package bibles

func EN_CCB_LoadInfo(CurrentBible *Bible) {
	CurrentBible.SetInfo("en.ccb", "Christian Community Bible")
	CurrentBible.AddBook("VPGN", "Genesis")
	CurrentBible.AddBook("VPEX", "Exodus")
	CurrentBible.AddBook("VPLV", "Leviticus")
	CurrentBible.AddBook("VPNM", "Numbers")
	CurrentBible.AddBook("VPDT", "Deuteronomy")
	CurrentBible.AddBook("VHIE", "Joshua")
	CurrentBible.AddBook("VHID", "Judges")
	CurrentBible.AddBook("VH1S", "1 Samuel")
	CurrentBible.AddBook("VH2S", "2 Samuel")
	CurrentBible.AddBook("VH1R", "1 Kings")
	CurrentBible.AddBook("VH2R", "2 Kings")
	CurrentBible.AddBook("VH1P", "1 Chronicles")
	CurrentBible.AddBook("VH2P", "2 Chronicles")
	CurrentBible.AddBook("VHED", "Ezra")
	CurrentBible.AddBook("VHNH", "Nehemiah")
	CurrentBible.AddBook("VH1M", "1 Maccabees")
	CurrentBible.AddBook("VH2M", "2 Maccabees")
	CurrentBible.AddBook("VMIS", "Isaiah")
	CurrentBible.AddBook("VMIE", "Jeremiah")
	CurrentBible.AddBook("VMEZ", "Ezekiel")
	CurrentBible.AddBook("VNOS", "Hosea")
	CurrentBible.AddBook("VNIL", "Joel")
	CurrentBible.AddBook("VNAM", "Amos")
	CurrentBible.AddBook("VNAB", "Obadiah")
	CurrentBible.AddBook("VNIN", "Jonah")
	CurrentBible.AddBook("VNMI", "Micah")
	CurrentBible.AddBook("VNNH", "Nahum")
	CurrentBible.AddBook("VNHA", "Habakkuk")
	CurrentBible.AddBook("VNSO", "Zephaniah")
	CurrentBible.AddBook("VNAG", "Haggai")
	CurrentBible.AddBook("VNZA", "Zechariah")
	CurrentBible.AddBook("VNML", "Malachi")
	CurrentBible.AddBook("VMDN", "Daniel")
	CurrentBible.AddBook("VSIB", "Job")
	CurrentBible.AddBook("VSPR", "Proverbs")
	CurrentBible.AddBook("VSEE", "Eclesiastes")
	CurrentBible.AddBook("VSCC", "Song of Songs")
	CurrentBible.AddBook("VHRT", "Ruth")
	CurrentBible.AddBook("VMLM", "Lamentations")
	CurrentBible.AddBook("VHET", "Esther")
	CurrentBible.AddBook("VHTB", "Tobit")
	CurrentBible.AddBook("VHIH", "Judith")
	CurrentBible.AddBook("VMBR", "Baruch")
	CurrentBible.AddBook("VSSP", "Wisdom")
	CurrentBible.AddBook("VSEI", "Sirach")
	CurrentBible.AddBook("VSPS", "Psalms")
	CurrentBible.AddBook("NEMT", "Matthew")
	CurrentBible.AddBook("NEMC", "Mark")
	CurrentBible.AddBook("NELC", "Luke")
	CurrentBible.AddBook("NEIO", "John")
	CurrentBible.AddBook("NTAA", "Acts")
	CurrentBible.AddBook("NPRM", "Romans")
	CurrentBible.AddBook("NP1C", "1 Corinthians")
	CurrentBible.AddBook("NP2C", "2 Corinthians")
	CurrentBible.AddBook("NPGA", "Galatians")
	CurrentBible.AddBook("NPEP", "Ephesians")
	CurrentBible.AddBook("NPPP", "Philippians")
	CurrentBible.AddBook("NPCL", "Colossians")
	CurrentBible.AddBook("NPPM", "Philemon")
	CurrentBible.AddBook("NP1E", "1 Thessalonians")
	CurrentBible.AddBook("NP2E", "2 Thessalonians")
	CurrentBible.AddBook("NP1I", "1 Timothy")
	CurrentBible.AddBook("NP2I", "2 Timothy")
	CurrentBible.AddBook("NPTT", "Titus")
	CurrentBible.AddBook("NTHB", "Hebrews")
	CurrentBible.AddBook("NCIB", "James")
	CurrentBible.AddBook("NC1P", "1 Peter")
	CurrentBible.AddBook("NC2P", "2 Peter")
	CurrentBible.AddBook("NCID", "Jude")
	CurrentBible.AddBook("NC1I", "1 John")
	CurrentBible.AddBook("NC2I", "2 John")
	CurrentBible.AddBook("NC3I", "3 John")
	CurrentBible.AddBook("NTAI", "Revelation")
}

func EN_CCB_LoadBooks(CurrentBible *Bible) {
	for x := range CurrentBible.Codes {
		var cb *Book = NewBook(CurrentBible.Codes[x], CurrentBible.Names[x])
		switch CurrentBible.Codes[x] {
		case "VPGN":
			EN_CCB_LoadVPGNChapters(cb)
		case "VPEX":
			EN_CCB_LoadVPEXChapters(cb)
		case "VPLV":
			EN_CCB_LoadVPLVChapters(cb)
		case "VPNM":
			EN_CCB_LoadVPNMChapters(cb)
		case "VPDT":
			EN_CCB_LoadVPDTChapters(cb)
		case "VHIE":
			EN_CCB_LoadVHIEChapters(cb)
		case "VHID":
			EN_CCB_LoadVHIDChapters(cb)
		case "VH1S":
			EN_CCB_LoadVH1SChapters(cb)
		case "VH2S":
			EN_CCB_LoadVH2SChapters(cb)
		case "VH1R":
			EN_CCB_LoadVH1RChapters(cb)
		case "VH2R":
			EN_CCB_LoadVH2RChapters(cb)
		case "VH1P":
			EN_CCB_LoadVH1PChapters(cb)
		case "VH2P":
			EN_CCB_LoadVH2PChapters(cb)
		case "VHED":
			EN_CCB_LoadVHEDChapters(cb)
		case "VHNH":
			EN_CCB_LoadVHNHChapters(cb)
		case "VH1M":
			EN_CCB_LoadVH1MChapters(cb)
		case "VH2M":
			EN_CCB_LoadVH2MChapters(cb)
		case "VMIS":
			EN_CCB_LoadVMISChapters(cb)
		case "VMIE":
			EN_CCB_LoadVMIEChapters(cb)
		case "VMEZ":
			EN_CCB_LoadVMEZChapters(cb)
		case "VNOS":
			EN_CCB_LoadVNOSChapters(cb)
		case "VNIL":
			EN_CCB_LoadVNILChapters(cb)
		case "VNAM":
			EN_CCB_LoadVNAMChapters(cb)
		case "VNAB":
			EN_CCB_LoadVNABChapters(cb)
		case "VNIN":
			EN_CCB_LoadVNINChapters(cb)
		case "VNMI":
			EN_CCB_LoadVNMIChapters(cb)
		case "VNNH":
			EN_CCB_LoadVNNHChapters(cb)
		case "VNHA":
			EN_CCB_LoadVNHAChapters(cb)
		case "VNSO":
			EN_CCB_LoadVNSOChapters(cb)
		case "VNAG":
			EN_CCB_LoadVNAGChapters(cb)
		case "VNZA":
			EN_CCB_LoadVNZAChapters(cb)
		case "VNML":
			EN_CCB_LoadVNMLChapters(cb)
		case "VMDN":
			EN_CCB_LoadVMDNChapters(cb)
		case "VSIB":
			EN_CCB_LoadVSIBChapters(cb)
		case "VSPR":
			EN_CCB_LoadVSPRChapters(cb)
		case "VSEE":
			EN_CCB_LoadVSEEChapters(cb)
		case "VSCC":
			EN_CCB_LoadVSCCChapters(cb)
		case "VHRT":
			EN_CCB_LoadVHRTChapters(cb)
		case "VMLM":
			EN_CCB_LoadVMLMChapters(cb)
		case "VHET":
			EN_CCB_LoadVHETChapters(cb)
		case "VHTB":
			EN_CCB_LoadVHTBChapters(cb)
		case "VHIH":
			EN_CCB_LoadVHIHChapters(cb)
		case "VMBR":
			EN_CCB_LoadVMBRChapters(cb)
		case "VSSP":
			EN_CCB_LoadVSSPChapters(cb)
		case "VSEI":
			EN_CCB_LoadVSEIChapters(cb)
		case "VSPS":
			EN_CCB_LoadVSPSChapters(cb)
		case "NEMT":
			EN_CCB_LoadNEMTChapters(cb)
		case "NEMC":
			EN_CCB_LoadNEMCChapters(cb)
		case "NELC":
			EN_CCB_LoadNELCChapters(cb)
		case "NEIO":
			EN_CCB_LoadNEIOChapters(cb)
		case "NTAA":
			EN_CCB_LoadNTAAChapters(cb)
		case "NPRM":
			EN_CCB_LoadNPRMChapters(cb)
		case "NP1C":
			EN_CCB_LoadNP1CChapters(cb)
		case "NP2C":
			EN_CCB_LoadNP2CChapters(cb)
		case "NPGA":
			EN_CCB_LoadNPGAChapters(cb)
		case "NPEP":
			EN_CCB_LoadNPEPChapters(cb)
		case "NPPP":
			EN_CCB_LoadNPPPChapters(cb)
		case "NPCL":
			EN_CCB_LoadNPCLChapters(cb)
		case "NPPM":
			EN_CCB_LoadNPPMChapters(cb)
		case "NP1E":
			EN_CCB_LoadNP1EChapters(cb)
		case "NP2E":
			EN_CCB_LoadNP2EChapters(cb)
		case "NP1I":
			EN_CCB_LoadNP1IChapters(cb)
		case "NP2I":
			EN_CCB_LoadNP2IChapters(cb)
		case "NPTT":
			EN_CCB_LoadNPTTChapters(cb)
		case "NTHB":
			EN_CCB_LoadNTHBChapters(cb)
		case "NCIB":
			EN_CCB_LoadNCIBChapters(cb)
		case "NC1P":
			EN_CCB_LoadNC1PChapters(cb)
		case "NC2P":
			EN_CCB_LoadNC2PChapters(cb)
		case "NCID":
			EN_CCB_LoadNCIDChapters(cb)
		case "NC1I":
			EN_CCB_LoadNC1IChapters(cb)
		case "NC2I":
			EN_CCB_LoadNC2IChapters(cb)
		case "NC3I":
			EN_CCB_LoadNC3IChapters(cb)
		case "NTAI":
			EN_CCB_LoadNTAIChapters(cb)
		}
		CurrentBible.Books = append(CurrentBible.Books, *cb)
	}
}

func EN_CCB_LoadNC1IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"This is what has been from the beginning, and what we have heard and have seen with our own eyes, what we have looked at and touched with our hands, I mean the Word who is Life..."
,"2":"The Life made itself known, we have seen Eternal Life and we bear witness, and we are telling you of it. It was with the Father and made himself known to us."
,"3":"So we tell you what we have seen and heard, that you may be in fellowship with us, and us, with the Father and with his Son, Jesus Christ."
,"4":"And we write this that you may have perfect joy."
,"5":"We heard his message from him and announce it to you: God is light and there is no darkness in him."
,"6":"If we say we are in fellowship with him, while we walk in darkness, we lie instead of being in truth."
,"7":"But if we walk in the light, as he is in the light, we are in fellowship with one another, and the blood of Jesus, the Son of God, purifies us from all sin."
,"8":"If we say, 'We have no sin,' we deceive ourselves and the truth is not in us."
,"9":"If we confess our sins, he who is faithful and just will forgive us our sins and cleanse us from all wickedness."
,"10":"If we say that we do not sin, we make God a liar, his word is not in us."
}`)
	CurrentBook.AddChapter(2, `{
"1":"My little children, I write to you that you may not sin. But if anyone sins, we have an intercessor with the Father, Jesus Christ, the Just One."
,"2":"He is the sacrificial victim for our sins and the sins of the whole world."
,"3":"How can we know that we know him? If we fulfill his commands."
,"4":"If you say, 'I know him,' but do not fulfill his commands, you are a liar and the truth is not in you."
,"5":"But if you keep his word, God's love is made complete in you. This is how we know that we are in him:"
,"6":"he who claims to live in him must live as he lived."
,"7":"My dear friends, I am not writing you a new commandment, but reminding you of an old one, one you had from the beginning. This old commandment is the word you have heard."
,"8":"But, in a way, I give it as a new commandment for it was indeed new in Jesus Christ and must be so in you as well, because the darkness is passing away and the true light already shines."
,"9":"If you claim to be in the light but hate your brother, you are still in darkness."
,"10":"If you love your brothers and sisters, you remain in the light and nothing in you will make you fall."
,"11":"But if you hate your brother you are in the dark and walk in darkness without knowing where you go, for the darkness has blinded you."
,"12":"My dear children, I write this to you: you have already received the forgiveness of your sins through the Name of Jesus."
,"13":"Fathers, I write this to you: you know him who is from the beginning. Young men, I write this to you: you have overcome the Evil One. My dear children, I write to you because you already know the Father."
,"14":"Fathers, I write to you because you know him who is from the beginning. Young men, I write to you because you are strong and the Word of God lives in you who have indeed overcome the Evil One."
,"15":"Do not love the world or what is in it. If anyone loves the world, the love of the Father is not in him."
,"16":"For everything in the world -,the craving of the flesh, the greed of eyes,and people boasting of their superiority -,all this belongs to the world, not to the Father."
,"17":"The world passes away with all its craving but those who do the will of God remain for ever."
,"18":"My dear children, it is the last hour. You were told that an antichrist would come; but several antichrists have already come, by which we know that it is now the last hour."
,"19":"They went out from us though they did not really belong to us. Had they belonged to us, they would have remained with us. So it became clear that not all of us were really ours."
,"20":"But you have the anointing from the Holy One, so that all of you have true wisdom."
,"21":"I write to you, not because you lack knowledge of the truth, but because you already know it, and lies have nothing in common with the truth."
,"22":"Who is the liar?,The one who denies that Jesus is the Christ. This is an antichrist, who denies both the Father and the Son. "
,"23":"The one who denies the Son is without the Father, and those who acknowledge the Son also have the Father."
,"24":"Let what you heard from the beginning remain in you. If what you heard from the beginning remains in you, you, too, will remain in the Son and in the Father."
,"25":"And this is the promise he himself gave us: eternal life."
,"26":"I write this to you thinking of those who try to lead you astray."
,"27":"You received from him an anointing, and it remains in you, so you do not need someone to teach you. His anointing teaches you all things, it speaks the truth and does not lie to you; so remain in him, and keep what he has taught you."
,"28":"And now, my children, live in him, so that when he appears in his glory, we may be confident and not ashamed before him when he comes."
,"29":"You know that he is the Just One: know then that anyone living justly is born of God."
}`)
	CurrentBook.AddChapter(3, `{
"1":"See what singular love the Father has for us: we are called children of God, and we really are. This is why the world does not know us, because it did not know him."
,"2":"Beloved, we are God's children and what we shall be has not yet been shown. Yet when he appears in his glory, we know that we shall be like him, for then we shall see him as he is."
,"3":"All who have such a hope try to be pure as he is pure."
,"4":"Anyone who commits a sin acts as an enemy of the law of God; any sin is a rejection of his law."
,"5":"You know that he came to take away our sins, and that there is no sin in him."
,"6":"Whoever remains in him has no sin, whoever sins has not seen or known him."
,"7":"My little children, do not be led astray; those who do what is right are upright, just as Jesus Christ is upright."
,"8":"But those who sin belong to the devil, for the devil sins from the beginning. This is why the Son of God was shown to us, he was to undo the works of the devil."
,"9":"Those born of God do not sin, for the seed of God remains in them; they cannot sin because they are born of God."
,"10":"What is the way to recognize the children of God and those of the devil? The one who does not do what is right is not of God; so, too, the one who does not love his brother or sister."
,"11":"For this is the message taught to you from the beginning: we must love one another."
,"12":"Do not imitate Cain who killed his brother, for he belonged to the Evil One. Why did he kill him? Because he himself did evil and his brother did good."
,"13":"So, be not surprised, brothers if the world hates us;"
,"14":"we love our brothers and sisters, and with this we know that we have passed from death to life. The one who does not love remains in death."
,"15":"The one who hates his brother is a murderer, and, as you know, eternal life does not remain in the murderer."
,"16":"This is how we have known what love is: he gave his life for us. We, too, ought to give our life for our brothers and sisters."
,"17":"If anyone enjoys the riches of this world, but closes his heart when he sees his brother or sister in need, how will the love of God remain in him?"
,"18":"My dear children, let us love not only with words and with our lips, but in truth and in deed."
,"19":"Then we shall know that we are of the truth and we may calm our conscience in his presence."
,"20":"Every time it reproaches us, let us say: God is greater than our conscience, and he knows everything."
,"21":"When our conscience does not condemn us, dear friends, we may have complete confidence in God."
,"22":"Then whatever we ask we shall receive, since we keep his commands and do what pleases him."
,"23":"His command is that we believe in the Name of his Son Jesus Christ and that we love one another, as he has commanded us."
,"24":"Whoever keeps his commands remains in God and God in him. It is by the Spirit God has given us that we know he lives in us."
}`)
	CurrentBook.AddChapter(4, `{
"1":"My beloved, do not trust every inspiration. Test the spirits to see whether they come from God, because many false prophets are now in the world."
,"2":"How will you recognize the spirit of God? Any spirit recognizing Jesus as the Christ who has taken our flesh is of God."
,"3":"But any spirit which does not recognize Jesus is not from God, it is the spirit of the antichrist. You have heard of his coming and even now he is in the world."
,"4":"You, my dear children, are of God and you have already overcome these people, because the one who is in you is more powerful than he who is in the world."
,"5":"They are of the world and the world inspires them and those of the world listen to them."
,"6":"We are of God and those who know God listen to us, but those who are not of God ignore us. This is how we know the spirit of truth and the spirit of error as well."
,"7":"My dear friends, let us love one another for love comes from God. Everyone who loves is born of God and knows God."
,"8":"Those who do not love have not known God, for God is love."
,"9":"How did the love of God appear among us? God sent his only Son into this world that we might have life through him."
,"10":"This is love: not that we loved God but that he first loved us and sent his Son as an atoning sacrifice for our sins."
,"11":"Dear friends, if such has been the love of God, we, too, must love one another."
,"12":"No one has ever seen God, but if we love one another, God lives in us, and his love spreads freely among us."
,"13":"How may we know that we live in God and he in us? Because God has given us his Spirit."
,"14":"We ourselves have seen and declare that the Father sent his Son to save the world."
,"15":"Those who acknowledge that Jesus is the Son of God, God remains in them and they in God."
,"16":"We have known the love of God and have believed in it. God is love. The one who lives in love, lives in God and God in him."
,"17":"When do we know that we have reached a perfect love? When in this world, we are like him in everything, and expect with confidence the Day of Judgment."
,"18":"There is no fear in love. Perfect love drives away fear, for fear has to do with punishment; those who fear do not know perfect love."
,"19":"So let us love one another, since he loved us first."
,"20":"If you say, 'I love God,' while you hate your brother or sister, you are a liar. How can you love God whom you do not see, if you do not love your brother whom you see? We received from him this commandment: let those who love God also love their brothers."
}`)
	CurrentBook.AddChapter(5, `{
"1":"All those who believe that Jesus is the Anointed, are born of God; if you love the Father you also love all those born of him."
,"2":"How may we know that we love the children of God? If we love God and fulfill his commands,"
,"3":"for God's love requires us to keep his commands. In fact, his commandments are not a burden"
,"4":"because all those born of God overcome the world. And the victory which overcomes the world is our faith."
,"5":"Who has overcome the world? The one who believes that Jesus is the Son of God."
,"6":"Jesus Christ was acknowledged through water, but also through blood. Not only water but water and blood. And the Spirit, too, witnesses to him for the Spirit is truth."
,"7":"There are then three testimonies:"
,"8":"the Spirit, the water and the blood, and these three witnesses agree."
,"9":"If we accept human testimony, with greater reason must we accept that of God, given in favor of his Son."
,"10":"If you believe in the Son of God, you have God's testimony in you. But those who do not believe make God a liar, since they do not believe his words when he witnesses to his Son."
,"11":"What has God said? That he has granted us eternal life and this life is in his Son."
,"12":"The one who has the Son has life, the one who do not have the Son of God do not have life."
,"13":"I write you, then, all these things that you may know that you have eternal life, all you who believe in the Name of the Son of God."
,"14":"Through him we are fully confident that whatever we ask, according to his will, he will grant us."
,"15":"If we know that he hears us whenever we ask, we know that we already have what we asked of him."
,"16":"If you see your brother committing sin, a sin which does not lead to death, pray for him, and God will give life to your brother. I speak, of course, of the sin which does not lead to death. There is also a sin that leads to death; I do not speak of praying about this."
,"17":"Every kind of wrongdoing is sin, but not all sin leads to death."
,"18":"We know that those born of God do not sin, for what has been born of God takes care of them, and the Evil One can do nothing against them."
,"19":"We know that we belong to God, while the whole world lies in evil."
,"20":"We know that the Son of God has come and has given us power to know the truth. We are in him who is true, his Son Jesus Christ. He is the true God and eternal life."
,"21":"My dear children, keep yourselves from idols."
}`)

}
func EN_CCB_LoadNC1PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"From Peter, apostle of Jesus Christ, to the Jews who live outside their homeland, scattered in Pontus, Galatia, Cappadocia, Asia and Bithynia,"
,"2":"to those whom God the Father has called, according to his plan, and made holy by the Spirit, to obey Jesus Christ and be purified by his blood: may grace and peace increase among you."
,"3":"Let us praise God, the Father of our Lord Jesus Christ, for his great mercy. In raising Jesus Christ from the dead he has given us new life and the hope of sharing life"
,"4":"beyond death, sin and all fleeting things. This inheritance is kept in the heavens for you,"
,"5":"since God's power shall keep you faithful until salvation is revealed in the last days."
,"6":"There is cause for joy, then, even though you may, for a time, have to suffer many trials."
,"7":"Thus will your faith be tested, like gold in a furnace. Gold, however, passes away but faith, worth so much more, will bring you in the end praise, glory and honor when Jesus Christ appears."
,"8":"You have not yet seen him and yet you love him; even without seeing him, you believe in him and experience a heavenly joy beyond all words,"
,"9":"for you are reaching the goal of your faith: the salvation of your souls."
,"10":"This was the salvation for which the prophets so eagerly looked when, in days past, they foretold the favor of God with regard to you."
,"11":"But they could only investigate when the Spirit of Christ present within them pointed out the time and the circumstances of this - the sufferings of Christ and the glories which would follow."
,"12":"It was revealed to them that they were working not for themselves but for you. Thus, in these days, after the Holy Spirit has been sent from heaven, the Gospel's preachers have taught you these mysteries which even the angels long to see."
,"13":"So, then, let your spirit be ready. Be alert, with confident trust in the grace you will receive when Jesus Christ appears."
,"14":"Like obedient children, do not return to your former life given over to ignorance and passions."
,"15":"Imitate the one who called you. As he is holy so you, too, be holy in all your conduct,"
,"16":"since Scripture says: Be holy for I am holy."
,"17":"You call upon a Father who makes no distinction between persons but judges according to each one's deeds; take seriously, then, these years which you spend in a strange land."
,"18":"Remember that you were freed from the useless way of life of your ancestors, not with gold and silver"
,"19":"but with the precious blood of the Lamb without spot or blemish."
,"20":"God, who has known Christ before the world began, revealed him to you in the last days."
,"21":"Through him, you have faith in God who raised him from the dead and glorified him in order that you might put all your faith and hope in God."
,"22":"In obeying the truth, you have gained interior purification from which comes sincere mutual love. Love one another, then, with all your heart,"
,"23":"since you are born again, not from mortal beings, but with enduring life, through the Word of God who lives and remains forever."
,"24":"It is written: All flesh is grass and its glory like the flowers of the field. The grass withers and the flower falls, but the Word of the Lord endures forever. This Word is the Gospel which has been brought to you."
}`)
	CurrentBook.AddChapter(2, `{
"1":"So, give up all evil and deceit, hypocrisy, envy and every kind of gossip."
,"2":"Like newborn children, seek eagerly for the pure milk of the Word which will help you grow and reach salvation."
,"3":"Did you not taste the goodness of the Lord?"
,"4":"He is the living stone rejected by people but chosen by God and precious to him."
,"5":"On drawing close to him, you also became living stones built into a spiritual temple, a holy community of priests offering spiritual sacrifices which please God through Jesus Christ."
,"6":"Scripture says: See, I lay in Zion a chosen and precious cornerstone; whoever believes in him will not be disappointed."
,"7":"This means honor for you who believed, but for unbelievers also the stone which the builders rejected has become the cornerstone"
,"8":"and it is a stone to stumble over, a rock which lays people low. They stumble over it in rejecting the Word, but the plan of God is fulfilled in this."
,"9":"You are a chosen race, a community of priest-kings, a consecrated nation, a people God has made his own to proclaim his wonders. For he called you from your darkness to his own wonderful light."
,"10":"At one stage you were no people, but now you are God's people, you had not received his mercy, but now you have been given mercy."
,"11":"Beloved, while you are strangers and exiles, I urge you not to indulge in selfish passions which wage war on the soul."
,"12":"Live a blameless life among the pagans; so when they accuse you falsely of any wrong, they may see your good works and give glory to God on the day he comes to them."
,"13":"For the Lord's sake, respect all human authority: the king as chief authority,"
,"14":"the governors as sent by him to punish evildoers and to encourage those who do good."
,"15":"And God wants you to do good so that you may silence those fools who ignorantly criticize you."
,"16":"Behave as free people but do not speak of freedom as a license for vice; you are free men and God's servants."
,"17":"Reverence each person, love your brothers and sisters, fear God and show respect to the emperor."
,"18":"Servants must respect their masters, not only those who are good and understanding but also those who are difficult."
,"19":"For there is merit in putting up with unprovoked suffering, for the sake of God."
,"20":"What merit would there be in taking a beating when you have done wrong? But if you endure punishment when you have done well, that is a grace before God."
,"21":"This is your calling: remember Christ who suffered for you, leaving you an example so that you may follow in his way."
,"22":"He did no wrong and there was no deceit in his mouth."
,"23":"He did not return insult for insult and, when suffering, he did not curse but put himself in the hands of God who judges justly."
,"24":"He went to the cross burdened with our sins so that we might die to sin and live an upright life. For by his wounds you have been healed."
,"25":"You were like stray sheep, but you have come back to the Shepherd and Guardian of your souls."
}`)
	CurrentBook.AddChapter(3, `{
"1":"In the same way, wives must be submissive to their husbands. If any of them resists the Word, they will be won over without words by the conduct of their wives."
,"2":"It will be enough for them to see your responsible and blameless conduct."
,"3":"Do not be taken up with outward appearances: hairstyles, gold necklaces and clothes."
,"4":"There is something more permanent that shines from within a person: a gentle and peaceful disposition. This is really precious in God's eyes."
,"5":"This was the way the holy women of the past dressed. They put their trust in God and were obedient to their husbands,"
,"6":"namely Sarah who had such respect for Abraham that she called him her lord. You are her children if you do what is right and are not afraid."
,"7":"Husbands, in your turn, be sensible in your life together. Be considerate, realizing that the woman is of a more frail disposition and that you both share in the gift of life. If you do this, God will readily answer your prayers."
,"8":"Finally, you should all be of one mind: share each other's troubles with mutual affection, be compassionate and humble."
,"9":"Do not repay evil for evil or answer one insult with another. Give a blessing, instead, since this is what you have been called to do, and so you will receive the blessing."
,"10":"For if you seek life and want to see happiness, keep your tongue from evil and your mouth from speaking deceit."
,"11":"Turn away from evil and do good; seek peace and pursue it."
,"12":"Because the Lord's eyes are turned to the just and his ears listen to their appeal. But the Lord frowns on evildoers."
,"13":"Who can harm you if you devote yourselves to doing good?"
,"14":"If you suffer for the sake of righteousness, happy are you. Do not fear what they fear or be disturbed as they are,"
,"15":"but bless the Lord Christ in your hearts. Always have an answer ready when you are called upon to account for your hope, but give it simply and with respect."
,"16":"Keep your conscience clear so that those who slander you may be put to shame by your upright, Christian living."
,"17":"Better to suffer for doing good, if it is God's will, than for doing wrong."
,"18":"Remember how Christ died, once and for all, for our sins. He, the just one, died for the unjust in order to lead us to God. He died as humans do, but was raised to life by the Spirit,"
,"19":"and it was then that he went to preach to the imprisoned spirits."
,"20":"They were the generation who did not believe when God, in his great patience, delayed punishing the world while Noah was building the ark in which a small group of eight persons escaped through water."
,"21":"That was a type of the baptism which now saves you; this baptism is not a matter of physical cleansing but of asking God to reconcile us through the resurrection of Christ Jesus."
,"22":"He has ascended to heaven and is at the right hand of God, having subjected the angels, Dominations and Powers."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Given that Christ suffered in his human life, arm yourselves with this certainty: the one who suffers in his body has broken with sin"
,"2":"so as to spend the rest of his life following the will of God and not human passions."
,"3":"You have given enough time, in the past, to living as the pagans do: a life of excess, evil passions, drunkenness, orgies and worship of idols."
,"4":"They now find it strange that you are no longer swept along with them in this ruinous flood, and they misinterpret it."
,"5":"But they will be accountable to the one who is ready to judge the living and the dead."
,"6":"The Gospel has been preached to many who are now dead. As humans they received a deadly sentence, but through the Spirit they shall live for God."
,"7":"The end of all things is near; live wisely and spend evening time praying."
,"8":"Above all, let your love for one another be sincere, for love covers a multitude of sins."
,"9":"Welcome one another into your houses without complaining."
,"10":"Serve one another with the gifts each of you received, thus becoming good managers of the varied graces of God."
,"11":"If you speak, deliver the word of God; if you have a special ministry, let it be seen as God's power so that, in everything, God may be glorified in Jesus Christ. To him belong glory and power forever and ever. Amen."
,"12":"My dear people, do not be surprised that you are being tested by fire. It is not an unusual occurrence."
,"13":"Instead, you should be glad to share in the sufferings of Christ because, on the day his Glory is revealed, you will also fully rejoice."
,"14":"You are fortunate if you are insulted because of the name of Christ, for the Spirit of glory rests on you."
,"15":"I suppose that none of you should suffer for being a murderer, a thief, a criminal or an informer;"
,"16":"but if anyone suffers on account of being a Christian, do not consider it a disgrace; rather let this name bring glory to God."
,"17":"The time of judgment has come and it begins with God's household. If its beginning so affects us, what will be the end of those who refuse to believe in the Gospel?"
,"18":"If the just one is barely saved, what will happen to the sinner and unbeliever?"
,"19":"So, then, if you suffer according to God's will, entrust yourself to the faithful Creator and continue to do good."
}`)
	CurrentBook.AddChapter(5, `{
"1":"I now address myself to those elders among you; I, too, am an elder and a witness to the sufferings of Christ, hoping to share the Glory which is to be revealed."
,"2":"Shepherd the flock which God has entrusted to you, guarding it not out of obligation but willingly for God's sake; not as one looking for a reward but with a generous heart;"
,"3":"do not lord it over those in your care, rather be an example to your flock."
,"4":"Then, when the Chief Shepherd appears, you will be given a crown of unfading glory."
,"5":"In the same way, let the younger ones among you respect the authority of the elders. All of you, be humble in your dealings with each other, because God opposes the proud but gives his grace to the humble."
,"6":"Bow down, then, before the power of God so that he will raise you up at the appointed time."
,"7":"Place all your worries on him since he takes care of you."
,"8":"Be sober and alert because your enemy the devil prowls about like a roaring lion seeking someone to devour."
,"9":"Stand your ground, firm in your faith, knowing that our brothers and sisters, scattered throughout the world, are confronting similar persecutions."
,"10":"God, the giver of all grace, has called you to share in Christ's eternal Glory and after you have suffered a little he will bring you to perfection: he will confirm, strengthen and establish you forever."
,"11":"Glory be to him forever and ever. Amen."
,"12":"I have had these few lines of encouragement written to you by Silvanus, our brother, whom I know to be trustworthy. For I wanted to remind you of the kindness of God really present in all this. Hold on to it."
,"13":"Greetings from the community in Babylon, gathered by God, and from my son, Mark."
,"14":"Greet one another with a friendly embrace. Peace to you all who are in Christ."
}`)

}
func EN_CCB_LoadNC2IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"I, the elder, to the chosen Lady and her children, whom I love sincerely - and with me all who know the truth -"
,"2":"because of this same truth which is and will be in us forever."
,"3":"Grace, mercy and peace be with you in the name of God the Father and of his Son, Christ Jesus, in truth and love."
,"4":"I rejoiced greatly on meeting some of your children who live in accordance with the truth, according to the command we have received from the Father."
,"5":"And now, I ask you, Lady - I write to you not a new commandment but that which we had from the beginning - I ask you: let us love one another."
,"6":"This is love: to walk according to his commandments. And this is the commandment: that you walk in love as you have learned from the beginning."
,"7":"Many deceivers have gone out into the world, people who do not acknowledge that Jesus is the Christ who came in the flesh. They are impostors and antichrists."
,"8":"Take care of yourselves that you do not lose the fruit of your labors, but receive a perfect reward."
,"9":"Everyone who goes beyond and does not remain within the teaching of Christ does not have God. The one who remains in the teaching has both the Father and the Son."
,"10":"If anyone comes to you and does not bring this teaching, do not receive him into your houses or even greet him."
,"11":"Even in greeting him you would become an accomplice in his wicked deeds."
,"12":"I have many things to write to you, but I prefer not to use paper and ink. I hope to meet you and speak to you personally, that our joy may be full."
,"13":"The children of your chosen sister greet you."
}`)

}
func EN_CCB_LoadNC2PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Symeon Peter, a servant and apostle of Jesus Christ, to those who have been sanctified by our God and Savior Jesus Christ and have received a faith as precious as ours:"
,"2":"may grace and peace abound in you through the knowledge of God and of Jesus our Lord."
,"3":"His divine power has given us everything we need for life and piety. First the knowledge of the One who called us through his own Glory and Might, by which we were given the most extraordinary and precious promises."
,"4":"Through them you share in the divine nature, after repelling the corruption and evil desires of this world."
,"5":"So, strive with the greatest determination and increase your faith with strength, strength with knowledge,"
,"6":"knowledge with moderation, moderation with constancy, constancy with piety,"
,"7":"piety with mutual affection, mutual affection with charity."
,"8":"If all these riches are in you so as to abound in you, you will not be idle and useless; you will rather be rooted in the knowledge of Jesus Christ our Lord."
,"9":"Whoever is not aware of this is blind and shortsighted and is forgetful of the cleansing of former sins."
,"10":"Therefore, brothers and sisters, strive more and more to respond to the call of God who chose you. If you do so, you will never stumble."
,"11":"Moreover you will be generously granted entry to the eternal kingdom of our Lord and Savior Jesus Christ."
,"12":"So I shall always remind you of these things, though you know them and remain firm in the truth that you have."
,"13":"It seems fitting that as long as I live in the tent of this body, I refresh your memory of them,"
,"14":"knowing that my tent may soon be folded up, as our Lord Jesus Christ has shown me."
,"15":"I will, nonetheless, endeavor to see that after my departure, you will be constantly reminded of all this."
,"16":"Indeed, what we taught you about the power and the return of Christ Jesus our Lord was not drawn from myths or formulated theories. We ourselves were eyewitnesses of his majesty,"
,"17":"when he received glory and honor from God the Father, when from the magnificent Glory this most extraordinary word came upon him: 'This is my beloved Son, this is my Chosen One.'"
,"18":"We ourselves heard this voice from heaven when we were with him on the holy mountain."
,"19":"Therefore, we believe most firmly in the message of the prophets which you should consider rightly as a lamp shining in a dark place, until the break of day, when the Morning Star shines in your hearts."
,"20":"Know this well: no prophecy of Scripture can be handed over to private interpretation,"
,"21":"since no prophecy comes from human decision, for it was men of God, moved by the Holy Spirit, who spoke."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Just as there have been false prophets in the midst of the people of Israel, so will there be false teachers among you. They will introduce harmful sects and, by denying the Master who saved them, they will bring upon themselves sudden perdition."
,"2":"Many, nonetheless, will imitate their vices and because of them the Way of Truth will be discredited."
,"3":"They will take advantage of you with deceitful words for the sake of money. But their condemnation has already begun and their destruction awaits them."
,"4":"In fact, God did not pardon the angels who sinned but cast them into hell, confining them in the dark pits, keeping them there until the Day of Judgment."
,"5":"Neither did he pardon the ancient world when he unleashed the waters of the flood upon the world of wicked people, but protected only Noah, the eighth prophet of righteousness."
,"6":"God also condemned the cities of Sodom and Gomorrah, reducing them to ashes, to serve as a warning to the wicked in the future."
,"7":"But he saved Lot, a good man deeply afflicted by the unbridled conduct of those vicious people."
,"8":"For Lot, a righteous man who lived in their midst, suffered day after day in the goodness of his heart as he saw and heard of their crimes."
,"9":"So, then, the Lord knows how to free from trial those who serve him and keep the wicked for punishment on the Day of Judgment."
,"10":"He will do this especially for certain people who follow the baser desires of their nature and despise the Lord's majesty. Proud and daring they are not afraid of insulting fallen spirits"
,"11":"while the angels, who are superior to them in strength and power, do not permit themselves any injurious accusation in the presence of the Lord."
,"12":"Those people are like irrational animals born to be caught and killed; after they have slandered what they cannot understand, they will end like animals"
,"13":"and they will suffer the repayment of their wickedness. They enjoy fleeting pleasures; they are obscene and vicious who delight in deceiving you when they share in your fraternal meals. "
,"14":"They cannot look at a woman without desiring her, they do not tire of sinning and seducing weak souls. They are full of greed - an accursed people."
,"15":"They abandoned the right way and followed Balaam, son of Beor who was attached to what he gained from his wrongdoing."
,"16":"But he was rebuked for his sin: his she-ass began to speak with a human voice, stopping the prophet in his madness."
,"17":"These people are like waterless springs, clouds driven by a storm which move swiftly into the blackest darkness."
,"18":"With their boastful and empty discourses, they encourage the lust and impure desire of those who have just freed themselves from the common errors."
,"19":"They promise freedom when they themselves are slaves of corruption: for people are slaves to whatever dominates them."
,"20":"Indeed, after being freed from worldly vices through the knowledge of the Lord and Savior Jesus Christ, they returned to those vices and surrendered to them; and their present state has become worse than the first."
,"21":"It would have been better for them not to have known the way of holiness than, knowing it, to turn away from the sacred doctrine that they had been taught. "
,"22":"In their case these proverbs are relevant: 'The dog turns back to its own vomit,' and: 'Hardly has the pig been washed than it again wallows in the mud.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Dearly beloved, this is the second letter I write to you. In both of them I have intended to remind you of sound doctrine."
,"2":"Do not forget the words of the holy prophets and the teaching of our Lord and Savior, as you heard it through his apostles."
,"3":"Remember, first of all, that in the last days scoffers will appear, their mockery serving their evil desires."
,"4":"And they will say, 'What has become of his promised coming? Since our fathers in faith died, everything still goes on as it was from the beginning of the world.'"
,"5":"Indeed, they deliberately ignore that in the beginning the heavens existed first and earth appeared from the water, taking its form by the word of God."
,"6":"By the same word of God, this world perished in the Flood."
,"7":"Likewise, the Word of God maintains the present heavens and earth until their destruction by fire; they are kept for the Day of Judgment when the godless will be destroyed."
,"8":"Do not forget, beloved, that with the Lord, one day is like a thousand years, and a thousand years is like one day."
,"9":"The Lord does not delay in fulfilling his promise, though some speak of delay; rather he gives you time because he does not want anyone to perish, but that all may come to conversion."
,"10":"The Day of the Lord is to come like a thief. Then the heavens will dissolve with a great noise; the elements will melt away by fire, and the earth with all that is on it will be burned up."
,"11":"Since all things are to vanish, how holy and religious your way of life must be,"
,"12":"as you wait for the Day of God and long for its coming, when the heavens will dissolve in fire and the elements melt away in the heat."
,"13":"We wait for a new heaven and a new earth in which justice reigns, according to God's promise."
,"14":"Therefore, beloved, as you wait in expectation of this, strive that God may find you rooted in peace, without blemish or fault."
,"15":"And consider that God's patience is for our salvation, as our beloved brother Paul wrote to you, with the wisdom given him."
,"16":"He speaks of these things in all his letters. There are, however, some points in them that are difficult to understand, which people who are ignorant and immature in their faith twist, as they do with the rest of the Scriptures, to their own destruction."
,"17":"So then, dearly beloved, as you have been warned, be careful lest those people who have gone astray deceive you in turn and drag you along, making you stumble and finally fall away."
,"18":"Grow in the grace and knowledge of our Lord and Savior Jesus Christ: to him be glory, now and to the day of eternity. Amen."
}`)

}
func EN_CCB_LoadNC3IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"I, the elder, to my dear friend Gaius, whom I love sincerely."
,"2":"Dear friend, may everything go well with you and may you enjoy health of body and soul."
,"3":"I greatly rejoiced with the friends who arrived and praised your truth, and how you live the truth."
,"4":"Nothing gives me greater joy than to know that my children live in the truth."
,"5":"Beloved, you do well to care for the brothers and sisters as you do. I mean those coming from other places."
,"6":"They spoke of your charity before the assembled Church. It will be well to provide them with what they need to continue their journey, as if you did it for God."
,"7":"In reality, they have set out on the road for his name without accepting anything from the pagans."
,"8":"We should receive such persons, making ourselves their cooperators in the work of the truth."
,"9":"I have written these words to the Church. But Diotrephes, who is anxious to preside over it, does not acknowledge our authority."
,"10":"So when I come, I will not cease reproaching his manner of acting, since he discredited us with words of evil intent. And not content with that, he does not receive the friends and even restrains those who want to receive them, and expels them from the Church."
,"11":"Dear friend, do not imitate evil, but only the good. Whoever does good is of God. Whoever does evil does not know God."
,"12":"Now about Demetrius: everyone praises him, even the truth itself. We, too, praise him, and you know that when we recommend anyone, we do it according to the truth."
,"13":"I have many things to tell you, but I do not want to do it in writing."
,"14":"I hope to see you soon, and we will talk face to face. Peace be with you. Your friends greet you. Greet the friends for me, each one by name."
}`)

}
func EN_CCB_LoadNCIBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"James, a servant of God and of the Lord Jesus Christ, sends greetings to the twelve tribes scattered among the nations."
,"2":"Consider yourselves fortunate, my brothers and sisters, when you meet with every kind of trial,"
,"3":"for you know that the testing of your faith makes you steadfast."
,"4":"Let your steadfastness become perfect with deeds, that you yourselves may be perfect and blameless, without any defect."
,"5":"If any of you is lacking in wisdom, ask God who gives to all easily and unconditionally."
,"6":"But ask with faith, not doubting, for the one who doubts is like a wave driven and tossed on the sea by the wind."
,"7":"Such a person should not expect anything from the Lord, since the doubter has two minds"
,"8":"and his conduct will always be insecure."
,"9":"Let the believer who is poor boast in been uplifted,"
,"10":"and let the rich one boast in being humbled, because he will pass away like the flower of the field."
,"11":"The sun rises and its heat dries the grass; the flower withers and its beauty vanishes. So, too, will the rich person fade away even in the midst of his pursuits."
,"12":"Happy are those who patiently endure trials, because afterwards they will receive the crown of life which the Lord promised to those who love him."
,"13":"No one, when tempted, should say, 'This temptation comes from God.' God is never tempted and he can never tempt anyone."
,"14":"Instead, each of us is lured and enticed by our own evil desire."
,"15":"Once this desire has conceived, it gives birth to sin, and sin, when fully grown, gives birth to death."
,"16":"Do not be deceived, my beloved."
,"17":"Every good and perfect gift comes from above, from the Father of Light, in whom there is no change or shadow of a change."
,"18":"By his own will he gave us life through the Word of Truth, that we might be a kind of offering to him among his creatures."
,"19":"My beloved, be quick to hear but slow to speak and slow to anger,"
,"20":"for human anger does not fulfill the justice of God."
,"21":"So get rid of any filth and reject the prevailing evil, and welcome the Word which has been planted in you and has the power to save you."
,"22":"Be doers of the Word and not just hearers, lest you deceive yourselves."
,"23":"The hearer who does not become a doer is like that one who looked himself at the mirror."
,"24":"He looked and then promptly forgot what he was like."
,"25":"But those who fix their gaze on the perfect law of freedom and hold onto it, not listening and then forgetting, but acting on it, will find blessing on their deeds."
,"26":"Those who think they are religious but do not restrain their tongue, deceive themselves and their religion is in vain."
,"27":"In the sight of God, our Father, pure and blameless religion lies in helping the orphans and widows in their need and keeping oneself from the world's corruption."
}`)
	CurrentBook.AddChapter(2, `{
"1":"My brothers and sisters, if you truly believe in our glorified Lord, Jesus Christ, you will not discriminate between persons."
,"2":"Suppose a person enters the synagogue where you are assembled, dressed magnificently and wearing a gold ring; at the same time, a poor person enters dressed in rags."
,"3":"If you focus your attention on the well-dressed and say, 'Come and sit in the best seat,' while to the poor one you say, 'Stay standing or else sit down at my feet,'"
,"4":"have you not, in fact, made a distinction between the two? Have you not judged, using a double standard?"
,"5":"Listen, my beloved brothers and sisters, did God not choose the poor of this world to receive the riches of faith and to inherit the kingdom which he has promised to those who love him?"
,"6":"Yet you despise them! Is it not the rich who are against you and drag you to court?"
,"7":"Do they not insult the holy name of Christ by which you are called?"
,"8":"If you keep the Law of the Kingdom, according to Scripture: Love your neighbor as yourself, you do well;"
,"9":"but if you make distinctions between persons, you break the law and are condemned by the same law."
,"10":"For whoever keeps the whole law but fails in one aspect, is guilty of breaking it all."
,"11":"For he who said, Do not commit adultery, also said, Do not kill. If, then, you do not commit adultery but you do commit murder, you have broken the Law."
,"12":"Therefore, speak and behave like people who are going to be judged by the law of freedom."
,"13":"There will be justice without mercy for those who have not shown mercy, whereas mercy has nothing to fear of judgment."
,"14":"What good is it, my brothers and sisters, to profess faith without showing works? Such faith has no power to save you."
,"15":"If a brother or sister is in need of clothes or food"
,"16":"and one of you says, 'May things go well for you; be warm and satisfied,' without attending to their material needs, what good is that?"
,"17":"So it is for faith without deeds: it is totally dead."
,"18":"Say to whoever challenges you, 'You have faith and I have good deeds; show me your faith apart from actions and I, for my part, will show you my faith in the way I act.'"
,"19":"Do you believe there is one God? Well enough, but do not forget that the demons also believe and tremble with fear!"
,"20":"You foolish one, do you have to be convinced that faith without deeds is useless?"
,"21":"Think of our father Abraham. Was he not justified by the act of offering his son Isaac on the altar?"
,"22":"So you see, his faith was active along with his deeds and became perfect by what he did."
,"23":"The word of Scripture was thus fulfilled, Abraham believed in God so he was considered a righteous person and he was called the friend of God."
,"24":"So you see, a person is acknowledged by works and not by faith alone."
,"25":"Likewise, we read of Rahab, the prostitute, that she was acknowledged and saved because she welcomed the spies and showed them another way to leave."
,"26":"So, just as the body is dead without its spirit, so faith without deeds is also dead."
}`)
	CurrentBook.AddChapter(3, `{
"1":"My brothers and sisters, don't all be teachers! You know that, as teachers, we will be judged most strictly;"
,"2":"in fact, we make mistakes, like everybody else. A person who commits no offense in speech is perfect and capable of ruling the whole self."
,"3":"We put a bit into the horse's mouth to master it and, with this, we control its whole body."
,"4":"The same is true of ships: however big they are and driven by strong winds, they are guided by a tiny rudder."
,"5":"In the same way, the tongue is a tiny part of the body but it is capable of great things. A small flame is enough to set a huge forest on fire. "
,"6":"The tongue is a similar flame; it is in itself a whole world of evil. It infects the whole being and sets fire to our world with the very fire of hell."
,"7":"Wild animals, birds, reptiles and sea creatures of every kind are and have been ruled by the human species."
,"8":"Nobody, however, can control the tongue; it is an untiring whip, full of deadly poison."
,"9":"We use it to bless God, our Father, and also to curse those made in God's likeness."
,"10":"From the same mouth come both blessing and curse. Brothers and sisters, this should not be the case. "
,"11":"Can both fresh and salt water gush from the same source?"
,"12":"Can a fig tree produce olives or a grapevine give figs? Neither is the sea able to give fresh water."
,"13":"If you consider yourself wise and learned, show it by your good life and let your actions, in all humility, be an example for others."
,"14":"But if your heart is full of bitter jealousy and ambition, do not try to show off; that would be covering up the truth;"
,"15":"this kind of wisdom does not come from above but from the world and it is earthly and devilish."
,"16":"Wherever there is jealousy and ambition, you will also find discord and all that is evil."
,"17":"Instead, the wisdom which comes from above is pure and peace-loving. Persons with this wisdom show understanding and listen to advice; they are full of compassion and good works; they are impartial and sincere."
,"18":"Peacemakers who sow peace reap a harvest of justice."
}`)
	CurrentBook.AddChapter(4, `{
"1":"What causes these fights and quarrels among you? Is it not your inner longings which make war within your own selves?"
,"2":"When you long for something you cannot have, you kill for it and when you do not get what you desire, you squabble and fight. The fact is, you do not have what you want because you do not pray for it."
,"3":"You pray for something and you do not get it because you pray with the wrong motive of indulging your pleasures."
,"4":"You adulterers! Don't you know that making friends with the world makes you enemies of God? Therefore, whoever chooses to be the world's friend becomes God's enemy."
,"5":"Surely, Scripture is not wrong when it says that our spirit tends towards excess."
,"6":"But God has something better to give, and Scripture also says, God opposes the proud but he gives his favor to the humble."
,"7":"Give in, then, to God; resist the devil and he will flee from you."
,"8":"Draw close to God and he will come close to you. Clean your hands, you sinners, and purify your hearts, you doubters."
,"9":"Recognize your distress, be miserable and weep. Turn your laughter into tears and your joy into sadness."
,"10":"Humble yourselves before the Lord and he will raise you up."
,"11":"Brothers and sisters, do not criticize one another. Anyone who speaks against or condemns another, speaks against the Law and condemns the Law. If, however, you condemn the Law, you are no longer an observer of the Law but a judge of it."
,"12":"There is only one lawgiver and one judge: he who has the power to save or condemn. So you, who are you to judge your neighbor?"
,"13":"Listen now, you who speak like this, 'Today or tomorrow we will go off to this city and spend a year there; we will do business and make money.'"
,"14":"You have no idea what tomorrow will bring. What is your life? No more than a mist which appears for a moment and then disappears."
,"15":"Instead of this, you should say, 'God willing, we will live and do this or that.'"
,"16":"But no! You boast of your plans: this brazen pride is wicked."
,"17":"Anyone who knows what is good and does not do it, sins."
}`)
	CurrentBook.AddChapter(5, `{
"1":"So, now for what concerns the rich! Cry and weep for the misfortunes which are coming upon you."
,"2":"Your riches are rotting and your clothes eaten up by the moths."
,"3":"Your silver and gold have rusted and their rust grows into a witness against you. It will consume your flesh like fire, for having piled up riches,in these the last days."
,"4":"You deceived the workers who harvested your fields but now their wages cry out to the heavens. The reapers' complaints have reached the ears of the Lord of hosts."
,"5":"You lived in luxury and pleasure in this world and felt happy while others were murdered."
,"6":"You have easily condemned and killed the innocent since they offered no resistance."
,"7":"Be patient then, beloved, until the coming of the Lord. See how the sower waits for the precious fruits of the earth, looking forward patiently to the autumn and spring rains."
,"8":"You also be patient and do not lose heart, because the Lord's coming is near."
,"9":"Beloved, do not fight among yourselves and you will not be judged. See, the judge is already at the door."
,"10":"Take for yourselves, as an example of patience, the suffering of the prophets who spoke in the Lord's name."
,"11":"See how those who were patient are called blessed. You have heard of the patience of Job and know how the Lord dealt with him in the end. For the Lord is merciful and shows compassion."
,"12":"Above all, my beloved, do not swear either by heaven or by earth, or make a habit of swearing. Let your yes be yes and your no be no, lest you become liable for judgment."
,"13":"Are any among you discouraged? They should pray. Are any of you happy? They should sing songs to God."
,"14":"If anyone is sick, let him call on the elders of the Church. They shall pray for him, anointing him with oil in the name of the Lord."
,"15":"The prayer said in faith will save the sick person; the Lord will raise him up and if he has committed any sins, he will be forgiven."
,"16":"There will be healing if you confess your sins to one another and pray for each other. The prayer of the upright man has great power, provided he perseveres."
,"17":"Elijah was a human being like ourselves and when he prayed earnestly for it not to rain, no rain fell for three and a half years."
,"18":"Then he prayed again: the sky yielded rain and the earth produced its fruit."
,"19":"Brothers, if any one of you strays far away from the truth and another person brings him back to it,"
,"20":"be sure of this: he who brings back a sinner from the wrong way will save his soul from death and win forgiveness for many sins."
}`)

}
func EN_CCB_LoadNCIDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Jude, servant of Jesus Christ and brother of James, to those called to the faith, beloved by God the Father and kept in Christ Jesus."
,"2":"May mercy, peace and love abound in you."
,"3":"Most beloved, I had wanted to write to you about the salvation we all share, but now I feel I must urge you to fight for the faith God has given once for all to the saints."
,"4":"Some individuals have slipped into your midst, godless people already condemned. They make use of the grace of our God as a license for immorality and deny our only Master and Lord Jesus Christ."
,"5":"Although you may be aware of it, I wish to remind you that the Lord saved his people from the land of Egypt, but later delivered to death those who did not believe."
,"6":"He did the same with the angels who did not keep their rank but abandoned their dwelling places. God enclosed them in eternal prisons, in the pit of darkness until the great day of Judgment."
,"7":"Sodom and Gomorrah and the surrounding cities who prostituted themselves and were lured into unnatural unions are also a warning of the punishment of eternal fire."
,"8":"In spite of all this, these people now do the same: in their ravings, they debase their bodies, scorn the celestial authorities, blaspheme against the angels."
,"9":"When the archangel Michael fought against the devil and disputed about the body of Moses, he did not dare insult him, but simply said, 'May the Lord rebuke you!'"
,"10":"Not so these people, they insult and scorn what they cannot understand; what they know by instinct like animals, they use for their corruption."
,"11":"Woe to them! They follow the footsteps of Cain and like Balaam go astray because of money: they will finally perish like the rebellious Korah."
,"12":"When you celebrate your love-meals, they spoil everything, coming only for the food and shamelessly seeing to their own needs. They are like clouds carried along by the wind which never bring rain, like trees without fruit at the end of autumn, twice dead when uprooted."
,"13":"The scum of their vices are splashed like foam on the rough waves of the sea, they are like shooting stars which the thick darkness engulfs for ever."
,"14":"The patriach Enoch, the seventh after Adam, said these words about them: The Lord comes with thousands of angels"
,"15":"to judge everyone and call the wicked to account for all the evil deeds they committed; he will punish all the injurious words the impious sinners uttered against him."
,"16":"All these are discontented who curse their lot and follow their passions. Their mouth is full of arrogant words, and they flatter people for their own interest."
,"17":"But, most beloved, remember what the apostles of Christ Jesus, our Lord, announced to you."
,"18":"They said to you, 'At the end of time, there will be scoffers led by their desires which are those of godless people.'"
,"19":"Actually, these people are those who cause divisions, they are worldly people and do not have the Holy Spirit."
,"20":"But, dearly beloved, build your life on the foundation of your most holy faith, praying in the Holy Spirit."
,"21":"Remain firm in the love of God, welcoming the mercy of Jesus Christ, our Lord, which leads to eternal life."
,"22":"Try to convince those who doubt;"
,"23":"others you will save, snatching them from condemnation. Treat the others with compassion but also with prudence, shunning even the clothes which touched their body."
,"24":"To the one God who is able to keep you from all sin and bring you happy and without blemish before his own Glory,"
,"25":"to the one God who saves us through Jesus Christ, our Lord, to him be glory, honor, might and power, from past ages, now and forever. Amen."
}`)

}
func EN_CCB_LoadNEIOChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"In the beginning was the Word. And the Word was with God,and the Word was God;"
,"2":"he was in the beginning with God."
,"3":"All things were made through him,and without him nothing came to be. Whatever has come to be, "
,"4":"found life in him, life which for humans was also light."
,"5":"Light that shines in the dark: light that darkness could not overcome."
,"6":"A man came, sent by God; his name was John."
,"7":"He came to bear witness, as a witness to introduce the Light,so that all might believe through him."
,"8":"He was not the Light,but a witness to introduce the Light."
,"9":"For the Light was coming into the world, the true Light that enlightens everyone."
,"10":"He was already in the world,and through him the world was made, the very world that did not know him."
,"11":"He came to his own, yet his own people did not receive him;"
,"12":"but all who have received him,he empowers to become children of God,for they believe in his Name."
,"13":"These are born, but without seed,or carnal desire or will of man: they are born of God."
,"14":"And the Word was made flesh; he had his tent pitched among us, and we have seen his Glory, the Glory of the only Son,coming from the Father: fullness of truth and loving-kindness."
,"15":"John bore witness to him openly, saying: This is the one who comes after me, but he is already ahead of me,for he was before me."
,"16":"From his fullness we have all received, favor upon favor."
,"17":"For God had given us the Law through Moses, but Truth and Loving-kindness,came through Jesus Christ."
,"18":"No one has ever seen God, but God-the-Only-Son made him known: the one who is in and with the Father."
,"19":"This was the testimony of John when the jews sent priests and levites to ask him, 'Who are you?'"
,"20":"John recognized the truth and did not deny it. he said, 'I am not the Messiah.'"
,"21":"And they asked him, 'Then who are you? Elijah?' He answered, 'I am not.' They said, 'Are you the Prophet?' And he answered, 'No.'"
,"22":"Then they said to him, 'Tell us who you are, so that we can give some answer to those who sent us. How do you see yourself?'"
,"23":"And John said, quoting the prophet Isaiah, 'I am the voice crying out in the wilderness: Make straight the way of the Lord.'"
,"24":"Those who had been sent were Pharisees;"
,"25":"so they put a further question to John: 'Then why are you baptizing if you are not the Messiah, or Elijah, or the Prophet?'"
,"26":"John answered, 'I baptize you with water, but among you stands one whom you do not know;"
,"27":"although he comes after me, I am not worthy to untie the strap of his sandal.'"
,"28":"This happened in Bethabara beyond the Jordan, where John was baptizing."
,"29":"The next day John saw Jesus coming towards him and said, 'There is the Lamb of God, who takes away the sin of the world."
,"30":"It is he of whom I said: A man comes after me who is already ahead of me, for he was before me."
,"31":"I myself did not know him, but I came baptizing to prepare for him, so that he might be revealed in Israel.'"
,"32":"And John also gave this testimony, 'I saw the Spirit coming down on him like a dove from heaven and resting on him."
,"33":"I myself did not know him but God who sent me to baptize told me: 'You will see the Spirit coming down and resting on the one who baptizes with the Holy Spirit.'"
,"34":"Yes, I have seen! and I declare that this is the Chosen One of God.'"
,"35":"On the following day John was standing there again with two of his disciples."
,"36":"As Jesus walked by, John looked at him and said, 'There is the Lamb of God.'"
,"37":"On hearing this, the two disciples followed Jesus."
,"38":"He turned and saw them following, and he said to them, 'What are you looking for?' They answered, 'Rabbi (which means Master), where are you staying?'"
,"39":"Jesus said, 'Come and see.' So they went and saw where he stayed and spent the rest of that day with him. It was about four o'clock in the afternoon."
,"40":"Andrew, the brother of Simon Peter, was one of the two who heard what John had said and followed Jesus."
,"41":"Early the next morning he found his brother Simon and said to him, 'We have found the Messiah' (which means the Christ),"
,"42":"and he brought Simon to Jesus. Jesus looked at him and said, 'You are Simon, son of John, but you shall be called Cephas' (which means Rock)."
,"43":"The next day, Jesus decided to set off for Galilee. He found Philip and said to him, 'Follow me.'"
,"44":"Philip was from Bethsaida, the town of Andrew and Peter."
,"45":"Philip found Nathanael and said to him, 'We have found the one that Moses wrote about in the Law, and the prophets as well: he is Jesus, son of Joseph, from Nazareth.'"
,"46":"Nathanael replied, 'Can anything good come from Nazareth?' Philip said to him, 'Come and see.'"
,"47":"When Jesus saw Nathanael coming, he said of him, 'Here comes an Israelite, a true one; there is nothing false in him.'"
,"48":"Nathanael asked him, 'How do you know me?' And Jesus said to him, 'Before Philip called you, you were under the fig tree and I saw you.'"
,"49":"Nathanael answered, 'Master, you are the Son of God! You are the King of Israel!'"
,"50":"But Jesus replied, 'You believe because I said: 'I saw you under the fig tree.' But you will see greater things than that."
,"51":"Truly, I say to you, you will see the heavens opened and the angels of God ascending and descending upon the Son of Man.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Three days later there was a wedding at Cana in Galilee and the mother of Jesus was there."
,"2":"Jesus was also invited to the wedding with his disciples."
,"3":"When all the wine provided for the celebration had been served and they had run out of wine, the mother of Jesus said to him, 'They have no wine.'"
,"4":"Jesus replied, 'Woman, your thoughts are not mine! My hour has not yet come.'"
,"5":"However his mother said to the servants, 'Do whatever he tells you.'"
,"6":"Nearby were six stone water jars meant for the ritual washing as practiced by the Jews; each jar could hold twenty or thirty gallons."
,"7":"Jesus said to the servants, 'Fill the jars with water.' And they filled them to the brim."
,"8":"Then Jesus said, 'Now draw some out and take it to the steward.' So they did."
,"9":"The steward tasted the water that had become wine, without knowing from where it had come; for only the servants who had drawn the water knew. So, he called the bridegroom"
,"10":"to tell him, 'Everyone serves the best wine first and when people have drunk enough, he serves that which is ordinary. Instead you have kept the best wine until the end.'"
,"11":"This miraculous sign was the first, and Jesus performed it at Cana in Galilee. In this way he let his Glory appear and his disciples believed in him."
,"12":"After this, Jesus went down to Capernaum with his mother, his brothers and his disciples; and they stayed there for a few days."
,"13":"As the Passover of the Jews was at hand, Jesus went up to Jerusalem."
,"14":"In the Temple court he found merchants selling oxen, sheep and doves, and money-changers seated at their tables."
,"15":"Making a whip of cords, he drove them all out of the Temple court, together with the oxen and sheep. He knocked over the tables of the money-changers, scattering the coins,"
,"16":"and ordered the people selling doves, 'Take all this away and stop turning my Father's house into a marketplace!'"
,"17":"His disciples recalled the words of Scripture: Zeal for your House devours me as a fire."
,"18":"The Jews then questioned Jesus, 'Where are the miraculous signs which give you the right to do this?'"
,"19":"And Jesus said, 'Destroy this temple and in three days I will raise it up.'"
,"20":"The Jews then replied, 'The building of this temple has already taken forty-six years, and you will raise it up in three days?'"
,"21":"Actually, Jesus was referring to the temple of his body."
,"22":"Only when he had risen from the dead did his disciples remember these words; then they believed both the Scripture and the words Jesus had spoken."
,"23":"Jesus stayed in Jerusalem during the Passover Festival and many believed in his Name when they saw the miraculous signs he performed."
,"24":"But Jesus did not trust himself to them, because he knew all of them."
,"25":"He had no need of evidence about anyone for he himself knew what there was in each one."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Among the Pharisees there was a ruler of the Jews named Nicodemus."
,"2":"He came to Jesus by night and said, 'Rabbi, we know that you have come from God to teach us, for no one can perform miraculous signs like yours unless God is with him.'"
,"3":"Jesus replied, 'Truly, I say to you, no one can see the kingdom of God unless he is born again from above.'"
,"4":"Nicodemus said, 'How can there be rebirth for a grown man? Who could go back to his mother's womb and be born again?'"
,"5":"Jesus replied, 'Truly, I say to you: No one can enter the kingdom of God without being born of water and Spirit."
,"6":"What is born of the flesh is flesh, and what is born of the Spirit is spirit."
,"7":"Because of this, don't be surprised when I say: 'You must be born again from above.'"
,"8":"The wind blows where it pleases and you hear its sound, but you don't know where it comes from or where it is going. It is like that with everyone who is born of the Spirit.'"
,"9":"Nicodemus asked again, 'How can this be?'"
,"10":"And Jesus answered, 'You are a teacher in Israel, and you don't know these things!"
,"11":"Truly, I say to you, we speak of what we know and we witness to the things we have seen, but you don't accept our testimony."
,"12":"If you don't believe when I speak of earthly things, what then, when I speak to you of heavenly things?"
,"13":"No one has ever gone up to heaven except the one who came from heaven, the Son of Man."
,"14":"As Moses lifted up the serpent in the desert, so must the Son of Man be lifted up,"
,"15":"so that whoever believes in him may have eternal life."
,"16":"Yes, God so loved the world that he gave his only Son that whoever believes in him may not be lost, but may have eternal life."
,"17":"God did not send the Son into the world to condemn the world; instead, through him the world is to be saved."
,"18":"Whoever believes in him will not be condemned. He who does not believe is already condemned, because he has not believed in the Name of the only Son of God."
,"19":"This is how the Judgment is made: Light has come into the world and people loved darkness rather than light because their deeds were evil."
,"20":"For whoever does wrong hates the light and doesn't come to the light for fear that his deeds will be shown as evil."
,"21":"But whoever lives according to the truth comes into the light so that it can be clearly seen that his works have been done in God.'"
,"22":"After this, Jesus went into the territory of Judea with his disciples. He stayed there with them and baptized."
,"23":"John was also baptizing in Aenon near Salim where water was plentiful; people came to him and were baptized."
,"24":"This happened before John was put in prison."
,"25":"Now John's disciples had been questioned by a Jew about spiritual cleansing,"
,"26":"so they came to him and said, 'Rabbi, the one who was with you across the Jordan, and about whom you spoke favorably, is now baptizing and all are going to him.'"
,"27":"John answered, 'No one can take on anything except what has been given him from heaven."
,"28":"You yourselves are my witnesses that I said: 'I am not the Christ but I have been sent before him.'"
,"29":"Only the bridegroom has the bride; but the friend of the bridegroom stands by and listens, and rejoices to hear the bridegroom's voice. My joy is now full."
,"30":"It is necessary that he increase but that I decrease."
,"31":"He who comes from above is above all; he who comes from the earth belongs to the earth and his words, too, are earthly. The One who comes from heaven"
,"32":"speaks of the things he has seen and heard; he bears witness to this but no one accepts his testimony."
,"33":"Whoever does receive his testimony acknowledges the truthfulness of God."
,"34":"The one sent by God speaks God's words and gives the Spirit without measure."
,"35":"For the Father loves the Son and has entrusted everything into his hands."
,"36":"Whoever believes in the Son lives with eternal life, but he who will not believe in the Son will never know life and always faces the justice of God.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"The Lord knew that the Pharisees were informed about him; people said that Jesus was attracting and baptizing more disciples than John;"
,"2":"in fact it was not Jesus himself who was baptizing but his disciples."
,"3":"So Jesus left Judea and returned to Galilee."
,"4":"He had to cross Samaria."
,"5":"He came to a Samaritan town called Sychar, near the land that Jacob had given to his son Joseph."
,"6":"Jacob's well is there. Tired from his journey, Jesus sat down by the well; it was about noon."
,"7":"Now a Samaritan woman came to draw water and Jesus said to her, 'Give me a drink.'"
,"8":"His disciples had just gone into town to buy some food."
,"9":"The Samaritan woman said to him, 'How is it that you, a Jew, ask me, a Samaritan and a woman, for a drink?' (For Jews, in fact, have no dealings with Samaritans.)"
,"10":"Jesus replied, 'If you only knew the Gift of God! If you knew who it is that asks you for a drink, you yourself would have asked me and I would have given you living water.'"
,"11":"The woman answered, 'Sir, you have no bucket and this well is deep; where is your living water?"
,"12":"Are you greater than our ancestor Jacob, who gave us this well after he drank from it himself, together with his sons and his cattle?'"
,"13":"Jesus said to her, 'Those who drink of this water will be thirsty again;"
,"14":"but those who drink of the water that I shall give will never be thirsty; for the water that I shall give will become in them a spring of water welling up to eternal life.'"
,"15":"The woman said to him, 'Give me this water, that I may never be thirsty and never have to come here to draw water.'"
,"16":"Jesus said, 'Go, call your husband and come back here.'"
,"17":"The woman answered, 'I have no husband.' And Jesus replied, 'You are right to say: 'I have no husband';"
,"18":"for you have had five husbands and the one you have now is not your husband. What you said is true.'"
,"19":"The woman then said to him, 'I see you are a prophet; tell me this:"
,"20":"Our fathers used to come to this mountain to worship God; but you Jews, do you not claim that Jerusalem is the only place to worship God?'"
,"21":"Jesus said to her, 'Believe me, woman, the hour is coming when you shall worship the Father, but that will not be on this mountain or in Jerusalem."
,"22":"You Samaritans worship without knowledge, while we Jews worship with knowledge, for salvation comes from the Jews."
,"23":"But the hour is coming and is even now here, when the true worshipers will worship the Father in spirit and truth; for that is the kind of worshippers the Father wants."
,"24":"God is spirit and those who worship him must worship in spirit and truth.'"
,"25":"The woman said to him, 'I know that the Messiah, that is the Christ, is coming; when he comes, he will tell us everything.'"
,"26":"And Jesus said, 'I who am talking to you, I am he.'"
,"27":"At this point the disciples returned and were surprised that Jesus was speaking with a woman; however, no one said, 'What do you want?' or: 'Why are you talking with her?'"
,"28":"So the woman left her water jar and ran to the town. There she said to the people,"
,"29":"'Come and see a man who told me everything I did! Could he not be the Christ?'"
,"30":"So they left the town and went to meet him."
,"31":"In the meantime the disciples urged Jesus, 'Master, eat.'"
,"32":"But he said to them, 'I have food to eat that you don't know about.'"
,"33":"And the disciples wondered, 'Has anyone brought him food?'"
,"34":"Jesus said to them, 'My food is to do the will of the One who sent me and to carry out his work."
,"35":"You say that in four more months it will be the harvest; now, I say to you, look up and see the fields white and ready for harvesting."
,"36":"People who reap the harvest are paid for their work, and the fruit is gathered for eternal life, so that sower and reaper may rejoice together."
,"37":"Indeed the saying holds true: 'One sows and another reaps.'"
,"38":"I sent you to reap where you didn't work or suffer; others have worked and you are now sharing in their labors.'"
,"39":"In that town many Samaritans believed in him when they heard the woman who declared, 'He told me everything I did.'"
,"40":"So, when they came to him, they asked him to stay with them and Jesus stayed there two days."
,"41":"After that many more believed because of his own words"
,"42":"and they said to the woman, 'We no longer believe because of what you told us; for we have heard for ourselves and we know that this is the Savior of the world.'"
,"43":"When the two days were over, Jesus left for Galilee."
,"44":"Jesus himself said that no prophet is recognized in his own country."
,"45":"Yet the Galileans welcomed him when he arrived, because of all the things he had done in Jerusalem during the Festival and which they had seen. For they, too, had gone to the feast."
,"46":"Jesus went back to Cana of Galilee where he had changed the water into wine. At Capernaum there was an official whose son was ill,"
,"47":"and when he heard that Jesus had come from Judea to Galilee, he went and asked him to come and heal his son, for he was at the point of death."
,"48":"Jesus said, 'Unless you see signs and wonders, you will not believe!'"
,"49":"The official said, 'Sir, come down before my child dies.'"
,"50":"And Jesus replied, 'Go, your son is living.',The man had faith in the word that Jesus spoke to him and went his way. "
,"51":"He was already going down the hilly road when his servants met him with this news, 'Your son has recovered!'"
,"52":"So he asked them at what hour the child had begun to recover and they said to him, 'The fever left him yesterday in the afternoon about one o'clock.'"
,"53":"And the father realized that it was the time when Jesus told him, 'Your son is living.' And he became a believer, he and all his family."
,"54":"Jesus performed this second miraculous sign when he returned from Judea to Galilee."
}`)
	CurrentBook.AddChapter(5, `{
"1":"After this there was a feast of the Jews and Jesus went up to Jerusalem."
,"2":"Now, by the Sheep Gate in Jerusalem, there is a pool (called Bethzatha in Hebrew) surrounded by five galleries."
,"3":"In these galleries lay a multitude of sick people - blind, lame and paralyzed."
,"4":"All were waiting for the water to move, for at times an angel of the Lord would descend into the pool and stir up the water; and the first person to enter after this movement of the water would be healed of whatever disease that person had.)"
,"5":"There was a man who had been sick for thirty-eight years."
,"6":"Jesus saw him, and since he knew how long this man had been lying there, he said to him, 'Do you want to be healed?'"
,"7":"And the sick man answered, 'Sir, I have no one to put me into the pool when the water is disturbed; so while I am still on my way, another steps down before me.'"
,"8":"Jesus then said to him, 'Stand up, take your mat and walk.'"
,"9":"And at once the man was healed, and he took up his mat and walked. Now that day happened to be the sabbath. "
,"10":"So the Jews said to the man who had just been healed, 'It is the sabbath and the Law doesn't allow you to carry your mat.'"
,"11":"He answered them, 'The one who healed me said to me: Take up your mat and walk.'"
,"12":"They asked him, 'Who is the one who said to you: Take up your mat and walk?'"
,"13":"But the sick man had no idea who it was who had cured him, for Jesus had slipped away among the crowd that filled the place."
,"14":"Afterwards Jesus met him in the Temple court and told him, 'Now you are well; don't sin again, lest something worse happen to you.'"
,"15":"And the man went back and told the Jews that it was Jesus who had healed him."
,"16":"So the Jews persecuted Jesus because he performed healings like that on the sabbath."
,"17":"Jesus replied, 'My Father goes on working and so do I.'"
,"18":"And the Jews tried all the harder to kill him, for Jesus not only broke the sabbath observance, but also made himself equal with God, calling him his own Father."
,"19":"Jesus said to them, 'Truly, I assure you, the Son cannot do anything by himself, but only what he sees the Father do. And whatever he does, the Son also does."
,"20":"The Father loves the Son and shows him everything he does; and he will show him even greater things than these, so that you will be amazed."
,"21":"As the Father raises the dead and gives them life, so the Son gives life to whom he wills."
,"22":"In the same way the Father judges no one, for he has entrusted all judgment to the Son,"
,"23":"and he wants all to honor the Son as they honor the Father. Whoever ignores the Son, ignores as well the Father who sent him."
,"24":"Truly, I say to you, anyone who hears my word and believes him who sent me, has eternal life; and there is no judgment for him because he has passed from death to life."
,"25":"Truly, the hour is coming and has indeed come, when the dead will hear the voice of the Son of God and, on hearing it, will live."
,"26":"For the Father has life in himself and he has given to the Son also to have life in himself."
,"27":"And he has empowered him as well to carry out Judgment, for he is a son of man."
,"28":"Do not be surprised at this: the hour is coming when all those lying in tombs will hear my voice"
,"29":"and come out; those who have done good shall rise to live, and those who have done evil will rise to be condemned."
,"30":"I can do nothing of myself, and I need to hear Another One to judge; and my judgment is just, because I seek not my own will, but the will of him who sent me."
,"31":"If I bore witness to myself, my testimony would be worthless."
,"32":"But Another One is bearing witness to me and I know that his testimony is true when he bears witness to me."
,"33":"John also bore witness to the truth when you sent messengers to him,"
,"34":"but I do not seek such human testimony; I recall this for you, so that you may be saved."
,"35":"John was a burning and shining lamp, and for a while you were willing to enjoy his light."
,"36":"But I have greater evidence than that of John - the works which the Father entrusted to me to carry out. The very works I do bear witness: the Father has sent me."
,"37":"Thus he who bears witness to me is the Father who sent me. You have never heard his voice and have never seen his likeness;"
,"38":"then, as long as you do not believe his messenger, his word is not in you."
,"39":"You search in the Scriptures thinking that in them you will find life; yet Scripture bears witness to me."
,"40":"But you refuse to come to me, that you may live."
,"41":"I am not seeking human praise;"
,"42":"but I have known that love of God is not within you,"
,"43":"for I have come in my Father's name and you do not accept me. If another comes in his own name, you will accept him."
,"44":"As long as you seek praise from one another instead of seeking the glory coming from the only God, how can you believe?"
,"45":"Do not think that I shall accuse you to the Father. Moses himself in whom you placed your hope, accuses you."
,"46":"If you believed Moses, you would believe me, for he wrote of me."
,"47":"But if you do not believe what he wrote, how will you believe what I say?"
,"19":"Moses gave you the Law, didn't he? But none of you keep the Law. Why, then, do you want to kill me?'"
,"20":"The people replied, 'You have a demon; who wants to kill you?'"
,"21":"Jesus said to them, 'I performed a single deed, and you are all astounded by it."
,"22":"But remember the circumcision ordered by Moses - actually it was not Moses but the ancestors who began this practice. You circumcise a man even on the sabbath,"
,"23":"and you would break the Law if you refused to do so because of the sabbath. How is it, then, that you are indignant with me because I healed the whole person on the sabbath?"
,"24":"Do not judge by appearances, but according to what is right.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"After this Jesus went to the other side of the Sea of Galilee, near Tiberias,"
,"2":"and large crowds followed him because of the miraculous signs they saw when he healed the sick."
,"3":"So he went up into the hills and sat down there with his disciples."
,"4":"Now the Passover, the feast of the Jews, was at hand."
,"5":"Then lifting up his eyes, Jesus saw the crowds that were coming to him and said to Philip, 'Where shall we buy bread so that these people may eat?'"
,"6":"He said this to test Philip, for he himself knew what he was going to do."
,"7":"Philip answered him, 'Two hundred silver coins would not buy enough bread for each of them to have a piece.'"
,"8":"Then one of Jesus' disciples, Andrew, Simon Peter's brother, said,"
,"9":"'There is a boy here who has five barley loaves and two fish; but what good are these for so many?'"
,"10":"Jesus said, 'Make the people sit down.' There was plenty of grass there so the people, about five thousand men, sat down to rest."
,"11":"Jesus then took the loaves, gave thanks and distributed them to those who were seated. He did the same with the fish and gave them as much as they wanted."
,"12":"And when they had eaten enough, he told his disciples, 'Gather up the pieces left over, that nothing may be lost.'"
,"13":"So they gathered them up and filled twelve baskets with bread, that is with pieces of the five barley loaves left by those who had eaten."
,"14":"When the people saw this sign that Jesus had just given, they said, 'This is really the Prophet, he who is to come into the world.'"
,"15":"Jesus realized that they would come and take him by force to make him king; so he fled to the hills by himself."
,"16":"When evening came, the disciples went down to the shore."
,"17":"After a while they got into a boat to make for Capernaum on the other side of the sea, for it was now dark and Jesus had not yet come to them."
,"18":"But the sea was getting rough because a strong wind was blowing."
,"19":"They had rowed about three or four miles, when they saw Jesus walking on the sea, and he was drawing near to the boat. They were frightened,"
,"20":"but he said to them, 'It is Me; don't be afraid.'"
,"21":"They wanted to take him into the boat, but immediately the boat was at the shore to which they were going."
,"22":"Next day the people who had stayed on the other side realized that only one boat had been there and that Jesus had not entered it with his disciples; rather, the disciples had gone away alone."
,"23":"Bigger boats from Tiberias came near the place where all these people had eaten the bread."
,"24":"When they saw that neither Jesus nor his disciples were there, they got into the boats and went to Capernaum looking for Jesus."
,"25":"When they found him on the other side of the lake, they asked him, 'Master, when did you come here?'"
,"26":"Jesus answered, 'Truly, I say to you, you look for me, not because you have seen through the signs, but because you ate bread and were satisfied."
,"27":"Work then, not for perishable food, but for the lasting food which gives eternal life. The Son of Man will give it to you, for he is the one the Father has marked.'"
,"28":"Then the Jews asked him, 'What shall we do? What are the works that God wants us to do?'"
,"29":"And Jesus answered them, 'The work God wants is this: that you believe in the One whom God has sent.'"
,"30":"They then said, 'Show us miraculous signs, that we may see and believe you. What sign do you perform?"
,"31":"Our ancestors ate manna in the desert; as Scripture says: They were given bread from heaven to eat.'"
,"32":"Jesus then said to them, 'Truly, I say to you, it was not Moses who gave you the bread from heaven. My Father gives you the true bread from heaven."
,"33":"The bread God gives is the One who comes from heaven and gives life to the world.'"
,"34":"And they said to him, 'Give us this bread always.'"
,"35":"Jesus said to them, 'I am the bread of life; whoever comes to me shall never be hungry, and whoever believes in me shall never be thirsty."
,"36":"Nevertheless, as I said, you refuse to believe, even when you have seen."
,"37":"Yet, all that the Father gives me will come to me, and whoever comes to me, I shall not turn away."
,"38":"For I have come from heaven, not to do my own will, but the will of the One who sent me."
,"39":"And the will of him who sent me is that I lose nothing of what he has given me, but instead that I raise it up on the last day."
,"40":"This is the will of the Father, that whoever sees the Son and believes in him shall live with eternal life; and I will raise him up on the last day.'"
,"41":"The Jews murmured because Jesus had said, 'I am the bread which comes from heaven.'"
,"42":"And they said, 'This man is the son of Joseph, isn't he? We know his father and mother. How can he say that he has come from heaven?'"
,"43":"Jesus answered them, 'Do not murmur among yourselves."
,"44":"No one can come to me unless he is drawn by the Father who sent me; and I will raise him up on the last day."
,"45":"It has been written in the Prophets: They shall all be taught by God. So whoever listens and learns from the Father comes to me."
,"46":"For no one has seen the Father except the One who comes from God; he has seen the Father."
,"47":"Truly, I say to you, whoever believes has eternal life."
,"48":"I am the bread of life."
,"49":"Though your ancestors ate the manna in the desert, they died."
,"50":"But here you have the bread which comes from heaven so that you may eat of it and not die."
,"51":"I am the living bread which has come from heaven; whoever eats of this bread will live forever. The bread I shall give is my flesh and I will give it for the life of the world.'"
,"52":"The Jews were arguing among themselves, 'How can this man give us flesh to eat?'"
,"53":"So Jesus replied, 'Truly, I say to you, if you do not eat the flesh of the Son of Man and drink his blood, you have no life in you."
,"54":"The one who eats my flesh and drinks my blood live with eternal life and I will raise him up on the last day."
,"55":"My flesh is really food and my blood is drink."
,"56":"Those who eat my flesh and drink my blood, live in me and I in them."
,"57":"Just as the Father, who is life, sent me and I have life from the Father, so whoever eats me will have life from me."
,"58":"This is the bread which came from heaven; unlike that of your ancestors, who ate and later died. Those who eat this bread will live forever.'"
,"59":"Jesus spoke in this way in Capernaum when he taught them in the synagogue."
,"60":"After hearing this, many of Jesus' followers said, 'This language is very hard! Who can accept it?'"
,"61":"Jesus was aware that his disciples were murmuring about this and so he said to them, 'Does this offend you?"
,"62":"Then how will you react when you see the Son of Man ascending to where he was before?"
,"63":"It is the spirit that gives life; the flesh cannot help. The words that I have spoken to you are spirit and they are life."
,"64":"But among you there are some who do not believe.',From the beginning, Jesus knew who would betray him. "
,"65":"So he added, 'As I have told you, no one can come to me unless it is granted by the Father.'"
,"66":"After this many disciples withdrew and no longer followed him."
,"67":"Jesus asked the Twelve, 'Will you also go away?'"
,"68":"Peter answered him, 'Lord, to whom shall we go? You have the words of eternal life."
,"69":"We now believe and know that you are the Holy One of God.'"
,"70":"Jesus said to them, 'I chose you, the Twelve, did I not? Yet one of you is a devil.'"
,"71":"Jesus spoke of Judas Iscariot, the son of Simon. He, one of the Twelve, was to betray him."
}`)
	CurrentBook.AddChapter(7, `{
"1":"After this Jesus went around Galilee; he would not go about in Judea because the Jews wanted to kill him."
,"2":"Now the Jewish feast of the Tents was at hand."
,"3":"So the brothers of Jesus said to him, 'Don't stay here; go instead to Judea and let your disciples see the works you are doing."
,"4":"Anyone who wants to be known doesn't work secretly. Since you are able to do these things, show yourself to the world.'"
,"5":"His brothers spoke like this because they didn't believe in him."
,"6":"Jesus said to them, 'My time has not yet come, but your time is always here."
,"7":"The world cannot hate you; but it hates me because I bear witness and I show that its deeds are evil."
,"8":"Go up to the feast! I am not going to this feast, because my time has not yet come.'"
,"9":"Jesus spoke like this and remained in Galilee."
,"10":"But after his brothers had gone to the festival, he also went up, not publicly but in secret."
,"11":"The Jews were looking for him at the festival and asked, 'Where is he?'"
,"12":"There was a lot of talk about him among the people. Some said, 'He is a good man,' but others replied, 'No, he is misleading the people.'"
,"13":"For fear of the Jews no one spoke openly about him."
,"14":"When the festival was half over, Jesus went to the Temple and began to teach."
,"15":"The Jews marveled and said, 'How is it that he knows Scriptures when he has had no teacher?'"
,"16":"And Jesus answered them, 'My teaching is not mine, but it comes from the One who sent me."
,"17":"Anyone who does the will of God shall know whether my teaching is from God or whether I speak on my own authority."
,"18":"Those who speak on their own authority wish to gain honor for themselves. But the one who seeks the glory of him who sent him is truthful and there is no reason to doubt him.'"
,"25":"Some of the people of Jerusalem said, 'Is this not the man they want to kill?"
,"26":"And here he is speaking freely, and they don't say a word to him? Can it be that the rulers know that this is really the Christ?"
,"27":"Yet we know where this man comes from; but when the Christ appears, no one will know where he comes from.'"
,"28":"So Jesus announced in a loud voice in the Temple court where he was teaching, 'You say that you know me and know where I come from! I have not come of myself; I was sent by the One who is true, and you don't know him."
,"29":"I know him for I come from him and he sent me.'"
,"30":"They would have arrested him, but no one laid hands on him because his time had not yet come."
,"31":"Many people in the crowd, however, believed in him and said, 'When the Christ comes, will he give more signs than this man?'"
,"32":"The Pharisees heard all these rumors among the people; they and the chief priests sent officers of the temple to arrest him."
,"33":"Jesus then said, 'I shall be with you a little longer; after that I shall go to him who sent me."
,"34":"You will look for me and you will not find me. Where I am you cannot come.'"
,"35":"The Jews said to one another, 'Where does this man intend to go where we shall not find him? Will he go abroad to the Jews dispersed among the Greek nations and teach the Greeks also?"
,"36":"What does he mean when he says: 'You will look for me and not find me,' and: 'Where I am going you cannot come'?'"
,"37":"On the last and greatest day of the festival, Jesus stood up and proclaimed, 'Let anyone who is thirsty, come to me;"
,"38":"and let the one who believes in me drink, for the Scripture says: Out of him shall flow rivers of living water.'"
,"39":"Jesus was referring to the Spirit which those who believe in him were to receive; the Spirit had not yet been given because Jesus had not yet entered into his Glory."
,"40":"Many who had been listening to these words began to say, 'This is the Prophet.'"
,"41":"Others said, 'This is the Christ.' But some wondered, 'Would the Christ come from Galilee?"
,"42":"Doesn't Scripture say that the Christ is a descendant of David and from Bethlehem, the city of David?'"
,"43":"The crowd was divided over him."
,"44":"Some wanted to arrest him, but no one laid hands on him."
,"45":"The officers of the Temple went back to the chief priests who asked them, 'Why didn't you bring him?'"
,"46":"The officers answered, 'No one ever spoke like this man.'"
,"47":"The Pharisees then said, 'So you, too, have been led astray!"
,"48":"Have any of the rulers or any of the Pharisees believed in him?"
,"49":"Only these cursed people, who have no knowledge of the Law!'"
,"50":"Yet one of them, Nicodemus, who had gone to Jesus earlier, spoke out,"
,"51":"'Does our law condemn people without first hearing them and knowing the facts?'"
,"52":"They replied, 'Do you, too, come from Galilee? Look it up and see for yourself that no prophet is to come from Galilee.'"
,"53":"And they all went home."
}`)
	CurrentBook.AddChapter(8, `{
"1":"As for Jesus, he went to the Mount of Olives."
,"2":"At daybreak Jesus appeared in the Temple again. All the people came to him, and he sat down and began to teach them."
,"3":"Then the teachers of the Law and the Pharisees brought in a woman who had been caught in the act of adultery. They made her stand in front of everyone."
,"4":"'Master,' they said, 'this woman has been caught in the act of adultery."
,"5":"Now the Law of Moses orders that such women be stoned to death; but you, what do you say?'"
,"6":"They said this to test Jesus, in order to have some charge against him. Jesus bent down and started writing on the ground with his finger. "
,"7":"And as they continued to ask him, he straightened up and said to them, 'Let anyone among you who has no sin be the first to throw a stone at her.'"
,"8":"And he bent down again, writing on the ground."
,"9":"As a result of these words, they went away, one by one, starting with the elders, and Jesus was left alone with the woman standing before him."
,"10":"Then Jesus stood up and said to her, 'Woman, where are they? Has no one condemned you?'"
,"11":"She replied, 'No one.' And Jesus said, 'Neither do I condemn you; go away and don't sin again.'"
,"12":"Jesus spoke to them again, 'I am the Light of the world; the one who follows me will not walk in darkness, but will have light and life.'"
,"13":"The Pharisees replied, 'Now you are speaking on your own behalf, your testimony is worthless.'"
,"14":"Then Jesus said, 'Even though I bear witness to myself, my testimony is true, for I know where I have come from and where I am going. But you do not know where I came from or where I am going."
,"15":"You judge by human standards; as for me, I don't judge anyone."
,"16":"But if I had to judge, my judgment would be valid for I am not alone: the Father who sent me is with me."
,"17":"In your Law it is written that the testimony of two witnesses is valid;"
,"18":"so I am bearing witness to myself, and the Father who sent me bears witness to me.'"
,"19":"They asked him, 'Where is your Father?' Jesus answered, 'You don't know me or my Father; if you knew me, you would know my Father as well.'"
,"20":"Jesus said these things when he was teaching in the Temple area, in the place where they received the offerings. No one arrested him, because his hour had not yet come."
,"21":"Again Jesus said to them, 'I am going away, and though you look for me, you will die in your sin. Where I am going you cannot come.'"
,"22":"The Jews wondered, 'Why does he say that we can't come where he is going? Will he kill himself?'"
,"23":"But Jesus said, 'You are from below and I am from above; you are of this world and I am not of this world."
,"24":"That is why I told you that you will die in your sins. And you shall die in your sins unless you believe that I am He.'"
,"25":"They asked him, 'Who are you?'; and Jesus said, 'Just what I have told you from the beginning."
,"26":"I have much to say about you and much to condemn; but the One who sent me is truthful and everything I learned from him, I proclaim to the world.'"
,"27":"They didn't understand that Jesus was speaking to them about the Father."
,"28":"So Jesus said, 'When you have lifted up the Son of Man, then you will know that I am He and that I do nothing of myself, but I say just what the Father taught me."
,"29":"He who sent me is with me and has not left me alone; because I always do what pleases him.'"
,"30":"As Jesus spoke like this, many believed in him."
,"31":"Jesus went on to say to the Jews who believed in him: 'You will be my true disciples if you keep my word."
,"32":"Then you will know the truth and the truth will make you free.'"
,"33":"They answered him, 'We are the descendants of Abraham and have never been slaves of anyone. What do you mean by saying: You will be free?'"
,"34":"Jesus answered them, 'Truly, I say to you, whoever commits sin is a slave."
,"35":"But the slave doesn't stay in the house forever; the son stays forever."
,"36":"So, if the Son makes you free, you will be really free."
,"37":"I know that you are the descendants of Abraham; yet you want to kill me because my word finds no place in you."
,"38":"For my part I speak of what I have seen in the Father's presence, but you do what you have learned from your father.'"
,"39":"They answered him, 'Our father is Abraham.' Then Jesus said, 'If you were Abraham's children, you would do as Abraham did."
,"40":"But now you want to kill me, the one who tells you the truth - the truth that I have learned from God. That is not what Abraham did;"
,"41":"what you are doing are the works of your father.',The Jews said to him, 'We are not illegitimate children; we have one Father, God.' "
,"42":"Jesus replied, 'If God were your Father you would love me, for I came forth from God, and I am here. And I didn't come by my own decision, but it was he himself who sent me."
,"43":"Why do you not understand my teaching? It is because you cannot bear my message."
,"44":"The father you spring from is the devil and you will carry out the evil wishes of your father, who has been a murderer from the beginning. He didn't uphold the truth for, in him, there is no truth; and now, when he speaks for himself, he lies. He is a liar and the father of lies."
,"45":"Now I speak the truth and you don't believe me."
,"46":"Which of you could find anything false in me? Then, if I speak the truth, why do you not believe me?"
,"47":"He who is of God hears the words of God; you don't hear because you are not of God.'"
,"48":"The Jews retorted, 'So we are right in saying that you are a Samaritan and are possessed by a demon.'"
,"49":"Jesus said, 'I am not possessed, and you try to shame me when I give honor to my Father."
,"50":"I don't care about my own glory; there is One who cares for me and he will be the judge."
,"51":"Truly, I say to you, if anyone keeps my word, he will never experience death.'"
,"52":"The Jews replied, 'Now we know that you have a demon. Abraham died and the prophets as well, but you say: 'Whoever keeps my word will never experience death.' Who do you claim to be?"
,"53":"Do you claim to be greater than our father Abraham, who died? And the prophets also died.'"
,"54":"Then Jesus said, 'If I were to praise myself, it would count for nothing. But he who gives glory to me is the Father, the very one you claim as your God,"
,"55":"although you don't know him. I know him and if I were to say that I don't know him, I would be a liar like you. But I know him and I keep his word."
,"56":"As for Abraham, your ancestor, he looked forward to the day when I would come; and he rejoiced when he saw it.'"
,"57":"The Jews then said to him, 'You are not yet fifty years old and you have seen Abraham?'"
,"58":"And Jesus said 'Truly, I say to you, before Abraham was, I am.'"
,"59":"They then picked up stones to throw at him, but Jesus hid himself and left the Temple."
}`)
	CurrentBook.AddChapter(9, `{
"1":"As Jesus walked along, he saw a man who had been blind from birth."
,"2":"His disciples asked him, 'Master, was he born blind because of a sin of his, or of his parents?'"
,"3":"Jesus answered, 'Neither was it for his own sin nor for his parents'. He was born blind so that God's power might be shown in him."
,"4":"While it is day we must do the work of the One who sent me; for the night will come when no one can work."
,"5":"As long as I am in the world, I am the light of the world.'"
,"6":"As Jesus said this, he made paste with spittle and clay and rubbed it on the eyes of the blind man."
,"7":"Then he said, 'Go and wash in the Pool of Siloam.' (This name means sent.) So he went and washed and came back able to see."
,"8":"His neighbors and all the people who used to see him begging, wondered. They said, 'Isn't this the beggar who used to sit here?'"
,"9":"Some said, 'It's the one.' Others said, 'No, but he looks like him.' But the man himself said, 'I am the one.'"
,"10":"Then they asked, 'How is it that your eyes were opened?'"
,"11":"And he answered, 'The man called Jesus made a mud paste, put it on my eyes and said to me: 'Go to Siloam and wash.' So I went, and washed, and I could see.'"
,"12":"They asked, 'Where is he?' and the man answered, 'I don't know.'"
,"13":"The people brought the man who had been blind to the Pharisees."
,"14":"Now it was a sabbath day when Jesus made mud paste and opened his eyes."
,"15":"The Pharisees asked him again, 'How did you recover your sight?' And he said, 'He put paste on my eyes, and I washed, and now I see.'"
,"16":"Some of the Pharisees said, 'This man is not from God, for he works on the sabbath'; but others wondered, 'How can a sinner perform such miraculous signs?' They were divided"
,"17":"and they questioned the blind man again, 'What do you think of this man who opened your eyes?' And he answered, 'He is a prophet.'"
,"18":"After all this, the Jews refused to believe that the man had been blind and had recovered his sight; so they called his parents"
,"19":"and asked them, 'Is this your son? You say that he was born blind, how is it that he now sees?'"
,"20":"The parents answered, 'He really is our son and he was born blind;"
,"21":"but how it is that he now sees, we don't know, neither do we know who opened his eyes. Ask him, he is old enough. Let him speak for himself.'"
,"22":"The parents said this because they feared the Jews who had already agreed that whoever confessed Jesus to be the Christ was to be expelled."
,"23":"Because of this his parents said, 'He is old enough, ask him.'"
,"24":"So a second time the Pharisees called the man who had been blind, and they said to him, 'Tell us the truth; we know that this man is a sinner.'"
,"25":"He replied, 'I don't know whether he is a sinner or not; I only know that I was blind and now I see.'"
,"26":"They said to him, 'What did he do to you? How did he open your eyes?'"
,"27":"He replied, 'I have told you already and you would not listen. Why do you want to hear it again? Do you also want to become his disciples?'"
,"28":"Then they started to insult him. 'Become his disciple yourself! We are disciples of Moses."
,"29":"We know that God has spoken to Moses, but as for this man we don't know where he comes from.'"
,"30":"The man replied, 'It is amazing that you don't know where the man comes from, and yet he opened my eyes!"
,"31":"We know that God doesn't listen to sinners, but if anyone honors God and does his will, God listens to him."
,"32":"Never, since the world began, has it been heard that anyone opened the eyes of a person who was born blind."
,"33":"If this man were not from God, he could do nothing.'"
,"34":"They answered him, 'You were born a sinner and now you teach us!' And they expelled him."
,"35":"Jesus heard that they had expelled him. He found him and said, 'Do you believe in the Son of Man?'"
,"36":"He answered, 'Who is he, that I may believe in him?'"
,"37":"Jesus said, 'You have seen him and he is speaking to you."
,"38":"He said, 'Lord, I believe'; and he worshiped him."
,"39":"Jesus said, 'I came into this world to carry out a judgment: Those who do not see shall see, and those who see shall become blind.'"
,"40":"Some Pharisees stood by and asked him, 'So we are blind?'"
,"41":"And Jesus answered, 'If you were blind, you would not be guilty. Now you say: 'We see'; this is the proof of your sin.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Truly, I say to you, anyone who does not enter the sheepfold by the gate, but climbs in some other way, is a thief and a robber."
,"2":"But the shepherd of the sheep enters by the gate."
,"3":"The keeper opens the gate to him and the sheep hear his voice; he calls each of his sheep by name and leads them out."
,"4":"When he has brought out all his own, he goes before them and the sheep follow him for they know his voice."
,"5":"A stranger they will not follow, rather they will run away from him because they don't recognize a stranger's voice.'"
,"6":"Jesus used this comparison, but they did not understand what he was saying to them."
,"7":"So Jesus said, 'Truly, I say to you, I am the gate of the sheep."
,"8":"All who came were thieves and robbers, and the sheep did not hear them."
,"9":"I am the gate. Whoever enters through me will be saved; he will go in and out freely and find food."
,"10":"The thief comes to steal and kill and destroy, but I have come that they may have life, life in all its fullness."
,"11":"I am the good shepherd. The good shepherd gives his life for the sheep."
,"12":"Not so the hired hand or any other person who is not the shepherd and to whom the sheep do not belong. They abandon the sheep as soon as they see the wolf coming; then the wolf snatches and scatters the sheep."
,"13":"This is because the hired hand works for pay and cares nothing for the sheep."
,"14":"I am the good shepherd. I know my own and my own know me,"
,"15":"as the Father knows me and I know the Father. Because of this I give my life for my sheep."
,"16":"I have other sheep that are not of this fold. These I have to lead as well, and they shall listen to my voice. Then there will be one flock since there is one Shepherd."
,"17":"The Father loves me because I lay down my life in order to take it up again."
,"18":"No one takes it from me, but I lay it down freely. It is mine to lay down and to take up again: this mission I received from my Father.'"
,"19":"Because of these words, the Jews were divided again."
,"20":"Many of them said, 'He has a demon and is out of his mind. Why listen to him?'"
,"21":"But others said, 'One possessed doesn't speak in this way. Can a demon open the eyes of the blind?'"
,"22":"The time came for the feast of the Dedication. It was winter"
,"23":"and Jesus walked back and forth in the portico of Solomon."
,"24":"The Jews then gathered around him and said to him, 'How long will you keep us in doubt? If you are the Messiah, tell us plainly.'"
,"25":"Jesus answered, 'I have already told you but you do not believe."
,"26":"The works I do in my Father's name proclaim who I am, but you don't believe because, as I said, you are not my sheep."
,"27":"My sheep hear my voice and I know them; they follow me"
,"28":"and I give them eternal life. They shall never perish and no one will ever steal them from me."
,"29":"What the Father has given me is stronger than everything and no one can snatch it from the Father's hand."
,"30":"I and the Father are one.'"
,"31":"The Jews then picked up stones to throw at him;"
,"32":"so Jesus said, 'I have openly done many good works among you which the Father gave me to do. For which of these do you stone me?'"
,"33":"The Jews answered, 'We are not stoning you for doing a good work but for insulting God; you are only a man and you make yourself God.'"
,"34":"Then Jesus replied, 'Is this not written in your Law: I said: you are gods?"
,"35":"So those who received this word of God were called gods and the Scripture is always true."
,"36":"Then what should be said of the one anointed and sent into the world by the Father? Am I insulting God when I say: 'I am the Son of God'?"
,"37":"If I am not doing the works of my Father, do not believe me."
,"38":"But if I do them, even if you have no faith in me, believe because of the works I do, and know that the Father is in me and I in the Father.'"
,"39":"Again they tried to arrest him, but Jesus escaped from their hands."
,"40":"He went away again to the other side of the Jordan, to the place where John had baptized, and there he stayed."
,"41":"Many people came to him and said, 'John showed no miraculous signs, but he spoke of this man and everything he said was true.'"
,"42":"And many became believers in that place."
}`)
	CurrentBook.AddChapter(11, `{
"1":"There was a sick man named Lazarus who was from Bethany, the village of Mary and her sister Martha."
,"2":"It was the same Mary who anointed the Lord with perfume and wiped his feet with her hair. Her brother Lazarus was sick."
,"3":"So the sisters sent this message to Jesus, 'Lord, the one you love is sick.'"
,"4":"On hearing this Jesus said, 'This illness will not end in death; rather it is for God's glory and the Son of God will be glorified through it.'"
,"5":"It is a fact that Jesus loved Martha and her sister and Lazarus;"
,"6":"yet, after he heard of the illness of Lazarus, he stayed two days longer in the place where he was."
,"7":"Only then did he say to his disciples, 'Let us go into Judea again.'"
,"8":"They replied, 'Master, recently the Jews wanted to stone you. Are you going there again?'"
,"9":"Jesus said to them, 'Are not twelve working hours needed to complete a day? Those who walk in the daytime shall not stumble, for they see the light of this world."
,"10":"But those who walk at night stumble, for there is no light in them.'"
,"11":"After that Jesus said to them, 'Our friend Lazarus has fallen asleep, but I am going to wake him.'"
,"12":"The disciples replied, 'Lord, a sick person who sleeps will recover.'"
,"13":"But Jesus had referred to Lazarus' death, while they thought that he had meant the repose of sleep."
,"14":"So Jesus said plainly, 'Lazarus is dead"
,"15":"and for your sake I am glad I was not there, for now you may believe. But let us go there, where he is.'"
,"16":"Then Thomas, called the Twin, said to his fellow disciples, 'Let us also go that we may die with him.'"
,"17":"When Jesus came, he found that Lazarus had been in the tomb for four days."
,"18":"As Bethany is near Jerusalem, about two miles away,"
,"19":"many Jews had come to Martha and Mary to offer consolation at their brother's death."
,"20":"When Martha heard that Jesus was coming, she went to meet him while Mary remained sitting in the house."
,"21":"And she said to Jesus, 'If you had been here, my brother would not have died."
,"22":"But I know that whatever you ask from God, God will give you.'"
,"23":"Jesus said, 'Your brother will rise again.'"
,"24":"Martha replied, 'I know that he will rise in the resurrection, at the last day.'"
,"25":"But Jesus said to her, 'I am the resurrection; whoever believes in me, though he die, shall live."
,"26":"Whoever is alive by believing in me will never die. Do you believe this?'"
,"27":"Martha then answered, 'Yes, Lord, I have come to believe that you are the Christ, the Son of God, he who is coming into the world.'"
,"28":"After that Martha went and called her sister Mary secretly, saying, 'The Master is here and is calling for you.'"
,"29":"As soon as Mary heard this, she rose and went to him."
,"30":"Jesus had not yet come into the village, but was still in the place where Martha had met him."
,"31":"The Jews who were with her in the house consoling her, also came. When they saw her get up and go out, they followed her, thinking that she was going to the tomb to weep."
,"32":"As for Mary, when she came to the place where Jesus was and saw him, she fell at his feet and said, 'Lord, if you had been here, my brother would not have died.'"
,"33":"When Jesus saw her weeping and the Jews also who had come with her, he was moved in the depths of his spirit and troubled."
,"34":"Then he asked, 'Where have you laid him?' They answered, 'Lord, come and see.'"
,"35":"And Jesus wept."
,"36":"The Jews said, 'See how he loved him!'"
,"37":"But some of them said, 'If he could open the eyes of the blind man, could he not have kept this man from dying?'"
,"38":"Jesus was deeply moved again and drew near to the tomb. It was a cave with a stone laid across it."
,"39":"Jesus ordered, 'Take the stone away.' Martha said to him, 'Lord, by now he will smell, for this is the fourth day.'"
,"40":"Jesus replied, 'Have I not told you that if you believe, you will see the glory of God?'"
,"41":"So they removed the stone. Jesus lifted up his eyes and said, 'Father, I thank you for you have heard me. "
,"42":"I knew that you hear me always; but my prayer was for the sake of these people, that they may believe that you sent me.'"
,"43":"When Jesus had said this, he cried out in a loud voice, 'Lazarus, come out!'"
,"44":"The dead man came out, his hands and feet bound with linen strips and his face wrapped in a cloth. So Jesus said to them, 'Untie him and let him go.'"
,"45":"Many of the Jews who had come with Mary believed in Jesus when they saw what he did;"
,"46":"but some went to the Pharisees and told them what Jesus had done."
,"47":"So the chief priests and the Pharisees called the Sanhedrin Council. They said, 'What are we to do? For this man keeps on giving miraculous signs. "
,"48":"If we let him go on like this, all the people will believe in him and, as a result of this, the Romans will come and sweep away our Holy Place and our nation.'"
,"49":"Then one of them, Caiaphas, who was High Priest that year, spoke up, 'You know nothing at all nor do you see clearly what you need."
,"50":"It is better to have one man die for the people than to let the whole nation be destroyed.'"
,"51":"In saying this Caiaphas did not speak for himself, but being High Priest that year, he foretold as a prophet that Jesus would die for the nation,"
,"52":"and not for the nation only, but also to gather into one the scattered children of God."
,"53":"So, from that day on, they were determined to kill him."
,"54":"Because of this, Jesus no longer moved about freely among the Jews. He withdrew instead to the country near the wilderness and stayed with his disciples in a town called Ephraim."
,"55":"The Passover of the Jews was at hand and people from everywhere were coming to Jerusalem to purify themselves before the Passover."
,"56":"They looked for Jesus and as they stood in the Temple, they talked with one another, 'What do you think? Will he come to the festival?'"
,"57":"Meanwhile the chief priests and the elders had given orders that anyone who knew where he was should let them know so that they could arrest him."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Six days before the Passover, Jesus came to Bethany where he had raised Lazarus, the dead man, to life."
,"2":"Now they gave a dinner for him, and while Martha waited on them, Lazarus sat at the table with Jesus."
,"3":"Then Mary took a pound of costly perfume made from genuine nard and anointed the feet of Jesus, wiping them with her hair. And the whole house was filled with the fragrance of the perfume."
,"4":"Judas, son of Simon Iscariot - the disciple who was to betray Jesus - remarked,"
,"5":"'This perfume could have been sold for three hundred silver coins and turned over to the poor.'"
,"6":"Judas, indeed, had no concern for the poor; he was a thief and as he held the common purse, he used to help himself to the funds."
,"7":"But Jesus spoke up, 'Leave her alone. Was she not keeping it for the day of my burial?"
,"8":"(The poor you always have with you, but you will not always have me.)'"
,"9":"Many Jews heard that Jesus was there and they came, not only because of Jesus, but also to see Lazarus whom he had raised from the dead."
,"10":"So the chief priests thought about killing Lazarus as well,"
,"11":"for many of the Jews were drifting away because of him and believing in Jesus."
,"12":"The next day many people who had come for the festival heard that Jesus was to enter Jerusalem."
,"13":"So they took branches of palm trees and went out to meet him. And they cried out, 'Hosanna! Blessed is he who comes in the name of the Lord! Blessed is the King of Israel!'"
,"14":"Jesus found a donkey and sat upon it, as Scripture says:"
,"15":"Do not fear, city of Zion, see your king is coming sitting on the colt of a donkey."
,"16":"The disciples were not aware of this at first, but after Jesus was glorified, they remembered and realized that this had been written of him and that they themselves had taken part in it."
,"17":"The people who came with him bore witness and told how he had called Lazarus out of the tomb and raised him from the dead."
,"18":"It was because of this miraculous sign which Jesus had given that so many people welcomed him."
,"19":"In the meantime the Pharisees said to one another, 'We are getting nowhere; the whole world has gone after him.'"
,"20":"There were some Greeks who had come up to Jerusalem to worship during the feast."
,"21":"They approached Philip, who was from Bethsaida in Galilee, and asked him, 'Sir, we wish to see Jesus.'"
,"22":"Philip went to Andrew and the two of them told Jesus."
,"23":"Then Jesus said, 'The hour has come for the Son of Man to be glorified."
,"24":"Truly, I say to you, unless the grain of wheat falls to the earth and dies, it remains alone; but if it dies, it produces much fruit."
,"25":"Those who love their life destroy it, and those who despise their life in this world keep it for everlasting life."
,"26":"Whoever wants to serve me, let him follow me and wherever I am, there shall my servant be also. If anyone serves me, the Father will honor him."
,"27":"Now my soul is in distress. Shall I say: 'Father, save me from this hour'? But, I have come to this hour to face all this."
,"28":"Father, glorify your Name!' Then a voice came from heaven, 'I have glorified it and I will glorify it again.'"
,"29":"People standing there heard something and said it was thunder; but others said, 'An angel was speaking to him.'"
,"30":"Then Jesus declared, 'This voice did not come for my sake but for yours;"
,"31":"now sentence is being passed on this world; now the ruler of this world is to be cast down."
,"32":"And when I am lifted up from the earth, I shall draw all to myself.'"
,"33":"With these words Jesus referred to the kind of death he was to die."
,"34":"The crowd answered him, 'We have been told by the Law that the Messiah stands forever. How can you say that the Son of Man shall be lifted up? What kind of Son of Man is this?'"
,"35":"Jesus said to them, 'The light will be with you a little longer. Walk while you have the light, lest the darkness overtake you. If you walk in the darkness you do not know where you are going."
,"36":"While you have the light, believe in the light and become children of light.',After Jesus had said this, he withdrew and kept himself hidden."
,"37":"Even though Jesus had done so many miraculous signs among them, they didn't believe in him."
,"38":"Indeed the words spoken by the prophet Isaiah had to be fulfilled: Lord, who has believed what we proclaimed? To whom have the ways of God the Savior been made known?"
,"39":"They could not believe. Isaiah had said elsewhere:"
,"40":"He let their eyes become blind and their hearts hard, so that they could neither see nor understand, nor be converted - otherwise I would have healed them."
,"41":"Isaiah said this when he saw His Glory, and his words refer to Him."
,"42":"Many of them, however, believed in Jesus, even among the rulers, but they did not acknowledge him because of the Pharisees, lest they be put out of the Jewish community."
,"43":"They preferred to be approved by people rather than by God."
,"44":"Yet Jesus had said, and even cried out, 'Whoever believes in me, believes not in me but in him who sent me."
,"45":"And whoever sees me, sees him who sent me."
,"46":"I have come into the world as light, so that whoever believes in me may not remain in darkness."
,"47":"If anyone hears my words and does not keep them, I am not the one to condemn him; for I have come, not to condemn the world, but to save the world."
,"48":"The one who rejects me, and does not receive my word, already has a judge: the very word I have spoken will condemn him on the last day."
,"49":"For I have not spoken on my own authority; the Father who sent me has instructed me in what to say and how to speak."
,"50":"I know that his commandment is eternal life, and that is why the message I give, I give as the Father instructed me.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"It was before the feast of the Passover. Jesus realized that his hour had come to pass from this world to the Father, and as he had loved those who were his own in the world, he would love them with perfect love."
,"2":"They were at supper and the devil had already put into the mind of Judas, son of Simon Iscariot, to betray."
,"3":"Jesus knew that the Father had entrusted all things to him, and as he had come from God, he was going to God."
,"4":"So he got up from table, removed his garment and taking a towel, wrapped it around his waist."
,"5":"Then he poured water into a basin and began to wash the disciples' feet and to wipe them with the towel he was wearing."
,"6":"When he came to Simon Peter, Simon said to him, 'Why, Lord, you want to wash my feet!'"
,"7":"Jesus said, 'What I am doing you cannot understand now, but afterwards you will understand it.'"
,"8":"Peter replied, 'You shall never wash my feet.',Jesus answered him, 'If I do not wash you, you can have no part with me.' "
,"9":"Then Simon Peter said, 'Lord, wash not only my feet, but also my hands and my head!'"
,"10":"Jesus replied, 'Whoever has taken a bath does not need to wash (except the feet), for he is clean all over. You are clean, though not all of you.'"
,"11":"Jesus knew who was to betray him; because of this he said, 'Not all of you are clean.'"
,"12":"When Jesus had finished washing their feet, he put on his garment again, went back to the table and said to them, 'Do you understand what I have done to you?"
,"13":"You call me Master and Lord, and you are right, for so I am."
,"14":"If I, then, your Lord and Master, have washed your feet, you also must wash one another's feet."
,"15":"I have just given you an example that as I have done, you also may do."
,"16":"Truly, I say to you, the servant is not greater than his master, nor is the messenger greater than he who sent him."
,"17":"Understand this, and blessed are you if you put it into practice."
,"18":"I am not speaking of you all, because I know the ones I have chosen and the Scripture has to be fulfilled that says, The one who shared my table has risen against me."
,"19":"I tell you this now before it happens, so that when it does happen, you may know that I am He."
,"20":"Truly, I say to you, whoever welcomes the one I send, welcomes me, and whoever welcomes me, welcomes the One who sent me.'"
,"21":"After saying this, Jesus was distressed in spirit and said plainly, 'Truly, one of you will betray me.'"
,"22":"The disciples then looked at one another, wondering who he meant."
,"23":"One of the disciples, the one Jesus loved, was reclining near Jesus;"
,"24":"so Simon Peter signaled him to ask Jesus whom he meant."
,"25":"And the disciple who was reclining near Jesus asked him, 'Lord, who is it?'"
,"26":"Jesus answered, 'I shall dip a piece of bread in the dish, and he to whom I give it, is the one.',So Jesus dipped the bread and gave it to Judas Iscariot, the son of Simon. "
,"27":"And as Judas took the piece of bread, Satan entered into him. Jesus then said to him, 'What you are going to do, do quickly.'"
,"28":"None of the others reclining at table understood why Jesus said this to Judas."
,"29":"As he had the common purse, they may have thought that Jesus was telling him, 'Buy what we need for the feast,' or, 'Give something to the poor.'"
,"30":"Judas left as soon as he had eaten the bread. It was night."
,"31":"When Judas had gone out, Jesus said, 'Now is the Son of Man glorified and God is glorified in him."
,"32":"God will glorify him, and he will glorify him very soon."
,"33":"My children, I am with you for only a little while; you will look for me, but, as I already told the Jews, so now I tell you: where I am going you cannot come."
,"34":"Now I give you a new commandment: love one another. Just as I have loved you, you also must love one another."
,"35":"By this everyone will know that you are my disciples, if you have love for one another.'"
,"36":"Simon Peter said to him, 'Lord, where are you going?' Jesus answered, 'Where I am going you cannot follow me now, but afterwards you will.'"
,"37":"Peter said, 'Lord, why can't I follow you now? I am ready to give my life for you.'"
,"38":"Jesus answered, 'To give your life for me! Truly, I tell you, the cock will not crow before you have denied me three times.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"'Do not be troubled; trust in God and trust in me."
,"2":"In my Father's house there are many rooms. Otherwise I would not have told you that I go to prepare a place for you"
,"3":"After I have gone and prepared a place for you, I shall come again and take you to me, so that where I am, you also may be."
,"4":"Yet you know the way where I am going.'"
,"5":"Thomas said to him, 'Lord, we don't know where you are going; how can we know the way?'"
,"6":"Jesus said, 'I am the way, the truth and the life; no one comes to the Father but through me."
,"7":"If you know me, you will know the Father also; indeed you know him and you have seen him.'"
,"8":"Philip asked him,'Lord, show us the Father and that is enough.'"
,"9":"Jesus said to him, 'What! I have been with you so long and you still do not know me, Philip? Whoever sees me sees the Father; how can you say: 'Show us the Father'?"
,"10":"Do you not believe that I am in the Father and the Father is in me?,All that I say to you, I do not say of myself. The Father who dwells in me is doing his own work. "
,"11":"Believe me when I say that I am in the Father and the Father is in me; at least believe it on the evidence of these works that I do."
,"12":"Truly, I say to you, the one who believes in me will do the same works that I do; and he will even do greater than these, for I am going to the Father."
,"13":"Everything you ask in my name, I will do, so that the Father may be glorified in the Son."
,"14":"And everything you ask in calling upon my Name, I will do."
,"15":"If you love me, you will keep my commandments;"
,"16":"and I will ask the Father and he will give you another Helper to be with you forever,"
,"17":"that Spirit of truth whom the world cannot receive because it neither sees him nor knows him. But you know him for he is with you and will be in you."
,"18":"I will not leave you orphans, I am coming to you."
,"19":"A little while and the world will see me no more, but you will see me because I live and you will also live."
,"20":"On that day you will know that I am in my Father and you in me, and I in you."
,"21":"Whoever keeps my commandments is the one who loves me. If he loves me, he will also be loved by my Father; I too shall love him and show myself clearly to him.'"
,"22":"Judas - not the Iscariot - asked Jesus, 'Lord, how can it be that you will show yourself clearly to us and not to the world?'"
,"23":"Jesus answered him, 'If anyone loves me, he will keep my word and my Father will love him; and we will come to him and make a room in his home."
,"24":"But if anyone does not love me, he will not keep my words, and these words that you hear are not mine but the Father's who sent me."
,"25":"I told you all this while I was still with you."
,"26":"From now on the Helper, the Holy Spirit whom the Father will send in my name, will teach you all things and remind you of all that I have told you."
,"27":"Peace be with you; I give you my peace. Not as the world gives peace do I give it to you. Do not be troubled; do not be afraid."
,"28":"You heard me say: 'I am going away, but I am coming to you.' If you loved me, you would be glad that I go to the Father, for the Father is greater than I."
,"29":"I have told you this now before it takes place, so that when it does happen you may believe."
,"30":"It is very little what I may still tell you, for the ruler of this world is at hand, although there is nothing in me that he can claim."
,"31":"But see, the world must know that I love the Father and that I do what the Father has taught me to do. Come now, let us go."
}`)
	CurrentBook.AddChapter(15, `{
"1":"I am the true vine and my Father is the vinegrower."
,"2":"If any of my branches doesn't bear fruit, he breaks it off; and he prunes every branch that does bear fruit, that it may bear even more fruit."
,"3":"You are already made clean by the word I have spoken to you;"
,"4":"live in me as I live in you. The branch cannot bear fruit by itself but has to remain part of the vine; so neither can you if you don't remain in me."
,"5":"I am the vine and you are the branches. As long as you remain in me and I in you, you bear much fruit; but apart from me you can do nothing."
,"6":"Whoever does not remain in me is thrown away as they do with branches and they wither. Then they are gathered and thrown into the fire and burned."
,"7":"If you remain in me and my words in you, you may ask whatever you want and it will be given to you."
,"8":"My Father is glorified when you bear much fruit: it is then that you become my disciples."
,"9":"As the Father has loved me, so I have loved you; remain in my love."
,"10":"You will remain in my love if you keep my commandments, just as I have kept my Father's commandments and remain in his love."
,"11":"I have told you all this, that my own joy may be in you and your joy may be complete."
,"12":"This is my commandment: love one another as I have loved you."
,"13":"There is no greater love than this, to give one's life for one's friends;"
,"14":"and you are my friends if you do what I command you."
,"15":"I shall not call you servants any more, because servants do not know what their master is about. Instead I have called you friends, since I have made known to you everything I learned from my Father."
,"16":"You did not choose me; it was I who chose you and sent you to go and bear fruit, fruit that will last. And everything you ask the Father in my name, he will give you."
,"17":"This is my command, that you love one another."
,"18":"If the world hates you, remember that the world hated me before you."
,"19":"This would not be so if you belonged to the world, because the world loves its own. But you are not of the world since I have chosen you from the world; because of this the world hates you."
,"20":"Remember what I told you: the servant is not greater than his master; if they persecuted me, they will persecute you, too. Have they kept my teaching? Will they then keep yours?"
,"21":"All this they will do to you for the sake of my name because they do not know the One who sent me."
,"22":"If I had not come to tell them, they would have no sin, but now they have no excuse for their sin."
,"23":"Those who hate me hate my Father."
,"24":"If I had not done among them what no one else has ever done, they would have no sin. But after they have seen all this, they hate me and my Father,"
,"25":"and the words written in their law become true: They hated me without cause."
,"26":"From the Father, I will send you the Spirit of truth. When this Helper has come from the Father, he will be my witness,"
,"27":"and you, too, will be my witnesses for you have been with me from the beginning."
}`)
	CurrentBook.AddChapter(16, `{
"1":"I tell you all this to keep you from stumbling and falling away."
,"2":"They will put you out of the Jewish communities. Still more, the hour is coming when anyone who kills you will claim to be serving God;"
,"3":"they will do this because they have not known the Father or me."
,"4":"I tell you all these things now so that when the time comes you may remember that I told you. I did not tell you about this in the beginning because I was with you. "
,"5":"But now I am going to the One who sent me and none of you asks me where I am going;"
,"6":"instead you are overcome with grief because of what I have said."
,"7":"Indeed believe me: It is better for you that I go away, because as long as I do not leave, the Helper will not come to you. But if I go away, it is to send him to you,"
,"8":"and when he comes, he will vindicate the truth in face of the world with regard to sin, to the way of righteousness, and to the Judgment."
,"9":"What has been the sin? They did not believe in me."
,"10":"What is the way of righteousness? I am on the way to the Father, meanwhile you will not see me."
,"11":"What Judgment? The Ruler of this world has himself been condemned."
,"12":"I still have many things to tell you, but you cannot bear them now."
,"13":"When he, the Spirit of truth comes, he will guide you into the whole truth. He has nothing to say of himself but he will speak of what he hears, and he will tell you of the things to come. "
,"14":"He will take what is mine and make it known to you; in doing this, he will glorify me."
,"15":"All that the Father has is mine; because of this I have just told you, that the Spirit will take what is mine and make it known to you.'"
,"16":"A little while and you will see me no more; and then a little while, and you will see me.'"
,"17":"Some of the disciples wondered, 'What does he mean by: 'A little while and you will not see me, and then a little while and you will see me'? And why did he say: 'I go to the Father'?'"
,"18":"And they said to one another, 'What does he mean by 'a little while'? We don't understand.'"
,"19":"Jesus knew that they wanted to question him; so he said to them, 'You are puzzled because I told you that in a little while you will see me no more, and then a little while later you will see me."
,"20":"Truly, I say to you, you will weep and mourn while the world rejoices. You will be sorrowful, but your sorrow will turn to joy."
,"21":"A woman in childbirth is in distress because her time is at hand. But after the child is born, she no longer remembers her suffering because of such great joy: a human being is born into the world."
,"22":"You feel sorrowful now, but I will see you again, and your hearts will rejoice. And no one will take your joy from you."
,"23":"When that day comes you will not ask me anything. Truly, I say to you, whatever you ask the Father in my Name, he will give you."
,"24":"So far you have not asked in my Name; ask and receive that your joy may be full."
,"25":"I taught you all this in veiled language, but the time is coming when I shall no longer speak in veiled language, but will tell you plainly of the Father."
,"26":"When that day comes, you will ask in my Name and it will not be for me to ask the Father for you,"
,"27":"for the Father himself loves you because you have loved me and you believe that I came from the Father."
,"28":"As I came from the Father and have come into the world, so I am leaving the world and going to the Father.'"
,"29":"The disciples said to him, 'Now you are speaking plainly and not in veiled language!"
,"30":"Now we see that you know all things, even before we question you. Because of this we believe that you came from God.'"
,"31":"Jesus answered them, 'You say that you believe!"
,"32":"The hour is coming, indeed it has come, when you will be scattered, each one to his home, and you will leave me alone. Yet I am not alone, for the Father is with me."
,"33":"I have told you all this, so that in me you may have peace. You will have trouble in the world; but, courage! I have overcome the world.'"
}`)
	CurrentBook.AddChapter(17, `{
"1":"After saying this, Jesus lifted up his eyes to heaven and said, 'Father, the hour has come; give glory to your Son, that the Son may give glory to you."
,"2":"You have given him power over all mortals, and you want him to bring eternal life to all you have entrusted to him."
,"3":"For this is eternal life: to know you, the only true God, and the One you sent, Jesus Christ."
,"4":"I have glorified you on earth and finished the work that you gave me to do."
,"5":"Now, Father, give me in your presence the same Glory I had with you before the world began."
,"6":"I have made your name known to those you gave me from the world. They were yours and you gave them to me, and they kept your word."
,"7":"And now they know that all you have given me comes indeed from you."
,"8":"I have given them the teaching I received from you, and they received it and know in truth that I came from you; and they believe that you have sent me."
,"9":"I pray for them; I do not pray for the world but for those who belong to you and whom you have given to me -"
,"10":"indeed all I have is yours and all you have is mine - and now they are my glory."
,"11":"I am no longer in the world, but they are in the world whereas I am going to you. Holy Father, keep them in your Name (that you have given me,) so that they may be one, just as we are."
,"12":"When I was with them, I kept them safe in your Name, and not one was lost except the one who was already lost, and in this the Scripture was fulfilled."
,"13":"But now I am coming to you and I leave these my words in the world that my joy may be complete in them."
,"14":"I have given them your word and the world has hated them because they are not of the world; just as I am not of the world."
,"15":"I do not ask you to remove them from the world but to keep them from the evil one."
,"16":"They are not of the world, just as I am not of the world;"
,"17":"consecrate them in the truth - your word is truth."
,"18":"I have sent them into the world as you sent me into the world,"
,"19":"and for their sake, I go to the sacrifice by which I am consecrated, so that they too may be consecrated in truth."
,"20":"I pray not only for these but also for those who through their word will believe in me."
,"21":"May they all be one as you Father are in me and I am in you. May they be one in us; so the world may believe that you have sent me."
,"22":"I have given them the Glory you have given me, that they may be one as we are one:"
,"23":"I in them and you in me. Thus they shall reach perfection in unity and the world shall know that you have sent me and that I have loved them just as you loved me."
,"24":"Father, since you have given them to me, I want them to be with me where I am and see the Glory you gave me, for you loved me before the foundation of the world."
,"25":"Righteous Father, the world has not known you but I have known you, and these have known that you have sent me."
,"26":"As I revealed your Name to them, so will I continue to reveal it, so that the love with which you loved me may be in them and I also may be in them.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"When Jesus had finished speaking, he went with his disciples to the other side of the Kidron Valley. There was a garden there where Jesus entered with his disciples."
,"2":"Now Judas, who betrayed him, knew the place since Jesus had often met there with his disciples."
,"3":"He led soldiers of the Roman battalion and guards from the chief priests and Pharisees, who went there with lanterns, torches and weapons."
,"4":"Jesus knew all that was going to happen to him; he stepped forward and asked, 'Who are you looking for?'"
,"5":"They answered, 'Jesus the Nazarene.' Jesus said, 'I am he.' Judas, who betrayed him, stood there with them."
,"6":"When Jesus said, 'I am he,' they moved back and fell to the ground."
,"7":"He then asked a second time, 'Who are you looking for?' and they answered, 'Jesus the Nazarene.'"
,"8":"Jesus replied, 'I told you that I am he. If you are looking for me, let these others go.'"
,"9":"So what Jesus had said came true: 'I have not lost one of those you gave me.'"
,"10":"Simon Peter had a sword; he drew it and struck Malchus, the High Priest's servant, cutting off his right ear."
,"11":"But Jesus said to Peter, 'Put your sword into its sheath; shall I not drink the cup which the Father has given me?'"
,"12":"The guards and the soldiers, with their commander, seized Jesus and bound him;"
,"13":"and they took him first to Annas. Annas was the father-in-law of Caiaphas, who was the High Priest that year;"
,"14":"and it was Caiaphas who had told the Jews: 'It is better that one man should die for the people.'"
,"15":"Simon Peter with another disciple followed Jesus. Because this disciple was known to the High Priest, they let him enter the courtyard of the High Priest along with Jesus,"
,"16":"but Peter had to stay outside at the door. The other disciple, who was known to the High Priest went out and spoke to the maidservant at the gate and brought Peter in."
,"17":"Then, this servant on duty at the door said to Peter, 'So you also are one of his disciples?' But he answered, 'I am not.'"
,"18":"Now the servants and the guards had made a charcoal fire and were standing and warming themselves, because it was cold. Peter was also with them warming himself."
,"19":"The High Priest questioned Jesus about his disciples and his teaching."
,"20":"Jesus answered him, 'I have spoken openly to the world; I have always taught in places where the Jews meet together, either at the assemblies in synagogues or in the Temple. I did not teach secretly."
,"21":"Why then do you ask me? Ask those who heard me, they know what I said.'"
,"22":"At this reply one of the guards standing by gave Jesus a blow on the face, saying, 'Is that the way to answer the High Priest?'"
,"23":"Jesus said to him, 'If I have spoken wrongly, point it out; but if I have spoken rightly, why do you strike me?'"
,"24":"Then Annas sent him, bound, to Caiaphas, the High Priest."
,"25":"Now Simon Peter stood there warming himself. They said to him, 'Surely you also are one of his disciples.' He denied it and answered, 'I am not.'"
,"26":"One of the High Priest's servants, a kinsman of the one whose ear Peter had cut off, asked, 'Did I not see you with him in the garden?'"
,"27":"Again Peter denied it, and at once the cock crowed."
,"28":"Then they led Jesus from the house of Caiaphas to the court of the Roman governor. It was now morning. The Jews didn't enter lest they be made unclean (by coming into the house of a pagan) and be unable to eat the Passover meal."
,"29":"So Pilate went out and asked, 'What charge do you bring against this man?',They answered, "
,"30":"'If he were not a criminal, we would not be handing him over to you.'"
,"31":"Pilate said, 'Take him yourselves and judge him according to your own law.' But they replied, 'We ourselves are not allowed to put anyone to death.'"
,"32":"It was clear from this what kind of death Jesus was to die, according to what Jesus himself had foretold."
,"33":"Pilate then entered the court again, called Jesus and asked him, 'Are you the King of the Jews?'"
,"34":"Jesus replied, 'Does this word come from you, or did you hear it from others?'"
,"35":"Pilate answered, 'Am I a Jew? Your own nation and the chief priests have handed you over to me. What have you done?'"
,"36":"Jesus answered, 'My kingship does not come from this world. If I were king like those of this world, my guards would have fought to save me from being handed over to the Jews. But my kingship is not from here.'"
,"37":"Pilate asked him, 'So you are a king?' And Jesus answered, 'Just as you say, I am a king. For this I was born and for this I have come into the world, to bear witness to the truth. Everyone who is on the side of truth hears my voice.'"
,"38":"Pilate said, 'What is truth?',Pilate then went out to the Jews again and said, 'I find no crime in this man. "
,"39":"Now, according to a custom, I must release a prisoner of yours at the Passover. With your agreement I will release for you the King of the Jews.'"
,"40":"But they insisted and cried out, 'Not this man, but Barabbas!' Now Barabbas was a robber."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Then Pilate had Jesus taken away and scourged."
,"2":"The soldiers also twisted thorns into a crown and put it on his head. They threw a cloak of royal purple around his shoulders"
,"3":"and began coming up to him and saluting him, 'Hail, king of the Jews,' and they struck him on the face."
,"4":"Pilate went outside yet another time and said to the Jews, 'Look, I am bringing him out and I want you to know that I find no crime in him.'"
,"5":"Jesus then came out wearing the crown of thorns and the purple cloak and Pilate pointed to him saying, 'Here is the man!'"
,"6":"On seeing him the chief priests and the guards cried out, 'Crucify him! Crucify him!' Pilate replied, 'Take him yourselves and have him crucified, for I find no case against him.'"
,"7":"The Jews then said, 'We have a Law, and according to the Law this man must die because he made himself Son of God.'"
,"8":"When Pilate heard this he was more afraid."
,"9":"And coming back into the court he asked Jesus, 'Where are you from?' But Jesus gave him no answer."
,"10":"Then Pilate said to him, 'You will not speak to me? Do you not know that I have power to release you just as I have power to crucify you?'"
,"11":"Jesus replied, 'You would have no power over me unless it had been given you from above; therefore the one who handed me over to you is more guilty.'"
,"12":"From that moment Pilate tried to release him, but the Jews cried out, 'If you release this man, you are no friend of Caesar. Anyone who makes himself king is defying Caesar.'"
,"13":"When Pilate heard this, he had Jesus brought outside to the place called the Stone Floor - in Hebrew Gabbatha - and there he had him seated in the tribune."
,"14":"It was the Preparation Day for the Passover, about noon. So Pilate said to the Jews, 'Here is your king.'"
,"15":"But they cried out, 'Away! Take him away! Crucify him!' Pilate replied, 'Shall I crucify your king?' And the chief priests answered, 'We have no king but Caesar.'"
,"16":"Then Pilate handed Jesus over to them to be crucified. They took charge of him. "
,"17":"Bearing his own cross, Jesus went out of the city to what is called the Place of the Skull, in Hebrew: Golgotha."
,"18":"There he was crucified and with him two others, one on either side, and Jesus was in the middle."
,"19":"Pilate had a notice written and fastened to the cross that read: Jesus the Nazorean, King of the Jews."
,"20":"Many Jewish people saw this title, because the place where Jesus was crucified was very close to the city. It was, moreover, written in Hebrew, Latin and Greek."
,"21":"The chief priests said to Pilate, 'Do not write: 'The king of the Jews'; but: 'This man claimed to be king of the Jews.' '"
,"22":"Pilate answered them, 'What I have written, I have written.'"
,"23":"When the soldiers crucified Jesus, they took his clothes and divided them into four parts, one part for each of them. But as the tunic was woven in one piece from top to bottom,"
,"24":"they said, 'Let us not tear it, but cast lots to decide who will get it.' This fulfilled the words of Scripture: They divided my clothing among them; they cast lots for my garment. This was what the soldiers did."
,"25":"Near the cross of Jesus stood his mother, his mother's sister Mary, who was the wife of Cleophas, and Mary of Magdala."
,"26":"When Jesus saw the Mother, and the disciple, he said to the Mother, 'Woman, this is your son.'"
,"27":"Then he said to the disciple, 'There is your mother.' And from that moment the disciple took her to his own home."
,"28":"With that Jesus knew all was now finished and he said, I am thirsty, to fulfil what was written in Scripture."
,"29":"A jar full of bitter wine stood there; so, putting a sponge soaked in the wine on a twig of hyssop, they raised it to his lips."
,"30":"Jesus took the wine and said, 'It is accomplished.' Then he bowed his head and gave up the spirit."
,"31":"As it was Preparation Day, the Jews did not want the bodies to remain on the cross during the sabbath, for this sabbath was a very solemn day. They asked Pilate to have the legs of the condemned men broken, so they might take away the bodies."
,"32":"The soldiers came and broke the legs of the first man and of the other who had been crucified with Jesus."
,"33":"When they came to Jesus, they saw that he was already dead; so they did not break his legs."
,"34":"One of the soldiers, however, pierced his side with a lance and immediately there came out blood and water."
,"35":"The one who has seen here gives his witness so that you may believe: his witness is true and He knows that he speaks the truth."
,"36":"All this happened to fulfill the words of Scripture, Not one of his bones shall be broken."
,"37":"Another text says: They shall look on him whom they have pierced."
,"38":"After this, Joseph of Arimathea approached Pilate, for he was a disciple of Jesus, though secretly, for fear of the Jews. And he asked Pilate to let him remove the body of Jesus. Pilate agreed, so he came and took away the body."
,"39":"Nicodemus, the man who earlier had come to Jesus by night, also came and brought a jar of myrrh mixed with aloes, about a hundred pounds."
,"40":"They took the body of Jesus and wrapped it in linen cloths with the spices, following the burial custom of the Jews."
,"41":"There was a garden in the place where Jesus had been crucified, and, in the garden, a new tomb in which no one had ever been laid."
,"42":"As the tomb was very near, they buried Jesus there because they had no time left before the Jewish Preparation Day."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Now, on the first day after the sabbath, Mary of Magdala came to the tomb early in the morning, while it was still dark and she saw that the stone blocking the tomb had been moved away."
,"2":"She ran to Peter and the other disciple whom Jesus loved. And she said to them, 'They have taken the Lord out of the tomb and we don't know where they have laid him.'"
,"3":"Peter then set out with the other disciple to go to the tomb."
,"4":"They ran together but the other disciple outran Peter and reached the tomb first."
,"5":"He bent down and saw the linen cloths lying flat, but he did not enter."
,"6":"Then Simon Peter came following him and entered the tomb; he, too, saw the linen cloths lying flat."
,"7":"The napkin, which had been around his head was not lying flat like the other linen cloths but lay rolled up in its place."
,"8":"Then the other disciple who had reached the tomb first also went in; he saw and believed."
,"9":"Scripture clearly said that he must rise from the dead, but they had not yet understood that."
,"10":"The disciples then went home again."
,"11":"Mary stood weeping outside the tomb, and as she wept she bent down to look inside;"
,"12":"she saw two angels in white sitting where the body of Jesus had been, one at the head, and the other at the feet."
,"13":"They said, 'Woman, why are you weeping?' She answered, 'Because they have taken my Lord and I don't know where they have put him.'"
,"14":"As she said this, she turned around and saw Jesus standing there, but she did not recognize him."
,"15":"Jesus said to her, 'Woman, why are you weeping? Who are you looking for?' She thought it was the gardener and answered him, 'Lord, if you have taken him away, tell me where you have put him, and I will go and remove him.'"
,"16":"Jesus said to her, 'Mary.' She turned and said to him, 'Rabboni' - which means, Master."
,"17":"Jesus said to her, 'Do not cling to me; you see I have not yet ascended to the Father. But go to my brothers and say to them: I am ascending to my Father, who is your Father, to my God, who is your God.'"
,"18":"So Mary of Magdala went and announced to the disciples, 'I have seen the Lord, and this is what he said to me.'"
,"19":"On the evening of that day, the first day after the sabbath, the doors were locked where the disciples were, because of their fear of the Jews, but Jesus came and stood in their midst. He said to them, 'Peace be with you';"
,"20":"then he showed them his hands and his side. The disciples kept looking at the Lord and were full of joy."
,"21":"Again Jesus said to them, 'Peace be with you. As the Father has sent me, so I send you.'"
,"22":"After saying this he breathed on them and said to them, 'Receive the Holy Spirit;"
,"23":"for those whose sins you forgive, they are forgiven; for those whose sins you retain, they are retained.'"
,"24":"Thomas, the Twin, one of the Twelve, was not with them when Jesus came."
,"25":"The other disciples told him, 'We have seen the Lord.' But he replied, 'Until I have seen in his hands the print of the nails, and put my finger in the mark of the nails and my hand in his side, I will not believe.'"
,"26":"Eight days later, the disciples were inside again and Thomas was with them. Despite the locked doors Jesus came and stood in their midst and said, 'Peace be with you.'"
,"27":"Then he said to Thomas, 'Put your finger here and see my hands; stretch out your hand and put it into my side. Resist no longer and be a believer.'"
,"28":"Thomas then said, 'You are my Lord and my God.'"
,"29":"Jesus replied, 'You believe because you see me, don't you? Happy are those who have not seen and believe.'"
,"30":"There were many other signs that Jesus gave in the presence of his disciples, but they are not recorded in this book."
,"31":"These are recorded so that you may believe that Jesus is the Christ, the Son of God; believe and you will have life through his Name."
}`)
	CurrentBook.AddChapter(21, `{
"1":"After this Jesus revealed himself to the disciples by the Lake of Tiberias. He appeared to them in this way."
,"2":"Simon Peter, Thomas who was called the Twin, Nathanael of Cana in Galilee, the sons of Zebedee and two other disciples were together;"
,"3":"and Simon Peter said to them, 'I'm going fishing.' They replied, 'We will come with you' and they went out and got into the boat. But they caught nothing that night."
,"4":"When day had already broken, Jesus was standing on the shore, but the disciples did not know that it was Jesus."
,"5":"Jesus called them, 'Children, have you anything to eat?' They answered, 'Nothing.'"
,"6":"Then he said to them, 'Throw the net on the right side of the boat and you will find some.' When they had lowered the net, they were not able to pull it in because of the great number of fish."
,"7":"Then the disciple Jesus loved said to Peter, 'It's the Lord!' At these words, 'It's the Lord,' Simon Peter put on his clothes, for he was stripped for work, and jumped into the water."
,"8":"The other disciples came in the boat dragging the net full of fish; they were not far from land, about a hundred meters."
,"9":"When they landed, they saw a charcoal fire with fish on it, and some bread."
,"10":"Jesus said to them, 'Bring some of the fish you've just caught.'"
,"11":"So Simon Peter climbed into the boat and pulled the net to shore. It was full of big fish - one hundred and fifty-three - but, in spite of this, the net was not torn."
,"12":"Jesus said to them, 'Come and have breakfast,' and not one of the disciples dared ask him, 'Who are you?' for they knew it was the Lord."
,"13":"Jesus then came and took the bread and gave it to them, and he did the same with the fish."
,"14":"This was the third time that Jesus revealed himself to his disciples after rising from the dead."
,"15":"After they had finished breakfast, Jesus said to Simon Peter, 'Simon, son of John, do you love me more than these?' He answered, 'Yes, Lord, you know that I love you.' And Jesus said, 'Feed my lambs.'"
,"16":"A second time Jesus said to him, 'Simon, son of John, do you love me?' And Peter answered, 'Yes, Lord, you know that I love you.' Jesus said to him, 'Look after my sheep.'"
,"17":"And a third time he said to him, 'Simon, son of John, do you love me?',Peter was saddened because Jesus asked him a third time, 'Do you love me?' and he said, 'Lord, you know everything; you know that I love you.',Jesus then said, 'Feed my sheep. "
,"18":"Truly, I say to you, when you were young you put on your belt and walked where you liked. But when you grow old, you will stretch out your hands and another will put a belt around you and lead you where you do not wish to go.'"
,"19":"Jesus said this to make known the kind of death by which Peter was to glorify God. And he added, 'Follow me.'"
,"20":"Peter looked back and saw that the disciple Jesus loved was following as well, the one who had reclined close to Jesus at the supper and had asked him, 'Lord, who is to betray you?'"
,"21":"On seeing him Peter asked Jesus, 'Lord, what about him?'"
,"22":"Jesus answered, 'If I want him to remain until I come, does that concern you? Follow me.'"
,"23":"Because of this the rumor spread in the community that this disciple would not die. Yet Jesus had not said to Peter, 'He will not die,' but 'suppose I want him to remain until I come.'"
,"24":"It is this disciple who testifies about the things he has recorded here and we know that his testimony is true."
,"25":"But Jesus did many other things; if all were written down, the world itself would not hold the books recording them."
}`)

}
func EN_CCB_LoadNELCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Several people have set themselves to relate the events that have taken place among us,"
,"2":"as they were told by the first witnesses who later became ministers of the Word."
,"3":"After I myself had carefully gone over the whole story from the beginning, it seemed right for me to give you, Theophilus, an orderly account,"
,"4":"so that your Excellency may know the truth of all you have been taught."
,"5":"In the days of Herod, king of Judea, there lived a priest named Zechariah, belonging to the priestly clan of Abiah. Elizabeth, Zechariah's wife, also belonged to a priestly family."
,"6":"Both of them were upright in the eyes of God and lived blamelessly in accordance with all the laws and commands of the Lord,"
,"7":"but they had no child. Elizabeth could not have any and now they were both very old."
,"8":"Now, while Zechariah and those with him were fulfilling their office,"
,"9":"it fell to him by lot, according to the custom of the priests, to enter the sanctuary of the Lord and burn incense."
,"10":"At the time of offering incense all the people were praying outside;"
,"11":"it was then that an angel of the Lord appeared to him, standing on the right side of the altar of incense."
,"12":"On seeing the angel, Zechariah was deeply troubled and fear took hold of him."
,"13":"But the angel said to him, 'Don't be afraid, Zechariah, be assured that your prayer has been heard. Your wife Elizabeth will bear you a son and you shall name him John."
,"14":"He will bring joy and gladness to you and many will rejoice at his birth."
,"15":"This son of yours will be great in the eyes of the Lord. Listen: he shall never drink wine or strong drink, but he will be filled with holy spirit even from his mother's womb."
,"16":"Through him many of the people of Israel will turn to the Lord their God."
,"17":"He himself will open the way to the Lord with the spirit and power of the prophet Elijah; he will reconcile fathers and children, and lead the disobedient to wisdom and righteousness, in order to make ready for the Lord a people prepared.'"
,"18":"Zechariah said to the angel, 'How can I believe this? I am an old man and my wife is elderly, too.'"
,"19":"The angel replied, 'I am Gabriel, who stand before God, and I am the one sent to speak to you and bring you this good news! My words will come true in their time."
,"20":"But you would not believe and now you will be silent and unable to speak until this has happened.'"
,"21":"Meanwhile the people waited for Zechariah, and they were surprised that he delayed so long in the sanctuary."
,"22":"When he finally appeared, he could not speak to them and they realized that he had seen a vision in the sanctuary. He remained dumb and made signs to them."
,"23":"When his time of service was completed, Zechariah returned home"
,"24":"and some time later Elizabeth became pregnant. For five months she kept to herself, remaining at home, and thinking,"
,"25":"'What is the Lord doing for me! This is his time for mercy and for taking away my public disgrace.'"
,"26":"In the sixth month, the angel Gabriel was sent from God to a town of Galilee called Nazareth. He was sent"
,"27":"to a young virgin who was betrothed to a man named Joseph, of the family of David; and the virgin's name was Mary."
,"28":"The angel came to her and said, 'Rejoice, full of grace, the Lord is with you.'"
,"29":"Mary was troubled at these words, wondering what this greeting could mean."
,"30":"But the angel said, 'Do not fear, Mary, for God has looked kindly on you."
,"31":"You shall conceive and bear a son and you shall call him Jesus."
,"32":"He will be great and shall rightly be called Son of the Most High. The Lord God will give him the kingdom of David, his ancestor; he will rule over the people of Jacob for-ever"
,"33":"and his reign shall have no end.'"
,"34":"Then Mary said to the angel, 'How can this be if I am a virgin?'"
,"35":"And the angel said to her, 'The Holy Spirit will come upon you and the power of the Most High will overshadow you; therefore, the holy child to be born shall be called Son of God."
,"36":"Even your relative Elizabeth is expecting a son in her old age, although she was unable to have a child, and she is now in her sixth month."
,"37":"With God nothing is impossible.'"
,"38":"Then Mary said, 'I am the handmaid of the Lord, let it be done to me as you have said.' And the angel left her."
,"39":"Mary then set out for a town in the Hills of Judah."
,"40":"She entered the house of Zechariah and greeted Elizabeth."
,"41":"When Elizabeth heard Mary's greeting, the baby leapt in her womb. Elizabeth was filled with holy spirit, and"
,"42":"giving a loud cry, said, 'You are most blessed among women and blessed is the fruit of your womb!"
,"43":"How is it that the mother of my Lord comes to me?"
,"44":"The moment your greeting sounded in my ears, the baby within me suddenly leapt for joy."
,"45":"Blessed are you who believed that the Lord's word would come true!'"
,"46":"And Mary said: 'My soul proclaims the greatness of the Lord,"
,"47":"my spirit exults in God my savior!"
,"48":"He has looked upon his servant in her lowliness, and people forever will call me blessed."
,"49":"The Mighty One has done great things for me, Holy is his Name!"
,"50":"From age to age his mercy extends,to those who live in his presence."
,"51":"He has acted with power and done wonders, and scattered the proud with their plans."
,"52":"He has put down the mighty from their thrones,and lifted up those who are downtrodden."
,"53":"He has filled the hungry with good things,but has sent the rich away empty."
,"54":"He held out his hand to Israel, his servant, for he remembered his mercy,"
,"55":"even as he promised our fathers, Abraham and his descendants forever.'"
,"56":"Mary remained with Elizabeth about three months and then returned home."
,"57":"When the time came for Elizabeth, she gave birth to a son."
,"58":"Her neighbors and relatives heard that the merciful Lord had done a wonderful thing for her and they rejoiced with her."
,"59":"When on the eighth day they came to attend the circumcision of the child, they wanted to name him Zechariah after his father."
,"60":"But his mother said, 'Not so; he shall be called John.'"
,"61":"They said to her, 'No one in your family has that name';"
,"62":"and they asked the father by means of signs for the name he wanted to give."
,"63":"Zechariah asked for a writing tablet and wrote on it, 'His name is John,' and they were very surprised."
,"64":"Immediately Zechariah could speak again and his first words were in praise of God."
,"65":"A holy fear came on all in the neighborhood, and throughout the Hills of Judea the people talked about these events."
,"66":"All who heard of it pondered in their minds and wondered, 'What will this child be?' For they understood that the hand of the Lord was with him."
,"67":"Zechariah, filled with holy spirit, sang this canticle,"
,"68":"'Blessed be the Lord God of Israel, for he has come and redeemed his people."
,"69":"He has raised up for us a victorious Savior,in the house of David his servant,"
,"70":"as he promised through his prophets of old,"
,"71":"salvation from our enemies,and from the hand of our foes."
,"72":"He has shown mercy to our fathers,and remembered his holy covenant,"
,"73":"the oath he swore to Abraham, our father,"
,"74":"to deliver us from the enemy,"
,"75":"that we might serve him fearlessly,as a holy and righteous people,all the days of our lives."
,"76":"And you, my child, shall be called prophet of the Most High, for you shall go before the Lord,to prepare the way for him"
,"77":"and enable his people to know of their salvation,when he comes to forgive their sins."
,"78":"This is the work of the mercy of our God, who comes from on high as a rising sun"
,"79":"shining on those who live in darkness,and in the shadow of death, and guiding our feet into the way of peace.'"
,"80":"As the child grew up, he was seen to be strong in the Spirit; he lived in the desert till the day when he appeared openly in Israel."
}`)
	CurrentBook.AddChapter(2, `{
"1":"At that time the emperor issued a decree for a census of the whole empire to be taken."
,"2":"This first census was taken while Quirinus was governor of Syria."
,"3":"Everyone had to be registered in his own town. So everyone set out for his own city; "
,"4":"Joseph too set out from Nazareth of Galilee. As he belonged to the family of David, being a descendant of his, he went to Judea to David's town of Bethlehem"
,"5":"to be registered with Mary, his wife, who was with child."
,"6":"They were in Bethlehem when the time came for her to have her child,"
,"7":"and she gave birth to a son, her firstborn. She wrapped him in swaddling clothes and laid him in the manger, because there was no place for them in the living room."
,"8":"There were shepherds camping in the countryside, taking turns to watch over their flocks by night."
,"9":"Suddenly an angel of the Lord appeared to them, with the Glory of the Lord shining around them. As they were terrified,"
,"10":"the angel said to them, 'Don't be afraid; I am here to give you good news, great joy for all the people."
,"11":"Today a Savior has been born to you in David's town; he is the Messiah and the Lord."
,"12":"Let this be a sign to you: you will find a baby wrapped in swaddling clothes and lying in a manger.'"
,"13":"Suddenly the angel was surrounded by many more heavenly spirits, praising God and saying,"
,"14":"'Glory to God in the highest; peace on earth for God is blessing humankind.'"
,"15":"When the angels had left them and gone back to heaven, the shepherds said to one another, 'Let us go as far as Bethlehem and see what the Lord has made known to us.'"
,"16":"So they came hurriedly and found Mary and Joseph with the baby lying in the manger."
,"17":"On seeing this they related what they had been told about the child,"
,"18":"and all were astonished on hearing the shepherds."
,"19":"As for Mary, she treasured all these messages and continually pondered over them."
,"20":"The shepherds then returned giving glory and praise to God for all they had heard and seen, just as the angels had told them."
,"21":"On the eighth day the circumcision of the baby had to be performed; he was named Jesus, the name the angel had given him before he was conceived."
,"22":"When the day came for the purification according to the law of Moses, they brought the baby up to Jerusalem to present him to the Lord,"
,"23":"as it is written in the law of the Lord: Every firstborn male shall be consecrated to God."
,"24":"And they offered a sacrifice as ordered in the law of the Lord: a pair of turtledoves or two young pigeons."
,"25":"There lived in Jerusalem at this time a very upright and devout man named Simeon; the Holy Spirit was in him. He looked forward to the time when the Lord would comfort Israel,"
,"26":"and he had been assured by the Holy Spirit that he would not die before seeing the Messiah of the Lord."
,"27":"So he was led into the Temple by the Holy Spirit at the time the parents brought the child Jesus, to do for him according to the custom of the Law."
,"28":"Simeon took the child in his arms and blessed God, saying,"
,"29":"'Now, O Lord, you can dismiss,your servant in peace, for you have fulfilled your word"
,"30":"and my eyes have seen your salvation,"
,"31":"which you display for all the people to see."
,"32":"Here is the light you will reveal to the nations,and the glory of your people Israel.'"
,"33":"His father and mother wondered at what was said about the child."
,"34":"Simeon blessed them and said to Mary, his mother, 'See him; he will be for the rise or fall of the multitudes of Israel. He shall stand as a sign of contradiction,"
,"35":"while a sword will pierce your own soul. Then the secret thoughts of many may be brought to light.'"
,"36":"There was also a prophetess named Anna, daughter of Phanuel, of the tribe of Asher. After leaving her father's home, she had been seven years with her husband, and since then she had been continually about the Temple, serving God as a widow night and day in fasting and prayer."
,"37":"She was now eighty-four."
,"38":"Coming up at that time, she gave praise to God and spoke of the child to all who looked forward to the deliverance of Jerusalem."
,"39":"When the parents had fulfilled all that was required by the law of the Lord, they returned to their town, Nazareth in Galilee."
,"40":"There the child grew in stature and strength and was filled with wisdom: the grace of God was upon him."
,"41":"Every year the parents of Jesus went to Jerusalem for the Feast of the Passover, as was customary."
,"42":"And when Jesus was twelve years old, he went up with them according to the custom for this feast."
,"43":"After the festival was over, they returned, but the boy Jesus remained in Jerusalem and his parents did not know it."
,"44":"They thought he was in the company and after walking the whole day they looked for him among their relatives and friends."
,"45":"As they did not find him, they went back to Jerusalem searching for him,"
,"46":"and on the third day they found him in the Temple, sitting among the teachers, listening to them and asking questions."
,"47":"And all the people were amazed at his understanding and his answers."
,"48":"His parents were very surprised when they saw him and his mother said to him, 'Son, why have you done this to us? Your father and I were very worried while searching for you.'"
,"49":"Then he said to them, 'Why were you looking for me? Do you not know that I must be in my Father's house?'"
,"50":"But they did not understand this answer."
,"51":"Jesus went down with them, returning to Nazareth, and he continued to be subject to them. As for his mother, she kept all these things in her heart."
,"52":"And Jesus increased in wisdom and age, and in divine and human favor."
}`)
	CurrentBook.AddChapter(3, `{
"1":"It was the fifteenth year of the rule of the Emperor Tiberius; Pontius Pilatus was governor of Judea; Herod ruled over Galilee, his brother Philip ruled over the country of Iturea and Trachonitis, and Lysanias over Abilene."
,"2":"Annas and Caiaphas were the High Priests at that time when the word of God came to John, the son of Zechariah in the desert."
,"3":"John proclaimed a baptism for repentant people to obtain forgiveness of sins and he went through the whole country bordering the Jordan River."
,"4":"It was just as is written in the book of the prophet Isaiah: listen to this voice crying out in the desert: prepare the way of the Lord, make his path straight."
,"5":"The valleys will be filled and the mountains and hills made low. Everything crooked will be made straight and the rough paths smooth;"
,"6":"and every mortal will see the salvation of God."
,"7":"John said to the crowds who came out to be baptized by him, 'You brood of vipers! How will you escape when divine punishment comes?"
,"8":"Produce now the fruits of a true change of heart, and do not deceive yourselves by saying: 'Abraham is our ancestor!.' For I tell you, God can make children of Abraham from these stones."
,"9":"The axe is already laid to the root of the tree and every tree that fails to produce good fruit will be cut down and thrown into the fire.'"
,"10":"The people asked him, 'What are we to do?'"
,"11":"And John answered, 'If you have two coats, give one to the person who has none; and if you have food, do the same.'"
,"12":"Even tax collectors came to be baptized and asked him, 'Master, what must we do?'"
,"13":"John said to them, 'Collect no more than your fixed rate.'"
,"14":"People serving as soldiers asked John, 'What about us? What are we to do?' And he answered, 'Don't take anything by force or threaten the people by denouncing them falsely. Be content with your pay.'"
,"15":"The people were wondering about John's identity, 'Could he be the Messiah?'"
,"16":"Then John answered them, 'I baptize you with water, but the one who is coming will do much more: he will baptize you with Holy Spirit and fire. As for me, I am not worthy to untie his sandal."
,"17":"He comes with a winnowing fan to clear his threshing floor and gather the grain into his barn. But the chaff he will burn with fire that never goes out.'"
,"18":"With these and many other words John announced the Good News to the people"
,"19":"until Herod had him put in prison. For John reproached Herod for living with Herodias, his brother's wife, and for his evil deeds."
,"20":"Then Herod added another crime to all the rest he had committed: he put John in prison."
,"21":"Now, with all the people who came to be baptized, Jesus too was baptized. Then, while he was praying, the heavens opened:"
,"22":"the Holy Spirit came down upon him in the bodily form of a dove and a voice from heaven was heard, 'You are my Son, this day I have begotten you.'"
,"23":"When Jesus made his appearance, he had reached the age of thirty years. He was known as the son of Joseph, whose father and forefathers were: Heli, "
,"24":"Matthat, Levi, Melchi, Jannai, Joseph,"
,"25":"Matthathias, Amos, Nahum, Esli, Naggai,"
,"26":"Maath, Mattathias, Semein, Josech, Joda,"
,"27":"Joanan, Rhesa, Zerubbabel, Shealtiel, Neri,"
,"28":"Melchi, Addi, Cosam, Elmadam, Er,"
,"29":"Joshua, Eliezer, Jorim, Matthat, Levi,"
,"30":"Simeon, Judah, Joseph, Jonam, Eliakim,"
,"31":"Melea, Menna, Mattatha, Nathan, David,"
,"32":"Jesse, Obed, Boaz, Salmon, Nahson,"
,"33":"Amminadab, Adnim, Arni, Hezron, Perez, Judah,"
,"34":"Jacob, Isaac, Abraham, Terah, Nahor,"
,"35":"Serug, Reu, Peleg, Eber, Shelah,"
,"36":"Cainan, Arphaxad, Shem, Noah, Lamech,"
,"37":"Methuselah, Enoch, Jared, Malaleel, Cainan,"
,"38":"Enos, Seth, and Adam - who was from God."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Jesus was now full of Holy Spirit. As he returned from the Jordan, the Spirit led him into the desert"
,"2":"where he was tempted by the devil for forty days. He did not eat anything during that time, and in the end he was hungry."
,"3":"The devil then said to him, 'If you are son of God, tell this stone to turn into bread.'"
,"4":"But Jesus answered, 'Scripture says: People cannot live on bread alone.'"
,"5":"Then the devil took him up to a high place and showed him in a flash all the nations of the world."
,"6":"And he said to Jesus, 'I can give you power over all the nations and their wealth will be yours, for power and wealth have been delivered to me and I give them to whom I wish."
,"7":"All this will be yours provided you worship me.'"
,"8":"But Jesus replied, 'Scripture says: You shall worship the Lord your God and serve him alone.'"
,"9":"Then the devil took him up to Jerusalem and set him on the highest wall of the Temple; and he said, 'If you are son of God, throw yourself down from here,"
,"10":"for it is written: God will order his angels to take care of you"
,"11":"and again: They will hold you in their hands, lest you hurt your foot on the stones.'"
,"12":"But Jesus replied, 'It is written: You shall not challenge the Lord your God.'"
,"13":"When the devil had exhausted every way of tempting Jesus he left him, to return another time."
,"14":"Jesus acted with the power of the Spirit, and on his return to Galilee the news about him spread throughout all that territory."
,"15":"He began teaching in the synagogues of the Jews and everyone praised him."
,"16":"When Jesus came to Nazareth where he had been brought up, he entered the synagogue on the sabbath as he usually did."
,"17":"He stood up to read and they handed him the book of the prophet Isaiah. Jesus then unrolled the scroll and found the place where it is written: "
,"18":"'The Spirit of the Lord is upon me. He has anointed me to bring good news to the poor, to proclaim liberty to captives and new sight to the blind; to free the oppressed"
,"19":"and announce the Lord's year of mercy.'"
,"20":"Jesus then rolled up the scroll, gave it to the attendant and sat down, while the eyes of all in the synagogue were fixed on him."
,"21":"Then he said to them, 'Today these prophetic words come true even as you listen.'"
,"22":"All agreed with him and were lost in wonder, while he kept on speaking of the grace of God. Nevertheless they asked, 'Who is this but Joseph's son?'"
,"23":"So he said, 'Doubtless you will quote me the saying: Doctor, heal yourself! Do here in your town what they say you did in Capernaum.'"
,"24":"Jesus added, 'No prophet is honored in his own country."
,"25":"Truly, I say to you, there were many widows in Israel in the days of Elijah, when the heavens withheld rain for three years and six months and a great famine came over the whole land."
,"26":"Yet Elijah was not sent to any of them, but to a widow of Zarephath, in the country of Sidon."
,"27":"There were also many lepers in Israel in the time of Elisha, the prophet, and no one was healed except Naaman, the Syrian.'"
,"28":"On hearing these words, the whole assembly became indignant."
,"29":"They rose up and brought him out of the town,"
,"30":"to the edge of the hill on which Nazareth is built, intending to throw him down the cliff. But he passed through their midst and went his way."
,"31":"Jesus went down to Capernaum, a town of Galilee, and began teaching the people at the sabbath meetings."
,"32":"They were astonished at the way he taught them, for his word was spoken with authority."
,"33":"In the synagogue there was a man possessed by an evil spirit who shouted in a loud voice,"
,"34":"'What do you want with us, Jesus of Nazareth? Have you come to destroy us? I recognize you: you are the Holy One of God.'"
,"35":"Then Jesus said to him sharply, 'Be silent and leave this man!' The evil spirit then threw the man down in front of them and came out of him without doing him harm."
,"36":"Amazement seized all these people and they said to one another, 'What does this mean? He commands the evil spirits with authority and power. He orders, and you see how they come out!'"
,"37":"And news about Jesus spread throughout the surrounding area."
,"38":"Leaving the synagogue, Jesus went to the house of Simon. His mother-in-law was suffering from high fever and they asked him to do something for her."
,"39":"Bending over her, he rebuked the fever, and it left her. Immediately she got up and waited on them."
,"40":"At sunset, people suffering from many kinds of sickness were brought to Jesus. Laying his hands on each one, he healed them."
,"41":"Demons were driven out, howling as they departed from their victims, 'You are the Son of God!' He rebuked them and would not allow them to speak, for they knew he was the Messiah."
,"42":"Jesus left at daybreak and looked for a solitary place. People went out in search of him and, finding him, they tried to dissuade him from leaving."
,"43":"But he said, 'I have to go to other towns to announce the good news of the kingdom of God. That is what I was sent to do.'"
,"44":"So Jesus continued to preach in the synagogues of the Jewish country."
}`)
	CurrentBook.AddChapter(5, `{
"1":"One day, as Jesus stood by the Lake of Gennesaret, with a crowd gathered around him listening to the word of God,"
,"2":"he caught sight of two boats left at the water's edge by the fishermen now washing their nets."
,"3":"He got into one of the boats, the one belonging to Simon, and asked him to pull out a little from the shore. There he sat and continued to teach the crowd."
,"4":"When he had finished speaking he said to Simon, 'Put out into deep water and lower your nets for a catch.'"
,"5":"Simon replied, 'Master, we worked hard all night and caught nothing. But if you say so, I will lower the nets.'"
,"6":"This they did and caught such a large number of fish that their nets began to break."
,"7":"They signaled their partners in the other boat to come and help them. They came and filled both boats almost to the point of sinking."
,"8":"Upon seeing this, Simon Peter fell at Jesus' knees, saying, 'Leave me, Lord, for I am a sinful man!'"
,"9":"For he and his companions were amazed at the catch they had made"
,"10":"and so were Simon's partners, James and John, Zebedee's sons. Jesus said to Simon, 'Do not be afraid. You will catch people from now on.' "
,"11":"So they brought their boats to land and followed him, leaving everything."
,"12":"One day in another town, a man came to Jesus covered with leprosy. On seeing him he bowed down to the ground, and said, 'Lord, if you want to, you can make me clean.'"
,"13":"Stretching out his hand, Jesus touched the man and said, 'Yes, I want it. Be clean.' In an instant the leprosy left him."
,"14":"Then Jesus instructed him, 'Tell this to no one. But go and show yourself to the priest. Make an offering for your healing, as Moses prescribed; that should be a proof to the people.'"
,"15":"But the news about Jesus spread all the more, and large crowds came to him to listen and be healed of their sickness."
,"16":"As for Jesus, he would often withdraw to solitary places and pray."
,"17":"One day Jesus was teaching and many Pharisees and teachers of the Law had come from every part of Galilee and Judea and even from Jerusalem. They were sitting there while the power of the Lord was at work to heal the sick."
,"18":"Then some men brought a paralyzed man who lay on his mat. They tried to enter the house to place him before Jesus,"
,"19":"but they couldn't find a way through the crowd. So they went up on the roof and, removing the tiles, they lowered him on his mat into the middle of the crowd, in front of Jesus."
,"20":"When Jesus saw their faith, he said to the man, 'My friend, your sins are forgiven.'"
,"21":"At once the teachers of the Law and the Pharisees began to wonder, 'This man insults God! Who can forgive sins but only God?'"
,"22":"But Jesus knew their thoughts and asked them, 'Why are you reacting like this?"
,"23":"Which is easier to say: 'Your sins are forgiven,' or: 'Get up and walk'?"
,"24":"Now you shall know that the Son of Man has authority on earth to forgive sins.' And Jesus said to the paralyzed man, 'Get up, take your mat and go home.'"
,"25":"At once the man stood before them. He took up the mat he had been lying on and went home praising God."
,"26":"Amazement seized the people and they praised God. They were filled with a holy fear and said, 'What wonderful things we have seen today!'"
,"27":"After this Jesus went out, and as he noticed a tax collector named Levi sitting in the tax-office, he said to him, 'Follow me.'"
,"28":"So Levi, leaving everything, got up and followed Jesus."
,"29":"Levi gave a great feast for Jesus, and many tax collectors came to his house and took their place at table with the other people."
,"30":"Then the Pharisees and their fellow teachers complained to Jesus' disciples, 'How is it that you eat and drink with tax collectors and other sinners?'"
,"31":"But Jesus spoke up, 'Healthy people don't need a doctor, but sick people do."
,"32":"I have come to call to repentance; I call sinners, not the righteous.'"
,"33":"Some people asked him, 'The disciples of John fast often and say long prayers, and so do the disciples of the Pharisees. Why is it that your disciples eat and drink?' Then Jesus said to them,"
,"34":"'You can't make wedding guests fast while the bridegroom is with them."
,"35":"But later the bridegroom will be taken from them and they will fast in those days.'"
,"36":"Jesus also told them this parable, 'No one tears a piece from a new coat to put it on an old one; otherwise the new will be torn and the piece taken from the new will not match the old."
,"37":"No one puts new wine into old wineskins; otherwise the new wine will burst the skins and be spilled, and the skins will be destroyed as well."
,"38":"But new wine must be put into fresh skins."
,"39":"Yet no one who has tasted old wine is eager to get new wine, but says: The old is good.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"One sabbath Jesus was going through the corn fields and his disciples began to pick heads of grain crushing them in their hands for food."
,"2":"Some of the Pharisees asked them, 'Why do you do what is forbidden on the sabbath?'"
,"3":"Then Jesus spoke, 'Have you never read what David did when he and his men were hungry?'"
,"4":"He entered the house of God, took and ate the bread of the offering and even gave some to his men, though only priests are allowed to eat that bread.'"
,"5":"And Jesus added, 'The Son of Man is Lord and rules over the sabbath.'"
,"6":"On another sabbath Jesus entered the synagogue and began teaching. There was a man with a paralyzed right hand"
,"7":"and the teachers of the Law and the Pharisees watched him: Would Jesus heal the man on the sabbath? If he did, they could accuse him."
,"8":"But Jesus knew their thoughts and said to the man, 'Get up and stand in the middle.'"
,"9":"Then he spoke to them, 'I want to ask you: what is allowed by the Law on the sabbath, to do good or to do harm, to save life or destroy it?'"
,"10":"And Jesus looked around at them all. Then he said to the man, 'Stretch out your hand.' He stretched it out and his hand was restored, becoming as whole as the other."
,"11":"But they were furious and began to discuss with one another how they could deal with Jesus."
,"12":"At this time Jesus went out into the hills to pray, spending the whole night in prayer with God."
,"13":"When day came, he called his disciples to him and chose twelve of them whom he called apostles:"
,"14":"Simon, whom he named Peter, and his brother Andrew, James and John; Philip and Bartholomew;"
,"15":"Matthew and Thomas; James son of Alpheus and Simon called the Zealot;"
,"16":"Judas son of James, and Judas Iscariot, who would be the traitor."
,"17":"Coming down the hill with them, Jesus stood on a level place. Many of his disciples were there and a large crowd of people who had come from all parts of Judea and Jerusalem and from the coastal cities of Tyre and Sidon."
,"18":"They gathered to hear him and be healed of their diseases; likewise people troubled by evil spirits were healed."
,"19":"All the crowd tried to touch him because of the power which went out from him and healed them all."
,"20":"Then lifting up his eyes to his disciples, Jesus said, 'Fortunate are you who are poor, the kingdom of God is yours.'"
,"21":"Fortunate are you who are hungry now, for you will be filled. Fortunate are you who weep now, for you will laugh."
,"22":"Fortunate are you when people hate you, when they reject you and insult you and number you among criminals, because of the Son of Man."
,"23":"Rejoice in that day and leap for joy, for a great reward is kept for you in heaven. Remember that is how the ancestors of this people treated the prophets."
,"24":"But alas for you who have wealth, for you have been comforted now."
,"25":"Alas for you who are full, for you will go hungry. Alas for you who laugh now, for you will mourn and weep."
,"26":"Alas for you when people speak well of you, for that is how the ancestors of these people treated the false prophets."
,"27":"But I say to you who hear me: Love your enemies, do good to those who hate you."
,"28":"Bless those who curse you and pray for those who treat you badly."
,"29":"To the one who strikes you on the cheek, turn the other cheek; from the one who takes your coat, do not keep back your shirt."
,"30":"Give to the one who asks and if anyone has taken something from you, do not demand it back."
,"31":"Do to others as you would have others do to you."
,"32":"If you love only those who love you, what kind of graciousness is yours? Even sinners love those who love them."
,"33":"If you do favors to those who are good to you, what kind of graciousness is yours? Even sinners do the same."
,"34":"If you lend only when you expect to receive, what kind of graciousness is yours? For sinners also lend to sinners, expecting to receive something in return."
,"35":"But love your enemies and do good to them, and lend when there is nothing to expect in return. Then will your reward be great and you will be sons and daughters of the Most High. For he is kind towards the ungrateful and the wicked."
,"36":"Be merciful, just as your Father is merciful."
,"37":"Don't be a judge of others and you will not be judged; do not condemn and you will not be condemned; forgive and you will be forgiven;"
,"38":"give and it will be given to you, and you will receive in your sack good measure, pressed down, full and running over. For the measure you give will be the measure you receive back.'"
,"39":"And Jesus offered this example, 'Can a blind person lead another blind person? Surely both will fall into a ditch."
,"40":"A disciple is not above the master; but when fully trained, he will be like the master."
,"41":"So why do you pay attention to the speck in your brother's eye while you have a log in your eye and are not conscious of it?"
,"42":"How can you say to your neighbor: 'Friend, let me take this speck out of your eye,' when you can't remove the log in your own? You hypocrite! First remove the log from your own eye and then you will see clearly enough to remove the speck from your neighbor's eye."
,"43":"No healthy tree bears bad fruit, no poor tree bears good fruit."
,"44":"And each tree is known by the fruit it bears: you don't gather figs from thorns, or grapes from brambles."
,"45":"Similarly the good person draws good things from the good stored in the heart, and an evil person draws evil things from the evil stored in the heart. For the mouth speaks from the fullness of the heart."
,"46":"Why do you call me: 'Lord! Lord!' and not do what I say?"
,"47":"I will show you what the one who comes to me and listens to my words and acts accordingly, is like."
,"48":"That one is like the builder who dug deep and laid the foundations of his house on rock. The river overflowed and the stream dashed against the house, but could not carry it off because the house had been well built."
,"49":"But the one who listens and does not act, is like a man who built his house on the ground without a foundation. The flood burst against it, and the house fell at once: and what a terrible disaster that was!'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"When Jesus had finished teaching in this way to the people, he went to Capernaum."
,"2":"There was a captain whose servant was very sick and near to death, a man very dear to him."
,"3":"So when he heard about Jesus, he sent some elders of the Jews to persuade him to come and save his servant's life."
,"4":"The elders came to Jesus and begged him earnestly, saying,"
,"5":"'He deserves this of you, for he loves our people and even built a synagogue for us.'"
,"6":"Jesus went with them. He was not far from the house when the captain sent friends to give this message, 'Sir, do not trouble yourself for I am not worthy to welcome you under my roof."
,"7":"You see I didn't approach you myself. Just give the order and my servant will be healed."
,"8":"For I myself, a junior officer, give orders to my soldiers and I say to this one: 'Go,' and he goes; and to the other: 'Come,' and he comes; and to my servant: 'Do this,' and he does it.'"
,"9":"On hearing these words, Jesus was filled with admiration. He turned and said to the people with him, 'I say to you, not even in Israel have I found such great faith.'"
,"10":"The people sent by the captain went back to his house; there they found that the servant was well."
,"11":"A little later Jesus went to a town called Naim and many of his disciples went with him - a great number of people."
,"12":"As he reached the gate of the town, a dead man was being carried out. He was the only son of his mother and she was a widow; there followed a large crowd of townspeople."
,"13":"On seeing her, the Lord had pity on her and said, 'Don't cry.'"
,"14":"Then he came up and touched the stretcher and the men who carried it stopped. Jesus then said, 'Young man, awake, I tell you.'"
,"15":"And the dead man got up and began to speak, and Jesus gave him to his mother."
,"16":"A holy fear came over them all and they praised God saying, 'A great prophet has appeared among us; God has visited his people.'"
,"17":"This news spread out in the Jewish country and the surrounding places."
,"18":"The disciples of John gave him all this news. So he called two of them and"
,"19":"sent them to the Lord with this message, 'Are you the one we are expecting, or should we wait for another?'"
,"20":"These men came to Jesus and said, 'John the Baptist sent us to ask you: Are you the one we are to expect, or should we wait for another?'"
,"21":"At that time Jesus healed many people of their sicknesses or diseases; he freed them from evil spirits and he gave sight to the blind."
,"22":"Then he answered the messengers, 'Go back and tell John what you have seen and heard: the blind see again, the lame walk, lepers are made clean, the deaf hear, the dead are raised to life, and the poor are given good news. Now, listen:"
,"23":"Fortunate are those who encounter me, but not for their downfall.'"
,"24":"When John's messengers had gone, Jesus began speaking to the people about John. And he said, 'What did you want to see when you went to the desert? A tall reed blowing in the wind?"
,"25":"What was there to see? A man dressed in fine clothes? But people who wear fine clothes and enjoy delicate food are found in palaces."
,"26":"What did you go out to see? A prophet? Yes, I tell you, and more than a prophet."
,"27":"For John is the one foretold in Scripture in these words: I am sending my messenger ahead of you to prepare your ways."
,"28":"No one may be found greater than John among those born of women but, I tell you, the least in the Kingdom of God is greater than he."
,"29":"All the people listening to him, even the tax collectors, had acknowledged the will of God in receiving the baptism of John,"
,"30":"whereas the Pharisees and the teachers of the Law, in not letting themselves be baptized by him, ignored the will of God."
,"31":"What comparison can I use for this people? What are they like?"
,"32":"They are like children sitting in the marketplace, about whom their companions complain: 'We piped you a tune and you wouldn't dance; we sang funeral songs and you wouldn't cry.'"
,"33":"Remember John: he didn't eat bread or drink wine, and you said: 'He has an evil spirit.'"
,"34":"Next came the Son of Man, eating and drinking, and you say: 'Look, a glutton for food and wine, a friend of tax collectors and sinners.'"
,"35":"But the children of Wisdom always recognize her work.'"
,"36":"One of the Pharisees asked Jesus to share his meal, so he went to the Pharisee's home and as usual reclined on the sofa to eat."
,"37":"And it happened that a woman of this town, who was known as a sinner, heard that he was in the Pharisee's house. She brought a precious jar of perfume"
,"38":"and stood behind him at his feet, weeping. She wet his feet with tears, she dried them with her hair and kissed his feet and poured the perfume on them."
,"39":"The Pharisee who had invited Jesus was watching and thought, 'If this man were a prophet, he would know what sort of person is touching him; isn't this woman a sinner?'"
,"40":"Then Jesus spoke to the Pharisee and said, 'Simon, I have something to ask you.' He answered, 'Speak, master.' And Jesus said,"
,"41":"'Two people were in debt to the same creditor. One owed him five hundred silver coins, and the other fifty."
,"42":"As they were unable to pay him back, he graciously canceled the debts of both. Now, which of them will love him more?'"
,"43":"Simon answered, 'The one, I suppose, who was forgiven more.' And Jesus said, 'You are right.'"
,"44":"And turning toward the woman, he said to Simon, 'Do you see this woman?"
,"45":"You gave me no water for my feet when I entered your house, but she has washed my feet with her tears and dried them with her hair. You didn't welcome me with a kiss, but she has not stopped kissing my feet since she came in."
,"46":"You provided no oil for my head, but she has poured perfume on my feet."
,"47":"This is why, I tell you, her sins, her many sins, are forgiven, because of her great love. But the one who is forgiven little, has little love.'"
,"48":"Then Jesus said to the woman, 'Your sins are forgiven.'"
,"49":"The others sitting with him at the table began to wonder, 'Now this man claims to forgive sins!'"
,"50":"But Jesus again spoke to the woman, 'Your faith has saved you; go in peace.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Jesus walked through towns and countryside, preaching and giving the good news of the kingdom of God. The Twelve followed him,"
,"2":"and also some women who had been healed of evil spirits and diseases: Mary called Magdalene, who had been freed of seven demons;"
,"3":"Joanna, wife of Chuza, Herod's steward; Suzanna and others who provided for them out of their own funds."
,"4":"As a great crowd gathered and people came to him from every town, Jesus began teaching them through stories, or parables,"
,"5":"'The sower went out to sow the seed. And as he sowed, some of the grain fell along the way, was trodden on and the birds of the sky ate it up."
,"6":"Some fell on rocky ground, and no sooner had it come up than it withered, because it had no water."
,"7":"Some fell among thorns; the thorns grew up with the seed and choked it."
,"8":"But some fell on good soil and grew, producing fruit - a hundred times as much.' And Jesus cried out, 'Listen then, if you have ears to hear!'"
,"9":"The disciples asked him, 'What does this story mean?'"
,"10":"And Jesus answered, 'You have been granted to know the mystery of the kingdom of God. But to others it is given in the form of stories, or parables, so that seeing they may not perceive and hearing they may not understand.'"
,"11":"Now, this is the point of the parable: The seed is the word of God."
,"12":"Those along the wayside are people who hear it, but immediately the devil comes and takes the word from their minds, for he doesn't want them to believe and be saved."
,"13":"Those on the rocky ground are people who receive the word with joy, but they have no root; they believe for a while and give way in time of trial."
,"14":"Among the thorns are people who hear the word but as they go their way, are choked by worries, riches, and the pleasures of life; they bring no fruit to maturity."
,"15":"The good soil, instead, are people who receive the word and keep it in a gentle and generous mind, and persevering patiently, they bear fruit."
,"16":"No one, after lighting a lamp covers it with a bowl or puts it under the bed; rather he puts it on a lampstand so that people coming in may see the light."
,"17":"In the same way, there is nothing hidden that shall not be uncovered; nothing kept secret that shall not be known clearly."
,"18":"Now, take care how well you listen, for whoever produces will be given more, but from those who do not produce, even what they seem to have will be taken away from them.'"
,"19":"Then his mother and his relatives came to him, but they could not get to him because of the crowd."
,"20":"Someone told him, 'Your mother and your brothers are standing outside and wish to meet you.'"
,"21":"Then Jesus answered, 'My mother and my brothers are those who hear the word of God and do it.'"
,"22":"One day Jesus got into a boat with his disciples and said to them, 'Let us go across to the other side of the lake.'"
,"23":"So they set out, and as they sailed he fell asleep. Suddenly a storm came down on the lake and the boat began to fill with water, and they were in danger."
,"24":"The disciples then went to Jesus to wake him, saying, 'Master! Master! We are sinking!' Jesus woke up. He rebuked the wind and the rolling waves; the storm subsided, and all was quiet."
,"25":"Then Jesus said to them, 'Where is your faith?' They had been afraid; now they were astonished and said to one another, 'Who can this be? See, he commands even the wind and the sea and they obey him!'"
,"26":"The crossing ended at the country of the Gerasenes, on the shore facing Galilee."
,"27":"As Jesus stepped ashore, a man from the town approached him. This man was possessed by demons and for a long time was without clothes. He would not live in a house but stayed among the tombstones."
,"28":"When he came nearer to Jesus, he yelled and threw himself on the ground before him, and then shouted, 'What do you want with me, Jesus, son of the Most High God? I beg you, do not torment me';"
,"29":"for Jesus had ordered the evil spirit to leave the man. This spirit had seized him many times, when he had been bound with ropes and chains and kept under control. He would then suddenly break the chains and be driven by the evil spirit into wild places. When Jesus asked him, "
,"30":"'What is your name?' the man said, 'I am Legion,' because many demons had entered into him."
,"31":"And they begged Jesus not to command them to go into the bottomless pit."
,"32":"Nearby a great herd of pigs was feeding, so the demons asked to be allowed to enter the pigs, and Jesus let them go."
,"33":"The demons then left the man and entered the pigs, and the herd rushed down into the lake and was drowned."
,"34":"When the herdsmen saw what had happened, they fled and reported it in the town and countryside."
,"35":"Then people went out to see what had happened and came to Jesus. There they saw the man from whom the demons had been driven out. He was clothed and in his right mind, and was sitting at the feet of Jesus. They were afraid."
,"36":"Then people who had seen it told them how the man had been healed,"
,"37":"and all this crowd from the Gerasene country asked Jesus to depart from them, for a great fear took hold of them. So Jesus got into the boat to return."
,"38":"It was then that the man freed of the demons asked Jesus if he could stay with him."
,"39":"But Jesus sent him on his way, 'Go back to your family and tell them how much God has done for you.' So the man went away, proclaiming through the whole town how much Jesus had done for him."
,"40":"When Jesus returned, the people welcomed him, for all had been waiting for him."
,"41":"At that time a man named Jairus, an official of the synagogue, threw himself at Jesus' feet and begged him to come to his house"
,"42":"because his only daughter, about twelve years old, was dying. As Jesus was on his way, the crowd pressed from every side."
,"43":"There was a woman who had suffered from a bleeding for twelve years. This woman had spent everything she had on doctors, but none of them had been able to cure her."
,"44":"Now she came up behind Jesus and touched the fringe of his cloak, and her bleeding stopped at once."
,"45":"Then Jesus asked, 'Who touched me?' Everyone denied it and Peter said, 'Master, the crowd is pushing all around you.'"
,"46":"But Jesus said, 'Someone touched me, for I felt power go out from me.'"
,"47":"The woman knew she had been discovered. She came trembling and knelt before Jesus. Then she openly confessed why she had touched him and how she had been instantly cured."
,"48":"And Jesus said to her, 'Daughter, your faith has saved you. Go in peace.'"
,"49":"While Jesus was still speaking, a messenger arrived from the official's home to tell him, 'Your daughter has just died; don't trouble the master any further.'"
,"50":"But Jesus heard the news and said to the official, 'Do not fear, only believe.'"
,"51":"When he entered the house, Jesus allowed no one to follow him except Peter, James and John, with the father and mother of the child."
,"52":"As all the people were weeping and wailing loudly, Jesus said to them, 'Do not weep, she is not dead but asleep.'"
,"53":"And they laughed at him, knowing that she was dead."
,"54":"As for Jesus, he took the child by the hand and said to her, 'Child, wake up!'"
,"55":"And her spirit returned and she got up at once; then Jesus told them to give her something to eat."
,"56":"The parents were amazed, but Jesus ordered them not to let anyone know what had happened."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Then Jesus called his twelve disciples and gave them power and authority to drive out all evil spirits and to heal diseases."
,"2":"And he sent them to proclaim the kingdom of God and to heal the sick."
,"3":"He instructed them, 'Don't take anything for the journey, neither walking stick, nor bag, nor bread, nor silver coins; and don't even take a spare tunic."
,"4":"Whatever house you enter, remain there until you leave that place."
,"5":"And wherever they don't welcome you, leave the town and shake the dust from your feet: it will be as a testimony against them.'"
,"6":"So they set out and went through the villages, proclaiming the good news and healing people everywhere."
,"7":"King Herod heard of all this and did not know what to think, for people said, 'This is John, raised from the dead.'"
,"8":"Others believed that Elijah or one of the ancient prophets had come back to life."
,"9":"As for Herod, he said, 'I had John beheaded; who is this man about whom I hear such wonders?' And he was anxious to see him."
,"10":"On their return the apostles told Jesus everything they had done. Then he took them aside to a lonely place, and they went away to a town called Bethsaida to be by themselves."
,"11":"But the crowd heard of this and caught up with him. So he welcomed them and began speaking about the kingdom of God, curing those who needed healing."
,"12":"The day was drawing to a close and the Twelve drew near to tell him, 'Send the crowd away and let them go into the villages and farms around, to find lodging and food, for we are here in a lonely place.'"
,"13":"But Jesus replied, 'You yourselves give them something to eat.' They answered, 'We have only five loaves and two fish; do you want us to go and buy food enough for all this crowd?'"
,"14":"For there were about five thousand men. Then Jesus said to his disciples, 'Make people sit down in groups of fifties.'"
,"15":"So they made all of them settle down."
,"16":"Jesus then took the five loaves and two fish, and raising his eyes to heaven, pronounced a blessing over them; he broke them and gave them to the disciples to distribute to the crowd."
,"17":"They ate and everyone had enough; and when they gathered up what was left, twelve baskets were filled with broken pieces."
,"18":"One day when Jesus was praying alone, not far from his disciples, he asked them, 'What do people say about me?'"
,"19":"And they answered, 'Some say that you are John the Baptist; others say that you are Elijah, and still others that you are one of the former prophets risen from the dead.' Again Jesus asked them,"
,"20":"'Who then do you say I am?' Peter answered, 'The Messiah of God.'"
,"21":"Then Jesus spoke to them, giving them strict orders not to tell this to anyone."
,"22":"And he added, 'The Son of Man must suffer many things. He will be rejected by the elders and chief priests and teachers of the Law, and put to death. Then after three days he will be raised to life.'"
,"23":"Jesus also said to all the people, 'If you wish be a follower of mine, deny yourself and take up your cross each day, and follow me."
,"24":"For if you choose to save your life, you will lose it, and if you lose your life for my sake, you will save it."
,"25":"What does it profit you to gain the whole world while you destroy or damage yourself?"
,"26":"If someone feels ashamed of me and of my words, the Son of Man will be ashamed of him when he comes in his Glory and in the Glory of his Father with his holy angels."
,"27":"Truly, I say to you, there are some here who will not experience death before they see the kingdom of God.'"
,"28":"About eight days after Jesus had said all this, he took Peter, John and James and went up the mountain to pray."
,"29":"And while he was praying, the aspect of his face was changed and his clothing became dazzling white."
,"30":"Two men were talking with Jesus: Moses and Elijah."
,"31":"They had just appeared in heavenly glory and were telling him about his departure that had to take place in Jerusalem."
,"32":"Peter and his companions had fallen asleep, but they awoke suddenly and saw Jesus' Glory and the two men standing with him."
,"33":"As Moses and Elijah were about to leave, Peter said to him, 'Master, how good it is for us to be here for we can make three tents, one for you, one for Moses and one for Elijah.' For Peter didn't know what to say."
,"34":"And no sooner had he spoken than a cloud appeared and covered them; and the disciples were afraid as they entered the cloud."
,"35":"Then these words came from the cloud, 'This is my Son, my Chosen one, listen to him.'"
,"36":"And after the voice had spoken, Jesus was there alone. The disciples kept this to themselves at the time, telling no one of anything they had seen."
,"37":"The next day, when they came down from the mountain, quite a group met Jesus."
,"38":"A man among them called out, 'Master, I beg you to look at my son, my only child. When the evil spirit seizes him, he suddenly screams."
,"39":"The spirit throws him into a fit and he foams at the mouth; it scarcely ever leaves him after wearing him out."
,"40":"I begged your disciples to drive it out, but they could not.'"
,"41":"Jesus answered, 'You faithless people! How wrong you are! How long must I be with you and put up with you? Bring your son here.'"
,"42":"And while the boy was being brought, the demon knocked him to the ground and threw him into a fit. But Jesus spoke sharply to the evil spirit, healed the boy and gave him back to his father."
,"43":"And all who saw it were astonished at God's wonderful work. While all were amazed at everything Jesus did, he said to his disciples, "
,"44":"'Listen and remember what I tell you now: The Son of Man will be delivered into human hands.'"
,"45":"But the disciples didn't understand this saying; something prevented them from grasping what he meant, and they were afraid to ask him about it."
,"46":"One day the disciples were arguing about which of them was the most important."
,"47":"But Jesus knew their thoughts, so he took a little child and stood him by his side."
,"48":"Then he said to them, 'Whoever welcomes this little child in my name welcomes me; and whoever welcomes me, welcomes the one who sent me. And listen: the one who is found to be the least among you all, is the one who is the greatest.'"
,"49":"Then John spoke up, 'Master, we saw someone who drove out demons by calling upon your name, and we tried to forbid him because he doesn't follow you with us.'"
,"50":"But Jesus said, 'Don't forbid him. He who is not against you is for you.'"
,"51":"As the time drew near when Jesus would be taken up to heaven, he made up his mind to go to Jerusalem."
,"52":"He had sent ahead of him some messengers who entered a Samaritan village to prepare a lodging for him."
,"53":"But the people would not receive him because he was on his way to Jerusalem."
,"54":"Seeing this, James and John, his disciples said, 'Lord, do you want us to call down fire from heaven to reduce them to ashes?'"
,"55":"Jesus turned and rebuked them,"
,"56":"and they went on to another village."
,"57":"As they went on their way, a man said to him, 'I will follow you wherever you go.'"
,"58":"Jesus said to him, 'Foxes have holes and birds of the air have nests; but the Son of Man has nowhere to lay his head.'"
,"59":"To another Jesus said, 'Follow me.' But he answered, 'Let me go back now, for first I want to bury my father.'"
,"60":"And Jesus said to him, 'Let the dead bury their dead; as for you, leave them and proclaim the kingdom of God.'"
,"61":"Another said to him, 'I will follow you, Lord, but first let me say goodbye to my family.'"
,"62":"And Jesus said to him, 'Whoever has put his hand to the plow and looks back is not fit for the kingdom of God.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"After this the Lord appointed seventy-two other disciples and sent them two by two ahead of him to every town and place, where he himself was to go."
,"2":"And he said to them, 'The harvest is rich, but the workers are few. So you must ask the Lord of the harvest to send workers to his harvest."
,"3":"Courage! I am sending you like lambs among wolves."
,"4":"Set off without purse or bag or sandals; and do not stop at the homes of those you know."
,"5":"Whatever house you enter, first bless them saying: 'Peace to this house.'"
,"6":"If a friend of peace lives there, the peace shall rest upon that person. But if not, the blessing will return to you."
,"7":"Stay in that house eating and drinking at their table, for the worker deserves to be paid. Do not move from house to house."
,"8":"When they welcome you in any town, eat what they offer you."
,"9":"Heal the sick who are there and say to them: 'The kingdom of God has drawn near to you.'"
,"10":"But in any town where you are not welcome, go to the marketplace and proclaim:"
,"11":"'Even the dust of your town that clings to our feet, we wipe off and leave with you. But know and be sure that the kingdom of God had come to you.'"
,"12":"I tell you that on the Judgment Day it will be better for Sodom than for this town."
,"13":"Alas for you Chorazin! Alas for you Bethsaida! So many miracles have been worked in you! If the same miracles had been performed in Tyre and Sidon, they would already be sitting in ashes and wearing the sackcloth of repentance."
,"14":"Surely for Tyre and Sidon it will be better than for you on the Judgment Day."
,"15":"And what of you, city of Capernaum? Will you be lifted up to heaven? You will be thrown down to the place of the dead."
,"16":"Whoever listens to you listens to me, and whoever rejects you rejects me; and he who rejects me, rejects the one who sent me.'"
,"17":"The seventy-two disciples returned full of joy. They said, 'Lord, even the demons obeyed us when we called on your name.'"
,"18":"Then Jesus replied, 'I saw Satan fall like lightning from heaven."
,"19":"You see, I have given you authority to trample on snakes and scorpions and to overcome all the power of the Enemy, so that nothing will harm you."
,"20":"Nevertheless, don't rejoice because the evil spirits submit to you; rejoice rather that your names are written in heaven.'"
,"21":"At that time Jesus was filled with the joy of the Holy Spirit and said, 'I praise you, Father, Lord of heaven and earth, for you have hidden these things from the wise and learned, and made them known to the little ones."
,"22":"Yes, Father, such has been your gracious will. I have been given all things by my Father, so that no one knows the Son except the Father, and no one knows the Father except the Son and he to whom the Son chooses to reveal him.'"
,"23":"Then Jesus turned to his disciples and said to them privately, 'Fortunate are you to see what you see,"
,"24":"for I tell you that many prophets and kings would have liked to see what you see but did not, and to hear what you hear but did not hear it.'"
,"25":"Then a teacher of the Law came and began putting Jesus to the test. And he said, 'Master, what shall I do to receive eternal life?'"
,"26":"Jesus replied, 'What is written in the Scripture? How do you understand it?'"
,"27":"The man answered, 'It is written: You shall love the Lord your God with all your heart, with all your soul, with all your strength and with all your mind. And you shall love your neighbor as yourself.'"
,"28":"Jesus replied, 'What a good answer! Do this and you shall live.'"
,"29":"The man wanted to keep up appearances, so he replied, 'Who is my neighbor?'"
,"30":"Jesus then said, 'There was a man going down from Jerusalem to Jericho, and he fell into the hands of robbers. They stripped him, beat him and went off leaving him half dead."
,"31":"It happened that a priest was going along that road and saw the man, but passed by on the other side."
,"32":"Likewise a Levite saw the man and passed by on the other side."
,"33":"But a Samaritan, too, was going that way, and when he came upon the man, he was moved with compassion."
,"34":"He went over to him and treated his wounds with oil and wine and wrapped them with bandages. Then he put him on his own mount and brought him to an inn where he took care of him."
,"35":"The next day he had to set off, but he gave two silver coins to the innkeeper and told him: 'Take care of him and whatever you spend on him, I will repay when I come back.''"
,"36":"Jesus then asked, 'Which of these three, do you think, made himself neighbor to the man who fell into the hands of robbers?'"
,"37":"The teacher of the Law answered, 'the one who had mercy on him.' And Jesus said, 'Go then and do the same.'"
,"38":"As Jesus and his disciples were on their way, he entered a village and a woman called Martha welcomed him to her house."
,"39":"She had a sister named Mary who sat down at the Lord's feet to listen to his words."
,"40":"Martha, meanwhile, was busy with all the serving and finally she said, 'Lord, don't you care that my sister has left me to do all the serving?'"
,"41":"But the Lord answered, 'Martha, Martha, you worry and are troubled about many things,"
,"42":"whereas only one thing is needed. Mary has chosen the better part, and it will not be taken away from her.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"One day Jesus was praying in a certain place and when he had finished, one of his disciples said to him, 'Lord, teach us to pray, just as John taught his disciples.'"
,"2":"And Jesus said to them, 'When you pray, say this: Father, hallowed be your name, may your kingdom come,"
,"3":"give us each day the kind of bread we need,"
,"4":"and forgive us our sins, for we also forgive all who do us wrong, and do not bring us to the test.'"
,"5":"Jesus said to them, 'Suppose one of you has a friend and goes to his house in the middle of the night and says: 'Friend, lend me three loaves,"
,"6":"for a friend of mine who is traveling has just arrived and I have nothing to offer him.'"
,"7":"Maybe your friend will answer from inside: 'Don't bother me now; the door is locked and my children and I are in bed, so I can't get up and give you anything.'"
,"8":"But I tell you, even though he will not get up and attend to you because you are a friend, yet he will get up because you are a bother to him, and he will give you all you need."
,"9":"And so I say to you, 'Ask and it will be given to you; seek and you will find; knock and it will be opened to you."
,"10":"For the one who asks receives, and the one who searches finds, and to him who knocks the door will be opened."
,"11":"If your child asks for a fish, will you give a snake instead?"
,"12":"And if your child asks for an egg, will you give a scorpion?"
,"13":"Even you evil people know how to give good gifts to your children, how much more then will the Father in heaven give holy spirit to those who ask him!'"
,"14":"One day Jesus was driving out a dumb demon. When the demon had been driven out, the mute person could speak, and the people were amazed."
,"15":"Yet some of them said, 'He drives out demons by the power of Beelzebul, the chief of the demons.'"
,"16":"So others wanted to put him to the test by asking him for a heavenly sign."
,"17":"But Jesus knew their thoughts and said to them, 'Every nation divided by civil war is on the road to ruin, and will fall."
,"18":"If Satan also is divided, his empire is coming to an end. How can you say that I drive out demons by calling upon Beelzebul?"
,"19":"If I drive them out by Beelzebul, by whom do your fellow members drive out demons? They themselves will give you the answer."
,"20":"But suppose I drive out demons by the finger of God; would not this mean that the kingdom of God has come upon you?"
,"21":"As long as the strong and armed man guards his house, his goods are safe."
,"22":"But when a stronger one attacks and overcomes him, the challenger takes away all the weapons he relied on and disposes of his spoils."
,"23":"Whoever is not with me is against me, and whoever does not gather with me, scatters."
,"24":"When the evil spirit goes out of a person, it wanders through dry lands looking for a resting place. And finding none, it says, 'I will return to my house from which I came.'"
,"25":"When it comes, it finds the house swept and everything in order."
,"26":"Then it goes to fetch seven other spirits even worse than itself. They move in and settle there, so that the last state of that person is worse than the first.'"
,"27":"As Jesus was speaking, a woman spoke from the crowd and said to him, 'Blessed is the one who bore you and nursed you!'"
,"28":"Jesus replied, 'Surely blessed are those who hear the word of God and keep it as well.'"
,"29":"As the crowd increased, Jesus began to speak in this way, 'People of the present time are evil people. They ask for a sign, but no sign will be given to them except the sign of Jonah."
,"30":"As Jonah became a sign for the people of Nineveh, so will the Son of Man be a sign for this generation."
,"31":"The Queen of the South will rise up on Judgment Day with the people of these times and accuse them, for she came from the ends of the earth to hear the wisdom of Solomon; and here there is greater than Solomon."
,"32":"The people of Nineveh will rise up on Judgment Day with the people of these times and accuse them, for Jonah's preaching made them turn from their sins, and here there is greater than Jonah."
,"33":"You do not light a lamp to hide it; rather you put it on a lampstand so that people coming in may see the light."
,"34":"Your eye is the lamp of your body. If your eye sees clearly, your whole person benefits from the light; but if your eyesight is poor, your whole person is without light."
,"35":"So be careful lest the light inside you become darkness."
,"36":"If your whole person receives the light, having no part that is dark, you will become light, as when a lamp shines on you.'"
,"37":"As Jesus was speaking, a Pharisee asked him to have a meal with him. So he went and sat at table."
,"38":"The Pharisee then wondered why Jesus did not first wash his hands before dinner."
,"39":"But the Lord said to him, 'So then, you Pharisees, you clean the outside of the cup and the dish, but inside yourselves you are full of greed and evil."
,"40":"Fools! He who made the outside, also made the inside."
,"41":"But according to you, by the mere giving of alms everything is made clean."
,"42":"A curse is on you, Pharisees; for the Temple you give a tenth of all, including mint and rue and the other herbs, but you neglect justice and the love of God. This ought to be practiced, without neglecting the other."
,"43":"A curse is on you, Pharisees, for you love the best seats in the synagogues and to be greeted in the marketplace."
,"44":"A curse is on you for you are like tombstones of the dead which can hardly be seen; people don't notice them and make themselves unclean by stepping on them.'"
,"45":"Then a teacher of the Law spoke up and said, 'Master, when you speak like this, you insult us, too.'"
,"46":"And Jesus answered, 'A curse is on you also, teachers of the Law. For you prepare unbearable burdens and load them on the people, while you yourselves don't move a finger to help them."
,"47":"A curse is on you, for you build memorials to the prophets your ancestors killed."
,"48":"So you approve and agree with what your ancestors did. Is it not so? They got rid of the prophets, and now you can build!'"
,"49":"(The Wisdom of God also said,) 'I will send prophets and apostles and this people will kill and persecute some of them."
,"50":"But the present generation will have to answer for the blood of all the prophets that has been shed since the foundation of the world,"
,"51":"from the blood of Abel to the blood of Zechariah, who was murdered between the altar and the sanctuary. Yes, I tell you, the people of this time will have to answer for them all."
,"52":"A curse is on you, teachers of the Law, for you have taken the key of knowledge. You yourselves have not entered, and you prevented others from entering.'"
,"53":"As Jesus left that place, the teachers of the Law and the Pharisees began to harass him,"
,"54":"asking him endless questions, setting traps to catch him in something he might say."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Meanwhile, such a numerous crowd had gathered that they crushed one another. Then Jesus spoke to his disciples in this way, 'Beware of the yeast of the Pharisees which is hypocrisy."
,"2":"Nothing is covered that will not be uncovered, or hidden that will not be made known."
,"3":"Whatever you have said in the darkness will be heard in daylight, and what you have whispered in hidden places, will be proclaimed from the housetops."
,"4":"I tell you, my friends, do not fear those who put to death the body and after that can do no more."
,"5":"But I will tell you whom to fear: Fear the One who after killing you is able to throw you into hell. This one you must fear."
,"6":"Don't you get five sparrows for two pennies? Yet not one of them has been forgotten by God."
,"7":"Even the hairs of your head have been numbered. So do not fear: are you not worth more than a flock of sparrows?"
,"8":"I tell you, whoever acknowledges me before people, the Son of Man will also acknowledge before the angels of God."
,"9":"But the one who denies me before others will be denied before the angels of God."
,"10":"There will be pardon for the one who criticizes the Son of Man, but there will be no pardon for the one who slanders the Holy Spirit."
,"11":"When you are brought before the synagogues, governors and rulers, don't worry about how you will defend youself or what to say."
,"12":"For the Holy Spirit will teach you at that time what you have to say.'"
,"13":"Someone in the crowd spoke to Jesus, 'Master, tell my brother to share with me the family inheritance.'"
,"14":"He replied, 'My friend, who has appointed me as your judge or your attorney?'"
,"15":"Then Jesus said to the people, 'Be on your guard and avoid every kind of greed, for even though you have many possessions, it is not that which gives you life.'"
,"16":"And Jesus continued with this story, 'There was a rich man and his land had produced a good harvest."
,"17":"He thought: 'What shall I do? For I am short of room to store my harvest.'"
,"18":"So this is what he planned: 'I will pull down my barns and build bigger ones to store all this grain, which is my wealth."
,"19":"Then I may say to myself: My friend, you have a lot of good things put by for many years. Rest, eat, drink and enjoy yourself.'"
,"20":"But God said to him: 'You fool! This very night your life will be taken from you; tell me who shall get all you have put aside?'"
,"21":"This is the lot of the one who stores up riches instead of amassing for God.'"
,"22":"Then Jesus said to his disciples, 'I tell you not to worry about your life: What are we to eat? Or about your body: What are we to wear?"
,"23":"For life is more than food and the body more than clothing."
,"24":"Look at the crows: they neither sow nor reap; they have no storehouses and no barns; yet God feeds them. How much more important are you than birds!"
,"25":"Which of you for all your worrying can add a moment to your span of life?"
,"26":"And if you are not able to control such a small thing, why do you worry about the rest?"
,"27":"Look at the wild flowers: they do not spin or weave; but I tell you, even Solomon with all his wealth was not clothed as one of these."
,"28":"If God so clothes the grass in the fields, which is alive today and tomorrow is thrown into the oven, how much more will he clothe you, people of little faith."
,"29":"Do not set your heart on what you are to eat and drink; stop worrying."
,"30":"Let all the nations of the world run after these things; your Father knows that you need them."
,"31":"Seek rather the Kingdom and these things will be given to you as well."
,"32":"Do not be afraid, little flock, for it has pleased your Father to give you the kingdom."
,"33":"Sell what you have and give alms. Get yourselves purses that do not wear out, and make safe investments with God, where no thief comes and no moth destroys."
,"34":"For where your investments are, there will your heart be also."
,"35":"Be ready, dressed for service, and keep your lamps lit,"
,"36":"like people waiting for their master to return from the wedding. As soon as he comes and knocks, they will open to him."
,"37":"Happy are those servants whom the master finds wide awake when he comes."
,"38":"Truly, I tell you, he will put on an apron and have them sit at table and he will wait on them. Happy are those servants if he finds them awake when he comes at midnight or daybreak!"
,"39":"Pay attention to this: If the master of the house had known at what time the thief would come, he would not have let his house be broken into."
,"40":"You also must be ready, for the Son of Man will come at an hour you do not expect.'"
,"41":"Peter said, 'Lord, did you tell this parable only for us, or for everyone?'"
,"42":"And the Lord replied, 'Imagine, then, the wise and faithful steward whom the master sets over his other servants to give them food rations at the proper time."
,"43":"Fortunate is this servant if his master on coming home finds him doing his work."
,"44":"Truly, I say to you, the master will put him in charge of all his property."
,"45":"But it may be that the steward thinks: 'My Lord delays in coming,' and he begins to abuse the menservants and the servant girls, eating and drinking and getting drunk."
,"46":"Then the master will come on a day he does not expect him and at an hour he doesn't know. He will discharge his servant and number him among the unreliable."
,"47":"The servant who knew his master's will, but did not prepare to do what his master wanted, will be punished with sound blows;"
,"48":"but the one who did what deserved a punishment without knowing it shall receive fewer blows. Much will be required of the one who has been given much, and more will be asked of the one entrusted with more."
,"49":"I have come to bring fire upon the earth and how I wish it were already kindled;"
,"50":"but I have a baptism to undergo and what anguish I feel until it is over!"
,"51":"Do you think that I have come to bring peace on earth? No, I tell you, but rather division."
,"52":"From now on, in one house five will be divided; three against two, and two against three."
,"53":"They will be divided, father against son and son against father; mother against daughter and daughter against mother; mother-in-law against her daughter-in-law, and daughter-in-law against her mother-in-law.'"
,"54":"Jesus said to the crowds, 'When you see a cloud rising in the west, you say at once: 'A shower is coming.' And so it happens."
,"55":"And when the wind blows from the south, you say: 'It will be hot'; and so it is."
,"56":"You superficial people! You understand the signs of the earth and the sky, but you don't understand the present times."
,"57":"And why do you not judge for yourselves what is fit?"
,"58":"When you go with your accuser before the court, try to settle the case on the way, lest you he drag before the judge and the judge deliver you to the jailer, and the jailer throw you in prison."
,"59":"I tell you, you will not get out until you have paid the very last penny.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"One day some persons told Jesus what had occurred in the Temple: Pilate had Galileans killed and their blood mingled with the blood of their sacrifices."
,"2":"Jesus replied, 'Do you think that these Galileans were worse sinners than all the other Galileans because they suffered this?"
,"3":"I tell you: no. But unless you change your ways, you will all perish as they did."
,"4":"And those eighteen persons in Siloah who were crushed when the tower fell, do you think they were more guilty than all the others in Jerusalem?"
,"5":"I tell you: no. But unless you change your ways, you will all perish as they did.'"
,"6":"And Jesus continued with this story, 'A man had a fig tree growing in his vineyard and he came looking for fruit on it, but found none."
,"7":"Then he said to the gardener: 'Look here, for three years now I have been looking for figs on this tree and I have found none. Cut it down, why should it use up the ground?'"
,"8":"The gardener replied: 'Leave it one more year, so that I may dig around it and add some fertilizer;"
,"9":"and perhaps it will bear fruit from now on. But if it doesn't, you can cut it down.'"
,"10":"Jesus was teaching in a synagogue on the sabbath"
,"11":"and a crippled woman was there. An evil spirit had kept her bent for eighteen years so that she could not straighten up at all."
,"12":"On seeing her, Jesus called her and said, 'Woman, you are freed from your infirmity.'"
,"13":"Then he laid his hands upon her and immediately she was made straight and praised God."
,"14":"But the ruler of the synagogue was indignant because Jesus had performed this healing on the sabbath day and he said to the people, 'There are six days in which to work; come on those days to be healed and not on the sabbath.'"
,"15":"But the Lord replied, 'You hypocrites! Everyone of you unties his ox or his donkey on the sabbath and leads it out of the barn to give it water."
,"16":"And here you have a daughter of Abraham whom Satan had bound for eighteen years. Should she not be freed from her bonds on the sabbath?'"
,"17":"When Jesus said this, all his opponents felt ashamed. But the people rejoiced at the many wonders that happened through him."
,"18":"Jesus continued speaking, 'What is the kingdom of God like? What shall I compare it to?"
,"19":"Imagine a person who has taken a mustard seed and planted it in the garden. The seed has grown and become like a small tree, so that the birds of the air shelter in its branches.'"
,"20":"And Jesus said again, 'What is the kingdom of God like?"
,"21":"Imagine a woman who has taken yeast and hidden it in three measures of flour until it is all leavened.'"
,"22":"Jesus went through towns and villages teaching and making his way to Jerusalem."
,"23":"Someone asked him, 'Lord, is it true that few people will be saved?',And Jesus answered, "
,"24":"'Do your best to enter by the narrow door, for many, I tell you, will try to enter and will not be able."
,"25":"When once the master of the house has got up and locked the door, you will stand outside; then you will knock at the door calling: 'Lord, open to us.' But he will say to you: 'I do not know where you come from.'"
,"26":"Then you will say: We ate and drank with you and you taught in our streets!"
,"27":"But he will reply: 'I don't know where you come from. Away from me all you workers of evil.'"
,"28":"You will weep and grind your teeth when you see Abraham and Jacob and all the prophets in the kingdom of God, and you yourselves left outside."
,"29":"Others will sit at table in the kingdom of God, people coming from east and west, from north and south."
,"30":"Some who are among the last will be the first, and others who were first will be last!'"
,"31":"At that time some Pharisees came to Jesus and gave him this warning, 'Leave this place and go on your way, for Herod wants to kill you.'"
,"32":"Jesus said to them, 'Go and give that fox my answer: 'I drive out demons and heal today and tomorrow, and on the third day I finish my course!'"
,"33":"Nevertheless, I must go on my way today and tomorrow and for a little longer, for it would not be fitting for a prophet to be killed outside Jerusalem."
,"34":"O Jerusalem, Jerusalem, you slay the prophets and stone your apostles! How often have I tried to bring together your children, as a bird gathers her young under her wings, but you refused!"
,"35":"From now on you will be left with your temple and you will no longer see me until the time when you will say: Blessed is he who comes in the name of the Lord.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"One sabbath Jesus had gone to eat a meal in the house of a leading Pharisee, and he was carefully watched."
,"2":"In front of him was a man suffering from dropsy;"
,"3":"so Jesus asked the teachers of the Law and the Pharisees, 'Is it lawful to heal on the sabbath or not?'"
,"4":"But no one answered. Jesus then took the man, healed him and sent him away."
,"5":"And he addressed them, 'If your lamb or your ox falls into a well on a sabbath day, who among you doesn't hurry to pull it out?'"
,"6":"And they could not answer."
,"7":"Jesus then told a parable to the guests, for he had noticed how they tried to take the places of honor. And he said,"
,"8":"'When you are invited to a wedding party, do not choose the best seat. It may happen that someone more important than you has been invited,"
,"9":"and your host, who invited both of you, will come and say to you: 'Please give this person your place.' What shame is yours when you take the lowest seat!"
,"10":"Whenever you are invited, go rather to the lowest seat, so that your host may come and say to you: 'Friend, you must come up higher.' And this will be a great honor for you in the presence of all the other guests."
,"11":"For whoever makes himself out to be great will be humbled, and whoever humbles himself will be raised.'"
,"12":"Jesus also addressed the man who had invited him and said, 'When you give a lunch or a dinner, don't invite your friends, or your brothers and relatives and wealthy neighbors. For surely they will also invite you in return and you will be repaid."
,"13":"When you give a feast, invite instead the poor, the crippled, the lame and the blind."
,"14":"Fortunate are you then, because they can't repay you; you will be repaid at the Resurrection of the upright.'"
,"15":"Upon hearing these words, one of those at the table said to Jesus, 'Happy are those who eat at the banquet in the kingdom of God!'"
,"16":"Jesus replied, 'A man once gave a feast and invited many guests."
,"17":"When it was time for the feast he sent his servant to tell those he had invited to come, for everything was ready."
,"18":"But all alike began to make excuses. The first said: 'Please excuse me. I must go and see the piece of land I have just bought.'"
,"19":"Another said: 'I am sorry, but I am on my way to try out the five yoke of oxen I have just bought.'"
,"20":"Still another said, 'How can I come when I have just married?'"
,"21":"The servant returned alone and reported this to his master. Upon hearing the account, the master of the house flew into a rage and ordered his servant: 'Go out quickly into the streets and alleys of the town and bring in the poor, the crippled, the blind and the lame.'"
,"22":"The servant reported after a while: 'Sir, your orders have been carried out, but there is still room.'"
,"23":"The master said: 'Go out to the highways and country lanes and force people to come in, to make sure my house is full."
,"24":"I tell you, none of those invited will have a morsel of my feast.'"
,"25":"One day, when large crowds were walking along with Jesus, he turned and said to them,"
,"26":"'If you come to me, without being ready to give up your love for your father and mother, your spouse and children, your brothers and sisters, and indeed yourself, you cannot be my disciple."
,"27":"Whoever does not follow me carrying his own cross cannot be my disciple."
,"28":"Do you build a house without first sitting down to count the cost to see whether you have enough to complete it?"
,"29":"Otherwise, if you have laid the foundation and are not able to finish it, everyone will make fun of you:"
,"30":"'This fellow began to build and was not able to finish.'"
,"31":"And when a king wages war against another king, does he go to fight without first sitting down to consider whether his ten thousand can stand against the twenty thousand of his opponent?"
,"32":"And if not, while the other is still a long way off he sends messengers for peace talks."
,"33":"In the same way, none of you may become my disciple if he doesn't give up everything he has."
,"34":"However good the salt may be, if it has lost its taste, you cannot make it salty again."
,"35":"It is fit for neither soil nor manure. Let them throw it away. Listen then, if you have ears!'"
}`)
	CurrentBook.AddChapter(15, `{
"1":"Meanwhile tax collectors and sinners were seeking the company of Jesus, all of them eager to hear what he had to say."
,"2":"But the Pharisees and the scribes frowned at this, muttering. 'This man welcomes sinners and eats with them.'"
,"3":"So Jesus told them this parable:"
,"4":"'Who among you, having a hundred sheep and losing one of them, will not leave the ninety-nine in the wilderness and seek out the lost one till he finds it?"
,"5":"And finding it, will he not joyfully carry it home on his shoulders?"
,"6":"Then he will call his friends and neighbors together and say: 'Celebrate with me for I have found my lost sheep.'"
,"7":"I tell you, just so, there will be more rejoicing in heaven over one repentant sinner than over ninety-nine upright who do not need to repent."
,"8":"What woman, if she has ten silver coins and loses one, will not light a lamp and sweep the house in a thorough search till she finds the lost coin?"
,"9":"And finding it, she will call her friends and neighbors and say: 'Celebrate with me for I have found the silver coin I lost!'"
,"10":"I tell you, in the same way there is rejoicing among the angels of God over one repentant sinner.'"
,"11":"Jesus continued, 'There was a man with two sons."
,"12":"The younger said to his father: 'Give me my share of the estate.' So the father divided his property between them."
,"13":"Some days later, the younger son gathered all his belongings and started off for a distant land where he squandered his wealth in loose living."
,"14":"Having spent everything, he was hard pressed when a severe famine broke out in that land."
,"15":"So he hired himself out to a well-to-do citizen of that place and was sent to work on a pig farm."
,"16":"So famished was he that he longed to fill his stomach even with the food given to the pigs, but no one offered him anything."
,"17":"Finally coming to his senses, he said: 'How many of my father's hired workers have food to spare, and here I am starving to death!"
,"18":"I will get up and go back to my father and say to him: Father, I have sinned against God and before you."
,"19":"I no longer deserve to be called your son. Treat me then as one of your hired servants.' With that thought in mind he set off for his father's house."
,"20":"He was still a long way off when his father caught sight of him. His father was so deeply moved with compassion that he ran out to meet him, threw his arms around his neck and kissed him."
,"21":"The son said: 'Father, I have sinned against Heaven and before you. I no longer deserve to be called your son...'"
,"22":"But the father turned to his servants: 'Quick! Bring out the finest robe and put it on him. Put a ring on his finger and sandals on his feet."
,"23":"Take the fattened calf and kill it. We shall celebrate and have a feast,"
,"24":"for this son of mine was dead and has come back to life. He was lost and is found.' And the celebration began."
,"25":"Meanwhile, the elder son had been working in the fields. As he returned and was near the house, he heard the sound of music and dancing."
,"26":"He called one of the servants and asked what it was all about."
,"27":"The servant answered: 'Your brother has come home safe and sound, and your father is so happy about it that he has ordered this celebration and killed the fattened calf.'"
,"28":"The elder son became angry and refused to go in. His father came out and pleaded with him."
,"29":"The indignant son said: 'Look, I have slaved for you all these years. Never have I disobeyed your orders. Yet you have never given me even a young goat to celebrate with my friends."
,"30":"Then when this son of yours returns after squandering your property with loose women, you kill the fattened calf for him.'"
,"31":"The father said: 'My son, you are always with me, and everything I have is yours."
,"32":"But this brother of yours was dead, and has come back to life. He was lost and is found. And for that we had to rejoice and be glad.''"
}`)
	CurrentBook.AddChapter(16, `{
"1":"At another time Jesus told his disciples, 'There was a rich man whose steward was reported to him for fraudulent service."
,"2":"He summoned the steward and asked him: 'What is this I hear about you? I want you to render an account of your service for it is about to be terminated.'"
,"3":"The steward thought to himself: 'What am I to do now? My master will surely dismiss me. I am not strong enough to do hard work, and I am ashamed to beg."
,"4":"I know what I will do: I must make sure that when I am dismissed, there will be some people to welcome me into their house.'"
,"5":"So he called his master's debtors one by one. He asked the first who came: 'How much do you owe my master?'"
,"6":"The reply was: 'A hundred jars of oil.' The steward said: 'Here is your bill. Sit down quickly and write there fifty.'"
,"7":"To the second he put the same question: 'How much do you owe?' The answer was: 'A thousand bushels of wheat.' Then he said: 'Take your bill and write eight hundred.'"
,"8":"The master commended the dishonest steward for his astuteness. For the people of this world are more astute in dealing with their own kind than are the people of light."
,"9":"And so I tell you: use filthy money to make friends for yourselves, so that when it fails, these people may welcome you into the eternal homes."
,"10":"Whoever can be trusted in little things can also be trusted in great ones; whoever is dishonest in slight matters will also be dishonest in greater ones."
,"11":"So if you have not been trustworthy in handling filthy money, who could entrust you with true wealth?"
,"12":"And if you have not been trustworthy with things which are not really yours, who will give you the wealth which is your own?"
,"13":"No servant can serve two masters. Either he does not like the one and is fond of the other, or he regards one highly and the other with contempt. You cannot give yourself both to God and to Money.'"
,"14":"The Pharisees, who loved money, heard all this and sneered at Jesus."
,"15":"He said to them, 'You do your best to be considered righteous by people. But God knows the heart, and what rises high among humans is loathed by God."
,"16":"The time of the Law and the Prophets has ended with John. Then comes the proclamation of the kingdom of God and this is the time for everyone to conquer it."
,"17":"It is easier for heaven and earth to pass away than for a single letter of Scripture not to be fulfilled."
,"18":"Anyone who divorces his wife and marries another commits adultery; and whoever marries a woman divorced by her husband also commits adultery."
,"19":"Once there was a rich man who dressed in purple and fine linen and feasted every day."
,"20":"At his gate lay Lazarus, a poor man covered with sores,"
,"21":"who longed to eat just the scraps falling from the rich man's table. Even dogs used to come and lick his sores."
,"22":"It happened that the poor man died and angels carried him to take his place with Abraham. The rich man also died and was buried."
,"23":"From hell where he was in torment, he looked up and saw Abraham afar off, and with him Lazarus at rest."
,"24":"He called out: 'Father Abraham, have pity on me and send Lazarus with the tip of his finger dipped in water to cool my tongue, for I suffer so much in this fire.'"
,"25":"Abraham replied: 'My son, remember that in your lifetime you were well-off while the lot of Lazarus was misfortune. Now he is in comfort and you are in agony."
,"26":"But that is not all. Between your place and ours a great chasm has been fixed, so that no one can cross over from here to you or from your side to us.'"
,"27":"The rich man implored once more: 'Then I beg you, Father Abraham, to send Lazarus to my father's house"
,"28":"where my five brothers live. Let him warn them so that they may not end up in this place of torment.'"
,"29":"Abraham replied: 'They have Moses and the prophets. Let them listen to them.'"
,"30":"But the rich man said: 'No, Father Abraham. But if someone from the dead goes to them, they will repent.'"
,"31":"Abraham said: 'If they will not listen to Moses and the prophets, they will not be convinced even if someone rises from the grave.''"
}`)
	CurrentBook.AddChapter(17, `{
"1":"Jesus said to his disciples, 'Scandals will necessarily come and cause people to fall; but woe to the one who has brought it about."
,"2":"It would be better for that one to be thrown into the sea with a millstone around the neck. Truly this would be better for that person than to cause one of these little ones to fall."
,"3":"Be careful. If your brother offends you, rebuke him and if he is sorry, forgive him."
,"4":"And if he offends you seven times in a day but says to you seven times: 'I'm sorry,' forgive him.'"
,"5":"The apostles said to the Lord, 'Increase our faith.' And the Lord said,"
,"6":"'If you have faith even the size of a mustard seed, you may say to this tree: 'Be uprooted and plant yourself in the sea,' and it will obey you."
,"7":"Who among you would say to your servant coming in from the fields after plowing or tending sheep: 'Come at once and sit down at table'?"
,"8":"No, you tell him: 'Prepare my dinner. Put on your apron and wait on me while I eat and drink; you can eat and drink afterwards.'"
,"9":"Do you thank this servant for doing what you commanded?"
,"10":"So for you. When you have done all that you have been told to do, you must say: 'We are no more than servants; we have only done our duty.''"
,"11":"On the way to Jerusalem, Jesus was passing along the border between Samaria and Galilee, and"
,"12":"as he entered a village, ten lepers came to meet him."
,"13":"Keeping their distance, they called to him, 'Jesus, Master, have pity on us!'"
,"14":"Then Jesus said to them, 'Go and show yourselves to the priests.' Now, as they went their way, they found they were cured."
,"15":"One of them, as soon as he saw he was cleansed, turned back praising God in a loud voice, and"
,"16":"throwing himself on his face before Jesus, he gave him thanks. This man was a Samaritan."
,"17":"Then Jesus said, 'Were not all ten healed? Where are the other nine?"
,"18":"Was no one found to return and give praise to God but this alien?'"
,"19":"And Jesus said to him, 'Stand up and go your way; your faith has saved you.'"
,"20":"The Pharisees asked Jesus when the kingdom of God was to come. He answered, 'The kingdom of God is not like something you can observe"
,"21":"and say of it: 'Look, here it is! There it is!' See, the kingdom of God is among you.'"
,"22":"And Jesus said to his disciples, 'The time is at hand when you will long to see one of the glorious days of the Son of Man, but you will not see it."
,"23":"Then people will tell you: 'Look there! Look here!' Do not go, do not follow them."
,"24":"As lightning flashes from one end of the sky to the other, so will it be with the Son of Man."
,"25":"But first he must suffer many things and be rejected by this people."
,"26":"As it was in the days of Noah, so will it be on the day the Son of Man comes."
,"27":"Then people ate and drank; they took husbands and wives. But on the day Noah entered the ark, the flood came and destroyed them all."
,"28":"Just as it was in the days of Lot: people ate and drank, they bought and sold, planted and built."
,"29":"But on the day Lot left Sodom, God made fire and sulfur rain down from heaven which destroyed them all."
,"30":"So will it be on the day the Son of Man is revealed."
,"31":"On that day, if you are on the rooftop, don't go down into the house to get your belongings, and if you happen to be in the fields, do not turn back."
,"32":"Remember Lot's wife."
,"33":"Whoever tries to save his life will lose himself, but whoever gives his life will be born again."
,"34":"I tell you, though two men are sharing the same bed, it may be that one will be taken and the other left."
,"35":"Though two women are grinding corn together, one may be taken and the other left.'"
,"37":"Then they asked Jesus, 'Where will this take place, Lord?' And he answered, 'Where the body is, there too will the vultures gather.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Jesus told them a parable to show them that they should pray continually and not lose heart."
,"2":"He said, 'In a certain town there was a judge who neither feared God nor people."
,"3":"In the same town was a widow who kept coming to him, saying: 'Defend my rights against my opponent.'"
,"4":"For a time he refused, but finally he thought: 'Even though I neither fear God nor care about people,"
,"5":"this widow bothers me so much I will see that she gets justice; then she will stop coming and wearing me out.'"
,"6":"And Jesus explained, 'Listen to what the evil judge says."
,"7":"Will God not do justice for his chosen ones who cry to him day and night even if he delays in answering them?"
,"8":"I tell you, he will speedily do them justice. Yet, when the Son of Man comes, will he find faith on earth?'"
,"9":"Jesus told another parable to some persons fully convinced of their own righteousness, who looked down on others,"
,"10":"'Two men went up to the Temple to pray; one was a Pharisee and the other a tax collector."
,"11":"The Pharisee stood by himself and said: 'I thank you, God, that I am not like other people, grasping, crooked, adulterous, or even like this tax collector."
,"12":"I fast twice a week and give the tenth of all my income to the Temple.'"
,"13":"In the meantime the tax collector, standing far off, would not even lift his eyes to heaven, but beat his breast saying: 'O God, be merciful to me, a sinner.'"
,"14":"I tell you, when this man went down to his house, he had been set right with God, but not the other. For whoever makes himself out to be great will be humbled, and whoever humbles himself will be raised.'"
,"15":"They even brought little children to Jesus to have him touch them; but then the disciples rebuked these people."
,"16":"So Jesus called the children to him and said, 'Let the children come to me and don't stop them, for the kingdom of God belongs to such as these."
,"17":"Truly, I tell you, whoever does not receive the kingdom of God like a child will not enter it.'"
,"18":"A ruler asked Jesus, 'Good master, what shall I do to inherit eternal life?'"
,"19":"Jesus said to him, 'Why do you call me good? No one is good but God alone."
,"20":"You know the commandments: Do not commit adultery, do not kill, do not steal, do not accuse falsely, honor your father and your mother.'"
,"21":"And the man said, 'I have kept all these commandments from my youth.'"
,"22":"Then Jesus answered, 'There is still one thing you lack. Sell all you have and give the money to the poor, and you will have riches in Heaven. And then come and follow me.'"
,"23":"When he heard these words, the man became sad for he was very rich."
,"24":"Jesus noticing this said, 'How hard it is for people who have riches to enter the kingdom of God!"
,"25":"It is easier for a camel to pass through the eye of a needle than for a rich person to enter the kingdom of God.'"
,"26":"The bystanders said, 'Who then can be saved?'"
,"27":"And Jesus replied, 'What is impossible for humans is possible for God.'"
,"28":"Then Peter said, 'We left everything we had and followed you.'"
,"29":"Jesus replied, 'Truly, I tell you, whoever has left house or wife, or brothers or parents or children for the sake of the kingdom of God,"
,"30":"will receive much more in this present time and eternal life in the world to come.'"
,"31":"Jesus then took the Twelve aside and told them, 'Now, we are going up to Jerusalem and everything the Prophets have written about the Son of Man will be fulfilled."
,"32":"He will be delivered up to the foreign power. People will mock him, insult him and spit on him."
,"33":"After they have scourged him, they will kill him, but he will be raised on the third day.'"
,"34":"The apostles could make nothing of this; the meaning of these words remained a mystery to them and they did not understand what he said."
,"35":"When Jesus drew near to Jericho, a blind man was sitting by the road, begging."
,"36":"As he heard the crowd passing by, he inquired what it was,"
,"37":"and they told him that Jesus of Nazareth was going by. Then he cried out,"
,"38":"'Jesus, Son of David, have mercy on me!'"
,"39":"The people in front scolded him, 'Be quiet!' but he cried out all the more, 'Jesus, Son of David, have mercy on me!'"
,"40":"Jesus stopped and ordered the blind man to be brought to him, and when he came near, he asked him,"
,"41":"'What do you want me to do for you?' And the man said, 'Lord, that I may see!'"
,"42":"Jesus said, 'Receive your sight, your faith has saved you.'"
,"43":"At once the blind man was able to see, and he followed Jesus, giving praise to God. And all the people who were there also praised God."
}`)
	CurrentBook.AddChapter(19, `{
"1":"When Jesus entered Jericho and was going through the city,"
,"2":"a man named Zaccheus was there. He was a tax collector and a wealthy man."
,"3":"He wanted to see what Jesus was like, but he was a short man and could not see because of the crowd."
,"4":"So he ran ahead and climbed up a sycamore tree. From there he would be able to see Jesus who had to pass that way."
,"5":"When Jesus came to the place, he looked up and said to him, 'Zaccheus, come down quickly for I must stay at your house today.'"
,"6":"So Zaccheus hurried down and received him joyfully."
,"7":"All the people who saw it began to grumble and said, 'He has gone to the house of a sinner as a guest.'"
,"8":"But Zaccheus spoke to Jesus, 'The half of my goods, Lord, I give to the poor, and if I have cheated anyone, I will pay him back four times as much.'"
,"9":"Looking at him Jesus said, 'Salvation has come to this house today, for he is also a true son of Abraham."
,"10":"The Son of Man has come to seek and to save the lost.'"
,"11":"Jesus was now near Jerusalem and the people with him thought that God's reign was about to appear. So as they were listening to him, Jesus went on to tell them a parable."
,"12":"He said, 'A man of noble birth went to a distant place to have himself appointed king of his own people, after which he would return."
,"13":"Before he left, he summoned ten of his servants and gave them ten pounds. He said: 'Put this money to work until I get back.'"
,"14":"But his compatriots who disliked him sent a delegation after him with this message: 'We do not want this man to be our king.'"
,"15":"He returned, however, appointed as king. At once he sent for the servants to whom he had given the money, to find out what profit each had made."
,"16":"The first came in and reported: 'Sir, your pound has earned ten more.'"
,"17":"The master replied: 'Well done, my good servant. Since you have proved yourself capable in a small matter, I can trust you to take charge of ten cities.'"
,"18":"The second reported: 'Sir, your pound earned five more pounds.'"
,"19":"The master replied: 'Right, take charge of five cities.'"
,"20":"The third came in and said: 'Sir, here is your money which I hid for safekeeping."
,"21":"I was afraid of you for you are an exacting person; you take up what you did not lay down and reap what you did not sow.'"
,"22":"The master replied: 'You worthless servant, I will judge you by your own words. So you knew I was an exacting person, taking up what I did not lay down and reaping what I did not sow!"
,"23":"Why, then, did you not put my money on loan so that when I got back I could have collected it with interest?'"
,"24":"Then the master said to those standing by: 'Take from him that pound, and give it to the one with ten pounds.'"
,"25":"They objected: 'But, sir, he already has ten!'"
,"26":"'I tell you: everyone who has will be given more; but from those who have nothing, even what they have will be taken away."
,"27":"As for my enemies who did not want me to be king, bring them in and execute them right here in my presence.''"
,"28":"So Jesus spoke, and he went on ahead of them, on his way to Jerusalem."
,"29":"When he drew near to Bethphage and Bethany, close to Mount Olivet, he sent two of the disciples with these instructions,"
,"30":"'Go to the village opposite and as you enter it you will find a colt tied up that no one has yet ridden: untie it and bring it here."
,"31":"And if anyone says to you: 'Why are you untying this colt?' You shall give this answer: 'The Master needs it.''"
,"32":"So the two disciples went and found things just as Jesus had said."
,"33":"As they were untying the colt, the owner said to them, 'Why are you untying the colt?'"
,"34":"And they answered, 'The Master needs it.'"
,"35":"So they brought it to Jesus and throwing their cloaks on the colt, they mounted Jesus on it."
,"36":"And as he went down, people spread their cloaks on the road."
,"37":"When Jesus came near Jerusalem, at the place where the road slopes down from the Mount of Olives, the whole multitude of his disciples began to rejoice and praise God with a loud voice for all the miracles they had seen,"
,"38":"and they cried out, 'Blessed is he who comes as king in the name of the Lord. Peace in heaven and Glory in the highest heavens.'"
,"39":"Some Pharisees in the crowd said to him, 'Master, rebuke your disciples.'"
,"40":"But Jesus answered, 'I tell you, if they were to remain silent, the stones would cry out.'"
,"41":"When Jesus had come in sight of the city, he wept over it"
,"42":"and said, 'If only today you knew the ways of peace! But now your eyes are held from seeing."
,"43":"Yet days will come upon you when your enemies will surround you with barricades and shut you in and press on you from every side."
,"44":"And they will dash you to the ground and your children with you, and leave not a stone within you, for you did not recognize the time and the visitation of your God.'"
,"45":"Then Jesus entered the Temple area and began to drive out the merchants."
,"46":"And he said to them, 'God says in the Scriptures: My house shall be a house of prayer: but you have turned it into a den of robbers.'"
,"47":"Jesus was teaching every day in the Temple. The chief priests and teachers of the Law wanted to kill him and the elders of the Jews as well,"
,"48":"but they were unable to do anything, for all the people were listening to him and hanging on his words."
}`)
	CurrentBook.AddChapter(20, `{
"1":"One day when Jesus was teaching the people in the Temple and proclaiming the good news, the chief priests and the teachers of the Law came with the elders of the Jews,"
,"2":"and said to him, 'Tell us, what right have you to act like this? Who gives you authority to do all this?'"
,"3":"Jesus said to them, 'I also will ask you a question; tell me:"
,"4":"Was John's preaching and baptism a work of God, or was it merely something human?'"
,"5":"And they argued among themselves, 'If we answer that it was a work of God, he will say: 'Why then did you not believe him?'"
,"6":"But if we answer that it was merely something human, all the people will stone us, for they all regard John as a prophet.'"
,"7":"So they answered Jesus, 'We don't know,'"
,"8":"and Jesus said to them, 'Neither will I tell you what right I have to act like this.'"
,"9":"Jesus went on to tell the people this parable, 'A man planted a vineyard and let it out to tenants before going abroad for a long time."
,"10":"In due time he sent a servant to the tenants to get some fruit from the vineyard. But the tenants beat him and sent him back empty-handed."
,"11":"Again the man sent another servant; they beat him as well and treated him shamefully and finally sent him away empty-handed."
,"12":"The owner then sent a third, but this one was wounded and thrown out."
,"13":"The owner then thought: 'What shall I do? I will send my beloved son; surely they will respect him.'"
,"14":"The tenants, however, as soon as they had seen him, said to one another: 'This is the one who will inherit the vineyard; let us kill him and the property will be ours.'"
,"15":"So they threw him out of the vineyard and killed him."
,"16":"Now, what will the owner of the vineyard do to them? He will come and destroy those tenants and give the vineyard to others.',On hearing this, some of the rulers said, 'May it not be so!' "
,"17":"Then Jesus looked directly at them and said, 'What does this text of the Scriptures mean: The stone which the builders rejected has become the keystone."
,"18":"Everyone who falls on that stone will be broken to pieces and anyone the stone falls on will be crushed?'"
,"19":"The teachers of the Law and the chief priests would have liked to arrest him right there, for they realized that Jesus meant this parable for them, but they were afraid of the crowd."
,"20":"So they left, looking for another opportunity. They sent spies who pretended to be honest, in order to trap him in his words and deliver him to the authority and power of the Roman governor."
,"21":"They asked him, 'Master, we know that you are true in your words and your teaching, and your answers do not vary according to who is listening to you, for you truly teach the way of God. Tell us:"
,"22":"are we allowed to pay taxes to Caesar or not?'"
,"23":"But Jesus saw through their cunning and said,"
,"24":"'Show me a silver coin. Whose head is this and whose name?' They answered, 'Caesar's.'"
,"25":"And Jesus said to them 'Return to Caesar the things that are Caesar's and to God what is God's.'"
,"26":"So they were unable to trap him in what he said in public: they were surprised at his answer and kept silent."
,"27":"Then some Sadducees arrived. These people claim that there is no resurrection"
,"28":"and they asked Jesus this question, 'Master, in the Scripture Moses told us: 'If anyone dies leaving a wife but no children, his brother must take the wife, and the child to be born will be regarded as the child of the deceased man.'"
,"29":"Now, there were seven brothers; the first married a wife, but he died without children;"
,"30":"and the second"
,"31":"and the third took the wife; in fact all seven died leaving no children."
,"32":"Last of all the woman died."
,"33":"On the day of the resurrection, to which of them will the woman be wife? For the seven had her as wife.'"
,"34":"And Jesus replied, 'Taking husband or wife is proper to people of this world,"
,"35":"but for those who are considered worthy of the world to come and of resurrection from the dead, there is no more marriage."
,"36":"Besides, they cannot die for they are like the angels. They too are sons and daughters of God because they are born of the resurrection."
,"37":"Yes, the dead will be raised, and even Moses implied it in the passage about the burning bush, where he calls the Lord the God of Abraham, the God of Isaac and the God of Jacob."
,"38":"For he is God of the living and not of the dead, and for him all are alive.'"
,"39":"Some teachers of the Law then agreed with Jesus, 'Master, you have spoken well.'"
,"40":"They didn't dare to ask him anything else."
,"41":"Then Jesus said to them, 'How can people say that the Messiah is the son of David?"
,"42":"For David says in the book of Psalms: The Lord said to my Lord: Sit at my right"
,"43":"until I put your enemies under your feet."
,"44":"David here calls him Lord; how then can he be his son?'"
,"45":"Jesus also said to his disciples before all the people,"
,"46":"'Beware of these teachers of the Law who like to be seen in long robes and love to be greeted in the marketplaces and to take the reserved seats in the synagogues and places of honor at feasts."
,"47":"They even devour the property of widows while making a show of long prayers. They will receive a very severe sentence!'"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Jesus looked up and saw rich people putting their gifts into the treasure box;"
,"2":"he also saw a poor widow dropping in two small coins."
,"3":"And he said, 'Truly, I tell you, this poor widow put in more than all of them."
,"4":"For all gave an offering from their plenty, but she, out of her poverty, gave all she had to live on.'"
,"5":"While some people were talking about the Temple, remarking that it was adorned with fine stonework and rich gifts, Jesus said to them,"
,"6":"'The days will come when there shall not be left one stone upon another of all that you now admire; all will be torn down.'"
,"7":"And they asked him, 'Master, when will this be, and what will be the sign that this is about to take place?'"
,"8":"Jesus then said, 'Take care not to be deceived, for many will come claiming my title and saying: 'I am he, the Messiah; the time is at hand.' Do not follow them."
,"9":"When you hear of wars and troubled times, don't be frightened; for all this must happen first, even though the end is not so soon.'"
,"10":"And Jesus said, 'Nations will fight each other and kingdom will oppose kingdom."
,"11":"There will be great earthquakes, famines and plagues; in many places strange and terrifying signs from heaven will be seen."
,"12":"Before all this happens, people will lay their hands on you and persecute you; you will be delivered to the Jewish courts and put in prison, and for my sake you will be brought before kings and governors."
,"13":"This will be your opportunity to bear witness."
,"14":"So keep this in mind: do not worry in advance about what to answer,"
,"15":"for I will give you words and wisdom that none of your opponents will be able to withstand or contradict."
,"16":"You will be betrayed even by parents, and brothers, by relatives and friends, and some of you will be put to death."
,"17":"But even though you are hated by all for my name's sake,"
,"18":"not a hair of your head will perish."
,"19":"Through perseverance you will possess your own selves."
,"20":"When you see Jerusalem surrounded by armies, then you must know that the time has come when it will be reduced to a wasteland."
,"21":"Then, if you are in Judea, flee to the mountains; if you are in the city, leave it; and let those who are in the fields not return to the city."
,"22":"For these will be the days of its punishment and all that was announced in the Scripture will be fulfilled."
,"23":"How hard will it be for pregnant women and for mothers with babies at the breast! For a great calamity will come upon the land, and divine justice upon this people."
,"24":"They will be put to death by the sword or taken as slaves to other nations; and Jerusalem will be trampled upon by the pagans until the time of the pagans is fulfilled."
,"25":"Then there will be signs in sun and moon and stars, and on the earth anguish of perplexed nations when they hear the roaring of the sea and its waves."
,"26":"People will faint with fear at the mere thought of what is to come upon the world, for the forces of the universe will be shaken."
,"27":"And at this time they will see the Son of Man coming in a cloud with power and great glory."
,"28":"Now, when you see the first events, stand erect and lift up your heads, for your deliverance is drawing near.'"
,"29":"And Jesus added this comparison, 'Look at the fig tree and all the trees."
,"30":"As soon as their buds sprout, you know that summer is already near."
,"31":"In the same way, as soon as you see these things happening, you know that the kingdom of God is near."
,"32":"Truly, I tell you, this generation will not pass away, until all this has happened:"
,"33":"heaven and earth will pass away, but my words will not pass away."
,"34":"Be on your guard; let not your hearts be weighed down with a life of pleasure, drunkenness and worldly cares, lest that day catch you suddenly as a trap."
,"35":"For it will come upon all the inhabitants of the whole earth."
,"36":"But watch at all times and pray, that you may be able to escape all that is bound to happen and to stand before the Son of Man.'"
,"37":"In the daytime Jesus used to teach in the Temple; then he would leave the city and pass the night on the mount of Olives."
,"38":"And early in the morning the people would come to the Temple to hear him."
}`)
	CurrentBook.AddChapter(22, `{
"1":"The feast of Unleavened Bread which is called the Passover, was now drawing near,"
,"2":"and the chief priests and the teachers of the Law wanted to kill Jesus. They were looking for a way to do this because they were afraid of the people."
,"3":"Then Satan entered into Judas, called Iscariot, one of the Twelve,"
,"4":"and he went off to discuss with the chief priests and the officers of the guard how to deliver Jesus to them."
,"5":"They were delighted and agreed to give him money;"
,"6":"so he accepted, and from that time he waited for an opportunity to betray him without the people knowing."
,"7":"Then came the feast of the Unleavened Bread in which the Passover lamb had to be sacrificed."
,"8":"So Jesus sent Peter and John saying, 'Go and get everything ready for us to eat the Passover meal.'"
,"9":"They asked him, 'Where do you want us to prepare it?'"
,"10":"And he said, 'When you enter the city, a man will come to you carrying a jar of water. Follow him to the house he enters"
,"11":"and say to the owner: 'The master asks: where is the room where I may take the Passover meal with my disciples?'"
,"12":"He will show you a large, furnished room upstairs, and there you will prepare for us.'"
,"13":"Peter and John went off and having found everything just as Jesus had told them, they prepared the Passover meal."
,"14":"When the hour came, Jesus took his place at table and the apostles with him."
,"15":"And he said to them, 'I was eager to eat this passover with you before I suffer;"
,"16":"for, I tell you, I shall not eat it again until it is fulfilled in the kingdom of God.'"
,"17":"Then they passed him a cup and when he had given thanks he said, 'Take this and share it among yourselves:"
,"18":"for I tell you that from now on I will not drink of the grape of the vine until the kingdom of God comes.'"
,"19":"Jesus also took bread, and after giving thanks, he broke it and gave it to them saying, 'This is my body which is given for you. Do this in remembrance of me.'"
,"20":"And he did the same with the cup after eating, 'This cup is the new covenant, sealed in my blood which is poured out for you."
,"21":"Yet the hand of the traitor is with me on the table."
,"22":"Know that the Son of Man is going the way marked out for him. But alas for that one who betrays him!'"
,"23":"They began to ask one another which of them could do such a thing."
,"24":"They also began to argue among themselves which of them should be considered the most important."
,"25":"And Jesus said, 'The kings of the pagan nations rule over them as lords, and the most hard-hearted rulers claim the title, 'Gracious Lord.'"
,"26":"But not so with you; let the greatest among you become as the youngest, and the leader as the servant."
,"27":"For who is the greatest, he who sits at the table or he who serves? He who is seated, isn't it? Yet I am among you as the one who serves."
,"28":"You are the ones who have been with me and stood by me through my troubles;"
,"29":"because of this, just as the kingship has been given to me by my Father, so I give it to you."
,"30":"You will eat and drink at my table in my kingdom, and you will sit on thrones and govern the twelve tribes of Israel."
,"31":"Simon, Simon, Satan has demanded to sift you like grain,"
,"32":"but I have prayed for you that your faith may not fail. And when you have recovered you shall strengthen your brothers.'"
,"33":"Then Peter said, 'Lord, with you I am ready to go even to prison and death.'"
,"34":"But Jesus replied, 'I tell you, Peter, the cock will not crow this day before you have denied three times that you know me.'"
,"35":"Jesus also said to them, 'When I sent you without purse or bag or sandals, were you short of anything?' They answered, 'No.'"
,"36":"And Jesus said to them, 'But now, the one who has a purse must take it, and a bag as well. And if anyone is without a sword, let him sell his cloak to buy one."
,"37":"For Scriptures says: He was numbered among criminals. These words had to be fulfilled in me, and now everything written about me is taking place."
,"38":"Then they said, 'See, Lord, here are two swords,' but he answered, 'That is enough.'"
,"39":"After this Jesus left to go as usual to Mount Olivet and the disciples followed him."
,"40":"When he came to the place, he told them, 'Pray that you may not be put to the test.'"
,"41":"Then he went a little further, about a stone's throw, and kneeling down he prayed,"
,"42":"'Father, if it is your will, remove this cup from me; still not my will but yours be done.'"
,"43":"And an angel from heaven appeared to give him strength."
,"44":"As he was in agony, he prayed even more earnestly and great drops of blood formed like sweat and fell to the ground."
,"45":"When he rose from prayer, he went to his disciples but found them worn out with grief, and asleep."
,"46":"And he said to them, 'Why do you sleep? Get up and pray, so that you may not be put to the test.'"
,"47":"Jesus was still speaking when a group appeared and the man named Judas, one of the Twelve, was leading them. He drew near to Jesus to kiss him,"
,"48":"and Jesus said to him, 'Did you need this kiss to betray the Son of Man?'"
,"49":"Those with Jesus seeing what would happen, said to him, 'Master, shall we use the sword?'"
,"50":"And one of them struck the High Priest's servant and cut off his right ear."
,"51":"But Jesus stopped him, 'No more of this.' He touched the man's ear and healed him."
,"52":"Then Jesus spoke to those coming against him, the chief priests, officers of the Temple and elders and he said to them, 'Did you really set out against a robber? Do you need swords and clubs to arrest me?"
,"53":"Day after day I was among you teaching in the Temple and you did not arrest me. But this is the hour of the power of darkness; this is your hour.'"
,"54":"Then they seized him and took him away, bringing him to the High Priest's house. Peter followed at a distance."
,"55":"A fire was kindled in the middle of the courtyard where people gathered, and Peter sat among them."
,"56":"A maidservant noticed him. Looking at him intently in the light of the fire, she exclaimed, 'This man also was with him!'"
,"57":"But he denied it, saying, 'Woman, I do not know him.'"
,"58":"A little later someone who saw him said, 'You are also one of them!' Peter replied, 'My friend, I am not!'"
,"59":"After about an hour another asserted, 'Surely this man was with him, for he is a Galilean.'"
,"60":"Again Peter denied, 'My friend, I don't know what you are talking about.' He had not finished saying this when a cock crowed."
,"61":"The Lord turned around and looked at Peter and he remembered the word that the Lord had spoken, 'Before the cock crows today you will have denied me three times.'"
,"62":"Peter went outside, weeping bitterly."
,"63":"Meanwhile the guards were mocking and beating Jesus."
,"64":"They blindfolded him, struck him and then asked, 'Who hit you? Tell us, prophet.'"
,"65":"And they hurled many other insulting words at him."
,"66":"At daybreak, the council of the elders of the people, among whom were the chief priests and the scribes, assembled again. Then they had Jesus brought before them, and they began questioning him:"
,"67":"'Tell us, are you the Christ?' Jesus replied, 'You will not believe if I tell you,"
,"68":"and neither will you answer if I ask you."
,"69":"Yet from now on the Son of Man will have his seat at the right hand of the Mighty God.'"
,"70":"In chorus they asked, 'So you are the Son of God?' And Jesus said to them, 'You are right, I am.'"
,"71":"Then they said, 'What need have we of witnesses? We have heard it from his own lips.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"The whole council rose and brought Jesus to Pilate."
,"2":"They gave their accusation: 'We found this man subverting our nation, opposing payment of taxes to Caesar, and claiming to be Christ the king.'"
,"3":"Pilate asked Jesus, 'Are you the King of the Jews?' Jesus replied, 'You said so.'"
,"4":"Turning to the chief priests and the crowd, Pilate said, 'I find no basis for a case against this man.'"
,"5":"But they insisted, 'All the country of the Jews is being stirred up with his teaching. He began in Galilee and now he has come all the way here.'"
,"6":"When Pilate heard this, he asked if the man was a Galilean."
,"7":"Finding the accused to come under Herod's jurisdiction, Pilate sent Jesus over to Herod who happened to be in Jerusalem at that time."
,"8":"Herod was delighted to have Jesus before him now; for a long time he had wanted to see him because of the reports about him, and he was hoping to see Jesus work some miracle."
,"9":"He piled up question upon question, but got no reply from Jesus."
,"10":"All the while the chief priests and the scribes remained standing there, vehemently pressing their accusations."
,"11":"Finally, Herod ridiculed him and with his guards mocked him. And when he had put a rich cloak on him, he sent him back to Pilate."
,"12":"Pilate and Herod who were enemies before, became friends from that day."
,"13":"Pilate then called together the chief priests and the elders before all the people,"
,"14":"and said to them, 'You have brought this man before me and accused him of subversion. In your presence I have examined him and found no basis for your charges."
,"15":"And neither has Herod, for he sent him back to me. It is quite clear that this man has done nothing that deserves a death sentence."
,"16":"I will therefore have him scourged and then release him.' ("
,"17":"On the Passover Pilate had to release a prisoner.)"
,"18":"Howling as one man, they protested: 'No! Away with this man! Release Barabbas instead.'"
,"19":"This man had been thrown into prison for an uprising in the city and for murder."
,"20":"Since Pilate wanted to release Jesus, he appealed to the crowd once more,"
,"21":"but they shouted back, 'To the cross with him! To the cross!'"
,"22":"A third time Pilate said to them, 'Why, what evil has he done? Since no crime deserving death has been proved, I shall have him scourged and let him go.'"
,"23":"But they went on shouting and demanding that Jesus be crucified, and their shouts grew louder."
,"24":"So Pilate decided to pass the sentence they demanded."
,"25":"He released the man they asked for, the one who was in prison for rebellion and murder, and he delivered Jesus in accordance with their wishes."
,"26":"When they led Jesus away, they seized Simon of Cyrene, who was coming in from the fields, and laid the cross on him, to carry it behind Jesus."
,"27":"A large crowd of people followed him; among them were women beating their breast and wailing for him,"
,"28":"but Jesus turned to them and said, 'Women of Jerusalem, do not weep for me, weep rather for yourselves and for your children."
,"29":"For the days are coming when people will say: 'Happy are the women without child! Happy are those who have not given birth or nursed a child!"
,"30":"And they will say to the mountains: Fall on us! And to the hills: Cover us!'"
,"31":"For if this is the lot of the green wood, what will happen to the dry?'"
,"32":"Along with Jesus, two criminals also were led out to be executed."
,"33":"There at the place called The Skull he was crucified together with the criminals - one on his right and another on his left. ("
,"34":"Jesus said, 'Father, forgive them for they do not know what they do.') And the guards cast lots to divide his clothes among themselves."
,"35":"The people stood by watching. As for the rulers, they jeered at him, saying to one another, 'Let the man who saved others now save himself, for he is the Messiah, the chosen one of God!'"
,"36":"The soldiers also mocked him and when they drew near to offer him bitter wine,"
,"37":"they said, 'So you are the king of the Jews? Free yourself!'"
,"38":"For above him was an inscription which read, 'This is the King of the Jews.'"
,"39":"One of the criminals hanging with Jesus insulted him, 'So you are the Messiah? Save yourself and us as well!'"
,"40":"But the other rebuked him, saying, 'Have you no fear of God, you who received the same sentence as he did?"
,"41":"For us it is just: this is payment for what we have done. But this man has done nothing wrong.'"
,"42":"And he said, 'Jesus, remember me when you come into your kingdom.'"
,"43":"Jesus replied, 'Truly, you will be with me today in paradise.'"
,"44":"It was now about noon."
,"45":"The sun was hidden and darkness came over the whole land until mid-afternoon; and at that time the curtain of the Sanctuary was torn in two."
,"46":"Then Jesus gave a loud cry, 'Father, into your hands I commend my spirit.' And saying that, he gave up his spirit."
,"47":"The captain on seeing what had happened, acknowledged the hand of God. He said, 'Surely this was an upright man.'"
,"48":"And all the people who had gathered to watch the spectacle, as soon as they saw what had happened went home beating their breasts."
,"49":"Only those who knew Jesus stood at a distance, especially the women who had followed him from Galilee; they witnessed all this."
,"50":"Then intervened a member of the Jewish supreme council, a good and righteous man named Joseph"
,"51":"from the Judean town of Arimathea. He had not agreed with the decision and action of his fellow members, for he lived uprightly in the hope of seeing the kingdom of God."
,"52":"He went to Pilate and asked for Jesus' body."
,"53":"He then took it down, wrapped it in a linen cloth and laid it in a yet unused tomb cut out of a rock."
,"54":"It was Preparation Day and the star which marks the beginning of the sabbath was shining."
,"55":"So the women who had come with Jesus from Galilee followed Joseph to see the tomb and how his body was being placed."
,"56":"And returning home, they prepared perfumes and ointments."
}`)
	CurrentBook.AddChapter(24, `{
"1":"On the sabbath the women rested according to the commandment, but the first day of the week, at dawn, they went to the tomb with the perfumes and ointments they had prepared."
,"2":"Seeing the stone rolled away from the opening of the tomb,"
,"3":"they entered and were puzzled to find that the body of the Lord Jesus was not there."
,"4":"Two men in dazzling garments appeared beside them."
,"5":"In fright the women bowed to the ground. But the men said, 'Why look for the living among the dead?"
,"6":"(You won't find him here. He is risen.)"
,"7":"Remember what he told you in Galilee, that the Son of Man had to be given into the hands of sinners, be crucified, and rise on the third day.'"
,"8":"And they recalled Jesus' words."
,"9":"Returning from the tomb, they informed the Eleven and their companions."
,"10":"Among the women who brought the news were Mary Magdalene, Joanna, and Mary the mother of James."
,"11":"But however much they insisted, those who heard did not believe the seemingly nonsensical story."
,"12":"Then Peter got up and ran to the tomb. All he saw there on bending down were the linen cloths. He went home wondering."
,"13":"That same day, two of them were going to Emmaus, a village seven miles from Jerusalem,"
,"14":"and they talked about what had happened."
,"15":"While they were talking and wondering, Jesus came up and walked with them,"
,"16":"but their eyes were held and they did not recognize him."
,"17":"He asked, 'What is this you are talking about?' The two stood still, looking sad."
,"18":"Then one named Cleophas answered, 'Why, it seems you are the only traveller in Jerusalem who doesn't know what has happened there these past few days.'"
,"19":"And he asked, 'What is it?',They replied, 'It is about Jesus of Nazareth. He was a prophet, you know, mighty in word and deed before God and the people."
,"20":"But the chief priests and our rulers sentenced him to death. They handed him over to be crucified."
,"21":"We had hoped that he would redeem Israel. It is now the third day since all this took place."
,"22":"It is true that some women of our group have disturbed us. When they went to the tomb at dawn,"
,"23":"they did not find his body; they came to tell us that they had seen a vision of angels who told them that Jesus was alive."
,"24":"Some friends of our group went to the tomb and found everything just as the women had said, but they did not see him.'"
,"25":"He said to them, 'How dull you are, how slow of understanding! You fail to believe the message of the prophets."
,"26":"Is it not written that the Christ should suffer all this and then enter his glory?'"
,"27":"Then starting with Moses and going through the prophets, he explained to them everything in the Scriptures concerning himself."
,"28":"As they drew near the village they were heading for, Jesus made as if to go farther."
,"29":"But they prevailed upon him, 'Stay with us, for night comes quickly. The day is now almost over.' So he went in to stay with them."
,"30":"When they were at table, he took the bread, said a blessing, broke it and gave each a piece."
,"31":"Then their eyes were opened, and they recognized him; but he vanished out of their sight."
,"32":"And they said to each other, 'Were not our hearts filled with ardent yearning when he was talking to us on the road and explaining the Scriptures?'"
,"33":"They immediately set out and returned to Jerusalem. There they found the Eleven and their companions gathered together."
,"34":"They were greeted by these words: 'Yes, it is true, the Lord is risen! He has appeared to Simon!'"
,"35":"Then the two told what had happened on the road and how Jesus made himself known when he broke bread with them."
,"36":"As they went on talking about this, Jesus himself stood in their midst. (And he said to them, 'Peace to you.')"
,"37":"In their panic and fright they thought they were seeing a ghost,"
,"38":"but he said to them, 'Why are you upset and why do such ideas cross your mind?"
,"39":"Look at my hands and feet and see that it is I myself. Touch me and see for yourselves that a ghost has no flesh and bones as I have.'"
,"40":"(As he said this, he showed his hands and feet.)"
,"41":"In their joy they didn't dare believe and were still astonished. So he said to them, 'Have you anything to eat?'"
,"42":"and they gave him a piece of broiled fish."
,"43":"He took it and ate it before them."
,"44":"Then Jesus said to them, 'Remember the words I spoke to you when I was still with you: Everything written about me in the Law of Moses, the Prophets and the Psalms had to be fulfilled.'"
,"45":"Then he opened their minds to understand the Scriptures. And he went on, "
,"46":"'You see what was written: the Messiah had to suffer and on the third day rise from the dead."
,"47":"Then repentance and forgiveness in his name would be proclaimed to all the nations, beginning from Jerusalem."
,"48":"Now you shall be witnesses to this."
,"49":"And this is why I will send you what my Father promised. So remain in the city until you are invested with power from above.'"
,"50":"Jesus led them almost as far as Bethany; then he lifted up his hands and blessed them."
,"51":"And as he blessed them, he withdrew (and was taken to heaven. They worshiped him)."
,"52":"They returned to Jerusalem full of joy and"
,"53":"were continually in the Temple praising God."
}`)

}
func EN_CCB_LoadNEMCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"This is the beginning of the Good News of Jesus Christ, the Son of God."
,"2":"It is written in the book of Isaiah, the prophet, 'I am sending my messenger ahead of you to prepare your way."
,"3":"Let the people hear the voice calling in the desert: Prepare the way of the Lord, level his paths.'"
,"4":"So John began to baptise in the desert; he preached a baptism of repentance for the forgiveness of sins."
,"5":"All Judea and all the people from the city of Jerusalem went out to John to confess their sins and be baptized by him in the river Jordan."
,"6":"John was clothed in camel's hair and wore a leather garment around his waist. His food was locusts and honey."
,"7":"He preached to the people saying, 'After me comes one who is more powerful than I am;"
,"8":"I have baptized you with water, but he will baptize you in the Holy Spirit. As for me, I am not worthy to bend down and untie his sandals.'"
,"9":"At that time Jesus came from Nazareth, a town of Galilee, and was baptized by John in the Jordan."
,"10":"And the moment he came up out of the water, heaven opened before him and he saw the Spirit coming down on him like a dove."
,"11":"And these words were heard from heaven, 'You are my Son, the Beloved, the One I have chosen.'"
,"12":"Then the Spirit drove him into the desert."
,"13":"Jesus stayed in the desert forty days and was tempted by Satan. He was with the wild animals, but angels ministered to him."
,"14":"After John was arrested, Jesus went into Galilee and began preaching the Good News of God."
,"15":"He said, 'The time has come; the kingdom of God is at hand. Change your ways and believe the Good News.'"
,"16":"As Jesus was walking along the shore of Lake Galilee, he saw Simon and his brother Andrew casting a net in the lake, for they were fishermen."
,"17":"And Jesus said to them, 'Follow me, and I will make you fish for people.'"
,"18":"At once, they left their nets and followed him."
,"19":"Jesus went a little farther on and saw James and John, the sons of Zebedee; they were in their boat mending their nets."
,"20":"Immediately, Jesus called them and they followed him, leaving their father Zebedee in the boat with the hired men. Jesus teaches and drives out an evil spirit "
,"21":"They went into the town of Capernaum and Jesus began to teach in the synagogue during the sabbath assemblies."
,"22":"The people were astonished at the way he taught, for he spoke as one having authority and not like the teachers of the Law."
,"23":"It happened that a man with an evil spirit was in their synagogue"
,"24":"and he shouted, 'What do you want with us, Jesus of Nazareth? Have you come to destroy us? I know who you are: You are the Holy One of God.'"
,"25":"Then Jesus faced him and said with authority, 'Be silent and come out of this man!'"
,"26":"The evil spirit shook the man violently and, with a loud shriek, came out of him."
,"27":"All the people were astonished and they wondered, 'What is this? With what authority he preaches! He even orders evil spirits and they obey him!'"
,"28":"And Jesus' fame spread throughout all the country of Galilee."
,"29":"On leaving the synagogue, Jesus went to the home of Simon and Andrew with James and John."
,"30":"As Simon's mother-in-law was sick in bed with fever, they immediately told him about her."
,"31":"Jesus went to her and taking her by the hand, raised her up. The fever left her and she began to wait on them."
,"32":"That evening at sundown, people brought to Jesus all the sick and those who had evil spirits:"
,"33":"the whole town was pressing around the door."
,"34":"Jesus healed many who had various diseases, and drove out many demons; but he did not let them speak, for they knew who he was."
,"35":"Very early in the morning, before daylight, Jesus went off to a lonely place where he prayed."
,"36":"Simon and the others went out, too, searching for him;"
,"37":"and when they found him they said, 'Everyone is looking for you.'"
,"38":"Then Jesus answered, 'Let's go to the nearby villages so that I may preach there too; for that is why I came.'"
,"39":"So Jesus set out to preach in all the synagogues throughout Galilee; he also cast out demons."
,"40":"A leper came to Jesus and begged him, 'If you so will, you can make me clean.'"
,"41":"Moved with pity, Jesus stretched out his hand and touched him, saying, 'I will; be clean.'"
,"42":"The leprosy left the man at once and he was made clean."
,"43":"As Jesus sent the man away, he sternly warned him,"
,"44":"'Don't tell anyone about this, but go and show yourself to the priest and for the cleansing bring the offering ordered by Moses; in this way you will make your declaration.'"
,"45":"However, as soon as the man went out, he began spreading the news everywhere, so that Jesus could no longer openly enter any town. But even though he stayed in the rural areas, people came to him from everywhere."
}`)
	CurrentBook.AddChapter(2, `{
"1":"After some days Jesus returned to Capernaum. As the news spread that he was at home,"
,"2":"so many people gathered that there was no longer room even outside the door. While Jesus was preaching the Word to them,"
,"3":"some people brought a paralyzed man to him."
,"4":"The four men who carried him couldn't get near Jesus because of the crowd, so they opened the roof above the room where Jesus was and, through the hole, lowered the man on his mat."
,"5":"When Jesus saw the faith of these people, he said to the paralytic, 'My son, your sins are forgiven.'"
,"6":"Now, some teachers of the Law who were sitting there wondered within themselves,"
,"7":"'How can he speak like this insulting God? Who can forgive sins except God?'"
,"8":"At once Jesus knew through his spirit what they were thinking and asked, 'Why do you wonder?"
,"9":"Is it easier to say to this paralyzed man: 'Your sins are forgiven,' or to say: 'Rise, take up your mat and walk?'"
,"10":"But now you shall know that the Son of Man has authority on earth to forgive sins.',And he said to the paralytic, "
,"11":"'Stand up, take up your mat and go home.'"
,"12":"The man rose and, in the sight of all those people, he took up his mat and went out. All of them were astonished and praised God saying, 'We have never seen anything like this!'"
,"13":"When Jesus went out again beside the lake, a crowd came to him and he taught them."
,"14":"As he walked along, he saw a tax collector sitting in his office. This was Levi, the son of Alpheus. Jesus said to him, 'Follow me.' And Levi got up and followed him."
,"15":"And it so happened that while Jesus was eating in Levi's house, tax collectors and sinners were sitting with him and his disciples for there were indeed many of them. But there were also teachers of the Law of the Pharisees' party,"
,"16":"among those who followed Jesus, and when they saw him eating with sinners and tax collectors, they said to his disciples, 'Why! He eats with tax collectors and sinners!'"
,"17":"Jesus heard them and answered, 'Healthy people don't need a doctor, but sick people do. I did not come to call the righteous but sinners.'"
,"18":"One day, when the disciples of John the Baptist and the Pharisees were fasting, some people asked Jesus, 'Why is it that both the disciples of John and of the Pharisees fast, but yours do not?'"
,"19":"Jesus answered, 'How can the wedding guests fast while the bridegroom is with them? As long as they have the bridegroom with them, they cannot fast."
,"20":"But the day will come when the bridegroom will be taken from them and on that day they will fast."
,"21":"No one sews a piece of new cloth on an old coat, because the new patch will shrink and tear away from the old cloth, making a worse tear."
,"22":"And no one puts new wine into old wineskins, for the wine would burst the skins and then both the wine and the skins would be lost. But new wine, new skins!'"
,"23":"One sabbath he was walking through grainfields. As his disciples walked along with him, they began to pick the heads of grain and crush them in their hands."
,"24":"Then the Pharisees said to Jesus, 'Look! they are doing what is forbidden on the sabbath!'"
,"25":"And he said to them, 'Have you never read what David did in his time of need, when he and his men were very hungry?"
,"26":"He went into the house of God when Abiathar was High Priest and ate the bread of offering, which only the priests are allowed to eat, and he also gave some to the men who were with him.'"
,"27":"Then Jesus said to them, 'The sabbath was made for man, not man for the sabbath."
,"28":"So the Son of Man is master even of the sabbath.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Again Jesus entered the synagogue. A man who had a paralyzed hand was there"
,"2":"and some people watched Jesus: Would he heal the man on the sabbath? If he did they could accuse him."
,"3":"Jesus said to the man with the paralyzed hand, 'Stand here in the center.'"
,"4":"Then he asked them, 'What does the Law allow us to do on the sabbath? To do good or to do harm? To save life or to kill?' But they were silent."
,"5":"Then Jesus looked around at them with anger and deep sadness because they had closed their minds. And he said to the man, 'Stretch out your hand.' He stretched it out and his hand was healed."
,"6":"But as soon as the Pharisees left, they met with Herod's supporters, looking for a way to destroy Jesus."
,"7":"Jesus and his disciples withdrew to the lakeside and a large crowd from Galilee followed him. A great number of people also came from Judea,"
,"8":"Jerusalem, Idumea, Transjordan and from the region of Tyre and Sidon, for they had heard of all that he was doing."
,"9":"Because of the crowd, Jesus told his disciples to have a boat ready for him, to prevent the people from crushing him."
,"10":"He healed so many that all who had diseases kept pressing towards him to touch him."
,"11":"Even the people who had evil spirits, whenever they saw him, would fall down before him and cry out, 'You are the Son of God.'"
,"12":"But he warned them sternly not to tell anyone who he was."
,"13":"Then Jesus went up into the hill country and called those he wanted and they came to him."
,"14":"So he appointed twelve to be with him; and he called them apostles. He wanted to send them out to preach,"
,"15":"and he gave them authority to drive out demons."
,"16":"These are the Twelve: Simon, to whom he gave the name Peter;"
,"17":"James, son of Zebedee, and John his brother, to whom he gave the name Boanerges, which means 'men of thunder';"
,"18":"Andrew, Philip, Bartholomew, Matthew, Thomas, James son of Alpheus, Thaddeus, Simon the Cananean"
,"19":"and Judas Iscariot, the one who betrayed him."
,"20":"They went home. The crowd began to gather again and they couldn't even have a meal."
,"21":"Knowing what was happening his relatives came to take charge of him: 'He is out of his mind,' they said."
,"22":"Meanwhile, the teachers of the Law who had come from Jerusalem said, 'He is in the power of Beelzebul: the chief of the demons helps him to drive out demons.'"
,"23":"Jesus called them to him and began teaching them by means of stories or parables, 'How can Satan drive out Satan?"
,"24":"If a nation is divided by civil war, that nation cannot stand."
,"25":"If a family divides itself into groups, that family will not survive."
,"26":"In the same way, if Satan has risen against himself and is divided, he will not stand; he is finished."
,"27":"No one can break into the house of the Strong one in order to plunder his goods, unless he first ties up the Strong one. Then indeed, he can plunder his house."
,"28":"Truly, I say to you, every sin will be forgiven humankind, even insults to God, however numerous."
,"29":"But whoever slanders the Holy Spirit will never be forgiven: he carries the guilt of his sin forever."
,"30":"'This was their sin when they said, 'He has an evil spirit in him.''"
,"31":"Then his mother and his brothers came. As they stood outside, they sent someone to call him."
,"32":"The crowd sitting around Jesus told him, 'Your mother and your brothers are outside asking for you.'"
,"33":"He replied, 'Who are my mother and my brothers?'"
,"34":"And looking around at those who sat there he said, 'Here are my mother and my brothers."
,"35":"Whoever does the will of God is brother and sister and mother to me.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Again Jesus began to teach by the lake, but such a large crowd gathered about him that he got into a boat and sat in it on the lake while the crowd stood on the shore."
,"2":"He taught them many things through stories or parables. In his teaching he said,"
,"3":"'Listen! The sower went out to sow."
,"4":"As he sowed, some of the seed fell along a path and the birds came and ate it up."
,"5":"Some of the seed fell on rocky ground where it had little soil; it sprang up immediately because it had no depth;"
,"6":"but when the sun rose and burned it, it withered because it had no roots."
,"7":"Other seed fell among thornbushes and the thorns grew and choked it, so it didn't produce any grain."
,"8":"But some seed fell on good soil, grew and increased and yielded grain; some produced thirty times as much, others sixty and others one hundred times as much.'"
,"9":"And Jesus added, 'Listen then, if you have ears.'"
,"10":"When the crowd went away, some who were around him with the Twelve asked about the parables."
,"11":"He answered them, 'The mystery of the kingdom of God has been given to you. But for those outside, everything comes in parables,"
,"12":"so that the more they see, they don't perceive; the more they hear, they don't understand; otherwise they would be converted and pardoned.'"
,"13":"Jesus said to them, 'Don't you understand this parable? How then will you understand any of the parables?"
,"14":"What the sower is sowing is the word."
,"15":"Those along the path where the seed fell are people who hear the word, but as soon as they do, Satan comes and takes away the word that was sown in them."
,"16":"Other people receive the word like rocky ground. As soon as they hear the word, they accept it with joy,"
,"17":"but they have no roots so it lasts only a little while. No sooner does trouble or persecution come because of the word, than they fall."
,"18":"Others receive the seed as among thorns. After they hear the word,"
,"19":"they are caught up in the worries of this life, false hopes of riches and other desires. All these come in and choke the word so that finally it produces nothing."
,"20":"And there are others who receive the word as good soil. They hear the word, take it to heart and produce: some thirty, some sixty and some one hundred times as much.'"
,"21":"Jesus also said to them, 'When the light comes, is it to be put under a tub or a bed? Surely it is put on a lampstand."
,"22":"Whatever is hidden will be disclosed, and whatever is kept secret will be brought to light."
,"23":"Listen then, if you have ears!'"
,"24":"And he also said to them, 'Pay attention to what you hear. In the measure you give, so shall you receive and still more will be given to you."
,"25":"For the one who produces something, more will be given, and from him who does not produce anything, even what he has will be taken away from him.'"
,"26":"Jesus also said, 'In the kingdom of God it is like this. A man scatters seed upon the soil."
,"27":"Whether he is asleep or awake, be it day or night, the seed sprouts and grows, he knows not how."
,"28":"The soil produces of itself; first the blade, then the ear, then the full grain in the ear."
,"29":"And when it is ripe for harvesting he takes the sickle for the cutting: the time for harvest has come.'"
,"30":"Jesus also said, 'What is the kingdom of God like? To what shall we compare it?"
,"31":"It is like a mustard seed which, when sown, is the smallest of all the seeds scattered upon the soil."
,"32":"But once sown, it grows up and becomes the largest of the plants in the garden and even grows branches so big that the birds of the air can take shelter in its shade.'"
,"33":"Jesus used many such stories or parables, to proclaim the word to them in a way they would be able to understand."
,"34":"He would not teach them without parables; but privately to his disciples he explained everything."
,"35":"On that same day when evening had come, Jesus said to them, 'Let's go across to the other side.'"
,"36":"So they left the crowd and took him away in the boat he had been sitting in, and other boats set out with him."
,"37":"Then a storm gathered and it began to blow a gale. The waves spilled over into the boat so that it was soon filled with water."
,"38":"And Jesus was in the stern, asleep on the cushion. They woke him up and said, 'Master, don't you care if we sink?' "
,"39":"As Jesus awoke, he rebuked the wind and ordered the sea, 'Quiet now! Be still!' The wind dropped and there was a great calm."
,"40":"Then Jesus said to them, 'Why are you so frightened? Do you still have no faith?'"
,"41":"But they were terrified and they said to one another, 'Who can this be? Even the wind and the sea obey him!'"
}`)
	CurrentBook.AddChapter(5, `{
"1":"They arrived on the other side of,the lake in the region of the Gerasenes."
,"2":"No sooner did Jesus leave the boat than he was met by a man with evil spirits who had come from the tombs."
,"3":"He lived among the tombs and no one could restrain him, even with a chain."
,"4":"He had often been bound with fetters and chains but he would pull the chains apart and smash the fetters, and no one had the strength to control him."
,"5":"Night and day he stayed among the tombs on the hillsides, and was continually screaming and beating himself with stones."
,"6":"When he saw Jesus from afar, he ran and fell at his feet"
,"7":"and cried with a loud voice, 'What do you want with me, Jesus, son of the Most High God? For God's sake I beg you, do not torment me.'"
,"8":"He said this because Jesus had commanded, 'Come out of the man, evil spirit.'"
,"9":"And when Jesus asked him, 'What is your name?' he replied, 'Legion is my name, for we are many.'"
,"10":"And all of them kept begging Jesus not to send them out of that region."
,"11":"Now, a great herd of pigs was feeding on the hillside,"
,"12":"and the evil spirits begged him, 'Send us to the pigs and let us go into them.'"
,"13":"So Jesus let them go. The evil spirits came out of the man and went into the pigs, and immediately the herd rushed down the cliff and all were drowned in the lake."
,"14":"The herdsmen fled and reported this in the town and in the countryside, so all the people came to see what had happened."
,"15":"They came to Jesus and saw the man freed of the evil spirits sitting there, clothed and in his right mind, the same man who had been possessed by the legion. They were afraid."
,"16":"And when those who had seen it told what had happened to the man and to the pigs,"
,"17":"the people begged Jesus to leave their neighborhood."
,"18":"When Jesus was getting into the boat, the man who had been possessed begged to stay with him."
,"19":"Jesus would not let him and said, 'Go home to your people and tell them how much the Lord has done for you and how he has had mercy on you.'"
,"20":"So he went throughout the country of Decapolis telling everyone how much Jesus had done for him. And all the people were astonished."
,"21":"Jesus then crossed to the other side of the lake and while he was still on the shore, a large crowd gathered around him."
,"22":"Jairus, an official of the synagogue, came up and seeing Jesus, threw himself at his feet"
,"23":"and asked him earnestly, 'My little daughter is at the point of death. Come and lay your hands on her so that she may get well and live.'"
,"24":"Jesus went with him and many people followed, pressing from every side."
,"25":"Among the crowd was a woman who had suffered from bleeding for twelve years."
,"26":"She had suffered a lot at the hands of many doctors and had spent everything she had, but instead of getting better, she was worse."
,"27":"Since she had heard about Jesus, this woman came up behind him and touched his cloak"
,"28":"thinking, 'If I just touch his clothing, I shall get well.'"
,"29":"Her flow of blood dried up at once, and she felt in her body that she was healed of her complaint."
,"30":"But Jesus was conscious that healing power had gone out from him, so he turned around in the crowd and asked, 'Who touched my clothes?'"
,"31":"His disciples answered, 'You see how the people are crowding around you. Why do you ask who touched you?'"
,"32":"But he kept looking around to see who had done it."
,"33":"Then the woman, aware of what had happened, came forward trembling and afraid. She knelt before him and told him the whole truth."
,"34":"Then Jesus said to her, 'Daughter, your faith has saved you; go in peace and be free of this illness.'"
,"35":"While Jesus was still speaking, some people arrived from the official's house to inform him, 'Your daughter is dead. Why trouble the Master any further?'"
,"36":"But Jesus ignored what they said and told the official, 'Do not fear, just believe.'"
,"37":"And he allowed no one to follow him except Peter, James and John, the brother of James."
,"38":"When they arrived at the house, Jesus saw a great commotion with people weeping and wailing loudly."
,"39":"Jesus entered and said to them, 'Why all this commotion and weeping? The child is not dead but asleep.'"
,"40":"They laughed at him. But Jesus sent them outside and went with the child's father and mother and his companions into the room where the child lay."
,"41":"Taking her by the hand, he said to her, 'Talitha kumi!' which means: 'Little girl, get up!'"
,"42":"The girl got up at once and began to walk around. (She was twelve years old.) The parents were astonished, greatly astonished."
,"43":"Jesus strictly ordered them not to let anyone know about it, and told them to give her something to eat."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Leaving that place, Jesus returned to his own country, and his disciples followed him."
,"2":"When the sabbath came, he began teaching in the synagogue, and most of those who heard him were astonished. They commented, 'How did this come to him? What kind of wisdom has been given to him that he also performs such miracles?"
,"3":"Who is he but the carpenter, the son of Mary and the brother of James and Joset and Judas and Simon? His sisters, too, are they not here among us?' So they took offense at him."
,"4":"And Jesus said to them, 'Prophets are despised only in their own country, among their relatives and in their own family.'"
,"5":"And he could work no miracles there, but only healed a few sick people by laying his hands on them."
,"6":"Jesus himself was astounded at their unbelief. Jesus then went around the villages teaching."
,"7":"He called the Twelve to him and began to send them out two by two, giving them authority over evil spirits."
,"8":"And he ordered them to take nothing for the journey except a staff; no food, no bag, no money in their belts."
,"9":"They were to wear sandals and were not to take an extra tunic."
,"10":"And he added, 'In whatever house you are welcomed, stay there until you leave the place."
,"11":"If any place doesn't receive you and the people refuse to listen to you, leave after shaking the dust off your feet. It will be a testimony against them.'"
,"12":"So they set out to proclaim that this was the time to repent."
,"13":"They drove out many demons and healed many sick people by anointing them."
,"14":"King Herod also heard about Jesus because his name had become well-known. Some people said, 'John the Baptist has been raised from the dead and that is why miraculous powers are at work in him.'"
,"15":"Others thought, 'He is Elijah,' and others, 'He is a prophet like the prophets of times past.'"
,"16":"When Herod was told of this, he thought: 'I had John beheaded, yet he has risen from the dead!'"
,"17":"For this is what had happened. Herod had ordered John to be arrested and had him bound and put in prison because of Herodias, the wife of his brother Philip. Herod had married her"
,"18":"and John had told him, 'It is not right for you to live with your brother's wife.'"
,"19":"So Herodias held a grudge against John and wanted to kill him, but she could not"
,"20":"because Herod respected John. He knew John to be an upright and holy man and kept him safe. And he liked listening to him, although he became very disturbed whenever he heard him."
,"21":"Herodias had her chance on Herod's birthday, when he gave a dinner for all the senior government officials, military chiefs and the leaders of Galilee."
,"22":"On that occasion the daughter of Herodias came in and danced; and she delighted Herod and his guests. The king said to the girl, 'Ask me for anything you want and I will give it to you.'"
,"23":"And he went so far as to say with many oaths, 'I will give you anything you ask, even half my kingdom.'"
,"24":"She went out to consult her mother, 'What shall I ask for?' The mother replied, 'The head of John the Baptist.'"
,"25":"The girl hurried to the king and made her request: 'I want you to give me the head of John the Baptist, here and now, on a dish.'"
,"26":"The king was very displeased, but he would not refuse in front of his guests because of his oaths."
,"27":"So he sent one of the bodyguards with orders to bring John's head. He went and beheaded John in prison;"
,"28":"then he brought the head on a dish and gave it to the girl. And the girl gave it to her mother."
,"29":"When John's disciples heard of this, they came and took his body and buried it."
,"30":"The apostles returned and reported to Jesus all they had done and taught."
,"31":"Then he said to them, 'Go off by yourselves to a remote place and have some rest.' For there were so many people coming and going that the apostles had no time even to eat."
,"32":"And they went away in the boat to a secluded area by themselves."
,"33":"But people saw them leaving and many could guess where they were going. So, from all the towns they hurried there on foot, arriving ahead of them."
,"34":"As Jesus went ashore he saw a large crowd, and he had compassion on them for they were like sheep without a shepherd. And he began a long teaching session with them."
,"35":"It was now getting late, so his disciples came to him and said, 'This is a lonely place and it is now late."
,"36":"You should send the people away and let them go to the farms and villages around here to buy themselves something to eat.'"
,"37":"Jesus replied, 'You yourselves give them something to eat.' They answered, 'If we are to give them food, we must go and buy two hundred silver coins' worth of bread.'"
,"38":"But Jesus said, 'You have some loaves: how many? Go and see.' The disciples found out and said, 'There are five loaves and two fish.'"
,"39":"Then he told them to have the people sit down together in groups on the green grass."
,"40":"This they did in groups of hundreds and fifties."
,"41":"And Jesus took the five loaves and the two fish and, raising his eyes to heaven, he pronounced a blessing, broke the loaves and handed them to his disciples to distribute to the people. He also divided the two fish among them."
,"42":"They all ate and everyone had enough."
,"43":"The disciples gathered up what was left and filled twelve baskets with broken pieces of bread and fish."
,"44":"Five thousand men had eaten there."
,"45":"Immediately, Jesus obliged his disciples to get into the boat and go ahead of him to the other side, towards Bethsaida, while he himself sent the crowd away."
,"46":"And having sent the people off, he went by himself to the hillside to pray."
,"47":"When evening came, the boat was far out on the lake while he was alone on the land."
,"48":"Jesus saw his disciples straining at the oars, for the wind was against them, and before daybreak he came to them walking on the lake; and he was going to pass them by."
,"49":"When they saw him walking on the lake, they thought it was a ghost and cried out;"
,"50":"for they all saw him and were terrified. But at once he called to them, 'Courage! It's me; don't be afraid.'"
,"51":"Then Jesus got into the boat with them and the wind died down. They were completely astonished,"
,"52":"for they had not really grasped the fact of the loaves; their minds were dull."
,"53":"Having crossed the lake, they came ashore at Genesaret where they tied up the boat."
,"54":"As soon as they landed, people recognized Jesus"
,"55":"and ran to spread the news throughout the countryside. Wherever he was they brought to him the sick lying on their mats."
,"56":"And wherever he went, to villages, towns or farms, they laid the sick in the marketplace and begged him to let them touch just the fringe of his cloak. And all who touched him were cured."
}`)
	CurrentBook.AddChapter(7, `{
"1":"One day the Pharisees gathered around Jesus and with them were some teachers of the Law who had just come from Jerusalem."
,"2":"They noticed that some of his disciples were eating their meal with unclean hands, that is, without washing them."
,"3":"Now the Pharisees, and in fact, all the Jews, never eat without washing their hands for they follow the tradition received from their ancestors."
,"4":"Nor do they eat anything when they come from the market without first washing themselves. And there are many other traditions they observe, for example, the ritual washing of cups, pots and plates."
,"5":"So the Pharisees and the teachers of the Law asked him, 'Why do your disciples not follow the tradition of the elders, but eat with unclean hands?'"
,"6":"Jesus answered, 'You, shallow people! How well Isaiah prophesied of you when he wrote: This people honors me with their lips, but their heart is far from me."
,"7":"The worship they offer me is worthless, for what they teach are only human rules."
,"8":"You even put aside the commandment of God to hold fast to human tradition.'"
,"9":"And Jesus commented, 'You have a fine way of disregarding the commandment of God in order to implant your own tradition."
,"10":"For example, Moses said: Do your duty to your father and your mother, and: Whoever curses his father or his mother is to be put to death."
,"11":"But according to you someone could say to his father or mother: 'I already declared Corban, which means 'offered to God,' what you could have expected from me.'"
,"12":"In this case, you no longer let him do anything for a father or mother."
,"13":"So you nullify the word of God through the tradition you have handed on. And you do many other things like that.'"
,"14":"Jesus then called the people to him again and said to them, 'Listen to me, all of you, and try to understand."
,"15":"Nothing that enters one from outside can make that person unclean. It is what comes out from within that makes unclean."
,"16":"Let everyone who has ears listen.'"
,"17":"When Jesus got home and was away from the crowd, his disciples asked him about this saying"
,"18":"and he replied, 'So even you are dull? Do you not see that whatever comes from outside cannot make a person unclean?"
,"19":"Since it enters, not the heart but the stomach and is finally passed out.',Thus Jesus declared that all foods are clean."
,"20":"And he went on, 'What comes out of a person is what defiles,"
,"21":"for evil designs come out of the heart: theft, murder,"
,"22":"adultery, jealousy, greed, maliciousness, deceit, indecency, slander, pride and folly."
,"23":"All these evil things come from within and make a person unclean.'"
,"24":"When Jesus left that place he went to the border of the Tyrian country. There he entered a house and did not want anyone to know he was there, but he could not remain hidden."
,"25":"A woman whose small daughter had an evil spirit, heard of him and came and fell at his feet."
,"26":"Now this woman was a pagan, a Syrophoenician by birth, and she begged him to drive the demon out of her daughter."
,"27":"Jesus told her, 'Let the children be fed first, for it is not right to take the children's bread and throw it to the dogs.'"
,"28":"But she replied, 'Sir, even the dogs under the table eat the crumbs from the children's bread.'"
,"29":"Then Jesus said to her, 'You may go your way; because of such a reply the demon has gone out of your daughter.'"
,"30":"And when the woman went home, she found her child lying in bed and the demon gone."
,"31":"Again Jesus set out; from the country of Tyre he passed through Sidon and skirting the sea of Galilee he came to the territory of Decapolis."
,"32":"There a deaf man who also had difficulty in speaking was brought to him. They asked Jesus to lay his hand upon him."
,"33":"Jesus took him apart from the crowd, put his fingers into the man's ears and touched his tongue with spittle."
,"34":"Then, looking up to heaven, he groaned and said to him, 'Ephphetha,' that is, 'Be opened.'"
,"35":"And his ears were opened, his tongue was loosened, and he began to speak clearly."
,"36":"Jesus ordered them not to tell anyone, but the more he insisted on this, the more they proclaimed it."
,"37":"The people were completely astonished and said, 'He has done all things well; he makes the deaf hear and the dumb speak.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Soon afterwards Jesus was in the midst of another large crowd that obviously had nothing to eat. So he called his disciples and said to them,"
,"2":"'I feel sorry for these people because they have been with me for three days and now have nothing to eat."
,"3":"If I send them to their homes hungry, they will faint on the way; some of them have come a long way.'"
,"4":"His disciples replied, 'Where in a deserted place like this could we get enough bread to feed these people?'"
,"5":"He asked them, 'How many loaves have you?' And they answered, 'Seven.'"
,"6":"Then he ordered the crowd to sit down on the ground. Taking the seven loaves and giving thanks, he broke them and handed them to his disciples to distribute. And they distributed them among the people."
,"7":"They also had some small fish, so Jesus said a blessing and asked that these be shared as well."
,"8":"The people ate and were satisfied. The broken pieces were collected, seven wicker baskets full of leftovers."
,"9":"Now there had been about four thousand people. Jesus sent them away"
,"10":"and immediately got into the boat with his disciples and went to the region of Dalmanutha."
,"11":"The Pharisees came and started to argue with Jesus. Hoping to embarrass him, they asked for some heavenly sign."
,"12":"Then his spirit was moved. He gave a deep sigh and said, 'Why do the people of this present time ask for a sign? Truly, I say to you, no sign shall be given to this people.'"
,"13":"Then he left them, got into the boat again and went to the other side of the lake."
,"14":"The disciples had forgotten to bring more bread and had only one loaf with them in the boat."
,"15":"Then Jesus warned them, 'Keep your eyes open and beware of the yeast of the Pharisees and the yeast of Herod.'"
,"16":"And they said to one another, 'He saw that we have no bread.'"
,"17":"Aware of this, Jesus asked them, 'Why are you talking about the loaves you are short of? Do you not see or understand? Are your minds closed?"
,"18":"Have you eyes that don't see and ears that don't hear? And do you not remember"
,"19":"when I broke the five loaves among five thousand? How many baskets full of leftovers did you collect?' They answered, 'Twelve.'"
,"20":"'And having seven loaves for the four thousand, how many wicker baskets of leftovers did you collect?' They answered, 'Seven.'"
,"21":"Then Jesus said to them, 'Do you still not understand?'"
,"22":"When they came to Bethsaida, Jesus was asked to touch a blind man who was brought to him."
,"23":"He took the blind man by the hand and led him outside the village. When he had put spittle on his eyes and laid his hands upon him, he asked, 'Can you see anything?'"
,"24":"The man, who was beginning to see, replied, 'I see people! They look like trees, but they move around.'"
,"25":"Then Jesus laid his hands on his eyes again and the man could see perfectly. His sight was restored and he could see everything clearly."
,"26":"Then Jesus sent him home saying, 'Do not return to the village.'"
,"27":"Jesus set out with his disciples for the villages around Cesarea Philippi; and on the way he asked them, 'Who do people say I am?'"
,"28":"And they told him, 'Some say you are John the Baptist; others say you are Elijah or one of the prophets.',Then Jesus asked them, "
,"29":"'But you, who do you say I am?' Peter answered, 'You are the Messiah.'"
,"30":"And he ordered them not to tell anyone about him."
,"31":"Jesus then began to teach them that the Son of Man had to suffer many things and be rejected by the elders, the chief priests and the teachers of the Law. He would be killed and after three days rise again."
,"32":"Jesus said all this quite openly, so that Peter took him aside and began to protest strongly."
,"33":"But Jesus turning around, and looking at his disciples, rebuked Peter saying, 'Get behind me Satan! You are thinking, not as God does, but as people do.'"
,"34":"Then Jesus called the people and his disciples and said, 'If you want to follow me, deny yourself, take up your cross and follow me."
,"35":"For if you choose to save your life, you will lose it; and if you lose your life for my sake and for the sake of the Gospel, you will save it."
,"36":"What good is it to gain the whole world but destroy yourself?"
,"37":"There is nothing you can give to recover your life."
,"38":"I tell you: If anyone is ashamed of me and of my words among this adulterous and sinful people, the Son of Man will also be ashamed of him when he comes in the Glory of his Father with the holy angels.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"And he went on to say, 'Truly I tell you, there are some here who will not die before they see the kingdom of God coming with power.'"
,"2":"Six days later, Jesus took with him Peter and James and John, and led them up a high mountain. There his appearance was changed before their eyes."
,"3":"Even his clothes shone, becoming as white as no bleach of this world could make them."
,"4":"Elijah and Moses appeared to them; the two were talking with Jesus."
,"5":"Then Peter spoke and said to Jesus, 'Master, it is good that we are here; let us make three tents, one for you, one for Moses and one for Elijah.'"
,"6":"For he did not know what to say; they were overcome with awe."
,"7":"But a cloud formed, covering them in a shadow, and from the cloud came this word, 'This is my Son, the Beloved; listen to him.'"
,"8":"And suddenly, as they looked around, they no longer saw anyone except Jesus with them."
,"9":"As they came down the mountain, he ordered them to tell no one what they had seen, until the Son of Man be risen from the dead."
,"10":"So they kept this to themselves, although they discussed with one another what 'to rise from the dead' could mean."
,"11":"Finally they asked him, 'Why then do the teachers of the Law say that Elijah must come first?'"
,"12":"Jesus answered them, 'Of course, Elijah will come first so that everything may be as it should be... But, why do the Scriptures say that the Son of Man must suffer many things and be despised?"
,"13":"I tell you that Elijah has already come and they have treated him as they pleased, as the Scriptures say of him.'"
,"14":"When they came to the place where they had left the disciples, they saw many people around and some teachers of the Law arguing with them."
,"15":"When the people saw Jesus, they were astonished and ran to greet him."
,"16":"He asked, 'What are you arguing about with them?' A man answered him from the crowd,"
,"17":"'Master, I brought my son to you for he has a dumb spirit."
,"18":"Whenever the spirit seizes him, it throws him down and he foams at the mouth, grinds his teeth and becomes stiff all over. I asked your disciples to drive the spirit out, but they could not.'"
,"19":"Jesus replied, 'You faithless people. How long must I be with you? How long must I put up with you? Bring him to me.'"
,"20":"And they brought the boy to him. As soon as the spirit saw Jesus, it shook and convulsed the boy who fell on the ground and began rolling about, foaming at the mouth."
,"21":"Then Jesus asked the father, 'How long has this been happening to him?' He replied, 'From childhood."
,"22":"And it has often thrown him into the fire and into the water to destroy him. If you can do anything, have pity on us and help us.'"
,"23":"Jesus said to him, 'Why do you say: 'If you can?' All things are possible for one who believes.'"
,"24":"Immediately the father of the boy cried out, 'I do believe, but help the little faith I have.'"
,"25":"Jesus saw that the crowd was increasing rapidly, so he ordered the evil spirit, 'Dumb and deaf spirit, I command you: Leave the boy and never enter him again.'"
,"26":"The evil spirit shook and convulsed the boy and with a terrible shriek came out. The boy lay like a corpse and people said, 'He is dead.'"
,"27":"But Jesus took him by the hand and lifted him and the boy stood up."
,"28":"After Jesus had gone indoors, his disciples asked him privately, 'Why couldn't we drive out the spirit?'"
,"29":"And he answered, 'Only prayer can drive out this kind, nothing else.'"
,"30":"After leaving that place, they made their way through Galilee; but Jesus did not want people to know where he was"
,"31":"because he was teaching his disciples. And he told them, 'The Son of Man will be delivered into human hands. They will kill him, but three days after he has been killed, he will rise.'"
,"32":"The disciples, however, did not understand these words and they were afraid to ask him what he meant."
,"33":"They came to Capernaum and, once inside the house, Jesus asked them, 'What were you discussing on the way?'"
,"34":"But they did not answer because they had been arguing about who was the greatest."
,"35":"Then he sat down, called the Twelve and said to them, 'If someone wants to be first, let him be last of all and servant of all.'"
,"36":"Then he took a little child, placed it in their midst, and putting his arms around it he said to them,"
,"37":"'Whoever welcomes a child such as this in my name, welcomes me; and whoever welcomes me, welcomes not me but the One who sent me.'"
,"38":"John said to him, 'Master, we saw someone who drove out demons by calling upon your name, and we tried to forbid him because he does not belong to our group.'"
,"39":"Jesus answered, 'Do not forbid him, for no one who works a miracle in my name can soon after speak evil of me."
,"40":"For whoever is not against us is for us."
,"41":"If anyone gives you a drink of water because you belong to Christ and bear his name, truly, I say to you, he will not go without reward."
,"42":"If anyone should cause one of these little ones who believe in me to stumble and sin, it would be better for him to be thrown into the sea with a great millstone around his neck."
,"43":"If your hand makes you fall into sin, cut it off! It is better for you to enter life without a hand than with two hands to go to hell, to the fire that never goes out."
,"45":"And if your foot makes you fall into sin, cut it off! It is better for you to enter life without a foot than with both feet to be thrown into hell."
,"47":"And if your eye makes you fall into sin, tear it out! It is better for you to enter the kingdom of God with one eye than, keeping both eyes, to be thrown into hell"
,"48":"where the worms that eat them never die, and the fire never goes out."
,"49":"The fire itself will preserve them."
,"50":"Salt is a good thing; but if it loses its saltiness, how can you make it salty again? Have salt in yourselves and be at peace with one another.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Jesus then left that place and went to the province of Judea, beyond the Jordan River. Once more crowds gathered around him and once more he taught them, as he always did."
,"2":"Some (Pharisees came and) put him to the test with this question, 'Is it right for a husband to divorce his wife?'"
,"3":"He replied, 'What law did Moses give you?'"
,"4":"They answered, 'Moses allowed us to write a certificate of dismissal in order to divorce.'"
,"5":"Then Jesus said to them, 'Moses wrote this law for you, because you are stubborn."
,"6":"But in the beginning of creation God made them male and female,"
,"7":"and because of this, man has to leave father and mother and be joined to his wife,"
,"8":"and the two shall become one body. So they are no longer two but one body."
,"9":"Therefore let no one separate what God has joined.'"
,"10":"When they were indoors at home, the disciples again asked him about this"
,"11":"and he told them, 'Whoever divorces his wife and marries another commits adultery against his wife,"
,"12":"and the woman who divorces her husband and marries another also commits adultery.'"
,"13":"People were bringing their little children to him to have him touch them, and the disciples rebuked them for this."
,"14":"When Jesus noticed it, he was very angry and said, 'Let the children come to me and don't stop them, for the kingdom of God belongs to such as these."
,"15":"Truly, I say to you, whoever does not receive the kingdom of God like a child will not enter it.'"
,"16":"Then he took the children in his arms and laying his hands on them, blessed them."
,"17":"Just as Jesus was setting out on his journey again, a man ran up, knelt before him and asked, 'Good Master, what must I do to have eternal life?'"
,"18":"Jesus answered, 'Why do you call me good? No one is good but God alone."
,"19":"You know the commandments: Do not kill, do not commit adultery, do not steal, do not bear false witness, do not cheat, honor your father and mother.'"
,"20":"The man replied, 'I have obeyed all these commandments since my childhood.'"
,"21":"Then Jesus looked steadily at him and loved him and he said, 'For you, one thing is lacking. Go, sell what you have and give the money to the poor, and you will have riches in heaven. Then come and follow me.'"
,"22":"On hearing these words, his face fell and he went away sorrowful for he was a man of great wealth."
,"23":"Jesus looked around and said to his disciples, 'How hard it is for those who have riches to enter the kingdom of God!'"
,"24":"The disciples were shocked at these words, but Jesus insisted, 'Children, how hard it is to enter the kingdom of God!"
,"25":"It is easier for a camel to go through the eye of a needle than for one who is rich to enter the kingdom of God.'"
,"26":"They were more astonished than ever and wondered, 'Who, then, can be saved?'"
,"27":"Jesus looked steadily at them and said, 'For humans it is impossible, but not for God; all things are possible with God.'"
,"28":"Peter spoke up and said, 'We have given up everything to follow you.'"
,"29":"Jesus answered, 'Truly, there is no one who has left house or brothers or sisters, or father or mother, or children, or lands for my sake and for the Gospel,"
,"30":"who will not receive his reward. I say to you: even in the midst of persecution he will receive a hundred times as many houses, brothers, sisters, mothers, children, and lands in the present time and in the world to come eternal life."
,"31":"Do pay attention: Many who now are first will be last, and the last, first.'"
,"32":"They were on the road going up to Jerusalem, and Jesus was walking ahead. The Twelve were anxious and those who followed were afraid. Once more Jesus took the Twelve aside to tell them what was to happen to him,"
,"33":"'You see we are going up to Jerusalem, and the Son of Man will be given over to the chief priests and the teachers of the Law. They will condemn him to death and hand him over to the foreigners"
,"34":"who will make fun of him, spit on him, scourge him and finally kill him; but three days later he will rise.'"
,"35":"James and John, the sons of Zebedee, came to Jesus and said to him, 'Master, we want you to grant us what we are going to ask of you.'"
,"36":"And he said, 'What do you want me to do for you?'"
,"37":"They answered, 'Grant us to sit one at your right and one at your left when you come in your glory.'"
,"38":"But Jesus said to them, 'You don't know what you are asking. Can you drink the cup that I drink or be baptized in the way I am baptized?'"
,"39":"They answered, 'We can.' And Jesus told them, 'The cup that I drink you will drink, and you will be baptized in the way I am baptized."
,"40":"But to sit at my right or at my left is not mine to grant. It has been prepared for others.'"
,"41":"On hearing this, the other ten were angry with James and John;"
,"42":"Jesus then called them to him and said, 'As you know, the so-called rulers of the nations act as tyrants and their great ones oppress them."
,"43":"But it shall not be so among you; whoever would be great among you must be your servant,"
,"44":"and whoever would be first among you shall make himself slave of all."
,"45":"Think of the Son of Man who has not come to be served but to serve and to give his life to redeem many.'"
,"46":"They came to Jericho. As Jesus was leaving Jericho with his disciples and a large crowd, a blind beggar, Bartimaeus, the son of Timaeus, was sitting by the roadside."
,"47":"On hearing that it was Jesus of Nazareth passing by, he began to call out, 'Son of David, Jesus, have mercy on me!'"
,"48":"Many people scolded him and told him to keep quiet, but he shouted all the louder, 'Son of David, have mercy on me!'"
,"49":"Jesus stopped and said, 'Call him.' So they called the blind man saying, 'Take heart. Get up, he is calling you.'"
,"50":"He immediately threw aside his cloak, jumped up and went to Jesus."
,"51":"Then Jesus asked him, 'What do you want me to do for you?' The blind man said, 'Master, let me see again!'"
,"52":"And Jesus said to him, 'Go your way, your faith has made you well.' And immediately he could see, and he followed Jesus along the road."
}`)
	CurrentBook.AddChapter(11, `{
"1":"When they drew near to Jerusalem and arrived at Bethphage and Bethany, at the Mount of Olives, Jesus sent two of his disciples with these instructions,"
,"2":"'Go to the village on the other side and, as you enter it, you will find there a colt tied up that no one has ridden. Untie it and bring it here."
,"3":"If anyone says to you: 'What are you doing?' give this answer: 'The Lord needs it, but he will send it back immediately.''"
,"4":"They went off and found the colt out in the street tied at the door."
,"5":"As they were untying it, some of the bystanders asked, 'Why are you untying that colt?'"
,"6":"They answered as Jesus had told them, and the people allowed them to continue."
,"7":"They brought the colt to Jesus, threw their cloaks on its back, and Jesus sat upon it."
,"8":"Many people also spread their cloaks on the road, while others spread leafy branches from the fields."
,"9":"Then the people who walked ahead and those who followed behind Jesus began to shout, 'Hosannah! Blessed is he who comes in the name of the Lord!"
,"10":"Blessed is the kingdom of our father David which comes! Hosannah in the highest!'"
,"11":"So Jesus entered Jerusalem and went into the Temple. And after he had looked all around, as it was already late, he went out to Bethany with the Twelve."
,"12":"The next day, when they were leaving Bethany, he felt hungry."
,"13":"In the distance he noticed a fig tree covered with leaves, so he went to see if he could find anything on it. When he reached it, he found nothing but leaves, for it was not the season for figs."
,"14":"Then Jesus said to the fig tree, 'May no one ever eat your fruit!' And his disciples heard these words."
,"15":"When they reached Jerusalem, Jesus went to the Temple and began to drive away all the people he saw buying and selling there. He overturned the tables of the money-changers and the stools of those who sold pigeons."
,"16":"And he would not let anyone carry anything through the Temple area."
,"17":"Jesus then taught the people, 'Does not God say in the Scriptures: My house will be called a House of Prayer for all the nations? But you have turned it into a den of thieves.'"
,"18":"The chief priests and the teachers of the Law heard of this, and they tried to find a way to destroy him. They were afraid of him because all the people were captivated in his teaching."
,"19":"When evening came, Jesus left the city."
,"20":"Early next morning, as they walked along the road, the disciples saw the fig tree withered to its roots."
,"21":"Peter then said to him, 'Master, look! The fig tree you cursed has withered.'"
,"22":"And Jesus replied, 'Have faith in God."
,"23":"Truly, I say to you, if you say to this mountain: 'Get up and throw yourself into the sea,' and have no doubt in your heart but believe that what you say will happen, it will be done for you."
,"24":"Therefore, I tell you, whatever you ask in prayer, believe that you have received it, and it shall be done for you."
,"25":"And when you stand to pray, forgive whatever you may hold against anyone,"
,"26":"so that your heavenly Father may also forgive your sins.'"
,"27":"They were once again in Jerusalem. As Jesus was walking in the Temple, the chief priests, the teachers of the Law and the elders came to him"
,"28":"and asked, 'What authority do you have to act like this? Who gave you authority to do the things you do?'"
,"29":"Jesus said to them, 'I will ask you a question, only one, and if you give me an answer, then I will tell you what authority I have to act like this."
,"30":"Was John's preaching and baptism a work of God, or was it merely something human? Answer me.'"
,"31":"And they kept arguing among themselves, 'If we answer that it was a work of God, he will say: 'Why then did you not believe him?''"
,"32":"But neither could they answer before the people that the baptism of John was merely something human, for everyone regarded John as a prophet."
,"33":"So they answered Jesus, 'We don't know,' and Jesus said to them, 'Neither will I tell you what authority I have to act as I do.'"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Using parables, Jesus went on to say, 'A man planted a vineyard, put a fence around it, dug a hole for the wine press and built a watch tower. Then he leased the vineyard to tenants and went abroad."
,"2":"In due time he sent a servant to receive from the tenants his share of the fruit."
,"3":"But they seized the servant, struck him and sent him back empty-handed."
,"4":"Again the man sent another servant. They also struck him on the head and treated him shamefully."
,"5":"He sent another and they killed him. In the same way they treated many others; some they struck and others they killed."
,"6":"One was still left, his beloved son. And so, last of all, he sent him to the tenants, for he said: 'They will respect my son.'"
,"7":"But those tenants said to one another: 'This is the one who is to inherit the vineyard. Let's kill him and the property will be ours.'"
,"8":"So they seized him and killed him, and threw him out of the vineyard."
,"9":"Now, what will the owner of the vineyard do? He will come and destroy those tenants and give the vineyard to others.'"
,"10":"And Jesus added, 'Have you not read this text of the Scriptures: The stone which the builders rejected has become the keystone."
,"11":"This was the Lord's doing; and we marvel at it."
,"12":"They wanted to arrest him for they realized that Jesus meant this parable for them, but they were afraid of the crowd. So they left him and went away."
,"13":"They sent to Jesus some Pharisees with members of Herod's party, with the purpose of trapping him in his own words."
,"14":"They came and said to Jesus, 'Master, we know that you are true; you are not influenced by anyone, and your answers do not vary according to who is listening to you but you truly teach God's way. Tell us, is it against the Law to pay taxes to Caesar? Should we pay them or not?'"
,"15":"But Jesus saw through their trick and answered, 'Why are you testing me? Bring me a silver coin and let me see it.'"
,"16":"They brought him one and Jesus asked, 'Whose head is this, and whose name?' They answered, 'Caesar's.'"
,"17":"Then Jesus said, 'Return to Caesar what is Caesar's, and to God what is God's.',And they were greatly astonished."
,"18":"The Sadducees also came to Jesus. Since they claim that there is no resurrection, they questioned him in this way,"
,"19":"'Master, in the Scriptures Moses gave us this law: 'If anyone dies and leaves a wife but no children, his brother must take the wife and give her a child who will be considered the child of his deceased brother.'"
,"20":"Now, there were seven brothers. The first married a wife, but he died without leaving any children."
,"21":"The second took the wife and he, too, died leaving no children. The same thing happened to the third."
,"22":"Finally the seven died leaving no children. Last of all the woman died."
,"23":"Now, in the resurrection, to which of them will she be wife? For the seven had her as wife.'"
,"24":"Jesus replied, 'You could be wrong in this regard because you understand neither the Scriptures nor the power of God."
,"25":"When they rise from the dead, men and women do not marry but are like the angels in heaven."
,"26":"Now, about the resurrection of the dead, have you never reflected on the chapter of the burning bush in the book of Moses? God said to him: I am the God of Abraham, the God of Isaac and the God of Jacob."
,"27":"Now, he is the God, not of the dead but of the living. You are totally wrong.'"
,"28":"A teacher of the Law had been listening to this discussion and admired how Jesus answered them. So he came up and asked him, 'Which commandment is the first of all?'"
,"29":"Jesus answered, 'The first is: Hear, Israel! The Lord, our God, is One Lord;"
,"30":"and you shall love the Lord, your God, with all your heart, with all your soul, with all your mind and with all your strength."
,"31":"And after this comes another one: You shall love your neighbor as yourself. There is no commandment greater than these two.'"
,"32":"The teacher of the Law said to him, 'Well-spoken, Master; you are right when you say that he is one and there is no other."
,"33":"To love him with all our heart, with all our understanding and with all our strength, and to love our neighbor as ourselves is more important than any burnt offering or sacrifice.'"
,"34":"Jesus approved this answer and said, 'You are not far from the kingdom of God.' But after that, no one dared to ask him any more questions."
,"35":"As Jesus was teaching in the Temple, he said, 'The teachers of the Law say that the Messiah is the son of David. How can that be?"
,"36":"For David himself, inspired by the Holy Spirit declared: The Lord said to my Lord: sit at my right until I put your enemies under your feet."
,"37":"If David himself calls him Lord, in what way can he be his son?',Many people came to Jesus and listened to him gladly."
,"38":"As he was teaching, he also said to them, 'Beware of those teachers of the Law who enjoy walking around in long robes and being greeted in the marketplace,"
,"39":"and who like to occupy reserved seats in the synagogues and the first places at feasts."
,"40":"They even devour the widow's and the orphan's goods while making a show of long prayers. How severe a sentence they will receive!'"
,"41":"Jesus sat down opposite the Temple treasury and watched the people dropping money into the treasury box; and many rich people put in large offerings."
,"42":"But a poor widow also came and dropped in two small coins."
,"43":"Then Jesus called his disciples and said to them, 'Truly I say to you, this poor widow put in more than all those who gave offerings."
,"44":"For all of them gave from their plenty, but she gave from her poverty and put in everything she had, her very living.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"As Jesus left the Temple, one of his disciples said, 'Look, Master, at the enormous stones and wonderful buildings here!'"
,"2":"And Jesus answered, 'You see these great buildings? Not one stone will be left upon another, but all will be torn down.'"
,"3":"After a while, when Jesus was sitting on the Mount of Olives, facing the Temple, Peter, James, John and Andrew approached him privately and asked,"
,"4":"'Tell us when this will be. What sign will be given us before all this happens?'"
,"5":"Then Jesus began to tell them, 'Don't let anyone mislead you."
,"6":"Many will come, taking my place, and say: 'I am the one you are waiting for,' and they will deceive many people."
,"7":"When you hear of war and threats of war, don't be troubled; this must occur but the end is not yet."
,"8":"Nation will fight nation and kingdom will oppose kingdom. There will be earthquakes everywhere and famines, too. And these will be like the first pains of childbirth."
,"9":"Be on your guard, for you will be arrested and taken to Jewish courts. You will be beaten in synagogues; and you will stand before governors and kings for my sake to bear witness before them."
,"10":"For the preaching of the Gospel to all nations has to come first."
,"11":"So when you are arrested and brought to trial, don't worry about what you are to say; for you shall say what will be given you in that hour. It is not you who speak but the Holy Spirit."
,"12":"Brother will betray brother, even to death, and the father his child. Children will turn against their parents and have them put to death."
,"13":"You will be hated by all for my name's sake, but whoever holds out to the end will be saved."
,"14":"So, when you see the idol of the oppressor set in the place where it should not be (may the reader understand!), then let those in Judea flee to the mountains."
,"15":"If you are on the housetop, don't come down to take anything with you."
,"16":"If you are in the field, don't turn back to fetch your cloak."
,"17":"How hard it will be then for pregnant women and mothers with babies at the breast!"
,"18":"Pray that it may not happen in winter."
,"19":"For this will be a time of distress such as was never known from the beginning when God created the world, until now and is never to be known again."
,"20":"So that if the Lord had not shortened that time, no one would survive; but he decided to shorten it for the sake of some of his chosen."
,"21":"And if anyone says to you at that time: 'Look, here is the Messiah! Look, he is there!' - do not believe it."
,"22":"For false Messiahs and false prophets will arise and perform signs and wonders in order to deceive even God's chosen people, if that were possible."
,"23":"Then be on your guard, I have told you everything ahead of time."
,"24":"Later on, in those days after that disastrous time, the sun will grow dark, the moon will not give its light,"
,"25":"the stars will fall out of the sky and the whole universe will be shaken."
,"26":"Then people will see the Son of Man coming in the clouds with great power and glory."
,"27":"And he will send the angels to gather his chosen people from the four winds, from the ends of the earth to the ends of the sky."
,"28":"Learn a lesson from the fig tree. As soon as its branches become tender and it begins to sprout leaves, you know that summer is near."
,"29":"In the same way, when you see these things happening, know that the time is near, even at the door."
,"30":"Truly, I say to you, this generation will not pass away until all this has happened."
,"31":"Heaven and earth will pass away, but my words will not pass away."
,"32":"But, regarding that Day and that Hour, no one knows when it will come, not even the angels, not even the Son, but only the Father."
,"33":"Be alert and watch, for you don't know when the time will come."
,"34":"When a man goes abroad and leaves his home, he puts his servants in charge, giving to each one some responsibility; and he orders the doorkeeper to stay awake."
,"35":"So stay awake, for you don't know when the Lord of the house will come, in the evening or at midnight, when the cock crows or before dawn."
,"36":"If he comes suddenly, do not let him catch you asleep."
,"37":"And what I say to you, I say to all: watch.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"It was now two days before the feast of the Passover and Unleavened Bread. The chief priests and the teachers of the Law were looking craftily for a way to arrest Jesus and put him to death;"
,"2":"for they said, 'Not during the Festival, or there might be trouble among the people.'"
,"3":"Jesus was in Bethany in the house of Simon the leper. As he was reclining at dinner, a woman entered carrying a precious jar of expensive perfume made of pure nard. She broke the jar and poured the perfumed oil on Jesus' head."
,"4":"Then some of them became angry and said, 'What a useless waste of perfume."
,"5":"It could have been sold for more than three hundred silver coins and the money given to the poor.' And they criticized her."
,"6":"But Jesus said, 'Let her alone; why are you troubling her? What she has just done for me is a very charitable work."
,"7":"At any time you can help the poor, for you always have them with you, but you will not have me forever."
,"8":"This woman has done what was hers to do, she has anointed my body beforehand for my burial."
,"9":"Truly, I say to you, wherever the Good News is proclaimed, and this will be throughout the world, what she has done will be told in praise of her.'"
,"10":"Then Judas Iscariot, one of the Twelve, went off to the chief priests in order to betray Jesus to them."
,"11":"On hearing him they were excited and promised to give him money. So Judas started planning the best way to hand him over to them."
,"12":"On the first day of the Festival of Unleavened Bread, the day when the Passover Lamb was killed, the disciples asked him, 'Where would you have us go to prepare the Passover meal for you?'"
,"13":"So Jesus sent two of his disciples with these instructions, 'Go into the city and there a man will come to you carrying a jar of water. Follow him to the house he enters and say to the owner,"
,"14":"'The Master says: Where is the room where I may eat the Passover meal with my disciples?'"
,"15":"Then he will show you a large room upstairs, already arranged and furnished. There you will prepare for us.'"
,"16":"The disciples went off. When they reached the city, they found everything just as Jesus had told them; and they prepared the Passover meal."
,"17":"When it was evening, Jesus arrived with the Twelve."
,"18":"While they were at table eating, Jesus said, 'Truly, I tell you, one of you will betray me, one who shares my meal.'"
,"19":"They were deeply distressed at hearing this and asked him, one after the other, 'You don't mean me, do you?'"
,"20":"And Jesus answered, 'It is one of you Twelve, one who dips his bread in the dish with me."
,"21":"The Son of Man is going as the Scriptures say he will. But alas for that man by whom the Son of Man is betrayed; better for him if he had never been born.'"
,"22":"While they were eating, Jesus took bread, blessed and broke it, and gave it to them. And he said, 'Take this, it is my body.'"
,"23":"Then he took a cup and after he had given thanks, passed it to them and they all drank from it."
,"24":"And he said, 'This is my blood, the blood of the Covenant, which is to be poured out for many."
,"25":"Truly, I say to you, I will not taste the fruit of the vine again until the day I drink the new wine in the kingdom of God.'"
,"26":"After singing psalms of praise, they went out to the Hill of Olives."
,"27":"And Jesus said to them, 'All of you will be confused and fall away; for the Scripture says: I will strike the shepherd and the sheep will be scattered."
,"28":"But after I am raised up, I will go to Galilee ahead of you.'"
,"29":"Then Peter said to him, 'Even though all the others fall away, I will not.'"
,"30":"And Jesus replied, 'Truly, I say to you, today, this very night before the cock crows twice, you will deny me three times.'"
,"31":"But Peter insisted,'Though I have to die with you, I will never deny you.' And all of them said the same."
,"32":"They came to a place which was called Gethsemane and Jesus said to his disciples, 'Sit here while I pray.'"
,"33":"But he took Peter, James and John along with him, and becoming filled with fear and distress,"
,"34":"he said to them, 'My soul is full of sorrow, even to death. Remain here and stay awake.'"
,"35":"Then he went a little further on and fell to the ground, praying that if possible this hour might pass him by. Jesus said,"
,"36":"'Abba (Daddy), all things are possible for you; take this cup away from me. Yet not what I want, but what you want.'"
,"37":"Then he came and found them asleep and said to Peter, 'Simon, are you sleeping? Couldn't you stay awake for one hour?"
,"38":"Keep watch and pray, all of you, so that you may not slip into temptation. The spirit indeed is eager but human nature is weak."
,"39":"And going away he prayed saying the same words."
,"40":"When he came back to the disciples, he found them asleep again; they could not keep their eyes open, and they did not know what to say to him."
,"41":"When he came back the third time, he said, 'You can sleep on now and take your rest! It is all over, the time has come; the Son of Man is now given into the hands of sinners."
,"42":"Get up, let us go. Look: the one betraying me is right here.'"
,"43":"While Jesus was still speaking, Judas, one of the twelve, came up. With him was a crowd armed with swords and clubs, who had been sent by the chief priests, the teachers of the Law and the elders."
,"44":"The traitor had arranged a signal for them, 'The one I kiss, he is the man. Arrest him and take him away under guard.'"
,"45":"So, when he came, he went directly to Jesus calling, 'Master! Master!' and kissed him."
,"46":"Then they seized Jesus and arrested him."
,"47":"One of the bystanders drew his sword and struck out at the High Priest's servant, cutting off his ear."
,"48":"Jesus turned to them saying, 'So you have set out against a robber! Did you need swords and clubs to arrest me?"
,"49":"Day after day I was among you teaching in the Temple and you did not arrest me. But let the Scriptures be fulfilled.'"
,"50":"Then they all deserted him and fled."
,"51":"A young man covered by nothing but a linen cloth followed Jesus. As they took hold of him,"
,"52":"he left the cloth in their hands and fled away naked."
,"53":"They led Jesus to the High Priest and all the chief priests assembled with the elders and the teachers of the Law."
,"54":"Peter had followed him at a distance and went right into the courtyard of the High Priest, where he sat with the guards, warming himself at the fire."
,"55":"Now the chief priests and the whole Council tried to find some evidence against Jesus so that they might put him to death, but they were unable to find any."
,"56":"Even though many came up to speak falsely against him, their evidence did not agree."
,"57":"At last some stood up and gave this false witness:"
,"58":"'We heard him say: 'I will destroy this Temple made by hands and in three days I will build another not made by human hands.'"
,"59":"But even so their evidence did not agree."
,"60":"The High Priest then stood up in the midst of them and asked Jesus, 'Have you no answer at all? What of this evidence against you?'"
,"61":"But Jesus was silent and made no reply. The High Priest put a second question to him, 'Are you the Christ, the Son of the Blessed One?'"
,"62":"Then Jesus answered, 'I am, and you will see the Son of Man seated at the right hand of the Most Powerful and coming with the clouds of heaven around him.'"
,"63":"The High Priest tore his clothes to show his horror and said, 'What more evidence do we need?"
,"64":"You have just heard his blasphemous words. What is your decision?' And they all condemned Jesus saying, 'He must die.'"
,"65":"Some of them began to spit on Jesus and, blindfolding him, they struck him saying, 'Play the prophet!' And the guards set upon him with blows."
,"66":"While Peter was below in the courtyard, one of the High Priest's servant-girls came by."
,"67":"Noticing Peter beside the fire, she looked straight at him and said, 'You also were with Jesus, the Nazarene.'"
,"68":"But he denied it, 'I don't know or understand what you are talking about.' And he went out through the gateway."
,"69":"The servant-girl saw him there and told the bystanders, 'This man is one of them.'"
,"70":"But Peter denied it again. After a little while those standing by said to Peter, 'Of course you are one of them; you are a Galilean, aren't you?'"
,"71":"And Peter began to justify himself with curses and oaths, 'I don't know the man you are talking about.'"
,"72":"Just then a cock crowed a second time and Peter remembered what Jesus had said to him, 'Before the cock crows twice you will deny me three times.' And he broke down and wept."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Early in the morning, the chief priests, the elders and the teachers of the Law (that is, the whole Council or Sanhedrin) had their plan ready. They put Jesus in chains, led him away and handed him over to Pilate."
,"2":"Pilate asked him, 'Are you the King of the Jews?' Jesus answered, 'You say so.'"
,"3":"As the chief priests accused Jesus of many things,"
,"4":"Pilate asked him again, 'Have you no answer at all? See how many charges they bring against you.'"
,"5":"But Jesus gave no further answers, so that Pilate wondered."
,"6":"At every Passover festival, Pilate used to free any prisoner the people asked for."
,"7":"Now there was a man called Barabbas, jailed with the rioters who had committed murder in the uprising."
,"8":"When the crowd went up to ask Pilate the usual favor,"
,"9":"he said to them, 'Do you want me to set free the King of the Jews?'"
,"10":"For he realized that the chief priests had handed Jesus over to him out of envy."
,"11":"But the chief priests stirred up the crowd to ask instead for the release of Barabbas."
,"12":"Pilate replied, 'And what shall I do with the man you call King of the Jews?'"
,"13":"The crowd shouted back, 'Crucify him!'"
,"14":"Pilate asked, 'What evil has he done?' But they shouted the louder, 'Crucify him!'"
,"15":"As Pilate wanted to please the people, he freed Barabbas and after the flogging of Jesus had him handed over to be crucified."
,"16":"The soldiers took him inside the courtyard known as the praetorium and called the rest of their companions."
,"17":"They clothed him in a purple cloak and twisting a crown of thorns, they forced it onto his head."
,"18":"Then they began saluting him, 'Long life to the King of the Jews!'"
,"19":"With a stick they gave him blows on the head and spat on him; then they knelt down pretending to worship him."
,"20":"When they had finished mocking him, they pulled off the purple cloak and put his own clothes on him. The soldiers led him out of the city to crucify him."
,"21":"On the way they met Simon of Cyrene, father of Alexander and Rufus, who was coming in from the country, and forced him to carry the cross of Jesus."
,"22":"When they had led him to the place called Golgotha, which means the Skull,"
,"23":"they offered him wine mixed with myrrh, but he would not take it."
,"24":"Then they nailed him to the cross and divided his clothes among themselves, casting lots to decide what each should take."
,"25":"It was about nine o'clock in the morning when they crucified him."
,"26":"The statement of his offense was displayed above his head and it read, 'The King of the Jews.'"
,"27":"They also crucified two robbers with him, one on his right and one on his left."
,"29":"People passing by laughed at him, shook their head and jeered, 'Aha! So you are able to tear down the Temple and build it up again in three days."
,"30":"Now save yourself and come down from the cross!'"
,"31":"In the same way the chief priests and the teachers of the Law mocked him saying to one another, 'The man who saved others cannot save himself."
,"32":"Let's see the Messiah, the king of Israel, come down from his cross and then we will believe in him.' Even the men who were crucified with Jesus insulted him."
,"33":"When noon came, darkness fell over the whole land and lasted until three o'clock;"
,"34":"and at three o'clock Jesus cried out in a loud voice, 'Eloi, Eloi, lamma sabachthani?' which means 'My God, my God, why have you deserted me?'"
,"35":"As soon as they heard these words, some of the bystanders said, 'Listen! He is calling for Elijah.'"
,"36":"And one of them went quickly to fill a sponge with bitter wine and, putting it on a reed, gave him to drink saying, 'Now let's see whether Elijah comes to take him down.'"
,"37":"But Jesus uttered a loud cry and gave up his spirit."
,"38":"And immediately the curtain which enclosed the Temple sanctuary was torn in two from top to bottom."
,"39":"The captain who was standing in front of him saw how Jesus died and heard the cry he gave; and he said, 'Truly, this man was the Son of God.'"
,"40":"There were also some women watching from a distance; among them were Mary Magdalene, Mary the mother of James the younger and Joset, and Salome,"
,"41":"who had followed Jesus when he was in Galilee and saw to his needs. There were also others who had come up with him to Jerusalem."
,"42":"It was now evening and as it was Preparation Day, that is the day before the sabbath,"
,"43":"Joseph of Arimathea boldly went to Pilate and asked for the body of Jesus. Joseph was a respected member of the Council who was himself waiting for the kingdom of God."
,"44":"Pilate was surprised that Jesus should have died so soon; so he summoned the captain and inquired if Jesus was already dead."
,"45":"After hearing the captain, he let Joseph have the body."
,"46":"Joseph took it down and wrapped it in the linen sheet he had bought. He laid the body in a tomb which had been cut out of the rock and rolled a stone across the entrance to the tomb."
,"47":"Now Mary of Magdala and Mary the mother of Joset took note of where the body had been laid."
}`)
	CurrentBook.AddChapter(16, `{
"1":"When the sabbath was over, Mary of Magdala, Mary the mother of James, and Salome bought spices so that they might go and anoint the body."
,"2":"And very early in the morning on the first day of the week, just after sunrise, they came to the tomb."
,"3":"They were saying to one another, 'Who will roll back the stone for us from the entrance to the tomb?'"
,"4":"But as they looked up, they noticed that the stone had already been rolled away. It was a very big stone."
,"5":"As they entered the tomb, they saw a young man in a white robe seated on the right, and they were amazed."
,"6":"But he said to them, 'Don't be alarmed; you are looking for Jesus of Nazareth who was crucified; he has been raised and is not here. This is, however, the place where they laid him."
,"7":"Now go and tell his disciples and Peter: Jesus is going ahead of you to Galilee; you will see him there just as he told you.'"
,"8":"The women went out and fled from the tomb, for terror and amazement had seized them. And they were so afraid that they said nothing to anyone."
,"9":"After Jesus rose early on the first day of the week, he appeared first to Mary of Magdala from whom he had driven out seven demons."
,"10":"She went and reported the news to his followers, who were now mourning and weeping."
,"11":"But when they heard that he lived and had been seen by her, they would not believe it."
,"12":"After this he showed himself in another form to two of them, as they were walking into the country."
,"13":"These men too went back and told the others, but they did not believe them."
,"14":"Later Jesus showed himself to the Eleven while they were at table. He reproached them for their unbelief and stubbornness in refusing to believe those who had seen him after he had risen."
,"15":"Then he told them, 'Go out to the whole world and proclaim the Good News to all creation."
,"16":"The one who believes and is baptized will be saved; the one who refuses to believe will be condemned."
,"17":"Signs like these will accompany those who have believed: in my Name they will cast out demons and speak new languages;"
,"18":"they will pick up snakes and, if they drink anything poisonous, they will be unharmed. They will lay their hands on the sick and they will be healed.'"
,"19":"So then, after speaking to them, the Lord Jesus was taken up into heaven and took his place at the right hand of God."
,"20":"The Eleven went forth and preached everywhere, while the Lord worked with them and confirmed the message by the signs which accompanied them."
}`)

}
func EN_CCB_LoadNEMTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"This is the document of the origins of Jesus Christ, son of David, son of Abraham."
,"2":"Abraham was the father of Isaac, Isaac the father of Jacob, Jacob the father of Judah and his brothers."
,"3":"Judah was the father of Perez and Zerah (their mother was Tamar), Perez was the father of Hezron, and Hezron of Aram."
,"4":"Aram was the father of Aminadab, Aminadab of Nahshon, Nahshon of Salmon."
,"5":"Salmon was the father of Boaz. His mother was Rahab. Boaz was the father of Obed. His mother was Ruth. Obed was the father of Jesse."
,"6":"Jesse was the father of David, the king. David was the father of Solomon. His mother had been Uriah's wife."
,"7":"Solomon was the father of Rehoboam. Then came the kings: Abijah, Asaph,"
,"8":"Jehoshaphat, Joram, Uzziah,"
,"9":"Jotham, Ahaz, Hezekiah,"
,"10":"Manasseh, Amon, Josiah."
,"11":"Josiah was the father of Jechoniah and his brothers at the time of the deportation to Babylon."
,"12":"After the deportation to Babylon Jechoniah was the father of Salathiel and Salathiel of Zerubbabel."
,"13":"Zerubbabel was the father of Abiud, Abiud of Eliakim, and Eliakim of Azor."
,"14":"Azor was the father of Zadok, Zadok the father of Akim, and Akim the father of Eliud."
,"15":"Eliud was the father of Eleazar, Eleazar of Matthan, and Matthan of Jacob."
,"16":"Jacob was the father of Joseph, the husband of Mary, and from her came Jesus who is called the Christ - the Messiah."
,"17":"There were then fourteen generations in all from Abraham to David, and fourteen generations from David to the deportation to Babylon, and fourteen generations from the deportation to Babylon to the birth of Christ."
,"18":"This is how Jesus Christ was born. Mary his mother had been given to Joseph in marriage but before they lived together, she was found to be pregnant through the Holy Spirit."
,"19":"Then Joseph, her husband, made plans to divorce her in all secrecy. He was an upright man, and in no way did he want to discredit her."
,"20":"While he was pondering over this, an angel of the Lord appeared to him in a dream and said, 'Joseph, descendant of David, do not be afraid to take Mary as your wife. She has conceived by the Holy Spirit,"
,"21":"and now she will bear a son. You shall call him 'Jesus' for he will save his people from their sins.'"
,"22":"All this happened in order to fulfill what the Lord had said through the prophet:"
,"23":"The virgin will conceive and bear a son, and he will be called Emmanuel which means: God-with-us."
,"24":"When Joseph woke up, he did what the angel of the Lord had told him to do and he took his wife to his home."
,"25":"So she gave birth to a son and he had not had marital relations with her. Joseph gave him the name of Jesus."
}`)
	CurrentBook.AddChapter(2, `{
"1":"When Jesus was born in Bethlehem, in Judea, during the days of King Herod, wise men from the east arrived in Jerusalem."
,"2":"They asked, 'Where is the newborn king of the Jews? We saw the rising of his star in the east and have come to honor him.'"
,"3":"When Herod heard this he was greatly disturbed and with him all Jerusalem."
,"4":"He immediately called a meeting of all high-ranking priests and those who taught the people of God his Law, and asked them where the Messiah was to be born."
,"5":"'In the town of Bethlehem in Judea,' they told him, 'for this is what the prophet wrote:"
,"6":"And you, Bethlehem, in the land of Judah, you are by no means the least among the clans of Judah, for from you will come a leader, the one who is to shepherd my people Israel.'"
,"7":"Then Herod secretly called the wise men and asked them the precise time the star appeared."
,"8":"Then he sent them to Bethlehem with the instruction, 'Go and get precise information about the child. As soon as you have found him, report to me, so that I too may go and honor him.'"
,"9":"After the meeting with the king, they set out. The star that they had seen in the East went ahead of them and stopped over the place where the child was."
,"10":"The wise men were overjoyed on seeing the star again."
,"11":"They went into the house and when they saw the child with Mary his mother, they knelt and worshiped him. They opened their bags and offered him their gifts of gold, incense and myrrh."
,"12":"In a dream they were warned not to go back to Herod, so they returned to their home country by another way."
,"13":"After the wise men had left, an angel of the Lord appeared in a dream to Joseph and said, 'Get up, take the child and his mother and flee to Egypt, and stay there until I tell you for Herod will soon be looking for the child in order to kill him.'"
,"14":"Joseph got up, took the child and his mother, and left that night for Egypt,"
,"15":"where he stayed until the death of Herod. In this way, what the Lord had said through the prophet was fulfilled: I called my son out of Egypt."
,"16":"When Herod found out that he had been tricked by the wise men, he was furious. He gave orders to kill all the boys in Bethlehem and its neighborhood who were two years old or under. This was done in line with what he had learned from the wise men about the time when the star appeared."
,"17":"In this way, what the prophet Jeremiah had said was fulfilled:"
,"18":"A cry is heard in Ramah, wailing and loud lamentation: Rachel weeps for her children. She refuses to be comforted, for they are no more."
,"19":"After Herod's death, an angel of the Lord appeared in a dream to Joseph and said,"
,"20":"'Get up, take the child and his mother and go back to the land of Israel, because those who tried to kill the child are dead.'"
,"21":"So Joseph got up, took the child and his mother and went to the land of Israel."
,"22":"But when Joseph heard that Archilaus had succeeded his father Herod as king of Judea, he was afraid to go there. He was given further instructions in a dream, and went to the region of Galilee."
,"23":"There he settled in a town called Nazareth. In this way what was said by the prophets was fulfilled: He shall be called a Nazorean."
}`)
	CurrentBook.AddChapter(3, `{
"1":"In the course of time John the Baptist appeared in the desert of Judea and began to proclaim his message,"
,"2":"'Change your ways, the Kingdom of heaven is now at hand!'"
,"3":"It was about him that the prophet Isaiah had spoken when he said, A voice is shouting in the desert: prepare a way for the Lord; make his paths straight."
,"4":"John had a leather garment around his waist and wore a cloak of camel's hair; his food was locusts and wild honey."
,"5":"People came to him from Jerusalem, from all Judea and from the whole Jordan valley,"
,"6":"and they were baptized by him in the Jordan as they confessed their sins."
,"7":"When he saw several Pharisees and Sadduccees coming to where he baptized, he said to them, 'Brood of vipers! Who told you that you could escape the punishment that is to come?"
,"8":"Let it be seen that you are serious in your conversion,"
,"9":"and do not think: We have Abraham for our father. I tell you that God can raise children for Abraham from these stones!"
,"10":"The axe is already laid to the roots of the trees; any tree that does not produce good fruit will be cut down and thrown in the fire."
,"11":"I baptize you in water for a change of heart, but the one who is coming after me is more powerful than me; indeed I am not worthy to carry his sandals. He will baptize you in the Holy Spirit and fire."
,"12":"He has the winnowing fan in his hand and he will clear out his threshing floor. He will gather his wheat into the barn, but the chaff he will burn in everlasting fire.'"
,"13":"At that time Jesus arrived from Galilee and came to John at the Jordan to be baptized by him."
,"14":"But John tried to prevent him, and said, 'How is it you come to me: I should be baptized by you!'"
,"15":"But Jesus answered him, 'Let it be like that for now that we may fulfill the right order.' John agreed."
,"16":"As soon as he was baptized, Jesus came up from the water. At once, the heavens opened and he saw the Spirit of God come down like a dove and rest upon him."
,"17":"At the same time a voice from heaven was heard, 'This is my Son, the Beloved; he is my Chosen One.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Then the Spirit led Jesus into the desert that he be put to the test by the devil."
,"2":"After spending forty days and nights without food, Jesus was hungry."
,"3":"Then the devil came to him and said, 'If you are the Son of God, order these stones to turn into bread.'"
,"4":"But Jesus answered, 'Scripture says: one does not live on bread alone, but on every word that comes from the mouth of God.'"
,"5":"Then the devil took Jesus to the holy city, set him on the highest wall of the temple, and said to him,"
,"6":"'If you are the Son of God, throw yourself down, for scripture says, God has given orders to his angels about you. Their hands will hold you up lest you hurt your foot against a stone.'"
,"7":"Jesus answered, 'But scripture also says: You shall not put to the test the Lord your God.'"
,"8":"Then the devil took Jesus to a very high mountain and showed him all the nations of the world in all their greatness and splendor. And he said,"
,"9":"'All this I will give you, if you kneel and worship me.'"
,"10":"Then Jesus answered, 'Be off, Satan! Scripture says: worship the Lord your God and serve him alone.'"
,"11":"Then the devil left him, and angels came to serve him."
,"12":"When Jesus heard that John had been arrested, he withdrew into Galilee."
,"13":"He left Nazareth and went to settle down in Capernaum, a town by the lake of Galilee, at the border of Zebulun and Naphtali."
,"14":"In this way the word of the prophet Isaiah was fulfilled:"
,"15":"Land of Zebulun and land of Naphtali crossed by the Road of the Sea, and you who live by the Jordan, Galilee, land of pagans, listen:"
,"16":"The people who lived in darkness have seen a great light; on those who live in the land of the shadow of death, a light has shone."
,"17":"From that time on Jesus began to proclaim his message, 'Change your ways: the kingdom of heaven is near.'"
,"18":"As Jesus walked by the lake of Galilee, he saw two brothers, Simon called Peter, and Andrew his brother, casting a net into the lake, for they were fishermen."
,"19":"He said to them, 'Come, follow me, and I will make you fish for people.'"
,"20":"At once they left their nets and followed him."
,"21":"He went on from there and saw two other brothers, James, the son of Zebedee, and his brother John in a boat with their father Zebedee, mending their nets. Jesus called them."
,"22":"At once they left the boat and their father and followed him."
,"23":"Jesus went around all Galilee, teaching in their synagogues, proclaiming the good news of the Kingdom, and curing all kinds of sickness and disease among the people."
,"24":"The news about him spread through the whole of Syria, and the people brought all their sick to him, and all those who suffered: the possessed, the deranged, the paralyzed, and he healed them all."
,"25":"Large crowds followed him from Galilee and the Ten Cities, from Jerusalem, Judea, and from across the Jordan."
}`)
	CurrentBook.AddChapter(5, `{
"1":"When Jesus saw the crowds, he went up the mountain. He sat down and his disciples gathered around him."
,"2":"Then he spoke and began to teach them:"
,"3":"Fortunate are those who have the spirit of the poor, for theirs is the kingdom of heaven."
,"4":"Fortunate are those who mourn, they shall be comforted."
,"5":"Fortunate are the gentle, they shall possess the land."
,"6":"Fortunate are those who hunger and thirst for justice, for they shall be satisfied."
,"7":"Fortunate are the merciful, for they shall find mercy."
,"8":"Fortunate are those with a pure heart, for they shall see God."
,"9":"Fortunate are those who work for peace, they shall be called children of God."
,"10":"Fortunate are those who are persecuted for the cause of justice, for theirs is the kingdom of heaven."
,"11":"Fortunate are you, when people insult you and persecute you and speak all kinds of evil against you because you are my followers."
,"12":"Be glad and joyful, for a great reward is kept for you in God. This is how this people persecuted the prophets who lived before you."
,"13":"You are the salt of the earth. But if salt has lost its strength, how can it be made salty again? It has become useless. It can only be thrown away and people will trample on it."
,"14":"You are the light of the world. A city built on a mountain cannot be hidden."
,"15":"No one lights a lamp and covers it; instead it is put on a lampstand, where it gives light to everyone in the house."
,"16":"In the same way your light must shine before others, so that they may see the good you do and praise your Father in heaven."
,"17":"Do not think that I have come to remove the Law and the Prophets. I have not come to remove but to fulfill them."
,"18":"I tell you this: as long as heaven and earth last, not the smallest letter or stroke of the Law will change until all is fulfilled."
,"19":"So then, whoever breaks the least important of these commandments and teaches others to do the same will be the least in the kingdom of heaven. On the other hand, whoever obeys them and teaches others to do the same will be great in the kingdom of heaven."
,"20":"I tell you, then, that if you are not righteous in a better way than the teachers of the Law and the Pharisees, you cannot enter the kingdom of heaven."
,"21":"You have heard that it was said to our people in the past: Do not commit murder; anyone who does kill will have to face trial."
,"22":"But now I tell you: whoever gets angry with a brother or sister will have to face trial. Whoever insults a brother or sister deserves to be brought before the council; whoever humiliates a brother or sister deserves to be thrown into the fire of hell."
,"23":"So, if you are about to offer your gift at the altar and you remember that your brother has something against you,"
,"24":"leave your gift there in front of the altar, go at once and make peace with him, and then come back and offer your gift to God."
,"25":"Don't forget this: be reconciled with your opponent quickly when you are together on the way to court. Otherwise he will turn you over to the judge, who will hand you over to the police, who will put you in jail."
,"26":"There you will stay, until you have paid the last penny."
,"27":"You have heard that it was said: Do not commit adultery."
,"28":"But I tell you this: anyone who looks at a woman to satisfy his lust has in fact already committed adultery with her in his heart."
,"29":"So, if your right eye causes you to sin, pull it out and throw it away! It is much better for you to lose a part of your body than to have your whole body thrown into hell."
,"30":"If your right hand causes you to sin, cut it off and throw it away! It is better for you to lose a part of your body than to have your whole body thrown into hell."
,"31":"It was also said: anyone who divorces his wife must give her a written notice of divorce."
,"32":"But what I tell you is this: If a man divorces his wife except in the case of unlawful union, he causes her to commit adultery. And the man who marries a divorced woman commits adultery."
,"33":"You have also heard that people were told in the past: Do not break your oath; an oath sworn to the Lord must be kept."
,"34":"But I tell you this: do not take oaths. Do not swear by the heavens, for they are God's throne,"
,"35":"nor by the earth, because it is his footstool, nor by Jerusalem because it is the city of the great king."
,"36":"Do not even swear by your head, because you cannot make a single hair white or black."
,"37":"Say yes when you mean yes and say no when you mean no. Anything else you say comes from the devil."
,"38":"You have heard that it was said: An eye for an eye and a tooth for a tooth."
,"39":"But I tell you this: do not oppose evil with evil; if someone slaps you on your right cheek, turn and offer the other."
,"40":"If someone sues you in court for your shirt, give your coat as well."
,"41":"If someone forces you to go one mile, go also the second mile."
,"42":"Give when asked and do not turn your back on anyone who wants to borrow from you."
,"43":"You have heard that it was said: Love your neighbor and do not do good to your enemy."
,"44":"But this I tell you: Love your enemies, and pray for those who persecute you,"
,"45":"so that you may be children of your Father in Heaven. For he makes his sun rise on both the wicked and the good, and he gives rain to both the just and the unjust."
,"46":"If you love those who love you, what is special about that? Do not even tax collectors do as much?"
,"47":"And if you are friendly only to your friends, what is so exceptional about that? Do not even the pagans do as much?"
,"48":"For your part you shall be righteous and perfect in the way your heavenly Father is righteous and perfect."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Be careful not to make a show of your righteousness before people. If you do so, you do not gain anything from your Father in heaven."
,"2":"When you give something to the poor, do not have it trumpeted before you, as do those who want to be seen in the synagogues and in the streets in order to be praised by the people. I assure you, they have been already paid in full."
,"3":"If you give something to the poor, do not let your left hand know what your right hand is doing,"
,"4":"so that your gift remains really secret. Your Father who sees what is kept secret, will reward you."
,"5":"When you pray, do not be like those who want to be seen. They love to stand and pray in the synagogues or on street corners to be seen by everyone. I assure you, they have already been paid in full."
,"6":"When you pray, go into your room, close the door and pray to your Father who is with you in secret; and your Father who sees what is kept secret will reward you."
,"7":"When you pray, do not use a lot of words, as the pagans do, for they hold that the more they say, the more chance they have of being heard."
,"8":"Do not be like them. Your Father knows what you need, even before you ask him."
,"9":"This, then, is how you should pray: Our Father in heaven, holy be your name,"
,"10":"your kingdom come,and your will be done, on earth as in heaven."
,"11":"Give us today the kind of bread we need."
,"12":"Forgive us our debts,just as we have forgiven those who are in debt to us."
,"13":"Do not bring us to the test,but deliver us from the evil one."
,"14":"If you forgive others their wrongs, your Father in heaven will also forgive yours."
,"15":"If you do not forgive others, then your Father will not forgive you either."
,"16":"When you fast, do not put on a miserable face as do the hypocrites. They put on a gloomy face, so people can see they are fasting. I tell you this: they have been paid in full already."
,"17":"When you fast, wash your face and make yourself look cheerful,"
,"18":"because you are not fasting for appearances or for people, but for your Father who sees beyond appearances. And your Father, who sees what is kept secret will reward you."
,"19":"Do not store up treasure for yourself here on earth where moth and rust destroy it, and where thieves can steal it."
,"20":"Store up treasure for yourself with God, where no moth or rust can destroy nor thief come and steal it."
,"21":"For where your treasure is, there also your heart will be."
,"22":"The lamp of the body is the eye; if your eyes are sound, your whole body will be in the light."
,"23":"If your eyes are diseased your whole body will be in darkness. Then, if your light has become darkness, how dark will be the darkest part of you!"
,"24":"No one can serve two masters; for he will either hate one and love the other, or he will be loyal to the first and look down on the second. You cannot at the same time serve God and money."
,"25":"This is why I tell you not to be worried about food and drink for yourself, or about clothes for your body. Is not life more important than food and is not the body more important than clothes?"
,"26":"Look at the birds of the air; they do not sow, they do not harvest and do not store food in barns, and yet your heavenly Father feeds them. Are you not worth much more than birds?"
,"27":"Can any of you add a day to your life by worrying about it?"
,"28":"Why are you so worried about your clothes? Look at the flowers in the fields how they grow. They do not toil or spin."
,"29":"But I tell you that not even Solomon in all his wealth was clothed like one of these."
,"30":"If God so clothes the grass in the field which blooms today and is to be burned tomorrow in an oven, how much more will he clothe you? What little faith you have!"
,"31":"Do not worry and say: What are we going to eat? What are we going to drink? Or: what shall we wear?"
,"32":"The pagans busy themselves with such things; but your heavenly Father knows that you need them all."
,"33":"Set your heart first on the kingdom and justice of God and all these things will also be given to you."
,"34":"Do not worry about tomorrow for tomorrow will worry about itself. Each day has enough trouble of its own."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Do not judge and you will not be judged."
,"2":"In the same way you judge others, you will be judged, and the measure you use for others will be used for you."
,"3":"Why do you look at the speck in your brother's eye and not see the plank in your own eye?"
,"4":"How can you say to your brother: 'Come, let me take the speck from your eye,' as long as that plank is in your own?"
,"5":"Hypocrite, take first the plank out of your own eye, then you will see clear enough to take the speck out of your brother's eye."
,"6":"Do not give what is holy to the dogs, or throw your pearls to pigs: they might trample on them and even turn on you and tear you to pieces."
,"7":"Ask and you will receive; seek and you will find; knock and the door will be opened."
,"8":"For everyone who asks, receives; whoever seeks, finds; and the door will be opened to him who knocks."
,"9":"Would any of you give a stone to your son when he asks for bread?"
,"10":"Or give him a snake, when he asks for a fish?"
,"11":"As bad as you are, you know how to give good things to your children. How much more, then, will your Father in heaven give good things to those who ask him!"
,"12":"So, do to others whatever you would that others do to you: there you have the Law and the Prophets."
,"13":"Enter through the narrow gate; for wide is the gate and broad is the road that leads to destruction, and many go that way."
,"14":"How narrow is the gate that leads to life and how rough the road; few there are who find it."
,"15":"Beware of false prophets: they come to you in sheep's clothing but inside they are wild wolves."
,"16":"You will recognize them by their fruits. Do you ever pick grapes from thornbushes, or figs from thistles?"
,"17":"A good tree always produces good fruit, a rotten tree produces bad fruit."
,"18":"A good tree cannot produce bad fruit and a rotten tree cannot bear good fruit."
,"19":"Any tree that does not bear good fruit is cut down and thrown in the fire."
,"20":"So you will know them by their fruit."
,"21":"Not everyone who says to me: Lord! Lord! will enter the kingdom of heaven, but the one who does the will of my heavenly Father."
,"22":"Many will say to me on that day, 'Lord, Lord, did we not speak in your name? Did we not cast out devils and perform many miracles in your name?'"
,"23":"Then I will tell them openly: I have never known you; away from me, you evil people!"
,"24":"'So, then, anyone who hears these words of mine and acts accordingly is like a wise man, who built his house on rock."
,"25":"The rain poured, the rivers flooded, and the wind blew and struck that house, but it did not collapse because it was built on rock."
,"26":"But anyone who hears these words of mine and does not act accordingly, is like a fool who built his house on sand."
,"27":"The rain poured, the rivers flooded, and the wind blew and struck that house; it collapsed, and what a terrible fall that was!'"
,"28":"When Jesus had finished this discourse, the crowds were struck by the way he taught,"
,"29":"because he taught with authority unlike their teachers of the Law."
}`)
	CurrentBook.AddChapter(8, `{
"1":"When Jesus came down from the mountain, large crowds followed him."
,"2":"Then a leper came forward. He knelt before him and said, 'Sir, if you want to, you can make me clean.'"
,"3":"Jesus stretched out his hand, touched him, and said, 'I want to, be clean again.' At that very moment the man was cleansed from his leprosy."
,"4":"Then Jesus said to him, 'See that you do not tell anyone, but go to the priest, have yourself declared clean, and offer the gift that Moses ordered as proof of it.'"
,"5":"When Jesus entered Capernaum, an army captain approached him to ask his help,"
,"6":"'Sir, my servant lies sick at home. He is paralyzed and suffers terribly.'"
,"7":"Jesus said to him, 'I will come and heal him.'"
,"8":"The captain answered, 'I am not worthy to have you under my roof. Just give an order and my boy will be healed."
,"9":"For I myself, a junior officer, give orders to my soldiers. And if I say to one: 'Go,' he goes, and if I say to another: 'Come,' he comes, and to my servant: 'Do this,' he does it.'"
,"10":"When Jesus heard this he was astonished and said to those who were following him, 'I tell you, I have not found such faith in Israel."
,"11":"I say to you, many will come from east and west and sit down with Abraham, Isaac and Jacob at the feast in the kingdom of heaven;"
,"12":"but the heirs of the kingdom will be thrown out into the darkness; there they will wail and grind their teeth.'"
,"13":"Then Jesus said to the captain, 'Go home now. As you believed, so let it be.' And at that moment his servant was healed."
,"14":"Jesus went to Peter's house and found Peter's mother-in-law in bed with fever."
,"15":"He took her by the hand and the fever left her; she got up and began to wait on him."
,"16":"Towards evening they brought to Jesus many possessed by evil spirits, and with a word he drove out the spirits. He also healed all who were sick."
,"17":"In doing this he fulfilled what was said by the prophet Isaiah: He bore our infirmities and took on himself our diseases."
,"18":"When he saw the crowd press around him, Jesus gave orders to cross to the other shore."
,"19":"A teacher of the Law approached him and said, 'Master, I will follow you wherever you go.'"
,"20":"Jesus said to him, 'Foxes have holes and birds have nests, but the Son of Man has nowhere to lay his head.'"
,"21":"Another disciple said to him, 'Lord, let me go and bury my father first.'"
,"22":"But Jesus answered him, 'Follow me, and let the dead bury their own dead.'"
,"23":"Jesus got into the boat and his disciples followed him."
,"24":"Without warning a fierce storm hit the lake, with waves sweeping the boat. But Jesus was asleep."
,"25":"They woke him and cried, 'Lord save us! We are lost!'"
,"26":"But Jesus answered, 'Why are you so afraid, you of little faith?' Then he stood up and ordered the wind and sea; and it became completely calm."
,"27":"The people were astonished. They said, 'What kind of man is he? Even the winds and the sea obey him.'"
,"28":"When Jesus reached Gadara on the other side, he was met by two demoniacs who came out from the tombs. They were so fierce that no one dared to pass that way."
,"29":"Suddenly they shouted, 'What do you want with us, you, Son of God? Have you come to torture us before the time?'"
,"30":"At some distance away there was a large herd of pigs feeding."
,"31":"So the demons begged him, 'If you drive us out, send us into that herd of pigs.'"
,"32":"Jesus ordered them, 'Go.' So they left and went into the pigs. The whole herd rushed down the cliff into the lake and drowned."
,"33":"The men in charge of them ran off to the town, where they told the whole story, also what had happened to the men possessed with the demons."
,"34":"Then the whole town went out to meet Jesus; and when they saw him, they begged him to leave their area."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Jesus got back into the boat, crossed the lake again, and came to his hometown."
,"2":"Here they brought a paralyzed man to him, lying on a bed. Jesus saw their faith and said to the paralytic, 'Courage, my son! Your sins are forgiven.'"
,"3":"Then some teachers of the Law said to themselves, 'This man insults God.'"
,"4":"Jesus was aware of what they were thinking, and said, 'Why have you such evil thoughts?"
,"5":"Which is easier to say: 'Your sins are forgiven' or 'Stand up and walk'?"
,"6":"You must know that the Son of Man has authority on earth to forgive sins.' He then said to the paralyzed man, 'Stand up! Take your stretcher and go home.'"
,"7":"The man got up, and went home."
,"8":"When the crowds saw this, they were filled with awe and praised God for giving such power to human beings."
,"9":"As Jesus moved on from there, he saw a man named Matthew at his seat in the custom-house, and he said to him, 'Follow me.' And Matthew got up and followed him."
,"10":"Now it happened, while Jesus was at table in Matthew's house, many tax collectors and other sinners joined Jesus and his disciples."
,"11":"When the Pharisees saw this they said to his disciples, 'Why is it that your master eats with those sinners and tax collectors?'"
,"12":"When Jesus heard this he said, 'Healthy people do not need a doctor, but sick people do."
,"13":"Go and find out what this means: What I want is mercy, not sacrifice. I did not come to call the righteous but sinners.'"
,"14":"Then the disciples of John came to him with the question, 'How is it that we and the Pharisees fast on many occasions, but not your disciples?'"
,"15":"Jesus answered them, 'How can you expect wedding guests to mourn as long as the bridegroom is with them? Time will come when the bridegroom will be taken away from them, then they will fast."
,"16":"No one patches an old coat with a piece of unshrunken cloth, for the patch will shrink and tear an even bigger hole in the coat."
,"17":"Besides you don't put new wine in old wineskins. If you do, the wineskins will burst and the wine be spilt. No, you put new wine in fresh skins; then both are preserved.'"
,"18":"While Jesus was speaking to them, an official of the synagogue came up to him, bowed before him and said, 'My daughter has just died, but come and place your hands on her, and she will live.'"
,"19":"Jesus stood up and followed him with his disciples."
,"20":"Then a woman who had suffered from a severe bleeding for twelve years came up from behind and touched the edge of his cloak."
,"21":"For she thought, 'If I only touch his cloak, I will be healed.'"
,"22":"Jesus turned, saw her and said, 'Courage, my daughter, your faith has saved you.' And from that moment the woman was cured."
,"23":"When Jesus arrived at the official's house and saw the flute players and the excited crowd, he said,"
,"24":"'Get out of here! The girl is not dead. She is only sleeping!' And they laughed at him."
,"25":"But once the crowd had been turned out, Jesus went in and took the girl by the hand, and she stood up."
,"26":"The news of this spread through the whole area."
,"27":"As Jesus moved on from there, two blind men followed him, shouting, 'Son of David, help us!'"
,"28":"When he was about to enter the house, the blind men caught up with him, and Jesus said to them, 'Do you believe that I am able to do what you want?' They answered, 'Yes, sir!'"
,"29":"Then Jesus touched their eyes and said, 'As you have believed, so let it be.'"
,"30":"And their eyes were opened. Then Jesus gave them a stern warning, 'Be careful and let no one know about this.'"
,"31":"But as soon as they went away, they spread the news about him through the whole area."
,"32":"When they had just left, some people brought to Jesus a man who was dumb because he was possessed by a demon."
,"33":"When the demon was driven out, the dumb man began to speak. The crowds were astonished and said, 'Nothing like this has ever been seen in Israel.' ("
,"34":"But the Pharisees said, 'He drives away demons with the help of the prince of demons.')"
,"35":"Jesus went around all the towns and villages, teaching in their synagogues and proclaiming the good news of the Kingdom, and he cured every sickness and disease."
,"36":"When he saw the crowds he was moved with pity, for they were harassed and helpless like sheep without a shepherd."
,"37":"Then he said to his disciples, 'The harvest is abundant but the workers are only few."
,"38":"Ask the master of the harvest to send workers to gather his harvest.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Then he called his twelve disciples to him and gave them authority over the unclean spirits to drive them out and to heal every disease and sickness."
,"2":"These are the names of the twelve apostles: first Simon, called Peter, and his brother Andrew;"
,"3":"James, the son of Zebedee, and his brother John; Philip and Bartholomew, Thomas and Matthew, the tax collector; James, the son of Alphaeus, and Thaddaeus;"
,"4":"Simon, the Canaanite, and Judas Iscariot, the man who would betray him."
,"5":"Jesus sent these twelve on mission with the instruction: 'Do not visit pagan territory and do not enter a Samaritan town."
,"6":"Go instead to the lost sheep of the people of Israel."
,"7":"Go and proclaim this message: The kingdom of heaven is near."
,"8":"Heal the sick, bring the dead back to life, cleanse the lepers, and drive out demons. You received this as a gift, so give it as a gift."
,"9":"Do not carry any gold, silver or copper in your purses."
,"10":"Do not carry a traveler's bag, or an extra shirt, or sandals, or walking-stick: workers deserve their living."
,"11":"When you come to a town or a village, look for a worthy person and stay there until you leave."
,"12":"As you enter the house, wish it peace."
,"13":"If the people in the house deserve it, your peace will be on them; if they do not deserve it, your blessing will come back to you."
,"14":"And if you are not welcomed and your words are not listened to, leave that house or that town and shake the dust off your feet."
,"15":"I assure you, it will go easier for the people of Sodom and Gomorrah on the day of judgment than it will for the people of that town."
,"16":"Look, I send you out like sheep among wolves. You must be clever as snakes and innocent as doves."
,"17":"Be on your guard with respect to people, for they will hand you over to their courts and they will flog you in their synagogues."
,"18":"You will be brought to trial before rulers and kings because of me, and so you may witness to them and the pagans."
,"19":"But when you are arrested, do not worry about what you are to say and how you are to say it; when the hour comes, you will be given what you are to say."
,"20":"For it is not you who will speak; but it will be the Spirit of your Father in you."
,"21":"Brother will hand over brother to death, and a father his child; children will turn against parents and have them put to death."
,"22":"Everyone will hate you because of me, but whoever stands firm to the end will be saved."
,"23":"When they persecute you in one town, flee to the next. For sure, you will not have gone through all the towns of Israel before the Son of Man comes."
,"24":"A student is not above his teacher, or a slave above his master."
,"25":"A student should be glad to become like his teacher, and the slave like his master. If the head of the family has been called Beelzebul, how much more the members of the family! So, do not be afraid of them."
,"26":"There is nothing covered that will not be uncovered, and nothing hidden that will not be made known."
,"27":"What I am telling you in the dark, you must speak in the light. What you hear in private, proclaim from the housetops."
,"28":"Do not be afraid of those who kill the body, but have no power to kill the soul. Rather be afraid of him who can destroy both body and soul in hell."
,"29":"For only a few cents you can buy two sparrows, yet not one sparrow falls to the ground without your Father's consent."
,"30":"As for you, every hair of your head has been counted."
,"31":"So do not be afraid: you are worth much more than many sparrows."
,"32":"Whoever acknowledges me before others I will acknowledge before my Father in heaven."
,"33":"Whoever rejects me before others I will reject before my Father in heaven."
,"34":"Do not think that I have come to establish peace on earth. I have not come to bring peace, but a sword."
,"35":"For I have come to set a man against his father and daughter against her mother; a daughter-in-law against her mother-in-law."
,"36":"Each one will have as enemies those of one's own family."
,"37":"Whoever loves father or mother more than me is not worthy of me. And whoever loves son or daughter more than me is not worthy of me."
,"38":"And whoever does not take up his cross and come after me is not worthy of me."
,"39":"One who wants to benefit from his life will lose it; one who loses his life for my sake will find it."
,"40":"Whoever welcomes you welcomes me, and whoever welcomes me welcomes him who sent me."
,"41":"The one who welcomes a prophet as a prophet will receive the reward of a prophet; the one who welcomes a just man because he is a just man will receive the reward of a just man."
,"42":"And if anyone gives even a cup of cold water to one of these little ones, because he is a disciple of mine, I assure you, he will not go unrewarded.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"When Jesus had finished giving his twelve disciples these instructions, he went on from there to teach and to proclaim his message in their towns."
,"2":"When John the Baptist heard in prison about the activities of Christ, he sent a message by his disciples,"
,"3":"asking him: 'Are you the one who is to come or should we expect someone else?'"
,"4":"Jesus answered them, 'Go back and report to John what you hear and see:"
,"5":"the blind see, the lame walk, the lepers are made clean, the deaf hear, the dead are brought back to life and good news is reaching the poor."
,"6":"And how fortunate is the one who does not take offense at me.'"
,"7":"As the messengers left, Jesus began to speak to the crowds about John, 'When you went out to the desert, what did you expect to see? A reed swept by the wind?"
,"8":"What did you go out to see? A man dressed in fine clothes? People who wear fine clothes live in palaces."
,"9":"What did you actually go out to see? A prophet? Yes, indeed, and even more than a prophet."
,"10":"He is the man of whom Scripture says: I send my messenger ahead of you to prepare the way before you."
,"11":"I tell you this: no one greater than John the Baptist has come forward among the sons of women, and yet the least in the kingdom of heaven is greater than he."
,"12":"From the days of John the Baptist until now the kingdom of heaven is something to be conquered and the unyielding seize it."
,"13":"Up to the time of John, there was only prophesy: all the prophets and the Law;"
,"14":"and if you believe me, John is this Elijah, whose coming was predicted."
,"15":"Let anyone with ears listen!"
,"16":"Now, to what can I compare the people of this day? They are like children sitting in the marketplace, about whom their companions complain:"
,"17":"'We played the flute for you but you would not dance. We sang a funeral-song but you would not cry!'"
,"18":"For John came fasting and people said: 'He is possessed.'"
,"19":"Then the Son of Man came, he ate and drank, and people said: 'Look at this man! A glutton and drunkard, a friend of tax collectors and sinners!' Yet the outcome will prove Wisdom to be right.'"
,"20":"Then Jesus began to denounce the cities in which he had performed most of his miracles, because the people there did not change their ways,"
,"21":"'Alas for you Chorazin and Bethsaida! If the miracles worked in you had taken place in Tyre and Sidon, the people there would have repented long ago in sackcloth and ashes."
,"22":"But I assure you, for Tyre and Sidon it will be more bearable on the day of judgment than for you."
,"23":"And you, Capernaum, will you be lifted up to heaven? You will be thrown down to the place of the dead! For if the miracles which were performed in you had taken place in Sodom, it would still be there today!"
,"24":"But I tell you, it will be more bearable for Sodom on the day of judgment than for you.'"
,"25":"On that occasion Jesus said, 'Father, Lord of heaven and earth, I praise you, because you have hidden these things from the wise and learned and revealed them to simple people."
,"26":"Yes, Father, this is what pleased you."
,"27":"Everything has been entrusted to me by my Father. No one knows the Son except the Father, and no one knows the Father except the Son and those to whom the Son chooses to reveal him."
,"28":"Come to me, all you who work hard and who carry heavy burdens and I will refresh you."
,"29":"Take my yoke upon you and learn from me for I am gentle and humble of heart; and you will find rest."
,"30":"For my yoke is good and my burden is light.'"
}`)
	CurrentBook.AddChapter(12, `{
"1":"It happened that Jesus walked through the wheat fields on a sabbath. His disciples were hungry, and began to pick some heads of wheat and crush them to eat the grain."
,"2":"When the Pharisees noticed this, they said to Jesus, 'Look at your disciples; they are doing what is prohibited on the Sabbath!'"
,"3":"Jesus answered, 'Have you not read what David did when he and his men were hungry?"
,"4":"He went into the house of God, and they ate the bread offered to God, although neither he nor his men had the right to eat it, but only the priests."
,"5":"And have you not read in the Law that on the Sabbath the priests in the Temple break the Sabbath rest, yet they are not guilty?"
,"6":"I tell you, there is greater than the Temple here."
,"7":"If you really knew the meaning of the words: It is mercy I want, not sacrifice, you would not have condemned the innocent."
,"8":"Besides the Son of Man is Lord of the Sabbath.'"
,"9":"Jesus then left that place and went into one of their synagogues."
,"10":"A man was there with a paralyzed hand, and people who wanted to bring a charge against Jesus asked him, 'Is it permitted to heal on the Sabbath?'"
,"11":"But he said to them, 'What if one of you has a sheep and it falls into a pit on the Sabbath? Will you not take hold of your sheep and lift it out?"
,"12":"But a human person is much more valuable than a sheep! It is therefore permitted to do good on the Sabbath.'"
,"13":"Then Jesus said to the man, 'Stretch out your arm.' He stretched it out and it was completely restored, as sound as the other one."
,"14":"Then the Pharisees went out and made plans to get rid of him."
,"15":"As Jesus was aware of the plot, he went away from that place. Many people followed him and he cured all who were sick."
,"16":"Then he gave them strict orders not to make him known."
,"17":"In this way Isaiah's prophecy was fulfilled:"
,"18":"Here is my servant whom I have chosen, the one I love, and with whom I am pleased. I will put my Spirit upon him and he will announce my judgment to the nations."
,"19":"He will not argue or shout, nor will his voice be heard in the streets."
,"20":"The bruised reed he will not crush, nor snuff out the smoldering wick. He will persist until justice is made victorious"
,"21":"and in him all the nations will put their hope.'"
,"22":"Then some people brought to him a possessed man who was blind and who could not talk. Jesus healed the man, who was then able to speak and see."
,"23":"All in the crowd were amazed and wondered, 'Could he be the Son of David?'"
,"24":"When the Pharisees heard this, they said, 'It is by Beelzebul, prince of the devils, that this man drives out devils.'"
,"25":"Jesus knew their thinking, so he said to them, 'Every kingdom that is divided by civil war will fall apart, and every dynasty that is divided cannot last."
,"26":"So if Satan drives out Satan, he is divided: how then can his reign stand?"
,"27":"And if it is by Beelzebul that I drive out devils, by whom do your own people drive them out? They themselves will give you the answer."
,"28":"But if it is by the Spirit of God that I drive out devils, then the kingdom of God has already come upon you."
,"29":"How can anyone break into the strong man's house and make off with his belongings, unless he first ties him up? Only then can he plunder his house."
,"30":"The one who is not with me is against me, and the one who does not gather with me scatters."
,"31":"And so I tell you this: people can be forgiven any sin and any evil thing they say against God, but whoever says evil words against the Spirit will not be forgiven."
,"32":"The one who speaks against the Son of Man, will be forgiven; but the one who speaks against the Holy Spirit will not be forgiven, either in this age or in the age to come."
,"33":"If you have a sound tree, its fruit will be sound; if you have a rotten tree, its fruit will be rotten. For you can know a tree by its fruit."
,"34":"You brood of vipers, how can you say anything good, when you are so evil? For the mouth speaks of what fills the heart."
,"35":"A good person produces good things from his good store, and an evil person produces evil from his evil store."
,"36":"I tell you this; on the judgment day people will have to give an account of any unjustified word they have spoken."
,"37":"Your own words will declare you either innocent or guilty.'"
,"38":"Then some teachers of the Law and some Pharisees spoke up, 'Teacher, we want to see a sign from you.'"
,"39":"Jesus answered them, 'An evil and unfaithful people want a sign, but no sign will be given them except the sign of the prophet Jonah."
,"40":"In the same way that Jonah spent three days and three nights in the belly of the monster fish, so will the Son of Man spend three days and three nights in the depths of the earth."
,"41":"At the judgment, the people of Niniveh will rise with this generation and condemn it, because they reformed their lives at the preaching of Jonah, and here there is greater than Jonah."
,"42":"At the judgment, the Queen of the South will stand up and condemn you. She came from the ends of the earth to listen to the wisdom of Solomon, and here there is greater than Solomon."
,"43":"When an evil spirit goes out of a person, it wanders over arid wastelands looking for a place to rest but it cannot find one."
,"44":"Then it says to itself: 'I will go back to my house which I had to leave.' So it goes back and finds the house empty, clean, and in order."
,"45":"Off it goes again to bring back with it, this time, seven spirits, more evil than itself. They move in and settle there, so that this person is finally in a worse state than he was at the beginning. This is what will happen to this evil generation.'"
,"46":"While Jesus was still talking to the people, his mother and his brothers wanted to speak to him and they waited outside."
,"47":"So someone said to him, 'Your mother and your brothers are just outside; they want to speak with you.'"
,"48":"Jesus answered, 'Who is my mother? Who are my brothers?'"
,"49":"Then he pointed to his disciples and said, 'Look! Here are my mother and my brothers."
,"50":"Whoever does the will of my Father in heaven is for me brother, sister, or mother.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"That same day Jesus left the house and sat down by the lakeside."
,"2":"As many people gathered around him, he got in a boat. There he sat while the whole crowd stood on the shore,"
,"3":"and he spoke to them in parables about many things."
,"4":"Jesus said, 'The sower went out to sow and, as he sowed, some seeds fell along the path and the birds came and ate them up."
,"5":"Other seeds fell on rocky ground where there was little soil, and the seeds sprouted quickly because the soil was not deep."
,"6":"But as soon the sun rose the plants were scorched and withered because they had no roots."
,"7":"Again other seeds fell among thistles; and the thistles grew and choked the plants."
,"8":"Still other seeds fell on good soil and produced a crop; some produced a hundredfold, others sixty and others thirty."
,"9":"If you have ears, then hear!'"
,"10":"Then his disciples came to him with the question, 'Why do you speak to them in parables?'"
,"11":"Jesus answered, 'To you it has been given to know the secrets of the kingdom of heaven, but not to these people."
,"12":"For the one who has, will be given more and he will have in abundance. But the one who does not have will be deprived of even what he has."
,"13":"That is why I speak to them in parables, because they look and do not see; they hear, but they do not listen or understand."
,"14":"In them the words of the prophet Isaiah are fulfilled: Much as you hear, you do not understand; much as you see, you do not perceive."
,"15":"For the heart of this people has grown dull. Their ears hardly hear and their eyes dare not see. If they were to see with their eyes, hear with their ears and understand with their heart, they would turn back and I would heal them."
,"16":"But blessed are your eyes because they see, and your ears, because they hear."
,"17":"For I tell you that many prophets and upright people would have longed to see the things you see, but they did not, and to hear the things you hear, but they did not hear it."
,"18":"Now listen to the parable of the sower."
,"19":"When a person hears the message of the Kingdom but without taking it to himself, the devil comes and snatches away what was sown in his heart. This is the seed that fell along the footpath."
,"20":"The seed that fell on rocky ground stands for the one who hears the word and accepts it at once with joy."
,"21":"But this fickle and has no roots. No sooner is he harassed or persecuted because of the word, than he gives up."
,"22":"The seed that fell among the thistles is the one who hears the word, but then the worries of this life and the love of money choke the word, and it does not bear fruit."
,"23":"As for the seed that fell on good soil it is the one who hears the word and understands it; this bears fruit and produces a hundred, or sixty, or thirty times more.'"
,"24":"Jesus told them another parable, 'The kingdom of heaven can be compared to a man who sowed good seed in his field."
,"25":"While everyone was asleep, his enemy came and sowed weeds among the wheat and left."
,"26":"When the plants sprouted and produced grain, the weeds also appeared."
,"27":"Then the servants of the owner came to him and said: 'Sir, was it not good seed that you sowed in your field? Where did the weeds come from?'"
,"28":"He answered them: 'This is the work of an enemy.' They asked him: 'Do you want us to go and pull up the weeds?'"
,"29":"He told them: 'No, when you pull up the weeds, you might uproot the wheat with them."
,"30":"Let them just grow together until harvest; and at harvest time I will say to the workers: Pull up the weeds first, tie them in bundles and burn them; then gather the wheat into my barn.'"
,"31":"Jesus put another parable before them, 'The kingdom of heaven is like a mustard seed, that a man took and sowed in his field."
,"32":"It is smaller than all other seeds, but once it has fully grown, it is bigger than any garden plant; like a tree, the birds come and rest in its branches.'"
,"33":"He told them another parable, 'The kingdom of heaven is like the yeast which a woman took and buried in three measures of flour until the whole mass of dough began to rise.'"
,"34":"Jesus taught all this to the crowds by means of parables; he did not say anything to them without using a parable."
,"35":"So what the Prophet had said was fulfilled: I will speak in parables. I will proclaim things kept secret since the beginning of the world."
,"36":"Then he sent the crowds away and went into the house. And his disciples came to him saying, 'Explain to us the parable of the weeds in the field.'"
,"37":"Jesus answered them, 'The one who sows the good seed is the Son of Man."
,"38":"The field is the world; the good seed are the people of the Kingdom; the weeds are those who follow the evil one."
,"39":"The enemy who sows them is the devil; the harvest is the end of time and the workers are the angels."
,"40":"Just as the weeds are pulled up and burned in the fire, so will it be at the end of time."
,"41":"The Son of Man will send his angels, and they will weed out of his kingdom all that is scandalous and all who do evil."
,"42":"And these will be thrown in the blazing furnace, where there will be weeping and gnashing of teeth."
,"43":"Then the just will shine like the sun in the kingdom of their Father. If you have ears, then hear."
,"44":"The kingdom of heaven is like a treasure hidden in a field. The one who finds it buries it again; and so happy is he, that he goes and sells everything he has, in order to buy that field."
,"45":"Again the kingdom of heaven is like a trader who is looking for fine pearls."
,"46":"Once he has found a pearl of exceptional quality, he goes away, sells everything he has and buys it."
,"47":"Again, the kingdom of heaven is like a big fishing net let down into the sea, in which every kind of fish has been caught."
,"48":"When the net is full, it is dragged ashore. Then they sit down and gather the good fish in buckets, but throw the worthless ones away."
,"49":"That is how it will be at the end of time; the angels will go out to separate the wicked from the just"
,"50":"and throw them into the blazing furnace, where they will weep and gnash their teeth.'"
,"51":"Jesus asked, 'Have you understood all these things?' 'Yes,' they answered."
,"52":"So he said to them, 'You will see that every teacher of the Law who becomes a disciple of the Kingdom is like a householder who can produce from his store things both new and old.'"
,"53":"When Jesus had finished these parables, he left the place."
,"54":"He went to his hometown and taught the people in their synagogue. They were amazed and said, 'Where did he get this wisdom and these special powers?"
,"55":"Isn't he the carpenter's son? Isn't Mary his mother and aren't James, Joseph, Simon and Judas his brothers?"
,"56":"Aren't all his sisters living here? How did he get all this?'"
,"57":"And so they took offense at him. Jesus said to them, 'The only place where prophets are not welcome is their hometown and in their own family.' "
,"58":"And he did not perform many miracles there because of their lack of faith."
}`)
	CurrentBook.AddChapter(14, `{
"1":"At that time the news about Jesus reached King Herod."
,"2":"And he said to his servants, 'This man is John the Baptist. John has risen from the dead, and that is why miraculous powers are at work in him.'"
,"3":"Herod had, in fact, ordered that John be arrested, bound in chains and put in prison because of Herodias, the wife of his brother Philip."
,"4":"For John had said to him, 'It is not right for you to have her as wife.'"
,"5":"Herod wanted to kill him but he did not dare, because he feared the people who regarded John as a prophet."
,"6":"On Herod's birthday the daughter of Herodias danced in the midst of the guests; she so delighted Herod"
,"7":"that he promised under oath to give her anything she asked."
,"8":"The girl, following the advice of her mother, said, 'Give me the head of John the Baptist here on a dish.'"
,"9":"The king was very displeased, but because he had made this promise under oath in the presence of the guests, he ordered it to be given her."
,"10":"So he had John beheaded in prison"
,"11":"and his head brought on a dish and given to the girl. The girl then took it to her mother."
,"12":"Then John's disciples came to take his body and bury it. And they went to bring the news to Jesus."
,"13":"On hearing this, Jesus set out secretly by boat for a secluded place. But the people heard of it, and they followed him on foot from their towns."
,"14":"When Jesus went ashore, he saw the crowd gathered there and he had compassion on them. And he healed their sick."
,"15":"Late in the afternoon, his disciples came to him and said, 'We are in a lonely place and it is now late. You should send these people away, so they can go to the villages and buy something for themselves to eat.'"
,"16":"But Jesus replied, 'They do not need to go away; you give them something to eat.'"
,"17":"They answered, 'We have nothing here but five loaves and two fishes.'"
,"18":"Jesus said to them, 'Bring them here to me.'"
,"19":"Then he made everyone sit down on the grass. He took the five loaves and the two fishes, raised his eyes to heaven, pronounced the blessing, broke the loaves and handed them to the disciples to distribute to the people."
,"20":"And they all ate, and everyone had enough; then the disciples gathered up the leftovers, filling twelve baskets."
,"21":"About five thousand men had eaten there besides women and children."
,"22":"Immediately Jesus obliged his disciples to get into the boat and go ahead of him to the other side, while he sent the crowd away."
,"23":"And having sent the people away, he went up the mountain by himself to pray. At nightfall, he was there alone."
,"24":"Meanwhile, the boat was very far from land, dangerously rocked by the waves for the wind was against it."
,"25":"At daybreak, Jesus came to them walking on the lake."
,"26":"When they saw him walking on the sea, they were terrified, thinking that it was a ghost. And they cried out in fear."
,"27":"But at once Jesus said to them, 'Courage! Don't be afraid. It's me!'"
,"28":"Peter answered, 'Lord, if it is you, command me to come to you walking on the water.'"
,"29":"Jesus said to him, 'Come.' And Peter got out of the boat, walking on the water to go to Jesus."
,"30":"But, in face of the strong wind, he was afraid and began to sink. So he cried out, 'Lord, save me!'"
,"31":"Jesus immediately stretched out his hand and took hold of him, saying, 'Man of little faith, why did you doubt?'"
,"32":"As they got into the boat, the wind dropped."
,"33":"Then those in the boat bowed down before Jesus saying, 'Truly, you are the Son of God!'"
,"34":"They came ashore at Gennesareth."
,"35":"The local people recognized Jesus and spread the news throughout the region. So they brought all the sick to him,"
,"36":"begging him to let them touch just the fringe of his cloak. All who touched it became perfectly well."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Then some Pharisees and teachers of the Law who had come from Jerusalem gathered around Jesus. And they said to him,"
,"2":"'Why don't your disciples follow the tradition of the elders? In fact, they don't wash their hands before eating.'"
,"3":"Jesus answered, 'And you, why do you break God's command for the sake of your traditions?"
,"4":"For God commanded: Do your duty to your father and your mother, and: whoever curses his father or his mother is to be put to death."
,"5":"But you say that anyone may say to his father or mother: 'What you could have expected from me, I have reserved for the Temple.'"
,"6":"In this case, according to you, a person is freed of his duty to his father and mother. And so, you have nullified the command of God for the sake of your traditions."
,"7":"Hypocrites! Isaiah rightly prophesied of you when he said:"
,"8":"This people honors me with their lips, but their heart is far from me."
,"9":"The worship they offer me is worthless, for they only teach human rules.'"
,"10":"Jesus then called the people near him and said to them, 'Listen and understand:"
,"11":"what enters into the mouth does not make a person unclean, what defiles one is what comes out of his mouth.'"
,"12":"After a while the disciples gathered around Jesus and said, 'Do you know that the Pharisees were offended by what you said?'"
,"13":"Jesus answered, 'Every plant which my heavenly Father has not planted shall be uprooted."
,"14":"Pay no attention to them! They are blind leading the blind. When a blind person leads another, the two will fall into a pit.'"
,"15":"Peter said to him, 'Explain this sentence to us.'"
,"16":"Jesus replied, 'So even you, too, are dull?"
,"17":"Do you not see that whatever enters the mouth goes into the stomach, and then out of the body?"
,"18":"But what comes out of the mouth comes from the heart, and that is what makes a person unclean."
,"19":"Indeed, it is from the heart that evil desires come - murder, adultery, immorality, theft, lies, slander."
,"20":"These are the things that make a person unclean; but eating without washing the hands does not make a person unclean.'"
,"21":"Leaving that place, Jesus withdrew to the region of Tyre and Sidon."
,"22":"Now a Canaanite woman came from those borders and began to cry out, 'Lord, Son of David, have pity on me! My daughter is tormented by a demon.'"
,"23":"But Jesus did not answer her, not even a word. So his disciples approached him and said, 'Send her away: see how she is shouting after us.'"
,"24":"Then Jesus said to her, 'I was sent only to the lost sheep of the nation of Israel.'"
,"25":"But the woman was already kneeling before Jesus and said, 'Sir, help me!'"
,"26":"Jesus answered, 'It is not right to take the bread from the children and throw it to the little dogs.'"
,"27":"The woman replied, 'It is true, sir, but even the little dogs eat the crumbs which fall from their master's table.'"
,"28":"Then Jesus said, 'Woman, how great is your faith! Let it be as you wish.' And her daughter was healed at that moment."
,"29":"From there Jesus went to the shore of Lake Galilee, and then went up into the hills where he sat down."
,"30":"Great crowds came to him, bringing the dumb, the blind, the lame, the crippled, and many with other infirmities. The people carried them to the feet of Jesus, and he healed them."
,"31":"All were astonished when they saw the dumb speaking, the lame walking, the crippled healed and the blind able to see; so they glorified the God of Israel."
,"32":"Jesus called his disciples and said to them, 'I am filled with compassion for these people; they have already followed me for three days and now have nothing to eat. I do not want to send them away fasting, or they may faint on the way.'"
,"33":"His disciples said to him, 'And where shall we find enough bread in this wilderness to feed such a crowd?'"
,"34":"Jesus said to them, 'How many loaves do you have?' They answered, 'Seven, and a few small fish.'"
,"35":"So Jesus ordered the people to sit on the ground."
,"36":"Then he took the seven loaves and the small fish and gave thanks to God. He broke them and gave them to his disciples, who distributed them to the people."
,"37":"They all ate and were satisfied, and the leftover broken pieces filled seven wicker baskets."
,"38":"Four thousand men had eaten, besides women and children."
,"39":"Then Jesus sent away the crowd, got into the boat and went to Magdala."
}`)
	CurrentBook.AddChapter(16, `{
"1":"The Pharisees and Sadducees appeared. They wanted to put Jesus to the test and asked him for some heavenly sign."
,"2":"Jesus answered, '(When evening comes, you say: 'It will be a good day for the sky is red.'"
,"3":"And in the morning you say: 'Stormy weather today, for the sky in the east is red.' If you know how to interpret the appearance of the sky, why can't you interpret the signs of the times?)"
,"4":"An evil and unbelieving people want a sign, but no sign will be given them except the sign of Jonah.',So Jesus left them and went away."
,"5":"When the disciples went to the other side, they forgot to take bread."
,"6":"It was then that Jesus said to them, 'Beware and do not trust the yeast of the Pharisees and Sadducees.'"
,"7":"And the disciples said to one another, 'He means the bread we did not bring.'"
,"8":"Jesus was aware of this, so he said to them, 'You of little faith! Why do you speak about the bread you haven't got?"
,"9":"Do you still not understand? Do you not remember the five loaves for the five thousand and how many baskets you gathered?"
,"10":"Or the seven loaves for the four thousand and how many wicker baskets you gathered?"
,"11":"How can you fail to understand that I was not talking of bread when I told you: Beware of the yeast of the Pharisees and Sadducees?'"
,"12":"Then they understood that he was not talking of yeast for bread, but of the teaching of the Pharisees and Sadducees."
,"13":"After that Jesus came to Caesarea Philippi. He asked his disciples, 'What do people say of the Son of Man? Who do they say I am?'"
,"14":"They said, 'For some of them you are John the Baptist, for others Elijah or Jeremiah or one of the prophets.'"
,"15":"Jesus asked them, 'But you, who do you say I am?'"
,"16":"Peter answered, 'You are the Messiah, the Son of the living God.'"
,"17":"Jesus replied, 'It is well for you, Simon Barjona, for it is not flesh or blood that has revealed this to you but my Father in heaven."
,"18":"And now I say to you: You are Peter (or Rock) and on this rock I will build my Church; and never will the powers of death overcome it."
,"19":"I will give you the keys of the kingdom of heaven: whatever you bind on earth shall be bound in heaven, and what you unbind on earth shall be unbound in heaven.'"
,"20":"Then he ordered his disciples not to tell anyone that he was the Christ."
,"21":"From that day Jesus began to make it clear to his disciples that he must go to Jerusalem; he would suffer many things from the Jewish authorities, the chief priests and the teachers of the Law. He would be killed and be raised on the third day."
,"22":"Then Peter took him aside and began to reproach him, 'Never, Lord! No, this must never happen to you.'"
,"23":"But Jesus turned to him and said, 'Get behind me, Satan! You would have me stumble. You are their King not as God does, but as people do.'"
,"24":"Then Jesus said to his disciples, 'If you want to follow me, deny yourself, take up your cross and follow me."
,"25":"For whoever chooses to save his life will lose it, but the one who loses his life for my sake will find it."
,"26":"What will one gain by winning the whole world if he destroys himself? There is nothing you can give to recover your own self."
,"27":"Know that the Son of Man will come in the Glory of his Father with the holy angels, and he will reward each one according to his deeds."
,"28":"Truly, I tell you, there are some here who will not die before they see the Son of Man coming as king.'"
}`)
	CurrentBook.AddChapter(17, `{
"1":"Six days later, Jesus took with him Peter and James and his brother John and led them up a high mountain where they were alone."
,"2":"Jesus' appearance was changed before them: his face shone like the sun and his clothes became bright as light."
,"3":"Just then Moses and Elijah appeared to them, talking with Jesus."
,"4":"Peter spoke and said to Jesus, 'Master, it is good that we are here. If you so wish, I will make three tents: one for you, one for Moses, and one for Elijah.'"
,"5":"Peter was still speaking when a bright cloud covered them in its shadow, and a voice from the cloud said, 'This is my Son, the Beloved, my Chosen One. Listen to him.'"
,"6":"On hearing the voice, the disciples fell to the ground, full of fear."
,"7":"But Jesus came, touched them and said, 'Stand up, do not be afraid.'"
,"8":"When they raised their eyes, they no longer saw anyone except Jesus."
,"9":"And as they came down the mountain, Jesus commanded them not to tell anyone what they had just seen, until the Son of Man be raised from the dead."
,"10":"The disciples then asked him, 'Why do the teachers of the Law say that Elijah must come first?'"
,"11":"And Jesus answered, 'So it is: first comes Elijah to set everything as it has to be."
,"12":"But I tell you, Elijah has already come and they did not recognize him, but treated him as they pleased. And they will also make the Son of Man suffer.'"
,"13":"Then the disciples understood that Jesus was referring to John the Baptist."
,"14":"When they met the people, a man approached Jesus, knelt before him and said,"
,"15":"'Sir, have pity on my son who is an epileptic and is in a wretched state. He has often fallen into the fire and at other times into the water."
,"16":"I brought him to your disciples but they could not heal him.'"
,"17":"Jesus replied, 'You, faithless and evil people! How long must I be with you? How long must I put up with you? Bring him here to me.'"
,"18":"And Jesus commanded the evil spirit to leave the boy, and the boy was immediately healed."
,"19":"The disciples then gathered around Jesus and asked him privately, 'Why couldn't we drive out the spirit?'"
,"20":"Jesus said to them, 'Because you have little faith. I say to you: if only you had faith the size of a mustard seed, you could tell that mountain to move from here to there, and the mountain would obey. Nothing would be impossible to you."
,"21":"(Only prayer and fasting can drive out this kind of spirit.')"
,"22":"While Jesus was in Galilee with the Twelve, he said to them, 'The Son of Man will be delivered into human hands,"
,"23":"and they will kill him. But he will rise on the third day.' The Twelve were deeply grieved."
,"24":"When they returned to Capernaum, the Temple tax collectors came to Peter and asked him, 'Does your master pay the temple tax?'"
,"25":"He answered, 'Certainly.',Peter then entered the house, but immediately Jesus asked him, 'What do you think, Simon? Who pay taxes or tributes to the kings of the earth: their sons or the other people?' "
,"26":"Peter replied, 'The others.' And Jesus told him, 'The sons, then, are tax-free."
,"27":"But so as not to offend this people, go to the sea, throw in a hook and open the mouth of the first fish you catch. You will find a coin in it, take it and let it pay for you and for me.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"At that time the disciples came to Jesus and asked him, 'Who is the greatest in the kingdom of heaven?'"
,"2":"Then Jesus called a little child, set the child in the midst of the disciples,"
,"3":"and said, 'I assure you that unless you change and become like little children, you cannot enter the kingdom of Jesus heaven."
,"4":"Whoever becomes lowly like this child is the greatest in the kingdom of heaven,"
,"5":"and whoever receives such a child in my name receives me."
,"6":"If any of you should cause one of these little ones who believe in me to stumble and fall, it would be better for you to be thrown into the depths of the sea with a great millstone around your neck."
,"7":"Woe to the world because of so many scandals! Scandals necessarily come, but woe to the one who has brought it about."
,"8":"If your hand or foot drags you into sin, cut it off and throw it away. It is better for you to enter life without a hand or a foot than to be thrown into eternal fire with your two hands and two feet."
,"9":"And if your eye drags you into sin, tear it out and throw it away. It is better for you to enter life with one eye than to be thrown into the fire of hell with your two eyes."
,"10":"See that you do not despise any of these little ones, for I tell you: their angels in heaven continually see the face of my heavenly Father."
,"11":"(The Son of Man has come to save the lost)."
,"12":"What do you think of this? If someone has a hundred sheep and one of them strays, won't he leave the ninety-nine on the hillside, and go to look for the stray one?"
,"13":"And I tell you: when he finally finds it, he is more pleased about it than about the ninety-nine that did not get lost."
,"14":"It is the same with your Father in heaven: there they don't want even one of these little ones to be lost."
,"15":"If your brother or sister has sinned against you, go and point out the fault when the two of you are in private, and if he listens to you, you have won your brother."
,"16":"If you are not listened to, take with you one or two others so that the case may be decided by the evidence of two or three witnesses."
,"17":"If he still refuses to listen to them, tell it to the assembled Church. But if he does not listen to the Church, then regard such a one as a pagan or a publican."
,"18":"I say to you: whatever you bind on earth, heaven will keep bound; and whatever you unbind on earth, heaven will keep unbound."
,"19":"In like manner, I say to you: if on earth two of you are united in asking for anything, it will be granted to you by my heavenly Father."
,"20":"For where two or three are gathered in my Name, I am there among them.'"
,"21":"Then Peter asked him, 'Lord, how many times must I forgive the offenses of my brother or sister? Seven times?'"
,"22":"Jesus answered, 'No, not seven times, but seventy-seven times."
,"23":"This story throws light on the kingdom of heaven. A king decided to settle the accounts of his servants."
,"24":"Among the first was one who owed him ten thousand gold ingots."
,"25":"As the man could not repay the debt, the king commanded that he be sold as a slave with his wife, children and all his goods in payment."
,"26":"The official threw himself at the feet of the king and said, 'Give me time, and I will pay you back everything.'"
,"27":"The king took pity on him and not only set him free but even canceled his debt."
,"28":"This official then left the king's presence and he met one of his companions who owed him a hundred pieces of silver. He grabbed him by the neck and almost strangled him, shouting, 'Pay me what you owe!'"
,"29":"His companion threw himself at his feet and asked him, 'Give me time, and I will pay everything.'"
,"30":"The other did not agree, but sent him to prison until he had paid all his debt."
,"31":"His companions saw what happened. They were indignant and so they went and reported everything to their lord."
,"32":"Then the lord summoned his official and said, 'Wicked servant, I forgave you all that you owed when you begged me to do so."
,"33":"Weren't you bound to have pity on your companion as I had pity on you?'"
,"34":"The lord was now angry, so he handed his servant over to be punished, until he had paid his whole debt.'"
,"35":"Jesus added, 'So will my heavenly Father do with you unless each of you sincerely forgive your brother or sister.'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"When Jesus had finished this teaching, he left Galilee and arrived at the border of Judea, on the other side of the Jordan River."
,"2":"A great crowd was with him and there, too, he healed their sick."
,"3":"Some Pharisees approached him. They wanted to test him and asked, 'Is a man allowed to divorce his wife for any reason he wants?'"
,"4":"Jesus replied, 'Have you not read that in the beginning the Creator made them male and female,"
,"5":"and he said: Man has now to leave father and mother, and be joined to his wife, and the two shall become one body?"
,"6":"So they are no longer two but one body; let no one separate what God has joined.'"
,"7":"They asked him, 'Then, why did Moses command us to write a bill of dismissal in order to divorce?'"
,"8":"Jesus replied, 'Moses knew your stubborn heart, so he allowed you to divorce your wives, but it was not so in the beginning."
,"9":"Therefore I say to you: whoever divorces his wife, unless it be for infidelity, and marries another, commits adultery.'"
,"10":"The disciples said, 'If that is the condition of a married man, it is better not to marry.'"
,"11":"Jesus said to them, 'Not everybody can accept what you have just said, but only those who have received this gift."
,"12":"Some are born incapable of marriage. Some have been made that way by others. But there are some who have given up the possibility of marriage for the sake of the kingdom of heaven. Let the one who can accept it, accept it.'"
,"13":"Then little children were brought to Jesus that he might lay his hands on them with a prayer. But the disciples scolded those who brought them."
,"14":"Jesus then said, 'Let them be! Do not stop the children from coming to me, for the kingdom of heaven belongs to people such as these.'"
,"15":"So Jesus laid his hands on them and went his way."
,"16":"It was then that a young man approached him and asked, 'Master, what good work must I do to receive eternal life?'"
,"17":"Jesus answered, 'Why do you ask me about what is good?' Only one is Good. If you want to enter eternal life, keep the commandments.'"
,"18":"The young man said, 'Which commandments?' Jesus replied, 'Do not kill, do not commit adultery, do not steal, do not bear false witness,"
,"19":"honor your father and mother, and love your neighbor as yourself.'"
,"20":"The young man said to him, 'I have kept all these commandments, what is still lacking?'"
,"21":"Jesus answered, 'If you wish to be perfect, go and sell all that you possess and give the money to the poor and you will become the owner of a treasure in heaven. Then come back and follow me.'"
,"22":"On hearing this answer, the young man went away sad for he was a man of great wealth."
,"23":"Then Jesus said to his disciples, 'Truly I say to you: it will be hard for one who is rich to enter the kingdom of heaven."
,"24":"Yes, believe me: it is easier for a camel to go through the eye of a needle than for the one who is rich to enter the kingdom of heaven.'"
,"25":"On hearing this the disciples were astonished and said, 'Who, then, can be saved?'"
,"26":"Jesus looked steadily at them and answered, 'For humans it is impossible, but for God all things are possible.'"
,"27":"Then Peter spoke up and said, 'You see we have given up everything to follow you: what will be our lot?'"
,"28":"Jesus answered, 'You who have followed me, listen to my words: on the Day of Renewal, when the Son of Man sits on his throne in glory, you, too, will sit on twelve thrones to rule the twelve tribes of Israel."
,"29":"As for those who have left houses, brothers, sisters, father, mother, children or property for my Name's sake, they will receive a hundredfold and be given eternal life."
,"30":"Many who are now first will be last, and many who are now last will be first."
}`)
	CurrentBook.AddChapter(20, `{
"1":"This story throws light on the kingdom of heaven. A landowner went out early in the morning to hire workers for his vineyard."
,"2":"He agreed to pay the workers a salary of a silver coin for the day, and sent them to his vineyard."
,"3":"He went out again at about nine in the morning, and seeing others idle in the square,"
,"4":"he said to them: 'You, too, go to my vineyard and I will pay you what is just.' So they went. The owner went out at midday and again at three in the afternoon, "
,"5":"and he did the same."
,"6":"Finally he went out at the last working hour - it was the eleventh - and he saw others standing there. So he said to them: 'Why do you stay idle the whole day?'"
,"7":"They answered: 'Because no one has hired us.' The master said: 'Go and work in my vineyard.'"
,"8":"When evening came, the owner of the vineyard said to his manager: 'Call the workers and pay them their wage, beginning with the last and ending with the first.'"
,"9":"Those who had come to work at the eleventh hour turned up and were given a denarius each (a silver coin)."
,"10":"When it was the turn of the first, they thought they would receive more."
,"11":"But they, too, received a denarius each. So, on receiving it, they began to grumble against the landowner."
,"12":"They said: 'These last hardly worked an hour, yet you have treated them the same as us who have endured the day's burden and heat.'"
,"13":"The owner said to one of them: 'Friend, I have not been unjust to you. Did we not agree on a denarius a day?"
,"14":"So take what is yours and go. I want to give to the last the same as I give to you."
,"15":"Don't I have the right to do as I please with my money? Why are you envious when I am kind?'"
,"16":"So will it be: the last will be first, the first will be last.'"
,"17":"When Jesus was going to Jerusalem, he took the Twelve aside and said to them on the way,"
,"18":"'See, we are going to Jerusalem. There the Son of Man will be given over to the chief priests and the teachers of the Law who will condemn him to death."
,"19":"They will hand him over to the foreigners who will mock him, scourge him and crucify him. But he will be raised to life on the third day.'"
,"20":"Then the mother of James and John came to Jesus with her sons, and she knelt down to ask a favor."
,"21":"Jesus said to her, 'What do you want?' And she answered, 'Here you have my two sons. Grant that they may sit, one at your right and one at your left, when you are in your kingdom.'"
,"22":"Jesus said to the brothers, 'You do not know what you are asking. Can you drink the cup that I am about to drink?' They answered, 'We can.'"
,"23":"Jesus replied, 'You will indeed drink my cup, but to sit at my right or at my left is not for me to grant. That will be for those for whom the Father has prepared it.'"
,"24":"The other ten heard all this and were angry with the two brothers."
,"25":"Then Jesus called them to him and said, 'You know that the rulers of the nations act as tyrants, and the powerful oppress them."
,"26":"It shall not be so among you; whoever wants to be more important in your group shall make himself your servant."
,"27":"And if you want to be first make yourself the servant of all."
,"28":"Be like the Son of Man who has come, not to be served but to serve and to give his life to redeem many.'"
,"29":"As they left Jericho, a great crowd followed them on the way."
,"30":"Two blind men were sitting by the roadside, and when they heard that Jesus was passing by, they began to call out, 'Son of David, have mercy on us!'"
,"31":"The people told them to keep quiet. But they shouted even louder, 'Lord, Son of David, have mercy on us!'"
,"32":"Jesus stopped, called out to them and asked, 'What do you want me to do for you?'"
,"33":"They said, 'Lord, open our eyes.'"
,"34":"Jesus was moved with compassion and touched their eyes. Immediately they recovered their sight and they began to follow Jesus."
}`)
	CurrentBook.AddChapter(21, `{
"1":"When they drew near Jerusalem and arrived at Bethphage, on the mount of Olives, Jesus sent two of his disciples,"
,"2":"saying, 'Go to the village in front of you, and there you will find a donkey tied up with its colt by her. Untie them and bring them to me."
,"3":"If anyone says something to you, say: The Lord needs them but he will send them back immediately.'"
,"4":"This happened in fulfillment of what the prophet said:"
,"5":"Say to the daughter of Zion: See, your king comes to you in all simplicity, riding on a donkey, a beast of burden, with its colt."
,"6":"The disciples went as Jesus had instructed them,"
,"7":"and they brought the donkey with its colt. Then they threw their cloaks on its back, and Jesus sat on them."
,"8":"Many people also spread their cloaks on the road, while others cut leafy branches from the trees and spread them on the road."
,"9":"The people who walked ahead of Jesus and those who followed him began to shout: 'Hosanna to the Son of David! Blessed is he who comes in the name of the Lord! Hosanna, glory in the highest!'"
,"10":"When Jesus entered Jerusalem, the whole city was disturbed. The people asked, 'Who is this man?'"
,"11":"And the crowd answered, 'This is the Prophet Jesus from Nazareth of Galilee.'"
,"12":"So Jesus went into the Temple and drove out all who were buying and selling in the temple area. He overturned the tables of the money changers, and the stools of those who sold pigeons."
,"13":"And he said to them, 'It is written: My house shall be called a house of prayer. But you have turned it into a den of thieves.'"
,"14":"The blind and the lame also came to him in the Temple and Jesus healed them."
,"15":"The chief priests and the teachers of the Law saw the wonderful things Jesus had just done, and the children shouting in the temple area, 'Hosanna to the Son of David!'"
,"16":"They became indignant and said to Jesus, 'Do you hear what they say?' Jesus answered them, 'Yes. Have you never read this text: From the mouths of children and infants you have got perfect praise?'"
,"17":"So leaving them he went out of the city and came to Bethany where he spent the night."
,"18":"While returning to the city early in the morning, Jesus felt hungry."
,"19":"He noticed a fig tree by the road, went up to it and found nothing on it but leaves. Then he said to the tree, 'Never again bear fruit!' And immediately, the fig tree withered."
,"20":"When the disciples saw this, they were astonished and they said, 'How did the fig tree suddenly dry up!'"
,"21":"Jesus told them, 'Truly, I say to you: if you had faith and did not doubt, not only could you do what I have done with the fig tree, but you could even say to that mountain: 'Go and throw yourself into the sea!' and it would be done."
,"22":"Whatever you ask for in prayer full of faith, you will receive.'"
,"23":"Jesus had entered the Temple and was teaching when the chief priests, the teachers of the Law and the Jewish authorities came to him and asked, 'What authority have you to act like this? Who gave you authority to do all this?'"
,"24":"Jesus answered them, 'I will also ask you a question, only one. And if you give me an answer, then I will tell you by what authority I do these things. When John began to baptize, was it a work of God, or was it merely something human?'"
,"25":"They reasoned out among themselves, 'If we reply that it was a work of God, he will say: Why, then, did you not believe him?"
,"26":"And if we say: The baptism of John was merely something human, beware of the people: since all hold John as a prophet.'"
,"27":"So they answered Jesus, 'We do not know.',And Jesus said to them, 'Neither will I tell you by what right I do these things.'"
,"28":"Jesus went on to say, 'What do you think of this? A man had two sons. He went to the first and said to him: 'Son, today go and work in my vineyard.'"
,"29":"And the son answered: 'I don't want to.' But later he thought better of it and went."
,"30":"Then the father went to the second and gave him the same command. This son replied: 'I will go, sir,' but he did not go."
,"31":"Which of the two did what the father wanted?' They answered, 'The first.' And Jesus said to them, 'Truly, I say to you: the publicans and the prostitutes are ahead of you on the way to the kingdom of heaven."
,"32":"For John came to show you the way of goodness but you did not believe him, yet the publicans and the prostitutes did. You were witnesses of this, but you neither repented nor believed him."
,"33":"Listen to another example: There was a landowner who planted a vineyard. He put a fence around it, dug a hole for the winepress, built a watchtower, leased the vineyard to tenants and then went to a distant country."
,"34":"When harvest time came, the landowner sent his servants to the tenants to collect his share of the harvest."
,"35":"But the tenants seized his servants, beat one, killed another and stoned another."
,"36":"Again the owner sent more servants, but they were treated in the same way."
,"37":"Finally, he sent his son, thinking: 'They will respect my son.'"
,"38":"But when the tenants saw the son, they thought: 'This is the one who is to inherit the vineyard. Let us kill him and his inheritance will be ours.'"
,"39":"So they seized him, threw him out of the vineyard and killed him."
,"40":"Now, what will the owner of the vineyard do with the tenants when he comes?'"
,"41":"They said to him, 'He will bring those evil to an evil end, and lease the vineyard to others who will pay him in due time.'"
,"42":"And Jesus replied, 'Have you never read what the Scriptures say? The stone which the builders rejected has become the keystone. This was the Lord's doing; and we marvel at it."
,"43":"Therefore I say to you: the kingdom of heaven will be taken from you and given to a people who will yield a harvest."
,"44":"(Whoever falls on this stone will be broken to pieces, and it will ground to dust on whom it falls.)'"
,"45":"When the chief priests and the Pharisees heard these parables, they realized that Jesus was referring to them."
,"46":"They would have arrested him, but they were afraid of the crowd who regarded him as a prophet."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Jesus went on speaking to them in parables:"
,"2":"'This story throws light on the kingdom of heaven. A king celebrated the wedding of his son."
,"3":"He sent his servants to call the invited guests to the wedding feast, but the guests refused to come."
,"4":"Again he sent other servants ordering them to say to the invited guests: 'I have prepared a banquet, slaughtered my fattened calves and other animals, and now everything is ready; come then, to the wedding feast.'"
,"5":"But they paid no attention and went away, some to their fields, and others to their work."
,"6":"While the rest seized the servants of the king, insulted them and killed them."
,"7":"The king became angry. He sent his troops to destroy those murderers and burn their city."
,"8":"Then he said to his servants: 'The wedding banquet is prepared, but the invited guests were not worthy."
,"9":"Go, then, to the crossroads and invite everyone you find to the wedding feast.'"
,"10":"The servants went out at once into the streets and gathered everyone they found, good and bad alike, so that the hall was filled with guests."
,"11":"The king came in to see those who were at table, and he noticed a man not wearing the festal garment."
,"12":"So he said to him: 'Friend, how did you get in without the wedding garment?' But the man remained silent."
,"13":"So the king said to his servants: 'Bind his hands and feet and throw him into the dark where there is weeping and gnashing of teeth.'"
,"14":"Know that many are called, but few are chosen.'"
,"15":"The Pharisees went out and took counsel on how they could trap Jesus with his own words."
,"16":"They then sent their disciples with the members of Herod's party for this purpose. They said to Jesus, 'Master, we know that you are an honest man and truly teach God's way; you are not influenced by others nor are you afraid of anyone. "
,"17":"Tell us, then, what you think: is it against the Law to pay taxes to Caesar or not?'"
,"18":"But Jesus understood their evil intent, and said to them, 'Hypocrites! Why are you testing me?"
,"19":"Show me the coin with which you pay the taxes.',They showed him a denarius, "
,"20":"and Jesus said to them, 'Whose head is this, and whose name?'"
,"21":"They answered, 'Caesar's.' Then Jesus replied, 'Therefore, return to Caesar what is Caesar's, and to God what is God's.'"
,"22":"Astonished by his answer, they left him and went away."
,"23":"That same day, some of the Sadducees came to Jesus. Since they claim that there is no resurrection, they questioned him in this way,"
,"24":"'Master, Moses said that if anyone dies without any children, his brother must take the wife and have a child who will be considered the child of the deceased man."
,"25":"Now, there were seven brothers. The first married a wife, and he died; since he had no children, he left his wife to his brother."
,"26":"The same thing happened to the second and to the third until the seventh."
,"27":"Then, last of all, the woman also died."
,"28":"Now, in the resurrection of the dead, to which of the seven will she be wife, for all had her as wife?'"
,"29":"Jesus answered, 'You are totally wrong because you understand neither the Scriptures nor the power of God."
,"30":"First of all, in the resurrection of the dead, neither men nor women will marry, but they will be like the angels in heaven."
,"31":"As for the resurrection of the dead, have you never reflected on what God said to you:"
,"32":"I am the God of Abraham, the God of Isaac, and the God of Jacob? He is God, not of the dead but of the living.'"
,"33":"The people who heard him were astonished at his teaching."
,"34":"When the Pharisees heard how Jesus had silenced the Sadducees, they came together."
,"35":"One of them, a teacher of the Law, tried to test him with this question,"
,"36":"'Teacher, which is the most important commandment in the Law?'"
,"37":"Jesus answered, 'You shall love the Lord, your God, with all your heart, with all your soul and with all your mind."
,"38":"This is the first and the most important of the commandments."
,"39":"But after this there is another one very similar to it: You shall love your neighbor as yourself."
,"40":"The whole Law and the Prophets are founded on these two commandments.'"
,"41":"As the Pharisees were gathered there, Jesus asked them,"
,"42":"'What do you think of the Messiah? Whose son is he to be?' They answered, 'David's.'"
,"43":"Jesus then asked, 'Why did David, inspired by God, call the Messiah Lord? For he says in a psalm:"
,"44":"The Lord said to my Lord: Sit at my right until I put your enemies under your feet."
,"45":"If David calls him Lord, how can he be his son?'"
,"46":"No one could answer him, not even a word. From that day on, no one dared question him anymore."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Then Jesus said to the crowds and to his disciples:"
,"2":"'The teachers of the Law and the Pharisees sat on the seat of Moses."
,"3":"So you shall do and observe all they say, but do not do as they do,"
,"4":"for they do not do what they say. They tie up heavy burdens and load them on the shoulders of the people, but they do not even raise a finger to move them."
,"5":"They do everything in order to be seen by people; so they wear very wide bands of the Law around their foreheads, and robes with large tassels."
,"6":"They enjoy the first place at feasts and reserved seats in the synagogues,"
,"7":"and being greeted in the marketplace and being called 'Master' by the people."
,"8":"But you, do not let yourselves be called Master because you have only one Master, and all of you are brothers and sisters."
,"9":"Neither should you call anyone on earth Father, because you have only one Father, he who is in heaven."
,"10":"Nor should you be called leader, because Christ is the only leader for you."
,"11":"Let the greatest among you be the servant of all."
,"12":"For whoever makes himself great shall be humbled, and whoever humbles himself shall be made great."
,"13":"Therefore, woe to you, teachers of the Law and Pharisees, you hypocrites! You shut the door to the kingdom of heaven in people's faces. You yourselves do not enter, nor do you allow others to do so."
,"14":"Woe to you, teachers of the Law and Pharisees, you hypocrites!"
,"15":"You travel by sea and land to win a single convert, yet once he is converted, you turn him twice as fit for hell as yourselves."
,"16":"Woe to you, blind guides! You say: To swear by the Temple is not binding, but to swear by the treasure of the Temple is."
,"17":"Blind fools! Which is of more worth? The gold in the Temple or the Temple which makes the gold a sacred treasure? You say:"
,"18":"To swear by the altar is not binding, but to swear by the offering on the altar is."
,"19":"How blind you are! Which is of more value: the offering on the altar or the altar which makes the offering sacred?"
,"20":"Whoever swears by the altar is swearing by the altar and by everything on it."
,"21":"Whoever swears by the Temple is swearing by it and by God who dwells in the Temple."
,"22":"Whoever swears by heaven is swearing by the throne of God and by him who is seated on it."
,"23":"Woe to you, teachers of the Law and Pharisees, you hypocrites! You do not forget the mint, anise and cummin seeds when you pay the tenth of everything, but then you forget what is most fundamental in the Law: justice, mercy and faith. These you must practice, without neglecting the others."
,"24":"Blind guides! You strain out a mosquito, but swallow a camel."
,"25":"Woe to you, teachers of the Law and Pharisees, you hypocrites! You fill the plate and the cup with theft and violence, and then pronounce a blessing over them."
,"26":"Blind Pharisee! Purify the inside first, then the outside too will be purified."
,"27":"Woe to you, teachers of the Law and Pharisees, you hypocrites! You are like whitewashed tombs beautiful in appearance, but inside there are only dead bones and uncleanness."
,"28":"In the same way you appear as religious to others, but you are full of hypocrisy and wickedness within."
,"29":"Woe to you, teachers of the Law and Pharisees, you hypocrites! You build tombs for the prophets and decorate the monuments of the righteous."
,"30":"You say: Had we lived in the time of our ancestors, we would not have joined them in the blood of prophets."
,"31":"So, you yourselves confess to be kins of those who murdered the prophets."
,"32":"And now, finish off what your ancestors began!"
,"33":"Serpents, race of vipers! How can you escape condemnation to hell?"
,"34":"And so I am sending you prophets, sages and teachers, but you will murder and crucify them, and flog others in the synagogues or drive them from one city to another."
,"35":"Because of this you will be accountable for all the innocent blood that has been shed on the earth, from the blood of upright Abel to the blood of Zechariah, son of Barachiah, whom you murdered between the altar and the Sanctuary."
,"36":"Truly, I say to you: the present generation will pay for all this."
,"37":"Jerusalem, Jerusalem! You murder the prophets and stone those sent to you by God. How often would I have gathered your children together, just as a hen gathers her chicks under her wings, but you refused!"
,"38":"Now you will be left with an empty Temple."
,"39":"I tell you that you will no longer see me until you say: 'Blessed is he who comes in the name of the Lord!'"
}`)
	CurrentBook.AddChapter(24, `{
"1":"Jesus left the Temple and as he was walking away, his disciples came to him and boasted about the imposing Temple buildings."
,"2":"But he said, 'You see all this? Truly I say to you: not one stone will be left upon another here. All will be thrown down.'"
,"3":"Later when Jesus was sitting on the Mount of Olives, the disciples approached him privately and asked, 'Tell us when this will take place. What sign will be given us before your coming and the end of history?'"
,"4":"Jesus answered, 'Be on your guard and let no one mislead you."
,"5":"Many will come, claiming my title and saying: 'I am the Messiah,' and they will mislead many people."
,"6":"You will hear about war and threats of war, but do not be troubled, for these things must happen, but it is not yet the end."
,"7":"Nations will fight one another, and kingdom oppose kingdom. There will be famines and earthquakes in several places,"
,"8":"but all these are only the beginning: the first pains of childbirth."
,"9":"Then they will arrest you, and they will torture and kill you. All nations will hate you for you bear my name."
,"10":"In those days, many will stumble and fall; they will betray one another and become enemies."
,"11":"False prophets will appear and mislead many people,"
,"12":"and because of such great wickedness, love will grow cold in many people."
,"13":"But the one who holds out to the end will be saved."
,"14":"The Good News of the Kingdom will be proclaimed throughout the world for all the nations to know; then the end will come."
,"15":"When you see what the prophet Daniel foretold: the idol of the invader set up in the Temple (may the reader understand!),"
,"16":"then let those in Judea flee to the mountains."
,"17":"If you are on the housetop, do not come down to take anything with you."
,"18":"If you are in the field, do not turn back to fetch your cloak."
,"19":"How hard it will be for pregnant women and mothers with babies at the breast!"
,"20":"Pray that it may not be in winter or on a sabbath that you flee."
,"21":"For there will be great tribulation such as was never known from the beginning of the world until now, and is never to be known again."
,"22":"And if that time were not to be shortened, no one would survive. But God will shorten it for the sake of his chosen ones."
,"23":"Then, if anyone says to you: 'Look! The Messiah is here! He is there!', do not believe it."
,"24":"For false Messiahs and false prophets will appear and perform signs and wonders so great that they would deceive even God's chosen people, if that were possible."
,"25":"See, I have told you everything ahead of time."
,"26":"So, if anyone tells you: 'He is in the desert,' do not go. If they say: 'He is in such a secluded place,' do not believe it."
,"27":"For the coming of the Son of Man will instead be like lightning which flashes from the east even to the west."
,"28":"'Wherever the body is, the vultures will gather.'"
,"29":"For later, after that distress, the sun will grow dark, the moon will not give its light, the stars will fall from the skies, and the whole universe will be shaken."
,"30":"Then the sign of the Son of Man will appear in heaven: as all the nations of the earth beat their breasts, they will see the Son of Man coming in the clouds of heaven with divine power and the fullness of Glory."
,"31":"He will send his angels to sound the trumpet and gather the chosen ones from the four winds, from one end of the earth to the other."
,"32":"Learn a lesson from the fig tree. When its branches grow tender and its leaves begin to sprout, you know that summer is near."
,"33":"In the same way, when you see all that I have told you, know that the time is near, even at the door."
,"34":"Truly, I say to you, this generation will not pass away until all these things have happened."
,"35":"Heaven and earth will pass away, but my words will not pass away."
,"36":"But as for that Day and that Hour, no one knows when it will come, not even the angels of God nor the Son, but only the Father."
,"37":"At the coming of the Son of Man it will be just as it was in the time of Noah."
,"38":"In those days before the Flood, people were eating and drinking, and marrying, until the day when Noah went into the ark."
,"39":"Yet they did not know what would happen until the flood came and swept them away. So will it be at the coming of the Son of Man."
,"40":"Of two men in the field, one will be taken and the other left."
,"41":"Of two women grinding wheat together at the mill, one will be taken and the other left."
,"42":"Stay awake, then, for you do not know on what day your Lord will come."
,"43":"Just think about this: if the owner of the house knew that the thief would come by night around a certain hour, he would stay awake to prevent his house to be broken into."
,"44":"So be alert, for the Son of Man will come at the hour you least expect."
,"45":"Imagine a capable servant whom his master has put in charge of his household to give them food at the proper time."
,"46":"Fortunate indeed is that servant whom his master will find at work when he comes."
,"47":"Truly, I say to you, his lord will entrust that one with everything he has."
,"48":"Not so with the bad servant who thinks: My master is delayed."
,"49":"And he begins ill-treating his fellow servants while eating and drinking with drunkards."
,"50":"But his master will come on the day he does not know and at the hour he least expects."
,"51":"He will dismiss that servant and deal with him as with the hypocrites, where there will be weeping and gnashing of teeth."
}`)
	CurrentBook.AddChapter(25, `{
"1":"This story throws light on what will happen in the kingdom of heaven. Ten bridesmaids went out with their lamps to meet the bridegroom."
,"2":"Five of them were careless while the others were sensible."
,"3":"The careless bridesmaids took their lamps as they were and did not bring extra oil."
,"4":"But those who were sensible, brought with their lamps flasks of oil."
,"5":"As the bridegroom delayed, they all grew drowsy and fell asleep."
,"6":"But at midnight, a cry rang out: 'The bridegroom is here, come out and meet him!'"
,"7":"All the maidens woke up at once and trimmed their lamps."
,"8":"Then the careless ones said to the sensible ones: 'Give us some oil, for our lamps are going out.'"
,"9":"The sensible ones answered: 'There may not be enough for both you and us. You had better go to those who sell and buy for yourselves.'"
,"10":"They were out buying oil when the bridegroom came, and those who were ready went with him to the wedding feast, and the doors were shut."
,"11":"Later the rest of the bridesmaids arrived and called out: 'Lord, Lord, open to us.'"
,"12":"But he answered: 'Truly, I do not know you.'"
,"13":"So, stay awake, for you do not know the day nor the hour."
,"14":"Imagine someone who, before going abroad, summoned his servants to entrust his property to them."
,"15":"He gave five talents of silver to one, then two to another, and one to a third, each one according to his ability; and he went away."
,"16":"He who received five talents went at once to do business with the money and gained another five."
,"17":"The one who received two did the same and gained another two."
,"18":"But the one with one talent dug a hole and hid his master's money."
,"19":"After a long time, the master of those servants returned and asked for a reckoning."
,"20":"The one who received five talents came with another five talents, saying: 'Lord, you entrusted me with five talents, but see I have gained five more with them.'"
,"21":"The master answered: 'Very well, good and faithful servant, since you have been faithful in a few things, I will entrust you with much more. Come and share the joy of your master.'"
,"22":"Then the one who had two talents came and said: 'Lord, you entrusted me with two talents; I have two more which I gained with them.'"
,"23":"The master said: 'Well, good and faithful servant, since you have been faithful in little things, I will entrust you with much more. Come and share the joy of your master.'"
,"24":"Finally, the one who had received a talent came and said: 'Master, I know that you are an exacting man. You reap what you have not sown and gather what you have not invested."
,"25":"I was afraid, so I hid your money in the ground. Here, take what is yours.'"
,"26":"But his master replied: 'Wicked and worthless servant, you know that I reap where I have not sown and gather where I have not invested."
,"27":"Then you should have deposited my money in the bank, and you would have given it back to me with interest on my return."
,"28":"Therefore, take the talent from him, and give it to the one who has ten."
,"29":"For to all those who have, more will be given, and they will have an abundance; but from those who are unproductive, even what they have will be taken from them."
,"30":"As for that useless servant, throw him out into the dark where there will be weeping and gnashing of teeth.'"
,"31":"'When the Son of Man comes in his glory with all his angels, he will sit on the throne of his Glory."
,"32":"All the nations will be brought before him, and as a shepherd separates the sheep from the goats,"
,"33":"so will he do with them, placing the sheep on his right and the goats on his left."
,"34":"The King will say to those on his right: 'Come, blessed of my Father! Take possession of the kingdom prepared for you from the beginning of the world."
,"35":"For I was hungry and you fed me, I was thirsty and you gave me drink."
,"36":"I was a stranger and you welcomed me into your house. I was naked and you clothed me. I was sick and you visited me. I was in prison and you came to see me.'"
,"37":"Then the good people will ask him: 'Lord, when did we see you hungry and give you food; thirsty and give you drink,"
,"38":"or a stranger and welcome you, or naked and clothe you?"
,"39":"When did we see you sick or in prison and go to see you?'"
,"40":"The King will answer, 'Truly, I say to you: whenever you did this to these little ones who are my brothers and sisters, you did it to me.'"
,"41":"Then he will say to those on his left: 'Go, cursed people, out of my sight into the eternal fire which has been prepared for the devil and his angels!"
,"42":"For I was hungry and you did not give me anything to eat, I was thirsty and you gave me nothing to drink;"
,"43":"I was a stranger and you did not welcome me into your house; I was naked and you did not clothe me; I was sick and in prison and you did not visit me.'"
,"44":"They, too, will ask: 'Lord, when did we see you hungry, thirsty, naked or a stranger, sick or in prison, and did not help you?'"
,"45":"The King will answer them: 'Truly, I say to you: whatever you did not do for one of these little ones, you did not do for me.'"
,"46":"And these will go into eternal punishment, but the just to eternal life.'"
}`)
	CurrentBook.AddChapter(26, `{
"1":"When Jesus had finished all he wanted to say, he told his disciples,"
,"2":"'You know that in two days' time it will be the Passover and the Son of Man will be handed over to be crucified.'"
,"3":"Then the chief priests and the Jewish authorities gathered together at the palace of the High Priest whose name was Caiaphas,"
,"4":"and they agreed to trap Jesus and kill him."
,"5":"But they said among themselves, 'Not during the feast, lest there be an uprising among the people.'"
,"6":"While Jesus was in Bethany in the house of Simon the leper,"
,"7":"a woman came up to him carrying a precious jar of expensive perfume. She poured it on Jesus' head as he was at table."
,"8":"Seeing this the disciples became indignant, protesting, 'What a useless waste!"
,"9":"The perfume could have been sold for a large sum and given to the poor.'"
,"10":"But Jesus was aware of this, so he said to them, 'Why are you troubling this woman? What she has just done for me is indeed a good work."
,"11":"You always have the poor with you but you will not have me forever."
,"12":"She was preparing for my funeral when she anointed my body with this perfume."
,"13":"Truly, I say to you: wherever the Gospel is proclaimed, all over the world, what she has done will be told in praise of her.'"
,"14":"Then one of the Twelve, who was called Judas Iscariot, went off to the chief priests and said,"
,"15":"'How much will you give me if I hand him over to you?' They promised to give him thirty pieces of silver,"
,"16":"and from then on he kept looking for the best way to hand him over to them."
,"17":"On the first day of the Festival of the Unleavened Bread, the disciples came to Jesus and said to him, 'Where do you want us to prepare the Passover meal for you?'"
,"18":"Jesus answered, 'Go into the city, to the house of a certain man, and tell him: 'The Master says: My hour is near, and I will celebrate the Passover with my disciples in your house.'"
,"19":"The disciples did as Jesus had ordered and prepared the Passover meal."
,"20":"When it was evening, Jesus sat at table with the Twelve."
,"21":"While they were eating, Jesus said, 'Truly, I say to you: one of you will betray me.'"
,"22":"They were deeply distressed and asked him in turn, 'You do not mean me, do you, Lord?'"
,"23":"He answered, 'He who will betray me is one of those who dips his bread in the dish with me."
,"24":"The Son of Man is going as the Scriptures say he will. But alas for that one who betrays the Son of Man; better for him not to have been born.'"
,"25":"Judas, who was betraying him, also asked, 'You do not mean me, Master, do you?' Jesus replied, 'You have said it.'"
,"26":"While they were eating, Jesus took bread, said a blessing and broke it, and gave it to his disciples saying, 'Take and eat; this is my body.'"
,"27":"Then he took a cup and gave thanks, and passed it to them saying, 'Drink this, all of you,"
,"28":"for this is my blood, the blood of the Covenant, which is poured out for many for the forgiveness of sins."
,"29":"Yes, I say to you: I will not taste the fruit of the vine from now until the day I drink new wine with you in my Father's kingdom.'"
,"30":"After singing psalms of praise, they went out to the Mount of Olives."
,"31":"Then Jesus said to them, 'You will falter tonight because of me, and all will fall. For the Scripture says: I will strike the shepherd and the sheep will be scattered."
,"32":"But after my resurrection I will go ahead of you to Galilee.'"
,"33":"Peter responded, 'Even though all doubt you and fall, I will never fall.'"
,"34":"Jesus replied, 'Truly, I say to you: this very night before the cock crows, you will deny me three times.'"
,"35":"Peter said, 'Though I have to die with you, I will never deny you.' And all the disciples said the same."
,"36":"Jesus came with them to a place called Gethsemane, and he said to his disciples, 'Sit here while I go over to pray.'"
,"37":"He took Peter and the two sons of Zebedee along with him, and he began to be filled with anguish and distress."
,"38":"And he said to them, 'My soul is filled with sorrow even to death. Remain here and stay awake with me.'"
,"39":"He went a little farther and fell to the ground, with his face touching the earth, and prayed, 'Father, if it is possible, take this cup away from me. Yet not what I want, but what you want.'"
,"40":"He went back to his disciples and found them asleep, and he said to Peter, 'Could you not stay awake with me for even an hour?"
,"41":"Stay awake and pray, so that you may not slip into temptation. The spirit indeed is eager, but human nature is weak.'"
,"42":"He again went away and prayed, 'Father, if this cup cannot be taken away from me without my drinking it, let your will be done.'"
,"43":"When he came back to his disciples, he again found them asleep, for they could not keep their eyes open."
,"44":"He left them and again went to pray the third time, saying the same words."
,"45":"Then he came back to his disciples and said to them, 'You can sleep on now and take your rest! The hour has come and the Son of Man is now given over into the power of sinners."
,"46":"Get up, let us go. Look: the betrayer is here.'"
,"47":"Jesus was still speaking when Judas, one of the Twelve, arrived. With him was a crowd armed with swords and clubs, who had been sent by the chief priests and the Jewish authorities."
,"48":"The traitor had arranged a signal for them: 'The one I kiss, he is the man; arrest him.'"
,"49":"And he went directly to Jesus and said, 'Good evening, Master' and he gave him a kiss."
,"50":"But Jesus said to him, 'Friend, do what you came for.' Then they laid hold of Jesus and arrested him."
,"51":"One of those who were with Jesus drew his sword and struck at the servant of the High Priest, cutting off his ear."
,"52":"So Jesus said to him, 'Put your sword back into its place, for he who uses the sword will perish by the sword."
,"53":"Do you not know that I could call on my Father, and he would at once send me more than twelve legions of angels."
,"54":"If Scripture says that this has to be, should it not be fulfilled?'"
,"55":"At that moment, Jesus said to the crowd, 'Why do you come to arrest me with swords and clubs, as if I were a robber? Day after day I was seated among you teaching in the Temple, yet you did not arrest me."
,"56":"But all this has come about in fulfillment of what the Prophets said.' Then all his disciples deserted him and fled."
,"57":"Those who had arrested Jesus brought him to the house of the High Priest Caiaphas, where the teachers of the Law and the Jewish authorities were assembled."
,"58":"Peter followed him at a distance as far as the courtyard of the High Priest; he entered and sat with the guards, waiting to see the end."
,"59":"The chief priests and the whole Supreme Council needed some false evidence against Jesus, so that they might put him to death."
,"60":"But they were unable to find any, even though false witnesses came forward."
,"61":"At last, two men came up and declared, 'This man said: I am able to destroy the temple of God and rebuild it in three days.'"
,"62":"The High Priest then stood up and asked Jesus, 'Have you no answer at all? What is this evidence against you?'"
,"63":"But Jesus kept silent. So the High Priest said to him, 'In the name of the living God, I command you to tell us: Are you the Messiah, the Son of God?' "
,"64":"Jesus answered, 'It is just as you say. I tell you more: from now on, you will see the Son of Man seated at the right hand of the Most Powerful God and coming on the clouds of heaven.'"
,"65":"Then the High Priest tore his clothes, saying, 'He has blasphemed. What more evidence do we need? You have just heard these blasphemous words."
,"66":"What is your decision?' They answered, 'He must die!'"
,"67":"Then they began to spit on Jesus and slap him while others hit him with their fists,"
,"68":"saying, 'Messiah, prophesy! Who hit you?'"
,"69":"Meanwhile, as Peter sat outside in the courtyard, a young servant-girl of the house said to him, 'You also were with Jesus of Galilee.'"
,"70":"But he denied it before everyone, saying, 'I do not know what you are talking about.'"
,"71":"And as Peter was going out to the gateway, another servant-girl saw him and told the bystanders, 'This man was with Jesus of Nazareth.'"
,"72":"Peter denied it again with an oath, swearing, 'I do not know that man.'"
,"73":"After a little while, those who were standing there approached Peter and said to him, 'Of course you are one of the Galileans; your accent gives you away.'"
,"74":"Peter began justifying himself with curses and oaths protesting that he did not know the man. Just then a cock crowed."
,"75":"And Peter remembered the words of Jesus, 'Before the cock crows, you will deny me three times.' And he went away weeping bitterly."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Early in the morning all the chief priests and the Jewish authorities met to look for ways of putting Jesus to death."
,"2":"They had him bound and led him away to be handed over to Pilate, the governor."
,"3":"When Judas, the traitor, realized that Jesus had been condemned, he was filled with remorse and returned the thirty pieces of silver to the chief priests and the elders,"
,"4":"saying, 'I have sinned by betraying an innocent man to death.' They answered, 'What does it matter to us? That is your concern.'"
,"5":"So, throwing the money into the Temple, he went away and hanged himself."
,"6":"The priests picked up the money, and said, 'This money cannot be put into the Temple treasury, for this is the price of blood.'"
,"7":"So they met together and decided to buy the Potter's Field with the money and make it a cemetery for foreigners."
,"8":"This is why that place has been called Field of Blood to this day."
,"9":"So what the prophet Jeremiah said was fulfilled: They took the thirty pieces of silver, the price the sons of Israel set on him."
,"10":"And they gave them for the Potter's Field, as the Lord commanded me."
,"11":"Jesus stood before the governor who questioned him, 'Are you the King of the Jews?' Jesus answered, 'You say so.'"
,"12":"The chief priests and the Elders accused him, but he made no answer."
,"13":"Pilate said to him, 'Do you hear all the charges they bring against you?'"
,"14":"But he did not answer even a single question, so that the governor wondered."
,"15":"It was customary for the governor to release any prisoner the people asked for on the occasion of the Passover."
,"16":"Now there was a well-known prisoner called Barabbas."
,"17":"As the people had gathered, Pilate asked them, 'Whom do you want me to set free: Barabbas, or Jesus called the Messiah?'"
,"18":"For he realized that Jesus had been handed over to him out of envy."
,"19":"As Pilate was sitting in court, his wife sent him this message, 'Have nothing to do with that holy man. Because of him I had a dream last night that disturbed me greatly.'"
,"20":"But the chief priests and the Elders stirred the crowds to ask for the release of Barabbas and the death of Jesus."
,"21":"When the governor asked them again, 'Which of the two do you want me to set free?' they answered, 'Barabbas.'"
,"22":"Pilate said to them, 'And what shall I do with Jesus called the Messiah?' All answered, 'Crucify him!'"
,"23":"Pilate insisted, 'What evil has he done?' But they shouted louder, 'Crucify him!'"
,"24":"Pilate realized that he was getting nowhere and that instead there could be a riot. He then asked for water and washed his hands before the people, saying, 'I am not responsible for his blood. It is your doing.'"
,"25":"And all the people answered, 'Let his blood be upon us and upon our children.'"
,"26":"Then Pilate set Barabbas free, but had Jesus scourged, and handed him over to be crucified."
,"27":"The Roman soldiers took Jesus into the palace of the governor and the whole troop gathered around him."
,"28":"They stripped him and dressed him in a purple military cloak."
,"29":"Then, twisting a crown of thorns, they forced it onto his head, and placed a reed in his right hand. They knelt before Jesus and mocked him, saying, 'Long life to the King of the Jews!'"
,"30":"They spat on him, took the reed from his hand and struck him on the head with it."
,"31":"When they had finished mocking him, they pulled off the purple cloak and dressed him in his own clothes again, and led him out to be crucified."
,"32":"On the way they met a man from Cyrene called Simon, and forced him to carry the cross of Jesus."
,"33":"When they reached the place called Golgotha (or Calvary) which means the Skull,"
,"34":"they offered him wine mixed with gall. Jesus tasted it but would not take it."
,"35":"There they crucified him and divided his clothes among themselves, casting lots to decide what each should take."
,"36":"Then they sat down to guard him."
,"37":"The statement of his offense was displayed above his head and it read, 'This is Jesus, the King of the Jews.'"
,"38":"They also crucified two bandits with him, one on his right and one on his left."
,"39":"People passing by shook their heads and insulted him,"
,"40":"saying, 'Aha! So you will destroy the Temple and build it up again in three days. Now save yourself and come down from the cross, if you are Son of God.'"
,"41":"In the same way the chief priests, the Elders and the teachers of the Law mocked him."
,"42":"They said, 'The man who saved others cannot save himself. Let the King of Israel now come down from his cross and we will believe in him."
,"43":"He trusted in God; let God rescue him if God wants to, since he himself said: I am the Son of God.'"
,"44":"Even the robbers who were crucified with him insulted him."
,"45":"From midday darkness fell over the whole land until mid-afternoon."
,"46":"At about three o'clock, Jesus cried out in a loud voice, 'Eloi, Eloi, lamma Sabbacthani?' which means: My God, my God, why have you forsaken me?"
,"47":"As soon as they heard this, some of the bystanders said, 'He is calling for Elijah.'"
,"48":"And one of them went quickly, took a sponge and soaked it in vinegar and, putting it on a reed, gave him to drink."
,"49":"Others said, 'Leave him alone, let us see whether Elijah comes to his rescue.'"
,"50":"Then Jesus cried out again in a loud voice and gave up his spirit."
,"51":"Just then the curtain of the Temple sanctuary was torn in two from top to bottom, the earth quaked, rocks were split,"
,"52":"tombs were opened, and several holy people who had died were raised to life."
,"53":"They came out of the tombs after the resurrection of Jesus, entered the Holy City and appeared to many."
,"54":"The captain and the soldiers who guarded Jesus were greatly terrified when they saw the earthquake and all that had happened, and said, 'Truly, this man was a Son of God.'"
,"55":"There were also some women there who watched from a distance; they had followed Jesus from Galilee and saw to his needs."
,"56":"Among them were Mary Magdalene, Mary the mother of James and Joseph, and the mother of Zebedee's sons."
,"57":"It was now evening and there arrived a wealthy man from Arimathea, named Joseph, who was also a disciple of Jesus."
,"58":"He went to Pilate and asked for the body of Jesus, and the governor ordered that the body be given him."
,"59":"So Joseph took the body of Jesus, wrapped it in a clean linen sheet"
,"60":"and laid it in his own new tomb which had been cut out of the rock. Then he rolled a huge stone across the entrance of the tomb and left."
,"61":"Mary Magdalene and the other Mary remained sitting there in front of the tomb."
,"62":"On the following day (the day after the Preparation for the Passover), the chief priests and the Pharisees went to Pilate"
,"63":"and said to him, 'Sir, we remember that when that impostor was still alive, he said: I will rise after three days."
,"64":"Therefore, have his tomb secured until the third day, lest his disciples come and steal the body and say to the people: He was raised from the dead. This would be a worse lie than the first.'"
,"65":"Pilate answered them, 'You have soldiers, go and take all the necessary precautions'."
,"66":"So they went to the tomb and secured it, sealing the stone and placing it under guard."
}`)
	CurrentBook.AddChapter(28, `{
"1":"After the sabbath, at the dawn of the first day of the week, Mary Magdalene and the other Mary went to visit the tomb."
,"2":"Suddenly there was a violent earthquake: an angel of the Lord descending from heaven, came to the stone, rolled it from the entrance of the tomb, and sat on it."
,"3":"His appearance was like lightning and his garment white as snow."
,"4":"The guards trembled in fear and became like dead men when they saw the angel."
,"5":"The angel said to the women, 'Do not be afraid, for I know that you are looking for Jesus who was crucified."
,"6":"He is not here, for he is risen as he said. Come, see the place where they laid him;"
,"7":"then go at once and tell his disciples that he is risen from the dead and is going ahead of you to Galilee. You will see him there. This is my message for you.'"
,"8":"They left the tomb at once in holy fear, yet with great joy, and they ran to tell the news to the disciples."
,"9":"Suddenly, Jesus met them on the way and said, 'Peace.' The women approached him, embraced his feet and worshiped him."
,"10":"But Jesus said to them, 'Do not be afraid. Go and tell my brothers to set out for Galilee; there they will see me.'"
,"11":"While the women were on their way, the guards returned to the city and some of them reported to the chief priests all that had happened."
,"12":"The chief priests met with the Jewish authorities and decided to give the soldiers a good sum of money,"
,"13":"with this instruction, 'Say that his disciples came by night while you were asleep, and stole the body of Jesus."
,"14":"If Pilate comes to know of this, we will satisfy him and keep you out of trouble.'"
,"15":"The soldiers accepted the money and did as they were told. This story has circulated among the Jews until this day."
,"16":"As for the Eleven disciples, they went to Galilee, to the mountain where Jesus had told them to go."
,"17":"When they saw Jesus, they bowed before him, although some doubted."
,"18":"Then Jesus approached them and said, 'I have been given all authority in heaven and on earth."
,"19":"Go, therefore, and make disciples from all nations. Baptize them in the Name of the Father and of the Son and of the Holy Spirit,"
,"20":"and teach them to fulfill all that I have commanded you. I am with you always until the end of this world.'"
}`)

}
func EN_CCB_LoadNP1CChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"From Paul, called to be an apostle of Christ Jesus by the will of God, and from Sosthenes, our brother,"
,"2":"to God's Church which is in Corinth; to you whom God has sanctified in Christ Jesus and called to be holy, together with those who everywhere call upon the name of our Lord Christ Jesus, their Lord and ours."
,"3":"Receive grace and peace from God our Father, and Christ Jesus our Lord."
,"4":"I give thanks constantly to my God for you and for the grace of God given to you in Christ Jesus."
,"5":"For you have been fully enriched in him with words as well as with knowledge,"
,"6":"even as the testimony concerning Christ was confirmed in you."
,"7":"You do not lack any spiritual gift and only await the glorious coming of Christ Jesus, our Lord."
,"8":"He will keep you steadfast to the end, and you will be without reproach on the day of the coming of our Lord Jesus."
,"9":"The faithful God will not fail you after calling you to this fellowship with his Son, Christ Jesus, our Lord."
,"10":"I beg of you, brothers, in the name of Christ Jesus, our Lord, to agree among yourselves and do away with divisions; please be perfectly united, with one mind and one judgment."
,"11":"For I heard from people of Cloe's house about your rivalries."
,"12":"What I mean is this: some say, 'I am for Paul,' and others: 'I am for Apollo,' or 'I am for Peter,' or 'I am for Christ.'"
,"13":"Is Christ divided or have I, Paul, been crucified for you? Have you been baptized in the name of Paul?"
,"14":"I thank God that I did not baptize any of you, except Crispus and Gaius,"
,"15":"so that no one can say that he was baptized in my name."
,"16":"Well, I have also baptized the Stephanas family. Apart from these, I do not recall having baptized anyone else."
,"17":"For Christ did not send me to baptize, but to proclaim his Gospel. And not with beautiful words! That would be like getting rid of the cross of Christ."
,"18":"The language of the cross remains nonsense for those who are lost. Yet for us who are saved, it is the power of God,"
,"19":"as Scripture says: I will destroy the wisdom of the wise and make fail the foresight of the foresighted."
,"20":"Masters of human wisdom, educated people, philosophers, you have no reply! And the wisdom of this world? God let it fail."
,"21":"At first God spoke the language of wisdom, and the world did not know God through wisdom. Then God thought of saving the believers through the foolishness that we preach."
,"22":"The Jews ask for miracles and the Greeks for a higher knowledge,"
,"23":"while we proclaim a crucified Messiah. For the Jews, what a great scandal! And for the Greeks, what nonsense!"
,"24":"But he is Christ, the power of God and the wisdom of God for those called by God among both Jews and Greeks."
,"25":"In reality, the 'foolishness' of God is wiser than humans, and the 'weakness' of God is stronger than humans."
,"26":"Brothers and sisters, look and see whom God has called. Few among you can be said to be cultured or wealthy, and few belong to noble families."
,"27":"Yet God has chosen what the world considers foolish, to shame the wise; he has chosen what the world considers weak to shame the strong."
,"28":"God has chosen common and unimportant people, making use of what is nothing to nullify the things that are,"
,"29":"so that no mortal may boast before God."
,"30":"But, by God's grace you are in Christ Jesus, who has become our wisdom from God, and who makes us just and holy and free."
,"31":"Scripture says: Let the one who boasts boast of the Lord."
}`)
	CurrentBook.AddChapter(2, `{
"1":"When I came to reveal to you he mystery of God's plan I did not count on eloquence or on a show of learning."
,"2":"I was determined not to know anything among you but Jesus, the Messiah, and a crucified Messiah."
,"3":"I myself came weak, fearful and trembling;"
,"4":"my words and preaching were not brilliant or clever to win listeners."
,"5":"It was, rather, a demonstration of spirit and power, so that your faith might be a matter, not of human wisdom, but of God's power."
,"6":"In fact, we do speak of wisdom to the mature in faith, although it is not a wisdom of this world or of its rulers, who, by the way, come to nothing."
,"7":"We teach the mystery and secret plan of divine wisdom, which God destined from the beginning to bring us to Glory."
,"8":"No ruler of this world ever knew this; otherwise they would not have crucified the Lord of Glory."
,"9":"But as Scripture says: Eye has not seen, ear has not heard, nor has it dawned on the mind what God has prepared for those who love him."
,"10":"God has revealed it to us, through his Spirit, because the Spirit probes everything, even the depth of God."
,"11":"Who but his own spirit knows the secrets of a person? Similarly, no one but the Spirit of God knows the secrets of God."
,"12":"We have not received the spirit of the world, but the Spirit who comes from God and, through him, we understand what God in his goodness has given us."
,"13":"So we speak of this, not in terms inspired by human wisdom, but in a language taught by the Spirit, explaining a spiritual wisdom to spiritual persons."
,"14":"The one who remains on the psychologic level does not understand the things of the Spirit. They are foolishness for him and he does not understand because they require a spiritual experience."
,"15":"On the other hand, the spiritual person judges everything but no one judges him."
,"16":"Who has known the mind of God so as to teach him? But we have the mind of Christ."
}`)
	CurrentBook.AddChapter(3, `{
"1":"I could not, friends, speak to you as spiritual persons but as fleshly people, for you are still infants in Christ."
,"2":"I gave you milk and not solid food, for you were not ready for it and up to now you cannot receive it"
,"3":"for you are still of the flesh. As long as there is jealousy and strife, what can I say but that you are at the level of the flesh and behave like ordinary people."
,"4":"While one says: 'I follow Paul,' and the other: 'I follow Apollos,' what are you but people still at a human level?"
,"5":"For what is Apollos? What is Paul? They are ministers and through them you believed, as it was given by the Lord to each of them."
,"6":"I planted, Apollos watered the plant, but God made it grow."
,"7":"So neither the one who plants nor the one who waters is anything, but God who makes the plant grow."
,"8":"The one who plants and the one who waters work to the same end, and the Lord will pay each according to their work."
,"9":"We are fellow-workers with God, but you are God's field and building."
,"10":"I, as a good architect, according to the capacity given to me, I laid the foundation, and another is to build upon it. Each one must be careful how to build upon it."
,"11":"No one can lay a foundation other than the one which is already laid, which is Jesus Christ."
,"12":"Then if someone builds with gold upon this foundation, another with silver and precious stones, or with wood, bamboo or straw,"
,"13":"the work of each one will be shown for what it is. The day of Judgment will reveal it, because the fire will make everything known. The fire will test the work of everyone."
,"14":"If your work withstands the fire, you will be rewarded;"
,"15":"but if your work becomes ashes, you will pay for it. You will be saved, but it will be as if passing through fire."
,"16":"Do you not know that you are God's temple, and that God's Spirit abides within you?"
,"17":"If anyone destroys the temple of God, God will destroy him. God's temple is holy, and you are this temple."
,"18":"Do not deceive yourselves. If anyone of you considers himself wise in the ways of the world, let him become a fool, so that he may become wise."
,"19":"For the wisdom of this world is foolishness in God's eyes. To this, Scripture says: God catches the wise in their own wisdom."
,"20":"It also says: The Lord knows the reasoning of the wise, that it is useless."
,"21":"Because of this, let no one become an admirer of,humans, for everything belongs to you, "
,"22":"Paul, Apollos, Cephas - life, death, the present and the future. Everything is yours,"
,"23":"and you, you belong to Christ, and Christ is of God."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Let everyone then see us as the servants of Christ and stewards of the secret works of God."
,"2":"Being stewards, faithfulness shall be demanded of us;"
,"3":"but I do not mind if you or any human court judges me. I do not even judge myself;"
,"4":"my conscience indeed does not accuse me of anything, but that is not enough for me to be set right with God: the Lord is the one who judges me."
,"5":"Therefore, do not judge before the time, until the coming of the Lord. He will bring to light whatever was hidden in darkness and will disclose the secret intentions of the hearts. Then each one will receive praise from God."
,"6":"Brothers and sisters, you forced me to apply these comparisons to Apollos and to myself. Learn by this example not to,believe yourselves superior by siding with one against the other. "
,"7":"How then are you more than the others? What have you that you have not received? And if you received it, why are you proud, as if you did not receive it?"
,"8":"So, then, you are already rich and satisfied, and feel like kings without us! I wish you really were kings, so that we might enjoy the kingship with you!"
,"9":"It seems to me that God has placed us, the apostles, in the last place, as if condemned to death, and as spectacles for the whole world, for the angels as well as for mortals."
,"10":"We are fools for Christ, while you show forth the wisdom of Christ. We are weak, you are strong. You are honored, while we are despised."
,"11":"Until now we hunger and thirst, we are poorly clothed and badly treated, while moving from place to place."
,"12":"We labor, working with our hands. People insult us and we bless them, they persecute us and we endure everything;"
,"13":"they speak evil against us, and ours are works of peace. We have become like the scum of the earth, like the garbage of humankind until now."
,"14":"I do not write this to shame you, but to warn you as very dear children."
,"15":"Because even though you may have ten thousand guardians in the Christian life, you have only one father; and it was I who gave you life in Christ through the Gospel."
,"16":"Therefore I pray you to follow my example."
,"17":"With this purpose I send to you Timothy, my dear and trustworthy son in the service of the Lord. He will remind you of my way of Christian life, as I teach it in all churches everywhere."
,"18":"Some of you thought that I could not visit you and became very arrogant."
,"19":"But I will visit you soon, the Lord willing, and I will see, not what those arrogant people say, but what they can do."
,"20":"Because the kingdom of God is not a matter of words, but of power."
,"21":"What do you prefer, for me to come with a stick or with love and gentleness?"
}`)
	CurrentBook.AddChapter(5, `{
"1":"You have become news with a case of immorality, and such a case that is not even found among pagans. Yes, one of you has taken as wife his own stepmother."
,"2":"And you feel proud! Should you not be in mourning instead and expel the one who did such a thing."
,"3":"For my part, although I am physically absent, my spirit is with you and, as if present, I have already passed sentence on the man who committed such a sin."
,"4":"Let us meet together, you and my spirit, and in the name of our Lord Jesus and with his power,"
,"5":"you shall deliver him to Satan, so that he may lose everything and his life, but his spirit be saved in the day of Judgment."
,"6":"This is not the time to praise yourselves. Do you not know that a little yeast makes the whole mass of dough rise?"
,"7":"Throw out, then, the old yeast and be new dough. If Christ became our Passover, you should be unleavened bread."
,"8":"Let us celebrate, therefore, the Passover, no longer with old yeast, which is sin and perversity; let us have unleavened bread, that is purity and sincerity."
,"9":"In my last letter I instructed you not to associate with immoral people."
,"10":"I did not mean, of course, those who do not belong to the church and who are immoral, exploiters, embezzlers or worshipers of idols. Otherwise you would have to leave this world."
,"11":"What I really meant was to avoid and not to mingle with anyone who, bearing the name of brother or sister, becomes immoral, exploiter, gossip, drunkard, embezzler. In which case you should not even eat with them."
,"12":"Why should I judge outsiders? But you, are you not to judge those who are inside?"
,"13":"Let God judge those outside, but as for you, drive out the wicked person from among you."
}`)
	CurrentBook.AddChapter(6, `{
"1":"When you have a complaint against a brother, how dare you bring it before pagan judges instead of bringing it before God's people?"
,"2":"Do you not know that you shall one day judge the world? And if you are to judge the world, are you incapable of judging such simple problems?"
,"3":"Do you not know that we will even judge the angels? And could you not decide every day affairs?"
,"4":"You should ask those who are the last in the Church to decide such matters."
,"5":"Shame on you! Is there not even one among you wise enough to be the arbiter among believers?"
,"6":"But no. One of you brings a suit against another one, and files that suit before unbelievers."
,"7":"It is already a failure that you have suits against each other. Why do you not rather suffer wrong and receive some damage?"
,"8":"But no. You wrong and injure others, and those are your brothers and sisters."
,"9":"Do you not know that the wicked will not inherit the Kingdom of God?,Make no mistake about it: those who lead immoral lives, or worship idols, or who are adulterers, homosexuals of any kind, "
,"10":"or thieves, exploiters, drunkards, gossips or embezzlers will not inherit the kingdom of heaven."
,"11":"Some of you were like that, but you have been cleansed and consecrated to God and have been set right with God by the Name of the Lord Jesus and the Spirit of our God."
,"12":"Everything is lawful for me, but not everything is to my profit. Everything is lawful for me, but I will not become a slave of anything."
,"13":"Food is for the stomach, as the stomach is for food, and God will destroy them both. Yet the body is not for sex, but for the Lord; and the Lord is for the body."
,"14":"And God who raised the Lord, will also raise us with his power."
,"15":"Do you not know that your bodies are members of Christ? And you would make that part of his body become a part of a prostitute? Never!"
,"16":"But you well know that when you join yourselves to a prostitute, you become one with her. For Scripture says: The two will become one flesh."
,"17":"On the contrary, anyone united to the Lord becomes one spirit with him."
,"18":"Avoid unlawful sex entirely. Any other sin a person commits is outside the body but those who commit sexual immorality sin against their own body."
,"19":"Do you not know that your body is a temple of the Holy Spirit within you, given by God? You belong no longer to yourselves."
,"20":"Remember at what price you have been bought and make your body serve the glory of God."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Now I will answer the questions in your letter. It is good for a man not to have sex with a woman."
,"2":"But the appeal of sex is there. Let each man have his own wife and each woman her own husband."
,"3":"Let the husband fulfill his duty of husband and likewise the wife."
,"4":"The wife is not the owner of her own body: the husband is. Similarly, the husband is not the owner of his own body: the wife is."
,"5":"Do not refuse each other, except by mutual consent and only for a time in order to dedicate yourselves to prayer, and then come together again, lest you fall into Satan's trap by lack of self-control."
,"6":"I approve of this abstention, but I do not order it."
,"7":"I would like everyone to be like me, but each has from God a particular gift, some in one way, others differently."
,"8":"To the unmarried and the widows I say that it would be good for them to remain as I am,"
,"9":"but if they cannot control themselves, let them marry, for it is better to marry than to burn with passion."
,"10":"I command married couples - not I but the Lord - that the wife should not separate from her husband."
,"11":"If she separates from him, let her not marry again, or let her make peace with her husband. Similarly the husband should not divorce his wife."
,"12":"To the others I say - from me and not from the Lord - if a brother has a wife who is not a believer but she agrees to live with him, let him not separate from her."
,"13":"In the same manner, if a woman has a husband who is not a believer but he agrees to live with her, let her not separate from her husband."
,"14":"Because the unbelieving husband is sanctified by the wife, and the unbelieving wife is sanctified by the husband who believes. Otherwise, your children also would be apart from God; but as it is, they are consecrated to God."
,"15":"Now, if the unbelieving husband or wife wants to separate, let them do so. In this case, the Christian partner is not bound, for the Lord has called us to peace."
,"16":"Besides, are you sure, wife, that you could save your husband, and you, husband, that you could save your wife?"
,"17":"Except for this, let each one continue living as he was when God called him, as was his lot set by the Lord. This is what I order in all churches."
,"18":"Let the circumcised Jew not remove the marks of the circumcision when he is called by God, and let the non-Jew not be circumcised when he is called."
,"19":"For the important thing is not to be circumcised or not, but to keep the commandments of God."
,"20":"Let each of you, therefore, remain in the state in which you were called by God."
,"21":"If you were a slave when called, do not worry, yet if you can gain your freedom, take the opportunity."
,"22":"The slave called to believe in the Lord is a freed person belonging to the Lord just as whoever who has been called while free, becomes a slave of Christ."
,"23":"You have been bought at a very great price; do not become slaves of a human being."
,"24":"So then, brothers and sisters, continue living in the state you were before God at the time of his call."
,"25":"With regard to those who remain virgins, I have no special commandment from the Lord, but I give some advice, hoping that I am worthy of trust by the mercy of the Lord."
,"26":"I think this is good in these hard times in which we live. It is good for someone to remain as he is."
,"27":"If you are married, do not try to divorce your wife; if you are not married, do not marry."
,"28":"He who marries does not sin, nor does the young girl sin who marries. Yet they will face disturbing experiences, and I would like to spare you."
,"29":"I say this, brothers and sisters: time is running out, and those who are married must live as if not married;"
,"30":"those who weep as if not weeping; those who are happy as if they were not happy; those buying something as if they had not bought it, and those enjoying the present life as if they were not enjoying it."
,"31":"For the order of this world is vanishing."
,"32":"I would like you to be free from anxieties. He who is not married is concerned about the things of the Lord and how to please the Lord."
,"33":"While he who is married is taken up with the things of the world and how to please his wife, and he is divided in his interests."
,"34":"Likewise, the unmarried woman and the virgin are concerned with the service of the Lord, to be holy in body and spirit. The married woman, instead, worries about the things of the world and how to please her husband."
,"35":"I say this for your own good. I do not wish to lay traps for you but to lead you to a beautiful life, entirely united with the Lord."
,"36":"If anyone is not sure whether he is behaving correctly with his fiancee because of the ardor of his passion, and considers it is better to get married, let him do so; he commits no sin."
,"37":"But if another, of firmer heart, thinks that he can control his passion and decides not to marry so that his fiancee may remain a virgin, he does better."
,"38":"So then, he who marries does well, and he who does not marry does better."
,"39":"The wife is bound as long as her husband lives. If he dies, she is free to be married to whomsoever she wishes, provided that she does so in the Christian way."
,"40":"However, she will be happier if, following my advice, she remains as she is, and I believe that I also have the Spirit of God."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Regarding meat from the offerings to idols, we know that all of us have knowledge but knowledge puffs up, while love builds."
,"2":"If anyone thinks that he has knowledge, he does not yet know as he should know,"
,"3":"but if someone loves (God), he has been known (by God)."
,"4":"Can we, then, eat meat from offerings to the idols? We know that an idol is without existence and that there is no God but one."
,"5":"People speak indeed of other gods in heaven and on earth and, in this sense, there are many gods and lords."
,"6":"Yet for us, there is but one God, the Father, from whom everything comes, and to whom we go. And there is one Lord, Christ Jesus, through whom everything exists and through him we exist."
,"7":"Not everyone, however, has that knowledge. For some persons, who until recently took the idols seriously, that food remains linked to the idol and eating of it stains their conscience which is unformed."
,"8":"It is not food that brings us closer to God. If we eat, we gain nothing, and if we do not eat, we do not lose anything."
,"9":"We are free, of course, but let not your freedom cause others, who are less prepared, to fall."
,"10":"What if others with an unformed conscience see you, a person of knowledge, sitting at the table in the temple of idols? Will not their weak conscience, because of your example, move them to eat also?"
,"11":"Then with your knowledge you would have caused your weak brother or sister to perish, the one for whom Christ died."
,"12":"When you disturb the weak conscience of your brother or sister and sin against them, you sin against Christ himself."
,"13":"Therefore, if any food will bring my brother to sin, I shall never eat this food lest my brother or sister fall."
}`)
	CurrentBook.AddChapter(9, `{
"1":"As for me, am I not free? I am an apostle and I have seen Jesus, the Lord, and you are my work in the Lord."
,"2":"Although I may not be an apostle for others, at least I am one for you. You are, in the Lord, evidence of my apostleship."
,"3":"Now this is what I answer to those who criticize me:"
,"4":"Have we not the right to be fed?"
,"5":"Have we not the right to bring along with us a sister as do the other apostles and the brothers of the Lord, and Cephas?"
,"6":"Am I the only one, with Barnabas, bound to work?,What soldier goes to war at his own expense? "
,"7":"What farmer does not eat from the vineyard he planted? Who tends a flock and does not drink from its milk?"
,"8":"Are these rights only accepted human practice? No. The Law says the same. In the law of Moses it is written: Do not muzzle the ox which threshes grain."
,"9":"Does this mean that God is concerned with oxen,"
,"10":"or rather with us? Of course it applies to us. For our sake it was written that no one plows without expecting a reward for plowing, and no one threshes without hoping for a share of the crop."
,"11":"Then, if we have sown spiritual riches among you, would it be too much for us to reap some material reward?"
,"12":"If others have had a share among you, we could have it all the more. Yet we made no use of this right and we prefer to endure everything rather than put any obstacle to the Gospel of Christ. "
,"13":"Do you not know that those working in the sacred service eat from what is offered for the temple? And those serving at the altar receive their part from the altar."
,"14":"The Lord ordered, likewise, that those announcing the Gospel live from the Gospel."
,"15":"Yet I have not made use of my rights, and now I do not write to claim them: I would rather die! No one will deprive me of this glory of mine."
,"16":"Because I cannot boast of announcing the Gospel: I am bound to do it. Woe to me if I do not preach the Gospel!"
,"17":"If I preached voluntarily, I could expect my reward, but I have been trusted this office against my will."
,"18":"How can I, then, deserve a reward? In announcing the Gospel, I will do it freely without making use of the rights given to me by the Gospel."
,"19":"So, feeling free with everybody, I have become everybody's slave in order to gain a greater number."
,"20":"To save the Jews I became a Jew with the Jews, and because they are under the Law, I myself submitted to the Law, although I am free from it."
,"21":"With the pagans, not subject to the Law, I became one of them, although I am not without a law of God, since Christ is my Law. Yet I wanted to gain those strangers to the Law."
,"22":"With people of unformed conscience I acted as if I were sharing their scruples in order to gain those who are still weak."
,"23":"So I made myself all things to all people in order to save, by all possible means, some of them. This I do for the Gospel, so that I too have a share of it."
,"24":"Have you not learned anything from the stadium? Many run, but only one gets the prize. Run, therefore, intending to win it,"
,"25":"as athletes who impose upon themselves a rigorous discipline. Yet for them the wreath is of laurels which wither, while for us, it does not wither."
,"26":"So, then, I run knowing where I go. I box but not aimlessly in the air."
,"27":"I punish my body and control it, lest after preaching to others, I myself should be rejected."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Let me remind you, brothers and sisters, about our ancestors. All of them were under the cloud and all crossed the sea."
,"2":"All underwent the baptism of the land and of the sea to join Moses"
,"3":"and all of them ate from the same spiritual manna"
,"4":"and all of them drank from the same spiritual drink. For you know that they drank from a spiritual rock following them, and the rock was Christ."
,"5":"However, most of them did not please God, and the desert was strewn with their bodies."
,"6":"All of this happened as an example for us, so that we might not become people of evil desires, as they did."
,"7":"Do not follow idols, as some of them did, and Scripture says: The people sat down to eat and drink and stood up for orgy."
,"8":"Let us not fall into sexual immorality as some of them did, and in one day twenty-three thousand of them fell dead."
,"9":"And let us not tempt the Lord as some of them did, and were killed by serpents;"
,"10":"nor grumble as some of them did and were cut down by the destroying angel."
,"11":"These things happened to them as an example, and they were written as a warning for us, as the last times come upon us."
,"12":"Therefore, if you think you stand, beware, lest you fall."
,"13":"No trial greater than human endurance has overcome you. God is faithful and will not let you be tempted beyond your strength. He will give you, together with the temptation, the strength to escape and to resist."
,"14":"Therefore, dear friends, shun the cult of idols."
,"15":"I address you as intelligent persons; judge what I say."
,"16":"The cup of blessing that we bless, is it not a communion with the blood of Christ? And the bread that we break, is it not a communion with the body of Christ?"
,"17":"The bread is one, and so we, though many, form one body, sharing the one bread."
,"18":"Consider the Israelites. For them, to eat of the victim is to come into communion with its altar."
,"19":"What does all that mean? That the meat is really consecrated to the idol, or that the idol is a being."
,"20":"However, when the pagans offer a sacrifice, the sacrifice goes to the demons, not to God. I do not want you to come into fellowship with demons."
,"21":"You cannot drink at the same time from the cup of the Lord and from the cup of demons. You cannot share in the table of the Lord and in the table of the demons."
,"22":"Do we want, perhaps, to provoke the jealousy of the Lord? Could we be stronger than he?"
,"23":"Everything is lawful for me, but not everything is to my profit. Everything is lawful for me, but not everything builds up:"
,"24":"let no one pursue his own interests, but the interests of the other."
,"25":"Eat, then, whatever is sold at the market, and do not raise questions of conscience about it."
,"26":"Because: the earth and whatever is on it belongs to the Lord."
,"27":"If someone who does not share your faith invites you, go and eat of anything served to you without problems of conscience."
,"28":"However, if somebody tells you that the meat is from the offerings to idols, then do not eat out of consideration for those warning you and for the sake of their conscience."
,"29":"I say: 'In consideration of their conscience,' not of yours, for is it convenient that my rights be misinterpreted by them and their conscience?"
,"30":"Is it good that I bring on me critics for some good thing I am sharing and for which I will give thanks?"
,"31":"Then, whether you eat, or drink, or whatever you do, do it for the glory of God."
,"32":"Give no offense to the Jews, or to the Greeks, or to the Church of God,"
,"33":"just as I try to please everyone in everything. I do not seek my own interest, but that of many, this is: that they be saved."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Follow my example as I follow the example of Christ."
,"2":"I praise you because you remember me in everything, and you keep the traditions that I have given you."
,"3":"However I wish to remind you that every man has Christ as his head, while the wife has her husband as her head; and God is the head of Christ."
,"4":"If a man prays or prophesies with his head covered, he dishonors his head."
,"5":"On the contrary, the woman who prays or prophesies with her head uncovered, does not respect her head. She might as well cut her hair."
,"6":"If a woman does not use a veil, let her cut her hair; and if it is a shame for a woman to have her hair cut or shaved, then let her use a veil."
,"7":"Men do not need to cover their head, for they are the image of God and reflect his glory, while a woman reflects the glory of man."
,"8":"Man was not formed from woman, but woman from man."
,"9":"Nor did God create man for woman, but woman for man."
,"10":"Therefore, a woman must respect the angels and have on her head the sign of her dependence."
,"11":"Anyway, the Christian attitude does not separate man from woman, and woman from man,"
,"12":"and if God has created woman from man, man is born from woman and both come from God."
,"13":"Judge for yourselves: is it proper for a woman to pray without a veil?"
,"14":"Common sense teaches us that it is shameful for a man to wear long hair,"
,"15":"while long hair is the pride of a woman, and it has been given to her precisely as a veil."
,"16":"If some of you want to argue, let it be known that it is not our custom nor the custom in the churches of God."
,"17":"To continue with my advice, I cannot praise you, for your gatherings are not for the better but for the worse."
,"18":"First, as I have heard, when you gather together, there are divisions among you and I partly believe it."
,"19":"There may have to be different groups among you, so that it plainly appears who are approved among you."
,"20":"Your gatherings are no longer the Supper of the Lord,"
,"21":"for each one eats at once his own food and while one is hungry, the other is getting drunk."
,"22":"Do you not have houses in which to eat and drink? Or perhaps you despise the Church of God and desire to humiliate those who have nothing? What shall I say? Shall I praise you? For this I cannot praise you."
,"23":"This is the tradition of the Lord that I received and that in my turn I have handed on to you; the Lord Jesus, on the night that he was delivered up, took bread and,"
,"24":"after giving thanks, broke it, saying, 'This is my body which is broken for you; do this in memory of me.'"
,"25":"In the same manner, taking the cup after the supper, he said, 'This cup is the new Covenant in my blood. Whenever you drink it, do it in memory of me.'"
,"26":"So, then, whenever you eat of this bread and drink from this cup, you are proclaiming the death of the Lord until he comes."
,"27":"Therefore, if anyone eats of the bread or drinks from the cup of the Lord unworthily, he sins against the body and blood of the Lord."
,"28":"Let each one, then, examine himself before eating of the bread and drinking from the cup."
,"29":"Otherwise, he eats and drinks his own condemnation in not recognizing the Body."
,"30":"This is the reason why so many among you are sick and weak and several have died."
,"31":"If we examined and corrected ourselves, the Lord would not have to exercise judgment against us."
,"32":"The Lord's strokes are to correct us, so that we may not be condemned with this world."
,"33":"So then, brothers, when you gather for a meal, wait for one another"
,"34":"and, if someone is hungry, let him eat in his own house. In this way you will not gather for your common condemnation. The other instructions I shall give when I go there."
}`)
	CurrentBook.AddChapter(12, `{
"1":"With respect to spiritual gifts, I will remind you of the following."
,"2":"When you were still pagans, you went to your dumb idols as people possessed."
,"3":"I tell you that nobody inspired by the Spirit of God may say, 'A curse on Jesus,' as no one can say, 'Jesus is the Lord,' except by the Holy Spirit."
,"4":"There is diversity of gifts, but the Spirit is the same."
,"5":"There is diversity of ministries, but the Lord is the same."
,"6":"There is diversity of works, but the same God works in all."
,"7":"The Spirit reveals his presence in each one with a gift which is also a,service. "
,"8":"One is to speak with wisdom, through the Spirit. Another teaches according to the same Spirit."
,"9":"To another is given faith, in which the Spirit acts; to another the gift of healing, and it is the same Spirit."
,"10":"Another works miracles, another is a prophet, another recognizes what comes from the good or evil spirit; another speaks in tongues, and still another interprets what has been said in tongues."
,"11":"And all of this is the work of the one and only Spirit, who gives to each one as he so desires."
,"12":"As the body is one, having many members, and all the members, while being many, form one body, so it is with Christ."
,"13":"All of us, whether Jews or Greeks, slaves or free, have been baptized in one Spirit to form one body and all of us have been given to drink from the one Spirit."
,"14":"The body has not just one member, but many."
,"15":"If the foot should say, 'I do not belong to the body for I am not a hand,' it would be wrong: it is part of the body!"
,"16":"Even though the ear says, 'I do not belong to the body for I am not an eye,' it is part of the body."
,"17":"If all the body were eye, how would we hear? And if all the body were ear, how would we smell?"
,"18":"God has arranged all the members, placing each part of the body as he pleased."
,"19":"If all were the same part where would the body be?"
,"20":"But there are many members and one body."
,"21":"The eye cannot tell the hand, 'I do not need you,' nor the head tell the feet, 'I do not need you.'"
,"22":"Still more, the parts of our body that we most need are those that seem to be the weakest;"
,"23":"the parts that we consider lower are treated with much care,"
,"24":"and we cover them with more modesty because they are less presentable, whereas the others do not need such attention."
,"25":"God himself arranged the body in this way, giving more honor to those parts that need it, so that the body may not be divided, but rather each member may care for the others."
,"26":"When one suffers, all of them suffer, and when one receives honor, all rejoice together."
,"27":"Now, you are the body of Christ and each of you individually is a member of it."
,"28":"So God has appointed us in the Church. First apostles, second prophets, third teachers. Then come miracles, then the gift of healing, material help, administration in the Church and the gift of tongues."
,"29":"Are all apostles? Are all prophets? Are all teachers? Can all perform miracles,"
,"30":"or cure the sick, or speak in tongues, or explain what was said in tongues?"
,"31":"Be that as it may, set your hearts on the most precious gifts, and I will show you a much better way."
}`)
	CurrentBook.AddChapter(13, `{
"1":"If I could speak all the human and angelic tongues, but had no love, I would only be sounding brass or a clanging cymbal."
,"2":"If I had prophecy, knowing secret things with all kinds of knowledge, and had faith great enough to remove mountains, but had no love, I would be nothing."
,"3":"If I gave everything I had to the poor, and even gave up my own body, but only to receive praise and not through love, it would be of no value to me."
,"4":"Love is patient, kind, without envy. It is not boastful or arrogant. It is not ill-mannered nor does it seek its own interest."
,"5":"Love overcomes anger and forgets offenses."
,"6":"It does not take delight in wrong, but rejoices in truth."
,"7":"Love excuses everything, believes all things, hopes all things, endures all things."
,"8":"Love will never end. Prophecies may cease, tongues be silent and knowledge disappear."
,"9":"For knowledge grasps something of the truth and prophecy as well."
,"10":"And when what is perfect comes, everything imperfect will pass away."
,"11":"When I was a child I thought and reasoned like a child, but when I grew up, I gave up childish ways."
,"12":"Likewise, at present we see dimly as in a faulty mirror, but then it shall be face to face. Now we know in part, but then I will know as I am known."
,"13":"Now we have faith, hope and love, these three, but the greatest of these is love."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Strive, then, for love and set your hearts on spiritual gifts, especially that you may prophesy."
,"2":"The one who speaks in tongues does not speak to people, but to God, for no one understands him; the spirit makes him say things that are not understandable."
,"3":"The prophet, instead, addresses all people to give them strength, encouragement and consolation."
,"4":"He who speaks in tongues strengthens himself, but the prophet builds the Church."
,"5":"Would that all of you spoke in tongues! But better still if you were all prophets. The prophet has an advantage over the one speaking in tongues, unless someone explains what was spoken, so that the community may profit."
,"6":"Suppose, brothers and sisters, I go to you and I speak in tongues, of what use will it be to you if I do not bring you some revelation, knowledge, prophecy or teaching?"
,"7":"When someone plays the flute, or harp, or any musical instrument, if there are not tones and notes, who will recognize the tune?"
,"8":"And if the bugle call is not clear, who will get ready for battle?"
,"9":"The same with you. If your words are not understood, who will know what is said? You will be talking to the moon."
,"10":"There are many languages in the world, and each of them has meaning,"
,"11":"but if I cannot find any meaning in what is said, I become a foreigner to the speaker, and the speaker to me."
,"12":"As you set your heart on spiritual gifts, be eager to build the Church and you will receive abundantly."
,"13":"Because of this, those who speak in tongues should ask God for the ability to explain what they say."
,"14":"When I am praying in tongues, my spirit prays, but my mind remains idle."
,"15":"What shall I do, then? I will pray with the spirit and I will pray with my mind. I will sing with the spirit and I will sing with the mind."
,"16":"If you praise God only with your spirit, how will the ordinary person add the 'Amen' to your thanksgiving, since the outsider has not understood what you said?"
,"17":"Your thanksgiving was indeed beautiful, but it was useless for others."
,"18":"I give thanks to God because I speak in tongues more than all of you,"
,"19":"but when I am in the assembly, I prefer to say five words from my mind, which may teach others, than ten thousand words in tongues."
,"20":"Brothers and sisters, do not remain as children in your thinking. Be like infants in doing evil, but mature in your thinking."
,"21":"God says in the Law: I will speak to this people through those talking other tongues and through lips of foreigners, but even so they will not listen to me."
,"22":"So, speaking in tongues is significant for those who refuse to believe, not for those who believe, while prophecy is a sign for those who believe, not for those who refuse to believe."
,"23":"Yet imagine that the whole Church is gathered together and all speak in tongues when unbelievers and uninformed people enter. What will they think? That you are crazy."
,"24":"Instead, suppose that each of you speaks as a prophet; as soon as an unbeliever or an uninformed person enters, all of you call him to account and disclose his most secret thinking."
,"25":"Then, falling on his face, he would be urged to worship God and declare that God is truly among you."
,"26":"What then shall we conclude, brothers? When you gather, each of you can take part with a song, a teaching, or a revelation, by speaking in tongues or interpreting what has been said in tongues. But let all this build up the Church."
,"27":"Are you going to speak in tongues? Let two or three, at most, speak, each in turn, and let one interpret what has been said."
,"28":"If there is no interpreter, hold your tongue in the assembly and speak to God by yourself."
,"29":"As for the prophets, let two or three speak, with the others commenting on what has been said."
,"30":"If a revelation comes to one of those sitting by, let the first be silent."
,"31":"Even all of you could prophesy, one by one, for the instruction and encouragement of all."
,"32":"The spirits speaking through prophets are submitted to prophets,"
,"33":"because God is not a God of confusion, but of peace."
,"34":"(Let women be silent in the assemblies, as in all the churches of the saints. They are not allowed to speak. Let them be submissive as the Law commands."
,"35":"If there is anything they desire to know, let them consult their husbands at home. For it is shameful for a woman to speak in Church.)"
,"36":"Did the word of God, perhaps, come from you? or did it come only to you?"
,"37":"Anyone among you who claims to be a prophet or a spiritual person, should acknowledge that what I am writing to you is the Lord's command."
,"38":"If he does not recognize that, God will not recognize him."
,"39":"So, my friends, set your hearts on the gift of prophecy, and do not forbid speaking in tongues."
,"40":"However, everything should be done in a fitting and orderly way."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Let me remind you, brothers and sisters, of the Good News that I preached to you and which you received and on which you stand firm."
,"2":"By that Gospel you are saved, provided that you hold to it as I preached it. Otherwise, you will have believed in vain."
,"3":"In the first place, I have passed on to you what I myself received: that Christ died for our sins, as Scripture says;"
,"4":"that he was buried; that he was raised on the third day, according to the Scriptures;"
,"5":"that he appeared to Cephas and then to the Twelve."
,"6":"Afterwards he appeared to more than five hundred brothers and sisters together; most of them are still alive, although some have already gone to rest."
,"7":"Then he appeared to James and after that to all the apostles."
,"8":"And last of all, he appeared the most despicable of them, this is to me."
,"9":"For I am the last of the apostles, and I do not even deserve to be called an apostle, because I persecuted the Church of God."
,"10":"Nevertheless, by the grace of God, I am what I am, and his grace towards me has not been without fruit. Far from it, I have toiled more than all of them, although not I, rather the grace of God in me."
,"11":"Now, whether it was I or they, this we preach and this you have believed."
,"12":"Well, then, if Christ is preached as risen from the dead, how can some of you say that there is no resurrection of the dead?"
,"13":"If there is no resurrection of the dead, then Christ has not been raised."
,"14":"And if Christ has not been raised, our preaching is empty and our belief comes to nothing."
,"15":"And we become false witnesses of God, attesting that he raised Christ, whereas he could not raise him if indeed the dead are not raised."
,"16":"If the dead are not raised, neither has Christ been raised."
,"17":"And if Christ has not been raised, your faith gives you nothing, and you are still in sin."
,"18":"Also those who fall asleep in Christ are lost."
,"19":"If it is only for this life that we hope in Christ, we are the most unfortunate of all people."
,"20":"But no, Christ has been raised from the dead and he comes before all those who have fallen asleep."
,"21":"A human being brought death; a human being also brings resurrection of the dead."
,"22":"All die for being Adam's, and in Christ all will receive life."
,"23":"However, each one in his own time: first Christ, then Christ's people, when he visits them."
,"24":"Then the end will come, when Christ delivers the Kingdom to God the Father, after having destroyed every rule, authority and power."
,"25":"For he must reign and put all enemies under his feet."
,"26":"The last enemy to be destroyed will be death."
,"27":"As Scripture says: God has subjected everything under his feet. When we say that everything is put under his feet, we exclude, of course, the Father who subjects everything to him. "
,"28":"When the Father has subjected everything to him, the Son will place himself under the One who subjected everything to him. From then on, God will be all in all."
,"29":"Tell me: what are these people doing who are baptized on behalf of the dead? If the dead cannot be raised, why do they want to be baptized for the dead?"
,"30":"As for us, why do we constantly risk our life? For death is my daily companion."
,"31":"I say that, brothers and sisters, before you who are my pride in Christ Jesus our Lord."
,"32":"Was it for human interest that I fought in Ephesus like a lion tamer? If the dead are not raised, let us eat and drink, for tomorrow we shall die!"
,"33":"Do not be deceived; bad theories corrupt good morals. Wake up, and do not sin,"
,"34":"because some of you are outstandingly ignorant about God; I say this to your shame."
,"35":"Some of you will ask: How will the dead be raised? With what kind of body will they come?"
,"36":"You fools! What you sow cannot sprout unless it dies."
,"37":"And what you sow is not the body of the future plant but a bare grain of wheat or any other seed,"
,"38":"and God will give the appropriate body, as he gives to each seed its own body."
,"39":"Now look: not all flesh is the same; one is the flesh of human beings; another the flesh of animals, and still others the flesh of birds and of fish."
," 40":"There are, likewise, heavenly bodies and earthly bodies, but the earthly bodies do not shine as do the heavenly ones."
,"41":"The brightness of the sun differs from the brightness of the moon and the stars, and the stars differ from one another in brightness."
,"42":"It is the same with the resurrection of the dead. The body is sown in decomposition; it will be raised never more to die."
,"43":"It is sown in humiliation, and it will be raised for Glory. It is buried in weakness, but the resurrection shall be with power. When buried it is a natural body, but it will be raised as a spiritual body."
,"44":"For there shall be a spiritual body as there is at present a living body."
,"45":"Scripture says that Adam, the first human being, was given natural life; but the last Adam has become spirit that gives life."
,"46":"The spirit does not appear first, but the natural life, and afterwards comes the spirit."
,"47":"The first man comes from the earth and is earthly, while the second one comes from heaven."
,"48":"As it was with the earthly one, so is it with the earthly people. As it is with Christ, so with the heavenly."
,"49":"This is why, after bearing the image of the earthly one, we shall also bear the image of the heavenly one."
,"50":"This I say, brothers: Flesh and blood cannot share the kingdom of God; nothing of us that is to decay can reach imperishable life."
,"51":"So I want to teach you this mystery: although not all of us will die, all of us have to be transformed,"
,"52":"in an instant, at the sound of the trumpet. You have heard of the last trumpet; then in the twinkling of an eye, the dead will be raised imperishable, while we shall be transformed."
,"53":"For it is necessary that our mortal and perishable being put on the life that knows neither death nor decay."
,"54":"When our perishable being puts on imperishable life, when our mortal being puts on immortality, the word of Scripture will be fulfilled: Death has,been swallowed up by victory. "
,"55":"Death, where is your victory? Death, where is your sting?"
,"56":"Sin is the sting of death to kill, and the Law is what gives force to sin."
,"57":"But give thanks to God who gives us the victory through Christ Jesus, our Lord."
,"58":"So then, my dear brothers and sisters, be steadfast and do not be moved. Improve constantly in the work of the Lord, knowing that with him your labor is not without fruit."
}`)
	CurrentBook.AddChapter(16, `{
"1":"With regard to the collection in favor of the saints, follow the rules that I gave to the churches of Galatia."
,"2":"Every Sunday, let each of you put aside what you are able to spare, so that no collection need be made when I come."
,"3":"Once I am with you, you will choose the persons whom I may accredit with letters to take your gifts to Jerusalem."
,"4":"And if it seems better for me to go, they will go with me."
,"5":"I will visit you after passing through Macedonia, for I want to go only through Macedonia."
,"6":"I would like to stay with you for a while, and perhaps I will spend the winter so that you may help me on my way wherever I go."
,"7":"I do not want to see you now just in passing, for I really hope to stay with you, if the Lord permits."
,"8":"But I will stay in Ephesus until Pentecost,"
,"9":"because I have a door wide open here, even though there are many opponents."
,"10":"When Timothy comes, make him feel at ease with you. Consider that, like me, he is working for the Lord."
,"11":"Let no one look down on him. Help him continue his journey so that he may return to me without difficulties. I am expecting him with the brothers."
,"12":"With respect to our brother Apollos, I have strongly urged him to visit you with the brothers, but he did not want to go at all; he will visit you at his first opportunity."
,"13":"Be alert, stand firm in the faith, be courageous, be strong."
,"14":"Let love be in all."
,"15":"Now, brothers and sisters, you know that in Achaia, there is none better than Stephanas and his family and that they have devoted themselves to the service of the holy ones."
,"16":"I urge you to be subject to such persons and to anyone who works and toils with them."
,"17":"I am glad about the coming of Stephanas, Fortunatus and Achaicus who were able to represent you."
,"18":"In fact, they appeased my spirit and yours. Appreciate persons like them."
,"19":"The churches of Asia greet you. Aquila and Prisca greet you in the Lord, as does the church that gathers in their house."
,"20":"All the brothers and sisters greet you. Greet one another with a holy kiss."
,"21":"The greeting is from me, Paul, in my own hand."
,"22":"A curse on anyone who does not love the Lord! Maranatha! Come, Lord!"
,"23":"The grace of the Lord Jesus be with you."
,"24":"My love to all in Christ Jesus."
}`)

}
func EN_CCB_LoadNP1EChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"From Paul, Sylvanus and Timothy to the church of Thessalonica which is in God the Father and in Christ Jesus, the Lord. May the peace and grace of God be with you."
,"2":"We give thanks to God at all times for you and remember you in our prayers."
,"3":"We constantly recall before God our Father the work of your faith, the labors of your love and your endurance in waiting for Christ Jesus our Lord."
,"4":"We remember, brothers and sisters, the circumstances of your being called."
,"5":"The gospel we brought you was such not only in words. Miracles, Holy Spirit and plenty of everything were given to you. You also know how we dealt with you for your sake."
,"6":"In return, you became followers of us and of the Lord when, on receiving the word, you experienced the joy of the Holy Spirit in the midst of great opposition."
,"7":"And you became a model for the faithful of Macedonia and Achaia,"
,"8":"since from you the word of the Lord spread to Macedonia and Achaia, and still farther. The faith you have in God has become news in so many places that we need say no more about it."
,"9":"Others tell of how you responded to us and turned from idols to the Lord. For you serve the living and true God,"
,"10":"and you wait for his Son from Heaven whom he raised from the dead, Jesus, who frees us from impending trial."
}`)
	CurrentBook.AddChapter(2, `{
"1":"You well know, brothers and sisters, that our visit to you was not in vain."
,"2":"We had been ill-treated and insulted in Philippi but, trusting in our God, we dared announce to you the message of God, and face fresh opposition."
,"3":"Our warnings did not conceal any error or impure motive, nor did we deceive anyone."
,"4":"But as God had entrusted his Gospel to us as to faithful ministers, we were anxious to please God who sees the heart, rather than human beings."
,"5":"We never pleased you with flattery, as you know, nor did we try to earn money, as God knows."
,"6":"We did not try to make a name for ourselves among people, either with you or anybody else,"
,"7":"although we were messengers of Christ and could have made our weight felt. On the contrary, we were gentle with you, as a nursing mother who feeds and cuddles her baby. "
,"8":"And so great is our concern that we are ready to give you, as well as the Gospel, even our very lives, for you have become very dear to us."
,"9":"Remember our labor and toil; when we preached the Gospel, we worked day and night so as not to be a burden to you."
,"10":"You are witnesses with God that we were holy, just and blameless toward all of you who now believe."
,"11":"We warned each of you as a father warns his children;"
,"12":"we encouraged you and urged you to adopt a way of life worthy of God who calls you to share his own glory and kingdom."
,"13":"This is why we never cease giving thanks to God for, on receiving our message, you accepted it, not as human teaching, but as the word of God. That is what it really is, and as such it is at work in you who believe."
,"14":"Brothers and sisters, you followed the example of the churches of God in Judea, churches of Christ Jesus. For you suffered from your compatriots the same trials they suffered from the Jews,"
,"15":"who killed the Lord Jesus and the prophets, and who persecute us. They displease God and harm all people"
,"16":"when they prevent us from speaking to the pagans and trying to save them. By doing so they are heaping up their sins, but now Judgment is coming upon them."
,"17":"We are for a time deprived of your presence, but not in our heart, and we eagerly long to see you."
,"18":"For we have wanted to visit you, and I, Paul, more than once; but Satan prevented us."
,"19":"In fact, who but you are our hope and our joy? Who but you will be our glorious crown before Jesus, our Lord, when he returns?"
,"20":"Yes, indeed, you are our glory and our joy."
}`)
	CurrentBook.AddChapter(3, `{
"1":"As I could no longer bear it, I decided to go alone to Athens,"
,"2":"and send you Timothy, our brother and servant of God in the Gospel of Christ. I wanted him to encourage you in the faith and strengthen you "
,"3":"so that none of you might turn back because of the trials you are now enduring. You know that such is our destiny."
,"4":"I warned you of this when I was there: 'We shall have to face persecution'; and so it was, as you have seen."
,"5":"Therefore I could not stand it any longer and sent Timothy to appraise your faith and see if the Tempter had tempted you and made our work useless."
,"6":"But now Timothy has just returned with good news of your faith and love. He told us that you remember us kindly and that you long to see us as much as we long to see you."
,"7":"What a consolation for us, brothers and sisters, in the midst of our troubles and trials, this faith of yours!"
,"8":"It is a breath of life for us when you stand firm in the Lord."
,"9":"How can we thank God enough for all the joy that we feel before God because of you?"
,"10":"Day and night we beg of him to let us see you again, that we may complete the instruction of the believers."
,"11":"May God our Father and Jesus our Lord prepare the way for us to visit you."
,"12":"May the Lord increase more and more your love for each other and for all people, as he increases our love for you."
,"13":"May he strengthen you interiorly to be holy and blameless before God, our Father, on the day that Jesus, our Lord, will come with all his saints."
}`)
	CurrentBook.AddChapter(4, `{
"1":"For the rest, brothers, we ask you in the name of Jesus, the Lord, and we urge you to live in a way that pleases God, just as you have learned from us. This you do, but try to do still more."
,"2":"You know the instructions we gave you on behalf of the Lord Jesus:"
,"3":"the will of God for you is to become holy and not to have unlawful sex."
,"4":"Let each of you behave towards his wife as a holy and respectful husband,"
,"5":"rather than being led by lust, as are pagans who do not know God."
,"6":"In this matter, let no one offend or wrong a brother. The Lord will do justice in all these things, as we have warned and shown you."
,"7":"God has called us to live, not in impurity but in holiness,"
,"8":"and those who do not heed this instruction disobey, not a human, but God himself who gives you his Holy Spirit."
,"9":"Regarding mutual love, you do not need anyone to write to you, because God himself taught you how to love one another."
,"10":"You already practice it with all the brothers and sisters of Macedonia, but I invite you to do more."
,"11":"Consider how important it is to live quietly without bothering others, to mind your own business, and work with your hands, as we have charged you."
,"12":"In obeying these rules you will win the respect of outsiders and be dependent on no one."
,"13":"Brothers and sisters, we want you not to be mistaken about those who are already asleep, lest you grieve as do those who have no hope."
,"14":"We believe that Jesus died and rose; it will be the same for those who have died in Jesus. God will bring them together with Jesus and for his sake."
,"15":"By the same word of the Lord we assert this: those of us who are to be alive at the Lord's coming will not go ahead of those who are already asleep."
,"16":"When the command by the archangel's voice is given, the Lord himself will come down from heaven, while the divine trumpet call is sounding. Then those who have died in the Lord will rise first;"
,"17":"as for us who are still alive, we will be brought along with them in the clouds to meet the Lord in the celestial world. And we will be with the Lord forever."
,"18":"So, then comfort one another with these words."
}`)
	CurrentBook.AddChapter(5, `{
"1":"You do not need anyone to write to you about the delay and the appointed time for these events."
,"2":"You know that the Day of the Lord will come like a thief in the night."
,"3":"When people feel secure and at peace, the disaster will suddenly come upon them as the birth pangs of a woman in labor, and they will not escape."
,"4":"But you, beloved, are not in darkness; so that day will not surprise you like a thief."
,"5":"All of you are citizens of the light and the day; we do not belong to night and darkness."
,"6":"Let us not, therefore, sleep as others do, but remain alert and sober."
,"7":"Those who sleep, go to sleep at night, and those who drink, get drunk at night."
,"8":"Since we belong to the day, let us be sober, let us put on the breastplate of faith and love, and let the hope of salvation be our helmet."
,"9":"For God has not willed us to be condemned but to win salvation through Christ Jesus our Lord."
,"10":"He died for us so that we might enter into life with him, whether we are still awake or already asleep."
,"11":"Therefore encourage one another and build up one another, as you are doing now."
,"12":"Brothers and sisters, I want you to be thankful to those who labor among you, who lead you in the way of the Lord and also reprimand you."
,"13":"Esteem them highly and love them for what they are doing. Live at peace among yourselves."
,"14":"We urge you to warn the idle, encourage those who feel discouraged, sustain the weak, have patience with everyone."
,"15":"See that no one repays evil for evil, but try to do good, whether among yourselves or towards others."
,"16":"Rejoice always,"
,"17":"pray without ceasing"
,"18":"and give thanks to God at every moment. This is the will of God, your vocation as Christians."
,"19":"Do not quench the Spirit,"
,"20":"do not despise the prophets' warnings."
,"21":"Put everything to the test and hold fast to what is good."
,"22":"Avoid evil, wherever it may be."
,"23":"May the God of Peace make you holy and bring you to perfection. May you be completely blameless, in spirit, soul and body, till the coming of Christ Jesus, our Lord;"
,"24":"he who called you is faithful and will do it."
,"25":"Brothers and sisters, pray for us."
,"26":"Greet all the brothers and sisters with a holy kiss."
,"27":"I order you in the name of the Lord that this letter be read to all of them."
,"28":"May the grace of Christ Jesus our Lord be with you."
}`)

}
func EN_CCB_LoadNP1IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"From Paul, apostle of Christ Jesus by a command of God our Savior and of Christ Jesus our hope,"
,"2":"to Timothy, my true son in the faith. May God the Father and Christ Jesus our Lord give you grace, mercy and peace."
,"3":"When I left for Macedonia I urged you to remain in Ephesus to warn certain persons not to teach false doctrine"
,"4":"or to concern themselves with fables and endless genealogies. These give rise to discussions rather than promoting a better service of God through faith."
,"5":"The aim of our warning is love which comes from a pure mind, a good conscience and sincere faith."
,"6":"Some have turned away from such a motivation and have strayed into useless discussions."
,"7":"They claim to be teachers of the Law when, in fact, they understand neither what they say nor the things they speak about."
,"8":"We know that the Law is good, as long as it serves its purpose."
,"9":"The Law is not for the righteous, but for the lawless and for the wicked and sinful, for those who do not respect God and religion, for those who kill their parents, for murderers,"
,"10":"for those who indulge in unlawful sex and homosexuality, for kidnappers and exploiters, for liars and perjurers and for all that is contrary to sound doctrine,"
,"11":"to the Gospel of the God of glory and happiness, which was entrusted to me."
,"12":"I give thanks to Christ Jesus, our Lord, who is my strength, who has considered me trustworthy and appointed me to his service,"
,"13":"although I had been a blasphemer, a persecutor and a rabid enemy. However he took mercy on me because I did not know what I was doing when I opposed the faith;"
,"14":"and the grace of our Lord was more than abundant, together with faith and Christian love."
,"15":"This saying is true and worthy of belief: Christ Jesus came into the world to save sinners, of whom I am the first."
,"16":"Because of that I was forgiven; Christ Jesus wanted to display his greatness in me so that I might be an example for all who are to believe and obtain eternal life."
,"17":"To the King of ages, the only God who lives beyond every perishable and visible creation - to him be honor and glory forever. Amen!"
,"18":"Timothy, my son, I command you to fight the good fight, fulfilling the prophetic words pronounced over you."
,"19":"Hold onto faith and a good conscience, unlike those who, ignoring conscience, have finally wrecked their faith."
,"20":"Among them are Hymeneus and Alexander whom I have delivered to Satan to be taught not to blaspheme."
}`)
	CurrentBook.AddChapter(2, `{
"1":"First of all I urge that petitions, prayers, intercessions and thanksgiving be made for everyone,"
,"2":"for rulers of states and all in authority, that we may enjoy a quiet and peaceful life in godliness and respect."
,"3":"This is good and pleases God."
,"4":"For he wants all to be saved and come to the knowledge of truth."
,"5":"As there is one God, there is one mediator between God and humankind, Christ Jesus, himself human,"
,"6":"who gave his life for the redemption of all. This is the testimony, given in its proper time,"
,"7":"and of this, God has made me apostle and herald. I am not lying, I am telling the truth: He made me teacher of the nations regarding faith and truth."
,"8":"I want the men in every place to lift pure hands in prayer to heaven without anger and dissension."
,"9":"Let women dress with simplicity and modesty, not adorned with fancy hairstyles, gold, jewels and expensive clothes,"
,"10":"but with good works, as is fitting for women serving God."
,"11":"Let a woman quietly receive instruction and be submissive."
,"12":"I allow no woman to teach or to have authority over men. Let them be quiet."
,"13":"For Adam was created first and then Eve."
,"14":"Adam was not deceived; it was the woman who was deceived and fell into sin."
,"15":"But she will be saved through motherhood, provided that her life be orderly and holy, in faith and love."
}`)
	CurrentBook.AddChapter(3, `{
"1":"If someone aspires to the over seer's ministry, he is without a doubt looking for a noble task."
,"2":"It is necessary that the overseer (or bishop) be beyond reproach, the husband of one wife, responsible, judicious, of good manners, hospitable and skillful in teaching."
,"3":"He must not be addicted to wine or quarrelsome, but gentle and peaceful, and not a lover of money,"
,"4":"but a man whose household is well-managed, with obedient and well-mannered children."
,"5":"If he cannot govern his own house, how can he lead the assembly of God?"
,"6":"He must not be a recent convert, lest he become conceited and fall into the same condemnation as the devil."
,"7":"Moreover he must enjoy a good reputation among the outsiders, lest people speak evil about him and he fall into the snare of the devil."
,"8":"Deacons, likewise, must be serious and sincere and moderate in drinking wine, not greedy for money,"
,"9":"they must keep the mystery of faith with a clear conscience."
,"10":"Let them be first tried and, if found blameless, be accepted as deacons."
,"11":"In the same way the women must be conscientious, not given to gossip, but reserved and trustworthy."
,"12":"A deacon must be husband of one wife, and must know how to guide his children and manage his household."
,"13":"Those who serve well as deacons will win honorable rank, with authority to speak of Christian faith."
,"14":"I give you these instructions, although I hope I will see you soon."
,"15":"If I delay, you will know how you ought to conduct yourself in the household of God, that is, the Church of the living God, which is the pillar and foundation of the truth."
,"16":"How great indeed is the mystery of divine blessing!,He was shown in the flesh,and sanctified by the Spirit; presented to the angels,and proclaimed to all nations. The world believed in him: He was taken up in glory!"
}`)
	CurrentBook.AddChapter(4, `{
"1":"The Spirit tells us clearly that in the last days some will defect from the faith and follow deceitful spirits and devilish doctrines,"
,"2":"led by lying hypocrites whose conscience has been branded with the stamp of infamy."
,"3":"These persons forbid marriage and condemn the use of certain foods which God created for those who know the truth, and which the believers receive with thanksgiving."
,"4":"Everything created by God is good, and all food is lawful; nothing is to be rejected if we receive it with thanksgiving,"
,"5":"for it is blessed with the word of God and prayer, and made holy."
,"6":"If you explain these things to the brothers and sisters, you will prove to be a good servant of Christ Jesus, nourished by the teachings of faith and the sound doctrine which you have followed."
,"7":"Reject irreligious fables and old wives' tales. Train yourself in godliness."
,"8":"Physical training is of limited value; godliness, instead, is useful in every way, holding promise for the present life and for the life to come."
,"9":"Here you have a sure doctrine you can trust."
,"10":"We toil and endure because we trust in the living God, the Savior of all, especially of those who believe."
,"11":"Command and teach these things."
,"12":"Let no one reproach you on account of your youth. Be a model to the believers in the way you speak and act, in your love, your faith and purity of life."
,"13":"Devote yourself to reading, preaching and teaching, until I come."
,"14":"Do not neglect the spiritual gift conferred on you with prophetic words when the elders laid their hands upon you."
,"15":"Think about it and practice it so that your progress may be seen by all."
,"16":"Take care of yourself and attend to your teaching. Be steadfast in doing this and you will save both yourself and your hearers."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Do not rebuke an older man; on the contrary, advise him as if he were your father. Treat the young as your brothers,"
,"2":"the elder women as mothers and the young girls as your sisters, with great purity."
,"3":"Take care of widows who are really widows."
,"4":"If a widow has children or grandchildren, they should first learn their family duties and give their parents financial help. This is correct and pleases God."
,"5":"A true widow is one who, in being left alone, has set her hope in God, praying day and night to God and asking him for help."
,"6":"On the contrary, a widow who lives as she pleases is dead even while she lives."
,"7":"Warn them about this that they may be blameless."
,"8":"Those who do not take care of their own, especially those of their household, have denied the faith and are worse than unbelievers."
,"9":"Let no one be put on the list of widows unless she is sixty years old and has been married only once."
,"10":"She must be commended for her good works and the education of her children. Has she offered hospitality to and humbly served the saints, helped the suffering and practiced other good deeds?"
,"11":"Do not accept younger widows; they may have other desires than for Christ and want to marry;"
,"12":"then they deserve condemnation for breaking their first commitment."
,"13":"Besides they form the habit of being idle, going from house to house. And it is not just idleness! They become gossips and busybodies, saying what they should not."
,"14":"So I want young widows to marry and have children, to rule their household and give adversaries no grounds for criticism."
,"15":"Some have already strayed to follow Satan."
,"16":"If any Christian woman has widows in her family, let her assist them; in this way the church will not be burdened and may assist those who are truly widows."
,"17":"Let the elders who rule well receive double compensation, especially those who labor in preaching and teaching."
,"18":"Scripture says: Do not muzzle the ox while it threshes grain, and: The worker deserves his wages."
,"19":"Do not accept accusations against an elder except on the evidence of two or three witnesses."
,"20":"If he continues to sin, rebuke him in the presence of the community, as a warning to the rest."
,"21":"I urge you, in the presence of God and Christ Jesus and of the holy angels, to obey these rules with impartiality, without making distinctions."
,"22":"Do not be hasty in the laying on of hands, thus becoming an accomplice in the sins of others. Keep yourself free from blame."
,"24":"The sins of some people are plain to see, even before they are examined; the sins of others are known only later on."
,"25":"Likewise good deeds are conspicuous; even when they are not, they cannot remain hidden."
,"23":"Do not drink only water but take a little wine to help your digestion, because of your frequent illness."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Let those who are slaves always show respect to their masters, so that no one may speak ill of God and his teaching."
,"2":"Those whose masters are Christians should not show less respect under the pretext that they are members of the church. On the contrary, they must give a better service since they are doing good works on behalf of believers and dear friends. Teach and stress these things. "
,"3":"Whoever teaches in some other way, not following the sound teaching of our Lord Christ Jesus and true religious instruction,"
,"4":"is conceited and understands nothing. This one is crazy about controversies and discussions which result in envy, insults,"
,"5":"blows and constant arguments between people of depraved minds and far from the truth. For them, religion is merely for financial gain."
,"6":"In reality, religion is a treasure if we are content with what we have."
,"7":"We brought nothing into the world and we will leave it with nothing."
,"8":"Let us then be content with having food and clothing."
,"9":"Those who strive to be rich fall into temptations and traps. A lot of foolish and harmful ambitions plunge them into ruin and destruction."
,"10":"Indeed, the love of money is the root of every evil. Because of this greed, some have wandered away from the faith, bringing on themselves afflictions of every kind."
,"11":"But you, man of God, shun all this. Strive to be holy and godly. Live in faith and love, with endurance and gentleness."
,"12":"Fight the good fight of faith and win everlasting life to which you were called when you made the good profession of faith in the presence of so many witnesses."
,"13":"Now, in the presence of God who gives life to all things, and of Christ Jesus who gave the good testimony before Pontius Pilate,"
,"14":"I command you to keep the commandment. Keep yourself pure and blameless until the glorious coming of Christ Jesus, our Lord,"
,"15":"which God will bring about at the proper time, he, the magnificent sovereign, King of kings and Lord of lords."
,"16":"To him, alone immortal, who lives in unapproachable light and whom no one has ever seen or can see, to him be honor and power for ever and ever. Amen!"
,"17":"Command the rich of this world not to be arrogant or to put their trust in the uncertainty of wealth. Let them rather trust in God who generously gives us all we need for our happiness."
,"18":"Let them do good, be rich in,good deeds and be generous; let them share with others. "
,"19":"In this way, they shall heap up a sound capital for the future and gain true life."
,"20":"Timothy, guard what has been entrusted to you; avoid useless and profane words, as well as discussions arising from false knowledge."
,"21":"Some have lost the faith in accepting such knowledge. The grace of God be with you all."
}`)

}
func EN_CCB_LoadNP2CChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paul, an apostle of Christ Jesus by the will of God, and Timothy, our brother, to the church of God in Corinth, and to all the saints in the whole of Achaia."
,"2":"May you receive grace and peace from God our Father and from Christ Jesus, the Lord."
,"3":"Blessed be God, the Father of Christ Jesus, our Lord, the all-merciful Father and the God of all comfort!"
,"4":"He encourages us in all our trials, so that we may also encourage those in any trial, with the same comfort that we receive from God."
,"5":"For whenever the sufferings of Christ overflow to us, so, through Christ, a great comfort also overflows."
,"6":"So, if we are afflicted, it is for your comfort and salvation; and if we receive comfort it is also for you. You may experience the same comfort when you come to endure the same sufferings we endure."
,"7":"Our hope for you is most firm; just as you share in our sufferings, so shall you also share in our consolation."
,"8":"Brothers and sisters, we want you to know some of the trials we experienced in the province of Asia. We were crushed; it was too much; it was more than we could bear and we had already lost all hope of coming through alive."
,"9":"We felt branded for death, but this happened that we might no longer rely on ourselves but on God, who raises the dead."
,"10":"He freed us from such a deadly peril and will continue to do so. We trust he will continue protecting us,"
,"11":"but you must help us with your prayers. When such a favor is obtained by the intercession of many, so will there be many to give thanks to God on our behalf."
,"12":"There is something we are proud of: our conscience tells us that we have lived in this world with the openness and sincerity that comes from God. We have been guided, not by human motives, but by the grace of God, especially in relation to you."
,"13":"There were no hidden intentions in my letter, but only what you can read and understand."
,"14":"I trust that what you now only partly realize, you will come to understand fully, and so be proud of us, as we shall also be proud of you on the Day of the Lord Jesus."
,"15":"With this assurance, I wanted to go and visit you first, and this would have been a double blessing for you."
,"16":"And from there I thought of going to Macedonia and then, from Macedonia, of coming back to you, that you might send me on my way to Judea."
,"17":"Have I planned this without thinking at all? Or do I change my decisions on the spur of the moment, so that I am between No and Yes?"
,"18":"God knows that our dealing with you is not Yes and No,"
,"19":"just as the Son of God, Christ Jesus, whom we - Silvanus, Timothy and I - preach to you, was not Yes and No; with him it was simply Yes."
,"20":"In him all the promises of God have come to be a Yes, and we also say in his name: Amen! giving thanks to God."
,"21":"God himself has anointed us and strengthens us with you to serve Christ;"
,"22":"he has marked us with his own seal in a first outpouring of the Spirit in our hearts."
,"23":"God knows, and I swear to you by my own life, that if I did not return to Corinth, it was because I wanted to spare you."
,"24":"I do not wish to lord it over your faith, but to contribute to your happiness; for regarding faith, you already stand firm."
}`)
	CurrentBook.AddChapter(2, `{
"1":"So I gave up a visit that would again be a distressing one."
,"2":"If I make you sad, who will make me happy if not you whom I have grieved?"
,"3":"Remember what I wrote you, 'May it be that when I come I do not feel sad because of you, who should rather make me happy.' I trust in everyone and I am sure that my joy will be the joy of you all."
,"4":"So afflicted and worried was I when I wrote to you, that I even shed tears. I did not intend to cause you pain, but rather to let you know of the immense love that I have for you."
,"5":"If anyone has caused me pain, he has hurt not me but in some measure, (I do not wish to exaggerate) all of you."
,"6":"The punishment that he received from the majority is enough for him."
,"7":"Now you should rather forgive and comfort him, lest excessive sorrow discourage him."
,"8":"So I beg you to treat him with love."
,"9":"This is why I wrote to you, to test you and to know if you would obey in everything."
,"10":"The one you forgive, I also forgive. And what I forgave, if indeed I had anything to forgive, I forgave for your sake in the presence of Christ,"
,"11":"lest Satan take advantage of us; for we know his designs."
,"12":"So I came to Troas to preach the Gospel of Christ, and the Lord opened doors for me."
,"13":"However I could not be at peace because I did not find my brother Titus there, so I took leave of them and went to Macedonia."
,"14":"Thanks be to God, who always leads us in the triumphant following of Christ and, through us, spreads the knowledge of him everywhere, like an aroma."
,"15":"We are Christ's fragrance rising up to God, and perceived by those who are saved as well as by those who are lost."
,"16":"To the latter, it smells of death and leads them to death. To others it is the fragrance of life and leads to life."
,"17":"But who is worthy of such a mission? Unlike so many who make money out of the word of God, we speak with sincerity: everything comes from God and is said in his presence, in Christ."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Am I again commending myself? Or do I need to present to you letters of recommendation as some do; or should I ask you for those letters?"
,"2":"You are the letter. This letter is written in your inner self, yet all can read and understand it."
,"3":"Yes, who could deny that you are Christ's letter written by us - a letter written not with ink but with the Spirit of the living God, carved not in slabs of stones, but in hearts of flesh."
,"4":"This is how we are sure of God, through Christ."
,"5":"As for us we would not dare consider that something comes from us: our ability comes from God."
,"6":"He has even enabled us to be ministers of a new covenant no longer depending on a written text but on the Spirit. The written text kills, but the Spirit gives life."
,"7":"The ministry of the Law carved on stones brought death; it was nevertheless surrounded by glory and we know that the Israelites could not fix their eyes on the face of Moses, such was his radiance, though fleeting."
,"8":"How much more glorious will the ministry of the Spirit be!"
,"9":"If there is greatness in a ministry which uses to condemn, how much more will there be in the ministry that brings holiness?"
,"10":"This is such a glorious thing that in comparison the former's glory is like nothing."
,"11":"That ministry was provisory and had only moments of glory; but ours endures with a lasting glory."
,"12":"Since we have such a great ambition, we are quite confident -"
,"13":"unlike Moses, who covered his face with a veil. Otherwise the Israelites would have seen his passing radiance fade."
,"14":"They became blind, however; until this day, the same veil prevents them from understanding the Old Covenant and they do not realize that in Christ it is nullified."
,"15":"Up to this very day, whenever they read Moses, the veil remains over their understanding"
,"16":"but, for whoever turns to the Lord, the veil shall be removed."
,"17":"The Lord is spirit, and where the Spirit of the Lord is, there is freedom."
,"18":"So, with unveiled faces, we all reflect the Glory of the Lord, while we are transformed into his likeness and experience his Glory more and more by the action of the Lord who is spirit."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Since this is our ministry mercifully given to us, we do not weaken."
,"2":"We refuse to stay with half-truths through fear; we do not behave with cunning or falsify the message of God but, manifesting the truth, we deserve the respect of everyone before God."
,"3":"In fact if the Gospel we proclaim remains obscure, it is obscure only for those who go to their own destruction."
,"4":"The god of this world has blinded the minds of these unbelievers lest they see the radiance of the glorious Gospel of Christ, who is God's image."
,"5":"It is not ourselves we preach, but Christ Jesus as Lord; and for Jesus' sake we are your servants."
,"6":"God who said, Let the light shine out of darkness, has also made the light shine in our hearts to radiate and to make known the Glory of God, as it shines in the face of Christ."
,"7":"However, we carry this treasure in vessels of clay, so that this all-surpassing power may not be seen as ours but as God's."
,"8":"Trials of every sort come to us, but we are not discouraged."
,"9":"We are left without answer, but do not despair; persecuted but not abandoned, knocked down but not crushed."
,"10":"At any moment we carry in our person the death of Jesus, so that the life of Jesus may also be manifested in us."
,"11":"For we, the living, are given up continually to death for the sake of Jesus, so that the life of Jesus may appear in our mortal existence."
,"12":"And as death is at work in us, life comes to you."
,"13":"We have received the same spirit of faith referred to in Scripture that says: I believed and so I spoke. We also believe and so we speak."
,"14":"We know that He who raised the Lord Jesus will also raise us with Jesus and bring us, with you, into his presence."
,"15":"Finally, everything is for your good, so that grace will come more abundantly upon you and great will be the thanksgiving for the glory of God."
,"16":"Therefore we are not discouraged. On the contrary, while our outer being wastes away, the inner self is renewed from day to day."
,"17":"The slight affliction which quickly passes away prepares us for an eternal wealth of glory so great and beyond all comparison."
,"18":"So we no longer pay attention to the things that are seen, but to those that are unseen, for the things that we see last for a moment, but that which cannot be seen is eternal."
}`)
	CurrentBook.AddChapter(5, `{
"1":"We know that when our earthly dwelling, or rather our tent, is destroyed, we may count on a building from God, a heavenly dwelling not built by human hands, that lasts forever."
,"2":"Therefore we long and groan: Why may we not put on this heavenly dwelling over that which we have?"
,"3":"(Indeed, are we sure that we shall still be wearing our earthly dwelling and not be unclothed?)"
,"4":"As long as we are in the field-tent, we indeed moan our unbearable fate for we do not want this clothing to be removed from us; we would rather put the other over it, that the mortal body may be absorbed by true life."
,"5":"This is God's purpose for us, and he has given us the Spirit as a pledge of what we are to receive."
,"6":"So we feel confident always. We know that while living in the body, we wander away from the Lord,"
,"7":"living by faith, without seeing;"
,"8":"but we dare to think that we would rather be away from the body to go and live with the Lord."
,"9":"So, whether we have to keep this house or lose it, we only wish to please the Lord."
,"10":"Anyway we all have to appear before the tribunal of Christ for each one to receive what he deserves for his good or evil deeds in the present life."
,"11":"So we know the fear of the Lord and we try to convince people while we live openly before God. And I trust that you know in your conscience what we truly are."
,"12":"Once more, we do not try to win your esteem; we want to give you a reason to feel proud of us, that you may respond to those who heed appearances and not the reality."
,"13":"Now, if I have spoken foolishly, let God alone hear; if what I have said makes sense, take it for yourselves."
,"14":"Indeed the love of Christ holds us and we realize that if he died for all, all have died."
,"15":"He died for all so that those who live may live no longer for themselves, but for him who died and rose again for them."
,"16":"And so from now on, we do not regard anyone from a human point of view; and even if we once knew Christ personally, we should now regard him in another way."
,"17":"For that same reason, the one who is in Christ is a new creature. For him the old things have passed away; a new world has come."
,"18":"All this is the work of God who in Christ reconciled us to himself, and who entrusted to us the ministry of reconciliation."
,"19":"Because in Christ God reconciled the world with himself, no longer taking into account their trespasses and entrusting to us the message of reconciliation."
,"20":"So we present ourselves as ambassadors in the name of Christ, as if God himself makes an appeal to you through us. Let God reconcile you; this we ask you in the name of Christ."
,"21":"He had no sin, but God made him bear our sin, so that in him we might share the holiness of God."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Being God's helpers we beg you: let it not be in vain that you received this grace of God."
,"2":"Scripture says: At the favorable time I listened to you, on the day of salvation I helped you. This is the favorable time, this is the day of salvation."
,"3":"We are concerned not to give anyone an occasion to stumble or criticize our mission."
,"4":"Instead we prove we are true ministers of God in every way by our endurance in so many trials, in hardships, afflictions,"
,"5":"floggings, imprisonment, riots, fatigue, sleepless nights and days of hunger."
,"6":"People can notice in our upright life, knowledge, patience and kindness, action of the Holy Spirit, sincere love,"
,"7":"words of truth and power of God. So we fight with the weapons of justice, to attack as well as to defend."
,"8":"Sometimes we are honored, at other times insulted; we receive criticism as well as praise. We are regarded as liars although we speak the truth;"
,"9":"as unknown though we are well known; as dead and yet we live. Punishments come upon us but we have not, as yet, been put to death."
,"10":"We appear to be afflicted, yet always joyful; we seem to be poor, but we enrich many; we have nothing, but we possess everything!"
,"11":"Corinthians! I have spoken to you frankly and I have uncovered my inner thought."
,"12":"My heart is wide open to you, but you feel uneasy because of your closed heart:"
,"13":"repay us with the same measure - I speak to you as to my children - open your hearts wide also."
,"14":"Do not make unsuitable covenants with those who do not believe: can justice walk with wickedness? Or can light coexist with darkness,"
,"15":"and can there be harmony between Christ and Satan? What union can there be between one who believes and one who does not believe?"
,"16":"God's temple must have no room for idols, and we are the temple of the living God. As Scripture says; I will dwell and live in their midst, I will be their God and they shall be my people."
,"17":"Therefore: Come out from their midst and separate from them, says the Lord. Do not touch anything unclean"
,"18":"and I will be gracious to you. I will be a father to you, that you may become my sons and daughters, says the all-powerful God."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Since we have such promises, dear friends, let us purify ourselves from all defilement of body and spirit, and complete the work of sanctification in the fear of God."
,"2":"Welcome us in your hearts. We have injured no one, we have harmed no one, we have cheated no one."
,"3":"I do not say this to condemn you: I have just said that you are in our heart to live together and die as one."
,"4":"I have great confidence in you and I am indeed proud of you. I feel very much encouraged and my joy overflows in spite of all this bitterness."
,"5":"Know that when I came to Macedonia, I had no rest at all but I was afflicted with all kinds of difficulties: conflict outside and fear within."
,"6":"But God who encourages the humble gave me comfort with the arrival of Titus,"
,"7":"not only because of his arrival, but also because you had received him very well. He told me about your deep affection for me; you were affected by what happened, you worried about me, and this made me rejoice all the more."
,"8":"If my letter caused you pain, I do not regret it. Perhaps I did regret it, for I saw that the letter caused you sadness for a moment but now I rejoice,"
,"9":"not because of your sadness, but because this sadness brought you to repentance. This was a sadness from God, so that no evil came to you because of me."
,"10":"Sadness from God brings firm repentance that leads to salvation and brings no regret, but worldly grief produces death."
,"11":"See what this sadness from God has produced in you: What concern for me! What apologies! What indignation and fear! What a longing to see me, to make amends and do me justice!,You have fully proved that you were innocent in this matter. "
,"12":"In reality, I wrote to you not on account of the offender or of the offended, but that you may be conscious of the concern you have for me before God."
,"13":"I was encouraged by this. In addition to this consolation of mine, I rejoice especially to see Titus very pleased with the way you all reassured him. "
,"14":"I had no cause to regret my praise of you to him. You know that I am always sincere with you; likewise my praise of you to Titus has been justified."
,"15":"He now feels much more affection for you as he remembers the obedience of all and the respect and humility with which you received him."
,"16":"Really I rejoice for I can be truly proud of you."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Now I want you to know about a gift of divine grace among the Churches of Macedonia."
,"2":"While they were so afflicted and persecuted, their joy overflowed and their extreme poverty turned into a wealth of generosity."
,"3":"According to their means - even beyond their means - they wanted to share in helping the saints."
,"4":"They asked us for this favor spontaneously and with much insistence"
,"5":"and, far beyond anything we expected, they put themselves at the disposal of the Lord and of us by the will of God."
,"6":"Accordingly, I urged Titus to complete among you this work of grace since he began it with you."
,"7":"You excel in everything: in the gifts of faith, speech and knowledge; you feel concern for every cause and, besides, you are first in my heart. Excel also in this generous service."
,"8":"This is not a command; I make known to you the determination of others to check the sincerity of your fraternal concern."
,"9":"You know well the generosity of Christ Jesus, our Lord. Although he was rich, he made himself poor to make you rich through his poverty."
,"10":"I only make a suggestion, because you were the first not only in cooperating, but in beginning this project a year ago."
,"11":"So complete this work and, according to your means, carry out what you decided with much enthusiasm."
,"12":"When there is a good disposition, everything you give is welcomed and no one longs for what you do not have."
,"13":"I do not mean that others should be at ease and you burdened. Strive for equality;"
,"14":"at present give from your abundance what they are short of, and in some way they also will give from their abundance what you lack. Then you will be equal"
,"15":"and what Scripture says shall come true: To the one who had much, nothing was in excess; to the one who had little, nothing was lacking."
,"16":"Blessed be God who inspires Titus with such care for you!"
,"17":"He not only listened to my appeal but he wanted to go and see you on his own initiative."
,"18":"I am sending with him the brother who has gained the esteem of the churches in the work of the Gospel;"
,"19":"moreover they appointed him to travel with us in this blessed work we are carrying on for the glory of the Lord but also because of our personal enthusiasm."
,"20":"We decided on this so that no one could suspect us with regard to this generous fund that we are administering."
,"21":"Let us see to it that all may appear clean not only before God but also before people."
,"22":"We also send with them another brother who on several occasions has shown us his zeal and, now, is more enthusiastic because of his confidence in you."
,"23":"You then have Titus, our companion and minister, to serve you and, with him, you have our brothers, representatives of the churches and a glory to Christ."
,"24":"Show them how you love, and prove before the churches all the good things I said to them about you."
}`)
	CurrentBook.AddChapter(9, `{
"1":"It is not necessary for me to write to you about assistance to the saints."
,"2":"I know your readiness and I praised you before the Macedonians. I said, 'In Achaia they have been ready for the collection since last year.' And your enthusiasm carried most of them along."
,"3":"So I send you these brothers of ours. May all my praise of you not fall flat in this case! May you be ready, as I said."
,"4":"If some Macedonians come with me, let them not find you unprepared. What a shame for me - and perhaps for you - after so much confidence!"
,"5":"So I thought it necessary to ask our brothers to go ahead of us and see you to organize this blessed work you have promised. It shall come from your generosity and not be an imposed task."
,"6":"Remember: the one who sows meagerly will reap meagerly, and there shall be generous harvests for the one who sows generously."
,"7":"Each of you should give as you decided personally, and not reluctantly as if obliged. God loves a cheerful giver."
,"8":"And God is able to fill you with every good thing, so that you have enough of everything at all times, and may give abundantly for any good work."
,"9":"Scripture says: He distributed, he gave to the poor, his good works last forever."
,"10":"God who provides the sower with seed will also provide him with the bread he eats. He will multiply the seed for you and also increase the interests of your good works."
,"11":"Become rich in every way, and give abundantly. What you give will become, through us, a thanksgiving to God."
,"12":"For this sacred relief, after providing the saints with what they need, will result in much thanksgiving to God."
,"13":"This will be a test for them; they will give thanks because you obey the requirements of Christ's Gospel and share generously with them and with all."
,"14":"They shall pray to God for you and feel affection for you because the grace of God overflows in you."
,"15":"Yes, thanks be to God for his indescribable gift!"
}`)
	CurrentBook.AddChapter(10, `{
"1":"It is I, Paul, who by the humility and kindness of Christ appeal to you, the Paul 'who is timid among you and bold when far away from you!'"
,"2":"Do not force me to act boldly when I come, as I am determined and will dare to act against some people who think that I act from human motives."
,"3":"Human is our condition but not our fight."
,"4":"Our weapons for this fight are not human but they have divine power to destroy strongholds - those arguments"
,"5":"and haughty thoughts which oppose the knowledge of God. They disarm the conceited minds, that they obey Christ."
,"6":"So I am prepared to punish any disobedience when you should show perfect obedience."
,"7":"See things as they really are. If someone is convinced that he belongs to Christ, let him consider that just as he is Christ's, so am I."
,"8":"Although I may seem too confident in the authority that the Lord gave me for building you up and not for pulling you down, I will not be put to shame for saying this."
,"9":"Do not think that I can only frighten you with letters."
,"10":"'His letters are severe and strong,' some say, 'but as he is, he has no presence and he is a poor speaker.'"
,"11":"To such people I say, 'Be careful: what my letters say from afar, is what I will do when I come.'"
,"12":"How could I venture to equate or compare myself with some people who proclaim their own merits? Fools! They measure themselves with their own measure and compare themselves with themselves."
,"13":"As for me, I will not boast beyond measure, for I will not go past the limits that the God of true measure has set for me: He gave the measuring stick when he made me set foot in your place."
,"14":"It is not the same when someone goes beyond his field to where he has not been able to set foot. But I am he who first reached you with the Gospel of Christ."
,"15":"I am not making myself important where others have worked. On the contrary, we hope that as your faith increases, so too our area of ministry among you will be enlarged without going beyond our limit."
,"16":"So we shall bring the Gospel to places beyond yours without entering into the field of others, or boasting and making ourselves important where the work is already done."
,"17":"Let the one who boasts, boast in the Lord."
,"18":"It is not the one who commends himself who is approved, but the one whom the Lord commends."
}`)
	CurrentBook.AddChapter(11, `{
"1":"May you bear with me in some little foolishness! But surely you will."
,"2":"I confess that I share the jealousy of God for you, for I have promised you in marriage to Christ, the only spouse, to present you to him as a pure virgin."
,"3":"And this is my fear: the serpent that seduced Eve with cunning could also corrupt your minds and divert you from the christian sincerity."
,"4":"Someone now comes and preaches another Jesus different from the one we preach, or you are offered a different spirit from the one you have received, with a different Gospel from the one you have accepted - and you agree!"
,"5":"I do not see how I am inferior to those super-apostles."
,"6":"Does my speaking leave much to be desired? Perhaps, but not my knowledge, as I have abundantly shown to you in every way."
,"7":"Perhaps my sin was that I humbled myself in order to uplift you, or that I gave you the Gospel free of charge."
,"8":"I called upon the services of other churches and served you with the support I received from them."
,"9":"When I was with you, although I was in need, I did not become a burden to anyone. The friends from Macedonia gave me what I needed. I have taken care not to be a burden to you in anything and I will continue to do so."
,"10":"By the truth of Christ within me, I will let no one in the land of Achaia stop this boasting of mine."
,"11":"Why? Because I do not love you? God knows that I do!"
,"12":"Yet I do and I will continue to do so to silence any people anxious to appear as equal to me: this is my glory."
,"13":"In reality, they are false apostles, deceivers disguised as apostles of Christ."
,"14":"It is not surprising: if Satan disguises himself as an angel of light,"
,"15":"his servants can easily disguise themselves as ministers of salvation, until they receive what their deeds deserve."
,"16":"I say again: Do not take me for a fool, but if you do take me as such, bear with me that I may sing my own praises a little."
,"17":"I will not speak in the language of Christ, but in that of a fool, bringing my own merits to prominence."
,"18":"As some people boast of human advantages, I will do the same."
,"19":"Fortunately you bear rather well with fools, you who are so wise!"
,"20":"You tolerate being enslaved, and exploited, robbed, treated with contempt and slapped in the face."
,"21":"What a shame that I acted so weakly with you!,But if others are so bold, I shall also dare, although I may speak like a fool. "
,"22":"Are they Hebrews? So am I. Are they Israelites? So am I. Are they descendants of Abraham? So am I."
,"23":"Are they ministers of Christ? (I begin to talk like a madman) I am better than they. Better than they with my numerous labors. Better than they with the time spent in prison. The beatings I received are beyond comparison. How many times have I found myself in danger of death! "
,"24":"Five times the Jews sentenced me to thirty-nine lashes."
,"25":"Three times I was beaten with a rod, once I was stoned. Three times I was shipwrecked, and once I spent a night and a day adrift on the high seas."
,"26":"I have been continually in hazards of traveling because of rivers, because of bandits, because of my fellow Jews, or because of the pagans; in danger in the city, in the open country, at sea; in danger from false brothers."
,"27":"I have worked and often labored without sleep, I have been hungry and thirsty and starving, cold and without shelter."
,"28":"Besides these and other things, there was my daily concern for all the churches."
,"29":"Whoever wavers, do I not waver with him? Whoever stumbles, am I not on hot bricks?"
,"30":"If it is necessary to boast, let me proclaim the occasions on which I was found weak."
,"31":"The God and Father of Jesus the Lord - may he be blessed for ever! - knows that I speak the truth."
,"32":"At Damascus, the governor under King Aretas placed the city under guard in order to arrest me,"
,"33":"and I had to be let down in a basket through a window in the wall. In that way I slipped through his hands."
}`)
	CurrentBook.AddChapter(12, `{
"1":"It is useless to boast; but if I have to, I will go on to some visions and revelations of the Lord."
,"2":"I know a certain Christian: fourteen years ago he was taken up to the third heaven."
,"3":"Whether in the body or out of the body, I do not know, God knows. But I know that this man, whether in the body or out of the body - I do not know, God knows -"
,"4":"was taken up to Paradise where he heard words that cannot be told: things which humans cannot express."
,"5":"Of that man I can indeed boast, but of myself I will not boast except of my weaknesses."
,"6":"If I wanted to boast, it would not be foolish of me, for I would speak the truth."
,"7":"However, I better give up lest somebody think more of me than what is seen in me or heard from me. Lest I become proud after so many and extraordinary revelations, I was given a thorn in my flesh, a true messenger of Satan, to slap me in the face."
,"8":"Three times I prayed to the Lord that it leave me,"
,"9":"but he answered, 'My grace is enough for you; my great strength is revealed in weakness.',Gladly, then, will I boast of my weakness that the strength of Christ may be mine. "
,"10":"So I rejoice when I suffer infirmities, humiliations, want, persecutions: all for Christ! For when I am weak, then I am strong."
,"11":"I have acted as a fool but you forced me. You should have been the ones commending me. Yet I do not feel outdone by those super-apostles,"
,"12":"even though I am nothing. All the signs of a true apostle are found in me: patience in all trials, signs, miracles and wonders."
,"13":"Now, in what way were you not treated like the rest of the churches? Only in this: I was not a burden to you - forgive me for this offense!"
,"14":"For the third time I plan to visit you, and I will not be a burden to you, for I am not interested in what you have but only in you. Children should not have to collect money for their parents, but the parents for their children."
,"15":"As for me, I am ready to spend whatever I have and even my whole self for all of you. If I love you so much, am I to be loved less?"
,"16":"Well, I was not a burden to you, but was it not a trick to deceive you? Tell me:"
,"17":"Did I take money from you through any of my messengers?"
,"18":"I asked Titus to go to you and I sent another brother with him. But did Titus take money from you? Have we not both acted in the same spirit?"
,"19":"Perhaps you think that we are again apologizing; but no: we speak in Christ and before God, and I do this for you, dear friends, to build you up."
,"20":"I fear that if I go and see you, I might not find you as I would wish, and you in turn, might not find me to your liking. I might see rivalries, envy, grudges, disputes, slanders, gossip, conceit, disorder."
,"21":"Let it not be that in coming again to you, God humble me because of you and I have to grieve over so many of you who live in sin, on seeing that they have not yet given up an impure way of living, their wicked conduct and the vices they formerly practiced."
}`)
	CurrentBook.AddChapter(13, `{
"1":"This will be my third visit to you. Any charge must be decided upon by the declaration of two or three witnesses."
,"2":"I have said and I say again, being still far away, just as I did on my second visit I say to you who lived in sin as well as to the rest: when I return to you, I will not have pity."
,"3":"You want to know if Christ is speaking through me? So you will. He is not used to dealing weakly with you, but rather he acts with power."
,"4":"If he was crucified in his weakness, now he lives by the strength of God; and so we are weak with him, but we will be well alive with him, because God acts powerfully with you."
,"5":"Examine yourselves: are you acting according to faith? Test yourselves. Can you assert that Christ Jesus is in you?"
,"6":"If not, you have failed the test. I hope you recognize that we ourselves have not failed it."
,"7":"We pray God that you may do no wrong, not that we wish to be acknowledged but we want you to do right, even if in this we appear to have failed."
,"8":"For we do not have power against the truth, but only for the truth."
,"9":"We rejoice if we are weak while you are strong, for all we hope is that you become perfect."
,"10":"This is why I am writing now, so that when I come I may not have to act strictly and make use of the authority the Lord has given me for building up and not for destroying."
,"11":"Finally, brothers and sisters, be happy, strive to be perfect, have courage, be of one mind and live in peace. And the God of love and peace will be with you."
,"12":"Greet one another with a holy kiss. All the saints greet you."
,"13":"The grace of Christ Jesus the Lord, the love of God and the fellowship of the Holy Spirit be with you all."
}`)

}
func EN_CCB_LoadNP2EChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"From Paul, Sylvanus and Timothy, to the church of the Thessalonians which is in God our Father and in Christ Jesus, the Lord."
,"2":"May grace and peace be yours from God the Father and Christ Jesus, the Lord."
,"3":"Brothers and sisters, we should give thanks to God at all times for you. It is fitting to do so, for your faith is growing and your love for one another increasing."
,"4":"We take pride in you among the churches of God because of your endurance and your faith in the midst of persecution and sufferings."
,"5":"In this the just judgment of God may be seen; for you must show yourselves worthy of the kingdom of God for which you are now suffering."
,"6":"Indeed, it is just that God repays with affliction those who persecute you,"
,"7":"but to you who suffer, he will grant rest with us when the Lord Jesus will be shown in his Glory, coming from heaven and surrounded by his court of angels."
,"8":"Then with flaming fire will be punished those who do not recognize God and do not obey the Gospel of Jesus, our Lord."
,"9":"They will be sent to eternal damnation far away from the face of the Lord and his mighty glory."
,"10":"On that day the Lord will be glorified in the midst of his saints, and reveal his wonders through those who believe in him, that is through you who have received our testimony."
,"11":"This is why we constantly pray for you; may our God make you worthy of his calling. May he, by his power, fulfill your good purposes and your work prompted by faith."
,"12":"In that way, the name of Jesus our Lord will be glorified through you, and you through him, according to the loving plan of God and of Christ Jesus the Lord."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Brothers and sisters, let us speak about the coming of Christ Jesus, our Lord, and our gathering to meet him."
,"2":"Do not be easily unsettled. Do not be alarmed by what a prophet says or by any report, or by some letter said to be ours, saying the day of the Lord is at hand."
,"3":"Do not let yourselves be deceived in any way. Apostasy must come first, when the man of Sin will appear,"
,"4":"that instrument of evil who opposes and defiles whatever is considered divine and holy, even to the point of sitting in the temple of God and claiming to be God."
,"5":"Do you not remember I spoke of it when I was still with you?"
,"6":"But you also know what prevents him from appearing until his due time."
,"7":"The mystery of sin is already at work, but the one who restrains it at present has to be taken away."
,"8":"Then the wicked one will appear, whom the Lord is to sweep away with the breath of his mouth and destroy in the splendor of his coming."
,"9":"This lawless one will appear with the power of Satan, performing miracles and wonderful signs at the service of deception."
,"10":"All the deceits of evil will then be used for the ruin of those who refused to love truth and be saved."
,"11":"This is why God will send them the power of delusion, that they may believe what is false."
,"12":"So all those who chose wickedness instead of believing the truth will be condemned."
,"13":"But we have to give thanks for you at all times, dear brothers and sisters in the Lord. For God chose you from the beginning to be saved through true faith and to be made holy by the Spirit."
,"14":"To this end he called you through the gospel we preach, for he willed you to share the glory of Christ Jesus our Lord."
,"15":"Because of that, brothers and sisters, stand firm and hold to the traditions that we taught you by word or by letter."
,"16":"May Christ Jesus our Lord who has loved us, may God our Father, who in his mercy gives us everlasting comfort and true hope, strengthen you."
,"17":"May he encourage your hearts and make you steadfast in every good work and word."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Finally, brothers and sisters, pray for us that the Word of God may finish the race and be crowned as it was with you."
,"2":"May God guard us from wicked and evil people, since not everyone has faith."
,"3":"The Lord is faithful; he will strengthen you and keep you safe from the Evil One."
,"4":"Besides, we have in the Lord this confidence that you are doing and will continue to do what we order you."
,"5":"May the Lord direct your hearts to the love of God and to perseverance for the sake of Christ."
,"6":"We command you, beloved, to stay away from believers who are living in idleness contrary to the traditions we passed on to you."
,"7":"You know how you ought to follow our example: we worked while we were with you."
,"8":"Day and night we labored and toiled so as not to be a burden to any of you."
,"9":"We had the right to act otherwise, but we wanted to give you an example."
,"10":"Besides, while we were with you, we said clearly: If anyone is not willing to work, neither should that one eat."
,"11":"However we heard that some among you live in idleness - busybodies, doing no work."
,"12":"In the name of Christ Jesus our Lord we command these people to work and earn their own living."
,"13":"And you, brothers and sisters, do not weary in doing what is right."
,"14":"If someone does not obey our instruction in this letter, take note and do not have anything to do with him, so that he may be ashamed."
,"15":"However, do not treat him as an enemy, but warn him as a brother."
,"16":"May the Lord of peace give you his peace at all times and in every way. May the Lord be with you all."
,"17":"I, Paul, write this greeting with my own hand. This is my signature in all my letters. This is how I write."
,"18":"May the grace of Christ Jesus our Lord be with you."
}`)

}
func EN_CCB_LoadNP2IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"From Paul, apostle of Christ Jesus by the will of God, for the sake of his promise of eternal life in Christ Jesus,"
,"2":"to my dear son Timothy. May grace, mercy and peace be with you from God the Father and Christ Jesus our Lord. "
,"3":"I give thanks to God whom I serve with a clear conscience the way my ancestors did, as I remember you constantly, day and night, in my prayers."
,"4":"I recall your tears and I long to see you that I may be filled with joy. I am reminded of your sincere faith,"
,"5":"so like the faith of your grandmother Lois and of your mother Eunice, which I am sure you have inherited."
,"6":"For this reason I invite you to fan into a flame the gift of God you received through the laying on of my hands."
,"7":"For God did not confer on us a spirit of bashfulness, but of strength, love and good judgment."
,"8":"Do not be ashamed of testifying to our Lord, nor of seeing me in chains. On the contrary, do your share in laboring for the Gospel with the strength of God."
,"9":"He saved us and called us - a calling which proceeds from his holiness. This did not depend on our merits, but on his generosity and his own initiative. This calling given to us from all time in Christ Jesus"
,"10":"has just been manifested with the glorious appearance of Christ Jesus, our Lord, who destroyed death and brought life and immortality to light in his Gospel."
,"11":"Of this message I was made herald, apostle and teacher."
,"12":"For its sake I now suffer this trial, but I am not ashamed, for I know in whom I have believed and I am convinced that he is capable of taking care of all I have entrusted to him until that day."
,"13":"Follow the pattern of the sound doctrine which you have heard from me, concerning faith and love in Christ Jesus."
,"14":"Keep this precious deposit with the help of the Holy Spirit who lives within us."
,"15":"You know that all from the province of Asia have deserted me, especially Phygelus and Hermogenes."
,"16":"May God bless the household of Onesiphoras, for he often came to visit me and was not ashamed of my chains."
,"17":"On the contrary, on arriving in Rome he searched for me until he found me."
,"18":"May the Lord grant that he find mercy from the Lord on that day. You well know all the services he rendered at Ephesus."
}`)
	CurrentBook.AddChapter(2, `{
"1":"You, my son, be strong with the grace you have in Christ Jesus."
,"2":"Entrust to reliable people everything you have learned from me in the presence of many witnesses, that they may instruct others."
,"3":"Labor like a good soldier of Christ Jesus."
,"4":"No soldier gets involved in civilian trade; the soldier's aim is to please his commanding officer."
,"5":"No athlete is crowned unless he competes according to the rules."
,"6":"And again, the farmer who tills the land is the first to enjoy the fruits of the harvest."
,"7":"Think over what I am telling you; the Lord will give you understanding in everything."
,"8":"Remember Christ Jesus, risen from the dead, Jesus, son of David, as preached in my Gospel."
,"9":"For this Gospel I labor and even wear chains like an evildoer, but the word of God is not chained."
,"10":"And so I bear everything for the sake of the chosen people, that they, too, may obtain the salvation given to us in Christ Jesus and share eternal glory."
,"11":"This statement is true:"
,"12":"If we have died with him, we shall also live with him; If we deny him, he will also deny us;"
,"13":"If we are unfaithful, he remains faithful for he cannot deny himself."
,"14":"Remind your people of these things and urge them in the presence of God not to fight over words, which does no good, but only ruins those who listen."
,"15":"Be for God an active and proved minister, a blameless worker correctly handling the word of truth."
,"16":"Do not take part in useless conversations, alien to the faith. This leads to a greater lack of faith."
,"17":"Such teaching spreads like gangrene: I am thinking of Hymeneus and Philetus."
,"18":"They strayed from the truth, holding that resurrection has already taken place; and with this they upset the faith of some."
,"19":"But the solid foundations laid by God are not shaken; on them it is written: The Lord knows those who are his, and: Let him who confesses the name of the Lord turn away from evil."
,"20":"In a large house we find not only vessels of gold and silver, but also of wood and clay. Some are reserved for special uses, others, for ordinary ones."
,"21":"All who clean themselves of what I speak of, will become a noble vessel, useful to the Lord, prepared for any holy purpose."
,"22":"So shun the passions of youth and seek righteousness, faith, love and peace, together with those who call upon the Lord with a pure heart."
,"23":"Avoid stupid and senseless discussions, since such are the cause of misunderstanding."
,"24":"God's servant must not be quarrelsome, but kind to all, always teaching and patient with those who do not understand,"
,"25":"gently correct opponents; perhaps God may grant them to repent and discover the truth,"
,"26":"withdrawing them from the snare of the devil who held them captive to his own will."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Be quite sure that there will be difficult times in the last days."
,"2":"People will become selfish, lovers of money, boastful, conceited, gossips, disobedient to their parents, ungrateful, unholy."
,"3":"They will be unable to love and to forgive; they will be slanderers, without self-control, cruel, enemies of good,"
,"4":"traitors, shameless, full of pride, more in love with pleasure than with God."
,"5":"They will keep the appearance of piety, while rejecting its demands. Keep away from such people."
,"6":"Of the same kind are those who enter houses and captivate weak women, full of sins, swayed by all kinds of passion,"
,"7":"who are always learning but never grasping knowledge of the truth."
,"8":"These people of corrupt mind and false faith oppose the truth just as Jannes and Jambres opposed Moses."
,"9":"Yet they may not go very far, for their folly will be clear to all, as in the case of those two."
,"10":"You, instead, have closely followed my teaching, my way of life, my projects, faith, patience, love, endurance,"
,"11":"persecutions and sufferings. You know what happened to me at Antioch, Iconium and Lystra. How many trials I had to bear! Yet the Lord rescued me from them all."
,"12":"All who want to serve God in Christ Jesus will be persecuted,"
,"13":"while evil persons and impostors will go from bad to worse, deceiving and being deceived."
,"14":"As for you, continue with what you have learned and what has been entrusted to you, knowing from whom you received it."
,"15":"Besides, you have known the Scriptures from childhood; they will give you the wisdom that leads to salvation through faith in Christ Jesus."
,"16":"All Scripture is inspired by God and is useful for teaching, refuting error, for correcting and training in Christian life."
,"17":"Through Scripture the man of God is made expert and thoroughly equipped for every good work."
}`)
	CurrentBook.AddChapter(4, `{
"1":"In the presence of God and Christ Jesus, who is to judge the living and the dead, and by the hope I have of his coming and his kingdom, I urge you"
,"2":"to preach the Word, in season and out of season, reproving, rebuking or advising, always with patience and providing instruction."
,"3":"For the time is coming when people will no longer endure sound doctrine but will be so eager to hear what is new, that they will never have enough teachers after their own liking."
,"4":"And they will abandon the truth to hear fables."
,"5":"So be prudent, do not mind your labor, give yourself to your work as an evangelist, fulfill your ministry."
,"6":"As for me the time of sacrifice has arrived, and the moment of my departure has come."
,"7":"I have fought the good fight, I have finished the race, I have kept the faith."
,"8":"Now there is laid up for me the crown of righteousness with which the Lord, the just judge, will reward me on that day; and not only me, but all those who have longed for his glorious coming."
,"9":"Do your best to come to me quickly."
,"10":"You must know that Demas has deserted me for the love of this world: he returned to Thessalonica. Crescens has gone to Galatia and Titus to Dalmatia."
,"11":"Only Luke remains with me. Get Mark and bring him with you, for he is a useful helper in my work."
,"12":"I sent Tychicus to Ephesus."
,"13":"Bring with you the cloak I left at Troas, in Carpos' house and also the scrolls, especially the parchments."
,"14":"Alexander the metalworker has caused me great harm. The Lord will repay him for what he has done."
,"15":"Distrust him for he has been very much opposed to our preaching."
,"16":"At my first hearing in court no one supported me; all deserted me. May the Lord not hold it against them."
,"17":"But the Lord was at my side, giving me strength to proclaim the Word fully, and let all the pagans hear it. So I was rescued from the lion's mouth."
,"18":"The Lord will save me from all evil, bringing me to his heavenly kingdom. Glory to him for ever and ever. Amen!"
,"19":"Greetings to Prisca and Aquila and to the family of Onesiphorus."
,"20":"Erastus remained in Corinth. I left Trophimus sick in Miletus."
,"21":"Try to come here before the winter. Eubulus, Pudens, Linus, Claudia and all the brothers and sisters send you greetings."
,"22":"The Lord be with your spirit. May grace be with you all."
}`)

}
func EN_CCB_LoadNPCLChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paul, apostle of Christ Jesus by the will of God and Timothy our brother,"
,"2":"to the saints in Colossae, our faithful brothers and sisters in Christ: Receive grace and peace from God our Father, and Christ Jesus our Lord."
,"3":"Thanks be to God, the Father of Christ Jesus, our Lord!,We constantly pray for you, "
,"4":"for we have known of your faith in Christ Jesus and of your love for all the saints. Indeed you await in hope the inheritance reserved for you in Heaven,"
,"5":"of which you have heard through the word of truth. This Gospel,"
,"6":"already present among you, is bearing fruit and growing throughout the world, as it did among you from the day you accepted it and understood the gift of God in all its truth."
,"7":"He who taught you, Epaphras, our dear companion in the service of Christ, faithful minister of Christ on our behalf,"
,"8":"has reminded me of the love you have for me in the spirit."
,"9":"Because of this, from the day we received news of you, we have not ceased praying to God for you, that you may attain the full knowledge of his will through all the gifts of wisdom and spiritual understanding."
,"10":"May your lifestyle be worthy of the Lord and completely pleasing to him. May you bear fruit in every good work and grow in the knowledge of God."
,"11":"May you become strong in everything by a sharing of the Glory of God, so that you may have great endurance and persevere in joy."
,"12":"Constantly give thanks to the Father who has empowered us to receive our share in the inheritance of the saints in his kingdom of light."
,"13":"He rescued us from the power of darkness and transferred us to the kingdom of his beloved Son."
,"14":"In him we are redeemed and forgiven."
,"15":"He is the image of the unseen God, and for all creation he is the firstborn,"
,"16":"for in him all things were created, in heaven and on earth, visible and invisible: thrones, rulers, authorities, powers... All was made through him and for him."
,"17":"He is before all,and all things hold together in him."
,"18":"And he is the head of the body, that is the Church, for he is the first, the first raised from the dead,that he may be the first in everything,"
,"19":"for God was pleased to let fullness dwell in him."
,"20":"Through him God willed to reconcile all things to himself, and through him, through his blood shed on the cross, God establishes peace, on earth as in Heaven."
,"21":"You yourselves were once estranged and opposed to God because of your evil deeds,"
,"22":"but now you have been reconciled. God reconciled you by giving up to death the body of Christ, so that you may be without fault, holy and blameless before him."
,"23":"Only stand firm, upon the foundation of your faith, and be steadfast in hope. Keep in mind the Gospel you have heard, which has been preached to every creature under heaven, and of which I, Paul, became a minister."
,"24":"At present I rejoice when I suffer for you; I complete in my own flesh what is lacking in the sufferings of Christ for the sake of his body, which is the Church."
,"25":"For I am serving the Church since God entrusted to me the ministry of bringing into effect his design for you."
,"26":"I mean that mysterious plan that for centuries and generations remained secret, and which God has now revealed to his holy ones."
,"27":"God willed to make known to them the riches and even the Glory that his mysterious plan reserved for the pagan nations: Christ is in you and you may hope God's Glory."
,"28":"This Christ we preach. We warn and teach everyone true wisdom, aiming to make everyone perfect in Christ."
,"29":"For this cause I labor and struggle with the energy of Christ working powerfully in me."
}`)
	CurrentBook.AddChapter(2, `{
"1":"I want you to know how I strive for you, for those of Laodicea and for so many who have not met me personally."
,"2":"I pray that all may be encouraged. May you be established in love, that you may obtain all the riches of a full understanding and know the mystery of God, Christ himself."
,"3":"For in him are hidden all the treasures of wisdom and knowledge."
,"4":"So let no one deceive you with persuasive arguments."
,"5":"Although I am far from you, my spirit is with you and I rejoice in recalling how well-disciplined you are and how firm in the faith of Christ."
,"6":"If you have accepted Christ Jesus as Lord, let him be your doctrine."
,"7":"Be rooted and built up in him; let faith be your principle, as you were taught, and your thanksgiving overflowing."
,"8":"See that no one deceives you with philosophy or any hollow discourse; these are merely human doctrines not inspired by Christ but by the wisdom of this world."
,"9":"For in Him dwells the fullness of God in bodily form."
,"10":"He is the head of all cosmic power and authority, and in him you have everything."
,"11":"In Christ Jesus you were given a circumcision but not by human hands, which removed completely from you the carnal body:"
,"12":"I refer to baptism. On receiving it you were buried with Christ; and you also rose with him for having believed in the power of God who raised him from the dead."
,"13":"You were dead. You were in sin and uncircumcised at the same time. But God gave you life with Christ. He forgave all our sins."
,"14":"He canceled the record of our debts, those regulations which accused us. He did away with all that and nailed it to the cross."
,"15":"Victorious through the cross, he stripped the rulers and authorities of their power, humbled them before the eyes of the whole world and dragged them behind him as prisoners."
,"16":"So, then, let no one criticize you in matters of food or drink or for not observing festivals, new moons or the sabbath."
,"17":"These things were only shadows of what was to come, whereas the reality is the person of Christ."
,"18":"Do not let yourselves be robbed of him by those people who offer you a religion of fear and the worship of the angels. In fact, they only appreciate their own visions and are puffed up with their idle notions,"
,"19":"instead of holding firmly to the head, Christ. It is he who nourishes and gives unity to the whole body by a complex system of nerves and ligaments, making it grow according to the plan of God."
,"20":"If you have really died with Christ, and are rid of the principles of the world, why do you now let yourselves be taught as if you belonged to the world?"
,"21":"'Do not eat this, do not taste that, do not touch that...'"
,"22":"These are human rules and teachings, referring to things that are perishable, that wear out and disappear."
,"23":"These doctrines may seem to be profound because they speak of religious observance and humility and of disregarding the body. In fact, they are useless as soon as the flesh rebels."
}`)
	CurrentBook.AddChapter(3, `{
"1":"So then, if you are risen with Christ, seek the things that are above, where Christ is seated at the right hand of God."
,"2":"Set your mind on the things that are above, not on earthly things."
,"3":"For you have died and your life is now hidden with Christ in God."
,"4":"When Christ, who is your life, reveals himself, you also will be revealed with him in Glory."
,"5":"Therefore, put to death what is earthly in your life, that is immorality, impurity, inordinate passions, wicked desires and greed which is a way of worshiping idols."
,"6":"These are the things that arouse the wrath of God."
,"7":"For a time you followed this way and lived in such disorders."
,"8":"Well then, reject all that: anger, evil intentions, malice; and let no abusive words be heard from your lips."
,"9":"Do not lie to one another. You have been stripped of the old self and its way of thinking"
,"10":"to put on the new, which is being renewed and is to reach perfect knowledge and the likeness of its creator."
,"11":"There, there is no distinction between Jew and Greek, between circumcised and uncircumcised. There are no strangers, barbarians, slave and free, but Christ is all and is in all."
,"12":"Clothe yourselves, then, as is fitting for God's chosen people, holy and beloved of him. Put on compassion, kindness, humility, meekness and patience"
,"13":"to bear with one another and forgive whenever there is any occasion to do so. As the Lord has forgiven you, forgive one another."
,"14":"When you have put on all these, take love as your belt so that the dress be perfect."
,"15":"May the peace of Christ overflow in your hearts; for this end you were called to be one body. And be thankful."
,"16":"Let the word of God dwell in you in all its richness. Teach and admonish one another with words of wisdom. With thankful hearts sing to God psalms, hymns and spontaneous praise."
,"17":"And whatever you do or say, do it in the Name of Jesus, the Lord, giving thanks to God the Father through him."
,"18":"Wives, submit yourselves to your husbands, as you should do in the Lord."
,"19":"Husbands, love your wives and do not get angry with them."
,"20":"Children, obey your parents in everything, because that pleases the Lord."
,"21":"Parents, do not be too demanding of your children, lest they become discouraged."
,"22":"Servants, obey your masters in everything; not only while they are present, to gain favor with them, but sincerely, because you fear the Lord."
,"23":"Whatever you do, do it wholeheartedly, working for the Lord, and not for humans."
,"24":"You well know that the Lord will reward you with the inheritance. You are servants, but your Lord is Christ."
,"25":"Every evildoer will be paid back for whatever wrong has been done, for God does not make exceptions in favor of anyone."
}`)
	CurrentBook.AddChapter(4, `{
"1":"As for you, masters, give your servants what is fair and reasonable, knowing that you yourselves have a Master in heaven."
,"2":"Be steadfast in prayer and even spend the night praying and giving thanks."
,"3":"Pray especially for us and our preaching: may the Lord give us words to announce the mystery of Christ. Because of this I am in chains;"
,"4":"pray then that I may be able to reveal this mystery as I should."
,"5":"Deal wisely with those who do not belong to the Church; take advantage of every opportunity."
,"6":"Let your conversation be pleasing with a touch of wit. Know how to speak to everyone in the best way."
,"7":"Tychicus will give news of me. He is our dear brother and for me a faithful assistant and fellow worker for the Lord."
,"8":"I am purposely sending him to give you news of me and to encourage you."
,"9":"With him I am sending Onesimus, our faithful and dear brother, who is one of yours. They will tell you about everything that is happening here."
,"10":"My companion in prison, Aristarchus, greets you, as does Mark, the cousin of Barnabas, about whom you have already received instructions. If he calls on you, receive him warmly."
,"11":"Jesus, called Justus, also greets you. They are the only Jewish people working with me for the kingdom of God, and because of that they have been a comfort to me."
,"12":"Greetings from your countryman Epaphras, a good servant of Christ Jesus. He constantly battles for you through his prayer that you be perfect and firm in whatever God asks of you."
,"13":"I assure you that he is deeply concerned about you, as he is for the Laodiceans and those of Hierapolis."
,"14":"Greetings from Luke, our dear doctor and from Demas."
,"15":"Greet the brothers and sisters of Laodicea, and don't forget Nympha and the church that gathers in her house."
,"16":"After reading this letter, see that it is read in the Church of the Laodiceans, and have the letter they received read in yours."
,"17":"And say to Archipus, 'Do not forget the ministry given to you in the Lord.'"
,"18":"Greetings in my own hand, Paul. Remember that I am in chains. Grace be with you."
}`)

}
func EN_CCB_LoadNPEPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paul, an apostle of Christ Jesus by the will of God, to the saints in Ephesus, to you who share Christian faith:"
,"2":"receive grace and peace from God our Father and from Jesus the Lord."
,"3":"Blessed be God, the Father of Christ Jesus our Lord, who in Christ has blessed us from heaven with every spiritual blessing."
,"4":"God chose us in him before the creation of the world,to be holy and without sin in his presence."
,"5":"From eternity he destined us in love,to be his sons and daughters through Christ Jesus, thus fulfilling his free and generous will. This goal suited him:"
,"6":"that his loving-kindness which he granted us in his Beloved,might finally receive all glory and praise."
,"7":"For in Christ we obtain freedom, sealed by his blood, and have the forgiveness of sins. In this appears the greatness of his grace,"
,"8":"which he lavished on us. In all wisdom and understanding,"
,"9":"God has made known to us his mysterious design, in accordance with his loving-kindness in Christ."
,"10":"In him and under him God wanted to unite, when the fullness of time had come, everything in heaven and on earth."
,"11":"By a decree of Him who disposes all things,according to his own plan and decision,we, the Jews, have been chosen and called"
,"12":"and we were awaiting the Messiah, for the praise of his glory."
,"13":"You, on hearing the word of truth, the Gospel that saves you, have believed in him. And, as promised, you were sealed with the Holy Spirit,"
,"14":"the first pledge of what we shall receive, on the way to our deliverance as a people of God, for the praise of his glory."
,"15":"I have been told of your faith and your affection towards all the believers,"
,"16":"so I always give thanks to God, remembering you in my prayers."
,"17":"May the God of Christ Jesus our Lord, the Father of Glory, reveal himself to you and give you a spirit of wisdom, that you may know him."
,"18":"May he enlighten your inner vision, that you may appreciate the things we hope for, since we were called by God. May you know how great is the inheritance, the glory, God sets apart for his saints;"
,"19":"may you understand with what extraordinary power he acts in favor of us who believe."
,"20":"He revealed his almighty power in Christ when he raised him from the dead and had him sit at his right hand in heaven,"
,"21":"far above all rule, power, authority, dominion, or any other supernatural force that could be named, not only in this world but in the world to come as well."
,"22":"Thus has God put all things under the feet of Christ and set him above all things, as head of the Church"
,"23":"which is his body. He who fills all in all unfolds his fullness in the Church."
}`)
	CurrentBook.AddChapter(2, `{
"1":"You were dead through the faults and sins."
,"2":"Once you lived through them according to this world and followed the Sovereign Ruler who reigns between heaven and earth and who goes on working in those who resist the faith."
,"3":"All of us belonged to them at one time and we followed human greed; we obeyed the urges of our human nature and consented to its desires. By ourselves, we went straight to the judgment like the rest of humankind."
,"4":"But God, who is rich in mercy, revealed his immense love."
,"5":"As we were dead through our sins, he gave us life with Christ. By grace you have been saved!"
,"6":"And he raised us to life with Christ, giving us a place with him in heaven."
,"7":"In showing us such kindness in Christ Jesus, God willed to reveal and unfold in the coming ages the extraordinary riches of his grace."
,"8":"By the grace of God you have been saved through faith. This has not come from you: it is God's gift."
,"9":"This was not the result of your works, so you are not to feel proud."
,"10":"What we are is God's work. He has created us in Christ Jesus for the good works he has prepared that we should devote ourselves to them."
,"11":"Remember that you were pagans even in your flesh and the Jews, who call themselves Circumcised (because of a surgical circumcision), called you Uncircumcised."
,"12":"At that time you were without Christ, you did not belong to the community of Israel; the covenants of God and his promises were not for you; you had no hope and were without God in this world."
,"13":"But now, in Christ Jesus and by his blood, you who were once far off have come near."
,"14":"For Christ is our peace, he who has made the two peoples one,"
,"15":"destroying in his own flesh the wall - the hatred - which separated us. He abolished the Law with its commands and precepts. He made peace in uniting the two peoples in him, creating out of the two one New Man."
,"16":"He destroyed hatred and reconciled us both to God through the cross, making the two one body."
,"17":"He came to proclaim peace; peace to you who were far off, peace to the Jews who were near."
,"18":"Through him we - the two peoples - approach the Father in one Spirit."
,"19":"Now you are no longer strangers or guests, but fellow citizens of the holy people: you are of the household of God. You are the house"
,"20":"whose foundations are the apostles and prophets, and whose cornerstone is Christ Jesus."
,"21":"In him the whole structure is joined together and rises to be a holy temple in the Lord."
,"22":"In him you too are being built to become the spiritual sanctuary of God."
}`)
	CurrentBook.AddChapter(3, `{
"1":"For this reason I, Paul, came to be the prisoner of Christ for you, the non-Jews."
,"2":"You may have heard of the graces God bestowed on me for your sake."
,"3":"By a revelation he gave me the knowledge of his mysterious design, as I have explained in a few words."
,"4":"On reading them you will have some idea of how I understand the mystery of Christ."
,"5":"This mystery was not made known to past generations but only now, through revelations given to holy apostles and prophets."
,"6":"Now the non-Jewish people share the Inheritance; in Christ Jesus the non-Jews are incorporated and are to enjoy the Promise. This is the Good News "
,"7":"of which I have become minister by a gift of God, a grace he gave me, when his power worked in me."
,"8":"This grace was given to me, the least among all the holy ones: to announce to the pagan nations the immeasurable riches of Christ"
,"9":"and to make clear to all how the mystery, hidden from the beginning in God, the Creator of all things, is to be fulfilled."
,"10":"Even the heavenly forces and powers will now discover through the Church the wisdom of God in its manifold expression, as the plan is being fulfilled"
,"11":"which God designed from the beginning in Christ Jesus, our Lord."
,"12":"In him we receive boldness and confidence to approach God."
,"13":"So I ask you not to be discouraged at seeing the trials I endure for you, but rather to feel proud because of them."
,"14":"And now I kneel in the presence of the Father"
,"15":"from whom every family in heaven and on earth has received its name."
,"16":"May he strengthen in you the inner self through his Spirit, according to the riches of his glory;"
,"17":"may Christ dwell in your hearts through faith; may you be rooted and founded in love."
,"18":"All of this so that you may understand with all the holy ones the width, the length, the height and the depth - in a word,"
,"19":"that you may know the love of Christ which surpasses all knowledge, that you may be filled and reach the fullness of God."
,"20":"Glory to God who shows his power in us and can do much more than we could ask or imagine;"
,"21":"glory to him in the Church and in Christ Jesus through all generations for ever and ever. Amen."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Therefore I, the prisoner of Christ, invite you to live the vocation you have received."
,"2":"Be humble, kind, patient, and bear with one another in love."
,"3":"Make every effort to keep among you the unity of Spirit through bonds of peace."
,"4":"Let there be one body and one spirit, for God, in calling you, gave the same Spirit to all."
,"5":"One Lord, one faith, one baptism."
,"6":"One God, the Father of all, who is above all and works through all and is in all."
,"7":"But to each of us divine grace is given according to the measure of Christ's gift."
,"8":"Therefore it is said: When he ascended to the heights, he brought captives and gave his gifts to people."
,"9":"He ascended: this refers to the one who first descended to the dead in the lower parts of the world."
,"10":"He himself who went down, then ascended far above all the heavens to fill all things."
,"11":"As for his gifts, to some he gave to be apostles, to others prophets, or even evangelists, or pastors and teachers."
,"12":"So he prepared those who belong to him for the ministry, in order to build up the Body of Christ,"
,"13":"until we are all united in the same faith and knowledge of the Son of God. Thus we shall become the perfect Man, upon reaching maturity and sharing the fullness of Christ."
,"14":"Then no longer shall we be like children tossed about by any wave or wind of doctrine, and deceived by the cunning of people who drag them along into error."
,"15":"Rather, with sincere love, we shall grow in every way towards him who is the head, Christ."
,"16":"From him comes the growth of the whole body to which a network of joints gives order and cohesion, taking into account and making use of the function of each one. So the body builds itself in love."
,"17":"I say to you, then, and with insistence I advise you in the Lord: do not imitate the pagans who live an aimless kind of life."
,"18":"Their understanding is in darkness and they remain in ignorance because of their blind conscience, very far from the life of God."
,"19":"As a result of their corruption, they have abandoned themselves to sensuality and have eagerly given themselves to every kind of immorality."
,"20":"But it is not for this that you have followed Christ."
,"21":"For I suppose that you heard of him and received his teaching which is seen in Jesus himself."
,"22":"You must give up your former way of living, the old self, whose deceitful desires bring self-destruction."
,"23":"Renew yourselves spiritually, from inside,"
,"24":"and put on the new self, or self according to God, which is created in true righteousness and holiness."
,"25":"Therefore, give up lying; let all of us speak the truth to our neighbors for we are members of one another."
,"26":"Be angry but do not sin: do not let your anger last until the end of the day,"
,"27":"lest you give the devil a foothold."
,"28":"Let the one who used to steal, steal no more, but busy himself working usefully with his hands so that he may have something to share with the needy."
,"29":"Do not let even one bad word come from your mouth, but only good words that will encourage when necessary and be helpful to those who hear."
,"30":"Do not sadden the Holy Spirit of God which you were marked with. It will be your distinctive mark on the day of salvation."
,"31":"Do away with all quarreling, rage, anger, insults and every kind of malice:"
,"32":"be good and understanding, mutually forgiving one another as God forgave you in Christ."
}`)
	CurrentBook.AddChapter(5, `{
"1":"As most beloved children of God, strive to imitate him."
,"2":"Follow the way of love, the example of Christ who loved you. He gave himself up for us and became the offering and sacrificial victim whose fragrance rises to God."
,"3":"And since you are holy, there must not be among you even a hint of sexual immorality or greed, or any kind of impurity: these should not be named among you."
,"4":"So too for scandalous words, nonsense and foolishness, which are not fitting; instead offer thanksgiving to God."
,"5":"Know this: no depraved, impure or covetous person who serves the god 'Money' shall have part in the kingdom of Christ and of God."
,"6":"Let no one deceive you with empty arguments, for these are the sins which God is about to condemn in people who do not obey."
,"7":"Do not associate with such people."
,"8":"You were once darkness, but now you are light in the Lord. Behave as children of light;"
,"9":"the fruits of light are kindness, justice and truth in every form."
,"10":"You yourselves search out what pleases the Lord,"
,"11":"and take no part in works of darkness that are of no benefit; expose them instead."
,"12":"Indeed it is a shame even to speak of what those people do in secret,"
,"13":"but as soon as it is exposed to the light, everything becomes clear."
,"14":"And what has become clear becomes light. Therefore it is said: 'Awake, you who sleep, arise from the dead that the light of Christ may shine on you.'"
,"15":"Pay attention to how you behave. Do not live as the unwise do, but as responsible persons."
,"16":"Try to make good use of the present time, because these days are evil."
,"17":"So do not be foolish but understand what the will of the Lord is."
,"18":"Do not get drunk: wine leads to levity; but be filled with the Holy Spirit."
,"19":"Gather together to pray with psalms, hymns and spiritual songs. Sing and celebrate the Lord in your heart,"
,"20":"giving thanks to God the Father in the name of Christ Jesus, our Lord, always and for everything."
,"21":"Let all kinds of submission to one another become obedience to Christ."
,"22":"So wives to their husbands: as to the Lord."
,"23":"The husband is the head of his wife, as Christ is the head of the Church, his body, of whom he is also the Savior."
,"24":"And as the Church submits to Christ, so let a wife submit in everything to her husband."
,"25":"As for you, husbands, love your wives as Christ loved the Church and gave himself up for her."
,"26":"He washed her and made her holy by baptism in the Word."
,"27":"As he wanted a radiant Church without stain or wrinkle or any blemish, but holy and blameless, he himself had to prepare and present her to himself."
,"28":"In the same way, husbands should love their wives as they love their own bodies. He who loves his wife loves himself."
,"29":"And no one has ever hated his body; he feeds and takes care of it. That is just what Christ does for the Church,"
,"30":"because we are a part of his body."
,"31":"Scripture says: Because of this a man shall leave his father and mother to be united with his wife, and the two shall become one flesh."
,"32":"This is a very great mystery, and I refer to Christ and the Church."
,"33":"As for you, let each one love his wife as himself, and let the wife respect her husband."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Children, obey your parents for this is right:"
,"2":"Honor your father and your mother. And this is the first commandment that has promise:"
,"3":"that you may be happy and enjoy long life in the land."
,"4":"And you, fathers, do not make rebels of your children, but educate them by correction and instruction which the Lord may inspire."
,"5":"Servants, obey your masters of this world with fear and respect, with simplicity of heart, as if obeying Christ."
,"6":"Do not serve only when you are watched or in order to please others, but become servants of Christ who do God's will with all your heart."
,"7":"Work willingly, for the Lord and not for humans, mindful that the good each one has done,"
,"8":"whether servant or free, will be rewarded by the Lord."
,"9":"And you, masters, deal with your servants in the same way, and do not threaten them, since you know that they and you have the same Lord who is in heaven, and he treats all fairly."
,"10":"Finally, be strong in the Lord with his energy and strength."
,"11":"Put on the whole armor of God to be able to resist the cunning of the devil."
,"12":"Our battle is not against human forces but against the rulers and authorities and their dark powers that govern this world. We are struggling against the spirits and supernatural forces of evil."
,"13":"Therefore put on the whole armor of God, that in the evil day, you may resist and stand your ground, making use of all your weapons."
,"14":"Take truth as your belt, justice as your breastplate,"
,"15":"and zeal as your shoes to propagate the Gospel of peace."
,"16":"Always hold in your hand the shield of faith to repel the flaming arrows of the devil."
,"17":"Finally, use the helmet of salvation and the sword of the Spirit, that is, the Word of God."
,"18":"Pray at all times as the Spirit inspires you. Keep watch, together with sustained prayer and supplication for all the holy ones."
,"19":"Pray also for me, so that when I speak, I may be given words to proclaim bravely the mystery of the Gospel."
,"20":"Even when in chains I am an ambassador of God; may he give me the strength to speak as I should."
,"21":"I also want you to know how I am and what I am doing. Tychicus, our beloved brother and faithful minister in the Lord, will tell you everything."
,"22":"I am sending him precisely to give you news of us and comfort you all."
,"23":"May peace and love with faith from God the Father and from Christ Jesus the Lord, be with the brothers and sisters."
,"24":"And may his blessing be with all who love Christ Jesus, our Lord, with undying love."
}`)

}
func EN_CCB_LoadNPGAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"From Paul, an apostle sent not by humans nor by human mediation,but by Christ Jesus and by God, the Father, who raised him from the dead; "
,"2":"I and all the brothers and sisters who are with me greet the churches in Galatia:"
,"3":"may you receive grace and peace from God our Father and from Christ Jesus our Lord."
,"4":"He gave himself for our sins to rescue us from this evil world, in fulfillment of the will of God the Father:"
,"5":"Glory to him for ever and ever. Amen."
,"6":"I am surprised at how quickly you have abandoned God who called you according to the grace of Christ, and have gone to another gospel."
,"7":"Indeed, there is no other gospel, but some people who are sowing confusion among you want to turn the Gospel of Christ upside down."
,"8":"But even if we ourselves were giving you another gospel different from the one we preached to you, or if it were an angel from heaven, I would say: fire him!"
,"9":"As I have said I now say again: if anyone preaches the Gospel in a way other than you received it, fire that one."
,"10":"Are we to please humans or obey God? Do you think that I try to please people? If I were still trying to please people, I would not be a servant of Christ."
,"11":"Let me remind you, brothers and sisters, that the Gospel we preached to you is not a human message,"
,"12":"nor did I receive it from anyone, I was not taught of it but it came to me as a revelation from Christ Jesus."
,"13":"You have heard of my previous activity in the Jewish community; I furiously persecuted the Church of God and tried to destroy it."
,"14":"For I was more devoted to the Jewish religion than many fellow Jews of my age, and I defended the traditions of my ancestors more fanatically."
,"15":"But one day God called me out of his great love, he who had chosen me from my mother's womb; and he was pleased"
,"16":"to reveal in me his Son, that I might make him known among the pagan nations. Then I did not seek human advice"
,"17":"nor did I go up to Jerusalem to those who were apostles before me. I immediately went to Arabia, and from there I returned again to Damascus."
,"18":"Later, after three years, I went up to Jerusalem to meet Cephas, and I stayed with him for fifteen days."
,"19":"But I did not see any other apostle except James, the Lord's brother."
,"20":"On writing this to you, I affirm before God that I am not lying."
,"21":"After that I went to Syria and Cilicia."
,"22":"The churches of Christ in Judea did not know me personally;"
,"23":"they had only heard of me: 'He who once persecuted us is now preaching the faith he tried to uproot.'"
,"24":"And they praised God because of me."
}`)
	CurrentBook.AddChapter(2, `{
"1":"After fourteen years I again went up to Jerusalem with Barnabas, and Titus came with us."
,"2":"Following a revelation, I went to lay before them the Gospel that I am preaching to the pagans. I had a private meeting with the leaders - lest I should be working or have worked in a wrong way."
,"3":"But they did not impose circumcision, not even on Titus who is Greek and who was with me."
,"4":"Because there were some intruders and false brothers who had gained access to watch over the way we live the freedom Christ has given us. They would have us enslaved by the Law,"
,"5":"but we refused to yield even for a moment; so that the truth of the Gospel remain intact in you."
,"6":"The others, the more respectable leaders - it does not matter what they were before: God pays no attention to the status of a person - gave me no new instructions."
,"7":"They recognized that I have been entrusted to give the Good News to the pagan nations, just as Peter has been entrusted to give it to the Jews."
,"8":"In the same way that God made Peter the apostle of the Jews, he made me the apostle of the pagans."
,"9":"James, Peter and John acknowledged the graces God gave me. Those men who were regarded as the pillars of the Church stretched out their hand to me and Barnabas as a sign of fellowship; we would go to the pagans and they to the Jews."
,"10":"We should only keep in mind the poor among them. I have taken care to do this."
,"11":"When later Cephas came to Antioch, I confronted him since he deserved to be blamed."
,"12":"Before some of James' people arrived, he used to eat with non-Jewish people. But when they arrived, he withdrew and did not mingle anymore with them, for fear of the Jewish group."
,"13":"The rest of the Jews followed him in this pretense, and even Barnabas was part of this double-dealing."
,"14":"When I saw that they were not acting in line with the truth of the Gospel, I said to Cephas publicly: If you who are Jewish agreed to live like the non-Jews, setting aside the Jewish customs, why do you now compel the non-Jews to live like Jews?"
,"15":"We are Jews by birth; we are not pagan sinners."
,"16":"Yet we know that no one is made just and holy by the observance of the Law but by faith in Christ Jesus. So we have believed in Christ Jesus that we may receive true righteousness from faith in Christ Jesus, and not from the practices of the Law, because no mortal will be set right with God in the field of the Law."
,"17":"We thought we would find in Christ the way of righteousness; if in doing this we were in the wrong, then Christ would be working for sin. Not so!"
,"18":"But look: if we do away with something and then restore it, we admit we did wrong."
,"19":"As for me, the very Law brought me to die to the Law, that I may live for God. I am crucified with Christ. Do I live? It is no longer me, Christ lives in me. My life in this body is life through faith in the Son of God who loved me and gave himself for me."
,"20":"In this way I don't ignore the gift of God,"
,"21":"for, if holiness were through the practice of the Law, Christ would have died for nothing."
}`)
	CurrentBook.AddChapter(3, `{
"1":"How foolish you are, Galatians! How could they bewitch you after Jesus Christ has been presented to you as crucified?"
,"2":"I shall ask you only this: Did you receive the Spirit by the practice of the Law, or by believing the message?"
,"3":"How can you be such fools: you begin with the Spirit and end up with the flesh!"
,"4":"So you have experienced all this in vain! Would that it were not so!"
,"5":"Did God give you the Spirit and work miracles among you, because of your observance of the Law or because you believed in his message?"
,"6":"Remember Abraham: he believed God and because of this was held to be a just man."
,"7":"Understand then that those who follow the way of faith are sons and daughters of Abraham."
,"8":"The Scriptures foresaw that by the way of faith, God would give true righteousness to the non-Jewish nations. For God's promise to Abraham was this: In you shall all the nations be blessed."
,"9":"So now those who take the way of faith receive the same blessing as Abraham who believed;"
,"10":"but those who rely on the practice of the Law are under a curse, for it is written: Cursed is everyone who does not always fulfill everything written in the Law."
,"11":"It is plainly written that no one becomes righteous, in God's way, by the Law: by faith the righteous shall live."
,"12":"Yet the Law gives no place to faith, for according to it: the one who fulfills the commandments shall have life through them."
,"13":"Now Christ rescued us from the curse of the Law by becoming cursed himself for our sake, as it is written: there is a curse on everyone who is hanged on a tree."
,"14":"So the blessing granted to Abraham reached the pagan nations in and with Christ, and we received the promised Spirit through faith."
,"15":"Brothers, listen to this comparison. When anyone has made his will in the prescribed form, no one can annul it or add anything to it."
,"16":"Well now, what God promised Abraham was for his descendant. Scripture does not say: for the descendants, as if they were many. It means only one: this will be for your descendant, and this is Christ."
,"17":"Now I say this: if God has made a testament in due form, it cannot be annulled by the Law which came four hundred and thirty years later; God's promise cannot be cancelled."
,"18":"But if we now inherit for keeping the law, it is not because of the promise. Yet that promise was God's gift to Abraham."
,"19":"Why then the Law? It was added with sin in mind; it was something added; that it was only valid until the descendant to whom the promise was addressed should come; and it was put into effect by the angels with Moses as a mediator"
,"20":"between them: if it were given by God himself, he is one."
,"21":"Does the Law then compete with the promises of God? Not at all. Only if we had been given a Law capable of raising life, could righteousness be the fruit of the Law."
,"22":"But the written Law actually closed out every viewpoint other than that of sin. So the believers receive the promise as the fruit of Christian faith."
,"23":"Before the time of faith had come, the Law confined us and kept us in custody until the time in which faith would show up."
,"24":"The Law then brought us to Christ as a child to his master, so that we be set right with God through faith."
,"25":"With the coming of faith, we are no longer submitted to this guidance."
,"26":"Now, in Christ Jesus, all of you are sons and daughters of God through faith."
,"27":"All of you who were given to Christ through baptism, have put on Christ."
,"28":"Here there is no longer any difference between Jew or Greek, or between slave or freed, or between man and woman: but all of you are one in Christ Jesus."
,"29":"And because you belong to Christ, you are of Abraham's race and you are to inherit God's promise."
}`)
	CurrentBook.AddChapter(4, `{
"1":"But listen, as long as the heir of the host is a child, he has no advantage over the slaves, although he is the master of them all."
,"2":"He is subject to those who care for him and who are entrusted with his affairs until the time set by his father comes."
,"3":"In the same way we as children were first subjected to the created forces that govern the world."
,"4":"But when the fullness of time came, God sent his Son. He came born of woman and subject to the Law,"
,"5":"in order to redeem the subjects of the Law, that we may be given our full rights of sons and daughters of God."
,"6":"And because you are sons, God has sent into your hearts the Spirit of his Son which cries out: Abba! that is, Father!"
,"7":"You yourself are no longer a slave but a son or daughter, and yours is the inheritance by God's grace."
,"8":"When you did not know God, you served those who are not gods."
,"9":"But now that you have known God - or rather he has known you - how can you turn back to weak and impoverished created things? Do you want to be enslaved again?"
,"10":"Will you again observe this and that day, and the new moon, and this period and that year...?"
,"11":"I fear I may have wasted my time with you."
,"12":"I implore you, dearly beloved, do as I do, just as I became like you. You have not offended me in anything."
,"13":"Remember that I was sick when I first announced the Gospel to you."
,"14":"Although I was a trial to you, you did not despise or reject me, but received me as an angel of God, as Christ Jesus."
,"15":"Where is this bliss? For I can testify that you would have even plucked out your eyes to give them to me."
,"16":"But now, have I become your enemy for telling you the truth?"
,"17":"Those who show consideration to you are not sincere; they want to separate you from me, so that you may show interest in them."
,"18":"Would that you were surrounded with sincere care at all times, and not only from me when I am with you!"
,"19":"My children! I still suffer the pains of childbirth until Christ is formed in you."
,"20":"How I would like to be with you now and speak to you personally, for I do not know what to say for the best."
,"21":"Tell me, you who desire to submit yourselves to the Law, did you listen to it?"
,"22":"It says that Abraham had two sons, one by a slave woman, the other by the free woman, his wife."
,"23":"The son of the slave woman was born in the ordinary way; but the son of the free woman was born in fulfillment of God's promise."
,"24":"Here we have an allegory and the figures of two covenants. The first is the one from Mount Sinai, represented through Hagar: her children have slavery for their lot."
,"25":"We know that Hagar was from Mount Sinai in Arabia: she stands for the present city of Jerusalem which is in slavery with her children."
,"26":"But the Jerusalem above, who is our mother, is free."
,"27":"And Scripture says of her: Rejoice, barren woman without children, break forth in shouts of joy, you who do not know the pains of childbirth, for many shall be the children of the forsaken mother, more than of the married woman."
,"28":"You, dearly beloved, are children of the promise, like Isaac."
,"29":"But as at that time the child born according to the flesh persecuted Isaac, who was born according to the spirit, so is it now."
,"30":"And what does Scripture say? Cast out the slave woman and her son, for the son of the slave cannot share the inheritance with the son of the free woman."
,"31":"Brethren, we are not children of the slave woman, but of the free woman."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Christ freed us to make us really free. So remain firm and do not submit again to the yoke of slavery."
,"2":"I, Paul, say this to you: if you receive circumcision, Christ can no longer help you."
,"3":"Once more I say to whoever receives circumcision: you are now bound to keep the whole Law."
,"4":"All you who pretend to become righteous through the observance of the Law have separated yourselves from Christ and have fallen away from grace."
,"5":"As for us, the Spirit imparts to us this hope that through faith we shall be set right with God."
,"6":"In Christ Jesus it is irrelevant whether we be circumcised or not; what matters is faith working through love."
,"7":"You had begun your race well, who then hindered you on the way? Why did you stop obeying the truth?"
,"8":"This was not in obedience to God who calls you:"
,"9":"in fact, a little leaven is affecting the whole of you."
,"10":"I am personally convinced that you will not go astray, but the one who confuses you, whoever he may be, shall receive punishment."
,"11":"I myself, brothers, could I not preach circumcision? Then I would no longer be persecuted. But where would be the scandal of the cross?"
,"12":"Would that those who confuse you might go as far as mutilating themselves!"
,"13":"You, brothers and sisters, were called to enjoy freedom; I am not speaking of that freedom which gives free rein to the desires of the flesh, but of that which makes you slaves of one another through love."
,"14":"For the whole Law is summed up in this sentence: You shall love your neighbor as yourself."
,"15":"But if you bite and tear each other to pieces, be careful lest you all perish."
,"16":"Therefore I say to you: walk according to the Spirit and do not give way to the desires of the flesh!"
,"17":"For the desires of the flesh war against the spirit, and the desires of the spirit are opposed to the flesh. Both are in conflict with each other, so that you cannot do everything you would like."
,"18":"But let the Spirit lead you: this has nothing to do with submitting to the Law."
,"19":"You well know what comes from the flesh: immorality, impurity and shamelessness,"
,"20":"idol worship and magic, hatred, jealousy and violence, anger, ambition, division, factions,"
,"21":"and envy, drunkenness, orgies and the like. I again say to you what I have already said: those who do these things shall not inherit the kingdom of God."
,"22":"But the fruit of the Spirit is charity, joy and peace, patience, understanding of others, kindness and fidelity,"
,"23":"gentleness and self-control. For such things there is no Law or punishment."
,"24":"Those who belong to Christ have crucified the flesh with its vices and desires."
,"25":"If we live by the Spirit, let us live in a spiritual way."
,"26":"Let us not be conceited; let there be no rivalry or envy of one another."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Brethren, in the event of someone falling into a sin, you who are spiritual shall set him aright with the spirit of kindness. Take care for you, too, may be tempted."
,"2":"Carry each other's burdens and so fulfill the law of Christ."
,"3":"If anyone thinks he is something, when in fact he is nothing, he deceives himself."
,"4":"Let each one examine his own conduct and boast for himself, if he wants to do so, but not before others."
,"5":"In this, let each one carry his own things."
,"6":"He who receives the teaching of the Word ought to share the good things he has with the one who instructs him."
,"7":"Do not be fooled. God cannot be deceived. You reap what you sow."
,"8":"The person who sows for the benefit of his own flesh shall reap corruption and death from the flesh. He who sows in the spirit shall reap eternal life from the Spirit."
,"9":"Let us do good without being discouraged; in due time we shall reap the reward of our constancy."
,"10":"So while there is time, let us do good to all and especially to our family in the faith."
,"11":"See these large letters I use when I write to you in my own hand. Who obliges you to be circumcised? "
,"12":"Those who are most anxious to put up a good show in life: what if the cross of Christ should bring them some trouble!"
,"13":"Not for being circumcised do they observe the Law: what interests them is the external rite. What a boast for them if they had you circumcised!"
,"14":"For me, I do not wish to take pride in anything except in the cross of Christ Jesus our Lord. Through him the world has been crucified to me and I to the world."
,"15":"Let us no longer speak of the circumcised and of non-Jews, but of a new creation."
,"16":"Let those who live according to this rule receive peace and mercy: they are the Israel of God!"
,"17":"Let no one trouble me any longer: for my part, I bear in my body the marks of Jesus."
,"18":"May the grace of Christ Jesus our Lord be with your spirit brothers and sisters. Amen."
}`)

}
func EN_CCB_LoadNPPMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"From Paul, a prisoner of Christ Jesus, and from our brother Timothy to Philemon, our friend and fellow worker,"
,"2":"to our dear sister Apphia, to Archippus faithful companion in our soldiering, and to all the Church gathered in your house."
,"3":"Grace and peace be with you from God the Father and Jesus Christ the Lord."
,"4":"I never cease to give thanks to my God when I remember you in my prayers,"
,"5":"for I hear of your love and faith towards the Lord and all the holy ones."
,"6":"And I pray that the sharing of your faith may make known all the good that is ours in Christ."
,"7":"I had great satisfaction and comfort on hearing of your charity, because the hearts of the saints have been cheered by you, brother."
,"8":"Because of this, although in Christ I have the freedom to command what you should do,"
,"9":"yet I prefer to request you in love. The one talking is Paul, the old man, now prisoner for Christ."
,"10":"And my request is on behalf of Onesimus, whose father I have become while I was in prison."
,"11":"This Onesimus has not been helpful to you, but now he will be helpful both to you and to me."
,"12":"In returning him to you, I am sending you my own heart."
,"13":"I would have liked to keep him at my side, to serve me on your behalf while I am in prison for the Gospel,"
,"14":"but I did not want to do anything without your agreement, nor impose a good deed upon you without your free consent."
,"15":"Perhaps Onesimus has been parted from you for a while so that you may have him back forever,"
,"16":"no longer as a slave, but better than a slave. For he is a very dear brother to me, and he will be even dearer to you."
,"17":"And so, because of our friendship, receive him as if he were I myself."
,"18":"And if he has caused any harm, or owes you anything, charge it to me."
,"19":"I, Paul, write this and sign it with my own hand: I will pay it... without further mention of your debt to me, which is you yourself."
,"20":"So, my brother, please do me this favor for the Lord's sake. Give me this comfort in Christ."
,"21":"Confident of your obedience I write to you, knowing you will do even more than I ask."
,"22":"And one more thing, get a lodging ready for me because, thanks to all your prayers, I hope to return to you."
,"23":"Epaphras, my fellow prisoner in Christ Jesus, sends greetings."
,"24":"So do Mark, Aristarchus, Demas and Luke, my assistants."
,"25":"May the grace of the Lord Christ be with you. Amen!"
}`)

}
func EN_CCB_LoadNPPPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"From Paul and Timothy, servants of Christ Jesus, to the saints in Philippi, with their bishops and deacons; to you all in Christ Jesus:"
,"2":"May grace and peace be yours from God, our Father, and Christ Jesus the Lord."
,"3":"I give thanks to my God each time I remember you,"
,"4":"and when I pray for you, I pray with joy."
,"5":"I cannot forget all you shared with me in the service of the Gospel, from the first day until now."
,"6":"Since God began such a good work in you, I am certain that he will complete it in the day of Christ Jesus."
,"7":"This is my hope for you, for I carry you all in my heart: whether I am in prison or defending and confirming the Gospel, you are with me and share the same grace."
,"8":"God knows that I love you dearly with the love of Christ Jesus,"
,"9":"and in my prayers I ask that your love may lead you each day to a deeper knowledge and clearer discernment,"
,"10":"that you may have good criteria for everything. So you may be pure of heart and come blameless to the day of Christ,"
,"11":"filled with the fruit of holiness which comes through Christ Jesus, for the glory and praise of God."
,"12":"I want you to know, brothers and sisters, that what has happened to me has served to advance the Gospel."
,"13":"Actually the whole praetorian guard, and even those outside the palace, know that I am in chains for Christ."
,"14":"And what is more, my condition as prisoner has encouraged most of our brothers who are now emboldened to proclaim the Word of God more openly and without fear."
,"15":"Some, it is true, are moved by envy and want to challenge me, but others preach Christ with a good intention."
,"16":"These latter are moved by love and realize that I am here to defend the Gospel."
,"17":"The others announce Christ to challenge me. They do not act with a pure intention but think they are making my prison more unbearable."
,"18":"But in any case, whether they are sincere or showing off, Christ is proclaimed and because of this I rejoice and have no regrets."
,"19":"I know that all this will be a grace for me because of your prayers and the help given by the Spirit of Christ."
,"20":"I am hopeful, even certain, that I shall not be ashamed. I feel as assured now, as before, that Christ will be exalted through my person, whether I live or die."
,"21":"For to me, to live is Christ, and even death is profitable for me."
,"22":"But if I am to go on living, I shall be able to enjoy fruitful labor. Which shall I choose?"
,"23":"So I feel torn between the two. I desire greatly to leave this life and to be with Christ, which will be better by far,"
,"24":"but it is necessary for you that I remain in this life."
,"25":"And because I am convinced of this, I know that I will stay and remain with you for your progress and happiness in the faith."
,"26":"I will surely come to you again, and give you more reason for being proud of belonging to Christ Jesus."
,"27":"Try, then, to adjust your lives according to the Gospel of Christ. May I see it when I come to you, and if I cannot come, may I at least hear that you stand firm in the same spirit, striving to uphold the faith of the Gospel with one heart."
,"28":"Do not be afraid of your opponents. This will be a sign that they are defeated and you are saved, that is saved by God."
,"29":"For through Christ you have been granted not only to believe in Christ but also to suffer for him."
,"30":"And you now share the same struggle that you saw I had and that I continue to have, as you know."
}`)
	CurrentBook.AddChapter(2, `{
"1":"If I may advise you in the name of Christ and if you can hear it as the voice of love; if we share the same spirit and are capable of mercy and compassion, then I beg of you"
,"2":"make me very happy: have one love, one spirit, one feeling,"
,"3":"do nothing through rivalry or vain conceit. On the contrary let each of you gently consider the others as more important than yourselves."
,"4":"Do not seek your own interest, but rather that of others."
,"5":"Let what was seen in Christ Jesus be seen in you:"
,"6":"Though being divine in nature, he did not claim in fact equality with God,"
,"7":"but emptied himself, taking on the nature of a servant, made in human likeness, and in his appearance found as a man."
,"8":"He humbled himself by being obedient to death, death on the cross."
,"9":"That is why God exalted him,and gave him the Name which outshines all names,"
,"10":"so that at the Name of Jesus all knees should bend,in heaven, on earth and among the dead,"
,"11":"and all tongues proclaim that Christ Jesus is the Lord,to the glory of God the Father."
,"12":"Therefore, my dearest friends, as you always obeyed me while I was with you, even more now that I am far from you, continue working out your salvation 'with fear and trembling.'"
,"13":"It is God who makes you not only wish but also carry out what pleases him."
,"14":"Do everything without grumbling,"
,"15":"so that without fault or blame, you will be children of God without reproach among a crooked and perverse generation. You are a light among them, like stars in the universe,"
,"16":"holding to the Word of life. I shall feel proud of you on the day of Christ on seeing that my effort and labor have not been in vain."
,"17":"And if I have to pour out my blood as an offering to celebrate your faith, I rejoice and continue to share your joy;"
,"18":"and you likewise should rejoice and share my joy."
,"19":"The Lord Jesus lets me hope that I may soon send you Timothy, and have news of you. With this I will feel encouraged."
,"20":"For I have no one so concerned for you as he is."
,"21":"Most follow their own interest, not those of Christ Jesus."
,"22":"But Timothy has proved himself, as you know. Like a son at the side of his father, he has been with me at the service of the Gospel."
,"23":"Because of that I hope to send him to you as soon as I see how things work out for me."
,"24":"Nevertheless the Lord lets me think that I myself shall be coming soon."
,"25":"I judged it necessary to send back to you Epaphroditus, who worked and fought at my side and whom you sent to help me in my great need."
,"26":"In fact, he missed you very much and was still more worried because you had heard of his sickness."
,"27":"He was indeed sick and almost died, but God took pity on him and on me, sparing me greater sorrow."
,"28":"And so I am eager to send him to you, so that on seeing him you will be glad and I will be at peace."
,"29":"Receive him then with joy, as is fitting in the Lord. Consider highly persons like him,"
,"30":"who almost died for the work of Christ; he risked his life to serve me on your behalf when you could not help me."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Finally, my brothers and sisters, rejoice in the Lord. It is not a burden for me to write again the same things, and for you it is safer. "
,"2":"Beware of the dogs, beware of the bad workers; beware of the circumcised."
,"3":"We are the true circumcised people since we serve according to the Spirit of God, and our confidence is in Christ Jesus rather than in our merits."
,"4":"I myself do not lack those human qualities in which people have confidence. If some of them seem to be accredited with such qualities, how much more am I!"
,"5":"I was circumcised when eight days old. I was born of the race of Israel, of the tribe of Benjamin; I am a Hebrew, born of Hebrews. With regard to the Law, I am a Pharisee,"
,"6":"and such was my zeal for the Law that I persecuted the Church. As for being righteous according to the Law, I was blameless."
,"7":"But once I found Christ, all those things that I might have considered as profit, I reckoned as loss."
,"8":"Still more, everything seems to me as nothing compared with the knowledge of Christ Jesus, my Lord. For his sake I have let everything fall away and I now consider all as garbage, if instead I may gain Christ."
,"9":"May I be found in him, without merit or holiness of my own for having fulfilled the Law, but with the holiness which comes through faith in Christ, the holiness given by God which depends on faith in Christ Jesus."
,"10":"May I know him and experience the power of his resurrection and share in his sufferings and become like him in his death,"
,"11":"and attain through this, God willing, the resurrection from the dead!"
,"12":"I do not believe I have already reached the goal, nor do I consider myself perfect, but I press on till I conquer Christ Jesus, as I have already been conquered by him."
,"13":"No, brothers and sisters, I do not claim to have claimed the prize yet. I say only this: forgetting what is behind me, I race forward and run towards the goal,"
,"14":"my eyes on the prize to which God has called us from above in Christ Jesus."
,"15":"Let all of us who claim to be perfect have the same way of thinking, but if there is something on which you differ, God will make it clear to you."
,"16":"In the meantime, let us hold on to what we have conquered."
,"17":"Unite in imitating me, brothers and sisters, and look at those who walk in our way of life."
,"18":"For many live as enemies of the cross of Christ. I have said it to you many times, and now I repeat it with tears:"
,"19":"they are heading for ruin; their belly is their god and they feel proud of what should be their shame. They only think of earthly things."
,"20":"For us, our citizenship is in heaven, from where we await the coming of our Savior, Jesus Christ, the Lord."
,"21":"He will transfigure our lowly body, making it like his own body, radiant in Glory, through the power which is his to submit everything to himself."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Therefore, my brothers and sisters, whom I love and long for, you my glory and crown, be steadfast in the Lord."
,"2":"I beg Evodia and Syntyche to agree with each other in the Lord."
,"3":"And you, Sycygus, my true companion, I beg you to help them. Do not forget that they have labored with me in the service of the Gospel, together with Clement and my other fellow-workers whose names are written in the Book of Life."
,"4":"Rejoice in the Lord always. I say it again: rejoice"
,"5":"and may everyone experience your gentle and understanding heart. The Lord is near:"
,"6":"do not be anxious about anything. In everything resort to prayer and supplication together with thanksgiving and bring your requests before God."
,"7":"Then the peace of God, which surpasses all understanding, will keep your hearts and minds in Christ Jesus."
,"8":"Finally, brothers and sisters, fill your minds with whatever is truthful, holy, just, pure, lovely and noble. Be mindful of whatever deserves praise and admiration."
,"9":"Put into practice what you have learned from me, what I passed on to you, what you heard from me or saw me doing, and the God of peace will be with you."
,"10":"I rejoice in the Lord because of your concern for me. You were indeed concerned for me before, but you had no opportunity to show it."
,"11":"I do not say this because of being in want; I have learned to manage with what I have."
,"12":"I know what it is to be in want and what it is to have plenty. I am trained for both: to be hungry or satisfied, to have much or little."
,"13":"I can do all things in him who strengthens me."
,"14":"However you did right in sharing my trials."
,"15":"You Philippians, remember that in the beginning, when we first preached the Gospel, after I left Macedonia you alone opened for me a debit and credit account,"
,"16":"and when I was in Thessalonica, twice you sent me what I needed."
,"17":"It is not your gift that I value but rather the interest increasing in your own account."
,"18":"Now I have enough and more than enough with everything Epaphroditus brought me on your behalf and which I received as 'fragrant offerings pleasing to God.'"
,"19":"God himself will provide you with everything you need, according to his riches, and show you his generosity in Christ Jesus."
,"20":"Glory to God, our Father, for ever and ever: Amen."
,"21":"Greet all who believe in Christ Jesus. The brothers and sisters with me greet you."
,"22":"All the believers here greet you, especially those from Caesar's household."
,"23":"The grace of Christ Jesus, the Lord, be with your spirit."
}`)

}
func EN_CCB_LoadNPRMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"From Paul, a servant of Jesus Christ, an apostle called and set apart for God's Good News,"
,"2":"the very promises he foretold through his prophets in the sacred Scriptures,"
,"3":"regarding his Son, who was born in the flesh a descendant of David,"
,"4":"and has been recognized as the Son of God endowed with Power, upon rising from the dead through the Holy Spirit. Through him, Jesus Christ, our Lord, "
,"5":"and for the sake of his Name, we received grace and mission in all the nations, for them to accept the faith:"
,"6":"All of you, the elected of Christ, are part of them, you, the beloved of God in Rome, called to be holy:"
,"7":"May God our Father, and the Lord Jesus Christ, give you grace and peace."
,"8":"First of all, I give thanks to my God through Jesus Christ for all of you, because your faith is spoken of all over the world."
,"9":"And God, whom I serve in spirit by announcing the Good News of his Son, is my witness that I remember you in my prayers at all times."
,"10":"I pray constantly that, if it is his will, he make it possible for me to visit you."
,"11":"I long to see you and share some spiritual blessings with you to strengthen you."
,"12":"In that way, we will encourage each other by sharing our common faith."
,"13":"You must know, brothers and sisters, that many times I have made plans to go to you, but till now I have been prevented."
,"14":"I would like to harvest some fruits among you, as I have done among other nations. Whether Greeks or foreigners, cultured or ignorant, I feel under obligation to all."
,"15":"Hence my eagerness to give the message also to you who are in Rome."
,"16":"For I am not ashamed at all of this Good News; it is God's power saving those who believe, first the Jews, and then the Greeks."
,"17":"This Good News shows us how God makes people upright through faith for the life of faith, as the Scripture says: The upright one shall live by faith."
,"18":"God is now ready to condemn the wickedness and any kind of injustice of those who have silenced the truth by their wicked ways."
,"19":"For everything that could have been known about God was clear to them: God himself made it plain."
,"20":"For, though we cannot see him, we can at least discover him through his works; for he created the world and through his works we understand him to be eternal and all-powerful, and to be God. So they have no excuse, "
,"21":"for they knew God and did not glorify him as was fitting, nor did they give thanks to him. On the contrary, they lost themselves in their reasoning and darkness filled their minds."
,"22":"Believing themselves wise, they became foolish:"
,"23":"they exchanged the Glory of the immortal God for the likes of mortal human beings, birds, animals and reptiles."
,"24":"Because of this God gave them up to their inner cravings; they did shameful things and dishonored their bodies."
,"25":"They exchanged God's truth for a lie; they honored and worshiped created things instead of the Creator, to whom be praise for ever, Amen!"
,"26":"Because of that, God gave them up to shameful passions: their women exchanged natural sexual relations for unnatural ones."
,"27":"Similarly, the men, giving up natural sexual relations with women, were lustful of each other, they did, men with men, shameful things, bringing upon themselves the punishment they deserve for their wickedness."
,"28":"And since they did not think that God was worth knowing, he gave them up to their senseless minds so that they committed all kinds of obscenities."
,"29":"And so they are full of injustice, perversity, greed, evil; they are full of jealousy, murder, strife, deceit, bad will and gossip."
,"30":"They commit calumny, offend God, are haughty; they are proud, liars, clever in doing evil. They are rebellious towards their parents,"
,"31":"senseless, disloyal, cold-hearted and merciless."
,"32":"They know of God's judgment which declares worthy of death anyone living in this way; yet not only do they do all these things, they even applaud anyone who does the same."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Therefore, you have no excuse, whoever you are, if you are able to judge others. For in judging your neighbor, you condemn yourself, for you practice what you are judging."
,"2":"We know that the condemnation of God will justly reach those who commit these things,"
,"3":"and do you think that by condemning others you will escape from the judgment of God, you who are doing the same?"
,"4":"This would be taking advantage of God and his infinite goodness, patience and understanding, and not to realize that his goodness is in order to lead you to conversion."
,"5":"If your heart becomes hard and you refuse to change, then you are storing for yourself a great punishment on the day of judgment, when God will appear as just judge."
,"6":"He will give each one his due, according to his actions."
,"7":"He will give everlasting life to those who seek glory, honor and immortality and persevere in doing good."
,"8":"But anger and vengeance will be the lot of those who do not serve truth but injustice."
,"9":"There will be suffering and anguish for everyone committing evil, first the Jew, then the Greek."
,"10":"But God will give glory, honor and peace to whoever does good, first the Jew then the Greek,"
,"11":"because one is not different from the other before God."
,"12":"Those who, without knowing the Law, committed sin, will perish without the Law, and whoever committed sin knowing the Law, will be judged by that Law."
,"13":"What makes us righteous before God is not hearing the Law, but obeying it."
,"14":"When the non-Jews, who do not have law, practice naturally what the Law commands, they are giving themselves a law,"
,"15":"showing that the commandments of the Law are engraved in their minds. Their conscience, speaking within them also shows it, when they condemn or approve their actions."
,"16":"The same is to happen on the day when God, according to my gospel, will judge people's secret actions in the person of Jesus Christ."
,"17":"But suppose you call yourself a Jew: you have the Law as foundation and feel proud of your God."
,"18":"You know the will of God and the Law teaches you to distinguish what is better,"
,"19":"and so you believe you are the guide for the blind, light in darkness,"
,"20":"teacher of those who do not know, instructor of children, because you possess in the Law the formulation of true knowledge."
,"21":"Well, then, you who teach others, why don't you teach yourself? If you say that one must not steal, why do you steal?"
,"22":"You say one must not commit adultery, yet you commit it! You say you hate idols, but you steal in their temples!"
,"23":"You feel proud of the Law, yet you do not obey it, and you dishonor your God."
,"24":"In fact, as the Scriptures say, the other nations despise the name of God because of you."
,"25":"Circumcision is of value to you if you obey the Law; but if you do not obey, it is as if you were not circumcised."
,"26":"On the contrary, if those who are uncircumcised obey the commandments of the Law, do you not think that, in spite of being pagans, they make themselves like the circumcised?"
,"27":"The one who obeys the Law without being marked in his body with circumcision, will judge you who have been marked with circumcision and who have the Law which you do not obey."
,"28":"For external things do not make a true Jew nor is real circumcision that which is marked on the body."
,"29":"A Jew must be so interiorly; the heart's circumcision belongs to spirit and not to a written law; he who lives in this way will be praised, not by people, but by God."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Then, what is the advantage of being a Jew? And what is the use of circumcision?"
,"2":"It is important from any point of view. In the first place, it was to the Jews that God entrusted his word."
,"3":"Well now, if some of them were not faithful, will their unfaithfulness do away with the faithfulness of God? Of course not."
,"4":"Rather, it will be proved that God is truthful, every human a liar, as the Scripture says: it will be proved that your words are true and you will be winner if they want to judge you."
,"5":"If our wickedness shows God to be just, would it be right to say that God is unjust when he gets angry and punishes us? (Some people might speak like this.)"
,"6":"- Not at all because, otherwise, how could God judge the world?"
,"7":"- But if my lie makes the truth of God more evident, thus increasing his glory, is it correct to call me a sinner?"
,"8":"- Then, your only choice would be to sin, so that good may come of it. Some slanderers say that this is my teaching, but they will have to answer for those words."
,"9":"Do we have, then, any advantage? Not really. For we have just demonstrated that all, Jews and non-Jews, are under the power of sin,"
,"10":"as the Scripture says: Nobody is good, not even one,"
,"11":"no one understands, no one looks for God."
,"12":"All have gone astray and have become base. There is no one doing what is good, not even one."
,"13":"Their throats are open tombs, their words deceit."
,"14":"Their lips hide poison of vipers, from their mouth come bitter curses."
,"15":"They run to where they can shed blood,"
,"16":"leaving behind ruin and misery."
,"17":"They do not know the way of peace,"
,"18":"There is no fear of God before their eyes."
,"19":"Now we know that whatever the Scripture says, it is said for the people of the Law, that is for the Jews. Let all be silent then and recognize that the whole world is guilty before God."
,"20":"Still more: no mortal will be worthy before God by performing the demands of the Law. What comes from the Law is the consciousness of sin."
,"21":"Yet, now we are told how God makes us just as he wants us to be without the Law. This was already foretold in the Law and the Prophets:"
,"22":"God makes us righteous by means of faith in Jesus Christ, and this is applied to all who believe, without distinction of persons."
,"23":"Because all have sinned and all fall short of the Glory of God;"
,"24":"and all are graciously forgiven and made righteous through the redemption effected in Christ Jesus."
,"25":"For God has given him to be the victim whose blood obtains us forgiveness through faith. So God shows us how he makes us righteous. Past sins are forgiven "
,"26":"which God overlooked till now. For now he wants to reveal his way of righteousness: how he is just and how he makes us righteous through faith in Jesus."
,"27":"Then what becomes of our pride? It is excluded. How? Not through the Law and its observances, but through another law which is faith."
,"28":"For we hold that people are in God's grace by faith and not because of all the things ordered by the Law."
,"29":"Otherwise, God would be the God of the Jews; but is he not God of pagan nations as well?"
,"30":"Of course he is, for there is only one God and he will save by faith the circumcised Jews as well as the uncircumcised nations."
,"31":"Do we, then, deny the value of the Law because of what we say of faith? Of course not; rather we place the Law in its proper place."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Let us consider Abraham, our father in the flesh. What has he found?"
,"2":"If Abraham attained righteousness because of his deeds, he could be proud. But he cannot be this before God."
,"3":"Because Scripture says: Abraham believed God who took into account and held him to be a just man."
,"4":"Now, when someone does a work, salary is not given as a favor, but as a debt that is paid."
,"5":"Here, on the contrary, someone who has no deeds to show but believes in Him who makes sinners righteous before him: such faith is taken into account and that person is held as righteous."
,"6":"David congratulates in this way those who become righteous by the favor of God, and not by their actions:"
,"7":"Blessed are those whose sins are forgiven and whose offenses are forgotten;"
,"8":"blessed the one whose sin God does not take into account!"
,"9":"Is this blessing only for the circumcised or is it also for the uncircumcised? We have just said that, because of his faith, Abraham was made a just man,"
,"10":"but when did this happen? After Abraham was circumcised, or before? Not after, but before."
,"11":"He received the rite of circumcision as a sign of the righteousness given him through faith when he was still uncircumcised, that he might be the father of all those uncircumcised who come to faith and are made just."
,"12":"And he was to be the father of the Jews, provided that besides being circumcised, they also imitate the faith Abraham showed before being circumcised."
,"13":"If God promised Abraham, or rather his descendant, that the world would belong to him, this was not because of his obeying the Law, but because he was just and a friend of God through faith."
,"14":"If now the promise is kept for those who rely on the Law, then faith has no power and nothing is left of the promise."
,"15":"For it is proper of the Law to bring punishment: law and condemnation go together."
,"16":"For that reason, faith is the way and all is given by grace; and the promises of Abraham are fulfilled for all his descendants, not only for his children according to the Law, but also for all the others who have believed. Abraham is the father of all of us, "
,"17":"as it is written: I will make you father of many nations. He is our father in the eyes of Him who gives life to the dead, and calls the non-existent as if already existing, for this is the God in whom he believed."
,"18":"Abraham believed and hoped against all expectation, thus becoming father of many nations, as he had been told: See how many will be your descendants."
,"19":"He did not doubt although his body could no longer give life - he was about a hundred years old - and in spite of his wife Sarah being unable to have children."
,"20":"He did not doubt nor did he distrust the promise of God, and by being strong in faith, he gave glory to God:"
,"21":"he was convinced that He who had given the promise had power to fulfill it."
,"22":"This was taken into account for him to attain righteousness."
,"23":"This was taken into account: these words of Scripture are not only for him,"
,"24":"but for us, too, because we believe in Him who raised Jesus, our Lord, from among the dead,"
,"25":"he who was delivered for our sins and raised to life for us to receive true righteousness."
}`)
	CurrentBook.AddChapter(5, `{
"1":"By faith we have received true righteousness, and we are at peace with God, through Jesus Christ, our Lord."
,"2":"Through him we obtain this favor in which we remain and we even boast to expect the Glory of God."
,"3":"Not only that, we feel secure even in trials, knowing that trials produce patience,"
,"4":"from patience comes merit, merit is the source of hope,"
,"5":"and hope does not disappoint us because the Holy Spirit has been given to us, pouring into our hearts the love of God."
,"6":"Consider, moreover, the time that Christ died for us: when we were still sinners and unable to do anything."
,"7":"Few would accept to die for an upright person; although, for a very good person, perhaps someone would dare to die."
,"8":"But see how God manifested his love for us: while we were still sinners, Christ died for us"
,"9":"and we have become just through his blood. With much more reason now he will save us from any condemnation."
,"10":"Once enemies, we have been reconciled with God through the death of his Son; with much more reason now we may be saved through his life."
,"11":"Not only that; we feel secure in God because of Christ Jesus, our Lord, through whom we have been reconciled."
,"12":"Now, sin entered the world through one man and through sin, death, and later on death spread to all humankind, because all sinned."
,"13":"As long as there was no law, they could not speak of disobedience, but sin was already in the world."
,"14":"This is why from Adam to Moses death reigned among them, although their sin was not disobedience as in Adam's case - this was not the true Adam, but foretold the other who was to come."
,"15":"Such has been the fall, but God's gift goes far beyond. Multitudes die because of the fault of one man, but how much more does the grace of God spread when the gift he granted reaches the multitudes, from this unique man Jesus Christ."
,"16":"The gift of God more than compensated for sin. The disobedience that brought condemnation was of one sinner, whereas the grace of God brings forgiveness to a world of sinners."
,"17":"If death reigned through the disobedience of one and only one person, how much more will there be a reign of life for those who receive the grace and the gift of true righteousness through the one person, Jesus Christ."
,"18":"Just as one transgression brought sentence of death to all, so, too, one rehabilitation brought pardon and life to all;"
,"19":"and as the disobedience of only one made many sinners, so the obedience of one person allowed a multitude to be made just and holy."
,"20":"The Law itself, introduced later on, caused sin to increase; but where sin increased, grace abounded all the more,"
,"21":"and as sin caused death to reign, so grace will reign in its own time, and after making us just and friends of God, will bring us to eternal life through Jesus Christ, our Lord."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Then, what shall we say? Shall we keep on sinning so that grace may come more abundantly?"
,"2":"Can we live again in sin? Of course not: we are now dead regarding sin."
,"3":"You know that in baptism which unites us to Christ we are all baptized and plunged into his death."
,"4":"By this baptism in his death, we were buried with Christ, and, as Christ was raised from among the dead by the Glory of the Father, so we begin walking in a new life."
,"5":"It was an image of his death when we were grafted in him, and so we will also share in his resurrection."
,"6":"We know that our old self was crucified with Christ, so as to destroy what of us was sin, so that we may no longer serve sin -"
,"7":"if we are dead, we are no longer in debt to sin."
,"8":"But if we have died with Christ, we believe we will also live with him."
,"9":"We know that Christ, once risen from the dead, will not die again and death has no more dominion over him."
,"10":"There has been death: a death to sin once for all; there is life: a life in God."
,"11":"So you, too, must consider yourselves dead to sin and alive to God in Christ Jesus."
,"12":"Do not allow sin any control over your mortal being; do not submit yourselves to its evil inclinations,"
,"13":"and do not give your members over to sin, as instruments to do evil. On the contrary, offer yourselves as persons returned from death to life, and let the members of your body be as holy instruments at the service of God."
,"14":"Sin will not lord it over you again, for you are not under the law, but under grace."
,"15":"I ask again: are we to sin because we are not under the Law, but under grace? Certainly not."
,"16":"If you have given yourselves up to someone as his slave, you are to obey the one who commands you, aren't you? Now with sin you go to death, and by accepting faith you go the right way."
,"17":"Let us give thanks to God for, after having sin as your master, you have been given to another, that is, to the doctrine of faith, to which you listen willingly."
,"18":"And being free from sin, you began to serve true righteousness -"
,"19":"you see that I speak in a very human way, taking into account that you are not fully mature. There was a time when you let your members be slaves of impurity and disorder, walking in the way of sin; convert them now into servants of righteousness, to the point of becoming holy."
,"20":"When you were slaves of sin, you did not feel under obligation to righteousness,"
,"21":"but what were the fruits of those actions of which you are now ashamed? Such things bring death."
,"22":"Now, however, you have been freed from sin and serve God. You are bearing fruit and growing in holiness, and the result will be life everlasting."
,"23":"So on one side is Sin: its reward, death; on the other side is God: he gives us, by grace, life everlasting in Christ Jesus, our Lord."
}`)
	CurrentBook.AddChapter(7, `{
"1":"You, my friends, understand law. The law has power only while a person is alive."
,"2":"The married woman, for example, is bound by law to her husband while he is alive; but if he dies, she is free from her obligations as a wife."
,"3":"If she gives herself to another while her husband is alive, she will be an adulteress; but once the husband dies, she is free and if she gives herself to another man, she is not an adulteress."
,"4":"It was the same with you, brothers and sisters: you have died to the Law with the person of Christ, and you belong to another, who has risen from among the dead, so that we may produce fruit for God."
,"5":"When we lived as humans used to do, the Law stirred up the desires for all that is sin, and they worked in our bodies with fruits of death."
,"6":"But we have died to what was holding us; we are freed from the Law and no longer serve a written law - which was the old; with the Spirit we are in the new."
,"7":"Then, shall we say that the Law is part of sin? Of course not. However, I would not have known Sin, had it not been through the Law. I would not be aware of greed if the Law did not tell me: Do not covet."
,"8":"Sin took advantage of the commandment to stir in me all kinds of greed; whereas, without a Law, Sin lies dead."
,"9":"First there was no Law and I lived. Then the commandment came and gave life to Sin:"
,"10":"and I died. It happened that the Law of life had brought me death."
,"11":"Sin took advantage of the commandment: it lured me and killed me through the commandment."
,"12":"But the Law itself is holy, just and good."
,"13":"Is it possible that something good brings death to me? Of course not. This comes from Sin which may be seen as sin when it takes advantage of something good to kill: the commandment let Sin appear fully sinful."
,"14":"We know that the Law is spiritual; as for me, I am flesh and have been sold to sin."
,"15":"I cannot explain what is happening to me, because I do not do what I want, but on the contrary, the very things I hate."
,"16":"Well then, if I do the evil I do not want to do, I agree that the Law is good;"
,"17":"but, in this case, I am not the one striving toward evil, but it is sin, living in me."
,"18":"I know that what is right does not abide in me, I mean, in my flesh. I can want to do what is right, but I am unable to do it."
,"19":"In fact I do not do the good I want, but the evil I hate."
,"20":"Therefore, if I do what I do not want to do, I am not the one striving towards evil, but Sin which is in me."
,"21":"I discover, then, this reality: though I wish to do what is right, the evil within me asserts itself first."
,"22":"My inmost self agrees and rejoices with the law of God,"
,"23":"but I notice in my body another law challenging the law of the spirit, and delivering me as a slave to the law of sin written in my members."
,"24":"Alas, for me! Who will free me from this being which is only death?"
,"25":"Let us give thanks to God through Jesus Christ, our Lord!,So, with my conscience I am a servant of the law of God, and with my mortal I serve the law of sin."
}`)
	CurrentBook.AddChapter(8, `{
"1":"This contradiction no longer exists for those who are in Jesus Christ."
,"2":"For, in Jesus Christ, the law of the Spirit of life has set me free from the law of sin and death."
,"3":"The Law was without effect because flesh was not responding. Then God, planning to destroy sin, sent his own Son, in the likeness of those subject to the sinful human condition; by doing this, he condemned the sin in this human condition."
,"4":"Since then the perfection intended by the Law would be fulfilled in those not walking in the way of the flesh, but in the way of the Spirit."
,"5":"Those walking according to the flesh tend towards what is flesh; those led by the spirit, to what is spirit."
,"6":"Flesh tends towards death, while spirit aims at life and peace."
,"7":"What the flesh seeks is against God: it does not agree, it cannot even submit to the law of God."
,"8":"So, those walking according to the flesh cannot please God."
,"9":"Yet your existence is not in the flesh, but in the spirit, because the Spirit of God is within you. If you did not have the Spirit of Christ, you would not belong to him."
,"10":"But Christ is within you; though the body is branded by death as a consequence of sin, the spirit is life and holiness."
,"11":"And if the Spirit of Him who raised Jesus from the dead is within you, He who raised Jesus Christ from among the dead will also give life to your mortal bodies. Yes, he will do it through his Spirit who dwells within you."
,"12":"Then, brothers, let us leave the flesh and no longer live according to it."
,"13":"If not, we will die. Rather, walking in the Spirit, let us put to death the body's deeds so that we may live."
,"14":"All those who walk in the Spirit of God are sons and daughters of God."
,"15":"Then, no more fear: you did not receive a spirit of slavery, but the Spirit that makes you sons and daughters and every time we cry, 'Abba! (this is Dad!) Father!'"
,"16":"the Spirit assures our spirit that we are sons and daughters of God."
,"17":"If we are children, we are heirs, too. Ours will be the inheritance of God and we will share it with Christ; for if we now suffer with him, we will also share Glory with him."
,"18":"I consider that the suffering of our present life cannot be compared with the Glory that will be revealed and given to us."
,"19":"All creation is eagerly expecting the birth in glory of the children of God."
,"20":"For if now the created world was unable to attain its purpose, this did not come from itself, but from the one who subjected it. But it is not without hope;"
,"21":"for even the created world will be freed from this fate of death and share the freedom and glory of the children of God."
,"22":"We know that the whole creation groans and suffers the pangs of birth."
,"23":"Not creation alone, but even ourselves, although the Spirit was given to us as a foretaste of what we are to receive, we groan in our innermost being, eagerly awaiting the day when God will give us full rights and rescue our bodies as well."
,"24":"To hope is the way we are saved. But if we saw what we hoped for, there would no longer be hope: how can you hope for what is already seen?"
,"25":"So we hope for what we do not see and we will receive it through patient hope."
,"26":"We are weak, but the Spirit comes to help us. How to ask? And what shall we ask for? We do not know, but the spirit intercedes for us without words, as if with groans."
,"27":"And He who sees inner secrets knows the desires of the Spirit, for he asks for the holy ones what is pleasing to God."
,"28":"We know that in everything God works for the good of those who love him, whom he has called according to his plan."
,"29":"Those whom he knew beforehand, he has also predestined to be like his Son, similar to him, so that he may be the Firstborn among many brothers and sisters."
,"30":"And so, those whom God predestined he called, and those whom he called he makes righteous, and to those whom he makes righteous he will give his Glory."
,"31":"What shall we say after this? If God is with us, who shall be against us?"
,"32":"If he did not spare his own Son, but gave him up for us all, how will he not give us all things with him?"
,"33":"Who shall accuse those chosen by God: he takes away their guilt."
,"34":"Who will dare to condemn them? Christ who died, and better still, rose and is seated at the right hand of God, interceding for us?"
,"35":"Who shall separate us from the love of Christ? Will it be trials, or anguish, persecution or hunger, lack of clothing, or dangers or sword?"
,"36":"As the Scripture says: For your sake we are being killed all day long; they treat us like sheep to be slaughtered."
,"37":"No, in all of this we are more than conquerors, thanks to him who has loved us."
,"38":"I am certain that neither death nor life, neither angels nor spiritual powers, neither the present nor the future, nor cosmic powers,"
,"39":"were they from heaven or from the deep world below, nor any creature whatsoever will separate us from the love of God, which we have in Jesus Christ, our Lord."
}`)
	CurrentBook.AddChapter(9, `{
"1":"I tell you sincerely in Christ, and my conscience assures me in the Holy Spirit that I am not lying:"
,"2":"I have great sadness and constant anguish for the Jews."
,"3":"I would even desire that I myself suffer the curse of being cut off from Christ, instead of my brethren: I mean my own people, my kin."
,"4":"They are Israelites whom God adopted, and on them rests his Glory. Theirs are the covenants, the Law, the worship and the promises of God."
,"5":"They are descendants of the Patriarchs and from their race Christ was born, he who as God is above all distinctions. Blessed be He forever and ever: Amen!"
,"6":"We cannot say that the promise of God has failed. For not all Israelites belong to Israel."
,"7":"And not because they are of the race of Abraham are they all his children, for it was said to him: The children of Isaac will be called your descendants."
,"8":"This means that the children of God are not identified with the race of Abraham, but only with the children born to him because of the promise of God."
,"9":"To such a promise this text refers: I shall return about this time and Sarah will have a son."
,"10":"And listen: Rebecca, the wife of our father Isaac, became pregnant,"
,"11":"and before the twins were born, or had done anything right or wrong, in order that God's purpose of election might continue,"
,"12":"not on the merits but of who is called, she was told: The elder will serve the younger,"
,"13":"as the Scripture says: I chose Jacob and rejected Esau."
,"14":"Shall we say that God is unjust? Of course not."
,"15":"However God said to Moses: I shall forgive whom I forgive and have pity on whom I have pity."
,"16":"So what is important is not that we worry or hurry, but that God has compassion."
,"17":"And he says in Scripture to Pharaoh: I made you Pharaoh to show my power in you, and for the whole world to know my name."
,"18":"And so God takes pity on whom he wishes, and hardens the heart of whomsoever he wishes."
,"19":"Maybe you say: 'Why then does God complain, if it is impossible to evade his decision?'"
,"20":"But you, my friend, who are you to call God to account? Should the clay pot say to its maker: Why did you make me like this?"
,"21":"Is it not up to the potter to make from the same clay a vessel for beauty and a vessel for menial use?"
,"22":"Thus God endures very patiently vessels that deserve his wrath, fit to be broken, and through them he wants to show his wrath and the extent of his power."
,"23":"But he also wants to show the riches of his Glory in others, in vessels of mercy prepared for glory."
,"24":"And he called us, not only from among the Jews, but from among the pagans, too,"
,"25":"as he said through the prophet Hosea: I will call 'my people' those that were not my people, and 'my beloved' the one who was not beloved."
,"26":"And in the same place where they were told: 'You are not my people,' they will be called children of the living God."
,"27":"With regard to Israel, Isaiah proclaims: Even if the Israelites are as numerous as the sand of the sea, only a few will be saved."
,"28":"This is a matter that the Lord will settle in Israel without fail or delay."
,"29":"Isaiah also announced: If the Almighty Lord had not left us some descendants, we would have become like Sodom and similar to Gomorrah."
,"30":"What are we saying, then? That the pagans who were not aiming at true righteousness found it (I speak of righteousness through faith);"
,"31":"while Israel, striving to observe a law of righteousness, lost the purpose of the Law."
,"32":"Why? Because they relied on the observance of the Law, not on faith. And they stumbled over the stumbling stone (Christ),"
,"33":"as it was said: Look, I am laying in Zion a stone that will make people stumble, a rock that will make them fall; but whoever relies on him will not be deceived."
}`)
	CurrentBook.AddChapter(10, `{
"1":"My brothers and sisters, I wish with all my heart that the Jews be saved and I pray God for them."
,"2":"I can testify that they are zealous for God, but this is not the way."
,"3":"They don't know God's way of righteousness and they try to achieve their own righteousness: this is why they did not enter God's way of righteousness."
,"4":"For Christ is the aim of the Law and it is then that the believer reaches this righteousness."
,"5":"Moses, indeed, speaks of becoming just through the Law; he writes: The one who obeys the Law will find life through it."
,"6":"But the righteousness coming from the faith says instead: Do not say in your heart: Who will go up to heaven? (because in fact Christ came down from there)"
,"7":"or who will go down to the world below? (because in fact Christ came up from among the dead)."
,"8":"True righteousness coming from faith also says: The word of God is near you, on your lips and in your hearts. This is the message that we preach, and this is faith."
,"9":"You are saved if you confess with your lips that Jesus is Lord and in your heart you believe that God raised him from the dead."
,"10":"By believing from the heart, you obtain true righteousness; by confessing the faith with your lips you are saved."
,"11":"For Scripture says: No one who believes in him will be ashamed."
,"12":"Here there is no distinction between Jew and Greek; all have the same Lord, who is very generous with whoever calls on him."
,"13":"Truly, all who call upon the name of the Lord will be saved."
,"14":"But how can they call upon the name of the Lord without having believed in him? And how can they believe in him without having first heard about him? And how will they hear about him if no one preaches about him?"
,"15":"And how will they preach about him if no one sends them? As Scripture says: How beautiful to see those coming to bring good news."
,"16":"Although not everyone obeyed the good news, as Isaiah said: Lord, who has believed in our preaching?"
,"17":"So, faith comes from preaching, and preaching is rooted in the word of Christ."
,"18":"I ask: Have the Jews not heard? But of course they have. Because the voice of those preaching resounded all over the earth and their voice was heard to the ends of the world."
,"19":"Then I must ask: Did Israel not understand? Moses was the first to say: I will make you jealous of a nation that is not a nation, I will excite your anger against a crazy nation."
,"20":"Isaiah dares to add more: I was found by those not looking for me, I have shown myself to those not asking for me."
,"21":"While referring to Israel, the same Isaiah says: I hold out my hands the whole day long to a disobedient and rebellious people."
}`)
	CurrentBook.AddChapter(11, `{
"1":"And so I ask: Has God rejected his people? Of course not. I myself am an Israelite, a descendant of Abraham, from the tribe of Benjamin."
,"2":"No, God has not rejected the people he knew beforehand. Don't you know what the Scripture says of Elijah when he was accusing Israel before God?"
,"3":"He said: 'Lord, they have killed your prophets, destroyed your altars, and I alone remain; and now they want to kill me.'"
,"4":"What was God's answer? 'I kept for myself seven thousand who did not worship Baal.'"
,"5":"In the same way now there is a remnant in Israel, those who were chosen by grace."
,"6":"It is said: by grace, not because of what they did. Otherwise grace would not be grace."
,"7":"What then? What Israel was looking for, it did not find, but those whom God elected found it. The others hardened their hearts,"
,"8":"as Scripture says: God made them dull of heart and mind; to this day their eyes cannot see nor their ears hear."
,"9":"David says: May they be caught and trapped at their banquets; may they fall, may they be punished."
,"10":"May their eyes be closed so that they cannot see and their backs be bent forever."
,"11":"Again I ask: Did they stumble so as to fall? Of course not. Their stumbling allowed salvation to come to the pagan nations and this, in turn, will stir up the jealousy of Israel."
,"12":"If Israel's shortcoming made the world rich, if the pagan nations grew rich with what they lost, what will happen when Israel is restored?"
,"13":"Listen to me, you who are not Jews: I am spending myself as an apostle to the pagan nations,"
,"14":"but I hope my ministry will be successful enough to awaken the jealousy of those of my race, and finally to save some of them."
,"15":"If the world made peace with God when they remained apart, what will it be when they are welcomed? Nothing less than a passing from death to life."
,"16":"When the first fruits are consecrated to God, the whole is consecrated. If the roots are holy, so will be the branches."
,"17":"Some branches have been cut from the olive tree, while you, as a wild olive tree, have been grafted in their stead, and you are benefiting from their roots and sap."
,"18":"Now therefore, do not be proud and despise the branches, because you do not support the roots, the roots support you."
,"19":"You may say, 'They cut off the branches to graft me.'"
,"20":"Well and good. But they were cut off because they did not believe, while you stand by faith. Then do not pride yourself on this too much, rather beware:"
,"21":"if God did not spare the natural branches, even less will he spare you."
,"22":"Admire at the same time both the goodness and severity of God: he was severe with the fallen and he is generous with you, as long as you remain faithful. Otherwise you will be cut off."
,"23":"If they do not keep on rejecting the faith they will be grafted in, for God is able to graft them back again."
,"24":"If you were taken from the wild olive tree to which you belonged and, in spite of being a different species, you were grafted into the good olive tree, it will be much easier and natural for them to be grafted into their own tree."
,"25":"I want you to understand the mysterious decree of God, lest you be too confident: a part of Israel will remain hardened until the majority of pagans have entered."
,"26":"Then the whole of Israel will be saved, as Scripture says: From Zion will come the Liberator who will purify the descendants of Jacob from all sin."
,"27":"And this is the covenant I will make with them: I will take away from them their sins."
,"28":"Regarding the Gospel, the Jews are opponents, but it is for your benefit. Regarding election, they are beloved because of their ancestors;"
,"29":"because the call of God and his gifts cannot be nullified."
,"30":"Through the rebellion of the Jews the mercy of God came to you who did not obey God."
,"31":"They in turn will receive mercy in due time after this rebellion that brought God's mercy to you."
,"32":"So God has submitted all to disobedience, in order to show his mercy to all."
,"33":"How deep are the riches, the wisdom and knowledge of God! His decisions cannot be explained, nor his ways understood!"
,"34":"Who has ever known God's thoughts? Who has ever been his adviser?"
,"35":"Who has given him something first, so that God had to repay him?"
,"36":"For everything comes from him, has been made by him and has to return to him. To him be the glory for ever! Amen."
}`)
	CurrentBook.AddChapter(12, `{
"1":"I beg you, dearly beloved, by the mercy of God, to give yourselves as a living and holy sacrifice pleasing to God: such is the worship of a rational being."
,"2":"Don't let yourselves be shaped by the world where you live, but rather be transformed through the renewal of your mind. You must discern the will of God: what is good, what pleases, what is perfect."
,"3":"The grace that God has given me allows me to tell each of you: be active, but not indiscreet. Let each one exercise wisely the gifts of faith granted by God."
,"4":"See, the body is one, even if formed by many members, but not all of them with the same function."
,"5":"The same with us; being many, we are one body in Christ, depending on one another."
,"6":"Let each one of us, therefore, serve according to our different gifts. Are you a prophet? Then give the insights of faith."
,"7":"Let the deacon fulfill his office; let the teacher teach,"
,"8":"the one who encourages, convince. You must, likewise, give with an open hand, preside with dedication, and be cheerful in your works of charity."
,"9":"Let love be sincere. Hate what is evil and hold to whatever is good."
,"10":"Love one another and be considerate. Outdo one another in mutual respect."
,"11":"Be zealous in fulfilling your duties. Be fervent in the Spirit and serve God."
,"12":"Have hope and be cheerful. Be patient in trials and pray constantly."
,"13":"Share with other Christians in need. With those passing by, be ready to receive them."
,"14":"Bless those who persecute you; bless and do not wish evil on anyone."
,"15":"Rejoice with those who are joyful, and weep with those who weep."
,"16":"Live in peace with one another. Do not dream of extraordinary things; be humble and do not hold yourselves as wise."
,"17":"Do not return evil for evil, but let everyone see your good will."
,"18":"Do your best to live in peace with everybody."
,"19":"Beloved, do not avenge yourselves, but let God be the one who punishes, as Scripture says: Vengeance is mine, I will repay, says the Lord."
,"20":"And it adds: If your enemy is hungry, feed him; if he is thirsty, give him to drink; by doing this you will heap burning coals upon his head."
,"21":"Do not let evil defeat you, but conquer evil with goodness."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Let everyone be subject to the authorities. For there is no authority that does not come from God, and the offices have been established by God."
,"2":"Whoever, therefore, resists authority goes against a decree of God, and those who resist deserve to be condemned."
,"3":"In fact, who fears authority? Not those who do good, but those who do evil. Do you want to be without fear of a person in authority? Do good and you will receive praise."
,"4":"They are the stewards of God for your good. But if you do not behave, fear them for they do not carry arms in vain; they are at the service of God when they judge and punish wrongdoers."
,"5":"It is necessary to obey, not through fear but as a matter of conscience."
,"6":"In the same way you must pay taxes, and the collectors are God's officials."
,"7":"Pay to all what is due them; to whomever you owe contributions, make a contribution; to whom taxes are due, pay taxes; to whom respect is due, give respect; to whom honor is due, give honor."
,"8":"Do not be in debt to anyone. Let this be the only debt of one to another: Love. The one who loves his or her neighbor fulfilled the Law."
,"9":"For the commandments: Do not commit adultery, do not kill, do not covet and whatever else are summarized in this one: You will love your neighbor as yourself."
,"10":"Love cannot do the neighbor any harm; so love fulfills the whole Law."
,"11":"You know what hour it is. This is the time to awake, for our salvation is now nearer than when we first believed;"
,"12":"the night is almost over and day is at hand. Let us discard, therefore, everything that belongs to darkness, and let us put on the armor of light."
,"13":"As we live in the full light of day, let us behave with decency; no banquets with drunkenness, no prostitution or vices, no fighting or jealousy."
,"14":"Put on, rather, the Lord Jesus Christ, and do not be led by the will of the flesh nor follow its desires."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Welcome those weak in faith and do not criticize their scruples."
,"2":"Some think they can eat any food, while others, less liberated, eat only vegetables."
,"3":"If you eat, do not despise those who abstain; if you abstain, do not criticize those who eat, for God has welcomed them."
,"4":"Who are you to pass judgment on the servant of another? Whether he stands or falls, the one concerned is his master. But he will not fall, for his master is able to keep him standing."
,"5":"For some, there are good and bad days; for others, all days are equal. Let us act according to our own opinion."
,"6":"The one who distinguishes among days does that for the Lord; and the one who eats eats for the Lord and in eating gives thanks to the Lord. And the one who does not eat does it for the Lord and gives him thanks as well."
,"7":"In fact, none of us lives for himself, nor dies for himself."
,"8":"If we live, we live for the Lord, and if we die, we die for the Lord. Either in life or in death, we belong to the Lord;"
,"9":"Christ experienced death and life to be Lord both of the living and of the dead."
,"10":"Then you, why do you criticize your brother or sister? And you, why do you despise them? For we will all appear at the tribunal of God."
,"11":"It is written: I swear by myself - word of the Lord - every knee will bend before me, and every tongue shall confess truth before God."
,"12":"So each of us will account for himself before God."
,"13":"Therefore, let us not continue criticizing one another; let us try, rather, never to put in the way of our brother anything that would make him stumble or fall."
,"14":"I know, I am sure of this in the Lord Jesus, that nothing is unclean in itself, it is only unclean for those who consider it unclean."
,"15":"But if you hurt your brother or sister because of a certain food, you are no longer walking according to love. Let not your eating cause the loss of one for whom Christ died."
,"16":"Don't put yourself in the wrong with something good."
,"17":"The kingdom of God is not a matter of food or drink; it is justice, peace and joy in the Holy Spirit,"
,"18":"and if you serve Christ in this way, you will please God and be praised by people."
,"19":"Let us look, then, for what strengthens peace and makes us better."
,"20":"Do not destroy the work of God because of food. All food is clean, but it becomes unclean for the one who eats against his own belief."
,"21":"And it may be better not to eat meat, or drink wine, or anything else that causes your brother or sister to stumble."
,"22":"Keep your own belief before God, and happy are you if you never act against your own belief."
,"23":"Instead, whoever eats something in spite of his doubt is doing wrong, because he does not act according to his belief, and whatever we do against our conscience is sinful."
}`)
	CurrentBook.AddChapter(15, `{
"1":"We, the strong and liberated, should bear the weakness of those who are not strong, instead of pleasing ourselves."
,"2":"Let each of us bring joy to our neighbors helping them for the good purpose, for building up."
,"3":"Christ himself did not look for his own contentment, as Scripture says: The insults of those insulting you fell upon me."
,"4":"And we know that whatever was written in the past was written for our instruction, for both perseverance and comfort given us by the Scripture sustain our hope."
,"5":"May God, the source of all perseverance and comfort, give to all of you to live in peace in Christ Jesus,"
,"6":"that you may be able to praise in one voice God, Father of Christ Jesus, our Lord."
,"7":"Welcome, then, one another, as Christ welcomed you for the glory of God."
,"8":"Look: Christ put himself at the service of the Jewish world to fulfill the promises made by God to their ancestors; here you see God's faithfulness."
,"9":"The pagans instead give thanks to God for his mercy, as Scripture says: Because of that, I will sing and praise your name among the pagans."
,"10":"And in another place: Rejoice, pagan nations, with God's people."
,"11":"And again: Praise the Lord, all people and let all nations speak of his magnificence."
,"12":"Isaiah says: A descendant of Jesse will come who will rule the pagan nations and they will hope in him."
,"13":"May God, the source of hope, fill you with joy and peace in the faith, so that your hope may increase by the power of the Holy Spirit."
,"14":"As for me, brothers and sisters, I am convinced that you have goodwill, knowledge and the capacity to advise each other;"
,"15":"nevertheless I have written boldly in some parts of this letter to remind you of what you already know. I do this according to the grace God has given to me"
,"16":"when I was sent to the pagan nations. I dedicate myself to the service of the Good News of God as a priest of Christ Jesus, in order to present the non-Jews to God as an agreeable offering consecrated by the Holy Spirit."
,"17":"This service of God is for me a cause of pride in Christ Jesus."
,"18":"Of course, I would not dare to speak of other things but what Christ himself has done through me, my words and my works,"
,"19":"with miracles and signs, by the power of the Holy Spirit - so that non-Jews may obey the faith. In this way I have extended the Good News to all parts, from Jerusalem to Illiricum."
,"20":"I have been very careful, however, and I am proud of this, not to preach in places where Christ is already known, and not to build upon foundations laid by others."
,"21":"Let it be as Scripture says: Those not told about him will see, and those who have not heard will understand."
,"22":"This work has prevented me from going to you."
,"23":"But now there is no more place for me in these regions, and as I have wanted for so long to go and see you,"
,"24":"I hope to visit you when I go to Spain. Then you could help me go to that nation, once I have fully enjoyed your company."
,"25":"Right now I am going to Jerusalem to help that community."
,"26":"Know that the churches of Macedonia and Achaia have decided to make a contribution for the poor among the believers of Jerusalem."
,"27":"They have decided to do that and, in fact, they were indebted to them. For the non-Jews have shared the spiritual goods of the Jews and now they must help them materially."
,"28":"So I am to complete this task and give over the amount that has been collected. Then I will go to you and from there to Spain."
,"29":"And I am sure that when I go to you, I will go with all the blessings of God."
,"30":"I beg of you, brothers and sisters, by Christ Jesus our Lord and by the love of the Spirit, to join me in the fight, praying to God for me;"
,"31":"pray that I may avoid the snares of the enemies of faith in Judea, and that the community of Jerusalem may welcome the help I bring."
,"32":"And so I will go to you with joy and, God willing, be refreshed in your company."
,"33":"The God of peace be with you. Amen."
}`)
	CurrentBook.AddChapter(16, `{
"1":"I recommend to you our sister Phoebe, deaconess of the church of Cenchreae."
,"2":"Please receive her in the name of the Lord, as it should be among brothers and sisters in the faith, and help her in whatever is necessary, because she helped many, among them, myself."
,"3":"Greetings to Prisca and Aquilas, my helpers in Christ Jesus."
,"4":"To save my life, they risked theirs; I am very grateful to them, as are all the churches of the pagan nations."
,"5":"Greetings also to the church that meets in their house. Greetings to my dear Epaenetus, the first in the province of Asia to believe in Christ."
,"6":"Greet Mary, who worked so much for you."
,"7":"Greetings to Andronicus and Junias, my relatives and companions in prison; they are well known apostles and served Christ before I did."
,"8":"Give greetings to Ampliatus, whom I love so much in the Lord."
,"9":"Greetings to Urbanus, our fellow worker, and to my dear Stachys."
,"10":"Greetings to Apelles, who suffered for Christ, and the family of Aristobulus."
,"11":"Greetings to my relative Herodion and those in the household of Narcissus, who works in the Lord's service."
,"12":"Greetings to Tryphaena and Tryphosa, who toil for the Lord's sake."
,"13":"Greetings to Rufus, elected of the Lord, and his mother who was a second mother to me."
,"14":"Greetings to Asyncritus, Phlegon, Hermes, Patrobas, Hermas and the brothers and sisters staying with them."
,"15":"Greetings to Philologus and Julia, Nereus and his sister, Olympas and all the holy ones in Christ Jesus with them."
,"16":"Greet one another with a holy kiss. All the churches of Christ send their greetings."
,"17":"Brothers and sisters, I beg of you to be careful of those who are causing divisions and troubles in teaching you a different teaching from the one you were taught. Keep away from them,"
,"18":"because those persons do not serve Christ our Lord, but their own interests, deceiving with their soft and entertaining language those who are simple of heart."
,"19":"Everybody knows that you are very obedient, and because of that I am happy, but I want you to be sensible in doing good and firm against evil."
,"20":"The God of peace will soon crush Satan and place him under your feet. May Christ Jesus, our Lord, bless you. "
,"21":"Timothy, who is with me, sends you greetings, and so do Lucius, Jason and Sosipatros, my relatives."
,"22":"I, Tertius, the writer of this letter, send you greetings in the Lord."
,"23":"Greetings from Gaius, who has given me lodging and in whose house the church meets. Greetings from Erastus, treasurer of the city, and from our brother Quartus. Glory be to God!"
,"25":"He is able to give you strength, according to the Good News I proclaim, announcing Christ Jesus. Now is revealed the mysterious plan kept hidden for long ages in the past."
,"26":"By the will of the eternal God it is brought to light, through the prophetic books, and all nations shall believe the faith proclaimed to them."
,"27":"Glory to God, who alone is wise, through Christ Jesus, for ever! Amen."
}`)

}
func EN_CCB_LoadNPTTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"From Paul, servant of God, apostle of Christ Jesus, at the service of God's chosen people, so that they may believe and reach the knowledge of truth and godliness."
,"2":"The eternal life we are waiting for was promised from the very beginning by God who never lies,"
,"3":"and as the appointed time had come, he made it known through the message entrusted to me by a command of God, our Savior."
,"4":"Greetings to you, Titus, my true son in the faith we share. May grace and peace be with you from God the Father and Christ Jesus our Lord."
,"5":"I left you in Crete because I wanted you to put right what was defective and appoint elders in every town, following my instructions."
,"6":"They must be blameless, married only once, whose children are believers and not open to the charge of being immoral and rebellious."
,"7":"Since the overseer (or bishop) is the steward of God's house, he must be beyond reproach: not proud, hot-headed, overfond of wine, quarrelsome or greedy for gain."
,"8":"On the contrary he must be hospitable, a lover of what is good, wise, upright, devout and self-controlled."
,"9":"He must hold to the message of faith just as it was taught, so that, in his turn, he may teach sound doctrine and refute those who oppose it."
,"10":"You know that there are many rebellious minds, talkers of nonsense, deceivers, especially the party of the circumcised."
,"11":"They have to be silenced when they go around disturbing whole families, teaching for low gain what should not be taught."
,"12":"A Cretan, one of their own prophets has said, 'Cretans: always liars, wicked beasts and lazy gluttons.'"
,"13":"This is true. For this reason rebuke them sharply if you want them to have a sound faith"
,"14":"instead of heeding Jewish fables and practices of people who reject the truth."
,"15":"To the pure everything is pure; to the corrupt and unbelieving nothing is pure: their minds and consciences have been defiled."
,"16":"They pretend to know God but deny him with their deeds. They are detestable, disobedient and unfit for doing anything good."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Let your words strengthen sound doctrine."
,"2":"Tell the older men to be sober, serious, wise, sound in faith, love and perseverance."
,"3":"The older women in like manner must behave as befits holy women, not given to gossiping or drinking wine,"
,"4":"but as good counselors, able to teach younger women to love their husbands and children,"
,"5":"to be judicious and pure, to take care of their households, to be kind and submissive to their husbands, lest our faith be attacked."
,"6":"Encourage the young men to be self-controlled."
,"7":"Set them an example by your own way of doing. Let your teaching be earnest and sincere,"
,"8":"and your preaching beyond reproach. Then your opponents will feel ashamed and will have nothing to criticize."
,"9":"Teach slaves to be subject to their masters, and to give satisfaction in every respect, instead of arguing."
,"10":"They must not steal from them but be trustworthy. In this way they will draw everyone to admire the doctrine of God our Savior."
,"11":"For God Savior has revealed his loving plan to all,"
,"12":"teaching us to reject an irreligious way of life and worldly greed, and to live in this world as responsible persons, upright and serving God,"
,"13":"while we await our blessed hope - the glorious manifestation of our great God and Savior Christ Jesus."
,"14":"He gave himself for us, to redeem us from every evil and to purify a people he wanted to be his own and dedicated to what is good."
,"15":"Teach these things, encourage and reprove with all authority. Let no one despise you."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Remind the believers to be submissive to rulers and authorities, to be obedient and to take the initiative in doing good."
,"2":"Tell them to insult no one; they must not be quarrelsome but gentle and understanding with everyone."
,"3":"We ourselves were once foolish, disobedient and misled. We were slaves of our desires, seeking pleasures of every kind. We lived in malice and envy, hateful and hating each other."
,"4":"But God our Savior revealed his eminent goodness and love for humankind"
,"5":"and saved us, not because of good deeds we may have done but for the sake of his own mercy. He gave us rebirth in baptism and renewed us by the Holy Spirit"
,"6":"poured over us through Christ Jesus our Savior."
,"7":"By the grace of God we were made holy and now we hope for everlasting life, our inheritance."
,"8":"This is the truth. I want you to insist on these things, for those who believe in God must excel in good deeds; that is what matters and is profitable to us."
,"9":"Avoid stupid arguments, discussions about genealogies and quarrels about the Law, for they are useless and unimportant."
,"10":"If anyone promotes sects in the church, warn him once and then a second time. If he still continues, break with him,"
,"11":"knowing that such a person is misled and sinful and stands self-condemned."
,"12":"When I send Artemas or Tychicus to you, try to come to me at Nicopolis as soon as possible, for I have decided to spend the winter there."
,"13":"Do your best to send Zenas the lawyer and Apollos on their way soon, and see to it that they have everything they need."
,"14":"Our people must learn to be outstanding in good works and to face urgent needs, instead of remaining idle and useless."
,"15":"All who are with me send greetings. Greet those who love us in the faith. Grace be with you all."
}`)

}
func EN_CCB_LoadNTAAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"In the first part of my work, Theophilus, I wrote of all that Jesus did and taught from the beginning"
,"2":"until the day when he ascended to heaven. But first he had instructed through the Holy Spirit the apostles he had chosen. "
,"3":"After his passion, he presented himself to them, giving many signs that he was alive; over a period of forty days he appeared to them and taught them concerning the Kingdom of God."
,"4":"Once when he had been eating with them, he told them, 'Do not leave Jerusalem but wait for the fulfillment of the Father's promise about which I have spoken to you:"
,"5":"John baptized with water, but you will be baptized with the Holy Spirit within a few days.'"
,"6":"When they had come together, they asked him, 'Is it now that you will restore the Kingdom of Israel?'"
,"7":"And he answered, 'It is not for you to know the time and the steps which the Father has fixed by his own authority."
,"8":"But you will receive power when the Holy Spirit comes upon you; and you will be my witnesses in Jerusalem, throughout Judea and Samaria, even to the ends of the earth.'"
,"9":"After Jesus said this, he was taken up before their eyes and a cloud hid him from their sight."
,"10":"While they were still looking up to heaven where he went, suddenly, two men dressed in white stood beside them"
,"11":"and said, 'Men of Galilee, why do you stand here looking up at the sky? This Jesus who has been taken from you into heaven, will return in the same way as you have seen him go there.'"
,"12":"Then they returned to Jerusalem from the Mount called Olives, which is a fifteen-minute walk away."
,"13":"On entering the city they went to the room upstairs where they were staying. Present there were Peter, John, James and Andrew; Philip and Thomas, Bartholomew and Matthew, James, son of Alpheus; Simon the Zealot and Judas son of James."
,"14":"All of these together gave themselves to constant prayer. With them were some women and also Mary, the mother of Jesus, and his brothers."
,"15":"It was during this time that Peter stood up in the midst of the community - about one hundred and twenty in all -"
,"16":"and he said, 'Brothers, it was necessary that the Scriptures referring to Judas be fulfilled. The Holy Spirit had spoken through David about the one who would lead the crowd coming to arrest Jesus. "
,"17":"He was one of our number and had been called to share our common ministry."
,"18":"(We know that he bought a field with the reward of his sin; yet he threw himself headlong to his death, his body burst open and all his bowels spilled out."
,"19":"This event became known to all the people living in Jerusalem and they named that field Akeldama in their own language, which means Field of Blood)."
,"20":"In the book of Psalms it is written: Let his house become deserted and may no one live in it. But it is also written: May another take his office."
,"21":"Therefore we must choose someone from among those who were with us during all the time that the Lord Jesus moved about with us,"
,"22":"beginning with John's baptism until the day when Jesus was taken away from us. One of these has to become, with us, a witness to his resurrection.'"
,"23":"Then they proposed two: Joseph, called Barsabbas, also known as Justus, and Matthias."
,"24":"They prayed: 'You know, Lord, what is in the hearts of all. Show us, therefore, which of the two you have chosen"
,"25":"to replace Judas in this apostolic ministry which he deserted to go to the place he deserved.'"
,"26":"Then they drew lots between the two and the choice fell on Matthias who was added to the eleven apostles."
}`)
	CurrentBook.AddChapter(2, `{
"1":"When the day of Pentecost came, they were all together in one place."
,"2":"And suddenly out of the sky came a sound like a strong rushing wind and it filled the whole house where they were sitting. There appeared"
,"3":"tongues as if of fire which parted and came to rest upon each one of them."
,"4":"All were filled with Holy Spirit and began to speak other languages, as the Spirit enabled them to speak."
,"5":"Staying in Jerusalem were religious Jews from every nation under heaven."
,"6":"When they heard this sound, a crowd gathered, all excited because each heard them speaking in his own language."
,"7":"Beside themselves with amazement and wonder, they said, 'Are not all these who are speaking Galileans?"
,"8":"How is it that we hear them in our own native language?"
,"9":"Here are Parthians, Medes and Elamites and residents of Mesopotamia, Judea and Cappadocia, Pontus and Asia,"
,"10":"Phrygia, Pamphylia, Egypt and the parts of Libya belonging to Cyrene, and visitors from Rome,"
,"11":"both Jews and foreigners who accept Jewish beliefs, Cretians and Arabians; and all of us hear them proclaiming in our own language what God, the Savior, does."
,"12":"They were amazed and greatly confused, and they kept asking one another, 'What does this mean?'"
,"13":"But others laughed and said, 'These people are drunk.'"
,"14":"Then Peter stood up with the Eleven and, with a loud voice, addressed them, 'Fellow Jews and all foreigners now staying in Jerusalem, listen to what I have to say."
,"15":"These people are not drunk as you suppose, for it is only nine o'clock in the morning."
,"16":"Indeed what the prophet Joel spoke about has happened:"
,"17":"In the last days, God says, I will pour out my Spirit on every mortal. Your sons and daughters will speak through the Holy Spirit; your young men will see visions and your old men will have dreams."
,"18":"In those days I will pour out my Spirit even on my servants, both men and women, and they will be prophets."
,"19":"I will perform miracles in the sky above and wonders on the earth below."
,"20":"The sun will be darkened and the moon will turn red as blood, before the great and glorious Day of the Lord comes."
,"21":"And then, whoever calls upon the Name of the Lord will be saved."
,"22":"Fellow Israelites, listen to what I am going to tell you about Jesus of Nazareth. God accredited him and through him did powerful deeds and wonders and signs in your midst, as you well know."
,"23":"You delivered him to sinners to be crucified and killed, and in this way the purpose of God from all times was fulfilled."
,"24":"But God raised him to life and released him from the pain of death, because it was impossible for him to be held in the power of death."
,"25":"David spoke of him when he said: I saw the Lord before me at all times; he is by my side, that I may not be shaken."
,"26":"Therefore my heart was glad and my tongue rejoiced; my body too will live in hope."
,"27":"Because you will not forsake me in the abode of the dead, nor allow your Holy One to experience corruption."
,"28":"You have made known to me the paths of life, and your presence will fill me with joy."
,"29":"Friends, I don't need to prove that the patriarch David died and was buried; his tomb is with us to this day."
,"30":"But he knew that God had sworn to him that one of his descendants would sit upon his throne and,"
,"31":"as he was a prophet, he foresaw and spoke of the resurrection of the Messiah. So he said that he would not be left in the region of the dead, nor would his body experience corruption."
,"32":"This Messiah is Jesus and we are all witnesses that God raised him to life."
,"33":"He has been exalted at God's right side and the Father has entrusted the Holy Spirit to him; this Spirit he has just poured upon us as you now see and hear."
,"34":"And look: David did not ascend into heaven, but he himself said: The Lord said to my Lord: sit at my right side"
,"35":"until I make your enemies a stool for your feet."
,"36":"Let Israel then know for sure that God has made Lord and Christ this Jesus whom you crucified.'"
,"37":"When they heard this, they were deeply troubled. And they asked Peter and the other apostles, 'What shall we do, brothers?'"
,"38":"Peter answered: 'Each of you must repent and be baptized in the name of Jesus Christ, so that your sins may be forgiven. Then you will receive the gift of the Holy Spirit."
,"39":"For the promise of God was made to you and your children, and to all those from afar whom our God may call.'"
,"40":"With many other words Peter gave the message and appealed to them saying, 'Save yourselves from this crooked generation.'"
,"41":"So those who accepted his word were baptized; some three thousand persons were added to their number that day."
,"42":"They were faithful to the teaching of the apostles, the common life of sharing, the breaking of bread and the prayers."
,"43":"A holy fear came upon all the people, for many wonders and miraculous signs were done by the apostles."
,"44":"Now all the believers lived together and shared all their belongings."
,"45":"They would sell their property and all they had and distribute the proceeds to others according to their need."
,"46":"Each day they met together in the Temple area; they broke bread in their homes; they shared their food with great joy and simplicity of heart;"
,"47":"they praised God and won the people's favor. And every day the Lord added to their number those who were being saved."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Once when Peter and John were going up to the Temple at three in the afternoon, the hour for prayer,"
,"2":"a man crippled from birth was being carried in. Every day they would bring him and put him at the temple gate called 'Beautiful'; there he begged from those who entered the Temple."
,"3":"When he saw Peter and John on their way into the Temple, he asked for alms."
,"4":"Then Peter with John at his side looked straight at him and said, 'Look at us.'"
,"5":"So he looked at them, expecting to receive something from them."
,"6":"But Peter said, 'I have neither silver nor gold, but what I have I give you: In the name of Jesus of Nazareth, the Messiah, walk!'"
,"7":"Then he took the beggar by his right hand and helped him up. At once his feet and ankles became firm,"
,"8":"and jumping up he stood on his feet and began to walk. And he went with them into the Temple walking and leaping and praising God."
,"9":"All the people saw him walking and praising God;"
,"10":"they recognized him as the one who used to sit begging at the Beautiful Gate of the Temple, and they were all astonished and amazed at what had happened to him."
,"11":"While he clung to Peter and John, all the people, struck with astonishment, came running to them in Solomon's Porch, as it was called."
,"12":"When Peter saw the people, he said to them, 'Fellow Israelites, why are you amazed at this? Why do you stare at us as if it was by some power or holiness of our own that we made this man walk? "
,"13":"The God of Abraham, of Isaac and of Jacob, the God of our ancestors has glorified his servant Jesus whom you handed over to death and denied before Pilate, when even Pilate had decided to release him."
,"14":"You rejected the Holy and Just One, and you insisted that a murderer be released to you."
,"15":"You killed the Master of life, but God raised him from the dead and we are witnesses to this."
,"16":"It is his Name, and faith in his Name, that has healed this man whom you see and recognize. The faith which comes through Jesus has given him wholeness in the presence of all of you."
,"17":"Yet I know that you acted out of ignorance, as did your leaders."
,"18":"God has fulfilled in this way what he had foretold through all the prophets, that his Messiah would suffer."
,"19":"Repent, then, and turn to God so that your sins may be wiped out"
,"20":"and the time of refreshment may come by the mercy of God, when he sends the Messiah appointed for you, Jesus."
,"21":"For he must remain in heaven until the time of the universal restoration which God spoke of long ago through his holy prophets."
,"22":"Moses foretold this when he said: The Lord God will raise up for you a prophet like me from among your own people; you shall listen to him in all that he says to you."
,"23":"Whoever does not listen to that prophet is to be cut off from among his people."
,"24":"In fact, all the prophets who have spoken, from Samuel onward, have announced the events of these days."
,"25":"You are the children of the prophets and heirs of the covenant which God gave to your ancestors when he said to Abraham: All the families of the earth will be blessed through your descendant."
,"26":"It is to you first that God sends his Servant; he raised him to life to bless you by turning each of you from your wicked ways.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"While Peter and John were still speaking to the people, the priests, the captain of the temple guard and the Sadducees came up to them."
,"2":"They were greatly disturbed because the apostles were teaching the people and proclaiming that resurrection from the dead had been proved in the case of Jesus."
,"3":"Since it was already evening, they arrested them and put them in custody until the following day."
,"4":"But despite this, many of those who heard the Message believed and their number increased to about five thousand."
,"5":"The next day, the Jewish leaders, elders and teachers of the Law assembled in Jerusalem."
,"6":"Annas, the High Priest, Caiaphas, John, Alexander, and all who were of the high priestly class were there."
,"7":"They brought Peter and John before them and began to question them, 'How did you do this? Whose name did you use?'"
,"8":"Then Peter, filled with the Holy Spirit, spoke up, 'Leaders of the people! Elders!"
,"9":"It is a fact that we are being examined today for a good deed done to a cripple. How was he healed?"
,"10":"You and all the people of Israel must know that this man stands before you cured through the Name of Jesus Christ the Nazarean. You had him crucified, but God raised him from the dead."
,"11":"Jesus is the stone rejected by you the builders which has become the cornerstone."
,"12":"There is no salvation in anyone else, for there is no other Name given to humankind all over the world by which we may be saved.'"
,"13":"They were astonished at the boldness of Peter and John, considering that they were uneducated and untrained men. They recognized, also, that they had been with Jesus,"
,"14":"but, as the man who had been cured stood beside them, they could make no reply."
,"15":"So they ordered them to leave the council room while they consulted with one another."
,"16":"They asked, 'What shall we do with these men? Everyone who lives in Jerusalem knows that a remarkable sign has been given through them, and we cannot deny it."
,"17":"But to stop this from spreading any further among the people, let us warn them never again to speak to anyone in the name of Jesus.'"
,"18":"So they called them back and charged them not to speak or teach at all in the name of Jesus."
,"19":"But Peter and John answered them, 'Judge for yourselves whether it is right in God's eyes for us to obey you rather than God."
,"20":"We cannot stop speaking about what we have seen and heard.'"
,"21":"Then the council threatened them once more and let them go. They could find no way of punishing them because of the people who glorified God for what had happened,"
,"22":"for the man who had been miraculously healed was over forty years old."
,"23":"As soon as Peter and John were set free, they went to their friends and reported what the chief priests and elders had said to them."
,"24":"When they heard it, they raised their voices as one and called upon God, 'Sovereign Lord, maker of heaven and earth, of the sea and everything in them,"
,"25":"you have put these words in the mouth of David, our father and your servant, through the Holy Spirit: Why did the pagan nations rage and the people conspire in folly?"
,"26":"The kings of the earth were aligned and the princes gathered together against the Lord and against his Messiah."
,"27":"For indeed in this very city Herod with Pontius Pilate, and the pagans together with the people of Israel conspired against your holy servant Jesus, whom you anointed."
,"28":"Thus, indeed, they brought about whatever your powerful will had decided from all time would happen."
,"29":"But now, Lord, see their threats against us and enable your servants to speak your word with all boldness."
,"30":"Stretch out your hand to heal and to work signs and wonders through the Name of Jesus your holy servant.'"
,"31":"When they had prayed, the place where they were gathered together shook, and they were all filled with Holy Spirit and began to speak the word of God boldly."
,"32":"The whole community of believers were one in heart and mind. No one claimed private ownership of any possessions, but rather they shared all things in common."
,"33":"With great power the apostles bore witness to the resurrection of the Lord Jesus, for all of them were living in an exceptional time of grace."
,"34":"There was no needy person among them, for those who owned land or houses, sold them and brought the proceeds of the sale."
,"35":"And they laid it at the feet of the apostles who distributed it according to each one's need."
,"36":"This is what a certain Joseph did. He was a Levite from Cyprus, whom the apostles called Barnabas, meaning: 'The encouraging one.'"
,"37":"He sold a field which he owned and handed the money to the apostles."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Another man named Ananias, in agreement with his wife Sapphira, likewise sold a piece of land;"
,"2":"with his wife's knowledge he put aside some of the proceeds, and the rest he turned over to the apostles."
,"3":"Then Peter said to him, 'Ananias, how is it that you let Satan fill your heart and why do you intend to deceive the Holy Spirit by keeping some of the proceeds of your land for yourself?"
,"4":"Who obliged you to sell it? And after it was sold, could you not have kept all the money? How could you think of such a thing? You have not deceived us but God.'"
,"5":"Upon hearing these words, Ananias fell down and died. Great fear came upon all who heard of it;"
,"6":"the young men stood up, wrapped his body and carried it out for burial."
,"7":"About three hours later Ananias's wife came but she was not aware of what had happened."
,"8":"Peter challenged her, 'Tell me whether you sold that piece of land for this price?' She said, 'Yes, that was the price.'"
,"9":"Peter replied, 'How could you two agree to put the Holy Spirit to the test? Those who buried your husband are at the door and they will carry you out as well.'"
,"10":"With that, she fell dead at his feet. The young men came in, found her dead and carried her out for burial beside her husband."
,"11":"And great fear came upon the whole church and upon all who heard of it."
,"12":"Many miraculous signs and wonders were done among the people through the hands of the apostles. The believers, of one accord, used to meet in Solomon's Porch."
,"13":"None of the others dared to join them, but the people held them in high esteem."
,"14":"So an ever increasing number of men and women, believed in the Lord."
,"15":"The people carried the sick into the streets and laid them on cots and on mats, so that when Peter passed by, at least his shadow might fall on some of them."
,"16":"The people gathered from the towns around Jerusalem, bringing their sick and those who were troubled by unclean spirits, and all of them were healed."
,"17":"The High Priest and all his supporters, that is the party of the Sadducees, became very jealous of the apostles;"
,"18":"so they arrested them and had them thrown into the public jail."
,"19":"But an angel of the Lord opened the door of the prison during the night, brought them out, and said to them,"
,"20":"'Go and stand in the Temple court and tell the people the whole of this living message.'"
,"21":"Accordingly they entered the Temple at dawn and resumed their teaching. When the High Priest and his supporters arrived, they called together the Sanhedrin, that is the full Council of the elders of Israel. They sent word to the jail to have the prisoners brought in. "
,"22":"But when the Temple guards arrived at the jail, they did not find them inside, so they returned with the news,"
,"23":"'We found the prison securely locked and the prison guards at their post outside the gate, but when we opened the gate, we found no one inside.'"
,"24":"Upon hearing these words, the captain of the Temple guard and the high priests were baffled, wondering where all of this would end."
,"25":"Just then someone arrived with the report, 'Look, those men whom you put in prison are standing in the Temple, teaching the people.'"
,"26":"Then the captain went off with the guards and brought them back, but without any show of force, for fear of being stoned by the people."
,"27":"So they brought them in and made them stand before the Council and the High Priest questioned them,"
,"28":"'We gave you strict orders not to preach such a Savior; but you have filled Jerusalem with your teaching and you intend charging us with the killing of this man.'"
,"29":"To this Peter and the apostles replied, 'Better for us to obey God rather than any human authority!"
,"30":"The God of our ancestors raised Jesus whom you killed by hanging him on a wooden post."
,"31":"God set him at his right hand as Leader and Savior, to grant repentance and forgiveness of sins to Israel."
,"32":"We are witnesses to all these things, as well as the Holy Spirit whom God has given to those who obey him.'"
,"33":"When the Council heard this, they became very angry and wanted to kill them."
,"34":"But one of them, a Pharisee named Gamaliel, a teacher of the Law highly respected by the people, stood up in the Sanhedrin. He ordered the men to be taken outside for a few minutes"
,"35":"and then he spoke to the assembly. 'Fellow Israelites, consider well what you intend to do to these men. "
,"36":"For some time ago Theudas came forward, claiming to be somebody, and about four hundred men joined him. But he was killed and all his followers were dispersed or disappeared."
,"37":"After him, Judas the Galilean appeared at the time of the census and persuaded many people to follow him. But he too perished and his whole following was scattered."
,"38":"So, in this present case, I advise you to have nothing to do with these men. Leave them alone. If their project or activity is of human origin, it will destroy itself."
,"39":"If, on the other hand, it is from God, you will not be able to destroy it and you may indeed find yourselves fighting against God.',The Council let themselves be persuaded. "
,"40":"They called in the apostles and had them whipped, and ordered them not to speak again of Jesus Savior. Then they set them free."
,"41":"The apostles went out from the Council rejoicing that they were considered worthy to suffer disgrace for the sake of the Name."
,"42":"Day after day, both in the Temple and in people's homes, they continued to teach and to proclaim that Jesus was the Messiah."
}`)
	CurrentBook.AddChapter(6, `{
"1":"In those days, as the number of disciples grew, the so-called Hellenists complained against the so-called Hebrews, because their widows were being neglected in the daily distribution."
,"2":"So the Twelve summoned the whole body of disciples together and said, 'It is not right that we should neglect the word of God to serve at tables."
,"3":"So, friends, choose from among yourselves seven respected men full of Spirit and wisdom, that we may appoint them to this task."
,"4":"As for us, we shall give ourselves to prayer and to the ministry of the Word.'"
,"5":"The whole community agreed and they chose Stephen, a man full of faith and Holy Spirit; Philip, Prochorus, Nicanor, Timon, Parmenus and Nicolaus of Antioch who was a proselyte."
,"6":"They presented these men to the apostles who first prayed over them and then laid hands upon them."
,"7":"The Word of God continued to spread, and the number of the disciples in Jerusalem increased greatly and even many priests accepted the faith."
,"8":"Stephen, full of grace and power, did great wonders and miraculous signs among the people."
,"9":"Some persons then came forward, who belonged to the so-called Synagogue of Freedmen from Cyrene, Alexandria, Cilicia and Asia."
,"10":"They argued with Stephen but they could not match the wisdom and the spirit with which he spoke."
,"11":"As they were unable to face the truth, they bribed some men to say, 'We heard him speak against Moses and against God.'"
,"12":"So they stirred up the people, the elders and the teachers of the Law; they took him by surprise, seized him and brought him before the Council."
,"13":"Then they produced false witnesses who said, 'This man never stops speaking against our Holy Place and the Law."
,"14":"We even heard him say that Jesus the Nazarean will destroy our Holy Place and change the customs which Moses handed down to us.'"
,"15":"And all who sat in the Council fixed their eyes on him, and his face appeared to them like the face of an angel."
}`)
	CurrentBook.AddChapter(7, `{
"1":"So the High Priest asked him: 'Is it true?' He answered, 'Brothers and fathers, listen to me."
,"2":"The God of glory appeared to our father Abraham when he was in Mesopotamia, before he went to live in Haran. And he said to him:"
,"3":"'Leave your land and your relatives and go to the land which I will show you.'"
,"4":"So he left the land of the Chaldeans and settled in Haran. After the death of his father, God made him move to this land in which you now dwell."
,"5":"And there he did not give him anything that was his own, not even the smallest portion of land to put his foot on, but promised to give it to him in possession and to his descendants, though he had no child."
,"6":"So God spoke: 'Your descendants shall live in a strange land, they shall be enslaved and maltreated for four hundred years."
,"7":"So I shall call the nation which they serve as slaves to render an account for it. They will come out and worship me in this place.'"
,"8":"He made with him the covenant of circumcision. And so, at the birth of his son Isaac, Abraham circumcised him on the eighth day. Isaac did the same to Jacob, and Jacob to the twelve patriarchs."
,"9":"The patriarchs envied Joseph so they sold him into Egypt. But God was with him."
,"10":"He rescued him from all his afflictions, granted him wisdom and made him please Pharaoh king of Egypt, who appointed him governor of Egypt and of the whole of his household."
,"11":"Then there was famine in all the land of Egypt and Canaan; it was a great misery and our ancestors did not have anything to eat."
,"12":"Upon learning that there was wheat in Egypt, Jacob sent our ancestors there on their first visit."
,"13":"On the second visit, Joseph made himself known to his brothers, and Pharaoh came to know the family of Joseph."
,"14":"Joseph commanded that his father Jacob be brought to him with the whole of his family of seventy-five persons."
,"15":"Jacob then went down to Egypt where he and our ancestors died."
,"16":"They were transferred to Shechem and laid in the tomb that Abraham had bought for a sum of silver from the sons of Hamor at Shechem."
,"17":"As the time of promise drew near, which God had made to Abraham, the people increased and multiplied in Egypt"
,"18":"until came another king who did not know Joseph."
,"19":"Dealing cunningly with our race, he forced our ancestors to abandon their newborn infants and let them die."
,"20":"At that time Moses was born, and God looked kindly on him. For three months he was nursed in the home of his father;"
,"21":"and when they abandoned him, Pharaoh's daughter took him and raised him as her own son."
,"22":"So Moses was educated in all the wisdom of the Egyptians. He was mighty in word and deed."
,"23":"And when he was forty years old, he wanted to visit his own people, the Israelites."
,"24":"When he saw one of them being wronged, he defended the oppressed man and killed the Egyptian."
,"25":"He thought his kinsfolk would understand that God was sending him to them as a liberator, but they did not understand."
,"26":"On the following day, he came to them as they were fighting and tried to reconcile them, saying: 'You are brothers, why do you hurt each other?'"
,"27":"At that moment, the one who was injuring his companion rebuffed him saying: 'Who appointed you as our leader and judge?"
,"28":"Do you want to kill me as you killed the Egyptian yesterday?'"
,"29":"When Moses heard this, he fled and went to live as a stranger in the land of Midian where he had two sons."
,"30":"After forty years an angel appeared to him in the desert of Mount Sinai in the flame of a burning bush."
,"31":"Moses was astonished at the vision. And as he approached to look at it, he heard the voice of the Lord:"
,"32":"'I am the God of your fathers, the God of Abraham, Isaac and Jacob.' Moses was filled with fear and did not dare look at it."
,"33":"But the Lord said to him: 'Take off your sandals for the place where you stand is holy ground."
,"34":"I have seen the affliction of my people in Egypt and heard them weeping, and I have come down to free them. And now, get up! I am sending you to Egypt.'"
,"35":"This Moses whom they rejected saying: 'Who appointed you leader and judge?' God sent as leader and liberator with the assistance of the angel who appeared to him in the bush."
,"36":"He led them out, performing signs and wonders in Egypt, at the Red Sea and in the desert for forty years."
,"37":"This Moses is the one who said to the Israelites: 'God will give you a prophet like me from among your own people.'"
,"38":"This is the one who in the Assembly in the desert became the mediator between the angel who spoke to him on Mount Sinai and our ancestors; and he received the words of life that he might communicate them to us."
,"39":"But him our ancestors refused to obey, they rejected him and turned their hearts to Egypt, saying to Aaron:"
,"40":"'Give us gods to lead us since we do not know what has happened to that Moses who brought us out of Egypt.'"
,"41":"So in those days, they fashioned a calf, offered sacrifices to their idol and rejoiced in the work of their hands."
,"42":"So God departed from them and let them worship the stars of heaven, as it is written in the Book of the Prophets: 'People of Israel, did you offer me burnt offerings and sacrifices for forty years in the desert?"
,"43":"No, you carried instead the tent of Moloch and the star of the god Rehan, images you made to worship, for this I will banish you farther than Babylon.'"
,"44":"Our ancestors had the Tent of Meeting in the desert, for God had directed Moses to build it according to the pattern he had seen."
,"45":"Our ancestors received it and brought it under the command of Joshua into the lands of the pagans that they conquered and whom God expelled before them. They kept it until the days of David"
,"46":"who found favor with God and asked him to let him build a house for the God of Jacob."
,"47":"However, it was Solomon who built that temple."
,"48":"In reality, the Most High does not dwell in houses made by human hands as the Prophet says:"
,"49":"'Heaven is my throne and earth is my footstool. What house will you build for me, says the Lord, how could you give me a dwelling place?"
,"50":"Was it not I who made all these things?'"
,"51":"But you are a stubborn people, you hardened your hearts and closed your ears. You have always resisted the Holy Spirit just as your fathers did."
,"52":"Was there a prophet whom your ancestors did not persecute? They killed those who announced the coming of the Just One whom you have now betrayed and murdered,"
,"53":"you who received the Law through the angels but did not fulfill it.'"
,"54":"When they heard this reproach, they were enraged and they gnashed their teeth against Stephen."
,"55":"But he, full of the Holy Spirit, fixed his eyes on heaven and saw the glory of God and Jesus at God's right hand,"
,"56":"so he declared: 'I see the heavens open and the Son of Man at the right hand of God.'"
,"57":"But they shouted and covered their ears with their hands and rushed together upon him."
,"58":"They brought him out of the city and stoned him, and the witnesses laid down their cloaks at the feet of a young man named Saul."
,"59":"As they were stoning him, Stephen prayed saying: 'Lord Jesus, receive my spirit.'"
,"60":"Then he knelt down and said in a loud voice: 'Lord, do not hold this sin against them.' And when he had said this, he died."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Saul was there, approving his murder. This was the beginning of a great persecution against the Church in Jerusalem. All, except the apostles, were scattered throughout the region of Judea and Samaria."
,"2":"Devout men buried Stephen and mourned deeply for him."
,"3":"Saul meanwhile was trying to destroy the Church; he entered house after house and dragged off men and women and had them put in jail."
,"4":"At the same time those who were scattered went about preaching the word."
,"5":"Philip went down to a town of Samaria and proclaimed the Christ there."
,"6":"All the people paid close attention to what Philip said as they listened to him and saw the miraculous signs which he did."
,"7":"For in cases of possession, the unclean spirits came out shrieking loudly. Many people who were paralyzed or crippled were healed."
,"8":"So there was great joy in that town."
,"9":"A certain man named Simon had come to this town, practicing magic. He held the Samaritans spellbound and passed himself off as a very important person."
,"10":"All the people, from the last to the greatest, put their trust in him, saying, 'This is the Power of God, the Great One.'"
,"11":"And they followed him because he had held them under the spell of his magic for a long time."
,"12":"But when they came to believe Philip who announced to them the Kingdom of God and Jesus Christ as Savior, both men and women were baptized."
,"13":"Simon himself believed and was baptized, and would not depart from Philip. He was astonished when he saw the miraculous signs and wonders that happened."
,"14":"Now, when the apostles in Jerusalem heard that the Samaritans had accepted the word of God, they sent Peter and John to them."
,"15":"They went down and prayed for them that they might receive the Holy Spirit,"
,"16":"for he had not as yet come down upon any of them since they had only been baptized in the name of the Lord Jesus."
,"17":"So Peter and John laid their hands on them and they received the Holy Spirit."
,"18":"When Simon saw that the Spirit was given through the laying on of the apostles' hands, he offered them money"
,"19":"saying, 'Give me also this power, so that anyone upon whom I lay my hands may receive the Holy Spirit.'"
,"20":"Peter replied, 'May you and your money perish for thinking that the Gift of God could be bought with money!"
,"21":"You cannot share in this since you do not understand the things of God."
,"22":"Repent, therefore, of this wickedness of yours and pray to the Lord that you may be forgiven such a wrong way of thinking;"
,"23":"I see you are poisoned with bitterness and in the grip of sin.'"
,"24":"Simon answered, 'Pray to the Lord for me yourselves, so that none of these things you spoke of will happen to me.'"
,"25":"Peter and John gave their testimony and spoke the word of the Lord. And they went back to Jerusalem, bringing the Good News to many Samaritan villages along the way."
,"26":"An angel of the Lord said to Philip, 'Go south towards the road that goes down from Jerusalem to Gaza, the desert road.'"
,"27":"So he set out and it happened that an Ethiopian was passing along that way. He was an official in charge of the treasury of the queen of the Ethiopians; he had come on pilgrimage to Jerusalem"
,"28":"and was on his way home. He was sitting in his carriage and reading the prophet Isaiah."
,"29":"The Spirit said to Philip, 'Go and catch up with that carriage.'"
,"30":"So Philip ran up and heard the man reading the prophet Isaiah; and he asked, 'Do you really understand what you are reading?' The Ethiopian replied,"
,"31":"'How can I, unless someone explains it to me?' He then invited Philip to get in and sit beside him."
,"32":"This was the passage of Scripture he was reading: He was led like a sheep to be slaughtered; like a lamb that is dumb before the shearer, he did not open his mouth. "
,"33":"He was humbled and deprived of his rights. Who can speak of his descendants? For he was uprooted from the earth."
,"34":"The official asked Philip, 'Tell me, please, does the prophet speak of himself or of someone else?'"
,"35":"Then Philip began to tell him the Good News of Jesus, using this text of Scripture as his starting point."
,"36":"As they traveled down the road they came to a place where there was some water. Then the Ethiopian official said, 'Look, here is water; what is to keep me from being baptized?'"
,"38":"Then he ordered the carriage to stop; both Philip and the Ethiopian went down into the water and Philip baptized him."
,"39":"When they came out of the water, the Spirit of the Lord took Philip away. The Ethiopian saw him no more, but he continued on his way full of joy."
,"40":"Philip found himself at Azotus, and he went about announcing the Good News in all the towns until he reached Caesarea."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Meanwhile Saul considered nothing but violence and death for the disciples of the Lord."
,"2":"He went to the High Priest and asked him for letters to the synagogues of Damascus that would authorize him to arrest and bring to Jerusalem anyone he might find, man or woman, belonging to the Way."
,"3":"As he traveled along and was approaching Damascus, a light from the sky suddenly flashed around him."
,"4":"He fell to the ground and heard a voice saying to him, 'Saul, Saul! Why do you persecute me?'"
,"5":"And he asked, 'Who are you, Lord?' The voice replied, 'I am Jesus whom you persecute."
,"6":"Now get up and go into the city; there you will be told what you are to do.'"
,"7":"The men who were traveling with him stood there speechless: they had heard the sound, but could see no one."
,"8":"Saul got up from the ground and, opening his eyes, he could not see. They took him by the hand and brought him to Damascus."
,"9":"He was blind and he did not eat or drink for three days."
,"10":"There was a disciple in Damascus named Ananias, to whom the Lord called in a vision, 'Ananias!' He answered, 'Here I am, Lord!'"
,"11":"Then the Lord said to him, 'Go at once to Straight Street and ask, at the house of Judas, for a man of Tarsus named Saul. You will find him praying,"
,"12":"for he has just seen in a vision that a man named Ananias has come in and placed his hands upon him, to restore his sight.'"
,"13":"Ananias answered, 'Lord, I have heard from many sources about this man and all the harm he has done to your saints in Jerusalem,"
,"14":"and now he is here with authority from the High Priest to arrest all who call upon your name.'"
,"15":"But the Lord said to him, 'Go! This man is my chosen instrument to bring my name to the pagan nations and their kings, and the people of Israel as well."
,"16":"I myself will show him how much he will have to suffer for my name.'"
,"17":"So Ananias left and went to the house. He laid his hands upon Saul and said, 'Saul, my brother, the Lord Jesus, who appeared to you on your way here, has sent me to you so that you may receive your sight and be filled with Holy Spirit.'"
,"18":"Immediately something like scales fell from his eyes and he could see; he got up and was baptized."
,"19":"Then he took food and was strengthened. For several days Saul stayed with the disciples at Damascus, "
,"20":"and he soon began to proclaim in the synagogues that Jesus was the Son of God."
,"21":"All who heard were astonished and said, 'Is this not the one who cast out in Jerusalem all those calling upon this Name? Did he not come here to bring them bound before the chief priests?'"
,"22":"But Saul grew more and more powerful, and he confounded the Jews living in Damascus when he proved that Jesus was the Messiah."
,"23":"After a fairly long time, the Jews conspired together to kill him."
,"24":"But Saul became aware of their plan: Day and night they kept watch at the city gate in order to kill him."
,"25":"So his disciples took him one night and let him down from the top of the wall, lowering him in a basket."
,"26":"When Saul came to Jerusalem, he tried to join the disciples there, but they were afraid of him because they could not believe that he was a disciple."
,"27":"But Barnabas took him and brought him to the apostles. He recounted to them how Saul had seen the Lord on his way and the words the Lord had spoken to him. He told them also how Saul had preached boldly in the name of Jesus."
,"28":"Then Saul began to live with them. He moved about freely in Jerusalem and preached openly in the name of the Lord."
,"29":"He also spoke to the Hellenists and argued with them, but they wanted to kill him."
,"30":"When the believers learned of this, they took him down to Caesarea and sent him off to Tarsus."
,"31":"Meanwhile, the Church had peace. It was building up throughout all Judea and Galilee and Samaria with eyes turned to the Lord and filled with comfort from the Holy Spirit."
,"32":"As Peter traveled around, he went to visit the saints who lived in Lydda."
,"33":"There he found a man named Aeneas who was paralyzed, and had been bedridden for eight years."
,"34":"Peter said to him, 'Aeneas, Jesus Christ heals you; get up and make your bed!' And the man got up at once."
,"35":"All the people living in Lydda and Sharon saw him and turned to the Lord."
,"36":"There was a disciple in Joppa named Tabitha, which means Dorcas or Gazelle. She was always doing good works and helping the poor."
,"37":"At that time she fell sick and died. After having washed her body, they laid her in the upstairs room."
,"38":"As Lydda is near Joppa, the disciples, on hearing that Peter was there, sent two men to him with the request, 'Please come to us without delay.'"
,"39":"So Peter went with them. On his arrival they took him upstairs to the room. All the widows crowded around him in tears, showing him the clothes which Dorcas had made while she was with them."
,"40":"Peter made them all leave the room and then he knelt down and prayed. Turning to the dead body he said, 'Tabitha, stand up.' She opened her eyes, looked at Peter and sat up."
,"41":"Peter gave her his hand and helped her up. Then he called in the saints and widows and presented her to them alive."
,"42":"This became known throughout all of Joppa and many people believed in the Lord because of it."
,"43":"As for Peter, he remained for some time in Joppa at the house of Simon, a tanner of leather."
}`)
	CurrentBook.AddChapter(10, `{
"1":"There was in Caesarea a man named Cornelius, captain of what was called the Italian Battalion."
,"2":"He was a religious and God-fearing man together with his whole household. He gave generously to the people and constantly prayed to God."
,"3":"One afternoon at about three he had a vision in which he clearly saw an angel of God coming towards him and calling him, 'Cornelius!'"
,"4":"He stared at the vision with awe and said, 'What is it, sir?' And the angel answered, 'Your prayers and your alms have just been recalled before God."
,"5":"Now send some men to Joppa and summon a certain Simon also known as Peter;"
,"6":"he is the guest of Simon, a tanner, who lives beside the sea.'"
,"7":"As soon as the angel who spoke to him departed, Cornelius called two of his servants and a devout soldier from among those attached to his service,"
,"8":"and after having explained everything to them, he sent them to Joppa."
,"9":"The next day, while they were on their journey and approaching the city, Peter went up to the roof at about noon to pray."
,"10":"He became hungry and wished to eat, but while they were preparing food, he fell into a trance."
,"11":"The heavens were opened to him and he saw an object that looked like a large sheet coming down, until it rested on the ground by its four corners."
,"12":"In it were all kinds of four-legged animals of the earth, reptiles and birds."
,"13":"Then a voice said to him, 'Get up, Peter, kill and eat!'"
,"14":"But Peter replied, 'Certainly not, Lord! I have never eaten any defiled or unclean creature.'"
,"15":"And again a second time the voice spoke, 'What God has made clean, you must not call unclean.'"
,"16":"This happened three times and then the sheet was taken up again into the sky."
,"17":"While Peter was still puzzling over the meaning of the vision he had seen, the messengers of Cornelius arrived at the gate asking for the house of Simon."
,"18":"They called out to inquire whether Simon, also known as Peter, was staying there."
,"19":"At that moment, as Peter continued pondering on the vision, the Spirit spoke to him, 'There are men looking for you;"
,"20":"get up and go downstairs and follow them without hesitation, for I have sent them.'"
,"21":"So Peter went and said to the men, 'I am the one you are looking for. What brings you here?' They answered,"
,"22":"'He who sent us is Captain Cornelius. He is an upright and God-fearing man, well respected by all the Jewish people. He has been instructed by a holy angel to summon you to his house, so that he may listen to what you have to say.'"
,"23":"So Peter invited them in and put them up for the night. The next day he went off with them and some of the believers from Joppa accompanied him. "
,"24":"The following day, he arrived in Caesarea where Cornelius was expecting them; he had called together his relatives and close friends."
,"25":"As Peter was about to enter, Cornelius went to him, fell on his knees and bowed low."
,"26":"But Peter lifted him up saying, 'Stand up, for I too am a human being.'"
,"27":"After talking with him, Peter entered and found many people assembled there."
,"28":"Then he said to them, 'You know that it is forbidden for Jews to associate with anyone of another nation or to enter their houses. But God has made it clear to me that no one should call any person common or unclean;"
,"29":"because of this I came at once when I was sent for. Now I should like to know why you sent for me.'"
,"30":"Cornelius then answered, 'Just three days ago at this time, about three in the afternoon, I was praying in my house when a man in shining clothes stood before me"
,"31":"and said to me: 'Cornelius, God has heard your prayer, and your alms have been remembered before him."
,"32":"Send someone, therefore, to Joppa and ask for Simon, also known as Peter, who is guest at the house of Simon the tanner by the sea.'"
,"33":"So I sent for you at once and you have been kind enough to come. Now we are all here in God's presence, waiting to hear all that the Lord has commanded you to say.'"
,"34":"Peter then spoke to them, 'Truly, I realize that God does not show partiality,"
,"35":"but in all nations he listens to everyone who fears God and does good."
,"36":"And this is the message he has sent to the children of Israel, the good news of peace he has proclaimed through Jesus Christ, who is the Lord of all."
,"37":"No doubt you have heard of the event that occurred throughout the whole country of the Jews, beginning from Galilee, after the baptism John preached."
,"38":"You know how God anointed Jesus the Nazarean with Holy Spirit and power. He went about doing good and healing all who were under the devil's power, because God was with him;"
,"39":"we are witnesses of all that he did throughout the country of the Jews and in Jerusalem itself. Yet they put him to death by hanging him on a wooden cross."
,"40":"But God raised him to life on the third day and let him manifest himself,"
,"41":"not to all the people, but to the witnesses that were chosen beforehand by God - to us who ate and drank with him after his resurrection from death."
,"42":"And he commanded us to preach to the people and to bear witness that he is the one appointed by God to judge the living and the dead."
,"43":"All the prophets say of him, that everyone who believes in him has forgiveness of sins through his Name.'"
,"44":"Peter was still speaking when the Holy Spirit came upon all who listened to the Word."
,"45":"And the believers of Jewish origin who had come with Peter were amazed, 'Why! God gives and pours the Holy Spirit on foreigners also!'"
,"46":"For indeed this happened: they heard them speaking in tongues and praising God."
,"47":"Then Peter declared, 'Can we refuse to baptize with water these people who have received the Holy Spirit, just as we have?'"
,"48":"So he had them baptized in the name of Jesus Christ. After that they asked him to remain with them for some days."
}`)
	CurrentBook.AddChapter(11, `{
"1":"News came to the apostles and the brothers and sisters in Judea that even foreigners had received the Word of God."
,"2":"So, when Peter went up to Jerusalem, these Jewish believers began to argue with him,"
,"3":"'You went to the home of uncircumcised people and ate with them!'"
,"4":"So Peter began to give them the facts as they had happened,"
,"5":"'I was at prayer in the city of Joppa when, in a trance, I saw a vision. Something like a large sheet came down from the sky and drew near to me, landing on the ground by its four corners."
,"6":"As I stared at it, I saw four-legged creatures of the earth, wild beasts and reptiles, and birds of the sky."
,"7":"Then I heard a voice saying to me: 'Get up, Peter, kill and eat!'"
,"8":"I replied, 'Certainly not, Lord! No common or unclean creature has ever entered my mouth.'"
,"9":"A second time the voice from the heavens spoke, 'What God has made clean, you must not call unclean.'"
,"10":"This happened three times, and then it was all drawn up into the sky."
,"11":"At that moment three men, who had been sent to me from Caesarea, arrived at the house where we were staying."
,"12":"The Spirit instructed me to go with them without hesitation; so these six brothers came along with me and we entered into the man's house."
,"13":"He told us how he had seen an angel standing in his house and telling him: Send someone to Joppa and fetch Simon, also known as Peter."
,"14":"He will bring you a message by which you and all your household will be saved.'"
,"15":"I had begun to address them when suddenly the Holy Spirit came upon them, just as it had come upon us at the beginning."
,"16":"Then I remembered what the Lord had said: 'John baptized with water, but you shall be baptized with the Holy Spirit.'"
,"17":"If, then, God had given them the same gift that he had given us when we believed in the Lord Jesus Christ, who was I to resist God?'"
,"18":"When they heard this they set their minds at rest and praised God saying, 'Then God has granted life-giving repentance to the pagan nations as well.'"
,"19":"Those who had been scattered because of the persecution over Stephen traveled as far as Phoenicia, Cyprus and Antioch, telling the message, but only to the Jews."
,"20":"But there were some natives of Cyprus and Cyrene among them who, on coming into Antioch, spoke also to the Greeks, giving them the good news of the Lord Jesus."
,"21":"The hand of the Lord was with them so that a great number believed and turned to the Lord."
,"22":"News of this reached the ears of the Church in Jerusalem, so they sent Barnabas to Antioch."
,"23":"When he arrived and saw the manifest signs of God's favor, he rejoiced and urged them all to remain firmly faithful to the Lord;"
,"24":"for he himself was a good man filled with Holy Spirit and faith. Thus large crowds came to know the Lord."
,"25":"Then Barnabas went off to Tarsus to look for Saul"
,"26":"and when he found him, he brought him to Antioch. For a whole year they had meetings with the Church and instructed many people. It was in Antioch that the disciples were first called Christians."
,"27":"At that time some prophets went down from Jerusalem to Antioch"
,"28":"and one of them, named Agabus, inspired by the Holy Spirit, foretold that a great famine would spread over the whole world. This actually happened in the days of the Emperor Claudius."
,"29":"So the disciples decided, within their means, to set something aside and to send relief to the brothers and sisters who were living in Judea."
,"30":"They did this and sent their donations to the elders by Barnabas and Saul."
}`)
	CurrentBook.AddChapter(12, `{
"1":"About that time King Herod decided to persecute some members of the Church."
,"2":"He had James, the brother of John, killed with the sword,"
,"3":"and when he saw how it pleased the Jews, he proceeded to arrest Peter also. This happened during the festival of the Unleavened Bread. "
,"4":"Herod had him seized and thrown into prison with four squads, each of four soldiers, to guard him. He wanted to bring him to trial before the people after the Passover feast,"
,"5":"but while Peter was kept in prison, the whole Church prayed earnestly for him."
,"6":"On the very night before Herod was to bring him to trial, Peter was sleeping between two soldiers, bound by a double chain, while guards kept watch at the gate of the prison."
,"7":"Suddenly an angel of the Lord stood there and a light shone in the prison cell. The angel tapped Peter on the side and woke him saying, 'Get up quickly!' At once the chains fell from Peter's wrists. The angel said, 'Put on your belt and your sandals.' Peter did so,"
,"8":"and the angel added, 'Now, put on your cloak and follow me.'"
,"9":"Peter followed him out; yet he did not realize that what was happening with the angel was real; he thought he was seeing a vision."
,"10":"They passed the first guard and then the second and they came to the iron door leading out to the city, which opened of itself for them. They went out and made their way down a narrow alley, when suddenly the angel left him."
,"11":"Then Peter recovered his senses and said, 'Now I know that the Lord has sent his angel and has rescued me from Herod's clutches and from all that the Jews had in store for me.'"
,"12":"Peter then found his bearings and came to the house of Mary, the mother of John also known as Mark, where many were gathered together and were praying."
,"13":"When he knocked at the outside door, a maid named Rhoda came to answer it."
,"14":"On recognizing the voice of Peter she was so overcome with joy that, instead of opening the door, she ran in to announce that Peter was at the door."
,"15":"They said to her, 'You are crazy!' And as she insisted, they said, 'It must be his angel.'"
,"16":"Meanwhile, Peter continued knocking and, when they finally opened the door, they were amazed to see him."
,"17":"He motioned to them with his hand to be quiet and told them how the Lord had brought him out of prison. And he said to them, 'Report this to James and to the brothers.' Then he left and went to another place."
,"18":"At daybreak there was a great commotion among the soldiers over what had become of Peter."
,"19":"Herod began a search for him and, not finding him, had the guards questioned and executed. After that, he came down from Judea to Caesarea and stayed there."
,"20":"At that time Herod was angry with the people of Tyre and Sidon. By general agreement they appeared before him and, after having won over Blastus, the king's treasurer, they asked for peace, for their country was supplied with food from the territory of Herod."
,"21":"On the appointed day Herod, clothed in royal robes, sat on his throne and addressed them."
,"22":"So the assembled crowd shouted back, 'A god is speaking, not a man!'"
,"23":"The angel of the Lord immediately struck Herod for he did not return the honor to God, and he died eaten by worms."
,"24":"Meanwhile the word of God was increasing and spreading."
,"25":"Barnabas and Saul carried out their mission and then came back from Jerusalem, taking with them John also called Mark."
}`)
	CurrentBook.AddChapter(13, `{
"1":"There were at Antioch - in the Church which was there - prophets and teachers: Barnabas, Symeon known as Niger, Lucius of Cyrene, Manaen who had been brought up with Herod, and Saul."
,"2":"On one occasion while they were celebrating the Lord and fasting, the Holy Spirit said to them, 'Set apart for me Barnabas and Saul and send them to do the work for which I have called them.'"
,"3":"So, after fasting and praying, they laid their hands on them and sent them off."
,"4":"These then, sent by the Holy Spirit, went down to the port of Seleucia and from there sailed to Cyprus."
,"5":"Upon their arrival in Salamis they proclaimed the word of God in the Jewish synagogue; John was with them as an assistant."
,"6":"They traveled over the whole island as far as Paphos where they met a certain magician named Bar-Jesus, a Jewish false prophet"
,"7":"who lived with the governor Sergius Paulus, an intelligent man. He had summoned Barnabas and Saul and wanted to hear the word of God."
,"8":"But they were opposed by the Elymas (that is, the magician) who tried to turn the governor from the faith."
,"9":"Then Saul, also known as Paul, full of Holy Spirit, looked intently at him"
,"10":"and said, 'You son of the devil, full of all kinds of deceit and enemy of all that is right! Will you never stop perverting the straight paths of the Lord?"
,"11":"Now the Lord's hand is upon you; you will become blind and for a time you will not see the light of day.' At once a misty darkness came upon him, and he groped about for someone to lead him by the hand."
,"12":"The governor saw what had happened; he believed, and was deeply impressed by the teaching about the Lord."
,"13":"From Paphos, Paul and his companions set sail and came to Perga in Pamphylia. There John left them and returned to Jerusalem"
,"14":"while they went on from Perga and came to Antioch in Pisidia. On the sabbath day they entered the synagogue and sat down."
,"15":"After the reading of the Law and the Prophets, the officials of the synagogue sent this message to them, 'Brothers, if you have any word of encouragement for the assembly, please speak up.'"
,"16":"So Paul arose, motioned to them for silence and began, 'Fellow Israelites and also all you who fear God, listen."
,"17":"The God of our people Israel chose our ancestors, and after he had made them increase during their stay in Egypt, he led them out by powerful deeds."
,"18":"For forty years he fed them in the desert,"
,"19":"and after he had destroyed seven nations in the land of Canaan, he gave them their land as an inheritance."
,"20":"All this took four hundred and fifty years."
,"21":"After that, he gave them Judges until Samuel the prophet. Then they asked for a king and God gave them Saul, son of Kish, of the tribe of Benjamin, and he was king for forty years."
,"22":"After that time, God removed him and raised up David as king, to whom he bore witness saying: I have found David, the son of Jesse, a man after my own heart, who will do all I want him to do."
,"23":"It is from the descendants of David that God has now raised up the promised savior of Israel, Jesus."
,"24":"Before he appeared, John proclaimed a baptism of repentance for all the people of Israel."
,"25":"As John was ending his life's work, he said: 'I am not what you think I am, for after me another one is coming whose sandal I am not worthy to untie.'"
,"26":"Brothers, children and descendants of Abraham, and you also who fear God, it is to you that this message of salvation has been sent."
,"27":"It is a fact that the inhabitants of Jerusalem and their leaders did not recognize Jesus. Yet in condemning him, they fulfilled the words of the prophets that are read every sabbath but not understood."
,"28":"Even though they found no charge against him that deserved death, they asked Pilate to have him executed."
,"29":"And after they had carried out all that had been written concerning him, they took him down from the cross and laid him in a tomb."
,"30":"But God raised him from the dead,"
,"31":"and for many days thereafter he showed himself to those who had come up with him from Galilee to Jerusalem. They have now become his witnesses before the people."
,"32":"We ourselves announce to you this Good News: All that God promised our ancestors,"
,"33":"he has fulfilled for us, their descendants, by raising Jesus, according to what is written in the second psalm: You are my Son, today I have begotten you."
,"34":"On raising him from the dead so that he would never know the decay of death, God fulfilled his promise: I will give you the holy blessings, the sure ones, that I kept for David."
,"35":"Moreover, in another place it is said: You will not allow your holy one to suffer corruption."
,"36":"Now David was subjected to corruption, for he died and was laid beside his ancestors after having served God's purpose in his own time."
,"37":"But the one God raised up - Jesus - did not know corruption."
,"38":"Through him, fellow Israelites, you have forgiveness of sins, and this is our good news."
,"39":"Whoever believes in him is freed of everything from which you could not be freed by the law of Moses."
,"40":"Now watch out lest what was said by the prophet happen to you:"
,"41":"Take care, you cynics; be amazed and disappear! For I am about to do something in your days which you would never believe even if you had been told.'"
,"42":"As Paul and Barnabas withdrew, they were invited to speak again on the same subject the following sabbath."
,"43":"After that, when the assembly broke up, many Jews and devout God-fearing people followed them and to these they spoke, urging them to hold fast to the grace of God."
,"44":"The following sabbath almost the entire city gathered to listen to Paul, who spoke a fairly long time about the Lord."
,"45":"But the presence of such a crowd made the Jews jealous. So they began to oppose with insults whatever Paul said."
,"46":"Then Paul and Barnabas spoke out firmly, saying, 'It was necessary that God's word be first proclaimed to you, but since you now reject it and judge yourselves to be unworthy of eternal life, we turn to non-Jewish people."
,"47":"For thus we were commanded by the Lord: I have set you as a light to the pagan nations, so that you may bring my salvation to the ends of the earth.'"
,"48":"Those who were not Jews rejoiced when they heard this and praised the message of the Lord, and all those destined for everlasting life believed in it."
,"49":"Thus the Word spread throughout the whole region."
,"50":"Some of the Jews, however, incited God-fearing women of the upper class and the leading men of the city, as well, and stirred up an intense persecution against Paul and Barnabas. Finally they had them expelled from their region."
,"51":"The apostles shook the dust from their feet in protest against this people and went to Iconium,"
,"52":"leaving the disciples filled with joy and Holy Spirit."
}`)
	CurrentBook.AddChapter(14, `{
"1":"In Iconium Paul and Barnabas likewise went into the Jewish synagogue and preached in such a manner that a great number of Jews and Greeks believed."
,"2":"But the Jews who would not believe stirred up the pagan people and poisoned their minds against the brothers."
,"3":"In spite of this Paul and Barnabas spent a considerable time there. They spoke fearlessly of the Lord, who confirmed the message of his grace with the miraculous signs and wonders he gave them power to do."
,"4":"There, too, all the town was stirred by the Teaching. They were divided, some siding with the Jews and some with the apostles."
,"5":"A move was made by pagans and Jews, together with their leaders, to harm the apostles and to stone them."
,"6":"But Paul and Barnabas learned of this and fled to the Lycaonian towns of Lystra and Derbe and to the surrounding countryside,"
,"7":"where they continued preaching the Good News. Paul and Barnabas spent a fairly long time at Lystra. "
,"8":"There was a crippled man in Lystra who had never been able to stand or walk."
,"9":"One day, as he was listening to the preaching, Paul looked intently at him and saw that he had the faith to be saved."
,"10":"So he spoke to him in a loud voice, 'In the Name of the Lord Jesus Christ, I command you to stand up on your feet!' And the man stood up and began to walk around."
,"11":"When the people saw what Paul had done, they cried out in the language of Lycaonia, 'The gods have come to us in human likeness!'"
,"12":"They named Barnabas Zeus, and Paul they called Hermes, since he was the chief speaker."
,"13":"Even the priest of the Temple of Zeus, which stood outside the town, brought oxen and garlands to the gate; together with the people, he wanted to offer sacrifice to them."
,"14":"When Barnabas and Paul heard this, they tore their garments to show their indignation and rushed into the crowd, shouting,"
,"15":"'Friends, why are you doing this? We are human beings with the same weakness you have and we are now telling you to turn away from these useless things to the living God who made the heavens, the earth, the sea and all that is in them."
,"16":"In past generations he allowed each nation to go its own way,"
,"17":"though he never stopped making himself known; for he is continually doing good, giving you rain from heaven and fruitful seasons, providing you with food and filling your hearts with gladness.'"
,"18":"Even these words could hardly keep the crowd from offering sacrifice to them."
,"19":"They were there teaching some time. But some Jews arrived from Antioch and Iconium to argue with Paul and Barnabas. They persuaded the people to reject them, saying that all this was untrue. Finally they stoned Paul and dragged him out of the town, leaving him for dead."
,"20":"But when his disciples gathered around him, he stood up and returned to the town. And the next day he left for Derbe with Barnabas."
,"21":"After proclaiming the gospel in that town and making many disciples, they returned to Lystra and Iconium and on to Antioch."
,"22":"They were strengthening the disciples and encouraging them to remain firm in the faith, for they said, 'We must go through many trials to enter the Kingdom of God.'"
,"23":"In each church they appointed elders and, after praying and fasting, they commended them to the Lord in whom they had placed their faith."
,"24":"Then they traveled through Pisidia, and came to Pamphylia."
,"25":"They preached the Word in Perga and went down to Attalia."
,"26":"From there they sailed back to Antioch, where they had first been commended to God's grace for the task they had now completed."
,"27":"On their arrival they gathered the Church together and told them all that God had done through them and how he had opened the door of faith to the non-Jews."
,"28":"They spent a fairly long time there with the disciples."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Some persons who had come from Judea to Antioch were teaching the brothers in this way, 'Unless you are circumcised according to the law of Moses, you cannot be saved.'"
,"2":"Because of this there was trouble, and Paul and Barnabas had fierce arguments with them. For Paul told the people to remain as they were when they became believers. Finally those who had come from Jerusalem suggested that Paul and Barnabas and some others go up to Jerusalem to discuss the matter with the apostles and elders."
,"3":"They were sent on their way by the Church. As they passed through Phoenicia and Samaria they reported how the non-Jews had turned to God, and there was great joy among all the brothers and sisters."
,"4":"On their arrival in Jerusalem, they were welcomed by the Church, the apostles and the elders, to whom they told all that God had done through them."
,"5":"Some believers, however, who belonged to the party of the Pharisees, stood up and said that non-Jewish men must be circumcised and instructed to keep the law of Moses."
,"6":"So the apostles and elders met together to consider this matter."
,"7":"As the discussions became heated, Peter stood up and said to them, 'Brothers, you know what God did among us in the early days, so that non-Jews could hear the Good News from me and believe."
,"8":"God, who can read hearts, put himself on their side by giving the Holy Spirit to them just as he did to us."
,"9":"He made no distinction between us and them and cleansed their hearts through faith."
,"10":"So why do you want to put God to the test? Why do you lay on the disciples a burden that neither our ancestors nor we ourselves were able to carry?"
,"11":"We believe, indeed, that we are saved through the grace of the Lord Jesus, just as they are.'"
,"12":"The whole assembly kept silent as they listened to Paul and Barnabas tell of all the miraculous signs and wonders that God had done through them among the non-Jews."
,"13":"After they had finished, James spoke up, 'Listen to me, brothers."
,"14":"Symeon has just explained how God first showed his care by taking a people for himself from non-Jewish nations."
,"15":"And the words of the prophets agree with this, for Scripture says,"
,"16":"After this I will return and rebuild the booth of David which has fallen; I will rebuild its ruins and set it up again."
,"17":"Then the rest of humanity will look for the Lord, and all the nations will be consecrated to my Name. So says the Lord, who does today"
,"18":"what he decided from the beginning."
,"19":"Because of this, I think that we should not make difficulties for those non-Jews who are turning to God."
,"20":"Let us just tell them not to eat food that is unclean from having been offered to idols; to keep themselves from prohibited marriages; and not to eat the flesh of animals that have been strangled, or any blood."
,"21":"For from the earliest times Moses has been taught in every place, and every sabbath his laws are recalled.'"
,"22":"Then the apostles and elders together with the whole Church decided to choose representatives from among them to send to Antioch with Paul and Barnabas. These were Judas, known as Barsabbas, and Silas, both leading men among the brothers."
,"23":"They took with them the following letter: Greetings from the apostles and elders, your brothers, to the believers of non-Jewish birth in Antioch, Syria and Cilicia. "
,"24":"We have heard that some persons from among us have worried you with their discussions and troubled your peace of mind. They were not appointed by us."
,"25":"But now, it has seemed right to us in an assembly, to choose representatives and to send them to you, along with our beloved Barnabas and Paul,"
,"26":"who have dedicated their lives to the service of our Lord Jesus Christ."
,"27":"We send you then Judas and Silas who themselves will give you these instructions by word of mouth."
,"28":"We, with the Holy Spirit, have decided not to put any other burden on you except what is necessary:"
,"29":"You are to abstain from blood from the meat of strangled animals and from prohibited marriages. If you keep yourselves from these, you will do well. Farewell.'"
,"30":"After saying good-bye, the messengers went to Antioch, where they assembled the community and handed them the letter."
,"31":"When they read the news, all were delighted with the encouragement it gave them."
,"32":"Judas and Silas, who were themselves prophets, spoke at length to encourage and strengthen them."
,"33":"After they had spent some time there, the messengers were sent off in peace by the believers;"
,"34":"Silas, however, preferred to stay with them and only Judas went off."
,"35":"So Paul and Barnabas continued in Antioch, teaching and preaching with many others the word of God."
,"36":"After some days Paul said to Barnabas, 'Let us return and visit the believers in every town where we proclaimed the word of the Lord, to see how they are getting on.'"
,"37":"Barnabas wanted to take with them John also called Mark,"
,"38":"but Paul did not think it right to take him since he had not stayed with them to the end of their mission, but had turned back and left them in Pamphylia."
,"39":"Such a sharp disagreement resulted that the two finally separated. Barnabas took Mark along with him and sailed for Cyprus."
,"40":"Paul, for his part, chose Silas and left, commended by the brothers and sisters to the grace of the Lord."
,"41":"He traveled throughout Syria and Cilicia, strengthening the churches there."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Paul traveled on to Derbe and then to Lystra. A disciple named Timothy lived there, whose mother was a believer of Jewish origin but whose father was a Greek."
,"2":"As the believers at Lystra and Iconium spoke well of him, Paul wanted Timothy to accompany him."
,"3":"So he took him and, because of the Jews of that place who all knew that his father was a Greek, he circumcised him."
,"4":"As they traveled from town to town, they delivered the decisions of the apostles and elders in Jerusalem, for the people to obey."
,"5":"Meanwhile, the churches grew stronger in faith and increased in number every day."
,"6":"They traveled through Phrygia and Galatia, because they had been prevented by the Holy Spirit from preaching the message in the province of Asia."
,"7":"When they came to Mysia, they tried to go on to Bithynia, but the Spirit of Jesus did not allow them to do this."
,"8":"So, passing by Mysia, they went down to Troas."
,"9":"There one night Paul had a vision. A Macedonian stood before him and begged him, 'Come over to Macedonia and help us!'"
,"10":"When he awoke, he told us of this vision and we understood that the Lord was calling us to give the Good News to the Macedonian people."
,"11":"So we put out to sea from Troas and sailed straight across to Samothrace Island, and the next day to Neapolis."
,"12":"From there we went inland to Philippi, the leading city of the district of Macedonia, and a Roman colony. We spent some days in that city."
,"13":"On the sabbath we went outside the city gate to the bank of the river where we thought the Jews would gather to pray. We sat down and began speaking to the women who were gathering there."
,"14":"One of them was a God-fearing woman named Lydia from Thyatira City, a dealer in purple cloth. As she listened, the Lord opened her heart to respond to what Paul was saying. "
,"15":"After she had been baptized together with her household, she invited us to her house, 'If you think I am faithful to the Lord, come and stay at my house.' And she persuaded us to accept her invitation."
,"16":"One day, as we were on our way to the place of prayer, we were met by a slave girl who had a divining spirit and gained much profit for her owners by her fortune-telling."
,"17":"She followed Paul and the rest of us shouting, 'These people are servants of the Most High God. They will make known to you a way of salvation.'"
,"18":"The girl did this for several days until Paul was annoyed. Then he turned around and said to the spirit, 'In the name of Jesus Christ, I command you, come out of her!' The spirit went out of her that very moment."
,"19":"When her owners realized that all the profits they expected had gone, they seized Paul and Silas and dragged them into the marketplace before the local authorities."
,"20":"And when they had turned them over to the officials, they said,"
,"21":"'These people are Jews and they are disturbing our city. They have come here to introduce customs which are not lawful for us Romans to adopt or practice.'"
,"22":"So they set the crowd against them and the officials tore the clothes off Paul and Silas and ordered them to be flogged."
,"23":"And after inflicting many blows on them, they threw them into prison, charging the jailer to guard them safely."
,"24":"Upon receiving these instructions, he threw them into the inner cell and fastened their feet between heavy blocks of wood."
,"25":"About midnight, Paul and Silas were praying and singing hymns to God, and the other prisoners were listening."
,"26":"Suddenly a severe earthquake shook the place, rocking the prison to its foundations. Immediately all the doors flew open and the chains of all the prisoners fell off."
,"27":"The jailer woke up to see the prison gates wide open. Thinking that the prisoners had escaped, he drew his sword to kill himself,"
,"28":"but Paul shouted to him, 'Do not harm yourself! We are all still here.'"
,"29":"The jailer asked for a light, then rushed in, and fell at the feet of Paul and Silas."
,"30":"After he had secured the other prisoners, he led them out and asked, 'Sirs, what must I do to be saved?'"
,"31":"They answered, 'Believe in the Lord Jesus Christ and you and your household will be saved.'"
,"32":"Then they spoke the word of God to him and to all his household."
,"33":"Even at that hour of the night, the jailer took care of them and washed their wounds; and he and his whole household were baptized at once."
,"34":"He led them to his house, spread a meal before them and joyfully celebrated with his whole household his newfound faith in God."
,"35":"The next morning the officials sent police officers with the order, 'Let those men go.'"
,"36":"So the jailer said to Paul and Silas, 'The officials have sent an order for you and Silas to be released. You may leave and go in peace.'"
,"37":"But Paul said to him, 'They flogged us publicly, and jailed us without trial, men who are Roman citizens; and now they want to smuggle us out secretly? Oh no! Let them come themselves and lead us out.'"
,"38":"The police officers reported this to the officials, who were afraid when they heard that Paul and Silas were Roman citizens."
,"39":"So they went to the prison with many of their friends and invited them to leave, 'We did not know that you were upright men.' And when Paul and Silas were leaving, they added, 'When you are out, please do not bring trouble on us for having spoken sharply to you.'"
,"40":"Once outside the prison, Paul and Silas went to Lydia's house where they met and encouraged the brothers and sisters, and then departed."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Paul and Silas took the road through Amphipolis and Apollonia and came to Thessalonica, where there was a Jewish synagogue."
,"2":"As Paul used to do, he went to the synagogue and on three sabbaths he held discussions with them about the Scriptures."
,"3":"He explained and proved to them that the Messiah had to suffer and rise from the dead, and he said, 'Such a Messiah is this Jesus whom I am proclaiming to you.'"
,"4":"Some of them were convinced and joined Paul and Silas. So too did a great number of Greeks sympathetic to Judaism and many prominent women."
,"5":"This only made the Jews jealous, so they gathered some of the good-for-nothing street loafers and formed a mob to start a riot in the town. They came to the house of Jason, in an attempt to bring Paul and Silas before the people's assembly."
,"6":"Not finding them there, they dragged off Jason and some believers to the city authorities shouting, 'These people who have turned the world upside down have come here also,"
,"7":"and Jason has given them hospitality. They all disregard the decrees of the Emperor and claim that there is another king, Jesus.'"
,"8":"In this way they upset the crowd and the city officials who heard them."
,"9":"The officials released Jason and the others on bail."
,"10":"As soon as night fell, the believers sent Paul and Silas off to Beroea. On their arrival they went to the Jewish synagogue."
,"11":"Its members were more open-minded than those in Thessalonica and welcomed the message with great enthusiasm. Each day they examined the Scriptures to see if these things were so."
,"12":"Many of them came to believe, as did numerous influential Greek women, and many men as well."
,"13":"But when the Jews of Thessalonica came to know that the word of God had been proclaimed by Paul in Beroea also, they hurried there to cause a commotion and stir up the crowds."
,"14":"At once, the believers sent Paul away to the coast; but both Silas and Timothy stayed in Beroea."
,"15":"Paul was taken as far as Athens by his escort, who then returned to Beroea with instructions for Silas and Timothy to come to him as soon as possible."
,"16":"While Paul was waiting for them in Athens, he felt very uneasy at the sight of a city full of idols."
,"17":"He held discussions in the synagogue with the Jews and the God-fearing people, as well as daily debates in the public square with ordinary passersby."
,"18":"Epicureans and Stoic philosophers debated with him, some of them asking, 'What is this babbler trying to say?' Others commented, 'He sounds like a promoter of foreign gods,' because he was heard to speak of Jesus and 'the Resurrection.'"
,"19":"So they took Paul and led him off to the Areopagus hall, and said, 'We would like to know what this new teaching is that you are talking about."
,"20":"Some of the things we hear you say sound strange to us, and we would like to know what they mean.'"
,"21":"Indeed, all Athenian citizens, as well as the foreigners who live there, have as their favorite occupation talking about or listening to the latest news."
,"22":"Then Paul stood up in the Areopagus hall and said, 'Athenian citizens, I note that in every way you are very religious."
,"23":"As I walked around looking at your shrines, I even discovered an altar with this inscription: To an unknown God. Now, what you worship as unknown, I intend to make known to you."
,"24":"God, who made the world and all that is in it, does not dwell in sanctuaries made by human hands, being as he is Lord of heaven and earth."
,"25":"Nor does his worship depend on anything made by human hands, as if he were in need. Rather it is he who gives life and breath and everything else to everyone."
,"26":"From one stock he created the whole human race to live throughout all the earth, and he fixed the time and the boundaries of each nation."
,"27":"He wanted them to seek him by themselves, even if it were only by groping for him, and eventually to find him. Yet he is not far from any one of us. "
,"28":"For in him we live and move and have our being, as some of your poets have said: for we too are his offspring."
,"29":"If we are indeed God's offspring, we ought not to think of divinity as something like a statue of gold or silver or stone, a product of human art and imagination."
,"30":"But now God prefers to overlook this time of ignorance and he calls on all people to change their ways."
,"31":"He has already set a day on which he will judge the world with justice through a man he has appointed. And, so that all may believe it, he has just given a sign by raising this man from the dead.'"
,"32":"When they heard Paul speak of a resurrection from death, some made fun of him, while others said, 'We must hear you on this topic some other time.'"
,"33":"At that point Paul left."
,"34":"But a few did join him, and believed. Among them were Dionysius, a member of the Areopagus court, a woman named Damaris, and some others."
}`)
	CurrentBook.AddChapter(18, `{
"1":"After this, Paul left Athens and went to Corinth."
,"2":"There he found a Jew named Aquila, a native of Pontus, who had recently come from Italy with his wife Priscilla, following a decree of the Emperor Claudius which ordered all Jews to leave Rome."
,"3":"Paul went to visit them and then stayed and worked with them because they shared the same trade of tentmaking."
,"4":"Every sabbath he held discussions in the synagogue, trying to convince both Jews and Greeks."
,"5":"When Silas and Timothy came down from Macedonia, Paul was able to give himself wholly to preaching and proving to the Jews that Jesus was the Messiah."
,"6":"One day when they opposed him and insulted him, he shook the dust from his clothes in protest, saying, 'You yourselves will account for your deeds! I am not to blame if from now on I go to the non-Jews.'"
,"7":"So Paul left there and went to the house of a God-fearing man named Titus Justus who lived next door to the synagogue."
,"8":"A leading man of the synagogue, Crispus, along with his whole household, believed in the Lord. On hearing Paul, many more Corinthians believed and were baptized."
,"9":"One night, in a vision, the Lord said to Paul, 'Do not be afraid, but continue speaking and do not be silent,"
,"10":"for many people in this city are mine. I am with you, so no one will harm you.'"
,"11":"So Paul stayed a year and a half in that place, teaching the word of God among them."
,"12":"When Gallio was governor of Achaia, the Jews made a united attack on Paul and brought him before the court. And they accused him,"
,"13":"'This man tries to persuade us to worship God in ways that are against the Law.'"
,"14":"Paul was about to speak in his own defense when Gallio said to the Jews, 'If it were a matter of a misdeed or vicious crime, I would have to consider your complaint."
,"15":"But since this is a quarrel about teachings and divine names that are proper to your own law, see to it yourselves: I refuse to judge such matters.'"
,"16":"And he sent them out of the court."
,"17":"Then the people seized Sosthenes, a leading man of the synagogue, and beat him in front of the tribunal; but Gallio paid no attention to it."
,"18":"Paul stayed on with the disciples in Corinth for many days; he then left them and sailed off with Priscilla and Aquila for Syria. And as he was no longer under a vow he had taken, he shaved his head before sailing from Cenchreae."
,"19":"When they reached Ephesus, he left Priscilla and Aquila behind and entered the synagogue to hold discussions with the Jews."
,"20":"But although they asked him to stay longer, he declined."
,"21":"And he took leave of them saying, 'God willing, I will come back to you again.' Then he set sail from Ephesus."
,"22":"On landing at Caesarea, he went up to greet the Church, and then went down to Antioch."
,"23":"After spending some time there, he left and traveled from place to place through Galatia and Phrygia, strengthening the disciples."
,"24":"A certain Jew named Apollos, a native of Alexandria, arrived at Ephesus. He was an eloquent speaker and an authority on the Scriptures,"
,"25":"and he had some knowledge of the way of the Lord. With great enthusiasm he preached and taught correctly about Jesus, although he knew only of John's baptism."
,"26":"As he began to speak boldly in the synagogue, Priscilla and Aquila heard him; so they took him home with them and explained to him the way more accurately."
,"27":"As Apollos wished to go to Achaia, the believers encouraged him and wrote to the disciples there to welcome him. When he arrived, he greatly strengthened those who, by God's grace, had become believers,"
,"28":"for he vigorously refuted the Jews, proving from the Scriptures that Jesus is the Messiah."
}`)
	CurrentBook.AddChapter(19, `{
"1":"While Apollos was in Corinth, Paul traveled through the interior of the country and came to Ephesus. There he found some disciples"
,"2":"whom he asked, 'Did you receive the Holy Spirit when you became believers?' They answered, 'We have not even heard that anyone may receive the Holy Spirit.'"
,"3":"Paul then asked, 'What kind of baptism have you received?' And they answered, 'The baptism of John.'"
,"4":"Paul then explained, 'John's baptism was for conversion, but he himself said they should believe in the one who was to come, and that one is Jesus.'"
,"5":"Upon hearing this, they were baptized in the name of the Lord Jesus."
,"6":"Then Paul laid his hands on them and the Holy Spirit came down upon them; and they began to speak in tongues and to prophesy."
,"7":"There were about twelve of them in all."
,"8":"Paul went into the synagogue and for three months he preached and discussed there boldly, trying to convince them about the Kingdom of God."
,"9":"Some of them, instead of believing, grew obstinate and criticized the way publicly. So Paul departed from them and took the disciples with him. He taught daily in the lecture hall of a certain Tyrannus, from eleven to four in the afternoon."
,"10":"He did this for two years, so that all those who lived in the province of Asia, both Jews and non-Jews, heard the word of the Lord."
,"11":"God did extraordinary deeds of power through the hands of Paul."
,"12":"Even handkerchiefs or cloths that had touched his skin were laid upon the sick and their illnesses were cured, and evil spirits also departed from them."
,"13":"Some Jews who traveled around driving out evil spirits, also tried to use the name of the Lord Jesus over those possessed by evil spirits, saying, 'I command you by this Jesus whom Paul preaches.'"
,"14":"Among them were the sons of a Jewish priest named Sceva."
,"15":"But one day, when they entered a house and dared to do this, the evil spirit said to them, 'Jesus I recognize and Paul I know; but who are you?'"
,"16":"Then the man with the evil spirit sprang at them and overpowered first one and then another. And he handled them so violently that they fled from that house naked and mauled."
,"17":"This became known to all the Jews and Greeks living in Ephesus; all of them were very impressed and the name of the Lord Jesus came to be held in great honor."
,"18":"Many of those who had become believers came forward and openly acknowledged their former practices."
,"19":"Many who had practiced magic arts collected their books and burned them in front of everyone. When the value of these was assessed, it came to fifty thousand silver coins."
,"20":"In this way, the word of the Lord spread widely and with power."
,"21":"When all these events were completed Paul, led by the Holy Spirit, decided to travel through Macedonia and Achaia again and then go on to Jerusalem. And he said, 'After I have been there, I must visit Rome also.'"
,"22":"So he sent two of his assistants, Timothy and Erastus, to Macedonia ahead of him, while he himself stayed on for a time in Asia."
,"23":"About that time the city was deeply troubled because of the way."
,"24":"It all began because of a certain silversmith named Demetrius, who made silver models of the temple of the goddess Artemis and whose business brought a great deal of profit to the workers."
,"25":"He called them, together with others who did similar work, and said, 'Friends, you know that our prosperity depends on this work."
,"26":"But, as you can see and hear for yourselves, this Paul has led astray a great number of people, not only here in Ephesus, but also throughout most of the province of Asia. And he has convinced them that gods made by human hands are no gods at all."
,"27":"The danger grows that not only our trade will be discredited, but even that the temple of the great goddess Artemis will count for nothing. She whom Asia and all the world worships may soon be stripped of her renown.'"
,"28":"On hearing this they became enraged and began shouting, 'Great is Artemis of the Ephesians!'"
,"29":"The uproar spread throughout the whole city. The mob rushed to the theater, dragging with them Gaius and Aristarchus, two Macedonians who were Paul's traveling companions."
,"30":"Paul wished to face this crowd, but the disciples would not let him."
,"31":"Some of the counselors of the Asian province also, who were friends of Paul, sent him a message begging him not to show himself in the theater."
,"32":"Meanwhile the whole assembly was in an uproar. Some shouted one thing, and some shouted another and most of them did not know why they were there."
,"33":"Some of the crowd wanted a certain Alexander to speak, whom the Jews put forward. Alexander intended to make a speech of defense before the crowd,"
,"34":"but when they recognized that he was a Jew, they chanted all together for about two hours, 'Great is Artemis of the Ephesians!'"
,"35":"Finally the town clerk was able to calm the mob. He said, 'Citizens of Ephesus, who does not know that Ephesus is keeper of the temple of the great Artemis, and of her image which fell from the sky?"
,"36":"Since these things are undeniable, you must calm yourselves and do nothing rash."
,"37":"These men whom you brought here are not temple-robbers nor have they spoken ill of our goddess."
,"38":"If Demetrius and his fellow craftsmen want to bring charges against anyone, the courts are open and there are officials. Let them bring charges against each other."
,"39":"If there is anything further that needs to be investigated, let it be done in the lawful assembly."
,"40":"For as it is today, we are in danger of being charged with rioting, since there is no valid excuse we can give for this wild demonstration.'"
,"41":"And the town clerk dismissed the assembly."
}`)
	CurrentBook.AddChapter(20, `{
"1":"After the uproar died down, Paul called his disciples together to encourage them. Then he said goodbye and set out on his journey to Macedonia."
,"2":"He traveled throughout those regions and spent himself in speaking and encouraging them. He finally arrived in Greece."
,"3":"When he had been there for three months, he wanted to set sail for Syria, but as the Jews were plotting against him, he decided to return by way of Macedonia."
,"4":"When he was about to leave for the Asian province, some companions went with him, Sopater, son of Pyrrhus, from Berea, Aristarchus and Secundus from Thessalonica, Gaius from Derbe, Timothy, Tychicus and Trophimus from Asia."
,"5":"So they went ahead and waited for us in Troas,"
,"6":"while we set sail from Philippi as soon as the festival of Unleavened Bread was over. Five days later we joined them in Troas where we spent a week."
,"7":"On the first day of the week we were together for the breaking of the bread, and Paul, who intended to leave the following day, spoke at length. The discourse went on until midnight,"
,"8":"with many lamps burning in the upstairs room where we were gathered. A young man named Eutychius was sitting on the window ledge,"
,"9":"and as Paul kept on talking, Eutychius grew more and more sleepy, until he finally went sound asleep and fell from the third floor to the ground. There they found him dead."
,"10":"Paul went down, bent over him and took him in his arms. 'Do not be alarmed,' he said, 'there is life in him.'"
,"11":"Then he went back upstairs, broke the bread and ate. After that he kept on talking with them for a long time until daybreak and then he left."
,"12":"As for the young man, they lifted him up alive and were greatly comforted."
,"13":"We went on ahead to the ship and sailed for Assos, where we were to pick up Paul. This was the arrangement since Paul intended to travel by foot."
,"14":"In fact, we met him at Assos and taking him aboard, we went on to Mitylene."
,"15":"We sailed from there and arrived off Chios the next day. A day later we came to Samos and the following day we reached Miletus."
,"16":"Paul had decided to sail past Ephesus, so as not to lose time in Asia, for he was eager to reach Jerusalem by the day of Pentecost, if at all possible."
,"17":"From Miletus Paul sent word to Ephesus, summoning the elders of the Church."
,"18":"When they came to him, he addressed them, 'You know how I lived among you from the first day I set foot in the province of Asia,"
,"19":"how I served the Lord in humility through the sorrows and trials that the Jews caused me."
,"20":"You know that I never held back from doing anything that could be useful for you; I spoke publicly and in your homes"
,"21":"and I urged Jews and non-Jews alike to turn to God and believe in our Lord Jesus."
,"22":"But now I am going to Jerusalem, chained by the Spirit, without knowing what will happen to me there."
,"23":"Yet in every city the Holy Spirit warns me that imprisonment and troubles await me."
,"24":"Indeed I put no value on my life, if only I can finish my race and complete the service to which I have been assigned by the Lord Jesus, to announce the good news of God's grace."
,"25":"I now feel sure that none of you among whom I have gone about proclaiming the Kingdom of God will ever see me again."
,"26":"Therefore I declare to you this day that my conscience is clear with regard to all of you."
,"27":"For I have spared no effort in fully declaring to you God's will."
,"28":"Keep watch over yourselves and over the whole flock the Holy Spirit has placed into your care. Shepherd the Church of the Lord which he has won at the price of his own blood."
,"29":"I know that after I leave, ruthless wolves will come among you and not spare the flock."
,"30":"And from among yourselves, some will arise corrupting the truth and inducing the disciples to follow them."
,"31":"Be on the watch, therefore, remembering that for three years, night and day, I did not cease to warn everyone even with tears."
,"32":"Now I commend you to God and to his grace-filled word, which is able to make you grow and gain the inheritance that you shall share with all the saints."
,"33":"I have not looked for anyone's silver, gold or clothing."
,"34":"You yourselves know that these hands of mine have provided for both my needs and the needs of those who were with me."
,"35":"In every way I have shown you that by so working hard one must help the weak, remembering the words that the Lord Jesus himself said, 'Happiness lies more in giving than in receiving.''"
,"36":"After this discourse, Paul knelt down with them and prayed."
,"37":"Then they all began to weep and threw their arms around him and kissed him."
,"38":"They were deeply distressed because he had said that they would never see him again. And they went with him even to the ship."
}`)
	CurrentBook.AddChapter(21, `{
"1":"When we had finally taken leave of them, we put out to sea and sailed straight to Cos, and the next day to Rhodes, and from there to Patara."
,"2":"There we found a ship that made for Phoenicia; we went aboard and set sail."
,"3":"We caught sight of Cyprus but passed it by on our left, as we continued on towards Syria. We landed at Tyre, where the ship had to unload cargo."
,"4":"There we found the disciples and stayed a week. Warned by the Spirit, they told Paul not to go to Jerusalem."
,"5":"But when it was time, we departed and continued on our journey. All of them, wives and children included, came out of the city with us, and on the beach we knelt down and prayed."
,"6":"After that we said good-bye to one another; we boarded the ship and they returned home."
,"7":"We continued our journey, sailing from Tyre to Ptolemais, where we greeted the brothers and sisters and spent a day with them."
,"8":"On the following day we left and came to Caesarea. There we entered the house of Philip the evangelist and we stayed with him. He was one of the Seven"
,"9":"and had four unmarried daughters who were gifted with prophecy."
,"10":"We were there some days when a prophet named Agabus came down from Judea. Coming to us, he took Paul's belt and bound his own feet and hands with it, saying,"
,"11":"'Thus speaks the Holy Spirit: This is how the Jews in Jerusalem will bind the owner of this belt and hand him over to the foreign power.'"
,"12":"When we heard this, we, together with these people of Caesarea, begged Paul not to go up to Jerusalem."
,"13":"Then he answered, 'Why are you weeping and breaking my heart? For I am ready not only to be imprisoned but also to die in Jerusalem for the name of the Lord Jesus.'"
,"14":"When he would not be persuaded, we gave up and said, 'The Lord's will be done.'"
,"15":"After this we got ready and went up to Jerusalem."
,"16":"With us were some of the disciples of Caesarea who brought us to the house of a Cypriot where we were to stay. He was called Mnason and was one of the early disciples."
,"17":"When we arrived in Jerusalem the brothers welcomed us warmly."
,"18":"The next day Paul went with us to James' house where all the elders had gathered."
,"19":"After greeting them, Paul began telling them in detail everything God had done among the non-Jews through his ministry."
,"20":"After hearing this, they all praised God, but they said, 'You see, brother, how many thousands of Jews of Judea have come to believe, and all of them are zealous for the Law."
,"21":"Yet they have heard that you teach the Jews who live in pagan nations to depart from Moses, telling them not to have their sons circumcised and to renounce Jewish customs."
,"22":"We shall gather the assembly for, in any case, they will hear that you have arrived."
,"23":"Then do as we tell you. There are four men among us who have made a vow. "
,"24":"Take them and purify yourself along with them and pay the sacrifice for them to shave their heads. In that way everyone will know that there is nothing true in what they have been told about you, but that you go on keeping the Law."
,"25":"As for the non-Jews who have become believers, we sent them a letter to tell them that they are only obliged not to eat meat offered to idols, or blood, or flesh of strangled animals; and also to avoid prohibited sexual union.'"
,"26":"So the next day Paul took the men; he purified himself with them and entered the Temple to give notice of what day the sacrifice would be offered for each of them to end his time of purification."
,"27":"When the seven days were almost over, some Jews from Asia, who saw Paul in the Temple, began to stir up the whole crowd. They seized him"
,"28":"shouting, 'Fellow Israelites, help! This is the man who is spreading his teaching everywhere against our people, our law and this Sanctuary. And now he has even brought non-Jews into the Temple area, defiling this Holy Place.'"
,"29":"They said this because earlier they had seen Trophimus, an Ephesian, with Paul in the city and they thought that Paul had taken him into the Temple."
,"30":"Then turmoil spread through the whole city. People came running from all sides. They seized Paul and dragged him outside the Temple. At once the gates were shut."
,"31":"They would have killed him, had not a report reached the commander of the Roman troops that all of Jerusalem was rioting."
,"32":"At once the commander took some officers and soldiers and rushed down to the crowd. On seeing him with the soldiers, the crowd stopped beating Paul. "
,"33":"The commander went over to Paul, arrested him and ordered him to be bound with two chains; then he inquired who he was and what he had done."
,"34":"But some in the crowd shouted one thing and others another. As the commander was unable to find out the facts because of the uproar, he ordered Paul to be brought to the fortress."
,"35":"When Paul reached the steps, he actually had to be carried up by the soldiers because of the violence of the mob,"
,"36":"for a multitude of people followed shouting, 'Kill him!'"
,"37":"Just as he was about to be taken inside, Paul said to the commander, 'May I say something to you?' He replied, 'So you speak Greek!"
,"38":"Are you not the Egyptian, then, who caused a riot some time ago and let a band of four thousand terrorists out into the desert?' Paul answered,"
,"39":"'I am a Jew, a citizen of Tarsus, a well-known city in Cilicia. I beg you, let me address these people.',The commander agreed. "
,"40":"So Paul standing on the steps, motioned to the people with his hand and, when they were silent, he began to speak to them in Hebrew."
}`)
	CurrentBook.AddChapter(22, `{
"1":"'Brothers and fathers, listen to what I have to say to you in my defense.'"
,"2":"When they heard him speaking to them in Hebrew, they became more quiet. So he went on."
,"3":"'I am a Jew, born in Tarsus in Cilicia, but brought up here in this city where I was educated in the school of Gamaliel, according to the strict observance of our Law. And I was dedicated to God's service as are all of you today."
,"4":"As for this way, I persecuted it to the point of death and arrested its followers, both men and women, throwing them into prison."
,"5":"The High Priest and the whole Council of elders can bear witness to this. From them I received letters for the Jewish brothers in Damascus and I set out to arrest the Christians I would find there and bring them back to Jerusalem for punishment."
,"6":"But as I was traveling along, nearing Damascus, at about noon a great light from the sky suddenly flashed about me."
,"7":"I fell to the ground and heard a voice saying to me: 'Saul, Saul, why do you persecute me?'"
,"8":"I answered: 'Who are you, Lord?' And he said to me: 'I am Jesus the Nazarean whom you persecute.'"
,"9":"The men who were with me saw the light and were afraid, but they did not understand the voice of the one who was speaking to me."
,"10":"I asked: 'What shall I do, Lord?' And the Lord replied: 'Get up and go to Damascus; there you will be told all that you are destined to do.'"
,"11":"Yet the brightness of that light had blinded me and so I was led by the hand into Damascus by my companions."
,"12":"There a certain Ananias came to me. He was a devout observer of the Law and well spoken of by all the Jews who were living there."
,"13":"As he stood by me, he said: 'Brother Saul, recover your sight.' At that moment I could see and I looked at him."
,"14":"He then said, 'The God of our ancestors has chosen you to know his will, to see the Just One and to hear the words from his mouth."
,"15":"From now on you shall be his witness before all the pagan peoples and tell them all that you have seen and heard."
,"16":"And now, why delay? Get up and be baptized and have your sins washed away by calling upon his Name.'"
,"17":"On my return to Jerusalem I was praying in the Temple, when I fell into a trance"
,"18":"and saw him. He spoke to me: 'Get ready to leave Jerusalem without delay, because they will not accept your testimony about me.'"
,"19":"I answered: 'Lord, they know well that I imprisoned those who believed in you and had them beaten in every synagogue,"
,"20":"and while the blood of your witness Stephen was being poured out, I stood by and approved it and even guarded the cloaks of his murderers.'"
,"21":"Then he said to me: 'Go, for I am sending you far away to the pagan nations.''"
,"22":"Up to this point the crowd listened to Paul, but on hearing the last words, they began to shout, 'Kill him! He does not deserve to live!'"
,"23":"They were screaming and waving their cloaks and throwing dust into the air."
,"24":"So the commander ordered Paul to be brought inside the fortress and questioned after flogging, to find out why they made such an outcry against him."
,"25":"But when the soldiers had strapped him down, Paul said to the officer standing there, 'Is it legal to flog a Roman citizen without a trial?'"
,"26":"On hearing this the officer went to the commander and said, 'What are you doing? That man is a Roman citizen.'"
,"27":"So the commander came and asked him, 'Tell me, are you a Roman citizen?' 'Yes,' answered Paul."
,"28":"The commander then said, 'It cost me a large sum of money to become a Roman citizen.' Paul answered, 'I am one by birth.'"
,"29":"Then those who were about to question him backed away, and the commander himself was alarmed when he realized that he had put a Roman citizen in chains."
,"30":"The next day the commander wanted to know for certain the charges the Jews were making against Paul. So he released him from prison and called together the High Priest and the whole Council; and they brought Paul down and made him stand before them."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Paul looked directly at the Council and said, 'Brothers, to this day I have lived my life with a clear conscience before God.'"
,"2":"At that the High Priest Ananias ordered his attendants to strike him on the mouth."
,"3":"Then Paul said, 'God is about to strike you, you whitewashed wall! You sit there to judge me according to the Law, and you break the Law by ordering me to be struck!'"
,"4":"At this the attendants protested, 'How dare you insult God's High Priest?'"
,"5":"Paul answered, 'Brothers, I did not know that he was the High Priest. For Scripture says: You shall not curse the ruler of your people.'"
,"6":"Paul knew that part of the Council were Sadducees and others Pharisees; so he spoke out in the Council, 'Brothers, I am a Pharisee, son of a Pharisee. It is for the hope in the resurrection of the dead that I am on trial here.'"
,"7":"At these words, an argument broke out between the Pharisees and the Sadducees and the whole assembly was divided."
,"8":"For the Sadducees claim that there is neither resurrection, nor angels nor spirits, while the Pharisees acknowledge all these things."
,"9":"Then the shouting grew louder, and some teachers of the Law of the Pharisee party protested, 'We find nothing wrong with this man. Maybe a spirit or an angel has spoken to him.'"
,"10":"With this the argument became so violent that the commander feared that Paul would be torn to pieces by them. He therefore ordered the soldiers to go down and rescue him from their midst and take him back to the fortress."
,"11":"That night the Lord stood by Paul and said, 'Courage! As you have borne witness to me here in Jerusalem, so must you do in Rome.'"
,"12":"When it was day, certain Jews formed a conspiracy: they bound themselves by an oath not to eat or drink until they had killed Paul."
,"13":"There were more than forty of them who joined in this conspiracy."
,"14":"They went to the high priests and the elders and said, 'We have bound ourselves by oath not to taste food until we have killed Paul."
,"15":"Now then, it is up to you and the Council together to convince the Roman commander to bring him down to you on the pretext that you want to investigate his case more thoroughly. We, for our part, are prepared to kill him before he gets there.'"
,"16":"But the son of Paul's sister heard about the planned ambush, so he went to the headquarters and informed Paul."
,"17":"Paul sent for one of the officers and said, 'Take this young man to the commander for he has something to report to him.'"
,"18":"So the officer took him and brought him to the commander, saying, 'The prisoner Paul called me and asked me to bring this boy to you because he has something to tell you.'"
,"19":"The commander took him by the hand and drawing him aside asked him privately, 'What is it that you have to report to me?'"
,"20":"The boy replied, 'The Jews have agreed among themselves to ask you tomorrow to have Paul brought down to the Council as if to inquire more thoroughly about him."
,"21":"But do not be persuaded by them, for there are more than forty of them ready to ambush him, having bound themselves by an oath not to eat or drink until they have killed him. They are now ready to do it and are awaiting your decision.'"
,"22":"The commander let the boy go with this advice, 'Do not tell anyone that you gave me this information.'"
,"23":"Then the commander summoned two of his officers and said to them, 'Get ready to leave for Caesarea by nine o'clock tonight, with two hundred infantrymen, seventy horsemen and two hundred spearmen."
,"24":"Provide horses also for Paul to ride, so that he may be brought safely to Felix the governor.'"
,"25":"He then wrote the governor a letter to this effect:"
,"26":"'Claudius Lysias greets the Most Excellent Governor Felix and communicates to him the following:"
,"27":"The Jews had arrested this man and were about to kill him when I intervened with my troops and took him out of their hands, since I knew he was a Roman citizen."
,"28":"As I wanted to know what charge they had against him, I presented him before the Sanhedrin"
,"29":"and I discovered that the accusation related to matters of their Law, but there was nothing which deserved death or imprisonment."
,"30":"When I was informed that the Jews had prepared a plot against this man, I decided to send him to you and told his accusers to present their complaints before you. Farewell.'"
,"31":"The soldiers acted in accordance with these instructions. They took Paul and brought him to Antipatris by night."
,"32":"On the following day, they returned to the fortress but the horsemen continued journeying with him."
,"33":"Upon entering Caesarea they handed the letter to the governor and presented Paul to him."
,"34":"When Felix had read the letter, he asked Paul from which province he was, and when he learned that Paul was from Cilicia,"
,"35":"he said to him: 'I shall hear your accusers when they come.' And he ordered that he be kept in custody in the palace of Herod."
}`)
	CurrentBook.AddChapter(24, `{
"1":"After five days Ananias the High Priest came down to Caesarea with some of the elders and a lawyer named Tertullus. And they presented their case against Paul before the governor."
,"2":"Paul was called in and Tertullus accused him in this way:"
,"3":"'Most Excellent Felix, thanks to you - your labors and your wise reforms - our people now enjoy great peace. We accept all this in every way and in every place, and we are totally grateful to you."
,"4":"So as not to take more of your time, I beg you to listen briefly to us with your usual kindness."
,"5":"We have found that this man is a pest, he creates division among the Jews throughout the world and is a leader of the Nazarene sect."
,"6":"He even tried to profane the Temple, so we seized him. We would have judged him according to our law,"
,"7":"but Lysias the commandant intervened in a very violent way and took him from us."
,"8":"Then he declared that his accusers must present themselves before you. By examining him yourself, you will learn from him about all that we accuse him of.'"
,"9":"The Jews confirmed this, firmly maintaining that all this was so."
,"10":"Then the governor motioned to Paul who said: 'As I know that you have administered this nation for many years, I make my defense with much confidence. "
,"11":"You yourself can ascertain that not more than twelve days ago I went up to Jerusalem to worship,"
,"12":"and that they did not find me disputing with anyone or inciting the people, either in the Temple or in the synagogues or in the city."
,"13":"So they cannot prove the things of which they now accuse me."
,"14":"But this I admit before you, that I serve the God of our ancestors according to the Way which they call a sect. I believe everything written in the Law and in the Prophets,"
,"15":"and I have the same hope in God that they have, that there will be a resurrection of the dead, both the good and the sinners."
,"16":"So I strive always to have a clear conscience before God and before people."
,"17":"After many years, I came to bring help to those of my nation and to offer sacrifices."
,"18":"On that occasion, they found me in the Temple; I had been purified according to the Law and there was no crowd or commotion. Yet all began with some Jews from Asia"
,"19":"who ought to be here before you to accuse me, if they have anything against me."
,"20":"Let these men say what crime they found in me when I stood before the Sanhedrin,"
,"21":"unless it was for having declared in a loud voice when I was before them: 'Today I am being judged on account of the resurrection of the dead.''"
,"22":"Felix who was well-informed about the Way, postponed the case and said to them, 'When the commandant, Lysias, comes down, I will examine the case thoroughly.'"
,"23":"So he ordered the captain to keep Paul under guard, giving him certain liberty and without preventing his friends from attending to him."
,"24":"After some days, Felix came with his wife Drusilla who was a Jew. He sent for Paul and let him speak about faith in Christ."
,"25":"But when Paul spoke about justice, self-control and the future judgment, Felix was frightened and he said to him: 'You may leave now; I shall send for you some other time.'"
,"26":"Felix was hoping that Paul would give him money, so he sent for him often and conversed with him."
,"27":"Two years passed, and Felix was succeeded by Porcius Festus; and as Felix wanted to remain on good terms with the Jews, he left Paul in prison."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Three days after Festus arrived in the province, he went up from Caesarea to Jerusalem."
,"2":"There the chief priests and the elders accused Paul again."
,"3":"In a very hypocritical way, they asked as a favor from Festus that Paul be brought to Jerusalem; but they were planning to kill him on the way."
,"4":"Festus answered that Paul was under custody in Caesarea and, as he himself had to go there shortly, he added,"
,"5":"'Let those of you who have the authority go down with me to Caesarea, and if this man has done anything wrong, let them accuse him.'"
,"6":"Festus did not stay in Jerusalem for more than eight or ten days, and then he went to Caesarea. The next day, he took his seat on the tribunal and sent for Paul."
,"7":"When Paul arrived, the Jews who came from Jerusalem stood around him and presented many serious charges which they could not prove."
,"8":"Paul defended himself from all these saying, 'I have not committed any offense against the Law of the Jews, or against the Temple or against Caesar.'"
,"9":"Then Festus, who wanted to please the Jews, asked Paul: 'Do you wish to go up to Jerusalem to be tried before me?'"
,"10":"Paul answered, 'I am on trial before Caesar's tribunal; here I have to be tried. I have done no wrong to the Jews: you yourself know this very well."
,"11":"If I have committed any crime which deserves death, I accept death. But if I have not done anything of which they accuse me, no one can give me up to them. I appeal to Caesar.'"
,"12":"So Festus, after conferring with his council, answered, 'You have appealed to Caesar. To Caesar you shall go.'"
,"13":"Some days later King Agrippa and his sister Bernice arrived in Caesarea to greet Festus. As they were to stay there several days, Festus told the king about Paul's case and said to him,"
,"14":"'We have here a man whom Felix left as a prisoner."
,"15":"When I was in Jerusalem, the chief priests and the elders of the Jews accused him and asked me to sentence him."
,"16":"I told them that it is not the custom of the Romans to hand over a man without giving him an opportunity to defend himself in front of his accusers."
,"17":"So they came and I took my seat without delay on the tribunal and sent for the man."
,"18":"When the accusers had the floor, they did not accuse him of any of the crimes that I was led to think he had committed;"
,"19":"instead they quarreled with him about religion and about a certain Jesus who has died but whom Paul asserted to be alive."
,"20":"I did not know what to do about this case, so I asked Paul if he wanted to go to Jerusalem to be tried there."
,"21":"But Paul appealed to be judged by the emperor. So I ordered that he be kept in custody until I send him to Caesar.'"
,"22":"Agrippa said to Festus: 'I would like to hear that man.' Festus answered him: 'Tomorrow you shall.'"
,"23":"On the following day, Agrippa and Bernice arrived with great ceremony and entered the audience hall with the commanders and the elders of the city. Festus ordered that Paul be brought in and said:"
,"24":"'King Agrippa and all here present, here you see this man about whom the whole community of the Jews came to see me, in Jerusalem as well as here, protesting loudly that he must not live."
,"25":"I, for my part, am convinced that he has not done anything that deserves death. But after he appealed to be judged by the emperor, I decided to send him on."
,"26":"Well, if I have no definite information, what can I write to Caesar about him? Therefore I present him before all of you, and especially before you, King Agrippa, that you may examine him and that I may know what to write."
,"27":"For it seems absurd to me to send a prisoner without indicating the charges against him.'"
}`)
	CurrentBook.AddChapter(26, `{
"1":"Agrippa said to Paul: 'You may speak in your own defense.' So Paul stretched out his hand and began in this way:"
,"2":"'King Agrippa, you have just heard about the accusations of the Jews. I consider myself fortunate in having the opportunity to defend myself against all this before you today,"
,"3":"for you are an expert in the customs of the Jews and their disputes. Therefore I beg you to listen to me patiently."
,"4":"All the Jews know how I have lived from my youth, how I have lived among my own people and in Jerusalem."
,"5":"They have always known me and they can tell you, if they wish, that I have lived as a Pharisee in the most rigorous sect of our religion."
,"6":"If I am now tried here, it is because of the hope I have in the promise made by God to our ancestors."
,"7":"The hope of attaining this promise is behind the fervent worship which our twelve tribes render to God night and day. Yet now, O king, the Jews accuse me for this hope!"
,"8":"But why refuse to believe that God raises the dead?"
,"9":"I myself in the beginning thought that I had to use all possible means to counteract the Name of Jesus of Nazareth."
,"10":"This I did in Jerusalem and, with the authorization of the chief priests, I put in prison many who believed; and I cast my vote when they were condemned to death."
,"11":"I went round the synagogues and multiplied punishments against them to force them to renounce their faith; such was my rage against them that I pursued them even to foreign cities."
,"12":"With this purpose in mind I went to Damascus with full authority and commissioned by the chief priests."
,"13":"On the way, O King, at midday I saw a light from heaven, more brilliant than the sun, that dazzled me and those who accompanied me."
,"14":"We all fell to the ground and I heard a voice saying to me in Hebrew: 'Saul, Saul, why do you persecute me? In vain do you kick against the goad.'"
,"15":"I answered: 'Who are you, Lord?' And the Lord said: 'I am Jesus whom you persecute."
,"16":"Get up now and stand on your feet. I have revealed myself to you to make you servant and witness to what I have just shown you and to what I will show you later on."
,"17":"I will rescue you from all evil that may come from your own people or from the pagans to whom I am sending you."
,"18":"For you shall open their eyes that they may turn from darkness to light, and from the power of Satan to God; and, through faith in me, may obtain forgiveness of their sins and a place among those who are sanctified.'"
,"19":"Since that time, King Agrippa, I did not stray from this heavenly vision;"
,"20":"on the contrary, I began preaching first to those in Damascus, then to those in Jerusalem and throughout Judea, and then to the pagan nations, that they should repent and turn to God, showing the fruits of true conversion."
,"21":"I was carrying out this mission when the Jews arrested me in the Temple and tried to kill me. But with the help of God, I still stand here today to give my testimony both to the great and the small."
,"22":"I do not teach anything other than what Moses and the Prophets announced beforehand:"
,"23":"the Messiah had to die, and after being the first to be raised from the dead, he would proclaim the light to his people as well as to all nations.'"
,"24":"As Paul came to this point of his defense, Festus said in a loud voice: 'Paul, you are mad; your great learning has deranged your mind!'"
,"25":"But Paul answered: 'I am not mad, Most Excellent Festus, but everything I have said is reliable and true."
,"26":"The king is acquainted with all these things, so to him I speak with such confidence. I am convinced that he knows everything about this case, for these things did not happen in a dark corner."
,"27":"King Agrippa, do you believe the Prophets? I know that you do.'"
,"28":"Agrippa said to him: 'You almost believe that you have already made me a Christian!'"
,"29":"Paul answered him: 'Whether little or more, I would that not only you but all who hear me this day may come to be as I am - except for these chains.'"
,"30":"Then the king rose and, with him, the governor, Bernice and all the attendants."
,"31":"When they went out they talked among themselves and said: 'This man has done nothing to deserve death or imprisonment.'"
,"32":"And Agrippa said to Festus: 'Had he not appealed to Caesar, he could have been set free.'"
}`)
	CurrentBook.AddChapter(27, `{
"1":"When it was decided that we should sail for Italy, they handed over Paul and the other prisoners into the care of an officer of the Augustan battalion, named Julius."
,"2":"We boarded a ship of Adramyttium bound for the Asian coasts, and we left accompanied by Aristarchus, a Macedonian from the city of Thessalonica."
,"3":"We arrived at Sidon on the next day. Julius was very kind to Paul, letting him visit his friends and be cared for by them."
,"4":"From there, we sailed along the sheltered coast of Cyprus, because the winds were against us."
,"5":"We sailed across the seas off Cilicia and Pamphylia and arrived at Myra in Lycia."
,"6":"There the captain found a ship from Alexandria sailing for Italy and made us board it."
,"7":"We sailed slowly for several days, and arrived with great difficulty at Cnidus. As the wind did not allow us to enter that port, we sailed for the shelter of Crete with the Cape of Salmone within sight."
,"8":"We turned with difficulty and arrived at a place called Good Ports, near the city of Lasea."
,"9":"Time passed and the crossing began to be dangerous: we had already celebrated the feast of the Fast."
,"10":"Then Paul said to them: 'Friends, I believe that it would not be very wise to proceed with our crossing for we could lose not only the cargo and the ship but also our lives.'"
,"11":"But the Roman officer relied more on the ship's captain and the owner of the ship than on the words of Paul."
,"12":"And as the port was not suitable for wintering, the majority agreed to set out from there in the hope of reaching the harbor of Crete called Phoenix, overlooking Africa and Choros, where they could spend the winter."
,"13":"Then the south wind began to blow and they thought that they had gained their purpose; they weighed anchor and sailed along the island of Crete."
,"14":"But a little later, a strong wind called 'the northeaster' swept down on them, from across the island."
,"15":"The ship was dragged along and could not face the wind, so that we remained adrift."
,"16":"As we were crossing under the lee of the small island of Cauda, we managed - but with effort - to secure the lifeboat."
,"17":"After lifting it aboard, they used cables to undergird the hull, and since we feared running aground on the sands of Syrtis, they lowered the sea anchor. So we continued to be dragged along."
,"18":"The storm lashed at us so strongly that on the next day they began throwing the cargo overboard."
,"19":"On the third day the sailors with their own hands threw out the ship's gear."
,"20":"For several days neither the sun nor the stars could be seen, and the tempest had not subsided: we lost all hope of saving ourselves."
,"21":"As we had not eaten for days, Paul stood up among them and said: 'Friends, if you had followed my advice when I told you not to set sail from Crete, we would not be in such danger now, and we could have avoided this loss."
,"22":"But now I invite you to regain courage for no one among you shall die; only the ship shall be destroyed."
,"23":"Last night there appeared to me an angel of my God to whom I serve,"
,"24":"and he said to me: 'Paul, do not be afraid, you must present yourself before Caesar's tribunal, and God has guaranteed you the life of all those who sail with you.'"
,"25":"Have courage, therefore, my friends, for I trust in God that it will be just as he told me."
,"26":"But we have to run aground on some island.'"
,"27":"Near midnight on the fourteenth night, as we were drifting in the Adriatic Sea, the sailors suspected that land was near."
,"28":"They measured the depth of the water and it was thirty-seven meters. After a while, they measured it again and it was twenty-seven meters."
,"29":"They feared that we might hit some rocks, so they cast out four anchors from the stern and waited anxiously for morning."
,"30":"Then the sailors tried to escape from the ship under the pretext of extending the cables of the anchors from the bow, so they lowered the lifeboat into the sea."
,"31":"But Paul said to the captain and to the soldiers: 'If they leave the ship, you can-not be saved."
,"32":"So the soldiers cut the mooring cables of the boat and let it fall."
,"33":"As they waited for dawn, Paul urged everyone: 'For fourteen days we have not eaten anything because of anxious waiting."
,"34":"I ask you to eat now if you want to live; be sure that not even a hair of your head will be lost.'"
,"35":"Having said this, he took bread, gave thanks to God in everybody's presence, broke it and began to eat."
,"36":"All were encouraged and they too ate."
,"37":"They were two hundred and seventy-six persons in all."
,"38":"When they had eaten enough, they threw the wheat into the sea to lighten the boat."
,"39":"When morning came, they did not recognize the land but noticed a bay with a beach, so they decided to run the ship aground, if possible."
,"40":"They cast off the anchors and left them in the sea; at the same time, they loosened the ropes of the rudders, hoisted the foresail to the wind and headed for the beach."
,"41":"But they struck a sandbank and the ship ran aground. The bow stuck and was immovable, while the stern was broken up by the violent waves."
,"42":"The soldiers then planned to kill the prisoners for fear that some of them might escape by swimming."
,"43":"But the captain, who wished to save Paul, did not allow them to do this. He ordered those who knew how to swim, to be the first to jump into the water and head for the shore,"
,"44":"and the rest to hold on to planks or pieces of the ship. So all of us reached land safe and sound."
}`)
	CurrentBook.AddChapter(28, `{
"1":"After being saved, we learned that the island was called Malta."
,"2":"The natives were very cordial. They lit a big bonfire and took good care of us all, since it was raining and cold."
,"3":"Paul gathered a bundle of dried twigs and as he threw them into the fire, a viper suddenly came out because of the heat and entwined itself around his hand."
,"4":"When the natives saw the viper hanging from his hand, they said to one another: 'Surely this man is a murderer: he has barely escaped from the raging sea, yet divine justice will not allow him to live.'"
,"5":"But Paul shook off the viper into the fire and did not suffer any harm. They waited to see him swell and die;"
,"6":"but after observing him for a while they saw that nothing happened to him, so they changed their minds and began to say that he was a god."
,"7":"Near this place was an estate owned by the head of the island, named Publius. For three days this man welcomed us hospitably."
,"8":"It so happened that his father was in bed with fever and dysentery. Paul went to see him; he prayed and laid his hands on him and healed him."
,"9":"Because of this, the rest of the sick people on the island came to see him and were cured."
,"10":"So they showered us with kindness, and on our departure they provided us with everything we needed."
,"11":"After three months, we boarded a ship which had spent the winter at the island. It belonged to an Alexandrian company and carried the figurehead of Castor and Pollux as insignia."
,"12":"We sailed for Syracuse, staying there for three days"
,"13":"and, after circling the coast, we arrived at Rhegium. On the following day, a south wind began to blow, and at the end of two days we arrived at Puteoli,"
,"14":"where we found some of our brothers who invited us to stay with them for a week. And that was how we came to Rome."
,"15":"There the brothers and sisters had been informed of our arrival and came out to meet us as far as the Appian Forum and the Three Taverns. When Paul saw them, he gave thanks to God and took courage."
,"16":"Upon our arrival in Rome, the captain turned the prisoners over to the military governor but permitted Paul to lodge in a private house with the soldier who guarded him."
,"17":"After three days, Paul called together the leaders of the Jews. When they had gathered, he said to them: 'Brothers, though I have not done anything against our people or against the traditions of our fathers, I was arrested in Jerusalem and handed over to the Romans."
,"18":"They examined me and wanted to set me free, for they saw nothing in my case that deserved death."
,"19":"But the Jews objected, so I was forced to appeal to Caesar without the least intention of bringing any case against my own people."
,"20":"Therefore, I have asked to see you and speak with you, since it is because of the hope of Israel that I bear these chains.'"
,"21":"They answered: 'We have not received any letter about you from Judea, and none of the brothers who have come from there have brought any message or said anything against you."
,"22":"But we wish to hear from you what you think, although we know already that everywhere people speak against this sect that you belong to.'"
,"23":"They set a day for him and came in great numbers to his lodging. So Paul explained everything he wanted to tell them regarding the Kingdom of God and tried to convince them concerning Jesus, taking the Law of Moses and the Prophets as his starting point. This continued from morning till night."
,"24":"Some were convinced by his words, others were not."
,"25":"Finally the Jews left, still arguing strongly among themselves; and Paul sent them away with this statement:'What the Holy Spirit said has come true, when he spoke to your ancestors through the prophet Isaiah:"
,"26":"Go to this people and say to them: However much you hear, you will not understand; you will see and see again but not perceive."
,"27":"The heart of this people has grown hard; they have covered their ears and closed their eyes, lest they should see with their eyes and hear with their ears, lest their spirit understand, and I should heal them."
,"28":"Let it be known to you, then, that this salvation of God has been sent to the pagans: they will listen.'"
,"30":"Paul stayed for two whole years in a house he himself rented, where he received without any hindrance all those who came to see him."
,"31":"He proclaimed the Kingdom of God and taught the truth about Jesus Christ, the Lord, quite openly and without any hindrance."
}`)

}
func EN_CCB_LoadNTAIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"The Revelation of Jesus Christ. God gave it to him to let his servants know what is soon to take place. He sent his angel to make it known to his servant, John,"
,"2":"who reports everything he saw, for this is the word of God and the declaration of Jesus Christ."
,"3":"Happy is the one who reads aloud these prophetic words, and happy those who hear them and treasure everything written here, for the time is near."
,"4":"From John to the seven Churches of Asia: receive grace and peace from him who is, who was and who is to come, and from the seven Spirits of God which are before his throne,"
,"5":"and from Jesus Christ, the faithful witness, the firstborn of the dead, the ruler of the kings of the earth. To him who loves us and has washed away our sins with his own blood, "
,"6":"making us a kingdom and priests for God his Father, to him be the glory and power for ever and ever. Amen."
,"7":"See he comes with the clouds and everyone will see him, even those who pierced him; on his account all the nations of the earth will beat his breast. Yes. It will be so."
,"8":"'I am the Alpha and the Omega,' says the Lord God, he who is, who was and who is to come: the Master of the universe."
,"9":"I, John, your brother, who share with you, in Jesus, the sufferings, the kingdom and the patient endurance, was on the island of Patmos, because of the Word of God and witnessing to Jesus."
,"10":"On the Lord's day, the Spirit took possession of me and I heard a voice behind me which sounded like a trumpet,"
,"11":"'Write down all that you see, in a book, and send it to the seven Churches of Ephesus, Smyrna, Pergamum, Thyatira, Sardis, Philadelphia and Laodicea.'"
,"12":"I turned to see who was speaking to me; behind me were seven golden lampstands"
,"13":"and, in the middle of these, I saw someone like a son of man, dressed in a long robe tied with a golden girdle."
,"14":"His head and his hair are white as wool or as snow and his eyes are like flames of fire."
,"15":"His feet are like burnished bronze when it has been refined in a furnace. His voice is like the roaring of the waves."
,"16":"I saw seven stars in his right hand and a sharp, double-edged sword coming out of his mouth; his face shone like the sun in all its brilliance."
,"17":"Seeing him, I fell at his feet like one dead but he touched me with his right hand and said, 'Do not be afraid. It is I, the First and the Last."
,"18":"I am the living one; I was dead and now I am alive for ever and ever; and mine are the keys of death and the netherworld."
,"19":"Now write what you have seen, both what is and what is yet to come."
,"20":"Know the secret of the seven stars you saw in my right hand and the seven golden lampstands: the seven stars are the angels of the seven Churches and the seven lampstands are the seven Churches."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Write this to the angel of the Church in Ephesus, 'Thus says the one who holds the seven stars in his right hand and who walks among the seven golden lampstands:"
,"2":"I know your works, your difficulties and your patient suffering. I know you cannot tolerate evildoers but have tested those who call themselves apostles and have proved them to be liars."
,"3":"You have persevered and have suffered for my name without losing heart."
,"4":"Nevertheless, I have this complaint against you: you have lost your first love."
,"5":"Remember from where you have fallen and repent, and do what you used to do before. If not, I will come to you and remove your lampstand from its place; this I will do, unless you repent."
,"6":"Yet it is in your favor that you hate the doings of the Nicolaitans, which I also hate."
,"7":"Let anyone who has ears listen to what the Spirit says to the Churches: To the victor I will give to eat of the tree of life which is in God's Paradise.'"
,"8":"Write this to the angel of the Church in Smyrna, 'Thus says the First and the Last, he who was dead and returned to life:"
,"9":"I know your trials and your poverty: you are rich indeed. I know how you are slandered by those who pretend to be Jews but are not, for they are, in fact, the synagogue of Satan."
,"10":"Do not be afraid of what will happen to you. The devil will throw some of you into prison to test you and there will be ten days of trials. Remain faithful even to death and I will give you the crown of life."
,"11":"Let anyone who has ears listen to what the Spirit says to the Churches: The victor has nothing to fear from the second death.'"
,"12":"Write this to the angel of the Church in Pergamum, 'Thus says the one who has the sharp, double-edged sword:"
,"13":"I know where you live, where Satan's throne is, but you cling firmly to my name; you have not renounced me, not even in the days when Antipas, my faithful witness, was killed in your place, where Satan lives."
,"14":"Nevertheless, I have a few complaints against you: Some among you hold the teaching of Balaam, who taught Balak how to make the Israelites stumble by eating food sacrificed to idols and comitting adultery."
,"15":"Also, among you some follow the teaching of the Nicolaitans."
,"16":"Therefore, repent; if not, I will come to you soon to attack these people with the sword of my mouth."
,"17":"Let anyone who has ears listen to what the Spirit says to the Churches: To the victor I will give the hidden manna. And I will also give a white stone with a new name written on it which no one knows except the one who receives it.'"
,"18":"Write this to the angel of the Church in Thyatira, 'Thus says the Son of God whose eyes are like flames of fire and whose feet are like burnished bronze."
,"19":"I know your works: your love, faith, service, patient endurance and your later works, greater than the first."
,"20":"Nevertheless, I have a complaint against you: you tolerate your Jezebel, this woman who calls herself a prophetess and is deceiving my servants; she teaches them prostitution and the eating of food sacrificed to idols."
,"21":"I have given her time to repent but she is unwilling to leave her prostitution."
,"22":"So I am going to throw her onto a bed and inflict severe trials on her partners in adultery unless they repent of their evil."
,"23":"I will strike her children dead and all the Churches will know that I am he who probes the heart and mind; I will give each of you what your conduct deserves."
,"24":"Listen to me now, the rest of you in Thyatira. You do not hold with this teaching and have not learned 'the secrets,' as they are called which are, in fact, those of Satan. So I have no cause to reproach you,"
,"25":"only hold on to what you have, until I come."
,"26":"To the victor who keeps to my ways to the end, I will give power over the nations,"
,"27":"to rule them with an iron rod and shatter them like earthen pots; he will be like me, who received this power from my Father."
,"28":"Moreover, I will give him the Morning Star."
,"29":"Let anyone who has ears listen to what the Spirit says to the Churches.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Write this to the angel of the Church in Sardis, 'Thus says he who holds the seven spirits of God and the seven stars: I know your worth: you think you live but you are dead. "
,"2":"Wake up and strengthen that which is not already dead. For I have found your works to be imperfect in the sight of my God."
,"3":"Remember what you were taught; keep it and change your ways. If you do not repent I will come upon you like a thief at an hour you least expect."
,"4":"Yet, there are some left in Sardis who have not soiled their robes; these will come with me, dressed in white, since they deserve it."
,"5":"The victor will be dressed in white and I will never erase his name from the book of life; instead, I will acknowledge it before my Father and his angels."
,"6":"Let anyone who has ears listen to what the Spirit says to the Churches.'"
,"7":"Write this to the angel of the Church in Philadelphia, 'Thus says he who is holy and true, who holds the key of David; if he opens, nobody shuts and if he shuts nobody opens."
,"8":"I know your worth; I have opened a door before you, which nobody can close, because you have kept my Word and not renounced me, in spite of your lack of power."
,"9":"I am giving you some of the synagogue of Satan who call themselves Jews but they are only liars. I will make them fall at your feet and recognize that I have loved you."
,"10":"Because you have kept my words with patient endurance, I, for my part, will keep you safe in the hour of trial which is coming upon the whole world, to test the people of the earth."
,"11":"I am coming soon; hold fast to what you have, lest anyone take your crown."
,"12":"I will make the victor into a column in the sanctuary of my God where he will stay forever. I will write on him the name of my God and the name of the city of my God, the new Jerusalem, which comes down from my God in heaven, and my own new name."
,"13":"Let anyone who has ears listen to what the Spirit says to the Churches.'"
,"14":"Write this to the angel of the Church in Laodicea, 'Thus says the Amen, the faithful and true witness, the beginning of God's creation:"
,"15":"I know your works: you are neither cold nor hot. Would that you were cold or hot!"
,"16":"You are lukewarm, neither hot nor cold so I will spit you out of my mouth."
,"17":"You think you are rich and have piled up so much that you need nothing, but you do not realize that you are wretched and to be pitied, poor, blind and naked."
,"18":"I advise you to buy from me gold that has been tested by fire, so that you may be rich, and white clothes to wear so that your nakedness may not shame you, and ointment for your eyes that you may see."
,"19":"I reprimand and correct all those I love. Be earnest and change your ways."
,"20":"Look, I stand at the door and knock. If you hear my call and open the door, I will come in to you and have supper with you, and you with me."
,"21":"I will let the victor sit with me on my throne just as I was victorious and took my place with my Father on his throne."
,"22":"Let anyone who has ears listen to what the Spirit says to the Churches.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"After this, I looked up to the wall of the sky and saw an open door. The voice which I had first heard speaking to me like a trumpet said, 'Come up here and I will show you what will come in the future.'"
,"2":"Immediately I was seized by the Spirit. There, in heaven, was a throne and one sitting on it."
,"3":"He who sat there looked like jasper and carnelian and round the throne was a rainbow resembling an emerald."
,"4":"In a circle around the throne are twenty-four thrones and seated on these are twenty-four elders, dressed in white clothes, with golden crowns on their heads."
,"5":"Flashes of lightning come forth from the throne, with voices and thunderclaps. Seven flaming torches burn before the throne; these are the seven spirits of God."
,"6":"Before the throne there is a platform, transparent like crystal. Around and beside the throne stand four living creatures, full of eyes, both in front and behind."
,"7":"The first living creature is like a lion, the second like a bull, the third has the face of a man and the fourth looks like a flying eagle."
,"8":"Each of the four living creatures has six wings full of eyes, all around as well as within; day and night they sing without ceasing, Holy, holy, holy is the Lord God, master of the universe, who was, and is and is to come."
,"9":"Whenever the living creatures give glory, honor and thanks to the One on the throne, he who lives for ever and ever,"
,"10":"the twenty-four elders fall down before him and worship the One who lives for ever and ever. They lay their crowns in front of the throne and say,"
,"11":"Our Lord and God, worthy are you,to receive glory, honor and power!,For you have created all things; by your will they came to be and were made."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Then I saw in the right hand of him who was seated on the throne a scroll written on both sides, sealed with seven seals."
,"2":"A mighty angel exclaimed in a loud voice, 'Who is worthy to open this and break the seals?'"
,"3":"But no one in heaven or on earth or in the netherworld was found able to open the book and read it."
,"4":"I wept much when I saw that no one was found worthy to open the book and read it."
,"5":"Then one of the elders said to me, 'Do not weep. Look, the Lion of the tribe of Judah, the Shoot of David, has conquered; he will open the book of the seven seals.'"
,"6":"And I saw next to the throne with its four living creatures and the twenty-four elders a Lamb standing, although it had been slain. I saw him with seven horns and seven eyes, which are the seven spirits of God sent out to all the earth."
,"7":"The Lamb moved forward and took the book from the right hand of him who was seated on the throne."
,"8":"When he took it, the four living creatures and the twenty-four elders bowed before the Lamb. They all held in their hands harps and golden cups full of incense which are the prayers of the holy ones."
,"9":"This is the new song they sang: You are worthy to take the book,and open its seals, for you were slain,and by your blood you purchased for God,people of every race, language and nation;"
,"10":"and you made them a kingdom and priests for our God,and they shall reign over the land."
,"11":"I went on looking; I heard the noise of a multitude of angels gathered around the throne, the living creatures and the elders, numbering millions of millions,"
,"12":"crying out with a loud voice: Worthy is the Lamb who was slain to receive,power and riches, wisdom and strength, honor, glory and praise."
,"13":"Then I heard the voice of the whole universe, heaven, earth, sea and the place of the dead; every creature cried out: To him who sits upon the throne and to the Lamb,be praise, honor, glory and power for ever and ever."
,"14":"And the four living creatures said, Amen, while the elders bowed down and worshiped."
}`)
	CurrentBook.AddChapter(6, `{
"1":"I saw the Lamb opening the first of the seven seals, and I heard one of the four living creatures cry out with a voice like thunder, 'Come and see!'"
,"2":"A white horse appeared, and its rider had a bow. He was crowned, and he went out as a conqueror and he will conquer."
,"3":"When he opened the second seal, I heard the second living creature cry out, 'Come!'"
,"4":"Then another horse the color of fire came out. Its rider was ordered to take peace away from the earth, that people might kill one another; so he was given a great sword."
,"5":"When he opened the third seal, I heard the third creature cry out, 'Come!' This time it was a black horse, and its rider held a balance in his hand."
,"6":"Then from the midst of the four living creatures a voice was heard: 'A measure of wheat for a piece of silver, and three measures of barley for a piece, as well! Do not spoil the oil or the wine.'"
,"7":"When he opened the fourth seal, I heard a cry from the fourth living creature, 'Come!'"
,"8":"A greenish horse appeared, its rider was called Death, and the Netherworld rode behind him. He was allowed to utterly destroy by sword, famine, pestilence and wild beasts a fourth of the inhabitants of the earth."
,"9":"When he opened the fifth seal, I saw under the altar the spirits of those who proclaimed the word of God and were slain for its sake."
,"10":"They began to cry aloud, 'Holy and righteous Lord, how long will it be before you render justice and avenge our blood on the inhabitants of the earth?'"
,"11":"Then each one of them was given a white garment, and they were told to wait a little while, un-til the number of their brothers and sisters and fellow servants who would be killed as they had been would be completed."
,"12":"And my vision continued. When the Lamb opened the sixth seal, there was a violent earthquake. The sun became black as a mourning dress, and the whole moon turned blood-red,"
,"13":"and the stars in the sky fell to the earth like dry figs falling from a fig tree shaken by a hurricane."
,"14":"The sky was folded up like rolled parchment; there was no mountain or continent that was not removed from its place."
,"15":"The kings of the earth and their ministers, the generals, the rich and the powerful, and all the people, slaves as well as free persons, hid in caves or among rocks on the mountains,"
,"16":"saying, 'Fall on us, mountains and rocks, and hide us, for we are afraid of him who sits on the throne, and of the wrath of the Lamb."
,"17":"The great Day of his wrath has come, and who can endure it?'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"After this, there were four angels standing at the four corners of the earth, holding back the four winds to prevent their blowing against the earth, the sea and the trees."
,"2":"I saw another angel ascending from the sunrise, carrying the seal of the living God, and he cried out with a loud voice to the four angels empowered to harm the earth and the sea,"
,"3":"'Do not harm the earth or the sea or the trees until we have sealed the servants of our God upon their foreheads.'"
,"4":"Then I heard the number of those marked with the seal: a hundred and forty-four thousand from all the tribes of the people of Israel:"
,"5":"from the tribe of Judah, twelve thousand were sealed; from the tribe of Reuben, twelve thousand; from the tribe of Gad, twelve thousand;"
,"6":"from the tribe of Asher, twelve thousand; from the tribe of Naphtali, twelve thousand; from the tribe of Manasseh, twelve thousand;"
,"7":"from the tribe of Simeon, twelve thousand; from the tribe of Levi, twelve thousand; from the tribe of Issachar, twelve thousand;"
,"8":"from the tribe of Zebulun, twelve thousand; from the tribe of Joseph, twelve thousand; from the tribe of Benjamin, twelve thousand."
,"9":"After this I saw a great crowd, impossible to count, from every nation, race, people and tongue, standing before the throne and the Lamb, clothed in white, with palm branches in their hands,"
,"10":"and they cried out with a loud voice, 'Who saves but our God who sits on the throne and the Lamb?'"
,"11":"All the angels were around the throne, the elders and the four living creatures; they then bowed before the throne with their faces to the ground to worship God."
,"12":"They said, Amen. Praise, glory, wisdom, thanks, honor, power and strength to our God forever and ever. Amen!"
,"13":"At that moment, one of the elders spoke up and said to me, 'Who are these people clothed in white, and where did they come from?'"
,"14":"I answered, 'Sir, it is you who know this.',The elder replied, 'They are those who have come out of the great persecution; they have washed and made their clothes white in the blood of the Lamb."
,"15":"This is why they stand before the throne of God,and serve him day and night in his sanctuary. He who sits on the throne will spread his tent over them."
,"16":"Never again will they suffer hunger or thirst,or be burned by the sun or any scorching wind."
,"17":"For the Lamb near the throne will be their Shepherd, and he will bring them to springs of life-giving water, and God will wipe away their tears.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"When the Lamb opened the seventh seal there was silence in heaven for about half an hour."
,"2":"Then I looked at the seven angels standing before God who were given seven trumpets."
,"3":"Another angel came and stood before the altar of incense with a golden censer. He was given much incense to be offered with the prayers of all the holy ones, on the golden altar before the throne;"
,"4":"and the cloud of incense rose with the prayers of the holy ones from the hands of the angel to the presence of God."
,"5":"Then the angel took the censer and filled it with burning coals from the altar, and threw them on the earth: and there came thunder, lightning and earthquakes."
,"6":"The seven angels with the seven trumpets prepared to sound them."
,"7":"When the first angel blew his trumpet, there came hail and fire, mixed with blood, which fell on the earth. And a third of the earth was burned up with a third of the trees and the green grass."
,"8":"When the second angel blew his trumpet, something like a great mountain was thrown into the sea, and a third of the sea was turned into blood."
,"9":"At once, a third of the living creatures in the sea died and a third of the ships perished."
,"10":"When the third angel sounded his trumpet, a great star fell from heaven, like a ball of fire, on a third of the rivers and springs."
,"11":"The star is called Wormwood, and a third of the waters was turned into wormwood and many people died because of the water which had turned bitter."
,"12":"The fourth angel blew his trumpet, and a third of the sun, the moon and the stars was affected. Daylight decreased one third, and the light at night as well."
,"13":"And my vision continued: I noticed an eagle flying through the highest heaven and crying with a loud voice, 'Woe, woe, woe to the inhabitants of the land when the last three angels sound their trumpets.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"And the fifth angel blew his trumpet. I then saw a star fall from heaven to earth. The star was given the key to the depths of the abyss."
,"2":"He opened the abyss, and a cloud of smoke rose as if from a great furnace which darkened the sun and the air."
,"3":"Locusts came from this smoke and spread throughout the earth. They were given the same harmful power as the scorpions of the earth."
,"4":"Then they were told not to harm the meadows, the green grass or the trees, but only the people who do not bear the seal of God upon their foreheads."
,"5":"They were not to kill them, but only torture them for five months. This pain is like the sting of scorpions."
,"6":"In those days, people will look for death but will not find it; they will long to die, but death will elude them."
,"7":"These locusts look like horses equipped for battle; they wear golden crowns on their heads, and their faces are like those of human beings."
,"8":"Their hair is like women's hair, and their teeth like lion's teeth;"
,"9":"their chests are like iron breastplates; and the noise of their wings like the roar of an army of chariots and horses rushing for battle."
,"10":"Their tails are like those of scorpions and have stings; the power they have to torture people for five months is in their tails."
,"11":"These locusts have a king, who is the angel of the abyss whose name in Hebrew is Abaddon or Apollyon in Greek (Destruction in English)."
,"12":"The first woe has passed. Two others are to come."
,"13":"The sixth angel blew his trumpet. Then I heard a voice calling from the corners of the golden altar before God."
,"14":"It said to the sixth angel who had just sounded the trumpet, 'Release the four angels chained at the banks of the great river Euphrates.'"
,"15":"And the four angels were released who had been waiting for this year, this month, this day and this hour, ready to utterly destroy a third of humankind."
,"16":"The number of the soldiers on horses was two hundred million; this is the number I heard."
,"17":"In my vision, I saw those horses and their riders: they wear breastplates the color of fire, hyacinth and sulfur. The heads of the horses look like lions' heads, and fire, smoke and sulfur come out of their mouths."
,"18":"Then a third of humankind was killed by these three plagues: fire, smoke and sulfur which the horses released through their mouths,"
,"19":"for the power of the horses was both in their mouths and in their tails. Their tails, in fact, look like serpents, and their heads are able to inflict injury as well."
,"20":"However, the rest of humankind who were not killed by these plagues did not renounce their way of life: they went on worshiping the demons, keeping those idols of gold, silver, bronze, stone and wood that cannot see, hear or walk."
,"21":"No, they did not repent of their crimes, or their sorcery, or their sexual immorality or their theft."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Then I saw another mighty angel coming down from heaven wrapped in a cloud. A rainbow was around his head, his face was like the sun and his legs like pillars of fire."
,"2":"I could see a small book open in his hand. He stood, his right foot planted on the sea and his left on the land,"
,"3":"and called in a loud voice like the roaring of a lion."
,"4":"Then the seven thunders sounded their own message. I was about to write what the seven thunders had sounded, when a voice from heaven said to me, 'Keep the words of the seven thunders secret and do"
,"4":"not write them down.'"
,"5":"And the angel I saw standing on the sea and land, raised his right hand to heaven,"
,"6":"swearing by him who lives for ever and ever, and who created the heavens, the earth, the sea and everything in them. He said, 'There is no more delay; "
,"7":"as soon as the trumpet call of the seventh angel is heard, the mysterious plan of God will be fulfilled according to the good news he proclaimed through his servants the prophets.'"
,"8":"And the voice I had heard from heaven spoke again, saying to me, 'Go near the angel who stands on the sea and on the land, and take the small book open in his hand.'"
,"9":"So I approached the angel and asked him for the small book; he said to me, 'Take it and eat; although it be sweet as honey in your mouth, it will be bitter to your stomach.'"
,"10":"I took the small book from the hand of the angel, and ate it. It was sweet as honey in my mouth, but when I had eaten it, it turned bitter in my stomach."
,"11":"Then I was told, 'You must again proclaim God's words about many peoples, nations, tongues and kings.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Then I was given a staff like a measuring stick, and I was told, 'Go and measure the temple of God and the altar, and count those who worship there."
,"2":"Do not bother to measure the outer courtyard, for this has been given to the pagans who will trample over the Holy City for forty-two months."
,"3":"Meanwhile, I will entrust my Word to my two witnesses who will proclaim it for one thousand two hundred and sixty days, dressed in sackcloth.'"
,"4":"These are the two olive trees and the two lamps which are before the Lord of the earth."
,"5":"If anyone intends to harm them, fire will come out of their mouths to devour their enemies: this is how whoever intends to harm them will perish."
,"6":"They have the power to close the sky and hold back the rain during the time of their prophetic mission; they also have the power to change water into blood, and punish the earth with a thousand plagues, any time they wish."
,"7":"But when my witnesses have fulfilled their mission, the beast that comes up from the abyss will make war upon them, and will conquer and kill them."
,"8":"Their dead bodies will lie in the square of the Great City which the believers figuratively call Sodom or Egypt, where their Lord was crucified."
,"9":"And their dead bodies will be exposed for three days and a half to people of all tribes, races, languages and nations who will be ordered not to have them buried."
,"10":"Then the inhabitants of the earth will rejoice, congratulate one another and exchange gifts among themselves because these two prophets were a torment to them."
,"11":"But after those three and a half days, a spirit of life coming from God entered them. They then stood up, and those who looked at them were seized with great fear."
,"12":"A loud voice from heaven called them, 'Come up here.' So they went up to heaven in the midst of the clouds in the sight of their enemies."
,"13":"At that moment, there was a violent earthquake which destroyed a tenth of the city and claimed seven thousand victims. The rest were overcome with fear, and acknowledged the God of heaven."
,"14":"The second woe has passed. The third is coming soon."
,"15":"The seventh angel blew his trumpet, then loud voices resounded in heaven: 'The world has now become the Kingdom of our God and of his Christ. He will reign for ever and ever.'"
,"16":"The twenty-four elders who sit on their thrones before God bowed down to worship God,"
,"17":"saying, We thank you, Lord God, Master of the universe, who are and who were, for you have begun your reign, making use of your invincible power."
,"18":"The nations raged,but your wrath has come, the time to judge the dead,and reward your servants the prophets, the saints and those who honor your Name -,whether great or small -,and destroy those who destroy the earth."
,"19":"Then the sanctuary of God in the heavens was opened, and the Ark of the Covenant of God could be seen inside the sanctuary. There were flashes of lightning, peals of thunder, an earthquake and a violent hail-storm."
}`)
	CurrentBook.AddChapter(12, `{
"1":"A great sign appeared in heaven: a woman, clothed with the sun, with the moon under her feet and a crown of twelve stars on her head."
,"2":"She was pregnant and cried out in pain, looking to her time of delivery."
,"3":"Then another sign appeared: a huge, red dragon with seven heads and ten horns and wearing seven crowns on its heads."
,"4":"It had just swept along a third of the stars of heaven with its tail, throwing them down to the earth. The dragon stood in front of the woman who was about to give birth, so that it might devour the child as soon as it was born. "
,"5":"She gave birth to a male child, the one who is to rule all the nations with an iron scepter; then her child was seized and taken up to God and to his throne"
,"6":"while the woman fled to the desert where God had prepared a place for her; there she would be looked after for one thousand two hundred and sixty days."
,"7":"War broke out in heaven with Michael and his angels battling with the dragon. The dragon fought back with his angels,"
,"8":"but they were defeated and lost their place in heaven."
,"9":"The great dragon, the ancient serpent known as the devil or Satan, seducer of the whole world, was thrown out. He was hurled down to earth, together with his angels."
,"10":"Then I heard a loud voice from heaven: Now has salvation come, with the power and the kingdom of our God, and the rule of his anointed. For our brothers' accuser has been cast out, who accused them night and day, before God."
,"11":"They conquered him by the blood of the Lamb,and by the word of their testimony, for they gave up their lives going to death."
,"12":"Rejoice, therefore, O you heavens,and you who dwell in them; but woe to you, earth and sea, for the devil has come to you in anger,knowing that he has but a little time."
,"13":"When the dragon saw that he had been thrown down to earth, he pursued the woman who had given birth to the male child."
,"14":"Then the woman was given the two wings of the great eagle so that she might fly into the desert where she would be looked after for three and a half years."
,"15":"The serpent poured water out of his mouth after the woman, to carry her away in the flood,"
,"16":"but the earth came to her rescue: it opened its mouth and swallowed the flood which the dragon had poured from its mouth."
,"17":"Then the dragon was furious with the woman and went off to wage war on the rest of her children, those who keep God's commandments and bear witness to Jesus."
,"18":"And he stood on the seashore."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Then, I saw a beast rising out of the sea, with ten horns and seven heads, with ten crowns on its horns. On each head was a title challenging God."
,"2":"The beast I saw looked like a leopard, with paws like a bear and a mouth like a lion. The dragon passed on his power, his throne and his great authority to the beast."
,"3":"One of its heads seemed to be fatally wounded but this wound healed. The whole earth wondered and they followed the beast."
,"4":"People prostrated themselves before the dragon who had given such authority to the beast and they prostrated themselves before the beast, saying, 'Who is like the beast? Who can oppose it?'"
,"5":"The beast was given speech and it spoke boastful and blasphemous words against God; it was allowed to wield its power for forty-two months."
,"6":"It spoke blasphemies against God, his name and his sanctuary, that is, those who already dwell in heaven."
,"7":"It was allowed to make war on the saints and to conquer them. It was given authority over people of every tribe, language and nation;"
,"8":"this is why all the inhabitants of the earth will worship before it, those whose names have not been written in the book of life of the slain Lamb, since the foundation of the world."
,"9":"Let anyone who has ears to hear, listen:"
,"10":"If your lot is the prison, to prison you will go; if your lot is to be killed by the sword, by the sword will you be slain. This is, for the holy ones, the time of endurance and faith."
,"11":"Then I saw another beast rise out of the earth, with two horns like the Lamb but speaking like the dragon."
,"12":"This second beast is totally at the service of the first one and enjoys its authority. So it makes the world and its inhabitants worship the first beast whose fatal wound has been healed."
,"13":"It works great wonders, even making fire descend from heaven to earth, in the sight of all."
,"14":"Through these great wonders which it is able to do on behalf of the beast, it deceives the inhabitants of the earth, persuading them to make a statue of the beast which, although wounded by the sword, is still alive."
,"15":"It has been allowed to give a spirit to this statue; the statue of the beast speaks and those who refuse to worship it are killed."
,"16":"So this second beast makes everyone - great and small, rich and poor, free and enslaved - be branded on the right hand or on the forehead,"
,"17":"and no one can buy or sell unless he has been branded with the name of the beast or with the number of its name."
,"18":"Let us see who is wise! If you are clever, you can interpret the number of the Beast; it is 666 and it is the name of a certain person."
}`)
	CurrentBook.AddChapter(14, `{
"1":"I was given another vision: The Lamb was standing on Mount Zion, surrounded by one hundred and forty-four thousand people who had his name and his Father's name written on their foreheads."
,"2":"A sound reverberated in heaven like the sound of the roaring of waves or deafening thunder; it was like a chorus of singers, accompanied by their harps."
,"3":"They sing a new song before the throne, in the presence of the four living creatures and the elders, a song which no one can learn except the hundred and forty-four thousand who have been taken from the earth."
,"4":"They are those who were not defiled with women but were chaste; these are given to follow the Lamb wherever he goes. They are the first taken from humankind who are already of God and the Lamb."
,"5":"No deceit has been found in them; they are faultless."
,"6":"Then I saw another angel, flying high in the sky, sent to proclaim the definitive good news to the inhabitants of the earth, to every nation, race, language and people."
,"7":"He cried out with a loud voice, 'Give God glory and honor, for the hour of his judgment has come. Worship him who made the heavens, the earth, the sea and all the waters.'"
,"8":"Another angel followed him, crying out, 'Fallen is Babylon the great, fallen the prostitute who has made all the nations drunk with her unleashed prostitution!'"
,"9":"A third angel then followed, shouting aloud, 'If anyone worships the beast or its image or has his forehead or hand branded,"
,"10":"he will also drink the wine of God's anger which has been prepared, undiluted, in the cup of his fury: he will be tortured by fire and brimstone, in the presence of the holy angels and the Lamb.'"
,"11":"The smoke of their torment goes up for ever and ever; for there is no rest, day or night, for those who worshiped the beast and its image, and for those who were branded with the mark of its name."
,"12":"This is the time for patient endurance among the holy ones, for those who keep the commandments of God and faith in Jesus."
,"13":"I heard someone from heaven say, 'Write this: Happy from now are the dead who have died in the Lord. The Spirit says: Let them rest from their labors; their good deeds go with them.'"
,"14":"Then I had this vision. I saw a white cloud and the one sitting on it like a son of man, wearing a golden crown on his head and a sharp sickle in his hand."
,"15":"An angel came out of the sanctuary, calling loudly to the one sitting on the cloud, 'Put in your sickle and reap, for harvest time has come and the harvest of the earth is ripe.'"
,"16":"He who was sitting on the cloud swung his sickle at the earth and reaped the harvest."
,"17":"Then another angel, who also had a sharp sickle, came out of the heavenly sanctuary."
,"18":"Still another angel, the one who has charge of the altar fire, emerged and shouted to the first who held the sharp sickle, 'Swing your sharp sickle and reap the bunches of the vine of the earth for they are fully ripe.'"
,"19":"So the angel swung his sickle and gathered in the vintage, throwing all the grapes into the great winepress of the anger of God."
,"20":"The grapes were trodden outside the city and blood flowed from the winepress, to the height of the horses' bridles and over an area of sixteen hundred furlongs."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Then I saw another great and marvelous sign in the heavens: seven angels brought seven plagues which are the last, for with these the wrath of God will end."
,"2":"There was a sea of crystal mingled with fire, and the conquerors of the beast, of its name and the mark of its name stood by it. They had been given the celestial harps "
,"3":"and they sang the song of Moses the servant of God and the song of the Lamb: Great and marvelous are your works, O Lord, God and Master of the universe. Justice and truth guide your steps, O King of the nations."
,"4":"Lord, who will not give honor and glory to your Name?,For you alone are holy. All the nations will come and bow before you, for they have now seen your judgments."
,"5":"Then the sanctuary of the Tent of Divine Declarations was opened,"
,"6":"and the seven angels bringing the seven plagues came out of the Sanctuary, clothed in pure and bright linen, with their waists girded with golden belts."
,"7":"One of the four living creatures gave the seven angels seven golden cups full of the wrath of God who lives for ever and ever."
,"8":"Then the sanctuary was filled with smoke which wraps God's glory and power, so that no one could enter until the seven plagues of the seven angels were completed."
}`)
	CurrentBook.AddChapter(16, `{
"1":"I heard a loud voice calling from the sanctuary to the seven angels, 'Go and empty on the earth the seven cups of the wrath of God.'"
,"2":"The first angel went to empty his cup on the earth, and malignant and painful sores appeared on the people who bore the mark of the beast and had bowed before its image."
,"3":"The second angel emptied his cup into the sea which turned into blood like that of the dead, and every living thing in the sea died."
,"4":"The third angel emptied his cup into the rivers and springs which turned into blood."
,"5":"And I heard the angel of the waters say, 'You who are and who were, O Holy One, you are just in punishing them in this way;"
,"6":"since they have shed the blood of your holy ones and the prophets, you have made them drink blood; they rightly deserved it.'"
,"7":"I heard another cry from the altar, 'Yes, Lord and God, Master of the universe, your judgments are true and just.'"
,"8":"The fourth angel poured out his cup on the sun and its heat began to scorch people."
,"9":"They were severely burned and began to insult God who has power over those plagues, instead of acknowledging him."
,"10":"The fifth angel emptied his cup on the throne of the beast, and suddenly his kingdom was in darkness and the people bit their tongues in agony."
,"11":"They insulted the Most High God for their pain and wounds, but they did not repent."
,"12":"The sixth angel poured out his cup on the great river Euphrates; then its water was dried up, leaving a free passageway for the kings of the east."
,"13":"I saw coming from the mouths of the monster, the beast and the false prophet, three unclean spirits which looked like frogs."
,"14":"They are, in fact, spirits of demons that perform marvelous things and go to the kings of the whole world to gather them for battle on the great day of God, the Master of the universe."
,"15":"'Beware! I come like a thief; happy is the one who stays awake and does not take off his clothes; so he will not have to go naked and his whole body be exposed for all to see.'"
,"16":"Then they assembled them at the place called Armageddon in Hebrew (or the Hills of Megiddo)."
,"17":"The seventh angel emptied his cup into the air. Then a voice came forth from the throne and was heard outside the sanctuary, saying, 'It is done.'"
,"18":"And there were flashes of lightning, peals of thunder and a violent earthquake. No, never has there been an earthquake so violent since people existed on earth."
,"19":"The Great City was split into three, while the cities of the nations collapsed. For the time had come for Babylon the Great to be remembered before God and to be given the cup of the foaming wine of his anger."
,"20":"Then the continents withdrew and the mountain ranges hid."
,"21":"Great hailstones from heaven, as heavy as stones, dropped on the people, and the people insulted God because of this disastrous hailstorm, for it was truly a terrible plague."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Then one of the seven angels of the seven cups came to me and said, 'Now I will show you the judgment of the sovereign prostitute who dwells on the great waters."
,"2":"She it is who let the kings of the earth sin with her; and with the wine of her lewdness the inhabitants of the earth have become drunk.'"
,"3":"The angel brought me to the desert: it was a new vision. There a woman was seated on a red beast. The beast, which had seven heads and ten horns, covered itself with titles and statements that offend God."
,"4":"The woman was clothed in purple and scarlet, with ornaments of gold, precious stones and pearls. She held in her hands a golden cup full of loathsome idolatry and impure prostitution."
,"5":"Her name could be read on her forehead, written in a mysterious way: Babylon the Great, mother of prostitutes and of the loathsome idols of the whole world."
,"6":"And I saw that the woman was drunk with the blood of the holy ones and the martyrs of Jesus. What I saw greatly surprised me, "
,"7":"but the angel said to me, 'Why are you surprised? I will reveal to you the secret of this woman and of the beast with seven heads and ten horns that she mounts."
,"8":"The beast you saw has been, though it IS not. It will come up from the abyss and then go to perdition. What a surprise for the inhabitants of the earth whose names are not written in the Book of Life from the creation of the world! They will marvel on discovering that the beast who has been IS not and passes away."
,"9":"Let us see if you guess: the seven heads are seven hills on which the woman sits. And they are also seven kings,"
,"10":"five of which have already fallen, one is in power, and the seventh has not yet come but will remain only a short while."
,"11":"The beast that has been but IS not can be considered as the eighth though it takes place among the seven; and it goes to perdition."
,"12":"The ten horns are ten kings who have not yet received power but will have authority for an hour with the beast."
,"13":"They all have only one aim and they place their authority and power at the service of the beast."
,"14":"They will fight against the Lamb, but the Lamb will conquer them, for he is Lord of lords and King of kings; and with him will be his followers who have been called and chosen and are faithful."
,"15":"The angel went on, 'Those waters you saw, on which the prostitute is seated, are peoples, multitudes and nations of every language."
,"16":"The ten horns, and the beast itself, will plan evil against the prostitute. They will destroy her and leave her naked; they will eat her flesh and set her on fire."
,"17":"God makes use of them to carry out his plan, so he has inspired them with their common purpose and they will place their power at the service of the beast until the words of God are fulfilled. A last word:"
,"18":"the woman you saw is the Great City which reigns over the kings of the whole world.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"After this I saw another angel coming down from heaven. So great was his authority that the whole earth was lit up with his glory."
,"2":"In a strong voice he cried out: 'Fallen is Babylon the great! Fallen!,She has become a haunt of demons, a lodge for every unclean spirit, a nest for any filthy and disgusting bird."
,"3":"She has made all nations drunk,with the wine of her lewdness, fornicated with kings of the earth, and glutted the world's merchants,with her wantonness and wealth.'"
,"4":"Then I heard another voice from heaven: 'Depart from her, my people, lest you share in her evil,and so share in her punishments;"
,"5":"for her sins are piled up to heaven, and God keeps count of her crimes."
,"6":"Give back to her as she has given, pay her twice for what she has done. Let her drink a double portion,of what she made others do."
,"7":"Give her as much torment and grief,as the wantonness she enjoyed herself. For she said to herself, 'I sit as queen, I am not a widow, never will I go into mourning!'"
,"8":"And so, suddenly, her plagues will come -,death, mourning and famine. She will be consumed by fire, for mighty is the Lord, the judge, who has passed sentence on her.'"
,"9":"The kings who shared her luxury and committed adultery with her will see the smoke as she burns, and they will weep and lament."
,"10":"They will nevertheless keep their distance, terrified at her punishment, and exclaim: 'Alas, alas! Great city that you are, O Babylon, seat of power!,Your doom has come in a single hour!'"
,"11":"The merchants of the world will mourn over her, for they will lose a market for their goods -"
,"12":"their cargoes of gold and silver, precious stones and pearls, fine linen and purple garments, silk and scarlet cloth, fragrant wood, ivory pieces and expensive furniture, bronze, iron and marble,"
,"13":"cinnamon and spices, perfume, myrrh and frankincense, wine and olive oil, fine flour and grain, cattle and sheep, horses and carriages, slaves and human lives."
,"14":"They will say: 'Gone is the fruit you longed for. Gone are your luxury and splendor. Never will you recover them, never!'"
,"15":"The merchants who dealt in these goods, who grew rich from business with the city, will stand at a safe distance for fear of her punishment. Weeping and mourning,"
,"16":"they will cry out: 'Woe, woe to the great city, to the linen and purple and scarlet you wore, to your gold and pearls, your finery,"
,"17":"your great wealth destroyed in an hour!',Every captain and navigator, every sailor and seafarer, will stand afar, "
,"18":"crying out on seeing the smoke going up as the city burns to the ground. 'What city could have compared with this one?'"
,"19":"They will pour dust on their heads and cry out in mourning: 'Alas, alas, great city, where all who had ships at sea,grew rich through her trade!,In an hour she has been devastated.'"
,"20":"Rejoice over her, O heavens!,Rejoice, prophets, saints and apostles!,God has rendered justice to you."
,"21":"A powerful angel picked up a boulder the size of a large millstone and threw it into the sea, saying: 'With such violence will Babylon, the great city, be thrown down, never again to be seen."
,"22":"Never again will tunes of harpists, minstrels, trumpeters and flutists be heard in you. Never again will an artisan of any trade be found in you. Never again will the noise of the mill be heard."
,"23":"Never again will the light of a lamp shine in you. The voice of bridegroom and bride will never again be heard in you. Because your traders were the world's great and you led the nations astray by your magic spell. "
,"24":"In this city was found blood of prophets and saints - yes, the blood of all who have been slain on the earth.'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"After this I heard what sounded like the loud singing of a great assembly in heaven: Alleluia! Salvation, glory and might belong to our God,"
,"2":"for his judgments are true and just. He has condemned the great harlot who corrupted the world with her adultery. He has avenged his servants' blood shed by her hand in harlotry."
,"3":"Once more they sang: Alleluia! The smoke from her goes up for ever and ever!"
,"4":"The twenty-four elders and the four living creatures fell down and worshiped God seated on the throne. And they cried: Amen! Alleluia!"
,"5":"A voice came from the throne: 'Praise our God, all you his servants, all you who revere him, both small and great!'"
,"6":"Then I heard what sounded like a great crowd, like the roaring of the waves, like peals of thunder, answering: Alleluia! The Lord now reigns, our Lord, the Master of the universe!"
,"7":"Let us rejoice and be glad,and give him glory!,This is the time to celebrate the wedding of the Lamb, his bride has made herself ready."
,"8":"Fine linen, bright and clean, is given her to wear. This linen stands for the good works of the holy ones."
,"9":"Then the angel told me, 'Write: Happy are those invited to the wedding of the Lamb.' And he went on, 'These are true words of God.'"
,"10":"As I fell down at his feet to worship him, he said to me, 'Beware, I am but a servant like you and your brothers who utter the testimonies of Jesus (these testimonies of Jesus are proclaimed through the spirit of the prophets). Worship God alone.'"
,"11":"Then I saw heaven opened and a white horse appeared. Its rider is the Faithful and True; he judges and wages just wars."
,"12":"His eyes are flames of fire; he wears many crowns and written on him is his own name, which no one can understand except himself."
,"13":"He is clothed in a cloak drenched in blood. His name is the Word of God."
,"14":"The armies of heaven clothed in pure white linen follow him on white horses."
,"15":"A sharp sword comes out of his mouth. With it he will strike the nations for he must rule them with an iron rod. He treads the winepress of the burning wrath of God, the Master of the universe."
,"16":"This is why this title is written on his cloak and on his thigh: King of kings and Lord of lords."
,"17":"I also saw an angel standing in the sun. He cried out with a loud voice to all the birds of the air, 'Come here to the great feast of God."
,"18":"Come and eat the flesh of kings, of generals and of the mighty; come and devour the soldier and his horse, flesh of all, both free and slaves, both small and great.'"
,"19":"Then I saw the beast with the kings of the earth and their armies gathered together to fight against him who rides on the horse and his army."
,"20":"But the beast was captured with the false prophet who served it and performed signs by which he deceived those who had received the mark of the beast and worshiped its statue. The two were thrown alive into the fiery lake of burning sulfur, and all"
,"21":"the rest were killed by the sword which comes from the mouth of the rider who mounts the horse. And all the birds were fed with their flesh."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Then an angel came down from heaven, holding in his hand the key to the Abyss and a huge chain."
,"2":"He seized the monster, the ancient serpent, namely Satan or the devil, and chained him for a thousand years."
,"3":"He threw him into the abyss and closed its gate with the key, then secured it with locks, that he might not deceive the nations in the future until the thousand years have passed. Then he will be released for a little while."
,"4":"There were thrones and seated on them were those with the power to judge. I then saw the spirits of those who had been beheaded for having held the teachings of Jesus and on account of the word of God. I saw all those who had refused to worship the beast or its image, or receive its mark on the forehead or on the hand. They returned to life and reigned with the Messiah for a thousand years. This is the first resurrection."
,"5":"The rest of the dead will not return to life before the end of the thousand years."
,"6":"Happy and holy is the one who shares in the first resurrection, for the second death has no power over them; they will be priests of God and of his Messiah and reign with him a thousand years."
,"7":"At the end of these thousand years, Satan will be released from his prison;"
,"8":"then he will set out to deceive the nations of the four corners of the world, namely Gog and Magog, and gather them for war. What an army, so numerous like the sand of the seashore!"
,"9":"They invaded the land and surrounded the camp of the holy ones, the most beloved city, but fire came down from heaven and devoured them."
,"10":"Then the devil, the seducer, was thrown into the lake of fire and sulfur, where the beast and the false prophet already were. Their torment will last day and night for ever and ever."
,"11":"After that I saw a great and splendid throne and the one seated upon it. At once heaven and earth disappeared, leaving no trace."
,"12":"I saw the dead, both great and small, standing before the throne while books were opened. Another book, the Book of Life, was also opened. Then the dead were judged according to the records of these books, that is, each one according to his works."
,"13":"The sea gave up the dead it had kept, as did death and the netherworld, so that all might be judged according to their works."
,"14":"Then death and the netherworld were thrown into the lake of fire. This lake of fire is the second death."
,"15":"All who were not recorded in the Book of Life were thrown into the lake of fire."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Then I saw a new heaven and a new earth. The first heaven and the first earth had passed away and no longer was there any sea."
,"2":"I saw the new Jerusalem, the holy city coming down from God, out of heaven, adorned as a bride prepared for her husband."
,"3":"A loud voice came from the throne, 'Here is the dwelling of God among mortals: He will pitch his tent among them and they will be his people; he will be God-with-them."
,"4":"He will wipe every tear from their eyes. There shall be no more death or mourning, crying out or pain, for the world that was has passed away.'"
,"5":"The One seated on the throne said, 'See, I make all things new.',And then he said to me, 'Write these words because they are sure and true.'"
,"6":"And he said to me: It is already done! I am the Alpha and the Omega, the Beginning and the End. I myself will give the thirsty to drink without cost from the fountain of living water."
,"7":"Thus the winner will be rewarded: For him I shall be God and he will be my son."
,"8":"As for cowards, traitors, depraved, murderers, adulterers sorcerers, and idolators - all those who live in falsehood, their place is the lake of burning sulfur. This is the second death.'"
,"9":"Then one of the seven angels came to me, one of those with the seven bowls full of the seven last plagues. And he said, 'Come, I am going to show you the bride, the wife of the Lamb.'"
,"10":"He took me up in a spiritual vision to a very high mountain and he showed me the holy city Jerusalem, coming down out of heaven from God. It shines with the glory of God,"
,"11":"like a precious jewel with the color of crystal-clear jasper."
,"12":"Its wall, large and high, has twelve gates; stationed at them are twelve angels. Over the gates are written the names of the twelve tribes of the sons of Israel."
,"13":"Three gates face the east; three gates face the north; three gates face the south and three face the west."
,"14":"The city wall stands on twelve foundation stones on which are written the names of the twelve apostles of the Lamb."
,"15":"The angel who was speaking to me had a golden measuring rod to measure the city, its gates and its wall."
,"16":"The city is laid out like a square: its length is the same as its breadth. He measured it with his rod and it was twelve thousand furlongs; its length, breadth and height are equal."
,"17":"Then he measured the wall: it was a hundred and forty-four cubits high. The angel used an ordinary measure."
,"18":"The wall is made of jasper and the city of pure gold, crystal-clear."
,"19":"The foundations of the wall are adorned with every kind of precious jewel: the first is jasper, the second sapphire, the third turquoise, the fourth emerald,"
,"20":"the fifth agate, the sixth ruby, the seventh chrysolite, the eighth beryl, the ninth topaz, the tenth chrysopraze, the eleventh hyacinth and the twelfth amethyst."
,"21":"The twelve gates are twelve pearls, each gate made of a single pearl and the square of the city is paved with gold as pure as transparent crystal."
,"22":"I saw no temple in the city for the Lord God, Master of the universe, and the Lamb are themselves its temple."
,"23":"The city has no need of the light of the sun or the moon, since God's Glory is its light and the Lamb is its lamp."
,"24":"The nations will walk in its light and the kings of the earth will bring their treasures to it."
,"25":"Its gates will not be closed at sunset, for there will be no night there."
,"26":"It is there that the wealth and the most precious things of the nations will be brought."
,"27":"Nothing unclean will enter it, or anyone who does what is evil and false but only those whose names are written in the Lamb's Book of Life."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Then he showed me the river of life, clear as crystal, gushing from the throne of God and of the Lamb."
,"2":"In the middle of the city, on both sides of the river are the trees of life producing fruit twelve times, once each month, the leaves of which are for healing the nations."
,"3":"No longer will there be a curse; the throne of God and of the Lamb will be in the City and God's servants will live in his presence."
,"4":"They will see his face and his name will be on their foreheads."
,"5":"There will be no more night. They will not need the light of lamp or sun for God himself will be their light and they will reign forever."
,"6":"Then the angel said to me, 'These words are sure and true; the Lord God who inspires the prophets has sent his angel to show his servants what must happen soon.'"
,"7":"'I am coming soon! Happy are those who keep the prophetic words of this book.'"
,"8":"I, John, saw and heard all this. When I had seen and heard them I fell at the feet of the angel who had shown me everything, to worship him."
,"9":"But he said, 'No, I am a fellow servant like you and your brothers, the prophets, and those who heed the words of this book. It is God you must worship.'"
,"10":"He then said to me, 'Do not keep secret the prophetic words of this book because the time is near."
,"11":"Let the sinner continue to sin and the defiled remain in his defilement; let the righteous continue to do what is right and he who is holy grow holier.'"
,"12":"'I am coming soon, bringing with me the salary I will pay to each one according to his deeds."
,"13":"I am the Alpha and the Omega, the First and the Last, the Beginning and the End.'"
,"14":"Happy are those who wash their robes for they will have free access to the tree of Life and enter the city through the gates."
,"15":"Outside are the dogs, sorcerers, the immoral, murderers, idolaters and all who take pleasure in falsehood!"
,"16":"'I, Jesus, sent my angel to make known to you these revelations concerning the Churches. I am the Shoot and Offspring of David, the radiant Morning Star.'"
,"17":"The Spirit and the Bride say, 'Come!' Whoever hears let him say, 'Come!' Whoever thirsts let him approach, and whoever desires, let him freely take the water of life."
,"18":"As for me, I warn everyone who hears the prophetic words of this book: If anyone adds anything to them, God will pile on him the plagues described in this book."
,"19":"And if anyone takes away words from this book of prophecy, God will take from him his share in the tree of Life and the holy city described in this book."
,"20":"He who has declared all this says, 'Yes, I am coming soon.',Amen! Come, Lord Jesus."
,"21":"May the grace of the Lord Jesus be with you all -"
}`)

}
func EN_CCB_LoadNTHBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"God has spoken in the past to our ancestors through the prophets, in many different ways, although never completely;"
,"2":"but in our times he has spoken definitively to us through his Son. He is the one God appointed heir of all things, since through him he unfolded the stages of the world."
,"3":"He is the radiance of God's Glory and bears the stamp of God's hidden being, so that his powerful word upholds the universe. And after taking away sin, he took his place at the right hand of the divine Majesty in heaven."
,"4":"So he is now far superior to angels just as the name he received sets him apart from them."
,"5":"To what angel did God say: You are my son, I have begotten you today? and to what angel did he promise: I shall be a father to him and he will be a son to me?"
,"6":"On sending his Firstborn to the world, God says: Let all the angels adore him."
,"7":"Whereas about angels we find words like these: God sends the angels like wind, makes his servants flames of fire."
,"8":"But of the Son we read this: Your throne, O God, will last forever and ever; a rule of justice is your rule."
,"9":"You loved righteousness and hated wickedness; therefore God, your God, has anointed you with the oil of gladness, above your fellow kings."
,"10":"And also these words: Lord, in the beginning you placed the earth on its foundation and the heavens are the work of your hands."
,"11":"They will disappear, but you remain. They will be for you like an old garment;"
,"12":"you will fold them like a cloak and change them. You, on the contrary, are always the same and your years will never end."
,"13":"God never said to any of his angels: Sit here at my right side until I put your enemies as a footstool under your feet."
,"14":"For all these spirits are only servants, and God sends them to help those who shall be saved."
}`)
	CurrentBook.AddChapter(2, `{
"1":"So we must pay the closest attention to the preaching we heard, lest we drift away."
,"2":"If words spoken through angels became law and all disobedience or neglect received its due reward,"
,"3":"how could we now escape if we neglect such powerful salvation? For the Lord himself announced it first and it was later confirmed by those who heard it."
,"4":"God confirmed their testimony by signs, wonders and miracles of every kind - especially by the gifts of the Holy Spirit which he distributed according to his will."
,"5":"The angels were not given dominion over the new world of which we are speaking."
,"6":"Instead someone declared in Scripture: What is man, that you should be mindful of him, what is the son of man that you should care for him?"
,"7":"For a while you placed him a little lower than the angels, but you crowned him with glory and honor."
,"8":"You have given him dominion over all things. When it is said that God gave him dominion over all things, nothing is excluded. As it is, we do not yet see his dominion over all things. "
,"9":"But Jesus who suffered death and for a little while was placed lower than the angels has been crowned with honor and glory. For the merciful plan of God demanded that he experience death on behalf of everyone."
,"10":"God, from whom all come and by whom all things exist, wanted to bring many children to glory, and he thought it fitting to make perfect through suffering the initiator of their salvation."
,"11":"So he who gives and those who receive holiness are one. He himself is not ashamed of calling us brothers and sisters,"
,"12":"as we read: Lord, I will proclaim your name to my brothers; I will praise you in the congregation."
,"13":"He also says: I will trust in God; here I am and the children God has given me."
,"14":"And because all those children share one same nature of flesh and blood, Jesus likewise had to share this nature. This is why his death destroyed the one holding the power of death, that is the devil,"
,"15":"and freed those who remained in bondage all their lifetime because of the fear of death."
,"16":"Jesus came to take by the hand not the angels but the human race."
,"17":"So he had to be like his brothers and sisters in every respect, in order to be the High Priest faithful to God and merciful to them, a priest able to ask pardon and atone for their sins."
,"18":"Having been tested through suffering, he is able to help those who are tested."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Therefore, holy brothers, called to a supernatural vocation, consider Jesus, the apostle and High Priest of our faith."
,"2":"He is faithful to God who appointed him, just as Moses was a faithful steward over God's household"
,"3":"but Jesus deserves much greater honor than Moses, since he who builds the house is greater than the house."
,"4":"As every house has a builder, God is the builder of all."
,"5":"It is said that Moses was found faithful as a servant of God over all his household, and as witness of a former revelation from God."
,"6":"Christ came as the Son, to whom the house belongs; and we are his household, provided that we stand firm in hope and courage."
,"7":"Listen to what the Holy Spirit says: If only you would hear God's voice today!"
,"8":"Do not be stubborn, as they were in the place called Rebellion,"
,"9":"when your ancestors challenged me in the desert, although they had seen my deeds"
,"10":"for forty years. That is why I was angry with those people and said: Their hearts are always going astray and they do not understand my ways."
,"11":"I was angry and made a solemn vow: They will never enter my rest."
,"12":"So, brothers, be careful lest some of you come to have an evil and unbelieving heart that falls away from the living God."
,"13":"Encourage one another, day by day, as long as it is called today. Let no one become hardened in the deceitful way of sin."
,"14":"We are associated with Christ provided we hold steadfastly to our initial hope until the end."
,"15":"Scripture says: If you hear God's voice, do not be stubborn as they were in the place called Rebellion."
,"16":"Who are those who having heard still rebelled? They were all those who came out of Egypt with Moses."
,"17":"With whom was God angry for forty years? With those who sinned and whose bodies fell in the desert."
,"18":"To whom did God swear that they would not enter into his rest? To those who had disobeyed."
,"19":"We see then that unbelief prevented them from reaching their rest."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Therefore let us fear while we are invited to enter the rest of God, lest any of you be left behind."
,"2":"We have been invited like them. But the message they heard did not benefit them because they did not hold to this belief."
,"3":"We are now to enter this rest because we believed, as it was said: I was angry and made a solemn vow: they will never enter my rest - that is the rest of God after he created the world."
,"4":"In another part it was said about the seventh day: And God rested on the seventh day from all his works."
,"5":"But now it is said: They will not enter my rest."
,"6":"We must conclude that some will enter the rest of God and that those who first received the good news did not, because of their disobedience."
,"7":"Yet God again assigns a day when he says: today, and declares through David many years later: If you hear God's voice today, do not be stubborn."
,"8":"So it was not Joshua who let them enter the land of rest; otherwise God would not have assigned another day later on."
,"9":"Then some other rest, or sabbath, is reserved for the people of God."
,"10":"For those who enter this rest of God rest from all their works as God rests from his work."
,"11":"Let us strive, then, to enter the rest and not to share the misfortune of those who disobeyed."
,"12":"For the word of God is living and effective, sharper than any two-edged sword. It pierces to the division of soul and spirit, of joints and marrow, and judges the intentions and thoughts of the heart."
,"13":"All creation is transparent to Him; everything is uncovered and laid bare to the eyes of Him to whom we render account."
,"14":"We have a great High Priest, Jesus, the Son of God, who has entered heaven. Let us, then, hold fast to the faith we profess."
,"15":"Our high priest is not indifferent to our weaknesses, for he was tempted in every way just as we are, yet without sinning."
,"16":"Let us, then, with confidence approach God, the giver of grace; we will obtain mercy and, through his favor, help in due time."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Every High Priest is taken from among mortals and appointed to be their representative before God to offer gifts and sacrifices for sin."
,"2":"He is able to understand the ignorant and erring for he himself is subject to weakness."
,"3":"This is why he is bound to offer sacrifices for his sins as well as for the sins of the people."
,"4":"Besides, one does not presume to take this dignity, but takes it only when called by God, as Aaron was."
,"5":"Nor did Christ become High Priest in taking upon himself this dignity, but it was given to him by the One who says: You are my son, I have begotten you today."
,"6":"And in another place: You are a priest forever in the priestly order of Melchizedek."
,"7":"Christ, in the days of his mortal life, offered his sacrifice with tears and cries. He prayed to him who could save him from death, and he was heard because of his humble submission."
,"8":"Although he was Son, he learned through suffering what obedience was,"
,"9":"and once made perfect, he became the source of eternal salvation for those who obey him."
,"10":"This is how God proclaimed him Priest in the order of Melchizedek."
,"11":"About this we have much to say, but it is difficult to explain, for you have become dull in understanding."
,"12":"You should be teachers by this time, but in fact you need to be taught again the basic elements of God's teaching. You need milk, not solid food."
,"13":"Those fed with milk are still infants: this refers to those who have not been tested in the way of righteousness."
,"14":"Solid food is for adults who have trained themselves to distinguish good from evil."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Therefore let us leave the elementary teaching about Christ and move forward to a more advanced knowledge without laying again the foundation, that is: turning away from dead works, faith in God,"
,"2":"the teaching about baptisms and laying on of hands, the resurrection of the dead and the final judgment."
,"3":"This is what we shall do, God permitting."
,"4":"In any case, it would be impossible to renew again through penance those who have once been enlightened and have tasted the heavenly gift and received the Holy Spirit,"
,"5":"tasted the beauty of the word of God and the wonders of the supernatural world."
,"6":"If in spite of this they have ceased to believe and have fallen away, it is impossible to move them a second time to repentance when they are crucifying, on their own account, the Son of God, and spurning him publicly."
,"7":"Soil that drinks the rain falling continually on it and produces profitable grass for those who till it, receives the blessings of God,"
,"8":"but the soil that produces thorns and bushes is poor soil and in danger of being cursed. In the end it will be burned."
,"9":"Yet even though we speak like this, we are more optimistic, dear friends, regarding you and your salvation."
,"10":"God is not unjust and will not forget everything you have done for love of his name; you have helped and still help the believers."
,"11":"We desire each of you to have, until the end, the same zeal for reaching what you have hoped for."
,"12":"Do not grow careless but imitate those who, by their faith and determination, inherit the promise."
,"13":"Remember God's promise to Abraham. God wanted to confirm it with an oath and, as no one is higher than God,"
,"14":"he swore by himself: I shall bless you and give you many descendants."
,"15":"By just patiently waiting, Abraham obtained the promise."
,"16":"People are used to swearing by someone higher than themselves and their oath affirms everything that could be denied."
,"17":"So God committed himself with an oath in order to convince those who were to wait for his promise that he would never change his mind."
,"18":"Thus we have two certainties in which it is impossible that God be proved false: promise and oath. That is enough to encourage us strongly when we leave everything to hold to the hope set before us."
,"19":"This hope is like a spiritual anchor, secure and firm, thrust beyond the curtain of the Temple into the sanctuary itself,"
,"20":"where Jesus has entered ahead of us - Jesus, High Priest for ever in the order of Melchizedek."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Scripture says that Melchizedek, king of Salem, priest of the Most High God, came out to meet Abraham who returned from defeating the kings. He blessed Abraham and Abraham gave him a tenth of everything."
,"2":"Let us note that the name Melchizedek means King of Justice, and that king of Salem means king of Peace."
,"3":"There is no mention of father, mother or genealogy; nothing is said about the beginning or the end of his life. In this he is the figure of the Son of God, the priest who remains forever."
,"4":"See then how great Melchizedek was. Even Abraham gave him a tenth of the spoils!"
,"5":"When the descendants of Levi are consecrated priests, they are commanded to collect tithes from their people, that is from their kindred, who are too, are descendants of Abraham."
,"6":"Here, however, Melchizedek, who does not belong to the family of the Levites, is given tithes from Abraham. Still more, he blesses him, the man of God's promise."
,"7":"There is no doubt that he who blesses is higher than the one who is blessed."
,"8":"In the first case we see that tithes are received by those who are mortals; here instead, Melchizedek is mentioned as one who lives on."
,"9":"When Abraham pays the tenth, it is, so to speak, the Levites, receivers of the tithes, who pay the tithe,"
,"10":"because, in a way, Levi was still in the body of Abraham, his ancestor, when Melchizedek met him."
,"11":"The institutions of the chosen people are founded upon the Levitical priesthood, but with it they could not attain what is perfect and permanent. If that were possible, why would there be need of another priest after the order of Melchizedek instead of Aaron's?"
,"12":"If there is a change in the priesthood, the Law also has to be changed."
,"13":"Jesus, to whom all this has reference, was from a tribe that never served at the altar."
,"14":"All know that he belonged to the tribe of Judah that is not mentioned by Moses when he speaks of the priesthood."
,"15":"All this, however, becomes clear if this priest after the likeness of Melchizedek"
,"16":"has in fact received his mission, not on the basis of any human law, but by the power of an immortal life."
,"17":"Because Scripture says: You are a priest forever in the priestly order of Melchizedek."
,"18":"With this the former disposition is removed as insufficient and useless"
,"19":"(for the Law did not bring anything to perfection). At the same time a better hope is given to us: that of drawing near to God."
,"20":"This change is confirmed by God's oath. When the others became priests, God did not compromise himself with an oath,"
,"21":"but Jesus is confirmed with an oath, as it is said: The Lord has sworn and will not change his mind: you are a priest forever."
,"22":"Therefore, Jesus is our assurance of a better covenant."
,"23":"The former priests were many since, as mortal men, they could not remain in office."
,"24":"But Jesus remains forever and the priesthood shall not be taken from him."
,"25":"Consequently he is able to save for all time those who approach God through him. He always lives to intercede on their behalf."
,"26":"It was fitting that our High Priest be holy, undefiled, set apart from sinners and exalted above the heavens;"
,"27":"a priest who does not first need to offer sacrifice for himself before offering for the sins of the people, as high priests do. He offered himself in sacrifice once and for all."
,"28":"And whereas the Law elected weak men as high priests, now, after the Law, the word of God with an oath appointed the Son, made perfect forever."
}`)
	CurrentBook.AddChapter(8, `{
"1":"The main point of what we are saying is that we have a high priest. He is seated at the right hand of the divine majesty in heaven,"
,"2":"where he serves as minister of the true temple and sanctuary, set up not by any mortal but by the Lord."
,"3":"A high priest is appointed to offer to God gifts and sacrifices, and Jesus also has to offer some sacrifice."
,"4":"Had he remained on earth, he would not be a priest, since others offer the gifts according to the Law."
,"5":"In fact, the ritual celebrated by those priests is only an imitation and shadow of the supernatural ritual. We know the word of God to Moses with regard to the construction of the holy tent. He said: You are to make everything according to the pattern shown to you on the mountain."
,"6":"Now, however, Jesus enjoys a much higher ministry in being the mediator of a better covenant, founded on better promises."
,"7":"If all had been perfect in the first covenant, there would have been no need for another one."
,"8":"Yet God sees defects when he says: The days are coming - it is the word of the Lord - when I will draw up a new covenant with the people of Israel and with the people of Judah."
,"9":"It will not be like the covenant that I made with their ancestors on the day I took them by the hand and led them out of Egypt. They did not keep my covenant, and so I myself have forsaken them, says the Lord."
,"10":"But this is the covenant that I will make with the people of Israel in the days to come: I will put my laws into their minds and write them on their hearts. I will be their God and they will be my people."
,"11":"None of them will have to teach one another or say to each other: Know the Lord, for they will know me from the least to the greatest."
,"12":"I will forgive their sins and no longer remember their wrongs."
,"13":"Here we are being told of a new covenant; which means that the first one had become obsolete, and what is obsolete and aging is soon to disappear."
}`)
	CurrentBook.AddChapter(9, `{
"1":"The first covenant had rites and regulations. There was also a sanctuary - an earthly one."
,"2":"A first room had the lampstand, the table and the bread of the presence. This room is called the Holy Place. "
,"3":"Behind the second curtain, there is a second sanctuary called the Most Holy Place,"
,"4":"with the gold altar for the burning of incense, and the ark of the Covenant, fully covered with gold. The ark contained a golden jar holding the manna, Aaron's rod that had sprouted leaves and the two slabs of the covenant."
,"5":"Above the ark the two cherubim of glory overshadowed the Seat of Mercy. But we cannot here describe it in detail."
,"6":"With everything arranged as described, the priests continually enter the first room to fulfill their ministry;"
,"7":"but the High Priest enters only once a year the second one, and not without bringing the blood which he will offer for himself and for the sins of the people."
,"8":"By this, the Holy Spirit teaches us that the way into the inner sanctuary is not open as long as the first room still stands."
,"9":"Here is a teaching by means of figures for the present age: the gifts and sacrifices presented to God cannot bring the people offering them to interior perfection."
,"10":"These are no more than food, drink and different kinds of cleansing by water; all these are human regulations awaiting a reformation."
,"11":"But now Christ has appeared as the high priest with regard to the good things of these new times. He passed through a sanctuary more noble and perfect, not made by hands, that is, not created."
,"12":"He did not take with himself the blood of goats and bulls but his own blood, when he entered once and for all into this sanctuary after obtaining definitive redemption."
,"13":"If the sprinkling of people defiled by sin with the blood of goats and bulls or with the ashes of a heifer provides them with exterior cleanness and holiness,"
,"14":"how much more will it be with the blood of Christ? He, moved by the eternal Spirit, offered himself as an unblemished victim to God and his blood cleanses us from dead works, so that we may serve the living God."
,"15":"So Christ is the mediator of a new covenant or testament. His death made atonement for the sins committed under the old testament, and the promise is handed over to all who are called to the everlasting inheritance."
,"16":"With every testament it is necessary to wait until its author has died."
,"17":"For a testament infers death and has no value while the maker of it is still alive."
,"18":"That is why the first covenant was not ratified without blood."
,"19":"Moses proclaimed to the assembled people all the commandments of the Law; then he took the blood of bulls and goats and mixed it with water, hyssop and red wool, and sprinkled the book of the Covenant and the people"
,"20":"saying: This is the blood of the Covenant that God commanded you."
,"21":"In the same way he sprinkled with blood the Sanctuary and all the objects of the ritual."
,"22":"According to the Law, almost all cleansings have to be performed with blood; there is no forgiveness without the shedding of blood."
,"23":"It was necessary that mere copies of supernatural realities be purified, but now these realities need better sacrifices."
,"24":"Christ did not enter some sanctuary made by hands, a copy of the true one, but heaven itself. He is now in the presence of God on our behalf."
,"25":"He had not to offer himself many times, as the High Priest does: he who may return every year, because the blood is not his own."
,"26":"Otherwise he would have suffered many times from the creation of the world. But no; he manifested himself only now at the end of the ages, to take away sin by sacrifice,"
,"27":"and, as humans die only once and afterwards are judged,"
,"28":"in the same way Christ sacrificed himself once to take away the sins of the multitude. There will be no further question of sin when he comes again to save those waiting for him."
}`)
	CurrentBook.AddChapter(10, `{
"1":"The religion of the Law is only a shadow of the good things to come; it has the patterns but not the realities. So, year after year, the same sacrifices are offered without bringing the worshipers to what is the end."
,"2":"If they had been cleansed once and for all, they would no longer have felt guilt and would have stopped offering the same sacrifices."
,"3":"But no, year after year their sacrifices witness to their sins"
,"4":"and never will the blood of bulls and goats take away these sins."
,"5":"This is why on entering the world, Christ says: You did not desire sacrifice and offering;"
,"6":"you were not pleased with burnt offerings and sin offerings."
,"7":"Then I said: 'Here I am. It was written of me in the scroll. I will do your will, O God.'"
,"8":"First he says: Sacrifice, offerings, burnt offerings and sin offerings you did not desire nor were you pleased with them - although they were required by the Law."
,"9":"Then he says: Here I am to do your will. This is enough to nullify the first will and establish the new. "
,"10":"Now, by this will of God, we are sanctified at once by the sacrifice of the body of Christ Jesus."
,"11":"So, whereas every priest stands daily by the altar offering repeatedly the same sacrifices that can never take away sins,"
,"12":"Christ has offered for all times a single sacrifice for sins and has taken his seat at the right hand of God,"
,"13":"waiting until God puts his enemies as a footstool under his feet."
,"14":"By a single sacrifice he has brought those who are sanctified to what is perfect forever."
,"15":"This also was testified by the Holy Spirit. For after having declared:"
,"16":"This is the covenant that I will make with them in the days to come - says the Lord - I will put my laws in their hearts and write them on their minds."
,"17":"He says: Their sins and evil deeds I will remember no more."
,"18":"So, if sins are forgiven, there is no longer need of any sacrifice for sin."
,"19":"So, my friends, we are assured of entering the Sanctuary by the blood of Jesus"
,"20":"who opened for us this new and living way passing through the curtain, that is, his body."
,"21":"Because we have a high priest in charge of the House of God,"
,"22":"let us approach with a sincere heart, with full faith, interiorly cleansed from a bad conscience and our bodies washed with pure water."
,"23":"Let us hold fast to our hope without wavering, because he who promised is faithful."
,"24":"Let us consider how we may spur one another to love and good works."
,"25":"Do not abandon the assemblies as some of you do, but encourage one another, and all the more since the Day is drawing near."
,"26":"If we sin willfully after receiving knowledge of the truth, there is no longer sacrifice for sin,"
,"27":"but only the fearful prospect of judgment and of fire which devours the rebellious."
,"28":"For whoever violated the law of Moses there is no mercy: is put to death by the testimony of two or three persons."
,"29":"What, then, do you think it will be for those who have despised the Son of God? How severely shall he be punished for having defiled the blood of the covenant by which they were sanctified and for having insulted the Spirit given to them?"
,"30":"For we know the One who says: Revenge is mine, I will repay. And also: The Lord will judge his people."
,"31":"What a dreadful thing to fall into the hands of the living God."
,"32":"Remember the first days when you were enlightened. You had to undergo a hard struggle in the face of suffering."
,"33":"Publicly you were exposed to humiliations and trials, and had to share the sufferings of others who were similarly treated."
,"34":"You showed solidarity with those in prison; you were dispossessed of your goods and accepted it gladly for you knew you were acquiring a much better and more durable possession."
,"35":"Do not now throw away your confidence which will be handsomely rewarded."
,"36":"Be patient in doing the will of God, and the promise will be yours:"
,"37":"A little, a little longer - says Scripture - and he who is coming will come; he will not delay."
,"38":"My righteous one will live if he believes; but if he distrusts, I will no longer look kindly on him."
,"39":"We are not among those who withdraw and perish, but among those who believe and win personal salvation."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Faith is the way of holding onto what we hope for, being certain of what we cannot see."
,"2":"Because of their faith our ancestors were approved."
,"3":"By faith we understand that the stages of creation were disposed by God's word, and what is visible came from what cannot be seen."
,"4":"Because of Abel's faith his offering was more acceptable than that of his brother Cain, which meant he was upright, and God himself approved his offering. Because of this faith he cried to God, as said in Scripture, even after he died."
,"5":"By faith Enoch was taken to Heaven, instead of experiencing death: he could not be found because God had taken him. In fact, it is said that before being taken up he had pleased God."
,"6":"Yet without faith it is impossible to please him: no one draws near to God without first believing that he exists and that he rewards those who seek him earnestly."
,"7":"By faith Noah was instructed of events which could not yet be seen and, heeding what he heard, he built a boat in which to save his family. The faith of Noah condemned the world and he reached holiness born of faith."
,"8":"It was by faith that Abraham, called by God, set out for a country that would be given to him as an inheritance; for he parted without knowing where he was going."
,"9":"By faith he lived as a stranger in that promised land. There he lived in tents, as did Isaac and Jacob, beneficiaries of the same promise."
,"10":"Indeed, he looked forward to that city of solid foundation of which God is the architect and builder."
,"11":"By faith Sarah herself received power to become a mother, in spite of her advanced age; since she believed that he who had made the promise would be faithful."
,"12":"Therefore, from an almost impotent man were born descendants as numerous as the stars of heavens, as many as the grains of sand on the seashore."
,"13":"Death found all these people strong in their faith. They had not received what was promised, but they had looked ahead and had rejoiced in it from afar, saying that they were foreigners and travelers on earth."
,"14":"Those who speak in this way prove that they are looking for their own country."
,"15":"For if they had longed for the land they had left, it would have been easy for them to return,"
,"16":"but no, they aspired to a better city, that is, a supernatural one; so God, who prepared the city for them is not ashamed of being called their God."
,"17":"By faith Abraham went to offer Isaac when God tested him. And so he who had received the promise of God offered his only son"
,"18":"although God had told him: Isaac's descendants will bear your name."
,"19":"Abraham reasoned that God is capable even of raising the dead, and he received back his son, which has a figurative meaning."
,"20":"By faith also Isaac blessed Jacob and Esau, determining their future."
,"21":"By faith Jacob, before he died, blessed both children of Joseph and worshiped as he leaned on his staff."
,"22":"By faith Joseph, when about to die, warned the children of Israel of their exodus and gave orders about his remains."
,"23":"By faith the parents of the newlyborn Moses hid him for three months, for they saw the baby was very beautiful and they did not fear the order of Pharaoh."
,"24":"By faith Moses, already an adult, refused to be called son of Pharaoh's daughter."
,"25":"He preferred to share ill treatment with the people of God, rather than enjoy the passing pleasures of sin."
,"26":"He considered the humiliation of Christ as greater riches than the wealth of Egypt, and he looked ahead to his reward."
,"27":"By faith he left Egypt without fearing the king's anger, and he persevered as if he could see another invisible wrath."
,"28":"By faith Moses had the Passover celebrated, sprinkling the doors with blood so that the Destroyer would not kill their firstborn sons."
,"29":"By faith they crossed the Red Sea, as if on dry land, while the Egyptians who tried to cross it were swallowed by the waters and drowned."
,"30":"By faith the walls of Jericho crumbled and fell, after Israel had marched round them for seven days;"
,"31":"by faith, also, the prostitute Rahab escaped death which befell the unbelievers for having welcomed the spies."
,"32":"Do I need to say more? There is not enough time to speak of Gideon, Barak, Samson, Jephthah, David, as well as Samuel and the prophets."
,"33":"Through faith they fought and conquered nations, established justice, saw the fulfillment of God's promises, shut the mouths of lions,"
,"34":"quenched raging fire, escaped the sword, were healed of their sicknesses, were valiant in battle, repulsed foreign invaders."
,"35":"Some women recovered their dead by resurrection but there were others - persecuted and tortured believers - who, for the sake of a better resurrection, refused to do what would have saved them."
,"36":"Others suffered chains and prison."
,"37":"They were stoned, sawn in two, killed by the sword. They fled from place to place with no other clothing than the skins of sheep and goats, lacking everything, afflicted, ill-treated."
,"38":"These people of whom the world was not worthy had to wander through wastelands and mountains, and take refuge in the dens of the land."
,"39":"However, although all of them were praised because of their faith, they did not enjoy the promise"
,"40":"because God had us in mind and saw beyond. And he did not want them to reach this end ahead of us."
}`)
	CurrentBook.AddChapter(12, `{
"1":"What a cloud of innumerable witnesses surround us! So let us be rid of every encumbrance, and especially of sin, to persevere in running the race marked out before us."
,"2":"Let us look to Jesus the founder of our faith, who will bring it to completion. For the sake of the joy reserved for him, he endured the cross, scorning its shame, and then sat at the right of the throne of God."
,"3":"Think of Jesus who suffered so many contradictions from evil people, and you will not be discouraged or grow weary."
,"4":"Have you already shed your blood in the struggle against sin?"
,"5":"Do not forget the comforting words that Wisdom addresses to you as children: My son, pay attention when the Lord corrects you and do not be discouraged when he punishes you."
,"6":"For the Lord corrects those he loves and chastises everyone he accepts as a son."
,"7":"What you endure is in order to correct you. God treats you like sons and what son is not corrected by his father?"
,"8":"If you were without correction which has been received by all, (as is fitting for sons), you would not be sons but bastards."
,"9":"Besides, when our parents according to the flesh corrected us, we respected them. How much more should we be subject to the Father of spirits to have life?"
,"10":"Our parents corrected us as they saw fit, with a view to this very short life; but God corrects us for our own good that we may share his holiness."
,"11":"All correction is painful at the moment, rather than pleasant; later it brings the fruit of peace, that is, holiness to those who have been trained by it."
,"12":"Lift up, then, your drooping hands, and strengthen your trembling knees;"
,"13":"make level the ways for your feet, so that the lame may not be disabled, but healed."
,"14":"Strive for peace with all and strive to be holy, for without holiness no one will see the Lord."
,"15":"See that no one falls from the grace of God, lest a bitter plant spring up and its poison corrupt many among you."
,"16":"Let no one be immoral or irreligious like Esau, who sold his birthright for a single meal."
,"17":"You know that later, when he wished to get the blessing, he was rejected although he pleaded with tears."
,"18":"Remember your initiation. There was no material presence nor heat of a blazing fire, darkness and gloom and storms..."
,"19":"blasts of trumpets or such a voice that the people pleaded that no further word be spoken."
,"20":"All this was intended to have them respect the order not to approach: Every man or beast reaching the mountain shall be stoned."
,"21":"The sight was so terrifying that Moses said: I tremble with fear."
,"22":"But you came near to Mount Zion, to the city of the living God, to the heavenly Jerusalem with its innumerable angels. You have come to the solemn feast,"
,"23":"the assembly of the firstborn of God, whose names are written in heaven. There is God, Judge of all, with the spirits of the upright brought to perfection."
,"24":"There is Jesus, the mediator of the new covenant, with the sprinkled blood that cries out more effectively than Abel's."
,"25":"Be careful not to reject God when he speaks. If those who did not heed the prophet's warnings were not spared on earth, how much more shall we be punished if we do not heed the One warning us from Heaven?"
,"26":"His voice then shook the earth, but now he says: In this last time I will shake not only the earth but also the heavens."
,"27":"The words in this last time indicate the removal of everything that can be shaken, that is, created things, and only those that cannot be shaken will remain."
,"28":"Such is the kingdom that we receive. Let us then be grateful and offer to God a worship pleasing to him with reverence and awe."
,"29":"Our God is indeed a consuming fire."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Let mutual love continue."
,"2":"Do not neglect to offer hospitality; you know that some people have entertained angels without knowing it."
,"3":"Remember prisoners as if you were with them in chains, and the same for those who are suffering. Remember that you also have a body."
,"4":"Marriage must be respected by all and husband and wife faithful to each other. God will punish the immoral and the adulterous."
,"5":"Do not depend on money. Be content with having enough for today for God has said: I will never forsake you or abandon you,"
,"6":"and we shall confidently answer: The Lord is my helper, I will not fear; what can man do to me?"
,"7":"Remember your leaders who taught you the word of God. Consider their end and imitate their faith."
,"8":"Christ Jesus is the same today as yesterday and forever."
,"9":"Do not be led astray by all kinds of strange teachings. Your heart will be strengthened by the grace of God rather than by foods of no use to anyone."
,"10":"We have an altar from which those still serving in the Temple cannot eat."
,"11":"After the High Priest has offered the blood in the Sanctuary for the sins of the people, the carcasses of the animals are burnt outside the camp."
,"12":"For this same reason Jesus, to purify the people with his own blood, suffered his Passion outside the holy city."
,"13":"Let us, therefore, go to him outside the sacred area, sharing his shame."
,"14":"For we have here no lasting city and we are looking for the one to come."
,"15":"Let us, then, continually offer through Jesus a sacrifice of praise to God, that is the fruit of lips celebrating his name."
,"16":"Do not neglect good works and common life, for these are sacrifices pleasing to God."
,"17":"Obey your leaders and submit to them, for they are concerned for your souls and are accountable for them. Let this be a joy for them rather than a burden, which would be of no advantage for you."
,"18":"Pray for us, for we believe our intentions are pure and that we only want to act honorably in all things."
,"19":"Now I urge you all the more to pray for me that I may be given back to you the sooner."
,"20":"May God give you peace, he who brought back from among the dead Jesus our Lord, the Great Shepherd of the sheep, whose blood seals the eternal covenant."
,"21":"He will train you in every good work, that you may do his will, for it is he who works in us what pleases him, through Jesus Christ, to whom all glory be for ever and ever. Amen!"
,"22":"Brothers, I beg you to take these words of encouragement. For my part, I will add few words."
,"23":"Know that our brother Timothy has been released. If he comes soon I will visit you with him."
,"24":"Greetings to all your leaders and to the saints. Greetings from those in Italy."
,"25":"Grace be with you all."
}`)

}
func EN_CCB_LoadVH1MChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Everything began with the conquests of Alexander the first, son of Philip, the Macedonian. Setting out from Greece, he killed Darius, king of the Persians and the Medes. Being already King of Greece, he took the throne of Darius."
,"2":"After fighting many battles, conquering strongholds and putting to death the kings of those nations,"
,"3":"he reached the ends of the earth and plundered several nations. And when the world became quiet and subject to his power, he became proud."
,"4":"He gathered a strong army, ruled over provinces and nations, and rulers paid him taxes."
,"5":"But he fell sick, and knowing he was going to die,"
,"6":"he summoned his generals and the noblemen who had been brought up with him from his youth; and while still alive, he divided his kingdom among them."
,"7":"Alexander had reigned for twelve years when he died."
,"8":"His generals assumed power, each one in the region assigned to him."
,"9":"And immediately after Alexander's death, they made themselves kings and their sons after them, filling the earth with evil for many years."
,"10":"From their descendants there came a godless offshoot, Antiochus Epiphanes, son of King Antiochus, who had been held as hostage in Rome. He became king in the one hundred and thirty-seventh year of the Greek era, (175 B.C.)."
,"11":"It was then that some rebels emerged from Israel, who succeeded in winning over many people. They said, 'Let us renew contact with the peoples around us for we have had endured many misfortunes since we separated from them.'"
,"12":"This proposal was well-received"
,"13":"and some eagerly went to the king. The king authorized them to adopt the customs of the pagan nations."
,"14":"With his permission, they built a gymnasium in Jerusalem in the pagan style."
,"15":"And as they wanted to be like the pagans in everything, they made artificial foreskins for themselves and abandoned the Holy Covenant, sinning as they pleased."
,"16":"When Antiochus felt confident of his power, he decided to seize Egypt and rule over the two nations."
,"17":"He entered Egypt with a strong army, with chariots of war, elephants, horses and a great fleet"
,"18":"and attacked Ptolemy, king of Egypt. Ptolemy had to retreat and was defeated, and many of his men died."
,"19":"The victors seized the fortified cities of Egypt and plundered the land."
,"20":"In the year one hundred and forty-three (169 B.C.), when Antiochus returned after defeating Egypt, he passed through Israel and went up to Jerusalem with a strong army."
,"21":"He arrogantly broke into the sanctuary and removed the golden altar, the lampstand for the light with all its accessories,"
,"22":"the table for the bread of offering, the libation vessels, the cups, the golden censers, the curtains and the crowns, and stripped away all the decorations, the golden moldings that used to cover the Temple entrance."
,"23":"He also took possession of the silver, gold, valuable objects and all the hidden treasures he could find."
,"24":"He took everything with him and left for his country, after shedding much blood and making arrogant statements."
,"25":"There was great mourning throughout the land of Israel:"
,"26":"The leaders and the elders groaned, young men and maidens lost courage, and women grew pale;"
,"27":"bridegrooms sang lamentations, and the young bride wept in her marriage-bed."
,"28":"The earth quaked, in sorrow for its inhabitants, and all the people of Jacob were humiliated."
,"29":"After two years, the king sent to the cities of Judah the chief tax collector and he came to Jerusalem with a strong army."
,"30":"He spoke to the people with words of peace in order to deceive them. But when he had gained their confidence, he suddenly fell on the city and dealt it a terrible blow, killing many Israelites."
,"31":"He plundered the city, burning and destroying the palaces and the surrounding walls."
,"32":"He took women and children captive and seized the livestock."
,"33":"Then they rebuilt the city of David with a high and solid wall protected by strong towers, and this became their fortress."
,"34":"There they set evil men and apostates who defended it."
,"35":"They stored up weapons and provisions, and everything they looted in the city, posing a constant threat."
,"36":"It became an ambush for the sanctuary, a grave and constant threat to Israel."
,"37":"They shed innocent blood around the sanctuary and defiled the sanctuary itself."
,"38":"The inhabitants of Jerusalem fled because of them. She became a colony of strangers, and was a stranger to her children who abandoned her."
,"39":"Her sanctuary became empty as the desert, her feasts became days of mourning, her Sabbaths were ridiculed, and her fame became an object of contempt."
,"40":"As her glory had been great, so now was her dishonor, for her greatness was turned into grief."
,"41":"Antiochus issued a decree to his whole kingdom."
,"42":"All the peoples of his empire had to renounce their particular customs and become one people."
,"43":"All the pagan nations obeyed and respected the king's decree, and even in Israel many accepted the imposed cult. They offered sacrifices to idols and no longer respected the Sabbath."
,"44":"The King sent messengers to Jerusalem and the cities of Judea to carry the decree which imposed strange customs."
,"45":"In accordance with it, burnt offerings, sacrifices and other offerings in the sanctuary were suppressed. It also ordered that Sabbaths and sacred feasts be like ordinary days."
,"46":"The sanctuary and its ministers were no longer to be regarded sacred,"
,"47":"instead, altars, sacred enclosures and temples were to be dedicated to idols. They were to offer pigs and unclean animals in sacrifice,"
,"48":"and not perform on their sons the rite of circumcision. To sum up, they were to defile themselves by all kinds of impurity and profanity"
,"49":"in order to forget the Law and change all their customs."
,"50":"The decree finally declared: 'Anyone who does not fulfill the king's order shall die.'"
,"51":"The king published this obligation throughout the province and inspectors appointed by him went around the land of Judea. They saw to it that sacrifices were offered in all cities."
,"52":"Many Israelites joined them, abandoned the Law and committed countless evils"
,"53":"obliging the true Israelites to find places of refuge to hide themselves."
,"54":"On the fifteenth day of the month of Chislev, in the year one hundred and forty-five, Antiochus erected the 'abominable idol of the invaders' on the altar of the temple. Pagan altars were built throughout the whole land of Judea;"
,"55":"incense was offered at the doors of their houses and in the squares."
,"56":"There wicked men tore up the books of the Law they found and burned them."
,"57":"They killed anyone they caught in possession of the book of the Covenant and who fulfilled the precepts of the Law, as the royal decree had ordered."
,"58":"And being men in power, they pursued the Israelite rebels they found month after month in the cities."
,"59":"On the twenty-fifth day of every month, they offered their sacrifices on the new altar they had built upon the altar of the Temple."
,"60":"The women who, in defiance of the decree, had the rite of circumcision performed on their children, were put to death with their babies hung around their necks."
,"61":"Their families and all who had taken part in the circumcision were also put to death."
,"62":"But in spite of all this, many Israelites still remained firm and determined not to eat unclean food."
,"63":"They preferred to die rather than to make themselves unclean with those foods (prohibited by the Law) that violated the Holy Covenant."
,"64":"And Israel suffered a very great trial."
}`)
	CurrentBook.AddChapter(2, `{
"1":"In those days Mattathias, son of Simon, a priest of the family of Yoarib, left Jerusalem and went to settle in Modein."
,"2":"He had five sons: John, known as Gaddi,"
,"3":"Simon called Thassi,"
,"4":"Judas called Maccabeus,"
,"5":"Eleazar called Avaran, and Jonathan called Apphus."
,"6":"Mattathias saw the blasphemies committed in Judah and Jerusalem,"
,"7":"so he said: 'Alas! Was I born just to witness the ruin of my people and the destruction of the holy city? Shall I sit by while she is in the hands of her enemies and her sanctuary in the power of foreigners?"
,"8":"Her temple has become like a dishonored man,"
,"9":"the precious objects that were her glory have been carried off as booty, her babies have been murdered in the squares, and her young men killed by the sword of the enemy."
,"10":"What nation has not received part of her treasures and taken possession of her spoils?"
,"11":"She has been stripped of all her adornments and from the freedom that was hers, she has gone into slavery."
,"12":"Our beautiful sanctuary that was our pride has been laid waste and profaned by pagans."
,"13":"What is there to live for?'"
,"14":"Mattathias and his sons tore their clothes, put on sackcloth and went into deep mourning."
,"15":"In the meantime, the king's representatives, who were forcing the Jews to give up their religion came to Modein to organize a sacred gathering."
,"16":"While many Israelites went to them, Mattathias and his sons drew apart."
,"17":"The representatives of the king addressed Mattathias, and said to him: 'You are one of the leaders of this city, an important and well-known man, and your many children and relatives follow you."
,"18":"Come now and be the first to fulfill the king's order, as the men of Judah have already done, and the survivors in Jerusalem as well. You and your sons will be named Friends of the King and the king will send you gold, silver and many other gifts.'"
,"19":"But Mattathias answered in a loud voice: 'Even if all the nations included in the kingdom should abandon the religion of their fathers and submit to the order of King Antiochus,"
,"20":"I, my sons and my family will remain faithful to the Covenant of our fathers."
,"21":"May God preserve us from abandoning the Law and its precepts."
,"22":"We will not obey the orders of the king nor turn aside from our religion either to the right or to the left.'"
,"23":"When he finished speaking these words, a Jew came forward in the sight of everyone to offer incense on the altar that was built in Modein according to the king's decree."
,"24":"When Mattathias saw him, he was fired with zeal, his heart was stirred, and giving vent to his righteous anger, he threw himself on the Jew and cut the man's throat on the altar."
,"25":"At the same time, he killed the king's representative who was forcing the people to offer sacrifice, and then tore down the altar."
,"26":"In doing this he showed his zeal for the Law, as Phinehas had done with Zimri, son of Salu."
,"27":"Mattathias then began to proclaim loudly in the city: 'Everyone who is zealous for the Law and supports the Covenant, come out and follow me!'"
,"28":"Immediately he and his sons fled to the mountains and left behind all they had in the city."
,"29":"Many Jews who looked for justice and wanted to be faithful to the Law went into the desert;"
,"30":"they took with them their children, wives and livestock because life had become unbearable for them."
,"31":"Then the king's representatives and the authority in the city of David, in Jerusalem, were informed that some men had disobeyed the king's order and had gone to hide in the caves in the desert."
,"32":"A strong force of the king pursued and overtook them. They surrounded them and prepared themselves for an attack. It was the day of the Sabbath."
,"33":"And they said to the Jews: 'Enough of this! Come out and obey the king's order if you wish to save your lives.'"
,"34":"But they answered: 'We will neither come out nor obey the king's order to violate the day of the Sabbath.'"
,"35":"So they attacked them at once,"
,"36":"but the Jews did not defend them-selves, nor did they try to close the entrance of their place of refuge."
,"37":"They said: 'We shall die with a clear conscience but heaven and earth will remember that we were murdered.'"
,"38":"The king's men attacked them on that Sabbath, and they all died - men, women and children - a total of more than a thousand, not counting the livestock."
,"39":"When Mattathias and his friends came to know what happened, they went into deep mourning."
,"40":"They said to one another: 'We cannot do as our brothers have done; we shall fight against the pagans to defend our life and our customs; otherwise, they will quickly destroy us.'"
,"41":"On that day, they resolved to defend themselves against anyone who attacked them on the day of the Sabbath, and not let themselves be killed, as had happened with their people in the hiding place."
,"42":"At that time, a group of Hasideans (the Devout), valiant Israelites who devoted themselves sincerely to the Law, joined them."
,"43":"All those who wanted to escape from oppression joined them, and in this way they grew strong."
,"44":"They succeeded in forming an army; then they began to pour their anger and indignation onto the sinners and renegades. These men had to flee to other lands for safety."
,"45":"Mattathias and his friends made expeditions during which they destroyed the altars,"
,"46":"imposed by force the rite of circumcision on the children they found uncircumcised,"
,"47":"and pursued all the arrogant. The undertaking prospered in their hands."
,"48":"They defended the Law against foreigners and their kings, and subdued the renegades."
,"49":"When Mattathias neared his death, he said to his sons: 'Now the insolent and the violent are in power; it is a time of upheaval in which God releases his anger."
,"50":"So, my sons, be zealous for the Law and risk your lives defending the Covenant of our fathers."
,"51":"Remember the deeds our fathers fulfilled in their time, that you too may have fame and glory."
,"52":"Remember Abraham who proved himself faithful in the hour of trial, and how God held him to be a righteous man."
,"53":"Joseph, at the time of his misfortune observed the commandment of God and so became the lord of Egypt."
,"54":"Phinehas, our father, because of his great zeal received the priesthood for himself and for his sons forever."
,"55":"Joshua became head of Israel because he carried out God's command."
,"56":"Caleb received his inheritance in this land because he had proclaimed the truth before the assembly."
,"57":"And David was given a lasting kingdom because of his devotion."
,"58":"Elijah because of his zeal for the Law was taken up into heaven."
,"59":"Hananiah, Azariah and Mishael were saved from the flames because of their faith."
,"60":"Daniel was rescued from the lion's mouth because of his righteousness."
,"61":"Consider, then, that in any generation those who trust in God are never defeated."
,"62":"Do not fear the threats of an impious man, for his glory shall end in dung and worms."
,"63":"Today he is exalted, but tomorrow he shall perish; he shall return to dust from where he came, and nothing shall remain of his plans."
,"64":"Have courage, my sons, and remain steadfast in the Law for in this you will receive glory."
,"65":"I know that among you, Simon is a man of sound judgment; listen to him and he shall take your father's place."
,"66":"Judas Maccabeus has been valiant from his youth: let him be your general and conduct the war against foreigners."
,"67":"Now, call all those who fulfill the Law to join you and defend our people."
,"68":"Retaliate against the pagans and fulfill the ordinance of the Law.'"
,"69":"Mattathias blessed them and then went to join his fathers."
,"70":"He died in the year one hundred and forty-six and they buried him in the tomb of his fathers at Modein; and all Israel mourned him deeply."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Mattathias' son, Judas Maccabeus, succeeded him."
,"2":"His brothers and all who had followed his father gave him their support and they continued the war with determination."
,"3":"Judas made the name of his people more famous. He put on his breastplate and girded himself with the armor of war like a giant; he fought many battles and protected his camp with his sword."
,"4":"He was like a lion when he attacked, like a lion's whelp roaring over its prey."
,"5":"He pursued the renegades in their secret places and consigned to the flames those who troubled his people."
,"6":"All the renegades feared him, all evildoers were confounded, and liberation was accomplished through him."
,"7":"Many kings feared him, while the people of Israel rejoiced in his deeds. His memory shall be blessed forever. "
,"8":"He went through the cities of Judah utterly destroying the impious and saved Israel in their trial."
,"9":"His fame resounded to the ends of the earth for having gathered those about to perish."
,"10":"Apollonius also gathered together men from the pagans and a good number of Samaritans to fight Israel."
,"11":"When Judas learned of this, he went out to meet him in battle; he defeated and killed him. Many of the enemy fell and the rest fled."
,"12":"They seized the plunder and Judas took the sword of Apollonius, and from then on he always used it in battle."
,"13":"Seron, the commander of the Syrian army, learned that Judas had gathered many men and that the whole community of believers was at his side."
,"14":"He thought: 'This is now the opportunity for me to make myself famous and become an important man in the kingdom. I will go to fight Judas and his men who do not obey the king's order.'"
,"15":"So he did, and a strong army of pagans went up with him to help him take vengeance on the children of Israel."
,"16":"As Seron approached the slope of Beth-horon, Judas went out to confront him with a small company of warriors."
,"17":"But on seeing the enemy advancing against them, Judas' men said to him, 'How can we, few as we are, fight against so many? And besides, we feel weak for we have not eaten anything today.'"
,"18":"But Judas declared: 'A multitude shall easily fall into the hands of a few, for Heaven can win over equally well with the help of many or of few."
,"19":"Victory does not depend on the number of those who fight, but on Heaven which gives us strength."
,"20":"They come against us, moved by their pride and lawlessness, to seize us and take possession of our wives and children and to take everything away from us."
,"21":"But we are fighting for our lives and our laws."
,"22":"God will crush them before us; so do not be afraid.'"
,"23":"As soon as he finished speaking, he suddenly rushed against the enemies. Seron and his army were defeated."
,"24":"They pursued them down the slope of Beth-horon to the plain. And about eight hundred of Seron's men fell and the rest escaped to the land of the Philistines."
,"25":"With this, fright and fear of Judas and his brothers seized the pagans who lived around them."
,"26":"The fame of his name reached the king, and the pagan nations recounted his battles."
,"27":"When this news reached King Antiochus, he was furious, so he ordered all the forces of his kingdom to assemble, for he had a powerful army."
,"28":"He opened his treasury and paid the troops a year's salary, ordering them to be prepared for any eventuality."
,"29":"But he found that the money in the treasury had run short, for the taxes of the provinces had decreased due to dissension and disaster, which he himself had caused in the land by changing the laws that were in force from the earliest days."
,"30":"He feared that, as before, he would not have enough funds for his expenses and for the gifts he used to give more lavishly than preceding kings."
,"31":"So great was his need that he decided to go to Persia to collect the taxes from those provinces and raise considerable funds."
,"32":"Then he left Lysias, a nobleman from the royal family, in charge of the affairs of government, from the river Euphrates to the Egyptian frontier,"
,"33":"and with the responsibility of educating the king's son, Antiochus, until his return."
,"34":"And he turned over to Lysias half of his troops with the elephants and gave him instructions about his policies. On matters dealing with the inhabitants of Judea and Jerusalem,"
,"35":"Lysias was to send an army to destroy and crush the defenders of Israel and all who remained in Jerusalem and to wipe out even the memory of them."
,"36":"Then he was to have foreigners settle throughout the Jewish territory and distribute the land to them by lot."
,"37":"The king took with him the remaining half of the army and set out from Antioch, the capital of the kingdom, in the year one hundred and forty-seven. He crossed the river Euphrates and went through the upper provinces."
,"38":"Lysias chose from among the Friends of the King, Ptolemy the son of Dorymenes, Nicanor and Gorgias - all influential men."
,"39":"With them, he dispatched forty thousand infantry and seven thousand cavalry to the Judean province to destroy it as the king had ordered."
,"40":"They marched out with their troops and encamped on the plain near Emmaus."
,"41":"The merchants of the region heard of their arrival, so they went to the camp with large amounts of silver, gold and fetters, proposing to buy the Israelites as slaves. The Syrian army and those from the province of the Philistines also joined the troops."
,"42":"Judas and his brothers understood that the situation was becoming worse, because the enemy had encamped in their territory. So when they learned of the king's order to destroy and crush the people,"
,"43":"they said, 'Let us uplift our people from their miserable situation and fight for them and for the Holy Place!'"
,"44":"The whole community assembled to prepare for war, and they prayed and asked God for mercy and compassion."
,"45":"Like a desert, Jerusalem was left without inhabitants. None of her children went in or out. The temple was profaned, and foreigners lived in the city which had become a dwelling place for the pagans. There was no more rejoicing for Jacob, no flute or zither was heard."
,"46":"So they gathered and went to Mizpah opposite Jerusalem because Mizpah had been a place of prayer for Israel."
,"47":"They fasted that day, put on sackcloth, sprinkled ashes on their heads and tore their garments."
,"48":"They opened the Book of the Law to look for an answer to their questions, just as the pagans consulted the images of their idols."
,"49":"They brought the vestments of the priests, the first-fruits and the tithes, and they brought in the Nazirites who had completed the days of their consecration;"
,"50":"they cried aloud to Heaven and said: 'What shall we do with this people, and where shall we take them?"
,"51":"For your sanctuary has been trampled on and profaned, your priests are in mourning and are humiliated."
,"52":"And now the pagans have gathered together to destroy us. You know what they are plotting against us."
,"53":"How can we resist them, if you do not come to help us?'"
,"54":"Then they sounded the trumpets and made a great outcry."
,"55":"After this, Judas appointed officials to lead his people: leaders of a thousand men, leaders of a hundred, of fifty, and of ten."
,"56":"Then he told those who were building houses, those about to marry, those who were planting vineyards, and those who were afraid, to return to their homes, as the Law allowed."
,"57":"Next the army marched out and encamped to the south of Emmaus."
,"58":"Judas told them: 'Prepare your weapons; be valiant and be ready to fight in the morning against those foreigners who have joined forces to crush us and remove our Holy Place from this land."
,"59":"It is better to die fighting than to live and see the misery of our nation and of the Holy Place."
,"60":"May Heaven's will be done in everything.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Gorgias took with him five thousand infantry and a thousand picked cavalry, and moved out by night"
,"2":"to fall upon the Jews and take them by surprise. He had asked men from the Citadel to guide his troops."
,"3":"But Judas learned of this, so he went out with his men to attack the king's army in Emmaus"
,"4":"while the enemy troops were still dispersed outside the camp."
,"5":"Gorgias arrived at the camp of the Jews by night but found no one there. He then began to search for them in the mountains, for he thought: 'They are running away from us.'"
,"6":"But at daybreak, Judas appeared in the plain with three thousand men who had not the armor or swords they would have liked."
,"7":"They saw the camp of the pagans with its strong fortifications and the calvary surrounding it - all trained men in war."
,"8":"Judas said to his men: 'Do not fear the number of the enemy or be afraid of their attack."
,"9":"Remember how our ancestors were saved at the Red Sea when Pharaoh's army pursued them."
,"10":"Cry out to God, for if he so wishes he will remember his Covenant and destroy that army before us this very day."
,"11":"And all the nations will know that Someone saves and liberates Israel.'"
,"12":"The pagans looked up and saw the Jews coming down against them,"
,"13":"so they came out of their camp to face them in battle. Judas had the trumpets sounded"
,"14":"and his men attacked. The pagans were defeated and fled to the plain,"
,"15":"but all the rear guard fell by the sword. They pursued them to Gazara, to the plains of Idumea, of Azot and Jamnia and killed about three thousand of the enemy."
,"16":"When Judas and his army stopped chasing them,"
,"17":"he said to the men with him: 'Do not think of the booty now, for another battle awaits us."
,"18":"Gorgias with his army is in the hills close by. Remain ready to fight them, and afterwards you can gather the plunder with nothing to worry about.'"
,"19":"He had barely finished speaking when an army detachment appeared on the hillside."
,"20":"These men saw that their own troops had fled and their camp had been destroyed, for the smoke that rose up from the camp was enough to tell them this."
,"21":"So they were terrified. And when they saw the army of Judas drawn up on the plain ready for battle,"
,"22":"they fled to the land of the Philistines."
,"23":"So Judas and his men returned to plunder the camp. They carried off valuable booty."
,"24":"And on their return, they sang and praised heaven: For he is good, and his mercy is eternal."
,"25":"That day was a great victory for Israel."
,"26":"The pagans who had escaped went to Lysias and told him what had happened."
,"27":"When he heard this, he was dismayed and depressed because things in Israel had not gone as expected, and he had not carried out the king's command."
,"28":"The following year, he organized an army of sixty thousand men and five thousand cavalry to confront the Jews."
,"29":"They advanced into Idumea and encamped at Bethzur. Judas came out with ten thousand men to meet them in battle."
,"30":"When he saw their military strength, he prayed, 'Blessed are you, Savior of Israel, who broke the warrior's strength by the hand of your servant David, and handed over the camp of the Philistines to the power of Jonathan, son of Saul, and to his armor-bearer."
,"31":"In the same way, give this army into the hands of your people Israel, and let the confidence they place in their power and in their horses be destroyed."
,"32":"Fill them with fear; shatter their confidence in their own strength. May they be defeated and recover no more."
,"33":"Deliver them to the sword of your faithful people so that all who know you may praise your name.'"
,"34":"Both sides attacked, and five thousand men from the army of Lysias fell dead."
,"35":"Lysias saw that his army was disheartened, while Judas and his men grew bolder and were ready to live or to die nobly. So he retreated to Antioch, where he recruited mercenaries to strengthen his army, for he planned to return to Judea."
,"36":"Then Judas and his brothers said: 'Our enemies are defeated, so let us go up and purify the Holy Place and consecrate it again.'"
,"37":"And all the army assembled and went up to Mount Zion."
,"38":"There they found the sanctuary abandoned, the altar profaned, the gates burned, bushes growing in the courtyard as in a forest or on a mountain, and the rooms destroyed."
,"39":"They tore their garments and wept bitterly. Some sprinkled ashes on their heads,"
,"40":"while others prostrated themselves on the ground. They sounded the trumpets and cried aloud to Heaven."
,"41":"Then Judas chose men to fight against the defenders of the Citadel until he had purified the temple."
,"42":"He chose blameless priests who showed great zeal for the Law"
,"43":"and had them purify the temple and bring the stones of the abominable altar of the pagans to an unclean place."
,"44":"They held a council to decide on what should be done with the altar of the holocausts which had been defiled."
,"45":"And they decided to destroy it, so that shame brought about by the pagans might not remain with it."
,"46":"They deposited the stones of the said altar in a convenient place on the temple hill until a prophet should appear to settle the matter."
,"47":"Then they took uncut stones as the Law prescribed, and built a new altar like the former one."
,"48":"They repaired the sanctuary, and the interior of the house, and consecrated the courts."
,"49":"They made new sacred vessels and brought in the lampstand, the altar of incense and the table."
,"50":"They burned incense on the altar, and lit the lamps on the lampstand, and these began to shine in the temple."
,"51":"They placed the bread on the table and hung up the curtains - bringing to completion all that had been decided."
,"52":"On the twenty-fifth day of the month of Chislev, in the year one hundred and forty-eight (164 B.C.)"
,"53":"they arose at dawn and offered the sacrifice prescribed by the Law on the new altar of holocausts which they had built."
,"54":"It was precisely at that same time and date that the pagans had profaned it before; but now they consecrated it with songs accompanied by zithers, harps and cymbals."
,"55":"All the people fell prostrate and blessed Heaven that had given them happiness and success."
,"56":"They celebrated the consecration of the altar for eight days, joyfully offering holocausts and celebrating sacrifices of thanksgiving and praise."
,"57":"The front of the temple was adorned with crowns of gold and shields; the gates and the rooms had been restored and fitted with doors."
,"58":"There was no end to the celebration among the people, and so the profanation of the temple by the pagans was forgotten."
,"59":"Finally, Judas, his brothers and the whole assembly of Israel agreed to celebrate the anniversary of the consecration of the altar annually for eight days, from the twenty-fifth of the month of Chislev, in high festivity."
,"60":"At that time, they built around Mount Zion high walls and strong towers to prevent the pagans from coming in to occupy it as they had done before."
,"61":"Judas stationed a garrison there to defend it. He also fortified Bethzur so that the people might have a fortress against Idumea."
}`)
	CurrentBook.AddChapter(5, `{
"1":"When the pagans who lived around them learned that the altar had been rebuilt and the temple restored as before, they became very angry."
,"2":"They determined to destroy the descendants of Jacob who lived among them; so they began killing and driving away the Jews."
,"3":"That is why Judas declared war against the sons of Esau in Idumea and in the province of Akrabattene, for they surrounded Israel. He dealt them a mortal blow - he humbled them and looted them."
,"4":"Then he remembered the wickedness of the gangs of Baean who were a plague and a permanent source of trouble for the Jews with their ambushes on the roads."
,"5":"So Judas, after blockading and besieging them in their towers, took an oath to exterminate them; he then burned the towers with all who were inside."
,"6":"From there he crossed over to the land of the Ammonites where he encountered a large and well-organized army under the command of Timotheus."
,"7":"He engaged them in many encounters, defeated them and crushed them."
,"8":"He attacked and captured the city of Yazer with its neighboring villages and then returned to Judea."
,"9":"The pagans of Gilead gathered together to destroy the Israelites who lived in their territory. But the Israelites took refuge in the fortress of Dathema,"
,"10":"and sent a letter to Judas and his brothers which said, 'The pagans around us have joined forces to crush us"
,"11":"and are now preparing to storm the fortress where we have taken refuge. Timothy is their leader."
,"12":"Come at once and rescue us from their hands since many among us have already died;"
,"13":"all our brothers living in the land of Tobias have been murdered, their women and children taken captives; about a thousand men have been killed.'"
,"14":"They were reading this letter when other messengers arrived from Galilee tearing their garments as they gave this message:"
,"15":"'The people of Ptolemais, Tyre, Sidon and the whole of heathen Galilee have united to destroy us!'"
,"16":"When Judas and his men heard this news, they summoned a great assembly to determine what could be done for their brothers and sisters in distress who were fighting for their lives."
,"17":"Judas said to his brother Simon: 'Choose your men; go and free our brothers in Galilee; I and my brother Jonathan will go to Gilead.'"
,"18":"He left the rest of the troops under the command of Joseph the son of Zechariah, and Azariah, a leader of the people, to defend the land of Judea,"
,"19":"and gave them this order: 'Remain at the head of the people, but do not attack the pagans until we return.'"
,"20":"Three thousand men were assigned to Simon for the campaign in Galilee, and eight thousand men to Judas for Gilead."
,"21":"Simon left for Galilee and defeated the pagans in many encounters,"
,"22":"and pursued them to the gates of Ptolemais. About three thousand of the pagans fell, and Simon seized their spoils."
,"23":"Then he took away with him the Jews who were in Galilee and Arbatta as well as their women and children, and all they had, and brought them into Judea with great rejoicing."
,"24":"Meanwhile, Judas Maccabeus and his brother Jonathan crossed the Jordan and journeyed through the desert for three days."
,"25":"There they encountered the Nabateans who received them in a friendly way and told them all that had happened to their brothers in the region of Gilead."
,"26":"They gave them the news that many Jews were imprisoned in Alema, Chaspho, Maked and Carnaim, all large and fortified towns in the vicinity of Bozrah and Bosor."
,"27":"They also related that Jews were also blockaded in other cities of Gilead, and that the pagans had decided to attack their strongholds on the following day intending to destroy all of them in one day."
,"28":"Judas quickly turned off with his army by the desert road to Bozrah; he occupied the city, put all the men to the sword, seized the booty and then burned the city."
,"29":"He left the place at night and advanced until they reached the fortress."
,"30":"At dawn, the Jews looked up and saw an innumerable army carrying ladders and engines of war to attack and capture the fortress."
,"31":"Judas saw that the attack had begun; from the city an uproar rose up to heaven with shouts and trumpet blast."
,"32":"He said to his men: 'Let us now fight for our brothers.'"
,"33":"Then he divided his troops into three groups, and attacked the enemy from behind, sounding the trumpets and praying out loud."
,"34":"When the army of Timothy recognized that it was Maccabeus, they began to escape, but Judas dealt them a heavy blow, and about five thousand of the enemy fell that day."
,"35":"From there, Judas went to Alema; he attacked and occupied the city, killed all the men and seized the booty, and then he burned the city."
,"36":"From there, he captured Chaspho, Maked and Bosor and the remaining towns of Gilead."
,"37":"After these events, Timothy gathered a new army and encamped opposite Raphon, at the other side of the stream."
,"38":"Judas sent men to explore the camp and they brought back the following information: 'All the pagans of this region have joined forces under Timothy, forming a powerful army."
,"39":"They have also hired Arab mercenaries as auxiliaries, and they are now encamped at the other side of the stream, ready to attack you.' So Judas set out to confront them in battle."
,"40":"Timothy saw that Judas was approaching the stream with his army, so he said to the captains of his troops, 'If he crosses first and advances against us, he shall attack us with such great force that we will not be able to withstand him."
,"41":"But if he hesitates and encamps at the other side of the river, then we shall cross over to attack and defeat him.'"
,"42":"When Judas reached the banks of the stream, he assigned the officials of his men along the stream and ordered them: 'Do not let anyone pitch his tent; all are to fight.'"
,"43":"Judas was the first to cross to the enemy, and all his men followed. They defeated all the pagans who threw down their weapons and took refuge in the sacred enclosure of Carnaim."
,"44":"But the Jews captured the city and burned the sacred enclosure with everyone inside. So Carnaim was crushed, and no one was able to withstand Judas."
,"45":"Judas gathered together all the Israelites from the region of Gilead, small and great, their women and children and their belongings, an immense multitude, to take them into the land of Judea."
,"46":"They reached Ephron, a strong and important town, situated by the road. It was impossible to go around it either to the right or to the left, so they were forced to go through it,"
,"47":"but the inhabitants entrenched themselves inside and blocked the entrance with stones."
,"48":"Judas sent them a message of peace saying: 'Allow us to go through your land as we go back to ours; we will simply walk through and none of us will do you any harm.' But they refused to open the gates to him."
,"49":"So Judas gave orders to his army for everyone to take up his position where he was."
,"50":"The men of war took up their positions, and Judas attacked the city all day and night until it fell into his hands."
,"51":"He put all the male inhabitants to the sword, razed the city and took its plunder."
,"52":"Then they passed through the city over the bodies of the dead and came to the great plain after crossing the Jordan opposite Bethshan."
,"53":"Throughout the journey Judas kept on encouraging his people and rallying those who fell behind, until they reached the land of Judah."
,"54":"They went up to Mount Zion joyfully and well contented, and they offered holocausts because they had returned safe and sound, without losing a single man."
,"55":"While Judas and Jonathan were in the land of Gilead, and their brother Simon was encamped in Galilee opposite Ptolemais,"
,"56":"Zechariah's son Joseph and Azariah were in command of the army. When they heard of their exploits and how well they had done in battle,"
,"57":"they said, 'We also have to win renown, so let us go and fight the pagans who live around us.'"
,"58":"So they gave orders to their army to march against Jamnia."
,"59":"But Gorgias came out of the city with his men and attacked them."
,"60":"Joseph and Azariah were defeated and pursued as far as the borders of Judea, and about two thousand Israelites fell that day."
,"61":"The people suffered this great defeat because the Jewish commanders did not listen to Judas and his brothers, thinking they themselves were capable of great deeds."
,"62":"They did not belong to those to whom the deliverance of Israel had been entrusted."
,"63":"The valiant Judas and his brothers were greatly honored in Israel and became famous among the foreigners who heard of them,"
,"64":"and many came to congratulate them."
,"65":"Judas with his brothers went to the Negeb to fight the Edomites. He seized Hebron and its villages, demolished its walls and burned its defending towers."
,"66":"Then he left for the land of the Philistines, passing through Marisa."
,"67":"That day some priests who wanted to be valiant fell because they imprudently attacked the enemy."
,"68":"From there Judas turned towards Azotus in the land of the Philistines. He destroyed their altars, burned the statues of their gods, plundered the city and then returned to Judah."
}`)
	CurrentBook.AddChapter(6, `{
"1":"When King Antiochus was making his way through the upper regions of Persia, he received news about Elymais, a city renowned for its wealth in silver and gold."
,"2":"They kept in the wealthy temple of their city golden armor, breastplates and weapons left there by the Macedonian king, Alexander the son of Philip, the first sovereign of the Greeks."
,"3":"So Antiochus went there but the inhabitants came out armed against him when they learned of his intention, so his attempt to take the city failed."
,"4":"He had to turn back, and he returned much embittered to Babylon."
,"5":"While he was still in Persia, it was reported to him that the armies sent to Judea had been defeated. They told him"
,"6":"that although Lysias had gone with a strong army, he had to flee before the Jews who had been strengthened with the weapons and the abundant booty taken from the neighboring armies."
,"7":"He heard too that the Jews had destroyed the abominable idol he had erected on the altar in Jerusalem, and had rebuilt the temple walls to the same height as before, and had also fortified the city of Beth-zur."
,"8":"When he received this news, he was terrified and deeply upset. He fell sick and became greatly depressed because things had not turned out the way he had planned."
,"9":"So he remained overcome by this terrible anguish for many days. He felt that he was dying,"
,"10":"so he called his friends and said to them, 'Sleep has fled from my eyes and I am greatly crushed by my anxieties."
,"11":"And I keep on asking why such grief has come upon me - I who was generous and well-loved when in power - and now I am so discouraged."
,"12":"Now I remember the evils I did in Jerusalem, the vessels of gold and silver that I stole, the inhabitants of Judea I ordered to be killed for no reason at all."
,"13":"I now know that because of this, these misfortunes have come upon me, and I am dying of grief in a strange land.'"
,"14":"The king then summoned Philip, one of his friends, and appointed him administrator of his whole kingdom."
,"15":"When he had entrusted him with the crown, robe and signet ring, with the charge of educating his son Antiochus and preparing him for the throne,"
,"16":"Antiochus died there in the year one hundred and forty-nine (163 B.C.)."
,"17":"As soon as Lysias learned of the king's death, he proclaimed his son Antiochus as his successor, for he himself had trained him from childhood and had named him Eupator."
,"18":"The men from the Citadel were blockading the Israelites around the temple and did not let an opportunity pass of harming them on behalf of the pagans."
,"19":"Judas decided to wipe them out,"
,"20":"so he gathered together all the people to besiege them. The troops assembled and laid siege to the Citadel in the year one hundred and fifty, building firing platforms and siege engines."
,"21":"But some of the besieged broke through the blockade and together with renegade Israelites"
,"22":"went to tell the king, 'How much longer will you wait to do us justice and avenge our brothers?"
,"23":"We took the side of your father, we obeyed his orders and observed his laws."
,"24":"The result is that the Citadel is now besieged by our own people and we are treated as foreigners. All of us who were caught have been killed and they have seized our property."
,"25":"And they are fighting not only against us but in the neighboring lands as well."
,"26":"Right now, they are encamped against the Citadel in Jerusalem to capture it, and they have fortified the temple and the city of Beth-zur."
,"27":"If you do not take the lead now, they will do greater things and then you will not be able to control them.'"
,"28":"The king was enraged when he heard this news, and he summoned all his friends, the generals of the army and the commanders of the cavalry."
,"29":"From other kingdoms and islands of the sea, he recruited mercenary troops."
,"30":"His forces numbered a hundred thousand infantry, twenty thousand horsemen and thirty-two elephants trained for battle."
,"31":"They came through Idumea, besieged Beth-zur and attacked for days, using engines of war. But the besieged made a sortie and burned their engines and bravely kept up the resistance."
,"32":"Then Judas ceased fighting at the Citadel and encamped at Beth-zechariah opposite the camp of the king."
,"33":"Early in the morning the king rose and his army boldly advanced along the road to Beth-zechariah. The troops prepared for battle and sounded the trumpets."
,"34":"They showed juice of grapes and mulberries to the elephants to arouse them for battle,"
,"35":"and distributed them among the battalions: one thousand men in coat of mail and bronze helmet lined up at the side of each elephant."
,"36":"A cavalry of five hundred picked horsemen went before each elephant and accompanied it with the order not to separate from it."
,"37":"A strong wooden tower was fixed to each elephant by means of leather straps, and four warriors including the driver were on the tower."
,"38":"The rest of the cavalry were stationed on the right and left flanks of the army to harass the enemy and protect the battalions."
,"39":"When the sun shone on the shields of gold and bronze, the mountains glittered and gleamed like flames of fire."
,"40":"One part of the king's army was deployed up in the mountains and the other on the plain. All advanced confidently and in good order."
,"41":"The Jews trembled when they heard the great noise of this vast multitude, the marching of that mass and the clanking of their weapons. It was indeed an army extremely numerous and powerful."
,"42":"Nevertheless Judas and his army advanced to give battle; and about six hundred men of the king's army fell."
,"43":"Eleazar, called Avaran, saw one of the beasts protected with armor which excelled all the others, so he supposed that it must be the king's."
,"44":"He then sacrificed himself to save his people and win eternal renown for himself."
,"45":"He boldly charged towards the animal right into the midst of the battalion, killing men right and left, scattering the enemy before him on both sides."
,"46":"He reached the elephant, darted in under it, and stabbed it in the belly. The elephant collapsed on top of him and he died on the spot."
,"47":"The Jews, however, aware of the tremendous force of the king's army and their bravery, retreated before them."
,"48":"The king's troops went up to Jerusalem to overtake them, and the king encamped in Judea and around Mount Zion."
,"49":"He made peace with the people of Beth-zur who evacuated the city since they had no food to continue the resistance, for that year was a year of rest for the land."
,"50":"The king seized Beth-zur and stationed a garrison there to guard it."
,"51":"He encamped before the temple for a long time and set up firing platforms, crossbows, engines, fire-throwers, catapults, scorpions to discharge arrows, and slingers."
,"52":"The defenders also constructed engines as their attackers had done and they fought for a long time."
,"53":"But they had no food in storage, as it was the seventh year and because the Israelites who came to Judea from the pagan lands had consumed the last of their reserves."
,"54":"So, few men were left in the temple because of the famine; the others had dispersed."
,"55":"Meanwhile Philip, to whom King Antiochus during his life had entrusted the education of his son Antiochus to prepare him for the throne,"
,"56":"had returned from Persia and Media with the army that had accompanied the king to those regions, and was planning to seize power."
,"57":"This is why Lysias hastily gave orders to depart, saying to the king, the generals of the army and the soldiers, 'We are losing strength every day, we are short of food and the place we are besieging is well fortified; we are moreover diverting our attention from the affairs of the kingdom."
,"58":"Let us, then, offer the hand of friendship to these men, and make peace with them and with their nation."
,"59":"Let us permit them to live according to their customs as before, since all this came to be because we suppressed their laws, and they have risen in defense of them.'"
,"60":"These words pleased the king and the generals,"
,"61":"so the king sent messengers to make peace with the Jews, and the Jews accepted it. When the king and the generals had committed themselves with an oath, the Jews came out of the fortress. "
,"62":"The king went up to Mount Zion and when he saw the defenses, he broke his oath and ordered the surrounding wall to be demolished."
,"63":"Then he hurriedly left and returned to Antioch where he found Philip already in control of the city. So he fought him and took the city by force."
}`)
	CurrentBook.AddChapter(7, `{
"1":"In the year one hundred and fifty-one, Demetrius the son of Seleucus escaped from Rome. He sailed with a few men to a port of the kingdom where he arrived and proclaimed himself king."
,"2":"As soon as he entered the kingdom of his fathers, the army arrested Antiochus and Lysias to hand them over to him."
,"3":"When Demetrius heard this, he said: 'I do not want to see their faces.'"
,"4":"So the army executed them and Demetrius took the throne."
,"5":"At once all the Israelites without law or religion came to him. They were led by Alcimus, a man who sought the office of chief priest for himself."
,"6":"And they began accusing their own people before the king, 'Judas and his brothers have murdered all your friends and have driven us away from our land."
,"7":"Send one of your trustworthy Friends, to see the havoc they have caused us and our province which belongs to the king. Let him punish all who support them.'"
,"8":"The king chose Bacchides, one of his Friends and a distinguished man of the kingdom, the governor of the western province of the Euphrates."
,"9":"He also sent with him Alcimus whom he had appointed chief priest, and ordered them to punish the Israelites."
,"10":"They set out with a large army. On reaching Judea, they sent messengers to Judas and his brothers with treacherous proposals of peace."
,"11":"But the Jews who knew that they came with a powerful army, did not trust them."
,"12":"However, a commission of teachers of the Law met with Alcimus and Bacchides to seek a satisfactory solution."
,"13":"These men from the group of the Hasideans, the first to seek peace in Israel,"
,"14":"reasoned like this: 'A man in the line of Aaron has come with the army, he will surely deal with us in fairness.'"
,"15":"Bacchides, moreover, sent them a friendly message and assured them under oath: 'We do not wish any harm to you and your friends.'"
,"16":"They believed him. But he arrested sixty of them and executed them the same day, according to the word of the Scripture:"
,"17":"Around Jerusalem, they have scattered the dead bodies of your saints; they have shed their blood, and there was no one to bury them."
,"18":"All the people were terrified and feared them. They said, 'There is no justice or truth in these people who have violated the agreement they made with an oath.'"
,"19":"Bacchides left Jerusalem and encamped at Beth-zur. From there, he ordered the arrest of many prominent men who had deserted to him as well as some of the people. And he had them thrown into a deep pit."
,"20":"Then he placed the province in the hands of Alcimus, leaving him with an army to help him and he returned to the king."
,"21":"Alcimus struggled to have the Israelites recognize him as chief priest,"
,"22":"and all who disturbed the peace of the people joined him. They became masters of the land of Judea and did great harm to the Israelites."
,"23":"Judas saw that Alcimus and his men were an even greater menace to Israel than the pagans had been."
,"24":"So he went throughout the territory of Judea to do justice to those traitors and to prevent them from going about the country."
,"25":"Alcimus realized that Judas and his men were of greater strength and that he could not resist them, so he returned to the king and accused them of serious crimes."
,"26":"The king then sent Nicanor, one of his more illustrious generals and a known enemy of Israel, with the mission to utterly destroy this people."
,"27":"Nicanor reached Jerusalem with a large army; he sent Judas and his brothers false messages of friendship saying to them,"
,"28":"'Let us not begin as enemies once more; I will come with a few men to meet you face to face in friendship.'"
,"29":"He inded came to Judas and they greeted each other peaceably, but the enemy was prepared to seize him."
,"30":"Judas was told that Nicanor had come to him treacherously, so he withdrew from Nicanor, and would not see him again."
,"31":"When Nicanor saw that his plans had been discovered, he went out to look for Judas, and this time to fight him. He found him near Capharsalama."
,"32":"About five hundred of Nicanor's men fell and the rest fled to the city of David."
,"33":"After these events, Nicanor went up to Mount Zion and some of the priests and elders came out of the temple to greet him peacefully and show him the sacrifice they offered for the king."
,"34":"But he mocked them, he scorned and insulted them"
,"35":"and angrily swore this oath: 'If you do not deliver Judas into my hands immediately, as soon as I have destroyed him, I will return and burn this temple.' And he went away furious."
,"36":"The priests entered the temple, and they stood weeping before the altar and the sanctuary. They said,"
,"37":"'You, Lord, chose this House that your name may be invoked in it, that it may be a house of prayer and petition for your people."
,"38":"Take vengeance on this man and on his army; let them die by the sword. Remember their insults and do not delay in punishing them.'"
,"39":"Nicanor left Jerusalem and encamped in Beth-horon where the Syrian army joined him."
,"40":"Meanwhile, Judas encamped in Adasa with three thousand men and prayed:"
,"41":"'Lord, when the messengers of the king of Assyria insulted you, your angel came and killed one hundred and eighty-five thousand of his men."
,"42":"So now, crush this army before us, so that all the rest may know that this Nicanor has blasphemed against your temple. Judge him according to his wickedness.'"
,"43":"The two armies met in battle on the thirteenth of the month Adar. Nicanor's army was defeated and he himself was one of the first to fall in the battle."
,"44":"When his troops saw that he was dead, they threw down their weapons and fled."
,"45":"The Jews pursued them a day's journey from Adasa to the entrance of Gazara, sounding the trumpets as they followed them."
,"46":"The people came out from all the neighboring villages of Judea and surrounded the fugitives, forcing them to return to defend their lives. So all fell by the sword, not even one of them was left."
,"47":"Then the Jews seized the plunder and booty; they cut off Nicanor's head and the right hand he had so arrogantly stretched out, and they displayed them at the entrance to Jerusalem within sight of all."
,"48":"The people were elated and"
,"49":"celebrated their victory annually on the thirteenth of the month Adar."
,"50":"The land of Judah enjoyed peace for a short time."
}`)
	CurrentBook.AddChapter(8, `{
"1":"In the meantime, Judas was informed about the Romans. He was told that the Romans were valiant in war and that they showed goodwill towards all who sided with them; that they offered friendship to all who approached them,"
,"2":"and were a strong ally in war. He was told of their wars and of their exploits among the Gauls whom they conquered and forced to pay taxes, "
,"3":"and of all they had done in Spain to gain possession of the silver and gold mines,"
,"4":"and how they had conquered that land by dint of intelligence and perseverance, despite its great distance from their own land. He also learned how they had defeated the kings who came from the ends of the earth to attack them, how they managed to conquer and crush them. There were others who paid them an annual tax."
,"5":"They had defeated and subjected Philip and Perseus, the kings of Macedonia and others who opposed them."
,"6":"They had vanquished Antiochus the Great, king of Asia, who went to fight the Romans with one hundred and twenty elephants, cavalry, chariots and a very strong army. But he was defeated"
,"7":"and fell into their hands. He and his successors were forced to pay an enormous amount in tax, to surrender hostages, and to cede some of their best provinces"
,"8":"like India, Media and Lydia which afterwards the Romans gave to King Eumenes."
,"9":"The Greeks had planned to come and destroy the Romans,"
,"10":"but hearing of it, the Romans sent a single general against them. They killed a great number of Greeks, took their women and children, destroyed their fortresses and enslaved them to this day."
,"11":"In the same way, they also destroyed and subdued other countries and islands, as well as others who opposed them."
,"12":"But they have usually remained faithful to their allies and to those who relied on them. The Romans were really powerful. They conquered kingdoms far and near, and all who heard their name feared them. "
,"13":"They appointed as kings those who were to their liking and deposed those who were not."
,"14":"But in spite of all this, not one of them had himself crowned or dressed as a king in order to be exalted."
,"15":"They had created a senate and three hundred and twenty men deliberated on daily matters relating to the good of the people and the maintenance of order."
,"16":"Every year they would choose one man to rule over them and govern the empire, and all obeyed him without envy or jealousy."
,"17":"So Judas sent Eupolemus the son of John, and Jason the son of Eleazar to Rome, entrusting them with the mission to make a covenant of friendship with the Romans."
,"18":"Since the Greeks treated the Israelites as slaves, Judas hoped to liberate them from oppression in this way."
,"19":"The envoys from Judas went to Rome, where they arrived after a long journey. When they entered the Senate they addressed the assembly:"
,"20":"'Judas Maccabeus, his brothers and the people of Israel have sent us to you to conclude a covenant of peace with you and to be numbered among your allies and friends.'"
,"21":"The Romans approved this proposal,"
,"22":"and this is the copy of the letter they wrote on bronze tablets which they sent to Jerusalem as a memorial of peace and alliance:"
,"23":"'May all go well with the Romans and the Jewish people at sea and on land forever, may both sword and enemy be far from them!"
,"24":"If war comes first to the Romans, or to any of their allies in any part of its empire,"
,"25":"the Jewish nation shall enter the war wholeheartedly, as circumstances permit."
,"26":"The Jewish nation will not receive from them wheat or weapons, or money, or ships as Rome has decided. They must fulfill their obligations without recompense."
,"27":"In the same way, if the Jewish nation is attacked, the Romans shall fight at her side with all zeal as circumstances may allow."
,"28":"The Roman allies will not receive wheat or weapons, or money, or ships as Rome has decided, but the Romans shall fulfill their obligations without deception."
,"29":"On these terms the Romans conclude their alliance with the Jewish nation."
,"30":"If after these terms have taken effect, either party should wish to add or delete anything, the said party shall do so in common agreement with the other party, then what has been added or deleted shall be binding."
,"31":"And concerning the harm King Demetrius does to the Jews, we have written to him as follows, 'Why do you lay such a heavy yoke upon the Jews, our friends and allies?"
,"32":"If they complain about you again, we shall defend their rights and attack you by sea and land.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"When Demetrius was informed of the death of Nicanor and the defeat of his army, he sent Bacchides and Alcimus back to Judea with the best troops of his army."
,"2":"They took the road to Galilee and besieged the city of Mesaloth in the Arbela region. They captured it and killed many."
,"3":"In the first month of the year one hundred and fifty-two, they encamped before Jerusalem."
,"4":"From there twenty thousand infantry and two thousand cavalry set out for Berea."
,"5":"Judas had his camp in Elasa with three thousand picked men."
,"6":"When they saw the huge number of enemies, they were terrified. Many slipped out of the camp, and only eight hundred men were left."
,"7":"Judas saw the dispersal of his army and this crushed his spirit. The battle was imminent but he had no time to group them together."
,"8":"Yet in spite of being dismayed, he did his best to encourage those who remained with him: 'Let us fight our enemies. We may yet be able to defeat them.'"
,"9":"They tried to dissuade him, 'We cannot do anything now but save ourselves. We can come back later with our brothers and fight. But now we are too few.'"
,"10":"But Judas answered them, 'God forbid that I should run away from them. If our time has come, then let us die as valiant men for our brothers, without tarnishing our glory.'"
,"11":"The army of Bacchides marched out of their camp while the Jews remained in their place to engage them in battle. The cavalry was divided into two wings. In the first line, the veterans in war advanced, and the archers and slingers followed."
,"12":"Bacchides was on the right wing. At the sound of the trumpets, they advanced on both sides. The Jews also sounded the trumpets."
,"13":"And the earth trembled with the noise of the armies, and a battle began which lasted the whole day."
,"14":"Judas saw that Bacchides and the main strength of his army was on the right. The most courageous of the Israelites went with him,"
,"15":"and they defeated the right wing of the enemy, pursuing them up to the hills."
,"16":"But when those on the left wing saw the right wing being defeated, they attacked Judas and his men from the rear."
,"17":"They fought bitterly and many fell on both sides."
,"18":"Judas also fell, and the rest fled."
,"19":"Jonathan and Simon took their brother and buried him in the tomb of their fathers at Modein."
,"20":"All the people of Israel mourned and wept for him for many days, repeating this lamentation:"
,"21":"'How the hero has fallen, he who saved Israel.'"
,"22":"The other deeds of Judas, his battles, exploits and heroism were not written for they were many."
,"23":"After the death of Judas, the renegades reappeared throughout the territory of Israel and the evildoers took courage."
,"24":"At the same time, there was a severe famine, and the country went over to their side."
,"25":"Bacchides chose renegade men and made them masters of the land."
,"26":"These men traced and searched out all the friends and supporters of Judas and brought them before Bacchides who punished and humiliated them in a thousand ways."
,"27":"It was a terrible trial for Israel such as had never been experienced since the disappearance of the prophets."
,"28":"So the friends of Judas came together and said to Jonathan,"
,"29":"'Since your brother Judas died, we haven't found anyone like him to head the resistance against the enemy, against Bacchides and all the enemies of our nation."
,"30":"So we now choose you to take his place, to be our head and lead us in our wars.' So from that day on,"
,"31":"Jonathan accepted the leadership and succeeded his brother Judas."
,"32":"When Bacchides heard of this, he planned to kill Jonathan."
,"33":"But Jonathan was informed of the plot and fled to the desert of Tekoa, together with his brother Simon and his followers. They encamped by the lake Asphar."
,"34":"Bacchides found this out on the sabbath day, and with all his army he crossed the Jordan."
,"35":"Jonathan had sent his brother John, representative of the people, to ask their friends the Nabatean to store for them their large amount of baggage."
,"36":"But the tribe of Yambri and the people of Medeba captured John and took all he had with him, then departed with the booty."
,"37":"After this had happened, Jonathan and his brother Simon were told that the Yambrites were celebrating a solemn wedding and were escorting the bride, a daughter of one of the magnates, from Nadabath with great pomp."
,"38":"Both remembered the murder of their brother John, so they went up and hid under cover of the mountain."
,"39":"At a certain moment they heard a confusion of sounds; then they saw a great deal of baggage. The bride groom, his friends and brothers came straight to them with tambourines, musical instruments and many weapons."
,"40":"Then the Jews rushed down on them from their ambush and killed them. There were many casualties and others fled to the mountain. Finally the Jews seized all the plunder."
,"41":"So the wedding turned to mourning and the music to lamentation."
,"42":"Having avenged the death of their brother, the Israelites went back to the marshes of the Jordan. Let us return to Bacchides. "
,"43":"He arrived with a strong army on the sabbath day at the banks of the Jordan."
,"44":"So Jonathan said to his men, 'Courage! Let us fight for our lives, for today things are going to be serious."
,"45":"Dangers surround us - we have the waters of the Jordan on this side, the marshes and the thickets on the other side - there is no place to turn."
,"46":"So cry out to Heaven for deliverance from our enemies.'"
,"47":"And the battle began. Jonathan stretched out his arm to strike Bacchides, but he eluded him and withdrew."
,"48":"So Jonathan and his men leapt into the Jordan, swimming to the other side; but their enemies did not follow them."
,"49":"On that day, about a thousand of Bacchides' men fell."
,"50":"Bacchides returned to Jerusalem. Then he began to build fortified cities in Judea - the strongholds of Jericho, Emmaus, Beth-horon, Bethel, Timnath, Pharathon and Tephon - with high walls and barred gates,"
,"51":"and a garrison stationed in each of them to harass the Israelites."
,"52":"He also fortified the cities of Beth-zur, Gazara and the Citadel, and placed troops in each of them with supplies of provisions."
,"53":"He took the sons of the leaders of the land as hostages and imprisoned them in the Citadel of Jerusalem."
,"54":"In the year one hundred and fifty-three, (159 B.C.) in the second month, Alcimus ordered the demolition of the wall of the inner court of the temple. This meant no less than destroying the work of the prophets."
,"55":"Alcimus did in fact begin the demolition but soon after suffered a stroke, so the work was suspended. Alcimus was no longer able to speak, not even to rule over his household."
,"56":"After a while, he died in great agony."
,"57":"Because of his death, Bacchides returned to the king and the land had peace for two years."
,"58":"Then all the renegades agreed on a plan: 'Jonathan and his people now live in peace without any fear at all. Let us bring Bacchides back; he can arrest them all in one night.'"
,"59":"They went to Bacchides, and when they had convinced him,"
,"60":"he set out with a large contingent. He secretly sent letters to his supporters in Judea instructing them to seize Jonathan and his men. But their plot was found out and their plan foiled."
,"61":"Instead the supporters of Jonathan arrested fifty Jewish leaders of this conspiracy and had them executed."
,"62":"Jonathan and Simon then withdrew with their men to Bethbasi in the desert; they rebuilt the ruins and fortified it."
,"63":"When Bacchides heard this, he assembled all his men and notified his adherents in Judea."
,"64":"He went to attack Bethbasi, besieged it for many days and built engines of war."
,"65":"Then Jonathan left his brother Simon in the city and went out into the countryside with a handful of men."
,"66":"He defeated Odomera and his brothers and the people of Phasiron in their camp."
,"67":"Then they turned back and began to attack the troops who had laid siege to the city. Meanwhile, Simon and his men went out of the city and burned the engines."
,"68":"They attacked Bacchides who was defeated and dismayed by the failure of his expedition."
,"69":"He was greatly enraged against the renegades who had advised him to return to the Jewish country; he executed many of them, and decided to return to his own land."
,"70":"When Jonathan learned this, he sent messengers to him to make a treaty of peace and to exchange prisoners."
,"71":"Bacchides accepted his terms. For Bacchides' part, he fulfilled his promises and swore that henceforth and until the day of his death, he would never harm him in any way."
,"72":"He turned over to Jonathan the prisoners taken earlier in Judea. Then he returned to his own country and never came back again to the territory of Judea."
,"73":"So there was peace in Israel, and Jonathan resided in Michmash where he began to govern the land, and the renegades disappeared from Israel."
}`)
	CurrentBook.AddChapter(10, `{
"1":"In the year one hundred and sixty (152 B.C.), Alexander Epiphanes, son of Antiochus, sailed for Ptolemais and occupied it. He was well received and he began to reign."
,"2":"When Demetrius heard this, he assembled a very large army and marched out to fight him."
,"3":"At the same time, he sent a letter of friendship to Jonathan and offered him vast power,"
,"4":"for Demetrius thought: 'Let us make the first move in making peace with him before he makes peace with Alexander against us,"
,"5":"remembering all the wrongs we have done to him, his brothers and his nation.'"
,"6":"So Demetrius authorized Jonathan to organize an army and manufacture arms; he named him his ally and ordered the release of the hostages who were in the Citadel of Jerusalem."
,"7":"Jonathan went at once to Jerusalem and read the letter before all the people and those in the Citadel."
,"8":"They were afraid when they heard that the king had authorized Jonathan to organize a great army,"
,"9":"and they released the hostages to Jonathan who handed them back to their families."
,"10":"Jonathan resided in Jerusalem and began rebuilding and restoring the city."
,"11":"He commanded the builders to build the walls and the defenses of Mount Zion with hewn stones. And they did so."
,"12":"Then all the foreigners who stayed in the fortresses built by Bacchides began to flee,"
,"13":"each of them abandoning his post and returning to his own land."
,"14":"Only at Beth-zur did some who had abandoned the Law and the precepts remain, since this was like a place of refuge."
,"15":"King Alexander was informed of the promises Demetrius had made to Jonathan; he was also given an account of the battles and exploits of Jonathan and his brothers and the trials they had endured."
,"16":"So Alexander declared: 'Shall we ever find another man like him? Let us make him our ally and friend.'"
,"17":"And he wrote him a letter:"
,"18":"'King Alexander to our brother Jonathan, peace."
,"19":"We have heard of you, that you are a valiant man and most worthy of our friendship."
,"20":"Therefore, we now appoint you High Priest of your nation and bestow on you the title Friend of the King (he also sent him a purple robe and a golden crown). So we invite you to watch over our interests and maintain friendly relations with us.'"
,"21":"This is why in the seventh month of the year one hundred and sixty (152 B.C.), on the occasion of the feast of Tabernacles, Jonathan put on the sacred vestments. He also recruited troops and manufactured a great quantity of arms."
,"22":"When Demetrius heard what had happened, he was greatly displeased and said,"
,"23":"'What have we done that Alexander is ahead of us in gaining the friendship of the Jews?"
,"24":"I will also write them kind words and promise them honor and gifts to win them to my side.'"
,"25":"So he wrote to the Jews: 'King Demetrius greets the Jewish nation. "
,"26":"You have kept your agreement with us and have remained our friends, and have not joined our enemies. We have heard of it and so we rejoice."
,"27":"Therefore, continue to be faithful and we will grant you privileges in return for all you do on our behalf."
,"28":"I will free the Jews from many taxes and grant them royal privileges and exemptions."
,"29":"From now on and forever, I now free all Jews from payment of tribute, salt dues and crown levies."
,"30":"I give up from this day and henceforth the third of the harvest and half of the fruit of the trees which I have the right to exact from the region of Judea and the three districts annexed to it from Samaria and Galilee."
,"31":"From this day on and for all time, Jerusalem shall be a Holy City and be free with all its territory, with the right to collect tithes and tributes."
,"32":"I also give up control of the Citadel of Jerusalem and turn it over to the High Priest that he may choose the men he wants to defend it."
,"33":"I grant freedom without ransom to all the captives taken from Judea into any part of my kingdom. I free everyone from the taxes they owe me for their livestock."
,"34":"All feasts, sabbaths, new moons, special days and the three holy days before and after a feast shall be days of exemption for all the Jews in my kingdom."
,"35":"No one shall have the right to pursue or molest them for any motive whatsoever."
,"36":"I also decree that they be accepted into the king's army to the number of thirty thousand Jews who shall receive the same salary as the rest of the king's forces."
,"37":"Some of them shall be stationed at the king's fortresses, and positions of trust shall be given to some of them; their officers shall be chosen from among themselves and they will live according to their laws as the king has prescribed in the land of Judea."
,"38":"The three districts of Samaria annexed to Judea shall be considered part of Jewish territory; to avoid any conflict of power, these shall be subject to no authority other than that of the High Priest."
,"39":"I give the city of Ptolemais and its territory as a gift to the temple of Jerusalem to cover the expenses of public worship."
,"40":"Henceforth, I will give fifteen thousand pieces of silver annually for the maintenance of the temple which shall be taken from the royal revenues from appropriate places."
,"41":"Moreover, I give all that should have been paid to me by the administrators in previous years."
,"42":"In addition, I also remit the five thousand pieces of silver levied every year from the tributes to the temple, and give them to the priests in charge of public worship."
,"43":"Anyone who takes refuge in the temple of Jerusalem or in any of its enclosures because of his debt on royal taxes or because of any other debt, shall not be disturbed and his possessions anywhere in my kingdom shall be duly protected."
,"44":"Finally, the cost of rebuilding or restoring the sanctuary shall be passed on to the king's account,"
,"45":"as well as the expenses of reconstructing the walls of Jerusalem, the fortification of its defenses and the construction of the walls in the cities of Judea.'"
,"46":"When Jonathan and the people heard such proposals, they did not believe or accept them, for they remembered the great wrongs Demetrius had done to Israel and the ill-treatment to which he had subjected them."
,"47":"They decided in favor of Alexander, for he was the first to propose peace, and they became his faithful allies."
,"48":"King Alexander assembled a great army and encamped opposite Demetrius."
,"49":"The two kings met in battle and the army of Demetrius was routed. Alexander pursued him until Demetrius was defeated."
,"50":"The battle lasted until sunset, and on that day Demetrius died."
,"51":"Then Alexander sent messengers to Ptolemy the king of Egypt with the following message:"
,"52":"'I am now again in my kingdom and have assumed power after defeating Demetrius and all his army."
,"53":"Now I occupy the throne of my fathers as master of all the land. Let us be friends."
,"54":"Give me your daughter in marriage, and I will become your son-in-law, and I will give you, and her, gifts worthy of you.'"
,"55":"King Ptolemy replied as follows: 'Blessed be the day when you returned to the land of your fathers and ascended to their throne!"
,"56":"I will without delay do for you as you have proposed. But meet me in Ptolemais. There we shall see one another and I will receive you as my son-in-law as you have requested.'"
,"57":"Ptolemy left Egypt with his daughter Cleopatra in the year one hundred and sixty-two, and arrived at Ptolemais."
,"58":"Alexander went to meet him, and Ptolemy gave him his daughter Cleopatra, and celebrated her wedding with great splendor as kings do."
,"59":"King Alexander also wrote to Jonathan to come and meet him."
,"60":"So Jonathan went to Ptolemais with great pomp and met the two kings. Then he gave them and their Friends much silver and gold and many other gifts."
,"61":"The renegades, the pest of Israel, gathered together to accuse Jonathan, but the king paid no attention to them."
,"62":"The king even gave orders that Jonathan remove his garment and be clothed in purple and it was done."
,"63":"The king also seated him by his side, and said to his captains: 'Go with him into the center of the city and proclaim that no one is to accuse Jonathan under any pretext, and no one is to molest him for any reason.'"
,"64":"When his accusers saw the public honor given to Jonathan and that he was clothed in purple, they all fled."
,"65":"The king did him great honor and enrolled him among his first Friends, and appointed him general and governor."
,"66":"So Jonathan returned to Jerusalem happy and secure."
,"67":"In the year one hundred and sixty-five (147 B.C.), Demetrius the son of Demetrius, returned from Crete to the land of his fathers."
,"68":"When King Alexander heard of it, he was so greatly disturbed that he returned to Antioch."
,"69":"Demetrius took his general Apollonius, the governor of Coele-Syria, who assembled a large force. He encamped at Jamnia and sent the following message to Jonathan, the high priest:"
,"70":"'Are you the only one who resists our authority? And am I to be ridiculed because of you? Why do you stand against our authority in your mountains?"
,"71":"If you have confidence in your forces, come down to the plain and let us measure each other's strength there, for I have with me the army of the cities."
,"72":"Inquire and find out who I am and who are those who support me. Men will tell you that you cannot resist us, for your fathers were twice defeated on their own land."
,"73":"Nor will you be able to withstand the cavalry and so great an army on the plain, where there are no stones or rocks offering a refuge.'"
,"74":"When Jonathan heard Apollonius' message, he was greatly aroused. So he left Jerusalem with ten thousand picked men, and his brother Simon came to his help."
,"75":"They encamped near Joppa, but the inhabitants of the city closed the gates to them, as Apollonius had a garrison there."
,"76":"So Jonathan gave the order to attack. The people in the city were so afraid that they opened the gates to him, and Jonathan occupied Joppa."
,"77":"When Apollonius learned of it, he mobilized three thousand cavalry and a large army. Then he set out towards Azotus, pretending to march through the land, but in fact his troops were spreading out in the direction of the plain, since he had a great number of cavalry on which he relied."
,"78":"Jonathan pursued him towards Azotus and they began to fight."
,"79":"Apollonius had left a thousand picked horsemen hidden behind Jonathan,"
,"80":"but Jonathan was informed of the ambush. The horsemen surrounded Jonathan's men and shot their arrows from morning till evening. "
,"81":"But the Israelites faced them as Jonathan had commanded until the horses of the enemy tired. Once the cavalry were exhausted,"
,"82":"Simon and his men advanced and attacked the infantry. The enemy was defeated and fled."
,"83":"The cavalry scattered over the plain and those who fled went to Azotus, where they entered the temple of Dagon, their idol, to save their lives."
,"84":"But Jonathan set fire to Azotus and the surrounding towns, and plundered them. He also burned down the temple of Dagon with all who had taken refuge in it."
,"85":"There were about eight thousand men who either fell by the sword or were burned to death."
,"86":"Jonathan then left for Askalon where the inhabitants received him with great honor."
,"87":"From there, Jonathan and his men returned to Jerusalem laden with booty."
,"88":"When King Alexander heard what had happened, he bestowed new honors on Jonathan."
,"89":"He sent him a golden brooch which is usually given to the kinsmen of kings. He also gave him Ekron and all its territory as his possession."
}`)
	CurrentBook.AddChapter(11, `{
"1":"But the king of Egypt assembled an army as numerous as the sands of the seashore, with many ships, for he intended to trick Alexander, take his kingdom and add it to his own."
,"2":"He went to Syria with words of peace, and the inhabitants of the cities opened their gates to him. They came out to meet him, as Alexander had ordered,"
,"3":"because Ptolemy was his father-in-law. But as soon as Ptolemy entered the cities, he stationed garrisons in them."
,"4":"When he reached Azotus, he was shown the burnt temple of Dagon, Azotus and its surroundings in ruins, the scattered corpses that had been abandoned, and the charred remains of those whom Jonathan burned to death in the battle, piled in heaps along the king's way."
,"5":"They recounted to King Ptolemy everything Jonathan had done. They were hoping that the king would disapprove, but he said nothing."
,"6":"Jonathan went with great pomp to Joppa to meet the king. They greeted each other and spent the night there."
,"7":"On the following day, Jonathan accompanied the king as far as the Eleutherus river, and then returned to Jerusalem."
,"8":"King Ptolemy for his part seized the coastal cities as far as Deleucia by the sea, for he had made plans against King Alexander."
,"9":"He sent this message to Demetrius: 'Come and let us forge an alliance. I will give you my daughter who was married to Alexander, and you will reign on the throne of your fathers."
,"10":"The fact is I now regret having given him my daughter, for he has tried to kill me.'"
,"11":"He accused Alexander because he wanted to take his kingdom."
,"12":"Ptolemy took his daughter away and gave her to Demetrius. In this way, his enmity towards Alexander became public."
,"13":"Ptolemy then entered Antioch and took for himself the crown of Asia. So he held two kingdoms: the kingdom of Egypt and the kingdom of Asia."
,"14":"At that time, Alexander was in Cilicia trying to quell a rebellion."
,"15":"When he heard what had happened, he returned to fight Ptolemy. Ptolemy went out to meet him in battle with a strong army, and Alexander was defeated."
,"16":"As he fled to Arabia and sought refuge there,"
,"17":"Zabdiel the Arab cut his head off and sent it to Ptolemy."
,"18":"But after three days, Ptolemy died, and immediately the Egyptian soldiers who guarded the fortified cities were killed by the local inhabitants."
,"19":"In this way, Demetrius became king in the year one hundred and sixty-seven (167 B.C.)."
,"20":"In those days, Jonathan assembled the Jewish army to attack the Citadel in Jerusalem which was occupied by the Syrians, and he prepared many siege engines."
,"21":"But some wicked men who were traitors to their country, informed the king."
,"22":"When the king heard of it, he became angry and immediately set out for Ptolemias. From there he wrote to Jonathan telling him to stop the siege and to come to see him as soon as possible."
,"23":"Jonathan received the message, but he ordered the siege to continue. Then he decided to risk himself, and went to see the king with the elders and priests of Israel."
,"24":"Bringing gold, silver, fine garments and other presents, they went before the king in Ptolemias and won him over."
,"25":"Some traitors accused them."
,"26":"But the king in the presence of all his Friends treated Jonathan as kings before had treated him."
,"27":"He confirmed Jonathan's office as high priest with all the privileges he already had. And he numbered him among his first Friends."
,"28":"Jonathan asked the king to exempt Judea and the three districts of Samaria from taxes, and promised him three hundred talents in return."
,"29":"The king agreed and wrote to Jonathan regarding the matter in these terms:"
,"30":"'King Demetrius to Jonathan, to his brothers and to the whole Jewish nation, peace."
,"31":"We are sending you a copy of the letter we have written to our kinsman Lasthenes that you may know:"
,"32":"King Demetrius greets his kinsman Lasthenes."
,"33":"Because of their fidelity to us, we have decided to grant favors to the Jewish nation, who are our friends and who fulfill their obligations to us. We wish to reward their fidelity."
,"34":"We confirm the possession of the territory of Judea and the three regions of Aphairema, Kydda and Ramathaim which have been annexed to Judea from Samaria, with all their dependencies. And to all who go up to Jerusalem to offer sacrifice, we grant exemption from the tax the king formerly received from them annually until now, from the produce of the soil and from the fruit of the trees."
,"35":"In the same way, they shall also be exempt from the other taxes due to us, especially from the taxes on the produce of the salt mines, and the gold crowns they formerly offered us."
,"36":"None of these privileges shall ever be annulled."
,"37":"Have a copy of this decree made and delivered to Jonathan to be displayed on the Holy Mountain in a conspicuous place.'"
,"38":"King Demetrius was able to place the kingdom under his rule and no one dared oppose him, so he dismissed his army, sent all the men back to their homes, except the foreign troops he had recruited from the islands of the pagans. And this drew the hatred of all the troops who had served his fathers."
,"39":"Then Trypho, one of Alexander's former supporters, took advantage of the army's discontent with Demetrius. He went to Iamleku the Arab who was in charge of the education of Antiochus, the son of Alexander."
,"40":"Trypho persuaded him to hand the boy over to him in order to restore Antiochus to the throne of his father. He told him of all the decisions of Demetrius and the resentment of his soldiers towards him. And Trypho spent a long time there."
,"41":"Meanwhile, Jonathan asked King Demetrius to withdraw the troops from the Citadel in Jerusalem and to call back the garrisons from the fortresses, since they were always fighting Israel."
,"42":"Demetrius answered him, 'Not only will I do this for you and for your people, but as soon as I have the occasion to do so."
,"43":"For the present, you would do well to send me reinforcements, for all my soldiers have deserted me.'"
,"44":"Jonathan sent off three thousand valiant men to Antioch; they presented themselves before the king, and this made him very happy."
,"45":"About a hundred and twenty thousand rebel inhabitants gathered at the center of the city intending to do away with the king."
,"46":"Demetrius took refuge in the palace while the residents occupied the streets of the city and began to attack."
,"47":"The king then called on the Jews to help him, and the Jews rallied round him. Then they spread out through the city and killed a hundred thousand men on that day."
,"48":"They burned the city, seized a great deal of plunder, and saved the king."
,"49":"The Jews took control of the city. And the inhabitants were so discouraged that they begged the king,"
,"50":"'Forgive us and stop the Jews from maltreating us and the city.'"
,"51":"They threw down their arms and made peace. With this, the Jews merited the admiration of the king and they became famous throughout the kingdom. Then they returned to Jerusalem laden with booty."
,"52":"But when Demetrius felt secure on his throne and the land was in peace,"
,"53":"he forgot his promises and changed his attitude towards Jonathan. He did not treat him with the same kindness as he had done before, but began to treat him very harshly."
,"54":"After this Trypho came back with Antiochus who was still a boy. He was proclaimed and crowned king,"
,"55":"and the troops discharged by Demetrius rallied to him and fought against Demetrius who had to flee."
,"56":"Trypho seized the elephants and occupied Antioch."
,"57":"Then the young Antiochus sent Jonathan this letter: 'I confirm your office as High Priest and make you governor of four districts, and I include you among the Friends of the King.'"
,"58":"He sent him a service of gold plate, and granted him the right to drink from gold vessels and to be clothed in purple and wear the golden brooch."
,"59":"He also appointed Jonathan's brother Simon as general from the Ladder of Tyre to the frontiers of Egypt."
,"60":"Jonathan then began to make rounds of the region and the cities on the western side of the Euphrates. The whole Syrian army came to his aid. He came to Askalon and the inhabitants of that city went out to receive him with full honors."
,"61":"From there he went to Gaza, but the people there closed their gates on him. So Jonathan laid siege to it and burned the suburbs of the city, plundering everything."
,"62":"Then the people of Gaza sought peace, and he made peace with them. But he took the sons of their elders as hostages and sent them away to Jerusalem. Then he traveled through the province until he reached Damascus."
,"63":"Jonathan then received news that the generals of Demetrius were in Kadesh of Galilee with a great army and planned to capture him."
,"64":"Leaving his brother Simon in Judea, he went out to meet them in battle."
,"65":"Simon encamped against Beth-zur and laid siege to it for many days."
,"66":"The inhabitants sued for peace, which he granted them. But he expelled them from the city and occupied it, and stationed a garrison there."
,"67":"Meanwhile, Jonathan encamped with his army by the waters of Gennesaret; then early in the morning, they went to the plain of Hazor."
,"68":"The army of the pagans went out to confront them on the plain, after laying an ambush for him in the mountains."
,"69":"As they advanced directly towards the Jews, the men in ambush broke cover and began to attack."
,"70":"The men of Jonathan's side fled. And only Mattathias, the son of Absalom, and Judas, the son of Chalphi, the leaders of his army remained with him."
,"71":"At this, Jonathan tore his garments, put dust on his head, and prayed."
,"72":"Then he faced his attackers, defeated them and put them to flight."
,"73":"So the troops who had abandoned him came back to his side, and together they pursued the enemies as far as Kadesh where the enemy camp was, and there they, too, pitched camp."
,"74":"About three thousand pagans perished that day. Then Jonathan returned to Jerusalem."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Jonathan saw that circumstances were to his advantage. So he chose men and sent them to Rome to confirm and renew the alliance of friendship with the Romans."
,"2":"He also sent letters to the Spartans and to other places for this same purpose."
,"3":"Those who went to Rome entered the Senate and delivered this message: 'The High Priest Jonathan and the Jewish nation have sent us to renew with you the friendship and alliance that formerly united us.'"
,"4":"The Senate gave them letters of recommendation to the authorities of each region, enabling them to journey safely back to the land of Judah."
,"5":"This is a copy of the letter Jonathan wrote to the Spartans:"
,"6":"'Jonathan, High Priest, the senate of the nation, the priests and the whole country of the Jews, to the people of Sparta, their brothers: peace."
,"7":"In the past, our high priest Onias received from Areios, your king, a letter stating that you are indeed our brothers, as the enclosed copy attests."
,"8":"Onias received the envoy with great honor and accepted the letter which clearly spoke of friendship and alliance."
,"9":"Though we are not in need, for we have our consolation in our Sacred Books,"
,"10":"we have decided to send ambassadors to you to renew our fraternal bonds and friendship in order not to become strangers to you, for it has been a long time since you wrote us."
,"11":"For our part, we constantly remember you in all circumstances, on special days, in the sacrifices we offer, as well as in our prayers; for it is but right and proper to remember our brothers"
,"12":"and greatly rejoice at your prosperity and fame."
,"13":"For our part, we have been involved in many trials, in misery and wars, for neighboring kings have attacked us."
,"14":"However, we did not want to be a burden to you or to the rest of our allies and friends during these wars,"
,"15":"for our help comes from Heaven. Finally we have been freed from our enemies who have been humbled."
,"16":"So we have chosen Numenius, son of Antiochus, and Antipater, son of Jason, and sent them to the Romans to renew our former friendship and alliance with them."
,"17":"We have also ordered them to go to you, greet you and deliver this letter to you on our behalf, with which we wish to renew our alliance."
,"18":"We shall be glad to receive a favorable response.'"
,"19":"This is a copy of the letter which Onias had received:"
,"20":"'Areios, king of the Spartans, to Onias the High Priest."
,"21":"We have found in one of our documents that the Spartans and the Jews are brothers, for both are of the race of Abraham."
,"22":"Now that we have come to know this, we shall be grateful if you send us news of your welfare."
,"23":"And we say this to you: our livestock and our possessions are yours, and similarly all that are yours are ours. This is what we have instructed our envoys to say to you.'"
,"24":"Jonathan learned that the generals of Demetrius had come to attack him with a larger army than before."
,"25":"So he left Jerusalem at once and went to face them in the country of Hamath, so as not to give them time to invade his own land."
,"26":"He sent spies to their camp, and on their return, they told him that the enemy planned to attack them during the night."
,"27":"So, at sunset, Jonathan ordered his men to keep watch throughout the night with their weapons at hand, ready to fight. And he posted guards around the camp."
,"28":"When the enemies learned that Jonathan was keeping watch with his troops and ready for battle, they were afraid and discouraged; for this reason, they kindled fires in their camp and fled."
,"29":"But neither Jonathan nor his army knew of their withdrawal until morning, for they saw the fires burning the whole night."
,"30":"Jonathan pursued them but was not able to catch up with them, for they had crossed the Eleutherus river."
,"31":"So Jonathan went back against the Arabs called Zabadeans, defeated them and plundered them."
,"32":"After breaking camp, he went to Damascus and traveled throughout the region. Meanwhile,"
,"33":"Simon had also set out and gone as far as Askalon and the neighboring fortresses. He then proceeded to Joppa and occupied it,"
,"34":"for he had heard that the inhabitants of that city planned to hand the Citadel over to the supporters of Demetrius. And he stationed a garrison there to hold it."
,"35":"On returning, Jonathan summoned the elders of the people. The assembly decided to build fortresses in Judea,"
,"36":"to make the walls of Jerusalem still higher, and to erect a barrier between the Citadel and the city, to separate it from the city and to isolate it and prevent its defenders from going out to buy or sell."
,"37":"They also held an assembly to rebuild the city. Part of the wall over a rushing stream had fallen and they built up a new wall they called Chapthenatha."
,"38":"Simon rebuilt Adida in the Shephelah, fortified it and erected barred gates in it."
,"39":"Trypho wanted to reign in Asia, and to do away with King Antiochus in order to be king himself."
,"40":"But he feared that Jonathan might not allow him to do so, and might even come to attack him. He set out and came to Bethshan."
,"41":"At once Jonathan went out to meet him with forty thousand men, and he, too, came to Bethshan."
,"42":"When Trypho saw that Jonathan had come with a large army, he was afraid to begin the assault."
,"43":"So he received Jonathan with honor, presented him to all his Friends, gave him gifts, and instructed his Friends and his troops to obey Jonathan as they obeyed him."
,"44":"Then he asked Jonathan, 'Why have you bothered to come with so many men? Are we perhaps enemies?"
,"45":"Send them back to their homes and remain here with some of them. Then you will come with me to the city of Ptolemais because I wish to hand it over to you, as well as the other fortresses and to place the rest of the troops and their officers at your disposal. Then, I will return home, for I have come only for this.'"
,"46":"Jonathan believed him and did as Trypho had asked him. He dismissed his men who then returned to the land of Judea,"
,"47":"and three thousand men remained with him. Of these, he left two thousand in Galilee and only a thousand accompanied him."
,"48":"But as soon as they had entered Ptolemais, the inhabitants closed the gates. They seized him and killed all who had come with him."
,"49":"Trypho sent troops and cavalry to Galilee and to the Great Plain to wipe out all of Jonathan's men."
,"50":"On receiving the news that Jonathan and his companions had been seized and killed, his soldiers encouraged one another and prepared to face their pursuers."
,"51":"When their enemy saw them ready to fight for their lives, they turned back."
,"52":"So the men of Jonathan reached the land of Judea safe and sound. They wept for Jonathan and his companions and they were discouraged. And all Israel was in mourning."
,"53":"Then all the neighboring nations planned to destroy them on seeing that they were now without leader or ally. And the pagans said: 'This is now the opportunity to wipe out the remembrance of them from among men.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Simon heard that Trypho had assembled a great army to invade Judea and devastate it."
,"2":"As the people were frightened and apprehensive, he went up to Jerusalem."
,"3":"There he called the people together and encouraged them with this exhortation: 'All of you know what I, my brothers, and the family of my father have done for the laws and for the Holy Place. You also know the wars and the hardships we endured. "
,"4":"All my brothers died for Israel and now I alone am left."
,"5":"God forbid that I should seek my own safety when things go wrong! For my life is not of more worth than the lives of my brothers. Now that all the nations have united in their hatred in order to destroy us,"
,"6":"I will defend my nation and the Holy Place, your wives and your children.'"
,"7":"All were encouraged with these words"
,"8":"and they exclaimed in a loud voice: 'Be our leader in place of Judas and your brother Jonathan."
,"9":"Lead us in the war and we will obey your commands.'"
,"10":"So Simon assembled all the men able to fight and hastened to finish building the walls of Jerusalem, which was fortified on all sides."
,"11":"Then he sent Jonathan, son of Absalom, with a strong army to Joppa. They drove out those who occupied it and remained there."
,"12":"Meanwhile, Trypho left Ptolemais with a large army to invade Judea, taking Jonathan with him as prisoner."
,"13":"Simon encamped in Adida facing the plain."
,"14":"But when Trypho learned that Simon had taken command in place of his brother Jonathan and was prepared to fight him, he sent some envoys to him with this message:"
,"15":"'We have in our custody your brother Jonathan because of the money he owes to the royal treasury for the offices he held."
,"16":"So, send a hundred talents of silver and two of his sons as hostages lest he slip away when we release him, and come back against us. Then we shall let him go.'"
,"17":"Simon knew that Trypho was deceiving him, but he still sent for the money and the boys so as not to draw upon himself the anger of the people of Israel who might say:"
,"18":"'They killed Jonathan because Simon refused to send Trypho the money and the boys.'"
,"19":"He therefore sent the boys and the hundred talents, but Trypho broke his word and did not set Jonathan free."
,"20":"After this, Trypho advanced to invade Judea and plunder it. He moved along the way to Adora, but Simon and his army kept confronting him wherever he went."
,"21":"Then the men in the Citadel sent messengers to Trypho urging him to come at once to their rescue by way of the desert and to bring them food."
,"22":"Trypho prepared his entire cavalry to go, but it snowed so heavily that night that he was not able to go. So he left for Gilead,"
,"23":"and when he approached Baskama he killed Jonathan and buried him there."
,"24":"Then Trypho returned to his own land."
,"25":"Simon sent men to look for the remains of Jonathan, his brother, and he buried him in Modein, the city of their fathers."
,"26":"All Israel deeply mourned and wept for Jonathan for many days."
,"27":"Simon built a monument over the tomb of his fathers and brothers, high enough to be seen even from afar, with the back and front covered with marble."
,"28":"He erected seven pyramids facing each other, for his father and mother and his four brothers."
,"29":"He surrounded the pyramids with great columns, and he had trophies of arms carved upon the columns as a lasting remembrance; and beside the armor, sculptured ships were to be seen by all who sailed the sea."
,"30":"This is the tomb he constructed in Modein and it is still there today."
,"31":"Trypho treated the young King Antiochus in bad faith, and put him to death."
,"32":"He then made himself king in his place, put on the crown of Asia and caused great havoc in the country."
,"33":"Now Simon rebuilt the fortresses of Judea, surrounded them with high towers and great walls with barred gates, and stored food in them."
,"34":"Simon chose men whom he sent to King Demetrius in his attempt to obtain tax exemption for the region, on the grounds that all that Trypho did was to plunder."
,"35":"King Demetrius responded favorably to his request and wrote to him as follows,"
,"36":"'King Demetrius greets Simon, High Priest and Friend of the King, the elders and the Jewish nation."
,"37":"We have received the golden crowns and the palm you have sent us and we are disposed to make a lasting peace with you, and to write to the officials to grant you remission of your debts."
,"38":"All our concessions in your favor are definitive and the fortresses you have built are yours."
,"39":"Moreover, we pardon all errors and offenses committed to this day, as well as the crown tax you owe. From now on, any other tax that used to be paid in Jerusalem shall no longer be collected."
,"40":"If any of your men are qualified to enlist in our army, they can do so. And let peace reign between us.'"
,"41":"So, in the year one hundred and seventy (142 B.C.), Israel became free from the yoke of the pagans."
,"42":"They began to write in their documents and contracts, 'In the first year of Simon, high priest, general and leader of the Jews.'"
,"43":"In those days, Simon encamped against Gazard and surrounded it with his army. He constructed a mobile tower, brought it up to the city, attacked and occupied one tower."
,"44":"Then the men of the mobile tower entered the city, causing great dismay."
,"45":"The inhabitants with their wives and children went up on the walls, tore their garments, cried out in a loud voice to Simon and sought peace."
,"46":"They said to him, 'Treat us not as our wickedness deserves, but according to your mercy.'"
,"47":"Simon was reconciled with them and did not treat them according to the rigor of war. But he expelled them from the city and purified the houses where idols were kept. He then entered the city singing hymns of thanksgiving."
,"48":"After cleansing it from all its impurity, he settled in it men who observed the Law. He fortified it and built a house there for himself."
,"49":"The men who occupied the Citadel in Jerusalem could no longer come out or go into Jewish territory to buy or sell. So they were desperately in need of food, many of them dying of hunger."
,"50":"They begged Simon for peace, and he granted it to them. But he expelled them from there and cleansed the Citadel from all that reminded them of the presence of the pagans."
,"51":"On the twenty-third day of the second month of the year one hundred and seventy-one (141 B.C.), the Jews entered it with songs and palm branches to the accompaniment of zithers, cymbals and harps, and with hymns and songs, for a great plague had been crushed and removed from Israel."
,"52":"Simon decreed that this day be celebrated as a day of annual rejoicing. He strengthened the fortifications of the Temple hill by the side of the military Citadel, and dwelt there with his men."
,"53":"John, son of Simon, had come to manhood, so his father appointed him general in command of all the troops, and John lived in Gazara."
}`)
	CurrentBook.AddChapter(14, `{
"1":"In the year one hundred and seventytwo, King Demetrius assembled his army and marched into Media to look for help in order to fight Trypho."
,"2":"Arsaces, king of Persia and Media, heard that Demetrius had entered his territory, so he sent one of his generals to capture him alive."
,"3":"The general went and defeated the army of Demetrius, seized him and brought him to Arsaces, who put him in prison."
,"4":"Judea had peace as long as Simon lived. He worked for the well-being of his country; his rule pleased the people, and he enjoyed much renown as long as he lived."
,"5":"To add to his glory, he took Joppa and made it a harbor, opening a way to communicate with the islands of the sea."
,"6":"He extended the frontiers of his land and was lord of his nation."
,"7":"He brought back many captives, conquered Gazard, Beth-zur and the Citadel and cast out everything pagan that was in it. No one was able to resist him."
,"8":"The inhabitants tilled their fields in peace; the land gave its grain and the trees their fruit."
,"9":"The elders sat at ease in the squares and talked of their welfare, while the young men wore finery and armor."
,"10":"He supplied the cities with food and made them into strongholds, until his fame spread out to the ends of the earth."
,"11":"He established peace in the land and Israel knew great joy."
,"12":"Each one sat under the shade of his vine and his fig tree, with no one to disturb him."
,"13":"There was no one in the land to fight them, for the kings had been defeated."
,"14":"He raised up the humble among his people, he observed the Law and cleared out the renegades and the wicked."
,"15":"He restored the splendor of the Temple and increased the number of its sacred vessels."
,"16":"When the news of Jonathan's death reached Rome and Sparta, these people, too, were deeply grieved."
,"17":"But as soon as they heard that his brother Simon had succeeded him as High Priest and was in command of the country and the cities in it,"
,"18":"they wrote to him on bronze sheets to renew the alliance and friendship they had made with his brothers Judas and Jonathan."
,"19":"The letter was read in Jerusalem before the whole assembly."
,"20":"This is a copy of the letter sent by the Spartans, 'The leaders and the people of Sparta to Simon, High Priest, and to the elders, to the priests and to all the Jewish people, their brothers: greetings. "
,"21":"The envoys you sent to our people informed us of the successes and prosperity of your nation. We rejoiced at their coming."
,"22":"We have recorded their declaration in our public acts as follows: 'Numenius, son of Antiochus, and Antipater, son of Jason, ambassadors of the Jews - have come to renew their relationship with us."
,"23":"It has been a pleasure for the people to receive them with honor and deposit a copy of their statement in the public archives as a remembrance for the people of Sparta.' And they made a copy of all this for the High Priest Simon.'"
,"24":"After this, Simon sent Numenius to Rome with a large gold shield weighing a thousand minas to confirm their alliance with the Romans."
,"25":"When the people came to know these events, they said, 'What favor can we do for Simon and his sons?"
,"26":"It was he and his brothers and the family of their fathers who strengthened the resistance; they have fought the enemies of Israel and restored its freedom.'"
,"27":"So they engraved an inscription on bronze sheets and set it up on pillars on Mount Zion. This is a copy of the text: 'On the eighteenth day of the month Elul, in the year one hundred and seventy-two, the third year of Simon, the High Priest, "
,"28":"in the grand assembly of the priests of Israel, the leaders of the nation and the elders of the people, the following was proclaimed:"
,"29":"'During the frequent wars for freedom in our land, Simon, the son of Mattathias, a priest from the family of Joarib, and his brothers risked their lives and stood up against the enemies of their nation to preserve the Holy Place and the Law, and brought eternal glory to their nation."
,"30":"Jonathan rallied the nation, and became the High Priest, and then rested with his fathers."
,"31":"The enemies of the Jews then planned to invade their land in order to destroy their Holy Place."
,"32":"So Simon arose to fight for his nation. He spent much of his own wealth to procure arms and to pay the salary of the soldiers of his nation."
,"33":"He fortified the cities of Judah and Beth-zur on the frontiers of Judea, where the enemy arsenal had been and he stationed a Jewish garrison there."
,"34":"He also fortified Joppa by the sea, and Gazara on the borders of Azotus, which was formerly inhabited by enemies, and established Jewish colonies there, providing them with all they needed."
,"35":"The people saw Simon's faith and the glory he had resolved to win for his nation. They made him their commander and High Priest because of the services he rendered, the justice and faithfulness he showed to his nation, and because he sought in every way to increase the honor of his people."
,"36":"In his days, the Jews managed to root out the pagans from their land, especially from the city of David, Jerusalem, where they had built a Citadel from which they went out to profane the surroundings of the temple and to violate its holiness."
,"37":"He settled Jewish soldiers in it and fortified it for the security of the region and the city, and built the walls of Jerusalem higher."
,"38":"And for this, King Demetrius confirmed him in his office as High Priest,"
,"39":"made him one of his Friends and bestowed high honors on him,"
,"40":"for he had heard that the Romans had considered the Jews their friends, allies and brothers, and had received Simon's envoy with honor."
,"41":"The king also took into account that the Jews and the priests had agreed that Simon be their leader and High Priest until a prophet worthy of trust appeared."
,"42":"They wanted him to be their general and take charge of the Holy Place, and to appoint men to supervise the works, to administer the country, the army and the fortresses."
,"43":"They also wanted everyone to obey him, that all documents of the nation bear his name and that he be clothed in purple and wear golden ornaments."
,"44":"None of the people or the priests shall be allowed to act contrary to these provisions or contradict his orders, or convene a public assembly without his consent, or be clothed in purple, or wear the golden brooch."
,"45":"Whoever opposes these decisions or violates any of these shall be liable to punishment."
,"46":"All the people agreed to grant Simon the right to act in accordance with these provisions."
,"47":"And Simon accepted and agreed to assume the office of High Priest and to be the general and leader of the Jews and of the priests, and to preside over all."
,"48":"They decided that this decree be engraved on bronze sheets and set up in a conspicuous place in the sacred enclosure,"
,"49":"and that copies be deposited in the Temple treasury and made available to Simon and his sons.'"
}`)
	CurrentBook.AddChapter(15, `{
"1":"Antiochus, son of King Demetrius, sent from the islands of the sea to Simon, the High Priest and leader of the Jews, and to the whole nation,"
,"2":"the following letter: 'King Antiochus to Simon, high priest and leader, and to the Jewish nation: peace!"
,"3":"Since wicked men have seized the kingdom of our fathers, I now intend to recover it and to reestablish it as it was before. I have gathered a very large army and have equipped warships"
,"4":"to make a landing in the country and take revenge on those who devastated our land and laid waste many cities in my kingdom. Now, therefore,"
,"5":"I confirm in your regard all the tax exemptions and all other privileges granted you by my royal predecessors."
,"6":"I authorize you to mint your own coinage for your nation."
,"7":"I accept the autonomy of Jerusalem and the Holy Place; all the arms you have manufactured as well as the fortresses you have constructed and those you have occupied are yours."
,"8":"From this day on, I cancel all debts to the king and everything you may owe in the future."
,"9":"And when I have taken possession of my kingdom, I shall bestow great honors on you, your nation and on the Temple, making you famous throughout all the earth.'"
,"10":"In the year one hundred and seventy-four, Antiochus marched out to the land of his fathers, and all the troops rallied to him, so that only a few remained with Trypho."
,"11":"Antiochus pursued him and Trypho took refuge in Dor on the coast."
,"12":"Trypho knew how critical the situation had become for him and that his army had deserted him."
,"13":"Antiochus encamped before Dor with a hundred and twenty thousand soldiers and eight thousand horsemen."
,"14":"And he surrounded the city while the ships attacked from the sea: the city was completely surrounded by land and sea, and no one could go in or come out."
,"15":"Then Numenius and his companions arrived from Rome, carrying letters addressed to the kings and to the nations in the following terms:"
,"16":"'Lucius, consul of the Romans, to King Ptolemy: peace!"
,"17":"The Jewish people sent by the High Priest Simon and by the Jewish people have come to us as our friends and allies to renew our friendship and alliance of old."
,"18":"They have brought us a gold shield weighing a thousand minas."
,"19":"It is our desire to write to the kings and the peoples that they should not harm the Israelites nor injure them or their cities or their land, nor ally themselves with their aggressors."
,"20":"We have accepted with pleasure the shield that the Jews sent us."
,"21":"Now, if some wicked Jews who have fled from their land are in your country, hand them over to the High Priest Simon that he may punish them according to their Law.'"
,"22":"The same letter was sent to King Demetrius, to Attalus, Ariarathes and Arsaces,"
,"23":"and to all the nations, to Sampsames, the Spartans, Delos, Myndos, Sicyon, Caria, Samos, Pamphylia, Lycia, Halicarnassus, Rhodes, Phaselis, Cos, Side, Aradus, Gortyna, Cnidus, Cyprus and Cyrene."
,"24":"They also sent copies of these letters to the High Priest Simon."
,"25":"King Antiochus encamped before Dor, in the new district, continually sending his battalions against it and constructing siege engines. He kept Trypho shut in and prevented him from going out or in."
,"26":"Simon sent him two thousand picked men to help him in the fight, with silver, gold and plenty of equipment."
,"27":"But Antiochus did not accept them; instead, he annulled the concessions he had granted to Simon and declared him his enemy."
,"28":"He sent Athenobius, one of his Friends, to him in order to meet him and say to him: 'You have occupied Joppa, Gazara and the Citadel of Judea which are cities of my kingdom."
,"29":"You have laid waste their territory and done great damage in the land, and have seized many towns in my kingdom."
,"30":"Restore, then, the cities you have seized and the taxes of the places you now occupy beyond the borders of Judea."
,"31":"Or pay me five hundred talents of silver as compensation for the damage you have caused and another five hundred talents for the taxes of the cities. If not, then I shall declare war against you.'"
,"32":"Athenobius, the Friend of the king, arrived in Jerusalem and when he saw the magnificence of Simon, his plates of gold and silver and the pomp that surrounded him, he was amazed. But he delivered the king's message."
,"33":"Simon answered him, 'We have not occupied any foreign land nor seized any foreign property: this is the inheritance of our fathers. It was our enemies who seized this for some time,"
,"34":"but now that we have a favorable opportunity, we are only recovering the inheritance of our fathers."
,"35":"Joppa and Gazara, which you claim, did great harm to our people and laid waste our land; but we are prepared to give you a hundred talents for them.',Athenobius did not say anything, "
,"36":"but went back to the king very angry and reported to him Simon's reply. He also told him of Simon's magnificence and everything he had seen. So the king became furious."
,"37":"Meanwhile, Trypho fled to Orthosia on a ship."
,"38":"The king appointed Cendebeus as general and gave him part of the troops and the horsemen."
,"39":"He ordered him to encamp against Judea, rebuild Kedron and fortify its gates and make war on the people. The king then went on pursuing Trypho."
,"40":"Cendebeus arrived at Jamnia and began to disturb the people. He invaded Judea, imprisoned some people and put them to death."
,"41":"He fortified Kedron, stationed horsemen and troops there to make sorties and to patrol the roads to Judea, as the king had commanded him."
}`)
	CurrentBook.AddChapter(16, `{
"1":"At that time, John went up from Gazara to relate to his father what Cendebeus was doing."
,"2":"So, Simon called his two elder sons, John and Judas, and said to them: 'I and my brothers and the family of my father have fought the enemies of Israel from our youth until today. And many times, we were able to liberate Israel."
,"3":"But now I am old, while you - thanks be to Heaven - are already mature men. Take my place and my brother's, and go out to fight for our country. May Heaven's help be with you!'"
,"4":"Then he chose a thousand men and horsemen from the country whom he sent against Cendebeus. And they spent the night in Modein."
,"5":"They arose early in the morning and advanced into the plain and saw what a large army, both infantry and cavalry, was coming to meet them. A stream lay between them, "
,"6":"and John with his troops drew up against the enemies. His troops were afraid to cross the stream, so he crossed over first. On seeing this, his men crossed after him."
,"7":"He divided his army into two groups and set the horsemen in the center for the enemy's cavalry was very numerous."
,"8":"They sounded the trumpets, and Cendebeus and his army were defeated. Many of them fell, and those who remained fled to the fortress."
,"9":"Judas, the brother of John, fell wounded, but John pursued the enemies until Cendebeus reached Kedron which he had fortified."
,"10":"The enemy fled as far as the towers in the fields of Azotus, but John burned these down. About two thousand of the enemy perished. And after this, John returned safely to Judea."
,"11":"Ptolemy, son of Abubos, had become general in command of the plain of Jericho. He had much silver and gold,"
,"12":"besides being the High Priest's son-in-law."
,"13":"He became too ambitious and thought of becoming the leader of his nation. So he looked for ways to do away with Simon and his sons."
,"14":"Simon was then making the rounds of the cities of Judea and attending to their administration. In the eleventh month called Shebat, in the year one hundred and seventy-seven (134 B.C.), Simon came to Jericho with his two sons, Mattathias and Judas."
,"15":"The son of Abubos received them treacherously into the small fortress called Dock which he had built. He gave them a grand banquet, but had set men in hiding."
,"16":"When Simon and his sons were drunk, Ptolemy and his men reached for their weapons and rushed on Simon in the midst of the banquet. They killed him with his two sons and some of his servants."
,"17":"With this, Ptolemy committed a great act of treachery, repaying evil for good."
,"18":"Ptolemy then made haste to send a letter to the king to inform him of what had happened, asking Antiochus to help him in handing over to him the cities and the country."
,"19":"He also sent other men to Gazara in order to kill John, and asked the commanders of the Jewish troops in a letter to defect to him, promising them silver, gold and gifts."
,"20":"He then sent others to seize Jerusalem and the Temple hill."
,"21":"But a man ran and reached Gazara before them, informing John that his father and brothers had been killed. And he added, 'He has also sent some people to kill you.'"
,"22":"John was shocked by the news. So he arrested the men who had been sent to kill him and put them to death, for he knew that they had come with this purpose."
,"23":"The rest of the deeds of John, his battles, his exploits, the walls he built and all his other achievements"
,"24":"are written in the annals of his pontificate from the day he succeeded his father as High Priest."
}`)

}
func EN_CCB_LoadVH1PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Adam, Seth, Enosh,"
,"2":"Kenan, Mahalel, Jared,"
,"3":"Enoch, Methuselah, Lamech,"
,"4":"Noah, Shem, Ham and Japheth."
,"5":"Sons of Japheth: Gomer, Magog, the Medes, Javan, Tubal, Meshech, Tiras."
,"6":"Sons of Gomer: Ashkenaz, Diphath, Togarmah."
,"7":"Sons of Javan: Elisha, Tarshish, the Kittim, the Daanites."
,"8":"Sons of Ham: Cush, Misraim, Put, Canaan."
,"9":"Sons of Cush: Seba, Havilah, Sabta, Raama, Sabteca, Sons of Raamah: Sheba, Dedan."
,"10":"Cush became father of Nimrod, the first potentate on earth."
,"11":"Misraim became of the people of Lud, of Anam, of Lehab, of Naptu,"
,"12":"of Pathros, Casluh and Caphtor, from which the Philistines came."
,"13":"Canaan became father of Sidon, his firstborn, then Heth,"
,"14":"and the Jebusites, the Amorites, Girgashites,"
,"15":"Hivites, Sinites,"
,"16":"Arvadites, Zemarites, Hamathites."
,"17":"Sons of Shem, Elam, Asshur, Arpachshad, Lud, Aram. Sons of Aram: Uz, Hul, Gether and Meshech."
,"18":"Arpachshad became father of Shelah, and Shelah became father of Eber."
,"19":"To Eber were born two sons; the first was called Peleg, because it was in his time the earth was divided, and his brother was called Joktan."
,"20":"Joktan became father of Almodad, Sheleph, Hazarmaveth, Jerah,"
,"21":"Hadoram, Uzal, Diklah,"
,"22":"Ebal, Abimael, Sheba,"
,"23":"Ophir, Havilah, Jobab; all these are sons of Joktan."
,"24":"Shem, Arpachshad, Shelah,"
,"25":"Eber, Peleg, Reu,"
,"26":"Serug, Nahor, Terah,"
,"27":"Abram, that is Abraham."
,"28":"Sons of Abraham: Isaac and Ishmael."
,"29":"Sons of Ishmael: Nebaioth (his first born) then Kedar, Adbeel, Mibsam,"
,"30":"Mishma, Dumah, Massa, Hadad, Tema,"
,"31":"Jetur, Naphish and Kedemah."
,"32":"Sons of Keturah, Abraham's concubine: Zimran, Jokshan,"
,"33":"Medan, Midian, Ishbak, and Shuah. Sons of Joksham: Sheba and Dedan. Sons of Midian were Ephah, Epher, Hanoch, Abida, Eldaah."
,"34":"Abraham was the father of Isaac who had two sons: Esau and Israel."
,"35":"The descendants of Esau were Eliphaz, Reuel, Jeush, Jalam and Korah."
,"36":"The descendants of Eliphaz were Teman, Omar, Zephi, Gatam, Kenaz, Timna and Amalek."
,"37":"The descendants of Reuel were Zerah, Shammah, and Mizzah."
,"38":"The sons of Seir were: Lotan, Shobal, Zibeon, Anah, Dishon, Ezer, and Dishan."
,"39":"The clans descended from Lotan were Hori and Homam. Lotan's sister was named Timna."
,"40":"The clans descended from Shobal were Alian, Manahath, Ebal, Shephi, and Onam. The descendants of Zibeon were Aiah and Anah."
,"41":"Anah had a son named Dishon, who was the ancestor of the clans of Hamran, Eshban, Ithran, and Cheran."
,"42":"Ezer was the ancestor of the clans of Bilhan, Zaavan, and Jaakan."
,"43":"Here are the kings who ruled in the land of Edom before an Israelite king ruled: Bela son of Bero; his city was called Dinhabah."
,"44":"When Bela died, Jobab son of Zerah from Bozrah became king."
,"45":"When Jobab died, Husham of the land of the Temanites became king."
,"46":"When Husham died, Hadad son of Bedad became king; he defeated the Midianites in the country of Moab, and his city was called Avith."
,"47":"When Hadad died, Samlah of Masrekah became king."
,"48":"Samlah died and Saul of Rehoboth-han-nahar became king."
,"49":"When Saul died, Baal-hanan son of Achbor became king."
,"50":"When Baal-hanan died, Hadad became king. His city was called Pai; his wife's name was Mehetabel daughter of Matred, from Mezahab."
,"51":"After Hadad died, these were the chiefs of Edom: Chief of Timna, Chief of Aliah, Chief Jetheth,"
,"52":"Chief Oholibamah, Chief of Elah, Chief Pinon,"
,"53":"Chief Kenaz, Chief Teman, Chief Mibzar, Chief Magdiel, and Chief Iram."
}`)
	CurrentBook.AddChapter(2, `{
"1":"These are the sons of Israel: Reuben, Simeon, Levi and Judah; Issachar and Zebulun;"
,"2":"Dan, Joseph and Benjamin, Nephtali; Gad and Asher."
,"3":"Judah had five sons in all. The first three were born to him by Bath-shua the Canaanite woman. They were Er, Onan and Shelah. Er, Judah's firstborn, was so evil that Yahweh put him to death."
,"4":"By his daughter-in-law Tamar, Judah had two more sons, Perez and Zerah."
,"5":"Perez had two sons, Hezron and Hamul."
,"6":"His brother Zerah had five sons: Zimri, Hetan, Heman, Calcol and Dara."
,"7":"One of them, Achar, son of Carmi - brought trouble upon the people of Israel by keeping loot that had been devoted to God."
,"8":"Ethan had one son, Azariah."
,"9":"Hezron became the father of Jerahmeel, Ram, and Caleb."
,"10":"Ram was the father of Amminadab; Amminadab of Nahshan."
,"11":"Nahshan, who was a prince of the tribe of Judah, was the father of Salmon; Salmon of Boaz;"
,"12":"Boaz of Obed; Obed of Jesse."
,"13":"Jesse had seven sons: Eliab, the firstborn, Abinadab, Shammah,"
,"14":"Nethanel, Raddai,"
,"15":"Ozem and David, the youngest. Jesse had two daughters: Zerwiah and Abigail."
,"16":"Zerwiah had three sons: Abishai, Joab and Asahel."
,"17":"Abigail married Jether the Ishmaelite. They had a son named Amasa."
,"18":"Caleb, son of Hezron, married Azubah and had a daughter named Jerioth. Jerioth had three sons: Jesher, Shobab and Ardon."
,"19":"Azubah died, and Caleb married Ephrath, and they had a son named Hur."
,"20":"Hur became father of Uri and grandfather of Bezalel."
,"21":"When Hezron was sixty years old he married Machir's daughter, the sister of Gilead. They had a son named Segub, who had a son named Jair."
,"22":"Jair ruled twenty-three towns in the land of Gilead."
,"23":"But the kingdoms of Geshur and Aram took from them the villages of Jair, that is Kenath and its towns, sixty towns in all. All this had belonged to the descendants of Machir, father of Gilead."
,"24":"After Hezron's death, his son Caleb married Ephrathah, his father's widow. They had a son named Ashur, the father of Tekoa."
,"25":"Jerahmeel, Hezron's eldest son, had five sons: Ram, his firstborn, Bunah, Oren, Ozem and Ahijah."
,"26":"Jerahmeel had another wife called Atarah; she was the mother of Onam."
,"27":"Ram had three sons: Maaz, Jamin and Eker."
,"28":"Onam was the father of Shammai and Jada; Shammai, of Nadab and Abishur."
,"29":"Abishur's wife was called Abihail; she bore him Ahban and Molid."
,"30":"Nadab had two sons, Seled and Appaim, but Seled died leaving no son."
,"31":"Appaim was the father of Ishi, who was the father of Sheshan; Sheshan was the father of Ahlai."
,"32":"Jada, Shammai's brother, had two sons: Jether and Jonathan. Jether died leaving no sons."
,"33":"Jonathan had two sons: Peleth and Zaza. These were all descendants of Jerahmeel."
,"34":"Sheshan had no sons, only daughters."
,"35":"He had an Egyptian slave named Jarha to whom he gave his daughter in marriage."
,"36":"They had a son named Attai. The ancestral line from Attai to Elishama is as follows: Attai, Nathan,"
,"37":"Zabad, Ephlal, Obed,"
,"38":"Jehu, Azariah,"
,"39":"Helez, Eleasah,"
,"40":"Sismai, Shallum,"
,"41":"Jekamiah, and Elishama."
,"42":"The firstborn son of Caleb, Jerahmeel's brother, was named Mesha. Mesha was the father of Ziph, who was the father of Meresha."
,"43":"Meresha was father of Hebron who had four sons: Korah, Tappuah, Rekem and Shema."
,"44":"Shema became father of Raham and grandfather of Jorkeam. Rekem became father of Shammai"
,"45":"and grandfather of Maon. Maon became father of Bethzur."
,"46":"Caleb had a concubine named Ephah who gave birth to Haran, Moza and Gazez. Haran also had a son named Gazez."
,"47":"Jahdai had six sons: Regem, Jotham, Geshan, Pelet, Ephah and Shaaph."
,"48":"Caleb had another concubine, Maacah, who gave birth to Sheber and Tirhanah."
,"49":"Later she had two more sons: Shaaph, who founded the town of Madmannah, and Sheva, who founded the towns of Machbenah and Gibea. The daughter of Caleb was Achsah."
,"50":"The following were also descendants of Caleb. Hur was the firstborn son of Ephrath. Hur's son Shobal was father of Kiriath-jearim;"
,"51":"Salma, father of Bethlehem, and Haroeh, father of Beth-gader."
,"52":"Shobal, the father of Kiriath-jearim was the father of the people of Haroah, that is half of the Manahathites,"
,"53":"and also the clans living in Kiriath-jearim: the Ithrites, Puthites, Shumathites and Mishraites. The people of the cities of Zorah and Eshtaol belonged to these clans."
,"54":"Sons of Salma: Bethlehem, Netophath, Atroth Beth-Joab, and the Zorites, who were one of the clans in Manaheth. The Soferites lived in the town of Jabez: the Tirathites, Shimeathites, and Sucathites. They were Cainites, descendants of Jamat, the Rechabites' ancestor."
}`)
	CurrentBook.AddChapter(3, `{
"1":"These are the sons of David who were born to him while he was in Hebron: the firstborn Amnon, whose mother was Ahinoam from Jezreel; second, Daniel, whose mother was Abigail from Carmel;"
,"2":"third, Absalom, whose mother was Maacah, daughter of King Talmai of Geshur; fourth, Adonijah, whose mother was Haggith;"
,"3":"fifth, Shephatiah, whose mother was Abital; sixth, Ithream, whose mother was Eglah."
,"4":"All six were born to him in Hebron, where he ruled for seven years and six months. He ruled as king for thirty-three years in Jerusalem. "
,"5":"Many sons were born to him in Jerusalem. By his wife Bathsheba, daughter of Ammiel, he had four sons: Shimea, Shobab, Nathan and Solomon. Nine other sons were:"
,"6":"Ibhar, Elishama, Eliphelet,"
,"7":"Nogah, Nepheg, Japhia,"
,"8":"Elishama, Eliada, and Eliphelet."
,"9":"All these were sons of David, besides other sons by the concubines. Tamar was their sister."
,"10":"These are the descendants of King Solomon from father to son: Rehoboam, Abijah, Asa, Jehoshaphat,"
,"11":"Joram, Ahaziah, Joash,"
,"12":"Amaziah, Azariah, Jotham,"
,"13":"Ahaz, Hezekiah, Manasseh,"
,"14":"Amon, and Josiah."
,"15":"Josiah had four sons: Johanan, the firstborn, Jehoiakim second, Zedekiah third, and Shallum fourth."
,"16":"The sons of Jehoiakim were: Jeconiah and Zedekiah."
,"17":"These are the descendants of King Jeconiah, who was taken captive by the Babylonians. Jeconiah had seven sons: Shealtiel,"
,"18":"Malchiram, Pedaiah, Shenazzar, Jekamiah, Hoshama, and Nedabiah."
,"19":"Pedaiah had two sons: Zerubbabel and Shimei. Zerubbabel had two sons, Meshullam and Hananiah, and one daughter, Shelomith."
,"20":"Meshullam had five sons: Hashubah, Ohel, Berechiah, Hasadiah, and Jushab-hesed."
,"21":"Hananiah's two sons were Pelatish and Jeshiah. Jeshiah was the father of Rephaiah, who was the father of Arnan, who was the father of Obadiah and grandfather of Shecaniah."
,"22":"Shecaniah's son was Shemaiah and his five grandsons were: Hattush, Igal, Bariah, Nedariah, and Shaphat."
,"23":"Neariah's three sons were: Elioenai, Hizkiah and Azrikam."
,"24":"Elioenai's seven sons were: Hodaviah, Eliashib, Pelaiah, Akkub, Johanan, Delaiah, and Anani."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Some of the descendants of Judah are: Perez, Hezron, Carmi, Hur, and Shobal."
,"2":"Shobal was the father of Reaiah, who was the father of Jahath, the father of Ahumai and Lahad: these people lived in Zorah."
,"3":"These were the descendants of Hareph, the father of Elam: Jezreel, Ishma, and Idbash, whose sister was called Hazzelelponi."
,"4":"Penuel became father of Gedor, and Ezer the father of Hushah. These are the descendants of Hur, the firstborn of Ephrathah, father of Bethlehem."
,"5":"Ashhur, father of Tekoa, had two wives: Helah and Naarah."
,"6":"Naarah bore him four sons: Ahuzaam, Hepher, the Temeni and the Haahashtari."
,"7":"Ashur had three sons by Helah: Zereth, Zohar, Ethnan."
,"8":"Koz became father of Anub and Zobebah, and the clans of Aharhel son of Harum."
,"9":"Jabez was the known of them. His mother had given him the name Jabez, to recall that 'In pain she had given birth to him.'"
,"10":"Jabez called on the God of Israel, 'If you truly bless me, you will give me much land. Be with me, and keep me from anything that might harm or cause me pain.' God gave him what he had prayed for."
,"11":"Chelub, the brother of Shuhah, became the father of Mehir, who was the father of Eshton."
,"12":"Eshton, had three sons, Bethrapha, Paseah and Tehinnah. Tehinnah was the father of Imahas. The descendants of these men lived in Recah."
,"13":"Kenaz had two sons, Othniel and Seraiah. Othniel also had two sons: Hathath and Meonothai,"
,"14":"who became the father of Ophrah. Seraiah became the father of Joab, the founder of Craftsmen's Valley, where skilled workers lived."
,"15":"Caleb, son of Jephunneh had three sons: Iru, Elah and Naam. Son of Elah: Kenaz."
,"16":"The sons of Jehallelel were: Ziph, Ziphah, Tiria, and Asarel."
,"17":"Ezrah had four sons: Jether, Mered, Epher, and Jalon. Mered's wife Bithiah, a daughter of the King of Egypt, gave birth to a daughter, Miriam, and two sons, Shammai and Ishbah. Ishbah was the father of Eshtemoa."
,"18":"Mered also had a wife from the tribe of Judah who gave birth to three sons: Jered, the father of Gedor; Heber, father of Soco; and Jekuthiel, father of Zanoah."
,"19":"Hodiah married the sister of Naham. Their descendants formed the clan of Garm, which lived in the town of Keilah, and the clan of Maacath, which lived in the town of Eshtemoa."
,"20":"The sons of Shimon were: Amnon, Rinnah, Ben-hanan, and Tilon. The sons of Ishi were: Zoheth and Ben-zoheth."
,"21":"The descendants of Shelah son of Judah were: Er, father of Lecah; Laadah, father of Mareshah; and the clans of linen weavers of Beth-ashbea;"
,"22":"Jokim and the people who lived in Cozeba; Joash and Saraph who went to Moab to take wives before returning to Bethlehem (these are events of long ago.)"
,"23":"They were potters and lived in the towns of Netaim and Gederah; they stayed with the king there, employed in his workshop."
,"24":"Simeon had five sons; Nemuel, Jamin, Jarib, Zerah, and Shaul."
,"25":"Shaul's son was Shallum, his grandson was Mibsam, and his great-grandson was Mishma."
,"26":"The sons of Mishma were: Hammuel, Zakur, Simi."
,"27":"Simi had sixteen sons and daughters, but his brothers did not have many children, and none of their families increased as the families of Judah did."
,"28":"They lived in Beersheba, Moladah and Hazarshual,"
,"29":"Bilhah, Ezem and Tolad,"
,"30":"Bethuel, Hormah and Ziklag."
,"31":"Beth-marcaboth, Hazarsusim, Bethbiri, Shaaraim. These were their towns until the reign of David."
,"32":"Their outlying villages were: Etam, Ain, Rimmon, Tochen and Ashan, five towns,"
,"33":"with all their surrounding villages as far as Baalath. Here they had their settlements and sorted themselves into their various groups."
,"34":"Meshobab, Jamlech, Joshah son of Amaziah,"
,"35":"Joel, Jehu son of Joshibiah, son of Seraiah, son of Asiel,"
,"36":"Elioenei, Jaakobah, Jeshohaiah, Asaiah, Adiel, Jesimiel, Benaiah,"
,"37":"Ziza, Ben-shiphi, Benallon, Ben-jedaiah, Ben-shimri, Ben-shemaiah."
,"38":"These men came with their clans and families; they grew in number and spread."
,"39":"As they searched for pasture for their flocks they traveled from the Gerar pass to the eastern end of the valley,"
,"40":"where they found good, fat pasture; the land was broad, untroubled, peaceful. Hamites had been living there before them. "
,"41":"But in the time of Hezekiah king of Judah this group of Simeon's tribe arrived there, overran their tents and the dwellings they found there. They wiped them out through an anathema still in force today and settled in their place, since there was pasturage for their flocks."
,"42":"Some of them, belonging to the sons of Simeon, reached Mount Seir: five hundred men led by Pelathiah, Neariah, Rephaiah, and Uzziel, the sons of Ishi."
,"43":"They defeated the surviving fugitives of Amalek and still live there today."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Descendants of Reuben, firstborn of Israel. He was indeed the firstborn but, when he had relations with his father's concubine, his birthright was given to the sons of Joseph son of Israel. The group of Joseph, however did not keep this firstborn right"
,"2":"because Judah proved more powerful than his brothers (and from him proceeds the Ruler), but the firstborn right belongs to the tribes of Joseph."
,"3":"Sons of Reuben, firstborn of Israel; Hanoch, Pallu, Hezron, Carmi."
,"4":"Sons of Joel: Shemaiah his son, Gog his son, Shimei his son,"
,"5":"Micah his son, Reaiah his son, Baal his son,"
,"6":"Beerah his son, whom Tiglath-pileser king of Assyria carried off into exile. He was a prince of the Reubenites."
,"7":"His kinsmen, by clans, grouped according to their kinship: Jeiel, the chief, Zechariah,"
,"8":"Bela son of Azaz, son of Shema, son of Joel. These lived in Aroer as far as Nebo and Baal-Mehon. "
,"9":"These extended to the east toward the River Euphrates, reaching the desert, because their flocks had multiplied in the land of Galaad."
,"10":"In the days of Saul they waged war against the Agarites who were defeated, and they occupied their homes east of Galaad."
,"11":"The sons of Gad lived opposite them, in the land of Bashan, as far as Salcah."
,"12":"First, Joel, and then Shaphan, Yani and Basat in Basan."
,"13":"The other families of the tribe were those of Michael, Mesullam, Sheba, Joral, Jacan, Zia, and Eber."
,"14":"These are the descendants of Abihail, whose ancestors were traced back as follows: Abihail, Huri, Jaroah, Gilead, Michael, Jeshishai, Jahdo, Buz."
,"15":"Ahi son of Abdiel, and grandson of Guni, was head of these clans."
,"16":"They had settled in the territory of Gilead and Bashan, in the towns there and all over the pasture lands of Sharon."
,"17":"(All were listed in the family records in the days of king Jotham of Judah and King Jeroboam of Israel)."
,"18":"The people of Reuben, Gad, and half tribe of Manasseh, were 44,760 valiant men, well-trained in the use of shields, swords, and bows."
,"19":"They waged war against the Hagrite tribes of Jetur, Naphish, and Nodab, and as they put their trust in God and called on him for help,"
,"20":"they were victorious over the Hagrites and all their allies."
,"21":"They took with them from the Hagrites' livestock, 50,000 camels, 25,000 sheep, and 2,000 donkeys."
,"22":"They took 100,000 prisoners of war, but many of the enemy had been killed for it was God's war. And they settled in what had been Hagrite territory until the exile."
,"23":"The half tribe of Manasseh settled in the land between Bashan and Baal-hermon, Senir and Mount Hermon, and they were very numerous."
,"24":"These are the heads of their clans: Epher, Ishi, Eliel, Azriel, Jeremiah, Hodaviah, and Jahdiel. These were famous warriors and leaders of their clans."
,"25":"But they were unfaithful to the God of their ancestors and worshiped the gods of the peoples whom God had driven out of the land."
,"26":"So the God of Israel brought against them the anger of Pul, king of Assyria, and of Tiglath-pileser, king of Assyria, who deported the tribes of Reuben, Gad and the half tribe of Manasseh. They were taken off to Halah near Habor and the river Gozan. They are still there today."
,"27":"Sons of Levi: Gershom, Kohath and Merari."
,"28":"Sons of Kohat: Amram, Izhar, Hebron, and Uzziel."
,"29":"Sons of Amram: Aaron, Moses and Mary. Sons of Aaron: Nadab and Abihu, Eleazar and Ithamar."
,"30":"The descendants of Eleazar from one generation to the next are as follows: Phinehas, Abishua, Bukki, Uzzi,"
,"31":"Zerahiah, Meraioth,"
,"32":"Amariah, Ahitub,"
,"33":"Zadok, Ahimaaz,"
,"34":"Azariah, Johanan,"
,"35":"Azariah (the one who served as priest in the Temple that Solomon built in Jerusalem),"
,"36":"Amariah, Ahitub,"
,"37":"Zadok, Shallum,"
,"38":"Hilkiah, Azariah,"
,"39":"Seraiah, Jehozadak."
,"40":"Jehozadak was deported when Yahweh, through King Nebuchadnezzar, sent into exile the people of Judah and Jerusalem."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Levi had three sons: Gershom, Kohath and Merari."
,"2":"These are the names of the sons of Gershom: Libni and Shimei."
,"3":"Sons of Kohath: Amran, Izhar, Hebron, and Uzziel."
,"4":"Sons of Merari: Mahli and Mushi. These are the families of Levi according to their ancestors."
,"5":"Descendants of Gershon from one generation to the next: Libni, Jahath, Zimmah,"
,"6":"Joah, Iddo, Zerah, Jeatheral."
,"7":"Descendants of Kohath from one generation to the next: Amminadab, Korah, Assir,"
,"8":"Elkanah, Ebiasaph, Assir,"
,"9":"Tahath, Uriel, Uzziah, Shaul."
,"10":"Elkanah had two sons, Amasai and Ahimoth."
,"11":"Elkanah, son of Ahimoth, Zophai, Nahath,"
,"12":"Eliab, Jeroham, Elkanah."
,"13":"The sons of Elkanah were: Samuel his firstborn, and Abijah. Samuel had two sons: Joel, the firstborn, and Abijah, the younger."
,"14":"Descendants of Merari from one generation to the next: Mahli, Libni,"
,"15":"Shimei, Uzzah, Shimea, Haggiah, Asaiah."
,"16":"These are the men David named to lead the singing in the Temple of Yahweh when the ark had come to rest there."
,"17":"They were responsible for the singing before the Holy Tent of the Tent of Meeting until Solomon had built the Temple of Yahweh in Jerusalem. They did their duties in accordance with the rules."
,"18":"These are the men who accomplished this ministry, and their sons: Of the clan of Kohath: Herman, the leader of the first choir, was the son of Joel. His ancestral line went back to Jacob as follows: Herman, Joel, Samuel, "
,"19":"Elkanah, Jeroham, Eliel, Toah, Zuph,"
,"20":"Elkanah, Mahath, Amasai,"
,"21":"Elkanah, Joel, Azariah, Zephaniah,"
,"22":"Tahath, Assir, Ebiasaph, Korah,"
,"23":"Izhar, Kohath, Levi, Jacob."
,"24":"His brother Asaph was leader of the second choir. His ancestral line went back to Levi as follows: Asaph, Berechiah, Shimea,"
,"25":"Michael, Baaseiah, Malchijah,"
,"26":"Ethni, Zerah, Adaiah,"
,"27":"Ethan, Zimmah, Shimei,"
,"28":"Jahath, Gershon, Levi."
,"29":"Ethan of the clan of Merari was the leader of the third choir, at the left side. His ancestral line went back to Levi as follows: Ethan, Kishi, Abdi, Malluch,"
,"30":"Hashabiah, Amaziah, Hilkiah,"
,"31":"Amzi, Bani, Shemer,"
,"32":"Mahli, Mushi, Medrari, Levi."
,"33":"Their brother Levites were in charge of the Holy Tent of the Temple of Yahweh."
,"34":"Aaron and his descendants burned the offerings on the altar for burnt offering and on the altar of incense. They were responsible for all the worship in the Most Holy Place and for the atonement for Israel's sins, according to the instructions of Moses, the servant of God."
,"35":"This is the line of Aaron's descendants: Eleazar, Phinehas, Abishua,"
,"36":"Bukki, Uzzi, Zerahiah,"
,"37":"Meraioth, Amariah, Ahitub,"
,"38":"Zadok, Ahimaaz."
,"39":"These are the places they lived in, according to the boundaries of their settlements."
,"40":"To the sons of Aaron of the Kohath clan (to whom the first share of land was assigned) they gave Hebron in the land of Judah and the pasture lands nearby."
,"41":"The fields and villages of this town, however, had been given to Caleb, son of Jephunneh."
,"42":"The following towns were given to the descendants of Aaron: Hebron, a city of refuge, Jattir, Libnah, Eshtemoa,"
,"43":"Hilen, Debir,"
,"44":"Ashan, and Beth-Shemesh, with pasture lands near them."
,"45":"In the territory of Benjamin they were given the following towns with their pasture lands: Geba, Alemeth, and Anathoth. A total of thirteen towns were given them for all their families to live in."
,"46":"To the rest of the clan of Kohath, family by family, ten towns were given from the territory of the half tribe of Manasseh."
,"47":"The clan of Gershom, family by family, were given thirteen towns from the territories of Issachar, Asher, Naphtali and from the tribe of Manasseh in Bashan."
,"48":"The clan of Merari, family by family, were given twelve towns from the territories of Reuben, Gad, and Zebulun."
,"49":"The people of Israel gave these towns with their pasture lands to the Levites."
,"50":"They received from the territories of Judah, Simeon and Benjamin the towns to which they gave names."
,"51":"The clans of Kohath obtained towns by lot from the tribe of Ephraim."
,"52":"They were given the following towns with their pasture lands: Shechem, the city of refuge in the hill country of Ephraim, Gezer,"
,"53":"Jokmeam, Beth-Horon,"
,"54":"Aijalon, and Gath Rimmon."
,"55":"In the territory of the half tribe of Manasseh, they were given the towns of Aner and Beileam with their pasture lands."
,"56":"The clan of Gershon, family by family, were given the following towns with their pasture lands. In the territory of the half tribe of Manasseh: Golan in Bashan, and Ashtaroth."
,"57":"In the territory of Issachar: Kedesh, Daberath,"
,"58":"Ramoth, and Anem."
,"59":"In the territory of Asher: Mashal, Abdon,"
,"60":"Hukok, and Rehob."
,"61":"In the territory of Naphtali: Kedesh in Galilee, Hammon, and Kiriathaim."
,"62":"To the rest of the clan of Merari were given the following towns with their pasture lands. In the territory of Zebulun: Rimmono and Tabor."
,"63":"In the territory of Reuben, beyond the Jordan River near Jericho: Bezer on the high, flat land, Jahzah,"
,"64":"Kedemoth, and Mephaath."
,"65":"In the territory of Gad: Ramoth in Gilead, Mahanaim,"
,"66":"Heshbon, and Jazer."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Issachar had four sons: Tola, Puah, Jashub, and Shimron."
,"2":"Tola had six sons: Uzzi, Rephaiah, Jeriel, Jahmai, Ibsam, and Shemuel. They were heads of families of the clan of Tola and famous warriors. In the time of David, the descendants numbered 22,600. Uzzi had one son, Izrahiah."
,"3":"Izrahiah had four sons: Michael, Obadiah, Joel, and Isshiah. All five of these were chiefs"
,"4":"and they were obliged to enlist their troops: 36,000 men, for they had many wives and children."
,"5":"The family records of all the clans of Issachar listed a total of 87,000 men able to give military service."
,"6":"Benjamin had three sons: Bela, Becher, and Jediael."
,"7":"Bela had five sons: Ezbon, Uzzi, Uzziel, Jeri-moth and Iri. They were heads of families in the clan and famous warriors. Their family records listed 22,034 men able to give military service."
,"8":"Becher had nine sons: Zemirah, Joash, Eliezer, Elioenai, Omri, Jeremoth, Abijah, Anathoth, and Alemeth."
,"9":"Their family records listed 17,200 men able to give military service. Shuppin and Huppin also belonged to this tribe."
,"10":"Jediael had one son, Bilhan who had seven sons: Jeush, Benjamin, Ehud, Chenaanah, Zethan, Tarshish, and Ahishahar."
,"11":"They were heads of families in the clan and famous warriors."
,"12":"Shuppin and Huppin also belong to this tribe."
,"13":"Naphtali had four sons: Jahziel, Guni, Jezer, and Shallum. They were descendants of Bilhan."
,"14":"Manasseh had Asriel by his Aramean concubine. She gave birth also to Machir, father of Gilead."
,"15":"Gilead was the father of Iefer and Eeleg. The son of Iefer was Zelophehad. Zelophehad had only daughters."
,"16":"Maacah, wife of Machir, gave birth to two sons, whom they named Peresh and Sheresh. Peresh had two sons: Ulam and Rakem."
,"17":"Ulam had a son named Bedan. These were the descendants of Gilead, the son of Machir and grandson of Manasseh."
,"18":"Gilead's sister Molecheth had three sons: Ishhod, Abiezer, and Mahlah."
,"19":"Shemida had four sons: Ahian, Shechem, Likhi and Aniam."
,"20":"These are the descendants of Ephraim from one generation to the next: Shuthelah, Bered, Tahath, Eleadah, Tahath, Zabad, Shuthelah. Ephraim's two other sons, Ezer and Elead,"
,"21":"were killed when they tried to steal the cattle belonging to the people of Gath."
,"22":"Ephraim, their father, mourned for them for a long time and his brothers came to comfort him."
,"23":"Then Ephraim went to his wife, and she conceived and gave birth to a son whom she called Beriah, because of the trouble that had come to their family."
,"24":"Beriah's daughter, Sheerah, built Lower and Upper Beth-horon and Uzzen-sheerah. Ephraim also had a son named Rephah. The descendants of "
,"25":"Rephah were as follows: Resheph, Telah, Tahan,"
,"26":"Ladan, Ammihud, Elishama,"
,"27":"Nun, Joshua."
,"28":"They had lands and settlements in Bethel and its towns, in Naasan to the east in Gezep and its towns to the west, Shechem and its towns, as far as Ayyah and its towns."
,"29":"Bethshean, Taanach, Megiddo, Dor, each with its towns, were controlled by the descendants of Manasseh. In all these places lived the descendants of Joseph, son of Jacob."
,"30":"Asher had four sons: Imnah, Ishvah, Ishvi, and Beriah; and one daughter, Serah."
,"31":"Sons of Beriah: Heber and Malchiel. Malchiel was the father of Birzaith."
,"32":"Heber had three sons: Japhlet, Shomer and Hotham; and one daughter Shura."
,"33":"Japhlet had three sons: Pasah, Bimhal and Ashvath."
,"34":"Shomar, his brother, also had three sons: Rohgah, Hubbah and Aram."
,"35":"His brother Hotham had four sons: Zophah, Imna, Shelesh, and Amal."
,"36":"The sons of Zophal were: Suah, Harnepher, Shual, Beri and Imrah,"
,"37":"Bezer, Hod, Shamma, Shilshah, Ithran and Beerah."
,"38":"The sons of Ulla were descendants of Asher. They were heads of families, and famous warriors; Asher's descendants included 26,000 men able to give military service."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Benjamin became father of Bela, his firstborn, Ashbel second, Ahiram third,"
,"2":"Nohah fourth, Rapha fifth."
,"3":"Bela had sons: Addar, Gera, Abihud,"
,"4":"Abishua, Naaman and Ahoah,"
,"5":"Gera, Shephuphan and Huram."
,"6":"These are the sons of Ehud. They were heads of families of the inhabitants of Geba and led them into exile at Manahath:"
,"7":"Naaman, Ahijah and Gera. It was he who led them into exile; he became the father of Uzza and Ahihud."
,"8":"He became father of Shaharaim in the plains of Moab after he had dismissed his wives, Hushim and Baara."
,"9":"By his new wife he had sons: Jobab, Zibia, Mesha, Malcam,"
,"10":"Jeuz, Sachia, Mirmah. These were his sons, heads of families."
,"11":"By Hushim he had sons: Abitub and Elpaal."
,"12":"Sons of Elpaal: Eber, Misham and Shemed: it was he who built Ono and Lud with its outlying towns."
,"13":"Beriah and Shema. They were heads of families of the inhabitants of Aijaloz."
,"14":"Shashak was his brother. Jeremoth, "
,"15":"Zebadiah, Arad, Eder,"
,"16":"Michael, Ishpah, Joha were sons of Beriah."
,"17":"Zebadiah, Meshullam, Hizki, Haber,"
,"18":"Ishmerai, Izliah, Jobab were sons of Elpaal."
,"19":"Jakim, Zichri, Zabdi,"
,"20":"Elioenai, Zillethai, Eliel,"
,"21":"Adaiah, Beraiah, Shimran were sons of Shimei."
,"22":"Ishpan, Eber, Eliel,"
,"23":"Abdon, Zichri, Hanan,"
,"24":"Hananiah, Elam, Anthothijah,"
,"25":"Iphdeiah, Penuel were sons of Shashak."
,"26":"Shamsherai, Shehariah, Athaliah,"
,"27":"Jaareshaiah, Elijah, Zichri were sons of Jeroham."
,"28":"These were the heads of families, grouped according to their kinship. They lived in Jerusalem."
,"29":"At Gibeon lived Abi-gibeon, whose wife was Macaah."
,"30":"His firstborn son was Abdon, then Zur, Kish, Baal, Ner, Nadab,"
,"31":"Gedor, Ahio, Zecher"
,"32":"and Mikloth who became father of Shimeah. These also, near their kinsmen, lived with their kinsmen in Jerusalem."
,"33":"Ner was father of Kish, Kish father of Saul, Saul father of Jonathan, Malchi-shua, Abinadab and Eshbaal."
,"34":"Son of Jonathan: Meribbaal. Meribbaal became father of Micah."
,"35":"Sons of Micah: Pithon, Melech, Tarea, Ahaz."
,"36":"Ahaz became father of Jehoaddah, Jehoaddah father of Alemeth, Azmaveth and Zimri. Zimri became father of Moza,"
,"37":"Moza father of Binea. Raphah his son, Eleasah his son, Azel his son."
,"38":"Azel had six sons, whose names were these: Azrikam, Bocheru, his firstborn, then Ishmael, Sheariah, Obadiah, Hanan. All these were sons of Azel."
,"39":"Sons of Eshek his brother: Ulam, his firstborn, Jeush second, Eliphelet third."
,"40":"Ulam had sons, stout fighting men and bowmen. They had numerous sons and grandsons, a hundred and fifty of them. All these were sons of Benjamin."
}`)
	CurrentBook.AddChapter(9, `{
"1":"All the Israelites were classified in related groups, but they were listed in the Book of the Kings of Israel. As for those of Judah, they were deported to Babylon for their faithlessness."
,"2":"The first who came back to their towns and their estates were Israelites, priests, Levites and helpers."
,"3":"So in Jerusalem lived Judaeans, Benjaminites, Ephraimites and Manassites."
,"4":"Uthai son of Ammihud, son of Omri, son of Imri, son of Bani, one of the sons of Perez son of Judah."
,"5":"Of the Shilonites: Asaiah, the firstborn, and his sons."
,"6":"Of the sons of Zerah: Jeuel. Also their kinsmen: six hundred and ninety."
,"7":"Of the tribe of Benjamin: Sallu son of Meshullam, son of Hodaviah, son of Hassenuah;"
,"8":"Ibneiah son of Jeroham; Elah son of Uzzi, son of Michri; Mesullam son of Shephatiah, son of Reuel, son of Ibnijah."
,"9":"They had nine hundred and fifty-six kinsmen, grouped according to their kinship. All these men were heads of families."
,"10":"Of the priests: Jedaiah, Jehoiarib, Jachin,"
,"11":"Azariah son of Hilkiah, son of Meshullam, son of Zadok, son of Meraioth, son of Ahitub, ruler of the house of God."
,"12":"Adaiah son of Jeroham, son of Pashhur, son of Malchijah, Maasai son of Adiel, son of Jahzerah, son of Meshullam, son of Meshillemith, son of Immer."
,"13":"They had kinsmen, heads of families, one thousand seven hundred and sixty men who undertook the duties of the Temple of God."
,"14":"Of the Levites: Shemaiah son of Hasshub, son of Azrikam, son of Hashabiah of the sons of Merari,"
,"15":"Bakbakkar, Heresh, Galal, Mattaniah son of Mica, son of Zichri, son of Asaph,"
,"16":"Obadiah son of Shemaiah, son of Galal, son of Jeduthun, and Berechiah son of Asa, son of Elkanah who lived in the villages of the Netophathites."
,"17":"The keepers of the gate: Shallum, Akkub, Talmon, Ahiman and their kinsmen. Shallum, was their head,"
,"18":"and they still keep station at the royal gate, to the east. These were the gatekeepers of the camp of the Levites."
,"19":"Shallum son of Kore, son of Ebiasaph, son of Korah, with his brother Korahites, of the same family, were responsible for the liturgical service; they were 'keepers of the threshold for the Tent,' for their fathers had guarded the entrance of the camp of Yahweh."
,"20":"At one time, Phinehas son of Eleazar had ruled them and they served before Yahweh."
,"21":"Zechariah son of Meshelemiah was keeper of the gate at the entrance to the Tent of Meeting."
,"22":"All the keepers of the gate at the thresholds were picked men; there were two hundred and twelve of them and they were registered in their various villages. These were appointed by David and Samuel the seer because of their loyalty."
,"23":"They and their sons had the guardianship of the gates of the House of Yahweh, the house of the Tent."
,"24":"On the four sides stood the keepers of the gate, east, west, north, and south."
,"25":"Their kinsmen in their villages would come to join them for a week from time to time,"
,"26":"since the four head gatekeepers themselves lived there permanently. Some of them were responsible for the chambers and treasuries of the house of God."
,"27":"They spent the night in the precincts of the house of God, their duties being to guard it and they had the keys with them to open the rooms at the morning."
,"28":"Some of them were responsible for the furnishings of worship; they counted them whenever they put them away and took them out."
,"29":"Others were in charge of the furniture and all the sacred furnishings, the fine flour, the wine, the oil, the incense, the spices,"
,"30":"but only the priests prepared the mixture for the spices."
,"31":"One of the Levites, Mattithiah the firstborn of Shallum the Korahite, was responsible for the offerings that were to be baked on the pan."
,"32":"Some of their kinsmen the Kohathites were responsible for the loaves to be set out in rows sabbath by sabbath."
,"33":"These are the cantors, heads of the levitical families. When free from service they lived in the Temple chambers, because they were on duty day and night."
,"34":"These were the heads of the families of the Levites, grouped according to their families. These heads lived in Jerusalem."
,"35":"In the city of Gibeon lived Abigibeon and Jeiel, whose wife was called Maacah."
,"36":"His firstborn was Abdon, then Zur, Kish, Baal, Ner, Nadab,"
,"37":"Gedor, Ahio, Zechariah."
,"38":"Mikloth became father of Shimeam. Their descendants lived in Jerusalem near other families of their clans."
,"39":"Ner became father of Kish, Kish father of Saul, Saul father of Jonathan, Malchi-shua, Abinadab and Eshbaal."
,"40":"Jonathan's son Merribbaal, became father of Micah."
,"41":"Micah had four sons: Pithon, Melech, Tahrea and Ahaz."
,"42":"Ahaz became father of Jarah, Jarah father of Alemeth, Azmaveth and Zimri; Zimri became father of Moza,"
,"43":"Moza father of Binea, whose son was"
,"44":"Rephaiah, whose son was Eleasah, whose son was Azel. Azel had six sons; their names were these: Azrikam, his firstborn, then Ishmael, Bocheru, Sheariah, Obadiah, Hanan. These were the sons of Azel."
}`)
	CurrentBook.AddChapter(10, `{
"1":"The Philistines attacked Israel, and the Israelites fled or were killed on Mount Gilboa."
,"2":"The Philistines caught up with Saul and killed Jonathan, Abinadab and Malchi-shua, the sons of Saul."
,"3":"The fighting grew heavy about Saul; he was hit by enemy arrows and badly wounded."
,"4":"Then Saul said to the young man carrying his weapon, 'Draw your sword and kill me. I do not want these godless Philistines to come and gloat over me.' But the young man was afraid and would not do it. So Saul took his own sword and threw himself on it."
,"5":"Then the young man threw himself on his sword too and died."
,"6":"And so Saul died, he and his three sons and all his own together."
,"7":"All the Israelites who were in the valley heard that the army had fled and that Saul and his sons were dead. So they abandoned their towns and ran away. The Philistines then came in and occupied them."
,"8":"When the Philistines came on the following day to strip the dead, they found Saul and his sons lying on Mount Gilboa."
,"9":"They stripped him and, taking his head and his armor, had them carried around the land of the Philistines to proclaim the good news to their idols and their people."
,"10":"They placed his armor in the temple of their god, but his head they hung in the temple of Dagon."
,"11":"When all the people of Gilead heard all that the Philistines had done to Saul,"
,"12":"the valiant men went and took the bodies of Saul and his sons away and brought them to Jabesh. They buried their bones under the oak tree in Jabesh, and they fasted for seven days."
,"13":"Saul died because he had been unfaithful to Yahweh: he had disobeyed the commands of Yahweh; he had even consulted the spirits of the dead."
,"14":"As he had not consulted Yahweh, Yahweh put him to death and gave control of the kingdom to David son of Jesse."
}`)
	CurrentBook.AddChapter(11, `{
"1":"All the people of Israel went to David at Hebron 'Look, we are your own flesh and blood."
,"2":"Even when Saul was our king, you led Israel in battle; and Yahweh your God said to you, 'You are the man who shall be shepherd of my people Israel and shall be ruler over them.''"
,"3":"So all the elders of Israel came to the king at Hebron, and David made a covenant with them at Hebron in the presence of Yahweh, and he became king of Israel, just as Yahweh had promised through Samuel."
,"4":"David with all the Israelites attacked Jerusalem (that is to say, Jebus); there lived the Jebusites."
,"5":"They said to David, 'You will not get in here.' But David captured the fortress of Zion, and it became the City of David."
,"6":"David said, 'The first man to attack the Jebusites shall become leader and commander of the army.' Joab son of Zeruiah attacked first and became commander."
,"7":"David went to live in the fortress, and because of this it was called the City of David."
,"8":"He then built a wall around the city, and the Millo as well as the surrounding wall, while Joab restored the rest of the city."
,"9":"David grew greater and greater, and Yahweh Sabaoth was with him."
,"10":"These are the famous warriors of David, those who during his rule struggled with him and with all Israel, to make him king as Yahweh had promised."
,"11":"This is the list of David's warriors: Jashobeam the Hachmonite, leader of the Thirty; one day he wielded his battle-ax against three hundred whom he killed at one time."
,"12":"After him there was Eleazar son of Dodo, the Ahohite, one of the three champions."
,"13":"He was with David at Pasdammim where the Philistines had gathered to attack. There was a field full of barley there. When the Israelites started to run away,"
,"14":"Eleazar took a stand in the middle of the field, defended it and fought the Philistines. So Yahweh brought about a great victory."
,"15":"The Thirty leading soldiers went down to David at the rock near the Cave of Adullam while a company of Philistines was encamped in the Valley of the Rephaim."
,"16":"David was then on a fortified hill, and a group of Philistines had occupied Bethlehem."
,"17":"David sighed, 'Oh, if someone would fetch me a drink of water from the well by the gate of Bethlehem!'"
,"18":"At this The Three, forcing their way through the Philistine camp, drew water from the well by the gate of Bethlehem and, bringing it away, presented it to David. But David would drink none of it and poured it out as an offering to Yahweh."
,"19":"'God keep me,' he said, 'from doing this! Am I to drink the blood of these men? For at the risk of their lives they brought it.' And so he would not drink it. Such were the deeds of The Three."
,"20":"Abishai, the brother of Joab, was leader of The Thirty. He fought with his spear against three hundred whom he killed, winning himself a name among The Thirty."
,"21":"He was the most famous of The Thirty and became their captain, but he was not as famous as The Three."
,"22":"Benaiah son of Jehoiada, a hero from Kabzeel, did many brave deeds; he killed the two Ariels of Moab. One snowy day, he went down and killed the lion in a pit."
,"23":"He also killed an Egyptian, a huge man seven and a half feet tall. The Egyptian had a gigantic spear in his hand, but Benaiah attacked him with a club, snatched the spear from the Egyptian's hand and killed the man with it."
,"24":"Such were the deeds of Benaiah son of Jehoiada, winning him a name among the thirty leading soldiers."
,"25":"He was famous among The Thirty, but he was not as famous as The Three. David put him in command of his bodyguard."
,"26":"The other valiant warriors were: Asahel the brother of Joab. Elhanan son of Dodo, from Bethlehem."
,"27":"Shammoth from Harod, Helez the Pelonite."
,"28":"Ira son of Ikkesh, from Tekoa. Abiezer from Anathoth."
,"29":"Sibbecai from Hushah. Ilai from Ahoh."
,"30":"Maharai from Netophah. Heled son of Baanah, from Netophah."
,"31":"Ithai son of Ribai, from Gibeah of Benjamin. Benaiah from Pirathon."
,"32":"Hurai from the valleys near Gaash. Abiel from Bethhaarabah."
,"33":"Azmaveth from Baharum. Eliahba from Shaalbon."
,"34":"Benehashem from Gizon. Jonathan son of Shagee, from Harar."
,"35":"Ahiam son of Sachar, from Harar. Eliphelet son of Ur."
,"36":"Hepher from Mecherah. Ahijah the Pelonite."
,"37":"Hezro from Carmel. Naarai son of Ezbai."
,"38":"Joel the brother of Nathan. Mibhar son of Hagri."
,"39":"Zelek the Ammonite. Naharai from Beeroth, armorbearer to Joab son of Zeruiah."
,"40":"Ira from Jattir. Gareb from Jattir."
,"41":"Uriah the Hittite. Zabad son of Ahlai."
,"42":"Adina son of Shiza (a leading member of the tribe of Reuben, with his own group of thirty soldiers)."
,"43":"Hanan son of Maacah. Joshaphat the Mithnite."
,"44":"Uzzia from Ashteroth. Shama and Jeiel, sons of Hotham the Aroerite."
,"45":"Jediaelson of Shimri, and Joha his brother, the Tizite."
,"46":"Eliel the Mahavite. Jeribai and Joshaviah, sons of Elnaam. Ithmah the Moabite."
,"47":"Eliel, Obed, and Jaasiel from Zoba."
}`)
	CurrentBook.AddChapter(12, `{
"1":"The following men came to David in Ziklag where he had gone to escape from King Saul. They were valiant and reliable warriors, members of the tribe of Benjamin, to which Saul belonged."
,"2":"They were archers who could use either the right or the left hand, both in slinging stones and in shooting arrows with the bow."
,"3":"They were Ahiezer the leader, and Joash, sons of Hashemar from Gibeah, Jeziel and Pelet, sons of Azmaveth, Berach and Jehu from Anathoth,"
,"4":"Ismaiah from Gibeon, a famous soldier and one of the leaders of The Thirty;"
,"5":"Jeremiah, Jahaziel, Johanan and Jozabad from Gederoth,"
,"6":"Eluzai, Jerimoth, Bealiah, Shemariah, Shephatiah from Hariph,"
,"7":"Elkanah, Eshiah, Azarel, Joezer, Jashobeam, Korahites,"
,"8":"Joelah, Zebadiah, sons of Jeroham from Gedor."
,"9":"Some Gadites also joined David's troops when he was at the desert fort. They were valiant fighting men and experts with shield and spear. They were as fierce-looking as lions and as quick as mountain deer."
,"10":"Ezer was the leader, Obadiah second, Eliab third,"
,"11":"Mishmannah fourth, Jeremiah fifth."
,"12":"Attai sixth, Eliel seventh,"
,"13":"Johanan eighth, Elzabad ninth,"
,"14":"Jeremiah tenth, Machbannai eleventh."
,"15":"These sons of God were troop commanders, each one in command of a unit, the junior officers placed over a hundred, and senior officers over a thousand."
,"16":"These are the men who crossed the Jordan in the first month, when it overflowed its course, and scattered all the people who lived on its banks, both east and west."
,"17":"Those men from the tribes of Benjamin and Judah came to David at the fort."
,"18":"David went to meet them and said, 'If you come to me as friends, to give me help, then I am ready to join you. But if it is to betray me to my enemies, when I have done no wrong, then may the God of our ancestors see and punish you.'"
,"19":"Then God's spirit took control of one of them, Amasai, leader of The Thirty, and he called out: 'Yours we are, David! We are with you, son of Jesse! Peace to you, peace to him that helps you, for God is on your side.',David welcomed them and made them officers in his army."
,"20":"Some people from the tribe of Manasseh went over to David's side as he was setting out with the Philistines to fight Saul. But David did not help the Philistines, because their chiefs, after consultation, sent him back to Ziklag. They were afraid he would betray them to his former master Saul."
,"21":"He was on his way to Ziklag when these Manassites joined him: Adnah, Jozabad, Jediael, Michael, Jozabad, Elihu, Zillethai, commanders of thousands in Manasseh."
,"22":"They were reinforcements for David and his troops, since they were all outstanding soldiers and became officers in the army."
,"23":"Indeed new men joined David's forces almost every day, so that his camp grew into an enormous camp."
,"24":"These are the figures from the list of experienced warriors who joined David at Hebron to transfer Saul's kingship to him in accordance with the command of Yahweh:"
,"25":"Sons of Judah carrying shield and spear: 6,800 men equipped for battle."
,"26":"Of the sons of Simeon; 7,100 well-trained men."
,"27":"Of the sons of Levi: 4,600"
,"28":"in addition to Jehoiada, in command of the Aaronites, with 3,700 men;"
,"29":"Zadok, a young and able fighter and 22 commanders of his family."
,"30":"Of the sons of Benjamin: 3,000 kinsmen of Saul, most of them hitherto in the service of the House of Saul."
,"31":"Of the sons of Ephraim: 20,800 men famous in their families."
,"32":"Of the half tribe of Manasseh: 18,000 men assigned by name to go and proclaim David king."
,"33":"Of the sons of Issachar, expert in knowing the times when Israel should take action, and the way to do it: 200 leaders and all their kinsmen under their command."
,"34":"Of Zebulun: 50,000 men fit for service, ready to fight with weapons of every kind."
,"35":"Of Naphtali: 1,000 commanders, and with them 37,000 men armed with shield and spear."
,"36":"Of the Danites: 28,600 men ready for battle."
,"37":"Of Asher: 40,000 men fit for service, ready for battle."
,"38":"From Transjordania: 120,000 men of Reuben, Gad and the half tribe of Manasseh, with weapons of every kind."
,"39":"All these warriors, ready for battle, came to Hebron willingly to proclaim David king over all Israel; and the rest of Israel, too, were all of one mind in making David king."
,"40":"For three days they stayed there, eating and drinking with David, for their kinsmen had sent food for them."
,"41":"Moreover from as far as Issachar and Zebulun and Naphtali their neighbors brought provisions, by donkey and camel, mule and ox - flour cakes, fig cakes, bunches of raisins, wine, oil, quantities of oxen and sheep; for there was joy in Israel."
}`)
	CurrentBook.AddChapter(13, `{
"1":"David consulted with the commanders of thousands, of hundreds, and with all the leaders."
,"2":"To the whole assembly of Israel David said, 'If you agree and if Yahweh our God wills it so, we will send messengers to the rest of our brothers throughout the territories of Israel, and also to the priests and Levites in their towns and nearby lands, and tell them to gather here with us."
,"3":"We will then go and get the ark of our God, for in the time of Saul we neglected it.'"
,"4":"They agreed to this, for in the eyes of all the people it was the right thing to do."
,"5":"So David gathered all the people together from the Shihor of Egypt to the Pass of Hamath to bring the ark of God from Kiriath-jearim."
,"6":"Then David and all Israel went up to Baalah, to Kiriath-jearim in Judah, to bring up the ark of God which bears the name of Yahweh who is seated on the Cherub."
,"7":"At Abinadab's house they placed the ark of God on a new cart. Uzziah and Ahio were leading the cart."
,"8":"David and all Israel danced before God with all their might, singing to the accompaniment of lyres, harps, tambourines, cymbals, and trumpets."
,"9":"When they came to the threshing floor of the Javelin, the oxen stumbled, and Uzzah stretched out his hand and took hold of the ark."
,"10":"Then the anger of Yahweh blazed out against Uzzah, and he killed him because he had laid his hand on the ark, and he died there in the presence of God."
,"11":"David was disturbed that Yahweh had punished Uzzah in anger, and so that place has been called Perez-uzzah ever since."
,"12":"David went in fear of God that day and said, 'How can I bring the ark of God to my home?'"
,"13":"So David did not take the ark home to the City of David, but took it to the house of a man named Obed-edom of Gath."
,"14":"The ark of God remained with the family of Obed-edom, in his house, for three months, and Yahweh blessed the family of Obed-edom and everything that belonged to him."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Hiram, king of Tyre, sent messengers to David with cedar wood and stonemasons and carpenters to build him a palace."
,"2":"David then knew that Yahweh had established him as king over Israel, and that for the sake of his people Israel his kingdom was being made prosperous."
,"3":"At Jerusalem David took more wives and fathered more sons and daughters."
,"4":"These are the names of the children born to him in Jerusalem: Shammua, Shobab, Nathan, Solomon,"
,"5":"Ibhar, Elishua, Elpelet,"
,"6":"Nogab, Nepheg, Japhia,"
,"7":"Elishama, Beeliada, Eliphelet."
,"8":"When the Philistines heard that David had been anointed king of all Israel, they all marched up to capture him. On hearing this, David went out to meet them."
,"9":"When the Philistines arrived, they began plundering the Valley of the Rephaim."
,"10":"David consulted Yahweh, 'Shall I attack the Philistines? Will you turn them over to me?' Yahweh answered him, 'Attack! I will turn them over to you.'"
,"11":"The Philistines went up to Baal-perazim and there David defeated them. David said, 'God has broken through them just as water breaks through a dam.' For this reason that place was called Baal Perazim."
,"12":"They had left their gods behind them there, and David ordered them to be burned."
,"13":"Again the Philistines started plundering in the valley."
,"14":"David again consulted God, and God answered, 'Do not attack them from the front; go around and get ready to attack them from the other side, near the balsam trees."
,"15":"When you hear the sound of marching in the tops of the balsam trees, launch your attack, for God is going out ahead of you to defeat the army of the Philistines.'"
,"16":"David did as God had ordered, and they defeated the Philistine army from Gibeon as far as Gezer."
,"17":"David became famous everywhere, and Yahweh made every nation afraid of him."
}`)
	CurrentBook.AddChapter(15, `{
"1":"David put up buildings for himself in the City of David and prepared a place for the ark of God, and he put up a tent for it."
,"2":"Then he said, 'Only the Levites shall move the ark of God, since Yahweh has chosen them to carry the ark and to serve him always.'"
,"3":"Then David gathered all Israel together in Jerusalem to bring the ark of God up to the place he had prepared for it."
,"4":"David called together the sons of Aaron and the sons of Levi:"
,"5":"of the sons of Kohath, Uriel the chief and his hundred and twenty kinsmen;"
,"6":"of the sons of Merari, Asaiah and his two hundred and twenty kinsmen;"
,"7":"of the sons of Gershom, Joel and his hundred and thirty kinsmen;"
,"8":"of the sons of Elizaphah, Shemaiah and his two hundred kinsmen;"
,"9":"of the sons of Hebron, Eliel and eighty kinsmen;"
,"10":"of the sons of Uzziel, Amminadab and his hundred and twelve kinsmen."
,"11":"David called in the priests Zadok and Abiathar, and the Levites Uriel, Asaiah, Joel, Shemaiah, Eliel and Amminadab."
,"12":"He told them, 'You are the heads of families of the Levites. Purify yourselves, you and your brothers, and bring the ark of Yahweh, the God of Israel, up to the place I have prepared for it."
,"13":"The first time you were not there to carry it and Yahweh our God punished us for not consulting him as we should have done.'"
,"14":"So the priests and the Levites purified themselves to bring up the ark of Yahweh, the God of Israel,"
,"15":"and the Levites carried the ark of God with the poles on their shoulders, as Moses had ordered according to the command of Yahweh."
,"16":"David then told the leaders of the Levites to assign duties for some Levites to sing and play a joyful tune with their various musical instruments: harps and lyres and cymbals."
,"17":"The Levites then appointed Heman son of Joel, Asaph son of Berechiah, one of his brothers, Ethan son of Kushaiah, one of their Merarite kinsmen;"
,"18":"and with them, next in rank, their kinsmen as keepers of the gate: Zechariah son of Jaaziel, Shemiramoth, Jehiel, Unni, Eliab, Benaiah, Maaseiah, Mattithiah, Eliphelehu, Mikneiah, Obed-edom, Jeiel."
,"19":"Heman, Asaph and Ethan the cantors, were to clash the cymbals of bronze;"
,"20":"Zechariah, Jaaziel, Shemiramoth, Jehiel, Unni, Eliab, Maaseiah and Benaiah were to play the keyed harp."
,"21":"Mattithiah, Eliphelehu, Mikneiah, Obed-edom, Jeiel and Azaziah, giving the beat, were to play the octave lyre."
,"22":"Chenaniah was chosen to be in charge of the transportation, because he was very skillful at doing these things."
,"23":"Berechiah and Elkanah were to be gatekeepers to the ark."
,"24":"The priests Shebaniah, Joshaphat, Nethanel, Amasal, Zechariah, Benaiah and Eliezer were to sound the trumpet before the ark of God. Obed-edom and Jehiah were to be gatekeepers to the ark."
,"25":"So David, with the leaders of Israel and the commanders of thousands, went to bring up the ark of the covenant of Yahweh from Obed-edom's house with great rejoicing."
,"26":"And while God was securing the Levites who carried the ark of the covenant of Yahweh, they sacrificed seven bulls and seven sheep."
,"27":"David was wearing a robe of fine linen, like all the Levites who carried the ark, as well as the cantors and Chenaniah, the officer in charge of its transportation. David also wore the linen."
,"28":"Thus all Israel brought up the ark of the covenant of Yahweh with shouts of joy to the sound of the horn, trumpets, and cymbals, making music with harp and lyre."
,"29":"Now as the ark of the covenant of Yahweh entered the City of David, Michal the daughter of Saul was watching from the window and saw King David dancing and leaping with joy and she despised him."
}`)
	CurrentBook.AddChapter(16, `{
"1":"They brought the ark of God in and put it inside the tent that David had prepared for it; and they offered burnt offerings and peace offerings to God."
,"2":"And when David had finished offering the sacrifices, he blessed the people in the name of Yahweh."
,"3":"He then distributed to all the Israelites, men and women, a loaf of bread each, a piece of roasted meat, and a raisin cake."
,"4":"David appointed some of the Levites to minister before the ark of Yahweh, to commemorate, thank and praise Yahweh, the God of Israel:"
,"5":"first Asaph, second Zechariah, then Uzziel, Shemiramoth, Jehiel, Mattithiah, Eliab, Benaiah, Obed-edom, Jeiel. These were to play the harp and the lyre, while Asaph was to clash the cymbals."
,"6":"The priests Benaiah and Jahaziel were to keep sounding the trumpet before the ark of the covenant of Yahweh."
,"7":"That day, David entrusted this song of praise to Asaph and his brethren:"
,"8":"Give thanks to Yahweh, call upon his name, proclaim his deeds to the peoples."
,"9":"Sing to him, sing his praise; tell of all his marvels."
,"10":"Glory in his holy name, let the hearts that seek Yahweh rejoice!"
,"11":"Seek Yahweh and his strength, seek his face untiringly;"
,"12":"Recall the wondrous deeds he has done, his miracles, the judgments from his mouth."
,"13":"Descendants of Israel his servant, sons of Jacob his chosen one,"
,"14":"he is Yahweh our God; he rules over all the earth."
,"15":"He remembers his covenant forever, his promises for many generations,"
,"16":"the covenant he made with Abraham, his promise to Isaac,"
,"17":"That he gave as law to Jacob, an everlasting covenant for Israel."
,"18":"For he said, 'I give you a land Canaan, your own possession,'"
,"19":"when they were easily counted, few in number, strangers to the country."
,"20":"They wandered from nation to nation, from one kingdom to another."
,"21":"But he let no one oppress them, and punished kings for their sake:"
,"22":"'Do not touch my anointed ones, do not harm my prophets.'"
,"23":"Sing to Yahweh, all the earth. Proclaim his salvation day after day."
,"24":"Tell his glory among the nations and his wonders to every people."
,"25":"Yahweh is great, and highly to be praised, more fearsome than all gods."
,"26":"Nothingness are all the gods of the nations, Yahweh himself made the heavens;"
,"27":"splendor and majesty go before him, praise and joy are in his sanctuary."
,"28":"Give to Yahweh, families of the peoples, give to Yahweh glory and praise."
,"29":"Give to Yahweh the glory due his name. Bring out offerings and bow before him, worship Yahweh in his sacred ornaments."
,"30":"Be quiet before him, all the earth! Firm has he made the world, not to be moved."
,"31":"Let the heavens be glad, and the earth rejoice! Say among the nations, 'Yahweh is King!'"
,"32":"Let the sea thunder and all that it holds, let the fields exult and all that is in them,"
,"33":"let all the trees cry out for joy, and rejoice before Yahweh, for he comes to rule the earth."
,"34":"Give thanks to Yahweh, for he is good, his love endures forever."
,"35":"Say, 'Save us, O God, our Savior, gather us and deliver us from among the nations, that we may give thanks to your holy name and glory in praising you.'"
,"36":"Blessed be Yahweh the God of Israel from all eternity and forever! And let all the people say, 'Amen! Alleluia!'"
,"37":"David left there, before the ark of the Covenant of Yahweh, Asaph and his brother Levites with the permanent charge of the worship that was held before the ark as each day's ritual required."
,"38":"He left also Obed-edom, with his sixty-eight kinsmen. Obed-edom son of Jeduthun, and Hosah were to be keepers of the gate."
,"39":"He left Zadok the priest and the priests, his kinsmen, before the Holy Tent of Yahweh at the High place in Gibeon"
,"40":"to offer burnt offerings to Yahweh regularly, morning and evening, on the altar for burnt offerings and to carry out all that is written in the Law of Yahweh laid down for Israel."
,"41":"With them were Heman and Jeduthun and the rest of those who were chosen and assigned by name to give praise to God, 'For his love is everlasting.'"
,"42":"With them were Heman and Jeduthun who were to sound the trumpets, cymbals and musical instruments accompanying the hymns to God. The sons of Jeduthun were given charge of the gate."
,"43":"Then all went away, each to his own house, and David returned to bless his household."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Once David was living in his palace, he said to the prophet Nathan, 'Here am I living in a house of cedar, while the ark of Yahweh's covenant dwells beneath a tent cloth.'"
,"2":"Nathan said to David, 'Do all that is in your mind, for God is with you.'"
,"3":"But that very night Yahweh said to Nathan,"
,"4":"'Go and tell my servant David, 'Yahweh says this: You yourself are not to build a temple for me to live in."
,"5":"I have never lived in a temple from the day I brought Israel out until today, but went from tent to tent, from one shelter to another."
,"6":"In all my journeying with the whole of Israel, did I say to any one of the rulers of Israel whom I had appointed as shepherds of my people: Why do you not build me a temple of cedar wood?"
,"7":"This you must say to my servant David: This is the word of Yahweh Sabaoth: I took you from following the sheep, to be leader of my people Israel."
,"8":"I have been with you wherever you have gone, and I have defeated all your enemies as you advanced. I will make your name as great as the name of the greatest on earth."
,"9":"I will provide a place for my people Israel; I will plant them there and they shall live in that place and never be disturbed again; nor shall the wicked ever again oppress them, as they did"
,"10":"in the days when I appointed judges over my people Israel. For now I will subdue all their enemies. Moreover I tell you that I will build you a house."
,"11":"And when your days are ended and you must die and be buried with your ancestors, I will raise up your offspring after you, one of your own sons, and I will make his kingdom strong."
,"12":"He will build a temple for me and I will make his throne firm forever."
,"13":"I will be a father to him and he a son to me. I will not withdraw my support from him, as I withdrew it from Saul."
,"14":"I will put him in charge of my people and his kingdom shall be established forever.'"
,"15":"Nathan told David accordingly all these words and this vision."
,"16":"King David then went in and, seated before Yahweh, said: 'I am not worthy of what you have already done for me, Yahweh God, nor is my family."
,"17":"Yet in your eyes, O God, this is still not enough. For you have made a promise for my descendants reaching into the distant future and you have looked on me as a great man."
,"18":"What more can I say to you? For you know your servant David."
,"19":"You yourself have done this because you have looked kindly on your servant and you wanted to show your own greatness."
,"20":"O Yahweh, there is none like you, no God except you alone, that we have ever heard of."
,"21":"Is there another people on the earth like your people Israel, whom you rescued from slavery in Egypt to make them your own people, giving yourself a name for great and terrible things by driving nations out before your people whom you rescued from Egypt?"
,"22":"You made your people Israel your own people forever; and you, Yahweh, have become their God."
,"23":"Now, Yahweh, let the promise you have made to me and to my descendants be always kept."
,"24":"May this promise hold good and your name be exalted forever; may they say, 'Yahweh Sabaoth, the God of Israel, is God for Israel.' And let my descendants be established before you forever."
,"25":"O my God, you have just made known to me that you will build me a house; because of this I have to offer this prayer in your presence."
,"26":"Yes, Yahweh, you are God indeed, and you have made this kind promise to me."
,"27":"Be pleased, then, to bless my house so that they may remain forever in your favor. You, Yahweh, are the one who blesses, and your blessing will rest on them forever.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"After this, David defeated the Philistines and subdued them, taking Gath and its outlying villages."
,"2":"He also defeated the Moabites; the Moabites became subject to David, paying him taxes."
,"3":"At Hamath David defeated Hadadezer, king of Zobah, who was trying to gain control of the territory by the river Euphrates."
,"4":"David captured one thousand chariots, seven thousand horsemen and twenty thousand foot soldiers from him; David hamstrung all the chariot teams, keeping only a hundred of them."
,"5":"The Arameans of Damascus came to the help of Hadadezer, king of Zobah, but David killed twenty-two thousand men of the Arameans."
,"6":"Then David established governors in Aram of Damascus, and the Arameans became subject to David, paying him taxes. Wherever David went, Yahweh gave him victory."
,"7":"David took the golden shields of the guards of Hadadezer and brought them to Jerusalem."
,"8":"From Tibhath and from Cun, towns belonging to Hadadezer, David took a great quantity of bronze; with this Solomon would make the bronze Sea and the bronze pillars and furnishings."
,"9":"When Tou, king of Hamath, heard that David had defeated the entire army of Hadadezer, king of Zobah,"
,"10":"he sent his son Hadoram to King David to greet him and to congratulate him on fighting and defeating Hadadezer, since Hadadezer was the enemy of Tou. Hadoram brought articles of every kind in gold, silver and bronze,"
,"11":"which King David also consecrated to Yahweh together with the silver and gold he had taken from all the nations: Edom, Moab, Ammonites, Philistines, Amalek."
,"12":"After that David defeated the Edomites in the Valley of Salt, eighteen thousand of them."
,"13":"He imposed governors on Edom, and all the Edomites became subject to David. Wherever David went, Yahweh gave him victory."
,"14":"David ruled over all Israel, administering law and justice to all his people."
,"15":"Joab son of Zeruiah was in command of the army; Jehoshapat son of Ahilud was recorder;"
,"16":"Zadok son of Ahitub and Abiathar son of Ahimelech were priests; Shavsha was secretary;"
,"17":"Benaiah son of Jehoiada was in command of the Cheretites and Pelethites; David's sons were the chief assistants of the King."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Afterwards Nahash, king of the Ammonites, died and his son Hanun became king."
,"2":"David thought, 'I will show kindness to Hanun, son of Nahash, since his father was kind to me.' And David sent messengers with his condolences on his father's death. But when David's servants reached Hanun in the land of the Ammonites to present these condolences,"
,"3":"the Ammonite leaders said to Hanun, 'Do you think David means to honor your father when he sends you messengers of sympathy? On the contrary he has sent them here as spies to explore the land, so that he can conquer it.'"
,"4":"Hanun had David's servants seized, shaved their beards, cut their clothes half-way up to the hips and sent them away."
,"5":"As soon as David was told what had happened to these men, he sent someone to meet them, for the men were too ashamed to return home. And he said, 'Stay in Jericho, until your beards have grown again, and come back then.'"
,"6":"The Ammonites saw that they had made David their enemy and so Hanun and the Ammonites sent a thousand talents of silver to hire chariots and charioteers from the Aramaeans of Upper Mesopotamia, of Maacah and of Zobah."
,"7":"They hired thirty-two thousand chariots; also the king of Maacah with his army. These came and encamped before Medeba, while the Ammonites came out from all their cities and got ready to fight."
,"8":"When David heard this, he sent Joab with the whole army and the warriors."
,"9":"The Ammonites marched out and took up their positions at the entrance to the town, but the kings who had come remained in the open country."
,"10":"Joab, seeing that he had to fight on two fronts, to his front and to his rear, chose the best fighters of the Israelites and drew them up in line facing the Aramaeans."
,"11":"He placed the rest of the troops under the command of his brother Abishai, to face the Ammonites. He said to him,"
,"12":"'If the Aramaeans prove too strong for me, you shall come to my help; if the Ammonites prove too strong for you, I will come to yours."
,"13":"Take courage and fight hard for the sake of our people and the towns of our God. And may Yahweh do as he thinks right.'"
,"14":"Joab and the force with him advanced to attack the Aramaeans,who fled before him."
,"15":"When the Ammonites saw that the Aramaeans were running away, they too fled before Abishai, Joab's brother, and withdrew into their town. Then Joab came back to Jerusalem."
,"16":"Seeing that they had been defeated by Israel, the Aramaeans sent messengers and mobilized the Aramaeans from beyond the river, with Shophach, commander of Hadadezer's army, at their head."
,"17":"News of this was brought to David, who gathered the Israelite troops, crossed the Jordan, and met them. David drew up his line of battle facing the Aramaeans, and the fighting began."
,"18":"But the Aramaeans fled before Israel, and David killed seven thousand of their chariot teams and forty thousand foot soldiers. He also killed Shophach, their general."
,"19":"When the kings who were subject to Hadadezer saw that they had been defeated by Israel, they made peace with David and became subject to him. After this the Aramaeans refused to give help to the Ammonites."
}`)
	CurrentBook.AddChapter(20, `{
"1":"At the turn of the year, the time when kings go to war, Joab set out with the army to invade the land of the Ammonites and went to lay siege to Rabbah. David, however, remained in Jerusalem. Joab attacked Rabbah and destroyed it."
,"2":"David took the gold crown from the head of the Ammonite idol Milcom; they found that it weighed about seventy five pounds. In it was set a precious stone which made an ornament for David's head. He carried off a great quantity of loot from the town."
,"3":"He brought away its population and set them to work with saws, iron picks and axes. David treated all the Ammonite towns in the same way. Then David and the whole army returned to Jerusalem."
,"4":"After this, war broke out again with the Philistines at Gezer. This was when Sibbecai of Hushah killed Sippai, a descendant of the Rephaim. The Philistines were defeated."
,"5":"War with the Philistines broke out again, and Elhanan son of Jair killed Lahmi, the brother of Goliath of Gath, the shaft of whose spear was as thick as a weaver's beam."
,"6":"There was another battle at Gath, where there was a giant with six fingers on each hand and six toes on each foot, twenty-four in all. He too was a descendant of Raphaim."
,"7":"He defied Israel and Jonathan, son of David's brother Shimea, killed him."
,"8":"These men were descended from Raphaim of Gath and they were killed by David and his guards."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Satan wanted to bring trouble on the people of Israel and so he made David take a census of the Israelites."
,"2":"David said to Joab and to the senior army officers, 'Go, and take a census of Israel, from Beersheba to Dan, then come back that I may know their number.'"
,"3":"Joab said, 'May Yahweh multiply the people a hundred times! My lord king, are they not all your servants? Why do you want to do this? Will you bring guilt upon Israel?'"
,"4":"But the king enforced his order on Joab, and Joab went away, traveling through the whole country of Israel before he returned to Jerusalem."
,"5":"Joab gave David the figures for the census of the people: the whole of Israel numbered one million, one hundred thousand men capable of drawing sword, and Judah four hundred and seventy thousand capable of drawing sword."
,"6":"But Joab disapproved of the king's command, and, because of this he had not taken any census of Levi or of Benjamin."
,"7":"God looked with displeasure on what had been done and so he began to punish Israel."
,"8":"Then David said to God, 'I have sinned greatly by doing this. But now I beg you to forgive me for this fault. I have been very foolish.'"
,"9":"Then Yahweh spoke to Gad, David's prophet,"
,"10":"'Go and say to David, 'Yahweh says this: I offer you three things; choose one of them for me to do to you.'"
,"11":"So Gad went to David and said, 'Yahweh says this, 'Take your choice:"
,"12":"three years of famine, three months running away from the armies of your enemies, or three days of Yahweh's own sword, an epidemic in your land, with Yahweh's destroying angel bringing death throughout Israel.' Now decide how I am to answer him who sends me.'"
,"13":"David said to Gad, 'This is a hard choice, but let me rather fall into the power of Yahweh, since his mercy is very great; and not into the power of men.'"
,"14":"So Yahweh sent an epidemic on Israel, and seventy thousand men of the Israelites died."
,"15":"God sent the angel to Jerusalem to destroy it, but as he was about to destroy it, Yahweh looked and changed his mind; and he said to the destroying angel, 'Enough! Now withdraw your hand.' The angel of Yahweh was standing beside the threshing floor of Ornan the Jebusite."
,"16":"David saw the angel of Yahweh standing between the heavens and earth with a naked sword in his hand, ready to destroy Jerusalem. Then David and the elders, clothed in sackcloth, fell on their faces."
,"17":"And David prayed to God, 'Was it not I who sinned, by ordering this wicked census? But these, this flock, what have they done? Yahweh my God, let your hand lie heavy on me and on my family; but let your people escape the plague.'"
,"18":"The angel of Yahweh then said to Gad, 'David must go up and build an altar to Yahweh on the threshing floor of Ornan the Jebusite.'"
,"19":"So David obeyed the command which Gad had spoken in the name of Yahweh."
,"20":"Now Ornan, as he turned, had seen the angel and had hidden, with his four sons. Ornan was threshing wheat "
,"21":"when David came to him. When Ornan looked up and saw David coming, he left the threshing floor and with his face to the ground did homage to David."
,"22":"Then David said to Ornan, 'Sell me your threshing floor, to build an altar to Yahweh. Let me have it at its full price, that the plague may be turned away from the people.'"
,"23":"'Take it,' Ornan said to David, 'and let my lord the king do as he thinks right. Look, I will give you the oxen for burnt offerings, the threshing sled for the wood and the wheat for the grain offering; I give them all.'"
,"24":"But King David said to Ornan, 'No, I must buy it from you at the full price; I will not take for Yahweh what is yours, or offer burnt offerings that cost me nothing.'"
,"25":"So David gave Ornan six hundred gold coins for the threshing place."
,"26":"David built an altar there to Yahweh and offered burnt offerings and peace offerings. He called on Yahweh, and Yahweh answered him with fire from heaven on the altar for burnt offerings"
,"27":"and ordered the angel to put his sword away."
,"28":"Then David saw that Yahweh had answered him on the threshing floor of Ornan the Jebusite, so he kept on offering sacrifices there."
,"29":"The Holy Tent of Yahweh that Moses had made in the wilderness and the altar for burnt offerings were at that time at the High place at Gibeon,"
,"30":"but David had not been able to go there before God to consult him, so fearful was he of the sword of the angel of Yahweh."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Then David said, 'Here is where the Temple of Yahweh God will be; and this is where the people of Israel are to offer burnt offerings.'"
,"2":"David gave orders to gather all the strangers living in the land of Israel and he set stonecutters to prepare stone blocks for building the Temple of God."
,"3":"David furthermore stored up great quantities of iron to make nails for the wooden gates and for clamps, and more bronze than could be weighed;"
,"4":"logs of cedar too, beyond number, the Sidonians and Tyrians having brought cedar logs to David in great quantities."
,"5":"Then David said, 'My son Solomon is young and inexperienced, and the Temple to be built for Yahweh must be of great splendor, and famous for its magnificence in every country. I will make preparations for him.' And so, before he died, David laid away large amounts of the materials needed."
,"6":"He then sent for his son Solomon and instructed him to build a Temple for Yahweh, the God of Israel,"
,"7":"'My son, my heart was set on building a temple for the name of Yahweh my God."
,"8":"But Yahweh told me, 'You have shed much blood and fought great battles; it is not for you to build a temple for my name, since you have shed so much blood on the earth in my presence."
,"9":"But now a son is born to you. He shall be a man of peace, and I will give him peace from all the enemies that surround him; for Solomon is his name, and in his days I will give Israel peace and quiet."
,"10":"He shall build a temple for my name; he shall be a son to me and I a father to him. His dynasty will rule Israel forever."
,"11":"Now, my son, may Yahweh be with you and give you success in building a temple for Yahweh your God, as he has said concerning you."
,"12":"Yet may he give you insight and wisdom so that you may govern Israel according to his Law."
,"13":"Success will be yours if you carefully observe the statutes and the ordinances that Yahweh has prescribed to Moses for Israel. Be strong and stand fast, be fearless, be confident."
,"14":"Poor as I am, I have set aside for the Temple of Yahweh four thousand tons of gold, and nearly forty thousand tons of silver and more bronze and iron than can be weighed; I have stored up wood and stone too, to which you must add more."
,"15":"You will have many workmen, stonecutters, masons, carpenters, skilled artisans of every kind,"
,"16":"while your supply of gold and silver, bronze and iron, will be unlimited. Set to work, then, and may Yahweh be with you!'"
,"17":"David then commanded all the Israelite leaders to help his son Solomon,"
,"18":"'Is not Yahweh your God with you? He has given you peace on all sides, since he has let me conquer all the people who lived in this land, and the land has been subdued for Yahweh and for his people."
,"19":"So now devote heart and soul to the search for Yahweh your God. Begin to build the sanctuary of Yahweh your God, so that the ark of the covenant of Yahweh and the holy things of God may be brought to the Temple that is built for the name of Yahweh.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"When David was very old, he made his son Solomon king over Israel."
,"2":"He then gathered all the Israelite leaders together, with the priests and Levites."
,"3":"A census was taken of those Levites thirty years old or older. The total was thirty-eight thousand;"
,"4":"twenty-four thousand of these were responsible for the services of the house of Yahweh; six thousand were scribes and judges;"
,"5":"four thousand were keepers of the gate; four thousand praised Yahweh on the instruments David had made for that purpose."
,"6":"Then David divided the Levites into three groups, according to their clans: Gershon, Kohath and Merari."
,"7":"For the Gershonites: Ladan and Shimei."
,"8":"Sons of Ladan: Jehiel first, Zetham, Joel; three in all."
,"9":"Sons of Shimei: Shelomoth, Haziel, Haran; three in all. These are the heads of families of Ladan."
,"10":"Sons of Shimei: Jahath, Zirah, Jeush, Beriah; these were the sons of Shimei; four in all."
,"11":"Jahath was the eldest, Zirah the second, then Jeush and Beriah, who had not many children and were counted as one family."
,"12":"Sons of Kohath: Amram, Izhar, Hebron, Uzziel; four in all."
,"13":"Sons of Amram: Aaron and Moses. Aaron and his descendants were set apart to be in charge of the sacred objects forever, to burn incense in the presence of Yahweh, to serve him and to bless the people in his name forever."
,"14":"As for Moses, the man of God, his sons were included among the Levites."
,"15":"Sons of Moses: Gershom and Eliezer."
,"16":"Sons of Gershom: Shebuel, the first:"
,"17":"Eliezer had sons: Rehabiah, the first. Eliezer had no other sons, but the sons of Rehabiah were very numerous."
,"18":"Sons of Izhar: Shelomith, the first."
,"19":"Sons of Hebron: Jeriah first, Amariah second, Jahaziel third, Jekameam fourth."
,"20":"Sons of Uzziel: Micah first, Isshiah second."
,"21":"Sons of Merari: Mahli and Mushi. Sons of Mahli: Eleazar and Kish."
,"22":"Eleazar died leaving no sons but only daughters; their cousins, the sons of Kish, married these."
,"23":"Sons of Mushi: Mahli, Eder, Jeremoth; three in all."
,"24":"These were the sons of Levi by their families, the heads of families, and those registered by name, individually; whoever was twenty years old or older had his duty in the service of the Temple of Yahweh."
,"25":"For David had said, 'Yahweh, the God of Israel, has given peace to his people, and he dwells in Jerusalem forever."
,"26":"The Levites are no longer required to carry the Holy Tent or anything used in its service.'"
,"27":"According to the last words of David, the Levites who had been registered were of twenty years and older."
,"28":"Their duty is to assist the sons of Aaron with the service of the Temple of Yahweh, in the courts and chambers, to purify everything that is sacred; their duty is to serve the Temple of God."
,"29":"They are also responsible for the loaves set out in rows, and for the flour for the grain offering, the wafers of unleavened bread, the cakes baked on the griddle or mixed, and they are to weigh and measure the Temple offerings."
,"30":"They have to be present every morning to give glory and praise to Yahweh, and also in the evening,"
,"31":"and at every burnt offering to Yahweh on the sabbath, New Moon or solemn feast, in such numbers as are prescribed. They must always be present before Yahweh."
,"32":"In serving the Temple of Yahweh they observe the ritual of the Tent of Meeting, the ritual of the sanctuary and the ritual of their brethren, the sons of Aaron."
}`)
	CurrentBook.AddChapter(24, `{
"1":"These are the groups to which the descendants of Aaron belong. Sons of Aaron: Nadab, Abihu, Eleazar, Ithamar."
,"2":"Nadab and Abihu died in their father's lifetime leaving no children, so Eleazar and Ithamar became priests."
,"3":"David divided them into groups with the help of Zadok, one of Eleazar's sons, and Ahimelech, one of the sons of Ithamar, and made a register of them according to their duties."
,"4":"The sons of Eleazar were found to have more leading men than the sons of Ithamar; accordingly, from the heads of families of the sons of Eleazar they made sixteen groups, and from those of the sons of Ithamar, eight."
,"5":"They divided them, both parties, by lot: there were Temple officials and spiritual leaders among the sons of Eleazar, as well as among the sons of Ithamar."
,"6":"One of the Levites, the scribe Shemaiah son of Nethanel, recorded them in the presence of the king, his officers, Zadok the priest, Ahimelech son of Abiathar and the heads of the priestly and levitical families. They took turns in drawing lots for each family of the sons of Eleazar and for the sons of Ithamar."
,"7":"The first lot fell to Jehoiarib, to Jedaiah the second,"
,"8":"Harim the third, Seorim the fourth,"
,"9":"Malchijah the fifth, Mijamin the sixth,"
,"10":"Hakkoz the seventh, Abijah the eighth,"
,"11":"Jeshua the ninth, Shecaniah the tenth,"
,"12":"Eliashib the eleventh, Jakim the twelfth,"
,"13":"Huppah the thirteenth, Ishbaal the fourteenth,"
,"14":"Bilgah the fifteenth, Immer the sixteenth,"
,"15":"Hezir the seventeenth, Happizzez the eighteenth,"
,"16":"Pethahiah the nineteenth, Jehezkel the twentieth,"
,"17":"Jachin the twenty-first, Gamul the twenty-second,"
,"18":"Delaiah the twenty-third, Maaziah the twenty-fourth."
,"19":"These men were registered according to their various duties, to enter the Temple of Yahweh according to the regulations that Yahweh, the God of Israel, had given through Haran, their ancestor."
,"20":"As regards the rest of the sons of Levi: Sons of Amram: Shubael. Sons of Shubael: Jehdeiah. "
,"21":"For Rehabiah, for the sons of Rehabiah: the eldest, Isshiah."
,"22":"Izharites: Shelomoth: Jahath."
,"23":"Sons of Hebron: Jeriah the first, Amariah the second, Jahaziel the third, Jekameam the fourth."
,"24":"Sons of Uzziel: Micah; sons of Micah: Shamir;"
,"25":"the brother of Micah: Isshiah; sons of Micah: Isshiah, Zechariah."
,"26":"Sons of Merari: Mahli and Mushi. Sons of Jaaziah: his son;"
,"27":"sons of Merari: for Jaaziah his son: Shoham, Zaccur, Ibri:"
,"28":"for Mahli: Eleazar who had no sons;"
,"29":"for Kish: the sons of Kish: Jerahmeel."
,"30":"Sons of Mushi: Mahli, Eder, Jerimoth."
,"31":"These were the sons of Levi by their families. The head of each family and one of his younger brothers drew lots for their assignments, just as their relatives, the priests descended from Aaron, had done. King David, Zadok, Ahimelech, and the heads of families of the priests and of the Levites were witnesses."
}`)
	CurrentBook.AddChapter(25, `{
"1":"For the liturgy, David and the senior army officers set apart the sons of Asaph, of Heman and of Jeduthun, who prophesied playing lyre and harp and cymbal, and a list was made of those with these duties to perform."
,"2":"Sons of Asaph: Zaccur, Joseph, Nethaniah, Asharelah; the sons of Asaph were under the direction of Asaph who prophesied whenever the king commanded."
,"3":"For Jeduthun: sons of Jeduthun: Gedaliah, Zeri, Jeshaiah, Hashabiah, Mattithiah; there were six of them under the direction of their father Jeduthun who, to the sound of the lyre, sang praise and thanks to the Lord."
,"4":"For Heman: sons of Heman: Bukkiah, Mattaniah, Uzziel, Shebuel, Jerimoth, Hananiah, Hanani, Eliathah, Giddalti, Romantiezer, Joshbekashah, Mallothi, Hothir, Mahazioth."
,"5":"All these were sons of Heman, the king's seer; these sounded the trumpet when Yahweh's word came. God gave Heman fourteen sons and three daughters;"
,"6":"all of them sang in the Temple of Yahweh under their father's direction to the sound of cymbal, harp and lyre, for the liturgy in the house of Yahweh at the king's direction."
,"7":"All of these, whether of Asaph, Jeduthun or Heman, who were trained in singing to Yahweh, all of them skilled men, were altogether two hundred and eighty-eight."
,"8":"They drew lots to determine the assignment of duties of each of them whether they were young or old, experts or beginners."
,"9":"The first lot fell to the Asaphite, Joseph. The second was Gedaliah, he and his sons and brothers were twelve."
,"10":"The third was Zaccur, he and his sons and brothers were twelve."
,"11":"The fourth was Izri, he and his sons and brothers were twelve."
,"12":"The fifth was Nethaniah, he and his sons and brothers were twelve."
,"13":"The sixth was Bukkiah, he and his sons and brothers were twelve."
,"14":"The seventh was Jesharelah, he and his sons and brothers were twelve."
,"15":"The eighth was Jeshaiah, he and his sons and brothers were twelve."
,"16":"The ninth was Mattaniah, he and his sons and brothers were twelve."
,"17":"The tenth was Shimei, he and his sons and brothers were twelve."
,"18":"The eleventh was Azarel, he and his sons and brothers were twelve."
,"19":"The twelfth was Hashabiah, he and his sons and brothers were twelve."
,"20":"The thirteenth was Shubael, he and his sons and brothers were twelve."
,"21":"The fourteenth was Jeremoth, he and his sons and brothers were twelve."
,"22":"The fifteenth was Mattithiah, he and his sons and brothers were twelve."
,"23":"The sixteenth was Hananiah, he and his sons and brothers were twelve."
,"24":"The seventeenth was Joshbekashah, he and his sons and brothers were twelve."
,"25":"The eighteenth was Hanani, he and his sons and brothers were twelve."
,"26":"The nineteenth was Mallothi, he and his sons and brothers were twelve."
,"27":"The twentieth was Eliathah, he and his sons and brothers were twelve."
,"28":"The twenty-first was Hothir, he and his sons and brothers were twelve."
,"29":"The twenty-second was Giddalti, he and his sons and brothers were twelve."
,"30":"The twenty-third was Mahazioth, he and his sons and brothers were twelve."
,"31":"The twenty-fourth was Romamtiezer, he and his sons and brothers were twelve."
}`)
	CurrentBook.AddChapter(26, `{
"1":"These are the assignments of work for the Levites who served as Temple guards. For the Korahites: Meshelemiah son of Kore, one of the sons of Ebiasahp."
,"2":"Meshelemiah had sons: Zechariah the firstborn, Jediael the second, Zebadiah the third, Jathniel the fourth,"
,"3":"Elam the fifth, Jehohanan the sixth, Eliehoenai the seventh."
,"4":"Obed-edom had sons: Shemaiah the firstborn, Jehozabad the second, Joah the third, Sacar the fourth, Nethanel the fifth,"
,"5":"Ammiel the sixth, Issachar the seventh, Peullethai the eighth; God had indeed blessed him."
,"6":"Shemaiah had sons who were important men in their clan because of their great ability."
,"7":"Sons of Shemaiah: Othni, Rephael, Obed, Elzabad and his brothers, Elihu and Semachia, brave men."
,"8":"All these were sons of Obed-edom. These and their sons and brothers were highly qualified for this work. For Obed-edom, sixty-two."
,"9":"Meshelemiah had sons and brothers: eighteen brave men."
,"10":"Hosah, son of Merari, had sons: Shimri was the first, for although he was not the firstborn his father had made him the chief."
,"11":"Hilkiah was the second, Tebaliah the third, Zechariah the fourth. Altogether thirteen members of Hosah's family were Temple guards."
,"12":"The Temple guards were divided into groups, according to their families, and they were assigned duties in the Temple, just as the other Levites were."
,"13":"They drew lots, junior and senior family alike, to see which gate it would be responsible for."
,"14":"For the east side the lot fell to Shelemiah, whose son Zechariah was a shrewd counselor; when they drew lots, the lot for the north side fell to the latter."
,"15":"To Obed-edom went the south, and to his sons the storehouse."
,"16":"To Shuppim and Hosah went the west with the Gate of the Felled Treetrunk on the upper road. Watches were established for each family."
,"17":"On the east, six daily; on the north, four daily; on the south, four daily; at the storehouse, two each side;"
,"18":"for the Parbar."
,"19":"These were the orders of the gatekeepers among the Korahites and Merarites."
,"20":"Others of their fellow Levites were in charge of the Temple Treasury and the storerooms for gifts dedicated to God."
,"21":"The sons of Ladan, sons of Gershon, through Ladan had the Jehielites for heads of the families of Ladan the Gershonite."
,"22":"The Jehielites, Zetham and Joel his brother, were responsible for the treasuries of the Temple of Yahweh."
,"23":"As regard the Amramites, Izharites, Hebronites, and Uzzielites;"
,"24":"Shebuel son of Gershom, son of Moses, was the officer responsible for the treasuries."
,"25":"His kinsmen through Eliezer: Rehabiah his son, Jeshaiah his son, Joram his son, Zichri his son, Shelomoth his son."
,"26":"This Shelomoth and his kinsmen were in charge of all the gifts dedicated to Yahweh by King David and by the heads of families as officers of thousands, of hundreds, or as other senior officers."
,"27":"There was a part of the loot they captured in battle and dedicated for use in the Temple"
,"28":"and also the things that Samuel and the seer Saul son of Kish, Abner son of Ner, and Joab son of Zeruiah had dedicated. All that had been dedicated was under the responsibility of Shelomoth and his kinsmen."
,"29":"For the Izharites: Chananiah and his sons were in charge of Israel's civil affairs as officials and judges."
,"30":"For the Hebronites: Hashabiah and his kinsmen, one thousand seven hundred fighting men, were appointed as overseers of all Israel west of Jordan, for all the service of Yahweh and the service of the king."
,"31":"For the Hebronites: Jerijah the chief. In the fortieth year of David's reign, the family line of the Hebronite families was investigated and fighting men were found belonging to them at Jazer in Gilead."
,"32":"King David appointed two thousand seven hundred fighting men, kinsmen to Jerijah and heads of families, as overseers of the Reubenites, the Gadites and the half tribe of Manasseh for all the service of Yahweh and the sacrifices of the king."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Census of the sons of Israel; The heads of families, the commanders of thousands and hundreds, and other officers who served the king in all that referred to the divisions of twenty-four thousand men each, that were on duty for a month, each month of the year."
,"2":"For the first month Jashobeam, son of Zabdiel,"
,"3":"son of Perez, and chief of all the officers of the division had charge of a division of twenty-four thousand men."
,"4":"For the second month Dodai, the Ahohite had charge of a division of twenty-four thousand men."
,"5":"For the third month Benaiah son of Jehoiada, the chief priest, had charge of a division of twenty-four thousand men."
,"6":"Benaiah who was champion of The Thirty, was overseer for The Thirty and for his division. Ammizabad was his son."
,"7":"For the fourth month was Asahel, the brother of Joab; his son Zebadiah succeeded him. He had charge of a division of twenty-four thousand men."
,"8":"For the fifth month, Shamhuth the Izrahite had charge of a division of twenty-four thousand men."
,"9":"For the sixth month, Ira son of Ikkesh of Tekoa had charge of a division of twenty-four thousand men."
,"10":"For the seventh month, Helez the Pelonite, an Ephraimite, had charge of a division of twenty-four thousand men."
,"11":"For the eighth month, Sibbecai of Hushah, a Zerahite, had charge of a division of twenty-four thousand men."
,"12":"For the ninth month, Abiezer of Anathoth, a Benjaminite, had charge of a division of twenty-four thousand men."
,"13":"For the tenth month, Maharai of Netophah, a Zerahite, had charge of a division of twenty-four thousand men."
,"14":"For the eleventh month, Benaiah of Pirathon, an Ephraimite, had charge of a division of twenty-four thousand men."
,"15":"For the twelfth month, Heldai from Netophah, of Othniel, had charge of a division of twenty-four thousand men."
,"16":"Overseers for the tribes of Israel: Eliezer son of Zichri was chief officer for the Reubenites, Shephatiah, son of Maacha for the Simeonites,"
,"17":"Hashabiah, son of Kemuel for the Levites, Zadok for the Aaronites,"
,"18":"Elihu, one of David's brothers, for the Judaeans, Omri son of Michael for the Issacharites,"
,"19":"Ishmaiah, son of Obadiah for the Zebulunites, Jeremoth, son of Azriel for the Naphtalite,"
,"20":"Hoshea, son of Azaziah for the Ephraimites, Joel, son of Pedaiah for the half tribe of Manasseh,"
,"21":"Iddo, son of Zechariah for the half tribe of Manasseh in Gad, Jaasiel, son of Abner for the Benjaminites,"
,"22":"Azarel, son of Jeroham for the Danites. These were the officials for the tribes of Israel."
,"23":"David took no census of those who were twenty years old and under, since Yahweh had promised to make Israel as numerous as the stars of heaven."
,"24":"Joab, son of Zeruiah began a census, but he did not finish it for God punished Israel because of this census. The final figures were never recorded in the official records of King David."
,"25":"This is the list of those who administered the king's property. Overseers for the king's storerooms: Azmaveth son of Adiel. Commissioner for the stores in provincial towns, villages, castles: Jonathan son of Uzziah."
,"26":"For the agricultural workers employed on the land: Ezri son of Chelub."
,"27":"For the vineyards: Shimei of Ramah. For those in the vineyards who looked after the wine cellars: Zabdi of Shepham."
,"28":"For the olives and sycamores in the lowlands: Baal-hanan of Geder. For the stores of oil: Joash."
,"29":"For cattle in pasture at Sharon: Shitrai of Sharon. For cattle in the valleys: Shaphat son of Adlai."
,"30":"For camels: Obil, the Ishmaelite. For donkeys: Jehdeiah of Meranoth."
,"31":"For flocks: Jaziz, the Hagrite. All these were overseers for King David's property."
,"32":"Jonathan, David's uncle, was a skillful adviser and a scholar."
,"33":"Ahithophel was the king's counselor. Hushai the Archite was Friend of the King."
,"34":"Jehoiada, son of Benaiah, and Abiathar succeeded Ahithophel. Joab was commander of the king's armies."
}`)
	CurrentBook.AddChapter(28, `{
"1":"David held a meeting in Jerusalem of all the officials of Israel, the overseers for the tribes, and the officials in the royal service, the commanders of thousands, the commanders of hundreds, the overseers for all the property and livestock of the king and his sons, together with the palace officials, leading soldiers, and important men."
,"2":"Then King David got up and said: 'My brothers and my people, listen to me. I had set my heart on building a settled home for the ark of the covenant of Yahweh, as a footstool for our God. I have made preparations for building, "
,"3":"but God has said to me, 'You are not to build a temple for my name, for you have been a man of war and have shed blood.'"
,"4":"Yahweh, the God of Israel, chose me and my descendants to rule Israel forever. He chose Judah for leader, my family within the tribe of Judah, and of my father's sons, myself. He was pleased to make me king of all Israel."
,"5":"Of all my sons - he has chosen my son Solomon to sit on the throne of Yahweh over Israel."
,"6":"He said to me, 'Solomon your son is the man to build my Temple and my courts, for I have chosen him to be a son to me and I will be a father to him."
,"7":"I will make his kingdom last forever if he continues to obey carefully all my laws and commands as he does now.'"
,"8":"So now in the sight of all Israel and of the assembly of Yahweh, and in the hearing of our God, I tell you to observe and meditate on all the commandments of Yahweh your God, so that you may possess this prosperous land and leave it to your children after you as an inheritance forever."
,"9":"And you, Solomon my son, know the God of your father, serve him with an undivided heart and a willing mind; for Yahweh knows all our thoughts and desires. If you seek him, he will let you find him; but if you turn away from him, he will abandon you forever."
,"10":"Realize at this moment that Yahweh has chosen you to build a house for him as sanctuary. Be strong and set to work.'"
,"11":"David gave his son Solomon the plans for the vestibule, the buildings, the treasuries, the upper rooms, the inner apartments and the room where the mercy Seat would be."
,"12":"He also gave him a description of all he had in mind for the courts of Yahweh's House, all the surrounding apartments, the treasuries of Yahweh's House and the treasuries of votive offerings;"
,"13":"also of the orders of priests and Levites, the liturgical duties in Yahweh's House."
,"14":"He instructed him about how much silver and gold was to be used for making the utensils,"
,"15":"the bullion for the golden lampstands and their lamps, the gold bullion for the silver lampstand, for the lampstand and its lamps according to the requirements for each lampstand,"
,"16":"gold bullion for the tables on which the rows of bread were set, for each of these tables, the silver for the silver tables,"
,"17":"the forks, the sprinkling bowls, basins of pure gold, the gold bullion for the bowls, for each of the bowls,"
,"18":"the bullion of refined gold for the altar of incense. He gave him the plans for the chariot, for the golden cherubim with wings outspread covering the ark of the covenant of Yahweh -"
,"19":"all this in accordance with the plan drawn according to the instructions which Yahweh himself gave him to carry out."
,"20":"Then David said to his son Solomon, 'Be strong, stand firm; be fearless, be determined and set to work, because Yahweh God, my God, is with you. He will not fail you or abandon you before you have finished all the work to be done for the House of Yahweh."
,"21":"Here are the orders of priests and Levites for all the duties of the House of God; every willing man of any aptitude will help you in all this work; the officials and all the people are entirely at your command.'"
}`)
	CurrentBook.AddChapter(29, `{
"1":"Then King David said to the whole assembly, 'Solomon my son, whom Yahweh has chosen, is still young and the work is great; this palace is not for men but for Yahweh God."
,"2":"With all my means, I have provided for the house of my God, adding gold to gold, silver to silver, bronze to bronze, iron to iron, wood to wood, onyx, inlaid stones, colored and striped stones, precious stones of every kind, masses of alabaster."
,"3":"What is more, the gold and silver that I have in my own treasury I give out of love for the house of God, above what I have provided already for the Holy House -"
,"4":"115 tons of the finest gold, gold of Ophir, 265 tons of pure silver for plating the walls of the buildings."
,"5":"Whatever gold you have, whatever silver, or workmanship of the craftsman's hand, will each of you offer it to Yahweh today?'"
,"6":"Then the heads of families, the officials for the tribes of Israel, the commanders of thousands and of hundreds, and those who managed the king's affairs,"
,"7":"gave for the service of the house of God 190 tons of gold, 380 tons of silver, 675 tons of bronze, and 3,750 tons of iron."
,"8":"Those who had precious stones brought them to Jehiel, the Gershonite for the treasury of Yahweh's House."
,"9":"The people rejoiced at what had been given so readily, since their gifts to Yahweh had been made wholeheartedly. King David too was filled with joy."
,"10":"In sight of the whole assembly David blessed Yahweh and said: 'May you be blessed, Yahweh God of Israel our ancestor, forever and ever! "
,"11":"Yours, Yahweh, is the greatness, the power, splendor, length of days, glory, for all that is in the heavens and on the earth is yours. Yours is the sovereignty forever, O Yahweh; you are supreme ruler over all."
,"12":"Riches and honor go before you, you are ruler of all, in your hand lie strength and power; You are the one who gives greatness and strength to all."
,"13":"At this time, our God, we give you thanks, we praise the splendor of your name."
,"14":"For who am I and what is my people to have received all that we give you back now? All comes from you; what we have received from your own hand we have given to you."
,"15":"For we are strangers before you, settlers only, as all our ancestors were; our days on earth pass like a shadow, and there is no hope beyond."
,"16":"Yahweh, our God, all this wealth that we have brought together to build a house for your holy Name, comes from your hand, all is yours."
,"17":"O my God, I know that you examine the heart and delight in honesty, and in honesty of heart I have willingly given all this; and now with joy I have seen your people here offer their gifts willingly."
,"18":"O Yahweh, God of our fathers, Abraham, Isaac, and Israel, keep such thoughts in the hearts and minds of your people forever, and direct their hearts toward you."
,"19":"Give Solomon my son a heart determined to keep your commandments, your decrees, your statutes; may he practice them all, and build this palace I have prepared for you.'"
,"20":"Then David said to the whole assembly, 'Bless now Yahweh your God!' And the whole assembly blessed Yahweh, the God of their ancestors, and went on their knees to give honor to Yahweh and to the king."
,"21":"The following day, the Israelites offered sacrifices and burnt offerings to Yahweh: a thousand bulls, a thousand rams, a thousand lambs with their wine offerings, as well as many sacrifices for the whole of Israel."
,"22":"They ate and drank that day in Yahweh's presence with great joy. Then they made Solomon, son of David, their second king and anointed him to rule over them in the name of Yahweh, and anointed Zadok as priest."
,"23":"Solomon sat on the throne of Yahweh, in place of David his father. He prospered, and all Israel obeyed him."
,"24":"All the officials, all the champions, and even all the sons of King David, swore fidelity to King Solomon."
,"25":"Yahweh exalted Solomon greatly in the eyes of all Israel, and gave him a glorious reign such as had not been enjoyed by any king over Israel before him."
,"26":"David son of Jesse had reigned over the whole of Israel."
,"27":"His reign over Israel had lasted forty years; he had reigned in Hebron for seven years, and in Jerusalem for thirty-three."
,"28":"He died at a good old age, with his fill of days, of riches, of honor. Then his son Solomon succeeded him."
,"29":"The history of King David, from first to last, can be found in the records of Samuel, the prophet, the records of Nathan the prophet, and the records of Gad, the prophet."
,"30":"These records tell how he ruled, how powerful he was, and all the things that happened to him, to Israel, and to the surrounding kingdoms."
}`)

}
func EN_CCB_LoadVH1RChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"King David was already a very old man who could no longer keep warm even in very thick clothing."
,"2":"So his servants said to him, 'They should get for my lord king a virgin girl to attend the king and nurse him. She could sleep with you, my lord king, and make you feel warm.'"
,"3":"And so they looked for a beautiful girl throughout the territory of Israel. They found Abishag the Shunamite, a very beautiful girl and brought her to the king."
,"4":"She attended to him, but the king had no intimate relations with her."
,"5":"Now Adonijah, son of Haggith, had in mind that he would be king and so he provided himself with a chariot and horsemen, and fifty men to run before him."
,"6":"His father had never interfered by questioning his conduct, 'Why have you done this or that?' He was a very handsome man born of Haggith after Absalom."
,"7":"Adonijah conferred with Joab, son of Zuriah, and with Abiathar, the priest. These two sided with him;"
,"8":"but Zadok, the priest, and Benaiah, son of Jehoiada; Nathan, the prophet; Shimei, Rei and David's warriors did not join Adonijah."
,"9":"Adonijah sacrificed sheep, oxen, and fattened calves at the Slipping Stone, beside Engrogel, and invited his brothers, the king's sons, and all the royal officials of Judah to join him;"
,"10":"but not Nathan the prophet or Benaiah, or the warriors, or his brother Solomon."
,"11":"Then Nathan spoke to Bathsheba, mother of Solomon, 'Have you heard that Adonijah, son of Haggith, acts as a king, unknown to David our lord?"
,"12":"Let me then give you advice that could save both your life and Solomon your son."
,"13":"Go, see King David immediately and tell him this, 'Did you not, my lord king, swear to your handmaid that Solomon, my son, would reign after you and sit on your throne? Why then does Adonijah act as king?'"
,"14":"Then, while you are still speaking with the king, I will come in and confirm what you say.'"
,"15":"So Bathsheba went to the king, right into his room. (Now the king was very old, and Abishag the Shunamite was attending to him.)"
,"16":"Bathsheba bowed in homage to the king who asked her, 'What do you want?'"
,"17":"She answered him, 'My lord, you swore to your handmaid by Yahweh your God that Solomon, my son, would reign after you and sit on your throne."
,"18":"But now, Adonijah acts as king without your knowing it, my lord king."
,"19":"He has sacrificed oxen, fattened calves and plenty of sheep, inviting all the king's sons, Abiathar the priest, and Joab, commander of the army; but he did not invite Solomon your servant."
,"20":"And now, my lord king, all Israel is waiting for your decision as to who shall reign as your successor."
,"21":"If this is not known when my lord the king passes away, I and my son Solomon will be numbered among the criminals.'"
,"22":"While she was still speaking with the king, Nathan the prophet arrived"
,"23":"and was announced to the king, 'Here is Nathan the prophet.' When Nathan came in before the king, he bowed before him with his face to the ground,"
,"24":"and said, 'My lord king, have you decided that Adonijah shall reign after you and sit on your throne?"
,"25":"For indeed, today he has gone down to sacrifice oxen, fattened calves and plenty of sheep. He has invited all the king's sons, Joab, the commander of the army, and Abiathar the priest. They are now eating and drinking with him and proclaiming, 'Long live King Adonijah!'"
,"26":"But he has not invited me, your servant, Zadok the priest, Benaiah the son of Jehoiada, nor your servant Solomon."
,"27":"Has my lord king decided this without having told us, your servants, who is to sit on your throne after you?'"
,"28":"King David then answered, 'Call Bathsheba to me.' So she came to the king. As she stood before him,"
,"29":"the king swore an oath and said, 'As Yahweh lives, he who has delivered me from all adversity,"
,"30":"so will I fulfill today the oath I swore to you by Yahweh, the God of Israel, when I said: 'Solomon, your son, shall reign after me; he shall sit on my throne in my place.'"
,"31":"Then Bathsheba bowed with her face to the ground and paid homage to the king as she said, 'May my lord King David live forever!'"
,"32":"King David then said, 'Call Zadok the priest, Nathan the prophet, and Benaiah the son of Jehoiada.' So they came to the king"
,"33":"who said to them, 'Take with you the servants of your lord and make my son Solomon ride on my own mule. Then bring him down to Gihon"
,"34":"and let Zadok the priest and Nathan the prophet anoint him there as king of Israel. Once this is done, sound the horn and proclaim, 'Long live King Solomon!'"
,"35":"Then he shall sit on my throne in your presence. From now on he will be king in my place for I have made him ruler of Israel and Judah.'"
,"36":"Benaiah, son of Jehoiada, answered the king, 'Amen! May Yahweh, the God of my lord king, confirm this."
,"37":"As Yahweh has been with my lord king, may he also be with Solomon and make his reign even greater than that of my lord King David's.'"
,"38":"So Zadok the priest, Nathan the prophet, Benaiah the son of Jehoiada, together with the Cherethites and the Pelethites, went down and made Solomon ride on King David's mule to Gihon."
,"39":"There Zadok the priest took the horn of oil that was in the Holy Tent and anointed Solomon."
,"40":"They then sounded the horn and all the people shouted, 'Long live King Solomon!' They all went up after him playing on pipes; and their shouts were so great that the noise seemed to rent the earth."
,"41":"Adonijah and all his guests heard this as they finished feasting. On hearing the sound of the horn, Joab asked, 'What is all this commotion in the city?'"
,"42":"While he was still speaking, Jonathan, the son of Abiathar the priest, arrived and Adonijah asked, 'Come in, for you are a worthy man and bring good news.'"
,"43":"Jonathan answered Adonijah, 'Not at all, for our lord King David has made Solomon king."
,"44":"The king sent him with Zadok the priest, Nathan the prophet, Benaiah the son of Jehoiada, and the Cherethites and Plethites who made him ride on the king's mule."
,"45":"Then Zadok the priest and Nathan the prophet anointed him king at Gihon. As they returned, all the city cheered; this is the noise that you have heard."
,"46":"Solomon already sits on the royal throne"
,"47":"and the king's servants came to congratulate our lord King David, saying: 'May your God make the name of Solomon more famous than yours and his reign greater than yours.' At this, the king bowed in worship on his bed and said,"
,"48":"'Blessed be Yahweh, the God of Israel, who has granted one of my offspring to sit on my throne this day when I can still see it.'"
,"49":"All the guests of Adonijah trembled and left, each going his own way."
,"50":"In his fear of Solomon, Adonijah went and held onto the horns of the altar."
,"51":"This was reported to Solomon, 'Adonijah is so afraid of King Solomon that he has held onto the horns of the altar, and he says, 'Let King Solomon swear to me today that he will not slay me with the sword'.'"
,"52":"Solomon replied, 'If he proves to be a worthy man, not a hair of his head shall perish. But if he acts like a wicked man, he shall die.'"
,"53":"So King Solomon sent for him and they brought him down from the altar. He came before King Solomon and paid him homage; after that, Solomon sent him home."
}`)
	CurrentBook.AddChapter(2, `{
"1":"When David was about to die, he gave his son Solomon this instruction,"
,"2":"'I am about to go the way of all creatures. Be strong and show yourself a man."
,"3":"Keep the commandments of Yahweh your God and walk in his ways. Keep his statutes, his commands, his ordinances and declarations written in the law of Moses, that you may succeed in whatever you do and wherever you go."
,"4":"If you do so, Yahweh will fulfill the promise he made to me: 'If your sons take care to walk before me faithfully with their whole heart and their whole soul, you shall always have one of your descendants on the throne of Israel.'"
,"5":"Now you know what Joab, the son of Zeruiah did to me - how he dealt with the two commanders of Israel's armies, Abner the son of Ner, and Amasa the son of Jether. These two he murdered, avenging, in time of peace, blood which had been shed in time of war. He has thus stained with innocent blood the belt I wear and the sandals on my feet."
,"6":"Act wisely, therefore, his blood must be shed before he dies of old age."
,"7":"As to the sons of Barzillai, the Gileadite, deal kindly with them and let them be among those who eat at your table, for they themselves treated me with similar kindness when I fled from your brother Absalom."
,"8":"With you also is Shimei, son of Gera, the Benjaminite from Bahurim who cursed me terribly, the day I fled to Mahanaim. When he came down to meet me at the Jordan, I swore to him by Yahweh, 'I will not put you to death with the sword.'"
,"9":"Now therefore, you, being a wise man, shall not hold him guiltless. You will know what to do with him: his blood must be shed before he dies of old age.'"
,"10":"Then David rested with his fathers and was buried in the city of David."
,"11":"David reigned over Israel for forty years: seven years in Hebron and thirty-three years in Jerusalem."
,"12":"So Solomon sat on the throne of David his father and his reign was firmly established."
,"13":"Then Adonijah, son of Haggith, came to Bathsheba, mother of Solomon, who asked him, 'Do you come in peace?' He answered, 'In peace,'"
,"14":"and added, 'I have something to tell you.' She said, 'Speak'"
,"15":"and Adonijah said, 'You know that the kingdom was mine and that all Israel fully expected me to reign. But the kingdom has slipped from my hands and become my brother's for it was given him by Yahweh."
,"16":"Now I have one thing to ask of you and I beg you not to refuse me.' She said, 'Speak,'"
,"17":"and he continued, 'Please ask King Solomon to give me Abishag the Shunammite for my wife. I know that he cannot refuse you.'"
,"18":"Bathsheba answered, 'Very well, I shall speak to the king on your behalf.'"
,"19":"So Bathsheba went to King Solomon to speak to him on behalf of Adonijah. The king met her and bowed to her. Then he sat on his throne and had a seat brought for the king's mother who sat on his right."
,"20":"She said, 'I have one small request to make of you. Do not refuse me.' And the king answered her, 'Make your request, my mother, for I will not refuse you.'"
,"21":"She then said, 'Let Abishag the Shunammite be given to Adonijah your brother as his wife.'"
,"22":"King Solomon answered his mother, 'And why do you not ask for the kingdom to be given to him! For he is my elder brother, and Abiathar the priest and Joab the son of Zeruiah are on his side.'"
,"23":"Then King Solomon swore this oath, 'Yahweh do so to me and more if this request does not cause Adonijah his life!"
,"24":"Now, therefore, as Yahweh lives, he who has established me and placed me on the throne of David my father, and who has established a kingly line as he promised, Adonijah shall be put to death this day.'"
,"25":"So King Solomon sent Benaiah, son of Jehoiada, who killed him."
,"26":"Then the king said to Abiathar the priest, 'Go to your estate at Anathoth. You deserve death but I will not put you to death, because you carried the ark of God before my father David and shared in all his trials.'"
,"27":"So Solomon removed Abiathar as priest of Yahweh, and fulfilled the word spoken by Yahweh in Shiloh concerning the descendants of Eli."
,"28":"This news reached Joab, who had supported Adonijah but not Absalom. He fled to the tent of Yahweh and held onto the horns of the altar."
,"29":"When it was reported to King Solomon that Joab had fled to the tent of Yahweh and was beside the altar, the king sent Benaiah, son of Jehoiada, with this command, 'Go, strike him down!'"
,"30":"So Benaiah went to the tent of Yahweh and said to Joab, 'The king commands: 'Come forward.'' But he replied, 'No, I will die here.',So Benaiah went back to the king with this report, 'This is what Joab answered.' "
,"31":"The king then replied. 'Do as he has said. Strike him down and have him buried. With this, the guilt for the blood which Joab shed will be lifted from me and from my father's family."
,"32":"Yahweh will repay him for the blood he shed because, without my father David's knowledge, he attacked and slew with the sword two men more righteous and better than himself, Abner son of Ner, commander of the Israelite army, and Amasa son of Jether, commander of Judah's army."
,"33":"'Their blood shall be avenged on Joab and his descendants forever; but David and his descendants, his family and throne shall enjoy peace from Yahweh forever.'"
,"34":"Then Benaiah, son of Jehoiada, went up, struck Joab down and killed him. He was buried in his own house in the desert."
,"35":"The king put Benaiah, son of Jehoiada, over the army in place of Joab; and Zadok the priest, in place of Abiathar."
,"36":"Then the king sent for Shimei and told him, 'Build yourself a house in Jerusalem and stay there, and do not leave the place to go anywhere."
,"37":"On the day you leave and cross the brook Kidron, you shall surely die and you shall be responsible for your own death.'"
,"38":"Shimei answered the king, 'What you say is good. Your servant will do as my lord the king has commanded.' So Shimei stayed in Jerusalem for many days."
,"39":"Three years later, two of Shimei's slaves ran away to Achish, son of Maacha, king of Gath. When it was reported to Shimei that his slaves were in Gath,"
,"40":"he saddled an ass and went to Achish in Gath in search of his slaves."
,"41":"When Solomon was informed that Shimei had left Jerusalem for Gath and returned,"
,"42":"the king sent for Shimei and said to him, 'Did I not make you swear by Yahweh and warned you severely that, on the day you left to go anywhere you would surely die? And you answered me: 'What you say is good; I shall obey!'"
,"43":"Why then did you not keep your oath to Yahweh and obey the command I gave you?'"
,"44":"The king told Shimei, 'Remember the evil you did to David my father. Now Yahweh will repay you for what you did."
,"45":"But King Solomon shall be blessed, and the throne of David shall stand firm before Yahweh forever.'"
,"46":"Then the king commanded Benaiah, son of Jehoiada, who went out and struck Shimei and killed him. In this manner, Solomon firmly established his reign."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Solomon entered into a marriage alliance with Pharaoh, king of Egypt. He took Pharaoh's daughter and brought her to the city of David until he had finished building his own palace, Yahweh's House and the wall around Jerusalem."
,"2":"Meantime, the people were sacrificing at the high places because the house for the Name of Yahweh had not yet been built."
,"3":"This is why Solomon also sacrificed and burnt incense at the high place, although he loved Yahweh and followed the commands of David his father."
,"4":"The king used to sacrifice at Gibeon, the great high place; on the altar there he had offered a thousand burnt offerings."
,"5":"It was in Gibeon, during the night, that Yahweh appeared to Solomon in a dream and said, 'Ask what you want me to give you.'"
,"6":"Solomon answered, 'You have shown your servant David my father a great and steadfast love because he served you faithfully and was righteous and sincere towards you. You have given him proof of your steadfast love in making a son of his sit on his throne this day."
,"7":"And now, O Yahweh my God, you have made your servant king in place of David my father, although I am but a young boy who does not know how to undertake anything."
,"8":"Meantime, your servant is in the midst of your people whom you have chosen - a people so great that they can neither be numbered nor counted."
,"9":"Give me, therefore, an understanding mind in governing your people that I may discern between good and evil. For who is able to govern this multitude of people of yours?'"
,"10":"Yahweh was pleased that Solomon had made this request."
,"11":"And he told him, 'Because you have requested this rather than long life or wealth or even vengeance on your enemies; indeed, because you have asked for yourself understanding to discern what is right,"
,"12":"I shall grant you your request. I now give you a wise and discerning mind such as no one has had before you nor anyone after you shall ever have."
,"13":"'I will also give you what you have not asked for, both wealth and fame; and no king shall be your equal during your lifetime."
,"14":"Moreover, if you will walk in my ways, keeping my statutes and commands, as your father David did, I shall give you long life.'"
,"15":"Solomon awoke and knew that this was a dream. So he went to Jerusalem and, standing before the ark of the covenant of Yahweh, he offered up burnt offerings and peace offerings, and gave a feast for all his servants."
,"16":"Then two harlots came to the king and stood before him."
,"17":"One of the two women said, 'Oh, my lord, this woman and I live in the same house, and I gave birth to a child while she was there with me."
,"18":"Three days after my child was born, this woman also gave birth. We were alone, and there was no one in the house but the two of us."
,"19":"Then this woman's son died during the night because she lay on him."
,"20":"So during the night, she got up, took my son from my side while I slept, laid it beside her and her dead son beside me."
,"21":"When I got up in the morning to nurse my child, I saw it was dead. But when I looked at it closely in the morning, I saw that it was not my child.'"
,"22":"The other woman said, 'No, the living child is mine; the dead child is yours.' To this, the first replied, 'Not so, the dead child is yours; the living child is mine.' And they quarreled this way in the king's presence."
,"23":"Then the king said, 'One says: 'This is my son who is alive; your son is dead'; the other says: 'That is not so, your son is dead; my son is the live one'.'"
,"24":"And the king said, 'Bring me a sword.' When they brought the king a sword,"
,"25":"he gave this order, 'Divide the child in two and give half to one, half to the other.'"
,"26":"Then the woman whose son was alive said to the king out of pity for her son, 'Oh, my lord, give her the living child but spare its life.' The other woman, however, said, 'It shall be neither mine nor yours. Divide it!'"
,"27":"Then the king spoke, 'Give the living child to the first woman and spare its life. She is its mother.'"
,"28":"When all Israel heard of the judgment which the king had given, they revered at him, seeing that God's wisdom was in him to render justice."
}`)
	CurrentBook.AddChapter(4, `{
"1":"King Solomon was king over all Israel"
,"2":"and had the following for his high officials: Azariah, son of Zadok, was the priest;"
,"3":"Elihoreph and Ahijah, sons of Shisha, were secretaries; Jehoshaphat, son of Ahilud, was recorder;"
,"4":"Benaiah, son of Jehoiada, was general of the army; Zadok and Abiathar were priests;"
,"5":"Azariah, son of Nathan, was head of the officers; Zabud, son of Nathan, was priest and the king's personal adviser;"
,"6":"Abishar was in charge of the palace; and Adoniram, son of Abda was in charge of forced labor."
,"7":"Solomon had twelve governors over all Israel who provided food for the king and his household; each one of them making provisions for one month during the year."
,"8":"These were their names: Benhur, in the hill country of Ephraim;"
,"9":"Bendeker, in Makaz; Shaalbim, Beth-shemesh, and Elonbeth-hanan;"
,"10":"Benhesed, in Arubboth (to him belonged Socoh and all the land of Hepher);"
,"11":"Ben-abinadab, in all of Naphath-dor (he had Taphath, daughter of Solomon, for his wife);"
,"12":"Baana, son of Ahilud, in Taanach; Megiddo and all of Beth-shean beside Zarethan below Jezreel, and from Beth-shean to Abelmeholah, as far as Jokmeam and beyond;"
,"13":"Ben-geber, in Ramoth-gilead (he had the villages of Jair, son of Manasseh, which are in Gilead, as also the region of Argob in Bashan, sixty big towns, walled and barred with brazen bars);"
,"14":"Ahinadab, son of Iddo, in Mahanaim;"
,"15":"Ahimaaz, in Naphtali (he had taken Basemath, daughter of Solomon, for his wife);"
,"16":"Baana, son of Hushai, in Asher and Bealoth;"
,"17":"Jehoshaphat, son of Paruah, in Issachar;"
,"18":"Shimei, son of Ela, in Benjamin;"
,"19":"Geber, son of Uri, in the land of Gilead, the country of Sihon king of the Amorites and of Og king of Bashan. And there was also an attendant in the land of Judah."
,"20":"Judah and Israel were as numerous as the sand on the seashore, eating and drinking, and making merry."
,"21":"Solomon ruled over all the kingdoms from the Euphrates to the land of the Philistines and on to the frontiers of Egypt. All these paid tribute and served Solomon during his lifetime."
,"22":"Solomon's provision for one day was thirty cors of fine flour, sixty cors of meal,"
,"23":"ten fat oxen, twenty pasture-fed cattle, a hundred sheep, besides harts, gazelles, roebucks, and fattened fowl."
,"24":"He ruled over all the region west of the Euphrates, from Tipshah to Gaza and over all its kings, and he had peace on all frontiers."
,"25":"Judah and Israel lived in security, from Dan to Beersheba, and everyone was safe under his vine and under his fig tree, for as long as Solomon lived."
,"26":"Solomon had forty thousand stalls of horses for his chariots and twelve thousand horsemen."
,"27":"All these governors supplied provisions for King Solomon and for all his guests at table, each one providing during his assigned month and seeing that nothing was lacking."
,"28":"They also brought barley and straw for the horses and swift studs wherever the king stayed, each one doing this during his appointed month."
,"29":"God gave Solomon great wisdom and understanding, and knowledge as vast as the sand on the shore,"
,"30":"so that his wisdom surpassed that of all the people of the east and of the Egyptians."
,"31":"He was wiser than any man; wiser than Ethan, the Ezrahite, and Heman, Calcot and Darda, sons of Mahol; and his fame spread among all the surrounding nations."
,"32":"He composed three thousand proverbs and knew a thousand and five songs."
,"33":"He took his examples from all the trees, from the cedar in Lebanon to the hyssop that grows out of the wall; he spoke also of the beasts and birds, and reptiles and fish."
,"34":"People from all nations came to hear the wisdom of Solomon; all the kings of the earth who had heard of his wisdom sent messengers to listen to him."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Now, Hiram King of Tyre sent his servants to Solomon when he heard that he had been anointed king in place of his father. For David had always been Hiram's friend."
,"2":"Solomon then sent this message to Hiram,"
,"3":"'You know that David my father could not build a temple for Yahweh his God because his enemies were at war with him until the time when Yahweh gave him victory over them."
,"4":"But now Yahweh my God has given me peace on all sides and there is no enemy or calamity that afflicts us."
,"5":"And so I intend to build a temple for Yahweh my God as Yahweh told David my father, 'Your son, whom I will set upon your throne, shall build the House for my Name."
,"6":"Now, therefore, give orders to have cedars of Lebanon cut for me. My servants will join yours and I will pay your servants the wages you set, for you know that none of us can cut timber like the Sidonians.'"
,"7":"When Hiram heard the answer of Solomon, he was exceedingly glad and said, 'Blessed be Yahweh this day who has given David a wise son to rule over this great people.'"
,"8":"Then Hiram sent a messenger to Solomon with these words, 'I have heard the message you sent me and I am ready to do whatever you want concerning the cedar and cypress timber."
,"9":"My servants shall have it sent down to the sea from Lebanon. I will make it into rafts and deliver them by sea to the place you choose. I will have the rafts broken up there and you can take the timber away. You, for your part, will provide food for my household.'"
,"10":"So Hiram supplied Solomon with all the cedar and cypress timber that he wanted,"
,"11":"while Solomon gave Hiram every year twenty thousand cors of wheat as food for his household, and twenty thousand cors of pure oil."
,"12":"Yahweh gave wisdom to Solomon as he had promised him, and there was peace between Hiram and Solomon who bound themselves by a treaty."
,"13":"King Solomon conscripted thirty thousand men from all Israel for forced labor."
,"14":"He sent them to Lebanon in relays of ten thousand a month, so that they would be in Lebanon for a month and at home for two months. Adoniram was in charge of the draft of laborers."
,"15":"Solomon had seventy thousand carriers and eighty thousand stone cutters in the hill country,"
,"16":"in addition to three thousand three hundred overseers in charge of the people engaged in the work."
,"17":"By order of the king, they quarried large and expensive stones to give the temple a foundation of hewn stones."
,"18":"Solomon's builders and Hiram's builders, along with the Gebalites did the hewing and prepared both timber and stone to build the temple."
}`)
	CurrentBook.AddChapter(6, `{
"1":"In the four hundred and eightieth year after the Israelites left the land of Egypt, in the fourth year of Solomon's reign over Israel, in the month of Ziv, which is the second month, Solomon began to build the temple of Yahweh."
,"2":"The House which King Solomon built for Yahweh was sixty cubits long, twenty wide, and thirty high."
,"3":"The vestibule fronting the Sanctuary was twenty cubits long from side to side, the width of the temple, and ten cubits deep in front of the House."
,"4":"He made windows with recessed frames for the House."
,"5":"Solomon had a structure built adjoining the walls all around the House and enclosing both Sanctuary and Inner Sanctuary. He also made lateral rooms all around."
,"6":"The lowest story was five cubits wide; the middle, six cubits wide; and the third, seven cubits wide. Around the exterior of the temple, he made offsets on the wall so that the supporting beams need not be inserted into walls of the temple."
,"7":"The House was built with stones prepared at the quarry so that no hammer, or axe, or any iron implement was heard in the temple during the construction."
,"8":"The entrance to the lowest story was on the right side of the House. A staircase led up to the middle story; and from the middle story, to the third."
,"9":"So, Solomon built the House and finished it, making the ceiling of the House from cedar beams and planks."
,"10":"Each story of the structure which he built surrounding the House was five cubits high joined to the House with cedar timber."
,"11":"The word of Yahweh was directed to Solomon,"
,"12":"'If you observe my statutes, obey my ordinances, keep all my commands and follow them, I will fulfill everything I said to David your father regarding this House."
,"13":"There I will be in the midst of the Israelites and not forsake my people Israel.'"
,"14":"So, Solomon built the House and finished it."
,"15":"He covered the interior walls of the temple with cedar boards; so that in the interior from the floor of the House to the rafters of the ceiling only wood could be seen. The floor also was covered with cypress boards."
,"16":"Solomon covered twenty cubits of the rear of the House with cedar boards from floor to rafter to serve as an inner sanctuary - the Most Holy Place."
,"17":"The front of the house, that is the Sanctuary, was forty cubits long."
,"18":"In all the interior of the House, the cedar was carved in the form of gourds and open flowers; all was of cedar and no stone was to be seen."
,"19":"The inner sanctuary in the innermost part of the building had been destined to house the ark of the covenant of Yahweh."
,"20":"It was twenty cubits long, twenty cubits wide, and twenty cubits high, overlaid with pure gold. He also made an altar of cedar."
,"21":"Solomon overlaid the interior of the House with pure gold. He closed the inner sanctuary with golden chains and overlaid it with gold."
,"22":"Solomon overlaid the entire House with gold. He also overlaid with gold the whole altar in the inner sanctuary."
,"23":"In the inner sanctuary, Solomon made two cherubim of olive wood, each ten cubits high."
,"24":"The length of the wings of each cherub was five cubits each, hence, ten cubits from tip to tip."
,"25":"Both cherubim had the same measurement and the same form,"
,"26":"both being ten cubits high."
,"27":"When the cherubim were put in the innermost part of the House their wings were so spread out that a wing of one touched one wall, while a wing of the other touched the other wall. Their other wings touched each other at the center of the House."
,"28":"The cherubim were also overlaid with gold."
,"29":"Solomon had all the surrounding walls of the House carved with figures of cherubim, palm trees and open flowers both in the interior and exterior rooms."
,"30":"He also had the floor of the House, in both the interior and exterior rooms, overlaid with gold."
,"31":"Solomon had doors made of olive wood for the entrance to the inner sanctuary of which the lintel and doorposts formed the fifth part."
,"32":"He covered the two olive wood doors with carvings of cherubim, palm trees and open flowers. He then overlaid them with gold and spread gold on the cherubim and the palm trees."
,"33":"He did the same for the olive wood doorposts at the entrance to the sanctuary, which formed the fourth part of the door."
,"34":"Both the right and left side of the door had two folding panels of cypress wood."
,"35":"He had cherubim, palm trees and open flowers carved on them and overlaid the carvings with gold evenly applied."
,"36":"As for the interior court, Solomon had it built with three courses of hewn stone and one course of cedar beams."
,"37":"In the month of Ziv of the fourth year, the foundation of Yahweh's House was laid."
,"38":"In the month of Bul, the eighth month of the eleventh year, the House was finished, complete and according to all specifications. It took Solomon seven years to build it."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Solomon took thirteen years to build his own palace."
,"2":"He built the House of the Forest of Lebanon which measured one hundred cubits long, fifty cubits wide, and thirty cubits high. It was built on three rows of cedar pillars with cedar beams on the pillars."
,"3":"It had a cedar ceiling above the beams that were on the forty-five pillars, fifteen in each row."
,"4":"There were three window frames at either end, each window corresponding to another opposite it."
,"5":"All the doorways and windows had square frames and each window corresponded to the one opposite it."
,"6":"The Hall of Pillars measured fifty cubits long and thirty cubits wide. It had a porch in front with pillars and a canopy over them."
,"7":"The Hall of the Throne where Solomon was to pronounce judgment, that is, the Hall of Judgment, was finished with cedar from floor to rafters."
,"8":"His own house, where he was to live, and which was in the other court behind the hall, was built in like manner. Solomon also made a house similar to this for Pharaoh's daughter whom he had taken in marriage."
,"9":"All these were made of costly stones, hewn according to measure, sawn on their inner and outer faces even from the foundation to the coping, and from the court of Yahweh's House to the big court."
,"10":"The foundation was of huge, costly stones of eighty and ten cubits."
,"11":"Above were costly stones, hewn according to measure, and cedar wood."
,"12":"The great court was surrounded by a wall of hewn stones and a course of cedar beams, like the interior court of Yahweh's House and its vestibule."
,"13":"King Solomon sent for and brought from Tyre, Hiram,"
,"14":"who was the son of a widow of Naphtali's tribe. His father was from Tyre and an artisan in bronze-work, and he himself was very knowledgeable and skilled in all kinds of bronze-work. Hiram came and did all the work that Solomon asked of him."
,"15":"He cast two brazen pillars, both of which measured eighteen cubits high and had a circumference of twelve cubits. Both were hollow and measured four fingers in thickness."
,"16":"He also made two capitals of molten bronze to set on the tops of the pillars, both measuring five cubits high."
,"17":"He also made two pieces of network with a chainlike mesh for each of the capitals on top of the pillars."
,"18":"Likewise, he made pomegranates arranged in two rows encircling each piece of network to cover each capital on top of the pillars."
,"19":"The capitals on top of the pillars in the vestibule had a lotus design measuring four cubits."
,"20":"They were on the two pillars above the nodes and beside the network, encircled by two hundred pomegranates arranged in two rows."
,"21":"Hiram set up the pillars at the vestibule of the temple; one to the right called Yakin, and one to the left called Boaz."
,"22":"In this way the work on the pillars was completed."
,"23":"Hiram then cast the great round bowl called the 'Sea,' measuring ten cubits from one brim to the opposite; it was five cubits high and had a circumference of thirty cubits."
,"24":"Under its brim, it was encircled with gourds, ten for each cubit, arranged in two rows and cast along with the Sea."
,"25":"This rested on twelve oxen, three facing north, three facing west, three facing south, and three facing east, with their haunches towards the center."
,"26":"It was a handbreadth in thickness, its brim resembling a cup or a lily flower, and had a capacity of two thousand baths."
,"27":"Hiram also made ten brazen stands, each measuring four cubits long, four cubits wide and three cubits high;"
,"28":"and this was how the stands were constructed: they had framed panels"
,"29":"on which were lions, oxen and cherubim. On the frames above and below the lions and oxen were wreaths in relief."
,"30":"Each stand had four brazen wheels and axles; its four feet had shoulderings under the basin."
,"31":"Its mouth measured one and a half cubits from where the shoulderings met the top; its mouth was round like a rest for a vessel; and on the mouth there were engravings, too. The crosspieces, however, were rectangular, not round."
,"32":"The four wheels were below the panels; their axles being one piece with the stands. Each wheel was a cubit and a half high."
,"33":"The wheels were made like chariot wheels; their axles, rims, spokes and hubs were all of cast metal. The four legs of each stand had cast braces supporting a basin and had wreaths on each side. "
,"34":"These four braces, extending to the corners of each stand, were of one piece with the stand."
,"35":"On top of the stand was a round band half a cubit high, with supports and panels which were of one piece with the stand. This was topped by a crown one cubit high within which was a rounded opening, the way a pedestal is made, a cubit and a half deep. Its opening had carvings and its panels were square and not round."
,"36":"On the surface of its supports, as also on its panels, and wherever there was space, were carvings of cherubim, lions and palm trees, with wreaths all around."
,"37":"This was how the ten stands were made - all of them with the same cast, same measurement, and same form."
,"38":"Hiram also made ten brazen basins, each holding forty baths and measuring four cubits. There was a basin for each of the ten stands."
,"39":"He placed five of the stands on the south side of the House, and five on the north side. The Sea he placed at the southeast corner of the temple."
,"40":"Hiram also made the bowls, shovels and basins, and thereby finished all the work that he had undertaken for King Solomon on Yahweh's House."
,"41":"Hence, two pillars, two bowls on the capitals at the top of the pillars,"
,"42":"four hundred pomegranates for two networks, two rows of pomegranates for each network to cover the two bowls of the capitals at the top of the pillars,"
,"43":"ten stands, ten basins on the stands,"
,"44":"the Sea, and twelve oxen underneath the Sea."
,"45":"Now the bowls, shovels and basins - all these vessels which Hiram made in Yahweh's House for King Solomon - were of burnished bronze."
,"46":"The king had them cast in the plain of Jordan, in the clay ground between Succoth and Zarethan."
,"47":"Solomon left all the vessels unweighed since there were so many of them. And so the weight of the bronze was not known."
,"48":"So Solomon made all the vessels that were in Yahweh's House: the golden altar, the golden table for the bread of Presence,"
,"49":"the lampstands of pure gold, five on the right side and five on the left in front of the inner sanctuary; the flowers, lamps and tongs of gold;"
,"50":"the cups, snuffers, basins, dishes for incense, and firepans of pure gold; and the golden hinges for both the doors of the innermost part of the House, the Most Holy Place, and the doors of the Sanctuary of the House."
,"51":"When all the work that King Solomon did on Yahweh's House was completed, he brought in the things which David his father had dedicated - the silver, the gold, and the vessels - and stored them in the treasures of Yahweh's House."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Then Solomon assembled before him in Jerusalem the elders of Israel and all the heads of the tribes, as well as the leaders of the ancestral houses of the Israelites, to bring up the ark of the covenant of Yahweh from the city of David, which is Zion."
,"2":"All the Israelites assembled near King Solomon in the month of Ethanim, the seventh month."
,"3":"When all the elders of Israel arrived, the priests carried the ark of Yahweh"
,"4":"and brought it up together with the Tent of Meeting and all the holy vessels that were in the tent. After the priests and Levites had brought them up,"
,"5":"King Solomon with the entire congregation of Israel that had assembled before him and were with him before the Ark, sacrificed so many sheep and oxen that they could neither be counted nor numbered."
,"6":"Then the priests laid the ark of the covenant of Yahweh in its place in the inner sanctuary of the House - the Most Holy Place - underneath the wings of the cherubim."
,"7":"The cherubim had their wings spread out over the place of the ark, providing a covering above the ark and its poles."
,"8":"The poles were so long that their ends were seen from the Holy Place in front of the inner sanctuary but not from the outside; and they remain there to this day."
,"9":"There was nothing in the ark except the two tables of stone which Moses placed there at Horeb, where Yahweh made a covenant with the Israelites when they came out of the land of Egypt."
,"10":"And when the priests came out of the Holy Place, such a cloud filled Yahweh's House"
,"11":"that the priests could not continue to minister. Indeed, the glory of Yahweh filled his House."
,"12":"Then Solomon said, 'Yahweh has said that he would dwell in thick darkness."
,"13":"So the House I have built you will be your House, a place for you to dwell in forever.'"
,"14":"The king turned and blessed the entire assembly of Israel, as they stood,"
,"15":"saying, 'Blessed be Yahweh, the God of Israel, who has fulfilled by his hand what he promised personally to David my father when he said,"
,"16":"'Since the day I brought my people Israel out of Egypt, I chose no city in all the tribes of Israel in which to build a resting place for my Name, but now I have chosen Jerusalem for my Name to be there, as I chose David to be the king of my people Israel.'"
,"17":"Now David my father wanted to build a House for the Name of Yahweh, the God of Israel;"
,"18":"but Yahweh told David my father, 'You meant well to build a House for my Name."
,"19":"Nevertheless, not you but your son who shall be born to you shall build this House for my Name'.'"
,"20":"Yahweh has fulfilled his promise, for I have succeeded David my father and am sitting on the throne of Israel; and, as Yahweh promised, I have built this House for the Name of Yahweh, the God of Israel."
,"21":"There I have provided a place for the ark with the covenant which Yahweh made with our fathers when he brought them out of the land of Egypt.'"
,"22":"Then Solomon stood before the altar of Yahweh in the presence of all the assembly of Israel. He raised his hands towards heaven"
,"23":"and said, 'O Yahweh, God of Israel, there is no God like you either in heaven or on earth! You keep your covenant and show loving- kindness to your servants who walk before you wholeheartedly."
,"24":"You have foretold this day to your servant David, my father, and this day you have fulfilled your promise."
,"25":"Now, O Yahweh, God of Israel, keep this other promise you made to David when you said, 'You shall always have someone from your family on the throne of Israel, provided that your sons are careful to serve me as you have done.'"
,"26":"Now, therefore, O God of Israel, confirm the promise you have given to David my father."
,"27":"But will God really live among men on earth? If neither heavens nor the highest heavens can contain you, how much less can this House which I have built!"
,"28":"Yet, listen to the prayer and supplication of your servant, O Yahweh my God; hearken to the cries and pleas which your servant directs to you this day."
,"29":"Watch over this House of which you have said, 'My name shall rest there.' Hear the prayer of your servant in this place."
,"30":"Listen to the supplication of your servant and your people Israel when they pray in this direction; listen from your dwelling place in Heaven and, on listening, forgive."
,"31":"When people charged with a crime against their neighbor come and take their oath before your altar in this temple,"
,"32":"then hear from Heaven and do justice. Condemn the guilty and let his evildoing fall upon him, but vindicate the righteous and reward him according to his righteousness."
,"33":"When your people Israel are defeated by the enemy for having sinned against you, and when they turn back to you and acknowledge their sins, praying and making supplications to you in this House;"
,"34":"then listen from heaven and forgive your people Israel. Bring them back to the land which you gave to their fathers."
,"35":"When the heavens are shut and no rain falls because they have sinned against you, and they pray in this place, acknowledging and repenting of their sin because you have afflicted them,"
,"36":"then listen from Heaven and forgive your servants, your people Israel, and teach them the way to live; and send rain on your land which you have given to your people as an inheritance."
,"37":"If there is famine in the land, or pestilence such as blight or mildew, locust or caterpillar; if their enemy attacks them in any of their cities; if they suffer from any plague or sickness;"
,"38":"whatever be the prayer or supplication of anyone showing repentance and raising his hands in the direction of this House,"
,"39":"then listen from Heaven, your dwelling place, and forgive. Do to each, whose heart you know, according to his conduct (for you alone know the hearts of all)"
,"40":"so that they may fear you as long as they live in the land which you gave our fathers."
,"41":"Likewise, when a foreigner who is not from your people Israel, comes from a far country because of your Name"
,"42":"(for they shall hear of your great Name, your mighty hand and outstretched arm), and prays in this House,"
,"43":"listen from the heavens, your dwelling place, and do for the foreigner whatever he asks of you, so that all the peoples of the earth may know your Name and fear you, as do your people Israel, and may know that your name rests on this House which I have built."
,"44":"If your people go to war wherever you send them, and they pray to Yahweh in the direction of the city which you have chosen and the House which I have built for your Name,"
,"45":"then from Heaven listen to their prayers and supplications and defend their cause."
,"46":"If they sin against you (and there is no one who does not sin), and, in your anger, you deliver them to an enemy who takes them captive into enemy territory, whether near or far off;"
,"47":"and if, in the land where they have been carried captive, they sincerely repent and plead with you and say, 'We have sinned and have acted wrongly and wickedly';"
,"48":"if they do repent with sincerity while in the land of their captors and pray to you, turning towards the land which you gave to their fathers, the city which you have chosen, and the House which I have built for your Name;"
,"49":"then listen from heaven, your dwelling place, their prayer and supplication and defend their cause."
,"50":"Forgive your people who have sinned against you; forgive all their offenses, and make their captors have compassion on them."
,"51":"(For they are your people - your heritage which you brought out of Egypt from the heart of the iron furnace)."
,"52":"Open your eyes to the pleadings of your servant and to those of your people Israel, and listen to them whenever they call on you."
,"53":"For you took them from among all the peoples of the earth to be your heritage, as you declared through Moses your servant when you brought our fathers out of Egypt, O Yahweh God.'"
,"54":"When Solomon finished offering all this prayer and entreaty to Yahweh, he rose from before the altar of Yahweh where he had knelt with hands raised towards heaven and,"
,"55":"standing, blessed all the assembly of Israel with a loud voice,"
,"56":"'Blessed be Yahweh who has given rest to his people Israel as he promised; for not one of his promises, given to Moses his servant, has been broken."
,"57":"May Yahweh our God be with us as he was with our fathers. May he not leave or forsake us;"
,"58":"may he incline our hearts towards him and make us walk in all his ways keeping his commands, his statutes and regulations which he commanded our fathers."
,"59":"Let my prayer to Yahweh be with our God day and night. May he defend my cause and the cause of his people Israel in their daily life;"
,"60":"in this way all the peoples of the earth may know that Yahweh is God and there is no other."
,"61":"As for you, let your heart be wholly true to Yahweh our God, following his laws and keeping his commands as at this time.'"
,"62":"Then the king and all the Israelites with him offered sacrifices before Yahweh."
,"63":"Solomon offered twenty-two thousand oxen and a hundred and twenty thousand sheep as peace offerings to Yahweh. So the king and all the Israelites dedicated Yahweh's House."
,"64":"That same day, the king consecrated the middle of the court in front of Yah-weh's House, for it was there that he offered the burnt offerings, the cereal offerings and the fat of the peace offerings since the bronze altar that was before Yahweh was too small to receive the burnt offering, the cereal offering and the fat of the peace offerings."
,"65":"So at this time Solomon, together with a large assembly of Israelites that gathered from the entrance of Hamath to the Brook of Egypt, celebrated the festival before Yahweh for seven days."
,"66":"On the eighth day, Solomon dismissed the people. After bidding farewell to the king, they went home rejoicing and happy because of all the kindness that Yahweh had shown to his servant David and to his people Israel."
}`)
	CurrentBook.AddChapter(9, `{
"1":"After Solomon had finished building Yahweh's House, the royal palace, and everything he wanted to build,"
,"2":"Yahweh appeared to him a second time, as he had appeared to him at Gibeon."
,"3":"Yahweh said to him, 'I have heard the prayer and supplication you made before me. I have consecrated this House you have built, that my Name may be there forever. My eyes and my heart will be there forever."
,"4":"As for you, if you will live in my presence, the way your father David did, with sincerity and uprightness, doing all that I have commanded you and keeping my decrees and laws,"
,"5":"I will affirm your kingship in Israel forever, as I promised your father David when I said, 'You shall always have someone from your family on the throne of Israel.'"
,"6":"But if you or your children refuse to follow me, and disobey my commands and laws which I have set before you; if they serve and worship other gods,"
,"7":"then I will cut off Israel from the land which I have given them and I will remove from my sight this House I have consecrated for my Name. Israel will become a proverb and a byword among all peoples."
,"8":"This House will be reduced to a heap of stones and everyone passing by will be astonished and jeer: 'Why has Yahweh done such a thing to this land and to this House?'"
,"9":"Then people will answer: 'Because they abandoned Yahweh their God who brought their fathers out of the land of Egypt, and they followed other gods, worshiping and serving them. That is why Yahweh has brought all this evil on them'.'"
,"10":"During these twenty years, in which Solomon had built the two houses - Yahweh's House and the royal house -"
,"11":"Hiram king of Tyre had supplied Solomon with as much cedar, cypress, timber and gold as he wanted. Then King Solomon gave Hiram twenty cities in the land of Galilee."
,"12":"But when Hiram left Tyre to visit the cities which Solomon had given him, he was displeased"
,"13":"and said, 'What kind of cities have you given me, my brother?' And that is why, to this day, they are called the land of Cabul."
,"14":"Hiram, however, had sent the king one hundred and twenty talents of gold."
,"15":"This is the account of the forced labor imposed by King Solomon for the building of Yahweh's House and his own palace, the Millo as well as the wall of Jerusalem; the cities of Hazor, Megiddo and Gezer."
,"16":"(Pharaoh king of Egypt had captured and burned Gezer, putting to death the Canaanites who dwelt there. Then he had given the city as dowry to his daughter, Solomon's wife.)"
,"17":"So Solomon rebuilt Gezer, Lower Beth-horon,"
,"18":"Baalath and Tamar in the desert, in the land of Judah,"
,"19":"all the store-cities that Solomon had, the cities for his chariots and those for his horsemen, and whatever Solomon wanted to build in Jerusalem, in Lebanon and in all the land of his dominion."
,"20":"On all the people who were left of the Amorites, the Hittites, the Perizzites, the Hivites and the Jebusites, who were not of the people of Israel -"
,"21":"their descendants who were left in the land and whom the Israelites were unable to completely destroy - on all of these Solomon imposed forced labor and it remains so to this day."
,"22":"Of the people of Israel, however, Solomon made no slaves. They were the soldiers, his officials, his commanders, his captains, his chariot commanders and horsemen."
,"23":"The overseers of Solomon's work, in charge of those who were working, were five hundred and fifty."
,"24":"When Pharaoh's daughter went up from the city of David to her own house that Solomon had built for her, he began building the Millo."
,"25":"After Solomon had finished the House, he came three times a year to offer up burnt offerings and peace offerings on the altar which he had built to Yahweh, burning incense before Yahweh."
,"26":"King Solomon built a fleet of ships at Ezion-geber, near Elath on the shore of the Red Sea, in the land of Edom."
,"27":"Hiram sent his servants, seamen who were familiar with the sea, to serve in the fleet together with the servants of Solomon."
,"28":"They sailed for Ophir and brought back to King Solomon gold amounting to four hundred and twenty talents."
}`)
	CurrentBook.AddChapter(10, `{
"1":"The queen of Sheba heard about Solomon's fame, and came to test him with difficult questions."
,"2":"She arrived in Jerusalem with a vast retinue and with camels loaded with spices, an abundance of gold and precious stones. When she came to Solomon, she told him all that she had on her mind"
,"3":"and Solomon answered all her questions. There was nothing that the king could not explain to her."
,"4":"And when the queen of Sheba had seen all the wisdom of Solomon, the palace he had built,"
,"5":"the food on his table, the residence of his officials, the attendance of his servants and their clothing, his cupbearers, and the burnt offerings which he offered at Yahweh's House, it left her breathless."
,"6":"Then she said to the king, 'All that I heard in my own land concerning you and your wisdom was true."
,"7":"But I did not believe the reports until I came and saw with my own eyes. And what did I see! I was told only half the story; for your wisdom and wealth surpass the report I heard."
,"8":"Fortunate are your wives! Fortunate are your servants who are ever in your presence and hear your wisdom!"
,"9":"Blessed be Yahweh your God, who has looked kindly on you and has put you on the throne of Israel! Because of Yahweh's eternal love for Israel, he has made you king so that you may dispense justice and righteousness.'"
,"10":"Then she gave the king a hundred and twenty talents of gold, spices in abundance, and precious stones. Such an abundance of spices as those which the queen of Sheba gave to King Solomon was never again seen."
,"11":"Moreover, the fleet of Hiram, which brought gold from Ophir, also brought from Ophir a huge amount of almug wood and precious stones."
,"12":"The king used the almug wood to make supports for Yahweh's House and the royal palace, and also to make lyres and harps for the singers. Such almug wood has never again been brought or seen to the present day."
,"13":"King Solomon, in turn, gave the queen of Sheba all that she desired and all that he in his generosity wanted to give her. Then she went back to her own land together with her servants."
,"14":"Now the weight of gold that Solomon received in one year was six hundred and sixty-six gold talents,"
,"15":"not counting that brought by traders, merchants, the kings of Arabia and the governors of the land."
,"16":"King Solomon made two hundred large shields of beaten gold, six hundred shekels of gold going into each shield."
,"17":"And he made three hundred shields of beaten gold with three minas of gold in each shield. And the king put them in the House of the Forest of Lebanon."
,"18":"The king also made a huge ivory throne and overlaid it with the finest gold."
,"19":"The throne had six steps, a rounded back, and on each side of the seat were arm rests with two lions standing beside the arm rests."
,"20":"The six steps had twelve lions, one on each end of a step. Nothing like this was ever made in any kingdom."
,"21":"All of King Solomon's drinking vessels were of gold, and all the vessels of the House of the Forest of Lebanon were of pure gold and none of silver, for silver was not considered of much value in the days of Solomon."
,"22":"The king had a fleet of Tarshish ships at sea with Hiram's fleet, and once every three years the fleet of Tarshish ships would bring gold, silver, ivory, apes and peacocks."
,"23":"King Solomon surpassed all the kings of the earth in wealth and wisdom."
,"24":"And the whole world sought audience with Solomon to hear the wisdom which God had put into his mind."
,"25":"Everyone who came brought a present: articles of silver and gold, garments, myrrh, spices, horses and mules, so much every year."
,"26":"Solomon gathered together chariots and horses - fourteen hundred chariots and twelve thousand horses which he stationed in the chariot cities and with the king in Jerusalem."
,"27":"The king made silver as common as stone in Jerusalem, and cedar as plentiful as sycamore in the lowland."
,"28":"Solomon imported his horses from Musri and Kue and the king's traders got them from Kue for a fixed price."
,"29":"A chariot could be imported from Musri for six hundred shekels of silver, and a horse for a hundred and fifty. They were exported in the same way to all the kings of the Hittites and the kings of Syria."
}`)
	CurrentBook.AddChapter(11, `{
"1":"King Solomon loved many foreign women besides the daughter of Pharaoh. There were Moabite, Ammonite, Edomite, Sidonian and Hittite women"
,"2":"from nations about which Yahweh had commanded the Israelites, 'You shall not marry them; nor shall they marry you, lest they win over your heart to their gods.' Solomon, however, imitated these peoples because of his love."
,"3":"He had seven hundred wives of royal birth, and three hundred concubines, and they won his heart."
,"4":"In Solomon's old age, his wives led him astray to serve other gods and, unlike his father David, his heart was no longer wholly given to Yahweh his God."
,"5":"For he served Astarte the goddess of the Sidonians, and Milcom, the idol of the Ammonites."
,"6":"He did what displeased Yahweh and, unlike his father David, was unfaithful to him."
,"7":"Solomon even built a high place for Chemosh, the idol of Moab, on the mountain east of Jerusalem and also for Molech, the idol of the Ammonites."
,"8":"He did the same for all his foreign wives who burned incense and sacrificed to their gods."
,"9":"Yahweh became angry with Solomon because his heart had turned away from Yahweh, the God of Israel."
,"10":"Yahweh appeared to him twice and commanded him not to follow other gods. But he did not obey Yahweh's command."
,"11":"Therefore, Yahweh said to Solomon, 'Since this has been your choice and you have kept neither my Covenant nor the statutes I commanded you, I will take the kingdom from you and give it to your servant."
,"12":"Nevertheless, I will not do this during your lifetime for the sake of your father David; I will take it from your son."
,"13":"But I will not take it all; I will reserve one tribe for your son for the sake of David my servant, and for the sake of Jerusalem, the city which I have chosen.'"
,"14":"And Yahweh raised up an adversary against Solomon. This was Hadad, the Edomite of the royal house in Edom."
,"15":"Indeed, when David had defeated Edom, and Joab the commander of the army went up to bury the slain, he slew every male in Edom."
,"16":"Joab and the Israelites remained in the place for six months until he had destroyed every male in Edom."
,"17":"However Hadad, then still only a boy, fled to Egypt together with some Edomites, his father's servants."
,"18":"They left Midian for Paran and, taking along with them some of the men from Paran, they went on to Egypt to Pharaoh, king of Egypt, who gave Hadad a house, promised him food and gave him land."
,"19":"Hadad pleased Pharaoh, who gave him as wife the sister of Queen Tahpenes, his own wife."
,"20":"The sister of Tahpenes bore him a son, Genubath, whom Tahpenes weaned in Pharaoh's house, and who lived there together with Pharaoh's sons."
,"21":"And so when Hadad heard in Egypt that David had slept with his fathers, and that Joab the commander of the army was also dead, he said to Pharaoh, 'Let me go back to my own country.'"
,"22":"Pharaoh asked him, 'What have I not done that you want to leave for your own country?' But he answered him, 'Please, let me go.' And he came back to his land. He ruled over Edom and hated Israel."
,"23":"God raised up another adversary in the person of Rezon son of Eliada, who had fled from his master Hadadezer king of Zobah."
,"24":"Rezon gathered men around him and became the leader of a marauding band. After David fought them and killed some of them, they went to live in Damascus where they made him king."
,"25":"He was an adversary of Israel during Solomon's lifetime."
,"26":"Jeroboam also rebelled against the king. He was the son of Nebat, an Ephraimite of Zeredah; his mother, Zeruah, had been left a widow. He was one of Solomon's officials."
,"27":"This was the reason for his rebellion. Solomon was building the Millo and was closing up the breach of the City of David his father;"
,"28":"when he noticed that Jeroboam was a man of great personal worth and an able worker, he put him in charge of all the forced labor of the tribes of Joseph."
,"29":"Once, when Jeroboam went out of Jerusalem, the prophet Ahijah of Shiloh found him on the road. The two of them were alone in the open country"
,"30":"when Ahijah, who had a new garment on, clutched and tore it into twelve pieces."
,"31":"He then said to Jeroboam, 'Take ten pieces for yourself for this is the word of Yahweh, the God of Israel: 'I am about to tear the kingdom from Solomon's hands "
,"32":"to give you ten tribes. Only one tribe shall be left to him for the sake of my servant David and Jerusalem, the city which I have chosen out of all the tribes of Israel."
,"33":"For Solomon has forsaken me and worshiped Astarte, the goddess of the Sidonians, Chemosh the god of Moab, and Milcom the god of the Ammonites. Unlike his father David, he has not walked in my ways to do what is right before me and to keep my commandments and decisions."
,"34":"Nevertheless, it is not from him that I will take the kingdom. I will let him reign during his lifetime for the sake of David my servant, whom I chose and who kept my commandments and statutes."
,"35":"But I will take the kingship from his son's hand and make you king over ten tribes."
,"36":"One tribe will be left for his son so that my servant David may always have a lamp before me in Jerusalem, the city where I have chosen to put my Name."
,"37":"I will let you reign over all you wish; you shall be king of Israel."
,"38":"Now, if you obey all that I command you, follow me and do what is right in my eyes, if you keep my commandments and my statutes, as my servant David did, I will be with you and establish your family for a long time, as I did for David. I will entrust Israel to you."
,"39":"In this way I will humble the family of David for a time'.'"
,"40":"Solomon wanted to kill Jeroboam, but Jeroboam took refuge in Egypt with Shishak king of Egypt, where he remained until the death of Solomon."
,"41":"Now the rest of the events of Solomon's reign, his deeds and his wisdom, are written in the book of the acts of Solomon."
,"42":"Solomon reigned over all Israel in Jerusalem for forty years."
,"43":"Then he rested with his fathers and was buried in the city of David; Rehoboam his son reigned in his place."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Rehoboam went to Shechem because all Israel had gathered there to make him king."
,"2":"When Jeroboam, son of Nebat, heard of this in Egypt where he had fled from King Solomon and where he still remained, he returned from Egypt."
,"3":"They called for him, and he came with all the assembly of Israel. The people of Israel went to Rehoboam with this demand, "
,"4":"'Your father made our yoke heavy. So now lighten the heavy yoke and the hard labor your father imposed on us and we will serve you.'"
,"5":"Rehoboam answered them, 'Leave now but come back on the third day.' And so the people went their way."
,"6":"King Rehoboam sought advice from the elderly counselors who served his father Solomon while he was still alive, and he asked them, 'How would you advise me to answer this people?'"
,"7":"To this they replied, 'If you attend to this people today making yourself their servant and speak to them with good words, they will serve you forever.'"
,"8":"But Rehoboam disregarded the advice of the old counselors and asked the opinion of the greenhorns who had grown up with him and were in his service."
,"9":"He asked them, 'What do you say we should answer this people who tell me: 'Lighten the yoke which your father imposed on us'?'"
,"10":"The greenhorns who had grown up with him answered, 'Since these people said to you, 'Your father made our yoke heavy, but you should now lighten it for us,' tell them this: 'My little finger is thicker than my father's waist."
,"11":"My father laid a heavy yoke on you, but I will make it heavier yet. My father chastised you with whips, but I will fix iron points to the lashes.'"
,"12":"On the third day, Jeroboam together with the people went back to Rehoboam just as the king said, for he had said to them, 'Come back on the third day.'"
,"13":"Ignoring the advice given him by the elderly counselors,"
,"14":"the king answered the people harshly in the way the greenhorns had advised him. He said, 'My father made your yoke heavy, but I will make it even heavier. My father chastised you with whips, but I will fix iron points to the lashes.'"
,"15":"The king did not listen to the people. It was, indeed, Yahweh who brought about this fateful event, fulfilling the word he had spoken to Jeroboam, son of Nebat, through Ahijah the Shilonite."
,"16":"All Israel realized that the king refused to listen to them, and they answered the same way, 'What have we to do with David? Is the son of Jesse from our tribes? Let the son of David deal with his own and you, people of Israel, go back to your homes!' And so the Israelites left for their homes."
,"17":"Only the Israelites who dwelt in the cities of Judah let Rehoboam reign over them."
,"18":"Rehoboam sent Adoram, task-master of the forced labor, but the Israelites stoned him to death and King Rehoboam had to mount his chariot and flee to Jerusalem."
,"19":"So Israel has been in rebellion against the house of David to the present time."
,"20":"As Jeroboam had returned and was with them at the assembly, having been called by them, they made him king of Israel. And so, with the exception of the tribe of Judah, no one followed the house of David."
,"21":"When Rehoboam came to Jerusalem, he called together all the people of Judah and the tribe of Benjamin, numbering a hundred and eighty thousand select warriors, to fight against the people of Israel in a bid to restore the kingship of Rehoboam, son of Solomon."
,"22":"But the word of God was directed to Shemaiah, the man of God,"
,"23":"'Give Rehoboam, son of Solomon, king of Judah, and all the people of Judah and Benjamin, and the rest of the people, this message from Yahweh:"
,"24":"You shall not go up to fight against your kinsmen, the Israelites. Let everyone return to his home for I am the author of this.' When they heard this word they went back home according to what Yahweh had ordered."
,"25":"Jeroboam fortified Shechem in the hill country of Ephraim and lived there. Then, he set out to fortify Penuel."
,"26":"Jeroboam thought, 'The kingdom could return to the house of David."
,"27":"Should this people go up to offer sacrifices in Yahweh's House in Jerusalem, their heart would turn again to their master, Rehoboam king of Judah. They would kill me and go back to him.'"
,"28":"And so the king sought advice and made two golden calves. Then he said to the people, 'You have been going up to Jerusalem long enough. Here are your gods, O Israel, who brought you up out of the land of Egypt.'"
,"29":"He put one of these in Bethel, the other in Dan."
,"30":"And so Jeroboam made the people sin; the people went as far as Dan to accompany one of them."
,"31":"Jeroboam also built temples on high places, appointing priests who were not from the Levites."
,"32":"Jeroboam also appointed a feast on the fifteenth day of the eighth month in imitation of the feast in Judah, and he himself offered sacrifices on the altar. This he did in Bethel and sacrificed to the calves that he had made; there he placed priests for the high places he had made."
,"33":"On the fifteenth day of the eighth month, the month which he had arbitrarily chosen, he ordained a feast for the Israelites and went up to the altar to burn incense."
}`)
	CurrentBook.AddChapter(13, `{
"1":"A man of God came out of Judah following a command of Yahweh, and he arrived at Bethel while Jeroboam was standing by the altar to burn incense."
,"2":"The man shouted, cursing the altar, 'O altar, altar, thus says Yahweh: There shall be born to the family of David a son by the name of Josiah. He shall sacrifice on you the priests of the high places who burn incense on you; and human bones shall be burned on you.'"
,"3":"And at once the man gave a sign. He said, 'This is the proof that Yahweh has spoken. The altar shall be torn down and the ashes on it shall be scattered.'"
,"4":"When the king heard the man of God shouting and cursing the altar of Bethel, he stretched out his hand from the altar and said, 'Arrest him!'"
,"5":"Immediately the hand which he pointed out against the man dried up and he could not draw it back. The altar itself crumbled and the ashes on it were scattered, according to the sign that had been given."
,"6":"And so the king said to the man of God, 'Entreat the favor of Yahweh your God and pray for me so that my hand may be restored.' The man of God entreated Yahweh and the king's hand was restored as it had been before."
,"7":"The king then said to the man of God, 'Come home with me and refresh yourself. I will give you a reward.'"
,"8":"But the man of God answered the king, 'Even if you give me half your house, I will not go in with you; nor will I eat or drink in this place, for this was commanded me by Yahweh."
,"9":"He precisely said to me: You shall neither eat bread nor drink water, nor return by the way you came.'"
,"10":"And the man did not return by the way he had come to Bethel, but he went another way."
,"11":"Now there was an old prophet living in Bethel, and his sons came to tell him what the man of God had done on that day in Bethel, and everything he had said to the king."
,"12":"Their father then asked them, 'Which way did he go?' and they told him which way the man of God from Judah had taken."
,"13":"He then said to his sons, 'Saddle the ass for me', and they did so."
,"14":"He mounted the ass and went after the man of God whom he found sitting under the Oak. He asked him, 'Are you the man of God who came from Judah? "
,"15":"Come home with me and eat bread.'"
,"16":"The prophet from Judah answered, 'I may neither return nor go in with you; nor will I eat or drink with you,"
,"17":"for this was the command of Yahweh: You shall neither eat bread nor drink water there, nor shall you return by the way you came.'"
,"18":"But the old prophet from Bethel said to him: 'I am also a prophet as you are; and an angel told me on behalf of Yahweh: Bring him back with you into your house that he may eat bread and drink water.'"
,"19":"The old prophet in fact, was lying. And so the man of God went back with him and ate and drank in his house."
,"20":"As they sat at table, the word of Yahweh came to the prophet who had brought him back."
,"21":"And he said in a loud voice to the man of God who came from Judah, 'Thus says Yahweh: You have disobeyed me and have not observed the command I gave you."
,"22":"Instead, you have come back and eaten and drunk although I told you not to eat bread or drink water. Because of this, your body shall not be laid in the tomb of your fathers.'"
,"23":"After he had eaten and drunk, the old prophet who had brought him back saddled the ass for him and the prophet from Judah went away."
,"24":"But a lion met him on the road and killed him. His body was thrown on the road with the lion beside it."
,"25":"People who passed by saw the body thrown on the road with the lion standing by; and they reported this in the city where the old prophet lived."
,"26":"When the prophet heard of this, he said, 'It is the man of God who disobeyed the word of Yahweh. Yahweh has delivered him to the lion which has torn and slain him just as Yahweh had told him.'"
,"27":"Then he said to his sons, 'Saddle the ass for me.'"
,"28":"They saddled it and he went and found the body thrown on the road with the ass and the lion standing beside it."
,"29":"The lion had neither eaten the body nor torn the ass. And so the prophet took up the body of the man of God, laid it on the ass and brought it back to the city to mourn and to bury him."
,"30":"He laid the body in his own grave and they mourned over him with the lament, 'Alas, my brother!'"
,"31":"After that the old prophet said to his sons, 'When I die, bury me in the grave where the man of God is buried and lay my bones beside his bones."
,"32":"For everything he said at Yahweh's command, cursing the altar in Bethel and all the sanctuaries of the high places in the cities of Samaria, will be fulfilled.'"
,"33":"After this, however, Jeroboam did not abstain from doing evil. Instead he made priests for the high places from among the people; he consecrated anyone who wanted to be a priest for the high places."
,"34":"And this became the sin of the family of Jeroboam for which it was to be cut off and destroyed from the face of the earth."
}`)
	CurrentBook.AddChapter(14, `{
"1":"At that time, Abijah, son of Jeroboam, fell ill."
,"2":"So the king told his wife. 'Go, disguise yourself so that no one may recognize you as Jeroboam's wife. Go to Shiloh where you will find Ahijah the prophet who foretold that I would be king over this people."
,"3":"Take with you ten loaves, a few cakes, and a jar of honey. Enter his house and he will tell you what shall happen to the child.'"
,"4":"Jeroboam's wife did as she was told and left for Shiloh. She entered the house of Ahijah who was now so old that he could not see."
,"5":"But Yahweh had told Ahijah, 'Jeroboam's wife is coming to consult you about her sick son, and this is what you must tell her. She will be coming in disguise.'"
,"6":"And so when Ahijah heard the sound of her footsteps, as she entered the door, he said, 'Come in, wife of Jeroboam. Why have you disguised yourself? I have been told to give you unpleasant news."
,"7":"Go, therefore; bring Jeroboam this message of Yahweh, the God of Israel:"
,"8":"I made you rise from the midst of the people and established you as the leader of Israel. I took the kingdom from David's family to give it to you. Yet you have not been like my servant David, who kept my commands and followed me with his whole heart, doing only what was pleasing to me."
,"9":"You have done worse than anyone before you. You have made me angry with your strange gods and the images you have made; and you have forsaken me."
,"10":"Now, I shall bring disaster on the family of Jeroboam. I will cut off every male in Jeroboam's line, whether slave or freeman in Israel, and I will wipe out the descendants of Jeroboam just as they wipe out the dung till all is gone."
,"11":"He who dies in the city will be devoured by dogs; he who dies in the field, by the birds of the sky. So Yahweh has spoken!"
,"12":"Leave now, and go back home! As soon as you enter the city, the child will die."
,"13":"All Israel will mourn for him and bury him. He alone of Jeroboam's line will be buried, for in him alone has Yahweh, the God of Israel, found something good."
,"14":"Yahweh himself will raise up for himself a king of Israel; it is he who will destroy Jeroboam's family."
,"15":"Yahweh will strike Israel like a reed tossed about in the water and root them out from this good land which he gave to their ancestors. He will scatter them beyond the river Euphrates because they made him angry with the sacred poles they set up."
,"16":"Yahweh will scatter Israel because of the sins Jeroboam has committed and by which he dragged Israel into sin.'"
,"17":"So Jeroboam's wife went home. On her arrival at Tirzah, and as soon as she crossed the threshold of her house, the child died."
,"18":"The child was buried and all Israel mourned over him just as Yahweh had prophesied through his servant the prophet Ahijah."
,"19":"The rest of the acts of Jeroboam, his achievements in war and his reign, are recorded in the Book of Chronicles of the Kings of Israel."
,"20":"Jeroboam reigned for twenty-two years. When he rested with his fathers, his son Nadab succeeded him as king."
,"21":"As for Rehoboam, son of Solomon, he was forty-one when he began to reign over Judah. He reigned for seventeen years in Jerusalem, the city which Yahweh chose out of all the tribes of Israel to put his Name there. His mother Naamah was an Ammonite."
,"22":"The people of Judah did what displeased Yahweh and, by their sins, angered him even more than their ancestors had done."
,"23":"They also built for themselves high places, pillars and sacred poles on every high hill and under every green tree."
,"24":"They even had male cult prostitutes in their land. Judah followed all the abominable practices of the nations whom Yahweh had driven out before the Israelites."
,"25":"In the fifth year of King Rehoboam, Shishak, king of Egypt, attacked Jerusalem"
,"26":"and looted everything, including the treasures of Yahweh's house and of the royal palace. As he had taken the golden shields made under Solomon,"
,"27":"Rehoboam replaced them with brazen shields and entrusted them to the officers of the guard who watched at the door of the king's palace."
,"28":"Every time the king went into Yahweh's House, the guards took them out and then brought them back to the guardroom."
,"29":"The rest of the events of Rehoboam's reign, including his deeds, are all written in the Book of the Chronicles of the Kings of Judah."
,"30":"There was incessant war between Rehoboam and Jeroboam."
,"31":"Then Rehoboam rested with his fathers and was buried with his ancestors in the City of David. His mother Naamah was an Ammonite. His son Abijam succeeded him as king."
}`)
	CurrentBook.AddChapter(15, `{
"1":"In the eighteenth year of King Jeroboam, son of Nebat, Abijam became king of Judah"
,"2":"and reigned for three years in Jerusalem. His mother's name was Maacah, daughter of Abishalom."
,"3":"He imitated all the sins his father had committed before him and, unlike his ancestor David, was not wholly faithful to Yahweh, his God."
,"4":"Yet Yahweh had promised David that he would keep his lamp burning in Jerusalem; he would raise his descendants after him and establish Jerusalem."
,"5":"This was because David had pleased Yahweh and did not disobey any of his commands as long as he lived, except in the case of Uriah the Hittite."
,"7":"The rest of the events of Abijam's reign and everything he did are written in the Book of the Chronicles of the Kings of Judah. There was war between Abijam and Jeroboam."
,"8":"When Abijam rested with his fathers, he was buried in the city of David, and his son Asa reigned in his place."
,"9":"In the twentieth year of Jeroboam, king of Israel, Asa, king of Judah, began to reign and"
,"10":"was king for forty-one years, ruling in Jerusalem. His grandmother was Maacah, daughter of Abishalom."
,"11":"Asa did what was right before Yahweh, just as his ancestor David had done."
,"12":"He rid the land of male cult prostitutes and removed all the idols his ancestors had made."
,"13":"He also deposed his grandmother Maacah as queen mother, for having made an abominable image for Asherah. Asa destroyed Asherah's image and burned it at the brook Kidron;"
,"14":"he did not, however, close down the high places. Nevertheless, Asa remained faithful to Yahweh for the rest of his life."
,"15":"He brought into Yahweh's house both the votive gifts of his father and his own: silver, gold and vessels."
,"16":"Asa and Baasha, king of Israel, were at war during their reigns."
,"17":"Baasha, king of Israel, attacked Judah and fortified Ramah to cut off all communication with Asa, king of Judah."
,"18":"Asa, in the meantime, collecting all the silver and gold remaining in the treasuries of the temple of Yahweh and the royal palace, entrusted them to his servants whom he sent to Ben-hadad, son of Tabrimmon, son of Hezion, king of Syria who reigned in Damascus."
,"19":"He sent him this message, 'Let us together make a treaty just as my father and yours did. I am sending you silver and gold, so please break your treaty with Baasha, king of Israel that he may withdraw from my territory.'"
,"20":"Ben-hadad acceded to King Asa's request and sent his officers to harass the cities of Israel, capturing Ijon, Dan, Abel-beth-maacah, all the land of Chinneroth and the region of Naphtali."
,"21":"On hearing this, Baasha stopped the fortification of Ramah and moved to Tirzah where he lived."
,"22":"Then King Asa issued an order to all of Judah, excluding no one, to take away the stones and timber which Baasha had been using to fortify Ramah. With these materials, King Asa built Geba of Benjamin and Mizpah."
,"23":"The rest of Asa's reign, his bravery, his deeds and the cities which he built are written in the Book of the Chronicles of the Kings of Judah. In his old age, Asa suffered from a foot disease."
,"24":"Asa then rested with his fathers and was buried in the City of David his ancestor. His son Jehoshaphat reigned in his place."
,"25":"Nadab, son of Jeroboam, began to reign over Israel in the second year of Asa, king of Judah."
,"26":"He reigned over Israel for two years, doing what displeased Yahweh and dragging Israel into sin as his father had done."
,"27":"Baasha, son of Ahijah of the family of Issachar, plotted against him and struck him down at Gibbethon of the Philistines when Nadab and the Israelites were laying siege to this city."
,"28":"Baasha killed Nadab in the third year of Asa king of Judah and reigned in his place."
,"29":"As soon as he was king, he killed off the entire family of Jeroboam, leaving him no one alive but wiping them out according to the word which Yahweh had spoken through his servant Ahijah, the Shilonite."
,"30":"This happened because of Jeroboam who aroused the anger of Yahweh, the God of Israel, by sinning and dragging Israel into sin."
,"31":"The rest of the events of Nadab's reign and his achievements are written in the Book of the Chronicles of the Kings of Israel."
,"32":"Asa and Baasha were at war during their reigns."
,"33":"In the third year of Asa king of Judah, Baasha, son of Ahijah, began to reign over all Israel at Tirzah where he reigned for twenty-four years."
,"34":"He did what displeased Yahweh and sinned just as Jeroboam, who dragged Israel into sin, had done."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Yahweh spoke to Jehu, son of Hanani, to condemn Baasha. He said,"
,"2":"'I have raised you from the dust to make you rule over my people Israel, but you have made me angry by going the way of Jeroboam and dragging my people Israel into sin."
,"3":"I will therefore sweep away Baasha and his family and deal with them as I did with Jeroboam, son of Nebat."
,"4":"Dogs will devour those of Baasha's line who die in the City, the birds of the air will feed on those who die in the country.'"
,"5":"The rest of the events of Baasha's reign, his deeds and achievements are written in the Book of the Chronicles of the Kings of Israel."
,"6":"Baasha rested with his fathers and was buried at Tirzah, while Elah his son reigned in his place."
,"7":"Yahweh indeed spoke through the prophet Jehu, son of Hanani, to condemn Baasha and his family, not only for doing what displeased Yahweh, making him angry as Jeroboam had done, but also because he murdered the family of Jeroboam."
,"8":"In the twenty-sixth year of Asa king of Judah, Elah, son of Baasha, began to reign over Israel in Tirzah and was king for two years."
,"9":"But his servant Zimri, commander of half his chariots, plotted against him. While Elah was getting himself drunk in the house of Arza, governor of Tirzah,"
,"10":"Zimri came in, struck him down and killed him. This happened in the twenty-seventh year of Asa, king of Judah. Then Zimri reigned in his place."
,"11":"As soon as Zimri began to reign, he had the entire family of Baasha killed, leaving him not a single male relative or friend."
,"12":"Zimri wiped out the entire house of Baasha according to Yahweh's pronouncement against him as spoken by Jehu, the prophet."
,"13":"And this happened because of the sins which Baasha and his son had committed, dragging Israel into sin and making Yahweh angry with their idols."
,"14":"Now the rest of the events of Elah's reign and all his deeds are written in the Book of the Chronicles of the Kings of Israel."
,"15":"It happened in the twenty-seventh year of Asa, king of Judah, that Zimri reigned seven days in Tirzah."
,"16":"For the army was besieging Gibbethon of the Philistines when Zimri plotted against Elah, and, on hearing that he had killed the king, they proclaimed Omri, commander of the army, king of Israel."
,"17":"Omri went up with the Israelites from Gibbethon and attacked Tirzah."
,"18":"When Zimri saw that the city was to be captured, he went into the citadel of the royal palace; he set the royal palace on fire, and he died."
,"19":"He died thus because of the sins he had committed, doing what displeased Yahweh and going the way of Jeroboam by dragging Israel into sin."
,"20":"The rest of the acts of Zimri and his plot are written in the Book of the Chronicles of the Kings of Israel."
,"21":"The Israelites were then divided; half of them followed Tibni, son of Ginath to make him king; the other half followed Omri."
,"22":"Those who followed Omri overcame those who followed Tibni, son of Ginath. And so, Tibni died and Omri became king."
,"23":"In the thirty-first year of Asa, king of Judah, Omri began to reign over Israel. He reigned for twelve years, six years of which he reigned in Tirzah."
,"24":"Then he bought the hill of Samaria from Shemer for two talents of silver. He built a city on the hill and called it Samaria, after Shemer, the owner of the hill."
,"25":"Omri did what displeased Yahweh, even more than all those who preceded him."
,"26":"He went the way of Jeroboam, son of Nebat, and dragged Israel into sin, thereby provoking the anger of Yahweh, the God of Israel, by their idols."
,"27":"The rest of the acts of Omri and his bravery are written in the Book of the Chronicles of the Kings of Israel."
,"28":"Then Omri rested with his fathers and was buried in Samaria while Ahab, his son, reigned in his place."
,"29":"Ahab, son of Omri became king in the thirty-eighth year of Asa, king of Judah, and he reigned over Israel in Samaria for twenty-two years."
,"30":"Ahab, son of Omri did what displeased Yahweh, even more than all those who preceded him."
,"31":"Apparently the example and the sins of Jeroboam son of Nebat were not enough for him; he even married Jezebel, daughter of Ethbaal, king of the Sidonians. So he served Baal and worshiped him."
,"32":"He set up an altar for Baal in the temple of Baal which he built in Samaria"
,"33":"and proceeded to make an Asherah. So Ahab did everything that could make Yahweh angry, even more than any of the kings of Israel who ruled before him."
,"34":"During his reign, Hiel of Bethel rebuilt Jericho. On laying its foundation he sacrificed Abirma, his firstborn. And when he set up the gates of the city, he sacrificed his youngest son, Segub, in accordance with the word of Yahweh spoken through Joshua, son of Nun."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Now Elijah, the prophet from Tishbe in Gilead, said to Ahab, 'As Yahweh, the God of Israel whom I serve lives, neither dew shall drop nor rain fall except at my command.'"
,"2":"Then the word of Yahweh came to Elijah,"
,"3":"'Leave this place and go eastward. Hide yourself by the brook Cherith, east of the Jordan."
,"4":"You shall drink from the brook and, for your food, I have commanded the ravens to feed you there.'"
,"5":"So Elijah obeyed the word of Yahweh and went to live by the brook Cherith, east of the Jordan."
,"6":"There the ravens brought him bread in the morning and meat in the evening; and he drank from the brook."
,"7":"After a while, the brook dried up because no rain had fallen in the land."
,"8":"Then Yahweh spoke to Elijah,"
,"9":"'Go to Zarephath of the Sidonites and stay there. I have given word to a widow there to give you food.'"
,"10":"So Elijah went to Zarephath. On reaching the gate of the town, he saw a widow gathering sticks. He called to her and said, 'Bring me a little water in a vessel that I may drink.'"
,"11":"As she was going to bring it, he called after her and said, 'Bring me also a piece of bread.'"
,"12":"But she answered, 'As Yahweh your God lives, I have no bread left but only a handful of flour in a jar and a little oil in a jug. I am just now gathering some sticks so that I may go in and prepare something for myself and my son to eat - and die.'"
,"13":"Elijah then said to her, 'Do not be afraid. Go and do as you have said, but first make me a little cake of it and bring it to me; then make some for yourself and your son."
,"14":"For this is the word of Yahweh, the God of Israel, 'The jar of meal shall not be emptied nor shall the jug of oil fail, until the day when Yahweh sends rain to the earth.'"
,"15":"So she went and did as Elijah told her; and she had food for herself, Elijah and her son from that day on."
,"16":"The jar of flour was not emptied nor did the jug of oil fail, in accordance with what Yahweh had said through Elijah."
,"17":"After this, the son of this housewife became ill. And such was his illness that he stopped breathing."
,"18":"She then said to Elijah, 'What did you do, O man of God? Have you come to uncover past sins and cause my son's death?'"
,"19":"He answered, 'Give me your son.',Taking him from her lap, he carried him up to the upper room where he was staying and laid him on his own bed. "
,"20":"Then he called on Yahweh, 'O Yahweh, my God, will you afflict even the widow with whom I am residing by letting her son die?'"
,"21":"Then he stretched himself on the child three times and called on Yahweh, 'O Yahweh, my God, let this child's breath return to him.'"
,"22":"Yahweh listened to the pleading of Elijah and the child's breath returned to him, and he lived."
,"23":"Elijah then took the child and brought him down from the upper room. He gave him to his mother and said, 'See, your son is alive.'"
,"24":"Then the woman said to Elijah, 'Now I am certain that you are a man of God, and that your words really came from Yahweh.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"After several days (in the third year) Yahweh spoke to Elijah and said, 'Go, show yourself to Ahab that I may let it rain on the earth.'"
,"2":"So Elijah went to show himself to Ahab."
,"3":"Now the famine in Samaria was severe. Ahab therefore called Obadiah, who was in charge of the household."
,"4":"(Obadiah was a faithful servant of Yahweh and when Jezebel slew the prophets of Yahweh he himself took a hundred prophets and hid them by fifties in caves, feeding them with bread and water.)"
,"5":"Then Ahab told Obadiah, 'Let's go and check all the watersprings and the valleys through the land, looking for grass so that the horses and mules may be kept alive and not perish.'"
,"6":"So Ahab and Obadiah divided the land between them and each of them went his own way."
,"7":"As Obadiah was going his way, Elijah met him. Recognizing Elijah, Obadiah fell on his face and said, 'Is that you, my master Elijah?'"
,"8":"He answered him, 'It is I. Go tell your master that I am here.'"
,"9":"But Obadiah replied, 'What evil have I done that you expose me to Ahab's anger? Surely you want me to die."
,"10":"By Yahweh, your God, there is no people or nation where my master has not searched for you and if they said, 'Elijah is not here,' he would make them take an oath that they had not found you."
,"11":"Yet now as soon as I leave to inform Ahab of your presence,"
,"12":"the Spirit of Yahweh will transport your goodness elsewhere, and when Ahab fails to find you, he will kill me. But I have served Yahweh from my youth."
,"13":"Do you not know that when Jezebel had the prophets of Yahweh killed, I hid a hundred of them in two caves and fed them with bread and water?"
,"14":"Now if I notify Ahab of your presence, as you want me to do, he will surely kill me!'"
,"15":"But Elijah said to him, 'By Yahweh of hosts whom I serve, I will show myself to him today.'"
,"16":"So Obadiah went to give Ahab this message and Ahab came to meet Elijah."
,"17":"On seeing Elijah, Ahab said to him, 'Is it you, the plague of Israel?'"
,"18":"Elijah replied, 'Who is troubling Israel? Isn't it you and your family who have disobeyed the commands of Yahweh and followed instead the Baals?"
,"19":"Now, therefore, give an order for the Israelites to gather before me at Mount Carmel, together with the four hundred and fifty prophets of Baal who are sustained by Jezebel.'"
,"20":"So Ahab sent for all the people of Israel and gathered the prophets at Mount Carmel."
,"21":"Then Elijah ad-dressed the people and asked, 'How long will you follow two ways at the same time? If Yahweh is God, follow him; but if Baal is God then follow him.' The people remained silent."
,"22":"So Elijah continued, 'I am the only prophet of Yahweh left here to face Baal's four hundred and fifty prophets."
,"23":"Get us two bulls. Let them choose one bull for themselves, cut it into pieces and lay it on the wood and I will do the same with the other bull. But we will not set it on fire."
,"24":"Then you shall call on the name of your god while I shall call on the name of Yahweh. The God who answers with fire is the true one.' Then the people answered, 'That is right.'"
,"25":"Then Elijah told the prophets of Baal, 'Choose for yourselves one bull and prepare it first, for you are many. Then call on the name of your god lest you are left without fire!'"
,"26":"So they took the bull and prepared it, and they called on the name of Baal, 'Baal, answer us!' But there was no voice and no one answered them while they went on dancing on one foot around the altar they had built."
,"27":"By noontime, Elijah began to mock them, 'Shout out louder. Baal is a busy god; or he may have gone out or perhaps he has gone on a trip, or he is sleeping and must be wakened.'"
,"28":"So they shouted louder gashing their skin with knives, as they are used to doing, until they bled."
,"29":"It was already past noon and they were still raving on until the time of the evening offering. But still there was no voice; no one answered or gave a sign of life."
,"30":"Then Elijah said to the people, 'Draw closer to me,' and the people drew closer to him. He then repaired the altar of Yahweh which had been thrown down."
,"31":"He took twelve stones corresponding to the number of tribes of the sons of Jacob whom Yahweh had addressed saying, 'Israel shall be your name.'"
,"32":"With these stones, he built an altar to the Name of Yahweh and dug a trench around it that would contain about thirty liters."
,"33":"He then arranged the firewood, cut the bull in pieces and laid them on the wood. Then, he said, 'Fill four jars with water and pour it on the burnt offering and on the firewood.'"
,"34":"He said, 'Do it again'; and they did it again; 'one more time,' and they did it a third time."
,"35":"The water ran around the altar and filled the trench."
,"36":"When the time of the evening offering came, Elijah the prophet came near and said, 'O Yahweh, God of Abraham, Isaac and Israel, let it be known today that you are God in Israel and that I am your servant, doing all these things at your command."
,"37":"Answer me, O Yahweh, answer me so that this people may know that you, O Yahweh, are God and that you are turning back their hearts to you.'"
,"38":"Then the fire of Yahweh fell and consumed the burnt offering, together with the wood, the stones also, and the dust; the water also dried up in the trench."
,"39":"All the people witnessed this. Then they fell on their faces and said, 'Yahweh is God! Yahweh is God!'"
,"40":"Then Elijah commanded them, 'Seize the prophets of Baal and let none of them escape.' And so they seized them. Then Elijah brought them down to the brook Kidron and had them slaughtered there."
,"41":"Elijah then said to Ahab, 'Go up, eat and drink, for the sound of rain is rushing in.'"
,"42":"So Ahab went up to eat and drink. Elijah, in the meantime, went to the top of Carmel, bowed to the ground and put his face between his knees."
,"43":"Then he said to his servant, 'Go up and look in the direction of the sea.' The man went up, looked, and said, 'There is nothing.' Then Elijah said, 'Go again' and seven times he went."
,"44":"At the seventh time, he perceived a little cloud, the size of a man's hand, rising out of the sea. Elijah told him, 'Go, tell Ahab: Prepare your chariot and go down before the rain stops you.'"
,"45":"A little later the sky grew dark with clouds and wind and a strong rain fell. Ahab was riding on his way to Jezreel;"
,"46":"as for Elijah, the hand of Yahweh was on him, and tucking his cloak in his belt, he ran before Ahab to the entrance of Jezreel."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Ahab told Jezebel everything Elijah had done and how he had slain all the prophets with the sword."
,"2":"Jezebel then sent word to Elijah, 'May I be cursed if by this time tomorrow I have not dealt with you as you dealt with them.'"
,"3":"Elijah was scared and fled for his life. He reached Beer-sheba of Judah and left his servant there."
,"4":"He himself disappeared into the desert going on a day's journey. Then he sat down under a broom tree and prayed to die, 'That is enough, Yahweh, take away my life for I am dying.'"
,"5":"He lay down and went to sleep under the broom tree. Then an angel touched him and said, 'Get up and eat.'"
,"6":"Elijah looked and saw, at his head, a cake baked on hot stones and a jar of water. He ate and drank and went back to sleep."
,"7":"The angel of Yahweh came a second time to him, saying, 'Get up and eat, for the journey is too long for you.'"
,"8":"He got up, ate and drank, and on the strength of that food, he traveled for forty days and forty nights to Horeb, the mount of God."
,"9":"On reaching the place, he came to the cave and stayed in it. Then the word of Yahweh came to him,'What are you doing here, Elijah?'"
,"10":"He answered, 'I am burning with jealous love for Yahweh, the God of Hosts, because the Israelites have forsaken your covenant, thrown down your altars, and slain your prophets with the sword. No one is left but myself and they are still trying to kill me as well.'"
,"11":"Then Yahweh said, 'Go up and stand on the mount, waiting for Yahweh.' And Yahweh passed by. There was first a windstorm, wild wind which rent the mountains and broke the rocks into pieces before Yahweh, but Yahweh was not in the wind. After the storm, an earthquake, but Yahweh was not in the earthquake. "
,"12":"After the earthquake, a fire, but Yahweh was not in the fire. After the fire, the murmur of a gentle breeze."
,"13":"When Elijah perceived it, he covered his face with his cloak, went out and stood at the entrance of the cave. Then he heard a voice addressing him again, 'What are you doing here, Elijah?' "
,"14":"He answered, 'I am burning with jealous love for Yahweh, the God of hosts, because the Israelites have forsaken your covenant, thrown down your altars and slain your prophets with the sword. No one is left but myself, yet they still seek my life to take it away.'"
,"15":"Yahweh said to him, 'Take the road back through the desert and go to Damascus for you must anoint Hazael as king of Syria;"
,"16":"you shall also anoint Jehu, son of Minshi, as king over Israel; and Elisha, son of Shaphat, from Abelmehrah, you shall anoint as prophet in your place."
,"17":"Whoever escapes from the sword of Hazael will be slain by Jehu and whoever escapes from the sword of Jehu, Elisha will let him die."
,"18":"Yet I will spare seven thousand in Israel who have not knelt before Baal and whose lips have not kissed him.'"
,"19":"So Elijah left. He found Elisha, son of Shaphat, who was plowing a field of twelve acres and was at the end of the twelfth acre. Elijah passed by him and cast his cloak over him."
,"20":"Elisha left the oxen, ran after Elijah and said, 'Let me say goodbye to my father and mother; then I will follow you.' Elijah said to him, 'Return if you want, don't worry about what I did.'"
,"21":"However, Elisha turned back, took the yoke of oxen and slew them. He roasted their meat on the pieces of the yoke and gave it to his people who ate of it. After this, he followed Elijah and began ministering to him."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Ben-hadad, king of Aram, gathered together his entire army. With him were thirty-two kings. With horses and chariots, he went to Samaria and besieged it."
,"2":"He then sent messengers into the city to Ahab, king of Israel, and said to him, 'Thus says Ben-hadad:"
,"3":"Your silver and gold are mine and so are your fairest wives and children.'"
,"4":"The king of Israel answered, 'As you say, my master, O king, I am yours with all that I possess.'"
,"5":"Again Ben-hadad sent messengers to say, 'I sent this message to you: 'Hand over to me your silver and gold, along with your wives and children,'"
,"6":"but now I will send my servants to you tomorrow about this time. They shall search your house and those of your officials and take with them whatever they want to take.'"
,"7":"Then the king of Israel summoned all the elders of the land and said, 'Look now and see how this man acts with evil intentions. He will send his officers to take my wives and children, and my silver and gold, although I agreed to deliver all to him.'"
,"8":"The elders and the people said to him, 'Pay no attention to him and do not agree to what he asks.'"
,"9":"So the king of Israel told Ben-hadad's messengers, 'Tell my master, the king, I will do everything you first demanded of me, but now it is too much.' The messengers left and reported this to"
,"10":"Ben-hadad who then answered, 'May I be cursed if enough dust remains of Samaria to give a handful to all the people who follow me.'"
,"11":"But the king of Israel answered, 'Let not he who puts on his armor boast like one who takes it off.'"
,"12":"Ben-hadad was drinking with the kings in the booths when he heard this message. So he said to his officers, 'Take your positions.' And they took their positions against the city."
,"13":"Then a prophet approached Ahab king of Israel and said, 'Have you seen this immense crowd? This is the word of Yahweh: I will deliver it into your hands today and you shall know that I am Yahweh.'"
,"14":"Ahab asked, 'Who is to win over him?' The prophet replied, 'The guards of the governors of the districts, for this is Yahweh's order.' Again the king asked, 'Who shall begin the battle?' He replied, 'You!'"
,"15":"And so the king of Israel mustered the guards of the governors of the districts, numbering two hundred and thirty-two. After that, he mustered all the Israelites, numbering seven thousand."
,"16":"They set out at noon while Ben-hadad was drinking himself drunk in the booths, together with the thirty-two kings who helped him."
,"17":"The guards of the governors of the districts went out first. Someone reported to Ben-hadad, 'People are coming out from Samaria.'"
,"18":"He said, 'If they have come out for peace, take them alive; if for war, take them alive as well.'"
,"19":"So the guards of the governors of the city went out, and the army followed them,"
,"20":"and each one began to kill his man. The Arameans fled, with the Israelites pursuing them. Ben-hadad, king of Aram was able to escape on a horse with horsemen,"
,"21":"but the king of Israel captured horses and chariots and utterly defeated the Arameans."
,"22":"Then the prophet came again to the king of Israel and said to him,'Courage, be on your guard and ponder well your next action, for next year the king of Aram will come up against you.'"
,"23":"The officers of the king of Aram said to him, 'Their gods are gods of the hills; that is why they were stronger than us."
,"24":"Let us fight against them on the plain and we shall overcome them. But you must also replace the princes with officers appointed by you."
,"25":"When you have gathered an army like the one you have lost, with the same amount of horses and chariots, we will fight on the plain, then we shall see who is stronger.' Ben-hadad listened to their advice and did just that."
,"26":"In the spring, Ben-hadad mustered the Arameans and set out for Aphek to fight against Israel."
,"27":"The Israelites were also mustered and they set out against the Arameans. As they encamped, the Israelites looked like two little herds of goats, whereas the Arameans filled the countryside."
,"28":"A man of God approached the king of Israel and said to him, 'Thus says Yahweh: Because the Arameans have said: 'Yahweh is a god of the hills but not of the valleys,' therefore I will deliver this immense crowd into your hands and you shall know that I am Yahweh.'"
,"29":"And they encamped facing each other for seven days. On the seventh day, the battle was engaged and that day the Israelites killed a hundred thousand Aramean foot soldiers. "
,"30":"As the rest fled into the city of Aphek, the wall fell on the twenty-seven thousand men that were left. Ben-hadad himself fled and entered an inner room in the city."
,"31":"His officers said to him, 'People say that the kings of Israel are merciful kings. Let us put sackcloth around our waists; perhaps he will spare your life.'"
,"32":"So, putting sackcloth around their waists and ropes around their necks, they went to the king of Israel and said, 'Your servant, Ben-hadad, pleads, 'Please, let me live.' He then asked, 'Is he still alive? He is my brother.'"
,"33":"They quickly took up his word and said, 'Yes, Ben-hadad is your brother.' The king of Israel then said, 'Go, bring him here.',Ben-hadad came to him and he let Ben-hadad get into his chariot. "
,"34":"Ben-hadad then said to him, 'I will give back the cities which my father took from your father, and you may put up business establishments for yourself in Damascus just as my father did in Samaria.' He then made an agreement with Ben-hadad and let him go."
,"35":"Now the word of Yahweh was directed to one of the fellow prophets, so he said to his companion, 'Strike me, please.' But his companion refused to strike him."
,"36":"So he said to him, 'Since you have not obeyed the voice of Yahweh, once you leave me, a lion shall kill you.' And, indeed, as soon as he had left, a lion found him and killed him."
,"37":"Then the fellow prophet found another man to whom he said, 'Please, strike me.' This man struck him, wounding him."
,"38":"Then this prophet left, disguising himself with a bandage over his eyes, and waited for the king along the road."
,"39":"When the king passed, he called to him and said, 'O King! I, your servant, went into the thick of the battle when a soldier left the line and brought me a man, saying: 'Guard this man. Should he escape, your life shall be in exchange for his, or else you shall pay a talent of silver.'"
,"40":"While I was busy running around, my prisoner disappeared.' The king of Israel said to him, 'You yourself have said what your sentence shall be.'"
,"41":"At once the man removed the bandage from his eyes and the king of Israel recognized him as one of the prophets."
,"42":"Then the prophet told him, 'Because you have released the man whom I have decreed to die, your life shall be in exchange for his and your people for his people.'"
,"43":"And the king of Israel went back home to Samaria, resentful and sad."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Now Naboth, a man from Jezreel, owned a vineyard just beside the palace of Ahab, king of Samaria."
,"2":"Ahab asked Naboth, 'Give me your vineyard which is near my house that I may use it for a vegetable garden. I will give you a better vineyard in exchange. Or, if you prefer, I will pay you its price.'"
,"3":"But Naboth said to Ahab, 'Yahweh forbid that I should give you the inheritance of my fathers.'"
,"4":"So Ahab went home angry and sad because of what Naboth had told him, that he would not give him the inheritance of his fathers. So he lay down on his bed with his face turned toward the wall and refused to eat."
,"5":"His wife Jezebel came to him and said, 'Why are you so angry that you refuse to eat?'"
,"6":"He answered, 'I spoke to Naboth the Jezreelite and asked him to sell me his vineyard or to exchange it for another better one but he answered: I will not give you my vineyard.'"
,"7":"His wife Jezebel said to him, 'Are you not king of Israel? Get up and eat and be joyful, for I will give you the vineyard of Naboth of Jezreel.'"
,"8":"So Jezebel wrote letters using Ahab's name and sealed them with his seal, and sent the letters to the elders and important persons living near Naboth."
,"9":"This is what she wrote in the letters, 'Declare a fast and put Naboth on trial."
,"10":"Get two worthless fellows to accuse him in this way: 'You have cursed God and the king.' Then take him out and stone him to death.'"
,"11":"The people, the elders and the important persons who lived in his city did as Jezebel had instructed them in the letters she sent to them."
,"12":"They declared a fast and put Naboth on trial."
,"13":"The two worthless fellows came in and sat facing him, accusing Naboth before the people, 'Naboth cursed God and the king!' So the people took him outside the city and stoned him to death."
,"14":"They then sent word to Jezebel that Naboth had been stoned and was dead."
,"15":"As soon as Jezebel heard that Naboth had been stoned and was dead, she told Ahab, 'Now take possession of the vineyard of Naboth, the man of Jezreel who refused to sell it to you, for Naboth is now dead.'"
,"16":"As soon as Ahab heard that Naboth was dead, he went down to the vineyard of Naboth and took possession of it."
,"17":"Then Yahweh spoke to Elijah of Tishbe,"
,"18":"'Go down to meet Ahab, king of Israel, in Samaria. He is taking possession of the vineyard of Naboth."
,"19":"Say to him: 'Have you killed and have taken possession at the same time?' Then give him this word of mine: 'Dogs shall lick your blood in the very place where the dogs licked the blood of Naboth.''"
,"20":"Ahab then said to Elijah, 'Who, better than my enemy, could find me here and now!' Elijah answered, 'I have come to you because you have done what Yahweh abhors."
,"21":"This is Yahweh's word: I will bring disgrace on you. I will sweep you away and cut off every male of your family, from the lowliest to the greatest."
,"22":"Your family will disappear like the families of Jeroboam and Baasa, because you have offended me and have dragged Israel into sin."
,"23":"There is another word of Yahweh to Jezebel: 'The dogs shall devour Jezebel within the territory of Jezreel.'"
,"24":"If anyone of Ahab's line dies in the city, he shall be devoured by dogs; if in the green country, the birds of the air shall feed on him.'"
,"25":"There was no one like Ahab, urged by his wife Jezebel, in doing what Yahweh abhorred."
,"26":"He did horrible things and ran after unclean idols just as the Amorites had done, from whom Yahweh had taken the land to give it to Israel."
,"27":"On hearing these words, Ahab tore his clothes and put on sackcloth. He fasted as he lay in sackcloth and moved around despondently."
,"28":"Then Yahweh said to Elijah the Tishbite, 'Have you seen how Ahab has humbled himself?"
,"29":"Because of this I will not bring about the disaster during his reign; during his son's reign disgrace will fall on his family.'"
}`)
	CurrentBook.AddChapter(22, `{
"1":"There was no war between Aram and Israel for three years."
,"2":"But in the third year, Jehoshaphat, king of Judah, came down to the king of Israel."
,"3":"The king of Israel then talked to his officers, 'Have you forgotten that Ramoth-gilead belongs to us? Yet we do nothing to take it back from the Arameans.'"
,"4":"So he asked Jehoshaphat, 'Will you come with me to conquer Ramoth-gilead?' Jehoshaphat answered the king of Israel, 'I am with you, my people are with your people, and my horses with yours.'"
,"5":"Jehoshaphat, king of Judah, said to the king of Israel, 'Let us consult Yahweh before setting out for war.'"
,"6":"So the king of Israel gathered all the prophets, numbering about four hundred men, and asked them, 'Shall I go to conquer Ramoth-gilead, or shall I hold back?' They replied, 'Go, for Yahweh will deliver the city into your hands.'"
,"7":"Jehoshaphat asked, 'Is there no other prophet of Yahweh around here whom we might ask?'"
,"8":"The king of Israel answered, 'There is still one through whom we may ask for Yahweh's counsel; but I hate him, for he never prophesies good about me but only evil. It is Micaiah, son of Imlah.' Then Jehoshaphat said, 'Don't speak in this manner.'"
,"9":"So the king of Israel called an official and told him, 'Bring quickly Micaiah, son of Imlah.'"
,"10":"Meantime, the king of Israel and Jehoshaphat, king of Judah, were seated on their thrones, fully robed. They were both at the threshing floor by the entrance gate of Samaria where the prophets continued to prophesy before them."
,"11":"There was Zedekiah, son of Chenaanah who made for himself horns from iron and said, 'Thus says Yahweh: 'With these horns you shall strike the Arameans until they are destroyed.'"
,"12":"All the prophets said the same, 'Go to Ramoth-gilead and triumph. Yahweh will deliver it into the hands of the king.'"
,"13":"The official who went to summon Micaiah said to him, 'Look here, all the prophets agree to foretell a happy end to the king. You too agree to speak favorably.'"
,"14":"But Micaiah replied, 'As Yahweh lives, I will speak what Yahweh tells me to.'"
,"15":"When he had come, the king asked him, 'Micaiah, shall we go to conquer Ramoth-gilead or shall we hold back?' Then Micaiah answered, 'Go and triumph! Yahweh will give the city into the hands of the king!'"
,"16":"But the king said to him, 'How many times shall I ask you to speak seriously to me and tell me the truth in the name of Yahweh?'"
,"17":"Then Micaiah said, 'I saw all Israel scattered on the mountains like sheep without a shepherd. Then Yahweh said: These have no master; so let each return to his home in peace.'"
,"18":"So the king of Israel said to Jehoshaphat, 'Did I not tell you that he would not prophesy good about me, but only evil?'"
,"19":"Micaiah replied, 'Listen again to this word of Yahweh. I saw Yahweh sitting on his throne with the entire host of Heaven standing beside him on his right and on his left."
,"20":"Then Yahweh asked: 'Who will deceive the king of Israel that he may go and fall at Ramoth-gilead?' One said one thing and another, another thing."
,"21":"Then a spirit came forward and stood before Yahweh, saying: 'I will deceive him.'"
,"22":"Yahweh then asked him, 'What will you do?' To this he replied: 'I will go and make myself a lying spirit on the lips of all his prophets.' Then Yahweh said, 'You shall succeed. Go and do just that.'"
,"23":"You must know that Yahweh has put a lying spirit in the mouths of all these prophets of yours because he willed to bring evil on you.'"
,"24":"Then Zedekiah, son of Chena-anah, approached Micaiah, struck him, and said, 'Has the Spirit of Yahweh left me to speak to you?'"
,"25":"Micaiah replied, 'You shall discover for yourself on the day you flee from house to house to hide.'"
,"26":"Then the king of Israel ordered, 'Seize Micaiah and take him back to Amon, governor of the city, and to Joash, the king's son."
,"27":"Give them this order: 'Throw this man in prison and feed him with scant fare of bread and water until I come in peace.'"
,"28":"Then Micaiah said, 'If you return in peace, then Yahweh has not spoken through me.'"
,"29":"So the king of Israel went up to Ramoth-gilead together with the king of Judah."
,"30":"The king of Israel told Jehoshaphat, 'I will disguise myself before the battle, but you wear your robes.' So the king of Israel disguised himself before the battle."
,"31":"Now the king of Aram had commanded the thirty-two captains of his chariots, 'Attack no one, big or small, but only the king of Israel.'"
,"32":"When the captains of the chariots saw Jehoshaphat, they thought, 'That surely is the king of Israel.' So they turned to attack him. But when Jehoshaphat shouted his cry of war,"
,"33":"the captains of the chariots saw that it was not the king of Israel and they no longer pursued him."
,"34":"In the meantime one of the Arameans drew his bow, without knowing at whom he aimed, and hit the king of Israel between the scale armor and the breastplate. The king then ordered the driver of his chariot, 'Turn around and carry me out of the battle for I am wounded.'"
,"35":"The battle raged fiercely on that day. Meanwhile, the king was propped up in his chariot, facing the Arameans, until the evening when he died. The blood from his wound flowed down into the bottom of the chariot."
,"36":"At about sunset, a cry went through the camp, 'Everyone to his city, and everyone to his country!"
,"37":"The king has died!',The king was brought to Samaria and was buried there. "
,"38":"But they washed the chariot by the pool of Samaria. So the dogs licked up his blood, while the harlots bathed in it in accordance with the word spoken by Yahweh."
,"39":"The rest of the acts of Ahab, his deeds, the ivory house he built, and the cities he restored are all written in the Book of the Chronicles of the Kings of Israel."
,"40":"So Ahab rested with his fathers and his son Ahaziah reigned in his place."
,"41":"Jehoshaphat, son of Asa, began to reign over Judah in the fourth year of Ahab, king of Israel."
,"42":"He was thirty-five years old when he began to reign, and he reigned for twenty-five years in Jerusalem. His mother was Azubah, daughter of Shilhi."
,"43":"He conducted himself like his father Asa, and did what pleased Yahweh without hesitation. Yet, he did not remove the high places where the people continued to sacrifice and burn incense."
,"44":"Jehoshaphat had peace with the king of Israel."
,"45":"The rest of the acts of Jehoshaphat, his bravery and his war exploits are written in the Book of the Chronicles of the Kings of Judah."
,"46":"He also removed from the land the remaining male cult prostitutes, completing the work of his father Asa."
,"47":"There was no king in Edom but a governor ruled over it."
,"48":"Jehoshaphat had Tarshish ships go to Ophir for gold, but the venture failed when the ships were wrecked at Eziongeber."
,"49":"Then Ahaziah, son of Ahab, said to Jehoshaphat, 'Let my servants go in the ships with your servants.' Jehoshaphat, however, refused."
,"50":"When Jehoshaphat rested with his fathers, he was buried with them in the city of his ancestor David and his son Jehoram reigned in his place."
}`)

}
func EN_CCB_LoadVH1SChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"There was a man from Rama-thaim, in the hills of Ephraim, whose name was Elkanah. He was son of Tohu, son of Jeroham, of the clan of Zuph."
,"2":"He had two wives, Hannah and Peninnah. Peninnah had children but Hannah had none."
,"3":"Every year Elkanah went to worship and to sacrifice to Yahweh of hosts at Shiloh. The priests there were the two sons of Eli, Hophni and Phineas."
,"4":"Whenever Elkanah offered sacrifice, he gave portions to his wife, Peninnah and to all her sons and daughters."
,"5":"To Hannah, however, he gave the more delightful portion because he loved her more, although she had no child."
,"6":"Yet Hannah's rival used to tease her for being barren."
,"7":"So it happened every year when they went to Yahweh's house. Peninnah irritated Hannah and she would weep and refuse to eat."
,"8":"Once Elkanah, her husband, asked her, 'Hannah, why do you weep instead of eating? Why are you sad? Are you not better off with me than with many sons?'"
,"9":"After they had eaten and drunk in Shiloh, Hannah stood up not far from Eli, the priest: his seat was beside the doorpost of Yahweh's house."
,"10":"Deeply distressed she wept and prayed to Yahweh"
,"11":"and made this vow, 'O Yahweh of hosts, if only you will have compassion on your maidservant and give me a son, I will put him in your service for as long as he lives and no razor shall touch his head.'"
,"12":"As she prayed before Yahweh, Eli observed the movement of her lips."
,"13":"Hannah was praying silently; she moved her lips but uttered no sound and Eli thought Hannah was drunk."
,"14":"He, therefore, said to her: 'For how long will you be drunk? Let your drunkenness pass.'"
,"15":"But Hannah answered: 'No, my lord, I am a woman in great distress, not drunk. I have not drunk wine or strong drink, but I am pouring out my soul before Yahweh."
,"16":"Do not take me for a bad woman. I was so afflicted that my prayer flowed continuously.'"
,"17":"Then Eli said, 'Go in peace and may the God of Israel grant you what you asked for.'"
,"18":"Hannah answered, 'Let your maidservant deserve your kindness.' Then she left the temple and when she was at table, she seemed a different woman."
,"19":"Elkanah rose early in the morning and worshiped before Yahweh with his wives. Then they went back home to Ramah. When Elkanah slept with his wife, Hannah, Yahweh took compassion on her,"
,"20":"and she became pregnant. She gave birth to a son and called him Samuel because she said: 'I have asked Yahweh to give him to me.'"
,"21":"Once more Elkanah went to the temple with his family to offer his yearly sacrifice and to pay his vow to Yahweh."
,"22":"Hannah would not go along but she said to her husband, 'I will bring the child there as soon as he is weaned. He shall be presented to Yahweh and stay there forever.'"
,"23":"Her husband answered, 'Do what seems best to you. Stay here until you have weaned the child and may Yahweh confirm your vow.' So Hannah stayed behind and continued to nurse her son until he was weaned."
,"24":"When the child was weaned, Hannah took him with her along with a three-year-old bull, a measure of flour and a flask of wine, and she brought him to Yahweh's house at Shiloh. The child was still young."
,"25":"After they had slain the bull, they brought the child to Eli."
,"26":"Hannah exclaimed: 'Oh, my lord, look! I am the woman who was standing here in your presence, praying to Yahweh."
,"27":"I asked for this child and Yahweh granted me the favor I begged of him."
,"28":"Now, I think, Yahweh is asking for this child. As long as he lives, he belongs to Yahweh.',And they worshiped Yahweh there."
}`)
	CurrentBook.AddChapter(2, `{
"1":"And this is the song of Hannah, 'My heart exults in Yahweh, I feel strong in my God. I rejoice and laugh at my enemies,for you came with power to save me."
,"2":"Yahweh alone is holy, no one is like you; there is no Rock like our God."
,"3":"Speak proudly no more; no more arrogance on your lips, for Yahweh is an all-knowing God, he it is who weighs the deeds of all."
,"4":"The bow of the mighty is broken,but the weak are girded with strength."
,"5":"The well-fed must labor for bread,but the hungry need work no more. The childless wife has borne seven children, but the proud mother is left alone."
,"6":"Yahweh is Lord of life and death; he brings down to the grave and raises up."
,"7":"Yahweh makes poor and makes rich, he brings low and he exalts."
,"8":"He lifts up the lowly from the dust, and raises the poor from the ash heap; they will be called to the company of princes, and inherit a seat of honor. The earth to its pillars belongs to Yahweh,and on them he has set the world."
,"9":"He guards the steps of his faithful ones, but the wicked perish in darkness, for no one succeeds by his own strength."
,"10":"The enemies of Yahweh are shattered, against them he thunders in heaven. Yahweh rules over the whole world, he will raise his own king. His anointed feels strong in Him.'"
,"11":"After that Elkanah went home to Ramah while the boy served Yahweh in the presence of Eli, the priest."
,"12":"The sons of Eli were worthless men who had no regard for Yahweh."
,"13":"This is how they acted with the people. When someone offered sacrifice, the servant of the priest would come while the meat was still boiling."
,"14":"With a fork, he would reach into the pan, or kettle, or caldron, or pot, and all that the fork brought up would be for the priests. This is how these priests treated the Israelites who went to Shiloh."
,"15":"Sometimes the priest's servant would come before the fat was burned and would say to the man who was sacrificing, 'Give meat for the priest to roast, for he will not accept boiled meat from you, only raw.'"
,"16":"And if the man answered, 'Let the fat be burned first and then take as much as you wish,' he would say, 'No, give it to me now or else I will take it by force.'"
,"17":"The sin of these young priests was very great in the sight of Yahweh because they defiled the offering of Yahweh."
,"18":"Meanwhile Samuel, now a boy wearing a priest's garment, was ministering before Yahweh."
,"19":"From time to time his mother made him a little robe which she handed to him when she went up with her husband to offer the yearly sacrifice."
,"20":"Eli blessed Elkanah and his wife with these words, 'May Yahweh give you more children by this woman for the sake of the boy she asked for and then gave to Yahweh.'"
,"21":"After the man had gone back home, Yahweh blessed Hannah with more children. She had three sons and two daughters while the boy Samuel grew in the presence of Yahweh."
,"22":"Eli was now very old. He heard how his sons dealt with the Israelites and how they slept with the women who served at the entrance to the Tent of Meeting."
,"23":"So he told them, 'How can you do the things I hear about you from everyone?"
,"24":"No, my sons, what I hear from the pilgrims of Yahweh's people is really bad news for me."
,"25":"When anyone sins against another man, God will mediate for him. But if he sins against Yahweh, who can intercede for him?' Yet the two would not listen to their father for Yahweh had already decided that they should die."
,"26":"The boy Samuel, in the meantime, was growing in stature and worth before Yahweh and the people."
,"27":"One day, a man of God came to Eli and said to him, 'This is Yahweh's word: I revealed myself to your ancestors when they were Pharaoh's slaves in Egypt."
,"28":"I chose them out of all the tribes of Israel to be my priests, to go up to my altar, to burn incense and to wear a priest's robe in my presence, and I gave them all the burnt offerings of Israel."
,"29":"Why do you now despise my sacrifice and the offerings that I myself ordered? Why do you give more importance to your sons than to me and fatten yourselves on the choicest parts of every offering made by my people Israel?"
,"30":"Therefore, Yahweh, the God of Israel declares: I promised that your family and that of your father should go on ministering before me forever; but now, far be it from me! Those who honor me I shall honor, those who despise me will be despised."
,"31":"The days are coming when I will break your strength and the strength of all your relatives."
,"32":"No one will live to a ripe old age."
,"33":"Those of your household that I do not reject from my service will be spared only to weep bitterly and live in grief; but the rest shall die by the sword."
,"34":"What will happen to your sons Hophni and Phinehas shall be a sign to you: both of them shall die on the same day."
,"35":"I will raise up for myself a faithful priest who shall act according to my heart and mind. I will give him a lasting succession that will serve me and my anointed one forever."
,"36":"And everyone that is left of your family shall ask him for some money or a loaf of bread, saying: Appoint me, I beg you, for a priestly function so that I may have something to eat.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"The boy Samuel ministered to Yahweh under Eli's care in a time in which the word of Yahweh was rarely heard; visions were not seen."
,"2":"One night Eli was lying down in his room, half blind as he was."
,"3":"The lamp of God was still lighted and Samuel also lay in the house of Yahweh near the ark of God."
,"4":"Then Yahweh called, 'Samuel! Samuel!' Samuel answered, 'I am here!'"
,"5":"and ran to Eli saying, 'I am here, did you not call me?' But Eli said, 'I did not call, go back to sleep.' So he went and lay down."
,"6":"Then Yahweh called again, 'Samuel!' and Samuel stood up and went to Eli saying, 'You called me; I am here.' But Eli answered, 'I did not call you, my son. Go back to sleep.'"
,"7":"Samuel did not yet know Yahweh and the word of Yahweh had not yet been revealed to him."
,"8":"But Yahweh called Samuel for the third time and, as he went again to Eli saying, 'I am here for you have called me,' Eli realized that it was Yahweh calling the boy."
,"9":"So he said to Samuel, 'Go, lie down, and if he calls you again, answer: 'Speak, Yahweh, your servant listens.'"
,"10":"Then Yahweh came and stood there calling as he did before, 'Samuel! Samuel!' And Samuel answered, 'Speak, for your servant listens.'"
,"11":"Then Yahweh spoke to Samuel, 'Look, I am about to do something in Israel which will scare everyone who hears about it."
,"12":"On that day I will carry out what I told Eli regarding his family. All will be fulfilled from beginning to end."
,"13":"For I told him that I was about to sentence his family forever. He himself knew that his sons were blaspheming God, but he did not stop them."
,"14":"This is why I have cursed the family of Eli. Their sin shall never be atoned for by sacrifice or by any offering.'"
,"15":"Samuel lay down until morning and rose up early. Then he opened the doors of Yahweh's house. Samuel was afraid to tell the vision to Eli,"
,"16":"but Eli called him and said, 'Samuel, my son.' Samuel answered, 'I am here.'"
,"17":"Eli asked, 'What did Yahweh tell you? Do not hide it from me. Fear the punishment of God if you hide from me even one thing he told you.'"
,"18":"So Samuel told him everything to the end and Eli said, 'He is Yahweh. Let him do what seems good to him.'"
,"19":"Samuel grew; Yahweh was with him and made all his words become true."
,"20":"All Israel, from Dan to Beersheba, knew that Samuel was really Yahweh's prophet."
,"21":"Yahweh would appear at Shiloh; there he revealed himself to Samuel by giving him his word."
}`)
	CurrentBook.AddChapter(4, `{
"1":"At that time Samuel was a prophet of Israel. The Israelites went out to battle against the Philistines. They encamped at Ebenezer, while the Philistines encamped at Aphek."
,"2":"The Philistines then drew up in battle formation. They attacked Israel and after a fierce struggle, Israel was defeated, leaving about four thousand men dead on the battlefield."
,"3":"When the troops retreated to their camp, the elders of Israel asked, 'Why has Yahweh allowed us to be defeated by the Philistines? Let us take the ark of God from Shiloh and bring it here so that Yahweh may be with us and save us from our enemies.'"
,"4":"So the people sent messengers to Shiloh to take the ark of Yahweh who is seated on the cherubim. Eli's two sons, Hophni and Phinehas, accompanied the ark."
,"5":"As soon as the ark of Yahweh entered the camp, the Israelites began to cheer so loudly that the earth resounded."
,"6":"The Philistines heard the shouting and asked, 'What does this loud shout in the camp of the Hebrews mean?' And they were told that the ark of Yahweh had been brought to the camp."
,"7":"The Philistines were overcome with fear. They exclaimed, 'A god has come into the camp."
,"8":"Woe to us! For nothing like this has happened before. Woe to us! Who can save us from the power of these mighty gods? These are the gods who struck the Egyptians with all sorts of plagues - and in the desert."
,"9":"Take courage and conduct yourselves like men, O Philistines, lest you become slaves to the Hebrews the way they have been slaves to you. Be manly and fight.'"
,"10":"So the Philistines fought and Israel was defeated. Everyone fled to his home. It was a disastrous defeat; thirty thousand foot soldiers of Israel were killed."
,"11":"The ark of God was captured and the two sons of Eli, Hophni and Phinehas, were slain."
,"12":"A man from the tribe of Benjamin fled from the battle line and arrived that same day in Shiloh. His clothes were torn and his head was covered with dust."
,"13":"When this man arrived, Eli was on his seat by the road, watching, for his heart trembled for what might happen to the ark of God. When the people heard the news the man brought, all the city cried out."
,"14":"Eli heard their outcry and asked, 'What is all this noise?' The man came to Eli at once and told him what happened."
,"15":"Eli was by then ninety-eight years old and was already blind."
,"16":"The man said to him, 'I came from the battle, for I was able to flee from it.' Then Eli asked him, 'How did the battle go, my son?'"
,"17":"The newsbearer answered, 'Israel fled before the Philistines. There has been a disaster for our men; your sons, Hophni and Phinehas, are among the dead and the ark of God has been taken.'"
,"18":"As soon as the man mentioned the ark of God, Eli fell over backward from his seat by the side of the gate. He broke his neck and died for he was an old and heavy man. Eli judged Israel for forty years."
,"19":"Eli's daughter-in-law, wife of Phinehas, was pregnant and was about to give birth. When she heard that the ark of God was taken and that both her father-in-law and her husband were dead, she gave birth prematurely."
,"20":"As she lay dying, the women attending her said to her, 'Do not be afraid for you have given birth to a son.' But she neither answered nor listened."
,"21":"She then named the child Ichabod, saying: 'The glory has departed from Israel!'"
,"22":"And she said 'the glory,' meaning the ark of God that had been captured."
}`)
	CurrentBook.AddChapter(5, `{
"1":"After they had taken the ark of God, the Philistines carried it from Ebenezer to Ashdod."
,"2":"There they brought it into the temple of Dagon and set it up beside him."
,"3":"Rising up early the following day, the people saw that Dagon had fallen face downward on the ground before the ark of Yahweh. So they picked up Dagon and put him back in his place."
,"4":"But when they rose the following morning, the people saw Dagon on the ground again, face downward before the ark of Yahweh. His head and hands were broken off and lay at the threshold. Only the trunk of Dagon was left where he fell."
,"5":"This is why the priests of Dagon and his worshipers do not tread on the threshold of his temple in Ashdod up to this day."
,"6":"The hand of Yahweh was heavy upon the people of Ashdod. Yahweh afflicted the people of Ashdod and its vicinity with hemorrhoids."
,"7":"Seeing this, the people of Ashdod said, 'Let the ark of the God of Israel not remain with us. His hand is heavy on us and on Dagon, our god.'"
,"8":"So they had all the chiefs of the Philistine cities gathered together to ask them, 'What shall we do with the ark of the God of Israel?' They answered, 'Let the ark of the God of Israel be brought to Gath.' So they brought the ark of the God of Israel there."
,"9":"But as soon as they had brought it to Gath, Yahweh raised his hand against the city, causing a very great panic. He afflicted the people there, both young and old, with hemorrhoids."
,"10":"So they moved the ark of God to Ekron. But when the ark entered Ekron, the people there cried out, 'They have brought us the ark of the God of Israel to slay us all.'"
,"11":"So they gathered the chiefs of the Philistine cities together to tell them, 'Send away the ark of the God of Israel. Let it return to its own place lest we all die.' For there was deadly panic throughout the city because of God's heavy hand."
,"12":"Those who did not die were stricken with hemorrhoids and the cry of the city reached to heaven."
}`)
	CurrentBook.AddChapter(6, `{
"1":"The ark of Yahweh was in the country of the Philistines for seven months."
,"2":"The Philistines called their priests and diviners and asked them, 'What shall we do with the ark of Yahweh? Tell us how we shall send it back to its place.'"
,"3":"The priests and diviners answered, 'If you send away the ark of the God of Israel, do not send it away empty. Instead, provide him with a guilt offering. Then you may be healed and you will know why God dealt with you so severely.'"
,"4":"The chiefs then asked, 'What guilt offering shall we provide him with?' The priests and diviners answered, 'Make five golden figures of hemorrhoids and five golden figures of mice corresponding to the number of Philistine cities, for the same plague was on all of you and on your chiefs."
,"5":"So you must make images of your hemorrhoids and images of your mice that ravage the land, and give glory to the God of Israel. Perhaps he will remove his hand from you, your gods and your land."
,"6":"But do not harden your hearts as the Egyptians and Pharaoh did. After Yahweh had afflicted them, did they not have to let the people go?"
,"7":"Now, then, prepare a new cart and take two milking cows which have never carried a yoke. Yoke the cows to the cart but take their calves away from them."
,"8":"Then, take the ark of Yahweh and place it on the cart. Put in a box beside it the golden figures which you are giving him as a guilt offering. Then send it off and let it go its way."
,"9":"Then, watch. If it goes up on the way to its own land, through Beth-shemesh, then it is he who has done us this great harm. If not, then we shall know that it is not his hand that struck us, that all these things happened to us by chance.'"
,"10":"The people carried out these instructions. They took two milking cows and yoked them to the cart and shut their calves in their shed."
,"11":"They then put the ark of Yahweh on the cart, along with the box with the golden mice and the images of their hemorrhoids."
,"12":"The cows went straight in the direction of Beth-shemesh along the way; they went mooing and they turned neither to the right nor to the left. Meanwhile, the chiefs of the Philistine cities followed them as far as the border of Beth-shemesh."
,"13":"The people of Beth-shemesh were harvesting their wheat in the valley when they saw the ark drawing near, and they rejoiced greatly."
,"14":"The cart arrived in Beth-shemesh in Joshua's field and stopped there. A big stone lay nearby, so the people split up the wood of the cart and offered the cows over the stone as a burnt offering to the Lord."
,"15":"Meanwhile, the Levites took down the ark of Yahweh and the box containing the golden figures, and they set these up on the big stone. That day the people of Beth-shemesh offered burnt offerings and sacrifices to Yahweh. The five chiefs of the Philistine cities, however, "
,"16":"upon seeing what happened, immediately returned to Ekron."
,"17":"These are the Philistine cities which gave golden figures of hemorrhoids as a guilt offering to Yahweh: Ashdod, Gaza, Ashkelon, Gath and Akron."
,"18":"Similarly, there were golden figures of mice corresponding in number to all the cities of the Philistines belonging to the five leaders, counting fortified cities and unwalled villages. The big stone beside which the people set down the ark of Yahweh in the field of Joshua of Beth-shemesh, is a witness to this day."
,"19":"Yahweh caused the death of seventy men of Beth-shemesh who had looked at the ark of Yahweh. On seeing this, the people mourned greatly."
,"20":"The people of Beth-shemesh then said, 'Who can stand before Yahweh, this holy God? And where can we send the ark away from us?'"
,"21":"So they sent messengers to the inhabitants of Kiriath-jearim with this word, 'The Philistines have returned the ark of Yahweh. Come down and take it up with you.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"The people of Kiriath-jearim came for the ark of Yahweh. They brought it into the house of Abinadab on the hill, and they consecrated his son, Eleazar, to take charge of it."
,"2":"A very long time passed from the day the ark was lodged at Kiriath-jearim. For some twenty years, all Israel mourned and longed for Yahweh."
,"3":"Then Samuel told the Israelites, 'If you turn back to Yahweh in all sincerity, get rid of the foreign gods and your Ashteroth. When you have set your heart on Yahweh and serve no one but him, he will deliver you from the Philistines.'"
,"4":"So the Israelites got rid of the Baals and the Ashteroth and began serving no one but Yahweh."
,"5":"Then Samuel said, 'Gather all Israel in Mizpah and I will pray to Yahweh on your behalf.'"
,"6":"And so they gathered at Mizpah. They drew water and poured it out before Yahweh. They fasted on that day and said, 'We have sinned against Yahweh.' It was Samuel who led this assembly of Israel at Mizpah."
,"7":"When the Philistines heard that the people of Israel had gathered at Mizpah, the chiefs of the Philistine cities went up to Israel's land. The Israelites became afraid when they learned this"
,"8":"and they said to Samuel, 'Pray without ceasing to Yahweh our God on our behalf so that he may save us from the Philistines.'"
,"9":"Samuel then took a suckling lamb and offered it to Yahweh as a whole burnt offering, appealing to him on behalf of the people. And Yahweh answered him."
,"10":"At the very time Samuel was offering the sacrifice, the Philistines launched an attack against Israel. But Yahweh's voice thundered loudly in the midst of the Philistines; they were suddenly confused and defeated by Israel."
,"11":"The Israelites left Mizpah, pursuing and slaying the Philistines to a point beyond Bethcar."
,"12":"Samuel, then, took a stone and set it up between Mizpah and Jeshanah and named it Ebenezar, for he said, 'Unto this place Yahweh has helped us.'"
,"13":"After this defeat, the Philistines did not dare enter the territory of Israel and Yahweh held them in check for as long as Samuel lived."
,"14":"The Israelites recovered the towns from Ekron to Gath which the Philistines had seized from Israel. Israel rescued their territories. And there was peace, even between the Israelites and the Amorites."
,"15":"Samuel was judge in Israel for the rest of his life."
,"16":"Every year he went around to Bethel, Gilgal, and Mizpah and judged Israel in all these places."
,"17":"After that he returned to Ramah for his home was there. There he judged Israel and there he built an altar to Yahweh."
}`)
	CurrentBook.AddChapter(8, `{
"1":"When Samuel grew old, he made his sons judges over Israel."
,"2":"His elder son was Joel and the second was Abijah, and both of them were judges in Beersheba."
,"3":"But they were not like their father; they had their vested interests, taking bribes and perverting justice."
,"4":"Because of this, all the chiefs of Israel gathered together and went to Samuel in Ramah."
,"5":"They said to him, 'You are already old and your sons are not following your ways. Give us a king to rule over us as in all the other nations.'"
,"6":"Samuel was very displeased with what they said, 'Give us a king to rule us,' and he prayed to Yahweh."
,"7":"And Yahweh told him, 'Give to this people all that they ask for."
,"8":"They are not rejecting you but they have rejected me as their king. They are now doing to you what they did to me from the day I brought them out of Egypt until now, forsaking me and serving other gods."
,"9":"Nevertheless, listen to them, and give them a serious warning. Tell them how they will be treated by their king.'"
,"10":"So Samuel answered those who were asking him for a king,"
,"11":"and he told them all that Yahweh said to him, 'Look, these will be the demands of your king: he will take your sons and assign them to his chariot and his horses and have them run before his chariot."
,"12":"Some he will assign as commanders over a thousand men and commanders over fifty. Others will till his ground and reap his harvest, make his implements of war and the equipment for his chariots."
,"13":"He will take your daughters as well to prepare perfumes, to cook and to bake for him."
,"14":"He will take the best of your fields, your vineyards and your olive orchards and give them to his officials."
,"15":"He will take a tenth portion of your grain and of your vineyards and give it to his officers and to his servants."
,"16":"He will take your menservants and maidservants, the best of your cattle and your asses for his own work."
,"17":"He will take the tenth of your flocks and you yourselves will become his slaves."
,"18":"When these things happen, you will cry out because of the king whom you have chosen for yourselves. But by then, Yahweh will not answer you.'"
,"19":"The people paid no attention to all that Samuel said. They insisted, 'No! We want a king to govern us as in all the other nations."
,"20":"Our king shall govern us, lead us and go ahead of us in our battles.'"
,"21":"Upon hearing all that his people said, Samuel repeated it to Yahweh."
,"22":"But Yahweh said to him, 'Listen to them and give them a king.' Samuel then said to the Israelites, 'Go back, all of you, to your own cities.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"There was a man from the tribe of Benjamin whose name was Kish. He was the son of Abiel, son of Zeror, son of Becorath, son of Aphiah, a valiant Benjaminite."
,"2":"Kish had a son named Saul, a handsome young man who had no equal among the Israelites, for he was a head taller than any of them."
,"3":"It happened that the asses of Kish were lost. So he said to his son Saul, 'Take one of the boys with you and go look for the asses.'"
,"4":"They went all over the hill country of Ephraim and the land of Shalishah but did not find them. They passed through the land of Shaalim and the land of Benjamin, but the asses were nowhere to be found."
,"5":"When they reached the land of Zuph, Saul said to his boy, 'Let us go back, lest my father be more worried about us than about the asses.'"
,"6":"But his servant said to him, 'Look, there is a man of God in this city. He is a highly respected man. All that he says comes true. Let us see him for he may be able to help us find what we are looking for.'"
,"7":"Saul replied, 'But if we go, what can we bring him? We have no more bread in our sacks and we have no present to bring to the man of God. What do we have?'"
,"8":"The servant answered, 'I still have with me a quarter silver coin. I will give it to the man of God to tell us our way.'"
,"10":"And Saul said to his boy, 'Well said! Come, let us go.' So they went to the city where the man of God was."
,"11":"As they went up the hill to the city, they met young girls coming out to draw water and asked them, 'Is the seer here?'"
,"9":"(Formerly, people in Israel who went to consult God, would say, 'Come, let us go to the seer,' for they did not speak of prophets, but of seers.)"
,"12":"The maidens answered, 'The seer is straight ahead. He has just arrived because they have a sacrifice today on the high place."
,"13":"As soon as you enter the city, you shall find him before he goes up to the high place to eat. The people will not eat until he comes because he must first bless the sacrifice, and then those who are invited may eat. Now go up; you will meet him immediately.'"
,"14":"So they went up to the city and entered it, and saw Samuel coming out towards them on his way up to the high place."
,"15":"The day before Saul came, Yahweh had already disclosed this to Samuel,"
,"16":"'Tomorrow, about this time, I will send you a man from the land of Benjamin and you shall anoint him to rule over my people Israel. He shall save my people from the hand of the Philistines for I have seen the affliction of my people and their cry has come to me.'"
,"17":"So, when Samuel saw Saul, Yahweh told him, 'Here is the man I spoke to you about! He shall rule over my people.'"
,"18":"Saul approached Samuel in the gateway and said, 'Tell me, where is the house of the seer?'"
,"19":"Samuel answered Saul, 'I am the seer. Go up ahead of me to the high place, for today you shall eat with me. In the morning, before you leave, I will tell you all that is in your heart."
,"20":"As for your asses that were lost three days ago, do not worry about them for they have been found.',Samuel added, 'For whom is the first place in Israel? Isn't it for you and for all your father's kin?' "
,"21":"Saul answered, 'I am a Benjaminite, from the least of the tribes of Israel, and my family is the lowliest of all the families of the tribe of Benjamin. Why do you speak to me in this way?'"
,"22":"Samuel took Saul and his boy, brought them into the hall and gave them a place at the head of the table, before some thirty guests."
,"23":"Then Samuel told the cook, 'Bring in the portion which I asked you to put aside.'"
,"24":"The cook brought in the leg with the tail portion and set it before Saul, saying to him, 'This has been set aside for you. Please eat.' So Saul ate with Samuel that day."
,"25":"Then they went down from the high place and entered the city. On the terrace they prepared a bed for Saul where he lay down to sleep."
,"26":"Early the next morning, Samuel called to Saul, 'Get up, for I must send you on your way.' Saul got up and began to walk down the street with Samuel."
,"27":"As they were going down to the outskirts of the city, Samuel said to Saul, 'Tell your servant to walk ahead. You stay here for a while and I shall give you a message from God.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Then Samuel took a vial of oil and poured it on Saul's head. And kissing Saul, Samuel said, 'Yahweh has anointed you to rule over and to lead his people Israel. And this will be Yahweh's sign to you that he has anointed you."
,"2":"After we part today, you will meet two men by Rachel's tomb at Zelzah, in the territory of Benjamin. They will say to you: 'The asses you were looking for have been found. But your father is now worried about you, and what may have happened to you.'"
,"3":"When you go on to the oak of Tabor, you will meet three men going up to see God at Bethel. One will be carrying three kids; another, three loaves of bread; and another, a skin of wine."
,"4":"They will greet you and give you two loaves of bread which you are to accept from them."
,"5":"After that, you will come to Gibeath-elohim where the garrison of the Philistines is. At the entrance of the city, you will meet a band of prophets coming down from the high place, and a choir with harp, tambourine, flute and lyre going before them. They will be in a trance as the prophets used to be."
,"6":"Then the Spirit of Yahweh will seize you. You shall prophesy with them and become another man."
,"7":"Now when these signs are fulfilled, do whatever seems good to you for God is with you."
,"8":"You shall go down to Gilgal ahead of me, and I shall join you there to offer burnt offerings and peace offerings. Wait there seven days until I come and tell you what you have to do.'"
,"9":"As soon as Saul parted from Samuel, God transformed him into a different person and all the signs Samuel mentioned to Saul were fulfilled that day."
,"10":"Upon entering Gibeah, a band of prophets met Saul; then the Spirit of God seized him and he began to prophesy with them."
,"11":"Those who knew him and saw him prophesying with the prophets asked one another, 'What has come over the son of Kish? Is Saul also one of the prophets?'"
,"12":"One of them exclaimed, 'And who is his father!' This, therefore, became a saying, 'Is Saul also one of the prophets?'"
,"13":"When Saul finished prophesying, he arrived with them at the sanctuary."
,"14":"Saul's uncle asked him and his boy, 'Where did you go?' Saul answered, 'To look for the asses. When we could not find them, we went to Samuel.'"
,"15":"His uncle said, 'Please, tell me what Samuel told you.'"
,"16":"Saul replied, 'He merely told us that the asses had been found.' But Saul did not tell his uncle what Samuel had said about the kingship."
,"17":"After that, Samuel called the people together before Yahweh at Mizpah."
,"18":"He then spoke to the Israelites, 'Thus says Yahweh, the God of Israel: I brought Israel out of Egypt and I delivered you from the hands of the Egyptians and from all the kingdoms oppressing you."
,"19":"But you have this day rejected your God who saves you from all your calamities and your distress. You have said, 'No! Give us a king to rule over us.' So now present yourselves before Yahweh, grouping yourselves into tribes and clans.'"
,"20":"Then Samuel made all the tribes of Israel come near him and when they cast lots, the tribe of Benjamin was chosen."
,"21":"He made the families of the tribe of Benjamin come near him, and the family of the Matrites was chosen. He made the members of the family of Matrites come near him, and the lot fell to Saul, son of Kish. They looked for him but could not find him."
,"22":"So they asked Yahweh again, 'Did the man come here?' Yahweh answered, 'He has hidden himself among the baggage.'"
,"23":"They ran to fetch him and when Saul stood among the people, they saw that he was a head taller than the others."
,"24":"Samuel spoke and said, 'Do you see the one Yahweh has chosen? There is none like him among all the people.' And all the people shouted, 'Long live the king!'"
,"25":"Samuel then told the people the rights and duties of the king. He wrote all these in a book and presented it before Yahweh. Then Samuel sent all the people home."
,"26":"Saul himself went home to Gibeah with these valiant men whose hearts God had touched."
,"27":"Some evil people, however, remarked; 'How can this man save us?' And they ignored Saul and brought him no gift."
}`)
	CurrentBook.AddChapter(11, `{
"1":"One month later, Nahash the Ammonite went to Jabesh-gilead and surrounded the city. The people of Jabesh told Nahash, 'Make an agreement with us and we will serve you.'"
,"2":"Nahash answered, 'I will make an agreement with you on this condition: I will pluck out the right eye of all of you, so that Israel will be left disgraced.'"
,"3":"The elders of Jabesh then told him, 'Give us seven days so we may send messengers through all the territories of Israel. If none of them comes to save us, we will surrender to you.'"
,"4":"So the messengers went to Gibeah of Saul, breaking the news to the people. And all the people wept aloud."
,"5":"Just then Saul came from the field with his oxen. He asked, 'What has happened to make the people weep?' And they told him what the men of Jabesh had said."
,"6":"At once, the spirit of God seized Saul and he was greatly angered."
,"7":"He took a yoke of oxen, cut them into pieces and gave them to the messengers to be taken through all the territories of Israel with this warning, 'I will do the same with the oxen of anyone who does not come out after Saul and Samuel.',Then a holy fear came upon the people and they set out as one man."
,"8":"When Saul inspected them at Bezek, the men of Israel were three hundred thousand; those of Judah, thirty thousand."
,"9":"And they sent the messengers with this answer to the people of Jabesh, 'Tomorrow, by noontime, we shall come to you.' When the messengers returned, the people of Jabesh were very comforted"
,"10":"and they told Nahash, 'Tomorrow we will surrender and you may do to us whatever you please.'"
,"11":"The following morning, Saul divided the people into three groups. They broke into the enemy camp early in the morning and slew the Ammonites until noontime. Those who could escape were scattered, each one running his own way."
,"12":"Then the people asked Samuel, 'Who are these who said: Saul will never reign over us? Bring the men and we shall put them to death.'"
,"13":"But Saul said, 'No man shall be put to death today, for this day Yahweh has saved Israel.'"
,"14":"Samuel told the people, 'Come, let us go to Gilgal and officially proclaim the kingdom.'"
,"15":"So all the people went to Gilgal and there they proclaimed Saul king before Yahweh. They sacrificed peace offerings and Saul and all Israel celebrated."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Samuel spoke to the Israelites, 'Listen, I have paid attention to all that you have told me and have given you a king."
,"2":"From now on, the king is here to lead you. As for me, I am old and my hair gray. My sons are with you. I have led you from my youth, and I have done so until this day."
,"3":"Now, I am here. Answer me before Yahweh and his anointed: Whose ox have I taken? Whose ass have I stolen? Whom have I cheated? Whom have I oppressed? Have I taken a bribe from anyone? If so, tell me, and I will restore it to you.'"
,"4":"But they said, 'You have not cheated or oppressed us; you have not stolen anything from anyone.'"
,"5":"Then Samuel said, 'Yahweh is witness against you, and his anointed is witness this day, that you have not found anything in my hand.' And they answered, 'He is witness.'"
,"6":"Samuel then said to the people, 'Yahweh is witness, he who sent Moses and Aaron and brought your ancestors out of the land of Egypt."
,"7":"Now, stand still, that I may confront you with all the deeds of Yahweh who saved you and your ancestors."
,"8":"Jacob went to Egypt and the Egyptians oppressed your ancestors. Then they cried to Yahweh and he sent Moses and Aaron. They brought your ancestors out of Egypt and brought them to this land."
,"9":"But they forgot Yahweh, their God, and he delivered them into the hands of Sisera, commander of the army of Jabin, king of Hazor, into the hands of the Philistines, and into the hands of the king of Moab who fought against them."
,"10":"Then your ancestors cried to Yahweh and said: 'We have sinned, forsaking Yahweh and serving the Baals and the Ashteroth. But now, deliver us out of the hands of our enemies and we will serve you.'"
,"11":"And Yahweh sent Jerubbaal and Barak, Jephthah and Samuel, and delivered you out of the hands of your enemies from all sides, so that you lived in safety in your land."
,"12":"Now, when you saw that Nahash, the king of the Ammonites, attacked you, you said to me: 'No! Let a king rule over us,' although Yahweh your God was your king."
,"13":"Yet Yahweh has given you the king whom you have chosen, whom you have asked for."
,"14":"May you fear Yahweh and serve him! May you listen to him and not go against his commandments! May both you and the king who reigns over you follow Yahweh, your God!"
,"15":"But if you will not listen to Yahweh and if you break his commandments, his hand will be against you and your king."
,"16":"Now wait awhile that you may see the wonder which Yahweh will do before you."
,"17":"Is it not wheat harvest today? I will call on Yahweh that he may send thunder and rain. So you shall know and see that you have gone very wrong in asking for another king.'"
,"18":"So Samuel called on Yahweh who sent thunder and rain on that day. Then all the people greatly feared Yahweh and Samuel."
,"19":"The people said to Samuel, 'Pray to Yahweh, your God, for your servants so we may not die. For we have added to our sins this evil of asking for a king.'"
,"20":"Samuel told the people, 'Fear not! You have done evil, but now you must not turn away from Yahweh. Serve him, instead, with all your heart."
,"21":"Do not go after these useless and vain idols that are unable to save."
,"22":"Yahweh will not cast away his people because of his great Name, since he has been pleased to make you his people."
,"23":"As for me, how can I commit the sin of ceasing to pray for you? I will continue to instruct you in the good and right way."
,"24":"Only fear Yahweh and serve him faithfully with all your heart, for you have seen the wonderful things he has done for you."
,"25":"But if you still persist in wickedness, both you and your king shall be swept away.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Saul became king and he ruled over Israel."
,"2":"Saul chose three thousand men of Israel. Two thousand were with him in Michmash and in the hills of Bethel, and a thousand with Jonathan in Gibeah of Benjamin. Saul sent the rest of the people away, every man to his home."
,"3":"Jonathan killed the Philistine governor in Geba and the Philistines heard of this. Saul then blew the trumpet throughout the land, saying, 'Let the Hebrews hear!'"
,"4":"And the news spread throughout Israel, 'Saul has killed the Philistine governor and now Israel is at war with them.' And they called everyone out to join Saul at Gilgal."
,"5":"The Philistines gathered to fight with Israel - three thousand chariots, six thousand horsemen, and troops as many as the sand on the seashore. They went up and encamped in Michmash, east of Bethaven."
,"6":"When the people of Israel saw that they were in trouble, they hid themselves in caves, in holes, in rocks, in tombs and in cisterns,"
,"7":"or crossed the fords of the Jordan River to the land of Gad and Gilead."
,"8":"Saul was still at Gilgal and all the people with him were afraid. He waited seven days - the time appointed by Samuel. But Samuel did not arrive at Gilgal and the people were beginning to disperse."
,"9":"So Saul said, 'Bring me the burnt offering and the peace offerings as well.' Saul then offered the burnt offering."
,"10":"He had just finished offering it when Samuel arrived. Saul went out to greet Samuel"
,"11":"who threw him this question, 'What have you done?' Saul answered him, 'When I saw the people beginning to disperse because of your failure to arrive on time, and considering that the Philistines have mustered their forces at Michmash,"
,"12":"I said to myself, 'The Philistines will launch their attack against me before I get Yahweh's blessings and so I decided to offer the burnt offerings.'"
,"13":"Samuel told Saul, 'You have done a foolish thing by not obeying the command of Yahweh your God who would have established your rule forever."
,"14":"But now your kingship will not last, for Yahweh has chosen someone else more pleasing to him, whom he has appointed to be commander over his people because you have not done what Yahweh commanded you.'"
,"15":"Samuel then left Gilgal and went on his way. Meanwhile the people went up from Gilgal with Saul to join the warriors at Gibeah of Benjamin. Saul reviewed his men numbering some six hundred. "
,"16":"While Saul and his son Jonathan stayed in Gebah of Benjamin with the men, the Philistines pitched camp in Michmash."
,"17":"Raiders came out of the Philistine camp in three companies - one company turned to Ophrah, to the land of Shual;"
,"18":"the other, to Bethoron; and the third, to the border overlooking the valley of Zeboim, toward the wilderness."
,"19":"The Israelites had no smith anywhere in their land, for the Philistines did not want the Hebrews to make swords or spears."
,"20":"To have their plowshare, mattock, axe or sickle sharpened, the Israelites had to go down to the Philistines"
,"21":"who would charge them two-thirds of a shekel for plowshares and mattocks, and a third of a shekel for sharpening axes and setting goads."
,"22":"And so, on the day of battle, the Israelites had neither sword nor spear. Only Saul and Jonathan had them."
,"23":"Yet the Philistine raiders had moved on toward the pass of Michmash."
}`)
	CurrentBook.AddChapter(14, `{
"1":"The same day, Jonathan, son of Saul, said to his armor-bearer, 'Let us go over to the Philistine garrison on the other side. Jonathan did not inform his father about this."
,"2":"Saul was at that time on the outskirts of Gibeah, at Migron, under the pomegranate tree with about six hundred men."
,"3":"Also with Saul was Ahijah, son of Ahitub, brother of Ichabod, son of Phinehas, son of Eli, priest of Yahweh in Shiloh, and he was wearing the ephod to consult Yahweh. Not even the soldiers knew that Jonathan had left them."
,"4":"The pass through which Jonathan planned to go to reach the Philistine garrison was flanked on each side by a rocky crag: one called Bozez, the other, Seneh."
,"5":"One of the crags was to the north in the direction of Michmash; the other to the south, in the direction of Giba."
,"6":"Jonathan said to his shield-bearer, 'Let us go over to the garrison of those uncircumcised fellows. It may be that Yahweh will help us, for it is as easy for Yahweh to give victory with a few men as with many.'"
,"7":"His armor-bearer replied, 'Do whatever you think best. As for me, I follow and obey you.'"
,"8":"Jonathan said, 'Look, we will draw near and show ourselves to those men."
,"9":"When they see us, if they cry out: 'Stay there and we shall go over to you,' we shall stay quiet and go no further."
,"10":"But if they say: 'Come up to us,' we shall go up because that will be a sign that Yahweh has delivered them into our hands.'"
,"11":"When the two were seen by the Philistines, the latter exclaimed, 'Look! Hebrews coming out of their hiding places!'"
,"12":"And they challenged Jonathan and his shield-bearer, 'Come over here and we will teach you a lesson!' Jonathan then told his armor-bearer, 'Follow me, for Yahweh has delivered them into the hands of Israel.'"
,"13":"Then Jonathan crawled up on his hands and feet, his armor-bearer following him. The Philistines fell before Jonathan, and his armor-bearer finished them off."
,"14":"In that first slaying by Jonathan and his armor-bearer, about twenty men lost their lives within half a furlong."
,"15":"Panic struck in the camp and in the countryside, sowing terror in the garrison. Even the band of raiders was disturbed. It was like an earthquake and they were filled with a holy terror."
,"16":"Saul's watchmen in Gibeah of Benjamin saw the commotion in the camp: the Philistines were running and scattering in all directions."
,"17":"Saul then told those who were around him, 'Count our men and see who is missing.' And they discovered that Jonathan and his armor-bearer were not with them."
,"18":"Saul ordered Ahijah: 'Bring the ephod,' because Ahijah had taken it with him."
,"19":"But while Saul was talking to the priest, the confusion in the Philistine camp increased. Saul then told the priest, 'Withdraw your hand,'"
,"20":"and after consulting his men, he went with them to the camp. They saw that there was complete confusion and the soldiers were striking each other with their swords."
,"21":"Moreover, the Hebrews who had joined the Philistines turned around and sided with the Israelites under Saul and Jonathan."
,"22":"When the Israelites who were hiding in the hill country of Ephraim heard that the Philistines were fleeing, they came out from hiding and pursued them."
,"23":"And so Yahweh delivered Israel that day in a battle that extended beyond Beth-horon."
,"24":"On that day, however, as the Israelites became weary, Saul took an oath putting the people under the ban, 'Cursed be the man who takes food before evening, before I have avenged myself on my enemies.' Because of this oath, no one dared touch any food."
,"25":"As the men wandered into the forest, they saw honey on the ground and"
,"26":"although it was freely dripping from the honeycomb, no one tasted it for fear of the oath."
,"27":"But Jonathan, who had not heard of this oath, dipped the tip of the rod he was holding in the honeycomb and put it to his lips. And he felt fortified."
,"28":"At this, someone said, 'Though the people were tired, your father bound them with this oath: cursed be the man who takes food today.'"
,"29":"Then Jonathan said, 'My father did you wrong. See how I have been fortified by tasting a little of this honey."
,"30":"If only our men had freely eaten today of the spoil of their enemies, the Philistines would have suffered an even greater defeat.'"
,"31":"Nevertheless they pursued the Philistines all the way from Michmash to Aijalon. Then the people, extremely worn out,"
,"32":"rushed to the spoils and took sheep, oxen, and calves and, after they had slaughtered them on the ground, they ate over the blood."
,"33":"Saul was told that the people were sinning against Yahweh by eating over the blood. He said, 'You have acted like pagan people! Roll a large stone here in front of me.'"
,"34":"Then he added, 'Go around and tell the people to bring their oxen or their sheep to me. Slaughter them here and eat, but do not offend Yahweh by eating over the blood.' So that night, everyone brought what he had of the spoils and slaughtered it there."
,"35":"Then Saul built an altar to Yahweh - the first he ever built to Him."
,"36":"Then Saul said, 'Let us pursue and spoil the Philistines by night and finish them off by morning without leaving a single man alive.' To this the people replied, 'Do what you think is best.' But the priest said, 'We must consult Yahweh.'"
,"37":"So Saul asked, 'Shall I attack the Philistines? Will you deliver them into the hands of Israel?' But God did not answer him that day."
,"38":"Saul said, 'Call all the army officers here. We must find out who is responsible for the sin that has been committed today."
,"39":"I swear before Yahweh, who has just saved Israel, that he shall surely die even if it happens to be my son Jonathan.' No one answered Saul."
,"40":"He told the people, 'Go, stand on one side while I and my son Jonathan, stand on the other.' The people answered, 'Do what you think is good.'"
,"41":"Then Saul said, 'O Yahweh, God of Israel, why did you not answer your servant this time? If it is my son Jonathan or I who have sinned, O Yahweh, God of Israel, let the casting of lots show Urim; if it is your people Israel who have sinned, let it show Thummin.' The lot cast pointed to Jonathan and Saul, not to the people."
,"42":"Saul then said, 'Cast the lot between me and my son Jonathan.' The lot singled out Jonathan."
,"43":"Saul then said to Jonathan, 'Tell me what you have done.' And Jonathan replied, 'All I did was to taste a little honey from the tip of the rod that I dipped in the honeycomb! Am I to die for this?'"
,"44":"Saul said, 'May God strike me down if you are not put to death, Jonathan.'"
,"45":"But the people protested, 'By no means shall Jonathan die, he who has brought this resounding victory to Israel! Not at all! By Yahweh's life not one hair of his head will fall, for he has acted today with God's assistance.' So the people rescued Jonathan from certain death."
,"46":"After that, Saul ceased to pursue the Philistines, and they withdrew to their own country."
,"47":"When Saul felt secure as king of Israel, he began to fight against all his surrounding enemies: Moab, the Ammonites, Edom, the kings of Zobah and the Philistines, routing his enemies wherever he went."
,"48":"He crushed the Amalekites, and delivered Israel out of the hands of those who were plundering them."
,"49":"The sons of Saul were Jonathan, Ishvi and Malchishua; his two daughters were Merab, his firstborn, and Michal."
,"50":"His wife was Ahinoam, daughter of Ahimaaz. The general of his army was Abner, son of Ner who was Saul's uncle."
,"51":"Kish was the father of Saul and Ner, the father of Abner, was the son of Abiel."
,"52":"Saul struggled fiercely against the Philistines all the days of his life, so whenever he discovered a strong and brave man, he recruited him into his service."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Samuel told Saul, 'Yahweh sent me to anoint you king over his people Israel. So now listen to what he has to say to you:"
,"2":"I will punish Amalek for having stood in the way of the Israelites when they were leaving Egypt."
,"3":"Now attack Amalek and destroy completely all that he has. Do not spare them - man, woman, infant or suckling, ox or sheep, camel or ass.'"
,"4":"Saul called his men to Telaim and reviewed two hundred thousand foot soldiers and ten thousand men from Judah."
,"5":"He went to the city of Amalek, set an ambush in the valley and"
,"6":"proceeded to warn the Kenites, 'Leave the Amalekites! I do not want to punish you with them since you showed kindness to the people of Israel when they left Egypt.' After the Kenites had left,"
,"7":"Saul defeated the Amalekites, from Havilah to Shur, east of Egypt."
,"8":"He took Agag, king of the Amalekites alive, but put the rest of the people to the sword."
,"9":"Saul and his men spared Agag and the best of the sheep, oxen, fatlings and lambs and everything that was good, but destroyed all that was worthless."
,"10":"Then Yahweh spoke to Samuel:"
,"11":"'I feel sorry that I made Saul king because he has turned his back on me and has not kept my command.' Samuel was troubled and cried to Yahweh all night."
,"12":"Early next morning, he went looking for Saul, but was told that Saul had set off for Carmel to erect a monument to himself and then had gone on his way to Gilgal."
,"13":"When finally they met, Saul greeted Samuel, 'May Yahweh bless you,' and added, 'I have done what Yahweh told me to do.'"
,"14":"Samuel then asked him, 'Why do I still hear the bleating of sheep and the lowing of oxen?'"
,"15":"Saul replied, 'We have brought them from the Amalekites, because the people spared the best sheep and oxen to sacrifice to Yahweh, your God. But the rest have been destroyed.'"
,"16":"Samuel then told Saul, 'Enough! Let me tell you what Yahweh said to me last night.' Saul replied, 'Please tell me.'"
,"17":"So Samuel went on and said, 'Though you had no confidence in yourself, you became chief of the tribes of Israel, for Yahweh wanted to anoint you king over Israel."
,"18":"Then he sent you with this command, 'Go. Completely crush the Amalekite offenders, engaging them in battle until they are destroyed.'"
,"19":"Why then did you not obey the voice of Yahweh but instead swooped down on the spoil, doing what was evil in his sight?'"
,"20":"To this, Saul replied, 'I have obeyed the voice of Yahweh and have carried out the mission for which he sent me. I have captured Agag, king of Amalek and completely destroyed the Amalekites."
,"21":"If my men spared the best sheep and oxen from among those to be destroyed, it was in order to sacrifice them to Yahweh, your God, in Gilgal.'"
,"22":"Samuel then said, 'Does Yahweh take as much delight in burnt offerings and sacrifices, as in obedience to his command? Obedience is better than sacrifice, and submission better than the fat of rams. "
,"23":"Rebellion is like the sin of divination, and stubbornness like holding onto idols. Since you have rejected the word of Yahweh, he too has rejected you as king.'"
,"24":"Saul then told Samuel, 'I have sinned in disobeying Yahweh's command and your instructions. I feared my own men and obeyed them instead."
,"25":"Please forgive my sin and return with me so I may worship Yahweh.'"
,"26":"Samuel refused and said, 'I will not return with you because you have rejected the word of Yahweh and he has rejected you as king of Israel.'"
,"27":"As Samuel turned to leave, Saul held onto the end of his robe, which tore."
,"28":"Then Samuel said to Saul, 'Yahweh has torn the kingdom of Israel from you this day and has given it to someone better than you."
,"29":"The Glory of Israel does not change or repent as man does.'"
,"30":"Saul then said, 'I have sinned. But please honor me now before the elders of my people and before Israel. Return with me so that I may worship Yahweh, your God.'"
,"31":"And Samuel returned with Saul who went to worship Yahweh."
,"32":"Samuel said, 'Bring me Agag, king of the Amalekites.' Agag stood before him with a cheerful face, thinking that he was now out of danger."
,"33":"But Samuel told him, 'As your sword has made women childless, so shall your mother be childless among women.' Then Samuel dealt a mortal blow to Agag before Yahweh in Gilgal."
,"34":"Samuel left for Ramah while Saul went home to Gibeah of Saul."
,"35":"From that day Samuel did not see Saul again until he died, but he was grieving over Saul because Yahweh regretted having made him king over Israel."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Yahweh asked Samuel, 'How long will you be grieving over Saul whom I have rejected as king of Israel? Fill your horn with oil and be on your way to Jesse the Bethlehemite for I have chosen my king from among his sons.'"
,"2":"Samuel asked, 'How can I go? If Saul hears of this, he will kill me!' Yahweh replied, 'Take a heifer with you and say, 'I have come to sacrifice to Yahweh.'"
,"3":"Invite Jesse to the sacrifice and I will let you know what to do next. You shall anoint for me the one I point out to you.'"
,"4":"Samuel did what Yahweh com-manded and left for Bethlehem. When he appeared, the elders of the city came to him asking, fearfully, 'Do you bring us peace?'"
,"5":"Samuel replied, 'I come in peace; I am here to sacrifice to Yahweh. Cleanse yourselves and join me in the sacrifice.' He also had Jesse and his sons cleansed and invited them to the sacrifice."
,"6":"As they came, Samuel looked at Eliab the older and thought, 'This must be Yahweh's anointed.'"
,"7":"But Yahweh told Samuel, 'Do not judge by his looks or his stature for I have rejected him. Yahweh does not judge as man judges; humans see with the eyes; Yahweh sees the heart.'"
,"8":"Jesse called his son Abinadab and presented him to Samuel who said, 'Yahweh has not chosen this one either.'"
,"9":"Jesse presented Shammah and Samuel said, 'Nor has Yahweh chosen this one.'"
,"10":"Jesse presented seven of his sons to Samuel who said, 'Yahweh has chosen none of them."
,"11":"But are all your sons here?' Jesse replied, 'There is still the youngest, tending the flock just now.' Samuel said to him, 'Send for him and bring him to me; we shall not sit down to eat until he arrives.'"
,"12":"So Jesse sent for his youngest son and brought him to Samuel. He was a handsome lad with ruddy complexion and beautiful eyes. And Yahweh spoke, 'Go, anoint him for he is the one.'"
,"13":"Samuel then took the horn of oil and anointed him in his brothers' presence. From that day onwards, Yahweh's Spirit took hold of David. Then Samuel left for Ramah."
,"14":"The spirit of Yahweh had left Saul and an evil spirit sent by Yahweh tormented him."
,"15":"Saul's servants said to him, 'We know that an evil spirit sent by God is tormenting you."
,"16":"If you so wish, your servants who stand before you will look for someone who can play the lyre so when the evil spirit from God comes over you, he will play and you will feel better.'"
,"17":"So Saul answered them, 'Get someone who can play the lyre well.'"
,"18":"One of them said, 'A son of Jesse, the Bethlehemite, plays very well. He is, moreover, a courageous man, intelligent and pleasant to talk with and Yahweh is with him.'"
,"19":"So Saul sent messengers to Jesse and asked for his son David who tended the sheep."
,"20":"Jesse loaded an ass with bread, a wineskin and a kid and had David take all these to Saul."
,"21":"David then left and entered Saul's service. Saul grew very fond of David and made him his armor-bearer."
,"22":"Then he sent word to Jesse, saying, 'Let David remain in my service for I am very pleased with him.'"
,"23":"So, whenever the evil spirit from God overpowered Saul, David would play on the lyre and Saul would feel better for the evil spirit would leave him."
}`)
	CurrentBook.AddChapter(17, `{
"1":"The Philistines prepared their forces for battle and gathered together at Socoh, a territory of Judah. They encamped between Socoh and Azekah in Ephesdammim."
,"2":"Saul and the Israelites, meantime, assembled and pitched camp in the valley of Elah, ready for their encounter with the Philistines."
,"3":"The Philistines took their position on one hill while the Israelites took theirs on another hill, with a valley separating the two forces."
,"4":"Then a champion named Goliath came out from the Philistine camp. He was from Gath and was about three meters tall."
,"5":"He wore a helmet of bronze, and a coat covered with bronze scales. His armor weighed sixty kilos."
,"6":"He had bronze greaves strapped on his legs and a bronze spear slung between his shoulders."
,"7":"The shaft of his spear was the size of a weaver's rod; its head weighed seven kilos. His shield-bearer went before him."
,"8":"He stood in front of the Israelite ranks and shouted, 'Why have you come out in battle array? I am a Philistine and you are Saul's men! Choose a man from among yourselves who can challenge me."
,"9":"If he fights better and kills me, we shall be subject to you; but if I overpower him and kill him, you shall be subject to us.'"
,"10":"The Philistine added, 'This is my challenge to the Israelite troops this day. Give me a man who can fight with me alone!'"
,"11":"When they heard this challenge of the Philistine, Saul and his men were afraid and greatly terrified."
,"12":"Now, David was the son of Jesse, an Ephrathite of Bethlehem in Judah who had eight sons. Jesse was already old during Saul's reign but he had sent men to the army."
,"13":"Three of his eldest sons had joined Saul in battle: Eliab, the firstborn, Abinadab, the second and Shammah, the third."
,"14":"David was Jesse's youngest and, while the three eldest followed Saul,"
,"15":"he would alternate his goings and comings to the army with the care of his father's flock in Bethlehem."
,"16":"Every morning and again in the evening, the Philistine would come out to throw his challenge; this he did for forty days."
,"17":"One day, Jesse told his son David, 'Bring a measure of this roasted grain and these ten loaves to your brothers;"
,"18":"and take these ten cheeses to the field officer. Find out how your brothers are and bring me back some token from them.'"
,"19":"David's brothers and the field officer were with Saul and the Israelites in the valley of Elah, facing the Philistines."
,"20":"David woke up early the next morning and entrusted the sheep to a shepherd. Taking the food along with him, he left in obedience to Jesse's command and arrived at the encampment just when the army was leaving for the battleground, shouting out their battle cry."
,"21":"Israel and the Philistine drew up facing one another."
,"22":"On seeing this, David entrusted his load to the baggage keeper and rushed to the ranks to greet his brothers."
,"23":"While he was talking with them, Goliath, the Philistine champion of Gath, came up from the ranks of the Philistines and shouted out the same challenge as before, this time reaching David's ears."
,"24":"When the Israelites saw the man, they all fled from him terrified"
,"25":"and one of them said, 'Have you seen this man who comes up challenging Israel? Whoever succeeds in killing him will be richly rewarded by the king. He will give him his daughter in marriage and set his family free of every contribution.'"
,"26":"David asked those who were around him, 'What will be the reward for the person who kills this Philistine and lifts this disgrace from Israel? And who is this uncircumcised Philistine who defies the armies of the living God?'"
,"27":"The people answered him in the same way, 'This will be the reward of whoever kills him.'"
,"28":"When he saw David talking to the men, his eldest brother Eliab was angry and said, 'Why did you come here? With whom did you leave those few sheep in the desert? I know you are an insolent fellow. You have come only to see the battle.'"
,"29":"David asked, 'What have I done this time? I was merely asking something!'"
,"30":"Leaving his brother, David turned to another man and asked him the same question, and the people answered him the same way as before."
,"31":"David's remarks spread around and reached Saul, who asked for him."
,"32":"David said to Saul, 'Let no one be discouraged on account of this Philistine, for your servant will engage him in battle.'"
,"33":"Saul told David, 'You cannot fight with this Philistine for you are still young, whereas this man has been a warrior from his youth.'"
,"34":"But David said, 'When I was tending my father's sheep, whenever a lion or bear came to snatch a lamb from the flock,"
,"35":"I would run after it, kill it and rescue the victim from its mouth. If it attacked me, I would hold it by its beard and slay it."
,"36":"I have killed lions and bears and will do the same with this uncircumcised Philistine, for he has defied the armies of the living God.'"
,"37":"David continued, 'Yahweh, who delivered me from the paws of lions and bears, will deliver me from the hands of the Philistine.',Saul then told David, 'Go and may Yahweh be with you!'"
,"38":"Saul fitted his armor on David, put a bronze helmet on his head, clothed him with a coat of mail."
,"39":"David secured his sword over the armor but could not walk because it was his first time. So he said to Saul, 'I cannot move with all these trappings on me because I am not accustomed to wearing them.' David got rid of all this armor,"
,"40":"took his staff, picked up five smooth stones from the brook and dropped them inside his shepherd's bag. And with his sling in hand, he drew near to the Philistine."
,"41":"The Philistine moved forward, closing in on David, his shield-bearer in front of him."
,"42":"When he saw that David was only a lad, (he was of fresh complexion and handsome) he despised him"
,"43":"and said, 'Am I a dog that you should approach me with a stick?' Cursing David by his gods,"
,"44":"he continued, 'Come and I will give your flesh to the birds of the sky and the beasts of the field!'"
,"45":"David answered the Philistine, 'You have come against me with sword, spear and javelin, but I come against you with Yahweh, the God of the armies of Israel whom you have defied."
,"46":"Yahweh will deliver you this day into my hands and I will strike you down and cut off your head. I will give the corpses of the Philistine army today to the birds of the sky and the wild beasts of the earth, and all the earth shall know that there is a God of Israel."
,"47":"All the people gathered here shall know that Yahweh saves not by sword or spear; the battle belongs to Yahweh, and he will deliver you into our hands.'"
,"48":"No sooner had the Philistine moved to attack him, than David rushed to the battleground."
,"49":"Putting his hand into his bag, he took out a stone, slung it and struck the Philistine on the forehead; it penetrated his forehead and he fell on his face to the ground."
,"50":"David triumphed over the Philistine with a sling and a stone, felling him without using a sword."
,"51":"He rushed forward, stood over him, took the Philistine's sword and slew him by cutting off his head. When the Philistines saw that their champion was dead, they scattered in all directions. "
,"52":"The men of Israel and Judah raised the battle cry and pursued the Philistines as far as Gath and the gates of Ekron. Wounded Philistines fell on the way from Shaaraim to Gath and Ekron."
,"53":"Returning from their pursuit of the Philistines, the Israelites plundered their camp."
,"54":"David took the head of the Philistine and brought it to Jerusalem but left the armor in his tent."
,"55":"When Saul saw David come out to oppose the Philistine, he asked his general, Abner, 'Abner, whose son is that young man?' Abner answered, 'I swear, O king, I do not know.'"
,"56":"The king said, 'Ask whose son that lad is.'"
,"57":"So when David returned after killing the Philistine, Abner took him to Saul."
,"58":"Saul asked David, who stood before him holding the head of the Philistine, 'Whose son are you, young man?' David answered, 'I am the son of your servant, Jesse the Bethlehemite.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"When David had finished speaking with Saul, Jonathan felt a deep affection for David and began to love him as himself."
,"2":"Saul kept David with him from that day and did not allow him to return to his father's house."
,"3":"Then Jonathan made an agreement with David because he loved him as himself."
,"4":"Jonathan, taking off the cloak he was wearing, gave it to David; he also gave him his own armor, sword, bow and belt."
,"5":"Wherever Saul sent David, he went and succeeded. For this reason, Saul put David in charge of the soldiers - a move which pleased Saul's men and his officers as well."
,"6":"When they arrived after David had slain the Philistine, the women came out from the cities of Israel to meet King Saul singing and dancing with timbrels and musical insruments."
,"7":"They were merrily singing this song: 'Saul has slain his thousands, and David, his tens of thousands.'"
,"8":"Saul was very displeased with this song and said, 'They have given tens of thousands to David but to me only thousands! By now he has everything but the kingdom!'"
,"9":"From then on, Saul became very distrustful of David."
,"10":"The following day, an evil spirit from God seized Saul, causing him to rave in his house. David then played on the lyre as he used to do, while Saul had his spear in hand."
,"11":"Then Saul pointed it at David thinking, 'I will nail David to the wall.' But David escaped on two occasions."
,"12":"Saul saw that Yahweh was with David and had left him. And he was afraid."
,"13":"So he removed David from his presence by making him chief of a thousand men. David went ahead of his troops"
,"14":"and was successful each time because Yahweh was with him."
,"15":"The more successful David was, the more afraid Saul became."
,"16":"But all Israel and Judah loved David because he led them in their expeditions."
,"17":"Saul said to David, 'You know my eldest daughter, Merab. I will give her to you as your wife; be brave and fight Yahweh's battles.' For Saul thought, 'Let the Philistines strike him instead of myself.'"
,"18":"David answered Saul, 'Who am I? And what is my father's family in Israel that I should be the king's son-in-law?'"
,"19":"Yet when it was time for Merab to be married to David, she was given instead to Adriel the Meholathite."
,"20":"Now, Saul's daughter, Michal, fell in love with David. When this came to Saul's knowledge, he was very pleased"
,"21":"for he thought, 'I shall promise her to him and it will be a snare to him. The Philistines will kill him.' So, Saul said to David a second time, 'You shall now be my son-in-law.'"
,"22":"Then he commanded his servants to talk to David privately and say, 'The king and all his servants like you. You should become the king's son-in-law!'"
,"23":"Saul's servants repeated these words to David who replied, 'Do you think it is easy to become the king's son-in-law, poor and unknown as I am?'"
,"24":"When Saul's servants repeated to the king what David had said,"
,"25":"Saul ordered them to tell David, 'The king wants no marriage gift other than a hundred Philistine foreskins to take revenge on his enemies.' For Saul wanted David to fall into the hands of the Philistines."
,"26":"Saul's servants told this to David and it seemed to him that he could easily become the king's son-in-law."
,"27":"David and his men set out and killed two hundred Philistines. And they brought the king the foreskins so that David could become the king's son-in-law. So Saul had to give his daughter Michal to David to become his wife."
,"28":"Saul feared David for he knew that Yahweh was with him. But Michal, Saul's daughter, loved him."
,"29":"Saul feared David more and more and was his enemy until the end."
,"30":"Whenever the Philistine chiefs engaged David in battle, he succeeded more than any of Saul's officers, in earning great fame for himself."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Saul told his son Jonathan and his servants of his intention to kill David. But Jonathan, who liked David very much,"
,"2":"said to David, 'My father Saul wants to kill you. Be on your guard tomorrow morning and hide yourself in a secret place."
,"3":"I will go out and keep my father company in the countryside where you are and I will speak to him about you. If I find out something, I will let you know.'"
,"4":"Jonathan spoke well of David to his father Saul and said, 'Let not the king sin against his servant David for he has not sinned against you. On the contrary, what he has done has benefited you."
,"5":"He risked his life in killing the Philistine and Yahweh brought about a great victory for Israel. You yourself saw this and greatly rejoiced. Why then sin against innocent blood and kill David without cause?'"
,"6":"Saul heeded Jonathan's plea and swore, 'As Yahweh lives, he shall not be put to death.'"
,"7":"So Jonathan called David and told him all these things. He then brought him to Saul and David was back in Saul's service as before."
,"8":"War broke out again and David set out to fight the Philistines. David crushed them so badly that they had to flee."
,"9":"Then an evil spirit from Yahweh seized Saul as he sat in his house holding his spear while David was playing on the lyre."
,"10":"Saul made an attempt to pin David to the wall with his spear. David, however, dodged the blow and the spear hit the wall instead. David fled and escaped."
,"11":"That night Saul sent messengers to David's house to keep an eye on him as he intended to kill him the following morning. But David's wife, Michal, told him, 'If you do not run for your life tonight, tomorrow you will be killed.'"
,"12":"So Michal let David down through the window, allowing him to escape."
,"13":"Next Michal took the household idol, laid it in the bed and put a bundle of goat's hair on its head. She then covered this with a blanket."
,"14":"When Saul sent messengers to capture David, Michal told them, 'He is sick.'"
,"15":"Saul sent messengers back to David and said, 'Bring him up to me on his bed for me to kill him.'"
,"16":"But when the messengers entered, they saw the household idol in the bed with the bundle of goat's hair at its head."
,"17":"Saul, therefore, asked Michal, 'Why did you deceive me and allow my enemy to escape?' Michal answered, 'He threatened to kill me if I did not let him go!'"
,"18":"David had fled and was in safety. He went to Samuel at Ramah and related all that Saul had done to him. He and Samuel then went to live at Naioth."
,"19":"Saul was told that David stayed at Naioth in Ramah,"
,"20":"so he sent messengers to capture David. But when they saw the band of prophets prophesying (signifying that they had fallen into a trance) with Samuel leading them, the spirit of Yahweh came upon them and made them prophesy."
,"21":"Upon hearing what happened, Saul sent more messengers who also began to prophesy. Saul sent more the third time and the same thing happened."
,"22":"Then Saul himself went to Ramah and arrived at the deep well in Secu. He asked, 'Where can I find Samuel and David?' The people answered, 'They are at Naioth in Ramah.'"
,"23":"So Saul proceeded to Naioth in Ramah but the Spirit of Yahweh came upon him as well. And he walked along prophesying until he reached the entrance of Naioth in Ramah."
,"24":"He took off his clothes and prophesied in Samuel's presence. Then he fell down naked, remaining in that position all day and all night. Hence sprang the saying, 'Is Saul also among the prophets?'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"David fled from Naioth in Ramah and went to Jonathan to ask him, 'What have I done? What am I guilty of? What sin have I committed against your father that he wants to kill me?'"
,"2":"Jonathan, however, assured him, 'No! You shall not die. My father does nothing small or great without informing me. Why should he hide this from me? No, this cannot be.'"
,"3":"But David replied, 'Your father knows very well that you are pleased with me, so he thinks it is better not to tell you and grieve you. But I swear there is but one step between death and me!'"
,"4":"Then Jonathan told David, 'What can I do for you?'"
,"5":"David answered, 'Tomorrow is the new moon and I should be dining with the king. But let me hide myself in the open country until the evening of the third day."
,"6":"If your father looks for me, say to him: 'David asked me to let him go over to Bethlehem because they have their yearly sacrifice there with the entire family.'"
,"7":"If he says, 'Good' then I am in no danger. But if he gets angry, then you can be certain that he wants to harm me."
,"8":"Do this for me according to our agreement. But if I am guilty, kill me yourself. Why hand me over to your father to be killed?'"
,"9":"Jonathan answered, 'Nonsense! If I knew that my father wanted to harm you, would I not warn you?'"
,"10":"David then asked him, 'Who will tell me if your father answers you angrily?'"
,"11":"Jonathan said, 'Come, let us go into the open country.' So they both left for the open country."
,"12":"Then Jonathan said to David, 'Yahweh, the God of Israel, be our witness. About this time tomorrow or the following day, I shall be sounding out my father. If he is well-disposed toward you, I shall send you word."
,"13":"But if my father intends to do you harm, may Yahweh punish me if I do not warn you that you may escape safely. Surely Yahweh will be with you as he has been with my father."
,"14":"If I live, always be kind to me. But if I die,"
,"16":"never cut off your friendship with my family even when Yahweh takes vengeance on David's enemies and wipes them out from the face of the earth.',So Jonathan made a covenant with the family of David."
,"17":"And he made David swear once more because of the affection he felt for him for he loved David as himself."
,"18":"Then Jonathan said, 'Tomorrow is the new moon. Your absence will be noticed because your seat will be vacant."
,"19":"On the third day it will be noticed all the more. So go and hide yourself where you hid before and stay beside the heap of stones there."
,"20":"I will shoot three arrows near the stones as if I were aiming at a target."
,"21":"I will then send a lad with this instruction: 'Go, look for the arrows.' If I say to the lad: 'The arrows are on this side, pick them up,' then you may come out for, I swear, you are not in danger."
,"22":"But if I say to the lad: 'The arrows are beyond you,' leave, for Yahweh is sending you away."
,"23":"But as to our covenant, Yahweh is our witness forever.'"
,"24":"So David hid himself in the open country. On the day of the new moon the king came to dine."
,"25":"He took his usual place on the seat against the wall while Jonathan sat facing him and Abner was beside him. David's seat remained vacant."
,"26":"Saul did not say anything on that day, thinking that something may have happened and David was unclean."
,"27":"On the second day of the new moon, David's seat was still vacant and Saul asked his son Jonathan, 'Why has the son of Jesse not come to table yesterday and today?'"
,"28":"Jonathan answered, 'David asked leave to go over to Bethlehem for he said,"
,"29":"'Our family is offering a sacrifice in the city and my brothers insisted that I be present. So please allow me to go and visit my brothers.' This is why he has not come to the king's table.'"
,"30":"Saul became very angry at Jonathan and told him, 'You son of a perverse and rebellious woman! Do I not know that you prefer the son of Jesse to your shame and your mother's shame?"
,"31":"For as long as the son of Jesse lives, neither you nor your Kingdom can stand. Send for him and bring him to me for he is doomed to die!'"
,"32":"Then Jonathan asked his father, 'Why should he die? What has he done?'"
,"33":"At this, Saul pointed his spear at him and Jonathan understood that his father intended to kill David."
,"34":"Jonathan rose angrily from the table and did not eat that second day of the month, grieving for David, because of what his father said against him."
,"35":"The next morning, Jonathan went to the open country with a young man, according to what he and David had agreed on."
,"36":"He told the lad, 'Run, fetch the arrows.' While the lad was running, Jonathan shot an arrow that flew beyond the lad."
,"37":"When the lad reached the spot where Jonathan had shot the arrow, Jonathan called after him and said, 'The arrow is beyond you!"
,"38":"Run quickly and do not waste time!' The lad picked up the arrow and ran back to his master."
,"39":"The lad knew nothing of Jonathan and David's agreement."
,"40":"After that, Jonathan gave his weapons to the lad and commanded him to take them to the city."
,"41":"When the lad had gone, David came out from behind the mound and lay on the ground. The two embraced each other and wept with one another until David was through."
,"42":"Then Jonathan said to David, 'Go in peace, for we have made an oath to one another in Yahweh's name when we said: Yahweh shall be between you and me and between your descendants and mine forever.'"
}`)
	CurrentBook.AddChapter(21, `{
"1":"David went on his way while Jonathan returned home."
,"2":"David came to Nob to the priest Ahimelech. Ahimelech came to meet him and asked trembling, 'Why are you alone?'"
,"3":"David replied, 'The king sent me on a mission and strictly ordered me not to tell anyone about it. Because of this I have decided on a place where I shall meet my men."
,"4":"What do you have here? Can you give me five loaves of bread or whatever you have?'"
,"5":"The priest answered David, 'I do not have ordinary bread at hand; there is only holy bread. If your men have had no relations with women they may eat it.'"
,"6":"David answered, 'Indeed we have abstained from women these days since I set out. The young men remained sexually clean though it was an ordinary expedition and today they are clean.'"
,"7":"So the priest gave him holy bread for there was no other bread. This was the bread of Presence which had been replaced by fresh bread on the day it was removed."
,"8":"Yet one of Saul's men was there on that day. He was Doeg, the Edomite, and Saul's chief shepherd."
,"9":"David asked Ahimelech, 'Do you have a spear or a sword with you? I did not take my arms with me because the king's order was urgent.'"
,"10":"The priest replied, 'I have here, wrapped in a piece of cloth behind the ephod, the sword of Goliath the Philistine whom you killed in the valley of Elah. You can take this if you wish, for I have nothing else here.' David said, 'There is none like it. Give it to me.'"
,"11":"That same day, David fled far from Saul. He went to Achish, king of Gath."
,"12":"Achish's servants remarked, 'O king, is this not David? Did the people not dance on his account and sing: 'Saul has slain his thousands and David his ten thousands?''"
,"13":"David understood these words and began to fear Achish, king of Gath."
,"14":"So he pretended to be mad, making marks on the doors of the gate as he let his spittle run down his beard."
,"15":"At this Achish told his servants, 'Look, it is a madman. Why did you bring him to me?"
,"16":"Am I short of madmen that you have to bring this fellow to act foolishly in my presence? Will this fellow come into my house?'"
}`)
	CurrentBook.AddChapter(22, `{
"1":"David left Gath and escaped to the cave of Adulam where his brothers and his father's family came down to him."
,"2":"Then those who had problems or debts or were embittered joined him there. Thus he became their chief; he had with him about four hundred men."
,"3":"From there, David went to Mispeh in Moab and asked the king of Moab to let his father and mother stay with him until he found out what God would do for him."
,"4":"So David left them with the king of Moab and they stayed there as long as David remained in the refuge."
,"5":"The prophet Gad said to David, 'Do not stay in the refuge; go to the land of Judah.' So David left and entered the forest of Hereth."
,"6":"Saul heard that David and his men had been seen. Saul was in Gibeah at the time, sitting under the tamarisk tree on the high place, his spear in hand, while his servants were standing by."
,"7":"Saul addressed them, 'Listen, men of Benjamin! Will the son of Jesse give every one of you fields of vineyards? Will he make each one of you a commander over a thousand or over a hundred men that you should all be conspiring against me?"
,"8":"Why, then, did no one tell me that my son made an agreement with the son of Jesse? No one among you had mercy on me and told me that my own son had stirred up my servant to conspire against me as is the case today.'"
,"9":"At this, Doeg the Edomite, who was standing with the officers of Saul, spoke up, 'I saw the son of Jesse come to Ahimelech, son of Ahitub, in Nob."
,"10":"Ahimelech consulted Yahweh for him, provided him with food and gave him the sword of Goliath the Philistine as well.'"
,"11":"On hearing this, the king sent for Ahimelech the priest, son of Ahitub, and all his family who were priests in Nob. They all came to the king."
,"12":"Then Saul said, 'Listen, son of Ahitub.' He replied, 'Yes, my lord.'"
,"13":"Saul asked him, 'Why did you conspire with the son of Jesse, giving him food and a sword and consulting Yahweh for him so that he could rebel against me as is the case today?'"
,"14":"Ahimelech answered the king, 'Who among all your servants is as faithful as David, the king's son-in-law, captain of your bodyguard and honored in your house?"
,"15":"Is today the first time that I have consulted Yahweh for him? By no means! Let not the king accuse me or any member of my family of such a thing for I knew nothing at all about the entire matter.'"
,"16":"But the king said, 'You and your entire family shall die, Ahimelech.'"
,"17":"And the king at once commanded the guards who were standing by, 'Turn and kill the priests of Yahweh for having assisted David. They knew very well that David was a fugitive but they did not tell me anything at all.' The king's servants, however, refused to lift their hands against the priests of Yahweh."
,"18":"And so the king turned to Doeg and commanded him, 'Come and stab the priests.' And so Doeg the Edomite drew near and stabbed the priests. On that day he killed eighty-five persons who were wearing the linen ephod. "
,"19":"After that, Saul put Nob, the city of priests, to the sword, killing men and women, children and infants, oxen, asses and sheep."
,"20":"A son of Ahimelech, son of Ahitub, named Abiathar, escaped and fled to David."
,"21":"Abiathar told David that Saul had killed the priests of Yahweh."
,"22":"David said to him, 'I knew that day, when Doeg the Edomite was there, that he would surely tell Saul. So I am responsible for the death of all your family."
,"23":"Stay with me and do not be afraid for he who wants to kill you must also kill me. You will be safe with me.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"David received a report that the Philistines were attacking Keilah and plundering the threshing floors."
,"2":"He, therefore, consulted Yahweh and asked, 'Shall I go and fight with these Philistines?' The answer was, 'Go and attack the Philistines and rescue Keilah.'"
,"3":"But David's men protested and said, 'Look, here in Judah we are in danger and afraid. What then if we go to Keilah and face the Philistines?'"
,"4":"So David consulted Yahweh again and got this answer, 'Go down to Keilah for I will deliver the Philistines into your hands.'"
,"5":"David went with his men to Keilah and fought with the Philistines, seizing their cattle and causing a great slaughter among them; and he rescued the inhabitants of the place."
,"6":"When Abiathar, son of Ahimelech, fled to David at Keilah, he took along the ephod."
,"7":"When Saul was told that David had come to Keilah he said, 'God has delivered him into my hands for he has shut himself in by entering a city with gates and bars.'"
,"8":"He then called on all the people to go down to Keilah and engage David and his men in battle."
,"9":"When David found out that Saul meant to harm him, he told the priest Abiathar to bring the ephod."
,"10":"Then he consulted Yahweh, 'O Yahweh, God of Israel, listen to your servant for I have heard that Saul plans to come to Keilah and destroy the city on my account."
,"11":"Will Saul come down as I heard? O Yahweh, God of Israel, speak to your servant.' Yahweh answered, 'He will come down.'"
,"12":"Then David asked, 'Will the lords of Keilah hand me and my men over to Saul?' Yahweh answered, 'They will hand you over to him.'"
,"13":"So David set out with his six hundred men. He left Keilah and wandered from one place to another. When Saul was informed that David had escaped from Keilah, he abandoned the expedition."
,"14":"Meanwhile David stayed in the strongholds in the hill country of the desert of Ziph. Saul, however, kept on searching for him but God did not deliver David into his hands."
,"15":"David knew that Saul had come out to kill him. And he remained at Horesh in the desert of Ziph."
,"16":"Saul's son, Jonathan, went to him and encouraged him in God's name with these words,"
,"17":"'Have no fear, for my father Saul will not harm you. Even my father Saul knows that you shall be king over Israel and that I shall be second to you.'"
,"18":"The two made an agreement before Yahweh in Horesh, after which David remained there while Jonathan returned home."
,"19":"Some of the Ziphites went up to Saul at Gibeah and told him, 'David is hiding among us in the refuges of Horesh on the hill of Hachilah, south of Jeshimon."
,"20":"Come down, therefore, O king, whenever it may please you and we shall deliver him into your hands.'"
,"21":"Saul replied, 'May Yahweh bless you for you have had mercy on me."
,"22":"Go and make sure where he has been and who has seen him there for I am told that he is very cunning."
,"23":"Check all the places where he may be hiding and come back to me, and I will go with you. If he is in the region, I will search him out among all the clans of Judah.'"
,"24":"So they went off to Ziph ahead of Saul. At this time, David and his men were in the desert of Maon, in the valley south of Jeshimon."
,"25":"When David learned that Saul and his men were looking for him, he went down to a ravine in the desert of Maon. Saul heard of this and pursued David into the desert of Maon."
,"26":"Saul moved along one side of the mountain, and David along the other. David was hurrying to escape from Saul who with his forces was closing in on him and his men."
,"27":"It was then that a messenger came to Saul and said, 'Come quickly because the Philistines have invaded the land!'"
,"28":"Saul then left off pursuing David and went to face the Philistines. This is how that place came to be called the Ravine of Parting."
}`)
	CurrentBook.AddChapter(24, `{
"1":"David then went up from there and stayed in the hiding places at Engedi."
,"2":"When Saul returned from his pursuit of the Philistines, he was told that David was in the desert of Engedi."
,"3":"So Saul took three thousand picked men from all Israel and went in search of David and his men to the east of the Wild Goat crags."
,"4":"When he came to the sheepfolds along the way, he entered a cave to relieve himself."
,"5":"Now David and his men were far back in the cave. David's men said to him, 'This is the day which Yahweh spoke of: look I will deliver your enemy into your hands and you will do with him as you see fit.' So David moved up and stealthily cut off an end of Saul's robe."
,"6":"But afterward, David regretted having cut off an end of Saul's robe,"
,"7":"and he said to his men, 'Let me not lay my hands on my master, for he is Yahweh's anointed.'"
,"8":"With these words, David restrained his men and did not allow them to attack Saul. Saul then left the cave and went on his way."
,"9":"Then David himself stepped out of the cave and called after Saul, 'My master, the king!' When Saul looked back, David knelt and then bowed to the ground in homage and asked him,"
,"10":"'Why do you listen to those who say that I want to harm you?"
,"11":"Look, today you have seen that Yahweh delivered you into my hands in the cave, and I was told to kill you but I held myself back and I said: 'I will not lift my hands against my master who is Yahweh's anointed.'"
,"12":"My father, look at this end of your robe which I am holding! I cut off the end of your robe but did not kill you. Now you may know that I mean you no harm or treason. I have done you no wrong and yet you are hunting me down to kill me."
,"13":"May Yahweh be judge between you and me and may he exact justice from you in my case, but I shall do you no harm."
,"14":"As the saying goes, 'From the wicked comes wickedness'; as for me, my hand shall not harm you."
,"15":"But who is it you are after, O king of Israel? Are you pursuing a dead dog? A flea?"
,"16":"May Yahweh be judge between you and me. May he see and uphold my cause and deliver me from your hands.'"
,"17":"After David had spoken these words, Saul asked, 'Is that your voice, my son David?' He wept aloud"
,"18":"and said to David, 'You are right and I am wrong, for you have repaid with kindness the harm I have inflicted on you."
,"19":"This day you have shown your righteousness to me by not taking my life when Yahweh put me into your hands."
,"20":"For if a man finds his enemy, will he let him go unharmed? May Yahweh reward you for what you have done for me today."
,"21":"Now I know for certain that you shall reign and the kingdom of Israel will be firm in your hand."
,"22":"Now swear to me by Yahweh that you will not wipe out my descendants and erase the name of my family.'"
,"23":"David swore to this before Saul after which Saul went home while David and his men went up to the hiding place."
}`)
	CurrentBook.AddChapter(25, `{
"1":"The day Samuel died, all Israel gathered together to mourn him; after which they buried him at his home in Ramah. Then David went down to the desert of Maon. "
,"2":"A very rich man, owner of three thousand sheep and a thousand goats, lived there and had his farm in Carmel."
,"3":"This man was named Nabal; his wife, Abigail. The woman was intelligent and beautiful; but the man himself, a Calebite, was rough and ill-mannered. He was at the time shearing his sheep in Carmel."
,"4":"When David heard in the desert that Nabal was shearing his sheep,"
,"5":"he sent ten young men to the farm with this instruction, 'Go to Nabal in Carmel and greet him for me"
,"6":"in these words: peace be with you and your family; peace be with all that is yours."
,"7":"I hear that you have shearers with you. Now when your shepherds were with us, we did not harm them; neither did they miss anything while they were in Carmel."
,"8":"Ask your servants and they will tell. So be kind to my servants since we come on a festive day; please give them and your son David whatever you can.'"
,"9":"When David's young men arrived, they delivered this message to Nabal in David's name and then waited."
,"10":"But Nabal answered David's servants, 'Who is David? Who is the son of Jesse? Many nowadays are the servants who run away from their masters."
,"11":"Must I take my bread, my wine, my meat which I have slaughtered for my shearers and give it to men who come from I don't know where?'"
,"12":"At this, David's young men left and returned to him, reporting everything Nabal had said."
,"13":"David then said to his men, 'Let every man strap on his sword!' And every one of them, including David, strapped on his sword. About four hundred men followed David while two hundred remained with the baggage."
,"14":"One of Nabal's servants told Abigail, his wife, 'David sent messengers from the desert to greet our master but he shouted at them."
,"15":"Yet these men were very good to us. We suffered no harm and did not miss anything while we were living among them during our stay in the open country."
,"16":"They were like a wall for us night and day while we were tending the sheep in their midst."
,"17":"Now think over what you should do; for our master and his entire family are surely doomed to die, but he is so wicked no one can speak to him.'"
,"18":"Abigail hurriedly prepared two hundred loaves, two skins of wine, five dressed sheep, five measures of roasted grain, a hundred cakes of pressed raisins, and two hundred cakes of pressed figs and loaded them on asses."
,"19":"Then she said to her servants, 'Go on ahead and I shall follow you.' But she told her husband nothing of this."
,"20":"As she rode down the mountain on her ass, David and his men were coming down from the other direction. When she met them,"
,"21":"David was reflecting, 'It was useless guarding all that this fellow has in the desert. Although he lost nothing belonging to him, he has returned me evil for good."
,"22":"May God do so to David and more if by morning I leave a single male alive among those who belong to him.'"
,"23":"On seeing David, Abigail quickly dismounted from the ass and threw herself on the ground before him."
,"24":"As she fell at his feet she said, 'My lord, let the blame be on me! Let your handmaid speak to you; listen to her words."
,"25":"Let not my lord pay attention to this ill-mannered man, Nabal, for he is just what his name says: he is a fool. I, your handmaid, did not see the young men whom you sent."
,"26":"Now, my lord, as Yahweh lives and as you live, it is Yahweh who prevents you from shedding blood and avenging yourself. Let your enemies and those who seek to harm my lord become like Nabal!"
,"27":"And now let this present which I have brought you, my lord, be given to the young men who follow you,"
,"28":"and please forgive me. Yahweh will certainly give you a lasting family because you are fighting the battles of Yahweh and no evil shall be found in you as long as you live. "
,"29":"Should anyone make an attempt on your life, may the life of my lord be bound in the bundle of the living in the care of Yahweh, your God. May he hurl away the lives of your enemies as from the hollow of a sling."
,"30":"So when Yahweh fulfills his promises and appoints you as commander over Israel,"
,"31":"you shall have no reason to grieve or to feel any grief or regret for having unrightfully shed blood or taken revenge yourself. May Yahweh bless you, and you, my lord, remember your handmaid.'"
,"32":"David then said to Abigail, 'Blessed be Yahweh, the God of Israel, who sent you to meet me today!"
,"33":"Blessed be your good judgment and may you yourself be blessed, for you have prevented me from shedding blood and avenging myself today!"
,"34":"For as Yahweh, the God of Israel, lives, he has prevented me from hurting you. If you did not hurry to meet me, not a single male belonging to Nabal would have been alive by morning.'"
,"35":"David accepted what she had brought him and told her, 'Go back home in peace. I have listened to you and granted your request.'"
,"36":"Abigail went back to Nabal and found him holding a feast in his house. He was joyful and very drunk so Abigail did not mention anything to him until the following day. "
,"37":"When morning came and Nabal had slept it off, his wife spoke to him about all these things. On hearing it Nabal had a stroke and remained paralyzed."
,"38":"Ten days later, Yahweh let him die."
,"39":"When David heard that Nabal was dead, he said, 'Blessed be Yahweh who has avenged the insult I received at the hand of Nabal and has prevented me from doing wrong. Yahweh himself has made Nabal's wrongdoings fall on his own head.'"
,"40":"David then sent his servants to Abigail in Carmel to propose marriage to her saying, 'David has sent us to you to say that he wants you to be his wife.'"
,"41":"Rising and bowing to the ground, Abigail answered, 'May I be as a slave to wash the feet of my lord's servants.'"
,"42":"She quickly rose and mounted an ass and, attended by five of her servants, she left with David's messengers and became his wife."
,"43":"David also married Ahinoam of Jezreel, making both her and Abigail his wives."
,"44":"Saul, in the meantime, had given Michal, his daughter and David's wife, to Palti, son of Laish who was from Gallim."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Ziphites came to Saul in Gibeah to tell him that David was hiding on the hill of Hachilah, east of Jeshimon."
,"2":"On hearing this, Saul went down with three thousand picked men of Israel to the desert of Ziph in search of David."
,"3":"He encamped on the hill of Hachilah beside the road east of Jeshimon."
,"4":"When David who was in the desert saw that Saul had come after him, he sent out spies who confirmed Saul's arrival."
,"5":"David came to Saul's place of encampment and saw where Saul was resting with Abner, son of Ner, chief of his army. Saul was sleeping in the center and his men were around him."
,"6":"David then asked Ahimelech the Hittite, and Abishai, son of Zeruiah and Joab's brother, 'Who will go down into the camp with me to Saul?' Abishai answered, 'I will go down with you.'"
,"7":"So, that night, David and Abishai went into the camp and found Saul sleeping in the center, his spear thrust into the ground at his head, while Abner and the rest of the soldiers were sleeping around him."
,"8":"Abishai said to David, 'God has delivered your enemy into your hands this day. Let me nail him to the ground with one thrust of the spear; I will not repeat it.'"
,"9":"But David answered Abishai, 'Do not harm him. For who could harm Yahweh's anointed and not be punished?"
,"10":"As Yahweh lives, only Yahweh may strike him; either he dies on the day appointed or is killed in battle."
,"11":"Don't let me harm Yahweh's anointed! Instead take the spear that is at his head and the water jug and let us be on our way.'"
,"12":"So David took the spear and the water jug from near Saul's head and they left. Nobody saw, nobody knew, nobody woke up. All remained asleep, for a deep sleep from Yahweh had fallen on them."
,"13":"On the opposite slope David stood at a distance, on top of the hill,"
,"14":"and called out to both Abner son of Ner and the soldiers, 'Why don't you answer, Abner?' Abner answered back, 'Who are you to awaken the king?'"
,"15":"David said to Abner, 'Are you not a man? Who is like you in Israel? Why then did you not closely guard your lord the king? An ordinary man has broken into the camp and made an attempt on the life of the king your lord."
,"16":"Is this the way you fulfill your duties? You deserve to die because you did not guard your lord, Yahweh's anointed. Now look for the king's spear and the water jug that were at his head.'"
,"17":"Saul recognized David's voice and asked, 'Is that your voice, David my son?' David answered, 'It is my voice, my lord, O king!"
,"18":"Why does my lord pursue me? What have I done? What am I guilty of?"
,"19":"Now, let my lord the king hear my words. If it is Yahweh who has incited you against me, may an offering appease him; but if men have done so, may they be cursed before Yahweh, for they have made me an exile to this day and have driven me from my share of the inheritance of Yahweh as if saying to me: 'Go and serve other gods.'"
,"20":"Let not my blood flow to the ground far from the presence of Yahweh! For the king of Israel has come to seek out a flea as a man hunts a partridge in the mountains.'"
,"21":"Then Saul said, 'I have done wrong. Come back, David my son. I will not harm you anymore since you valued my life this day. I have acted like a fool and have made a great mistake.'"
,"22":"David answered, 'I have your spear with me, O king! Let one of your servants come over to fetch it."
,"23":"Yahweh rewards a righteous and loyal man. Today he delivered you into my hands but I refused to harm Yahweh's anointed."
,"24":"As I valued your life today, may Yahweh value my life and deliver me from all distress.'"
,"25":"Finally Saul told David, 'Blessed are you, David my son! You shall succeed in everything you do.' Then David went his way and Saul went home."
}`)
	CurrentBook.AddChapter(27, `{
"1":"David thought, 'Some day I shall die at the hand of Saul. It is better for me to escape to the land of the Philistines where I shall be beyond his reach and Saul will get tired of searching for me within the borders of Israel.'"
,"2":"So David went with his six hundred men to Achish, son of Maoch, king of Gath."
,"3":"He and his men lived with Achish in Gath; each one had his family with him and David had his two wives, Ahinoam of Jezreel and Abigail of Carmel, Nabal's widow."
,"4":"When Saul was informed that David had fled to Gath, he no longer searched for him."
,"5":"David said to Achish, 'If I meet with your approval, let me have a place to live in one of the country towns. Why should your servant live in the royal city with you?'"
,"6":"That very day, Achish gave David Ziklag, which since then and up to the present time has belonged to the kings of Judah."
,"7":"David lived one year and four months in the country of the Philistines."
,"8":"David and his men raided the Geshurites, the Girzites and the Amalekites - all these lived in the land extending from Telem to Shur and the land of Egypt."
,"9":"David would attack the land leaving neither man nor woman alive and carrying off their sheep, oxen, asses, camels and garments. Then he would come back to Achish."
,"10":"Whenever Achish asked, 'Whom did you raid this time?' David would answer, 'The Negeb of Judah,' or 'The Negeb of the Jarahmeelites,' or 'The Negeb of the Kenites.'"
,"11":"David left neither man nor woman alive. For he said, 'If I brought them to Gath, they could talk against us and say: This is what David did.' Such was his practice as long as he lived in the country of the Philistines."
,"12":"Achish trusted David and said to himself, 'David is now hated by his own people. He shall be my servant forever.'"
}`)
	CurrentBook.AddChapter(28, `{
"1":"In those days, the Philistines mustered their forces to fight against Israel, and Achish told David, 'I want you to know that you and your men must join me to fight this battle.'"
,"2":"David answered, 'Then you will see for yourself what your servant can do.' Achish said to David, 'I will make you my permanent bodyguard.'"
,"3":"Now Samuel had died and when all Israel had mourned for him, they buried him in his own city, Ramah. Meanwhile, Saul had driven those who consult spirits of the dead and fortunetellers out of the land."
,"4":"As the Philistines gathered together and encamped in Shunem, Saul also mustered the Israelite forces and encamped in Gilboa."
,"5":"But on seeing the Philistine camp, Saul was afraid and his heart failed him."
,"6":"Saul consulted Yahweh but Yahweh gave no answer whether in dreams or by the Urim or through prophets."
,"7":"Then Saul said to his servants, 'Find me a woman who consults the spirits of the dead, that I may go and consult her.' His servants told him, 'There is a medium at Endor.'"
,"8":"Saul disguised himself, putting on other clothes, and left with two men. He arrived at night and said to the woman: 'Tell my fortune through a ghost and call the spirit I shall name.'"
,"9":"But the woman answered him, 'Do you not know that Saul has driven medium and fortunetellers out of the land? Why do you set a trap for me to bring about my death?'"
,"10":"But Saul swore to her by Yahweh, 'As Yahweh lives, you will not be in trouble for this.'"
,"11":"Then the woman asked him, 'Whom do you want me to call up?' Saul said, 'Call up Samuel.'"
,"12":"When the woman saw Samuel, she screamed and said to Saul, 'Why have you deceived me? You are Saul!'"
,"13":"The king then told her, 'Have no fear. What do you see?',The woman said, 'I see him rising from the ground. He is a god.' "
,"14":"Saul asked her, 'What does he look like?' She replied, 'The one rising is an old man clothed in a mantle.' Saul knew that it was Samuel. He knelt and bowed face to the ground in homage."
,"15":"Samuel spoke to Saul, 'Why did you disturb me by summoning me up?' Saul answered, 'I am in great distress, for the Philistines are waging war against me and God has abandoned me. He no longer answers me either through prophets or in dreams. Because of this I have called you to tell me what I should do.'"
,"16":"Samuel said, 'Why do you ask me, if Yahweh has abandoned you and turned against you?"
,"17":"Yahweh has done to you what he foretold through me. He has torn the kingdom from your hand and has given it to your neighbor, David."
,"18":"Remember that you disobeyed Yahweh by not executing his fierce anger against Amalek; that is why Yahweh has done this to you today."
,"19":"Now Yahweh will deliver Israel, together with you, into the hands of the Philistines. By tomorrow, you and your sons shall be with me when Yahweh delivers the army of Israel into the hands of the Philistines.'"
,"20":"Immediately Saul fell full length on the ground, terrified by what Samuel said. He had no strength left because he had not eaten anything all that day and night."
,"21":"The woman drew close to Saul and, seeing how frightened he was, said to him, 'Look, your maidservant has obeyed you and risked her life doing what you have asked her to do."
,"22":"Now it is your turn to listen to me. Let me give you something to eat so you may have strength when you go on your way.'"
,"23":"Saul refused and said, 'I will not eat.' But on the insistence of his servants and the woman, he agreed, rose from the ground and sat on the bed."
,"24":"The woman had a fattened calf in the house which she immediately butchered. She also took some flour, kneaded it and baked unleavened bread,"
,"25":"and set it before Saul and his servants. They then ate and left that night."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Now the Philistines mustered all their forces at Aphek; the Israelites were encamped beside the spring in Jezreel."
,"2":"While the Philistine rulers went ahead of their groups of thousands and hundreds, David and his men were marching at the rear with Achish."
,"3":"The Philistine chiefs asked, 'Who are these Hebrews?' Achish replied to the Philistine chiefs, 'This is David, servant of Saul, king of Israel. He has been with me for over a year and since he fled to me up to the present day I have found no fault in him.'"
,"4":"But the Philistine chiefs were angered at this and said to him, 'Send that man back! Let him return to the place where you assigned him. He must not go down into battle with us lest during the battle he turn against us. How better could this fellow regain his master's favor than by bringing him the heads of our men?"
,"5":"Is this not the David for whom they danced and sang: Saul has slain his thousands, but David his tens of thousands?'"
,"6":"So Achish called David and said to him, 'As Yahweh lives, you are honest and I would like you to be with me in the camp for I have found nothing wrong in you since you came to me up to the present day. But you displease the lords."
,"7":"So it is better for you to leave and go back quietly and do nothing to displease the Philistine lords.'"
,"8":"David asked Achish, 'But what have I done? Have I done anything since I entered your service until the present time that would bar me from joining the fight against the enemies of my lord the king?'"
,"9":"Achish replied to David, 'I myself hold nothing against you, but the Philistine chiefs are determined not to allow you to join us in battle."
,"10":"Now, therefore, get up early tomorrow morning and leave with the soldiers who came with you.'"
,"11":"So David and his men left early in the morning and returned to the land of the Philistines. The Philistines, in the meantime, went on to Jezreel."
}`)
	CurrentBook.AddChapter(30, `{
"1":"David and his men reached Ziklag on the third day, but the Amalekites had just raided the Negeb and Ziklag, storming it and burning it to the ground."
,"2":"They had taken captive the women and all who were in the city, young and old. They killed no one but carried them off when they left."
,"3":"When they reached the town, David and his men found it burned to the ground and their wives, sons and daughters taken captive."
,"4":"Then David and those with him wept aloud until they could weep no more."
,"5":"David's two wives, Ahinoam of Jezreel and Abigail, widow of Nabal of Carmel had also been taken captive."
,"6":"Now David was greatly distressed because the people were talking of stoning him; for they were embittered because of what had happened to their sons and daughters. But David found strength in Yahweh his God."
,"7":"David told Abiathar the priest, son of Ahimelech, to bring him the ephod. So Abiathar brought the ephod to David"
,"8":"who then consulted Yahweh, 'Shall I go after these raiders? Can I overtake them?' The answer was, 'Go after them for you shall surely overtake them and recover the captives.'"
,"9":"David set out with his six hundred men and they reached the brook of Besor. There, two hundred men stayed behind, for they were too exhausted to cross the brook,"
,"10":"and David continued the chase with four hundred men."
,"11":"They found an Egyptian in the open country and brought him to David. They gave him food, which he ate, and water to drink."
,"12":"They gave him a piece of fig cake and two pieces of raisin cake. The Egyptian ate and recovered his strength, for he had been three days and three nights without eating or drinking."
,"13":"David then questioned him, 'To whom do you belong, and where do you come from?' He answered, 'I am an Egyptian, slave of an Amalekite. My master abandoned me because I fell sick three days ago."
,"14":"We raided the Negeb of the Cherethites, the territory of Judah and the Negeb of Caleb and set Ziklag on fire.'"
,"15":"David then asked him, 'Will you lead me to this raiding band?' He replied, 'Swear to me by God that you will neither kill me nor deliver me into the hands of my master and I will lead you to this raiding band.'"
,"16":"So the Egyptian led David to the raiding band whom they found scattered all over the ground, eating, drinking, dancing and feasting with the spoils they had taken from the land of the Philistines and from the land of Judah."
,"17":"David fought them from early morning to the evening of the following day, allowing no one to escape except four hundred young men who mounted their camels and fled."
,"18":"David recovered everything the Amalekites had taken and rescued his two wives."
,"19":"Nothing and no one was missing, small or great, son or daughter, booty or anything the Amalekites had taken. David brought back everything."
,"20":"He then gathered flocks and herds and the people drove them before him, saying, 'These are David's spoils!'"
,"21":"David reached the two hundred men who had been too tired to follow him, and were left behind at the Besor brook. These men came to meet David and those who were with him. David then drew near and greeted them."
,"22":"But the malicious and worthless people among those who had accompanied David said, 'Since they did not come with us, we shall not share the booty with them; let each of them take his wife and children and leave.'"
,"23":"But David said, 'My brothers, you shall not do that after what Yahweh has given us. He has protected us and delivered into our hands the band that raided us."
,"24":"Who would agree to what you have said? The share of those who go down to battle and of those who remain with the baggage shall be the same; they shall share alike.'"
,"25":"From that day to the present, this has been a statute and custom for Israel."
,"26":"When David arrived in Ziklag, he sent part of the booty to the elders of Judah, to each of his friends, saying, 'This is a gift to you from the booty of Yahweh's enemies:"
,"27":"to those in Bethel, in Ramoth-negeb, in Jattir,"
,"28":"in Aroer, in Sipmoth, in Eshtemoa,"
,"29":"in Racal, in the Jerahmeelite cities, in the Kenite cities,"
,"30":"in Hormah, in Borashan,"
,"31":"in Athach, in Hebron, and in all the places where David and his men had stayed."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Now the Philistines fought against the Israelites who, in their flight, fell mortally wounded on Mount Gilboa."
,"2":"The Philistines surrounded Saul and his sons and killed Jonathan, Abinadab and Malchishua, Saul's sons."
,"3":"The battle raged around Saul, and he was afraid when he saw that the archers had found him."
,"4":"Then Saul commanded his armor-bearer, 'Draw your sword and run me through lest these uncircumcised men come and stab me themselves, making fun of me.' But his armor-bearer did not move because he was greatly terrified. So Saul drew his own sword and fell upon it."
,"5":"Seeing that Saul was dead, the armor-bearer also fell upon his sword and died with him."
,"6":"Thus, Saul, his three sons, his armor-bearer and all his men died together on the same day."
,"7":"When the Israelites on the other side of the valley and those beyond the Jordan saw that the men of Israel had fled and that Saul and his sons were dead, they abandoned their cities and fled. Then the Philistines came and occupied those cities."
,"8":"The following day, the Philistines came to strip the slain and found Saul and his three sons lying dead on Mount Gilboa."
,"9":"They cut off his head and stripped off his armor and then sent messengers throughout the Philistine lands to proclaim this good news in the temples of their idols and among the people."
,"10":"They put his armor in the temple of Ashtaroth and pinned his body on the wall of Bethshan."
,"11":"When the inhabitants of Jabesh-gilead heard what the Philistines had done to Saul,"
,"12":"all their warriors set out, marched through the night and removed the bodies of Saul and his sons from the wall of Bethshan. They then returned to Jabesh and burnt the bodies there."
,"13":"Then they took their bones and buried them under the tamarisk tree in Jabesh, after which, they fasted for seven days."
}`)

}
func EN_CCB_LoadVH2MChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Greetings to our brothers, the Jews in Egypt, from their brothers, the Jews in Jerusalem and in the region of Judea - may you have peace and happiness."
,"2":"May God fill you with every good and remember his covenant with Abraham, Isaac and Jacob, his faithful servants."
,"3":"May he give you all a heart to worship him and to fulfill his will with generosity and a well-disposed spirit."
,"4":"May he incline your hearts to listen to his law and precepts, and give you peace."
,"5":"May he hear your prayers and be reconciled with you, and not abandon you in time of misfortune."
,"6":"This is what we now pray for you."
,"7":"In the year one hundred and seventy-nine, when Demetrius was king, we Jews wrote to you during the most critical moment of trials that we had to endure during those years. And we said to you: 'Jason and his associates have betrayed the cause of the Holy Land and of the Kingdom."
,"8":"They have burned the Temple gateway and shed innocent blood. But we prayed to the Lord and were heard. And now we have just offered a sacrifice with wheat flour, lighted the lamps again and set out the loaves of bread. "
,"9":"So we write to you again that you may celebrate the Feast of Tents in the month of Chislev in this year one hundred and eighty-eight."
,"10":"The inhabitants of Jerusalem and Judea, their senators and Judas, to Aristobulus, teacher of King Ptolemy, belonging to the family of the anointed priests, and to the Jews in Egypt: greetings and prosperity."
,"11":"Having been saved by God from great dangers, we give him thanks because he came to our help against the king himself."
,"12":"God drove out those who fought against the Holy City;"
,"13":"their leader left for Persia with a seemingly invincible army, but the priests of the goddess Nanea laid a trap for them and killed them in her temple."
,"14":"Antiochus and his friends came to that place under the pretext of marrying the goddess, but in reality they wanted to seize its great treasures as a dowry."
,"15":"The priests of Nanea had set out the treasures and Antiochus entered the sacred enclosure with a few men. But as soon as Antiochus had entered, they closed the temple"
,"16":"and opened a secret door in the ceiling. Then they threw stones down and crushed the leader and his men. They then dismembered the bodies, cut off their heads and threw them to those outside."
,"17":"In all these things, may our God be blessed for he has handed over the impious to death."
,"18":"As we are about to celebrate the purification of the Temple on the twenty-fifth day of Chislev, it seems good to us to inform you, so that you, too, may celebrate the Feast of Tents and remember the fire that appeared when Nehemiah, who built the Temple and the altar, offered sacrifices."
,"19":"For when our fathers were deported to Persia, the devout priests of the time took some of the fire from the altar and hid it secretly in the hollow of a dry well, with such caution that the place remained unknown to everyone."
,"20":"Many years had passed, when in God's own time Nehemiah, who was commissioned by the king of Persia, sent the descendants of the priests who had hidden the fire to look for it."
,"21":"But they reported to us that they did not find the fire but instead a thick liquid. So Nehemiah ordered them to draw it out and bring it to him. When the sacrifice had been prepared on the altar, Nehemiah ordered the priests to sprinkle the liquid on the wood and the victims placed on it. "
,"22":"They did so and after some time the sun which had previously been clouded over, shone. At once such a great fire blazed up that all were astonished."
,"23":"While the sacrifice was being consumed, the priests together with all those present prayed. Jonathan led while Nehemiah and the rest responded."
,"24":"This was their prayer: 'Lord, Lord God, Creator of all things, dreadful and strong, just and merciful, you alone are good and are King, "
,"25":"you alone are generous, just, all-powerful and eternal. You who save Israel from many evils, who chose our fathers and sanctified them,"
,"26":"accept this sacrifice on behalf of all your people Israel. Protect your heritage and sanctify it."
,"27":"Gather our scattered people together, set free those held in slavery among the nations, turn your eyes on those who are despised and crushed; so the pagans may know that you are our God."
,"28":"Afflict those who oppress us, who insult and treat us with contempt."
,"29":"Plant your people in your holy place, as Moses said.'"
,"30":"The priests sang the hymns,"
,"31":"and when the sacrifice was all consumed, Nehemiah ordered that the remaining liquid be poured over some large stones."
,"32":"This was done, and a flame flared up but it was outshone by the fire from the altar."
,"33":"This matter became known, and it was reported to the king of the Persians that the liquid with which Nehemiah and his companions had burned the sacrifice was found in the place where the exiled priests had hidden the fire."
,"34":"So, after verifying the facts, the king ordered that a fence be built to enclose the place and decreed that it be a sacred place."
,"35":"The king gave some of that liquid to those who enjoyed his favor, and they gave him gifts in return."
,"36":"Nehemiah and his companions called the place 'Nephtar' which means 'purification' but afterwards, many called it 'Naphtha.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"It is found in the archives that the prophet Jeremiah ordered the exiles to take the fire, as we have already said."
,"2":"After giving them the Law, he exhorted them not to forget the precepts of God and not to let themselves be dazzled by the idols of silver and gold with all their adornment."
,"3":"He spoke to them of many similar things, admonishing them never to lose their love for the Law."
,"4":"It is also said in these writings of the past that the prophet Jeremiah, fulfilling orders from Heaven, commanded that the ark of the Covenant with its tent be brought with him. And he went to the mountain which Moses had climbed before and from where he had seen the promised land."
,"5":"There Jeremiah found a cave; and he brought in the ark, the tent that covered it and the altar of incense. Then he closed up the entrance with stones."
,"6":"Some of those who followed him returned to mark out the way, but they could not find it anymore."
,"7":"When Jeremiah learned this, he reproached them and said, 'This place is to remain hidden until God has compassion on his scattered people and gathers them together."
,"8":"Then the Lord will reveal these things again and his Glory shall appear in the cloud as it appeared in the time of Moses and when Solomon asked God to come and consecrate his house.'"
,"9":"It was also reported in these archives how Solomon, inspired by his wisdom, offered the sacrifice of the dedication and completion of the Temple."
,"10":"And as fire had come down from heaven through the prayer of Moses to consume the offerings and the sacrificial victim, so through the prayer of Solomon, fire also came down from heaven and burned up the holocausts."
,"11":"And what Moses had said was fulfilled: Inasmuch as the sin-offering was not eaten, the fire consumed it."
,"12":"Solomon celebrated the feast, too, for eight days."
,"13":"This also can be read in the archives and in the Memories of Nehemiah's time. It is recounted there that Nehemiah founded a library and collected the books dealing with the kings and the prophets, the writings of David and the letters of the kings about offerings."
,"14":"In the same way, Judas has just gathered all the books dispersed on account of the war we suffered, and they are now in our possession."
,"15":"So, if you need any of them, send someone to get them for you."
,"16":"We said we are now about to celebrate the feast of the purification of the Temple; you will do well to celebrate these feast days also,"
,"17":"for God has saved all his people and returned to everyone his own land. He let us recover the kingdom, the Temple, and the worship rendered to him in that Temple,"
,"18":"as is commanded in his Law. God himself, as we do hope, will soon have mercy on us and gather us together from everywhere to the Holy Place, since he has rescued us from great evils and has purified this Place."
,"19":"The story of Judas Maccabeus and his brothers has been written by Jason of Cyrene. He narrated the purification of the Temple of the Most High, the dedication of the altar,"
,"20":"the wars against Antiochus Epiphanes and his son Eupator,"
,"21":"and the heavenly manifestations in favor of those who fought bravely and gloriously for Judaism. Although they were few in number, they liberated the whole land and put to flight hordes of foreigners."
,"22":"They regained the Temple renowned throughout the world, liberated the city and reestablished the laws which were nearly abolished, for the Lord was gracious to them in his great kindness."
,"23":"All this, which has been set forth in five volumes by Jason of Cyrene, we shall now attempt to sum up in a single book."
,"24":"We recognize that these books contain many figures, and that it is difficult for those who wish to understand this history because of so many facts."
,"25":"So we have concerned ourselves to offer something engaging for those who simply want to read, something easily committed to memory, and profitable for anyone who reads it."
,"26":"For us who have undertaken the arduous task of summarizing, it has not been easy but has cost as much effort"
,"27":"as it would to prepare a banquet which would please everyone. But like those who prepare a banquet, we have endured this toil willingly in order to please others."
,"28":"So we leave to the historian the task of relating accurately all the details, and we have condensed this enormous work into a simple summary."
,"29":"For just as the architect of a new house has to be concerned about the whole construction, while the painters and decorators are concerned only about what relates to their task, so it is with us."
,"30":"The analysis of details and discussion on disputable points belongs to the historian."
,"31":"But for one who tries to condense a report, his task is to summarize and not present a complete narration of facts and events."
,"32":"So let us begin our narrative without going on at length about what has been said before, for it would be senseless to expand the preface while cutting short the narration of the history itself."
}`)
	CurrentBook.AddChapter(3, `{
"1":"While the Holy City enjoyed complete peace and the laws were observed as perfectly as possible through the piety of Onias the High Priest and his hatred for all wickedness,"
,"2":"it came about that kings honored the Holy Place and made the High Priest richer by their magnificent gifts."
,"3":"Even Seleucus, king of Asia, paid from his own account for the expenses of the sacrificial services."
,"4":"But a certain Simon, a priest of the tribe of Bilgah and the Temple administrator, came into conflict with the High Priest regarding the inspection of the city markets."
,"5":"But he could not prevail over Onias. So he went to Apollonius of Tarsus, the governor of Coele-Syria and Phoenicia,"
,"6":"and reported to him that the treasury in Jerusalem was full of untold wealth, that there was a great amount of money which had nothing to do with the expenses required by the sacrifices, and that all this could easily be brought under the control of the king."
,"7":"Apollonius met with the king and told him about the wealth that had been disclosed to him. The king then sent Heliodorus, who was in charge of his affairs, with a letter that authorized him to transfer the treasures."
,"8":"Heliodorus at once set out on his journey, pretending that he was going to visit Coele-Syria and Phoenicia, but with the intention of carrying out the king's order."
,"9":"On his arrival in Jerusalem, he was hospitably received by the city and the High Priest to whom he related the report that had been made. He revealed the reason for his coming and asked the High Priest if the report was really true."
,"10":"The High Priest explained that there were some deposits belonging to widows and orphans."
,"11":"Some belonged to Hyrcanus, son of Tobias, a person of very prominent position, who had also been affected by these slanders. All in all, the treasury had four hundred talents of silver and two hundred of gold."
,"12":"Finally, Onias pointed out that it was utterly impossible to cheat those who had put their confidence in this Holy Place and in the inviolable majesty of that Temple venerated throughout the world."
,"13":"But, following the orders of the king, Heliodorus insisted that all those treasures should be turned over to the king."
,"14":"So, on the day set for Heliodorus to draw up the inventory, there was great disturbance in the city."
,"15":"The priests in their sacred vestments stood before the altar and called upon Heaven: he who had given the law governing deposits should now preserve them for those who had deposited them."
,"16":"None could look at the face of the High Priest without being deeply touched, for his appearance and his paleness revealed the anguish of his soul."
,"17":"A kind of fear overwhelmed him that made him tremble from head to foot, showing to those who saw him the sorrow of his heart."
,"18":"People rushed out of their houses in great confusion to pray together because the Holy Place was about to be profaned."
,"19":"The women, girded with sackcloth below their breasts, thronged into the streets. The younger girls who were not yet allowed to go out into the streets ran to the doorways, and some climbed the walls and others looked out from the windows."
,"20":"All raised their hands to heaven and joined in prayer."
,"21":"It was touching to see such a crowd prostrate in disarray on the ground and the High Priest in great anguish."
,"22":"While they were praying to the All-powerful Lord to protect the deposits of the Temple and keep them safe for those who entrusted them to the High Priest,"
,"23":"Heliodorus began to carry out what had been decided upon."
,"24":"He had already come near the Treasury with his bodyguard, when the Lord of the spirits and of every power caused so great a manifestation that all who had dared accompany Heliodorus were astonished before the power of God, and they lost their strength and courage."
,"25":"There appeared to them a horse with magnificent gear and on it was a fearsome rider. It rushed furiously at Heliodorus and struck at him with its forefeet. The rider appeared to have armor of gold."
,"26":"And two young men, strong and very beautiful and magnificently clothed, also appeared. They stood on each side of Heliodorus, and flogged him continuously, inflicting stroke after stroke."
,"27":"Heliodorus fell to the ground, enveloped in great darkness; then his men took him up and put him on a stretcher."
,"28":"So he was carried away, powerless even to help himself, he who but a moment before had proudly entered the treasury with a great retinue and all his bodyguard. Everyone clearly recognized the power of God."
,"29":"Because of the divine intervention, Heliodorus became mute and lost all hope of saving his life."
,"30":"Meanwhile the Jews blessed the Lord who had glorified his Holy Place. The Temple, which a little while before had been filled with terror and fear, now overflowed with joy and gladness because of the extraordinary manifestation of God."
,"31":"Then some of Heliodorus' companions begged Onias to call upon the Most High to grant the grace of life to him who was at the point of death."
,"32":"The High Priest, on his part, feared that the king might suspect the Jews of some foul play against Heliodorus, so he offered a sacrifice for the man's recovery."
,"33":"While the High Priest was offering the sacrifice of atonement, the same young men, clothed in the same way, again appeared to Heliodorus, and standing before him, said, 'Thank Onias the High Priest, for through him the Lord grants you the grace of life."
,"34":"And as for you, who have been scourged by heaven's command, make known to all how great is the power of God.' Having said this, they vanished."
,"35":"Heliodorus then offered a sacrifice to the Lord and prayed at great length to him who had spared his life. He took leave of Onias and went back with his guards to the king."
,"36":"There he began to bear witness to the works of the Most High God, which he had seen with his own eyes."
,"37":"The king asked Heliodorus who could be sent again to Jerusalem to carry out what he failed to do. Heliodorus answered him,"
,"38":"'If you have some enemy whom you wish to eliminate, send him there and you will see him return well flogged; that is, if he ever returns at all, for surely, divine power is in that place."
,"39":"He himself who dwells in heaven watches over the place and defends it, striking to death those who come to profane it.'"
,"40":"This was what happened to Heliodorus and how the Treasury was saved."
}`)
	CurrentBook.AddChapter(4, `{
"1":"The Simon mentioned before as the informer about the treasures of the Temple, who was traitor to his country, spoke evil of Onias, accusing him of a plot against Heliodorus and saying that he was responsible for all the troubles."
,"2":"He even dared to lay the blame for everything on Onias who was the great benefactor of the city, the defender of his compatriots and a zealous observer of the laws."
,"3":"The hostility between them reached such proportions that crimes were even committed by some of the supporters of Simon."
,"4":"Onias recognized the dangers involved in such an unbearable rivalry. Even Apollonius, son of Menestheus, governor of Coele-Syria and Phoenicia, was instigating Simon to evil."
,"5":"So Onias went to the king, not to accuse his fellow citizens, but for the good of the whole nation."
,"6":"For he saw that it was impossible to maintain peace and stop the foolishness of Simon without the king's intervention."
,"7":"When King Seleucus died, his son Antiochus who was called Epiphanes, succeeded to the throne. Then, Jason, the brother of Onias the High Priest, usurped the office of high priest."
,"8":"In a conversation with the king, Jason promised three hundred and sixty talents of silver and eighty talents from other revenues."
,"9":"He further committed himself to pay one hundred fifty more talents if he would be allowed to establish on his own account a gymnasium with a Center for the cultural advancement of the youth and if the statute of Antioquian citizenship could apply to the inhabitants of Jerusalem, as well."
,"10":"With the consent of the king and using the power at his disposal, he at once set about encouraging his fellow citizens to adopt the customs of the Greeks."
,"11":"He suppressed the privileges that kings had granted to the Jews through John, the father of Eupolemus, who had established friendship and an alliance between the Romans and the Jews. He overthrew lawful institutions and introduced new customs contrary to the Law."
,"12":"So, he very readily founded a gymnasium right under the Citadel, and persuaded the noblest among the young to be educated in the Greek way."
,"13":"Paganism was propagated through Jason's influence, who proved to be more of a godless wretch than a high priest. Greek customs were so much in vogue, "
,"14":"that priests no longer showed any interest in serving at the altar. They despised the sanctuary and neglected the sacrifices and as soon as the discus throw began they would run to the stadium to take part in athletic competitions prohibited by the Law."
,"15":"They did not value anymore the customs of their fathers, but held in highest esteem the values of the Greeks."
,"16":"With this, they themselves were put in a difficult situation, for those whom they took as models and whose customs they wanted to imitate in everything proved to be their enemies and tyrants."
,"17":"For it is not easy to break the divine laws with impunity as the following episodes will show."
,"18":"When the quinquennial games held every five years were going on in Tyre before the king,"
,"19":"the wicked Jason sent as envoys some 'citizens of Antioch' from the inhabitants of Jerusalem and he entrusted to them three hundred drachmas of silver allotted for the sacrifice to Hercules. When these envoys came, they decided that it was not fitting to spend the money on the sacrifice, but preferred to spend it on other things."
,"20":"So through the sole initiative of those sent to spend the money for the sacrifice to Hercules, the amount was used instead for the construction of trireme ships."
,"21":"Antiochus had sent Apollonius, son of Menestheus, to Egypt to represent him in the enthronement of King Philometor. But when Antiochus learned that Philometor had become his political adversary, Antiochus was worried about his own safety."
,"22":"So, he left Joppa, and went to Jerusalem where he was well received by Jason and the whole city, entering the city in the midst of acclamations and torches. Then, he went with his troops to Phoenicia."
,"23":"After three years, Jason sent Menelaus, brother of the Simon mentioned above, to bring the money to the king and initiate steps to negotiate urgent matters with him."
,"24":"Menelaus presented himself to the king whom he impressed by his personal bearing as a man of authority, and so obtained the office of high priest for himself, offering three hundred talents more than Jason."
,"25":"After receiving the royal mandate, he returned with nothing worthy of a high priest, but only with the rage of a cruel tyrant or a wild beast."
,"26":"Jason, who had usurped the office of his brother, was now supplanted by another, and had to flee to the land of Ammon."
,"27":"Menelaus held the office but did not pay the amount he promised to the king,"
,"28":"although Sostratus, the commander of the Citadel, demanded the payment, since the king had entrusted to him the collection of revenue. The two of them were then summoned by the king because of this."
,"29":"Menelaus left his brother Lysimachus as his substitute, and Sostratus left Crates, the commander of the Cypriots."
,"30":"Meanwhile, the inhabitants of Tarsus and Mallus revolted because their cities were given as a gift to Antiochis, the king's concubine."
,"31":"The king set out at once to reestablish order, leaving Andronicus, one of his ministers, as his deputy."
,"32":"Menelaus thought of taking advantage of the opportunity, and stole some of the golden vessels from the Temple, which he then gave to Andronicus as gifts. He also managed to sell others in Tyre and in the neighboring cities."
,"33":"When Onias had clear evidence of what Menelaus had done, he sought refuge in Daphne near Antioch, a place of asylum, and from there denounced him."
,"34":"For this reason, Menelaus met Andronicus in private and urged him to kill Onias. Andronicus went to Onias and deceitfully gained his confidence, offering Onias his right hand in oath. He was able to persuade Onias, in spite of the latter's suspicion, to come out of his place of refuge. Then Andronicus killed him at once without any regard for justice."
,"35":"For this reason, not only Jews but people of other nationalities as well became indignant and grieved over the unjust killing of that man."
,"36":"When the king returned to the regions of Coele-Syria, the Jews of Jerusalem, together with the Greeks who were for justice, went to see him and complained about the murder of Onias."
,"37":"The king was touched and became sad, and even wept as he remembered the personality and noble conduct of the departed."
,"38":"He became angry with Andronicus and immediately removed him from office. Then he ordered that Andronicus be divested of his purple robe, tore his garments off him, and led him all around the city up to the place where Andronicus had murdered Onias, and right there the king ordered that he be put to death - God dealing out to him the punishment he deserved."
,"39":"Lysimachus committed much sacrilegious plunder in Jerusalem with the connivance of Menelaus. When this became known, the populace rebelled against Lysimachus, who had already taken many golden vessels from the city."
,"40":"When Lysimachus saw the people rising up in rebellion and becoming enraged, he armed about three thousand men and began a violent repression, designating as leader a certain Auranus, a man advanced in years but of very little intelligence."
,"41":"So, as the people were attacked by the men of Lysimachus, they reacted by picking up stones and clubs, and even gathered handfuls of ashes lying at hand, and threw everything against the men of Lysimachus."
,"42":"In this way, they wounded many of them, killed some, and put the rest to flight. As for the sacrilegious robber Lysimachus, they killed him near the treasury."
,"43":"Because of all this a charge was brought against Menelaus and"
,"44":"when the king arrived at Tyre, three men sent by the council of the elders of Jerusalem told him of Menelaus' cruelty."
,"45":"Seeing his ruin, Menelaus promised a great amount of money to Ptolemy, son of Dorymenes, in order to have the king in his favor."
,"46":"Ptolemy then went with the king privately to a colonnade for some fresh air, and persuaded him to change his mind."
,"47":"The king actually dismissed all the accusations against Menelaus, the cause of all this evil, while he condemned to death Menelaus' unfortunate accusers who would have been acquitted had a tribunal of barbarians judged them."
,"48":"So those who had defended the cause of the city, the people and the sacred vessels were executed at once."
,"49":"Some Tyrians were so enraged by that crime that they prepared a magnificent funeral for them."
,"50":"But through the corruption of the rulers, Menelaus remained in power, growing in wickedness and becoming a tyrant towards his own people."
}`)
	CurrentBook.AddChapter(5, `{
"1":"By this time, Antiochus was preparing a second expedition against Egypt."
,"2":"And for nearly forty days, there appeared throughout the city, galloping through the air, horsemen dressed in gold,"
,"3":"troops with swords drawn and formed in squadrons, cavalry squadrons in order of battle, attacks and charges from this side and that, movements of shields, many spears, arrows, missiles, the glitter of golden outfits and armor of all kinds."
,"4":"Everyone prayed that these apparitions would be an announcement of something good about to happen."
,"5":"As a false rumor spread that Antiochus had died, Jason gathered together about ten thousand men and launched a surprise attack on the city. The troops upon the walls defended the city, but once these were taken, the whole city fell into the hands of Jason, while Menelaus took refuge in the Citadel."
,"6":"Jason cruelly massacred his fellow citizens, without realizing that his victory against his own nation was the greatest defeat. He seemed to believe that he was winning over enemies when, in reality, these were his own people."
,"7":"But he did not stay in power for long and after obtaining nothing but shame for himself, he had to flee once again to the land of Ammon."
,"8":"Finally, he had a very unfortunate end. Accused before Aretas, the king of the Arabs, fleeing from city to city, pursued by all, scorned as a renegade from the law and hated as the executioner of his country and fellow citizens, he was banished to Egypt."
,"9":"And he, who had exiled so many from their own country, died in exile: for he went as far as Lacedemonia in the hope of finding protection there because of the kinship between that people and ours."
,"10":"He, who had deprived so many of burial places, died with no one to mourn him, no funeral rites nor place in the tomb of his fathers."
,"11":"When news of these events reached the king, he thought that the whole of Judea had risen in rebellion. He became furious and, leaving Egypt, went to take Jerusalem by force."
,"12":"He ordered his soldiers to kill without mercy everyone they encountered and to behead as well all those who took refuge in their houses."
,"13":"Young and old perished; men, women and children were massacred, and infants and virgins were put to the sword."
,"14":"Within only three days, there were eighty thousand victims - forty thousand perished in the slaughter and as many were sold as slaves."
,"15":"Not content with this, Antiochus boldly entered the holiest Temple in the entire world, guided by Menelaus, the traitor to the law and country."
,"16":"With his unclean hands, Antiochus seized the sacred vessels, and with impious hands took away what other kings had given as gifts for the glory and honor of the Temple."
,"17":"But in acting in such an insolent manner, Antiochus did not realize that the Lord had let him profane the Temple in order to punish the inhabitants of the city, because their sins had offended him."
,"18":"For, had the city not been sinful, Antiochus would have been flogged the moment he entered, as Heliodorus who was sent by Seleucus to rob the treasury had been. And he would have also repented of his audacity."
,"19":"But God had not chosen the people for the Temple, but the Temple for the sake of the nation."
,"20":"Therefore, the Temple also shared in the nation's misfortune, as it also shared afterward in its restoration. As it had been abandoned in the time of the wrath of God, it was again restored to its glory when the Most High Lord was appeased."
,"21":"Antiochus took with him eighteen hundred talents which he had stolen from the Temple, and hurriedly went back to Antioch, so proud that he thought himself capable of sailing by land and walking on the sea."
,"22":"At his departure, he left ministers to oppress our race. In Jerusalem, he appointed Philip, of Phrygian ancestry and of more barbarous character than he who had appointed him;"
,"23":"and he left Andronicus in Gerizim. Besides there was Menelaus, who surpassed them in his hatred for his fellow citizens. This man had indeed a deep hatred for his Jewish brothers."
,"24":"Antiochus also sent Apollonius with an army of twenty-two thousand soldiers with orders to behead all the grown men and sell the women and children."
,"25":"Arriving in Jerusalem, under the pretext of peace, he waited until the holy day of the sabbath. Then he took the Jews by surprise as they rested. He ordered his men to conduct a military parade,"
,"26":"and he killed all those who came out to see the show. Then, running through the streets, the soldiers killed many people."
,"27":"Judas Maccabeus, however, withdrew into the desert with about nine others willing to live like the wild beasts. There they fed on clean vegetables, for they did not want to eat unclean meat."
}`)
	CurrentBook.AddChapter(6, `{
"1":"After a while, the king sent an older Athenian to force the Jews to abandon their ancestral laws and no longer live according to the laws of God."
,"2":"And to have them also profane the temple in Jerusalem and dedicate it to the Olympian god. In the same way, he wanted them to dedicate the temple in Mount Gerizim to the hospitable god, according to the wishes of the inhabitants of the place."
,"3":"This worsened the evil and made it difficult and unbearable for all."
,"4":"The Temple was profaned by the orgies of the pagans who went there to have a good time with prostitutes, and had intercourse in the sacred enclosures. And besides, they brought into the Temple things not permitted by the Law;"
,"5":"the altar was laden with unclean victims prohibited by the law."
,"6":"It was no longer allowed to celebrate the sabbath or observe the customs of our fathers, or even to declare oneself a Jew."
,"7":"But, on the contrary, they were led by bitter necessity to celebrate the king's birthday with a monthly sacrifice. And when the feast of Dionysus came, they were also forced to follow the Dionysus procession and wear floral wreaths."
,"8":"At the suggestion of the inhabit-ants of Ptolemy, a decree was sent to the neighboring Greek cities ordering them to treat the Jews who lived there in the same way and oblige them to participate in the sacrifices."
,"9":"Those who would not adopt the Greek customs were to be killed. So it was easy to foresee the fatal outcome."
,"10":"Two women were charged of having performed the rite of circumcision on their sons. They publicly paraded the women throughout the city with their babies hung at their breasts. Then they hurled them down from the city wall."
,"11":"Others who had assembled in nearby caves to celebrate the sabbath were denounced to Philip and they allowed themselves to be burned. Because of the holiness of the sabbath day, they had scruples about defending themselves."
,"12":"I now ask the readers of this book not to be shocked by these calamities. Bear in mind that this did not happen for the destruction of our race, but rather for our education."
,"13":"God is showing his kindness when he does not let sinners continue on their way for a long time, but punishes them at once."
,"14":"As for the other nations, the patient Lord doesn't punish them until they reach the full measure of their sins. But he deals with us in a different manner:"
,"15":"he does not wait until we have reached the full measure in order to punish us."
,"16":"Therefore he never withdraws his mercy from us, and does not abandon his people, even when he punishes us with some adversity."
,"17":"After reminding our readers of these truths, let us continue the story."
,"18":"Eleazar, one of the prominent teachers of the Law, already old and of noble appearance, was forced to open his mouth to eat the flesh of a pig."
,"19":"But he preferred to die honorably than to live in disgrace, and voluntarily came to the place where they beat him to death. He spit out bravely the piece of meat,"
,"20":"as should be done by those who do not want to do things prohibited by the Law, even to save their life."
,"21":"Those in charge of this impious banquet took him aside, since they had known him for a long time, and tried to convince him to pretend to be eating the meat, but in reality, to eat something allowed by the Law and prepared by himself."
,"22":"In this way, he could escape death, and be treated with humanity for the sake of their long-time friendship."
,"23":"But he preferred to make a noble decision worthy of his age, of his noble years, of his shining white hair, and of the irreproachable life he had led from childhood. Above all, showing respect for the holy laws established by God, he answered that he would rather be sent to the place of the dead. And he added,"
,"24":"'It would be unworthy to pretend at our age, and to lead many young people to suppose that I, at ninety years, have gone over to the pagan customs."
,"25":"If I led them astray for the sake of this short life I would bring disgrace to my old age."
,"26":"Even if I could now be saved from men, I cannot - whether living or dead - escape from the hands of the Almighty."
,"27":"I prefer to bravely sacrifice my life now, as befits my old age."
,"28":"So I shall leave an excellent example to the young, dying voluntarily and valiantly for the sacred and holy laws.',Having said this, he gave himself over to death."
,"29":"Those who escorted him considered his words foolishness, so their previous gentleness turned into harshness."
,"30":"When he was almost at the point of death, he said groaning, 'The Holy Lord, who sees all, knows that though I could have saved myself from death, I now endure terrible sufferings in my body. But in my soul, I suffer gladly because of the respect I have for him.'"
,"31":"In his death, he left a noble example and a memorial of virtue and strength, not only to the young but to the whole nation."
}`)
	CurrentBook.AddChapter(7, `{
"1":"It happened also that seven brothers were arrested with their mother. The king had them scourged and flogged to force them to eat the flesh of a pig which was prohibited by the Law."
,"2":"One of them, speaking in behalf of all, said, 'What do you want to find out from us? We are prepared to die right now rather than break the law of our ancestors.'"
,"3":"The king became furious and ordered that pans and caldrons be heated over a fire."
,"4":"When these were red-hot, he commanded that the tongue of their spokesman be cut out, his head scalped, and his hands and feet cut off while his brothers and mother looked on."
,"5":"When he had been thoroughly mutilated, the king ordered that while still breathing, he be brought to the fire and roasted alive. While the smoke from the pan spread widely, the other brothers and their mother encouraged one another to die bravely. And they said,"
,"6":"'The Lord God sees all, and in reality, has compassion on us, as Moses declared in his song, and clearly said: The Lord will have pity on his servants.'"
,"7":"When the first had left the world in this way, they brought the second for execution. After stripping the skin with the hair from his head, they asked him: 'Which do you prefer: to eat the flesh of a pig or to be tortured limb by limb?'"
,"8":"He answered them in the language of his ancestors, 'I will not eat.' And so he, too, was tortured."
,"9":"At the moment of his last breath, he said, 'Murderer, you now dismiss us from life, but the King of the world will raise us up. He will give us eternal life since we die for his laws.'"
,"10":"After this, they punished the third. He stuck his tongue out when asked to, bravely stretched forth his hands,"
,"11":"and even had the courage to say: 'I have received these limbs from God, but for love of his laws I now consider them as nothing. For I hope to recover them from God.'"
,"12":"The king and his court were touched by the courage of this young man, so unconcerned about his own sufferings."
,"13":"When this one was dead, they subjected the fourth to the same torture."
,"14":"At the point of death, he cried out, 'I would rather die at the hands of men, and wait for the promises of God who will raise us up; you, however, shall have no part in the resurrection of life.'"
,"15":"They took the fifth at once and tortured him. But with his eyes fixed on the king,"
,"16":"he said to him, 'Though you are mortal, you have authority over people and are able to do what you will. But do not think that our race has been abandoned by God."
,"17":"Wait, and you shall see his great power when he torments you and your descendants.'"
,"18":"After this, they took the sixth who, at the point of death, said, 'Don't be mistaken. We suffer all this because of ourselves for we have sinned against our own God; so these astonishing things have come upon us."
,"19":"But do not think that you are going to remain unpunished, after having made war with God.'"
,"20":"More than all of them, their mother ought to be admired and remembered. She saw her seven sons die in a single day. But she endured it even with joy for she had put her hope in the Lord."
,"21":"Full of a noble sense of honor, she encouraged each one of them in the language of their fathers. Her woman's heart was moved by manly courage, so she told them:"
,"22":"'I wonder how you were born of me; it was not I who gave you breath and life, nor I who ordered the matter of your body."
,"23":"The Creator of the world who formed man in the beginning and ordered the unfolding of all creation shall in his mercy, give you back breath and life, since you now despise them for love of his laws.'"
,"24":"Antiochus thought that she was making fun of him and suspected that she had insulted him. As the youngest was still alive, the king tried to win him over not only with his words, but even promised to make him rich and happy, if he would abandon the traditions of his fathers. He would make him his Friend and appoint him to a high position in the kingdom."
,"25":"But as the young man did not pay him any attention, the king ordered the mother to be brought in. He urged her to advise her son in order to save his life."
,"26":"After being asked twice by the king, she agreed to persuade her son."
,"27":"She bent over him and fooled the cruel tyrant by saying in her ancestral language: 'My son, have pity on me. For nine months, I carried you in my womb and suckled you for three years; I raised you up and educated you until this day. "
,"28":"I ask you now, my son, that when you see the heavens, the earth and all that is in it, you know that God made all this from nothing, and the human race as well."
,"29":"Do not fear these executioners, but make yourself worthy of your brothers - accept death that you may again meet your brothers in the time of mercy.'"
,"30":"When she finished speaking, the young man said, 'What are you waiting for? I do not obey the king's order but the precepts of the Law given by Moses to our fathers."
,"31":"And you who have devised such tortures against the Hebrews, shall not escape the hands of God."
,"32":"Know that we perish because of our sins."
,"33":"Our living Lord punishes and corrects us for a short time because he is angry with us, but he shall again be reconciled with his servants."
,"34":"And you, the most wretched and impious man, do not be proud or be carried away by your vain hopes. Do not raise your hand against the sons of Heaven,"
,"35":"for you have not yet escaped the judgment of the almighty God, who sees everything."
,"36":"Our brothers suffered a short time for the sake of eternal life and have already entered into the friendship of God. But you, for your part, shall suffer the punishment you deserve for your arrogance."
,"37":"With my brothers, I give up my body and my soul for the laws of my fathers, calling on God that he may at once have pity on our race, and that by trials and afflictions, you may come to confess that he is the only God."
,"38":"Through me and my brothers, may the wrath of the Almighty which has justly fallen on the whole of our race come to an end.'"
,"39":"The king was even more infuriated at him than at the others because of his mockery and he dealt more cruelly with him."
,"40":"So the youngest also died undefiled, putting his whole trust in God."
,"41":"After all her sons, the mother also died."
,"42":"This is enough to make known what happened regarding the pagan sacrifices and the tortures beyond all imagination."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Meanwhile, Judas, also called Maccabeus, and his companions, would enter secretly into the villages, call their relatives, summon those who had remained faithful to Judaism, and finally they assembled about six thousand men."
,"2":"They prayed to the Lord to turn his countenance on his people oppressed on all sides, to take pity on the Sanctuary profaned by impious men,"
,"3":"to have compassion on the city - destroyed and on the point of being leveled - to listen to the cry of the blood reaching out to him;"
,"4":"and they asked that he not forget the unjust killing of innocent children and show his indignation against those who had insulted his Name."
,"5":"The Lord's anger turned into compassion, and as soon as Maccabeus had organized his troops, they became invincible against the pagans. Judas generally took advantage of the night for his military campaigns. "
,"6":"So he attacked them by surprise, set cities and villages on fire, captured strategic positions, and put to flight many of the enemies."
,"7":"And people everywhere talked about him and his bravery."
,"8":"When Philip saw that Judas was making progress little by little and his victories increased from day to day, he wrote to Ptolemy, the military commissioner of Coele-Syria and Phoenicia, to come and help him under the king's service."
,"9":"Ptolemy at once appointed Nicanor, son of Patroclus, one of the king's first Friends, and sent him at the head of some twenty thousand men coming from all nations, with the order to wipe out all the Jews. At his side, he put Gorgias, a general of much experience in matters of war."
,"10":"Nicanor intended to raise two thousand talents by the sale of Jewish slaves in order to pay for the tribute the king owed to the Romans."
,"11":"So he extended an invitation to all the coastal cities to come and buy slaves for a talent, without any regard for the punishment of the Almighty that might come upon him."
,"12":"When Judas learned that Nicanor had come with a great army, he told his men about this."
,"13":"So the cowardly and those who had no confidence in divine justice took to flight."
,"14":"Still others sold everything they owned and asked God to deliver from the impious Nicanor those who had been sold even before any battle."
,"15":"They prayed that if the Lord would not save them because of their own merits, that at least out of consideration for the covenant he made with their fathers and for that great venerable Name with which he had blessed his people, he would do so."
,"16":"Maccabeus gathered and reorganized his troops, numbering about six thousand, and exhorted them not to fear the enemy but to fight bravely against their unjust aggressors, despite their great number."
,"17":"He reminded them how those men had profaned the Holy Place, slaughtered the inhabitants of Jerusalem, and removed their traditional institutions."
,"18":"He said to them, 'They come with confidence in their weapons and their boldness, but we trust in the almighty God, who is able to wipe out in one stroke all who invade our land and even the whole world.'"
,"19":"He recounted to them all the occasions when God had come to help their fathers, especially when he wiped out one hundred and eighty-five thousand men under Sennacherib."
,"20":"He also reminded them of what had happened in Babylonia, in the battle against the Galatians. On that day, eight thousand Jews fought side by side with four thousand Macedonians, and as the Macedonians were hard pressed, their Jewish allies alone killed twenty thousand of the enemies' troops with heaven's help and seized a great booty."
,"21":"Judas encouraged them with these words, and made them ready to die for their laws and country; then, he divided the army into four groups."
,"22":"He assigned his brothers Simon, Joseph and Jonathan to each lead one division with fifteen hundred men in each."
,"23":"He ordered that the Sacred Book be read, and he gave them their watchword 'Help from God'; then, he himself led the first battalion, and fell on Nicanor."
,"24":"With the help of the Almighty they slaughtered nine thousand enemies, wounded and crippled many, and put the rest to flight."
,"25":"They seized the money of those who had come to buy the Jews, and pursued them for a good while. But it was nearly evening,"
,"26":"so they had to return because it was the vigil of the sabbath. That is why they stopped pursuing their enemies."
,"27":"They gathered the weapons and the plunder of their enemies, and celebrated the sabbath on that day with praise and thanksgiving to God who had just saved them and had begun to show them his mercy."
,"28":"After the sabbath, they divided part of the booty among those who had been tortured, the widows and the orphans; and they divided the rest among themselves and their men."
,"29":"Having done this, they asked the Merciful Lord during a public prayer to be fully reconciled with his servants."
,"30":"Then, in an encounter with the army of Timotheus and Bacchides, they killed more than twenty thousand men, and took control of the fortified cities. They divided the abundant plunder into equal shares among themselves, those who had been tortured, the orphans, the widows and the aged."
,"31":"They carefully stored in safe places the weapons they had taken from the enemies, and brought the rest of the booty to Jerusalem."
,"32":"They killed the chief guard of Timotheus, an extremely wretched man who had done so much evil against the Jews."
,"33":"Then, as they celebrated their victory in Jerusalem, they burned alive those who had burned the temple gates, including Callisthenes who had taken refuge in one small house. So these men paid the price deserved for their impiety."
,"34":"The thrice-as-wretched Nicanor, who had brought thousands of merchants to buy the Jews,"
,"35":"found himself humbled with God's help by those same men he had despised before. Having discarded his splendid robe he fled across the country as a fugitive, and reached Antioch, very much relieved that he had not perished with his army."
,"36":"He who had intended to pay the tribute owed to the Romans by selling the Jews, now affirmed that the Jews were invincible and invulnerable, and that Someone fought for them, provided they were obeying the laws prescribed by him."
}`)
	CurrentBook.AddChapter(9, `{
"1":"By that time, Antiochus had to return without glory from the regions of Persia."
,"2":"When he entered a city called Persepolis, and tried to plunder the temple and seize the city, its inhabitants rebelled and took up arms against him. This people threw Antiochus and his men out. They fled and returned very much humiliated."
,"3":"When Antiochus came to Ecbatana, he was informed of what had happened to the two generals - Nicanor and Timotheus - in Israel."
,"4":"He was infuriated and determined to take revenge on the Jews for the offense he had just received in Persepolis when they forced him to flee. He ordered the chariot driver to hurry up and not to stop until the journey's end. But the judgment of God was coming upon him, for he said in his pride, 'As soon as I arrive in Jerusalem, I shall turn it into a cemetery of the Jews.' "
,"5":"Then the Lord who sees all, the God of Israel, punished him with an incurable sickness of an internal nature."
,"6":"He had barely finished speaking when he felt an unbearable pain in his stomach and began to be afflicted all over his body. This was indeed just for one who had tortured others in the same way with countless new punishments. "
,"7":"But this did not diminish his arrogance. In his rage against the Jews, he gave orders to journey ahead with even more speed. Yet, because his chariot was running very fast, Antiochus fell and his physical condition worsened."
,"8":"Not long before, in his conceit and sense of superiority he thought of giving orders to the sea and measuring the heights of the mountains. Now he lay down and had to be brought on a stretcher, giving to all a clear testimony of the power of God."
,"9":"Worms began to teem in the body of the impious and though he was still alive, his flesh tore off into pieces, leaving him in agonizing pain. The stench of his decay was so intolerable that his whole army shunned him."
,"10":"No one went near him who not long before thought he could touch the stars of heaven with his hand."
,"11":"Only when he was beaten by the divine scourge did he begin to shed his arrogance. His pains grew worse, and he realized this was the punishment of God."
,"12":"He himself could no longer endure his stench. He said, 'It is right to submit to God. Mortal man should not try to be equal with him.'"
,"13":"And the wretch made a vow to the Lord who would no longer take pity on him."
,"14":"He had marched to Jerusalem to level it and turn it into a cemetery. But now he even promised to declare it a free city."
,"15":"Moreover, he who before had refused burial to the Jews and wished to throw them with their children to the wild beasts, now offered to make them equal with the Athenians. He had plundered the temple and profaned the Sacred Place;"
,"16":"but now he promised to decorate it lavishly, to return a great number of the sacred vessels, and to pay for all the expenses of the sacrifices."
,"17":"And he promised to become a Jew and to proclaim in all the inhabited countries the power of God."
,"18":"His pains however did not diminish, for the just judgment of God had come upon him. He lost hope of recovery and wrote to the Jews this letter of supplication,"
,"19":"'To the honorable Jews, our citizens, good health, prosperity and all good things from the king and general, Antiochus."
,"20":"If you and your children are well and your wishes are fulfilled, we give thanks to Heaven, for we remember your token of affection and kindness."
,"21":"On my return from Persia, I became gravely ill, and because of this, I thought it necessary to be concerned for the common security of all of you."
,"22":"I do not despair of my condition, and even have great hope of recovering from this illness."
,"23":"But I thought of how my father would designate his successor whenever he set out for any military expedition into the uplands,"
,"24":"so that his subjects would not be upset if anything unexpected should happen or any misfortune should befall him. Everyone would know who is in power."
,"25":"I am aware that the kings of all the neighboring countries around are watching the turn of events and waiting for an opportune time. Therefore, I have designated my son, Antiochus, as king. I already presented and commended him to most of you, when I set out for the northern regions. And now I communicate to him this letter I am sending you."
,"26":"I ask you, then, to take into account the favors each and everyone of you has received from me and maintain the same kindness toward me and my son."
,"27":"I am sure that following my own policies of moderation and humanity, he shall live in good accord with you.'"
,"28":"In this way that blasphemer and murderer ended, suffering the terrible torments he had inflicted on others. He died miserably in the mountains of a foreign land."
,"29":"His companion, Philip, brought his body and then withdrew to Egypt to the court of Ptolemy Philometor, because he feared the son of Antiochus."
}`)
	CurrentBook.AddChapter(10, `{
"1":"With God's help Maccabeus and his men seized the Temple and the city."
,"2":"They destroyed the altars built by the foreigners in the public squares, as well as the sacred enclosures."
,"3":"After purifying the Temple, they built a new altar. They kindled fire from flint and for the first time in two years offered sacrifices. Once again, there were incense, lamps, and the bread of presence."
,"4":"Having done all this they threw themselves flat on the ground and asked the Lord not to send them such calamities anymore. But if they should sin again, they asked that he would correct them with gentleness and not hand them over again into the hands of blasphemous and ferocious foreigners."
,"5":"The purification of the Temple took place on the same date on which the foreigners had profaned it, that is, on the twenty-fifth of the month of Chislev."
,"6":"For eight days they celebrated the feast with rejoicing, in the same way that they celebrated the Feast of the Tabernacles remembering how, not long before on that same date, they were dwelling in the mountains and caves like wild animals."
,"7":"Then, carrying leafy branches and palms, they chanted hymns to Him who had brought the cleansing of his own Holy Place to a happy end."
,"8":"They also decided by public vote that this event would be commemorated annually by the whole Jewish nation."
,"9":"This is all that refers to the death of Antiochus, called Epiphanes."
,"10":"We shall now proceed to narrate the events that happened under Antiochus Eupator, son of the impious, and to relate briefly the calamities brought about by the war."
,"11":"In fact, once he inherited the kingdom, he appointed Lysias to be in charge of his affairs and to act as high commissioner for Coele-Syria and Phoenicia."
,"12":"Now Ptolemy, called Macron, was the first governor to do justice to the Jews. He was upset by injustices done against them, so he tried to solve all their problems satisfactorily."
,"13":"But the Friends of King Eupator made use of this to accuse him before the king. They continually called him a traitor, reminding him that he had once abandoned the land of Cyprus, which had been entrusted to him by Philometor, in order to go over to Antiochus Epiphanes. Since he could not discharge his high office with dignity, he was driven to despair and committed suicide by poisoning himself."
,"14":"It was then that Gorgias was appointed military commissioner of those regions, and began to stir up war against the Jews by any means."
,"15":"On the other hand, the Idumeans had strong fortresses and harassed the Jews. Gathering the fugitives from Jerusalem, they managed to prolong the war."
,"16":"The men of Maccabeus, after praying and asking the Lord to come and fight at their side, attacked the fortresses of the Idumeans."
,"17":"They carried on with their assaults and the place fell into their power. They repelled those who fought on the ramparts, slaughtered all who fell into their hands, and killed more than twenty thousand men."
,"18":"At least nine thousand men took refuge in the two towers that were strongly fortified with everything they needed to withstand a prolonged siege."
,"19":"Maccabeus left Simon, Joseph, and also Zaccheus and his men in sufficient numbers to sustain the siege, and went off to where his presence was more needed."
,"20":"Yet the men of Simon were tempted by greed, and let themselves be bought with the silver of those in the towers. So in exchange for sixty thousand pieces of silver, they allowed a number of them to escape."
,"21":"As soon as Maccabeus learned this, he assembled the leaders of the people and accused those men of having sold their brothers for money by letting their enemies escape."
,"22":"He condemned them to death as traitors, and proceeded at once to capture the towers."
,"23":"He killed more than twenty thousand men in those two towers, successfully bringing to an end the undertaking they had begun."
,"24":"Timothy, who had been defeated before by the Jews, gathered together an enormous number of foreign troops and a great number of horses from Asia. He appeared in Judea in order to conquer it by force of arms."
,"25":"Before his attack, the men of Maccabeus sprinkled dust on their heads and put on sackcloth as a means of entreating God."
,"26":"They bowed at the foot of the altar and asked God to treat them well and to be the enemy of their enemies, the adversary of their adversaries, as written in the Law."
,"27":"After praying, they armed themselves and advanced from the city. They stopped when they came close to the enemy."
,"28":"Right at daybreak, they attacked from both sides. One side placed their confidence in their Lord as the pledge of success and victory besides their bravery, while the others were moved by hatred."
,"29":"When the battle was at its height, there appeared from heaven before the enemies, five radiant men riding on horses with golden bridles, who put themselves at the head of the Jews."
,"30":"They surrounded Maccabeus and defended him with their weapons, making him invulnerable. At the same time, they rained arrows and thunderbolts on the enemy, who in turn fell and were dispersed in great disorder, blinded and confused."
,"31":"Twenty thousand five hundred infantrymen and six hundred horsemen died."
,"32":"Timothy took refuge in a heavily guarded fortress called Gezer where Chereas was in command."
,"33":"The forces of Maccabeus gallantly besieged the fortress for four days."
,"34":"Those within were confident in the strength of the fortress, so they hurled insults and curses at the Jews."
,"35":"At daybreak on the fifth day, twenty young men from the troops of Maccabeus, enraged by the blasphemies they had been hearing, bravely stormed the wall and with brutal fury killed everyone who stood before them."
,"36":"Others took advantage of this diversion to climb the walls and set fire to the towers. They made bonfires and burned the blasphemers alive. Others destroyed the gates while the rest of the army entered to occupy the city."
,"37":"They killed Timothy who had hidden in a well, and his brother Chereas, and Apollophanes."
,"38":"When all this was over, they chanted hymns and praises to the Lord who had exalted Israel and had given them victory."
}`)
	CurrentBook.AddChapter(11, `{
"1":"After a while, Lysias, the king's tutor and kinsman, who was head of the government, was much displeased at the turn of events,"
,"2":"and gathered together about eighty thousand men and his entire cavalry. They advanced against the Jews intending to make the city of Jerusalem a Greek colony and"
,"3":"to convert the Temple into a source of revenue, as they had done with other sanctuaries of the pagans, and to put the office of high priest up for sale every year."
,"4":"He took God's power for granted, and went up with his infantry regiments, his horsemen by the thousands, and his eighty elephants."
,"5":"He entered Judea, came near Beth-zur, a strong city some kilometers away from Jerusalem, and besieged it."
,"6":"When the men of Maccabeus learned that Lysias had begun laying siege to their strong cities, they prayed to the Lord together with all the people, with tears and lamentations, that the Lord might send a good angel to save Israel."
,"7":"Maccabeus himself was the first to take arms and exhort the rest to go with him to face the danger and help their brothers and sisters. They set out together, full of enthusiasm."
,"8":"While they were still near Jerusalem, a horseman dressed in white with golden armor appeared and stood at the head of them."
,"9":"So with one voice, everyone blessed the merciful God. They were strengthened and prepared not only to face men in battle but even the most savage beasts and walls of iron."
,"10":"They advanced with the aid of this ally sent from heaven, for the Lord had compassion on them."
,"11":"They charged like lions against the enemy, brought down eleven thousand infantrymen and one thousand six hundred horsemen, and forced the rest to flee."
,"12":"Most of them fled, wounded and disarmed, until Lysias himself fled in disgrace in order to save himself."
,"13":"Lysias, being an intelligent man, reflected on the defeat he had suffered and understood that the Hebrews were invincible because the powerful God fought for them."
,"14":"So he sent a messenger to convince them to accept peace with every kind of just condition. And he even promised to persuade the king to make peace with them, too."
,"15":"Maccabeus, thinking of the common good of all, accepted Lysias' offer of peace. And in fact, the king granted all the demands that Maccabeus had presented to Lysias in writing."
,"16":"Lysias wrote to them as follows: 'From Lysias to the Jewish people, greetings. "
,"17":"John and Absalom, your envoys, have delivered to us your written petitions, asking us to respond."
,"18":"I have set forth before the king everything that needed his attention; and I have granted everything that was within my competence."
,"19":"Therefore, if you maintain your good will toward the State, I will also try in the future to work in your favor."
,"20":"As for the details, I have given orders for your envoys and my own representatives to discuss these with you."
,"21":"May everything go well with you. In the year one hundred and forty-eight, the twenty-fourth day of the month of the Corinthian God.'"
,"22":"The king's letter was as follows: 'King Antiochus greets his brother Lysias."
,"23":"From the day we succeeded to the throne of our father, who has gone to the dwelling place of the gods, it has been our desire that all our subjects live undisturbed so that everyone may dedicate himself to his own work."
,"24":"Learning that the Jews do not wish to adopt Greek customs, as it was the will of my father, but prefer their own way of life and ask that they be allowed to live according to their laws,"
,"25":"and since it is our desire that this nation live in peace, we have decreed that the Temple be restored to them and that they be allowed to live according to the laws and customs of their ancestors."
,"26":"You will do well, therefore, to send envoys to conclude a treaty of peace with them. May they come to know our constant aim, so they may be reassured and dedicate themselves with joy to their own occupations.'"
,"27":"This was the king's letter to the Jewish people: 'King Antiochus to the Council of Elders and to the Jewish people: greetings!"
,"28":"If you enjoy good health, we are happy for you; we ourselves are also well."
,"29":"Menelaus has told us that you wish to return to your homes and occupations."
,"30":"Therefore, I have issued a decree of amnesty for all who would go home before the thirtieth of the month of Xanthicus."
,"31":"The Jews from now on may live according to their own customs concerning their food, and be governed by their own laws as before. None of them is to be molested in any way for anything done involuntarily."
,"32":"I have ordered Menelaus to reassure you of all this."
,"33":"I wish you good health. In the year one hundred and forty-eight, the fifteenth day of the month of Xanthicus.'"
,"34":"The Romans also sent them a letter which read as follows: 'Quintus Memmius and Titus Manius, ambassadors of the Romans, send their greetings to the Jewish people."
,"35":"Everything that Lysias, the king's kinsman, has granted you, we also approve."
,"36":"As for the matters about which Lysias considered it necessary to inform the king and take up with him, we ask that you study them carefully and send someone to us at once, so we can explain everything to the king to your advantage, for we are now leaving for Antioch."
,"37":"Lose no time, therefore, in sending someone to us, that we may know your plans."
,"38":"We wish you good health. In the fifteenth of the month of Xanthicus in the year one hundred and forty-eight.'"
}`)
	CurrentBook.AddChapter(12, `{
"1":"After these agreements had been concluded, Lysias returned to the king and the Jews began to return to their fields."
,"2":"But the commanders of the different regions, Timotheus and Apollonius, the son of Genneus, as well as Hieronymus and Domophenes, and Nicanor, the leader of the Cypriots, would not let them live in peace and quiet."
,"3":"Moreover, the inhabitants of Joppa committed this grave crime. They invited the Jews with their wives and children to a cruise on some boats they had prepared, as if they did not have any hostility."
,"4":"This was decided by the city authorities and the Jews accepted in order to show their desire to live with them in peace and without any suspicion at all. But once out in the open sea, the men of Joppa pushed them into the water and at least two hundred died."
,"5":"When Judas Maccabeus was informed of this cruelty against his countrymen, he informed his men."
,"6":"After calling upon God, the just judge, he set out against the murderers of his brothers and sisters. He set fire to the harbor by night, burned the ships and put to the sword those who had taken refuge there."
,"7":"But, as the gates were closed, he could not enter the city, so he withdrew, intending to come back to wipe out all the inhabitants of Joppa."
,"8":"Meanwhile, he learned that the inhabitants of Jamnia wanted to deal in the same way with the Jews who lived there."
,"9":"He also attacked the people of Jamnia by night, and set the harbor and ships on fire. The blaze was so great that the glow could be seen even from Jerusalem, some fifty kilometers away."
,"10":"From there, they set out and marched against Timotheus, but when they had marched for about two kilometers, five thousand Arabs supported by five hundred horses, attacked them."
,"11":"A bloody battle took place, and the men of Judas emerged victorious with the help of God. The defeated Arabs sued for peace, and promised to give them livestock, and to help them in the future."
,"12":"Judas, convinced that they could indeed be useful to them, made peace with them. Then the Arabs withdrew to their camps."
,"13":"Judas attacked a city strongly fortified with ditches and walls. The city was called Caspin. People of every race lived there."
,"14":"The besieged, confident in the strength of their walls and because they had their storehouses full of provisions, underestimated the men of Judas and behaved most insolently toward them. They also shouted insults, blasphemies and sacrilegious words at them."
,"15":"The men of Judas called on the great Sovereign of the world who had demolished the walls of Jericho without engines of war during the time of Joshua, and then rushed furiously upon the walls."
,"16":"God willed that they should take possession of the city, and they carried out an incredible slaughter: the nearby lake, five hundred meters wide, seemed filled with blood."
,"17":"After marching for one hundred and fifty kilometers, they arrived in Charax, where the Jews were known as Tubians."
,"18":"They did not find Timotheus there, for he had gone without having achieved anything; but he had left a strong garrison in one place."
,"19":"Dositheus and Sosipater, leaders of the troops of Maccabeus, marched against them and destroyed the garrison of more than ten thousand men left behind by Timotheus."
,"20":"Maccabeus then organized his army, set these two as their commanders, and rushed out against Timotheus who had twenty thousand infantrymen and two thousand five hundred horsemen with him."
,"21":"When Timotheus learned that Judas was approaching, he sent the women and children away with a good deal of the baggage to a fortress called Carnaim which was in an impregnable place and difficult to reach because of the narrow approaches surrounding it."
,"22":"At the sight of the first battalion of Judas, terror and panic seized their enemies because of an apparition of Him who sees all things. They fled in all directions, so that they were dragged on the ground by their own companions and wounded by their own swords."
,"23":"Judas pursued Timotheus in fury and ardor, putting to the sword those wicked men and killing about thirty thousand of them."
,"24":"Timotheus himself fell into the hands of Dositheus' and Sosipater's troops. He very cunningly pleaded with them to let him go, for, as he said, he had the parents and brothers of most of the Jews in his power and they would surely be put to death if he were to be killed."
,"25":"When he had convinced them by the strength of his words, they let him go in order to save their brothers."
,"26":"Then Judas left for Carnaim and Atargateion, and killed twenty-five thousand men there."
,"27":"After defeating and destroying these enemies, he led an expedition against the walled city of Ephron, where Lysias had taken refuge with people of every race. Strong young men were stationed outside the walls and they fought bravely. And there were stores of war engines and missiles inside."
,"28":"After calling on the Lord almighty to crush the forces of the enemy, the Jews seized the city and killed more than twenty-five thousand of the people inside."
,"29":"Moving off from there, they went to Scythopolis, a city one hundred and twenty kilometers from Jerusalem."
,"30":"But as the Jews who lived there assured Judas that the inhabitants of that city had always treated them well and had received them favorably in times of persecution,"
,"31":"Judas and his men thanked these people and asked them to extend the same kindness to his race in the future. Then they returned to Jerusalem, since the feast of Weeks of Pentecost was approaching."
,"32":"After the feast and Pentecost, they marched against Gorgias who was the governor of Idumea."
,"33":"Gorgias came out with three thousand infantrymen and four thousand horsemen to meet him."
,"34":"The battle began and some fell in the ranks of the Jews."
,"35":"Dositheus, a horseman from Bachenor's troops, a very valiant man, grasped Gorgias by the cloak, and forcibly dragged him along, wanting to take that criminal alive. But a Thracian horseman rushed upon Dositheus and slashed his shoulder, so that Gorgias was able to flee to Marisa."
,"36":"Judas saw that the men of Esdrias were exhausted because they had been fighting for a long time. He, therefore, prayed to the Lord to show himself as their ally and lead them in battle."
,"37":"Then, he chanted a battle hymn in the language of their fathers, charged against the troops of Gorgias all of a sudden, and defeated them."
,"38":"Judas reorganized his army, and then went to the city of Adullam. Since it was the week's end, they purified themselves and celebrated the sabbath there."
,"39":"The next day the companions of Judas went to take away the bodies of the dead (it was urgent to do it) and buried them with their relatives in the tombs of their fathers."
,"40":"They found under the tunic of each of the dead men objects consecrated to the idols of Jamnia, which the Law forbade the Jews to wear. So it became clear to everyone why these men had died."
,"41":"Everyone blessed the intervention of the Lord, the just Judge who brings to light the most secret deeds;"
,"42":"and they prayed to the Lord to completely pardon the sin of their dead companions. The valiant Judas urged his men to shun such sin in the future, for they had just seen with their own eyes what had happened to those who sinned."
,"43":"He took up a collection among his soldiers which amounted to two thousand pieces of silver and sent it to Jerusalem to be offered there as a sacrifice for sin. They did all this very well and rightly inspired by their belief in the resurrection of the dead. "
,"44":"If they did not believe that their fallen companions would rise again, then it would have been a useless and foolish thing to pray for them."
,"45":"But they firmly believed in a splendid reward for those who died as believers; therefore, their concern was holy and in keeping with faith."
,"46":"This was the reason why Judas had this sacrifice offered for the dead - so that the dead might be pardoned for their sin."
}`)
	CurrentBook.AddChapter(13, `{
"1":"In the year one hundred and fortynine, the men of Judas learned that Antiochus Eupator had come against Judea with countless troops,"
,"2":"together with Lysias, his tutor who was head of the government. Each of them was in command of a Greek army of one hundred and ten thousand infantrymen, five thousand and three hundred horsemen, twenty-two elephants and about three hundred chariots of war with scythes."
,"3":"Menelaus joined them, and incited Antiochus with every evil intent since he was not seeking the freedom of his country but only hoping that he would be restored to the office of High Priest."
,"4":"But the King of kings roused the anger of Antiochus against that wicked man, when Lysias made the king realize that Menelaus was the cause of all the evils. So the king ordered that Menelaus be taken to Berea and executed according to the custom of the place. "
,"5":"There is a tower in that place, twenty-five meters high, full of burning ashes, provided with a revolving device on top, which sloped on all sides into ashes."
,"6":"Whoever robbed any sacred thing or committed any other notorious crime was brought up to the tower, and then, pushed into the ashes."
,"7":"In this way, Menelaus died without even a burial."
,"8":"This was indeed a just punishment for him who had committed so many offenses against the Altar whose fire and ashes were sacred; and so, he met his death in ashes."
,"9":"The king came with a heart full of evil designs, prepared to be more cruel to the Jews, than his father had been."
,"10":"When Judas learned of this, he ordered his army to call on God day and night, so that as God had done in other circumstances, he would now also help those"
,"11":"who were in danger of be-ing deprived of their Law, their country and their temple. God could not let his people, who had hardly begun to breathe freely, fall once again into the hands of blasphemous pagans."
,"12":"Once all the people had carried out the order to pray to the merciful Lord with lamentations, fasting and prayer for three consecutive days, Judas encouraged them and commanded them to stand ready."
,"13":"After summoning the Elders in private, he determined to leave with his men for a decisive attempt with the help of God, before the king's army could invade Judea and take control of Jerusalem."
,"14":"Judas entrusted the decision to the Creator of the world, and encouraged his men to fight heroically to the death for the Law, the Temple, the city, the country and the institutions. So he left with his army and encamped near Modein."
,"15":"He gave his men this watchword: 'God's victory.' With the most capable young men of his army he attacked by night the tent of the king, putting to the sword about two thousand men, the strongest elephant and its rider."
,"16":"They caused fear and confusion in the camp and then withdrew in complete success."
,"17":"All this happened just as day was dawning, for God's help protected them."
,"18":"When the king saw the daring of the Jews, he tried to take control of their fortresses by using tricks."
,"19":"He advanced against Beth-zur, a city strongly defended by the Jews; he attacked it but was repelled and defeated."
,"20":"Judas supplied the defenders of the city with everything they needed."
,"21":"Rhodocus, one of Judas' men, gave secret information to the enemies. He was hunted, captured and executed."
,"22":"The king again kept in contact with the defenders of Beth-zur, made peace with them and withdrew."
,"23":"He attacked the troops of Judas but was defeated. When he was informed that Philip, whom he had left in Antioch as head of the government, had revolted, he was dismayed. He sought peace with the Jews and had to accept and swear to observe their just petitions; he became reconciled with them, offered sacrifices, honored the Temple and showed generosity to the Holy Place."
,"24":"The king took leave of Maccabeus and named Hegemonides as governor from Ptolemais to the land of the Gerarrites."
,"25":"When he came to Ptolemais, he found the inhabitants were indignant over that treaty; they were so angry they wanted to annul its terms."
,"26":"But Lysias came up to the tribunal to defend what had been decided; he convinced and appeased them, winning their goodwill before he set out for Antioch. This was what happened with the king's expedition and retreat."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Three years later, Judas and his men were informed that Demetrius, son of Seleucus, had landed in Tripoli with a fleet and a powerful army,"
,"2":"and had taken control of the kingdom, killing Antiochus and his tutor Lysias."
,"3":"A certain Alcimus, who had been High Priest before, but was disgraced during the time of the rebellion, realized that there was no way for him to be restored to the ministry at the sacred altar."
,"4":"So, he went to King Demetrius in about the year one hundred and fifty-one, and offered him a golden crown, a palm and even some olive branches from the Temple as usual. On that day, he did not ask for anything."
,"5":"But he found a proper occasion for his evil designs when he was called to a meeting of the king's council. When he was asked with what disposition and spirit the Jews were to be confronted, he answered,"
,"6":"'There exists a party called Hasideans among the Jews, headed by Judas Maccabeus, that keeps up war and rebellion, and hinders the reestablishment of peace and order in the land."
,"7":"Because of them, I have been deprived of the dignity of my ancestors, that is, the office of High Priest. And I came here,"
,"8":"concerned for the king's interests above everything else, but for my compatriots as well, since the fanaticism of those men has plunged our people into great misery."
,"9":"O King, look upon our land and nation which is hard pressed on all sides, with that same kindness you have for all."
,"10":"For as long as Judas lives, it is impossible for the State to find peace.'"
,"11":"When Alcimus had said this, the rest of the King's Friends who were hostile to Judas, quickly incited Demetrius against him."
,"12":"And the king immediately chose Nicanor, who commanded the squadron of elephants, and appointed him military commissioner of Judea"
,"13":"with orders to kill Judas, disperse his men and restore Alcimus as priest of the great Temple."
,"14":"The pagans who had earlier escaped from Judea for fear of Judas, flocked in great number to Nicanor, thinking that the misfortunes and defeat of the Jews would mean victory for them."
,"15":"When the men of Judas learned about the coming of Nicanor and the invasion of Nicanor was coming and about the invasion of the pagans, they sprinkled dust upon their heads, and called on Him who had established his people forever, and had each time protected his people by wonderful manifestations."
,"16":"Then, at their leader's command they set out to march, and the battle began near Dessau."
,"17":"Simon, the brother of Judas, had attacked Nicanor, but his men were suddenly confounded by the enemies, suffering a slight setback."
,"18":"However, as Nicanor had heard of the courage of Judas and his men and of how bravely they fought for their country, he feared resolving the situation by bloodshed."
,"19":"So, he sent Posidonius, Theodotus and Mattathias to arrange for peace."
,"20":"After a thorough consideration of the conditions, he communicated this to his troops and it seemed that they were unanimous about it. The treaty of peace was accepted."
,"21":"So they set the date on which the leaders should meet. A chariot came forward from each side and they prepared seats of honor."
,"22":"Judas positioned armed men in strategic places, in case of sudden treachery on the part of the enemy. But their meeting went well."
,"23":"Nicanor spent some time in Jerusalem without doing any harm, and even dismissed the people that had gathered around him."
,"24":"He always had Judas with him, for he had a high regard for him."
,"25":"He advised him to get married and have children, so Judas got married and enjoyed a peaceful life."
,"26":"When Alcimus saw the good understanding between the two, he secured a copy of the signed accord and went to Demetrius, accusing Nicanor of acting against the interests of the State, inasmuch as he had appointed Judas, the enemy of the kingdom, as his minister."
,"27":"The king was infuriated and stirred up by the slanders of that wicked man. He wrote Nicanor telling him how indignant he was over the treaty and ordering him to put Maccabeus in chains and to send him to Antioch at once."
,"28":"Nicanor was dismayed to learn that he was asked to break the treaty with Judas who had done nothing wrong."
,"29":"But he could not go against the king's orders, so he sought an occasion to carry this out by deceit."
,"30":"Maccabeus noticed that Nicanor had become more reserved towards him and more unpleasant in their usual meetings, so he understood that this did not promise well. He began to gather some of his men, but did not make this known to Nicanor."
,"31":"When the latter became aware that Judas had escaped without being disloyal, he appeared in the holy Temple while the priests were offering the ritual sacrifices, and demanded that they hand Judas over to him."
,"32":"The priests declared on oath that they did not know where he was to be found."
,"33":"Then, he stretched out his hand to the sanctuary and made this oath: 'If you do not hand Judas over to me in chains, I shall raze this place consecrated to God, destroy the altar, and right here build a splendid temple to Dionysus.'"
,"34":"And after saying this, he left. The priests stretched forth their hands to heaven and called on him who had unceasingly defended our nation, saying "
,"35":"'O Lord of the universe, though you do not need anything, it has pleased you to put among us this temple as your dwelling place."
,"36":"So now, keep undefiled forever this house that has just been purified.'"
,"37":"Razis, one of the elders of Jerusalem, was denounced to Nicanor as being a very patriotic man, well known as 'father of the Jews' because of his kindness."
,"38":"In the time before the rebellion, he had been accused of Judaism and with much enthusiasm he had totally given himself to the defense of Judaism."
,"39":"Now then, Nicanor, wishing to show his hatred towards the Jews, ordered more than five hundred soldiers to take him prisoner."
,"40":"He thought that by putting him in prison, he would deal a great blow to the Jews."
,"41":"When the soldiers were about to capture the tower and were breaking the door of the courtyard (they had already ordered that fire be brought to burn the door), Razis, surrounded on all sides, struck his belly with his own sword."
,"42":"He preferred to die bravely rather than fall into the hands of foreigners and suffer insults unworthy of his noble birth."
,"43":"But when he fell upon his sword, he did not hit exactly, so when he saw the troops were now rushing in through the gates, he gathered enough strength to climb to the top of the tower, and manfully threw himself down upon the soldiers."
,"44":"But they quickly withdrew, so he fell into an empty space."
,"45":"Still alive, and aflame with valor, he stood up in spite of the blood that gushed forth and the wounds he had, and came running through the soldiers."
,"46":"He stood on a steep rock and there, with his blood almost completely drained from him, he took hold of his intestines with both hands and hurled them at the crowd. Then calling upon the name of the Lord of life and spirit to give them back to him again one day, he left this life."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Nicanor was informed that the men of Judas were in the neighboring villages of Samaria, so he prepared to safely attack them on the day of the sabbath."
,"2":"The Jews, who were forced to accompany him, said to him, 'Do not destroy them so savagely and barbarously, but show respect for the day of the sabbath, for He who sees all has honored this day and sanctified it.'"
,"3":"But the wretch asked if there was indeed a sovereign in heaven who had commanded that the sabbath be holy."
,"4":"They answered, 'It is the living God himself, the Sovereign in heaven, who has commanded us to celebrate the seventh day.'"
,"5":"'So I, as sovereign on earth, command you to take up arms and carry out the decrees of the king.' But he could not bring to completion his evil designs."
,"6":"Nicanor was so sure of victory, that he planned to build a monument with the mortal remains of Judas and his men."
,"7":"But Maccabeus, for his part, felt confident and put his trust in God's help."
,"8":"He encouraged his men not to fear the attack of the pagans, and not to forget the times God had come to their help, confident that even now God would give them victory."
,"9":"He roused their spirit with the words of the Law and the Prophets, reminding them of previous triumphs."
,"10":"Encouraging his men more and more, he finished by showing them the evil of the pagans and how they had betrayed their oath."
,"11":"So he armed them not with the sword or shield but with the certainty that comes from noble words. Then he made them all full of joy by telling them what he saw in a true dream."
,"12":"He had seen Onias, the former High Priest, a courteous, good man, humble in his ways, distinguished in his words and exemplary in his irreproachable conduct since childhood. With arms outstretched, Onias prayed for the whole Jewish community."
,"13":"Then, a gray-haired and honorable man appeared, praying in the same way, and characterized by dignity and majesty."
,"14":"Then Onias, the High Priest, said to Judas, 'This is he who loves your brothers, he who prays without ceasing for the Jewish people and for the Holy City. He is Jeremiah, the prophet of God.'"
,"15":"And Jeremiah had stretched out his right hand giving a golden sword to Judas, as he said,"
,"16":"'Receive this sword as a gift from God, with which you shall destroy your enemies.'"
,"17":"Encouraged by these beautiful words of Judas, which were able to encourage righteous people and strengthen young souls, they determined not to set up camp with defenses. They decided instead to rush out bravely and take the offensive to settle the matter by fighting bravely, for the Holy City Jerusalem, their religion and the Temple were in danger."
,"18":"They considered of secondary importance any concern for their wives, children and friends; because they feared above all for the Temple consecrated to God."
,"19":"Regarding those who had stayed in the city, their anxiety was by no means little, since they were worried about the battle that was about to begin in the camp."
,"20":"Everyone waited for the imminent outcome as the enemies attacked. They had set their troops in place, led the elephants to strategic positions and had the cavalry in the wings."
,"21":"Then Maccabeus could see this multitude with their weapons of every kind and the ferocious elephants. He stretched forth his hands to heaven and called on the Lord who works marvels, for he knew that God gives victory to those who deserve it, and this does not depend on weapons, but on the will of God."
,"22":"So Judas said in prayer, 'O Lord, you sent your angel in the days of Hezekiah, the king of Judah, and he wiped out one hundred and eighty-five thousand men of the army of Sennacherib."
,"23":"So now, O Lord of Heaven, send your good angel, before us too, to fill our enemies with fear and terror."
,"24":"Show your power and let your arm strike those who insult you and who come to destroy your holy people.' With this, he ended his prayer."
,"25":"Meanwhile, Nicanor and his men advanced amid blasts of trumpets and shouts of war."
,"26":"Judas and his men, for their part, entered into battle with supplication and prayer."
,"27":"As they fought with their hands, their hearts prayed to God. And being so magnificently strengthened by the manifest presence of God, they killed no less than thirty-five thousand enemies."
,"28":"When the battle ended, and they returned rejoicing, they found Nicanor dead, lying on the ground with all his armor."
,"29":"Then they blessed God in their ancestral language amidst shouts and clamors."
,"30":"Judas, who had once fully consecrated himself to the welfare of his fellow residents and had never wavered in his affection for them, ordered that Nicanor's head and arms up to the shoulders be cut off and brought to Jerusalem."
,"31":"There he summoned his compatriots and priests. He stood before the altar and ordered them to send for those in the Citadel."
,"32":"He showed them the head of that wretched, Nicanor, and the hand which that wicked man had raised in pride above the house of God."
,"33":"He ordered that Nicanor's tongue be cut into pieces and given to the birds, and the hand be hung in front of the sanctuary as punishment for his arrogance."
,"34":"Then they blessed Heaven saying, 'Blessed be he who did not let his Sacred House be defiled!'"
,"35":"Finally, Judas ordered that Nicanor's head be hung in the Citadel as a sign of God's help."
,"36":"By popular agreement, they decided that on the thirteenth day of the twelfth month called Adar in Aramaic, the vespers of the day of Mordecai would be commemorated as a festival day."
,"37":"These were the events during the time of Nicanor. As from those days the city remained under the power of the Hebrews, I end my account here."
,"38":"If the narration has been good and well composed, that is indeed what I desired; but if it has been ordinary and indifferent, it is what I was able to do."
,"39":"The readers' pleasure depends on how the account was arranged, just as it is with one who drinks. It does not do any good when one drinks only pure wine or water but wine mixed with water is tasty and delightful. Let this, then, be my last word."
}`)

}
func EN_CCB_LoadVH2PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Solomon, son of David, took firm control of the Kingdom of Israel. Yahweh, his God, was with him and exalted him greatly."
,"2":"Solomon then spoke to all Israel, to commanders of thousands and of hundreds, to the judges, and to all the princes of Israel, the heads of families."
,"3":"Then Solomon, and with him the whole assembly, went to the High place at Gibeon, where God's Tent of Meeting was, which Moses, the servant of God, had made in the wilderness;"
,"4":"David, however, had brought the ark of God from Kiriath-jearim to the place he had prepared for it, having set up a tent for it in Jerusalem."
,"5":"The bronze altar that Bezalel, son of Uri, son of Hur, had made stood there in front of the Holy Tent of Yahweh; Solomon, with the assembly, came to this altar, looking for Yahweh's presence."
,"6":"Solomon went up to the bronze altar that was by the Tent of Meeting, and offered a thousand burnt offerings on it."
,"7":"That night, God appeared to Solomon and said, 'Ask what you would like me to give you.'"
,"8":"Solomon replied to God, 'You showed great kindness to David my father; and you have made me king in his place."
,"9":"Yahweh God, the promise you made to David my father has now been fulfilled, since you have made me king over a people who are so many that they cannot be counted."
,"10":"Therefore now give me wisdom and knowledge to act as leader of this people, for who could govern a people so great as yours?'"
,"11":"God said to Solomon, 'Since that is what you want, you have asked, not for riches, treasure, honor, the lives of your enemies, or even for a long life, but for wisdom and knowledge to govern my people of whom I have made you king;"
,"12":"therefore wisdom and knowledge are granted you. I give you riches too, and treasures, and honor such as none of the kings had that were before you, nor shall any have that come after you.'"
,"13":"Solomon left the High place and the Tent of Meeting at Gibeon and returned to Jerusalem."
,"14":"Solomon built up a force of chariots and horses; he had one thousand four hundred chariots and twelve thousand horses; these he stationed in the chariot towns and with the king in Jerusalem."
,"15":"During his reign, silver and gold became as common in Jerusalem as stone, while cedar wood was as plentiful as the ordinary sycamore trees in the foothills of Judah."
,"16":"Solomon's horses were imported from Cilicia; the king's agents took delivery of them from Cilicia at a fixed rate."
,"17":"They imported chariots from Egypt for 600 pieces of silver each, and horses for 150 each. These men acted in the same way for all the kings of the Hittites and the kings of Aram."
,"18":"Solomon decided to build a house for Yahweh's Name and a palace for himself."
}`)
	CurrentBook.AddChapter(2, `{
"1":"He put 70,000 men to work transporting materials, 80,000 to quarry in the hill country, and 3,600 supervisors in charge of them."
,"2":"Solomon then sent this message to Huram king of Tyre, 'Deal with me as you dealt with my father David when you sent him cedars to build a house to live in."
,"3":"I am now building a house to honor Yahweh, my God, to acknowledge his holiness by burning incense of scented spices in his presence, by the loaves that are perpetually set out, by offerings morning and evening, on the sabbath, New Moon, and the solemn festivals of Yahweh our God - and this forever in Israel."
,"4":"The house I am building will be large, for our God is greater than all gods."
,"5":"Yet no one can really build a temple for God because the heavens and the heaven cannot contain him. And I cannot build him a house for anything more than to burn incense in his presence."
,"6":"So send me a man skilled in working with gold, silver, bronze, iron, scarlet, crimson, violet, and the art of engraving too; he is to work with the skilled men whom my father David provided here in Judah and Jerusalem."
,"7":"From Lebanon send me cedar wood, juniper and algummim, since I know your servants are experts in felling the trees of Lebanon. My servants will work with yours."
,"8":"They will prepare wood in bulk for me, since the house I wish to build is to be of astounding size."
,"9":"For the woodmen who are to fell the trees I assign twenty thousand kors of grain, twenty thousand kors of barley, twenty thousand baths of wine, and twenty thousand baths of oil - this is for the maintenance of your servants.'"
,"10":"In a letter sent to King Solomon, Huram king of Tyre replied, 'Because Yahweh loves his people he has made you king."
,"11":"Blessed be Yahweh, the God of Israel, who has made the heavens and the earth, and given King David a wise son, full of understanding and skill, who is going to build a house for Yahweh and a palace for himself and his court."
,"12":"And I am also sending you a skilled craftsman, Huram-abi,"
,"13":"the son of a Danite woman by a Tyrian father. He is skilled in the use of gold, silver, bronze, iron, stone, wood, scarlet, violet, fine linen, crimson, in engraving of all kinds, and in the execution of any design suggested to him. Let him be put to work with your craftsmen and those of my lord David, your father."
,"14":"So now let my lord send his servants the wheat, barley, oil and wine, as already suggested."
,"15":"For our part, we will cut down all the cedar trees you need from Lebanon, and bring them to you in rafts by sea to Joppa, and you will transport them to Jerusalem.'"
,"16":"Solomon took a count of all the foreigners living in the land of Israel, following the census that David his father had taken; it was found there were a hundred and fifty-three thousand six hundred."
,"17":"He impressed seventy thousand of these for carrying loads, eighty thousand for quarrying in the hill country, and three thousand six hundred as overseers to make sure the people worked."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Solomon then began to build Yahweh's House in Jerusalem on Mount Moriah where David his father had a vision. It was the place prepared by David, the threshing floor of Ornan the Jebusite."
,"2":"Solomon began building in the second month of the fourth year of his reign, on the second day."
,"3":"The house which Solomon built was 90 feet long and 30 feet high."
,"4":"The Hall in front of the Great Room of the Temple was 30 cubits long across the width of the house, and its height was 180 feet. He plated it on the inside with pure gold."
,"5":"The Great Room he faced with juniper which he plated with pure gold, and on it set palms and festoons."
,"6":"He adorned the building with precious stones of great beauty; the gold was gold from Parvaim,"
,"7":"and with this he faced the house, the beams, thresholds, walls and doors; on the walls he carved cherubs."
,"8":"He then built the Holy of Holies; its length, across the width of the Great Room, was 30 feet, and its width 30 feet. He plated it with 25 tons of fine gold;"
,"9":"the gold nails weighed 20 ounces. He also plated the upper rooms with gold."
,"10":"In the Holy of Holies he made two cherubs of wrought metal work and plated them with gold."
,"11":"The total span of the cherubs' wings was 30 feet, each being 7 1/2 feet long, with one wing touching the wall of the room, while the other touched that of the other cherub."
,"12":"One wing of a cherub, 7 1/2 feet long, touched the wall of the apartment; the second, 7 1/2 feet long, touched the wing of the other cherub."
,"13":"The spread of these cherubs' wings was 30 feet. They stood on their feet, facing the Hall."
,"14":"He made the Veil of violet, scarlet, crimson and fine linen; he worked cherubs on it."
,"15":"In front of the Great room he made two pillars 52 feet high, and on the top of each a capital measuring 7 feet."
,"16":"He set festoons like in the Holy of holies, at the tops of the pillars, and a hundred pomegranates which he placed on the festoons."
,"17":"He set up the pillars in front of the house, one on the right, the other on the left; the one on the right he called Jachin, the one on the left Boaz."
}`)
	CurrentBook.AddChapter(4, `{
"1":"He made an altar of bronze, 30 feet long, 30 feet wide and ten high."
,"2":"He made the Sea of cast metal, 15 feet from rim to rim, circular in shape and 7 feet high; a cord 44 feet long gave the measurement of its girth."
,"3":"Under it and completely encircling it were pomegranates; they went around the Sea over a length of 44 feet; the pomegranates were in two rows, of one and the same casting with the rest."
,"4":"It rested on twelve oxen, three facing north, three facing west, three facing south, three facing east; on these, their hindquarters all turned inward, stood the Sea."
,"5":"It was a hand's breadth in thickness, and its rim was shaped like the rim of a cup, like a flower. It could hold 15,000 gallons of water."
,"6":"He made ten basins, arranging five on the right side, five on the left, for washing the victim for the burnt offering which was purified there; but the Sea was for the priests to wash in."
,"7":"He made the ten golden lampstands in the way prescribed and placed them in the Great room, five on the right and five on the left."
,"8":"He made a hundred golden sprinkling bowls."
,"9":"He made the court of the priests and the great court with its gates and plated the gates with bronze."
,"10":"He placed the Sea some distance from the right-hand side, to the southeast."
,"11":"Huram also made the pots, the shovels and the bowls. Thus he completed the work he had to do for King Solomon in the house of God: "
,"12":"the two pillars; the two moldings of the capitals surmounting the pillars; the two sets of filigree to cover the two moldings of the capitals surmounting the pillars;"
,"13":"the four hundred pomegranates for the two sets of filigree, with the pomegranates of each filigree in two rows;"
,"14":"the ten stands and the ten basins on the stands;"
,"15":"the Sea and the twelve oxen beneath it;"
,"16":"the pots, the shovels, the forks, and all their accessories made by Huram-abi of burnished bronze for King Solomon, for Yahweh's House."
,"17":"The king made them by the process of sand casting, near the Jordan between Succoth and Zeredah."
,"18":"Solomon made all these articles in such quantities, that the weight of bronze could not be reckoned."
,"19":"Solomon placed all the furnishings he had made in the house of God: the golden altar and the tables for the loaves of offering;"
,"20":"the lampstands of pure gold with their lamps to burn, as prescribed, before the sanctuary, of pure gold;"
,"21":"the floral work, the lamps, the extinguishers, of gold (and it was pure gold);"
,"22":"the knives, the sprinkling bowls, incense boats, of fine gold; the door of the Temple, the inner doors (for the Holy of Holies) and the Temple doors (for the Hekal), of gold."
}`)
	CurrentBook.AddChapter(5, `{
"1":"So all the work that Solomon did for Yahweh's House was completed, and Solomon brought the dedicated offerings of his father David, the silver and the gold and the vessels, and put them in the Temple storerooms."
,"2":"Then Solomon called the leaders of the tribes and clans of Israel together in Jerusalem to bring the ark of the covenant of Yahweh up from the City of David, which is Zion."
,"3":"All the men of Israel assembled around the king in the seventh month, at the time of the feast."
,"4":"All the leaders of Israel came, and the Levites took up the ark"
,"5":"and the Tent of Meeting with all the sacred vessels that were in it; the levitical priests carried them."
,"6":"King Solomon, and all the community of Israel gathered with him in front of the ark, sacrificed sheep and oxen, countless, innumerable."
,"7":"The priests brought the ark of the covenant of Yahweh to its place, in the place, in the sanctuary of the house, that is, in the Holy of Holies, under the cherubs' wings."
,"8":"For there where the ark was placed the cherubs spread out their wings and sheltered the ark and its poles."
,"9":"The poles of the ark were long enough for their ends to be seen from the Holy Place in front of the sanctuary, but not from outside;"
,"10":"they are still there today. There was nothing in the ark except the two stone slabs that Moses had placed in it at Horeb, where Yahweh had made a covenant with the Israelites when they came out of Egypt."
,"11":"Finally, the priests came out of the sanctuary. All the priests were present, for they had purified themselves whatever group they belonged to."
,"12":"All the Levite musicians, Asaph, Heman and Jeduthun with their sons and brothers, were stationed to the east of the altar, robed in fine linen and playing cymbals, harps, and lyres. A hundred and twenty priests accompanied them on the trumpet."
,"13":"All those who played the trumpet, or who sang, united in giving praise and glory to Yahweh. Lifting their voices to the sound of the trumpet and cymbal and instruments of music, they gave praise to Yahweh. 'For he is good, for his love is everlasting.' Just then a cloud filled the sanctuary, the building of Yahweh."
,"14":"Because of the cloud the priests could no longer perform their duties: for the Glory of Yahweh filled the house of God."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Then Solomon said: 'Yahweh has chosen to live in the thick cloud. Yes, I have built you a majestic temple,"
,"2":"a place for you to live in forever.'"
,"3":"Then the king turned and asked God's blessing on the whole assembly of Israel, who were standing there."
,"4":"He said, 'Blessed be Yahweh, the God of Israel, who has spoken through the mouth of David, my father and has now carried out by his hand what he said:"
,"5":"From the day I brought my people out of Egypt until now I did not choose any city in the land of Israel as the place to build a house where my Name would be, and I did not choose anyone to be prince of my people Israel."
,"6":"But now I have chosen Jerusalem as the place where my Name will be, and you, David, to rule my people.'"
,"7":"My father David had set his heart on building a house for the Name of Yahweh, the God of Israel,"
,"8":"but Yahweh said to him, 'You have set your heart on building a temple for my name, and in this you have done well;"
,"9":"and yet, you are not the man to build the house; your son, born of your own body, shall build me a house.'"
,"10":"Yahweh has kept the promise he made: I have succeeded David my father and am seated on the throne of Israel, as Yahweh promised; and now I have built a house for the Name of Yahweh, the God of Israel,"
,"11":"and have placed in it the ark containing the covenant that Yahweh made with the people of Israel.'"
,"12":"Then in the presence of the whole assembly of Israel Solomon stood before the altar of Yahweh and stretched out his hands."
,"13":"Solomon had made a bronze pedestal and had placed it in the middle of the court; it was 7 feet long, 7 feet wide and 7 feet high. Solomon mounted it, and knelt down on it in the presence of the whole assembly of Israel; he stretched out his hands to heaven."
,"14":"and said, 'Yahweh, God of Israel, not in heaven nor on earth is there such a God as you; you are true to your covenant and show graciousness toward your servants when they live in wholehearted obedience to you."
,"15":"You have kept the promise you made to your servant David my father; what you promised with your mouth, today you have carried out by your hand."
,"16":"And now, Yahweh, God of Israel, keep the promise you made your servant David when you said, 'You shall always have someone from your line to rule as king of Israel, if only your sons are careful how they behave, following my Law as you yourself have done.'"
,"17":"So now, God of Israel, let the words come true which you spoke to your servant David my father."
,"18":"Yet will God really live with men and women on the earth? Why, the heavens and their own heavens cannot contain you! How much less this house that I have built!"
,"19":"Listen to the prayer and grant the requests of your servant, Yahweh my God; listen to the cry and to the prayer your servant makes to you."
,"20":"Day and night let your eyes watch over this house, where you have promised that your Name would be."
,"21":"Hear the prayers of your servant and of Israel your people as they pray in this place. From heaven where your dwelling is, hear; and, as you hear, forgive."
,"22":"If anyone sins against his neighbour, and the neighbour calls down a curse on him and makes him swear an oath before your altar in this house,"
,"23":"hear from heaven, and act; decide between your servants: punish the wicked one, bringing his conduct down on his own head; and vindicate the innocent, rewarding him as his innocence deserves."
,"24":"If Israel your people are defeated by the enemy because they have sinned against you, but they return to you and praise your name and humbly pray to you for forgiveness, in this house,"
,"25":"hear from heaven. Forgive the sin of your people Israel, and bring them back to the land you gave to them and to their ancestors."
,"26":"When the heavens are shut and there is no rain because they have sinned against you, if they pray in this place and praise your name, having been humbled by you, and repent of their sin,"
,"27":"hear from heaven and forgive the sin of your servant and of your people Israel. Teach them to do what is right; and send rain on your land which you have given your people as an inheritance."
,"28":"Should there be famine in the land or epidemic or the crops are destroyed by scorching winds or swarms of locusts, should this people's enemies lay siege to one of their cities, if there is any plague or sickness,"
,"29":"if any person, or all Israel your people, should, out of heartfelt sorrow, pray, stretching out his hands toward this house,"
,"30":"hear from heaven where your home is. Forgive, and deal with each as his conduct deserves, for you know each heart - you alone know the hearts of all humankind -"
,"31":"that they may come to you and follow your ways as long as they live in the land you gave to our ancestors."
,"32":"And the foreigner too, not belonging to your people Israel, if he comes from a distant country for the sake of your Name and of your mighty hand and outstretched arm, if he comes and prays in this house,"
,"33":"hear from heaven where your home is, and grant all the foreigner asks, so that all the peoples of the earth may come to know your name and, like your people Israel, revere you, and know that your Name dwells in this house I have built."
,"34":"If your people go out to war against their enemies whatever way you send them, and if they turn toward the city you have chosen and toward the house I have built for your Name and pray to you,"
,"35":"hear from heaven their prayer and give them victory."
,"36":"If they sin against you - for there is no one who does not sin - and you are angry with them and deliver them to the enemy, and they are led away captive to a land far or near,"
,"37":"if in the land of their exile they come to themselves and repent, and in the country of their captivity they pray to you saying, 'We have sinned, we confess how sinful and wicked we have been,'"
,"38":"and if they turn again to you with all their heart and soul in the country of their captivity to which they have been deported, and pray, turning toward the land you gave their ancestors, toward the city you have chosen, and toward the house I have built for your name,"
,"39":"hear from heaven where your home is. Hear their prayer, be merciful to them, and forgive your people the sins they have committed against you."
,"40":"Now, O my God, may your eyes be open and your ears attentive to the prayer offered in this place."
,"41":"And now rise Yahweh God, come to your resting place, you and the ark of your power. Let your priests, Yahweh God, be blessed in all they do, and your faithful people rejoice in prosperity."
,"42":"Yahweh God, do not reject the face of your anointed king and remember David your servant.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"When Solomon had finished his prayer, fire came down from heaven and burned up the sacrifices that had been offered; and the Glory of Yahweh filled the Temple."
,"2":"The priests could not enter the temple of Yahweh's House because the glory of Yahweh filled his house."
,"3":"All the people of Israel, seeing the fire come down and the Glory of God resting on the house, bowed down on the pavement with their faces to the earth; they worshiped and gave praise to Yahweh, 'for he is good, for his love is everlasting.'"
,"4":"Then the king and all the people offered sacrifice before Yahweh."
,"5":"King Solomon offered twenty-two thousand oxen and a hundred and twenty thousand sheep in sacrifice; and so the king and all the people dedicated Yahweh's House."
,"6":"The priests stood in their places, and also the Levites who gave praise to Yahweh on the instruments that David had made to accompany the canticles of Yahweh, 'for his love is everlasting.' They played and sang the hymns of praise that David had composed. By their side were the priests sounding the trumpet, while all Israel stood."
,"7":"Solomon consecrated the inside part of the court that is in front of Yahweh's House; he offered the burnt offering there and the fatty parts of the peace offerings since the bronze altar Solomon had made could not hold the burnt offering, the grain offering and the fatty part."
,"8":"Solomon then celebrated the feast for seven days. Enormous crowds of Israelites gathered together with him from the Pass of Hamath to the border of Egypt."
,"9":"On the eighth day they held a closing celebration, for they had been seven days celebrating the dedication of the altar."
,"10":"On the twenty-third day of the seventh month Solomon dismissed the people who returned to their homes, rejoicing and with happy hearts for the goodness Yahweh had shown to David, to Solomon and to his people Israel."
,"11":"Solomon finished Yahweh's House and the royal palace and successfully concluded all he had set himself to do in both of them."
,"12":"Then Yahweh appeared to Solomon in the night and said, 'I have heard your prayer. I choose this house to be the place where sacrifices are to be offered to me."
,"13":"When I close the skies and there is no rain, when I command the locust to devour the land, when I send an epidemic among my people,"
,"14":"and my people who bear my name humble themselves, and pray and look for me, and turn from their wicked ways then I myself will hear from heaven and forgive their sins and restore their land."
,"15":"From now on, my eyes are open and my ears attentive to the prayer that is offered in this place."
,"16":"From now on, I have chosen and consecrated this house as the place where my name will be forever; my eyes and my heart will be there forever."
,"17":"For your part, if you serve me faithfully as David your father did, if you do all that I order you and keep my statutes and my ordinances,"
,"18":"I will make your royal throne secure, according to the promise I made to David your father when I said: Israel will always be ruled by one of your descendants."
,"19":"But if you turn away from me and forsake the commandments and statutes I have set before you, and go and serve other gods and worship them,"
,"20":"then I will cast the Israelites out from the land I have given them, and I will reject this house that I have consecrated as the place where my Name would be, so that it may be an example for all the nations."
,"21":"All those who pass by this place which is now so exalted, will be astounded; they will whistle and say, 'Why has Yahweh treated this country and this Temple like this?'"
,"22":"And the answer will be, 'Because they abandoned Yahweh, the God of their ancestors, who brought them out of the land of Egypt, and they adopted other gods, which they worshiped and served; that is why he has brought all these disasters on them.''"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Solomon spent twenty years in building Yahweh's House and his own palace."
,"2":"Then he rebuilt the towns that Huram had given him and settled Israelites in them."
,"3":"He went against Hamath of Zobah and conquered it:"
,"4":"he built Tadmor in the wilderness and all the storing towns which he built in Hamath."
,"5":"He rebuilt Upper beth-horon and Lower Beth-horon, fortified towns with walls and gates and bars,"
,"6":"also Baalath and all the storing towns owned by Solomon, all the towns for his chariots and horses, and all it pleased Solomon to build in Jerusalem, in Lebanon and in all the countries subject to him."
,"7":"Solomon employed for forced labor all those who remained of the Hittite, Amorite, Perizzite, Hivite and Jebusite peoples, that is the non-Israelites"
,"8":"whose descendants were left in the country and had not been killed by the Israelites. Their descendants continue to be slaves down to the present time."
,"9":"Upon the Israelites, however, Solomon did not impose slave labor; these served as fighting men; they were officers of his chariots and commanders of horsemen."
,"10":"Solomon appointed two hundred and fifty overseers to make all these people work."
,"11":"Solomon brought Pharaoh's daughter from the City of David up to the house he had built for her. For he said, 'I can't let a woman live in the palace of David king of Israel; these are holy places where the ark of Yahweh has been.'"
,"12":"Solomon then offered burnt offerings to Yahweh on Yahweh's altar which he had built in front of the porch."
,"13":"Observing the daily rule for burnt offerings according to the requirements of Moses for sabbaths, New Moon and the three annual feasts: the feast of Unleavened Bread, the feast of Weeks and the feast of Tabernacles."
,"14":"He established the priestly orders in their duties according to the regulations of his father David. He also enforced the rules affecting the Levites who offered praise and served with the priests according to the daily ritual, and the different orders of gatekeepers at each gate, for such had been the commandments of David, the man of God."
,"15":"They did not change anything of the royal ordinances applying to the priests and the Levites, not even in the matter of treasurership."
,"16":"In this way all of Solomon's work was completed from the day when the foundations of Yahweh's House were laid, until the end - and so... Yahweh's House was finished."
,"17":"Then Solomon went as far as Eziongeber and Elath on the shores of the sea, in the land of Edom."
,"18":"Huram sent him ships manned by his own men, who were experienced sailors. These men went with Solomon's men to Ophir and from there they brought back almost sixteen tons of gold, which they delivered to King Solomon."
}`)
	CurrentBook.AddChapter(9, `{
"1":"The fame of Solomon having reached the queen of Sheba, she came to Jerusalem to test him with difficult questions. She came with immense riches, camels loaded with spices, great quantities of gold and precious stones. On coming to Solomon, she asked him all the questions that she had in mind,"
,"2":"and Solomon had an answer for all her questions, not one was too difficult for him to explain."
,"3":"When the queen of Sheba saw the wisdom of Solomon, the palace he had built,"
,"4":"the food at his table, the accommodations for his officials, the organization of his staff and the way they were dressed, his cupbearers and the burnt offerings he offered in the Temple of Yahweh, it left her breathless;"
,"5":"and she said to the king, 'What I heard in my own country about you and your wisdom was true, then!"
,"6":"I could not believe what they told me was not even half of your wisdom for the reality surpasses what I heard."
,"7":"How happy your wives are! How happy these servants of yours who wait on you always and hear your wisdom!"
,"8":"Blessed be Yahweh your God who loves you and made you king to rule in his name. Because your God loves Israel and wants to preserve them forever, he has made you their king to administer law and justice.'"
,"9":"And the queen of Sheba gave King Solomon almost five tons of gold and great quantities of spices and precious stones. There never were spices like those the queen of Sheba gave to King Solomon."
,"10":"Similarly the servants of Huram and the servants of Solomon, who carried gold from Ophir, brought algummim wood and precious stones."
,"11":"Of the algummim wood the king made floorboards for Yahweh's House and for the royal palace, and lyres and harps for the musicians; nothing like them had ever been seen before in the land of Judah."
,"12":"And King Solomon, in his turn, gave the queen of Sheba everything she expressed any wish for, besides returning what she had brought to the king. Then she went home, she and her servants, to her own country."
,"13":"The weight of gold coming to Solomon in one year was over twenty-five tons,"
,"14":"not counting the taxes paid by the traders and merchants; all the kings of Arabia and the governors of the country also brought gold and silver to Solomon."
,"15":"King Solomon made two hundred great shields of beaten gold, and plated each shield with about fifteen pounds of gold,"
,"16":"and also three hundred small shields of beaten gold, and plated each of these with about eight pounds of gold; and he put them in the Hall of the Forest of Lebanon."
,"17":"The king also made a great ivory throne and plated it with purest gold."
,"18":"The throne had six steps, with a platform behind and arms at either side of the seat; two lions stood beside the arms,"
,"19":"and twelve lions stood on either side of the six steps. No throne like this was ever made in any other kingdom."
,"20":"All King Solomon's drinking vessels were of gold, and all the furnishings in the Hall of the Forest of Lebanon were of pure gold; silver was not considered valuable in the time of Solomon."
,"21":"And the king also had ships that went to Tarshish with Huram's men, and once every three years the ships of Tarshish would come back bringing gold and silver, ivory, apes and baboons."
,"22":"King Solomon was richer and wiser than any other king in the world."
,"23":"All the kings of the earth consulted Solomon to hear the wisdom God had given him,"
,"24":"and each would bring his own present: gold vessels, silver vessels, robes, armor, spices, horses and mules; and this went on year after year."
,"25":"Solomon had four thousand stalls for his horses and chariots, and twelve thousand horses; these were stationed in the chariot towns and near the king in Jerusalem."
,"26":"Solomon extended his power over all the kingdoms from the river to the land of the Philistines and the Egyptian border."
,"27":"In Jerusalem the king made silver as common as stone, and cedars as plentiful as the sycamores of the Lowlands."
,"28":"Horses were imported for Solomon from Cilicia and all the other countries too."
,"29":"The rest of the history of Solomon, from first to last, is recorded in the History of Nathan the prophet, in the Prophecy of Ahijah of Shiloh, and in the Vision of Iddo, the seer concerning Jeroboam son of Nebat."
,"30":"Solomon reigned in Jerusalem over all Israel for forty years."
,"31":"Then Solomon rested with his fathers and was buried in the City of David his father; his son Rehoboam succeeded him."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Rehoboam went to Shechem where all the people of northern Israel had gone to proclaim him king."
,"2":"As soon as Jeroboam son of Nebat heard the news - he was still in Egypt where he had gone to escape from king Solomon - he returned from Egypt."
,"3":"The people of the northern tribes sent for him, and he came with the whole assembly. And they said this to Rehoboam, "
,"4":"'Your father placed heavy burdens on us. If you make these burdens lighter for us, we will serve you.'"
,"5":"He said, 'Come back to me in three days.' And the people went away."
,"6":"King Rehoboam consulted the older men who had served as advisers to his father Solomon and asked them, 'What reply do you advise me to give to this people?'"
,"7":"They said, 'If you are kind to these people and listen to them and treat them fairly, then they will serve you forever.'"
,"8":"But he rejected the advice given him by the elders and consulted the bloody young men who had grown up with him."
,"9":"He asked, 'How do you advise us to answer these people who have said to me, 'Lighten the burden your father put on us'?'"
,"10":"The bloody young men who had grown up with him replied, 'Give this answer to these people who have said, 'Your father gave us a heavy burden to bear, you must lighten it for us.' Say this to them, 'My little finger is thicker than my father's waist!"
,"11":"My father made you bear a heavy burden, but I will make it heavier still! My father beat you with whips; I am going to beat you with bullwhips!'"
,"12":"Jeroboam with all the people came to Rehoboam on the third day according to what the king had said, 'Come back to me on the third day.'"
,"13":"King Rehoboam, rejecting the advice of the elders, gave them a harsh answer"
,"14":"and spoke to them as the bloody young men had recommended, 'My father made you bear a heavy burden, but I will make it heavier still. My father beat you with whips; I am going to beat you with bullwhips!'"
,"15":"The king in fact paid no attention to the people's wishes, and this was brought about by God to carry out what Yahweh had spoken through Ahijah of Shiloh to Jeroboam son of Nebat."
,"16":"When all Israel saw that the king paid no attention to their wishes, they gave him this answer: 'Down with David and his descendants! What have they ever done for us? To your tents, men of Israel; let's go home. From now on let Rehoboam look out for himself!'"
,"17":"So the people of Israel rebelled and Rehoboam was left with those people of Israel who lived in the towns of Judah."
,"18":"King Rehoboam sent Adoram who was in charge of forced labor, but the Israelites stoned him to death;"
,"19":"whereupon King Rehoboam was obliged to mount his chariot and escape to Jerusalem. And the people of Israel have been in rebellion against the family of David until the present day."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Rehoboam went to Jerusalem and called together the tribes of Judah and Benjamin, a hundred and eighty thousand selected warriors, to fight the northern tribes of Israel and win back the kingdom of Rehoboam."
,"2":"But the word of Yahweh came to the prophet Shemaiah,"
,"3":"'Say this to Rehoboam son of Solomon, king of Judah, and to all the Israelites in Judah and Benjamin, 'Yahweh says this:"
,"4":"Do not attack your fellow Israelites; let everyone go home, for what has happened is my doing.'"
,"5":"They obeyed Yahweh's command and went back, instead of fighting against Jeroboam. Rehoboam lived in Jerusalem and built fortified towns in Judah. "
,"6":"He rebuilt Bethlehem, Etam, Tekoa,"
,"7":"Bethzur, Soco, Adullam,"
,"8":"Gath, Mareshah, Ziph,"
,"9":"Adoraim, Lachish, Azekah,"
,"10":"Zorah, Aijalon, Hebron; these were fortified towns in Judah and Benjamin."
,"11":"He fortified them with walls and put commanders in them with stores of food, oil and wine."
,"12":"In each of these towns were shields and spears. He made them very strong to keep Judah and Benjamin under control."
,"13":"From all the territory of Israel, priests and Levites came south to Judah."
,"14":"The Levites, indeed, abandoned their pasture lands and their holdings, and came to Judah and Jerusalem, since Jeroboam and his sons did not recognize them as the only priests of Yahweh"
,"15":"and had appointed priests of his own to serve at the High places to worship the goats and the bullcalves he had made."
,"16":"Members of all the tribes of Israel, people who sincerely wanted to worship Yahweh the God of Israel, followed them and came to Jerusalem to sacrifice to Yahweh, the God of their ancestors."
,"17":"These Israelites added strength to the kingdom of Judah, and gave their support to Rehoboam son of Solomon for three years, because during three years he followed the example of David and Solomon."
,"18":"Rehoboam took as wife Mahalath the daughter of Jerimoth, son of David and of Abihail, daughter of Eliab, son of Jesse."
,"19":"She bore him sons: Jeush, Shemariah and Zaham."
,"20":"After her, he married Maacah daughter of Absalom, who bore him Abijah, Attai, Ziza and Shelomith."
,"21":"Rehoboam loved Maacah, daughter of Absalom, more than all his other wives and concubines. He had in fact a total of eighteen wives and sixty concubines, twenty-eight sons and sixty daughters."
,"22":"Rehoboam favored Abijah, Maacah's son over all his other children, choosing him as the one to succeed him as king."
,"23":"Rehoboam ruled prudently by scattering his sons throughout Judah and Benjamin in the fortified towns, where he provided them with generous provisions and many wives."
}`)
	CurrentBook.AddChapter(12, `{
"1":"As soon as Rehoboam had established his authority as king and had become powerful, he and all his people abandoned the Law of Yahweh."
,"2":"In the fifth year of Rehoboam, Shishak the king of Egypt attacked Jerusalem, since it had been unfaithful to Yahweh."
,"3":"With twelve hundred chariots and sixty thousand horses and countless army of Libyans, Sukkiim and Ethiopians who came from Egypt with him,"
,"4":"he captured the fortified towns of Judah and reached Jerusalem. Rehoboam and the Judaean captains, at the advance of Shishak, had gathered near Jerusalem;"
,"5":"to them came Shemaiah the prophet and he said, 'Yahweh says this: as you have abandoned me, now I have abandoned you into the hands of Shishak."
,"6":"Then the Israelite captains and the king humbled themselves and said, 'Yahweh is just!'"
,"7":"When Yahweh saw that they had humbled themselves, the word of Yahweh came to Shemaiah. 'They have humbled themselves; because of this I will not destroy them. In a little while I will grant them deliverance; my anger shall not fall on Jerusalem through the power of Shishak."
,"8":"Nevertheless they shall become his slaves, so that they may come to understand the difference between serving me and serving the kings of foreign countries.'"
,"9":"Shishak the king of Egypt attacked Jerusalem and took all the treasures from the Temple of Yahweh and from the royal palace. He took everything, including the golden shields that Solomon had made;"
,"10":"in place of them King Rehoboam had bronze shields made, entrusting them to the care of the officers of the guard who guarded the king's palace gate."
,"11":"Whenever the king went to the Temple of Yahweh, the guards would come out carrying them, and return them to the guardroom afterward."
,"12":"Since he had submitted to Yahweh, the anger of Yahweh did not completely destroy him. There was still something good in Judah."
,"13":"King Rehoboam was able to strengthen his position in Jerusalem and to govern. Now Rehoboam was forty-one years old when he became king and he reigned for seventeen years in Jerusalem, the city chosen by Yahweh out of all the tribes of Israel, as the place where his Name would be. Rehoboam's mother was Naamah, the Ammonitess."
,"14":"He did evil, because he had not set his heart on seeking Yahweh."
,"15":"The history of Rehoboam, from first to last, is all recorded in the Annals of Shemaiah the prophet and of Iddo the seer. There was constant warfare between Rehoboam and Jeroboam."
,"16":"Then Rehoboam rested with his fathers and was buried in the City of David; his son Abijah succeeded him."
}`)
	CurrentBook.AddChapter(13, `{
"1":"In the eighteenth year of King Jeroboam, Abijah became king of Judah"
,"2":"and reigned for three years in Jerusalem. His mother was Micaiah, daughter of Uriel, from Giveah. Abijah and Jeroboam were at war."
,"3":"Abijah went into battle with an army of brave fighters, four hundred thousand picked men, while Jeroboam drew up his battle line against him with eight hundred thousand picked men, brave soldiers."
,"4":"Abijah went up Mount Zemaraim, in the hill country of Ephraim, and cried, 'Jeroboam and all Israel, listen to me!"
,"5":"Do you know that Yahweh the God of Israel has given the kingship of Israel to David forever? It is an unbreakable covenant for him and for his sons."
,"6":"Yet Jeroboam son of Nebat, a servant of Solomon son of David, has rebelled against his king;"
,"7":"worthless men, scoundrels, have rallied to him and opposed Rehoboam, the son of Solomon. Rehoboam, then a young man and timid, was unable to resist them."
,"8":"Now you propose to subdue the Kingdom of Yahweh that he gave to David's descendants. You stand here with a huge army, but you are bringing the golden calves that Jeroboam made you for gods!"
,"9":"Have you not driven out the priests of Yahweh, the sons of Aaron and the Levites, to make priests of your own like the peoples of foreign countries? Anyone who comes with a bull and seven rams can ask to be consecrated and become priest of what is no god at all!"
,"10":"As for us, our God is Yahweh, and we have not abandoned him: the sons of Aaron minister to Yahweh, and the Levites as well."
,"11":"Every morning, every evening, we burn burnt offerings to Yahweh our God, we have the incense of sweet spices, the loaves set out in rows on the pure table, the golden lampstand with its lamps that burn each evening; for we observe the ritual of Yahweh our God, that you have abandoned."
,"12":"See how God is with us, at our head; see his priests with the trumpets, which they will sound against you. People of Israel, do not fight against Yahweh, the God of our ancestors, for you will not succeed.'"
,"13":"Jeroboam outflanked the Judaeans by setting an ambush behind them; the Judaeans were facing the Israelites with the ambush at their rear."
,"14":"The Judaeans, turning about, found themselves attacked from the front and the rear. They called on Yahweh and while the priests sounded the trumpets,"
,"15":"the men of Judah raised the war cry. And as they raised the war cry, God scattered Jeroboam and all Israel before Abijah and the people of Judah."
,"16":"The Israelites fled before Judah and God delivered them into the power of the Judaeans."
,"17":"Abijah and his army inflicted a crushing defeat on them: five hundred thousand of Israel's chosen men were killed."
,"18":"And so the people of Israel were humbled and the people of Judah were victorious because they relied on Yahweh, the God of their ancestors."
,"19":"Abijah pursued Jeroboam's army and captured towns from him: Bethel with its outlying villages, Jeshanah with its outlying villages and Ephron with its outlying villages."
,"20":"So in the lifetime of Abijah, Jeroboam could no longer maintain his power. Yahweh struck him down, and he died."
,"21":"But Abijah grew in strength; he took fourteen wives and had twenty-two sons and sixteen daughters."
,"22":"The rest of the history of Abijah, his conduct and his deeds, is not all this recorded in the commentary of the prophet Iddo? Then Abijah rested with his fathers and they buried him in the City of David; his son Asa succeeded him. In his time the country was at peace for ten years."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Asa did what is good and right in the eyes of Yahweh."
,"2":"He removed the altars of foreign worship and the High places. He broke down the sacred stones and cut down the Asherah's trunks."
,"3":"He commanded the people of Judah to do the will of Yahweh, the God of their ancestors, and to observe the Law and its commands."
,"4":"He removed the High places and the altars of incense in every town of Judah. The kingdom was at peace under his rule."
,"5":"He rebuilt the fortified towns of Judah, since the country was at peace, and there was no war during those years, for Yahweh granted him peace."
,"6":"He told the people of Judah, 'Let us rebuild these towns and surround them with walls and towers, with gates and bars while we have control of this land, since we have done the will of Yahweh our God; and he has protected us and given us peace on every side.'"
,"7":"They built and prospered. Asa had an army of three hundred thousand Judaeans armed with buckler and spear, and two hundred eighty thousand Benjaminites bearing shield and wielding the bow, all of them brave, well-trained men."
,"8":"Zerah the Cushite, with an army one million strong and three hundred chariots, made an incursion which reached to Mareshah."
,"9":"Asa marched against him and drew up his battle line in the Valley of Zephathah, at Mareshah."
,"10":"He called on Yahweh, his God, 'Yahweh, no one but you can stand up for the powerless against the powerful. Come to our help, Yahweh our God! We rely on you, and fight against this huge army in your name. Yahweh, you are our God. Let no one defeat you.'"
,"11":"Yahweh defeated the Cushites when Asa and the Judaean army attacked them. The Cushites fled,"
,"12":"and Asa pursued them with his army as far as Gerar. The Cushites fell even to the last for they had been overpowered by Yahweh and his camp. They collected great amounts of loot."
,"13":"They conquered all the towns in the area of Gerar, for the terror of Yahweh had fallen on these towns and they plundered them all since they were full of loot."
,"14":"They also attacked the camps of some shepherds and carried off great numbers of sheep and camels; then they returned to Jerusalem."
}`)
	CurrentBook.AddChapter(15, `{
"1":"The spirit of God came on Azariah, son of Obed;"
,"2":"he went out to meet Asa and said, 'Listen to me, Asa, and all you of Judah and of Benjamin. Yahweh is with you so long as you are with him. When you look for him, he lets you find him; when you turn away, he will abandon you."
,"3":"For a long time Israel will be without the true God, and without priest to teach the Law,"
,"4":"but when trouble comes, they will turn to Yahweh, the God of Israel. They will look for him and find him."
,"5":"When that time comes, there will be no peace for anyone, for many troubles will come upon all the inhabitants of the earth."
,"6":"One nation will oppress another nation, and one city another city, because God will bring trouble and distress on them."
,"7":"But for your part, take courage, and be strong, for your deeds will be rewarded.'"
,"8":"When Asa heard these words and this prophecy, he was encouraged to do away with all the idols throughout the land of Judah and Benjamin, and in the towns he had captured in the highlands of Ephraim; he then repaired the altar of Yahweh that stood in front of the Hall of Yahweh."
,"9":"He gathered all Judah and Benjamin together, and also the Ephraimites, Manassites and Simeonites who had settled with them, since great numbers of Israelites had gone over to Asa's side when they saw that Yahweh was with him."
,"10":"In the third month of the fifteenth year of Asa they assembled in Jerusalem;"
,"11":"and they sacrificed to Yahweh that day seven hundred oxen and seven thousand sheep out of the spoil they had brought back."
,"12":"They made a covenant in which they agreed to seek Yahweh, the God of their ancestors, with all their heart and soul;"
,"13":"anyone who would not seek Yahweh the God of Israel was to be put to death, young or old, man or woman."
,"14":"They pledged their oath to Yahweh aloud with shouts to the sound of trumpet and horn;"
,"15":"all Judah rejoiced at the oath they had wholeheartedly taken. They sought Yahweh so earnestly that he let them find him, and granted them peace on every side."
,"16":"King Asa took from his grandmother Maacah her title of queen mother, because she had made a hideous idol Asherah. Asa cut down the idol, and burned it in the wadi Kidron. Though the High places were not abolished in Israel, the heart of Asa was blameless all his life. He deposited the offerings dedicated by his father and his own offerings too, in the house of God, silver and gold and furnishings."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Up to the thirty-fifth year of Asa's reign there was no war. In the thirty-sixth year of Asa's reign, Baasha king of Israel invaded Judah and fortified Ramah to blockade Asa king of Judah."
,"2":"Asa then took the silver and gold from the treasuries of Yahweh's House and the royal palace, and sent it with the following message to Ben-hadad king of Aram who lived in Damascus,"
,"3":"'Let there be a covenant between myself and you, as between my father and your father! With this I send you silver and gold. Come, break off your alliance with Baasah king of Israel, so that he goes away from me."
,"4":"Ben-hadad agreed, and sent his generals against the towns of Israel; he conquered Ijon, Dan, Abelmaim and all the garrison towns of Naphtali."
,"5":"When Baasha heard this he stopped fortifying Ramah, abandoning this work."
,"6":"King Asa then brought all the people of Judah, who took away the stones and timber with which Baasah had been fortifying Ramah, and the king used them to fortify Geba and Mizpah."
,"7":"It was then that Hanani, the prophet, came to Asa king of Judah and said, 'Since you have relied on the king of Aram and not on Yahweh your God, the army of the king of Aram will escape from you."
,"8":"Did not the Cushites and Libyans form a vast army with great numbers of chariots and horses? And were they not delivered into your power because you relied on Yahweh?"
,"9":"Yahweh keeps close watch over the whole world to give strength to those who are devoted to him wholeheartedly. You have acted foolishly in this matter, for from now on you will have wars.'"
,"10":"Asa was very angry with the prophet and had him put in chains in prison, for he was angry because of these words. At the same time Asa treated some others harshly too."
,"11":"The history of Asa, from first to last, is recorded in the Book of the Kings of Judah and Israel."
,"12":"A disease attacked Asa from head to foot in the thirty-ninth year of his reign; and, what is more, he turned in his sickness, not to Yahweh, but to doctors."
,"13":"Then Asa rested with his fathers in the forty-first year of his reign. They buried him in the tomb he had ordered to be dug for himself in the City of David. They laid him on a couch entirely covered with spices and varied ointments, products of the perfumer's skill, and lit a huge fire for him."
}`)
	CurrentBook.AddChapter(17, `{
"1":"His son Jehoshaphat succeeded him and strengthened his position against Israel."
,"2":"He put troops in all the fortified towns in Judah, and appointed governors in the land of Judah and in all the towns of Ephraim captured by his father Asa."
,"3":"Yahweh blessed Jehoshaphat because he followed the example of David his father and did not worship Baal;"
,"4":"he served the God of his father, following his commandments and not following the example of Israel."
,"5":"So Yahweh made the kingship secure in his hands; all the people of Judah brought gifts to Jehoshaphat, and ample riches and honor were his."
,"6":"He took pride in serving Yahweh and destroyed all the High places and Asherah's trunks in Judah."
,"7":"In the third year of his reign he sent his officers: Benhail, Obadiah, Zechariah, Nethanel and Micaiah, to give instruction in the towns of Judah."
,"8":"With them went the Levites: Shemaiah, Nethaniah, Zebadiah, Asaherel, Shemiramoth, Jehonathan, Adonijah and Tobijah, the Levites, together with the priests, Elishama and Jehoram."
,"9":"They gave instruction in Judah, having with them the book of the Law of Yahweh, and went around all the towns of Judah instructing the people."
,"10":"The fear of Yahweh came upon all the kingdoms surrounding Judah, so that they did not war against Jehoshaphat."
,"11":"Some of the Philistines brought him gifts and silver in tribute; the Arabs themselves brought him, in small stock, seven thousand seven hundred rams and seven thousand seven hundred he-goats."
,"12":"Jehoshaphat became more and more powerful. Throughout Judah he built fortresses and towns with storage places."
,"13":"He had many workers in the towns of Judah and a garrison of outstanding officers in Jerusalem."
,"14":"This was their disposition by families: for Judah, commanders of thousands; Adnah, the commanding officer, with three hundred thousand outstanding officers under his command,"
,"15":"Jehohanan with two hundred and eighty thousand;"
,"16":"Amasiah son of Zichri, who had volunteered for Yahweh's service, with two hundred thousand valiant warriors."
,"17":"From Benjamin: the valiant warrior Eliada with two hundred thousand, armed with bow and shield:"
,"18":"under his command, Jehozabad with a hundred and eighty thousand equipped for war."
,"19":"These were the men who served the king, not counting those the king had put in the fortified towns throughout Judah."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Jehoshaphat, then, enjoyed great wealth and honor and allied himself by marriage to Ahab."
,"2":"After some years he went to visit Ahab in Samaria. Ahab slaughtered for him and for his retinue great numbers of sheep and oxen; then urged him to attack Ramoth-gilead."
,"3":"And he asked Jehoshaphat, 'Will you come with me to Ramoth-gilead?' Jehoshaphat answered the king of Israel, 'I am with you, my men are yours, and we will fight together.'"
,"4":"Jehoshaphat, however, said to the king of Israel, 'First, please consult the word of Yahweh.'"
,"5":"So the king of Israel called the prophets who were four hundred men, and asked them, 'Should we march to attack Ramoth-gilead, or should I refrain?' They replied, 'Go, because Yahweh will deliver it into your power.'"
,"6":"But Jehoshaphat said, 'Is there no other prophet of Yahweh here for us to consult?'"
,"7":"The king of Israel answered, 'There is one more man through whom we can consult Yahweh, but I hate him because he never tells me good things but only discouraging words. He is Micaiah son of Imlah.' Jehoshaphat said, 'The king should not say such things.'"
,"8":"Accordingly the king of Israel summoned one of his officials and said, 'Bring Micaiah son of Imlah immediately.'"
,"9":"The king of Israel and Jehoshaphat king of Judah were both sitting on their thrones in royal garments; they sat at the threshing-floor outside the gate of Samaria, with all the prophets raving in front of them."
,"10":"Zedekiah son of Chenaanah had made himself iron horns and said, 'Yahweh says this: You will gore the Arameans till you make an end of them.'"
,"11":"And all the prophets prophesied the same saying, 'March to Ramoth-gilead, for you will succeed. Yahweh will deliver it into the power of the king.'"
,"12":"In the meantime the messenger who had gone to summon Micaiah said to him, 'All the prophets as one man are foretelling victory to the king. Try to speak like one of them and foretell success.'"
,"13":"But Micaiah answered, 'As Yahweh lives, what my God says, that will I utter!'"
,"14":"When he came to the king, the king asked him, 'Micaiah, should we go to attack Ramoth-gilead, or should I refrain?' He answered, 'Go and you will succeed. They will be delivered into your power.'"
,"15":"But the king said, 'How often must I beg you to tell me nothing but the truth in the name of Yahweh?'"
,"16":"Then Micaiah said, 'I have seen all Israel scattered on the mountains like sheep without a shepherd. And Yahweh said, 'These have no master, let each one go home in peace.' '"
,"17":"At this the king of Israel said to Jehoshaphat, 'Did I not tell you that he never foretells me good things, but only what is discouraging?'"
,"18":"Micaiah went on. 'Listen to the word of Yahweh. I have seen Yahweh seated on his throne; all the array of heaven stood to his right and to his left."
,"19":"Yahweh said, 'Who will trick Ahab king of Israel so that he goes and falls at Ramoth-gilead?' At which some answered one way, and some another."
,"20":"Then a spirit stepped forward, approached Yahweh and said, 'I will trick him.' Yahweh asked, 'How?'"
,"21":"He replied, 'I will go and become a lying spirit in the mouths of all his prophets.' Yahweh said, 'You shall trick him and succeed. Go and do it.'"
,"22":"So Yahweh has put a lying spirit into the mouths of your prophets here because he himself wants you to meet with disaster!'"
,"23":"Then Zedekiah, son of Chenaanah came up and slapped Michaiah's face, and he asked, 'When did the spirit of Yahweh leave me, to talk to you?'"
,"24":"Micaiah replied, 'This is what you will find out the day you flee from house to house to hide.'"
,"25":"The king of Israel said, 'Seize Micaiah and hand him over to Amon, governor of the city, and to Prince Joash,"
,"26":"and say: This is the king's order: Put this man in prison and feed him on nothing but bread and water until I come back safe and sound.'"
,"27":"Micaiah said, 'If you come back safe and sound, Yahweh has not spoken through me.'"
,"28":"The king of Israel and Jehoshaphat king of Judah went to attack the city of Ramoth in Gilead."
,"29":"The king of Israel said to Jehoshaphat, 'I will disguise myself as we go into battle, but I want you to wear your royal clothes.' The king of Aram had given his chariot commanders the following order: 'Do not attack anyone of whatever rank, except the king of Israel.' When the chariot commanders saw Jehoshaphat, they thought he was the king of Israel. And they wheeled to the attack. But Jehoshaphat gave a shout and Yahweh came to his help, God rescued him and turned the attack away from him. The chariot commanders realized that he was not the king of Israel and called off their pursuit. By chance, however, one of the soldiers shot an arrow which struck the king of Israel between the joints of his armor. The king said to his charioteer, 'Turn around and get me out of the battle; I have been hurt.' But the battle grew fiercer so that they held the king upright in his chariot facing the Aramaeans until evening, and at sunset he died. "
}`)
	CurrentBook.AddChapter(19, `{
"1":"Jehoshaphat came back safe and sound to Jerusalem."
,"2":"Jehu, son of Hanani the prophet, went to meet him and said to king Jehoshaphat, 'Should a man give help to the wicked? Should you love those who hate Yahweh? Because of this you have brought his anger on you!"
,"3":"There is some good in you, however, since you have removed from your land Asherah's trunks and have set your heart on seeking God.'"
,"4":"Jehoshaphat stayed for a time in Jerusalem. After that he would again visit his people regularly, from Beersheba to the highlands of Ephraim to bring them back to Yahweh, the God of their ancestors."
,"5":"He appointed judges in the country in every one of all the fortified towns of Judah."
,"6":"He said to these judges, 'Give due thought to your duties, since you are not judging in the name of men but in the name of Yahweh, who is with you whenever you pronounce sentence."
,"7":"May the fear of Yahweh now be on you. Keep the Law, apply it, for Yahweh our God does not tolerate fraud or partiality or the taking of bribes.'"
,"8":"In addition, Jehoshaphat appointed priests, Levites and heads of Israelite families in Jerusalem as judges in cases involving a violation of the Law or legal disputes between people living in the city. They lived in Jerusalem"
,"9":"and Jehoshaphat gave them the following instructions, 'You are to perform these duties in the fear of Yahweh, as upright and honest men."
,"10":"Whatever dispute comes before you from your brothers living in their towns: either about crimes or questions of the Law, you are to teach them the commandments, statutes or ordinances, so that they do not become guilty of sinning against Yahweh, lest his anger come on you and your brothers. Do this and you will not be guilty."
,"11":"Amariah, the chief priest, will have final authority over you in all religious matters, and Zebadiah son of Ishmael, governor of Judah, in all matters affecting the king. The Levites will serve as your scribes. Be courageous, carry out these instructions, and Yahweh will be there to bring success.'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"After this the Moabites and Ammonites with some of the Meunites started to make war on Jehoshaphat."
,"2":"Jehoshaphat received the following message, 'A large army is advancing against you from Edom, from the other side of the sea; they are already at Hazaaon-tamar, that is, Engedi.'"
,"3":"Jehoshaphat was frightened and prayed to Yahweh for guidance. Then he ordered that a fast be observed throughout the country."
,"4":"Judah assembled to seek help from Yahweh; they came seeking Yahweh's guidance from every single town in Judah."
,"5":"Then Jehoshaphat stood before this assembly of the people of Judah and Jerusalem in Yahweh's House, before the new court"
,"6":"and said, 'Yahweh, God of our ancestors, are you not the God who dwells in heaven? Do you not rule over all the kingdoms of the world? Such power and might are in your hands that no one can oppose you."
,"7":"Are you not our God, you who drove out the people who were living here before your people Israel and gave the land to the descendants of your friend Abraham forever?"
,"8":"They have settled in it and built a sanctuary in it for your name,"
,"9":"saying, 'Should disaster strike us, or war, punishment, epidemic, or famine, then we shall stand before this house and before you, for your Name rests on this house. From the depths of our distress we shall cry to you, and you will hear and save us.'"
,"10":"Here now are the Ammonites and Moab and the folk of Seir. When Israel came out of the land of Egypt you would not let Israel invade them; instead, Israel turned away from them and did not destroy them,"
,"11":"and this is how they reward us, by coming to drive us out of the possessions you have given us as our inheritance."
,"12":"Will you, our God, not punish them, since we are helpless in the face of this large army that attacks us? We ourselves do not know what to do; but we look to you.'"
,"13":"All the men of Judah, even down to their youngest children and their wives, stood there at the House."
,"14":"In the middle of the assembly the spirit of Yahweh came on Jahaziel son of Zechariah, son of Benaiah, son of Jeiel, son of Mattaniah the Levite, one of the sons of Asaph."
,"15":"And he cried, 'Listen all you men of Judah and you who live in Jerusalem, and you, King Jehoshaphat! Yahweh says this to you: You must not be discouraged or afraid to face this large army; this battle is not yours but God's."
,"16":"March out against them tomorrow; they are coming up by the Slope of Ziz and you will come on them in the Valley of Soph, near the wilderness of Jeruel."
,"17":"You will not need to fight there, but only take up your position, stand firm, and see what salvation Yahweh has in store for you. Judah and Jerusalem, be fearless, be dauntless; go out to battle tomorrow and Yahweh will be with you.'"
,"18":"Jehoshaphat bent his head, his face to the ground, and all Judah with those who lived in Jerusalem fell down before Yahweh, worshiping him."
,"19":"Then the Levites - Kohathites and Korahites - began praising Yahweh the God of Israel at the top of their voices."
,"20":"They rose early in the morning and left for the wilderness of Tekoa. As they were setting out, Jehoshaphat stood and said, 'Listen to me Judah and all who live in Jeru-salem! Put your trust in Yahweh your God and you will stand your ground; have faith in his prophets and you will be successful.'"
,"21":"Then, having held a conference with the people, he ordered some musicians to put on the robes they wore on sacred occasions and to march at the head of the army, to sing praises to him: 'Give praise to Yahweh, for his love is everlasting.'"
,"22":"As they began to sing their joy and their praise, Yahweh threw the invading armies into a panic and completely destroyed them. The Moabites and the Ammonites struck the people of Seir and there was a disaster."
,"23":"For the Ammonites and Moabites turned on the mountain folk of Seir in savage fighting and after they had destroyed them, they began to kill one another."
,"24":"When the men of Judah reached the spot that looks out on the wilderness and turned to face the enemy, they found only dead bodies lying on the ground; no one had escaped."
,"25":"Jehoshaphat came with his troops to plunder them, and found quantities of cattle, goods, clothing and valuables; they collected more than they could take away; the loot was so plentiful that they were three days gathering it."
,"26":"On the fourth day they assembled in the Valley of Beracah; and there they did indeed praise Yahweh for all he had done. Because of this, this Valley was named the Valley of Beracah which it is still called."
,"27":"Then all the men of Judah and Benjamin, with Jehoshaphat at their head, went back joyfully to Jerusalem, for Yahweh had filled them with joy at the expense of their enemies."
,"28":"To the music of harp and lyre and trumpet they came to Jerusalem and to Yahweh's House."
,"29":"When the kingdoms of foreign countries heard how Yahweh had defeated Israel's enemies, they were all terrified."
,"30":"In the meantime, the kingdom of Jehoshaphat was calm, and God granted him peace on every side."
,"31":"Jehoshaphat reigned over Judah. He was thirty-five years old when he became king and he reigned for twenty-five years in Jerusalem. His mother was Azubah, daughter of Shilhi."
,"32":"He followed the example of his father Asa without wavering, doing what is right in the eyes of Yahweh."
,"33":"The High places however, were not destroyed; the people had still not turned their hearts to the God of their ancestors."
,"34":"The rest of the history of Jehoshaphat, from first to last, is recorded in the Annals of Jehu son of Hanani which have been transcribed into the Book of the Kings of Israel."
,"35":"After this, Jehoshaphat king of Judah allied himself with Ahaziah king of Israel, who led him into evil ways."
,"36":"He combined with him to build big ships that would sail to Tarshish. These were built at Eziongeber."
,"37":"Eliezer, son of Dodavahu of Mareshah, then made a prophecy against Jehoshaphat, 'Because you have allied yourself with Ahaziah, Yahweh has destroyed your plans.' In fact the ships broke up and were never fit to sail to Tarshish."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Jehoshaphat rested with his ancestors and was buried in the City of David. His son Jehoram succeeded him."
,"2":"Jehoram had six brothers, sons of Jehoshaphat: Azariah, Jehiel, Zechariah, Azariahu, Michael and Shepatiah; these were all the sons of Jehoshaphat king of Israel."
,"3":"Their father had made them many gifts of silver, gold and jewels, and of fortified towns in Judah, but he made Jehoram his successor since he was the firstborn."
,"4":"When Jehoram was in firm control of the kingdom, he had all his brothers killed, as well as some Israelite officials."
,"5":"Jehoram was thirty-two years old when he became king and he reigned for eight years in Jerusalem."
,"6":"He followed the wicked example of the kings of Israel and did as the family of Ahab had done, for he had married one of Ahab's daughters; and he did what was evil in the eyes of Yahweh."
,"7":"Yahweh however did not intend to destroy the descendants of David, because of the covenant he had made with David, when he promised to leave a lamp for him and his sons forever."
,"8":"In his time Edom revolted against Judah and set up a king for itself."
,"9":"Jehoram invaded Edom with his commanders and all his chariots. He rose during the night and broke through and escaped from the Edomites encircling him and his chariot commanders."
,"10":"Thus Edom became independent of Judah, and has remained free to the present day. Libnah also revolted against Jehoram at the same time for he had deserted Yahweh, the God of his ancestors."
,"11":"He also set up High places in the highlands of Judah and caused the people living in Jerusalem and Judah to sin against Yahweh."
,"12":"Then something written by the prophet Elijah came into his hand. It ran, 'This is the word of Yahweh, the God of David your ancestor. You have not followed the example of your father Jehoshaphat or of Asa king of Judah,"
,"13":"but the wicked example of the kings of Israel, and have caused Judah and the people living in Jerusalem to sin against Yahweh, just as Ahab and his successors did. You have also murdered your brothers, your own family, better men than yourself."
,"14":"Because of this Yahweh will strike you with a great calamity, which will come upon your people, your descendants, your wives and all your property."
,"15":"You yourself will suffer a painful intestinal disease that will grow worse day by day."
,"16":"Yahweh stirred up against Jehoram the Philistines and the Arabs bordering on the Cushites."
,"17":"They attacked Judah and invaded it, carrying off all they found in the king's palace, including his sons and his wives; the only son left him was Ahaziah, the youngest of them."
,"18":"And after all this, Yahweh brought on him a painful disease of the intestines."
,"19":"It lasted for more than one year, and when the two years were over and his last hour had come, he died in great pain. The people did not light a bonfire in mourning for him as they had for his father."
,"20":"He was thirty-two years old when he became king and he reigned for eight years in Jerusalem. He passed away with no one to regret him, and they buried him in the City of David, though not in the tombs of the kings."
}`)
	CurrentBook.AddChapter(22, `{
"1":"The people of Jerusalem proclaimed his youngest son, Ahaziah, king in place of him, since the armed band that had broken into the camp with the Arabs had killed all the elder sons. So Ahaziah son of Jehoram became king of Judah."
,"2":"Ahaziah was twenty years old when he became king and he reigned for one year in Jerusalem. His mother was Athaliah, daughter of Omri."
,"3":"He too followed the example of Ahab's family, since his mother gave him wicked advice."
,"4":"He sinned against Yahweh as Ahab's family had done, for they were his advisers after his father's death, and they led him to his downfall."
,"5":"He also put their policies into practice and went with Jeroham son of Ahab, king of Israel, to fight against Hazael king of Aram at Ramoth-gilead. But the Aramaeans wounded Jeroham,"
,"6":"who returned to Jezreel to recover from the wounds that he had received at Ramoth, fighting against Hazael king of Aram. Ahaziah son of Jehoram, king of Judah, went down to Jezreel to visit Jehoram son of Ahab because he was ill. "
,"7":"Yahweh used this visit to Jeroham to bring about Ahaziah's downfall. On his arrival he went out with Jeroham against Jehu son of Nimshi whom Yahweh had chosen to destroy the family of Ahab."
,"8":"While Jehu was busy carrying out God's sentence against Ahab's family, he came across the officials of Judah and the kinsmen of Ahaziah who were in the king's service and killed them."
,"9":"He then went in search of Ahaziah who was captured while he tried to hide in Samaria. He was taken to Jehu who put him to death. But they gave him burial, for they said, 'This was a son of Jehoshaphat who sought Yahweh with all his heart.'"
,"10":"There was no one left in the royal family of Ahaziah strong enough to reign. As soon as Athaliah, the mother of Ahaziah, learned that her son was dead, she promptly gave orders for all the members of the royal family of Judah to be killed."
,"11":"But Jehosheba, daughter of king Joram, secretly rescued Joash, her brother's son, from among the sons of the king who were being murdered, and put him with his nurse in the sleeping quarters; in this way Jehosheba the daughter of King Joram and wife of Jehoiada the priest (a sister, too, of Ahaziah) hid him from Athaliah, and prevented her from killing him."
,"12":"He stayed with them for six years, hidden in the house of God, while Athaliah governed the country."
}`)
	CurrentBook.AddChapter(23, `{
"1":"After waiting six years Jehoiada the priest decided to take action. He sent for the commanders of hundreds: Azariah son of Jehoram, Ishmael son of Jehohanan, Azariah son of Obed, Maaseiah son of Adaiah and Elishaphat son of Zichri, and made a pact with them."
,"2":"They went through Judah, gathering the Levites from all the towns of Judah, and the heads of the Israelite families. They came to Jerusalem,"
,"3":"and this whole assembly made a pact with the king in the house of God. Jehoiada told them, 'Here is the son of the king, let him rule as king as Yahweh has promised regarding the descendants of David!"
,"4":"This is what you must do: one third of you, priests, Levites and keepers of the gate, must come in for the sabbath,"
,"5":"one third must be at the royal palace, one third at the Gate of Foundation, and all the people will be in the court of Yahweh's House."
,"6":"No one is to enter Yahweh's House except the priests and the Levites on duty, since they are consecrated and may enter. The people must all obey Yahweh's instructions and stay outside."
,"7":"The Levites must surround the king, each with his weapons in his hand; anyone who tries to enter the Temple is to be put to death. Stay with the king wherever he goes.'"
,"8":"The Levites and all Judah carried out all the orders of Jehoiada the priest. Every commander summoned both those who went off duty on the Sabbath, and those coming on duty, because Jehoiada did not except anyone."
,"9":"Then Jehoiada the priest provided the commanders of hundreds with King David's spears and large and small shields, which were in the house of God."
,"10":"He stationed the men from the west wing to the east wing, between the House and the altar, each with spear in hand, to protect the king."
,"11":"Then they brought out the king's son, crowned him and put on him the ornaments, and they proclaimed him king. Jehoiada and his sons then anointed him and shouted, 'Long live the king!'"
,"12":"Athaliah, on hearing the shouts of the people who were rushing to the king and acclaiming him, went to Yahweh's House where the people were."
,"13":"When she saw the king standing there at the entrance beside the pillar, with the captains and trumpeters at his side, and all the people from the countryside rejoicing and sounding trumpets, and the cantors with their musical instruments leading the hymns, Athaliah tore her clothes in distress and shouted, 'Treason, treason!'"
,"14":"Then Jehoiada the priest called out the military officers and ordered them, 'Take her outside the Temple, and kill anyone who follows her.' And he also said, 'You must not put her to death in Yahweh's House.'"
,"15":"They seized her, and when she had reached the palace at the entry to the Gate of the Horses, they put her to death there."
,"16":"Jehoiada made a covenant between the king and all the people, by which they would be the people of Yahweh."
,"17":"All the people then went to the house of Baal and tore it down; they smashed his altars and his images and killed Mattan, priest of Baal, in front of the altars."
,"18":"Jehoiada posted sentries to guard Yahweh's House under the authority of the levitical priests. David had appointed them in Yahweh's House to offer the burnt offerings of Yahweh according to the Law of Moses, and to sing joyfully the songs of David."
,"19":"He stationed gatekeepers at the gates of the Temple of Yahweh so that no one who was in any way unclean might enter."
,"20":"Then taking the commanders of hundreds, the notables, the ranking officials, and all the people from the countryside, he brought the king in procession from the House to the palace. They entered the royal palace through the main gate and seated the king on the royal throne."
,"21":"All the people from the countryside were delighted, and the city was quiet. Athaliah was put to death."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Joash was seven years old when he became king and he reigned for forty years in Jerusalem. His mother was Zibiah of Beersheba."
,"2":"Joash did what is pleasing to Yahweh throughout the lifetime of Jehoiada the priest."
,"3":"Jehoiada found him two wives and he had sons and daughters."
,"4":"After that Joash decided to repair Yahweh's House."
,"5":"Calling the priests and the Levites together, he said, 'Go out to the towns of Judah, and collect enough money from all the Israelites to make possible annual repairs on the house of God. Do this quickly.' But the Levites were in no hurry,"
,"6":"so the king called Jehoiada for he was their head, and said, 'Why have you not insisted on the Levites collecting from Judah and Jerusalem the tax which Moses, the servant of Yahweh, required the people to pay for the maintenance of the Tent of the Meeting?"
,"7":"Athaliah and her sons, whom she perverted, damaged the house of God and even used many of the sacred objects in the worship of Baal.'"
,"8":"So the king ordered them to make a chest and to place it outside the gate of Yahweh's House."
,"9":"And they announced throughout Judah and Jerusalem that they had to bring to Yahweh the tax Moses, that servant of God, had required in the wilderness."
,"10":"All the officials and all the people came joyfully with their contribution, dropping it into the chest until all was paid."
,"11":"The chest was taken to the royal office of control by the Levites whenever they saw that there was a great amount of money in it. The king's secretary then came with representatives of the chief priest to take the chest, empty it of money and later return it to its place. They did this every day, and collected a large sum of money."
,"12":"The king and Jehoiada gave the money to those who were in charge of repairing the House, and they hired men, masons and carpenters, who set about restoring Yahweh's House; craftsmen in iron and bronze also worked on the repairing of it."
,"13":"The supervisors having once made a start, the repairs went ahead; they rebuilt the house of God as it was before, as solid as ever."
,"14":"When they had finished, they brought the balance of the money to the king and Jehoiada, and from this, furnishings were made for Yahweh's House, vessels for the liturgy and for the burnt offerings, incense boats and objects of gold and silver. So, for as long as Jehoiada lived they offered sacrifices regularly in Yahweh's House. "
,"15":"Then Jehoiada, growing old, had his fill of days and died. He died at the age of a hundred and thirty years,"
,"16":"and they buried him with the kings in the City of David because he had served Israel well and also God and his house."
,"17":"After the death of Jehoiada, the officials of Judah came to pay court to the king, and the king now turned to them for advice."
,"18":"The Judaeans abandoned the house of Yahweh, the God of their ancestors, for the worship of sacred trunks and idols and God's anger fell on Judah and Jerusalem because of their guilt."
,"19":"He sent them prophets to bring them back to Yahweh, but when the prophets spoke, they would not listen."
,"20":"The spirit of God took control of Zechariah, son of Jehoiada the priest. He stood up before the people and said, 'God says this: Why are you disobeying the commandments of Yahweh? You cannot prosper. You have abandoned Yahweh and he will abandon you.'"
,"21":"They then plotted against him and by order of the king stoned him in the court of Yahweh's House."
,"22":"King Joash forgot the kindness of Jehoiada, the father of Zechariah, and killed Jehoiada's son who cried out as he died, 'Let Yahweh see and do justice!'"
,"23":"When a year had gone by, the Aramaean army made war on Joash. They reached Judah and Jerusalem, and killed all the officials among the people, sending back to the king of Damascus all that they had plundered from them."
,"24":"Though the Aramaean army was small, Yahweh delivered into its power an army of great size for they had abandoned him, the God of their ancestors."
,"25":"The Aramaeans wounded Joash and when they withdrew they left him a very sick man; and his officers, plotting against him to avenge the death of the son of Jehoiada the priest, murdered him in his bed. So he died, and they buried him in the City of David, though not in the tombs of the king."
,"26":"These were the conspirators: Zabad son of Shimeath the Ammonite woman, and Jehozabad son of Shimrith the Moabitess."
,"27":"As regard his sons, the heavy tribute he demanded, and the restoration of the house of God, this is all recorded in the commentary on the Book of the Kings. His son Amaziah succeeded him."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Amaziah was twenty-five years old when he became king, and he reigned for twenty-nine years in Jerusalem. His mother was Hehoassan of Jerusalem."
,"2":"He did what is pleasing to Yahweh, though not steadily."
,"3":"As soon as he was firmly in power, he killed those of his officers who had murdered the king his father."
,"4":"But he did not put their sons to death, in obedience to what is written in the Law, in the book of Moses, where Yahweh has ordered, 'Fathers must not be put to death for sons, nor sons for fathers; but everyone will pay for his own crime.'"
,"5":"Amaziah called the men of Judah together and organized them in families with commanders of thousands and of hundreds for all Judah and Benjamin. He counted those who were twenty years old or older, and found there were three hundred thousand of selected warriors fit for military service, and for handling spear and shield."
,"6":"Next, he enrolled one hundred thousand from Israel as mercenaries, for about four tons of silver."
,"7":"A man of God then came to him and said, 'O king, don't take these Israelite soldiers with you, for Yahweh is not with Israel or with any of the Ephraimites."
,"8":"If they come, whatever be the number of your men, God will still bring you down before your enemies, for God's is the power to uphold or to throw down.'"
,"9":"Amaziah answered the man of God, 'And what about the four tons of silver I have given the Israelite soldiers?' The man of God replied, 'Yahweh can give you far more than that.'"
,"10":"At this, Amaziah dismissed from his army the troops that had come to him from Ephraim and sent them home; these men were furious with Judah and went home in great anger."
,"11":"Amaziah led his army to Salt Valley and defeated ten thousand Edomite soldiers."
,"12":"The men of Judah took ten thousand captives alive and, taking them to the top of the cliff, threw them off the top; they were all dashed to pieces."
,"13":"Then the Israelite troops which Amaziah had dismissed and not allowed to fight with him raided the towns of Judah, from Samaria as far as Bethhoron, but they were defeated by a troop of three thousand men who recovered great quantities of plunder."
,"14":"On returning from his defeat of the Edomites, Amaziah brought the gods of the Edomites with him and set these up as gods for himself, bowing down before them and burning incense to them."
,"15":"Then Yahweh became angry with Amaziah and he sent him a prophet, who said, 'Why have you looked to this people's gods, who could not save their own people from your power?'"
,"16":"He was still speaking when Amaziah interrupted him, 'Have we appointed you a royal counselor? If you do not want to be hurt, be quiet!' The prophet paused; then he said, 'Now I know that God has decided to destroy you, since after having acted like this, you refuse to listen to me.'"
,"17":"After consulting his advisers, Amaziah king of Judah sent a message to Joash son of Jehoahaz, son of Jehu, king of Israel, challenging him to fight."
,"18":"Joash king of Israel sent back word to Amaziah king of Judah, 'The thornbush of Lebanon sent a message to the cedar of Lebanon, saying, 'Give my son your daughter in marriage'; but the wild animals of Lebanon trampled the thornbush down as they passed. You are very proud because you have defeated the Edomites - Boast on but stay at home."
,"19":"Why stir up trouble that will only bring disaster on you and your people?'"
,"20":"But Amaziah would not listen. It was God's will for him to be defeated, because he had worshiped the Edomite idols."
,"21":"And at Bethshemesh Judah, they made their trial of strength, Joash and Amaziah king of Judah."
,"22":"Judah was defeated by Israel, and everyone fled to his tent."
,"23":"The king of Judah, Amaziah son of Joash, son of Ahaziah, was taken prisoner at Bethshemesh by Joash, king of Israel who led him off to Jerusalem, where Joash tore down the city wall from the Gate of Ephraim to the Gate of the Corner, a distance of two hundred yards."
,"24":"He took all the gold and silver, all the furnishings to be found with Obed-edom in the House of God, the treasures of the royal palace, and hostages besides, and then returned to Samaria."
,"25":"Amaziah son of Joash, king of Judah, lived for fifteen years after the death of Joash son of Jehoahaz, king of Israel."
,"26":"The rest of the history of Amaziah, from first to last, is all recorded in the Book of the Kings of Judah and Israel."
,"27":"After the time when Amaziah rebelled against Yahweh, there had been a plot against him in Jerusalem; he fled to Lachish; but he was followed to Lachish and put to death there."
,"28":"He was brought back by horse, and buried with his ancestors in the City of David."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Uzziah, who is sixteen years old, and, made him king in place of his father Amaziah."
,"2":"He rebuilt Elath and recovered it for Judah, after the death of Amaziah."
,"3":"Uzziah was sixteen years old when he became king and he reigned for fifty-two years in Jerusalem. His mother was Jecoliah, of Jerusalem."
,"4":"He did what is pleasing to Yahweh, just as his father Amaziah had done;"
,"5":"he sought God in the lifetime of Zechariah, who taught him the fear of God. And for as long as he sought Yahweh, God gave him prosperity."
,"6":"He went out to fight the Philistines, tore down the walls of Gath, Jabneh and Ashdod, then rebuilt the towns in the area of Ashdod and in Philistine territory."
,"7":"God helped him defeat the Philistines, the Arabs, the inhabitants of Gurbaal and the Meunites."
,"8":"The Ammonites paid tribute to Uzziah. His fame spread as far as the border of Egypt, since he had become very powerful indeed."
,"9":"Uzziah built towers in Jerusalem, at the Gate of the Corner, at the Gate of the Valley and at the Angle; and he fortified these."
,"10":"He built towers in the wilderness too, and dug a great many cisterns, for he had large herds in the lowlands and on the tableland; and he had farmers and vinedressers in the hills and on the fertile lands; he was fond of agriculture."
,"11":"Uzziah had an army ready for battle. They set out for war by turns, according to the census carried out by the scribe Jeiel and the registrar Maaseiah. Their commander was Hananiah, one of the king's officers."
,"12":"The total number of heads of families among these valiant warriors was two thousand six hundred."
,"13":"Under their command was a trained army of three hundred and seven thousand five hundred fighting men, a powerful force to support the king against the enemy."
,"14":"Uzziah provided them with shields, spears, helmets, coats of armor, bows and sling stones, for each battle."
,"15":"In Jerusalem he constructed engines, invented by experts, which were mounted on the towers and at the corners to fire arrows and great stones. His fame spread far and wide; for he was extraordinary in getting help until he was strong."
,"16":"But, as his power increased, he became so proud that he lost what he had gained. He defied Yahweh his God by going into the House to burn incense on the altar of incense."
,"17":"Azariah the priest followed King Uzziah in, with eighty brave priests of Yahweh,"
,"18":"to resist him. They said to him, 'Uzziah, it is not for you to burn incense to Yahweh, but for the priests, the sons of Aaron, consecrated for the purpose. Leave the sanctuary; you have offended Yahweh God and you no longer have his blessing.'"
,"19":"Uzziah, censer in hand for the burning incense, became angry with the priests and immediately, leprosy broke out on his forehead in the presence of the priests, in Yahweh's House, there by the altar of incense."
,"20":"Azariah the chief priest and all the other priests turned toward him and saw the leprosy on his forehead. They quickly hurried him out, and he himself was anxious to go, since Yahweh had punished him."
,"21":"King Uzziah was a leper till his dying day. He lived in an isolated house, a leper, excluded from Yahweh's House. Jotham, his son, was master of the palace, and ruled the people of the country."
,"22":"The rest of the history of Uzziah, from first to last, has been written by the prophet Isaiah son of Amoz."
,"23":"Then Uzziah rested with his ancestors and they buried him in the ground where the tomb of the kings is, for they said, 'He is a leper.' His son Jotham succeeded him."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Jotham was twenty-five years old when he became king and he reigned for sixteen years in Jerusalem. His mother was Jerushah, daughter of Zadok."
,"2":"He did what is pleasing to Yahweh, just as his father Uzziah had done. But he did not enter the sanctuary of Yahweh. As for the people, they went on sinning."
,"3":"He built the Upper Gate of Yahweh's House and carried out considerable work on the wall of the Ophel."
,"4":"He built towns in the highlands of Judah, and fortified places and towers in the fertile lands."
,"5":"He fought against the king of the Ammonites. He defeated them, and that year the Ammonites gave him four tons of silver, fifty thousand bushels of wheat and ten thousand of barley. And they had to pay him the same for the second and third years."
,"6":"Jotham became powerful because he faithfully obeyed Yahweh his God."
,"7":"The rest of the deeds of Jotham, all his wars and his policy, are recorded in the Book of the Kings of Israel and Judah."
,"8":"He was twenty-five years old when he became king and he reigned for sixteen years in Jerusalem."
,"9":"Then Jotham rested with his ancestors and they buried him in the City of David; his son Ahaz succeeded him."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Ahaz was twenty years old when he became king, and he reigned for sixteen years in Jerusalem. He did not do what is pleasing to Yahweh, as his ancestor David had done."
,"2":"He followed the example of the kings of Israel, and even had Baal's idols made of metal."
,"3":"He offered incense in the Valley of Ben-Hinnom and even sacrificed his own sons as burnt offerings to disgusting idols, copying the shameful practice of the people whom Yahweh had driven out of the land he would give to the Israelites."
,"4":"He offered sacrifices and incense at the High places, on the hills and under every spreading tree."
,"5":"Yahweh his God let the King of the Aramaeans defeat him and take great numbers of his people captive, carrying them off to Damascus. He was also delivered into the power of the king of Israel, who defeated him."
,"6":"In a single day, Pekah son of Remaliah killed a hundred and twenty thousand in Judah, all brave fighting men; this was because they had abandoned Yahweh, the God of their ancestors."
,"7":"Zichri, an Ephraimite champion, killed Maaseiah, son of the king, Azrikam the controller of the palace, and Elkanah the king's second-in-command."
,"8":"The Israelites took two hundred thousand of their Judaean brothers captive, with wives, sons, and daughters; they also took quantities of loot, carrying everything off to Samaria."
,"9":"A prophet of Yahweh, named Oded, was there and he went out to meet the troops returning to Samaria and said, 'Yahweh, the God of your ancestors, was angry with Judah and so he delivered them into your power, but you have slaughtered with such fury as reaches to heaven."
,"10":"And you intended to make the men and women of Jerusalem and Judah your slaves. But you yourselves are also guilty before Yahweh your God."
,"11":"Now listen to me: release the prisoners you have taken of your brothers, or Yahweh will punish you in his anger.'"
,"12":"Some of the Ephraimite chieftains then stood up in opposition to those who returned from the war: Azariah son of Jehohanan, Berechiah son of Meshillemoth, Jehizkiah son of Shallum and Amasa son of Hadlai."
,"13":"They said, 'You must not bring the captives in here for we are guilty enough before Yahweh. Will you add to our sins and to our guilt? But our guilt is already heavy and the fierce anger of Yahweh is hanging over Israel.'"
,"14":"So in the presence of the officials and of the whole assembly, the army gave up the captives and the loot."
,"15":"Four men were appointed to provide the prisoners with clothing. From the loot they clothed all those who were naked; they gave them clothing and sandals, provided them with food and drink, and washed them. Those who were too weak to walk they put on donkeys and took them back to their kinsmen at Jericho, the city of palm trees. Then they returned to Samaria."
,"16":"It was then that King Ahaz sent asking the kings of Assyria to come to his assistance,"
,"17":"for the Edomites once again invaded and defeated Judah, and carried off prisoners."
,"18":"The Philistines were raiding the towns in the lowlands and in the Negeb of Judah. They took Bethshemesh, Aijalon, Gederoth, and Soco with its outlying villages, Timnah with its outlying villages, Gimzo with its outlying villages, and they settled in them."
,"19":"Yahweh humbled Judah on account of Ahaz, king of Israel, who let Judah go its own way and was not faithful to Yahweh."
,"20":"Tiglath-pileser king of Assyria attacked and besieged him but could not defeat him."
,"21":"Ahaz however had to take part of the goods in Yahweh's House and in the palaces of the king and princes, to hand over to the king of Assyria, yet he received no help from him."
,"22":"During the time Jerusalem was under siege, King Ahaz sinned against Yahweh more than ever,"
,"23":"by offering sacrifices to the gods of Damascus who had defeated him. He said, 'Since the gods of the kings of Aram have been of help to them, I will sacrifice to them so that they may be of help to me.' But they proved to be his downfall and that of Israel."
,"24":"Ahaz then took implements of the House and broke them in pieces; he closed the doors of Yahweh's House and put up altars at every street corner in Jerusalem;"
,"25":"he set up High places in every town of Judah to offer incense to other gods, and so brought on himself the anger of Yahweh, the God of his ancestors."
,"26":"The rest of his history, his whole policy, from first to last, is recorded in the Book of the Kings of Judah and Israel."
,"27":"Then Ahaz rested with his ancestors and they buried him in the city, in Jerusalem, though he was not taken into the tombs of the kings of Israel. His son Hezekiah succeeded him."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Hezekiah became king when he was twenty-five years old and reigned for twenty-nine years in Jerusalem. His mother was Abijah, daugther Zechariah."
,"2":"He did what is pleasing to Yahweh, just as his ancestor David had done."
,"3":"In the first month of the first year of his reign, he reopened the gates of Yahweh's House and repaired them."
,"4":"Then he brought the priests and the Levites, assembled them in the eastern square,"
,"5":"and said to them: 'Listen to me, Levites! Sanctify yourselves now and consecrate the house of Yahweh, the God of our ancestors, and remove from the House everything that defiles it. "
,"6":"Your ancestors have been unfaithful and have done what is displeasing to Yahweh our God. They have abandoned him; they have turned their faces away from the place Yahweh has made his home, they have turned their backs on him."
,"7":"They have even closed the doors of the Vestibule, they have put out the lamps and offered neither incense nor burnt offerings to the God of Israel in the Sanctuary."
,"8":"So the anger of Yahweh has fallen on Judah and Jerusalem; and what he has done to them has shocked and frightened everyone, as you can see for yourselves."
,"9":"This is why our ancestors have fallen by the sword, and our sons, our daughters, and our wives have been taken captive."
,"10":"But now I have decided to make a covenant with Yahweh, the God of Israel, so that his fierce anger may be turned away from us."
,"11":"My sons, be negligent no longer, for Yahweh has chosen you to stand in his presence and serve him, to worship him, and offer him incense.'"
,"12":"The Levites set to work: Mahath son of Amasai and Joel son of Azariah, of the Kohathites; Kish son of Abdi and Azariah son of Jehallelel of the Merarites; Joah son of Zimmah and Eden son of Joah of the Gershonites;"
,"13":"Shimri and Jeuel of the sons of Elizaphan; Zechariah and Mattaniah of the sons of Asaph;"
,"14":"Jehiel and Shimei of the sons of Heman; and Shemaiah and Uzziel of the sons of Jeduthun."
,"15":"They gathered their fellow Levites together, purified them, and in obedience to the king's order and in accordance with the words of Yahweh, they began consecrating in the Temple of Yahweh."
,"16":"The priests went inside the house of Yahweh to make it clean. They brought everything unclean they found in the sanctuary of Yahweh, out into the court of Yahweh's House, and the Levites collected it and carried it outside, into the Kidron Valley."
,"17":"They began this consecration on the first day of the first month, and were able to enter the Hall of Yahweh on the eight of the month; they then took eight days to consecrate Yahweh's House, and finished on the sixteenth day of the first month."
,"18":"They then went into the palace of King Hezekiah and said, 'We have purified the whole Temple of Yahweh, the altar for burnt offerings with all its furnishings, and the table on which the rows of bread are set with all its furnishings."
,"19":"All the furnishings King Ahaz took away during those years he was unfaithful to Yahweh we have put back and consecrated; they are now in front of the altar of Yahweh.'"
,"20":"King Hezekiah lost no time but called the officials of the city together and went up to Yahweh's House."
,"21":"They brought seven bulls, seven rams and seven lambs, with seven he-goats as a sacrifice for sin on behalf of the royal house, of the sanctuary, and of Judah. The king then told the priests, the sons of Aaron, to offer the burnt offering on the altar of Yahweh."
,"22":"They slaughtered the bulls and the priests took up the blood and poured it on the altar. They then slaughtered the rams and poured their blood on the altar."
,"23":"Then they brought the he-goats, the sacrifice for sin, before the king and the assembly who laid their hands on them."
,"24":"The priests slaughtered them, and with their blood on the altar offered a sacrifice to take away the sin of all the people - since the king had ordered the burnt offering and the sacrifice for sin on behalf of all Israel."
,"25":"He then ordered the Levites to stand in Yahweh's House with cymbals, harps and lyres, in accordance with the ordinances of David, of Gad the king's prophet and of Nathan the prophet; the order had in fact come from Yahweh through his prophets."
,"26":"When the Levites had taken their places with David's musical instruments, and the priests with their trumpets,"
,"27":"Hezekiah ordered the burnt offering to begin, the hymns of Yahweh began too, and the trumpets sounded, to the accompaniment of the instruments of David king of Israel."
,"28":"The whole assembly worshiped, cantors singing, trumpets sounding, until the holocaust was over."
,"29":"When the offering was at an end, the king and all there with him fell to their knees and worshiped."
,"30":"Then King Hezekiah and the officials told the Levites to sing praise to Yahweh in the words of David and of Asaph the prophet; they sang praises till their joy was full and then they fell down and worshiped."
,"31":"Hezekiah spoke again, 'Now you are dedicated to the service of Yahweh. Come forward, bring sacrifices and thanksgiving offerings into Yahweh's House.' The assembly brought sacrifices and thanksgiving offerings: all the generous people brought burnt offerings."
,"32":"The number of victims for these burnt offerings was seventy bulls, a hundred rams and two hundred lambs, all as burnt offerings for Yahweh;"
,"33":"six hundred bulls and three hundred sheep were sacrificed."
,"34":"The priests were too few, however, and could not slaughter all these animals, so the Levites helped them until the work was done and the other priests were sanctified; for the Levites were more educated than the priests regarding the requirements of purification."
,"35":"There were indeed many burnt offerings besides the fat of the peace offerings which was to be burnt together with the drink offerings. So was completed the consecration of Yahweh's House. Hezekiah and all the people rejoiced that God had helped the people to act so promptly."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Hezekiah sent messengers to all Judah and Israel (for he also wrote letters to Ephraim and Manasseh), inviting them to come to Yahweh's House in Jerusalem to celebrate a Passover in honor of Yahweh, the God of Israel."
,"2":"The king and his officials and all the assembly in Jerusalem had agreed to celebrate it in the second month,"
,"3":"being unable to celebrate it at the proper time, since the priests had not purified themselves in sufficient numbers, and the people had not assembled in Jerusalem."
,"4":"The king and all the assembly were pleased with their plan."
,"5":"They issued a decree to be proclaimed throughout Israel, from Dan to Beer-sheba, calling all the people to come to Jerusalem and celebrate a Passover in honor of Yahweh, the God of Israel, for they had not celebrated it for a long time."
,"6":"Messengers went out with letters from the hands of the king and his officials for every part of Israel and Judah. They had orders from the king to say, 'People of Israel, come back to Yahweh the God of Abraham, of Isaac, of Israel, and he will come back to those of you who are left and have escaped the grasp of the kings of Assyria."
,"7":"Do not be like your fathers and brothers who were unfaithful to Yahweh, the God of their ancestors, and whom he punished severely as you can see."
,"8":"Do not harden your hearts as your ancestors did, but reconcile with Yahweh and come to his house which he has consecrated forever. Serve Yahweh your God and he will turn his fierce anger from you."
,"9":"If you come back sincerely to Yahweh, your brothers and your sons will win the mercy of their conquerors and return to this land, for Yahweh your God is gracious and merciful. If you come back to him, he will not turn his face from you.'"
,"10":"The messengers went from town to town through the land of Ephraim and Manasseh, but the people laughed at them and made fun of them,"
,"11":"though a few men from Asher and Manasseh and Zebulun were humble enough to come to Jerusalem."
,"12":"But in Judah, the hand of God was upon the people and made them of one mind to obey the order of the king and the officials according to the word of Yahweh."
,"13":"A great number of people gathered in Jerusalem to celebrate the feast of Unleavened Bread in the second month. A very great assembly"
,"14":"set to work removing the altars that had been used in Jerusalem and all the altars for burning incense, and throwing them into the wadi Kidron."
,"15":"They killed the lambs for the passover sacrifice on the fourteenth day of the second month. The priests and the Levites felt ashamed; so they sanctified themselves and were able to bring burnt offerings into Yahweh's House."
,"16":"Then they took up their places in the House according to the instructions in the Law of Moses, the man of God. The priests poured out the blood handed to them by the Levites,"
,"17":"since there were many people in the assembly who had not sanctified themselves; so the Levites were to slaughter the Passover lambs on behalf of those who lacked the requisite purity in order to consecrate them to Yahweh."
,"18":"For many people, especially from Ephraim, Manasseh, Issachar and Zebulun, had not purified themselves and so had eaten the Passover without observing the regulations. But Hezekiah interceded for them, saying, "
,"19":"'Yahweh, God of our ancestors, in your goodness forgive those who seek you with all their heart, even though they are not clean.'"
,"20":"Yahweh heard Hezekiah and left the people unharmed."
,"21":"For seven days the Israelites rejoiced and celebrated in Jerusalem the feast of Unleavened Bread, while each day the Levites and the priests praised Yahweh with all their might."
,"22":"At the end Hezekiah encouraged the Levites who had shown themselves skilled in the worship of Yahweh."
,"23":"Then all the assembly agreed to continue the celebrations for a further seven days which they made seven days of rejoicing."
,"24":"Hezekiah king of Judah had provided a thousand bulls and seven thousand sheep for the assembly, and the officials another thousand bulls and ten thousand sheep, and now the priests were ready in great numbers."
,"25":"So the whole assembly of Judah rejoiced, the priests too, and the Levites, and all who had come from Israel, the refugees of Israel living in Judah and the people of Judah."
,"26":"There was great rejoicing in Jerusalem, for since the time of Solomon son of David, king of Israel, nothing like this had happened in Jerusalem."
,"27":"The levitical priests began to bless the people. Their voices were heard and their prayer received in heaven, His holy dwelling place."
}`)
	CurrentBook.AddChapter(31, `{
"1":"When all this was over, all the Israelites who were there set off for the towns of Judah to smash the pillar, cut down the sacred trunks and wreck the High places and the altars. So they did throughout Judah, Benjamin, Ephraim, and Manasseh and did away with them. Then all the Israelites returned to their towns, each man to his home."
,"2":"Hezekiah reestablished the priestly and levitical orders, each man in his proper order according to his duties, whether priest or Levite, whether for burnt offering, peace offering, liturgical service, thanksgiving or praise, within the gates of the camp of Yahweh."
,"3":"The king set aside a portion of his own possessions for the morning and evening burnt offerings, and the burnt offerings of sabbath, New Moon, and solemn feast, as laid down in the Law of Yahweh."
,"4":"He then told the people of Jerusalem to give the priests and the Levites their share so that they might devote themselves to the Law of Yahweh."
,"5":"As soon as the order had been published, the Israelites gathered in the first fruits of corn, wine, oil, honey, and all agricultural produce, and brought in a generous gift of everything."
,"6":"The Israelites and Judaeans living in the towns of Judah also brought in the tithe of cattle and sheep, and the tithe of the holy things dedicated to Yahweh their God, piling them up, heap after heap."
,"7":"They began making these heaps in the third month and finished them in the seventh."
,"8":"When Hezekiah and his officials saw how much had been given, they praised Yahweh and praised his people Israel."
,"9":"Hezekiah questioned the priests and the Levites about the heaps,"
,"10":"and Azariah, the chief priest, of the family of Zadok, answered him, 'Since the contributions were first brought to Yahweh's House, we have had enough to eat and still have plenty left over, for Yahweh has blessed his people; this huge pile is what is left.'"
,"11":"Hezekiah then ordered them to have storerooms prepared in Yahweh's House. They did this,"
,"12":"and then brought in the contributions, tithes and consecrated things, to keep them in a safe place. Conaniah the Levite was officer-in-charge of them, with Shimei his brother as his assistant."
,"13":"Jehiel, Azaziah, Nahath, Asahel, Jerimoth, Jozabad, Eliel, Ismachiah, Mahat, and Benaiah were appointed supervisors under the command of Conaiah and his brother Shimei, by order of King Hezekiah and of Azariah the High Priest."
,"14":"Kore, son of Imnah the Levite, keeper of the eastern gate, was made responsible for the voluntary offerings to God; he provided the portion set aside for Yahweh and the most holy offerings."
,"15":"Under his command he had Eden, Miniamin, Jeshua, Shemaiah, Amariah and Shecaniah, who resided permanently in the towns of the priests to distribute these gifts to their kinsmen great or small according to their orders."
,"16":"In addition to this, there was the organization by related groups of all those men thirty years old or older who went to Yahweh's House, by daily rotation, to perform the ritual duties appropriate to their orders."
,"17":"There was also the organization of priests by families; as also that of Levites twenty years old or older, by duties and orders."
,"18":"There was also the organization of all their families for the whole assembly, since they were busy with the holy ministry."
,"19":"As regards the priests, the sons of Aaron, who lived in the pasture lands belonging to their towns, or in the towns themselves, appointed men, distributed the food to every male among the priests and also to the inscribed Levites who were enrolled."
,"20":"Hezekiah enforced these arrangements throughout Judah. He did what is good and right and loyal before Yahweh his God."
,"21":"He was successful, because everything he did for the Temple or in observance of the Law, he did as one seeking God with all his heart."
}`)
	CurrentBook.AddChapter(32, `{
"1":"After Hezekiah had faithfully done all this, Sennacherib king of Assyria invaded Judah. He pitched camp before the fortified towns and gave orders for his army to break their way through the walls."
,"2":"Hezekiah realized that Sennacherib intended to attack Jerusalem also,"
,"3":"so he summoned his officers and champions and they decided to cut off the water supply from the springs situated outside the city."
,"4":"So a large number of people banded together to block all the springs and cut off the watercourse flowing through the fields. They said, 'Why should the king of Assyria find plenty of water when he arrives?'"
,"5":"Hezekiah strengthened his defenses: he had the broken parts of the wall repaired, built towers on it, constructed a second wall on the outer side, strengthened the Millo of the City of David and made quantities of spears and shields."
,"6":"He then appointed generals to command the people, had them assemble in the square by the city gate and spoke as follows to encourage them,"
,"7":"'Be strong and stand firm; be fearless, be confident when you face the king of Assyria and the whole army he brings with him, since he that is with us is stronger than he that is with him."
,"8":"He has only an arm of flesh, but we have Yahweh our God to help us and fight our battles.' The people were encouraged by the words of Hezekiah king of Judah."
,"9":"Next, Sennacherib king of Assyria, who was then outside Lachish with all his army, sent his servants to Jerusalem, to Hezekiah king of Judah, and to all the Judaeans who were in Jerusalem. They said,"
,"10":"'Hear the message from Sennacherib king of Assyria, 'What gives you the confidence to stay in Jerusalem under siege?"
,"11":"Is not Hezekiah deceiving you? Is he not condemning you to die of hunger and thirst when he says: Yahweh our God will save us from the king of Assyria?"
,"12":"Is not Hezekiah the very man who has destroyed the High places and the altars of Yahweh, and given the order to Judah and to Jerusalem: Before one altar only are you to worship, and on that alone offer incense?"
,"13":"Do you not know what I have done, I and my ancestors, to all the peoples of other countries? Have the gods of any nation in those countries ever been able to save them from me?"
,"14":"Who among all the gods of those nations was able to save his people from me?"
,"15":"Do not let Hezekiah deceive you. Do not let him mislead you like this. Do not believe him, for no god of any nation or kingdom has been able to save his people from me or from my ancestors. No more will your god be able to save you from me.'"
,"16":"His officials were still speaking against Yahweh God, and his servant Hezekiah,"
,"17":"when Sennacherib wrote a letter insulting Yahweh the God of Israel. This is what he said about him, 'Just as the gods of the nations in other countries have failed to save their peoples from me, so will the god of Hezekiah fail to save his people.'"
,"18":"They shouted this out in the language of Judah, to the people of Jerusalem who were on the city wall, to confuse and frighten them, and so that they might capture the city:"
,"19":"they spoke of the God of Jerusalem in the same way they talked of the gods of the peoples of the world, the work of human hands."
,"20":"Then King Hezekiah and the prophet Isaiah son of Amoz prayed and cried out to heaven."
,"21":"And Yahweh sent an angel who made all the mighty warriors, commanders and officers die in the camp of the king of Assyria. So the emperor went back to Assyria very ashamed. And as he came into the temple of his god, some of his own sons struck him with their swords."
,"22":"So Yahweh saved Hezekiah and the people of Jerusalem from the power of Sennacherib king of Assyria and from everyone else, and he gave them peace on every side."
,"23":"Many people brought grain offerings to Yahweh in Jerusalem and gifts for Hezekiah king of Judah; since then all the nations held Hezekiah in honor."
,"24":"In those days, Hezekiah fell ill and was at the point of death. He prayed to Yahweh, who heard him and granted him a sign."
,"25":"But Hezekiah did not show gratitude for what Yahweh had done for him; his heart grew proud and Judah and Jerusalem suffered for it."
,"26":"Finally, however, Hezekiah and the people of Jerusalem humbled themselves, and so Yahweh did not punish the people until after Hezekiah's death."
,"27":"Hezekiah enjoyed immense riches and honor. He built himself storerooms for gold, silver, precious stones, spices, gems and every sort of valuable."
,"28":"He had storehouses for his returns of corn, wine and oil, buildings for his different sorts of cattle, and sheep runs for his sheep,"
,"29":"and, further, acquired donkeys and enormous herds and flocks. God had indeed given him very great riches."
,"30":"It was Hezekiah who stopped the upper outlet of Gihon Spring and channeled the water down to the west side of the City of David. Hezekiah succeeded in all he undertook."
,"31":"However, when the authorities in Babylon sent to him to inquire about the extraordinary thing that had taken place in the country, God abandoned him only to test him, and to discover the secrets of his heart."
,"32":"The rest of the history of Hezekiah, and his deed of piety, are recorded in the Vision of the prophet Isaiah son of Amoz and in the Book of the Kings of Judah and Israel."
,"33":"Then Hezekiah rested with his fathers and they buried him on the slope going up to the tombs of the sons of David. At his death, all of Judah and the inhabitants of Jerusalem did him honor. His son Manasseh succeeded him."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Manasseh was twelve years old when he came to the throne and he reigned for fifty-five years in Jerusalem."
,"2":"He did what was evil in the eyes of Yahweh, and followed the disgusting practices of the nations that Yahweh had removed from the land before giving it to Israel,"
,"3":"He rebuilt the High places his father Hezekiah had wrecked; he set up altars to the Baals and made sacred trunks. He worshiped the whole array of heaven and served it."
,"4":"He built altars in Yahweh's House of which Yahweh had said, 'In Jerusalem shall my Name be forever.'"
,"5":"He built altars to the whole array of heaven in the two courts of Yahweh's House."
,"6":"He caused his sons to pass through the fire in the Valley of Benhinnom. He practiced soothsaying, magic and witchcraft, and introduced necromancers and wizards. He did many things displeasing to Yahweh, thus provoking his anger."
,"7":"He placed the idol he had made in the house of which God had said to David and to his son Solomon, 'In this house and in Jerusalem, the city I chose out of all the tribes of Israel, I will give my Name a home forever."
,"8":"I will no longer turn Israel's footsteps away from the land I assigned to their fathers, provided they observe all I have ordered them in accordance with the whole Law, the statutes and the ordinances, given through Moses.'"
,"9":"Manasseh led Judah and the inhabitants of Jerusalem astray, so that they did more evil than those nations Yahweh had destroyed before the sons of Israel."
,"10":"Yahweh spoke to Manasseh and his people, but they paid no attention."
,"11":"Then Yahweh sent the generals of the king of Assyria against them, who captured Manasseh with hooks, put him in chains and led him away to Babylon."
,"12":"In his distress he sought to appease Yahweh his God. Humbling himself deeply before the God of his ancestors, he prayed to him,"
,"13":"and God changed his mind. Hearing his plea he allowed him to come back to Jerusalem and reign again. Manasseh realised then that Yahweh is God."
,"14":"After that he rebuilt the outer wall of the Citadel of David, west of Gihon in the wadi, as far as the Fish Gate; it encircled the Ophel, and he increased its height very considerably. He stationed military governors in all the fortified towns of Judah."
,"15":"He removed the alien gods and the idol from Yahweh's House and all the altars he had built on the mountain of Yahweh's House and in Jerusalem, and threw them out of the city."
,"16":"He rebuilt the altar of Yahweh and offered peace offerings and praise offerings on it, and ordered Judah to serve Yahweh the God of Israel;"
,"17":"however, the people continued to sacrifice on the High places, although only to Yahweh their God."
,"18":"The rest of the history of Manasseh, his prayer to God, and the words of the seers who spoke to him in the name of Yahweh the God of Israel, can be found in the Annals of the Kings of Israel."
,"19":"His prayer and how God heard his prayer, all his sins, his unfaithfulness, the sites where he built High places and set up sacred trunks and idols before he humbled himself are recorded in the Annals of Hozai."
,"20":"Then Manasseh rested with his ancestors and was buried in his palace. His son Amon succeeded him."
,"21":"Amon was twenty-two years old when he became king and he reigned for two years in Jerusalem."
,"22":"He did what is displeasing to Yahweh, as Manasseh his father had done. Amon offered sacrifice and worship to all the idols Manasseh his father had made,"
,"23":"but he did not humble himself before Yahweh like Manasseh his father had done; instead he made the guilt of Judah worse."
,"24":"His officers plotted against him and killed him in his palace. But the people of the nation struck down all those who had plotted against King Amon and proclaimed his son Josiah as his successor."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Josiah was eight years old when he became king and he reigned for thirty-one years in Jerusalem."
,"2":"He did what is pleasing to Yahweh, and walked in the ways of his father David, without turning aside."
,"3":"In the eighth year of his reign, when he was still a youth, he began to seek the God of his father David. In the twelfth year he began to purge Judah and Jerusalem of the High places, the sacred trunks and the molten idols."
,"4":"He looked on while they smashed the altars of Baal, and he himself tore down the incense altars near them. He reduced to dust the symbols of Asherah and the other idols and then threw the dust over the graves of those who had sacrificed to them."
,"5":"He burned the bones of their priests on their altars, and so purified Judah and Jerusalem."
,"6":"He did the same in the towns of Manasseh, Ephraim, Simeon, and as far as Naphtali, and in the devastated areas around them."
,"7":"There too he destroyed the altars and symbols of the goddess, smashed the sacred trunks and the idols and ground them to powder, and tore down all the altars of incense throughout the land of Israel. Then he returned to Jerusalem."
,"8":"In the eighteenth year of his reign, with the object of purifying land and Temple, he sent Shaphan son of Azaliah, Maaseiah governor of the city and the herald Joah son of Joahaz, to repair the house of Yahweh his God."
,"9":"These men went to the high priest Hilkiah and handed over to him the money that had been brought to the house of God. The Levite gatekeepers had collected this money from Manasseh, Ephraim and all the rest of Israel, and from all the Judaeans and Benjaminites and from the people living in Jerusalem."
,"10":"They handed it over to the masters of works of Yahweh's House and these men used it for the repair and restoration of the House."
,"11":"They gave it to the carpenters and builders for buying the stones and timber for the beams and framework of the buildings which the kings of Judah had let go to ruin."
,"12":"The men worked conscientiously. Over them were set Jahath and Obadiah, Levites of the sons of Merari; together with Zechariah and Meshullam of the sons of Kohath, as supervisors. These Levites were all skilled liturgical musicians;"
,"13":"but they also directed the carriers and the masters of works of the various jobs. Other Levites were scribes, clerks and gatekeepers."
,"14":"When they were taking out the money that had been brought to Yahweh's House, Hilkiah the high priest found the book of the Law given through Moses."
,"15":"At once Hilkiah told Shaphan the secretary, 'I have found the book of the Law in Yahweh's House.' And Hilkiah gave the book to Shaphan."
,"16":"Shaphan took the book to the king, and reported to him, 'Your servants are carrying out the commands you gave them:"
,"17":"they have melted down the silver which was in Yahweh's House and have handed it over to the supervisors and masters of works.'"
,"18":"After which Shaphan the secretary informed the king, 'Hilkiah the priest has given me a book'; and Shaphan read from it in the king's presence."
,"19":"When the king heard the book being read, he tore his garments,"
,"20":"and gave the following order to Hilkiah, Ahikam son of Shaphan, Abdon son of Micah, Shaphan the secretary and Asaiah the king's minister,"
,"21":"'Go and consult Yahweh, for me and for the people who still remain in Israel and Judah, about the words of the book that has been found. Great indeed must be the anger of Yahweh to be poured down on us because our ancestors did not observe the word of Yahweh nor do according to what is written in this book.'"
,"22":"Hilkiah and the king's men went to Huldah the prophetess, wife of Shallum son of Tokhath, son of Hasrah, the keeper of the Temple robes; she lived in Jerusalem in the new town. They spoke to her about this,"
,"23":"and she answered, 'This is the word of Yahweh for the man who sent you to me:"
,"24":"I am going to punish Jerusalem and all its people, carrying out all the curses written in the book that has been read in the presence of the king of Judah,"
,"25":"because they have abandoned me and have burned incense to other gods, stirring up my anger by everything they have done. Because of this my anger is aroused against Jerusalem, and it will not die down."
,"26":"And you will tell the king of Judah who sent you to consult Yahweh, that thus answers Yahweh, the God of Israel, regarding the words you have heard:"
,"27":"Since your heart has been touched and you have humbled yourself before God on hearing what he has threatened against Jerusalem and those who live in it, since you have humbled yourself before me and torn your garments and wept before me, I for my part have heard - this is Yahweh's word."
,"28":"The punishment which I am going to bring on Jerusalem will not come until after your death. I will let you die in peace.' They took this answer to the king."
,"29":"The king then had all the elders of Judah and of Jerusalem summoned,"
,"30":"and the king went up to Yahweh's House, with all the people of Judah and the inhabitants of Jerusalem, priests, Levites and all the people, great and small alike. In their hearing he read out everything that was said in the book of the covenant found in Yahweh's House."
,"31":"The king stood beside the pillar, and in the presence of Yahweh he made a covenant to follow Yahweh and to keep his laws and commands with all his heart and soul, as written in that book."
,"32":"He committed everyone there in Jerusalem or in Benjamin to obey the requirements of the covenant of God, the God of their ancestors."
,"33":"Josiah removed all the disgusting idols throughout the territories belonging to the people of Israel. For the rest of his life he made sure that every member of Israel served their God. They did not fail to follow Yahweh, the God of their ancestors."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Josiah then celebrated a Passover in honor of Yahweh in Jerusalem and they killed the passover lamb on the fourteenth day of the first month."
,"2":"He appointed certain functions to the priests and let them discharge the duties of Yahweh's House."
,"3":"Then he said to the Levites, who were to instruct all Israel and who were consecrated to Yahweh, 'The holy ark has been put in the house built by Solomon son of David, king of Israel, and it is no longer a burden for your shoulders. So you shall serve Yahweh your God and Israel your people in this way."
,"4":"Stand in the holy place by families and orders, according to the written decree of David king of Israel and his son Solomon,"
,"5":"and let some be available to help each family of the people of Israel; for the Levites are to have a portion in each family."
,"6":"Kill the animals for the festival, sanctify yourselves, and be at the disposal of your brothers in acting in accordance with the word of Yahweh which was spoken through Moses.'"
,"7":"Josiah then provided for the use of the people, lambs and kids from the flocks to the number of thirty thousand, all as Passover offerings for all who were present, and three thousand bulls as well; all these animals came from the king's possessions."
,"8":"His officials, for their part, made provision for what the people, the priests and the Levites would use. The senior officials of the house of God, Hilkiah, Zechariah and Jehiel, also gave the priests two thousand six hundred lambs and kids and three hundred bulls as Passover victims."
,"9":"The heads of the Levites, Conaniah, Shemaiah and his brothers Nathanel, Hashabiah, Jeiel and Jozabad, provided five thousand lambs and kids and five hundred bulls as Passover victims for the Levites."
,"10":"When everything for the Passover had been prepared, the priests took their posts, and the Levites also in their orders as commanded by the king."
,"11":"They killed the lambs and goats, and while the priests sprinkled the blood they received, the Levites cut up the victims."
,"12":"They put aside the animals for the burnt offering and distributed to family groupings of the lay people, giving to each his offering to Yahweh, as is written in the Book of Moses; they did the same with the bulls."
,"13":"They roasted the passover, as ordained, and boiled the sacred foods in pots, dishes, and pans, carrying them speedily to the people."
,"14":"Afterward they prepared the passover for themselves and for the priests. Because the priests, the sons of Aaron, had been busy till nightfall offering the burnt offering and the fatty parts, the Levites prepared the passover for themselves and for the priests, the sons of Aaron."
,"15":"The musicians, the sons of Asaph, were at their places, in accordance with the ordinances of David; neither Asaph, Heman, Jeduthun the king's prophet, nor the keepers of each gate had to leave their duties, since their brothers the Levites made all the preparations for them."
,"16":"So the whole service of Yahweh was prepared that day to celebrate the Passover and to offer burnt offerings on the altar of Yahweh, in accordance with the ordinances of King Josiah."
,"17":"The Israelites who were present celebrated the Passover and, for seven days, the feast of Unleavened Bread."
,"18":"No Passover like this one had ever been celebrated in Israel since the days of the prophet Samuel; no king of Israel had ever celebrated a Passover like the one celebrated by Josiah with the priests, the Levites, all of Judah and of Israel who were present, and the people of Jerusalem."
,"19":"This Passover was celebrated in the eighteenth year of the reign of Josiah."
,"20":"After all this, when Josiah had already repaired the House, Neco king of Egypt came up to fight at Carchemish on the Euphrates and Josiah marched out to stop him."
,"21":"Neco sent him messengers to say, 'There is no quarrel between me and you, king of Judah. I have not come today to attack you, but to fight my enemies, and God has told me to hurry. Do not oppose God who is with me, lest he destroy you.'"
,"22":"But Josiah continued to challenge him for he was determined to fight him, and would not listen to what God was saying through Neco. So he went out to fight in the plain of Megiddo."
,"23":"Egyptian arrows struck King Josiah, and the king said to his followers, 'Take me away; I am badly wounded.'"
,"24":"His servants lifted him out of his own chariot, transferred him to another one and took him back to Jerusalem, where he died. He was buried in the tombs of his ancestors. All Judah and Jerusalem mourned for Josiah."
,"25":"Jeremiah composed a lament for Josiah which all the women singers use when speaking of Josiah in their laments to this day; this has become a custom in Israel; the song is found in the collection of laments."
,"26":"The rest of the history of Josiah and all his good deeds according to the Law, and his acts from the first to last, are recorded in the Book of the Kings of Israel and Judah."
}`)
	CurrentBook.AddChapter(36, `{
"1":"The people of the nation took Jehoahaz, son of Josiah and made him king in Jerusalem in succession to his father."
,"2":"Jehoahaz was twenty-three years old when he became king and he reigned for three months in Jerusalem."
,"3":"The king of Egypt took him prisoner and made the people of Judah pay 7,500 pounds of silver and 75 pounds of gold as tribute."
,"4":"The king of Egypt then made Eliakim, brother of Jehoahaz, king of Judah and Jerusalem, and changed his name to Jehoiakim. Neco took his brother Jehoahaz to Egypt."
,"5":"Jehoiakim was twenty-five years old when he became king and he reigned for eleven years in Jerusalem. He did what was evil in the eyes of Yahweh his God."
,"6":"Nebuchadnezzar king of Babylon attacked him, put him in chains and carried him off to Babylon."
,"7":"Nebuchadnezzar also carried off to Babylon some of the treasures of the House and put them in his palace at Babylon."
,"8":"The rest of the history of Jehoiakim, the disgusting things he did and those discovered to his discredit, these are recorded in the Book of Kings of Israel and Judah. His son Jehoiakim succeeded him."
,"9":"Jehoiakim was eight years old when he became King and he reigned for three months and ten days in Jerusalem. He did what was evil in the eyes of Yahweh."
,"10":"When spring came, King Nebuchadnezzar sent for him and had him taken to Babylon as a prisoner, with the treasures of the temple and made Zedekiah, his brother, king of Judah and Jerusalem in his place."
,"11":"Zedekiah was twenty-one years old when he became king and he reigned for eleven years in Jerusalem."
,"12":"He did what was evil in the eyes of Yahweh his God. He did not listen humbly to the prophet Jeremiah, accredited by Yahweh himself."
,"13":"He also rebelled against King Nebuchadnezzar who had forced him to swear in God's name that he would be loyal. He became stubborn, and obstinately refused to return to Yahweh the God of Israel."
,"14":"Furthermore, all the heads of the priesthood, and the people, too, were exceedingly unfaithful, following the disgusting example of the nations around them, and so they defiled the house which Yahweh himself had made holy."
,"15":"Yahweh, the God of their ancestors, continued to send prophets to warn his people, since he had compassion on them and on his dwelling place."
,"16":"But they mocked the messengers of God, ignored his words, and laughed at his prophets, until at last the anger of Yahweh rose so high against his people that there was no further remedy."
,"17":"Then he brought against them the king of the Chaldeans who killed with the sword the young men of Judah even in the House; he spared neither youth nor virgin, neither old man nor aged cripple: God handed them all over to him."
,"18":"All the furnishings of the house of God, large and small, the treasures of Yahweh's House, the treasures of the king and his officials, he carried off to Babylon."
,"19":"They burned down the house of God, broke down the walls of Jerusalem, set fire to all its palaces, and destroyed everything of value in it."
,"20":"The survivors were deported by Nebuchadnezzar to Babylon; they were to serve him and his descendants as slaves until the kingdom of Persia came to power."
,"21":"This is how the work of Yahweh was fulfilled that he spoke through Jeremiah, 'The land will lie desolate for seventy years, to make up for its Sabbath rests that have not been observed.'"
,"22":"And in the first year of Cyrus king of Persia, to fulfill what he had said through the prophet Jeremiah, Yahweh stirred up the spirit of Cyrus king of Persia to issue the following command and send it out in writing to be read aloud everywhere in his kingdom:"
,"23":"'Thus speaks Cyrus king of Persia: Yahweh, the God of heaven, who has given me all the kingdoms of the earth, has ordered me to build him a house in Jerusalem, in Judah. Now, all of you who belong to his people, go there and may Yahweh your God be with you.'"
}`)

}
func EN_CCB_LoadVH2RChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"After the death of Ahab, Moab rebelled against Israel."
,"2":"In Samaria, King Ahaziah fell through the window from the second floor of his house and was badly injured. So he sent messengers to consult Baal-zebub, the god of Ekron, 'Ask him whether I shall survive this accident.'"
,"3":"Then an angel of Yahweh said to Elijah of the town of Tishbe, 'Arise, and go up to meet the messengers of the king of Samaria. You will say to them: Why have you come to consult Baal-zebub, the god of Ekron? Is it because there is no God in Israel?"
,"4":"Now Yahweh himself gives you this answer: You shall not rise again from the bed where you lay down, but shall die there.' So Elijah went."
,"5":"Then the messengers returned to Ahaziah who asked, 'How is it that you have returned?'"
,"6":"They answered, 'A man met us on the way, and he said to us: 'Return to the king who sent you and say to him in the name of Yahweh: Why do you send men to consult Baal-zebub, the god of Ekron? Is there no God in Israel? Because of this, you shall not rise again from the bed where you lay down, but shall die there.'"
,"7":"The king asked them, 'What was the appearance of the man who met you on the way and told you this?'"
,"8":"They answered him, 'The man wore a mantle of fur with a leather belt around his waist.' The king then said, 'He is Elijah from the town of Tishbe.'"
,"9":"Ahaziah sent a captain of fifty men who went up with his fifty men to get him. Elijah was seated at the top of the mountain. The captain said to him, 'Man of God, the king commands you to come down.'"
,"10":"Elijah answered the captain, 'If I am a man of God, then may fire come down from heaven and devour you and your men.' Fire came down from heaven and devoured him with his fifty men."
,"11":"The king again sent to him another captain of fifty who went up and said to him, 'Man of God, the king says that you are to come down at once.'"
,"12":"Elijah answered, 'If I am a man of God, then may fire come down from heaven and devour you and your men.' Fire came down from heaven and devoured them all."
,"13":"The king sent a third captain with his fifty men. This third one went up and as he came, he fell on his knees before Elijah and said to him, 'Man of God, I beg you to pardon me as well as my fifty men; we are all your servants."
,"14":"I have heard that fire came down from heaven twice and devoured the two captains with their fifty men. So now, do spare my life.'"
,"15":"Then the angel of Yahweh said to Elijah, 'Go down with him and do not be afraid.'"
,"16":"So he stood up and went down with them to the king. And Elijah said to the king, 'Listen to this word of Yahweh: Because you sent your messengers to consult Baal-zebub, the god of Ekron, you shall not rise again from the bed on which you lie but shall die there.'"
,"17":"Ahaziah died according to what Yahweh had said through the mouth of Elijah, and since he had no sons, his brother Jehoram reigned in his place in the second year of Jehoram, son of Jehoshaphat, king of Judah."
,"18":"Everything referring to Ahaziah and his deeds is written in the Book of the Chronicles of the Kings of Israel."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Yahweh took Elijah up to heaven in a whirlwind. It happened this way: Elijah and Elisha had left Gilgal, and Elijah said to Elisha,"
,"2":"'I beg you to stay here, for Yahweh is sending me to Bethel.' Elisha said, 'I swear by Yahweh and by your life that I will never leave you.' So they went down to Bethel together."
,"3":"The fellow prophets in Bethel went out to welcome Elisha and said to him, 'Don't you know that today Yahweh will take your master away from you?' He answered them, 'Yes, I also know it. So, be quiet.'"
,"4":"Elijah said to Elisha, 'Please stay here, for Yahweh is only sending me to Jericho.' Elisha answered, 'I swear by Yahweh and by your life that I will never leave you.'"
,"5":"So they went on to Jericho. The fellow prophets in Jericho approached Elisha and said to him, 'Do you not know that Yahweh is to take your master away today?' Elisha answered, 'Yes, I know it. Be quiet.'"
,"6":"Elijah said once more to Elisha, 'Stay here, I beg you, for Yahweh is only sending me to the Jordan.' But Elisha answered, 'I swear by Yahweh and by your life that I will never leave you.' And as they went on their way,"
,"7":"fifty fellow prophets of Jericho followed them at a certain distance. When Elijah and Elisha stood by the Jordan "
,"8":"Elijah took his mantle, rolled it, and struck the water with it. The water parted to both sides and they crossed over on dry ground."
,"9":"After they had crossed, Elijah said to Elisha, 'What shall I do for you before I am taken away from you? Ask me.' Elisha said, 'Grant that I may have the best of your spirit.'"
,"10":"Elijah answered, 'Your request is most difficult. Yet if you see me while I am being taken from you, then you shall have it. But if not, you shall not have it.'"
,"11":"As they were talking on the way, a chariot of fire with horses of fire stood between them, and Elijah was taken up to heaven in a whirlwind."
,"12":"Elisha saw him and cried out, 'Father, my father, chariots of Israel and its horsemen!',When Elisha lost sight of him, he took hold of his own clothes and tore them. "
,"13":"He then picked up the mantle which had fallen from Elijah and returned to the banks of the Jordan."
,"14":"There he struck the water with the mantle, but it did not part. So he asked, 'Where is Yahweh, the God of Elijah?' And as he struck the water again it parted. Elisha crossed over."
,"15":"The fellow prophets of Jericho saw him from the other side, and said, 'The spirit of Elijah rests upon Elisha.' And as they came to him, they bowed to the ground before him saying,"
,"16":"'There are fifty valiant men here with us. Let them go in search of Elijah, for it may be that the spirit of Yahweh has left him in some mountain or valley.' Elisha replied, 'Do not send anyone.'"
,"17":"But they insisted so much that Elisha let them go, and they sent fifty men to search for Elijah."
,"18":"After three days they had not found him and they returned to Elisha, who had stayed in Jericho. He commented, 'Did I not tell you not to go?'"
,"19":"The men of the city said to Elisha, 'The location of this city is good, as my lord can see, but the water is bad, and so the land is unproductive.'"
,"20":"He said to them, 'Bring me a new pot with salt in it.' When they brought it to him,"
,"21":"Elisha went to the fountain and threw salt in it saying, 'This is what Yahweh says: I have healed this water, never more will it cause death or sickness.'"
,"22":"And the water has remained wholesome to this day, just as Elisha said."
,"23":"From there, he went up to Bethel. He was on his way when some youths came out from the city and made fun of him saying, 'Go up, baldhead! Go up, baldhead!'"
,"24":"Elisha turned around, looked at them and cursed them in the name of Yahweh. At once, two she-bears came out of the forest and killed forty-two of them."
,"25":"From there Elisha set out for Mount Carmel, and from there he returned to Samaria."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Jehoram, son of Ahab, began to reign over Israel in Samaria in the eighteenth year of Jehoshaphat, king of Judah, and he reigned for twelve years."
,"2":"He did what was displeasing to Yahweh, but not as his father or mother had done, for he removed the statue of Baal which his father had made."
,"3":"Nonetheless he clung to the sin of Jeroboam, the son of Nebat, which had become the sin of Israel, and did not depart from it."
,"4":"Mesha, the king of Moab, had flocks of sheep. He paid the king of Israel a hundred thousand lambs and a hundred thousand rams with their wool annually."
,"5":"But when Ahab died, the king of Moab rebelled against the king of Israel."
,"6":"At that time, King Jehoram set out from Samaria to mobilize the whole of Israel."
,"7":"He also sent word to Jehoshaphat, the king of Judah, 'The king of Moab has rebelled against me; will you come with me to fight against Moab?' Jehoshaphat answered him, 'I will go with you, for you and I are one; my men and my horses are at your disposal.'"
,"8":"Jehoram asked, 'By which way shall we go up?' And he answered, 'By the way of the desert of Edom.'"
,"9":"The kings of Israel, of Judah and of Edom had been going around for seven days, and there was no water for the soldiers and for the animals that followed them."
,"10":"Then the king of Israel said, 'Yahweh has called us three kings to give us into the hands of Moab.'"
,"11":"Then Jehoshaphat asked, 'Is there no prophet of Yahweh here, through whom we may consult Yahweh?' One of the servants of the king of Israel said, 'Elisha, son of Shaphat, is here. It was he who poured water on the hands of Elijah.'"
,"12":"And Jehoshaphat agreed, 'Indeed, God's word comes to him.' So the king of Israel, the king of Edom and Jehoshaphat went down to Elisha."
,"13":"Elisha said to the king of Israel, 'What have I to do with you? Go see the prophets of your father or those of your mother.' But the king of Israel asked him, 'Has Yahweh perhaps called us three together to deliver us into the hands of Moab?'"
,"14":"Elisha replied, 'Had not Jehoshaphat the king of Judah been before me, I swear by Yahweh God of Hosts whom I serve, that I would not attend to you nor look at you."
,"15":"Now, bring me someone who plays the harp.' As the musician played, the hand of Yahweh came upon Elisha"
,"16":"and he said, 'This is the word of Yahweh: Dig trenches and more trenches in this valley,"
,"17":"for Yahweh says: You shall not see wind or rain, but the valley shall be filled with water, and you, your troops and your livestock will drink."
,"18":"This is an easy thing for Yahweh, for he shall give Moab into your hands."
,"19":"You shall conquer all the fortified cities, cut down all fruit-bearing trees, close up all the springs of water, and scatter stones in all the plowed fields.'"
,"20":"In the morning, at the time of the offering, water came from the direction of Edom, and the whole country was flooded."
,"21":"The Moabites had learned that the kings had come to attack them, so they gathered together all the men able to bear arms and positioned them at the border."
,"22":"When they woke up in the morning, they saw the sun shining upon the water, and this appeared to them as if it were blood."
,"23":"So the Moabites said, 'Look at the blood; the kings have surely turned against one another and killed each other. Let us now go and gather the booty!'"
,"24":"But when they came to the camp the Israelites confronted, defeated and routed them. The Israelites pursued and entered Moab."
,"25":"They destroyed the cities of Moab, and each man threw stones on the fertile land, until it was covered. They closed up the springs of water and cut down fruit trees. Only Kir-hareseth was left with stones, but men armed with slings, surrounded the city and began harassing it."
,"26":"When the king of Moab saw that his enemies were winning, he gathered seven hundred warriors to break through the blockade, opposite the king of Edom. But they did not succeed."
,"27":"So he took his firstborn son who was to succeed him as king, and sacrificed him in the fire upon the wall. The fury that came upon the Israelites was great, so they withdrew from there and returned to their own land."
}`)
	CurrentBook.AddChapter(4, `{
"1":"The widow of one of the fellow prophets called Elisha saying, 'You know that my husband feared God. But now his creditor has come to collect payment. And as we could not pay, he wanted to take my two sons as slaves.'"
,"2":"Elisha said, 'What can I do for you? Tell me what you have in your house?' She answered, 'I have but a little oil for cleaning.'"
,"3":"Elisha said to her, 'Go and ask your neighbors for empty jars."
,"4":"Get as many as you can; then go into your house with your sons and close the door. Pour oil into the vessels. And when they are filled, set them aside.'"
,"5":"The woman went and locked herself in her house with her sons. They handed her the vessels and she filled them all."
,"6":"She said to one of her sons, 'Bring me another vessel,' and he answered, 'There are no more.' Then the oil stopped flowing."
,"7":"As she went back to tell this to the man of God, he said to her, 'Go and sell the oil to pay for your debts; you and your sons can live on the money that is left.'"
,"8":"One day Elisha went to Shunem, and a rich woman invited him to eat. Afterwards, whenever he went to that town, he would go to her house to eat."
,"9":"The woman said to her husband, 'See, this man who constantly passes by our house is a holy man of God."
,"10":"If you want, we can make a small upper room for him, and place a bed, a table, a chair and a lamp in it. So when he comes, he may stay and rest.'"
,"11":"One day when Elisha came, he went to the upper room and lay down."
,"12":"Then he said to Gehazi, his manservant, 'Call this woman.' She came when called and stood before Elisha."
,"13":"Elisha said to her, 'You have taken all this trouble for us. Tell me: what then can we do for you? Would you like me to say something to the king or the commander of the army for you?' But she answered, 'I do not need anything in this land.'"
,"14":"So Elisha said to Gehazi, 'What can we do for her?' The young man answered, 'She has no children and her husband is now old.'"
,"15":"And so Elisha said to him, 'Call her.' The young man called her and as the woman stood by the door,"
,"16":"Elisha said, 'By this time next year, you will hold a son in your arms.' She answered, 'No, my lord, O man of God, you are deceiving your maidservant.'"
,"17":"But the woman gave birth to a son precisely at the time Elisha had told her."
,"18":"The boy grew. One day, when he had gone out to his father among the harvesters, he had a severe headache."
,"19":"So the father ordered his servant, 'Carry him to his mother.'"
,"20":"The servant brought him to his mother, and the boy sat on her lap till noon, when he died."
,"21":"Then the mother went up and laid him on Elisha's bed and she left, closing the door."
,"22":"Then she called her husband, 'Send me one of the servants with an ass. I am going to the man of God, and I will come back.'"
,"23":"He asked, 'Why are you going to him? It is not the new moon yet nor the sabbath.' But she said, 'Do not worry.'"
,"24":"She saddled the ass, and said to her servant, 'Lead on, and don't stop until I tell you.'"
,"25":"So she set off and arrived at Mount Carmel where the man of God was. Elisha saw her from afar, so he said to his servant, 'Here comes our Shunamite. "
,"26":"Run to meet her and ask: Are you well? How is your husband? And your son?' She answered, 'Everything is all right.'"
,"27":"She went to the man of God, and embraced his feet. Then Gehazi came to draw her away, but the man of God said to him, 'Leave her, for her soul is in bitter distress, and Yahweh has not made known to me nor has he revealed it to me.'"
,"28":"She said, 'Did I ask, my lord, for a son? Why have you deceived me?'"
,"29":"Elisha said to Gehazi, 'Get ready, take my staff and go. If you meet anyone, do not stop to greet him; and if someone greets you, do not greet him in return. And as soon as you arrive, place my staff on the boy's face.'"
,"30":"But the boy's mother said, 'I swear by Yahweh and by your life that I will not leave you.' So Elisha arose and followed her."
,"31":"Gehazi went on ahead and laid the staff on the boy's face, but the boy did not move or give any sign of life, so Gehazi returned to meet them and said, 'The boy has not revived.'"
,"32":"Elisha came into the house, and found the dead boy lying on his bed."
,"33":"He entered, closed the door behind him, and prayed to Yahweh."
,"34":"Then he lay upon the boy, put his mouth upon the boy's mouth, his eyes upon his eyes, his hands upon the boy's hands, and warmth returned to the boy's body."
,"35":"Elisha came down and began walking to and fro. Then he went upstairs to stretch himself upon the boy, and the boy sneezed seven times and opened his eyes."
,"36":"Elisha then called Gehazi and said, 'Call the woman.' And when she came, Elisha told her, 'Take your son.'"
,"37":"She bowed at his feet, then she took her son and went out."
,"38":"Elisha returned to Gilgal. There was great scarcity of food in the region, and when the fellow prophets came to sit with Elisha, he said to his servant, 'Take the big pot and prepare some broth for the fellow prophets.'"
,"39":"One of them went out into the field to gather herbs; he found a wild plant, from which he gathered poisonous fruits, enough to fill his cloak. When he came back, he cut them into pieces and put them in the pot where the broth was being prepared, for he did not know what they were."
,"40":"Then the broth was served to the men to eat. But as soon as they tasted the soup, they cried out, 'Man of God, this is pure poison!' So they did not eat any more."
,"41":"Then Elisha said, 'Bring me flour.' And he put it into the pot. Then he said, 'Serve these men and let them eat.' And there was no longer anything harmful in the pot."
,"42":"A man came from Baal-shalishad bringing bread and wheat to the man of God. These were from the first part of the harvest, twenty loaves of barley and wheat. Elisha told him, 'Give the loaves to these men that they may eat.'"
,"43":"His servant said to him, 'How am I to divide these loaves among one hundred men?' Elisha insisted, 'Give them to the men that they may eat, for Yahweh says: They shall eat and have some left over.'"
,"44":"So the man set it before them; and they ate and had some left, as Yahweh had said."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Naaman was the army commander of the king of Aram. This man was highly regarded and enjoyed the king's favor, for Yahweh had helped him lead the army of the Arameans to victory. But this valiant man was sick with leprosy."
,"2":"One day some Aramean soldiers raided the land of Israel and took a young girl captive who became a servant to the wife of Naaman. She said to her mistress,"
,"3":"'If my master would only present himself to the prophet in Samaria, he would surely cure him of his leprosy.'"
,"4":"Naaman went to tell the king what the young Israelite maidservant had said."
,"5":"The king of Aram said to him, 'Go to the prophet, and I shall also send a letter to the king of Israel.',So Naaman went and took with him ten gold bars, six thousand pieces of silver and ten festal garments. "
,"6":"On his arrival, he delivered the letter to the king of Israel. It said, 'I present my servant Naaman to you that you may heal him of his leprosy.'"
,"7":"When the king had read the letter, he tore his clothes to show his indignation, 'I am not God to give life or death. And the king of Aram sends me this man to be healed! You see he is just looking for an excuse for war.'"
,"8":"Elisha, the man of God, came to know that the king of Israel had torn his clothes, so he sent this message to him: 'Why have you torn your clothes? Let the man come to me, that he may know that there is a prophet in Israel.'"
,"9":"So Naaman came with his horses and chariots, and stopped before the house of Elisha."
,"10":"Elisha then sent a messenger to tell him, 'Go to the river Jordan and wash seven times, and your flesh shall be as it was before, and you shall be cleansed.'"
,"11":"Naaman was angry, so he went away. He thought: 'On my arrival, he should have personally come out, and then paused and called on the name of Yahweh, his God. And he should have touched with his hand the infected part, and I would have been healed."
,"12":"Are the rivers of Damascus, Abana and Pharpar not better than all the rivers of the land of Israel? Could I not wash there to be healed?'"
,"13":"His servants approached him and said to him, 'Father, if the prophet had ordered you to do something difficult, would you not have done it? But how much easier when he said: Take a bath and you will be cleansed.'"
,"14":"So Naaman went down to the Jordan where he washed himself seven times as Elisha had ordered. His skin became soft like that of a child and he was cleansed."
,"15":"Then Naaman returned to the man of God with all his men. He entered and said to him, 'Now I know that there is no other God anywhere in the world but in Israel. I ask you to accept these gifts from your servant.'"
,"16":"But Elisha answered, 'I swear by Yahweh whom I serve, I will accept nothing.' And however much Naaman insisted, Elisha would not accept his gifts."
,"17":"So Naaman told him, 'Since you refuse, let me get some sacks of soil from your land - the amount that two mules can carry. I shall use it to build an altar to Yahweh, for I shall not offer sacrifices to any other god but him."
,"18":"But may Yahweh pardon me: when my king goes to the temple of his god Rimmon, he leans on my arm, and I bow down with him. May Yahweh pardon me for this.'"
,"19":"Elisha answered, 'Go in peace.' And Naaman went. Naaman was already at a certain distance, "
,"20":"when Gehazi, Elisha's servant, thought: 'Imagine that my lord refused to take the gifts that Aramean brought! As Yahweh lives, I will run after him and get some of them!'"
,"21":"Gehazi went after Naaman and Naaman saw Gehazi running after him, so he jumped out of his chariot to greet him."
,"22":"Gehazi said to him, 'Pardon me, lord, my master sent me to say to you: Two young men from the community of the prophets have just come to me from the mountain of Ephraim, kindly give me a talent of silver and two new garments for them.' Naaman replied,"
,"23":"'Please accept two talents of silver.',He insisted that Gehazi accept them, so he put the two talents of silver with two new garments in two sacks, and handed them over to two of his servants who carried them before Gehazi. "
,"24":"When they reached Ophel, Gehazi took them from their hands and put them away in his house. Then he sent the two servants of Naaman away, and they left."
,"25":"When he appeared before his master, Elisha asked him, 'Where have you been, Gehazi?' He answered, 'Your servant has not been any place.'"
,"26":"Elisha replied, 'Did not my spirit run after you when a man jumped out of his chariot to meet you? Well, you have received silver and can now buy olive groves, vineyards, sheep, oxen and servants."
,"27":"But you and all your decendants shall be infected with the leprosy of Naaman forever.' And Gehazi left his presence with leprosy, as white as snow."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Now the fellow prophets said to Elisha, 'See, the place where we are gathered has become too small for us."
,"2":"Let us go to the Jordan, and let each of us get a log to build a shed where we can gather.' Elisha answered, 'Go.'"
,"3":"Then one of them said to him, 'Why do you not come along with us?'"
,"4":"So Elisha went with them. And when they arrived at the Jordan, they began to cut down the trees."
,"5":"But as one of them was cutting a tree, his axehead fell into the river, and he exclaimed, 'O my master, the iron piece that you have lent me!' The man of God asked him,"
,"6":"'Where did it fall?' And he showed Elisha the place. Elisha cut off a stick, threw it in there, and the iron piece floated."
,"7":"Elisha said, 'Get it.' The man reached out his hand and took it."
,"8":"At that time when the king of Aram was raiding Israel, he consulted with his officials, and told them, 'Let us attack that people.'"
,"9":"But the man of God sent a message to the king of Israel, 'Guard this place for the Arameans shall go there.'"
,"10":"So the king of Israel sent men to the place indicated by the man of God, and they kept watch there. And this happened several times."
,"11":"The king of Aram was worried because of these things, so he called his officials and told them, 'Go and find out who is revealing our plans to the king of Israel.'"
,"12":"One of his officials said, 'None of us has betrayed you, my king, but Elisha, the prophet who is in Israel, makes known to his king even the words you say in your bedroom.'"
,"13":"The king answered them, 'Go then and find out where he lives, that I may send people to arrest him.' When they told him that Elisha was in Dothan,"
,"14":"he sent chariots, horses and strong troops who arrived there by night and surrounded the city."
,"15":"On the following day, when the servant of the man of God rose early in the morning, he went out and saw the Arameans surrounding the city with their chariots and horses. He said to Elisha, 'O my master, what shall we do?'"
,"16":"He answered, 'Do not fear, for those who are with us are more than those who are with them.'"
,"17":"Elisha prayed and said, 'Yahweh, open his eyes that he may see.' Yahweh opened the eyes of the servant, and he saw the hill full of horses and chariots of fire around Elisha."
,"18":"As the Arameans came down to him, Elisha again prayed to Yahweh, 'Blind them.' So Yahweh made them unable to see as Elisha had asked."
,"19":"Elisha told them, 'This is not the way nor is this the city. Follow me and I shall bring you to the man whom you seek.' And he led them to Samaria."
,"20":"When they had entered Samaria, Elisha said, 'Yahweh open their eyes that they may see,' and they saw they were in Samaria."
,"21":"When the king of Israel saw them, he said to Elisha, 'My father, should I kill them?'"
,"22":"He answered, 'If you do not kill those whom you have captured with your sword and your bow, how can you kill these men? Give them bread and water so they may eat and drink, and let them return to their master.'"
,"23":"So the king served them a grand banquet, and they ate and drank. Then he sent them away to their master. From that day on, the troops of Aram did not return any more to invade the territories of Israel."
,"24":"Afterwards Ben-hadad, the king of Aram, gathered together all his troops and went to lay siege to Samaria."
,"25":"There was great famine in Samaria; so great was the misery that the head of an ass was sold for eighty pieces of silver, and a half-liter of chickpeas for five pieces of silver."
,"26":"The king of Israel was walking by upon the wall when a woman cried out to him, 'Save me, my lord King!'"
,"27":"The king answered, 'In what way can I help you? If Yahweh does not give you bread, where shall I get it?"
,"28":"What is the matter?' She answered, 'That woman told me: give up your son that we may eat him today, and then we will eat my son tomorrow."
,"29":"So we cooked my son and ate him. But on the next day, when I said to her: Take your son that we may eat him, she had hidden him.'"
,"30":"When the king heard the words of the woman, he tore his clothes. He was upon the wall, and the people saw that he was wearing sackcloth under his tunic."
,"31":"The king swore: 'May the Lord punish me, if the head of Elisha, the son of Shaphat, remains on his shoulders today.' And the king sent a guard to Elisha's house."
,"32":"Elisha was seated in his house and the elders were sitting with him. Before the messenger's arrival, Elisha said to them, 'Do you not know that this murderer has ordered someone to cut my head off? Well then, when the messenger comes, shut the door and do not let him in. Behind him, I hear the sound of his master's footsteps.'"
,"33":"He was still talking to them, when the king arrived. The king said, 'If all this evil comes from Yahweh, why should I still trust him?'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"But Elisha answered, 'Listen to the word of Yahweh: Tomorrow at this same time, at the gate of Samaria, a measure of flour shall be sold for a piece of silver, and two measures of barley for a piece of silver, too.'"
,"2":"The shield bearer on whose arm the king leaned said to the man of God, 'Even if Yahweh opens the windows of heaven for it to rain wheat, how could this thing be?' Elisha answered, 'You shall see it with your own eyes, but you shall not eat of it.'"
,"3":"Four men were at the city gates, outside, at the other side of the wall. They were lepers. And on that day, they said to one another, 'Shall we sit here until we die?"
,"4":"If we decide to enter the city, there we shall die of hunger. But if we stay here, we die as well. So let us go over to the camp of the Arameans. If they spare our lives, then we live; and if they kill us, then let us die!'"
,"5":"They arose as it was getting dark to go to the camp of the Arameans. But when they reached the camp, they found no one there."
,"6":"The Lord had let the Arameans hear the noise of chariots and horses, the sound of a great army. And they had thought: 'The king of Israel has sent money to the kings of the Hittites and Moshrites to come and attack us.'"
,"7":"So they fled as it was getting dark to save themselves, abandoning their tents, their horses, and their asses, leaving the camp just as it was."
,"8":"When these lepers reached the camp boundary, they went into a tent. They ate and drank; they took the silver, gold and clothes, and hid them there in the ground. They entered another tent and took whatever they found, and hid them in the same way."
,"9":"Then they thought: 'What we are doing is not good. Today is a day of good tidings, and if we keep silent until tomorrow, we shall be guilty. So let us go and tell this to the king's men.'"
,"10":"Returning to the city, they called out to the city guards, saying, 'We went to the camp of the Arameans but no one was there, not a trace of anyone, only horses and asses tied, and the tents just as they were left.'"
,"11":"The guards cried out the news and it was told within the king's household."
,"12":"The king arose in the night and said to his officials, 'The Arameans know that we are hungry. They have left their camp and have hidden in the field, waiting for us to come out of the city that they may take us alive and then get into the city.'"
,"13":"One of the officials answered, 'Let some men take five of the remaining horses for, at any rate, these are also bound to die of hunger, as are all the people of this city. Dispatch them and see.'"
,"14":"So they took two chariots and their horses, and the king sent the horsemen after the Arameans."
,"15":"They went as far as the Jordan, and all the way was littered with clothes and equipment which the Arameans had thrown away in their flight. The messengers returned and told this to the king. "
,"16":"Then the people went out and plundered the camp of the Arameans. A measure of flour was sold for a piece of silver and a double measure of barley was also sold for a piece, as Elisha had said."
,"17":"The king had appointed his shield bearer to keep watch at the city gates. But he was crushed right there by the crowd, so that he died,"
,"18":"just as Elisha had told him when the king had come down to see him. For when Elisha had said to the king, 'Tomorrow at this hour, at the gate of Samaria, two measures of barley as well as a measure of flour shall be sold for a shekel,' "
,"19":"the shield bearer had said to the man of God, 'Even if Yahweh opens the windows of heaven for it to rain down wheat, what you say will not happen.' Then Elisha had told him, 'You shall see it with your own eyes, but you shall not eat of it.'"
,"20":"So it happened. The people ran over him and crushed him at the city gates, and there he died."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Now Elisha had said to the woman whose son he had brought back to life, 'Arise, and go with your family to live in another place, wherever it seems best for you, because Yahweh has called for a famine and it will come upon the land for seven years.'"
,"2":"The woman did what the man of God told her to do - she went with her family to the land of the Philistines and stayed there for seven years."
,"3":"At the end of the seven years, the woman came back to her land and went to ask the king for her house and field."
,"4":"The king was talking with Gehazi, the servant of the man of God, saying, 'Tell me all the marvelous things Elisha has done.'"
,"5":"As Gehazi was narrating how Elisha had restored the dead to life, the woman showed up, she whose very son Elisha had raised from the dead. She was claiming back from the king her house and field. Gehazi said, 'This, my lord, is the woman, and this is her son whom Elisha raised from the dead.'"
,"6":"The king asked her about what had happened, and she recounted it to him. Then the king immediately sent a palace official with her, and said to him, 'See to it that all her properties are returned to her with all the produce of her field from the day she left her land until now.'"
,"7":"Elisha went to Damascus. Ben-hadad, the king of Aram, was sick. When he was told that the man of God had come,"
,"8":"he said to Hazael, 'Go to the man of God and consult Yahweh through him, that I may know if I shall recover from this sickness. But take with you a good gift.'"
,"9":"So Hazael went to see Elisha, taking with him all the best he could find in Damascus, forty camel loads of gifts. When he came before Elisha, he said to him, 'Your son, Ben-hadad, the king of Aram, has sent me to ask you: Shall I recover from this sickness?'"
,"10":"Elisha answered, 'Go and tell him that he shall recover. But Yahweh has shown me that he shall certainly die.'"
,"11":"Then the face of the man of God became rigid, his gaze fixed and he began to weep."
,"12":"Hazael asked him, 'Why do you weep, my lord?' He answered, 'Because I have just seen the evil you will do to the children of Israel: you shall set on fire their fortresses, kill their young men by the sword, crush their children, and rip open the womb of pregnant women.'"
,"13":"Hazael told him, 'Who am I, your servant, that I should carry out such exploits?' Elisha answered, 'I have just had a vision: Yahweh has made you king of Aram.'"
,"14":"Hazael left Elisha and returned to his master who asked him, 'What has Elisha said to you?' He answered, 'He has told me that you shall surely live.'"
,"15":"But on the following day, Hazael took a mantle, dipped it in water, and pressed it down on the king's face until he died. And so, Hazael succeeded him as king of Aram."
,"16":"In the fifth year of Joram, son of Ahab and king of Israel, Jehoram, son of Jehoshaphat, king of Judah began to reign."
,"17":"He was thirty-two years old when he began his reign, and he reigned for eight years in Jerusalem."
,"18":"He followed the footsteps of the kings of Israel and acted in everything like the family of Ahab. Because he had married the daughter of Ahab, he acted very badly with Yahweh."
,"19":"However, Yahweh would not destroy Judah for the sake of his servant David, according to the promise he had made to keep his lamp burning forever, which referred to David's descendants."
,"20":"In his days, the Edomites rebelled against the rule of Judah, and proclaimed a king of their own."
,"21":"Then Joram went to attack the city of Zair with all his chariots of war. Rising by night he managed to escape from the Edomites, who had surrounded him and his chariot commanders, but the troops had fled."
,"22":"Thus Edom has rebelled against Judah to this day. At that time, the city of Libnah also rebelled."
,"23":"The rest of the deeds of Joram and his bravery are written in the Book of the Chronicles of the Kings of Judah."
,"24":"When Joram died, they buried him with his fathers in the city of David, and his son Ahaziah succeeded him."
,"25":"Ahaziah, son of Joram, king of Judah, began to reign in the twelfth year of Joram, son of Ahab, king of Israel."
,"26":"Ahaziah was twenty-two years old when he began his reign, and he reigned for a year in Jerusalem. His mother was Athaliah, daughter of Omri, king of Israel."
,"27":"He followed in the footsteps of Ahab and acted badly towards Yahweh like those in the family of Ahab had done, since he was related to Ahab's family."
,"28":"He went with Joram, the son of Ahab, to make war against Hazael, the king of Aram, at Ramoth of Gilead."
,"29":"But the Arameans wounded Joram who returned from Ramoth to Jezreel to recover from his wounds. After a while, Ahaziah, the king of Judah, went to Jezreel to visit him as he was recuperating."
}`)
	CurrentBook.AddChapter(9, `{
"1":"The prophet Elisha called one of the fellow prophets, and said to him, 'Prepare to go to the city of Ramoth in Gilead taking this bottle of oil."
,"2":"Look there for Jehu, the son of Jehoshaphat, son of Nimshi. Make him leave his companions, and lead him to a place apart from them."
,"3":"There you shall take the bottle and pour the oil on his head, saying: Yahweh has anointed you king of Israel. Then open the door and flee without delay.'"
,"4":"So the young man went to Ramoth."
,"5":"When he arrived, the commanders of the army were seated together, and he said, 'I have to talk with you, commander.' Jehu asked, 'To which of us?' He answered, 'To you, commander.'"
,"6":"So Jehu arose and went into the house. Then the young man poured the oil on Jehu's head, and said to him, 'Yahweh, the God of Israel, has consecrated you king of the people of Israel. Thus says Yahweh: "
,"7":"You shall overthrow the kings of the family of Ahab, that I may avenge the blood of my servants, the prophets, whom Jezebel has murdered."
,"8":"I shall destroy the family of Ahab and all their men shall perish."
,"9":"The family of Ahab shall be like the family of Jeroboam and the family of Baasha."
,"10":"And regarding Jezebel, no one shall bury her, for the dogs shall devour her in the field of Jezreel.' Then the young man opened the door and fled."
,"11":"Jehu came out to join the officers of the king. They said to him, 'What happened? Why did that fool call you?' Jehu answered, 'You know that fellow and you also know why he came.'"
,"12":"They said, 'We do not know anything. Tell us what he said to you.' He answered, 'These are his exact words: Yahweh has consecrated you king of Israel.'"
,"13":"Then all the commanders, the companions of Jehu, took their cloaks and put them on a wooden platform in the shape of a throne. And with blast of trumpets, they proclaimed, 'Jehu is king!'"
,"14":"Thus Jehu, son of Jehoshaphat, son of Nimshi, conspired against Joram. At that time, Joram was with the Israelites defending the city of Ramoth in Gilead against Hazael, king of Aram,"
,"15":"but Joram had retreated to Jezreel to recover from the wounds he had received in battle. Jehu said, 'If it seems good to you, let no one leave the city, lest they go and tell the news to the king in Jezreel.' "
,"16":"Jehu then mounted his chariot and went to Jezreel, where Joram lay sick, and Ahaziah, king of Judah, had gone to visit him."
,"17":"The watchman at the tower in Jezreel saw the retinue of Jehu coming and said, 'I see a company.' Joram said, 'Take your horse and run to meet them, and ask them if they have any news.'"
,"18":"So the man went out to meet them and said, 'The king sent me to ask if you have any news.' Jehu answered, 'Do not worry about the news. Turn around and follow me.' And the watchman immediately reported, 'The messenger reached them, but he has not returned.'"
,"19":"They sent another messenger who came to them and said, 'The king wants to know if you bring any news.' And Jehu again answered, 'Do not worry about the news, turn around and ride behind me.'"
,"20":"Again the watchman reported, 'He has reached them, but has not returned. The way of driving of him who comes resembles that of Jehu, son of Nimshi, for he drives like a madman.'"
,"21":"Joram then said, 'Harness the horses of my chariot.' And Joram, the king of Israel, went out with Ahaziah, the king of Judah, each in his chariot, to meet Jehu. They met him in the field of Naboth of Jezreel."
,"22":"When Joram saw Jehu, he asked, 'Do you bring peace, Jehu?' Jehu answered, 'Why do you ask for peace when the prostitution of your mother, Jezebel, and her many sorceries still continue?'"
,"23":"So Joram turned his chariot around and fled, saying to Ahaziah, 'Treachery, Ahaziah!'"
,"24":"Jehu then drew his bow with all his strength and shot Joram in the back, so that the arrow pierced his heart. And Joram fell dead in his chariot."
,"25":"Jehu said to his shield bearer Bidkar, 'Take the body and throw it in the field of Naboth of Jezreel; for remember, when we served together in the cavalry of his father, Ahab, Yahweh pronounced this sentence against him:"
,"26":"I swear that in this field, I shall take vengeance on you, for the blood of Naboth and for the blood of his sons which I saw you shed yesterday. So take his body and throw it into the field according to the word of Yahweh.'"
,"27":"As for Ahaziah, the king of Judah, he fled in the direction of Beth-haggan. Jehu pursued him, crying out, 'Kill him, too!' And they shot him in his chariot at the slope of Gur near Ibleam. He reached Megiddo, took refuge there and died."
,"28":"His servants carried his body in a chariot to Jerusalem, and buried him with his fathers in the city of David."
,"29":"Ahaziah had begun his reign in Judah in the eleventh year of Joram, son of Ahab."
,"30":"Jehu entered the city of Jezreel. When Jezebel learned this, she painted her eyes, adorned her neck, and looked out of the window."
,"31":"As Jehu entered the gates, she said to him, 'Do you bring peace? Will you not have Zimri's fate after murdering your master?'"
,"32":"Jehu looked up to the window and cried out, 'Who is on my side?' Two or three eunuchs looked down at him."
,"33":"He ordered them, 'Throw her down.' They threw her down through the window, and her blood splashed on the walls and on the horses, and Jehu in his chariot ran over her."
,"34":"Jehu entered Jezreel. After he had eaten and drunk, he gave these orders, 'Take care of that cursed woman and bury her, for she was a king's daughter.'"
,"35":"They went to bury her, but they found no more than her hands and feet with the skull."
,"36":"When they told Jehu about it, he said, 'This is what Elijah of Tishbe said in the name of Yahweh: In the field of Jezreel, the dogs shall eat Jezebel."
,"37":"Her body shall be as dung on the land, so that no one can say: This was Jezebel.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"The seventy sons of Ahab lived in Samaria. So Jehu wrote letters and sent them to Samaria, to the leaders of the city, to the judges and to those who took care of the sons of Ahab, saying,"
,"2":"'As soon as this letter comes to you who have the king's sons, chariots of war and horses, fortified cities and weapons,"
,"3":"select the best and most fit of your master's sons and make him sit on his father's throne; then prepare to defend the family of your lord.'"
,"4":"They were in great fear, and they said, 'If the two kings were not able to stand up to him, how then can we resist him?'"
,"5":"The palace chamberlain, the military commissioner of the city, the judges and the tutors sent this response to Jehu: 'We are your servants, and we will do whatever you say. We will not proclaim anyone king; do whatever seems best to you.'"
,"6":"Then he sent them a second letter which said, 'If you are on my side and among those who obey me, take the heads of the sons of the king, your lord, and come to talk to me tomorrow at this time in Jezreel.',The king's sons were seventy and they were growing up in the houses of prominent families of the city."
,"7":"As soon as this letter reached them, they seized the sons of the king, beheaded seventy of them and placed their heads in large baskets which they sent to Jezreel."
,"8":"The messenger came to where Jehu was and said to him, 'Here they send you the heads of the king's sons.' He answered, 'Lay them in two heaps at the entrance of the gate of Jezreel until tomorrow.'"
,"9":"In the morning, Jehu went out and said to all the people, 'Be fair, tell me: if I have conspired against my king and have killed him, who then has beheaded all these?"
,"10":"Know then that none of the words Yahweh has spoken against the family of Ahab shall be without effect. Everything he said through the mouth of his servant Elijah has been fulfilled.'"
,"11":"Jehu then killed all who remained loyal to Ahab in Jezreel - all his ministers, relatives, priests - without sparing anyone."
,"12":"Then he left for Samaria, and in Beth-eked of the Shepherds,"
,"13":"he met the brothers of Ahaziah, king of Judah. He asked them, 'Who are you?' They answered, 'We are the brothers of Ahaziah, and we go to greet the sons of the king and the sons of the queen.'"
,"14":"Jehu said, 'Take them alive.' They took them alive and beheaded them all by the well of Beth-eked. They were forty-two men, and none was left alive."
,"15":"Setting out from there, he met Jehonadab, son of Rechab, who came out to meet him. Jehu greeted him and said, 'Would you be faithful to me as I am to you?' Jehonadab answered, 'Yes.' So Jehu said to him, 'Give me your hand.' He gave him his hand, and Jehu took him up with him into his chariot, and said,"
,"16":"'Come with me and see my zeal for Yahweh.' And he had him ride in his chariot."
,"17":"When Jehu came to Samaria, he killed all the survivors loyal to Ahab in that city, and he did not spare anyone. So the word Yahweh had said through the mouth of Elijah was fulfilled."
,"18":"Jehu gathered together all the inhabitants and said, 'Ahab served Baal, but I will serve him still better.'"
,"19":"And he added, 'Summon all the prophets of Baal, all his faithful followers and priests."
,"20":"Let no one be missing at the solemn sacrifice I will offer to Baal. Whoever is absent shall die.' Jehu did this with cunning, for he was determined to kill all who were faithful to Baal. They themselves proclaimed the sacred solemnity that Jehu had commanded. And Jehu, for his part,"
,"21":"sent messengers throughout Israel for all the faithful of Baal to come without any exception. When they entered the temple of Baal, they were so many that they hardly touched the ground. "
,"22":"Then Jehu ordered those in charge of the vestments to bring out the sacred vestments reserved for the faithful of Baal and to distribute these to them."
,"23":"Jehu who was accompanied by Jehonadab, the son of Rechab, said insistently to the faithful of Baal, 'Make sure that none of the faithful of Yahweh has entered with you, that there is no one here except all the true servants of Baal.'"
,"24":"Then they entered to prepare the sacrifice. But Jehu had stationed eighty men outside, and said to them, 'Whoever of you lets anyone escape of those who must die shall pay with his own life.'"
,"25":"And when the sacrifice was finished, Jehu gave this order to the soldiers and officers, 'Go in and kill all of them, let none of them escape.' So, they went in and put everyone to the sword, going as far as the sanctuary of the House of Baal."
,"26":"They pulled out the sacred pillar of the House of Baal and burned it."
,"27":"They destroyed the altar and pulled down the temple, which remains a garbage dump to this very day."
,"28":"This was how Jehu wiped out the name of Baal from Israel."
,"29":"But Jehu did not turn aside from the sins which Jeroboam, the son of Nesbat, had caused Israel to commit, for they kept the golden calves of Bethel and Dan."
,"30":"In spite of this, Yahweh said to Jehu, 'Since you have acted well, doing what seems just to me, and have dealt with the family of Ahab according to my will, your sons until the fourth generation shall sit on the throne of Israel.'"
,"31":"But Jehu did not completely walk according to the Law of Yahweh, since he did not give up the sins into which Jeroboam had led Israel."
,"32":"In those days, Yahweh began to reduce the land of Israel, and Hazael conquered the Israelites taking their territory"
,"33":"from the Jordan to the East, all the land of Gilead, of the tribes of Gad, Reuben, Manasseh, from Aroer by the brook of Arnon, all the land of Gilead and Bashan."
,"34":"Now the rest of the story of Jehu, all that he did and his bravery are written in the Book of the Chronicles of the Kings of Israel."
,"35":"When Jehu died, they buried him in Samaria, and his son Jehoahaz reigned in his place."
,"36":"Jehu reigned over Israel in Samaria for twenty-eight years."
}`)
	CurrentBook.AddChapter(11, `{
"1":"When Athaliah, the mother of Ahaziah, saw that her son had died, she was determined to wipe out all the descendants of the king."
,"2":"But Jehosheba, the daughter of King Joram and sister of Ahaziah, took Joash, her nephew, and brought him away from among the king's sons who were about to be killed, and put him with his wet nurse in the bedroom. Thus she hid him from Athaliah, so that the boy was saved."
,"3":"And Joash remained hidden in the House of Yahweh for six years while Athaliah reigned over the land."
,"4":"In the seventh year, Jehoiada the chief priest, summoned the officers of the royal guard and of the Carites to the House of Yahweh. After concluding a pact with them under oath, he showed them the king's son."
,"5":"Then he gave them these orders, 'One third of your men who come on duty on the sabbath shall guard the king's house,"
,"6":"another third shall be at the foundation gate, and the last third at the back gates. Keep watch continuously."
,"7":"Now about those who come off duty on the sabbath, two divisions of them shall guard the House of Yahweh and surround King Joash."
,"8":"You shall be at his side, each with drawn weapons, and you will kill all who would cross your line. Take care of the king wherever he goes.'"
,"9":"The commanders of the guards did what Jehoiada the priest had told them to do and they showed up with all their men, those who were to go off duty on the sabbath as well as those who were to come on duty on that day."
,"10":"Jehoiada entrusted to the officers the spears and shields of King David which were in the House of Yahweh."
,"11":"And then the guards stood from the southern corner of the house to the north, surrounding the altar and the House of Yahweh."
,"12":"Then Jehoiada, the priest, brought out the king's son, crowned him and put the bracelets on him, then proclaimed and consecrated him king. All clapped their hands, shouting and crying out, 'Long live the king!'"
,"13":"When Athaliah heard the noise of the people, she approached the crowd surrounding the House of Yahweh."
,"14":"The king was standing by the pillar, according to the custom, and the officers and the trumpeters were with him. The people were filled with joy and they were blowing trumpets. On seeing this, Athaliah tore her clothes and cried out, 'Treason, treason!'"
,"15":"Jehoiada the priest commanded the officers, 'Surround her and bring her out to the courtyard, and kill anyone who tries to defend her.' He gave this order, because he thought, 'She should not die in the House of Yahweh.'"
,"16":"They brought her out, and when they reached the palace of the king by the horses' entrance, there they killed her."
,"17":"Jehoiada made a covenant between Yahweh and the king and the people so they would be the people of Yahweh."
,"18":"All the citizens went to the temple of Baal and destroyed it. They broke the altars and the images into pieces, and killed Mattan, the priest of Baal, before his altar. Then Jehoiada, the priest, posted guards over the House of Yahweh. "
,"19":"He led the officers, the guards of the king, the Carites guards and the citizens, and they accompanied the king to the palace, passing through the Gate of the Guards. King Joash sat on the royal throne."
,"20":"All the citizens were happy and the city was at peace. Now regarding Athaliah, she had died by the sword in the king's palace."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Joash was seven years old when he began his reign."
,"2":"It was then the seventh year of Jehu, and he reigned for forty-two years in Jerusalem. His mother was Zibiah of Beer-sheba."
,"3":"Joash did what was right in the eyes of Yahweh as long as the priest Jehoiada guided him."
,"4":"But he did not demolish the sanctuaries on the hillsides where people continued offering sacrifices and burning incense."
,"5":"Joash said to the priest, 'All the money from the sacred contributions which the people bring to offer in the House of Yahweh, the money in cash, that which is offered as personal assessment, and that which is freely and voluntarily given in the House of Yahweh -"
,"6":"all these you can receive. Let each one receive from the hand of those to whom he attends, but you are to repair the House of Yahweh, when anything needs to be repaired.'"
,"7":"By the twenty-third year of the reign of Joash, the priests had not yet carried out the repairs needed in the House of Yahweh."
,"8":"So the king summoned Jehoiada the priest and the other priests with him, and said to them, 'Why have you not carried out the repairs of the House yet? From now on, you will no longer keep any money during your service, but shall set it aside for the repair of the House.'"
,"9":"The priests agreed that henceforth, they would not accept money from the people and would not be in charge of the repair of the House."
,"10":"So Jehoiada, the priest, had a box made with a hole in the cover. He placed this by the altar, to the right side of those entering the House of Yahweh, and the priests who were at the gates put in it all the money offered in the House of Yahweh."
,"11":"Whenever they saw that the box was full, a secretary of the king would come, and together with the high priest, they would take and count the money."
,"12":"Then they would turn the amount over into the hands of those responsible for the work of the House, who would, in turn, pay with this money the carpenters and bricklayers doing the repairs."
,"13":"From this amount, they also bought the stones, wood and everything necessary for the repair of the House of Yahweh."
,"14":"But of this money given for the House of Yahweh, they did not make any silver cups, or cutting tools, or water jars, or trumpets, or any golden or silver objects,"
,"15":"but all the money was used to pay those who were repairing the House of Yahweh."
,"16":"Accounts were not asked from those responsible for paying the laborers, since they acted with great honor."
,"17":"Only the money offered for the expiation of sins was for the priests."
,"18":"At that time Hazael, king of Aram, went up to fight against Gath. He captured it and was heading for Jerusalem."
,"19":"So Joash, king of Judah, took all the precious things that his fathers, Jehoshaphat, Jehoram and Ahaziah, kings of Judah, had consecrated, with all that he himself had consecrated, and all the gold he could find in the treasury of the House of Yahweh and in those of the king's house. Then he sent them to Hazael, king of Aram, who left Jerusalem with them."
,"20":"Now the rest regarding Joash and all that he did is written in the Book of the Chronicles of the Kings of Judah."
,"21":"Some of his officials plotted a conspiracy against him, and they killed him in Beth-Millo, as he was going to Silla."
,"22":"Jozacar, son of Shimeath, and Jehozabad, son of Shomer, struck him down, and he died. He was buried with his fathers in the city of David, and his son Amaziah reigned in his place."
}`)
	CurrentBook.AddChapter(13, `{
"1":"In the twenty-third year of Joash, son of Ahaziah, king of Judah, Jehoahaz, son of Jehu, began to rule over Israel from Samaria, its capital; he reigned for seventeen years."
,"2":"He acted badly towards Yahweh and persisted in the sins of Jeroboam, son of Nebat, which had become the sins of Israel, without turning away from them."
,"3":"So the anger of Yahweh burned against Israel, and he delivered them into the hands of Hazael, king of Aram, and into the hands of Ben-hadad, son of Hazael, throughout that time."
,"4":"But Jehoahaz prayed to Yahweh, and Yahweh listened to him for he had seen the oppression of Israel, how the king of Aram oppressed them."
,"5":"And Yahweh gave Israel a liberator who would free them from the oppression of Aram, so the Israelites could live peacefully in their homes as before."
,"6":"(But they did not turn away from the sins by which Jeroboam made Israel sin, for the sacred pillar still remained standing in Samaria.)"
,"7":"No more than fifty horsemen, ten chariots of war and ten thousand soldiers were left of the army of Jehoahaz, for the king of Aram had wiped out all the rest like dust."
,"8":"The rest about Jehoahaz, all that he did and his bravery are written in the Book of the Chronicles of the Kings of Israel."
,"9":"When Jehoahaz slept with his fathers, they buried him in Samaria and his son Joash reigned in his place."
,"10":"In the thirty-seventh year of Joash, king of Judah, Joash, son of Jehoahaz, began to reign over Israel in Samaria, its capital; he reigned for sixteen years."
,"11":"He did what was evil in the eyes of Yahweh; he did not turn away from the sins which Jeroboam, son of Nebat, made Israel commit."
,"12":"The rest about Joash and all that he did, his bravery and how he fought against Amaziah, king of Judah are written in the Book of the Chronicles of the Kings of Israel."
,"13":"When Joash slept with his fathers, he was buried in Samaria, together with the kings of Israel, and Jeroboam sat upon his throne."
,"14":"When Elisha became very sick and was about to die, Joash, king of Israel, went down to him and went before him, saying, 'My father! My father! Chariot and horses of Israel!'"
,"15":"Elisha said to him, 'Take a bow and arrows.' So he took a bow and arrows."
,"16":"Elisha then said to the king, 'Draw the bow,' and the king drew the bow. Then Elisha put his hand on the king's hand"
,"17":"and said, 'Open the window towards the east.' He opened it. Elisha then said, 'Shoot!' And he shot. Elisha said, 'Yahweh's arrow of victory, arrow of victory over Aram! You shall defeat Aram in Aphek until you utterly destroy them!'"
,"18":"And he added, 'Take the arrows.' And he took them. Elisha said to the king, 'Strike the ground with them.' He struck three times and stopped."
,"19":"So the man of God became angry at him, and said, 'You should have struck five or six times, then you would have struck down Aram completely. But now, you will strike down Aram only three times.'"
,"20":"Elisha died and they buried him. A little later, a detachment of Moabites conducted a raid as they used to do at the beginning of every year."
,"21":"It happened that at that time some people were burying a dead man, when they saw the Moabites. So they quickly threw the body into the grave of Elisha, and then fled to safety. But as soon as the man's body touched the bones of Elisha, the man revived and stood on his feet."
,"22":"Hazael, king of Aram, oppressed the Israelites throughout the reign of Jehoahaz."
,"23":"But Yahweh had pity and took compassion on them; he turned towards them because of his covenant with Abraham, Isaac and Jacob, and would not utterly destroy them, or cast them far from his face."
,"24":"Hazael, the king of Aram, died; and his son Ben-hadad reigned in his place."
,"25":"Then Joash, son of Jehoahaz, again took from Ben-hadad the cities which Hazael had taken from Jehoahaz. Joash defeated him thrice and recovered the cities of Israel."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Amaziah, son of Joash, king of Judah, began to reign in the second year of Joash, king of Israel."
,"2":"He was twenty-five years old when he began to reign, and he reigned for twenty-nine years in Jerusalem. His mother was Jehoaddin of Jerusalem."
,"3":"He did what was right in the eyes of Yahweh, yet not like his father David; rather he acted like his father Joash."
,"4":"The Sanctuaries on the Hillside still stood; there the people continued to offer sacrifices and to burn incense."
,"5":"When the kingdom was firmly in his hands, Amaziah killed the officers who had murdered the king, his father,"
,"6":"but did not kill the sons of the assassins, according to what is written in the Law of Moses where Yahweh gave this command: 'You shall not put the fathers to death because of their sons, nor shall you put the sons to death because of their fathers, but everyone shall be punished on account of his own crimes.'"
,"7":"Amaziah conquered ten thousand Edomites in the valley of Salt, and conquered the Rock by arms, calling it Joktheel, which is its name to this day."
,"8":"Then Amaziah sent messengers to Joash, son of Jehoahaz, son of Jehu, king of Israel, to say to him, 'Come up and let us see which of the two of us is better.'"
,"9":"Joash, king of Israel, sent as an answer to Amaziah, king of Judah: 'A thornbush of Lebanon sent this message to a cedar of Lebanon: Give me your daughter to be my son's wife. But the wild beasts of Lebanon passed by and trampled down the bush."
,"10":"You now feel very proud since you conquered the Edomites. Be content with your fame and be quiet in your own house lest disgrace befall you and the people of Judah.'"
,"11":"But Amaziah did not listen; so Joash, king of Israel, came and confronted him in Beth-shemesh of Judah."
,"12":"Judah was defeated by Israel, and everyone of them fled to his home."
,"13":"Joash, king of Israel, took Amaziah, son of Ahaziah, as prisoner in Beth-shemesh, and brought him to Jerusalem. He made an opening two hundred meters wide in the wall of Jerusalem, from the Ephraim Gate to the Corner Gate. "
,"14":"He took all the gold and silver, all that he found in the House of Yahweh and in the treasuries of the king's house, and hostages as well, and then returned to Samaria."
,"15":"Now the rest about Joash, about his bravery and how he fought against Amaziah, king of Judah, is written in the Book of the Chronicles of the Kings of Israel."
,"16":"When Joash rested with his fathers, they buried him in Samaria with his ancestors, and his son Jeroboam reigned in his place."
,"17":"Now about Amaziah: he lived fifteen more years after the death of Joash, king of Israel."
,"18":"The rest of the history of Amaziah is written in the Book of the Chronicles of the Kings of Judah."
,"19":"There were people who conspired against him in Jerusalem. So Amaziah took refuge in Lachish, but they pursued him and killed him in that city."
,"20":"His body was brought from there in a chariot, and they buried him in Jerusalem with his fathers in the city of David."
,"21":"Then, all the people of Judah took Azariah, who was sixteen years old, and proclaimed him king in place of his father Amaziah."
,"22":"He rebuilt Elath and restored it to Judah, after the king, his father, died."
,"23":"Jeroboam, son of Joash, king of Israel, began to reign in Samaria in the fifteenth year of the reign of Amaziah, king of Judah. He reigned for forty-one years,"
,"24":"and during his reign he acted badly towards Yahweh, for he did not turn away from the sins which Jeroboam, son of Nebat, made Israel commit."
,"25":"He restored the border of Israel from the entrance of Hamath up to the Dead Sea, according to the word which Yahweh, the God of Israel, had said through the mouth of his servant, the prophet Jonah, the son of Amittai from Gath-hepher."
,"26":"Yahweh had seen the extreme bitter misery of Israel; there was no one left, neither slave nor freeman, who would help Israel."
,"27":"But Yahweh did not decide to wipe out the name of Israel from under the heavens, so he saved them by the hand of Jeroboam, son of Joash."
,"28":"Now the rest regarding Jeroboam, all that he did and his bravery, how he fought and restored Hamath and Damascus to Israel, is written in the Book of the Chronicles of the Kings of Israel."
,"29":"When Jeroboam died, he was buried with the kings of Israel, and his son Zechariah reigned in his place."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Azariah, son of Amaziah, king of Judah, began to reign in the twenty-seventh year of the reign of Jeroboam in Israel."
,"2":"He was sixteen years old when he began his reign; he reigned for fifty-two years in Jerusalem. His mother was Jecoliah of Jerusalem."
,"3":"He did what pleased Yahweh, like his father Amaziah had done."
,"4":"But the Sanctuaries of the Hillsides were not demolished, and the people still offered sacrifices and burned incense on them."
,"5":"Yahweh struck down the king. He became sick with leprosy, and he remained a leper to the day of his death. He lived in an isolated house, while Jotham, his son, was head of the king's household and administered justice in the kingdom."
,"6":"Now the rest about Azariah and all that he did is written in the Book of the Chronicles of the Kings of Judah."
,"7":"When Azariah died, they buried him with his fathers in the city of David, and his son Jotham succeeded him."
,"8":"Zechariah, son of Jeroboam, began to reign over Israel in Samaria, its capital, in the thirty-eighth year of Azariah, king of Judah. For the six months that he stayed in power,"
,"9":"he acted badly towards Yahweh, as his fathers had done, for he did not turn away from the sins which Jeroboam, son of Nebat, made Israel commit."
,"10":"Shallum, son of Jabesh, conspired against him, and struck him down at Ibleam. He killed him and reigned in his place."
,"11":"Now the rest regarding Zechariah is written in the Book of the Chronicles of the Kings of Israel."
,"12":"In this way the promise Yahweh had made to Jehu was fulfilled: 'Your sons until the fourth generation shall sit upon the throne of Israel.' And so it was."
,"13":"Shallum, son of Jabesh, began to reign in the thirty-ninth year of Uzziah, king of Judah, and he reigned for a month in Samaria."
,"14":"Then Menahem, son of Gadi, rebelled against him in Tirzah. He came to Samaria and killed Shallum in that city. Having killed Shallum, Menahem reigned in his place."
,"15":"Now the rest about Shallum and the conspiracy which he plotted is written in the Book of the Chronicles of the Kings of Israel."
,"16":"Then Menahem seized Tappuah and killed its inhabitants, devastating its territory from Tirzah onwards, since they would not open the gates to him. And he ripped open all the pregnant women."
,"17":"Menahem, son of Gadi, began to reign in the thirty-ninth year of Azariah, king of Judah. He reigned for ten years in Samaria,"
,"18":"and he too acted badly towards Yahweh, for he did not turn away from the sins of Jeroboam, son of Nebat, which he made Israel commit."
,"19":"In his days, Pul, the king of Assyria, invaded the land of Israel. And Menahem had to give him a thousand talents of silver so that the king of Asshur would receive him as an ally and keep him in power."
,"20":"Menahem exacted the money from all the wealthy and prominent people of Israel to give to the king of Asshur: fifty pieces of silver from each one. With this, the king of Asshur turned back and did not stay there in the land."
,"21":"Now the rest regarding Menahem and all that he did is written in the Book of the Chronicles of the Kings of Israel."
,"22":"When Menahem died, his son Pekahiah succeeded him."
,"23":"Pekahiah, son of Menahem, began to reign over Israel in Samaria in the fiftieth year of Azariah, king of Judah. He reigned for two years,"
,"24":"during which he acted badly towards Yahweh; he did not turn away from the sins which Jeroboam, son of Nebat, made Israel commit."
,"25":"His general, Pekah, son of Remaliah, rebelled against him. He led some fifty men from the province of Gilead, and they came to kill him in Samaria in the tower of the palace. With the king dead, Pekah succeeded him."
,"26":"The rest about Pekahiah and all that he did is written in the Book of the Chronicles of the Kings of Israel."
,"27":"In the fifty-second year of Azariah, king of Judah, Pekah, son of Remaliah, began to reign over Israel in Samaria, its capital. He reigned for twenty years, and he acted badly towards Yahweh,"
,"28":"for he did not turn away from the sins which Jeroboam made Israel commit."
,"29":"In the time of Pekah, king of Israel, Tiglath-pileser, king of Assyria, came and seized Iyon, Abel-beth-maacah, Janoah, Kedesh, Hazor, the territory of Gilead and Galilee, and the whole land of Naphtali, and deported their inhabitants to Asshur."
,"30":"Then Hoshea, son of Elah, conspired against Pekah, son of Remaliah, killed him and reigned in his place."
,"31":"The rest about Pekah and all that he did is written in the Book of the Chronicles of the Kings of Israel."
,"32":"Jotham, son of Uzziah, king of Judah, began to reign in the second year of Pekah, son of Remaliah, king of Israel."
,"33":"Jotham was twenty-five years old when he began to reign, and he reigned for sixteen years in Jerusalem. His mother was Jerusha, daughter of Zadok."
,"34":"He did what pleased Yahweh, as his father had done,"
,"35":"but he did not abolish the Sanctuaries on the high places where the people continued to offer sacrifices and burn incense. He built the Upper Gate of the House of Yahweh. "
,"36":"The rest about Jotham and all that he did is written in the Book of the Chronicles of the Kings of Judah."
,"37":"In those days, Yahweh began to send Rezin, king of Aram, and Pekah, son of Remaliah, against Judah."
,"38":"When Jotham died, they buried him with his fathers in the city of his ancestor David, and his son Ahaz succeeded him."
}`)
	CurrentBook.AddChapter(16, `{
"1":"In the seventeenth year of the reign of Pekah, son of Remaliah, Ahaz the son of Jotham, king of Judah, began to reign."
,"2":"Ahaz was then twenty years old and he reigned for sixteen years in Jerusalem. He did not do what pleased Yahweh, his God, as his father David had done."
,"3":"He walked in the way of the kings of Israel, and even sacrificed his son in the fire, according to the hateful practices of those nations which Yahweh had expelled from the land, so the children of Israel could occupy their place."
,"4":"He offered sacrifices in the sanctuaries on the hills, on the slopes and under every green tree."
,"5":"Then Rezin, king of Aram, and Pekah, son of Remaliah, king of Israel, came up to fight Jerusalem. They surrounded it, but could not conquer it."
,"6":"At that time Rezin, king of Aram, recovered Elath for the Edomites, expelling the Jews from there. The Edomites then entered Elath and lived there until now."
,"7":"Ahaz sent messengers to Tiglath-pileser, king of Asshur, to tell him, 'I am your servant and your son. Come then and rescue me from the hands of the king of Aram and of the king of Israel, who wage war against me.'"
,"8":"Ahaz took the silver and gold that was in the House of Yahweh and the treasures from the house of the king, and sent them as a gift to the king of Asshur."
,"9":"The king of Asshur paid heed to him and went to attack Damascus; he seized that city and exiled its inhabitants to Kir, then he killed Rezin."
,"10":"So King Ahaz went to Damascus to meet with Tiglath-pileser, king of Asshur. And when he saw the altar in Damascus, he sent to Uriah the priest, the measurement of that altar together with the design which he copied exactly in all its details."
,"11":"The priest Uriah built the altar according to the design the king had sent him from Damascus. He finished it before King Ahaz arrived from Damascus."
,"12":"When the king returned from Damascus, he saw the altar, approached it and went up to it."
,"13":"He burned on that altar his holocausts and sacrifices. There he made his libation and shed the blood of his peace offerings."
,"14":"He removed the altar of bronze that was before Yahweh, from the front of the House, from between the new altar and the House of Yahweh, and he placed it on the north side of his new altar. King Ahaz ordered the priest Uriah, "
,"15":"'Upon this great altar you shall burn the morning holocaust and the evening sacrifice, the king's holocaust and his sacrifice, the holocausts of the people of the land, their sacrifices and libations. You shall shed upon it all the blood of the holocausts and sacrifices. As for the bronze altar, I will deal with it.'"
,"16":"The priest Uriah did as the king had commanded him."
,"17":"The king dismantled the paneling of the stands, removed the washbasins from on top of them, took down the big bronze basin from the top of the oxen that supported it, and placed it upon the stone pavement. Now, about the throne which had been built within the House of Yahweh and the outer entrance for the king,"
,"18":"he removed them from the House of Yahweh because of the king of Asshur."
,"19":"The rest regarding Ahaz and all that he did is written in the Book of the Chronicles of the Kings of Judah."
,"20":"When Ahaz died, they buried him with his fathers in the city of David, and his son Hezekiah succeeded him."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Hoshea, son of Elah, began to reign in Israel in the twelfth year of Ahaz, king of Judah. He reigned for nine years in the city of Samaria,"
,"2":"and he acted badly towards Yahweh though not as bad as the previous kings of Israel."
,"3":"Shalmaneser, king of Asshur, came with his army to attack Hoshea, who surrendered to him and began paying taxes to him."
,"4":"But the king of Asshur discovered that Hoshea was plotting against him, for Hoshea had sent messengers to So, king of Egypt, and did not pay him the taxes as he had done every year. Shalmaneser arrested him, and then put him in prison."
,"5":"The army of the king of Asshur subjected the whole of Israel, and they came to Samaria and laid siege to it for three years."
,"6":"In the ninth year of Hoshea, the king of Assyria captured Samaria, exiled the Israelites to Asshur and made them settle in Halah, at the banks of Habor, the river of Gozan, as well as in the cities of the Medes."
,"7":"This happened because the children of Israel had sinned against Yahweh, their God, who had brought them out of the land of Egypt, where they were subject to Pharaoh, but they had turned back to other gods."
,"8":"They followed the customs of the nations which Yahweh had driven out before them."
,"9":"The children of Israel introduced many innovations that offended Yahweh, their God. They built sanctuaries in all the cities, from the watchtowers to the fortified cities."
,"10":"They placed images and sacred pillars on all the hills and under every green tree."
,"11":"There they burned incense in their sanctuaries on the hills, like the nations Yahweh had dispossessed for them. They did wicked things, provoking Yahweh to anger. "
,"12":"They served their filthy idols in spite of what Yahweh had told them: 'You must not do such a thing.'"
,"13":"Yahweh warned Israel and Judah through the mouth of every prophet and seer, saying: 'Turn from your evil ways and keep my commandments and precepts according to the laws which I commanded your fathers and which I have sent to you by my servants, the prophets.'"
,"14":"But they did not listen and refused as did their fathers who did not believe in Yahweh, their God."
,"15":"They despised his statutes and the covenant he had made with their fathers, and the warnings he had given them. They went after worthless idols and they themselves became worthless, following the nations which surrounded them, in spite of what Yahweh had said, 'Do not do as they do.'"
,"16":"They abandoned all the commandments of Yahweh and fashioned two calves of bronze. They made sacred pillars and knelt before all the stars of heaven, and worshiped Baal."
,"17":"They sacrificed their sons and daughters in the fire, practiced divination and magic, and sold themselves to evildoing in the sight of Yahweh enkindling his anger."
,"18":"So Yahweh became indignant with Israel and cast them far away from his presence, leaving only the tribe of Judah."
,"19":"But neither did Judah keep the commandments of Yahweh, their God; on the contrary, they followed the customs practiced in Israel."
,"20":"Because of this, Yahweh rejected the whole race of Israel. He humbled them and delivered them into the hands of plunderers, until the day came when he drove them far away from his presence."
,"21":"When he divided the kingdom of David, Israel chose Jeroboam, son of Nebat, as king: he made them commit a great sin by separating themselves from Yahweh."
,"22":"The Israelites followed Jeroboam in his sins, and did not turn away from them"
,"23":"until Yahweh had removed Israel from his presence, according to the warning given them through his servants, the prophets. So Israel was exiled from its land to the country of Asshur until this day."
,"24":"The king of Asshur brought people from Babylon, Cuthah, Avva, Hamath and Sepharvaim, and he settled them in the cities of Samaria in place of the Israelites. These people occupied the country of Samaria and resided in its cities."
,"25":"When they first settled there they did not worship Yahweh, so Yahweh sent lions which killed many of them."
,"26":"Then it was reported to the king of Asshur, 'The people you deported and sent to Samaria to settle in its cities do not know how Yahweh, the God of the land, should be honored, so he has sent lions which are killing them.'"
,"27":"So the king of Asshur commanded, 'Let one of the priests we have banished from Samaria return there. Let him go and live with those people and teach them how to honor the God of that land.'"
,"28":"So, one of the priests who had been banished from Samaria came back, and staying in Bethel, taught these people how they should honor Yahweh."
,"29":"Yet each of these nations made its own gods, and placed them in the sanctuaries on the hills which the Samaritans had built. Each of these nations put their god in the city where they settled:"
,"30":"the Babylonians set up the idol Succoth, the inhabitants of Cuth made Negal, the inhabitants of Hamath made Ashima,"
,"31":"those of Avva made Nibjaz and Tartak. Those of Sepharvaim burned their children in the fire in honor of Adrammelech and Anammelech, their gods."
,"32":"They worshiped Yahweh, but they appointed for themselves priests from among their people, who served Yahweh in the Houses on the hills."
,"33":"They honored Yahweh but at the same time, served their own gods, according to the customs of the nations where they had been banished."
,"34":"Until this very day, they still observe the old customs. They do not honor Yahweh since they do not follow the precepts and customs, the Law or the commandments which Yahweh had given to the children of Jacob to whom he had given the name Israel."
,"35":"Yahweh had made a covenant with them, commanding them, 'Do not honor other gods or bow down before them, or serve them or offer them sacrifices."
,"36":"You shall honor Yahweh alone, who brought you out of the land of Egypt with the strength of his arm; before him you shall bow and to him alone shall you offer sacrifices."
,"37":"Keep the precepts, the ordinances, the Law and the commandments he wrote for you. Fulfill them all your days and do not adore strange gods."
,"38":"Do not forsake the covenant he made with you and do not adore strange gods,"
,"39":"but adore only Yahweh, your God, and he shall free you from the hand of all your enemies.'"
,"40":"But they did not pay attention; instead they followed their ancient customs."
,"41":"So these people honored Yahweh, but at the same time also served their idols; and after them, their children and their children's children continued doing what their fathers had done."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Hezekiah, son of Ahaz, began to reign in Judah in the third year of Hoshea, son of Elah, king of Israel."
,"2":"He was twenty-five years old then, and his reign in Jerusalem lasted for twenty-nine years. His mother was Abijah, daughter of Zechariah."
,"3":"He did what was right in the eyes of Yahweh, like David, his ancestor."
,"4":"He did away with the sanctuaries on the hills, demolished the standing stones and cut down the sacred pillars. He also destroyed the bronze serpent that Moses had fashioned in the desert for, until that time, the Israelites were offering sacrifices to it and called it Nehushtan."
,"5":"He trusted in Yahweh more than any of the kings of Judah who preceded or succeeded him and he never departed from Yahweh."
,"6":"He kept the commandments Yahweh had given through Moses."
,"7":"For that reason, Yahweh was with him; he succeeded in all his undertakings. He rebelled against the king of Assyria and was no longer subject to him."
,"8":"He imposed his authority on the Philistines as far as Gaza, and seized their land from the watchtowers to the fortified cities."
,"9":"In the fourth year of Hezekiah's reign, which was the seventh year of Hoshea, son of Elah, king of Israel, Shalmaneser, king of Assyria, came against Samaria and besieged it."
,"10":"At the end of three years, he conquered it. In the sixth year of Hezekiah, which was the ninth year of Hoshea, king of Israel, Samaria was conquered."
,"11":"The king of Assyria deported the Israelites to Assyria and settled them in Halah, on the Habor, the river of Gozan, and in the cities of the Medes."
,"12":"This happened to them because they did not listen to the voice of Yahweh, their God, and had broken his covenant; they did not listen to nor put into practice what Moses, the servant of Yahweh, had commanded them."
,"13":"In the fourteenth year of Hezekiah's reign, Sennacherib, king of Assyria, came up and invaded Judah; he laid siege to all the fortified cities and seized all of them."
,"14":"Hezekiah, king of Judah, sent a message to Sennacherib who was in Lachish, 'I have acted badly, stop your attack and I will do whatever you demand of me.' The king of Assyria demanded that Hezekiah give a contribution of three hundred talents of silver and thirty of gold."
,"15":"Hezekiah then handed over to him all the money that was found in the House of Yahweh and in the treasuries of the royal palace."
,"16":"It was at that time that Hezekiah ordered that the gold sheets, with which he himself had adorned the doorposts, be stripped from the gates of the House of Yahweh, and given to the king of Assyria."
,"17":"From Lachish the king of Assyria sent his field commander with a large army to King Hezekiah in Jerusalem. They halted at the channel of the Upper Pool on the highway to the Fuller's Field. The field commander called for the king; and"
,"18":"Eliakim son of Hilkiah, the palace administrator, went out to him together with Shebnah the secretary and Joah son of Asaph, the recorder."
,"19":"The field commander said to them, 'Give Hezekiah this message from the great king of Assyria: How can you be so confident?"
,"20":"You thought that words are as good as wisdom and replace strength in time of war? On whom are you relying that you rebel against me?"
,"21":"You rely on Egypt, a broken staff which pierces the palm of him who leans on it. Such is Pharaoh, king of Egypt, for all who rely on him."
,"22":"Yes, you may say to me: 'We rely on Yahweh our God.' But isn't he the one whose altars and high places Hezekiah removed when he commanded Judah and Jerusalem: You shall worship before this altar?"
,"23":"Come now, make a bargain with my master, the king. I will give you two thousand horses if you are able to supply riders."
,"24":"How could you ever repulse one of the least of my master's generals? And you rely on Egypt for chariots and horsemen!"
,"25":"Do you think that I have come to attack and destroy this land without consulting Yahweh? He himself said to me: Go up to this land and conquer it!'"
,"26":"Then Eliakim and Shebna and Joah said to the field commander, 'Speak to your servants in Aramaic; we understand it. Do not speak to us in Hebrew in the hearing of these people on the walls.'"
,"27":"But the field commander said, 'Do you think that my master sent me to speak these words only to your master and to you? Is it not also to the men on the walls who, with you, will have to eat their own dung and drink their own urine?'"
,"28":"Then the field commander stood and cried out with a loud voice in Hebrew, 'Hear the words of the great king of Assyria:"
,"29":"Do not let Hezekiah deceive you! No, he will not be able to help you!"
,"30":"Do not listen to him when he tells you to trust in Yahweh, saying, 'Yahweh will save us; this city will not be given over to the king of Assyria.' Do not listen to Hezekiah but"
,"31":"to what the king of Assyria says, 'Make your peace with me and surrender. Then I will let each of you eat of your vine and of your fig tree and drink the water of your cistern until I come again."
,"32":"Then I will take you to a land like your own land, a land of grain and new wine, of bread and vineyards, of oil and honey, that you may live and not die. Hezekiah is misleading you when he says that Yahweh will save you. "
,"33":"Have the gods of the nations rescued their land from the hands of the king of Assyria?"
,"34":"Where are the gods of Hamath and Arpad? Where are the gods of Sepharvaim, Hena and Ivvah? And have the gods delivered Samaria from my hand?"
,"35":"Who among all the gods of these nations has been able to save his country from me? Do you think that Yahweh will deliver Jerusalem from my hand?'"
,"36":"The people were like deaf men and remained silent, since the king had commanded them not to answer him."
,"37":"Then Eliakim with Shebna and Joah came to Hezekiah with their clothes torn and told him what the field commander had said."
}`)
	CurrentBook.AddChapter(19, `{
"1":"When King Hezekiah heard this he tore his clothes, covered himself with sackcloth and went to the house of Yahweh."
,"2":"He sent Eliakim, the overseer of the palace, Shebna, the secretary, and the elders among the priests, all wearing sackcloth, to the prophet Isaiah son of Amoz."
,"3":"And they said to Isaiah, 'This is what Hezekiah says: 'Today is a day of distress, rebuke and disgrace, as when children are at the point of birth and there is no strength to deliver them."
,"4":"Would that your God might hear the words of the field commander, whom his master the king of Assyria has sent. May Yahweh your God rebuke him for the words he said, insulting the living God. Therefore offer a prayer for the few of us that are left.'"
,"5":"When King Hezekiah's officials came to Isaiah,"
,"6":"he said to them: 'Tell your master this word of Yahweh: Do not fear because of the words you have heard, with which the servants of the king of Assyria have insulted me."
,"7":"Listen! I will let him be frightened. Then he will return to his country, and there I will have him slain by the sword.'"
,"8":"The field commander returned and found the king of Assyria fighting against Libnah, for he had heard that the king had left Lachish."
,"9":"This was because King Sennacherib had heard that Tirhakah, the Cushite king of Egypt, was going out to fight him. Again Sennacherib sent messengers to Hezekiah with these words, "
,"10":"'Say to Hezekiah, king of Judah that his God in whom he trusts may be deceiving him in saying that Jerusalem will not be given into the hands of the king of Assyria."
,"11":"Surely you have heard what the kings of Assyria have done to all the lands they have destroyed! And will you be spared?"
,"12":"Have their gods saved the nations that my fathers destroyed? Gozan and Haran, Rezeph and the sons of Eden who were in Telassar?"
,"13":"Where is the king of Hamath, the king of Arpad, the kings of the city of Sepharvaim, of Hena and Ivvah?'"
,"14":"Hezekiah took the letter from the messengers, and when he had read it he went to the house of Yahweh where he unrolled the letter"
,"15":"and prayed saying, 'O Yahweh, God of hosts and God of Israel, enthroned above the cherubim! You alone are God over all the kingdoms of the earth; you have made the heavens and the earth."
,"16":"Give ear, Yahweh, and hear! Open your eyes and see! Listen to all the words of Sennacherib who has sent men to insult the living God!"
,"17":"It is true, Yahweh, that the kings of Assyria have laid waste all the countries of the earth."
,"18":"They have thrown their gods into the fire and destroyed them, for they were not true gods but gods made of wood and stone by human hands."
,"19":"Now, O Yahweh our God, save us from his hand and let all the kingdoms of the earth know that you alone, Yahweh, are God.'"
,"20":"Then Isaiah, son of Amoz, sent word to Hezekiah: 'You have called upon Yahweh and he has heard your prayer regarding Sennacherib, king of Assyria."
,"21":"This is what Yahweh has spoken against him: The Virgin Daughter of Zion,despises and scorns you; the Daughter of Jerusalem,shakes her head behind you."
,"22":"Whom have you insulted and blasphemed?,Against whom have you raised your voice,and lifted up your eyes in arrogance?,Against the Holy One of Israel!"
,"23":"Through your servants,you have insulted Yahweh. For you have said: With the enormous number of my chariots, I have ascended the heights of the mountains, the topmost recesses of Lebanon. I have cut down its tallest cedars,and its choicest fir trees. I have climbed its remotest heights to the densest of its forests."
,"24":"I have dug wells and drunk waters; I have dried up with the soles of my feet all the streams of Egypt."
,"25":"Have you not heard,how I decreed it long ago, how I planned from days of old,what now I have brought to pass?,Your ordained role was,to lay waste fortified cities, to turn them into ruinous heaps."
,"26":"Shorn of power, their inhabitants,have been dismayed and confounded; they have been as the grass,and green plants in the field, as the grass on the housetops, scorched before it has grown."
,"27":"I know whenever you rise or sit, whenever you go out or come in; and I know your rage against me."
,"28":"Because of your rage against me,and your arrogance that I have heard of, I will put my hook in your nose,and my bridle in your mouth, and I will turn you back,on the way by which you came."
,"29":"This will be a sign for you, O Hezekiah: This year you will eat the after-growth grain, and next year what grows from that, but in the third year, sow and reap, plant vines and eat the fruit."
,"30":"A remnant of the house of Judah shall take root below and produce fruit above."
,"31":"For a remnant will come from Jerusalem and survivors from Mount Zion. The zeal of Yahweh of hosts will accomplish this."
,"32":"That is why Yahweh has said this concerning the king of Assyria: He shall not enter this city nor shoot his arrows. He shall not raise a shield to oppose it nor build a siege ramp against it."
,"33":"He shall leave by the way he came and he shall not enter the city, word of Yahweh."
,"34":"I will protect this city and so save it for my own sake and for the sake of David, my servant."
,"35":"It happened that the angel of Yahweh went out that night and struck one hundred and eighty-five thousand men in the Assyrian camp. When the people rose early next morning there were all the corpses."
,"36":"So Sennacherib, king of Assyria, departed, returned home and lived in Nineveh."
,"37":"While he was worshiping in the temple of his god, Nisroch, his sons Adrammelech and Sharezer slew him with the sword and then escaped to the land of Ararat. And Esarhaddon, his son, succeeded him as king."
}`)
	CurrentBook.AddChapter(20, `{
"1":"In those days Hezekiah fell mortally ill and the prophet Isaiah, son of Amoz, went to him with a message from Yahweh, 'Put your house in order for you shall die; you shall not live.'"
,"2":"Hezekiah turned his face to the wall and prayed to Yahweh,"
,"3":"'Ah, Yahweh! Remember how I have walked before you in truth and wholeheartedly, and have done what is good in your sight.' And Hezekiah wept bitterly."
,"4":"Isaiah had still not reached the central courtyard when the word of Yahweh came to him,"
,"5":"'Go back and tell Hezekiah, the ruler of my people, what Yahweh, the God of his father David, says: 'I have heard your prayer and I have seen your tears. And now I will cure you. On the third day you will go up to the house of Yahweh."
,"6":"See! I am adding fifteen years to your life and I will save you and this city from the power of the king of Assyria. I will defend it for my sake and for the sake of David my servant.'"
,"8":"Hezekiah said to Isaiah, 'What shall be the sign that Yahweh will heal me and that I shall go up to the House of Yahweh within three days?'"
,"9":"Isaiah answered, 'This shall be the sign for you in Yahweh's name, that Yahweh shall do what he has said: Do you wish the shadow of the second story to go forward ten steps or to go back?'"
,"10":"Hezekiah said, 'It is easy for the shadow to lengthen ten steps, but it shall be wonderful if the shadow goes back ten steps.'"
,"11":"The prophet Isaiah called on Yahweh, and Yahweh made the shadow go back ten steps, line by line, on the ten steps it had covered on the stairway."
,"7":"Isaiah then said, 'Bring a fig cake to rub on the ulcer and let Hezekiah be cured!'"
,"12":"At that time Merodach-baladan, son of Baladan, king of Babylon, sent letters and a gift to Hezekiah after hearing that he was recovering from an illness."
,"13":"Hezekiah rejoiced, so he showed the envoys his treasure house - the silver, the gold, the spices, the fragrant oils, his weapons and all that was in the treasury. There was nothing in this palace, or in all he possessed that Hezekiah did not show."
,"14":"Then the prophet Isaiah went to the king and said, 'What did these men say? Where did they come from?' The king answered, 'They have come from a far country, from Babylon.'"
,"15":"Isaiah said, 'And what have they seen in your house?' The king answered, 'They have seen all that is in my house; there is nothing in my treasuries that I did not show them.'"
,"16":"So Isaiah said to the king, 'Listen to this word of Yahweh:"
,"17":"The days are coming when all that is in your house and all that your fathers have stored up to this day shall be taken to Babylon; nothing shall be left, says Yahweh."
,"18":"Some of your own sons who are born of your blood shall be taken away, and they shall be eunuchs in the palace of the king of Babylon.'"
,"19":"Hezekiah answered Isaiah, 'What you say is a good word from Yahweh'; for he thought, 'What does it matter just so I have peace and security in my own lifetime?'"
,"20":"Now the rest regarding Hezekiah and all about his bravery, how he built the great reservoir and how it supplied water to the city is written in the Book of the Chronicles of the Kings of Judah."
,"21":"When Hezekiah slept with his fathers, his son Manasseh reigned in his place."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Manasseh was twelve years old when he began his reign, and he reigned for fifty-five years in Jerusalem. His mother's name was Hephzibah."
,"2":"He treated Yahweh very badly, imitating the wretched practices of the people Yahweh had driven out from the land in order to give it to the Israelites."
,"3":"He rebuilt the sanctuaries on the hills, which had been destroyed by Hezekiah his father. He built altars to the god Baal and made a sacred pillar similar to the one Ahab, king of Israel, had made. He knelt before all the stars of heaven and worshiped them."
,"4":"He built altars in the courtyard of the House of Yahweh, about which Yahweh had said, 'Jerusalem shall be the dwelling place of my Name.'"
,"5":"He built altars for all the stars of heaven in the two courtyards of the House of Yahweh."
,"6":"He sacrificed his son by fire. He practiced soothsaying and magic, he brought in seers and wizards, doing without ceasing what Yahweh condemned, and thus provoking his anger."
,"7":"He even put up the sacred pillar of the goddess Asherah in the House of Yahweh in spite of what Yahweh had said to David and to his son, Solomon: 'I shall let my Name rest forever in this House, for I have chosen Jerusalem from among all the tribes of Israel."
,"8":"I shall no longer let Israel wander out of the land I gave to their fathers, provided that you try to live according to all the Law I gave you through my servant Moses.'"
,"9":"But they did not listen, and Manasseh led them into doing things worse than those nations had done whom Yahweh had expelled before the Israelites."
,"10":"So Yahweh spoke through the mouth of his servants, the prophets, saying,"
,"11":"'Manasseh, king of Judah, has multiplied the wretched practices and has acted worse than the Amorites. He has made the people of Judah sin with his repugnant images."
,"12":"Therefore, I shall bring upon Jerusalem and upon Judah an evil so great that the ears of those who hear of it shall buzz."
,"13":"Jerusalem and its kings shall suffer the fate of Samaria and of the family of Ahab. I will wipe Jerusalem as one wipes a plate to clean it, and then turns it upside down."
,"14":"I shall drive away the rest of my people and give them over into the hands of their enemies so that they shall become their prey and booty."
,"15":"For they did what displeased me and made me angry from the day when their fathers came out of Egypt to this day.'"
,"16":"Manasseh also shed innocent blood in such quantity that it filled up Jerusalem from one end to the other, besides the sins which he made Judah commit, doing what is wrong in the sight of Yahweh."
,"17":"The rest regarding Manasseh, all that he did and the sins he committed, is written in the Book of the Chronicles of the Kings of Judah."
,"18":"When Manasseh died, they buried him in the garden of his house, in the garden of Uzza, and his son Amon reigned in his place."
,"19":"Amon was twenty-two years old when he began his reign, and he reigned for two years in Jerusalem; his mother's name was Meshullemeth, daughter of Haruz, of the city of Jotbah."
,"20":"He treated Yahweh badly, as his father Manasseh had done."
,"21":"He completely followed in the footsteps of his father - he served the idols his father had served and bowed down before them."
,"22":"He abandoned Yahweh, the God of his fathers, and did not walk in the way of Yahweh."
,"23":"The officials of Amon conspired against him, and murdered him in his house."
,"24":"But the citizens killed all who had plotted against the king, and they proclaimed his son Josiah king in his place."
,"25":"The rest regarding Amon and all that he did is written in the Book of the Chronicles of the Kings of Judah."
,"26":"They buried him in his tomb, in the garden of Uzza, and his son Josiah reigned in his place."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Josiah was eight years old when he began to govern, and he reigned for thirty-one years in Jerusalem. His mother was Jedidah, daughter of Adaiah of Bozkath."
,"2":"He did everything that was right in the eyes of Yahweh, and followed in the footsteps of David, his father, without turning aside either to the right or to the left."
,"3":"In the eighteenth year of his reign, King Josiah sent his secretary Shaphan, son of Azaliah, son of Meshullam, to the House of Yahweh, saying,"
,"4":"'Go up to the high priest Hilkiah and give him the amount of money which the people offer for the House of Yahweh, and that which the gatekeepers have collected, and when these have been smelted down,"
,"5":"let them turn it over to those in charge of the House of Yahweh."
,"6":"It shall be given to those carpenters and construction workers who do the repairs of the House. In the same way, they shall buy the wood and stones needed for the repair of the House."
,"7":"But do not ask from them any account of the money, for they are honorable men.'"
,"8":"At that moment Hilkiah, the high priest, said to Shaphan, the secretary, 'I have found the Book of the Law in the House of Yahweh.' And he entrusted the Book to Shaphan who read it."
,"9":"Then Shaphan went to the king and said, 'We have gathered the money in the House, and this has been turned over to the caretakers of the House to make the repairs.'"
,"10":"And Shaphan added, 'The priest Hilkiah has turned over a book to me.' And Shaphan read the book to the king."
,"11":"When the king heard the contents of the book, he tore his clothes and"
,"12":"commanded Hilkiah, Ahikam, Achbor, the secretary Shaphan, and Asaiah, his minister, to do the following,"
,"13":"'Go and consult Yahweh about the threats in this book which you have found. Consult him for me, for the people and for the whole of Judah, since our fathers did not listen to what this book says nor to its ordinances. This is why the anger of Yahweh is ready to burn against us.'"
,"14":"The priest Hilkiah, Ahikam, Achbor, Shaphan and Asaiah went to consult the prophetess Huldah, wife of Shallum, son of Tikva, son of Harhas, keeper of the wardrobe. She lived in Jerusalem, in the new city."
,"15":"She answered them,"
,"16":"'You will say to the one who sent you to me: This is what Yahweh says: I shall bring evil upon this place and upon its inhabitants according to all the words of the book which the king of Judah has read,"
,"17":"for this people have abandoned me and they have burned incense in honor of other gods. Because of all they have done, I am angry about this place, and the fire of my anger will not be quenched."
,"18":"You shall deliver this answer to the king of Judah, who has sent you to consult Yahweh: Yahweh, the God of Israel says this - The warnings in this book shall not reach you,"
,"19":"for your heart has been touched and you have done penance in the presence of Yahweh when you heard what I have said against this place and its inhabitants, that this place shall be desolate and cursed. You have torn your garments and wept before me, and I have heard you, says Yahweh."
,"20":"Therefore, you shall join your fathers; you shall die and be buried in peace, without seeing any of the evils I shall send against this place.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"The king summoned to his side all the leaders of Judah and Jerusalem."
,"2":"Then he went up to the House of Yahweh followed by all the people of Judah and Jerusalem. The priests with the prophets and all the people went with him, from the youngest to the oldest. When all were gathered, he read to them the book of the Law found in the House of Yahweh."
,"3":"The king stood by the pillar; he made a covenant in the presence of Yahweh, promising to follow him, to keep his commandments and laws, and to respect his ordinances. He promised to keep this covenant according to what was written in the book with all his heart and with all his soul. And all the people promised with him."
,"4":"Then the king commanded the high priest Hilkiah as well as the priests of lesser rank and all the gatekeepers to bring out all the objects which had been made for Baal, Asherah and for all the stars of heaven. He had them burned outside Jerusalem, in the idle land of Kidron, and had their ashes brought to Bethel."
,"5":"The kings of Judah had appointed pagan priests who offered sacrifices in the sanctuaries on the hills, in the different cities of Judah and in the suburbs of Jerusalem. Josiah did away with them and with those who offered incense to Baal, to the sun, the moon, the stars and all the heavenly host."
,"6":"The Sacred Pillar that was in the House of Yahweh was brought out of Jerusalem and was taken to the brook Kidron, where it was burned and its ashes thrown on the public grave."
,"7":"The king demolished the house of the effeminate men who dedicated themselves to prostitution (as was done in the cult of Asherah). This was within the courtyards of the House of Yahweh, and in this house too the women wove veils for Asherah."
,"8":"Right after this he made all the priests from the cities of Judah come to Jerusalem, and he destroyed all the sanctuaries on the hills where they had offered sacrifice from Beersheba in the south to Geba in the north. He destroyed the Sanctuary of the Gates that was at the entrance of the gate of Joshua, the city governor. It was on the left side of the entrance gate to the city."
,"9":"The priests who had served in the sanctuaries on the hills could not offer sacrifices in the House of Yahweh; they only ate the unleavened bread with the priests of Jerusalem."
,"10":"The king had the place for burning human sacrifices in the valley of Ben-hinnom destroyed, so that no one could sacrifice his sons or daughters in the fire according to the ritual of Molech."
,"11":"The horses which the kings of Judah had dedicated to the sun were removed from the entrance of the House of Yahweh; these were in the atrium, near the house of the palace official, Nathanmelech. And the chariots of the sun were burned."
,"12":"There were altars which the kings of Judah had built on the roof of the palace of Ahaza. There were also altars built by Manasseh in the two courtyards of the House of Yahweh. Josiah had them all destroyed and reduced to dust, which was thrown into the brook Kidron."
,"13":"The king destroyed the sanctuaries on the hills facing Jerusalem, to the south of the Mount of Olives. Solomon, king of Israel, had built them for Ashtoreth the idol of the Sidonians, for Chemosh, the idol of Moab, and for Milcom, the idol of the Ammonites."
,"14":"The king broke in pieces the images of the false gods, cut down the sacred pillars, and filled the places in which these had been with human bones to make them unclean."
,"15":"There was also the sanctuary of Bethel, with the altar which Jeroboam, king of Israel, had made. This cult had been the sin of Israel. The king destroyed it. He set the sanctuary on fire and burned the sacred pillar."
,"16":"Looking around on all sides, Josiah saw the tombs on the mountain; he had the bones taken out of the tomb and burned on the altar. So the word of Yahweh was fulfilled which the man of God had proclaimed when Jeroboam was standing by the altar during a feast. Josiah noticed the tomb of this man of God,"
,"17":"and he said, 'What is that monument that I see?' The people of the city said to him, 'That is the tomb of the man of God who came from Judah to announce what you have just done with the altar of Bethel.'"
,"18":"The king commanded, 'Leave the tomb in peace, and let no one touch his bones.' And his bones, together with the bones of the prophet of Samaria, were not touched."
,"19":"Josiah also removed all the sanctuaries on the hills in the cities of Samaria. These sanctuaries had been made by the kings of Israel and they had provoked the anger of Yahweh. The king destroyed them and did to them as he had done to the temple of Bethel."
,"20":"He slaughtered upon the altars all the priests of the sanctuaries on the hills who were found there, and he burned human bones on the altars. Then he returned to Jerusalem."
,"21":"The king gave this order to all the people, 'Celebrate the Passover in honor of Yahweh, our God, as it is written in this Book of the Covenant.'"
,"22":"A Passover like this had not been celebrated since the days of the Judges who had governed Israel, or during the time when the kings of Israel and the kings of Judah reigned."
,"23":"This Passover was celebrated in Jerusalem in the eighteenth year of King Josiah."
,"24":"Josiah obeyed all the words of the Law written in the book which the priest Hilkiah had found in the House of Yahweh. He immediately did away with the mediums and seers, the small household gods and the idols, and all those loathsome things seen in the lands of Judah and Jerusalem."
,"25":"There had never before been a king like him who returned to Yahweh with all his heart, with all his soul, and with all his strength, observing all the Law of Moses, nor was another like him seen again."
,"26":"In spite of this, Yahweh did not turn from the fire of his anger. He was angry with Judah because of all the evils Manasseh had done."
,"27":"So Yahweh declared, 'I shall also cast Judah away from my presence as I have cast Israel; I shall no longer take Jerusalem into consideration, though it is the city I have chosen and there is the House of which I have said: My Name dwells here.'"
,"28":"The rest regarding Josiah and all that he did is written in the Book of the Chronicles of the Kings of Judah."
,"29":"In those days, the Pharaoh Neco crossed the river Euphrates and went to join the king of Asshur. King Josiah set out to confront him, but Neco killed him in Megiddo when he saw him."
,"30":"Josiah's servants brought his body in a chariot from Megiddo to Jerusalem, and they buried him in his tomb. Then the people took Jehoahaz, son of Josiah, to anoint him and make him king in place of his father."
,"31":"Jehoahaz was twenty-three years old when he began to reign, and he reigned for three months in Jerusalem. His mother was Hamutal, daughter of Jeremiah of Libnah."
,"32":"He did what displeases Yahweh, imitating his fathers."
,"33":"The Pharaoh Neco bound Jehoahaz in chains in Riblah, in the land of Hamath, since he did not want him to reign in Jerusalem. Then he imposed on the land a contribution of one hundred talents of silver and ten of gold."
,"34":"And he installed as king another son of Josiah, Eliakim, as the successor to his father, and changed his name to Jehoiakim. But he took Jehoahaz away and brought him to Egypt, where Jehoahaz died."
,"35":"Jehoiakim gave the silver and gold to the Pharaoh to pay the contribution which the Pharaoh himself exacted from him, through a tax imposed on all the land. Everyone had to pay his quota according to what he possessed. So Jehoiakim collected from all the people the gold and silver demanded by the Pharaoh."
,"36":"Jehoiakim was twenty-five years old when he began to reign, and he reigned for eleven years in Jerusalem. His mother was Zebidha, daughter of Pedaiah of Rumah."
,"37":"He did what displeased Yahweh, imitating his fathers."
}`)
	CurrentBook.AddChapter(24, `{
"1":"In those days, Nebuchadnezzar, king of Babylon, invaded the land, and Jehoiakim became subject to him for three years, after which he rebelled."
,"2":"Yahweh then sent against Jehoiakim, bands of Chaldeans, Arameans, Moabites and Ammonites. They raided the land of Judah and destroyed it according to the word Yahweh had spoken through his servants, the prophets."
,"3":"All this happened only because Yahweh had ordered it so. He willed to cast the people far away from his presence because of the sins of Manasseh, and all the evils he had done."
,"4":"And also because of the innocent blood he had shed that filled Jerusalem. Because of all this, Yahweh would not pardon them."
,"5":"The rest regarding Jehoiakim and all that he did is written in the Book of the Chronicles of the Kings of Judah."
,"6":"When Jehoiakim died, his son Jehoiachin succeeded him."
,"7":"The king of Egypt did not leave his own land again because the king of Babylon had conquered all that belonged to the king of Egypt, from the river of Egypt to the Euphrates River."
,"8":"Jehoiachin was eighteen years old when he succeeded his father, and he reigned for three months in Jerusalem. His mother was Nehushta, daughter of Elnathan of Jerusalem."
,"9":"Jehoiachin treated Yahweh badly, as his father had done."
,"10":"At that time, the officials of Nebuchadnezzar, king of Babylon, came to attack Jerusalem, surrounding the city."
,"11":"Nebuchadnezzar came while the city was being besieged by his men."
,"12":"Jehoiachin, king of Judah, surrendered together with his mother, his servants, his leaders and the palace officials. It was the eighth year of the reign of Nebuchadnezzar."
,"13":"Nebuchadnezzar captured them and he took away the treasures of the House of Yahweh and of the king's house. He also destroyed all the objects of gold which Solomon, king of Israel, had made for the sanctuary of Yahweh. So the word Yahweh had spoken, was fulfilled."
,"14":"Nebuchadnezzar carried off into exile all the leaders and prominent men, the blacksmiths and locksmiths, all the men of valor fit for war. A total of ten thousand were exiled to Babylon. Only the poorest sector of the population was left."
,"15":"Nebuchaddnezzar also carried away Jehoiachin, with his mother, his wives, the ministers of the palace, and the prominent men of the land."
,"16":"So all the prominent people, numbering seven thousand, the blacksmiths, numbering a thousand, and all the men fit for war were deported to Babylon by the king of Babylon."
,"17":"He made Mattaniah, Jehoiachin's uncle, king of Jerusalem, in place of Jehoiachin. And he changed his name to Zedekiah."
,"18":"Zedekiah was twenty-one years old, and he reigned in Jerusalem for eleven years. His mother was Hamutal, daughter of Jeremiah."
,"19":"He did what displeased Yahweh, as Jehoiakim had done;"
,"20":"so the punishment of Yahweh fell on Jerusalem and Judah, until he cast them far away from his presence. And Zedekiah rebelled against the king of Babylon."
}`)
	CurrentBook.AddChapter(25, `{
"1":"In the ninth year of Zedekiah's reign, on the tenth day of the tenth month, Nebuchadnezzar king of Babylon marched with his entire army and laid siege to Jerusalem. They camped outside the city and built siege works all around it."
,"2":"The city was under siege up to the eleventh year of Zedekiah."
,"3":"On the ninth day of the fourth month famine became a serious problem in the city, and throughout the land there was no bread for the people."
,"4":"When the city was opened by a breach in the wall, the Judean army fled through the gate between the two walls near the king's garden while the Chaldeans were still around the city and they fled towards the Arabah."
,"5":"The Chaldeans followed in hot pursuit of King Zedekiah and caught up with him in the plains of Jericho. All his army deserted and scattered."
,"6":"The Chaldeans seized the king and led him away to Riblah in the territory of Hamath and there the king of Babylon passed sentence on him."
,"7":"There at Riblah the king of Babylon slaughtered the sons of Zedekiah in his presence. He then put out the eyes of Zedekiah, bound him with a double bronze chain and took him to Babylon."
,"8":"On the seventh day of the fifth month in the nineteenth year of Nebuchadnezzar king of Babylon, Nebuzaradan, commander of the bodyguard and servant of the king of Babylon, entered Jerusalem and"
,"9":"set fire to the House of Yahweh and the royal palace as well as to all the houses in Jerusalem."
,"10":"The Chaldean army under the commander of the bodyguard completely demolished all the walls around Jerusalem."
,"11":"Nebuzaradan, commander of the bodyguard, carried off into exile the last of the Jews left in the city, those who had deserted to the king of Babylon and the remainder of the artisans."
,"12":"But he left those among the very poor who were capable of working in vineyards and cultivating the soil."
,"13":"The Chaldeans broke into pieces the bronze pillars, the stands and the bronze Sea in the House of Yahweh and carried off all this bronze to Babylon."
,"14":"They also took the pots, shovels, wick trimmers, the spoons and all the bronze articles used in the temple service."
,"15":"The commander of the bodyguard took the basins, censers, sprinkling bowls, pots, lampstands, ladles and bowls - all that was made of gold or silver."
,"16":"The two pillars, the Sea, the movable stands which King Solomon had made for the House of Yahweh - all this bronze was of immeasurable weight."
,"17":"The pillars were each eighteen cubits high. Each had a thickness of four fingers and was hollow. On top of each pillar was a bronze capital five cubits high, and above and around the capital there was filigree work with pomegranates made of bronze."
,"18":"The commander of the bodyguard took captive Seraiah the chief priest and Zephaniah the next priest in rank, as well as three doorkeepers."
,"19":"He also took from those in the city a eunuch in command of the fighting men, five personal advisers to the king who were discovered in the city, the commander's secretary, responsible for military conscription, and sixty of his men who were found in the city."
,"20":"Nebuzaradan took all these away to the king of Babylon at Riblah."
,"21":"There at Riblah in the territory of Hamath the king of Babylon had them put to death. So Judah was taken away captive from its own land."
,"22":"As for the remnant of the people whom Nebuchadnezzar, king of Babylon, had left behind, he appointed Gedaliah, son of Ahikam, son of Shaphan, as their governor."
,"23":"When the commanders of the troops and their men heard that the king of Babylon had appointed Gedaliah as governor, they went to him at Mizpah. These were Ishmael, son of Nethaniah, Johanan, son of Kareah, Seraiah, son of Tanhumeth, from Natophah, Jaazaniah the Macaathite, with their men."
,"24":"Gedaliah told them and their men most solemnly, 'Do not be afraid of submitting yourselves to the Chaldeans. Live in the country obeying the king of Babylon, and all will be well with you.'"
,"25":"In the seventh month, however, Ishmael, son of Nethaniah son of Elishama, who belonged to the king's family, came with ten of his men and killed Gedaliah as well as the Judeans and the Chaldeans who were with him at Mizpah."
,"26":"Then all the people, from the greatest to the least, set out with the commanders of the troops and took refuge in Egypt, in fear of the Chaldeans."
,"27":"On the twenty-seventh day of the twelfth month in the thirty-seventh year of the exile of Jehoiakin king of Judah, Evil-merodah, king of Babylon, in the year he came to the throne pardoned Jehoiakin king of Judah and released him from prison."
,"28":"He spoke kindly to him, and gave him more honorable treatment than the other kings who were with him in Babylon."
,"29":"Jehoiakin put aside his prison garment and for the rest of his life ate at the king's table."
,"30":"Day by day, for as long as he lived, he was maintained by the king of Babylon."
}`)

}
func EN_CCB_LoadVH2SChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"It was thus that Saul died. As for David, he returned after defeating the Amalekites. He was already two days in Ziklag"
,"2":"when, on the third day, a man came from Saul's camp, with his clothes torn and dust strewn on his head. He went to David and fell to the ground in homage."
,"3":"David asked him, 'Where are you from?' And he answered, 'I have escaped from the Israelite camp.'"
,"4":"David then said, 'Tell me what happened.' And the man told him, 'The soldiers fled from the battle but many of them fell and died. Saul and his son Jonathan - they too are dead.'"
,"5":"Then David asked the young man who reported this, 'How do you know that Saul and his son Jonathan are dead?'"
,"6":"The young man replied, 'I happened to be on Mount Gilboa and I saw Saul leaning on his spear while chariots and horsemen were closing in on him."
,"7":"He turned around and, seeing me, called me."
,"8":"I said, 'Here I am.' He asked, 'Who are you?' and I replied, 'I am an Amalekite.'"
,"9":"He then said to me, 'Come here and kill me for I feel dizzy though I am fully alive.'"
,"10":"So I went over and killed him, for I knew that he would fall and not rise again. Then I removed the crown from his head and the armlet from his arm, both of which I have here to give you, my lord.'"
,"11":"At this, David took hold of his clothes and tore them and his men did the same."
,"12":"And they mourned, weeping and fasting until evening, for the death of Saul and his son Jonathan, for all the people of Judah and for the nation of Israel."
,"13":"David asked the young man who told him this, 'Where are you from?' And he answered, 'I am the son of an Amalekite immigrant.'"
,"14":"David said, 'Why were you not afraid to lay your hands on Yahweh's anointed and kill him?'"
,"15":"He then called one of his men and ordered him, 'Come and strike him down.' He struck down the Amalekite and killed him."
,"16":"David declared, 'You will answer for your own blood for you condemned yourself when you said, 'I have killed Yahweh's anointed'.'"
,"17":"David sang this song of lamentation for Saul and his son Jonathan, and had it taught to the people of Judah. It is called 'The Bow'"
,"18":"and is found in the Book of the Just."
,"19":"'Your glory, O Israel, is slain upon your mountains!,How the mighty ones have fallen!"
,"20":"Tell it not in Gath, proclaim it not in the streets of Ashkelon,lest the Philistine women rejoice, lest foreign maidens exult."
,"21":"Mountains of Gilboa, let neither dew nor rain visit you, no more fertile fields on you!,For on you the shield of the valiant was defiled."
,"22":"The shield of Saul was not anointed with oil; but with the blood of the slain. From the fat of the warriors, the bow of Jonathan did not turn back, nor did the sword of Saul return unstained."
,"23":"Saul and Jonathan, beloved and cherished, neither in life nor in death were they parted; swifter than eagles they were,and stronger than lions."
,"24":"Women of Israel, weep over Saul,who clothed you in precious scarlet."
,"25":"How the valiant have fallen!,In the midst of the battle Jonathan lies slain on your mountains."
,"26":"I grieve for you, my brother Jonathan; how dear have you been to me!,Your love for me was wonderful, even more than the love of women."
,"27":"How the valiant have fallen!,The weapons of war have perished!'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"After this, David consulted Yahweh, 'Shall I go up to one of the cities of Judah?' Yahweh answered him, 'Go!' Then David asked, 'Where shall I go?' He answered, 'To Hebron.'"
,"2":"So David went up to Hebron with his two wives, Ahinoam of Jezreel and Abigail the widow of Nabal of Carmel."
,"3":"David also brought up his men with their families and they settled in the towns of Hebron."
,"4":"Then the men of Judah came and there they anointed David king over the nation of Judah. David learned that the men of Jabesh-gilead had buried Saul, "
,"5":"so he sent messengers to them with these words, 'May Yahweh bless you for you have dealt kindly with Saul, your master, and have buried him."
,"6":"May Yahweh show his love and fidelity to you! I, in turn, will be kind to you for having done this."
,"7":"Now be brave and strong for although your master Saul is dead, the people of Judah have anointed me their king.'"
,"8":"Now Abner, son of Ner, Saul's general, had taken Ishbaal, son of Saul, and brought him over to Mahanaim"
,"9":"where he made him king over Gilead, the Ashurites, Jezreel, Ephraim, Benjamin and the rest of Israel."
,"10":"Ishbaal, Saul's son, was forty years old when he began to reign over Israel, and he reigned for two years. Only the people of Judah followed David."
,"11":"David was their king in Hebron and he ruled over them for seven years and six months."
,"12":"Abner, son of Ner, and the menservants of Ishbaal, Saul's son, left Mahanaim for Gibeon"
,"13":"where Joab, son of Zeruiah and the men of David met them at the pool of Gibeon. There they sat, one group on one side of the pool, the other on the opposite side."
,"14":"Abner told Joab, 'Let the young men rise and perform for us.' Joab replied, 'Let them rise!'"
,"15":"So they rose and were counted off: twelve of the Benjaminites of Ishbaal, Saul's son, and twelve of David's men."
,"16":"Each one caught his opponent's head and thrust his sword in his opponent's side, and all fell down together. Therefore, that place in Gibeon was called field of the fighting."
,"17":"After a very fierce battle that day, Abner and the men of Israel were defeated by David's troops."
,"18":"The three sons of Zeruiah - Joab, Abishai and Asahel - were there."
,"19":"Asahel, who ran as fast as a wild gazelle, pursued Abner, turning neither to the right nor to the left."
,"20":"Abner turned around and asked, 'Is that you, Asahel?' He replied, 'Yes, it is I.'"
,"21":"Abner said to him, 'Turn right or left, go after one of the young men and take his spoil.' But Asahel refused to desist from following him,"
,"22":"so Abner again said, 'Stop following me! I will surely strike you down and then, how could I face your brother Joab?'"
,"23":"But Asahel would not heed, and Abner, without turning back, struck him in the belly with his spear which ran through him and came out his back. He fell and died on the spot and all who came to the place where Asahel fell dead, stopped there."
,"24":"Joab and Abishai, however, pursued Abner and, by sunset, arrived at the hill of Ammah which lies near Giah toward the desert of Gibeon."
,"25":"The Benjaminites then rallied around Abner, forming one band, and took their position on the hilltop."
,"26":"Then Abner called to Joab, 'When will the sword rest? Do you not realize that this will bring you more bitterness? When will you order your men to stop pursuing their brothers?'"
,"27":"Joab replied, 'As God lives, if you had not spoken, my men would have continued pursuing their brothers until morning.'"
,"28":"So Joab blew the trumpet and the men desisted from pursuing the Israelites and fighting them."
,"29":"Abner and his men marched all night through the lowland, crossed the Jordan, and marched the whole morning until they reached Mahanaim."
,"30":"As for Joab, he stopped pursuing Abner and gathered all his men. Besides Asahel, nineteen of David's servants were missing."
,"31":"But David's men had killed three hundred and sixty of Abner's men from among the Benjaminites."
,"32":"Asahel was taken and buried in his father's tomb at Bethlehem. Then Joab and his men marched all night and reached Hebron at daybreak."
}`)
	CurrentBook.AddChapter(3, `{
"1":"There was a long war between Saul's party and that of David, but David grew stronger while Saul's party grew weaker."
,"2":"Sons were born to David at Hebron: his firstborn, Amnon, of Ahinoam of Jezreel;"
,"3":"his second, Chileab, of Abigail, widow of Nabal of Carmel; the third, Absalom, son of Maacah the daughter of Talmai, king of Geshur;"
,"4":"the fourth, Adonijah, the son of Haggith; the fifth, Shephatiah, the son of Abital;"
,"5":"and the sixth, Ithream, of David's wife Eglah. These were born to David in Hebron."
,"6":"While war was going on between the party of Saul and that of David, Abner was strengthening his position in Saul's family."
,"7":"Now Saul had a concubine named Rizpah, daughter of Aiah, on whose account Ishbaal chided Abner, 'Why have you slept with my father's concubine?'"
,"8":"Abner was very angry because of Ishbaal's remark and exclaimed, 'Am I a dog's head? Up to now I have been loyal to the family of Saul your father, to his brothers and friends, and have not delivered you into the hands of David, and you come accusing me because of this woman."
,"9":"May God deal with me severely if I do not do for David what Yahweh swore to him -"
,"10":"to transfer the kingdom from the family of Saul to that of David and make him king of Israel and Judah to rule over all the land from Dan to Beersheba.'"
,"11":"Ishbaal could no longer say a word to Abner for he feared him."
,"12":"Abner then sent messengers to David at Hebron saying, 'To whom does the land belong? Enter into an agreement with me and I shall help you obtain all Israel.'"
,"13":"David replied, 'I will make an agreement with you, but on one condition: you may appear before me when you bring me Saul's daughter, Michal.'"
,"14":"Then David sent messengers to Ishbaal, Saul's son, to tell him, 'Give me my wife Michal whom I married for the price of a hundred Philistine foreskins.'"
,"15":"Ishbaal sent for her and took her away from her husband Paltiel, son of Laish,"
,"16":"who followed her weeping all the way to Bahurim. There Abner said to him, 'Go back!' and he turned back."
,"17":"Abner conferred with the elders of Israel and told them, 'You have long wanted to have David as your king."
,"18":"Well, make it come true; for Yahweh made a promise to David and said: By my servant David, I will save my people Israel from the Philistines and from all their enemies.'"
,"19":"Abner also spoke to the people of Benjamin; then he went to tell David at Hebron the proposals of Israel and the Benjaminites."
,"20":"When Abner came to David at Hebron, David prepared a feast for him and the twenty men who were with him."
,"21":"Then Abner said to David, 'I will now go and assemble all Israel for my master the king, that they may enter into an agreement with you, and that you may reign over all those you want to rule.'"
,"22":"Just then, David's men and Joab arrived from a raid taking along with them a great deal of booty. Abner was no longer with David at Hebron for he had departed quietly after David had dismissed him."
,"23":"When Joab arrived with his troops he was told, 'Abner, son of Ner, came to see the king; then the king sent him on his way and he went in peace.'"
,"24":"Joab then went to the king and said, 'What did you do? When Abner came to you, why did you allow him to leave?"
,"25":"You know what Abner, son of Ner, is like; he came to you deceitfully to observe and find out what you are doing.'"
,"26":"Joab left David and sent messengers to go after Abner and they had him brought back from the cistern of Sirah. But David did not know of that."
,"27":"When Abner arrived at Hebron, Joab took him aside within the city gate as though to speak with him, privately. There he stabbed him in the belly and he died. Joab did so in revenge for the murder of his brother, Asahel."
,"28":"Later on, David heard about this. Then he said, 'Yahweh will not punish me and my kingdom for the blood of Abner, son of Ner."
,"29":"May justice for his blood fall on Joab and on all his father's family, and may there be forever among them some member who has discharge, or is sick with leprosy, or who is only fit to hold a spindle, or who falls by the sword or hungers!'"
,"30":"Joab and his brother Abishai slew Abner because he had killed their brother Asahel in the battle at Gibeon."
,"31":"David then told Joab and those who were with him, 'Tear off your clothes, put on sackcloth and mourn before Abner.' King David himself followed the corpse."
,"32":"They buried Abner at Hebron; there the king wept aloud over his grave and all the people joined in the lamentation."
,"33":"The king began the mourning song for Abner with these words, 'Should Abner die as a fool dies?"
,"34":"Your hands were not bound, your feet were not fettered; as one falls at the hands of the wicked, so you have fallen.' And all the people again wept over him."
,"35":"Then the people tried to persuade David to take some food while it was still day, but David swore, 'May God do so to me and more if I touch food before sundown!'"
,"36":"The people heeded this and it pleased them; in fact, they were pleased at whatever the king said."
,"37":"This day they realized, as did all the people of Israel, that the king had no part in the murder of Abner, son of Ner."
,"38":"Then the king said to his servants, 'Do you realize that a general and valiant warrior passed away today in Israel?"
,"39":"Although I am the anointed king, today I feel helpless to control the sons of Zeruiah. May Yahweh repay the one who did evil.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"When Ishbaal, Saul's son, heard that Abner had died at Hebron, he was stunned and the Israelites were disheartened."
,"2":"Saul's son had two men, captains of raiding bands: one was Baanah, the other Rechab, both sons of Rimmon, a Benjaminite from Beeroth. For Beeroth was still considered part of Benjamin;"
,"3":"the Beerothites fled to Gittaim and have remained there as immigrants to the present day."
,"4":"(Jonathan, son of Saul, had a son whose feet were crippled. He was five years old when the news came from Jezreel about the death of Saul and Jonathan. His nurse took him up and fled so hastily that the boy fell and became lame. He was called Mepibaal.)"
,"5":"Now Rechab and Baanah, sons of Rimmon, the Beerothite, went their way and arrived in the heat of the day at the house of Ishbaal who was taking a nap."
,"6":"His doorkeeper had been cleaning wheat, but feeling drowsy, she slept; Rechab and his brother Baanah got into the house."
,"7":"They rushed into Ishbaal's bedroom as he lay asleep in his bed and struck him dead. They beheaded him, took his head and left, walking all night by the way of the Arabah."
,"8":"They brought Ishbaal's head to David at Hebron and said to the king, 'Here is the head of Ishbaal son of Saul, your enemy who sought your life. This day Yahweh has avenged my lord the king, on Saul and his son.'"
,"9":"But David answered Rechab and his brother Baanah, sons of Rimmon the Beerothite, 'Let Yahweh hear, he who has saved me from all adversities."
,"10":"When somebody reported Saul's death to me, thinking he was bringing me good news, I took hold of him and killed him at Ziklag, instead of giving him a reward."
,"11":"Will I do less when wicked men have murdered a just one in his own house and on his bed? Shall I not now demand his blood from your hands and sweep you away?'"
,"12":"So David commanded his young men to kill them. They cut off their hands and feet and hung them beside the pool at Hebron. Then they took Ishbaal's head and buried it in Abner's tomb on Hebron."
}`)
	CurrentBook.AddChapter(5, `{
"1":"All the tribes of Israel came to David at Hebron and said, 'We are your bone and flesh."
,"2":"In the past, when Saul was king over us, it was you who led Israel. And Yahweh said to you, 'You shall be the shepherd of my people Israel and you shall be commander over Israel.'"
,"3":"Before Yahweh, King David made an agreement with the elders of Israel who came to him at Hebron, and they anointed him king of Israel."
,"4":"David was thirty years old when he began to reign, and he reigned for forty years:"
,"5":"he reigned over Judah, from Hebron, seven and a half years; and over Israel and Judah, from Jerusalem, for thirty-three years."
,"6":"The king and his men set out for Jerusalem to fight the Jebusites who lived there. They said to David, 'If you try to break in here, the blind and the lame will drive you away,' which meant that David could not get in."
,"7":"Yet David captured the fortress of Zion that became the 'city of David.'"
,"8":"That day David said, 'Whoever wants to defeat the Jebusites, let him reach these lame and blind, David's enemies, through the tunnel for fetching water.' From this came the saying, 'The blind and the lame shall not enter the house.'"
,"9":"David lived in the fortress, calling it the City of David, and proceeded to build the city around it, from the Millo and inside as well."
,"10":"And David grew more powerful, for Yahweh, the God of hosts, was with him."
,"11":"Hiram, king of Tyre, sent messengers to David with cedar trees, carpenters and masons to build a house for David."
,"12":"David then understood that Yahweh had made him king over Israel and had exalted his reign for the sake of his people Israel."
,"13":"After David had come from Hebron he took more concubines and wives from Jerusalem, and more sons and daughters were born to him."
,"14":"These are the names of those who were born to him in Jerusalem: Shammua, Shobab, Nathan, Solomon,"
,"15":"Ibhar, Elishua, Nepheg, Japhia,"
,"16":"Elishama, Eliada and Eliphelet."
,"17":"When the Philistines heard that David had been anointed king of Israel, they went to search for him. On hearing this, David went down to the stronghold."
,"18":"When the Philistines overran the valley of Rephaim,"
,"19":"David consulted Yahweh, 'Shall I attack the Philistines? Will you deliver them into my hands?' Yahweh answered David, 'Go ahead, for I will certainly deliver the Philistines into your hands.'"
,"20":"So David came to Baalperazim where he defeated them. He said, 'Yahweh has scattered my enemies before me like a sudden bursting flood.' That is why that place is called Baalperazim."
,"21":"There the Philistines left their idols and David and his men picked them up."
,"22":"The Philistines went up again and overran the valley of Rephaim."
,"23":"David consulted Yahweh who said, 'Do not go up straight but circle around and attack them from behind when you are in front of the balsam trees."
,"24":"Once you hear a marching sound on top of the balsam trees, act quickly, for Yahweh is going ahead of you to attack the Philistine army.'"
,"25":"David obeyed Yahweh's command and struck down the Philistines from Giba to as far as Gezer."
}`)
	CurrentBook.AddChapter(6, `{
"1":"David gathered together once more all the picked men of Israel, numbering thirty thousand in all."
,"2":"Then he and all the people with him in Baala-Judah set forth to bring up from there the ark of God on which Yahweh of hosts pronounced and put his Name, he who rests on the cherubim."
,"3":"They placed the ark of God on a new cart and brought it out of the house of Abinadab on the hill. Uzzah and Ahio, sons of Abinadab, were guiding the cart"
,"4":"with the ark of Yahweh, with Ahio walking before it."
,"5":"David and the Israelites were joyfully celebrating before Yahweh, singing and playing on lyres, harps, tambourines, castanets and cymbals."
,"6":"When they came to the threshing floor of Nacon, the oxen stumbled and Uzzah stretched his hand to the ark of God to hold it."
,"7":"Yahweh's anger burnt against Uzzah and God struck him there; Uzzah died there beside the ark of God."
,"8":"David was angry because Yahweh had struck Uzzah, and that place is called Perez-Uzzah to the present day."
,"9":"David was afraid of Yahweh that day and said, 'How can the ark of Yahweh come to me?'"
,"10":"So David refused to take the ark of Yahweh into the city of David but had it brought, instead, to the house of Obededom the Gittite."
,"11":"Yahweh's ark remained there for three months and Yahweh blessed Obededom and all his household."
,"12":"King David was told that Yahweh had blessed the family of Obededom and all that belonged to him because of the ark of God, so he went to bring up the ark of God from the house of Obededom to the city of David, rejoicing."
,"13":"After those who carried the ark of Yahweh had walked six paces, they sacrificed an ox and a fattened calf."
,"14":"David whirled round dancing with all his heart before Yahweh, wearing a linen ephod,"
,"15":"for he and all the Israelites brought up the ark of Yahweh, shouting joyfully and sounding the horn."
,"16":"As the ark of Yahweh entered the city of David, Michal, Saul's daughter, looked out of the window; and when she saw King David leaping and whirling round before Yahweh, she despised him in her heart."
,"17":"They brought in the ark of Yahweh and laid it in its place in the tent which David had pitched for it. Then David offered burnt and peace offerings before Yahweh."
,"18":"Once the offerings had been made, David blessed the people in the name of Yahweh of hosts,"
,"19":"and distributed to each of them, to each man and woman of the entire assembly of Israel, a loaf of bread, a portion of meat and a raisin cake. With this, all the people left for their homes."
,"20":"When David returned to bless his household, Michal, Saul's daughter, met him and said, 'How the king of Israel honored himself today, exposing himself before his servants' maids as uncouth men do!'"
,"21":"But David said to Michal, 'I did that before Yahweh who chose me instead of your father and his family, making me commander over Israel, Yahweh's people. By Yahweh's life I swear that I will dance and whirl again before him."
,"22":"I will humble myself still more and you may look at me, but I will not be rejected by the maids you spoke about.'"
,"23":"And Michal, Saul's daughter, had no child to the day she died."
}`)
	CurrentBook.AddChapter(7, `{
"1":"When the king had settled in his palace and Yahweh had rid him of all his surrounding enemies,"
,"2":"he said to Nathan the prophet, 'Look, I live in a house of cedar but the ark of God is housed in a tent.'"
,"3":"Nathan replied, 'Do as it seems fit to you for Yahweh is with you.'"
,"4":"But that very night, Yahweh's word came to Nathan,"
,"5":"'Go and tell my servant David, this is what Yahweh says: Are you able to build a house for me to live in?"
,"6":"I have not dwelt in a house since I brought the Israelites up from Egypt to the present day, but I went about with a tent for shelter."
,"7":"As long as I walked with the Israelites, did I say anything to the chiefs of Israel whom I commanded to shepherd my people Israel? Did I say: Why have you not built me a house of cedar?"
,"8":"Now you will tell my servant David, this is what Yahweh of hosts says: I took you from the pasture, from tending the sheep, to make you commander of my people Israel."
,"9":"I have been with you wherever you went, cutting down all your enemies before you. Now I will make your name great as the name of the great ones on earth."
,"10":"I will provide a place for my people Israel and plant them that they may live there in peace. They shall no longer be harassed, nor shall wicked men oppress them as be-fore."
,"11":"From the time when I appointed judges over my people Israel it is only to you that I have given rest from all your enemies. Yahweh also tells you that he will build you a house."
,"12":"When the time comes for you to rest with your ancestors, I will raise up your son after you, the one born of you and I will make his reign secure."
,"13":"He shall build a house for my name and I will firmly establish his kingship forever."
,"14":"I will be a father to him and he shall be my son. If he does wrong, I will punish him with the rod, as men do."
,"15":"But I will not withdraw my kindness from him as I did from Saul when I removed him out of your way."
,"16":"Your house and your reign shall last forever before me, and your throne shall be forever firm.'"
,"17":"Nathan repeated these words and related this vision to David."
,"18":"Then King David went in, sat before Yahweh and said, 'Who am I, O Yahweh God, and who is my family that you have brought me so far?"
,"19":"Yet this was not enough for you, O Yahweh God, for you have also spoken of your servant's house for a long time to come. Is this the way men act, O Yahweh God?"
,"20":"What more can David say to you? You know your servant, O Yahweh God!"
,"21":"You fulfill your promise and carry out your plan, as you do now in bringing about all these great things and revealing them to your servant."
,"22":"Therefore you are great, O Yahweh God, for there is no one like you, nor is there a God other than you from all that we ourselves have heard."
,"23":"Is there on earth another nation like your people Israel, whom God has come to redeem, and to make his people? Indeed you made them famous when you did, for your glory, great and awesome things, rescuing them out of Egypt, from their people and their gods."
,"24":"You have set apart your people Israel to become your people forever; and you, Yahweh, have become their God."
,"25":"Now, O Yahweh God, keep forever the promise you made and have now revealed to me regarding myself and my family,"
,"26":"that your name may be honored forever and people may say, 'Yahweh of hosts is God over Israel.' The house of your servant David will be secure before you"
,"27":"because you, O Yahweh of hosts, God of Israel, have made it known to your servant and have said to him: 'Your family will last forever.' This is why I have dared to address this prayer to you."
,"28":"So now, O Yahweh God, since you are the faithful God, and have promised me this good thing,"
,"29":"please bless my descendants, that they may continue forever before you. For you, O Yahweh God, have spoken and, with your blessing, my family shall be blessed forever.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"After this, David defeated the Philistines, crushing them in such a way that they were no longer in control of the land."
,"2":"Then he defeated the Moabites. He had them measured with a line and made them lie down on the ground; two thirds of them were to be executed, and one third to be spared. And so the Moabites became David's servants and paid tribute to him."
,"3":"David also defeated Hadadezer, son of Rehob, king of Zobah, when he tried to retake the valley of the Euphrates."
,"4":"David captured from him a thousand and seven horsemen and twenty thousand foot soldiers. He hamstrung all the chariot horses but left a sufficient number for a hundred chariots."
,"5":"The Arameans of Damascus came to help Hadadezer, king of Zobah, but David won over twenty-two thousand of their men."
,"6":"Then David set up governors in Aram of Damascus and the Arameans became David's servants, paying tribute to him. Yahweh made David victorious wherever he went. "
,"7":"David took the golden shields carried by the servants of Hadadezer and brought them to Jerusalem;"
,"8":"he also took a great quantity of bronze from Betah and Berothai, cities of Hadadezer."
,"9":"When Toi, king of Hamath heard that David had defeated the entire army of Hadadezer,"
,"10":"he sent his son Joram to King David to greet him and thank him for having fought against Hadadezer and defeating him. For the latter had often been at war with Toi. Joram brought with him articles of silver, gold and bronze"
,"11":"which King David consecrated to Yahweh together with the silver and gold which he consecrated from all the nations he subdued:"
,"12":"from Edom, Moab, the Ammonites, the Philistines, Amalek, as well as the booty of Hadadezer, son of Rehob, king of Zobah."
,"13":"David became famous when he returned from defeating an army of eighteen thousand Edomites in the Valley of Salt."
,"14":"He set up governors in Edom and the Edomites became his servants. So Yahweh made David victorious wherever he went."
,"15":"David reigned over all Israel, issuing decrees and administering justice to all his people."
,"16":"Joab, son of Zeruiah, was commander of the army; Jehoshaphat, son of Ahilud, recorder;"
,"17":"Zadok, son of Ahitub and Ahimelech, son of Abiathar, priests; Seraiah, secretary;"
,"18":"and Benaiah, son of Jehoiada, was in charge of the Cherethites and the Pelethites. David's sons were priests."
}`)
	CurrentBook.AddChapter(9, `{
"1":"David asked, 'Is there anyone left of the house of Saul to whom I can show kindness for the sake of Jonathan?'"
,"2":"So they called a servant of Saul, named Ziba, and brought him to David who asked, 'So you are Ziba?' He replied, 'I am your servant.'"
,"3":"Then the king asked him, 'Is there still someone of the house of Saul to whom I can give God's favor?' Ziba answered the king, 'A son of Jonathan whose feet are crippled still lives.'"
,"4":"The king asked him, 'Where is he?' And Ziba replied, 'He is in the house of Machir, son of Ammiel, at Lodebar.'"
,"5":"So King David sent for him and had him brought from the house of Machir, son of Ammiel, at Lodebar."
,"6":"When Mepibaal, son of Jonathan, son of Saul arrived, he fell on the ground and paid homage to David who said, 'Mepibaal!' He replied, 'Your servant listens.'"
,"7":"David then told him, 'Do not be afraid. I will do you a favor for the sake of your father Jonathan and give you back all the land of Saul your father. Besides, you shall always eat at my table.'"
,"8":"He bowed down and said, 'What is your servant that you should show concern for a dead dog like myself?'"
,"9":"The king called Ziba, Saul's servant, and said to him, 'I have turned over to your master's son everything that Saul and his family possessed."
,"10":"You yourself, your sons and servants shall till the land for him and carry in the harvest so that your master's family may have food, although your master's son Mepibaal shall always eat at my table.' Ziba, who had fifteen sons and twenty servants"
,"11":"said to the king, 'Your servant will do whatever my lord the king commands. Yet Mepibaal ate at my table like a king's son.'"
,"12":"Mepibaal had a young son named Mica; and all who lived in Ziba's house became Mepibaal's servants."
,"13":"But Mepibaal lived in Jerusalem for he always ate at the king's table. He was lame in both feet."
}`)
	CurrentBook.AddChapter(10, `{
"1":"When the king of the Ammonites died and Hanun his son reigned in his place,"
,"2":"David said, 'I will be kind to Hanun son of Nahash as his father was kind to me.' So David sent his servants to comfort him over his father's death. When David's servants arrived in the land of the Ammonites,"
,"3":"the Ammonite chiefs told Hanun their lord, 'Do you think that, by sending men with condolences, David is honoring your father? Has not David rather sent his servants to you to explore the city, spy on it and overthrow it?'"
,"4":"At this, Hanun seized David's servants, shaved off half their beard, cut away the lower halves of their garments even up to their hips and sent them away."
,"5":"When this was reported to David, he sent messengers to meet these men who felt greatly ashamed and to tell them, 'Stay in Jericho and return after your beards have grown.'"
,"6":"The Ammonites saw that David could no longer bear with them, so they sent for and hired the Arameans of Beth-rehob and of Zobah numbering twenty thousand foot soldiers, the king of Maacah with one thousand men and also twelve thousand men of Tob."
,"7":"On hearing this, David sent out Joab with all the warriors."
,"8":"The Ammonites came out in battle formation at the entrance gate while the Arameans of Zobah and Rehob and the men of Tob and Maacah grouped separately in the open country."
,"9":"When Joab saw that there were two battlefronts, one in front of him and the other behind, he selected picked men of Israel and arranged them in battle formation against the Syrians."
,"10":"Then he entrusted the rest of his army to Abishai his brother and arranged them in battle formation against the Ammonites."
,"11":"And he said, 'If the Syrians are too strong for me, you shall help me; but if the Ammonites are too strong for you, I will come to your assistance."
,"12":"Take courage! Let us act like men for the sake of our people and God's cities; and may Yahweh do what seems good to him.'"
,"13":"Joab and the people who were with him launched the attack against the Arameans and put them to flight."
,"14":"When the Ammonites saw the Arameans fleeing, they too fled before Abishai and entered the city. Then Joab returned from his battle against the Ammonites and came to Jerusalem."
,"15":"When the Arameans saw that they had been defeated by Israel, they gathered together."
,"16":"Hadadezer sent for the Syrians and had them brought from beyond the Euphrates. They came to Helam with Shobach, the commander of Hadadezer's army, leading them."
,"17":"This was reported to David who, in turn, gathered together all Israel and came to Helam after crossing the Jordan. The Arameans then arranged themselves in battle formation and fought against David,"
,"18":"but they fled before Israel. David had seven hundred of the men in chariots and forty thousand horsemen killed. Shobach, too, the commander of their army was slain and died there."
,"19":"After having been defeated by Israel, all the kings who depended on Hadadezer made peace with Israel and became subject to them. So the Arameans no longer dared to help the Ammonites."
}`)
	CurrentBook.AddChapter(11, `{
"1":"In the spring of that year, when kings usually set out to fight, David sent out Joab, his officers and all the Israelite troops. They slaughtered the Ammonites and attacked Rabbah, while David remained in Jerusalem."
,"2":"One afternoon, David got up from his siesta and took a walk on the roof of the royal house. From the rooftop, he saw a woman bathing, and the woman was very beautiful."
,"3":"David sent to inquire about the woman, and was told, 'She is Bathsheba, daughter of Eliam and wife of Uriah, the Hittite.'"
,"4":"So David sent messengers to have her brought to him; and he had intercourse with her after she had cleansed herself after her monthly period. Then she returned to her house."
,"5":"As the woman saw she was with child, she sent word to David, 'I am with child.'"
,"6":"David then sent a message to Joab, 'Send me Uriah the Hittite.' So Joab sent Uriah to David."
,"7":"When Uriah came, David asked him about Joab, how the people were and how the war was proceeding;"
,"8":"then he told Uriah, 'Go down to your house and wash your feet.',Uriah left the palace and the king had a portion from his table sent to him. "
,"9":"Uriah, however, did not go down to his house but slept by the door of the king's palace with all the servants of his lord."
,"10":"David was told that Uriah did not go down to his house, and he said to him, 'Have you not come from a journey? Why did you not go down to your house?'"
,"11":"Uriah replied, 'The ark, the men of Israel and Judah are housed in tents while my lord Joab and his servants are encamped in the open country. Shall I go to my house to eat and drink there and sleep with my wife? As you live, I will not do this!'"
,"12":"So David said to Uriah, 'Remain here today also and I will dismiss you tomorrow.' Uriah therefore stayed in Jerusalem that day and the day after."
,"13":"David invited him to table and he ate and drank until he was drunk. When evening fell, however, he went to lie down on his couch with the guards of his lord instead of going down to his house."
,"14":"The next morning, David wrote Joab a letter to be taken by hand by Uriah,"
,"15":"in which he said, 'Place Uriah in the front row where the fighting is very fierce and then withdraw from him so that he may be struck down and die.'"
,"16":"When Joab was attacking the city, he assigned Uriah to a place which he knew was being defended by strong warriors."
,"17":"And the defenders attacked the men of Joab. Some of David's soldiers and officers were killed; Uriah the Hittite also died."
,"18":"Then Joab sent a messenger to tell David everything that had happened during the battle."
,"19":"And he said to him, 'When you have finished recounting the outcome of the battle to the king,"
,"20":"perhaps he will get angry and ask you, 'Why did you go so near the city to fight? Did you not know they would shoot from the wall?"
,"21":"Who killed Abimelech, son of Jerubbesheth? Was it not a woman who dropped a millstone on him from the wall so that he died at Thebez? Why did you go so close to the wall?'; then you shall say: Your servant Uriah the Hittite is also dead.'"
,"22":"So the messenger went to tell David all that Joab instructed him."
,"23":"So he answered the king and explained, 'These men had overcome us and pushed us in the field; then we drove them back to the entrance gate."
,"24":"But the archers aimed at your guard from the top of the wall, killing some of them. Your servant Uriah the Hittite has also been killed.'"
,"25":"David said to the messenger, 'Try to encourage Joab with this message: Do not let this thing disturb you, for the sword devours one this time and another at another time. Intensify your attacks against the city and overthrow it.'"
,"26":"When Uriah's wife heard of the death of her husband, she mourned for him."
,"27":"After her mourning was over, David had her brought to his house. She became his wife and bore him a son. But Yahweh was displeased with what David had done."
}`)
	CurrentBook.AddChapter(12, `{
"1":"So Yahweh sent the prophet Nathan to David. Nathan went to the king and said to him, 'There were two men in a city: one was rich; the other, poor."
,"2":"The rich man had many sheep and cattle,"
,"3":"but the poor man had only one little ewe lamb he had bought. He himself fed it and it grew up with him and his children. It shared his food, drank from his cup and slept on his lap. It was like a daughter to him."
,"4":"Now a traveler came to the rich man, but he would not take from his own flock or herd to prepare food for the traveler. Instead, he took the poor man's lamb and prepared that for his visitor.'"
,"5":"David was furious because of this man and told Nathan, 'As Yahweh lives, the man who has done this deserves death!"
,"6":"He must return the lamb fourfold for acting like this and showing no compassion.'"
,"7":"Nathan said to David, 'You are this man! It is Yahweh, God of Israel, who speaks: 'I anointed you king over Israel and saved you from Saul's hands;"
,"8":"I gave you your master's house and your master's wives; I also gave you the nation of Israel and Judah. But if this were not enough, I would have given you even more."
,"9":"Why did you despise Yahweh by doing what displeases him? You struck down Uriah the Hittite with the sword and took his wife for yourself. Yes, you killed him with the sword of the Ammonites."
,"10":"Now the sword will never be far from your family because you have despised me and taken the wife of Uriah the Hittite for yourself."
,"11":"Thus says Yahweh: Your misfortune will rise from your own house! I will take your wives from you and give them to your neighbor who shall lie with them in broad daylight."
,"12":"What you did was done secretly, but what I do will be done before Israel in broad daylight.'"
,"13":"David said to Nathan, 'I have sinned against Yahweh.' Nathan answered him, 'Yahweh has forgiven your sin; you shall not die."
,"14":"However, because you have dared to despise Yahweh by doing such a thing, the child that is born to you shall die.'"
,"15":"Then Nathan left and went to his house. Yahweh struck the child that Uriah's wife bore to David and it became sick. "
,"16":"David entreated God for the child; he kept a strict fast and lay on the ground the whole night."
,"17":"The elders of his house asked him to rise from the ground but he refused. Nor did he join them to eat."
,"18":"On the seventh day, the child died. David's servants were afraid to tell him that the child was dead for they said, 'When the child was still alive, we spoke to him but he would not listen to us. What will he do if we tell him the child is dead?'"
,"19":"When David saw his servants whispering to one another, he realized that the child was dead and asked them, 'Is the child dead?' They replied, 'He is dead.'"
,"20":"Then David rose from the ground, washed and anointed himself, and changed his clothes. He entered the house of Yahweh and worshiped. After that, he went to his own house, asked for food and ate. "
,"21":"Then his servants asked him, 'Why are you acting like this? You fasted and wept for the child while it was alive; but after it died, you got up and took food.'"
,"22":"David answered, 'While the child was still alive, I fasted and wept thinking: who knows? Perhaps Yahweh will be kind to me and let my child live."
,"23":"But now that he is dead, why should I fast? Can I bring him back to life? I can go to him but he cannot return to me.'"
,"24":"David comforted his wife Bathsheba. He went in and slept with her and she bore a son whom he named Solomon. Yahweh loved him"
,"25":"and made it known through Nathan the prophet, who named him Jedidiah on Yahweh's behalf."
,"26":"Joab fought against Rabbah of the Ammonites and conquered the king's city."
,"27":"Then he sent messengers to David and told him, 'I have fought against Rabbah and conquered the city of waters."
,"28":"Gather then the rest of the people to attack and capture the city lest I myself do it and the city be called by my name.'"
,"29":"So David mustered the people, attacked and captured Rabbah."
,"30":"He took the crown of their god Milkom from its head, the weight of which was a talent of gold, and which had a precious stone embedded in it. This they put on David's head. He carried off an amount of booty"
,"31":"and brought away the people whom he set to labor with saws, iron picks and iron axes, making them work at the brick-kilns. David dealt like this with all the Ammonite cities, then he returned to Jerusalem with all the people."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Now David's son Absalom had a beautiful sister named Tamar. It happened that Amnon, another of David's sons, loved her."
,"2":"Amnon was so obsessed that he became ill and, as Tamar was a virgin, he could not do anything."
,"3":"Amnon had a friend named Jonadab, son of Shimeah, David's brother. Jonadab, who was a very shrewd man, said to him,"
,"4":"'Oh son of the king, why do you look so miserable morning after morning? Will you not tell me?' Amnon replied, 'I love Tamar, sister of my brother Absalom.'"
,"5":"So Jonadab said to him, 'Lie down on your bed and pretend to be ill; and when your father comes to see you, say to him, 'Let my sister Tamar come to give me bread to eat and let her prepare the food in my presence so that I may eat it from her hand.'"
,"6":"So Amnon lay down and pretended to be ill; and when the king came to see him, he told the king, 'Please let my sister Tamar come to make some cakes in my presence; I will eat from her hand.'"
,"7":"So David sent for Tamar and said to her, 'Go to your brother Amnon's house and prepare him some food.'"
,"8":"Tamar went to her brother Amnon's house where he was lying down. She took dough, kneaded it, made and baked cakes before him."
,"9":"But when she took the pan and set the cakes before him, he refused to eat and said, 'Send everyone outside.' After they all left,"
,"10":"Amnon said to Tamar, 'Bring the food into the bedroom and let me eat from your hand.' Tamar took the cakes she had made and brought them to her brother Amnon in the bedroom."
,"11":"But when she brought them to him to eat, he grabbed her and said, 'Come, lie with me, my sister.'"
,"12":"She answered him, 'No, my brother, do not force me. No such thing is done in Israel. Do not commit this foolishness."
,"13":"Where will I hide my shame? And you yourself would be regarded as a foolish man by all the people. So please, talk to the king for he will not keep me from you.'"
,"14":"But he refused to listen to her and, being stronger than she, forced her and lay with her."
,"15":"Afterwards, Amnon hated her with a hatred exceeding the love he had had for her; and he said to Tamar, 'Get up and leave.'"
,"16":"But she answered him, 'No, my brother. Sending me away is a greater offense than what you did to me.' But Amnon refused to listen."
,"17":"He called his servant and said, 'Get this woman out and bolt the door behind her.'"
,"18":"(Now Tamar was wearing a long robe with sleeves like the virgin daughters of the king used to wear.) So the servant brought her out, bolting the door behind her."
,"19":"Tamar then put ashes on her head and tore the long robe she was wearing. Laying her hand on her head, she went away crying aloud."
,"20":"Her brother Absalom spoke to her, 'Has your brother Amnon been with you? Be calm and do not take this to heart for he is your brother.' Desolate as she was, Tamar stayed in her brother Absalom's house."
,"21":"When King David heard of this, he was very angry but he did not like to scold Amnon because he loved him as his firstborn."
,"22":"Absalom, for his part, no longer spoke to Amnon. He hated him for having raped his sister Tamar."
,"23":"Two years later, when Absalom had celebrated the shearing of his flock at Baalhazor near Ephraim, he invited all the king's sons."
,"24":"He himself went to the king and said, 'I have shearers; so please let the king and his servants accept my invitation.'"
,"25":"But the king answered Absalom, 'No, my son, not all of us should go lest we be a burden to you.' As Absalom urged him the king refused to go personally but gave him his blessing."
,"26":"Then Absalom said, 'If you will not go, please let my brother Amnon come with us.' The king replied, 'Why should he go with you?'"
,"27":"But Absalom insisted until the king allowed Amnon and all the king's sons to go with him. Absalom prepared a royal feast."
,"28":"Then he commanded his servants, 'Watch until Amnon gets drunk and when I tell you, 'Strike Amnon,' kill him. Have no fear for I myself have given you this order. Be brave and determined.'"
,"29":"So Absalom's servants did to Amnon what he had commanded. On seeing this all the sons of the king hastily mounted their mules and fled."
,"30":"While they were on the way, a report reached David, 'Absalom has slain all the king's sons, leaving no one alive.'"
,"31":"At this, the king tore his garments and lay on the ground; and all his servants around him also tore their garments."
,"32":"But Jonadab, son of Shimeah, David's brother, said, 'Don't imagine that they have killed all your sons. Only Amnon is dead, for Absalom had decided to kill him from the day Amnon raped his sister Tamar."
,"33":"So let not my lord the king believe that all his sons are dead: Amnon alone is dead.'"
,"34":"Meanwhile, Absalom had fled. Then the young watchman saw many people coming from the Horonaim road by the side of the mountain."
,"35":"Jonadab said to the king, 'Was it not true what I said to you? It is your sons who are coming.'"
,"36":"As soon as he had spoken, the king's sons came, crying aloud; the king, too, and all his servants wept bitterly."
,"38":"As for Absalom, he fled to Talmai son of Ammihud, king of Geshur, where he remained for three years."
,"39":"All this time King David mourned for his son. And when he had recovered from the death of Amnon he began to yearn for Absalom."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Now Joab son of Zeruiah saw that the king was yearning for Absalom."
,"2":"So he sent a messenger to Tekoa to fetch a wise woman and he told her this, 'Please pretend to be a mourner. Put on mourning garments and do not perfume yourself with oil that you may look like a woman who has been mourning for several days for the dead"
,"3":"and go to the king with this message.' And Joab told her what to say."
,"4":"When the woman of Tekoa appeared before the king, she fell on her face in homage and said, 'Help me, O king!'"
,"5":"The king asked her, 'What is wrong?' She answered, 'Alas, I am a widow; my husband is dead."
,"6":"I, your handmaid, had two sons who quarreled with one another in the field. Since there was no one to part them, one struck the other and killed him."
,"7":"Now the entire family demand that I give up the one who struck his brother. And they say: 'We will kill him and avenge his brother's death.' So they want to quench my remaining hope; with this they will leave my husband without name or posterity on the earth.'"
,"8":"Then the king said to the woman, 'Go home and I will give orders on your behalf.'"
,"9":"But the woman of Tekoa said to the king, 'Let me and my family be blamed, my lord the king, and let the king and his throne not be criticized for this.'"
,"10":"The king said, 'If anyone says anything to you, bring him to me and he shall never bother you again.'"
,"11":"Then she said, 'Please let the king swear by Yahweh, his God, that the avenger of blood may not deepen my disgrace by killing my son.' The king replied, 'As Yahweh lives, not one hair of your son shall perish.'"
,"12":"Then the woman said, 'Please allow me to say something to my lord the king.' The king told her, 'Speak.'"
,"13":"And she went on, 'Why do you yourself act against the people of God? In giving this decision, the king condemns himself for not having brought his banished son back home."
,"14":"We are all mortals and as water spilt on the ground cannot be gathered up again, so God does not make the soul return. So let the king find a way to bring back his banished son."
,"15":"Now, if I have come to talk about this to my lord the king, it is because the people scared me and I thought, 'I will speak to the king; perhaps he will listen to me."
,"16":"If he agrees to help me when I tell him about the man who seeks to cut off both me and my son from the inheritance God gave us,"
,"17":"he will surely give the decision which will bring us peace. For my lord the king is like an angel of God in understanding everything. Yahweh your God be with you!'"
,"18":"Then the king said to the woman, 'Do not hide anything from me when I question you.' The woman replied, 'Let my lord the king speak.'"
,"19":"The king asked, 'Is Joab behind you in all this?' The woman answered, 'As you surely live, my lord the king, all is as my lord the king says. It was your servant Joab who ordered me and taught me everything I had to say."
,"20":"Joab did this to disguise the purpose. But my lord is as wise as an angel of God, knowing all things that happen on earth.'"
,"21":"Then the king told Joab, 'Well, I shall do it. Go, fetch the young man Absalom.'"
,"22":"Joab fell on his face to the ground in homage and blessed the king, saying, 'Today I know that you look kindly on me, my lord the king, because you have granted this my request.'"
,"23":"Joab went on his way to Geshur to fetch Absalom and bring him to Jerusalem."
,"24":"The king, however, told him, 'Let him stay in his own house for I shall not receive him.' So Absalom stayed in his own house and was not received by the king."
,"25":"In all Israel, there was no one as praised for his handsome appearance as Absalom, from the sole of his feet to the crown of his head he was without defect."
,"26":"When he cut his hair (every year he cut his hair when it became too heavy for him), he weighed it, and it weighed two hundred shekels by the king's weight."
,"27":"There were born to Absalom three sons and a daughter named Tamar, a beautiful woman."
,"28":"For two years Absalom stayed in Jerusalem but the king did not receive him."
,"29":"Absalom called for Joab to send him to the king, but Joab refused to see him. He called for him a second time but Joab would not come."
,"30":"So Absalom said to his servants, 'You know Joab's field which is next to mine, planted with barley. Go set it on fire.' And so they did. Then the servants of Joab came to him to tell him, 'The servants of Absalom set your field on fire.'"
,"31":"Then Joab went to Absalom's house and asked him, 'Why have your servants set my field on fire?'"
,"32":"Absalom replied, 'Come over, for I want to send you to the king with this message, 'Why did you let me return from Geshur? It would be better for me to be there yet.' Now I want to be received by the king. If I am guilty, let him send me to death!'"
,"33":"Joab went to the king and brought him the message. So the king called for Absalom who appeared before the king, bowing low with his face to the ground. And the king embraced Absalom."
}`)
	CurrentBook.AddChapter(15, `{
"1":"After this, Absalom got himself a chariot and horses, as well as fifty men to run before him."
,"2":"Absalom used to rise early and stand beside the gateway. Whenever a man with a grievance came before the king's tribunal, Absalom would call to him and say, 'From which city are you?' Should he say, 'Your servant is from such and such a tribe in Israel,'"
,"3":"Absalom would tell him, 'Your cause is good and just but there is no one to hear you on behalf of the king.'"
,"4":"Absalom added, 'I wish I were judge in the land! Then every man with a grievance or cause could come to me and I would give him justice.'"
,"5":"Whenever a man approached to pay him homage, he would stretch out his arms to hold and embrace him."
,"6":"Absalom did this to all Israelites who came to the tribunal of the king, winning their hearts for himself."
,"7":"After four years, Absalom said to the king, 'Please allow me to go and fulfill the vow I have to pay to Yahweh in Hebron."
,"8":"For while I lived at Geshur in Aram, I made this vow: 'If Yahweh will really bring me back to Jerusalem, I shall go there to worship him!'"
,"9":"The king said to him, 'Go in peace,' and he left for Hebron."
,"10":"Absalom sent spies throughout the tribes of Israel with this instruction, 'As soon as you hear the trumpet sound, proclaim: 'Absalom is king in Hebron!'"
,"11":"Two hundred men from Jerusalem had left with Absalom as invited guests. But nothing of his purpose dawned on them."
,"12":"While Absalom was offering the sacrifices, he sent for Ahitophel the Gilonite, David's counselor, from his city Giloh. Meantime, the conspiracy grew strong and the number of people with Absalom kept increasing."
,"13":"A messenger came to report to David that the Israelites were siding with Absalom."
,"14":"Then David said to all his servants who were with him in Jerusalem, 'Let us flee, for we cannot resist Absalom. Go quickly, lest he come hurriedly and overtake us. Surely he will put the city to the sword if he can bring disaster upon us.'"
,"15":"The king's servants answered him, 'Your servants are with you in whatever my lord the king decides.'"
,"16":"The king departed with all his household, but left ten concubines behind to take care of the house."
,"17":"The king left on foot and the people followed him. They stopped at the last house of the city and"
,"18":"his servants marched past him, as well as the Cherethites, the Pelethites and all the six hundred Gittites who had followed him from Gath, and went ahead of him."
,"19":"Then the king said to the commander, Ittai, the Gittite, 'Why are you also coming with us? Go back and stay with your king, for you are a foreigner, an exile from your home."
,"20":"Are you setting out when you have just arrived? Shall I make you wander about with us? Go back, take your brothers with you and may Yahweh show you kindness and faithfulness."
,"21":"Ittai, however, answered the king, 'As Yahweh lives, and as my lord the king lives, wherever my lord the king shall be, whether in life or in death, there also will your servant be.'"
,"22":"Then David said to Ittai,'Go then, march on.' So Ittai the Gittite marched on with all his men and all the children who were with him."
,"23":"Meanwhile, all those in the countryside wept aloud as all the people passed by. Then the king crossed the brook Kidron and all the people moved on to the desert."
,"24":"The priest Zadok came with all the Levites bearing the ark of the Covenant of God. They set down the ark of God where Abiathar stood until the people had all gone out of the city;"
,"25":"after which the king said to Zadok, 'Carry the ark of God back into the city. If Yahweh looks kindly on me, he will bring me back and allow me to again see the ark and its lodging place."
,"26":"But if he says, 'I am not pleased with you,' I am here; let him do to me what seems good to him.'"
,"27":"The king also said to the priest Zadok, 'See, better go back to the city in peace and take with you your son Ahimaaz, and Jonathan, son of Abiathar."
,"28":"I will wait in the desert fords until you send word for me.'"
,"29":"So Zadok and Abiathar carried the ark of God back to Jerusalem and remained there."
,"30":"David himself went up the Mount of Olives, weeping. He was barefooted and had his head covered, and all the people who were with him had their heads covered and wept as they went."
,"31":"When David was informed that Ahitophel was among the conspirators with Absalom, he said, 'O Yahweh, turn the counsel of Ahitophel into folly.'"
,"32":"When David reached the summit where God is worshiped, Hushai the Archite met him with his coat torn and dust strewn on his head."
,"33":"David said to him, 'If you come with me, you will be a burden to me."
,"34":"It would be better for you to return to the city and say to Absalom, 'I will be your servant, O king! Just as I have been your father's servant in the past, I will now be your servant.' In that way you will be useful to me in thwarting the counsel of Ahitophel."
,"35":"The priests Zadok and Abiathar are there to help you. Report whatever you hear from the king's house."
,"36":"Both their sons are there, Ahimaaz, Zadok's son, and Jonathan, Abiathar's son, and you shall report to me through them everything you hear.'"
,"37":"So David's friend Hushai arrived in the city just as Absalom was entering Jerusalem."
}`)
	CurrentBook.AddChapter(16, `{
"1":"When David had gone a little beyond,the summit, Ziba the steward of Mepibaal met him with saddled asses laden with two hundred loaves of bread, a hundred bunches of raisins, a hundred summer fruits and a skin of wine. "
,"2":"The king then asked Ziba, 'Why have you brought these?' Ziba answered, 'The asses are for the king's household to ride on. The bread and summer fruit are for your servants to eat, while the wine is drink for those who faint in the desert.'"
,"3":"Then the king asked him, 'Where is your master's son?' Ziba replied, 'He is staying in Jerusalem, for he said, 'Today the Israelites will give me back my father's kingdom!'"
,"4":"To this, the king said, 'Everything that belongs to Mepibaal is now yours.' And Ziba said, 'I pay homage to my lord the king. May I always find favor with you.'"
,"5":"When King David came to Bahurim, a man from the clan of Saul's family named Shimei, son of Gera, came out cursing him."
,"6":"He threw stones at David and his officers although the king's men and warriors flanked the king on the right and left."
,"7":"Shimei said as he cursed, 'Go away! Go away! You bloodthirsty good-for-nothing!"
,"8":"Yahweh has brought down on your head all the blood of the family of Saul. You became king in his place, but God has now placed the kingdom in the hands of your son Absalom. Ruin has come upon you because you are a bloodthirsty man.'"
,"9":"Then Abishai, son of Zeruiah, said to the king, 'Why should this dead dog curse my lord the king? Let me go and cut his head off.'"
,"10":"But the king said, 'Why should I listen to you, sons of Zeruiah? If Yahweh has ordered him to curse me, who shall ask him why he acts like this?'"
,"11":"Then David said to Abishai and his officers, 'If my own son wants to kill me, how much more this Benjaminite! Leave him alone and let him curse me if Yahweh has ordered him to do so."
,"12":"Perhaps Yahweh will look on my affliction and turn to good things the curses heaped on me today.'"
,"13":"So David and his men went their way while Shimei, following on the hillside opposite him, continued to curse as he threw stones and flung dust at him."
,"14":"The king, together with his men, arrived exhausted at the Jordan where he refreshed himself."
,"15":"Now Absalom, accompanied by Ahitophel, entered Jerusalem with all the Israelites."
,"16":"When Hushai the Archite, David's friend, appeared before Absalom and exclaimed, 'Long live the king!'"
,"17":"Absalom said to Hushai, 'Is this your loyalty to your friend? Why did you not go with your friend?'"
,"18":"Hushai said to Absalom, 'No, I will be with the one Yahweh and this people and the Israelites have chosen, and with him I will remain."
,"19":"Whom am I now to serve? Are you not his son? As I have served your father, so will I serve you.'"
,"20":"Then Absalom said to Ahitophel, 'Have a meeting to decide what we shall do.'"
,"21":"Ahitophel said to Absalom, 'Go and be with the concubines your father has left to keep his house. When the Israelites hear that you have made yourself odious to your father, all those of your party will be strengthened.'"
,"22":"So they pitched a tent for Absalom on the terrace and Absalom went in to his father's concubines in the sight of the Israelites."
,"23":"In those days, Ahitophel's counsel was deemed as sound as the oracle of God, and so it was deemed by both David and Absalom."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Ahitophel said to Absalom, 'Let me choose twelve thousand men that I may set out and pursue David tonight."
,"2":"I will attack him while he is tired and discouraged and throw him into a panic. All those who are with him will flee so I will strike down only the king."
,"3":"Then I will bring all the people back to you as a bride comes home to her husband. Seek the death of only one man and then all the people will be unharmed.'"
,"4":"The advice pleased Absalom and all the elders of Israel."
,"5":"Then Absalom said, 'Call in Hushai the Archite to hear what he has to say.'"
,"6":"When Hushai came before Absalom, Absalom asked him, 'Ahitophel has given this advice. Shall we follow it? If not, you speak.'"
,"7":"So Hushai said to Absalom, 'This time, Ahitophel's advice is not good."
,"8":"You know that your father and his men are warriors. When enraged, they are like a bear robbed of her cubs in the field. Besides, your father is expert enough in war not to spend the night with his men."
,"9":"Right now he is hiding in one of the pits or in some other place. If some of your men fall in the first attack, whoever hears of it will say, 'There has been a slaughter among the men who follow Absalom.'"
,"10":"Then even the valiant man whose heart is like that of a lion will utterly melt with fear, for all Israel knows that your father is a warrior, as are the men who are with him."
,"11":"My advice is for you to gather all the Israelites from Dan to Beersheba, as many as the sands of the sea, and go to battle in person."
,"12":"Then we shall find him wherever he is and fall on him as the dew falls on the ground. Neither he nor any of his men will be left alive."
,"13":"If he withdraws into a city, all Israel will bring ropes and drag it into the valley until not even a pebble of it remains.'"
,"14":"Absalom and all the Israelites said, 'The counsel of Hushai the Archite is better than the counsel of Ahitophel.' For Yahweh had decreed that the good counsel of Ahitophel be defeated, so that he might bring evil upon Absalom."
,"15":"Then Hushai reported to the priests Zadok and Abiathar, 'Ahitophel advised Absalom and the elders of Israel in this way; but I have advised them in this manner."
,"16":"Therefore send word to David quickly, 'Do not lodge tonight at the desert fords. Go beyond them lest the King and all the men with him be trapped!'"
,"17":"Now Jonathan and Ahimaaz were waiting at Enrogel where a maidservant regularly went to report to them so they could go and tell king David, for they themselves must not be seen in the city."
,"18":"But a lad saw them and reported to Absalom. The two hurriedly left the place and entered the house of a man of Bahurim who had a well in his courtyard, and they got down into it."
,"19":"The woman took a covering and spread it over the well's mouth, then scattered grain over it without anyone noticing."
,"20":"When Absalom's servants came to the woman's house, they asked, 'Where are Ahimaaz and Jonathan?' The woman answered them, 'They left, following the brook.' They looked for them but could not find them; and so they returned to Jerusalem."
,"21":"After they had gone, the men came up out of the well and went to tell David, 'Hurry and cross over the river, for this is what Ahitophel has counseled against you.'"
,"22":"So David and all those who were with him crossed over the Jordan; and by daybreak, not one was left who had not crossed the Jordan."
,"23":"When Ahitophel saw that his advice was not followed, he saddled his ass and rode back home to his own city. After setting his house in order, he hanged himself and died. He was then buried in the tomb of his father."
,"24":"David had already entered Mahanaim when Absalom crossed over the Jordan with all the Israelites."
,"25":"Absalom had put Amasa in charge of the army instead of Joab. Amasa was the son of Ithra, an Ishmaelite who had married Abigail the daughter of Isai, sister of Zeruiah, the mother of Joab."
,"26":"The Israelites and Absalom pitched camp in the land of Gilead."
,"27":"When David arrived at Mahanaim, Shobi the son of Nahash from Rabbah of the Ammonites, and Machir the son of Ammiel from Lodebar, and Barzillai the Gileadite from Rogelim,"
,"28":"brought beds, basins, earthen vessels, wheat, barley, meal, roasted grain, beans and lentils, honey and curds, sheep and cheese from the herd. All this was for David and the people with him to eat"
,"29":"for they said, 'The people are hungry, weary and thirsty in the desert.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"David then mustered the men who were with him and set over them commanders of a thousand men and commanders of a hundred men. He sent forth the army, of which one third was under the command of Joab;"
,"2":"one third, under the command of Abishai, son of Zeruiah, Joab's brother, and one third, under the command of Ittai, the Gittite. Then the king said to the men, 'I myself will go out with you.'"
,"3":"But the men replied, 'You shall not go out. They could not care less if we flee or if half of us die. But you are worth ten thousand of us and it is better if you are able to send us assistance from the city.'"
,"4":"So the king said to them, 'I will do whatever seems best to you.' Then the king stood by the side of the gate while the entire army marched out by hundreds and by thousands."
,"5":"The king ordered Joab, Abishai and Ittai, 'Don't hurt the young man Absalom for my sake.' All the army heard the king giving orders to all the commanders concerning Absalom."
,"6":"The army of David went out into the field against Israel. The battle was fought in the forest of Ephraim"
,"7":"where the Israelites were defeated by the men of David. The slaughter there on that day was great, numbering twenty thousand men."
,"8":"The battle spread over the entire country and more people perished in the ravines of the forest than were killed by the sword that day."
,"9":"Absalom was riding a mule and happened to meet the guards of David. As the mule passed under the thick branches of a big oak tree, his head was caught in the oak tree and he was left hanging between heaven and earth, while the mule he was riding went its way."
,"10":"Someone reported to Joab, 'I saw Absalom hanging from an oak tree.'"
,"11":"Joab said to the man who reported this, 'What! You saw him but did not strike him at once? I would have given you ten pieces of silver and a belt.'"
,"12":"But the man answered Joab, 'Even if I felt in my hand the weight of a thousand pieces of silver, I would not raise my hand against the king's son, for we heard the king command you, Abishai and Ittai: 'For my sake, spare the young man Absalom.'"
,"13":"If I had not done my duty, the king would come to know about it and you yourself would have kept your distance.'"
,"14":"Joab replied, 'I will not waste time talking with you.' So he took three spears in his hand and thrust them into Absalom's heart while he was still alive in the oak tree."
,"15":"Then ten guards, Joab's armor-bearers, surrounded Absalom and struck him down."
,"16":"Joab blew the trumpet and the troops stopped pursuing the Israelites as Joab restrained them."
,"17":"They then took Absalom, threw him into a deep pit in the forest and covered him with a great heap of stones. In the meantime all the Israelites fled, each one to his own home."
,"18":"During his lifetime Absalom had a memorial created for himself in the king's Valley for he said, 'I have no son by whom my name may be remembered.' He called the pillar after his own name and, to this day, it is called Absalom's monument."
,"19":"Then Ahimaaz, the son of Zadok, said, 'Let me run and report to the king that Yahweh has delivered him from the power of his enemies.'"
,"20":"But Joab said to him, 'Today you would not be a bearer of good news; another day you will run, but today there is no good news because the king's son is dead.'"
,"21":"Joab then said to a Cushite, 'Go tell the king what you have seen.' The Cushite bowed before Joab and ran."
,"22":"But Ahimaaz, the son of Zadok, again said to Joab, 'Come what may, let me also run behind the Cushite.' Joab asked, 'Why must you run, my son, seeing that you will have no reward for this news?'"
,"23":"Ahimaaz insisted, 'It does not matter, I will run.' So Joab allowed him to go, and Ahimaaz ran by way of the plain, outrunning the Cushite."
,"24":"David was sitting between the two gates. The watchman posted at the roof of the gate, on the wall, saw a man running alone."
,"25":"So he called out and reported to the king who said, 'If he is alone, he brings good news.' As he was drawing near,"
,"26":"the watchman saw another man running. So he called to the gatekeeper and said, 'Look, another man is running alone!' The king said, 'He also brings good news.'"
,"27":"The watchman said, 'The first man runs like Ahimaaz, the son of Zadok.' The king replied, 'He is a good man, so he comes with good news.'"
,"28":"Then Ahimaaz cried out to the king, 'All is well.' Bowing before the king with his face to the ground, he said, 'Blessed be Yahweh your God who has delivered up the men who rebelled against my lord the king!'"
,"29":"The king asked him, 'How is the young Absalom?' Ahimaaz answered, 'When Joab sent your servant, I saw a great tumult but did not know what it was all about.'"
,"30":"So the king said, 'Move away and stand here.' He moved aside and stayed there."
,"31":"The Cushite arrived and said, 'Good news for my lord the king! Yahweh has done you justice today and saved you from all those who rebelled against you.'"
,"32":"The king asked the Cushite, 'How is the young Absalom?' The Cushite answered, 'May the enemies of my lord the king and all who rebel against you end up like that young man.'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"The king was greatly disturbed and, going up to the room over the gate, he wept and said, 'O, my son Absalom! My son, my son Absalom! Would that I had died instead of you, O Absalom, my son, my son!'"
,"2":"It was reported to Joab, 'The king is weeping and mourning for Absalom.'"
,"3":"So the victory that day turned into mourning for all the people, when they heard that the king was grieving over his son."
,"4":"The people quietly entered the city that day, like those fleeing from battle in shame."
,"5":"The king covered his face and was crying aloud, 'O my son Absalom, O Absalom, my son, my son!'"
,"6":"Joab then came to the king's house and said, 'You have today put to shame all your servants who saved your life, the lives of your sons and daughters, and of your wives and concubines."
,"7":"Yes, you love those who hate you and hate those who love you. For you have made it clear today that your commanders and guards mean nothing to you. I know that if Absalom were alive today and all of us dead, you would be pleased."
,"8":"You must now show yourself and say a good word to your guards for, I swear by Yahweh, if you do not, no one will stay with you tonight, and this will be worse than all the evil that has happened to you from your youth to the present day.'"
,"9":"So the king took his seat at the gate and as the people were informed that the king was sitting at the gate, they came before him. The people of Israel had fled, each man to his own home. "
,"10":"Yet throughout all the tribes of Israel, the people were arguing, 'The king who delivered us from the Philistines has had to flee because of Absalom."
,"11":"We ourselves anointed Absalom to rule over us. But if he died in battle, what prevents us from bringing back the king?'"
,"12":"King David heard what the Israelites said. So he sent this message to the priests Zadok and Abiathar, 'Say to the elders of Judah: 'Why should you be the last to bring the king back to his house?"
,"13":"You are relatives, of my own race. Why should you be the last to bring back the king?'"
,"14":"Say also to Amasa, 'Are you not of my own family? I swear before God that I will make you general of my army in place of Joab.'"
,"15":"So he won over the men of Judah and, as one man, they sent word to the king, 'Please return with your servants.'"
,"16":"So the king came back and the men of Judah went over to Gilgal to welcome him and help him cross the Jordan."
,"17":"Shimei, son of Gera, the Benjaminite from Bahurim, hurried down with the people of Judah to meet King David."
,"18":"He had taken with him a thousand men from Benjamin. Ziba also, the steward of Saul's family, hurried down to the Jordan before the king with his fifteen sons and twenty servants."
,"19":"He helped the king's household cross the ford and attended to his needs. Shimei the son of Gera fell down before the king, as he was about to cross the Jordan, "
,"20":"and said to him, 'Let not my lord hold me guilty or remember the wrong your servant did when my lord the king left Jerusalem. Let not the king remember this,"
,"21":"for I confess that I have sinned; and therefore I have come today, the first from Joseph's tribes to welcome my lord the king.'"
,"22":"Abishai the son of Zeruiah answered, 'Shall not Shimei be put to death for having cursed Yahweh's anointed?'"
,"23":"But David said, 'Far be it from me to listen to you, you sons of Zeruiah! This is bad advice; no one shall be put to death in Israel today. Do I not know that I am ruling again over Israel this day?'"
,"24":"So the king assured Shimei with an oath, 'You shall not die.'"
,"25":"Mepibaal, the son of Saul, came down from Jerusalem to meet the king. He had not washed his feet, or trimmed his beard, or cleaned his clothes since the king departed."
,"26":"When he arrived to meet the king, the king said to him, 'Why did you not go with me, Mepibaal?'"
,"27":"He answered, 'My lord, O king! My steward deceived me. For I said to him, 'Saddle an ass for me so that I may ride on it and go with the king,' since I am lame."
,"28":"But he has slandered me to my lord the king. And yet my lord the king is like an angel of God. Do, therefore, what seems good to you."
,"29":"My father's family was doomed to die before my lord the king, but you counted your servant among those who eat at your table. What further right do I have to complain to the king?'"
,"30":"The king said to him, 'Why talk more? I have decided - you and Ziba shall divide the land.'"
,"31":"Mepibaal answered, 'Oh, let him take it all since my lord the king has come home safely.'"
,"32":"Now, Barzillai the Gileadite had come down from Rogelim and he crossed the Jordan with him; then he said goodbye to him."
,"33":"Barzillai was a very old man of eighty, who, being a very wealthy man, had provided the king with food when he remained in Mahanaim."
,"34":"The king said to Barzillai, 'Come, join me and stay with me; I will take care of you in Jerusalem.'"
,"35":"But Barzillai said to the king, 'How many more years will I live that I should go up with the king to Jerusalem?"
,"36":"Today, I am eighty years old and can discern neither what is pleasant nor what is not. Can your servant still taste what he eats or drinks; or listen to the voice of men and women singing? Why then should your servant be an added burden to my lord the king?"
,"37":"Your servant will accompany the king just a little past the Jordan. Why should the king reward me for this?"
,"38":"Please allow me to return to my own city where I may die and be buried near the graves of my father and mother. But let this my son Kimham, your servant, continue with my lord the king. You can do for him whatever it may please you."
,"39":"The king answered, 'Kimham will come with me and I will give him whatever seems fit to you. Besides, I will do for you whatever you desire of me.'"
,"40":"As all the people had crossed the Jordan, the king also crossed. Then the king embraced and blessed Barzillai who then returned to his own home."
,"41":"The king went on to Gilgal accompanied by Kimham, together with the men of Judah and some Israelites."
,"42":"Then the Israelites came to the king and asked, 'Why have our brothers, the men of Judah, grabbed you? They have brought the king and his entire family over the Jordan together with all your soldiers?'"
,"43":"The men of Judah answered the Israelites, 'Because the king is our immediate relative. But why does this rouse your anger? Have we fed ourselves at the king's expense or received any gift from him?'"
,"44":"But the Israelites answered the men of Judah, 'We have more right to the king than you because we are ten tribes. Why did you disregard us? Were we not the first to have the king brought back?' But the men of Judah argued more vehemently than the Israelites."
}`)
	CurrentBook.AddChapter(20, `{
"1":"There happened to be there a base fellow named Sheba, son of Bichri, a Benjaminite, who sounded the trumpet and said, 'We have nothing to do with David. What can we expect from the son of Jesse? Go back, O Israelites, each man to his home!'"
,"2":"So all the Israelites left David and followed Sheba the son of Bichri. The men of Judah, however, steadfastly followed their king from the Jordan to Jerusalem."
,"3":"When David reached his house at Jerusalem, he took the ten concubines whom he had left to keep the palace and put them under guard. He provided for them but had no relations with them. So they were secluded until the day of their death and lived like widows."
,"4":"The king said to Amasa, 'Assemble all the men of Judah within three days; then come here to me.'"
,"5":"So Amasa left to summon the men of Judah but he failed to show up at the appointed time."
,"6":"David then said to Abishai, 'Sheba son of Bichri, will do us more harm than Absalom. Take my guards and pursue him lest he flee to any fortified city and escape from us.'"
,"7":"So Abishai, with the men of Joab, the Cherethites, Pelethites and all the warriors, left Jerusalem to pursue Sheba, son of Bichri."
,"8":"When they reached the big stone in Gibeon, Amasa came to meet them. Now Joab was wearing over his tunic a belt with a sheathed sword. The sword slipped out."
,"9":"Joab said to Amasa, 'How are you, my brother?' And he held Amasa's beard with his right hand as if to embrace him."
,"10":"Amasa did not notice the sword which he held until Joab stabbed him, shedding his entrails to the ground. Amasa died on the spot without need of a second thrust. Then Joab and Abishai his brother pursued Sheba, son of Bichri. "
,"11":"Meantime, one of Joab's men stood beside Amasa and said, 'Let him who is for Joab and stands by David follow Joab.'"
,"12":"Amasa then lay bathed in his blood, lying on the highway. When the man saw the people stopping to look, he carried Amasa from the highway into the field and covered him with a garment."
,"13":"When he was removed from the highway, the people followed Joab in pursuit of Sheba, son of Bichri."
,"14":"Sheba passed through all the tribes of Israel and entered Abel of Bethmaacah with all his allies who had assembled to follow him."
,"15":"Joab's men came and attacked him in Abel of Bethmaacah. They set up a mound against the city, and all the men of Joab dug under the wall to throw it down."
,"16":"Then a wise woman called out from the city, 'Listen! Listen! Tell Joab to come here that I may speak to him.'"
,"17":"As Joab approached, the woman asked, 'Are you Joab?' He answered, 'I am.'"
,"18":"The woman continued, 'They used to say in olden days to settle a matter, 'Seek advice at Abel if you want to know the ancient customs"
,"19":"of the faithful of Israel.' And you want to destroy a city which is a mother city in Israel. Why do you want to destroy the heritage of Yahweh?'"
,"20":"Joab answered, 'By no means do I want to destroy it!"
,"21":"But a man from the hill country of Ephraim, named Sheba, son of Bichri, has rebelled against King David. Only surrender him and I will withdraw from the city.' So the woman said to Joab, 'We shall throw his head over the wall to you.'"
,"22":"The woman then gathered the inhabitants and spoke to them so persuasively that they beheaded Sheba, son of Bichri, and threw his head out to Joab who then sounded the trumpet for the people to depart from the city. Then everyone went home and Joab himself returned to the king in Jerusalem."
,"23":"Joab was in command of all the army of Israel while Benaiah, son of Jehoiada, was in command of the Cherethites and the Pelethites."
,"24":"Adoram was in charge of the forced labor, and Jehoshaphat, son of Ahilud, was the recorder. Sheva was secretary,"
,"25":"and Zadok and Abiathar were priests,"
,"26":"and Ira the Jairite was David's priest."
}`)
	CurrentBook.AddChapter(21, `{
"1":"There was famine during the reign of David for three consecutive years and David consulted Yahweh. The answer was, 'There is bloodguilt on Saul and his family because he put the Gibeonites to death.'"
,"2":"The Gibeonites were not of the people of Israel but descendants of the Amorites. Although the Israelites had sworn to spare them, Saul had attempted to wipe them out on behalf of the people of Israel and Judah."
,"3":"So David called the Gibeonites and asked them, 'What shall I do for you? And how shall I repay you that you may bless the people of Yahweh?'"
,"4":"The Gibeonites answered him, 'Our quarrel with Saul and his family is not over silver or gold, nor is it our task to put any Israelite to death.' The king asked again, 'Tell me then what I shall do for you';"
,"5":"and they replied,'That man slaughtered us and planned our destruction so that we would no longer occupy any place in Israel."
,"6":"Surrender seven of his sons to us so that we may hang them up before Yahweh at Gibeon on the mountain of Yahweh.' To this, the king said, 'I will surrender them.'"
,"7":"David spared Mepibaal, son of Jonathan, Saul's son, because of the oath David and Jonathan took before Yahweh."
,"8":"But he took the two sons of Rizpah, daughter of Aiah whom she bore to Saul - Armoni and Mepibaal; and the five sons of Merab, daughter of Saul, whom she bore to Adriel, son of Barzillai the Meholathite."
,"9":"He delivered them into the hands of the Gibeonites who hanged them on the mountain of Yahweh where all seven perished together. They were put to death in the first days of harvest at the beginning of the barley harvest."
,"10":"Then Rizpah, daughter of Aiah, took sackcloth and spread it for herself on the rock, from the beginning of harvest until rain fell on them from the heavens. She did not allow the birds of the air to come on them by day or the beasts of the field by night."
,"11":"When David was told what Rizpah, Aiah's daughter and Saul's concubine, had done,"
,"12":"he asked the men of Jabesh-gilead for the bones of Saul and those of his son Jonathan. (They had taken them from the wall of Bethshan where the Philistines had nailed them when they killed Saul on Gilboa.)"
,"13":"So David had brought up from there the bones of Saul and his son Jonathan, and the bones of those who had been hanged were gathered."
,"14":"All of them were buried in the land of Benjamin in Zela, in the tomb of Kish their father. When all that the king had commanded was done, God had pity on the land."
,"15":"The Philistines waged war again with Israel, and David went down together with his servants to fight against them. When David was already tired,"
,"16":"Ishbibenob, one of the descendants of the giants whose spear weighed three hundred shekels of bronze and who had put on a new sword, thought of killing David."
,"17":"But Abishai, son of Zeruiah, came to his help, attacking and killing the Philistine. Then David's men urged him, 'You shall not join us anymore in battle lest the lamp of Israel be extinguished.'"
,"18":"After this, there was more fighting with the Philistines at Gob; there Sibbecai the Hushathite, slew Saph, one of the descendants of the giants."
,"19":"There was another battle with the Philistines at Gob where Elhanan, son of Jaareoregim, the Bethlehemite, slew Goliath the Gittite, the shaft of whose spear was the size of a weaver's beam."
,"20":"In another encounter at Gath, there was a huge man with six fingers on each hand and six toes on each foot, numbering twenty-four in all. He too was a descendant of the giants."
,"21":"When he taunted Israel, Jonathan, son of Shimei, David's brother, slew him."
,"22":"All four descendants of the giants fell by the hand of David and his guards."
}`)
	CurrentBook.AddChapter(22, `{
"1":"David sang this song to Yahweh on the day Yahweh delivered him from his enemies and from Saul."
,"2":"He said, The Lord is my rock, my rampart, my deliverer "
,"3":"and my God, the rock in whom I take refuge. He is my shield, my salvation, my stronghold and my refuge, my Savior; you save me from violence."
,"4":"I call on the Lord, who is worthy of praise; he saves me from my enemies."
,"5":"Waters of death carried me along, torrents of destruction terrified me."
,"6":"Caught as by the cords of the grave, I was utterly helpless before the snares of death."
,"7":"But I called upon the Lord in my distress, to my God I cried for help; and from his temple he heard my voice, my cry of grief reached his ears."
,"8":"Then the earth reeled and rocked; the foundations of the heavens shook; they trembled in his fury."
,"9":"From his nostrils smoke rose, from his mouth a devouring fire,throwing off live embers."
,"10":"He bent the heavens and came down,with dark clouds under his feet."
,"11":"He rode on a cherub and flew, he was seen on the wings of the wind."
,"12":"He set darkness around him as his tent, a heap of waters in the thick clouds."
,"13":"Then from the brightness of his presence,flared up fiery embers."
,"14":"From heaven the Lord thundered; the voice of the Most High resounded."
,"15":"Sending out a hail of arrows, he scattered them; flashing forth bolts of lightning, he routed them."
,"16":"The beds of the seas lay uncovered,as the foundations of the world,were laid bare, at your rebuke, O Yahweh, at the blast from your nostril's breath."
,"17":"Reaching down from above, he drew me out of the deep water."
,"18":"Too strong for me were my enemies, but he rescued me from my adversaries."
,"19":"They have launched their attack,in an opportune day,but the Lord has been my stay."
,"20":"In the open he has set me free. How great indeed is his love for me!"
,"21":"Yahweh rewarded me according to my justice, and according to my righteousness."
,"22":"For I have been faithful to Yahweh's way,and I did not sin far from him."
,"23":"With his ordinances all before me, I have always followed his statutes."
,"24":"Before him I have done uprightly,and kept myself from iniquity."
,"25":"Therefore Yahweh has given me,recompense according to my righteousness."
,"26":"To the faithful you show yourself faithful; to the blameless you show yourself blameless;"
,"27":"to the pure you show yourself pure; but to the crooked you show yourself astute."
,"28":"For you raise up the humble,and humiliate the arrogant."
,"29":"Yahweh, you are my lamp. O my God, you brighten up my darkness."
,"30":"Yes, with you I can crush an armed band, and by my God I can leap over a wall."
,"31":"This God - his way is perfect; the word of the Lord is always fulfilled. To those who seek refuge in him, he is a shield."
,"32":"There is no other God but Yahweh; there is no other rock but our God."
,"33":"This God is my stronghold,and keeps my path unerring and safe."
,"34":"He has made my feet as swift as the hinds'; he has set me secure on the heights."
,"35":"He trains my hands for war,and my arms to bend a bow of brass."
,"36":"You have given me your shield for protection, and your help has made me great."
,"37":"You have given wide room for my steps, so that they have never faltered."
,"38":"I have pursued my enemies and wiped them out, I did not turn back till I had destroyed them."
,"39":"Thrusting them through, I did not give them time to rise,as they fell under my feet."
,"40":"You have given me strength for the battle; you have subdued my adversaries beneath me;"
,"41":"you have put my enemies to flight,and destroyed those who opposed me."
,"42":"They cried for help, but no one came. They cried to the Lord; he did not answer them."
,"43":"I pulverized them as dust of the earth; like mud in the streets I trampled on them."
,"44":"You have delivered me from,the people's assault,and have made me head over the nations. They came to serve me -,people I had not known."
,"45":"Foreigners approached me, cringing and fawning. At the sound of my voice, they rose to obey."
,"46":"Foreigners succumbed,or locked themselves in their fortresses."
,"47":"Yahweh lives! Praised be my rock!,Exalted be my savior God -"
,"48":"the God who grants me vengeance,and subdues the peoples for me."
,"49":"He brings me out from my foes; he exalts me above my adversaries; he rescues me from men of violence."
,"50":"For this I will extol you, Yahweh, among the nations; I will sing praise to your name."
,"51":"You have given your king great victory; you have shown your love forever,to your anointed, to David and to his,descendants."
}`)
	CurrentBook.AddChapter(23, `{
"1":"These are the last words of David: The oracle of David, son of Jesse, the oracle of the man whom God exalted, the anointed of the God of Jacob, the singer of the songs of Israel:"
,"2":"'The Spirit of Yahweh speaks through me, his word is on my tongue."
,"3":"The God of Israel has spoken, the Rock of Israel has said to me: when one rules justly over men, ruling in the fear of God,"
,"4":"he dawns on them like the morning light, like the sun shining forth on a cloudless morning, making grass sprout from the ground after the rain."
,"5":"Yes, is not my family like this before God? He has made with me an eternal covenant, orderly and secure. Will he not complete my salvation and fulfill my desire?"
,"6":"But godless men are like thorns that are thrown away. They cannot be held with one's hand"
,"7":"but are uprooted with iron and the shaft of a spear, and they are burned in fire.'"
,"8":"These are the names of the warriors who were with David: the first of the Three was Ishbaal, a Hachemonite who wielded his spear against eight hundred whom he slew in a single encounter."
,"9":"Next was Eleazar, son of Dodo, son of Ahohi, who was with David when they challenged the Philistines who were gathered there for battle. When he saw the retreat of the Israelites,"
,"10":"he fought and struck down the Philistines until his hand grew tired from holding the sword without pause. Yahweh brought about a great victory that day.The others returned after him, but only to strip the slain."
,"11":"Next was Shammah, son of Agee the Hararite. The Philistines gathered together at Lehi, where there was a plot of ground planted to barley, and the men fled from the Philistines."
,"12":"But Shammah stood in the middle of the plot to defend it and slew the Philistines. And Yahweh worked a great victory."
,"13":"At about harvest time, three of the Thirty went down to David at the cave of Adullam while a band of Philistines was encamped in the valley of Rephaim."
,"14":"David was in the stronghold while the Philistine garrison was at Bethlehem."
,"15":"David longed for water and said, 'Who will give me water to drink from the well by the gate of Bethlehem!'"
,"16":"At this, the three warriors broke through the Philistine camp, drew water out of the well by the gate of Bethlehem and brought it to David. But David refused to drink of it and poured it out as an offering to Yahweh."
,"17":"He said, 'By no means should I do this. Shall I drink the blood of the men who risked their lives?' Therefore, he refused to drink it. These were the deeds of the three warriors."
,"18":"Now Abishai, brother of Joab, son of Zeruiah, was chief of the Thirty. He wielded his spear against three hundred men and slew them, winning a name beside the Thirty."
,"19":"Though he was the most popular of the Thirty and became their commander, he did not equal the Three."
,"20":"Benaiah son of Jehoiada, a warrior of Kabzeel, was a man of great achievements who killed the two sons of Ariel of Moab. He also went down into a pit on a snowy day and slew a lion."
,"21":"He slew a handsome Egyptian who held a spear. Benaiah went against him with a staff, snatched the spear from the Egyptian's hand and killed him with his own spear."
,"22":"Benaiah, son of Jehoiada, did these things and won a name beside the thirty warriors."
,"23":"He was popular among the Thirty but did not equal the Three. David put him in command of his bodyguard."
,"24":"Asahel, brother of Joab, was one of the Thirty; Elhanan, son of Dodo of Bethlehem;"
,"25":"Shammah of Harod, Elika of Harod;"
,"26":"Helez, the Paltite; Ira the son of Ikkesh of Tekoa;"
,"27":"Abiezor of Anathoth; Mebunnai, the Hushathite,"
,"28":"Zalmon the Ahohite; Maharai of Netophah;"
,"29":"Jeleb, the son of Baanah of Netophah; Ittai, the son of Ribai of Gibeah of the Ben-jaminites;"
,"30":"Benaiah of Pirathon; Hiddai, of the brooks of Gaash;"
,"31":"Abialbon, the Arbathite; Azmaveth of Bahurim;"
,"32":"Eliahba of Shaalbon; the sons of Jashen, Jonathan;"
,"33":"Shammah, the Hararite; Ahiam, the son of Sharar, the Hararite,"
,"34":"Eliphelet, the son of Ahasbai of Maacah; Eliam, the son of Ahithophel of Gilo;"
,"35":"Hezro of Carmel; Paarai the Arbite;"
,"36":"Igal, the son of Nathan of Zobah, Bani, the Gadite;"
,"37":"Zelek the Ammonite; Naharai of Beeroth, the armor-bearer of Joab, the son of Zeruiah,"
,"38":"Ira, the Ithrite; Gareb the Ithrite;"
,"39":"Uriah, the Hittite - thirty-seven in all."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Again the anger of Yahweh blazed out against Israel. So he let David harm them in this way, 'Count the people of Israel and Judah.'"
,"2":"The king said to Joab and the commanders of the army who were with him, 'Go through all the tribes of Israel from Dan to Beersheba and count the people that I may know how many they are.'"
,"3":"Joab told the king, 'May Yahweh your God multiply the people a hundred times and may my lord the king see this blessing. But why does my lord the king want to take a census?'"
,"4":"But the king's word prevailed so that Joab and the commanders of the army went out from the king's presence in order to count the people of Israel."
,"5":"They crossed the Jordan and started with Aroer, the city in the middle of the valley, and went on toward Gad and to Jazer."
,"6":"Then they proceeded to Gilead and to Kadesh in the land of the Hittites. They then went to Dan, and from Dan to Sidon,"
,"7":"and arrived at the fortress of Tyre and the cities of the Hivites and the Canaanites. They went out through the Negeb of Judah at Beersheba and"
,"8":"after having gone through all the land, returned to Jerusalem at the end of nine months and twenty days."
,"9":"Joab gave the total count of the people to the king: eight hundred thousand sword-wielding warriors in Israel and five hundred thousand men in Judah."
,"10":"But after he had the people counted, David felt remorse and said to Yahweh, 'I have sinned greatly in what I have done, but now, O Yahweh, I ask you to forgive my sin for I have acted foolishly.'"
,"11":"The following day, before David awoke, Yahweh's word had come to the prophet Gad, David's seer,"
,"12":"'Go, and give David this message: I offer you three things and I will let one of them befall you according to your own choice.'"
,"13":"So Gad went to David and asked him, 'Do you want three years of famine in your land? Or do you want to be pursued for three months by your foes while you flee from them? Or do you want three days' pestilence in your land? Now, think and decide what answer I shall give him who sent me.'"
,"14":"David answered Gad, 'I am greatly troubled. Let me fall into the hands of Yahweh whose mercy is abundant; but let me not fall into the hands of men.'"
,"15":"So Yahweh sent a pestilence on Israel from morning until the appointed time, causing the death of seventy thousand men from Dan to Beersheba."
,"16":"When the angel stretched forth his hand toward Jerusalem to destroy it, Yahweh would punish no more and said to the angel who was causing destruction among the people, 'It is enough, hold back your hand.' The angel of Yahweh was already at the threshing floor of Araunah, the Jebusite."
,"17":"When David saw the angel striking the people, he spoke to Yahweh and said, 'I have sinned and acted wickedly, but these are only the sheep; what have they done? Let your hand strike me and my father's family.'"
,"18":"Gad went to David that day and said to him, 'Go, set up an altar to Yahweh on the threshing floor of Araunah the Jebusite.'"
,"19":"So David left to follow Yahweh's command made through Gad."
,"20":"When Araunah saw the king and his officials coming toward him, he went forward, paid homage to the king with his face to the ground, and said,"
,"21":"'Why has my lord the king come to his servant?' David answered, 'I will buy your threshing floor in order to build an altar to Yahweh so that the plague may end among the people.'"
,"22":"Then Araunah said to David, 'Let my lord the king take the threshing floor and offer the sacrifice that seems good to him: here you have my oxen for the burnt offering, the threshing sledges, and the oxen's yokes for the wood."
,"23":"All this, O king, Araunah gives to the king. May Yahweh your God hear you.'"
,"24":"But the king said to Araunah, 'No, I will pay you for all this, for I will not offer to Yahweh my God something that costs me nothing.' So David bought the threshing floor and the oxen for fifty shekels of silver."
,"25":"David built there an altar to Yahweh and offered burnt offerings and peace offerings. So Yahweh had mercy on the land and the plague ended in Israel."
}`)

}
func EN_CCB_LoadVHEDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"In the first year of Cyrus, king of Persia, Yahweh willed to fulfill the word he had said through the prophet Jeremiah, so he moved the spirit of Cyrus, king of Persia, to issue the following command and send it out in writing to be read aloud everywhere in his kingdom,"
,"2":"'Thus speaks Cyrus, king of Persia: Yahweh, the God of heavens, who has given me all the kingdoms of the earth, has ordered me to build him a Temple in Jerusalem, in the land of Judah."
,"3":"To everyone belonging to his people, may his God be with him! Let them go up to Jerusalem with the help of their God and there build the House of Yahweh, the God of Israel, the God who is in Jerusalem."
,"4":"In every place where the rest of the people of Yahweh live, let the people of those places help them for their journey with silver, gold and all kinds of goods and livestock. Let them also give them voluntary offerings for the House of Yahweh which is in Jerusalem.'"
,"5":"Then they rose up - the heads of the families of Judah and Benjamin, the priests and the Levites, and all those whose spirit God had stirred up - and they decided to go and build the House of Yahweh."
,"6":"And all their neighbors gave them all kinds of help: gold, silver, livestock and precious objects in great quantity, besides every kind of voluntary offering."
,"7":"King Cyrus also brought out the vessels of the House of Yahweh which Nebuchadnezzar had carried away from Jerusalem and placed in the house of his gods."
,"8":"Cyrus, the king, gave them into the hands of Mithredath, the treasurer, who counted them and turned them over to Sheshbazzar, the prince of Judah."
,"9":"This is the list: golden cups for the offering, 30; silver cups for offering,1000; knives, 29;"
,"10":"other cups of gold, 30; of silver, 410; other vessels, 1,000."
,"11":"Total number of golden and silver vessels: 5,400. All this was brought out by Sheshbazzar when the exiles were allowed to return to Jerusalem from Babylon."
}`)
	CurrentBook.AddChapter(2, `{
"1":"These were the people of the province who returned from captivity and exile. After being deported to Babylon by Nebuchadnezzar, king of Babylon, they returned to Jerusalem and to Judah, each to his own town."
,"2":"They arrived with Zerubbabel, Jeshua, Nehemiah, Seraiah, Reelaiah, Nahamani, Mordecai, Bilshan, Mispar, Bigvai, Rehum and Baanah. The list of the clans of the people of Israel: "
,"3":"the clan of Parosh, two thousand one hundred and seventy-two;"
,"4":"the clan of Sehphatiah, three hundred and seventy-two;"
,"5":"the clan of Arah, seven hundred and seventy-five;"
,"6":"the clan of Pahathmoab, that is to say the sons of Jeshua and Joab, two thousand eight hundred and twelve;"
,"7":"the clan of Elam, one thousand two hundred and fifty-four;"
,"8":"the clan of Zattu, nine hundred and forty-five;"
,"9":"the clan of Zaccai, seven hundred and sixty;"
,"10":"the clan of Bani, six hundred and forty-two;"
,"11":"the clan of Bebai, six hundred and twenty-three;"
,"12":"the clan of Azgad, one thousand two hundred and twenty-two;"
,"13":"the clan of Adonikam, six hundred and sixty-six;"
,"14":"the clan of Bigvai, two thousand and fifty-six;"
,"15":"the clan of Adin, four hundred and fifty-four;"
,"16":"the clan of Ater, that is to say of Hezekiah, ninety-eight;"
,"17":"the clan of Bezai, three hundred and twenty-three;"
,"18":"the clan of Jorah, one hundred and twelve;"
,"19":"the clan of Hashum, two hundred and twenty-three;"
,"20":"the clan of Gibbar, ninety-five;"
,"21":"people of Bethlehem, one hundred and twenty-three;"
,"22":"people of Netophah, fifty-six;"
,"23":"people of Anathoth, one hundred and twenty-eight;"
,"24":"the clan of Azmaveth, forty-two;"
,"25":"people of Kiriath-jearim, Chephirah and Beeroth, seven hundred and forty-three;"
,"26":"people of Ramah and Geba, six hundred and twenty-one;"
,"27":"people of Michmas, one hundred and twenty-two;"
,"28":"people of Bethel and Ai, two hundred twenty-three;"
,"29":"people of Nebo, fifty-two;"
,"30":"people of Magbish, one hundred and fifty-six;"
,"31":"people of another Elam, one thousand two hundred and fifty-four;"
,"32":"people of Harim, three hundred and twenty;"
,"33":"people of Lod, Hadid and Ono, seven hundred and twenty-five;"
,"34":"people of Jericho, three hundred and forty-five;"
,"35":"people of Se-naah, three thousand six hundred and thirty."
,"36":"The priests: the clan of Jedaiah, that is to say the House of Jeshua, nine hundred and seventy-three;"
,"37":"the clan of Immer, one thousand and fifty-two;"
,"38":"the clan of Pashhur, one thousand two hundred and forty-seven;"
,"39":"the clan of Harim, one thousand and seventeen."
,"40":"The Levites: descendants of Jeshua, that is to say Kadmiel, Binnui, Hodaviah, seventy-four."
,"41":"The Temple musicians: the clan of Asaph, one hundred and twenty-eight."
,"42":"The gatekeepers: the clan of Shallum, the clan of Ater, the clan of Talmon, the clan of Akkub, the clan of Hatita, the clan of Shobai: in all, one hundred and thirty-nine."
,"43":"The helpers: the clans of Ziha, Hasupha, Tabbaoth,"
,"44":"Keros, Siaha, Padon,"
,"45":"Lebanah, Hagabah, Akkub,"
,"46":"Hagab, Shamlai, Hanan,"
,"47":"Giddel, Gahar, Reaiah,"
,"48":"Rezin, Nekoda, Gazzam,"
,"49":"Uzza, Paseah, Besai,"
,"50":"Asnah, the Meunites, the Nephisites,"
,"51":"Bakbuk, Hakupha, Harhur,"
,"52":"Bazluth, Mehida, Harsha,"
,"53":"Barkos, Sisera, Temah,"
,"54":"Neziah, Hatipha."
,"55":"The clans of Solomon's slaves: Sotai, Hassophereth, Peruda,"
,"56":"Jaalah, Darkon, Giddel,"
,"57":"Shephatiah, Hattil, Pochereth-hazzebaim, Ami."
,"58":"The total of the helpers and the sons of Solomon's slaves: three hundred and ninety-two."
,"59":"The following who came from Tel-melah, Tel-harsha, Cherub, Addan and Immer, could not prove that their families and ancestry were of Israelite origin:"
,"60":"the clans of Dela-iah, Tobiah, Nekoda: six hundred and fifty-two."
,"61":"And among the priests: the clans of Habaiah, Hakkoz, Barzillai, who had married one of the daughters of Barzillai, the Gileadite, whose name he adopted."
,"62":"These people searched in their ancestral registers but could not be located in them, so they were excluded from the priesthood as unclean"
,"63":"and His Excellency forbade them to eat the sacred foods until a priest could be found for the Urim and Thummim."
,"64":"The whole assembly numbered forty-two thousand three hundred and sixty people,"
,"65":"not counting their slaves and maidservants to the number of seven thousand three hundred and thirty-seven. They also had two hundred male and female singers."
,"66":"Their horses numbered seven hundred and thirty-six, their mules two hundred and forty-five,"
,"67":"their camels four hundred and thirty-five and their donkeys six thousand seven hundred and twenty."
,"68":"When they arrived at the Temple of Yahweh in Jerusalem, some of the leaders of the clans made voluntary offerings for the Temple of God, for its rebuilding on its old site."
,"69":"In accordance with their means they gave one thousand drachmas of gold; 5,740 minas of silver; and one hundred priestly robes to the sacred funds."
,"70":"The priests, Levites and part of the people settled in Jerusalem; the gatekeepers, Temple musicians, workmen and all the other Israelites, in their own towns."
}`)
	CurrentBook.AddChapter(3, `{
"1":"By the seventh month, the Israelites were already settled in their cities. Then all the people gathered in Jerusalem."
,"2":"Joshua, son of Jozadak, with his fellow-priests, and Zerubbabel, son of Shealtiel, with his brothers, began rebuilding the altar of the God of Israel, to offer the sacrifices upon it, as it is written in the Law of Moses, the man of God."
,"3":"They built the altar in the same place, in spite of the fear they had of the people of the land, and they offered burnt offerings upon it, and the morning and evening sacrifice."
,"4":"They celebrated the Feast of the Tabernacles as it is written, and offered burnt offerings daily according to the established ritual."
,"5":"Then they continued offering the perpetual sacrifice and the sacrifices on the sabbaths, the new moon and all the solemnities of Yahweh, besides what everyone would offer voluntarily to Yahweh."
,"6":"They began offering burnt offerings on the first day of the seventh month, although the foundation of the House of Yahweh had not yet been laid."
,"7":"They gave money to the masons and the carpenters. They also gave food, wine and oil to the Tyrians to bring cedar lumber from Lebanon to Joppa by sea, according to the authorization of Cyrus, king of Persia."
,"8":"In the second year, after their arrival at the House of God in Jerusalem, in the second month, Zerubbabel, son of Shealtiel, and Joshua, son of Jozadak, with the rest of their brothers, the priests, the Levites and all who had returned to Jerusalem from exile, began the work: they appointed the Levites who were twenty years old and upward to supervise the work in the House of Yahweh."
,"9":"Joshua, his sons and his brothers, Kadmiel and his sons, and the sons of Henadad, all together agreed to supervise those who worked in the House of God."
,"10":"When the workers had laid the foundation for the sanctuary of Yahweh, the priests, clothed in fine linen, came forward with trumpets, and the Levites, sons of Asaph, with cymbals, and they sang to Yahweh according to the ordinance of David, king of Israel."
,"11":"They gave thanks to Yahweh, singing and praising: 'For he is good, for his love for Israel is eternal.',All the people shouted aloud the praises of Yahweh for the foundation of the House of Yahweh had now been laid. Many of the priests, Levites and older heads of the families who have seen the first house wept with great lamentation as the foundation was laid. "
,"12":"But others raised their voices with shouts of joy,"
,"13":"and the people could not distinguish the shouts of rejoicing from the cries of weeping, for the people shouted so loudly that the noise was heard afar."
}`)
	CurrentBook.AddChapter(4, `{
"1":"When the enemies of Judah and Benjamin learned that those who had returned from exile were building the sanctuary of Yahweh, the God of Israel,"
,"2":"they approached Zerubbabel, Joshua and the heads of the families, and said to them, 'Allow us to help you in the work of reconstruction for we are also concerned about your God. We have offered him sacrifices from the time of Esar Haddon, king of Assyria, who brought us here.'"
,"3":"Zerubbabel, Joshua and the heads of the Israelite families answered them, 'We cannot let you join us, for we alone must rebuild it, as Cyrus, king of Persia, has commanded.'"
,"4":"Then the people of the land set about discouraging the workers of Judah and frightening them to keep them from building."
,"5":"They hired some counselors of the royal court to make the project fail, and they did this all during the time of Cyrus, king of Persia, until the reign of Darius, king of Persia."
,"6":"In the beginning of the reign of Xerxes, they lodged a complaint against the inhabitants of Judah and Jerusalem."
,"7":"Again in the time of King Artaxerxes, king of Persia, Bishlam, Mithredath, Tabeel, and the rest of their colleagues wrote to Artaxerxes. The letter was written in Aramaic and translated. So it began this way:"
,"8":"'From Rehum, the governor, and Shimshai, the secretary,"
,"9":"and from the rest of their colleagues, the judges and the legates, and all Persian officials, the people of Erech, Babylon and Susa, that is, the Elamites,"
,"10":"and from the rest of the nations whom the great Assurbanipal deported and settled in the cities of Samaria and in the rest of the province at the other side of the River...'"
,"11":"This is a copy of the letter they sent to King Artaxerxes: 'Your servants, the people beyond the River, send greetings."
,"12":"It should be made known to the king that the Jews who came up from your side to ours and have gone to Jerusalem are now building this rebellious and wicked city. They are now rebuilding the walls and have laid the foundation."
,"13":"Be it known, then, to the king, that if this city is rebuilt and its walls finished, they will no longer pay taxes, tributes or toll duties, and in the end, this city shall bring harm to the kings."
,"14":"Now, as we eat the salt of the palace and we do not wish to see the king dishonored, we are sending this information to the king."
,"15":"If you look into the records of your fathers, you will find that this city is a rebellious city. It has disturbed the kings and the provinces, and has fostered sedition from of old. It is precisely because of this that it was destroyed."
,"16":"We make known to the king that if this city is rebuilt and its walls restored, you will soon lose your territories on that side of the River.'"
,"17":"The king wrote this in reply: 'To Rehum, the governor; to Shimshai, the secretary; and to the rest of their colleagues who are in Samaria and in the other places at the other side of the River: greetings."
,"18":"The letter you sent to me has been read word for word in my presence."
,"19":"I gave orders to inquire into these things, and it has been found that from ancient times that city has rebelled against the kings, and that sedition and rebellions have happened there."
,"20":"There were powerful kings in Jerusalem, masters of all the land at the other side of the River, to whom tribute taxes and toll duties were paid."
,"21":"Therefore, order the people to stop work; they shall not rebuild that city without my authorization."
,"22":"Do not neglect this grave concern, lest further harm be done to the kingdom.'"
,"23":"When the copy of this letter of King Artaxerxes was read before Rehum, the governor, Shimshai, the secretary, and their colleagues, they went hurriedly to Jerusalem and they used force and violence to make the Jews suspend their work."
,"24":"So the work on the House of God in Jerusalem was interrupted and not begun until the second year of the reign of Darius, king of Persia."
}`)
	CurrentBook.AddChapter(5, `{
"1":"The prophets Haggai and Zechariah, son of Iddo, addressed the Jews who lived in Judea and Jerusalem in the name of the God of Israel, who was with them."
,"2":"Upon hearing them, Zerubbabel, son of Shealtiel, and Joshua, son of Jozadak, began to rebuild the House of God in Jerusalem. The prophets of God were with them, supporting them."
,"3":"Then Tattenai, the governor of the province at the other side of the River, and Shethar Bozenai came with their counselors and said to them, 'Who has ordered you to build this House and its walls?'"
,"4":"And they also asked, 'Who are the men working on the construction of this building?'"
,"5":"But the favor of God was with the leaders of the Jews, for these people did not oblige the Jews to stop the work while the matter was being referred to King Darius and they were waiting for his answer."
,"6":"This is a copy of the joint letter to King Darius from Tattenai, governor of the province of the other side of the River, Shethar Bozenai and his counselors, the Persians at the other bank of the River:"
,"7":"'To King Darius, peace."
,"8":"We wish to inform the king that we went to the province of Judea, to the House of the Great God. They are now building the Temple with hewn stones and timber to reinforce the walls; the work is being done with great care and progresses quickly at their hands."
,"9":"We questioned the Elders, and asked them: Who has ordered you to build this House and finish this Sanctuary?"
,"10":"We also asked them their names and wrote down the names of their leaders for your information."
,"11":"They gave us this answer: We are the servants of the God of heaven and earth, and we are rebuilding the House that was built many years ago. A great king of Israel built and finished it."
,"12":"But then, our fathers angered the God of heaven, so he gave the children into the hands of the king of Babylon, Nebuchadnezzar, who destroyed this house and exiled them."
,"13":"However, in the first year of his reign Cyrus, king of Babylon, issued a decree that the House of God should be rebuilt."
,"14":"The gold and silver vessels of the House of God, which Nebuchadnezzar had taken from the temple of Jerusalem, and placed in the temple of Babylon, were taken from there by Cyrus and turned over to Sheshbazzar, whom he had appointed governor."
,"15":"He said to him: Take these vessels, and bring them to the temple of Jerusalem, and let the House of God be rebuilt in the same place."
,"16":"Then Sheshbazzar came and laid the foundations of the house of God in Jerusalem. From that time until now, it is gradually being rebuilt but is still not finished."
,"17":"Now, if it seems good to the king that inquiries be made into the royal archives there in Babylon, to verify whether a decree was indeed issued by King Cyrus for the rebuilding of the House of God in Jerusalem, then may the king inform us of his will in this matter.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Then King Darius commanded that inquiries be made in the house of the archives in Babylon, where the records were kept."
,"2":"And in Ecbatana, a fortress in the province of Media, a scroll was found on which the following was written:"
,"3":"'In the first year of his reign, King Cyrus has issued this decree concerning the House of God in Jerusalem: Let the foundation of that House be laid and the House be rebuilt in order that sacrifices be offered in it. The said House shall be thirty meters high and thirty meters wide,"
,"4":"with three layers of hewn stones and one of wood. The expenses shall be paid for by the house of the king."
,"5":"Moreover, the vessels of gold and silver which Nebuchadnezzar took out of the temple of Jerusalem are to be returned to the place where these used to be kept in the House of God."
,"6":"Now therefore, I say this to you: Tattenai, governor of the province at the other side of the River, Shethar, Bozenai, and their Persian counselors living at the other side of the River, do not interfere in this matter."
,"7":"Let the governor of the Jews together with their leaders build the House of God on its former site."
,"8":"This is the command I give as to what you should do to help those Jewish leaders rebuild the House of God: pay the expenses in full and without delay, with the income from taxes of the province at the other side of the River which is allotted to the king."
,"9":"Then, upon the request of the priests of Jerusalem, give them daily and without fail what is needed for the sacrifices to the God of Heaven: young bulls, rams, lambs, wheat, salt, wine and oil."
,"10":"With these, they shall offer sacrifices acceptable to the God of heaven, and pray for the life of the king and his sons."
,"11":"Moreover, I command the following: if anyone opposes these ordinances, a beam shall be pulled out of his house and he shall be hung on it, and his house reduced to a heap of ruin as punishment for his rebellion."
,"12":"And may the God who makes his Name dwell there crush every rebel, king or people, who goes against this and tries to destroy the House of God in Jerusalem. I, Darius, give this command. Let it be carried out at once.'"
,"13":"Tattenai, governor of the region beyond the River, Shethar Bozenai, and his counselors acted in conformity with the order of King Darius."
,"14":"And the leaders of the Jews continued to make progress in building, encouraged by what Haggai, the prophet, and Zechariah, the son of Iddo, had said; and they finished the work according to the command of the God of Israel and the decrees of Cyrus and Darius."
,"15":"The House was finished on the third day of the month of Adar in the sixth year of the reign of Darius."
,"16":"The children of Israel, the priests and the Levites, and the rest of those who had returned from exile celebrated the consecration of this House of God with rejoicing,"
,"17":"offering on this solemnity one hundred young bulls, two hundred rams and four hundred lambs; and twelve he-goats as a sin-offering for all Israel, according to the number of the tribes of Israel."
,"18":"Then they installed the priests according to their ranks, and the Levites according to their classes, for the service of the house of God in Jerusalem, as it is written in the book of Moses."
,"19":"Those who had returned from exile celebrated the Passover on the fourteenth day of the first month,"
,"20":"for the priests and the Levites had purified themselves together, and all of them were clean. So, they slaughtered the Passover lamb for all who had returned from exile, for their fellow-priests and for themselves."
,"21":"The Israelites who had returned from exile ate the Passover lamb with all those who had separated themselves from the people of the land and joined the returned exiles to seek Yahweh, the God of Israel."
,"22":"They celebrated the Feast of Unleavened Bread joyfully for seven days; the reason for their joy was that Yahweh had turned the king of Assyria to look favorably on them so that they had been allowed to continue the work of rebuilding the House of the God of Israel."
}`)
	CurrentBook.AddChapter(7, `{
"1":"After this, in the reign of Artaxerxes, king of Persia, Ezra, the son of Seraiah, came from Babylon. He was a descendant of Azariah, Hilkiah,"
,"2":"Shallum, Zadik, Ahitub,"
,"3":"Amariah, Azariah, Meraioth,"
,"4":"Zerahiah, Uzzi, Bukki,"
,"5":"Abishua, Phinehas, Eleazar, and Aaron, the high priest."
,"6":"This Ezra, well-educated in the law given to Moses by Yahweh, the God of Israel, went up from Babylon, and as the hand of Yahweh, his God, was upon him, the king granted him all he asked."
,"7":"Many children of Israel, priests, Levites, singers, gatekeepers, and temple servants, also came to Jerusalem in the seventh year of King Artaxerxes."
,"8":"Ezra came to Jerusalem in the fifth month of the seventh year of the king."
,"9":"He had left Babylon on the first day of the first month, and arrived in Jerusalem on the first day of the fifth month, for the good hand of his God was upon him."
,"10":"Ezra had indeed dedicated himself with all his heart in putting into action the Law of Yahweh and teaching his commandments and precepts to Israel."
,"11":"Here is the copy of the letter given by King Artaxerxes to Ezra, priest and scribe, learned in the commandments and laws Yahweh has given to Israel."
,"12":"'Artaxerxes, King of kings, to Ezra, priest and teacher, learned in the Law of the God of heaven, peace."
,"13":"I have given orders so that all the Israelites who are in my kingdom and are ready to go with you to Jerusalem may leave with their priests and Levites."
,"14":"As for you, you shall go as the representative of the king and of his seven counselors to see to it that the Law of God which is in your hands is observed in Judah and Jerusalem,"
,"15":"and to bring there the gold and silver which the king and his counselors have generously offered to the God of Israel, whose House is in Jerusalem."
,"16":"You shall also bring all the silver and gold you can gather in Babylon with the voluntary offerings of the people and the priests for the House of God in Jerusalem."
,"17":"With this money, take care to buy young bulls, rams, lambs, and everything needed for the grain offerings and the libations, which you shall offer upon the altar of the House of your God in Jerusalem."
,"18":"Do whatever seems best to you and your brothers with the rest of the silver and gold, according to the will of your God."
,"19":"Place before God in Jerusalem the vessels given to you for the service of the House of your God,"
,"20":"and take from the treasuries of the king whatever is needed to pay for other expenses for the House of your God."
,"21":"I, King Artaxerxes, command all the treasurers in the region at the other side of the River to do exactly all that Ezra, priest and scribe, learned in the Law of the God of heaven, may ask of them,"
,"22":"giving him up to a hundred talents of silver, a hundred sacks of wheat, a hundred measures of wine and a hundred measures of oil; salt shall be given him without measure."
,"23":"Everything commanded by the God of heaven should be done with great care for the House of the God of heaven in order that his wrath may not come upon the kingdom, the king and his sons."
,"24":"We also make it known that taxes, contributions or toll duties cannot be collected from any of the priests, Levites, singers, gatekeepers, ministers and servants of this House of God."
,"25":"And you, Ezra, according to the wisdom of your God, appoint judges and magistrates to administer justice to all the people at the other side of the River, to all who know the Law of your God; and teach it to those who do not know it."
,"26":"Whoever will not fulfill the Law of your God and the law of the king shall be severely punished with death, banishment, fine or imprisonment.'"
,"27":"Blessed be Yahweh, the God of our fathers, who inspired the king with this will to exalt and glorify the House of Yahweh in Jerusalem,"
,"28":"and who let me win the favor of the king, of his counselors and of all his important officers. For my part, I took courage, since the hand of Yahweh my God was with me, and I gathered together the leaders of Israel to go up with me."
}`)
	CurrentBook.AddChapter(8, `{
"1":"These are the heads of clans who set out from Babylon with me in the reign of King Artaxerxes - their predecessors are named:"
,"2":"Of the clan of Phinehas: Gershom; of the clan of Ithamar: Daniel; of the clan of David: Hattush"
,"3":"son of Secaniah; of the clan of Parosh: Zechariah, with whom one hundred and fifty males were registered;"
,"4":"of the clan of Pahath-moab: Eliehoenai, son of Zerahiah, and with him two hundred males;"
,"5":"of the clan of Zattu: Shecaniah, son of Jahaziel, and with him three hundred males;"
,"6":"of the clan of Adin: Ebed, son of Jonathan, and with him fifty males;"
,"7":"of the clan of Elam: Jeshaiah, son of Athaliah, and with him seventy males;"
,"8":"of the clan of Shephatiah: Zebadiah, son of Michael, and with him eighty males;"
,"9":"of the clan of Joab: Obadiah, son of Jehiel, and with him two hundred and eighteen males;"
,"10":"of the clan of Bani: Shelomith, son of Josiphiah, and with him a hundred and sixty males;"
,"11":"of the clan of Bebai: Zechariah, son of Bebai, and with him twenty-eight males;"
,"12":"of the clan of Azgad: Johanan son of Hakkatan, and with him a hundred and ten males;"
,"13":"of the clan of Adonikam: the younger sons, whose names are: Eliphelet, Jeiel and Shemaiah, and with them sixty males;"
,"14":"and of the clan of Bigvai: Uthai, son of Zabud, and with him seventy males."
,"15":"I gathered them by the river that runs to Ahava, and there we encamped for three days; and having searched among these people, I did not find anyone from the tribe of Levi."
,"16":"So I called for the leaders - Eliezer, Ariel, Shemaiah, Jarib, Elnathan, Zechariah and Meshullam - Joarib and Elnathan, men of understanding."
,"17":"I gave them orders concerning Iddo, the leader who was in Casiphia; I gave them a message to relay to Iddo and his brothers, the helpers, in Casiphia, to send us ministers for the House of our God."
,"18":"As the good hand of God was with us, they brought us Sherebiah, a very sensible man, of the sons of Mahli, son of Levi, son of Israel, and with him were his sons and his brothers, numbering eighteen;"
,"19":"Hashabiah and with him Isaiah of the sons of Merari, their brothers and their sons, twenty;"
,"20":"and of the helpers whom David and the leaders had placed at the service of the Levites, two hundred twenty-two men, all written down by name."
,"21":"There at the banks of the river Ahava, I proclaimed a fast so we might humble ourselves before our God, to implore him for a safe journey for ourselves, our children and our goods."
,"22":"I was ashamed to ask the king for soldiers and horsemen to protect us against the enemy on the way, for we had said to the king, 'The hand of our God is for good, upon all who seek him; and the power of his wrath upon all who abandon him.'"
,"23":"So we fasted and prayed to our God for this intention, and he listened to us."
,"24":"I chose twelve of the leaders of the priests, besides Sherebiah and Hashabiah and ten of their brothers."
,"25":"I weighed out before them the silver and gold, the consecrated vessels given by the king, his counselors and his leaders, and by all the Israelites who were there, for the House of our God."
,"26":"And I entrusted into their hands six hundred and fifty talents of silver, silver vessels worth a hundred talents,"
,"27":"twenty bowls of gold worth a thousand darics, and two vessels of fine bright bronze as precious as vessels of gold."
,"28":"Then I said to them, 'You are consecrated to Yahweh, these vessels are sacred objects, and the silver and gold are voluntary offerings made to Yahweh, the God of our fathers."
,"29":"Take care of them and keep them until you weigh them before the leaders of the priests, the Levites and the families of Israel in Jerusalem, in the chambers of the House of Yahweh.'"
,"30":"Then, the priests and the Levites received all that we had weighed: the silver and gold, and the vessels, to bring them to Jerusalem to the House of our God."
,"31":"We left the banks of the river Ahava to go to Jerusalem on the twelfth day of the first month. The hand of God was with us and he kept us from all attacks and ambushes from enemies throughout our journey."
,"32":"We arrived in Jerusalem where we rested for three days."
,"33":"On the fourth day, in the House of our God we weighed the silver, the gold and the vessels, turning over everything to the priest Meremoth, son of Uriah, and to Eleazar, son of Phinehas, with the Levites Jozabad, son of Joshua, and Hoadiah, son of Binnui."
,"34":"After counting and weighing everything again, the total weight was written down."
,"35":"The Jews who had returned from exile offered sacrifices to the God of Israel: twelve young bulls for all Israel, ninety-six rams, seventy-seven lambs, and as a sin-offering, twelve he-goats. All these were burnt offerings to Yahweh."
,"36":"And the decrees of the king were delivered to his governors and officials of the province beyond the River, who helped the people and the House of God."
}`)
	CurrentBook.AddChapter(9, `{
"1":"After all this was finished, the leaders approached me and said, 'The people of Israel, the priests and the Levites have not departed from the pagan peoples and are now serving the idols of the Canaanites, the Hittites, Perizzites, Jebusites, Ammonites, Moabites, Egyptians and Amorites."
,"2":"For they took women from among these people for themselves and for their sons, and mixed their holy race with that of the pagans. The leaders and magistrates were the first in committing this sin.'"
,"3":"When I heard this, I tore my garments and my mantle, pulled hair from my head and beard, and sat down very much grieved."
,"4":"All who remembered the words of the God of Israel gathered around me; they were afraid because of this sin committed by the men who had returned from exile."
,"5":"I remained seated and dismayed until the evening sacrifice; and then, at the time for the evening offering, I rose from my fasting, and with my clothes and mantle torn, I knelt down, spreading out my hands to Yahweh, my God."
,"6":"I said, 'My God! I am ashamed and confused, my God, I do not dare raise my eyes to you for our sins have increased over our heads and our crimes reach up to the heavens."
,"7":"From the days of our fathers to this day, our guilt has been great. We, our kings and priests have been given into the hands of foreign kings because of our crimes; we have been delivered to the sword, to captivity, to plunder, and put to shame as on this day."
,"8":"However, for a brief moment, the mercy of Yahweh, our God, has been shown to us. He made a remnant of our people survive, and allowed the survivor to settle once again in his Holy Place; he has given us joy and life, though we are in bondage."
,"9":"We are no more than slaves, but in the midst of our slavery, God has not abandoned us, he has extended a merciful hand over us to support us before the kings of Persia. He has revived our life, enabled us to rebuild the House of our God, and to have walls in Jerusalem and in the other cities of Judah."
,"10":"But now, our God, what shall we say when, in spite of all this, we have abandoned your commandments?"
,"11":"You have said through your servants, the prophets: The land you are entering to take possession of was defiled by the impurities of its inhabitants; they made it entirely unclean from one end to the other with their idolatry."
,"12":"Therefore, do not give your daughters as wives for their sons, nor take their daughters as wives for your sons. Do not work with them for their prosperity and well-being forever. Be strong, eat the best fruits of the land, and leave it as an inheritance to your sons forever."
,"13":"After all that has come upon us for our evil deeds and our sins, you, our God, have pardoned our wickedness, since you allowed all who are here to survive."
,"14":"How could we despise your commandments once more and intermarry with these wretched peoples? Will you not be angry with us and destroy us without leaving any remnant or survivors?"
,"15":"Yahweh, God of Israel, you are just; see that we are a remnant of survivors. We are here in your presence with our sins, but we cannot remain so in your presence.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"While Ezra bowed before the House of God, weeping, praying and making this confession, a great crowd of men, women and children of Israel were gathered around him; and these people wept bitterly."
,"2":"Then Shecaniah, son of Jehiel, of the sons of Elam, said to Ezra, 'We have treated our God badly, by marrying foreign women taken from the peoples of this land, but Israel is not without hope because of this."
,"3":"Let us make a covenant with our God, and send these women away with their children according to the statement of my lord and all of us who respect the commandment of our God."
,"4":"Let the Law be obeyed. You command and we are with you. Have courage and command.'"
,"5":"So Ezra arose and made the leaders of the priests, the Levites and of all Israel swear that they would do what had just been said, and so they swore."
,"6":"Then, Ezra withdrew from where he stood, in front of the House of God and went to the chamber of Jehohanan, son of Eliashib, but he did not eat bread or drink water there, for he was much afflicted by the sin of those who had returned from exile."
,"7":"A proclamation was made throughout Judah and Jerusalem that all who had returned from exile should assemble in Jerusalem,"
,"8":"and if anyone would not come within three days, according to the decision of the leaders and of the local elders, all his prop-erty would be confiscated and he himself banned from the assembly of those who had returned from exile."
,"9":"All the men of Judah and Benjamin assembled in Jerusalem within the three days. It was the twentieth day of the ninth month, and all the people were in the open square of the House of God, trembling because of this matter and because it was raining."
,"10":"Then the priest Ezra stood up and said, 'You have been rebels in marrying foreign women, and have increased the offense of Israel."
,"11":"Now then, acknowledge your sin before Yahweh, the God of your fathers, and carry out his will; separate yourselves from the peoples of this land and from your foreign wives.'"
,"12":"The whole assembly answered with a loud voice, 'Yes, we shall do as you say."
,"13":"But the people are so numerous and we are now in the rainy season; we cannot endure the inclement weather, and besides, this matter cannot be settled in a day or two, for we are many who have committed this sin."
,"14":"Our leaders can represent the whole assembly: those in our cities who have married foreign women shall come at appointed times, accompanied by the local leaders and judges of every city, until we have turned aside from us the anger of our God because of this matter.'"
,"15":"The only ones who opposed this option were Jonathan, son of Asahel, and Jahzeiah, son of Tikvah, who were supported by the Levites Meshullam and Shabbethai."
,"16":"But those who had returned from exile complied. In accordance with what the priest Ezra ordered, they selected a family head for every family group, each of them designated in a personal way, and they sat down to resolve the matter on the first day of the tenth month."
,"17":"On the first day of the first month, they finished attending to all the cases of Jews who had been married to foreign women."
,"18":"In the clan of the priestly clans, these are the names of those who were found to have married foreign women: among the clan of Jeshua, son of Jozadak, and among his brothers: Maaseiah, Eliezer, Jarib and Gedaliah;"
,"19":"they pledged their word to put their wives away and, for their sin, offered a ram as a sacrifice of reparation;"
,"20":"In the clan of Immer: Hanani and Zebadiah;"
,"21":"In the clan of Harim: Maaseiah, Elijah, Shemaiah, Jehiel and Uzziah;"
,"22":"In the clan of Pashhur: Elioenia, Maaseiah, Ishmael, Nethanel, Jozabad and Elasah."
,"23":"Among the Levites: Jozabad, Shimei, Kelaiah - that is, Kelita - Pethahiah, Judah, and Eliezer."
,"24":"Among the Temple musicians: Eliashib and Zaccur. Among the gatekeepers: Shallum, Telem and Uri."
,"25":"And among the Israelites: of the clan of Parosh: Ramiah, Izziah, Malchijah, Mijamin, Eleazar, Malchijah and Benaiah;"
,"26":"of the clan of Elam: Mattaniah, Zechariah, Jehiel, Abdi, Meremoth and Elijah;"
,"27":"of the clan of Zattu: Elioenai, Eliashib, Mattaniah, Jeremoth, Zabad and Aziza;"
,"28":"of the clan of Bebai: Jehohanan, Hananiah, Zabbai, Athlai;"
,"29":"of the clan of Bigvai: Meshullam, Malluch, Jedaiah, Jashub, Sheal, Jeremoth;"
,"30":"of the clan of Pahath-moab: Adna, Chelal, Benaiah, Maaseiah, Mattaniah, Bezalel, Binnui and Manasseh;"
,"31":"of the clan of Harim: Eliezer, Isshijah, Malchijah, Shemaiah, Shimeon,"
,"32":"Benjamin, Malluch, Shemariah;"
,"33":"of the clan of Hashum: Mattenai, Mattattah, Zabad, Eliphelet, Jeremai, Manasseh, Shimei;"
,"34":"of the clan of Bani: Maadai, Amran, Uel,"
,"35":"Benaiah, Bediah, Cheluhi,"
,"36":"Vaniah, Meremoth, Eliashib,"
,"37":"Mattaniah, Matenai and Jaasau;"
,"38":"of the clan Binnui; Shimei;"
,"39":"Shelemiah, Nathan and Adaiah."
,"40":"of the clan Zaccai: Sharai; Shashai, Sharai"
,"41":"Azarel, Shelemiah Shemariah,"
,"42":"Shallum, Amariah, Joseph;"
,"43":"of the clan of Nebo; Jeiel, Mattithiah, Zabad, Zebina, Jaddai, Joel, Benaiah."
,"44":"All these had married of foreign wives; they put them away, both women and children."
}`)

}
func EN_CCB_LoadVHETChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"In the days of Ahasuerus - the Aha- -suerus whose empire stretched from India to Ethiopia and comprised one hundred twenty-seven provinces -"
,"2":"when he occupied the royal throne in the citadel of Susa,"
,"3":"in the third year of his reign, he gave a banquet for all his officers and ministers, the Persian and Median aristocracy, chiefs of the army, the nobles and the governors of the provinces."
,"4":"For a hundred and eighty days, he displayed the riches and splendor of his empire and the wealth and pomp of his royal estate."
,"5":"At the close of this period, the king gave a banquet lasting seven days at the palace garden for all the people, great and lowly, living in Susa."
,"6":"There were white cotton curtains and blue hangings fastened with cords of fine linen and purple to silver rings on marble pillars. On a mosaic pavement of porphyry, marble, mother-of-pearl and colored stones were gold and silver couches."
,"7":"Drinks were served in a variety of golden goblets, and the royal wine flowed freely, in keeping with the king's generosity."
,"8":"By the king's order, each guest was allowed to drink as he pleased; all the stewards had been instructed to serve each guest according to his own wishes."
,"9":"Queen Vashti also gave a banquet for the women in the royal palace of King Ahasuerus."
,"10":"Merry with wine on the seventh day, the king ordered the seven eunuchs who served him as chamberlains - Mahuman, Biztha, Harbona, Bigtha, Abagtha, Zethar, and Carkas -"
,"11":"to bring into his presence Queen Vashti with her royal crown, for she was very lovely and he wished to display her beauty to the people and nobles."
,"12":"Queen Vashti, however, refused to come at the order of the king transmitted by the eunuchs; the king was very displeased and burned with rage."
,"13":"As was his procedure, the king consulted experts in law and justice."
,"14":"He summoned the seven nobles of Persia and Media who were in his personal service and held first rank in the kingdom - Carshena, Shethar, Admatha, Tarshish, Meres, Marsena and Memucan."
,"15":"He asked them, 'According to law, what is to be done with Queen Vashti for disobeying the king's order issued through the eunuchs?'"
,"16":"In the presence of the king and nobles, Memucan replied, 'It is not the king alone that Queen Vashti has wronged but all the nobles and the whole populace in the provinces of King Ahasuerus."
,"17":"All the women will soon know what she did, and so they will despise their husbands and say: 'King Ahasuerus ordered his wife to be brought before him but she refused.'"
,"18":"When the Persian and Median ladies hear of that, they will treat the royal officials in the same manner. So there will be no end to this kind of disrespect."
,"19":"If it pleases the king, therefore, let an irrevocable royal decree be issued and included among the laws of Persia and Media, that Vashti is never again to come into the presence of King Ahasuerus, and that the king is authorized to give her royal position to someone else more worthy than she."
,"20":"When this decree of the king is proclaimed throughout his vast kingdom, all wives will honor their husbands, from the least to the greatest.'"
,"21":"This proposal pleased the king and his officials; so the king acted on Memucan's advice."
,"22":"He sent letters to all parts of the kingdom, to each province in its own script and to each people in their own language, declaring that every husband should be master in his own household."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Later when his anger had cooled, King Ahasuerus remembered Vashti's disobedience and his decree against her."
,"2":"The king's courtiers proposed, 'Let beautiful young girls be chosen for the king."
,"3":"Let him appoint commissioners throughout the provinces of his realm to bring all the beautiful young virgins to the harem in Susa. Let them be put under the care of the royal eunuch Hegai, custodian of women, and let them be given ointments for beauty treatment."
,"4":"Then let the girl who pleases the king take Vashti's place.' The king was pleased with the suggestion and he acted on it."
,"5":"Now there lived in Susa a Jew named Mordecai, son of Jair, son of Shimei, son of Kish, a Benjaminite"
,"6":"who had been exiled from Jerusalem among the captives taken away with King Jeconiah of Judah by the Babylonian King Nebuchadnezzar."
,"7":"Mordecai was foster father to his cousin Hadassah, that is Esther, who had lost both father and mother. The girl had a lovely face and figure. On the death of her parents, Mordecai had adopted her as his daughter."
,"8":"In compliance with the king's edict, a great number of young girls were brought to Susa and entrusted to Hegai. Esther was among them."
,"9":"Esther pleased the custodian of women and won his favor. He not only promptly provided her with cosmetics and good food but assigned to her seven special maids from the king's household and transferred her and her maids into the best place in the harem."
,"10":"Esther did not reveal her nationality or family, for Mordecai had forbidden her to do so."
,"11":"Each day Mordecai would walk up and down the courtyard of the harem to find out how Esther was faring."
,"12":"After a preparation of twelve months decreed for the women, each of them had to appear in turn before King Ahasuerus. This preparatory period was for beautifying treatment: six months with oil of myrrh and six months with perfumes and cosmetics."
,"13":"Then when the girl was to present herself to the king, she was allowed to take with her from the harem to the king's palace anything she wanted."
,"14":"She would go there in the evening and return the following morning to another harem under the care of the royal eunuch Shaashgaz, custodian of the concubines. She would not go back to the king unless he was pleased with her and summoned her by name."
,"15":"When the turn came for Esther - the daughter of Abihail whom Mordecai had adopted from his uncle - to go to the king, she asked for nothing beyond what the eunuch Hegai had given her; and yet she won the admiration of all who saw her."
,"16":"Esther was brought to King Ahasuerus in his palace in the tenth month called Tebeth, in the seventh year of his reign."
,"17":"The king liked Esther more than any of the other women. Having won his favor and approval more than any of the other virgins, she received the royal crown and was made queen in place of Vashti."
,"18":"The king then gave a great banquet in honor of Esther for all his officials and ministers; he proclaimed a holiday for all the provinces and distributed gifts with royal liberality."
,"19":"When the virgins were assembled a second time, Mordecai was sitting at the king's gate."
,"20":"Up to this time Esther had not revealed her family background or nationality, in compliance with Mordecai's instructions. She followed his advice just as she had when she was being brought up by him."
,"21":"It was during the time that Mordecai spent at the king's gate, that Bagathan and Thares, two of the royal eunuchs who guarded the entrance, conspired to assassinate King Ahasuerus."
,"22":"Mordecai learned of the plot and informed Queen Esther, who in turn reported it to the king, giving credit to Mor-decai."
,"23":"The matter was investigated, found to be true, and the two conspirators were hanged on the gallows. The incident was recorded in the Book of Chronicles in the presence of the king."
}`)
	CurrentBook.AddChapter(3, `{
"1":"After these events, King Ahasuerus promoted Haman, son of Hammedatha the Agagite, to a rank higher than that of all the other officials."
,"2":"On orders of the king, all the royal officials at the king's gate would kneel and bow down to Haman. This Mordecai refused to do."
,"3":"The royal officials at the king's gate asked Mordecai, 'Why do you disobey the king's order?'"
,"4":"They spoke to him day after day, but he refused to comply, explaining that he was a Jew. To find out if this explanation was acceptable, they reported the matter to Haman."
,"5":"Haman was enraged when he saw that Mordecai would not kneel down or pay him honor."
,"6":"Having learned who Mordecai's people were, he thought it would not be enough to lay hands on him alone, but sought to destroy all the Jews throughout the kingdom of Ahasuerus."
,"7":"In the first month, the month of Nisan, in the twelfth year of King Ahasuerus, the pur or lot was cast in Haman's presence to determine the day and the month for the destruction of Mordecai's people. The lot fell on the thirteenth day of the twelfth month, Adar."
,"8":"Haman talked to King Ahasuerus, 'Scattered throughout the provinces of your kingdom is a certain people, whose customs differ from those of other people. Since they do not obey our laws, it is not in the king's best interests to tolerate them."
,"9":"If it please the king, let a decree be issued to destroy them. I will deposit in the royal treasury ten thousand silver talents for the men who carry out the king's business.'"
,"10":"The king took the signet ring off his finger, handed it to Haman, son of Hammedatha the Agagite, enemy of the Jews, and said,"
,"11":"'Keep the money, and do with these people as you please.'"
,"12":"On the thirteenth day of the first month, the royal scribes were summoned. As Haman dictated, they wrote orders in the script of each province and in the language of each people to the king's satraps, the governors of every province, and the officials of every people. Written in the name of King Ahasuerus himself and sealed with his own ring,"
,"13":"these dispatches were sent by couriers to all the royal provinces with the order to kill, destroy and wipe out all the Jews - young and old, women and children - on a single day, the thirteenth day of the twelfth month of Adar, and to plunder their goods."
,"14":"A copy of the edict to be promulgated as law in every province was published for all the people to know so that they would be ready for that day."
,"15":"The couriers, spurred on by the king's command, set out in haste, and the edict was first promulgated in Susa. As the king and Haman sat down to drink, the city of Susa was in bewilderment."
}`)
	CurrentBook.AddChapter(4, `{
"1":"When Mordecai learned what had happened, he tore his clothes, put on sackcloth and ashes, and walked through the city crying bitterly and loudly."
,"2":"But he came only as far as the king's gate, for no one in sackcloth was allowed to enter."
,"3":"In every province where the king's edict was read, there was great mourning among the Jews; fasting and weeping with lamentation, and many of them slept on sackcloth and ashes."
,"4":"Queen Esther's maids and eunuchs informed her about Mordecai. Overcome with grief, she sent clothes for Mordecai to put on instead of his sackcloth, but he refused."
,"5":"Esther summoned Hathach, one of the king's eunuchs assigned to attend to her, and ordered him to find out the reason for Mordecai's action."
,"6":"So Hathach went out to Mordecai in the public square in front of the king's gate."
,"7":"Mordecai told him all that had happened, as well as the exact amount of money Haman had promised to contribute to the royal treasury."
,"8":"He also gave Hathach a copy of the written decree for their destruction, to show and explain to Esther. He further told him to urge her to go to the king to beg for mercy and intercede for her people: 'Remember the days of your lowly estate when you were brought up in my charge. Haman, who is next to the king, has asked for our death. Pray to the Lord and speak to the king for us. Save us from death.'"
,"9":"Hathach returned to Esther and told her what Mordecai had said."
,"10":"In reply, Esther gave Hathach this message for Mordecai,"
,"11":"'All the king's servants and the people of his provinces know that any man or woman who goes to the king in the inner court without being summoned suffers the death penalty, unless the king grants them their life by holding out to them his golden scepter. But I have not been called to go to the king for thirty days now.'"
,"12":"When Mordecai received Esther's words,"
,"13":"he sent back this answer, 'Do not suppose that because you are in the king's palace, you alone of all the Jews will escape."
,"14":"If you remain silent now, relief and deliverance will come to the Jews from another source, but you and your father's family will perish. And who knows - perhaps you have come to the throne for just such a time as this.'"
,"15":"Esther sent back her reply to Mordecai,"
,"16":"'Go, gather all the Jews who are in Susa. Fast for me - all of you; do not eat or drink for three days, night or day. My maids and I will also fast. Then I will go to the king, even if it is against the law. If I die for this, let it be.'"
,"17":"Mordecai went away and carried out Esther's instructions."
}`)
	CurrentBook.AddChapter(5, `{
"3":"The king asked, 'What is it, Queen Esther? Tell me what you wish. Even if it is half of my kingdom, I will give it to you.'"
,"4":"Esther replied, 'If it please your majesty, come with Haman to a banquet I have prepared today.'"
,"5":"The king gave the order: 'Call Haman at once so that Esther may have her wish.',So the king and Haman went to the banquet prepared by Esther. "
,"6":"During the drinking of wine, the king again said to Esther, 'What is your petition? Speak up and it will be given. What is your request? Even half of my kingdom is yours for the asking.'"
,"7":"Esther replied, 'My petition and request is this:"
,"8":"if I have found favor with your majesty, if it pleases you to grant my petition and request, come with Haman tomorrow to another banquet I will prepare. Then I will answer your question.'"
,"9":"Haman left that day happy and in good spirits, but when he saw Mordecai at the royal gate neither rising nor showing signs of fear of him, he was filled with rage towards the man."
,"10":"He did not show it, however, but went home and summoned his friends and his wife Zeresh."
,"11":"After boasting about his vast wealth, his many sons, and the promotion he received from the king placing him above the officials and royal servants,"
,"12":"Haman added, 'Besides, Queen Esther invited me alone to go with the king to the banquet she gave. And she has invited me again tomorrow together with the king."
,"13":"Yet none of this satisfies me, as long as I see the Jew Mordecai sitting at the king's gate.'"
,"14":"His wife Zeresh and all his friends said, 'Have a fifty-cubit gallows built. In the morning ask the king to have Mordecai hanged on it. Then go to the banquet merrily together with the king.' Satisfied with the suggestion, Haman had the gallows erected."
}`)
	CurrentBook.AddChapter(6, `{
"1":"As he was sleepless that night, the king asked for the Book of Chronicles and ordered that the record of his reign be read to him."
,"2":"He came across the passage wherein Mordecai exposed a plot to assassinate King Ahasuerus, the plot of two royal eunuchs guarding the gate, Bagathan and Teresh."
,"3":"The king asked, 'What reward and honor did Mordecai receive for this?' The king's attendants answered, 'None, your majesty.'"
,"4":"Haman had entered the outer court, wanting to speak to the king about hanging Mordecai on the gallows he had erected. 'Who is there in the court?' the king asked."
,"5":"So the king's attendants answered, 'Haman is there, standing in the court.' The king ordered, 'Let him come in.'"
,"6":"When Haman entered, the king asked him, 'What should be done to the man the king wishes to honor?',Haman thought to himself: whom would the king wish to honor but me? "
,"7":"So he replied, 'For the man the king wishes to honor,"
,"8":"let royal robes be brought which the king has worn, and a horse, which the king has ridden, with a royal diadem on its head."
,"9":"The robes and the horse should be handed to one of the king's noblest officers who should array the man the king wishes to honor and lead him on horseback through the city street, proclaiming before him: 'This is what is done for the man the king is pleased to honor!''"
,"10":"The king ordered Haman, 'Hurry! Take the robes and the horse and do as you have said for the Jew Mordecai sitting at the royal gate. Do not leave out anything you have recommended.'"
,"11":"So Haman took the robes and the horse, arrayed Mordecai and led him on horseback through the streets, proclaiming, 'This is what is done for the man the king is pleased to honor!'"
,"12":"After this Mordecai returned to the king's gate, while Haman hurried home greatly dejected and with his head veiled."
,"13":"He told his wife and all his friends everything that had happened, and they said to him, 'If Mordecai, who started your downfall, is of Jewish origin, you will not win against him. You will surely be ruined.'"
,"14":"While they were still talking, the king's eunuchs arrived and escorted Haman to the banquet Esther had prepared."
}`)
	CurrentBook.AddChapter(7, `{
"1":"So the king and Haman went to the banquet that Esther had prepared."
,"2":"And again, on that second day, while they were drinking wine, the king said to Esther 'Whatever your petition is, Queen Esther, it shall be granted. Whatever request you make shall be fulfilled, even if it were half of my kingdom.'"
,"3":"Queen Esther replied, 'If I have found favor with you, O king, and if it pleases your majesty, grant me my life; and spare also the lives of my people. This is my petition and request for myself and for my people."
,"4":"For my people and I have been delivered to destruction, slaughter and extinction. Had we been sold merely as male and female slaves, I would have said nothing, for our calamity would not be as great a loss to the king.'"
,"5":"King Ahasuerus asked Queen Esther, 'Who and where is the man who dared do such a thing?'"
,"6":"Esther answered, 'He is no other than this wicked Haman - an enemy and a foe!',At this, Haman was seized with terror. "
,"7":"The king left the banquet in anger and went to the garden. Haman stayed to beg Queen Esther for his life, realizing that the king had decided on his doom."
,"8":"When the king returned from the garden to the banquet hall, Haman had thrown himself on the bed where Esther was reclining. The king exclaimed, 'Is he going to molest the queen even before my eyes in my own house?' No sooner had the king spoken than his assistants covered Haman's face."
,"9":"Harbona, one of the king's eunuchs, said, 'This man built a fifty-cubit gallows for Mordecai who gave the report that saved the king. It is standing there at his house.',The king said, 'Very well, hang him on it.' "
,"10":"So Haman was hanged on the gallows he had prepared for Mordecai, and the king's anger subsided."
}`)
	CurrentBook.AddChapter(8, `{
"1":"That same day King Ahasuerus gave Queen Esther the house of Haman, enemy of the Jews. Mordecai was admitted into the king's presence, for Esther had revealed how he was related to her."
,"2":"The king took off his signet ring, which he had recovered from Haman, and gave it to Mordecai, whom Esther appointed in charge of Haman's house."
,"3":"Once more Esther had an opportunity of being heard by the king. Weeping and falling before him, she begged him to frustrate the evil plot of Haman the Agagite against the Jews."
,"4":"The king held out the golden scepter to her, and she rose and stood before him, saying,"
,"5":"'If it please your majesty, if I am pleasing to your eyes and have found favor with you, and if you think it proper to do so, let an order be issued revoking the letters which Haman, son of Hammedatha the Agagite, wrote to destroy the Jews in all the royal provinces."
,"6":"For how can I bear to see the destruction of my people, the extermination of my race?'"
,"7":"King Ahasuerus said to Queen Esther and to Mordecai the Jew, 'I have given Haman's house to Esther and had Haman hanged on the gallows for plotting to destroy the Jews."
,"8":"Now you can write a decree as you please concerning the Jews, in the name of the king, and seal it with the royal signet ring; for any document written in the king's name and sealed with his ring cannot be revoked.'"
,"9":"The royal scribes were summoned that very day, the twenty-third of the third month of Sivan, and as Mordecai dictated they wrote an order to the Jews, to the satraps, governors and officials of the one hundred twenty-seven provinces from India to Ethiopia, to each province in its own script, to each people in its own language, and to the Jews in their own script and language."
,"10":"These letters written in the name of King Ahasuerus and sealed with the royal signet ring were carried by couriers mounted on the king's thoroughbred steeds."
,"11":"The king's edict granted the Jews in each city the right to assemble and defend themselves, to kill, destroy and wipe out any armed group of any nation or province that might attack them and their women and children, and to seize their goods as spoil."
,"12":"This edict took effect throughout the provinces of King Ahasuerus on the thirteenth day of the twelfth month, Adar."
,"13":"A copy of the text of the edict to be promulgated as law in every province was published among all the peoples so that the Jews might be prepared on the day stated to avenge themselves on their enemies."
,"14":"Spurred on by the king's command, the couriers, mounted on the king's steeds, rode out in haste, and the edict was promulgated in the citadel of Susa."
,"15":"In royal garments of blue and white, with a large golden crown and a cloak of purple and fine linen, Mordecai left the king's presence. There was a joyful celebration in the city of Susa."
,"16":"For the Jews it was a time of splendor and merriment, honor and triumph."
,"17":"Wherever the king's edict was read in every province and in each city, there was rejoicing and feasting among the Jews. Many people of other nationalities were seized with fear of the Jews, and they embraced Judaism."
}`)
	CurrentBook.AddChapter(9, `{
"1":"When the day came for the order of the king to be carried out - the thirteenth day of the twelfth month, Adar, on which the enemies of the Jews had expected to crush them - the reverse happened, for it was the Jews who got the upper hand over those who sought their harm."
,"2":"In their towns throughout the provinces of King Ahasuerus, the Jews gathered to strike at those who planned their destruction. But no one dared resist them, for they were feared by all the other nations."
,"3":"In fact, all the officials of the provinces, the satraps, governors and the king's administrators supported the Jews out of fear of Mordecai,"
,"4":"who had become more and more powerful and prominent not only in the palace but throughout the provinces."
,"5":"The Jews struck down their enemies, killing them by the sword, doing as they pleased to those who hated them."
,"6":"In Susa alone, they killed five hundred men."
,"7":"They also killed Parshandatha, Dalphon, Aspatha"
,"8":"Porathai, Adalia, Aridatha,"
,"9":"Parmashta, Arisai, Aridai, and Vaizatha,"
,"10":"the ten sons of Haman, who was Hammedatha's son and enemy of the Jews. But they laid no hand on the spoils."
,"11":"That same day the number of the slain in Susa was reported to the king,"
,"12":"who in turn told Esther: 'The Jews have killed five hundred men and the ten sons of Haman in Susa alone. Imagine what more they have done in the rest of my provinces! But you shall again be granted whatever you ask; whatever you request shall be fulfilled.'"
,"13":"Esther replied, 'If it pleases the king, let the Jews in Susa be permitted again tomorrow to carry out today's edict, and let Haman's ten sons be hanged on the gallows.'"
,"14":"The king then ordered that this be done. The edict was issued in Susa, and the ten sons of Haman were hanged."
,"15":"On the fourteenth day of the month of Adar, the Jews in Susa gathered again and put to death three hundred men. But again they laid no hand on the spoils."
,"16":"The other Jews in the king's provinces also assembled to protect themselves and rid themselves of their enemies. They killed seventy-five thousand of their foes, but did not lay hands on the spoils."
,"17":"This was on the thirteenth day of the month of Adar, and the Jews rested on the fourteenth, making it a day of feasting and rejoicing."
,"18":"The Jews in Susa, however, assembled on the thirteenth and fourteenth and rested on the fifteenth, making this a day of feasting and rejoicing."
,"19":"That is why the rural Jews have a different day of rest and celebration: the fourteenth of the month of Adar on which they send presents to each other."
,"20":"Mordecai recorded these events and sent letters to all the Jews throughout the provinces of King Ahasuerus, both near and far,"
,"21":"directing them to celebrate annually the fourteenth and fifteenth of the month of Adar"
,"22":"as the days when the Jews rid themselves of their enemies, and as the month when their sorrow was turned into joy and their mourning into feasting. They were to observe these as days of festivity and rejoicing, days for giving food presents to one another and gifts to the poor."
,"23":"The Jews agreed to observe annually this celebration instituted on Mordecai's written order."
,"24":"For Haman, son of Hammedatha the Agagite, enemy of the Jews, had plotted to destroy them and had cast the pur or lot for their ruin."
,"25":"Yet through Esther's intervention, the king ordered in writing that the wicked plan against the Jews should instead be turned against Haman, whom he ordered to be hanged as well as his sons."
,"26":"These days, therefore, have been called Purim after the word pur. Because of this written order and of what they had seen and experienced,"
,"27":"the Jews took upon themselves, their descendants and all who would join them, to celebrate these two days every year without fail, in the manner prescribed and at the time appointed."
,"28":"Commemorated and celebrated thus, in every family, province and city, through all generations, these days of Purim were never to fall into disuse among the Jews nor into oblivion among their descendants."
,"29":"Queen Esther, daughter of Abihail, along with the Jew Mordecai, wrote with full authority to confirm this second letter concerning Purim."
,"30":"Letters were sent to all the Jews in the one hundred twenty-seven provinces of Ahasuerus' kingdom, in words conveying goodwill and assurance,"
,"31":"enjoining them to observe these days of Purim at the designated time, as Mordecai the Jew and Queen Esther had decreed and just as the Jews had prescribed for themselves and their descendants, with respect to their duty of fasting and lamentation."
,"32":"Esther's decree fixed these practices of Purim, and it was recorded in the book."
}`)
	CurrentBook.AddChapter(10, `{
"1":"King Ahasuerus levied tribute throughout the empire including the distant islands."
,"2":"All his acts of power and valor, together with a full account of the greatness of Mordecai who was raised by the king to high honor, are recorded in the chronicles of the kings of Media and Persia."
,"3":"The Jew Mordecai was second in rank to King Ahasuerus; he was great among the Jews and esteemed by many of his brothers as the harbinger of peace and welfare for all his people."
,"4":"And Mordecai said, 'This is God's work."
,"5":"I remember the dream I had about this, nothing of which has failed to be fulfilled -"
,"6":"the little spring that became a river, the light, the sun and the flood of water. Esther is the river, whom the king married and made queen."
,"7":"Haman and I are the two dragons."
,"8":"Those who assembled to destroy the Jews are the nations."
,"9":"And my nation is Israel, my people, who cried to God and were saved. Yes, the Lord has saved his people and delivered us from all these evils. God has worked such signs and great wonders as have never occurred among the nations."
,"10":"For this purpose, God prepared two destinies - one for his people and the other for all the nations."
,"11":"These two destinies were fulfilled at the moment, the hour and the day laid down by God among the nations."
,"12":"He remembered his people and rendered justice to his inheritance."
,"13":"Thus, gathering together with joy before God on the fourteenth and fifteenth of the month of Adar, Israel will celebrate these days from generation to generation."
}`)
	CurrentBook.AddChapter(11, `{
"1":"In the fourth year of the reign of Ptolemy and Cleopatra, Dositheus, who affirmed he was a priest and a Levite, and his son Ptolemy brought to Egypt the foregoing letter concerning the Purim, maintaining that it was genuine and had been translated by Lysimachus, Ptolemy's son and a resident of Jerusalem."
,"2":"On the first day of Nissan, in the second year of the reign of Ahasuerus the Great, a dream came to Mordecai, son of Jair, son of Shimei, son of Kish, of the tribe of Benjamin."
,"3":"Mordecai was a Jew residing at Susa who held a prominent position at the king's court."
,"4":"He was one of the captives whom Nebuchadnezzar, king of Babylon, had deported from Jerusalem with Jeconiah, king of Judah."
,"5":"According to his dream, there were cries and tumult, thunder and earthquake and confusion upon the earth,"
,"6":"as two great dragons came, both ready for combat."
,"7":"At the sound of their terrible roar every nation prepared to fight against the holy nation."
,"8":"On earth it was a day of darkness and gloom, tribulation and distress, affliction and great disturbance."
,"9":"The whole nation of the just was troubled because of the fear of evils awaiting them, and were ready to perish."
,"10":"But they cried out to God, and a little spring appeared, from which grew a great river with a flood of water."
,"11":"Light came as the sun rose, and the humble were raised up and they devoured the mighty."
,"12":"In this dream Mordecai saw what God intended to do. On awakening he thought deeply about the matter and tried all day to understand its meaning."
}`)
	CurrentBook.AddChapter(12, `{
"1":"In those days while Mordecai was resting at the king's gate together with Bigthan and Teresh, two of the king's eunuchs and palace guards,"
,"2":"he was aware that they had become irritated and were plotting to kill King Ahasuerus."
,"3":"Mordecai investigated the matter, informed the king who had the two eunuchs questioned. They confessed and were put to death."
,"4":"By order of the king, these events were recorded by Mordecai"
,"5":"who was rewarded and appointed to an office in the court."
,"6":"In revenge for the king's two eunuchs, Haman son of Hammedatha, the Agagite who enjoyed the king's favor, sought to harm Mordecai and his people."
}`)
	CurrentBook.AddChapter(13, `{
"1":"The text of the letter was as follows: The Great King Ahasuerus to the rulers of the hundred and twenty-seven provinces from India to Ethiopia and to the governors under them:"
,"2":"As ruler of many nations and master of the whole world, I have resolved never to be carried away by the arrogance of power but always to rule with fairness and clemency, to provide for my subjects a life free of distress, and to restore the peace that all men desire by making my government humane and truly civilized as far as the borders of my kingdom."
,"3":"When I consulted my advisers on how this might be accomplished, Haman, who excels among us in wisdom, who has earned distinction for trustworthiness and loyalty, and who has attained the second rank in the kingdom,"
,"4":"brought to our attention the existence throughout my realm of a people of ill will, whose laws are opposed to those of every nation. Their continuous disregard of the decrees of kings hinders the establishment of unity in the empire."
,"5":"Considering, therefore, the continuous opposition of this people to all humankind, its outlandish system of laws and strange manner of life, its hostility to our interests and the harm it does to the stability of our kingdom,"
,"6":"we hereby decree that all the people indicated in the letters of Haman, who is in charge of affairs and a second father to us, be utterly destroyed with women and children, by the sword, without mercy or consideration, on the fourteenth day of the twelfth month, Adar, of the present year,"
,"7":"so that when these people, with their past and present ill will, have gone down into the world of the dead on a single day, they may at last leave our government in complete stability and peace."
,"8":"Recalling all that the Lord had done, he prayed to him and said:"
,"9":"Lord, King and Master of all, everything is under your power; no one can withstand you in your will to save Israel."
,"10":"You made heaven and earth and all the marvels under heaven."
,"11":"You are the Lord of all, no one can resist you, Lord."
,"12":"You know all things, O Lord; you know that no insolence, no vainglory or arrogance prompted me to act thus, to refuse to bow down before the proud Haman."
,"13":"Readily would I have kissed his feet for Israel's safety."
,"14":"But what I did, I did so as not to place human glory above the glory of God. I will not bow down to anyone except to you, O Lord. My refusal has not been out of pride."
,"15":"And now, Lord God, King, God of Abraham, deliver your people! Our enemies plot our ruin; they are bent upon destroying the inheritance that was yours from the beginning."
,"16":"Do not forsake your own inheritance which you redeemed out of Egypt for yourself."
,"17":"Hear my supplication, have mercy on your inheritance. Turn our mourning into rejoicing, that we may live to sing praise to your name, O Lord. Do not silence the mouths of those who give you praise."
,"18":"And Israel cried out with all their might, for they were faced with death."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Seized with anguish in her fear of death, Queen Esther likewise had recourse to the Lord."
,"2":"Taking off her splendid robes, she put on garments of distress and mourning. In place of expensive perfumes, she covered her head with dirt and ashes. Humbling her body severely, she put aside all her festive adornments and left her hair disheveled."
,"3":"Then she prayed to the Lord God of Israel:"
,"4":"My Lord, you who stand alone, come to my help; I am alone and have no help but you. Through my own choice I am endangering my life."
,"5":"As a child I was wont to hear from the people of the land of my forebears that you, O Lord, chose Israel from among all peoples, and our fathers from among their ancestors to be your lasting heritage; that you did for them, all that you have promised."
,"6":"But we have sinned, and for this you have handed us over to our enemies;"
,"7":"we have worshiped their gods, but you, O Lord, are just."
,"8":"Dissatisfied with our bitter servitude, they made a pact with their idols"
,"9":"to abolish what you have decreed, to blot out your heritage,"
,"10":"to shut the mouths that give you praise, to quench the glory of your Temple and your altar and instead to let the pagans sing the praise of worthless idols, and idolize forever a king of flesh."
,"11":"Do not give up your scepter, O Lord, to non-existent beings. Never let them gloat over our ruin, but turn their designs against themselves and make an example of our chief enemy."
,"12":"Remember us, Lord; reveal yourself in the time of our calamity. Give me courage, King of gods and master of all power."
,"13":"Make my words persuasive when I face the lion; turn his heart against our enemy, that the latter and his like may be brought to their end."
,"14":"Save us by your hand; help me who am alone and have none but you, O Lord."
,"15":"You know everything; you know how I hate honor if from the impious, how I loathe the bed of the uncircumcised and of any foreigner."
,"16":"You know I am here under constraint, that I loathe the diadem about my brow when I appear in public; as a filthy rag I loathe it and do not wear it in private."
,"17":"Your handmaid has never eaten at Haman's table, nor has taken pleasure in royal banquets, nor drunk the wine offered to their gods."
,"18":"Neither has your handmaid found pleasure from the day of her promotion till now except in you, Lord God of Abraham."
,"19":"O God, more powerful than all, hear the voice of those in despair; save us from the evil man's power, and deliver me from my fear."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Ending her prayer on the third day, Esther took off her penitential garments and put on her royal attire."
,"2":"Radiant in appearance after invoking the all-seeing God and Savior, she took her two maids with her,"
,"3":"and leaned gently on one of them for support,"
,"4":"while the other followed carrying her train."
,"5":"Although her heart was frozen with fear, she looked radiant in her perfect beauty, her face depicting love and joy."
,"6":"After passing through all the doors, she found herself face to face with the king seated on his throne, awe-inspiring in the full array of his majesty, his robes all covered with gold and precious stones."
,"7":"As he looked up, his face flushed with majestic anger, the queen faltered, turned pale and leaned weakly upon the shoulder of the maid in front of her."
,"8":"Then God changed the king's anger to gentleness. Alarmed, he sprang from his throne, took Esther in his arms until she had recovered and comforted her with soothing words."
,"9":"'What is it, Esther?' he said. 'I am your brother. Take heart."
,"10":"You will not die, because our decree applies only to ordinary people."
,"11":"Come, speak to me.'"
,"12":"He raised the golden scepter, touched her neck with it, then embraced her saying, 'Speak to me.'"
,"13":"Esther spoke: 'My lord, I saw you like an angel of God, and I trembled with fear before your majesty."
,"14":"For you are admirable, my Lord, and your appearance is awesome although you are full of kindness.'"
,"15":"But she fell fainting as she spoke."
,"16":"The king was deeply distressed, and his attendants tried to revive her."
}`)
	CurrentBook.AddChapter(16, `{
"1":"The text of the letter read as follows: 'The great King Ahasuerus to the satraps, governors and all our loyal subjects in the one hundred twenty-seven provinces stretching from India to Ethiopia: Greetings!"
,"2":"The more some men are honored through the generosity of their patrons, the prouder they become."
,"3":"Gloating in their power and incapable of responsibility, they seek to injure our subjects and even plot against their own benefactors."
,"4":"They drive out gratitude from the human heart. Carried away by the arrogant boasts of men who know nothing of goodness, they think they will escape the justice of the all-seeing God."
,"5":"It often happens also that those in authority, through the influence of friends entrusted with the administration of public affairs, become partly responsible for the shedding of innocent blood and are involved in causing irremediable misfortune."
,"6":"Even well-intentioned rulers are led astray by the trickery of the corrupt."
,"7":"These evil practices of past times, as attested by the records, have been carried over to the present in the crimes perpetrated by unworthy officials."
,"8":"For the future, however, we will strive to make our kingdom a realm of peace for all"
,"9":"by starting now to adopt new policies and by treating with the utmost justice all matters that come to our attention."
,"10":"To give an example, Haman, son of Hammedatha, a Macedonian who is alien to Persian blood and devoid of our kindness, was treated hospitably by us."
,"11":"Enjoying the goodwill that we have towards every nation, he was even proclaimed our 'father,' before whom, as second in rank to the king, everyone bowed down."
,"12":"But his arrogance turned his head, and he schemed to deprive us of our kingdom and our life."
,"13":"He plotted for the destruction of Mordecai, our savior and constant benefactor, of Esther, our blameless royal partner, and of their entire race."
,"14":"In that way he hoped to make us defenseless and facilitate the transfer of rule by the Persians to the Macedonians."
,"15":"'We find, however, that the Jews consigned to extinction by this accursed man are not evildoers but are governed by the most just of laws."
,"16":"They are, in fact, children of the Most High, the great living God, who has made our kingdom prosperous for us and for our ancestors."
,"17":"You will, therefore, do well to ignore the letter sent by Haman, son of Hammedatha,"
,"18":"for the man himself, together with his entire family, has been hanged at the gate of Susa. Thus speedily has God, who rules over all, given him the punishment he deserved."
,"19":"Post a copy of this letter in every public place, give the Jews freedom to live by their own laws,"
,"20":"and come to their aid in time of trial against those who plan to attack them on the thirteenth day of the twelfth month, Adar."
,"21":"For God, who rules over all, has turned this day from one of destruction into one of joy for his chosen people."
,"22":"You should, therefore, celebrate this memorable day among your designated feasts with all rejoicing,"
,"23":"so that both now and hereafter it may be for us and the loyal Persians a celebration of salvation, and for those who plot against us a reminder of destruction."
,"24":"Every city and country, without exception, that fails to observe this decree shall be ruthlessly destroyed with sword and fire. It will then be ever left untrodden not only by men but by the beasts and birds as well."
}`)

}
func EN_CCB_LoadVHIDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"After the death of Joshua, the Israelites consulted Yahweh, 'Who among us shall be the first to fight against the Canaanites?'"
,"2":"Yahweh answered: 'The tribe of Judah shall go up first, and I will give the land into their hands.'"
,"3":"So the people of Judah said to their brothers from the tribe of Simeon, 'Help us conquer the part of the land that is allotted to us, and then we will conquer with you the region that is yours.' So they joined forces for the war."
,"4":"When the tribe of Judah attacked the Canaanites and the Perizzites, Yahweh gave them into their hands; in Bezek they defeated ten thousand men."
,"5":"In Bezek they encountered the lord of Bezek and fought against him."
,"6":"The lord of Bezek fled but they pursued him. They captured him and cut off his thumbs and his big toes."
,"7":"The lord of Bezek then said, 'Seventy kings whose thumbs and big toes I cut off used to pick scraps under my table, now God has done to me according to what I have done.' They brought him to Jerusalem, and he died there."
,"8":"The tribe of Judah attacked the city of Jerusalem, and after killing its inhabitants they burned the city."
,"9":"Afterwards they went down from Jerusalem to attack the Canaanites who lived in the mountains, in the Negeb and in the plains."
,"10":"They also attacked the Canaanites who were in Hebron (Hebron was also called Kiriath-arba at that time), and they defeated Sheshai, Ahiman and Talmai."
,"11":"From there they marched against the inhabitants of Debir, a city which was also called Kiriath-sepher."
,"12":"Then Caleb made this promise, 'To the one who takes Kiriath-sepher, I will give my daughter Achsah as wife.'"
,"13":"It was Othoniel who took the city; he was the son of Kenaz, Caleb's younger brother, and Caleb gave him Achsah, his daughter, as wife."
,"14":"When Achsah came to Othoniel, she urged him to ask her father for a field. She alighted from her ass, and Caleb asked her, 'What do you want?'"
,"15":"She answered, 'What a gift this Negeb wilderness is! Give me also springs of water.' And Caleb gave her the Upper Springs and the Lower Springs."
,"16":"The descendants of the Kenite, Moses' father-in-law, also went up with the people of Judah from the city of palms to that part of the desert of Judah on the boundary of the Negeb near Arad, and they settled there with them."
,"17":"Those from Judah and their brothers from the tribe of Simeon attacked the Canaanites who lived in Zephath, and they sacrificed Zephath in honor of Yahweh. For this reason, the city was named 'Anathema.'"
,"18":"Judah seized Gaza, Ashkelon and Ekron with their respective territories."
,"19":"Although they conquered the mountainous regions with the help of Yahweh, they could not drive out the inhabitants of the plain because they fought with iron chariots."
,"20":"Following the orders of Moses, they gave the city of Hebron to Caleb who had cast out the three sons of Anak from there."
,"21":"But the tribe of Benjamin did not succeed in expelling the Jebusites who lived in Jerusalem; the Jebusites have stayed in Jerusalem until this day."
,"22":"The people of Joseph went up against Bethel with the help of Yahweh."
,"23":"They sent men out to spy in Bethel, formerly called Luz,"
,"24":"and they met a man coming out of the city. They said to him, 'Tell us how we can enter the city, and we will not kill you.'"
,"25":"He showed them the way. Then they entered and put the city to the sword, but set that man free together with his whole family."
,"26":"The man went to the land of the Hittites where he built a city which he named Luz which is its name to this day."
,"27":"However, the tribe of Manasseh did not drive out the people of Beth-shean and Taa-nach or the inhabitants of Dor, Ibleam and Megiddo. The Canaanites persisted in dwelling in these cities and in the towns that depended on them, and they kept their lands."
,"28":"But when the Israelites grew stronger, they exacted taxes from the Canaanites who stayed in their place."
,"29":"Neither did the tribe of Ephraim expel the Canaanites who lived in Gezer"
,"30":"nor did the tribe of Zebulun drive out the inhabitants of Kitron and Nahalol. These Canaanites lived among them, but had to pay taxes to them."
,"31":"Those of Asher did not expel the people of Acco, Sidon, Ahlab, Achzib, Helbah, Aphik or Rehob."
,"32":"The tribe of Asher had to live in the midst of the Canaanites who occupied their territory, for they could not drive them out from that region."
,"33":"The same happened with the tribe of Naphtali that failed to drive out the inhabitants of Beth-shemesh and Beth-anath; they had to dwell in the midst of the Canaanites who lived in that region. Nevertheless, the inhabitants of Beth-shemesh and Beth-anath paid taxes to this tribe."
,"34":"The Amorites did not allow the descendants of Dan to come down to the plain, so the latter had to live in the mountains."
,"35":"The Amorites also remained in Har-heres, Aijalon and Shaalbim, but when the tribe of Joseph grew stronger, they forced the Amorites to pay taxes."
,"36":"The territory of the Amorites extended from the slope of Akrabbim, to Sela and upward."
}`)
	CurrentBook.AddChapter(2, `{
"1":"The Angel of Yahweh went up from Gilgal to Bochim where the Israelites were gathered, and he said to them, 'I made you go up from Egypt and brought you to the land I had promised your fathers. I said to them, 'Never will I break my covenant with you,"
,"2":"but you shall not make any covenant with the Canaanites and shall destroy their altars.' But you have not obeyed my command. Why did you not obey me?"
,"3":"Now, I will not drive out these nations before you. They shall be your oppressors and their gods shall be a trap for you.'"
,"4":"After the Angel of Yahweh had spoken, all the Israelites began to weep and cry."
,"5":"For this reason, they named that place Bochim, which means 'those who weep,' and they offered sacrifices to Yahweh."
,"6":"When Joshua dismissed the Israelites, each one of them went to his inheritance to occupy the land."
,"7":"The people served Yahweh during the lifetime of Joshua and of the leaders who outlived him, and who had witnessed all the great works of Yahweh for Israel."
,"8":"Joshua, son of Nun, the servant of Moses, died at the age of one hundred and ten years."
,"9":"They buried him at the boundary of his inheritance in Timnath-heres, in the mountains of Ephraim, north of the mountain of Gaash."
,"10":"That whole generation died and another one came, but they did not know Yahweh or what he had done for Israel."
,"11":"The Israelites treated Yahweh badly for they served the Baals instead."
,"12":"They abandoned Yahweh, the God of their fathers who had brought them out of Egypt, and served other gods, the gods of the neighboring peoples. They bowed before those gods and offended Yahweh."
,"13":"When Yahweh saw that they had abandoned him to serve Baal and Ashtaroth,"
,"14":"he became angry with his people and gave them into the hands of plunderers who left them in misery. He himself sold them to their enemies who completely surrounded the Israelites, so that these Israelites could no longer withstand them."
,"15":"Whenever they felt strong for an offensive, Yahweh would turn against them and send evil upon them, as he had warned them and sworn to do. And this caused much distress and anguish for the Israelites."
,"16":"Yahweh raised up 'judges' (or liberators) who saved the Israelites from their exploiters."
,"17":"But neither did they obey those 'judges' for they still prostituted themselves to other gods and worshiped them. They soon left the way of their fathers who obeyed the commandments of Yahweh; they did not follow the way of their fathers."
,"18":"When Yahweh made a judge appear among his people, Yahweh was with him and saved them from their enemies. That lasted as long as the judge lived, for Yahweh was moved to pity by the lament of his people who were oppressed and persecuted."
,"19":"But when the judge died, they again became worse than their fathers - worshiping and serving other gods. They would not renounce their pagan practices and stubborn ways."
,"20":"Yahweh was angry and he said, 'These people broke the Covenant I made with their fathers and they refuse to obey me."
,"21":"Well now, neither shall I drive out before them any of the nations left when Joshua died."
,"22":"And I shall test the Israelites through those nations; then I shall know if they will finally follow my ways as their fathers did.'"
,"23":"So Yahweh left those nations in their place and did not take the land immediately from them. This was also why he did not give them into the hands of Joshua."
}`)
	CurrentBook.AddChapter(3, `{
"1":"These are the nations that Yahweh let live in order to test the Israelites through them, that is to say, all the Israelites who had not known any of the wars in Canaan."
,"2":"He let these people live so that the generation of the children of Israel who had not known war before might learn how to fight."
,"3":"These people were the five lords of the Philistines and all the Canaanites, the Sidonians and the Hivites of Mount Lebanon, from the mountain of Baal-hermon to as far as the entrance of Hamath."
,"4":"They remained to test Israel to see if they would observe the commandments that Yahweh had prescribed to their fathers through Moses."
,"5":"So the Israelites lived in the midst of the Canaanites, Hittites, Amorites, Perizzites, Hivites and Jebusites."
,"6":"The Israelites married the daughters of these people, gave their own daughters in marriage to the sons of these people and served their gods."
,"7":"The Israelites treated Yahweh badly; they forgot Yahweh, their God, and served the Baals and the Asheroths."
,"8":"Because of this, the anger of Yahweh burned against Israel and he left them in the hands of Cushanrishathaim, king of Aram, to whom they were subject for eight years."
,"9":"Then the Israelites cried to Yah-weh, and he raised up from among them a liberator who saved them - Othniel the son of Kenaz, Caleb's younger brother."
,"10":"The spirit of Yahweh was upon him and he led Israel. When Othniel went to war, Yahweh gave Cushanrishathaim, king of Aram, into Othniel's hands."
,"11":"Othniel won over the king and the land had peace for forty years. Then Othniel, son of Kenaz, died."
,"12":"The Israelites again did what was evil in the sight of Yahweh, so he strengthened Eglon, king of Moab, so he could attack them; that was because they had treated Yahweh badly."
,"13":"Eglon joined the Ammonites and the Amalekites; they set out and marched together defeating Israel and taking the City of Palms."
,"14":"The Israelites became subject to Eglon, king of Moab, for eighteen years."
,"15":"But as they cried to Yahweh, he gave them a liberator - Ehud, a left-handed man, the son of Gera, from the tribe of Benjamin. The Israelites entrusted a gift to him to bring to Eglon, king of Moab. "
,"16":"So, Ehud made for himself a two-edged dagger, one cubit long, and strapped it on his right thigh under his clothes."
,"17":"He then went to present the gift to Eglon, king of Moab. Eglon was a very fat man."
,"18":"When Ehud finished offering the present, he dismissed the men who had brought all the things."
,"19":"But when he arrived at the place of the Idols, near Gilgal, he went back to the king, and said to Eglon, 'I have a secret message for you, O king.' Eglon, king of Moab, then declared, 'Leave me alone!' And so everyone who was present left the room."
,"20":"Then Ehud approached him, while the king was seated alone on his private roof chamber where it was cool. Ehud said to him, 'Lord, I have a warning from God for you.' The king rose from his seat."
,"21":"Then Ehud, with his left hand, took the dagger from his right thigh and thrust it into the king's belly."
,"22":"The handle even went in with the blade and the fat closed over the blade, for Ehud did not draw the dagger out of his belly; and the dirt came out."
,"23":"Ehud jumped out through the window after having locked the doors of the roof behind him."
,"24":"When he had gone, the servants came and saw that the doors of the upper room were locked. They thought, 'He must be relieving himself in the cool room.'"
,"25":"They waited for some time, but the doors of the roof room remained closed. Finally, they took the keys and opened the doors: their lord lay on the floor dead."
,"26":"Ehud had escaped while the servants waited for their king; he had passed through the place of the Idols and reached a safe place in Seirah."
,"27":"When he arrived he had the trumpets sounded in the mountains of Ephraim and the Israelites went down from the mountains."
,"28":"He stood before all of them and said, 'Follow me, for Yahweh has given the people of Moab, our enemies, into our hands.' They went down with him, barred the passages of the Jordan towards Moab and they let nobody pass."
,"29":"They defeated Moab on that occasion, killing some ten thousand, all strong and brave men. Nobody was spared."
,"30":"So on that day, Moab became subject to Israel, and the land remained peaceful for eighty years."
,"31":"Then Shamgar, the son of Anath, came; he killed six hundred Philistines with an oxgoad. He, too, saved Israel."
}`)
	CurrentBook.AddChapter(4, `{
"1":"After Ehud died, the Israelites again treated Yahweh badly,"
,"2":"so he left them in the power of Yabin, king of Canaan. Yabin reigned in Hazor, and the commander of his army was Sisera, who lived in Harosheth-hagoiim."
,"3":"Then the Israelites cried to Yahweh, for Yabin had nine hundred chariots of war, and had kept the Israelites oppressed for twenty years."
,"4":"At that time, Deborah, a prophetess and wife of Lappidoth, became judge."
,"5":"She used to sit under what was called the Palm of Deborah, between Ramah and Bethel, in the land of Ephraim. There she resolved the complaints that the Israelites presented to her."
,"6":"And she sent and called for Barak, the son of Abinoam, who was from the town of Kedesh of Naphtali. She said to him, 'This is the order of Yahweh: Go, gather the people on Mount Tabor and take with you ten thousand men from the tribes of Naphtali and Zebulun,"
,"7":"for I am going to bring Sisera to you at the river Kishon with his chariots and men, and I will give him into your hands.'"
,"8":"Barak answered her, 'If you will go, then I shall go, too; but if you do not go, I shall not go.'"
,"9":"Deborah answered, 'I will go with you, but if you do it that way the honor of the victory will not be yours, for Sisera will be killed by a woman.',In this way Deborah went with Barak to Kedesh. "
,"10":"Barak summoned men from Zebulun and Naphtali and ten thousand followed him. Deborah also went up with him."
,"12":"When Sisera came to know that Barak had climbed Mount Tabor,"
,"13":"he gathered all his chariots - nine hundred chariots of war in all - and all his men, and they set out from Harosheth-ha-goiim to the river Kishon."
,"14":"Then Deborah said to Barak, 'Rise, for this is the day in which Yahweh shall give Sisera into your hands. Today, Yahweh goes before you.',So, Barak went down from Mount Tabor with his ten thousand men. "
,"15":"Yahweh made him win over Sisera and his chariots and all his army. Sisera alighted from his chariot and fled,"
,"16":"while Barak pursued the chariots and the army to Harosheth-ha-goiim. All of Sisera's army perished. Nobody was spared."
,"11":"At that moment, Heber the Kenite was encamped by the oak of Zaan-nannim, near Kedesh, after separating from the other Kenite descendants of Hobab, Moses' father-in-law."
,"17":"There Sisera took refuge, and came running to the tent of Yael, the wife of Heber the Kenite. Peace reigned between the Kenite tribe and the Canaanites of Yabin, king of Hazor."
,"18":"Yael came out to meet Sisera and said to him, 'Come this way, my lord, have no fear.' Sisera entered and Yael hid him under a blanket."
,"19":"He asked her for a little water to quench his thirst. The woman opened a skin of milk, gave him a drink, and covered him again with the blanket."
,"20":"And he said to her, 'Stand at the entrance; and if anyone comes and asks you, tell him there is no one with you.'"
,"21":"Sisera was very tired, so he slept. Then the woman took a hammer and a tent peg, went quietly to him and drove the peg into his temple till it was fixed into the ground."
,"22":"When Barak arrived, Yael came out to meet him and said, 'Come in, and I will show you the man you are looking for.' He entered and saw Sisera dead with a tent peg through his temple."
,"23":"On that day Yahweh humbled Yabin before the Israelites."
,"24":"The Israelites did not rest until they destroyed all the Canaanites."
}`)
	CurrentBook.AddChapter(5, `{
"1":"On that day, Deborah and Barak, the son of Abinoam, sang this song:"
,"2":"In Israel the warriors let their hair loose, in Israel they presented voluntary offerings for the war. Blessed be Yahweh!"
,"3":"Listen, O kings; pay attention, O princes. To Yahweh will I sing. To Yahweh, the God of Israel, will I offer praise."
,"4":"When you went forth from Seir, O Yahweh, when you came from the camp of Edom, the earth trembled, the heavens reeled and the clouds poured down rain."
,"5":"The mountains rocked before Yahweh, before Yahweh - the God of Israel."
,"6":"In the days of Shamgar the son of Anath, in the days of Yael, caravans ceased and travelers wandered through the byways."
,"7":"There were no leaders in Israel until I, Deborah, awoke and arose as a mother of Israel."
,"8":"They went after new gods, and war was upon them. There was hardly a shield or a spear for forty thousand men in Israel!"
,"9":"My heart is with the leaders of Israel, among the people who came willingly. Blessed be Yahweh!"
,"10":"Those who go riding on white asses, those who walk by the way, meditate!"
,"11":"Hear the voice of those who divide the plunder near the watering place: they sing the favors God has done to Israel when the people of Yahweh march down to the gates."
,"12":"Wake up, Deborah, wake up! Wake up, wake up and begin to sing. Arise, Barak! And bring your songs, son of Abinoam."
,"13":"Let the survivors of the people rule over their oppressors! May Yahweh be with me, stronger than the valiant!"
,"14":"Your roots, O Ephraim, are in Amalek; your brother Benjamin is behind you among your army. From Machir the commanders marched down; from Zebulun the leaders bearing the brass staff."
,"15":"The leaders of Issachar are with Deborah, Issachar is with Barak; the people rushed forth following their footsteps into the plain. There were long talks among the clans of Reuben. "
,"16":"Why did you choose to remain in your folds listening to the flute among the flock? The clans of Reuben could not decide."
,"17":"Galaad remained on the other side of the Jordan, and Dan, why did you remain in your ships? Asher has remained on the seacoasts; he is quiet in his ports."
,"18":"Zebulun, in turn, has scorned death; Naphtali went up to the battlefield, too."
,"19":"The kings came to fight; the kings of Canaan fought at Taanach, near the waters of Megiddo, but they got no silver."
,"20":"From the heavens the stars fought, from their orbits they fought against Sisera."
,"21":"The torrent Kishon dragged them away, the cold torrent, the torrent Kishon. March on without fear, my soul!"
,"22":"Hoofs of horses shake the ground: the galloping, galloping of his horses."
,"23":"Cursed be Meroz, said the angel of Yahweh, cursed be it, cursed be its inhabitants, for it came not to the aid of Yahweh, not like the heroes."
,"24":"Blessed among women be Yael, wife of Heber the Kenite, among the women who dwell in tents, blessed may you be!"
,"25":"He asked for water, she gave him milk; in the cup of honor she served him cream."
,"26":"She put her hand to the peg and with her right hand took the hammer of a workman. She struck Sisera, crushed his head, pierced and shattered his temple."
,"27":"He collapsed at her feet, and there he fell, and lay still."
,"28":"Sisera's mother looks out of the window, and she cries out behind the lattice: Why is his chariot late in coming? Why is his chariot delayed?"
,"29":"The wisest of her women answers and says:"
,"30":"Surely they are dividing the plunder - one captive, two captives for each warrior; colored cloths for Sisera as booty, colored cloths twice adorned with raised embroidery for a scarf."
,"31":"So may all your enemies perish, O Yahweh, but may your friends be like the brilliant sun!"
}`)
	CurrentBook.AddChapter(6, `{
"1":"The Israelites treated Yahweh badly, and Yahweh gave them into the hands of the Midianites for seven years,"
,"2":"and the hand of the Midianites lay heavily on them. Because of Midian, the Israelites made for themselves passages in the mountains, caves and shelters. "
,"3":"When the Israelites had sown, Midian would come with Amalek and with the people of the East. They would come up against the Israelites,"
,"4":"encamp in the lands of the Israelites and destroy all the fields as far as the entrance to Gaza. They would leave no provisions or sheep or ox or ass,"
,"5":"for they would come up like locusts in number, bringing with them their livestock and their tents. They and their camels were many and they invaded and plundered the land."
,"6":"In this way, Midian subdued Israel and brought upon it so great a misery that the Israelites cried to Yahweh."
,"7":"When the Israelites cried to Yahweh because of Midian,"
,"8":"Yahweh sent them a prophet who said to them, 'This is the word of Yahweh, the God of Israel: I led you up from Egypt and brought you out of the house of slavery."
,"9":"I freed you from the hands of the Egyptians and from all your oppressors. I drove out before you the inhabitants of these lands, and gave their lands to you,"
,"10":"and I said to you, 'I am Yahweh, your God. Disregard the gods of the Amorites, in whose land you dwell.' But you did not listen to me.'"
,"11":"The Angel of Yahweh came and sat under the sacred tree at Ophrah, which belonged to Joash, of the family of Abiezer. Gideon, the son of Joash, was threshing the wheat in the winepress to hide it from the Midianites."
,"12":"The Angel of Yahweh said to him, 'Yahweh be with you, valiant warrior.'"
,"13":"Gideon answered, 'Please, my lord, if Yahweh is with us, why is all this happening to us? Where are the wonders which our fathers recounted to us? Did they not say that Yahweh led them up from Egypt? Why has he abandoned us now and given us into the hands of the Midianites?'"
,"14":"Yahweh then turned to him and said, 'Go, and with your courage, save Israel from the Midianites. It is I who send you.'"
,"15":"Gideon answered: 'Pardon me, Lord, but how can I save Israel? My family is the lowliest in my tribe and I am the least in the family of my father.'"
,"16":"Yahweh said to him, 'I will be with you and you shall defeat the people of Midian with one single stroke.'"
,"17":"Gideon said to him, 'Please give me a sign that it is indeed you who speak."
,"18":"Do not leave until I return with an offering and present it to you.' Yahweh responded, 'I am going to wait for you here.'"
,"19":"Gideon went and prepared a young goat, took a measure of flour and baked unleavened bread. He put the broth in a pot and the meat in a basket, and went to present them to the Angel under the tree."
,"20":"Then the Angel of God said to him, 'Take the meat and the bread; put them on this rock, and pour the broth over them.' Gideon did so."
,"21":"At that moment, the Angel of Yahweh extended the staff he was holding and touched the meat and the bread. Suddenly, fire blazed from the rock. The fire consumed the meat and the bread, and the Angel of Yahweh disappeared."
,"22":"Gideon realized that he was the Angel of Yahweh and said, 'Alas, O Lord Yahweh! I have seen the Angel of Yahweh face to face.'"
,"23":"But Yahweh said to him, 'Peace be with you. Do not fear for you shall not die.'"
,"24":"Gideon built an altar to Yahweh in that place and called it Yahweh-Peace. To this day, it is still in Ophrah of Abiezer."
,"25":"That same night Yahweh said to Gideon, 'Take with you ten of your father's servants and a seven-year-old bull. Destroy your father's altar to Baal and cut the sacred pillar beside it."
,"26":"Then build an altar to Yahweh on this knoll and sacrifice the bull to me, burning it with the wood from the sacred pillar.'"
,"27":"So, Gideon, with the help of his ten servants, did what Yahweh had commanded. But because he feared his family and the people of the town, he did it by night."
,"28":"On the following day, the towns-people saw the altar of Baal broken into pieces and the sacred pillar cut down. They also saw that a bull had been sacrificed on the new altar."
,"29":"So they asked one another and, as they investigated, found out that it was Gideon who had done it,"
,"30":"and they went to Joash and said, 'Hand your son over to us for he must die; he destroyed the altar of Baal and cut down the sacred pillar.'"
,"31":"But Joash said to the angry crowd, 'Are you going to defend Baal and save him? If he is god, let him defend himself when someone destroys his altar.'"
,"32":"On that day they gave Gideon the name Jerubaal which means: 'Let Baal defend himself against Gideon, for Gideon destroyed his altar.'"
,"33":"All Midian, Amalek and the people of the East joined forces, crossed the Jordan and invaded the plains of Jezreel."
,"34":"Then the spirit of Yahweh clothed Gideon with strength; he blew the trumpet and summoned the men of Abiezer."
,"35":"He sent messengers throughout the whole territory of Manasseh and they joined him. The people of Asher, Zebulun and Naphtali also went out to meet them."
,"36":"Gideon said to God, 'If indeed you will save Israel by my hand, as you have said, grant me this favor."
,"37":"I am going to spread this woolen fleece on the threshing ground. If the dew falls only on the fleece while all the ground remains dry, then I shall know that you are to save Israel by my hand, as you have promised.'"
,"38":"So it was: Gideon rose at day-break, squeezed the fleece and wrung out the dew, filling a cup with water."
,"39":"Gideon again spoke to God and said to him, 'Don't be angry with me if I dare to speak to you again. Allow me to make another test with the fleece: let it be dry only on the fleece and let dew come on all the ground.'"
,"40":"That night, Yahweh did so. The fleece remained dry and dew covered all the ground."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Jerubaal, that is Gideon, rose early with all the people who were with him and they encamped beside the spring of Harod. The Midianite camp was farther north and extended from the hill of Moreb to the plains."
,"2":"Then Yahweh said to Gideon, 'There are too many people with you. If I give the Midianites into their hands, the Israelites might think that they won over the Midianites by their own strength."
,"3":"So summon your men and say to them that whoever is afraid may go home.' So twenty-two thousand men returned and only ten thousand remained."
,"4":"Yahweh said to Gideon, 'There are still too many people. Take them down to the water and I myself will test them for you. If I say: This one shall go with you, he will go. And if I say: Not this one, he shall not go.'"
,"5":"So Gideon brought them down to the water and Yahweh told him, 'Those who lap the water like a dog, you shall place on one side. And those who kneel down to drink, you shall place on the other side.'"
,"6":"Three hundred men lapped the water, and the rest knelt down to drink."
,"7":"Then Yahweh said to Gideon, 'I will help these three hundred men who lapped the water and give the Midianites into your hands. Let the rest return to their homes.'"
,"8":"The three hundred men took the pitchers and the horns of whom Gideon dismissed. Finally, Gideon and his three hundred men faced the Midianites who were encamped below the valley."
,"9":"That night Yahweh said to him, 'Rise and go down to the camp, because I have given it into your hands."
,"10":"But if you are afraid to go down alone, set out for the camp with your servant Purah,"
,"11":"and listen to what they say there. You shall be strengthened by it and then you shall attack the camp.' He then went down with his servant Purah to the outposts of the guards of the camp."
,"12":"Midian, Amalek, and all the people of the East were in the valley, thick as locusts, and their camels were as countless as the sand on the seashore."
,"13":"Gideon approached just as a man was recounting his dream to his comrade. Gideon heard him say, 'I had a dream: a big loaf of barley bread rolled down into the camp of Midian, until it came to a tent, bumped against it and overturned the tent.'"
,"14":"His comrade answered him, 'This cannot mean anything other than the sword of Gideon, son of Joash, the Israelite. God has given Midian and the whole camp into his hands.'"
,"15":"When Gideon heard the dream and its interpretation, he bowed, returned to the camp of Israel and said, 'Arise, for Yahweh has given the camp of Midian into your hands.'"
,"16":"Gideon divided the three hundred men into three groups. Then he handed the trumpets to all and the empty pitchers with lighted torches inside."
,"17":"He said to them, 'Look at me, and do what I do. When I come to the outskirts of the camp, do as I do."
,"18":"When I and those who are with me blow the trumpets then blow yours all around the camp and shout, 'For Yahweh and for Gideon!''"
,"19":"With the hundred men with him, Gideon came to the Midianite camp just as the guards were changing shift at the beginning of the midnight watch."
,"20":"Then the Israelites smashed the jars, took the torches in one hand, and blew the trumpets they were holding in the other hand. After blowing the trumpets, the three groups shouted, 'For Yahweh and for Gideon!'"
,"21":"Everyone stood in his place around the camp while the Midianites ran, shouting as they fled."
,"22":"As the three hundred Israelites went on blowing the trumpets, Yahweh made the Midianites in the camp kill one another. Those who managed to escape went as far as Beth-shittah toward Zererah, and as far as the border of Abel-meholah opposite Tabbath."
,"23":"Then the Israelites from the tribe of Naphtali, Asher and the whole of Manasseh came to help Gideon, and they pursued Midian."
,"24":"Gideon also sent messengers throughout all the mountains of Ephraim to say, 'Come down to fight against Midian and block the passages as far as Beth-barah and along the Jordan.' So, all the men of Ephraim came out and occupied the shallow waters as far as Beth-barah and along the Jordan."
,"25":"They took the two leaders of Midian, Oreb and Zeeb as prisoners. They killed Oreb at the rock of Oreb, and Zeeb at the winepress of Zeeb. They pursued Midian and brought the heads of Oreb and Zeeb to Gideon at the other side of the Jordan."
}`)
	CurrentBook.AddChapter(8, `{
"1":"The people of Ephraim said to Gideon, 'Why didn't you call us when you went to fight against Midian?' They argued with him violently."
,"2":"He said to them, 'What have I done in comparison with what you have done? Are not the grapes of Ephraim better than the vintage of Abiezer?"
,"3":"Yahweh has given the leaders of Midian - Oreb and Zeeb - into your hands. What have I been able to do in comparison with what you have done?' After hearing this, their anger lessened."
,"4":"Gideon and his three hundred men came to the Jordan and crossed it. They were exhausted and hungry."
,"5":"So he said to the people of Succoth, 'Please give loaves of bread to the army that follows me, for they are exhausted and hungry, and I am still pursuing Zebah and Zalmunna, the kings of Midian.'"
,"6":"But the elders of Succoth answered, 'Have you by chance already restrained the hands of Zebah and Zalmunna? Why should we give bread to your army?'"
,"7":"Gideon answered them, 'Well, when Yahweh has given Zebah and Zalmunna into my hands, I will skin your flesh with the thorns and thistles of the desert.'"
,"8":"From there he went up to Penuel and made the same request. But they answered him as those of Succoth had."
,"9":"So Gideon said, 'When I return victorious, I will tear down this tower.'"
,"10":"Zebah and Zalmunna were in Karkor with their army of about fifteen thousand men, all that were left of the people of the East; a hundred and twenty thousand warriors had died!"
,"11":"Gideon went up by the road of the nomads, east of Nobah and Yogbehah, and fell upon Zebah and Zalmunna and their army."
,"12":"Zebah and Zalmunna fled. He pursued them, took the two as prisoners and scattered all their army."
,"13":"After the battle, Gideon, the son of Joash, returned through the slope of Heres."
,"14":"He caught a young man of the people of Succoth and questioned him. The young man wrote down for him the names of the seventy-seven leaders and elders of Succoth."
,"15":"Gideon went to the people of Succoth and said to them, 'Here are Zebah and Zalmunna about whom you mocked me by saying: Have you by chance already restrained the hands of Zebah and Zalmunna for us to give bread to your hungry troops?'"
,"16":"So he took the elders of the town and punished the people of Succoth with thorns and thistles of the desert."
,"17":"He tore down the tower of Penuel and killed the inhabitants of the town."
,"18":"Then he said to Zebah and Zalmunna, 'What did the men whom you killed at Tabor look like?' They answered, 'They looked like you, they looked like sons of kings.'"
,"19":"Gideon answered, 'They were my brothers, the sons of my mother. As Yahweh lives, if you had let them live, I would not kill you.'"
,"20":"He said to Yether, his eldest son, 'Courage, kill them!' But the youth did not draw his sword; he did not dare do it for he was still very young."
,"21":"So Zebah and Zalmunna said, 'Rise and kill us yourself, for as the man is, so is his courage.' Gideon arose and killed them, and took the ornaments off their camels' necks."
,"22":"The Israelites said to Gideon, 'Since you have saved us from the Midianites, you shall be our king, and after you, your son and the descendants of your son.'"
,"23":"But Gideon answered, 'I will not rule over Israel, nor my son, for Yahweh is our king!'"
,"24":"Gideon added, 'I will ask something from you. Let each of you give me an earring from your booty.' Gideon said this for these Midianites wore gold earrings like all the Ishmaelites."
,"25":"They answered him, 'That we will gladly do.' Then Gideon spread out his cloak and every Israelite threw in an earring from his booty."
,"26":"The gold earrings reached one thousand seven hundred pieces of gold; not counting the brooches, the rings, the expensive garments used by the kings of Midian, and the collars of the camels."
,"27":"With this money, Gideon made an idol and put it in his city of Ophrah. People from all Israel began to go to that place, turning away from Yahweh. That was the trap into which Gideon and his family fell."
,"28":"In spite of this, the Midianites were humbled in such a way that peace reigned in Israel for forty years during Gideon's lifetime."
,"29":"Gideon returned to Ophrah and remained in his house."
,"30":"He had seventy sons of his blood, for he had many wives."
,"31":"A woman from the city of Shechem also bore him a son whom he named Abimelech."
,"32":"Gideon the son of Joash died at a happy old age, and he was buried in the tomb of Joash his father, in Ophrah of Abiezer."
,"33":"After the death of Gideon, the Israelites again prostituted themselves to the Baals and took Baal-Berith as god."
,"34":"The Israelites no longer remembered Yahweh, their God, who had freed them from the hands of all the enemies who surrounded them."
,"35":"Neither were they grateful to the family of Jerubaal-Gideon for all the good things he had done to Israel."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Abimelech, the son of Jerubaal, marched to Shechem where the brothers of his mother were, and he said to them and to the whole paternal family of his mother,"
,"2":"'Please ask this of all the lords of Shechem: Which is better for you, that you be governed by all the seventy sons of Jerubaal, or by only one man? Remember that I am of the same blood as you are.'"
,"3":"The brothers of his mother sent this message to all the lords of Shechem. The lords of Shechem took sides with Abimelech, saying, 'He is our brother.'"
,"4":"So they gave him seventy pieces of silver from the temple of Baal-berith which Abimelech used to hire wicked mercenaries to set out with him."
,"5":"Abimelech went with them to the house of his father in Ophrah, and on one stone killed all his brothers, the seventy sons of Jerubaal. Only Jotham, the youngest son of Jerubaal, was able to escape by hiding himself."
,"6":"Then all the lords of Shechem and the whole council assembled together by the oak at the pillar in Shechem, and proclaimed Abimelech king."
,"7":"When Jotham was told about this, he went to the top of Mount Gerizim. There he cried out to them, 'Listen to me, lords of Shechem, that God may listen to you!"
,"8":"The trees once set out to find and anoint a king. They said to the olive tree, 'Be our king.'"
,"9":"The olive tree answered, 'Am I going to renounce the oil by which - thanks to me - gods and men are honored, to hold sway over the trees?'"
,"10":"The trees said to the fig tree: 'Come and reign over us.'"
,"11":"The fig tree answered them, 'Am I going to renounce my sweetness and my delicious fruit, to hold sway over the trees?'"
,"12":"The trees said to the vine: 'Come and reign over us.'"
,"13":"The vine answered, 'Am I going to renounce my juice which cheers gods and men to hold sway over the trees?'"
,"14":"Then the trees said to the bramble bush: 'Come, reign over us.'"
,"15":"The bramble bush answered the trees, 'If you come in sincerity to anoint me as your king, then come near and take shelter in my shade; but if not, let fire break out of the bramble bush to devour even the cedars of Lebanon.'"
,"16":"And now, tell me, have you acted rightly and truthfully in choosing Abimelech king? Have you treated Jerubaal and his family well and given him what he deserves according to his merits?"
,"17":"For my father fought for you, risking his life to free you from the hands of Midian."
,"18":"But now, you have risen against the family of my father. You have killed all his seventy sons with one stone, and have declared Abimelech, the son of his slave, as king over the lords of Shechem because he is your brother."
,"19":"If you have acted rightly and truthfully toward Jerubaal and his family today, then may Abimelech rejoice in you and you in him."
,"20":"But if not, let fire break forth from Abimelech to devour the lords of Shechem and their council; and let fire break forth from their council to devour Abimelech.'"
,"21":"Jotham fled to the safety of Beer, where he lived far from his brother Abimelech."
,"22":"Abimelech ruled over Israel for three years."
,"23":"But Yahweh sent a spirit of discord between Abimelech and the lords of Shechem; and the lords of Shechem betrayed Abimelech."
,"24":"Yahweh did this so that the seventy sons of Jerubaal might be avenged. Their blood had to fall back upon their brother Abimelech who murdered them, and the lords of Shechem who helped him murder his brothers."
,"25":"To do him harm, the lords of Shechem prepared ambushes against Abimelech on the mountaintops, and intimidated everyone who passed by the way. Abimelech was informed of this."
,"26":"Then Gaal, the son of Ebed, came with his brothers, and he won the confidence of the lords of Shechem."
,"27":"One day they went to the vineyards and gathered grapes and trod on them. Then they feasted in the temple of their god. While eating and drinking, they cursed Abimelech."
,"28":"Then Gaal, the son of Ebed, exclaimed, 'Who is Abimelech for the Shechemites that we should serve him? He is only the son of Jerubaal, and Zebul is but his town captain. Let us serve the people of Hamor, the father of Shechem. Why should we serve Abimelech?"
,"29":"If only this people were in my hands, then I would remove Abimelech and say to him: Reinforce your army, come out and fight!'"
,"30":"When Zebul, the city governor, was informed of the plan of Gaal, the son of Ebed, he was very angry."
,"31":"He sent messengers to Abimelech in secret to say to him, 'See, Gaal, the son of Ebed, has come with his brothers to Shechem and he is stirring up the city against you."
,"32":"Therefore, arise, you and the men you have with you, and lay an ambush in the field."
,"33":"By early morning at sunrise, go and rush upon the city. When Gaal comes out against you with his men, you may do to him whatever you wish.'"
,"34":"Abimelech and all his troops rose by night, and they laid an ambush against Shechem in four groups."
,"35":"When Gaal, the son of Ebed, went out and stood at the entrance of the city, Abimelech and his troops rose from their hiding place."
,"36":"Gaal saw the troops and said to Zebul, 'Look, people are coming down from the mountain tops.' But Zebul answered him, 'It is the shadow of the mountain that you see. You mistake it for men.'"
,"37":"Gaal said again, 'Look, people are coming down from the center of the land, and another group is coming from the Diviners' Oak.'"
,"38":"Zebul then said, 'Did you not say: Who is Abimelech that we should serve him? Are not these men those whom you despised? Go now and fight them.'"
,"39":"Gaal went out and led the people of Shechem in fighting Abimelech."
,"40":"Abimelech pursued Gaal who fled and many fell dead before reaching the gates."
,"41":"Abimelech returned to Arumah, and Zebul drove out Gaal and his brothers, and did not let them live in Shechem."
,"42":"The following day, the people went out into the fields. Abimelech was informed about this,"
,"43":"so he called his troops, divided them into three groups and laid an ambush in the fields. When he saw the people coming out of the city, he rose against them and killed them."
,"44":"Abimelech and the group with him attacked and took possession of the entrance to the city gates; other groups rushed upon those who were in the fields."
,"45":"Throughout that day, Abimelech attacked the city. He took it and killed all its inhabitants. Then he destroyed the city and sprinkled salt over it."
,"46":"When the inhabitants of the Tower of Shechem heard this, they went to the underground room of the temple of El-Berith."
,"47":"Abimelech was told that all the inhabitants of the Tower of Shechem were together,"
,"48":"so he went up to Mount Zalmon with all his troops. Taking an ax, he cut down a branch of a tree, lifted it up and bore it on his shoulders. He then said to the troops with him, 'You have seen what I have done, so do the same.'"
,"49":"So all his men cut the branches, then followed Abimelech. They piled the branches on top of the underground room and set them on fire over the people inside. So all the inhabitants of the Tower of Shechem - about a thousand men and women - died."
,"50":"Abimelech went against Thebez, besieged it and took it."
,"51":"But inside the city was a strong tower in which all the men and women, all the inhabitants of the city sought refuge. They locked it from within and went up to the roof of the tower."
,"52":"Abimelech came to the tower to attack them; he approached the door, intending to set it on fire."
,"53":"But a woman threw a millstone upon his head and shattered his skull."
,"54":"He immediately called out to his young armor-bearer and said to him, 'Draw your sword and kill me, lest they say of me: 'A woman killed him'.' So his armor-bearer thrust him through, and he died."
,"55":"When the people of Israel saw that Abimelech was dead, everyone returned to his home."
,"56":"In this way God repaid Abimelech for the evil he had done to his father when he murdered his seventy brothers."
,"57":"He also made the people of Shechem pay for all their wickedness. So the curse of Jotham, son of Jerubaal, was fulfilled."
}`)
	CurrentBook.AddChapter(10, `{
"1":"After Abimelech, Tola the son of Puah, the son of Dodo, appeared to save Israel. He was from the tribe of Issachar and lived at Shamir, in the mountains of Ephraim."
,"2":"He was judge of Israel for twenty-three years and when he died, he was buried in Shamir."
,"3":"After him rose Jair of Gilead who was judge of Israel for twenty-two years."
,"4":"He had thirty sons who rode on thirty asses, and had thirty cities which are still called the villages of Jair to this day, in the land of Gilead."
,"5":"When Jair died, he was buried in Kamon."
,"6":"The Israelites again treated Yahweh badly; they served the Baals and the Ashtaroth, the gods of Aram and Sidon, the gods of Moab, the gods of the Ammonites and the gods of the Philistines. They abandoned Yahweh and no longer served him."
,"7":"The anger of Yahweh burned against Israel, so he gave them into the hands of the Philistines and the Ammonites."
,"8":"For eighteen years, all the Isra-elites living on the other side of the Jordan in the Amorite land of Gilead were disturbed and oppressed."
,"9":"The Ammonites also crossed the Jordan to attack Judah, Benjamin and the people of Ephraim. Israel was in great distress."
,"10":"In those years the Israelites called out to Yahweh saying, 'We have sinned against you, for we have abandoned Yahweh, our God, to serve the Baals.'"
,"11":"Yahweh said to the Israelites, 'When the Egyptians, the Amorites, the Ammonites, the Philistines,"
,"12":"the Sidonians, Amalek and Midian oppressed you, and you cried out to me, did I not save you from their hands?"
,"13":"But in spite of this, you have abandoned me and served other gods. So I will not save you again."
,"14":"Go and cry out to the gods you have chosen: see if they will save you in the time of your distress.'"
,"15":"The Israelites answered Yahweh, 'We have sinned. Do to us whatever you wish, but save us today.'"
,"16":"Then they put away the strange gods and served Yahweh. And he could no longer endure the suffering of Israel."
,"17":"The Ammonites assembled and went to encamp in Gilead. The Israelites also assembled and they encamped at Mizpah."
,"18":"There the people and the leaders of Gilead asked one another, 'Who will lead us all to fight against the Ammonites? Whoever he is, we shall make him head of all the inhabitants of Gilead.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Jephthah the Gileadite was a valiant warrior. His mother was a prostitute, and his father was Gilead."
,"2":"But Gilead's wife also bore him sons, and when they grew up, they drove Jephthah out saying, 'You shall not share or inherit anything in the household of our father, for you are the son of another woman.'"
,"3":"Jephthah fled from his brothers and went to the region of Tob. There he joined a band of mercenaries who made their raids with him."
,"4":"The time came when the Ammonites declared war on Israel."
,"5":"So the elders of Gilead went to Jephthah in the land of Tob"
,"6":"and said to him, 'Come and lead our men in fighting the Ammonites.'"
,"7":"Jephthah answered the elders of Gilead, 'Didn't you drive me out of my father's house because you hated me? Why do you come to me now in your distress?'"
,"8":"The elders answered him, 'We come asking you to join us in fighting the Ammonites; we want you to be head of the whole of Gilead.'"
,"9":"Jephthah answered them, 'If you ask me to return to fight the Ammonites and Yahweh grants me victory, I will be your head.'"
,"10":"And they said to him, 'May Yahweh listen to us! Woe to us if we do not carry out what we have just said!'"
,"11":"So Jephthah returned with the elders of Gilead and the people made him their head and general, and Jephthah repeated all his conditions before Yahweh in Mizpah."
,"12":"Jephthah sent messengers to the king of the Ammonites to say to him, 'What happened between us that you come and attack me in my own country?'"
,"13":"The king answered the messengers, 'When Israel went up out of Egypt, they seized my country from the Arnon to the Yabbok and to the Jordan. So give it back willingly.'"
,"14":"Jephthah again sent messengers to the king of the Ammonites,"
,"15":"saying 'This is what Jephthah says: Israel has not seized the land of the Ammonites."
,"16":"When they came up from Egypt, Israel went through the desert to the Sea of Reeds and came to Kadesh."
,"17":"Then Israel sent messengers to the king of Edom and said to him, 'Let us pass through your country.' But the king of Edom did not listen. They also sent to the king of Moab, and he, too, refused. So Israel remained at Kadesh."
,"18":"Then journeying through the desert, they went around the country of Edom and Moab, and came to the east of the land of Moab. They encamped on the other side of the Arnon, for the Arnon was the boundary of Moab."
,"19":"Israel then sent messengers to Sihon, king of the Amorites, who ruled in Heshbon, and said to him, 'Let us pass through your country and go to our place.'"
,"20":"But Sihon did not trust Israel enough to let them pass through; he gathered all his men and encamped at Jahaz and attacked Israel."
,"21":"Yahweh the God of Israel gave Sihon and all his people into the hands of Israel. Israel defeated them and conquered all the land of the Amorites who lived there."
,"22":"So they conquered the whole territory of the Amorites from the Arnon to the Yabbok, and from the desert to the Jordan."
,"23":"Since Yahweh the God of Israel has taken this land from the Amorites for his people Israel, can you now take it away from us?"
,"24":"Do you not hold all that your god Chemosh has given you? In the same way, we hold all that Yahweh, our God, has given us."
,"25":"Will you do better than Balak, son of Zippor, the king of Moab? Was he able to attack Israel?"
,"26":"For three hundred years, Israel has lived in Heshbon and the cities that depend on it. They have also lived in Aroer and in its villages and in all the cities on both sides of the Jordan. Why didn't you recover these within that time?"
,"27":"I have not offended you, but you are treating me badly by attacking me. Let Yahweh, the Judge, decide today between the children of Israel and the children of Ammon.'"
,"28":"But the king of the Ammonites did not pay attention to Jephthah's message."
,"29":"The Spirit of Yahweh came upon Jephthah. He went through Gilead and Manasseh, passed through Mizpah of Gilead, and then entered the territory of the Ammonites."
,"30":"Jephthah made a vow to Yahweh: 'If you make me victorious,"
,"31":"I shall sacrifice to you whoever first comes out of my house to meet me when I return from battle. He shall be for Yahweh and I shall offer him up through the fire.'"
,"32":"Jephthah crossed the territory of the Ammonites to fight against them, and Yahweh gave him victory."
,"33":"He pursued them from the city of Aroer to the entrance of Minnith and Abel Keramim, seizing twenty towns. So he defeated the Ammonites."
,"34":"When Jephthah returned home to Mizpah, his daughter came out to meet him. She was so happy to see her father that she danced to the sound of her tambourine. She was an only child; besides her he had no other daughter or son."
,"35":"When Jephthah saw her, he tore his clothes and cried out, 'My daughter, you have shattered me; you have brought me misfortune. For I have made a foolish vow to Yahweh, and now I cannot take it back.'"
,"36":"She answered him, 'Father, even if you have made such a foolish vow, you have to do to me just as you promised, for Yahweh has avenged you and crushed your enemies."
,"37":"I only beg of you to give me two months to live with my companions in the mountains. There I shall lament because I will never marry.'"
,"38":"Jephthah said to her, 'Go then.' And he sent her away for two months. She and her companions went to the mountains and wept because she would never marry."
,"39":"At the end of two months, she returned to her father and he fulfilled the vow he had made. The young girl had never known a man. From this comes the Israelite custom"
,"40":"that the daughters of Israel go out for four days annually to lament the daughter of Jephthah the Gileadite."
}`)
	CurrentBook.AddChapter(12, `{
"1":"The men of Ephraim gathered, crossed the Jordan northward and said to Jephthah, 'Why did you go and attack the Ammonites without asking us to march with you? For this we shall burn you inside your house.'"
,"2":"Jephthah answered them, 'My people and I had a great struggle with the Ammonites. I asked help from you but you did not save me from their hands."
,"3":"When I saw that no one had come to help me, I risked my own life and marched against the Ammonites, and Yahweh gave them into my hands. Why, then, have you come up today to fight me?'"
,"4":"Then Jephthah gathered all the men of Gilead and attacked Ephraim. The Gileadites defeated the Ephraimites who told them, 'You, Gileadites, are fugitives who crossed from Ephraim and Manasseh.'"
,"5":"Gilead seized the shallow waters of the Jordan and blocked the way. Whenever a fugitive from Ephraim said, 'Let me pass,' the men of Gilead would ask him, 'Are you an Ephraimite?' If he responded, 'No,'"
,"6":"they would add, 'Then say Shibboleth.',But then he would say, 'Sibboleth' for an Ephraimite could not pronounce it correctly. So they would seize him and cut his throat by the shallow waters of the Jordan. Forty-two thousand men from Ephraim perished at that time."
,"7":"Jephthah was judge in Israel for six years. Then he died and was buried in his city, Mizpah of Gilead."
,"8":"After him, Ibzan of Bethlehem was judge in Israel."
,"9":"He had thirty sons and thirty daughters. His thirty daughters were given in marriage outside his clan, but for his sons, he brought in thirty women. He was judge in Israel for seven years."
,"10":"When Ibzan died, he was buried in Bethlehem."
,"11":"After him, Elon the Zebulunite became judge in Israel. He governed Israel for ten years."
,"12":"Then he died and was buried in Aijalon in the land of Zebulun."
,"13":"After him, Abdon, the son of Hillel of Pirathon, was judge in Israel."
,"14":"He had forty sons and thirty grandsons who rode on seventy asses. He was judge in Israel for eight years."
,"15":"Then he died and was buried at Pirathon, in the mountains of Ephraim, in the mountain of the Amorites."
}`)
	CurrentBook.AddChapter(13, `{
"1":"The Israelites again treated Yahweh badly so he gave them into the hands of the Philistines for forty years."
,"2":"There was a man of Zorah of the tribe of Dan, called Manoah. His wife could not bear children."
,"3":"The Angel of Yahweh appeared to this woman and said to her, 'You have not borne children and have not given birth, but see, you are to conceive and give birth to a son."
,"4":"Because of this, take care not to take wine or any alcoholic drink, nor to eat unclean foods from now on,"
,"5":"for you shall bear a son who shall be a Nazirite of Yahweh from the womb of his mother. Never shall his hair be cut for he is consecrated to Yahweh. He shall begin the liberation of the Israelites from the Philistine oppression.'"
,"6":"The woman went to her husband and told him, 'A messenger of God who bore the majesty of an angel spoke to me. I did not ask him where he came from nor did he tell me his name."
,"7":"But he said to me: 'You are to conceive and give birth to a son. Henceforth, you shall not drink wine or fermented drinks, nor eat anything unclean, for your son shall be a Nazirite of God from the womb of his mother until the day of his death'.'"
,"8":"Manoah called upon Yahweh and said, 'I pray you, Lord, that the man of God whom you have sent may come again to us and teach us how to bring up the boy who is to be born.'"
,"9":"Yahweh listened to Manoah and the Angel of Yahweh came to the woman as she was seated in the fields. Again Manoah, her husband, was not with her when the Angel came."
,"10":"The woman immediately ran to inform her husband and told him, 'Look, the man who came to me the other day is here again.'"
,"11":"Manoah rose and followed his wife. He came to the man and said to him, 'Are you the man who has spoken to this woman?',He answered, 'I am.' "
,"12":"Manoah said to him, 'When your word is fulfilled, what rule and direction shall the boy follow?'"
,"13":"The Angel of Yahweh answered Manoah, 'She must abstain from all I have indicated to this woman."
,"14":"She shall not taste anything that comes from the grape, nor drink wine or fermented drinks, nor eat anything unclean, and she shall observe everything I have commanded her.'"
,"15":"Manoah then said to the Angel of Yahweh, 'Permit us to detain you and prepare a young goat for you.' (Manoah did not know that the man was the Angel of Yahweh)"
,"16":"But he said to Manoah, 'Even if I did stay, I would not taste your food. But if you want to offer a burnt offering, offer it to Yahweh.'"
,"17":"So Manoah said to the Angel of Yahweh, 'What is your name, that we may honor you when your word comes true.'"
,"18":"The Angel of Yahweh answered him, 'Why do you ask my name? It is Wonderful...'"
,"19":"Manoah then took the young goat and the cereal offering, and offered it upon the rock as a holocaust to Yahweh who does wonderful things."
,"20":"And something happened as Manoah and his wife looked on. A fire broke forth from the altar rising toward heaven, and the Angel of Yahweh ascended in the flame. When Manoah and his wife saw this, they fell face downwards on the ground. "
,"21":"When the Angel of Yahweh vanished from the sight of Manoah and his wife, Manoah knew then that he was the Angel of Yahweh."
,"22":"And he said to his wife, 'We shall surely die for we have seen God.'"
,"23":"She answered him, 'If Yahweh had wanted to kill us, he would not have accepted the holocaust or the offering from our hand; he would not have made all these things happen or said what we have just heard.'"
,"24":"The woman gave birth to a son and named him Samson. The boy grew and Yahweh blessed him."
,"25":"Then the Spirit of Yahweh began to move him when he was in Mahane Dan between Zorah and Eshtaol."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Samson went down to Timnah and saw a Philistine woman."
,"2":"He came up and said to his father and mother, 'I have seen a Philistine woman at Timnah; get her for me that she may be my wife.'"
,"3":"His father and mother said to him, 'Is there no one among the daughters of your brothers and among all your people that you should go and take a wife from among those uncircumcised Philistines?',Samson said to his father, 'Get her for me, for I like her.' "
,"4":"His father and mother did not know that this came from Yahweh who was seeking a quarrel with the Philistines; for at that time, the Philistines had dominion over Israel."
,"5":"Samson then went down to Timnah, and when he reached the vineyards at Timnah, a young lion came up roaring toward him."
,"6":"The Spirit of Yahweh then seized Samson. With bare hands he tore the lion to pieces as he would have done with a young goat."
,"7":"But he told neither his father or mother what he had done."
,"8":"Then he went down and talked to the woman who pleased him. After some time, he returned to take her. He went out of his way to look at the carcass of the lion. He found a swarm of bees and honey in the lion's carcass. "
,"9":"Samson scraped the honey into his hands and ate it as he walked. When he reached his parents, he gave them honey and they ate it, too. But he did not tell them he had taken the honey from the lion's carcass. "
,"10":"Then, Samson's father went down to the woman and Samson offered a banquet as was the custom among the young."
,"11":"When he appeared, the Philistines assigned thirty men to go with him as his wedding companions."
,"12":"Samson said to them, 'I am going to give you a riddle. If you can give me the right solution within seven days of the feast, I shall give you thirty tunics and thirty linen garments."
,"13":"But if you can't tell me the solution, you will give me thirty tunics and thirty linen garments.' They answered, 'Tell your riddle; we are listening.'"
,"14":"He said to them, 'From him who eats came what is eaten, and from the strong, sweetness came.'"
,"15":"After three days, they had not guessed the riddle. So on the fourth day, they said to Samson's wife, 'Convince your husband to explain the riddle to us, or we will burn you and your father's family. Did you invite us to rob us?'"
,"16":"Samson's wife began to weep and she threw herself upon her husband saying, 'You do not like me or love me anymore. You have given a riddle to the young men of my people, but you have not explained it to me.' He said to her, 'I have not explained it even to my parents, why should I explain it to you?'"
,"17":"She cried before him for seven days while the feast lasted. On the seventh day, he explained it to her for he was bored with her crying. She then related it to her countrymen."
,"18":"On the seventh day, before the married couple were to enter the wedding chamber, the people of the city said to Samson, 'What is sweeter than honey? What is stronger than a lion?' He said to them, 'If you had not plowed with my young cow, you would not have guessed my riddle.'"
,"19":"Then the Spirit of Yahweh seized him. He went down to Ashkelon, killed thirty men, took their plunder and gave the linen garments to those who had guessed the riddle. Then, in great anger, he came up to his father's house."
,"20":"So Samson's wife was given to one of his wedding companions."
}`)
	CurrentBook.AddChapter(15, `{
"1":"After some time, during wheat harvest, Samson went to visit his wife, bringing a young goat with him, and he said, 'I want to be with my wife in our room.' But her father would not let him in,"
,"2":"saying, 'I thought that you did not like her anymore, so I gave her to your companion. Is not her younger sister still better? Why don't you take her instead?'"
,"3":"Samson replied, 'This time I owe nothing to the Philistines even if I do them harm.'"
,"4":"Samson went out and caught three hundred foxes, took some torches and tied the animals tail to tail. He then placed a torch in between every two tails,"
,"5":"set fire to the torches and turned the foxes loose in the grain fields of the Philistines. In this way, he burned the sheaves and the standing grain, together with the vineyards and olive groves."
,"6":"The Philistines asked, 'Who did this?' And they answered, 'Samson, the son-in-law of the man from Timnah, because this man took his wife and gave her to his companion.' So they went up and burned her and her family."
,"7":"Samson said to them, 'Since you did this, I will not rest until I have had my revenge on you.'"
,"8":"So he caused a great havoc upon them. Then he went down to live in a cave in the rock of Etam."
,"9":"The Philistines went up to the mountains of Judah and raided Lehi."
,"10":"The men of Judah asked them, 'Why have you come to attack us?' They answered, 'We have come to capture Samson, and do to him what he did to us.'"
,"11":"Three thousand men of Judah went down to the cave at the rock of Etam and said to Samson, 'Do you not know that the Philistines lord it over us? Now what have you done to us?' He answered, 'What they did to me, I have done to them.'"
,"12":"They said to him, 'We have come down to tie you up and hand you over to the Philistines.' Samson said to them, 'Swear to me that you will not kill me.'"
,"13":"They answered, 'No, we only want to tie you up and hand you over to them, but we will not kill you.' They bound him with two new ropes and brought him up from the rocks."
,"14":"When they arrived in Lehi, the Philistines ran to him with shouts of victory. But the Spirit of Yahweh came upon Samson. The ropes that bound him became like linen flax burned in the fire and the knots were loosened from his arms."
,"15":"He found a fresh jawbone of an ass, grabbed it and with it killed a thousand men."
,"16":"Samson then said, 'With the jawbone of an ass, I dealt them a mighty blow; with the jawbone of an ass, I beat a thousand men.'"
,"17":"When he finished speaking, he threw away the jawbone and that is why the place was called Ramath-lehi."
,"18":"Then he became terribly thirsty and called out to Yahweh saying, 'You have given your servant this great victory. Now am I to die of thirst and fall into the hands of the uncircumcised?'"
,"19":"So Yahweh opened a hollow in the ground at Lehi and water gushed forth from it. Samson drank; his strength returned and he revived. For this, the name En-hakkore was given to the fountain which is still in Lehi to this day."
,"20":"Samson became judge of Israel for twenty years during the time of the Philistines."
}`)
	CurrentBook.AddChapter(16, `{
"1":"When Samson went to Gaza, he saw a prostitute there and entered the place where she lived."
,"2":"When the men of Gaza were notified that Samson had come, they made the rounds and lay in wait for him at the city gates. They kept quiet all night, thinking, 'We will wait for him until dawn and then we will kill him.'"
,"3":"But Samson slept until midnight. At midnight, he arose and took hold of the door panels of the city gates together with the doorcase, and pulled them up with the bar. He put them upon his shoulders and carried them to the hilltop opposite Hebron."
,"4":"After this, Samson fell in love with a woman in the valley of Sorek; she was called Delilah."
,"5":"The Philistine chiefs said to this woman, 'Charm him and find out where he gets such strength and how we can defeat and tie him up. Each of us shall give you eleven hundred pieces of silver.'"
,"6":"So Delilah asked Samson, 'Tell me, please, where do you get such strength and how can others tie you up to subdue you?'"
,"7":"Samson answered her, 'If they bind me with seven new and moist bowstrings, then I shall lose my strength and be as any other man.'"
,"8":"The Philistine chiefs sent seven new bowstrings that had not been dried to Delilah, and she tied Samson with them."
,"9":"With men hidden in her dwelling, she shouted, 'Samson, here come the Philistines!' Samson broke the bowstrings as if they were burned flax. So they did not find out where his great strength came from."
,"10":"Then Delilah said to Samson, 'You made a fool of me, and you lied to me. Tell me, how can they subdue you?'"
,"11":"Samson answered her, 'If they bind me this time with seven newly-braided ropes which have never been used, then I shall lose my strength and be like any other man.'"
,"12":"So Delilah bound him with seven newly-braided ropes. But when she shouted, 'Here come the Philistines!' he again snapped the ropes round his arms like thread."
,"13":"So Delilah said to him, 'How long will you deceive me and lie to me? Tell me how they can subdue you.' He answered her, 'If you braid the seven locks of my hair in the warp of the loom and tighten it with a pin, then I shall lose my strength.'"
,"14":"She lulled him to sleep, and then braided the seven locks of his hair in the warp of the loom and tightened it with a pin. Then she cried, 'Here come the Philistines!' Samson woke up and pulled the warp with the locks of his hair. And so, Delilah did not find out where his great strength came from."
,"15":"Then Delilah said to him, 'You say that you love me, but your heart is not with me. Three times, you have deceived me and have not told me from whence your great strength comes.'"
,"16":"And as Delilah insisted and bothered him day after day with her questions, the time came when Samson felt he would die in disgust."
,"17":"So he told her the truth: 'Never has my hair been cut for I am a Nazirite, consecrated to God from the womb of my mother. If my hair is cut, then I shall lose my strength and be like any other man.'"
,"18":"Delilah understood that he had told her the truth this time, so she called the Philistine chiefs and said, 'Come, because Samson has revealed his secret to me.' They took the money and came to her."
,"19":"Delilah lulled Samson to sleep upon her knees and called a man to cut the seven locks of his hair. And she could immediately subdue him for his strength had left him."
,"20":"When Delilah shouted 'Samson, the Philistines!' he awoke and thought that he could still save himself as on other occasions. But he did not know that Yahweh was no longer with him."
,"21":"So the Philistines seized him, gouged out his eyes, and brought him to Gaza. There they bound him with two bronze chains and made him turn the mill in the prison."
,"22":"The hair on Samson's head, however, began to grow as soon as it was cut."
,"23":"The Philistine chiefs assembled to offer a great sacrifice to their god Dagon and had a great feast, saying, 'Our god has given Samson, our enemy, into our hands!'"
,"25":"As they were very happy, they said, 'Bring out Samson that he may amuse us.' They brought him out of prison and he amused them. Then they had him placed between the columns"
,"24":"and on seeing him the people praised their god saying, 'Our god has put our enemy into our hands, Samson who has destroyed our country and killed our men.'"
,"26":"Samson then said to the boy who held him by the hand, 'Lead me where I can touch the pillars on which this house rests, so that I may lean on them.'"
,"27":"The house was full of men and women, all the Philistine chiefs were also there, and on the roof were about three thousand men and women watching Samson for amusement."
,"28":"Samson called on Yahweh and exclaimed, 'Lord, Yahweh, please remember me and restore my strength only this once, so that I may avenge myself against the Philistines for my eyes.'"
,"29":"Samson grasped the two middle pillars on which the house rested, leaned on them with his right arm on one pillar and his left on the other,"
,"30":"and cried out, 'Let me die with the Philistines!' He pushed with all his strength and the house fell upon the chiefs and the people gathered there. Those who joined him in his own death were more than those he had killed during his lifetime."
,"31":"His brothers and the whole family of his father went down to get him. They buried him between Zorah and Eshtaol, in the tomb of his father Manoah. He had judged Israel for twenty years."
}`)
	CurrentBook.AddChapter(17, `{
"1":"A man named Micah lived in the mountains of Ephraim. One day"
,"2":"he said to his mother, 'The eleven hundred pieces of silver taken from you and about which you uttered a curse, well, it was I who took that silver. And now, I return it to you.'"
,"3":"His mother answered, 'May Yahweh bless my son!' So he returned the eleven hundred pieces of silver to his mother. But his mother said to him, 'I had consecrated this money to Yahweh with my own hand, so that with this money, my son could make a statue cast in metal. So I am giving this silver back to you.'"
,"4":"He, however, returned the silver to his mother who set aside two hundred pieces for the silversmith, who made a statue cast in metal."
,"5":"This was placed in the house of Micah, so that Micah had a house of God. He also made an ephod to consult Yahweh as they cast lots, and some small idols, and consecrated also one of his sons as his priest."
,"6":"At that time, there was no king in Israel and each one did what seemed right to him."
,"7":"A young Levite of Bethlehem in Judah, a descendant of Moses who lived there as a foreigner,"
,"8":"left Bethlehem one day and set out to see where he could live as a guest. He came to the house of Micah in the mountains of Ephraim,"
,"9":"and Micah asked him, 'Where do you come from?' He answered, 'I am a Levite and I have come walking from Bethlehem; I am in search of a place where I can stay as a guest.'"
,"10":"Micah said to him, 'Stay in my house and be a father and priest to me; I shall give you ten pieces of silver a year, clothing and food.' So the Levite went in to his house."
,"11":"The Levite agreed to stay in Micah's house and became like one of his sons."
,"12":"Micah consecrated the Levite, and this young man became his priest and remained in the house of Micah."
,"13":"And Micah said, 'Now I know that Yahweh will bestow favors on me for this Levite has become my priest.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"At that time there was no king in Israel. The tribe of Dan was looking for a territory to dwell in, because until that day they had not received a share in the inheritance of the tribes of Israel."
,"2":"So the Danites sent five valiant men from Zorah and Eshtaol - all from the Danite tribe - to go around the land and explore it. They said to them, 'Go and explore the country.' These men came to the mountains of Ephraim near the house of Micah and spent the night there."
,"3":"When they were near the house, they recognized the voice of the young Levite, so they went in. They asked him, 'Who has brought you here? What are you doing in this place? Why are you here?'"
,"4":"He answered, 'Such and such a thing Micah has done for me. He has hired me to become his priest.'"
,"5":"They said to him, 'Ask God so we may know whether the journey we are making shall be successful or not.'"
,"6":"The priest answered them, 'Go in peace, the journey you make is under the eye of Yahweh.'"
,"7":"The five men left and came to Laish. They saw that the inhabitants of that place were living in security according to the customs of the Sidonians - quiet and trusting people - with no one creating trouble. They lived far from the Sidonians and had no dealings with anyone else."
,"8":"Upon their return to their brothers in Zorah and Eshtaol,"
,"9":"they were asked, 'What news do you bring?' They answered, 'Come on, let us go and attack them for the country we have seen is an excellent place. But why are you silent? Do not delay in setting out to conquer the land."
,"l0":"When you go, you shall meet a quiet people; the land is vast and God has given it into our hands, a place which does not lack anything.'"
,"11":"So six hundred armed men of the tribe of Dan set out from Zorah and Eshtaol;"
,"12":"they went up and encamped at Kiriath-jearim in Judah."
,"13":"From there they passed through the mountains of Ephraim and came to the house of Micah."
,"14":"Then the five men who had gone to explore the land addressed their brothers and said, 'Do you not know that in one of these houses, there is an ephod used to consult Yahweh, some small idols and a statue cast in metal? Now decide what you have to do.'"
,"15":"The troops made a detour and entered the house of the young Levite, the house of Micah. They greeted him"
,"16":"while the six hundred armed Danites stood at the threshold of the gate."
,"17":"Then the five men who had earlier gone up to explore the land went up again, entered Micah's house"
,"18":"and took the statue, the ephod that is used to consult Yahweh and the small idols, while the priest stood at the gate with the six hundred armed men. The priest said to them, 'What are you doing?'"
,"19":"They said to him, 'Be quiet!' Put your hand on your mouth and come with us. You shall be a father and priest to us. Do you prefer to be a priest in the house of one individual or to be a priest for a tribe of Israel?'"
,"20":"This made the priest happy, so he took the ephod, the small idols and the statue, and went with the troops."
,"21":"The Danites went on their way, putting the women, children, livestock and precious objects in front of them."
,"22":"They were already far from the house of Micah when the people of the neighboring houses started shouting and set out to pursue them."
,"23":"But the Danites turned around and said to Micah, 'Why are you shouting?'"
,"24":"He answered, 'You have taken the gods which I made, and my priest is going away with you. What else is left to me? And yet you still ask me: 'What is the matter with you?''"
,"25":"The Danites answered him, 'Be quiet now lest some ill-tempered men fall upon you, and kill you and your household.'"
,"26":"So the Danites went their way, and Micah, seeing that they were stronger, returned home."
,"27":"As for them, they now had the gods which Micah had fashioned and the priest he had in his service, and they marched on against Laish, a quiet and trusting people. They put the inhabitants to the sword and burned the city."
,"28":"No one came to help them for they lived far from Sidon, and had no relationship with anyone else. This city was in the valley which extended to Beth-rehob."
,"29":"The Danites rebuilt the city and lived there, and they gave it the name Dan in memory of their ancestor Dan, son of Israel, though the city was formerly called Laish."
,"30":"They set aside a place for the statue, and Jonathan - a descendant of Gershom, son of Moses - and his sons after him, became priests of the tribe of Dan until the people were driven out of the land."
,"31":"They set up the image Micah had made, and there it remained all the time the house of God was in Shiloh."
}`)
	CurrentBook.AddChapter(19, `{
"1":"At that time there was still no king in Israel. A Levite who lived deep in the mountains of Ephraim took a woman from Bethlehem in Judah as concubine."
,"2":"This woman left him and returned to her father's house in Bethlehem of Judah. She remained there for about four months."
,"3":"Her husband set out to visit her and speak to her heart to make her return to his home. He brought with him a servant and two asses. She welcomed him in the house of her father who was glad to see him. "
,"4":"His father-in-law, the father of the girl, made him stay so he remained with him for three days. They ate, drank and spent the night there."
,"5":"On the fourth day, they rose early in the morning and the Levite prepared to leave. But the father of the young maiden said to his son-in-law, 'Eat some bread first so you can regain your strength, then you can go.'"
,"6":"The two sat and began to eat and drink together. Then the father-in-law said, 'Please spend the night here and have a good time.'"
,"7":"When the Levite got up to leave, his father-in-law insisted, so he stayed that night."
,"8":"On the fifth day, he again rose early in the morning to go, but the father of the young maiden said to him, 'Have more patience and stay until evening.' So they ate together."
,"9":"But when the husband, his concubine and his servant stood up to leave, the father-in-law said to his son-in-law, 'Look, it's already getting dark. Spend the night here and enjoy yourself. You can leave early tomorrow morning and be on your way home.'"
,"10":"But the Levite refused to spend the night there, so he got up, left and arrived opposite Jebush, or Jerusalem. He brought with him the two saddled asses, his concubine and his servant."
,"11":"It was very late when they came near Jebush. So the servant said to his master, 'Let us not go any farther but go into the city of the Jebusites and spend the night there.'"
,"12":"His master answered him, 'Let us not go to a foreign city where there are no Israelites; we will go to Gibeah.' And he added to his servant,"
,"13":"'Come and let us go near one of those towns. We will spend the night in Gibeah or in Ramah.'"
,"14":"So they went their way, and at sunset they arrived opposite Gibeah of Benjamin."
,"15":"They turned aside and went there to spend the night."
,"16":"Then, an old man came in from his work in the fields. He was a man from the mountains of Ephraim and lived as a visitor in Gibeah, for the people of that place were of the tribe of Benjamin."
,"17":"Looking to one side, the old man noticed the visitor in the city square and said to him, 'Where do you come from and where are you going?'"
,"18":"And he answered, 'We are passing through, for we come from Bethlehem of Judah, and we are going up to the borders of the mountains of Ephraim where I come from. I went to Bethlehem of Judah and now I am returning home. But here no one has offered me his house."
,"19":"We have, however, straw and green fodder for our asses, and bread and wine for me, my wife and the young man who accompanies us. We don't lack anything.'"
,"20":"The old man said to him, 'Peace be with you. I shall provide you with all that you need. Just don't spend the night in the square.'"
,"21":"He brought them to his house and gave fodder to the asses. The travelers washed their feet, then ate and drank."
,"22":"As they were relaxing, the wicked men of the city went round the house, pounded on the door and said to the old man who owned the house, 'Bring out the man you have welcomed into your house so we may amuse ourselves with him.'"
,"23":"The owner of the house went out to them and said, 'No, my brothers, do not treat him badly. This man has come into my house, so do not do him evil."
,"24":"Here is my daughter, a virgin, and my companion's concubine. I can give her to you if you want. Ravish her and do with her what seems good to you, but not with this man.'"
,"25":"But those men would not listen to him. So the man took his concubine and brought her outside. They violated and maltreated her the whole night until morning. At dawn, they left her."
,"26":"At early morning, the woman came and fell at the entrance of the man's house where her husband was. She lay there until it was day."
,"27":"When her husband rose up in the morning, opened the door of the house and went out to go on his way, he saw the woman, his concubine, lying at the entrance of the house, her hands on the threshold."
,"28":"He said to her, 'Get up, and let us go.' But there was no response. So the man put her on his ass and went home."
,"29":"When he arrived home, he took a knife and taking hold of his concubine, he divided her, limb by limb, into twelve pieces and sent them throughout the territory of Israel."
,"30":"He gave his messengers, this order: 'Say this to the Israelites: Until today, have you seen anything like this since the Israelites came up from the land of Egypt? Think about it. Seek counsel and decide.' Everyone who saw it said: 'Until today, never has this happened nor has a thing like this been seen since the Israelites came up from the land of Egypt.'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"So all the children of Israel, the whole community from Dan to Beer-sheba, gathered as one man, including the land of Gilead, before Yahweh at Mizpah."
,"2":"The heads of all the people and of all the tribes of Israel came to the assembly of the people of God: four hundred thousand men on foot, all armed with swords."
,"3":"The men of the tribe of Benjamin also knew that the Israelites had gone up to Mizpah. The sons of Israel said, 'Tell us how this crime happened.' "
,"4":"The Levite, the husband of the murdered woman, addressed them and said, 'I arrived at Gibeah in Benjamin with my concubine to spend the night there."
,"5":"By night, the residents of Gibeah showed up and surrounded the house, intending to harm us. They were determined to kill me, and they abused my concubine in such a way that she died."
,"6":"I then took her, cut her into pieces, one piece to each territory of Israel, because what they have done is a shame for Israel."
,"7":"Now that you are here, all sons of Israel, discuss among yourselves and make a decision now.'"
,"8":"All the people rose as one man and said, 'None of us shall return to his tent nor go to his house."
,"9":"This is what we will do with the people of Gibeah: we will draw lots"
,"10":"and will take from the tribes of Israel ten men for every hundred, a hundred for every thousand, and a thousand for every ten thousand. They shall gather provisions for the troops who will go to punish Gibeah in Benjamin for the crime its inhabitants have committed in Israel.'"
,"11":"So all the men of Israel united as one man against the city."
,"12":"The tribes of Israel sent messengers throughout the whole tribe of Benjamin and said to them: 'What is this crime that has been committed among you?"
,"13":"Hand over those wicked men of Gibeah to us, that we may kill them and banish the evil from Israel.' But the Benjaminites did not mind their Israelite brothers."
,"14":"Meanwhile, the Benjaminites also left their cities and gathered at Gibeah to face the Israelites."
,"15":"That day the Benjaminites who came from different cities totaled twenty-six thousand men, armed with swords, without counting the inhabitants of Gibeah."
,"16":"Among them were seven hundred valiant men, all left-handed and able to sling a stone at a hair's breadth without missing."
,"17":"The people of Israel also counted their men. Without counting Benjamin, there were four hundred thousand men, able to draw sword, all men of war."
,"18":"So they set out and went up to Bethel where they asked God: 'Who among us shall go up first to fight the sons of Benjamin?' And Yahweh answered, 'Judah shall go up first.'"
,"19":"The Israelites rose early and encamped opposite Gibeah."
,"20":"They went out to fight against Benjamin and drew up the battle line against Gibeah."
,"21":"But the Benjaminites came out of Gibeah and killed twenty-two thousand Israelites."
,"22":"On the second day, the sons of Israel attacked the Benjaminites."
,"23":"The sons of Israel then went up to weep before Yahweh until evening, and asked Yahweh, saying, 'Shall we fight again with the sons of our brother Benjamin?' Yahweh answered, 'Go up against them.'"
,"24":"So the people, the troops of Israel, regained their courage and returned to their former battle line."
,"25":"On that day, too, the Benjaminites went out against them and killed eighteen thousand sword-wielding Israelites."
,"26":"Then all the Israelites, all the people, went up to Bethel. There they sat weeping before Yahweh. They fasted the whole day until evening and presented burnt and peace offerings before Yahweh,"
,"27":"for the Ark of the Covenant was there,"
,"28":"with Phinehas, son of Eleazar, son of Aaron, as its minister. They asked: 'Shall we come out again and fight the sons of our brother Benjamin, or not?' Yahweh replied, 'Go up tomorrow, and I will give them into your hands.'"
,"29":"Israel set men in ambush around Gibeah."
,"30":"On the third day, the sons of Israel marched against Gibeah and positioned themselves in the battle line as on previous times."
,"31":"The sons of Benjamin went out against them, but the Israelites cut off the way that led back to the city. The Benjaminites began as before to attack the men of Israel, killing about thirty men on the roads going up to Bethel and to Gibeah."
,"32":"So the Benjaminites thought: 'We have defeated them again as before.',But the Israelites said to themselves: 'Let us flee to draw them away from the city and cut off the roads.' "
,"33":"All the men of Israel moved from their camp and took up position at Baal-Tamar, while those who were in ambush rushed out of their place to the west of Gibeah."
,"34":"So ten thousand chosen men from all Israel came against Gibeah. The battle was fought hard, and the Benjaminites did not notice the calamity which was to come upon them."
,"35":"Yahweh defeated Benjamin before Israel, and on that day the Israelites killed twenty-five thousand Benjaminites, all sword-wielding men."
,"36":"The Benjaminites thought they were victorious, but the men of Israel gave them ground, because they relied on the ambush they had set against Gibeah."
,"37":"The men in ambush rushed out and quickly deployed themselves. They attacked Gibeah and put the whole city to the sword."
,"38":"The men of Israel had planned with those in ambush that smoke would rise from the city as a signal. At this, the Israelites would then return and fight."
,"39":"So the Israelites who pretended to escape returned when the Benjaminites had killed about thirty men and had thought: 'Now they are defeated as in the first battle.'"
,"40":"The smoke signal was already rising from the city. When the Benjaminites looked behind, they saw that the whole city was on fire, with flames rising up to heaven."
,"41":"When the Israelites faced them, the Benjaminites trembled before the calamity which had come upon them."
,"42":"They retreated before the men of Israel and fled in the direction leading to the desert. But the Israelites who came out of the city overtook them and destroyed them."
,"43":"They surrounded the men of Benjamin, pursued them without rest and crushed them opposite Gibeah by the east."
,"44":"Eighteen thousand Benjaminites fell, all valiant men."
,"45":"The survivors retreated and fled towards the desert to the rock of Rimmon. About five thousand men, however, were killed on the way. They also pursued Benjamin as far as Gideon, killing two thousand men."
,"46":"On that day, twenty-five thousand sword-wielding Benjaminites died, all valiant men. Of those who fled to the desert to the rock of Rimmon,"
,"47":"six hundred were able to escape. They remained there for four months."
,"48":"The troops of Israel turned against the towns of Benjamin and put them to the sword, the people as well as the livestock and everything in them. They also burned all the cities they found."
}`)
	CurrentBook.AddChapter(21, `{
"1":"The men of Israel swore at Mizpah: 'None of us shall give his daughter in marriage to any Benjaminite.'"
,"2":"The people went to Bethel. There they sat before Yahweh until evening, called on him and wept with great lamentation."
,"3":"They said, 'Yahweh, God of Israel, why has this misfortune happened to Israel, that one of its tribes has perished today?'"
,"4":"On the next day, the people rose early, built an altar there and offered holocausts and peace offerings."
,"5":"The Israelites then asked, 'Who among all the tribes of Israel did not come to the assembly of Yahweh?' For they had sol-emnly sworn that whoever would not come up to Mizpah before Yahweh should die."
,"6":"The sons of Israel had compassion on their brother Benjamin and they said, 'Today a tribe of Israel has been cut off,"
,"7":"what shall we do to provide wives for those that remain, for we have sworn to Yahweh not to give them our daughters in marriage?'"
,"8":"Because of this they asked, 'Did any tribe of Israel not come up to Mizpah before Yahweh?' And they found out that none from Yabesh of Gilead had come to the camp for the assembly."
,"9":"They made the census and saw that there was no one from Yabesh of Gilead."
,"10":"Then the community sent there twelve thousand of their valiant men with this order: 'Go and put to the sword the inhabitants of Yabesh of Gilead, including women and children."
,"11":"This is what you shall do: kill every man and every woman who has had a relation with a man, but let the maidens live.'"
,"12":"So they did. They found four hundred young virgins among the inhabitants of Yabesh in Gilead (who had not had any relations with man), and they brought them to the camp at Shiloh in the land of Canaan."
,"13":"Then the community sent messengers to the Benjaminites who were at the rock of Rimmon to make peace with them,"
,"14":"and the Benjaminites returned. The Israelites gave them the women of Yabesh of Gilead they had spared, but there were not enough for all."
,"15":"The people had compassion again on Benjamin for Yahweh had let one of the tribes of Israel perish."
,"16":"So the community elders said, 'What can we do to provide wives for those that are left, for the women of Benjamin were killed?'"
,"17":"and they added, 'How can the survival of Benjamin be assured that a tribe of Israel may not perish?"
,"18":"We cannot give them our daughters since we have made this oath: Cursed be he who gives a wife to Benjamin?'"
,"19":"But they said, 'It is now the feast of Yahweh which is celebrated annually at Shiloh, north of Bethel, east of the road that goes up from Bethel to Shechem, and south of Lebonah.'"
,"20":"So they advised the Benjaminites: 'Go and wait in ambush in the vineyards."
,"21":"Be ready and when the maidens of Shiloh come dancing in groups, come out of the vineyards and each man seize a wife and go to the land of Benjamin."
,"22":"If their fathers or brothers come to complain against you, we shall tell them: 'Try to understand them; see, the war left us with no means of giving a wife to each one of them. You are not the ones who gave them your maidens, otherwise you would have broken your vow.'"
,"23":"So the Benjaminites did and seized the women they needed. Then they went and returned to their inheritance, rebuilt their cities and dwelt in them."
,"24":"The Israelites then marched from there to their homes, every man to his tribe and family."
,"25":"At that time, there was no king in Israel and everyone did what seemed good to him."
}`)

}
func EN_CCB_LoadVHIEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"After the death of Moses, Yahweh spoke to Joshua, the son of Nun and the minister of Moses, and said to him:"
,"2":"'My servant Moses is dead; therefore, the hour has come for you to cross the Jordan River, and all the people shall go with you to the land which I give to the sons of Israel."
,"3":"I give you all the places where you set your feet, as I promised Moses."
,"4":"Your frontiers will extend from the mountain of Lebanon in the north, to the desert in the south, as far as the great Euphrates in the east and the Great Sea in the west."
,"5":"As long as you live, no one will be able to stand against you. I will be with you as I was with Moses. I will not leave you or abandon you."
,"6":"Be valiant and have courage for I will give this people the land I swore to their fathers I would give them."
,"7":"Therefore, be brave and faithfully fulfill the whole Law which Moses, my servant, gave you. Do not turn aside from it either to the right or to the left, and you shall succeed wherever you go."
,"8":"Constantly read the book of this Law and meditate on it day and night that you may truly do what it says. So shall your plans be fulfilled and you shall succeed in everything."
,"9":"It is I who command you; be strong, then, and be valiant. Do not tremble or be afraid, because Yahweh, your God, is with you wherever you go.'"
,"10":"Joshua ordered the secretaries of the people:"
,"11":"'Pass through the camp and give this command: 'Store up enough food for, in three days' time, you shall cross the Jordan and enter the land which Yahweh, your God, will give you'.'"
,"12":"To the people of the tribes of Reuben and Gad and to half of the tribe of Manasseh, Joshua said,"
,"13":"'Remember the command of Moses, the servant of Yahweh; Yahweh has provided you with a place of rest and has given you all this region."
,"14":"The women and children, as well as the livestock, shall remain on this side of the Jordan, in the region which Moses gave you; but you who are valiant shall cross over, armed, ahead of your brothers and shall help them"
,"15":"until Yahweh gives them rest, as he has given you, that they may also conquer the land which Yahweh, our God, gives them. So you shall return to the region which Moses gave us and take possession of that land at the east of the Jordan.'"
,"16":"They answered Joshua: 'We will do all you have commanded us and go wherever you send us. Just as we have obeyed Moses, so shall we obey you in the same way."
,"17":"May Yahweh, your God, be with you as he was with Moses."
,"18":"He who contradicts your words and disobeys your orders shall die. But be valiant and courageous.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Joshua sent two spies secretly from Shittim with the following order 'Go and look over the land well, especially the city of Jericho.',The spies went and as soon as they came to Jericho, they went to the house of the prostitute named Rahab. "
,"2":"But someone told the king of Jericho: 'Some Israelites have entered here tonight to spy on us.'"
,"3":"So the king of Jericho sent word to Rahab: 'Send those men out of your house because they came to spy on the land.'"
,"4":"But the woman had hidden them, so she said: 'It is true; they came to my house but I did not know where they came from."
,"5":"And at nightfall, shortly before the city gates were to be closed, they went out. I do not know where they went, but hurry and you will surely overtake them.'"
,"6":"The woman had hidden them on the roof of the house, under the stalks of flax which she kept there."
,"7":"The pursuers went to search for them by the road leading to the valley of the Jordan, and as they went out, the city gates were closed."
,"8":"Then the woman went up to where she had hidden the spies of Joshua,"
,"9":"and she said to them: 'I know that Yahweh, your God, has given this land to you; we are frightened and the inhabitants of the land tremble before you."
,"10":"We know how Yahweh dried up the waters of the Red Sea to let you cross when you came out of Egypt. We know what you did to the two kings of the Amorites who lived at the other side of the Jordan, to Sihon and Og, whom you destroyed by anathema."
,"11":"The news has frightened us, and everyone has lost courage because of you, for Yahweh, your God, is God in heaven above as he is on earth below."
,"12":"Now then, swear to me by Yahweh that just as I have been faithful to you, so shall you be towards my family,"
,"13":"and respect the life of my father, mother, brothers and sisters, and all that belong to them.'"
,"14":"The men answered: 'Provided that you do not reveal our talk, then we will pay back life for life when Yahweh hands over to us this land, and we will deal generously and faithfully with you.'"
,"15":"Then she let them down by a rope through the window, since her house was built into the city wall."
,"16":"But she said to them: 'Go through the mountains so that you do not meet those who pursue you. Remain in hiding for three days, until they return, and then you may go your way.'"
,"17":"They answered: 'See how we shall fulfill our oath."
,"18":"When we enter this land, tie this scarlet cord as a sign on the window through which we have escaped. Bring into your house your father, mother, brothers and sisters, and all your relatives."
,"19":"If any of them leaves the house, he shall be the one responsible for his death, and the guilt will not be ours. But if anyone who is with you is killed, then may the punishment for his death come upon us."
,"20":"However, be careful not to reveal our plan. If you do, then we are freed from the oath we have sworn.'"
,"21":"Rahab said to them: 'So be it.' And after she had sent them off, she tied the scarlet cord to the window."
,"22":"The men went into the mountains and hid there for three days, until their pursuers had returned. These men had searched in vain for them everywhere."
,"23":"Then the two spies came down again from the mountains and, crossing the Jordan River, came to Joshua, son of Nun, and gave him an account of their mission and everything that had happened."
,"24":"They said to Joshua: 'Yahweh has given all this land into our hands; their inhabitants already tremble before us.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Early in the morning, Joshua rose and set out from Shittim with all the people of Israel and came to the Jordan River. There they encamped while waiting to cross the river."
,"2":"After three days, the officers went around the camp"
,"3":"and ordered the Israelites: 'When you see the Ark of the Covenant of Yahweh go by, carried by the priests from the tribe of Levi, then you shall set out from your camp and follow it,"
,"4":"that you may know the way you shall go. Because you have never been that way before. But you shall follow it at a distance of a thousand meters. Do not go near it.'"
,"5":"Joshua said to the Israelites: 'Purify yourselves, for tomorrow Yahweh will be in your midst doing wonders.'"
,"6":"And Joshua ordered the priests: 'Take the Ark of the Covenant and cross the river at the head of the people.'"
,"7":"Then Yahweh said to Joshua: 'Today I will begin to make you great in the eyes of Israel and they shall know that I am with you as I was with Moses."
,"8":"Give this order to the priests who carry the Ark of the Covenant: As soon as you come to the banks of the Jordan, stand still in the river.'"
,"9":"And Joshua said to the Israelites: 'Come nearer and listen to the words of Yahweh, our God."
,"10":"Do you want a sign that Yahweh, the living God, is in your midst, he who drives away before you the Canaanites, Hittites, Hivites, Perizzites, as well as the Girgashites, Jebusites and Amorites?"
,"11":"See, the Ark of the Covenant of the Lord of all the earth is going to cross the Jordan before you."
,"12":"Now, choose twelve men from the twelve tribes of Israel, one from each tribe."
,"13":"When the priests who carry the Ark of the Lord of all the earth put their feet into the water of the Jordan, the water coming from upstream shall stop flowing and stand in one single mass.'"
,"14":"When the people set out from their camp to cross the Jordan, the priests who carried the Ark of the Covenant went before them."
,"15":"There was much water in the Jordan, for it was overflowing its banks at this time of the barley harvest. Nevertheless, when those who carried the Ark went down to the river and their feet touched the edge of the water, the water from upstream stopped flowing."
,"16":"The water stood still, forming something like a dam very far from that place, near Adam, the neighboring city of Zarethan. The water flowing down to the Dead Sea was completely cut off, and so the people could cross opposite Jericho."
,"17":"The priests who carried the Ark of the Covenant remained in the middle of the river which dried up, until all the Israelites had crossed the Jordan."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Once the whole nation had crossed,"
,"2":"Yahweh said to Joshua: 'Choose twelve men, one from each tribe,"
,"3":"and give them the following order: Take twelve stones from the riverbed of the Jordan, from the very place where the priests stood still. Bring them with you and put them where you will encamp tonight.'"
,"4":"Joshua then called the twelve men he had chosen from the twelve tribes of Israel"
,"5":"and ordered them: 'Walk to the Ark, up to the middle of the Jordan and take from there a stone for each tribe and carry it upon your shoulder."
,"6":"They will remain with you as a sign of what happened, so that when your children ask you in the future: What do these stones mean for you?"
,"7":"you may answer: When the Ark of Yahweh crossed the Jordan, the water parted before it. So these stones shall serve as a memorial to the Israelites forever.'"
,"8":"The Israelites carried out Joshua's order and picked up twelve stones from the riverbed of the Jordan, one for each tribe, just as Yahweh had ordered Joshua. They brought these to the place where they encamped and placed them there."
,"9":"Joshua piled up twelve stones on the riverbed of the Jordan, at the spot where the priests who carried the Ark of the Covenant stood. They are still there to this day."
,"10":"The priests who carried the Ark stood in the middle of the Jordan until Joshua finished saying everything that Yahweh had ordered him."
,"11":"Then when all the people had finished crossing the river, the Ark also crossed, and the priests walked at the head of the people again."
,"12":"The men from the tribes of Reuben, Gad and half of the tribe of Manasseh went ahead armed, as Moses had ordered them to do."
,"13":"They were about forty thousand, well-armed, and they marched before Yahweh, ready for battle, to the plains of Jericho."
,"14":"On that day, Yahweh exalted Joshua before all Israel, and henceforth they respected him all the days of his life as they had done with Moses."
,"15":"Yahweh said to Joshua:"
,"16":"'Command the priests who carry the Ark of the Divine Words to come up from the Jordan.'"
,"17":"Joshua, therefore, ordered them to come up from the river."
,"18":"And when these priests who carried the Ark of the Covenant of Yahweh came up from the middle of the Jordan, when their feet touched the banks, the waters of the Jordan returned as abundantly as on previous days and overflowed its banks."
,"19":"It was on the tenth day of the first month when the people came up out of the Jordan and encamped in Gilgal, on the eastern border of Jericho."
,"20":"There in Gilgal, Joshua set up the twelve stones taken from the riverbed of the Jordan."
,"21":"Then Joshua said to the Israelites: 'When your children ask you in the future what these stones mean,"
,"22":"then you shall tell them that the people of Israel crossed the Jordan without getting their feet wet,"
,"23":"for Yahweh, our God, dried up the waters of the Jordan before us just as he did to the Red Sea which he also dried up before us to let us cross."
,"24":"He did this so that the people of this land may know the power of Yahweh, our God, and that you yourselves may fear him forever.'"
}`)
	CurrentBook.AddChapter(5, `{
"1":"The kings of the Amorites on the west of the Jordan and all the kings of the Canaanites who lived in the neighboring lands of the Mediterranean Sea came to know how Yahweh dried up the bed of the Jordan for the Israelites to cross. So they lost their courage and spirit to face the Israelites."
,"2":"At that time, Yahweh said to Joshua: 'Make flint knives and celebrate a new circumcision for the sons of Israel.'"
,"3":"Joshua obeyed the order of Yahweh and circumcised the Israelites at a place called the Hill of the Foreskins."
,"4":"This is the reason why Joshua did this second circumcision: all the men of Israel who left Egypt were circumcised, but they died during their journey in the desert."
,"5":"But all those born in the desert were not circumcised."
,"6":"For the Israelites walked in the desert for forty years until the whole nation died - the whole generation who did not obey Yahweh. For Yahweh had sworn that they would not enter the land flowing with milk and honey which he promised to their fathers."
,"7":"But it was their children, whom Joshua circumcised."
,"8":"After circumcising all, they rested in the camp until they were healed."
,"9":"Then Yahweh said to Joshua: 'Today I have removed from you the shame of Egypt.' So the place is called Gilgal up to this day."
,"10":"The Israelites encamped in Gilgal where they celebrated the Passover on the evening of the fourteenth day of the month in the plains of Jericho."
,"11":"On the following day, they ate of the produce of the land: unleavened bread and roasted grain on that very day."
,"12":"And from that day on when they ate of the produce of the land, the manna ceased. There was no more manna for the Israelites, and that year they ate of the fruit of the land of Canaan."
,"13":"When Joshua was near Jericho, he lifted up his eyes and saw before him a man with a drawn sword in his hand. Joshua approached him and said: 'Are you for us or for our enemies?'"
,"14":"And he answered: 'No, I have come as the commander of the army of Yahweh.' Joshua lay prostrate on the ground, worshiped him and said: 'What does my Lord ask of his servant?'"
,"15":"The commander of the army of Yahweh said to him: 'Take off your sandals from your feet; the place where you stand is holy.' And Joshua did so."
}`)
	CurrentBook.AddChapter(6, `{
"1":"The inhabitants of Jericho had closed the city and had fastened their bolts so that the Israelites could not enter. No one came in and no one went out."
,"2":"But Yahweh said to Joshua: 'I will give you the city, its king and all its men of war."
,"3":"For this, you shall have to go around the city once every day for six days."
,"4":"Seven priests shall go before the Ark bearing the seven trumpets used in the time of the Jubilee. On the seventh day, they shall march around the city seven times,"
,"5":"and when they blow the horn, all the people shall come up to attack, shouting their battle cry. At that moment, the walls of the city will fall and everyone shall enter straight ahead of him.'"
,"6":"Joshua, son of Nun, called the priests and said to them: 'You shall carry the Ark of the Covenant; seven priests shall go ahead with the trumpets they use for the Jubilee.'"
,"7":"Then Joshua said to the people: 'You shall march around the city and the vanguard of the army shall go before the Ark of Yahweh.'"
,"8":"When Joshua finished speaking, the priests began to blow the seven trumpets they used to blow on the Feast of the Jubilee, and they went before the Ark of Yahweh."
,"9":"The vanguard of the people went before the priests, and the rest of the people came after the Ark."
,"10":"The trumpets blew continually. Joshua had given this order: 'Do not shout or utter anything, nor let even a single word be heard, until the day comes when I say: Shout and cry out!'"
,"11":"That day he had the Ark of Yahweh carried around the city once, then all returned to the camp where they spent the night."
,"12":"On the following day, Joshua rose early in the morning"
,"13":"and the priests took the Ark and those who blew the seven trumpets again went before the Ark. The vanguard went before them and the rest followed the Ark while the trumpets blew."
,"14":"So they did the next day, and for six days they marched once a day around the city and then returned to the camp."
,"15":"On the seventh day, the Israelites rose early at dawn and marched around Jericho in the same way as on the previous days. But on that day, they did it seven times."
,"16":"At the seventh time, as the priests blew the trumpets, Joshua ordered the people: 'Shout your battle cry for Yahweh has given you the city!"
,"17":"The city and all that is in it shall be given in anathema to Yahweh. Only Rahab the prostitute with all who may be with her in her house shall live, since she hid the spies we sent."
,"18":"But for your part, be careful not to touch anything, big or small since everything shall be consecrated in anathema; do not take anything for yourself lest the curse be upon the camp of Israel and bring trouble upon it."
,"19":"All the gold, silver, copper and iron are to be consecrated to Yahweh and shall go into the treasury of Yahweh.'"
,"20":"The people shouted and the trumpets blew. At this precise moment, the walls of the city fell. Then everyone went straight into the city to the place before him."
,"21":"They seized Jericho. And with sword in hand, they killed all the men and women, both young and old, as well as the oxen, sheep and asses, and they gave these as anathema or, rather, sacrificed them to God."
,"22":"Two men had been sent to explore Jericho, (and upon entering the city, were hidden by a prostitute). Then Joshua said to them: 'Go into the house of the prostitute and bring her out with all her family as you had sworn to her.'"
,"23":"These young men then brought out the woman named Rahab, her father, her mother, her brothers and sisters with all her relatives to safety outside the camp of Israel."
,"24":"Afterwards, they burned the city and all that was in it. They saved only the silver, gold and the vessels of bronze and iron which they put with the precious things in the Sanctuary of Yahweh."
,"25":"Joshua saved the prostitute and all her family, and she lived in Israel, because she had kept the spies sent by Joshua."
,"26":"Joshua asked the people to pronounce this curse: 'May Yahweh curse the man who rebuilds Jericho. May its foundation rise on the body of his eldest son, and the gates on that of his youngest son.'"
,"27":"So Yahweh was with Joshua and made him famous in all the land."
}`)
	CurrentBook.AddChapter(7, `{
"1":"The Israelites did not keep the anathema. It happened that Achan, son of Carmi, son of Zabdi, son of Zerah, of the tribe of Judah, appropriated for himself some of the things consecrated by anathema, and because of this, the anger of Yahweh burned against Israel."
,"2":"Joshua sent men from Jericho to Ai, which was near Bethaven, east of the city of Bethel. And he said to them: 'Go up and explore the land.'"
,"3":"The spies said to Joshua on their return: 'It would not be necessary to mobilize the whole army: some two or three thousand men will be enough to conquer the land. It would be useless to tire the people for that nation is but few in number.'"
,"4":"So about three thousand men attacked Ai but were repulsed by the city's defenders."
,"5":"The people of Ai killed thirty-six men and pursued them outside the gate as far as Shebarim, defeating them on the slopes. Upon seeing this, all the people were disheartened."
,"6":"Then Joshua and all the leaders of Israel rent their garments, put ashes on their heads and remained prostrate before the Ark of Yahweh until evening. Joshua lamented:"
,"7":"'Alas, Yahweh, why have you made this people cross the river Jordan just to give us into the hands of the Amorites who will destroy us?,It would have been better for us to remain on the other side of the Jordan. "
,"8":"Yahweh, my God, what can I say when I see Israel fleeing from their enemies?"
,"9":"The Canaanites and all the inhabitants of this land will know of this. They will unite to surround us and drive us out. And you, what are you going to do for the honor of your Name?'"
,"10":"Yahweh answered: 'Stand up! Why are you prostrate on the ground?"
,"11":"Israel sinned and has violated my covenant; Israelites have taken from what was set apart by anathema and have hidden stolen objects with their belongings."
,"12":"So Israel cannot face its enemies, but shall flee from them, since it has come to be an anathema. I will not be with you anymore unless you remove the curse from your midst."
,"13":"Go then, and sanctify the people. Say to them: 'Cleanse yourselves for tomorrow. Yahweh, the God of Israel, says to you: Oh, Israel, the anathema is in your midst and you shall not face your enemies until you have removed the anathema from you."
,"14":"Therefore in the morning you shall come near, grouped according to tribes. The tribe that Yahweh designates by lot shall present itself by families. And the family that Yahweh designates shall present itself by households, and the household by individuals."
,"15":"He who turns out to be responsible for this offense shall be burned, together with all his household goods, for having violated the covenant of Yahweh and having done a detestable crime in Israel.'"
,"16":"Joshua rose early in the morning and ordered the tribes of Israel to present themselves."
,"17":"The lot fell on the tribe of Judah. Lots were drawn among the families, and the family of Zerah was left. Lots were drawn among the households of this family and the household of Zabdi was left."
,"18":"And then lots were drawn among the members of this household which revealed that the guilty one was Achan, son of Carmi, son of Zabdi, son of Zoreh, of the tribe of Judah."
,"19":"Joshua then said to him: 'My son, confess the truth before Yahweh, the God of Israel, and render him praise. Tell me what you have done without hiding anything.'"
,"20":"Achan answered: 'It is true that I have sinned against Yahweh. This is what I have done:"
,"21":"I saw among the plunder a beautiful mantle from Shinar, two hundred shekels of silver and a bar of gold weighing fifty shekels. I was tempted so I took them. Then I hid them in the ground inside my tent with the silver underneath.'"
,"22":"Joshua then sent some messengers who ran to the tent of Achan and found the booty inside the tent with the silver underneath."
,"23":"They took all these and presented them to Joshua and to the people; everything was put before Yahweh."
,"24":"Then Joshua took Achan together with the silver, the mantle and the gold, his sons as well as his daughters, his oxen, asses and sheep, his tent and all that he had. All Israel accompanied him and they brought them to the Valley of Achor."
,"25":"There Joshua said to him: 'Since you brought us misfortune, may Yahweh bring this misfortune upon you today.' Then all the people stoned him."
,"26":"And of those that were his, some were crushed and others were burned. They piled on him a great heap of stones that remains to this day. Then the Lord turned from his anger. Henceforth the place was called the Valley of Achor."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Then Yahweh said to Joshua: 'Do not fear or be discouraged. March with all your warriors against the city of Ai. I will give into your hands its king and its people, the city and its territory."
,"2":"You shall deal with Ai as you have dealt with Jericho and its king. But you may take possession of the plunder and all the animals. So now, prepare an ambush behind the city.'"
,"3":"So Joshua left with all his warriors and went up to Ai. Then he chose thirty thousand valiant warriors, and sent them out by night."
,"4":"And he commanded them: 'Lie in ambush behind the city. Do not go very far and be ready."
,"5":"I and all the people who are with me shall close in on the city. But when they come out against us, as they did before, we shall flee from them."
,"6":"Then they shall pursue us and go out far from the city, thinking that we are fleeing from them as before."
,"7":"But then you shall rise from where you are hiding and occupy the city. Yahweh, our God, will give it to us."
,"8":"After taking the city, you shall burn it according to what Yahweh has commanded. These are my orders.'"
,"9":"So Joshua sent them out and they went to the place of ambush, between Bethel and Ai, to the west of the city, while Joshua slept that night in the midst of his people."
,"10":"Very early in the morning, Joshua rose and mustered his army, and then marched at the head of the people, accompanied by the leaders."
,"11":"All the warriors who were with him went up and marched until they reached the front of the city. Then they encamped opposite the northern side of the city. The valley separated them from the city."
,"12":"(Then he took five thousand men whom he set in ambush between Bethel and Ai, to the west of the city.)"
,"13":"The people then set up their camp to the north of the city and their rearguard to the west. That night Joshua was in the valley."
,"14":"When the king of Ai saw the situation, he made haste with all his people to attack Israel on the slope opposite the valley of Jordan, without knowing that the Israelites had prepared an ambush behind the city."
,"15":"Joshua and the Israelites pretended that they were being defeated, and so fled to the road leading to the wilderness."
,"16":"Then all the people of the city began to shout and left to pursue them."
,"17":"No one remained to defend the city, and they left the city open."
,"18":"Then Yahweh said to Joshua: 'Stretch out toward Ai the javelin you have in your hand because I have given you this city.'"
,"19":"So Joshua did this, and at this sign the warriors rose out of their places in the ambush and ran to the city. They entered and seized the city, and set it on fire."
,"20":"The men of Ai looked back and saw the smoke of the city rising up to heaven, and at the same time, the Israelites who were fleeing turned back upon them."
,"21":"They lost their courage as they were trapped by the Israelites:"
,"22":"for on one side were Joshua and all the people of Israel, and on the other, those who had just set the city on fire. The Israelites killed them until none were left to survive or to escape. "
,"23":"Only the king of Ai was taken alive and they brought him to Joshua."
,"24":"The Israelites killed the inhabitants of Ai who went into the fields or who fled to the wilderness; they killed them all. Then they returned to the city and killed all by the sword."
,"25":"The total of those who fell that day was twelve thousand."
,"26":"Joshua did not give the order to stop the war until all the inhabitants of Ai had been killed in accordance with anathema."
,"27":"But the Israelites took for themselves the livestock and plunder as Yahweh had commanded."
,"28":"Joshua burned the city and left it in ruins. That place has remained as it was to this day."
,"29":"As for the king of Ai, Joshua had him hanged on a tree until the sun set. Then he had his body taken down; they cast it at the entrance of the city and raised over it a great heap of stones which can be seen to this day."
,"30":"Joshua then built an altar to Yahweh, the God of Israel, on Mount Ebal."
,"31":"He fulfilled what Moses had commanded the children of Israel. And according to what is written in the book of the Law of Moses, the altar was made of uncut stones and was built without the use of an iron tool. On this altar, he offered burnt offerings and peace offerings to Yahweh."
,"32":"There in the presence of the Israelites he wrote upon the stones a copy of the Law which Moses had written."
,"33":"All the people stood on both sides of the Ark, with their leaders, secretaries and judges. Opposite it were the priests and the Levites who carried the Ark of Yahweh. Israelites by birth and aliens were together. Half the people were in front of Mount Gerizim and the other half were near Mount Ebal according to Moses' commandment for the blessing of Israel."
,"34":"Joshua proceeded to read the words of blessing and curse, and all that is written in the book of the Law."
,"35":"He did not omit any word from all that was written by Moses. He read it with a loud voice before the assembly of all Israel, including women, children and foreigners who lived among them."
}`)
	CurrentBook.AddChapter(9, `{
"1":"The kings who lived west of the Jordan, on the mountain, on the plain and on the seacoast heard of these events. The Hittites, Amorites, Canaanites, Perizzites, Hivites and Jebusites"
,"2":"made a pact and came to an agreement to fight as one against Joshua and Israel."
,"3":"The inhabitants of Gibeon came to know what Joshua had done to Jericho and Ai,"
,"4":"and decided to deceive the Israelites. They prepared provisions for themselves, loaded some worn-out, torn and mended sacks and wineskins on their asses,"
,"5":"put on worn-out and patched sandals and clothes. For their journey, they brought some dry bread, broken into pieces."
,"6":"Then they went to Joshua, to the camp at Gilgal, and said to him: 'We come from a far land to make a pact with you.'"
,"7":"The Israelites answered: 'Do you live near us? If so, then we cannot make a pact with you.'"
,"8":"They answered Joshua: 'We are your servants.' And Joshua asked them: 'Who are you? Where do you come from?'"
,"9":"They answered: 'Your servants come from a very far country and through the greatness of Yahweh, your God, we came to know of his power and all that he did in Egypt"
,"10":"and with the two kings of the Amorites who reigned in the eastern part of the Jordan - Sihon, the king of Heshbon, and Og, the king of Bashan, who lived in Ashtaroth."
,"11":"The leaders and the rest of the inhabitants of our country told us: 'Take provisions for a long journey, go out to meet them and say to them: We are your servants; may you make a covenant with us.'"
,"12":"Look at our bread which was warm when we took it from our houses to come and meet you, but see how dry it has become and how it has broken into pieces."
,"13":"These wineskins that we filled up with wine were new, now they are ripped and worn-out. The clothes and sandals that we use have worn out because of the very long journey.'"
,"14":"The Israelites shared their food with them without having asked Yahweh what must be done."
,"15":"Joshua made a covenant with them without waiting for any answer from Yahweh. So he as well as the leaders of the community promised to let them live."
,"16":"Three days later, the Israelites learned that these people lived near their own territory."
,"17":"On hearing this, the Israelites set out and entered their cities: Gibeon, Chephirah, Beeroth and Kiriath-jearim."
,"18":"They spared their lives because of what the leaders of the people had sworn to them by the name of Yahweh."
,"19":"But all the people criticized their leaders. Then all the leaders said to them: 'We have sworn by the name of Yahweh, therefore, we cannot kill them."
,"20":"But this we can do: we shall let them live so that the anger of Yahweh may not be upon us,"
,"21":"but they shall serve by cutting firewood and fetching water for the community of Israel.'"
,"22":"Then Joshua summoned the Gibeonites and told them about the decision of the leaders: 'Why did you deceive us and say to us that you come from very far when in fact, you live right in our midst?"
,"23":"Henceforth, you are cursed and shall always cut wood and fetch water for the House of my God.'"
,"24":"The Gibeonites answered: 'We came to know that Yahweh had commanded Moses to destroy all the inhabitants of the land he gave you. We were afraid so we opted for this measure."
,"25":"And now, we are in your hands: do with us whatever seems good and just to you.'"
,"26":"Joshua fulfilled his promise and did not let the Israelites kill them."
,"27":"But from that day on, they cut firewood and fetched water for the whole community and for the altar of Yahweh in the place he would choose."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Adonizedek king of Jerusalem came to know how Joshua had conquered and leveled Ai, doing to it and its king what he had done to Jericho and its king. He also knew how the Gibeonites had made peace with the Israelites and were living in their midst."
,"2":"He feared greatly, for Gibeon was a very important city, a royal city greater than Ai and its men were very brave."
,"3":"In view of this, Adonizedek sent for Hoham king of Hebron, for Aram king of Jarmuth, for Japhia king of Lachish and for Debir king of Eglon saying:"
,"4":"'Come and help me conquer Gibeon for it has made a pact with Joshua and the Israelites.'"
,"5":"So the five kings of the Amorites - the kings of Jerusalem, Hebron, Jarmuth, Lachish and Eglon - joined forces and set out, each one with troops. They encamped opposite Gibeon and surrounded it."
,"6":"The Gibeonites sent word to Joshua at the camp in Gilgal: 'Do not leave us alone, but come and help us, for all the Amorite kings who live on the mountains have united against us.'"
,"7":"So Joshua left Gilgal that day with all his valiant warriors."
,"8":"Then Yahweh said to Joshua: 'Do not be afraid because I have placed them in your hands and no one among them will be able to stand up against you.'"
,"9":"Joshua marched from Gilgal, journeying throughout the night and came upon the Amorites by surprise."
,"10":"Yahweh defeated them. The Israelites gained a great victory in Gibeon and pursued the Amorites by the slope of Beth-horon up to Azekah and Makkedah."
,"11":"As they were fleeing, Yahweh rained huge hailstones on them and pursued them up to Azekah, and they were killed. There were more who died because of the hailstones than by the sword of the Israelites."
,"12":"On that day when Yahweh gave the Amorites over to them, Joshua addressed Yahweh and said in the sight of all Israel: 'Sun, stand still at Gibeon, and you, moon, in the valley of Aijalon.'"
,"13":"And the sun stood still and the moon stopped until the people had taken revenge on their enemies: so it is written in the Book of the Just, 'The sun stood still in mid-heaven and did not hasten to set for almost a whole day."
,"14":"There has not been a day like this before or after in which Yahweh obeyed the order of a man. It was Yahweh who fought for Israel.'"
,"15":"Then Joshua and all Israel returned to the camp at Gilgal."
,"16":"But the five kings fled and hid themselves in a cave at Makkedah."
,"17":"And so it was told to Joshua: 'We have found the five kings. They are hiding in a cave at Makkedah.'"
,"18":"So Joshua ordered: 'Roll great stones against the entrance of the cave and set men to guard it."
,"19":"But do not stay there. Pursue your enemies and fall upon their rear. Do not let them return to their cities for Yahweh, our God, has placed them in our hands.'"
,"20":"Joshua and the Israelites destroyed and finished them off. Only a few survivors were left who took refuge in the fortified cities"
,"21":"while all Israel returned unscathed to the camp with Joshua. Henceforth, no one dared challenge them."
,"22":"Then Joshua ordered: 'Open the entrance of the cave, take the five kings out and bring them to me.'"
,"23":"They did this and brought the five kings before Joshua: the kings of Jerusalem, Hebron, Lachish, Jarmuth and Eglon."
,"24":"Joshua assembled all Israel and said to the captains of the troops: 'Come here and step on the necks of these kings.',So they came near and put their feet on the necks of the kings."
,"25":"Then Joshua said to them: 'Do not be afraid or lose courage, be valiant and firm, for Yahweh will do so to all your enemies against whom you will fight.'"
,"26":"Joshua immediately put them to death by hanging them on five trees until evening."
,"27":"At nightfall, they took down the bodies of the kings and threw them into the same cave where they had hidden and closed it with great stones which remain there to this day."
,"28":"On that same day Joshua seized Makkedah. He slew its king and its inhabitants. And he consecrated it and all that was in it in anathema to Yahweh, without sparing anyone. The king suffered the same fate as did the king of Jericho."
,"29":"Then Joshua and all Israel went to attack Libnah."
,"30":"Yahweh gave the city and its king to the Israelites, and they put to the sword all its inhabitants without sparing anyone. The king met the same fate as the king of Jericho."
,"31":"From Libnah Joshua went to Lachish, laid siege to it and attacked it."
,"32":"Yahweh also gave them this city and its king and inhabitants suffered the same fate as Libnah."
,"33":"Then Horam king of Gezer came to help Lachish but Joshua destroyed him together with all his people without leaving anyone alive."
,"34":"From Lachish he then went to Eglon; he besieged it and conquered it on the same day."
,"35":"The king and the inhabitants of Eglon were also put to death by the sword. They consecrated the city in anathema as they had done to Lachish."
,"36":"From Eglon they went to Hebron. Joshua conquered it together with"
,"37":"all the towns which were subject to it, put to the sword its king and all its inhabitants, without letting anyone survive. He consecrated it in anathema as he had dealt with Eglon."
,"38":"Joshua and all Israel with him turned back to Debir and attacked it. He took it as well as the towns subject to it."
,"39":"He put to the sword its king and inhabitants, consecrating them in anathema, without sparing anyone. Debir and its king received the same punishment as Hebron and Libnah."
,"40":"In this way, Joshua struck the whole region of the Mountains, the Negeb Desert, the Plains and the mountain slopes with their kings. He did not let anyone survive but consecrated all living beings in anathema according to what Yahweh had commanded. "
,"41":"Joshua destroyed them all from Kadesh-barnea to Gaza and from Goshen to Gibeon."
,"42":"Joshua defeated all these kings and seized all these lands in one single campaign because Yahweh fought for Israel."
,"43":"Then he and all Israel returned to their camp at Gilgal."
}`)
	CurrentBook.AddChapter(11, `{
"1":"When Jabin king of Hazor came to know all this, he sent ambassadors to Jobab king of Madon, to the king of Shimron, to the king of Achshaph,"
,"2":"to the kings in the northern mountains, on the steppes to the south of Chineroth in the plains, and in the heights of Dor on the west,"
,"3":"to the Canaanites in the east and the west, to the Amorites, Hittites, Perizzites and Jebusites in the mountains, and the Hivites at the foot of Mount Hermon in the region of Mizpah."
,"4":"And they set out with their troops, a multitude as numerous as the sand of the sea, accompanied by a great number of horses and chariots ready for combat."
,"5":"All these kings joined forces and encamped together at the spring of Merom to attack Israel."
,"6":"Then Yahweh said to Joshua: 'Do not be afraid, for tomorrow at this hour I will give them to you that you may sacrifice them to me. Cut the hocks of their horses and burn their chariots of war.'"
,"7":"So Joshua and all the armed men with him went to Merom and attacked them by surprise."
,"8":"Yahweh gave them into the hand of Israel; the Israelites destroyed and pursued them as far as Great Sidon and Misrephoth-maim and as far as Mizpah to the east, without leaving anyone alive."
,"9":"Joshua also carried out what Yahweh had commanded - cutting the hocks of the horses and burning the chariots."
,"10":"At once Joshua turned back and conquered Hazor, and killed its king. At that time, Hazor was the capital of all those kingdoms."
,"11":"He put to the sword all the inhabitants of that city, consecrating it in anathema. No one was left alive, and they immediately set the city on fire."
,"12":"Joshua took all the cities of these kings and all their kings, and consecrated them in anathema according to what Moses, the servant of Yahweh, had commanded."
,"13":"Israel set on fire all the cities except those lying on the slopes and on the heights; of these only Hazor was burned by Joshua."
,"14":"The Israelites divided among themselves the plunder and the livestock of these cities, but they put to the sword the whole population without sparing anyone."
,"15":"So what Yahweh had commanded Moses, and what Moses had entrusted to Joshua was completely fulfilled: Joshua did not neglect anything that Yahweh had commanded Moses."
,"16":"So Joshua conquered all this land: the mountains, the Negeb, Goshen, the plains, the steppes, and the mountains of Israel with its plains."
,"17":"From the region of the mountain range that rises up to Seir, as far as Baalgad in the valley of Lebanon, to the foot of Mount Hermon, he destroyed all their kings - vanquishing and killing them."
,"18":"The war Joshua waged against these kings lasted a long time;"
,"19":"there was no city that made peace with the Israelites except the Hivites of Gibeon; all were conquered."
,"20":"Yahweh gave all of them courage to fight against Israel, so that at the end, they could be consecrated in anathema and destroyed without pity as Yahweh had commanded Moses."
,"21":"At that time, Joshua came back and wiped out the Anakim from the mountains, from Hebron, from Debir, from Anab and from all the mountains of Judah and Israel. They and their cities were given in anathema."
,"22":"No Anakim was left in the land of Israel except in Gaza, Gath and Ashdod."
,"23":"Joshua seized the whole land as Yahweh had directed Moses and gave it as an inheritance to the Israelites to be distributed among their tribes. With this, the land rested from war."
}`)
	CurrentBook.AddChapter(12, `{
"1":"These are the kings of the country whom the Israelites defeated, taking their land beyond the Jordan eastward, from the valley of Arnon to Mount Hermon, including all the lowland."
,"2":"Sihon, king of the Amorites, who lived at Heshbon, and ruled from Aroer, which is on the edge of the Arnon (the border was at the middle of the valley), as far as the Jabbok river, that was the boundary with the Ammonites."
,"3":"To him belonged half of Gilead and the lowland from the east side of the Lake of Chinneroth to the Beth-jeshimot road, on the east side of the sea of the lowland, that is the Salt Sea, at the foot of the slopes of Pisgah."
,"4":"Og, king of Bashan, one of the survivors of the Rephaim, who lived at Ashtaroth and Edrei,"
,"5":"ruled over Mount Hermon, Salecah and all Bashan to the boundary of the Geshurites and Macathites, and over half of Gilead beyond the land of Sihon, king of Heshbon."
,"6":"Moses, the servant of Yahweh, with the Israelites, defeated them and Moses gave their land to the Reubenites, the Gadites and half the tribe of Mannaseh as their inheritance."
,"7":"Now these are the kings of the country whom Joshua and the Israelites defeated on the west side of the Jordan, from Baalgad, in the valley of Lebanon, to Mount Halak rising toward Seir. This is the land that Joshua divided among the tribes of Israel:"
,"8":"the hill country and the lowlands, the Arabah, the hillsides, the wilderness and the Negeb. This land had belonged to the Hittites, Amorites, Canaanites, Perizzites, Hivites and Jebusites. And these were the defeated kings:"
,"9":"king of Jericho, king of Ai near Bethel."
,"10":"king of Jerusalem, king of Hebron."
,"11":"king of Jarmuth, king of Lachish."
,"12":"king of Eglon, king of Gezer."
,"13":"king of Debir, king of Geder."
,"14":"king of Hormah, king of Arad."
,"15":"king of Libnah, king of Adullam."
,"16":"king of Makkedah, king of Bethel."
,"17":"king of Tappuah, king of Hepher."
,"18":"king of Aphek, king of Sharon."
,"19":"king of Madon, king of Hazor."
,"20":"king of Symoon, king of Achshaph."
,"21":"king of Taanach, king of Megiddo."
,"22":"king of Kedesh, king of Jokneam in Carmel."
,"23":"king of Dor on the hillsides of Dor. king of Goiim in Galilee, "
,"24":"and king of Tirzah. Total number of all these kings: thirty-one."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Now Joshua had grown old and advanced in years. Yahweh said to him, 'You are old now, yet much of the land is still unconquered, including:"
,"2":"All the territory of the Philistines and the Geshurites."
,"3":"All the land from the river east of Egypt, to the boundary of Ekron in the north that is considered Canaanite territory. (The five chief towns of the Philistines: Gaza, Ashdod, Ashkelon, Gath and Ekron; the Avvites also in the south.)"
,"4":"The whole country of the Canaanites from Arah, which the Sidonians hold, to Aphekah at the Amorite border,"
,"5":"and then the country of the Gebalites with all Lebanon eastward from Baagad at the foot of Mount Hermon to the Pass of Hamath."
,"6":"All the land of the Sidonians who live in the highlands from Lebanon to Misrephoth-maim westward. I myself will drive them all out before the Israelites. In the meantime, share out the land among the Israelites by drawing lots as I have commanded you. "
,"7":"The time has come to divide this land among the nine tribes and half the tribe of Mannaseh: from the Jordan River to the Mediterranean Sea westward you shall give it to them; the Mediterranean will mark their boundary.'"
,"8":"As for the other half tribe of Mannaseh, they and the tribes of Reuben and Gad had already received the land given them by Moses on the east side of the Jordan River. Moses the servant of Yahweh had given them"
,"9":"the land as far as Aroer, which lies on the edge of the Arnon valley, with the city in the middle of that valley and all the high, flat land from Medeba to Dibon."
,"10":"All the towns of Sihon the king of the Amorites, who had reigned in Heshbon, were included, as far as the boundary of the Ammonites."
,"11":"Gilead and the territory of the Geshurites and Maacathites with all the highlands of Hermon and with the whole of Bashan as far as Salecah."
,"12":"In Bashan the whole kingdom of Og, who reigned in Ashtaroth and Edrei and was the last survivor of the Rephaim. Moses had conquered these people and driven them out."
,"13":"But the Israelites did not drive out the Geshurites or the Maacathites, and therefore Geshur and Maacah still live in the midst of Israel to this day."
,"14":"To the tribe of Levi alone no land was given; Yahweh the God of Israel was their inheritance, as he had told them."
,"15":"Moses had given the tribe of Reuben a part of the land according to their clans."
,"16":"The land they received stretched from Aroer, on the edge of the Arnon Valley, including the town within the valley itself, and all the high, flat land up to Medeba,"
,"17":"and Heshbon and all the towns on the high, flat land: Dibon, Bamoth-baal, Beth-baal-meon,"
,"18":"Jahaz, Kedemoth Mephaath,"
,"19":"Kiriathaim, Sibmah and Zereth-shahar in the highlands of Gor;"
,"20":"Beth-peor, the slopes of Pisgah, Beth-jeshimoth,"
,"21":"all these towns and the whole kingdom of Sihon the king of the Amorites, who reigned in Heshbon; he had been defeated by Moses, and with him the princes of Midian, Evi, Rekem, Zur, Hur, and Reba, who had ruled the land for King Sihon who used to live in this country."
,"22":"As for Balaam son of Beor, the seer, the Israelites had put him to the sword with others they had killed."
,"23":"Thus the land of the Reubenites stretched to the Jordan River. This was the inheritance of the tribe of Reuben according to their clans, with the towns and their outlying villages."
,"24":"Moses had given the tribe of Gad, a part of the land according to their clans:"
,"25":"Jazer, all the towns of Gilead, half the country of the Ammonites as far as Aroer facing Rabbah,"
,"26":"and from Heshbon to Ramathmizpeh and Betonim, and from Mahanaim as far as the territory of Lodebar,"
,"27":"and lastly, in the Jordan valley: Beth-haram, Bethnimrah, Succoth, and Zaphon, the rest of the kingdom of Sihon the king of Heshbon. The Jordan River was their western border as far north as the Sea of Galilee, on the eastern side of the Jordan."
,"28":"This was the inheritance of the tribe of Gad according to their clans, with the towns and their outlying villages."
,"29":"Moses had given half the tribe of Manasseh a part of the land according to their clans:"
,"30":"from Mahanaim right through Bashan, including the whole kingdom of Og the king of Bashan and all sixty villages of Jair in Bashan."
,"31":"Half of Gilead as well as Ashtaroth and Edrei, the royal cities of Og in Bashan, were given to half the families from Machir, son of Manasseh."
,"32":"This was how Moses divided the land when he was in the plains of Moab, beyond the Jordan east of Jericho."
,"33":"But to the tribe of Levi, Moses had given no land; Yahweh the God of Israel is their inheritance, as he has told them."
}`)
	CurrentBook.AddChapter(14, `{
"1":"The land of Canaan was divided among the Israelites by Eleazar the priest and by Joshua son of Nun and by the heads of the families of the tribes of Israel."
,"2":"They divided the land by drawing lots as Yahweh had commanded through Moses for the nine."
,"3":"(Remember that Moses had given the two and a half tribes beyond the Jordan their own property; to the Levites, he had given no land,"
,"4":"but the sons of Joseph were two tribes, Manasseh and Ephraim.) The Levites were given no share of the land except certain towns to live in, with pasture lands nearby for their cattle and property."
,"5":"In dividing the land, the Israelites did as Yahweh had commanded Moses to do."
,"6":"When the sons of Judah came to Joshua at Gilgal, Caleb son of Jephunneh the Kenizzite, said to him, 'You know what Yahweh said to Moses, the man of God, at Kadesh-barnea concerning you and me."
,"7":"I was forty years old when Moses, the servant of Yahweh, sent me from Kadesh-barnea to spy on this land, and I made an honest report about it to him."
,"8":"But the men who had gone with me discouraged the people, whereas I myself faithfully obeyed Yahweh my God."
,"9":"That day Moses made this promise to me, 'Because you have obeyed Yahweh my God, the land your foot may walk upon shall be the land which you and your children will own forever.'"
,"10":"From then till now, Yahweh has kept me alive in accordance with his promise. It is forty-five years since Yahweh made this promise to Moses (Israel was then journeying through the wilderness), and now I am eighty-five years old."
,"11":"Today I am still as strong as the day when Moses sent me out on the raid; for fighting, for going and coming, I am as strong now as then."
,"12":"Give me then the highlands that Yahweh promised me. You know that there are a race of giants called the Anakim and their towns are great and strong. But if Yahweh is with me, I shall drive them out as Yahweh said.'"
,"13":"Joshua blessed Caleb, son of Jephunneh, and gave him the city of Hebron as an inheritance."
,"14":"And hence Hebron down to the present day belongs to the descendants of Caleb son of Jephunneh, the Kenizzite, because he obeyed Yahweh the God of Israel."
,"15":"The name of Hebron in earlier times was Kiriath-arba. Arba had been the greatest man of the Anakim. And the country had rest from war."
}`)
	CurrentBook.AddChapter(15, `{
"1":"The land given to the tribe of Judah according to their clans was near the border of Edom from the wilderness of Zin to Kadesh southwestward."
,"2":"Their southern border began at the end of the Dead Sea;"
,"3":"went south from the Ascent of Akrabbim and crossed through Zin. It went south of Kadesh-barnea, passed Hezron, went up to Addar and from there turned toward Karka,"
,"4":"skirted Azmon, came out at the stream on the border of Egypt and ended at the Mediterranean."
,"5":"On the east, the border was formed by the Dead Sea as far as the mouth of the Jordan."
,"6":"On the north the border began at the Sea Tongue at the mouth of the Jordan. This border went up to Beth-hoglah, passed through the north of Beth-arabah and reached the Stone of Bohan of Reuben."
,"7":"The border then went up to Debir from Acor Valley and turned toward the circle of stones opposite the Ascent of Adummim, south of the valley; the border went on to the waters of En-shemesh and ended at Enrogel."
,"8":"Then it went on up the Benhinnom Valley on the south side of the hill where the Jebusite city, that is to say, Jerusalem, was located. The border then climbed to the top of the mountain on the west side of Hinnom Valley and at the northern end of the plain of Rephaim."
,"9":"From the mountain the border bent toward the source of the waters of Nephtoah, passed from there toward Mount Ephron and then turned toward Baalah, that is to say, Kiriath-jearim."
,"10":"From Baalah the border bent westward to the mountain country of Seir, went on the northern slope of Mount Jearim, that is to say, Chesalon, went down to Beth-shemesh and through Timnah,"
,"11":"reached the north side of Ekron, turned toward Shikkeron, passed by the Hill of Baalah, then on to Jabneel, and ended at the Big Sea, that is, the Mediterranean."
,"12":"The western border was the Big Sea itself. This was the border that enclosed the lands given to the clans of the tribe of Judah."
,"13":"Caleb son of Jephunneh was given part of the territory of Judah, as Yahweh had commanded Joshua to do. Joshua gave him Kiriath-arba, the chief city of the Anakim, which is now Hebron."
,"14":"Caleb drove the descendants of Anak out of it: the clans of Sheshai, Ahiman and Talmai."
,"15":"From there he marched up to attack the people living in Debir, the name of which was once Kiriath-sepher."
,"16":"Then Caleb said, 'To the man who conquers and captures Kiriath-sepher, I will give my daughter Achsah as wife.'"
,"17":"Othniel, son of Kenaz, Caleb's brother conquered the city; Caleb gave him his daughter Achsah in marriage."
,"18":"When she came to her husband, he urged her to ask her father for a field. When she jumped down from her donkey, Caleb asked her, 'What do you want?'"
,"19":"She answered, 'Grant me a favor; since you have sent me away to the wilderness of the Negeb, at least grant me some springs of water.' So he gave her the upper springs and the lower springs."
,"20":"This was the land given to the tribe of Judah according to their clans."
,"21":"These are the furthermost towns of the tribe of Judah, toward the boundary of Edom in the Negeb: Kabzeel, Eder, Jagur,"
,"22":"Kinah, Dimon, Adadah,"
,"23":"Kedesh, Hazor, Ithnan,"
,"24":"Ziph, Telem, Bealoth,"
,"25":"Hazor-hadattah, Kerioth-hezron (that is to say, Hazor),"
,"26":"Amam, Shema, Moladah,"
,"27":"Hazar-gaddah, Heshmon, Beth-pelet,"
,"28":"Hazar-shual, Beer-sheba, Biziothiah,"
,"29":"Baalah, Iim, Ezem,"
,"30":"Eltolad, Chesil, Hormah,"
,"31":"Ziklag, Madmannah, Sansannah,"
,"32":"Lebaoth, Shilhim, En-rimmon. In all, twenty-nine towns, with their outlying villages."
,"33":"In the lowlands there were fourteen towns with their villages: Eshtaol, Zorah, Ashnah,"
,"34":"Zanoah, En-gannim, Tappuah, Enam,"
,"35":"Jarmuth, Adullam, Socoh, Azekah,"
,"36":"Shaaraim, Adithaim, Gederah."
,"37":"Zenan, Hadashah, Migdalgad,"
,"38":"Dilean, Mizpah, Joktheel,"
,"39":"Lachish, Bozkath, Eglon,"
,"40":"Cabbon, Lahmas, Chitlish,"
,"41":"Gederoth, Beth-dagon, Naamah, Makkedah, altogether sixteen towns with their villages."
,"42":"Libnah, Ether, Ashan,"
,"43":"Iphtah, Ashnah, Nezib,"
,"44":"Keilah, Achzib, Mareshah, altogether nine towns with their villages."
,"45":"Ekron with its towns and villages near Ashdod."
,"46":"From Ekron to the sea,"
,"47":"Ashdod and Gaza with their towns and villages as far as the stream on the border of Egypt and the Mediterranean Sea."
,"48":"In the highlands: Shamir, Jattir, Socoh,"
,"49":"Dannah, Kiriath-sannah, which is now Debir,"
,"50":"Anab, Eshtemoh, Anim,"
,"51":"Goshen, Holon, Giloh - eleven towns with their villages."
,"52":"Arab, Dumah, Eshan,"
,"53":"Janum, Beth-tappuah, Aphekah,"
,"54":"Humtah, Kiriath-arba, which is now Hebron, Zior - nine towns with their villages."
,"55":"Maon, Carmel, Ziph, Juttah,"
,"56":"Jezreel, Jokdeam, Zanoah,"
,"57":"Kain, Gibeah, Timnah - ten towns with their villages."
,"58":"Halhul, Beth-zur, Gedor,"
,"59":"Maarath, Beth-anoth, Eltekon - six towns with their villages. Tekoa, Ephrathah, which is now Bethlehem, Peor, Etam, Kulon, Tatam, Sores, Carem, Gallim, Bether, Manach - eleven towns with their villages."
,"60":"Kiriath-baal, which is now Kiriath-jearim, and Rabbah - two towns with their villages."
,"61":"In the wilderness: Beth-arabah, Middin, Secacah,"
,"62":"Nibshan, the City of Salt and Engedi - six towns with their villages."
,"63":"But the people of Judah could not drive out the Jebusites who lived in Jerusalem; the Jebusites lived there side by side with the sons of Judah, as they still do today."
}`)
	CurrentBook.AddChapter(16, `{
"1":"The land given by lot to the descendants of Joseph stretched from the Jordan opposite Jericho eastward. From Jericho onward the southern border climbed the highlands into the hill country as far as Bethel;"
,"2":"it left Bethel and Luz and went on toward the border of the Archites of Ataroth;"
,"3":"then it went westward to the area of the Japhletites as far as the area of Lower Beth-horon. From there it went to Gezer, and reached the Mediterranean Sea."
,"4":"The tribes of Manasseh and Ephraim, descendants of Joseph, divided this inheritance among themselves."
,"5":"The border of the tribe of Ephraim ran from Ataroth-addar as far as Upper Beth-horon,"
,"6":"and it ended at the Mediterranan Sea. Michmethath was to the north. From there the border turned east towards Tanaath-shiloh and ran beyond it on the east to Janoah."
,"7":"Then it went down from Janaoah to Ataroth and Naarah, touched Jericho and ended at the Jordan."
,"8":"From Tappuah the border went westward to the stream Kanah and ended at the Mediterranean Sea. This was the land given to the tribe of Ephraim according to their clans,"
,"9":"as well as the towns set apart for the Ephraimites inside the territory of the descendants of Manasseh, all those towns and their villages."
,"10":"The Canaanites living in Gezer were not driven out; they have lived among the Ephraimites to the present day, but are submitted to obligatory works."
}`)
	CurrentBook.AddChapter(17, `{
"1":"A part of the land awarded to Manasseh, who was Joseph's firstborn son, was given to Machir, Manasseh's eldest son and father of Gilead. To him was given, as was fitting for a military hero, the country of Gilead and Bashan."
,"2":"Land was also given to other families descended from Manasseh according to their clans: the families of Abiezer, Helek, Asriel, Shechem, Hepher, Shemida. These were the clans of the male descendants of Manasseh son of Joseph."
,"3":"Zelophehad son of Hepher, son of Gilead, son of Machir, son of Manasseh, had no sons, only daughters, whose names are: Mahlah, Noah, Hoglah, Milcah and Tirzah."
,"4":"These daughters went to the priest Eleazar and to Joshua the son of Nun and to the leaders, and said, 'Yahweh commanded Moses to give us some of the land among our brothers as our own.' According to Yahweh's command, therefore, they were given land along with their male relatives."
,"5":"In this way Manasseh received ten shares besides the country of Gilead and Bashan which lies across the Jordan,"
,"6":"since Manasseh's female descendants received a share in the land as well as his male descendants. The country of Gilead itself belonged to the rest of the descendants of Manasseh."
,"7":"The border of Manasseh stretched from Asher to Michmethath, which is opposite Shechem. From there the border went south to the spring of Tappuah."
,"8":"The land surrounding Tappuah belonged to Manasseh, but the town of Tappuah on Manasseh's border belonged to the descendants of Ephraim."
,"9":"The border passed down to the stream, south of the river, where the towns set apart for Ephraim from among the towns of Manasseh were situated. The border of Manasseh passed north of the stream and ended at the sea."
,"10":"Ephraim was to the south and Manasseh to the north, and both were bounded on the west by the Mediterranan Sea. They touched Asher to the north and Issachar to the east."
,"11":"Within the territories of Issachar and Asher, Manasseh had Beth-shean and Ibleam with their surrounding towns, as well as Dor and Endor, Taanach and Megiddo and their surrounding towns, and a third of the Nepheth."
,"12":"But the people of Manasseh could not conquer these towns, and the Canaanites continued to live there."
,"13":"However, when the Israelites became stronger, they forced the Canaanites to work for them, but they never drove them out."
,"14":"The descendants of Joseph spoke to Joshua, 'Why have you given us only one share of the land when there are so many of us because Yahweh blessed us?'"
,"15":"Joshua answered, 'If your people are so many, go up to the forest and clear out a place for yourselves in the land of the Perizzites and the Rephaim, since the highlands of Ephraim are too small for you.'"
,"16":"The descendants of Joseph answered, 'The highlands are not enough for us, and, in the plain, the Canaanites have iron chariots, and so have those in Beth-shean and its surrounding towns, and those in the plain of Jezreel.'"
,"17":"Joshua said to the tribes of Ephraim and Manasseh, 'You are a numerous people and very powerful; you will not be left with only this share"
,"18":"for you will go up to the forest and clear it. All the land shall be yours, and you will drive out the Canaanites despite their iron chariots and great strength.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"After they had conquered the land, the whole community of Israel gathered at Shiloh, and the Tent of Meeting was set up there."
,"2":"Among the Israelites were seven tribes which had not yet been given their share of the land."
,"3":"Then Joshua said to them, 'How much longer will you wait before going in and taking possession of the land which Yahweh, the God of your fathers has given you?"
,"4":"Choose three men from each tribe. I will send them out to make a survey of the whole territory so that it can be divided."
,"5":"They must divide the land into seven parts, because those of the tribe of Judah have already their territory to the south, and those of the tribe of Joseph have their territory to the north."
,"6":"You are to survey the land in seven divisions and bring your findings to me here, so that I can cast lots for you before Yahweh our God."
,"7":"The Levites have no share in the land with the rest of you; their share is to serve as priests of Yahweh, and the tribes of Gad and Reuben and half the tribe of Manasseh have received their land beyond the Jordan eastward, as Moses, Yahweh's servant, gave it to them.'"
,"8":"To those who were to survey the country, Joshua gave this command before they started on their way: 'Go, survey and map the whole country, and then come back to me. Here in Shiloh I will consult Yahweh for you by drawing lots.'"
,"9":"So the men left and went all over the country, making a list of all the towns and how they were to be divided into seven parts. When they brought it back to Joshua in the camp at Shiloh,"
,"10":"he drew lots to consult Yahweh for them and divided the land among the Israelites according to their clans."
,"11":"The first share of land went to the tribe of Benjamin according to their clans: their territory lay between that of the tribes of Judah and Joseph."
,"12":"The northern border began at the Jordan, climbed to the northern side of Jericho, rose through the hill country westward and ended at the wilderness of Beth-aven."
,"13":"From there it continued toward the south side of Luz which is now called Bethel; then downward to Ata-roth-addar, on the mountain south of Lower Beth-horon."
,"14":"The border then curved, and on the western side of this mountain turned southward and ended at Kiriath-baal, which is now called Kiriath-jearim, a city of the tribe of Judah. This was the western border."
,"15":"The southern border ran from the edge of Kiriath-jearim toward Gasin, and to the spring of Nephtoah."
,"16":"It continued to the foot of the mountain facing the Valley of Ben-hinnom, at the north end of Rephaim Valley. It then went south through the Valley of Hinnom, south of the mountainside of the Jebusites and reached En-rogel."
,"17":"It then curved northward to En-shemesh coming out at the circles of stones facing the Ascent of Adummim,"
,"18":"then on to Cheteph in sight of the Arabah and down to the Arabah and"
,"19":"the stone of Bohan (Bohan was a son of Reuben) and from there passed north of the mountainside overlooking the Jordan Valley. The border ended at the bay of the Dead Sea, at the mouth of the Jordan. This was the southern border."
,"20":"The Jordan itself was the eastern border. Such was the land given to the tribe of Benjamin, with the borders defining it."
,"21":"The towns of the tribe of Benjamin, according to their clans, were Jericho, Beth-hoglah, Emek-keziz;"
,"22":"Beth-arabah, Zemaraim, Bethel;"
,"23":"Avvim, Parah, Ophrah,"
,"24":"Chephar-ammoni, Ophni, Geba: twelve towns and their surrounding villages."
,"25":"Gibeon, Ramah, Beeroth;"
,"26":"Mizpeh, Chephirah, Mozah;"
,"27":"Rekem, Irpeel, Taralah;"
,"28":"Zela, Haeleph, Jerusalem, Gibeah and Kiriath: fourteen towns with their surrounding villages. This was the land given to the tribe of Benjamin, according to their clans."
}`)
	CurrentBook.AddChapter(19, `{
"1":"The second share of land went to the tribe of Simeon, according to their clans; their land was encircled by the land of the tribe of Judah."
,"2":"For they had Beer-sheba, Shema, Moladah;"
,"3":"Hazarshual, Balah, Ezem;"
,"4":"Eltolad, Bethul, Hormah;"
,"5":"Ziglag, Beth-marcaboth, Hazar-susah;"
,"6":"Beth-lebaoth and Sharuhen - thirteen towns and their surrounding villages:"
,"7":"Ain, Rimmon, Ether and Ashan - four towns and their surrounding villages."
,"8":"Moreover, they were given all the villages lying outside these towns as far as Baalath-beer, Ramah of the Negeb. This was the land given to the tribe of Simeon according to their clans."
,"9":"This land was taken from the territory of Judah, because their share of these was too large for them; this is why the tribe of Simeon was given land within the territory of the tribe of Judah."
,"10":"The third share of land went to the tribe of Zebulun according to their clans; their border reached as far as Sarid."
,"11":"From there the border climbed westward to Maraalah, touching Dabbesheth first and then the stream east of Jokneam."
,"12":"From Sarid it went eastward toward the sunrise to the border of Chisloth-tabor, then to Dobrath and to Japhia."
,"13":"From there it continued eastward to Gathhepher and Ittah-kazin; it came out at Rimmon and turned toward Neah."
,"14":"On the north the border bent toward Hannathon and ended at the valley of Iphtahel."
,"15":"It included Kattath, Nahalal, Shimron, Iralah and Bethlehem - twelve towns with their surrounding villages."
,"16":"This was the land received by the tribe of Zebulun according to their clans: these towns and their surrounding villages."
,"17":"The fourth share of land went to the tribe of Issachar, according to their clans."
,"18":"Their border reached to Jezreel and included Chesulloth and Shunem;"
,"19":"Hapharaim, Shion, Anaharath;"
,"20":"Dobrath, Kishion, Ebez;"
,"21":"Remeth and En-gannim, En-haddah and Beth-pazzez."
,"22":"Their border touched Tabor and Shahazimah and Beth-shemesh, and ended at the Jordan: sixteen towns with their surrounding villages."
,"23":"This was the land given to the tribe of Issachar, according to their clans: the towns with their surrounding villages."
,"24":"The fifth share of land went to the tribe of Asher, according to their clans."
,"25":"Within their territory were Helkath, Hali, Beten, Achshaph,"
,"26":"Allammelech, Amad and Mishal; on the west their border touched Carmel and the stream of the Libnath;"
,"27":"on the other side it went eastward to Beth-dagon, touching Zebulun and the Valley of Iphtahel on the way north to Beth-emek and Neiel. It continued north to Cabul,"
,"28":"Abdon, Rehob, Hammon and Kanah as far as Sidon the Great."
,"29":"The border then turned back toward Ramah reaching the fortress city of Tyre. From there it turned to Hosah and ended at the Mediterranean Sea. It included Mahalab, Achzib,"
,"30":"Acco, Aphek, Rehob: twenty-two towns with their surrounding villages."
,"31":"This was the land given to the tribe of Asher, according to their clans; these towns with their surrounding villages."
,"32":"The sixth share of land went to the tribe of Naphtali according to their clans."
,"33":"Their border went from Heleph and the Oak of Zanaannim to Adami-negeb, to Jabneel as far as Lakkum, and ended at the Jordan."
,"34":"From there the border ran west to Aznoth-tabor and went on to Hukkok, touching Zebulun on the south, Asher on the west and the Jordan on the east."
,"35":"The fortified towns were Ziddim, Zer, Hammath, Rakkath, Chinnereth;"
,"36":"Adamah, Ramah, Hazor;"
,"37":"Kedesh, Edrei, En-hazor;"
,"38":"Yiron, Migdalel, Horem, Beth-anath, Beth-shemesh: nineteen towns with their surrounding villages."
,"39":"This was the land given to the tribe of Naphtali according to their clans."
,"40":"The seventh share of the land went to the tribe of Dan according to their clans,"
,"41":"Within their territory were Zorah, Eshtaol, Irshemesh;"
,"42":"Sha-alabbin, Aijalon, Ithlah;"
,"43":"Elon, Timnah, Ekron,"
,"44":"Eltekeh, Gibbethon,"
,"45":"Baalath; Jehud, Bene-berak, Gathrimmon;"
,"46":"Mejarkon and Rakkon with the land around Joppa."
,"47":"But the territory of the tribe of Dan was too small for them; and therefore they went up and attacked Leshem and captured it and killed its people. Having seized the town they settled in it, and changed the name of Leshem to Dan after Dan their ancestor."
,"48":"This was the land of the tribe of Dan, according to their clans: these towns with their surrounding villages."
,"49":"When the Israelites finished distributing the land by drawing lots, they gave Joshua son of Nun a part of the land as his own;"
,"50":"at the command of Yahweh, they gave him the town he had asked for, Timnath-serah in the hill country of Ephraim; he rebuilt the city and settled there."
,"51":"These are the shares of land which Eleazar the priest, Joshua son of Nun, and the heads of each family divided among the tribes of Israel by drawing lots at Shiloh, in Yahweh's presence, at the door of the Tent of Meeting; and thus they finished dividing the land."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Yahweh said to Joshua,"
,"2":"'Speak to the Israelites and say to them: Choose the cities of refuge about which I told you through Moses,"
,"3":"towns where a person who kills someone accidentally may find safety; they are to be your refuge from the dead person's relative who is looking for revenge."
,"4":"The man who has killed may run away to one of these towns; he shall appear at the entrance to the town and explain his case to the elders of the place. They shall welcome him and assign him. place to live among them."
,"5":"If the person who wants revenge follows him there, they are not to hand him over, since he has killed his neighbor accidentally and not out of hatred."
,"6":"The man who has killed must remain in that town until he has received a public trial and until the death of the high priest then in office. Only then may the man who has killed go back to his own town and his own house, to the town from which he has escaped.'"
,"7":"For this purpose they set aside Kedesh in Galilee, in the hill country of Naphtali, Shechem in the highlands of Ephraim, and Kiriath-arba, which is now Hebron, in the hill country of Judah."
,"8":"East of the Jordan, in the desert east of Jericho, they chose Bezer in the territory of Reuben, Ramoth-gilead in the territory of Gad, and Golan in Bashan in the territory of Manasseh."
,"9":"These were the towns set aside for all the Israelites and for any foreigner living among them, where anyone who had killed a person accidentally could find safety from the dead person's relative looking for revenge, until he had been given a public trial."
}`)
	CurrentBook.AddChapter(21, `{
"1":"The heads of families among the Levites came to Eleazar the priest and to Joshua son of Nun and to the heads of families of all the tribes of Israel."
,"2":"At Shiloh in the land of Canaan, they said to them, 'Yahweh commanded through Moses that we should be given towns to live in, with the pasture land around them for our cattle.'"
,"3":"In accordance with Yahweh's command, the Israelites gave the Levites certain cities and pasture lands out of their own territories."
,"4":"First among the Levite clan of Kohath, the families descended from Aaron the priest, were given thirteen towns from the territories of Judah, Simeon and Benjamin;"
,"5":"the other Kohath families received, clan by clan, ten towns from the territories of Ephraim, Dan and half the tribe of Manasseh."
,"6":"The clan of Gershon was given thirteen towns from the territories of Issachar, Asher, Naphtali and half the tribe of Manasseh in Bashan."
,"7":"The families of the clan of Merari were given twelve towns from the territories of Reuben, Gad and Zebulun."
,"8":"These towns and the pasture lands near them the Israelites gave to the Levites by drawing lots, as Yahweh had commanded through Moses."
,"9":"These are the towns of Judah and Simeon that Joshua gave"
,"10":"to the descendants of Aaron who were of the Kohathite clan of the Levites, the first to be given some cities."
,"11":"They gave them Kiriath-arba, the chief city of the Anakim, which is now Hebron, in the hill country of Judah, with the pasture lands around it."
,"12":"But the fields and surrounding villages of this town had already been given to Caleb son of Jephunneh as his property."
,"13":"To the descendants of Aaron the priest, they gave Hebron, a city of refuge, and the pasture lands near it; also Libnah with its pasture lands,"
,"14":"and Jattir, Eshtemoa,"
,"15":"Holon, Debir,"
,"16":"Ashan, Juttah and Bethshemesh, each with its pasture lands: nine towns taken from these two tribes."
,"17":"From the territory of Benjamin four towns: Gibeon and Geba with their pasture lands,"
,"18":"Anathoth and Almon with theirs."
,"19":"The towns of the priests, the descendants of Aaron, were thirteen towns in all, with their pasture lands."
,"20":"Some towns from the territory of Ephraim were given to the other families of the Levite clan of Kohath:"
,"21":"the city of refuge, Shechem, with its pasture lands, in the hill country of Ephraim, together with Gezer,"
,"22":"Kibzaim and Beth-horon, each with its pasture lands: four towns."
,"23":"From the territory of Dan, Elteke, Gibbethon,"
,"24":"Aijalon and Gathrimmon with their pasture lands: four towns."
,"25":"From the territory of half the tribe of Manasseh they were given two towns: Taanach and Jibleam with their pasture lands."
,"26":"In all, ten towns with their pasture lands were given to the families of the clan of Kohath."
,"27":"To the Levite clan of Gershon were given the city of refuge Golan in Bashan and also Ashtaroth, each with its pasture lands: two towns, both from the territory of the half tribe of Manasseh."
,"28":"From the territory of Issachar four towns: Kishion, Dobrath,"
,"29":"Jarmuth and En-gannim, each with its pasture lands."
,"30":"From the territory of Asher four towns: Mishal, Abdon,"
,"31":"Helkath and Rehob, each with its pasture lands."
,"32":"From the territoy of Naphtali three towns: Kedesh, the city of refuge in Galilee, Hammoth-dor and Rakkath, each with its pasture lands."
,"33":"The Gershonites according to their clans were given thirteen towns in all with their pasture lands."
,"34":"To the clans of Merari, the rest of the Levites, were given four towns with their pasture lands from the territory of Zebulun:"
,"35":"Jokneam, Kartah, Rimmon and Nahalal."
,"36":"From the territory of Reuben, beyond the Jordan four towns: the city of refuge Bezer, Jahaz,"
,"37":"Kedemoth and Mephaath, each with its pasture lands."
,"38":"From the tribeof Gad four towns: the city of refuge Ramoth-gilead, Mahanaim,"
,"39":"Heshbon and Jazer, each with pasture lands."
,"40":"A total of twelve towns were given to the clan of Merari."
,"41":"The towns thus given to the Levites from the Israelite inheritance were"
,"42":"forty-eight, with their pasture lands. All these towns, as well as the pasture lands around them, were given to the Levites."
,"43":"So it was that Yahweh gave the Israelites all the land he had solemnly promised to give their ancestors. They took possession of it and began to live there."
,"44":"Yahweh gave them peace throughout their land just as he had promised their ancestors. Not one of their enemies was able to stand against them; Yahweh gave them victory over all their enemies"
,"45":"and kept all the promises he had made to the people of Israel."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Then Joshua summoned the Reubenites, the Gadites and the halftribe of Manasseh"
,"2":"and said to them,"
,"3":"'You have observed all that Moses, the servant of Yahweh ordered you, and you have obeyed me constantly. You have never deserted your brothers over this long period of time; at every point you have obeyed the orders of Yahweh your God."
,"4":"Now that Yahweh your God has granted your brothers the rest he promised them, go back to your tents, to the land given into your possession by Moses the servant of Yahweh, beyond the Jordan."
,"5":"But take care above all to keep the commandments of the Law which Moses the servant of Yahweh gave you: love Yahweh your God, follow his paths always, keep his commandments, be faithful to him and serve him with all your heart and all your soul.'"
,"6":"So Joshua blessed them and sent them away; they went home to their tents."
,"7":"Moses had given territory in Bashan to one half of the tribe of Manasseh; because of this Joshua gave land to the other half of Manasseh among their brothers on the west bank of the Jordan. As Joshua sent them home to their tents he blessed them"
,"8":"and said to them, 'You are going back to your tents with great wealth, with cattle in plenty, with silver and gold, bronze and iron and great quantities of clothing; these are the spoils of your enemies that you shared with your brothers.'"
,"9":"The Reubenites, the Gadites and the half-tribe of Manasseh went home again; they left the Israelites at Shiloh in the land of Canaan, and made their way back to the land of Gilead, the territory which belonged to them and where they had settled in accordance with the order of Yahweh given through Moses."
,"10":"When they came to the circles of stones at the Jordan which are in Canaanite territory, the Reubenites, the Gadites and the half-tribe of Manasseh built there beside the Jordan, an imposing altar of great size."
,"11":"The Israelites were told, 'The Reubenites, the Gadites and the half-tribe of Manasseh have built this altar facing the land of Canaan near the circles of stones at the Jordan, beyond the territory of the Israelites.'"
,"12":"At this news the children of Israel summoned the whole community at Shiloh, ready to make war on them."
,"13":"The Israelites sent the priest Phinehas son of Eleazar to the Reubenites, the Gadites and the half-tribe of Manasseh, in the land of Gilead,"
,"14":"and with him ten leading men, one leader from each tribe in Israel; every one of them was head of his family among the clans of Israel."
,"15":"When they came to the Reubenites, the Gadites and the half-tribe of Manasseh in the land of Gilead, they said to them:"
,"16":"'The whole community of Yahweh asks you: What do you mean by this treachery committed against the God of Israel? Why turn aside from Yahweh today, building yourselves an altar? You are sinning against Yahweh himself."
,"17":"Was the sin at Peor not enough, the sin from which we are not cleansed even now, in spite of the plague that ravaged the whole community of Yahweh?"
,"18":"You have stopped following Yahweh today, and you have set yourselves in revolt against him today. Tomorrow his anger will be roused against the whole community of Israel."
,"19":"Do you think your land is unclean? Then cross over into the territory of Yahweh, where his Holy Tent is and come to live among us. But do not rebel against Yahweh or set yourselves apart by building an altar to vie with the altar of Yahweh our God."
,"20":"When Achan, son of Zerah betrayed his trust in the matter of the anathema, did not Yahweh vent his anger on the whole community of Israel, although he was only one man? Did he not have to die for his sin?'"
,"21":"The Reubenites, the Gadites and the half-tribe of Manasseh answered the heads of the clans of Israel:"
,"22":"'Yahweh is the God of gods! Yahweh well knows, and let Israel know it too: Let Yahweh punish us immediately if there has been defiance or treachery on our part against Yahweh."
,"23":"Let Yahweh punish us if we have built an altar to turn away from Yahweh and offer holocaust and oblation and communion sacrifice on it."
,"24":"We made it to prevent what might happen one day when your children say to ours: 'What link have you with Yahweh the God of Israel?"
,"25":"Has not Yahweh set the boundary of the Jordan between us and you, you sons of Reuben and sons of Gad? You have no share in Yahweh.' Thus your children might make us turn aside from Yahweh."
,"26":"So we said to each other, 'Let us build this altar, not for holocausts or other sacrifices"
,"27":"but as a witness between us and you and among our descendants after us. It will prove that we, too, worship Yahweh with our holocausts, our victims and our communion sacrifices in his presence. So that your children will never be able to say to ours: You have no share in Yahweh."
,"28":"For, in this case, we should say to them: Look at this structure, Yahweh's altar made by our ancestors not for holocausts or other sacrifices but as a witness between us and you.'"
,"29":"We have no intention of defying Yahweh or turning away from him today. We are not building an altar for holocaust or oblations or sacrifices to compete with the altar of Yahweh our God that stands before his tabernacle!'"
,"30":"When Phinehas the priest, and the leaders of the community who were with him, heard the answer of the sons of Gad and of Reuben and of Manasseh, they approved of them."
,"31":"Then the priest Phinehas son of Eleazar said to the sons of Reuben and sons of Gad and sons of Manasseh, 'Now we clearly see that Yahweh is among us, because you have not sinned against him; you have saved the children of Israel from the punishment of Yahweh.'"
,"32":"The priest Phinehas son of Eleazar and the leaders left the Reubenites and the Gadites and returned from the land of Gilead to the land of Canaan, and they brought back this answer to the Israelites."
,"33":"The Israelites were pleased to hear this; they gave thanks to God and spoke no more of making war and ravaging the country where the sons of Reuben and of Gad had settled."
,"34":"The Reubenites and the Gadites named the altar: 'Witness', 'Because,' they said, 'it will be a witness between us that Yahweh is God.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"A long time after Yahweh gave peace to Israel in all its borders,"
,"2":"Joshua, who was now very old and burdened with age, summoned all Israel - their elders, leaders, secretaries and judges - and he said to them: 'I am now very old."
,"3":"You have seen all that Yahweh has done to all these nations for your sake and how he himself has fought for you."
,"4":"See, I have distributed to you the territory of all these nations that we destroyed from the Jordan to the Great Sea, as well as those nations that still remain."
,"5":"Yahweh, our God, will continue driving them back before you and will deprive them of their lands that you may take them as Yahweh has promised you."
,"6":"Therefore be very valiant and have the determination to do all that is written in the book of the Law of Moses, without turning aside from it either to the right or to the left."
,"7":"Do not intermingle with these nations that are left among you. Do not call upon their gods or swear by their name. Do not serve them or bow before them,"
,"8":"but remain united to Yahweh, our God, as you have done to this day."
,"9":"For that reason, Yahweh has driven away before you many powerful nations: no one was able to stand before your presence."
,"10":"One of you pursued a thousand since Yahweh, our God, fought for you as he had promised."
,"11":"So then, be very careful to love Yahweh, your God."
,"12":"But if you separate yourselves from him and become one with the rest of these nations that still remain among you, if they come to be your relatives and you intermarry with them,"
,"13":"know very well that Yahweh shall no longer drive out these nations before you, but they shall be a snare and a trap for you, a scourge on your sides, and thorns in your eyes, until you perish from this beautiful land Yahweh, our God, has given you."
,"14":"I am now about to go the way of all creatures, so I say to you: know in your soul and in your conscience that all the promises of Yahweh, our God, have been fulfilled; not one of them has failed."
,"15":"But just as all these promises of Yahweh in your favor have been fulfilled, so shall Yahweh bring all the evil he has threatened against you until you have been wiped out from this magnificent land he has given you,"
,"16":"if you break the covenant that Yahweh, our God, has given us. If you follow and serve other gods and bow before them, the wrath of Yahweh shall rise against you, and you shall suddenly perish from this fertile land he has given you.'"
}`)
	CurrentBook.AddChapter(24, `{
"1":"Joshua summoned all the tribes of Israel in Shechem, and assembled the elders, leaders, judges and secretaries. And together they presented themselves before God."
,"2":"Addressing the people, Joshua said to them: 'Yahweh, the God of Israel, commands me to say to you: Your ancestors lived beyond the Euphrates River - Terah the father of Abraham and Nahor - serving other gods."
,"3":"But I brought Abraham your father from beyond the Euphrates and led him through the whole land of Canaan. Then I gave him a son Isaac, that he might have numerous descendants."
,"4":"And to Isaac, I gave two sons: Esau and Jacob. Esau received the mountains of Seir as his inheritance, while Jacob and his sons went down to Egypt."
,"5":"Then I sent Moses and Aaron to punish Egypt in the way that you know, that you might leave."
,"6":"Then I brought your fathers out of Egypt and you came to the sea. The Egyptians pursued you with chariots and horses as far as the Red Sea."
,"7":"Then you cried to Yahweh, and he put immense darkness between you and the Egyptians. He made the sea go back on them and they were drowned. You have witnessed all the things he did in Egypt, and then you lived in the desert for a long time."
,"8":"Then I brought you to the land of the Amorites who were on the east of the Jordan. You fought them but it was I who gave them into your hand; you destroyed them and you seized their lands."
,"9":"Balak, the son of Zippor, king of Moab, declared war on Israel and commanded Balaam son of Beor to curse you."
,"10":"But I would not listen to him, so Balaam blessed you and I saved you from the hands of Balak."
,"11":"Then you crossed the Jordan and came to Jericho. And the landlords of Jericho fought against you: the Amorites, Perizzites, Canaanites, Hittites, Girgashites, Hivites and Jebusites declared war on you, but I gave them to you."
,"12":"The two Amorite kings fled from you because of the swarm of hornets that attacked them and not because of your sword and bow."
,"13":"I gave you lands which you have not tilled, cities which you did not build but in which you now live. I gave you vineyards and olive groves which you did not plant but from which you now eat."
,"14":"So fear Yahweh, and be sincere and faithful in serving him. Set aside those gods your fathers worshiped in Mesopotamia and Egypt. Serve only Yahweh."
,"15":"But if you do not want to serve Yahweh, make known this very day whom you shall serve - whether they be the gods your fathers served in Mesopotamia or the gods of the Amorites who formerly occupied the land in which you now live. As for me, I and my household will serve Yahweh.'"
,"16":"The people answered: 'May God not permit that we ever abandon Yahweh to serve other gods!"
,"17":"For it was he who brought us and our fathers out of Egypt, the house of slavery. It was he who did those great wonders that we have seen; he protected us on the way and through all the land where we passed,"
,"18":"driving away before us all the nations especially the Amorites who lived in this land. So we shall also serve Yahweh: he is our God!'"
,"19":"Joshua asked the people: 'Will you be able to serve Yahweh? He is a Holy God, a Jealous God who does not tolerate wickedness or faults."
,"20":"If you abandon Yahweh to serve other gods, he will turn against you and just as he has done you so much good, so shall he punish you and destroy you.'"
,"21":"The people replied: 'No, may it not be as you say. We will serve Yahweh.'"
,"22":"Joshua said: 'You yourselves are witnesses that you have chosen Yahweh to serve him.' They answered: 'We are witnesses.'"
,"23":"Joshua then said, 'Remove now from your midst any other gods and serve Yahweh, the God of Israel, with all your heart.'"
,"24":"The people answered: 'We will serve Yahweh, our God, and obey his commands.'"
,"25":"On that day at Shechem, Joshua made a covenant with the people and fixed laws and ordinances."
,"26":"He also wrote down everything expressed in the book of the Law of God; he chose a great stone and put it under the oak tree in the sacred place of Yahweh."
,"27":"Then Joshua said to the people: 'This stone shall be a witness to all that Yahweh said to us, for it heard all these words. It shall be a witness against you, lest you deal falsely with Yahweh.'"
,"28":"Joshua immediately sent the people away and everyone returned to his land."
,"29":"After all these deeds, Joshua, son of Nun and servant of Yahweh, died at the age of a hundred and ten."
,"30":"They buried him in his land at Timnath-serah, in the hill country of Ephraim, to the north of Mount Gaash."
,"31":"Israel served Yahweh throughout the whole life of Joshua and of the elders who outlived Joshua and who had witnessed all the wonders Yahweh did for Israel."
,"32":"The Israelites brought from Egypt the bones of Joseph. They buried them at Shechem in a place in the field which Jacob bought from the children of Hamor, the father of Shechem, for a hundred pieces of money. This became the possession of the children of Joseph."
,"33":"Eleazar the son of Aaron also died and they buried him on the hill given to his son Phinehas on the mountains of Ephraim."
}`)

}
func EN_CCB_LoadVHIHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"It was in the twelfth year of the reign of Nebuchadnezzar, king of the Assyrians, who ruled in the great city of Nineveh that, at the same time, Arphaxad, king of the Medes, ruled at Ecbatana."
,"2":"Arphaxad had built around Ecbatana ramparts of stone, with each stone cut to the size of one and a half meters wide and three meters long. The ramparts were thirty-five meters high and twenty-five meters wide."
,"3":"He built at the gates city towers which were fifty meters high and rested on foundations twenty meters wide."
,"4":"The gates themselves were thirty-five meters high and twenty meters wide, wide enough for his valiant warriors and foot soldiers to march through them in battle array."
,"5":"In those days, King Nebuchadnezzar made war on King Arphaxad in the Great Plain, that is, the plain near the territory of the Ragae."
,"6":"All the people who lived in the mountains, those who lived along the banks of the rivers Euphrates, Tigris and Hydaspes, those on the plains of Arioch, king of the Elamites, and many other peoples joined the ranks of the Chaldeans to fight against the sons of Cheleoud."
,"7":"Nebuchadnezzar, king of the Assyrians, sent his messengers to all those living in Persia and in the West, to the inhabitants of Cilicia, Damascus, Lebanon and Anti-Lebanon, to those along the seacoast,"
,"8":"to the people of Carmel, Gilead, Upper Galilee and the Great Plain of Esdraelon,"
,"9":"to those in Samaria and its towns, and beyond the Jordan as far as Jerusalem, Bethany, Chelous, Kadesh, the River of Egypt, Tahpanhes, Raamses, and all the country of Goshen"
,"10":"as far as the region beyond Tanis and Memphis, and to all the inhabitants of Egypt as far as the country of Ethiopia."
,"11":"But the inhabitants of all these regions took no notice of the order of Nebuchadnezzar, king of the Assyrians, and did not join him in waging war. They no longer feared him because they considered him just like any other man. They sent back his messengers empty-handed and shamefaced."
,"12":"Nebuchadnezzar was greatly enraged against all these regions and swore by his throne and by his kingdom to punish all the districts of Cilicia, Damascus and Syria, and to put to the sword all who were in the lands of Moab, Ammon, the whole of Judea, and all those in Egypt as far as the coasts between the two seas."
,"13":"In the seventeenth year, Nebuchadnezzar went to battle with his army against King Arphaxad, and conquered him in the campaign. He drove back the army of Arphaxad with all his cavalry and chariots."
,"14":"Nebuchadnezzar occupied all the cities. Finally, he reached Ecbatana where he demolished its towers, pillaged the streets of the city and reduced its splendor to ruins."
,"15":"He pursued Arphaxad into the mountains of the Ragae, pierced him through with arrows and utterly destroyed him."
,"16":"Then he returned to Nineveh with a great crowd of followers and a considerable multitude of soldiers. He and his entire army stayed there amusing themselves and feasting for one hundred and twenty days."
}`)
	CurrentBook.AddChapter(2, `{
"1":"On the twenty-second day of the first month in the eighteenth year of his reign, there was talk in the House of Nebuchadnezzar, king of the Assyrians, of punishing all those who had disobeyed the king's commands."
,"2":"He called together his ministers and his noblemen, and told them his secret plan."
,"3":"He proclaimed publicly the total destruction of the land and the punishment of all those who had disregarded his call."
,"4":"As soon as Nebuchadnezzar, king of the Assyrians, had made this decision, he summoned Holofernes, the chief general of his army who was second in command, and said to him,"
,"5":"'So says the Great King, Lord of all the earth, you will set out from my presence, taking with you men of true courage, about one hundred and twenty thousand foot soldiers and a great number of horses with about twelve thousand cavalrymen."
,"6":"You will go to all the countries in the West and punish all the peoples, because they disregarded my orders."
,"7":"Tell them to submit themselves to me on land and water, lest in my anger I myself march against them. I will cover all the face of the earth with the footprints of my army, and I will give them over to my men to be plundered by them."
,"8":"The ravines will be filled with their wounded, rivers and torrents will be full of their dead."
,"9":"I will lead away their prisoners as captives to the uttermost parts of the earth."
,"10":"Go, then, and occupy in my name all their territories; if they surrender to you, keep them for me that I may punish them."
,"11":"Show no pity to those who resist you. Hand them over to be massacred and plundered throughout all their lands."
,"12":"For, as truly as I live and by the power of my kingdom, I will carry out with my own hands what I have said."
,"13":"And you, do not disobey the words of your lord nor fail to carry them out exactly as I have instructed you. Do not change any of them.'"
,"14":"Holofernes went out from the presence of his lord and called together all the chiefs of staff, the generals and commanders of the army of Assyria."
,"15":"He gathered about a hundred and twenty thousand specially chosen men for the army as his lord had ordered him, and twelve thousand archers."
,"16":"He arranged them in battle positions."
,"17":"He took along camels, donkeys and mules to carry the baggage, and a great number of sheep, oxen, and goats for their food."
,"18":"He took a sufficient quantity of provisions for each man, and an abundant supply of gold and silver from the king's treasury."
,"19":"Then Holofernes set out on the march with all his army, with their chariots, cavalry and picked foot soldiers going ahead of King Nebuchadnezzar to cover all the lands to the West with this army."
,"20":"They were accompanied by a great crowd of people, so many were they that they were like locusts or the dust of the earth."
,"21":"After marching for three days from Nineveh, Holofernes and his men reached the plain of Bectileth where they encamped before the city, near the mountains to the north of Upper Cilicia."
,"22":"Then Holofernes took all his army, foot soldiers, cavalry and chariots, and marched into the mountain region."
,"23":"He utterly destroyed Put and Lud, and plundered all the land of Rassis and of Ishmael on the border of the desert to the south of the country of the Chaldeans."
,"24":"Then he followed the Euphrates, crossed Mesopotamia and destroyed all the cities high above the torrent of Abron until he reached the sea."
,"25":"He took possession of the land of Cilicia, and cut down all who opposed him, and arrived at the land of Japheth in the south toward Arabia."
,"26":"He surrounded all the children of Midian, burned their tents and destroyed their livestock."
,"27":"Then descending to the plain of Damascus at the time of the wheat harvest, he burned all their fields, scattered all their animals and killed the young ones, pillaged their villages, devastated their plains, and put all their young men to the sword."
,"28":"The fear and terror of him fell upon all the inhabitants of the seacoast, those in Tyre and Sidon, in Sur, Ocina and Jamnia. The people of Azotus and Ascalon also feared him."
}`)
	CurrentBook.AddChapter(3, `{
"1":"They therefore sent messengers to Holofernes offering him terms of peace:"
,"2":"'See, we consider ourselves as servants of Nebuchadnezzar, the great king, do with us as you will."
,"3":"All our farms, our whole territory, all our wheatfields, our oxen and our sheepfolds lie before you - use them as you please."
,"4":"See, our towns and all their inhabitants are yours, deal with them as you wish.'"
,"5":"These men went to Holofernes and repeated these words."
,"6":"Then Holofernes moved down to the seacoast with his army. He stationed garrisons in the hill cities and took from them men whom he chose as auxiliaries."
,"7":"The people of these cities received him, as did all the people of the surrounding countryside, with garlands, singing and dancing to the music of tambourines."
,"8":"Nevertheless, he still laid waste all their land, cut down their sacred woods and destroyed all their gods, that all people of all languages and nations might worship Nebuchadnezzar alone and proclaim him as god."
,"9":"Then he arrived opposite Esdraelon, near Dothan, facing the great chain of Judean hills."
,"10":"He encamped between Geba Scythopolis, and remained there a month in order to reorganize the provisions of his army."
}`)
	CurrentBook.AddChapter(4, `{
"1":"The children of Israel in Judea learned what had happened to the other nations at the hands of Holofernes, the chief general of Nebuchadnezzar, the king of the Assyrians, and how he had plundered the neighboring villages and destroyed their sanctuaries."
,"2":"And they trembled with great fear because of him. They were anxious about Jerusalem and the Temple of the Lord their God,"
,"3":"since they had only recently returned from exile. The people of Judea had just come together and the new furnishings of the Altar and the Sanctuary had just been consecrated after being profaned."
,"4":"They sent messengers to warn all the inhabitants of the territory of Samaria, Kona, Beth-horon, Belmain, Jericho, Choba and Aesora, and the valley of Salem."
,"5":"They occupied all the summits of the mountains, fortified the ramparts of the towns and prepared stores of foodstuff and provisions for the war, since their field had just been harvested."
,"6":"Joakim, the high priest, who was in Jerusalem in those days, wrote to the inhabitants of Bethulia and Betomesthaim opposite Esdraelon, at the entrance to the plain of Dothan."
,"7":"He told them to seize and fortify the mountain passes because it was by them that Holofernes would enter Judea. There it would be easy to stop those who were advancing since the narrow passes allowed no more than two men to go forward at a time."
,"8":"The children of Israel obeyed the orders of Joakim and of the Council of the Elders which assembled in Jerusalem."
,"9":"All the people of Israel called upon God with great fervor and humbled themselves before him."
,"10":"Men, women and children, including the animals, all the foreigners who resided among them, their laborers and slaves, all clothed themselves in sackcloth."
,"11":"All the men of Israel in Jerusalem, with their wives and children, bowed before the Temple, sprinkled ashes on their heads and held out their hands in supplication before the Lord."
,"12":"They covered the Altar in sackcloth, and with one voice earnestly begged the God of Israel not to let their children be massacred, their wives raped, their towns destroyed and their Sanctuary profaned, that they might not become the laughingstock of other nations."
,"13":"The Lord heard their prayer and looked upon their anguish. The people throughout the whole of Judea fasted for many days, and those in Jerusalem fasted before the Sanctuary of the Lord Almighty."
,"14":"The high priest Joakim, with all the priests and ministers, stood before the Lord dressed in sackcloth, and offered continual sacrifice, prayers and the voluntary gifts of the people."
,"15":"They put ashes on their turbans and cried out with all their strength to the Lord, asking him to watch over the whole house of Israel."
}`)
	CurrentBook.AddChapter(5, `{
"1":"It was reported to Holofernes that the people of Israel were prepared for war, that they had closed the mountain passes, fortified the ramparts on the summits of all the high mountains and placed blockades in the plains."
,"2":"Seething with anger, Holofernes called the leaders of the Moabites, the generals of Ammon and all the governors of the Seacoast,"
,"3":"and said to them, 'Tell me, sons of Canaan, who are these people living in the mountain region? Which towns do they inhabit? What is the strength of their army? In what does their power and strength consist? Who has been placed at their head as commander of their army?"
,"4":"Why have they not appeared before me like everyone else in the West?'"
,"5":"Achior, commander of the Ammonites, said to him, 'May my Lord listen to the word spoken by your servant, for I will tell you the truth about these people from the mountain region whom you now encounter."
,"6":"These people descend from the Chaldeans."
,"7":"They settled first in Mesopotamia, for they did not wish to worship any longer the gods of their fathers who lived in Chaldea."
,"8":"They abandoned the religion of their ancestors, and worshiped the God of Heaven, a God whom they had come to recognize. Because of this their fathers drove them out and they fled to Mesopotamia where they dwelt for a long time."
,"9":"Then their God told them to leave the country where they had settled and go to the land of Canaan. They went to live there, and acquired an abundance of gold and silver and numerous herds of cattle."
,"10":"There was famine throughout the land of Canaan, so they went down into Egypt where they remained as long as there was food. Then they became so numerous that their race could not be counted."
,"11":"But the king of Egypt rose up against them and tricked them into making bricks, and they were humiliated and made into slaves."
,"12":"They called upon their God who punished the whole of Egypt with such incurable plagues that the Egyptians drove them out."
,"13":"Then God dried up the Red Sea in front of them"
,"14":"and he led them along the route of Sinai and Kadesh Barnea. The Israelites drove all the inhabitants into the desert;"
,"15":"they inhabited the country of the Amorites and wiped out the Heshbonites. Then, having crossed the Jordan, they took possession of all the hill country,"
,"16":"driving out the Canaanites, the Perizzites, the Jebusites, the Shechemites, and the Gergesites, and they lived there for a long time."
,"17":"As long as they did not offend God, they prospered, because their God who hates wrongdoing was on their side."
,"18":"But when they strayed from the path he had set for them, they were completely annihilated in many battles, and they were led off into captivity in a country not their own. The temple of their God was leveled to the ground and their cities were occupied by their enemies."
,"19":"Now that they have turned again to their God, they have returned from exile from the various places in which they had been scattered. They have retaken Jerusalem where their Sanctuary is and they have settled in the mountain region because it has remained deserted."
,"20":"And now, Sovereign Lord, we must find out if there is any wrongdoing in this people."
,"21":"If they are sinning against their God, then we shall march against them and we shall conquer. But if there is no sinfulness in their nation, then, my Lord, turn aside from them for fear that their Lord and God will cover them with his shield and the whole world will witness our downfall.'"
,"22":"Now it happened that when Achior had finished speaking, all the people standing in a circle around the tent began criticizing and protesting. The officers of Holofernes and all the inhabitants of the seacoast and of Moab wanted to beat him black and blue. They said,"
,"23":"'We are not afraid of the children of Israel. Look, they are a people with no strength or energy to sustain a violent conflict."
,"24":"Let us go forth, and they will be like bread for your whole army, O Lord Holofernes!'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"When the tumult among the men standing around the tent had died down, Holofernes, general in chief of the Assyrian army, said to Achior in the presence of all the foreigners and all the people of Moab,"
,"2":"'Who are you, Achior, you and all the people bribed by Israel to prophesy against us as you have done today? Why do you counsel us not to make war on the race of Israel because their God will cover them with a shield? Who is God, if not Nebuchadnezzar. He will send out his army and wipe them off the face of the earth and their God will not save them."
,"3":"But we, the king's servants, will crush them as though they were just one man. They will not withstand the onslaught of our horses."
,"4":"We will burn the whole lot of them in their own homes. Their mountains will be soaked with their blood, their plains will be full of their dead. They will not be able to hold their ground before us. Most surely they will perish, as King Nebuchadnezzar, lord of all the earth, had foretold. He said it and the words he has uttered will not be in vain."
,"5":"But you, Achior, an Ammonite mercenary who has today uttered these words to your shame, from now on you will not see my face until I avenge myself on this race who came from Egypt."
,"6":"The sword of my soldiers and the lance of my officers will pierce your sides. When I return from battle, your body will be with all the dead of Israel."
,"7":"My servants will lead you into the mountain region and will deposit you in one of the towns which are on the slopes,"
,"8":"so that you will share the same fate as the rest of them."
,"9":"But if you believe that they will not be taken, then do not put on such a long face. I have spoken and not one of my words will be without effect.'"
,"10":"Holofernes ordered his guards who were standing in the tent to seize Achior, take him to Bethulia and hand him over into the hands of the Israelites."
,"11":"The servants seized him and took him outside the camp onto the plain; from the middle of the plain they took him towards the mountain country and reached the springs which were at the foot of Bethulia."
,"12":"When the men of the town at the top of the mountain saw them coming, they took their weapons, went out of the town to the summit of the mountain, and those who were armed with catapults tried to stop their ascent by slinging stones at them."
,"13":"The guards took shelter, tied up Achior and left him lying on the ground at the foot of the mountain. They then returned to their lord."
,"14":"The sons of Israel descended from the town and went up to Achior, and having untied him, they led him to Bethulia, and took him to the rulers of the town,"
,"15":"who in those days were Uzziah the son of Micah of the tribe of Simeon, Chabris the son of Gothoniel, and Charmis the son of Melchiel."
,"16":"As they called for a meeting of all the elders of the town, the young people and the women also joined the assembly. They placed Achior in the midst of the assembled people and Uzziah asked him what had happened."
,"17":"In reply he told them about the council meeting of Holofernes and all that he himself had said to the leaders of the Assyrians. He also told them of the threatening words of Holofernes against Israel."
,"18":"The people threw themselves down on the ground, worshiped God and called upon his help saying,"
,"19":"'Lord God of Heaven, take into consideration the insolence of the Assyrians and have pity on your humiliated people. Look this day upon those who are consecrated to you.'"
,"20":"They encouraged Achior and congratulated him warmly."
,"21":"Then Uzziah led him from the assembly into his own house and gave a meal for the elders. All through the night the people called upon the God of Israel, begging him to come to their aid."
}`)
	CurrentBook.AddChapter(7, `{
"1":"The next day Holofernes gave an order to the whole of his army and to those people who had come to his help to move camp in the direction of Bethulia, to occupy the mountain slopes and to wage war against the Israelites."
,"2":"All his valiant warriors moved that day; the forces of fighting men numbered one hundred and seventy thousand foot soldiers and twelve thousand cavalry, without counting the baggage and the men who looked after it as well as the crowd of people who accompanied them - a considerable crowd."
,"3":"They camped in the valley near Bethulia, near the spring; they spread out the whole width from Dothan to Belbain, and the length from Bethulia to Cyamon which faces Esdraelon."
,"4":"When the Israelites saw how numerous they were, they were extremely afraid and said to one another, 'Without doubt this crowd is going to devour all the country, neither the high mountains nor the ravines nor the hills will be able to put a stop to their progress.'"
,"5":"Nonetheless each one seized his fighting equipment; they lit fires on the tops of the towers and kept watch all that night."
,"6":"The second day, Holofernes lined up all his cavalry in front of the Israelites in Bethulia."
,"7":"He observed the approaches to their town, discovered the sources supplying water, seized them and stationed guards over them, then he returned to his army."
,"8":"The leaders of the Edomites, the commanders of the Moabites and the generals of the Seacoast approached Holofernes and said,"
,"9":"'Let our Master listen to us, and your army will not suffer loss."
,"10":"This people of Israel really do not put their trust in javelins but in the height of the mountains which they inhabit, for it is not easy to reach the summit of their mountains."
,"11":"Master, if you wish to save the lives of your men, do not fight against them in battle formation."
,"12":"Remain in your camp and keep all the men in your army safe but let us take possession of the spring which flows at the foot of the mountain,"
,"13":"because it is from there that the people of Bethulia draw all their water. They will be dying of thirst and so they will hand over their town. We and our people will scale the summits of the neighboring mountains and set up outposts to prevent anyone from leaving the town."
,"14":"The famine will destroy them; men, women and children will be lying dead in the streets of their town before ever the sword is raised against them."
,"15":"So you will have punished them severely for having rebelled and for not having come out to meet you with offers of peace.'"
,"16":"This advice pleased Holofernes and all his officers, and he agreed to do what they said."
,"17":"The Moabites, with five thousand Assyrians, moved camp; they encamped in the valley and cut off the springs and the water supply from the Israelites."
,"18":"The Edomites and the Ammonites climbed up and camped on the mountain near Dothan; they sent some of their men to the south and to the east facing Egrebel, near Chusi, which is on the torrent of Mochmur. The rest of the Assyrian army encamped in the plain, covering the whole countryside. The camp site covered by their tents and their bag-gage spread out wide for they were an enormous crowd."
,"19":"Disheartened, the people of Israel called upon the Lord their God because their enemies had encircled them and had cut off all means of escape."
,"20":"All the Assyrian army, its foot soldiers, its chariots and horsemen surrounded them for thirty-four days."
,"21":"The inhabitants of Bethulia saw the water jars becoming empty and the wells running dry so that drinking water had to be rationed every day."
,"22":"The small children became weak with thirst; the women and the young collapsed in the streets and gateways of the town."
,"23":"Then everyone - men, women, young people and children - gathered and accused Uzziah and the leaders of the town. They called out with loud cries and said before all the elders, "
,"24":"'May God judge between you and us, for you are the cause of this misfortune by not engaging in peaceful negotiations with the Assyrians."
,"25":"And now there is no one who can bring us any help; God has delivered us into the hands of these pagans in such a way that we lie dying before them from great thirst and misery."
,"26":"You must call on the Assyrians and let the whole army of Holofernes pillage us."
,"27":"It is better for us to become their booty, for then we shall become slaves, but at least we shall live and not have to see our women, our older children and the little ones die before our eyes."
,"28":"We urge you by heaven and earth and by our God, the Lord of our fathers, who punishes us according to our sins and the sins of our fathers: make this decision this very day.'"
,"29":"Altogether they raised a great lamentation in the midst of the assembly, and they cried out with a loud voice to the Lord God."
,"30":"Then Uzziah said to them, 'Have confidence, my brothers; hold out for five days more, during which time the Lord our God will show us his mercy, for he will not abandon us forever."
,"31":"If these days pass without his coming to our help, then we shall do what you say.'"
,"32":"Then he dismissed the men, each to his post, and they went towards the ramparts and the towers of the town, and he sent the women and children back to their homes. Now there was a great depression throughout the town."
}`)
	CurrentBook.AddChapter(8, `{
"1":"The news of what had happened came in those days to Judith, daughter of Merari, son of Joseph, of Oziel, of Elkiah, of Ananias, of Gideon, of Raphain, of Ahitub, of Elijah, of Hilkiah, of Eliab, of Nathanael, of Salamiel, of Sarasadai, of Israel."
,"2":"Her husband was Manasseh, of the same tribe and family. He had died during the harvesting of the barley"
,"3":"as he was supervising the reapers who were binding the sheaves on the plain; he suffered sunstroke, took to his bed and died in Bethulia, his town. He was buried with his ancestors in the field which lies between Dothan and Balamon."
,"4":"As a widow, Judith remained in her house for three years and four months."
,"5":"She had built a room on the rooftop of the house where she lived."
,"6":"She covered herself in sackcloth, put on widow's garments and fasted all the days of her widowhood with the exception of the eves of the Sabbath, the Sabbath day, the eves of the new moons, the days of the new moons, and all the celebrations of the people of Israel."
,"7":"She was exceedingly beautiful and very pleasing to look at. Manasseh, her husband, had left her gold, silver, servants, cattle and fields and she remained the owner of all this estate."
,"8":"No one could say anything evil of her because she greatly feared God."
,"9":"She heard of the threatening words which the people had addressed to their leaders because they were downcast, suffering from lack of water. Judith also heard all that Uzziah had promised in reply, how he had sworn to hand over their city to the Assyrians at the end of five days."
,"10":"So she sent the maidservant who looked after her affairs, to call Chabris and Charmis, two elders of the town, to come and see her."
,"11":"They came to her house and she said to them, 'Listen to me, you elders of Bethulia, for the words which you have spoken in front of the people today are not right. You did wrong to take an oath between God and yourselves, and to say that you would hand over the town to our enemies if, within a certain number of days, the Lord does not come to your help."
,"12":"Who are you to put God to the test and take God's place when you answered the people?"
,"13":"That is not the way to call for his mercy, but rather, one that leads to his wrath."
,"14":"For if you cannot probe the depths of the human heart nor know what a man is thinking, how can you understand the God who has made all things? Do you know his mind or understand his thoughts? No, my brothers, do not annoy the Lord our God."
,"15":"For if he does not wish to come to our help within these five days, he has the power to protect us for as many days as he wishes or else to annihilate us in front of our enemies."
,"16":"As for yourselves, do not challenge the designs of the Lord our God, for God cannot give in to threats as a man does, nor can any decision be imposed upon him as it can on the sons of men."
,"17":"That is why, while waiting patiently for him to save us, let us beg him to come to our help. He will listen to our plea, if it pleases him."
,"18":"For it has not happened in our generation nor is there among us today any tribe or family or people or city that worships gods made by human hands, as happened in days past."
,"19":"It was for that reason that our fathers were handed over to be slain by the sword and pillaged, and that they suffered great disaster at the hands of their enemies."
,"20":"But we do not recognize any other god than the One God, therefore let us hope that he will not look with contempt on us or on any of our race."
,"21":"If the enemies capture us, so in the same way, the whole of Judea will be taken; our Sanctuary will be pillaged and we will answer for its profanation with our blood."
,"22":"God will bring upon our heads the murder of our brothers, the bondage of our country and the devastation of our heritage. Wherever among the nations we shall be slaves, we shall be maltreated by those to whom we belong."
,"23":"Our enslavement will not be changed in our favor, but the Lord our God will turn it into dishonor."
,"24":"Now, my brothers, let us show our fellow countrymen that their lives depend on ours; that the safety of the Sanctuary, the Temple and the Altar rests with us."
,"25":"Much more, let us thank the Lord our God who is putting us to the test as he did our fathers."
,"26":"Remember what he did with Abraham, all the trials to which he subjected Isaac and all those that happened to Jacob in Mesopotamia of Syria where he looked after the sheep of Laban, his mother's brother."
,"27":"Is not God making us pass through fire as he did the others to prove their hearts? The Lord is not punishing us, but he scourges those who draw near to him in order to admonish them.'"
,"28":"Uzziah said to her, 'All that you have said has been said with wisdom and no one can contradict your words."
,"29":"In fact it is not just today that your wisdom is evident, but ever since your early days all the people have recognized your intelligence and the natural goodness of your heart."
,"30":"But the people were suffering great thirst so they forced us to carry out what we have said, and they have charged us with an oath which we cannot break."
,"31":"Since you are a devout woman, pray for us that the Lord will send rain to fill our reservoirs and we shall no longer be exhausted.'"
,"32":"Judith said to them, 'Listen to me, I will do something which will be handed down from generation to generation of the children of our race."
,"33":"Tonight you will stand at the gate of the town and I will go out with my maidservant and, by the end of the time which has been fixed for you to hand over the town to our enemies, the Lord will visit Israel through my hand."
,"34":"But do not try to find out what I shall do for I will not tell you, until I have fulfilled what I will do.'"
,"35":"Then Uzziah and the leaders said to her, 'Go in peace and may the Lord our God go before you so that you may take vengeance upon our enemies.'"
,"36":"Then, leaving Judith's room, they went back to their posts."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Judith knelt and bowed her head to the ground, put ashes on her head and uncovered the sackcloth with which she was clothed. At precisely the same moment as incense was being offered in the House of God at Jerusalem, Judith invoked aloud the Lord God, she said,"
,"2":"'Lord, God of my father Simeon, you placed a sword in his hand to punish the foreigners who did violence to a young girl. For they had abused her, uncovering her body to shame her and violating her womb to dishonor her. They did this though you said: This shall not be done."
,"3":"Because of this you handed over their leaders to be slain and their bed, reddened because of their deceit, was left red with their blood. You struck down the slaves with their leaders and the leaders themselves with their servants."
,"4":"You handed over their women to rape, their daughters to slavery and all their possessions to be shared among your favored sons who were filled with horror at this defilement of their blood and invoked your help."
,"5":"O God, my God, listen to me, a widow! It is you who made all things past, what is present and what is yet to come. It is you who consider things present and to come. Those things which you decided have been realized."
,"6":"The things you have planned have presented themselves saying: Here we are. In truth, all your ways are prepared and your decision is known from the beginning of time."
,"7":"Therefore see what a great multitude these Assyrians make with their army, how they pride themselves on their horses and their cavalrymen. They have placed great pride in the strength of their foot soldiers and their trust in their shields, javelins, bows and arrows."
,"8":"But they do not recognize that you, Lord, decide the outcome of wars. Lord is your name; wipe out their force with your power, and in your anger overthrow their superiority; for they intend to profane your Sanctuary, to defile your Tabernacle where your glorious Name resides, to overturn by force the horn of your Altar."
,"9":"Consider their pride, let your anger fall on their heads and give to my hands, the hands of a widow, the strength necessary for what I have decided."
,"10":"By my lying lips punish the slave with his master and the master with his servant; put an end to their arrogance by the hand of a woman."
,"11":"Truly your strength is not in number nor your power in strong men for you are a God of the humble, the defender of the little ones, the support of the weak, the protector of the abandoned, the savior of those in despair."
,"12":"Yes, God of my fathers and God of the heritage of Israel, Ruler of the heavens and the earth, Creator of the waters, King of all creation, listen to my prayer."
,"13":"Give me tempting words to wound and kill those who have conceived cruel designs against your Covenant, your consecrated House, Mount Zion and the House which belongs to your sons."
,"14":"Make the nation and all the tribes know that you are God, all-powerful and strong, and that, apart from you, there is no other protector for the people of Israel.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"When Judith had finished her prayer to the God of Israel,"
,"2":"she rose from the ground, and after calling her maidservant, she went down into the house where she usually spent the sabbath days and the feasts."
,"3":"She took off the sackcloth and her widow's clothes in which she was dressed. She washed her whole body with water, anointed it with rich perfume, combed her hair and placed a jewelled band around it. She dressed herself in the beautiful garments she had been accustomed to wear when her husband, Manasseh, was living."
,"4":"She put sandals on her feet, put on her anklets, bracelets and rings, her earrings and all her jewels. She made herself extremely beautiful in order to attract the attention of the men who would see her."
,"5":"She gave the servant a skin of wine and a jar of oil, she filled a bag with flour made from barley and some small cakes made from dried figs and fine flour. She wrapped up all these things and put the maid in charge of them."
,"6":"Then they set out in the direction of the gate of the town of Bethulia where they found stationed Uzziah and the elders of the town, Chabris and Charmis."
,"7":"As soon as the men saw her, her face so transformed and her clothes so different, they were full of admiration for her beauty and said to her,"
,"8":"'May the God of our fathers grant that you may find favor and that your undertakings may be successful for the glory of the sons of Israel and the exaltation of Jerusalem.',She adored God and said to them, "
,"9":"'Command that the gate of the town be opened for me and I will go forth in order to accomplish what you have just said.' They ordered the young men to open the gate as she had asked."
,"10":"They carried out the command and Judith went out with her maidservant. The townsmen watched her until she reached the foot of the mountain and crossed the valley, then they lost sight of her. "
,"11":"Judith and the maid walked straight through the valley and a sentry for the Assyrians came to meet them."
,"12":"He stopped them and asked, 'Who are you? Where have you come from? Where are you going?' She replied, 'I am a daughter of the Hebrews; I am fleeing far from them because they are on the point of handing themselves over to be despoiled by you."
,"13":"I have come to present myself to Holofernes, the general-in-chief of your army, to speak to him in all sincerity. I will show him a way by which he can advance and become master of the whole mountain without losing a single man either from injury or loss of life.'"
,"14":"As soon as the men had heard her words and noticed her face (for she was strikingly beautiful) they said to her,"
,"15":"'You have saved your life by hurrying to present yourself before our lord. Approach his tent; certain men from among us will accompany you until they have handed you over safely into his hands."
,"16":"When you stand before him, do not have any fear in your heart, but tell him what you have to say and he will treat you well.'"
,"17":"They chose one hundred men from their number; these men accompanied Judith and the maid and led them to the tent of Holofernes."
,"18":"In the whole camp the news of her arrival spread from tent to tent, and throughout the whole camp men came running. They made a circle round her as she stood waiting outside Holofernes' tent while someone informed him of her arrival."
,"19":"They were captivated by her beauty and, on seeing her, they praised the sons of Israel and said to one another, 'Who can look down on the people who have such women? It would be a mistake to leave one man alive; they would be able to deceive the whole world.'"
,"20":"Those who were sleeping near Holofernes and all his officers came out and led her into the tent."
,"21":"Holofernes was lying on his bed under hangings of purple and gold set with emerald and precious stones."
,"22":"Having been informed about her, he moved towards the entrance of the tent, with silver lamps carried before him."
,"23":"As Judith came before him and his officers, they all admired the beauty of her face. Throwing herself face downwards to the ground, she bowed before him; the servants of Holofernes raised her up."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Holofernes said to Judith, 'Have confidence, woman, have no fear in your heart, I do not harm any person who has chosen to serve Nebuchadnezzar, king of all the earth."
,"2":"And, if those of your people who dwell on the mountain had not ignored me, I should not have raised my sword against them; but they have brought this upon themselves."
,"3":"Now, tell me why you have fled from their midst and have come to us. Are you doing this to save yourself? Have confidence, your life is safe tonight and also in the future."
,"4":"No one will harm you, you will be well-treated as are all the servants of my lord, King Nebuchadnezzar.'"
,"5":"Judith replied, 'Listen to the words of your servant, so that I may speak freely in your presence and I will not lie to my lord tonight."
,"6":"And if you follow the advice of your servant, everything will be accomplished by the hand of God and my lord will not fail in his undertakings."
,"7":"For just as truly as Nebuchadnezzar is king of all the earth and his presence is felt, and he has sent you for the correction of others, it is thanks to your power that not only do men serve him but also wild beasts, animals and the birds of the air live for Nebuchadnezzar and all his house."
,"8":"We have heard of your wisdom and prudence of mind and it is said throughout the world that you alone are the bravest man in the kingdom, powerful because of your knowledge and outstanding in military strategy."
,"9":"We have heard about the discourse delivered in your council by Achior, and of its terms, because the men of Bethulia took him in and he reported to them all that he had said in your presence."
,"10":"Now all-powerful lord, do not dismiss what he said but keep it in mind because it is true. Our nation will never be punished nor the sword used against it unless its people sin against their God."
,"11":"Yet my lord will not be driven back and fail. Death will overtake them, for they have fallen into the sin that arouses the anger of God every time they commit it."
,"12":"As a result of the shortage of food and water, they have decided to lay hands on their animals. They have resolved to eat those things which God in his laws forbade them to eat, including the first fruits of the harvest and the tithes of wine and oil which, after their consecration, had been put aside for the priests who minister before the face of our God in Jerusalem."
,"13":"They have decided to consume these things completely, although it is not lawful for any of the people even to touch them with their hands."
,"14":"They have sent messengers to Jerusalem - for those who dwell there have also done this - and they have charged these men to bring back this permission from the Council of the Elders."
,"15":"Now it will come to pass that when this permission arrives and the people will have acted upon it, on that same day they will be delivered over to you for their destruction."
,"16":"That is why I, your servant, having understood all this, have fled far from them. God has sent me to bring about, along with you, deeds that will strike terror throughout the whole world and cause those who hear them to talk."
,"17":"For your servant is a pious woman who serves God night and day. From now on I will remain near you, my lord. Each evening I will go out towards the ravine and I will pray to God and he will tell me when they have fallen into sin."
,"18":"Then I will report this to you, so that you will go forth with your whole army and there will be no man able to withstand you."
,"19":"Then I will lead you through Judea until I arrive in Jerusalem where I will set up your tent. You will lead them like sheep without a shepherd and not one dog will growl at you. I have been given a premonition of these things. It has been revealed to me, and I have been sent to make it known to you.'"
,"20":"Her words pleased Holofernes and all his officers. They admired her wisdom and said,"
,"21":"'From one end of the earth to the other there is no woman like her for the beauty of her face and the wisdom of her words.'"
,"22":"Holofernes said to her, 'God has done well to send you ahead of this people to show them that the power is in my hands and that destruction is the fate of those who despised my lord."
,"23":"You are beautiful to look at and prudent in your words: if you do as you have said, your God shall be my God and you will live in the house of King Nebuchadnezzar, and be famous throughout all the world.'"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Then Holofernes had her brought into the place where his silver dishes were laid out and commanded them to serve her from his food and to give her his wine to drink."
,"2":"But Judith said, 'I will not eat it for fear that it might be the occasion of my downfall. What I have brought with me is sufficient.'"
,"3":"Holofernes said to her, 'When you have finished the things that you have brought, where will we be able to get the same kind of food to give you, for there is no one of your race here?'"
,"4":"Judith said to him, 'As your soul lives my lord, your servant will not have finished what I have brought with me before the Lord will have carried out by my hand what he has decided to do.'"
,"5":"Then the officers of Holofernes led her to the tent and she slept until midnight. She arose at the morning watch"
,"6":"and sent a message to Holofernes, 'Will my lord command that his servant be allowed to go out to pray.'"
,"7":"Holofernes ordered his bodyguards not to prevent her from doing so. She remained in the camp three days. Each night she went to the ravine of Bethulia and bathed herself in the spring which was in the camp. "
,"8":"When she returned to the tent, she prayed to the Lord, the God of Israel, that he would guide her steps in the right path to bring about the release of her people;"
,"9":"and now purified, once she had returned, she remained in the tent until she took her food towards evening."
,"10":"Then on the fourth day, Holofernes gave a banquet for his personal servants without sending invitations to any of his officers."
,"11":"He said to the eunuch Bagoas who looked after his affairs, 'Go and persuade this Hebrew woman who is under your care to come eat and drink with us,"
,"12":"for it would be a disgrace if we allowed such a woman to depart without having enjoyed her company. If we are not able to allure her, she will laugh at us.'"
,"13":"So Bagoas left Holofernes and entered Judith's tent, and said to her, 'Will this beautiful slave not hesitate to come to my lord's tent to be honored in his presence, merrily to drink wine with us and to become this very day like an Assyrian woman who dwells in the house of Nebuchadnezzar?'"
,"14":"Judith said to him, 'Who am I to go against the wishes of my Lord? All that pleases him I will hasten to do and that will be for me a joy until the day of my death.'"
,"15":"Then she arose; she dressed in her beautiful garments and all the finery of a woman. Her servant went and spread on the ground, in front of Holofernes, the fleece which Judith had received from Bagoas for her daily use so that she could recline on it while she ate."
,"16":"So Judith entered the tent and took her place. The heart of Holofernes was ravished by her beauty, his whole being was captivated and he had a passionate desire to possess her. Ever since the first day he had seen her, he had been waiting for an occasion to seduce her."
,"17":"Holofernes said to her: 'Drink and share our happiness.'"
,"18":"Judith said, 'I will drink then, my lord, because today my life has become more precious to me than on any other day since my birth.'"
,"19":"She took what her servant had prepared for her and ate and drank in front of him."
,"20":"Holofernes was bewitched by her and he drank a great quantity of wine, much more than he had ever drunk on any single day since his birth."
}`)
	CurrentBook.AddChapter(13, `{
"1":"When it was late, the servants hurried away. Bagoas dismissed from the presence of his master those who were standing around, and closed the tent from the outside. All the men hurried to bed for they were tired from having drunk too much."
,"2":"So Judith was left alone in the tent with Holofernes who, sodden with wine, had collapsed onto the bed."
,"3":"Judith told her servant to stand outside the room and watch for her coming out because she would go out to pray, as she did each day. She also spoke to Bagoas in much the same way."
,"4":"Everyone left the tent of Holofernes, not one - small or great - remained in the room. Judith, then, stood by Holofernes' bed and prayed in her heart, 'Lord God all-powerful, help me now in what I will do for the glory of Jerusalem."
,"5":"For now is the time to support the cause of your people and to ensure that my undertaking brings about the ruin of the enemies who are drawn up against us.'"
,"6":"Then she moved towards the bedpost near Holofernes' head and took down the sword and,"
,"7":"approaching the bed, she seized the hair of his head saying, 'O Lord God of Israel, give me strength, this very moment!'"
,"8":"Then with all her strength she struck his neck twice and cut off his head."
,"9":"She then rolled his body from the bed and took off the hangings from the columns. Then she went out at once and gave the head of Holofernes to her servant"
,"10":"who put it in the bag in which she carried the food. Then they went out together as they used to do for prayer. After they had crossed the camp, they passed round the edge of the ravine, climbed the mountain to Bethulia and reached the gates of the town."
,"11":"Judith called from a distance to those who were keeping guard at the gates, 'Open, open the gates! God, our God, is with us! Today he has once again worked a miracle in Israel and exerted his power against our enemies.'"
,"12":"As soon as the townsfolk heard her voice, they called the elders and hurried down to the gates of the town."
,"13":"They all ran together, from the smallest to the greatest, for they were waiting for her return. They opened the gates and welcomed the two women; then, having lighted a fire so as to see them, they gathered around the two."
,"14":"She said to them in a loud voice, 'Praise God, praise him! Praise God who has not withheld his mercy from the House of Israel. This very night he has crushed our enemies by my hand.'"
,"15":"And, taking out the head of Holofernes from the bag, she showed it to them saying, 'Here is the head of Holofernes, general-in-chief of the Assyrian army, and here are the hangings under which he was lying in his drunkenness. The Lord has struck him down by the hand of a woman."
,"16":"As truly as the Lord lives, it was my face that seduced him to his undoing, but the Lord has protected me. This man could not sin with me to disgrace or dishonor me.'"
,"17":"All the people were greatly amazed, so they bowed down and worshiped God, saying with one voice, 'Blessed are you, our God, who today have crushed the enemies of your people.'"
,"18":"Uzziah said to her, 'My daughter, may the Most High God bless you more than all women on earth. And blessed be the Lord God, the Creator of heaven and earth, who has led you to behead the leader of our enemies. "
,"19":"Never will people forget the confidence you have shown; they will always remember the power of God."
,"20":"May God ensure your everlasting glory, and may he reward and bless you for you have risked your life when your race was humiliated. You chose instead to do the best before God in order to prevent our downfall.',And all the people said, 'Amen! Amen!'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Judith said to them, 'Listen, my brothers, take this head and hang it from the battlements of our rampart,"
,"2":"then when dawn breaks and the sun rises over the earth, let each of you take his weapons and let all those able to fight go outside the town. And under the command of a captain, proceed as if you were about to go down into the plain in the direction of the Assyrian outposts, but you will not descend."
,"3":"The Assyrian guards will seize their arms, and go towards their camp to awaken the generals of the Assyrian army. These officers will run to the tent of Holofernes but will not find him; fear will then come upon them and they will flee from you."
,"4":"Then you and all those who dwell in the land of Israel will follow them and strike them down as they go."
,"5":"But, before you do this, call Achior the Ammonite so that he may see and recognize the one who despised the people of Israel, the man who sent him to you as to his death.'"
,"6":"Achior was brought from the house of Uzziah. As soon as he arrived and saw the head of Holofernes in the hand of one of the people, he fainted and fell face down on the ground."
,"7":"When they had lifted him up, he threw himself at the feet of Judith, bowed before her and said, 'May you be blessed throughout Judea and among all the nations, who on hearing your name will be amazed."
,"8":"But now, tell me all that you did during these days.',Standing in the midst of the people, Judith told him all that she had done from the day she set out until the moment in which she was now speaking to them. "
,"9":"When she had finished talking, the people cried out with great joy, and this was heard throughout the town."
,"10":"When Achior saw all that the God of Israel had done, he immediately believed in him. He was circumcised and became a member of the community of Israel down to this day."
,"11":"When the sun had risen and they had hung Holofernes' head on the rampart, all the men took their arms and went out in groups to the mountain slopes."
,"12":"As soon as the Assyrians saw them, they warned their commanders. These men, in turn, went to inform the generals, the captains and all their officers."
,"13":"Then they all went to the tent of Holofernes and said to the steward in charge of his affairs, 'Waken our Lord, for the slaves plan to come down and fight against us to their utter destruction."
,"14":"So Bagoas drew back the curtain and knocked, thinking that Holofernes was sleeping with Judith."
,"15":"As no one answered, he entered the room, and found Holofernes lying across the wooden footstool dead with his head cut off."
,"16":"He cried out with a loud voice and tore his clothes."
,"17":"He entered the tent where Judith had stayed but did not find her. Then he rushed out to the troops, shouting,"
,"18":"'The slaves have deceived us! One Hebrew woman has put to shame the army of King Nebuchadnezzar, for Holofernes lies dead on the ground."
,"19":"When the officers of the Assyrian army heard these words, they were greatly distressed. They tore their garments and cried out with a loud voice in their camp."
}`)
	CurrentBook.AddChapter(15, `{
"1":"When those who were in the camp heard the cries, they were astounded."
,"2":"Terror and fear fell on them, they no longer controlled themselves but at the same moment they all broke rank and fled by way of the roads across the plain and the mountain."
,"3":"Those who were encamped in the mountains around Bethulia also began to flee. Then the men of Israel, all among them who were capable of fighting, fell on them."
,"4":"Uzziah sent messengers to Betomasthaim, Choba, Kona, and throughout the land of Israel, to announce what had happened and to invite them all to fall upon the enemy and destroy them."
,"5":"When the men of Israel heard this, they threw themselves on the enemy and pursued them as far as Choba. Even those from Jerusalem came, as well as those from all the mountainous region, because they were told what had happened in the camp of their enemies. Those from Gilead and from Galilee caught them on the flank and struck great blows against them until they reached Damascus and its surrounding territory."
,"6":"As for the inhabitants of Bethulia who remained behind, they rushed into the Assyrian camp, pillaged it and thereby greatly enriched themselves."
,"7":"Once they returned from the carnage, the Israelite men took possession of what remained. Also the people from the villages and farms in the mountains and on the plains seized great booty because there was plenty that they could get."
,"8":"Then the high priest Joakim and the council of the Elders of Israel in Jerusalem came to hear the good things which the Lord had done for Israel, and to see Judith and congratulate her."
,"9":"As soon as they had approached her they blessed her all together and said, 'You are the pride and joy of Jerusalem! You are the glory of Israel. You are the honor of our people. "
,"10":"You alone have accomplished all this. You have done great things for Israel and God has blessed your work. May the almighty Lord bless you forever.',And all the people said, 'Amen!'"
,"11":"All the people pillaged the camp for thirty days. They gave Holofernes' tent to Judith, with all his silver, his beds, his drinking vessels and all his furniture. She took them, and after harnessing her mule, she prepared her chariots and piled up all these goods in them."
,"12":"All the Israelite women also ran out to see her, they blessed her and a number of them formed a choir in her honor. She took olive branches in her hand and gave some to the women who accompanied her."
,"13":"She and the women with her made crowns of olive leaves. Then she went ahead of the people, leading the women in dance. All the Israelite men followed, clad in their armor, carrying crowns and loudly chanting hymns."
,"14":"Then Judith intoned this hymn of thanksgiving and the entire people of Israel echoed this praise."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Judith said, 'Sing a song to my God with tambourines, sing in honor of God with cymbals. Compose for him a psalm of praise. Exalt and bless his Name!"
,"2":"The Lord is truly a God who crushes war, who encamps in the midst of his people,for he has snatched me from the hand of those who pursued me."
,"3":"The Assyrian came from the mountains of the north. He came with the myriads of his army, his soldiers have filled the torrents,and his cavalry covered the hills."
,"4":"He wanted to burn my land, to kill the young men by the sword, to destroy my children at the breast, to hand over my little ones to slaughter,and to rape my young maidens."
,"5":"The Lord Almighty has driven them back by the hand of a woman."
,"6":"Their hero has not been overcome by young warriors; he was not struck down by the sons of the Titans, or laid low by any great giants. But it is Judith, the daughter of Merari, who by the beauty of her face has defeated him. For the relief of the oppressed in Israel "
,"7":"she took off her widow's robes, anointed her face with perfume,"
,"8":"put a jewelled band around her hair, and put on a linen dress in order to seduce him."
,"9":"Her sandals delighted his eyes, her beauty captivated his soul, and the scimitar cut through his neck."
,"10":"The Persians trembled with fear at her boldness, and the Medes were upset by her daring."
,"11":"Then my oppressed people shouted for joy; my weak ones cried out, the enemy was terrified; they raised their voices; the enemy took to flight."
,"12":"The children of young women pierced them through and struck them down like fugitives, and so the enemy perished in a battle,arranged by God."
,"13":"I will sing to my God a new song: Lord, you are great and glorious, wonderfully strong, invincible!"
,"14":"May the whole of your creation serve you, for you spoke and all things were, you sent forth your spirit and all things came into being: No one can resist your voice."
,"15":"For the mountains with the waters will be shaken to their foundations, the rocks will melt like wax before you, but to those who fear you,you will always show mercy."
,"16":"The fragrance of any sacrifice is little to please you,and the holocausts of fatted animals,are as nothing before you, but he who fears the Lord is forever great."
,"17":"Woe to the nations which rise up against my people: The Lord Almighty will punish them in the day of judgment, with fire and worms under their skin, and they will keep on weeping, suffering forever.'"
,"18":"When they arrived in Jerusalem, they worshiped God and, when the people had been purified, they presented their holocausts, freewill offerings and gifts."
,"19":"Then Judith offered all of Holofernes' belongings which the people had given her and she dedicated to the Lord the hangings from his room which she herself had taken."
,"20":"So the people remained in Jerusalem, rejoicing before the Sanctuary for three months and Judith stayed with them."
,"21":"After these days were over, each one returned to his own house. Judith returned to Bethulia and devoted herself to her household. During her lifetime she was famous throughout the land."
,"22":"Though many desired to marry her, she had no relation with any man since the death and burial of Manasseh, her husband."
,"23":"She spent her old age in the house of her husband. And she set her maidservant free. She died in Bethulia at the age of a hundred and five and was buried in the grave of Manasseh, her husband."
,"24":"All Israel mourned for her for seven days. Before her death she had divided her property among the relatives of her husband, Manasseh, and those of her own family."
,"25":"No one again threatened the people of Israel while Judith lived, nor for a very long time after her death."
}`)

}
func EN_CCB_LoadVHNHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"The words of Nehemiah, son of Hacaliah. In the month of Chislev, in the twentieth year of King Artaxerxes, I was in the Citadel of Susa when"
,"2":"Hanani, one of my brothers, came with some men from Judah. I asked them about the Jewish survivors who had returned from exile and about Jerusalem."
,"3":"They answered me, 'The people now live there in the province, in the midst of great poverty and shame. The wall of Jerusalem is broken down and its gates burned.'"
,"4":"When I heard these words, I sat down, wept and mourned for days. I fasted and prayed before the God of heaven."
,"5":"And I said, 'O Yahweh, God of heaven, you are fearsome and great. You keep your covenant and your kindness towards those who love you and fulfill your commandments. "
,"6":"May your ears be attentive and your eyes open to listen to the prayer of your servant!,I am now in your presence day and night, for your servants, the children of Israel. I confess to you the sins we children of Israel have committed against you: I myself and the family of my father have sinned. "
,"7":"We have acted very badly. We did not fulfill your commandments, laws and instructions which you gave to your servant Moses."
,"8":"But remember, too, what you said to Moses: If you are not faithful to me, I will scatter you among the nations."
,"9":"But if you fulfill my commandments and put them into practice, I shall again lead you back to the place where I have chosen to dwell. I shall gather you, though you be dispersed to the ends of the world."
,"10":"So then, Lord, do not forget that they are your servants; they are your people, whom you have saved with your great power and strong hand."
,"11":"Listen to my prayer and to the prayer of those who only wish to honor your Name. I ask you to help me now. May I be well received by the king.',I was then in charge of preparing the drinks of the king."
}`)
	CurrentBook.AddChapter(2, `{
"1":"In the month of Nisan, in the twentieth year of King Artaxerxes, I was doing my duty as cupbearer. I took up the wine and gave it to the king. I had never been sad before the king in the past."
,"2":"So, the king said to me, 'Why do you look sad? You don't look sick. Is there something that bothers you?',I became hesitant. "
,"3":"And I said, 'May the king live forever! How could I afford not to be sad when the city where my fathers are buried lies in ruins and its gates are burned down?'"
,"4":"The king said to me, 'What do you want, then?' I asked help of God from heaven and"
,"5":"said to the king, 'If it seems good to the king and if he is pleased with my work, then may he send me to the land of Judah, to the city where my fathers are buried, that I may rebuild it.'"
,"6":"The queen was sitting beside the king, and the king asked me, 'How long will you be gone? When will you be back?' I told him the date and he allowed me to leave."
,"7":"And I said to the king, 'If it pleases the king, may you give me letters for the governors of the province at the other side of the River that I may travel to Judah,"
,"8":"and also a letter to Asaph, the caretaker of the king's forest, for I will need wood for the gates of the Citadel near the Temple, for the walls of the city and for the house where I shall live.',The good hand of God was sup-porting me, so that the king gave me what I asked. "
,"9":"I went to the governors at the other side of the River, and delivered to them the letters of the king. The king had ordered that I be accompanied by officers of the army and horsemen."
,"10":"But in Jerusalem, Sanballat the Horonite and Tobiah, the Ammonite servant, came to know of my arrival and it displeased them that someone had come to help the Israelites."
,"11":"I came to Jerusalem and was there for three days."
,"12":"Then I arose in the night, accompanied by a few men, without telling anyone what my God had inspired me and what I planned to do in Jerusalem. Bringing along only the horse on which I rode, "
,"13":"I went out by night by the Gate of the Garbage Dump, I inspected the ruined wall of Jerusalem and the burned gates."
,"14":"I went on to the Fountain Gate and the King's Reservoir, but my horse could not pass through anywhere."
,"15":"So I went up, in the night, by the ravine. I inspected the wall and turned back, entering by the Valley Gate. So I returned to the house. "
,"16":"The counselors did not know where I had been or what I was doing. Until that time I had not yet told any of the Jews or the counselors, or the priests or the nobles, or any of those in public office."
,"17":"Then I said to them, 'You your-selves see the misery we are in because Jerusalem lies in ruins and its gates burned. Come, let us rebuild the walls of Jerusalem, and put an end to this humiliating situation.'"
,"18":"And I recounted to them how the good hand of God had helped me, and what the king had told me. Everyone said, 'Let us begin the work.' And they encouraged one another to make this good work a reality."
,"19":"Sanballat the Horonite, Tobiah the Ammonite and Geshem the Arab heard of this. They laughed at us and came to tell us, 'What are you doing? You are rebelling against the king.'"
,"20":"I answered them, 'The God of heaven shall grant us success. We, his servants, are now going to build. But as for you, you have neither right nor inheritance nor anything to do with Jerusalem.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"The high priest Eliashib and his brothers, the priests, were entrusted with the building of the Sheep Gate. They built it, set its doors and continued as far as the Tower of Hananel."
,"2":"The people of Jericho worked at their side, and farther on, Zaccur, son of Imri."
,"3":"The Fish Gate was assigned to the sons of Hassenaah. They set up and fixed its doors, bolts and bars."
,"4":"Next to them, Meremoth, son of Uriah, son of Hakkoz, and Meshullam, son of Berechiah, son of Meshezabel built the next section and at their side, Zadok, son of Baana, repaired another section."
,"5":"At their side, the inhabitants of Tekoa worked, but their nobles wanted not to labor in the service of their Lord."
,"6":"The Old Gate was repaired by Joiada, son of Paseah, and Meshullam, son of Besodeiah. They set up and fixed the gate with its bolts and bars."
,"7":"Next to them worked Malatiah of Gibeon and Yadan of Meronot with the people of Gibeon and Mizpah, beside the house of the provincial governor."
,"8":"Next to them worked Uzziel, of the jewellers' guild. Next were Hananiah, of the perfumers' guild: they strengthened Jerusalem as far as the Wall of the Square."
,"9":"Next to them repairs were carried out by Rephaiah son of Hur, ruler of half the district of Jerusalem."
,"10":"Next to them Jedaiah son of Harumaph worked opposite his own house; next to him repairs were carried out by Hattush son of Hashabneiah."
,"11":"Malchijah son of Harim and Hasshub son of Pahath-moab repaired the next section as far as the Tower of the Furnaces."
,"12":"Next to them worked Shallum son of Hallohesh, ruler of half the district of Jerusalem, he and his daughters."
,"13":"Hanun and the inhabitants of Zanoah repaired the Valley Gate; they restored it, constructed its framework and set its doors, bolts and bars in place, and repaired a thousand cubits of wall up to the Dung Gate."
,"14":"Malchijah son of Rechab, ruler of the district of Bethhaccherem, repaired the Dung Gate, he and his sons: he set its doors, bolts and bars in place."
,"15":"Shallum, son of Colhozeh, ruler of the district of Mizpah, worked at the Fountain Gate; he built it, covered it, and set its doors, bolts and bars in place. He also rebuilt the wall of the conduit cistern, adjoining the king's garden, as far as the steps coming down from the Citadel of David."
,"16":"Next to him, Nehemiah son of Azbuk, ruler of half the district of Beth-zur, worked up to a point opposite the tombs of David, the artificial pool and the House of Heroes."
,"17":"Next to him worked the Levites: Rehum son of Bani and next to him Hashabiah, ruler of half the district of Keilah, for his own district."
,"18":"Next to them worked their brothers: Binnui son of Henadad, ruler of half the district of Keilah;"
,"19":"next to him, Ezer son of Jeshua, ruler of Mizpah, opposite the slope up to the Armory, towards the Angle."
,"20":"Next to him Baruch son of Zabbai worked from the Angle as far as the door of the house of Eliashib the high priest."
,"21":"Next to him Meremoth son of Uriah, son of Hakkoz from the door of Eliashib's house to its farther end."
,"22":"Next to him worked the priests who lived there."
,"23":"Next to them worked Benjamin and Hasshub, opposite their own houses. Next to them Azariah son of Maaseiah, son of Ananiah, beside his own house."
,"24":"Next to him Binnui son of Henadad from the house of Azariah up to the Angle."
,"25":"Next to him Palal son of Uzai worked opposite the corner of the tower jutting out over the upper palace of the king near the prison courtyard. Next to him Pedaiah son of Parosh worked"
,"26":"as far as the Water Gate, in an easterly direction and up to a point opposite the projecting tower."
,"27":"Next to him the men of Tekoa worked opposite the great tower as far as the wall of Ophel."
,"28":"From the Horse Gate onwards repairs were carried out by the priests, each opposite his own house."
,"29":"Next to them worked Zadok son of Immer opposite his own house. Next to him Shemaiah son of Shecaniah, keeper of the East Gate."
,"30":"Next to him Hananiah son of Shelemiah and Hanun sixth son of Zalaph. Next to him son of Berechiah worked opposite where he lived."
,"31":"Next to him Malchijah, of the goldsmiths' guild, repaired as far as the quarters of the helpers and the merchants, opposite the Watch Gate as far as the high chamber of the corner."
,"32":"And between the high chamber of the corner and the Sheep Gate repairs were carried out by the goldsmiths and the merchants."
,"33":"When Sanballat heard that we were rebuilding the wall, he became angry. He ridiculed the Jews"
,"34":"and said before his brothers and the lords of Samaria, 'What are those miserable Jews trying to do? Are they perhaps going to rebuild, finish and celebrate the inauguration in a single day? Do they think they can make stones out of heaps of ruins?'"
,"35":"Tobiah the Ammonite who was by him said, 'Let them build, for if any fox goes up on their wall, it will surely collapse.'"
,"36":"Listen, O our God, for we are despised! May their insult fall back upon their own heads; give them up to contempt in a land where they shall be exiled!"
,"37":"Do not cover their guilt nor let their sin be blotted out in your presence, for they have offended those who built."
,"38":"The people worked with all their hearts and we finished half the wall's height."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Sanballat, Tobiah, the Arabs, the Ammonites and the residents of Azotus saw that the repair of the wall was advancing, and that we had begun covering the holes."
,"2":"They were greatly enraged, and all of them agreed to attack Jerusalem and humiliate me."
,"3":"So we prayed to our God, and set a guard day and night."
,"4":"The people of Judah said, 'The strength of the bearers is already failing, and much debris still remains; we can never rebuild the wall.'"
,"5":"And our enemies said, 'We will take them by surprise before they know it. We will kill them and stop their work.'"
,"6":"But some Jews who lived with them came to notify us about this. Ten times they said to us, 'From all the places where they live, they shall set out against us.'"
,"7":"So I ordered that people be sta-tioned behind the wall, there in the lowest part. I stationed them by families, with their swords, spears, and bows."
,"8":"They were afraid, but I stood up and said to the nobles, the counselors and the rest of the people, 'Remember the Lord, great and magnificent, and fight for your brothers, sons and daughters, wives and homes.'"
,"9":"When our enemies learned that we had been notified, that God willed that their plans be thwarted, we all returned to the wall, each one to his work."
,"10":"But from that day on, only half of my men worked while the other half, with bows, spears, shields and armor, stood behind all the people of Judah"
,"11":"building the wall. The bearers picked up their loads with one hand because they held a weapon with the other hand."
,"12":"Each of the builders had his sword girded at his side as he worked. Beside me was the man assigned to sound the trumpet. "
,"13":"I told the nobles, the counselors and the rest of the people, 'The extent of the work is great and we are scattered along the wall, far from one another,"
,"14":"so when you hear the sound of the horn, come to our aid at once and our God shall fight for us.'"
,"15":"So we scheduled the work from daybreak till the stars came out, half of us with weapons in hand."
,"16":"I also said to the people, 'Everyone shall spend the night within Jerusalem, with his servants. So we may keep guard by night and work by day.'"
,"17":"Yet my brothers, my men, the men of the guard who followed me, and I did not take off our clothes when we slept. Everyone kept his weapon with him."
}`)
	CurrentBook.AddChapter(5, `{
"1":"The common people and their wives presented very serious complaints against their Jewish brothers."
,"2":"Some of them said, 'We have big families and we need wheat to eat for strength to live.'"
,"3":"Others cried out, 'We have to mortgage our fields, vineyards and houses to get grain because of this famine.'"
,"4":"Others said, 'We have borrowed money on account of our fields and vineyards in order to pay the tax to the king."
,"5":"Though we are of the same race as our brothers and our children are not different from their children, we have to give our sons as slaves; even many of our daughters are now regarded as concubines. And we do not have any other solution, inasmuch as our fields and vineyards have passed on to others.'"
,"6":"Those complaints and accusations filled me with indignation"
,"7":"and I reproached the nobles and the counselors,"
,"8":"saying to them, 'Why do you not have compassion on your brothers?',Because of this, I held a great assembly and said to them, 'We have rescued, according to our resources, our Jewish brothers who were slaves. But are you now buying your own brothers?',They remained silent. They could not answer. "
,"9":"And I continued, 'What you do is not good. Should you not live in obedience to our God lest we be put to shame by our pagan enemies?"
,"10":"My brothers, my relatives and I have also lent money and wheat. Now then, let us forget everything they owe us,"
,"11":"returning to them at once their fields, vineyards, and olive groves, and canceling their debts in money, wheat, wine and oil.'"
,"12":"They answered me, 'We will return these and demand nothing from them. We will do as you have said.',So I called the priests, and before them made all of them swear an oath that they would fulfill their promise. "
,"13":"Then I shook out the folds of my mantle, saying, 'So may God shake out of his house and his inheritance all who do not fulfill this word, and may he be so shaken that nothing is left of him.' The whole assembly answered, 'Amen' and praised Yahweh. And the people fulfilled their promise."
,"14":"King Artaxerxes had appointed me governor of the land of Judah in the twentieth year of his reign. Until the thirty-second year, or rather, for twelve years, neither I nor my brothers ever demanded to be given the governor's bread."
,"15":"But the former governors had collected forty pieces of silver per day from the people. This payment was a burden to the people, and so were their servants."
,"16":"As I dedicated myself to rebuilding the wall, I did not buy fields; and all my men were there helping."
,"17":"At my table a hundred and fifty men, leaders and counselors were seated, besides those who came to us from neighboring nations."
,"18":"A male calf, six choice rams and fowls were slaughtered daily, and every ten days a great quantity of wine was brought. But though all these were charged to my account, I never asked for the governor's bread, because the people were already burdened enough with the task of reconstruction."
,"19":"Remember for my good, my God, all that I have done for this people!"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Sanballat, Tobiah, Geshem the Arab, and the rest of our enemies learned that I had rebuilt the wall of Jerusalem. There was no hole left in it, although the doors had not been set up yet."
,"2":"Then Sanballat and Geshem sent me a message saying, 'Come and let us talk in Keriphim, in the lowland of Ono.',They intended to do me harm; "
,"3":"but I sent messengers to them, saying, 'I am much occupied in a very important work, I cannot come down to meet you, for the work would stop if I left it.'"
,"4":"They invited me again four times, but I gave them the same answer every time."
,"5":"Then Sanballat invited me for the fifth time. His servant brought an open letter which said the following,"
,"6":"'Do you know the news that circulates among those who are not Jews? Gashmu says that you and the Jews are planning to rebel and that is why you are rebuilding the wall."
,"7":"And you also wish to become their king, and have already chosen prophets to proclaim you king of Jerusalem. The king shall know of this, so come, that the two of us may talk.'"
,"8":"But I sent to him, saying, 'There's nothing true in what you say; you have invented this story.'"
,"9":"For they all wanted to frighten us, saying: 'Let us discourage them that they may not finish the work.',But I, on the contrary, worked with greater strength. "
,"10":"Then I went to Shemaiah, son of Delaiah, son of Mehetabel, since he could not leave his house. He said to me, 'Let us meet together in the House of God, within the sanctuary, and then close its doors, for they are coming to kill you, to strike you this very night.'"
,"11":"But I answered him, 'Should a man like me flee? Why should a man like me seek sanctuary to save my life? I will not go.'"
,"12":"I understood then that Semaiah had not been sent by God but that Tobiah and Sanballat had brought him"
,"13":"to frighten me. In hiding in the sanctuary, I would have committed an offense, and this would have damaged my reputation and put me to shame."
,"14":"O my God, remember Tobiah and Sanballat for what they have done; and also the prophetess Noadiah and the rest of the prophets who tried to frighten me."
,"15":"The wall was finished on the twenty-fifth day of Elul, in fifty-two days."
,"16":"When our enemies and the neighboring nations knew about it, they were afraid and lost courage. They had to recognize the work of God in this."
,"17":"During that time, several distinguished Jews often wrote to and received letters from Tobiah."
,"18":"Tobiah had many friends in Judah for he was the son-in-law of Shecaniah, son of Arah, and because his son Jehohanan was married to the daughter of Meshullam, son of Berechiah."
,"19":"They even came to speak well of Tobiah in my presence, and recounted to him all my words as well. And it was he - Tobiah - who sent letters to frighten me."
}`)
	CurrentBook.AddChapter(7, `{
"1":"When the wall was built and the doors were in place, gatekeepers were designated to keep watch."
,"2":"Then I set my brother Hanani as governor of Jerusalem, and Hananiah as head of the Citadel, for he was a faithful man and true servant of God as few can be found."
,"3":"Then I said to them, 'Open the gates of Jerusalem only when the sun begins to get hot, but while it is still day, close and bar the doors while the guards are still at their posts. And during the night, the inhabitants of Jerusalem shall come out to keep guard, some at their posts and others in front of their houses.'"
,"4":"The city was spacious and wide, but it had few inhabitants and many houses had not been rebuilt."
,"5":"God inspired in me the idea to assemble the leaders, the counselors and the people to take a census. I found the registry book of the census of those who had returned from exile in the beginning. I found the following written in it:"
,"6":"These are the people of the province who returned from exile whom Nebuchadnezzar, king of Babylon, had deported, but returned to Jerusalem and Judea, each to his city:"
,"7":"These are the Israelites who came with Zerubbabel, Jeshua, Nehemiah, Azariah, Raamiah, Nahamani, Mordecai, Bilshan, Mispereth, Bigvai, Nehum, Baanah; here are the numbers:"
,"8":"The sons of Parosh, 2,172;"
,"9":"those of Shephatiah, 372;"
,"10":"those of Arah, 652;"
,"11":"those of Pahath-moab of the sons of Jeshua and Joab, 2,818;"
,"12":"the sons of Elam 1,254;"
,"13":"those of Zattu, 845;"
,"14":"those of Zaccai, 760;"
,"15":"those of Binnui, 648;"
,"16":"those of Bebai, 628;"
,"17":"those of Azgad, 2,322;"
,"18":"those of Adonimkan, 667;"
,"19":"those of Bigvai, 2,067;"
,"20":"those of Adin, 655;"
,"21":"those of Ater, of Hezekiah, 98;"
,"22":"those of Hashum, 328;"
,"23":"those of Bezai, 324;"
,"24":"those of Hariph, 112;"
,"25":"those of Gibeon, 95."
,"26":"The men of Bethlehem and Netophah, 188;"
,"27":"those of Anathoth, 128;"
,"28":"those of Bethazmaveth, 42;"
,"29":"those of Kiriath-jearim, Chephirah, and Beeroth, 743;"
,"30":"those of Ramah and Geba, 621;"
,"31":"those of Michmas, 122;"
,"32":"those of Bethel and Ai, 123;"
,"33":"those of the other Nebo, 52."
,"34":"The sons of the other Elam, 1,254;"
,"35":"those of Harim, 320;"
,"36":"those of Jericho, 345;"
,"37":"those of Lod, Hadid and Ono, 721;"
,"38":"those of Senaah, 3,930."
,"39":"The priests: the sons of Jedaiah of the house of Jeshua, 973;"
,"40":"those of Immer, 1,052;"
,"41":"those of Pashhur, 1,247;"
,"42":"those of Harim, 1,017."
,"43":"The Levites: the sons of Jeshua, of Kadmiel, of the sons of Hodevah, 74."
,"44":"The singers: the sons of Asaph, 148."
,"45":"The gatekeepers: the sons of Shallum, of Ater, of Talmon, of Akkub, of Hatita, of Shobai, 138."
,"46":"The temple servants: the sons of Ziha, of Hasupha, of Tabbaoth,"
,"47":"of Keros, of Sia, of Padon,"
,"48":"of Lebana, of Hagaba, of Shalmai,"
,"49":"of Hanan, of Giddel, of Gahar,"
,"50":"of Reaiah, of Rezin, of Nekoda,"
,"51":"of Gazzam, of Uzza, of Paseah,"
,"52":"of Besai, of Meunim, of Nephushessim,"
,"53":"of Bakbuk, of Hakupha, of Harhur,"
,"54":"of Bazlith, of Mehida, of Harsha,"
,"55":"of Barkos, of Sisera, of Temah,"
,"56":"of Neziah, of Hatipha."
,"57":"The sons of Solomon's servants: the sons of Sotai, of Sophereth, of Perida,"
,"58":"of Jaala, of Darkon, of Giddel,"
,"59":"of Shephatiah, of Hattil, of Pochereth-hazzenaim, of Amon."
,"60":"All the temple servants and the sons of Solomon's servants were 392."
,"61":"And these were they who came up from Telmelah, Telharsha, Cherub, Addon, and Immer; but they could not prove that their families and ancestry were of Israelite origin:"
,"62":"the sons of Delaiah, of Tobiah, of Nekoda, 642."
,"63":"And of the priests: the sons of Hobaiah, of Hakkoz, of Barzillai, who took a wife of the daughters of Barzillai, the Gileadite, and was named after them."
,"64":"These people searched for their ancestral registration, but it could not be located; therefore they were considered unclean and excluded from the priesthood."
,"65":"And the governor said to them that they should not eat from the most holy things until a priest would make a decision through the Urim and Thummim."
,"66":"The whole assembly together was 42,360,"
,"67":"besides their male and female servants: 7,337; and they had 245 male and female singers."
,"68":"They had 736 horses, 245 mules;"
,"69":"435 camels; 6,720 donkeys."
,"70":"Some of the heads of families gave offerings for the work. The governor gave to the treasury 1,000 gold drachmas, 50 basins, 530 priests' garments."
,"71":"The heads of families gave into the treasury of the work 20,000 gold drachmas, and 2,200 silver minas and 67 priests' garments."
,"72":"The rest of the people gave 20,000 gold drachmas and 2,000 silver minas, and 67 priests' garments."
,"73":"The priests, the Levites, the gatekeepers, the singers, some of the people, the temple servants, and all Israel lived in their cities. And when the seventh month came, the sons of Israel were in their cities."
}`)
	CurrentBook.AddChapter(8, `{
"1":"In the seventh month, all the people gathered as one man in the square before the Water Gate, and they asked Ezra to bring the Book of the Law of Moses, which Yahweh had given to Israel."
,"2":"Ezra brought the Law before the assembly, both men and women and all the children who could understand what was being read. It was the first day of the seventh month."
,"3":"Ezra read the book before all of them from early morning until midday in the square facing the Water Gate; and all who heard were attentive to the Book of the Law."
,"4":"Ezra, the teacher of the Law, stood on a wooden platform built for that occasion and to his right were Mattithiah, Shema, Anaiah, Uriah, Hilkiah and Maaseiah; and to his left were Pedaiah, Mishael, Malchijah, Hashum, Hasbaddanah, Zechariah and Meshullam."
,"5":"Ezra opened the book in the sight of all the people, for he was in a higher place; and when he opened it, all the people stood."
,"6":"Ezra blessed Yahweh, the great God; and all the people lifted up their hands and answered, 'Amen! Amen!' And they bowed their heads to the ground."
,"7":"The Levites Joshua, Bani and the rest of their brothers explained the Law to the people who were standing."
,"8":"They read from the Book of the Law of God, clarifying and interpreting the meaning, so that everyone might understand what they were hearing."
,"9":"Then Ezra, the teacher of the Law, said to the people, 'This day is dedicated to Yahweh, your God, so do not be sad or weep.' He said this because all wept when they heard the reading of the Law."
,"10":"Then he said to them, 'Go and eat rich foods, drink sweet wine and share with him who has nothing prepared. This day is dedicated to the Lord, so do not be sad. The joy of Yahweh is our strength.'"
,"11":"The Levites also calmed the people down, saying, 'Do not weep. This day is a festival day. Do not be sad.'"
,"12":"And the people went their way to eat, drink and share, and they had a great feast, because they had understood the words that had been proclaimed to them."
,"13":"On the second day, the heads of the families, the priests and the Levites came together to Ezra, the teacher of the Law, in order to learn the Law."
,"14":"There they read that Yahweh had commanded the children of Israel that they should dwell in huts during the feast of the seventh month."
,"15":"Then they proclaimed in all the cities and in Jerusalem: 'Go to the mountains and bring branches of olive, pine, myrtle, palm and of any leafy tree to build huts according to what is commanded.'"
,"16":"The people went out and brought branches and built huts for themselves on the roofs of their houses, or in their yards, or in the courtyards of the House of Yahweh, or in the square at the Water Gate or in the square at the Gate of Ephraim."
,"17":"The whole assembly of those who had returned from exile built huts and dwelt in them, a thing the Israelites had not done since the days of Joshua, son of Nun. And there was great rejoicing."
,"18":"They read the Book of the Law of God daily, from the first day to the last day of the feast. The feast lasted for seven days as prescribed and there was a solemn assembly on the eighth day."
}`)
	CurrentBook.AddChapter(9, `{
"1":"On the twenty-fourth day of that same month, the Israelites assembled to fast. They put on sackcloth and sprinkled dust upon their heads."
,"2":"The race of Israel separated themselves from all foreigners; they stood and confessed their sins and those of their fathers."
,"3":"They stood up in their place and read from the Book of the Law of Yahweh, their God, for three hours. For another three hours, they confessed their sins and bowed before Yahweh, their God."
,"4":"Joshua, Bani, Kadmiel, Shebaniah, Bunni, Sherebiah, Bani and Chenani stood on the platform of the Levites and cried out with a loud voice to Yahweh, their God."
,"5":"Then the Levites: Joshua, Bani, Kadmiel, Hashabneiah, Sherebiah, Hodiah, Shebaniah and Pethaliah said, 'Arise, bless Yahweh, our God, forever and ever. Blessed be your glorious Name which is beyond all blessing and praise.'"
,"6":"Then Ezra said, 'You, Yahweh, you alone made the heavens, the heaven of heavens, and all their army, the earth and all that is on it, the seas and all that is in them. You give life to all, and all the angels of heaven adore you."
,"7":"You, Yahweh, are the God who chose Abram; you brought him out of Ur of Chaldea, and gave him the name Abraham."
,"8":"You found him faithful to you and made with him the Covenant to give him and his descendants the land of the Canaanite, the Hittite, the Amorite, the Perizzite, the Jebusite and the Girgashite. And you have fulfilled your word, for you are just."
,"9":"You saw the affliction of our fathers in Egypt and listened to their cry by the Red Sea."
,"10":"You worked signs and wonders against Pharaoh, his ministers and all his people, for you knew that they had treated us harshly, and you have received fame to this day."
,"11":"You divided the sea before our fathers who passed through the midst of the sea without their feet getting wet. You cast their pursuers into the depths of the sea, as stones fall into the deep waters."
,"12":"You guided them by day with a pillar of cloud, and by night with a pillar of fire to light for them the way they should follow."
,"13":"You came down upon Mount Sinai and spoke with them from heaven; you gave them just decisions and laws that express truth, excellent precepts and commandments."
,"14":"You taught them to consecrate the sabbath to you; you gave them commandments, precepts and the Law, through the hand of Moses, your servant."
,"15":"You gave them bread from heaven and told them to satisfy their hunger; you made water gush forth from the rock to quench their thirst, and commanded them to go and take possession of the land which you had sworn to give them."
,"16":"But our fathers became proud and hard-headed, and they did not listen to your commands."
,"17":"They refused to listen and to remember all the marvels you did for them. They hardened their hearts rebelliously and wanted to return to their slavery in Egypt. But you, God of forgiveness, merciful and gracious, slow to anger and rich in kindness, did not abandon them."
,"18":"They even made for themselves a molten calf and said: 'This is your god, Israel, who brought you out of Egypt,' and they terribly insulted you and blasphemed you."
,"19":"But you, in your great kindness, did not abandon them in the desert; the pillar of cloud did not depart from them by day, nor the pillar of fire by night, by which you showed them the way they should take."
,"20":"You gave them your good Spirit to instruct them; you gave them manna so they could eat, and water to quench their thirst."
,"21":"Forty years you cared for them in the desert and they lacked nothing, neither did their clothes wear out or their feet swell."
,"22":"You gave them kingdoms and lands; you allotted to them the frontier lands. They took possession of the land of Sihon, king of Heshbon, and the land of Og, king of Bashan."
,"23":"And you multiplied their sons as the stars of heaven, bringing them to the land you promised their fathers."
,"24":"Their sons entered and took possession of the land. Before them you crushed the land's inhabitants, the Canaanites whom you gave into their hands with their kings and all the inhabitants, to do to them as they pleased."
,"25":"They conquered fortified cities and a fertile land, took possession of houses well-stocked, wells ready-hewn, vineyards and olive groves, and fruit trees in great abundance. They ate, were satisfied and grew fat, and they lived comfortably by your great kindness."
,"26":"But then, they were disobedient and they rebelled against you. They threw your Law behind their backs, they killed your prophets and they terribly blasphemed you."
,"27":"You handed them over to their enemies who oppressed them. In their oppression they cried to you, and you listened to them from heaven, so by your immense kindness, you sent them saviors who freed them from their oppressors."
,"28":"But when they were at peace, they did evil against you again, and you gave them over to the hands of the enemies who oppressed them. Once more they cried to you, and you listened to them from heaven, and by your great kindness you saved them many times."
,"29":"Insistently, you asked them to return to your Law, but they were very proud, so they did not listen to your commands and decisions. They did not observe what a man should fulfill to have life. They turned their backs and did not listen to you for they were hard-headed."
,"30":"You were patient with them for many years. You admonished them by your Spirit through the mouth of the prophets; but they did not listen. Then you gave them over into the hands of the peoples of these countries. "
,"31":"But because of your great kindness, you did not let them be destroyed, nor did you abandon them, for you are a God of kindness and mercy."
,"32":"Now then, our God, great, powerful and fearsome God, you who keep your covenant and your love, take into account this misery which has come upon us, upon our kings and leaders, our priests and prophets, upon our fathers and all your people since the time of the kings of Assyria to the present day."
,"33":"You have shown yourself just in all that has happened, for you have faithfully fulfilled your promises, but we have acted wickedly."
,"34":"Our kings and leaders, our priests and our fathers did not keep your Law, they did not follow your commandments or the norms you gave them."
,"35":"While they were in their king-doms, enjoying the prosperity that came from you and the very fertile and wide land you had prepared for them, they did not serve you nor did they turn away from their wicked deeds."
,"36":"See, we are now slaves, enslaved in the land you gave to our fathers to enjoy its fruits and its goodness."
,"37":"The abundant fruits of the land go to the kings you have set over us because of our sins. They do what they please with us and our livestock, and because of this we live in great distress.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"In accordance with all this, we make a firm commitment in writing. The document has been signed by our leaders, our Levites and our priests."
,"2":"Nehemiah son of Hacaliah son of Zedekiah,"
,"3":"Seraiah, Azariah, Jeremiah,"
,"4":"Pashhur, Amariah, Malchijah,"
,"5":"Hattush, Shebaniah, Malluch,"
,"6":"Harim, Meremoth, Obadiah,"
,"7":"Daniel, Ginnethon, Baruch,"
,"8":"Meshullam, Abijah, Mijamin,"
,"9":"Maaziah, Bilgai, Shemaiah: these are the priests."
,"10":"Then the Levites: Jeshua son of Azaniah, Binnui of the clan of Henadad, Kadmiel,"
,"11":"and their kinsmen Shebaniah, Hodaviah, Kelita, Pelaiah, Hanan,"
,"12":"Mica, Rehob, Hashabiah,"
,"13":"Zaccur, Sherebiah, Shebaniah,"
,"14":"Hodiah, Bani, Chenani."
,"15":"The leaders of the people: Parosh, Pathmoab, Elam, Zattu, Bani,"
,"16":"Bunni, Azgad, Bebai,"
,"17":"Adonijah, Bigvai, Adin,"
,"18":"Ater, Hezekiah, Azzur,"
,"19":"Hodiah, Hashum, Bezai,"
,"20":"Hariph, Anathoth, Nebai,"
,"21":"Magpiash, Meshullam, Hezir,"
,"22":"Meshezabel, Zadok, Jaddua,"
,"23":"Pelatiah, Hanan, Anaiah,"
,"24":"Hoshea, Hananiah, Hasshub,"
,"25":"Hallohesh, Pilha, Shobek,"
,"26":"Rehum, Hashabnah, Maaseiah,"
,"27":"Ahiah, Hanan, Anan,"
,"28":"Malluch, Harim, Baanah."
,"29":"And the rest of the people, the priests and the Levites, the gatekeepers, singers and helpers and all who have separated themselves from the inhabitants of the land to follow the Law of God together with their wives and their children who are old enough to understand, all these"
,"30":"with their leaders and their brothers have sworn to walk according to the Law of God promulgated through Moses, the servant of God, and to keep and fulfill all the precepts of Yahweh, our God, and his decisions and laws."
,"31":"We decided not to give our daughters in marriage to the men of the land nor take their daughters as wives for our sons."
,"32":"If the people of the land bring goods or any foodstuff whatsoever to sell on the sabbath day, we will not buy anything from them on the sabbath day or on any other sacred feast day. We will leave our fields uncultivated in the seventh year, and cancel all debts owed to us."
,"33":"We consider it our obligation to give one third of a shekel yearly for the service of the House of Yahweh,"
,"34":"for the show-bread, for perpetual food offering and the holocaust, for the sacrifices on the sabbath, on the new moon, on feasts for other sacrifices, for the expiation of the sin of Israel and for everything necessary in the House of God."
,"35":"Among the priests, Levites and people of the town, we have drawn lots for the offering of firewood that each family shall bring by turn to the House of Yahweh every year to keep the fire burning at the altar of Yahweh, our God, as it is written in the Law."
,"36":"We will bring the first fruits of our fields and of our fruit trees to the House of Yahweh through all the years."
,"37":"Our firstborn sons and the firstborn of our animals, as it is written in the Law, the firstborn of our cattle and sheep we will set aside for the House of Yahweh and for the priests who serve in the House of our God."
,"38":"We will bring the best of our cereals, the fruit of every tree, the wine and the oil to the priests to be kept in the chambers of the House of our God; we will also bring the tithes from our fields for the Levites. The Levites themselves will collect the tithes from all the agricultural towns."
,"39":"A priest, a son of Aaron, will go with them when they collect the tithes. The Levites will bring the tenth part of the tithes into the storage rooms of the House of God where the treasures are kept,"
,"40":"since the Israelites and the Levites bring to these storage rooms what they owe in wheat, wine and oil. In these rooms are also found the supplies for the Sanctuary, for the priests who are on duty, and for the gatekeepers and the singers. So we will no longer neglect the house of our God"
}`)
	CurrentBook.AddChapter(11, `{
"1":"The leaders of the people settled in Jerusalem. The rest of the people drew lots so that for every ten men, one would live in Jerusalem, the Holy City, with the remaining nine settling in other cities."
,"2":"The people blessed all the men who volunteered to live in Jerusalem."
,"3":"These are the provincial leaders who resided in Jerusalem. And in the cities of Judah, everyone settled on his property, in the city of his family: the people of Israel and their priests and Levites, ministers and the sons of the servants of Solomon."
,"4":"In Jerusalem there lived some of the tribe of Judah and some of the tribe of Benjamin. Of the tribe of Judah: Athaiah son of Uzziah, grandson of Zechariah, son of Amariah, son of Sephatiah, son of Mehalalel, of the descendants of Perez; "
,"5":"Maaseiah son of Baruch, grandson of Colhozeh, son of Hazaiah, son of Adaiah, son of Joiarib, son of Zechariah, descendant of Shelah."
,"6":"The total number of the descendants of Perez living in Jerusalem was four hundred and sixty-eight adult men."
,"7":"These belonged to the tribe of Benjamin: Sallu son of Meshullam, grandson of Joed, son of Pedaiah, son of Kolaiah, son of Maaseiah, son of Ithiel, son of Jeshaiah,"
,"8":"and his kinsmen, adult men: nine hundred and twenty-eight."
,"9":"Joel son of Zichri was their leader, and Judah son of Hassenuah was second in command of the city."
,"10":"Of the priests: Jedaiah son of Joiakin, son of Seraiah, son of Hilkiah,"
,"11":"grandson of Meshullam, son of Zadok, son of Meraioth, son of Ahitub, who was the High Priest,"
,"12":"and his kinsmen who were responsible for the Temple liturgy: eight hundred and twenty-two; Adaiah son of Jeroham, son of Pelaliah, son of Amzi, son of Zechariah, son of Pashhur, son of Malchijah,"
,"13":"and his kinsmen, heads of families: two hundred and forty-two; and Amashai son of Azarel, grandson of Ahzai, son of Meshillemoth, son of Immer,"
,"14":"and his kinsmen, adult men: one hundred and twenty-eight. Zabdiel son of Haggadol was in charge of them."
,"15":"Of the Levites: Shemaiah son of Hasshub, grandson of Azrikam, son of Hashabiah, son of Bunni,"
,"16":"Shabbethai and Jozabad, the levitical leaders responsible for the outside work of the Temple of God;"
,"17":"Mattaniah son of Mica, grandson of Zabdi, son of Asaph, who directed the hymns and, at prayer, intoned the thanksgiving; Bakbukiah, the second in rank among his kinsmen; Obaidah son of Shammua, grandson of Galai, son of Jeduthun."
,"18":"The total number of Levites in the holy city: two hundred and eighty-four."
,"19":"The gatekeepers: Akkub, Talmon and their kinsmen, who kept watch at the gates: one hundred and seventy-two."
,"21":"The workmen lived at Ophel; Ziha and Gishpa were in charge of the workmen."
,"22":"The head of the Levites in Jerusalem was Uzzi son of Bani, grandson of Hashbiah, son of Mattaniah, son of Mica, he belonged to the clan of Asaph who were responsible for the chanted parts of the liturgy in the Temple of God;"
,"23":"there were royal regulations stating how the clans should take turns in leading the Temple music each day."
,"24":"Pethahiah son of Meshezabel, belonging to the clan of Zerah and the tribe of Judah, was the king's commissioner for all such matters as concerned the people."
,"20":"The rest of the Israelites, priests and Levites made their homes throughout the towns of Judah, each man in his own inheritance,"
,"25":"and in the villages situated in rural districts of their own fields. Some of the tribe of Judah made their homes in Kiriatharba and its outlying villages, in Dibon and its outlying villages, in Jekabzeel and its outlying villages, "
,"26":"in Jeshua, Moladah, Beth-pelet,"
,"27":"Hazar-shual, in Beersheba and its villages,"
,"28":"in Ziklag, in Meconah and its villages,"
,"29":"in Enrimmon, Zorah, Jarmuth,"
,"30":"Zanoah, Adullam and their villages: thus, they settled from Beersheba as far as the Valley of Hinnom."
,"31":"Some of the tribe of Benjamin made their homes in Geba, Michmash, Aija, in Bethel and its villages,"
,"32":"Anathoth, Nob, Ananiah,"
,"33":"Hazor, Ramah, Gittaim,"
,"34":"Hadid, Zeboim, Neballat,"
,"35":"Lod and Ono, and the Valley of the Craftsmen."
,"36":"Some groups of Levites settled in Judah as well as in Benjamin."
}`)
	CurrentBook.AddChapter(12, `{
"1":"These are the priests and the Levites who came back with Zerubbabel son of Shealtiel, and with the High Priest Jeshua:"
,"2":"Seraiah, Jeremiah, Ezra,"
,"3":"Amariah, Malluch, Hattush, Shecaniah, Harim, Meremoth,"
,"4":"Iddo, Ginnethoi, Abijai,"
,"5":"Mijamin, Maadiah, Bilgah,"
,"6":"Shemaiah; also: Joiarib, Jedaiah,"
,"7a":"Sallu, Amok, Hilkiah, Jedaiah."
,"7b":"These were the heads of the priests and of their kinsmen in the days of Jeshua."
,"8":"And the Levites: Jeshua, Binnui, Kadmiel, Sherebiah, Judah, Mattaniah - the latter with his kinsmen, directed the hymns of thanksgiving"
,"9":"while Bakbukiah, Unno and their kinsmen in their respective groups formed an alternate choir."
,"10":"Jeshua was the father of Joiakim father of Eliashib, Eliashib father of Joiada,"
,"11":"Joiada father of Johanan, and Johanan father of Jaddua."
,"12":"In the days when Joiakim was High Priest the heads of the priestly clans were: clan of"
,"13":"Seraiah, Meraiah; of Jeremiah, Hananiah; of Ezra, Meshullam; of Amariah, Jehohanan;"
,"14":"of Malluchi, Jonathan; of Shebaniah, Joseph;"
,"15":"of Harim, Adna; of Meremoth, Helkai;"
,"16":"of Iddo, Zechariah; of Ginnethon, Meshullam;"
,"17":"of Abijah, Zichri; of Miniamin, and of Moadiah, Piltai;"
,"18":"of Bilgah, Shammua; of Shemaiah, Jehonathan;"
,"19":"also: of Joiaarib, Mattenai; of Jedaiah, Uzzi;"
,"20":"of Sallai, Kallai; of Amok, Eber;"
,"21":"of Hilkiah, Hashabiah; of Jedaiah, Nethanel."
,"22":"In the days of the High Priests Eliashib, Joiada, Johanan and Jaddua, the heads of the priestly families were recorded in the Book of the Chronicles up to the reign of Darius the Persian."
,"23":"The sons of Levi."
,"24":"The heads of the Levite families were recorded in the Book of the Chronicles, but only up to the time of Johanan, grandson of Eliashib. The heads of the Levites: Hashabiah, Sherebiah, Jeshua, Binnui, Kadmiel; and their kinsmen forming an alternate choir for the hymns of praise and thanksgiving, in accordance with the instructions of David the man of God, in alternating groups. "
,"25":"Mattaniah, Bakbukiah, Obadiah, Meshullam, Talmon and Akkub were gatekeepers and stood guard at the storehouses near the gates."
,"26":"These lived in the days of Joiakim son of Jeshua, grandson of Jozadak and in the days of Nehemiah, the governor and of Ezra, priest and scholar of the Law."
,"27":"When the wall of Jerusalem was inaugurated, the Levites were summoned from all the places where they lived and they came to Jerusalem to celebrate the dedication with joy, with songs of thanksgiving, with the music of cymbals and zithers."
,"28":"The singers from the neighboring regions and from the villages of Netophath,"
,"29":"Beth-gilgal and the districts of Bega and Azmaveth gathered together in Jerusalem, because the singers had built themselves villages around Jerusalem."
,"30":"The priests and the Levites purified themselves, and then purified the people, the gates and the wall."
,"31":"I then ordered the leaders of Judah to stand on top of the wall and I organized two grand choirs. The first advanced on top of the wall in the southern part, facing the Gate of the Garbage Dump;"
,"32":"behind them went Hoshaiah and half the leaders of the Jews,"
,"33":"and also Azariah, Ezra, Meshullam,"
,"34":"Judah, Benjamin, Shemaiah and Jeremiah,"
,"35":"the priests and then the musicians with the trumpets came: Zechariah, son of Jonathan, son of Shemaiah, son of Mattaniah, son of Micaiah, son of Zaccur, son of Asaph,"
,"36":"with his brothers, Shemaiah, Azarel, Milalai, Gilalai, Maai, Nethanel, Judah, Hanani, carrying the musical instruments of David, the man of God. Ezra, the teacher of the Law, went in front of them."
,"37":"They went straight on up to the Fountain Gate, near the steps of the City of David, along the top of the wall of the house of David, as far as the Water Gate, on the east."
,"38":"The second choir marched to the left: I followed it with half the leaders of the people along the top of the wall, passing through the Tower of the Furnaces and as far as the Wide Wall,"
,"39":"over the Gate of Ephraim, the Fish Gate, the Tower of Hananel, as far as the Sheep Gate, and we stopped at the Watch Gate."
,"40":"Then the two choirs took their places in the House of God. Half of the counselors"
,"41":"and the priests Eliakim,"
,"42":"Maaseiah, Miniamin, Micaiah, Elioenai, Zechariah, and Hananiah, who were carrying the trumpets, were at my side, together with Maaseiah, Shemaiah, Eleazar, Uzzi, Jehohanan, Malchijah, Elam and Ezer. The singers chanted their songs under the direction of Jezrahiah."
,"43":"Great sacrifices were offered that day and the people rejoiced, for God had bestowed great joy on them; the women and the children also participated in the feast. And the shouts of joy of Jerusalem could be heard far away."
,"44":"At that time, supervisors were appointed to guard the storage rooms where the contributions, the firstfruits and the tithes were kept. They were to store in them the portions from the different cities of the territory required by the Law for the priests and Levites. For the people of Judah rejoiced to see the priests and Levites doing their duty."
,"45":"They performed the liturgy of their God and the ceremonies of purification with the singers and the gatekeepers, as commanded by David and his son Solomon."
,"46":"For from the beginning, from the days of David and Asaph, there had been song leaders and songs of praise and thanksgiving to God."
,"47":"The whole of Israel, in the time of Zerubbabel and Nehemiah, gave the singers and the gatekeepers what was necessary for each day. The sacred objects were entrusted to the Levites, and what was for the sons of Aaron was given to them."
}`)
	CurrentBook.AddChapter(13, `{
"1":"At that time, the book of the Law of Moses was read in the presence of the people, and they found this written in it: 'The Ammonite and Moabite will never enter the assembly of God,"
,"2":"for they did not welcome the sons of Israel with bread and water. They gave money to Balaam to curse them, but our God turned their curse into a blessing.'"
,"3":"When they heard this Law, they excluded from Israel all those of foreign descent."
,"4":"Before this, the priest Eliashib had been caretaker of the chambers of the House of God. Since he was related to Tobiah,"
,"5":"he had allotted to him a spacious chamber which used to be the storage room for the offerings, incense, utensils, tithes of the wheat, wine and oil, that is, for what belonged to the Levites, singers and gatekeepers, and the contributions for the priests."
,"6":"I was not in Jerusalem when this happened, because in the thirty-second year of Artaxerxes, king of Babylon, I had gone to see the king. Then after some time, the king allowed me to return."
,"7":"I returned to Jerusalem and I was informed of the evil Eliashib had done just to please Tobiah, allotting to him a chamber inside the court to the House of God."
,"8":"This made me very angry. So I threw all of Tobiah's furniture out of the chamber and"
,"9":"ordered the chamber to be purified, and had the utensils of the House of God, the offerings and the incense put back in place."
,"10":"I also learned that the portions were not given to the Levites. And because of this, the Levites and the singers in charge of the ceremonies had gone back to their fields."
,"11":"I was angry with the counselors and said to them, 'Why is the House of God abandoned?' Then I gathered together the Levites and the singers, and sent them back to work according to their respective duties."
,"12":"With this, all the Jews turned over to the storehouses the tenth part of their wheat, wine and oil."
,"13":"I entrusted the administration of the storehouses to the priest Shelemiah, to the teacher of the Law Zadok, to the Levite Pedaiah, and to Hanan, son of Zaccur, as assistant. I appointed them since they were regarded as responsible men. Their work consisted in distributing the food to their brothers."
,"14":"My God, remember the things I have done. Do not forget the good works I did for your House and its ceremonies."
,"15":"In those days, I found men of Judah working in the winepress on the sabbath. Others took sheaves of wheat and loaded them on their asses together with wine, grapes, figs and every kind of produce they wanted to bring into Jerusalem on the sabbath day. I reprimanded them as they were selling their produce."
,"16":"Some Tyrians who had settled in Jerusalem brought in fish and every sort of merchandise to sell to the Jews on the Sabbath day."
,"17":"So I reprimanded the leaders of Judah, saying to them, 'You have done great evil by not respecting the sabbath day."
,"18":"When your fathers did not observe the sabbath, our God brought all those misfortunes on us and on this city. You increase the wrath of God against Israel by not respecting his sabbaths.'"
,"19":"So I ordered that as the shadows were falling on the gates of Jerusalem in the evening before the sabbath, the gates were to be closed and not to be opened until after the sabbath was over. Moreover, I also stationed some of my men by the gates so that no goods would be brought in on the sabbath day."
,"20":"Once or twice, some merchants who sold every kind of merchandise spent the night outside Jerusalem,"
,"21":"but I warned them, saying, 'Why do you spend the night by the wall? Do this again, and I shall use force against you.' From then on, they did not return any more on the sabbath day."
,"22":"I also ordered the Levites to purify themselves and to come and guard the gates in order to sanctify the sabbath. For this, too, remember me, my God, and have pity on me according to your great mercy."
,"23":"In those days, I also saw that some Jews had remarried Ashdodite, Ammonite and Moabite women,"
,"24":"and half of their children spoke Ashdodite and did not know our own language."
,"25":"I reprimanded them and cursed them; I had some of them flogged and tore out their hair, and made them swear in the name of Yahweh, saying to them: 'You shall not marry your daughters to the sons of those people, nor take any of their daughters as wife, neither you nor your sons."
,"26":"Did Solomon, king of Israel, not sin in this? Among the many nations, there had not been a king like him. He was loved by God, and God made him king of all Israel. But foreign women also made him sin."
,"27":"Will it also be said of you that you committed the same grave crime by rebelling against our God in marrying foreign women?'"
,"28":"I also sent away from my side one of the sons of Jehoiada, son of the high priest Eliashib, who was the son-in-law of Sanballat, the Horonite."
,"29":"Remember this people, my God, for they defiled the priesthood and your covenant with the priests and Levites."
,"30":"So I purified them from everything foreign. And I established regulations for the priests and the Levites, defining the tasks of everyone."
,"31":"I also fixed the time for the wood offering and for the firstfruits. Remember me, my God, for my good!"
}`)

}
func EN_CCB_LoadVHRTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"There was a famine in the land during the time of the Judges, and a man from Bethlehem in Judah departed with his wife and two sons to sojourn in the country of Moab."
,"2":"The man was Elimelech, his wife Naomi, and his two sons Mahlon and Chilion. They were Ephrathites from Bethlehem, Judah. A little later, after they had settled in Moab,"
,"3":"Naomi's husband Elimelech died. She was left with her two sons,"
,"4":"who married Moabite women, one named Orpah and the other Ruth. After living in Moab for about ten years, "
,"5":"Mahlon and Chilion also died and Naomi was left bereft of husband and two sons."
,"6":"Having heard that Yahweh had come to help his people by giving them food, Naomi prepared to return home."
,"7":"With her two daughters-in-law, she took the road back to Judah."
,"8":"It was then that Naomi said to her daughters-in-law, 'Go back, each of you, to your mother's house. And may Yahweh be kind to you, as you have been to your dead and to me."
,"9":"May he also grant each of you rest in the home of another husband.' She kissed them goodbye. But they wept aloud"
,"10":"and said to her, 'No, we will go back with you to your people.'"
,"11":"Naomi said, 'Return home, my daughters. Why should you come with me, when I have no more sons to become your husbands?"
,"12":"Return home, my daughters. I am now too old to marry again. Even if I hope to have a husband tonight and give birth to sons,"
,"13":"would you remain unmarried waiting for them to grow up? No, my daughters. I won't share my lot with you for it is too bitter. Yahweh's hand has been raised against me!'"
,"14":"Again they sobbed and wept. Then Orpah kissed her mother-in-law goodbye, but Ruth clung to her."
,"15":"Naomi said, 'Look, your sister-in-law returns to her people and her gods. You too must return. Go after her.'"
,"16":"Ruth replied, 'Don't ask me to leave you. For I will go where you go and stay where you stay. Your people will be my people and your god, my God."
,"17":"Where you die, there will I die and be buried. May Yahweh deal with me severely if anything except death separates us.'"
,"18":"Realizing that Ruth was determined to go with her, Naomi stopped urging her."
,"19":"So the two went on till they reached Bethlehem. Their arrival set the town astir. Women asked, 'Can this be Naomi?'"
,"20":"She said to them, 'Don't call me Naomi. Call me Mara for Yahweh has made life bitter for me."
,"21":"I came away full but go back empty. Why call me Naomi, when Yahweh has afflicted me?'"
,"22":"Thus it was that Naomi returned from Moab with her Moabite daughter-in-law and arrived in Bethlehem as the barley harvest began."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Naomi had a well-to-do kinsman, Boaz, from the clan of her husband Elimelech."
,"2":"And Ruth the Moabite said to Naomi, 'Let me go to pick up the left-over grain in the field whose owner will allow me that favor.' Naomi said, 'Go ahead, my daughter.'"
,"3":"So she went to glean in the fields behind the harvesters. It happened that the field she entered belonged to Boaz of the clan of Elimelech."
,"4":"When Boaz came from Bethlehem, he greeted the harvesters, 'Yahweh be with you.' They returned the greeting, 'Yahweh bless you.'"
,"5":"Noticing Ruth, Boaz asked the foreman of his harvesters, 'To whom does that young woman belong?'"
,"6":"The foreman replied, 'She is the Moabite who came back with Naomi from the country of Moab."
,"7":"She came this morning and asked leave to glean behind the harvesters. Since then she has been working without a moment's rest.'"
,"8":"Boaz said to Ruth, 'Listen, my daughter. Don't go away from here to glean in anyone else's field. Stay here with my women servants."
,"9":"See where the harvesters are and follow behind. I have ordered the men not to molest you. They have filled some jars with water. Go there and drink when you are thirsty.'"
,"10":"Bowing down with her face to the ground, she exclaimed, 'Why have I, a foreigner, found such favor in your eyes?'"
,"11":"Boaz answered, 'I have been told all about you - what you have done for your mother-in-law since your husband's death, how you have gone with her, leaving your own father and mother and homeland, to live with a people you knew nothing about before you came here."
,"12":"May Yahweh reward you for this! May you receive full recompense from Yahweh, the God of Israel, under whose wings you have come for refuge!'"
,"13":"Ruth said, 'May I prove worthy of your favor, my lord. You have consoled your servant with your kind words, though I am not the equal of your maidservants.'"
,"14":"Boaz called her at mealtime, 'come over, have some bread and dip it in the wine.' As she sat among the reapers, he handed her some roasted grain. She ate her fill and had some left over."
,"15":"When she rose to glean, Boaz instructed his men, 'Let her glean even among the sheaves and do not scold her."
,"16":"And pull some stalks from the bundles; leave them scattered for her to glean.'"
,"17":"She worked until evening and when she threshed what she had gleaned it amounted to about an ephah."
,"18":"Ruth carried back to town the threshed barley, which she showed to her mother-in-law. She also gave her what she had left over from lunch."
,"19":"Naomi asked her daughter-in-law, 'Where did you glean today? Where did you work? May the man who took notice of you be blessed.' Ruth told her mother-in-law about the owner of the field where she had worked. 'His name is Boaz,' she said."
,"20":"Naomi exclaimed, 'May Yahweh bless him! God indeed is merciful both to the living and the dead. This man is a close relative, one with a right of redemption over us.'"
,"21":"Ruth continued, 'He even told me to stay with his servants until they finish harvesting the grain.'"
,"22":"Naomi said, 'It will be better for you, my daughter, to go out with his maidservants than to go working in some other field where harm might come to you.'"
,"23":"Ruth, therefore, stayed close to the maidservants of Boaz, gleaning until the end of the wheat and barley harvests. And she continued living with her mother-in-law."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Later Naomi talked to Ruth: 'My daughter, is it not my duty to see you settled in a home where you will be well provided for?"
,"2":"And is not Boaz, who has treated you kindly with his maidservants, a close relative of ours? Tonight at the threshing floor, he will be winnowing barley."
,"3":"So bathe and perfume yourself, then put on your best clothes and go down to the threshing floor. But don't make yourself known to,him till he has finished eating and drinking. "
,"4":"Take note of the place where he lies down to sleep. Then go, uncover his feet and lie down there. He will tell you what to do.'"
,"5":"Ruth answered, 'I will do as you say.'"
,"6":"She went down to the threshing floor and did as her mother-in-law told her."
,"7":"Feeling happy after eating and drinking, Boaz went to lie down at the end of the pile of grain. Ruth then approached quietly, turned back the covering of his feet and lay there."
,"8":"At midnight the man awoke when he turned over and felt someone lying at his feet. He got up and was startled to find a woman there."
,"9":"'Who are you?' he asked. The answer came, 'I am Ruth, your servant. Spread the corner of your cloak over me for you are a kinsman who has right of redemption over me.' "
,"10":"Boaz said, 'May Yahweh bless you, my daughter! This kindness of yours now is even greater than that which you have shown earlier, for you have not gone after young men, rich or poor."
,"11":"Have no fear, my daughter; I will do for you all that you ask, since all my townsmen know that you are a worthy woman."
,"12":"It is true that I am a close relative, but there is another still closer."
,"13":"Stay here for the night. In the morning, if he wants to claim you - good! But if not - as surely as Yahweh lives - I will claim you myself. Lie here till morning.'"
,"14":"She lay at his feet till morning and got up before anyone could be recognized. For Boaz said, 'It must not be known that a woman came to the threshing floor.'"
,"15":"Then turning to Ruth, Boaz said, 'Hold out the mantle you are wearing.' She did so and he poured into it six measures of barley. He helped her lift the bundle, then went back to town."
,"16":"Ruth returned home to her mother-in-law, who asked, 'How did you fare, my daughter?' She told her everything"
,"17":"and added, 'He gave me these six measures of barley because, as he said, he did not want me to go back to my mother-in-law empty-handed.'"
,"18":"Naomi said, 'Wait, my daughter, till you learn what happens, for he will not rest until it is settled today.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Meanwhile Boaz went to the town gate and sat there waiting for the closer relative about whom he had spoken to Ruth. When he saw him coming, he called him by name and said, 'Come here and sit down.' And so he did."
,"2":"Boaz picked out ten from the city elders and asked them to sit with them, which they did."
,"3":"Then he said to the other man who also had right of redemption, 'Naomi, who has come back from Moab, is selling the piece of land that belonged to our brother Elimelech."
,"4":"I thought of bringing this matter to you before our elders here, because as the closer kin you have more right to lay claim to it. But if you have no wish to redeem it, let me know because I am next to you in line.',The man replied, 'I am willing to put in my claim. I will redeem it.' "
,"5":"Boaz continued, 'If you buy the land from Naomi, you will also have to take the Moabite Ruth, widow of the late heir, and her sons will inherit the name and the land of the dead.'"
,"6":"The man said, 'Then I cannot redeem it, because I might endanger my own estate. Redeem it yourself.'"
,"7":"It used to be the custom in Israel that for a contract of redemption or exchange to become binding, one party had to take off his sandal and give it to the other. This act legalized transactions."
,"8":"So the man took off his sandal and said to Boaz, 'Buy it yourself.'"
,"9":"Boaz turned to the elders and all those present. 'This day you are witnesses that I buy from Naomi all the holdings of Elimelech, Chilion and Mahlon."
,"10":"I also take Mahlon's widow, Ruth the Moabite, as my wife to raise up a family for her late husband, so that the name of the dead will be restored to his inheritance and be present among his brothers when they gather at the gate of his town. Do you witness this today?'"
,"11":"The elders and all those at the gate answered, 'We witness. May Yahweh make the woman coming into your house like Rachel and Leah, who together built up the house of Israel. May you prosper in Ephrathah and be of good standing in Bethlehem."
,"12":"And through the offspring Yahweh will give you by this woman, may your house become like that of Perez whom Tamar bore to Judah.'"
,"13":"So Ruth was taken by Boaz and became his wife. Yahweh made her conceive and give birth to a son."
,"14":"The women said to Naomi, 'Blessed be Yahweh who has provided you today with an heir. May he become famous in Israel!"
,"15":"He will be your comfort and stay in your old age, for he is born of a daughter-in-law who loves you and is worth more than seven sons.'"
,"16":"Naomi took the child as her own and became his nurse."
,"17":"And the women of the neighborhood gave him his name, saying, 'A son has been born for Naomi.' They named him Obed. He was the father of Jesse, who was David's father."
,"18":"This, then, is Perez's family line: Perez was the father of Hezron, "
,"19":"Hezron of Ram, Ram of Amminadab,"
,"20":"Amminadab of Nahshon, Nahshon of Salmon,"
,"21":"Salmon of Boaz, Boaz of Obed,"
,"22":"Obed of Jesse, and Jesse the father of David."
}`)

}
func EN_CCB_LoadVHTBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"This is the story of Tobit son of Tobiel, son of Ananiel, son of Adonel, son of Gabael of the race of Asiel, of the tribe of Naphtali."
,"2":"In the days of Shalmaneser, king of Assyria, Tobit was deported from Thisbe, which is to the south of Kedesh of Naphtali in Galilee, above Asher."
,"3":"I, Tobit, have walked in the ways of truth and justice all the days of my life; I have given many alms to my brethren and to those of my countrymen who were deported with me to Nineveh, a city in the country of the Assyrians."
,"4":"When I was a young man in my country, the land of Israel, all the tribe of my father Naphtali broke away from the family of David in Jerusalem. This was, however, the city chosen among all the tribes of Israel to be the place of sacrifice for all the tribes, and where the Temple, the house of God the Most High, had been built and consecrated for all generations forever."
,"5":"All the tribes which had separated, including the tribe of Naphtali my father, sacrificed to the calf Baal which Jeroboam, king of Israel, had set up at Dan, in the hills of Galilee."
,"6":"I, alone, often went to Jerusalem for the feasts, as is ordered for all the people of Israel by an everlasting decree. I went with the first fruits and tithes of my crop, and with the first shearings of the sheep."
,"7":"I gave these for the altar, to the priests, sons of Aaron; I gave a tithe of the corn, the wine, the olives, the pomegranates, the figs and the other fruits to the Levites who officiated in Jerusalem. I sold the second tithe every six years and went to distribute the money in Jerusalem."
,"8":"I gave the third tithe to the orphans and widows and to the pagan converts who had joined the Israelites. I gave them every three years and we ate according to the rules which had been laid down on this matter in the Law of Moses, and according to the recommendations made by Deborah, my father's mother, for my father had left me an orphan."
,"9":"When I reached manhood I married Anna of the race of our forefathers and she bore me a son, Tobias."
,"10":"When I was taken to the city of Nineveh as a prisoner, all my relatives and those of our family ate the pagans' food."
,"11":"But I watched over myself so as not to eat it"
,"12":"because I remembered God with all my heart."
,"13":"The Most High let me be esteemed by Shalmaneser and I became his purchaser."
,"14":"I used to go to Media to make purchases for him until he died; one day I left on deposit with Gabael, brother of Gabria, at Rages in Media, a sack containing ten talents of silver."
,"15":"When Shalmaneser died, his son Sennacherib became king in his place. In his time the highways of Media were in a state of insurrection so that I could no longer go to Media."
,"16":"In the days of Shalmaneser I gave many alms to my kinsmen."
,"17":"I gave my bread to those who were hungry, my garments to those who were naked, and if I saw anyone of my tribe dead, and his body thrown over the ramparts of Nineveh I would bury him."
,"18":"I buried secretly those whom King Sennacherib killed on returning from Judea in the days when he was punished by the king of Heaven because of the blasphemies which he had uttered. In his anger he slew a great number of Jews. The king looked for their bodies but could not find them."
,"19":"One of the inhabitants of Nineveh went and told the king that I had buried them, so I went into hiding. Then I learned that they were looking for me to put me to death. I was afraid and fled to a distance. "
,"20":"All my goods were confiscated and nothing was left to me that was not taken for the royal treasury, except Anna my wife and Tobias my son."
,"21":"But only forty days had passed when Sennacherib was killed by his two sons. They fled to Mount Ararat and his son Esarhaddon became king in Sennacherib's place. Esarhaddon appointed Ahikar, the son of my brother Anael, over all the administration."
,"22":"Ahikar intervened on my behalf and I returned to Nineveh. My nephew Ahikar was head of the cup bearers, keeper of the seals, administrator and accountant. Esarhaddon made him second only to himself."
}`)
	CurrentBook.AddChapter(2, `{
"1":"When I returned to my house, my wife Anna and my son Tobias were given back to me. At the feast of Pentecost, the sacred feast of the Seven Weeks, they prepared a good meal for me and I sat down to eat."
,"2":"I saw the many dishes and said to my son: 'Go and bring as many as you can find of our relatives who are in need and who remember the Lord. I will wait here for them.'"
,"3":"When Tobias returned, he said: 'Father, one of ours has been strangled and thrown into the public square.'"
,"4":"Before I ate anything I hurried out and carried this man into the house and waited till sunset to bury him."
,"5":"When I returned home I washed myself and ate my food in sorrow."
,"6":"I remembered the prophecy which Amos uttered against Bethel: 'Your feasts will be turned into mourning. All your songs will be turned into lamentations,'"
,"7":"and I wept. After sunset I went out and, after I had dug a trench, I buried the man. "
,"8":"My neighbors mocked me, saying: 'He no longer fears to be put to death for doing that; he had to flee but look he is again burying the dead.'"
,"9":"That same night, after I had buried the body, I returned home. I washed myself and went out into the courtyard to sleep against the wall; my face was uncovered because of the heat."
,"10":"I did not see that there were sparrows on the wall of the courtyard and, as my eyes were open, the hot droppings from the sparrows fell into my eyes and formed a white film on my eyes. I went to find doctors to attend to me for medical treatment but the more ointments they smeared on my eyes, the more blind I became because of the film. Finally I became totally blind. I suffered from blindness for four years. All my brothers were burdened because of me. Ahikar kept me for two years before he departed for Elymiade."
,"11":"My wife Anna worked hard at a woman's task, weaving."
,"12":"On the seventh day of the month of March she cut the cloth and delivered it to her employers. They paid her wages and gave her, over and above, a young goat for food."
,"13":"When she returned home the kid began to cry. I said to her, 'Where does the little kid come from? Did you steal it? Return it to its owners for we are not allowed to eat anything that is stolen.'"
,"14":"But she said, 'It is a gift which has been given to me in addition to my wages.' 'I don't believe it. I tell you to return it to its owners.' I was ashamed of her. She replied, 'What about your own almsgiving and your good deeds? I have to put up with all this from you.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Distressed, I wept and prayed and expressing my sorrow, I said,"
,"2":"'You are just, O Lord; all your actions and all your ways are merciful and just; your judgments are always true and just."
,"3":"Remember me, Lord, and look on me. Do not punish me for my sins nor for the wrongs I have committed through ignorance. Pardon the sins which my fathers have committed in your sight,"
,"4":"for they disobeyed your commandments. You have allowed us to suffer pillage, captivity and death. You have allowed us to be mocked by all the pagan nations among whom we have been dispersed."
,"5":"Ah well! All your judgments are just when you choose to punish me for my sins and those of my fathers, because we have not accomplished your will, nor have we sincerely obeyed your commands. We have not walked before you in truth."
,"6":"Do with me as you will. Order my life taken from me, and turn me into dust, because I prefer death to life. In this way free me and let me return to dust. It is better for me to die than to live, because these unjust reproaches have caused me great distress. Command that I be now released from trials, and let me enter my eternal dwelling place. Do not turn your face away from me.'"
,"7":"That same day, at Ecbatana in Media, Sara, the daughter of Ragouel, was insulted in a similar way by her father's young maidservants."
,"8":"Sara had had seven husbands, but the demon Asmodeus had killed each one of them before the marriage had been consummated. The maidservants said, 'It was you who killed your husbands. You have had seven husbands and you have not enjoyed marital relationship with any of them."
,"9":"Why do you punish us? Since they are dead, go and join them. May we never see a son or daughter of yours!'"
,"10":"That same day Sara was so distressed in mind that she went to the upper room in her father's house. She wished to hang herself. But she thought better of it and said: 'If people ever reproached my father and said to him: 'You had an only daughter whom you cherished and she hanged herself because she was unhappy,' I would cause my father in his old age to die of grief. It is better for me not to hang myself but to ask the Lord that I may die and not live to hear any more insults.'"
,"11":"At that moment she stretched forth her hands towards the window and prayed, saying, 'You are blessed, O Lord my God, and blessed is your holy and glorious Name throughout the ages. May all your works praise you forever."
,"12":"Lord I have turned my eyes and my face towards you."
,"13":"Command that I be set free from the earth and that I may hear no more insults."
,"14":"You know, O Lord, that I am pure of all contact with man;"
,"15":"that I have not defiled my name, nor my father's name in the country of my captivity. I am my father's only daughter. He has no other son or daughter who can inherit from him, neither has he a close relative who can be given to me as a husband. So, after my seven husbands are dead, I have no one to live for. If it does not seem good to you, O Lord, that I should die, command that people will respect me and have pity on me and that I may hear no more insults.'"
,"16":"The Lord in his glory heard the prayer of Tobit and of Sara"
,"17":"and he sent Raphael to heal them both - to give back his sight to Tobit and to give Sara, the daughter of Ragouel, to Tobit's son Tobias, as his wife. Also, Raphael would enchain the wicked demon Asmodeus so that Sara would be the wife of Tobias. At the same time Tobit, who had gone for a short walk, returned to the house; and Sara, the daughter of Ragouel, came down from the upper room."
}`)
	CurrentBook.AddChapter(4, `{
"1":"The same day Tobit remembered the money which he had deposited with Gabael at Rages in Media, and he said to himself:"
,"2":"'I have asked for death, had I better not call Tobias and tell him about this money before I die?'"
,"3":"He called Tobias and said to him: 'My son, when I die, see to my burial. Look after your mother. Honor her all the days of your life. Do what pleases her and do not cause her any pain."
,"4":"Remember, my son, that she suffered much pain on your account when you were in her womb. When she dies, bury her next to me, in the same tomb."
,"5":"Always remember the Lord our God. Do not consent to sin or go against his commandments. Act justly all the days of your life, and do not walk in the paths of wrongdoing,"
,"6":"for, if you act uprightly, you will be successful in all you do."
,"7":"Give alms from what you have to those who act justly and do good. Do not be grudging when you give alms. Do not turn away your face from anyone who is poor so that God may not turn away his face from you."
,"8":"Give alms in proportion to the amount you have; if you have little, do not be afraid to give alms according to the little you have."
,"9":"In this way you are storing up treasure against the day of tribulation, because"
,"10":"almsgiving frees us from death and keeps us from wandering in the darkness."
,"11":"For, in fact, almsgiving is, for the man who practices it, a precious treasure in the eyes of God."
,"12":"Keep yourself, my son, from all unlawful sexual relations and, above all, take a wife from the tribe of your fathers. Do not take a foreign woman, one who does not belong to the tribe of our fathers, because we are children of the prophets. Remember, my son, that in former times our fathers, Noah, Abraham, Isaac and Jacob took wives from among their relatives so that they might be blessed in their children and that their race might possess the land."
,"13":"Love your relatives and do not despise the sons and daughters of your people to the point where you would take a foreign woman as your wife. Pride brings about ruin and your complete downfall; in laziness are found extreme humiliation and indigence; laziness is the mother of want, hunger, famine."
,"14":"Do not keep back overnight the wages of any man who has worked for you but give them as soon as possible. If you serve God, you will be rewarded. Take care in all your actions and behave correctly in all you do. "
,"15":"Do not do to another what you would hate done to yourself. Do not drink wine to the point of drunkenness; do not let drunkenness be a life-long companion."
,"16":"Give your bread to those who are hungry and your clothes to those who are naked; give alms of everything you have over."
,"17":"Scatter your bread on the tombs of the just; do not give it to those who are sinners."
,"18":"Take counsel of those who are wise and do not despise any useful advice."
,"19":"In all circumstances bless the Lord and ask him to make your ways upright; and to make your plans and projects succeed because not every nation has true wisdom. It is the Lord who gives everything and he humbles those whom he wishes. My son, remember my advice and do not let it be erased from your heart."
,"20":"I also wish to mention the ten talents of silver which I placed on deposit with Gabael, son of Gabria, at Rages in Media."
,"21":"Do not fear, my son, because we have become poor. If you fear God, if you abstain from all sin and if you do what is pleasing in God's sight - in this way you will have great wealth.'"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Tobias spoke to Tobit, 'Father, I shall do everything you have asked."
,"2":"But how can I get the money from this man. He does not know me and I do not know him. What proof of identity shall I give him to make him trust me and give me the money? Also, I do not know the way to Media.'"
,"3":"Tobit gave Tobias a receipt and said to him, 'My son, find a trustworthy man to go with you, and on your return I shall give him a salary until he dies. When you reach Rages, collect the money from the man Gabael.'"
,"4":"Tobias went to look for a man and he found Raphael. Raphael was an angel but Tobias did not know it."
,"5":"Tobias said to Raphael, 'Can you go with me to Rages in Media? Do you know the place?'"
,"6":"The angel said to Tobias, 'I will go with you. I know the way and I have even spent a night with your kinsman, Gabael.'"
,"7":"Tobias said to Raphael, 'Wait for me. I am going to speak to my father. I want you to come with me to Media and I will pay you.'"
,"8":"Raphael said to Tobias, 'Go, but do not delay.'"
,"9":"Tobias went in and said to his father, 'I have found the man who will go with me.' His father said, 'Bring this man to me. I want to know the name of his tribe. I want to know if I can trust him to go with you.' Tobias went out and called Raphael. Tobias said to Raphael, 'Young man, my father wants to see you.'"
,"10":"Raphael entered the house and approached Tobit."
,"11":"Tobit said to him, 'Friend, what is the name of your tribe and of your family? Tell me.'"
,"12":"Raphael said to him, 'Are you looking for a tribe and a family or for a hired man to go with your son?' Tobit said to him, 'Friend, I want to know your tribe and your name.'"
,"13":"Raphael said, 'I am Azarias, the son of Ananias the Great, one of your kinsmen.'"
,"14":"Tobit said to him, 'Welcome, my brother! Do not be angry with me because I have tried to find out the name of your tribe and your family, for now I find that you are my kinsman, that you come from a noble and good family. Indeed, I knew Ananias and Nathan, sons of Semaiah the Great. We used to travel together to worship in the city of Jerusalem and bring the firstborn of our sheep, and a tithe of our produce. They did not adopt pagan practices when other countrymen went astray. My friend, you come of good stock."
,"15":"But tell me what salary should I give you, a drachma a day, and whatever is necessary for you as well as for my son?"
,"16":"I shall give you something over and above if you return in safety.' They settled on that. Raphael said to Tobit, 'I will go with him. Do not be afraid. We shall set out in safety and return to you in safety, because I am sure of the way.' "
,"17":"Then Tobit called his son Tobias and said to him, 'My child, prepare what is necessary for the journey and set out with your friend. May the God of Heaven protect you on your way and may he bring you back to me in safety. May his angel go with you on the way.' Then Tobias prepared to leave. He kissed his father and mother and Tobit said to Tobias, 'Safe journey!'"
,"18":"The two companions were setting off and Tobias' dog followed him when Anna, the mother of Tobias, burst into tears and said to Tobit, 'Why have you sent away our child? Is he not our support as he comes and goes?'"
,"19":"Anna said, 'What use is it to add money to money? Better we save our son's life."
,"20":"Is not what God has provided for us enough to live on?'"
,"21":"Tobit said to her, 'Don't get upset, my sister. He will return in safety. You will see him again."
,"22":"Indeed a good angel will go with him; he will have a successful journey and he will return in safety.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Anna then stopped crying."
,"2":"Raphael and Tobias continued their journey and that evening they reached the River Tigris. They spent the night there."
,"3":"As Tobias went to wash his feet, a big fish rose out of the river and tried to swallow Tobias' foot."
,"4":"Raphael said to Tobias, 'Catch that fish!' Tobias seized the fish and drew it to land."
,"5":"Raphael then said to Tobias, 'Open the fish. Take out its heart, liver and gall and put them away carefully. Throw away the intestines. The gall, the heart and the liver of this fish are useful remedies.'"
,"6":"Tobias did as the angel told him. He opened up the fish, kept the gall, the heart and the liver; then they cooked the fish and ate it."
,"7":"Then the two of them continued their journey until they reached Media. Tobias said to Raphael, 'Friend Azarias, what remedy is there in the heart, the liver and the gall of the fish?'"
,"8":"Raphael said to him, 'If you burn the heart and the liver in the presence of a man or a woman who is tormented by a devil or an evil spirit, their torments will cease."
,"9":"As for the gall, if you smear it on a man whose eyes are covered with a white film, his eyes will be cured.'"
,"10":"When they had entered Media and were already approaching Ecbatana,"
,"11":"Raphael said to Tobias, 'Friend, we shall spend the night at the house of Ragouel. He is a relative of yours. He has no son, just an only daughter called Sara."
,"12":"I will speak to him and ask that he give her to you as your wife."
,"13":"You are the one who is nearest of kin and free to marry her. You alone are of her tribe and you should inherit her father's goods. The girl is wise, good, courageous and very beautiful and her father is a good man. So listen, friend, tonight we will marry you to her. When we return from Rages, we shall take her with us and introduce her into your home. She belongs to you rather than to any other man according to the Law of Moses, and any trespasser would die. So I know that Ragouel will not give her to any other man."
,"14":"Then Tobias said to Raphael, 'Friend Azarias, I have heard that this girl has been given in marriage to seven husbands and they all died in the bridal chamber. I am my father's only son and I fear that once I have entered the room I shall die, like all those before me, because a demon loves her, and he harms those who approach her."
,"15":"Well, I fear death. I also fear causing my father and mother to die of grief on my account, for they have no other son to bury them.'"
,"16":"The angel said to Tobias, 'Do you not remember your father's advice to marry a woman of your own tribe? Well, listen to me, my friend. She will be your wife. Do not worry about the demon as this very night she will become your wife."
,"17":"'When you enter the wedding chamber you will take some glowing embers of incense, and you will put on top of them part of the heart and liver of the fish."
,"18":"As soon as the fire begins to smoke, the demon will smell it and flee never to return. And when you go to Sara, stand up together and call on the all-merciful God. He will keep you safe because he has compassion. Do not be afraid, because from all eternity Sara has been destined to be your wife. You will save her, and she will go with us. And I am sure that she will bear you children.'"
,"19":"When Tobias heard Raphael's words, he loved Sara and his heart became strongly attached to her."
}`)
	CurrentBook.AddChapter(7, `{
"1":"When they arrived in Ecbatana Tobias said to Raphael, 'Friend Azarias, take me straightaway to our friend Ragouel.' So Raphael led Tobias to Ragouel's house and they found Ragouel sitting by the door of the courtyard."
,"2":"Ragouel said to his wife, Edna, 'This young man is very like my cousin Tobit!'"
,"3":"Edna questioned them, 'Where have you come from, my friends?' They replied, 'We are of the sons of Naphtali who live as exiles in Nineveh.'"
,"4":"She asked them, 'Do you know my kinsman, Tobit?'"
,"5":"They said, 'Yes, we know him.' She continued, 'Is he in good health?' Then Tobias said, 'Tobit is my father.'"
,"6":"Ragouel ran towards him and covered him with kisses, then in tears he blessed Tobias and said to him, 'Blessings on you, you are the son of a good and worthy man!'"
,"7":"When he learned that Tobit had lost his sight he grieved and wept. 'What a misfortune that a man who is so just and generous should become blind!'"
,"8":"His wife Edna and his daughter Sara wept also and they received Tobias and Raphael with great kindness."
,"9":"They killed a sheep and served them numerous dishes. After they had bathed and washed, as they were relaxing before the meal, Tobias said to Raphael, 'Friend Azarias, tell Ragouel to give me Sara my kinswoman. Talk about what you were saying during our journey, that the matter may come about and be accomplished.' "
,"10":"Ragouel overheard the conversation and he said to Tobias, 'Eat, drink and be merry tonight. You are the man who has most right to take Sara my daughter because you are my kinsman. Indeed it is impossible for me to give her to any other man but you, because you are my closest relative. But, my son, I must tell you the whole story."
,"11":"I gave her to seven husbands from among our kinsmen. They each died on the wedding night. But, for the moment, my son, eat and drink and the Lord will arrange things for you.',Tobias said, 'I shall eat nothing if you do not stop now and bring this matter to a conclusion.' Ragouel said to Tobias, 'Take her from now on; I give her to you according to the Law of Moses and you have to understand that God himself gives her to you. Receive your kinswoman, from now on you are her brother and she is your sister. She is yours from today and forever. Now God will bless you this night and may he give you both his mercy and peace.'"
,"12":"He called his daughter Sara and taking her by the hand, he gave her to Tobias as his wife. He said, 'According to Moses' Law, take her now and bring her to your father's house.' And he blessed them."
,"13":"Ragouel then called Edna his wife; taking a sheet of parchment, he wrote down a matrimonial contract and they both affixed their seals."
,"14":"Then they all began to eat."
,"15":"Ragouel called his wife and said to her 'My sister, prepare the other room and take Sara there.'"
,"16":"Edna did as Ragouel told her and she took Sara to this room and Sara began to cry. Edna dried her daughter's tears and said,"
,"17":"'Have courage, my child, the God of heaven and earth will change your sorrow into joy. Have confidence, my daughter!'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"When they had finished eating and drinking they wished to go to bed, so they escorted Tobias to the bedroom where Sara was."
,"2":"Tobias remembered Raphael's words. He took the liver and the heart of the fish which he had in a basket and put them on the hot coals of incense."
,"3":"The smell of the fish made the devil flee to the upper regions of Egypt where Raphael chained him up."
,"4":"When Sara's parents had left the room and closed the door, Tobias got up from the bed and said to Sara, 'Get up, my sister, and let us ask the Lord to have mercy on us and save us.'"
,"5":"She got up and they began to pray, asking that they be given life. Tobias began like this, 'May you be blessed, O Lord God of our fathers, and may your holy and glorious Name be blessed forever. May the heavens and all creatures bless you. "
,"6":"You created Adam and you gave him Eve, his wife, as a helper and companion, so that from these two the human race might be born. You said: 'It is not good that man should be alone, let us give him a companion who is like himself.' "
,"7":"Now, Lord, I take my sister to myself in sincerity and love, not merely seeking pleasure. Have mercy on us and grant us a long life together.'"
,"8":"Together they said, 'Amen,'"
,"9":"and returned to bed for the night. Ragouel got up early and called his servants and told them to dig a grave. "
,"10":"For he said to himself, 'What if this man should also die and we become an object of scorn and reproach.'"
,"11":"Then Ragouel entered the house and said to his wife,"
,"12":"Edna, 'Send one of the maidservants to see if Tobias is alive. If he has died, we will bury him without anyone knowing.'"
,"13":"The maidservant opened the door and saw them asleep."
,"14":"She then went to tell them that Tobias was alive."
,"15":"Ragouel blessed the Lord saying, 'May you be blessed, O Lord, with all pure and holy blessings. May the saints and all your creatures bless you. May all the angels and the elect bless you forever."
,"16":"May you be blessed for having filled me with joy. What I feared has not happened, but you have treated us with great kindness"
,"17":"and have had mercy on these two who are only children. Have mercy on them, Lord, and give them your grace and protection so that they may be blessed with good health and great joy all their lives. May they always live in your grace.'"
,"18":"Then he sent his servants to fill in the grave before daybreak. Ragouel organized for Tobias and Sara a wedding feast which was to last fourteen days. "
,"19":"He told his wife to bake a batch of bread. He went to the stable, brought out two oxen and four sheep and ordered that they be killed and prepared."
,"20":"He then called Tobias and said to him, 'You will stay here for fourteen days, eating and drinking in my house, and you will bring joy to my daughter, who has suffered so much.' Ragouel swore an oath and told Tobias that he should not set out before the fourteen days of the wedding festivities were over. And he said, 'You will go home to your father in safety."
,"21":"You will take with you half of my possessions; the other half will be yours when I and Edna die. Have confidence, my son, I am now your father and Edna is your mother. From now on we shall be close to you and your wife. Have confidence!'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Tobias called Raphael and said to him,"
,"2":"'Brother Azarias, please take with you a manservant and two camels and go to Rages in Media."
,"3":"Call on Gabael, give him the receipt and recover the money. Then invite Gabael to the wedding feast. You saw that Ragouel made me swear an oath, so I may not depart from this house without breaking the oath."
,"4":"Yet you know that my father is counting the days and if I delay longer than necessary he will be worried."
,"5":"Raphael set out for Rages in Media and stayed the night in Gabael's house. Raphael presented him with the receipt, and Gabael brought out the sealed bags of money and gave them to him."
,"6":"The next morning they arose early and set off to the wedding. When they entered Ragouel's house, they found Tobias at the table. Gabael went to him and embraced him. He wept and blessed Tobias saying, 'Good and worthy man, son of a good and honest father, a man who is just and compassionate, may the Lord of Heaven bless you and your wife. May he also bless the father and mother of your wife. Blessed be God because I have seen Tobias, my cousin, who is so like his father.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Each morning Tobit counted how many days it would be before Tobias would return from his journey. When the time was up and his son, Tobias, and his companion, Raphael, had not yet returned,"
,"2":"he thought, 'Maybe he has received a refusal, or perhaps Gabael is dead and there is no one to hand over the money.'"
,"3":"He became very sad."
,"4":"Anna his wife said, 'My son is dead or he would not delay so long.' She began to lament over him saying,"
,"5":"'why did I let you go, light of my eyes!'"
,"6":"Tobit said to her, 'Calm yourself, my sister. Do not worry. He is well.'"
,"7":"She replied, 'Keep quiet, do not try to deceive me, my child is dead.' Every day she went out along the road which her son had taken. By day, she took no food; by night, she never ceased crying, unable to sleep. When the fourteen days of festivities were over during which Ragouel had sworn that Tobias should stay with him, Tobias went to Ragouel and said, 'Let me return home because my parents will certainly be despairing that they will never see me again.' "
,"8":"Ragouel replied, 'Stay with me and I will send messengers to your father to give him news of you.'"
,"9":"Tobias said, 'No, let me go to them.'"
,"10":"Then Ragouel handed over to him his wife Sara and half of all his goods: servants, oxen, sheep, donkeys, camels, clothes, silver and various other things. Ragouel blessed them and allowed them to set out."
,"11":"Bidding farewell to Tobias he said to him, 'Goodbye, my son, safe journey! May the Lord of Heaven bless you and make you fruitful and may I see your children before I die.'"
,"12":"To his daughter, Sara, he said, 'Honor your parents-in-law, since from now on they are your parents just as we are who gave you life. Go in peace, my daughter, and may we always hear good things of you.' He embraced her and let them depart."
,"13":"Edna, in her turn, said to Tobias, 'My dear son, may the Lord bring you back one day so that I may see your children and be happy before the Lord. I entrust my daughter to your care. Do not cause her any sadness.'"
,"14":"After that Tobias left Ragouel's house. He praised God who had brought his journey to such a happy conclusion, and he blessed Ragouel and his wife, Edna."
}`)
	CurrentBook.AddChapter(11, `{
"1":"When they arrived near Kaserin which faces the city of Nineveh,"
,"2":"Raphael said to Tobias, 'You know in what state your father Tobit was when we left him;"
,"3":"let us go ahead to prepare the house before your wife Sara arrives."
,"4":"Bring with you the gall of the fish.' The dog also went with them, walking behind them."
,"5":"Now Anna was sitting there, scanning the road along which her son should return."
,"6":"She saw Tobias and Raphael coming in the distance and said to the father of Tobias, 'Your son is coming with the man who accompanied him.'"
,"7":"While Tobias and Raphael were still going along the road, Raphael said to Tobias, 'I am sure that your father will regain his sight."
,"8":"Rub his eyes with the fish gall and when he feels his eyes itching, he will rub them and the film will come away like scales from his eyes. He will regain his sight and see the light.'"
,"9":"Anna ran to meet Tobias and threw her arms around his neck saying, 'At last I have seen you again, my child. Now I can die!' And both of them began to cry."
,"10":"Tobit also got up and, stumbling, arrived at the door of the courtyard. Tobias ran to him"
,"11":"with the fish gall in his hand. He breathed on his father's eyes, embraced him and said, 'Father, have confidence!'"
,"12":"Then he spread the fish gall on Tobit's eyes. Tobias waited."
,"13":"When his eyes began to itch, Tobit rubbed them and with both hands scaled off the film from the corners of his eyes. When Tobit saw his son he threw his arms around Tobias' neck"
,"14":"and began to weep. He said, 'Blessed be you, O God. Blessed be your Name forever. Blessed be your holy angels."
,"15":"You have punished me, but you have taken pity on me, and now I can see my son, Tobias.',Tobias was very happy. After entering the house he told his father about the important things that had happened in Media. He told his father about the successful outcome of his journey, how he got the money, and how he married Sara, daughter of Ragouel, who just then was approaching the gates of Nineveh."
,"16":"Tobit, happy and praising God, went out to meet his daughter-in-law at the gates of Nineveh. All those who saw him, walking alone and unaided, were amazed that he could see."
,"17":"Tobit proclaimed to them that God had taken pity on him and cured him. Then he went to Sara and blessed her saying, 'Welcome, daughter! May God be blessed for having brought you to us and may your father and mother also be blessed.',It was a day of great rejoicing for all Tobit's relatives who lived in Nineveh. "
,"18":"Ahikar, Tobit's nephew and Nabad arrived (from Elymiade) and the wedding celebrations lasted for a week."
}`)
	CurrentBook.AddChapter(12, `{
"1":"When the wedding feast was over, Tobit called Tobias, his son, and said to him, 'Be sure you give the wages to the man who accompanied you, and we should add something extra.'"
,"2":"Tobias said, 'What shall I give him? It would not be too much if I were to give him half of what I have brought back since"
,"3":"he has brought me home again safe and sound. He has taken care of my wife and he helped me to get back the money. He has also cured your blindness.'"
,"4":"The old man said, 'That amount would be well justified in his case.'"
,"5":"Then Tobias called the angel and said to him, 'Please take half of all that you have brought.'"
,"6":"The angel took Tobit and Tobias to one side and said to them, 'Bless God, return thanks to him, proclaim his glory and render him thanks before all the living for all he has done for you. It is good to praise God and to exalt his Name, by making known in a worthy manner the story of God's deeds. Do not be slow in giving him thanks. "
,"7":"It is good to hide the secrets of kings but to make known publicly the works of God. Do the works of God. Do good, and evil will not harm you."
,"8":"It is a good thing to accompany prayer with fasting, almsgiving and justice. It is better to do a little with honor than much with injustice. It is better to give alms than to treasure up gold."
,"9":"Almsgiving preserves from death; it purifies from all sin. Those people who give alms and act justly will have a long life,"
,"10":"but sinners only harm themselves."
,"11":"I will hide nothing from you. Yes, I have said that it is good to keep the secrets of kings but to make known publicly the glorious works of God."
,"12":"Tobit, when you and your daughter-in-law Sara prayed, I kept the remembrance of your prayer before the Holy One; when you, Tobit, buried the dead,"
,"13":"I was with you in the same way; and when you did not hesitate to rise up and leave your meal in order to hide the dead man, your good deed did not go unnoticed because I was with you."
,"14":"Well, God sent me to cure you and also to cure Sara, your daughter-in-law."
,"15":"I am Raphael, one of the seven holy angels who present the prayers of holy people and who stand before the glory of God.'"
,"16":"They both trembled with fear. They threw themselves face downwards on the ground because they were seized with terror."
,"17":"But Raphael said to them, 'Do not be afraid; be at peace! Bless God always,"
,"18":"for I did not come on my own account but because God willed it. Bless him forever."
,"19":"All the time that I was visible to you I neither ate nor drank anything. I only appeared to do so."
,"20":"Now bless and give thanks to God, because I am returning to the One who sent me. Write down in a book all that has happened.'"
,"21":"Then he rose up and disappeared. Tobit and Tobias got up, but Raphael was no longer visible."
,"22":"They made known the great and wonderful works of God and how an angel of the Lord had appeared to them."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Tobit, in an ecstasy of joy, composed a prayer: 'Blessed be God, living and reigning for all ages."
,"2":"It is he who punishes and he who has mercy; who makes people go down to hell and rise up again. No one can escape his hand."
,"3":"Give him thanks, sons of Israel, before all the nations. Though he has dispersed you among them "
,"4":"he now shows you his greatness. Exalt him before all the living, because he is our God and Lord, our Father forever."
,"5":"He punishes us for our wrongdoing,but again he will forgive us. He will bring us together again,from amongst all the nations among whom we have been dispersed."
,"6":"If you turn back to him with all your heart and soul, and live justly before him, then he will turn back to you,and will no longer hide his face from you."
,"7":"See what he has done for you,and return him thanks aloud. Bless the Lord who alone is just,and praise the King of ages."
,"8":"I, in the land of my captivity, will return him thanks,and show his strength and greatness to my sinful people. Be converted, you sinners, and live justly before him, certain that he will be pleased with you and show you mercy."
,"9":"I will praise my God the King of heaven; my soul, radiant with happiness, will proclaim his greatness."
,"10":"May all in Jerusalem give thanks to him."
,"11":"Jerusalem, holy city, God will punish you because of the sins of your children, but he will have pity once more on the children of the just. Jerusalem, return thanks to the Lord in a worthy manner,and bless the King of the ages, in order that his Temple may be rebuilt in your midst with joy;"
,"12":"that, there, God will gladden your exiles and show love to the unfortunate."
,"13":"Many nations will come from afar to celebrate the Name of the Lord God. They will carry gifts in their hands, gifts for the King of heaven. Generation after generation will manifest their joy, and your name will be glorified forever."
,"14":"Jerusalem, cursed be all who hate you. Blessed forever be those who love you."
,"15":"You will rejoice and be glad,because the children of the just will be gathered again to praise the Lord of all ages."
,"16":"Blessed those who love you, Jerusalem, and rejoice in your peace. Blessed also those who have sorrowed because of your calamities; they will rejoice again on seeing your glory and they will share your happiness forever. May my soul bless God, the great King, "
,"17":"because Jerusalem will be rebuilt. Her gates will be built of sapphires and emeralds, her walls of precious stones, her towers and ramparts of pure gold, her squares will be paved with mosaics of beryl, ruby, and stone of Ophir."
,"18":"All her streets will cry out with joy and her inhabitants will shout, 'Alleluia.',They will praise God saying, 'Blessed be God who has glorified you forever.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"In this way Tobit ended his song of thanksgiving. Tobit died peacefully at the age of one hundred and twelve years, and was buried with honor in Nineveh."
,"2":"He was sixty-two years old when he became blind. Eight years later he regained his sight. He lived happily, practiced almsgiving, and continued to praise God and to proclaim his great works."
,"3":"When he was very old he called Tobias and said to him, 'My son, you see that I have become old and that I am near death. Take your children"
,"4":"and go to Media because I believe in the word of God which Nahum prophesied about Nineveh. Everything that the prophets sent by God pronounced about Assyria and Nineveh will happen. No word will be forgotten but it will all come to pass in due time. Nineveh will be destroyed. You will be safer in Media, where there will be peace for some time, because I am certain and I believe that all that God has said will be fulfilled. Our brothers and sisters who live in the land of Israel will be dispersed and led away into captivity. As a result the whole of the land of Israel will be deserted. Jerusalem and Samaria will be desolate. The House of God will be burned down and left in ruins for some time. "
,"5":"But God will again take pity on his people and they will return to their land. They will rebuild the Temple, though it will not be like the first one until better times come. When that time comes they will all return from captivity. They will rebuild Jerusalem in all its magnificence. In it they will rebuild the House of God in all its glory for all generations to come, just as the prophets have foretold."
,"6":"People of all nations will be converted and know the true God. They will bury their idols which led them into error"
,"7":"and they will praise the God of Justice. All the Israelites saved at that time will remember the Lord in all truth. They will come together and go to Jerusalem. They will live securely forever in the land of Abraham which will be given back to them. Those who sincerely love God will rejoice. But sinners and the unjust will disappear from the earth."
,"8":"My son, leave Nineveh. Do not remain here."
,"9":"Now, my children, I give you this advice: serve God and do what is pleasing in his sight. Teach your children how to exercise justice and how to give alms. Teach them also to remember God and to bless his name sincerely at all times, with all their strength."
,"10":"The very day that you bury your mother here beside me, do not stay overnight in this place. I know that the people here commit many injustices and practice great treachery and no one is ashamed of doing so. You see what Nadab did to Ahikar my nephew who had brought him up. He buried him alive. But God punished Nadab by exposing his injustice. He brought Ahikar into the light and sent Nadab down into eternal darkness, because he had tried to kill him. Because he gave alms, Ahikar was delivered from the death planned for him by Nadab. Instead, Nadab fell into the trap and perished."
,"11":"See how almsgiving and uprightness can save you and how wrongdoing leads to death. But I feel I am breathing my last.' They laid him on his bed and he died. He was given an honorable burial."
,"12":"When Anna his mother died, Tobias buried her next to his father. Then Tobias with his wife and family made their way to Media and settled in Ecbatana near Ragouel, his father-in-law."
,"13":"He took great care of his parents-in-law in their old age and he buried them with honor in Ecbatana in Media. Tobias inherited Ragouel's fortune as well as that of his father Tobit."
,"14":"Tobias died at the age of one hundred and twenty-seven years at Echbatana in Media."
,"15":"But before he died he saw the downfall of Nineveh which Nebuchadnezzar destroyed. He saw the Ninevites and the Assyrians reduced to slavery and taken to Media. Thus, before he died, he was able to rejoice over the fate of Nineveh. He blessed the Lord God forever."
}`)

}
func EN_CCB_LoadVMBRChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"These are the words of the book written by Baruch, the son of Neriah, descended from Massiah, from Sedekiah, from Hasadiah, from Hilkiah."
,"2":"They were written in the fifth year, on the seventh day of the month, at the time when the Chaldeans had taken Jerusalem and burned it."
,"3":"Baruch read the words of this book to Jeconiah, the son of Joachim, the king of Judah, in the presence of all the people who had come together to hear it read."
,"4":"He read it in the hearing of the nobles and the king's sons, of the elders and all the people, from the smallest to the greatest - that is, all those who were living in Babylon near the River Sudi."
,"5":"Then the people wept and fasted and prayed before the Lord."
,"6":"They also collected money according to what each one could afford"
,"7":"and this they sent to Jerusalem, to the priest Jehoiakim, son of Hilkiah, the son of Shallum, and to the other priests and people who dwelt in Jerusalem with him."
,"8":"This same Baruch had undertaken to carry back to Judea, on the tenth day of the month of Sivan, the sacred vessels which had been taken away from the Temple of the Lord. These were the silver vessels made by Zedekiah, son of Josiah, king of Judah,"
,"9":"after Nebuchadnezzar, the king of Babylon, had carried off Jeconiah, the artisans, the nobles and the people of the land and had taken them captive to Babylon."
,"10":"The letter said: Look, we are sending you money; buy with it victims for the holocaust and for sin offerings and incense; prepare oblations and offer them on the Altar of the Lord our God."
,"11":"Pray for the life of Nebuchadnezzar, king of Babylon, and of Balthasar, his son, so that they may be successful in all that they do."
,"12":"Thus the Lord will give strength and light to our eyes. We will live under the protection of Nebuchadnezzar, King of Babylon, and of his son, Balthasar. We shall have a long life serving them and we shall find favor before them."
,"13":"Pray to the Lord our God for us also, for we have sinned against the Lord our God, even to this day the anger of the Lord and his fury have not been turned away from us."
,"14":"Finally, read this book which we are sending to you, so that you can read it publicly in the House of the Lord on the day of the Feast and on other suitable days."
,"15":"You will say: May everyone recognize the justice of our God but, on this day, shame and confusion befit the men of Judah and the inhabitants of Jerusalem -"
,"16":"our kings and princes, our priests, our prophets, and our fathers,"
,"17":"because we have sinned before the Lord."
,"18":"We have disobeyed him and have not listened to the voice of the Lord our God, nor have we followed the commandments which the Lord had put before us."
,"19":"From the day that the Lord brought our fathers out of the land of Egypt until this day, we have disobeyed the Lord our God and we have rebelled against him instead of listening to his voice."
,"20":"Because of this, from the day on which the Lord brought our fathers out of the land of Egypt, so as to give them a land flowing with milk and honey, the evils and the curse which the Lord pronounced by Moses, his servant, have dogged our footsteps right down to the present day."
,"21":"We did not listen to the voice of the Lord our God speaking through the words of the prophets whom he sent to us,"
,"22":"but each one of us followed his perverted heart, serving false gods and doing what displeases the Lord our God."
}`)
	CurrentBook.AddChapter(2, `{
"1":"That is why the Lord our God has carried out the word which he spoke against us, against the judges who have governed Israel, against our kings, our princes and the men of Israel and Judah."
,"2":"No one under the sky has ever seen the like of what happened in Jerusalem, according to what is written in the book of Moses."
,"3":"For people among us came to eat their son's and daughter's flesh."
,"4":"And he handed them over into the power of all the surrounding kingdoms, so that they were cursed and humiliated among the neighboring peoples among whom the Lord had scattered them."
,"5":"Submission and not command has been our lot, because we have sinned against the Lord our God and have not listened to his voice."
,"6":"Just is the Lord our God, whereas shame and confusion befit us and our fathers right down to this day."
,"7":"All those evils which the Lord prophesied concerning us have fallen upon us."
,"8":"And we have not begged the Lord to make each of us turn away from the thoughts of our evil hearts."
,"9":"Then the Lord kept watch over the evils and allowed them to come upon us, for the Lord is just in all that he has commanded us to do."
,"10":"We have not listened to his voice nor followed the commands which the Lord has ordered us to keep."
,"11":"And now, Lord God of Israel, you who brought your people out of Egypt with a strong hand, with miracles and wonders and great power, you who stretched out your arm and made for yourself a name such as you have today,"
,"12":"we have sinned. We have been godless and unjust, Lord, careless about all your commands."
,"13":"May your fury be turned away from us, for there are very few of us left among the nations in which you have scattered us."
,"14":"Hear our supplication and our prayer, O Lord, deliver us for your own honor and let us find favor with those who deported us."
,"15":"Let all the earth know that you are the Lord our God, because Israel and its people bear your name."
,"16":"Lord, look down from your holy dwelling place and think of us; Lord, incline your ear and listen;"
,"17":"Lord, open your eyes and consider: it is not the dead, lying in the netherworld, who will praise your glory and justice,"
,"18":"since their spirit has been taken from their breast. Grieving under his burden, and walking bowed down and exhausted, the man with eyes sore from weeping and who is hungry - these are they, who can give you glory and justice, O Lord."
,"19":"For it is not on account of the merits of our fathers and of our kings that we pour out our cry for pity before you, O Lord our God."
,"20":"You have sent down on us your fury and your anger as you announced through your servants, the prophets, saying,"
,"21":"'Thus says the Lord: Bend your shoulders and serve the king of Babylon and you will dwell in the land that I gave to your fathers."
,"22":"But if you do not listen to the voice of the Lord your God and serve the king of Babylon,"
,"23":"I will bring to an end in the towns of Judah and in Jerusalem the song of joy and gladness, the song of the bridegroom and the bride, and the whole country will become a desert without inhabitants."
,"24":"We did not listen to your invitation to serve the king of Babylon and so you carried out what you had foretold by your servants, the prophets, that the bones of our kings and our fathers would be taken from their graves."
,"25":"See, they have been exposed to the heat of the day and the cold of the night; they died in cruel sufferings, by famine, by the sword and by plagues."
,"26":"And you have reduced the nation which bears your name to the state in which it is today because of the wickedness of the people of Judah."
,"27":"However, you have acted towards us, O Lord our God, indulgently and with great tenderness,"
,"28":"as you foretold by your servant Moses, the day you ordered him to write down your Law in the presence of the children of Israel saying:"
,"29":"If you do not listen to my voice, this great and vast multitude will be reduced to a small remnant among the nations where I shall scatter them;"
,"30":"for I know well that they will not listen to me because they are a stiff-necked people. But in the land of their exile their hearts will be converted"
,"31":"and they will know that I am the Lord their God."
,"32":"And I will give them a heart and listening ears, that they may praise me in the land of their exile and remember my name."
,"33":"They will repent of their stiff-necked obstinacy and their evil deeds, because they will remember what happened to their fathers who had sinned before the Lord."
,"34":"And I will lead them into the land which I have promised by oath to their fathers, to Abraham, Isaac and Jacob and they will take possession of it. I will increase their number and it will no longer diminish."
,"35":"I will make with them an everlasting covenant; I will be their God and they shall be my people. I will no longer drive my people Israel from the land which I have given them."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Almighty Lord, God of Israel, a soul in anguish and a discouraged spirit cries out to you."
,"2":"Listen, Lord, and have pity for we have sinned against you;"
,"3":"for you reign forever while we perish forever."
,"4":"Lord, all-powerful God of Israel, listen then to the prayers of the dead of Israel. We are the sons of those who sinned against you, who did not listen to the voice of their God, and this is why disgrace has come upon us."
,"5":"Do not remember any longer the wrongdoing of our fathers, but remember at this time your power and your name;"
,"6":"for you are the Lord, our God and we will praise you, Lord."
,"7":"That is why you have put your fear into our hearts and we call upon your name. And we will praise you in our exile for we have removed from our hearts all the wrong of our fathers who sinned against you."
,"8":"We are here today in our exile where you have scattered us to be insulted, cursed and condemned for the wrongdoing of our fathers, who separated themselves from the Lord our God."
,"9":"Listen, Israel, to the commands of life, give ear so as to learn prudence,"
,"10":"Why, Israel! Why are you in the land of your foes? Why are you growing old in a foreign country, contaminated by pagans,"
,"11":"counted among those who go to the pit?"
,"12":"You have abandoned the source of Wisdom."
,"13":"If you had walked in the way of God, peace would be your dwelling place forever."
,"14":"Learn where is Wisdom, where is Strength and Understanding, that you may know, at the same time, where are length of days and life, light of the eyes and Peace."
,"15":"Who will find Wisdom's dwelling?,Who will enter her storage rooms?"
,"16":"Where are the leaders of the nations, those who commanded the beasts of the earth,"
,"17":"who played with the birds of the heavens, who piled up silver and gold - in which men put their trust -,and who never tired of collecting it?"
,"18":"Amassing money was their only concern, their business beyond measure."
,"19":"But they have disappeared, they have gone down to the dead,and others have risen in their place."
,"20":"A younger generation is there,on the earth and enjoys the light, but they have not known the ways of knowledge; they have not seen his tracks nor have they met him,"
,"21":"and their sons after them did not leave their paths."
,"22":"No one in Canaan has heard of Wisdom, no one has seen her in Teman."
,"23":"The sons of Agar, who seek knowledge of the earth, the traders of Madian and Teman, the tellers of fables and philosophers, they have not known the path of Wisdom, they have not discovered her ways."
,"24":"O Israel, how great is the house of God, how vast his dominion!"
,"25":"It is great and has no limits. It is lofty, wide and immeasurable."
,"26":"There were born the ancient and famous giants,of high stature and skillful in war."
,"27":"God did not choose them, he did not teach them the ways of Wisdom,"
,"28":"and they perished because of their folly, because they lacked knowledge."
,"29":"Who has ascended to Heaven that he may lay hold of her,and bring her down from the clouds?"
,"30":"Who has crossed seas and found her, and bought her with the purest of gold?"
,"31":"There is no one who knows her path, no one who thinks of her way."
,"32":"But he who knows everything recognizes her. He has found her in his own intellect. He who created the earth, for all time, and has filled it with four-footed beings."
,"33":"He who sends the light, and it goes, who recalls it, and trembling it obeys."
,"34":"The stars shine, full of joy, to keep their night watches. He calls them and they answer, 'Here we are.',They shine with joy for their Creator."
,"35":"It is he who is our God, no other can be compared with him."
,"36":"He has found the way of understanding and has given her to Jacob his servant and to Israel his well-beloved."
,"37":"Then Wisdom was seen on earth and lived among men."
}`)
	CurrentBook.AddChapter(4, `{
"1":"She herself is the book of the commands of God, the law which endures forever. All who hold fast to her will have life,but those who abandon her will die."
,"2":"Come back, Jacob, and embrace her, walk towards brightness under her light."
,"3":"Do not give up what is your glory or sell your privileges to any strange nation."
,"4":"We are fortunate, O Israel, for we know what pleases the Lord!"
,"5":"Take courage, my people, you who preserve the memory of Israel."
,"6":"You have been sold to the nations but not for your destruction; because you had aroused the anger of God, you were delivered to your enemies."
,"7":"For you displeased your Creator in sacrificing to demons and not to God."
,"8":"You have forgotten the Eternal God, the one who nourished you. You have filled Jerusalem with sadness, she who brought you up."
,"9":"For she saw the anger of God fall on you and she said, 'Listen, you neighboring cities of Zion, God has sent me a great sorrow."
,"10":"I have seen the captivity of my sons and daughters, which the Eternal one brought on them."
,"11":"I had nurtured them in joy; with tears and sadness I saw them leave."
,"12":"Let no one rejoice on seeing me a widow and abandoned by all. Because of the sins of my children I am now alone, because they have turned away from the law of God."
,"13":"They have not remembered its precepts; nor have they walked in the ways of his commandments, and followed the discipline which leads to uprightness."
,"14":"Let them come, the neighbors of Zion, and remember the captivity which the Eternal One laid on my sons and daughters."
,"15":"For he caused a distant nation to come against them, a ruthless nation with an unknown language. They had no respect for the old, and no pity for the infant; "
,"16":"they took away the only son of the widow, as well as her daughter, and left her alone."
,"17":"But as for myself, how can I help you?"
,"18":"He who caused these evils to come upon you will deliver you from the hands of your enemies."
,"19":"Well, my children, go on your way; as for me, I am left alone."
,"20":"I have taken off the garment of peace and put on again the sackcloth of penance and prayer. I will cry out to the Eternal One all the rest of my days."
,"21":"Come, take courage, my children, cry out to God. He will deliver you from the violence of the enemy."
,"22":"Because I hoped for your salvation from the Eternal One, joy has come to me from the Holy One, because of the mercy that will come to you soon from the Eternal One, our Savior."
,"23":"In tears and mourning, I saw you leave, but in joy and gladness God will bring you back to me forever."
,"24":"As the neighbors of Zion have seen your captivity so they will soon see your salvation from God, when he manifests to you the great glory and the splendor of the Eternal God."
,"25":"Children, bear patiently this punishment which came on you from God. The enemy has persecuted you, but you will soon see his downfall and you will trample him underfoot."
,"26":"My well-beloved children have walked by difficult paths, carried off like a herd stolen by enemies."
,"27":"Take courage, my children, cry out to God, for he who sent you into exile will remember you."
,"28":"Thus, as you distanced yourself from God, return to him and seek him ten times more earnestly."
,"29":"For he who caused these evils to fall on you will bring you salvation and eternal joy."
,"30":"Take courage, Jerusalem. He who has named you will console you."
,"31":"Cursed be those who did evil to you and rejoiced in your downfall."
,"32":"Cursed be those cities in which your children were slaves, cursed the nation in which they had to live."
,"33":"Just as that nation rejoiced in your downfall and took pleasure in your destruction so will she be afflicted and destroyed."
,"34":"I will take from her the joy of being a numerous people; her pride will be turned into mourning."
,"35":"A fire will descend on her from the Eternal One and burn for many days. She will be inhabited by demons for a long time."
,"36":"Jerusalem, look towards the East, and see the joy which is coming to you from God."
,"37":"Look, your sons who were scattered are returning. They are assembling, coming together, from the East and from the West, at the voice of the Holy One, rejoicing in the glory of God."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Jerusalem, put off your garment of mourning and unhappiness, put on the splendor and glory of God forever."
,"2":"Wrap yourself in the mantle of holiness that comes from God, put on your head the crown of glory of the Eternal One."
,"3":"For God will show your splendor to every being under Heaven."
,"4":"He will call your name forever, 'Peace in Justice' and 'Glory in the Fear of the Lord.'"
,"5":"Rise up, Jerusalem, stand on the heights. Look towards the East and see your children gathered together from the setting of the sun to its rising, by the voice of the Holy One, rejoicing because God has remembered them."
,"6":"They left you on foot, taken away by the enemy. God will lead them back, carried gloriously like royal princes."
,"7":"For God has resolved to bring low every high mountain and the everlasting hills, to fill up the valleys and level out the ground, in order that Israel may walk in safety under the Glory of God."
,"8":"Even the forests and the fragrant trees will give shade to Israel at God's command."
,"9":"For God will lead Israel with joy by the light of his Glory, escorting them with his mercy and justice."
}`)
	CurrentBook.AddChapter(6, `{
"0":"A copy of the letter which Jeremiah sent to those who were to be taken captive to Babylon by the king of the Babylonians, to let them know what God had ordered him."
,"1":"'Because of the sins you have committed against God, you will be led captive to Babylon by Nebuchadnezzar, king of the Babylonians. "
,"2":"After your arrival in Babylon you will remain there for a number of years - a long time, for seven generations; but after that I shall bring you home in peace."
,"3":"In Babylon you will see gods of silver, gold and wood, carried on men's shoulders and filling the people with fear."
,"4":"Take care not to copy what foreigners do and not to let yourselves be terrified by them"
,"5":"when you see the crowds pressing in front and behind to adore them."
,"6":"Say rather to yourselves: 'Master, it is you we are to adore.' My angel is with you to take care of your lives."
,"7":"Their tongues have been polished by a craftsman and even if they are of gold and silver, they are false and are unable to speak."
,"8":"As for a maiden conscious of her appearance, these pagans make golden crowns for their gods."
,"9":"Yet at times the priests steal the gold and silver from their gods for their own use and for the prostitutes in their temples."
,"10":"They give clothes to these gods as if they were men, but they are only things of gold, silver and wood, which cannot defend themselves from rust or woodworm."
,"11":"So, after clothing them in purple, they wipe their faces because of the thick dust of the temple that covers them."
,"12":"The god has a scepter like a governor of a province, but he cannot destroy the person who has wronged him."
,"13":"He carries sword and axe in his right hand, but he is helpless both in war and against thieves."
,"14":"This clearly proves they are not gods; have no fear of them."
,"15":"A broken pot is useless for anyone. So are those gods enshrined in their temples."
,"16":"Their eyes are full of the dust raised by those who enter."
,"17":"Just as doors are carefully closed on a man who has offended the king or on a convict sentenced to death, in the same way the priests lock and bolt the doors of the temple for fear of thieves."
,"18":"They light lamps, far more numerous than what they need for themselves, and yet the god sees no one."
,"19":"He is no more than any of the beams of the temple and some whisper that the inner part is gnawed by termites; worms out of the ground devour both the god and his clothes, but he feels nothing."
,"20":"Their faces have become black because of the smoke of the temple."
,"21":"Owls alight on their heads and shoulders, swallows and other birds perch on them and cats prowl around them."
,"22":"This tells you they are not gods, so have no fear of them."
,"23":"If the rust on the gold that adorns them is not removed, they cannot shine. Yet what does it matter? Even when they were cast they felt nothing."
,"24":"They may be bought at a high price but there is not a breath of life in them."
,"25":"As they are without feet, they are carried on men's shoulders, showing publicly their shame. What a confusion for their worshipers if the god falls! They must lift him up."
,"26":"Once he has been stood up, he does not move. If tilted, he is helpless to straighten up. So you make offerings to these gods as you make to dead men."
,"27":"The priests collect what has been offered for sacrifice, selling it, while the wives salt some of it but give nothing to the poor and helpless. Do you think these are true offerings? Even women giving birth or who are ritually unclean touch them."
,"28":"See that they are not gods and have no fear of them."
,"29":"How can they be called gods? Women carry offerings to things made of silver, wood and gold."
,"30":"The priests remain seated in the temple, their garments torn, head and beard shaved, and no covering on their heads."
,"31":"They roar and cry in the presence of their gods as do certain people during funeral meals."
,"32":"With the garments taken from the gods the priests clothe their wives and their children."
,"33":"Whether they are treated well or shabbily, the gods can make no return, neither can they make or unmake a king."
,"34":"They are incapable of bestowing riches or money. If someone fails to keep a vow, he is not called to account."
,"35":"They can neither save a man from death nor rescue a helpless person from the clutch of the powerful."
,"36":"They cannot restore sight to the blind or save someone in distress."
,"37":"They will show no compassion to the widow nor do good to the orphan."
,"38":"These pieces of wood plated with gold and silver are no more worthy than rocks hewn out of a mountain and their worshipers shall be humiliated."
,"39":"How then can anyone believe they are gods? How can they be called gods?"
,"40":"The Chaldeans themselves have put them to shame. If they see someone who is dumb, unable to speak, they bring him before Bel, entreating him to make him speak, as if the god could hear them!"
,"41":"And yet these thinking people are unable to abandon gods that are completely devoid of sense."
,"42":"Women with cord round their waists sit in the street burning bran."
,"43":"When one of them has been picked up by a passerby and has slept with him, she taunts her companion for not having been so highly regarded as herself and for failing to have her cord broken."
,"44":"All that goes on anywhere near these gods is false. How can they be considered or declared to be gods?"
,"45":"They have been fashioned by craftsmen and goldsmiths; they are nothing more than what the artisans decided they were to be."
,"46":"Those who made them haven't long to live; so how could the work of their hands be gods?"
,"47":"What they leave to their descendants is nothing more than illusion and shame."
,"48":"For when war or other disasters come upon them, they discuss among themselves where they, with their gods, will hide."
,"49":"How could anyone fail to be convinced that what cannot save from war and disaster is not a god?"
,"50":"Later on, these pieces of wood plated with silver and gold will be known to be false. It will be plain to all kings and nations that they are not gods, but merely the handicraft of men and God does nothing through them."
,"51":"Is there anyone unconvinced that these are not gods?"
,"52":"They are incapable of establishing a king in a country or of sending rain to people."
,"53":"They are unable to discern what is just or to rescue a person who has been wronged. They are as helpless as crows between the sky and the ground."
,"54":"When fire breaks out in the temple of these wooden gods plated with silver and gold, the priests flee to safety but their gods are burnt with the beams in the midst of the flames."
,"55":"They can neither resist a king nor a hostile army."
,"56":"How can it be admitted or believed that they are gods?"
,"57":"These gods cannot escape either from thieves or brigands. These are more powerful and despoil them of their gold, their silver and their robes. Such gods are unable to defend themselves."
,"58":"Better to be a king with a show of power, or even a household pot that is of some use to its owner than to be a false god; better even to be the door of a house that guards what is within, or a wooden column in a royal palace than to be a false god."
,"59":"The sun, moon and stars that shine and serve us are obedient to God;"
,"60":"likewise the lightning that is beautiful to see, and the wind that blows over the country"
,"61":"and the clouds passing over the earth at God's command, fire sent from on high to consume mountain and forest - all do what is commanded."
,"62":"But these wooden objects can in no way compare with them,"
,"63":"that is why it must not be either believed or said that these are gods, since they are powerless to administer justice or benefit mankind in any way."
,"64":"Since you know they are not gods, have no fear of them."
,"65":"They can neither curse"
,"66":"nor bless kings, nor bring about signs in the heavens for the nations to see. They can neither shine like the sun nor give light like the moon."
,"67":"Animals are of more worth, since by taking cover they can look after themselves."
,"68":"So in no way whatever is it evident to us that these are gods; for that reason have no fear of them."
,"69":"For like a scarecrow in a field of melons, these gods plated with silver and gold protect nothing."
,"70":"Again these wooden gods may be compared to a thornbush in a garden where any bird can perch, or to a corpse thrown into a dark place."
,"71":"You know by the purple and scarlet robes rotting on them that they are not gods. They end up by being eaten away and become a disgrace to the country."
,"72":"Better then a just man who has no idols, he will not be dishonored."
}`)

}
func EN_CCB_LoadVMDNChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"In the third year of Jehoiakim's reign as king of Judah, King Nebuchadnezzar of Babylon besieged Jerusalem."
,"2":"The Lord delivered into his hands King Jehoiakim of Judah, and some of the vessels from the temple of God as well. These he carried off to the land of Shinar and placed in the treasure house of his god."
,"3":"King Nebuchadnezzar ordered his chief eunuch Ashpenaz to bring in some of the Israelites from the royal family and the nobility:"
,"4":"young men without physical defect, handsome, intelligent and wise, well-informed, quick to learn and understand, and suitable for service in the king's palace. They were to be taught the language and literature of the Chaldeans."
,"5":"They were allotted a daily portion of food and wine from the king's table and were to be trained for three years, after which they were to enter the king's service."
,"6":"Among these were young men of Judah: Daniel, Hananiah, Mishael, and Azariah,"
,"7":"whose names the chief eunuch changed - Daniel to Belteshazzar, Hananiah to Shadrach, Mishael to Meshach, and Azariah to Abednego."
,"8":"As Daniel was resolved not to make himself unclean with the king's food or wine, he begged the chief eunuch to spare him this defilement."
,"9":"By the grace of God, the chief eunuch had been sympathetic to Daniel,"
,"10":"but he was afraid of the king, and so he said, 'If the king, who has allotted your food and drink, sees that you look more emaciated than the other young men of your age, he might think ill of me. It will put my life in danger to give in to your wish.'"
,"11":"Daniel then turned to the steward whom the chief eunuch had put in charge of Daniel, Hananiah, Mishael, and Azariah."
,"12":"'Please test your servants for ten days. Give us only vegetables to eat and water to drink,"
,"13":"and see how we look in comparison with the young men who eat food from the king's table. Then treat us in accordance with what you see.'"
,"14":"The steward agreed and tested them for ten days,"
,"15":"at the end of which they looked healthier and better fed than any of the young men who ate the king's food."
,"16":"So the steward continued to give them vegetables instead of the choice food and wine."
,"17":"To these four youths God gave wisdom and proficiency in literature, and to Daniel the gift of interpreting visions and dreams."
,"18":"At the end of the period set by the king for the youths' training, the chief eunuch presented them to Nebuchadnezzar."
,"19":"The king talked with them and found none to equal Daniel, Hananiah, Mishael, and Azariah. These four became members of the king's court."
,"20":"In any matter of wisdom and discernment about which the king consulted, he found them ten times better than all the magicians and enchanters in his whole kingdom."
,"21":"Daniel remained there until the first year of King Cyrus."
}`)
	CurrentBook.AddChapter(2, `{
"1":"In the second year of Nebuchadnezzar's reign, he had a series of troubling dreams which rendered him sleepless."
,"2":"The king summoned magicians, enchanters, sorcerers and Chaldean diviners to interpret his dreams. When they arrived and stood in his presence,"
,"3":"the king said, 'I had a terrible dream and I want to know its meaning.'"
,"4":"The Chaldeans answered in Aramaic, 'Live forever, O King! Tell your servants the dream, and we will give you its meaning.'"
,"5":"But the king replied, 'You have to tell me the dream and interpret it, too. That is my decision. If you won't do it, I will have you cut into pieces and your houses razed to the ground."
,"6":"But if you can tell me the dream and its meaning, I will give you presents and reward you with great honor.'"
,"7":"They insisted, 'Let the king tell us his dream and we will explain what it means.'"
,"8":"The king said, 'You are only trying to gain time, for you know what I will surely do,"
,"9":"that if you do not tell me my dream there is only one sentence for you. You have conspired to mislead me with a deceitful interpretation, hoping that times will change. But if you can show me that you have the ability to know what my dream was, I can be sure that you also have the power to understand its meaning.'"
,"10":"The Chaldeans exclaimed, 'No man on earth can do what your majesty asks. Never has any king, however great and mighty, asked such a thing of any magician, enchanter or diviner."
,"11":"What the king demands is too difficult. No one can tell him that except the gods who do not live among men.'"
,"12":"This made the king so furious that he ordered all the wise men of Babylon executed."
,"13":"Upon issuance of the decree to put the wise men to death, a search was also made for Daniel and his companions to have them killed."
,"14":"Daniel, however, talked prudently with Arioch, the commander of the king's guards who had gone out to kill the wise men."
,"15":"'Why did the king issue such a harsh decree?' Daniel asked, and Arioch explained."
,"16":"Daniel then went to the king and asked for the suspension of the execution to give him time to interpret the dream."
,"17":"Daniel returned home and informed his companions Hananiah, Mishael, and Azariah."
,"18":"He asked them to implore God's mercy regarding this mystery, so that they would not perish with the rest of Babylon's wise men."
,"19":"Then in a night vision, the mystery was revealed to Daniel. He blessed the God of heaven:"
,"20":"Blessed be God's name forever and ever, for his are wisdom and power."
,"21":"He changes times and seasons; he sets up and deposes kings. He gives wisdom to the wise,and knowledge to the discerning."
,"22":"He reveals things deep and hidden; he knows what lies in darkness; for the light dwells with him."
,"23":"I give thanks and praise to you, O God of my fathers. You have given me wisdom and power; you have shown me what we asked for -,you have made known to us the dream of the king."
,"24":"After this Daniel went to Arioch, the commander appointed by the king to execute the wise men of Babylon. Daniel said to him, 'Do not execute the wise men yet. Bring me to the king, and I will interpret his dreams.'"
,"25":"At once Arioch took Daniel to the king and said, 'Here is a man found among the Judean captives who says he can interpret the king's dream.'"
,"26":"The king asked Daniel, who had been named Beltheshazzar, 'Can you tell me what my dream was and what it means?'"
,"27":"Daniel answered, 'No wise man, enchanter, magician or diviner can interpret the king's dream."
,"28":"But there is a God in heaven who reveals mysteries, and he has shown King Nebuchadnezzar what will happen in the future. I will tell you the dream and visions you had."
,"29":"As you lay in bed, O King, your thoughts turned to the future, and he who reveals mysteries showed you what is to happen."
,"30":"This mystery has been revealed to me not because I am wiser than anybody else but so that you may know what it means and what went on in your mind."
,"31":"In your vision you saw a statue - very large, very bright, terrible to look at."
,"32":"Its head was of pure gold, its chest and arms of silver, its belly and thighs of bronze,"
,"33":"its legs of iron, its feet partly of iron and partly of baked clay."
,"34":"As you watched, a rock cut from a mountain but not by human hands, struck the statue on its feet of iron and clay, smashing them."
,"35":"All at once the iron, clay, bronze, silver and gold crumbled into pieces as fine as chaff on the threshing floor in summer. The wind swept them off and not a trace was left. But the rock that struck the statue became a great mountain that filled the whole earth."
,"36":"That was the dream. Now the interpretation."
,"37":"You, O king, are king of kings, to whom the God of heaven has given dominion, strength, power and glory,"
,"38":"and into whose hand he has placed mankind, the beasts of the field and the birds of the air, making you ruler over them. You are that head of gold."
,"39":"After you, another kingdom inferior to yours will rise. Then a third kingdom of bronze will rule the whole world."
,"40":"Last shall be a fourth kingdom strong as iron and just as iron breaks and crushes everything else, so will it break and smash all the others."
,"41":"The partly-clay and partly-iron feet and toes mean that it will be a divided kingdom; yet it will have some of the strength of iron, just as you saw iron mixed with clay."
,"42":"And as the toes were partly iron and partly clay, the kingdom will be partly strong and partly weak."
,"43":"Just as you saw the iron mixed with baked clay, the people will be a mixture but will not remain united, any more than iron mixes with clay."
,"44":"In the time of those kings the God of heaven will set up a kingdom never to be destroyed or delivered up to another people. It will crush all those kingdoms and put an end to them. And it will endure forever."
,"45":"This is the meaning of your vision of a rock cut from a mountain not by human hands, the rock which struck the statue and broke into pieces the iron, bronze, clay, silver and gold. The great God has shown the king what will happen in the future. The dream is true and its interpretation reliable.'"
,"46":"King Nebuchadnezzar fell prostrate before Daniel and ordered that oblation and incense be offered to him."
,"47":"The king said to Daniel, 'Surely your God is the God of gods, the Lord of kings and the revealer of mysteries. That is why you were able to reveal this mystery.'"
,"48":"The king gave Daniel a high position and showered gifts on him. He made him governor of the entire province of Babylon and in charge of all its wise men."
,"49":"At Daniel's request the king appointed Shadrach, Meshach and Abednego administrators of the province of Babylon, while Daniel himself remained at the king's court."
}`)
	CurrentBook.AddChapter(3, `{
"1":"King Nebuchadnezzar had a golden statue, sixty cubits high and six cubits wide, erected on the plain of Dura in the province of Babylon."
,"2":"Then he summoned the satraps, prefects, governors, counselors, treasurers, judges, magistrates and all the other provincial officials to come for the dedication of the statue."
,"3":"All those summoned came together for the dedication and stood before the statue set up by King Nebuchadnezzar."
,"4":"There a herald proclaimed aloud, 'Nations and peoples of every language, you are hereby commanded"
,"5":"to fall down and worship the golden statue as soon as you hear the music played on the horn, flute, zither, lyre, harp, pipes and all other instruments."
,"6":"Whoever fails to do this will at once be thrown into a burning furnace.'"
,"7":"At this command, all the people of every nation and language who heard the sound of music on the horn, flute, zither, lyre, harp, pipes and other instruments fell down and worshiped the statue set up by King Nebuchadnezzar."
,"8":"It was then that Chaldean diviners came to the king accusing the Jews."
,"9":"They said to King Nebuchadnezzar, 'Live forever, O king!"
,"10":"You issued a decree that upon hearing the sound of the horn, flute, zither, lyre, harp, pipes and other musical instruments, everyone must fall down and worship the golden statue,"
,"11":"and whoever failed to do so was to be thrown into a burning furnace."
,"12":"There are some Jews, those whom you appointed administrators of Babylon: Shadrach, Meshach and Abednego, who gave no heed to your order. They would not serve your gods or worship the golden image you set up.'"
,"13":"Nebuchadnezzar flew into a rage and summoned Shadrach, Meshach and Abednego, who were immediately brought before the king."
,"14":"King Nebuchadnezzar questioned them, 'Is it true, Shadrach, Meshach and Abednego, that you do not serve my gods or worship the golden statue I have set up?"
,"15":"If you hear now the sound of horn, flute, zither, lyre, harp, pipes and other instruments, will you fall down and worship the statue I made? If you won't, you know the punishment: you will immediately be thrown into a burning furnace. And then what god can deliver you out of my hands?'"
,"16":"Shadrach, Meshach and Abednego answered, 'King Nebuchadnezzar, we need not defend ourselves before you on this matter."
,"17":"If you order us to be thrown into the furnace, the God we serve will rescue us."
,"18":"But even if he won't, we would like you to know, O king, that we are not going to serve your gods or worship the golden statue you have set up.'"
,"19":"Nebuchadnezzar's face reddened with fury as he looked at Shadrach, Meshach and Abednego. He ordered the furnace heated seven times hotter than usual"
,"20":"and commanded some of his strongest soldiers to bind Shadrach, Meshach and Abednego and throw them into the burning furnace."
,"21":"At once they were bound and thrown into the furnace, with their hats, shoes and garments on,"
,"22":"for the king's order was very urgent. So fierce was the fire in the furnace that it devoured even the men who threw Shadrach, Meshach and Abednego into it."
,"23":"The three, bound fast, fell into the midst of the blazing furnace."
,"24":"They walked in the midst of the flames, singing to God and praising the Lord."
,"25":"Azariah stood up in the midst of the fire and prayed aloud:"
,"26":"Blessed and worthy of praise are you, O Lord God of our fathers!,your name is glorious forever!"
,"27":"Justice is in all that you do; your acts are faultless, your ways are right, your judgments always true."
,"28":"You have indeed given a just sentence in bringing evil upon us and upon Jerusalem, the Holy City of our fathers. You have acted in accordance with truth and justice, as punishment for our sins."
,"29":"For we have sinned and acted perversely by deserting you. We have sinned gravely in everything and have not listened to your commandments."
,"30":"We have not observed them, and we have not fulfilled everything you commanded us for our good."
,"31":"All the evils you have brought upon us, all that you have done to us, you have done according to your just sentence."
,"32":"You have given us into the hands of our enemies, lawless people, the worst of the impious, into the hands of an unjust king, the most perverse in all the world."
,"33":"And today, we cannot even open our mouths; shame and humiliation have overcome those who serve and worship you."
,"34":"Do not abandon us forever, do not reject your covenant for your Name's sake."
,"35":"Do not withdraw your mercy from us, for the sake of Abraham, your friend, of Isaac, your servant, of Israel, your holy one,"
,"36":"to whom you promised to multiply their race as the stars of heaven and the sand on the shore of the sea."
,"37":"Lord, see, we have become the least among the nations in all the world, and we are humiliated because of our sins."
,"38":"At this time, we no longer have a king, or prophet, or leader. We cannot offer you holocausts, sacrifices, offerings, or incense. We have no place to present to you the first-fruits of our crops, and so obtain your favor."
,"39":"But at least when we present ourselves with a contrite soul and humbled spirit may we then be acceptable to you,"
,"40":"more than by offerings of rams and calves as holocausts, and of thousands of fat lambs. May this sacrifice of ours today obtain for us your favor for we know that those who trust in you shall never be disappointed."
,"41":"And now, we serve you with our whole heart, we fear you and we seek your face."
,"42":"Do not leave us in our humiliation, but treat us according to your kindness and your great mercy."
,"43":"Free us in keeping with your wonders, and give us the glory of your Name, Lord."
,"44":"Let those who maltreat your servants be confounded, may they be covered with shame and deprived of all their power. Crush their strength,"
,"45":"and let them know that you alone are God and Lord, glorious over all the earth.'"
,"46":"The king's servants who had thrown them into the furnace did not stop kindling the fire with oil, tar, tow and vine shoots,"
,"47":"so that the flames rose up to about twenty-five meters above the furnace"
,"48":"and extending out, burnt the Chaldeans who were standing around."
,"49":"But the angel of the Lord came down into the furnace beside Azariah and his companions; he drove the flames of the fire outside the furnace, and blew upon them,"
,"50":"in the middle of the furnace, a coolness like that of wind and dew, so that the fire did not touch them or cause them pain or trouble them."
,"51":"Then the three began singing together, glorifying and blessing God within the furnace, and saying;"
,"52":"'Blessed are you, Lord, God of our fathers, be praised and exalted for ever. Blessed is your holy and glorious name, celebrated and exalted for ever."
,"53":"Blessed are you in the temple of your sacred glory, your praises are sung for ever."
,"54":"Blessed are you on the throne of your kingdom, honored and glorified for ever."
,"55":"Blessed are you who fathom the depths, who are enthroned on the cherubim, praised and exalted for ever."
,"56":"Blessed are you in the firmament of heaven, praised and glorified for ever."
,"57":"All the works of the Lord, bless him, praise him, exalt him for ever."
,"58":"Angels of the Lord, bless him, praise and glorify him for ever."
,"59":"Heavens, bless the Lord, praise and exalt him for ever."
,"60":"All the waters above the heavens, bless the Lord, praise and exalt him for ever."
,"61":"All the powers of the Lord, bless the Lord, praise and exalt him for ever."
,"62":"Sun and moon, praise and exalt him for ever."
,"63":"Stars of heaven, praise and exalt him for ever."
,"64":"Rain and dew, praise and exalt him for ever."
,"65":"All winds, praise and exalt him for ever."
,"66":"Fire and heat, praise and exalt him for ever."
,"67":"Cold and heat, praise and exalt him for ever."
,"68":"Dew and frost, praise and exalt him for ever."
,"69":"Ice and cold, praise and exalt him for ever."
,"70":"Frost and snow, praise and exalt him for ever."
,"71":"Days and nights, praise and exalt him for ever."
,"72":"Light and darkness, praise and exalt him for ever."
,"73":"Lightnings and clouds, praise and exalt him for ever."
,"74":"Earth, praise and exalt him for ever."
,"75":"Mountains and hills, praise and exalt him for ever."
,"76":"Everything that sprouts on the earth, praise and exalt him for ever."
,"77":"Springs of water, praise and exalt him for ever."
,"78":"Seas and rivers, praise and exalt him for ever."
,"79":"Whales and fishes, praise and exalt him for ever."
,"80":"All the birds of heaven, praise and exalt him for ever."
,"81":"Animals wild and tame, praise and exalt him for ever."
,"82":"Sons of men, praise and exalt him for ever."
,"83":"Israel, praise and exalt him for ever."
,"84":"Priests of the Lord, praise and exalt him for ever."
,"85":"Servants of the Lord, praise and exalt him for ever."
,"86":"Spirits and souls of the just, praise and exalt him for ever."
,"87":"Holy men and humble of heart, praise and exalt him for ever."
,"88":"Ananiah, Azariah, Mishael, bless the Lord, praise and exalt him for ever. For he has taken us out from the netherworld, he has saved us from the hands of death, freed us from the furnace of burning flames and rescued us from the midst of the fire."
,"89":"Give thanks to the Lord, for he is good, for his mercy is everlasting."
,"90":"All who worship the Lord, bless the God of gods, praise and acknowledge him for his mercy is everlasting.'"
,"91":"Then King Nebuchadnezzar suddenly rose up in great amazement and asked his counselors, 'Did we not throw three men bound into the fire?' They answered, 'Certainly.'"
,"92":"The king said, 'But I can see four men walking about freely through the fire without suffering any harm, and the fourth looks like a son of the gods.'"
,"93":"Nebuchadnezzar approached the mouth of the blazing furnace and said, 'Shadrach, Meshach and Abednego, servants of the Most High God, come out and come here.' So they came out from the midst of the fire."
,"94":"The officials, prefects, governors and counselors of the king drew near to examine them: the fire had no effect on their bodies, their hair was not singed, their trousers were not burned, and they did not even have the smell of smoke."
,"95":"Nebuchadnezzar exclaimed, 'Blessed be the God of Shadrach, Meshach and Abednego who sent his angel to free his servants who, trusting in him, disobeyed the king's order and preferred to give their bodies to the fire rather than serve and worship any other god but their God."
,"96":"I give this command, therefore: From every race, nation and language, anyone who speaks irreverently of the God of Shadrach, Meshach and Abednego shall be cut into pieces and his house shall be destroyed, for there is no other god who can save like this.'"
,"97":"And the king promoted Shadrach, Meshach and Abednego in the province of Babylon."
,"98":"Nebuchadnezzar, the king, to all peoples, all nations and to all men on the earth whatever be their language: Peace."
,"99":"It pleases me to make known to you the signs and wonders the Most High God has done in me."
,"100":"How great are his signs, how mighty his wonders!,His kingdom is an everlasting kingdom, his dominion lasts for all generations."
}`)
	CurrentBook.AddChapter(4, `{
"1":"I, Nebuchadnezzar, was at peace in my house and content in my palace when I had a dream which appalled me."
,"2":"The nightmares I had as I lay in bed, and the visions that passed through my mind tormented me."
,"3":"So I summoned all the wise men of Babylon that they might explain to me what the dream meant."
,"4":"The wise men, seers and astrologers came, and I recounted the dream to them, but they could not explain it to me."
,"5":"So Daniel came in before me - he was renamed Belteshazzar after the name of my god, for in him dwells the spirit of the Holy God. I told him my dream in this way:"
,"6":"Belteshazzar, chief of the wise men, I know that you have the spirit of the Holy God and that no mystery is ever difficult for you. Examine the dream I have had and explain it to me."
,"7":"These were my dreams as I lay in bed. There was a tree at the center of the world; it was very tall."
,"8":"The tree grew, it became big and reached up to heaven, and its branches could be seen from the ends of the earth."
,"9":"Its leaves were beautiful, its fruits abundant; there was food for all in it. Animals of the field found refuge in its shade, the birds of heaven nested in its branches and all living things fed on it."
,"10":"I was looking at this interior vision when a watchful one, a holy one, came down from heaven."
,"11":"He cried in a loud voice: Cut the tree down, cut off its branches, strip off its leaves and throw away its fruits. Let the beasts flee from under it and the birds as well."
,"12":"But leave in the earth the stump and the roots bound with iron and bronze bands, in the grass of the field. Let him be drenched with the dew of heaven, let him share the grass of the earth with the animals. "
,"13":"Let his heart cease from being human, and let a beast's heart be given him and pass over him seven times."
,"14":"This is the sentence given by the watchful ones, the question settled by the holy ones, so that every living thing may know that the Most High is higher than any human authority. He confers power on whom he pleases and raises the most humble of men."
,"15":"This was the dream I had, I, King Nebuchadnezzar. You, Belteshazzar, explain it to me, since not one of the wise men in my kingdom has been able to interpret it for me. But you can, for the spirit of the Holy God dwells in you."
,"16":"Then Daniel, renamed Belteshazzar, was stunned for a while and looked very much upset. The king said, 'Belteshazzar, what is in that dream or in its interpretation that upsets you so?' Belteshazzar answered,"
,"17":"'My lord, may this dream be meant for your enemies and its content refer to your foes!'"
,"18":"The tree you saw, which grew big and strong, and reached to heaven and was visible through all the earth, with beautiful leaves and abundant fruit, which had food for all, under which animals of the field found refuge and in whose branches the birds of heaven built their nests -"
,"19":"this tree is you, O King, whose power has increased reaching up to heaven, whose empire extends to the ends of the earth."
,"20":"Now, regarding what the king has seen: a watchful one, a holy one, who came down from heaven and said: Cut the tree down, destroy it, but leave the stump and the roots in the ground with bands of iron and bronze, in the grass of the field; let him be drenched with the dew of heaven, and share the lot of the animals of the field until they have passed over him seven times."
,"21":"Now I shall explain it to you: This is the decree of the Most High regarding the king, my lord. "
,"22":"You shall be driven out from among men and live with the beasts of the field. You shall eat grass like the oxen, and be drenched by the dew of heaven. Seven times shall pass over you until you acknowledge that the Most High is higher than any human authority, and that he gives the power to whom he pleases."
,"23":"The order to leave the stump and the roots means that you shall recover your kingdom when you have acknowledged that all power comes from heaven."
,"24":"May it then please the king to accept my advice: wipe out your sins with works of justice, and your iniquities by showing mercy to the poor; then perhaps you may lengthen your prosperity.'"
,"25":"All this happened to King Nebuchadnezzar."
,"26":"Twelve months later, while walking on the roof of the royal palace in Babylon,"
,"27":"the king said, 'Is this not the great Babylon I built with the strength of my own power as my royal residence, and for the glory of my majesty?'"
,"28":"These words were still in the mouth of the king when a voice came down from heaven: 'King Nebuchadnezzar, I speak to you: your empire is finished."
,"29":"You shall be driven from among men, and live with the animals of the field; you shall eat grass like oxen and seven times shall pass over you until you acknowledge that the Most High disposes of the power among men and gives it to whom he pleases.'"
,"30":"These words were fulfilled at once. Nebuchadnezzar was driven from among men, he fed on grass like oxen, his body was drenched with the dew of heaven, until his hair grew like the feathers of an eagle and his nails like the claws of a bird."
,"31":"At the end of this time, I, Nebuchadnezzar, lifted up my eyes to heaven and my reason returned to me; so I blessed the Most High: Blessed and glorified is he who lives for ever, whose dominion is everlasting and whose kingdom lasts through all generations."
,"32":"All the inhabitants of the earth are before him as if they were nothing. He does as he pleases with the army of heaven and the inhabitants of the earth. No one can stop his hand or ask him to render an account."
,"33":"At that moment, I regained my reason, I recovered my throne and again began to govern, for the glory of my kingdom. My counselors and my noblemen acclaimed me, they restored me to my throne and I was given still greater power."
,"34":"So now, I, Nebuchadnezzar, praise, exalt and glorify the King of Heaven. For all his works are true, and his ways are all just; he knows how to humble those who walk in pride."
}`)
	CurrentBook.AddChapter(5, `{
"1":"King Belshazzar gave a great banquet for his nobles, a thousand of them attended and he drank wine with them."
,"2":"Under the influence of wine, he ordered that the gold and silver vessels his father Nebuchadnezzar had taken from the temple in Jerusalem be brought in so that he and his nobles, his wives and concubines might drink from them."
,"3":"The gold and silver vessels taken from God's temple were brought in, and the king and his nobles, his wives and concubines drank from them."
,"4":"While they drank wine, they praised the gods of gold and silver, of bronze and iron, of wood and stone."
,"5":"Suddenly a man's fingers appeared opposite the lampstand and wrote on the plastered wall of the king's palace. Watching the hand as it wrote, the king turned pale."
,"6":"So terrified was he that his knees knocked and his legs gave way."
,"7":"He shouted, calling for his enchanters and Chaldean diviners. 'Whoever reads this writing and tells me its meaning,' said he to the wise men of Babylon, 'will be clothed in purple, wear a gold chain around his neck, and be made the third highest ruler in my kingdom.'"
,"8":"All the king's wise men came, but none could read the writing or tell its meaning."
,"9":"King Belshazzar became very frightened and his face grew even more pale. His nobles were likewise terrified and confused."
,"10":"Hearing the troubled voices of the king and his nobles, the queen entered the banquet hall and said, 'Live forever, O king! Do not be alarmed and become pale."
,"11":"In your kingdom is a man who has the spirit of the holy gods. He was found to have discernment and god-like wisdom during your father's lifetime. He was in fact appointed chief of the magicians, enchanters and diviners by your father King Nebuchadnezzar."
,"12":"This man Daniel, whom the king called Beltheshazzar, knew how to interpret dreams, explain riddles and solve difficult problems. Call for Daniel and he will tell you what the writing means.'"
,"13":"Daniel was brought in and questioned by the king, 'Are you Daniel, one of the exiles my father brought from Judah?"
,"14":"I have heard that you have the spirit of the gods, that you have insight and extraordinary wisdom."
,"15":"Wise men and enchanters were brought here, but none of them could read this writing and tell its meaning."
,"16":"I have heard that you can interpret dreams and solve problems. If you can read this writing and tell me what it means, you will be clothed in purple, wear a gold chain around your neck, and be appointed third in rank in my kingdom.'"
,"17":"Daniel replied, 'You may keep your gifts or give them to someone else. Just the same I will read and interpret the writing for you."
,"18":"God the Most High gave your father Nebuchadnezzar sovereignty and a great kingdom."
,"19":"Because of the greatness given him by God, he was feared by nations and peoples of every language. He had the power of life and death over everyone. He exalted or humbled whomsoever he wished."
,"20":"But when he became arrogant and insolent, he was deposed and stripped of his glory."
,"21":"He became an outcast and as senseless as a beast. He lived with wild asses, ate grass like cattle and his body was drenched with the dew of heaven, until he acknowledged that God the Most High rules over the kingdom of men and appoints whom he pleases to govern it."
,"22":"But you his son Belshazzar, although you knew all this, have not humbled yourself."
,"23":"You have defied the Lord of heaven. You had the vessels from his temple brought to you, and together with your nobles, your wives and concubines, you drank wine from them. You praised the idols made of silver and gold, of bronze, iron and stones, which neither see, nor hear, nor understand; but you never glorified God who has power over your life and all your fortunes."
,"24":"So he sent the hand that wrote the inscription"
,"25":"which read MENE, MENE, TEKEL, PARSIN. And these words mean:"
,"26":"MENE, God has numbered the days of your reign and put an end to it;"
,"27":"TEKEL, you have been weighed on the scales and found wanting;"
,"28":"PARSIN, your kingdom has been divided and given to the Medes and the Persians.'"
,"29":"On Belshazzar's order, Daniel was clothed in purple, given a gold chain to wear around his neck, and proclaimed the third highest ruler in the kingdom."
,"30":"That very night, however, the Chaldean king Belshazzar was slain."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Darius the Mede, at the age of sixty-two, took over the kingdom."
,"2":"Darius appointed one hundred and twenty satraps throughout the whole kingdom. They were made accountable to three administrators, one of whom was Daniel. This was to ensure that no loss or harm should come to the king."
,"3":"Because of the extraordinary spirit residing in him, Daniel excelled above all the other administrators and satraps, so that the king planned to give him authority over the entire kingdom."
,"4":"This provoked envy among the administrators and satraps, who tried to find grounds for filing charges against Daniel as regard his performance of official duties. But he was so trustworthy that neither corruption nor negligence could be found in him."
,"5":"Finally the men decided: 'We will never find any grounds for charges against this man Daniel except in something that has to do with the law of his God.'"
,"6":"These administrators and satraps, therefore, went as a group to the king and said to him, 'Live forever, O King Darius!"
,"7":"The administrators of the kingdom, the prefects, satraps, counselors and governors are all agreed that the king should issue and enforce a decree that anyone who prays and makes petition to any god or man within the next thirty days, except to you, O king, shall be thrown into the lions' den."
,"8":"And now, O king, put the decree in writing and have it signed at once, so that it cannot be altered or annulled, in accordance with Medo-Persian laws."
,"9":"King Darius put in writing and signed the prohibition, thus making it a law."
,"10":"Daniel heard about the new law, but just as usual, he returned home and prayed three times a day, giving thanks to his God, in his room upstairs with the windows opened towards Jerusalem."
,"11":"There the men spying on him found Daniel kneeling in prayer and asking God for help."
,"12":"So they went to the king and reminded him about the prohibition, 'O king, did you not publish a decree that anyone who prays or makes petition to any god or man except to you would be thrown into the lions' den?',The king answered, 'Yes, and the decree stands, in accordance with Medo-Persian laws which cannot be altered or annulled.'"
,"13":"Then they said, 'But the Jewish exile Daniel pays no attention to you and to your decree. Three times a day he still prays to some god other than you.'"
,"14":"Greatly aggrieved at what he heard, the king decided to help Daniel. He made every effort till sundown to save him."
,"15":"But the men kept coming to him and insisting, 'Remember, O king, that under the Medo-Persian laws every decree or prohibition issued by the king is irrevocable.'"
,"16":"The king, therefore, could not help giving the order that Daniel be brought and thrown into the lions' den. The king said to Daniel, 'May your God, whom you serve faithfully, save you.'"
,"17":"A stone was placed at the mouth of the den, and the king sealed it with his own signet ring and with that of his nobles, so that Daniel's situation might remain unchanged."
,"18":"Then the king returned to his palace and spent a sleepless night, refusing food and entertainment."
,"19":"Very early next morning, he rose and hurried to the lions' den."
,"20":"As he came near he called in an anguished voice, 'Daniel, servant of the living God, did your God whom you serve faithfully save you from the lions?'"
,"21":"Daniel answered, 'Live forever, O king!"
,"22":"My God sent his angel who closed the lions' mouths so that they did not hurt me. God did that because I am innocent in his sight. Neither have I wronged you, O king.'"
,"23":"The king felt very glad and ordered Daniel released from the lions' den. No wound was found on him for he had trusted in his God."
,"24":"At the king's order, the men who had accused Daniel were thrown into the lions' den, together with their wives and children. No sooner had they reached the floor of the den than the lions lunged at them and tore them to pieces."
,"25":"King Darius wrote to the nations, to peoples of every language, 'Peace to you all!"
,"26":"I decree that throughout my kingdom people should reverence and fear the God of Daniel. 'For he is the living God, and forever he endures; his kingdom will not be crushed, his dominion will never cease."
,"27":"He rescues and he delivers; he performs signs and wonders,both in heaven and on earth. And he came to Daniel's rescue,saving him from the lions' tooth and claw.'"
,"28":"Daniel greatly prospered during the reign of Darius and the reign of Cyrus the Persian."
}`)
	CurrentBook.AddChapter(7, `{
"1":"In the first year of the reign of King Belshazzar of Babylon, Daniel had a dream and visions in his mind as he was sleeping. When he woke up, he wrote down the dream. This is how the narrative began:"
,"2":"Daniel said, 'I saw the following in my vision: the four winds of heaven stirred up the great sea,"
,"3":"and four great beasts, each one different from the other, came out of the sea."
,"4":"The first was like a lion with eagle's wings. As I looked at it, its wings were torn off. It was lifted up from the ground, stood up on its feet like a man, and was given a human heart."
,"5":"The second was a beast like a bear; it was raised up on one side and had three ribs in its mouth between its teeth. It was told: Go and devour much flesh."
,"6":"I went on looking and saw another beast like a leopard with four wings on its back; it had four heads and dominion was given to it."
,"7":"I continued seeing my visions of the night and saw a terrible fourth beast. It was fearful and extraordinarily strong; it had great iron teeth; it ate, tore into pieces, and crushed underfoot whatever remained. It was different from the previous beasts and had ten horns."
,"8":"I was looking at the horns, when another small horn sprang among them, and three of the first horns were pulled out by the roots to make way for the new. It had eyes like human eyes and a mouth that uttered insolent words."
,"9":"I looked and saw the following: Some thrones were set in place and One of Great Age took his seat. His robe was white as snow, his hair white as washed wool. His throne was flames of fire with wheels of blazing fire. "
,"10":"A river of fire sprang forth and flowed before him. Thousands upon thousands served him and a countless multitude stood before him. Those in the tribunal took their seats and opened the book. "
,"11":"But as I remembered the haughty words of the horn with human eyes and mouth which I had seen before, this animal was killed before my eyes, and its body destroyed and cast into the fire."
,"12":"Dominion was taken from the other animals, though they were allowed to stay alive for a time, until the fixed time."
,"13":"I continued watching the nocturnal vision: One like a son of man came on the clouds of heaven. He faced the One of Great Age and was brought into his presence. "
,"14":"Dominion, honor and kingship were given him, and all the peoples and nations of every language served him. His dominion is eternal and shall never pass away; his kingdom will never be destroyed."
,"15":"I, Daniel, was deeply troubled, since these visions terrified me."
,"16":"I approached one of those who were standing there, and asked him to tell me what all this meant. He answered me and gave me the interpretation of these things:"
,"17":"'These four beasts are four kings who will rise from the earth."
,"18":"But the holy ones of the Most High shall receive the kingdom to possess it eternally, forever and ever.'"
,"19":"Then I wanted to know the meaning of the fourth beast, different from the others, extraordinarily terrifying, with iron teeth and bronze claws, that ate, tore into pieces and crushed underfoot whatever remained."
,"20":"I also wanted to know about the ten horns it had on its head, and about the other horn which had sprung up, and the three first horns that fell, and about this horn with eyes and a mouth that spoke with arrogance, and that looked greater than the other horns."
,"21":"As I looked, this horn waged war against the holy ones and was subduing them"
,"22":"until the One of Great Age came to do justice for the holy ones of the Most High, and the time came for the holy ones to take possession of the kingdom."
,"23":"Then I was told: 'The fourth animal shall be a fourth kingdom on earth, different from all the kingdoms. It will devour the earth, crush it and destroy it."
,"24":"The ten horns are ten kings who shall rise from this kingdom. Another one will rise up after them and destroy three kings."
,"25":"This king shall insult the Most High and persecute the holy ones of the Most High. He shall try to change the feasts and the laws. The holy ones shall be handed over to his power for a time, two times, and half a time."
,"26":"But judgment will come and dominion will be taken from him; he shall be destroyed and utterly wiped out."
,"27":"The kingship, dominion and leadership of all the kingdoms of the world shall be given to the people of the holy ones of God Most High: his kingdom will be without end. All the kingdoms shall serve him and be subject to him.'"
,"28":"Here ends the narrative. I, Daniel, was greatly disturbed in my thoughts, I grew pale and I kept these things in my heart.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"In the third year of the reign of King Belshazzar, I, Daniel, had another vision."
,"2":"In the vision, I saw myself in Susa, the fortified city in the province of Elam; I noticed that I was by the river Ulai."
,"3":"I raised my eyes and saw a ram standing before the river. It had two long horns, but one was longer than the other."
,"4":"I saw the ram charging westward, northward and southward. No animal could resist it, none could escape its power. It did as it pleased and so became great."
,"5":"As I was thinking, a he-goat came from the west, as if flying above the entire earth without touching the ground; it had a great horn between its eyes."
,"6":"It approached the ram with the two horns which I had seen by the river, and it ran towards the ram with all the fury of its strength."
,"7":"I saw how it reached the ram and directed itself against it; it charged the ram and broke its two horns, and the ram was unable to resist. It cast it down to the ground and crushed it. No one could free the ram from its power."
,"8":"The he-goat became very great, but when it was powerful, the great horn snapped and in its place sprang four great horns facing the four winds of heaven."
,"9":"From one of these, the small one, sprang a horn which grew big towards the south and east and towards the Beautiful Land."
,"10":"It grew up to the army of heaven and flung part of the stars to the ground and crushed them underfoot."
,"11":"It even came to the Commander of the army, deprived him of the perpetual sacrifice and made useless his temple"
,"12":"and the army. It put Abomination in place of the sacrifice and flung Truth to the ground. And whatever it undertook succeeded."
,"13":"Then I heard a holy one speaking and another who asked him in return, 'When shall the vision be fulfilled? What about the perpetual offering, the Abomination of the devastator, the sanctuary handed over and the army trampled underfoot?'"
,"14":"He answered, 'Until two thousand three hundred evenings and mornings have gone by, then the Temple shall be restored.'"
,"15":"As I, Daniel, looked at this vision and tried to understand it, I suddenly saw before me someone like a man,"
,"16":"and I heard a human voice over the river Ulai that cried out to him: 'Gabriel, explain the vision to this man.'"
,"17":"He approached the place where I was. When he came, I was terrified and fell on my face. He said to me, 'Son of man, understand: this vision refers to the end-time.'"
,"18":"As he spoke, I lost consciousness and fell face down on the ground. He touched me and raised me to my feet."
,"19":"Then he said, 'See, I will reveal to you what is going to happen when the wrath comes to an end, for the end is set."
,"20":"The ram you have seen, with its two horns, stands for the two kings of the Medes and the Persians."
,"21":"The hairy he-goat is the king of Greece; the great horn between its eyes is the first of its kings; this horn snapped,"
,"22":"and the four horns that sprang up in its place are the four kingdoms that will rise from his nation, but will not overpower him."
,"23":"At the end of their reign, when the sinners have reached their full number, a king will arise, insolent and wise in cunning."
,"24":"His strength will increase, so that he shall plot things unheard of before. Whatever he undertakes shall prosper, he shall destroy the powerful and the very people of the holy ones. "
,"25":"He shall carry out his deceits, will be believed in by many and, in the fullness of peace, shall destroy many. He shall even rise against the Prince of princes, but he shall be destroyed without the intervention of any human hand."
,"26":"What I said of the vision of the mornings and evenings is true, but keep the vision secret, for it will be fulfilled only in the remote future.'"
,"27":"I, Daniel, fainted and was sick for several days. Then I got up to attend to the king's affairs. I remained frightened because of the vision and did not understand it."
}`)
	CurrentBook.AddChapter(9, `{
"1":"In the first year of the reign of Darius, son of Ahasuerus, of the Median race, who was king of Chaldea, the following happened:"
,"2":"I, Daniel, thought about the number of years, according to the scriptures, before Jerusalem should be left in ruins. Yahweh spoke of seventy years to the prophet Jeremiah."
,"3":"I turned to the Lord and begged him. I pleaded with prayers and fasting. I did penance, I put on sackcloth and sat on an ash pile."
,"4":"I prayed to Yahweh, my God, and made this confession: 'Lord God, great and to be feared, you keep your Covenant and love for those who love you and observe your commandments."
,"5":"We have sinned, we have not been just, we have been rebels, and have turned away from your commandments and laws."
,"6":"We have not listened to your servants, the prophets, who spoke in your name to our kings, leaders, fathers and to all the people of the land."
,"7":"Lord, justice is yours, but ours is a face full of shame, as it is to this day - we, the men of Judah, the inhabitants of Jerusalem, the whole of Israel, near and far away, in all the lands where you have dispersed us because of the infidelity we have committed against you."
,"8":"Ours is the shame, O Lord for we, our kings, princes, fathers, have sinned against you."
,"9":"We hope for pardon and mercy from the Lord, because we have rebelled against him."
,"10":"We have not listened to the voice of Yahweh, our God, or followed the laws which he has given us through his servants, the prophets."
,"11":"All Israel has broken your law and has turned away from it rather than listen to your voice. Therefore, the curse and the threats written in the Law of Moses, the servant of God, have come upon us because we have sinned against him."
,"12":"He has carried out the threats he pronounced against us and against those who governed us: he brought a terrible calamity upon us. No, never could there be anything worse than what has come upon Jerusalem."
,"13":"All these disasters have struck us with dread as it was written in the Law of Moses, but we have not tried to calm the anger of Yahweh, our God. We have not turned away from our sins and learned to listen to your truth."
,"14":"Yahweh made true his threat and brought this calamity upon us, for Yahweh, our God, is just in all his works, while we have not obeyed his voice."
,"15":"And now, O Lord our God, who brought your people out of Egypt by your powerful hand and gained renown to this day, we have sinned, we have been unfaithful."
,"16":"Lord, in keeping with your kindness, turn away your anger and wrath from Jerusalem, your city, your holy mountain, for because of our sins and the wickedness of our fathers, Jerusalem and your people are the laughingstock of all around us."
,"17":"So now, our God, listen to the prayer and pleading of your servant and, for your own sake, let your face shine upon your desolate sanctuary."
,"18":"My God, incline your ear and listen. Open your eyes and see how the city lies in ruins, the city upon which your Name has been pronounced. We do not rely on our good works, but we pour out our plea before you, trusting in your great mercy."
,"19":"Listen, Lord! Lord, forgive! Pay attention to us, Lord! Act, my God, and do not delay for your own sake, since your city and your people are called by your name.'"
,"20":"At the hour of the evening sacrifice, I was still speaking, confessing my sins and those of Israel, my people, begging Yahweh on behalf of his Holy Mountain."
,"21":"At that moment, Gabriel whom I had seen at the beginning of the vision, came to me, flying,"
,"22":"and he said to me, 'Daniel, I have come now to make you understand."
,"23":"As you were praying, a word was uttered and I have come to teach it to you because God loves you. Pay attention to this word and understand the vision:"
,"24":"Seventy weeks are set for your people and your holy city, to put an end to transgression, to put sin under lock, to wipe out the offense, and to bring everlasting justice, so that the visions and the prohecies will be fulfilled and the Holy of Holies be anointed."
,"25":"Understand this, then: From the time the order to rebuild Jerusalem was given until an anointed leader comes, there shall be seven weeks. Then in sixty-two weeks squares and walls will be rebuilt, but in a difficult time."
,"26":"After the sixty-two weeks, an anointed one will be cut off; the city and the temple shall be destroyed by the people of a king who will come. They will be carried along as by a flood. Until the end, there will be wars and disasters which God has decreed."
,"27":"He will impose his law on a great part of the people for a week. By mid-week, he will put a stop to the sacrifices and offerings. The devastator shall place the abominable idol in the Temple until the ruin decreed by God comes upon the devastator.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"In the third year of the reign of Cyrus, king of Persia, God gave a message to Daniel, renamed Belteshazzar. This message spoke of fidelity and great anguish. Daniel paid attention to these words and to the following vision:"
,"2":"At that time, I, Daniel, was mourning for three weeks."
,"3":"I ate no rich food, took no meat or wine, and did not perfume myself for three weeks."
,"4":"On the twenty-fourth day of the first month, as I stood on the bank of the river Tigris,"
,"5":"I raised my eyes and saw this: a man clothed in linen with a belt of pure gold round his waist."
,"6":"His body was like chrysolite, his face had the brilliance of lightning, his eyes were like blazing torches, and the sound of his words was like the noise of a crowd."
,"7":"I, Daniel, alone saw this vision; the men who were with me did not see it, but they were seized with great fear and they fled to hide."
,"8":"So I was left alone gazing on this vision. I was powerless. The appearance of my face changed fearfully, and I retained absolutely no strength."
,"9":"I heard the sound of his words, and when I heard it, I fainted face down to the ground."
,"10":"Then a hand touched me, and set me trembling on my hands and knees."
,"11":"He said to me, 'Daniel, man loved by God, pay attention to the words I shall say to you and stand up, for I have been sent to you now.' When I heard these words I stood up trembling."
,"12":"Then he said to me, 'Daniel, do not be afraid, for from that first day when you resolved to acquire understanding and to humble yourself before your God, your supplications were heard, and it is precisely because of this that I have come."
,"13":"The prince of the Persian kingdom has resisted me for twenty-one days, but Michael, one of the leading angels, has come to my assistance. I left him there with the kings of Persia,"
,"14":"and I have come to tell you what will happen to your people in the days to come. For this new vision, too, refers to those days.'"
,"15":"When he had said these words to me, I bowed my head and kept silent, but someone like a man touched my lips."
,"16":"Then I opened my mouth to speak and said to him who was before me, 'My lord, anguish overcomes me at this vision, and I have no strength."
,"17":"How can I speak to my lord when my strength fails me and I cannot breathe?'"
,"18":"The one who looked like a man touched me again, and he strengthened me."
,"19":"He said to me, 'Man chosen by God, do not fear. Peace be with you. Have courage and be strong.'"
,"20":"And as he spoke, I felt strengthened, and I said, 'Speak, my lord, now that I feel strong.',Then he said to me, 'Do you know why I have come to you? "
,"21":"I shall reveal to you what is written in the Book of Truth. After that I have to return to fight against the angel of Persia; then, the angel of Greece will come. No one lends me support in all this except Michael, your angel."
}`)
	CurrentBook.AddChapter(11, `{
"1":"He helps and strengthens me in the same way that I have helped him in the first year of Darius, the Mede."
,"2":"But now, I shall tell you the truth. There shall be three more kings in Persia, and the fourth shall have more riches than all the others. And when he has grown strong with his riches, he will stir up everything against the kingdom of Greece."
,"3":"A powerful king will rise and reign over a vast empire and do as he pleases."
,"4":"But as soon as he has secured his reign, his empire will be broken up and divided out to the four winds of heaven, though not among his descendants. It will not be the same dynasty, but his kingdom shall be taken from them and passed on to others."
,"5":"The king of the South will grow powerful, but one of his leaders will grow more powerful still and will have an empire greater than his."
,"6":"Some years later, they will be allies and the daughter of the king of the South shall come to the king of the North to conclude the alliance. But she will not endure; for she will be put to death with those who brought her, and her son and husband as well."
,"7":"Then, a bud from her roots will sprout in her place, and will cross the land of 'the army' and enter the fortress of the king of the North."
,"8":"He will be victorious in wars and will appropriate to himself their gods, statues and objects of silver and gold: all this plunder will be brought into Egypt. For some years, he shall remain far away from the king of the North."
,"9":"The king of the North will invade the kingdom of the South, and then return to his own country."
,"10":"His sons will prepare for war and assemble a great multitude of troops. One of them will come like an overflowing river; he will break through and then withdraw after having fought right up to his fortress."
,"11":"Then the king of the South, enraged, will set out to fight against the king of the North. He will mobilize a great army, and the multitude will fall into his hands"
,"12":"and perish. Then he will become proud and crush tens of thousands of men, but his strength will not last."
,"13":"The king of the North will attack after mobilizing a greater army than the first. And after several years, he will come with a large army and abundant provisions and supplies."
,"14":"Then many will rise against the king of the South, and the violent among your people will rise against him, trusting in a vision, but they will throw up siegeworks and will capture the fortified city."
,"15":"The king of the South will not be able to resist, he and the picked troops of his people."
,"16":"He who marches against him will do as he pleases, and none can resist him, and he will settle in the Beautiful Land, bringing destruction."
,"17":"He shall plan to reign over his whole kingdom, and will conclude an agreement with him, giving him one of his daughters, in order to destroy the kingdom. But he will not succeed, so it will not happen."
,"18":"Then he will turn against the islands and seize a good number of them, but a commander will humble him, and he will not be able to avenge himself."
,"19":"So he will turn against the fortresses of his own land, but he will stumble, fall and never rise again."
,"20":"In his place will rise another who will send a tax collector to despoil the Glory of his Kingdom, but he will be overthrown within a few days, though neither with arms nor in battle."
,"21":"In his place a contemptible man will rise to whom royal dignity has not been given, but he will intervene unexpectedly and will gain possession of the kingdom by intrigue."
,"22":"The enemy forces will be completely routed and utterly destroyed by him, and the Prince of the covenant, too."
,"23":"He will act with cunning, making good use of the pacts concluded with him, and with a few men, he will grow strong."
,"24":"He will invade the richest provinces and will do what his fathers or his grandfathers had not done. He will divide the plunder, the booty and the riches among his friends. He will devise plans against fortresses, but up to a certain period only."
,"25":"He will direct his strength and courage against the king of the South. The king of the South will go to war with a great and powerful army, but will not be able to resist, for conspiracies have been plotted against him."
,"26":"Those who ate from his table will ruin him, his army will be disbanded and many will fall dead by the sword."
,"27":"The two kings will not think of anything but to do harm and to deceive each other while sitting at the same table. But they will not accomplish anything, since there is,still time before the appointed moment."
,"28":"The king of the North will return to his land with great riches and will devise plans against the Holy Covenant. He will act against it, then he will return to his land."
,"29":"In due time he will return again to the South, but in this second time, things will not be as before."
,"30":"The ships of Kittim will come against him and he will have to abandon his plan, but he will vent his anger against the Holy Covenant, and will again favor those who have turned away from the Holy Covenant."
,"31":"He will send some of his forces to profane the Citadel sanctuary, to suppress the perpetual sacrifice and there to set up the Abominable Idol of the devastator."
,"32":"He will corrupt with flatteries those who violate the Covenant, but the people who know their God will stand firm."
,"33":"The most intelligent among the people will teach many, but they will fall by the sword or be burned or exiled or plundered of their goods for some time."
,"34":"And when they fall, they will receive little help; but many will join them in deceit."
,"35":"Some among the learned will stumble, but this will be so as to prove them, to purify and cleanse them until the end which is to come at its appointed time."
,"36":"The king will act according to his whims, becoming conceited and exalting himself above all the gods, and he will speak outrageous blasphemies against the God of gods. He will prosper until the Wrath is filled to overflowing, for what has been decreed will be fulfilled."
,"37":"He will pay no heed to his fathers' gods, will not mind the favorite god of the women, or any other god, but will exalt only himself as greater than them all."
,"38":"In their place, he will worship the god of fortresses, a god unknown to his fathers, and will honor him with gold, silver and precious stones and jewels."
,"39":"Trusting in a foreign god, he will attack the fortresses. Those who adore him will be given great honor, they will have authority to divide the land as a reward."
,"40":"When the end-time comes, the king of the South will confront him. The king of the North will attack him with chariot cavalry and many ships. He will enter his lands, invade them and pass through them."
,"41":"He will come to the Beautiful Land where many will fall; only the people of Edom, Moab and the best of the Ammonites will escape."
,"42":"He will stretch out his hand to many countries, including Egypt."
,"43":"He will seize the treasures of gold and silver and all precious objects of Egypt. Libyans and Ethiopians will join him."
,"44":"But reports coming from the East and the North will worry him, and he will set out in a rage, determined to utterly wipe out and destroy many."
,"45":"He will set up the tent of his military camp between the sea and the Holy Mountain of the Beautiful Land. Then he will come to his end and no one will come to his aid."
}`)
	CurrentBook.AddChapter(12, `{
"1":"At that time, Michael will rise, the Great Commander who defends the sons of your people. It shall be a time of anguish as never before since the nations first existed until this very day. Then all those whose names are written in the Book will be saved. "
,"2":"Many of those who sleep in the Region of the Dust will awake, some to everlasting life but others to eternal horror and shame."
,"3":"Those who acquired knowledge will shine like the brilliance of the firmament; those who taught people to be just will shine like the stars for all eternity."
,"4":"And you, Daniel, keep these words secret and have the Book sealed until the appointed time of the end. Many will wander looking here and there. Wickedness will go on increasing.'"
,"5":"I, Daniel, looked and saw two others standing, one on either side of the river."
,"6":"One said to the man clothed in linen who was upstream, 'When will these wonderful things take place?'"
,"7":"And I heard the answer of the man in linen who was upstream. He raised his hands to heaven and swore by the One who lives eternally: 'Everything will be fulfilled within a time, two times and a half a time. When the holy people is completely crushed and without any strength, then these things will be fulfilled.'"
,"8":"I heard but did not understand. Then I said, 'My lord, what will be the outcome of these things?'"
,"9":"He said, 'Go, Daniel, for these words are secret and sealed until the appointed time of the end."
,"10":"Many will be purified, cleansed and proved. The impious will go on doing evil, none of them will understand anything, only the learned will understand."
,"11":"From the time the perpetual sacrifice is suppressed and the Abominable Idol of the devastator is installed, there shall be a thousand two hundred ninety days."
,"12":"Fortunate is the one who waits and reaches a thousand three hundred thirty-five days."
,"13":"And you, go your way until your end. You shall rest and then rise to receive your reward at the end of time.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"There lived in Babylon a man named Joakim,"
,"2":"who was married to a very beautiful God-fearing woman, Susanna, Hilkiah's daughter,"
,"3":"whose pious parents had trained her in the law of Moses."
,"4":"A very rich man and greatly respected by his countrymen, Joakim was frequently visited by the Jews in his house adjoining a garden."
,"5":"That year, two elders of the people were appointed judges, in whom this word of the Lord became true, 'Wickedness has come forth from Babylon, through the elders appointed judges, who were supposed to govern the people.'"
,"6":"These men frequented Joakim's house, and all who had legal disputes used to come to them."
,"7":"After the people had left at noon, Susanna would go into her husband's garden for a walk."
,"8":"The two old men began to lust for her as they watched her enter the garden every day."
,"9":"Forgetting the demands of justice and virtue, their lust grew all the more as they made no effort to turn their eyes to heaven."
,"10":"Although both were possessed of the same passion for her, they concealed that from each other,"
,"11":"for they were ashamed to reveal their lustful desire."
,"12":"But they continued watching her day after day."
,"13":"One day before lunch, they parted, saying to each other, 'Let us go home for it is meal time. So off they went in different directions."
,"14":"but both turned back, and coming face to face again, each was obliged to explain his action and admit his lust. They agreed to wait for an opportunity to meet her alone."
,"15":"One day, as they were waiting for an opportune time, Susanna entered the garden as usual with only two maids. She decided to bathe, for it was a hot day."
,"16":"Nobody else was there ex-cept the two elders watching her from where they had hidden themselves."
,"17":"She said to the maids, 'Bring me oil and ointments, and shut the garden doors while I bathe.'"
,"18":"Unaware of the elders hidden inside the garden, the two maids did as ordered, shutting the doors and leaving by the side entrance to the house to fetch what she had asked for."
,"19":"When the maids had left, the two elders hurried to her and said,"
,"20":"'Look, the garden doors are shut and no one sees us. We desire to possess you."
,"21":"If you refuse to give in, we will testify that you sent your maids away for there was a young man here with you.'"
,"22":"Susanna moaned, 'Whatever I do, I am trapped. If I give in to your desire, it will be death for me; if I refuse, I won't escape your persecution."
,"23":"I would rather be persecuted than sin in the eyes of the Lord.'"
,"24":"Susanna shrieked, but the old men shouted, putting the blame on her."
,"25":"One of them ran and opened the garden doors."
,"26":"Hearing the noise in the garden, the household servants rushed in by the side entrance to see what was happening."
,"27":"They were taken aback when they heard the elders' accusation, for never had anything like this been said of Susanna."
,"28":"The next day a meeting was held at Joakim's house. The two elders arrived, vindictively determined to have Susanna sentenced to death."
,"29":"They ordered before all the people, 'Send for Susanna, Hilkiah's daughter and Joakim's wife.'"
,"30":"They sent for her, and she came with her parents, children and all her relatives."
,"31":"Susanna was a very refined and beautiful woman."
,"32":"She had her veil on, but the wicked elders ordered her to uncover her face for them to feast on her beauty."
,"33":"Her family and friends and all who saw her wept."
,"34":"The two elders stood up and laid their hands upon her head."
,"35":"Completely trusting in the Lord, she raised her tearful eyes to heaven."
,"36":"The elders started making their accusation, 'We were taking a walk in the garden when this woman came in with two maids. She ordered them to shut the garden doors and dismissed them."
,"37":"Then a young man came out of hiding and lay with her."
,"38":"We were in a corner of the garden, and we saw this crime from there. We ran to them,"
,"39":"and caught them in the act of embracing. We were unable to take hold of the man. He was too strong for us. He made a dash for the door, opened it and ran off."
,"40":"But we were able to seize this woman. We asked her who the young man was,"
,"41":"but she refused to tell us. This is our statement, and we testify to its truth.',The assembly took their word, since they were elders and judges of the people. Susanna was condemned to death. "
,"42":"She cried aloud, 'Eternal God, nothing is hidden from you; you know all things before they come to be."
,"43":"You know that these men have testified falsely against me. Would you let me die, though I am not guilty of all their malicious charges?'"
,"44":"The Lord heard her,"
,"45":"and as she was being led to her execution, God aroused the holy spirit residing in a young lad named Daniel."
,"46":"He shouted, 'I will have no part in the death of this woman!'"
,"47":"Those present turned to him, 'What did you say?' they all asked."
,"48":"Standing in their midst, he said to them, 'Have you become fools, you Israelites, to condemn a daughter of Israel without due process and in the absence of clear evidence?"
,"49":"Return to court, for those men have testified falsely against her.'"
,"50":"Hurriedly they returned, and the elders said to Daniel, 'Come and sit with us, for you also possess the gifts bestowed by God upon the elders.'"
,"51":"Daniel said to the people, 'Separate these two from one another and I will examine each of them.'"
,"52":"When the two elders were separated from each other, Daniel called one of them and said, 'How wicked you have grown with age. Your sins of earlier days have piled up against you, and now is the time of reckoning."
,"53":"Remember how you have passed unjust sentences, condemning the innocent and freeing the guilty, although the Lord has said 'The innocent and the just should not be put to death.'"
,"54":"Now, if you really witnessed the crime, under what tree did you see them do it?'"
,"55":"The elder answered, 'Under a mastic tree.',Daniel said, 'Your lie will cost you your head. You will be cut in two, as soon as the Lord's angel receives your sentence from God.'"
,"56":"Putting the first one aside, Daniel called the other elder and said to him, 'You offspring of Canaan and not of Judah, you have long allowed yourself to be perverted by lust."
,"57":"This is how you have dealt with the daughters of Israel, who out of fear have yielded to you. But here is a daughter of Judah who would not tolerate your wickedness."
,"58":"Tell me then, under what tree did you catch them committing the crime?',The answer came, 'Under an oak.'"
,"59":"'Your lie has also cost you your head,' Daniel said. 'God's angel waits to cut you both in two.'"
,"60":"The whole assembly shouted and blessed God for helping those who hope in him."
,"61":"They turned against the two elders who, through Daniel's efforts, had been convicted by their own mouths. In accordance with Moses' law, the penalty the two elders had intended to impose upon their neighbor was inflicted upon them."
,"62":"They were sentenced to death. Thus was the life of an innocent woman spared that day."
,"63":"Hilkiah and his wife praised God for the justice given Susanna, and so did Joakim her husband and all her relatives, for she was not found guilty of any shameful deed."
,"64":"Daniel was greatly esteemed by the people from that day onward."
}`)
	CurrentBook.AddChapter(14, `{
"1":"When King Astyages died, Cyrus the Persian ascended the throne."
,"2":"Daniel was very close to the king, who held him in higher esteem than any of his other friends."
,"3":"The Babylonians had an idol called Bel, to which twelve bushels of fine flour, forty sheep, and six measures of wine were offered daily."
,"4":"The king took part in this cult and worshiped the idol every day. Daniel, on the other hand, worshiped only his own God."
,"5":"And the king asked him, 'Why don't you worship Bel?',Daniel answered, 'I worship no man-made idols, but only the living God who made heaven and earth and rules over all mankind.' "
,"6":"The king asked, 'Don't you think Bel is a living god? Don't you see how much he eats and drinks every day?'"
,"7":"Daniel laughed. 'Do not be deceived, O king. This is only clay inside and bronze outside. It never ate or drank anything.'"
,"8":"Enraged, the king called his priests and said to them, 'If you will not tell me who consumes all these offerings, you will all die."
,"9":"But if you can show that Bel consumes them, it is Daniel who will die for blaspheming.' Daniel said to the king, 'Let it be as you say.'"
,"10":"There were seventy priests of Bel, besides their wives and children. Together with Daniel, the king went to Bel's temple."
,"11":"The priests said to the king, 'See, we are going outside. We will leave you here inside, O king, to set out the food and prepare the wine. Then you can leave them, shut the door and seal it with your ring."
,"12":"You will return in the morning, and if you find that Bel has not eaten the food and drunk the wine, we are ready to be executed. But if the reverse happens, Daniel must die for telling lies and slandering us.'"
,"13":"They were confident for they had made a secret entrance under the table, through which they used to come in to consume the food and wine offerings."
,"14":"When the priests had left, the king set the food before Bel, while Daniel ordered his servants to scatter ashes all over the temple floor. Then they left after shutting the door and sealing it with the king's ring."
,"15":"That night the priests and their wives and children came and, as usual, ate and drank the offerings."
,"16":"Early the next morning, the king returned to the temple with Daniel."
,"17":"'Are the seals unbroken, Daniel?' the king asked. Daniel answered, 'They are unbroken, O king.'"
,"18":"Opening the door, the king looked at the table, then exclaimed, 'You are indeed great, O Bel. There is no deception in you.'"
,"19":"Daniel laughed, and restraining the king from entering, he said, 'But look at the floor and see whose footprints these are.'"
,"20":"The king said, 'I see footprints of men, women and children.'"
,"21":"Enraged, the king ordered the priests and their wives and children to be seized. They were compelled to show him the secret door through which they used to enter to consume the offerings on the table."
,"22":"They were put to death on orders of the king. And Bel was handed over to Daniel, who destroyed the idol and its temple."
,"23":"In Babylon there was a big dragon which was also worshiped."
,"24":"'Look,' said the king to Daniel, 'this is alive, not made of bronze. Would you deny that this is a living god? Worship it.'"
,"25":"Daniel replied, 'I will worship no one but the Lord my God, for he alone is the living God."
,"26":"With your permission, O king, I will slay this dragon without sword or club.' The king answered, 'You have my permission.'"
,"26":"Then Daniel took some pitch, fat and hair, and boiled them together. He made them into cakes which he fed to the Dragon. And the Dragon burst after eating them."
,"27":"Daniel said to the king, 'Now look at what happened to the thing you worship."
,"28":"The Babylonians became angry upon hearing of this. 'Our king has become a Jew,' they said. 'He destroyed Bel, killed the Dragon and put the priests to death.'"
,"29":"They went to the king and said, 'Hand Daniel over to us or we will kill you and your family!'"
,"30":"The king was forced to hand Daniel over to the people."
,"31":"Daniel was thrown into the lions' den, where he stayed for six days."
,"32":"In the den were seven lions which were fed daily with two human bodies and two sheep. This food was withheld from them, to make sure that they would devour Daniel."
,"33":"Now in Judea was a prophet named Habakkuk. He had put some bread and stew in a basket, and was about to take them to the reapers in the field"
,"34":"when an angel of the lord appeared and said to him, 'Take that lunch to Daniel in the lion's den at Babylon.'"
,"35":"Habakkuk said, 'Sir, I have never been to Babylon nor have I seen the lions' den.'"
,"36":"The angel then took him by the crown of his head, carried him by his hair, and soon they were alighting above the lion's den in Babylon."
,"37":"'Daniel, Daniel,' cried, Habakkuk, 'take this lunch God has sent you.'"
,"38":"Daniel gave thanks to God, saying, 'You have remembered me, O God, and have not forsaken those who love you.'"
,"39":"Daniel ate, and the Lord's angel returned Habakkuk to his own place."
,"40":"On the seventh day, the king came to the lions' den to mourn for Daniel. He looked inside and saw Daniel sitting there."
,"41":"The king cried aloud, 'How great you are, O Lord God of Daniel! Surely there is no other God but you!'"
,"42":"He took Daniel out and threw into the den those who tried to destroy him. They were at once devoured before his eyes."
}`)

}
func EN_CCB_LoadVMEZChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"On the fifth day of the fourth month of the thirtieth year when I was with the exiles by the river Kebar, the heavens opened and I had visions from Yahweh."
,"2":"On the fifth of the month (it was the fifth year of the exile of King Jehoiakin)"
,"3":"the word of Yahweh came to Ezekiel, son of Buzi, the priest, in the land of the Chaldeans by the banks of the Kebar. There the hand of Yahweh was upon me."
,"4":"I looked: a windstorm came from the north bringing a great cloud. A fiery light inside it lit up all around it, while at the center there was something like a glowing metal."
,"5":"In the center were what appeared to be four creatures with the same form;"
,"6":"but each had four faces and four wings."
,"7":"Their legs were straight and their feet were like those of a calf, shining like polished bronze."
,"8":"Under their wings (on their four sides) they had human hands. The wings of one"
,"9":"touched those of the other. Their faces did not turn as they advanced, because they were able to go forward in any of the four directions of their faces."
,"10":"I saw they had human faces; but each one also had the face of a lion on the right, and on the left the face of an ox, and all four had the face of an eagle."
,"11":"Their wings were spread upwards. Each had two wings meeting those of its neighbor and two covering its body; having four faces they could advance in any of the four directions."
,"12":"Wherever the spirit would go, they went without turning as they advanced."
,"13":"Between these creatures could be seen glowing coals like torches moving between them. The fire blazed and flashed from thunderbolts."
,"14":"The creatures ran to and fro like thunderbolts."
,"15":"While I looked at the creatures, I saw a wheel on the ground beside each of them,"
,"16":"glittering as if made of chrysolite. The four wheels had the same shape: indeed each was double - two wheels placed crosswise,"
,"17":"so they could follow any of the four directions without turning as they went."
,"18":"Their rims were lofty and looked terrifying, and the four of them were covered with eyes all the way round."
,"19":"When the creatures moved forward the wheels moved along beside them and when the creatures rose from the ground the wheels rose, too."
,"20":"Wherever the spirit was to go, there the creatures went and the wheels went with them for the spirit of the creatures was also in the wheels."
,"21":"When the creatures moved forward they did, too, stopping when they stopped, rising above the ground when they did, for the spirit of the creatures was in the wheels."
,"22":"Over the heads of the creatures was a kind of platform; it looked like crystal."
,"23":"Under the platform their wings were straight, one parallel to the other. (Each creature had two that covered its body)."
,"24":"I heard the noise of their wings when they moved, similar to the roar of many waters, similar to the voice of the Most High, the noise of a multitude or of a camp. When they were not moving they lowered their wings."
,"25":"I heard a noise above the platform over their heads."
,"26":"Above it was a throne resembling a sapphire and high on this throne was a figure similar to that of a man. Then I saw a light as of glowing bronze as if fire enveloped him"
,"27":"from his waist upwards. And from his waist downwards it was as if fire gave radiance around him."
,"28":"The surrounding light was like a rainbow in the clouds after a day of rain. This vision was the likeness of Yahweh's Glory. On seeing it I fell on my face and then I heard a voice speaking."
}`)
	CurrentBook.AddChapter(2, `{
"1":"He said to me, 'Son of man, stand up for I am about to speak to you.'"
,"2":"A spirit came upon me as he spoke and kept me standing and then I heard him speak,"
,"3":"'Son of man, I am sending you to the Israelites, to a people who have rebelled against me; they and their fathers have sinned against me to this day."
,"4":"Now I am sending you to these defiant and stubborn people to tell them 'this is the Lord Yahweh's word.'"
,"5":"So, whether they listen or not this set of rebels will know there is a prophet among them."
,"6":"But you, son of man, do not fear them or what they say, for they will be as thorns for you and you will be sitting on a nest of scorpions. Don't be afraid of their words when you are facing this set of rebels."
,"7":"Tell them what I say whether they choose to listen or not, for they are rebels."
,"8":"Listen then, son of man, to what I say and don't be a rebel among rebels. Open your mouth and take in what I'm about to say.'"
,"9":"I looked and saw a hand stretched out in front of me holding a scroll."
,"10":"He unrolled it before me; on both sides were written lamentations, groanings and woes."
}`)
	CurrentBook.AddChapter(3, `{
"1":"He said to me, 'Son of man, eat what is given to you. Eat this scroll and then go; speak to the people of Israel.'"
,"2":"I opened my mouth and he made me eat the scroll and then"
,"3":"he said to me, 'Eat and fill yourself with this scroll that I'm giving you.' I ate it and it tasted as sweet as honey."
,"4":"He said, 'Son of man, go to the Israelites; speak to them with my words."
,"5":"Indeed it is not a people with a difficult foreign language to whom you are sent; it is to the people of Israel."
,"6":"It's not to the many nations with difficult and obscure languages which you cannot understand. If I sent you to them they would listen to you."
,"7":"But the Israelites will not listen to you because they are not willing to listen to me; all of them are defiant and stubborn of heart."
,"8":"See I am making your face as unyielding as theirs and your forehead as hard as theirs."
,"9":"I am making your forehead as hard as a diamond, harder than flint; so you shall not fear or tremble because of this set of rebels.'"
,"10":"He said to me, 'Son of man, listen and take to heart all I say to you,"
,"11":"and then go to the exiles, your fellow countrymen, speak to them and tell them: 'This is what Yahweh says,' whether they listen or not.'"
,"12":"Then the spirit lifted me up; behind me I heard a great acclamation, 'Blessed be the Glory of Yahweh in his dwelling place'"
,"13":"and I heard the noise of the animals' wings brushing against each other, and the noise of the wheels; it was a great uproar."
,"14":"The spirit had lifted me up, and carried me off but I went in a bitter and feverish spirit because the hand of Yahweh was heavy upon me."
,"15":"I came to Tel Abib to the exiles living by the river Chebar and I stayed there seven days with them, overwhelmed."
,"16":"After seven days the word of Yahweh came to me,"
,"17":"'Son of man, I have made you a watchman for the House of Israel. With the word you hear from my mouth you will warn them in my name."
,"18":"When I say to the wicked, 'You will surely die,' if you do not speak to warn the wicked man to give up his evil ways and so live, he shall die for his sin, and I will hold you responsible for his death."
,"19":"But if you have warned the wicked man and he has not given up his wickedness and evil ways, he shall die for his sin but you will save yourself."
,"20":"When the righteous man turns from what is good to do evil I shall put an obstacle in his path: he shall die. Since you did not warn him, he will die for his sin. His good deeds will not be remembered and I shall hold you responsible for his death."
,"21":"But when you have warned the righteous man to keep him from sinning and he has not sinned, he will live for sure for he was warned and you will save your life.'"
,"22":"The hand of Yahweh was upon me and he said to me,'Get up! Go to the valley and there I shall speak to you.'"
,"23":"I got up and went towards the valley and there was the Glory of Yahweh that I had seen by the Chebar river. I fell on my face."
,"24":"Then the spirit came to me and kept me standing; He spoke to me and said; 'Go! Shut yourself in your house."
,"25":"You, son of man, will be bound with cords and prevented from going among the people."
,"26":"Your tongue shall stick to your palate and you will remain dumb and not be able to rebuke them for they are a rebellious people."
,"27":"But when I speak to you I shall open your lips and you shall say to them: This is the word of Yahweh! He who listens, let him listen and he who refuses to listen, let him refuse for they are a rebellious people."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Son of man, take a clay tablet; place it in front of you and draw on it the city of Jerusalem."
,"2":"Then act as if you were laying siege to it; dig a trench round it and build a ramp; set up tents and a battering ram against it."
,"3":"Take an iron pan; place it as a wall of iron between you and the city and look towards the city: it is under siege and you are besieging it. All this will be a sign for the people of Israel."
,"4":"Lie on your left side, taking upon yourself the sin of Israel, for you will bear their sin as long as you are lying on it."
,"5":"I have assigned to you a number of days equal to the duration of their sins - for a hundred and ninety days you will bear the sin of Israel."
,"6":"When you have completed this you shall lie down again on your right side and bear the sin of Judah for forty days - one day corresponding to a year."
,"7":"Then you shall turn your face and your bared arm towards the siege of Jerusalem and prophesy against it."
,"8":"I shall bind you with cords to prevent you from turning from one side to the other until you have completed the days of your confinement."
,"9":"Take some wheat and barley, some beans, lentils, millet and spelt; put it all in one vessel and make some bread; this is what you will eat all the time you are lying on your side - one hundred and ninety days."
,"10":"The food you eat will be a daily ration of eight ounces a day;"
,"11":"you will drink two thirds of a quart of water each day."
,"12":"Eat the food as you would a barley cake. You will cook it publicly on human dung,"
,"13":"for that is the way - says Yahweh - the people of Israel will eat unclean bread among the nations where I shall drive them.'"
,"14":"I said, 'Ah, Lord Yahweh! I have not been defiled: from childhood until now I have never eaten any animal found dead or torn; unclean meat has never entered my mouth.'"
,"15":"He then said, 'Very well! I allow you cow dung in place of human dung for baking your bread.'"
,"16":"He continued, 'Son of man, I shall cut off the food in Jerusalem. They will eat strictly-rationed bread with anxiety and despair as they drink water sparingly,"
,"17":"for food and water will be in short supply and they will all waste away because of their sin."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Son of man, take a sharp sword and use it as a barber's razor on your head and beard. Then take scales and divide the hair you have cut off."
,"2":"Burn a third of it in the middle of the city at the end of the siege, then take a third that you will strike with the sword all around the city; finally scatter a third in the wind and unsheathe a sword and pursue them."
,"3":"Take a few strands of hair and tuck them away in the folds of your clothes;"
,"4":"then throw some of them to burn in the fire. Then speak against all Israel:"
,"5":"This is what Yahweh said: That is Jerusalem! I placed her in the midst of the nations surrounded by other countries;"
,"6":"she rebelled against my laws and my precepts more than neighboring nations. In fact she rejected my laws and did not keep my decrees."
,"7":"That is why Yahweh speaks thus: Your rebellion is greater than that of the nations around you - you have not kept my laws, respected my decrees or observed my ordinances but instead have conformed to the laws of neighboring nations -"
,"8":"because of that Yahweh speaks thus: I too have set myself against you. I will pass judgment on you in the sight of the nations."
,"9":"And because of your abominations I will punish you in a way I have never before done and never will do in the future."
,"10":"That is why fathers among you will eat their children and children their fathers. I will pass judgment on you and scatter your remnant to every wind."
,"11":"Therefore as surely as I live, declares Yahweh, because you have defiled my sanctuary with all your horrors and abominations, I will strike you without pity! I too will show no mercy!"
,"12":"A third of your people will die of the plague or starve within your walls, a third will fall by the sword outside the city, a third I will scatter to the winds and pursue with sword unsheathed."
,"13":"My anger will spend itself, my fury against them be satisfied. I will have my revenge and they will know that I, Yahweh, have spoken in my jealousy when I have exhausted my fury against them."
,"14":"I will make you a heap of ruins, a reproach among the neighboring nations in the eyes of all who pass by."
,"15":"You will be a reproach, a taunt, a lesson, a warning and an object of horror for the nations near you when, with anger, wrath and stinging reproach, I punish you. I, Yahweh, have spoken."
,"16":"When I send against you the deadly arrows of starvation to do away with you and blot you out, I will make you lack all food."
,"17":"Hunger and wild beasts will destroy your children, while sword and plague will visit you. It is I, Yahweh, who have spoken.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"The word of Yahweh came to me as follows,"
,"2":"'Son of man, look towards the mountains of Israel and prophesy against them. Say to them:"
,"3":"Mountains of Israel, listen to the word of Yahweh! To the mountains and hills, to the rivers and valleys Yahweh has spoken: I am going to bring the sword against you and destroy your high places."
,"4":"Your altars will become desolate, your incense burners smashed;"
,"5":"I will lay your corpses in front of your idols and scatter your bones around your altars."
,"6":"Wherever you live, the towns will be in ruins and the high places desolate, your altars demolished and defiled, your filthy idols smashed and ruined,"
,"7":"your incense burners knocked all around you and you will know that I am Yahweh."
,"8":"But I shall spare some of you. They will escape the sword and be scattered among the nations."
,"9":"Your survivors then will remember me among the people where they are exiled, for I shall break the adulterous hearts of those whose eyes lusted after their idols. They will loathe themselves for the evil they committed, for all their abominations."
,"10":"And they will know that I, Yahweh, have not spoken in vain in saying I would inflict this disaster on them.'"
,"11":"This is what Yahweh said, 'Clap your hands, stamp your feet and say: Well done! when the people of Israel are falling by the sword, famine and plague because of their abominations."
,"12":"He who is far away will die of the plague, he who is near will fall by the sword, whoever survives and is spared will die of starvation. Against them I will exhaust my fury."
,"13":"And you will know that I am Yahweh when their people lie slain in the midst of their idols, around their altars, on every high hill, on the mountain tops, under every green tree and spreading oak and wherever they offered fragrant incense to all their idols."
,"14":"I will stretch out my hand against them, I will make their country a desolate wasteland from the desert to Riblah, wherever they live; and they will know that I am Yahweh.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"This word of Yahweh came to me,"
,"2":"'And you, son of man, listen to what the Lord says to Israel:"
,"3":"Finished! The end is coming for the four corners of the land. It is all over for you. I am unleashing my anger against you. I will judge you according to your ways and repay you for all your filthy practices."
,"4":"I will not look on you with pity; I will be merciless. I will bring against you what is fitting for your conduct and your detestable practices and you will know it is Yahweh striking you."
,"5":"Thus says Yahweh: Disaster! Disaster is coming!"
,"6":"The end is near! It is your turn, you who live in the country."
,"7":"The time has come, the day is near! No joy, only panic on the mountains!"
,"8":"Now I am unleashing my fury against you; my anger will exhaust itself on you. I will judge you according to your ways and your detestable practices."
,"9":"I will not look on you with pity; I will be without mercy. I will judge you according to your conduct and call you to account for your detestable practices. I will not look on you with pity and I will show you no mercy. I will give you what your conduct deserves. And you will know that I am Yahweh when I strike you for your abominable practices."
,"10":"This is the day, the end is coming, the die is cast. For insolence has blossomed, pride bears its fruits"
,"11":"and violence reigns. No one will escape."
,"12":"The time has come, the day is here! Let not the buyer rejoice or the seller regret, for the punishment will fall upon all."
,"13":"The seller will not get back what he has sold, even though he survives, for the sentence regarding the multitude will not be reversed."
,"14":"They may sound the trumpet, make preparations, but no one will go to battle, for I am indignant with all."
,"15":"Outside in the open is the sword; plague and starvation in the houses. Those in the country will die by the sword, those in the city will be victims of famine and plague."
,"16":"Those who escape will go to the mountains; they will be like doves, each one moaning because of his sin."
,"17":"Every hand will be limp, every knee as weak as water;"
,"18":"they will put on sackcloth and shudder. All will be covered with shame and every head bald."
,"19":"They will throw their silver in the streets and their gold will be dropped like filth. Silver or gold will not save them on the day of Yahweh's anger. It will be useless to satisfy their hunger and to fill their stomachs, for it was their stumbling block, the cause of their sin."
,"20":"They became proud of their splendid jewel (the Temple), but they put into it their loathsome images and idols; that is why I will make it a horror."
,"21":"I will hand it over as plunder to foreigners and as booty to the most wicked of the land, and they will defile it."
,"22":"I will take away my protection from them and people will profane my treasure. Robbers will enter and desecrate it"
,"23":"and within it there will be massacres, for the land is full of violence."
,"24":"I will bring the most cruel of the nations to take possession of their houses. I will break the pride of the violent and their sanctuaries will be profaned."
,"25":"Anguish is coming; they will seek peace but there will be none."
,"26":"Disaster will follow disaster, rumor will follow rumor. In vain will they demand a vision from the prophet. The priest will have no answer; the elders will be unable to advise."
,"27":"The king will mourn; the princes will be overcome with grief, and the hands of the citizens will tremble. I will treat them as their conduct deserves and judge them according to their deeds, and they will know that I am Yahweh."
}`)
	CurrentBook.AddChapter(8, `{
"1":"On the fifth day of the sixth month in the sixth year, I happened to be sitting in my house with the elders of Judah sitting in front of me when the hand of Yahweh fell heavily on me."
,"2":"I looked and saw a being as of fire. Downwards from what appeared to be his loins there was the appearance of fire, and from his loins upward a brightness like sparkling bronze."
,"3":"As he stretched out the form of a hand and took me by my hair, the spirit lifted me between heaven and earth and brought me in a divine vision to Jerusalem, to the entrance of the inner gate facing north. There stands the idol which provokes Yahweh's jealousy."
,"4":"And the Glory of the God of Israel was there, similar to the vision I had seen in the plain."
,"5":"He said to me, 'Son of man, look to the north.' I looked in the direction of the north and there, to the north of the altar gate, at the entrance, I saw this idol which provokes his jealousy."
,"6":"He said to me, 'Son of man, do you see what they are doing? Do you see the great abomination that Israel commits here to drive me from my sanctuary? You will see other abominations greater than this.'"
,"7":"He then led me to the door of the court."
,"8":"He said, 'Son of man, break through the wall.',I broke through the wall and made an opening. "
,"9":"He said, 'Go in and see the wicked abomination they are committing here.'"
,"10":"I went in, looked around and saw all kinds of reptiles, repulsive beasts and all the filthy idols of Israel portrayed on the wall all around."
,"11":"Before them stood seventy men, elders of Israel, and among them was Jaazaniah, son of Shaphan. Each held a censer in his hand, and perfume rose from a cloud of incense."
,"12":"He said, 'Do you see, son of man, what the elders of Israel do in the dark, each one in his room of pictures? For they think: Yahweh does not see us; Yahweh has forsaken the land.'"
,"13":"Then he said, 'You will see more of their great abominations.'"
,"14":"He brought me to the entrance of the north gate of the house of Yahweh and there women were sitting, weeping for Tammuz."
,"15":"He said to me, 'Did you see, son of man? You will see even greater abominations than these.'"
,"16":"And he led me to the inner court of the house of Yahweh and at the door to Yahweh's sanctuary, between the porch and the altar, were about twenty-five men, their backs to the temple, facing east and worshiping the sun. He said to me,"
,"17":"'Did you see, son of man? Is it not enough for Judah to commit the abominations that they commit here? See they are waving the branch before their nose."
,"18":"I too will act against them in anger; my eye will not see with pity and I will be without mercy. Though they cry loudly in my ears, I will not hear them.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Then he shouted loudly in my ears saying, 'The punishment of the city is near; see each one of these has in his hand his instrument of destruction.'"
,"2":"And six men came from the direction of the upper gate which faces north, each one with his instrument of destruction. With them was a man clothed in linen with writing material at his side. They came and stopped near the altar of bronze."
,"3":"Then the Glory of the God of Israel rose from the cherubim where it rested and went to the threshold of the house. Yahweh called to the man clothed in linen who had the material for writing at his side,"
,"4":"and he said to him, 'Pass through the center of the city, through Jerusalem, and trace a cross on the forehead of the men who sigh and groan because of all the abominations committed in it.'"
,"5":"I heard him say to the others, 'Now you may pass through the city after him and strike. Your eyes shall not look with pity; show no mercy! Do away with them all -"
,"6":"old men, young men, virgins, children and women - but do not touch anyone marked with a cross.',And as they were told to begin with the sanctuary, they struck the elders who were in front of the Temple. "
,"7":"Yahweh said to them, 'Let the courts be filled with the slain and the Temple be defiled with their blood; go out!',They went and slew the people in the city. "
,"8":"While they were slaying the people, I fell on my face and cried out saying, 'Ah, Yahweh! Are you going to destroy all that is left of Israel, and unleash your fury against Jerusalem?'"
,"9":"He said to me, 'The sin of Israel and Judah is very great; the land is filled with blood and the city full of perversion. For they say: 'Yahweh has forsaken the land; Yahweh does not see.'"
,"10":"I too will be without pity; I will show no mercy and I will bring their deeds upon their heads.'"
,"11":"Then the man clothed in linen who brought the writing kit reported, 'I have done what you ordered.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"I looked and saw that in the expanse over the heads of the cherubim there was something resembling a sapphire stone in the form of a throne."
,"2":"He spoke to the man clothed in linen, 'Enter by the space between the wheels under the cherubim, fill your hands with coals of fire from between the cherubim and scatter them over the city.' And I saw him as he entered."
,"3":"The cherubim stood at the right of the Temple when the man entered and the cloud filled the inner court."
,"4":"Then the Glory of Yahweh rose from above the cherubim to the threshold of the Temple and the Temple was filled with the cloud while the court was filled with the radiance of Yahweh's Glory."
,"5":"The noise of the cherubim's wings could be heard as far as the outer court, similar to the voice of God Almighty when he thunders."
,"6":"Yet the man clothed in linen had been given the order to take the fire from between the wheels, in the space between the cherubim; so he went and stood beside the wheel."
,"7":"A cherub then stretched his hand towards the fire in the space between the cherubim, took some and gave handfuls to the man clothed in linen who took them and went out."
,"8":"At that moment I noticed this human hand under the wings of the cherubim."
,"9":"I also saw four wheels beside the cherubim, each wheel beside a cherub. The wheels resembled sparkling chrysolite."
,"10":"As for their appearance, the four had the same form; each was formed of two wheels placed crosswise,"
,"11":"so they could move following any of their four directions, without turning as they went."
,"12":"In the direction the cherub's head was turned, the wheels followed without turning. Their rims were full of eyes all around."
,"13":"In my hearing the wheels were called 'whirling.'"
,"14":"(Each one had four faces, the first was the face of a cherub, the second the face of a man, the third the face of a lion, the fourth the face of an eagle."
,"15":"The cherubim mounted up - they were the same creatures I had seen by the river Chebar)."
,"16":"When the cherubim moved, the wheels moved at their side and when the cherubim raised their wings to rise above the earth, the wheels did not depart from their side."
,"17":"When they stopped, the wheels stopped; when they rose, the wheels rose with them, for the spirit of the living creatures was in them."
,"18":"The Glory of Yahweh went from above the threshold of the house and went to rest on the cherubim."
,"19":"Then the cherubim left, opening their wings and rising above the earth in my sight, and the wheels went with them. They halted at the east gate of the house of Yahweh and the Glory of the God of Israel was over them."
,"20":"These were the living creatures I had seen under the God of Israel on the banks of the river Chebar. I recognized them as cherubim."
,"21":"Each had four faces, each had four wings and they had what seemed like human hands under their wings."
,"22":"As for the appearance of their faces, they were the faces I had seen by the river Chebar, the same likeness. Each one went straight ahead."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Then the spirit lifted me up and brought me to the eastern gate of Yahweh's house, the one facing east, and there at the entrance to the gate were twenty-five men. Among them I saw Jaazaniah son of Azzur and Peletiah, son of Benaiah, leaders of the people."
,"2":"Yahweh said to me, 'Son of man, these are the men who plot wickedness and give evil counsel in the city."
,"3":"They say: 'Now there is no need of more houses! The city is the pot and we are the meat!'"
,"4":"Because of that, prophesy against them, prophesy, son of man!'"
,"5":"The spirit of Yahweh seized me and said, 'Speak! This is the word of Yahweh: I know what you have said, Israel! I know what you are thinking."
,"6":"You have multiplied your victims in the city; you have filled the streets with the slain."
,"7":"That is why Yahweh has spoken. The slain you have left in its midst; they are the meat, this city is the pot and I will bring you out of it."
,"8":"Yahweh says: Because you are afraid of the sword, I will send the sword against you."
,"9":"I will make you leave and deliver you over to foreigners and I will pass sentence on you."
,"10":"You will fall by the sword; I will judge you on the borders of Israel and you will know that I am Yahweh. "
,"11":"The city will not be like a pot to preserve you, nor will you be meat within her."
,"12":"And you will know that I am Yahweh, for until now you have not walked according to my ordinances; you have not applied my laws, but instead you have acted according to the laws of the nations around you.'"
,"13":"It happened that while I was prophesying, Pelatiah, son of Beniah, died. I fell on my face and cried aloud saying, 'Ah, Yahweh! Are you to destroy even the remnant of Israel?'"
,"14":"The word of Yahweh came to me in these terms,"
,"15":"'Son of man, these people have said of your brothers, your relatives, and all the exiled Israelites: 'They are well far from Yahweh! He gave this land to us as our possession.'"
,"16":"Give them therefore this word from Yahweh: I myself have sent them far away among the nations and scattered them among the peoples, but I have been a sanctuary for them in the countries they entered."
,"17":"For that reason Yahweh says, 'I will gather you from among the peoples; I will group you together out of the countries where you were scattered and give you the land of Israel."
,"18":"When you have come back and removed all the horrors and abominations, I will give you a new heart; I will put a new spirit in you."
,"19":"Yes, I will remove their heart of stone and give them a heart of flesh,"
,"20":"that they may walk in my statutes, observe my laws and practice them, and they shall be my people and I will be their God."
,"21":"As for those whose hearts follow their horrors and abominations, I will punish them according to their deeds.'"
,"22":"Then the cherubim lifted up their wings and the wheels went with them."
,"23":"The Glory of the God of Israel was over them. The Glory of Yahweh rose, leaving the city to rest on the mountain that is to the east. "
,"24":"At that point the spirit lifted me up and brought me to the exiles in Chaldea - all this happened in vision by the power of the spirit of God - and the vision I had seen left me."
,"25":"Then I told the exiles all that Yahweh had shown me."
}`)
	CurrentBook.AddChapter(12, `{
"1":"This word of Yahweh came to me,"
,"2":"'Son of man, you live in the midst of a house of rebels: they have eyes for seeing but do not see; they have ears for hearing but do not hear, for they are a house of rebels."
,"3":"Because of this, son of man, prepare for yourself an exile's baggage in their sight as an exile does; and go as an exile to another place in their sight. Would that they may understand, because they are a house of rebels."
,"4":"You will gather your things, an exile's baggage, by day to be seen by them, and you will leave in the evening as for a departure of deportees. While they look on,"
,"5":"dig a hole in the wall and leave from there."
,"6":"As they look on, shoulder your baggage and leave in the dark. Veil your face and do not look at the land for I have made you a sign for Israel.'"
,"7":"I did as I was ordered, gathering my things by day, an exile's baggage, and in the evening I made a hole in the wall with my hand. I left in the dark, in their presence, shouldering my baggage."
,"8":"In the morning the word of Yahweh came to me:"
,"9":"'Son of man, did not the Israelites, these rebels, ask you, 'What are you doing there?'"
,"10":"Answer them on behalf of Yahweh: This oracle concerns the prince in Jerusalem and all the Israelites remaining in the city."
,"11":"Say, 'I am a sign for you,' for what I have done will happen to them: They will be deported, exiled."
,"12":"The prince among them shall shoulder his baggage in the dark and depart. They will dig a hole in the wall to let him leave by it. He will cover his face because he must not see the land with his eyes."
,"13":"I will spread my net over him and he will be caught in its mesh. I will bring him to Babylon in the country of the Chaldeans but he will not see it and it is there that he will die."
,"14":"As for all those who form his court, his guard, his troops, I will scatter them to the winds and pursue them with the sword."
,"15":"They will know I am Yahweh when I scatter them among the nations and disperse them in other countries."
,"16":"I will however allow a small number of them to escape the sword, famine and pestilence so they may confess their abominations among the nations where they will go and they will know I am Yahweh.'"
,"17":"This word of Yahweh came to me,"
,"18":"'Son of man, trembling you will eat your bread and you will drink water in fear and anxiety."
,"19":"Say to the people, 'This is what Yahweh says regarding those who live in Jerusalem in the land of Israel: In fear they will eat their bread and in affliction they will drink their water because the land will be desolate, stripped of all it contains, due to the violence of its inhabitants."
,"20":"Cities that were inhabited will become ruins, the country a wasteland and you will know that I am Yahweh.'"
,"21":"The word of Yahweh came to me in these terms,"
,"22":"'Son of man, what do you mean by this proverb: The days pass and the visions do not come true? Why do you refer thus to what happens in Israel?"
,"23":"You shall say to them this word of Yahweh: No more of this proverb. It will not be used in Israel, for the day is at hand when every vision will be fulfilled."
,"24":"No longer will there be false visions or misleading divinations in Israel."
,"25":"I, Yahweh, will say what I want to say, and my words will be fulfilled. There will be no more delay, for it is in your days, rebellious people, that I will speak and it will be done - word of Yahweh.'"
,"26":"The word of Yahweh was given me in these terms,"
,"27":"'Son of man, this is what Israel says: 'Ezekiel's visions refer to the distant future; he prophesies for times far off.'"
,"28":"Therefore speak to them: This is what Yahweh says: There will be no further delay concerning my words: what I say will be done - word of Yahweh.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"The word of Yahweh came to me again,"
,"2":"'Son of man, prophesy against the prophets of Israel, against those who prophesy on their own initiative. Say: Hear the word of Yahweh!"
,"3":"This is what Yahweh says: Woe to the senseless prophets who follow their own inspiration without having seen anything!"
,"4":"Your prophets, Israel, are like foxes among the ruins!"
,"5":"They have not gone up to the breaches nor have they built a wall around Israel so that she may hold out in battle on the day of Yahweh."
,"6":"Their discourse is trickery and lies; they say: word of Yahweh when Yahweh has not sent them and yet they wait for him to fulfill their word."
,"7":"Is it not a false vision you have seen? Have you not uttered lying divinations? You say: oracle of Yahweh when I have not spoken."
,"8":"But this is what Yahweh says: Because of your false and lying revelations I will oppose you, word of Yahweh."
,"9":"My hand will strike the prophets whose revelations are delusions, whose predictions are lies. They will not be accepted among my people's assembly nor will they be inscribed in the register of the nation of Israel. They will not reenter the land of Israel - and you will know that I am Yahweh."
,"10":"These prophets have misled my people saying 'Peace!' when there is no peace. The people are building a wall and these prophets daub it with whitewash;"
,"11":"but say to those who daub it with whitewash: The wall will fall. I will send torrential rain, huge hailstones and stormy winds, and see:"
,"12":"the wall will fall! Will they not say to you: Where is the whitewash with which you daubed it?'"
,"13":"That is why Yahweh speaks thus: In my fury I will make a violent wind break out and in my anger I will send a torrential downpour, and my wrath will hurl destructive hailstones."
,"14":"I will destroy the wall you daubed with whitewash; I will level it to the ground and its foundation will be laid bare. It will fall and beneath it you will be utterly destroyed and you will know that I am Yahweh."
,"15":"I will exhaust my anger against the wall and against those who daubed it with whitewash. Then they will say to you: Where is the wall and where are those who whitewashed it,"
,"16":"the prophets of Israel who prophesied to Jerusalem and who had visions of peace when there was no peace?'"
,"17":"Yahweh then said to me, 'As for you, son of man, turn towards the women of your people who prophesy on their own initiative, and prophesy against them."
,"18":"You will say: Woe to those who make magic bands for all wrists and veils for every size of head - those women who ensnare souls!"
,"19":"For the Lord Yahweh says: You who ensnare the lives of my people, will you preserve your own? You have dishonored me among my people for handfuls of barley and pieces of bread. Because of you, people die who should not die, and people live who should not live. For my people listen to you and your lies.'"
,"20":"That is why Yahweh speaks, 'I hate the wrist bands with which you ensnare souls like birds."
,"21":"I will tear your veils and free my people from your hands. No more will they fall into your hands and you will know that I am Yahweh."
,"22":"You have disheartened with lies the righteous whom I would never dishearten, and you have strengthened the wicked, that he might not turn away from his evil ways and so save his life."
,"23":"Because of that I will no longer let you have false visions or practice divinations. I will free my people from your clutches and you will know that I am Yahweh.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Some of the elders of Israel came and sat in front of me."
,"2":"Then the word of Yahweh came to me,"
,"3":"'Son of man, these men are keeping in their heart and remain attached to what makes them sin. Am I to allow them to consult me?"
,"4":"Speak to them on my behalf: To every Israelite who goes to a prophet while he keeps filthy idols in his heart and is attached to what makes him sin, I, Yahweh, will give the answer his many idols deserve."
,"5":"For I want to take hold of Israel's heart, the heart of all those who have strayed from me because of their filthy idols."
,"6":"So then say to the people of Israel: Thus says Yahweh: come back, turn away from your filthy idols; turn your face away from all your abominations."
,"7":"If a man of the people of Israel or a guest staying in Israel strays away from following me and goes to a prophet to consult me while he keeps idols in his heart and remains attached to what makes him sin, I, Yahweh, will answer him myself."
,"8":"I will turn my face against this man, I will make of him a proverbial example, I will strike him from the midst of my people and you will know that I am Yahweh."
,"9":"If the prophet lets himself be seduced and gives an answer, it will be I, Yahweh, who will have let him be seduced. I will stretch out my hand against him and destroy him from among my people Israel."
,"10":"They will be responsible for their sin. The prophet will be as guilty as the one who consulted him,"
,"11":"that the people of Israel may no longer stray from me. Instead of defiling themselves with all their transgressions, they will be for me a people and I will be their God - word of Yahweh.'"
,"12":"The word of Yahweh came to me in these terms,"
,"13":"'Son of man, when a nation sins against me by being unfaithful, I will stretch out my hand against it, deprive it of bread, and famine will destroy men and animals."
,"14":"But if there were found in the land these three men, Noah, Daniel and Job, they would save their lives because of their righteousness - word of Yahweh."
,"15":"If I also let wild beasts roam the land to deprive it of children so that it becomes a desolation without a passerby because of the beasts,"
,"16":"if these three men were in the land, as I live, word of Yahweh, they would not save their sons or daughters but only they themselves would be spared while the land would be made desolate."
,"17":"The same would happen if I brought the sword against this land and ordered the sword to go through the land destroying men and animals."
,"18":"If these three men were in the land, as I live, word of Yahweh, they would not save sons and daughters but they themselves would be spared."
,"19":"Or if I sent pestilence to the land and poured out my fury against it in bloodshed in order to destroy men and animals,"
,"20":"if Noah, Daniel and Job were in the land, as I live, word of Yahweh, they would not save sons or daughters, but their own lives would be spared because of their righteousness.'"
,"21":"Now this is what Yahweh says, 'Although I have sent my four great punishments, sword, famine, wild beasts and plague against Jerusalem to destroy men and animals,"
,"22":"there are survivors, sons and daughters who will be brought out. They will come to you here, and when you see their way of life and their deeds, you will no longer be shocked at the disaster I brought on Jerusalem and at everything that happened to her."
,"23":"They will set your mind at rest when you see their conduct and you will realize that not in vain was all that I did in the city - word of Yahweh.'"
}`)
	CurrentBook.AddChapter(15, `{
"1":"This word of Yahweh came to me,"
,"2":"'Son of man, in what way is the wood of the vine superior to that of any other tree in the forest?"
,"3":"Do they take its wood to make anything? Do they use it to make a peg for hanging a tool?"
,"4":"But now they have used it as fuel and the fire has burned it at both ends leaving the middle charred. Is it then of any use?"
,"5":"If it was of no use when it was whole, of even less use will it be when burnt in the fire.'"
,"6":"That is why Yahweh speaks thus, 'I took the vine from among all the trees of the forest, and I gave it to the fire to be burned. This is how I have just dealt with those living in Jerusalem."
,"7":"I will turn my face against them. Though they escaped from the fire, the fire will burn them and you will know that I am Yahweh when I turn against them."
,"8":"I will make the land desolate because they have been unfaithful - word of Yahweh.'"
}`)
	CurrentBook.AddChapter(16, `{
"1":"The word of Yahweh came to me in these terms,"
,"2":"'Son of man, make known to Jerusalem its sins."
,"3":"You say on my behalf: Your beginning was in Canaan; there you were born. Your father was an Amorite and your mother a Hittite."
,"4":"On the day you were born your cord was not cut, you were not bathed in water to make you clean, you were not rubbed with salt nor were you wrapped in cloth."
,"5":"There was no one to look with pity on you or compassionate enough to give you any of these attentions. You were left exposed in the open fields because you were looked upon with disgust on the day you were born."
,"6":"But I passed by and saw you immersed in your blood. I said to you in the midst of your blood, 'Live!'"
,"7":"I made you grow like a plant of the field."
,"8":"You grew up and became tall and were becoming of marriageable age. Your breasts were formed and your hair had grown but you were naked and exposed. I passed by later and saw you were at the age of love and spread part of my garment over you to cover your nudity. I made a covenant with you with an oath - word of Yahweh - and you were mine."
,"9":"Then I bathed you in water, I cleansed you of your blood and anointed you with oil."
,"10":"I clothed you with embroidered cloth and put soft leather sandals on your feet. I dressed you in fine linen and covered you with silk."
,"11":"I adorned you with jewelry, putting bracelets on your arms, a necklace around your neck"
,"12":"and a ring in your nose."
,"13":"I gave you earrings and a magnificent crown for your head. You were adorned with gold and silver; your clothing was fine linen, silk and embroidered cloth. You were fed on finest flour, honey and oil; you became very beautiful and rose to be queen."
,"14":"Your beauty was perfect and your renown spread through the nations, because of the splendor I had given you - word of Yahweh."
,"15":"But you relied on your beauty; you trusted in your fame and you began to give yourself to every passerby like a prostitute."
,"16":"With some of your garments you made your high places where you played the harlot (the like has never been and never will be)."
,"17":"With my silver and my gold and with the ornaments that were your splendor and which I had given you, you formed male idols and gave yourself to them."
,"18":"With your embroidered garments you covered them and before them you have placed my oil and my incense."
,"19":"My bread which I gave you, the fine flour, the oil and the honey with which I fed you, you offered as fragrant incense before them, word of Yahweh."
,"20":"You took the sons and daughters you bore for me and sacrificed them as food to the idols. Was it not enough to prostitute yourself?"
,"21":"Did you have to slaughter my children as an offering to your idols?"
,"22":"You revel in your abominations and prostitution without remembering the days of your youth when you were naked and exposed, lying in your blood."
,"23":"Woe, woe to you - declares Yahweh - for all this wickedness!"
,"24":"You built your mounds and made your high places at every crossroad."
,"25":"At the entrance to every road you built your lofty shrines; you defiled your beauty giving yourself to every passerby and always increasing your harlotry."
,"26":"You gave yourself to the Egyptians, your large-limbed neighbors and provoked my anger with your increasing promiscuity."
,"27":"And I stretched out my hand against you and reduced your territory and gave you over to the mercy of your enemies, the daughters of the Philistines who were shocked by your filthy ways."
,"28":"You played the harlot with the Assyrians as well because you were never satisfied. Yes, you played the harlot with them but you remained insatiable."
,"29":"Then you multiplied your prostitutions in a land of merchants, Chaldea, and even with that you were not satisfied."
,"30":"Ah! How my anger rose against you, word of Yahweh, as you did all that, the work of an accomplished harlot,"
,"31":"when you built your mounds at the entrance to every road and your shrines in every square! You were not like a prostitute because you scorned payments."
,"32":"Adulterous wife! You prefer strangers to your husband."
,"33":"All prostitutes receive fees, but you gave gifts to your lovers, bribing them to come to you for your favors."
,"34":"In your prostitution you have been different from other women; no one approaches you and whereas you offer payment no one gives you any. You are completely different."
,"35":"Therefore harlot, hear the word of Yahweh!"
,"36":"This is what Yahweh says, 'For having exposed yourself and uncovered your nakedness to your lovers and your abominable idols and because you have offered them the blood of your children, because of that,"
,"37":"I will gather all the lovers that found pleasure in you and all those you loved, as well as those you hated; I will assemble them from all around to come against you and I will strip you before them and they will see your nakedness."
,"38":"I will judge you as adulterous women are judged and as those who shed blood and I will bring upon you the blood vengeance of anger and jealousy."
,"39":"I will hand you over to them; they will tear down your mounds and shrines; they shall strip you of your clothes, taking from you the ornaments that were your splendor and leaving you naked and bare."
,"40":"They shall bring a troop against you to stone you and gash you with swords."
,"41":"Your houses will be burned by fire. Sentence shall be passed on you in the presence of many women. I will make you cease your prostitutions and you shall no longer be hired."
,"42":"But when I have exhausted my fury against you, my jealousy shall leave you. I will be calm and no longer angry."
,"43":"Because you did not remember the days of your youth and roused my anger with all these things, I in turn will make you responsible for all you did, word of Yahweh. Have you not added detestable deeds to all your other abominations?"
,"44":"Every maker of proverbs will say of you: 'Like mother, like daughter!'"
,"45":"You are the daughter of your mother who loathed her husband and her children, and you are the sister of your sisters who loathed their husbands and their children. Your mother was a Hittite, your father an Amorite."
,"46":"Your elder sister is Samaria who with her daughters lives on your left, and your younger sister at your right is Sodom with her daughters."
,"47":"You have followed their ways insanely and given yourself to the same abominations. You have been more corrupt than they in every way."
,"48":"As I live, word of Yahweh, Sodom your sister and her daughters have not done as you have done."
,"49":"The sins of Sodom your sister were pride, over-indulgence in food, complacency and indifference to the poor and needy."
,"50":"They were arrogant and did detestable things in my sight. For that reason I destroyed them as you have seen."
,"51":"As for Samaria she has not committed half of your sins. Your abominations are more numerous than hers and in comparison make your sisters appear righteous."
,"52":"So bear your disgrace, you who have committed such detestable sins that have provided excuses to your sisters! They appear to be more righteous than you are. Be ashamed and bear your disgrace since your sisters seem holy compared to you."
,"53":"When I restore the fortunes of Sodom and her daughters, I will restore your own fortunes in their midst,"
,"54":"that you may bear your shame and confusion because they now feel they are better than you."
,"55":"When your sister Sodom and her daughters and Samaria with hers will return to what they were before, you and your daughters will also return to what you were before."
,"56":"Had not Sodom your sister become a byword for you in the time when you felt proud,"
,"57":"before your wickedness had become known? But now you have become the taunt of the daughters of Edom and all her neighbors, of the daughters of the Philistines who all around show their disgust for you."
,"58":"You shall bear the consequences of your foul behavior and your abominations, word of Yahweh."
,"59":"For thus says Yahweh: 'I will treat you as you deserve, you who despised the oath and broke the covenant."
,"60":"But I will remember my covenant with you in the days of your youth and make in your favor an eternal covenant."
,"61":"You will be mindful of your ways and be ashamed when I take your sisters, both the elder and the younger, and give them to you as daughters, without prejudice to my covenant with you."
,"62":"For I will uphold my covenant with you and you will know that I am Yahweh,"
,"63":"so that you may remember, be ashamed and never open your mouth again because of your humiliation, when I have pardoned you for all you have done, word of Yahweh."
}`)
	CurrentBook.AddChapter(17, `{
"1":"The word of Yahweh came to me in these terms,"
,"2":"'Son of man, set a riddle and relate a parable to the people of Israel. Yahweh says this:"
,"3":"The great eagle with powerful wings, long feathers and fine plumage of various colors came to Lebanon and removed the top of a cedar."
,"4":"He broke off the topmost of the twigs and carried it off to a land of trade and set it in a city of merchants."
,"5":"He then took a seed of the land and planted it like a willow in fertile soil near abundant water."
,"6":"It grew and became a splendid vine with spreading branches turned towards the eagle, and roots growing deep. It became a vine growing branches and producing foliage."
,"7":"But there was another great eagle with powerful wings and abundant plumage and the vine twisted its roots and"
,"8":"its branches towards him to be better watered than in the soil where it was planted. That vine, however, was able to produce branches, bear fruit and develop into a magnificent vine, because it had been planted in a good field near abundant water.'"
,"9":"Yahweh says, 'Will the vine prosper? Will the eagle not tear out its roots and cut away its fruit so that the foliage will wither and the vine dry up? It will not take much effort or many people to pull up its roots."
,"10":"It has been transplanted, but it will not prosper. When the east wind blows, the vine will completely wither away. In the soil where it grows it will wither!'"
,"11":"The word of Yahweh came to me in these terms,"
,"12":"'Say to these rebellious people: Do you not recognize what all this signifies? The king of Babylon came to Jerusalem and carried the king and princes off to Babylon."
,"13":"Then he took a member of the royal family and made an alliance with him, binding him by oath. He also carried off the leading citizens"
,"14":"to keep the kingdom humble and unable to assert itself, and to oblige the king to respect the treaty."
,"15":"But the king rebelled against him and sent messengers to Egypt to ask for horses and a powerful army. Will he succeed? Will he escape after doing this? Will he escape after breaking the treaty?"
,"16":"As I live, word of Yahweh, he will die in the land of the king who put him on the throne, but whose oath he despised, and whose treaty he has broken. There in Babylon he will die."
,"17":"Pharaoh will not send a mighty army and throngs of men to help him in war when ramps are built and siege works erected to kill many people."
,"18":"This king has despised the oath and broken the treaty. Because he did all these things after giving his hand, he shall not escape!"
,"19":"That is why Yahweh speaks thus: 'As I live, I will make him account for the oath he despised and the treaty he broke."
,"20":"I will spread my net over him and he will be caught in its mesh. I will bring him to Babylon and there I will demand an account of his infidelity to me."
,"21":"As for the pick of his troops they will fall by the sword; those who survive will be scattered to the winds and you will know that I, Yahweh, have spoken.'"
,"22":"Thus says Yahweh: 'At the top of the cedar I will take one of its uppermost branches, a tender twig and plant it."
,"23":"On a lofty, massive mountain, on a high mountain of Israel I will plant it. It will produce branches and bear fruit and become a magificent cedar. Birds of all kinds will nest in it and find shelter in its branches."
,"24":"And all the trees of the field shall know that I am Yahweh, I who bring down the lofty tree and make the lowly tree tall. I will make the tree that is full of sap wither and the dry tree bloom. I, Yahweh, have spoken and this will I do.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"The word of Yahweh came to me in these terms,"
,"2":"'Why are you applying this proverb to the land of Israel: 'The fathers have eaten sour grapes and the children's teeth are set on edge'?"
,"3":"As I live, word of Yahweh, this proverb will no longer be quoted in Israel."
,"4":"All life is in my hands, the life of the father and the life of the son are mine. The lives of both are in my hands, so the one who sins will die."
,"5":"Imagine a man who is righteous and practices what is just and right."
,"6":"He does not eat in the mountain shrines, or look towards the filthy idols of Israel, does not defile his neighbor's wife, or have intercourse with a woman during her period;"
,"7":"he molests no one, pays what he owes, does not steal, gives food to the hungry and clothes to the naked,"
,"8":"demands no interest on a loan and doesn't lend for interest, refrains from injustice, practices true justice, man to man,"
,"9":"follows my decrees and obeys my laws in acting loyally. Because such a man is truly righteous, he will live, word of Yahweh."
,"10":"But perhaps this man has a son who steals and sheds blood, committing crimes which his father never did."
,"11":"Perhaps the son eats at the mountain shrines, defiles the wife of his neighbor,"
,"12":"oppresses the poor and needy, steals, neglects to pay his debts, looks to the idols, does detestable things,"
,"13":"demands interest on a loan, even practices usury. Will such a man live? No, he will not! Because he has committed all these abominations he will die: his guilt will fall upon him."
,"14":"But imagine that such a man has in turn a son who does not commit the sins he has seen his father do."
,"15":"He does not eat at the mountain shrines or look to the idols of Israel, does not defile his neighbor's wife,"
,"16":"or oppress anyone or ask for a pledge on a loan; does not steal; and gives food to the hungry and clothing to the naked,"
,"17":"turns from injustice, exacts no usury or excessive interest, observing my decrees and practicing my laws: such a man shall not die because of his father's sins; no, he will live!"
,"18":"His father instead, who practiced extortion and stole from others, will die for his sin, because he did wrong among his people."
,"19":"You may say, 'Why does the son not bear the guilt of his father?' But the son did what was just and right, observing and practicing my decrees; he will live!"
,"20":"The person who sins is the one who will die. The son will not be held responsible for the sin of his father and the father will not be responsible for the sin of his son. The righteous deeds of the righteous will be to his credit and the sin of the wicked will be charged against him."
,"21":"If the sinner turns from his sin, observes my decrees and practices what is right and just, he will live, he will not die."
,"22":"None of the sins he committed will be charged against him; he will live as a consequence of his righteous deeds."
,"23":"Do I want the death of the sinner? - word of Yahweh. Do I not rather want him to turn from his ways and live?"
,"24":"But if the righteous man turns away from what is good and commits sins as the wicked do, will he live? His righteous deeds will no longer be credited to him, but he will die because of his infidelity and his sins."
,"25":"But you say: Yahweh's way is not just! Why, Israel! Is my position wrong? Is it not rather that yours is wrong?"
,"26":"If the righteous man dies after turning from his righteous deeds and sinning, he dies because of his sins."
,"27":"And if the wicked man does what is good and right, after turning from the sins he committed, he will save his life."
,"28":"He will live and not die, because he has opened his eyes and turned from the sins he had committed."
,"29":"But you, Israel, say: Yahweh's way is not just! Is my position not just? Is it not rather yours that is wrong?"
,"30":"That is why I will judge you, Israel, each one according to his ways, word of Yahweh. Come back, turn away from your offenses, that you may not deserve punishment."
,"31":"Free yourselves from all the offenses you have committed and get a new heart and a new spirit. Why should you die, Israel?"
,"32":"I do not want the death of anyone, word of Yahweh, but that you be converted and live!'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"As for you, son of man, intone a lamentation for the princes of Israel."
,"2":"Say: A lioness among lions was your mother! Crouching among the cubs she nursed her whelps."
,"3":"One of these she pushed forward and he grew to be a young lion, able to tear his prey and become a man-eater."
,"4":"But the nations heard about him and he was trapped in their pit; and they brought him with hooks to the land of Egypt."
,"5":"When she saw that her hope had come to nothing, she took another of her cubs and made him a young lion."
,"6":"He strutted among the others for he had become a strong lion, able to tear his prey and be a man-eater."
,"7":"He destroyed their strongholds and ravaged their towns. The country and its inhabitants were alarmed at the sound of his roar."
,"8":"But the nations came against him from the regions round about. They spread their net over him and caught him in their pit."
,"9":"They put him in a cage with hooks and brought him to the king of Babylon. There he was put in custody so that his roar was no longer heard in the mountains of Israel."
,"10":"Your mother was like the vine of a vineyard planted near water. It became fruitful and leafy from being so well-watered."
,"11":"It produced a vigorous branch that became a royal scepter towering above the foliage. It was outstanding for its height and its numerous branches."
,"12":"But the vine was uprooted in fury and cast down to the ground. The east wind dried it up and stripped it of its fruit. Its vigorous branch withered and was burned by fire."
,"13":"It is now planted in the desert, in an arid land of drought."
,"14":"Fire from its stem has destroyed its branches and fruit. No vigorous branch or royal scepter has been left. This is a lament that people will sing."
}`)
	CurrentBook.AddChapter(20, `{
"1":"It happened on the tenth day of the fifth month of the seventh year, some men from among the elders of Jerusalem came to consult Yahweh and sat in front of me."
,"2":"Then the word of Yahweh came to me in these terms,"
,"3":"'Son of man, say to the elders of Israel: This is the word of Yahweh: Do you come to consult me? As I live, I will not answer you - word of Yahweh."
,"4":"Judge them, son of man, will you judge them? Let them know about the detestable practices of their fathers."
,"5":"Say to them: This is what Yahweh has said: The day I chose Israel, I committed myself to the descendants of Jacob with an oath. I revealed myself to them in the land of Egypt and I swore to them, I am Yahweh, your God. "
,"6":"On that day I swore to them that I would take them out of Egypt to a country I had explored for them, a land flowing with milk and honey, the most splendid of lands."
,"7":"I said to them: Let each one reject the horrors that attract him! Do not defile yourselves with the idols of Egypt. I am Yahweh, your God."
,"8":"But they rebelled against me and would not listen; none of them rejected the horrors that attracted them, none abandoned the filthy idols of Israel. I then thought of pouring out my fury on them, exhausting my anger against them in the land of Egypt."
,"9":"But for the sake of my Name I relented, lest it be profaned in the sight of the nations where they lived, whose inhabitants had seen how I revealed myself to the Israelites in bringing them out of Egypt."
,"10":"So I brought them out of Egypt and led them to the desert."
,"11":"I gave them my decrees and made my laws known to them, laws by which man lives provided he observes them."
,"12":"I also gave them my sabbaths to be a sign between us, letting them know that I am Yahweh who makes them holy."
,"13":"But Israel rebelled against me in the desert. They did not follow my decrees, they despised my laws by which man lives, provided he obeys them; they so profaned my sabbaths that in my fury I thought of destroying them in the desert."
,"14":"But again I relented for the sake of my Name, lest it be profaned in the sight of the nations who saw me bring them out."
,"15":"However I swore to them in the desert that I would not bring them to the land flowing with milk and honey that I had given them - the choicest of lands -"
,"16":"because they had despised my laws and had not followed my decrees; they had profaned my sabbaths, and their heart went after their idols."
,"17":"But I had pity on them and did not destroy them; I did not do away with them in the desert."
,"18":"I said to their children in the desert: Do not follow the example of your fathers; do not keep their practices and do not defile yourselves with their idols."
,"19":"I am Yahweh, your God. Follow my decrees, observe my laws and practice them."
,"20":"Keep my sabbaths holy and let them be a sign between us and you will know that I am Yahweh, your God."
,"21":"But their children too rebelled against me; they did not follow my decrees or observe my laws; they did not carry out these laws by which man lives provided he obeys them. They profaned my sabbaths and I thought of pouring out my fury on them and exhausting my anger against them in the desert."
,"22":"But once more I held back my hand lest my Name be profaned in the eyes of the nations that had seen me bring them out."
,"23":"However I swore to them in the desert that I would scatter them among the nations and disperse them in other lands since they had not obeyed my laws,"
,"24":"but instead had defiled my sabbaths and had looked to the idols of their fathers."
,"25":"In the meantime I gave them statutes that were not good and laws they could not live by,"
,"26":"so that they might be defiled by their gifts. I let them offer by fire all their firstborn, in order to shame them and let them know that I am Yahweh."
,"27":"Therefore, son of man, speak to Israel; say to them: This is what Yahweh says: Do you not know that your fathers offended me by their infidelity?"
,"28":"I led them to the land I had sworn to give them, but whenever they saw a lofty hill or leafy tree they offered sacrifices. They provoked me with the offerings they made there - appeasing aromas and drink offerings."
,"29":"Then I said to them, 'What is this place to which you go?' That is why they called it high place."
,"30":"Say to Israel, thus says Yahweh: Since you follow your fathers in lusting after their abominations,"
,"31":"in bringing your gifts and in sacrificing your children by fire, never ceasing to defile yourselves with your idols, am I to answer when you consult, Israel? As I live, word of Yahweh, I will not answer you."
,"32":"You have in mind to be like the other nations, worshiping wood and stone, but this shall not happen."
,"33":"As I live, word of Yahweh, I will rule you with an iron hand, an outstretched arm and outpourings of wrath."
,"34":"Then I will bring you from the midst of the nations and from the peoples where I have scattered you with a strong hand, an outstretched arm and outpourings of wrath."
,"35":"I will lead you to the wilderness of Syria and"
,"36":"there I will enter into judgment with you face to face. Just as I judged your fathers in the desert of Egypt,"
,"37":"so will I judge you, word of Yahweh. I will make you feel my rod and sort you out."
,"38":"I will rid you of rebels; though they go out from the land of their exile, they shall not enter the land of Israel and you will know that I am Yahweh."
,"39":"People of Israel, this is what the Lord Yahweh says: Go, serve your idols, but in the end you will not refuse to listen to me. No longer shall you profane my holy Name with your gifts and your idols."
,"40":"For it is on my holy mountain, the high mountain of Israel - word of Yahweh - that all Israel, all in the land, shall serve me."
,"41":"There I will accept you as a pleasing fragrance when I bring you out from the nations and assemble you from the lands where you were dispersed, and through you my holiness will be shown to the nations."
,"42":"You will know that I am Yahweh when I lead you to the land of Israel, to the land that I swore to your fathers that I would give you."
,"43":"And there you will remember your ways and all your deeds by which you defiled yourselves; and you shall loathe yourselves because of your evil ways."
,"44":"You will know that I am Yahweh when I deal with you, Israel, for my Name's sake and not according to your wickedness and corrupt deeds, word of Yahweh."
}`)
	CurrentBook.AddChapter(21, `{
"1":"The word of Yahweh came to me in these terms,"
,"2":"'Son of man, look towards the south; direct your words to the south and prophesy against Forest of the south."
,"3":"Say to the forest: 'O forest, hear the word of Yahweh: I am kindling a fire that will burn every tree, both green and dry; its flame will not be quenched but from the south to the north every face will be scorched."
,"4":"Everyone will see that it was I, Yahweh, who kindled it and that it will not be put out.'"
,"5":"This time I said, 'Lord Yahweh, they say that I am always talking in parables.'"
,"6":"But the word of Yahweh came to me in these terms,"
,"7":"'Son of man, look towards Jerusalem; address your words to the sanctuary and prophesy against Israel."
,"8":"Say to Israel: I come against you; I will unsheathe my sword and cut off from you both the good and the wicked."
,"9":"Yes: against both the good and the wicked. My sword is unsheathed against all mortals from north to south."
,"10":"And all will know that I, Yahweh, have unsheathed my sword, and unsheathed it will remain.'"
,"11":"And you, son of man, groan in the bitterness of a broken heart, groan in their presence."
,"12":"When they say to you, 'Why are you groaning?' you will answer: 'Because of what will happen; when you hear of it, every heart will melt, every hand become limp, every spirit will be faint and knees shall be as weak as water.' It is to happen; it has come, word of the Lord Yahweh.'"
,"13":"The word of Yahweh came to me in these terms,"
,"14":"'Son of man; prophesy and say on my behalf: The sword has been polished and sharpened."
,"15":"It has been sharpened for a massacre."
,"16":"Yahweh gave it to be polished and seized by the hand. He has had the sword sharpened and polished to hand to the executioner."
,"17":"Cry out and wail, son of man, for this sword is intended for my people and for the princes of Israel. They shall be given over to the sword with my people; beat your breast, word of Yahweh."
,"18":"-"
,"19":"And you, son of man, prophesy and clap your hands! The sword will strike and strike again for the slaughter, for the massacre."
,"20":"Hearts languish and people fall for I have placed at every gate the sword for slaughter."
,"21":"It has been sharpened and shines. O sword! slash to the right, slash to the left, wherever you turn."
,"22":"For my part I clap my hands and release my fury; I, Yahweh, have spoken.'"
,"23":"The word of Yahweh came to me in these terms,"
,"24":"'Son of man, mark two roads for the coming of the king of Babylon's sword. The two should leave from the same point."
,"25":"At the head of each road place a sign, the first directing the sword to Rammah of the Ammonites and the second to Judah and the fortified city of Jerusalem."
,"26":"The king of Babylon, in fact, is now standing at the parting of the ways, at the head of both roads looking for an omen. He is shaking arrows, questioning the idols, looking at the liver of the victims."
,"27":"The lot falls upon Jerusalem. Then he raises a warcry, 'Set a battering ram at the gates, construct a ramp and erect siegeworks.'"
,"28":"Those who have sworn allegiance to him in Jerusalem do not dare believe it; but he remembers their guilt and they are captured."
,"29":"That is why Yahweh has spoken: Your evil deeds have brought to mind your wickedness and made known your sins. And when I remembered you, sin appeared in all your deeds. Because of this you will be taken captive."
,"30":"As for you, dishonored criminal, prince of Israel, the day and moment of your punishment has come."
,"31":"They will remove your turban, take away your crown. All will be changed: what is lowly will be lifted high and what is lofty will be brought low."
,"32":"I will make it a ruins, a ruins such as never has been, until the one comes whose right it is to rule, the one I shall send."
,"33":"And you, son of man, prophesy and say: This is Yahweh's word concerning the Ammonites and their insults. This is what you are to say: The sword is unsheathed for the slaughter, polished and flashing for the work of destruction."
,"34":"Beware of your false visions and lying omens, when your sword is laid to the necks of the wicked for their time has come and their punishment is near."
,"35":"People of Ammon, put back the sword in its shealth. In your own place, in the land of your birth you will be judged."
,"36":"I will pour out my wrath on you, against you I will breathe the fire of my fury and hand you over to brutal men, experts in destruction."
,"37":"You will be fuel for the fire; your blood will be spilled throught the land and you shall be remembered no more for I, Yahweh, have spoken.'"
}`)
	CurrentBook.AddChapter(22, `{
"1":"The word of Yahweh came to me in these terms,"
,"2":"'Son of man, will you judge them? Will you judge the city of blood? Charge her with all her detestable practices."
,"3":"Say: This is Yahweh's word: City of bloodshed, your hour has come. You who made your own idols to defile yourself, you are nearing your last days, the end of your years has come."
,"4":"That is why I am making you an object of horror for the nations and a laughing-stock for every country."
,"5":"Those both near and far will mock you, for your name is defiled and you are full of tumult."
,"6":"The leaders of Israel, each according to his strength, have one intent - to shed blood."
,"7":"In you, Israel, father and mother are treated with contempt, in you the alien is oppressed, the fatherless and the widow are wronged."
,"8":"You have despised my holy things and profaned my sabbaths."
,"9":"In you, men slander to shed blood; in you, they go to eat on the hill sanctuaries and act shamefully."
,"10":"In you are those who defile their father's bed, in you are those who violate women when they are unclean."
,"11":"One man commits a detestable offense with his neighbor's wife, another shamefully dishonors his daughter-in-law, another violates his own sister, his father's daughter."
,"12":"In you, men accept bribes to shed blood. You exact interest and usury and you rob and exploit your neighbor, and you have forgotten me. It is Yahweh who speaks."
,"13":"See, I will clap my hands at your dishonest profit, and the blood you have shed. Will your courage hold out, will your hands be steady when I shall come against you?"
,"14":"I, Yahweh, have spoken and I will act accordingly."
,"15":"I will scatter you among the nations, I will disperse you in other countries to rid you of your uncleanness."
,"16":"Then you will be dishonored in the eyes of the nations and you will know that I am Yahweh.'"
,"17":"The word of Yahweh came to me in these terms,"
,"18":"'Israel has become for me like dross; some were like silver, bronze, tin, iron and lead; but in the furnace only dross is left."
,"19":"The Lord Yahweh has spoken: This is how I am gathering you together in Jerusalem."
,"20":"As they place silver, bronze, iron, lead and tin in the fires of a furnace to be smelted, so in my anger will I assemble you, put you in the furnace and smelt you."
,"21":"I will gather you in Jerusalem, stir up the fire of my wrath and smelt you in it."
,"22":"As silver is smelted in the furnace so will you be smelted and you will know that I, Yahweh, have poured out my fiery wrath against you.'"
,"23":"The word of Yahweh came to me in these terms,"
,"24":"'Son of man, say to Jerusalem: You are a land without rain, a land without a shower on a day of wrath,"
,"25":"a land where the princes have been like a roaring lion tearing its prey. They devour people; they take treasures and precious objects and increase the number of widows."
,"26":"Your priests have broken my laws and have profaned my holy things. They have made no distinction between what is holy and what is common; they have not taught what difference there is between the clean and the unclean. They have ignored my sabbath and I have been dishonored by them."
,"27":"The officials of the city are like wolves who tear their prey, shedding blood and killing people for unjust gain."
,"28":"As for the prophets, they whitewash everything by means of false visions and lying predictions, saying: 'Yahweh has spoken' when Yahweh has not spoken."
,"29":"The lords of the land have practiced extortion and robbery, oppressing the poor and needy, molesting the alien and denying him justice."
,"30":"I looked for a man among them to build a wall and stand on the breach to protect the land lest I destroy it, but I found none."
,"31":"So I have poured out my wrath against them; I have destroyed them in the heat of my fury bringing down on their heads all they have done - it is Yahweh who speaks.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"The word of the Lord Yahweh came to me in these terms,"
,"2":"'Son of man, there were two women, daughters of the same mother."
,"3":"They became prostitutes in Egypt, even from their youth. In that land their breasts were fondled and caressed."
,"4":"The elder was called Oholah, her sister Oholibah. Both of them were mine and they gave me sons and daughters. Oholah is Samaria and Oholibah is Jerusalem."
,"5":"Oholah was mine when she played the harlot; she lusted after her lovers, the Assyrians,"
,"6":"warriors dressed in purple, governors, commanders, desirable young men, riders on horses."
,"7":"She offered them her harlotry, to those who were the best of Assyria. She dishonored herself with all those for whom she lusted and with their idols."
,"8":"But she did not forget her harlotry with the Egyptians who had lain with her and poured their lust on her from the time of her youth."
,"9":"That is why I gave her over to her lovers, the Assyrians, the object of her lustful desires."
,"10":"They uncovered her nakedness, seized her sons and daughters and slew her. And she became a byword among women because punishment had come to her."
,"11":"Her sister, Oholibah, witnessed this but she was even more corrupt in her lust and worse than her sister in her prostitution."
,"12":"She lusted after the Assyrians, governors, commanders, horsemen, all desirable young men, and"
,"13":"I saw how she dishonored herself. Both sisters acted in the same way but she went further than her sister. "
,"14":"No sooner had she seen men portrayed on walls, pictures of Chaldeans sketched in vermilion than she lusted after these men,"
,"15":"tightly belted, heads top-heavy with turbans, all resembling Babylonian cavalry officers."
,"16":"She sent messengers to Chaldea and"
,"17":"they came to her in the bed of love and defiled her with their prostitution. They dishonored her so much that she turned from them in disgust."
,"18":"But because she had given herself and exposed her nakedness, I too turned from her in disgust just as I had turned away from her sister."
,"19":"She multiplied her harlotry recalling her youth when she played the harlot in Egypt."
,"20":"She lusted after her lovers whose bodies were like those of donkeys and whose organs resembled those of horses."
,"21":"She returned to the shameful conduct of her youth with the Egyptians."
,"22":"That is why, Oholibah, thus says Yahweh: I am sending against you your lovers from whom you have turned away in disgust and I will bring them against you from all sides,"
,"23":"Babylonians and Chaldeans, men of Pekod, Shoa and Koa and all the Assyrians with them, handsome young men, governors, commanders, cavalry officers, titled people, all riding horses."
,"24":"They will come against you with chariots, wagons and throngs of people who will assail you from all sides with buckler, shield and helmet."
,"25":"I will put your case before them and they will judge you according to their laws. I will release my jealousy against you so that they shall deal with you furiously. They will cut off your nose and your ears and what is left of you will fall by the sword. They will seize your sons and daughters and what is left of you will be consumed by the fire;"
,"26":"they will strip you of your clothes and ornaments."
,"27":"I will put an end to your shameful behavior and your harlotry dating from your time in Egypt; you will not look towards them again and will no longer dream of Egypt. Thus says"
,"28":"the Lord Yahweh: I am handing you over to those you hate, to those from whom you turned in disgust."
,"29":"They will treat you with loathing and take from you everything you have worked for, leaving you naked and uncovered and the nakedness of your harlotry will be exposed."
,"30":"Your shameful conduct and your promiscuity have brought this upon you, because you lusted after the nations and defiled yourself with their idols."
,"31":"Since you have gone the way of your sister, I will place her cup in your hand."
,"32":"Thus says Yahweh: You shall drink your sister's cup which is deep and wide. You shall be the butt of derision and mockery: the cup holds so much!"
,"33":"You shall be filled with drunkenness and sorrow; it is a cup of desolation and horror, the cup of Samaria, your sister!"
,"34":"You will drink and empty it to the dregs, and then tear your breasts - for I have spoken, word of the Lord Yahweh.'"
,"35":"That is why the Lord Yahweh speaks thus: 'Since you have forgotten me and turned your back on me, you too will pay for your immodesty and harlotry!'"
,"36":"Then Yahweh said to me, 'Son of man, will you judge Oholah and Oholibah? Confront them with their abominations,"
,"37":"for they have committed adultery and stained their hands with blood. They committed adultery with their idols and even sacrificed their children - my children - as food for them."
,"38":"At that time they defiled my sanctuary and profaned my sabbaths;"
,"39":"the same day they sacrificed their children to their idols, they entered my sanctuary to desecrate it. This is what they did in my house."
,"40":"Both of them sent messages to men who had come from afar and they came. You bathed yourself for them, painted your eyes and decked yourself with jewels."
,"41":"You seated yourself on a stately couch and beside a table on which you put incense and oil that was mine."
,"42":"The sound of a carefree crowd was heard there because of their number, not to mention the people brought in from the desert. They put bracelets on the wrists of the women and splendid crowns on their heads."
,"43":"Then I said about this city, worn out and defiled with her adultery: This is indeed harlotry!"
,"44":"Men go to her as one goes to a prostitute. So they went to Oholah and Oholibah, the dissolute women!"
,"45":"But upright men will judge as adulterous those who have shed blood, for indeed they are adulteresses and blood is on their hands.'"
,"46":"For thus says Yahweh: 'Let a great assembly be gathered against them! Let them be delivered to terror and spoil!"
,"47":"The assembly will stone them, have them cut in pieces by the sword, kill their sons and daughters and burn their houses."
,"48":"I will put an end to debauchery in this land; all the women will be warned and no longer will they imitate your immorality."
,"49":"I will make your immorality fall on your own heads and when you receive the punishment of your idolatry, you will know that I am Yahweh.'"
}`)
	CurrentBook.AddChapter(24, `{
"1":"The word of Yahweh came to me on the tenth day of the tenth month of the ninth year in these terms,"
,"2":"'Write today's date, this very day, because the king of Babylon has laid siege to Jerusalem today."
,"3":"Teach this rebellious people by means of a parable: This is what Yahweh ordered me to do: Put the pot on the fire; place it there and pour water into it."
,"4":"Put in it all the pieces of meat, the choice pieces, the leg and shoulder and fill it with the best of the bones."
,"5":"Take these from the pick of the flock. Set wood underneath it in a circle to boil the pieces of meat and cook the bones in it.'"
,"6":"Now this is what Yahweh says, 'Woe to the city of blood, to the rusty pot with the rust encrusted on it! Let them empty it, piece by piece but without sparing anyone,"
,"7":"for the blood she shed is in her midst. She poured it on the rock surface, not on the ground where dust would cover it."
,"8":"But I will not cover the blood that was poured on the bare rock. I shall instead kindle my fury and take revenge."
,"9":"That is why the Lord Yahweh speaks thus: Woe to the city of blood!"
,"10":"I will make a great heap of wood! Pile on the wood, light the fire, cook the meat well, adding the spice, and let the bones burn."
,"11":"Leave the empty pot on the coals that it may heat and the bronze grow red-hot to melt the filth inside so its rust will be consumed."
,"12":"But the rust is such that not even the fire removes it."
,"13":"I have tried to cleanse you of the filth of your immorality but since you would not be cleansed, you shall not be cleansed until I have satisfied my fury against you."
,"14":"I, Yahweh, have spoken. This will happen; I will act and not relent; I will show no pity, no compassion. You shall be judged according to your ways and your deeds - word of Yahweh.'"
,"15":"The word of Yahweh came to me in these terms,"
,"16":"'Son of man, I am about to suddenly take from you the delight of your eyes, but you are not to lament or weep or let your tears flow."
,"17":"Groan in silence and do not mourn for the dead; wear your turban, put on your sandals, do not cover your beard or eat the customary food of mourners.'"
,"18":"I spoke to the people in the morning and my wife died that evening. The next morning I did as I had been commanded."
,"19":"Then the people said to me: 'Explain to us the meaning of your actions.'"
,"20":"I said to them, 'The word of Yahweh came to me in these terms:"
,"21":"'Say to Israel: I am about to profane my sanctuary, your pride, the delight of your eyes for which you long. The sons and daughters you left behind will also fall by the sword,"
,"22":"but you will do as I have done: you will not cover your beard or eat the customary food of mourners;"
,"23":"you will keep your turbans on your heads and sandals on your feet. You will not lament or weep. Instead, because of your sin, you will waste away and groan among yourselves."
,"24":"Ezekiel will be a sign for you. Do as he did and when this happens you will know that I am Yahweh.'"
,"25":"Son of man, the day I take their stronghold, the jewel which is the delight of their eyes, for which they and their children long,"
,"26":"on that day a fugitive will come to give you the news."
,"27":"That very day you will open your mouth and be able to speak to him and you will no longer be silent. You will be a sign for them and they will know I am Yahweh.'"
}`)
	CurrentBook.AddChapter(25, `{
"1":"The word of Yahweh came to me in these terms,"
,"2":"'Turn towards the people of the Ammonites and prophesy against them."
,"3":"Say to them on my behalf: This is what Yahweh says: Because you mocked when my sanctuary was profaned, when the land of Israel was laid waste and the Judeans were exiled,"
,"4":"I am giving you over to the people of the East as their possession; they will pitch their camps and settle among you. They will eat your fruit and drink your milk."
,"5":"I will turn Rabbah into a pasture for camels and the towns of the Ammonites into a sheepfold and you will know that I am Yahweh.'"
,"6":"Thus says Yahweh: 'Because you clapped your hands and stamped your feet and danced for joy with an evil heart against the land of Israel,"
,"7":"I will stretch out my hand against you and hand you over as plunder to the nations. I will cut you off from the nations; no longer will you be numbered among them. I will destroy you and you will know I am Yahweh.'"
,"8":"Thus says Yahweh, 'Because Moab said: 'Judah is like all the other nations,'"
,"9":"I will leave Moab unprotected and destroy the towns which are her glory: Beth Jeshimoth, Baal Meon, Kiriathaim."
,"10":"I will give Moab along with the Ammonites as a possession to the people of the East so that the Ammonites will not be remembered among the nations."
,"11":"When I will punish Moab, they will know I am Yahweh.'"
,"12":"Word of Yahweh, 'Because Edom took revenge on Judah and was guilty in so doing, this is what"
,"13":"Yahweh says: I will stretch out my hand against Edom, destroying men and animals. I will make it a ruins from Teman and let them be slain as far as Dedan."
,"14":"I will put Israel in charge of my revenge against Edom. They will deal with Edom according to my wrath and my fury and Edom will experience my revenge' - word of Yahweh."
,"15":"Word of Yahweh, 'Because the Philistines have taken revenge with an evil heart and because of their ceaseless hatred, thus says Yahweh:"
,"16":"I intend to stretch out my hand against the Philistines; I will cut off the Kerethites and destroy the rest of the coast."
,"17":"I will take terrible revenge and punish them in my wrath - then they will know I am Yahweh.'"
}`)
	CurrentBook.AddChapter(26, `{
"1":"On the first day of the month in the eleventh year, the word of Yahweh came to me in these terms,"
,"2":"'Son of man, you see how Tyre has mocked Jerusalem: 'Aha! the land through which the goods of the nations came to me is destroyed; what she received will now be mine, I shall prosper while she lies in ruins.'"
,"3":"Because Tyre said that - word of Yahweh - I am against her! I will bring many people against her. They will rise like the waves of the sea,"
,"4":"they will destroy the ramparts of Tyre and knock down its towers. I will sweep away the dust, making of it a bare rock."
,"5":"She will be in the midst of the sea, a place to hang out nets - I, Yahweh, have spoken."
,"6":"Tyre will be plunder for the nations; her villages on dry land will be laid waste by the sword and they will know that I am Yahweh.'"
,"7":"This is what Yahweh says, 'From the north I will bring Nebuchadnezzar, king of Babylon, against Tyre. He will come with horses, chariots and cavalry, a vast army and throngs of people."
,"8":"He will lay waste with the sword your villages on dry land. He will set up a siege wall against you and throw up a mound and raise a roof of shields against you."
,"9":"He will set a battering ram to hammer your walls and he will demolish your towers with weapons."
,"10":"His numerous horses will cover you with dust. The noise of the cavalry, the wheels of the chariots and wagons will make your walls shake when they enter your gates as one enters a town through a breach in its walls."
,"11":"Horses' hooves will trample your streets; he will slay your people with the sword and your powerful pillars will crumble to the ground."
,"12":"They will plunder your riches and loot your merchandise. They will break down your walls and destroy your pleasant houses. Your stones, timber and soil they will cast into the sea."
,"13":"I will silence your songs and the sound of your lyres will be heard no more."
,"14":"I will make a stark rock of you, a place to dry fishing nets, and you shall never be rebuilt! - I, Yahweh, have spoken."
,"15":"This is a word of Yahweh to Tyre: At the time of your massacre, will not the coastlands quake, when the noise of your fall and the groaning of the victims is heard?"
,"16":"All the princes of the sea will step down from their thrones; they will remove their robes and take off their embroidered garments. They will put on mourning clothes, sit on the ground, tremble with fear and be appalled because of you."
,"17":"They will be amazed on your account and will take up this lament: 'How you have perished, vanished from the sea, city of renown! Formerly you and your citizens were so powerful on the sea! You imposed terror on all "
,"18":"but now the coastlands tremble on the day of your fall. The islands of the sea are terrified at your disappearance.'"
,"19":"Thus says Yahweh: When I make you into a city of ruins like uninhabited towns, when I make the ocean rise against you and the mighty waters cover you,"
,"20":"then I will thrust you down with those who descend to the pit, to the people of long ago. I will throw you into the netherworld, into everlasting loneliness, like those who go down to the pit, that you may not return to the land of the living."
,"21":"Then you will be an object of horror, and even if sought, you will not be found - word of Yahweh.'"
}`)
	CurrentBook.AddChapter(27, `{
"1":"The word of Yahweh came to me in these terms,"
,"2":"'Son of man, intone a lament for Tyre and"
,"3":"say to her, who is gateway to the sea who trades with people on many coasts: This is what Yahweh says: Tyre, you were satisfied with your perfect beauty. "
,"4":"Your borders were in the heart of the sea and your builders perfected your beauty;"
,"5":"all your planks were made of the wood of fir trees, your masts from the cedars of Lebanon and"
,"6":"your oars from the oak of Bashan. Your decks were of cedar from the coast of Cyprus inlaid with ivory."
,"7":"Embroidered linen from Egypt was used for your sails which served as your ensign. Your awning was made of blue and purple from the coasts of Elishah."
,"8":"Your oarsmen were citizens of Sidon and Arvad. The most skilled men from Zemer served you as pilots,"
,"9":"veteran craftsmen from Gebal were on board to seal your seams. All the ships of the seas with their crews called on you to barter for your wares."
,"10":"Persia, Lud and Put served in your army as men of war. They brought you splendor and hung their bucklers and helmets on your walls."
,"11":"The men of Arvad and Helech watched all around your walls; men of Gamad guarded your towers and hung their shields on your walls completing your magnificence."
,"12":"Tarshish traded with you because of your abundant wealth, supplying your markets with silver, iron, tin and lead."
,"13":"Javan, Tubal and Mishech trafficked with you, providing you with slaves and articles in bronze."
,"14":"People of Togarmah exchanged work horses, war horses and mules for your wares."
,"15":"The men of Rhodes traded with you and many coastlands were your customers; in payment they gave ivory tusks and ebony wood."
,"16":"Edom trafficked with you because of your many products and provided your markets with turquoise, purple fabric, embroidered cloth, fine linen, coral and rubies."
,"17":"Judah and Israel sold you wheat from Minnith, millet, honey, oil and resin."
,"18":"Damascus traded with you because of your abundant wares and provided you with wine from Helbon and white wool."
,"19":"Danites and Greeks from Uzal exchanged wrought iron, cassia and calamus for your merchandise."
,"20":"Dedan supplied you with saddle blankets."
,"21":"Arabia and all the princes of Kedar carried on a lively trade with you in lambs, rams and goats."
,"22":"Merchants from Sheba and Raamah provided your markets with all kinds of high grade spices, precious stones and gold."
,"23":"Haran, Canneh, Eden, Asshur and Chilmad"
,"24":"traded with you in beautiful garments, blue fabric, embroidered cloth, colored rugs with twisted and tightly-knotted cords."
,"25":"The ships of Tarshish carried your merchandise. You lay filled and heavy,in the midst of the ocean."
,"26":"Your mariners led you to the high sea and the east wind wrecked you in the sea."
,"27":"Your riches, wares, merchandise, your seamen and sailors, those who repaired your seams, and assured your trade, your men of war with all the passengers sank into the depths of the sea,on the day of your shipwreck."
,"28":"At the cries of your seamen the coasts quaked"
,"29":"and the oarsmen came from their ships; sailors and seamen went ashore."
,"30":"They mourn and weep bitterly for you, throw dust on their heads and roll in ashes."
,"31":"Because of you they shave their heads and wear sackcloth. In the bitterness of their hearts they weep and intone a bitter lament for you."
,"32":"A funeral song is heard: Who was like Tyre, now silent,in the midst of the ocean?"
,"33":"How many nations you provided,with the goods unloaded from distant shores!,With your abundant riches and commerce you enriched the kings of the earth,"
,"34":"but now you are shattered by the sea, engulfed in its depths. Your wares and all your company have gone down!"
,"35":"All who live on the coasts are appalled because of you, their kings shudder, and fall prostrate."
,"36":"The merchants of the nations hiss at you, you are an object of dread. You have gone forever.'"
}`)
	CurrentBook.AddChapter(28, `{
"1":"The word of Yahweh came to me in these terms,"
,"2":"'Son of man, say to the prince of Tyre: You are very proud and self-satisfied: 'I am a god, I sit like a god in the heart of the sea. Yet you are man and not a god; would you hold yourself as wise as God?"
,"3":"You consider yourself wiser than Daniel; no secret is hidden from you."
,"4":"Your wisdom and know-how have earned you a fortune, gold and silver flowed to your treasury."
,"5":"Clever in trade, you became wealthy,and as your fortune increased, your heart became prouder."
,"6":"But now Yahweh has spoken to you, to the one who is like God:"
,"7":"I am bringing foreigners against you, the most feared of all the nations. Their sword will challenge your wisdom and debase your refined culture."
,"8":"They will bring you down to the pit,and you will die in the depths of the sea."
,"9":"Will you be able to say 'I am a god',when your murderers are killing you?,You are a man and not a god."
,"10":"You will die the death of the uncircumcised and perish at the hands of aliens, for I have spoken - word of Yahweh.'"
,"11":"The word of Yahweh came to me in these terms,"
,"12":"'Son of man, intone a lamentation for the king of Tyre and say to him: This is what Yahweh says: You were the model of perfection, full of wisdom and perfect in beauty."
,"13":"You lived in Eden, the garden of God, and every kind of precious stone adorned you, ruby, topaz, emerald, chrysolite, onyx and jasper, sapphire, turquoise and emerald. The trinkets on your robe were made of gold, prepared for you on the day you were created."
,"14":"I anointed you a guardian angel,on the holy mountain of God,where you walked amidst the spirits of God."
,"15":"You were perfect in your ways,from the day you were created,until wickedness was found in you."
,"16":"Because of your extensive trade,you were filled with violence and sinned; I then deprived you of your dignity, driving you away from the mountain of God, expelling you from among the guardian angels;"
,"17":"your heart was proud because of your beauty. As your splendor corrupted your wisdom I have cast you down to the ground,and exposed you before kings, a spectacle in their sight."
,"18":"Your many sins and dishonest trade,have filled and defiled your sanctuaries. Then I made fire break out in you,and reduced you to ashes on the ground in the sight of all who looked on."
,"19":"The nations who knew you are appalled. You have become an object of terror; you have gone forever.'"
,"20":"The word of Yahweh came to me in these terms,"
,"21":"'Look towards Sidon and prophesy against her. You will say:"
,"22":"Thus says Yahweh: I come against you, Sidon, and I will be glorified in you. When I inflict punishment on her and make known my holiness, they will know I am Yahweh."
,"23":"I will send pestilence against her and shed blood in her streets. The sword is directed against her from all sides and they will know I am Yahweh when the victims fall."
,"24":"No longer will there be for the people of Israel thorns that wound or briers that prick them among their neighbors. Then they will know that I am Yahweh."
,"25":"Thus says Yahweh: When I gather Israel from among the nations where she has been dispersed, I will use them to show the nations my holiness and they will live in the land I gave to my servant Jacob."
,"26":"They will live safely, build houses and plant vineyards. They will live in safety when I punish all those neighbors who treated them with contempt and they will know that I am Yahweh, their God.'"
}`)
	CurrentBook.AddChapter(29, `{
"1":"On the tenth day of the twelfth month of the tenth year the word of Yahweh came to me in these terms,"
,"2":"'Son of man, look towards Pharaoh, king of Egypt, and prophesy against all Egypt."
,"3":"Say: This is the word of Yahweh: I am against you, Pharaoh, king of Egypt! Huge monster wallowing in the midst of your streams saying: 'The Nile and its canals are mine; I made them.'"
,"4":"I will put hooks in your jaws and make the fish of your rivers cling to your scales. I will drag you from your rivers with all the fish clinging to your scales."
,"5":"I will throw you and the fish of the rivers into the desert. You will fall on the ground with no one to lift you up or bury you. I will give you as food to the wild beasts and to the birds of the air, and"
,"6":"all who live in Egypt will know I am Yahweh. You have been but a staff of reed for Israel. "
,"7":"When they took hold of you, you broke in their hands; you tore open all their shoulder; when they leaned on you, you wrenched their backs."
,"8":"That is why thus says Yahweh: I am bringing the sword against you and I will destroy both men and animals."
,"9":"Egypt will be a wasteland and a ruins, and the Egyptians will know that I am Yahweh when Egypt is made a ruins and a wasteland. You said: 'The Nile is mine, I made it.' "
,"10":"Because of that I am coming against you in the midst of your streams. I will reduce Egypt to a lonely ruins from Migdal to Aswan and to the border of Cush."
,"11":"Neither foot of man nor hoof of animal will tread its paths. Egypt will be uninhabited for forty years;"
,"12":"I will make it one of the wastelands and for forty years its cities will be numbered among cities in ruins. I will scatter the Egyptians among the nations and disperse them in other lands."
,"13":"Thus says Yahweh: After forty years I will gather the Egyptians from among the nations where they were dispersed;"
,"14":"I will bring back Egyptian captives to Pathros, the land of their birth. There they will form a small kingdom,"
,"15":"weaker than other kingdoms, no longer strong enough to dominate other nations."
,"16":"I will decrease their number, so that they may no longer conquer other lands. No longer will Israel be tempted to trust in Egypt, nor will they sin by turning to Egypt for help. Then they will know that I am Yahweh.'"
,"17":"It happened on the first day of the first month of the twenty-seventh year that the word of Yahweh came to me in these terms:"
,"18":"'Son of man, Nebuchadnezzar, king of Babylon has mobilized his army for an expedition against Tyre. All are worn out, bald-headed, their shoulders raw, but neither he nor his people have received any reward for this campaign against Tyre."
,"19":"That is why thus says Yahweh: I intend to give Egypt to Nebuchadnezzar, king of Babylon. He will carry off its riches, plunder it and let his army have the loot in place of wages."
,"20":"Because these people have worked for me, I will give Egypt to them as a reward - word of Yahweh."
,"21":"On that day I will lift up the nation of Israel, and as for you, I will let you speak among them again and they will know that I am Yahweh.'"
}`)
	CurrentBook.AddChapter(30, `{
"1":"The word of Yahweh came to me in these terms,"
,"2":"'Son of man, prophesy and say: This is the word of Yahweh: Moan! Ah!"
,"3":"the day is near; the day of Yahweh is coming! It will be a day of clouds, a time of doom for the nations."
,"4":"The sword is brought to strike Egypt and anguish will come to Cush. The slain will fall throughout Egypt; people will carry off its riches and its foundations will be torn away."
,"5":"Cush, Put and Lydia, all Arabia, Libya and all the people of the covenant will fall by the sword."
,"6":"This is the word of Yahweh: 'Those who support Egypt will fall; her haughty power will crumble! From Migdal to Aswan, people will be slain, word of Yahweh."
,"7":"They will be numbered among desolate lands, and her cities among ruined cities."
,"8":"They will know I am Yahweh when I set fire to Egypt and when all her allies are crushed."
,"9":"On that day my messengers will leave in ships to shake the people of Cush out of their complacency and they will be in anguish on the day of the fall of Egypt; for that day is coming."
,"10":"Thus says Yahweh: I will put an end to the hordes of Egypt by means of Nebuchadnezzar, king of Babylon and"
,"11":"his people with him, the most feared among the nations. For I will lead them here to destroy the land. They will draw their swords against Egypt and fill the land with victims. "
,"12":"I will dry up Egypt's canals and hand over the country to the wicked. I will use the hand of the foreigner to make the land and all it contains a waste. I, Yahweh, have spoken."
,"13":"This is the word of Yahweh: I will destroy the idols and wipe out the false gods in Memphis. No longer will there be a prince in the land of Egypt and I will put fear in the land."
,"14":"I will make a wasteland of Pathros, set fire to Zoan and inflict punishment on Thebes."
,"15":"I will pour out my fury on Pelusium, the fortress of Egypt, and destroy the throngs of Thebes."
,"16":"I will set fire to Egypt; Pelusium will writhe in agony. They will enter Thebes through a breach and take her by storm."
,"17":"The young men of Heliopolis and Bubastis will fall by the sword and the women will be taken captive."
,"18":"What a dark day it will be in Tahpanhes when I break the leadership of Egypt and destroy her arrogant might! As for this city a cloud will cover it and her daughters will be taken captive."
,"19":"I will inflict punishment on Egypt and they will know that I am Yahweh.'"
,"20":"On the seventh day of the first month of the eleventh year, the word of Yahweh came to me,"
,"21":"'Son of man, I have broken the arm of Pharaoh, king of Egypt. No one has treated it for healing or bandaged it to enable him to hold a sword."
,"22":"That is why thus says Yahweh: See, I am against Pharaoh, king of Egypt. I will break his arms, both the one that is strong and the wounded one as well."
,"23":"I will scatter the Egyptians among the nations and disperse them in other lands."
,"24":"I will strengthen the arm of the king of Babylon and put my sword in his hand; but as for Pharaoh, I will break his arms, making him moan like a mortally wounded man."
,"25":"Yes, I will strengthen the arm of the king of Babylon but make Pharaoh's arm limp. They will know I am Yahweh when I place my sword in the hand of the king of Babylon."
,"26":"I will scatter the Egyptians among the nations and disperse them in other lands and they will know that I am Yahweh.'"
}`)
	CurrentBook.AddChapter(31, `{
"1":"On the first of the third month of the eleventh year, the word of Yahweh came to me,"
,"2":"'Son of man, say to Pharaoh, king of Egypt and to his multitude: Who is comparable to you in your greatness?"
,"3":"You are like a very tall cedar in Lebanon, with beautiful branches providing forest shade, with its top among the clouds."
,"4":"It grew. The waters made it grow, and the streams ascending from the deep springs that watered all the trees of the land through the canals, flowed straight to its place."
,"5":"Higher than all the other trees, its boughs increased and its branches grew larger because of the plentiful water."
,"6":"The birds of the air nested in its boughs and all the animals brought forth their young under its branches. Numerous nations lived in its shade."
,"7":"It became majestic in height and in the thickness of its branches for its roots were turned towards plentiful water."
,"8":"The other cedars in the garden of God could not equal it. The pine trees could not equal its boughs nor could the plane trees rival its branches. No other tree in God's garden was comparable to it in beauty."
,"9":"I made it beautiful in the abundance of its branches, the envy of the trees in the garden of God in Eden."
,"10":"That is why thus says Yahweh: Because it grew tall and reached the clouds and became proud,"
,"11":"I will hand it over to the ruler of the nations who will treat it according to its wickedness. I have rejected it."
,"12":"Foreigners, the most terrible among the nations, have felled it, cut it down on the mountains: its boughs have fallen in all the valleys, its branches lie broken in ravines. All the nations have fled from its shade and abandoned it."
,"13":"The birds of the air alight on its broken boughs and the animals are found among its fallen branches."
,"14":"This is to prevent well-watered trees from attaining such a height and reaching the clouds. For all are destined to die and go below among those who descend to the pit."
,"15":"Thus says Yahweh: The day the cedar descended to the netherworld I made the depths mourn for it. I restrained its rivers and held back the abundant waters. Darkness covered Lebanon and all the trees of the field were faint."
,"16":"The nations were shaken at the noise of its fall when I made it depart to the lower regions with those who go down to the pit. Then all the trees from Eden, the finest trees of Lebanon, all that were well-watered were comforted in the earth below."
,"17":"Those from among the nations who lived in its shade, they too went down together to those slain by the sword."
,"18":"O tree, splendid and glorious, who among the trees of Eden was comparable to you? But you were made to go down to the lower regions like the other trees of Eden. You lay among the uncircumcised people, victims of the sword, you, Pharaoh and all your multitudes, word of Yahweh.'"
}`)
	CurrentBook.AddChapter(32, `{
"1":"On the first of the twelfth month in the twelfth year, the word of Yahweh came to me in these terms,"
,"2":"'Intone a lamentation for Pharaoh, king of Egypt. You will say: Lion of the nations, you are lost! You were like a monster of the sea, thrashing the water in the rivers, stirring and muddying the water with your feet."
,"3":"This is what Yahweh says: I will spread my nets over you, and an assembly of many nations will haul you up into my net."
,"4":"I will throw you on the ground, hurl you into the open field and let the birds of the air settle on you and the beasts of the earth feed on you."
,"5":"I will scatter your flesh on the mountains, fill the valleys with your remains and"
,"6":"drench the earth with your liquids. When I blot you out,"
,"7":"the skies will darken and the stars become dim; I will veil the sun with a cloud and the moon shall not give its light."
,"8":"Because of you I will darken all the lights in the sky and cover the earth in darkness, word of Yahweh."
,"9":"Many nations will grieve when I spread the news of your fall, even people you do not know;"
,"10":"their kings will shudder because of you when I wave my sword before them. All of them will tremble for their life, on the day of your fall."
,"11":"For thus says Yahweh: The sword of the king of Babylon is coming against you."
,"12":"The sword of the warriors, the most terrible among the nations will destroy your numerous people. They will shatter the pride of Egypt and your multitudes will be exterminated."
,"13":"I will destroy all your cattle along the shores of the great river, no longer to be trod by man or beast."
,"14":"And then I will calm their rivers, and their streams will flow like oil, word of Yahweh."
,"15":"When I make a wasteland of Egypt and destroy its inhabitants, striking all those who live there, they will know that I am Yahweh."
,"16":"This is the dirge which the cities of the nations will chant for Egypt and its multitudes - word of Yahweh.'"
,"17":"On the fifteenth day of the month, in the eleventh year, the word of Yahweh came to me in these terms,"
,"18":"'Son of man, wail for the multitudes of Egypt and make them descend to the netherworld."
,"19":"For I will send them to the land of shadows with those who go down to the pit."
,"20":"There they will meet all the victims of the sword. Egypt has been taken; she has been dragged away with her multitudes."
,"21":"The mighty heroes in the netherworld together with Pharaoh's allies, will say to her: 'Why should you be more favored than others? Come down and make your bed with the uncircumcised, with those fallen by the sword.'"
,"22":"Assyria is there with her entire army; she is surrounded by the tombs of her victims fallen by the sword."
,"23":"Their graves are at the bottom of the pit and her army lies around her tomb; all those who spread terror in the land of the living have been killed by the sword."
,"24":"Elam is there with all her multitude around her tomb, all of them slain, fallen by the sword. They are the uncircumcised, who have gone down to the lower regions, those who spread terror in the land of the living; they bear their shame with those who go down to the pit."
,"26":"Meschech and Tubal are there with the tombs of their multitude around them. All these uncircumcised are there pierced by the sword, for they spread terror in the land of the living."
,"27":"They are not lying with the heroes of former times who went to the grave with all their gear of war; the heroes whose terror filled the land of the living, lie with their swords placed under their heads their shields over their bones."
,"28":"You instead will be among the uncircumcised victims of the sword."
,"29":"Edom is there with her kings and princes who despite their bravery lie with those fallen by the sword. They are placed with the uncircumcised and with those who go down to the pit."
,"30":"All the princes of the north are there and all the Sidonians who have gone down in disgrace with the slain, despite the terror caused by their power. They are shamed and lie with the uncircumcised, victims of the sword. They bear their shame with those who go down to the pit."
,"31":"When Pharaoh and all his army see them, he will be comforted because of all his multitudes killed by the sword, word of Yahweh."
,"32":"Although I had him spread terror in the land of the living, Pharaoh will be laid among the uncircumcised victims of the sword, he and his multitudes, word of Yahweh.'"
}`)
	CurrentBook.AddChapter(33, `{
"1":"The word of Yahweh came to me in these terms,"
,"2":"'Son of man, speak to your people and say to them: Imagine that I bring the sword against a country, and the people of that country choose one among them to be their sentry."
,"3":"When this man sees the sword approach the land, he shall sound the trumpet to warn the people;"
,"4":"then if anyone hears the trumpet and does not heed the warning he shall be responsible for his own death,"
,"5":"but the man who gave the warning will save his life."
,"6":"On the other hand when the sentry sees the sword coming and does not blow the trumpet, the people are not warned and some are killed. In that case I will hold the sentry responsible and he will answer for the victims' death."
,"7":"For your part, son of man, I have set you as a watchman for Israel, and when you hear my word, you must give them my warning."
,"8":"When I say to the wicked: 'Wicked man, you shall die for sure,' if you do not warn the wicked man to turn from his ways, he will die because of his sin, but I will also call you to account for his blood."
,"9":"If you warn the wicked man to turn from his ways and he does not do so, he will die for his sin, but you yourself will be saved."
,"10":"Son of man, you know the people of Israel say: 'We are wasting away because of our sin, and our wrongdoing is weighing us down. How can we live?'"
,"11":"Say to them: As I live, word of Yahweh, I do not want the wicked to die but rather that they turn from their ways and live. Turn! turn from your wicked ways! Why, O Israel, should you die?"
,"12":"You, son of man, say to your people: The righteous life of the upright will not save him on the day he turns to sin and the wicked man will not be bound to his wickedness on the day he turns from his evil ways; likewise for the upright: he will die."
,"13":"When I have said to the righteous: 'You will live,' if he takes advantage of his righteousness to do evil, his former upright life will not be remembered; the evil he is doing will make him die."
,"14":"And if I say to the wicked man, 'You will certainly die,' but he then turns from his sin and does what is just and right,"
,"15":"gives back what he took as a pledge on a loan, restores what he has stolen, obeys the decrees that are life-giving and avoids evil, he will live, he will not die."
,"16":"His life in sin will no longer be held against him. He has done what is just and right and because of that he will live."
,"17":"Yet your people say, 'The position of the Lord is not just.' On the contrary it is theirs that is wrong."
,"18":"The upright man who turns from what is just and right and does evil, shall die;"
,"19":"and the wicked man who turns from evil to do what is just and right shall live!"
,"20":"Though you say: 'The Lord's position is wrong,' I will judge you, Israel, each one according to his ways.'"
,"21":"On the fifth day of the tenth month in the eleventh year of our exile, a fugitive arrived from Jerusalem to tell me: 'The city has fallen.'"
,"22":"Now the hand of Yahweh had been on me the evening before the arrival of the fugitive. When I met him in the morning, Yahweh opened my mouth. My tongue was loosened and no longer was I silent."
,"23":"The word of Yahweh then came to me in these terms,"
,"24":"'Son of man, those who remain among the ruins in the land of Israel reckon: 'Abraham was alone when he received the land as a possession; we are still numerous enough and it is to us that the country has been given.'"
,"25":"But you will say to them: thus says Yahweh: You eat food with blood, you look towards idols, you shed blood, and you want to possess the land!"
,"26":"You lean on your sword, you do what is detestable, each one dishonors his neighbor's wife and yet you want to possess the land!"
,"27":"Say to them: This is the word of Yahweh: As I live, those who settled among the ruins will fall by the sword; those in the open country I will give as food to the beasts and those in strongholds and caves shall die of the plague."
,"28":"I will make the country a wasteland, a lonely place. They will no longer lean on their power and the mountains of Israel shall be deserted with no one crossing them."
,"29":"Then they will know that I am Yahweh when I make their country a lonely waste because of all the detestable things they have done."
,"30":"Son of man, your people talk about you along the walls and at the doors of the houses, each one with his neighbor: 'Come and hear the latest word of Yahweh.'"
,"31":"They go to you as they go to an assembly and sit in front of you. They listen to your words but do not do what you say. Instead they continue to lie and look only for their own interest."
,"32":"For them you are no more than a singer of lovesongs - a beautiful voice accompanied by beautiful music. They listen but do not practice what they hear."
,"33":"But when what is foretold comes true - and it is about to happen - they will know that there was a prophet among them.'"
}`)
	CurrentBook.AddChapter(34, `{
"1":"The word of Yahweh came to me in these terms,"
,"2":"'Son of man, speak on my behalf against the shepherds of Israel! Say to the shepherds on my behalf: Woe to the shepherds of Israel who feed themselves! Should not the shepherds feed the flock?"
,"3":"But you feed on milk and are clothed in wool, and you slaughter the fattest sheep. You have not taken care of the flock,"
,"4":"you have not strengthened the weak, cared for the sick or bandaged the injured. You have not gone after the sheep that strayed or searched for the one that was lost. Instead you ruled them harshly and were their oppressors."
,"5":"They have scattered for want of a shepherd and became prey of wild animals."
,"6":"My sheep wander over the mountains and high hills; and when they are scattered throughout the land, no one bothers about them or looks for them."
,"7":"Hear then shepherds, what Yahweh says:"
,"8":"As I live - word of Yahweh, - because my sheep have been the prey of wild animals and become their food for want of shepherds, because the shepherds have not cared for my sheep, because you shepherds have not bothered about them but fed yourselves and not the flocks, because of that,"
,"9":"hear the word of Yahweh."
,"10":"This is what Yahweh says: I will ask an account of the shepherds and reclaim my sheep from them. No longer shall they tend my flock; nor shall there be shepherds who feed themselves. I shall save the flock from their mouths and no longer shall it be food for them."
,"11":"Indeed Yahweh says this: I myself will care for my sheep and watch over them."
,"12":"As the shepherd looks after his flock when he finds them scattered, so will I watch over my sheep and gather them from all the places where they were scattered in a time of cloud and fog."
,"13":"I will bring them out from the nations and gather them from other countries. I will lead them to their own land and pasture them on the mountains of Israel in all the valleys and inhabited regions of the land."
,"14":"I will take them to good pastures on the high mountains of Israel. They will rest where the grazing is good and feed in lush pastures on the heights of Israel."
,"15":"I myself will tend my sheep and let them rest, word of Yahweh."
,"16":"I will search for the lost and lead back the strays. I will bind up the injured and strengthen the weak, but the fat and strong will be eliminated. I will shepherd my flock with justice."
,"17":"As for you, my flock - says Yahweh - I will distinguish between one sheep and another, and set apart rams and goats."
,"18":"Was it not enough for you to feed on good pasture? Why did you trample under your feet the rest of the pasture? Were you not satisfied with drinking clear water? Why did you muddy the rest with your feet?"
,"19":"Must my sheep feed on what you have trampled and drink what you have muddied with your feet?"
,"20":"That is why thus says the Lord Yahweh to the shepherds: Here I am. I myself will judge between the fat sheep and the lean."
,"21":"Because with flank, shoulder and horns you butt the weak sheep until you have driven them away,"
,"22":"I will rescue my flock and no longer will they be plundered. I will judge between one sheep and another."
,"23":"Over them I will put one shepherd, my servant David who will tend them, pasture them and be a true shepherd for them."
,"24":"I, Yahweh, will be their God and my servant David a ruler among them. I, Yahweh, have this to say:"
,"25":"I will make a covenant of peace with them and rid the land of wild beasts, so that they may live safely in the desert and sleep in forests."
,"26":"I will settle them on my holy mountain, sending them rain in season, showers of rich blessings."
,"27":"The trees of the field will give their fruit and the soil its produce, while they are safe in their land, and they will know that I am Yahweh. I will break the bars of their yoke and free them from the power of those who enslave them. "
,"28":"No longer will they be plundered by the nations or ravaged by wild beasts. They will live in security without anyone causing them to fear."
,"29":"I will give them splendid crops; people will not die of hunger and no longer will you be scorned by other nations."
,"30":"This people will know that I, Yahweh, am their God and that I am with them and that they, Israel, are my people - word of Yahweh."
,"31":"You are my sheep, the flock of my pasture, and I am your God, declares Yahweh.'"
}`)
	CurrentBook.AddChapter(35, `{
"1":"The word of Yahweh came to me,"
,"2":"'Son of man, set your face against the mountain of Seir, prophesy against it"
,"3":"and say: Thus says Yahweh: I come to strike you, mountain of Seir! I have stretched out my hand against you and I will make of you a mournful solitude."
,"4":"I will reduce your towns to ruins, make you a desolation and you shall know that I am Yahweh."
,"5":"I know your long-standing enmity and how you handed over the people of Israel to the sword in the day of their disaster, when their sins reached an end."
,"6":"Because of that, as I live, word of Yahweh, I intend to give you over to bloodshed, and bloodshed will pursue you."
,"7":"I will make of the mountain of Seir a mournful solitude and destroy all who come and go there."
,"8":"The mountains will be filled with the slain; the victims of the sword will fall on your hills, in your valleys and ravines."
,"9":"I will reduce you to a desolate ruins forever; no longer will your towns be inhabited and then you will know that I am Yahweh."
,"10":"You said: 'These two nations and these two countries will be mine, we shall take possession of them,' and you disregarded Yahweh who was there."
,"11":"Because of that, as I live, declares Yahweh, I will deal with you according to your hatred towards them and I will make myself known among them when I judge you."
,"12":"Then you will know that I, Yahweh, have heard all the insults uttered against the mountains of Israel, such as: 'They are devastated and have been given over to us to be devoured.'"
,"13":"For I heard when you boasted against me without restraint."
,"14":"Thus says Yahweh: When all the earth rejoices, you will be desolate."
,"15":"Since you rejoiced when the inheritance of Israel became a deserted ruins, that is how I will deal with you. You will become a desert, Mount Seir, and Edom likewise, and people will know that I am Yahweh.'"
}`)
	CurrentBook.AddChapter(36, `{
"1":"'Son of man, prophesy regarding the mountains of Israel; say to them: Mountains of Israel, hear the word of Yahweh:"
,"2":"Your enemies have said: 'Aha! these eternal heights have become our possession.'"
,"3":"People have envied you and ravaged you on all sides; other nations have taken possession of you, so that you became the subject of talk and gossip. Because of that,"
,"4":"mountains of Israel, hear this word of Yahweh. Yahweh says to the mountains, the hills, the ravines and the valleys, to the deserted ruins and the empty towns which have become the plunder and target of mockery for other nations around:"
,"5":"Truly in the fire of my jealousy I will speak against the other nations, namely all of Edom, who with glee and malice in their hearts, have taken possession of my land and plundered its pastures."
,"6":"Now you shall prophesy concerning Israel. You shall say to the mountains, the hills, the ravines and the valleys: This is the word of Yahweh who speaks in the fury of his jealousy! Because you have suffered the scorn of the nations,"
,"7":"Yahweh says: I swear with uplifted hand, the nations surrounding you will suffer scorn."
,"8":"But you, mountains of Israel, you shall bring forth branches and produce fruit for my people Israel, for soon they will return."
,"9":"Indeed, I have turned in your direction and I have bent towards you; you will be cultivated and sown with seed."
,"10":"I will increase your population in all Israel; the towns will be inhabited and the ruins rebuilt."
,"11":"Both people and animals will increase; they will be fruitful and multiply. I will build up their numbers as in the past and they will know that I am Yahweh."
,"12":"Men and women of Israel will walk on you again. They will take possession of you; you will be their heritage again, and never again will you let their children perish.'"
,"13":"Yahweh speaks, 'People say that you devour men and that you rob your people of children."
,"14":"But never again shall you devour men or rob your people of children - word of Yahweh."
,"15":"You shall no longer hear the mockery of the nations or suffer the insults of other lands - word of Yahweh.'"
,"16":"The word of Yahweh came to me in these terms,"
,"17":"'Son of man, when Israel occupied her own land she defiled it by her way of life and her actions. To me her conduct was like the uncleanness of a woman in her period."
,"18":"I poured out my fury on them because of the blood they shed in the land and because they defiled it with their filthy idols."
,"19":"Then I scattered them among the nations and dispersed them in other lands. I judged them according to their conduct and their actions."
,"20":"But when they were brought to other nations, my holy Name was profaned because others said of them: 'The people of Yahweh had to be exiled from his land!'"
,"21":"Then I was concerned for my holy Name, profaned by Israel among the nations where she had been dispersed. Now you shall say to the people of Israel:"
,"22":"It is not for your sake that I am about to act, but because of my holy Name that you have profaned in the places where you have gone."
,"23":"I will make known the holiness of my great Name, profaned among the nations because of you, and they will know that I am Yahweh when I show them my holiness among you."
,"24":"For I will gather you from all the nations and bring you back to your own land."
,"25":"Then I shall pour pure water over you and you shall be made clean - cleansed from the defilement of all your idols."
,"26":"I shall give you a new heart and put a new spirit within you. I shall remove your heart of stone and give you a heart of flesh."
,"27":"I shall put my spirit within you and move you to follow my decrees and keep my laws."
,"28":"You will live in the land I gave your forefathers; you shall be my people and I will be your God."
,"29":"I will free you from all your uncleanness. I shall summon the wheat and make it plentiful and so keep famine away from you."
,"30":"I shall see that the fruits of the earth and the produce of the fields are plentiful and that you no longer suffer the disgrace of famine among the nations."
,"31":"Then you will remember your evil ways and wicked actions and loathe yourselves for the sins you committed and for your detestable practices."
,"32":"I want you to know that it is not for your sake I am doing this, word of Yahweh. Be ashamed and humbled because of your conduct, Israel!"
,"33":"This is what Yahweh says: The day I cleanse you from all your sins, I shall repopulate the cities and the ruins will be rebuilt."
,"34":"The devastated land will be cultivated wherever passersby saw it desolate."
,"35":"Everyone will say, 'This devastated land is now a garden of Eden and its cities once in ruins and leveled to the ground have been rebuilt and populated.'"
,"36":"And the nations that remain around you will know that I, Yahweh, have rebuilt the ruined city and replanted what was desolate. I, Yahweh, have spoken and I will do it."
,"37":"Thus says Yahweh: Once again I shall listen to the plea of Israel and favor them. I shall make their people as numerous as sheep,"
,"38":"as numerous as the flock they bring to Jerusalem's Temple at the time of her holy days. In the same way the ruined cities will be filled with flocks of people and they will know that I am Yahweh.'"
}`)
	CurrentBook.AddChapter(37, `{
"1":"The hand of Yahweh was upon me. He brought me out and led me in spirit to the middle of the valley which was full of bones."
,"2":"He made me walk to and fro among them and I could see there was a great number of them on the ground all along the valley and that they were very dry."
,"3":"Yahweh said to me, 'Son of man, can these bones live again?' I said, 'Lord Yahweh, only you know that.'"
,"4":"He then said, 'Speak on my behalf concerning these bones; say to them: Dry bones, hear the word of Yahweh! "
,"5":"Yahweh says: I am going to put spirit in you and make you live."
,"6":"I shall put sinews on you and make flesh grow on you; I shall cover you with skin and give you my spirit, that you may live. And you will know that I am Yahweh.'"
,"7":"I prophesied as I had been commanded and then there was a noise and commotion; the bones joined together."
,"8":"I looked and saw that they had sinews, that flesh was growing on them and that he was covering them with skin. But there was no spirit in them."
,"9":"So Yahweh said to me, 'Speak on my behalf and call on the Spirit, son of man! Say to the Spirit: This is the word of Yahweh: Spirit, come from the four winds. Breathe into these dead bones and let them live!'"
,"10":"I prophesied as he had commanded me and breath entered them; they came alive, standing on their feet - a great, immense army!"
,"11":"He then said to me, 'Son of man, these bones are all Israel. They keep saying: 'Our bones are dry, hope has gone, it is the end of us.'"
,"12":"So prophesy! Say to them: This is what Yahweh says: I am going to open your tombs, I shall bring you out of your tombs, my people, and lead you back to the land of Israel."
,"13":"You will know that I am Yahweh, O my people! when I open your graves and bring you out of your graves,"
,"14":"when I put my spirit in you and you live. I shall settle you in your land and you will know that I, Yahweh, have done what I said I would do.'"
,"15":"The word of Yahweh came to me in these terms, 'Son of man, take a piece of wood and write on it: 'Judah and the Israelites loyal to him.'"
,"16":"Take another piece of wood and write: 'Joseph, the branch of Ephraim and the Israelites loyal to him.'"
,"17":"Join one to the other to make a single piece of wood in your hand."
,"18":"When your people say to you, 'Won't you tell us what this means?'"
,"19":"say to them: Yahweh says this: I am going to take the branch of Joseph which is in the hand of Ephraim and the tribes of Israel loyal to him and put Judah's branch with them, and they will be as one in my hand."
,"20":"And you will hold in your hand in their sight the pieces of wood on which you wrote."
,"21":"You will then say to them: Thus says Yahweh: I am about to withdraw the Israelites from where they were among the nations. I shall gather them from all around and bring them back to their land."
,"22":"I shall make them into one people on the mountains of Israel and one king is to be king of them all. They will no longer form two nations or be two separate kingdoms,"
,"23":"nor will they defile themselves again with their idols, their detestable practices and their sins. I shall free them from the guilt of their treachery; I shall cleanse them and they will be for me a people and I shall be God for them."
,"24":"My servant David will reign over them, one shepherd for all. They will live according to my laws and follow and practice my decrees."
,"25":"They will settle in the land I gave to my servant Jacob where their forefathers lived. There they will live forever, their children and their children's children. David my servant will be their prince forever."
,"26":"I shall establish a covenant of peace with them, an everlasting covenant. I shall settle them and they will increase and I shall put my sanctuary in their midst forever."
,"27":"I shall make my home at their side; I shall be their God and they will be my people."
,"28":"Then the nations will know that I am Yahweh who makes Israel holy, having my sanctuary among them forever.'"
}`)
	CurrentBook.AddChapter(38, `{
"1":"The word of Yahweh came to me in these terms,"
,"2":"'Son of man, turn towards Gog of the country of Magog, the chief prince of Meshech and Tubal and prophesy against him."
,"3":"Say to him: Hear the word of Yahweh: I come to strike you, Gog, chief prince of Meshech and Tubal."
,"4":"I will turn you round, fix hooks in your jaws and bring you out, you and your entire army, horses and riders all perfectly equipped, a great army, all with shields and bucklers and brandishing swords."
,"5":"Persia, Cush and Put are with them, all with buckler and helmet."
,"6":"Gomer and all his troops, and Bethtogarmah from the far north with his battalions, a vast throng, are with you."
,"7":"Get ready, be prepared, you and all your troops massed around you, and take command of them."
,"8":"After many days you will be given a mission. In the years ahead you will invade a land recovered from war where the people are gathered from among many nations on the mountains of Israel which had for long been barren. Its people were brought from among the nations and now live in safety, all of them."
,"9":"Then you will go up like a storm, like a cloud covering the earth, you and all your troops and the many nations with you."
,"10":"Thus says Yahweh: On that day thoughts will come to your mind and you will plan an evil scheme"
,"11":"saying: 'I will go up against unprotected towns, against peaceful people living in safety, all of them living without walls, bars or gates."
,"12":"I will plunder and loot; I will attack the land that is inhabited again. I will go against this people gathered from among the nations, who live by trading and are increasing their cattle at the center of the world.'"
,"13":"People of Sheba and Dedan and all the merchants of Tarshish and its villages will ask you: 'Have you come to plunder? Is it to loot that you have assembled such an army?' And they will come with silver and gold, to take away the livestock and to buy your enormous booty."
,"14":"Therefore prophesy, son of man and say to Gog on my behalf: On that day when my people Israel are living in security you will come from the far north,"
,"15":"you and the throngs with you, all on horses, with many troops - a vast army."
,"16":"You will come against my people Israel like a cloud about to cover the earth. It will be in the far-off days that you shall come against my people, and I shall let you do so, that the nations may know me, for I shall manifest my holiness through you, O Gog!"
,"17":"Thus says Yahweh: You are the one about whom I spoke in former times through my servants, the prophets of Israel, saying that I would bring you against them in far-off days."
,"18":"On that day when Gog will come to the land of Israel - word of Yahweh - my fury will be aroused."
,"19":"In the jealousy and heat of my anger I declare: On that day there will be a great earthquake in Israel."
,"20":"The fish of the sea, the birds of the air, the beasts of the field, the creatures that creep on the ground and every human being on the earth will tremble before me. Mountains will fall, cliffs crumble and walls collapse."
,"21":"I will summon the sword against Gog on all my mountains - word of Yahweh. Each one's sword will turn against his brother."
,"22":"I will punish Gog with plague and bloodshed. I will send torrential rain, hailstones and burning sulfur on him and on his battalions and on the many nations with him."
,"23":"I will manifest myself as the Mighty and Holy One in the sight of these many people, and they will know that I am Yahweh."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Son of man, prophesy against Gog! Say to him: Thus says Yahweh: I come against you, Gog, chief prince of Meshech and Tubal."
,"2":"When I have led, directed and brought you from the far north to the mountains of Israel,"
,"3":"I shall break the bow in your left hand and snatch the arrows from your right hand."
,"4":"You will fall on the mountains of Israel, you, your battalions and the nations with you. And I shall give you over to all the birds of prey and wild beasts"
,"5":"when you have fallen in the open countryside, for I have spoken, word of Yahweh."
,"6":"I shall send fire to the land of Magog and to those living peacefully in the islands and they will know that I am Yahweh."
,"7":"I will manifest my holy Name among my people Israel, and never again allow my holy Name to be profaned, and the nations will know that I am Yahweh, the Holy One of Israel."
,"8":"All this will come about and take place - word of Yahweh. This is the day I foretold."
,"9":"After that citizens of the towns of Israel will make a fire, using your weapons as fuel: small and large bucklers, bows and arrows, clubs and javelins. For seven years they will be used as fuel;"
,"10":"there will be no need to bring wood from the country or to gather it in the forests since they will have your weapons to burn. They will plunder their plunderers and loot those who looted them - word of Yahweh."
,"11":"On that day I shall give Gog a well-known burial place in Israel, the valley of the Abarim, on the east of the sea, the valley where the traveler has to stop. There they will bury Gog and his hordes and they will call it the Valley of the Multitude of Gog."
,"12":"It will take seven months to bury the dead and cleanse the country."
,"13":"All the population will work at burying the dead and this will be their honor on the day I am glorified, word of Yahweh."
,"14":"Men will work on a regular basis going around the country to bury those lying on the ground and so cleanse the land. For seven months they will go searching."
,"15":"If, as they go through the land, they come across human remains, they will make a pile of stones beside them until the grave diggers bury them in the Valley of the Multitude of Gog"
,"16":"(the name of the town is Multitude). In that way the land will be cleansed."
,"17":"Son of man, Yahweh says this: Say to every kind of bird and wild beast: Assemble and come together from all parts to the sacrifice I am preparing for you, a great sacrifice on the mountains of Israel at which you will eat flesh and drink blood,"
,"18":"the flesh of heroes and the blood of the world's princes. They are all rams, lambs, goats, bullocks, all fattened animals from Bashan."
,"19":"You will eat all the fat you want and drink blood until you are drunk at the sacrifice I am preparing for you."
,"20":"You will have your fill of horses, riders, heroes and warriors of all kinds - word of Yahweh."
,"21":"I will show my glory among all the nations and they will know my judgment and the punishment I shall inflict on them."
,"22":"Then Israel will know from that day onward that I am Yahweh, their God."
,"23":"And the nations will know that Israel was exiled because they were unfaithful to me, and this was why I hid my face from them; I handed them over to their enemies and they perished by the sword."
,"24":"I dealt with them as their defilement and sins deserved, and I hid my face from them."
,"25":"That is why thus says Yahweh: Now, moved by my compassion for Israel, I am going to bring back the captives of Jacob and I will give glory to my holy name."
,"26":"They will forget their shame and the treachery they committed towards me, when they live safely in their own land with no one to disturb them."
,"27":"When I gather them from among the nations and take them from the land of their enemies, I will show my holiness through them to many nations."
,"28":"They will know that I am Yahweh their God when, after their exile among the nations, I bring them together in their own land and leave no one behind."
,"29":"Never again shall I hide my face from them because I shall pour out my Spirit on Israel - word of Yahweh.'"
}`)
	CurrentBook.AddChapter(40, `{
"1":"In the twenty-fifth year of our captivity, at the beginning of the year, on the tenth day of the month, fourteen years after Jerusalem had been taken, the hand of Yahweh was upon me."
,"2":"In a divine vision he took me away to the land of Israel and put me down on a very high mountain, on the south of which there seemed to be built a city."
,"3":"He took me to it, and there I saw a man who seemed to be made of bronze. He had a flax cord and a measuring rod in his hand and was standing in the gateway."
,"4":"The man said to me, 'Son of man, look carefully, listen closely and pay attention to everything I show you, since they brought you here for me to show it to you. Tell the people of Israel everything that you see.'"
,"5":"The House was surrounded with a wall, and the man was holding a measuring rod that was three meters long (six great cubits). He measured the thickness of this construction - one rod; and its height - one rod."
,"6":"He went to the east gate, climbed the steps and measured its threshold: one rod deep."
,"7":"Each guardroom one rod by one rod; and the walls between the guardrooms five cubits thick;"
,"8":"and the threshold of the gate inward from the porch of the gate: one rod."
,"9":"He measured the porch of the gate: eight cubits; its jambs: two cubits; the porch of the gate was at the inner end."
,"10":"There were three guardrooms on each side of the east gate, all three the same size; the walls between them all the same thickness on each side."
,"11":"He measured the width of the entrance: ten cubits; and the width all down the gateway: thirteen cubits."
,"12":"There was a rail in front of the guardrooms; each rail on either side was one cubit. And the guardrooms on either side were six cubits square."
,"13":"He measured the width of the gate from the back wall of one guardroom to the back wall of the other; it was twenty-five cubits across from window to window."
,"14":"He measured the entrance: twenty cubits; after the porch of the gate came the outer court."
,"15":"From the entrance end of the gate to the porch opposite: fifty cubits."
,"16":"On each side of the gate there were windows with screens both in the guardrooms and in the spaces between, and there were openings all around inside the porch as well, and palm trees decorating the pillars."
,"17":"He took me through to the outer court. There were rooms and a paved terrace going all the way around; there were thirty rooms on this terrace."
,"18":"This terrace, which came right up to the sides of the gates and matched their depth, is the Lower Terrace."
,"19":"He measured across the outer court from the lower gate to the outside of the inner court: a hundred cubits."
,"20":"He measured the length and breadth of the north gate of the outer court."
,"21":"It had three guardrooms on each side; the thickness of the walls between them, and its porch too, all measured the same as those of the first gate: fifty cubits by twenty-five cubits."
,"22":"Its windows, its entrance and its palm-tree decoration all measured the same as those of the east gate. There were seven steps up to it, and its porch was at the inner end."
,"23":"In the inner court there was, opposite the north gate, a gate like the one opposite the east gate. He measured the distance from one gate to the other: a hundred cubits."
,"24":"He took me to the south and there was a gate to the south gate; he measured its guardrooms, the thickness of its walls and porch; they were of the same dimensions as the others."
,"25":"All around it and its entrance were windows, like the other windows; it measured fifty cubits by twenty-five cubits,"
,"26":"and it had seven steps up to it; its entrance was at the inner end and had palm-tree decorations on its pillars, one on each side."
,"27":"The inner court had a southern gate; he measured the distance southward from one gate to the other: a hundred cubits."
,"28":"He then took me into the inner court by the south gate; he measured the south gate which was the same size as the others."
,"29":"Its guardrooms, the thickness of its walls and entrance all measured the same as the others."
,"30":"Its entrance had windows all around. It measured fifty cubits by twenty-five cubits. Its entrance, measured in all, all around, was twenty-five cubits by five cubits."
,"31":"The entrance gave on to the outer court. It had palm trees on its pillars, each side, and eight steps leading up to it."
,"32":"He took me to the east gate and measured it. It was the same size as the others."
,"33":"Its guardrooms, the thickness of its walls, its entrance all measured the same as the others. The gate and its entrance had windows all around. Its area was fifty cubits by twenty-five cubits."
,"34":"Its porch gave on to the outer court. There were palm trees on its pillars on either side, and eight steps leading up to it."
,"35":"He took me to the north gate and measured it. Its guardrooms, the thickness of its walls and its entrance all measured the same as the others."
,"36":"It had windows all around. Its area was fifty cubits by twenty-five cubits."
,"37":"Its entrance gave on to the outer court. There were palm trees on its pillars on either side, and eight steps leading up to it."
,"38":"There was a room entered from the entrance of the gates. It was here that they had to wash the holocaust."
,"39":"And on either side of the entrance of the gate there were two tables for slaughtering the burnt offering, the sacrifice for sin and the sacrifice of repayment."
,"40":"Going northward up to the gate, there were two tables outside and two more tables at the entrance end of the gate."
,"41":"There were four tables on the inside and four tables on the outside of the entrance; in all, eight tables on which the sacrifices were offered."
,"42":"There were also four tables of dressed stone for burnt offerings, a cubit and a half long, a cubit and a half wide and a cubit high, on which all the things necessary for killing the burnt offering and the sacrifices were put."
,"43":"Rims, a handbreadth broad, went all around the top, and on these tables was put the flesh of the offerings."
,"44":"He took me into the inner court; there were two lodges in the inner court, one at the side of the north gate, facing south, the other at the side of the south gate, facing north."
,"45":"He told me, 'The lodge looking south is for the priests in charge of the Temple,"
,"46":"and the lodge looking north is for the priests who serve the altar. These are the sons of Zadok, the only sons of Levi who approach Yahweh to serve him.'"
,"47":"He measured the inner court. It was a quadrangle, a hundred cubits by a hundred cubits, with the altar in front of the House."
,"48":"He took me to the Hall of the House and measured its door pillars - five cubits each side; and the width of the entrance was fourteen cubits with a three-cubit wall each side."
,"49":"The Hall was twenty cubits by twelve cubits. There were ten steps leading up to it, and there were columns by the door pillars, one on each side."
}`)
	CurrentBook.AddChapter(41, `{
"1":"He took me into the Sanctuary and measured its door pillars: six cubits deep on the one side, six cubits deep on the other."
,"2":"The width of the entrance was ten cubits. The walls on each side of the entrance were five cubits on the one side and five cubits on the other. He measured its length: forty cubits; and its width: twenty cubits."
,"3":"He went in and measured the door pillars at the entrance: two cubits; then the entrance: six cubits; and the walls on each side of the entrance: seven cubits."
,"4":"He measured its length: twenty cubits; and its width measured across the end wall of the Sanctuary: twenty cubits. He then said to me, 'This is the most holy place.'"
,"5":"He measured the wall of the House: six cubits. The width of the side cells was four cubits, all around the House."
,"6":"The cells were one above the other, thirty of them in three stories."
,"7":"The supports for the surrounding cells were fixed into the House wall, so that the cells were not recessed into the wall of the House. The width of the cells increased, story by story, for they surrounded the House in the stories that went right around it."
,"8":"Then I saw that there was a paved terrace all around the House. The height of this, which formed the base of the side cells, was a full rod of six cubits."
,"9":"The outer wall of the side cells was five cubits thick and the pavement formed a veranda outside the cells of the House."
,"10":"Beyond the rooms was an area twenty cubits wide right around the House."
,"11":"And for access from the side cells onto the courtyard there was one entrance on the north side and one entrance on the south side. The width of the courtyard was five cubits all around."
,"12":"The building to the west of this surrounding area was seventy cubits by ninety cubits, and the wall of the building was five cubits thick, all around."
,"13":"He measured the length of the House: a hundred cubits. The length of the court plus the building and its walls: a hundred cubits."
,"14":"The breadth of the facade of the House with the quadrangle: a hundred cubits."
,"15":"He measured the length of the building plus the surrounding area at the back, plus the side depth of its door: a hundred cubits. The inside of the Sanctuary and the entrance of the court, their thresholds, the window screens, the three sets of doors, one at each threshold, "
,"16":"were all paneled with wood, from floor to windows, and the windows were screened with lattice-work."
,"17":"From the door to the inner part of the House, and right around the whole wall of the inner room, outside and inside,"
,"18":"were carved cherubs and palm trees, palm trees and cherubs alternating; each cherub had two faces -"
,"19":"the face of a man turned toward the palm tree on one side and the face of a lion toward the palm tree on the other, all around the House. The cherubs and palm trees were carved"
,"20":"from the floor to above the entrance, as also on the wall of the hall."
,"21":"The pillars of the House were square. In front of the Most Holy Place, "
,"22":"there appeared to be a wooden altar, three cubits high and two cubits square. Its corners, base and sides were of wood. He said to me, 'This is the table before Yahweh.'"
,"23":"There was a double door for the Temple, and a double door for the Sanctuary."
,"24":"These doors had two hinged leaves, two leaves for the one door, two leaves for the other."
,"25":"On them, on the doors of the Sanctuary, were carved cherubs and palm trees like those carved on the walls. A wooden screen outside went across the front of the Hall."
,"26":"There were screened windows with flanking palm trees on the walls of the House, and of the cells at the side of the House."
}`)
	CurrentBook.AddChapter(42, `{
"1":"He took me northward into the court and led me to the rooms facing the outer court, and the building to the north."
,"2":"They were one hundred cubits long on the north side and fifty cubits wide."
,"3":"On the sides facing the entrance of the inner court and the paving of the outer court was a gallery in front of the triple gallery,"
,"4":"and in front of the rooms was a walk, ten cubits broad measured inward and a hundred cubits long; their doors looked north."
,"5":"The top-floor rooms were narrow because the galleries took up part of the width, being narrower than those on the ground floor or those on the middle floor of the building."
,"6":"They were in three stories and had no columns such as those in the court had. Hence they were narrower than the groundfloor ones or the middle-floor ones below them."
,"7":"The outer wall parallel to the rooms, facing them and giving on to the outer court, was fifty cubits long,"
,"8":"the length of the rooms facing the outer court being fifty cubits, while on the side facing the building it was a hundred cubits."
,"9":"Beneath the rooms there was an entrance from the east, leading in from the outer court."
,"10":"In the thickness of the wall of the court, on the south side fronting the court and the building, were rooms."
,"11":"A walk ran in front of them, as with the rooms built on the north side; they were of the same length and breadth, and had similar design and doors in and out."
,"12":"They were like the entrances of the southern rooms; one entrance at the end of each walk, fronting the eastern wall, being the way in. He said to me,"
,"13":"'The northern and southern rooms giving on to the court are holy rooms, in which the priests who approach Yahweh will eat the most holy things. In them will be placed the most holy things: the offering, the sacrifice for sin and the sacrifice of repayment, since this is a holy place."
,"14":"Once the priests have entered they will not go out of the holy place into the outer court without leaving their liturgical vestments there, since these vestments are holy; they will put on other clothes before going near the room assigned to the people.'"
,"15":"When he had finished measuring the inside of the Temple, he took me out to the east gate and measured the whole area of the court."
,"16":"He measured the east side with his measuring rod: a total of five hundred cubits by the measuring rod."
,"17":"He then measured the north side: five hundred cubits by the measuring rod."
,"18":"He then measured the south side: five hundred cubits by the measuring rod."
,"19":"On the west side he measured five hundred cubits."
,"20":"So he measured the entire enclosing wall on all four sides: length five hundred, breadth five hundred. This separated the sacred from the profane."
}`)
	CurrentBook.AddChapter(43, `{
"1":"He took me to the gate, facing east."
,"2":"Then I saw the Glory of the God of Israel approaching from the east with a sound like the sound of the ocean, and the earth shone with his Glory."
,"3":"This vision was like the one I had seen when he came for the destruction of the city, and like the one I had seen on the bank of the river Chebar. Then I threw myself to the ground."
,"4":"The Glory of Yahweh arrived at the Temple by the east gate."
,"5":"The spirit lifted me up and brought me into the inner court: the Glory of Yahweh was filling the House."
,"6":"And I heard someone speaking to me from the Temple while the man stood beside me."
,"7":"The voice said, 'Son of man, you have seen the place of my throne, where I will place the soles of my feet, and live among the sons of Israel forever; and the people of Israel, they and their kings, will no longer defile my holy name with their prostitutions and the kings,"
,"8":"setting their threshold beside my threshold and their door beside my door, with a common wall shared by them and me. They used to defile my holy name by their filthy practices, and this is why I destroyed them in my anger."
,"9":"From now on if they take their prostitutions and the corpses of their kings away from my presence, I shall live among them forever."
,"10":"Son of man, describe this House to the people of Israel, to shame them out of their filthy practices."
,"11":"If they are ashamed of their behavior, draw up the plan and show them the design of the Temple, its exits and entrances, its shape, how all of it is arranged, its rules and its laws. Give them all this in writing so that they can see and take note of its design and the way it is all arranged and carry it out."
,"12":"This is the law of the Temple: all the surrounding area on top of the mountain is a most holy area."
,"13":"Here are the dimensions of the altar (in big cubits, each of a cubit plus a handbreadth). The base: one cubit high and one cubit wide. The ledge all around it: one span. This is the height of the altar:"
,"14":"from the ground level of the base up to the lower base, two cubits high and one cubit wide; from the lesser plinth to the greater base, four cubits high and one cubit wide."
,"15":"The altar hearth: four cubits high, with four horns projecting from the hearth,"
,"16":"the hearth being square: twelve cubits by twelve cubits;"
,"17":"and the square base: fourteen cubits by fourteen cubits; and the ledge all around: half a cubit; and the base: one cubit all around. The steps are on the east side.'"
,"18":"He said to me, 'Son of man, Yahweh says this: As regard the altar, this is how things are to be done when it has been built for the offering of the holocaust and for the pouring of blood."
,"19":"To those levitical priests of the race of Zadok who approach me to serve me - it is Yahweh who speaks - you must give a young bull as sacrifice for sin."
,"20":"You are to take some of its blood and put it on the four horns and the four corners of the base and the surrounding ledge."
,"21":"In this way you will purify it and make atonement on it. Then take the bull of the sacrifice for sin and burn it in a room of the House apart from the sanctuary."
,"22":"On the second day, you must offer an unblemished he-goat as sacrifice for sin, and the altar is to be purified again as with the bull."
,"23":"When you have finished the purification you must offer a young bull without blemish and an unblemished ram chosen from the flock."
,"24":"You are to present them before Yahweh, and the priests will sprinkle salt on them and offer them as a holocaust to Yahweh."
,"25":"As a sacrifice for sin, every day for seven days you must offer a he-goat, a bull and an unblemished ram chosen from the flock, for a week."
,"26":"In this way the altar will be atoned for and will be purified and inaugurated."
,"27":"At the end of that time, on the eighth day and afterwards, the priest is to offer your burnt offerings and your communion offerings on the altar, and I will look kindly on you - it is Yahweh who speaks.'"
}`)
	CurrentBook.AddChapter(44, `{
"1":"He brought me back to the outer east gate of the sanctuary. It was shut."
,"2":"Yahweh said to me, 'This gate will be kept shut. No one will open it or go through it, since Yahweh the God of Israel has been through it. And so it must be kept shut."
,"3":"The prince himself, however, may sit there to take his meal in the presence of Yahweh. But he is to enter through the entrance of the gate and leave through the same way.'"
,"4":"He led me through the north gate to the front of the House. I looked; I saw the Glory of Yahweh filling his House, and I threw myself to the ground."
,"5":"Yahweh said to me, 'Son of man, pay attention, look carefully and listen closely to everything while I explain to you all the rules of the House of Yahweh and all its laws. Be careful about which men are admitted to the House and which are excluded from the sanctuary."
,"6":"And say to the rebels of the people of Israel, the Lord Yahweh says this: There has been enough of all your filthy practices, House of Israel."
,"7":"You let aliens enter, uncircumcised in heart and body, to frequent my sanctuary and profane my Temple; you gave me for my food the fat and the blood; and you broke my covenant with all your filthy practices."
,"8":"Instead of performing your duties to men in the Holy Place, you have deputed someone else to perform your duties in my sanctuary."
,"9":"The Lord Yahweh says this: No alien, uncircumcised in heart and body, is to enter my sanctuary, none of those aliens living among the Israelites."
,"10":"The Levites who abandoned me when Israel strayed far from me, and followed their idols, must bear the weight of their own sin."
,"11":"They are to be servants in my sanctuary, responsible for guarding the gates and serving the House. They will kill the burnt offering and the sacrifice for the people, and hold themselves at the service of the people."
,"12":"But since they used to be at their service in front of their idols and made Israel sin, (and I have raised my hand against them) it is Yahweh who speaks - they must bear the weight of their sin."
,"13":"They are never to approach me again to perform the priestly office in my presence, or to touch my holy things and my most holy things; they must bear the disgrace of their filthy practices."
,"14":"I shall let them work in the House and serve it and do everything to be done in it."
,"15":"The levitical priests, the sons of Zadok, who did their duty to me in the sanctuary when the Israelites strayed far from me, may still approach me to serve me. They may stand in my presence to offer me the fat and blood - it is Yahweh who speaks."
,"16":"They may enter my sanctuary and approach my table to serve me; they may perform my liturgy."
,"17":"Once they enter the gates of the inner court, they are to wear linen garments; they are to wear no wool when they serve inside the gates of the inner court and in the House."
,"18":"They are to wear linen caps on their heads, and linen breeches about their loins; they are not to wear belts that may make them sweat."
,"19":"When they go out to the people in the outer court, they are to remove the garments in which they have performed the liturgy and leave them in the rooms of the Holy Place, and put on other clothes, so as not to hallow the people with their vestments."
,"20":"They are neither to shave their heads nor to let their hair grow long, but must cut their hair to a reasonable length."
,"21":"No priest is to drink wine on the day he enters the inner court."
,"22":"They are not to marry widows or divorced women, but only virgins of the race of Israel; they may, however, marry widows, if it is the widow of a priest."
,"23":"They are to teach my people what is sacred and what is profane and make them know what is clean and what is unclean."
,"24":"They are to be judges in disputes; they must judge in the spirit of my statutes; they must follow my laws and ordinances at all my feasts and keep my sabbaths holy."
,"25":"They are not to go near a dead man, lest they become unclean, except for father, mother, daughter, son, brother or unmarried sister."
,"26":"After one of them has been purified, seven days must elapse;"
,"27":"then on the day when he enters the sanctuary - the inner court, to minister in the sanctuary, he is to offer his sacrifice for sin - it is Yahweh who speaks."
,"28":"They are to have no inheritance in Israel; I myself will be their inheritance. You are to give them no patrimony in Israel; I myself will be their patrimony."
,"29":"Their food is to be the offering, the sacrifice for sin and the sacrifice of repayment. Everything in Israel consecrated by anathema shall be for them."
,"30":"The best of all your first fruits of every sort and of all that you offer, is to go to the priests; and the best of your dough you are also to give to the priests, so that a blessing may rest on your houses."
,"31":"Priests are not to eat the flesh of anything that has died a natural death or been savaged, neither the flesh of a bird nor of any other creature."
}`)
	CurrentBook.AddChapter(45, `{
"1":"When you divide the country into portions by lot, you are to allocate a sacred portion of the country to Yahweh: twenty-five thousand cubits long and twenty thousand wide."
,"2":"The whole of this land is to be sacred, and of this square area five hundred by five hundred cubits is to be for the sanctuary, with a boundary fifty cubits wide all around."
,"3":"Out of this area you are also to measure a section twenty-five thousand by ten thousand cubits, in which there shall stand the sanctuary; this is a very holy land."
,"4":"This is to be the sacred portion of the country; it shall belong to the priests who officiate in the sanctuary and approach Yahweh to serve him. There they are to have their houses and also a district set apart for the sanctuary."
,"5":"An area twenty-five thousand by ten thousand cubits is to be kept for the Levites serving the House to own, with towns to live in."
,"6":"You are to give the city possession of an area five thousand by twenty-five thousand cubits, near the land belonging to the sanctuary; this is to be for the whole people of Israel."
,"7":"The prince is to have a domain on either side of the very holy land and of the land belonging to the city, and adjacent to both of them, stretching westward from the west and eastward from the east, its size equal to one of the portions between the west and the east frontiers of the country."
,"8":"This is to be his possession in Israel. Then my princes will no longer oppress my people; they must leave the rest of the country for the people of Israel, for its tribes."
,"9":"Yahweh says this: Let this be enough for you, princes of Israel! Give up your violence and plundering, practice justice and integrity, crush my people no more with taxation - it is Yahweh who speaks."
,"10":"Have scales that are fair, a fair ephah, a fair bath."
,"11":"Let the ephah and bath be equal, let the bath hold one tenth of a homer and the ephah one tenth of a homer."
,"12":"Let the measures be based on the homer. The shekel is to be twenty gerahs. Twenty shekels, twenty-five shekels plus fifteen shekels are to make one mina."
,"13":"This is the tax that you are to levy: the sixth of an ephah for every homer of wheat, and the sixth of an ephah for every homer of barley."
,"14":"The dues on oil: one bath of oil out of every ten baths or out of every cor (which is equal to ten baths or one homer, since ten baths equal one homer)."
,"15":"You are to levy one sheep on every flock of two hundred from the patrimony of Israel for the oblation, the burnt offering and the communion sacrifice. This is for the atonement - it is Yahweh who speaks."
,"16":"Let all the people of the country be bound to give this offering for the prince of Israel."
,"17":"The prince is to provide the burnt offerings, grain offerings and drink offerings for feasts, New Moons and sabbaths, for all the solemn festivals of Israel. He is to provide the sacrifice for sin, oblation, holocaust and communion sacrifices atoning for Israel."
,"18":"Yahweh says this: On the first day of the first month, you must take a young bull without blemish, to purify the sanctuary."
,"19":"The priest is to take blood from the sacrifice for sin and put it on the doorposts of the House, on the four corners of the altar base and on the doorposts of the gates of the inner court."
,"20":"You must do the same on the seventh of the month, on behalf of anyone who has sinned through inadvertence or ignorance. This is how you are to make atonement for the House."
,"21":"On the fourteenth day of the first month, you must celebrate the feast of the Passover. For seven days everyone is to eat unleavened loaves."
,"22":"On that day, the prince must offer a bull as a sacrifice for sin, for himself and all the people in the country."
,"23":"For the seven days of the feast, he must offer Yahweh a burnt offering of seven bulls and seven rams without blemish, daily for a week, and one he-goat daily as a sacrifice for sin,"
,"24":"with a grain offering of one ephah for each bull and one ephah for each ram, and a hin of oil for every ephah for the oblation."
,"25":"For the feast on the fifteenth day of the seventh month, he must do the same for seven days, offering the sacrifice for sin, burnt offering, drink offering and the oil."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Thus speak Yahweh: The east gate of the inner court must be kept shut for the six working days. On the sabbath day it is to be opened, as also on the day of the New Moon;"
,"2":"and the prince is to go in through the entrance of the outer gate and stand by the doorposts of the gate. The priest must then offer his holocaust and his communion sacrifice. He must prostate himself on the threshold of the gate and go out, and the gate is not to be shut again until the evening."
,"3":"The people of the country are to prostrate themselves in the presence of Yahweh at the entrance to the gate on sabbaths and days of the New Moon."
,"4":"On the sabbath day the prince shall offer six unblemished lambs and one unblemished ram for the burnt offering."
,"5":"The grain offering is of one ephah for the ram, with such oblation as he pleases for the lambs, and a hin of oil for every ephah."
,"6":"On the day of the New Moon he shall offer a young bull without blemish, six unblemished lambs and one unblemished ram;"
,"7":"he must make a grain offering of one ephah for the bull and one ephah for the ram, and what he pleases for the lambs, and a hin of oil for every ephah."
,"8":"When the prince goes in, he is to enter by the entrance of the gate, and he must leave by the same way."
,"9":"When the people of the country come into the presence of Yahweh at the solemn festivals to prostrate themselves, those who have come in by the north gate are to go out by the south gate, and those who have come in by the south gate are to go out by the north gate; no one is to turn back to leave through the gate by which he entered but is to go out on the opposite side."
,"10":"The prince is to come with them, coming in like them and going out like them."
,"11":"On feast days and solemn festivals the oblation must be one ephah for every bull, one ephah for every ram, what he pleases for the lambs, and a hin of oil for every ephah."
,"12":"When the prince offers Yahweh a voluntary communion sacrifice, the east gate is to be opened for him, and he is to offer his holocaust and his communion sacrifice as he does on the sabbath day; when he has gone out, the gate is to be shut after him."
,"13":"Every day he must offer an unblemished lamb one year old as a holocaust to Yahweh; he must offer this every morning."
,"14":"Every morning, in addition, he is to offer an oblation of one sixth of an ephah and one third of a hin of oil, for mixing with the flour. This is an eternal law."
,"15":"The lamb, the oblation and the oil are to be offered morning after morning forever."
,"16":"Yahweh says this: If the prince gives his sons part of his inheritance, the gift is to pass to the ownership of his sons, and become their heritage."
,"17":"But if he gives part of his inheritance to one of his servants, it shall only belong to the man until the year of liberation and is then to revert to the prince. Only his sons may retain his inheritance."
,"18":"The prince may not take any part of the people's inheritance and thus rob them of their rightful possessions; he must provide the patrimony of his sons out of his own property, so that no member of my people will be robbed of his rightful possessions.'"
,"19":"He took me through the entrance at the side of the north gate that leads to the rooms of the Holy Place set apart for the priests. And there before us, to the west, was a space at the end."
,"20":"He said to me, 'This is where the priests are to boil the slaughtered animals for the sacrifice for sin and the sacrifice of reparation, and where they are to bake the oblation. They shall not carry them into the outer court lest they hallow the people."
,"21":"He took me into the outer court and led me to each of its four corners;"
,"22":"in each corner was a compound; there were four small compounds, forty cubits by thirty, all four being the same size."
,"23":"Each of the four was enclosed by a wall, with hearths all around the bottom of the wall."
,"24":"He said, 'These are the kitchens where the Temple servants are to boil the sacrifices offered by the people.'"
}`)
	CurrentBook.AddChapter(47, `{
"1":"The man brought me back to the entrance of the Temple and I saw water coming out from the threshold of the Temple and flowing eastwards. The Temple faced the east and the water flowed from the south side of the Temple, from the south side of the altar."
,"2":"He then brought me out through the north gate and led me around the outside to the outer gate facing the east and there I saw the stream coming from the south side."
,"3":"The man had a measuring cord in his hand. As he went towards the east he measured off a thousand cubits and led me across the water which was up to my ankles."
,"4":"He measured off another thousand cubits and made me cross the water which came to my knees. He measured off another thousand cubits and we crossed the water which was up to my waist."
,"5":"When he had again measured a thousand cubits, I could not cross the torrent for it had swollen to a depth which was impossible to cross without swimming."
,"6":"The man then said to me, 'Son of man, did you see?' He led me on further and then brought me back to the bank of the river."
,"7":"There I saw a number of trees on both sides of the river."
,"8":"He said to me, 'This water goes to the east, down to the Arabah, and when it flows into the sea of foul-smelling water, the water will become wholesome."
,"9":"Wherever the river flows, swarms of creatures will live in it; fish will be plentiful and the sea water will become fresh. Wherever it flows, life will abound."
,"10":"Fishermen will stand on the banks and spread nets from En Gedi to En Eglaim. Fish of many kinds will be found there, like the fish of the open sea and very plentiful."
,"11":"The swamps and the marshes will not become wholesome; they will be used as saltbeds."
,"12":"Near the river on both banks there will be all kinds of fruit trees with foliage that will not wither and fruit that will never fail; each month they will bear a fresh crop because the water comes from the Temple. The fruit will be good to eat and the leaves will be used for healing."
,"13":"Yahweh says this: Here are the boundaries of the territories to be allotted between the twelve tribes of Israel, with two portions for Joseph."
,"14":"You must share it out equally between you, since I swore to your fathers that I would give them this land which now falls to you as your inheritance."
,"15":"Here are the frontiers of the land. On the north, from the Great Sea by the way of Hethlon to the Pass of Hamath and on to Zedad,"
,"16":"Berothah, Sibraim lying between the territories of Damascus and Hamath - and to Hazer-hatticon on the borders of Hauran."
,"17":"The frontier will extend from the sea to Hazar-enon, marching with Damascus and Hamath on the north; this is the northern frontier."
,"18":"On the east the Jordan will serve as frontier between Hauran and Damascus, between Gilead and the land of Israel, down to the Eastern Sea as far as Tamar; this is for the eastern frontier."
,"19":"On the south, from Tamar southward to the waters of Meribah in Kadesh, to the torrent of Egypt and the Great Sea; this is for the southern frontier."
,"20":"On the west the Great Sea will serve as frontier straight up towards Hamath; so much for the western frontier."
,"21":"You are to share out this land among yourselves, between the tribes of Israel."
,"22":"You are to divide it into inheritances for yourselves and the aliens settled among you who have had children among you, since you are to treat them as citizens of Israel. They are to draw lots with you for their inheritance, with the tribes of Israel."
,"23":"You must give the alien his inheritance in the tribe in which he is living - it is Yahweh who speaks."
}`)
	CurrentBook.AddChapter(48, `{
"1":"This is the list of the tribes. In the far north by way of Hethlon to Hamath, to Hazar-enon, with the frontier of Damascus lying to the north, bordering Hamath - each portion extends from the eastern frontier to the western frontier: Dan, one portion."
,"2":"Bordering Dan, from the eastern frontier to the western frontier: Asher."
,"3":"Bordering Asher, from the eastern frontier to the western frontier: Naphtali."
,"4":"Bordering Naphtali, from the eastern to the western frontier: Manasseh."
,"5":"Bordering Manasseh, from the eastern frontier to the western frontier: Ephraim."
,"6":"Bordering Ephraim, from the eastern frontier to the western frontier: Reuben."
,"7":"Bordering Reuben, from the eastern frontier to the western frontier: Judah."
,"8":"Bordering Judah, from the eastern frontier to the western frontier, is the part you are to set aside, twenty-five thousand cubits wide, and as long as each of the other portions from the eastern frontier to the western frontier. The sanctuary will be in the center of it."
,"9":"The part you must set aside for Yahweh is to be twenty-five thousand cubits long and ten thousand cubits wide."
,"10":"This consecrated portion is to belong to the priests, being, on the north side, twenty-five thousand cubits; on the west side ten thousand cubits wide, on the east side ten thousand cubits wide and on the south side twenty-five thousand cubits long, and the sanctuary of Yahweh will be the center of it."
,"11":"This is to belong to the consecrated priests, to those of the sons of Zadok who maintained my liturgy and did not go astray with the straying Israelites, as the Levites went astray."
,"12":"And so their portion is to be taken out of the most holy portion of the land, at the side of the territory of the Levites."
,"13":"The territory of the Levites, like the territory of the priests, is to be twenty-five thousand cubits long and ten thousand wide - the whole length being twenty-five thousand and the width ten thousand."
,"14":"They must not sell or exchange any part of it, and their part can never be alienated, since it is consecrated to Yahweh."
,"15":"The remainder, an area of five thousand cubits by twenty-five thousand, is to be a non-sacred space for the city, for houses and pastures. The city is to stand in the center."
,"16":"Here are its measurements: on the north side, four thousand five hundred cubits; on the south side, four thousand five hundred cubits; on the east side, four thousand five hundred cubits; on the west side, four thousand five hundred cubits."
,"17":"And the city pastures are to extend two hundred and fifty cubits to the north, two hundred and fifty to the south, two hundred and fifty to the east, two hundred and fifty to the west."
,"18":"What remains of the part set aside, after keeping out the consecrated portion, consists of ten thousand cubits eastward and ten thousand westward, alongside the consecrated portion; this will bring in a revenue for feeding the people working inside the city."
,"19":"These people are to be drawn from all the tribes of Israel and shall till this land."
,"20":"The portion is to have a total area of twenty-five thousand cubits by twenty-five thousand cubits. So the sacred portion has a square shape and is located beside the land belonging to the city."
,"21":"What is left over on either side of the sacred portion and of the land belonging to the city, shall be for the prince, extending along the twenty-five thousand cubits eastward to the eastern frontier, and extending along the twenty-five thousand cubits westward to the western frontier - running parallel with the other portions. This is the portion for the prince with, the consecrated portion and the sanctuary of the Temple at the middle."
,"22":"Thus, apart from the property of the Levites and property of the city which lie inside the prince's portion, everything between the borders of Judah and the borders of Benjamin is to belong to the prince."
,"23":"Here are the rest of the tribes: from the eastern frontier to the western frontier: Benjamin."
,"24":"Bordering Benjamin, from the eastern frontier to the western frontier: Simeon."
,"25":"Bordering Simeon, from the eastern frontier to the western frontier: Issachar."
,"26":"Bordering Issachar, from the eastern frontier to the western frontier: Zebulun."
,"27":"Bordering Zebulun, from the eastern frontier to the western frontier: Gad."
,"28":"The southern border of Gad will be formed by the southern frontier running through Tamar to the waters of Meribah in Kadesh, to the Wadi and the great Sea."
,"29":"This is the inheritance of the tribes of Israel and this is how you will apportion it - it is Yahweh who speaks."
,"30":"Here are the ways out of the city. On the north side, being four thousand five hundred cubits long,"
,"31":"three gates: the gate of Reuben, the gate of Judah, the gate of Levi; the gates of the city are to be named after the tribes of Israel."
,"32":"On the east side, which is to be four thousand five hundred cubits long, three gates: the gate of Joseph, the gate of Benjamin, the gate of Dan."
,"33":"On the south side, which is to be four thousand five hundred cubits long, three gates: the gate of Simeon, the gate of Issachar, the gate of Zebulun."
,"34":"On the west side, which is to be four thousand five hundred cubits long, three gates: the gate of Gad, the gate of Asher, the gate of Naphtali."
,"35":"The total perimeter will be eigthteen thousand cubits, and the name of the city is to be: Yahweh-is-there.'"
}`)

}
func EN_CCB_LoadVMIEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"These are the words of Jeremiah son of Hilkiah, one of the priests at Anathoth in the territory of Benjamin."
,"2":"The word of Yahweh came to him in the thirteenth year of the reign of Josiah son of Amon, king of Judah."
,"3":"It came again during the reign of Jehoiakim son of Josiah, king of Judah, until the eleventh year of Zedekiah son of Josiah, king of Judah. In the fifth month of that year, the inhabitants of Jerusalem were taken into exile."
,"4":"A word of Yahweh came to me,"
,"5":"'Even before I formed you in the womb I have known you; even before you were born I had set you apart, and appointed you a prophet to the nations!'"
,"6":"I said, 'Ah, Lord Yahweh! I do not know how to speak; I am still young!'"
,"7":"But Yahweh replied, 'Do not say; 'I am still young', for now you will go whatever be the mission I am entrusting to you, and you will speak of whatever I command you to say."
,"8":"Do not be afraid of them, for I will be with you to protect you - it is Yahweh who speaks!'"
,"9":"Then Yahweh stretched out his hand and touched my mouth and said to me, 'Now I have put my words in your mouth."
,"10":"See! Today I give you authority over nations and over kingdoms to uproot and to pull down, to destroy and to overthrow, to build and to plant.'"
,"11":"A word of Yahweh came to me again, 'Jeremiah what do you see?' I said, 'I see the branch of a watching tree.'"
,"12":"And Yahweh said to me, 'You are right. I too am watching to fulfill my word.'"
,"13":"The word of Yahweh came to me a second time, 'What do you see?' I replied, 'I see a boiling caldron coming from the north and it is tilted towards this direction.' Then Yahweh said to me,"
,"14":"'From the north disaster will boil down on all the people of this land."
,"15":"I am calling all the kingdoms of the north - it is Yahweh who speaks. Each of them will come and encamp at the entrance of the gates of Jerusalem; against all its surrounding walls and against all the cities of Judah."
,"16":"I will pass judgment on my people because of the evil they do in forsaking me; they have burned incense to foreign gods and worshipped gods their hands have made."
,"17":"But you, get ready for action; stand up and say to them all that I command you. Be not scared of them or I will scare you in their presence!"
,"18":"See, I will make you a fortified city, a pillar of iron with walls of bronze, against all the nations, against the kings and princes of Judah, against the priests and the people of the land."
,"19":"They will fight against you but shall not overcome you, for I am with you to rescue you - it is Yahweh who speaks.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"A word of Yahweh came to me,"
,"2":"'Go and shout this in the hearing of Jerusalem. This is Yahweh's word: I remember your kindness as a youth, the love of your bridal days, when you followed me in the wilderness, through a land not sown."
,"3":"Israel was holy to Yahweh, the first-fruits of his harvest. All who ate of it had to pay,and misfortune fell on them -,it is Yahweh who speaks."
,"4":"Hear the word of Yahweh, people of Jacob, all you families of the nation of Israel."
,"5":"What wrong did your fathers find in me,that they strayed far from me?,Why did they pursue what is worthless,and become worthless themselves?"
,"6":"And they did not say: 'Where is Yahweh,who brought us out of Egypt,and led us in the wilderness, through a land of deserts and pits, a land of drought and darkness, a land still untrodden and without inhabitants?'"
,"7":"I brought you to a fertile land,to eat of the choicest fruit. As soon as you came you defiled my land,and dishonored my heritage!"
,"8":"The priests did not ask, 'Where is Yahweh?',The masters of my teaching did not know me; the pastors of my people betrayed me; the prophets followed worthless idols,and spoke in the name of Baal."
,"9":"Therefore I contend with you -,it is Yahweh who speaks -,and I will contend with the sons of your sons!"
,"10":"Cross to the coasts of Cyprus and see, or send to Kedar and observe with care,if there has ever been such a thing!"
,"11":"Has a nation exchanged its gods, false though they be?,But my people have exchanged their Glory,for what is worthless!"
,"12":"Be aghast at that, O heavens!,Shudder, be utterly appalled -,it is Yahweh who speaks -"
,"13":"for my people have done two evils: they have forsaken me, the fountain of living water, to dig for themselves leaking cisterns,that hold no water!"
,"14":"Did I make Israel a slave,or was he born in bondage?,How then did you become the spoil of others?"
,"15":"The lions have roared against you, loudly indeed have they roared, making your country a wasteland, your cities a ruins without inhabitants."
,"16":"Even the Egyptians of Memphis and Tahpanhes have humbled you!"
,"17":"Didn't you bring this on yourself,by forsaking Yahweh, your God, even as he led you in the way?"
,"18":"Now why call to Egypt?,Will the water of the Nile heal you?,And why go to Assyria?,What good will the water of the River do you?"
,"19":"Your own wickedness chastises you,and your own unfaithfulness punishes you!,Know, and see that it is bitter and evil,to forsake Yahweh your God,and no longer to fear me -,it is Yahweh, the God of hosts, who speaks!"
,"20":"It was long ago that you broke your yoke,and burst your bonds, saying: 'I will not serve!',On every high hill,and under every green tree,you played the harlot!"
,"21":"I planted you a choice vine, a shoot of wholesome stock; why have you become degenerate, a wild vine?"
,"22":"Even if you wash with soda,and use soap in abundance, the stain of your sin is always before me -,it is the Lord Yahweh who speaks."
,"23":"How do you dare say: 'I am not defiled, I have not gone after the Baals'?,See your footprints in the valley, admit what you have done, O restive young she-camel, running here and there."
,"24":"Wild ass of the desert, sniffing the wind in her desire, who can restrain her lust?,Those who pursue her, need not tire themselves, at mating time they will find her."
,"25":"Run if you wish, until your feet are sore, and your throat is dry!,But you say: 'It's no use, I love foreign gods, it is them I follow.'"
,"26":"As a thief is shamed when caught, so is the house of Israel, they, their kings, their princes, their priests and their prophets!"
,"27":"To a tree they say: 'You are my father!',and to a stone: 'You gave me birth!',For they have turned their back on me instead of their face!,In the day of misfortune,they will call me: 'Rise and save us!'"
,"28":"Where, then, are the gods of your own making?,Let them rise and save you if they can, in the time of your distress, for your gods, O Judah! are as many,as your cities."
,"29":"Why argue with me? You have all betrayed me - it is Yahweh who speaks."
,"30":"In vain did I strike your sons, they did not learn a lesson!,And your sword, like a destroying lion,devoured your prophets!"
,"31":"All you of this generation, hear what Yahweh says: Have I been a desert for Israel, a land of darkness?,Why do my people say: 'We will depart from you,and no more return to you'?"
,"32":"Does a virgin forget her ornaments, or a bride her sash?,But my people have forgotten me,for days without number!"
,"33":"How well you direct your steps in your search for lovers, even to walking along with crime!"
,"34":"Look at your garments,stained with the blood of the innocent poor, although you did not catch them breaking in!"
,"35":"I know you say: 'I am innocent. Why does his anger not turn away from me?',I will accuse you: Yes, you have sinned!"
,"36":"How lightly do you change your way!,You will be put to shame by Egypt as you were by Assyria."
,"37":"You will also leave that place with your hands on your head, for Yahweh has rejected those you trust, and they will not help you!"
}`)
	CurrentBook.AddChapter(3, `{
"1":"If a man divorces his wife and she leaves him and marries another man, should he come back to her? Wouldn't the land be totally polluted? But you, you are a harlot with many lovers, and you still have the nerve to return to me? - it is Yahweh who speaks."
,"2":"Lift your eyes to the hills and see: Where have you not been violated? By the wayside you sat waiting for your lovers, like an Arab in the wilderness, and you have dishonored the land with your evil and your harlotry!"
,"3":"The showers held back and there was no spring rain for you, yet you have a harlot's brow and refuse to be ashamed!"
,"4":"Worse still you called to me: 'Father, guide of my youth!"
,"5":"Will you always be angry? Will your wrath last forever?' That is what you said, and did evil as much as you were able to.'"
,"6":"During the reign of King Josiah, Yahweh said to me, 'Have you seen what faithless Israel has done? She has gone on every high hill and under every green tree and there played the harlot!"
,"7":"So I thought: After all this she will return to me; but she did not. Her perverse sister, Judah, saw"
,"8":"that for all the adulteries of that unfaithful Israel, I sent her away with a certificate of divorce. Yet I saw that the disloyal Judah had no fear and that she too went and played the harlot!"
,"9":"Because of her harlotry, she dishonored the land, sinning with stones and trees."
,"10":"And even after that her sister, the unfaithful Judah, did not come to me wholeheartedly. It was only pretense. It is Yahweh who speaks.'"
,"11":"And Yahweh continued, 'Rebellious Israel has been less guilty than false Judah."
,"12":"Go and shout this message to the north: Come back, unfaithful Israel - it is Yahweh who speaks - I will not let my anger fall on you for I am merciful, I will not be angry forever."
,"13":"Simply confess your guilt; you have rebelled against Yahweh your God, and have scattered your favors among strangers under every green tree, and you have not obeyed my voice - it is the word of Yahweh."
,"14":"Come back, faithless people - it is Yahweh who speaks - for I am your master. I will select one from a city and two from a family and bring you to Zion."
,"15":"Then I will give you shepherds after my own heart, who will feed you with knowledge and prudence."
,"16":"And when you have increased and multiplied in the land in those days - it is Yahweh who speaks - people will no longer speak of the ark of the covenant of Yahweh; it will not be remembered or missed, nor shall it be made again!"
,"17":"Then they will call Jerusalem 'The Throne of Yahweh' and all the nations will gather there to honor the name of Yahweh and no longer will they follow the stubbornness of their wicked hearts."
,"18":"In those days the people of Judah will unite with the people of Israel and together they will return from the north to the land that I gave to their ancestors as a heritage."
,"19":"And I thought: How gladly would I have placed you among my children and given you as your inheritance a beautiful land, the most splendid among all the nations! And I thought you would call me 'my father' and not turn from following me!"
,"20":"But, like a woman unfaithful to her husband, you have been unfaithful to me, O people of Israel! - it is Yahweh who speaks.'"
,"21":"A cry is heard in the barren heights, the weeping and pleading of the children of Israel, because they have perverted their way and have forgotten Yahweh their God!"
,"22":"'Come back, unfaithful people, I will heal you of your rebelliousness!','Yes, we come to you, for you are Yahweh our God!"
,"23":"Truly the temples on the heights and the feasts on the hills are useless; only Yahweh our God can save Israel."
,"24":"The infamous god has devoured all the fruits of our forefathers' labor since our youth, their flocks and their herds, their sons and their daughters."
,"25":"Let us lie down in our shame and let our confusion cover us, for it is against Yahweh our God that we have sinned from our youth until this day, we and our fathers, and we have not obeyed the voice of Yahweh our God!'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"'If you return to me, O Israel - it is Yahweh who speaks - if you convert to me and remove your dirty idols from my sight you will have no need to hide from me;"
,"2":"if you truthfully, justly and honestly swear by Yahweh's life, then you will be a blessing for all nations, and you will be their glory.'"
,"3":"For thus says Yahweh to the people of Judah and Jerusalem, 'Break up deeply your fallow land and do not sow among the thorns."
,"4":"O men of Judah and Jerusalem! circumcise yourselves for Yahweh and purify your hearts, lest my wrath spread like a fire that cannot be quenched because of your evil deeds.'"
,"5":"Announce this in Judah, proclaim it in Jerusalem. Sound the trumpet through the land; shout aloud and say: 'Assemble and go to the fortified cities!"
,"6":"Raise a banner towards Zion!,Run for your lives, do not tarry, for I will bring evil and great destruction from the north."
,"7":"The lion has come out of his den; the destroyer of nations has set out to devastate your country and make your cities ruins without inhabitants!"
,"8":"Because of this, wrap yourselves in sackcloth; lament and groan, for the fury of Yahweh's anger has not turned away from us."
,"9":"On that day - it is Yahweh who speaks - the king and the leaders will be discouraged, the priests will be terrified and the prophets will be astounded."
,"10":"People will say, 'Ah! Lord Yahweh, you have truly deceived this people and Jerusalem, saying: 'You will have peace' even as the sword is at our throat.'"
,"11":"When the time comes it will be said to the people of Jerusalem: 'Wearing wind from the desert heights is coming to the daughter of my people, neither to winnow nor to cleanse!"
,"12":"A strong wind comes from there. Now I will declare my judgments against them.'"
,"13":"See! Someone comes like the clouds, his chariots are like a whirlwind, his horses swifter than eagles!,Woe to us for we are ruined!"
,"14":"Cleanse your heart of every evil, Jerusalem, that you may be saved! How long will you harbor evil plans within you?"
,"15":"A voice from Dan declares of a coming disaster from Mount Ephraim! 'Warn the nations."
,"16":"Let everyone know in Jerusalem and Judah that enemies are coming from a distant land.'"
,"17":"They encircle Jerusalem like men guarding a field, because she has rebelled against me - it is Yahweh who speaks."
,"18":"Your own conduct and actions have brought this upon you. How bitter is your punishment and how it deeply penetrates your heart because you have rebelled against me!'"
,"19":"I am in anguish! I tremble in the depths of my being; my heart beats wildly. I cannot remain silent for I hear the sound of the trumpet and the clamor of war!"
,"20":"Disaster after disaster; all the land is laid waste; my tents are suddenly destroyed and in an instant all that shelters me is wiped out."
,"21":"For how long must I see the banner raised and hear the sound of the trumpet?"
,"22":"'This happens because my people are foolish and do not know me. They are senseless and have no understanding, - wise in doing evil but stupid in doing good!'"
,"23":"I looked at the earth and I found it formless and void; I looked at the sky but darkness engulfed it."
,"24":"I looked at the mountains and they were quaking, and all the hills were swaying to and fro."
,"25":"I looked and saw that it was a no-man's land; even the birds deserted the skies."
,"26":"I looked and saw that the fruitful land was a desert and that all the cities were in ruins because of Yahweh and his fierce anger."
,"27":"Yahweh says, 'The whole land may be desolate but I will not totally destroy it!"
,"28":"Because of this the earth shall mourn and the skies be darkened: I have declared my purpose and will not relent; I have made up my mind and will not change it.'"
,"29":"At the sound of the horsemen and,archers every town takes flight; some go to the thickets,and climb among the rocks. All the towns are deserted,and no one is left."
,"30":"And you, desolate one, what will you do?,Even if you are garbed in scarlet,and wear jewels of gold,and put make-up on your eyes, in vain do you beautify yourself, for your lovers despise you,and are ready to take your life."
,"31":"I hear a cry as of a woman in labor, anguish as of one giving birth the first time. It is the cry of the daughter of Zion, gasping for breath with hands outstretched: 'Woe is me! I am fainting amidst a band of murderers!'"
}`)
	CurrentBook.AddChapter(5, `{
"1":"'Go through the streets of Jerusalem; observe carefully and take note. Search the entire city squares and find, if you can, even one man who acts justly and seeks the truth, that I may forgive this city.'"
,"2":"Even though they swear, 'As surely as Yahweh lives' they do not mean what they say."
,"3":"O Yahweh, are you not looking for truth? You struck them but they did not feel it; you crushed them but they rejected correction. They set their faces harder than a rock and refused to repent."
,"4":"Then I thought: 'Such are the poor, they act foolishly because they do not know the way of Yahweh, the law of their God!"
,"5":"So I will go to the well-to-do and speak to them for they know the way of Yahweh and the law of their God.' But they, too, have broken their yoke and burst their bonds!"
,"6":"That is why the lion from the forest will slay them and the wolf from the desert will destroy them, while the leopard lurks around their cities. Anyone who comes out is torn to pieces, for great is their sin and many are their desertions!"
,"7":"'Why should I pardon you? Your sons have rejected me and sworn by false gods. I gave them all they needed and yet they committed adultery and trooped to the harlot's house. They are well-fed,"
,"8":"lusty stallions, each one neighing for his neighbor's wife."
,"9":"Shall I not call them to account - it is Yahweh who speaks - shall I not take vengeance against a nation like this?"
,"10":"Go up, nations, through her vineyards and ravage them, but do not entirely destroy my vine. Cut off her branches for they are not Yahweh's."
,"11":"For the people of Israel and Judah have been utterly unfaithful to me - it is Yahweh who speaks."
,"12":"They have spoken falsely of Yahweh, saying, 'He does not exist; no harm will happen to us; we shall see neither the sword nor famine!"
,"13":"As for the prophets, they are but wind. God doesn't speak to them.'"
,"14":"Because of this, Yahweh the God of hosts has spoken, 'This is what I am going to do to them: I will put words in your mouth. They will be like a fire, and this people will be the wood it devours.'"
,"15":"People of Israel! I will bring against you a nation from afar - it is Yahweh who speaks - whose language you do not understand."
,"16":"All of them are mighty warriors."
,"17":"They will devour your harvest and your food, devour your sons and daughters, devour your flocks and herds, devour your vines and your fig trees. They will devastate with the sword,the fortified cities in which you trust."
,"18":"But even in those days - it is Yahweh who speaks - I will not utterly destroy them."
,"19":"And when they ask, 'Why has Yahweh our God done all this to us?' you shall say to them, 'Just as you have forsaken me and served foreign gods in your land, so shall you serve strangers in a land that is not your own.'"
,"20":"Declare this to the people of Jacob and make it known in Judah,"
,"21":"listen, stupid and senseless people!,who have eyes and do not see, who have ears and do not hear!"
,"22":"Do you not fear me? -,it is Yahweh who speaks -,Will you not tremble before me?,I set the sand as a limit to the sea, an everlasting barrier it may never pass; its waves toss but cannot prevail; they roar but are unable to go beyond it."
,"23":"But this people's heart is rebellious and stubborn; they have turned aside and gone away!"
,"24":"They do not say in their hearts, 'Let us fear Yahweh our God who sends in season the rain, and has in store for us the harvest.'"
,"25":"Your crimes have turned order into chaos, your sins have deprived you of these blessings,"
,"26":"for among my people are wicked men; they set traps like fowlers and catch human beings."
,"27":"Their houses are filled with loot, like a cage full of birds. It has turned them rich and powerful;"
,"28":"they have become fat and sleek. Great is their wickedness; there is no justice in their judgment, for they do not protect the orphan's rights nor defend the needy's cause!"
,"29":"Should I not severely punish them for such things? - it is Yahweh who speaks - Should I not exact vengeance against a people like them?"
,"30":"A terrible and abominable thing has happened in the land,"
,"31":"prophets prophesy lies and priests teach what pleases them, and my people like it to be so. But what will you do soon?"
}`)
	CurrentBook.AddChapter(6, `{
"1":"People of Benjamin! Seek safety beyond Jerusalem. Sound the trumpet in Tekoa, raise a signal in Beth-hacherem, for misfortune pours out from the north: it will be a huge disaster."
,"2":"Shall I not compare you, daughter of Zion, to a beautiful pasture?"
,"3":"Shepherds with their flocks are coming to her, they pitch their tents and feed their flocks all over her."
,"4":"Declare a holy war against her, attack her at noontime. Woe to us! For the day declines; the evening shadows lengthen!"
,"5":"Rise up! We shall attack by night,and destroy her palaces!"
,"6":"For Yahweh of hosts has spoken: 'Cut down trees and build a siege-ramp against Jerusalem. This city must be punished for all in her is oppression."
,"7":"Evil springs from her as water from a well. Violence and opression are heard in the city, suffering and cruelty are always before me."
,"8":"Take warning, Jerusalem, lest I turn away from you and make you a desolation, a no-man's land.'"
,"9":"Yahweh of hosts further said, 'You shall glean thoroughly as a vine, what is left of Israel. You shall do what the grape-gatherer does when his hand goes over the branches again.'"
,"10":"To whom shall I speak, whom shall I warn? No one of them wants to listen, that they may understand. Their ears are stuffed and they pay no attention. They scorn what Yahweh says and refuse to listen."
,"11":"The anger of Yahweh has filled me and I can bear it no longer!,'Then pour it out on the children in the street and on the gathering of young men; both husband and wife will be caught, both the elderly and those who are not of age."
,"12":"Their houses will be passed to others, together with their fields and their wives, when I stretch out my hand and strike the people of the land - it is Yahweh who speaks."
,"13":"All of them - from the least to the greatest - are greedy for gain; prophet and priest alike are deceitful."
,"14":"They treat lightly the disaster of my people saying, 'Peace, peace,' when there is no peace."
,"15":"They should be ashamed of their abominable deeds. But they have no shame and don't even know how to blush. Surely they shall fall with those who will fall; when I ask them to account they will stumble - it is Yahweh who speaks."
,"16":"This is what Yahweh says, 'Stand in the roads and look. Ask for the ancient paths and know where the good way is. Walk on it and experience peace for yourselves.' But you said, 'We will not take it.'"
,"17":"Then Yahweh set watchmen over you: 'Pay attention to the sound of the horn!' But you said, 'We will not listen.'"
,"18":"Listen nations; know what will befall them!"
,"19":"Listen earth! I am bringing disaster on this people! It is the fruit of their rebellion, because they ignored my words and despised my Law."
,"20":"The incense from Sheba is useless for me, don't bring me the fragrant cane from a distant land. Your burnt offerings are not acceptable to me nor do I find your sacrifices pleasing.'"
,"21":"This is what Yahweh says, 'I will place stumbling blocks before this people to make them stumble, parents and children, neighbors and friends together.'"
,"22":"It is Yahweh who speaks, 'See, a people comes from the north, a powerful nation from the ends of the earth."
,"23":"Armed with bow and spear they are cruel and merciless. Their voice roars like the roaring sea. Mounted on horses, in battle formation they come as a fire, against you, daughter of Zion.'"
,"24":"When we heard this our hands went limp, anguish seized us like the birthpangs of a woman."
,"25":"'Let us not go to the fields or onto the roads, for the enemy's sword brings terror on every side.'"
,"26":"O my people! Wrap yourself in sackcloth and roll in ashes; mourn with bitter lament as for an only child, for the destroyer is coming against us."
,"27":"'I have appointed you as an examiner among my people, that you may see and appreciate their ways.'"
,"28":"They are all rebels and slanderers. They are like bronze and iron and all are corrupt."
,"29":"The bellows blow to burn away the lead with fire, but the smelter works in vain for the evil elements remain."
,"30":"They will be called 'worthless silver' for Yahweh has rejected them."
}`)
	CurrentBook.AddChapter(7, `{
"1":"These words were spoken by Yahweh, to Jeremiah,"
,"2":"'Stand at the gate of Yahweh's house and proclaim this in a loud voice: Listen to what Yahweh says, all you people of Judah (who enter these gates to worship Yahweh)."
,"3":"Yahweh the God of Israel says this: Amend your ways and your deeds and I will stay with you in this place."
,"4":"Rely not on empty words such as: 'Look, the Temple of Yahweh! the Temple of Yahweh! This is the Temple of Yahweh!'"
,"5":"It is far better for you to amend your ways and act justly with all."
,"6":"Do not abuse the stranger, orphan or widow or shed innocent blood in this place or follow false gods to your own ruin."
,"7":"Then I will stay with you in this place, in the land I gave to your forefathers in times past and forever."
,"8":"But you trust in deceptive and useless words."
,"9":"You steal, kill, take the wife of your neighbor; you swear falsely, worship Baal and follow foreign gods who are not yours."
,"10":"Then, after doing all these horrible things, you come and stand before me in this temple that bears my Name and say, 'Now we are safe.'"
,"11":"Is this house on which rests my Name a den of thieves? I have seen this myself - it is Yahweh who speaks."
,"12":"Go to the sanctuary at Shiloh in Israel, where I first let my Name rest, and see what I did to that place because of the wickedness of my people Israel."
,"13":"You have done all this and have not listened when I repeatedly warned you; neither have you answered when I called you."
,"14":"What I did in Shiloh, I will likewise do to this temple on which rests my Name, this sacred place in which you trust and which I have given to you and to your forefathers."
,"15":"As for you, I will drive you out of my sight, just as I cast away all your kinsmen in the north, the entire race of Ephraim."
,"16":"Do not plead for this people. Make no prayer or supplication for them; do not press me on their behalf because I will not listen to you."
,"17":"Don't you see what they do in the cities of Judah and in the streets of Jerusalem?"
,"18":"The children gather wood and the fathers light fire. The women knead dough to make cakes for the Queen of Heaven and pour out drink offerings for foreign gods."
,"19":"They do this to belittle me. But is it me they belittle? asks Yahweh. No, they belittle themselves to their own confusion."
,"20":"Because of this Yahweh has spoken, 'The fury of my anger will be poured out on this place, both on man and beast, on the trees in the fields and on the produce of the earth; it will burn and not be extinguished.'"
,"21":"This is what Yahweh of hosts, says to you, 'Add your burnt offerings to your sacrifices and eat the flesh."
,"22":"When I brought your forefathers out of Egypt I did not give them mandate regarding sacrifices and burnt offerings."
,"23":"One thing I did command them: Listen to my voice and I will be your God and you will be my people. Walk in the way I command you and all will be well with you."
,"24":"But they did not listen and paid no attention; they followed the bad habits of their stubborn heart and turned away from me."
,"25":"From the time I brought their forefathers out of Egypt until this day I have continually sent them my servants, the prophets,"
,"26":"but this stiff-necked people did not listen. They paid no attention and were worse than their forefathers."
,"27":"You may say all these things to them but they will not listen; you will call them but they will not answer."
,"28":"This is a nation that did not obey Yahweh and refused to be disciplined; truth has perished and is no longer heard from their lips."
,"29":"Cut off your hair and throw it away. Intone a lament on the bare heights, for Yahweh has rejected and foresaken these people.' This is Yahweh's word."
,"30":"The people of Judah have done what disgusts me; they have placed their idols in the sanctuary that houses my Name and defiled it."
,"31":"They have built the temple of Topheth in the valley of Hinnom where they burn their sons and daughters, something I never commanded or even thought of."
,"32":"Hence the time will come when it will no longer be called Topheth or the valley of Hinnom, but rather the valley of Slaughter, for they will bury the dead in Topheth for lack of space elsewhere."
,"33":"And the corpses of this people will be eaten by birds and animals; and none will scare them away."
,"34":"In the cities of Judah and the streets of Jerusalem I will bring to an end all expressions of joy and happiness, the songs of the bride and bridegroom, for the land will become a wilderness."
}`)
	CurrentBook.AddChapter(8, `{
"1":"When that time comes - it is Yahweh who speaks - they will bring from the tombs the bones of the kings of Judah, the bones of their leaders, priests, prophets and of the inhabitants of Jerusalem."
,"2":"They will expose them to the Sun and Moon and all the gods of the skies, because they have loved and served them, and they have followed and worshiped them. These bones will not be gathered up to be replaced in tombs but will remain like dung on the ground."
,"3":"Death will be preferable to life for the survivors of this perverse race who remain in places to which I have driven them."
,"4":"This is what Yahweh told me, 'You will say to them: Doesn't the one who falls get up and the one who goes away return?"
,"5":"Why then has this people turned away in stubborn rebellion? They make a habit of deceit and refuse to repent."
,"6":"I listened attentively; they did not speak truthfully nor did they repent of their wickedness. No one says: 'What have I done!' They all follow their own course like horses plunging into battle."
,"7":"Even the stork in the sky knows her times; the dove, the swallow and the crane know the time to return, but my people do not know the ordinances of Yahweh."
,"8":"How dare you say: 'We are wise and the Law of Yahweh is with us' when the deceiving pen of the scribe has turned it into a lie?"
,"9":"The wise will be put to shame; they shall be dismayed and trapped. Since they have despised the word of Yahweh, what then is left as the basis of their wisdom?"
,"10":"That is why I will give their wives to other men, their fields to conquerors, for all of them, the smallest to the greatest, are greedy for gain. All, from the prophet to the priest, practice deceit."
,"11":"They treat lightly the wound of my people saying 'Peace, peace!' when there is no peace."
,"12":"They should be ashamed of their aborminable deeds. They have no shame and don't even know how to blush. Surely they shall fall along with those who will fall; for I will ask them to account and they will stumble."
,"13":"I will make an end of them - it is Yahweh who speaks - for the vine yields no grapes, the fig tree no figs, even the leaves are withered. I will hand them over to the passersby.'"
,"14":"'Why do we sit still? Get up! We shall go to the fortified cities to perish there. See, Yahweh our God wants us to die and gives us poisoned water, because we have sinned against him."
,"15":"We hoped for peace and we see nothing good! for a time of healing, but terror came!"
,"16":"From Dan we hear the snorting of his horses; at the sound of the neighing of his stallions the whole earth trembles.',- 'They are coming to devour the land and all it contains, the city and all who dwell in it."
,"17":"For I am letting loose against you snakes and adders that cannot be charmed, and they will bite you.'"
,"18":"Sorrow takes hold of me, my heart fails me."
,"19":"The pleading of the daughter of my people is heard all over the land: Has Yahweh abandoned Zion? Is her king no longer there? -'Why have they provoked me with their images, with their foreign gods?'"
,"20":"The harvest is over, the summer is past and we have not been saved."
,"21":"I am brokenhearted because of my people's misfortune. I am crushed and dismayed."
,"22":"Is there no balm in Gilead? Is there no healer there? Why is no remedy given to my people?"
,"23":"I would that my head were a well of water and my eyes a fountain of tears to weep day and night for the slain of my people."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Who will give me a lodging, in the desert, that I may leave my people,and go far from them?,For they are all adulterers, a band of traitors."
,"2":"They bend their tongue like bows. Deceit and not truth prevail in the land. They commit one crime after another,and do not know me."
,"3":"Each one is suspicious of his friend,and no one trusts his brother, brother deceives brother, friend slanders friend."
,"4":"They deceive each other; no one speaks the truth. Their tongues are addicted to lying; they are perverse and too hardened to repent."
,"5":"They live amidst deceitfulness,and deceitfulness prevents them from knowing me."
,"6":"That is why - word of Yahweh God of hosts -,I will refine and test them, for what else can I do for my people?"
,"7":"Their tongues are like deadly arrows, uttering deceitful words. With their friend they speak of peace,but in their heart they set a trap for him."
,"8":"Isn't it reason enough for me to punish them?,Shall I not avenge myself on such a nation?"
,"9":"On the mountains there will be weeping and wailing, and on the prairies of the wilderness a dirge, because they have been burnt and deserted, and the sound of flock is heard no more. The birds of the sky and the beasts have all fled and are gone."
,"10":"I will make Jerusalem a heap of ruins, a den of jackals. I will make the cities of Judah a wasteland without inhabitants.'"
,"11":"Who is wise enough to understand these events? And who is the one Yahweh has chosen to reveal them? Why has the land perished and been laid waste like a desert where no one passes?"
,"12":"Yahweh answered, 'It is because they have forsaken the Law that I gave them. They have not listened to me"
,"13":"but in the stubbornness of their heart they have followed the Baals as they were instructed by their fathers.'"
,"14":"That is why Yahweh, the God of hosts and the God of Israel says, 'I will make this people eat bitter food and I will give them poisoned water."
,"15":"I will scatter them among nations that neither they nor their fathers knew and I will send the sword after them until I have finished with them.'"
,"16":"Listen! Call for the wailing women to come, send for the most skillful!"
,"17":"Let them hasten to intone a funeral song, and let us weep, our eyes running with tears."
,"18":"The sound of wailing is heard in Zion. A terrible disaster has befallen us!,How great our shame to leave the land, to see our homes broken down!"
,"19":"You women, take heed of what Yahweh says, let your ears pay attention to his words. Teach this lament to your daughters,and each of them to their friends:"
,"20":"'Death has come through our windows and invaded our palaces, cutting down the children in the street,and young men in the squares!"
,"21":"The corpes are scattered in the fields like dung; like sheaves cut by the reaper,with no one to gather them!'"
,"22":"It is Yahweh who speaks: 'Let not the wise boast of his wisdom, nor the valiant of his valor,nor the wealthy of his wealth!"
,"23":"But if someone wants to boast, let him boast of this: of understanding and knowing me. I am Yahweh, the merciful; I implement justice,and rule the world with righteousness. 'For in these things I delight,',- this is Yahweh's word."
,"24":"'The time is coming,' Yahweh says, 'when I will ask to account both those who are circumcised and those who are not:"
,"25":"Egypt, Juda, the Amonites and the Moabites with all the Arabs of the desert, for all these nations are not circumcised, and the people of Israel are not circumcised in their heart.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Hear the word which Yahweh speaks to you, people of Israel,"
,"2":"'Do not follow the way of the foreign nations and do not fear signs in the sky as they do. The Awesome God of these nations is but nothing."
,"3":"It is only wood cut from a tree in the forest and shaped by a craftsman's chisel."
,"4":"They adorn it with silver from Tarshish and gold from Ophir and then fasten it with hammer and nails to keep it from falling."
,"5":"Their idols are like scarecrows in a cucumber field; they cannot speak. They have to be carried because they cannot walk. Have no fear of them; they can do neither harm nor good.'"
,"6":"No one equals you, Yahweh, you are great. Power is yours, and great is your Name!"
,"7":"Who would not fear you, King of nations?,You are to be feared, for among the wise of the nations,and in all their kingdoms,no one equals you."
,"8":"They are all brutish and stupid; their idols are proof of their foolishness."
,"10":"But Yahweh is the true God, the living God and eternal King. His anger makes the earth quake; the nations cannot endure his fury."
,"11":"You will say this to them, 'The gods who did not make either the heavens or the earth shall disappear from the earth and from under the heavens.'"
,"12":"By his power he made the earth, by his wisdom he established the world; by his understanding he extended the heavens."
,"13":"When he raises his voice,the waters pile up in the heavens. He calls the clouds from the ends of the earth; he sends lightning with the rain and from his storehouse sends out the wind."
,"14":"At this all men feel stupid and without knowledge. Every goldsmith is ashamed of his idol which is a fraud without breath."
,"15":"They are worthless, ridiculous objects; they shall perish when the time of retribution comes."
,"16":"He instead has formed the universe and Israel as well, the tribe of his inheritance, for he is the portion of Jacob: Yahweh, God of hosts is his name."
,"17":"Gather up your belongings and leave the land, you who are the victims of siege,"
,"18":"for thus says Yahweh, 'I am hurling far away the inhabitants of this land, and I will let them be pursued and captured.'"
,"19":"Woe is me! What suffering!,My wound is incurable!,But I shall say; 'Mine is this illness, I must bear it.'"
,"20":"My tent is destroyed, all its cords are snapped. My children have left me and are no more; no one is left to pitch my tent,or to set my shelter up."
,"21":"For the pastors have become senseless and have not consulted Yahweh; they have not prospered,and all their flocks are scattered."
,"22":"Heed the news! Pay attention!,A great commotion is heard from the north; they are coming to make the cities of Judah a desolate land, a den of jackals."
,"23":"You know, Yahweh, that man's life is not within his own control and it is not for him to direct his steps!"
,"24":"Correct us, Yahweh, with prudence, not in anger, lest you destroy us completely."
,"25":"Put out your anger on the nations that do not know you, on the people who do not call on your Name. For they have devoured Jacob and consumed him thoroughly; his homeland is already laid waste."
}`)
	CurrentBook.AddChapter(11, `{
"1":"This is the word that came to Jeremiah from Yahweh:"
,"2":"Say to the men of Jerusalem:"
,"3":"Cursed be the man who does not heed the terms of this covenant"
,"4":"which I ordained for your fathers the day I freed them from that cleansing furnace that Egypt is. I said to them: 'If you obey my voice and do all that I command you, you will be my people and I will be your God."
,"5":"Then I will fulfill the promise I swore to your fathers, to give you a land flowing with milk and honey,' (as it is today).',I replied, 'Amen, Yahweh.'"
,"6":"Yahweh said to me, 'Publish what I say in the cities of Judah and the streets of Jerusalem, 'Hear the terms of this covenant and keep them."
,"7":"When I brought your forefathers out of Egypt, I solemnly warned them and have continued to tell them: 'Obey me.'"
,"8":"But they did not listen to me or heed what I said; each one followed his own stubborn heart. So I fulfilled against them all the words of this covenant that I had commanded them, but which they did not follow.'"
,"9":"Yahweh said to me, 'There is a conspiracy among the men of Judah and the inhabitants of Jerusalem."
,"10":"They have returned to the sins of their forefathers who refused to obey me; they have followed and served foreign gods. The nation of Israel and the nation of Judah have broken the covenant I made with their fathers.'"
,"11":"That is why Yahweh says to you, 'I will bring upon them a disaster from which there will be no escape. When they cry to me I will not listen."
,"12":"Then the cities of Judah and the people of Jerusalem will go crying to the gods they worship, but these will not help them in the time of misfortune."
,"13":"For you, Judah, have as many gods as there are cities; as numerous as the streets in Jerusalem are the altars you have raised to Baal.'"
,"14":"For your part, do not intercede for this people, nor offer a plea or petition because I will not listen when they cry to me in the time of their distress."
,"15":"What is my beloved doing in my House?,She is plotting evil deeds. Will your vows and the meat of your,victims cleanse you from your wickedness and allow you to rejoice?,Yahweh had called you"
,"16":"'Beautiful Green Olive Tree -,fair and fruitful!',But with the roar of a storm, its foliage took fire,and its branches were broken."
,"17":"And Yahweh, God of host, who planted you, has condemned to shame. Indeed the nation of the Israel and the nation of Jacob harmed themselves when they worshiped Baal and aroused my anger."
,"18":"Yahweh made it known to me and so I know! And you let me see their scheming: (126) 'Take care, even your own brothers and family are false with you and behind your back they freely criticize you. Do not trust them when they approach you in a friendly way.'"
,"19":"But I was like a gentle lamb led to the slaughter. I did not know it was against me that they were plotting, 'Let us feed him with trials and remove him from the land of the living and let his name never be mentioned again.'"
,"20":"Yahweh, God of hosts, you who judge with justice and know everyone in his heart and in his intentions, let me see your vengeance on them, for to you I have entrusted my cause."
,"21":"This is what Yahweh has to say against the people of Anathoth who threatened me with death and said, 'Do not prophesy any more in the name of Yahweh and we will spare your life.'"
,"22":"Yahweh says to them, 'This is how I will punish you: the young men shall die by the sword; their sons and daughters shall die of hunger."
,"23":"No one will survive when I bring disaster on the people of Anathoth in the year of their punishment.'"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Yahweh, you are always right,when I complain to you; nevertheless, where is your justice?,Why do the wicked prosper?,And why do traitors live in peace?"
,"2":"You plant them and they take root; they grow and are fruitful; they honor you with words,but their heart is far from you."
,"3":"But you, Yahweh, you know me and see me; you search my heart - it is close to you. Send them off like sheep to be butchered; put them aside for the day of slaughter."
,"4":"How long will the land be in mourning,and the grass of the fields remain withered?,The birds and the beasts have perished,because of the wickedness of the inhabitants, for they say: 'God does not see what we do.'"
,"5":"'If you tire when running with those on foot, how can you compete with horses?,If you do not feel secure in a peaceful land, what will you do in the thickets of the Jordan?'"
,"7":"I have abandoned my house, I have given up my own people; I have given over those I most cherished into the hands of their enemies."
,"8":"My own have been for me like a lion in the forest; they have roared against me - now I hate them."
,"9":"My own have become for me like a bird of prey. Let all the birds of prey attack them. Come here, all you wild beasts and devour them!"
,"10":"Many shepherds have ravaged my vine; they have trampled my beloved field,and made it a desolate wasteland,"
,"11":"parched and mournful in my sight. But no one cares!"
,"12":"To every height in the desert destroyers have come, for Yahweh has a devouring sword. It reaches from one end of the land to the other; no one is safe!"
,"13":"They have sown grain and reaped thorns; they have toiled for nothing. Your harvests bring shame on you because of Yahweh's anger."
,"14":"Yahweh declares, 'Because all my wicked neighbors have laid hands on the land I gave my people Israel, I will uproot them from their own land, and I will uproot the people of Judah from among them."
,"15":"But after I have done this, I will have compassion on them and bring them back to their possession, each one to his own land."
,"16":"If then they learn the ways I taught my people and call upon my name when taking an oath, they who once taught my people to swear by Baal, may settle among my people."
,"17":"But if then any nation does not obey me, I will uproot and destroy it - it is Yahweh who speaks.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"This is what Yahweh said to me: 'Go! Buy yourself a linen belt and put it around your waist; do not put it in water.'"
,"2":"So I bought the belt as Yahweh ordered and put it around my waist."
,"3":"The word of Yahweh came to me a second time,"
,"4":"'Take the belt you bought, the one you put around your waist, and go to the torrent Perah; hide it there in a hole in the rock.'"
,"5":"I went and hid it as Yahweh instructed me."
,"6":"After many days Yahweh said to me, 'Go to the torrent Perah and get the belt I ordered you to hide there.'"
,"7":"I went to the torrent and dug up the belt but it was ruined and good for nothing,"
,"8":"and Yahweh said to me,"
,"9":"'In this way I will destroy the pride and great glory of Judah,"
,"10":"this wicked people who refuse to heed what I say, this stubborn people who go after other gods to serve and worship them. And they shall become like this belt which is now good for nothing."
,"11":"For just as a belt is to be bound around a man's waist so was the people of Israel and Judah bound to me - it is Yahweh who speaks - to be my people, my glory and my honor; but they would not listen."
,"12":"You will say to them this word of Yahweh the God of Israel, 'Every pitcher should be filled with wine.' And they will say: 'Don't we know that a pitcher should be filled with wine?'"
,"13":"You will reply, 'You are the pitchers that Yahweh will fill until you are drunk. I am going to fill with drunkenness all who live in this land - kings who succeed David, the priests, the prophets and all who live in Jerusalem."
,"14":"I will dash them one against another, father and sons together. I will have neither compassion nor mercy: I am going to destroy them.'"
,"15":"Hear and pay attention; do not be proud, for Yahweh has spoken!"
,"16":"Give glory to Yahweh your God before he brings darkness, and your feet stumble in the darkening hills. You were hoping for light, but he will turn it into the darkness of death and deep gloom!"
,"17":"If you do not heed this warning I will weep in secret because of your pride and I will shed tears when Yahweh's flock has been taken captive."
,"18":"Say to the king and the queen mother, 'Humble yourselves, for the crown of glory,has fallen from your head."
,"19":"The cities of the Negeb have been shut and no one comes to open them, all Judah is deported, completely carried off.'"
,"20":"Look up Jerusalem and see those who come from the north. Where is the flock that was entrusted to you and where are your beautiful sheep?"
,"21":"What will you say when those you let take liberties with you come back to oppress you?,Won't your pain be like that of a woman giving birth?"
,"22":"And if you ask yourself, 'Why has all this disgrace fallen on me?' It is because of your great wickedness that they have torn away your clothes and dealt violently with you."
,"23":"Can an Ethiopian change his skin or a leopard his spots? And can you do good, you who are accustomed to doing evil?"
,"24":"I will scatter you like straw blown by the desert wind;"
,"25":"that is your reward - it is Yahweh who speaks - because you have forgotten me and trusted in Falsehood."
,"26":"I myself will pull your skirts over your face and your shame shall be seen."
,"27":"Your adultery, your neighing, your brazen prostitution, all this abomination I have seen on the hills and in the fields. Woe to you Jerusalem! When at last will you be cleansed?'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"The word of Yahweh concerning drought came to Jeremiah:"
,"2":"Judah mourns, the cities languish, desolate, they sink to the ground. From Jerusalem a cry is heard."
,"3":"The rich sent the poor for water, but they found none at the cisterns, and returned with empty vessels."
,"4":"The soil is cracked,because there is no rain in the land; the farmers are dismayed,and have covered their heads like mourners."
,"5":"Even the doe in the fields,abandons her newborn calf,because there is no pasture."
,"6":"The wild donkeys stand on the heights,sniffing the air like jackals,and languish as they find not even a thistle!"
,"7":"Even if our faults accuse us, you Yahweh, work for the glory of your Name. In truth, many have been our rebellions,and great is our sin against you."
,"8":"O Yahweh! Hope of Israel, you who save in the time of distress, why are you as a stranger in this land, or like a traveler who stays only a night?"
,"9":"Why should you be as if bewildered, like a warrior unable to save?,But you are in our midst Yahweh, and on us your Name has been invoked. Do not abandon us!"
,"10":"This is what Yahweh says about this people, 'They like to wander here and there, not stopping for a moment, so Yahweh takes no pleasure in them; he remembers their wickedness and will punish their sins.'"
,"11":"And Yahweh said, 'Do not pray for the well-being of this people!"
,"12":"If they fast I will not listen to their cry; if they offer me burnt offerings and oblations, I will not accept them. Instead I am going to make an end of them with sword, famine and plague.'"
,"13":"And I said, 'Ah, Lord Yahweh! You know what the prophets are saying to them: 'You will not see the sword nor suffer famine for I will give you true peace in this place.''"
,"14":"But Yahweh said, 'These prophets have proclaimed untruths in my name. I did not send them, nor did I command them or speak to them. False visions, worthless divinations and delusions of their own imagination - that is what they prophesy.'"
,"15":"And Yahweh added, 'These prophets whom I did not send and who prophesy in my name, saying that the sword and famine will not touch this land - these same prophets will perish by the sword and famine."
,"16":"As for the people listening to them, their corpses will be thrown into the streets of Jerusalem. There will be no one to bury them or their wives, their sons or daughters, when they die of famine and by the sword. For I shall make their own malice fall upon them."
,"17":"This you will say to them: Let my eyes shed tears night and day without ceasing! For with a great wound has the virgin daughter of my people been wounded, a most grievous wound."
,"18":"If I go into the country, I see those slain by the sword. If I enter the city I see the ravages of famine. For the prophet and the priest did not understand what was happening in the land.'"
,"19":"Have you then rejected Judah forever? Do you abhor Zion? Why have you wounded us and left us with no hope of recovery?,We hoped for salvation but received nothing good; we waited for healing, but terror came!"
,"20":"Yahweh, we know our wickedness and that of our fathers, and the times we have sinned against you."
,"21":"For your name's sake do not despise us; do not dishonor the throne of your glory. Remember us. Do not break your covenant with us!"
,"22":"Among the worthless idols of the nations, are there any who can bring rain, or make the skies send showers?,Only in you, Yahweh our God, do we hope, for it is you who do all this."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Yahweh answered me, 'Even if Moses and Samuel came in person to plead for this people, my heart would have no pity. Send them away from my presence! Let them go!"
,"2":"And if they say: 'Where shall we go?' tell them: Yahweh says this: Those destined for the plague, to the plague; for the sword, to the sword; for starvation, to starvation; those for captivity, to captivity."
,"3":"For I shall send them four kinds of destroyers: the sword to slay, dogs to ravage, birds of the sky and beasts of the earth to devour and destroy."
,"4":"I shall make them an object of horror for all the kingdoms of the world because of what Manasseh, son of Hezekiah, king of Judah, did in Jerusalem."
,"5":"Who will take pity on you, Jerusalem?,Who will feel sorry for you?,Who will turn to ask how you are?"
,"6":"It was you who rejected me - word of Yahweh - you turned your back on me, and because of that I have stretched out my hand to destroy you. I was weary of showing mercy!"
,"7":"I winnowed them with a fork in the cities of the land, I left my people without children; I brought them to ruin, but they did not change their ways."
,"8":"Their widows are more numerous than the sand of the seas. On the mothers of young men I have brought a destroyer who ravages in broad daylight. Suddenly terror and fear grips them."
,"9":"The mother who had seven sons is confused and discouraged as if breathing her last. Although it is still day her sun has set. As for those who remain, I shall let them be slain by the sword in sight of their enemies - it is Yahweh who speaks."
,"12":"Can you break iron that comes from the north, or bronze?"
,"13":"I will let your wealth and your treasures be handed over to plunderers, not for a price but because of all your sins within your frontiers."
,"14":"You shall be slaves of your enemies,among a people you do not know, for the fury of my anger is on fire and will burn you up.'"
,"10":"Woe is me, Mother, why did you bring me to the light?,A man of dissension throughout the land!,I owe them nothing, neither do they owe me, yet they all curse me!"
,"11":"Tell me Yahweh, if I have not served you well!,Did I not plead with you for my enemies,in the time of their shame and disgrace?"
,"15":"You know I have, Yahweh!,Take care of me, defend me; take vengeance on my persecutors. Remember! For you I have suffered great humiliations."
,"16":"I devoured your words when they came. They were my happiness,and I felt full of joy,when you made your Name rest on me. Never did I associate with worldly people,"
,"17":"amusing myself with scoffers!,When your hand was upon me I stood apart,and you filled me with your anger."
,"18":"Why is there no end to my sorrow,or healing for my wound?,Why do you deceive me, and why does my spring suddenly dry up?"
,"19":"Then Yahweh spoke to me, 'If you return I will take you back,and you will serve me again. Draw the gold from the dross,and you will be as my own mouth. You must draw them to you and not go over to them."
,"20":"I will make you a fortress,and a wall of bronze facing them; if they fight against you,they will not overcome you;"
,"21":"I am with you to free you and save you. I will redeem you from the wicked,and free you from the hands of tyrants.'"
}`)
	CurrentBook.AddChapter(16, `{
"1":"The word of Yahweh came to me in these terms:"
,"2":"'Do not take a wife nor have sons and daughters in this place,"
,"3":"for this is what Yahweh says about sons and daughters born here, and about fathers and mothers who bring them to light in this country:"
,"4":"All will die of fatal diseases and no one will mourn for them or bury them; their corpses will be like dung on the ground. They will perish by the sword and by starvation and their corpses will be devoured by birds of prey and wild animals.'"
,"5":"Yahweh further insisted, 'Do not go into a house of mourning; neither weep nor loudly lament with the bereaved for I have already withdrawn my peace from these people - even my unwavering love and compassion."
,"6":"Both the great and the lowly in this country will perish and no one will mourn for them or bury them. No one shall gash his skin or shave his head as an act of mourning."
,"7":"No funeral meal shall be shared to comfort the bereaved or console them on the death of their fathers and mothers."
,"8":"Do not go to a house of celebration to feast with them before foods and drinks,"
,"9":"for Yahweh, Saboath God of Israel has this to say: In this place and before your very eyes, I will muffle every sound of pleasure and joy, even the song of the newlywed."
,"10":"When you announce all these things to the people, they will ask you: 'Why has Yahweh decided to bring such terrible disasters on us? What wickedness or sin have we committed against Yahweh our God?'"
,"11":"Then you shall tell them: 'It is because your fathers turned away from me and went after other gods to serve and worship them. They have forsaken me and refused to obey my Law."
,"12":"But you are worse than your forefathers because each of you has gone his own evil ways following his stubborn heart in complete defiance of me."
,"13":"Therefore, I will kick you out of this land into a place which is strange to you and your forefathers. There, you will serve other gods day and night, and you will get no compassion from me.' '"
,"14":"Yahweh says, 'The days are coming when people will no longer say, 'Yahweh is a living God for he brought the Israelites out of Egypt,'"
,"15":"Rather, they will say, 'Yahweh is a living God for he liberated the Israelites out of the northern land and out of all the countries where he had banished them.' Yes, I will bring them back to their own country - the land that I bestowed to their forefathers.'"
,"16":"But now Yahweh says, 'I am sending for many fishermen to catch them. Afterwards, I will send for many hunters to hunt them down on every mountain, hill and cave in the rocks."
,"17":"The things that they do are manifest before my eyes and the sins that they commit are not hidden from me."
,"18":"I will make them pay double for their wickedness and sin; they have contaminated my land with their idols that are as dead as corpses and have filled it with their abominations.'"
,"19":"Yahweh, my strength and my fortress, my refuge in times of distress!,From the furthest limits of the earth,nations will come to you and say, 'Our fathers possessed only falsehood, worthless idols bereft of power.'"
,"20":"Will man make his own gods?,Then they are not gods!"
,"21":"Hence Yahweh says: 'I will show,and let them know my power and my might. And they will know that Yahweh is my name."
}`)
	CurrentBook.AddChapter(17, `{
"1":"The sin of Judah is engraved with a tool of steel, with a point of diamond. It is written on the tablets of their hearts as on the horns of their altars."
,"2":"Their altars and sacred poles witness of it beside every green tree,"
,"3":"on the high hills and in the open country! I will give away your wealth and your treasures as plunder because of your sin in the high places of your land."
,"4":"Because of your fault you will lose the land I gave you. I will give you as slaves to your enemies in a land that you have never known before, for you have kindled the fire of my anger and it will burn forever."
,"5":"This is what Yahweh says, 'Cursed is the man who trusts in human beings and depends on a mortal for his life, while his heart is drawn away from Yahweh!"
,"6":"He is like a bunch of thistles in dry land, in parched desert places, in a salt land where no one lives and who never finds happiness."
,"7":"Blessed is the man who puts his trust in Yahweh and whose confidence is in him!"
,"8":"He is like a tree planted by the water, sending out its roots towards the stream. He has no fear when the heat comes, his leaves are always green; the year of drought is no problem and he can always bear fruit."
,"9":"Most deceitful is the heart. What is there within man, who can understand him?"
,"10":"I, Yahweh, search the heart and penetrate the mind. I reward each one according to his ways and the fruit of his deeds."
,"11":"Like a partridge hatching eggs it did not lay, is someone who hoards riches that he unjustly gained. At the noontime of his life, his wealth will abandon him; at the twilight of his breath, his folly will be confirmed.'"
,"12":"What a glorious and exalted throne is our Sanctuary!"
,"13":"Yahweh, hope of Israel, all who forsake you will be put to shame and those who turn from you will be cast out from your land, for they have rejected Yahweh, the fountain of living water."
,"14":"Heal me, Yahweh, and I shall be whole; save me and I shall be safe, O you, my hope!"
,"15":"People say to me, 'Where are Yahweh's threats? Let them be carried out now!'"
,"16":"But I did not urge you to bring devastation,nor a time of tragic death; you well know my desire,and my pleading is in your ears."
,"17":"Do not terrorize my heart; be my refuge in the day of disaster."
,"18":"Let my persecutors be humbled, rather than me!,Let them be terrified but not me!,Let the day of misfortune fall on them!,Crush them twice over!"
,"19":"The word of Yahweh came to me in these terms, 'Go and stand at the gate they call the People Gate, where the kings of Judah enter and leave;"
,"20":"and tell the king and all the people of Judah that this is what Yahweh says:"
,"21":"For the sake of your lives, be careful not to carry a load on the sabbath day or bring it through the gates of Jerusalem."
,"22":"Carry no burden out of your adobes and refrain from work on the day of the sabbath. Uphold its sacredness as I commanded your forefathers."
,"23":"They did not obey me or pay attention to what I said. Stiff-necked as they were, they would not hear or accept my warnings."
,"24":"But if you pay attention - it is Yahweh who speaks - and keep the sabbath holy, not working or carrying loads"
,"25":"through the gates of Jerusalem, then you will be witnesses to the entry of kings of David's descent through these gates, riding in chariots and on horses. You shall see them and their princes along with the people of Judah and the inhabitants of Jerusalem; and this city shall last forever."
,"26":"People will come from the towns of Judah and from the suburbs of Jerusalem, from the territory of Benjamin, from the Lowland and the hill country and from the Negeb, bringing into the temple burnt offerings and sacrifices, grain offerings and incense, as an act of thanksgiving to Yahweh."
,"27":"But if you do not listen and do not keep the sabbath holy, if you work and carry loads through the gates of Jerusalem, then I will set fire to those gates. It will burn the city and will not be quenched.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"This is the word of Yahweh that came to Jeremiah:"
,"2":"'Go down to the potter's house and there you will hear what I have to say.'"
,"3":"So I went to the potter's house and found him working at the wheel."
,"4":"But the pot he was working on was spoiled in his hands, so he reworked it all over again into another pot that suits his desire."
,"5":"Meanwhile Yahweh sent me his word,"
,"6":"'People of Israel, can I not do with you what this potter does? As clay in the potter's hand so are you in my hands."
,"7":"At times I warn a nation or a kingdom that I will uproot or destroy it."
,"8":"But if they change their ways, I then relent and refrain from doing the harm I had intended to do."
,"9":"At other times I declare that a nation or kingdom will be built up and planted"
,"10":"but then they do what displeases me and do not listen to me, so I decide to reverse the good deeds that I intend to do.'"
,"11":"And Yahweh added, 'Now tell the people of Judah and to those who live in Jerusalem: Yahweh says to you, 'Listen, I am planning to destroy you; I am hatching a devastating plot against you! Turn from your evil ways; rectify your conduct and your deeds.'"
,"12":"But you reply: 'It's no use! We shall follow our own plans'; and each one goes on obeying his stubborn heart.'"
,"13":"Because of this Yahweh has to say: Ask among the nations, 'Has anyone heard the like of this?,The Virgin Israel has done a most abominable thing."
,"14":"Does the snow of Lebanon ever leave the rocky heights of the field?,Do the fresh waters of great rivers ever dry up?"
,"15":"Yet my people have forgotten me, offering incense to empty idols,that made them stumble on their way,as they left the ancient paths. Now they have taken the wrong way, the crooked way that leads nowhere."
,"16":"Their land will be left desolate, and an object of lasting derision. All who pass by will be astonished,and shake their heads."
,"17":"Like the wind that blows from the east I will scatter them before their enemies; I will turn my back to them, not my face, in the day of their disaster!"
,"18":"Then, they said, 'Come, let us plot against Jeremiah, for even without him, there will be priests to interpret the Teachings of the Law; there will always be wisemen to impart counsel and prophets to proclaim the word. Come, let us accuse him and strike him down instead of listening to what he says.'"
,"19":"Hear me, O Yahweh!,Listen to what my accusers say."
,"20":"Is evil the reward for good?,Why do they dig a grave for me?,Remember how I stood before you,to speak well on their behalf,so that your anger might subside."
,"21":"Now let their children starve; hand them over to the sword!,Let their wives become childless and widows!,Let their men be victims of plague,and their young men be slain in battle!"
,"22":"Let cries be heard in their houses,when you suddenly bring bandits against them, for they have dug a pit to trap me,and hidden snares to catch my feet."
,"23":"O Yahweh, you know all of their plots to take my life!,Forgive not their crime; forget not their sin; crush them on the day of your anger."
}`)
	CurrentBook.AddChapter(19, `{
"1":"This was an order of Yahweh to Jeremiah, 'Go and buy a jar from the potter. Take with you some elders of the people and a few senior priests,"
,"2":"and go out to the valley of Ben-Hinnom at the entrance to the Potsherd Gate. Proclaim there what I tell you."
,"3":"Say this: Hear the word of Yahweh, kings of Judah and citizens of Jerusalem! Yahweh the God of hosts and the God of Israel is the one who speaks. I am about to send a disaster upon this place that will make the ears of those who hear it tingle."
,"4":"Here they have forsaken me, offering incense to foreign gods that neither they, their fathers nor the kings of Judah have known. They have profaned this place by filling it with the blood of the innocent."
,"5":"They have put up high places for Baal to burn their children in fire as a sacrifice. This is something that I have never commanded them to do, much less conceived in my mind."
,"6":"'Hence, I, Yahweh, tell you now that the days will surely come when this place will no longer be called Topheth or the Valley of Ben Hinnom, but the Valley of Massacre."
,"7":"In this place I will frustrate the plans of Judah and Jerusalem and let them be slain by their enemies - the very people who have doggedly sought their lives. Then, I will commit their corpses to the birds and the beasts as food."
,"8":"I will transform this city into a horrible wasteland - an object of scorn and a panorama of horror that will shock passers-by and make them kiss upon witnessing the terrible catastrophe!"
,"9":"The city will be surrounded by the enemies who have vowed to massacre the people. No one will be able to flee from this tight siege and the people in the city will be forced to eat the flesh of one another, even that of their very own children."
,"10":"Then, you shall break the jar before the people who have accompanied you"
,"11":"and you will tell them that I, Yahweh the God of hosts, will smash the people of this city like the shattered jar of the potter which is beyond repair. People will bury the dead even in Topheth, for there is no more space in the land to bury them."
,"12":"This is precisely what I will do to Jerusalem and its citizens, making this city like Topheth."
,"13":"The houses of Jerusalem and the palaces of the kings of Judah will be defiled like Topheth because the roofs of these houses have been used to burn incense for the stars of the skies and to pour wine-offerings for strange gods.'"
,"14":"Then Jeremiah left Topheth where Yahweh had sent him to prophesy, and stood in the porch of the House of Yahweh. There he told all the people,"
,"15":"'Listen to the word of Yahweh, God of Israel: I am about to bring on this city and the towns surrounding the disaster that I have already foretold, because they are a stiff-necked people and will not listen to me.'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"When the priest Pashur, son of Immer, who was the chief officer in the House of Yahweh, heard Jeremiah prophesying like this,"
,"2":"he ordered his people to beat Jeremiah and put him in chains at the Gate of Benjamin, the upper gate at the House of Yahweh."
,"3":"The next day, after Pashur ordered the release of Jeremiah, the latter told the former, 'Yahweh has already changed your name. It is not Pashur anymore but 'Terror on every side.'"
,"4":"For Yahweh says: I am going to hand you over to terror, you and your friends. They will fall under the sword of their enemies while you look on. I will deliver the people of Judah into the hands of the king of Babylon who will deport them to Babylon or slay them by the sword."
,"5":"I will likewise allow the enemies plunder all the wealth of this city. All the possessions and treasures of the kings of Judah will be seized and carried off to Babylonia."
,"6":"As for you, Pashur, you and your entire family will be taken as captives to Babylon where you will die and be buried - you and all your friends whom you deceived with lies.'"
,"7":"Yahweh, you have seduced me,and I let myself be seduced. You have taken me by force and prevailed. I have become a laughingstock all day long; they all make fun of me,"
,"8":"for every time I speak,I have to shout, 'Violence! Devastation!',Yahweh's word has brought me,insult and derision all day long."
,"9":"So I decided to forget about him,and speak no more in his name. But his word in my heart becomes like a fire,burning deep within my bones. I try so hard to hold it in, but I cannot do it."
,"10":"I hear many people whispering, 'Terror is all around!,Denounce him! Yes, denounce him!',All my friends watch me to see if I will slip: 'Perhaps he can be deceived,' they say; 'then we can get the better of him,and have our revenge.'"
,"11":"But Yahweh, a mighty warrior, is with me. My persecutors will stumble and not prevail; that failure will be their shame,and their disgrace will never be forgotten."
,"12":"Yahweh, God of hosts, you test the just,and probe the heart and mind. Let me see your revenge on them, for to you I have entrusted my cause."
,"13":"Sing to Yahweh! Praise Yahweh and say: he has rescued the poor from the clutches of the wicked!"
,"14":"Cursed be the day I was born!,Bless not the day my mother brought me to light!"
,"15":"Cursed be the man who broke the news to my father: 'It's a boy!',and it made him joyful!"
,"16":"Let him be like the towns that Yahweh destroyed without mercy. Let him hear a warning shout in the morning,and a battle cry at noon!"
,"17":"For he did not kill me in the womb, that my mother would have been my grave, and have carried me forever."
,"18":"Why did I ever leave the womb,to live in trouble and sorrow, and spend my days in shame?"
}`)
	CurrentBook.AddChapter(21, `{
"1":"These words of Yahweh came to Jeremiah when king Zedekiah sent Pashur, son of Malchiah and the priest Zephaniah son of Maaseiah, to say to him:"
,"2":"'Consult Yahweh on our behalf, for Nebuchadnezzar, king of Babylon, has started a war with us. Perhaps Yahweh will work a few of his miracles and make the enemy withdraw.'"
,"3":"Jeremiah replied, 'This is what Yahweh the God of Israel says to Zedekiah:"
,"4":"I am about to bring back to you the weapons with which you are fighting outside the wall the king of Babylon and the Chaldeans who are besieging you; and I will pile up these weapons in the center of the city."
,"5":"Then I myself will fight against you with outstretched hand and mighty arm, with anger and fury and great wrath,"
,"6":"I will strike all in the city, both humans and animals, and they will perish in a terrible plague."
,"7":"After this - it is Yahweh who speaks - I will hand over Zedekiah, king of Judah, his servants and the citizens who survive the plague, the sword and famine over to Nebuchadnezzar, king of Babylon. I will hand them over to their enemies, to those who have been hounding their blood. They shall be slain without mercy or compassion.'"
,"8":"Then Yahweh instructed me to say this to the people: 'Take heed! I, Yahweh, am presenting you a choice between the way that leads to life and the way that leads to death."
,"9":"Those who remain in the confines of the city will meet their deaths by the sword, famine or plague; those who go out and surrender to the Chaldeans besieging the city will live and will be the only ones to be saved."
,"10":"For I am turning to this city for its ruin, not for its good - word of Yahweh - it will be given over to the king of Babylon who will destroy it by fire.'"
,"11":"You will give this message to the King's officials. To the royal family of Judah say this:"
,"12":"Officials of David's palace, hear the word of Yahweh: Give judgment each morning,and deliver the oppressed from the hand of the oppressor, lest my fury break loose like a fire,with no one to quench it.'"
,"13":"This is Yahweh's word, 'See, I am coming to you,who live in the hills overlooking the valley, you who say, 'Who will come against us and enter this secure place?'"
,"14":"I will punish you according to your deeds, and in your forests I will kindle a fire,that will devour all that surrounds it.'"
}`)
	CurrentBook.AddChapter(22, `{
"1":"Yahweh said to me, 'Go to the palace of the king of Judah and give him this message:"
,"2":"Hear the word of Yahweh, O king of Judah who sit on the throne of David. To you, your servants and all who enter by these gates,"
,"3":"Yahweh says: Practice justice and do good. Free the oppressed from their oppressor. Harm not the foreigners, the orphans and the widows; do them no violence, and let no innocent blood be spilled in this place."
,"4":"If you do this, kings succeeding King David will enter these gates riding on their chariots and horses, together with their servants and their people."
,"5":"But if you do not heed my word,- it is Yahweh who speaks I swear by myself that this place will become a ruin.'"
,"6":"For this is what Yahweh says of the royal house of Judah: For me you are like Gilead, like a peak of Lebanon! And yet I will transform you into a desert, a city where no one lives."
,"7":"I will prepare destroyers to attack you, each with an axe in his hand. They will cut down your choice cedars and throw them into the fire."
,"8":"Pagans without number will pass by this city and say to one another, 'Why has Yahweh dealt with this great city in such a way?'"
,"9":"And they will answer, 'Because they broke their covenant with Yahweh, their God, and worshiped and served other gods!'"
,"10":"Weep not for the one who is dead!,grieve not for him. Mourn rather for him who is in exile for he will never return to see his homeland again!"
,"11":"For this is what Yahweh has said of King Josiah's son, Shallum, who succeeded his father as king of Judah:"
,"12":"'He will never return, for he will die in the place to which he has been deported and will never see this land again."
,"13":"Damned is the man who builds his house with stolen goods, and extends it upwards by means of injustice; he who makes his fellowman work for nothing and refuses to give him his wages!"
,"14":"So you build for yourself a fine palace with spacious upper rooms!,So you have large windows put in, you have it paneled with cedarwood and painted vermillion."
,"15":"Does amassing cedar make you more of a king?,Was not your father a just man? He ate and drank to his life's content, but he acted justly and all went well for him."
,"16":"He defended the cause of the poor and needy: this is the meaning of knowing Yahweh."
,"17":"But your eyes and heart are set on selfish gain, on the shedding of innocent blood, and oppressive violence."
,"18":"Therefore this is what Yahweh says concerning Jehoiakim, son of Josiah, king of Judah: No one shall lament for him saying: Alas, my brother! Alas, O sister! No one shall lament for him saying: Alas, my lord! Alas, your majesty!"
,"19":"He will be given the burial of a donkey, dragged away and thrown out beyond the gates of Jerusalem."
,"20":"Go up to Lebanon and cry out; weep from the heights of Bashan,cry out from Abarim, for all your lovers have been crushed."
,"21":"I spoke to you in more fortunate days, but you said: 'I will not listen.',You have been like that since your youth, paying no attention to my word."
,"22":"All your shepherds will be scattered by the wind and your lovers will be taken captive; then you will be covered with shame because of your evil deeds."
,"23":"You who call your house: 'Lebanon',and made your nest of cedarwood, how you will groan when sorrow comes like the birthpangs of a woman in labor!"
,"24":"By my life - says Yahweh - even if Jeconiah, Jehoiakim's son, king of Judah, were the signet ring on my right hand I would pull him off!"
,"25":"I will hand you to those who seek your life, to the Chaldeans you fear."
,"26":"Then I will hurl you and the mother who bore you into a foreign land where you were not born. There you shall die,"
,"27":"for to the land for which you long, you will never return!'"
,"28":"Is this Jeconiah a broken and useless crock that no one wants? Why has he been expelled, he and his family, to a land they do not know?"
,"29":"Land, land, land! Hear what Yahweh says."
,"30":"These are his words, 'List this man as childless!' None of his race will succeed; not one will be fortunate to sit on David's throne and rule again over Judah."
}`)
	CurrentBook.AddChapter(23, `{
"1":"'Woe to the shepherds who mislead and scatter the sheep of my pasture!'"
,"2":"This is the message of Yahweh, God of Israel, to the shepherds in charge of my people, 'You have scattered my sheep and driven them away instead of caring for them. Now I will deal with you because of your evil deeds."
,"3":"I will gather the remnant of my sheep from every land to which I have driven them and I will bring them back to the grasslands. They will be fruitful and increase in number."
,"4":"I will appoint shepherds who will take care of them. No longer will they fear or be terrified. No one will be lost.'"
,"5":"Yahweh further says, 'The day is coming when I will raise up a king who is David's righteous successor. He will rule wisely and govern with justice and righteousness."
,"6":"That will be a grandiose era when Judah will enjoy peace and Israel will live in safety. He will be called Yahweh-our-justice!"
,"7":"'The days are coming,' says Yahweh, 'when people shall no longer swear by Yahweh as the living God who freed the people of Israel from the land of Egypt."
,"8":"Rather, they will swear by Yahweh as the living God who restored the descendants of Israel from the northern empire and from all the lands where he had driven them, to live again in their own land!'"
,"9":"About the prophets: My heart breaks within me, and all my bones tremble, I am like a drunken man, like a man overcome by wine,because of Yahweh and his holy words."
,"10":"The land is full of adulterers. Because of this I put a curse on the country; it is in mourning and the desert grasslands have withered. They follow an evil path and readily act unjustly."
,"11":"Even the prophet and the priest are corrupt; I have found out about their wickedness in my House - word of Yahweh."
,"12":"That is why their path will become slippery in the dark, making them stumble and fall when I bring evil upon them in the year of their punishment."
,"13":"I well know how stupid the prophets of Samaria were; they prophesied in the name of Baal and led my people Israel astray."
,"14":"But among the prophets of Jerusalem I have likewise seen horrors: for they are adulterers and liars!,They encourage the evildoers so that none of them turns away from wickedness. For me all of them are like Sodom; and the common people like Gomorrah."
,"15":"That is why Yahweh the God of hosts speaks against the prophets: I will give them bitter food to eat and poisoned water to drink, for from the prophets of Jerusalem evil has spread all over the land."
,"16":"Thus Yahweh warns, 'Do not listen to what the prophets say. They give you false hope and tell you their own illusions, and not what comes from the mouth of Yahweh."
,"17":"They dare say to those who despise me: 'Yahweh has spoken, be at peace'; and to those who follow their own stubborn hearts they say: 'No misfortune will come upon you!'"
,"18":"Who then has been present in the council of Yahweh? Who has heard and understood his word? Who has paid attention to his word and is able to pass it on?"
,"19":"The storm of Yahweh's wrath breaks forth and a whirling hurricane bursts upon the head of the wicked!"
,"20":"Yahweh's wraths will not relent before the full accomplishment of his plans. The time will come when you will understand what it is."
,"21":"I did not send these prophets, yet they went running. I did not speak, yet they prophesied!"
,"22":"Were they present in my council? Then let them proclaim my word to my people and have them turn away from their evil ways and their wicked deeds."
,"23":"Am I a God only when I am near - it is Yahweh who speaks - and not when I am far off?"
,"24":"If someone hides in secret places do I not see him? - Do I not fill the heavens and the earth?"
,"25":"I have listened and heard the lies that the prophets have proclaimed in my name. All said: 'I had a dream! I had a dream!'"
,"26":"How long will there be prophets of lies who proclaim their own illusions?"
,"27":"They would like to make the people forget my Name by the dreams they relate to one another, just as their fathers forgot my Name when they followed Baal."
,"28":"The prophet who has a dream prophesies a dream, whereas the one who receives my word proclaims the word of truth. What have straw and wheat in common?"
,"29":"Isn't my word like fire, like the hammer that shatters a rock?"
,"30":"That is why I oppose the prophets who steal from one another words that are supposedly mine."
,"31":"I am against the prophets who have only to move their tongues to utter oracles."
,"32":"I am against those whose prophecies are based on lying dreams, who lead my people astray with their trickery and pretensions. I did not commission or charge them to transmit my orders, so they are of no benefit to my people - word of Yahweh."
,"33":"And when these people, or a prophet or a priest jestingly asks you: What is the 'Burden' of Yahweh? you will answer: 'You are the burden - and I am going to get rid of you.' This is Yahweh's word."
,"34":"And the prophets, priests or common people who say: 'Burden' of Yahweh, will be punished, and their household as well."
,"35":"This is what you should say, each one to his friend or brother, 'What is Yahweh's answer?' or 'What has Yahweh said?'"
,"36":"But there must be no mention of 'Burden' of Yahweh for it shall be burdensome for the one who says it."
,"37":"And if you want to know,"
,"38":"this is what Yahweh says:"
,"39":"Since you use this expression in spite of my prohibition, I will cast you off and thrust you out of my sight, - you and the city I gave to you and your fathers."
,"40":"I will bring upon you everlasting shame and dishonor that will be yours forever."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Yahweh showed me two baskets of figs placed in front of the Temple. It was after Nebuchadnezzar, king of Babylon had deported Jekoniah, son of Jehoiakim, king of Judah together with the princes of Judah, the blacksmiths and metalworkers and had taken them to Babylon."
,"2":"One of the baskets had choice figs that ripen early, the other had bad ones, so bad that they couldn't be eaten."
,"3":"Yahweh said to me, 'What do you see Jeremiah?' I replied, 'Figs. The good figs are excellent but the bad figs are so rotten they cannot be eaten!'"
,"4":"So the word of Yahweh came to me: 'Just as these figs are good, so do I consider good those who have been deported from Judah to the land of the Chaldeans."
,"6":"I will look kindly on them and bring them back to this land. I will restore and not destroy them, I will plant and not uproot them."
,"7":"I will dispose their heart to know me as Yahweh. They will be my people and I will be their God for they will come back to me with all their heart."
,"8":"'But as far as King Zedekiah of Judah is concerned, I will deal with him as one deals with rotten figs - so rotten they cannot be eaten. I will likewise deal with his princes and the remnants of Jerusalem - those who have stayed in the country and those who have migrated to Egypt."
,"9":"I will make them a horror to all the kingdoms of the earth, a reproach and a byword, an object of ridicule, a curse in all the countries to which I will drive them."
,"10":"I will also bring sword, famine and plague upon them until they are utterly erased from the land I gave to them and to their fathers."
}`)
	CurrentBook.AddChapter(25, `{
"1":"This is the word that came to Jeremiah concerning all the people of Judah in the fourth year of Jehoiakim, son of Josiah, which was the first year of Nebuchadnezzar, king of Babylon."
,"2":"And this word was transmitted by the prophet Jeremiah to all the people of Judah and to all the citizens of Jerusalem:"
,"3":"For twenty-three years, that is, from the thirteenth year of Josiah son of Amon until today, the word of Yahweh has come to me and I have continuously spoken to you,"
,"4":"but you would not listen. Besides Yahweh has sent his servants the prophets to you again and again, but you neither listened nor paid attention."
,"5":"They said, 'Turn from your evil ways and repent of your wicked deeds that you may live in the land that Yahweh gave to you and your fathers forever and ever."
,"6":"Do not turn after other gods to serve and worship them. Do not provoke my anger with these things your own hands have made, and I will do you no harm.'"
,"7":"But you refused to listen - it is Yahweh who speaks - and provoked my anger with these gods you yourselves have made to your own detriment."
,"8":"That is why Yahweh God of hosts says to you: Since you have not listened to what I said,"
,"9":"I will summon all the clans of the north - it is Yahweh who speaks - and my steward Nebuchadnezzar will bring them against this land and its inhabitants and against all the surrounding nations. I will completely destroy these people, making them desolate, an object of ridicule, an everlasting ruins."
,"10":"I will banish from them every sound of joy and happiness, the song of the bride and bridegroom, the noise of the mill and the light of the lamp."
,"11":"All the land will be a ruin and a desolation and for seventy years these nations will serve the king of Babylon."
,"12":"(But after seventy years I will punish the king of Babylon and his nation for their guilt - it is Yahweh who speaks - and I will make it forever desolate!)"
,"13":"On this land I will now bring all that I foretold, all that is written in this book."
,"14":"They will be subject to great nations and kings! I will repay them according to their deeds and the work of their hands.'"
,"15":"Yahweh, the God of Israel, instructed me, 'Take from my hand this cup of wine and let all the nations to whom I send you drink from it."
,"16":"They will drink and stagger and lose control of their minds before the sword I am sending among them.'"
,"17":"So I took the cup from Yahweh's hand and made all the nations to whom he sent me drink from it:"
,"18":"to bring them in ruins, a desolation which is an object of ridicule and curses, as they are today."
,"19":"Then I gave it to Pharaoh king of Egypt, to his ministers, his princes and all his people, to all the countries of the west,"
,"20":"to all the kings of Uz, to all the kings of the Philistines in Ashkelon, Gaza, Ekron and those left at Ashdod;"
,"21":"to all the people of Edom, Moab and Ammon;"
,"22":"all the kings of Tyre and Sidon: the kings of the coastlands across the sea;"
,"23":"Deda, Tama, Buz and"
,"24":"all the kings of Arabia and the kings of the west and the kings of those who live in the desert;"
,"25":"all the kings of Zimri, Elim and Media and"
,"26":"all the kings of the north, far and near, one after the other; all the kings that are found on the face of the earth! And after them the king of Babylon shall drink it!"
,"27":"You will say to them, 'This is the message of Yahweh the God of hosts and the God of Israel: 'Drink, get drunk, vomit, fall without raising again in front of the sword I am sending against you.'"
,"28":"But if they refuse to take the cup from your hand to drink, tell them, 'Yahweh the God of hosts has spoken: You also must drink."
,"29":"When you see that I am punishing first the city where my Name rests, do you think you will be spared? No, you will not, for I am personally bringing down a sword on all the inhabitants of the earth - it is Yahweh God of hosts who speaks.'"
,"30":"You will communicate all these words to them and say, 'Yahweh roars on high and from his holy dwelling threatens all the inhabitants of the world. His mighty roar echoes to the farthest ends of the earth."
,"31":"For Yahweh judges all the nations and passes sentence against all humankind, and he abandons the wicked to the sword - word of Yahweh.'"
,"32":"Yahweh, God of hosts, says, 'See, disaster spreads from nation to nation. A storm arises from the ends of the earth."
,"33":"On that day Yahweh's victims will be spread from one end of the earth to the other. No one will mourn for them; no one will gather them up or bury them - they will be like dung on the soil!"
,"34":"Howl, shepherds, and lament!,Roll in the dust you leaders of flocks for the day of slaughter and dispersal has come for you and you will fall like fattened rams."
,"35":"The shepherds will find no refuge and the leaders of the the flocks will not be able to escape."
,"36":"The shepherds cry out and the leaders of flocks wail,"
,"37":"for Yahweh lays waste the grasslands, and the pastures are silent because of the fury of Yahweh's anger."
,"38":"Like a lion he leaves his lair; because of his fierce wrath the land has been stricken by the sword and has become a wasteland.'"
}`)
	CurrentBook.AddChapter(26, `{
"1":"At the beginning of the reign of Judah's king Jehoiakim son of Josiah, the word of Yahweh came to Jeremiah:"
,"2":"Yahweh says this, 'Stand in the courtyard of Yahweh's House and say to all who come from the towns of Judah to worship in Yahweh's house - all that I command you to say; do not omit anything!"
,"3":"Perhaps they will listen to you. Perhaps each one will turn from his wicked ways. Then I will change my mind and forget the destruction that I have planned to inflict on them because of their wicked deeds."
,"4":"Tell them: This is what Yahweh says: 'You have not obeyed me and you have failed to walk according to my Law which I have set before you."
,"5":"You have not heeded my servants, the prophets, whom I have persistently sent to you. If you stubbornly close your ears to them,"
,"6":"I will treat this House of mine as I treated the sanctuary of Shiloh and let all the nations see that Jerusalem is a cursed city.'"
,"7":"The priests, the prophets and all the people heard what Jeremiah said in Yahweh's House."
,"8":"When Jeremiah finished saying all that Yahweh had commanded, he was besieged by the priests and prophets saying, 'You are bound to die!"
,"9":"How dare you speak in Yahweh's Name telling us that this House will be treated like Shiloh and this city is to become a deserted ruins.' And all the people gathered around Jeremiah in the House of Yahweh."
,"10":"Upon hearing this, the leaders of Judah came up from the king's palace to the House of Yahweh and took their place at the entrance of the New Gate."
,"11":"Then the priests and the prophets said to the leaders of the people: 'This man must die for he has spoken against the city as you have heard with your own ears!'"
,"12":"Jeremiah replied, 'I have been sent by Yahweh to prophesy against this House and this city all that you have heard."
,"13":"Hence, reform your ways and your deeds and obey Yahweh your God that he may change his mind and not bring upon you the destruction he had intended."
,"14":"As for me I am in your hands; do with me whatever you consider just and right."
,"15":"But know that I am innocent and if you take my life you commit a crime that is a curse on yourselves, on the city and the people. In truth it was Yahweh who sent me to say all that I said in your hearing.'"
,"16":"Then the leaders, backed by the people, said to the priests and the prophets, 'This man does not deserve death; he spoke to us in the Name of Yahweh.'"
,"17":"Some of the elders of the land addressed the people's assembly saying,"
,"18":"'Micah of Moresheth prophesied publicly in the time of Hezekiah, king of Judah: 'Zion will become like a field, Jerusalem a heap of rubble and the Temple Mount a hill of overgrown thickets.'"
,"19":"Did King Hezekiah of Judah and the people of Judah kill him? They instead feared Yahweh and implored his pardon until they succeeded in their plea to make him change his mind; and Yahweh did not inflict the harm with which he had threatened them. How can we commit such a crime?'"
,"20":"There was another man, by the name of Uriah son of Shemaiah from Kiriath Jearim who also prophesied in the name of Yahweh. He spoke against this city and this country in words similar to those of Jeremiah."
,"21":"When King Jehoiakim together with his officials heard his words, he decided to do away with him. When Uriah came to know about it, he was scared and fled to Egypt."
,"22":"But King Jehoiakim sent Elnathan son of Achbor with some people into Egypt."
,"23":"They brought Uriah out of Egypt and took him to King Jehoiakim who had him slain and his body thrown into the common people's burial place."
,"24":"As for Jeremiah he was befriended by Ahikam, son of Shaphan, and was not handed over to those who wanted him put to death."
}`)
	CurrentBook.AddChapter(27, `{
"1":"In the beginning of the reign of Zedekiah, son of Josiah, the word of Yahweh came to Jeremiah in this way,"
,"2":"'Make for yourself ropes and a yoke and put them on your neck."
,"3":"Then send word to the kings of Edom, Moab, Ammon, Tyre and Sidon through their ambassadors, who have come to Jerusalem, to see Zedekiah king of Judah."
,"4":"Give them these instructions for their masters: Yahweh God of hosts tells you what you ought to say to your masters:"
,"5":"By means of my great power and mighty deeds I made the earth, as well as the people and animals that inhabit it, and I give them to whom ever I wish."
,"6":"Now I have given all these lands into the hands of my steward Nebuchadnezzar king of Babylon and I will even make the beasts of the field subject to him."
,"7":"All nations will serve him, his son and his grandson until the time for his land comes and then he will be overpowered by powerful nations and great kings."
,"8":"As for the nation or kingdom that refuses to serve Nebuchadnezzar, king of Babylon, I will punish it with the sword, famine and plague - word of Yahweh - until I completely wipe it out."
,"9":"Hence you must no longer pay attention to your prophets, diviners, interpreters of dreams, astrologists or sorcerers who say that you must not submit yourselves to the king of Babylon."
,"10":"For they are prophets of lies which will cause you to be finally driven from your land. I myself will drive you out and you will perish."
,"11":"But the nation that submits to the yoke of the king of Babylon and serves him, that nation I will leave in its own land - word of Yahweh - to till it and live there.'"
,"12":"Then I gave the same message to King Zedekiah of Judah, 'Place your neck under the yoke of the king of Babylon. Serve him and his people and you will live."
,"13":"Why should you and your people die by the sword, famine and plague as Yahweh has threatened any nation that will not serve the king of Babylon?"
,"14":"Do not listen to the prophets when they say, 'You will not have to serve the king of Babylon.' For they are deceiving you with their prophesies."
,"15":"I did not send them, says Yahweh, and they falsely use my name in their prophesying. Let it not be that I drive you out of your land and you perish, you and the prophets who have spoken to you.'"
,"16":"Then I spoke to the priests and the people, 'Yahweh tells you not to listen to your prophets who say: 'Very soon now the articles from Yahweh's House will be brought back from Babylon.' They prophesy lies."
,"17":"Do not listen to them; instead serve the king of Babylon and survive. Why should this city become a ruins?"
,"18":"If they were prophets and if they had Yahweh's word in their hearts, they would now be praying to Yahweh God of hosts not to allow the objects still remaining in the House of Yahweh and in the royal palace and in Jerusalem to be carried off to Babylon."
,"19":"For, Yahweh says something about the pillars, the Sea, the movable stands and the other objects still in this city"
,"20":"which Nebuchadnezzar did not carry off when he deported Jekoniah son of Jehoiakim, king of Judah from Jerusalem to Babylon together with all the nobles of Judah and Jerusalem."
,"21":"Yes, this is what Yahweh the God of hosts says about the objects remaining in the House of Yahweh and in the royal palace in Jerusalem:"
,"22":"'They will be taken to Babylon and there they will remain until the day I deal with them. Then I will bring them back and restore them to this place.'"
}`)
	CurrentBook.AddChapter(28, `{
"1":"Early in the reign of Zedekiah, king of Judah, in the fifth month of the fourth year, the prophet Hananiah spoke to me. Hananiah son of Azzur from Gibeon proclaimed in Yahweh's House in the presence of the priests and the people,"
,"2":"'This is what Yahweh the God of hosts and the God of Israel says: I will break the yoke of the king of Babylon."
,"3":"Within two years I will bring back to this place all the objects that King Nebuchadnezzar of Babylon took away from Yahweh's House and carried to Babylon."
,"4":"I will likewise bring back Jekoniah son of Jehoiakim, king of Judah, and all who were taken from Judah and deported to Babylon. For I will break the yoke of the king of Babylon - word of Yahweh.'"
,"5":"Then Jeremiah replied to Hananiah in the presence of the priests and all the people,"
,"6":"'So be it! May Yahweh fulfill the words you have spoken and bring back from Babylon to this place the objects taken from the House of Yahweh and all the exiles."
,"7":"Yet hear now what I say in your hearing and the hearing of all the people."
,"8":"The prophets who came before you and me continually prophesied war, disaster and plague to many nations and great kingdoms."
,"9":"So the prophet who prophesies peace will not be recognized as truly sent by Yahweh, until his predictions are fulfilled.'"
,"10":"Then Hananiah took the yoke from the neck of Jeremiah and broke it."
,"11":"Hananiah proclaimed in the presence of all the people, 'Yahweh says this: In the same manner within two years will I break the yoke of Nebuchadnezzar from the neck of all the nations.' Then Jeremiah the prophet went on his way."
,"12":"Some time later, a word of Yahweh came to Jeremiah,"
,"13":"'Go and tell this to Hananiah: This is what Yahweh says: You have broken a wooden yoke but in its place you will get a yoke of iron."
,"14":"For this is what Yahweh the God of hosts and the God of Israel says: I am placing a yoke of iron on the neck of all the nations to make them serve Nebuchadnezzar king of Babylon and they will serve him. I will even give him control over the wild animals.'"
,"15":"Then Jeremiah said to Hananiah, 'Listen! Hananiah, you have not been sent by Yahweh and yet you have deceived these people, giving them false hope with your lies."
,"16":"That is why Yahweh says with regard to you: I am removing you from the face of the earth. You will die this very year because you have counseled rebellion against Yahweh.'"
,"17":"And in the seventh month of that year Hananiah died."
}`)
	CurrentBook.AddChapter(29, `{
"1":"This is the text of the letter the prophet Jeremiah sent to the rest of the elders, to the priests, the prophets and to all the people that Nebuchadnezzar had deported from Jerusalem to Babylon."
,"2":"This was after King Jekoniah, the queen mother, the officials, the princes of Judah and Jerusalem, the smiths and metalworkers had left Jerusalem."
,"3":"The letter was hand-carried by Elasah son of Shaphan and Gemariah son of Hilkiah, whom Zedekiah king of Judah sent to King Nebuchadnezzar in Babylon. It said: This is what Yahweh God of hosts and God of Israel says to all those deported from Jerusalem to Babylon:"
,"5":"'Build houses and live in them, plant gardens and eat what they produce,"
,"6":"marry and have children, seek wives for your sons and give your daughters in marriage, so that they too will have children. While there, increase in number; do not decrease."
,"7":"Pull yourselves together for the welfare of the land to which I have sent you and intercede on its behalf as you pray to Yahweh; for its welfare will be your welfare.'"
,"10":"This is what Yahweh says, 'When the seventy years allowed to Babylon have been completed I will come to you and fulfill my promise of restoring you back to this place."
,"11":"For I know what my plans for you are, plans to save you and not to harm you, plans to give you a future and to give you hope.'"
,"12":"And Yahweh says, 'When you call on me I will listen."
,"13":"You will seek me and find me when you search for me with all your heart.'"
,"14":"For Yahweh says, 'I will let myself be found by you and I will gather you from among all the nations and from all the places where I have driven you and bring you back to the place from which I sent you into exile."
,"15":"Indeed you are trusting in prophets allegedly raised for you by Yahweh in Babylon."
,"16":"But this is the word of Yahweh:"
,"8":"Do not be deceived by the prophets and seers who are among you. Do not believe in their dreams or be confident in their illusions."
,"9":"For I did not send them and they take advantage of my name to foretell lies. As for the king who sits on the throne of David and all the people who live in this city (your kinsmen who did not go into exile with you);"
,"17":"thus says Yahweh God of hosts, 'I am sending sword, famine and plague against them. I will make them like rotten figs, so rotten they cannot be eaten."
,"18":"I will pursue them with sword, famine and plague. They will be a horror for all the kingdoms of the earth, a curse, an abomination, a sign of desolation, mockery and ridicule among all the nations where I scatter them."
,"19":"For they did not heed my words when I sent them again and again my servants, the prophets. They refused to pay attention."
,"20":"As for you, exiles, whom I sent away from Jerusalem to Babylon, hear the word of Yahweh."
,"21":"This is what Yahweh the God of hosts and the God of Israel says concerning Ahab son of Kolaiah and Zedekiah son of Maaseiah who prophesy lies in my name, 'I will hand them over to Nebuchadnezzar, king of Babylon and he will slay them before your eyes."
,"22":"This will give rise to a curse widely used by the captives from Judah in Babylon: 'May the Lord treat you like Zedekiah and Ahab, who were roasted in the fire by the king of Babylon!'"
,"23":"for they have acted outrageously: they have committed adultery with their neighbors' wives and have used my name to proclaim lies which I did not command them. I know it and have witnessed it,' declares Yahweh."
,"24":"After that Shemaiah of Nehelam"
,"25":"sent letters in his own name to all the people in Jerusalem and to Zephaniah, son of Maaseiah the priest and to all the priests saying,"
,"26":"'Yahweh has made you priest in place of Jehoiada to be in charge in the House of Yahweh to arrest every mad prophet and put him in the stocks and neck-irons."
,"27":"So why have you not rebuked Jeremiah of Anathoth, a would-be prophet in your midst?"
,"28":"In this role he sent a message to us in Babylon: You will be there for a long time! Build houses and live in them; plant gardens and eat their produce.'"
,"29":"When Zephaniah the priest read this letter in the hearing of the prophet Jeremiah,"
,"30":"the word of Yahweh came to Jeremiah,"
,"31":"'Send this message to all the exiles: This is what Yahweh says concerning Shemaiah of Nehelam: Shemaiah prophesied although I did not send him and he made you trust in lies."
,"32":"Because of that I will punish Shemaiah and his descendants; none of them will live to witness the blessings I will bestow on my people, for he incited my people to rebel against Yahweh.'"
}`)
	CurrentBook.AddChapter(30, `{
"1":"This is another word that came to Jeremiah from Yahweh:"
,"2":"Yahweh, God of Israel says, 'Write in a book all that I have communicated to you,"
,"3":"for the days are coming when I shall bring my captive people Israel and Judah back to the land I gave to their fathers as their inheritance."
,"4":"These are words spoken by Yahweh to Israel:"
,"5":"We have heard cries of fear, terror and not peace!"
,"6":"Ask and see: Does a man bear children?,Then why do I see every strong man,with his hands on his hips like a woman in labor, every face turned a ghastly color?"
,"7":"How terrible that day!,there is none to equal it!,It is a time of distress for Jacob, but he will be saved."
,"8":"On that day, - declares Yahweh of hosts - I will break the yoke around his neck and burst his bonds, that strangers may no longer enslave them."
,"9":"They will instead serve Yahweh their God and David their king whom I will raise up for them."
,"10":"Yahweh says, 'Fear not, Jacob my servant. Be not dismayed, Israel, for I will rescue you and your descendants from that far-off land where you are captive. Jacob shall return and know peace, molested by no one."
,"11":"I am with you to save you. I will utterly destroy the nations where you are scattered. You alone shall not be destroyed, but I will discipline you justly and not let you go unpunished.'"
,"12":"Yahweh says, 'Your wound is incurable, your injury is grievous."
,"13":"There is no one to plead your cause. There is a remedy for an ulcer,but no healing for you!"
,"14":"All your lovers have forgotten you; they care nothing for you. For I struck you as an enemy does, with a cruel punishment, because of your great guilt,and the wickedness of your sin."
,"15":"Why cry out now that you are hurt?,Is there no cure for your pain?,Because of your great crime and grievous sin I have done this to you."
,"16":"Yet all who devour you will be devoured. Your oppressors will be taken captive; your plunderers will be plundered and those who despise you will be despised."
,"17":"Because you were called 'outcast - Zion for whom no one cares,' I will restore you to health and heal your wounds,' says Yahweh."
,"18":"Yahweh says, 'I will restore my people into Jacob's tents and have pity on his dwellings. The city will be rebuilt over its ruins and the palace restored on its proper place."
,"19":"From them will come songs of praise and the sound of merrymaking. I will multiply them and they shall not be few. I will bestow honor on them and they shall not be despised."
,"20":"Their children will be as before and their community will be established before me. I will ask their oppressors to account."
,"21":"Their leader will be one of themselves, their ruler shall emerge from their midst. I will bring him close to me for who would dare to approach me?"
,"22":"You shall be my people and I shall be your God.'"
,"23":"See the storm of Yahweh bursting forth in fury; like the turmoil of a hurricane it sweeps down on the head of the wicked."
,"24":"The fierce wrath of Yahweh will not turn away until he has done and accomplished the purpose of his heart. In the latter days you will understand this."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Yahweh declares that when that time comes he will be the God of all the families of Israel, and they will be his people."
,"2":"Thus says Yahweh: The people who survived the sword have found grace in the desert. As Israel was seeking for his rest"
,"3":"Yahweh appeared from afar saying, I have loved you with a love everlasting, so I have kept for you my mercy."
,"4":"I will restore you again, and you shall be rebuilt, O virgin Israel!,You will take up your tambourines and go out dancing joyfully."
,"5":"You will plant vineyards again on the hills of Samaria, and the farmers who plant them will enjoy their fruit."
,"6":"There shall be a day when watchmen will call out on the hills of Ephraim, 'Come, let us go to Zion, to Yahweh our God!'"
,"7":"For Yahweh says this: Shout with joy for Jacob; rejoice for the greatest of nations. Proclaim your praise and say: 'Yahweh has saved his people, the remnant of Israel!'"
,"8":"Look, I will bring them back from the land of the north, gather them from the ends of the earth, the lame and the blind, mothers and women in labor - a great throng will return."
,"9":"They went away weeping, they will return in joy. I will lead them by the streams of water, on a level path so that no one will stumble, for I am Israel's father,and Ephraim is my firstborn. He who scattered Israel now gathers them!"
,"10":"Hear the word of Yahweh, O nations, proclaim it on distant coastlands: He who scattered Israel will gather them,and guard them as a shepherd guard his flock."
,"11":"For Yahweh has ransomed Jacob,and redeemed him from the hand of his conqueror."
,"12":"They shall come shouting for joy, while ascending Zion; they will come streaming to Yahweh's blessings -,the grain, the new wine and the oil, the young of the flocks and herds. They will be like a well-watered garden; no more will they be afflicted."
,"13":"Maidens will make merry and dance, young men and old as well. I will turn their mourning into gladness, I will give them comfort and joy for sorrow."
,"14":"I will fill the priests with abundance, and satisfy my people with my bounty,- this is Yahweh's word."
,"15":"Thus speaks Yahweh: 'In Ramah, a voice,of mourning and great weeping is heard, Rachel wailing for her children,and refusing to be consoled, for her children are no more.'"
,"16":"Yahweh says this to her: 'Weep no more and wipe the tears of your eyes; your sorrow will have redress. They will come back from the enemy's land."
,"17":"There is hope for your descendants; your sons will return to their own borders."
,"18":"I heard Ephraim saying in grief: 'You disciplined me like an untamed calf, and I have been disciplined. Bring me back, and I will return, for you are my God, my Lord."
,"19":"Yes, I strayed, but I have repented. Now I understand and I beat my breast; I bear the disgrace of my youth, and I blush with shame and humiliation.'"
,"20":"Is not Ephraim my favored son, the child in whom I delight?,Often have I threatened him, but I still remember him, and my heart yearns for him. I must show him mercy,' declares Yahweh."
,"21":"Set up road signs, put up guideposts; focus your attention to the highway, the road by which you went. Return, O virgin Israel, return to these cities of yours."
,"22":"How long will you remain wandering, O unfaithful daughter?,Yahweh is creating something new on earth -,the woman finds her husband again.'"
,"23":"These are words of Yahweh, God of hosts and God of Israel, 'When I bring back the captives to the land of Judah and its towns, the people will once more use the expression: 'Yahweh bless you, O dwelling of righteousness, holy mountain!'"
,"24":"All Judah and its towns, the farmer and those who move about with their herds will live there in peace."
,"25":"I will refresh the weary and lift up the downhearted.'"
,"26":"Then I awoke and looked around; my sleep had been peaceful."
,"27":"'The days are coming - this is the word of Yahweh - when I shall sow the people of Israel and the people of Judah with the seed of man and of beasts."
,"28":"It will happen that just as I watched over them to uproot and overthrow, to destroy and bring disaster, so shall I likewise build and plant - word of Yahweh."
,"29":"No longer will it be said: 'The fathers have eaten sour grapes and the children's teeth are set on edge.'"
,"30":"Instead everyone will die because of their own sin; whoever eats sour grapes will have his teeth set on edge!"
,"31":"The time is coming - it is Yahweh who speaks - when I will forge a new covenant with the people of Israel and the people of Judah."
,"32":"It will not be like the one I made with their fathers when I took them by the hand and led them out of Egypt. For they broke my covenant although I was their Lord."
,"33":"This is the covenant I shall make with Israel after that time: I will put my Law within them and write it on their hearts; I will be their God and they will be my people."
,"34":"And they will not have to teach each other, neighbor or brother, saying: 'Know the Lord,' because they will all know me, from the greatest to the lowliest, for I will forgive their wrongdoing and no longer remember their sin.'"
,"35":"This is the word of Yahweh, he who gives the sun for light during the day and orders the moon and the stars to give light at night, he who stirs the sea and makes the waves roar, and who is called Yahweh, God of hosts:"
,"36":"'Only if these laws vanish from my sight, - says Yahweh - will the descendants of Israel cease to be a nation before me."
,"37":"Only when the skies above are measured and the foundations of the earth are found below, only then will I reject the descendants of Israel because of what they have done - word of Yahweh."
,"38":"Behold, the days are coming when the city will be rebuilt for Yahweh from the Tower of Hananel to the Corner Gate"
,"39":"and the measuring tape will stretch from there to the hill of Gareb and then turn to Goah."
,"40":"The whole valley where dead bodies and ashes are thrown and all the fields as far as the brook of Kidron and the corner of the Horse Gate on the east will be holy to Yahweh. Never again will the city be uprooted, never again destroyed.'"
}`)
	CurrentBook.AddChapter(32, `{
"1":"This is the word that came to Jeremiah from Yahweh in the tenth year of Zedekiah's reign as king of Judah, the eighteenth year of Nebuchadnezzar."
,"2":"At that time the army of the king of Babylon was besieging Jerusalem and the prophet Jeremiah was imprisoned in the Guards' Courtyard of the royal palace of Judah."
,"3":"Zedekiah king of Judah had him shut up after saying to him, 'Why do you prophesy in the name of Yahweh as you do? Yes, you said: 'I am going to hand this city to the king of Babylon who will take it."
,"4":"And King Zedekiah will not escape from the Chaldeans; he will be delivered into the power of the king of Babylon, speak face to face to him and see him with his own eyes."
,"5":"Zedekiah will be brought to Babylon where he will remain until I deal with him. In any case your fight against the Chaldeans is hopeless'.'"
,"6":"So at that time the word of Yahweh came to Jeremiah:"
,"7":"'Hanamel, son of your uncle Shallum, is going to visit you and ask you to buy his field at Anathoth as it is your right to do so.'"
,"8":"Then my cousin Hanamel came to me in the courtyard of the Guards and said, 'Purchase my field at Anathoth since you have the right of possession and the redemption is yours; buy it for yourself.'"
,"9":"I then understood this was the word of Yahweh and I bought the field from Hanamel and I weighed out the silver for it, seventeen shekels of silver."
,"10":"Then I signed and sealed the deed, had it witnessed and the silver weighed on the scales."
,"11":"Then I took the deed of purchase (the sealed copy containing the terms and conditions and the open copy)."
,"12":"I gave the deed of purchase to Baruch, son of Neriah, son of Mahseiah, in the presence of Hanamel my uncle and the witnesses who signed the deed and before all the Jews who were sitting in the court of the Guards."
,"13":"Then in their presence I commanded Baruch:"
,"14":"This is what Yahweh the God of hosts and the God of Israel says: Take these documents, both the sealed and the unsealed copies of the deed of purchase. Place them in an earthenware jar so that they may last a long time"
,"15":"for Yahweh God of hosts and God of Israel says this: Houses, fields and vineyards will again be bought in this land.'"
,"16":"When I had given the deed of purchase to Baruch son of Neriah, I prayed to Yahweh:"
,"17":"'Ah, Lord Yahweh, you have made the heavens and the earth with your great power and mighty deeds. Nothing is impossible to you!"
,"18":"You show mercy to thousands but bring the punishment for the fathers' sins on their children. Great and Mighty, Yahweh God of hosts is your name!"
,"19":"You are great in planning and mighty in deeds, your eyes follow the ways of all the humans, and you give to each one according to his conduct and the fruit of his actions."
,"20":"You have continually worked signs and wonders, in the land of Egypt, in Israel and among all humankind. Hence you have become famous, as we see today."
,"21":"You brought your people from the land of Egypt with signs and wonders, with your great power and your mighty deeds."
,"22":"You gave your people this land which you had promised with an oath to their fathers, a land flowing with milk and honey."
,"23":"But as soon as they entered and conquered it, they did not listen to you and did not walk according to your Law. They refused to do what you commanded and you brought great misfortune on them."
,"24":"You see, O Yahweh, the mounds built up to take the city are reaching it. And the city exhausted by the sword, famine and plague will be given over to the Chaldeans. What you foretold has happened as you can now see!"
,"25":"And yet you told me, O Lord Yahweh, to buy a field with silver and have the purchase witnessed in the very days the city is falling to the Chaldeans!'"
,"26":"The word of Yahweh then came to Jeremiah:"
,"27":"'I am Yahweh, the God of all humankind. Is there anything impossible for me?"
,"28":"Therefore this is what Yahweh says: I am about to hand the city over to the Chaldeans and Nebuchadnezzar, king of Babylon who will take it."
,"29":"The Chaldeans who are attacking the city will come in and set it on fire. They will burn the houses where the people aroused my anger by burning incense to Baal and pouring drink offerings to foreign gods."
,"30":"For the people of Israel and Judah have done nothing but evil in my sight from their youth."
,"31":"All they did was to arouse my anger with the work of their hands - it is Yahweh who speaks - for this city has so aroused my anger and fury from the time it was built to this day,"
,"32":"that I must remove it from my sight. It is on account of all the evil the people of Israel and Judah have done to anger me - they, their kings and princes, their priests and prophets, the people of Judah and the inhabitants of Jerusalem."
,"33":"They turned their backs to me and not their faces. Although I taught them time and time again they did not listen nor have they learned the lesson."
,"34":"They even put their idols in the sanctuary that houses my Name to defile it."
,"35":"They built high places to Baal in the valley of Ben-Hinnom where they worshipped Baal and sacrificed their sons and daughters to Moloch. This I never commanded nor did I ever think they could do such a detestable thing and so make Judah so sinful."
,"36":"As you say, this city exhausted by the sword, famine and plague will be handed over to the king of Babylon. But now listen to what Yahweh the God of Israel says:"
,"37":"'See, I am going to gather them from all the countries where I scattered them in my anger, fury and great wrath. I will bring them back to this place and have them live in safety."
,"38":"They will be my people and I shall be their God."
,"39":"I will have them think and act in another way, so that they may always fear me for their own good and the good of their children."
,"40":"I will forge an eternal covenant with them by which I shall never cease to do them good and I shall place my fear in their heart so that they may never turn away from me."
,"41":"I shall rejoice in doing them good and I shall plant them securely in this land with all my heart and soul.'"
,"42":"And Yahweh says, 'Just as I brought great disaster on this people, so shall I bring them all the happiness I promised them."
,"43":"Then fields will be bought in this land about which you say that it is a wasteland without man or beast and given over to the Chaldeans."
,"44":"Fields will be bought for silver, and deeds written and sealed and witnessed in the territory of Benjamin and the region around Jerusalem, in the towns of Judah, in the towns of the hill country, in the towns of Shephelah and those of the south. Yes, I will bring back their captives' - word of Yahweh."
}`)
	CurrentBook.AddChapter(33, `{
"1":"When Jeremiah was still detained in the Guards' Court the word of Yahweh came to him a second time:"
,"2":"He who made the earth, who fashioned and established it, he whose Name is Yahweh is speaking to you,"
,"3":"'Call me and I shall answer. I will reveal to you great and mysterious things you have not known.'"
,"4":"For this is what Yahweh God of Israel says, 'You have seen how the houses of Jerusalem and the royal palace of Judah were demolished and used as a defense against the siege mounds in the"
,"5":"fighting against the Chaldeans. But they have been filled with dead bodies, for I slew these people in the fury of my anger when I no longer looked to this city because of their wickedness."
,"6":"However I will apply a remedy for its healing. I will cure them and make them enjoy peace and truth."
,"7":"I will bring back the captives of Judah and Israel and rebuild them as before."
,"8":"I will cleanse them from the guilt of their sin against me and their infidelity."
,"9":"This city will be for me a cause of joy, praise and glory in the sight of all the nations of the earth, when they hear of all the good I do for them. They will fear and tremble when they see all the good and all the peace I provide for them.'"
,"10":"Thus says Yahweh, 'You say of this city that it is a wasteland without men or animals. But in the towns of Judah and in the streets of Jerusalem which are a ruins without men or animals"
,"11":"there will be heard again the sound of merriment and happiness, the song of the newlywed and the voice of those who pray: 'Praise to Yahweh God of hosts, for Yahweh is good and his love endures forever!' When I restore the fortune of the land as it was before,' says Yahweh, 'the voice of those who sing praise in the House of Yahweh will be heard.'"
,"12":"Thus says Yahweh God of hosts: In this place, which is a wasteland without men or animals and in all its towns, there will once again be pastures where the shepherds will tend their flocks."
,"13":"In the towns of the hill country, Shephelah and the south, in the territory of Benjamin and the villages around Jerusalem and in the towns of Judah, flocks will pass under the hand of the one who counts them - word of Yahweh."
,"14":"The days are coming when I shall fulfill the promise that I made in favor of Israel and Judah."
,"15":"In those days and at that time I will cause to sprout the shoot of righteousness from David's line; he will practice justice and righteousness in the land."
,"16":"In those days Judah will experience salvation and Jerusalem will live in safety. He will be called Yahweh-Our-Righteousness.'"
,"17":"For Yahweh says, 'David will never be without a descendant seated on the throne of Israel,"
,"18":"nor will the priests and Levites be left without descendants to stand before me and to present burnt offerings, grain offerings and sacrifices.'"
,"19":"The word of Yahweh came to Jeremiah as follows,"
,"20":"'If you are able to break my covenant with the day or my covenant with the night so that night and day would not follow at their appointed times,"
,"21":"then might my covenant with David my servant be broken. Only then would there be no descendant to reign on his throne and no priests or Levites to minister before me."
,"22":"Just as the stars in the sky or the sand on the seashore cannot be counted, to the same extent shall I multiply the descendants of David and the Levites who minister before me.'"
,"23":"Again the word of Yahweh came to Jeremiah,"
,"24":"'Have you not noticed what these people say: 'Yahweh has rejected the two kingdoms he chose.' So they despise my people, and no longer consider them a nation."
,"25":"But Yahweh says: If I have not established my covenant with day and night, if I have not fixed the laws of the heavens and the earth,"
,"26":"then I can reject the descendants of Jacob and David my servant and not take from among them rulers for the descendants of Abraham, Isaac and Jacob. For I am going to restore their fortune and show compassion on them.'"
}`)
	CurrentBook.AddChapter(34, `{
"1":"This was the word of Yahweh addressed to Jeremiah when Nebuchadnezzar, king of Babylon, and his army as well as all the kingdoms of the earth that were under his dominion, and all the peoples were fighting against Jerusalem and all the cities of Judah:"
,"2":"This is the word of Yahweh, God of Israel, 'Go and say this to Zedekiah king of Judah: 'See, I am giving this city to the king of Babylon and he will set it on fire."
,"3":"You will not escape from his hands but will surely be captured and given over to him. You will see him face to face and speak directly to him and you will go to Babylon.'"
,"4":"Just listen, Zedekiah, king of Judah, to the word of Yahweh! This is what Yahweh says about you, 'You will not be slain by the sword;"
,"5":"no, you will die in peace. As they made funeral pyres in honor of your fathers, former kings, so will they make a fire in your honor and lament 'Alas, my master! - word of Yahweh.'"
,"6":"Then Jeremiah the prophet gave this message to Zedekiah, king of Judah in Jerusalem."
,"7":"At that time the army of the king of Babylon was besieging Jerusalem and the cities of Judah which were still resisting - Lachish and Azekah. These were the only fortified cities remaining in Judah."
,"8":"The word of Yahweh came to Jeremiah after King Zedekiah had made a treaty with all the people of Jerusalem to proclaim freedom for the slaves."
,"9":"Everyone was to free his Hebrew slaves, male and female, so that no fellow Jew would be kept in bondage."
,"10":"The princes and all the citizens agreed to this. They made a treaty and so set them free."
,"11":"Yet they changed their mind afterwards and brought back the slaves they had freed and used them as slaves again."
,"12":"Then the word of Yahweh came to Jeremiah,"
,"13":"'Yahweh the God of Israel says this: I made a covenant with your fathers the day I brought them out of Egypt from the house of slavery and I said:"
,"14":"At the end of every seven years you will free your brother Hebrew who sold himself to you. When he has served you for six years, you are to send him away a free man. But your fathers did not listen and paid no attention."
,"15":"Recently you repented and did what was right in my sight when each one proclaimed the freedom of his slave and you made a covenant with me in the House where my Name rests."
,"16":"But now you have gone back on your word and profaned my Name. You have brought back your slaves, male and female, to whom you had given complete freedom and you have again reduced them to slavery."
,"17":"That is why Yahweh says: Since you have not obeyed me in proclaiming freedom for your brothers and neighbors I now proclaim 'freedom' for you, freedom to fall by the sword, plague and famine. I will make you detestable to every kingdom on earth."
,"18":"The men who have sinned against my covenant, who have not observed the terms of the alliance they made before me, I will liken them to the calf they cut in two and then walked between its halves."
,"19":"The princes of Judah and Jerusalem, the court officials, the priests and all the free men who walked between the pieces of the calf,"
,"20":"I will hand them over to their enemies. Their corpses will serve as food for the birds of the air and the beasts of the earth."
,"21":"Zedekiah and his officials I will give over to the hands of their enemies. You saw the army of the king of Babylon withdrawing from you."
,"22":"But now I am issuing an order to bring them back to this city. They will attack and capture the city and set it on fire. As for the towns of Judah I will reduce them to a wasteland without inhabitants.'"
}`)
	CurrentBook.AddChapter(35, `{
"1":"A message from Yahweh came to Jeremiah in the days of Joasiah's son Jehoiakim, king of Judah:"
,"2":"'Go to the Rechabite family; speak to them and bring them to a room in the House of Yahweh; then give them wine to drink.'"
,"3":"So I went to get Jaazaniah, son of Jeremiah, son of Habazziniah, his brothers and sons and all the household of the Rechabites."
,"4":"I brought them to the House of Yahweh, into the room of the sons of Hanan, son of Igdaliah, the man of God. It was close to the room of the leaders which is above the room of the doorkeeper Maasekah, son of Shallum."
,"5":"I then placed pitchers of wine and cups before the Rechabites and told them, 'Drink wine!'"
,"6":"But they answered, 'We don't drink wine because our father Jonadab son of Rechab commanded us: 'Never drink wine, you as well as your children;"
,"7":"don't build a house and don't sow seeds. You shall not plant or own a vineyard; do nothing like that but live in tents all your days so that you may live for a long time in the land where you dwell!'"
,"8":"We have observed all the commands of our father Jonadab, son of Rechab, always abstaining from wine, we, our wives, our sons and daughters."
,"9":"We haven't built houses to live in and we have no vineyards, fields or seeds."
,"10":"We live in tents and we obey and practice all that our father Jonadab ordered us."
,"11":"But when king Nebuchadnezzar of Babylon attacked the land, we said: 'Come, we shall go to Jerusalem to escape from the army of the Chaldeans and the army of the Arameans. This is why now we stay in Jerusalem.'"
,"12":"Yahweh spoke again to Jeremiah,"
,"13":"'Yahweh the God of hosts and the God of Israel bids you to go and tell the people of Judah and the citizens of Jerusalem: Will you reject a correction and refuse what I say? - word of Yahweh."
,"14":"Jonadab son of Rechab commanded his children not to drink wine, and his words have been observed; to this day they have obeyed their father by not taking wine. As for you, I have spoken to you time and time again and you have not listened to me!"
,"15":"I have sent you my servants the prophets again and again saying: 'Turn away from your wickedness, reform your way of life and do not follow other gods to serve them. Then you will live in the land that I gave you and your forefathers.' But you neither heeded nor listened to me."
,"16":"The descendants of Jonadab son of Rechab have carried out their father's order but this nation has not obeyed me.'"
,"17":"Therefore this is what Yahweh the God of hosts and the God of Israel says, 'I am going to bring on Judah and on everyone living in Jerusalem all the disaster I foretold, because I spoke and they would not listen, I called and they would not respond.'"
,"18":"Then Jeremiah said to the Rechabites, 'This is what Yahweh God of hosts and God of Israel says: 'Because you have been obedient to your father Jonadab and observed all his instructions, because you have acted according to his commands,"
,"19":"because of that - word of Yahweh - Jonadab shall always have a descendant to stand before me.'"
}`)
	CurrentBook.AddChapter(36, `{
"1":"This word from Yahweh came to Jeremiah in the fourth year of Jehoiakim son of Josiah."
,"2":"'Get a scroll and write on it all that I have spoken to you concerning Jerusalem, Judah and all the nations, from the first day I spoke to you in the time of Josiah until this day."
,"3":"Perhaps when the people of Judah hear of all the afflictions I intend to send them, to make each of them turn away they would decide to turn from their wicked ways. Hence I may forgive their wickedness and sin.'"
,"4":"Jeremiah then called Baruch son of Neriah and while Jeremiah dictated, Baruch wrote on the scroll all that Yahweh had said."
,"5":"Then Jeremiah commanded Baruch, 'I am in jail and cannot go to Yahweh's House."
,"6":"So you go to Yahweh's House on a day of fasting and read publicly all that you wrote as I dictated. Read it to all the people of Judah who come in from their towns."
,"7":"Perhaps they will entreat Yahweh and each one will turn from his wickedness, for great is the wrath of Yahweh and the punishment with which he has threatened this people.'"
,"8":"So Baruch Neriah's son did all that the prophet Jeremiah had commanded about this reading in the House of Yahweh."
,"9":"In the ninth month of the fifth year of Josiah's son Jehoiakim, king of Judah, a fast before Yahweh was proclaimed to all the people in Jerusalem and all the people who came from the towns of Judah. Then in the House of Yahweh Baruch read publicly the words of Jeremiah written in the scroll."
,"10":"This he did in the room of the secretary Gemariah Shapan's son, in the upper court at the entry of the New Gate of the House of Yahweh."
,"11":"When Micaiah son of Gemariah, son of Shaphan heard all of Yahweh's words written on the scroll"
,"12":"he went to the secretary's room in the king's house where all the officials were sitting - Elishama, the secretary, Delaiah, son of Shemaiah; Elnathan, son of Acbor; Gemariah, son of Shaphan; Zedekiah, son of Hananiah, and the rest of the officials."
,"13":"Micaiah told them all that he had heard when Baruch read the the content of the scroll to the people."
,"14":"Then all the officials sent Jehudi, son of Netaniah, the son of Shelemiah, the son of Cushi, to say to Baruch, 'Bring the scroll from which you read to all the people and come!' So Baruch went with the scroll in his hand."
,"15":"They told him to sit down and read it to them, and Baruch read it to them."
,"16":"When they heard all that, they gazed at one another in fear and said, 'We ought to tell this to the king.'"
,"17":"They then asked Baruch, 'May we know how you wrote that.' He said,"
,"18":"'As he dictated these words, I wrote them in ink on the scroll.'"
,"19":"Then the officials instructed Baruch, 'Jeremiah and you have to hide and let no one know where you are.'"
,"20":"They kept the scroll in the room of Elishama the secretary and went to the king in the courtyard and reported all to him."
,"21":"The king then sent Jehudi to bring him the scroll. Jehudi brought it from Elishamah's room and read it to the king and to all the officials standing around him."
,"22":"Now it was the ninth month and the king was sitting in the winter palace while a fire was burning in the fire pot in front of him."
,"23":"Whenever Jehudi finished reading three or four columns, the king would cut them off into pieces with the secretary's knife and cast them in the fire until the whole scroll was burned."
,"24":"Neither the king nor his officials were afraid when they heard all these words and they did not tear their garments."
,"25":"And yet Elnathan, Deliah and Gemariah had urged the king not to burn the scroll, but he did not listen."
,"26":"Instead the king ordered Jerahmeel, a son of the king, Seraiah son of Azriel and Shelemiah son of Abdeel to arrest Baruch the secretary and Jeremiah the prophet; but Yahweh concealed them."
,"27":"A word of Yahweh came to Jeremiah after the king burned the scroll with the words Baruch had written as Jeremiah dictated,"
,"28":"'Take another scroll and write on it all the words that were on the first one which Jehoiakim burned."
,"29":"And tell Jehoiakim this message of Yahweh: You have burned the scroll and you said: This man dared to write that the king of Babylon will certainly destroy this land and wipe away from it men and animals!"
,"30":"That is why Yahweh has spoken against Jehoiakim, king of Judah: Not one of his descendants will sit on the throne of David. His dead body will be exposed to the heat of day and the chill of night."
,"31":"I will ask him to account as well as his children and his attendants for their wickedness. I will pour out on them all the disasters and it will be the same for the people of Judah and the inhabitants of Jerusalem I have foretold against them, because they have paid no attention.'"
,"32":"Then Jeremiah took another scroll and gave it to Baruch son of Neriah, the secretary. He wrote on it all the words of the scroll that Jehoiakim king of Judah burned in the fire, and he added many more similar words."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Josiah's Zedekiah was appointed by Nebuchadnezzar king of Babylon to be king of Judah in the place of Jehoiakin son of Jehoiakim."
,"2":"But neither he nor his attendants nor the people of the land paid attention to the words of Yahweh spoken through Jeremiah the prophet."
,"3":"King Zedekiah sent Jehucal son of Shelemiah with the priest Zehaniah son of Maaseiah to Jeremiah to say, 'Intercede for us with Yahweh our God!'"
,"4":"At that time Jeremiah had not yet been imprisoned and he was still going about among the people."
,"5":"Pharaoh's army had come out of Egypt and when the Chaldeans heard of this, they withdrew from Jerusalem."
,"6":"Then the word of Yahweh came to Jeremiah the prophet:"
,"7":"'Yahweh the God of Israel has spoken. Say this to the king of Judah who sent you to consult me: Pharaoh's army which was on its way to help you is about to return to its own land,"
,"8":"and the Chaldeans will come back and attack this city. They will capture it and set it on fire."
,"9":"Do not deceive yourselves by saying that the Chaldeans are not to come back, because they surely will."
,"10":"Even if you had defeated the whole Chaldean army and they were left with only wounded men, they would all come out of their tents and set fire to this city.'"
,"11":"While the Chaldean army was withdrawing from Jerusalem because of the advance of Pharaoh's troops,"
,"12":"Jeremiah left Jerusalem to go to the territory of Benjamin to receive an inheritance there."
,"13":"But upon reaching the Benjamin Gate he was stopped by a sentry named Irijah, son of Shelemiah, son of Hananiah who said, 'You are deserting to the Babylonians!'"
,"14":"Jeremiah answered, 'There's no truth to that!' But Irijah did not listen. He nabbed Jeremiah and brought him to the officials."
,"15":"They were so angry with Jeremiah, they beat him and locked him in the house of Jonathan the secretary which had been transformed into a prison."
,"16":"Jeremiah was put in the dungeon cells and was kept there for a number of days."
,"17":"Then King Zedekiah sent for him and secretly questioned him in his house:'Is there any word from Yahweh?' Jeremiah replied, 'Yes, there is!' and added, 'You will be handed over to the king of Babylon!'"
,"18":"Then Jeremiah said to King Zedekiah, 'What wrong have I done to you, to your servants or to the people that you should have me imprisoned?"
,"19":"Where are your prophets"
,"20":"who said to you: 'The King of Babylon will never come to attack you and destroy this land?' Now listen to me, my lord king! Take heed of my plea and do not send me back to the house of Jonathan the secretary, for there I am doomed to die!'"
,"21":"So King Zedekiah ordered that Jeremiah be transferred to the Guards' Court and that every day he be supplied with loaf of bread from the bakers' street until there was no more bread. So Jeremiah remained in the Guards' Court."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Shephatiah son of Mattan, Gedaliah son of Pashhur son of Malchiah heard what Jeremiah said publicly"
,"2":"in the name of Yahweh, 'Anyone who stays in the city will perish by the sword, famine and plague, but whoever surrenders to the Chaldeans will survive although he may lose everything."
,"3":"For Yahweh has spoken: I have handed over this city to the king of Babylon and he will take it.'"
,"4":"Then the officials told the king, 'This man should be put to death, because he is weakening the will of the fighting men and the people left the city. In fact he is not out to save the people but to do harm.'"
,"5":"King Zedekiah said, 'His life is in your hands for the king has no power against you.'"
,"6":"So they took Jeremiah and threw him into the cistern of Malchiah the king's son, in the Guards' Court. They lowered him by means of ropes. There was no water in the cistern but only mud and Jeremiah sank into the mud."
,"7":"Ebedmelech, an Ethiopian official of the king's house, heard that they had lowered Jeremiah in the cistern. While the king was sitting at the Benjamin Gate,"
,"8":"Ebedmelech went and spoke to him,"
,"9":"'My lord king! These men have acted wickedly in all they did to Jeremiah the prophet. They threw him into the cistern where he will die.'"
,"10":"So the king ordered Ebedmelech the Ethiopian: 'Take three men with you from here and draw Jeremiah the prophet out from the cistern before he dies.'"
,"11":"Ebedmelech took the men with him and went into the king's house beneath the treasury. There he got pieces of rags and old clothes which he lowered by means of ropes to Jeremiah in the cistern."
,"12":"Ebedmelech said to Jeremiah, 'Put the pieces of rags and old clothes under your armpits, over the ropes.' This Jeremiah did."
,"13":"Then Jeremiah was pulled up from the cistern by means of the ropes and was brought to the Guards' Court to stay there."
,"14":"King Zedekiah sent for Jeremiah the prophet and received him at the third entrance of Yahweh's House and there said to him, 'I am going to ask you a question; hide nothing from me!' Jeremiah said to Zedekiah,"
,"15":"'If I tell you something, won't you put me to death? And if I advice you, will you listen to me?'"
,"16":"King Zedekiah swore secretly to Jeremiah: 'As Yahweh lives who gave us a soul, I will not have you die and I will not hand you over to those who want to kill you.'"
,"17":"Jeremiah told to Zedekiah, 'This is what Yahweh God of hosts and God of Israel says: If you surrender to the officers of the king of Babylon you will survive and the city will not be burned. You and your household will live."
,"18":"But if you surrender not to the king of Babylon, this very city will be handed over to the Chaldeans and they will set it on fire. For your part, you will not escape.'"
,"19":"King Zedekiah said to Jeremiah, 'I am afraid of the people of Judah who have surrendered to the Chaldeans. I fear the Chaldeans will give me over to them and they will ill-treat me.'"
,"20":"Jeremiah said, 'They will not hand you over. Listen to what Yahweh says to you through me; it will be well with you and you will live."
,"21":"But if you refuse to surrender, this is what Yahweh has let me see:"
,"22":"All the women left in your palace will be handed over to the officers of the king of Babylon and will sing this song: 'Your friends have deceived and overcome you. When your feet have sunk into the mud, they turn away from you!'"
,"23":"All your wives and children shall be led out to the Chaldeans and you will not escape from them. You will be nabbed by the king of Babylon and this city will be burned down!'"
,"24":"Then Zedekiah said to Jeremiah, 'Let no one know about this conversation lest you will die."
,"25":"If the officials hear that I have spoken with you and if they come to you and ask you what I spoke of to you, even though they threaten you,"
,"26":"you will say to them: I only made a petition to the king not to send me back to the house of Jonathan to die.'"
,"27":"All the officials came to Jeremiah and questioned him. He replied just as the king had instructed him, and they said no more since no one had overheard the conversation."
,"28":"But Jeremiah remained in the Guards' Court until the day Jerusalem was taken."
}`)
	CurrentBook.AddChapter(39, `{
"1":"In the tenth month of the ninth year of Zedekiah king of Judah, Nebuchadnezzar king of Babylon came with his entire army and they besieged Jerusalem."
,"2":"On the ninth day of the fourth month in Zedekiah's eleventh year a breach was made in the city wall."
,"3":"All the officials of the king of Babylon entered and took their seats at the Middle Gate: Nergal-Sherazer of Samgar, Sarsekim chief officer, Nergal-Sherazer a high official and all the officials of the king of Babylon."
,"4":"Upon seeing this, King Zedekiah of Judah and all the military fled from the city by night, going out by way of the king's garden through the gate between the two walls in the direction of Arabah."
,"5":"But the Chaldean army chased them and caught up with Zedekiah in the plains of Jericho. They took him and brought him up to the king of Babylon at Riblah in the land of Hamath. There Nebuchadnezzar passed sentence on him."
,"6":"The king of Babylon slaughtered the sons of Zedekiah in his presence and all the nobles of Judah."
,"7":"He gouged Zedekiah's eyes and bound him with a double bronze chain to take him to Babylon."
,"8":"The Chaldeans burned the King's palace along with the people's abodes and then broke down the walls of Jerusalem."
,"9":"Nebuzaradan, commander of the guards, deported to Babylon the remainder of the people who stayed in the city as well as those who had deserted to his side and those craftsmen who were still there."
,"10":"As for the poorest people who owned nothing, Nebuzaradan left them at that time in the land of Judah, giving them vineyards and fields."
,"11":"Nebuchadnezzar king of Babylon had given orders about Jeremiah to Nebuzaradan chief of the guards:"
,"12":"'Take him and look after him; do him no harm but deal with him just as he tells you.'"
,"13":"Nebuzaradan commander of the guards, Nebushazban a chief officer, Nergal-Sharezer, a high official and all the other officers of the king of Babylon"
,"14":"sent and had Jeremiah taken from the Guards' Court and given over to Gedaliah son of Ahikam son of Shaphan. So he remained among the people."
,"15":"Now the word of Yahweh had come to Jeremiah while he was imprisoned in the Guards' Court:"
,"16":"'Go and talk to Ebedmelek the Ethiopian: Tell him this word of Yahweh the God of hosts and the God of Israel: You see on that day that I am about to carry out what I have foretold in the past, disaster and not prosperity for this city."
,"17":"But I will save you on that day - word of Yahweh - and you will not be handed over to the men whom you fear. For I will certainly save you and you will not perish by the sword."
,"18":"You will be able to escape and live because you have trusted me - it is Yahweh who speaks.'"
}`)
	CurrentBook.AddChapter(40, `{
"1":"The word of Yahweh came to Jeremiah after Nebuzaradan, commander of the guards, had released him at Ramah when he had taken him, bound in chains, with those to be deported from Jerusalem and Judah to Babylon."
,"2":"The commander of the guards took Jeremiah and said to him, 'Yahweh your God foretold this calamity for this place."
,"3":"Now he has implemented what he then said he would do because you have sinned against him and have not listened to him."
,"4":"But I have been removing today the fetters off your hands and releasing you to be free... You may wish to go with me to Babylon and I will take care of you. However I am not obliging you if you decide not to go. You have the choice to go wherever you like in this land.'"
,"5":"Nebuzaradan added, 'Why don't you go back to Gedaliah son of Ahikam son of Shaphan? He has been appointed governor over the towns of Judah by the King of Babylon. You could stay with him among your people. Yet go wherever it seems right for you to go.' The commander of the guards gave him provisions and a gift and set him on his way."
,"6":"And so Jeremiah went to Gedaliah son of Ahikam who was residing at Mizpah. He stayed with him among the people who were left in the land."
,"7":"Now all the army chiefs in the open country with their men heard that the king of Babylon had appointed Gedaliah son of Ahikam to be governor over the land and put him in charge of the men, women and children and the lowliest of the people who had not been deported to Babylon."
,"8":"They came to Gedaliah at Mizpah: Ishmael son of Nethaniah, Johanan and Jonathan the sons of Kareah, Seraiah son of Tanhumeth, the sons of Ephai the Netophathite and Jaazaniah son of Maacathite and their men."
,"9":"Gedaliah son of Ahikam son of Shaphan swore to them and their men: 'Don't be afraid to serve the Chaldeans; remain in the country, serve the king of Babylon and all will be well with you."
,"10":"As for me, I am based here in Mizpah and I am your representative with the Chaldeans who settle at this place. For your part gather wine, fruit and oil; store it in your vessels and stay in the towns you have occupied.'"
,"11":"The Jews who were in Moab, Ammon, Edom and in the other lands also learned that the king of Babylon had left a remnant of the population and that he had placed over them Gedaliah son of Ahikam, son of Shaphan."
,"12":"All of these Jews returned from the places where they had been dispersed and came to Gedaliah at Mizpah in the land of Judah. There they gathered in wine and fruit in great quantities."
,"13":"Johanan son of Kareah and all the chiefs of guerrilla warfare came to Gedaliah at Mizpah"
,"14":"and said, 'Don't you know that Baalis, king of the Ammonites has commissioned Ishmael son of Nethaniah to assassinate you?'"
,"15":"But Gedaliah, son of Ahikam, did not believe him. Then Johanan spoke secretly to Gedaliah at Mizpah, 'Let me go and kill Ishmael son of Nethaniah without anyone knowing. Don't allow him to kill you lest all the Jews assembled with you be dispersed and the rest of Judah perish.'"
,"16":"But Gedaliah son of Ahikam said to Johanan son of Kareah, 'Don't do that because what you have said about Ishmael is a lie.'"
}`)
	CurrentBook.AddChapter(41, `{
"1":"It was the seventh month when Ishmael son of Nethaniah son of Elishama, a member of the royal family who had been chief officer of the king, came with ten men to Gedaliah, son of Ahikam, son of Shaphan at Mizpah. While they were eating together"
,"2":"Ishmael and the men with him stood up and slew Gedaliah with the sword, thus killing the man whom the king of Babylon had appointed governor of the land."
,"3":"Ishmael also killed the Jews who were with Gedaliah at Mizpah as well as the Chaldean soldiers who were there."
,"4":"Two days after the assassination of Gedaliah and before anyone had heard of it,"
,"5":"eighty men from Shechem, Shiloh and Samaria arrived with beards shaved, torn clothes and their bodies slashed, carrying offerings and incense to the House of Yahweh."
,"6":"Ishmael son of Nethaniah left Mizpah to meet them weeping as they went. He said to them,"
,"7":"'Come along to Gedaliah, son of Ahikam.' But as soon as he came to the center of the town, Ishmael son of Nethaniah and the men with him killed them and threw their bodies into a cistern."
,"8":"Ten of these men, however, said to Ishmael, 'Don't kill us for we have provisions hidden in the country, corn, oil barley and honey.' These Ishmael did not kill with the others."
,"9":"The cistern where Ishmael had thrown the corpses of these people he had killed was the large cistern built by King Asa when he had to defend himself against Basha king of Israel. Ishmael son of Nethaniah filled it with their corpses."
,"10":"Ishmael took captive the small population of Mizpah, the royal princesses whom Nebuzaradan, commander of the bodyguard had left in the care of Gedaliah. Ishmael obliged them to follow him and set out for the land of the Ammonites."
,"11":"When Johanan son of Kareah and the army officers with him heard of the crimes of Ishmael they assembled their men and set off to fight Ishmael."
,"12":"They caught up with him at the great pool of Gibeon."
,"13":"As soon as the people Ishmael had taken by force from Mizpah saw Johanan, son of Kareah and the army officers with him, they rejoiced"
,"14":"and turned back to join Johanan."
,"15":"In the meantime Ishmael was able to flee from Johanan with eight men and went to the Ammonites."
,"16":"Then Johanan and the army officers with him took the people he had rescued from Ishmael, son of Nethaniah. They were those men, women, children and court officials that Ishmael carried off by force from Mizpah after slaying Gedaliah. Johanan brought them from Gibeon,"
,"17":"and they stayed at Geruth Chimham near Bethlehem. They planned to go on later towards Egypt"
,"18":"for fear of the Chaldeans because Ishmael had slain Gedaliah who was appointed governor of the land by the king of Babylon."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Then the army officers, especially Johanan, son of Kareah and Jezaniah son of Hoshaiah, and all the people from the smallest to the greatest came to speak to Jeremiah:"
,"2":"'Listen to our plea and pray to Yahweh our God for us, this remnant of people, because really we are few from many, as you can see."
,"3":"May Yahweh your God show us the way we should go and what we should do.'"
,"4":"Jeremiah the prophet answered them, 'I have heard you. Yes, I am going to speak to Yahweh as you have requested. And whatever be the word of Yahweh, I shall let you know it without hiding anything.'"
,"5":"They said to Jeremiah, 'May Yahweh be a true and worthy witness against us if we do not act according to every word that Yahweh your God will say to us through you!"
,"6":"Whether it be good or bad for us we will obey Yahweh our God to whom we are sending you, so it will be well with us for having obeyed the voice of Yahweh our God.'"
,"7":"Ten days later the word of Yahweh came to Jeremiah."
,"8":"He then called Johanan, son of Kareah and the army officers with him and all the people from the least to the greatest"
,"9":"and said to them, 'This is the word of Yahweh, God of Israel to whom you sent me with your petition:"
,"10":"If you wish to live peacefully in this land I will build you up and not pull you down, I will plant you and not uproot you for I will relent of the harm I did you."
,"11":"You are afraid of the king of Babylon, but do not fear him - word of Yahweh - for I am with you to save you and rescue you from his hand."
,"12":"I will put mercy in his heart so that he may have mercy on you and let you live in your own land."
,"13":"But if you say: 'No, we will no longer live in this land,' disobeying the voice of Yahweh your God,"
,"14":"and if you say: 'No, we shall go to Egypt where we shall no more have wars or hear the trumpet call, where we shall not be hungry for bread!'"
,"15":"Then hear the word of Yahweh, remnant of Judah! Yahweh God of hosts and God of Israel speaks: 'If you turn towards Egypt to go there and stay there,"
,"16":"the sword you fear will strike you there in the land of Egypt and famine which you dread will be yours there in Egypt and you will die."
,"17":"All those who turn towards Egypt to enter and live there will die by sword, famine and pestilence. No one will escape or flee from the misfortune that I will bring upon them.'"
,"18":"This is what Yahweh God of hosts and God of Israel says, 'Just as my burning anger was poured out on the people of Jerusalem, so will my fury be poured out on you when you go to Egypt. You will become a curse and a reproach and you will never again see this place.'"
,"19":"That is what Yahweh has foretold, O remnant of Judah. Do not go to Egypt; be quite sure that I have warned you today."
,"20":"You risked your lives when you sent me to Yahweh your God saying: 'Pray for us to Yahweh our God and tell us all that Yahweh says and we shall do it.'"
,"21":"I have told you today though you still do not obey Yahweh your God in all that he told you through me."
,"22":"Be sure of this, it will be by the sword, famine and pestilence that you will die in the place where you want to go and live.'"
}`)
	CurrentBook.AddChapter(43, `{
"1":"Jeremiah had hardly finished giving the message of Yahweh to the people - all that Yahweh had sent him to say -"
,"2":"when Azariah son of Hoshiah and Johanan son of Kareah and all the arrogant men said to Jeremiah, 'You are lying! Yahweh our God did not send you to tell us not to go and settle in Egypt."
,"3":"No, Baruch son of Neriah is prompting you to hand us over to the Chaldeans either to be killed or deported to Babylon!'"
,"4":"So neither Johanan son of Kareah nor the army officers nor the people heeded Yahweh's command to stay in the land of Judah."
,"5":"Instead Johanan and the army officers led away the remnant of the Jews who had returned to the land of Judah from the nations where they had been driven."
,"6":"They also led away the men, women, children and the royal princesses - all those that Nebuzaradan, commander of the bodyguard, had left in the care of Gedaliah, son of Ahikam, son of Shaphan, with Jeremiah, the prophet and Baruch, son of Neriah."
,"7":"So in defiance of Yahweh's order they entered Egypt and arrived at Tahpanhes."
,"8":"There at Tahpanhes the word of Yahweh came to Jeremiah: 'While the Jews are watching you,"
,"9":"take some large stones and bury them in clay in the brick terrace at the entrance to Pharaoh's house at Tahpanhes"
,"10":"and then say to them: This is what Yahweh God of hosts and God of Israel says: I am sending for my servant Nebuchadnezzar king of Babylon and he will set his throne over these stones that I have hidden here and spread a royal canopy."
,"11":"He shall come and strike the land of Egypt bringing death to those destined to die, captivity for those destined to be taken captive, sword for those destined for the sword."
,"12":"He will set fire to the temples of the Egyptian gods; these gods will be burned or carried away. As a shepherd wraps himself in a cloak, so will the king of Babylon wrap the land of Egypt about himself and depart in safety."
,"13":"He will break the sacred pillars at Heliopolis and burn the temples of the gods in Egypt.'"
}`)
	CurrentBook.AddChapter(44, `{
"1":"A word of Yahweh came to Jeremiah concerning all the Jews living in Egypt especially in the cities of Migdal, Tahpanhes and Memphis, as well as in the territory of Patros:"
,"2":"'You have seen all the disaster that I brought on Jerusalem and the towns of Judah."
,"3":"These are no more than ruins without inhabitants because of the evil they have done. They have provoked my anger by offering incense to foreign gods that neither they nor their fathers knew."
,"4":"I sent them my servants the prophets time and time again to tell them: 'Do not do this abominable thing that I detest!'"
,"5":"But they did not listen or pay attention; they did not turn away from their evil ways or give up worshiping strange gods."
,"6":"Then the fury of my anger was loosed and blazed in the towns of Judah and the streets of Jerusalem making them the desolate ruins they are today."
,"7":"And now Yahweh the God of hosts and the God of Israel asks you: Why do you bring such great harm on yourselves? Because of your deeds every man, woman, child and infant will be taken from Judah and you will be left without a remnant."
,"8":"Why do you provoke my anger with the work of your hands? Why do you worship foreign gods in Egypt where you came to live? Surely you will decrease in number and be a curse and an object of reproach among all the nations?"
,"9":"Have you forgotten the wickedness of your fathers and the misdeeds of the kings of Judah and its princes, and the evil behavior of your wives in the land of Judah and the streets of Jerusalem?"
,"10":"So far they have had no contrition and have not followed my law and my decrees that I set before you and your fathers.'"
,"11":"Because of this Yahweh God of hosts and God of Israel warns you, 'I am turning my face away from you to bring disaster on you and to completely destroy Judah."
,"12":"The remnant of Judah that chose to enter Egypt and live there will all perish. They will be destroyed by the sword and famine and become an object of horror and cursing, of condemnation and reproach."
,"13":"I will punish those in Egypt as I punished Jerusalem with the sword, famine and pestilence."
,"14":"None of the remnant of Judah that came to Egypt will escape or flee, and return to Judah where you long to go and live.'"
,"15":"Then all the men who knew their wives were offering incense to foreign gods and all the women, a great assembly, replied to Jeremiah in a louder voice."
,"16":"'As for what you say in the name of Yahweh we will not listen;"
,"17":"we want to do all that we said we wanted to do: burn incense to the queen of heaven and pour out wine to her as we did, we and our fathers, our kings and princes in the towns of Judah and the streets of Jerusalem. Then we had our fill of bread and were prosperous and free from misfortune."
,"18":"But since we stopped burning incense to the queen of heaven we have been in need of everything and have perished by the sword and famine.'"
,"19":"And the women added, 'When we offered incense and poured libations to the queen of heaven, didn't our husbands know that we made sacrificial cakes decorated with her image?'"
,"20":"Jeremiah then answered all the people, men and women, who had told him this:"
,"21":"'Is it not better that Yahweh remembered the incense you burned in the towns of Judah and in the streets of Jerusalem, you, your fathers, your kings, princes, and all the people?,Do you think it slipped his memory?"
,"22":"Yahweh could no longer bear the sight of your evil and abominable deeds. That is why your land has become the desolate waste that it is today!"
,"23":"All the misfortune that you are suffering today has happened because you burned incense and sinned against Yahweh, by not obeying him or following his law, his instructions and his commands.'"
,"24":"Jeremiah then addressed all the people especially the women, 'Listen to Yahweh's message:"
,"25":"This is what Yahweh the God of hosts and the God of Israel says: You and your wives think that what you say with your lips becomes an obligation you must fulfill. You say: 'We are bound to keep the vows we have made to burn incense and pour out wine to the queen of heaven.' Go ahead! Fulfill your vows and do what you promised!"
,"26":"Nevertheless listen, all you Jews living in Egypt, listen to what Yahweh says to you: By my own great Name I swear - word of Yahweh - that throughout Egypt no one from Judah will invoke my Name; no one will be left to say: 'As the Lord Yahweh lives.'"
,"27":"I am watching over them but not for their good. All the people of Judah in Egypt will perish by the sword and famine until they are wiped out."
,"28":"Only a few will escape the sword and return from Egypt to Judah; and the remnant who came to settle in Egypt will understand whose word comes true, theirs or mine!"
,"29":"And this is the sign that I will punish you in this place, says Yahweh, that you may know that my threatening words to you will be fulfilled:"
,"30":"I will hand over the Pharaoh Hophra, king of Egypt to his enemies who want to slay him, just as I let Zedekiah, king of Judah, be taken by his adversary, Nebuchadnezzar king of Babylon, who was determined to kill him."
}`)
	CurrentBook.AddChapter(45, `{
"1":"These are the words of Jeremiah the prophet to Baruch, son of Neriah who wrote on a scroll what Jeremiah dictated. It was in the fourth year of the reign of Jehoiakim son of Josias king of Judah when he said"
,"2":"'There is a word of Yahweh for you, Baruch. Why do you complain:"
,"3":"'Alas for me! I am weary of sighing and I find no rest!'"
,"4":"Yahweh says: 'When I am knocking down what I have built and pulling up what I planted,"
,"5":"why do you want great things for yourself? Don't look for them! Yet, though I am about to send disaster on everyone - word of Yahweh - you will be safe wherever you go.'"
}`)
	CurrentBook.AddChapter(46, `{
"1":"These are Yahweh's words addressed to the prophet Jeremiah concerning the nations."
,"2":"Concerning Egypt, this is the message against the army of Pharaoh Neco, king of Egypt, which was defeated at Carchemish on the Euphrates by Nebuchadnezzar, king of Babylon, in the fourth year of Jehoiakim, son of Josiah, king of Judah:"
,"3":"'Prepare shield and buckler, and march to battle!"
,"4":"Harness the horses. Into your saddles, horsemen!,To your ranks, with your helmets on!,Polish your spears!,Put on your breastplates!"
,"5":"But what do I see?,With broken ranks they fall back; their warriors are routed. They flee headlong without looking back, as terrors explode on every side."
,"6":"The swift cannot flee, nor the hero escape. In the north by the Euphrates, they stumble and fall."
,"7":"Who is this surging forward like the Nile, like rivers of billowing waters?"
,"8":"Egypt surges like the Nile, like rivers of billowing waters. She says, 'I will rise and flood the earth; I will sweep cities and their people away.'"
,"9":"Charge, horses!,Drive madly, charioteers!,March on, warriors -,men of Cush and Put, with your shields, men of Lydia, with your bows."
,"10":"This is the day of Yahweh God of hosts, a day of vengeance on his foes. The sword devours, drunk with blood; for Yahweh Sabaoth holds a sacrifice,in the north country by the Euphrates."
,"11":"Go up to Gilead in search of balm, virgin daughter of Egypt. You have taken medicines in vain, but for you there is no healing."
,"12":"The nations have heard of your shame, the earth is filled with your cries; warrior has stumbled against warrior, and both have fallen together.'"
,"13":"This is the message Yahweh gave to the prophet Jeremiah about the coming of Nebuchadnezzar, king of Babylon, who was to attack Egypt:"
,"14":"'Announce this in Egypt, and proclaim it in Migdol, Memphis and Tahpanhes. Say to them: Take your posts; prepare for the worst!,The sword has devoured your neighbors."
,"15":"Why has Apis fled?,Your black bull god did not make a stand!,Why? Because Yahweh thrust him down"
,"16":"and caused him to stumble and fall. Then they said to each other: 'Get up, let us go back to our people, to the land of our birth, away from the devouring sword.'"
,"17":"Pharaoh, king of Egypt, will be called 'The noisy one who lets his chance slip by.'"
,"18":"As surely as I live - says the King,whose name is Yahweh Sabaoth -,one will come who is like Tabor, like Carmel above the sea."
,"19":"Pack your belongings ready for exile, you who live in Egypt, for Memphis will be laid waste, without inhabitants and desolate."
,"20":"Egypt is a beautiful heifer, but a gadfly from the north has come upon her."
,"21":"The mercenaries in her ranks,are like fattened calves; but they too have fled,failing to stand their ground, for the day of their calamity has come, the time of their punishment."
,"22":"She makes a sound like a fleeing serpent,as her enemies advance in force, coming against her with axes, like loggers cutting down trees."
,"23":"Dense though her forest be, they will raze it - says Yahweh. They are beyond number, more numerous than locusts."
,"24":"The daughter of Egypt will be abased, handed over to the people of the north.'"
,"25":"Yahweh Sabaoth, the God of Israel, has said: 'I will punish Amon of Thebes, and Egypt with her gods and kings, Pharaoh and those who trust in him."
,"26":"I will hand them over to those who seek their lives, to Nebuchadnezzar, king of Babylon, and his ministers. Later, however, Egypt will be inhabited again as in times past - it is Yahweh who says so."
,"27":"But fear not, my servant Jacob; be not dismayed, O Israel. I will deliver you from a distant land, your descendants from their place of exile. Jacob will again find rest, and no one will make him afraid."
,"28":"Fear not, Jacob my servant, for I am with you - Yahweh speaks - I will make an end of the nations among which I scattered you, but I will spare you. I will discipline you, though, with justice; I will not let you go unpunished."
}`)
	CurrentBook.AddChapter(47, `{
"1":"This is Yahweh's word that came to the prophet Jeremiah concerning the Philistines before Pharaoh attacked Gaza."
,"2":"Thus says Yahweh: 'Look, waters rise from the north; soon they will become a raging flood,overflowing the land and all it contains, the towns and their inhabitants. All dwellers in the land will wail"
,"3":"at the sound of the hooves of stamping steeds, the rattle of chariots, the rumbling of wheels. Fathers forget their children, as their hands fall limp."
,"4":"The day of ruin has come upon the Philistines; Tyre and Sidon, the last of their allies, are cut off from them. Yahweh is set to destroy the Philistines, the remnant from the coasts of Caphtor."
,"5":"Gaza is shaved bald, Ashkelon has perished. O remnant in the valley, how long will you gash yourselves?"
,"6":"O sword of Yahweh, how long before you rest?,Return to your scabbard; stop and keep still!"
,"7":"But how can it rest, when it is Yahweh who commanded it,to attack Ashkelon and the seacoast?'"
}`)
	CurrentBook.AddChapter(48, `{
"1":"Concerning Moab. Yahweh the God of Israel, says this: 'Woe to Nebo, for it is laid waste. Kiriathaim is captured and disgraced; the fortress is shattered and abased."
,"2":"No more will Moab be praised; men in Heshbon are plotting her downfall: 'Let us put an end to that nation!',You, too, Madmen, will be subdued; behind you stalks the sword."
,"3":"Listen, a cry from Horonaim -,a cry of ruin and destruction!"
,"4":"Moab is destroyed; her cry is heard as far as Zoar."
,"5":"Her little ones go up the way to Lulith, weeping bitterly as they make the ascent. On the descent to Horonaim,the cry of destruction is still heard."
,"6":"Flee, run for your lives, like the wild asses in the desert."
,"7":"Since you trusted in your deeds and riches, you also will be captured. Chemosh will go into exile, together with her priests and officials."
,"8":"Upon every city the destroyer comes, and not a single city escapes. The valley is despoiled, the plain plundered, as Yahweh has declared."
,"9":"Bury Moab for she has perished!,Her cities will become desolate, with no inhabitant left."
,"10":"A curse be on him who is lax in performing the work of Yahweh! A curse be on him who holds back his sword from shedding blood!"
,"11":"From his youth Moab has lived at ease resting complacently upon lees, never having gone into exile, never having been decanted; so she kept her own flavor as wine, her aroma remained the same."
,"12":"And so the day will come - Yahweh says - when I will send decanters to her. They will empty her flasks and break her jars."
,"13":"Then Moab will be ashamed of Chemosh, as Israel has been ashamed of Bethel, in which they put their trust."
,"14":"How can you say, 'We are heroes and valiant men of war?'"
,"15":"Moab will be destroyed, her towns shattered; her finest young men will be slaughtered - it is the King who speaks, whose name is Yahweh Sabaoth."
,"16":"Moab's ruin is near at hand; her downfall comes at top speed."
,"17":"All you her neighbors, mourn for her, all you who knew her well; say, 'How the mighty scepter is broken, the glorious rod!'"
,"18":"Come down from glory, sit on the parched ground, all you who dwell in Dibon; Moab's destroyer has come against you, he has destroyed your stronghold."
,"19":"Stand by the way and watch closely, you who dwell in Aroer; ask the men who flee, the women who escape, ask them what has happened."
,"20":"Moab is shamed, oh, yes, destroyed; howl and cry out for her. Announce it by the Arnon,that Moab is ruined."
,"21":"Judgment has come on the tableland: on Holon, Jahzah and Mephaath,"
,"22":"on Dibon, Nebo and Bethdiblathaim,"
,"23":"on Kiriathaim, Bethgamul and Bethmeon,"
,"24":"on Kerioth and Bozrah, on all the cities of Moab, far and near."
,"25":"The horn of Moab is cut off and her arm broken - it is Yahweh who speaks."
,"26":"Make her drunk! Because she magnified herself against Yahweh, Moab will wallow in her vomit and become a laughingstock in turn."
,"27":"Was not Israel a laughingstock to you? Was she found among thieves, that whenever you speak of her you wag your head?"
,"28":"Leave the cities and dwell in the rocky cliffs, O inhabitants of Moab. Learn from the dove that makes its nest out of reach on the edge of a cliff."
,"29":"We have heard of the pride of Moab, of her loftiness and arrogance, of the haughtiness of her heart."
,"30":"Yahweh says: I know her insolence; her words are false, her deeds are vain."
,"31":"And so I wail for Moab; for the whole of Moab I moan; for the men of Kir-heres I mourn."
,"32":"O vineyard of Sibmah, I weep for you more than for Jazer. Your branches spread as far as the sea, all the way to the sea of Jazer. The destroyer has fallen,on your harvest and your vintage."
,"33":"Jubilation is at an end,in the fruit gardens of Moab; the vintage shout of joy is not heard, for I have drained the wine from the wine vats."
,"34":"The cry of Heshbon and Elealeh is heard as far as Jahaz. From Zoar to Horonaim and Eglathshelishiyah, their lament is heard, for even the waters of Nimrim have become desolate."
,"35":"Yahweh says: I will bring to an end any man in Moab who offers sacrifice on the high place and burns incense to his gods."
,"36":"And that is why my heart, like a flute, sobs for Moab, moans for the men of Kir-heres whose accumulated riches have all perished."
,"37":"Every head is shorn, every beard cut off; gashes are on their hands, sackcloth covers their loins."
,"38":"There is nothing but lamentation on all the housetops and in the public squares of Moab, for I have shattered her like a vessel that no one wants - says Yahweh."
,"39":"What terror has seized Moab, what wailing! Oh, how she has turned back in shame! Moab has become a laughingstock and a horror to her neighbors."
,"40":"For thus says Yahweh: Look, an eagle is swooping down, spreading its wings over Moab."
,"41":"The towns will be captured, the strongholds seized. The heart of Moab's warriors on that day will be like the heart of a woman in travail."
,"42":"Moab will be destroyed as a nation because she defied the Lord."
,"43":"Terror, pit, and snare be upon you, O people of Moab - says Yahweh."
,"44":"He who flees from terror will fall into the pit; he who climbs out of the pit will be caught in the snare; for I will let this happen to Moab in the year of her punishment - says Yahweh."
,"45":"Fugitives stop in the shadow of Heshbon, for a fire has gone from the house of Sihon, burning Moab's skull and her boasters' crown."
,"46":"Woe to you, Moab, people of Chemosh who suffer calamity!,Your sons are taken into exile, your daughers into captivity."
,"47":"But in the days to come I will restore the fortunes of Moab - Yahweh declares.',The judgment on Moab ends here."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Concerning the Ammonites. Yahweh says this: 'Has Israel no sons?,Has she no heir?,Why then has Milcom disinherited Gad, why have his people settled in its cities?"
,"2":"But the days are coming,- says Yahweh -,when I will sound the battle alarm,against Rabbah of the Ammonites. It will become a heap of ruins, its villages destroyed by fire. Then Israel will dispossess,those who had dispossessed her,- Yahweh says."
,"3":"Wail, Heshbon, for the destroyer marches!,Howl, inhabitants of Rabbah!,Put on sackcloth, lament, run to and fro, gashing yourselves; for Milcom goes into exile, along with his priests and officials."
,"4":"Why boast of your valleys, your valleys flowing with fruit, O faithless daughter, trusting in your riches and saying, 'Who will dare attack me?'"
,"5":"Look, I will bring terror upon you; you will be driven away, everyone making his own way, with no one to gather the fugitives."
,"6":"Yet I will restore the fortunes,of the Ammonites later on. It is Yahweh Sabaoth who speaks.'"
,"7":"Concerning Edom, this is what Yahweh says: 'Is there no more wisdom left in Teman?,Has counsel perished from the prudent?,Has their understanding decayed?"
,"8":"Flee or hide in dark caves, you inhabitants of Dedan, for I will bring destruction upon Esau,when I come to punish him."
,"9":"If grape pickers worked in your vineyard, would they not leave gleanings behind?,If thieves came to you at night, would they not steal only as much as they want?"
,"10":"But I will strip Esau bare; his hiding places I will uncover. His relatives, children and neighbors,will perish, and he will be no more."
,"11":"Leave your widows and orphans behind, and rest assured I will keep them alive.'"
,"12":"For thus says Yahweh: 'Even those not sentenced to drink the cup must drink it. Why then should you go unpunished? You, too, shall drink!"
,"13":"By my own self have I sworn, says Yahweh: Bozrah shall become an object of horror and disgrace, a desolation and a curse. All her towns and cities shall be ruins forever.'"
,"14":"I have received a message from Yahweh, a herald has been sent among the nations: 'Assemble! Prepare for battle!,March against these people!"
,"15":"Look, I will reduce you among the nations, make you despised among humankind."
,"16":"The terror that you inspire,and your pride have deceived you, you who live in the crags, on the rocky heights of the hill. Though you build your nest as high as the eagle's, I will bring you down from there - it is Yahweh who speaks."
,"17":"Edom will become a horror, shocking every passerby who will catch his breath at the sight of her wounds."
,"18":"As when Sodom, Gomorrah, and their neighboring towns were overthrown, no man shall dwell or visit there - thus Yahweh proclaims."
,"19":"As when a lion comes from the thicket of Jordan to a rich feeding ground, so I, in an instant, will drive Edom from its land. Whom will I choose for this task? Who is like me and can call me to account? What shepherd can stand against me?"
,"20":"Therefore hear Yahweh's plan against Edom, against those who live in Teman. They will be dragged away, even the smallest sheep; their pasture will be destroyed on account of them."
,"21":"The earth will tremble at the sound of their fall; to the Sea of Reeds their cry will resound."
,"22":"Look! An eagle will soar and spread its wings over Bozrah. On that day the heart of Edom's warriors will pound like the heart of a woman in labor.'"
,"23":"Message concerning Damascus: 'Hamath and Arpad are confused, having heard bad news. Their hearts are faint with fear,like the waters of a troubled sea."
,"24":"Damascus has become feeble,and turns to flee in panic, gripped by anguish and pain, like a woman in travail."
,"25":"How the renowned city is forsaken, the city of delight!"
,"26":"Her young men will fall in the streets, her soldiers will be silenced on that day. Yahweh declares:"
,"27":"I will set fire to the walls of Damascus; it will consume Ben-Hadad's fortresses.'"
,"28":"A message concerning Kedar and the kingdoms of Hazor, which Nebuchadnezzar king of Babylon attacked. This is what Yahweh says: 'Arise and attack Kedar, destroy the people of the east!"
,"29":"Their tents and flocks will be taken away, their goods and camels carried off,as men shout, 'Terror on every side!'"
,"30":"Flee, dwell in deep caves, you who live in Hazor - says Yahweh. For Nebuchadnezzar king of Babylon has devised a plot against you."
,"31":"Arise and attack a nation at ease, which lives in confidence, a nation that has neither bars nor gates, a people that dwells alone complacently."
,"32":"Their camels will become plunder, their large herds will be spoils; I will scatter to the winds,those who are in far-off places; I will bring disaster,on them from every side."
,"33":"Hazor will be a jackal's haunt, forever a wasteland,uninhabited by man, unvisited by anyone.'"
,"34":"This is the Word of Yahweh against Elam, which came to the prophet Jeremiah at the beginning of the reign of Zedekiah, king of Judah."
,"35":"Yahweh Sabaoth says this: 'See, I will break the bow of Elam, the mainstay of their might."
,"36":"I will bring the four winds against her from the four quarters of the heavens, and there will be no nation on earth to which Elam's exiles will not be dispersed."
,"37":"I will shatter Elam before their foes, before those who seek their lives. I will bring disaster upon them, even my fierce anger. I will pursue them with the sword until I have made an end of them."
,"38":"I will set my throne in Elam and destroy her king and officials."
,"39":"Yet I will restore the fortunes of Elam in the days to come - says Yahweh.'"
}`)
	CurrentBook.AddChapter(50, `{
"1":"This is the word Yahweh spoke against Babylon and the land of the Chaldeans, through the prophet Jeremiah:"
,"2":"'Do not hide this, but announce among the nations that Babylon is taken, Bel confounded, Merodach dismayed; her images are put to shame, her idols destroyed."
,"3":"A people from the north marches against her, set to turn her into a wasteland abandoned by both man and beast."
,"4":"In those days - declares Yahweh - the people of Israel and Judah will come in tears to seek their God Yahweh."
,"5":"Their faces turned toward Zion, they will ask the way to it. They will come and say, 'Let us join ourselves to the Lord in an everlasting covenant never to be forgotten.'"
,"6":"My people were lost sheep misled by their shepherds and left to roam on the mountains. They wandered from hill to hill and lost the way to their fold."
,"7":"They were devoured by enemies who chanced upon them and said, 'We have no guilt. This is their due for they sinned against Yahweh, their true shepherd and hope of their fathers.'"
,"8":"Flee from Babylon, leave the land of the Chaldeans, be like the rams that lead the flock!"
,"9":"For I will stir up nations from the north to march against Babylon. Their arrows are like those of skilled warriors, that never return empty-handed; and Babylon will be captured."
,"10":"Chaldea will be plundered, and the plunderers will be filled."
,"11":"Rejoice as long as you can, you plunderers of my inheritance!,Frolic like heifers threshing grain, and neigh like stallions!"
,"12":"But your mother will be disgraced; she will be the least of the nations, laid waste and a desert."
,"13":"Yahweh's fury will leave her desolate, an empty solitude, uninhabited. Every passerby will be horrified,at the sight of the wounds of Babylon."
,"14":"Take your posts around the city, all you who bend the bow. Shoot at her, spare no arrows, for great is her iniquity."
,"15":"Raise the war cry!,Now she surrenders!,Her walls are torn down, her towers fallen. Since this is Yahweh's vengeance, take revenge on her; do to her as she has done to others."
,"16":"Cut off the sower from Babylon, and the reaper with his sickle at harvest time. Escape from the oppressor's sword; let everyone return to his own people, let everyone flee to his own land."
,"17":"Israel was a straying sheep which lions pursued. First to devour her was the Assyrian; and the last to crush her bones was Nebuchadnezzar of Babylon."
,"18":"Therefore Yahweh, God of Israel, says: I will punish the king of Babylon and his land, as once I punished the king of Assyria."
,"19":"But I will return Israel to her fold, to feed on Bashan and Carmel and on Mount Ephraim and Gilead, till she has her fill."
,"20":"In those days, Yahweh says, a search will be made for Israel's guilt, but none will be found, and for the sins of Judah, and none will be found; for I will forgive the remnant whose lives I have spared."
,"21":"Attack the land of Merathaim, and those who live in Pekod; pursue and kill them, says Yahweh; do all as I have commanded."
,"22":"Battle alarm is in the land, the alarm of great destruction."
,"23":"How broken and shattered is the hammer of the whole earth! How horrifying has Babylon become among the nations!"
,"24":"You ensnared yourself, O Babylon, and were caught before you knew it; you were found out and seized because you challenged Yahweh."
,"25":"Yahweh has opened his armory, brought out the arms of his fury, for Yahweh Sabaoth has work to do in the land of Chaldea."
,"26":"Come against her from every side; break open her granaries; pile her up like heaps of grain, destroy her, leaving no remnant."
,"27":"Slay all her oxen, down to the slaughterhouse with them! Woe to them! Their day has come, the time for their chastisement."
,"28":"Listen! Fugitives and refugees from the land of Babylon have come to announce in Zion Yahweh's vengeance for his temple."
,"29":"Surround Babylon with archers, and leave her no way of escape. Repay her as her deeds deserve; do to her as she has done to others. Give her the due for her defiance of Yahweh, the Holy One of Israel."
,"30":"That day her warriors and young men as well will fall and lie in silence."
,"31":"I am against you, arrogant one! It is Yahweh Sabaoth who speaks - the time to punish you has come."
,"32":"The arrogant one will stumble; no one will help her up. In her towns I will kindle a fire that will consume everything around."
,"33":"Thus says Yahweh Sabaoth: The people of Israel are oppressed, and the people of Judah as well, for their captors hold them fast and refuse to let them go."
,"34":"But strong is their avenger, Yahweh Sabaoth is his name. He will fight for their cause and succeed; he will give them rest in their land, but unrest to those who live in Babylon."
,"35":"A sword upon the Chaldeans, upon the people of Babylon, her princes and sages!"
,"36":"A sword upon her false prophets: may they lose their wits! A sword upon her warriors: may they tremble in terror!"
,"37":"A sword upon her mercenaries: may they become women!,A sword upon her treasures: may they be plundered!"
,"38":"A sword upon her waters: may they dry up! For hers is a land of idols that go mad with terrors."
,"39":"So, desert beasts will live there; there will the owl and ostrich dwell. From generation to generation, the land will never be inhabited again."
,"40":"As when God overturned Sodom and Gomorrah with their neighbors, no man will live there any more, no one will make his home there again."
,"41":"A strong people is coming from the north, a mighty nation. Stirred up from the far ends of the earth"
,"42":"are men armed with bows and spears who are cruel and without mercy. They sound like the roaring sea as they ride on galloping steeds. They come in battle formation against you, daughter of Babylon."
,"43":"Your king has heard news of them, and his hands hang limp. Anguish has gripped him, and pain as that of a woman in travail."
,"44":"As a lion comes from the thicket of Jordan to a rich feeding ground, so I, in an instant, will drive them off, and whom I choose I will establish there. For who is like me? And who can call me to account? What shepherd can stand against me?"
,"45":"Therefore hear Yahweh's plans against Babylon, against the land of the Chaldeans: they will be dragged away, even the smallest sheep, their pasture will be destroyed on account of them."
,"46":"The earth quakes at the cry 'Babylon is captured!' Among the nations the outcry is heard.'"
}`)
	CurrentBook.AddChapter(51, `{
"1":"This is what Yahweh says: I will stir up a devastating wind against Babylon and the Chaldeans."
,"2":"I will send foreigners to Babylon,to winnow her and lay waste her land. On the day of her affliction,they will besiege her from all sides."
,"3":"Let not her archers bend their bows, let them not stand up in their armor. Spare not her young men; destroy the host of her warriors."
,"4":"They will fall fatally wounded,in the streets of Babylon."
,"5":"For Israel and Judah have not been forgotten by their God, Yahweh Sabaoth, though their land is guilt-ridden,before the Holy One of Israel."
,"6":"Save your lives, flee from Babylon!,Partake not of her punishment; this is a time of Yahweh's vengeance, a time of his recompense to her."
,"7":"Babylon was a golden cup in Yahweh's hand, a cup which made the whole earth drunk. The nations drank her wine, and they have become mad."
,"8":"Babylon's fall is sudden. Wail for her, wail!,Bring balm for her wounds, if she could yet be healed."
,"9":"'We have tried to heal Babylon, but she is beyond healing. Let us go back, each to his own land, and leave her to her judgment,which rises up to heaven.'"
,"10":"Yahweh has defended our rights, come, let us declare in Zion,what our God Yahweh has done."
,"11":"Sharpen the arrows, take up the shields!,Yahweh has aroused Media's kings,in his resolve to destroy Babylon. This is Yahweh's vengeance, vengeance for his temple."
,"12":"Raise a flag on the walls of Babylon, and make the watch strong. Post guards, prepare an ambush!,Yahweh will carry out his purpose, his words against the people of Babylon."
,"13":"You who dwell by mighty waters, you who are rich in treasures, this is your end; the time,for you to be cut off has come."
,"14":"Yahweh Sabaoth has sworn: Surely I will fill you with men, thick as a swarm of locusts; they will exult over you and raise the vintage shout."
,"15":"He made the earth by his power, founded the world by his wisdom, spread out the sky by his discernment."
,"16":"When he thunders, the heaven roars; from the earth he makes clouds rise; he sends lightning with the rain, and from his vaults brings out the wind."
,"17":"Men stand stupefied at this; artisans blush, for the idols they made,have no life and are a fraud."
,"18":"They are worthless, ridiculous; when judgment comes they will perish."
,"19":"The Portion of Jacob is not like them, for he is the creator of all; Yahweh Sabaoth is his name, and his heritage is Israel."
,"20":"You were my hammer, my weapon of war. With you I wrecked nations, with you I demolished kingdoms."
,"21":"With you I wrecked horse and rider, chariot and charioteer."
,"22":"With you I wrecked man and woman, youth and aged, young man and maiden."
,"23":"With you I wrecked shepherd and flock, farmer and draft animal, rulers and officials."
,"24":"But now I will repay Babylon and those who dwell in Chaldea for the wrong they did to Zion."
,"25":"I am against you, ravaging mountain, ravager of the whole earth! It is Yahweh who speaks. I will lay my hands on you, roll you down over the crags, and make you a parched, eroded mountain."
,"26":"No cornerstone will be taken from you, or foundation stone; forever shall you be a ruins, Yahweh says."
,"27":"Raise a signal on the earth, among the nations blow the trumpet. Prepare the nations for war, summon the kingdoms to battle Ararat, Minni and Ashkenaz. Marshal a great force against her; bring up the cavalry, swarming and bristling."
,"28":"Prepare the nations to battle her, the Medes with their kings, their governors and officials, all the countries they rule."
,"29":"The earth trembles and writhes as Yahweh carries out his process of turning the land of Babylon into a desert where no one lives."
,"30":"Her warriors have ceased to fight; they cower in their strongholds. Their strength is dried up, their homes are burned and their gates broken."
,"31":"One after another couriers run to the king, bringing news that his entire city is fallen:"
,"32":"The fords have been seized, the fortresses set afire, and all the warriors terrified."
,"33":"Yahweh Sabaoth, God of Israel, says: Babylon is like a threshing floor at the time it is trodden. A little while, and the time of the harvest grain will come for her.'"
,"34":"The people of Zion said: 'Nebuchadnezzar, king of Babylon, has consumed and routed me. He has left me as an empty vessel. Like a dragon he has swallowed me, and filled his belly; he cast me out of my Eden."
,"35":"May the violence done to my flesh be upon Babylon,' says the city of Zion. 'May my blood be upon the Chaldeans,' says Jerusalem."
,"36":"Yahweh says to his people: 'See now, I defend your cause and avenge you. I will dry up her sea and drain her springs."
,"37":"Babylon shall become a heap of ruins, a haunt of jackals, an object of horror and derision, a place where no one lives."
,"38":"Her people will roar like lions; they will growl like lion cubs."
,"39":"But while they are feverish, I will prepare a drink for them and make them drunk till they grow drowsy and fall into eternal sleep, never to wake up again."
,"40":"I will bring them down like lambs to the slaughter, like goats and rams."
,"41":"How has Babylon been seized, the glory of the world taken captive! How has Babylon become a horror among nations!"
,"42":"The sea has risen over Babylon and covered her with its roaring waves."
,"43":"Her cities have become desolate, a land of drought and a desert, a land where no one dwells, a land through which no man travels."
,"44":"I will punish Bel in Babylon and make him belch out what he devoured. No longer will nations stream to him. The wall of Babylon has fallen."
,"45":"My people, come out of her! Run for your lives! Run from Yahweh's fierce anger."
,"46":"Do not lose heart or be afraid when rumors are heard, when rumors come year after year, rumors of violence and disaster, intrigues of ruler against ruler."
,"47":"The time will surely come when I will punish the idols of Babylon; her land will be put to shame when all around her lie slain."
,"48":"Then heaven and earth and all therein will rejoice over Babylon, for out of the north the destroyers will come to attack her - it is Yahweh who speaks."
,"49":"Babylon must fall for the slain of Israel, just as the slain of all the earth have fallen because of Babylon."
,"50":"You who have escaped the sword, leave and do not linger. Remember Yahweh from this far country and think of Jerusalem:"
,"51":"'We have been put to shame, dishonor has covered our faces; because aliens have entered the holy places of Yahweh's house.'"
,"52":"But days will come - Yahweh declares - when I will punish her idols, the wounded will groan all over her land."
,"53":"Though Babylon mount skyward, though she fortify her heights, the mere threat of the destroyers I send is enough to make her terrified."
,"54":"Listen! Loud cries from Babylon, the sound of terrible destruction from the land of the Chaldeans!"
,"55":"That is Yahweh laying waste the city, silencing her monstrous din. Well may her waves roar and their clamor be heard afar!"
,"56":"Upon Babylon the destroyer has come; her warriors are captured, their bows are broken. For Yahweh is a God who rewards, who repays her enemies in full."
,"57":"I will make her rulers and sages drunk, her governors, her officers and warriors; they will sleep the sleep of death and never awake, says the King whose name is Yahweh Sabaoth."
,"58":"Yahweh Sabaoth says this: The wide ramparts of Babylon will be razed to the ground, her high gates burned down. The people's labor will go to naught; the nation's toil will end in fire.'"
,"59":"This is the message Jeremiah gave to Seraiah, son of Neriah who is Mahseiah's son, when he went to Babylon at the command of Zedekiah, who was then in the fourth year of his reign as king of Judah."
,"60":"Jeremiah had written on a scroll the entire disaster that was to befall Babylon - all these words recorded here."
,"61":"Jeremiah then said to Seraiah, 'When you get to Babylon, see that you read all these words aloud."
,"62":"Then say: 'Yahweh, you yourself have proclaimed that this place will be destroyed, that neither man nor beast will ever live here again, for it will remain desolate forever.'"
,"63":"When you finish reading this scroll, tie a stone to it and throw it into the Euphrates."
,"64":"Then say: 'So will Babylon sink and rise no more because of the disaster I will bring upon her.',Here end the words of Jeremiah."
}`)
	CurrentBook.AddChapter(52, `{
"1":"Zedekiah was twenty-one years old when he became king and he reigned eleven years in Jerusalem. His mother, Hamutal by name, was the daughter of Jeremiah from Libnah."
,"2":"He did evil in the sight of Yahweh just as Jehoiakim had done."
,"3":"All that happened in Jerusalem and Judah came about because of Yahweh's anger until the day when he drove them out of his sight. Zedekiah rebelled against the king of Babylon;"
,"4":"so in the ninth year of Zedekiah's reign, on the tenth day of the tenth month, Nebuchadnezzar king of Babylon marched with his entire army and laid siege to Jerusalem. They camped outside the city and built siege works all around it."
,"5":"The city was under siege up to the eleventh year of Zedekiah."
,"6":"On the ninth day of the fourth month famine became a serious problem in the city, and throughout the land there was no bread for the people."
,"7":"When the city was opened by a breach in the wall the Judean army fled. They left the city by night through the gate between the two walls near the king's garden. While the Chaldeans were still surrounding the city they fled towards the Arabah."
,"8":"The Chaldeans followed in hot pursuit of King Zedekiah. They caught up with him in the plains of Jericho. All his army deserted and scattered."
,"9":"The Chaldeans seized the king and led him away to Riblah in the territory of Hamath and there the king of Babylon passed sentence on him. There at Riblah, the king of Babylon slaughtered the sons of Zedekiah in his presence and also killed all the officials of Judah."
,"10":"He then put out the eyes of Zedekiah, bound him with a double bronze chain and took him to Babylon."
,"11":"He was imprisoned there in the house of the guards until the day of his death."
,"12":"On the tenth day of the fifth month in the nineteenth year of Nebuchadnezzar king of Babylon, Nebuzaradan commander of the bodyguard and servant of the king of Babylon, entered Jerusalem and set fire to the House of Yahweh and the royal palace as well as to all the houses in Jerusalem."
,"13":"He also burned every important building."
,"14":"The Chaldean army under the commander of the bodyguard completely demolished all the walls around Jerusalem."
,"15":"Nebuzaradan commander of the bodyguard carried off into exile some of the poorest among the people, the remnant of Jews left in the city, and those who had deserted to the king of Babylon and the remainder of the artisans."
,"16":"But Nebuzaradan left behind those among the very poor who were capable of working in vineyards and cultivating the soil."
,"17":"The Chaldeans broke into pieces the bronze pillars, the stands and the bronze Sea in the House of Yahweh and carried off all this bronze to Babylon."
,"18":"They also took the pots, shovels, wick trimmers, the spoons and all the bronze articles used in the temple service."
,"19":"The commander of the bodyguard took the basins, censers, sprinkling bowls, pots, lampstands, ladles and bowls - all that was made of gold or silver."
,"20":"The two pillars, the Sea and the twelve bronze bulls underneath it, the movable stands which King Solomon had made for the House of Yahweh - all this bronze was of an immeasurable weight."
,"21":"The pillars were each eighteen cubits high with a circumference of twelve cubits. Each had a thickness of four fingers and was hollow."
,"22":"On the top of each pillar was a bronze capital five cubits high and above this and around the capital was filigree work with pomegranates in bronze."
,"23":"Ninety-six pomegranates hung down and in all the filigree decoration there was a total of a hundred pomegranates."
,"24":"The commander of the bodyguard took captive Seraiah the chief priest and Zephaniah the next priest in rank, as well as three doorkeepers."
,"25":"He also took from those in the city a eunuch in command of the fighting men, seven personal advisers to the king who were discovered in the city,"
,"26":"the commander's secretary responsible for military conscription and sixty of his men who were found in the city. Nebuzaradan took all these away to the king of Babylon at Riblah."
,"27":"There at Riblah in the territory of Hamath the king of Babylon had them put to death. So Judah was taken captive and taken away from its own land."
,"28":"This is the number of the population deported by Nebuchadnezzar: in the seventh year 3,023 Jews;"
,"29":"in the 18th year of Nebuchadnezzar 832 people from Jerusalem;"
,"30":"in his 23rd year 745 Jews deported by Nebuzaradan commander of the bodyguard - in all 4,600 people."
,"31":"On the 25th day of the 12th month in the 37th year of the exile of Jehoiakin king of Judah, Evil-merodach king of Babylon, in the year he came to the throne pardoned Jehoiakin king of Judah and released him from prison."
,"32":"He spoke kindly to him and gave him more honorable treatment than the other kings who were with him in Babylon."
,"33":"Jehoiakin put aside his prisoner's garment and for the rest of his life ate at the king's table."
,"34":"Day by day for as long as he lived he was maintained by the king of Babylon."
}`)

}
func EN_CCB_LoadVMISChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"This is what Isaiah son of Amoz foretold concerning Judah and Jerusalem in the days of Uzziah, Jotham, Ahaz, and Hezekiah, kings of Judah."
,"2":"Listen, O heavens!,Give heed, O earth! for the Lord speaks: 'I raised children, I brought them up, but they have risen against me."
,"3":"The ox knows its master,and the ass its owner's manger, but Israel does not know me, my people do not understand."
,"4":"A sinful nation, a people weighed down with iniquity, a wicked race, perverted children!,They have turned away from Yahweh,and despised the Holy One of Israel."
,"5":"Shall I strike you again and again; people always rebelling, Your whole head is diseased,and your heart also afflicted."
,"6":"From the soles of your feet,to the top of your head -,all is wounds and bruises, sores uncleaned and unbound, not eased with soothing ointment."
,"7":"Your country lies desolate, your cities razed by fire. Aliens have devoured the harvest,before your very eyes, and you were left in ruins."
,"8":"The Daughter of Zion is left,like a shanty in a vineyard, like a hut in a melon field, like a hamleted town."
,"9":"Had not Yahweh of hosts,left us a small remnant, we would resemble Sodom, we would be like Gomorrah."
,"10":"Hear the warning of Yahweh, rulers of Sodom. Listen to the word of God, people of Gomorrah."
,"11":"'What do I care,' says Yahweh,'for your endless sacrifices?,I am fed up with your burnt offerings, and the fat of your bulls. The blood of fatlings, and lambs and he-goats,I abhor."
,"12":"When you come before me and trample on my courts, who asked you to visit me?"
,"13":"I am fed up with your oblations. I grow sick with your incense. Your New Moons, Sabbaths and meetings, evil with holy assemblies, I can no longer bear."
,"14":"I hate your New Moons and appointed feasts,they burden me."
,"15":"When you stretch out your hands,I will close my eyes; the more you pray, the more I refuse to listen, for your hands are bloody."
,"16":"Wash and make yourselves clean. Remove from my sight,the evil of your deeds. Put an end to your wickedness"
,"17":"and learn to do good. Seek justice and keep in line the abusers; give the fatherless their rights,and defend the widow.'"
,"18":"'Come,' says the Lord, 'let us reason together. Though your sins be like scarlet, they will be white as snow; though they be as crimson red, they will be white as wool."
,"19":"If you will obey me, you will eat the goods of the earth;"
,"20":"but if you resist and rebel, the sword will eat you instead.',Truly the Lord has spoken."
,"21":"Zion, the faithful city, has become a harlot!,She who abounded in justice, in whom righteousness lodged, has become a hideout of murderers!"
,"22":"Your silver has turned to dross, your best wine thinned with water."
,"23":"Your rulers are tyrants, partners of thieves. They love a bribe,and look around for gifts. No one protects the orphan, or listens to the claim of the widow."
,"24":"This is why the Lord speaks, Yahweh Sabaoth, the Mighty One of Israel: 'I will subdue my foes,and exact payment from my enemies."
,"25":"I will turn my hand against you, I will smelt away your dross and remove your impurities."
,"26":"I will restore your judges, I will give back your counselors, as it was in the beginning. Then you will be called,the City of Righteousness, the Faithful City.'"
,"27":"The deliverance of Zion will be like a judgment,there will be a remnant: the just ones."
,"28":"But rebels and sinners,alike will be destroyed, and those who desert the Lord,will likewise perish."
,"29":"Yes, you will be ashamed of your sacred oaks which have,given you delight; you will blush for your gardens,which you have chosen."
,"30":"You will be like an oak, the leaves of which wither, and like a garden,which runs out of water."
,"31":"The strongman will be as tinder,and all his work a spark: both will burn together,and no one will quench the fire."
}`)
	CurrentBook.AddChapter(2, `{
"1":"The vision of Isaiah, son of Amoz, concerning Judah and Jerusalem."
,"2":"In the last days, the mountain of Yahweh's house shall be set over the highest mountains and shall tower over the hills."
,"3":"All the nations shall stream to it, saying, 'Come, let us go to the mountain of the Lord, to the house of the God of Jacob, that he may teach us his ways and we may walk in his paths. For the Teaching comes from Zion, and from Jerusalem the word of Yahweh."
,"4":"He will rule over the nations and settle disputes for many peoples. They will beat their swords into plowshares and their spears into pruning hooks. Nation will not raise sword against nation; they will train for war no more."
,"5":"O nation of Jacob, come, let us walk in the light of the Lord!"
,"6":"You have forsaken your people, the land of Jacob, for it was full of diviners. They turned into soothsayers like the Philistines, and clasped hands with pagans."
,"7":"Their land is full of silver and gold, there is no end to their treasures. Their land is full of horses, there is no end to their chariots."
,"8":"Their land is full of idols, and they bow down,before the work of their hands, before the things their fingers have made."
,"9":"Man will be humbled,and the mortal fallen, forgive them not!"
,"10":"Get behind the rocks, hide in the dust, for fear of the Lord,and the splendor of his majesty!"
,"11":"The haughty looks of man will be humbled; the pride of mortal will be brought low. Yahweh alone will be exalted on that day."
,"12":"Yahweh will stand up on that day,against all the proud and arrogant, against all that is high or great,"
,"13":"against all the cedars of Lebanon,and all the oaks of Bashan,"
,"14":"against all the lofty mountains, and all the soaring hills,"
,"15":"against every high tower,and fortified walls,"
,"16":"against all the ships of Tarshish,and their luxurious load."
,"17":"The arrogance of man will be humbled; the pride of mortal will be brought low. Yahweh alone will be exalted on that day,"
,"18":"and all the idols will pass away."
,"19":"People will flee,into the hollows of the rocks, into the caverns of the earth, from the terror of Yahweh, from the splendor of his majesty, when he arises to terrify the earth."
,"20":"On that day, they will throw to the moles and to the bats,their idols of silver and gold, which they made for themselves to worship."
,"21":"They will flee,into the caverns of the rocks, into the crevices of the crags, from the terror of the Lord, from the splendor of his Majesty, when he arises to terrify the earth."
,"22":"Rely not on man, who has but a breath in his nostrils. What is he worth?"
}`)
	CurrentBook.AddChapter(3, `{
"1":"See how the Lord, Yahweh Sabaoth, takes away provisions and supplies,from Judah and Jerusalem -"
,"2":"the hero and the soldier, the judge and the prophet, the diviner and the elder,"
,"3":"the captain and the man of rank, the counselor, the wise man, the,craftsman, and the enchanter."
,"4":"I will make striplings their princes,and raw lads their rulers."
,"5":"People will oppress each other -,every neighbor his neighbor; the young will bully the old,and the base will insult the honorable."
,"6":"When that day comes, a man will take hold of his brother,in the house of his father,and say, 'You have clothes, so be our leader,and rule over this heap of ruins.'"
,"7":"But he will cry out in protest: 'I cannot undertake to remedy all this, when in my own house,there is neither food nor clothing; do not make me leader of the people.'"
,"8":"See how Jerusalem crumbles,and Judah falls, for in word and deed,they have defied the Lord, and insulted his glorious presence."
,"9":"The look on their faces denounces them: they do not hide their sin; instead, they parade it, like Sodom: Woe to them! They bring about their own downfall!"
,"10":"Say, 'Fortunate are the righteous, they will eat of the fruit of their deeds.'"
,"11":"But woe to the wicked: the evil that their hands have done shall be done to them!"
,"12":"O my people, plundered by your rulers, enslaved by your creditors! O my people, your leaders deceive you and lead you astray."
,"13":"Yahweh takes his place in court and stands to try his people."
,"14":"Yahweh calls to judgment the elders and the princes: 'You have devoured my vineyard. The spoil of the poor is in your houses. "
,"15":"What right have you to crush the people and to grind down the poor?' declares Yahweh Sabaoth."
,"16":"Yahweh says, 'Haughty are the women of Zion, walking with their heads held high, with mincing steps, flirting with their eyes, ornaments tinkling on their ankles.'"
,"17":"But Yahweh will cover with scabs the heads of Zion's women and make their scalps bald."
,"18":"On that day the Lord will take away the ankle ornaments, the headbands and the crescents,"
,"19":"the pendants, the bracelets, and the scarves,"
,"20":"the headdresses, the armlets, the sashes, the perfume bottles and the amulets,"
,"21":"the signet rings and nose rings,"
,"22":"the festal robes, the mantles, the cloaks, and the handbags,"
,"23":"the garments, the turbans, and the veils."
,"24":"Instead of fragrance, there will be stench; instead of girdle, rope; instead of well-set hair, baldness; instead of jeweled gown, sackcloth; and instead of beauty, shame."
,"25":"Your men will fall by the sword; your heroes, in battle."
,"26":"The city gates will lament and mourn,as Zion, ravaged, sits on the ground."
}`)
	CurrentBook.AddChapter(4, `{
"1":"On that day, seven women will fight over one man. 'We will eat our own food,' they will say, 'we will wear our own clothing, only let us be called by your name and take away our disgrace.'"
,"2":"On that day the Shoot of Yahweh will be beautiful and glorious; and the Fruit of the earth will be honor and splendor for the survivors of Israel."
,"3":"Those who are left in Zion and remain in Jerusalem will be called holy all who are recorded among the living in Jerusalem,"
,"4":"when Yahweh washes away the filth of the women of Zion and purges Jerusalem of the bloodstains in its midst with the blast of searing judgment, the blast of fire."
,"5":"Then will Yahweh create over the whole site of Mount Zion and over its assemblies a cloud of smoke by day and a glow of fire by night. For the Glory of the Lord will be a canopy and a pavilion for all, "
,"6":"a shade from the scorching heat by day, a refuge from the storm and rain."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Let me sing for my beloved,the love song of my beloved,about his vineyard. My beloved had a vineyard,on a fertile hillside."
,"2":"He dug it up, cleared the stones, and planted the choicest vines. He built there a watchtower,and hewed out a winepress as well. Then he looked,for a crop of good grapes, but it yielded only wild grapes."
,"3":"Now, inhabitants of Jerusalem and men of Judah, judge between me and my vineyard."
,"4":"What more was there to do,that I have not done for my vineyard?,Good grapes was the yield I expected, why did it yield only sour grapes?"
,"5":"Now I will let you know,what I am going to do,with my vineyard: I will remove its hedge,and it will be burned; I will break down its wall,and it will be trampled on."
,"6":"I will make it a wasteland, I will neither prune nor hoe it, and briers and thorns will grow there. I command the clouds, as well, not to send rain on it."
,"7":"The vineyard of Yahweh Sabaoth,is the people of Israel, and the men of Judah,are his pleasant vine. He looked for justice, but found bloodshed; He looked for righteousness,but heard cries of distress."
,"8":"Woe to you who join house to house, who add field to field!,So no room will remain, with you alone in the land?"
,"9":"Yahweh Sabaoth has sworn in my hearing: 'Many houses will remain in ruins, beautiful mansions without occupants."
,"10":"Ten acres of vineyard,will yield only a barrel of wine; ten bushels of seed, only a bushel of grain.'"
,"11":"Woe to those who rise early in the morning,to run after strong drink, and tarry late in the evening,till they are inflamed with wine."
,"12":"They have lyres and harps, timbrels and flutes, and wine at their banquets; but they have no thought for the deeds of the Lord, nor do they see his plans."
,"13":"Thus my people will go into exile,for want of understanding, their dignitaries dying of hunger, their masses parched with thirst."
,"14":"Therefore the grave has enlarged its throat,and opened its mouth to the full; it swallows the upper crust of Zion, their throngs and their revelry."
,"15":"Man shall be humbled,and the mortal fallen, and the eyes of the haughty cast down."
,"16":"But Yahweh Sabaoth will be exalted,when he comes in judgment; the sentences of the holy God,will reveal his holiness."
,"17":"Then will the lambs graze as at pasture, fatlings and kids will browse among the ruins.)"
,"18":"Woe to those who haul their wrongs with cords of deceit, to those who pull a cart of sins,"
,"19":"to those who say, 'Let God hurry, let him speed up his work,so that we may see it. Let the plans of the Holy One of Israel,draw near and come true, which we are eager to learn about!'"
,"20":"Woe to those who call evil good, and good evil, who change darkness for light,and light for darkness, who give bitter for sweet,and sweet for bittter."
,"21":"Woe to those who are wise in their own eyes,and take themselves for sages."
,"22":"Woe to those who are champions in mixing drinks,and valiant at drinking bouts,"
,"23":"but acquit the guilty for a bribe,and deprive the innocent of his right."
,"24":"Therefore, as the tongues of fire lick up stubble, as dry grass sinks down in the flames, so their roots will rot, and their flowers be blown away like dust, for they have rejected the law of Yahweh Sabaoth,and scorned the word of the Holy One of Israel."
,"25":"Therefore the Lord, his wrath burning against his people, raises his hand against them,and strikes them down. The mountains quake: the corpses litter the streets. Yet for all this his anger does not subside, his hand is still raised, poised to strike."
,"26":"He gives a signal to nations afar, he whistles to them from the ends of the earth; speedily and swiftly they come."
,"27":"None of them is weary, none stumbles,none slumbers or sleeps; not a waist belt is loosened, not a sandal-thong broken."
,"28":"Their arrows are sharp, all their bows are strong: their horses' hoofs seem like flint, their chariot wheels like the whirlwind."
,"29":"They roar like young lions; they growl as they seize their prey, no one to rescue it as they carry it off."
,"30":"On that day they will roar over these people,like the roaring of the sea. Just look at the land -,darkness and distress, the light flickering out in shadows, darkened finally by the clouds."
}`)
	CurrentBook.AddChapter(6, `{
"1":"In the year that King Uzziah died I saw the Lord seated on a throne, high and exalted; the train of his robe filled the Temple."
,"2":"Above him were seraphs, each with six wings: two to cover the face, two to cover the feet, and two to fly with."
,"3":"They were calling to one another: 'Holy, holy, holy is Yahweh Sabaoth. All the earth is filled with his Glory!'"
,"4":"At the sound of their voices the foundations of the threshold shook and the Temple was filled with smoke."
,"5":"I said, 'Poor me! I am doomed! For I am a man of unclean lips living among a people of unclean lips, and yet I have seen the King, Yahweh Sabaoth.'"
,"6":"Then one of the seraphs flew to me; in his hands was a live coal which he had taken with tongs from the altar."
,"7":"He touched my mouth with it and said, 'See, this has touched your lips; your guilt is taken away and your sin is forgiven.'"
,"8":"Then I heard the voice of the Lord, 'Whom shall I send? And who will go for us?' I answered, 'Here I am. Send me!'"
,"9":"He said, 'Go and tell this people: 'Much as you hear, you will not understand; much as you see, you do not perceive.'"
,"10":"Let their hearts be hardened, make their ears deaf and their eyes blind; what a misfortune for them, should they hear and see! Yet if they understood and came back to me I would heal them.'"
,"11":"Then I said, 'For how long, O Lord?' And he answered, 'Until towns have been laid waste and left without inhabitant; until the houses are deserted and the fields ruined and ravaged, "
,"12":"until Yahweh has sent away the people and the fields are left deserted."
,"13":"Even though a tenth remain in it, it will be burned. Yet there a stump will remain like that of a fallen oak; this stump is a holy seed.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"When Ahaz son of Jotham, the son of Uzziah, was king of Judah, King Rezin of Aram and Pekah son of Remaliah, king of Israel, laid siege to Jerusalem but they were unable to capture it."
,"2":"When the news reached the house of David, 'Aram's troops are encamped in Ephraim,' the heart of the king and the hearts of the people trembled as the trees of the forest tremble before the wind."
,"3":"Yahweh then said to Isaiah: 'Go with your son A-remnant-will-return, and meet Ahaz at the end of the aqueduct of the Upper Pool, on the road to the Washerman's Field."
,"4":"Say to him, Stay calm and fear not; do not lose courage before these two stumps of smoldering firebrands - the fierce anger of Rezin the Aramean and the blazing fury of the son of Remaliah. You know that "
,"5":"Aram, Ephraim and Remaliah's son have plotted against Judah, saying:"
,"6":"Let us invade and scare it, let us seize it and put the son of Tabeel king over it."
,"7":"But the Lord Yahweh says: It shall not be so, it shall not come to pass."
,"8a":"For Damascus is only the head of Aram,and Rezin the lord of Damascus."
,"9a":"Samaria is only the head of Ephraim,and Remaliah's son is only the lord of Samaria."
,"8b":"Within fifty-six years, Ephraim will be shattered,and will no longer be a people."
,"9b":"But if you do not stand firm in faith, you, too, will not stand at all.'"
,"10":"Once again Yahweh addressed Ahaz,"
,"11":"'Ask for a sign from Yahweh your God, let it come either from the deepest depths or from the heights of heaven.'"
,"12":"But Ahaz answered, 'I will not ask, I will not put Yahweh to the test.'"
,"13":"Then Isaiah said, 'Now listen, descendants of David. Have you not been satisfied trying the patience of people, that you also try the patience of my God?"
,"14":"Therefore the Lord himself will give you a sign: The Virgin is with child and bears a son and calls his name Immanuel. "
,"15":"He will live on curds and honey by the time he learns to refuse evil and choose good."
,"16":"For before the child knows how to reject evil and cherish virtue, the land of the two kings that you abhor will be deserted."
,"17":"Yahweh will bring a time much worse than any since Ephraim broke away from Judah."
,"18":"On that day Yahweh will whistle,for flies from the farthest streams of Egypt,and for bees from the land of Assyria."
,"19":"They will come and settle,in the steep ravines, in the clefts of the rocks, on all the bushes, and on every pasture."
,"20":"On that day, with a razor hired from beyond the river,Yahweh will shave the head,and the hair of the legs,and the beard as well."
,"21":"On that day a man will raise,a heifer and a couple of sheep,"
,"22":"and from the abundance of milk,those who survive in the land,will feed on curds and honey."
,"23":"On that day every place,planted with a thousand vines,worth a thousand silver shekels,will be covered with briers and thorns."
,"24":"Men will go there,armed with bows and arrows, for the whole country,will be covered with briers and thorns."
,"25":"No one will dare come,to all the hills which used to be cultivated with hoe, for fear of briers and thorns. There, cattle will be let loose,and sheep left to graze."
}`)
	CurrentBook.AddChapter(8, `{
"1":"The Lord said to me, 'Take a large cylindrical seal and write on it in ordinary characters: Quick to plunder-Booty is Close."
,"2":"Do this before Uriah the priest and Zechariah the son of Jeberechiah my reliable witness.'"
,"3":"I went to my wife; she conceived and gave birth to a son. Then Yahweh said to me, 'Call him Quick to plunder-Booty is Close, for this is Yahweh's word:"
,"4":"Before the child knows how to say 'father' or 'mother', the wealth of Damascus and the booty of Samaria will be carried off by the king of Assyria.'"
,"5":"Again Yahweh spoke to me:"
,"6":"'Because this people refuses the gently flowing waters of Shiloah, and cowers in fear before Rezin and the son of Remaliah,"
,"7":"therefore the Lord will bring against them the waters of the River, deep and mighty - the king of Assyria with all his pomp. It will rise over all its channels,and overflow all its banks;"
,"8":"it will sweep on to Judah, it will overflow and pass on, reaching up to the neck. It will spread its wings over the whole breadth of your land, O Immanuel!"
,"9":"Know it, O you nations. Hear, O you distant lands; gird yourselves for war and be dismayed!"
,"10":"Devise a plan and it will be thwarted, make a resolve and it will not stand, for God-is-with-us."
,"11":"Thus Yahweh spoke to me when his hand grasped me and he warned me not to walk in the way of these people:"
,"12":"'Do not speak of conspiracy whenever these people dread conspiracy; do not fear what they fear nor be in dread."
,"13":"Only Yahweh Sabaoth must you hold in veneration, only him must you fear, only him must you dread."
,"14":"He will be a sanctuary and at the same time a stumbling-stone, the rock that brings down, for both houses of Israel. He will be like trap and snare for the people of Jerusalem."
,"15":"Many of them will stumble, many will fall and be broken, be trapped and captured.'"
,"16":"Yahweh added: 'Bind this testimony and seal it in the midst of my disciples.'"
,"17":"So I will wait for Yahweh who hides his face from the people of Jacob. I will hope in him."
,"18":"Here am I and the children he has given me. We are signs and portents in Israel from Yahweh Sabaoth, who dwells on Mount Zion."
,"19":"Should people tell you to consult mediums and spiritists who whisper and mutter, you must say to them: 'A people, of course, must consult its gods! On behalf of the living, will you consult the dead?'"
,"20":"This is what is said through the law and revelations: this word will not fade away."
,"21":"Distressed and famished, they will roam the land. In their hunger they will fume,and curse their God and their king. They will look upward,"
,"22":"and then look towards the earth, but they will only find distress and darkness, and frightening gloom."
,"23":"Yet, where there was but anguish, darkness will disappear. He has just afflicted the land of Zebulun and the land of Naphtali; but in the future he will confer glory on the way of the sea, on the land beyond the Jordan - the pagans' Galilee."
}`)
	CurrentBook.AddChapter(9, `{
"1":"The people who walk in darkness,have seen a great light. A light has dawned,on those who live in the land of the shadow of death."
,"2":"You have enlarged the nation; you have increased their joy. They rejoice before you, as people rejoice at harvest time,as they rejoice in dividing the spoil."
,"3":"For the yoke of their burden, the bar across their shoulders, the rod of their oppressors, you have broken it as on the day of Midian."
,"4":"Every warrior's boot that tramped in war, every cloak rolled in blood, will be thrown out for burning, will serve as fuel for the fire."
,"5":"For a child is born to us, a son is given us; the royal ornament is laid upon his shoulder, and his name is proclaimed: 'Wonderful Counselor, Mighty God, Everlasting Father, Prince of Peace.'"
,"6":"To the increase of his powerful rule,in peace, there will be no end. Vast will be his dominion, he will reign on David's throne,and over all his kingdom, to establish and uphold it,with justice and righteousness,from this time onward and forever. The zealous love of Yahweh Sabaoth will do this."
,"7":"The Lord has sent a word against Jacob: the sentence fell upon Israel."
,"8":"The people of Samaria and Ephraim saw it, but they said in pride and arrogance of heart:"
,"9":"'The bricks have fallen down, but we will rebuild with hewn stones; the sycamores have been cut down, but in their place we will plant cedars.'"
,"10":"Therefore Yahweh raises foes against them and stirs up their adversaries:"
,"11":"from the east, Arameans, from the west, Philistines - with open mouth they devour Israel. Yet for all this his anger does not subside, his hand is poised to strike."
,"12":"For the people have not come back to him who has smitten them; they have not sought Yahweh Sabaoth."
,"13":"Therefore Yahweh has cut off from Israel both head and tail, palm branch and reed in a single day."
,"14":"The elders and prominent men are the head, the tail is the prophet of lies."
,"15":"The guides of these people mislead them, the leaders have lost their way."
,"16":"The Lord, therefore, does not spare their young men nor have compassion on their orphans and widows. For everyone has become evil and ungodly; every mouth speaks folly. Yet for all this his anger does not subside, his hand is poised to strike."
,"17":"Their wickedness has become like a fire,which consumes both thorn and brier; it rages, sets thickets ablaze, and all of them vanish like smoke."
,"18":"By the wrath of Yahweh Sabaoth the land is set aflame, and,the people are burned like fuel for fire because no one spares his brother."
,"19":"Snatching left and right, they still go hungry and they remain unfilled: each one devours his neighbor's flesh."
,"20":"Manasseh devours Ephraim, Ephraim devours Manasseh; and against Judah together they march. Yet for all this his anger does not subside, his hand is poised to strike."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Woe to those who enact unjust laws,and issue oppressive decrees!"
,"2":"Woe to those who rob the poor of their rights,and deprive the helpless of justice!,They prey on widows and plunder the orphans."
,"3":"What will you do on the day of punishment?,Where will you flee for help,when disaster suddenly comes?,Where will you save your wealth?"
,"4":"You can do nothing but cringe,among the captives and exiles,or fall down among the slain. Yet for all this Yahweh's anger does not subside, his hand is poised to strike."
,"5":"Woe to Assyria, the rod of my anger, the staff of my fury!"
,"6":"Against a godless nation I send him, against a people who provoke my wrath I dispatch him, to plunder and pillage, to tread them down like mud in the streets."
,"7":"But the mind of his king is far from this, his heart harbors other thoughts; what he wants is to destroy, to make an end of all nations."
,"8":"For he says: 'Are not my commanders like kings?"
,"9":"Was it not the same for Calno as for Carchemish, for Hamath as for Arpad, and for Samaria as for Damascus?"
,"10":"Just as my hands have seized idolatrous kingdoms, whose graven images excelled those of Samaria and Jerusalem,"
,"11":"just as I have dealt with Samaria and her idols, shall I not do to Jerusalem and her idols?'"
,"12":"When Yahweh has finished all his work on Mount Zion and in Jerusalem, he will punish the king of Assyria for his willful pride and arrogant insolence."
,"13":"For the king says; 'By my own strength I have done this,and by my own wisdom, for I am clever. I have moved the frontiers of peoples, I have plundered treasures, I have brought inhabitants down to the dust, I have toppled kings from their thrones."
,"14":"As one reaches into a nest, so my hands have reached into nations' wealth. As one gathers deserted eggs, so have I gathered the riches of the earth. No one flapped a wing,or opened its mouth to chirp a protest.'"
,"15":"Does the axe claim more credit,than the man who wields it?,Does the saw magnify itself,more than the one who uses it?,This would be like a rod wielding the man who lifts it up; will those not made of wood, be controlled by the cudgel?"
,"16":"Therefore the Lord, Yahweh Sabaoth, is ready to send a wasting sickness,upon the king's sturdy warriors. Beneath his plenty, a flame will burn,like a consuming fire."
,"17":"The Light of Israel will be a fire,and his Holy One a flame -,to burn and devour his thorns and briers,all in a single day."
,"18":"The splendor of his forest and fruitful land,comes undone and raves, body and soul disappears and passes away."
,"19":"The remnant of the trees in his forest,will be so few, so easy to count, that a child could make a list of them."
,"20":"On that day, the remnant of Israel and the survivors of the people of Jacob will no longer rely upon the tyrant who struck them down, but instead will truly rely upon the Holy One of Israel."
,"21":"A remnant will return - a remnant of Jacob - to the mighty God."
,"22":"Yes, Israel! Though your people be as the sand of the sea, only a remnant of them will return; their end has been ordered, justice shall be fully done."
,"23":"The Lord will make a full end, as decreed by Him, all over the land."
,"24":"Thus says the Lord, Yahweh Sabaoth, 'O my people, who dwell in Zion, do not be afraid of the Assyrians who strike you with the rod and lift up their staff against you as did the Egyptians. "
,"25":"In a little while my anger against you will be over and will be directed to their destruction."
,"26":"Yahweh Sabaoth will lash at them with a scourge, as he did with the Midianites at the rock of Oreb, as he did in Egypt when he raised his rod over the sea."
,"27":"On that day, their burden will be lifted off your shoulders, their yoke lifted off your neck. The yoke will be destroyed."
,"28":"They have gone up from Rimmon,and have come to Aiath; they have passed through Migron,and stored supplies at Michmash."
,"29":"They have crossed over the pass,and now camp at Geba for the night. Ramah is in terror; Gibeah of Saul has fled."
,"30":"Lift up your voice, O daughter of Gallim, let it be heard at Laishah,and answered at Anathoth."
,"31":"Madmenah is in flight; the people of Gebim flee for their lives."
,"32":"This day the invaders will halt at Nob; they will shake their fists,at the mount of the Daughter of Zion, at the hill of Jerusalem."
,"33":"Suddenly, the Lord, Yahweh Sabaoth,lops off the boughs with terrifying violence. The tall trees are hewn down, the lofty ones are brought low."
,"34":"With an axe he cuts down the thickets; and Lebanon, the majestic, falls."
}`)
	CurrentBook.AddChapter(11, `{
"1":"From the stump of Jesse a shoot will come forth; from his roots a branch will grow and bear fruit."
,"2":"The Spirit of the Lord will rest upon him -,a Spirit of wisdom and understanding, a Spirit of counsel and power, a Spirit of knowledge and fear of the Lord."
,"3":"Not by appearances will he judge, nor by what is said must he decide,"
,"4":"but with justice he will judge the poor,and with righteousness decide for the meek. Like a rod, his word will strike the oppressor, and the breath of his lips slay the wicked."
,"5":"Justice will be the girdle of his waist, truth the girdle of his loins."
,"6":"The wolf will dwell with the lamb, the leopard will rest beside the kid, the calf and the lion cub will feed together,and a little child will lead them."
,"7":"Befriending each other, the cow and the bear,will see their young ones lie down together. Like cattle, the lion will eat hay."
,"8":"By the cobra's den the infant will play. The child will put his hand into the viper's lair."
,"9":"No one will harm or destroy over my holy mountain, for as water fills the sea,the earth will be filled with the knowledge of the Lord."
,"10":"On that day the 'Root of Jesse' will be raised as a signal for the nations. The people will come in search of him, thus making his dwelling place glorious."
,"11":"On that day Yahweh will again raise his hand to reclaim the remnant of his people from Assyria; from Egypt, Pathros and Ethiopia; from Elam, Shinar, Hamath and from the coastlands of the sea."
,"12":"He will set up a signal that can be seen from all the countries and assemble the exiles of Israel; he will gather the scattered people of Judah from all the corners of the earth."
,"13":"Then Ephraim will cast off its jealousy and Judah will be rid of its enemies. Ephraim will not envy Judah nor Judah be hostile to Ephraim."
,"14":"But the two will sweep down together upon the shoulder of Philistia to the west and plunder the nations to the east. They will lay their hands upon Edom and Moab and make the Ammonites their subjects."
,"15":"Yahweh will dry up the tongue of the Egyptian sea; he will sweep his hand over the Euphrates in scorching fury, and break it into seven streams that men can cross dry-shod."
,"16":"Then there will be a highway for the remnant of his people coming back from Assyria, as there was when Israel came out of Egypt."
}`)
	CurrentBook.AddChapter(12, `{
"1":"On that day you will say: 'I give praise to you, O Lord. Although you have been angry with me,your anger has been appeased,and you have consoled me."
,"2":"He is the God of my salvation; in him I trust and am not afraid, Yahweh is my strength: him I will praise, the one who saved me.'"
,"3":"You will draw water with joy,from the very fountain of salvation."
,"4":"Then you will say: 'Praise to the Lord, break into songs of joy for him, proclaim his marvellous deeds among the nations,and exalt his Name."
,"5":"Sing to the Lord: wonders he has done,let these be known all over the earth."
,"6":"Sing for joy, O people of Zion, for great in your midst is the Holy One of Israel.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"An oracle concerning Babylon, seen by Isaiah, son of Amoz:"
,"2":"On a bare hilltop raise a banner; cry aloud to them, wave a hand for them,to enter the Gates of the Nobles."
,"3":"I have ordered my sacred knights, I have summoned my mighty warriors -,all those who rejoice in my triumph -,I have commanded them to carry out my wrath."
,"4":"Listen, a rumbling on the mountains,as of a great multitude!,Listen, a tumultuous uproar,as of kingdoms massing together!,Yes, Yahweh Sabaoth is mustering his army."
,"5":"From faraway lands, from the ends of the heavens,they come - Yahweh,and the instruments of his wrath -,to destroy the whole earth."
,"6":"Wail, for the day of Yahweh is near; it will come as destruction from the Almighty."
,"7":"Every man's arm will go limp, every man's heart will fail him,"
,"8":"Everyone will be gripped with terror. Pain and sorrow taking hold of them, men will be in anguish,like women in travail. They will look aghast at each other, their faces aflame as with fever."
,"9":"See how the day of Yahweh comes: it is a cruel day,coming with wrath and fierce anger. It will make the earth desolate; it will destroy sinners within it."
,"10":"The stars and constellations at night,will send forth no light, the moon,will not shine; in the morning the sun,will be dark as it rises."
,"11":"I punish the world for the evil it does, and the wicked for their sins. I make the arrogance of the proud cease,I end the haughtiness of the ruthless."
,"12":"I will make men scarcer than gold,and mankind more rare than the gold of Ophir."
,"13":"This is why the heavens tremble,and the earth shakes its foundation, at the wrath of Yahweh Sabaoth,on the day of his burning anger."
,"14":"Like a hunted gazelle, or like a flock without a shepherd,everyone returns to his own people, each one flees to his native land."
,"15":"Whoever is captured will be butchered, whoever is caught will be slaughtered."
,"16":"Their babies will be dashed to pieces before their eyes, their houses will be looted, their wives raped."
,"17":"Against them I will stir up the Medes, who don't crave for money,and are not interested in gold."
,"18":"Their bows and arrows will strike down young men,without mercy or compassion. They do not spare infants and children."
,"19":"Babylon, the jewel of kingdoms, pride and glory of the Chaldeans, will be like Sodom and Gomorrah,when overthrown by God."
,"20":"She will never be inhabited, nor dwelt in from age to age. There no Arab will pitch his tent, no shepherd will tend his flock."
,"21":"There wild beasts of the desert will lie, howling creatures will fill the houses, owls and ostriches will dwell there,and wild goats will leap about."
,"22":"There mad dogs will cry out in her strongholds, and jackals in her palaces. Her time is close at hand; her days are now numbered."
}`)
	CurrentBook.AddChapter(14, `{
"1":"The Lord will take pity on Jacob, he will choose Israel again and settle them in their own land. Then foreigners will join them and be counted with the people of Jacob."
,"2":"Nations will take them and bring them to their own place. But as soon as they are back home, the people of Israel will subdue them and make them servants and maids. Thus the people of Israel will make captives of their captors and rule over their oppressors."
,"3":"On the day Yahweh gives you rest from your suffering and turmoil, from your fear and your cruel bondage,"
,"4":"you will take up this taunt against the king of Babylon: How has the oppression ceased?,How has the strongman ended?"
,"5":"Yahweh has broken the staff of the wicked, the scepter of the tyrant"
,"6":"who struck down the people,with blow after blow, who ruled the nations in anger, with unrelenting persecution."
,"7":"The whole earth is at rest and at peace, breaking forth into song."
,"8":"Even the cypresses exult,and the cedars of Lebanon say: 'Now that you have fallen, no loggers come to cut us down.'"
,"9":"The netherworld is all astir,to meet you when you come. It stirs up the dead to greet you -,all who were leaders of theworld. It raises from their thrones -,all who were kings of the nations."
,"10":"They all speak and say to you: 'You have also been thrown to the ground and have become like us!"
,"11":"All your pomp has been brought down to the Kingdom of death, along with the sound of your harps; maggots are the bed beneath you,and worms are your blanket."
,"12":"How you are fallen from heaven, O Lucifer, son of the morning!,How you are cast down to the ground, you who mowed down the nations!"
,"13":"You said in your heart, 'I will ascend to heaven, I will raise my throne,higher than the stars of God; I will sit on the Mount of Assembly, in the far recesses of the North."
,"14":"I will climb up above the clouds; I will be like the Most High!'"
,"15":"But down to the netherworld you go, to the deep recesses of the Pit."
,"16":"All who see you stare at you,and ponder over your fate: 'Is this the man who shook the earth, who made kingdoms quake,"
,"17":"who made the world a waste, who overthrew its cities,and would not give its captives release?'"
,"18":"All kings of nations lie in state, each in his own tomb."
,"19":"You are nevertheless cast out of the tomb, like a rejected untimely birth, like a trampled corpse buried,under the slaughtered, under those cut down by the sword, thrown into the common grave."
,"20":"You were not given a monument,for you have brought your land to ruin, and caused your people to be slain. May the descendants of evildoers never be mentioned again!"
,"21":"Go up, slaughter the sons for the sins of their fathers, lest they rise and possess the land,and cover the earth with their cities."
,"22":"'I will rise up against them,' says Yahweh Sabaoth. 'I will cut off from Babylon her name, her remnant, offspring and posterity,' says Yahweh."
,"23":"'I will turn her into a swampland, a habitation of reptiles and crocodiles; I will sweep her with the broom of destruction,' says Yahweh Sabaoth."
,"24":"Yahweh Sabaoth has sworn: 'As I have planned, so will it be!,As I have decided, so will I do;"
,"25":"I will destroy the Assyrian in my land, trample him down on my mountains; take his yoke off my people's neck, and remove his burden from their shoulders."
,"26":"This is the sentence he pronounced for the whole earth; with his hand stretched out over all nations."
,"27":"Yahweh has made a decision, and who will annul it? His hand is stretched out, and who can turn it back?"
,"28":"In the year King Ahaz died this oracle was proclaimed:"
,"29":"'Rejoice not, all you Philistines, that the rod which smote you is broken; for from the root of the snake will come forth a viper, and its offspring will be a flying dragon."
,"30":"On that day my poor will have their fill with the fruits of my fields and the helpless will rest secure. But through famine I will kill your children and slay even your remnant."
,"31":"Wail, O gate! Cry, O city!,tremble in fear, all you Philistines!,For smoke comes from the north -,a great army sweeps down on you."
,"32":"What answer will then be given to the messengers of that nation? 'Yahweh has laid the foundation of Zion, and there his afflicted people will take refuge.'"
}`)
	CurrentBook.AddChapter(15, `{
"1":"An oracle concerning Moab: Laid waste in a night, Ar of Moab is silent!,Laid waste in a night, Kir of Moab is ruined!"
,"2":"The people of Diman have gone,to the high places to weep. Over Nebo and Medeba Moab wails. Every head is shaved, every beard is shorn."
,"3":"In the streets they wear sackcloth, on the rooftops and in the squares; everyone wails, every heart melts in tears."
,"4":"Heshbon and Elealeh cry out; their howling is heard as far as Jahaz; the armed men of Moab cry aloud,and their hearts are faint."
,"5":"My heart cries out for Moab; her fugitives flee as far as Zoar, as far as Eglath-shelishiyah. At the ascent of Luhith,they go up weeping; on the way to Horonaim,their cries are heart-rending."
,"6":"The watered fields of Nimrim,have become a wasteland; the turf is dried up, the grass is withered, the verdure is gone."
,"7":"Now they carry away their possessions, the wealth they have stored up, to the Brook of the Willows."
,"8":"Their cry rings round the border of Moab, resounds as far as Eglaim, reaches as far as Beer Elim."
,"9":"The waters of Dimon flow with blood, but worse is yet in store, for I will bring lions upon Dimon, upon those who escape from Moab, and upon those who survive in the land."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Like bewildered birds,cast out of their nests, the daughters of Moab,stay at the fords of Arnon."
,"2":"From Sela, across the wilderness, they send lambs to the mount of Zion: are they not the rulers of the land?"
,"3":"They say: 'Take counsel, render decision with justice. Even at high noon,let your shade be like the night,to hide the fugitives. Do not betray the refugees."
,"4":"Let the outcasts from Moab,sojourn among you; be a refuge to them,against the destroyer.',and the destruction is over,and those who trample the land,underfoot have gone,"
,"5":"a throne will be established,steadfast in love. One from the House of David, for the sake of truth will sit on it; he will administer justice swiftly,and judge the people righteously.)"
,"6":"We have heard of the pride of Moab, of her arrogance and insolence, of her empty pretensions."
,"7":"Let her wail then, and let everyone wail for her. Mourn for the raisin-cakes of Kirhareseth."
,"8":"The fields of Heshbon languish, the vines of Sibmah wither. The tyrants of the nations,have trampled down the choicest vines, those that once reached Jazer, spreading towards the desert, stretching out as far as the sea."
,"9":"Therefore I weep as Jazer weeps,for the vines of Sibmah. I drench you, O Heshbon, O Elealeh, with my tears!,For over your fruit and your vintage,have been heard loud battle cheers."
,"10":"But they are gone: joy and gladness,have now vanished from your orchards. In the vineyards,no more singing is heard, no more shout of joy is raised. In the winepresses,no foot treads out wine, no voice shouts in exultation, no heart sings a vintage song."
,"11":"Like a lyre, therefore, my soul moans for Moab; my heart pines for Kir-areseth."
,"12":"When Moab appears on the high places, she will only grow weary; when she goes to pray at the sanctuary, it will be to no avail."
,"13":"This is the word which Yahweh spoke against Moab in the past. But"
,"14":"now Yahweh says, 'Within three years, like the years of a servant bound by contract, the glorious power of Moab will have ceased to command respect, her survivors will be very few and feeble.'"
}`)
	CurrentBook.AddChapter(17, `{
"1":"An oracle concerning Damascus: 'Damascus will cease to be a city,and will become a heap of ruins."
,"2":"Her towns will be abandoned,and left as pasture for flocks; there they will lie down afraid of no one. Damascus will no longer be a kingdom,"
,"3":"so Ephraim will be left undefended. From now on the remnant of Aram will have no more power than the children of Israel.',This is Yahweh Sabaoth speaking."
,"4":"On that day,the glory of Jacob will fade; the fat of his flesh will waste away."
,"5":"It will be as when a reaper,gathers the standing grain,and lops off the stalks, or as when they gather the gleanings,in the Valley of Rephaim."
,"6":"Yet some gleanings remain, as when an olive tree is beaten -,two or three olives are left on the topmost bough, four or five on the fruitful branches, says Yahweh, the God of Israel."
,"7":"On that day people will look to their Creator, their eyes turned to the Holy One of Israel."
,"8":"They will no longer look to the altars, to the work of their hand, the sacred pole or the incense stand,which their fingers have made."
,"9":"On that day your cities will be like the cities of the Hivites and the Amorites which they abandoned to the Israelites. All will be desolation."
,"10":"For you have forgotten the God of your salvation, you have failed to remember the Rock of your refuge. You may plant the finest plants, you may plant out imported shoots,"
,"11":"you may make them grow,on the day you plant them, you may make them blossom,on the day you sow, yet they dwindle and the harvest is gone: then you may cry!"
,"12":"Oh, the rage of many peoples -,they rage like the raging sea!,Oh, the thunder of many nations -,they thunder like the thundering of mighty waves!"
,"13":"But God rebukes them, and they flee far away, swept away like chaff,on the hills before the wind, whirled away like eddying dust,before the thunderstorm."
,"14":"At eventide they sow terror; before morning they are no more. Such is the portion of our despoilers, such is the lot of our plunderers."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Woe to the land of whirring wings,beyond the rivers of Cush,"
,"2":"which sends ambassadors by sea,in papyrus boats over the waters!,Go, swift messengers, to a people tall and bronzed, to a nation feared far and wide, a nation conquering and strong, whose land the rivers divide."
,"3":"All you inhabitants of the world, all you who dwell on earth, when a banner on the mountain is raised, look!,When a horn on the hill is sounded, listen!"
,"4":"For thus Yahweh spoke to me: 'From where I dwell, I gaze untroubled, like heat shimmering in the sunshine, like a dewy mist in the heat of harvest.'"
,"5":"For before the vintage, when the flowers fall, and the blooms become ripened grapes, I will cut shoots and prune,and hew away spreading branches."
,"6":"They will be left to the birds of prey,and to the beasts of the earth. The birds will feed on them all summer, and the beasts all winter."
,"7":"At that time the tall, bronzed people from a country traversed by rivers - a conquering and strong nation feared far and wide - will bring offerings to Yahweh Sabaoth, to Mount Zion. For this is the place where the name of Yahweh dwells."
}`)
	CurrentBook.AddChapter(19, `{
"1":"An oracle concerning Egypt: Yahweh rides on a swift cloud and comes to Egypt. The idols of Egypt tremble before him; the heart of Egypt melts within it."
,"2":"I will stir Egyptians against each other: brother will fight against brother, friend against friend, city against city, kingdom against kingdom."
,"3":"The Egyptians will lose heart for I will confound their plans; they will consult idols and sorcerers, ghosts and necromancers."
,"4":"I will deliver the Egyptians,into the hands of a cruel master, and a tyrant will be their ruler. It is Yahweh Sabaoth who speaks."
,"5":"The waters of the river will dry up; the river bed will be parched."
,"6":"The canals will become foul dry, the tributaries of Egypt's Nile will dwindle and cease to flow. The reeds and rushes will wither."
,"7":"The plants on the banks,and at the mouth of the river, and all the crops along the Nile will dry up, blow away and be no more."
,"8":"The fishermen will mourn, all who cast hook in the Nile will groan, and those who throw nets upon the waters will lament."
,"9":"The flax worker will despair, the carders, too, and white cloth weavers;"
,"10":"the spinners will be crushed; the hired laborers despondent."
,"11":"The princes of Zoan are utter fools, and brutish is the counsel,of the wisest of Pharaoh's counselors. How can you say to Pharaoh, 'I am one of the wise men, a disciple of ancient kings?'"
,"12":"Where are your wise men?,Let them come forward now, let them explain to you,what Yahweh will do against Egypt."
,"13":"The princes of Zoan have become fools; the princes of Memphis have been deceived; Egypt is led astray by the chiefs of her tribes."
,"14":"Yahweh has poured into them a spirit,which makes Egypt err in all her ventures, as a vomiting drunkard errs."
,"15":"And Egypt will never succeed,in anything it attempts,by head or by tail, by palm or by reed."
,"16":"On that day the Egyptians will be like a woman trembling in fear whenever they see the hand of Yahweh Sabaoth raised against them."
,"17":"Judah will be a terror to Egypt. Whenever they think of Judah, the Egyptians will be terrified because of the terrible fate Yahweh Sabaoth has in store for them."
,"18":"On that day there will be five cities in the land of Egypt speaking the language of Canaan, in which people will call upon Yahweh Sabaoth. One of them is called the City of the Sun."
,"19":"On that day there will be an altar to Yahweh in the center of the land of Egypt and a sacred pillar to Yahweh at its border."
,"20":"It will be a sign and a remembrance of Yahweh Sabaoth in the land of Egypt, so that they may call to him when they are oppressed, and he will send a savior to defend and deliver them."
,"21":"Yahweh will reveal himself to the Egyptians. They will acknowledge him on that day and worship him with sacrifice and burnt offerings. They will make vows to Yahweh and perform them."
,"22":"Yahweh will strike Egypt and then cure it. When they turn to him, he will heal them and heed their supplications."
,"23":"On that day there will be a highway from Egypt to Assyria. Assyrians will come to Egypt, and Egyptians to Assyria. Egyptians and Assyrians will worship together."
,"24":"On that day, Israel will be a third party with Egypt and Assyria - a blessing on earth."
,"25":"And Yahweh will bless them saying, 'Blessed be Egypt my people, Assyria my creation, and Israel my heritage.'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"In the year that the general sent by Sargon, king of Assyria, made an assault upon Ashdod, capturing it,"
,"2":"Yahweh gave a warning through Isaiah, the son of Amoz, saying, 'Hang the sackcloth from your hips, take off your sandals and go.' He did so, and walked naked and barefoot."
,"3":"Then Yahweh said: Just as my servant Isaiah has walked naked and barefoot for three years as a sign and portent for Egypt and Ethiopia,"
,"4":"so will the king of Assyria lead away captives from Egypt and exiles from Ethiopia, both the young and the old, naked and barefoot, their buttocks uncovered, to the disgrace of Egypt."
,"5":"Those who pinned their hope upon Ethiopia and made a boast of Egypt will be frightened and put to shame."
,"6":"On that day the inhabitants of this coastland will say, 'Look at what happened to those we trusted and fled to for help and deliverance from the king of Assyria! What are we going to do now to save ourselves?'"
}`)
	CurrentBook.AddChapter(21, `{
"1":"An oracle concerning the Desert by the Sea: A fearful vision is shown to me: As whirlwinds sweep over the Negeb, coming in waves from the desert, from the fearful land,"
,"2":"the traitor betrays, the plunderer plunders. 'Go up, O Elam!,Lay siege, O Media!','I have silenced all the groanings.'"
,"3":"Therefore I am in anguish; my body is wracked with pain,as a woman in travail. I am so bewildered that I cannot hear, I am so dismayed that I cannot see."
,"4":"My mind reels, my heart falters in fear; the twilight I longed for,has become a horror."
,"5":"They set the tables, they spread the rugs, they eat and drink. Arise, O princes, oil the shield!"
,"6":"For this is what Yahweh said to me, 'Go, post a watchman,and make him report what he sees."
,"7":"If he sees riders: horsemen in pairs, men mounted on camels, men mounted on donkeys; let him observe diligently, let him listen attentively.'"
,"8":"Then the watchman shouted, 'On a watchtower, O Lord, I stand,through all the watches of the day, and at my post I stay,through all the watches of the night."
,"9":"And look, here come riders, horsemen in pairs.',And he spoke up again: 'Fallen is Babylon, fallen, and all the graven images of her gods,lie shattered on the ground !''"
,"10":"O my people, threshed and winnowed, I announce to you what I have heard,from Yahweh Sabaoth, the God of Israel."
,"11":"An oracle concerning Dumah: Someone calls to me out of Seir, 'Watchman, what of the night?,Watchman, what of the night?'"
,"12":"The watchman answers, 'Morning comes, but soon,it will be night again. Come back and ask, if you want to ask again.'"
,"13":"An oracle concerning Arabia: In the forest of Arabia lodge,the Dedanites' traveling companies."
,"14":"Those who dwell in the land of Tema,went to meet the fugitives: bring bread for the hungry,and water for the thirsty."
,"15":"These people have fled from the sword, from the whetted swords, from the bent bows, from the fury of battle."
,"16":"For thus Yahweh says to me, 'In a year's time, as a worker bound by contract would reckon it, all the glory of Kedar will come to an end."
,"17":"Few of Kedar's archers and warriors will remain.' Yahweh God of Israel has spoken."
}`)
	CurrentBook.AddChapter(22, `{
"1":"An oracle concerning the Valley of Vision. What ails you now, that you have all gone up to the housetops,"
,"2":"you with your hustle and bustle,a tumultuous city, a wanton town?,Your slain men,have not been killed by the sword, nor have they died in battle."
,"3":"Together your leaders have fled; they were captured under the threat of the bow. Your valiant were caught together, they had fled far away."
,"4":"That is why I say, 'Look away from me. I will weep bitterly. Do not try to comfort me,over the ruin of the daughter of my people.'"
,"5":"There comes from the Lord Yahweh Sabaoth a day of trampling and rout. In the Valley of Vision they undermine the walls,and the cries for help ascend to the mountains."
,"6":"Elam bears the quiver,with charioteers and horsemen; Kir uncovers the shield."
,"7":"Chariots are all over your choicest valleys; horsemen are stationed at the gates."
,"8":"Judah is stripped of her defenses. On that day you turned your eyes to the arsenal at the Palace of the Forest. "
,"9":"You saw the many breaches in the defenses of the city of David. You gathered together the waters of the lower pool."
,"10":"You counted the houses of Jerusalem and tore down some of them to strengthen the wall."
,"11":"You built a reservoir between the two walls for the water of the old Pool. But you gave no thought to its Maker. You had no regard for him who had planned it long ago. "
,"12":"On that day the Lord Yahweh Sabaoth called you to weep and mourn, to shave your head and put on sackcloth."
,"13":"But look, instead of that, there is wanton revelry: oxen are butchered and sheep are slaughtered. You eat meat and get drunk, saying, 'Let us eat and drink for tomorrow we die.'"
,"14":"A word from Yahweh Sabaoth has reached my ears: 'This sin will not be forgiven until they die.'"
,"15":"Thus says the Lord Yahweh Sabaoth: Go and talk to this man Shebna, who is the palace steward. Ask him:"
,"16":"Who are you and what right have you,to carve a resting place on the heights, to cut out a burial place,for yourself here in the rock?"
,"17":"Look here, O you strongman, Yahweh will seize you; he will take you captive,and take firm hold of you."
,"18":"He will roll you up, toss you like a ball, then violently hurl you down,into a large open land. There you will perish,with the chariots of your glory, O you, the shame of your master's house!"
,"19":"You will be deposed, strongman. I will hurl you down from where you are."
,"20":"On that day I will summon,my servant Eliakim, son of Hilkiah."
,"21":"I will clothe him with your robe, I will strengthen him with your girdle, I will give him your authority, and he will be a father,to the inhabitants of Jerusalem,and to the people of Judah."
,"22":"Upon his shoulder I will place,the key of the House of David: what he opens, no one shall shut; what he shuts, no one shall open."
,"23":"I will fasten him like a peg,in a sure spot, and he will be a seat of honor,in the house of his father."
,"24":"(Upon him will hang all the load of his father's house - offspring and descendants, all the little vessels from bowls to jars."
,"25":"On that day, says Yahweh Sabaoth, the peg fastened in a sure spot will give way; it will be cut down and the load hanging on it will fall. Thus Yahweh has spoken.)"
}`)
	CurrentBook.AddChapter(23, `{
"1":"An oracle concerning Tyre: Wail, O ships of Tarshish, for Tyre is destroyed!,When you return from Kittim,you will hear the news and wonder."
,"2":"Keep silent, merchants of Sidon, all you inhabitants of the coast. Your messengers passed over the sea,"
,"3":"across the wide oceans; the grain of Shihor, the harvest of the Nile, was your income,and you were the fair of the nations."
,"4":"Be ashamed, O Sidon, refuge on the sea!,The queen of the sea wonders: 'Have I not had labor pains,and brought forth children?,Have I not nourished young men,and brought up daughters?'"
,"5":"Those in Egypt will be in anguish,when they learn the fate of Tyre."
,"6":"You who dwell on the coastlands, wail as you pass over to Tarshish."
,"7":"Is this the ancient city, your pride, whose feet had carried her afar,to found colonies in distant lands?"
,"8":"Who has planned this against Tyre, the imperial city whose merchants,are princes, whose traders are among the great ones of the world?"
,"9":"It is Yahweh Sabaoth who has planned it, to bring down her proud majesty, to humble the great ones of the world."
,"10":"Till your land like the valley of the Nile,O Daughter of Tarshish, you have no more shipbuilding yard."
,"11":"Yahweh has stretched out his hand,over the sea to make kingdoms tremble. He has ordered the destruction,of the fortresses of Phoenicia."
,"12":"He has said, 'Rejoice no longer, ravished virgin daughter of Sidon. Arise, pass over to Cyprus; even there you will find no rest.'"
,"13":"Look at the land of the Chaldeans, a people now of no account. The Assyrians have destined the land,to be a place for wild beasts. They have erected siege towers,and demolished her bastions, razed her palaces, completely,reducing her to ruins."
,"14":"Wail, O ships of Tarshish, for your haven is destroyed."
,"15":"On that day, Tyre will be forgotten for seventy years, about the span of a king's life. Then at the end of seventy years, it will happen to Tyre as in a harlot's song:"
,"16":"Take a harp, go about the city, forgotten harlot, sing your sweetest song, play your best melody, that they may remember you."
,"17":"At the end of seventy years, Yahweh will visit Tyre. She will return to her hire and once again play whore with all the kingdoms of the world on the face of the earth."
,"18":"But her wages and activities as harlot will be dedicated to Yahweh, instead of being stored or hoarded. Her profits will go to those who live in the presence of Yahweh, that they may have abundant food and beautiful clothes."
}`)
	CurrentBook.AddChapter(24, `{
"1":"See how Yahweh breaks,the land and makes it crack, how he turns it upside down,and scatters its inhabitants,"
,"2":"priest and people alike, servant and master, maid and mistress; buyer and seller, lender and borrower. As it will be with the creditor, so will it be with the debtor."
,"3":"Cracked is the earth, worn out is the world, for Yahweh has spoken."
,"4":"The earth mourns and withers, the world pines and fades, both heaven and earth languish."
,"5":"The land lies polluted, defiled by its inhabitants,who have transgressed the laws, violated the ordinances, and broken the covenant."
,"6":"Therefore a curse consumes the land,and its people burn for their guilt. Few of its inhabitants are left."
,"7":"The new wine mourns, the vine pines away, all the revelers groan."
,"8":"The merry timbrels are stilled, the noise of the revelers is over, the harps and lyres are silenced."
,"9":"No more will they drink wine with a song; strong drink tastes bitter to the drinker."
,"10":"The city of confusion is broken down, every door is closed; you cannot enter."
,"11":"In the streets they cry for wine: all joy is gone, all cheer has left the land."
,"12":"The city is left in distress, its ruined market is deserted.)"
,"13":"Some remain where nations have been,as olives after the beating of the trees, as grapes after the vintage."
,"14":"They lift up their voices and shout for joy, from the vast lands they acclaim Yahweh."
,"15":"People give him glory from the western islands: 'Islands, sing to Yahweh, the God of Israel!'"
,"16":"From the remotest part of the earth,we hear songs of praise: 'Glory to the Righteous One.',Yet I said: 'Woe is me! Woe is me! there is but treachery and traitors!'"
,"17":"Not at all!,Terror, pit and snare,await you, inhabitants of the earth."
,"18":"He who flees at the cry of terror,falls into the pit, and he who climbs out of the pit,gets caught in the snare. For the floodgates of heaven are opened,and the earth shakes to its foundation."
,"19":"The earth is broken into fragments, the earth is in convulsion."
,"20":"The earth reels like a drunkard, it sways like a hut in the storm, weighed down by its transgression, and it falls, never to rise again."
,"21":"On that day Yahweh will punish,the host of the heavens above, and the kings of the earth below."
,"22":"They will be gathered together,as prisoners are gathered in the pit; they will be shut up in a dungeon,and after a time, punished."
,"23":"Then the moon will be confounded,and the sun ashamed, when Yahweh Sabaoth reigns,on Mount Zion and in Jerusalem, and lets his Glory be shown to his elders."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Yahweh, you are my God; I exalt you and praise your name, for you have done wonderful things, faithful and true, planned long ago."
,"2":"You have made the city a heap, the massively defended city a ruin. The bastion of foreign domination is a city no more, nor will it ever be rebuilt."
,"3":"Therefore a strong people glorifies you; the head of a great nation holds you in awe."
,"4":"For you have been a refuge to the poor, a haven to the needy in time of distress, a harbor in the storm, a shade from the heat. For the blast from the ruthless is like an icy storm, "
,"5":"like heat in a dry place. You silence the noise of foreigners; you subdue the singing of the despot and the proud."
,"6":"On this mountain Yahweh Sabaoth will prepare for all peoples a feast of rich food and choice wines, meat full of marrow, fine wine strained."
,"7":"On this mountain he will destroy the pall cast over all peoples, this very shroud spread over all nations,"
,"8":"and death will be no more. The Lord Yahweh will wipe away the tears from all cheeks and eyes; he will take away the humiliation of his people all over the world: for Yahweh has spoken."
,"9":"On that day you will say: This is our God. We have waited for him to save us, let us be glad and rejoice in his salvation."
,"10":"For on this mountain the hand of Yahweh rests. Moab instead will be trodden down, as straw trodden down on a dunghill. "
,"11":"He will stretch forth his hands there, as a swimmer spreads out his hands to swim. But Yahweh will strike down their pride together with their falsehood."
,"12":"He will raze the high-walled fortress; he will level it to the ground, as dust."
}`)
	CurrentBook.AddChapter(26, `{
"1":"On that day this song will be sung in the land of Judah: We have a strong city, he himself has set up,walls and fortifications to protect us."
,"2":"Open the gates!,Let the righteous nation enter, she who is firm in faithfulness."
,"3":"You keep in perfect peace,the one of steadfast mind, the one who trusts in you."
,"4":"Trust in Yahweh forever, for Yahweh is an everlasting Rock."
,"5":"He brought down those who dwell on high, he laid low the lofty city, he razed it to the ground, leveled it to the dust,"
,"6":"Now it is trampled,the poor and the lowly tread upon it."
,"7":"Let the righteous walk in righteousness. You make smooth the path of the just,"
,"8":"and we only seek the way of your laws, O Yahweh. Your name and your memory are the desire of our hearts. "
,"9":"My soul yearns for you in the night; for you my spirit keeps vigil. When your judgments come to earth, the world's inhabitants learn to be upright. "
,"10":"But when favor is shown to the wicked, he does not learn to be just. He does evil in a land of righteousness and fails to see Yahweh's majesty."
,"11":"Yahweh, your hand is lifted up, but they fail to see that. Let them see your zeal for your people, that they may be put to shame. Let your enemies be burned in the fire of your anger."
,"12":"Yahweh, please give us peace; for all that we accomplish is your work."
,"13":"O Yahweh, our God, other lords besides you have ruled us, but it is your name alone that we honor."
,"14":"They are now dead, never to rise again, for you have passed sentence on them. You have wiped out all remembrance of them."
,"15":"You have enlarged the nation, O Yahweh; you have given glory to your name; you have widened the borders of the country."
,"16":"For they sought you in distress, they cried out to you in the time of their punishment."
,"17":"As a woman in travail moans and writhes in pain, so are we now in your presence."
,"18":"We conceived, we had labor pains, but we gave birth to the wind. We have not brought salvation to the land; the inhabitants of a new world have not been born."
,"19":"Your dead will live! Their corpses will rise! Awake and sing, you who lie in the dust!,Let your dew fall, O Lord, like a dew of light, and the earth will throw out her dead."
,"20":"Come, my people, enter your rooms and shut the doors behind you; hide yourselves for a moment until his wrath is over."
,"21":"For look, Yahweh is coming out of his dwelling; he will punish the inhabitants of the earth for their sins. The earth will reveal the blood shed upon her and will not conceal her slain any longer."
}`)
	CurrentBook.AddChapter(27, `{
"1":"On that day, with his fierce, strong, and powerful sword, Yahweh will punish Leviathan, the twisting serpent always fleeing; he will slay the dragon of the sea."
,"2":"On that day, he will say, 'Praise my fruitful vineyard!"
,"3":"I, Yahweh, am its keeper; I water it every moment. So that no one will harm it, day and night I guard it.'"
,"4":"'I have no wall, who will cleanse me from thorns?','I myself will march against them, I will burn them altogether. "
,"5":"Or if they come to me for refuge, let them make peace with me, yes, let them make peace with me.'"
,"6":"In days to come Jacob will take root, Israel will blossom and bear many a shoot,and fill the face of the earth with fruit."
,"7":"Has Yahweh beaten them as he beat those who beat them?,Has he slain them as he slew those who slew them?"
,"8":"With expulsion and exile,the city has been punished; with a blast as fierce as a storm from the east, she has been pursued and carried off."
,"9":"By this, therefore, the guilt,of Jacob will be expiated,and he will atone for his sins,when he pulverizes all the altar stones,like chalkstones crushed to pieces. No more Asherah poles or incense altars!"
,"10":"For the fortified city is abandoned: it lies deserted now, a forsaken habitation,left like a wilderness. There the calves graze, there they lie down, and there,they strip bare its branches."
,"11":"Its dry boughs are broken; women come and make fire with them. This is a people without understanding; therefore their Maker will not spare them; he will not show compassion on them."
,"12":"On that day, between the Euphrates and the Wadi of Egypt, Yahweh will thresh out the grain. One by one you will be gleaned, O people of Israel."
,"13":"On that day,a great trumpet will blow, and those who were perishing,in the land of Assyria,and those who were driven out,to the land of Egypt,will return to worship the Lord,on the mountain in Jerusalem."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Woe to the drunkards of Ephraim proudly adorned, to that fading flower of luxurious beauty,on the head of a rich valley -,all are dizzy with wine."
,"2":"Look, the Lord is sending,a powerful and strong one. Like a downpour of hail, like a destructive tempest, like flooding water,in torrential rain, he will cast it down to the ground -"
,"3":"that proud ornament,of the drunkards of Ephraim. He will trample it underfoot -"
,"4":"that fading flower of glorious beauty,on the head of a rich valley. It will be like an early fruit,which ripened before summer: as soon as someone sees it,he picks it, and while it is yet,in his hand he eats it."
,"5":"On that day, Yahweh Sabaoth,will be a glorious ornament, a diadem of beauty, to the remnant of his people."
,"6":"He will be a spirit of justice,to him who sits in judgment, a source of strength,to those who turn back the enemies at the gate."
,"7":"But they also have erred through wine, reeling and stumbling from strong drink. Priests and prophets stagger, befuddled with wine, reeling when seeing visions, stumbling when rendering decisions."
,"8":"All the tables are full of vomit; there is not a spot without filth."
,"9":"'Who does he think he is teaching?,Who does he think listens to him?,Babies just weaned from their mother's milk?,Babies just taken from their mother's breast?"
,"10":"Who cares to hear his,'Keep quiet, keep quiet!,Wait a little, wait a little!'"
,"11":"Yes, surely with stammering lips,and in a strange tongue, he will talk to this nation,"
,"12":"he who once said to them, 'This is rest, give rest to the weary'; and, 'This is repose.',But they would not listen."
,"13":"That is why Yahweh now says: Keep quiet, keep quiet!,Wait a little, wait a little!,So that when they have to go forward, they will instead fall backward; they will be injured and snared,and taken captive."
,"14":"Therefore, listen to the word of Yahweh, you scoffers who rule these people of Jerusalem."
,"15":"Because you make a boast, 'We have made a covenant with death, we have made a pact with the netherworld. When the flood passes by,it cannot harm us, for we have made lies our refuge,and falsehood our hiding place.'"
,"16":"Therefore the Lord Yahweh says this: See, I lay in Zion a granite stone, a precious stone, a sure foundation; he who relies on it shall not be put to shame."
,"17":"I will make justice the measure,and righteousness the plumb line. Violent hail will sweep away your refuge of lies and raging waters will overflow your hiding place."
,"18":"Your covenant with death will not stand, your pact with the netherworld will be annulled. When the overwhelming flood passes, you will be crushed by it."
,"19":"Morning after morning, by day and by night, the scourge will seize and crush you. If you understood this message, you would be terrified."
,"20":"'The bed will be too short to stretch out on, the blanket too narrow to wrap around you.'"
,"21":"Yahweh will arise as on Mount Perazim, he will rouse himself as in the Valley of Gibeon, to work his work - his singular work; to do his deed - his strange deed."
,"22":"Put an end to your mocking, or your bonds will be tightened, for I have heard the destruction decreed,against the whole earth,by the Lord Yahweh Sabaoth."
,"23":"Listen to my words, pay attention and understand what I say."
,"24":"Does the plowman do nothing but plow, loosen the earth, pulverize the clods with a harrow?"
,"25":"After leveling the soil, does he not begin to sow caraway and scatter cumin, wheat and barley and put spelt as the border?"
,"26":"For his God instructs him on what to do, he gives him guidance and discretion, too."
,"27":"For caraway is not threshed nor cumin crushed, but caraway is beaten with a stick and cumin with a rod."
,"28":"Is the wheat milled on the threshing floor? Is it threshed without end? They put in movement chariot and horses but do not grind it."
,"29":"All comes from Yahweh Sabaoth whose advice is excellent, whose wisdom is wonderful."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Woe to Ariel - Ariel, the city against which David encamped!,After a year or two, after the feasts have made their full round,"
,"2":"I will lay siege on Ariel,and there will be grief and mourning. To me she will be like an Ariel."
,"3":"I will send warriors against you; they will encircle you with outposts,and raise siegeworks against you."
,"4":"Thrown down, you will speak from the ground: from the dust your words will come muffled, your voice will rise as a ghost's, your speech will be a whisper in the dust. But in a flash,"
,"5":"the horde of your enemies will be like dust, the horde of tyrants, flying chaff."
,"6":"For suddenly, Yahweh Sabaoth will come,with thunder, earthquake and great noise, with whirlwind and thunderstorm,and flames of consuming fire."
,"7":"The hordes of all nations,that fight against Ariel, that attack and besiege her fortress, will vanish like a dream, like a vision in the night."
,"8":"As when a hungry man dreams he is eating,and awakens with an empty stomach, or when a thirsty man dreams he is drinking,and awakens with a parched throat, so will the horde of nations be,that make war against Zion."
,"9":"Be irresolute, be stupefied, lose your sight and remain blind!,Be drunk but not from wine, stagger but not from beer."
,"10":"For Yahweh has poured out on you,a spirit of deep sleep; he has shut your eyes - the prophets; he has covered your heads - the seers."
,"11":"The revelation of all this has become for you like the words of a sealed scroll. When someone gives it to another who knows how to read and says, 'Read this,' the other one answers, 'I cannot; it is sealed.'"
,"12":"When the scroll is given to one who doesn't know how to read,' he answers, 'I do not know.'"
,"13":"Yahweh has said; 'These people approach me in words; they honor me with lip-service, while their hearts stay afar. The worship they offer me is useless, these are no more than traditions and human rules."
,"14":"Because of this I will surprise them once more; the wisdom of the wise will be useless and the understanding of their prudent men will be at a loss."
,"15":"Woe to those,who hide deep from Yahweh their plans, who work in the dark and say, 'Who will know, and who will see us?'"
,"16":"You turn things upside down, as though the potter were the clay, and of him it could say, 'He did not make me; he knows nothing.'"
,"17":"In a very short time, Lebanon will become a fruitful field,and the fruitful field will be as a forest."
,"18":"On that day,the deaf will hear the words of the book, and out of the dark and obscurity,the eyes of the blind will see."
,"19":"The meek will find joy,and the poor among men will rejoice,in the Holy One of Israel."
,"20":"For the tyrant will be no more,and the scoffers gone forever, and all who plan,to do evil will be cut down -"
,"21":"those who by a word make a man guilty, those who for a bribe can lay a snare,and send home the just empty-handed."
,"22":"Therefore Yahweh, Abraham's redeemer, speaks concerning the people of Jacob: No longer will Jacob be ashamed; no longer will his face grow pale."
,"23":"When he sees the work of my hands, his children again in his midst, they will sanctify my name, they will sanctify the Holy One of Jacob, and stand in awe of the God of Israel."
,"24":"Those who err in spirit will understand; those who murmur will learn."
}`)
	CurrentBook.AddChapter(30, `{
"1":"'Woe to the rebellious children,' says the Lord; 'they make plans which are not mine, they form alliances I did not inspire, and thus add sin upon sin."
,"2":"They go down to Egypt without my advice to take refuge in Pharaoh's protection and seek shelter in the shadow of Egypt."
,"3":"Therefore Pharaoh's protection will be your shame and Egypt's shadow your confusion."
,"4":"When your officials reach Zoan and your ambassadors come to Hanes,"
,"5":"they will all be put to shame by a people who can do nothing for them, who can give neither help nor benefit but only disgrace and reproach.'"
,"6":"An oracle concerning the beasts of the Negeb: Through a distressed and troubled land,of lions and lionesses, of vipers and darting snakes, the envoys carry their riches upon the shoulders of young asses, their treasures upon the humps of camels, to a people that is of no use to them."
,"7":"Egypt! An illusory and useless help. Because of that I call it: Scarecrow, the Do-Nothing."
,"8":"Now go, write it down as a record for them, inscribe it on a scroll, so it will be an everlasting accusation against them."
,"9":"These are a rebellious people, their children deceitful. They do not listen to Yahweh's advice."
,"10":"To the seers they say, 'See not,' and to the prophets, 'Do not prophesy the truth. Just tell us pleasant things; see illusions and prophesy deceits."
,"11":"Stray from the path, turn from the way! Take away from us the Holy One of Israel!'"
,"12":"Therefore the Holy One of Israel says, 'Because you despised this message and resorted instead to lies and abusive taxes, choosing to stay with it,"
,"13":"therefore this guilt of yours will be like a breach on a high wall, cracked and bulging, ready to fall; the crash will come suddenly and instantly."
,"14":"It will be like the breaking of a potter's vessel, smashed so ruthlessly that among its fragments not one shard remains big enough to scoop cinder out of the hearth or ladle water out of the cistern.'"
,"15":"For thus said the Lord Yahweh, the Holy One of Israel: 'Conversion and calmness would have been your salvation, quietness and trust your strength.'"
,"16":"But instead you said, 'No, we will flee on horses!' Very well then, flee! And you added, 'We will ride on swift steeds.' Your pursuer will be swifter."
,"17":"At the threat of one, a thousand will flee, at the threat of five all will flee, till what is left of you will be like a staff on a mountaintop, like a banner on a hill."
,"18":"Yet Yahweh waits to give you grace; he rises to show you compassion. For Yahweh is a God of justice. Blessed are all who wait for him."
,"19":"O people of Zion, who dwell in Jerusalem, you will weep no more. When you cry, he will listen; when he hears, he will answer."
,"20":"When the Lord has given you the bread of anguish and the water of distress, he, your teacher will hide no longer."
,"21":"Your own eyes will see him, and your ear will listen to his words behind you: 'This is the way, walk in it.'"
,"22":"You will see the uncleanliness of your idols and images overlaid with silver and gold. You will throw them out like a menstrual cloth.'Away with you then!' you will say to them."
,"23":"He will then give rain for the seed you sow and make the harvest abundant from the crops you grow. On that day your cattle will graze in wide pastures."
,"24":"Your beasts of burden will eat silage tossed to them with pitchfork and shovel."
,"25":"For on the day of the great slaughter, when fortresses fall, streams of water will flow on every mountain and lofty hill."
,"26":"The light of the moon will be as the light of the sun, and the light of the sun seven times greater, like the light of seven days, when Yahweh binds up the wounds of his people and heals the bruises inflicted by his blows."
,"27":"Look, from afar,the Name of Yahweh is coming, burning in anger, with a heavy hand. Filled with fury are his lips, like a consuming fire is his tongue."
,"28":"Like a rushing torrent is his breath, rising up to the neck, shaking the nations,as in a sieve of destruction, putting the bit of his bridle,between the jaws of the peoples,causing them to err and stray."
,"29":"You will sing, as on the night of a holy solemnity; your hearts will rejoice,as when people go up with flutes, with timbrels and lyres. to the mountain of the Lord, to the mighty One of Israel."
,"30":"Yahweh will make his majestic voice heard,and show his arm descending,in devastating fury and consuming fire, with sweeping wind and crashing thunder."
,"31":"At the voice of Yahweh, Assyria will be battered; at the blows of his rod, it will be shattered."
,"32":"At every beat of the punishing rod,the plagues will fall on him. For Yahweh will fight him,with outstretched hand."
,"33":"The pyre has long been ready, prepared for the king. Broad and deep is its fire pit, piled up with dry grass and wood. The breath of the Lord, like a stream of brimstone, will set it ablaze."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Woe to those who go down to Egypt for help, who pin their hopes on cavalry, putting their trust in chariots because they are many, relying on horsemen because they are strong. Why did they not look to the Holy One of Israel or consult Yahweh? "
,"2":"And yet he is very wise, and from him disaster will come. He does not go back on his word; he will rise against the evildoers, and cut off the help the wicked waited for."
,"3":"The Egyptians are men, not God; their horses are flesh, not spirit. When Yahweh stretches forth his hand, the helper and the one he helped will fall and perish together."
,"4":"For thus the Lord has spoken: Just as a lion or a lion cub growls over its prey and is neither frightened nor disturbed by the shouts of the shepherd, so will Yahweh Sabaoth descend to fight on Mount Zion."
,"5":"Like birds that hover, so will Yahweh Sabaoth shield Jerusalem: he will protect and deliver, rescue and save."
,"6":"Return, O children of Israel, to him you have so wickedly betrayed."
,"7":"On that day each one of you will throw away the idols of silver and gold that his sinful hands have made."
,"8":"Assyria will fall by a sword not wielded by a man. They will be devoured by a sword not held by a mortal. They will flee before the sword, their young men will be captured and put to forced labor."
,"9":"They will desert their post and the officers, in terror, will abandon the standard.',It is Yahweh who speaks, whose fire is in Zion and whose furnace is in Jerusalem."
}`)
	CurrentBook.AddChapter(32, `{
"1":"A king will reign with justice,and princes reign in righteousness."
,"2":"Each will be like a shield from the wind,and a shelter from the rain, like streams of water in a dry, parched land, like the shade of a rock in a weary land."
,"3":"The eyes that see will not be shut; the ears that hear will not be stopped."
,"4":"The mind of the rash will not judge hastily; the tongue that stammers will speak clearly."
,"5":"No more will the fool be taken as noble, nor the scoundrel considered honorable."
,"6":"For the fool speaks folly and his mind thinks sinfully: he practices wickedness and takes pride in godlessness; he lets the hungry go without food, and the thirsty without drink."
,"7":"The ways of the scoundrel are also evil, scheming wickedly against the poor, destroying the needy with lies even when their plea is just."
,"8":"But the noble man's plans are noble, and so are his deeds."
,"9":"Rise up, women who are at ease; hear my voice, carefree daughters; give heed to my words."
,"10":"In a little over a year, you who feel complacent will be shaken, for harvest will not come and the vintage will fail."
,"11":"Tremble, you women who are at ease; be troubled, you carefree ones. Strip yourselves bare, with only a sackcloth to cover your loins."
,"12":"Beat your breasts for the pleasant fields, for the fruitful vine,"
,"13":"for the soil of my people overgrown with briers and thorns, for all the houses of joy, for the city of the wanton."
,"14":"For the palace will be abandoned, and the noisy city deserted; the fort and the tower will become dens forever, the delight of wild asses, a pasture for flocks."
,"15":"When at last the spirit is poured on us from on high, then will the desert become a garden, and this garden will be free as a fallow land."
,"16":"Justice will dwell in the wilderness; and in the fertile land, righteousness."
,"17":"Justice will bring about peace; justice will produce calm and security forever."
,"18":"My people will live in comfort and bliss in a land of secure dwellings and undisturbed resting places."
,"19":"While the forest will be beaten down and the fortress laid waste."
,"20":"How blessed you will be, sowing by every stream, letting your work animals roam contented and free."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Woe to you, O ravager,who never have been ravaged, you O treacherous one,who have not been betrayed!,When your ravaging is over, you yourself will be ravaged; when your treacherous deals are ended, you yourself will be betrayed."
,"2":"O Yahweh, have mercy on us,who put all our hope in you. Be our strength every morning, our salvation when trouble comes."
,"3":"Peoples flee when you thunder and threaten, nations scatter when you rise majestically."
,"4":"Your spoil, O nations, will be gathered,like grasshoppers or locusts,leaping and pouncing at grain in the fields."
,"5":"Great is Yahweh who dwells in the height,who fills Zion with justice and right,"
,"6":"at any time he makes you secure. Wisdom and knowledge are the helpful riches, the fear of Yahweh will be your treasure."
,"7":"The people of Ariel lament in the street, their envoys of peace bitterly weep."
,"8":"The highways lie waste with no traveler in sight. For the covenants were broken, the promises trampled down; no one has been respected."
,"9":"The earth mourns and languishes, Lebanon withers away with shame, Sharon has become a wilderness, and Bashan and Carmel are stripped bare."
,"10":"Yahweh says: now I will rise up, now I will be exalted, now I will lift myself up."
,"11":"You conceived chaff, you will deliver stubble, my breath like fire will devour you."
,"12":"The nations will be burned to lime, like thorns cut down and burned in the fire."
,"13":"You who are afar, hear what I have done; and you who are near, acknowledge my might."
,"14":"The sinners of Zion shake, trembling in fear are the hypocrites. 'Who among us will dwell with flames?,Who can subsist in the midst of fire?"
,"15":"He who walks uprightly,and speaks righteously, spurns profit from oppression, shakes his fists at graft and corruption, stops his ears against suggestions of bloodshed,and averts his eyes from evil plans."
,"16":"This is the man,who will dwell on the heights, his stronghold a fortress of rocks; bread is given to him, his water will not fail."
,"17":"Your eyes will behold a king in his splendor and a land that stretches afar."
,"18":"Yet your mind may still dwell on its old fears: Where is the oppressor who counted and weighed the taxes and enrolled our sons?"
,"19":"But you will see no more of those fierce people with obscure speech you cannot comprehend, with stammering tongue you cannot understand."
,"20":"Look to Zion, the city of our festivals; see Jerusalem, a peaceful abode, a tabernacle never to be destroyed. Not one of its stakes will ever be removed nor any of its ropes severed."
,"21":"But there is Yahweh mighty for our sake, in place of broad rivers and streams. Here you see no galley with oars; no stately sailing ship."
,"22":"But Yahweh is our judge, Yahweh is our king: he will save us."
,"23":"Your rigging hangs loose: it cannot hold the mast firm, it cannot keep the sail spread out. Such have been the prey and spoil that even the lame pounced on it. "
,"24":"On that day no one apologized, 'I am sickly.' The people who dwell there have been forgiven their sins."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Come, O nations, hear,and take heed, O peoples!,Listen, O earth and all that is in you; listen, O world and all that comes from you."
,"2":"The wrath of Yahweh is upon all nations. His fury is upon all their armies. He has doomed them, he has given them over for slaughter."
,"3":"Their slain will be thrown away, stench coming from the carcasses, mountains will flow with blood."
,"4":"The heavens will dissolve,and the skies roll up like a scroll, all their hosts shall fall, as the leaf falls from its vine, as the fruit falls from its tree."
,"5":"My sword waited in the heavens; and look, it descends upon Edom, to judge the people I have doomed."
,"6":"The sword of Yahweh is bathed in blood,and covered with fat -,the blood of goats and lambs, the fat of the saddle of rams. For Yahweh has a sacrifice in Bozrah, a great slaughter in the land of Edom."
,"7":"Wild oxen will fall,and young steers with the bulls. Their land will be drenched with blood; their soil enriched with fat."
,"8":"For Yahweh has a day of vengeance, Zion's defender has a year of recompense."
,"9":"The streams of Edom will become pitch, her soil will be turned into brimstone, her land will be burning pitch."
,"10":"Never will its fire be quenched, night or day, forever will its smoke go up. From generation to generation the land will lie desolate,and none will ever pass through it."
,"11":"It will be the haunt of pelican and wild hog, the dwelling place of the owl and the hawk. God has decided to make it empty, he has destined it to be desolate."
,"12":"There will be no more kings to be proclaimed, no princes to be acclaimed, for the nobility will vanish,in a kingdom doomed to perish."
,"13":"Thorns will grow over the castles, nettles and brambles over the citadels; the place will be a haunt of reptiles, an abode of owls and ostriches."
,"14":"Wild beasts will meet there, wild goats will call to one another; there will the night creatures alight,to find for themselves a resting place."
,"15":"There will the great owl make her nest,to lay and hatch and also find rest. There will the vultures gather, each with its mate."
,"16":"Seek and read from the book of Yahweh: not one of them will be missing, for his mouth has given the order,and his spirit has brought them together."
,"17":"He has cast the lot for them. His hand has divided it among them. They will possess the land forever, and from generation to generation they shall dwell there."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Let the wilderness and the arid land rejoice, the desert be glad and blossom."
,"2":"Covered with flowers, it sings and shouts with joy, adorned with the splendor of Lebanon, the magnificence of Carmel and Sharon. They, my people, see the glory of Yahweh, the majesty of our God."
,"3":"Give vigor to weary hands,and strength to enfeebled knees."
,"4":"Say to those who are afraid: 'Have courage, do not fear. See, your God comes, demanding justice. He is the God who rewards, the God who comes to save you.'"
,"5":"Then will the eyes of the blind be opened,and the ears of the deaf unsealed."
,"6":"Then will the lame leap as a hart,and the tongue of the dumb sing and shout. For water will break out in the wilderness,and streams gush forth from the desert."
,"7":"The thirsty ground will become a pool, the arid land springs of water. In the haunts where once reptiles lay, grass will grow with reeds and rushes."
,"8":"There will be a highway,which will be called The Way of Holiness; no one unclean will pass over it,nor any wicked fool stray there."
,"9":"No lion will be found there,nor any beast of prey. Only the redeemed will walk there."
,"10":"For the ransomed of Yahweh will return: with everlasting joy upon their heads, they will come to Zion singing, gladness and joy marching with them, while sorrow and sighing flee away."
}`)
	CurrentBook.AddChapter(36, `{
"1":"In the fourteenth year of King Hezekiah's reign, Sennacherib, king of Assyria, attacked all the fortified cities of Judah and captured them."
,"2":"From Lakish the king of Assyria sent his field commander with a large army to King Hezekiah in Jerusalem. They halted at the channel of the Upper Pool on the highway of the Fuller's Field."
,"3":"So Eliakim son of Hilkiah, the palace administrator, went out to him together with Shebna the secretary and Joah son of Asaph the recorder."
,"4":"The field commander said to them, 'Give Hezekiah this message of the great king of Assyria: How can you be so confident?"
,"5":"Do you think words can replace strategy and military strength? On whom are you relying to rebel against me?"
,"6":"You rely on Egypt, a broken staff which pierces the palm of him who leans on it. Such is Pharaoh, king of Egypt, for all who rely on him."
,"7":"Yes, you may say to me: 'We rely on Yahweh our God.' But isn't he the one whose altars and high places Hezekiah removed when he commanded Judah and Jerusalem: You shall worship before this altar?"
,"8":"Come now, make a bargain with my master, the king. I will give you two thousand horses if you are able to supply riders."
,"9":"How could you ever repulse one of the least of my master's generals? And you rely on Egypt for chariots and horsemen!"
,"10":"Do you think that I have come to attack and destroy this land without consulting Yahweh? He himself said to me: Go up to this land and conquer it!'"
,"11":"Then Eliakim and Shebna and Joah said to the field commander, 'Speak to your servants in Aramaic, we understand it. Do not speak to us in Hebrew in the hearing of these people on the walls.'"
,"12":"But the field commander said, 'Do you think that my master sent me to speak these words only to your master and you? Isn't it also to the men on the walls who with you will have to eat their own dung and drink their urine?'"
,"13":"Then the field commander stood and cried out with a loud voice in Hebrew, 'Hear the words of the great king of Assyria:"
,"14":"Do not let Hezekiah deceive you! No, he will not be able to help you!"
,"15":"Do not listen to him when he tells you to trust in Yahweh, saying, 'Yahweh will save us; this city will not be given over to the king of Assyria.'"
,"16":"Do not listen to Hezekiah but to what the king of Assyria says, 'Make your peace with me"
,"17":"and surrender. So I will let each of you eat of your vine and of your fig tree and drink the water of your cistern until I come again. Then I will take you to a land like your own land, a land of grain and new wine, of bread and vineyards."
,"18":"Hezekiah is misleading you when he says that Yahweh will save you. Have the gods of the nations rescued their lands from the hands of the king of Assyria?"
,"19":"Where are the gods of Hamath and Arpad? Where are the gods of Shepharvaim? And have the gods delivered Samaria from my hand?"
,"20":"Who among all the gods of these nations has been able to save his country from me? Do you think that Yahweh could deliver Jerusalem from my hand?'"
,"21":"The people were like deaf men and remained silent, for the king had commanded them not to answer him."
,"22":"Then Eliakim with Shebna and Joah came to Hezekiah with their clothes torn and told him what the field commander had said."
}`)
	CurrentBook.AddChapter(37, `{
"1":"When King Hezekiah heard this he tore his clothes, covered himself with sackcloth and went to the house of Yahweh."
,"2":"He sent Eliakim, Shebna and the elders among the priests, all wearing sackcloth, to the prophet Isaiah, son of Amoz."
,"3":"And they said to Isaiah, 'This is what Hezekiah says: 'Today is a day of distress, rebuke and disgrace, as when children come to birth and there is no strength to deliver."
,"4":"May your God hear the words of the field commander, whom his master the king of Assyria has sent. May Yahweh your God rebuke him for the words he said, insulting the living God. Therefore offer a prayer for the few of us that are left.'"
,"5":"When King Hezekiah's officials came to Isaiah,"
,"6":"he said to them: 'Tell your master this word of Yahweh: Do not fear because of what you heard when the servants of the king of Assyria insulted me. Listen!"
,"7":"I will let him be disturbed by certain news, so he will return to his country and there I will have him slain by the sword.'"
,"8":"The field commander returned and found the king of Assyria fighting against Libnah, for he had heard that the king had left Lachish."
,"9":"This was because King Sennacherib had heard that Tirhakah, the Cushite king of Egypt, was going out to fight him. Again Sennacherib sent messengers to Hezekiah with these words, "
,"10":"'Say to Hezekiah king of Judah that his God in whom he trusts might deceive him in saying that Jerusalem will not be given into the hands of the king of Assyria."
,"11":"Surely you have heard what the kings of Assyria have done to all the lands they have destroyed! And will you be spared?"
,"12":"Have the gods saved the nations that my fathers destroyed? Gozan and Haran, Rezeph and the sons of Eden who were in Telassar?"
,"13":"Where is the king of Hamath, the king of Arpad, the kings of the cities of Sepharvaim, of Hena and of Ivvah?'"
,"14":"Hezekiah took the letter from the messengers and when he had read it he went to the house of Yahweh where he unrolled the letter"
,"15":"and prayed saying,"
,"16":"'O Yahweh, God of hosts and God of Israel, enthroned above the cherubim! You alone are God over all the kingdoms of the earth, give ear Yahweh and hear!"
,"17":"Open your eyes and see! Listen to all the words of Sennacherib who has sent men to insult the living God!"
,"18":"It is true, Yahweh, that the kings of Assyria have laid waste all the countries of the earth."
,"19":"They have thrown their gods into the fire and destroyed them, for they were not true gods but made of wood and stone by human hands."
,"20":"Now, O Yahweh our God, save us from his hand and let all the kingdoms of the earth know that you alone, Yahweh, are God.'"
,"21":"Then Isaiah, son of Amoz, sent word to Hezekiah: 'You have called upon Yahweh and he has heard your prayer regarding Sennacherib, king of Assyria. This is what Yahweh has spoken against him:"
,"22":"The Virgin Daughter of Zion,despises and scorns you; the Daughter of Jerusalem,shakes her head behind you."
,"23":"Whom have you insulted and blasphemed?,Against whom have you raised your voice,and lifted up your brow?,Against the Holy One of Israel!"
,"24":"Through your servants,you have insulted Yahweh. For you have said: With my numerous chariots, I have climbed the heights of the mountains, the topmost recesses of Lebanon. I have felled its tallest cedars and its choicest fir trees. I have reached the remotest heights of its border, the best of its forests."
,"25":"I have dug wells and drunk waters; I dried up with the sole of my foot all the streams of Egypt."
,"26":"But have you not heard how I decreed it long ago?,I have just brought to pass what I planned from days of old: to lay waste fortified cities, to turn them into heaps of ruins."
,"27":"Shorn of power, their inhabitants,have been dismayed and confounded; they have been as the grass,and green plants in the field, as the grass on the housetops, as corn scorched before it blooms."
,"28":"I know whenever you rise or sit, whenever you come or go."
,"29":"Because of your rage against me,and of your arrogance that has,reached my ears, I will put my hook in your nose,and my bridle in your mouth, and I will turn you back,on the way by which you came."
,"30":"This will be a sign for you, O Hezekiah: This year you will eat the gleaning of the fields and next year the self-sown grain, but in the third year sow and reap, plant vines and eat the fruit."
,"31":"A remnant of the people of Judah shall take root below and produce fruit above."
,"32":"For a remnant will come from Jerusalem and survivors from Mount Zion. The zeal of Yahweh of hosts will accomplish this. That is why Yahweh has spoken concerning the king of Assyria."
,"33":"He shall not enter this city nor shoot his arrows."
,"34":"He shall not raise a shield to oppose it nor build a siege ramp against it. He shall leave by the way he came and he shall not enter the city, word of Yahweh."
,"35":"I will protect this city and so save it for my own sake and for the sake of David, my servant.'"
,"36":"That night the angel of Yahweh went and struck one hundred and eighty-five thousand men in the Assyrian camp. When the people rose early next morning there lay all the corpses."
,"37":"So Sennacherib, king of Assyria departed, returned home and lived in Nineveh."
,"38":"While he was worshiping in the temple of his god, Nisroch, his sons Adrammelech and Sharezer slew him with the sword and then escaped to the land of Ararat. And Esarhaddon, his son, succeeded him as king."
}`)
	CurrentBook.AddChapter(38, `{
"1":"In those days Hezekiah fell mortally ill and the prophet Isaiah, son of Amoz, went to him with a message from Yahweh, 'Put your house in order for you shall die; you shall not live.'"
,"2":"Hezekiah turned his face to the wall and prayed to Yahweh,"
,"3":"'Ah Yahweh! Remember how I have walked before you in truth and wholeheartedly, and done what is good in your sight.' And Hezekiah wept bitterly."
,"4":"Then the word of Yahweh came to Isaiah,"
,"5":"'Go and tell Hezekiah what Yahweh, the God of his father David, says: I have heard your prayer and I have seen your tears. See! I am adding fifteen years to your life"
,"6":"and I will save you and this city from the power of the king of Assyria. I will defend it for my sake and for the sake of David my servant."
,"7":"And this shall be for you a sign from Yahweh, that he will do what he has promised."
,"8":"See! I shall make the shadow descending on the stairway of Ahaz go back ten steps.' So the sunlight went back the ten steps it had covered on the stairway."
,"9":"Canticle of Hezekiah king of Judah,after his illness and recovery:"
,"10":"Once I said: In the noontime of my life I go; I am sent to the land of the dead, for the rest of my years."
,"11":"I said: Never again shall I see Yahweh,in the land of the living; never again shall I see the inhabitants of the earth."
,"12":"Like a shepherd's tent, my dwelling,has been pulled down and thrown away; like a weaver, you rolled up my life,and cut it from the loom: from day to night you made me waste away."
,"13":"I have cried for help until morning. Like a lion, he has broken all my bones."
,"14":"I have uttered shrill cries,like a swallow or a crane, I have moaned like a dove. My eyes all the while are growing weary,as I look up to the heavens: Come and help me, O Lord!,For I am troubled."
,"15":"But how can I speak,and what shall I say to him, if he himself is doing this to me?,I will have to walk all my years,bearing this anguish of my soul."
,"16":"O Lord, give me back my health,and give me back my life!"
,"17":"My anguish has turned to peace; you have retrieved my life,from the pit of corruption; you have cast all my sins behind you."
,"18":"For the dead cannot give you thanks, death cannot give you praise; those who go down to the pit,cannot hope for your kindness."
,"19":"The living, the living alone,can give you thanks and praise, as I do; fathers will tell their sons of your fidelity."
,"20":"O Yahweh, come and save me!,We will sing, accompanied by harps, in the Temple of Yahweh,all the days of our life."
,"21":"Isaiah then said, 'Bring a fig cake to rub on the ulcer and let Hezekiah be cured!'"
}`)
	CurrentBook.AddChapter(39, `{
"1":"At that time MerodachBaladan, son of Baladan, king of Babylon, sent letters and a gift to Hezekiah after hearing that he was recovering from an illness."
,"2":"Hezekiah was pleased and showed the envoys all that was in his treasure house, the silver, gold, spices and fine oil, his entire armory and all that was in his treasury. In fact there was nothing in his palace or in his kingdom that Hezekiah did not show them."
,"3":"Isaiah the prophet came to Hezekiah and asked him, 'What did these men say and from where did they come?' Hezekiah answered, 'They came to me from a distant country - from Babylon.'"
,"4":"And Isaiah said, 'What have they seen in your palace?' Hezekiah replied, 'They have seen everything in my palace; there is nothing among my treasures that I did not show them.'"
,"5":"Isaiah then said, 'Hear this word of Yahweh, the God of hosts:"
,"6":"Behold the days are coming when all that is in your palace, and which your fathers have treasured to this day, will be carried off to Babylon. Nothing will be left."
,"7":"And some of your descendants, born of you, will be taken and will become eunuchs in the palace of the king of Babylon.'"
,"8":"Hezekiah then said to Isaiah, 'The word of Yahweh which you have spoken to me is good!' For he thought: there will be peace and truth in my lifetime."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Be comforted, my people, be strengthened, says your God."
,"2":"Speak to the heart of Jerusalem, proclaim to her,that her time of bondage is at an end, that her guilt has been paid for, that from the hand of Yahweh,she has received double punishment,for all her iniquity."
,"3":"A voice cries, 'In the wilderness prepare the way for Yahweh. Make straight in the desert a highway for our God."
,"4":"Every valley will be raised up; every mountain and hill will be laid low. The stumbling blocks shall become level,and the rugged places smooth."
,"5":"The glory of Yahweh will be revealed, and all mortals together will see it; for the mouth of Yahweh has spoken.'"
,"6":"A voice says, 'Cry.',and I say, 'What shall I cry?','All flesh is grass, and all its beauty as the flower of the field."
,"7":"The grass withers, the flower wilts, when the breath of Yahweh blows upon it."
,"8":"The grass withers, the flower fades, but the word of our God will forever stand.'"
,"9":"Go up onto the high mountain, messenger of Zion, lift up your voice with strength, fear not to cry aloud when you tell Jerusalem,and announce to the cities of Judah: Here is your God!"
,"10":"Here comes your God with might; his strong arm rules for him; his reward is with him, and here before him is his booty."
,"11":"Like a shepherd he tends his flock: he gathers the lambs in his arms, he carries them in his bosom, gently leading those that are with young."
,"12":"Who has measured the waters of the sea in a cupped hand, or the breadth of the sky in the span of a hand?,Who has collected the sands of the earth?,Who has weighed the mountains in scales,and the hills in a balance?"
,"13":"Who has probed the spirit of Yahweh,or as a counselor advised him?"
,"14":"Whom has he consulted to enlighten him, and help him to decide?,Who gave him knowledge,and taught him the ways of success?"
,"15":"The nations before him are like a drop on the brim of the bucket, or like dust on the scales. The islands weigh no more than powder."
,"16":"Lebanon is not enough to burn as altar fire, nor will its animals provide a holocaust."
,"17":"All nations before him are as nothing, all emptiness, all vanity in his eyes."
,"18":"To whom, then, will you liken God?,With whose image will you compare him?"
,"19":"To an idol cast by a craftsman, covered with gold by a goldsmith,and adorned with silver chains?"
,"20":"Or to wood that will not rot, chosen and fashioned by a skilled craftsman into an image that cannot move?"
,"21":"Have you not known?,Have you not heard?,Has it not been told you from the beginning, that you may understand how the earth was founded?"
,"22":"He sits far above the vault of the earth, with its inhabitants like grasshoppers; he stretches out the heavens as a curtain,and spreads them out like a tent where he dwells."
,"23":"He reduces the princes to naught, and the rulers of the earth to nothingness."
,"24":"No sooner are they planted or sown, no sooner do they take root in the ground, than he blows on them, and they wither, a storm sweeps them away like stubble."
,"25":"To whom, then, will you liken me,or make me equal? says the Holy One."
,"26":"Lift up your eyes and see: who has created all this?,He has ordered them as a starry host,and called them each by name. So mighty is his power, so great his strength, that not one of them is missing."
,"27":"How can you say, O Jacob, how can you complain, O Israel, that your destiny is hidden from me, that your rights are ignored by Yahweh?"
,"28":"Have you not known, have you not heard,that Yahweh is an everlasting God, the Creator of the ends of the earth?,He does not grow tired or weary, his knowledge is without limit."
,"29":"He gives strength to the enfeebled, he gives vigor to the wearied."
,"30":"Youth may grow tired and faint, young men will stumble and fall,"
,"31":"but those who hope in Yahweh,will renew their strength. They will soar as with eagle's wings; they will run and not grow weary; they will walk and never tire."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Keep silent before me, O islands, or be prepared to contend with me; O nations, draw near and speak. Let us meet together for judgment."
,"2":"Who has called from the east,one that victory hails at every step?,Who has given him the nations to rule,and their kings to subdue?,His sword makes dust of them,and his arrows scatter them like chaff."
,"3":"Unharmed he pursues them through paths,that his feet have scarcely touched."
,"4":"Who really has done all this?,I, who call the generations from the beginning, I, Yahweh, who am the first,and will be with the last."
,"5":"The islands have seen it and feared, the ends of the earth were scared."
,"6":"(Each helps the other and says to his companion, 'Take heart!'"
,"7":"So the craftsman encourages the goldsmith, and he who beats out with the hammer assures the other who strikes the anvil, saying, 'It is ready for soldering'; and he fastens the idol with nails to hold it in place.)"
,"8":"But you, Israel, my servant, Jacob, whom I have chosen, seed of Abraham my friend,"
,"9":"I have taken you from the ends of the earth. I have called you from the remotest corners, and I said, 'You are my servant, I have chosen you and will not cast you away.'"
,"10":"Fear not, for I am with you; be not dismayed, for I am your God. I will give you strength, I will bring you help, I will uphold you with the right hand of my justice."
,"11":"All who rage against you will be put to shame and disgrace; all who fight against you will perish and come to nothing."
,"12":"You will seek, but will not find them; those enemies of yours, those who took up arms against you will be destroyed, brought to nothing."
,"13":"For I, Yahweh, your God, take hold of your right hand and say to you: 'Fear not, I am your assistance.'"
,"14":"Fear not, Jacob, poor worm, and you, people of Israel, so frail. I am your redeemer, says Yahweh, the Holy One of Israel, your helper."
,"15":"I will make you a thresher, new and with sharp double teeth: you will thresh hills and mountains, crushing them and reducing them to chaff."
,"16":"You will winnow them, the wind will carry them off and the storm will scatter them. But you will rejoice in Yahweh and glory in the Holy One of Israel."
,"17":"The poor and the afflicted seek water, and find none. Their tongues are parched with thirst. But I, Yahweh, will hear them; I, the God of Israel, will not forsake them."
,"18":"I will open up streams over the barren heights,and let the rivers flow through all the valleys; I will turn the desert into lakes and brooks,and the thirsty earth,into a land of springs."
,"19":"I will plant in the wilderness the cedar, the acacia, the myrtle and the olive; I will plant in the wasteland fir, cypress and pine -"
,"20":"that all may see and know, consider and understand, that the hand of Yahweh has done this, that the Holy One of Israel has created it."
,"21":"Present your case, says Yahweh. Produce your evidence, says the King of Jacob."
,"22":"Bring your idols and let them tell us what is going to happen. What have they foretold, so that we may consider them and reflect on the final outcome?"
,"23":"Let them foretell what is to come, that we may know that they are gods. Let them do good or do evil, that we may be dismayed and terrified."
,"24":"See, they are nothing, their work is nothing, and to choose them is foolishness."
,"25":"From the north I have called him, and he comes; from the east I have called him by his name. He tramples kings and princes down,as if they were mortar, as if he were a potter working the clay."
,"26":"Has anyone announced this from the beginning, so we might know, or foretold it long ago, so we might say, 'It is true'?,No one among you foretold it, no one proclaimed it. No one heard a word from you."
,"27":"I was the first to announce to Zion: 'Look, here they come!',and I sent a messenger to Jerusalem."
,"28":"But when I looked, there was no one, there was not a single counselor among them who, if asked, could give an answer."
,"29":"All of them are nothing, emptiness are their works; their images are wind and nothingness."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Here is my servant whom I uphold, my chosen one in whom I delight. I have put my spirit upon him, and he will bring justice to the nations."
,"2":"He does not shout or raise his voice,proclamations are not heard in the streets."
,"3":"A broken reed he will not crush, nor will he snuff out the light,of the wavering wick. He will make justice appear in truth."
,"4":"He will not waver or be broken,until he has established justice on earth; the islands are waiting for his law."
,"5":"Thus says God, Yahweh, who created the heavens and stretched them out, who spread the earth and all that comes from it, who gives life and breath to those who walk on it:"
,"6":"I, Yahweh, have called you for the sake of justice; I will hold your hand to make you firm; I will make you as a covenant to the people, and as a light to the nations,"
,"7":"to open eyes that do not see, to free captives from prison, to bring out to light those who sit in darkness."
,"8":"I am Yahweh, that is my name, I will not give my glory to another; or my praise to graven images."
,"9":"See, the former things have come to pass, and new things do I declare: before they spring forth I tell you of them."
,"10":"Sing a new song to Yahweh; let his praise reach the ends of the earth. Let the sea and all that it holds, let the coastlands and their inhabitants,resound with song and praise of him."
,"11":"Let the wilderness and the cities,lift up their voice, together with the villages of Kedar. Let the inhabitants of Sela sing, and shout from the top of the mountain."
,"12":"Let them give glory to Yahweh,and praise him in the far islands."
,"13":"Yahweh comes like a mighty warrior, he stirs up his fury before the fight. He threatens, he raises the battlecry, and he triumphs over his enemies."
,"14":"For a long time I have been silent; I have kept still and restrained myself, I moaned like a woman in labor, breathing and panting:"
,"15":"I will lay waste mountains and hills,and wither all their vegetation; I will turn rivers into wasteland,and dry up the pools."
,"16":"I will lead the blind by ways,which they do not know; along unseen paths I will guide them. I will turn darkness into light before them,and make the rough ground smooth. These are the things that I will do, and I will not forsake them."
,"17":"But those who trust in graven images and say to idols, 'You are our gods' will be turned back in shame."
,"18":"Listen, O deaf, look, O blind, that you may see!"
,"19":"Who is blind, but my servant, or deaf as the messenger I send?,Who is blind but the one I am lifting up? Who is deaf but the servant of Yahweh?"
,"20":"You have seen many things without observing; your ears were open but without hearing."
,"21":"It pleased Yahweh, the Just One, that his Law receive glory and fame."
,"22":"But this is a people robbed and plundered, all of them ensnared in pits or languishing in prison. They have become a prey, with no one to rescue them; they have become a spoil, with no one to order, 'Send them back!'"
,"23":"Who among you will give ear to this?,Who will listen and hear for the time to come?"
,"24":"Who handed Jacob to the spoilers,and Israel to the plunderers?,Was it not Yahweh, against whom we have sinned, in whose ways they would not walk, and whose law they would not obey?"
,"25":"Therefore he poured out on them,the fury of his anger -,the violence of war. It blazed round about them, and they failed to know what it meant; it burned and consumed them, and they remained in bewilderment."
}`)
	CurrentBook.AddChapter(43, `{
"1":"But now, thus says Yahweh, who created you, Jacob, who formed you, Israel: Fear not, for I have redeemed you; I have called you by your name; you are mine."
,"2":"When you pass through the waters, I will be with you. When you pass through the rivers, they will not sweep over you. When you walk through fire, you will not be burned; neither will the flames consume you."
,"3":"For I am your savior, I, Yahweh, your God, the Holy One of Israel. I give Egypt for your ransom, Ethiopia and Seba in exchange for you."
,"4":"Since you are precious in my sight, and important - for I have loved you, I give men in exchange for you,and people in return for your life."
,"5":"Fear not, for I am with you: I will bring your children from the east,and gather you from the west."
,"6":"I will say to the north, 'Give them up!',and to the south, 'Do not hold them!',Bring back my sons from afar, my daughters from the ends of the earth,"
,"7":"all those called by my name,all I have created for my glory."
,"8":"Lead out my people -,who have eyes but are blind, who have ears but are deaf."
,"9":"Let the nations gather together, let the people assemble. Who among them can foretell this,or declare to us the things to come?,Let them bring their witnesses to prove them right; let others hear so that they may say, 'It is true.'"
,"10":"You are my witnesses, says Yahweh, you are my servant whom I have chosen, that you may know and believe me,and understand that I am He. Before me no God was formed, neither will there be one after me."
,"11":"I, I am Yahweh, there is no savior but me."
,"12":"It is I who have foretold; I have spoken and made it known, I, not any of your foreign gods. Therefore you are my witnesses,- it is Yahweh who speaks, I am God."
,"13":"From ever I am God,there is no one who can deliver from my hand. I act, and what I do no one undoes."
,"14":"Thus says Yahweh, your redeemer, the Holy One of Israel: For your sake I send an army to Babylon,to bring down all their bars. The Chaldeans' shout of joy,will turn into lamentation."
,"15":"I am Yahweh, your Holy One, the Creator of Israel, your King."
,"16":"Thus says Yahweh, who opened a way through the sea,and a path in the mighty waters,"
,"17":"who brought down chariots and horses, a whole army of them, and there they lay, never to rise again, snuffed out like a wick."
,"18":"But do not dwell on the past, or remember the things of old."
,"19":"Look, I am doing a new thing: now it springs forth. Do you not see?,I am opening up a way in the wilderness,and rivers in the desert."
,"20":"The beasts of the land will honor me, jackals and ostriches, because I give water in the wilderness,and rivers in the desert,that my chosen people may drink."
,"21":"I have formed this people for myself; they will proclaim my praise."
,"22":"You have not called upon me, O Jacob, indeed you were tired of me, O Israel;"
,"23":"neither have you brought me sheep for burnt offerings, nor honored me with your sacrifices. I have not burdened you with offerings, nor wearied you asking for incense."
,"24":"You have not spent money on sweet frankincense for me, neither have you satisfied me with the fat of your sacrifices. Instead you have burdened me with your sins,and wearied me with your offenses."
,"25":"I it is, I am He,who blots out your offenses for my own sake, and remembers your sins no more."
,"26":"Remind me about the past; let us argue together. Speak up and prove your innocence."
,"27":"Your first father sinned, and your mediators have rebelled against me."
,"28":"Therefore I have disgraced the dignitaries of your temple, I have consigned Jacob to destruction, Israel to scorn."
}`)
	CurrentBook.AddChapter(44, `{
"1":"But now listen, Jacob my servant, Israel whom I have chosen."
,"2":"This is what Yahweh says -,he who made you and will help you, he who formed you from the womb: Fear not, O Jacob my servant, Jeshurun, whom I have chosen."
,"3":"For I will pour water upon the thirsty land,and streams on the dry ground. I will pour my spirit upon your race,and my blessing upon your offspring."
,"4":"They will spring up like grass, like poplars beside the flowing streams."
,"5":"One will say, 'I belong to Yahweh'; another will call himself by Jacob's name. On his hand another will write 'Yahweh',and take the name of Israel."
,"6":"This is what the Lord says -,Israel's King and Redeemer, Yahweh Sabaoth: I am the first and the last, there is no other God besides me."
,"7":"Who then is like me?,Let him stand up and speak, let him argue this out with me. Who from the beginning has foretold the future, and revealed to us what was to come?"
,"8":"Do not be afraid or troubled. Have I not proclaimed,and foretold this long ago?,You are my witnesses; is there a God besides me,or another Rock? I know of none."
,"9":"Good-for-nothing are all idol makers, and useless are the works they prize so much. Their witnesses, blind and ignorant, will be put to shame."
,"10":"Who ever fashioned a god or cast an idol without hope of gain? See how its devotees will be ridiculed, for its craftsmen are but men."
,"11":"Let them all assemble, let them come to court; they will be both terrified and scorned."
,"12":"The blacksmith works on an iron image over the fire and beats it into shape with a hammer. He gets hungry and tired; if there is no water to drink, he gets exhausted."
,"13":"In like manner, the wood carver takes the measurement and marks the outline of an idol, carves it with chisels, giving it a bodily form and a human face that it may live in a shrine."
,"14":"He cut down cedars or perhaps took an oak or cypress from the forest or maybe he planted a cedar which the rain caused to grow."
,"15":"For the common people, that means fuel which they use to warm themselves and to cook their food. But the craftsman carves out of the tree trunk an idol which he worships and before which he bows down."
,"16":"The remaining portion he burns to warm himself; over its live embers he roasts meat and is satisfied. He says, 'Well and good, I feel warm and enjoy the light.'"
,"17":"The other portion which he has made into an idol he worships and bows before it, praying 'Rescue me, for you are my god.'"
,"18":"They have no knowledge, no discernment. For they have shut their mind to un-derstanding, their heart to all reason."
,"19":"Not one of them has the intelligence to reflect and the sense to say, 'Half of the log I burned, and on its embers I baked bread and roasted meat. Shall I then make a dirty idol of what remains? Am I to worship a block of wood?'"
,"20":"Only one of deluded mind can hold on to ashes. Will he not save himself at least and confess, 'What I hold is only a lie?'"
,"21":"Remember this, Jacob, for you are my servant, O Israel, I have formed you to be my servant; Israel, do not forget me."
,"22":"I have blotted out your offenses as a thick cloud, your sins as a mist. Return to me for I am redeeming you."
,"23":"Sing gladly, O heavens, for Yahweh has done this. Shout aloud, O earth below!,Burst into song, you mountains, you forests with all your trees!,For Yahweh has redeemed Jacob,and shown his glory to Israel."
,"24":"Thus says Yahweh, your redeemer, who formed you from the womb: I am Yahweh who made all things, I alone stretched out the heavens, and spread out the earth. Who helped me?"
,"25":"I am he who thwarts the omens of false prophets, who makes fools of diviners, who turns wise men back,and makes nonsense of their knowledge."
,"26":"I confirm the word of my servant,and carry out the plan announced by my messengers. I am he who says of Jerusalem, 'It shall be inhabited,',and of the towns of Judah, 'They shall be rebuilt; I will restore their ruins.'"
,"27":"I am he who says to the ocean, 'Be dry, I will dry up your wellsprings!'"
,"28":"I call on Cyrus, 'My shepherd!',and he goes to fulfill my will. I say to Jerusalem, 'Be rebuilt!',and see: the cornerstone is laid."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Thus says Yahweh to his anointed, to Cyrus: 'I have taken you by the right hand,to subdue nations before you,and strip kings of their armor, to open the gateways before you,so that they will be closed no more."
,"2":"I will go before you to level the slopes, I will break the gates of brass,and destroy the iron bars;"
,"3":"I will give you treasures hidden in darkness,and riches stored in secret places, so that you may know that I am Yahweh, the God of Israel who calls you by your name."
,"4":"For the sake of Jacob my servant, of Israel my chosen one, I have called you by your name,and given you your mission,although you do not know me."
,"5":"I am Yahweh, and there is no other; there is no God besides me. I armed you when you did not know me,"
,"6":"so that, from the rising,to the setting of the sun, all may know,that there is no one besides me; I am Yahweh, and there is no other."
,"7":"I form the light and create the dark; I usher in prosperity and bring calamity. I, Yahweh, do all this."
,"8":"Let the heavens send righteousness like dew,and the clouds rain it down. Let the earth open and salvation blossom, so that justice also may sprout; I, Yahweh, have created it."
,"9":"Woe to him who argues with his Maker being but a pot among pots. Will the clay say to him who fashions it, 'What are you making? You have no skill.'"
,"10":"Woe to him who asks a father, 'What have you begotten!' or a mother, 'To what have you given birth?'"
,"11":"Thus says Yahweh, the Holy One, he who fashions Israel: Is it for you to question me about my children, or decide the work of my hands for me?"
,"12":"I am He who made the earth and created man upon it. I am He who stretched out the heavens with my own hands and gave order to their whole array."
,"13":"I have raised Cyrus for the sake of justice. I will direct his ways and make him rebuild my city. He will send my exiles home without ransom or indemnity. It is Yahweh Sabaoth who speaks."
,"14":"Thus says Yahweh: The peasants of Egypt, the traders of Ethiopia and the tall men of Seba will pass near you in chains, and bow down facing you. In worship they will say, 'Surely God is with you. There is no one else, there is no other god.'"
,"15":"Truly you are the God who remains hidden, the God of Israel, the Savior."
,"16":"All idol makers will be put to shame, they will go away humiliated."
,"17":"But Israel will be saved by Yahweh - delivered with an everlasting salvation. You will never be put to disgrace for everlasting ages."
,"18":"Yes, this is what Yahweh says, he who created the heavens, - for he is God, who formed and shaped the earth, - for he himself set it: 'I did not let confusion in it, I wanted people to live there instead',- for I am Yahweh and there is no other."
,"19":"I have not spoken in secret, from a dark place of the earth; I have not said to the race of Jacob: 'Seek me, but all will be confused', - for I Yahweh tell the truth and I speak openly -,Every knee will bend"
,"20":"Come, gather together, and try to understand, survivors from among the nations: They are but fools they who follow idols of wood,and pray to gods that cannot move -"
,"21":"Let them present their arguments,take counsel together and tell me: Who announced this from the beginning, who foretold it in the distant past?,Is it not me Yahweh?,There is no other God besides me, a Savior, a God of justice, there is no other one but me."
,"22":"Turn to me and be saved, all you from the ends of the earth, for I am God and there is no other."
,"23":"By my own self I swear it, and what comes from my mouth is truth, a word I say will not be revoked. Before me every knee will bend, by me every tongue will swear, "
,"24":"saying, 'In Yahweh alone are righteousness and strength.',All who have raged against him will come to him in shame."
,"25":"But through Yahweh there will be victory and glory,to the people of Israel."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Bel bows down, Nebo collapses, the carriages are weighed down with their idols. Their sacred objects have become a burden for the weary feasts."
,"2":"They cringe and crouch together, powerless to save those who carry them, as they themselves are taken captive."
,"3":"Hear me, O people of Jacob, and all who remain of Israel, whom I have cared for since you were conceived, and carried since you were born."
,"4":"Even to your old age, I am he,and I will sustain you,even when your hair turns gray. It is I who have done this, and who bear the burdens, I will sustain and save you."
,"5":"To whom will you compare me or consider me equal?,Against whom will you match me, as though we were alike?"
,"6":"Some pour out gold from their purses, and with silver weighed on the scales,they hire a goldsmith to make an image,before which they bow and worship."
,"7":"They carry it upon their shoulders,and set it up in its place; and there it stands, unmoving and silent. They cry out to it, but it does not answer, it delivers no one from distress and disaster."
,"8":"Bear it well in mind, you rebels,"
,"9":"recall those things of long ago. I am God, and there is no other; I am God, and there is none like me."
,"10":"From the beginning I foretold the outcome, from ancient times, what was yet to come. I say, and my plan will be fulfilled; and what I wish, I will accomplish."
,"11":"From the east I call forth a bird of prey, from a distant land, a man to carry out my plan. Yes, I have spoken, it will be done; I have planned, it will be executed."
,"12":"Listen to me, you without hope, you who are deprived of any right."
,"13":"I am bringing my justice, it is not far away; my salvation will not delay. I will make salvation appear in Zion, upon Israel I will bestow my glory."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Come down and sit in the dust, O virgin daughter of Babylon!,No more throne! Sit on the ground, O daughter of the Chaldeans. No longer will you be called,dainty and delicate."
,"2":"Take the millstone and grind meal; uncover your hair, bare your legs; strip to the thighs and pass over the rivers."
,"3":"Your nakedness will be exposed, your shame will be uncovered. I will take revenge on you,and no one will save you,"
,"4":"says our Redeemer, Yahweh Sabaoth. His name is the Holy One of Israel."
,"5":"Go creep into the shadows and sit in,silence, O daughter of the Chaldeans, for no more will you be called,sovereign lady of the kingdoms."
,"6":"Angry with my people, I had left my,inheritance; I gave them into your hands, but you showed them no mercy. You laid a heavy yoke on the aged."
,"7":"You said, 'I will reign forever'; but you did not take this to heart,or ponder on what would ensue."
,"8":"Listen, therefore, you wanton woman, lounging in security and deluding yourself, 'I am, and there is none besides me. I will never be a widow or suffer the loss of children.'"
,"9":"But these two things will come to you,in a moment, on a single day -,loss of children and widowhood. They will come upon you in full measure, in spite of all your witchcraft, in spite of the power of your spells."
,"10":"You have trusted in your wickedness, saying, 'Nobody sees me.',Your intelligence and knowledge,have perverted you, for you have said: 'I am, and there is none besides me.'"
,"11":"Evil, suddenly, will come your way,though you do not know it. Disaster will fall upon you, and no ransom will ward it off; a catastrophe you cannot foresee,will come upon you suddenly."
,"12":"Keep on, then, with your magic spells and with the multitude of your sorceries, which you have labored at since your youth. Do you think they will help you now? Do you think they will cause terror around you?"
,"13":"Yet you are wearied with so many advisers. Let your astrologers stand up, your stargazers who foretell what will happen each month; let them save you from what is to come upon you."
,"14":"Look, they will be like stubble,and the fire will burn them. They cannot even save themselves,from the power of consuming flames. These are no embers to warm anyone, no fireside to sit by."
,"15":"This is your lot and of your wizards,with whom you have labored from your youth. Now each will go his own way - powerless to save you."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Listen to this, House of Jacob, called by the name of Israel,and born out of Judah's womb, you who swear by the name of Yahweh,and invoke the God of Israel, though not in truth or righteousness -"
,"2":"calling yourselves after the holy city, and relying on the God of Israel,whose name is Yahweh Sabaoth."
,"3":"From long ago I revealed things past: they went forth from my mouth; I declared them. Then suddenly I acted,and the word came to be."
,"4":"Because I know that you are stubborn, your head as hard as iron, your forehead as bronze,"
,"5":"So I told you about them; before they took place,I let you hear of them, lest you should say: 'My idols did these, my graven image, my molten image commanded them.'"
,"6":"Now that you have heard and seen, will you not admit it?,From now on I will tell you new things, even hidden things you have not known before."
,"7":"They are created now and not long ago; up to this day you have not heard of them,lest you should say, 'I already knew.'"
,"8":"You have not heard, you didn't know,nor were your ears opened before, for I knew how treacherous you were -,you who from birth have been called a rebel."
,"9":"For my name's sake I delayed my anger, for my honor's sake I restrained it, lest I destroy you."
,"10":"See: I have refined you as silver; I have tested you in the furnace of affliction."
,"11":"But now for my own sake I will act, yes, for my own sake. For how could I let my Name be defiled?,Never will I yield my glory to another."
,"12":"Listen to me, O Jacob, Israel whom I have called, I am the same, I am the first, and I am also the last."
,"13":"My hand laid the foundation of the earth, my right hand spread out the heavens. When I call on the stars,they all stand forth together."
,"14":"Assemble, all of you, and listen. Who among them has foretold these things?,The beloved of Yahweh will do what pleases him,with Babylon and the people of Chaldea."
,"15":"I, yes I myself, have spoken; I myself called him and made him prosper in his way."
,"16":"Come near me and listen to this: From the beginning I have not spoken in secret; from the time that it happened I have been there. Know then, that Yahweh the Lord, with his Spirit has sent me!"
,"17":"Thus says Yahweh, your Re-deemer, the Holy One of Israel: I, Yahweh, your God, teach you what is best for you; I lead you in the way that you must go."
,"18":"Had you paid attention to my commandments, your peace would have been like a river, your righteousness like the waves of the sea."
,"19":"Your descendants would have been like the sand, and those born of your stock like its grains, their names never cut off nor blotted out from my presence."
,"20":"'Go forth from Babylon, flee from Chaldea!' Declare this with shouts of joy, make this known to the ends of the earth. Proclaim: Yahweh has redeemed his servant Jacob!"
,"21":"Those he led through the desert were never thirsty. He made water flow for them from the rock; he split the rock and water gushed out."
,"22":"There is no peace for the wicked, Yahweh says."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Listen to me, O islands, pay attention, peoples from distant lands. Yahweh called me from my mother's womb; he pronounced my name before I was born."
,"2":"He made my mouth like a sharpened sword. He hid me in the shadow of his hand. He made me into a polished arrow,set apart in his quiver."
,"3":"He said to me, 'You are Israel, my servant, Through you I will be known.'"
,"4":"'I have labored in vain,' I thought,and spent my strength for nothing.',Yet what is due me was in the hand of Yahweh, and my reward was with my God. I am important in the sight of Yahweh, and my God is my strength."
,"5":"And now Yahweh has spoken, he who formed me in the womb to be his servant, to bring Jacob back to him, to gather Israel to him."
,"6":"He said: ' 'Tis not enough,that you be my servant, to restore the tribes of Jacob, to bring back the remnant of Israel. I will make you the light of the nations, that my salvation will reach to the ends of the earth.'"
,"7":"Thus says Yahweh, the Redeemer and Holy One of Israel, to him whom people despise, to him whom nations abhor, to the servant of tyrants: 'Kings will see you and stand up, and princes will bow down,for the sake of Yahweh, the faithful one, the Holy One of Israel who has chosen you.'"
,"8":"This is what Yahweh says: 'At a favorable time I have answered you, on the day of salvation I have been your help; I have formed you and made you to be my covenant with the people. You will restore the land, and allot its abandoned farms. "
,"9":"You will say to the captives: Come out; and to those in darkness: Show yourselves. They will feed along the road; they will find pasture on barren hills. "
,"10":"They will neither hunger nor thirst, nor will the scorching wind or the sun beat upon them; for he who has mercy on them will guide them and lead them to springs of water."
,"11":"I will turn all my mountains into roads and raise up my highways."
,"12":"See, they come from afar, some from the north and west, others from the land of Sinim."
,"13":"Sing, O heavens, and rejoice, O earth; break forth into song, O mountains: for Yahweh has comforted his people,and taken pity on those who are afflicted."
,"14":"But Zion said: 'Yahweh has forsaken me, my Lord has forgotten me.'"
,"15":"Can a woman forget the baby at her breast,and have no compassion on the child of her womb?,Yet though she forget, I will never forget you."
,"16":"See, I have written your name upon the palm of my hands; your walls are ever before me."
,"17":"Your sons hurry back, and those who laid you waste hasten to depart from you."
,"18":"Lift up your eyes, look around and see: your sons are all assembling and coming to you. As I live, says Yahweh, you will wear them all as your jewels; they will adorn you as brides are adorned."
,"19":"Your lonely places and your ruins, your wastelands and devastated country, will now be too small for your people, while those who destroy you will be driven off."
,"20":"The children you will have, after those you lost, will also say in your hearing, 'This place is too small for us. Give us more space to live in.'"
,"21":"You will then say in your heart, 'Who has borne me these? I was bereaved and barren, and who has brought these up? I was left alone; but these - where have they come from?'"
,"22":"Thus speaks the Lord Yahweh: See, I am to make signs to the nations; and to raise my banner to the peoples, that they will bring your sons in their arms, your daughters upon their shoulders."
,"23":"Kings will be your foster fathers, their queens your nursing mothers. They will bow down before you with their faces to the ground; they will lick the dust of your feet. Then you will know that I am Yahweh and that those who hope in me will not be put to shame."
,"24":"Can booty be taken from a warrior, or captives be rescued from a tyrant? But thus says Yahweh:"
,"25":"Yes, captives will be taken from warriors and booty rescued from a tyrant: for I will fight whoever fight you and I will save your children."
,"26":"I will make your oppressors eat their own flesh and be drunk with their own blood, as with wine. All mankind will know that I, Yahweh, am your savior, your redeemer, the Mighty One of Jacob."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Thus says Yahweh: Where is the writ of divorce with which I dismissed your mother? Or to which of my creditors have I sold you? It was for your sins that you were sold, for your crimes that your mother was dismissed."
,"2":"Why was there no one when I came?,Why did no one answer when I called?,Is my hand too short to reach out and save?,Have I not the power to deliver?,See how, at my threat, the sea dries up, the rivers turn into desert, their fish dying, for lack of water."
,"3":"I clothe the heavens in mourning: I make sackcloth their covering."
,"4":"The Lord Yahweh has taught me,so I speak as his disciple,and I know how to sustain the weary. Morning after morning he wakes me up,to hear, to listen like a disciple."
,"5":"The Lord Yahweh has opened my ear. I have not rebelled, nor have I withdrawn."
,"6":"I offered my back to those who strike me, my cheeks to those who pulled my beard; neither did I shield my face,from blows, spittle and disgrace."
,"7":"I have not despaired, for the Lord Yahweh comes to my help. So, like a flint I set my face, knowing that I will not be disgraced."
,"8":"He who avenges me is near. Who then will accuse me?,Let us confront each other. Who is now my accuser?,Let him approach."
,"9":"If the Lord Yahweh is my help. who will condemn me?,All of them will wear out like cloth; the moth will devour them."
,"10":"Let anyone among you who fears Yahweh listen to the voice of his servant. Whoever walks in darkness and has no light to shine for him, let him trust in the name of Yahweh, let him rely upon his God."
,"11":"Yet all of you who kindle flames and carry about burning torches, go into the flames of your own fire, into the sparks you have kindled. This will befall you from my hand, you will lie down in torment."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Listen to me, you who pursue justice, you who go in search of Yahweh. Look to the rock from which you were hewn, to the pit from which you were quarried."
,"2":"Look to Abraham, your father, and to Sarah, who gave you birth. He was alone when I called him; but I blessed and increased him."
,"3":"Truly Yahweh's compassion is for Zion, his mercy is upon all her ruins. He will make her deserts like Eden, her wastelands like Yahweh's garden. In her will be found joy and rejoicing, melody and song of praise and thanks-giving."
,"4":"Listen to me, you peoples, hear me, O nations. I am to give you my law, my justice will be a light to the nations."
,"5":"Suddenly my justice will appear, my salvation is on the way, and my arm will impose my rule. The islands also wait in hope for me, trusting in my arm."
,"6":"Lift up your eyes to the heavens,and look upon the earth beneath. Like smoke, the heavens will vanish, and the earth wear out like a garment; its inhabitants will fall like flies. But my salvation will last forever, my justice will never fail."
,"7":"Hear me, you who know righteousness, you who have my law in your hearts: do not fear the reproach of men,or be terrified by their mocking."
,"8":"For they will be like garments eaten by moths, like wool consumed by grubs. But my justice will last forever,and my salvation for all generations."
,"9":"Awake, awake, put on strength, O arm of Yahweh!,Awake as in ancient days, in times of generations long ago. Was it not you who split Rahab in two,and pierced the dragon through?"
,"10":"Was it not you who dried up the sea, the waters of the great deep, to make a way on the seabed,for the redeemed to pass over?"
,"11":"The redeemed of Yahweh will return,and come to Zion singing with joy, crowned with everlasting gladness, while sorrow and mourning flee away."
,"12":"I, yes I, am your comforter. How then can you be afraid of man who dies, of the son of man who fades like grass?"
,"13":"Are you forgetting Yahweh who made you, who stretched forth the heavens,and laid the foundations of the earth?,Why live every day in constant fear,of the fury of the oppressor, when he sets out to destroy you?,And where is the fury of the oppressor?"
,"14":"The captive exiles will soon be free; they will not die in a deep prison, nor will they want for food."
,"15":"I am Yahweh, your God, the one who stirs the sea, making its waves roar. My name is Yahweh Sabaoth."
,"16":"I have put my words in your mouth as I stretched out the heavens; When I laid the foundations of the earth, I said to Zion: 'You are my people, and I have shielded you in the shadow of my hand.'"
,"17":"Awake, awake!,Arise, O Jerusalem, you who drank at the hand of Yahweh the cup of his fury, the cup which made you tremble, that you drank to the last drop!"
,"18":"Among all the sons she bore, she has no one to guide her; among all the sons she reared, she has no one to take her by the hand."
,"19":"These double calamities have befallen you - ruin and destruction, famine and sword. Who is there to console you?"
,"20":"Your sons were found helpless at the corner of every street, like wild bulls in a net. They had drunk to the full the fury of Yahweh, the wrath of your God."
,"21":"Therefore hear this now, you afflicted one, you who are drunk but not with wine."
,"22":"Thus says your Lord Yahweh, your God, defender of your people's cause: See, I am taking out of your hand the cup of trembling; the cup of my anger - you will drink of it no more. "
,"23":"But I will put it into the hands of your tormentors, those who ordered you to bow down, that they might trample on you, while you laid your body as a pavement, as a street for them to walk on."
}`)
	CurrentBook.AddChapter(52, `{
"1":"Awake, awake!,Put on your strength, O Zion; put on your glorious garments, O Jerusalem, holy city. For never will the uncircumcised,or the unclean enter you again."
,"2":"Shake the dust off yourself,and rise up, O Jerusalem. Loose the bonds from your neck, O captive Daughter of Zion."
,"3":"For thus says Yahweh: You were sold for no amount, you will be redeemed without money."
,"4":"Thus says the Lord God: In the beginning,my people lived as aliens in Egypt; then Assyria oppressed them without reason."
,"5":"But now, what am I doing here? says Yahweh. My people have been carried off for no money and their masters make a boast of it; all day long my name is scorned."
,"6":"Therefore my people will know my name; therefore they will know on that day,that it is I who say: 'Here I am!'"
,"7":"How beautiful on the mountains are the feet of those,who bring good news, who herald peace and happiness, who proclaim salvation,and announce to Zion: 'Your God is king!'"
,"8":"Together your watchmen,raise their voices in praise and song; they see Yahweh face to face returning to Zion."
,"9":"Break into shouts of joy, O ruins of Jerusalem, for Yahweh consoles his people,and redeems Jerusalem."
,"10":"Yahweh has bared his holy arm,in the eyes of the nations; all the ends of the earth, in alarm, will witness God's salvation."
,"11":"Depart, depart from that nation, come out!,Touch nothing unclean. Purify yourselves, you who bear,all Yahweh's holy vessels."
,"12":"Yet not in escape, or in fright, will you come out, you will not leave in headlong flight; for ahead is Yahweh, your vanguard, and behind, the God of Israel, your rearguard."
,"13":"It is now when my servant will succeed; he will be exalted and highly praised."
,"14":"Just as many have been horrified,at his disfigured appearance: 'Is this a man? He does not look like one,'"
,"15":"so will nations be astounded, kings will stand speechless, for they will see something never told, they will witness something never heard of."
}`)
	CurrentBook.AddChapter(53, `{
"1":"Who could believe what we have heard, and to whom has Yahweh revealed his feat?"
,"2":"Like a root out of dry ground, like a sapling he grew up before us, with nothing attractive in his appearance, no beauty, no majesty."
,"3":"He was despised and rejected, a man of sorrows familiar with grief, a man from whom people hide their face, spurned and considered of no account."
,"4":"Yet ours were the sorrows he bore, ours were the sufferings he endured, although we considered him as one,punished by God, stricken and brought low."
,"5":"Destroyed because of our sins, he was crushed for our wickedness. Through his punishment we are made whole; by his wounds we are healed."
,"6":"Like sheep we had all gone astray, each following his own way; but Yahweh laid upon him all our guilt."
,"7":"He was harshly treated, but unresisting and silent, he humbly submitted. Like a lamb led to the slaughter,or a sheep before the shearer,he did not open his mouth."
,"8":"He was taken away to detention and judgment -,what an unthinkable fate!,He was cut off from the land of the living, stricken for his people's sin."
,"9":"They made his tomb with the wicked, they put him in the graveyard of the oppressors, though he had done no violence nor spoken in deceit."
,"10":"Yet it was the will of Yahweh to crush him with grief. When he makes himself an offering for sin, he will have a long life and see his descendants. Through him the will of Yahweh is done."
,"11":"For the anguish he suffered, he will see the light and obtain perfect knowledge. My just servant will justify the multitude; he will bear and take away their guilt."
,"12":"Therefore I will give him his portion among the great, and he will divide the spoils with the strong. For he surrendered himself to death,and was even counted among the wicked, bearing the sins of the multitude,and interceding for sinners."
}`)
	CurrentBook.AddChapter(54, `{
"1":"Rejoice, O barren woman who has not given birth; sing and shout for joy, you who never had children, for more are the children of the rejected woman than the children of the married wife, says Yahweh."
,"2":"Enlarge the space for your tent, stretch out your hangings, lengthen your ropes and strengthen your stakes,"
,"3":"for you will spread out to the right and to the left; your descendants will take possession of the nations and inhabit cities that have been abandoned."
,"4":"Do not be afraid for you will not be deceived, do not be ashamed for you will not be disgraced. You will forget the shame of your youth; no longer will you remember the disgrace of your widowhood."
,"5":"For your Maker is to marry you: Yahweh Sabaoth is his name. Your Redeemer is the Holy One of Israel: He is called God of all the earth."
,"6":"For Yahweh has called you back as one forsaken and grieved in spirit. Who could abandon his first beloved? says your God."
,"7":"For a brief moment I have abandoned you, but with great tenderness I will gather my people."
,"8":"For a moment, in an outburst of anger, I hid my face from you, but with everlasting love I have had mercy on you, says Yahweh, your Redeemer."
,"9":"This is for me like Noah's waters, when I swore that they would no more flood the earth; so now I swear not to be angry with you and never again to rebuke you."
,"10":"The mountains may depart and the hills be moved, but never will my love depart from you nor my covenant of peace be removed, says Yahweh whose compassion is for you."
,"11":"O afflicted city, lashed by storm and unconsoled, I will set your stones with turquoise, your foundations with sapphires."
,"12":"I will crown your wall with agate, make your gates crystal, and your ramparts of precious stones."
,"13":"All your children will be taught by Yahweh, and they will prosper greatly."
,"14":"Justice will be your foundation; tyranny and the fear of oppression will never come near you."
,"15":"If ever you are attacked, it will not be of my doing; and your attacker will surely fail."
,"16":"Look, it is I who created the blacksmith, who fans the burning coals and forges his weapons. But I have also prepared the one who makes them useless."
,"17":"No weapon forged against you will succeed, and all who speak against you will be silenced. Such is the lot of the servants of Yahweh, and such is the right I grant them - says Yahweh."
}`)
	CurrentBook.AddChapter(55, `{
"1":"Come here, all you who are thirsty, come to the water!,All who have no money, come!,Yes, without money and at no cost, buy and drink wine and milk."
,"2":"Why spend money on what is not food and labor for what does not satisfy? Listen to me, and you will eat well; you will enjoy the richest of fare."
,"3":"Incline your ear and come to me; listen, that your soul may live. I will make with you an everlasting covenant, I will fulfill in you my promises to David."
,"4":"See, I have given him for a witness to the nations, a leader and commander of the people."
,"5":"Likewise you will summon a nation unknown to you, and nations that do not know you will come hurrying to you for the sake of Yahweh your God, the Holy One of Israel, for he has promoted you."
,"6":"Seek Yahweh while he may be found; call to him while he is near."
,"7":"Let the wicked abandon his way, let him forsake his thoughts, let him turn to Yahweh for he will have mercy, for our God is generous in forgiving."
,"8":"For my thoughts are not your thoughts, my ways are not your ways, says Yahweh."
,"9":"For as the heavens are above the earth, so are my ways higher than your ways, and my thoughts above your thoughts."
,"10":"As the rain and the snow come down,from the heavens and do not return,till they have watered the earth, making it yield seed for the sower,and food for others to eat,"
,"11":"so is my word that goes forth out of my mouth: it will not return to me idle, but it shall accomplish my will, the purpose for which it has been sent."
,"12":"Yes, in joy you will depart, in peace you will be led forth: mountains and hills will break into song before you, trees of the countryside will clap their hands."
,"13":"Instead of the thornbush, the cypress will thrive; instead of briers, the myrtle. This will make Yahweh famous and remain as an everlasting witness to him."
}`)
	CurrentBook.AddChapter(56, `{
"1":"This is what Yahweh says: Maintain what is right,and do what is just, for my salvation is close at hand, my justice is soon to come."
,"2":"Blessed is the mortal who does these things, and perseveres in them, who does not defile the sabbath and who refrains from evil."
,"3":"Let no foreigner say, 'Surely Yahweh will exclude me from his people.' Neither let the castrated man say, 'I have become a mere dry tree.'"
,"4":"For this is what Yahweh says: To the castrated men who keep my sabbaths, who choose to do what pleases me and remain faithful to my covenant:"
,"5":"I will give them in my house and within its walls, a memorial and a name that are worth more than sons and daughters; I will give them a name that will never die away or be forgotten."
,"6":"Yahweh says to the foreigners who join him, serving him and loving his name, keeping his sabbath unprofaned and remaining faithful to his covenant:"
,"7":"I will bring them to my holy mountain and give them joy in my house of prayer. I will accept on my altar their burnt offerings and sacrifices, for my house will be called a house of prayer for all the nations."
,"8":"Thus says the Lord God, Yahweh, who gathers the exiles of Israel: There are others I will gather besides those already gathered."
,"9":"All you wild beasts, come and devour, all you beasts of the forests!"
,"10":"Blind are Israel's watchmen: they all see nothing. They are dumb watchdogs they are unable to bark. Lying down and dreaming, they love to slumber."
,"11":"Greedy dogs that are never satisfied; shepherds of no discretion, they all turn their own way, everyone of them to his own gain."
,"12":"'Come, bring wine,' they say, 'and let us all get drunk, and tomorrow will be as today, or perhaps even a happier day.'"
}`)
	CurrentBook.AddChapter(57, `{
"1":"Righteous people perish, and no one cares about it. The just one is taken off, and no one understands that he is taken away from the calamity that comes, "
,"2":"he enters into peace."
,"3":"But all you sons of a witch, come here, you offspring of the whore and the adulterer."
,"4":"Who are you mocking?,At whom are you making faces, opening wide your mouth and sticking out your tongue?,You are children of sin, offspring of deceit and falsehood,"
,"5":"burning with lust among the bushes, under spreading branches, sacrificing your children by the streams, in the clefts of rocks."
,"6":"Your heart is with your idols, the smooth stones of the wadis to which you have poured out drink offerings,and brought oblations of grain. Can I tolerate this?"
,"7":"You have made your bed upon a high and lofty mountain. You went up there to offer your sacrifice."
,"8":"You have set up your domestic idols,behind your doorposts and your doors. Deserting me, you have uncovered your bed, climbed into it and spread it wide. You made a bargain with those,whose bed you enjoy, and you had intercourse with them."
,"9":"With perfumed oil, you made yourself,look your best for Molech; you sent envoys far afield -,the children you sent to your pagan god through a sacrificial death."
,"10":"Although wearied with your misdeeds, you have never given up; you have never tired or weakened, but instead found your strength revived."
,"11":"Where had gone your fear of me,that you should lie and disown me, refuse me a place in your heart,and not remember me?,Have I held my peace so long,that you do not fear me any more?"
,"12":"But now I will tell your merits and your deeds, it will not be for your advantage."
,"13":"When you cry out in distress, let your idols save you! The wind will blow them all away; a whiff of a breeze will carry them off. But he who takes refuge in me will take possession of the land, my holy mountain his inheritance."
,"14":"Then it shall be said: 'Prepare, prepare, open up a way, remove all obstructions from my people's way.'"
,"15":"For thus says the Most High, he who is enthroned forever, he whose name is holy: 'I reign exalted and holy,but I am also with him who is contrite and humble in spirit, to give the contrite a heart revived,and the humble in spirit a new life."
,"16":"For I will not contend forever, nor will I always be angry, lest the spirit of man faint before me, the very breath that I have created."
,"17":"His wickedness enraged me for a time, I smote him and hid my face, for he, a rebel, wanted to go his own drive. And I have seen his ways."
,"18":"But from now on I will console, I will heal and fully comfort him, - all those of his people who mourn."
,"19":"I will bring smiles to their lips. Peace!,Peace to him who is far and to him who is near. I will indeed heal you,' Yahweh says."
,"20":"But the wicked are like a turbulent sea,that finds no rest,and whose waters cast up mire and slime."
,"21":"'There is no peace,' says my God, 'for the wicked.'"
}`)
	CurrentBook.AddChapter(58, `{
"1":"Cry out aloud for all you are worth; raise your voice like a trumpet blast; tell my people of their offenses, Jacob's family of their sins."
,"2":"Is it true that they seek me,day after day, longing to know my ways, as a people that does what is right,and has not forsaken the word of its God?,They want to know the just laws,and not to drift away from their God."
,"3":"'Why are we fasting,' they complain, 'and you do not even see it?,We are doing penance and you never notice it.',Look, on your fast days you push your trade,and you oppress your laborers."
,"4":"Yes, you fast but end up quarreling, striking each other with wicked blows. Fasting as you do,will not make your voice heard on high."
,"5":"Is that the kind of fast that pleases me, just a day for a man to humble himself?,Is fasting merely bowing down one's head, and making use of sackcloth and ashes?,Would you call that fasting, a day acceptable to Yahweh?"
,"6":"See the fast that pleases me: breaking the fetters of injustice,and unfastening the thongs of the yoke, setting the oppressed free,and breaking every yoke."
,"7":"Fast by sharing your food with the hungry, bring to your house the homeless, clothe the man you see naked,and do not turn away from your own kin."
,"8":"Then will your light break forth as the dawn,and your healing come in a flash. Your righteousness will be your vanguard, the Glory of Yahweh your rearguard."
,"9":"Then you will call and Yahweh will answer, you will cry and he will say, I am here. If you remove from your midst the yoke, the clenched fist and the wicked word,"
,"10":"if you share your food with the hungry,and give relief to the oppressed, then your light will rise in the dark, your night will be like noon."
,"11":"Yahweh will guide you always,and give you relief in desert places. He will strengthen your bones; he will make you as a watered garden, like a spring of water,whose waters never fail."
,"12":"Your ancient ruins will be rebuilt, the age-old foundations will be raised. You will be called the Breach-mender, and the Restorer of ruined houses."
,"13":"If you stop profaning the sabbath,and doing as you please on the holy day, if you call the sabbath a day of delight,and keep sacred Yahweh's holy day, if you honor it by not going your own way, not doing as you please,and not speaking with malice,"
,"14":"then you will find happiness in Yahweh, over the heights you will ride triumphantly, on the inheritance of your father Jacob you,will feast joyfully. The mouth of Yahweh has spoken."
}`)
	CurrentBook.AddChapter(59, `{
"1":"Yahweh's arm is not too short to save nor his ear too dull to hear."
,"2":"It is your sins, rather, that separate you from God. It is your iniquities that veil his face, so that he does not hear you."
,"3":"For your hands are blood-stained, your fingers blotted with crimes; your lips have spoken lies, your tongues have uttered deceit."
,"4":"No one fights for a right cause; no one makes a truthful plea. They all tell lies and rely on vanity; they conceive mischief and bring forth iniquity."
,"5":"They hatch vipers' eggs,and weave spiders' webs. Whoever eats their eggs dies; and from an egg that is crushed,a venomous snake is hatched."
,"6":"Their thread gives useless cloth; their works are of help to no one. Their plans are evil plots,executed in deeds of violence."
,"7":"Their feet rush to do evil; they are quick to shed innocent blood. Their minds are full of wicked thoughts, leaving in their wake ruin and havoc."
,"8":"They do not know the way of peace; from them no one can expect justice. They have made their roads tricky and crooked,so that he who follows them is lost or waylaid."
,"9":"So, far away from us lies justice, and beyond reach is righteousness. We look for light but behold darkness; we long for brightness but walk in gloom."
,"10":"Like the blind we grope for the wall, like those without eyes we feel our way. We stumble at noon as at twilight; we are dead in the midst of our sins."
,"11":"We are like bears that growl; we are like doves that moan. We look for justice and find none; we wait for salvation that never comes."
,"12":"For our offenses before you are many, and our sins bear witness against us. We acknowledge our offenses; we know all our iniquities."
,"13":"Yes, we have betrayed and deceived Yahweh, turning away from following our God. We have planned violence and rebellion; we have thought and murmured lies."
,"14":"Justice has been withheld, righteousness stands aloof, for truth has fallen in the public square,and integrity is not allowed to enter."
,"15":"There is no sincerity nor honesty. The man who turns from evil is despoiled. Yahweh has seen this and is aggrieved,that justice does not exist."
,"16":"Appalled at seeing none would intervene, his own arm brought about the victory, his justice giving him its support."
,"17":"He put on righteousness as a breastplate, and salvation as a helmet upon his head. He wrapped himself in garments of vengeance,and put on a mantle of fury."
,"18":"To each he will pay his due -,wrath to his enemy, reprisal to his foe."
,"19":"Those in the west will hear the name of Yahweh; those in the east will see his glory. For it will come like a pent-up stream,driven by the breath of Yahweh."
,"20":"But to Zion he will come as redeemer, and to those of Jacob who turn from sin. This is Yahweh speaking."
,"21":"For my part, this is my covenant with them, says Yahweh. My spirit which I have poured out on you, and my words which I have put in your mouth, will never leave you, nor your children, nor your children's children forever and ever."
}`)
	CurrentBook.AddChapter(60, `{
"1":"Arise, shine, for your light has come. The Glory of Yahweh rises upon you."
,"2":"Night still covers the earth,and gloomy clouds veil the peoples, but Yahweh now rises,and over you his glory appears."
,"3":"Nations will come to your light,and kings to the brightness of your dawn."
,"4":"Lift up your eyes round about and see: they are all gathered and come to you, your sons from afar, your daughters tenderly carried."
,"5":"This sight will make your face radiant, your heart throbbing and full; the riches of the sea will be turned to you, the wealth of the nations will come to you."
,"6":"A flood of camels will cover you, caravans from Midian and Ephah. Those from Sheba will come, bringing with them gold and incense, all singing in praise of Yahweh."
,"7":"The flocks of Kedar will be gathered for you, the rams of Nebaioth put at your service: they are acceptable offerings on my altar,and will enhance the glory of my house."
,"8":"Who are these as thick as clouds, flying like doves to their cote?"
,"9":"Ah, they are ships, with those of Tarshish in the front, for the islands now trust in me. They bear your sons from far away,bringing their gold and silver with them, for the name of Yahweh your God, for the Holy One of Israel, for he has glorified you."
,"10":"Foreigners will rebuild your walls, and their kings will attend to you. For though in anger I have struck you, in love I will have mercy on you."
,"11":"Your gates will forever be open,and never be shut by night or day, that you may receive the wealth of the nations, their kings leading them in procession;"
,"12":"for the nations and kingdoms that refuse to serve you will perish; they will be destroyed.)"
,"13":"The glory of Lebanon will come to you, the pine, the fir and the cypress, too, to adorn the place of my sanctuary, to give glory to the resting place of my feet."
,"14":"The sons of those who oppressed you will come bending low; all who despised you will fall before your feet. They will call you the City of Yahweh, Zion of the Holy One of Israel."
,"15":"Though you have been forsaken, hated and avoided, I will make of you an everlasting pride, a joy for all generations."
,"16":"You will suck the milk of nations,and be nursed at royal breasts. You will know that I, Yahweh, am your savior, your redeemer, the Mighty One of Jacob."
,"17":"Instead of bronze I will bring you gold; instead of iron I will bring silver; instead of wood, bronze; instead of stones, iron. Peace will be overseers, justice your taskmasters."
,"18":"Violence will no more be heard in your land, nor ruin and destruction within your borders. You will call your walls Salvation, and your gates Praise."
,"19":"No more will the sun give you light by day, nor the moon shine on you by night. For Yahweh will be your everlasting light,and your God will be your glory."
,"20":"No more will your sun go down, never will your moon wane. For Yahweh will be your everlasting light, and your days of mourning will come to an end."
,"21":"Your people will be upright; forever they will possess the land -,they the shoot of my planting, the work of my hand -,in them I shall be glorified."
,"22":"The least of them will become a clan, the smallest a mighty nation. I, Yahweh, will do this, swiftly, in due time."
}`)
	CurrentBook.AddChapter(61, `{
"1":"The Spirit of the Lord Yahweh is upon me, because Yahweh has anointed me,to bring good news to the poor. He has sent me to bind up broken hearts, to proclaim liberty to the captives, freedom to those languishing in prison;"
,"2":"to announce the year of Yahweh's favor,and the day of vengeance of our God; to give comfort to all who grieve;"
,"3":"(to comfort those who mourn in Zion),and give them a garland instead of ashes, oil of gladness instead of mourning, and festal clothes instead of despair. They will be called oaks of integrity,planted by Yahweh to show his glory."
,"4":"They will rebuild the ancient ruins,and repair cities laid waste, left desolate for many generations."
,"5":"Strangers will stand to feed your flocks, foreigners to be your plowmen and vinedressers."
,"6":"But you will be named priests of Yahweh, you will be called ministers of our God. You will feed on the wealth of nations,and bathe in the splendor of their riches."
,"7":"Since my people's shame has been twofold,and disgrace has been their lot, they will possess a double portion,of inheritance in their land. I will give them everlasting joy."
,"8":"For I, Yahweh, love justice, I hate robbery and oppression; I will give them their due reward,and make an everlasting covenant with them."
,"9":"Their descendants shall be known among the nations,and their offspring among the peoples. All who see them will acknowledge,that they are a race Yahweh has blessed."
,"10":"I rejoice greatly in Yahweh, my soul exults for joy in my God, for he has clothed me in the garments of his salvation, he has covered me with the robe of his righteousness, like a bridegroom wearing a garland, like a bride adorned with jewels."
,"11":"For as the earth brings forth its growth, and as a garden makes seeds spring up, so will the Lord Yahweh make justice and praise,spring up in the sight of all nations."
}`)
	CurrentBook.AddChapter(62, `{
"1":"For Zion's sake I will not hold my peace, for Jerusalem I will not keep silent, until her holiness shines like the dawn,and her salvation flames like a burning torch."
,"2":"The nations will see your holiness,and all the kings your glory. You will be called by a new name,which the mouth of Yahweh will reveal."
,"3":"You will be a crown of glory,in the hand of Yahweh, a royal diadem in the hand of your God."
,"4":"No longer will you be named Forsaken; no longer will your land be called,Abandoned; but you will be called My Delight,and your land Espoused. For Yahweh delights in you,and will make your land his spouse."
,"5":"As a young man marries a virgin, so will your builder marry you; and as a bridegroom rejoices in his bride, so will your God rejoice in you."
,"6":"Upon your walls, O Jerusalem, I have stationed watchmen; all the day and throughout the night they will not be silent. You who call on Yahweh, give yourselves no rest; "
,"7":"and give him no rest either till he restores Jerusalem and makes of it the pride of the earth."
,"8":"Yahweh swears by his right hand and by his mighty arm: Never again will I give your grain as food for your enemies, nor will foreigners drink the wine for which you have labored."
,"9":"But those who toil will eat the harvest, and praise Yahweh; and those working for the vintage shall drink of the wine in the courts of my sanctuary."
,"10":"'Pass through, pass through the gates, prepare the way for the people. Build it up, bank up the highway, clear it of stones; raise up a standard for the peoples.'"
,"11":"For Yahweh proclaims to the ends of the earth: Say to the daughter of Zion, here comes your salvation! Yahweh brings the reward of his victory, his booty is carried before him."
,"12":"They shall be called the holy people, the redeemed of Yahweh; and you shall be called The Sought After, a city no longer abandoned."
}`)
	CurrentBook.AddChapter(63, `{
"1":"Who is this coming from Edom, majestically arrayed,in crimson garments from Bozrah, marching in great strength?,'It is I, proclaiming justice, I who am powerful to save.'"
,"2":"Why are your clothes red, and your garments like those,of men who tread the winepress?"
,"3":"'Alone I have trod the grapes; not one of my people was with me. I trampled them in my anger, I trod them down in my wrath, their lifeblood spattering my garments, staining with crimson all my raiment."
,"4":"For I had set a day of vengeance,and my year of redemption had come."
,"5":"I looked about: there was no one to help. I was appalled: there was no one to give support. My own arm, then, brought about the victory, and I was supported by my own fury."
,"6":"I crushed the peoples in my anger, I trampled them down in my wrath, and on the earth I poured their lifeblood.'"
,"7":"I will sing in praise of Yahweh and recall his kindness, according to all that he has done for us, his great goodness to the family of Israel. He has granted us mercy in the abundance of his blessings."
,"8":"For he said: 'Surely they are my people, sons who will not be disloyal.' So he proved himself their Savior"
,"9":"in all their trials. It was not a messenger or an angel but he himself who delivered them. Out of his love and mercy, he redeemed them, lifting them up and carrying them throughout the days of old."
,"10":"Yet they rebelled, giving grief to his holy Spirit. So he turned and became their enemy, fighting against them."
,"11":"His people then remembered the days of old, the days of Moses. Where is he who brought them out of the sea, the shepherd of his flock?,Where is he who in the midst of them poured out his holy Spirit, "
,"12":"who sent his own power to accompany Moses, who divided the waters before them, winning for himself eternal renown,"
,"13":"who made them go through the depths as easily as a horse in the wilderness?"
,"14":"Like cattle going down into the valley, they did not stumble. The spirit of Yahweh led them to their rest; you guided your people, winning for yourself glorious renown."
,"15":"Look down from heaven, look down from your holy and glorious throne. Where is your zeal and your strength, the yearning of your heart and your compassion? How long will you ignore our pain?"
,"16":"For you are our Father, whereas Abraham does not know us nor has Israel any knowledge of us. But you, O Yahweh, are our Father, from the beginning, you are our redeemer: this is your name."
,"17":"Why have you made us stray from your ways? Why have you let our heart become hard so that we do not fear you? Return for the sake of your servants, the tribes of your inheritance."
,"18":"Why have irreligious people invaded your sanctuary? Why have our enemies trampled it down?"
,"19":"For too long we have become like those you do not rule, like those who do not bear your name. Oh, that you would rend the heavens and come down! The mountains would quake at your presence."
}`)
	CurrentBook.AddChapter(64, `{
"1":"As when fire sets brushwood ablaze and causes water to boil, make the nations know your name, and your enemies tremble."
,"2":"Let them witness your stunning deeds."
,"3":"No one has ever heard or perceived, no eye has ever seen a God besides you who works for those who trust in him."
,"4":"You have confounded those who acted righteously and who joyfully kept your ways in mind. You are angry with our sins, yet conceal them and we shall be saved."
,"5":"All of us have become like the unclean; all our good deeds are like polluted garments; we have all withered like leaves, blown away by our iniquities."
,"6":"There is no one who calls upon your name, no one who rouses himself to lay hold of you. For you have hidden your face, you have given us up to the power of our evil acts."
,"7":"And yet, Yahweh, you are our Father; we are the clay and you are our potter; we are the work of your hand."
,"8":"Do not let your anger go too far, O Yahweh, or think of our sins forever. See, we all are your people!"
,"9":"Your holy cities have become a wilderness, Zion has become a wasteland, Jerusalem a desolation."
,"10":"Our holy and glorious house, where our fathers used to pray to you, has been razed to the ground, and all that we treasure lies in ruins."
,"11":"Can you still remain unmoved, O Yahweh, before all this? Will you punish us further with your silence?"
}`)
	CurrentBook.AddChapter(65, `{
"1":"I let myself be found by those who did not ask for me; I have been met by those who did not seek me. I said, 'Here I am, here I am,' to a nation who did not call on my name. "
,"2":"I have stretched out my hands all day to a rebellious people who chose the evil way, following their own wishes."
,"3":"These people provoked me to my face, continually, sacrificing in gardens, burning incense on bricks,"
,"4":"living in tombs and spending nights in dark places; a people who eat the flesh of swine and broth of abominable meat."
,"5":"They cry out, 'Stay away, do not come near, for I am too sacred to be touched.' Such men and their acts arouse my anger like fire that burns all day."
,"6":"Look, all this is written in my book, I will not keep silent till I have settled my account with them"
,"7":"for their crimes and the crimes of their fathers as well, Yahweh says. Because they burned incense on the mountains and blasphemed against me on the hills, I will pay them back in full."
,"8":"Yahweh says, 'When people find juice in a grape, they say: 'Do not destroy it, there is a blessing here.' So will I do with my servants; I will not destroy all of them."
,"9":"I will create a new race from Jacob and they will own the hills of Judah. My chosen people will inherit them, and my servants will dwell there."
,"10":"Sharon will be a pasture for flocks, the Valley of Achor a resting place for herds; they will be for my people who have sought me."
,"11":"But as for you who have forsaken Yahweh, you who have forgotten my holy mountain, you who spread a table for Fortune and fill cups of mixed wine for Destiny,"
,"12":"I have destined you to the sword. All of you will kneel for the slaughter. For I called and you did not answer; I spoke and you did not listen. Instead you did what was evil in my sight,and chose that in which I had no delight."
,"13":"Therefore thus says the Lord Yahweh: Look, my servants will eat,but you will go hungry; my servants will drink,but you will be thirsty; my servants will rejoice,but you will be disgraced;"
,"14":"my servants will sing with gladness of heart, but you will cry with grief in your heart,and wail in anguish of spirit."
,"15":"My chosen ones will use as a curse the name you will leave behind, as I strike you dead and give my servants a new name."
,"16":"Whoever invokes a blessing in the land will receive the blessing from the God of truth; whoever takes an oath in the land will swear by the God of truth. For past troubles will be forgotten, and I will see them no more."
,"17":"I now create new heavens and a new earth, and the former things will not be remembered, nor will they come to mind again."
,"18":"Be glad forever and rejoice in what I create; for I create Jerusalem to be a joy and its people to be a delight."
,"19":"I will rejoice over Jerusalem and take delight in my people. The sound of distress and the voice of weeping will not be heard in it any more."
,"20":"It will no longer know of dead children or of a grown man not completing his days. He who reaches a hundred years will have died a mere youth, but he who fails to reach a hundred will be considered accursed."
,"21":"They will build houses and dwell in them; they will plant crops and eat their fruit."
,"22":"No longer will they build houses for others to dwell in; no longer will they plant for others to eat the harvest. For as the days of a tree will the days of my people be; my chosen ones will long enjoy the work of their hands."
,"23":"Their labor will not be in vain, nor will they bear children destined for misfortune, for they will be a people blessed by Yahweh, and their descendants with them."
,"24":"Before they call, I will have answered; while they are yet speaking, I will have heard."
,"25":"The wolf and the lamb will feed together, the lion will eat straw like the ox, They will not destroy nor do any harm,over all my holy mountain, says Yahweh."
}`)
	CurrentBook.AddChapter(66, `{
"1":"Thus says Yahweh: Heaven is my throne and earth my footstool. What house, then, could you build for me, and what could you offer as my resting place?"
,"2":"My hands have made all this and it is all mine, but what I am looking for is the one who is meek and contrite of heart, who trembles at my word."
,"3":"They sacrifice an ox, then they murder a man. They sacrifice a lamb, then they break a dog's neck; they bring a cereal offering, then they offer swine's blood. They burn incense, but they burn it for idols. Since they have chosen their own ways and taken delight in their dirty idols, "
,"4":"I will likewise choose afflictions for them that they fear and abhor. For when I called no one answered, when I spoke no one listened. Instead they did what was evil in my sight,and chose that in which I had no delight."
,"5":"Hear the word of Yahweh, you who tremble at his word: Because of my name your brothers hate and reject you, saying, 'Let Yahweh show his glory, that we may see your joy.',These mockers will be put to shame. "
,"6":"Listen, an uproar from the city, a voice from the temple! It is the voice of Yahweh avenging and paying back his enemies."
,"7":"Long before being in labor, she has given birth; before having birth pangs,she has been delivered of a son."
,"8":"Has anyone ever heard of such a thing? Has anyone seen the like of it? How could a land spring forth in one day? How could a nation be formed in a moment?,Yet Zion had scarcely been in travail when she gave birth to her children."
,"9":"Yahweh says: Do I allow to conceive and yet not to give birth? For I am the one who opens the womb and who closes it."
,"10":"'Rejoice for Jerusalem and be glad for her, all you who love her. Be glad with her, rejoice with her, all you who were in grief over her,"
,"11":"that you may suck of the milk from her comforting breasts, that you may drink deeply from the abundance of her glory.'"
,"12":"For this is what Yahweh says: I will send her peace, overflowing like a river; and the nations' wealth, rushing like a torrent towards her. And you will be nursed and carried in her arms and fondled upon her lap."
,"13":"As a son comforted by his mother, so will I comfort you."
,"14":"At the sight of this, your heart will rejoice; like grass, your bones will flourish. For it shall be known that Yahweh's hand is with his servant, but his fury is upon his enemy."
,"15":"Look, Yahweh will come in fire, his chariots like the whirlwind, to release his anger with fury,and his threat with flames of fire."
,"16":"For by fire will Yahweh execute judgment, and by his sword, against all mankind. Those slain by yahweh will be many."
,"17":"As for those who sanctify and purify themselves by going to the gardens and following the priestess in the midst - those who eat the flesh of pigs, reptiles and rats - their deeds and thoughts will suddenly come to an end, says Yahweh."
,"18":"Now I am going to gather the nations of every tongue, and they will witness my glory,"
,"19":"for I will perform a wonderful thing among them. Then I will send some of their survivors to the nations - Tarshish, Put, Lud, Moscheck, Rosh, Tubal, and Javan - to the distant islands where no one has ever heard of me or seen my glory. They will proclaim my glory among the nations."
,"20":"They will bring your brothers from all the nations as an offering to Yahweh on horses, in chariots, in litters, on mules, on camels to my holy mountain in Jerusalem, says Yahweh, just as the Israelites bring oblations in clean vessels to the house of Yahweh."
,"21":"Then I will choose priests and Levites even from them, says Yahweh."
,"22":"Yahweh says, 'As the new heavens and the new earth that I will make shall endure before me, so will your name and your descendants also endure.'"
,"23":"From new moon to new moon, from sabbath to sabbath, every mortal will come to worship me, says Yahweh."
,"24":"And on their way out they will see the corpses of those who rebelled against me. Their worms shall not die, nor their fire be quenched, and they will be abhorrent to all."
}`)

}
func EN_CCB_LoadVMLMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"How forlorn the city lies, once teeming with people!,How like a widow is she, once mistress of the nations!,A princess among the cities, she has now become a slave."
,"2":"She spends her nights weeping, drenching her cheeks with tears. Who is there to comfort her,among all her lovers?,All her friends have betrayed her,and have become her enemies."
,"3":"Humiliated, exhausted, Judah has gone into exile,but she finds no rest among the nations,where she sojourns; her pursuers have overtaken her,where there is no way of escape."
,"4":"All roads to Zion are in mourning; no one comes to her feasts. Her gates are deserted, her priests groan, her virgins grieve. What bitter anguish she suffers!"
,"5":"She is at the mercy of her foes,who enjoy prosperity and power. Yahweh himself has made her suffer,for all her iniquity. Her children, driven into captivity, take the lonely road to exile."
,"6":"Gone from the daughter of Zion,is all her majestic splendor. Her rulers, like harts,that find no pasture, have fled helplessly,before the oppressors."
,"7":"Jerusalem recalls her days,of wandering and affliction, her people fell into the hands of her foes,and there was no help. Haters gloated over her downfall,and laughed at her destruction."
,"8":"Greatly has Jerusalem sinned; she has become as a thing unclean. Honored before, but now despised by those who have seen her naked, she herself groans in dismay,and turns her face away."
,"9":"Her filth clings to her skirt. She gave no thought to her doom, and so her fall came suddenly, with no one to offer comfort. 'Look, O Yahweh, upon my misery, for my enemy has overcome me.'"
,"10":"She has seen how the enemy,has laid hands on her treasures. She has seen how the nations,have defiled her sanctuary -,those peoples you have not allowed,to come into your assembly."
,"11":"All her people groan,as they search for bread; just to keep themselves alive, they give their jewels for food. Look, Yahweh, and mark,how I have been despised."
,"12":"All you who pass by, look and see. Is there any calamity,like this, inflicted on me,by Yahweh on the day,of his burning anger."
,"13":"From above he sent a fire,down into my very bones, he ensnared my feet,and threw me down, and left me in pain,the whole day long."
,"14":"He bound my sins into a yoke,and fastened them together, then set them upon my neck,and caused my strength to fail. Yahweh gave me into the hands,of those I cannot withstand."
,"15":"Yahweh has spurned,the bravest of my fighters; he has summoned an army,to crush my young warriors. Yahweh has trodden in his winepress,Judah's virgin daughter."
,"16":"This is what I weep about, what makes my tears well up. No one is near to restore my spirit, no one at hand to console me. My children are desolate, for the enemy has triumphed."
,"17":"Zion stretches out her hands, but there is no one to give comfort. Yahweh has decreed for Jacob,that his neighbors become his foes. As an unclean thing among them,has Jerusalem become."
,"18":"Yahweh acts justly, for I have defied his order. Listen, all you peoples, and see how I suffer. My young men and maidens,have all gone into exile."
,"19":"I cried for help to my lovers, but they betrayed me. My priests and my elders,perished in the city,they sought anything to eat, but finally they had to die."
,"20":"Look, Yahweh, upon my distress: all within me is in anguish. My heart recoils within me: I know that I have been rebellious. See, outside the sword that kills, and within, death that stalks."
,"21":"People have heard my moaning,but no one comes to comfort me. My foes have known of my suffering, they rejoice at what you have done. Hasten the day you have proclaimed, that they may be even as I am."
,"22":"Let their evil come,before you, and deal with them,as you have dealt with me,on account of my sins. Great indeed is my groaning. How sick at heart I am!"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Oh, how Yahweh in his anger,has despised the daughter of Zion!,Israel's glory he has flung,from heaven down to earth; unmindful of his footstool,on the day of his wrath."
,"2":"Without pity Yahweh has shattered,in Jacob every dwelling. He has torn down in his anger,the ramparts of Judah's daughter. He has thrown her rulers and her king,to the ground, dishonored."
,"3":"He has cut down in his anger,the horn of Israel's might. He has withdrawn his right hand,at the approach of the enemy. In Jacob, he has blazed like a fire, he has devoured all around."
,"4":"Like an enemy he has bent his bow, his right hand steadying the arrow. All our pride of manhood he slew,as he took his stand as a foe, pouring out fury like fire,upon the tent of Zion's daughter."
,"5":"The Lord has become an enemy,who has laid Israel in ruins. He has destroyed all her palaces,and laid waste her fortresses. He has multiplied the tears,of the daughter of Judah."
,"6":"Yahweh has wrecked her dwelling, laid waste her place of meeting. He has made Zion forget,her appointed feasts and sabbaths; he has spurned in his fierce wrath,king and prophet and priest."
,"7":"The Lord has rejected his altar, has forsaken his sanctuary. He has handed over the walls of her tower to the enemy, whose triumphant shouts are heard,in the temple of Yahweh."
,"8":"Yahweh resolved to tear down,the ramparts of Zion's daughter. He stretched out the measuring line, and did not relent from bringing ruin. He made both wall and rampart mourn, till together they crumbled down."
,"9":"Her gates have sunk into the ground; broken and removed are their bars. Her king and rulers,live in exile among the nations. No more message for their prophets, no more visions from Yahweh."
,"10":"The elders of the daughter of Zion,sit in silence upon the ground, their heads sprinkled with dust, their bodies wrapped in sackcloth, while Jerusalem's young women,bow their heads to the ground."
,"11":"With weeping my eyes are spent; my soul is in torment,because of the downfall,of the daughter of my people, because children and infants faint,in the open spaces of the town."
,"12":"To their mothers they say, 'Where is the bread and wine?',as they faint like wounded men,in the streets and public squares, as their lives ebb away,in their mothers' arms."
,"13":"To what can I compare you, O daughter of Jerusalem?,Who can save or comfort you, O virgin daughter of Zion?,Deep as the sea is your affliction, and who can possibly heal you?"
,"14":"Your prophets' visions,were worthless and false. Had they warned of your sins, your fate might have been averted. But what they gave you instead,were false, misleading signs."
,"15":"Passersby shudder; some clap their hands at the sight; others wag their heads at the fate,of the daughter of Jerusalem. 'Is this the city that was called,the loveliest, the joy of the world?'"
,"16":"All your enemies open wide,their mouths against you; they gnash their teeth, they hiss, they crow: 'We have destroyed her!,This is the day we have waited for; we have lived to see it happen.'"
,"17":"Yahweh has accomplished his purpose; he has fulfilled his word,which he decreed in the days of old; he overthrew you merciless. He made your enemies joyful,and gave them power to crush you."
,"18":"Cry out to the Lord, O wall,of the daughter of Zion!,Oh, let your tears flow,day and night, like a river. Give yourself no relief; grant your eyes no respite."
,"19":"Get up, cry out in the night, as the evening watches start; pour out your heart like water,in the presence of the Lord. Lift up your hands to him,for the lives of your children, who faint with hunger,at the corner of every street."
,"20":"Look, Yahweh, and answer: Why have you treated us like this?,Why must women eat their little ones, whom they have nursed in their arms?,Why must priest and prophet be slaughtered,in the sanctuary of the Lord?"
,"21":"In the dust of the streets,lie the young and the old, both virgins and young men -,all fallen by the sword. You have killed on the day of your fury; you have slaughtered without mercy."
,"22":"As for a feast day, you bade,terrors to come from every side. There was, on the day of your anger, neither fugitive nor survivor. My enemy has murdered,all whom I bore and reared."
}`)
	CurrentBook.AddChapter(3, `{
"1":"I am a man who has known calamity from the rod of his wrath;"
,"2":"he has driven and brought me,into darkness, not into the light."
,"3":"He turns his hand against me alone, all the day long, again and again."
,"4":"He has worn away my flesh and skin; he has broken all my bones."
,"5":"He assails me and surrounds me,with tribulation and bitterness."
,"6":"He leaves me to dwell in darkness, like those who have long been dead."
,"7":"He has walled me in without escape; he has weighed me down with chains."
,"8":"I could not even cry for help, for he has stopped my prayer."
,"9":"He bars my way with stones,and left me helplessly alone."
,"10":"Like a bear lying in ambush, like a lion waiting for its prey,"
,"11":"he lunged at me, tore me to pieces, and left me alone and helpless."
,"12":"Then he drew his bow,and aimed his arrow at me."
,"13":"He pierced my sides,with arrows from his quiver."
,"14":"I have become a laughingstock, a topic of songs for all the peoples."
,"15":"He has sated me with bitter food; he has made me drunk with wormwood."
,"16":"He has broken my teeth with gravel,and thrown me down in the ashes."
,"17":"He has deprived my soul of peace, till I have forgotten happiness."
,"18":"Now I say, 'Gone are my hopes,and all my confidence in the Lord.'"
,"19":"Recalling my affliction and homelessness is wormwood and gall."
,"20":"Thinking it over and over,makes my soul downcast."
,"21":"But this, when I ponder, is what gives me hope:"
,"22":"Yahweh's love abides unceasingly. His compassion is never consumed;"
,"23":"every morning it is renewed. And his love remains ever faithful."
,"24":"'My portion is Yahweh,' says my soul. 'On him shall I rely.'"
,"25":"Yahweh is good to those who hope in him, to souls who search for him."
,"26":"It is rewarding to wait in silence,for the Lord's salvation."
,"27":"It is good for man to bear the yoke from his youth."
,"28":"Let him sit alone in silence,when Yahweh fastens the yoke on him."
,"29":"Let him put his lips to the dust,there may still be hope."
,"30":"Let him offer his cheek to be struck; let him be overwhelmed with insult."
,"31":"For it is not forever,that the Lord rejects man."
,"32":"In the abundance of his love,he punishes, but has compassion."
,"33":"For he does not willingly abase,or afflict the human race."
,"34":"To trample underfoot,the prisoners of the land,"
,"35":"to deny a man his rights,in the presence of the Most High,"
,"36":"to deprive people of justice -,the Lord does not approve of this."
,"37":"Who can command and execute,what the Lord has not willed?"
,"38":"From the mouth of the Most High,come all things, good or bad."
,"39":"Why should then mortals complain,when punished for their sin?"
,"40":"Let us search and examine our ways and return to the Lord."
,"41":"Let us lift up our hearts and hands,to God in heaven, and say:"
,"42":"'We have sinned and rebelled, and you have not forgiven us."
,"43":"Clothed in anger you have pursued us without mercy."
,"44":"You have wrapped yourself in clouds,so that no prayer can reach you."
,"45":"You have reduced us to dust,and refuse among the nations."
,"46":"Our foes have opened wide,their mouths against us."
,"47":"Terror is our lot: pitfall, ruin and desolation."
,"48":"Great is my grief over the downfall,of the daughter of my people."
,"49":"No respite, no relief, as my tears flow ceaselessly,"
,"50":"till the Lord looks down,from heaven and sees."
,"51":"My soul will grieve in torment,for the women of my city."
,"52":"Like a bird I have been hunted,by my foes without cause."
,"53":"They flung me alive,into a pit,and cast stones at me."
,"54":"As the waters closed over my head, I thought I would never again live."
,"55":"Out of the depths I called,on your name, O Yahweh."
,"56":"You heard; you have not been deaf,to my cry for relief."
,"57":"When I called, you even came near,and told me not to fear."
,"58":"O Lord, you took up my case,and redeemed my life."
,"59":"You have seen the wrong they did me, uphold my cause!"
,"60":"You have seen how resentfully,they plotted to destroy my life."
,"61":"O Yahweh, you have heard the insults,hurled at me, their insidious plots;"
,"62":"You have been aware of their thoughts, their muttering against me all day long."
,"63":"Look at them - sitting or standing -,mocking me in their song!"
,"64":"Repay them as they deserve, according to their deeds, O Yahweh."
,"65":"Harden their hearts; hold them under your curse."
,"66":"Pursue and destroy them in fury,from under the heavens, O Yahweh."
}`)
	CurrentBook.AddChapter(4, `{
"1":"How tarnished the gold has become. The fine gold has lost its luster. Why, the sacred stones lie strewn,at every street corner!"
,"2":"Oh, the precious sons of Zion, once worth their weight in gold -,but now reckoned no more,than earthen jars from a potter's mold!"
,"3":"Even jackals bare their breasts,to suckle their young, but my people have become heartless, like ostriches in the desert land."
,"4":"In thirst the infant's tongue,cleaves to the roof of its mouth. Children are begging for alms, but there is no one to help them."
,"5":"Those accustomed to fine food,now lie dying in the streets. Those accustomed to wear purple,now lie destitute upon the ash heaps."
,"6":"The punishment of my people,is greater than that of Sodom, which was overthrown in an instant, without a helping hand."
,"7":"Brighter than snow were their rulers, even whiter than milk; their bodies rosier than coral, their beauty as radiant as sapphires."
,"8":"Now they look blacker than soot, unrecognized in the streets. Their emaciated form shows lack of food, their skin shriveled and dry as wood."
,"9":"Better to have died by the sword,than to have perished in hunger. The famine-stricken people perish, and slowly, wretchedly, pass away."
,"10":"Once loving mothers, our women,have cooked their own children,and made them their food: such has been the crash of my people!"
,"11":"Yahweh has given full vent to his wrath; pouring out his fierce anger. He has kindled a fire in Zion, which has consumed her foundation."
,"12":"Never had kings believed,nor the world thought possible,that the enemy could break,through the gates of Jerusalem."
,"13":"But this happened because of the priests, who sinned, because of the prophets who transgressed, shedding in her midst the blood of the just."
,"14":"They wandered like blind men, groping through the streets, so defiled with blood,that none could touch their garments."
,"15":"'Go away!' people cried at them. 'Do not touch us! You are unclean!',They became fugitives wandering about, but even the nations would drive them out."
,"16":"Yahweh himself has dispersed them; no longer does he watch over them. The priests are shown no honor; the elders are given no favor."
,"17":"Our watchmen strained their eyes, looking for help in vain. We anxiously waited for an ally, who failed to save us."
,"18":"Like dogs our enemies hounded us,and kept us off the streets. As our end drew near, we knew our days were numbered."
,"19":"Swifter were our pursuers, than the eagles in the sky. Over the hills they chased us, they waylaid us in the wilderness."
,"20":"Our life's breath, Yahweh's anointed, was taken captive in their pit -,he of whom we said, 'In his protection,we shall live among the nations.'"
,"21":"Rejoice and be glad, O daughter of Edom, you who dwell in the land of Uz. But you shall be drunk and stripped bare, for to you also the cup will pass."
,"22":"Your ordeal, daughter of Zion, will end; for your exile will not be prolonged. But Edom's daughter will be chastised, and her wickedness will be exposed."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Remember, Yahweh, what has befallen us. Look, and see our disgrace,"
,"2":"our home handed over to strangers, our inheritance to foreigners."
,"3":"We are as orphans, fatherless, and early widowed are our mothers."
,"4":"Our drinking water we must buy; for our own wood we have to pay."
,"5":"With the yoke stifling our breath, without rest we work to death."
,"6":"We have bowed down to Egypt, and to Assyria, just to subsist."
,"7":"Our fathers who sinned are no more but we bear their guilt."
,"8":"Slaves rule us, and there is no one to rescue us from their hands."
,"9":"We brave the desert heat and the sword just to get our hard-earned food."
,"10":"Our skin is hot like a furnace, dried up and shriveled by hunger."
,"11":"Ravished are the wives in Zion, the virgins in the towns of Judah."
,"12":"Princes are hung up by their hands; elders shown no respect."
,"13":"Young men toil at the millstones, boys stagger under heavy loads."
,"14":"The old have shunned the city gate, the young, their music."
,"15":"From our hearts joy is gone; we danced then, but now we lament."
,"16":"The garlands have fallen,from our heads. Woe upon us, for we have sinned!"
,"17":"Over all this our hearts are sick; and our eyes have grown weak:"
,"18":"for we see Mount Zion desolate; the jackals prowl within."
,"19":"You, O Yahweh, forever reign; your throne endures from age to age."
,"20":"Why, then, should you abandon us, why forget us for so long a time?"
,"21":"Lead us to you again, O Lord, that we may be restored; renew our days as of old."
,"22":"Have you utterly rejected us? Is there no end to your wrath against us?"
}`)

}
func EN_CCB_LoadVNABChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"The Vision of Obadiah. This is what the Lord Yahweh says about Edom: We have heard news from Yahweh, and a messenger has been sent out to the nations to say, 'Rise, let us go against Esau.'"
,"2":"The day has come: you now are small among the nations; you are utterly despised."
,"3":"Your arrogance has led you astray, you who live in the clefts of the rock, you who make the heights your home, you who say to yourself: Who can bring me down to the ground?"
,"4":"Though you soar like the eagle, though you make your nests among the stars, I will bring you down again."
,"5":"If thieves or plunderers come at night, what a disaster awaits you then!,Would they not ransack till they had enough? If grape gatherers worked in your vineyard, would they not leave only gleanings? "
,"6":"See how Esau has been looted, even his hidden treasures pillaged!"
,"7":"You have been driven to the frontiers: and those were your very friends!,Those who partook of your bread,set for you a trap in secret."
,"8":"Yahweh declares: Shall I not destroy,the wise men of Edom on that day, and deprive of sages the mountain of Esau?"
,"9":"Your warriors, O Teman, will be afraid, and all from Mount Esau will be slaughtered."
,"10":"For the violence done to Jacob, your brother, you will be disgraced and destroyed forever."
,"11":"You stood aloof in waiting,when strangers carried off his wealth, when foreigners entered his gates,and cast lots for Jerusalem, you were as guilty as the rest of them."
,"12":"Do not come to see and gloat,over the misfortune of your brother. Do not exult over Judah's ruin, nor brag on the day of her destruction."
,"13":"Do not go through the gate of my people,on the day of their disgrace, nor gloat over them in their misfortune,on the day of their adversity, nor lay your hands upon their possessions,on the day of their destruction."
,"14":"Do not wait at the crossroad,to slay their stragglers, nor betray their survivors,on the day of their disaster."
,"15":"For the day of Yahweh is near,for every nation. As you have done to another, so to you will it be done. Whatever you have done,will come back upon your head."
,"16":"For as you have drunk on my holy mountain, so will the surrounding nation drink, drink and drink up to the brim... Then they shall be as if they had never been."
,"17":"But there will be survivors on Mount Zion,- a holy remnant. The house of Jacob will take possession,of its own inheritance."
,"18":"The nation of Jacob will be a fire, the nation of Joseph a flame; but those of Esau will be a stubble, and they will burn and consume them. And of Esau's house none will remain, for it is Yahweh who has spoken."
,"19":"People from the Negeb,will occupy Esau's mountains; those from the plains, the land of the Philistines; they will occupy Ephraim and Samaria, and Benjamin will possess Gilead."
,"20":"The Israelite exiles who are in Canaan,will possess Phoenicia as far as Zarephtah; the exiles from Jerusalem now in Sepharad,will possess the towns of the Negeb."
,"21":"Deliverers will ascend Mount Zion,to rule over the mountains of Esau, - then Yahweh will reign."
}`)

}
func EN_CCB_LoadVNAGChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"In the second year of the reign of Darius, on the first day of the sixth month, a word of Yahweh was directed to the prophet Haggai for the benefit of Zerubbabel, the son of Shealtiel, governor of Judah, and Joshua the son of Jehozadak, the high priest."
,"2":"'So says Yahweh of hosts: This people claim that the time to rebuild the House of Yahweh has not yet come."
,"3":"Well now, hear what I have to say through the prophet Haggai:"
,"4":"Is this the time for you to live in your well-built houses while this House is a heap of ruins?"
,"5":"Think about your ways:"
,"6":"you have sown much but harvested little, you eat and drink but are not satisfied, you clothe yourselves but still feel cold, and the laborer puts the money he earned in a tattered purse."
,"7":"Now think about what you must do:"
,"8":"go to the mountain and look for wood to rebuild the House. This will make me happy and I will feel deeply honored, says Yahweh."
,"9":"You expected much but it turned out to be very little. I blew away what you had piled up. Why? Because my House lies in ruins while each of you goes running home."
,"10":"Therefore the heavens have withheld rain, and the earth has not produced anything."
,"11":"I sent drought upon the valley and the hills, upon the wheat and the vines, the oil and whatever the soil produces, upon people and animals, and upon any work of your hands.'"
,"12":"Now, when Zerubbabel, the son of Shealtiel, Joshua the son of Jehozadak, the high priest,"
,"13":"and all the people heard these words of the prophet Haggai whom Yahweh had sent to speak to them, they paid attention to what Yahweh had told them and the people were filled with respect for God."
,"14":"Then Haggai, the messenger of Yahweh, passed on to the people this word of Yahweh, 'I am with you.' Then Yahweh moved the heart of Zerubbabel, Joshua and all the people, and they began rebuilding the House of Yahweh of hosts, their God."
,"15":"It was the twenty-fourth day of the sixth month."
}`)
	CurrentBook.AddChapter(2, `{
"1":"On the twenty-first day of the seventh month of the second year of the reign of Darius, this word of Yahweh was sent through the prophet Haggai,"
,"2":"'Give this message to Zerubbabel, the governor of Judah, and to Joshua, the high priest, and to all the people:"
,"3":"Is there left among you one of those who saw this house long ago in the time of its glory? What do they think of what they see now? Is it not a very little thing?"
,"4":"But I say to you, Zerubbabel, Joshua and my people: do not be discouraged. Begin to work, for I am with you, says Yahweh."
,"5":"Do not be afraid, for my spirit is in your midst."
,"6":"Thus says Yahweh of hosts, within a short while I will shake the heavens and the earth, the sea and the continents."
,"7":"Then I will shake all the nations and bring in the treasures of the whole world. I will fill this House with glory, says Yahweh."
,"8":"I will have as much silver and gold as I wish."
,"9":"The renown of this Temple will be greater than before, and in this place I will give peace,' says Yahweh of hosts."
,"10":"On the twenty-fourth day of the ninth month, in the second year of Darius, the word of Yahweh was directed again to the prophet Haggai."
,"11":"He should ask the priests to resolve the following case in accordance with the Law:"
,"12":"'If someone brings consecrated meat wrapped in his cloak, and the edge of his cloak touches bread, cooked food, wine, oil, or any other food, will all these become consecrated food?' They immediately answered, 'No.'"
,"13":"Haggai went on to say, 'But if someone becomes unclean by having touched a dead body, and then touches any of these things, will all these become unclean?' This time the priests said, 'Yes.'"
,"14":"Then Haggai addressed them, 'So it is with this people and this nation before me, says Yahweh, so with everything they do and all they offer here: all is unclean."
,"15":"Pay attention to this from now on: how was it with you before the rebuilding of the Temple was begun?"
,"16":"You expected twenty sacks of wheat, but there were only ten. You thought of drawing out fifty measures of wine but there were only twenty."
,"17":"I spoiled all your work with blight, mildew and hail. Yet none returned to me, says the Lord."
,"18":"Pay attention, then, from now on, since the first stone of the Sanctuary of Yahweh was laid."
,"19":"See if the wheat, the vine, the fig tree and the pomegranate go on yielding little! From this day on I will bless your olive trees.'"
,"20":"The word of Yahweh came again to Haggai on the twenty-fourth day of the same month,"
,"21":"'Say to Zerubbabel, the governor of Judah:"
,"22":"I will overthrow the thrones of the kings and destroy the power of the nations. I will overturn the chariot and its driver; the horses and their riders shall tumble down to the ground. They will kill one another."
,"23":"On that day I will take you, Zerubbabel, my servant, the son of Shealtiel, and for me you will be like a ring on my finger with my initials on it. For I have chosen you, says Yahweh of hosts.'"
}`)

}
func EN_CCB_LoadVNAMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"These are the words of Amos, one of the sheep-breeders of Tekoa, and the visions which he saw concerning Israel during the reign of Uzziah, King of Judah and Jeroboam, son of Jehoash, King of Israel, two years before the earthquake."
,"2":"He said, 'Yahweh roars from Zion, his voice thunders from Jerusalem. The pastures of the shepherds are scorched,and the choicest farmland is dried up.'"
,"3":"Yahweh says this, 'Because Damascus has sinned, not once but three times and even more, I will not relent. Because they have threshed Gilead with threshing sledges of iron,"
,"4":"I will send fire upon the people of Hazael that shall devour the strongholds of Benhadad. I will cut off the ruler from the Valley of Aven and him who holds the scepter from Betheden."
,"5":"I shall break the protective crossbar of Damascus.'"
,"6":"Yahweh says this, 'Because Gaza has sinned, not once but three times and even more, I will not relent. Because they carried a whole people into captivity to deliver them over to Edom,"
,"7":"I will send fire upon the wall of Gaza and it will devour her strongholds."
,"8":"I will cut off the ruler from Ashdod, and him that holds the scepter from Ashkelon; I will turn my hand against Ekron and the remnant of the Philistines will perish,' says Yahweh."
,"9":"Yahweh says this, 'Because Tyre has sinned, not once but three times and even more, I will not relent. Because they delivered over to Edom a whole people and did not remember the covenant of brotherhood,"
,"10":"I will send fire upon the walls of Tyre and it shall devour her palaces.'"
,"11":"Yahweh says this, 'Because Edom has sinned, not once but three times and even more, I will not relent. Because he pursued his brother with the sword and cast off all pity, because his anger rages forever and his wrath is always wild,"
,"12":"I will send fire upon Teman and it shall devour the strongholds of Bozrah.'"
,"13":"Yahweh says this, 'Because the Amonites have sinned, not once but three times and even more, I will not relent. Because they have ripped open pregnant women in Gilead, that they might enlarge their border,"
,"14":"I will set fire to the walls of Rabbah and it shall devour her strongholds. Then there will be war cry and battle; then storm winds will blow."
,"15":"Their king will go into exile, he and his princes with him,' says Yahweh."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Yahweh says this, 'Because Moab has sinned, not once but three times and even more, I will not relent. Because they burned to a cinder the bones of the king of Edom,"
,"2":"I will send fire on Moab and it shall be destroyed in the midst of the tumult, with war cries and the blast of the trumpet."
,"3":"I will do away with their ruler and all the princes with him,' says Yahweh."
,"4":"Yahweh says this, 'Because Judah has sinned, not once but three times and even more, I will not relent. Because they rejected the law of Yahweh and did not keep his statutes, but have been led astray by the falsehood after which their fathers walked,"
,"5":"I will send fire upon Judah and it will devour the fortresses of Jerusalem.'"
,"6":"Yahweh says this, 'Because Israel has sinned, not once but three times and even more, I will not relent. They sell the just for money and the needy for a pair of sandals;"
,"7":"they tread on the head of the poor and trample them upon the dust of the earth, while they silence the right of the afflicted; a man and his father go to the same woman to profane my holy name;"
,"8":"they stretch out upon garments taken in pledge, beside every altar; they take the wine of those they swindle and are drunk in the house of their God."
,"9":"It was I who destroyed the Amorites before them, whose height was like the height of the cedar, a people as sturdy as an oak. I destroyed their fruit above and their roots below."
,"10":"It was I who brought you up from the land of Egypt and led you forty years in the wilderness to take possession of the land of the Amorites."
,"11":"It was I who raised up prophets among your sons, and Nazirites among your young men. Is this not so, people of Israel?' says Yahweh."
,"12":"'But you gave the Nazirites wine to drink and commanded the prophets not to prophesy."
,"13":"Behold, I will crush you to the ground, as a cart does when it is full of sheaves."
,"14":"The swift shall be unable to flee and the strong man shall lose his strength. The warrior shall not save himself nor the bowman stand his ground."
,"15":"The swift of foot shall not escape nor the horseman save himself."
,"16":"Even the most stout-hearted among the warriors shall flee away naked on that day,' says Yahweh."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Hear this word which Yahweh speaks against you, people of Israel, against the whole family which he brought up from the land of Egypt."
,"2":"'Only you have I known of all the families of the earth; therefore I will call you to account for all your wrongdoings.'"
,"3":"Do two walk together unless they have agreed?"
,"4":"Does a lion roar in the forest when it has no prey? Does a young lion growl in its den unless it has seized something?"
,"5":"Does a bird get caught in a snare if the snare has not been baited?,Does a tiger spring up from the ground unless it has caught something?"
,"6":"If a trumpet sounds in a city, will the people not be frightened?,If disaster strikes a city, has not Yahweh caused it? "
,"7":"Yet Yahweh does nothing without revealing his plan to his servants, the prophets."
,"8":"If the lion roars, who will not be afraid? If Yahweh speaks, who will not prophesy?"
,"9":"Call on the people living in the palaces of Ashur and in the palaces of Egypt, 'Come together against the hill of Samaria and see the many scandals and the oppression that is there.'"
,"10":"'These people do not know how to do what is right, says Yahweh, storing in strongholds what they have taken through violence and extortion."
,"11":"Therefore this is the word of Yahweh, 'The enemy shall surround the land; your strength shall be broken down and your strongholds plundered.'"
,"12":"Yahweh says this, 'As the shepherd rescues from the mouth of the lion a pair of legs or the tip of an ear, so shall some of you be saved, O Israelites of Samaria who loll on comfortable couches and rest on pillows of Damascus.'"
,"13":"'Hear and accuse the nation of Jacob,' says Yahweh, God of hosts,"
,"14":"'On the day that I call Israel to account for his crimes, I will punish as well the altars of Bethel. The horns of the altar will be broken off and fall to the ground."
,"15":"Then I will strike the winter house and the summer house. The palaces of ivory shall be ruined, and the great house destroyed.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Listen to this word, you cows of Bashan, you women who live on the hills of Samaria, who oppress the weak and abuse the needy, who order your husbands, 'Bring us something to drink quickly!'"
,"2":"Yahweh has sworn by his holiness, 'The time is coming upon you when you will be dragged away with hooks, even the last of you with fishhooks."
,"3":"Through the breaks in the wall you will go out, straight ahead, driven out all the way to Hermon.' It is Yahweh who speaks."
,"4":"'Come, sinners, to the Sanctuary in Bethel, go down to Gilgal and sin even more!,Each morning bring your sacrifices and on the third day your tithes. Burn leavened food for thanksgiving. "
,"5":"Proclaim in public your freewill offering, for this is what makes you happy, people of Israel,' says Yahweh."
,"6":"'Though I have made your teeth clean of food in every city, though I have made your bread in all your dwellings scarce, yet you did not return to me,' says Yahweh."
,"7":"'Though I withheld rain from you when the harvest was still three months away, though I sent rain upon one town and withheld it from another,"
,"8":"though people staggered from town to town, and found no water to quench their thirst, yet you never returned to me,' says Yahweh."
,"9":"'Though with blight and calamities I have stricken your garden and vineyard, though your fig and olive trees were devoured by the locusts, yet you never returned to me,' says Yahweh."
,"10":"'Though as in Egypt I sent you a plague, though I slew your young men with the sword along with your captured horses, and nauseated you with stench from your own dead, yet you never returned to me,' says Yahweh."
,"11":"'I overthrew you, a divine punishment, as happened to Sodom and Gomorrah; you were like a brand snatched from the blaze, yet you never returned to me,' says Yahweh."
,"12":"'Therefore I will deal with you in my own way, Israel, and since I will do this to you, prepare, Israel, to meet your God!'"
,"13":"For it is he who makes the thunder and creates the winds, and makes people know why he did, who turns dawn to twilight, who strides upon the heights of the earth - Yahweh, God of hosts, is his name."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Listen to these words, this lament I pronounce over you, nation of Israel,"
,"2":"'Virgin Israel is fallen, never to rise again! With none to help her up, abandoned, she lies upon her own land.'"
,"3":"For Yahweh says this, 'The city that went forth to war a thousand strong shall be left with a hundred, and that which went forth with a hundred shall be left with ten in Israel.'"
,"4":"For Yahweh says this to the nation of Israel, 'Seek me, that you may live,"
,"5":"but not in Bethel nor come to Gilgal, nor pass through to Beersheba. For Gilgal shall be led into exile and Bethel brought to nothing.'"
,"6":"Seek Yahweh, that you may live, or he will rush like fire on the nation of Joseph and no one will be at Bethel to quench the blaze."
,"7":"Woe to those whose decrees are bitterness, not justice, who trample on the rights!"
,"8":"He who made the Pleiades and Orion, who turns dusk to dawn and darkens the day into night, who summons the waters of the sea and pours them out upon the earth - Yahweh is his name."
,"9":"He makes destruction flash forth against the strong, and brings ruin upon the fortified city."
,"10":"You hate him who reproves in court; you despise him who speaks the truth."
,"11":"Because you have trampled on the poor and extorted levies on their grain, though you have built mansions of hewn stones you will not dwell in them; though you have planted choice grapevines, you shall not drink of their wine."
,"12":"For I know the number of your crimes and how grievous are your sins: persecuting the just, taking bribes, turning away the needy at the gates."
,"13":"See, how the prudent keep silent at this time, for it is an evil time."
,"14":"Seek good and shun evil, that you may live. Then Yahweh, the God of hosts, as you have claimed, will be with you."
,"15":"Hate wickedness and love virtue, and let justice prevail in the courts; perhaps Yahweh, the God of hosts, will take pity on the remnant of Joseph."
,"16":"Yahweh, God of hosts thus says: 'In every square, wailing will be heard, in every street, cries of anguish. Farmers will be summoned to lament and professional mourners to weep noisily."
,"17":"There will be lamentation in every vineyard, for I will pass through your midst, says the Lord.'"
,"18":"Woe to you who long for Yahweh's day! Why should you long for that day? It is a day of darkness, not of dawn,"
,"19":"as if a man fled from a lion only to run into a bear; or as if he entered his home, rested his hand against the wall, only to be bitten by a viper."
,"20":"The day of Yahweh will be darkness, not light, gloom without a glow of brightness."
,"21":"'I hate, I reject your feasts, I take no pleasure when you assemble"
,"22":"to offer me your burnt offerings. Your cereal offerings, I will not accept! Your offerings of fattened beasts, I will not look upon!"
,"23":"Away with the noise of your chanting, away with your strumming on harps."
,"24":"But let justice run its course like water, and righteousness be like an ever-flowing river."
,"25":"Did you, Israel, bring me offerings and sacrifices for forty years, in the wilderness?"
,"26":"Yet now you lift up King Sikkuth and Kiyun, your idols, which you made yourselves."
,"27":"Therefore I will send you into exile beyond Damascus,' says Yahweh whose name is God of hosts."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Woe to those proud people who live, overconfident on the hill of Samaria!,Woe to you, men of renown, from the first among the nations, to whom the people of Israel come!"
,"2":"Pass through Kalneh and see; from there go to Hamath the great, then go down to Gath of the Philistines. Are you better than these kingdoms were? Is your territory greater than theirs?"
,"3":"You hope to postpone the evil day; in fact you bring about a year of violence."
,"4":"You lie on beds inlaid with ivory and sprawl on your couches; you eat lamb from the flock and veal from calves fattened in the stall."
,"5":"You strum on your harps, and like David, try out new musical instruments."
,"6":"You drink wine by the bowlful and anoint yourselves with the finest oils, but you do not grieve over the ruins of Joseph."
,"7":"Therefore you will be the first to go into exile; and the feast of sprawlers will be over."
,"8":"Yahweh has sworn by his life, 'I hate the proud city of Jacob, I hate its palaces. I will hand over the city and all that fills it.'"
,"9":"In those days, if ten people are left in one house, they shall die."
,"10":"Their kinsman will lift the corpses and bring the bones from the house; when he will say to his comrade at the back part of the house, 'Are there any more?' the other will say, 'No, but hush! We must not mention the name of Yahweh.'"
,"11":"For this is Yahweh's command, 'The great house shall crumble, and the small house fall to pieces.'"
,"12":"Do horses run on craggy cliffs? Does anyone plow the sea with oxen? Well, you have turned the rights into a poisonous plant and the sentences of the court into wormwood."
,"13":"You rejoice about unimportant matters when you say, 'Are we not winners once more?'"
,"14":"Yet am I stirring up against you, Israel, a nation that will oppress you from the pass of Hamath to the brook of the Arabah."
}`)
	CurrentBook.AddChapter(7, `{
"1":"This is what Yahweh showed me. He was forming a swarm of locusts just as the late sowing began to come up. It was the second growth which follows the king's mowing."
,"2":"When they were about to finish devouring all the crops of the land, I said, 'Yahweh, forgive! How shall Jacob survive, small as he is?'"
,"3":"Yahweh repented and said, 'It shall not happen.'"
,"4":"This is what Yahweh showed me: he was calling for burning heat. It consumed the great deep and was consuming the land."
,"5":"I said, 'Yahweh, stop! How shall Jacob survive small as he is?'"
,"6":"Yahweh relented and said, 'This too shall not happen.'"
,"7":"This is what Yahweh showed me. He was standing beside a wall with a plumb line in his hand."
,"8":"The Lord asked me, 'Amos, what do you see?' And I answered, 'A plumb line.' Then the Lord said, 'Behold, I am measuring my people Israel with a plumb line. I will forgive them no more."
,"9":"The high places of Isaac are to be made desolate, and the sanctuaries of Israel laid waste. For I will arise, sword in hand, against the family of Jeroboam.'"
,"10":"Amaziah, the priest of Bethel, then sent word to King Jeroboam of Israel, 'Amos is conspiring against you in the very center of Israel; what he says,goes too far. "
,"11":"These are his very words: Jeroboam shall die by the sword and Israel shall be exiled from its land.'"
,"12":"Amaziah then said to Amos, 'Off with you, seer, go back to the land of Judah. Earn your bread there by prophesying."
,"13":"But never again prophesy at Bethel for it is a king's sanctuary and a national shrine.'"
,"14":"Amos replied to Amaziah, 'I am not a prophet or one of the fellow-prophets. I am a breeder of sheep and a dresser of sycamore trees."
,"15":"But Yahweh took me from shepherding the flock and said to me: Go, and from me, tell my people Israel."
,"16":"Now hear the word of Yahweh, you who say: No more prophecy against Israel, no more insults against the family of Isaac!"
,"17":"This is what Yahweh says: Your wife shall be made a harlot in the city, your sons and daughters shall fall by the sword, your land shall be divided up and given to others, and you yourself shall die in a foreign land, for Israel shall be driven far from its land.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Yahweh showed me a basket of ripe fruit"
,"2":"and asked, 'Amos, what do you see?' I replied, 'A basket of ripe fruit.',Then Yahweh said to me, 'My people Israel is ripe for destruction; I will no longer forgive them. "
,"3":"The songs of the palace will become wailings on that day, says the Lord. Heaps of corpses everywhere, all cast out in silence.'"
,"4":"Hear this, you who trample on the needy to do away with the weak of the land."
,"5":"You who say, 'When will the new moon or the sabbath feast be over that we may open the store and sell our grain? Let us lower the measure and raise the price; let us cheat and tamper with the scales,"
,"6":"and even sell the refuse with the whole grain. We will buy up the poor for money and the needy for a pair of sandals.'"
,"7":"Yahweh, the pride of Jacob, has sworn by himself, 'I shall never forget their deeds.'"
,"8":"Shall not the land tremble because of this, and all who dwell in it mourn, while it rises up and heaves like the Nile and settles back again like the river of Egypt?"
,"9":"Yahweh says, 'On that day I will make the sun go down at noon and darken the earth in broad daylight."
,"10":"I will turn your festivals into mourning and all your singing into wailing. Everyone will mourn, covered with sackcloth and every head will be shaved. I will make them mourn as for an only son and bring their day to a bitter end.'"
,"11":"Yahweh says, 'Days are coming when I will send famine upon the land, not hunger for bread or thirst for water, but for hearing the word of Yahweh."
,"12":"Men will stagger from sea to sea, wander to and fro, from north to east, searching for the word of Yahweh, but they will not find it."
,"13":"On that day, fair virgins and strong young men will faint from thirst,"
,"14":"all the young people who swore by the god of Samaria and said: Long life to the god of Dan, long life to the god of Bersheba! They shall fall, never to rise again.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"I saw the Lord standing by the altar, and he said, 'Strike the top of the columns, so that the beams shake and the roof falls down on the heads of them all. Those who are left I will slay with the sword; not one shall flee, not one shall escape."
,"2":"Though they dig down to the netherworld, my hand will take them from there; though they climb up to heaven, I will bring them down from there;"
,"3":"Though they hide on the top of Carmel, I will search them out there and take them; though they hide from me in the depths of the sea, I will bid the sea serpent bite them."
,"4":"When they are led into captivity by their enemies, there I will command the sword to slay them. For I have set my eye upon them, not for help but for harm.'"
,"5":"When Yahweh of hosts touches the earth, it melts and all who dwell on it mourn. The earth rises up and heaves like the Nile and settles back again like the river of Egypt."
,"6":"He has built heaven, his upper room, and established the dome of the sky over the earth. He summons the waters of the sea and pours them upon the face of the earth: Yahweh is his name."
,"7":"And now Yahweh says, 'Are you Israelites more to me than the Ethiopians? Did I not bring Israel up from the land of Egypt as I brought the Philistines from Caphtor and Aram from Kir?"
,"8":"My eyes are upon your sinful kingdom. I wanted to destroy it from the face of the earth, but I cannot do away completely with the nation of Jacob,' says Yahweh."
,"9":"'This is what I have ordered: I will sift the nation of Israel among the nations as one sifts with a sieve, letting no pebble pass through."
,"10":"All sinners among my people shall die, those who say, 'Evil will not reach or overtake us.'"
,"11":"On that day I shall restore the fallen hut of David and wall up its breaches and raise its ruined walls and so build it as in days of old."
,"12":"They shall conquer the remnant of Edom and the neighboring nations upon which my name has been called.' Thus says Yahweh, the one who will do this."
,"13":"Yahweh says also, 'The days are coming when the plowman will overtake the reaper and the treader of grapes overtake the sower. The mountains shall drip sweet wine and all the hills shall melt."
,"14":"I shall bring back the exiles of my people Israel; they will rebuild the desolate cities and dwell in them. They will plant vineyards and drink their wine; they will have orchards and eat their fruit."
,"15":"I shall plant them in their own country and they shall never again be rooted up from the land which I have given them,' says Yahweh your God."
}`)

}
func EN_CCB_LoadVNHAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"These are the message and the vision of Habakkuk, the prophet."
,"2":"Yahweh, how long will I cry for help while you pay no attention to me? I denounce the oppression and you do not save."
,"3":"Why do you make me see injustice?,Are you pleased to look on tyranny? All I see is outrage, violence and quarrels."
,"4":"That is why the Law has been put aside and just decrees are no longer issued. The wicked overrule the upright and they get crooked sentences."
,"5":"Look, traitors, and pay attention; be amazed and astounded, for I am going to do in your own days, something that you would not believe if you were told it."
,"6":"I am going to call the Chaldeans, that terrifying and violent people who raid to the ends of the earth, to seize the lands of others."
,"7":"I call a terrible and dangerous nation who obey no other law but their own will."
,"8":"Their horses are speedier than leopards, fiercer than wolves on the plain; their riders gallop on and come from afar, they swoop like the eagle descending on its prey."
,"9":"When they launch themselves for an attack, pushed forward by the desert wind, they round up prisoners like sand."
,"10":"This people makes fun of kings and laughs at princes; they make light of fortified cities, for they build up an embankment and seize them."
,"11":"Thus they come and go like the wind! Their strength is their god!"
,"12":"But you, are you not Yahweh from past ages? You, my holy God, you cannot die. You have set this people to serve your justice and you have made them firm as a rock to fulfill your punishment."
,"13":"Yahweh, your eyes are too pure to tolerate wickedness and you cannot look on oppression. Why, then, do you look on treacherous people and watch in silence while the evildoer swallows up one better than himself?"
,"14":"You treat human beings like the fish in the sea, like reptiles who are nobody's concern."
,"15":"This nation catches all on its hook, pulls them out with its net and piles them up in its dragnet."
,"16":"Pleased and delighted at their catch, they offer sacrifices to their net and burn incense to their dragnets, since these supplied them with fish in plenty and provided them with food in abundance."
,"17":"Will they continue, then, to constantly empty their nets, slaughtering nations without mercy?"
}`)
	CurrentBook.AddChapter(2, `{
"1":"I will stand in my watchtower and take up position on my battlements; I will see what he replies, if there is an answer to my question."
,"2":"Then Yahweh answered me and said, 'Write down the vision, inscribe it on tables so it can be easily read, "
,"3":"since this is a vision for an appointed time; it will not fail but will be fulfilled in due time. If it delays, wait for it, for it will come and will not be deferred. Look:"
,"4":"I don't look with favor on the one who gives way; the upright, on the other hand, will live by his faithfulness.'"
,"5":"The grasping conqueror is always ready to devour, he enlarges his mouth like the netherworld; he is as insatiable as death, he seizes on all the nations and monopolizes all the peoples for himself."
,"6":"But will not all the people mock him, as with one voice? Will they not write fierce satires to show him up? They will say, Woe to him who amasses what is not his and fills himself with extorted pledges. "
,"7":"Your creditors will come suddenly, your money collectors will waken and take away all your goods."
,"8":"Since you have plundered so many nations, shedding blood, stripping the land, their cities and homes, all the remaining nations will turn on you."
,"9":"Woe to him who raises his house on unjust profits and fixes his nest so high that he thinks he can thereby escape misfortune!"
,"10":"You have willed the disgrace of your house; you draw evil on your own head."
,"11":"The very stones of your walls cry out against you and the rafters reply from the roof."
,"12":"Woe to the one who builds a city on bloody foundations and sets up a town by means of evil."
,"13":"Has Yahweh of hosts not willed that the work of the nations go to the fire and the peoples toil for nothing?"
,"15":"Woe to him who gives drink to his neighbors and drugs them to make them drunk so that everyone looks at their nakedness."
,"16":"This will bring you more shame than glory. You will also drink and uncover your foreskin. The cup turns over in Yahweh's hand and pours out onto you: disgrace will swallow your glory."
,"17":"The violence you did in Lebanon will befall you and the animals will devour you, since you slaughtered human beings, destroyed the country with its cities and put an end to all who lived there."
,"18":"What use is a statue? Why do the sculptors make them? Why these images and deceiving answers? Why do their makers trust them and produce mute idols?"
,"19":"Woe to the one who says to a piece of wood, 'Wake up,' and to a dumb stone, 'Get up.' Can it give any answer? For, even though it is plated with gold and silver, there is not a single breath of life in it."
,"20":"But Yahweh lives in his holy Temple: let the whole earth be silent before him!"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Prayer of Habakkuk, the prophet. To the tune of a dirge."
,"2":"I have heard, Yahweh, of your renown; I stand in awe of your work, O Yahweh. In the middle of years make it known; in your wrath even, remember mercy."
,"3":"God comes from Teman, the Holy One from Mount Paran. His glory shrouds the heavens, his praise fills the earth,"
,"4":"his splendor is like the daylight,with rays flashing from his hand, radiating from his hidden power."
,"5":"Pestilence goes before him, plague follows close behind."
,"6":"He stands and the earth sways; he looks and the nations tremble. The ancient mountains crumble, the time-honored hills collapse."
,"7":"I saw the tents of Cushan in distress, the pavilions of Midian in anguish."
,"8":"Was your anger against the rivers, Yahweh?,Was your wrath against the sea,that you drive your steeds,with your invincible chariots?"
,"9":"You bare and ready your bow,and set upon it your arrow. With rivers you cleave the earth."
,"10":"At your sight the mountains writhe. Torrents of water ragingly sweep by, the deep roaring, lifting its waves high."
,"11":"The sun and moon stood still,at the glint of your flying arrows, at the gleam of your flashing spears."
,"12":"You stride the earth in wrath, you trample the nations in rage."
,"13":"You came out to redeem your people, to save your anointed one -,you crush the head of the wicked, you lay him bare from head to foot."
,"14":"You pierce with your shafts his warriors who came like a whirlwind to scatter us in joy, to devour the wretched quietly."
,"15":"You trample the waters with your horses, amid the churning of the great seas."
,"16":"I heard and my heart pounded, my lips quivered at the sound. Decay crept into my bones; my legs tottered under my body. Yet I wait confidently for the day of distress, when we face the people coming against us."
,"17":"For though the fig trees blossom not, nor grapes be on the vines, though the olive crop fail,and the fields produce no food, though the flock be lost from the fold, and the herd be gone from the stalls,"
,"18":"yet in Yahweh will I rejoice, in God my savior will I exult."
,"19":"My Lord Yahweh is my stronghold; he makes my feet as fleeting as the hinds; he steadies my steps upon the heights. For the choirmaster: with stringed instruments."
}`)

}
func EN_CCB_LoadVNILChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"This is the word of Yahweh that came to Joel, son of Pethuel. The attack of the locusts"
,"2":"Hear this, you elders!,Listen, all you, land dwellers!,Has such happened in your days or in the days of your fathers? "
,"3":"Tell it to your children, then your children to their children, and then their children to the next generation."
,"4":"What the cutting locusts left, the swarming locusts ate. What the swarming locusts left, the hopping locusts ate. What the hopping locusts left, the destroying locusts ate."
,"5":"Wake up, drunkards, and weep! Wail, drinkers of wine, because of the sweet wine withheld from your mouths."
,"6":"A nation numerous and mighty has invaded my country. It has the teeth of a lion and the fangs of a lioness. "
,"7":"It has destroyed my vines and ruined my fig trees. It has stripped off their bark and left white their branches."
,"8":"Mourn like a virgin in sackcloth, grieving for the husband of her youth."
,"9":"Grain and drink offerings are not found in the House of Yahweh. The priests who minister before Yahweh are in mourning."
,"10":"The fields are in ruin, the earth mourns, for the grain is destroyed; the wine fails and the oil dries up."
,"11":"Grieve, O you farmers; wail, O you vine growers, over the barley and the wheat, for the harvest of the field has perished."
,"12":"The vine withers, the fig tree wilts away; pomegranate, palm and apple - all the trees of the field dry up. Oh, how joy has faded away among all these people!"
,"13":"Gird yourselves, O priests, and weep; mourn, O ministers of the altar. Come, spend the night in sackcloth, O ministers of my God! For the house of your God is deprived of grain and drink offering."
,"14":"Proclaim a fast, call an assembly. Summon the elders and all who live in the land into the house of your God, and cry out to Yahweh, "
,"15":"'What a dreadful day - the day of Yahweh that draws near and comes as ruin from the Almighty!'"
,"16":"Has not the food been taken away from us before our very eyes, and joy and gladness too from the house of our God?"
,"17":"The seed under the clods lies shriveled; the granaries are in ruins, the barns are broken down, for the harvest has dried up."
,"18":"How the cattle groan! The herds wander and moan, for they have no pasture. Even the flocks of sheep suffer."
,"19":"To you, Yahweh, I call. Fire has razed the open pasture; flames have burned the trees."
,"20":"Even wild beasts cry out to you for the streams have dried up, for the pastures have been devoured by fire."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Blow the trumpet in Zion, sound the alarm on my holy mountain! Let all dwellers in the land tremble, for the day of Yahweh is coming. Yes, the day is fast approaching - "
,"2":"a day of gloom and darkness, a day of clouds and blackness. A vast and mighty army comes, like dawn spreading over the mountain, such as has never occurred before nor will happen again in the future."
,"3":"In front a fire devours, behind a flame consumes. The land ahead that appears like a garden soon becomes like a desert, nothing escapes their onslaught."
,"4":"They look like horses, they gallop along like chargers."
,"5":"With the clattering of chariots, they leap over the mountains; with crackling like burning stubble, they charge - a mighty army arrayed for battle."
,"6":"Before them nations are appalled, and every face turns pale."
,"7":"They attack like warriors; they scale walls like soldiers. Marching in line, they move onward,without swerving from their course,"
,"8":"without jostling one another, everyone of them marches straight ahead; amid a hail of arrows they run, they press without breaking ranks."
,"9":"They rush upon the city; they leap over the walls; they break into the houses, like thieves enter through the windows."
,"10":"Before them the earth shakes,and the heavens tremble, the sun and moon grow dark,and the stars lose their twinkle."
,"11":"Yahweh thunders before his army, his vast and mighty forces. The day of Yahweh is exceedingly great, terrible and dreadful - who can endure it?"
,"12":"Yahweh says, 'Yet even now, return to me with your whole heart, with fasting, weeping and mourning."
,"13":"Rend your heart, not your garment. Return to Yahweh, your God - gracious and compassionate.',Yahweh is slow to anger, full of kindness, and he repents of having punished."
,"14":"Who knows? Probably he will relent once more and spare some part of the harvest from which we may bring sacred offerings to Yahweh, your God."
,"15":"Blow the trumpet in Zion, proclaim a sacred fast, call a solemn assembly."
,"16":"Gather the people, sanctify the community, bring together the elders, even the children and infants at the breast. Let the bridegroom leave his bed, and the bride her room."
,"17":"Between the vestibule and the altar, let the priests, Yahweh's ministers, weep and say: Spare your people, Yahweh. Do not humble them or make them an object of scorn among the nations. Why should it be said among the peoples: Where is their God?"
,"18":"Yahweh has become jealous for his land; he has had pity on his people."
,"19":"Yahweh has given an answer; he says to them, 'I am sending you grain, new wine and oil which will fully satisfy you; never again will you be scorned by the nations."
,"20":"I will drive far from you the enemy from the North and pursue him towards a land of drought and desolation: his vanguard to the Eastern Sea, his rearguard to the Western Sea. Its stench will rise everywhere. See that I do great things.'"
,"21":"Fear not, O earth! exult and rejoice for Yahweh has acted magnificently!"
,"22":"Do not be afraid, beasts of the field, for the desert prairies are green again, the trees are with fruit, the fig tree and the vine have yielded their riches."
,"23":"Sons of Zion, be glad! Rejoice in Yahweh your God, for he has sent you the blessing of autumn rain and showers - the autumn and spring rains as in the past."
,"24":"The threshing-floors will be full of grain, the vats overflowing with new wine and oil."
,"25":"I will compensate you for the years devastated by grasshoppers, may-bugs, crickets and locusts - the powerful army I sent against you."
,"26":"You will eat and be satisfied, and you will praise the name of Yahweh, your God, who has done wonders for you."
,"27":"And then you will know that I am in the midst of Israel, I, Yahweh your God, no other! Never again will my people be shamed."
}`)
	CurrentBook.AddChapter(3, `{
"1":"In the last days, I will pour out my Spirit on every mortal. Your sons and daughters will prophesy, your old men will dream dreams, your young men will see visions."
,"2":"Even upon my servants and maidens, I will pour out my Spirit on that day."
,"3":"I will show wonders in the heavens, and on earth blood and fire and columns of smoke."
,"4":"The sun will darken and the moon turn to blood,at the approach of the great and dreadful day of God."
,"5":"Then all who call upon the name of Yahweh will be saved. For on Mount Zion there will be a remnant, as Yahweh has said; in Jerusalem some will be saved -,those whom Yahweh will call."
}`)
	CurrentBook.AddChapter(4, `{
"1":"In those days and at that time when I reestablish Judah and Jerusalem,"
,"2":"I shall let all the nations gather together and come to the Valley of Jehoshaphat. Then I shall uphold against them the cause of Israel, my people and my heritage. For they have dispersed them among the nations and divided my land."
,"3":"They cast lots for my people; they gave a boy for a harlot, and a girl for the wine they drank."
,"4":"And you Tyre and Sidon, and all the districts of Philistia, what are you for me? Will you take revenge on me? If you want to do that, swiftly and immediately will I take reprisals against you!"
,"5":"You who carried off my silver and gold and my finest jewelry to your temples!"
,"6":"You sold to the Greeks the people of Judah and Jerusalem removing them far away from their own land."
,"7":"But now I am going to summon them from wherever you sold them, and I will return your deed on your head."
,"8":"Yahweh says: I will sell your sons and daughters to,the Judeans who will then sell them to the Sabaeans in a distant land."
,"9":"Make this known among the nations, proclaim the holy war, call the warriors, let men of war advance!"
,"10":"Hammer your plowshares into swords, your sickles into spears! Let the weak say: I am a warrior! And the meek: I too will fight!"
,"11":"Come quickly, neighboring nations, and assemble!"
,"12":"Rise up, O peoples, and come to the Valley of Jehoshaphat, nations."
,"13":"Bring a sickle for the harvest is ripe; come and tread for the winepress is full and the vats overflow, so great is their wickedness!"
,"14":"Multitudes and more multitudes in the Valley of Verdict! The day of Yahweh is near in the Valley of Verdict!"
,"15":"The sun and the moon become dark, the stars lose their radiance."
,"16":"Yahweh roars from Zion and raises his voice from Jerusalem; heaven and earth are shaken. Indeed Yahweh is a refuge for his people, a stronghold for the sons of Israel."
,"17":"You will know that I am Yahweh, your God, dwelling on Zion, my holy mountain. Jerusalem will be a holy place, and foreigners will never pass through there again."
,"18":"On that day the mountains shall drip wine and the hills flow with milk; all the streams of Judah will run with water and a fountain will spring from the House of Yahweh, and water the valley of Shittim."
,"19":"On the other hand, Egypt will be devastated and Edom will become a deserted wasteland because they committed violence against Judah, and shed innocent blood in their country."
,"20":"But Judah will be inhabited forever, and Jerusalem through all generations."
,"21":"And I shall avenge their blood and not leave it unpunished, for Yahweh dwells in Zion."
}`)

}
func EN_CCB_LoadVNINChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"The word of Yahweh came to Jonah, son of Amittai,"
,"2":"'Go to Nineveh, the great city, and preach against it, because I have known its wickedness.'"
,"3":"But Jonah decided to flee from Yahweh and go to Tarshish. He went down to Joppa, found a ship bound for Tarshish, and paid the fare. Then he boarded it and went into the hold of the ship, journeying with them to Tarshish, far away from Yahweh."
,"4":"Yahweh stirred up a storm wind on the sea, so there was a sea tempest, which threatened to destroy the ship."
,"5":"The sailors took fright, and each cried out to his own god. To lighten the ship, they threw its cargo into the sea."
,"6":"Meanwhile Jonah had gone into the hold of the ship, where he lay fast asleep. The captain came upon him and said, 'How can you sleep? Get up and call on your god. Perhaps he will be mindful of us and will not allow us to die here.'"
,"7":"The sailors said to each other, 'Let us cast lots to find out who is responsible for this disaster.' So they did, and the lot fell on Jonah."
,"8":"They questioned him, 'So you are responsible for this evil that has come upon us? Tell us where you are from. What is your country, your nationality?'"
,"9":"And Jonah told them his story, 'I am a Hebrew and I worship Yahweh, God of heaven who made the sea and the land...'"
,"10":"As they knew that he was fleeing from Yahweh, the sailors were seized with great fear and said to him, 'What a terrible thing have you done!'"
,"11":"'What shall we do with you now to make the sea calm down?' The sea was growing more and more agitated."
,"12":"He said to them, 'Pick me up and throw me into the sea. It will quiet down, for I know it is because of me that this storm has come.'"
,"13":"The sailors, however, still did their best to row back to land. But they could not, for the sea had grown much rougher than before."
,"14":"Then they called on Yahweh, 'O Yahweh, do not let us perish for taking this man's life. Do not hold us guilty of shedding innocent blood. For you, Yahweh, have done this as you have thought right.'"
,"15":"They took Jonah and threw him overboard, and the raging sea grew calm again."
,"16":"At this the men were seized with great fear of Yahweh. They offered a sacrifice to Yahweh and made vows to him."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Yahweh provided a large fish which swallowed Jonah. He remained in the belly of the fish for three days and three nights."
,"2":"From the belly of the fish Jonah prayed to Yahweh, his God:"
,"3":"'In my distress I cried to Yahweh, and he answered me; from the belly of the netherworld,you heard my voice when I called."
,"4":"You cast me into the abyss, into the very heart of the sea, and the currents swirled about me; all your breakers and your billows,passed over engulfing me."
,"5":"Then I thought: I have been cast out from your presence, but I keep on looking to your holy Temple."
,"6":"The waters engulfed me up to my throat; all around me was the abyss; wrapped about my head were seaweeds."
,"7":"I went down to the roots of the mountains, the bars of the netherworld closed upon me, but you brought my life up from the pit, Yahweh, my God."
,"8":"When my soul was fainting within me, I remembered Yahweh, and before you rose my prayer,up to your holy Temple."
,"9":"Those who worship worthless idols,lose your grace"
,"10":"but I, with songs of praise, will offer to you sacrifices. What I have vowed, I will make good -,deliverance comes from Yahweh, my God.'"
,"11":"Then Yahweh gave his command to the fish, and it belched out Jonah onto dry land."
}`)
	CurrentBook.AddChapter(3, `{
"1":"The word of Yahweh came to Jonah a second time:"
,"2":"'Go to Nineveh, the great city, and announce to them the message I give you.'"
,"3":"In obedience to the word of Yahweh, Jonah went to Nineveh. It was a very large city, and it took three days just to cross it."
,"4":"So Jonah walked a single day's journey and began proclaiming, 'Forty days more and Nineveh will be destroyed.'"
,"5":"The people of the city believed God. They declared a fast, and all of them, from the greatest to the least, put on sackcloth."
,"6":"Upon hearing the news, the king of Nineveh got up from his throne, took off his royal robe, put on sackcloth and sat down in ashes."
,"7":"He issued a proclamation throughout Nineveh: 'By the decree of the king and his nobles, no people or beasts, herd or flock, will taste anything; neither will they eat nor drink. "
,"8":"But let people and beasts be covered with sackcloth. Let everyone call aloud to God, turn from his evil ways and violence."
,"9":"Who knows? God may yet relent, turn from his fierce anger and spare us.'"
,"10":"When God saw what they did and how they turned from their evil ways, he had compassion and did not carry out the destruction he had threatened upon them."
}`)
	CurrentBook.AddChapter(4, `{
"1":"But Jonah was greatly displeased at this, and he was indignant."
,"2":"He prayed to Yahweh and said, 'O Yahweh, is this not what I said when I was yet in my own country? This is why I fled to Tarshish. I knew that you are a gracious and merciful God, slow to anger and full of love, and you relent from imposing terrible punishment."
,"3":"I beseech you now, Yahweh, to take my life, for now it is better for me to die than to live.'"
,"4":"But Yahweh replied, 'What right have you to be angry?'"
,"5":"Jonah then left the city. He went to a place east of it, built himself a shelter and sat under its shade to wait and see what would happen to Nineveh."
,"6":"Then Yahweh God provided a castor-oil plant and made it grow up over Jonah to give shade over his head and to ease his discomfort. Jonah was very happy about the plant."
,"7":"But the next day, at dawn, God sent a worm which attacked the plant and made it wither."
,"8":"When the sun rose, God sent a scorching east wind; the sun blazed down upon Jonah's head, and he grew faint. His death wish returned and he said, 'It is better for me to die than to live.'"
,"9":"Then God asked Jonah, 'Do you have a right to be angry about the castor-oil plant?' Jonah answered, 'I am right to be angry enough to wish to die.'"
,"10":"Yahweh said, 'You are concerned about a plant which cost you no labor to make it grow. Overnight it sprang up, and overnight it perished."
,"11":"But Nineveh has more than a hundred and twenty thousand people who cannot distinguish right from left and they have many cattle as well. Should I not be concerned for such a great city?'"
}`)

}
func EN_CCB_LoadVNMIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"This is the word of Yahweh which came to Micah of Moresheth during the reigns of Jotham, Ahaz and Hezekiah, kings of Judah. These are his visions concerning Samaria and Jerusalem."
,"2":"Hear all you peoples, let the earth listen and all who are in it. For Yahweh is witnessing against you from his holy temple."
,"3":"Yahweh has come forth from his place, he comes down and treads upon the heights of the earth."
,"4":"Beneath him mountains collapse and valleys melt like wax before the fire, as torrents pouring down the hillside."
,"5":"All this for the crime of Jacob, for the sin of the nation of Judah. What is the crime of Jacob? Is it not Samaria? What is the sin of the nation of Judah? Is it not Jerusalem?"
,"6":"Therefore I will make Samaria a heap of ruins in the open country, a place for planting vineyards. I will scatter her stones down into the valley and lay her foundations bare."
,"7":"All her carved images will be dashed to pieces and her filthy idols burnt by fire. I will make a waste heap of all her idols for they were made with harlot's wages, and to harlot's wages they will return."
,"8":"For this reason I lament and wail, go barefoot and naked. I shall howl like a jackal and wail like an ostrich."
,"9":"For her wound cannot be healed; rather it has come to Judah. It has reached the capital of my people, Jerusalem."
,"10":"Exult not in Gath; break down and weep in Acco. In Beth-leaphra roll in the dust."
,"11":"Sound the bugle, O people of Shaphir and do not let the dwellers in Zaanan come forth. Mourn greatly, Beth Ezel: your treasures are taken away."
,"12":"Surely they trembled, the people in Maroth, when calamity came down from Yahweh to the gates of Jerusalem."
,"13":"Hitch the horses to the chariot, citizens of Lachish. In you the rebellions of Israel were found and because of you Zion began to sin."
,"14":"Therefore you must give a redress to Moresheth-Gath. The houses of Achzib have become deceitful to the kings of Israel."
,"15":"Again I will bring the conqueror to you, people of Maresha, and the elite of Israel will leave forever."
,"16":"Shave your hair for your delightful children. Make yourself bald as an eagle for they have been deported far from you."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Woe to those who plot wickedness and plan evil even on their beds! When morning comes they do it, as soon as it is within their reach."
,"2":"If they covet fields, they seize them. Do they like houses? They take them. They seize the owner and his household, both the man and his property."
,"3":"This is why Yahweh speaks, 'I am plotting evil against this whole brood, from which your necks cannot escape. No more shall you walk with head held high for it will be an evil time.'"
,"4":"On that day they will sing a taunting song against you and a bitter lamentation will be heard, 'We have been stripped of our property in our homeland. Who will free us from the wicked who allots our fields.'"
,"5":"Truly, no one will be found in the assembly of Yahweh to keep a field for you."
,"6":"What will you say to that? For there is no reply. Disgrace will not pass away; these words will strike the nation of Jacob."
,"7":"They answer, 'Is the might of Yahweh weakened? Is this his way of working things out? Has he not good words for his people of Israel?'"
,"8":"But it is you who oppress my people and are his enemies. You strip off the garments of those who pass by confidently;"
,"9":"you drive the women of my people from the home they love; you rob my blessing from their children forever."
,"10":"Get up! Away with you! There is no resting place for you here! Because of this uncleanness of yours, you will go roped up."
,"11":"If a deceiver were to come and say, 'I will preach to you of wine and strong drink,' he would be the prophet for this people."
,"12":"I shall assemble you, nation of Jacob, and gather the remnant of Israel. I will bring them together like sheep in a fold, like a flock in its pasture."
,"13":"They have a leader in their midst. See: their king goes before them, Yahweh is heading them!"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Then I said, 'You rulers of the house of Israel, is it not your duty to know what is right?"
,"2":"Yet you hate good and love evil, you tear the skin from my people and the flesh from their bones."
,"3":"Those who eat my people's flesh and break their bones to pieces, who chop them up like meat for the pan and share them like flesh for the pot,"
,"4":"when they cry, Yahweh will not answer. He will hide his face from them because of their evil deeds.'"
,"5":"This is what Yahweh says of the prophets who lead my people astray: You cry: 'Peace' when you have something to eat, but to anyone with nothing for your mouths, it is 'War' that you declare. "
,"6":"So night will come to you without vision, and darkness without divination. Then sun will set for the prophets and the day will be dark for them."
,"7":"Then the seers will be disgraced and the diviners put to shame. They will all cover their faces because no answer will come from God."
,"8":"But as for me, I am filled with might, with the spirit of Yahweh, with justice and courage, to declare to Jacob his transgressions, to Israel his sins."
,"9":"Hear this, leaders of the nation of Jacob, rulers of the house of Israel, you who despise justice and pervert what is right,"
,"10":"you who build Zion with blood and Jerusalem with crime."
,"11":"Her leaders judge for a bribe, her priests prophesy for money, and yet they rely on Yahweh and say, 'Is Yahweh not in our midst? No evil, then, will come upon us.'"
,"12":"Therefore, because of you, Zion will become a field, Jerusalem will be a heap of ruins and the temple mount a forest with sacred stones."
}`)
	CurrentBook.AddChapter(4, `{
"1":"In the last days, the mountain of Yahweh's house shall be set over the highest mountains and will tower over the hills."
,"2":"All the nations will stream to it, saying, 'Come, let us go to the mountain of Yahweh, to the house of the God of Jacob, so he may teach us his ways and we may walk in his paths. For the Teaching comes from Zion and from Jerusalem the word of Yahweh.'"
,"3":"He will rule over the nations and settle disputes for many peoples. They will beat their swords into plowshares and their spears into pruning hooks. Nation will not raise sword against nation; neither will they train for war any more."
,"4":"But each one will sit in peace and freedom under a fig tree or a vine of his own, for the mouth of Yahweh of hosts has spoken."
,"5":"While peoples walk, each in the name of his god, we shall walk in the name of Yahweh, our God, forever and ever."
,"6":"Yahweh declares, 'On that day I will assemble the lame and gather the banished, those whom I have afflicted."
,"7":"I will make the lame a remnant and those driven out a mighty nation. Yahweh will reign over them on Zion from now and forever."
,"8":"As for you, O watchtower of the flock, O city of Zion, city of the king, your former dominion will be restored, the kingdom of the daughter of Jerusalem."
,"9":"Now, why do you wail? Would it be that you have no king and your counselor has perished? Why are you in anguish like a woman in labor?"
,"10":"Writhe and howl, O daughter of Zion, like a woman in labor, for now you must leave the city and camp in the open country. To Babylon you must go; there you shall be rescued and Yahweh will redeem you from the hand of your enemies."
,"11":"But now many nations are massed against you; they say, 'Let Jerusalem be defiled, let our eyes gloat over Zion.'"
,"12":"But they do not know Yahweh's thoughts, nor do they understand his purpose: that he has gathered them like sheaves on the threshing floor."
,"13":"Arise and thresh, O Zion, for I will give you horns of iron and hooves of bronze, and you shall crush many peoples. You shall devote their plundered wealth to Yahweh, their treasures to the Lord of the whole earth."
,"14":"Strengthen the walls of your fortress, for they have laid siege against us. With a rod they want to strike the cheek of Israel's ruler."
}`)
	CurrentBook.AddChapter(5, `{
"1":"But you, Bethlehem Ephrathah, so small that you are hardly named among the clans of Judah, from you shall I raise the one who is to rule over Israel. For he comes forth from of old, from the ancient times."
,"2":"Yahweh, therefore, will abandon Israel until such time as she who is to give birth has given birth. Then the rest of his deported brothers will return to the people of Israel."
,"3":"He will stand and shepherd his flock with the strength of Yahweh, in the glorious Name of Yahweh, his God. They will live safely while he wins renown to the ends of the earth."
,"4":"He shall be peace. When the Assyrian invades our land,and sets foot on our territory, we will raise against him,not one but seven shepherds, eight warlords."
,"5":"They will rule Assyria with the sword, and Babylonia with the bared blade. He will deliver us from the Assyrians,when they come into our land, when they set foot within our borders."
,"6":"Then the remnant of Jacob will be,in the midst of many peoples, like dew dropping down from Yahweh, like showers falling upon the grass. For they do not put their hope in man,or expect anything from mortals."
,"7":"The remnant of Jacob will then be,in the midst of many peoples, like a lion among the beasts of the forest, like a young lion in a flock of sheep, trampling down as it goes, mangling its prey, and no rescuer in sight."
,"8":"May your hand be raised high over your foes, and all your enemies perish."
,"9":"'On that day - Yahweh speaks -,I will drive away your horses; I will wreck your chariots,"
,"10":"I will demolish your cities,and tear down your strongholds."
,"11":"I will do away with your witchcraft,and rid you of soothsayers."
,"12":"I will abolish your carved images, the sacred stones from your midst, so that you no longer worship the work of your hands."
,"13":"I will pull down your sacred poles,and destroy all your idols."
,"14":"In raging fury I will take vengeance,upon the nations that have not obeyed me.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Listen to what Yahweh said to me, 'Stand up, let the mountains hear your claim, and the hills listen to your plea.'"
,"2":"Hear, O mountains, Yahweh's complaint! Foundations of the earth, pay attention! For Yahweh has a case against his people, and will argue it with Israel."
,"3":"'O my people, what have I done to you? In what way have I been a burden to you? Answer me."
,"4":"I brought you out of Egypt; I rescued you from the land of bondage; I sent Moses, Aaron and Miriam to lead you."
,"5":"O my people, remember what Balak, king of Moab, plotted, and what Balaam, son of Beor, answered him. Remember your journey from Shittim to Gilgal, how you have come to know Yahweh's righteous paths.'"
,"6":"'What shall I bring when I come to Yahweh and bow down before God the most high? Shall I come with burnt offerings, with sacrifices of yearling calves?"
,"7":"Will Yahweh be pleased with thousands of rams, with an overabundance of oil libations? Should I offer my firstborn for my sins, the fruit of my body for my wrongdoing?'"
,"8":"'You have been told, O man, what is good and what Yahweh requires of you: to do justice, to love mercy, and to walk humbly with your God."
,"9":"The voice of Yahweh calls to the city, in order to save those who fear his Name.'"
,"10":"'Is there still within you unjust wealth and accursed short measure?"
,"11":"Shall I approve your false scales and your bags of false weights?"
,"12":"O city whose rich are full of violence, whose citizens speak falsehood, men of deceitful tongue!"
,"13":"See, I am striking you a grievous blow, making you desolate because of your sins."
,"14":"You shall eat but not be satisfied and your insides will go on crying. What you overtake, you will not carry off, and those who escape I will hand them over to the sword. "
,"15":"You shall sow but not reap. You shall tread your olives, but not anoint yourselves with the oil. You shall tread the grapes but not drink the wine."
,"16":"You keep the rules of Omri and follow the examples of Ahab's court. So I will give you up to devastation, so that your citizens become an object of derision. You shall bear the scorn of the peoples.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"How I sorrow! For I am like the gatherer of summer fruit, like the gleaner of the vintage, when there are no grapes to eat, none of the early figs I crave."
,"2":"The godly have vanished from the earth and not one upright man is to be found. All lie in ambush to shed blood, one hunts another with a net."
,"3":"Their hands are skilled at doing evil. The official demands a bribe, the judge judges for a price and the mighty decides as he pleases."
,"4":"Their kindness is like a brier, their justice worse than a thorn hedge. But the time of punishment has come, and now is the time of confusion."
,"5":"Do not rely on a friend nor trust an intimate companion. Be guarded in speech with the woman who shares your bed."
,"6":"For son treats father like a fool, daughter rebels against mother, daughter-in-law against mother-in-law. The enemies of each one are those of his household."
,"7":"As for me, I will watch expectantly for Yahweh, waiting hopefully for the God who saves me. My God will hear me."
,"8":"Do not rejoice over me, my enemy; though I have fallen, I will rise again. Though I now dwell in darkness, Yahweh is my light."
,"9":"I will bear the wrath of Yahweh - for I have sinned against him - while he examines my cause and defends my rights. Then he will bring me out to the light and I shall probe his justice."
,"10":"Then my enemy shall also see and shame will cover her. Did she not say, 'Where is Yahweh, your God?' My eyes, then, shall rejoice: See how she is trampled like mud in the street!"
,"11":"The day is coming when your walls will be rebuilt and your boundaries extended."
,"12":"On that day they will come to you from Assyria to Egypt, from Tyre to the Euphrates, from sea to sea and from mountain to mountain,"
,"13":"while the earth will remain desolate because of its citizens and their deeds."
,"14":"Shepherd your people with your staff, shepherd the flock of your inheritance that dwells alone in the scrub, in the midst of a fertile land. Let them feed in Bashan and Gilead"
,"15":"as in the days of old, in the days when you went out of Egypt. Show us your wonders. "
,"16":"On seeing this the nations will be put to shame in the midst of all their might. People will lay their hands upon their mouths and they will not believe the news."
,"17":"They shall lick the dust like snakes, like creatures that crawl upon the ground. They will come trembling out of their strongholds; they will be in fear of you."
,"18":"Who is a god like you, who takes away guilt and pardons crime for the remnant of his inheritance?,Who is like you whose anger does not last? For you delight in merciful forgiveness."
,"19":"Once again you will show us your loving kindness and trample on our wrongs, casting all our sins into the depths of the sea."
,"20":"Show faithfulness to Jacob, mercy to Abraham, as you have sworn to our ancestors from the days of old."
}`)

}
func EN_CCB_LoadVNMLChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"An oracle. These are the words that Yahweh directed to Israel through Malachi."
,"2":"When Yahweh says, 'I love you,' you reply, 'How do you show that love?' So Yahweh asks you,"
,"3":"'Was Esau not Jacob's brother? Yet I loved Jacob and hated Esau. See how I left his mountains desolate and abandoned his land to the jackals of the desert."
,"4":"If Edom decides to rebuild its ruins, after having been destroyed, Yahweh of hosts says: They may rebuild, but I will demolish. You will call them: 'Accursed country' and 'Nation with which Yahweh is forever displeased.'"
,"5":"You will see this with your own eyes, then you will exclaim: The power of Yahweh goes beyond the borders of Israel.'"
,"6":"The son honors his father, the servant respects his master. Now if I am a father, where is the honor due to me? If I am your master, where is your respect for me? This is what Yahweh of hosts wants you to know, priests who despise his name. But you will only ask: How have we despised your name?"
,"7":"You present defiled foods on my altar, yet you say: How did we defile you? You think that my table does not deserve respect."
,"8":"When you bring a blind animal as a sacrifice, or when you present one that is lame or sick, are you not doing wrong? Go, present these to the governor; will he be pleased and receive you well?' says Yahweh of hosts."
,"9":"So now, ask God that he may have mercy on us. But if it goes badly for us because of your sin, are you those who should entreat him?"
,"10":"Who among you would close my doors that you may no longer come to kindle fire upon my altar in vain? I am not pleased with you, says Yahweh of hosts, nor am I pleased with your offerings."
,"11":"See, from the rising of the sun to its setting, all the nations revere my Name and everywhere incense is offered to my Name as well as a pure offering. I am rightly esteemed among the nations, says Yahweh of hosts."
,"12":"But you despise my Name when you say: 'The Lord's table is dirty and his food is good for nothing.'"
,"13":"When you complain that you do not like this food you despise me, says Yahweh. You bring a stolen animal, lame or diseased, to offer to me in sacrifice. Do you think that I will accept it?"
,"14":"Cursed be the cheater who, after promising me a bull from his herd, sacrifices a stunted animal. For I am a great King and my Name is respected through all the nations, says Yahweh of hosts."
}`)
	CurrentBook.AddChapter(2, `{
"1":"This warning is also for you, priests. If you do not listen to it"
,"2":"or concern yourself to glorify my Name, says Yahweh of hosts, I will send the curse on you and curse even your blessings."
,"3":"I will curse you for none of you takes his ministry seriously. Right now, I am going to break your arm, throw dung in your face, the very dung of your animals, and sweep you away with them."
,"4":"And you will realize that it was I who threatened to put an end to my covenant with Levi, your ancestor, says Yahweh."
,"5":"My covenant with him spoke of life and peace, and I gave him these; it also spoke of respect and he respected me and reverenced my Name."
,"6":"His mouth taught the true doctrine and nothing evil came from his lips; he walked in accord with me, being peaceful and upright, and brought back many people from their wickedness."
,"7":"The lips of the priest speak of knowledge, and the Law must be found in his mouth, since he is the messenger of Yahweh of hosts."
,"8":"But you, says Yahweh of hosts, have strayed from my way, and moreover caused many to stumble because of your teaching. You have broken my covenant with Levi."
,"9":"Therefore I let all the people despise you and consider you unworthy, because you do not follow my ways and you show partiality in your judgments."
,"10":"Do we not all have the same father? Has the same God not created all of us? Why, then, does each of us betray his brother, defiling the Covenant of our ancestors?"
,"11":"Judah has been unfaithful, a grave sin has been committed in Israel and Jerusalem: the people of Judah have defiled the sacred inheritance of Yahweh by loving and marrying the daughters of a foreign god."
,"12":"Let whoever does this be cut off from the homeland of Jacob and let there be no one to defend him in the tribunal or present an offering for him to Yahweh."
,"13":"You also commit another offense. As Yahweh refuses to look at your offerings and does not take them into account, you come weeping and wailing and cover the altar with tears."
,"14":"And then you ask: 'Why?',It is because Yahweh has seen how you dealt with your first wife, the wife of your youth. You betrayed her although she was your companion with whom you made a covenant. "
,"15":"Has God not made a single being and given him breath? And what does he seek but a family given by God? Do not betray, then, the wife of your youth."
,"16":"I hate divorce, says Yahweh, the God of Israel, and those who are actually covering their violence. Be very careful, and do not betray."
,"17":"You annoy Yahweh with your discourses and you dare say: 'How did we annoy him?' You annoy him whenever you say that Yahweh looks favorably on those who do evil, and lets everything go well with them, or when you ask: 'Where is the God who does justice?'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Now I am sending my messenger ahead of me to clear the way; then suddenly the Lord for whom you long will enter the sanctuary. The envoy of the covenant which you so greatly desire already comes, says Yahweh of hosts."
,"2":"Who can bear the day of his coming and remain standing when he appears? For he will be like fire in the foundry and like the lye used for bleaching."
,"3":"He will be as a refiner or a fuller. He will purify the sons of Levi and refine them like gold and silver. So Yahweh will have priests who will present the offering as it should be."
,"4":"Then Yahweh will accept with pleasure the offering of Judah and Jerusalem, as in former days."
,"5":"When I came to you to do justice I shall demand the immediate punishment of the sorcerers and the adulterers, of those who swear false oaths, who oppress the wage-earner, the widow and the orphan, who do not respect the rights of the foreigner. They do all this and have no fear of me, says Yahweh."
,"6":"I, Yahweh, have not changed in anything; just as you, children of Jacob, are always the same."
,"7":"Since the day of your ancestors you stray from my ordinances and do not practice them. Return to me and I will return to you, says Yahweh of hosts. But you ask: 'Why do we have to return?'"
,"8":"Can a man deceive God? Yet you cheat me and moreover ask: 'How did we cheat you?' I point out your sacred tributes and the tenth which is due to me."
,"9":"Cursed be you who cheat me! Cursed be all the nation!"
,"10":"Turn over into the temple treasury the tenth part of all, that there may be food in my House. Then you may test me says Yahweh of hosts, to see if I will not open the gates of heaven and bring blessed rain to you up to the last drop."
,"11":"I will rebuke the locusts that they may not devour your fields, and let not the vines wither in your land, says Yahweh."
,"12":"Then all the nations will congratulate you because your land will be the choicest."
,"13":"You say very harsh things about me, says Yahweh, and yet you say: 'What harsh things did we say against you?'"
,"14":"You say: 'It is useless to serve God. There is no benefit in observing his commandments or in leading an austere life for his sake. Happy are the shameless!"
,"15":"Those who do evil succeed in everything; though they provoke God, they remain unharmed.'"
,"16":"Those were the very words of those who fear Yahweh. Yahweh listened and heard what they said. He ordered at once that the names of those who respect him and reverence his Name be written in a record."
,"17":"And he declared, 'They will be mine on the,day I have already set. Then I shall care for them as a father cares for his obedient son. "
,"18":"And you will see the different fates of the good and the bad, those who obey God and those who disobey him."
,"19":"The day already comes, flaming as a furnace. On that day all the proud and evildoers will be burned like straw in the fire. They will be left without branches or roots."
,"20":"On the other hand the sun of justice will shine upon you who respect my Name and bring health in its rays. You will come out leaping like fattened calves."
,"21":"You will trample on the evildoers and they will be like ashes scattered on your way when I do this, says Yahweh."
,"22":"Remember the law of my servant Moses, the laws and ordinances I gave him at Mount Horeb for the whole of Israel."
,"23":"I am going to send you the prophet Elijah before the day of Yahweh comes, for it will be a great and terrible day."
,"24":"He will reconcile parents with their children, and the children with their parents, so that I may not have to curse this land when I come.'"
}`)

}
func EN_CCB_LoadVNNHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Oracle against Nineveh. This is the book of the vision which Nahum of Elkosh has seen."
,"2":"Yahweh is a jealous and avenging God, Yahweh takes vengeance in his wrath;"
,"3":"Yahweh is slow to anger,though immense in power. He does not overlook the evil. In storm and whirlwind is his path; clouds are the dust of his feet."
,"4":"He rebukes the sea and dries it; he drains rivers of their water. Bashan and Carmel wither; the blossoms of Lebanon fade."
,"5":"Before him the mountains quake,and the hills melt; the earth trembles,and all the peoples."
,"6":"Who can stand before his fury?,Who can face his blazing anger?,His wrath is poured out like fire, and the rocks are rent asunder."
,"7":"Yahweh is good for those who hope; in the day of trouble he shelters them. He remembers those who trust in him"
,"8":"when the flood engulfs them. He utterly destroys his adversaries,and pursues his foes into darkness. What are you plotting against him?,Yahweh will bring it to an end,"
,"9":"oppression will not rise a second time. Yahweh gives his foe no quarter, he stores up fury for his enemy."
,"10":"They will be entangled,devoured like thorns, and be consumed like dry stubble."
,"11":"Yahweh will take off Juda his enemy,the one who plots evil."
,"12":"Thus Yahweh says to Judah: 'Though they be strong and many,they will be annihilated. Though I had afflicted you, no more shall I afflict you."
,"13":"I will break their yoke from your neck,and tear away your shackles.'"
,"14":"To the people of Nineveh, here is Yahweh's decree. 'No descendants shall bear your name. I will abolish from your temple,the carved image and the molten idol. I will make your tomb an object of shame.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"See, there on the mountains, the feet of one who brings good news, one who proclaims peace. Judah, celebrate your feasts,and carry out your vows. For the wicked have been destroyed, they will not attack you any more."
,"3":"Yahweh will now restore,Jacob's magnificence, like Israel's splendor. For they had been plundered, laid waste as a ravaged vineyard. Nineveh shall fall"
,"2":"Against Nineveh a destroyer advances. Watch the road, man the fortress; brace yourselves, muster your forces."
,"4":"The shields of his soldiers are red; his warriors are crimson-clad. His chariots gleam as if on fire,when mustered in battle array, while prancing horses and frenzied horsemen,wait impatiently for bloody action."
,"5":"As chariots storm through the streets,and dash madly through the squares, they look like flashing torches,or darting lightning bolts."
,"6":"The picked troops are called out; ranks break at their charge. Having set up the mantelet,they rushed toward the rampart."
,"7":"The river gates are thrown open, and the palace defense collapses."
,"8":"The goddess is taken captive,together with all her handmaids, moaning like doves and beating their breasts."
,"9":"Nineveh looks like a pool,with its waters running away: All flee: 'Stop, stop!',but no one comes back."
,"10":"All kinds of wealth, gold and silver -,it is an endless treasure, a heap of the most precious things."
,"11":"Waste and ruin, desolation and emptiness, failing hearts and trembling knees, terror and agony on all blanched faces!"
,"12":"Where now is the lion's cave, the den of the cubs,where the lion would bring his prey, and the cubs lie down undisturbed?"
,"13":"The lion tore to pieces for his whelps, and strangled for his mates; he filled his caves with prey,and his dens with mangled flesh."
,"14":"Yahweh Sabaoth speaks: I have come against you. I will send up your chariots in smoke, give your cubs to the sword; wipe the earth clear of your plunder, and your envoys' voices will be heard no more."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Woe to the bloody city, city of lies and booty, O city of unending plunder!"
,"2":"But what! Crack of whips, rumble of wheels and clatter of hoofs!"
,"3":"See the frenzied chargers, the flashing swords and glittering spears, the heaps of the wounded, the dead and dying,- we trip over corpses!"
,"4":"The harlot is paying for her harlotries, her deadly charms, her sorceries. She traded nations with her prostitutions,and caught peoples by her spells."
,"5":"'I am against you,' Yahweh Sabaoth says. 'I will lift your skirts over your face. I will show the nations your nakedness,and the kingdoms your disgrace."
,"6":"I will pelt you with filth, I will treat you with contempt,and make of you a shameful show,"
,"7":"so that all who look on you,will turn their backs in disgust,and say: Nineveh - a city of lust - is in ruins. Who will mourn for her?,Where can we find one to comfort her?"
,"8":"Are you any better,than Thebes by the Nile, surrounded by water, her rampart the river, and the water her wall?"
,"9":"Ethiopia and Egypt were her stay, Put and Libya were her allies,"
,"10":"yet she was carried away,and held captive among the exiles. Her infants were dashed to pieces,at the head of every road; lots were cast for her nobles, her great men bound in chains."
,"11":"You, too, shall drink of this: you will also hide from your enemies."
,"12":"Your fortresses are like fig trees,laden with early-ripening fruits,which fall, when shaken, into the waiting mouths."
,"13":"Look at your braves - they are like women!,Your gates are wide open, the bars consumed by fire, and the enemies freely enter."
,"14":"Brace yourselves for the siege: draw water, strengthen the bulwark, tread the clay and the mortar,and repair the brickwork."
,"15":"There the fire will devour you,and the sword will cut you down,though you were numerous as locusts, beyond count like grasshoppers."
,"16":"You had multiplied your merchants,more than the stars of the sky;"
,"17":"like grasshoppers were your officials,and your soldiers like swarms of locusts,which settle on the walls on a cold day. But the sun appears, they fly away and they are gone, no one knows where."
,"18":"O king of Assyria, your shepherds slumber, your nobles lie down fast asleep, while over the mountains your people scatter, and there is no one to gather them up."
,"19":"Nothing can heal your wounds; your injury is fatal. All clap their hands,when they hear about your fall. for who has not suffered constantly,the plague of your cruelty?"
}`)

}
func EN_CCB_LoadVNOSChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"The word of Yahweh was addressed to Hosea son of Beeri, during the reign of Ussiah, Jotham, Ahaz and Hezekiah in Judah, and of Jeroboam son of Joash, in Israel."
,"2":"When Yahweh began to speak through Hosea, the Lord said to him, 'Go, take for your wife a woman involved in sacred prostitution and have children born of prostitution, for the land is wholeheartedly lapsing into prostitution and turning away from Yahweh.'"
,"3":"So he married Gomer, daughter of Diblaim. And she was with child and bore a son."
,"4":"Yahweh told him, 'Name him Jezreel, for I will soon punish the family of Jehu for the massacre at Jezreel. I will put an end to the kingdom of Israel."
,"5":"The days are coming when Israel will be defeated in the Valley of Jezreel.'"
,"6":"Gomer was again with child and gave birth to a daughter. Yahweh said to Hosea, 'Name her Unloved, for I will have no more love for the nation of Israel, nor will I forgive them.'"
,"8":"After weaning Unloved, Gomer was with child again and had another son."
,"9":"Yahweh said, 'Name him Not-my-people, for you are not my people, nor AM - I for you.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Yet the people of Israel shall be like the sand of the sea, that cannot be measured or counted. In the place where it was said to them, 'You are not my people,' they shall be called 'sons of the living God.'"
,"2":"The people of Judah and the people of Israel will be reunited, they will appoint one leader to rule over them, and they will come up out of the land. For there will be a great victory in Jezreel."
,"3":"You will call your brothers My-people, and your sisters My-loved-ones."
,"4":"Denounce your mother, denounce,- for she is not my wife, nor am I her husband. Let her rid her face of her ornaments,and her breasts of her lewd idols;"
,"5":"or I will strip her naked,as on the day of her birth; I will reduce her to an arid land, making of her a desert -,I will let her die of thirst."
,"6":"How could I love her children?,They are children of adultery;"
,"7":"their mother has played the harlot,they are children of debauchery. She said, 'I will go after my lovers, who give me my bread and water, my wool and my flax, my oil and my drink.'"
,"10":"Yet she would not acknowledge that it was I,who gave her the grain, the wine and the oil, and the silver and gold,with which this people made their Baals."
,"11":"So I will take back my grain when it ripens,and my new wine when it is ready; I will take back my wool and my flax,which I gave to cover her nudity."
,"12":"Before her lovers I will lay bare her shame,and no one can rescue her from my power."
,"13":"I will bring an end to all her gladness, her monthly feasts, sabbaths and celebrations."
,"14":"I will lay waste her vines, and her fig trees, for she said, 'My lovers gave them to me.',I will turn them into thickets,to be ravaged by wild beasts."
,"15":"I will punish her for the feast days,when she brought burnt offerings to the Baals, decked herself with her gaudy jewels, ran after her lovers and forgot me, says Yahweh."
,"8":"With thorns, therefore, I will block her path, wall her and not let her find her way out."
,"9":"Pursuing her lovers, she will not overtake them; looking for her lovers, she will not find them. Then she will say, 'I will go back to my husband,for I was better off then than now.'"
,"16":"So I am going to allure her, lead her once more into the desert, where I can speak to her tenderly."
,"17":"Then I will give back her vineyards, make the Valley of Achor a door of hope. There she will answer me as in her youth, as when she came out of the land of Egypt."
,"18":"On that day, Yahweh says, you will call me my husband, and never again: my Baal."
,"19":"I will take the names of Baals from her lips,and no longer will they be invoked."
,"20":"That day on her behalf I will make a covenant,with beasts of the field and birds of the air, with creatures creeping upon the ground. I will wipe out the sword and war in the land; I will make people rest safe and secure."
,"21":"You will be my spouse forever, betrothed in justice and integrity; we will be united in love and tenderness."
,"22":"I will espouse you in faithfulness,and you will come to know Yahweh."
,"23":"This is what Yahweh says of those days, 'I will be at peace with the heavens, and they will respond to the earth;"
,"24":"the earth will respond to the grain, wine and oil, which will come up to the expectation of Jezreel."
,"25":"I will sow them for myself in the land; I will show my love to Unloved; I will say to Not-my-people, 'You are my people'; and they will answer, 'You are my God.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Yahweh said to me, 'Welcome once more this woman who makes love to others. Love her just as Yahweh loves his people who turn to other gods and offer raisin cakes to them.'"
,"2":"So I bought her for fifteen pieces of silver and a whole measure of barley."
,"3":"Then I said to her, 'You shall stay here with me many days without giving yourself to anyone and without deserting me for another man. And I too will stand aloof.'"
,"4":"For the people of Israel shall be for many days without king or ruler, without sacrifice or sacred pillar, without divination or household idol."
,"5":"Then the people of Israel shall turn back, looking for Yahweh, their God, and for David, their king. In the last days they will come respectfully to Yahweh and to his blessings."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Hear the word of Yahweh, Israel! for Yahweh has an accusation to bring against the inhabitants of this land. There is neither truth nor goodness nor knowledge of God in the country;"
,"2":"only perjury, lies, murder, theft and adultery, with continual bloodshed."
,"3":"That is why the country is in mourning with all who live there wasting away; the beasts of the field, the birds of the air, even the fish are dying."
,"4":"But let no one apologize or accuse another, for it is you, priest, whom I single out!"
,"5":"You will stumble in broad daylight, and the prophet will fall with you into darkness; I will silence you."
,"6":"My people perish for want of knowledge. As you have dropped the Knowledge, I will drop you from my priesthood, and since you ignore the law of your God, I, too, will ignore your children."
,"7":"All have offended me; they have exchanged me, their Glory, for idols, their shame."
,"8":"Since they eat of the sacrifices for sin, they like my people to sin."
,"9":"Yet it will be for the people as for the priest; I shall punish both for their conduct and repay them for their deeds."
,"10":"They will eat and not be satisfied; they will multiply their prostitutions but remain without child, for they have no reverence for Yahweh."
,"11":"Harlotry, wine and liquors have taken hold of their hearts."
,"12":"My people consult a wooden idol and rely on a rod for information. A spirit of adultery leads them astray and makes them unfaithful to their God."
,"13":"They sacrifice on the mountain tops and offer incense on the hills, under the oak, the poplar and the terebinth, wherever the shade is pleasant."
,"14":"That is why, if your daughters turn to prostitution and your daughters-in-law to adultery, I will not punish them, for you yourselves go off with harlots and sacrifice with temple prostitutes. A senseless people destroys itself."
,"15":"If Israel is a prostitute, there is no reason for Judah to sin. Do not go to Gilgal or Beth-aven; do not swear, 'As Yahweh lives!')"
,"16":"Since Israel is as obstinate as a stubborn cow, will Yahweh pasture it gently as a lamb?"
,"17":"Ephraim is devoted to idols, let Yahweh leave him alone!"
,"18":"After being drunk with wine they go with prostitutes; they prefer their idols to their Glory."
,"19":"A whirlwind will sweep them away and they will have gained nothing with their sacrifices."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Hear this, O priests! and you, people of Israel, pay attention! Hear, officials of the king for you are to be judged. You have been a snare at Mizpah and a net on Tabor,"
,"2":"and a deep pit at Shittim, so I am to punish you all."
,"3":"I know what Israel is like; he cannot hide from me. Ephraim is playing the harlot; Israel is a people which defiles itself."
,"4":"Their deeds prevent them from returning to their God; a spirit of prostitution has taken hold of them and they do not know Yahweh."
,"5":"The pride of Israel is witness against him; this people are failing because of their guilt."
,"6":"With their sheep and bulls they will go in search of Yahweh, but they will not find him for he has gone far from them."
,"7":"He found they were unfaithful and their children were not his. So now the destroyer will do away with them and their lands will be devastated."
,"8":"Blow the horn at Gibeah, the trumpet at Ramah, raise the battlecry in Beth-aven! For Benjamin has been defeated,"
,"9":"the day has come in which Ephraim is ruined. Let the tribes of Israel know that this is about to occur!"
,"10":"The princes of Judah are like those who remove border stones and I shall pour out my anger on them like a flood."
,"11":"In the same way those of Ephraim are oppressors and trample justice."
,"12":"I will be like a moth for Ephraim, like rot for Judah."
,"13":"Ephraim saw he was sick and Judah saw his ulcer. Then Ephraim turned to the great King of Assyria for help, but he will not cure you or heal your sores."
,"14":"I will be like a leopard for Ephraim and like a lion for Judah. I will tear them to pieces and leave them. When I carry them off, no one will rescue them."
,"15":"Then I will go away and return to my place until they admit their guilt and come back to me, for in their anguish they will earnestly seek me."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Come, let us return to Yahweh. He who shattered us to pieces, will heal us as well; he has struck us down, but he will bind up our wounds."
,"2":"Two days later he will bring us back to life; on the third day, he will raise us up, and we shall live in his presence."
,"3":"Let us strive to know Yahweh. His coming is as certain as the dawn;"
,"5":"c,his judgment will burst forth like the light; he will come to us as showers come, like spring rain that waters the earth."
,"4":"O Ephraim, what shall I do with you?,O Judah, how shall I deal with you?,This love of yours is like morning mist, like morning dew that quickly disappears."
,"5":"This is why I smote you through the prophets, and have slain you by the words of my mouth."
,"6":"For it is love that I desire, not sacrifice; it is knowledge of God, not burnt offerings."
,"7":"At Adam they broke my covenant; there they were unfaithful to me."
,"8":"Gilead is a city of evildoers, stained with footprints of blood."
,"9":"Like thieves in an ambush, so are the priests; they murder on the road to Shechem and commit adultery."
,"10":"In Bethel I saw their disgraceful conduct; that is where Ephraim played the harlot and was defiled."
,"11":"(For you, too, Judah, I have a harvest stored when I bring back my captive people and heal Israel.)"
}`)
	CurrentBook.AddChapter(7, `{
"1":"The sin of Ephraim appears clearly; the wickedness of Samaria is obvious. They cheat one another, they break into houses while bandits raid outside."
,"2":"They do not realize that I am mindful of their evil deeds. They are engulfed by their sins which are always before me."
,"3":"They amuse the king with their wickedness and the officials with their trickery."
,"4":"They are and remain adulterers, like an oven heated by a baker; he has not to stir the fire from the time the dough is kneaded until it rises."
,"5":"On the day of the king his officials get drunk and the king joins hands with the revelers."
,"6":"In their plotting they burn like an oven; all night their anger smolders and in the morning blazes like a fire."
,"7":"They are all heated like an oven and they devour their own rulers; all their kings fall but none of them calls on me for help."
,"8":"Ephraim mixes with other nations. He is like a half-baked loaf;"
,"9":"the nations around him consume his strength but he is unaware of it. He has become old and he does not know it."
,"10":"Israel's arrogance is witness against him but even so they will not turn back to Yahweh, their God, or search for him."
,"11":"Ephraim is like a silly pigeon, now calling on Egypt, now turning to Assyria."
,"12":"But wherever they turn I shall throw my net over them for they rebelled against me and they will fall like birds."
,"13":"Woe to them who fled far from me; disgrace will fall on those who deceived me. I wanted to redeem them but they spoke evil of me."
,"14":"They did not call on me sincerely when they groaned on their beds because of their wheat and wine and turned to me."
,"15":"When I made them successful and strong, they plotted evil against me."
,"16":"Now they turn to nothingness. They are deceptive as a twisted bow. Their leaders will fall by the sword because of their insolent talk; in the land of Egypt, people will make fun of them."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Sound the trumpet, sentry! Warn the people of Yahweh because they have broken my covenant and are unfaithful to my Law."
,"2":"They cry to me, 'We, Israel, acknowledge you, O God.'"
,"3":"But Israel rejected what is right and this is why the enemy will hunt them down."
,"4":"Without my approval they set up kings and without my blessing appointed leaders. With their silver and gold they fashioned idols to their own ruin."
,"5":"To me, Samaria, your calf is loathsome and my anger blazes against you. How long will you remain defiled?"
,"6":"The calf is yours, Israel, a craftsman has made it; it is not God and will be broken into pieces."
,"7":"As they sow the wind, they will reap the whirlwind. Like the erect ear of corn they will bear no grain and produce no flour, or if they do, foreigners will devour it."
,"8":"-"
,"9":"Israel lived apart as a wild donkey, but he was eaten up. Now they are among pagans as a worthless object. Ephraim went to Assyria with gifts."
,"10":"Now they have been given up to the nations and I shall gather them. For in no time they have been left with no prophets, or kings, or leaders."
,"11":"Ephraim built many altars but his altars made him more guilty."
,"12":"I wrote out for him the numerous precepts of my Law, but they look on them as coming from foreigners."
,"13":"They offer sacrifices to me because they are those who eat the meat, but Yahweh does not accept their sacrifices for he is mindful of their sin and remembers their wickedness. They will return to Egypt."
,"14":"Israel has forgotten his Maker and built palaces, but I will set fire to their towns and burn their palaces."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Do not rejoice and celebrate, Israel, like other nations, for you have deserted your God. You are fond of prostitution gifts and run to every threshing floor where there is wheat. "
,"2":"This is why threshing floors and vats will not feed you; new wine will disappoint you."
,"3":"No longer will you remain in Yahweh's land. Ephraim will return to Egypt - in fact to Assyria, where they will eat unclean food."
,"4":"No more will they be able to pour out the wine offering for Yahweh and no longer will they sacrifice to him. They will have only bread for mourners; all who eat it will be defiled. This food will be for themselves and it will not be taken into the house of Yahweh."
,"5":"What shall you do on the feast? You will leave but not for the pilgrimage to Yahweh; rather you will flee because of the invaders."
,"6":"Egypt will gather you and Memphis entomb you. Nettles will take over your treasures of silver and thorns creep over your tents."
,"7":"The time of punishment has come, the day of retribution is here. The Israelites will know it. The prophets will go out of their mind; the seers will become like mad men because your defeat will be as great as your sins have been."
,"8":"Ephraim watches before my God; his prophets try to stop the enemy on every path to protect the house of their gods."
,"9":"Yet they are as corrupted as they were long ago in Gibeah. Yahweh will remember their wickedness and punish their sin."
,"10":"I found Israel like wild grapes in the desert, I saw your fathers like the first fruits on a fig tree. But no sooner had they come to Baal-peor than they gave themselves to the idol; and they became as worthless as their dirty god."
,"11":"The glory of Ephraim will flee away like a bird; it has died stillborn, miscarried, not even conceived."
,"12":"Had they brought out children, I would take them off before they were adults, for woe to them when I abandon them!"
,"13":"I have seen that Ephraim will make his sons like a game; he will send his sons to be slaughtered."
,"14":"Give them, Yahweh, what you will; give them wombs that miscarry and breasts that are dry."
,"15":"It is at Gilgal that their wickedness is seen. There I hated them. I will expel them from my House because of their evil conduct. I will love them no longer for all their leaders are rebels."
,"16":"Ephraim is blighted; his root is withered; he will produce no fruit. Even when they are with child, the child will die in the womb."
,"17":"My God will reject them because they did not listen; he will make them wander among the nations."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Israel was a spreading vine, rich in fruit. The more his fruit increased, the more altars he built; the more his land prospered, the more he adorned his sacred stones."
,"2":"Their heart is divided! They shall pay for it. Their altars will be thrown down and their sacred stones broken to pieces."
,"3":"Now they say, 'We have no king (because we have no fear of God) and what good would a king do us?'"
,"4":"Let them speak like this, take an oath and make covenants! Their sentence is growing like weeds in a plowed field."
,"5":"The people of Samaria tremble for their idols of Bethel; they mourn for their calf as do the priests who were so proud of it."
,"6":"The glorious idol has been taken far away, carried off to Assyria as a tribute to the great king. Ephraim will reap the shame of this; the people of Israel will be disgraced."
,"7":"As for the king of Samaria, he has been carried off like foam on water."
,"8":"The idolatrous high places - the sin of Israel - will be destroyed. Thorn and thistle will creep over the altars. Then they will say to the mountains: 'Cover us,' and to the hills: 'Fall on us.'"
,"9":"Since the days of Gibeah you have sinned and rebelled, Israel. Will not the battle against the evildoers of Gibeah overtake you again?"
,"10":"I shall come and punish you, gathering the nations against you because of your double sin."
,"11":"Ephraim is a well-trained heifer fond of threshing; on her neck I shall place a yoke; Ephraim will be harnessed and plowed; the nation of Jacob will break the clods."
,"12":"Plow new ground, sow for yourselves justice and reap the harvest of kindness. It is the time to go seeking Yahweh until he comes to rain salvation on you."
,"13":"For your part you planted wickedness, reaped evil and ate the fruit of falsehood. When you rely on your own strength and your many warriors, confusion will overcome your people."
,"14":"See, your fortresses are destroyed as when Shalman devastated Beth-arbel; all was crushed."
,"15":"That is what will happen to you, people of Israel, because of your great evil. The storm will blow away the king of Israel."
}`)
	CurrentBook.AddChapter(11, `{
"1":"I loved Israel when he was a child; out of Egypt I called my son."
,"2":"But the more I have called, the further have they gone from me - sacrificing to the Baals, burning incense to the idols."
,"3":"Yet it was I who taught Ephraim to walk, taking them by the arms; yet little did they realize that it was I who cared for them."
,"4":"I led them with cords of human kindness, with leading strings of love, and I became for them as one who eases the yoke upon their neck and stoops down to feed them."
,"5":"If they refuse to return to me, they will have to go back to Egypt and be ruled by an Assyrian king."
,"6":"Swords will flash in their cities, slaughtering their sons, putting an end to all their plans."
,"7":"They insist on turning away from me; they cry out because the yoke is upon them and no one lifts it."
,"8":"How can I give you up, Ephraim? Can I abandon you like Admah or make you like Zeboiim? My heart is troubled within me and I am moved with compassion."
,"9":"I will not give vent to my great anger; I will not return to destroy Ephraim for I am God and not human. I am the Holy One in your midst and I do not want to come to you in anger."
,"10":"You will follow Yahweh when he roars like a lion. When he roars his sons will come trembling from the west;"
,"11":"they will come with fear like sparrows from Egypt, like doves from Assyria. For I will bring them to their homes again."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Ephraim has surrounded me with lies; Israel comes to me with deceit. They follow Baal and run after the sanctuaries."
,"2":"Ephraim feeds on wind, forever chasing the east wind, always more given to falsehood and violence. They have made a treaty with Assyria and brought oil to Egypt."
,"3":"Yahweh has brought Jacob to trial. He will call him to account for his ways and repay his deeds."
,"4":"In the womb he supplanted his brother and later he struggled with God, battling until he got the better of the angel."
,"5":"The angel, in fact, wept and pleaded with him! He met him at Bethel and there he spoke to him."
,"6":"(Yahweh, the God of armies, Yahweh is his Name.)"
,"7":"You must return to your God, practice love and justice and trust in your God.)"
,"8":"Canaan has dishonest scales and likes to cheat."
,"9":"Ephraim boasts, 'I have become rich and possess a fortune.' Yet he will be left with nothing of what he has treasured for he was doing wrong."
,"10":"I am Yahweh, your God, since the days of Egypt; I will have you live in tents again as in the days of Meeting."
,"11":"Then I will speak to the prophets, give them many visions and teach you through their parables."
,"12":"The people of Gilead are wicked; they are false. They offered sacrifices to bulls in Gilgal. This is why their altars will become ruins on a plowed field."
,"13":"Jacob fled to the plains of Aram; Israel served to have a wife, and for her sake he cared for sheep."
,"14":"Yahweh, in turn brought Israel out of Egypt through a prophet; by means of this prophet he cared for them."
,"15":"Ephraim, nevertheless, angered him bitterly. The Lord will bring down on him the blood he shed and repay him for his contempt."
}`)
	CurrentBook.AddChapter(13, `{
"1":"When Ephraim spoke all trembled; he was powerful in Israel but became guilty of Baal worship and ruined himself."
,"2":"They now continue to sin and make images from molten metal, fashioning idols from silver, the work of craftsmen. And they call them God! They offer sacrifices to them and humans adore calves!"
,"3":"That is why they will be like morning mist and like dew which does not last, like the straw swept away on the threshing floor, like smoke escaping through a window."
,"4":"But I am Yahweh, your God who brought you out of Egypt; you have no God other than me and no savior but me."
,"5":"I knew you in the desert, in a land of scorching heat."
,"6":"When they had food they were satisfied and when they were satisfied they became proud and no longer remembered me."
,"7":"So I became for them like a leopard, like a tiger I watched out for them,"
,"8":"and attacked them with the fury of a bear that has lost its cubs. I tore out their heart and like a lion I devoured them; like a savage beast I tore them apart."
,"9":"Israel, you had in me a helper, will I be now your destroyer?"
,"10":"Where is your king that he may rescue your cities? Where are your rulers about whom you said, 'Give us a king and commanders.'"
,"11":"So in my anger I gave you a king and in my fury I took him away."
,"12":"The wickedness of Ephraim is deep-set; his sin is stored up."
,"13":"The pangs of woman in labor come upon him. But the child is capricious. When it is time he does not leave the womb."
,"14":"Will I ransom them from the power of the netherworld? Will I rescue them from death? Not at all! Where, O death, are your plagues? Where, O netherworld, is your venom? Yet my eyes will not look with compassion"
,"15":"on the one who excelled among his brothers. Yahweh will send the east wind from the desert to dry up his sources of water and parch his fountains, to strip him of all his treasures."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Samaria is guilty for she rebelled against her God. They will fall by the sword, their little ones will be crushed and women with child ripped open."
,"2":"Return to your God Yahweh, O Israel!,Your sins have caused your downfall."
,"3":"Return to Yahweh with humble words. Say to him, 'Oh you who show compassion to the fatherless,forgive our debt, be appeased. Instead of bulls and sacrifices, accept the praise from our lips."
,"4":"Assyria will not save us: no longer shall we look for horses,nor ever again shall we say 'Our gods',to the work of our hands.'"
,"5":"I will heal their wavering,and love them with all my heart,for my anger has turned from them."
,"6":"I shall be like dew to Israel,like the lily will he blossom. Like a cedar he will send down his roots;"
,"7":"his young shoots will grow and spread. His splendor will be like an olive tree, his fragrance, like a Lebanon cedar."
,"8":"They will dwell in my shade again, they will flourish like the grain, they will blossom like a vine, and their fame will be like Lebanon wine."
,"9":"What would Ephraim do with idols, when it is I who hear and make him prosper?,I am like an ever-green cypress tree; all your fruitfulness comes from me."
,"10":"Who is wise enough to grasp all this?,Who is discerning and will understand?,Straight are the ways of Yahweh: the just walk in them, but the sinners stumble."
}`)

}
func EN_CCB_LoadVNSOChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"When Josiah, son of Ammon, reigned in Juda, the word of Yahweh was addressed to Zephaniah, the son of Cushi, son of Gedaliah, son of Amariah, son of Hezekiah. He said:"
,"2":"'I will wipe out everything from the face of the earth."
,"3":"I will put an end to humans and animals, to the birds of heaven and the fish of the sea. I will wipe humankind from the face of the earth."
,"4":"I will raise my hand to punish Judah and all the inhabitants of Jerusalem; and I will bring out of that place all the remnants of Baal with their priests."
,"5":"I will also drive away those who kneel on the roofs to worship the stars, those who invoke at the same time Yahweh and Milcom,"
,"6":"those who have deserted Yahweh and no longer look toward him or consult him."
,"7":"Silence before Yahweh! For his day is near: Yahweh has prepared a sacrifice and consecrated his invited guests."
,"8":"Yahweh says, 'On the day that sacrifice is made, I will call to account the officials, the king's sons and all who clothe themselves in foreign fashion."
,"9":"I will also give the corresponding punishment to everyone who jumps over the threshold without stepping on it and fills the House of their Lord with the fruits of their crimes and thefts."
,"10":"On that day, a great cry will be heard from the Fish Gate, a wail from the new city and a frightful noise from the nearby hills."
,"11":"Wail, inhabitants of the lower district, for all the traders have disappeared, all who counted the silver have perished."
,"12":"On that day I will explore Jerusalem with torches, and call to account those who have sunk in their vices and think in their hearts: Well, Yahweh does not do good or evil!"
,"13":"Their riches will be pillaged, their houses demolished. You have built houses but will not live in them. You have planted vineyards but you will not taste the wine.'"
,"14":"The great day of the Lord is near, it already comes. Its sound is so frightening,that even the valiant cries out in terror."
,"15":"It is a day of wrath, anguish and distress; a day of destruction and devastation, of gloom and darkness; it is a day of dark clouds"
,"16":"and fog when the trumpet sounds,the call for battle, and the enemy attacks the fortresses,and the high fortified towers."
,"17":"I will bring misfortune on these people and they will grope along like the blind. Their blood will be poured out like dust and their remains will lie like dung."
,"18":"Neither their gold nor their silver will rescue them when the anger of God burns against them. The land of Judah will be burned in the fire of his zeal when he destroys even the traces of all who dwell in that land."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Gather together and assemble, O shameless people,"
,"2":"that you may be scattered by the wind like a heap of straw when the anger of Yahweh comes upon you!"
,"3":"Seek Yahweh, all you poor of the land who fulfill his commands, do justice and are meek, and perhaps you will find refuge on the day Yahweh comes to judge."
,"4":"Gaza shall be a desert, Ashkelon completely destroyed to its very foundation."
,"5":"Woe to the nation of the Cherethites on the seacoast, for Yahweh has spoken against it: 'O Canaan, land of the Philistines, I will destroy you so that no one will be left in you.'"
,"6":"The seacoast shall be like pastures where the shepherds and their flocks go and the lambs gather."
,"7":"This region will belong to the remnant of the tribe of Judah; there they shall bring their flocks to graze and they will sleep at night in the houses of Ashkelon, when Yahweh their God comes to visit them and bring their captives back."
,"8":"Yahweh of hosts, the God of Israel says, 'I have heard the affronts of Moab and the mockery of the Ammonites who insulted my people and extended their boundaries at the expense of my territory."
,"9":"Therefore I swear that, as I live, Moab shall become like Sodom, and Ammon like Gomorrah, as desert indeed. The remnant of my people shall plunder them, the survivors of my nation shall receive them as an inheritance."
,"10":"This shall be their lot, in payment for their pride, for they insulted the people of the God of hosts and have enriched themselves at my people's expense.'"
,"11":"Yahweh will be inflexible with them when he calls to account all the gods of the earth."
,"12":"Then the pagans who live on the islands shall worship him, each in his own land. 'The threat of my sword also hangs over you, Ethiopians.' "
,"13":"Yahweh will raise his hand against the north and reduce Assyria to ruins."
,"14":"He will leave Nineveh in utter desolation, barren as the desert. Herds of all kinds of animals shall find shelter in her, and even the pelican and the heron shall dwell in her ruins; the owl shall hoot from the window and the raven from the threshold."
,"15":"The cedar has been uprooted! So will be the end of the happy city that felt secure in her own power and said to herself: I and no one but I. Why is it now a heap of ruins where animals take shelter? Everyone who passes by her hisses, making signs with the hand."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Woe to the rebellious, the defiled, the city that oppresses."
,"2":"She did not pay attention to the call nor accept the correction; she did not trust Yahweh nor did she approach her God."
,"3":"Her kings are like roaring lions, her rulers like evening wolves that do not leave even a bone for the next day."
,"4":"Her prophets are blabbermouths and treacherous people; her priests defile whatever is sacred with no respect for the Law."
,"5":"However, Yahweh the Just one is in her midst; he never commits injustice. Every morning he says what must be done; but the unjust do not even feel ashamed."
,"6":"I have wiped out the nations, demolished their watchtowers, left their streets abandoned, and no one walks in them; their cities have been leveled, and no one lives there."
,"7":"I thought: 'If you took into account my correction' I said: 'she will not forget my threats.' But you were eager to behave still more corruptly."
,"8":"Therefore, wait for me, says Yahweh, for the day when I come to accuse, when I have the nations gathered and the kingdoms assembled to vent my wrath on you with all the fury of my anger. Then the fire of my jealous wrath will burn the whole land."
,"9":"At that time I will give truthful lips to the pagan nations that all of them may call on the name of Yahweh and serve him with the same zeal."
,"10":"From beyond the rivers of Ethiopia they will bring offerings to me."
,"11":"On that day you will no longer be ashamed of all your deeds when you were unfaithful to me; I will have removed from your midst the conceited and arrogant and my holy mountain will no longer be for you a pretext for boasting."
,"12":"I will leave within you a poor and meek people who seek refuge in God."
,"13":"The remnant of Israel will not act unjustly nor will they speak falsely, nor will deceitful words be found in their mouths. They will eat and rest with none to threaten them."
,"14":"Cry out with joy, O daughter of Zion; rejoice, O people of Israel! Sing joyfully with all your heart, daughter of Jerusalem!"
,"15":"Yahweh has lifted your sentence and has driven your enemies away. Yahweh, the King of Israel is with you; do not fear any misfortune."
,"16":"On that day they will say to Jerusalem: Do not be afraid nor let your hands tremble,"
,"17":"for Yahweh your God is within you, Yahweh, saving warrior. He will jump for joy on seeing you, for he has revived his love. For you he will cry out with joy, as you do in the days of the Feast."
,"18":"I will drive away the evil I warned you about, and you will no longer be shamed."
,"19":"On that day I will face your oppressors; I will save the lame sheep and bring the lost back into the fold. I will give them renown and honor in all the lands where humiliation was your lot."
,"20":"On that day I will be good to you and gather you to make you famous and honorable among all the peoples of the earth, when I bring back the captives before your eyes, - this is Yahweh's word."
}`)

}
func EN_CCB_LoadVNZAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"In the eighth month of the second year of Darius, the word of Yahweh came to the prophet Zechariah son of Berechiah, the son of Iddo:"
,"2":"'Yahweh was very angry with your ancestors."
,"3":"Then you will tell them these words of Yahweh Sabaoth: 'Return to me and I will return to you.'"
,"4":"Do not be like your ancestors whom the earlier prophets warned, reiterating to them Yahweh Sabaoth's words: 'Turn from your evil ways and your wicked deeds.' But they would not listen or pay attention to me. Yahweh asks you,"
,"5":"'Where are your ancestors now? Those prophets also died"
,"6":"but my words and decrees entrusted to my servants, the prophets, overtook your ancestors. They repented and confessed: 'Yahweh Sabaoth has treated us just as he had determined to do, according to our ways and deeds.'"
,"7":"On the twenty-fourth of Shebat, the eleventh month, in the second year of Darius, the word of Yahweh came to the prophet Zechariah son of Berechiah, the son of Iddo, in the following manner."
,"8":"In a vision at night, I saw a man riding a red horse. He was standing among the myrtle trees in a ravine, and behind him were red, brown and white horses."
,"9":"I asked, 'What are these, my lord?' The angel with whom I was talking answered, 'You will know.'"
,"10":"The man standing among the myrtle trees spoke, 'They are those whom Yahweh sent to patrol the earth.'"
,"11":"These then reported to Yahweh's angel standing among the myrtle trees, 'We have patrolled the whole earth and found it peaceful and tranquil.'"
,"12":"The angel of Yahweh spoke, 'O Yahweh of hosts, how long will you be without mercy for Jerusalem and the cities of Judah which you have afflicted in anger these seventy years?'"
,"13":"Yahweh replied with comforting words to the angel who spoke to me."
,"14":"This angel then turned to me and said, 'Proclaim this word which Yahweh Sabaoth speaks: 'I am very jealous for Jerusalem and Zion,"
,"15":"but I am very angry with complacent nations. At first I was only a little angry with Jerusalem, but they made things worse.'"
,"16":"Therefore Yahweh says: 'I will turn again with mercy to Jerusalem, where my house will be rebuilt and the measuring line stretched.'',Then Yahweh Sabaoth said, "
,"17":"'Proclaim this as well: 'My towns will once more overflow with prosperity; Yahweh will again comfort Zion and make Jerusalem his favorite.''"
}`)
	CurrentBook.AddChapter(2, `{
"1":"I raised my eyes and saw four horns."
,"2":"I asked the angel who spoke to me what these were, and he answered, 'These horns are the nations that scattered Judah and Jerusalem.'"
,"3":"Yahweh then showed me four blacksmiths, and I asked, 'What are they coming to do?'"
,"4":"He answered, 'Here are the horns that scattered Judah so that no one dared raise his head. But these blacksmiths have come to strike down the power of the nations that scattered the people of Judah.'"
,"5":"Raising my eyes again, I saw a man with a measuring line in his hand. I asked, 'Where are you going?'"
,"6":"He answered, 'I'm going to measure Jerusalem, to find its width and its length.'"
,"7":"As the angel who spoke to me came forward, another angel met him"
,"8":"and said, 'Run and tell this to that young man: 'Jerusalem will remain unwalled because of its multitude of people and livestock.'"
,"9":"For this is the word of Yahweh: I myself will be around her like a wall of fire, and also within her in Glory.'"
,"10":"'Come, come! Flee from the land of the north,' says Yahweh to all those whom he scattered to the four winds of heaven."
,"11":"'Come, escape O Zion, you who dwell in Babylon.'"
,"12":"For thus Yahweh Sabaoth says, after his Glory sent me to condemn the nations that have plundered you, 'Whoever touches you touches the apple of my eye."
,"13":"Look, I will raise my hand against those nations, and they will be plundered by their slaves.' Thus you will know that Yahweh Sabaoth has sent me."
,"14":"'Sing and rejoice, O daughter of Zion, for I am about to come, I shall dwell among you,' says Yahweh."
,"15":"'On that day, many nations will join Yahweh and be my people, but my dwelling is among you.'"
,"16":"The people of Judah will be for Yahweh as his portion in his holy land. He will choose Jerusalem again."
,"17":"Keep still in Yahweh's presence, for he comes, having risen from his holy dwelling.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"He showed me then the high priest Joshua standing before the Angel of Yahweh. At Joshua's right side stood Satan, ready to accuse him."
,"2":"But the angel of Yahweh said to Satan, 'May Yahweh rebuke you, Satan! Yahweh who has chosen Jerusalem - may he rebuke you! Is not this man a burning brand snatched from the fire?'"
,"3":"Clad in filthy garments, Joshua stood before the Angel,"
,"4":"who said to those in front of him, 'Take off his filthy garments.' Then turning to Joshua, he said, 'See, I have taken away your guilt. Now I will clothe you with rich garments.'"
,"5":"He added, 'Put a clean turban on his head.' So they put a clean turban on his head and clothed him, as the Angel of Yahweh looked on."
,"6":"The Angel of Yahweh gave Joshua this assurance,"
,"7":"'Listen to this word of Yahweh Sabaoth: 'If you walk in my ways and heed my charge, you shall rule my house and keep my courts, and I will give you free access among those standing here."
,"8":"Listen further, O high priest Joshua and your associates who join in council with you: I am going to bring my servant the Branch."
,"9":"See, I am setting (before Joshua) a stone with seven eyes. I myself will engrave an inscription on it, and I will remove the guilt of this land in a single day."
,"10":"On that day, you will invite one another under your vines and fig trees.' This is what Yahweh Sabaoth says.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"The angel who talked with me returned and shook me as one does to wake another from sleep."
,"2":"He asked, 'What do you see?' I answered, 'I see a lampstand all of gold, with a bowl on top. On the stand are seven lamps and there are seven pipes to feed them."
,"3":"There are also two olive trees, one at the right of the bowl and another at the left.'"
,"4":"I asked the angel, 'What are these, my Lord?'"
,"5":"He replied with a question, 'Don't you know what they are?' I answered, 'No, my Lord.'"
,"6":"This is a word of Yahweh for Zerubbabel, 'Not by might nor by power, but by my Spirit.'"
,"7":"'What are you, O mighty mountains? You will be leveled before Zerubbabel. He will quarry from you to the last stone which crowns the Temple amid shouts of: blessing, blessing on it!'"
,"8":"The word of Yahweh then came to me,"
,"9":"'The hands of Zerubbabel have laid the foundation of this House; his hands also shall finish it. (Then you will know that Yahweh Sabaoth has sent me to you.)"
,"10":"Perhaps the beginning seems a small thing to you, yet you will rejoice on that day to see the crowning stone in the hands of Zerubbabel.'"
,"10b":"He explained, 'These seven are the eyes of Yahweh which range throughout the earth.'"
,"11":"I asked the angel, 'What are these two olive trees to the right and left of the lampstand?'"
,"13":"His reply was a question. 'Don't you know what these are?' I answered, 'No, my Lord.'"
,"14":"He said, 'These are the two anointed with fresh oil, who serve the Lord of the whole earth.'"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Again I raised my eyes and saw a flying scroll."
,"2":"He asked me, 'What do you see?' And I answered, 'A flying scroll, thirty feet long and fifteen feet wide.'"
,"3":"He said to me, 'This is the curse going forth throughout the earth. On one side it is written that every thief shall be banished; on the other side, that everyone who swears falsely shall be expelled."
,"4":"I will send it out to the house of the thief, as well as to the house of anyone who swears falsely. It will lodge there and destroy the house - timber, stone and everything."
,"5":"Then the angel who talked with me came forward and said, 'Look up and see what this is that is coming forth.'"
,"6":"I asked, 'What is it?' He answered, 'This is a bushel container. This is the guilt of the people throughout the land.'"
,"7":"The lead cover was lifted, and there sitting inside was a woman."
,"8":"'This is wickedness,' he said and thrust the woman inside the bushel stopping the opening with the lead cover."
,"9":"I looked up and saw two winged women coming; their wings were like that of a stork. As they lifted the bushel into the air,"
,"10":"I asked the angel who was speaking to me, 'Where are they taking the bushel?'"
,"11":"He answered, 'To Babylonia, to build a temple for it and set it down on a plinth.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Once more I raised my eyes and saw four chariots coming out from between two mountains of bronze."
,"2":"The first chariot had red horses, the second black,"
,"3":"the third white, and the fourth dapple gray."
,"4":"I asked the angel talking with me, 'What are these, my Lord.'"
,"5":"The angel replied, 'These are the four winds of heaven, going forth after presenting themselves before the Lord of the whole earth."
,"6":"The chariot with black horses goes towards the north country, the one with white horses towards the west, and the one with dapple gray horses towards the land of the south.'"
,"7":"As the reds asked to start off and to patrol the earth, the angel said to them, 'Go, patrol the earth!' and they went."
,"8":"Then he cried out to me, 'Look, those have just gone to the land of the north and they will set my spirit at rest in the land of the north.'"
,"9":"The word of Yahweh came to me,"
,"10":"'Take offerings from the returned captives, from the hands of Heldai, Tobijah and Jedaiah, and go this very day to the house of Josiah, Zephaniah's son, where they have arrived from Babylon."
,"11":"Take silver and gold and have crowns made, which you will set on the head of the high priest Joshua, son of Jehozadak."
,"12":"Repeat to him these words of Yahweh Sabaoth: 'Here is the man whose name is Branch. From where he is he will branch out and build the temple of Yahweh."
,"13":"It is he who will build the temple of Yahweh, and this will be his glory. He will sit and rule upon his throne. A priest will sit at his right, and there will be harmony between both.'"
,"14":"As for the crowns, they will remain in the temple of Yahweh as a memorial of what Heldai, Tobijah, Jedaiah and Josiah, Zephaniah's son have done."
,"15":"Those from afar will come and help build the temple of Yahweh, and you will know that Yahweh Sabaoth has sent me to you. This will happen if you diligently listen to the voice of your God Yahweh.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"On the fourth day of the ninth month in the fourth year of Darius, the king,"
,"2":"the people of Bethel sent Sharezer and Regemmelech with their men to win the favor of Yahweh"
,"3":"and to question the priests of the House of Yahweh, God of hosts, and the prophets, 'Must we mourn and fast in the fifth month as we have done these many years?'"
,"4":"And the word of Yahweh, God of hosts came to me:"
,"5":"'Speak to the inhabitants of the land and to the priests; say to them: When you fasted and mourned in September and December for seventy years, was I the one who made you fast?"
,"6":"Were you not those who decided to eat and to drink or not to do so?"
,"7":"Remember the message that Yahweh proclaimed through earlier prophets when Jerusalem was peacefully inhabited and the surrounding region as well, when the Negeb and the western foothills were settled."
,"8":"Yahweh said,"
,"9":"Render true judgment, be kind and merciful to each other."
,"10":"Do not oppress the widow or the orphan, the alien or the poor, do not plot evil in your heart against one another."
,"11":"But they refused to listen and stubbornly turned their back, stopping their ears."
,"12":"They made their hearts hard as diamonds so as not to hear the Law or the words that Yahweh, the God of hosts spoke by his spirit through the earlier prophets."
,"13":"Then Yahweh, God of hosts in his great anger proclaimed that just as they had not listened when he called to them, so when they cried to him he would not listen."
,"14":"Yahweh said he would scatter them as in a whirlwind among nations they did not know and the land behind them would be devastated without anyone passing through it. In that way a pleasant land was made desolate.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"The word of Yahweh, the God of hosts was directed to me in this way,"
,"2":"'I am intensely jealous for Zion, stirred by a burning anger for her sake."
,"3":"Yahweh says: I will return to Zion and live in her midst. Jerusalem shall be called City of faithfulness and the Mountain of Yahweh of hosts, the Mountain of holiness.'"
,"4":"Yahweh, God of hosts speaks, 'Old men and women will again sit in the squares, each with a stick in hand on account of their great age."
,"5":"The squares of the city will be filled with girls and boys playing.'"
,"6":"Yahweh, God of hosts declares, 'If that seems impossible in the eyes of those who have returned from exile, will it be impossible for me as well?' - word of Yahweh."
,"7":"Yahweh, God of hosts says, 'See, I am going to save my people,"
,"8":"bringing them from the east and from the west and they will live in Jerusalem. They will be my people and I shall be their God in truth and in justice.'"
,"9":"Yahweh, God of hosts declares, 'In these days you have just heard the words of the prophets, because on this day the foundation stone is laid for the reconstruction of the Temple. Now do not be discouraged."
,"10":"Before these days there was no salary for anyone nor food for beasts, people could not travel because of the ambushes, and I myself let everyone quarrel with his neighbor."
,"11":"But from now on I will deal differently with this people.'"
,"12":"Yahweh says, 'I am sowing peace. The vine will give its fruit, the earth its produce, the heavens its dew and to the remnant of this people I will give all these things."
,"13":"So it will happen that just as you were a curse among the nations, now I will save you, Judah and Israel, and make you a blessing. Have no fear and let your hands be strong!'"
,"14":"This is what Yahweh, God of hosts, says: 'Just as I resolved to do you harm because your fathers angered me and I did not relent,"
,"15":"so now in these days am I determined to deal kindly with Jerusalem and Judah. Have no fear!"
,"16":"This is what you must do: Speak the truth to one another; let those who judge give peace through honest sentences"
,"17":"and do not plot evil in your heart against one another. Refrain from false oaths for it is what I detest' - word of Yahweh."
,"18":"The word of Yahweh came to me, saying:"
,"19":"'This is what you will say for my sake: From now on the fasts of the fourth, fifth, seventh and tenth months will be days of joy, happy feastdays. Only be peacemakers and sincere people.'"
,"20":"Yahweh, the God of hosts speaks, 'People will come from other nations, people from great cities."
,"21":"The inhabitants of one town will talk with those of another and say: 'Come, let us go and implore the favor of Yahweh, and I, too, will seek Yahweh.'"
,"22":"Many great peoples and powerful nations will come seeking Yahweh, God of hosts, in Jerusalem and pray to him.'"
,"23":"Yahweh, the God of hosts assures you, 'In those days ten men of different languages spoken in various lands, will take hold of a Jew by the hem of his garment and say: We, too, want to go with you for we have heard that God is with you.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Word of Yahweh. Yahweh dwells in the land of Hadrach and Damascus for the cities of Aram belong to him as do all the tribes of Israel,"
,"2":"and Hamath as well, on its border, and Tyre and Sidon, the people who do good business."
,"3":"Tyre built herself a stronghold and piled up silver like dust, gold like the mud in the street."
,"4":"But the Lord will take away her possessions and throw down her power on the sea and she herself will perish by fire."
,"5":"Ashkelon will see and be afraid; Gaza, too, will tremble and Ekron as well for her hope will fade. The king will disappear from Gaza and Ashkelon will be without inhabitants."
,"6":"People of low birth will occupy Ashdod. I will put an end to the pride of the Philistines."
,"7":"I shall take the meat with blood from their mouth and their unclean food from between their teeth. Only a remnant of them will be left and they will become like a clan among the Judeans. The people of Ekron will be like the Jebusites at the present time."
,"8":"I shall camp as a guard near my House to protect it from all who come and go. No longer shall an oppressor crush them now for I am aware of their affliction."
,"9":"Rejoice greatly, daughter of Zion!,Shout for joy, daughter of Jerusalem!,For your king is coming, just and victorious, humble and riding on a donkey, on a colt, the foal of a donkey."
,"10":"No more chariots in Ephraim, no more horses in Jerusalem, for he will do away with them. The warrior's bow shall be broken when he dictates peace to the nations. He will reign from sea to sea, and from the River to the ends of the earth."
,"11":"As for you, for the sake of your covenant sealed with blood, I shall release your prisoners from the ancient cistern."
,"12":"The prisoners who wait in expectation will return to you, O Zion; today I declare that I will repay you double for your exile."
,"13":"I shall bend my bow - Judah - and Ephraim shall be my arrow. I shall send your sons, O Zion, against the Greeks! For me you shall be a warrior's sword."
,"14":"Yahweh will appear above them, his arrows flashing like lightning. He will sound his horn and come in a storm from the south."
,"15":"Yahweh, God of hosts, will protect them; they will triumph and trample the wicked. They will drink blood like wine and be filled with it like the bowls of the drink offering, like the horns of an altar."
,"16":"On that day, Yahweh, their God, will save them and pasture them like a flock."
,"17":"How happy! how beautiful it will be! Grain will make young men flourish and new wine, the maidens!"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Ask from Yahweh the spring rain, and Yahweh, who makes the lightnings, will send showers of rain and make grass sprout in each one's field."
,"2":"The home idols utter empty words and diviners have false visions, dreams that foretell illusions and offer empty comfort."
,"3":"This is why the people stray like sheep without a shepherd. Against these shepherds my anger is aroused and I will punish the leaders. When Yahweh of hosts visits his flock, the nation of Judah, he will make it his proud war horse. "
,"4":"He will provide the host and the spear, the bow in battle and all the leaders."
,"5":"They will be like warriors trampling mud in battle. They will fight recalling that Yahweh is with them and rout those on horses."
,"6":"'I will strengthen the nation of Judah and save the descendants of Joseph. I will bring them back for I have compassion on them and they will be as if I had never rejected them, for I am Yahweh, their God, who hears their cry."
,"7":"Ephraim's men will be like heroes and feel joyful as if warmed by wine. Their children will rejoice on seeing it; their hearts will exult in Yahweh."
,"8":"Yahweh says: I shall whistle and gather them together for I have redeemed them and they shall be as numerous as before."
,"9":"Then I shall spread them among the nations, but from the most distant lands they will remember me. There they shall raise their children who will return."
,"10":"I shall bring them back from Egypt and gather them from Assyria. I shall give them again the land of Gilead and Lebanon but these will not suffice for them."
,"11":"They will pass through the sea of Egypt and the depths of the Nile will be dried up. Then the arrogance of Assyria will be cast down and Egypt will no longer have a king."
,"12":"I shall strengthen them, says Yahweh, and they shall advance confident in my Name.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Open your gateways, Lebanon, to let fire devour your cedars."
,"2":"Lament, cypresses, for the cedar has fallen. The majestic ones have been brought low. Wail, oaks of Bashan, for the impenetrable forest has been cut down."
,"3":"The sighs of the shepherds reecho because their beautiful plain has been ravaged. The young lions' roar reechoes because the fruitful valley of the Jordan is laid waste."
,"4":"Yahweh, my God, said to me: 'Pasture the sheep to be slaughtered,"
,"5":"for their buyers slay them and get away with it, whereas those who sell them say: 'Praised be Yahweh! I am rich!' And their shepherds hardly give them a thought."
,"6":"Yahweh says: I shall no longer give a thought to the inhabitants of this land, and I am handing over each one to the power of his shepherd; although their king may oppress the land, I shall not rescue this people from their power.'"
,"7":"So I became the shepherd of the sheep to be slaughtered and provided myself with two staffs - one I called Favor and the other Bonds. I then pastured my flock,"
,"8":"doing away with three leaders in one month. I lost patience with them and they, for their part, were disgusted with me."
,"9":"So I said, 'No longer shall I shepherd you: whatever is to die, let it die and let what is to perish, perish, and let those who are left devour each other's flesh.'"
,"10":"Then I took and broke my staff Favor to break the covenant I had made with all nations."
,"11":"It was broken off that day and the sheep merchants who watched knew it was Yahweh who had spoken."
,"12":"I then said to them, 'If you agree, give me my wages, otherwise let it go.' So they weighed out my wages, thirty pieces of silver."
,"13":"And Yahweh said to me, 'Throw it into the treasury, this splendid sum at which they valued me!' So I took the thirty pieces of silver and threw them into the treasury in Yahweh's House."
,"14":"I then snapped in two my second staff Bonds, doing away with the friendship between Judah and Israel."
,"15":"Then Yahweh said to me, 'Take another disguise, one that is fitting for a foolish shepherd"
,"16":"for I am going to raise up another shepherd who will care nothing for lost sheep nor will he search for strays, or bind up the injured and pasture those that survive. No, but he will eat the fat ones and tear off their hoofs.'"
,"17":"Woe to the worthless shepherd who abandons his flock! May the sword strike his arm and his right eye! Let his arm wither and his right eye be blind!"
}`)
	CurrentBook.AddChapter(12, `{
"1":"An oracle. This is the word of Yahweh concerning Israel. Word of Yahweh, who spread out the heavens, laid the foundations of the earth and formed the spirit of man within him."
,"2":"'See, I am making of Jerusalem a cup that will send the nations reeling; it will happen when Jerusalem is besieged."
,"3":"On that day I shall make Jerusalem an immovable rock for all the nations around her. All the nations will be united against her and all who try to lift the rock will be badly injured.'"
,"4":"Yahweh says: 'On that day I will make every horse wild with fright, every rider demented. All the horses of the nations will be blinded but I will watch over Judah"
,"5":"and the leaders of the clans of Judah will say to themselves: 'The strength of the inhabitants of Jerusalem comes from Yahweh their God.'"
,"6":"On that day I will make the leaders of the clans of Judah like a fire in a woodland and a flaming torch among the sheaves. They will devour right and left all the nations around them, while Jerusalem will continue to hold its site."
,"7":"Yahweh will first save the towns and villages of Judah so that David's people and the inhabitants of Jerusalem will not feel more important than the rest of Judah."
,"8":"On that day Yahweh will strengthen the inhabitants of Jerusalem in such a way that the weaklings among them shall be like David and David's people who lead them, will be like God, like an angel of Yahweh."
,"9":"On that day I will see to the destroying of all the nations that came against Jerusalem."
,"10":"I will pour out on the family of David and the inhabitants of Jerusalem a spirit of love and supplication. They will look at the one who was pierced and mourn for him as for an only child, weeping bitterly as for a firstborn."
,"11":"The mourning in Jerusalem will be as great as the mourning of Haddadrimmon in the plain of Megiddo."
,"12":"Each family will mourn individually: the family of David by themselves and their wives separately; the family of Nathan by themselves and their wives separately,"
,"13":"the family of Levi by themselves and their wives separately, the family of Shimei by themselves and their wives separately"
,"14":"and the same with the other families, each family by themselves and their wives separately."
}`)
	CurrentBook.AddChapter(13, `{
"1":"On that day a spring will well up for the family of David and for the inhabitants of Jerusalem to cleanse themselves of sin and defilement. Yahweh, God of hosts says: "
,"2":"On that day I will wipe out the names of idols from the land and never again will they be mentioned."
,"3":"I will also remove the prophets and their unclean spirits and expel them from the land. If a prophet does prophesy, his parents: father and mother, will say to him: 'You shall live no longer for you uttered lies in the name of Yahweh.' His own father and mother will stab him when he prophesies."
,"4":"On that day the prophets will be ashamed of their prophetical visions and no longer wear a prophet's garment of hair in order to deceive."
,"5":"Instead, each of them will say: 'I am not a prophet, I am a farmer, the land has owned me since my youth.'"
,"6":"And if anyone says to him: 'What are these wounds on your hands?' He will answer: 'With these I was wounded in my friend's house.'"
,"7":"'Sword, awake and strike my shepherd, the man who is near to me!' says Yahweh, God of hosts. 'Strike the shepherd and let the flock be scattered!' Yahweh threatens, 'I will turn against the little ones,"
,"8":"and in all the land, two thirds shall be destroyed and one third left."
,"9":"This third shall be cleansed by fire; I shall refine them as silver is refined; I shall test them as gold is tested. They shall call upon my Name and I will hear them. I will say, 'They are my peo-ple,' and they shall say, 'Yahweh is my God.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"The day of Yahweh will come when people will divide spoils in your midst."
,"2":"I will let all the nations come against Jerusalem to attack it. The city will be taken and houses pillaged, women violated. Half of the city will be deported but the rest will not be removed."
,"3":"Then Yahweh will go forth and fight against the nations as he does on the day of battle."
,"4":"On that day his feet will rest on the mount of Olives, facing Jerusalem on the east and the mount of Olives will be split in two from east to west by a deep valley leaving half of the mountain to the north and half to the south."
,"5":"You will flee through my mountain valley for it will extend as far as Azel. You will flee as you fled from the earthquake in the days of Uzziah, king of Judah, and Yahweh will come and all his holy ones with him."
,"6":"On that day there will be no cold or frost."
,"7":"It will be a unique day, known to Yahweh, without day or night and when evening comes there will still be light."
,"8":"On that day living water will flow from Jerusalem, half to the sea in the east, half to the sea in the west; it will never dry up in summer or in winter."
,"9":"Yahweh will be king of all the earth. On that day there will be Yahweh alone and only his Name."
,"10":"All the land will be turned into a plain from Geba to Rimmon in the Negeb, but Jerusalem shall be outstanding on its heights, from the Benjamin Gate to the First Gate, to the Corner Gate and from the tower of Hananel to the royal winepress."
,"11":"Its people shall no longer fear any disaster. Jerusalem shall be inhabited and secure."
,"12":"And this is how Yahweh will punish all the nations that made war on Jerusalem: each one's flesh will rot even as he stands, and their eyes will rot in their sockets, their tongue in their mouth."
,"15":"A similar plague shall strike the horses, mules, camels and donkeys, and all the animals in their camps."
,"13":"On that day Yahweh will cause great panic among them: they will take hold of one another and attack one another"
,"14":"while the men of Judah fight in Jerusalem. The wealth of all the neighboring nations will be left in that place, gold, silver and garments in great quantities."
,"16":"The survivors of all the nations that fought against Jerusalem will come, year by year, to worship Yahweh, God of hosts and celebrate the feast of Tabernacles."
,"17":"If any peoples of the earth do not go up to Jerusalem to worship the King Yahweh, God of hosts, they will have no rain."
,"18":"If the Egyptian people do not go up and take part, they too will be afflicted with the plague destined for those who do not go up to celebrate the feast of Tabernacles."
,"19":"That shall be the punishment of Egypt and of all the nations who do not go up to celebrate the feast of Tabernacles."
,"20":"On that day, even the bells of the horses shall be inscribed: 'Consecrated to Yahweh.'"
,"21":"The cooking pots of the Temple will be as sacred as the bowls of offering that are used for the altar, and even the ordinary cooking pots of the people of Jerusalem and Judah will be consecrated to Yahweh, God of hosts. So everyone who offers sacrifice may use them for cooking. Still more: from that day, there will no longer be merchants in the House of Yahweh, God of hosts."
}`)

}
func EN_CCB_LoadVPDTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"These are the words that Moses spoke to all Israel, at the other side of the Jordan River, in the Arabah desert. They were facing Suf, between Paran, Tophel, Laban, Hazeroth and Dizahab."
,"2":"From Mount Horeb to Kadesh-Barnea they had had a journey of eleven days through the mountains of Seir."
,"3":"But now it was the first day of the eleventh month of the fortieth year after they left Egypt, when Moses told the children of Israel all that Yahweh had commanded him regarding them."
,"4":"After defeating Sihon, the king of the Amorites, who lived in Heshbon, and Og, the king of Bashan who ruled in Ashtaroth and in Edrei,"
,"5":"Moses began to explain this law. They were in the land of Moab, at the other side of the Jordan."
,"6":"Moses said, 'Yahweh, our God, spoke to us at Mount Horeb: 'You have stayed long enough at this mountain."
,"7":"Leave this place and go into the territory of the Amorites and to its neighboring peoples in the Arabah, the Mountains, the Lowlands, the Negeb and the seacoast, into the land of Canaan and Lebanon up to the great Euphrates River."
,"8":"Look: I offer you this land; you will take possession of it and live in the land which Yahweh swore to give to your fathers, to Abraham, Isaac and Jacob and to all their descendants.'"
,"9":"I said to you at that time: 'I alone cannot be responsible for all of you."
,"10":"Yahweh, your God, has multiplied you, and now, you are as numerous as the stars in heaven."
,"11":"May Yahweh, the God of your fathers, increase you a thousand times more and bless you just as he promised."
,"12":"But how can I alone resolve all your problems and disputes?"
,"13":"Look for intelligent, keen-sighted and experienced men from each of your tribes, and I will place them over the people.'"
,"14":"And you answered: 'What you ask us to do is right.'"
,"15":"Thus, I chose from among the heads of your tribes wise and experienced men and placed them over you as leaders of the thousands, hundreds, fifties, and tens, and also as secretaries for each tribe."
,"16":"And I gave this order to the judges: 'Attend to the complaints of your brothers, and judge with justice the lawsuit between an Israelite and his brother, or between an Israelite and a foreigner who lives in your midst."
,"17":"Do not be influenced by anyone when you judge, but listen to the poor and the rich alike, to the powerful as well as the weak, and do not be afraid of anyone because you act in place of God. And if there arises a very difficult case for you, refer this to me and I will attend to it.'"
,"18":"At that time, I established what you had to do."
,"19":"Finally, having left Horeb, we passed through that wide and terrible desert that we saw, on the way to the hill country of the Amorites, as Yahweh had commanded us, and arriving at Kadesh-Barnea,"
,"20":"I said to you: 'We have come to the mountain of the Amorites which Yahweh, our God, gives us. "
,"21":"Look, Israel, at the land which Yahweh gives you; take possession of that which was promised to your fathers. Do not be afraid or discouraged.'"
,"22":"Then all of you gathered around me and said to me: 'Better send some men before us to explore the land and map out the roads leading to the cities where we are to go.'"
,"23":"That was a good suggestion, so I took twelve men from among you, one from each tribe,"
,"24":"who set out and climbed the mountains on foot until they came to the Valley of the Grapevines."
,"25":"And once there, they took with them the fruits of the valley, and upon their return recounted to us what they had seen. They told us: 'The land which Yahweh gives us is a good land.'"
,"26":"Nevertheless, you did not want to go up into the mountains but rebelled against the commands of Yahweh."
,"27":"And you began to murmur in your tents: 'Yahweh does not like us; he made us leave Egypt to turn us over to the Amorites who in turn will kill us all."
,"28":"Where shall we go? The messengers have frightened us with what they told us: The people who live in the land are greater and taller than us. The cities are great and are fortified with high walls. We have seen giants there as in times past.'"
,"29":"Then I said to you: 'Have no fear and do not be afraid of them."
,"30":"Yahweh who leads you will likewise fight for you as he did in Egypt."
,"31":"You have also seen what he did in the desert where he carried you all the way just as a father carries his son, until we came to this place.'"
,"32":"But still you would not believe Yahweh, our God,"
,"33":"who went before you in all your journeys, and has instructed you where to set up camp; by night he has shown you the way with fire and by day with a cloud."
,"34":"And when Yahweh heard the rumblings of your complaints, he was angry and he swore:"
,"35":"Not one from this perverse generation will see the beautiful land which I swore to give to your fathers"
,"36":"except Caleb, the son of Jephunneh. He shall see it and I will give him and his children the land upon which he trod because he has faithfully followed Yahweh."
,"37":"Yahweh was angry with me as well because of your fault, and he said to me: 'Neither will you enter there;"
,"38":"but your assistant, Joshua, the son of Nun, will enter. Encourage him because he will be the one to give Israel its inheritance."
,"39":"Your children will enter there; to them will I give the land, and they will possess it although you feared they would become the prey of your enemies."
,"40":"But as for you, go back into the desert by the Red Sea.'"
,"41":"And you answered me: 'We have sinned against Yahweh, our God. Now, we will go and fight as he has commanded us.' So each one took his weapons and thought it easy to climb the mountains."
,"42":"But Yahweh told me: 'Tell them not to go and fight because I am not with them, or else they will be defeated by the enemy.'"
,"43":"I told you this but you did not listen. You disobeyed the order of Yahweh and went up to the mountains instead."
,"44":"Then the Amorites who live on those mountains came out to meet you; they struck you and pursued you like bees from Seir to Hormah."
,"45":"And you returned with much weeping in the presence of Yahweh who did not want to hear you nor listen to your voice."
,"46":"So you were to remain at Kadesh for many days; and you know how long it was."
}`)
	CurrentBook.AddChapter(2, `{
"1":"We, therefore, turned back and set out towards the desert by the way leading to the Red Sea, as Yahweh had commanded me, and we walked around the mountains of Seir for a long time."
,"2":"Then, Yahweh said to me:"
,"3":"'You have been going around these mountains for a long time; now, go north."
,"4":"Give this command to the people: You are to pass through the territory of your brothers, the children of Esau, who live in Seir. They will be afraid of you,"
,"5":"but be very careful that you do not attack them because I will not give you even the parcel of land on which you stand. Know that I have given to Esau the mountains of Seir as a possession."
,"6":"You shall buy food and water from them with your silver."
,"7":"Think of all the blessings that Yahweh has bestowed on you in all our work and how he has been present in your journey through the desert. Yahweh has been with you for forty years, and never have you been in want."
,"8":"So we passed through the land of our brothers, the children of Esau who live in Seir. We left the Arabah road that led to Elath and Ezion-geber, and we took the road going into the desert of Moab."
,"9":"Then Yahweh said to me: 'Do not attack Moab or provoke them to fight since I will not give you any of their land. Know that I have given Ar to the children of Lot as a possession.'"
,"10":"(The Emim formerly lived there - a great and numerous people, and tall as the Anakim."
,"11":"And just like the Anakim, they were also known as giants, but the Moabites called them Emim."
,"12":"And the Horites also used to live in Seir but the children of Esau drove them out, killed them and settled in their place, as Israel did in the land they possess and which Yahweh gave them.)"
,"13":"And now rise up and pass through the brook of Zered.',We then went to the brook of Zered. "
,"14":"We walked for thirty-eight years from Kadesh-Barnea until we crossed the brook, until the entire generation of the men old enough to fight had perished just as Yahweh said."
,"15":"Even the hand of Yahweh was against them, dealing them their death in the camps until all of them perished."
,"16":"When finally all those who were old enough to fight died,"
,"17":"Yahweh said to me:"
,"18":"'Today you will pass through the frontiers of Moab, facing the city of Ar,"
,"19":"and you will meet these people. Do not attack or defy them for I will not give you any of the land of the Ammonites. Know that I have given that land to the children of Lot.'"
,"20":"(This land was also considered the land of the giants who formerly lived there and whom the Ammonites called Zummim."
,"21":"They were a great and numerous people, tall and of enormous stature, similar to the Anakim. But Yahweh destroyed them through the hand of the Ammonites, and in their place he made the Ammonites to dwell in the land."
,"22":"He did the same with the people of Esau who dwell in Seir. They destroyed the Horites and took possession of their land up to this very day."
,"23":"He dealt in the same manner with the Avvim who lived in the camps as far as Gaza. They were expelled by the Caphtorim who killed them and occupied their place.)"
,"24":"Rise up and go to the brook of Arnon. Look, I give into your hands Sihon the Amorite, the king of Heshbon, and all his land."
,"25":"Begin, right now, to occupy his land and fight. And I, for my part, will begin to instill among all the peoples under heaven the dread and fear of you. They will tremble when they hear your name; they will tremble like a woman in childbirth and they will lose courage when they face you."
,"26":"From the desert of Kedemoth, I sent messengers to Sihon, the king of Heshbon, with these words of peace:"
,"27":"'I wish to pass through your land but I will go only by the road without turning aside either to the right or to the left."
,"28":"We ask you to sell us food for money that we may eat, and water that we may drink. And let us only pass through as the children of Esau who live in Seir and the Moabites who dwell in Ar did for us,"
,"29":"until we come to the Jordan and enter the land which Yahweh, our God, gives to us.'"
,"30":"But Sihon, the king of Heshbon, would not let us pass through his land, (and Yahweh made him stubborn so that our God might give him into our hands.)"
,"31":"And Yahweh said to me: 'You have to know that I have begun to give Sihon and his land over to you; begin conquering his land.'"
,"32":"Then, Sihon came out with all his men to meet us in battle at Jahaz."
,"33":"And Yahweh, our God, gave him over to us and we defeated him together with his sons and all his men."
,"34":"At that time we captured all their cities and pronounced an anathema over them, killing all their inhabitants, men, women and children without sparing anyone,"
,"35":"except the animals which were part of the plunder of the cities you have occupied."
,"36":"From Aroer, the city at the edge of the brook Arnon, up to Galaad, there was neither a village nor a city which we did not capture. Yahweh, our God, gave everything over to us,"
,"37":"except the land of the Ammonites which we did not touch, the banks of the river Jabbok and the cities in the mountains, that is, all the places which Yahweh, our God, forbade us to take."
}`)
	CurrentBook.AddChapter(3, `{
"1":"On turning back, we went up the way to Bashan. Og, the king of Bashan, and all his people came out to fight us in Edrei."
,"2":"Then Yahweh said to me: 'Do not be afraid because I am giving him into your hands together with his people and his land, that you may do to him what you did to Sihon, the Amorite king who lived in Heshbon.'"
,"3":"And Yahweh gave Og, the king of Bashan, and all his people into our hands; and sparing no one, we killed everyone by the sword."
,"4":"We took possession of all their cities; there was not one of them that escaped us. We captured the sixty cities: the whole of the Argob region - the kingdom of Og, in Bashan."
,"5":"All these were cities fortified with high walls, with gates and bars, besides the innumerable villages in the open fields."
,"6":"We completely destroyed them for the honor of Yahweh, killing all the people, as we had done with Sihon, the king of Heshbon: we wiped out all the cities, men, women and children."
,"7":"The only things that we spared and kept for ourselves were the livestock and the plunder from the cities."
,"8":"We took possession of the land occupied by the two Amorite kings, the land beyond the Jordan, from the brook of Arnon up to the Mount of Hermon"
,"9":"(the Sidonians call Hermon Sirion while the Amorites call it Senir.)"
,"10":"And we captured all the cities on the plateau and all the land of Galaad and Bashan as far as Salecah and Edrei, cities in the kingdom of Og, in Bashan."
,"11":"(Og, the king of Bashan, was the last survivor in the race of the giants. His iron bed, which is four and a half meters long and two meters wide, can be seen in Rabbah, a city of the Ammonites.)"
,"12":"Then, we took possession of that land. I gave to the tribes of Reuben and Gad half of the mountains of Gilead with their cities, from Aroer situated at the edge of the brook of Arnon."
,"13":"And I gave to half of Manasseh's tribe the other half of the kingdom of Gilead and the whole kingdom of Og, or Bashan with the whole of the Argob region. The whole land of Bashan was called the land of the giants."
,"14":"Jair, a son of Manasseh, took all the territories of Argob up to the boundaries of Gesuri and Maacati. And he gave his name to these cities which until today are called villages of Jair."
,"15":"I gave part of Gilead to Makhir."
,"16":"And to the tribes of Reuben and Gad, I gave the territory from Gilead up to the brook of Arnon (the boundary lies halfway along the brook) and up to the river Jabbok, the boundary of the territory of the sons of Ammon."
,"17":"It is bounded by the Arabah in the west, and in the east by the Jordan, from Kinnereth up to the sea in the desert, known as the Salt Sea, at the foot of Mount Pisgah."
,"18":"Then I gave you these orders: 'Yahweh, our God, has given you this land to own."
,"19":"But only your women, your children and your livestock, your numerous livestock, will remain in the cities which I have given you."
,"20":"All the strong men will go armed ahead of their Israelite brothers until Yahweh gives them a place where they can rest as he has given you, and they too possess the land which I will give you at the other side of the Jordan. Then each one of you will return to his own inheritance which I have given you.'"
,"21":"I also gave the following order to Joshua: 'You have seen with your own eyes what Yahweh has done with those two kings, and he will do the same to the kingdoms where you shall go."
,"22":"Do not be afraid because Yahweh will fight for you.'"
,"23":"Then I asked Yahweh:"
,"24":"'Yahweh, my Lord, you have begun to manifest your greatness and the power of your hand. For what God in the heavens and on the earth can do such works and deeds as you have done?"
,"25":"Do let me go and see that splendid land at the other side of the Jordan, those mountains without comparison and Lebanon, too.'"
,"26":"But because of your fault, Yahweh was angry with me and did not hear me. And Yahweh said to me: 'It is enough, speak no more of this to me,"
,"27":"but climb to the top of Mount Pisgah and from there look to the west and to the north, to the south, and to the east. You shall see the land, but you shall not cross over the Jordan."
,"28":"Give your orders to Joshua, encourage him and strengthen him because he will be the one to bring this people across and distribute to them the land which you see.'"
,"29":"We, then, remained in the valley opposite Bethpeor."
}`)
	CurrentBook.AddChapter(4, `{
"1":"And now, Israel, listen to the norms and laws which I teach that you may put them into practice. And you will live and enter and take possession of the land which Yahweh, the God of your fathers, gives you."
,"2":"Do not add anything to what I command you nor take anything away from it. But keep the commandments of Yahweh, your God, as I command you."
,"3":"You have seen with your own eyes what Yahweh has done with Baal-peor and with those who served him. Yahweh has destroyed them."
,"4":"But you who have been faithful to Yahweh, your God, are all alive today."
,"5":"See, as Yahweh, my God, ordered me, I am teaching you the norms and the laws that you may put them into practice in the land you are going to enter and have as your own."
,"6":"If you observe and practice them, other peoples will regard you as wise and intelligent. When they come to know of all these laws, they will say, 'There is no people as wise and as intelligent as this great nation.'"
,"7":"For in truth, is there a nation as great as ours, whose gods are as near to it as Yahweh, our God, is to us whenever we call upon him?"
,"8":"And is there a nation as great as ours whose norms and laws are as just as this Law which I give you today?"
,"9":"But be careful and be on your guard. Do not forget these things which your own eyes have seen nor let them depart from your heart as long as you live. But on the contrary, teach them to your children and to your children's children."
,"10":"You were in the presence of Yahweh at Mount Horeb when he spoke to me, 'Gather the people before me that they may hear my words. Thus they will fear me as long as they live in that land and will teach these words to their children.'"
,"11":"Then you came nearer and stood at the foot of the mountain. It was burning in flames reaching up to heaven amid the dense fog and the dark clouds."
,"12":"And Yahweh spoke to you from the midst of the fire. You heard the sound of words but did not see any figure; you only heard a voice."
,"13":"And Yahweh spoke to you that you might know his Covenant by which he commanded you to keep his ten commandments, which he had written on two slabs of stone."
,"14":"And as for me, he commanded me to teach you the norms and laws that you might put them into practice in the land which is going to be yours."
,"15":"Think well about what you are to do. You did not see any form on that day when Yahweh spoke to you at Mount Horeb from the midst of the fire."
,"16":"Therefore, do not become corrupted: do not make an idol or a god carved in the form of a man or of a woman,"
,"17":"or in the form of any animal that lives on the earth, or of any kind of bird that flies in the sky,"
,"18":"or of any reptile that crawls on the earth, or of any fish that lives in the water under the earth."
,"19":"When you look at the heavens and you see the sun, the moon, the stars, and all the heavenly bodies, do not prostrate yourselves to adore and serve them as gods."
,"20":"Yahweh, your God, has left those for the rest of the peoples, but he has chosen you and has brought you from the fiery crucible, that is Egypt, to be his own people as you are now."
,"21":"Through your fault, Yahweh became angry with me and he swore that I would not cross the Jordan nor enter into the beautiful land which he gives you as an inheritance."
,"22":"I will die in this land and not be able to cross the Jordan. You, in turn, will cross over and possess that beautiful land."
,"23":"So, be careful not to forget the Covenant which Yahweh has made with you and do not make any kind of idols, as Yahweh, your God, has commanded you."
,"24":"Know that Yahweh, your God, is a devouring fire, Yahweh is a jealous God."
,"25":"When you have children and grandchildren and have grown old in the land, do not be corrupted by having idols and doing that which offends Yahweh. If you anger him, you will perish from the land which is going to be yours after crossing the Jordan."
,"26":"Heaven and earth are witness to my warning: you will all be destroyed."
,"27":"Yahweh will scatter you among the peoples and only a few of you will remain among the nations where Yahweh will bring you."
,"28":"There you will be obliged to serve their gods, gods made by human hands, gods of wood and stone, which do not see or hear, or eat or feel."
,"29":"There you will look for Yahweh, your God, and you will encounter him if you search for him with all your heart and with all your soul in the midst of your anguish."
,"30":"When this happens in the last days, you will return to Yahweh, and you will listen to his voice."
,"31":"Because Yahweh, your God, is a merciful God who will not reject you nor destroy you all, nor forget the Covenant he swore to your fathers."
,"32":"Ask of the times past. Inquire from the day when God created man on earth. Ask from one end of the world to the other: Has there ever been anything as extraordinary as this?"
,"33":"Has anything like this been heard of before? Has there ever been a people who remained alive after hearing as you did the voice of the living God from the midst of the fire?"
,"34":"Never has there been a God who went out to look for a people and take them out from among the other nations by the strength of trials and signs, by wonders and by war, with a firm hand and an outstretched arm. Never has there been any deed as tremendous as those done for you by Yahweh in Egypt, which you saw with your own eyes."
,"35":"You saw this that you might know that Yahweh is God and that there is no other besides him."
,"36":"He let you hear his voice from heaven that you might fear him; on earth he let you see his blazing fire and from the midst of the fire you heard his word."
,"37":"Because of the love he had for your fathers, he chose their descendants after them, and he himself made you leave Egypt with his great power."
,"38":"He expelled before you peoples more numerous and stronger than you, and he has made you occupy their land: today he has given this to you as an inheritance."
,"39":"Therefore, try to be convinced that Yahweh is the only God of heaven and earth, and that there is no other."
,"40":"Observe the laws and the commandments that I command you today, and everything will be well with you and your children after you. So you will live long in the land which Yahweh, your God, gives you forever.'"
,"41":"Moses designated three cities at the other side of the Jordan, on the east,"
,"42":"where one who involuntarily kills his neighbor may find refuge, one who has never been his enemy before. He should flee into one of those cities and so save himself."
,"43":"These are the cities: Bezer on the desert plateau for the tribe of Reuben, Ramoth in Gilead for the tribe of Gad, and Golan in Bashan for the tribe of Manasseh."
,"44":"This is the Law which Moses gave to the children of Israel."
,"45":"These are the precepts, decrees, and laws which Moses made known to the children of Israel after their departure from Egypt,"
,"46":"at the other side of the Jordan, in the valley opposite Beth-peor, in the land of Sihon, the king of the Amorites. This Sihon, who lived in Heshbon, was defeated by Moses and the children of Israel after their departure from Egypt"
,"47":"and they took possession of his land, as they had done with Og, the king of Bashan. The two Amorite kings ruled at the east of the Jordan,"
,"48":"from Aroer at the boundary of the brook of Arnon, up to Mount Sirion, also called Hermon"
,"49":"that is, the whole plain to the east of the Jordan up to the Dead Sea at the foot of Mount Pisgah."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Moses gathered the whole of Israel and said to them: 'Listen, Israel, to the laws and norms which I teach you this day. Learn them and be careful to put them into practice."
,"2":"Yahweh, our God, made a covenant with us in Horeb, and his covenant"
,"3":"was not only with our fathers, but with us as well who are all alive here today."
,"4":"Yahweh spoke with us face to face from the midst of the fire in the mountain."
,"5":"And I stood between Yahweh and you to transmit his word to you, since you could not go up the mountain for fear of the great fire. These were his words:"
,"6":"I am Yahweh, your God, who brought you out of the land of Egypt, the house of slavery."
,"7":"Do not have other gods before me."
,"8":"Do not have idols, do not make any figure of things in the heaven or here below on the earth, or in the waters under the earth."
,"9":"Do not kneel before them or worship them, because I, Yahweh, am your God, a jealous God who punishes the children until the third and fourth generation for the wickedness of their fathers who hate me."
,"10":"But I am merciful to the thousandth generation to those who love me and obey my commandments."
,"11":"Do not take the name of Yahweh, your God, in vain because Yahweh will not leave unpunished him who takes his name in vain."
,"12":"Take care to keep holy the sabbath day, as Yahweh, your God, commands you."
,"13":"You have six days to work and do your tasks."
,"14":"But the seventh day is the Day of Rest in honor of Yahweh, your God. Do not do any work, you or your child, or your servant, or your ox, or your donkey, or any of your animals. Neither will the foreigner who lives in your land work. Your servant will rest just like you."
,"15":"Remember that you were once enslaved in the land of Egypt from where Yahweh, your God, brought you out with his powerful hand and outstretched arm. For that reason, Yahweh, your God, commands you to observe the sabbath."
,"16":"Honor your father and your mother as Yahweh, your God, has commanded, and you will live long and it will be well with you in the land which Yahweh, your God, gives you."
,"17":"Do not kill."
,"18":"Do not commit adultery."
,"19":"Do not steal."
,"20":"Do not give false testimony against your neighbor."
,"21":"Do not desire the wife of your neighbor. Do not covet the house of your neighbor, or his field, or his servant, or his ox, or his donkey, or anything that is his."
,"22":"These are the words of Yahweh said to the whole assembly on the mountain when he spoke from the midst of the fire and the thick cloud. He said only this and he wrote these words on the two slabs of stone which he gave to me."
,"23":"You heard that voice in the midst of darkness, while the mountain was becoming resplendent. Then all the heads of the tribes together with the elders gathered around me"
,"24":"and said: 'See, Yahweh, our God, has shown us his glory and greatness, and we have heard his voice from the midst of the fire. We now know that the word of Yahweh is life for man."
,"25":"We are, nevertheless, going to die devoured by this terrible fire if we keep listening to the voice of Yahweh, our God."
,"26":"What man can remain alive after listening to the voice of the living God speaking from the midst of the fire, as he has now done for us?"
,"27":"Better that you go nearer to hear all the things that Yahweh, our God, will say to you. Then tell these to us that we may put them into practice.'"
,"28":"Yahweh heard your words and said to me, 'I have heard what this people said and they have spoken well."
,"29":"May they always have the same spirit, fear me and observe all my precepts that all may go well with you and with your children for all time."
,"30":"Rise up and tell them to return to their tents in the fields."
,"31":"But as for you, remain here with me that I may teach you all the commandments, precepts and laws which you have to teach that they may put them into practice in the land that I will give them as a possession.'"
,"32":"Observe and carry out the things that Yahweh has commanded us. Do not turn aside from them either to the right or to the left."
,"33":"Follow all the way which Yahweh has marked out for you, and you will live and be happy and you will live long in the land you are going to conquer."
}`)
	CurrentBook.AddChapter(6, `{
"1":"These are the commandments, the norms and the laws that Yahweh, your God, has commanded me to teach you so that you may observe them in the land which is going to be yours."
,"2":"Fear Yahweh, observe his commandments all the days of your life and his norms that I teach you today. So also for your children and your children's children that they may live long."
,"3":"Listen, then, Israel, observe these commandments and put them into practice. If you do this, you will be well and you will multiply in this land flowing with milk and honey, as Yahweh, the God of your fathers, promised you."
,"4":"Listen, Israel: Yahweh, our God, is One Yahweh."
,"5":"And you shall love Yahweh, your God, with all your heart, with all your soul and with all your strength."
,"6":"Engrave on your heart the commandments that I pass on to you today."
,"7":"Repeat them over and over to your children, speak of them when you are at home and when you travel, when you lie down and when you rise."
,"8":"Brand them on your hand as a sign, and keep them always before your eyes."
,"9":"Engrave them on your doorposts and on your city gates."
,"10":"Do not forget Yahweh when he has led you into the land which he promised to your fathers, to Abraham, Isaac and Jacob; for he will give you great and prosperous cities which you did not build,"
,"11":"houses filled with everything good which you did not provide, wells which you did not dig, vineyards and olive groves which you did not plant. So when you have eaten and have been satisfied,"
,"12":"do not forget Yahweh who brought you out from Egypt where you were enslaved."
,"13":"Fear Yahweh, your God, serve him and call on his Name when you have to swear an oath."
,"14":"Do not go after other gods; do not serve any of the gods of the nations around you,"
,"15":"because your God, who is in your midst, is a jealous God. And when he burns in anger, you shall disappear from the face of the earth."
,"16":"You shall not put Yahweh, your God, to the test, as you did in Massah."
,"17":"Observe the precepts, the commandments and the norms that Yahweh has commanded you."
,"18":"You shall do what is right and good in the eyes of Yahweh that you may be happy and may come to possess the splendid land which he swore to your fathers"
,"19":"he would give you after having destroyed all your enemies before you."
,"20":"And when your child asks you one day: What are these precepts, these commandments and these norms which Yahweh has commanded us?"
,"21":"You shall answer your child: We were Pharaoh's slaves in Egypt, but Yahweh led us out of Egypt with prodigious deeds."
,"22":"And we have seen the great and wonderful things, the awesome marvels he has done against Pharaoh and all his people."
,"23":"And he took us out from there to lead us into the land which he promised to our fathers."
,"24":"Yahweh has commanded us to put into practice all these precepts and to fear him, our God. Because of this, we are happy and alive today,"
,"25":"and we shall be perfect in his eyes if we observe and practice these commandments as he has told us to do."
}`)
	CurrentBook.AddChapter(7, `{
"1":"When Yahweh, your God, has brought you into the land where you are going and which you will conquer; when he drives away before you many peoples - the Hittites, the Girgashites, the Amorites and the Canaanites, the Perizzites, the Hivites, and the Jebusites - seven nations that are much more numerous and more powerful than you;"
,"2":"when he has given them into your hand and you defeat them, you must destroy them all according to the law of anathema."
,"3":"Do not make any covenant with them or have compassion on them."
,"4":"Do not intermarry with them, giving your daughters to their sons, or taking their daughters for your sons, because they would seduce your children to abandon me and adore strange gods for which the anger of Yahweh would burn against you, and then he would destroy you."
,"5":"On the contrary, this is what you must do: destroy their altars and break their sacred pillars into pieces, demolish their poles and burn their idols."
,"6":"You are a people consecrated to Yahweh, your God. Yahweh has chosen you from among all the peoples on the face of the earth, that you may be his own people."
,"7":"Yahweh has bound himself to you and has chosen you, not because you are the most numerous among all the peoples (on the contrary, you are the least)."
,"8":"Rather, he has chosen you because of his love for you and to fulfill the oath he made to your fathers. Therefore, with a firm hand Yahweh brought you out from slavery in Egypt, from the power of Pharaoh."
,"9":"So know that Yahweh, your God, is the true and faithful God. He keeps his covenant, and his love reaches to the thousandth generation for those who love him and fulfill his commandments,"
,"10":"but he punishes in their own persons those who hate him and he repays them without delay."
,"11":"So keep the commandments, the norms and the laws that today I command you to practice."
,"12":"If you observe these norms, if you keep and practice them, Yahweh will be faithful to his Covenant and will show you the love he promised to your fathers."
,"13":"He will love you, bless you and multiply you. He will bless you with many children and abundant harvests: wheat, wine and oil; he will multiply the young of your cattle and of your sheep in the land that he promised your fathers he would give you."
,"14":"You shall be more favored than all the peoples; there will be no sterile male or female among your people or in your livestock."
,"15":"Yahweh will remove from you all infirmities, he will not let any of the plagues of Egypt which you have known fall upon you. But he will inflict them upon those who hate you."
,"16":"So, destroy all the peoples which Yahweh, your God, will put in your power. Do not have pity on them or serve their gods: this would be a trap for you."
,"17":"Perhaps you will say in your heart: 'These nations are more numerous than I am, how then am I going to drive them away?'"
,"18":"Do not be afraid, remember what Yahweh, your God, has done with Pharaoh and with the Egyptians,"
,"19":"those terrible trials which you saw with your eyes and the marvels and signs, the strong hand and outstretched arm with which Yahweh, your God, has freed you."
,"20":"He will do the same with all the people whom you fear. Yahweh will even send wasps to destroy those who remain and hide themselves to escape from you."
,"21":"Do not be afraid of them because Yahweh, your God, is in your midst. He is a great and terrible God."
,"22":"It is he who will drive out these nations little by little before your eyes. If you were to destroy them all at once, the wild beasts would multiply and cause you trouble."
,"23":"Yahweh, your God, will give these people over to you and he will fill them with fear until they all perish."
,"24":"Yahweh will give their kings into your hands so that you may strike out their name from under heaven, and nothing will stand before you until you have destroyed them."
,"25":"Burn the images of their gods and do not covet the gold or silver that covers them. Do not take it for yourself lest you be trapped by it, because Yahweh hates it."
,"26":"None of these shall enter your house, for as they are accursed, the curse might return to you. Regard these as abominable because they are indeed 'anathema' or accursed."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Be careful to fulfill all the commandments which I give you today, that you may live and increase, and conquer the land which Yahweh promised on oath to your fathers."
,"2":"Remember how Yahweh, your God, brought you through the desert for forty years. He humbled you, to test you and know what was in your heart, whether you would keep his commandments or not."
,"3":"He made you experience want, he made you experience hunger, but he gave you manna to eat which neither you nor your fathers had known, to show you that man lives not on bread alone, but that all that proceeds from the mouth of God is life for man."
,"4":"Your garment did not even fray, or your foot swell all these forty years."
,"5":"Understand, then, that Yahweh has taught you in the same way that a father teaches his child."
,"6":"Observe the commandments of Yahweh, your God; follow his ways and revere him."
,"7":"For Yahweh, your God, will bring you into that good land, a land of streams and rivers, of subterranean waters that gush forth in the valleys and mountains,"
,"8":"a land of wheat and barley, of grapes and figs, of pomegranates and olives, a land of oil and honey,"
,"9":"a land where the bread you eat is not rationed and where you will lack nothing, a land with iron in stones and copper mines in the mountains."
,"10":"You shall eat until you are satisfied, and you shall bless Yahweh for the good land he has given you."
,"11":"So take care that you do not forget Yahweh, your God, by neglecting the commandments, norms and laws that I give you today."
,"12":"And when you have eaten and have been satisfied, when you have built comfortable homes and live in them,"
,"13":"when your livestock have multiplied, when you have silver and gold in abundance, and an increase of good things of every kind,"
,"14":"then do not let your heart become proud and do not forget Yahweh, your God, who brought you out of the land of Egypt, the house of slavery."
,"15":"It is he who has led you across this great and terrible desert, full of fiery serpents and scorpions, an arid land where there is no water. But for you he made water gush forth from the hardest rock."
,"16":"And he fed you in the desert with manna which your fathers did not know. He made you experience want and put you to the test, so that it would be for your good later on, "
,"17":"lest you say, 'With my own strength I have attained all these good things.'"
,"18":"Remember Yahweh, your God, the one who gave you power to become prosperous, as you are today, in fulfillment of the Covenant he promised under oath to your fathers."
,"19":"But if you forget Yahweh and follow other gods, if you pay them homage and bow before them, I warn you right now that you will surely perish."
,"20":"In the same way that Yahweh destroyed the nations that stood in your way, so will he destroy you if you disobey Yahweh, your God."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Listen, Israel: you are to cross the Jordan today to take the land of greater and stronger nations than yourself, nations with grand cities whose walls reach up to heaven."
,"2":"They are a great people, they are tall - the Anakites whom you have seen and of whom you heard it said that nothing can overcome them."
,"3":"But today you will see Yahweh, your God, crossing the Jordan before you. He will destroy them all and he will subject them to you. Then, you will seize the land from them and make them perish, as Yahweh promised you."
,"4":"When Yahweh, your God, has destroyed them in your presence, do not think: 'Yahweh brought me to this land and gave it to me because of my own goodness.' Yahweh drove those nations out because of their wickedness."
,"5":"It is not by your merits nor because you are good that you will conquer the land: Yahweh will deprive them of the land because they have done evil, and also to fulfill the promise he swore to your fathers, to Abraham, Isaac and Jacob."
,"6":"Know, therefore, that Yahweh has given you your inheritance, this excellent land, not because of any merit of yours since you are a rebellious people."
,"7":"Remember and do not forget that it was because you rebelled that Yahweh became angry with you in the desert, for you have been rebellious towards Yahweh from the day you left Egypt until you arrived here."
,"8":"Then at Horeb, you provoked his anger and he was ready to destroy you."
,"9":"When I went up the mountain to receive the slabs of stone, the tables of the Covenant that Yahweh made with you, I stayed on the mountain for forty days and forty nights without eating or drinking."
,"10":"And Yahweh gave me the two slabs of stone written with his finger, containing all the words that he told you on the mountain, from the midst of the fire, on the day of the Assembly."
,"11":"And when Yahweh gave me the two slabs of stone, the tables of the Covenant, at the end of the forty days and forty nights,"
,"12":"he said to me: 'Go down from this mountain at once because your people whom you brought out of Egypt have become corrupt, they have suddenly abandoned the way that I taught them and they have made an idol for themselves.'"
,"13":"And Yahweh also said to me: 'I see this people; they are a rebellious people."
,"14":"Let me alone and I will destroy them and wipe out their name from under heaven. And out of you, I will make another people more numerous and greater than they.'"
,"15":"I, therefore, went down from the mountain, from the summit which was burning, holding in my hands the two tables of the Covenant."
,"16":"And I saw that you had sinned against Yahweh, your God, and that you had made a molten calf."
,"17":"How suddenly had you turned aside from the way which Yahweh had taught you! Holding the two slabs with both hands, I hurled them down and broke them into pieces in the sight of all."
,"18":"Then I fell prostrate before Yahweh and, as before, I passed forty days and forty nights without eating or drinking, for the sin which you had committed by doing evil in the sight of Yahweh and arousing his anger."
,"19":"I was afraid that the wrath and anger of Yahweh against you had reached the point that he wanted to destroy you. And Yahweh listened to me, once more."
,"20":"Yahweh was also very angry with Aaron and he was ready to destroy him. In the same way, I interceded for Aaron also."
,"21":"Regarding the sin, that calf which you had made - I threw it in the fire, broke it into pieces and ground it until it was fine as dust. Then I threw the dust into the brook that flows down from the mountain."
,"22":"At Taberah and at Massah, and at Kibroth-hattavah, you provoked the wrath of Yahweh."
,"23":"And when he wanted you to leave Kadesh-barnea saying,'Go up and take possession of the land that I have given you,' you rebelled again. You did not believe Yahweh nor did you want to listen to his voice."
,"24":"You have been rebellious against Yahweh ever since I have known you."
,"25":"So, I lay prostrate before Yahweh for forty days and forty nights because he said he would destroy you."
,"26":"I prayed to Yahweh and said to him: 'O Lord God, do not destroy your people and your inheritance, whom you redeemed with your might, whom you brought out of Egypt with the strength of your hand."
,"27":"Remember your servants, Abraham, Isaac and Jacob; do not look on the stubbornness of this people, or on their wickedness, or on their sins,"
,"28":"that it may not be said in the land from which you brought us out: 'Yahweh was not able to bring them to the land which he had promised them. He does not like them, so he brought them out of Egypt to slay them in the desert.'"
,"29":"Do not forget that they are your people and your possession whom you brought out of Egypt with your great power and outstretched arm.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"At that time, Yahweh said to me, 'Make two slabs of stone like the first ones and come up to me. And make an ark of wood also."
,"2":"I shall write on the slabs the words that were on the first slabs which you broke. Then you shall put them in the ark.'"
,"3":"So I made an ark of acacia wood, and made two slabs of stone like the first. And I climbed up the mountain carrying these."
,"4":"He wrote on the slabs, just as he had done with the first, the ten sayings that he spoke to you on the mountain from the midst of the fire, on the day of the Assembly; and Yahweh gave them to me."
,"5":"Upon my return, coming down from the mountain, I placed the tables in the ark which I made, and there they are as Yahweh commanded me."
,"6":"The children of Israel left for the wells of Bene-jaakan, going through Moserah. Aaron died and was buried there, and his son Eleazar succeeded him."
,"7":"From there, they went to Gudgodah, and from Gudgodah to Jotbathah, a land of brooks and springs."
,"8":"It was then that Yahweh set apart the tribe of Levi to carry the Ark of the Covenant, to become his servants, to stand before the Lord, and to give blessings by calling on his name, as they do until this day."
,"9":"For that reason, Levi has no share in the inheritance with his brothers; Yahweh is his inheritance, as Yahweh, your God, told him."
,"10":"I therefore stayed on the mountain for forty days and forty nights as I did the first time. Yahweh again listened to my prayer and gave up his plan to destroy you."
,"11":"And Yahweh said to me: 'Rise up and lead this people that they may go and take possession of the land which I swore to their fathers to give them as an inheritance.'"
,"12":"So now, Israel, what is it that Yahweh, your God, asks of you but to fear him and follow all his ways? Love him and serve him with all your heart and with all your soul."
,"13":"Observe the commandments of Yahweh and his laws which I command you today, for your good."
,"14":"See: the heavens, those that are seen and those that are unseen, the earth and all that is in it, everything belongs to Yahweh, your God."
,"15":"Nevertheless, it was on your fathers that Yahweh set his heart. He loved them, and after them, he chose their descendants - you - preferring you to all the peoples, as you can see this day."
,"16":"Purify your hearts, then, and do not be defiant towards Yahweh because"
,"17":"Yahweh is the God of gods and the Lord of lords. He is the great God, the strong and terrible God. When he judges, he treats everyone equally; he does not let himself be bought by gifts."
,"18":"He renders justice to the orphan and the widow, and loves the stranger, giving him bread and clothing."
,"19":"Love the stranger then, because you yourselves were strangers in the land of Egypt."
,"20":"Fear Yahweh, your God, serve him, follow him and call on his name when you have to make an oath."
,"21":"He is your pride and he is your God, who has done those amazing things for you."
,"22":"When you went down to Egypt, your ancestors were no more than seventy persons, but now, Yahweh, your God, has made you as many as the stars of heaven."
}`)
	CurrentBook.AddChapter(11, `{
"1":"So, love Yahweh, your God, and observe all that he has commanded you: his laws, norms and commandments."
,"2":"You, with whom I am speaking, understand all this. Perhaps this may be more difficult for your children who have not known the teaching of Yahweh or seen his greatness and strength."
,"3":"But you saw the signs and the marvels he did in Egypt against Pharaoh and all his land,"
,"4":"and what he did to the army of Egypt, to their horses and chariots, when he buried them in the waters of the Red Sea, destroying them as they pursued us."
,"5":"Remember, too, all that Yahweh did for you in the desert, until you came to this place,"
,"6":"what he did to Dathan and Abiram, the sons of Eliab, from the tribe of Reuben, when the earth opened its mouth and swallowed them with all their families, their tents and their followers, in the midst of all Israel."
,"7":"You have seen with your eyes all these great wonders that Yahweh has done."
,"8":"Therefore, observe all these commandments that I give you, that you may gather strength and occupy the land which you are going over to possess."
,"9":"And you will live long in the land which Yahweh swore to give to your fathers and to their descendants, a land flowing with milk and honey."
,"10":"For the land you are to enter and possess is not like the land of Egypt which you left, where after having sown your seeds, you had to water them like a vegetable garden with your feet on the water wheel,"
,"11":"but a land of mountains and valleys, which drinks water from the rain that comes from the heavens."
,"12":"Yahweh, your God, cares for this land and his eyes are constantly fixed on it from the beginning of the year until its end."
,"13":"If you truly obey the commandments that I give you today, if you love Yahweh and serve me with all your heart and with all your soul,"
,"14":"I will give rain to your land in season, both in autumn and in spring, that you may harvest your wheat, wine and oil."
,"15":"Your field will give you grass for your cattle, and you will eat until you are satisfied."
,"16":"But if you turn aside, if you serve other gods and bow before them,"
,"17":"the anger of Yahweh will break out against you. He will close up the heavens and it will cease to rain; the land will not yield its fruit and you will suddenly perish in that beautiful land which Yahweh gives you."
,"18":"Engrave these words of mine on your heart and in your soul, brand them on your hand as a sign, and keep them always before your eyes."
,"19":"Teach them to your children. Speak of them when you are at home and when you travel, when you lie down and when you rise."
,"20":"Engrave them on your doorposts and on your city gates."
,"21":"Then your days and the days of your children will be multiplied in the land which Yahweh swore to give to your fathers, and you will dwell in that land as long as the heavens are above the earth."
,"22":"For if you observe the commandments that I command you to practice, if you love Yahweh and follow his ways, clinging to him,"
,"23":"Yahweh will destroy all those nations before you and you will seize the land from greater and more powerful nations."
,"24":"Every place where you set foot will be yours; your territory will be from the desert up to Lebanon and from the Euphrates River up to the Western Sea."
,"25":"No one will be able to stand against you. In all the land that you tread, Yahweh will make the peoples fear and be afraid when they hear of you, as he himself has said."
,"26":"See that on this day, I set before you a blessing and a curse."
,"27":"A blessing if you obey the commandments of Yahweh that I command you today;"
,"28":"a curse if you disobey these commandments and turn aside from the way that I show you now, to follow strange gods which are not yours."
,"29":"When Yahweh, your God, has brought you into the land you are going to conquer, you shall set the blessing on Mount Gerizim, and the curse on Mount Ebal."
,"30":"(Those mountains are at the other side of the Jordan, beyond the western road, in the land of the Canaanites who dwell in the Arabah, opposite Gilgal, near the oak of Moreh.)"
,"31":"Now you are going to cross the Jordan to take possession of the land which Yahweh gives you. You are to possess it and live in it,"
,"32":"and be careful to carry out all the laws and precepts which I now set before you."
}`)
	CurrentBook.AddChapter(12, `{
"1":"These are the precepts, the norms and the laws that you shall endeavor to put into practice all the days of your life in the land which Yahweh, the God of your fathers, has given you."
,"2":"Totally destroy all the places where the peoples you are going to drive away had worshiped their gods. Do this in the high mountains as well as in the hills and under every green tree."
,"3":"Destroy their altars, smash their pedestals, burn their sacred pillars, and break into pieces the images of their gods. Wipe out in those places even the name of their gods."
,"4":"Do not build similar sanctuaries for Yahweh,"
,"5":"for he himself has already chosen a place among all the tribes to put his Name there and dwell in it. There you will go and look for Yahweh."
,"6":"To that place you will bring your burnt offerings and your sacrifices, tithes and offerings. There you will present the offerings that you promised to God and those which you voluntarily offer, as well as the firstlings of your cattle and sheep."
,"7":"There you shall eat in the presence of Yahweh and feast together with your families, enjoying everything you have reaped through the blessing of Yahweh."
,"8":"You shall not do there as we do here. For now everyone does what seems best for him,"
,"9":"because we have not yet come to the place of rest, that is, the land which Yahweh is giving you as your inheritance."
,"10":"When you cross the Jordan and settle in the land which Yahweh will give you, when he has delivered you from all your enemies, you will at last find rest."
,"11":"Then you shall bring to the place chosen by Yahweh as a dwelling place for his Name, everything which I commanded: the burnt offerings, the sacrifices, the tithes and the first-fruits of the work of your hand, and the selected offerings which you promised by vow to Yahweh:"
,"12":"There you shall celebrate your banquets before Yahweh: you and your children, your servants as well as the Levites who live among you, since they have no portion or inheritance as you have."
,"13":"Be careful not to offer your holocaust in any place."
,"14":"Only in the place chosen by Yahweh in the land of one of your tribes are you to offer your holocaust, and only there will you do all that I command you."
,"15":"However, in all your cities you may slaughter and eat meat, as much as you like of the animals Yahweh has blessed you with. Both the clean and the unclean may eat of it, just as you would eat gazelle or deer."
,"16":"Only you must not eat the blood but pour it out upon the earth like water."
,"17":"You may not eat in your cities the tithes of your wheat, wine and oil, or the firstlings of your herd or your flock, or any of the things which you have offered to Yahweh either freely or by vow."
,"18":"These you are to eat before Yahweh in the place Yahweh has chosen, together with your children and your servants, and you will feast before Yahweh, your God, enjoying the fruit of your labor."
,"19":"Be careful not to forget the Levite as long as you live."
,"20":"When Yahweh has extended your boundaries as he promised you, and you would like to eat meat, you may do so whenever you like."
,"21":"If the place chosen by Yahweh for his dwelling is too far, then you may kill any of your herd or your flock, which Yahweh has given you, in the manner that I have prescribed for you."
,"22":"You may eat it within your cities as much as you like, but you shall eat it just as the gazelle or the deer is eaten: all may equally eat of it - the clean and the unclean."
,"23":"Only take care not to eat the blood because blood and life are one and you must not eat the life with the flesh."
,"24":"Do not eat it but pour it as water is poured upon the land,"
,"25":"that all may go well with you and with your children after you, doing what is pleasing in the eyes of Yahweh."
,"26":"In turn, you shall bring with you the things you have consecrated and offered by vow to Yahweh and go to the place chosen by Yahweh."
,"27":"There you will sacrifice your holocausts, the flesh as well as the blood, on the altar of Yahweh, your God. Pour out the blood on the altar, and then eat the flesh."
,"28":"Be careful to obey all that I command you, and all shall always be well with you and with your children after you, for doing what is right and good in the eyes of Yahweh."
,"29":"Yahweh, your God, will destroy before you the nations you drive away. When you have destroyed them and dwell in their land, be careful after having destroyed them."
,"30":"Let it not be that you fall in the trap and follow their example. Do not look at their gods saying: 'How did this nation serve their gods? We will do the same.'"
,"31":"This you shall not do, even to honor Yahweh your God, since in order to honor their gods,"
,"32":"they have done everything that Yahweh abhors, including burning their children in honor of their gods."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Do all that I command you with out adding or taking anything away from it."
,"2":"What about the prophet or the professional dreamer who gives you signs or miracles?"
,"3":"If these signs or these marvels happen, and he takes advantage of them to say: 'Come and let us follow other gods (gods which are not ours), and let us serve them,'"
,"4":"do not pay attention to the words of this prophet or dreamer; because Yahweh, your God, is testing you to know if you really love him with all your heart and with all your soul."
,"5":"It is Yahweh, your God, you will follow and him will you fear. Obey his commandments and listen to his voice. Serve him and cling to him."
,"6":"As for the prophet or dreamer, he must die because he has spoken to draw you away from Yahweh, your God, who brought you out of Egypt and redeemed you from the house of slavery. This prophet must die because he wanted you to stray from the path that Yahweh has commanded you to follow. In this way you will purge the evil from your midst."
,"7":"If your brother, the child of your father, or if your son or daughter, or the woman you love or your close friend secretly tries to lure you, saying: 'Come, let us serve other gods,' gods whom neither you nor your fathers have known,"
,"8":"the gods of either the neighboring nations that surround you along the boundaries of your land or those far away,"
,"9":"do not yield to him or listen to him. Do not pity him, or pardon him or cover up for him,"
,"10":"but denounce him. You shall deal him his death and your hand shall be the first raised against him, and then the hand of all the people."
,"11":"You shall kill him by stoning because he tried to draw you away from Yahweh, your God, who brought you out of the land of Egypt, from that house of slavery."
,"12":"All in Israel will hear of this and they will fear, and never dare to do such evil."
,"13":"You may hear that in some of the cities that Yahweh will give you to dwell in,"
,"14":"some evil people have appeared. You will perhaps hear that they have perverted their fellow residents and have invited them to serve new and strange gods."
,"15":"Then carefully inquire about them and try to discover the truth of the matter. If it is certain and you have confirmed that such a shameful thing has indeed been done,"
,"16":"you shall kill by the sword all the inhabitants of that city. You shall curse the city and all that is in it, even the animals."
,"17":"Then you shall pile up all the plunder in the center of the square and set the city on fire with all the plunder so as to fulfill the curse of Yahweh. This city will forever be a heap of ruins, and will never again be rebuilt."
,"18":"You shall not take hold of anything from this city, not even the smallest thing, in order to appease the wrath of Yahweh, and that he may have mercy on you. Then he will bless you and fulfill the promise he has sworn to your fathers"
,"19":"if you listen to the voice of Yahweh, observing all his commandments that I command you today, and doing what is right in the sight of Yahweh, your God."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Yahweh holds you as his sons, so you will not cut yourselves or cut the hair on your forehead for the dead."
,"2":"You are a people, holy and consecrated to Yahweh, your God. Yahweh has chosen you from among all the peoples on the face of the earth to be his very own people."
,"3":"Do not eat anything that is unclean."
,"4":"These are the animals that you may eat: ox, sheep, goat,"
,"5":"deer, gazelle, roebuck, wild goat, ibex, antelope, and mountain sheep."
,"6":"You may eat any animal that chews the cud and has a split hoof."
,"7":"But of those that chew cud or have a split hoof, you may not eat the following: camel, hare, and rock badger, because they do chew the cud but do not have a divided hoof - these are unclean for you. Neither shall you eat the meat"
,"8":"of the pig because although it has a split hoof, it does not chew the cud. Regard it as unclean: do not eat their meat or touch their carcass."
,"9":"Of all the animals that live in the water, you may eat the following: all that has fins and scales,"
,"10":"but not those that do not have fins and scales. Consider them as unclean."
,"11":"You may eat all clean birds."
,"12":"But do not eat the following: eagle, vulture, osprey,"
,"13":"buzzard, kite, the different kinds of falcons,"
,"14":"all kinds of ravens, -"
,"15":"ostrich, nighthawk, sea gull, and all the different kinds of hawk,"
,"16":"eagle, owl and ibis, swan,"
,"17":"pelican, purple gallinule, cormorant,"
,"18":"stork, the different kinds of heron, hoopoe, and bat."
,"19":"Consider as unclean all winged insects. Do not eat them."
,"20":"But you may eat all clean birds."
,"21":"Do not eat any animal that you find dead. You may give it to the foreigner who lives in your city, or sell it to the stranger, for you are a people consecrated to Yahweh, your God. Do not boil a kid in its mother's milk."
,"22":"Every year separate the tenth part from the yield of what you have sown in your fields."
,"23":"In the presence of Yahweh, in the place he has chosen as the dwelling place for his Name, you shall eat the tithe of your wheat, your oil and your wine, and the firstlings of your herd and flock that you may learn to honor Yahweh, your God, all the days of your life."
,"24":"The journey may be too long for you to bring those tithes to the place Yahweh has chosen as a dwelling place for his Name. In that case, when Yahweh your God, blesses you, exchange them all for money."
,"25":"Take the money in your hand and go to the place chosen by Yahweh."
,"26":"There you shall buy whatever you like - oxen or sheep, or wine or strong drink - anything you like. And there you shall eat in the presence of Yahweh, and shall rejoice - you and your household."
,"27":"And do not forget the Levite who dwells in your cities, since he has nothing of his own and no inheritance as you have."
,"28":"Every three years, separate the tithes of all the year's harvest but store them in the city."
,"29":"Then the Levite among you who has no inheritance of his own, and the foreigner, the orphan and the widow who live in your cities may come and eat, and be satisfied. So Yahweh will bless all the works of your hands, all that you undertake."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Every seven years you shall pardon debts."
,"2":"You shall do this in the following manner: the creditor shall pardon any debt of his neighbor or brother, and shall stop exacting it of him because Yahweh's pardon has been proclaimed."
,"3":"You may demand that a foreigner pay back his debts but you shall pardon the debt of your brother."
,"4":"However you should have no poor in your midst for Yahweh will give you prosperity in the land that you have conquered."
,"5":"If you listen to the voice of Yahweh, your God, and obey all that he has commanded you, which I now remind you of, he will bless you as he promised."
,"6":"You shall lend to many nations but you shall not borrow; you shall drive away many nations and they shall not have dominion over you."
,"7":"If there is anybody poor among your brothers, who lives in your cities in the land that Yahweh gives you, do not harden your heart or close your hand,"
,"8":"but be open-handed and lend him all that he needs."
,"9":"Be careful that you do not harbor in your heart these perverse thoughts: 'The seventh year, the year of pardon, is near,' so you look coldly at your poor brother and lend him nothing. He may cry to Yahweh against you, and you will be guilty."
,"10":"When you give anything, give it willingly, and Yahweh, your God, will bless you for this in all your work and in all that you undertake."
,"11":"The poor will not disappear from this land. Therefore I give you this commandment: you must be open-handed to your brother, to the needy and to the poor in your land."
,"12":"If your fellow Hebrew, a man or a woman, sells himself to you as a slave, he shall serve you for six years, and in the seventh, you shall set him free."
,"13":"When you set him free, do not let him go empty-handed,"
,"14":"but give him something from your flock, from your store of wheat and wine, something from the good things that Yahweh has blessed you with."
,"15":"Remember that you too were a slave in the land of Egypt, and Yahweh, your God, has given you freedom. Because of this, I give you this commandment."
,"16":"But if your slave says: 'I do not want to leave,' because he loves you and your household and knows that he will be well off with you,"
,"17":"you shall then take an awl and thrust it through his ear into the door of your house, and he will serve you forever. You shall do likewise with your maidservant."
,"18":"Do not think it hard on you to give him freedom, because for six years you have gained from him twice as much as from a hired servant."
,"19":"You shall consecrate to Yahweh all the male firstlings that are born of your cattle or sheep. You shall not use the firstling of your cattle for work, nor shear the firstling of your sheep."
,"20":"You shall eat these every three years in the presence of Yahweh with all your family in the place Yahweh has chosen."
,"21":"You shall not sacrifice an animal to Yahweh if it has any defect, if it is lame or blind,"
,"22":"but shall eat it in your house; the clean as well as the unclean may eat of it, as you would eat a gazelle or a deer."
,"23":"Only take care that you do not eat the blood, you shall pour it out on the ground like water."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Observe the month of Abib and celebrate the Passover in honor of Yahweh since it was in this month that Yahweh, your God, brought you out of Egypt by night."
,"2":"On the Passover, you shall sacrifice oxen and sheep to Yahweh in the place he has chosen for his Name to dwell."
,"3":"For the Passover supper, you are not to eat leavened bread, but for seven days, you shall eat unleavened bread, the bread of affliction, because you left Egypt hastily. So you shall remember all the days of your life the day on which you left Egypt."
,"4":"For seven days, no leaven shall be seen throughout your territory; nor shall any of the flesh you sacrificed on the evening of the first day be left for the following day."
,"5":"You may not offer the Passover sacrifice in any city which Yahweh gives you,"
,"6":"but only in the place chosen by Yahweh as the dwelling place for his Name. Sacrifice the Passover in the evening, at sunset, at the time you came out of Egypt. "
,"7":"You shall roast it and eat it in the place chosen by Yahweh, your God. And then, in the morning you shall return to your house."
,"8":"You shall eat unleavened bread for six days, and on the seventh, you shall celebrate a solemn assembly in honor of Yahweh and you shall not work."
,"9":"You shall count seven weeks, beginning from the day you start cutting the standing wheat."
,"10":"Then you shall celebrate the Feast of the Seven Weeks for Yahweh, your God, making a voluntary offering from your harvest in proportion to the way Yahweh, your God, blesses you."
,"11":"At the place Yahweh has chosen as the dwelling place for his Name, you shall feast, you and your children, your servants, the Levite who lives in your cities, the foreigner, the orphan and the widow who live among you."
,"12":"Remember that you were a slave in Egypt and be careful to put these precepts into practice."
,"13":"Celebrate too the Feast of the Tents for seven days, after gathering the produce of your threshing floor and of your winepress."
,"14":"Rejoice during this feast - you and your children, your servants, the Levite, the foreigner, the orphan and the widow who live in your city."
,"15":"You shall feast for seven days in honor of Yahweh at the place chosen by him; because Yahweh will bless you in all your produce and in all the work of your hands, so that your joy may be complete."
,"16":"Three times a year all your men shall present themselves before Yahweh, your God, in the place chosen by him: on the Feast of Unleavened Bread, on the Feast of Weeks, and on the Feast of Tents. And you shall not present yourselves empty-handed,"
,"17":"but each one will offer in proportion to what he has, according to the blessing that Yahweh has bestowed upon you."
,"18":"Appoint judges and secretaries for your tribes in every city which Yahweh gives you, that they may judge the people according to justice."
,"19":"You shall not bend the law or show partiality. Do not accept gifts because gifts blind the eyes of the wise and subvert the cause of the righteous."
,"20":"Justice! Seek justice if you want to live and inherit the land which Yahweh, your God, gives you."
,"21":"Do not plant any tree or sacred pillar near the altar of your God."
,"22":"Do not put up there the sacred stones that Yahweh hates."
}`)
	CurrentBook.AddChapter(17, `{
"1":"You shall not sacrifice to Yahweh, your God, an ox or a sheep that has any blemish or defect because Yahweh abhors this."
,"2":"If there is among you, in any of the cities which Yahweh will give you, a man or a woman who does what is evil in the sight of Yahweh to the point of breaking his covenant,"
,"3":"if they go to serve other gods and bow before them - to the sun, or the moon, or the stars of heaven - which I have forbidden,"
,"4":"and this has been reported to you or you learn of it, you shall begin to investigate the matter well. If you have proved that this abomination has indeed been committed in Israel,"
,"5":"you shall bring to the gates of the city that man or woman who committed the misdeed, and you shall stone him or her to death."
,"6":"But you will need the testimony of two or three witnesses to condemn a person to death. No one will be condemned by the accusation of only one witness."
,"7":"The hands of the witnesses shall throw the first stones to kill the accused. Afterwards all the people shall stone him. In this way, you will make the evil disappear from your midst."
,"8":"If a very difficult case is presented to you which you cannot resolve in the city tribunal, either about murder, a legal dispute or a quarrel because of injuries, you shall go up to the place chosen by Yahweh, your God;"
,"9":"you shall approach the Levite priests and the judge in office at that time. You shall consult them and they will point out to you the decision on the case."
,"10":"You shall carry out the decision that they have made for you in that place chosen by Yahweh, and you shall act in accordance with what they have instructed you."
,"11":"You shall follow the instructions or the verdict they have given you without turning aside either to the right or to the left from the decision they made for you."
,"12":"He who dares to act in another way and does not listen to the priest who stands there in the service of Yahweh, or to the judge, that man will die. You shall banish evil from Israel."
,"13":"So all the people upon knowing this shall fear and not make decisions without the right to do so."
,"14":"When you come to the land which Yahweh, your God, gives you, when you have conquered it and live in it, you shall perhaps say: 'I would like to have a king like all the neighboring nations.'"
,"15":"Then you have to appoint a king chosen by Yahweh from among your brothers. You shall not appoint a foreign king who is not a brother Israelite."
,"16":"Ensure that your king does not acquire many horses, lest he again send his people to Egypt to get more horses. For Yahweh commanded you never to go back that way."
,"17":"Neither shall he have many women lest they pervert his heart. And neither let him pile up gold and silver."
,"18":"When he ascends the throne, let him copy for his use this Law from the book of the Levite priests."
,"19":"He shall bring it with him and read it every day of his life, that he may learn to fear Yahweh, keeping all the sayings of the Law and putting his precepts into practice."
,"20":"So let him not become conceited nor look down on his brothers, nor turn aside from this commandment either to the right or to the left, so that he and his children may lengthen the days of their reign in the midst of Israel."
}`)
	CurrentBook.AddChapter(18, `{
"1":"The Levite priests, the whole tribe of Levi, will have no share or inheritance as the rest of the children of Israel have, but they shall live on the burnt offerings in honor of Yahweh, and on what is consecrated to him."
,"2":"The Levite shall have no share in the inheritance received by his brother because Yahweh is his inheritance as he has promised."
,"3":"This will be the right of the priests from what is offered, whether ox or sheep: to the priest shall be given the shoulder, the jaws and the stomach."
,"4":"You shall also give him the firstfruits of your wheat, your wine and your oil, as well as the first wool from the shearing of your sheep,"
,"5":"for Yahweh chose him from among all the tribes to be the servant of his Name, he and his children forever."
,"6":"If a Levite comes from one of the cities of the territory of Israel where he resides, and he wishes to enter into the place chosen by Yahweh,"
,"7":"he shall officiate in the Name of Yahweh, his God, like all his Levite brothers who stand there with him in the presence of Yahweh."
,"8":"He shall eat the same portion, regardless of what he has obtained from the sale of his family goods."
,"9":"When you have entered into the land which Yahweh, your God, gives you, do not imitate the evil deeds of those people."
,"10":"You must not have in your midst anyone who makes his child pass through the fire, or one who practices divination, or anyone who consults the stars, who is a sorcerer,"
,"11":"or one who practices enchantments or who consults the spirits, no diviner or one who asks questions of the dead."
,"12":"For Yahweh abhors those who do these things, and it is precisely for this reason that he drives them away before you."
,"13":"You must be blameless for Yahweh, your God."
,"14":"Those people that you are to drive away listened to sorcerers and diviners, but Yahweh, your God, has provided you with something different."
,"15":"He will raise up for you a prophet like myself from among the people, from your brothers, to whom you shall listen."
,"16":"Remember that in Horeb, on the day of the Assembly, you said: 'I am afraid to die and I do not want to hear the voice of Yahweh again or see again that great fire.'"
,"17":"So Yahweh said to me: 'They have spoken well."
,"18":"I shall raise up a prophet from their midst, one of their brothers, who will be like you. I will put my words into his mouth and he will tell them all that I command."
,"19":"If someone does not listen to my words when the prophet speaks on my behalf, I myself will call him to account for it."
,"20":"But any prophet who says in my name anything that I did not command, or speaks in the name of other gods, that prophet shall die.'"
,"21":"You will perhaps ask: 'How are we going to know that a word does not come from Yahweh?'"
,"22":"If any prophet speaks in the name of Yahweh and if that which he says does not happen, you shall know that the word does not come from Yahweh. The prophet has spoken to boast and you shall not pay any attention to him."
}`)
	CurrentBook.AddChapter(19, `{
"1":"When Yahweh, your God, has destroyed the nations whose land he will give you, when you have driven them away and you occupy their houses,"
,"2":"you shall set aside three cities in the midst of the land which Yahweh, your God, gives you in possession."
,"3":"Open a way to them and divide in three parts the territory that Yahweh, your God, gives you in possession: so that anyone who has killed someone may find refuge in those cities."
,"4":"But who may find refuge there to save himself? The person who caused the death of his neighbor with whom he had had no quarrel before."
,"5":"For example, if someone goes to the forest with a companion to cut firewood and as he wields the axe to cut a tree, the blade comes off its handle, mortally wounding his companion, he can flee into one of those cities and so save himself."
,"6":"The avenger of blood must not be allowed, in his rage, to hunt the killer and catch up with him because the distance is great, and kill him in turn, when in reality the latter is not guilty of murder, since he had had no previous quarrel with his companion."
,"7":"For this reason, I command you to set aside these three cities."
,"8":"But perhaps Yahweh will extend your frontiers as he has sworn to your fathers, and give you all the land that he promised to your fathers,"
,"9":"on condition that you keep his commandments and do what I tell you today, that is, that you love Yahweh, your God, and follow his ways at all times. Then you shall add three more to these three cities."
,"10":"In that way, innocent blood shall not be shed in the midst of the land which Yahweh, your God, gives you as your inheritance, and you will not be guilty of such shedding of blood."
,"11":"But if a man, because of a feud with his neighbor, ambushes him and falls on him and wounds him fatally, and if afterwards the aggressor flees into one of these cities,"
,"12":"the heads of this city shall order that he be arrested there in the place of asylum. And he shall be put in the hands of the relatives of the victim that they may kill him."
,"13":"Do not show pity to him for you must remove from Israel the shedding of innocent blood, so that you may have prosperity."
,"14":"In the inheritance you receive in the land which Yahweh, your God, will give as your possession, do not move the boundaries of your neighbor set by your ancestors."
,"15":"A sole witness is not enough to condemn anyone, whatever be the crime or offense of which the person is accused. Only by the testimony of two or three witnesses can a case be resolved."
,"16":"If only one witness rises against a person and accuses him of an offense,"
,"17":"both parties involved shall appear before Yahweh in the presence of the priests and judges then in office, who may deal with it."
,"18":"The judges will examine the case in detail, and if it turns out that the witness had lied in falsely accusing his brother,"
,"19":"they shall impose on him the punishment which the lying witness tried to impose on his brother. So shall you uproot evil from your midst,"
,"20":"because others, upon knowing it, shall fear and not do the same."
,"21":"Do not feel sorry for him: life for life, eye for eye, tooth for tooth, hand for hand, foot for foot."
}`)
	CurrentBook.AddChapter(20, `{
"1":"When you go to war against your enemies and you see horses, chariots and an army more numerous than yours, then have no fear because Yahweh, your God, who brought you out of Egypt, is with you."
,"2":"When the hour of battle draws near, the priest shall advance to the head of the army and shall speak to the people saying:"
,"3":"'Listen, Israel, today you are to enter into battle against your enemies. Do not let your heart be discouraged, or afraid or troubled, and do not tremble before them,"
,"4":"for Yahweh, your God, is with you, to fight in your favor against your enemies and save you.'"
,"5":"So the secretaries shall say to the people: 'Is there anyone of you who has just built a new house and has not dedicated it? Let him go home; lest he die in battle and another dedicate it."
,"6":"Is there anyone among you who has planted a new vineyard and has not yet enjoyed its fruits? Let him go home, lest he die in the war and another enjoy its fruit."
,"7":"Is there anyone who has made a promise to marry and has not yet been married? Let him go back to his home at once, lest he die in combat and another take the woman as his wife.'"
,"8":"They shall also say: 'Is there anyone who is afraid or weakhearted? Let him go home immediately, lest his fear discourage others.'"
,"9":"When they have finished speaking, commanders shall be put at the head of the people."
,"10":"When you draw near to a city to lay siege to it, you shall first offer it peace."
,"11":"If it accepts your proposal and opens the gates to you, all the people found in it shall become your slaves and serve you."
,"12":"If they do not accept the peace that you offer them and declare war against you, you shall lay siege to the city."
,"13":"And when Yahweh, your God, gives it into your hands, you shall kill by the sword all the men,"
,"14":"but the women and children, the livestock and all the other things which you find there shall be your booty, and you shall eat from the plunder of your enemies which Yahweh has given over to you."
,"15":"This you shall do to all the cities which are very far from you and which are not in the country which you will possess."
,"16":"But in the cities which Yahweh gives you as an inheritance, you shall not leave anything that lives."
,"17":"You must destroy them all according to the law of anathema - the Hittites, Amorites, Canaanites, Perizzites, Hivites and Jebusites - as Yahweh, your God, has commanded you,"
,"18":"that they may not teach you all those evil things which they have done to honor their gods, for by imitating them you shall sin against Yahweh, your God."
,"19":"If, on attacking a city, you have to lay siege to it for a long time before capturing it, you shall not destroy the fruit trees around it nor cut them with your axe, that you may eat their fruit. Do not cut them, then. Are the trees of the field men that they should also be stricken?"
,"20":"If there are trees in the field which are not fruit-bearing, but are for other uses, cut them down and make ladders and instruments out of them with which you may seize the city that offers you resistance."
}`)
	CurrentBook.AddChapter(21, `{
"1":"If the corpse of a slain man is found in the land which Yahweh, your God, will give you, and it is not known who killed him,"
,"2":"your judges and leaders shall go out to measure the distance between the victim and the surrounding cities to"
,"3":"determine which city is nearest to the dead man. And the leaders of that city shall take a calf that has never been used for work or borne a yoke. "
,"4":"And they shall bring it down to an overflowing brook, to a place which has never been plowed or sown, and there they shall break its neck."
,"5":"The priests, descendants of Levi, shall be present for they were chosen by Yahweh to minister and give the blessings in his name, and they are those who decide on all lawsuits or criminal cases."
,"6":"Then all the elders of the city nearest to the man found dead shall wash their hands in the brook over the calf whose neck was broken."
,"7":"And they shall pronounce these words, 'Our hands did not shed this blood, and our eyes did not see it."
,"8":"Forgive, O Yahweh, your people of Israel whom you rescued, and do not charge them with this shedding of innocent blood.'"
,"9":"So they shall be absolved from this blood; you shall have removed from your midst the guilt of innocent blood and have done what is right in the eyes of Yahweh."
,"10":"When you go to war against your enemies, and Yahweh, your God, delivers them over to you,"
,"11":"if you see among the captives a beautiful woman, and you fall in love with her and desire to have her as your wife,"
,"12":"you shall bring her to your house. First, she shall shave her head and clip her nails."
,"13":"She shall take off the dress of a captive and stay in your house. And she will mourn for her father and mother for a month, after which you may have relations with her. So you shall be her husband and she your wife."
,"14":"If in time she does not please you anymore, you shall set her free. You shall not sell her for money, nor make her your slave, since you have taken her by force."
,"15":"When a man has two wives and prefers one to the other, supposing that both of them bear him children, and the firstborn is the son of the wife he loves less,"
,"16":"then on the day he divides the inheritance among his children, he cannot give the right of the firstborn to the son of the woman he prefers, at the expense of the true firstborn who is the son of the woman he loves less."
,"17":"On the contrary, he should recognize the child of the woman he loves less as the firstborn and give him a double share of all his property. He is his firstborn, and to him belongs the right of the firstborn."
,"18":"If a man has a stubborn and rebellious child who does not pay attention to what his father or mother commands, and does not listen to them when they call him,"
,"19":"his parents shall seize him and bring him before the leaders of the city, to the gate of judgment,"
,"20":"and shall say to them: 'This son of ours is stubborn and rebellious, he does not pay any attention to us; he is spoiled and a drunkard.'"
,"21":"Then all the men of this town shall stone him to death. In this way shall you banish evil from your midst, and all Israel upon knowing this shall fear."
,"22":"If a man, guilty of any crime that deserves death, has been put to death by hanging him on a tree,"
,"23":"his body must not remain hanging there through the night. But you shall bury him on the same day because the hanged man is a curse of God. So you shall not defile the land which Yahweh, your God, gives you as an inheritance."
}`)
	CurrentBook.AddChapter(22, `{
"1":"If you find the lost ox or sheep of your brother, do not pretend that you did not see it, but bring it back to its owner."
,"2":"If your brother does not live near you, or you do not know to whom the animal belongs, you shall keep it in your house until its owner comes looking for it. Then you shall return it to him."
,"3":"Do the same with his ass, his clothes, or with anything lost by your brother that you happen to find. Do not pretend not to notice them."
,"4":"If you see the ass of your brother or his ox fall down by the way, do not pretend not to notice it, but help your brother lift the animal up."
,"5":"A woman must not wear a man's clothing, nor a man the clothing of a woman, because whoever does such a thing deserves the reprobation of Yahweh."
,"6":"If you find along your way a bird's nest in a tree or on the ground, and the mother-bird is sitting upon the birdlings or upon the eggs, you shall not bring with you the mother-bird together with the young,"
,"7":"but you shall let the mother go and take only the young. Then you shall prosper and live long."
,"8":"When you build a new house, you shall construct a small wall around the roof, lest someone should fall from it, and your house become stained with blood."
,"9":"Do not sow any other seed in your vineyard because when you do this, you can neither eat from the produce of the grapes nor from the produce of the other plants."
,"10":"Do not plow with an ox and an ass together."
,"11":"Do not wear a garment woven from wool and linen together."
,"12":"Make for yourself tassels on the four corners of your cloak with which you cover yourself."
,"13":"It may happen that a man takes a wife and afterwards does not like her,"
,"14":"so he reproaches her for her behavior, and defames her by saying: 'I married this woman, but when I went to bed with her, I found out that she was not a virgin.'"
,"15":"In this case, the father and mother of the young woman shall take the sheet of the wedding night which proves that she was a virgin, and will show this to the judges of the city."
,"16":"The father of the young woman shall then say to the judges: 'I have given my daughter as wife to this man, but now that he no longer likes her,"
,"17":"he pretends that when he married her she was not a virgin. And yet, see, here is the proof of my daughter's virginity.'"
,"18":"They shall spread the sheet before the judges of the city. If the man is guilty, the judges shall arrest him and have him whipped."
,"19":"They shall also fine him a hundred silver coins which they shall give to the father of the young woman because the man publicly defamed a virgin of Israel. The husband shall have her as his wife and cannot repudiate her as long as he lives."
,"20":"But if what the man says is true, and the proof of her virginity is not found,"
,"21":"then you shall bring her to the door of her father's house and the people shall stone her to death for having committed an evil deed in Israel - becoming a prostitute while still in her father's house. So shall you banish evil from your midst."
,"22":"If a man is caught lying with a married woman, the two shall die: the adulterer and the adulteress. So shall you banish evil from Israel."
,"23":"If a young woman has been promised in marriage to a man, and another man meets her in the city and lies with her,"
,"24":"they shall bring the two and stone them to death: the young woman because she did not cry for help when she was in the city, and the man because he dishonored the future wife of his neighbor. So shall you banish evil from your midst."
,"25":"But if in the fields, a man meets a young woman promised in marriage, and violates her by force, then only the man shall die."
,"26":"The young woman shall not suffer punishment. She does not deserve death, for this case is similar to a highwayman who falls upon a man and murders him; in the same manner, the young woman was assaulted."
,"27":"She was alone in the fields, she cried but no one came to help her."
,"28":"If a man meets a young virgin who is not promised in marriage to another man, and that man violates her by force, and they are caught by surprise,"
,"29":"the man who lay with her shall give to the father of the young woman fifty pieces of silver, and take her as his wife, because he has dishonored her, and he cannot send her away all his life."
}`)
	CurrentBook.AddChapter(23, `{
"1":"No man shall take the wife of his father; let him not dishonor his father."
,"2":"The man whose testicles are crushed and whose penis is cut shall not be admitted into the assembly of Yahweh."
,"3":"Nor shall the half-breed be admitted into the assembly of Yahweh, even to the tenth generation."
,"4":"The Ammonite or Moabite shall never be admitted into the assembly of Yahweh even after the tenth generation,"
,"5":"because when you came forth from Egypt, they did not go out to meet you with bread and water, but instead they hired Balaam, the son of Beor, from the Pethor in Mesopotamia, to curse you."
,"6":"But Yahweh, your God, did not listen to Balaam and turned the curse into a blessing because Yahweh loves you."
,"7":"You shall never share your prosperity or happiness with these peoples."
,"8":"You shall not regard the Edomite as abominable, for he is your brother, or the Egyptian, because you were a pilgrim in his land."
,"9":"From the third generation, their descendants can be admitted into the assembly of Yahweh."
,"10":"When you set out against your enemies, you shall keep yourselves from every evil act."
,"11":"If there is among you a man who is not clean by reason of nocturnal emission, he shall go and stay outside the camp."
,"12":"When evening comes, he shall bathe himself and after sunset, he may enter the camp."
,"13":"You shall have a place outside the camp for your natural necessities."
,"14":"You shall bring a stick with your equipment with which you may dig a hole, and then cover up the excrement with the unearthed soil."
,"15":"Because Yahweh, your God, walks in the midst of the camp to protect you and give your enemy into your hands; your camp must be sacred, that Yahweh may not see anything indecent in it; otherwise, he will turn away from you."
,"16":"You shall not turn over to his master the slave who ran away from his house and sought refuge with you."
,"17":"He shall stay with you among your household, in the place that he chooses in one of your cities, where it seems best for him. You shall not oppress him."
,"18":"There shall not be among the daughters of Israel a consecrated prostitute, or a consecrated homosexual among the sons of Israel."
,"19":"You shall not bring into the house of Yahweh, your God, a gift for prostitutes, or the wages of a dog, that is, a homosexual, to pay for the vow that you have made, for both of these are abominable in the eyes of Yahweh."
,"20":"You shall not lend with interest to your brothers, either in money or food, or in any other thing."
,"21":"You can lend with interest to a foreigner, but not to your brother, so that Yahweh, your God, may bless you in all your undertakings in the land you are to possess."
,"22":"If you make any vow to Yahweh, you shall not be late in fulfilling it for Yahweh will surely require it of you and it would be charged as sin against you."
,"23":"If you abstain from making vows, you do not commit any sin."
,"24":"Fulfill your promises and, if you make any vow, you shall offer what you have promised to Yahweh."
,"25":"If you go through the vineyard of your neighbor, you may eat as many grapes as you wish, but you may not bring any away."
,"26":"If you pass through the wheat fields of your neighbor, you may pluck the ears with your hand, but you shall not put a sickle to your neighbor's standing wheat."
}`)
	CurrentBook.AddChapter(24, `{
"1":"If a man marries a woman, and then dislikes her because of some notable defect he discovers in her, he may write a certificate of divorce, give it to the woman, and send her out of his house."
,"2":"If afterwards she becomes the wife of another man"
,"3":"and he also dislikes her and sends her out with a certificate of divorce; or, if this second man who took her to be his wife dies,"
,"4":"the first husband who sent her away cannot take her back as wife, since she has been defiled. It is an abomination in the eyes of Yahweh for him to take her back. You shall not defile the land which Yahweh will give you for an inheritance."
,"5":"The newly married man shall not go to war or be given other public duties. He shall be exempt from everything throughout the year, that he may stay in his house and make his wife happy."
,"6":"Mill and grindstone shall not be taken as a pledge. Can life be taken as a pledge?"
,"7":"If a man is caught kidnapping an Israelite, that is to say, one of his brothers, to sell him as a slave, the kidnapper must die. So shall you banish evil from the midst of your people."
,"8":"Be careful of contagious leprosy. Obey and put into practice what the Levite priests tell you to do; fulfill what I commanded them."
,"9":"Remember what Yahweh, your God, did to Miriam, when the people were on the way coming out of Egypt."
,"10":"When you lend anything to your neighbor, you shall not go into his house to take anything as pledge."
,"11":"Wait outside, and he shall come out of the house to give you the pledge."
,"12":"If you have taken as pledge the cloak of a poor man, you shall not keep it overnight;"
,"13":"you shall return it to him when the sun goes down that he may sleep in his cloak. Then the poor shall bless you and you shall be righteous in the eyes of Yahweh, your God."
,"14":"Do not exploit the lowly and the poor daily-wage earner, whether he be one of your brothers or a foreigner whom you find in your land in any of your cities."
,"15":"Pay him daily before the sun goes down, because he is poor and he depends on his earnings. Then he will not cry to Yahweh against you, and you will have no sin."
,"16":"The fathers shall not be put to death for the sin of their children, nor the children for the sin of their fathers. Everyone must pay for his own sin."
,"17":"Do not violate the right of the foreigner, or of the orphan, or take as pledge the clothing of a widow."
,"18":"Remember that you were a slave in Egypt, and Yahweh, your God, rescued you. This is why I command you to do this."
,"19":"When you harvest the wheat in your fields, if you drop a sheaf, do not return to pick it up, but let it be there for the foreigner, the orphan and the widow. Yahweh will bless you for this in all your work."
,"20":"When you harvest your olives, do not go back to beat the trees another time, what is left shall be for the foreigner, the orphan and the widow."
,"21":"When you gather the grapes in your vineyard, do not return to look for what has been left. This will be the share of the foreigner, the orphan and the widow."
,"22":"Remember that you were a slave in Egypt. This is why, I command you to do this."
}`)
	CurrentBook.AddChapter(25, `{
"1":"When there is a dispute between two persons, let them go to the judges. These will declare who is righteous and who is guilty."
,"2":"If he deserves flogging, the judge shall make him fall down on the ground in his presence and shall have him flogged with the number of stripes in proportion to his sin."
,"3":"You may give him forty stripes - not more - otherwise, the punishment would be too much and your brother would be dishonored in your eyes."
,"4":"Do not muzzle an ox when it threshes the grain."
,"5":"If two brothers live together and one of them dies without any child, the wife of the dead man shall not marry anyone other than the brother of her husband. He shall take her as his wife and shall give offspring to his brother."
,"6":"The first son she bears will perpetuate the name and the family of the dead. In this way his name shall not be wiped out of Israel."
,"7":"If the brother-in-law refuses to take her for his wife, she shall present herself at the city gates and say to the elders, 'My brother-in-law refuses to perpetuate his brother's name in Israel. He does not want to perform his duty as brother-in-law in my favor.'"
,"8":"Then the judges shall call this man and speak to him. If he persists and says: 'I do not want to take her for my wife,'"
,"9":"his sister-in-law shall go up to him and in the presence of the judges remove his sandal from his foot, spit in his face and say these words, 'So shall it be done to the man who does not perpetuate the name of his brother.'"
,"10":"His family shall be called in Israel 'the house of the barefooted one.'"
,"11":"If two men fight with each other and the wife of one draws near to save her husband from the blows of the other, extends her hand and grasps him by the testicles,"
,"12":"you shall cut off the woman's hand without pity."
,"13":"You shall not keep in your bag two weights, one heavier and the other lighter,"
,"14":"nor shall you have in your house a large measure and a small one."
,"15":"You shall have a full and exact weight, and an equally just and exact measure, that you may lengthen your days in the land which Yahweh, your God, gives you."
,"16":"Because Yahweh hates him who does such things and any kind of injustice."
,"17":"Remember what Amalek did to you when you were on the road, coming out of Egypt."
,"18":"He went out to meet you on the way and when you were weak and tired attacked all who were left behind. He had no fear of God."
,"19":"Therefore, when Yahweh, your God, after subduing all your enemies around you, has given you rest in the land which he gives you, you shall wipe out the remembrance of Amalek from under the heavens. Do not forget."
}`)
	CurrentBook.AddChapter(26, `{
"1":"When you come into the land which Yahweh, your God, gives you as an inheritance, when you possess it and dwell in it,"
,"2":"you shall take the firstfruits of all your harvests, place them in a large basket and bring it to the place chosen by Yahweh, your God, as the dwelling place for his Name."
,"3":"Present these to the priest who is in office, and say to him, 'On this day, I confess that Yahweh, my God, let me enter into the land he promised our fathers that he would give us.'"
,"4":"Then the priest shall take the large basket from your hands and place it before the altar of Yahweh, your God,"
,"5":"and you shall say these words before Yahweh, 'My father was a wandering Aramean. He went down to Egypt to find refuge there, while still few in number; but in that country, he became a great and powerful nation."
,"6":"The Egyptians maltreated us, oppressed us and subjected us to harsh slavery."
,"7":"So we called to Yahweh, the God of our fathers, and Yahweh listened to us. He saw our humiliation, our hard labor and the oppression to which we were subjected."
,"8":"He brought us out of Egypt with a firm hand, manifesting his power with signs and awesome wonders."
,"9":"And he brought us here to give us this land flowing with milk and honey."
,"10":"So now I bring and offer the firstfruits of the land which you, Yahweh, have given me.'"
,"11":"You shall place these before Yahweh, bow before him and worship Yahweh, your God. Afterwards, you and your household shall feast on all the good things Yahweh has given you and your family. The Levite and the foreigner who lives among you shall also feast with you."
,"12":"On the third year, the year of tithing, when you have finished separating the tithes from all your harvests and have given them to the Levite, the foreigner, the widow and the orphan, that they may eat within your very city until they are satisfied,"
,"13":"you shall say in the presence of Yahweh, 'I have brought out of my house the sacred share. I have given it to the Levite, the foreigner, the orphan and the widow according to the commandments that you have given me, without going against any of them or forgetting them. "
,"14":"Of that tithe I have not eaten anything in time of mourning, or removed any of it while I was unclean. I have offered nothing to the dead. I have obeyed the voice of Yahweh, my God, and have done as he has commanded me."
,"15":"From your sanctuary, from on high in the heavens, look down and bless your people Israel, as you bless the land which you have given us just as you had promised to our fathers, the land flowing with milk and honey.'"
,"16":"On this day, Yahweh, your God, commands you to fulfill these norms and these commandments. Obey them now and put them into practice with all your heart and with all your soul."
,"17":"Today Yahweh has declared to you that he will be your God, and so you shall follow his ways, observing his norms, his commandments and his laws, and listening to his voice."
,"18":"Today Yahweh has declared that you will be his very own people even as he had promised you, and you must obey all his commandments."
,"19":"He, for his part, will give you honor, renown and glory, and set you high above all the nations he has made, and you will become a nation consecrated to Yahweh, your God, as he has declared."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Moses and the elders of Israel gave this order to the people: 'Observe all the commandments that I give you today."
,"2":"When you cross the Jordan to go to the land which Yahweh, your God, will give you, set up large stones and plaster them with lime."
,"3":"Then you shall write upon them all the words of this Law at the time that you cross over, that you may enter the land which Yahweh, the God of your fathers, will give you as he has promised, a land flowing with milk and honey."
,"4":"When you have crossed the Jordan, set up these stones on Mount Ebal as I command you today, and plaster them with lime."
,"5":"Set up there an altar in honor of Yahweh, built with unhewn stones."
,"6":"Build the altar to Yahweh with uncut stones and on this altar offer burnt offerings to Yahweh, your God."
,"7":"There you shall also sacrifice peace offerings; you shall eat and feast in the presence of Yahweh, your God."
,"8":"Write plainly upon these stones all the words of this Law.'"
,"9":"Then Moses and the priests from the tribe of Levi said to the people of Israel: 'Pay attention and listen, Israel. Today you have become the people of Yahweh, your God:"
,"10":"Listen, therefore, to his voice and put into practice the commandments and the norms that I give you today.'"
,"11":"On that day, Moses gave this command to the people:"
,"12":"When you have crossed the Jordan River, the tribes of Simeon, Levi, Judah, Issachar, Joseph and Benjamin shall stand on Mount Gerizim to repeat the blessings over the people,"
,"13":"while those of Reuben, Gad, Asher, Zebulun, Dan and Naphtali shall stand on Mount Ebal to repeat the curses."
,"14":"The Levites shall declare to all the Israelites with a loud voice:"
,"15":"Cursed be the man who makes an idol covered with metal, a thing hateful to Yahweh, the work of the hands of a craftsman, and sets it up in a hidden place! All the people shall answer: Amen!"
,"16":"Cursed be he who despises his father or mother! And the people shall respond: Amen!"
,"17":"Cursed be he who moves the boundaries of his neighbor's inheritance. All the people shall respond: Amen!"
,"18":"Cursed be he who leads the blind astray from the way! All the people shall respond: Amen!"
,"19":"Cursed be he who does not respect the rights of the foreigner, the orphan and the widow! All the people shall respond: Amen!"
,"20":"Cursed be he who lies with the wife of his father and dishonors his father's bed! All the people shall respond: Amen!"
,"21":"Cursed be he who sins with any kind of animal! The people shall respond: Amen!"
,"22":"Cursed be he who lies with his sister, whether the daughter of his father or mother! All the people shall respond: Amen!"
,"23":"Cursed be he who lies with his mother-in-law! All the people shall say: Amen!"
,"24":"Cursed be he who treacherously murders his neighbor! All the people shall say: Amen!"
,"25":"Cursed be he who accepts a bribe to kill an innocent person! All the people shall say: Amen!"
,"26":"Cursed be he who does not affirm the words of this Law by putting them into practice! And all the people shall say: Amen!"
}`)
	CurrentBook.AddChapter(28, `{
"1":"Well now, if you obey in truth the voice of Yahweh, your God, practicing and observing all the commandments which I give you today, Yahweh, your God, shall raise you high above all the nations of the earth."
,"2":"Then all these blessings shall reach you and come upon you for having obeyed the voice of Yahweh, your God:"
,"3":"Blessed shall you be in the city and in the field."
,"4":"Blessed shall be the fruit of your body and the fruit of your land, the young of your asses, the offspring of your cattle and sheep."
,"5":"Blessed shall be your basket and your bowl of dough."
,"6":"Blessed shall you be when you begin and when you finish."
,"7":"Yahweh will bring down your enemies who rise against you, and put them at your feet. By one way they shall come out against you but by seven ways they shall flee from you."
,"8":"Yahweh will order the blessing to be with you in your granaries and in your activities. He shall bless you in the land which Yahweh, your God, gives you."
,"9":"Yahweh shall make you a holy people, as he has sworn, if you keep his commandments and follow in his ways."
,"10":"Then all the nations of the earth shall see that you are under the protection of Yahweh and they will respect you."
,"11":"Yahweh shall fill you with all kinds of good things, increasing the fruit of your womb, the fruit of your livestock and the fruit of your land which Yahweh promised on oath to your fathers that he would give you."
,"12":"Yahweh shall open the heavens for you, his rich treasury, to give rain in its season which your fields need, and he shall bless all that you plan to do. You shall lend to many nations but it shall not be necessary for you to borrow anything from them."
,"13":"Yahweh will set you at the head of the nations and not at the tail; you shall always be on top and never below, if you fulfill the commandments of Yahweh, your God, which I command you today,"
,"14":"observing them and putting them into practice, without turning aside either to the right or to the left to follow and worship other gods."
,"15":"But if you do not obey the voice of Yahweh, your God, and do not take care to practice all his commandments and norms which I command you today, all these curses shall come upon you:"
,"16":"Cursed shall you be in the city and in the field."
,"17":"Cursed shall your granary be, and cursed shall your storage houses be."
,"18":"Cursed shall be the fruit of your body and the fruit of your land, the offspring of your cattle and the young of your sheep."
,"19":"Cursed shall you be in everything you do, from beginning to end."
,"20":"Yahweh will send misfortune, destruction and fear upon everything you do until you are destroyed and perish quickly on account of the evil deeds you have done in forsaking Yahweh."
,"21":"He shall make pestilence cling to you until you disappear from the land which you are entering today to make it yours."
,"22":"Yahweh will punish you with tuberculosis, fever, inflammation, fiery heat, wheat-smug and mildew that shall pursue you until you die."
,"23":"The heavens above you shall be brass and the earth under you shall be iron."
,"24":"Instead of rain, Yahweh shall make ashes and powder fall from heaven until you are destroyed."
,"25":"Yahweh shall let you be defeated before your enemies. By one way you shall go out to fight them but by seven ways you shall flee from them. All the nations of the earth shall be horrified to see you."
,"26":"Your dead bodies shall serve as food for all the birds of the air, and no one shall chase them away."
,"27":"Yahweh shall strike you with the boils and plagues of Egypt, with tumors, scurvy and itch, from which you cannot be healed."
,"28":"Yahweh shall punish you with madness and blindness and confusion of mind."
,"29":"In the same way that the blind grope in darkness, so shall you grope in broad daylight, and you shall not succeed. You shall always be oppressed and robbed, with no one to defend you."
,"30":"You shall be engaged to marry a woman, but another man shall lie with her. You shall build a house but not live in it. You shall plant a vineyard but not eat its grapes."
,"31":"Your ox shall be slaughtered before you but you shall not eat of it. Before your very eyes, you shall be robbed of your ass, which will never be recovered. Your sheep shall be turned over to your enemies, but no one shall come to defend you."
,"32":"Your sons and daughters shall be handed over to foreign nations and you shall yearn for them continually but you will be unable to take action."
,"33":"A people unknown to you shall eat the fruit of your fields, the fruit of all your toil. And you shall never cease to be exploited and oppressed all your life."
,"34":"You shall be driven mad by what you see."
,"35":"Yahweh will strike you with the most malignant boils on the knees and legs, from which you cannot be healed, from the sole of your foot to the crown of your head."
,"36":"Yahweh will bring you and the king you have chosen to a nation which neither you nor your fathers have known, and there you shall serve other gods made of wood and stone."
,"37":"All the nations to which Yahweh will bring you will be astonished, and will make you a byword and the butt of jokes."
,"38":"You shall sow many seeds in your fields but shall harvest very little because the locusts shall devour them."
,"39":"You shall plant and cultivate a vineyard but shall not drink wine or eat grapes because the worms shall devour them."
,"40":"You shall have olive trees throughout all your territory, but they shall not give you even a drop of oil to anoint yourself, for the olives shall drop off and rot."
,"41":"You shall have sons and daughters but they shall not be yours for they shall be taken into captivity."
,"42":"All your trees and all the produce of your land shall be infested with insects."
,"43":"The foreigner who lives with you shall prosper every day at your expense as you become poorer."
,"44":"He shall lend to you and you shall have to borrow; he shall always be the head and you the tail."
,"45":"All these curses shall fall upon you, pursue you and oppress you until all of you perish, for you did not listen to the voice of Yahweh, your God, or obey the commandments and the norms which he gave you."
,"46":"These shall be forever upon you and your descendants as an awesome sign."
,"47":"For having not served Yahweh, your God, with joy and gladness of heart when you lacked nothing,"
,"48":"you shall serve the enemies Yahweh will send against you, while you go hungry, thirsty, naked and suffer all kinds of misery. They shall put a yoke of iron upon your neck until they have destroyed you all."
,"49":"Yahweh shall make a nation from afar come against you, as swift as the eagle flies,"
,"50":"a nation whose language you do not understand, a cruel nation that does not show respect to the old or compassion to the young."
,"51":"They shall consume the offspring of your livestock and the produce of your land so that you perish, leaving you with no wheat or wine or oil or the young of your cattle and sheep until they finish you off."
,"52":"They shall besiege you in all your cities until the highest and most fortified walls in which you placed your trust fall down throughout your land. You shall remain besieged within your cities throughout the land which Yahweh, your God, will give you."
,"53":"You shall eat the fruit of your body, the flesh of your sons and daughters which Yahweh has given you, in the siege and anguish to which your enemy will reduce you."
,"54":"The most refined among you shall look with distrust at his brother, his wife and his children who are still alive"
,"55":"refusing to share with them the flesh of his children that he is eating, because nothing is left to him during the siege and the anguish to which your enemy shall reduce you in your cities."
,"56":"The most tender and delicate woman among your people, so delicate and tender that she will not dare go barefoot, shall look with distrust at the husband of her heart, and also at her son and daughter."
,"57":"She shall hide from them to eat the placenta from her womb and the children to whom she gave birth, for lack of any other food, when your enemy lays siege to your cities and reduces you to the most extreme misery."
,"58":"If you do not put into practice all the words of this Law which are written in this book and do not fear that glorious and terrible Name, Yahweh, your God,"
,"59":"he will punish you, you and your descendants, with fearful plagues, severe and lasting plagues, malignant sicknesses and incurable diseases."
,"60":"He will make all the plagues of Egypt fall upon you, which you were afraid of, and these shall cling to you."
,"61":"Even more, Yahweh shall order all the diseases and plagues which are not recorded in this book of the Law to be with you until you are wiped out."
,"62":"For not having obeyed the voice of Yahweh, your God, only a few of you will remain, although before, you were as numerous as the stars of the heaven."
,"63":"So it shall happen, that in the same manner that it pleased Yahweh to do you good and to multiply you, it shall also please him to pursue and destroy you. You shall be plucked off the land you are entering to conquer."
,"64":"Yahweh shall scatter you among all the nations, from one end of the earth to the other, and there you shall serve other gods of wood and stone, which neither you nor your fathers have known."
,"65":"In those nations, you shall not have peace or rest for the sole of your foot. There Yahweh shall give you a cowardly heart, swollen eyes and anxious soul by day and by night."
,"66":"Your life shall be before you as a pendant that hangs on a thread, and you shall be in dread night and day."
,"67":"In the morning you shall say: 'Would it were evening!' but in the evening you shall say: 'Would it were morning!' because of the fear that makes your heart tremble when you behold what your eyes see."
,"68":"Yahweh shall bring you back to Egypt for your sin, in spite of what he said to you: 'You shall not see it again.' There you shall offer yourselves for sale to your enemies as slaves, but no man will buy you.'"
,"69":"These are the words of the Covenant which Yahweh commanded Moses to make with the children of Israel in the land of Moab, besides the Covenant he made with them at Horeb."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Moses summoned all the people of Israel and said to them: 'You have seen all that Yahweh did before your eyes in the land of Egypt, to Pharaoh, to his servants and to all his land,"
,"2":"the great plagues which you yourselves witnessed, the signs and the marvels."
,"3":"But to this very day, Yahweh has not given you a heart to understand, or eyes to see, or ears to hear."
,"4":"Yahweh made you wander in the desert for forty years, but your clothes did not wear out and neither did your sandals from so much journeying."
,"5":"You did not have bread to eat, or wine or fermented liquor to drink, so that you might know that I, Yahweh, am your God."
,"6":"And when we came to this place, Sihon, the king of Heshbon, and Og, the king of Bashan, set out to fight against us, but we defeated them"
,"7":"and seized their lands, which we then gave as an inheritance and a possession to Reuben, Gad and to half of the tribe of Manasseh."
,"8":"So observe the conditions of this Covenant and put them into practice, that you may succeed in whatever you do."
,"9":"You are all here today in the presence of Yahweh, your God: your leaders, your elders, your secretaries, all the men of Israel,"
,"10":"with your sons and daughters, and with your wives, together with the foreigner who lives in your field, who cuts the firewood or fetches water for you."
,"11":"You are here in this place to celebrate a Covenant with Yahweh, your God."
,"12":"Through this oath he makes you his people and he becomes your God, as he said to you and promised to your fathers, to Abraham, Isaac and Jacob."
,"13":"And not only with you do I make this covenant and this oath today,"
,"14":"but I make it both with those who are here with you today in the presence of Yahweh and with those who are not here."
,"15":"You know very well how we lived in the land of Egypt and how we crossed through other lands."
,"16":"You have seen the abominations and the loathsome idols they kept: of stone, wood, gold and silver."
,"17":"So may there be no man or woman, family or tribe among you whose heart turns away from Yahweh to go and serve the gods of those nations. May no poisonous and bitter plants sprout among you."
,"18":"If anyone does not heed the words of this sworn Covenant, thinking, 'I shall have peace though I do as I please, the just and the sinner perish together,'"
,"19":"Yahweh shall not pardon him. His rage and jealousy shall burn against that man, and all the curses written in this book await him. Yahweh will wipe out his name from under the heavens,"
,"20":"and will separate him from the tribes of Israel to his misfortune, according to all the curses of the Covenant expressed in this book of the Law."
,"21":"The future generations that will come after you and the foreigners who come from distant countries shall see the plagues of this land and the plagues Yahweh inflicted on it, and they shall say,"
,"22":"'A land of salt and sulfur is this one, burned and unsown; not even grass can be seen. So it was with Sodom and Gomorrah, Admah and Zeboiim, when Yahweh destroyed them and laid them waste in his anger and rage.'"
,"23":"All the nations shall ask: 'Why has Yahweh dealt so with this nation? What does such anger mean?'"
,"24":"And they shall answer: 'This happened because they abandoned the Covenant which Yahweh, the God of their fathers, made with them when he brought them out of Egypt,"
,"25":"because they went to serve other gods and worshiped them, gods that were not theirs and to whom Yahweh had not entrusted them."
,"26":"Therefore Yahweh was angry with that land, bringing upon it all the curses written in this book."
,"27":"Yahweh has pulled them out of their land with anger, rage and great indignation, and cast them into another land, as you can see today."
,"28":"The secret things belong to Yahweh, our God, but what he made known to us belongs to us and our children forever. So we have to put into practice all the provisions of this Law!"
}`)
	CurrentBook.AddChapter(30, `{
"1":"When these things come upon you according to this blessing and this curse that I have set before you, you will recall them among the nations where Yahweh, your God, has driven you."
,"2":"Then you will return to him, you and your children; you will listen to his voice with all your heart and with all your soul, obeying all that I command you today."
,"3":"So Yahweh, your God, will bring back the captives of your people, he will have pity on you, and will gather you again from all the nations where Yahweh has scattered you."
,"4":"Though you are driven out at the other end of the earth,"
,"5":"Yahweh will gather you even from there, and will take you once again to the land which your fathers possessed so that it may also be yours. He will make you happy and make you more numerous than your fathers."
,"6":"Yahweh, your God, will circumcise your heart and the heart of your descendants that you may love Yahweh with all your heart and with all your soul, in order that you may live."
,"7":"So Yahweh, your God, will inflict all these curses upon your enemies who hate you and persecute you."
,"8":"You shall again listen to Yahweh and put into practice all his commandments that I give you today."
,"9":"Yahweh, your God, will make you succeed in everything you do. He will multiply for your good your children, the offspring of your livestock and the fruits of your land. For Yahweh will again be pleased to treat you well, as he did your fathers."
,"10":"For you shall turn to Yahweh, your God, with all your heart and with all your soul, and observe his commandments and norms, in a word, everything written in this book of the Law."
,"11":"These commandments that I give you today are neither too high nor too far for you."
,"12":"They are not in heaven that you should say: 'Who will go up to heaven to get these commandments that we may hear them and put them into practice.'"
,"13":"Neither are they at the other side of the sea for you to say: 'Who will cross to the other side and bring them to us, that we may hear them and put them into practice.'"
,"14":"On the contrary, my word is very near you; it is already in your mouth and in your heart, so that you can put it into practice."
,"15":"See, I set before you on this day life and good, evil and death."
,"16":"I command you to love Yahweh, your God and follow his ways. Observe his commandments, his norms and his laws, and you will live and increase, and Yahweh will give you his blessing in the land you are going to possess."
,"17":"But if your heart turns away and does not listen, if you are drawn away and bow before other gods to serve them,"
,"18":"I declare on this day that you shall perish. You shall not last in the land you are going to occupy on the other side of the Jordan."
,"19":"Let the heavens and the earth listen, that they may be witnesses against you. I have set before you life and death, blessing and curse. Therefore, choose life that you and your descendants may live,"
,"20":"loving Yahweh, listening to his voice, and being one with him. In this is life for you and length of days in the land which Yahweh swore to give to your fathers, to Abraham, Isaac and Jacob.'"
}`)
	CurrentBook.AddChapter(31, `{
"1":"When Moses finished telling all Israel these words, he said,"
,"2":"'I am now a hundred and twenty years old and I can no longer deal with anything - Remember that Yahweh told me that I shall not cross the Jordan River."
,"3":"Now Joshua shall be at your head, as Yahweh has said. He, your God, will go before you to destroy these nations before you, and you will drive them away."
,"4":"Yahweh shall deal with these cities as he dealt with Sihon and Og, the Amorite kings, and their land, which he destroyed."
,"5":"So when he has given these nations over to you, you shall do the same, according to what I have commanded you."
,"6":"Be valiant and strong, do not fear or tremble before them for Yahweh, your God, is with you; he will not leave you or abandon you.'"
,"7":"After this, Moses called Joshua and said to him in the presence of all Israel: 'Be valiant and strong, you shall go with this people into the land which Yahweh swore to their fathers he would give them and you shall give it to them as their possession."
,"8":"Yahweh shall go before you. He shall be with you; he shall not leave you or abandon you. Do not fear, then, or be discouraged.'"
,"9":"Moses put this Law in writing and entrusted it to the priests, descendants of Levi, who carried the Ark of the Covenant of Yahweh, as well as to all the leaders of Israel,"
,"10":"giving this order to them: 'Every seven years, at the time fixed for the Year of Pardon, on the Feast of the Tents,"
,"11":"when all Israel assembles to present themselves before Yahweh in the place chosen by him, you shall read this Law in the hearing of all Israel."
,"12":"Assemble the people - men, women and children, and the foreigner who lives in your cities - that they may listen to it, learn to fear Yahweh and take care to put into practice all the words of this Law."
,"13":"Your children who do not know it yet shall hear it and learn to fear Yahweh, your God, all the days that they live in the land which you are going to conquer after crossing the Jordan.'"
,"14":"Yahweh said to Moses: 'The day of your death is already near. Call Joshua that the two of you may present yourselves to me in the Tent of Meeting, that I may give him my orders.',So Moses and Joshua presented themselves in the Tent of Meeting. "
,"15":"Yahweh appeared to them in the Tent in a column of cloud; the column was at the entrance of the Tent."
,"16":"And Yahweh said to Moses: 'Now you are going to rest with your fathers. Then this people shall rebel and prostitute themselves to strange gods, the gods of the land which they are going to enter. They shall abandon me and break the Covenant I have made with them. "
,"17":"On that day, I shall be angry with them, I shall abandon them and hide my face from them. They will be devoured, and many evils and adversities will come upon them so that they will say: 'Have not these evils come upon me because my God is not in our midst anymore?'"
,"18":"But on that day I shall hide my face from them because of all the evil which they have done in going after other gods."
,"19":"So, write this song and teach it to the children of Israel and have them remember it, for this song shall be my witness against the children of Israel."
,"20":"For I shall bring them to the land which I swore to their fathers, a land flowing with milk and honey, but after they have eaten and are satisfied and have grown fat, they shall turn to other gods and pay homage to them while despising me and breaking my Covenant."
,"21":"And when these evils and calamities without number come upon them, this song shall bear witness against them, since their descendants will not forget it. I know very well the plans they are already making even before they have entered the land which I promised them.'"
,"22":"On that day, Moses wrote this song and taught it to the children of Israel."
,"23":"Then Moses told Joshua, son of Nun, 'Be valiant and strong, for you shall bring the children of Israel to the land which Yahweh promised to them, and I shall be with you.'"
,"24":"When he finished writing in a book all the words of this Law,"
,"25":"Moses gave this order to the Levites who carried the Ark of the Covenant of Yahweh,"
,"26":"'Take the book of this Law. Place it by the side of the Ark of the Covenant of Yahweh, your God. There it shall remain as a witness against you,"
,"27":"because I know how rebellious and stubborn you are. If today, as I live among you, you are rebellious against Yahweh, how much more shall you be after my death?"
,"28":"Gather together around me all the leaders and secretaries of all the tribes, I am going to say these words in their hearing, and I shall ask heaven and earth to witness against you."
,"29":"For I know that after my death, you shall do perverse things and shall stray from the way that I have pointed out to you. And misfortune shall come upon you in the future for doing what is evil in the eyes of Yahweh, provoking his anger with the work of your hands.'"
,"30":"Then, before the whole assembly of Israel, Moses recited this song until the end."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Listen, O heavens, as I speak; hear, earth, the words of my mouth."
,"2":"May my teaching be drenching as the rain, and my words, permeate gently as the dew: like abundant rain upon the grass, like a gentle shower on the tender crops."
,"3":"For I will proclaim the name of the Lord and declare the greatness of our God."
,"4":"He is the Rock, and perfect are all his works, just are all his ways. A faithful God he is, upright and just and unerring."
,"5":"Yet he has been treated perversely,by his degenerate children -,a deceitful and crooked generation."
,"6":"Is this how you repay the Lord, you foolish and senseless people?,He is your father, your creator, who formed you and set you up."
,"7":"Recall the days of old, think of the years gone by; your father will teach you about them, your elders will enlighten you."
,"8":"When the Most High divided mankind and gave the nations their inheritance, he set up boundaries for the peoples,after the number of the sons of God."
,"9":"But the Lord keeps for himself his portion,Jacob, his chosen one."
,"10":"In the wilderness he found them, in a barren, howling wasteland; he shielded them and cared for them,as the apple of his eye."
,"11":"Like an eagle watching its nest, hovering over its young, supporting them on its spread wings,and carrying them on its pinions,"
,"12":"the Lord alone led them, without the aid of a foreign god."
,"13":"He made them ride on the heights,and live on the produce of the earth. He gave them honey to suck from the rock, olive oil from the hard stony crag,"
,"14":"curds from the herd, milk from the flock, fattened lambs and goats and Bashan bulls, the finest wheat and the best grape wine."
,"15":"Israel grew up well nourished -,you were fat, heavy and overfed. But they abandoned God, their creator; they rejected the rock, their savior."
,"16":"They made him jealous with their strange gods; they angered him with their abominable deeds."
,"17":"They sacrificed not to him but to the demons, to gods they had not known, to newly arrived gods they feared,but which their fathers never revered."
,"18":"They have disowned the Rock who fathered them; they have forgotten the God who gave them birth."
,"19":"The Lord saw this, and in his anger rejected his sons and daughters."
,"20":"He said, 'I will hide my face from them,and see what will become of them. They are so perverse, so unfaithful!"
,"21":"They made me jealous with their false gods,and angered me with their idols. I will, therefore, make them envious of a foolish people, I will provoke them to anger with an empty-headed nation."
,"22":"For my wrath has kindled a fire, burning the world of death to its depths, devouring the earth and its harvests, setting ablaze the foundations of the mountains."
,"23":"I will send them trouble upon trouble,and spend all my arrows upon them;"
,"24":"I will afflict them with famine, deadly diseases and pestilence. I will send them wild beasts and venomous snakes."
,"25":"Their children will fall by the sword; terror shall reign within, destroying both young man and virgin, both the sucking child and the old man."
,"26":"I said I would scatter them afar,and blot out their memory among mankind,"
,"27":"but I feared the enemy's boasting, lest the adversary misunderstand,and say; 'We have triumphed, the Lord has brought this about.'"
,"28":"They are a senseless and undiscerning nation. Had they wisdom, they would have known"
,"29":"the meaning of this and the end awaiting them."
,"30":"For how could one or two men put to flight a thousand or ten thousand, unless their Rock had abandoned them, unless their Lord had given them up?"
,"31":"Even our enemies understand this: their rock indeed is not like our Rock:"
,"32":"They are an offshoot of Sodom's vinestock, an outgrowth from the fields of Gomorrah; their grapes are poison, their clusters bitter,"
,"33":"their wine contains venom,from the cruel fangs of deadly vipers."
,"34":"I have kept this in reserve,and sealed up in my storehouse."
,"35":"Vengeance and recompense is mine. Their feet will slip in due time, their day of calamity is at hand, and swiftly their doom will come."
,"36":"The Lord will give justice to his people,and have mercy on his servants, when he sees their strength failing,and both slave and free disappearing."
,"37":"He will say, 'Where are their gods, the rock they thought could be their refuge,"
,"38":"who ate the fat of their sacrifices and drank the wine of their libations?,Let them rise up now and help you, let them give you protection!"
,"39":"Learn this now - that I alone am He; there is no god besides me. It is I who give both death and life; it is I who wound and heal as well,and out of my hand no one can deliver."
,"40":"I raise my hand to heaven and swear: as truly as I live forever,"
,"41":"when I sharpen my glittering sword and my hand takes hold of judgment, I will deal out vengeance upon my foes,and retribution upon those who hate me."
,"42":"My arrows will drip with blood, my sword will sink deep into the flesh - blood of the wounded and slain captives, flesh of beheaded enemy leaders."
,"43":"Rejoice, O nations, with his people, for he will avenge his servants' blood, take vengeance on his adversaries, and perform the rite of expiation,for his people and his land."
,"44":"Moses recited the words of this song in the hearing of the people, and Joshua, son of Nun, was with him."
,"45":"When Moses had finished reciting these words to all Israel,"
,"46":"he said to them, 'Be attentive to all these words which I declare to you today. Repeat them to your children so that they may take care to put all these laws into practice."
,"47":"It is no slight matter: on this depends your life, and by this, you shall lengthen your days in the land you are going to conquer after crossing the Jordan.'"
,"48":"Yahweh spoke to Moses on that same day and he said:"
,"49":"'Go up to the mountains of Abarim in the land of Moab and climb Mount Nebo facing Jericho. From there you shall see the land of Canaan which I give to the children of Israel."
,"50":"Then you shall die on Mount Nebo and join your fathers as your brother Aaron died on Mount Hor and went to join them."
,"51":"Remember that you did not trust me at the waters of Meribah in the desert of Zion, when you did not proclaim me before the Israelites."
,"52":"Therefore you shall not enter the Land, but shall only see it from afar.'"
}`)
	CurrentBook.AddChapter(33, `{
"1":"This is the blessing that Moses gave to the children of Israel before he died. He said:"
,"2":"'Yahweh has come from Sinai; he rises above the horizon of Seir for his people. He has shone from Mount Paran; he has come to Meribah of Kadesh for them; his midday radiance has reached Ashdot."
,"3":"Yahweh loves these tribes and his hand protects his holy ones; they bow before his feet, waiting for his teaching."
,"5":"He came to Israel as king, and made himself the inheritance of the children of Israel when the leaders assembled and the tribes of Israel gathered together."
,"6":"Let Reuben live and not die, nor let his men be few.'"
,"7":"This is the blessing for Judah: 'Listen, Yahweh, to the voice of Judah, and let him be with his people. His hands will fight for him and will help him against his opponents.'"
,"8":"He said of Levi: 'You have given, O Yahweh, your Thummim and Urim to him who loves you, whom you tested at Massah and reproached at Meribah."
,"9":"He said to his parents 'I do not know you,' and disowned his brothers and sisters and children. He has observed your words and kept your Covenant."
,"10":"They teach Jacob your decrees, Israel your Law. They offer you incense and make sacrifices on your altar."
,"11":"Bless, O Yahweh, his courage and accept his service. Strike the back of his foes, that his enemies may not rise against him anymore.'"
,"12":"He said of Benjamin: 'Beloved of Yahweh, you put your trust in him who protects you, and you dwell in his hills.'"
,"13":"He said to Joseph: 'Your land has received the blessings of Yahweh, the dew from heaven and the waters that gush forth from the deep,"
,"14":"the sun-ripened fruits and the liberal produce of the months,"
,"15":"the best of the ancient mountains and the everlasting hills, the generous land and all that is in it."
,"16":"May the blessing of him who arose in the bush descend upon the head of Joseph, for he is the chosen one among his brothers."
,"17":"Joseph is his firstling bull, glory to him! His horns are those of a wild ox, with which he strikes all the people at the same time. See the multitudes of Ephraim, and the thousands of Manasseh!'"
,"18":"He said to Zebulun: 'Rejoice, Zebulun, when you journey. Rejoice, Issachar, in your tents."
,"19":"They call the peoples to the sacred mountain for the prescribed sacrifices. They enjoy the riches of the sea and the hidden treasures of the sand.'"
,"20":"He said of Gad: 'Blessed be he who enlarges Gad. Like a lioness, he couches and tears the arm and head."
,"21":"He chooses the best part, the part reserved for the leader. He has led the people. He has fulfilled the justice of Yahweh and his decisions in favor of Israel.'"
,"22":"He said of Dan: 'Dan is a lion's cub that leaps forth from Bashan.'"
,"23":"He said of Naphtali: 'Naphtali is filled with favors, filled with the blessing of Yahweh. May your land reach to the south and to the sea!'"
,"24":"He said of Asher: 'May Asher be blessed among the sons. May he be preferred to his brothers and let him put his feet in oil."
,"25":"May his fastening bars be iron and bronze. May you be strong as long as you live."
,"26":"There is none like our God, O Israel, who walks above the heavens, riding above the clouds, and comes to help you in his zeal."
,"27":"The eternal God is a refuge; from eternity he frees you with his arm. He drives your enemy away before you and says to you: 'Destroy him.'"
,"28":"Israel dwells in safety. The fountain of Jacob flows in the land of wheat and wine, and dew comes from heaven."
,"29":"Happy are you, O Israel! Who is like you, a people saved by Yahweh? He is the shield that protects you, the sword that gives you victory! Your enemies shall flee from you, but you, you are outstanding in everything.'"
}`)
	CurrentBook.AddChapter(34, `{
"1":"From the barren plain of Moab, Moses went up to Mount Nebo, to the summit of Pisgah, opposite Jericho. And Yahweh showed him all the Land: from Gilead to Dan,"
,"2":"the whole of Naphtali, the land of Ephraim, and of Manasseh, the whole land of Judah, as far as the Western Sea,"
,"3":"the Negeb, the Plains, the valley of Jericho, the city of palm trees, as far as Zoar."
,"4":"And Yahweh said to him: 'This is the land about which I swore to Abraham, Isaac and Jacob, promising it to their descendants. I have let you see it with your own eyes, but you shall not enter it.'"
,"5":"Moses, the servant of God, died there in the land of Moab, according to the will of Yahweh."
,"6":"They buried him in the valley in the land of Moab opposite Beth-peor; but to this very day, no one knows where his tomb is."
,"7":"Moses was a hundred and twenty years old when he died. He did not lose his vigor and his eyes still saw clearly."
,"8":"The children of Israel mourned for him in the plains of Moab for thirty days."
,"9":"But Joshua, son of Nun, was full of the spirit of wisdom because Moses had laid his hands upon him. The children of Israel obeyed him and did as Yahweh had commanded Moses."
,"10":"No prophet like Moses has appeared again. Yahweh conversed with him face to face."
,"11":"What signs and wonders he worked in Egypt against Pharaoh, against his people and all his land!"
,"12":"What a powerful hand was his that worked these terrible things in the sight of all Israel!"
}`)

}
func EN_CCB_LoadVPEXChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Here are the names of the sons of Israel who came to Egypt with Jacob, each with his family:"
,"2":"Reuben, Simeon, Levi and Judah,"
,"3":"Issachar, Zebulun and Benjamin,"
,"4":"Dan and Naphtali, Gad and Asher."
,"5":"These descendants of Jacob numbered seventy in all; apart from these, Joseph was already in Egypt."
,"6":"Then Joseph died as did all his brothers and all that generation."
,"7":"The sons of Israel were fruitful and kept increasing. To such an extent did they multiply and grow in strength that the land teemed with them."
,"8":"Then a new king who had not known Joseph came to power"
,"9":"and said to his people, 'The Israelites are more numerous and stronger than we are."
,"10":"Let us deal warily with them lest they increase still more and, in case of war, side with our enemy, fight against us and escape from the land.'"
,"11":"So they set taskmasters over them to oppress them with forced labor. In that way they built the storage towns of Pithom and Rameses."
,"12":"But the more they oppressed the Hebrews the more they increased and spread, until the Egyptians dreaded the Israelites"
,"13":"and became ruthless in making them work."
,"14":"They made life bitter for them in hard labor with bricks and mortar and with all kinds of work in the fields. In all their work the Egyptians treated them harshly."
,"15":"Then the king of Egypt gave orders to the Hebrew midwives - one of whom was called Shiprah and the other Puah -"
,"16":"that when they attended Hebrew women who were on the birthstool and saw that it was a boy, they were to kill it, but if it was a girl they were to let it live."
,"17":"But the midwives feared God and did not do as the king of Egypt commanded but let the children live."
,"18":"The king called the midwives and said, 'Why have you acted like that and let the children live?'"
,"19":"The midwives replied, 'Because the Hebrew women are not like the Egyptian women. They are vigorous and give birth even before a midwife arrives.'"
,"20":"God blessed the midwives, and the people increased and became even more numerous."
,"21":"Because the midwives revered God, he made them mothers of families."
,"22":"Pharaoh then gave this order to all the people: 'Every infant boy born to the Hebrews must be thrown into the Nile, but every girl may live.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Now a man belonging to the clan of Levi married a woman of his own tribe."
,"2":"She gave birth to a boy and, seeing that he was a beautiful child, she kept him hidden for three months."
,"3":"As she could not conceal him any longer, she made a basket out of papyrus leaves and coated it with tar and pitch. She then laid the child in the basket and placed it among the reeds near the bank of the Nile;"
,"4":"but the sister of the child kept at a distance to see what would happen to him."
,"5":"Now the daughter of Pharaoh came down to bathe in the Nile; her attendants meanwhile walked along the bank. When she saw the basket among the reeds, she sent her maidservant to fetch it."
,"6":"She opened the basket and saw the child - a boy, and he was crying! She felt sorry for him, for she thought: 'This is one of the Hebrew children.'"
,"7":"Then the sister of the child said to Pharaoh's daughter, 'Shall I go and get one of the Hebrew women to nurse the baby for you?'"
,"8":"Pharaoh's daughter agreed, and the girl went to call the mother of the child."
,"9":"Pharaoh's daughter said to her, 'Take the child and nurse him for me and I will pay you.' So the woman took the child and nursed him"
,"10":"and, when the child had grown, she brought him to Pharaoh's daughter who adopted him as her son. And she named him Moses to recall that she had drawn him out of the water."
,"11":"After a fairly long time, Moses, by now a grown man, wanted to meet his fellow Hebrews. He noticed how heavily they were burdened and he saw an Egyptian striking a Hebrew, one of his own people."
,"12":"He looked around and seeing no one, he killed the Egyptian and hid him in the sand."
,"13":"When he went out the next day he saw two Hebrews quarreling. Moses said to the man in the wrong, 'Why are you striking a fellow countryman?'"
,"14":"But he answered, 'Who has set you prince and judge over us? Do you intend to kill me as you killed the Egyptian?' Moses was afraid and thought, 'What I did must be known.'"
,"15":"When Pharaoh heard about it he tried to kill Moses, but Moses fled from Pharaoh and went to live in the land of Midian. There he sat down by a well."
,"16":"A priest of Midian had seven daughters. They came to draw water and fill the troughs to water their father's sheep."
,"17":"Some shepherds came and drove them away; but Moses went to their help and watered the sheep."
,"18":"When the girls returned to their father Reuel, he asked them, 'Why have you come back so early today?'"
,"19":"They said, 'An Egyptian protected us from the shepherds, and even drew water for us and watered the sheep.'"
,"20":"The man said, 'Where is he? Why did you leave him there? Call him and offer him a meal.'"
,"21":"Moses agreed to stay with the man and he gave Moses his daughter Zipporah in marriage."
,"22":"She had a child and Moses named him Gershom, to recall that he had been a guest in a strange land."
,"23":"It happened during that long period of time that the king of Egypt died. The sons of Israel groaned under their slavery; they cried to God for help and from their bondage their cry ascended to God."
,"24":"God heard their sigh and remembered his covenant with Abraham, Isaac and Jacob."
,"25":"God looked upon the sons of Israel and revealed himself to them."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Moses pastured the sheep of Jethro his father-in-law, priest of Midian. One day he led the flock to the far side of the desert and came to Horeb, the Mountain of God."
,"2":"The Angel of Yahweh appeared to him by means of a flame of fire in the middle of a bush. Moses saw that although the bush was on fire it did not burn up."
,"3":"Moses thought, 'I will go and see this amazing sight, why is the bush not burning up?'"
,"4":"Yahweh saw that Moses was drawing near to look, and God called to him from the middle of the bush, 'Moses! Moses!' He replied, 'Here I am.'"
,"5":"Yahweh said to him, 'Do not come near; take off your sandals because the place where you are standing is holy ground.'"
,"6":"And God continued, 'I am the God of your fathers, the God of Abraham, the God of Isaac and the God of Jacob.',Moses hid his face lest his eyes look on God. "
,"7":"Yahweh said, 'I have seen the humiliation of my people in Egypt and I hear their cry when they are cruelly treated by their taskmasters. I know their suffering."
,"8":"I have come down to free them from the power of the Egyptians and to bring them up from that land to a beautiful spacious land, a land flowing with milk and honey, to the territory of the Canaanites, the Hittites, the Amorites, the Perizzites, the Hivites and the Jebusites. "
,"9":"The cry of the sons of Israel has reached me and I have seen how the Egyptians oppress them."
,"10":"Go now! I am sending you to Pharaoh to bring my people, the sons of Israel, out of Egypt.'"
,"11":"Moses said to God, 'Who am I that I should go to Pharaoh and bring the people of Israel out of Egypt?'"
,"12":"God replied, 'I will be with you and this will be the sign that I have sent you. When you have brought the people out of Egypt, you will worship God on this mountain.'"
,"13":"Moses answered God, 'If I go to the Israelites and say to them: 'The God of your fathers has sent me to you,' they will ask me: 'What is his name?' What shall I answer them?'"
,"14":"God said to Moses, 'I AM WHO AM. This is what you will say to the sons of Israel: 'I AM sent me to you.'"
,"15":"God then said to Moses, 'You will say to the Israelites: 'YAHWEH, the God of your fathers, the God of Abraham, the God of Isaac and the God of Jacob, has sent me.' That will be my name forever, and by this name they shall call upon me for all generations to come."
,"16":"Go! Call together the elders of Israel and say to them, 'Yahweh, the God of your fathers, the God of Abraham, the God of Isaac and the God of Jacob appeared to me and said: I have seen and taken account of how the Egyptians have treated you,"
,"17":"and I mean to bring you out of all this oppression in Egypt and take you to the land of the Canaanites, a land flowing with milk and honey.'"
,"18":"The elders of Israel will listen to you and, with them, you shall go to the palace of the king of Egypt and say to him: 'The God of the Hebrews, Yahweh, has met with us. Now let us go a three days' journey into the wilderness to sacrifice to Yahweh our God.'"
,"19":"I well know that the king of the Egyptians will not allow you to go unless he is forced to do so."
,"20":"I will therefore stretch out my hand and strike Egypt in extraordinary ways, after which he will let you go."
,"21":"And I will make the Egyptians treat my people well when you leave; you will not go empty-handed."
,"22":"Each woman will ask her neighbor, and any Egyptian woman staying in her house, to lend her ornaments of silver and gold, and clothing. With these you will clothe your sons and daughters, and in this way you will plunder the Egyptians.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Moses replied to Yahweh, 'What if they will not believe me or listen to me? Maybe they will say: 'That's not true. Yahweh did not appear to you.'"
,"2":"Yahweh then asked him, 'What is that in your right hand?' 'A staff,' he replied."
,"3":"God said, 'Throw it to the ground.' He threw it and it became a serpent; and Moses drew back from it."
,"4":"Yahweh said, 'Take it by the tail.' Moses took it and it was again a staff in his hand."
,"5":"Then Yahweh said, 'With such signs they may believe that Yahweh, the God of your fathers, appeared to you.'"
,"6":"Again Yahweh said to him, 'Put your hand on your chest.' He put his hand on his chest and when he took it away his hand was covered with leprosy, white as snow."
,"7":"And God said, 'Put your hand back on your chest.' So he put it back, and when he took it away again, his hand was healthy like the rest of his body."
,"8":"Yahweh added, 'If they don't believe you and are not convinced by the first sign, they will believe you when they see the second."
,"9":"But if these two signs are not enough to make them believe you, take some water from the Nile and pour it on the ground; and the water from the river will turn into blood.'"
,"10":"Moses said to Yahweh, 'But, my Lord, never have I been a fluent speaker either before or after you have spoken to me. I cannot find words to express what I want to say.'"
,"11":"Yahweh said to him,'Who gave man a mouth? Who makes him dumb or deaf, with sight or blind? Is it not I, Yahweh?"
,"12":"Go now. I will be on your lips and will inspire what you say.'"
,"13":"But Moses insisted, 'My Lord, I pray you, why not send someone else?'"
,"14":"At this Yahweh became angry with Moses and said, 'Haven't you Aaron, your brother, the Levite? I know he speaks well. Look! He is coming to meet you,"
,"15":"and he will be glad when he sees you. You will speak to him and tell him what I have told you to say. And when you tell him, or when he speaks, I will be with you and teach you what you have to say."
,"16":"Aaron will speak for you as a prophet speaks for his god."
,"17":"And with this staff in your hand you will work miraculous signs.'"
,"18":"Then Moses went back to Jethro, his father-in-law, and said to him, 'I am going back to my brothers in Egypt to see if they are still alive.' Jethro said to Moses, 'Go in peace!'"
,"19":"Yahweh said to Moses in the land of Midian, 'Go back to Egypt for all the men who wanted to kill you are dead.'"
,"20":"Moses took with him his wife and his sons. He put them on a donkey and set off for Egypt, holding in his hand the staff of God."
,"21":"Yahweh said to Moses, 'You are returning to Egypt and you will perform all the miraculous signs that I have empowered you to do, in the presence of Pharaoh. I will, however, make him stubborn so that he will not let the people go."
,"22":"You shall then say to Pharaoh: 'This is Yahweh's message: Israel is my firstborn son,"
,"23":"and I said to you: Let my son go that he may worship me. But you have refused to let him go and, because of this, I will take the life of your firstborn son.'"
,"24":"At a lodging place on the way, the Angel of Yahweh approached Moses and tried to kill him."
,"25":"But Zipporah took a flint stone and cut her son's foreskin and, with it, she touched the feet of Moses saying, 'You are now my husband by blood!'"
,"26":"And the Angel left him. Zipporah said 'husband by blood' because of the circumcision."
,"27":"Yahweh said to Aaron, 'Go into the desert and meet your brother, Moses.' So Aaron went and met him at the Mountain of God and kissed him."
,"28":"Moses related to Aaron all that Yahweh had said to him and all the signs he had commanded him to perform."
,"29":"Moses and Aaron assembled all the elders of the Israelites"
,"30":"and Aaron told them everything that Yahweh had said to Moses. He also performed all the signs before the people and they believed him."
,"31":"When they heard that Yahweh had visited the people of Israel and had seen their suffering, they bowed to the ground and worshiped him."
}`)
	CurrentBook.AddChapter(5, `{
"1":"After this Moses and Aaron went to Pharaoh and said, 'This is what Yahweh, the God of Israel says: 'Let my people go that they may hold a feast for me in the desert.'"
,"2":"Pharaoh replied, 'Who is Yahweh that I should listen to his voice and let Israel go? I do not know Yahweh and I will not let Israel go.'"
,"3":"They then said, 'The God of the Hebrews has met with us. Allow us to make a three days' journey to the desert. There we shall offer sacrifices to Yahweh, our God, lest he punish us with the plague or the sword.'"
,"4":"The king of Egypt said to them, 'Moses and Aaron, why do you take people away from their work? Get back to your tasks."
,"5":"The people are now numerous and you are asking them to interrupt their work.'"
,"6":"That same day Pharaoh gave the following order to the taskmasters of the people and to the Israelite foremen,"
,"7":"'You will no longer supply the people with straw for making bricks. Let them go and find it themselves;"
,"8":"but you will exact from them the same number of bricks as before, not one less. They are lazy and that is why they are crying out to go and sacrifice to their God."
,"9":"Make the work harder for the people and pay no attention to their lies.'"
,"10":"The slave drivers and their Israelite foremen went out and said to the people, 'Pharaoh will not give you any more straw."
,"11":"Go and get it yourselves wherever you can find it, but the amount of work done must be the same as before.'"
,"12":"The people scattered throughout Egypt to gather stubble to use for straw."
,"13":"The taskmasters kept pressing them, saying, 'Complete the work required of you each day, as you did when you had straw.'"
,"14":"The taskmasters beat the Israelite foremen they had placed over the people saying, 'Why haven't your people completed the same amount of work as before?'"
,"15":"The Israelite foremen complained to Pharaoh saying, 'Why do you treat us like this?"
,"16":"We are given no straw and yet we are told to make bricks. We are being beaten, but the fault is with your own people.'"
,"17":"Pharaoh replied, 'Lazy! You are lazy, and that is why you ask to go and sacrifice to Yahweh."
,"18":"Go back to work. You will not be given straw but you will produce the same number of bricks.'"
,"19":"The Israelite foremen felt they were in great trouble."
,"20":"They met Moses and Aaron who were waiting for them"
,"21":"and said to them, 'May Yahweh look upon you and judge you, because you have made us hateful to Pharaoh and his ministers, and placed in his hand a sword to kill us.'"
,"22":"Moses then turned to Yahweh and said, 'O Lord! Why have you treated your people so badly? Why did you send me?"
,"23":"From the time I spoke to Pharaoh in your name, he has brought trouble on this people and you have done nothing to rescue them!'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Yahweh said to Moses, 'Now you will see that I will overcome him and oblige him to let you go, even force him to drive you out of his land.'"
,"2":"God spoke to Moses saying, 'I am Yahweh!"
,"3":"I appeared to Abraham, Isaac and Jacob as God Almighty, but I did not make myself known to them by the name of Yahweh."
,"4":"I established my covenant with them promising to give them the land of Canaan, in which they lived as strangers,"
,"5":"and now I remember my covenant as I hear the groaning of the Israelites enslaved by the Egyptians."
,"6":"Therefore say this to them: 'I am Yahweh. I will take you away from the burden of Egypt and free you from its bondage; I will redeem you with the blows of my powerful hand."
,"7":"I will take you for my people and you will know that I am Yahweh your God who delivered you from the slavery of the Egyptians."
,"8":"I will bring you to the land I swore I would give to Abraham, Isaac and Jacob and I will give it to you as your own possession. I am Yahweh.'"
,"9":"This is how Moses spoke to the people of Israel but they did not listen, so discouraged were they by their cruel slavery."
,"10":"Yahweh spoke to Moses saying,"
,"11":"'Go and speak to Pharaoh, king of Egypt and tell him to let the people of Israel leave the country.'"
,"12":"But Moses said, 'If the sons of Israel paid no attention to me, how then will Pharaoh listen to me, a man who has difficulty in expressing himself?'"
,"13":"But Yahweh spoke to Moses and Aaron and ordered them, and Pharaoh as well, to bring the people of Israel out of Egypt."
,"14":"These were the heads of the tribes: Sons of Reuben, Israel's firstborn: Hanoch, Pallu, Hezron and Carmi; these are the families of Reuben."
,"15":"Sons of Simeon: Jemuel, Jamin, Ohad, Jachin, Zohar, and Shaul, son of a Canaanite woman; these are the families of Simeon."
,"16":"These are the sons of Levi with their descendants: Gershon, Kohath and Merari. Levi lived a hundred and thirty-seven years."
,"17":"Sons of Gershon: Libni and Shimei and their descendants."
,"18":"Sons of Kohath: Amram, Izhar, Hebron and Uzziel. Kohath lived for a hundred and thirty-three years."
,"19":"Sons of Merari: Mahli and Mushi. These are the descendants of Levi with their families."
,"20":"Amram married Jochebed, his aunt, who gave him two sons, Aaron and Moses. Amram lived a hundred and thirty-seven years."
,"21":"The sons of Izhar were: Korah, Nepheg and Zichri."
,"22":"The sons of Uzziel: Mishael, Elzaphan and Sithri."
,"23":"Aaron married Elisheba, daughter of Amminadab and sister of Nahshon, and she bore him Nadab, Abihu, Eleazar and Ithamar."
,"24":"The sons of Korah: Assir, Elkanah and Abiasaph. These are the families of the Korahites."
,"25":"Eleazar, son of Aaron, married one of Putiel's daughters and Phinehas was their son. These are the heads of the families of the Levites according to their clans."
,"26":"It was to Aaron and Moses that Yahweh said, 'Bring the people of Israel out of the land of Egypt in divisions.'"
,"27":"It was they who spoke with Pharaoh, king of Egypt, about bringing the sons of Israel out of Egypt. Yes, it was Moses and Aaron."
,"28":"When Yahweh spoke to Moses in the land of Egypt,"
,"29":"he said, 'I am Yahweh. Say to Pharaoh, king of Egypt, all that I tell you.'"
,"30":"But Moses replied, 'I am a poor speaker and why would Pharaoh listen to me?'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Yahweh said to Moses, 'See, I have made you like a god in Pharaoh's eyes; and Aaron, your brother, will be your prophet."
,"2":"You will tell Aaron all that I command you, and he will tell Pharaoh to let the people of Israel leave the country."
,"3":"But I will make him stubborn and although I multiply my signs and miracles,"
,"4":"he will not listen to you. Then I will use my power and lead my armies, my people, the sons of Israel out of Egypt by means of great punishments."
,"5":"Then will the Egyptians know that I am Yahweh when they see with what power I bring the people of Israel out of their country.'"
,"6":"Moses and Aaron did exactly what Yahweh had commanded."
,"7":"Moses was eighty and Aaron eighty-three when they spoke to Pharaoh."
,"8":"Yahweh spoke to Moses and Aaron saying,"
,"9":"'When Pharaoh speaks to you and tells you to perform a miracle to prove the truth of what you say, you will say to Aaron: 'Take your staff and throw it down before Pharaoh, and it will become a snake.''"
,"10":"Moses and Aaron went to Pharaoh and did what Yahweh had commanded. Aaron threw his staff before Pharaoh and his ministers, and it became a snake."
,"11":"Pharaoh then summoned wise men and magicians, and they, too, the magicians of Egypt, did the same by means of their secret arts."
,"12":"Each one threw his staff down and the staffs became serpents. But Aaron's staff swallowed the staffs of the magicians."
,"13":"However, Pharaoh was obstinate and he did not listen to them, as Yahweh had said."
,"14":"Yahweh said to Moses, 'Pharaoh is stubborn; he has refused to let the people leave."
,"15":"So you will go to Pharaoh in the morning, when he goes to the water. Wait for him on the bank of the river and hold in your hand the staff that turned into a serpent."
,"16":"You will say to him, 'Yahweh, the God of the Hebrews, sent me to say to you: 'Let my people go to worship me in the desert; but so far you have not listened."
,"17":"By this you shall learn that I am Yahweh: Look, I will strike the waters of the Nile with the staff I have in my hand, and they will turn into blood!"
,"18":"The fish in the river will die and the Nile will become foul, and the Egyptians will no longer be able to drink its water.'"
,"19":"Yahweh said to Moses, 'Say to Aaron: 'Take your staff and stretch out your hand over the waters of Egypt, rivers, canals, ponds and pools of water; and they will turn into blood. There will be blood throughout Egypt, even in vessels of wood and stone.''"
,"20":"Moses and Aaron did as Yahweh had commanded. Aaron raised his staff and struck the waters of the Nile, in the presence of Pharaoh and his ministers, and all the water in the Nile turned to blood. "
,"21":"The fish in the river died and the Nile was contaminated so that the Egyptians could no longer drink the water of the Nile. There was blood all over the country of Egypt. "
,"22":"The Egyptian magicians, however, could do the same with their secret crafts, and Pharaoh remained unmoved; and, as Yahweh had foretold, he would not listen to Moses and Aaron."
,"23":"Pharaoh returned to his house as if nothing of importance had happened."
,"24":"And yet all the Egyptians were digging near the Nile for water to drink because they could not drink from the river."
,"25":"Seven days passed after Yahweh had struck the Nile."
,"26":"Yahweh said to Moses, 'Go to Pharaoh and tell him that Yahweh says, 'Let my people go to worship me!"
,"27":"If you refuse to let them leave, I will punish the country with a plague of frogs."
,"28":"The Nile will teem with frogs. They will invade your house, your bedroom and your bed, your servants' and your people's houses, your ovens and your kneading bowls."
,"29":"Over you and your people the frogs will climb.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Yahweh spoke to Moses, 'Say to Aaron: 'Stretch out your hand with your staff over the rivers, canals and ponds of Egypt"
,"2":"and cause frogs to cover all the country of Egypt.'"
,"3":"The magicians of Egypt did the same by means of their secret formulas, and they brought frogs over the land of Egypt!"
,"4":"Then Pharaoh summoned Moses and Aaron and said, 'Ask Yahweh to remove the frogs from me and my people and I will send your people to sacrifice to Yahweh.'"
,"5":"But Moses replied, 'Let me know, please, when I am to make the petition for you, your officials and your people that you may be rid of frogs except in the Nile.'"
,"6":"Pharaoh answered, 'Tomorrow'; and Moses said, 'Right, and that you may know that there is no one like Yah-weh, our God,"
,"7":"the frogs will disappear from you and your house, your servants and your people; only in the Nile will they remain.'"
,"8":"With this Moses and Aaron left Pharaoh. Then Moses called on Yahweh concerning the frogs that he had inflicted on Pharaoh. "
,"9":"Yahweh did as Moses had promised Pharaoh and the frogs died in the houses, the farms and the fields."
,"10":"The people piled them in heaps and the land was filled with a foul smell."
,"11":"Now that relief had come, Pharaoh became even more stubborn and would not listen, just as Yahweh had foretold."
,"12":"Yahweh said to Moses, 'Tell Aaron to strike the dust of the earth with his staff and turn it into mosquitoes throughout the land.'"
,"13":"Aaron did this; he struck the dust of the earth which turned into mosquitoes that tormented men and animals. All the dust of the earth all over Egypt turned into mosquitoes."
,"14":"But when the magicians tried, by means of their secret formulas, to drive away the mosquitoes, they were not able to do so, and the mosquitoes kept tormenting men and animals."
,"15":"The magicians said to Pharaoh, 'This is the finger of God'; but Pharaoh was unmoved and did not listen, as Yahweh had foretold."
,"16":"Yahweh said to Moses, 'Rise early in the morning and go to Pharaoh, when he is on his way to the river. Say to him: This is Yahweh's message: Let my people go and worship me."
,"17":"If you refuse to let them go, I will send horseflies on you, on your officials and on your people and your houses. The houses of the Egyptians will be filled with horseflies and even the ground on which they are built."
,"18":"But on that day I will spare the land of Goshen where my people are. No horseflies will be there and by this you may know that I, Yahweh, am in the land."
,"19":"I will make a distinction between my people and your people. By tomorrow this will have happened.'"
,"20":"Yahweh did this and dense swarms of horseflies invaded Pharaoh's house and the houses of all his people and devastated the whole country."
,"21":"Pharaoh summoned Moses and Aaron and said, 'Go and sacrifice to your God in this country.'"
,"22":"But Moses replied, 'That would not be right. We offer to our God animals which are sacred for the Egyptians. If we were to offer in their presence a sacrifice which offends the Egyptians, wouldn't they stone us?"
,"23":"We must make a three-day journey into the desert and there we will sacrifice to Yahweh, our God, as he commands.'"
,"24":"Pharaoh replied, 'I will let you go and sacrifice to your God in the desert, but on condition that you do not go far. And pray to God for me!'"
,"25":"Moses said, 'I am leaving you and I will pray to Yahweh for you, and tomorrow the horseflies will leave you, your officials and your people, but do not continue to deceive us by refusing to let the people go to the desert.'"
,"26":"Moses left Pharaoh's house and prayed to Yahweh"
,"27":"who did as Moses had asked, and delivered Pharaoh, his officers and people from the horseflies. Not one horsefly was left."
,"28":"But Pharaoh was relentless and refused to let the people go."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Yahweh said to Moses, 'Go to Pharaoh and say to him, 'This is the message of Yahweh, the God of the Hebrews: Let my people go and offer sacrifices to me."
,"2":"If you refuse to let them go and hold them back any longer,"
,"3":"the hand of Yahweh will bring a terrible plague on your horses, your donkeys and your camels, on your cattle and your sheep."
,"4":"But Yahweh will make a distinction between the livestock of Israel and that of Egypt. Nothing belonging to the people of Israel will die.'"
,"5":"Yahweh then fixed a time and said, 'It will be done tomorrow.'"
,"6":"Yahweh did this the following day; all the livestock belonging to the Egyptians died, but not one owned by the Israelites died."
,"7":"Pharaoh made inquiries and in fact found that none of the cattle belonging to the Israelites had died. But Pharaoh remained adamant and did not let the people go."
,"8":"Yahweh said to Moses and Aaron, 'Take two handfuls of ashes from the brick oven and let Moses throw it up in the air in front of Pharaoh's eyes."
,"9":"It will become fine dust all over Egypt and bring festering boils on men and animals.'"
,"10":"So they took ashes from the oven and, in the presence of Pharaoh, Moses threw it up in the air and it brought festering boils on men and animals."
,"11":"And the magicians could not stand before Moses because they had boils like all the other Egyptians."
,"12":"But Yahweh made Pharaoh stubborn and he did not listen to Moses and Aaron as Yahweh had foretold."
,"13":"Yahweh said to Moses, 'Rise early; present yourself to Pharaoh and say to him: This is the message of Yahweh, the God of the Hebrews: Send my people away to worship me"
,"14":"because this time I will send the full force of my plagues against you, your ministers and your people, that you may know there is no one like me in the whole world."
,"15":"For had I wished, I could have raised my hand against you and your people, and with a similar pestilence wiped you from the face of the earth."
,"16":"But this is why I have let you live: that you may witness my power and that my name may be celebrated throughout the earth."
,"17":"Are you still set against my people leaving the country?"
,"18":"Tomorrow at this time I will send very heavy hail such as has never been in Egypt from the day of its foundation."
,"19":"So now let all your livestock and all that you have in the fields take shelter, because when the hail falls on all that remains in the fields, whether men or animals, they will die.'"
,"20":"Those among Pharaoh's officials who believed Yahweh's word hurried to bring their slaves and cattle inside;"
,"21":"but those who paid no attention to Yahweh's warning left their slaves and their cattle in the fields."
,"22":"Then Yahweh said to Moses, 'Stretch out your hand towards heaven and let hail fall throughout Egypt on men and animals, and all that grows in the field.'"
,"23":"Moses stretched out his staff towards heaven and Yahweh sent thunder and hail; lightning struck the earth"
,"24":"and Yahweh rained hail on the land of Egypt: lightning flashed in the midst of the hail. It was very heavy hail such as had never been known in all Egypt from the time it had first become a nation."
,"25":"Throughout Egypt the hail struck everything in the fields, both men and animals. It beat down everything growing in the fields and felled every tree."
,"26":"But where the Israelites lived there was no hail."
,"27":"Pharaoh summoned Moses and Aaron and said, 'Now it is clear I have sinned. Yahweh is in the right; I and my people are in the wrong."
,"28":"Pray Yahweh to stop the thunder and hail! I will let you go, and no longer will you stay here.'"
,"29":"Moses said to him, 'As soon as I leave the town I will lift my hands towards Yahweh; the thunder will cease and there will be no more hail, and you will know that the earth is Yahweh's."
,"30":"But as for you and your officials, I know that you don't yet fear Yahweh, our God.'"
,"31":"The flax and the barley were ruined, as the barley was almost ripe and the flax was in flower,"
,"32":"but the wheat and the spelt which are late crops were not destroyed."
,"33":"Moses left Pharaoh and went out of the city and raised his hands towards Yahweh. The thunder and hail ceased and it stopped raining."
,"34":"Pharaoh, seeing that there was no rain and that the thunder and hail had ceased, sinned yet again."
,"35":"He and his ministers remained unyielding and would not let the Israelites go, just as Yahweh had foretold through Moses."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Yahweh said to Moses, 'Go to Pharaoh for I have made him stubborn and his ministers as well, in order to show my signs among them,"
,"2":"and that you may tell your grandchildren how I dealt harshly with the Egyptians and about the signs I worked among them, and that you may know that I am Yahweh.'"
,"3":"Moses went with Aaron and said to Pharaoh, 'This is the word of Yahweh, the God of the Hebrews: How much longer will you refuse to submit to me? Let my people go and worship me."
,"4":"If you refuse to let my people go, I will bring locusts into your country"
,"5":"and they will completely cover the surface of the land. They will devour what was left after the hail as well as every tree in the fields."
,"6":"They will fill your house and the houses of your ministers and all the houses in Egypt, something your fathers and their fathers before them have never seen from ancient times to this day.' Having said this, Moses turned away and left Pharaoh's presence."
,"7":"Pharaoh's ministers said to him, 'For how long will this man be a snare to us? Let the men go and worship Yahweh, their God. Don't you realize that Egypt is ruined?'"
,"8":"So Moses and Aaron were brought back to Pharaoh, and he said, 'Go! Worship Yahweh, your God. But exactly who are to go?'"
,"9":"Moses said, 'We shall go with our young and our old, with our sons and daughters, with our sheep and our cattle, for it is the great feast of Yahweh that we are to celebrate.'"
,"10":"Pharaoh said, 'May Yahweh help you if ever I let you go with your little ones! Oh no! It's clear you are bent on evil."
,"11":"No! Only the men will offer sacrifice to Yahweh, if that is what you want!' And they were driven away from Pharaoh's presence."
,"12":"Yahweh said to Moses, 'Stretch out your hand and bring locusts to the land of Egypt. Let them eat every plant in the land, everything that was left after the hail.'"
,"13":"So Moses stretched out his staff over the land of Egypt. All that day and night Yahweh brought an east wind over the land and in the morning the east wind brought the locusts."
,"14":"They came and settled on the land in such quantities as had never been seen before and will never be seen again."
,"15":"They covered the sky of Egypt and the earth was in darkness. They devoured all the vegetation in the land and all the fruit of the trees left after the hail. Nothing green remained, neither tree nor plant of the field, in all the land of Egypt."
,"16":"Because of all this Pharaoh hastened to summon Moses and Aaron and said to them, 'I have sinned against Yahweh, your God, and against you."
,"17":"Forgive my sin, I pray you, at least for once and ask Yahweh, your God, for a final favor: to rid me of this deadly plague.'"
,"18":"Moses left Pharaoh and interceded with Yahweh"
,"19":"who brought a very strong wind from the west that carried off the locusts and swept them into the Red Sea. Not one locust was left within the boundaries of Egypt."
,"20":"But Yahweh let Pharaoh be stubborn and he would not allow the Israelites to leave."
,"21":"Yahweh said to Moses, 'Stretch your hand towards heaven and let darkness descend on the land of Egypt, a darkness so dense that it can be felt.'"
,"22":"Moses stretched out his hand towards heaven and instantly black darkness covered the land of Egypt for three days."
,"23":"They could not see each other and they could not move about for three days, but where the sons of Israel lived, there was light."
,"24":"Pharaoh summoned Moses and said, 'Go and worship Yahweh, you and your children with you; leave only your flocks and herds behind!'"
,"25":"Moses said, 'Are you going to give us animals for our sacrifices and burnt offerings?"
,"26":"No! Our cattle to the last hoof must also go with us, for it is from our livestock that we will choose the victims we will offer to Yahweh. Moreover we shall not know which ones we must sacrifice until we arrive at that place.'"
,"27":"But Yahweh let Pharaoh be stubborn and Pharaoh would not let them go."
,"28":"Pharaoh said to Moses, 'Get out of my sight! Take care! Never come before me again, for the day you do, you will die!'"
,"29":"Moses said, 'It is as you say, I shall never come before you again.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Yahweh said to Moses, 'I will bring one more plague on Pharaoh and Egypt. After that he will send you away and even drive you away completely."
,"2":"Speak to the people and tell them that both men and women are to ask their neighbors for articles of silver and gold.'"
,"3":"Yahweh disposed the Egyptians favorably towards the people. Moses, moreover, was regarded as a person of importance in Egypt both by Pharaoh's ministers and by the people."
,"4":"Moses said, 'This is Yahweh's message: 'About midnight, I shall go through Egypt"
,"5":"and all the firstborn in Egypt shall die, from the firstborn of Pharaoh who is heir to the throne, to the firstborn of the servant behind the mill and the firstborn of the animals."
,"6":"There will be great wailing throughout all Egypt, such as has never been before and never will be again."
,"7":"But among the Israelites not a dog will howl for the death of either man or beast. This is that you may understand that Yahweh makes a distinction between Egypt and Israel."
,"8":"All these ministers of yours will come down to me and bow before me saying, 'Go, you and all who follow you!' After that I will leave.' And turning in anger he left Pharaoh."
,"9":"Yahweh said to Moses, 'Pharaoh will not listen to you, and so the wonders that I do in Egypt will be multiplied.'"
,"10":"Moses and Aaron had worked all these marvels in the presence of Pharaoh, but Yahweh had made Pharaoh obstinate and he would not let the people of Israel leave his country."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Yahweh spoke to Moses and Aaron in the land of Egypt and said,"
,"2":"'This month is to be the beginning of all months, the first month of your year."
,"3":"Speak to the community of Israel and say to them: On the tenth day of this month let each family take a lamb, a lamb for each house. "
,"4":"If the family is too small for a lamb, they must join with a neighbor, the nearest to the house, according to the number of persons and to what each one can eat."
,"5":"You will select a perfect lamb without blemish, a male born during the present year, taken from the sheep or goats."
,"6":"Then you will keep it until the fourteenth day of the month. On that evening all the people will slaughter their lambs "
,"7":"and take some of the blood to put on the doorposts and on top of the doorframes of the houses where you eat."
,"8":"That night you will eat the flesh roasted at the fire with unleavened bread and bitter herbs."
,"9":"Do not eat the meat lightly cooked or boiled in water but roasted entirely over the fire - the head, the legs and the inner parts."
,"10":"Do not leave any of it until the morning. If any is left till morning, burn it in the fire."
,"11":"And this is how you will eat: with a belt round your waist, sandals on your feet and a staff in your hand. You shall eat hastily for it is a passover in honor of Yahweh."
,"12":"On that night I shall go through Egypt and strike every firstborn in Egypt, men and animals; and I will even bring judgment on all the gods of Egypt, I, Yahweh!"
,"13":"The blood on your houses will be the sign that you are there. I will see the blood and pass over you; and you will escape the mortal plague when I strike Egypt."
,"14":"This is a day you are to remember and celebrate in honor of Yahweh. It is to be kept as a festival day for all generations forever."
,"15":"For seven days you are to eat unleavened bread. From the first day you are to remove all leaven from your houses, for if anyone eats leavened bread from the first to the seventh day he will no longer live in Israel."
,"16":"On the first day there will be a sacred reunion and another on the seventh. No work is to be done on these days except what is necessary in the preparation of food."
,"17":"Celebrate the feast of unleavened bread, because on that day I brought your armies out of Egypt. Celebrate it in future generations as an everlasting ordinance."
,"18":"In the first month, from the fourteenth day in the evening to the twenty-first, you are to eat unleavened bread."
,"19":"For seven days there will be no leaven in your houses. Anyone who eats what is leavened will be cut off from the community of Israel whether foreigner or native born."
,"20":"Nothing leavened is to be eaten; only unleavened bread is to be eaten.'"
,"21":"Moses called all the elders of Israel and said to them, 'Select and take one animal for each family and slaughter the Passover lamb."
,"22":"Take a twig of hyssop dipped in its blood and sprinkle the blood on the doorposts and the top of the doorframe: from then on no one will go out of the door of the house before morning."
,"23":"Because Yahweh will pass through to strike Egypt and when he sees the blood on the lintel and the doorposts, he will pass over the door and not allow the destroyer to enter your houses and kill."
,"24":"You and your descendants shall observe these instructions as an everlasting ordinance;"
,"25":"you will carry out this ceremony when you enter the land that Yahweh will give you, as he promised."
,"26":"And when your children ask you: 'What does this ceremony mean?'"
,"27":"you will tell them: It is the sacrifice of the Passover for Yahweh who passed over the houses of the Israelites when he struck Egypt and spared our houses.',When the people heard this they bowed down and worshiped. "
,"28":"Then they went away and did what Yahweh had ordered Moses and Aaron."
,"29":"It happened that in the middle of the night Yahweh struck down all the firstborn in Egypt, from the firstborn of Pharaoh, heir to the throne, to the firstborn of the prisoner in the dungeon and the firstborn of all the animals."
,"30":"Pharaoh, his officials and all the Egyptians got up in the night and there was loud wailing in Egypt for there was no house without a death."
,"31":"Pharaoh called Moses and Aaron in the night and said, 'Get up and go from among my people, you and the people of Israel. Go and worship Yahweh as you have said!"
,"32":"Take your sheep and your cattle, as you told me, and go! provided that the blessing be for me as well.'"
,"33":"The Egyptians, too, pressed the people to leave the country in all haste. For they said, 'If they don't go, we are all going to die.'"
,"34":"So the Israelites carried away on their shoulders the dough which had not yet risen, and their kneading bowls wrapped in their cloaks."
,"35":"They did as Moses had instructed them and borrowed from the Egyptians articles of gold and silver and clothes."
,"36":"Yahweh made the Egyptians agree to the requests of his people and give them what they asked for. In this way they plundered the Egyptians."
,"37":"The Israelites left Rameses for Succoth, about six hundred thousand of them on the march, counting the men only, and not the children."
,"38":"A great number of other people of all descriptions went with them, as well as sheep and cattle in droves."
,"39":"With the dough they had brought with them from Egypt, they made cakes of unleavened bread. It had not risen, for when they were driven from Egypt they could not delay and had not even provided themselves with food."
,"40":"The Israelites had been in Egypt for four hundred and thirty years."
,"41":"It was at the end of these four hundred and thirty years to the very day that the armies of Yahweh left Egypt."
,"42":"This is the watch for Yahweh who brought Israel out of Egypt. This night is for Yahweh, and the sons of Israel are also to keep vigil on this night, year after year, for all time."
,"43":"Yahweh said to Moses and Aaron, 'These are the precepts for the celebration of the Passover. No foreigner is to eat it,"
,"44":"except the slave who has been circumcised after having been bought."
,"45":"He may eat it. But not so the temporary resident or the hired worker."
,"46":"The lamb must be eaten inside the house and nothing of it shall be taken outside. Do not break any of its bones."
,"47":"All the community of Israel will observe this rite."
,"48":"If a guest is staying with you and wants to celebrate the Passover of Yahweh, he must have all the males in his household circumcised. Then he may take part like one born in the land, but no uncircumcised man may participate."
,"49":"The law is the same for the native and the stranger living with you.'"
,"50":"All the people of Israel did as Yahweh had commanded Moses and Aaron,"
,"51":"and that same day Yahweh brought out the sons of Israel and their armies from the land of Egypt."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Yahweh spoke to Moses saying,"
,"2":"'Consecrate to me every firstborn: the first to leave the womb among the sons of Israel, whether of man or beast, is mine.'"
,"3":"Moses said to the people, 'Remember the day you came out of Egypt from the house of slavery, for it was by his power that Yahweh brought you out; because of this you will not eat leavened bread."
,"4":"The day you left was in the month of Abib."
,"5":"When Yahweh brings you to the land of the Canaanites, the Hittites, the Amorites, the Hivites and the Jebusites - a land flowing with milk and honey which he swore to your fathers to give you - you will carry out this ceremony."
,"6":"For seven days you will eat unleavened bread and on the seventh day you will hold a feast in honor of Yahweh."
,"7":"You will eat unleavened bread for seven days and no leavened bread is to be seen among you or anywhere throughout all your territory."
,"8":"On that day you will tell your son: 'I do this because of what Yahweh did for me when I came out of Egypt.'"
,"9":"This ceremony will be for you as a sign on your hand and a reminder on your forehead, so that Yahweh's law may be ever on your lips, for it was with great power that Yahweh brought you out of Egypt."
,"10":"Because of this you will observe this ordinance at the appointed time from year to year."
,"11":"When Yahweh brings you to the land of the Canaanites and gives it to you, as he swore to you and your fathers,"
,"12":"you are to give over to Yahweh all that first opens the womb, and every firstborn of your cattle as well. These firstborn males are for Yahweh."
,"13":"Every firstborn donkey will be redeemed by a lamb, and if you do not redeem it, you are to break its neck. Every firstborn among your sons you are to redeem."
,"14":"When in the future your son questions you as to what it means you will say: 'Yahweh, by his power brought us out of Egypt from the house of slavery."
,"15":"As Pharaoh stubbornly refused to let us go, Yahweh slew every firstborn in Egypt, of man and beast. That is why I sacrifice to Yahweh all the males of my cattle that first open the womb, but the firstborn of my sons, I redeem.'"
,"16":"It will be as a sign on your hand and a charm between your eyes, reminding you that the power of Yahweh brought us out of Egypt.'"
,"17":"It happened that when Pharaoh sent the people away, God did not lead them through the land of the Philistines, although it was nearer, for God thought that the people might lose heart if they were faced with the prospect of a battle and would return to Egypt."
,"18":"God therefore led the people by the way of the wilderness towards the Red Sea. So the Israelites left Egypt in an orderly manner."
,"19":"Moses took with him the bones of Joseph for he had made the sons of Israel swear saying, 'God will surely remember you and then you will carry my bones with you away from here.'"
,"20":"They moved on from Succoth and encamped at Etham bordering the wilderness."
,"21":"By day Yahweh went before them in a pillar of cloud to guide them along the way, and by night in a pillar of fire to give them light, enabling them to travel day and night."
,"22":"Neither the cloud by day nor the fire by night, disappeared from the sight of the people."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Then Yahweh said to Moses,"
,"2":"'Tell the people of Israel to turn back and encamp in front of Pihahiroth, between Migdol and the sea, facing Baalzephon. You will encamp opposite this place and near the sea."
,"3":"So Pharaoh will think that the people of Israel have lost their way, and the wilderness has closed in on them."
,"4":"Then I will make Pharaoh's heart stubborn so that he will pursue you. And I will draw glory for myself at the cost of Pharaoh and his army, and the Egyptians shall know that I am Yahweh!',And the Israelites did as they had been instructed."
,"5":"The king of Egypt was told that the people had fled; then Pharaoh and his ministers changed their minds with regard to the people. 'What have we done,' they said, 'in allowing Israel to go and be free of our service?'"
,"6":"Pharaoh prepared his chariot and took his army with him."
,"7":"There were six hundred of his best chariots; indeed he took all the Egyptian chariots, each one with his warriors."
,"8":"Yahweh had hardened the mind of Pharaoh, king of Egypt, who set out in pursuit of the Israelites as they marched forth triumphantly."
,"9":"The Egyptians - all the chariots and horses of Pharaoh, his horsemen and his army - gave chase and caught up with them when they had encamped by the sea near Pihahiroth, facing Baalzephon."
,"10":"The Israelites saw the Egyptians marching after them: Pharaoh was drawing near. They were terrified and cried out to Yahweh."
,"11":"Then they said to Moses, 'Were there no tombs in Egypt? Why have you brought us to the desert to die?"
,"12":"What have you done by bringing us out of Egypt? Isn't this what we said when we were in Egypt: Let us work for the Egyptians. Far better serve Egypt than to die in the desert!'"
,"13":"Moses said to the people, 'Have no fear! Stay where you are and see the work Yahweh will do to save you today. The Egyptians whom you see today, you will never see again!"
,"14":"Yahweh will fight for you and all you have to do is to keep still.'"
,"15":"Yahweh said to Moses, 'Why do you cry to me? Tell the people of Israel to go forward."
,"16":"You will raise your staff and stretch your hand over the sea and divide it to let the Israelites go dryfoot through the sea."
,"17":"I will so harden the minds of the Egyptians that they will follow you."
,"18":"And I will have glory at the expense of Pharaoh, his army, his chariots and horsemen. The Egyptians will know that I am Yahweh when I gain glory for myself at the cost of Pharaoh and his army!'"
,"19":"The Angel of God who had gone ahead of the Israelites now placed himself behind them. The pillar of cloud changed its position"
,"20":"from the front to the rear, between the camps of the Israelites and the Egyptians. For one army the cloud provided light, for the other darkness so that throughout the night the armies drew no closer to each other."
,"21":"Moses stretched his hand over the sea and Yahweh made a strong east wind blow all night and dry up the sea. The waters divided"
,"22":"and the sons of Israel went on dry ground through the middle of the sea, with the waters forming a wall to their right and to their left."
,"23":"The Egyptians followed them and all Pharaoh's horses, his chariots and horsemen moved forward in the middle of the sea."
,"24":"It happened that in the morning watch, Yahweh in the pillar of cloud and fire, looked towards the Egyptian camp and threw it into confusion."
,"25":"He so clogged their chariot wheels that they could hardly move. Then the Egyptians said, 'Let us flee from the Israelites for Yahweh is fighting for them against Egypt.'"
,"26":"Then Yahweh said to Moses, 'Stretch your hand over the sea and let the waters come back over the Egyptians, over their chariots and horsemen.'"
,"27":"Moses stretched out his hand over the sea. At daybreak the sea returned to its place. As the Egyptians tried to flee, Yahweh swept them into the sea."
,"28":"The waters flowed back and engulfed the chariots and horsemen of the whole army of Pharaoh that had followed Israel into the sea. Not one of them escaped."
,"29":"As for the Israelites they went forward on dry ground in the middle of the sea, the waters forming a wall on their right and their left."
,"30":"On that day Yahweh delivered Israel from the power of the Egyptians and Israel saw the Egyptians lying dead on the seashore."
,"31":"They understood what wonders Yahweh had done for them against Egypt, and the people feared Yahweh. They believed in Yahweh and in Moses, his servant."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Then Moses and the people sang this song to Yahweh: I will sing to Yahweh, the glorious one, horse and rider he has thrown into the sea."
,"2":"Yahweh is my strength and my song, and he is my salvation. He is my God and I will praise him; the God of my father: I will extol him."
,"3":"Yahweh is a warrior; Yahweh is his name."
,"4":"The chariots of Pharaoh and his army,he has hurled into the sea; his chosen officers were drowned in the Red Sea."
,"5":"The deep covers them; they went down like a stone."
,"6":"Your hand, O Yahweh, glorious and powerful, your right hand, O Yahweh, shatters the enemy."
,"7":"In the splendor of your majesty you crush your foes; you send forth your fury, which devours them like stubble."
,"8":"At the blast of your nostrils the waters piled up, the surging waters stood firm in a heap; the deeps congealed in the heart of the sea."
,"9":"The enemy said, 'I will give chase and overtake, I will divide the spoil and make a feast of it. I shall draw my sword and my hand will destroy them.'"
,"10":"A breath of yours and the sea covered them; they sank like lead in the mighty waters."
,"11":"Who among the gods is like you, Yahweh?,Who is like you, majestic in holiness, awesome in power, doing wonders?"
,"12":"You stretched out your right hand; the earth swallowed them."
,"13":"In unfailing love you guided the people you redeemed, in strength you led them to your holy house."
,"14":"Hearing this, the nations tremble; anguish grips the people of Philistia."
,"15":"The chieftains of Edom are dismayed; the leaders of Moab are seized with trembling; the people of Canaan melt away."
,"16":"Terror and dread fall upon them, your powerful arm leaves them still as stone,until your people pass by, O Yahweh!,till the people you have purchased pass by."
,"17":"You will bring them in and plant them,on the mountain of your inheritance, the place you chose to dwell in, O Yahweh, the sanctuary prepared by your hands."
,"18":"Yahweh will reign forever!"
,"19":"When Pharaoh's chariots, horses and horsemen went into the sea, Yahweh brought back the waters over them, while the people of Israel walked on dry ground through the sea."
,"20":"Then Miriam, the prophetess, sister of Aaron, took a tambourine in her hand and all the women followed her dancing and playing tambourines."
,"21":"Miriam sang to them, 'Sing to Yahweh the glorious one; horse and rider he has thrown into the sea.'"
,"22":"Moses then led Israel from the Red Sea towards the wilderness of Shur. They walked in the desert for three days without finding water."
,"23":"They reached Marah but could not drink the water there as it was bitter. That is why the place is called Marah."
,"24":"The people grumbled against Moses and said, 'What shall we drink?'"
,"25":"oses then cried out to Yahweh who showed him a piece of wood, and when he threw it in the water, the water became sweet. There Yahweh gave the people statutes and laws. There he tested them"
,"26":"and said, 'If you listen carefully to the voice of Yahweh, your God, and if you do what is right in his eyes, if you obey his commands and statutes, I will not inflict on you any of the diseases I brought on the Egyptians, for I am Yahweh, the One who heals you.'"
,"27":"Then they came to Elim where there are twelve springs and seventy palm trees, and there they pitched their camp beside the water."
}`)
	CurrentBook.AddChapter(16, `{
"1":"The Israelites left Elim and the entire community reached the desert of Sin, between Elim and Sinai, on the fifteenth day of the second month after leaving Egypt."
,"2":"In the desert the whole community of Israel grumbled against Moses and Aaron"
,"3":"and said to them, 'If only we had died by the hand of Yahweh in Egypt when we sat down to caldrons of meat and ate all the bread we wanted, whereas you have brought us to this desert to let the whole assembly die of starvation!'"
,"4":"Yahweh then said to Moses, 'Now I am going to rain down bread from heaven for you. Each day the people are to gather what is needed for that day. In this way I will test them to see if they will follow my Teaching or not."
,"5":"On the sixth day when they prepare what they have brought in, they will find that there is twice as much as they gather each day.'"
,"6":"Then Moses and Aaron said to the people of Israel, 'In the evening you will know that it was Yahweh who brought you out of Egypt,"
,"7":"and in the morning you will see the Glory of Yahweh. For he has heard your grumbling against him, because: who are we that you should grumble against us?"
,"8":"In the evening Yahweh will give you meat to eat and in the morning bread to satisfy your hunger, because Yahweh heard your grumbling. You are not grumbling against us but against Yahweh, for who are we?'"
,"9":"Then Moses directed Aaron to say to the whole community of Israel, 'Draw near to Yahweh for he has heard your complaints.'"
,"10":"It happened that as Aaron was speaking to the full assembly of Israel, they turned towards the desert and saw the Glory of Yahweh in the midst of the cloud."
,"11":"Then Yahweh spoke to Moses,"
,"12":"'I have heard the complaints of Israel. Speak to them and say: Between the two evenings you will eat meat, and in the morning you will have bread to your heart's content; then you shall know that I am Yahweh, your God!'"
,"13":"In the evening quails came up and covered the camp. And in the morning, dew had fallen around the camp."
,"14":"When the dew lifted, there was on the surface of the desert a thin crust like hoarfrost."
,"15":"The people of Israel upon seeing it said to one another, 'What is it?' for they didn't know what it was. Moses told them, 'It is the bread that Yahweh has given you to eat.'"
,"16":"'This is what Yahweh commanded: Gather it according to the amount each one eats, about four liters a piece, and according to the number of persons each of you has in his tent.'"
,"17":"This is what the people of Israel did. They gathered it, some more, others less."
,"18":"But when they measured it with an omer, he that had gathered more didn't have too much while the man who had gathered less didn't have too little. Each one had as much as he needed."
,"19":"And Moses said to them, 'Let no one leave any of it till the morning.'"
,"20":"But they did not listen to Moses and some of them left it till morning. It bred worms and became foul, and Moses was angry with them."
,"21":"Every morning each one gathered as much as he could eat, and when the sun grew hot it melted."
,"22":"On the sixth day they gathered the double amount of bread, two omers each, and the leader of the people came to tell Moses."
,"23":"He said to them, 'This is what Yahweh commanded: Tomorrow you shall rest, for that day is a Rest - or sabbath - sacred to Yahweh."
,"24":"Bake today what you have to bake and boil what you have to boil, and you shall put aside what is left over to be kept till the next day.',So they put it aside until morning as Moses had ordered and its smell was not foul and it was free of maggots. "
,"25":"And Moses said, 'Eat it today, for this is a day of Rest - or sabbath - in honor of Yahweh. Today you will not find it in the fields."
,"26":"For six days you will gather it, but on the seventh day, the Sabbath, there will be none.'"
,"27":"Some of the people went out on the seventh day but found none."
,"28":"Then Yahweh said to Moses, 'How long will you refuse to obey my commands and my laws?"
,"29":"Yahweh has given you this Resting Day! That is why on the sixth day he gave you bread for two days. Let everyone stay where he is, and no one go out of his place on the seventh day.'"
,"30":"And so the people rested on the seventh day."
,"31":"The people of Israel called this food manna. It was white like coriander seed and it tasted like wafers made with honey."
,"32":"And Moses said, 'This is what Yahweh commanded: 'Take a measure of manna and keep it for future generations to let them see the bread I gave you to eat in the desert when I brought you out of Egypt.'"
,"33":"Then Moses said to Aaron, 'Take a jar and fill it with a measure of manna and place it before Yahweh for your descendants.'"
,"34":"Accordingly Aaron put a full measure of manna in the jar as Yahweh had commanded Moses and placed it before the slabs of divine statement to be kept there."
,"35":"The people of Israel ate the manna until they came to an inhabited land. They ate it for forty years"
,"36":"up to the time they reached the border of Canaan."
}`)
	CurrentBook.AddChapter(17, `{
"1":"The whole community of the people of Israel moved on from the desert of Sin going from place to place as Yahweh commanded, and encamped at Rephidim. But there was no water to drink."
,"2":"The people complained to Moses and said, 'Give us water to drink.' But Moses replied, 'Why do you find fault with me? Why do you put Yahweh to the test?'"
,"3":"But the people thirsted for water there and grumbled against Moses, 'Why did you make us leave Egypt to have us die of thirst with our children and our cattle?'"
,"4":"So Moses cried to Yahweh, 'What shall I do with the people? They are almost ready to stone me!'"
,"5":"Yahweh said to Moses, 'Go ahead of the people and take with you the elders of Israel. Take with you the staff with which you struck the Nile, and go."
,"6":"I will stand there before you on the rock at Horeb. You will strike the rock and water will flow from it and the people will drink.' Moses did this in the presence of the elders of Israel."
,"7":"The place was called Massah and Meribah because of the complaints of the Israelites, who tested Yahweh saying, 'Is Yahweh with us or not?'"
,"8":"When the Israelites were at Rephidim, the Amalekites came and attacked them."
,"9":"So Moses said to Joshua, 'Choose some of our men and go out to fight the Amalekites in the morning. As for me, I will stand with God's staff in my hand at the top of the hill.'"
,"10":"Joshua fought the Amalekites as Moses had directed, while Moses, Aaron and Hur went to the top of the hill."
,"11":"It happened that when Moses raised his hands, the Israelites would win but when he lowered them, the Amalekites would have the advantage."
,"12":"As Moses' arms grew weary they placed a stone for him to sit on while Aaron and Hur on either side held up his arms which remained steadily raised until sunset."
,"13":"For his part Joshua mowed down Amalek and his people with the sword."
,"14":"Yahweh then instructed Moses, 'Write this in a book as something to be remembered, and make it known in the hearing of Joshua that I will wipe out the remembrance of Amalek from under heaven.'"
,"15":"After that Moses built an altar and called it 'Yahweh is my banner,'"
,"16":"for he said, 'Raise up the standard of Yahweh; Yahweh is at war with the Amalekites from generation to generation.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Jethro, the priest of Midian, father-in-law of Moses, heard all that God had done for Moses and for Israel, his people, when Yahweh brought Israel out of Egypt."
,"2":"After Moses had sent away Zipporah, his wife, Jethro, his father-in-law, received her"
,"3":"and her two sons. The first, Moses had called Gershom, to remember that he had been a guest in a foreign land,"
,"4":"and the other Eliezer, for he said, 'The God of my father came to my help and delivered me from the sword of Pharaoh.'"
,"5":"So Jethro came with Moses' wife and sons to the desert where the people had encamped at the mountain of God."
,"6":"Moses was told, 'Your father-in-law Jethro is here. He has come with your wife and her two sons.'"
,"7":"So Moses went out to meet his father-in-law and bowing low before him, he kissed him, and when each had inquired about the other's health, they entered the tent."
,"8":"Moses then told his father-in-law all that Yahweh had done to Pharaoh and Egypt for the sake of Israel and all the difficulties they had met with on the way and how Yahweh had saved them."
,"9":"Jethro rejoiced at all Yahweh's goodness to Israel in freeing them from the power of Egypt and he said,"
,"10":"'Blessed be Yahweh who has delivered you from the power of Egypt and Pharaoh, and has rescued the people from the grip of Egypt."
,"11":"I know now that Yahweh is greater than all the gods, for he delivered his people when they were being oppressed.'"
,"12":"Then Jethro brought a burnt offering and other sacrifices to offer to God; and Aaron came with all the elders of Israel to share this meal with Moses' father-in-law in the presence of God."
,"13":"The next day Moses took his seat to administer justice for the people who stood around him from morning till night."
,"14":"His father-in-law, seeing all the work of Moses for the people, said to him, 'What is this you are doing for the people? Why do you alone sit and judge while all the people stand around you from morning till night?'"
,"15":"Moses answered, 'It is the people who come to me to know God's will."
,"16":"When there is a dispute they bring it to me to decide between the two parties, and I teach them God's decrees and laws.'"
,"17":"Jethro replied, 'What you are doing is not good."
,"18":"You and your people will wear yourselves out, for the work is too heavy and you cannot do it alone."
,"19":"Now listen to the advice I am going to give you and God be with you. You will be the people's representative before God and bring their cases to him."
,"20":"You will teach them the statutes and laws and the way they must live and what they must do."
,"21":"But choose among the people, capable, God-fearing men, men of truth who hate a bribe, and appoint them as leaders for groups of a thousand, a hundred, fifty and ten."
,"22":"They will administer justice at all times, bringing to your attention only those cases of major importance, while they deal with all those of lesser importance. That will ease your burden since they will be sharing it with you."
,"23":"If you do this, God will guide you and you will be able to cope with this duty; and all these people will reach their place in peace.'"
,"24":"Moses followed his father-in-law's advice and did as he said."
,"25":"He chose capable men from among the Israelites and placed them as leaders for groups of a thousand, a hundred, fifty and ten."
,"26":"They administered justice at all times, bringing difficult cases to Moses but judging all other cases themselves."
,"27":"Then Moses let his father-in-law return to his own country."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Exactly two months after the Israelites had left Egypt, they arrived at the wilderness of Sinai."
,"2":"They arrived there coming from Rephidim and camped in the wilderness of Sinai."
,"3":"The Israelites camped there in front of the mountain, but Moses went up to God and Yahweh called to him from the mountain, saying, 'This is what you are to say and to explain to the Israelites:"
,"4":"You have seen what I did to the Egyptians and how I carried you on eagle's wings and brought you to myself."
,"5":"Now if you listen to me and keep my covenant, you shall be my very own possession among all the nations. For all the earth is mine,"
,"6":"but you will be for me a kingdom of priests and a holy nation.',And he added, 'This is what you are to say to the people of Israel.'"
,"7":"So Moses went and summoned all the elders of the people and related to them all that Yahweh had commanded him to say."
,"8":"All the people responded with one voice, 'All that Yahweh has said, we will do.' Moses then brought back to Yahweh the people's response."
,"9":"Yahweh spoke to Moses, 'I am going to come to you in a dense cloud so that the people may hear me speaking with you and trust you always.' Then Moses related to Yahweh what the people had said."
,"10":"Again Yahweh spoke to Moses, 'Go to the people and have them sanctified today and tomorrow; let them wash their garments"
,"11":"and be ready for the third day. For on the third day Yahweh will come down on Mount Sinai in the sight of all the people."
,"12":"You will fix a limit for the people round about, saying: 'Take care not to go up to the mountain or touch its base. Whoever touches the mountain will die."
,"13":"No hand shall touch him but he will be stoned or shot down by arrows; be it man or beast he shall not live.' Only when the ram's horn sounds may some of them go up to the mountain.'"
,"14":"Moses came down from the mountain to the people and purified them, and they washed their garments."
,"15":"He then said to the people, 'Be ready in three days and abstain from sexual relations.'"
,"16":"On the morning of the third day there was thunder and lightning and a dense cloud over the mountain, and a very loud trumpet blast was heard. All the people in the camp trembled."
,"17":"Moses then made the people leave the camp to meet God and stand at the foot of the mountain."
,"18":"Mount Sinai was completely covered in smoke because Yahweh had come down in fire, and the smoke rose as from a furnace. The whole mountain shook violently,"
,"19":"while the blast of the trumpet became louder and louder. Moses spoke and God replied in thunder."
,"20":"When Yahweh had come down to the summit of Mount Sinai, God called Moses who went to the summit"
,"21":"where Yahweh said to him, 'Go down and give this warning to the people, lest they rush to see Yahweh and many of them perish."
,"22":"Even the priests who come near Yahweh must purify themselves lest Yahweh break out against them.'"
,"23":"Moses answered Yahweh, 'The people cannot ascend Mount Sinai because you yourself ordered us to put limits around the mountain, and set it apart as holy.'"
,"24":"Yahweh replied, 'Go down and bring up Aaron with you, but do not let the priests and the people break through to come up to Yahweh or he will break out against them.'"
,"25":"So Moses went down to the people and said to them..."
}`)
	CurrentBook.AddChapter(20, `{
"1":"God spoke all these words."
,"2":"He said, 'I am Yahweh your God who brought you out of the land of Egypt, out of the house of slavery."
,"3":"Do not have other gods before me."
,"4":"Do not make yourself a carved image or any likeness of anything in heaven, or on the earth beneath, or in the waters under the earth;"
,"5":"you shall not bow down to them or serve them. For I, Yahweh your God, am a jealous God; for the sin of the fathers, when they rebel against me, I punish the sons, the grandsons and the great-grandsons;"
,"6":"but I show steadfast love until the thousandth generation for those who love me and keep my commandments."
,"7":"Do not take the name of Yahweh your God in vain for Yahweh will not leave unpunished anyone who takes his name in vain."
,"8":"Remember the sabbath day and keep it holy."
,"9":"For six days you will labor and do all your work,"
,"10":"but the seventh day is a sabbath for Yahweh your God. Do not work that day, neither you, nor your son, nor your daughter nor your servants, men or women, nor your animals, nor the stranger who is staying with you."
,"11":"For in six days Yahweh made the heavens and the earth and the sea and all that is in them, but on the seventh day he rested; that is why Yahweh has blessed the sabbath day and made it holy."
,"12":"Honor your father and your mother that you may have a long life in the land that Yahweh has given you."
,"13":"Do not kill."
,"14":"Do not commit adultery."
,"15":"Do not steal."
,"16":"Do not give false witness against your neighbor."
,"17":"Do not covet your neighbor's house. Do not covet your neighbor's wife, or his servant, man or woman, or his ox, or his donkey, or anything that is his.'"
,"18":"In the meantime, all the people witnessed the thunder and lightning and heard the blast of the trumpet and saw the mountain smoking. They trembled with fear and kept at a distance."
,"19":"Then they said to Moses, 'You yourself speak to us and we shall listen. But do not have God speak to us, lest we die.'"
,"20":"Moses answered the people, 'Do not be afraid, for God has come to test you, so that the fear of God may be with you, and that you may not sin again.'"
,"21":"So the people kept at a distance while Moses went forward to the cloud where God was."
,"22":"Yahweh spoke to Moses, 'Say this to the people of Israel: You have seen for yourselves that I have spoken to you from the heavens."
,"23":"Do not make any gods of silver or gold to stand beside me."
,"24":"For me you are to make an altar of earth, and on it you will sacrifice burnt offerings and peace offerings, your sheep and your cattle. In every place where you come to remember my name, I will come to you and bless you."
,"25":"If you build an altar of stone, do not make it of cut stones, for you will defile it by using tools on it."
,"26":"And you will not ascend my altar on steps lest you expose your nakedness on it."
}`)
	CurrentBook.AddChapter(21, `{
"1":"These are the laws you are to set before them:"
,"2":"When you buy a Hebrew slave, he will serve you for six years and in the seventh year he shall go free, with nothing to pay."
,"3":"If he came alone, he will leave alone. If he was married, his wife will leave with him."
,"4":"If his master gives him a wife and she bears him sons or daughters, the wife and her children belong to his master; he will leave alone."
,"5":"But if the slave says: 'I love my wife, my master and my children, I will not go free,'"
,"6":"his master shall bring him to God; he will take him to the door or the doorpost, then his master will pierce his ear with an awl, and he shall serve him for life."
,"7":"When a man sells his daughter as a slave, she is not to go free as men slaves do."
,"8":"If she does not please the master who intended her for himself, he shall let another redeem her; he is not to sell her to foreigners because he has broken faith with her."
,"9":"If he intends her for his son, he will deal with her according to the rights of daughters."
,"10":"If he takes another for himself he will not diminish her food, her clothing or her marital rights."
,"11":"If he fails her in respect of these three rights she is to go free without any payment of money."
,"12":"The man who strikes another and so causes his death shall die."
,"13":"If he did not want to kill him, but as it were, let it happen, then I will give you a place where he may find refuge."
,"14":"Instead, if a man willfully attacks another to kill him treacherously, you will take him away even from my altar and put him to death."
,"15":"Whoever strikes his father or mother shall be put to death."
,"16":"Anyone who kidnaps another and either sells him or is found holding him captive, shall be put to death."
,"17":"He who curses his father or mother shall be put to death."
,"18":"When men quarrel and one strikes another with a stone or with his fist so that the man is confined to bed,"
,"19":"but after that he gets up and walks about with the help of a stick, the man who struck the blow will not be held as a criminal. He will, however, pay the injured man for loss of time and see that he is completely healed."
,"20":"When a man strikes his slave or his servant with a rod and the man dies at his hands, he shall be punished."
,"21":"But if the slave survives for a day or two, he will not be penalized since the slave is his property."
,"22":"If men are fighting and a pregnant woman is hit, so that the child is born prematurely but she is not injured, the one who hurt her will pay the fine demanded by her husband and allowed by the court."
,"23":"But if there is serious injury you are to take life for life,"
,"24":"eye for eye, tooth for tooth, foot for foot,"
,"25":"burn for burn, wound for wound, bruise for bruise."
,"26":"When a man strikes the eye of his slave, male or female, and the eye is lost, he will let the slave go free in compensation for the eye"
,"27":"or if he knocks out a tooth he will likewise give the slave his freedom."
,"28":"When an ox gores a man or woman to death, the ox will be stoned and its flesh will not be eaten, but the owner of the ox will not be punished."
,"29":"If the ox had gored someone in the past and its owner had been warned but had not kept it fenced in, and if later it kills a man or woman, the ox will be stoned and its owner put to death."
,"30":"If the owner, however, is allowed to pay a fine to save his life, he must pay all that is demanded."
,"31":"If the ox gores a boy or a girl the same law applies."
,"32":"If the ox gores a man or woman slave, the owner of the slave shall be paid thirty pieces of silver and the ox will be stoned."
,"33":"When a man leaves a pit uncovered or when he digs a pit and leaves it open and an ox or a donkey falls into it,"
,"34":"the owner of the pit will make compensation to the owner of the animal by paying him money, but he may keep the dead animal."
,"35":"When a man's ox injures the ox of his neighbor and it dies, they will sell the live ox and share both the money and the meat of the dead animal."
,"36":"Or if it is known that the ox has been in the habit of goring and its owner has not kept it in, he must make good the loss by giving his neighbor a live ox but the dead ox will be his."
,"37":"If a man steals an ox or a sheep and either slaughters or sells it, he must pay five oxen for the ox, four sheep for the sheep."
}`)
	CurrentBook.AddChapter(22, `{
"1":"If a thief is caught breaking into a house and receives a mortal blow, the man who struck him will not be guilty of his death,"
,"2":"but if it happened after dawn he will be guilty of murder. The thief must make full restitution. If he cannot do this he must be sold for what he has stolen."
,"3":"If what has been stolen is found alive in his possession, be it ox, donkey or sheep, he must pay double."
,"4":"If a man puts his animals to graze and lets them stray and feed in another man's field or vineyard, he must make good the loss with the best of his own crop and the best of his vineyard."
,"5":"When a fire breaks out and spreads through the thorn bushes and burns the grain that is either stacked or growing there, the one who started the fire must pay for the damage."
,"6":"If a man gives money or goods to another to keep for him, and they are stolen, the thief, if he is found, shall pay back double."
,"7":"Should the thief not be found, the man who owns the house must swear before the judges that he has not stolen the other man's property."
,"8":"Whenever there is a failure of trust whether it concerns an ox, donkey, sheep, clothing or any other lost object, the case shall come before the judges. The person the judges find guilty shall pay double to the other."
,"9":"If a man entrusts to his neighbor his donkey, cow, sheep or other animal, and the animal dies or is injured, or is carried off without being seen,"
,"10":"an oath before Yahweh shall prove that the man has not stolen the other's property. The owner of the animal shall accept the oath and the other shall not make restitution."
,"11":"But if the animal has been stolen from him, restitution shall be made."
,"12":"If the animal was killed by wild beasts, the man must bring the remains as evidence but shall not pay anything."
,"13":"When a man borrows an animal from his neighbor and the animal is injured or dies when the owner is not present, the man who borrowed must pay for it."
,"14":"But if the owner is present the borrower need not repay."
,"15":"If a man seduces a virgin who is not betrothed and lies with her, he shall pay the 'bride price' and marry her."
,"16":"If her father refuses to give her to him, he shall pay money equal to that for a virgin given in marriage."
,"17":"You shall not allow a sorceress to live."
,"18":"Whoever has sexual relations with a beast shall die."
,"19":"Whoever sacrifices to any god other than Yahweh shall die."
,"20":"You shall not wrong or oppress a stranger, for you were strangers in the land of Egypt."
,"21":"You shall not harm the widow or the orphan."
,"22":"If you do harm them and they cry out to me, I will hear them"
,"23":"and my anger will blaze and I will kill you with the sword, and your own wives will be widows and your own children orphans."
,"24":"If you lend money to any of my people who are poor, do not act like a moneylender and do not charge him interest."
,"25":"If ever you take a person's cloak as a pledge, you must give it back to him by sunset,"
,"26":"for it is all the covering he has for his body. In what else will he sleep? And when he cries to me I will hear him, for I am full of pity."
,"27":"Do not revile God or curse a ruler of your people."
,"28":"Do not delay in giving me my share of your wheat and your wine. You shall give to me the firstborn of your sons. "
,"29":"It shall be the same for your cattle and sheep. The firstborn shall stay with its mother for seven days; on the eighth day you shall give it to me."
,"30":"You are to be men consecrated to my service. Do not eat flesh that has been torn by wild animals; let it be given to the dogs."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Do not make false statements. And do not join hands with the wicked by being a malicious witness."
,"2":"Do not follow the majority when they do evil, or when they pervert justice in a lawsuit."
,"3":"Do not be partial, not even to the poor."
,"4":"If you see your enemy's ox or donkey going astray, take it back to him."
,"5":"When you see the donkey of a man who hates you falling under its load, do not pass by but help him."
,"6":"Do not deny justice to any of your poor in a lawsuit."
,"7":"Keep away from lies. Do not slay the innocent or the just, for I will not forgive the wicked."
,"8":"And do not take a bribe, for a bribe blinds the eyes of the clear-sighted and perverts the sentence of the just."
,"9":"Do not oppress a stranger; you know what it is to be a stranger, for that is what you were in the land of Egypt."
,"10":"For six years you will sow your fields and reap their produce,"
,"11":"but in the seventh you will let the land rest and lie fallow. The poor may eat what it produces and what they leave the wild animals will eat. It will be the same for your vineyard and your olive grove."
,"12":"For six days you shall work but on the seventh you shall rest, so that your ox and your donkey may also rest and the son of your slave girl and the stranger as well may have a breathing space."
,"13":"Pay attention to all that I tell you and do not call upon other gods; don't let their names be heard on your lips."
,"14":"Three times each year you shall celebrate a feast in my honor."
,"15":"You shall keep the feast of Unleavened Bread, as I commanded you, and eat unleavened bread for seven days at the appointed time in the month of Abib, for it was then that you left Egypt. And do not come to me empty-handed."
,"16":"You shall keep the feast of the Harvest with the feast of the first harvest of what you sowed in your fields. Then the feast of Ingathering at the end of the year when you gather in the fruit of your labor in the fields."
,"17":"Three times during the year all your men shall present themselves before Yahweh."
,"18":"Do not offer the blood of my sacrifice with leavened bread or let the fat of my feast remain until morning."
,"19":"The first of the first fruits of your soil you will bring to the house of Yahweh, your God. Do not boil a kid in its mother's milk."
,"20":"See, I am sending an Angel before you to keep you safe on the way and bring you to the place I have made ready."
,"21":"Be on your guard in his presence and listen to him; do not resist him for he will not pardon your wrong-doing, for my name is in him."
,"22":"If you listen to him and do what I say, I will be enemy to your enemies and the opponent of your opponents."
,"23":"My Angel will go before you and bring you to the land of the Amorites, the Hittites, the Perizzites, the Canaanites, the Hivites and the Jebusites; all these I will destroy."
,"24":"You shall not bow down before their gods or serve them, or act according to their ways; rather you will destroy them utterly and smash their sacred stones."
,"25":"If you serve Yahweh, your God, he will bless your bread and your water - and I will keep sickness away from you."
,"26":"No woman among you will miscarry or be barren. I will fulfill the number of your days."
,"27":"Now I will send my terror ahead of you and throw into confusion all the people you encounter; I will make all your enemies turn and flee before you."
,"28":"I will send hornets ahead of you to drive out the Hivites, the Canaanites and the Hittites."
,"29":"I will not drive them out in a single year lest the land become a desert and the wild beasts increase and molest you."
,"30":"I will drive them out before you little by little until your number increase and you are able to take possession of the land."
,"31":"I will fix your boundaries from the Red Sea to the sea of the Philistines and from the Wilderness to the Euphrates; for I will deliver into your power the inhabitants of the land and I will drive them out before you."
,"32":"You shall make no treaty with them or with their gods."
,"33":"They shall not live in your country lest they lead you to sin against me and to serve their gods. That would surely be a snare for you.'"
}`)
	CurrentBook.AddChapter(24, `{
"1":"Then he said to Moses, 'Go up to Yahweh, you, Aaron, Nadab and Abihu with seventy of the elders of Israel, and let them worship from a distance."
,"2":"Moses alone shall go forward to Yahweh but not the others, nor shall the people go up with him.'"
,"3":"Moses came and told the people all the words of Yahweh and all his laws. The people replied with one voice: 'Everything that Yahweh has said, we shall do.'"
,"4":"Moses wrote down all the words of Yahweh, then rose early in the morning and built an altar at the foot of the mountain with twelve raised stones for the twelve tribes of Israel."
,"5":"He then sent young men from among the sons of Israel to offer burnt offerings and sacrifice bullocks as peace offerings to Yahweh."
,"6":"And Moses took half the blood and put it in basins; and with the other half of the blood he sprinkled the altar."
,"7":"He then took the Book of the Covenant and read it in the hearing of the people. They said, 'All that Yahweh said we shall do and obey.'"
,"8":"Moses then took the blood and sprinkled it on the people saying, 'Here is the blood of the covenant that Yahweh has made with you in accordance with all these words.'"
,"9":"Then Moses went up with Aaron, Nadab, Abihu and the seventy elders of Israel."
,"10":"They saw the God of Israel. Under his feet there was what seemed like a pavement of sapphire, clear as the sky itself."
,"11":"And he did not let his hand overpower these chosen men from among the sons of Israel; they looked on God and ate and drank."
,"12":"Yahweh said to Moses, 'Come up to me on the mountain and stay there. I will give you the slabs of stone, the Teaching and commandment which I have written for their instruction.'"
,"13":"So Moses arose with his servant, Joshua, and before going up the mountain of God,"
,"14":"Moses said to the elders, 'Remain here until we come back to you. Aaron and Hur are with you; let whoever has a dispute to settle, go to them.'"
,"15":"When Moses went up the mountain a cloud covered it."
,"16":"The Glory of Yahweh rested on Mount Sinai and the cloud covered it for six days. On the seventh day He called to Moses from within the cloud."
,"17":"The Glory of Yahweh appeared like a consuming fire on the top of the mountain: so it was as it appeared to the Israelites."
,"18":"And Moses entered the cloud and went up the mountain. Moses stayed on the mountain forty days and forty nights."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Yahweh spoke to Moses and said,"
,"2":"'Tell the sons of Israel to set aside a contribution for me; you shall accept this contribution from every man who gives from the heart."
,"3":"The things you shall accept from them are these: gold, silver, and bronze,"
,"4":"purple cloth of violet shade and red, crimson cloth, fine linen, goats' hair;"
,"5":"rams' skins dyed red, fine leather, acacia wood;"
,"6":"oil for the lamps, spices for the chrism and for the fragrant incense; precious stones and gems to be set in priestly vestments."
,"8":"For they must build me a sanctuary so that I may dwell among them,"
,"9":"and you shall make the tabernacle and its furnishings following exactly the pattern I shall show you."
,"10":"You are to make me an ark of acacia wood, two and a half cubits long, one and a half cubits wide, one and a half cubits high."
,"11":"You are to cover it with pure gold inside and out, and decorate it all around with a gold molding."
,"12":"You will cast four gold rings for the ark and fix them to its four supports: two rings on one side and two rings on the other."
,"13":"You will also make poles of acacia wood covered with gold"
,"14":"and pass the poles through the rings on the sides of the ark, to carry the ark by these."
,"15":"The poles must remain in the rings of the ark and not be withdrawn."
,"16":"Inside the ark you will place the Statement that I shall give you."
,"17":"Further, you are to make the mercy Seat of pure gold, two and a half cubits long, and one and a half cubits wide."
,"18":"For the two ends of the mercy Seat you are to make two golden cherubim of hammered gold."
,"19":"Make the first cherub for one end and the second for the other, and fasten them to the two ends of the cover so that they may make one piece with it."
,"20":"The cherubim are to have their wings spread upward so that they overshadow the mercy Seat. They must face one another, their faces towards the mercy Seat."
,"21":"You must place the mercy Seat on the top of the ark. Inside the ark you must place the stone tablets that I shall give you."
,"22":"There I shall come to meet you; there, from above the mercy Seat from between the two cherubim on it, I shall give you all my commands for the people of Israel."
,"23":"You are to make a table of acacia wood, two cubits long, one cubit wide, and one and a half cubits high."
,"24":"You are to cover it with pure gold and decorate it all around with a gold edge."
,"25":"You are to surround it with a frame three inches wide, and decorate these with a golden edge."
,"26":"You are to make for it four gold rings and fix these at the four corners where the four legs are."
,"27":"The rings must be close to the frame to hold the poles for carrying the table."
,"28":"You are to make the poles of acacia wood and cover them with gold. The table is to be carried by these."
,"29":"You are to make dishes, cups, jars and bowls to be used for the wine offerings; you are to make these of pure gold."
,"30":"On the table, before me, you must place the bread of continual offering."
,"31":"You are to make a lampstand of pure gold; the lampstand must be of hammered gold, both its base and stem. Its decorative flowers, including buds and petals, must be of one piece with it."
,"32":"Six branches must extend from its sides, three from one side, three from the other."
,"33":"Each of the six branches of the lampstand is to have three decorative flowers shaped like almond blossoms, each with its bud and petals."
,"34":"The lampstand itself is to have four decorative flowers shaped like almond blossoms, each with its bud and petals, thus:"
,"35":"one bud under the first two branches extending from the lampstand, one under the next pair, one under the last pair: corresponding to the six branches extending from the lampstand."
,"36":"The buds and the branches must be of one piece with the lampstand, and the whole made from a single piece of pure hammered gold."
,"37":"Then you are to make lamps for it, seven of them, and set them so that they throw their light toward the front of it."
,"38":"Tongs for extinguishing the burning lamps and trays must be of pure gold."
,"39":"You are to use seventy-five pounds of pure gold for making the lampstand and all its accessories."
,"40":"See that you make them according to the pattern shown you on the mountain."
}`)
	CurrentBook.AddChapter(26, `{
"1":"The Holy Tent itself you are to make with ten sheets of fine twined linen, of purple wool, violet shade and red, and of crimson wool; you are to have these sheets finely embroidered with angels."
,"2":"The length of a single sheet is to be twenty-eight cubits, its width four cubits, all the sheets to be of the same size."
,"3":"Five of the sheets must be sewed together, and the other five, also."
,"4":"You must attach loops of violet wool to the border of the last sheet in one set, and do the same for the border of the last sheet in the other set."
,"5":"You are to put fifty loops on the first sheet and, matching them one by one, fifty loops on the border of the last sheet in the second set."
,"6":"And you are to make fifty gold clasps to draw the sheets together. In this way the Holy Tent will be a unified whole."
,"7":"You are to make sheets of goats' hair to form a cover over the Holy Tent. There will be eleven sheets."
,"8":"The length of a single sheet is to be thirty cubits, its width four cubits, the eleven sheets to be all of the same size."
,"9":"You must sew five of these sheets together into one sheet, the remaining six into another; the sixth you will fold double over the front of the cover."
,"10":"You must attach fifty loops to the border of the last sheet in one set, and do the same for the border of the last sheet in the second set."
,"11":"You must make fifty bronze clasps and put them into one of the loops, so as to draw the two sets together to form one tent over the Holy Tent."
,"12":"One sheet will be left over, half of which is to hang over the back of the Holy Tent."
,"13":"This extra cubit is to hang over the sides of the Holy Tent as a covering for it."
,"14":"For the Holy Tent you will make further coverings, one of rams' skins dyed red, and to spread over this, another covering of fine leather."
,"15":"You are to make frames of acacia wood for the Holy Tent which will stand upright."
,"16":"Each board is to be ten cubits long and one and a half cubits wide."
,"17":"Each board shall have two arms that shall serve to fasten the boards in line; for all the frames of the Holy Tent you must do this."
,"18":"There will be twenty boards for the southern side of the Holy Tent."
,"19":"You are to make forty silver bases for putting under the twenty boards thus: two bases under the first board to receive its two matching arms, and so on for the other boards."
,"20":"The other side of the tabernacle, on the north, is to have also twenty boards"
,"21":"supported by forty silver bases, two bases under each board."
,"22":"For the back of the Holy Tent on the west, you must make six boards,"
,"23":"and also two boards for the corners at the back of the Holy Tent."
,"24":"These boards must be joined at the bottom and also at the top, up to the level of the first ring; and the same for the two boards that are to form the two corners."
,"25":"So there will be eight boards with their sixteen silver bases: two bases under the first board and so on."
,"26":"You are to make five crossbars of acacia wood to hold together the boards for one side of the tabernacle,"
,"27":"and five to hold the boards that form the other side of the Holy Tent."
,"28":"They will run halfway up the boards, from one end to the other."
,"29":"The boards are to be covered with gold, and with gold rings on them to take the crossbars which you are to cover with gold."
,"30":"This is how you are to set up the Holy Tent according to the model shown to you on the mountain."
,"31":"You are to make a veil of purple wool, violet shade and red, of crimson wool, and of fine twined linen; you are to have it finely embroidered with Cherubim."
,"32":"You are to hang it on four posts of acacia wood covered with gold and furnished with gold hooks and set in four silver bases."
,"33":"You must hang the veil from the clasps and there behind the veil you must place the ark of the Statement and the veil will serve to separate the Holy Place from the Holy of Holies."
,"34":"The mercy Seat you must place on top of the ark inside the Holy of Holies."
,"35":"Outside the veil, you shall set the table and the lampstand on the south side of the Holy Tent, opposite the table, for the table will be on the north side."
,"36":"Finally, for the entrance to the Tent you are to make a curtain of purple wool, violet shade and red, and of crimson stuffs and fine twined linen, the work of a skilled embroiderer."
,"37":"And you shall have for this curtain five posts of acacia wood covered with gold, with gold hooks; for these you are to cast five bronze bases."
}`)
	CurrentBook.AddChapter(27, `{
"1":"You are to make an altar out of acacia wood, a square five cubits long and five cubits wide, its height to be three cubits."
,"2":"At its four corners you are to put horns, the horns to be of one piece with it, covering it with bronze."
,"3":"For the service of the altar you are to make pans for the ashes for burning the fat, as well as shovels, sprinkling basins, fire pans; you must make all the vessels for the altar out of bronze."
,"4":"You are also to make a grating for it of bronze network, and on the four corners of this put four bronze rings."
,"5":"You shall set it under the altar's ledge, below, so that it reaches halfway up the altar."
,"6":"And for the carrying of the altar you are to make poles of acacia wood and cover them with bronze."
,"7":"These are to be passed through the rings, so that they are on either side of the altar when it is carried."
,"8":"You are to make the altar of hollowed-out boards; in the same way that was shown to you on the mountain."
,"9":"You are to make also the court of the Holy Tent. The hangings of the court on the side facing south are to be of fine twined linen, one hundred cubits long for one side."
,"10":"Their twenty bronze posts are to be set in the twenty bronze bases and to have hooks and rods of silver."
,"11":"So too for the northern side there are to be hangings one hundred cubits long, and twenty posts set in twenty bases, with their hooks and rods of silver."
,"12":"Across the width of the court, on the western side, there are to be fifty cubits of hangings, carried on ten posts set in ten bases."
,"13":"The width of the court on the eastern side facing the sunrise is to be fifty cubits."
,"14":"On one side of the gateway there are to be fifteen cubits of hangings, carried on three posts set in three bases."
,"15":"On the other side of the gateway there are also to be fifteen cubits of hangings, carried on three posts set in three bases."
,"16":"The gateway to the court is to consist of a curtain twenty cubits wide made of purple wool, violet shade and red, of crimson wool and fine twined linen, the work of a skilled embroiderer, carried on four posts set in their four bases."
,"17":"All the posts enclosing the court are to be connected by silver rods; their hooks are to be of silver, their bases of bronze."
,"18":"The length of the court is to be one hundred cubits, its width fifty cubits, its height five cubits. All the hangings are to be made of fine twined linen, and their bases of bronze."
,"19":"All the furnishings for whatever use in the tabernacle, all the pegs of it and of the court, must be of bronze."
,"20":"You are to command the people of Israel to bring you pure olive oil for the light, and to keep a flame burning there perpetually."
,"21":"Aaron and his sons are to set this flame in the Tent of Meeting, outside the veil that is before the Statement. It must burn there before Yahweh from evening to morning perpetually. This command is to be kept forever by the people of Israel."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Set apart of the sons of Israel your brother Aaron and his sons, and summon them to be priests in my service: Aaron, Nadab and Abihu, Eleazar and Ithamar."
,"2":"For Aaron, your brother, you are to make sacred vestments to give him dignity and magnificence."
,"3":"You are to instruct all the ablest craftsmen (I myself filled them with wisdom), to make Aaron's vestments for his consecration to my priesthood."
,"4":"These are the vestments they must make: Breastpiece, Ephod, robe, embroidered tunic, turban and belt. Your brother, Aaron, and his sons will serve me with these sacred vestments."
,"5":"For them you shall use gold, purple wool, violet shade and red, crimson wool, and fine twined linen."
,"6":"They are to make the Ephod of gold, purple wool, violet shade and red, crimson wool and fine twined linen, the work of a skilled embroiderer."
,"7":"It must have two shoulder straps fitted to it to join its two ends together."
,"8":"The woven band on it to hold it on is to be of similar workmanship and to form one piece with it: this must be of gold thread, purple wool, violet shade and red, crimson wool, and fine twined linen."
,"9":"You will then take two precious stones and engrave them with the names of the sons of Israel,"
,"10":"six of their names on one stone, the remaining six on the other, in the order of their birth."
,"11":"With the art of a jeweler, of an engraver of seals, you are to engrave the two stones with the names of the sons of Israel, and mount them in settings of gold mesh."
,"12":"You are to fasten the two stones commemorating the sons of Israel to the shoulder straps of the Ephod. In this way Aaron will bear their names on his shoulders in the presence of Yahweh, that he may remember them."
,"13":"You must also make golden rosettes,"
,"14":"and two chains of pure gold twisted like cord; you are to attach these cordlike chains to the rosettes."
,"15":"You are to make the Breastpiece of judgment, finely embroidered, of the same workmanship as the apron. You are to make it of gold, purple wool, violet shade and red, crimson wool, and fine twined linen."
,"16":"It is to be square and doubled over nine inches wide."
,"17":"In this you are to set four rows of stones: sard, topaz, carbuncle, for the first row;"
,"18":"emerald, sapphire, diamond for the second row;"
,"19":"for the third row, hyacinth, ruby, amethyst;"
,"20":"and for the fourth row, beryl, onyx, jasper. These are to be mounted in gold settings."
,"21":"There are to be twelve according to the number of the sons of Israel whose names are engraved on them. They are to be engraved like seals, each with the name of one of the twelve tribes."
,"22":"For the Breastpiece you will make chains of pure gold twisted like cords,"
,"23":"and also two gold rings and fix them to its two upper corners."
,"24":"You must fasten the two gold cords to the two rings fixed on the corners of the Breastpiece."
,"25":"The other two ends of the cords you must fasten to the two rosettes, so that they will be attached to the shoulder straps of the Ephod, on the front."
,"26":"You are to make two gold rings and fix them to the two lower corners of the Breastpiece, on the inner hem, next to the Ephod, on the front."
,"27":"You are to make two more gold rings and fix them low down on the front of the two shoulder pieces of the Ephod, close to the seam, above the woven band of the Ephod."
,"28":"You must secure the Breastpiece by passing a ribbon of violet-purple through its rings and those of the Ephod, so that the Breastpiece will sit above the woven band and not come apart from the Ephod."
,"29":"So when Aaron enters the sanctuary wearing the Breastpiece of judgment, he will bear the names of the sons of Israel on his breast to call them to mind continually in the presence of Yahweh."
,"30":"In the Breastpiece of judgment you will put the Urim and the Thummim by means of which he takes the decisions for the Israelites. Aaron shall have them on his breast when he goes into Yahweh's presence."
,"31":"You are to make the robe of the Ephod entirely of violet-purple."
,"32":"In the center it must have an opening for the head, with a border woven around the neck to keep the robe from being torn."
,"33":"You shall decorate the lower hem with pomegranates of purple wool, violet shade and red, crimson wool, and fine twined linen,"
,"34":"and you shall fit gold bells between: gold bells and pomegranates will be alternately all around the lower hem of the robe."
,"35":"Aaron is to wear this robe when he serves before God, so that the tinkling of the bells will be heard whenever he enters the sanctuary and goes into Yahweh's presence, or leaves it; if he does not, he will die."
,"36":"You are to make a plate of pure gold and engrave on it 'Consecrated to the Lord.'"
,"37":"You will tie this to the front of the headpiece with a ribbon of violet-purple."
,"38":"Aaron is to wear it on his forehead, and so take on himself any sins which the sons of Israel may have committed in any of their sacred offerings. Aaron must always wear this plate on his forehead, to draw down on the Israelites the goodwill of Yahweh."
,"39":"You shall also weave the shirt of fine linen, and make a headpiece of fine linen, and a belt, the work of a skilled embroiderer."
,"40":"You are to make shirt and belt and headdress for the sons of Aaron to make them dignified and beautiful."
,"41":"You will put all these ornaments on your brother Aaron and his sons. You will then anoint and invest and consecrate them to serve me in the priesthood."
,"42":"You are to make them linen shorts to cover their nakedness from waist to thigh."
,"43":"Aaron and his sons must wear these when they go into the Tent of Meeting and when they approach the altar to serve the sanctuary. If they do not, they will be guilty and die. This is a permanent rule for Aaron and for his descendants after him."
}`)
	CurrentBook.AddChapter(29, `{
"1":"This is the ceremony you must use when you consecrate them to serve me in the priesthood. Take one young bull and two rams without any defects,"
,"2":"unleavened cakes mixed with oil, and unleavened wafers spread with oil, made from fine wheat flour."
,"3":"You must put these things into a basket and present them in the basket, at the same time as the young bull and the two rams."
,"4":"Then you shall bring Aaron and his sons to the entrance of the Tent of Meeting after they have been bathed."
,"5":"Take the vestments and dress Aaron in the shirt, the robe over the Ephod, the Ephod and the Breastpiece, and embroidered belt."
,"6":"Put the headdress on his head and tie on it the sacred plate."
,"7":"Then take the chrism oil and pour it on his head, and so anoint him."
,"8":"Next, bring his sons and clothe them with shirts,"
,"9":"pass the belts around their waists and put the headdresses on their heads. With this the priesthood will be theirs forever. This is how you are to ordain Aaron and his sons. "
,"10":"You are to bring the bull in front of the Tent of Meeting. Aaron and his sons are to lay their hands on its head."
,"11":"Kill the bull there before Yahweh at the entrance to the Tent of Meeting."
,"12":"Then take some of its blood and with your finger put it on the horns of the altar. Next, pour out the rest of the blood at the foot of the altar."
,"13":"And then take all the fat that covers the inner organs, the fatty mass which is over the liver, the two kidneys with their covering fat, and burn them on the altar."
,"14":"As for the bull's flesh, its skin and its intestines, you must burn them outside the camp, for it is an offering to take away the sins of the priests."
,"15":"Next you are to take one of the rams. Aaron and his sons are to lay their hands on its head."
,"16":"You are to kill the ram, take up its blood and pour it out on the sides of the altar."
,"17":"Next, divide the ram in pieces and wash the inner organs and legs and put them on top of the head and the other pieces."
,"18":"Then burn the whole ram on the altar. This is a fire offering to Yahweh, a fragrant offering by fire."
,"19":"Next you are to take the other ram. Aaron and his sons are to lay their hands on its head."
,"20":"You are to kill the ram, take some of its blood and put it on the lobe of Aaron's right ear, on the lobes of his sons' right ears, the thumbs of their right hands, and the big toes of their right feet, and pour out the rest of the blood on the sides of the altar."
,"21":"Then take some of the blood that remains on the altar, together with the chrism oil, and sprinkle it on Aaron and his vestments and on his sons and their vestments so that he and his vestments will be consecrated and his sons, too, and their vestments."
,"22":"You are to take the fatty parts of the ram: the tail, the fat that covers the inner organs, the fatty mass which is over the liver, the two kidneys with their covering fat and also the right thigh, for this is a ram for the clothing ceremony."
,"23":"You are to take a loaf of bread, a cake of bread made with oil, and a wafer, from the basket of unleavened bread placed before Yahweh,"
,"24":"and put it all into Aaron's hands and those of his sons and make the gesture of offering before Yahweh."
,"25":"Then you are to take them back and burn them on the altar, on top of the burnt offering, as a sweet-smelling offering which pleases Yahweh."
,"26":"You are to take the breast of the ram and make the gesture of offering before Yahweh; this is to be your own portion."
,"27":"You are to consecrate the breast that has been thus offered, as also the thigh that is set aside - the breast, that is, which has been offered and the thigh that has been set aside from the ram."
,"28":"This, by perpetual law, will be the portion that Aaron and his sons are to receive from the sons of Israel; this is the portion set aside, a portion the sons of Israel are to set aside from their communion sacrifices, the portion they owe to Yahweh."
,"29":"Aaron's sacred vestments are to pass to his sons after him, and they will wear them for their anointing and consecration."
,"30":"The son of Aaron who comes after him in the priesthood and enters the Tent of Meeting to serve in the sanctuary must wear them for seven days."
,"31":"You are to take the ram used for the ordination and cook its meat in a holy place."
,"32":"Aaron and his sons will eat the meat of the ram, and also the bread that is in the basket, at the entrance to the Tent of Meeting."
,"33":"They are to eat what was used in the ceremony of forgiveness during their ordination. No layman may eat these; they are holy things."
,"34":"If any of the meat from the ordination sacrifice, or the bread, should be left till morning, you must put what is left in the fire. It is not to be eaten; it is a holy thing."
,"35":"For Aaron and his sons, you are to do exactly as I have commanded you: you are to spend seven days in ordaining them."
,"36":"On each day of this week you are also to offer a bull as a sacrifice for sin, in atonement; by offering an atonement sacrifice for sin, you will take away sin from the altar; then you must anoint it, and so consecrate it."
,"37":"For seven days you are to repeat the atonement sacrifice for the altar and consecrate it. So it will be extremely holy, and whatever touches it will become holy."
,"38":"This is what you are to offer on the altar: two yearling lambs day by day continually."
,"39":"The first lamb you must offer in the morning, the second in the evening twilight."
,"40":"With the first lamb you must offer two pounds of fine flour mixed with one quart of purest oil, and pour out one quart of wine as an offering."
,"41":"The second lamb you must offer in the evening twilight; do this with the same amounts of flour, olive oil and wine as in the morning. This is a sweet-smelling offering which pleases Yahweh."
,"42":"This is the perpetual offering which is to be offered from generation to generation, at the entrance to the Tent of Meeting in the presence of Yahweh. That is where I shall meet you and speak to you. "
,"43":"There I will teach the people of Israel, and this place will be consecrated by the presence of my glory."
,"44":"In this way I will consecrate the Tent of Meeting and the altar, and Aaron too, and his sons, to be priests in my service."
,"45":"For I will remain with the people of Israel, and I will be their God."
,"46":"And so they will know that it is I, their God, who brought them out of the land of Egypt to live among them: I, their God."
}`)
	CurrentBook.AddChapter(30, `{
"1":"You must make an altar on which to burn incense; you are to make it out of acacia wood."
,"2":"It is to be one cubit long, and one cubit wide - that is to say, square - and to stand two cubits high; its horns are to be one piece with it."
,"3":"The top of the altar, its surrounding sides, and its horns, are to be covered with pure gold, and decorated with a gold edge all around."
,"4":"You are to put two gold rings on it below the edge on its two opposite sides: these are to hold the poles used for carrying it."
,"5":"These poles you must make of acacia wood and cover with gold."
,"6":"You are to set up the altar before the veil that protects the ark of the Statement opposite the ark and the mercy Seat from where I speak to you."
,"7":"On this altar Aaron must burn fragrant incense each morning when he prepares the lamps,"
,"8":"and in the evening twilight when Aaron puts the lamps back, he must burn it again. You must make these offerings of incense before Yahweh unfailingly from generation to generation."
,"9":"You must not offer unholy incense on this altar or animal or grain offering, or pour out any wine offering on it."
,"10":"Once a year Aaron is to perform the atonement on the horns of this altar; he shall do this atonement with the blood of the victim to take away sins. And you shall do the same once a year in the generations to come. This ceremony will be extremely holy in the eyes of Yahweh.'"
,"11":"Yahweh spoke to Moses and said,"
,"12":"'When you take a census and make a register of the people of Israel, each is to pay Yahweh a ransom for his life, so that no disaster comes on them when the census is being made."
,"13":"Everyone subject to the census must pay the required amount of money, weighed according to the official standard, and this shall be set aside for Yahweh."
,"14":"Everyone subject to the census, that is to say of twenty years and over, must pay the sum set aside for Yahweh."
,"15":"The rich man is not to give more, nor the poor man less, when they pay this amount for their lives."
,"16":"You will use this ransom money given to you by the people of Israel for the upkeep of the Tent of Meeting. It will remind Yahweh of the people of Israel and will be the ransom for your lives.'"
,"17":"Yahweh spoke to Moses and said,"
,"18":"'You must also make a bronze basin on a stand, for washing. You must place it between the Tent of Meeting and the altar and put water in it."
,"19":"In this, Aaron and his sons must wash their hands and feet."
,"20":"When they are about to enter the Tent of Meeting they must wash in water lest they die, and when they have to approach the altar for their service, to burn the offering burned in honor of Yahweh,"
,"21":"they must wash their hands and feet lest they die. This is a lasting rule for them, for Aaron and for his descendants from generation to generation.'"
,"22":"Yahweh spoke to Moses and said,"
,"23":"'Take the choicest spices: twelve pounds of liquid myrrh, six pounds of sweet-smelling cinnamon, six pounds of scented cane and twelve pounds"
,"24":"of cassia (all weighed according to the official standard) and one gallon of olive oil."
,"25":"These you are to make into a holy oil for anointing, such a blend as the perfumer might make."
,"26":"With it you are to anoint the Tent of Meeting and the ark of the Statement,"
,"27":"the table and all its furnishings, the lampstand and all its accessories,"
,"28":"the altar of incense, the altar of burnt offering with all its furnishings, and the basin with its stand."
,"29":"In this way you shall consecrate"
,"30":"them and they will remain extremely holy; and whatever touches them will become holy. You must anoint Aaron and his sons and consecrate them, so that they may be priests in my service."
,"31":"Then you are to say to the people of Israel: 'Such will be the oil of holy anointing from generation to generation."
,"32":"It is not to be poured on the bodies of common men, nor are you to make any other oil of the same mixture. It is a holy thing and you must consider it holy."
,"33":"Whoever makes any like it or uses it on a layman shall be outlawed from his people.'"
,"34":"Yahweh said to Moses, 'Take sweet spices: storax, onycha, galbanum, sweet spices and pure frankincense in equal parts,"
,"35":"and make an incense, such as the perfumer might make, salted, pure, and holy."
,"36":"Crush a part of it into a fine powder, and put some of this in front of the ark of the Statement in the Tent of Meeting, the place appointed for my meetings with you. You must regard it as most holy."
,"37":"You are not to make any incense like it for your own use. You must hold it to be a holy thing, reserved for Yahweh."
,"38":"Whoever copies it for use as perfume shall be outlawed from his people.'"
}`)
	CurrentBook.AddChapter(31, `{
"1":"Yahweh spoke to Moses and said,"
,"2":"'See, I have chosen Bezalel son of Uri, son of Hur, of the tribe of Judah."
,"3":"I have filled him with the spirit of God, with wisdom, understanding, skill, and ability for every kind of craft:"
,"4":"for the art of designing and working in gold and silver and bronze;"
,"5":"for cutting stones to be set, for carving in wood, for every kind of craft."
,"6":"Here and now I give him a partner, Oholiab son of Ahisamach, one of the tribe of Dan; and to all the men that have skill I have given more, for them to carry out all that I have commanded you:"
,"7":"the Tent of Meeting; the ark of Statement and the mercy Seat that is on top of the ark,"
,"8":"and all the furniture of the Holy Tent; the table and its furnishings; the pure lampstand and all its accessories; the altar of incense;"
,"9":"the altar of burnt offering with all its furnishings; the basin with its stand;"
,"10":"the beautiful priestly vestments, that is, the sacred vestment of Aaron the priest and the vestments of his sons, for the priestly functions;"
,"11":"the anointing oil and the fragrant incense for the sanctuary. In this they are to do exactly as I have directed you.'"
,"12":"Yahweh said to Moses,"
,"13":"'Speak to the people of Israel and say: 'You shall keep my sabbaths carefully, because the sabbath is a sign between myself and you from generation to generation to show that it is I, Yahweh, who have made you my own people."
,"14":"You must keep the sabbath, then; it is to be held sacred by you. Whoever does not keep it, but works on that day, must be put to death."
,"15":"Work is to be done for six days, but the seventh day must be a day of complete rest, consecrated to Yahweh. Whoever does any work on the sabbath day must be put to death. "
,"16":"The people of Israel are to keep the sabbath, observing it from generation to generation: this is a lasting covenant."
,"17":"Between myself and the people of Israel the sabbath is a sign forever, since in six days Yahweh made the heavens and earth, but on the seventh day he rested and drew breath.'"
,"18":"When Yahweh had finished speaking to Moses about all these things, he gave him the two slabs of the Statement, slabs of stone written with the finger of God."
}`)
	CurrentBook.AddChapter(32, `{
"1":"When the people saw that Moses was so long in coming down from the mountain they assembled around Aaron and said to him, 'Come, make us gods to walk ahead of us; as for this Moses who brought us out of Egypt, we don't know what has happened to him.'"
,"2":"And Aaron said to them, 'Take the gold earrings from your wives, your sons and daughters and bring them to me.'"
,"3":"So all the people took off their earrings and brought them to Aaron."
,"4":"He took what they gave him and with a graving tool made the gold into a molten calf. They then said, 'These are your gods, O Israel, who brought you out of Egypt.'"
,"5":"Now, when Aaron saw this, he built an altar before the molten calf and cried out, 'Tomorrow will be a feastday for Yahweh.'"
,"6":"So next day they rose early and sacrificed burnt offerings and brought peace offerings. They then sat down to eat and drink and got up to make merry."
,"7":"Then Yahweh said to Moses, 'Go down at once, for your people, whom you brought up from the land of Egypt, have corrupted themselves."
,"8":"They have quickly turned from the way I commanded them and have made for themselves a molten calf; they have bowed down before it and sacrificed to it and said: 'These are your gods, Israel, who brought you out of Egypt.'"
,"9":"And Yahweh said to Moses, 'I see that these people are a stiff-necked people."
,"10":"Now just leave me that my anger may blaze against them. I will destroy them, but of you I will make a great nation.'"
,"11":"But Moses calmed the anger of Yahweh, his God, and said, 'Why, O Yahweh, should your anger burst against your people whom you brought out of the land of Egypt with such great power and with a mighty hand?"
,"12":"Let not the Egyptians say: 'Yahweh brought them out with evil intent, for he wanted to kill them in the mountains and wipe them from the face of the earth.' Turn away from the heat of your anger and do not bring disaster on your people."
,"13":"Remember your servants, Abraham, Isaac and Jacob, and the promise you yourself swore: I will multiply your descendants like the stars of heaven, and all this land I spoke about I will give to them as an everlasting inheritance.'"
,"14":"Yahweh then changed his mind and would not yet harm his people."
,"15":"Moses then returned and came down from the mountain carrying in his hand the two slabs of the Statement, slabs written on both sides, back and front."
,"16":"These slabs were the work of God and the writing graven on the slabs was the writing of God."
,"17":"When Joshua heard the noise of the people who were shouting he said to Moses, 'There is a sound of war in the camp.'"
,"18":"But Moses answered, 'It is not a victory song, nor the cry of defeat that I hear, but the sound of singing.'"
,"19":"When he drew near to the camp and saw the calf and the dancing, his anger burst forth and he threw the slabs from his hands and shattered them against the base of the mountain."
,"20":"Then he seized the calf they had made and burned it in the fire, grinding it into a powder that he scattered over the surface of the water, and this he made the Israelites drink."
,"21":"Moses said to Aaron, 'What did these people do to you that you brought such a great sin on them?'"
,"22":"And Aaron said, 'Don't let your anger be roused. You know this people and how evil they are."
,"23":"They said to me: 'Make us gods to go before us; as for this Moses, the man who brought us out of Egypt, we don't know what has happened to him.'"
,"24":"I then said to them that whoever had gold was to give it over to me. I threw it in the fire and out came this calf!'"
,"25":"Moses saw that the people were out of control, for Aaron had let them run wild, to a point that would make them an easy prey for their opponents."
,"26":"Then Moses stood at the gate of the camp and said, 'All those for Yahweh, come to me.' And all the sons of Levi rallied round him."
,"27":"Then he said to them, 'This is what Yahweh, the God of Israel commands: Let each one carry a sword at his side. Go back and forth from door to door and don't hesitate to kill even your brothers, your companions and your relatives.'"
,"28":"The Levites did what Moses had ordered and that day about three thousand men fell."
,"29":"Moses then said, 'From now on your hands are consecrated to Yahweh for each of you has been able to turn against his very sons and brothers. Because of this, Yahweh gives you today his blessing.'"
,"30":"The next day Moses said to the people, 'You have committed a very grave sin, but now I am going up to Yahweh; perhaps I will obtain pardon for your sin.'"
,"31":"So Moses went towards Yahweh and said, 'Ah! This people has committed a very great sin; they made a god out of gold."
,"32":"And now please forgive their sin... if not, blot me out of the book you have written.'"
,"33":"Yahweh said to Moses, 'Whoever has sinned against me, I will blot him out from my book."
,"34":"Go now! Lead the people where I told you. My Angel will walk before you and on the day of punishment I will punish them for their sin.'"
,"35":"And so Yahweh punished the people with a plague because of the calf Aaron had made for them."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Yahweh said to Moses, 'Go now! Leave this place, you and the people you brought out from the land of Egypt and go to the land I promised on oath to Abraham, Isaac and Jacob when I said: 'I will give it to your descendants.'"
,"2":"I will send an Angel before you to drive out the Canaanites, the Amorites, the Hittites and the Perizzites, the Hivites and the Jebusites."
,"3":"But I will not go with you to this land flowing with milk and honey, for you are a stiff-necked people and I might destroy you on the way.'"
,"4":"When the people heard these distressing words they were very sad and none of them put on any ornaments."
,"5":"Yahweh then said to Moses, 'Say to the sons of Israel: 'You are a stiff-necked people. If I were to go with you, even for a moment, I would destroy you! Now, take off your orna-ments that I may know what I shall do to you.'"
,"6":"And so the Israelites gave up their ornaments before leaving Mount Horeb."
,"7":"Moses then took the Tent and pitched it for himself outside the camp, at a distance from it, and called it the Tent of Meeting. Whoever sought Yahweh would go out to the Tent of Meeting outside the camp."
,"8":"And when Moses went to the tent all the people would stand, each one at the entrance to his tent and keep looking towards Moses until he entered the tent."
,"9":"Now, as soon as Moses entered the tent, the pillar of cloud would come down and remain at the entrance to the tent, while Yahweh spoke with Moses."
,"10":"When all the people saw the pillar of cloud at the entrance to the tent, they would arise and worship, each one at the entrance to his own tent."
,"11":"Then Yahweh would speak to Moses face to face, as a man speaks with his neighbor, and then Moses would return to the camp, but his servant Joshua, son of Nun, would not leave the tent."
,"12":"Then Moses said to Yahweh, 'You say to me: 'Lead this people up,' but you haven't told me who you will send with me and yet you have said that you know me by name and that I have found favor in your sight."
,"13":"And now if I have found favor in your sight, let me know your ways, that I may know you and so find favor in your sight. Look, this people is your own people.'"
,"14":"Yahweh said, 'My Face will go with you and I will give you rest.'"
,"15":"And Moses said, 'If your Face does not come with us, do not take us from here."
,"16":"And how will anyone here know that you look kindly on me and my people? Will it not be because you go with us? In that way, I myself and your people will be distinguished from every other nation on the face of the earth.'"
,"17":"Yahweh then said to Moses, 'What you have said I will do, for I look kindly on you and I have known you by name.'"
,"18":"Moses said, 'Then let me see your Glory.'"
,"19":"And He said, 'I will make all my goodness pass before you and proclaim the name of Yahweh before you. For I am gracious to whom I want to be gracious and I am merciful to whom I want to be merciful.'"
,"20":"Then Yahweh said, 'You cannot see my face because man cannot see me and live.'"
,"21":"And he added, 'See this place near me; you shall stand on the rock"
,"22":"and when my Glory passes I will put you in a hollow of the rock and cover you with my hand until I have passed by."
,"23":"Then I will take away my hand and you shall see my back, but my face shall not be seen.'"
}`)
	CurrentBook.AddChapter(34, `{
"1":"Yahweh said to Moses, 'Cut two slabs of stone like the first, and I will write on the slabs the words that were on the former slabs that you broke."
,"2":"Be ready in the morning and come up to Mount Sinai and wait for me on the top of the mountain."
,"3":"No one will go up with you and no one is to be seen anywhere on the mountain. Even the sheep and the cattle are not to graze near the mountain.'"
,"4":"So Moses cut two slabs of stone like the first. Then he rose early in the morning and went up Mount Sinai as Yahweh had commanded, taking in his hands the two slabs of stone."
,"5":"And Yahweh came down in a cloud and stood there with him, and Moses called on the name of Yahweh."
,"6":"Then Yahweh passed in front of him and cried out, 'Yahweh, Yahweh is a God full of pity and mercy, slow to anger and abounding in truth and loving-kindness."
,"7":"He shows loving-kindness to the thousandth generation and forgives wickedness, rebellion and sin; yet he does not leave the guilty without punishment, even punishing the children and their children for the sin of the fathers to the third and fourth generation.'"
,"8":"Moses hastened to bow down to the ground and worshiped."
,"9":"He then said, 'If you really look kindly on me, my Lord, please come and walk in our midst and even though we are a stiff-necked people, pardon our wickedness and our sin and make us yours.'"
,"10":"Yahweh said, 'I am making a covenant with you; in the presence of all the people I will do marvels never yet done in any land or nation so that all the people among whom you live may see how awesome is the work of Yahweh that I will do for you."
,"11":"Obey what I command you today. I will drive out before you the Amorites, the Canaanites, the Hittites, the Perizzites, the Hivites and the Jebusites."
,"12":"Take care to make no treaty with the inhabitants of the country you enter, lest it be a snare for you."
,"13":"Rather shall you knock down their altars and smash their sacred stones and cut down their Asherah poles."
,"14":"Do not worship another god, for Yahweh whose name is jealous, is a jealous God!"
,"15":"So make no treaty with those who live in the land, for they prostitute themselves to their gods and sacrifice to them; otherwise they will invite you and you will eat of their sacrifices."
,"16":"Then you will take their daughters for your sons and as those daughters prostitute themselves to their gods, they will lead your sons to do the same."
,"17":"Make no molten gods for yourself."
,"18":"Keep the feast of Unleavened Bread; for seven days in the month of Abib you are to eat unleavened bread, for that was the month you went out of Egypt."
,"19":"All that first opens the womb is mine and every firstborn male of your livestock, sheep and cattle."
,"20":"You shall redeem the firstborn of a donkey with a lamb. If you do not redeem it you must break its neck. Every firstborn of your sons you shall redeem; and no one shall appear before me empty-handed."
,"21":"You shall work for six days and rest on the seventh day; even at the time of plowing and harvesting you shall rest."
,"22":"Celebrate the Feast of Weeks with the firstfruits of the wheat harvest and the Feast of Ingathering at the turning of the year."
,"23":"Three times each year all your men shall appear before Yahweh, God of Israel."
,"24":"I will drive out nations before you and extend your boundaries. No one shall covet your country when you go up three times each year to appear before Yahweh, your God."
,"25":"Do not offer the blood of a sacrifice to me together with leavened bread and do not let anything from the Passover Feast remain until morning."
,"26":"Bring the very best of the firstfruits of your soil to the house of Yahweh, your God. Do not boil a kid in the milk of its mother.'"
,"27":"Then Yahweh said to Moses, 'Write down these words, for these are the requirements of the covenant that I have made with you and with Israel.'"
,"28":"Moses remained there with Yahweh forty days and forty nights without eating bread or drinking water. He wrote on the slabs the words of the Covenant - the Ten Commandments."
,"29":"When Moses came down from Mount Sinai, with the two slabs of the Statement in his hands, he was not aware that the skin of his face was radiant after speaking with Yahweh."
,"30":"Aaron and all the sons of Israel saw that Moses' face was radiant and they were afraid to go near him."
,"31":"But Moses called them, and Aaron with all the leaders of the community drew near, and Moses spoke to them."
,"32":"Afterwards all the Israelites came near and he told them all that Yahweh had commanded him on Mount Sinai."
,"33":"When Moses had finished speaking with them, he put a veil over his face."
,"34":"Whenever Moses went before Yahweh to speak with him, he took off the veil until he came out again. And when he came out and told them what he had been commanded,"
,"35":"the Israelites saw that his face was radiant. Moses would then replace the veil over his face until he went again to speak with Yahweh."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Moses assembled the whole community of the people of Israel and said to them, 'This is what Yahweh has ordered to be done:"
,"2":"Work is to be done for six days, but the seventh is to be a holy day for you, a day of complete rest, consecrated to Yahweh. Whoever does any work on that day shall be put to death."
,"3":"You must not light a fire on the sabbath day in any of your homes.'"
,"4":"Moses spoke to the whole community of the people of Israel, 'This is what Yahweh has commanded:"
,"5":"Set aside a contribution for Yahweh out of your possessions. Let all give willingly and bring this contribution for Yahweh: gold, silver, and bronze;"
,"6":"purple wool, of violet shade and red, crimson wool, fine linen, goats' hair,"
,"7":"rams' skins dyed red and fine leather, acacia wood,"
,"8":"oil for the light, spices for the anointing oil and for the fragrant incense;"
,"9":"precious stones and gems to be set in Ephod and Breastpiece."
,"10":"Let all the most skilled craftsmen among you come and make all that Yahweh has commanded:"
,"11":"the Holy Tent, its tent and its covering, its hooks and its frames, its crossbars, its posts, and its bases;"
,"12":"the ark with its poles, the mercy Seat on the ark and the veil that screens it;"
,"13":"the table with its poles and all the furnishings for it, and the loaves of offering;"
,"14":"the lampstand for the light, with its accessories, its lamps, and the oil for the light;"
,"15":"the altar of incense with its poles, the anointing oil, the fragrant incense, and the screen for the entrance to the Holy Tent;"
,"16":"the altar of burnt offering with its bronze grating, its poles, and all the furnishings for it, the basin and its stand;"
,"17":"the hangings of the court, its posts, its bases, and the screen for the gateway to the court;"
,"18":"the pegs of the Holy Tent and of the court, together with their cords;"
,"19":"the beautiful priestly vestments for service in the sanctuary, that is, the sacred vestments for Aaron the priest and the vestments of his sons for the priestly functions.'"
,"20":"Then the whole community of Israel withdrew from Moses' presence."
,"21":"And all those who wanted to give came, bringing their contribution for Yahweh for making the Tent of Meeting, for all its functions and for the sacred vestments."
,"22":"They came, men and women, all giving willingly, bringing brooches, rings, bracelets, necklaces, gold things of every kind - the gold which each one had offered to Yahweh."
,"23":"All those who happened to own purple wool, of violet shade or red, crimson wool, fine linen, goats' hair, rams' skins dyed red, or fine leather, brought them."
,"24":"All who could contribute to the collection of silver and bronze brought their contribution for Yahweh. And all who happened to own acacia wood, suitable for any of the work to be done, brought it."
,"25":"All the skilled women set their hands to spinning, and brought purple wool, of violet shade and red, crimson wool and fine linen, from what they had spun."
,"26":"All the women willingly used their special skill and spun the goats' hair."
,"27":"The leaders brought precious stones and gems to be set in Ephod and Breastpiece,"
,"28":"and the spices and oil for the light, for the anointing oil and for the fragrant incense."
,"29":"All the men and women of Israel who wanted to contribute to all the work that Yahweh had ordered through Moses to be done brought their free offering to Yahweh."
,"30":"Moses said to the people of Israel, 'See, Yahweh has chosen Bezalel son of Uri, son of Hur, of the tribe of Judah."
,"31":"He has filled him with the spirit of God and given him understanding, skill, and ability for every kind of craft:"
,"32":"for the art of designing and working in gold and silver and bronze;"
,"33":"for cutting stones to be set, for carving in wood, for every kind of craft."
,"34":"And to him and Oholiab son of Ahisamach, of the tribe of Dan, he has given the gift of teaching."
,"35":"He has filled them with skill to carry out all the crafts of engraver, weaver of fine linen, embroiderer in purple wool, of violet shade and red, in crimson wool and fine linen, as well as of the common weaver; they are able to do work of all kinds, and are skillful designers.'"
}`)
	CurrentBook.AddChapter(36, `{
"1":"Bezalel and Oholiab and all the skilled craftsmen to whom Yahweh had given skill and understanding to carry out all that was required for the building of the sanctuary, did their work exactly as Yahweh had directed."
,"2":"Moses then called Bezalel and Oholiab and all the skilled craftsmen to whom Yahweh had given ability and who felt able to do the work."
,"3":"They received from Moses all that the people of Israel had brought as contributions for the work of building the sanctuary. In the meantime, the people continued each morning to bring their offerings."
,"4":"So the skilled craftsmen who did all the sacred work, besides their own work,"
,"5":"went to tell Moses, 'The people are bringing more than what is needed for the work which Yahweh has told us to do.'"
,"6":"Moses then sent this command throughout the camp: 'Let no one, man or woman, do anything more toward the collection for the sanctuary.' So the people were stopped from bringing any more;"
,"7":"the material they had was enough, and more than enough, to complete all the work."
,"8":"All the most skilled craftsmen among the workers made the Holy Tent. They made it with ten sheets of fine twined linen, of purple wool, violet shade and red, and of crimson wool, finely embroidered with angels."
,"9":"The length of a single sheet was twenty-eight cubits, its width four cubits, all the sheets being of the same size."
,"10":"They sewed five of the sheets together, and the other five also."
,"11":"They attached loops of violet wool to the border of the last sheet in one set, and did the same for the border of the last sheet in the other set."
,"12":"They put fifty loops on the first sheet and, matching them one by one, fifty loops on the border of the last sheet in the second set."
,"13":"They made fifty gold clasps and with them joined the two sets into one piece."
,"14":"Next they made sheets of goats' hair to form a tent over the Holy Tent; they made eleven of these."
,"15":"The length of a single sheet was thirty cubits, its width four cubits; the eleven sheets were all of the same size."
,"16":"They joined five of these sheets together into one set, the remaining six into another."
,"17":"They attached fifty loops to the border of the last sheet in the first set, and fifty loops to the border of the last sheet in the second set."
,"18":"And they made fifty bronze clasps, to join the two sets so as to form one cover."
,"19":"They made another covering of rams' skins dyed red to be put over the Holy Tent and a covering of fine leather to spread over that."
,"20":"The Holy Tent was made with boards of acacia wood, which stood upright."
,"21":"Each board was ten cubits long and one and a half cubits wide."
,"22":"Each board was fitted with two matching arms; this they did for all the boards of the Holy Tent."
,"23":"They made twenty boards for the southern side,"
,"24":"with forty silver bases to put under the twenty boards: two bases under the first board to receive its two matching arms, and so on for the other boards."
,"25":"For the other side on the north, they made twenty boards"
,"26":"and forty silver bases, two bases under each board."
,"27":"For the back on the west, they made six boards."
,"28":"And they made two boards for the corners at the back of the Holy Tent."
,"29":"These boards were joined at the bottom and also at the top, up to the level of the first ring; this they did with the two boards that were to form the two corners."
,"30":"In this way there were eight boards with their sixteen silver bases; two bases under each board."
,"31":"They made crossbars of acacia wood: five to hold the boards together that were to form one side of the Holy Tent,"
,"32":"five on the other side to hold the boards that were to form the northern side."
,"33":"They made the middle bar, fixed halfway up, to run from one end to the other."
,"34":"They covered the boards with gold, and put gold rings on them to take the crossbars which they covered with gold."
,"35":"They made the veil of purple wool, violet shade and red, of crimson wool, and of fine twined linen, skillfully embroidered with Cherubim."
,"36":"For hanging this veil they made four posts of acacia wood and covered them with gold, with gold hooks, and they cast four silver bases for them."
,"37":"For the entrance to the tent they made a curtain of purple wool, violet shade and red, and of crimson wool and fine twined linen, the work of a skilled embroiderer."
,"38":"For the hanging of this they made five posts with hooks; their tops and rods they plated with gold; their five bases were of bronze."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Bezalel made the ark of acacia wood, two and a half cubits long, one and a half cubits wide, one and a half cubits high."
,"2":"He covered it, inside and out, with pure gold, and decorated it all around with a gold edge."
,"3":"He cast four gold rings for the ark, attaching them to its four feet: two rings on one side and two rings on the other."
,"4":"He also made poles of acacia wood covering them with gold;"
,"5":"and he passed the poles through the rings on the sides of the ark, for carrying it."
,"6":"Also he made of pure gold the mercy Seat, two and a half cubits long, and one and a half cubits wide."
,"7":"For the two ends of the mercy Seat he made two golden Cherubim of hammered gold,"
,"8":"the first Cherub for one end and the second for the other, and fastened them to the two ends of the mercy Seat so that they made one piece with it."
,"9":"The Cherubim had their wings spread upward so that they overshadowed the mercy Seat. They faced one another."
,"10":"He made the table of acacia wood, two cubits long, one cubit wide, and a half cubit high."
,"11":"He covered it with pure gold, and decorated it all around with a gold edge."
,"12":"He surrounded it with a frame three inches wide, and decorated this with a gold edge."
,"13":"He cast four gold rings for it and fixed these at the four corners where the four legs were."
,"14":"The rings lay close to the frame to hold the poles for carrying the table."
,"15":"He made the poles of acacia wood and covered them with gold; these were for carrying the table."
,"16":"He made furnishings of pure gold for the table: dishes, cups, jars and bowls to be used for the wine offerings."
,"17":"He made the lampstand of pure gold, and made the lampstand, base and stem, of hammered gold. Its decorative flowers including buds and petals were of one piece with it."
,"18":"Six branches extended from the sides of it, three from one side, three from the other."
,"19":"The first branch carried three decorative flowers shaped like almond blossoms, each with its bud and petals; the second branch, too, carried three decorative flowers shaped like almond blossoms, each with its bud and petals, and similarly all six branches extending from the lampstand."
,"20":"The lampstand itself carried four decorative flowers shaped like almond blossoms, each with its bud and petals:"
,"21":"one bud under the first two branches extending from the lampstand, one under the next pair, one under the last pair: for there were six branches extending from the lampstand."
,"22":"The buds and the branches were of one piece with the lampstand, and the whole was made from a single piece of pure hammered gold."
,"23":"Then he made the lamps for it, seven of them, with tongs and trays of pure gold."
,"24":"He used seventy-five pounds of pure gold for making the lampstand and all its accessories."
,"25":"He made the altar of incense out of acacia wood. It was one cubit long, and one cubit wide that is to say, square - and two cubits high; its horns were one piece with it."
,"26":"The top of it, its surrounding sides, and its horns, he covered with pure gold, and decorated it all around with a gold edge."
,"27":"He fixed two gold rings to it below the edge on its two opposite sides, to hold the poles used for carrying it."
,"28":"These poles he made of acacia wood and covered them with gold."
,"29":"He also made the sacred anointing oil and the pure, fragrant incense, blending it as perfumers do."
}`)
	CurrentBook.AddChapter(38, `{
"1":"He made the altar of burnt offering out of acacia wood, a square five cubits long and five cubits wide, and three cubits high."
,"2":"At its four corners he put horns, the horns being of one piece with it, and covered it with bronze."
,"3":"He made all the altar vessels: caldrons, shovels, sprinkling basins, pans for the ashes, fire pans; he made all the vessels for the altar out of bronze."
,"4":"He made a grating for it of bronze network which he set under the ledge, below, so that it reached halfway up the altar."
,"5":"He cast four rings and fixed them on the four corners of the bronze grating to hold the poles."
,"6":"He made the poles of acacia wood and covered them with bronze"
,"7":"and placed them through the rings on the sides of the altar for carrying it. He made the altar hollow, of boards."
,"8":"He also made the bronze basin and its bronze base from the mirrors of the women who served at the entrance to the Tent of Meeting."
,"9":"He made the court. For the southern side of the court, facing the south country, there were one hundred cubits of hangings of fine twined linen."
,"10":"Their twenty posts with their twenty bases were of bronze, their hooks and rods of silver."
,"11":"For the northern side there were one hundred cubits of hangings. Their twenty posts with their twenty bases were of bronze, their hooks and rods of silver."
,"12":"For the western side, there were fifty cubits of hangings, carried on ten posts set in ten bases, with their hooks and rods of silver."
,"13":"Fifty cubits, too, for the eastern side facing the sunrise."
,"14":"On one side of the gateway there were fifteen cubits of hangings carried on three posts set in three bases."
,"15":"On the other side there were fifteen cubits of hangings, with their three posts and their three bases."
,"16":"All the hangings enclosing the court were of fine twined linen."
,"17":"The bases for the posts were of bronze and their hooks of silver like the rods at the top. The tips of the posts were of silver and had rods of silver."
,"18":"The screen for the gateway of the court, the work of a skilled embroiderer, was made of purple wool, violet shade and red, of crimson wool, and fine twined linen. It was twenty cubits long and, along the width of it, five cubits high like the hangings of the court."
,"19":"Its four posts with their four bases were of bronze. The hooks for the posts were of silver, like the plating at the top and like their rods."
,"20":"The pegs for the Holy Tent and for the court enclosure were all of bronze."
,"21":"Here is the account of metals used for the Holy Tent - the Tent of Meeting - the account drawn up by the Levites under the direction of Ithamar son of Aaron, the priest, as Moses had ordered."
,"22":"Bezalel son of Uri, son of Hur, of the tribe of Judah, made all that Yahweh had commanded."
,"23":"His partner was Oholiab son of Ahisamach, of the tribe of Dan, engraver, weaver of fine linen, embroiderer in purple wool, of violet shade and red, in crimson wool and fine linen."
,"24":"The amount of gold used in the work - the entire work for the sanctuary - (this was gold consecrated by offering) weighed 2,195 pounds, weighed according to the official standard."
,"25":"The silver collected when the census of the community was taken weighed 7,550 pounds, weighed according to the official standard."
,"26":"A census of all those of twenty years and over was made. They were six hundred and three thousand five hundred and fifty; each of them paid a small silver coin."
,"27":"The 7,500 pounds of silver were used for casting the one hundred bases for the sanctuary and the veil, 75 pounds for each base."
,"28":"With the remaining 50 pounds of silver he made the hooks for the posts, the plating for their tops, and their rods."
,"29":"The bronze consecrated by offering amounted to 5,310 pounds,"
,"30":"and with this he made the bases for the entrance of the Tent of Meeting, the bronze altar with its grating of bronze and all the furnishings for it,"
,"31":"the bases for the enclosure of the court, those for the gateway to the court, all the pegs for the Holy Tent, and all the pegs for the court enclosure."
}`)
	CurrentBook.AddChapter(39, `{
"1":"From the purple wool, violet shade and red, the crimson wool, and the fine linen they made beautiful priestly vestments for service in the sanctuary. They made the sacred vestments for service for Aaron, as Yahweh had directed Moses."
,"2":"They made the Ephod of gold thread, purple wool, violet shade and red, crimson wool, and fine twined linen."
,"3":"They beat gold into thin plates, and cut these into fine strips to weave into the purple wool, violet shade and red, into the crimson wool and the fine linen, as does the weaver of fine linen."
,"4":"For the Breastpiece they made two shoulder straps, joined to it at its two ends."
,"5":"The woven band on it to hold it formed one piece with it and was of similar workmanship: this was of gold thread, purple wool, violet shade and red, crimson wool, and fine twined linen, as Yahweh had directed Moses."
,"6":"They fashioned the precious stones, mounted in settings of gold mesh and engraved, as a seal is engraved, with the names of the sons of Israel."
,"7":"They fastened the stones to the shoulder straps of the Breastpiece, stones commemorating the sons of Israel, as Yahweh had directed Moses."
,"8":"They made the Breastpiece, finely embroidered, of the same workmanship as the Ephod, of gold thread, purple wool, violet shade and red, and fine twined linen."
,"9":"It was square and folded double, nine inches long and nine inches wide."
,"10":"In this they set four rows of stones: sard, topaz, carbuncle, for the first row;"
,"11":"emerald, sapphire, diamond, for the second row;"
,"12":"for the third row, hyacinth, ruby, amethyst;"
,"13":"and for the fourth row, beryl, onyx, jasper. These were mounted in settings of gold mesh"
,"14":"and bore the names of the twelve sons of Israel. They were engraved as seals are, each with the name of one of the twelve tribes."
,"15":"For the Breastpiece they made chains of pure gold twisted like cords."
,"16":"They made two gold rosettes and two gold rings,"
,"17":"and they fastened the two gold cords to the two rings fixed on the corners of the Breastpiece."
,"18":"The other two ends of the cords they fastened to the two rosettes; they were thus attached to the shoulder straps of the Ephod, on the front."
,"19":"They made two gold rings and fixed them to the lower corners of the Breastpiece, on the inner hem, next to the Ephod."
,"20":"And they made two more gold rings and fixed them low down on the front of the two shoulder straps of the Ephod, close to the seam, above the woven band of the apron."
,"21":"They secured the Breastpiece by passing a ribbon of violet-purple through its rings and those of the apron, so that the Breastpiece would sit above the woven band and not come apart from the Ephod, as Yahweh had directed Moses."
,"22":"Then they made the robe of the Ephod woven entirely of violet-purple."
,"23":"The opening in the center of it was like the neck of a shirt and around the opening was a border to keep the robe from tearing."
,"24":"The lower hem of the robe they decorated with pomegranates of purple wool, violet shade and red, crimson wool, and fine twined linen."
,"25":"They also made bells of pure gold and placed them all around the lower hem of the robe between the pomegranates,"
,"26":"bells and pomegranates alternately all around the lower hem of the robe, as Yahweh had directed Moses."
,"27":"Then they made the shirts of finely woven linen for Aaron and his sons,"
,"28":"the headdress of fine linen, the shorts of fine twined linen,"
,"29":"the belts of fine twined linen, of purple wool, violet shade and red, and of crimson wool, finely embroidered, as Yahweh had directed Moses."
,"30":"They also made the plate, the holy plate of pure gold, and engraved on it 'Consecrated to Yahweh,' as a man engraves a seal."
,"31":"They tied to this a ribbon of violet-purple to secure it to the top of the turban, as Yahweh had directed Moses."
,"32":"So all the work of the tabernacle, that is the Tent of Meeting, was completed. In carrying it out the sons of Israel had done exactly as Yahweh had directed Moses."
,"33":"Then they brought to Moses all these things, the Tent of Meeting, and all its furnishings: its hooks, frames, crossbars, posts, bases,"
,"34":"the covering of rams' skins dyed red, the covering of fine leather, and the screening veil;"
,"35":"the ark of the Statement with its poles and the mercy Seat;"
,"36":"the table with all its furnishings, and the loaves of offering;"
,"37":"the lampstand of pure gold with its lamps - the lamps that were to be set on it - and all its accessories; the oil, too, for the light;"
,"38":"the golden altar, the anointing oil, the fragrant incense, the curtain for the entrance to the tent;"
,"39":"the bronze altar with its grating of bronze, its poles and all its furnishings; the basin and its stand;"
,"40":"hangings of the court with their posts and bases, and the curtain for the gateway to the court, its cords, its pegs, and all the furniture for the service in the Holy Tent, the Tent of Meeting;"
,"41":"the beautiful priestly vestments for service in the sanctuary, that is, the sacred vestments for Aaron the priest, and the vestments for his sons for the priestly functions."
,"42":"The Israelites had done all the work exactly as Yahweh had directed Moses."
,"43":"Moses examined the whole work, and he could see they had done it as Yahweh had directed him. And Moses blessed them."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Yahweh spoke to Moses and said,"
,"2":"'On the first day of the first month you are to erect the Holy Tent, the Tent of Meeting,"
,"3":"and place the ark of the Statement in it, screening it with the veil."
,"4":"Bring in the lampstand, too, and set up its lamps."
,"5":"Place the golden altar of incense in front of the ark of the Statement, and set up the screen at the entrance of the Holy Tent."
,"6":"Place the altar for burnt offerings in front of the entrance to the Holy Tent, the Tent of Meeting."
,"7":"Place the basin between the Tent of Meeting and the altar, and fill it with water."
,"8":"Set up the enclosure of the court and hang the curtain at the gateway of the court."
,"9":"Then, taking the sacred oil, anoint the Holy Tent and everything in it, consecrating it with its furniture, to make it a holy place."
,"10":"Anoint the altar for burnt offerings with all its furnishings; and consecrate the altar which, henceforth, will be a most holy thing."
,"11":"Anoint the basin with its stand, and consecrate it."
,"12":"Bring Aaron and his sons to the entrance of the Tent of Meeting and see that they bathe."
,"13":"Then clothe Aaron with the priestly garments and anoint and consecrate him, to serve me in the priesthood."
,"14":"Next, bring his sons and clothe them with shirts."
,"15":"Anoint them as you have anointed their father, to serve me in the priesthood. This anointing of them is to confer the priesthood on them forever from generation to generation.'"
,"16":"Moses did this; he did exactly as Yahweh had commanded him."
,"17":"The Holy Tent was set up on the first day of the first month in the second year."
,"18":"Moses set up the Holy Tent. He fixed the bases for it, put up its frames, put its crossbars in position, set up its posts."
,"19":"He spread the tent over the Holy Tent and on top of this the covering for the tent, as Yahweh had commanded Moses."
,"20":"He took the Statement and placed it inside the ark. He set the poles to the ark in place and put the mercy Seat on it."
,"21":"He brought the ark into the Holy Tent and put the screening veil in place; thus he screened the ark of Yahweh, as Yahweh had commanded Moses."
,"22":"He placed the table in the Tent of Meeting, on the north side of the Holy Tent, outside the veil,"
,"23":"and on it arranged the loaves before Yahweh, as Yahweh had commanded Moses."
,"24":"He put the lampstand in the Tent of Meeting, opposite the table, on the southern side of the Holy Tent,"
,"25":"and he set up the lamps before Yahweh, as Yahweh had commanded Moses."
,"26":"He put the golden altar in the Tent of Meeting in front of the veil,"
,"27":"and on it burned fragrant incense, as Yahweh had commanded Moses."
,"28":"Then he put the screen at the entrance to the Holy Tent."
,"29":"Then he put the altar for the burnt offerings at the entrance to the Tent of Meeting, and on it offered the burnt offering and grain offering, as Yahweh had commanded Moses."
,"30":"He put the basin between the Tent of Meeting and the altar, and filled it with water."
,"31":"This was for Aaron and his sons to wash their hands and feet:"
,"32":"whenever they entered the Tent of Meeting or approached the altar they washed, as Yahweh had commanded Moses."
,"33":"Moses then set up the court around the Holy Tent and the altar and placed the screen at the gateway to the court. Thus Moses completed the work."
,"34":"Then the cloud covered the Tent of Meeting and the Glory of Yahweh filled the Holy Tent."
,"35":"Moses could not enter the Tent of Meeting because of the cloud that rested on it and because of the Glory of Yahweh that filled the Holy Tent."
,"36":"At every stage of their journey, whenever the cloud rose from the Holy Tent the people of Israel would continue their march."
,"37":"If the cloud did not rise, they waited and would not move their camp until it did."
,"38":"For the cloud rested on the Holy Tent by day, and a fire shone within the cloud by night for all the House of Israel to see. And so it was for every stage of their journey."
}`)

}
func EN_CCB_LoadVPGNChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"In the beginning, when God began to create the heavens and the earth,"
,"2":"the earth had no form and was void; darkness was over the deep and the Spirit of God hovered over the waters."
,"3":"God said, 'Let there be light'; and there was light."
,"4":"God saw that the light was good and he separated the light from the darkness."
,"5":"God called the light 'Day' and the darkness 'Night'. There was evening and there was morning: the first day."
,"6":"God said, 'Let there be a firm ceiling between the waters and let it separate waters from waters.'"
,"7":"So God made the ceiling and separated the waters below it from the waters above it. And so it was."
,"8":"God called the firm ceiling 'Sky'. There was evening and there was morning: the second day."
,"9":"God said, 'Let the waters below the sky be gathered together in one place and let dry land appear.' And so it was."
,"10":"God called the dry land 'Earth', and the waters gathered together he called 'Seas'. God saw that it was good."
,"11":"God said, 'Let the earth produce vegetation, seed-bearing plants, fruittrees bearing fruit with seed, each according to its kind, upon the earth.' And so it was."
,"12":"The earth produced vegetation: plants bearing seed according to their kind and trees producing fruit which has seed, according to their kind. God saw that it was good."
,"13":"There was evening and there was morning: the third day."
,"14":"God said, 'Let there be lights in the ceiling of the sky to separate day from night and to serve as signs for the seasons, days and years;"
,"15":"and let these lights in the sky shine above the earth.' And so it was."
,"16":"God therefore made two great lights, the greater light to govern the day and the smaller light to govern the night; and God made the stars as well."
,"17":"God placed them in the ceiling of the sky to give light on the earth"
,"18":"and to separate the light from the darkness. God saw that it was good."
,"19":"There was evening and there was morning: the fourth day."
,"20":"God said, 'Let the water teem with an abundance of living creatures, and let birds fly above the earth under the ceiling of the sky.'"
,"21":"God created the great monsters of the sea and all living animals, those that teem in the waters, according to their kind, and every winged bird, according to its kind. God saw that it was good."
,"22":"God blessed them saying, 'Be fruitful and increase in number, fill the waters of the sea, and let the birds increase on the earth.'"
,"23":"There was evening and there was morning: the fifth day."
,"24":"God said, 'Let the earth produce living animals according to their kind: cattle, creatures that move along the ground, wild animals according to their kind.' So it was."
,"25":"God created the wild animals according to their kind, and everything that creeps along the ground according to its kind. God saw that it was good."
,"26":"God said, 'Let us make man in our image, to our likeness. Let them rule over the fish of the sea, over the birds of the air, over the cattle, over the wild animals, and over all creeping things that crawl along the ground.'"
,"27":"So God created man in his image; in the image of God he created him; male and female he created them."
,"28":"God blessed them and said to them, 'Be fruitful and increase in number, fill the earth and subdue it, rule over the fish of the sea and the birds of the sky, over every living creature that moves on the ground.'"
,"29":"God said, 'I have given you every seed-bearing plant which is on the face of all the earth, and every tree that bears fruit with seed. It will be for your food."
,"30":"To every wild animal, to every bird of the sky, to everything that creeps along the ground, to everything that has the breath of life, I give every green plant for food.' So it was."
,"31":"God saw all that he had made, and it was very good. There was evening and there was morning: the sixth day."
}`)
	CurrentBook.AddChapter(2, `{
"1":"That was the way the sky and earth were created and all their vast array."
,"2":"By the seventh day the work God had done was completed, and he rested on the seventh day from all the work he had done."
,"3":"And God blessed the seventh day and made it holy, because on that day he rested from all the work he had done in his creation."
,"4":"These are the successive steps in the creation of the heavens and the earth. On the day that Yahweh God made the earth and the heavens, "
,"5":"there was not yet on the earth any shrub of the fields, nor had any plant yet sprung up, for Yahweh God had not made it rain on the earth, and there was no man to till the earth,"
,"6":"but a mist went up from the earth and watered the surface of the earth."
,"7":"Then Yahweh God formed Man, dust drawn from the clay, and breathed into his nostrils a breath of life and Man became alive with breath."
,"8":"God planted a garden in Eden in the east and there he placed Man whom he had created."
,"9":"Yahweh God caused to grow from the ground every kind of tree that is pleasing to see and good to eat, also the tree of Life in the middle of the garden and the tree of the Knowledge of Good and Evil."
,"10":"A river flowed from Eden to water the garden and from there it divided to form four main streams."
,"11":"The name of the first river is Pishon. It is the one that flows around all the country of Havilah where there is gold,"
,"12":"and the gold of that country is good; bidellium and onyx stone are there."
,"13":"The name of the second river is Gihon. It is the one that flows around all the land of Cush."
,"14":"The name of the third river is Tigris. It is the one that flows to the east of Assyria. The fourth river is the Euphrates."
,"15":"Yahweh God took Man and placed him in the garden of Eden to till it and take care of it."
,"16":"Then Yahweh God gave an order to Man saying, 'You may eat of every tree in the garden,"
,"17":"but of the tree of the Knowledge of Good and Evil, you will not eat, for on the day you eat of it, you will die.'"
,"18":"Yahweh God said, 'It is not good for Man to be alone; I will give him a helper who will be like him.'"
,"19":"Then Yahweh God formed from the earth all the beasts of the field and all the birds of the air and brought them to Man to see what he would call them; and whatever Man called every living creature, that was its name."
,"20":"So Man gave names to all the cattle, the birds of the air and to every beast of the field. But he did not find among them a helper like himself."
,"21":"Then Yahweh God caused a deep sleep to come over Man and he fell asleep. He took one of his ribs and filled its place with flesh."
,"22":"The rib which Yahweh God had taken from Man he formed into a woman and brought her to the man."
,"23":"The man then said, 'Now this is bone of my bone and flesh of my flesh. She shall be called woman because she was taken from man.'"
,"24":"That is why man leaves his father and mother and is attached to his wife, and with her becomes one flesh."
,"25":"Both the man and his wife were naked and were not ashamed."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Now the serpent was the most crafty of all the wild creatures that Yahweh God had made. He said to the woman, 'Did God really say: You must not eat from any tree in the garden?'"
,"2":"The woman said to the serpent, 'We may eat the fruit of the trees in the garden,"
,"3":"but of the fruit of the tree that is in the middle of the garden God said: You must not eat, and you must not touch it or you will die.'"
,"4":"The serpent said to the woman, 'You will not die,"
,"5":"but God knows that the day you eat it, your eyes will be opened and you will be like gods, knowing good and evil.'"
,"6":"The woman saw that the fruit was good to eat, and pleasant to the eyes, and ideal for gaining knowledge. She took its fruit and ate it and gave some to her husband who was with her. He ate it."
,"7":"Then their eyes were opened and both of them knew they were naked. So they sewed leaves of a fig tree together and made themselves loincloths."
,"8":"They heard the voice of Yahweh God walking in the garden, in the cool of the day, and they, the man and his wife, hid from Yahweh God among the trees of the garden."
,"9":"Yahweh God called the man saying to him, 'Where are you?'"
,"10":"He said, 'I heard your voice in the garden and I was afraid because I was naked, so I hid.'"
,"11":"God said, 'Who told you that you were naked? Have you eaten of the tree I ordered you not to eat?'"
,"12":"The man answered, 'The woman you put with me gave me fruit from the tree and I ate it.'"
,"13":"God said to the woman, 'What have you done?' The woman said, 'The serpent deceived me and I ate.'"
,"14":"Yahweh God said to the serpent, 'Since you have done that, be cursed among all the cattle and wild beasts! You will crawl on your belly and eat dust all the days of your life."
,"15":"I will make you enemies, you and the woman, your offspring and her offspring. He will crush your head and you will strike his heel.'"
,"16":"To the woman, God said, 'I will increase your suffering in childbearing, and you will give birth to your children in pain. You will be dependent on your husband and he will lord it over you.'"
,"17":"To the man, He said, 'Because you have listened to your wife, and have eaten from the tree of which I forbade you to eat, cursed be the soil because of you! In suffering you will provide food for yourself from it, all the days of your life."
,"18":"It will produce thorn and thistle for you and you will eat the plants of the field."
,"19":"With sweat on your face you will eat your bread, until you return to clay, since it was from clay that you were taken, for you are dust and to dust you shall return.'"
,"20":"The man called his wife by the name of Eve, because she was the mother of all the living."
,"21":"Yahweh God made garments of skin for the man and his wife, and with these he clothed them."
,"22":"Then Yahweh God said, 'Man has now become like one of us, making himself judge of good and evil. Let him not stretch out his hand to take and eat from the tree of Life as well, and live forever.'"
,"23":"So God cast him from the garden of Eden to till the soil from which he had been made."
,"24":"And after having driven the man out, God posted cherubim and a flaming sword that kept turning at the east of the garden of Eden to guard the way to the tree of Life."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Adam had intercourse with Eve his wife; she became pregnant and gave birth to a child. She named him Cain, for she said, 'I have got a man with help from Yahweh.'"
,"2":"She later gave birth to Abel, his brother. Abel was a shepherd and kept flocks, and Cain tilled the soil."
,"3":"It happened after a time that Cain brought fruits of the soil as an offering to Yahweh."
,"4":"Abel for his part brought the firstborn of his flock, and some fat as well. Now Yahweh was well pleased with Abel and his offering,"
,"5":"but towards Cain and his offering he showed no pleasure. This made Cain very angry and downcast."
,"6":"Then Yahweh said to Cain, 'Why are you angry and downcast?"
,"7":"If you do right, why do you not look up? But if you are not doing what is right, sin is lurking at the door. It is striving to get you, but you must control it.'"
,"8":"Cain said to his brother Abel, 'Let's go to the fields.' Once there, Cain turned on his brother Abel and killed him."
,"9":"Yahweh said to Cain, 'Where is your brother, Abel?' He answered, 'I don't know; am I my brother's keeper?'"
,"10":"Yahweh asked, 'What have you done? Your brother's blood cries out to me from the ground."
,"11":"Now be cursed and driven from the ground that has opened its mouth to receive your brother's blood that your hand has shed."
,"12":"When you till the soil, it will no longer yield you its produce. You will be a fugitive wandering on the earth.'"
,"13":"Cain said to Yahweh, 'My punishment is greater than I can bear."
,"14":"See! Today you drive me from this land. I must hide from you and be a wanderer and a fugitive on the earth, and it will so happen that whoever meets me will kill me.'"
,"15":"Yahweh said to him, 'Well then, whoever kills Cain, will suffer vengeance seven times.' And Yahweh put a mark on Cain to prevent anyone who met him from killing him."
,"16":"Cain then went from Yahweh's presence and settled in the land of Nod, to the east of Eden."
,"17":"Cain had intercourse with his wife; she conceived and gave birth to Enoch. As he was building a town, he called it by the name of his son, Enoch."
,"18":"A son, Irad, was born to Enoch. Irad became father of Mehujael, and Mehujael of Methuael, and Methuael of Lamech."
,"19":"Lamech had two wives, Adah and Zillah."
,"20":"Adah gave birth to Jabel: he was father to those who live in tents and keep flocks."
,"21":"His brother was Jubal: he was father to all those who play the lyre and flute."
,"22":"As for Zillah, she gave birth to Tubal-Cain, forger of all tools in bronze and iron. The sister of Tubal-Cain was Naamah."
,"23":"Lamech said to his wives: 'Adah and Zillah, hear my voice; wives of Lamech, listen to what I say, for I killed a man for wounding me,and a boy for striking me."
,"24":"If Cain will be avenged seven times, then Lamech seventy-seven times.'"
,"25":"Adam again had intercourse with his wife and she gave birth to a son and named him Seth; for she said, 'Yahweh has given me another child in place of Abel since Cain killed him.'"
,"26":"To Seth also a son was born and he called him Enosh. At that time people began to call on the name of Yahweh."
}`)
	CurrentBook.AddChapter(5, `{
"1":"This is the account of Adam's descendants. When God created Adam he made him in the likeness of God;"
,"2":"male and female he created them; he blessed them and called them Man on the day they were created."
,"3":"Adam was a hundred and thirty years old when he became father of a son born in his own likeness, in his own image; and he named him Seth."
,"4":"After the birth of Seth, Adam lived for eight hundred years and had other sons and daughters."
,"5":"Altogether Adam lived nine hundred and thirty years; then he died."
,"6":"When Seth was a hundred and five, he became father of Enosh."
,"7":"After the birth of Enosh, Seth lived eight hundred and seven years. He had other sons and daughters."
,"8":"Altogether Seth lived nine hundred and twelve years; then he died."
,"9":"When Enosh was ninety years old, he became the father of Kenan."
,"10":"After the birth of Kenan, Enosh lived eight hundred and fifteen years, and he had other sons and daughters."
,"11":"Altogether Enosh lived nine hundred and five years; then he died."
,"12":"When Kenan was seventy years old, he became father of Mahalalel."
,"13":"After the birth of Mahalalel, Kenan lived eight hundred and forty years, and he had other sons and daughters."
,"14":"Altogether Kenan lived nine hundred and ten years; then he died."
,"15":"When Mahalalel was sixty-five, he became the father of Jared."
,"16":"After that, Mahalalel lived eight hundred and thirty years, and had other sons and daughters."
,"17":"All the days of Mahalalel were eight hundred and ninety-five years; then he died."
,"18":"When Jared was a hundred and sixty-two, he became father of Enoch."
,"19":"After the birth of Enoch, Jared lived eight hundred years, and he had other sons and daughters."
,"20":"Altogether Jared lived nine hundred and sixty-two years; then he died."
,"21":"When Enoch was sixty-five, he became father of Methuselah."
,"22":"After the birth of Methuselah, Enoch walked with God three hundred years, and he had other sons and daughters."
,"23":"In all Enoch lived three hundred and sixty-five years."
,"24":"After Enoch had walked with God, he disappeared because God took him up."
,"25":"When Methuselah was a hundred and eighty-seven, he became father of Lamech."
,"26":"After the birth of Lamech, Methuselah lived seven hundred and eighty-two years, and he had other sons and daughters."
,"27":"In all Methuselah lived nine hundred and sixty-nine years; then he died."
,"28":"Lamech was a hundred and eighty-two when he became father of a son"
,"29":"and named him Noah, for he said, 'He will console us in the hard toil and suffering of our hands, because of the soil that was cursed by Yahweh."
,"30":"After the birth of Noah, Lamech lived five hundred and ninety-five years, and he had other sons and daughters."
,"31":"In all Lamech lived seven hundred and seventy-seven years; then he died."
,"32":"When Noah was five hundred years old, he became the father of Sem, Ham and Japheth."
}`)
	CurrentBook.AddChapter(6, `{
"1":"When people began to increase on the earth and daughters were born to them,"
,"2":"the sons of God saw that men's daughters were very beautiful, so they married those they chose."
,"3":"Yahweh then said, 'My spirit will not remain in man forever, for he is flesh. His span of life will be one hundred and twenty years.'"
,"4":"At that time there were giants on the earth, and afterwards as well, when the sons of God went to the daughters of men and had children by them. These were the heroes of old, men of renown."
,"5":"Yahweh saw how great was the wickedness of man on the earth and that evil was always the only thought of his heart."
,"6":"Yahweh regretted having created man on the earth and his heart grieved."
,"7":"He said, 'I will destroy man whom I created and blot him out from the face of the earth, as well as the beasts, creeping creatures and birds, for I am sorry I made them.'"
,"8":"But Noah was pleasing to God."
,"9":"This is the story of Noah. Noah was a just man, blameless among the people of his time, a man who walked with God."
,"10":"Noah became the father of three sons: Shem, Ham and Japheth."
,"11":"The earth became corrupt in God's sight and was full of violence."
,"12":"God saw the earth and saw it was corrupt, for corrupt, indeed, was the way of all mortals."
,"13":"Yahweh said to Noah, 'I have in mind to destroy all people, for the earth is filled with violence because of them. This is why I will destroy them and with them the earth."
,"14":"As for you, build an ark of cypress wood. You will make rooms in the ark and coat it with pitch inside and outside."
,"15":"This is the way you will do it: the length of the ark, four hundred and fifty feet; the width, seventy-five feet; the height, forty-five feet."
,"16":"You will put a roof on the ark and finish it within eighteen inches from the top. Put a door in the side of the ark and have lower, middle and upper decks."
,"17":"I am about to bring floodwaters on the earth to destroy the earth, to destroy all life under the heavens, every creature that has the breath of life. Everything on earth will perish,"
,"18":"but I will establish my covenant with you. You shall come into the ark, you, your wife, your sons and your sons' wives with you."
,"19":"You shall bring into the ark two of every kind of living thing, male and female, to keep them alive with you."
,"20":"Of the birds, the animals and all creeping things on the ground, according to their kind, two of every sort shall come in to be kept alive with you."
,"21":"Take with you every sort of food that is eaten. Make a store of it and it will be food for you and them.'"
,"22":"And Noah did all as God had commanded him."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Yahweh said to Noah, 'Go into the ark, you and all your household, for I see that you are just in this generation."
,"2":"Of all the clean animals, you are to take with you seven of each kind, male and female, and a pair of unclean animals, a male and a female."
,"3":"In the same way for the birds of the air, take seven and seven, male and female, to keep their kind alive over all the earth,"
,"4":"for in seven days I will send rain on the earth for forty days and forty nights. I will blot out from the face of the earth all the living creatures I have created.'"
,"5":"Noah did all as Yahweh had commanded."
,"6":"Noah was six hundred years old when the floodwaters covered the earth."
,"7":"So Noah went into the ark with his children, his wife and his sons' wives to escape the waters of the flood."
,"8":"Clean animals and also unclean, birds, and all that crawls on the earth went into the ark with Noah;"
,"9":"they went two and two, male and female, as God had commanded Noah."
,"10":"And after seven days the waters of the flood were over the earth."
,"11":"In the six hundredth year of Noah's life, in the second month and on the seventeenth day of the month, all the fountains of the great deep burst forth"
,"12":"and there was a downpour on the earth lasting forty days and forty nights."
,"13":"On that same day Noah went into the ark, as well as Shem, Ham and Japheth, his sons, and his wife and his daughters-in-law."
,"14":"All the animals according to their kind also entered into the ark, all the cattle, all the creeping things that crawl on the earth and all the birds according to their kind; all that flies and everything with wings."
,"15":"They came to Noah in the ark, two by two, all creatures that had the breath of life in them."
,"16":"And they that went in were male and female just as God had commanded. Then Yahweh closed the door on Noah. "
,"17":"The flood lasted for forty days on the earth. The waters rose and lifted the ark and raised it above the earth."
,"18":"The waters rose and increased greatly on the earth and the ark floated on the surface of the waters."
,"19":"The water rose more and more above the earth and all the high mountains under the heavens were submerged."
,"20":"The waters had risen and covered the mountains to a depth of more than twenty feet."
,"21":"Every living thing that moved on the earth died: birds, cattle, animals, everything that swarmed on the earth - and all humankind."
,"22":"All on the face of the earth that had the breath of life in its nostrils died."
,"23":"Every living being on the face of the earth, men and animals, and creatures that crawl and the birds of the air were wiped off the earth. Only Noah was left and those that were with him in the ark."
,"24":"The waters flooded the earth for one hundred and fifty days."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Then God remembered Noah and all the animals and cattle that were with him in the ark. God made a wind blow over the earth and the waters subsided."
,"2":"Then the fountains of the deep and the floodgates of the heavens were closed and the downpour from the heavens held back."
,"3":"The waters receded from the earth and after one hundred and fifty days the waters had abated."
,"4":"In the seventh month, in the seventeenth day of the month, the ark rested on Mount Ararat."
,"5":"The waters continued to recede until the tenth month. On the first day of the tenth month the mountain tops could be seen."
,"6":"At the end of the forty days Noah opened the window of the ark that he had built"
,"7":"and let the raven out. This went off and kept flying to and fro until the waters had dried up from the earth."
,"8":"Then Noah let out the dove to see if the waters were receding from the earth."
,"9":"But the dove could not find a place to set its foot and flew back to him in the ark for the waters still covered the surface of the whole earth. So Noah stretched out his hand, took hold of it and brought it back to himself in the ark."
,"10":"He waited some more days and again sent the dove out from the ark."
,"11":"This time the dove came back to him in the evening with a fresh olive branch in its beak. Then Noah knew the waters had receded from the earth. "
,"12":"He waited seven more days and let the dove loose, but it did not return to him any more."
,"13":"In the year six hundred and one, in the first month, on the first day of the month, the waters dried up from the earth. Noah then removed the covering from the ark and looked out and saw that the surface of the earth was dry."
,"14":"On the twenty-seventh day of the second month, the earth was dry."
,"15":"Then God said to Noah,"
,"16":"'Come out of the ark, you and your wife, your sons and their wives with you."
,"17":"Bring out with you all flesh, that is, all the animals who are with you, all things of flesh; birds, cattle and all that crawls on the earth. Let them abound on the earth, be fruitful and increase in number.'"
,"18":"So Noah went out, with his sons, his wife and his sons' wives with him."
,"19":"All the animals, all the birds, all that creeps on the earth, came out of the ark, one kind after another."
,"20":"Noah built an altar to Yahweh and, taking some of all the clean animals and all the clean birds, he offered burnt offerings on it."
,"21":"Yahweh smelled the pleasing aroma and said to himself: 'Never again will I curse the earth because of man, even though his heart is set on evil from childhood; never again will I strike down every living creature as I have done."
,"22":"As long as the earth lasts, seedtime and harvest, cold and heat, summer and winter, day and night, shall not cease to be.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"God blessed Noah and his sons and he said to them, 'Be fruitful, multiply and fill the earth."
,"2":"Fear and dread of you will be in all the animals of the earth and in all the birds of the air, upon everything that creeps on the ground and all the fish of the sea. They are given to you."
,"3":"Everything that moves and lives shall be food for you; as I gave you the green plants, I have now given you everything."
,"4":"Only you shall not eat flesh with its life, that is its blood."
,"5":"But I will also demand a reckoning for your lifeblood. I will demand it from every animal; and from man, too, I will demand a reckoning for the life of his fellow man."
,"6":"He who sheds the blood of man shall have his blood shed by man; for in the image of God has God made man."
,"7":"As for you, be fruitful and increase. Abound on the earth and be master of it.'"
,"8":"God spoke to Noah and his son,"
,"9":"'See I am making a covenant with you and with your descendants after you;"
,"10":"also with every living animal with you: birds, cattle, that is, with every living creature of the earth that came out of the ark."
,"11":"I establish my covenant with you. Never again will all life be cut off by the waters of a flood, and never again will there be a flood to destroy the earth.'"
,"12":"God said, 'This is the sign of the covenant I make between me and you, and every animal living with you for all future generations."
,"13":"I set my bow in the clouds and it will be a sign of the covenant between me and the earth."
,"14":"When I bring clouds over the earth and the rainbow appears in the clouds,"
,"15":"I will remember the covenant between me and you and every kind of living creature, so that never again will floodwaters destroy all flesh."
,"16":"When the rainbow is in the clouds, I will see it and remember the everlasting covenant between God and every living creature of every kind that exists on the earth.'"
,"17":"God said to Noah, 'This is the sign of the covenant I have made between me and all that has life on the earth.'"
,"18":"The sons of Noah who came out of the ark were Shem, Ham and Japheth. Ham is the ancestor of Canaan."
,"19":"These were Noah's three sons and from them the whole earth was peopled."
,"20":"Noah, a man of the soil, set about planting a vineyard."
,"21":"He drank the wine, became drunk, and lay uncovered in the middle of his tent."
,"22":"When Ham, Canaan's ancestor, saw his father's nakedness, he told his two brothers outside the tent."
,"23":"But Shem and Japheth took a cloak, put it on their shoulders, the two of them, then walked backwards and covered their father's nakedness. Their faces were turned away and they did not see their father's nakedness."
,"24":"When Noah awoke from his wine he knew what his youngest son had done to him."
,"25":"And he said, 'Cursed be Canaan! He shall be his brothers' meanest slave!'"
,"26":"He then added: 'Blessed be Yahweh, God of Shem, let Canaan be his slave!"
,"27":"May God extend (the territory of) Japheth, and may he live in the tents of Shem! And may Canaan be his slave!'"
,"28":"Noah lived three hundred and fifty years after the flood."
,"29":"In all Noah lived for nine hundred and fifty years. Then he died."
}`)
	CurrentBook.AddChapter(10, `{
"1":"These are the descendants of Noah's sons. Shem, Ham and Japheth; these are their sons who were born after the flood."
,"2":"Japheth's sons: Gomer, Magog, the Medes, Javan, Tubal, Meshech, Tiras."
,"3":"Gomer's sons: Ashkenaz, Riphath, Togarmah."
,"4":"Javan's sons: Elishah, Tarshish, the Kittim, the Dananites."
,"5":"These were dispersed and peopled the islands of the nations. These were Japheth's sons, according to their countries and each of their languages, according to their tribes and their nations."
,"6":"Ham's sons: Cush, Misraim, Put, Canaan."
,"7":"Cush's sons: Seba, Havilah, Sabtah, Raamah, Sabteca. Raamah's sons: Sheba, Dedan."
,"8":"Cush became the father of Nimrod who was the first great ruler on earth."
,"9":"He was a mighty hunter in the eyes of Yahweh, hence the saying, 'Like Nimrod, a mighty hunter in the eyes of Yahweh.'"
,"10":"The beginning of his empire was Babel, with Erech and Accad, all of them in the land of Shinar."
,"11":"From this country came Ashur, the builder of Niniveh, Rehoboth-ir, Calah,"
,"12":"and Resen between Niniveh and Calah (this is the great city)."
,"13":"Misraim became the father of the people of Lud, of Anam, Lehab, Naphtuh,"
,"14":"Pathros, Cusluh and Capthor, from which the Philistines came."
,"15":"Canaan became the father of Sidon, his firstborn, the Hittites,"
,"16":"and the Jebusites, the Amorites, Girgashites,"
,"17":"Hivites, Arkites, Sinites,"
,"18":"Arvadites, Zemarites, Hamathites; later the Canaanite tribes scattered."
,"19":"The Canaanite frontier stretched from Sidon in the direction of Sodom, Gomorrah, Admah and Zeboim, and as far as Lesha."
,"20":"These were Ham's sons, according to their tribes and languages, according to their countries and nations."
,"21":"There were also children born to Shem, the ancestor of all the sons of Eber, who are the Hebrews, and the elder brother of Japheth."
,"22":"Shem's sons: Elam, Asshur, Arpachshad, Lud, Aram."
,"23":"Aram's sons: Uz, Hul, Gether and Mash."
,"24":"Arpachshad became the father of Shelah, and Shelah became the father of Eber."
,"25":"To Eber were born two sons: the first was called Peleg, because it was in his time that the earth was divided; and his brother was called Joktan."
,"26":"Joktan became the father of Almodad, Sheleph, Hazarmaveth, Jerah,"
,"27":"Hadoram, Uzal, Diklah,"
,"28":"Obal, Abimael, Sheba,"
,"29":"Ophir, Havilah, Jobab; all these are sons of Joktan."
,"30":"They occupied a stretch of country from Mesh in the direction of Sephar, to the eastern mountain range."
,"31":"These were Shem's sons, according to their tribes and languages, and according to their countries and nations."
,"32":"These were the tribes of Noah's sons, according to their descendants and their nations. From these came the dispersal of the nations over the earth, after the flood."
}`)
	CurrentBook.AddChapter(11, `{
"1":"The whole world had one language and a common speech."
,"2":"As people moved from east, they found a plain in the country of Shinar where they settled."
,"3":"They said to one another, 'Come, let us make bricks and bake them in fire.' They used brick for stone and bitumen for mortar."
,"4":"They said also, 'Come, let us build ourselves a city and a tower with its top reaching heaven; so that we may become a great people and not be scattered over the face of the earth!'"
,"5":"Yahweh came down to see the city and the tower that the sons of man were building,"
,"6":"and Yahweh said, 'They are one people and they have one language. If they carry this through, nothing they decide to do from now on will be impossible."
,"7":"Come! Let us go down and confuse their language so that they will no longer understand each other.'"
,"8":"So Yahweh scattered them over all the earth and they stopped building the city."
,"9":"That is why it was called Babel, because there Yahweh confused the language of the whole earth and from there Yahweh scattered them over the whole face of the earth."
,"10":"These are Shem's descendants: When Shem was a hundred years old he became the father of Arpachshad, two years after the flood. After the birth of Arpachshad, "
,"11":"Shem lived five hundred years and he had more sons and daughters."
,"12":"When Arpachshad was thirty-five years old he became the father of Shelah."
,"13":"After the birth of Shelah, Arpachshad lived four hundred and three years and he had more sons and daughters."
,"14":"When Shelah was thirty years old he became the father of Eber. After the birth of Eber,"
,"15":"Shelah lived four hundred and three years and he had more sons and daughters."
,"16":"When Eber was thirty-four years old he became the father of Peleg. After the birth of Peleg,"
,"17":"Eber lived four hundred and thirty years and he had more sons and daughters."
,"18":"When Peleg was thirty years old he became the father of Reu;"
,"19":"Peleg lived two hundred and nine years and he had more sons and daughters."
,"20":"When Reu was thirty-two years old he became the father of Serug;"
,"21":"Reu lived two hundred and seven years and he had more sons and daughters."
,"22":"When Serug was thirty years old he became the father of Nahor. After the birth of Nahor,"
,"23":"Serug lived two hundred years and he had more sons and daughters."
,"24":"When Nahor was twenty-nine years old he became the father of Terah. After the birth of Terah,"
,"25":"Nahor lived a hundred and nineteen years and he had more sons and daughters."
,"26":"When Terah was seventy years old he became the father of Abram, Nahor and Haran."
,"27":"These are Terah's descendants: Terah became the father of Abram, Nahor and Haran. Haran became the father of Lot."
,"28":"Haran died before his father Terah in his native land, Ur of the Chaldeans."
,"29":"Abram and Nahor both married: Abram's wife was called Sarai; Nahor's wife was called Milcah, the daughter of Haran, father of Milcah and Iscah."
,"30":"Sarai was barren, having no child."
,"31":"Terah took his son Abram, his grandson Lot, the son of Haran, and his daughter-in-law, the wife of Abram, and made them leave Ur of the Chaldeans to go to the land of Canaan. But on arrival in Haran they settled there."
,"32":"Terah lived two hundred and five years; then he died in Haran."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Yahweh said to Abram, 'Leave your country, your family and your father's house, for the land I will show you."
,"2":"I will make you a great nation. I will bless you and make your name great, and you will be a blessing."
,"3":"I will bless those who bless you, and whoever curses you, I will curse, and in you all peoples of the earth will be blessed.'"
,"4":"So Abram went as Yahweh had told him, and Lot went with him. Abram was seventy-five years old when he left Haran. "
,"5":"Abram took Sarai, his wife, his nephew Lot, all the possessions they had accumulated and the people they had acquired in Haran. They set out for the land of Canaan. They arrived at Canaan. "
,"6":"Abram traveled through the country as far as Shechem, to the oak of Moreh. At that time the Canaanites were in the land."
,"7":"Yahweh appeared to Abram and said, 'To your descendants I will give this land.' There he built an altar to Yahweh who had appeared to him."
,"8":"From there he went on to the mountains east of Bethel and pitched his tent, with Bethel to the west and Ai to the east. There also he built an altar to Yahweh and called on the name of Yahweh."
,"9":"Then Abram set out in the direction of Negeb."
,"10":"There was famine in the land, and Abram went down to Egypt to stay there for some time, for the famine was severe in the land."
,"11":"Just as he was about to enter Egypt he said to Sarai, his wife, 'Now I know you are a beautiful woman."
,"12":"When the Egyptians see you they will say: 'That is his wife!' They will then kill me, but they will let you live."
,"13":"Say that you are my sister, so that they treat me well on account of you and my life be spared because of you.'"
,"14":"In fact, when Abram arrived in Egypt, the Egyptians saw that the woman was very beautiful."
,"15":"Pharaoh's officials saw her and praised her to Pharaoh. The woman was taken into Pharaoh's house"
,"16":"and because of her he dealt well with Abram; he received sheep, cattle, donkeys, menservants, maidservants, she-asses and camels."
,"17":"But Yahweh inflicted severe plagues on Pharaoh and his household because of Sarai."
,"18":"So Pharaoh summoned Abram and said, 'What have you done to me?"
,"19":"Why did you say: 'She's my sister,' so that I took her for my wife. Now, here is your wife! Take her and go!'"
,"20":"And Pharaoh gave orders to his men regarding Abram, and they sent him on his way, with his wife and all that was his."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Abram went up from Egypt to the Negeb, he and his wife, with all he had and Lot with him."
,"2":"Now Abram was very rich in flocks, silver and gold."
,"3":"As he journeyed on, he went from the Negeb as far as Bethel, to the place where he first pitched his tent between Bethel and Ai"
,"4":"at the spot where he had formerly made an altar and called on the Name of Yahweh."
,"5":"Lot who went with Abram also had flocks, cattle and tents."
,"6":"The land was not sufficient to allow them to stay together, for their possessions were too great for them to live together."
,"7":"A quarrel arose between the herdsmen of Abram's flock and those of Lot. (The Canaanites and the Perizzites were living in the land at the time.)"
,"8":"Abram said to Lot, 'Don't let there be a dispute between you and me, nor between my herdsmen and yours, since we are brothers!"
,"9":"Isn't the whole land there before you? Let us part company. If you go to the left, I will go to the right; if you go to the right, I will go to the left.'"
,"10":"Lot looked up and saw the whole valley of the Jordan: how well it was watered! Before Yahweh destroyed Sodom and Gomorrah, this was like one of Yahweh's gardens, like the country of Egypt, on coming to Zoar."
,"11":"Lot chose for himself all the Jordan valley and journeyed eastward. In this way they separated from each other."
,"12":"Abram settled in the country of Canaan while Lot lived among the towns of the plain and moved his tent as far as Sodom."
,"13":"Now the men of Sodom were wicked, sinning greatly against Yahweh."
,"14":"Yahweh said to Abram after Lot had left him, 'Raise your eyes and look from where you are, towards the north, the south, the east and the west;"
,"15":"all the land you see I will give to you and your descendants forever."
,"16":"I will make your descendants as the dust of the earth; if the grains of the dust can be counted, then your descendants may be counted."
,"17":"Come, travel through the length and breadth of the land, for it is to you that I am giving it.'"
,"18":"So Abram moved his tent and came to live by the oak of Mamre at Hebron. There he built an altar to Yahweh."
}`)
	CurrentBook.AddChapter(14, `{
"1":"At the time of Amraphel king of Shinar, Arioch king of Ellasar, Chedorlaomer king of Elam, and Tidal king of Goiim,"
,"2":"these kings made war on Bera king of Sodom, Birsha king of Gomorrah, Shinab king of Admah, Shemeber king of Zeboiim and the king of Bela (that is, Zoar)."
,"3":"All these joined forces in the valley of Siddim (that is the Salt Sea)."
,"4":"Twelve years they had been dominated by Chedorlaomer, but in the thirteenth year they rebelled."
,"5":"In the fourteenth year, Chedorlaomer and the king who were his allies, came and fought and subdued the Rephaim in Ashteroth-karnaim, the Zuzim in Ham, the Emin in Shaveh-kiriathaim"
,"6":"and the Horites in their Mount Seir as far as Elparan which is near the desert."
,"7":"They then turned back and came to the Spring of Judgment (that is, Kadesh) and subdued all the country of the Amalekites, as well as that of the Amorites who lived in Hazazontamar."
,"8":"Then the king of Sodom, the king of Gomorrah, the king of Admah, the king of Zeboiim and the king of Bela (that is, Zoar) went out and took up battle positions in the valley of Siddim"
,"9":"against Chedorlaomer king of Elam, Tidal king of Goiim, Amraphel king of Shinar and Arioch king of Ellasar; four kings against five."
,"10":"Now there were many bitumen pits in the valley of Siddim, and as the kings of Sodom and Gomorrah fled, some fell into them and the rest took refuge in the mountains."
,"11":"The enemy took all the possessions of Sodom and Gomorrah, all their provisions and went off."
,"12":"They also took Lot, the son of Abram's brother, who lived in Sodom, and his possessions and went off."
,"13":"One who escaped came to tell Abram the Hebrew, who was living by the oak of Mamre the Amorite, the brother of Eshcol and of Aner: these were allies of Abram."
,"14":"As soon as Abram heard that his brother had been taken away captive, he assembled and led forth his trained men born in his house, three hundred and eighteen men and set off in pursuit as far as Dan."
,"15":"He grouped his forces against them by night, he and his servants, and routed and followed them to Hobah, north of Damascus."
,"16":"Then he brought back all his possessions, his kinsman Lot and his possessions, together with the women and the people."
,"17":"On his return after defeating Chedorlaomer and the kings who were his allies, the king of Sodom came out to meet him in the valley of Shaveh (that is the Valley of the King)."
,"18":"Then Melchizedek, king of Salem, brought bread and wine; he was a priest of God Most High,"
,"19":"and he blessed Abram saying, 'Blessed be Abram by God Most High, maker of heaven and earth!"
,"20":"And blessed be God Most High who has delivered your enemies into your hands!',And Abram gave him a tenth part of everything."
,"21":"The king of Sodom said to Abram, 'Give me the people and keep the goods for yourself.'"
,"22":"Abram said to the king of Sodom, 'I raise my hand to Yahweh God Most High, creator of heaven and earth, to swear"
,"23":"that not one thread or thong of a sandal, or anything that is yours, would I take. Lest you say, 'Abram became rich at my expense,'"
,"24":"I claim nothing for myself! Only what the young men have eaten and the share that is due to Aner, Eshcol and Mamre, the men who came with me.'"
}`)
	CurrentBook.AddChapter(15, `{
"1":"After this the word of Yahweh was spoken to Abram in a vision: 'Do not be afraid, Abram, I am your shield; your reward will be very great!'"
,"2":"Abram said, 'My Lord Yahweh, where are your promises? I am still childless and all I have will go to Eliezer of Damascus."
,"3":"You have given me no children, so a slave of mine will be my heir.'"
,"4":"Then the word of Yahweh was spoken to him again, 'Eliezer will not be your heir, but a child born of you (your own flesh and blood) will be your heir.'"
,"5":"Then Yahweh brought him outside and said to him, 'Look up at the sky and count the stars if you can. Your descendants will be like that.'"
,"6":"Abram believed Yahweh who, because of this, held him to be an upright man."
,"7":"And he said, 'I am Yahweh who brought you from Ur of the Chaldeans to give you this land as your possession.'"
,"8":"Then Abram asked, 'My Lord, how am I to know that it shall be mine?'"
,"9":"Yahweh replied, 'Bring me a three-year-old heifer, a three-year-old goat, a three-year-old ram, a turtle dove and a young pigeon.'"
,"10":"Abram brought all these animals, cut them in two, and laid each half facing its other half, but he did not cut the birds in half."
,"11":"The birds of prey came down upon them, but Abram drove them away."
,"12":"As the sun was going down, a deep sleep came over Abram, and a dreadful darkness took hold of him."
,"13":"Then Yahweh said to Abram, 'Know for certain that your descendants will be exiles in a land that is not theirs. They will be slaves there, oppressed for four hundred years."
,"14":"But I will judge the nation that oppresses them, and after that, they will not leave empty-handed."
,"15":"As for yourself, you shall go to your fathers in peace, and be buried at a ripe old age."
,"16":"Your descendants of the fourth generation will come back here, for the wickedness of the Amorites has not yet deserved that I take the land from them.'"
,"17":"When the sun had set and darkness had fallen, a smoking firepot and a flaming torch passed between the halves of the victims."
,"18":"On that day Yahweh made a covenant with Abram, saying, 'To your descendants I have given this country from the river of Egypt to the Great River, the Euphrates."
,"19":"The land of the Kenites, the Kenizzites, the Kadmonites,"
,"20":"the Hittites, the Perizzites, the Rephraim,"
,"21":"the Amorites, the Canaanites, the Girgashites and the Jebusites.'"
}`)
	CurrentBook.AddChapter(16, `{
"1":"Sarai, Abram's wife had not borne him a child, but she had an Egyptian servant named Hagar,"
,"2":"and she said to Abram, 'Now, since Yahweh has kept me from having children, go to my servant; perhaps I shall have a child by her.' Abram agreed to what Sarai said."
,"3":"Abram had been in the land of Canaan ten years when Sarai, his wife, took Hagar, her Egyptian maid, and gave her to Abram her husband as wife."
,"4":"He went in to Hagar and she became pregnant. When she was aware of this, she began to despise her mistress. "
,"5":"Sarai said to Abram, 'May this injury done to me be yours. I put my servant in your arms and now that she knows she is pregnant, I count for nothing in her eyes. Let Yahweh judge between me and you.'"
,"6":"Abram said to Sarai, 'Your servant is in your power; do with her as you please.' Then Sarai treated her so badly that she ran away."
,"7":"The angel of Yahweh found her near a spring in the wilderness"
,"8":"and said to her, 'Hagar, servant of Sarai, where have you come from and where are you going?' She said, 'I'm running away from Sarai, my mistress.'"
,"9":"The angel of Yahweh said to her, 'Go back to your mistress and humbly submit yourself to her.'"
,"10":"The angel of Yahweh said to her, 'I will so increase your descendants, that they will be too numerous to be counted.'"
,"11":"Then the angel of Yahweh said to her, 'Now you are with child and you will have a son, and you shall name him Ishmael, for Yahweh has heard your distress."
,"12":"He shall be a wild ass of a man, his hand against everyone and everyone's hand against him, defiant towards all his brothers.'"
,"13":"Hagar gave to Yahweh who spoke to her the name of El Roi, for she said: 'I have seen the One who sees me.'"
,"14":"That is why this well is called the well of Lahai-roi. It is between Kadesh and Bered."
,"15":"Hagar gave birth to a son and Abram called the child Hagar bore him, Ishmael."
,"16":"Abram was eighty-six years old when Hagar gave birth to Ishmael."
}`)
	CurrentBook.AddChapter(17, `{
"1":"When Abram was ninety-nine years old, Yahweh appeared to him and said, 'I am God Almighty. Walk in my presence and be without blame!"
,"2":"I will make a covenant between myself and you, and I will multiply your race.'"
,"3":"Abram fell face down and God said to him,"
,"4":"'This is my covenant with you: you will be the father of a multitude of nations."
,"5":"No longer will you be called Abram, but Abraham, because I will make you the father of a multitude of nations."
,"6":"I will make you more and more famous; I will multiply your descendants; nations shall spring from you, kings shall be among your descendants."
,"7":"And I will establish a covenant, an everlasting covenant between myself and you and your descendants after you; from now on I will be your God and the God of your descendants after you, for generations to come."
,"8":"I will give to you and your descendants after you the land you are living in, all the land of Canaan, as an everlasting possession and I will be the God of your race.'"
,"9":"God said to Abraham, 'For your part, you shall keep my covenant, you and your descendants after you, generation after generation."
,"10":"This is my covenant with you, that you will keep, you and your descendants after you: Every male among you shall be circumcised;"
,"11":"you shall circumcise your foreskin and that will be the sign of the covenant between me and you."
,"12":"When he is eight days old, every male among you will be circumcised, generation after generation;"
,"13":"those born in your household or bought from a foreigner to be slaves. Whether born in your household or bought to be slaves, they must be circumcised. So my covenant will be written in your flesh as an everlasting covenant."
,"14":"Any uncircumcised male, who has not been circumcised in the flesh, will be cut off from his people for having broken my covenant.'"
,"15":"God said to Abraham, 'As for Sarai, your wife, no longer are you to call her Sarai, but Sarah."
,"16":"I will bless her, and I will give you a son by her. I will bless her and from her will come nations; kings and peoples shall come from her.'"
,"17":"Then Abraham fell face down, and he laughed and said to himself, 'Will a son be born to a man a hundred years old? And can Sarah who is ninety have a child?'"
,"18":"And Abraham said to God, 'If only you would accept Ishmael as yours!'"
,"19":"But God said, 'Not at all! It is Sarah, your wife, who will give birth to your son and you will name him Isaac. I will establish my covenant with him and his descendants after him forever."
,"20":"As for Ishmael, I heard you. I will bless him and make him fruitful, and I will multiply his race. He shall be the father of twelve princes and I will make of him a great nation."
,"21":"But my covenant I will establish with Isaac, the child Sarah will have this time next year.'"
,"22":"When he had finished speaking with Abraham, God went away from him."
,"23":"Abraham then took Ishmael, his son, as well as all those born in his house and all those he had bought to be slaves, all the males in the household of Abraham, and circumcised their foreskins that same day as God had told him."
,"24":"Abraham was ninety-nine years old when he was circumcised,"
,"25":"and his son, Ishmael, was thirteen."
,"26":"Abraham and his son Ishmael were both circumcised that same day."
,"27":"And every male in his household, whether born in his household or bought with money from a foreigner, was circumcised with him."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Yahweh appeared to Abraham near the oak of Mamre. Abraham was sitting at the entrance to his tent, in the heat of the day,"
,"2":"when he looked up and saw three men standing nearby. When he saw them he ran from the entrance of the tent to meet them. He bowed to the ground"
,"3":"and said, 'My Lord, if I have found favor in your sight, do not pass your servant by."
,"4":"Let a little water be brought. Wash your feet and then rest under the trees."
,"5":"I shall fetch some bread so that you can be refreshed and continue on your way, since you have come to your servant.' They then said, 'Do as you say.'"
,"6":"Abraham hurried into the tent to Sarah and said to her, 'Quick, take three measures of flour, knead it and make cakes.'"
,"7":"Abraham then ran to the herd, took a fine, tender calf, gave it to the servant who hurried to prepare it."
,"8":"He took butter and milk and together with the calf he had prepared laid it all before them. And while he remained standing, they ate."
,"9":"They then asked, 'Where is Sarah, your wife?' Abraham answered, 'She is in the tent.'"
,"10":"And the visitor said, 'At this same time next year I will return and Sarah by then will have a son.',Now Sarah was behind him, listening at the entrance to the tent. "
,"11":"Abraham and Sarah were old, well on in years, and Sarah no longer had her monthly periods."
,"12":"Sarah laughed to herself saying, 'Now that I am old and worn and my husband is an old man, am I to have this pleasure?'"
,"13":"Yahweh said to Abraham, 'Why did Sarah laugh, saying: 'Am I really going to have a child now that I am old?'"
,"14":"Is there anything that is impossible for God? At this same time next year I will return and Sarah by then will have a son.'"
,"15":"Sarah denied saying, 'I did not laugh,' for she was afraid. But he said, 'You did laugh.'"
,"16":"The men went away and turned towards Sodom. Abraham walked with them to set them on their way."
,"17":"And Yahweh said, 'Can I conceal from Abraham what I am about to do?"
,"18":"Abraham, in fact, is going to become a great and powerful nation and through him all the nations of the earth will be blessed,"
,"19":"for I have chosen him to command his sons and his household after him to keep the way of the Lord by doing what is right and just, so that Yahweh may bring about for Abraham what he has promised him.'"
,"20":"Then Yahweh said, 'How great is the cry for justice against Sodom and Gomorrah! And how grievous is their sin!"
,"21":"I am going down to see if they have done all that they are charged with in the outcry that has reached me. If it is not so, I will know.'"
,"22":"The men with him turned away and went towards Sodom, but Yahweh remained standing before Abraham."
,"23":"Abraham went forward and said, 'Will you really let the just perish with the wicked?"
,"24":"Perhaps there are fifty good people in the town. Are you really going to let them perish? Would you not spare the place for the sake of these fifty righteous people?"
,"25":"It would not be at all like you to do such a thing and you can't let the good perish with the wicked, nor treat the good and the wicked alike. Far be it from you! Will not the judge of all the earth be just?'"
,"26":"Yahweh said, 'If I find fifty good people in Sodom, I will spare the whole place for their sake.'"
,"27":"Abraham spoke up again, 'I know that I am very bold to speak like this to my Lord, I who am only dust and ashes!"
,"28":"But perhaps the number of the good is five less than fifty. Will you destroy the town because of five?' Yahweh replied, 'I will not destroy the town if I find forty-five good people there.'"
,"29":"Again Abraham said to him, 'Perhaps there will be only forty.' He answered, 'For the sake of forty I will not do it.'"
,"30":"Abraham went on, saying, 'May my Lord not be angry, but let me speak. Maybe only thirty good people will be found in the town.' Yahweh answered, 'I will not destroy it if I find thirty there.'"
,"31":"Abraham said, 'Now that I have been so bold as to speak to my Lord, what if only twenty can be found?' He said, 'For the sake of twenty I will not destroy the place.'"
,"32":"But Abraham insisted, 'May my Lord not be angry, but let me speak just once more. What if only ten can be found?' And Yahweh answered, 'For the sake of ten good people, I will not destroy Sodom.'"
,"33":"When Yahweh had finished speaking with Abraham, he left and Abraham went home."
}`)
	CurrentBook.AddChapter(19, `{
"1":"When the two angels reached Sodom in the evening, Lot was sitting at the gate of the town. As soon as he saw them, he rose to meet them, bowed with his face to the ground,"
,"2":"and said, 'My lords, I pray you come to your servant's house to stay the night. Wash your feet, and then in the morning you may rise early and go on your way.' They said, 'No, we will spend the night in the square.'"
,"3":"But so strongly did he insist that they went with him to his house; there he prepared a meal for them, baking bread without yeast. This they ate."
,"4":"They had not yet gone to bed when men from the town surrounded the house; they were the men of Sodom, young and old, the entire population."
,"5":"They called Lot and said to him, 'Where are the men who arrived here tonight? Send them out so that we may have sex with them.'"
,"6":"Lot went out to meet them, shut the door behind him and said,"
,"7":"'I beg you, my brothers, don't do such a wicked thing."
,"8":"I have two daughters who are still virgins; let me bring them out to you; you may do with them as you please, but don't do anything to these men, for they have come to shelter under my roof.'"
,"9":"But they replied, 'Get out of the way! This fellow is a foreigner and he wants to play the judge! Now we will do worse with you than with them.' They pressed hard against Lot and drew near in order to break the door."
,"10":"But the men inside the house stretched out their hands to bring Lot inside and then shut the door."
,"11":"As for those at the entrance to the house, they were struck with blindness, from the smallest to the largest, so that they were unable to find the door."
,"12":"The two men said to Lot, 'Who is still here with you? Your sons-in-law? Get them out of the place: your sons, your daughters and all your people in the town. We are about to destroy this place."
,"13":"The cry for retribution against it is great before Yahweh who has sent us to destroy it.'"
,"14":"Lot went out and spoke to his sons-in-law, those who were to marry his daughters, saying, 'Hurry, leave, for Yahweh is about to destroy the town.' But they took what he said as a joke."
,"15":"At daybreak the Angels urged Lot, saying, 'Hurry! Take your wife and two daughters who are here, lest they perish because of the sin of the town.'"
,"16":"As he hesitated, the men took him by the hand and his wife and two daughters with him, because Yahweh had mercy on him. And they led him outside the town."
,"17":"When they were outside, the men said to him, 'Flee for your life and don't look back and don't stop anywhere in the plain. Flee to the mountain lest you perish.'"
,"18":"But Lot replied, 'My lords, your servant has found favor with you,"
,"19":"and you have shown me great kindness in saving my life. But I cannot flee to the mountains for fear the disaster will overtake me and I die. See, there is a town near enough for me to flee to and it's a small one."
,"20":"Let me flee there: it is very small (that is why the town is called Zoar). So I will be safe.'"
,"21":"And the angel answered, 'I grant you this favor as well by not destroying the town you speak of."
,"22":"But flee fast for I can do nothing until you arrive there.'"
,"23":"The sun had risen on the earth when Lot reached Zoar."
,"24":"Then Yahweh rained on Sodom and Gomorrah burning sulphur out of the heavens from Yahweh,"
,"25":"and he completely destroyed those towns and all the valley and all the inhabitants of the towns and everything that grew there."
,"26":"Lot's wife looked back and she became a pillar of salt."
,"27":"Early next morning Abraham returned to the place where he had stood before Yahweh."
,"28":"He looked towards Sodom and Gomorrah and towards all the land of the valley and he saw smoke rising from the earth like the smoke from a furnace."
,"29":"So when God destroyed the towns of the plain he remembered Abraham and made Lot escape from the catastrophe while he destroyed the cities where Lot had lived."
,"30":"Lot went up from Zoar and lived in the hills with his two daughters, because he was afraid to live in Zoar. He lived in a cave, he and his two daughters."
,"31":"The elder said to the younger, 'Our father is old and there is not a man in the country to lie with us as is the custom all over the world."
,"32":"Come, let us make our father drunk with wine; we shall lie with him and have the race survive through our father.'"
,"33":"So they made their father drink wine that night and the elder went to lie with her father. He knew nothing of it, neither when she lay down nor when she left."
,"34":"The next day the elder daughter said to the younger, 'Last night I lay with my father. Let us give him wine again tonight and you go and lie with him. In this way we shall continue the race through our father.'"
,"35":"Again that night they got their father to drink wine. The younger went and lay with him. He was aware of nothing, neither when she lay with him nor when she left."
,"36":"And the two daughters of Lot became pregnant by their father."
,"37":"The elder gave birth to a son and named him Moab. He was the ancestor of the Moabites who live today."
,"38":"The younger, also gave birth to a son and named him Ben-ammi. He is the ancestor of the Ammonites who exist to this day."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Abraham left there for the territory of the Negeb, and lived between Kadesh and Shur; and he stayed for a time in Gerar."
,"2":"Abraham had said of his wife, 'She is my sister'; so Abimelech, king of Gerar, sent for Sarah and had her brought to him."
,"3":"But God came to Abimelech in a dream at night. He said to him, 'You are a dead man because of this woman you have taken, for she is a married woman.'"
,"4":"But Abimelech had not gone near her, so he said, 'My Lord, are you going to kill a pagan who acted with good intention?"
,"5":"Didn't he say to me: 'She is my sister'? And she said to me: 'He is my brother.' I acted in the simplicity of my heart and with innocent hands.'"
,"6":"God said to him in the dream, 'I knew that you did that in the simplicity of your heart and I prevented you from sinning against me. That is why I did not let you touch her."
,"7":"Now give the woman back to the man for he is a prophet; he will pray for you and you shall live. But if you do not give her back, know that you will surely die; you and all yours will die.'"
,"8":"So Abimelech rose early in the morning and called all his officials and told them all these things. The officials were terrified."
,"9":"Abimelech then called Abraham and said to him, 'What have you done to us? In what way have I wronged you, for you to bring against me and my kingdom such a grave sin? You have done to me things that should not be done.'"
,"10":"Abimelech said to Abraham, 'Why did you act as you did?'"
,"11":"Abraham said, 'I thought there is no fear of God at all in this place and they will kill me because of my wife."
,"12":"Yet it is true that she is my sister, the daughter of my father, but not of my mother, and she became my wife."
,"13":"So, when the gods made me wander far from my father's family, I said to her: Now, if you love me, I beg you to say that I am your brother wherever we go.'"
,"14":"Abimelech then brought sheep and cattle, male and female slaves and gave them to Abraham, and he had Sarah returned to her husband."
,"15":"And he told Abraham, 'See, you have the run of my land; live wherever you please.'"
,"16":"And to Sarah he said, 'I am giving your brother a thousand silver coins. It will be as a protection for you, and an evidence for all those who are with you. So none of them will think ill of you.'"
,"17":"Then Abraham prayed to God and God healed Abimelech, his wife and his servants, so that they were able to have children again."
,"18":"For Yahweh had made it impossible for Abimelech's wife and maids to have more children, because of Abraham's wife, Sarah."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Yahweh was kind to Sarah as he had said, and fulfilled his promise to her."
,"2":"Sarah became pregnant and bore a son to Abraham in his old age, at the very time Yahweh had promised."
,"3":"Abraham gave the name Isaac to the son that Sarah bore him"
,"4":"and circumcised him when he was eight days old, as Yahweh had commanded."
,"5":"Abraham was a hundred years old when his son Isaac was born to him."
,"6":"Sarah said, 'God has brought me laughter and everyone who hears of this will laugh with me.'"
,"7":"She added, 'Who would have told Abraham that Sarah would nurse children? Yet I have given birth to a son for him in his old age.'"
,"8":"The child grew and on the day Isaac was weaned, Abraham held a great feast."
,"9":"Sarah saw the child that Hagar, the Egyptian had borne to Abraham, mocking her son"
,"10":"and she said to Abraham, 'Send this slave girl and her son away; the child of this slave must not share the inheritance with my son, Isaac.'"
,"11":"This matter distressed Abraham because it concerned his son,"
,"12":"but God said to him, 'Don't be worried about the boy and your maidservant. Listen to Sarah and do whatever she says, because the race which is called by your name will spring from Isaac."
,"13":"But from the son of your servant I will also form a nation, for he too is your offspring.'"
,"14":"Abraham rose early next morning and gave bread and a skin bag of water to Hagar. He put the child on her back and sent her away. She went off and wandered in the desert of Beersheba."
,"15":"When there was no more water in the skin, she pushed the boy under one of the bushes,"
,"16":"and then went and sat down about a hundred yards away, for she thought, 'I cannot bear to see my son die.',But as she sat there, the child began to wail. "
,"17":"God heard him and the Angel of God called to Hagar from heaven and said, 'What is the matter, Hagar? Don't be afraid. God has heard the boy crying."
,"18":"Get up, pick the boy up and hold him safely, for I will make him into a great nation.'"
,"19":"God then opened her eyes and she saw a well of water. She went and filled the skin and gave the boy a drink."
,"20":"God was with the boy. He grew up and made his home in the wilderness and became an expert archer."
,"21":"He lived in the desert of Paran and his mother chose a wife for him from the land of Egypt."
,"22":"At that time Abimelech came with Phicol, the commander of his army, to speak to Abraham, 'God is with you in everything you do;"
,"23":"swear to me here before God that you will not deal falsely with me or my descendants, but instead you will show to me and the country where you are living the same kindness that I have shown to you.'"
,"24":"And Abraham said, 'Yes, this I swear.'"
,"25":"Then Abraham complained to Abimelech about a well that Abimelech's servants had seized."
,"26":"Abimelech said, 'I don't know who has done this; you did not tell me and I only heard about it today.'"
,"27":"Abraham then took sheep and cattle and gave them to Abimelech and the two men made a treaty."
,"28":"Abraham set aside seven ewe lambs from the flock."
,"29":"Abimelech said to him, 'Why have you put aside these seven ewe lambs?"
,"30":"Abraham replied, 'Accept these seven lambs from my hand as evidence that I dug this well.'"
,"31":"So the place was called Beersheba because the two men took an oath there."
,"32":"After making the treaty at Beersheba, Abimelech went away with Phicol, the commander of his army, and returned to the land of the Philistines."
,"33":"Abraham planted a tamarisk tree at Beersheba and there he called on Yahweh, the everlasting God."
,"34":"And Abraham stayed in the land of the Philistines for a long time."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Some time later God tested Abraham and said to him, 'Abraham!' And he answered, 'Here I am.'"
,"2":"Then God said, 'Take your son, your only son, Isaac, whom you love, and go to the land of Moriah and offer him there as a burnt offering on one of the mountains I shall point out to you.'"
,"3":"Abraham rose early next morning and saddled his donkey and took with him two of his young men and his son Isaac. He chopped wood for the burnt offering and set out for the place to which God had directed him."
,"4":"On the third day Abraham looked up and saw the place in the distance,"
,"5":"and he said to the young men, 'Stay here with the donkey. The boy and I will go over there to worship and then we will come back to you.'"
,"6":"Abraham took the wood for the burnt offering and laid it on Isaac his son. He carried in his hand the fire and the knife. As the two of them went on together,"
,"7":"Isaac spoke to Abraham, his father, 'Father!'"
,"8":"And Abraham replied, 'Yes, my son?' Isaac said, 'The fire and the wood are here, but where is the lamb for the sacrifice?' Abraham replied, 'God himself will provide the lamb for the sacrifice.',They went on, the two of them together, "
,"9":"until they came to the place to which God had directed them. When Abraham had built the altar and set the wood on it, he bound his son Isaac and laid him on the wood placed on the altar."
,"10":"He then stretched out his hand to seize the knife and slay his son."
,"11":"But the Angel of Yahweh called to him from heaven, 'Abraham! Abraham!',And he said, 'Here I am.' "
,"12":"'Do not lay your hand on the boy; do not harm him, for now I know that you fear God, and you have not held back from me your only son.'"
,"13":"Abraham looked around and saw behind him a ram caught by its horns in a bush. He offered it as a burnt offering in place of his son."
,"14":"Abraham named the place 'The Lord will provide.' And the saying has lasted to this day."
,"15":"And the Angel of Yahweh called from heaven a second time,"
,"16":"'By myself I have sworn, it is Yahweh who speaks, because you have done this and not held back your son, your only son,"
,"17":"I will surely bless you and make your descendants as numerous as the stars in the sky and the sand on the seashore. Your descendants will take possession of the lands of their enemies."
,"18":"All the nations of the earth will be blessed through your descendants because you have obeyed me.'"
,"19":"So Abraham returned to his servants, and they set off together for Beersheba and it was there that Abraham stayed."
,"20":"Some time after this Abraham was told that Milcah too, had borne children for Nahor, Abraham's brother:"
,"21":"Uz, the firstborn, Buz, his brother, Kemuel the father of Aram,"
,"22":"Chesed, Hazo, Pildash, Jidlaph and Bethuel."
,"23":"Bethuel became the father of Rebekah. These eight children Milcah gave Nahor, Abraham's brother."
,"24":"He also had a concubine, named Reumah, who gave birth to Tebah, Gaham, Tahash and Maacah."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Sarah lived a hundred and twenty-seven years."
,"2":"She died at Kiriatharba - that is Hebron - in the land of Canaan, and Abraham went in to weep and mourn for Sarah."
,"3":"Abraham left his dead one"
,"4":"and spoke to the Hittites, 'I am only a stranger among you; give me a burial place among you, so that I may bury my dead.'"
,"5":"The Hittites answered Abraham,"
,"6":"'Hear us, my lord. You are God's prince among us; bury your dead in the best of our tombs; none of us would refuse you a tomb to bury your dead.'"
,"7":"Abraham rose and bowed to the Hittites, the people of the land,"
,"8":"and then spoke to them, 'If you are willing that I bury my dead, hear me and plead with Ephron, the son of Zohar,"
,"9":"to give me the cave of Machpelah belonging to him; it is at the edge of his field. For the full price and in your presence, let him give it to me for a burial place.'"
,"10":"Now Ephron was there sitting among the Hittites, and he replied to Abraham in the hearing of all who were seated at the gate of the town,"
,"11":"'No, my lord, listen! I give you the field and I give you the cave in it. In the presence of the sons of my people, I give it to you. Bury your dead there.'"
,"12":"Abraham bowed before the people of the land and spoke to Ephron in the hearing of the people of the land,"
,"13":"'Ah, if only you will listen to me, I will give you the price of the land. Accept it from me that I may bury my dead there.'"
,"14":"Ephron replied to Abraham, 'My lord, hear me."
,"15":"Four hundred silver coins for a piece of land, is it not the right price for both of us? Bury your dead.'"
,"16":"Abraham agreed with Ephron and he weighed out for Ephron the silver he had insisted on in the hearing of the Hittites, four hundred silver coins, in merchants' coins."
,"17":"And so Ephron's field in Machpelah, to the east of Mamre, the field with the cave in it, and all the trees in the field, throughout its entire area,"
,"18":"was acquired by Abraham as his possession in the presence of the Hittites and of all who went in at the gate of their city."
,"19":"After this Abraham buried his wife Sarah in the cave of Machpelah."
,"20":"The unused field and the cave that is in it were given to Abraham as a possession for a burying place by the Hittites."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Abraham was now old and well on in years, and Yahweh had blessed him in every way."
,"2":"Abraham said to his senior servant, who was his steward, 'Put your hand under my thigh"
,"3":"and you will swear to me by Yahweh, God of heaven and earth, that you will not choose a wife for my son from the daughters of the Canaanites among whom we live;"
,"4":"rather it is to my country and my kinsfolk that you will go to choose a wife for my son, Isaac.'"
,"5":"The servant said to him, 'Perhaps the woman will not want to follow me to this country. In that case should I take your son to the country you came from?'"
,"6":"Abraham said to him, 'In no way will you take my son back."
,"7":"For Yahweh, God of heaven and God of earth, who took me from my father's house and from the land of my birth, spoke to me and swore to me that he would give this country to my race. He will send his angel before you, that you may find a wife for my son."
,"8":"But if the woman is unwilling to follow you, you will be free of this oath. In any case you are not to take my son down there.'"
,"9":"So the servant placed his hand under the thigh of Abraham, his master, and swore to him that he would do it."
,"10":"The servant took ten of his master's camels and set out, taking with him something of the best from all that his master owned. He rose and went off in the direction of Aram Naharaim, towards the town of Nahor."
,"11":"And he made the camels kneel outside the town, near the well, in the evening when the women go to draw water."
,"12":"The steward then prayed, 'Yahweh, God of my master Abraham, be with me and show your loving kindness to Abraham, my master."
,"13":"See, I am standing at the spring while the girls of the city are coming to draw water."
,"14":"Now I will ask them like this: 'Please tilt your pitcher that I may drink.' Now, the first girl who will say: 'Drink and I will water your camels as well'; let her be the one you have chosen for your servant Isaac. In this way I shall know you have shown kindness to my master.'"
,"15":"He had not finished praying when Rebekah came out. She was the daughter of Bethuel, son of Milcah, wife of Abraham's brother, Nahor. She had a pitcher on her shoulder."
,"16":"The girl was very beautiful and a virgin, for no man had lain with her. She went down to the well, filled her pitcher and came up again."
,"17":"The servant ran to meet her and said, 'Please let me drink a little water from your pitcher.'"
,"18":"She said, 'Drink, my lord!' and at once lowering her pitcher to her hand she let him drink."
,"19":"When she had finished letting him drink, she said, 'I am going to water your camels as well, until they have had enough.'"
,"20":"She hurried to empty her pitcher into the trough, and then ran again to draw water for all his camels,"
,"21":"while the man watched in silence to find out whether Yahweh was making his journey successful or not."
,"22":"So when the camels had finished drinking, the man took out a gold nose ring weighing half a shekel and for her arms two gold bracelets weighing ten shekels."
,"23":"He then said, 'Whose daughter are you? Please tell me! Is there room in your father's house where we can spend the night?'"
,"24":"She said to him, 'I am the daughter of Bethuel, the son Milcah bore to Nahor.'"
,"25":"She continued, 'We have plenty of straw and fodder, and room for you to spend the night.'"
,"26":"Then the man knelt and wor-shiped Yahweh"
,"27":"saying, 'Blessed be Yahweh, God of my master Abraham, who has not stopped showing kindness and faithfulness to my master. Yahweh has guided me to the house of my master's brother.'"
,"28":"The girl ran to her mother's house and related all these things."
,"29":"Now Rebekah had a brother named Laban and Laban ran out to the man, near the spring."
,"30":"As soon as he saw the ring and the bracelets on his sister's arms, as soon as he heard his sister Rebekah saying, 'This is what the man said to me... ' he came towards Abraham's steward who was standing near the camels by the spring."
,"31":"He said to him, 'Come in, you who are blessed by Yahweh. Why do you stay outside? I have prepared the house and there is room for your camels.'"
,"32":"So the man entered the house and unloaded the camels. Straw and fodder were given to the camels and water to wash the feet of the man and of those who were with him."
,"33":"Then they gave him food to eat, but he said, 'I won't eat until I have said what I have to say!' Laban said, 'Speak!'"
,"34":"Then he spoke like this, 'I am the servant of Abraham. Yahweh has greatly blessed my master and he has become very rich."
,"35":"Yahweh has given him flocks and herds, silver and gold, menservants and maidservants, camels and donkeys."
,"36":"Now Sarah, my master's wife, bore him a son in her old age;"
,"37":"so my master has given him all he owns and he made me swear an oath saying: 'You will not choose a wife for my son from the daughters of these Canaanites in whose country I live;"
,"38":"rather you will go to my father's house, to my kinsfolk and there you will choose a wife for my son.'"
,"39":"I then said to my master, 'Perhaps the woman will not agree to come with me!'"
,"40":"And his reply was: 'Yahweh, in whose presence I have walked, will send his angel with you and make your journey successful. You will choose a wife for my son from my own clan and from my father's house."
,"41":"This is what you have to do to be released from your oath. Whether they refuse you or not you will be free of the oath.'"
,"42":"So on arriving at the spring, I prayed, 'Yahweh, God of my master, Abraham, if you wish my journey to be successful, let it happen like this:"
,"43":"as I stand by the spring a girl will come to draw water and I will say to her: Let me drink a little from your pitcher."
,"44":"If she answers me: Yes, drink, and I will draw water for your camels as well, let it be that she is the wife Yahweh has chosen for my master's son.' I was still thinking this over,"
,"45":"when Rebekah came out with a pitcher on her shoulder. She went down to the spring and drew water. I said to her, 'Please, let me drink!'"
,"46":"She immediately lowered the pitcher and said, 'Drink! I will water your camels as well!' I drank and she watered the camels."
,"47":"I questioned her saying, 'Who is your father?' And she said, 'I am the daughter of Bethuel, the son of Nahor and Milcah.' I then put this ring through her nostril and bracelets on her arms."
,"48":"Then I knelt in worship and blessed Yahweh, God of my master, Abraham, who had led me to choose the daughter of my master's brother for his son."
,"49":"Now let me know whether you intend to show kindness and faithfulness to my master; if not, tell me and I shall know which way to turn.'"
,"50":"Laban and Bethuel replied, 'This is God's doing. It is not for us to decide either way."
,"51":"Here is Rebekah, take her and go. Let her become the wife of your master's son as Yahweh has directed.'"
,"52":"When Abraham's servant heard this answer, he bowed to the ground before Yahweh."
,"53":"He then took the gold and silver jewelry as well as the clothes and gave them to Rebekah. He also gave costly gifts to her brother and mother."
,"54":"They ate and drank, he and his companions, and spent the night there. When they were up next morning, the servant said, 'Let me return to my master.' "
,"55":"Rebekah's mother and brother replied, 'Let the girl remain with us for a few days, about ten. After that she may go.'"
,"56":"He said, 'Do not delay me; since Yahweh has made my journey successful, let me leave and return to my master.'"
,"57":"They then said, 'Call the girl and ask her about it.'"
,"58":"They called and questioned Rebekah, 'Do you want to leave with this man?' She said, 'I will go.'"
,"59":"So they let Rebekah, their sister, go with her nurse and Abraham's servant and his men."
,"60":"They blessed Rebekah with these words, 'Sister of ours, may you increase to thousands upon thousands, may your descendants take possession of the cities of their enemies.'"
,"61":"Then Rebekah and her maids got ready, mounted the camels and followed Abraham's servant. So it was that he departed bringing Rebekah."
,"62":"Now Isaac had come from the well of Lahai-roi, for he was living in the Negeb."
,"63":"As Isaac went out in the early evening to meditate in the field, he looked up and saw camels coming."
,"64":"Rebekah also looked up and when she saw Isaac she alighted from her camel"
,"65":"and said to the servant, 'Who is this man in the field coming to meet us?' He replied, 'It is my master!' She then covered her face with her veil."
,"66":"The servant related to Isaac all that he had done"
,"67":"and Isaac brought Rebekah into the tent of Sarah, his mother. He made her his wife, and he loved her; and Isaac was comforted after his mother's death."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Abraham married another wife named Keturah."
,"2":"She bore him Zimram, Jokshan, Medan, Midian, Ishbak and Shuah."
,"3":"Jokshan was the father of Sheba and Dedan, and the sons of Dedan were the Asshurites, the Letushites, and the Leummites."
,"4":"The sons of Midian were Ephah, Epher, Hanoch, Abida and Eldaah. All these were descendants of Keturah."
,"5":"Abraham left everything he owned to Isaac."
,"6":"To the sons of his concubines Abraham gave presents, and as long as he lived he sent them away from his son Isaac, to the land of the east."
,"7":"Abraham had lived a hundred and seventy-five years."
,"8":"Then at a good old age Abraham breathed his last, an old man, after a full span of years, and was gathered to his ancestors."
,"9":"His sons, Isaac and Ishmael, buried him in the cave at Machpelah,"
,"10":"in the field of Ephron the Hittite, son of Zohar. This was the field near Mamre that Abraham bought from the Hittites. Abraham and his wife, Sarah, were buried there."
,"11":"After Abraham's death God blessed his son Isaac who lived near the well of Lahai-roi."
,"12":"These are the descendants of Ishmael, the son of Abraham and Hagar, the Egyptian."
,"13":"These are the names of the sons of Ishmael in order of their birth. Ishmael's firstborn was Nebaioth, and after him Kedar, Adbeel, Mibsam,"
,"14":"Mishma, Dumah, Massa,"
,"15":"Hadad, Tema, Jetur, Naphish and Kedemah."
,"16":"These are the sons of Ishmael, and these are their names, according to their settlements and camps, twelve tribal princes."
,"17":"Ishmael lived a hundred and thirty-seven years. He breathed his last and died and was gathered to his people."
,"18":"His descendants lived in the territory stretching from Havilah to Shur, near the border of Egypt in the direction of Assyria. They have been fighting continually among themselves."
,"19":"This is the story of Isaac, son of Abraham."
,"20":"Isaac was forty when he married Rebekah, daughter of Bethuel, the Aramean from Paddan-aram, the sister of Laban the Aramean."
,"21":"Isaac prayed to Yahweh for his wife, because she could not have children. Yahweh heard Isaac's prayer and Rebekah, his wife, conceived."
,"22":"As the children struggled together within her, she said, 'If it is like this, why do I continue to live?' She went to consult Yahweh,"
,"23":"and Yahweh said to her, 'Two nations are in your womb, and two peoples will be born of you; one nation will be stronger than the other, and the elder shall serve the younger.'"
,"24":"When the time came for her to give birth, there were twins in her womb."
,"25":"The first to be born was red and his whole body was like a hairy garment, so they called him Esau."
,"26":"Then his brother was born and his hand had gripped Esau's heel so he was named Jacob. Isaac was sixty at the time of their birth."
,"27":"When the boys grew up, Esau became a skillful hunter, a man of the open country; Jacob was a quiet man living in tents."
,"28":"Isaac who had a liking for game loved Esau, but Rebekah loved Jacob."
,"29":"Once when Jacob was making a stew, Esau came back from the country and he was famished;"
,"30":"and he said to Jacob, 'Let me have some of that red stew, for I am famished.' That is why he was also called Edom."
,"31":"Jacob said, 'First sell me your right as the firstborn.'"
,"32":"Esau said, 'Since I am to die soon, what good is my right as the firstborn to me?'"
,"33":"Then Jacob said, 'Give me your oath first.' So he swore to him and sold his firstborn right to Jacob."
,"34":"Then Jacob gave him bread and the lentil stew. Esau ate and drank and then got up and went his way. So it was that Esau thought nothing of his right as the firstborn."
}`)
	CurrentBook.AddChapter(26, `{
"1":"There was a famine in the land - a second one after the famine that had taken place in the time of Abraham - and Isaac went to Gerar, the land of Abimelech, king of the Philistines."
,"2":"For Yahweh appeared to him and said, 'Do not go down to Egypt; stay in the land I shall tell you of."
,"3":"Remain in this land, and I will be with you and I will bless you. I will give all these lands to you and your race, and I shall keep the oath I swore to your father, Abraham. For I told him:"
,"4":"I will make your descendants as many as the stars in the heavens, and to them I will give all these lands; and through your descendants all nations in the world will be blessed"
,"5":"because you were obedient and kept my charge, my commandments, my decrees and my laws.'"
,"6":"So Isaac stayed in Gerar."
,"7":"When the men of that place questioned him about his wife, he replied, 'She is my sister.' He would not say, 'She is my wife,' for he was afraid and he thought, 'The men of this place might kill me because of Rebekah who is very beautiful.'"
,"8":"When Isaac had been there a long time, it happened that Abimelech, looking out of a window, saw Isaac caressing his wife Rebekah."
,"9":"Abimelech called Isaac and said, 'So she really is your wife! Why did you tell me that she was your sister?' Isaac said to him, 'Because I thought that they might kill me on her account.'"
,"10":"Then Abimelech said, 'What is this you have done to us? One of my people could have slept with your wife and you would have brought guilt on us.'"
,"11":"So Abimelech gave an order to all the people: 'Whoever molests this man or his wife will be put to death.'"
,"12":"Isaac sowed crops on this land and that same year he harvested a hundredfold. Yahweh blessed him"
,"13":"and he prospered. He continued to prosper until he was very rich."
,"14":"He had flocks and herds and many servants so that the Philistines envied him."
,"15":"All the wells dug by his father's servants in Abraham's time were stopped up by the Philistines and filled with earth."
,"16":"Abimelech said to Isaac, 'Go away from us for you are more powerful than we are.'"
,"17":"So Isaac left that place and encamped in the Valley of Gerar and settled there."
,"18":"Isaac opened up again the wells that had been dug in the time of his father, Abraham, and that the Philistines had blocked up after Abraham's death. He gave these wells the names his father had given them."
,"19":"Isaac's servants dug in the valley and discovered there a fresh water spring."
,"20":"The herdsmen of Gerar quarreled with Isaac's herdsmen saying, 'The water is ours!' So he named the well Esek, because they squabbled about it."
,"21":"They dug another well and there was quarreling about that as well, so he called it Sitnah."
,"22":"He moved away from there and dug another well and as no one quarreled over it, he called it Rehoboth saying, 'Now the Lord has made room for us, we shall prosper in the land.'"
,"23":"From there Isaac went to Beersheba,"
,"24":"and Yahweh appeared to him the same night and said, 'I am the God of Abraham, your father; do not be afraid, for I am with you. I will bless you and increase your descendants for the sake of my servant Abraham.'"
,"25":"Isaac built an altar there and called on the name of Yahweh. It was there he pitched his tent and there his servants dug a well."
,"26":"Abimelech went to him from Gerar together with Ahuzzath, his friend, and Phicol, the commander of his forces."
,"27":"Isaac said to him, 'Why have you come after me seeing that you hate me and have sent me away?'"
,"28":"They answered, 'We have clearly seen that Yahweh is with you, so we said: Let peace be sworn between us and you, and let us make a treaty:"
,"29":"you will do us no harm, just as we have not interfered with you, but always treated you well and sent you away in peace. We know that you have Yahweh's blessing.'"
,"30":"Isaac then made a feast for them and they ate and drank."
,"31":"Next morning they rose early and swore an oath to each other. Isaac then set them on their way and they left him in peace."
,"32":"That day Isaac's servants came and told him of the well they had dug: 'We have found water.'"
,"33":"He called the well Shibeah and that is why the name of the town has been Beersheba to this day."
,"34":"When Esau was forty, he married Judith, daughter of Beeri the Hittite, and Basemath, the daughter of Elon, the Hittite."
,"35":"They made life bitter for Isaac and Rebekah."
}`)
	CurrentBook.AddChapter(27, `{
"1":"When Isaac was old and his eyes so weak that he could no longer see, he called Esau, his older son, and said to him, 'My son.' 'Here I am,' he answered."
,"2":"Isaac continued, 'You see I am old and I don't know when I shall die;"
,"3":"so take your weapons, your bow and arrow, go out into the country and hunt some game for me."
,"4":"Then prepare some of the savory food I like and bring it to me so that I may eat and give you my blessing before I die.'"
,"5":"Now Rebekah was listening when Isaac spoke to his son Esau. When Esau went into the country to hunt game and bring it back,"
,"6":"Rebekah said to her son Jacob, 'I heard your father saying to your brother Esau:"
,"7":"'Bring me some game and prepare food for me that I may eat and bless you before Yahweh before I die.'"
,"8":"Now my son, listen and do what I command you."
,"9":"Go to the flock and bring me two fine kids so that I can prepare for your father the food that he likes."
,"10":"You will bring it to your father and he will eat it and give you his blessing before he dies.'"
,"11":"Jacob said to Rebekah, 'My brother Esau is a hairy man and I am smooth-skinned."
,"12":"Perhaps my father will feel me and I will seem to be tricking him and so bring a curse on myself instead of a blessing.'"
,"13":"But his mother said, 'Let the curse fall on me, my son! Only do what I tell you; go and get the kids for me.'"
,"14":"So he went and got them and took them to his mother to prepare food that his father liked."
,"15":"Then Rebekah took the best clothes of her elder son Esau that she had in the house and put them on Jacob, her younger son."
,"16":"With the goatskin she covered his hands and the smooth part of his neck,"
,"17":"and she handed to him the bread and food she had prepared."
,"18":"He went to his father and said, 'Father!' He answered, 'Yes, my son, who is it?'"
,"19":"and Jacob said to his father, 'It is Esau, your firstborn; I have done what you told me to do. Come, sit up and eat my game so that you may give me your blessing.'"
,"20":"Isaac said, 'How quick you have been my son!' Jacob said, 'Yahweh, your God, guided me.'"
,"21":"Isaac said to Jacob, 'Come near and let me feel you, my son, and know that it is you, Esau my son, or not.'"
,"22":"When Jacob drew near to Isaac, his father felt him and said, 'The voice is the voice of Jacob but the hands are the hands of Esau.'"
,"23":"He did not recognize him, for his hands were hairy like the hands of Esau his brother and so he blessed him."
,"24":"He asked, 'Are you really my son Esau?' and Jacob answered, 'I am.'"
,"25":"Isaac said, 'Bring me some of your game, my son, so that I may eat and give you my blessing.' So Jacob brought it to him and he ate. And he brought him wine and he drank."
,"26":"Then his father Isaac said to him, 'Come near and kiss me, my son.'"
,"27":"So Jacob came near and kissed him. Isaac then caught the smell of his clothes and blessed him, saying, 'The smell of my son is like the smell of a field which the Lord has blessed."
,"28":"May God give you of the dew of heaven; and of the richness of the earth; and abundance of grain and wine."
,"29":"Let peoples serve you,and nations bow down before you. Be lord over your brothers, and let your mother's sons bow down to you. Cursed be everyone that curses you,and blessed be everyone,that blesses you!'"
,"30":"When Isaac had finished blessing him and Jacob had just left Isaac's room, Esau came in from hunting."
,"31":"He also prepared food and brought it to his father and said to him, 'Father, sit up and eat the game your son has prepared, so that you may give me your blessing.'"
,"32":"Isaac said, 'Who are you?' 'I am your son, your firstborn, Esau.'"
,"33":"Isaac trembled violently and said, 'Who was it then that hunted game and brought it to me? I ate it all before you came and I blessed him and he will be blessed.'"
,"34":"On hearing his father's words, Esau gave a loud and bitter cry and said, 'Bless me, too, father.'"
,"35":"But Isaac said, 'Your brother came deceitfully and took your blessing.'"
,"36":"Esau said, 'Is it because he is called Jacob that he has supplanted me twice? First he took my birthright and now he has taken my blessing.' Then he asked, 'Haven't you kept a blessing for me?'"
,"37":"Isaac answered Esau, 'I have made him your lord. I have given him all his brothers as servants; I have provided him with grain and wine. What can I do for you, my son?'"
,"38":"Esau said to his father, 'Have you only one blessing? Father, bless me, too.' Then Esau wept aloud."
,"39":"Isaac then gave him this answer, 'Your dwelling place shall be far away from the richness of the earth, away from the dew of heaven above."
,"40":"You shall live by your sword, and you shall serve your brother; but when you win your freedom you will throw off his yoke from your neck.'"
,"41":"Now Esau continued to hate his brother because of the blessing his father had given him and he thought to himself, 'The time of mourning for my father is near; I shall then kill my brother Jacob.'"
,"42":"When Rebekah was told what her elder son had said, she sent and called her younger son, Jacob, and said to him, 'Your brother Esau is consoling himself with the thought of killing you."
,"43":"Now my son, listen to me and flee to Laban, my brother, in Haran."
,"44":"You will stay with him for a time"
,"45":"until your brother's fury has cooled; and when he has forgotten his anger and what you did to him, I will send someone to bring you back. Why should I lose both of you on the same day?'"
,"46":"Rebekah said to Isaac, 'I am weary of my life because of the Hittite women. If Jacob marries a woman from this land, a Hittite like these, what value is there left in life for me?'"
}`)
	CurrentBook.AddChapter(28, `{
"1":"Isaac summoned Jacob and blessed him and commanded him, 'Do not marry a Canaanite woman."
,"2":"Go to Paddan-aram, to the house of Bethuel, your mother's father, and choose a wife for yourself from the daughters of Laban, your mother's brother."
,"3":"May God Almighty bless you and make you increase to become a group of nations."
,"4":"May he grant you and your descendants the blessings of Abraham, so that you may take possession of the land where you live now, and that Yahweh gave to Abraham."
,"5":"Isaac sent Jacob away and he went to Paddan-aram to Laban, the son of Bethuel, the Aramean, brother to Rebekah."
,"6":"Esau saw that Isaac had blessed Jacob and sent him to Paddan-aram to choose a wife for himself, and in blessing him had commanded him, 'Do not marry a Canaanite woman.'"
,"7":"And in obedience to his father and mother, Jacob had gone to Paddan-aram."
,"8":"So Esau understood how displeasing the Canaanite women were to his father Isaac."
,"9":"So he went to Ishmael and chose a wife for himself besides those he already had - Mahalath, daughter of Ishmael, son of Abraham and sister of Nebaioth."
,"10":"Jacob left Beersheba and set out for Haran."
,"11":"When he reached a certain place the sun had set and he spent the night there. He took one of the stones that were there and using it as a pillow, he lay down to sleep."
,"12":"While Jacob was sleeping, he had a dream in which a ladder stood on the earth with its top reaching to heaven and on it were angels of God going up and coming down."
,"13":"And Yahweh was standing there near him and said, 'I am Yahweh, the God of your father, Abraham, and the God of Isaac. The land on which you sleep, I give to you and your descendants."
,"14":"Your descendants will be numerous like the specks of dust of the earth and you will spread out to the west and the east, to the north and the south. Through you and your descendants all the nations of the earth will be blessed."
,"15":"See, I am with you and I will keep you safe wherever you go. I will bring you back to this land and not leave you until I have done what I promised.'"
,"16":"Jacob woke from his dream and said, 'Truly Yahweh was in this place and I was not aware of it.'"
,"17":"He was afraid and said, 'How full of awe is this place! It is nothing less than a House of God; it is the Gate to Heaven!'"
,"18":"Then Jacob rose early and took the stone he had put under his head and set it up as a pillar and poured oil on the top of it."
,"19":"He named that place Bethel although before that it was called Luz."
,"20":"Then Jacob made a vow, 'If Yahweh will be with me and keep me safe during this journey I am making, if he gives me bread to eat and clothes to wear,"
,"21":"and if I return in peace to my father's house, then Yahweh will be my God."
,"22":"This stone which I have set up as a pillar will be God's house, and of all that you give me, I will give back a tenth.'"
}`)
	CurrentBook.AddChapter(29, `{
"1":"Jacob set out and came to the land of the people of the east."
,"2":"There he saw a well and lying beside the well were three flocks of sheep, for it was at this well that the flocks were watered, and a large stone covered the mouth of the well."
,"3":"Then when all the flocks gathered there, the shepherds rolled away the stone from the opening of the well, watered their flocks and replaced the stone at the mouth of the well."
,"4":"Jacob said to them, 'Brothers, where are you from?' 'We are from Haran,' they replied."
,"5":"He then said, 'Do you know Laban, Nahor's son?' 'Yes, we know him,' they replied."
,"6":"And Jacob asked, 'Is he well?' 'Yes, he is well,' they said, 'and here is Rachel, his daughter, coming with the sheep!'"
,"7":"Jacob then said, 'Look! The sun is still high; it's not yet time for the flocks to be gathered together. Water the sheep and let them graze.'"
,"8":"But they said, 'We cannot do that until all the flocks are gathered together and the stone is rolled away from the mouth of the well; it's then we water the sheep.'"
,"9":"He was still speaking when Rachel arrived with her father's flock, for she looked after them."
,"10":"As soon as Jacob saw Rachel he went forward and rolled the stone from the mouth of the well and then watered Laban's flock."
,"11":"Then Jacob kissed Rachel and wept aloud."
,"12":"Jacob told Rachel he was her father's kinsman and Rebekah's son, and she ran and told her father."
,"13":"As soon as Laban heard the news about Jacob being his sister's son, he ran to meet him; and after embracing and kissing him he brought him into his house. Jacob told Laban all that had happened"
,"14":"and Laban said to him, 'Truly you are my bone and flesh!' And Jacob stayed there a month with him."
,"15":"Laban said to Jacob, 'Even if you are my kinsman, should you work for me for nothing? Tell me, what wages do you want?'"
,"16":"Now Laban had two daughters; the name of the older one was Leah and the name of the younger was Rachel."
,"17":"Leah's eyes were weak but Rachel had a lovely figure and was beautiful."
,"18":"Jacob had fallen in love with Rachel and he said, 'I will work for you for seven years in return for your younger daughter, Rachel.'"
,"19":"Laban said, 'It is better for me to give her to you than to any other man; stay with me.'"
,"20":"To win Rachel, Jacob worked for seven years which seemed to him only a few days, because he loved her so much."
,"21":"Jacob then said to Laban, 'Give me my wife, for I have served my time and I want to lie with her.'"
,"22":"So Laban gathered together all the people of the place and gave a feast."
,"23":"But when night came he took his daughter Leah and gave her to Jacob and he lay with her."
,"24":"Laban gave his slave girl Zilpah to Leah to be her maid."
,"25":"When morning came, there was Leah! And Jacob said to Laban, 'What have you done to me? Haven't I worked with you for Rachel? Why have you deceived me?'"
,"26":"Laban said, 'It is not our custom to give the younger daughter before the firstborn."
,"27":"As soon as the marriage week is over, I will give you my younger daughter as well, but you must work with me for another seven years."
,"28":"Jacob agreed to this and when he completed the week with Leah, Laban gave him his daughter Rachel to be his wife."
,"29":"Laban gave Rachel his slave girl, Bilhah, to be her maidservant."
,"30":"So Jacob slept with Rachel as well, and he loved Rachel more than Leah. And he continued working for Laban another seven years."
,"31":"As Yahweh saw that Leah was not loved, he let her have children; but Rachel was barren."
,"32":"Leah gave birth to a child and named him Reuben, for she said, 'Because the Lord has seen my affliction; my husband is sure to love me now.'"
,"33":"She gave birth to another son and said, 'Yahweh saw that I was neglected and has given me this son as well'; and she called him Simeon."
,"34":"Again she gave birth to a son and said, 'This time my husband will be united to me because I have borne him three sons.' That is why he was called Levi."
,"35":"She again gave birth to a son and said: 'This time I will praise Yahweh.' That is why she named him Judah. After that she had no more children."
}`)
	CurrentBook.AddChapter(30, `{
"1":"When Rachel saw that she bore Jacob no children, she became jealous of her sister, and so she said to Jacob, 'Give me sons or I shall die.'"
,"2":"Jacob became angry and said to her, 'Is it my fault that God has deprived you of children?'"
,"3":"She then said, 'Here is my servant Bilhah; sleep with her so that she may give birth on my knees; so the child will be mine.'"
,"4":"And she gave Bilhah her servant as wife to Jacob."
,"5":"She became pregnant and bore him a son."
,"6":"Rachel then said, 'God has done me justice! He has heard my prayer and given me a son. That is why she named him Dan."
,"7":"Bilhah, Rachel's servant, bore a second son to Jacob."
,"8":"And Rachel said, 'I have had a mighty struggle with my sister and I have won!' And so she named her son Naphtali."
,"9":"When Leah saw that she had stopped having children, she took her servant, Zilpah, and gave her to Jacob as a wife."
,"10":"Zilpah gave birth to a son for Jacob."
,"11":"Leah said 'How fortunate!' and named him Gad."
,"12":"Leah's servant bore a second son to Jacob."
,"13":"Leah said, 'How happy I am! Women will call me happy.' So she named him Asher."
,"14":"At the time of the wheat harvest, Reuben went out to the fields and found some mandrake plants which he brought to his mother, Leah. Rachel said to Leah, 'Please give me some of your son's mandrakes.'"
,"15":"But Leah replied, 'Isn't it enough for you to have taken my husband? Now you want to take my son's mandrakes as well!' Rachel then said, 'He will sleep with you tonight in return for your son's mandrakes.'"
,"16":"In the evening when Jacob came in from the fields Leah went to meet him and said, 'You will sleep with me tonight for I have hired you with my son's mandrakes!' So he slept with her that night."
,"17":"Yahweh heard Leah, and she became pregnant and bore Jacob a fifth son."
,"18":"Leah said, 'God has given me my reward because I gave my maidservant to my husband.' She named the child Issachar."
,"19":"Leah bore another son to Jacob."
,"20":"Then she said, 'God has offered me a beautiful gift; this time my husband will honor me for I have given him six children.' She named the child Zebulun."
,"21":"She later gave birth to a daughter and called her Dinah."
,"22":"Then Yahweh remembered Rachel and let her have a child."
,"23":"She became pregnant and gave birth to a son. 'Yahweh has taken away my shame,' she said."
,"24":"And she called the child Joseph saying,'May Yahweh give me another son.'"
,"25":"After Rachel had given birth to Joseph, Jacob said to Laban, 'Let me go, so that I may return to my homeland."
,"26":"Give me my wives and my children, for whom I have served you, and let me go, for you know how well I have served you.'"
,"27":"Laban said, 'If I have won your friendship... I have learned from signs that Yahweh has blessed me because of you.'"
,"28":"He then added, 'Say what you want for wages and I will pay you.'"
,"29":"Jacob said, 'You know how well I have served you and how your cattle have prospered with me."
,"30":"For you had little when I came, but since I have been with you there has been a considerable increase and Yahweh has blessed you. But now, when am I to do something for my own household?'"
,"31":"Laban asked, 'What shall I give you?',Jacob replied, 'You will give me nothing, but if you do for me what I ask, I will continue to pasture and look after your flock. "
,"32":"Today I shall go through your flock removing from it every black lamb, and the spotted and speckled among the goats; these shall be my wages."
,"33":"My honesty will answer for me later, when you come to look into my wages. Any goat among my herd that is not spotted or speckled, any lamb found among the sheep in my possession that is not black will be counted as stolen.'"
,"34":"Laban said, 'Agreed, it will be as you say.'"
,"35":"That same day Laban put aside the he-goats that were streaked, every one that had white on it, and all the black sheep. These he handed over to his sons"
,"36":"and he put a distance of a three days' journey between himself and Jacob. So Jacob looked after the rest of Laban's flock."
,"37":"Jacob then gathered fresh branches of poplar, almond and plane. He peeled white streaks in them, letting the white of the stems be seen."
,"38":"Then he placed the branches he had peeled in front of the channels of the watering troughs where the animals came to drink and where they could be clearly seen by the animals. And as they mated there in front of the branches when they came to drink,"
,"39":"the animals produced streaked, spotted and speckled young."
,"40":"He put the sheep apart but made the rest face the streaked and dark colored animals that belonged to Laban. In this way he built up droves of his own and did not add them to Laban's flock."
,"41":"Whenever the stronger of the ewes were breeding, Jacob put the branches in the channels in front of the eyes of the ewes so that they would mate there among the branches."
,"42":"But for the feebler ewes he did not put them there so that the feebler were for Laban and the more robust for Jacob."
,"43":"In this way he became extremely rich with a great number of sheep, maidservants and menservants, camels and donkeys."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Jacob learned that the sons of Laban were saying, 'Jacob has taken everything our father owned, and it is at our father's expense that he has accumulated this fortune.'"
,"2":"Jacob understood from Laban's expression that his attitude towards him was no longer the same."
,"3":"Then Yahweh said to Jacob, 'Go back to your homeland, the country of your kinsmen. I will be with you.'"
,"4":"Jacob had Rachel and Leah called to the field where his flocks were."
,"5":"There he said to them, 'I see that your father no longer looks kindly on me, but the God of my father has been with me."
,"6":"You yourselves know that I have served your father with all my strength."
,"7":"But your father has not been straight with me, changing my wages ten times. But God has not allowed him to do me harm."
,"8":"Whenever he said: 'The spotted ones will be your wages,' then all the ewes had spotted lambs. And whenever he said: 'The streaked ones will be your wages,' then all the ewes produced streaked lambs."
,"9":"It is God who has taken your father's livestock in that way and has given it to me."
,"10":"For, in the breeding season, when I was looking up, I saw in a dream that the rams mating with the ewes were streaked, spotted or speckled."
,"11":"And the angel in the dream said to me: 'Jacob.' 'Here I am,' I replied."
,"12":"He then said: 'Look up and see that all the rams mating with the ewes are streaked, spotted or speckled. I have seen all that Laban has done to you."
,"13":"I am the God who appeared to you at Bethel where you anointed a pillar and vowed to me by oath. Now get ready, leave this country and return to the land of your birth.'"
,"14":"Then Rachel and Leah replied, 'Have we still any share in the inheritance of our father's estate?"
,"15":"Haven't we been regarded by him as foreigners since he has sold us, and well and truly used up our money?"
,"16":"Surely all the fortune that God has taken from our father belongs to us and to our children. So do then all that God has told you.'"
,"17":"So Jacob got ready and put his children and his wives on camels."
,"18":"He also took with him all his livestock and all that he had accumulated (the livestock he had acquired at Paddan-aram) to return to his father Isaac in the land of Canaan."
,"19":"Rachel then took advantage of Laban. While he was shearing his sheep she stole her father's family gods."
,"20":"So Jacob tricked Laban in not letting him know he was running away."
,"21":"He fled with all he had, and after crossing the river Euphrates he made for the hill country of Gilead."
,"22":"Three days later Laban heard that Jacob had fled."
,"23":"Taking his brothers with him, he followed Jacob for seven days and caught up with him in the hill country of Gilead."
,"24":"God appeared to Laban in a dream at night and said to him, 'Be careful not to say anything - either good or bad - to Jacob.'"
,"25":"Jacob had pitched his tent in the hill country of Gilead when Laban overtook him. Laban and his brothers also encamped on the hills of Gilead."
,"26":"Then Laban said to Jacob, 'What have you done, tricking me and carrying my daughters off like prisoners of war?"
,"27":"Why did you run away secretly and cheat me? Why didn't you tell me? I could have sent you off with joy and singing and the music of tambourine and harp."
,"28":"You didn't even let me kiss my grandchildren and daughters goodbye. You have done a foolish thing"
,"29":"and I have power to harm you, but last night the God of your father warned me saying: 'Be careful not to say anything - good or evil - to Jacob.'"
,"30":"Now if you have gone off because you were planning to return to your father's house, why did you steal my gods?'"
,"31":"Jacob replied to Laban, 'It was because I was afraid you would take your daughters from me!"
,"32":"But whoever is found in possession of your gods will not live. In the presence of our relatives see for yourself if anything that belongs to you is here with me and, if so, take it.' Now Jacob did not know that Rachel had stolen the gods."
,"33":"Laban entered Jacob's tent, then Leah's and then the tent of the two maidservants, but he found nothing. When Laban came out of Leah's tent, he entered the tent of Rachel."
,"34":"Rachel had taken the gods, but put them into the camel's saddle, and sat on them. Laban felt all about the tent but did not find them."
,"35":"Rachel said to her father, 'Do not be angry with me, my lord, if I do not stand in your presence, for I am having my period.' So he searched but did not find the gods."
,"36":"Then Jacob became angry and rebuked Laban. 'What is my crime?' he asked him. 'What sin of mine makes you hound me down?"
,"37":"Now that you have searched through all my belongings, have you found anything that belongs to your household? If so, let it be seen here in the presence of your family and mine and let them judge between the two of us."
,"38":"During the twenty years I have been with you, your ewes and your she-goats have not miscarried and I haven't eaten any of the rams from your flocks."
,"39":"I haven't brought you any animal torn by a wild beast. I suffered the loss and you demanded payment from me for whatever was stolen by day or night."
,"40":"During the day I have been stifled by the heat and at night I have suffered from the cold, and sleep has left my eyes."
,"41":"It's twenty years that I've been with you. I worked fourteen years for your two daughters and six years for your flocks, and ten times you have altered my wages."
,"42":"If the God of my father Abraham and the Fearsome God of Isaac had not been with me, you would have sent me away empty-handed. But God has seen my hardship and the toil of my hands and last night he passed sentence.'"
,"43":"Laban answered and said to Jacob, 'The daughters are my daughters, the children are my children, these sheep are my sheep and all that you see are mine. How can I harm today these daughters of mine or their children?"
,"44":"Come now, let us make a treaty, you and me, and let it be a witness between us.'"
,"45":"Jacob took a stone and set it up as a pillar."
,"46":"He then said to his kinsmen, 'Collect stones.' So they gathered stones and piled them up, and they ate there by the pile."
,"47":"Laban called it Jegar-sahadutha, and Jacob called it, Galeed."
,"48":"Laban said, 'This pile of stones is a witness between you and me today.' That is why it was called Galeed;"
,"49":"and it was also known as Mizpah because Laban had said, 'May Yahweh watch between me and you when we are no longer in sight of each other."
,"50":"If you harm my daughters or take other wives besides my daughters, even though no man is with us, remember that God is witness between you and me.'"
,"51":"Then Laban said to Jacob, 'Here is the pile and the pillar which I have set between you and me."
,"52":"This pile and this pillar will witness that I will not pass beyond this pile to harm you and that you will not pass beyond this pile and pillar to harm me."
,"53":"May the God of Abraham and the God of Nahor judge between us!' So Jacob swore by the Fearful God of his father Isaac."
,"54":"Jacob also offered a sacrifice on the mountain and invited his brothers to the meal. After they had eaten, they spent the night there."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Next morning Laban rose early and, after kissing his sons and daughters, he blessed them and left for home."
,"2":"As for Jacob, he went on his way and met Angels of God."
,"3":"On seeing them Jacob exclaimed, 'This is God's camp,' and he named the place Mahanaim."
,"4":"And going on his way, he sent messengers ahead of him to his brother Esau in the land of Seir, the country of Edom."
,"5":"Jacob sent Esau this message, 'I have been staying with Laban until now. I have oxen, asses, flocks, men-servants and maidservants. I have sent to tell you this, my lord, that you may receive me kindly.'"
,"6":"The messenger returned and said to Jacob, 'We went to your brother Esau and he is already coming to meet you with four hundred men.'"
,"7":"Jacob was full of fear and dis-tressed. He then divided the people with him and the flocks, the herds and camels into two camps,"
,"8":"thinking, 'If Esau attacks one camp, the other will escape.'"
,"9":"And Jacob said, 'God of my father Abraham and my father Isaac, Yahweh, who said to me: 'Return to your country, to your father's land, and I will make you prosper,'"
,"10":"I am unworthy of the kindness and faithfulness you have shown to me, for with only my staff I crossed the Jordan and now I have enough to form two companies."
,"11":"Deliver me from the hands of my brother Esau for I am afraid lest he come and kill us all, even the mothers and their children."
,"12":"Yet it was you who said: I will be good to you and make your descendants like the sand on the seashore, so many that they cannot be counted.'"
,"13":"So Jacob spent the night there. Then he took what he had with him, a present for his brother Esau: "
,"14":"two hundred she-goats, and twenty he-goats, two hundred ewes and twenty rams,"
,"15":"thirty camels in milk and their calves, forty cows and ten bulls, twenty she-asses and ten male donkeys."
,"16":"He put them in the care of his servants, each herd by itself, and said to his servants, 'Go ahead of me and leave a space between each herd.'"
,"17":"He instructed the leader, 'When my brother Esau meets you and asks, 'To whom do you belong? And where are you going? Who is the owner of the animals you are driving?'"
,"18":"Then you shall say: They belong to your servant Jacob. It is a present he is sending to my lord Esau. He himself is coming along behind us!'"
,"19":"Jacob ordered the second and third servants and all who were following the herds in the same way, 'That is what you shall say to Esau when you meet him:"
,"20":"Your servant Jacob is following!' For he thought to himself, 'I may pacify him with the present I sent ahead, so that when I meet him face to face, he may perhaps receive me kindly.'"
,"21":"So the present went ahead of him, but he himself spent that night in the camp."
,"22":"That same night Jacob got up and taking his two wives, his two maidservants and his eleven sons, crossed the ford of the Jabbok."
,"23":"He took them and sent them across the stream and likewise everything he had."
,"24":"And Jacob was left alone. Then a man wrestled with him until daybreak. "
,"25":"When the man saw that he could not get the better of Jacob, he struck him in the socket of his hip and dislocated it as he wrestled with him."
,"26":"The man said, 'Let me go, for day is breaking.' But Jacob said, 'I will not let you go until you have given me your blessing.'"
,"27":"The man then said, 'What is your name?' 'Jacob' was the reply."
,"28":"He answered, 'You will no longer be called Jacob, but Israel, for you have been strong-with-God as you have been with men and have prevailed.'"
,"29":"Then Jacob asked him, 'What is your name?' He answered, 'Why do you ask my name?' And he blessed him there."
,"30":"So Jacob called the place Penuel, saying, 'I have seen God face to face and survived.'"
,"31":"The sun rose as he passed through Penuel, limping because of his hip."
,"32":"That is why to this day the Israelites do not eat the sciatic nerve which is in the hip socket because the sciatic nerve in Jacob's hip had been touched."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Jacob looked up and saw that Esau was coming with four hundred men. So he divided the children among Leah, Rachel and the two maidservants."
,"2":"He then put the maidservants in front with their children, then Leah with her children and Rachel and Joseph last of all."
,"3":"He himself went on before them and bowed to the ground seven times until he came near his brother."
,"4":"Esau ran to meet him, took him in his arms, kissed him; and both wept."
,"5":"Esau looked up and seeing the women and the children said, 'Who are these with you?' Jacob replied, 'They are the children God has given to your servant.'"
,"6":"Then the servants and their children went forward and bowed down."
,"7":"Leah with her children likewise advanced and bowed, and lastly Joseph and Rachel went forward and bowed."
,"8":"Esau said, 'What is the meaning of all this company I have met?' Jacob replied, 'It is to win your favor.'"
,"9":"Esau answered, 'Brother, I have plenty; keep what you have for yourself.'"
,"10":"Jacob said, 'But, no, please! Accept the gift I offer, for I came to you as to God, and you received me kindly."
,"11":"So accept the gift I have brought you, for God has dealt generously with me and I have plenty.' And so much did Jacob insist that Esau accepted the gift."
,"12":"Esau then said, 'Let us be on our way. I will lead you.'"
,"13":"But Jacob said to him, 'My lord knows that the children are not strong, and besides I must think of the ewes with lambs and the cows that have calves and if they are driven too hard, even for one day, all the flocks will die."
,"14":"Let it please my lord to go ahead of me while I move on slowly at the pace of the cattle I'm driving and that of the children, until I reach my lord at Seir.'"
,"15":"Esau said, 'At least let me leave with you some of my men.' Jacob replied, 'Why? All I want is to keep your friendship.'"
,"16":"So Esau returned that same day to Seir."
,"17":"But Jacob left for Succoth. There he built a house for himself and shelters for his cattle. That is why the place was called Succoth."
,"18":"On his return from Paddan-aram, Jacob safely reached Shechem, a town in the land of Canaan, and encamped within sight of the town."
,"19":"For one hundred pieces of silver he bought from the sons of Hamor, the father of Shechem, the plot of land where he had pitched his tent."
,"20":"There he erected an altar and called it God - the God of Israel."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Now Dinah, Jacob's daughter by Leah, went out to visit the women of that place."
,"2":"When Shechem, son of Hamor the Hivite, the prince of that country, saw her, he seized her, raped her and dishonored her."
,"3":"He was attracted to Jacob's daughter Dinah and loved the girl and spoke to her affectionately."
,"4":"Shechem said to his father Hamor, 'Get me this girl to be my wife.'"
,"5":"Now Jacob heard how his daughter Dinah had been dishonored, but said nothing until his sons who were in the fields with his cattle came home."
,"6":"Hamor, father of Shechem, went to speak with Jacob."
,"7":"When Jacob's sons returned from the fields and heard what had happened, they were indignant and very angry that Shechem had committed what was a crime in Israel by lying with Jacob's daughter, something which should never be done."
,"8":"But Hamor spoke to them saying, 'Shechem, my son, deeply loves your daughter; please give her to him to be his wife."
,"9":"Let us intermarry; give us your daughters and take our daughters for yourselves."
,"10":"You will settle with us and the land is there before you to live in it, travel through it and acquire property in it."
,"11":"Shechem spoke to the father and brothers of the girl, 'Please forgive me and I give you whatever you ask of me."
,"12":"Fix a price for the marriage and whatever gift you require. Whatever you ask I will give but only let me have the girl as my wife.'"
,"13":"Jacob's sons gave a cunning answer to Shechem and Hamor because Shechem had defiled their sister:"
,"14":"'We cannot do such a thing - give our sister to an uncircumcised man - for that would be a disgrace for us."
,"15":"Only on one condition would we consent - that you and every male become like us and be circumcised."
,"16":"Then we will give you our daughters and take yours, live with you, and with you become one people."
,"17":"But if you don't listen to us and be circumcised, we will take our daughter and go.'"
,"18":"What they said pleased Hamor and Shechem, his son."
,"19":"Shechem lost no time in doing what was demanded for he was truly in love with Jacob's daughter, and he was the most honored in his father's family."
,"20":"So Hamor and his son Shechem went to the gate of their city and spoke to their fellow citizens,"
,"21":"'These men are peaceful. Let them settle here and move around freely. The land is vast enough for them. We shall marry their daughters and give our daughters in marriage to them."
,"22":"But on one condition will these men agree to live with us and become one people with us, and that is, that every male be as they are and be circumcised."
,"23":"If we agree with them, their flocks, their possessions, their cattle will be ours. Let's do what they ask and they will settle with us.'"
,"24":"All those who went out to the gate of the city agreed with Hamor and Shechem and every male was circumcised."
,"25":"Three days later when they were still in pain, two of Jacob's sons, Simeon and Levi, Dinah's brothers, taking their swords, entered and took the town by surprise"
,"26":"and slew Hamor and Shechem and all the males. They took Dinah from Shechem's house and went off."
,"27":"Jacob's sons attacked the wounded and plundered the city because their sister had been violated."
,"28":"They took their flocks and their herds and their donkeys, what was in the city and what was in the fields,"
,"29":"all their wealth, all their women and children. They plundered all that was in their houses."
,"30":"Then Jacob said to Simeon and Levi, 'You have brought trouble on me, making me hateful to the people of this land, the Canaanites and the Perizzites. I have only a few men and if the others unite against me and attack me, I shall be destroyed, myself and my household."
,"31":"But their reply was, 'Is it right for him to treat our sister as a prostitute?'"
}`)
	CurrentBook.AddChapter(35, `{
"1":"God said to Jacob, 'Go up to Bethel and settle there. Build an altar there to God who appeared to you when you were fleeing from your brother Esau.'"
,"2":"Jacob said to his family and to all those who were with him, 'Get rid of the foreign gods you have with you, purify yourselves and change your clothes."
,"3":"We will then go up to Bethel. There I will make an altar to God who helped me when I was in trouble and who was with me during my journey.'"
,"4":"So they gave Jacob all the foreign gods they had as well as their earrings and Jacob hid them under the oak that was near Shechem."
,"5":"They then left and a terror fell on all the surrounding towns with the result that no one followed in pursuit of them."
,"6":"When Jacob and all those with him came to Luz in Canaan - which is Bethel -"
,"7":"he built an altar there and called the place El-Bethel because it was there that God had shown himself to him when he was fleeing from his brother."
,"8":"At that time Rebekah's nurse, Deborah, died and was buried below Bethel near the oak. That is why it was called the Oak of Tears."
,"9":"God appeared again to Jacob when he arrived from Paddan-aram and blessed him"
,"10":"and said to him, 'Your name is Jacob, but no longer will you be called Jacob, for Israel will be your name.' So he was called Israel."
,"11":"Then God said to him, 'Be fruitful and grow in number! A nation or rather a group of nations will come from you."
,"12":"The land I gave to Abraham and Isaac I will give to you and to your descendants after you.'"
,"13":"Then God left him."
,"14":"Jacob set up a stone in the place where God had spoken to him and offered a libation on it and poured oil on it."
,"15":"Jacob called the place where God had spoken to him, Bethel."
,"16":"They moved on from Bethel and were still some distance from Ephrath when Rachel gave birth and the delivery was very difficult."
,"17":"When she was in great pain the midwife said to her, 'Courage! For now you will have another son.'"
,"18":"And as she breathed her last - for she was dying - she called him Benoni (which means: son of my pain), but his father named him Benjamin."
,"19":"So Rachel died and was buried on the way to Ephrath - that is Bethlehem -"
,"20":"and Jacob placed a pillar over her tomb which marks the place of the tomb to this day."
,"21":"Israel journeyed on and pitched his tent beyond Migdal-eder."
,"22":"While Israel was living in that region, it happened that Reuben went and lay with Bilhah, his father's concubine, and Israel heard of it. Jacob had twelve sons. "
,"23":"By Leah: Reuben, Jacob's eldest son, then Simeon, Levi, Judah, Issachar and Zebulun."
,"24":"The sons by Rachel: Joseph and Benjamin."
,"25":"The sons by Bilhah, Rachel's slave girl: Dan and Naphtali."
,"26":"The sons by Zilpah, Leah's slave girl: Gad and Asher. These were the sons born to Jacob in Paddanaram."
,"27":"Jacob came home to his father Isaac at Mamre or Kiriatharba (that is, Hebron) where Abraham and Isaac had lived."
,"28":"After living a hundred and eighty years"
,"29":"Isaac breathed his last and was gathered to his people at a good old age. His sons Esau and Jacob buried him."
}`)
	CurrentBook.AddChapter(36, `{
"1":"These are the descendants of Esau that is, Edom. Esau married women of Canaan:"
,"2":"Adah, the daughter of Elon the Hittite, Oholibamah, the daughter of Anah, the son of Zibeon the Horite,"
,"3":"Basemath, the daughter of Ishmael and sister of Nebaioth."
,"4":"Adah bore to Esau Eliphaz, Basemath bore Reuel,"
,"5":"Oholibamah bore Jeush, Jalam and Korah. These are the sons of Esau born to him in the land of Canaan."
,"6":"Esau, with his wives, his sons and daughters, all the members of his household, his livestock, all his cattle and all the goods he had acquired in the land of Canaan, left for the land of Seir far removed from his brother Jacob."
,"7":"For they had acquired too much to live together. The land where they were living at that time could not support them both because of their cattle."
,"8":"That is why Edom settled in the hilly country of Seir. Esau is Edom."
,"9":"These are the descendants of Esau, the father of Edom, in the mountainous region of Seir."
,"10":"These are the names of Esau's sons: Eliphaz the son of Adah, Esau's wife, and Reuel the son of Basemath, Esau's wife."
,"11":"The sons of Eliphaz were: Teman, Omar, Zepho, Gatam, Kenaz."
,"12":"Eliphaz son of Esau had Timna for concubine and she bore him Amalek. These are the sons of Adah, Esau's wife."
,"13":"These are the sons of Reuel: Nahath, Zerah, Shammah, Mizzah. These are the sons of Basemath, Esau's wife."
,"14":"These are the sons of Esau's wife Oholibamah, daughter of Anah son of Zibeon: she bore him Jeush, Jalam and Korah."
,"15":"These are the chiefs of the sons of Esau. The sons of Eliphaz, firstborn of Esau: chief Teman, chief Omar, chief Zepho, "
,"16":"chief Kenaz, chief Gatam, chief Amalek. These are the chiefs of Eliphaz in the land of Edom. These are the sons of Adah."
,"17":"And these are the sons of Reuel son of Esau: Nahath, Zerah, Shammah, Mizzah. These are the chiefs of Reuel in the land of Edom; these are the sons of Basemath, Esau's wife."
,"18":"And these are the sons of Oholibamah, Esau's wife: chief Jeush, Jalam, Korah. These are the chiefs of Esau's wife Oholibamah, daughter of Anah."
,"19":"These are the sons of Esau. This is Edom and these are their chiefs."
,"20":"These are the sons of Seir the Horite, inhabitants of the land: Lotan, Shobal, Zibeon, Anah,"
,"21":"Dishon, Ezer, Dishan; these are the chiefs of the Horites, the sons of Seir in the land of Edom."
,"22":"The sons of Lotan were Hori and Heman, and Lotan's sister was Timna."
,"23":"These are the sons of Shobal: Alvan, Manahath, Ebal, Shepo, Onam."
,"24":"These are the sons of Zibeon: Aiah, Anah - the Anah who found the hot springs in the wilderness as he pastured the donkeys of his father Zibeon."
,"25":"These are the children of Anah: Dishon, Oholibamah daughter of Anah."
,"26":"These are the sons of Dishon: Hemdan, Eshban, Ithran, Cheran."
,"27":"These are the sons of Ezer: Bilhan, Zaavan, Akan."
,"28":"These are the sons of Dishan: Uz and Aran."
,"29":"These are the chiefs of the Horites: chief Lotan, chief Shobal, chief Zibeon, chief Anah,"
,"30":"chief Dishon, chief Ezer, chief Dishan. These are the chiefs of the Horites according to their clans in the land of Seir."
,"31":"These are the kings who reigned in the land of Edom before an Israelite king reigned."
,"32":"In Edom these reigned: Bela son of Beor; his city was called Dinhabah."
,"33":"Bela died and Jobab son of Zerah, from Bozrah, succeeded him as king."
,"34":"Jobab died and Husham of the land of the Temanites succeeded."
,"35":"Husham died and Hadad, son of Bedad succeeded; he defeated the Midianites in the country of Moab, and his city was called Avith."
,"36":"Hadad died and Samlah of Masrekah succeeded."
,"37":"Samlah died and Shaul of Rehoboth-hannahar succeeded."
,"38":"Shaul died and Baal-hanan son of Achbor succeeded."
,"39":"Baal-hanan died and Hadad succeeded; his city was called Paul; his wife's name was Mehetabel, daughter of Matred, from Mezahab."
,"40":"These are the names of the chiefs of Esau according to their clans and localities, by name: chiefs Timna, Alvah, Jetheth,"
,"41":"Oholibamah, Elah, Pinon,"
,"42":"Kenaz, Teman, Mibzar,"
,"43":"Magdiel, Iram. These are the chiefs of Edom according to their families and residence in the land that was theirs. (This is Esau, father of Edom)."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Jacob lived in the land where hisfather had settled, in the land of canaan."
,"2":"this is the history of jacob's family. Joseph, a young man of seventeen, was shepherding the flock with his brothers, the sons of Bilhah and the sons of Zilpah, his father's wives. Joseph informed his father of the bad reputation they had. "
,"3":"Now Israel loved Joseph more than any of his other children, for he was the son of his old age and he had a coat with long sleeves made for him."
,"4":"His brothers who saw that their father loved him more than he loved them, hated him and could no longer speak to him in a friendly way."
,"5":"Joseph had a dream which, when he told it to his brothers, made them hate him the more:"
,"6":"'Listen to the dream I had."
,"7":"We were binding sheaves in the field when my sheaf rose and stood up and your sheaves gathered round and bowed down to my sheaf.'"
,"8":"His brothers said to him, 'So you want to rule us or lord it over us!' They hated him even more because of his dreams and what he said."
,"9":"Joseph had another dream which he told to his brothers, 'I saw the sun, the moon and seven stars bowing down before me.'"
,"10":"When he told this to his father and brothers his father rebuked him, 'What is this dream of yours? Are all of us, myself, your mother and your brothers to bow to the ground before you?'"
,"11":"His brothers were jealous of him but his father kept in mind what he had said."
,"12":"His brothers had gone to pasture their father's flock at Shechem,"
,"13":"and Israel said to Joseph, 'Your brothers are pasturing the flock at Shechem; come along, I'll send you to them.' Joseph replied, 'Here I am.'"
,"14":"Then his father said, 'Go and see if all is well with your brothers and with the flock; then come back and tell me.' Jacob sent him from the valley of Hebron and Joseph arrived at Shechem."
,"15":"A man met him as he was wandering through the countryside and said to him, 'What are you looking for?'"
,"16":"He replied, 'I'm looking for my brothers, please tell me where they are pasturing the flock.'"
,"17":"The man said, 'They have gone from here, for I heard them say: Let's go to Dothan!' So Joseph went off after his brothers and found them at Dothan."
,"18":"They saw him in the distance and before he reached them, they plotted to kill him."
,"19":"They said to one another, 'Here comes the specialist in dreams!"
,"20":"Now's the time! Let's kill him and throw him into a well. We'll say a wild animal devoured him. Then we'll see what his dreams were all about!'"
,"21":"But Reuben heard this and tried to save him from their hands"
,"22":"saying, 'Let us not kill him; shed no blood! Throw him in this well in the wilderness, but do him no violence.' This he said to save him from them and take him back to his father."
,"23":"So as soon as Joseph arrived, they stripped him of his long-sleeved coat that he wore"
,"24":"and then took him and threw him in the well. Now the well was empty, without water."
,"25":"They were sitting for a meal when they looked up and saw a caravan of Ishmaelites coming from Gilead, their camels laden with spices, balm and myrrh, which they were taking down to Egypt."
,"26":"Judah then said to his brothers, 'What do we gain by killing our brother and hiding his blood?"
,"27":"Come! We'll sell him to the Ishmaelites and not lay our hands on him, for he is our brother and our own flesh!' His brothers agreed to this."
,"28":"So when the Midianite merchants came along they pulled Joseph up and lifted him out of the well. For twenty pieces of silver they sold Joseph to the Midianites, who took him with them to Egypt."
,"29":"When Reuben went back to the well, Joseph was no longer there. He tore his clothes"
,"30":"and returned to his brothers and said, 'The boy has disappeared, and what am I to do?'"
,"31":"They then took Joseph's coat, killed a goat and dipped the coat in its blood."
,"32":"They sent the long-sleeved coat and had it taken to their father, saying, 'This we have found; see if it is your son's coat or not.'"
,"33":"He recognized it and said, 'It is my son's coat. Joseph has been attacked by a wild animal and torn to pieces.'"
,"34":"Jacob then tore his garments, put on sackcloth and mourned his son for a long time."
,"35":"All his sons and daughters came to comfort him but he refused to be consoled saying, 'No, I shall go down to the land of Shadows, mourning for my son.' Thus his father wept for him."
,"36":"Meanwhile the Midianites sold Joseph in Egypt to Potiphar, an officer of Pharaoh and the commander of the guard."
}`)
	CurrentBook.AddChapter(38, `{
"1":"It happened at this time that Judah left his brothers and went to stay with an Adullamite by the name of Hirah."
,"2":"There Judah saw the daughter of a Canaanite called Shua. He married her"
,"3":"and she gave birth to a son whom he called Er."
,"4":"She had another child and called him Onan."
,"5":"And then she had a third child whom she called Shelah. She was at Chezib when she gave birth to him."
,"6":"Judah got a wife for Er, his firstborn son. Her name was Tamar."
,"7":"But Er, Judah's firstborn, was wicked in Yahweh's sight and the Lord took his life."
,"8":"Then Judah said to Onan, 'Lie with your brother's widow and fulfill the duties of a brother-in-law; the child to be born will be the heir of your brother.'"
,"9":"But Onan knew the child would not be his, so whenever he slept with his brother's widow, he spilled the semen on the ground lest he give an heir to his brother."
,"10":"What he did was displeasing to Yahweh who took his life as well."
,"11":"Then Judah said to his daughter-in-law, 'Live as a widow in your father's house until Shelah, my son has grown up,' for he was afraid that Shelah, like his brothers, might die. So Tamar went and lived in her father's house."
,"12":"After a long time, the wife of Judah, Shua's daughter died. When Judah became consoled, he went up to Timnah to his sheep-shearers with his friend Hirah, the Adullamite."
,"13":"It happened that Tamar was told, 'Your father-in-law is going up to Timnah to shear his sheep.'"
,"14":"She at once took off her widow's clothes, wrapped herself in a veil and sat down at the entrance to Enaim which is on the road to Timnah, for she knew that Shelah was a grown man and had not been given to her in marriage."
,"15":"Judah saw her and as her face was veiled he took her for a prostitute."
,"16":"He went over to her on the roadside and said, 'Allow me to sleep with you,' for he didn't know she was his daughter-in-law. She asked, 'What will you give me to sleep with you?'"
,"17":"He said, 'I will send you a kid from my flock.' She replied, 'Will you give me a pledge till you send it?'"
,"18":"'What pledge shall I give you?' he asked. She answered, 'Give me your seal, your cord and the staff in your hand.' So he gave them to her and slept with her;"
,"19":"then she rose and left him and, taking off her veil, she put on her widow's clothes. And she became pregnant."
,"20":"When Judah sent the kid by his friend, the Adullamite, to recover the pledge from the woman, he did not find her."
,"21":"So he questioned the local people, 'Where is the prostitute who was by the road at Enaim?' 'There has been no prostitute there,' they said."
,"22":"He returned to Judah and said, 'I didn't find her and even the local people said that there was no prostitute there.'"
,"23":"Judah then said, 'Let her keep it all for herself lest the people finally laugh at us. At least I sent her the kid even if you didn't find her.'"
,"24":"About three months later Judah was told, 'Tamar, your daughter-in-law played the prostitute and moreover she is now with child.' Judah said, 'Bring her out and let her be burned.'"
,"25":"As they were bringing her out she sent word to her father-in-law, 'I have become pregnant by the man who owns these things. Find out to whom this seal, cord and staff belong!'"
,"26":"Judah acknowledged them and said, 'She is more righteous than I am since I wouldn't give her to my son Shelah.' And he had no further intercourse with her."
,"27":"When the time came for her to give birth, there were twins in her womb."
,"28":"And when she was giving birth, one of them put out his hand and the midwife tied a scarlet thread around his wrist saying, 'This one is the firstborn.'"
,"29":"But he withdrew his hand and his brother came out first and she said, 'What a rift you have made for yourself!' And he was called Perez."
,"30":"Then his brother with the scarlet thread on his wrist came out and he was given the name Zerah."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Now Joseph was taken down to Egypt, and Potiphar, an officer of Pharaoh, commander of the guard, an Egyptian, bought him from the Ishmaelites who had brought him there."
,"2":"Yahweh blessed Joseph while he lived in the house of his master, the Egyptian, and everything went right for him."
,"3":"The Egyptian could see that God was with him and everything worked well for him."
,"4":"So Joseph pleased his master who made him overseer of his house and of all that he owned,"
,"5":"and from that time God blessed the Egyptian's house because of Joseph; he blessed all that the Egyptian owned, his household and his land."
,"6":"The Egyptian left all he had to the care of Joseph and, with Joseph fully in charge, he concerned himself with nothing except the food that he ate. Now Joseph was a handsome man and well-built. "
,"7":"After some time his master's wife kept noticing him and said, 'Sleep with me.'"
,"8":"But he refused and said to her, 'With me in charge, my master has no concern about anything in the house and has entrusted to me all that he has."
,"9":"He is no more master in this house than I am and he refuses me nothing, except yourself, of course, because you are his wife. How then could I do such an evil thing and sin against God?'"
,"10":"Now, although day after day she spoke to Joseph, he would not agree to sleep with her or give himself to her."
,"11":"It happened that one day, when he entered the house to attend to his duties, none of the servants were in the house."
,"12":"Then Potiphar's wife caught hold of Joseph by his cloak saying, 'Come to bed with me.' But Joseph left his cloak in her hands and ran out of the house."
,"13":"As soon as he had run out of the house,"
,"14":"she called her servants and said, 'Look, a Hebrew has been brought here to make fun of us; he came here to lie with me; so I screamed"
,"15":"and when he heard me scream he left his cloak with me and ran out of the house.'"
,"16":"Then she kept the cloak by her until the master came home."
,"17":"She then told her story, 'That Hebrew slave of yours came to make sport of me,"
,"18":"but when I screamed he left his cloak with me and ran out of the house.'"
,"19":"When his master heard what his wife told him, 'This is how your servant treated me,' he blazed with anger."
,"20":"He took Joseph and put him in the Royal Prison where the king's prisoners were kept. But while Joseph was in prison"
,"21":"Yahweh was with him and showed him kindness so that he was well-liked by the warden of the prison."
,"22":"The warden put him in charge of all the prisoners and made him responsible for all that was done there."
,"23":"The warden did not interfere with anything that was under Joseph's care, because Yahweh was with him and gave him success in everything he did."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Some time after this it happened that the cupbearer of the king of Egypt, who prepared the drinks for Pharaoh, and his chief baker offended their lord."
,"2":"Pharaoh was angry with his two officers"
,"3":"and put them in custody in the house of the captain of the guard, in the prison where Joseph was kept."
,"4":"So the captain of the guard appointed Joseph to attend to their needs, for they were under arrest for some time."
,"5":"One night both of them dreamed, each one his own dream, and each dream had its own meaning. As the two officers were with Joseph in custody in his master's house,"
,"6":"when Joseph came to them the next morning, he saw that they were troubled."
,"7":"So he questioned them, 'Why do you look sad today?'"
,"8":"They answered, 'Both of us have had a dream, but there is no one to interpret them.' Then Joseph said to them, 'Is it not God who interprets dreams? Tell me what they were.'"
,"9":"Then the chief cupbearer told Joseph what his dream had been. 'In my dream there was a vine in front of me"
,"10":"and on the vine there were three branches. As it grew and flowered, its clusters ripened into grapes."
,"11":"Pharaoh's cup was in my hand and I took the grapes and pressed them into Pharaoh's cup and placed the cup in his hand.'"
,"12":"Joseph said to him, 'Here's the interpretation: the three branches are three days."
,"13":"Within three days Pharaoh will release you and restore you to your office and you will place Pharaoh's cup in his hand as before when you were his cupbearer."
,"14":"But when things go well with you, remember me and be kind enough to speak my name to Pharaoh and get me out of this place,"
,"15":"for I was, in fact, kidnapped from the land of the Hebrews and even here I have done nothing to deserve imprisonment.'"
,"16":"The chief baker, seeing that the interpretation was favorable, said to Joseph, 'In my dream I had on my head three baskets of cakes."
,"17":"In the top basket there were all kinds of baked food for Pharaoh, but the birds were eating it from the basket above my head.'"
,"18":"Joseph said, 'The three baskets are three days,"
,"19":"and before three days have passed Pharaoh will take off your head and hang you on a tree and the birds will eat your flesh.'"
,"20":"It so happened that on the third day, Pharaoh's birthday, he made a feast for all his officers and remembered the chief cupbearer and the chief baker."
,"21":"The cupbearer was restored to his office and placed the cup in Pharaoh's hand;"
,"22":"but the chief baker was hanged, as Joseph had interpreted to them."
,"23":"Yet the chief cupbearer did not remember Joseph, but forgot him."
}`)
	CurrentBook.AddChapter(41, `{
"1":"After two whole years Pharaoh dreamed that he was standing by the Nile"
,"2":"when seven cows, sleek and fat, were coming up from the Nile and beginning to feed among the rushes."
,"3":"Behind them came seven other cows, lean and scraggy that stood beside the cows already there."
,"4":"These devoured the sleek and fat cows. Then Pharaoh awoke."
,"5":"He fell asleep again and had a second dream. He saw growing on one stalk seven ears of corn that were full and ripe."
,"6":"And after these, there sprouted seven more ears of corn that were small and scorched by the east wind."
,"7":"Now the small ears of corn swallowed the plump and ripe ones. Then Pharaoh awoke."
,"8":"In the morning he was uneasy and called all the magicians and wise men in Egypt. He told his dreams to them but not one among them was able to interpret his dreams."
,"9":"Then the chief cupbearer spoke to Pharaoh, 'This reminds me of my wrongs."
,"10":"Pharaoh was angry with his servants and had me put in custody in the house of the captain of the guard and with me the chief baker."
,"11":"Once on the same night we both had a dream, each with its own meaning."
,"12":"With us was a young Hebrew, a servant of the captain of the guard. When we told him our dreams he interpreted them giving to each one its own meaning."
,"13":"What he interpreted for us happened. I was restored to my office and the chief baker was hanged.'"
,"14":"Pharaoh then had Joseph summoned. They took him quickly from the prison, shaved him, changed his clothes and he presented himself to Pharaoh."
,"15":"Then Pharaoh addressed him, 'I have had a dream which no one can explain; now I have heard that when you hear a dream you are able to interpret it.'"
,"16":"Joseph replied, 'It's not I but God who will give Pharaoh a favorable answer.'"
,"17":"Pharaoh then began telling his dream. 'I was beside the Nile "
,"18":"when seven fine cows, sleek and fat, came up from the river and began to feed in the rushes."
,"19":"Then seven other cows came up behind them. These were poor, scraggy and lean. I had never seen any so ugly in all the land of Egypt."
,"20":"The thin, gaunt cows ate up the seven fat cows,"
,"21":"but after eating them, it was as if they had not eaten them at all because they remained as lean and scraggy as they were before. And then I woke."
,"22":"I also saw in my dream seven ears of corn growing on one stalk, full and ripe."
,"23":"Then, after them, there sprouted seven ears of corn that were hard and small and withered by the east wind."
,"24":"The withered ears of corn swallowed the good ears. I told this to the magicians but none of them could explain its meaning.'"
,"25":"Then Joseph said, 'Pharaoh's dream is one and the same. Yahweh has just revealed to Pharaoh what he will do."
,"26":"The seven fat cows are seven years and the seven good ears as well. It's one dream!"
,"27":"The seven lean cows coming after them are seven years as are the seven withered ears of corn scorched by the east wind, and they are seven years of famine."
,"28":"As I said to Pharaoh, God is revealing to him what he is about to do."
,"29":"There will be seven years of plenty throughout the land of Egypt,"
,"30":"but they will be followed by seven years of famine. Then the time of abundance will be forgotten and famine will exhaust the land."
,"31":"So severe will the famine be that no one will remember the time of plenty."
,"32":"If the dream has been repeated twice for Pharaoh it is because God has so determined and will soon make it happen."
,"33":"Now it is for Pharaoh to choose an intelligent and wise man and set him over the land of Egypt."
,"34":"Pharaoh could have supervisors in the land and could levy a tax of one fifth of the produce of the land during the seven years of plenty."
,"35":"They must gather all the food of these productive years that are coming and, by the authority of Pharaoh, store grain for food in the towns and keep it."
,"36":"This food will be a reserve for the seven years of famine coming to the land of Egypt so that the people will not die of hunger.'"
,"37":"The proposal of Joseph pleased Pharaoh and his ministers, and Pharaoh asked them,"
,"38":"'Where shall we find such a man possessed with the spirit of God?'"
,"39":"And to Joseph he said, 'Since it is to you that God has made known all this, there can be no one as intelligent and wise as you."
,"40":"You shall be over my house, and all my people will obey your orders. Only I myself will be greater than you.'"
,"41":"So Pharaoh said to Joseph, 'See, I have put you in charge of the whole land of Egypt.'"
,"42":"He then took the signet ring from his finger and put it on Joseph's finger. He clothed him in fine linen and put a gold chain around his neck."
,"43":"He had him ride in the chariot that was second only to his and they cried out before him, 'Make way.' Thus he was put in charge of the whole land of Egypt."
,"44":"Then Pharaoh said to Joseph, 'I am Pharaoh! Without your consent no one is to raise hand or foot in the whole land of Egypt.'"
,"45":"Pharaoh named Joseph Zaphenath-paneah and gave him in marriage Asenath, the daughter of Potiphera, priest of On. After that Joseph traveled throughout the land of Egypt."
,"46":"Joseph was thirty years old when he was summoned to the presence of Pharaoh, King of Egypt. After taking his leave of Pharaoh he journeyed through the entire land of Egypt."
,"47":"During the seven years of plenty the land produced abundantly."
,"48":"So Joseph gathered up all the food that was produced during these years, storing in each town the food from the fields around it."
,"49":"Joseph stored huge quantities of wheat, like the sand from the sea, so much that they lost count of the amount."
,"50":"Before the years of famine came, Asenath, Joseph's wife, had two sons."
,"51":"Joseph called the first Manasseh, for he said, 'God has made me forget all my hardship and all my father's house.'"
,"52":"He called the second by the name of Ephraim, for he said, 'God has given me children in the land of my sorrow.'"
,"53":"When the seven years of plenty throughout the land of Egypt came to an end,"
,"54":"the seven years of famine began as Joseph had foretold. There was famine in all the countries but bread was to be had in every part of Egypt."
,"55":"When the land of Egypt began to suffer from the famine, the people came to Pharaoh for bread. But Pharaoh told all the Egyptians, 'Go to Joseph and do as he tells you.'"
,"56":"When the famine had spread throughout the land, Joseph opened all the storehouses and sold grain to the Egyptians for the famine was indeed severe over the land."
,"57":"As the famine had worsened throughout the whole world, people came from other countries to buy grain from Joseph."
}`)
	CurrentBook.AddChapter(42, `{
"1":"When Jacob heard there was wheat in Egypt he said to his sons, 'Why do you stand looking at one another?"
,"2":"I've heard there is grain in Egypt, so go down and buy some for us so that we may stay alive and not die!'"
,"3":"Joseph's brothers - ten of them - went down to Egypt to buy wheat"
,"4":"but Jacob did not send Benjamin, Joseph's brother, for he said, 'Something might happen to him.'"
,"5":"So the sons of Israel were among those going to buy grain, for there was famine in Canaan."
,"6":"It was Joseph, as governor of the land, who sold the grain to all the people. When his brothers arrived they bowed before him, with their faces to the ground."
,"7":"Joseph recognized his brothers but did not make himself known and, instead, said harshly to them, 'Where do you come from?' And they answered, 'We come from the land of Canaan to buy grain for food.'"
,"8":"Joseph recognized his brothers but they did not recognize him."
,"9":"And he remembered the dreams he once had concerning them. He told them, 'You are spies, and it is to discover the weak points of the land that you have come.'"
,"10":"They said, 'No, my lord, your servants have come to buy grain for food."
,"11":"We are all sons of the same man. We are honest men; your servants are not spies.'"
,"12":"Joseph replied, 'No, it is to find out the weak points of the country that you have come.'"
,"13":"They said, 'Your servants are twelve brothers, the sons of one man in the land of Canaan; the youngest is today with our father and the other is no more.'"
,"14":"But Joseph insisted, 'It's just as I said, you are spies!"
,"15":"And this will be proved. By the life of Pharaoh you will not leave this place unless your youngest brother comes here."
,"16":"One of you is to go and fetch your brother. The others will be imprisoned while I verify whether you are telling the truth. If not, then as true as Pharaoh lives, you are spies.'"
,"17":"And so he put them all in prison for three days."
,"18":"On the third day Joseph said to them, 'I will help you to save yourselves, for I am a man who fears God."
,"19":"If you are sincere, let one of your brothers remain prisoner in the house of the guard where you now are, and the rest of you take the grain to save your families from famine."
,"20":"Then you will bring back your youngest brother; so the truth of what you say will be proved and your lives spared.' They did as they were ordered"
,"21":"and said among themselves, 'Alas! We are guilty because of the way we treated our brother when he pleaded with us for mercy, but we didn't listen. That is why this trouble has come upon us.'"
,"22":"Reuben answered them, 'Didn't I tell you not to sin against the boy. But you did not listen and now we are brought to account for his blood.'"
,"23":"Now they did not know that Joseph understood them as there was an interpreter between them."
,"24":"As for Joseph, he withdrew and wept. When he came back, he spoke to them and took Simeon and had him bound and put in prison while they looked on."
,"25":"Joseph ordered their sacks to be filled with wheat and their money replaced in the sack of each one and provisions be given them for the journey. All this was done;"
,"26":"they loaded the grain on their donkeys and set off."
,"27":"But in the evening one of them emptied his sack to feed his donkey at the lodging place, and he saw his money at the mouth of the sack, so he said,"
,"28":"'My money has been put back: here it is in my sack;' Their hearts failed them and they trembled and turned to each other and said, 'What is this that God has done to us!'"
,"29":"When they came back to Jacob in the land of Canaan, they told him about all their adventures:"
,"30":"'The man who is governor of the country spoke harshly to us and treated us as spies,"
,"31":"but we said: 'We are honest men, not spies."
,"32":"We were twelve brothers, sons of the same father; one is no more and the youngest is with our father in the land of Canaan.'"
,"33":"Then the man who is lord of the land said: By this I will know if you are honest. Leave one of your brothers here; take grain to save your families from the famine and go."
,"34":"Bring back your youngest brother and let me see you are not spies but honest men. Then I shall release your brother and you can trade in the land.'"
,"35":"Now, when they emptied their sacks, each one found his money bag in his sack. When they saw this, they were afraid and their father as well."
,"36":"Jacob their father said to them, 'You are taking my children from me. Joseph has gone; Simeon has gone and now you are taking Benjamin. I have all this to bear!'"
,"37":"Then Reuben said to his father, 'You may have the lives of my two sons if I do not bring him back to you. Entrust him to me and I shall see that he comes back.'"
,"38":"But Jacob said, 'My son will not go with you, for his brother is dead and he alone is left. If he were to meet with some misfortune on the way, you would send my gray head to the land of Shadows in sorrow.'"
}`)
	CurrentBook.AddChapter(43, `{
"1":"Now the lack of food was severe in the land,"
,"2":"and when they had eaten the grain they brought from Egypt, their father said to them, 'Go down again and buy us a little food.'"
,"3":"But Judah said to him, 'The man solemnly warned us that our brother had to come with us."
,"4":"If you send our brother with us, we will go down and buy food for you;"
,"5":"but if you don't send him, we will not go, for the man said: You will not be admitted to my presence if your brother is not with you.'"
,"6":"Israel then said, 'Why did you bring this misery on me by letting the man know you have another brother?'"
,"7":"They replied, 'The man questioned us carefully about ourselves and our kinsfolk saying: 'Is your father still alive? Have you another brother?' And so we answered these questions. Could we have known that he would tell us to bring our brother?'"
,"8":"Judah then said to Israel his father, 'Send the boy with me. Let us go so that we, you and our children may live and not die."
,"9":"I will guarantee his safety. If I do not bring him back and set him here before you, I will bear the blame forever."
,"10":"If we hadn't delayed for so long we could have been there and back twice over.'"
,"11":"Israel their father said to them, 'If it must be so, then do this: take some choice products of the land in your bags and a gift for the man - some balm, a little honey, gum, myrrh, pistachio nuts and almonds."
,"12":"Take double the money with you and you will repay what was put in your sacks; it may have been a mistake."
,"13":"Take your brother and go back to the man."
,"14":"May God Almighty grant you mercy in his presence, so that he will allow you to bring back your other brother and Benjamin. As for myself if I am bereaved of my children, then bereaved I shall have to be.'"
,"15":"The men took the gift and the double amount of money as well. And, taking Benjamin, they set off and went down to Egypt and were admitted to the presence of Joseph."
,"16":"When Joseph saw that Benjamin was with them, he said to his steward, 'Bring these men to my house. Have an animal slaughtered and a meal prepared, for these men will eat with me at noon.'"
,"17":"The steward did as Joseph directed and brought the men to Joseph's house."
,"18":"They were afraid and said to each other, 'It's because of the money that was placed in our sacks the last time, that we are brought in. He wants to attack and overpower us and have us as slaves and take our donkeys.'"
,"19":"So they approached Joseph's steward and spoke to him at the door of the house,"
,"20":"'By your leave, sir, we came down here the first time to buy food,"
,"21":"and when we reached a lodging place and opened our sacks, we found in the mouth of the sacks each one's money to the full weight. We have brought it back with us"
,"22":"as well as additional money to buy food. We don't know who put the money in our sacks.'"
,"23":"The steward said, 'Be at peace! Don't be afraid. Your God, the God of your father, put a treasure in your grain sacks. Your money reached me safely.' He then brought Simeon out to them."
,"24":"The steward took them into Joseph's house, gave them water to wash their feet and fodder for their donkeys."
,"25":"They prepared their present and waited for Joseph's arrival at midday, for they heard they were to dine there."
,"26":"When Joseph came into the house, they offered him the gift they had with them and bowed to the ground before him."
,"27":"He asked them how they were and said, 'Is your father well, the old man you spoke about? Is he still alive?'"
,"28":"They answered, 'Your servant our father is well and is still alive.'"
,"29":"He looked up and saw his brother Benjamin, the son of his own mother, and said, 'Is this your youngest brother, the one you told me about?' And he added, 'God be good to you, my son!'"
,"30":"So deeply moved was Joseph, on seeing his brother, that he wanted to cry and went out quickly and wept in his own private room."
,"31":"After he had washed his face and come out, controlling himself, he said, 'Serve the meal.'"
,"32":"He was served separately and so were they, and the Egyptians as well, for the Egyptians cannot share a meal with Hebrews; for the Egyptians this would be a shame."
,"33":"They were seated opposite him in the order of their ages from the eldest to the youngest and they looked at each other in astonishment."
,"34":"Joseph had portions from his own dish taken to them and Benjamin's portion was five times more than that of the others. So they drank freely with him."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Now Joseph gave this order to his steward, 'Fill the men's sacks with as much food as they can carry and put back each man's silver in the mouth of his sack,"
,"2":"and put my cup, the silver cup with the money for the grain in the sack of the youngest.' The steward did as Joseph had directed."
,"3":"As soon as it was light next morning the men were sent away with their donkeys."
,"4":"When they had gone but were still not far from the city, Joseph said to his steward, 'Go quickly after those men and when you have caught up with them, say this: Why have you repaid good with evil?"
,"5":"Isn't this the cup my master drinks from and uses for divination? You have done a wicked thing.'"
,"6":"When he caught up with them he repeated these words."
,"7":"They said to him, 'Why does my lord speak like that? Far be it from your servants to do such a thing."
,"8":"The money we found in the mouths of our sacks, we brought back to you from the land of Canaan! How then could we have stolen silver or gold from your lord's house?"
,"9":"If one of your servants is found with the object, he will die and we too will become my lord's slaves.'"
,"10":"'Very well then,' he said, 'it will be as you say. The one who is found to have the cup will become my master's slave; the rest of you will go free.'"
,"11":"Then each one quickly lowered his sack to the ground and opened it."
,"12":"And he searched, beginning with the eldest and ending with the youngest. And the cup was found in Benjamin's sack."
,"13":"Then they tore their clothes and, reloading their donkeys, they returned to the city."
,"14":"Joseph was still in the house when Judah and his brothers returned and they threw themselves on the ground before him."
,"15":"Joseph said to them, 'What have you done? Didn't you know that a man such as I am is able to divine?'"
,"16":"Then Judah said, 'What shall we say to my lord? How can we prove our innocence? God has uncovered your servant's guilt; we are my lord's slaves, we and the one who has been found with the cup.'"
,"17":"But Joseph said, 'Far be it from me to do that. Only the man found to have the cup will be my slave. As for the rest, go back in peace to your father.'"
,"18":"Judah then went forward and said, 'My lord, allow your servant to speak. Do not be angry with your servant, although you are equal to Pharaoh himself."
,"19":"The last time you questioned your servants saying: 'Have you a father or a brother?'"
,"20":"We said to my lord: 'We have an aged father who had a child in his old age. His brother is dead and he is the only one left of his mother's children. And his father loves him.'"
,"21":"Then you said to us: 'Bring him down so that I can see him for myself.'"
,"22":"We told my lord that the boy could not leave his father, for if he did, his father would die."
,"23":"You then told us that if our youngest brother did not come with us, we would not be admitted to your presence."
,"24":"All this we said to our father on returning there."
,"25":"So when he told us to come back and buy a little food,"
,"26":"we said: 'We cannot go down again unless our youngest brother is with us. We shall not be admitted to the lord's presence unless our brother is with us.'"
,"27":"Then my father said: 'You know that my wife had two children."
,"28":"One went away from me and has surely been torn to pieces since I have not seen him anymore."
,"29":"If you take this one from me and something happens to him you will bring my gray hair in sorrow to the grave.'"
,"30":"Now I can't return to my father without the boy, for my father loves him very much. If he sees that the boy is not there,"
,"31":"he will die and we will have sent the gray hairs of our father in sorrow to the grave."
,"32":"Now I, your servant, guaranteed the boy's safety and said to my father: 'If I do not bring him back, I will bear the blame before you all my life.'"
,"33":"So now let me take the place of the boy and stay here as slave and let the boy go with his brothers,"
,"34":"for I can't return to my father without the boy. Do not let me see the misery that would be too much for my father.'"
}`)
	CurrentBook.AddChapter(45, `{
"1":"Now Joseph could no longer control his feelings in the presence of all those standing by and he called out, 'Leave my presence, everyone!' And only his brothers were with him when Joseph made himself known to them."
,"2":"He wept so loudly that the Egyptians heard and the news spread through Pharaoh's house."
,"3":"Joseph said to his brothers, 'I am Joseph. Is my father still alive?' And his brothers could not answer because they were terrified at seeing him."
,"4":"Joseph said, 'Come closer,' and they drew nearer. 'I am Joseph your brother, yes, it's me, the one you sold to the Egyptians."
,"5":"Now don't grieve and reproach yourselves for selling me, because God has sent me before you to save your lives."
,"6":"It's two years since famine has been in the land and there will be another five years without tilling and without harvest."
,"7":"God has sent me ahead of you to make our race survive there and to save many of you."
,"8":"So it was not you but God who sent me here, and made me a father to Pharaoh and lord of his household, and ruler also of all the land of Egypt."
,"9":"Go back quickly to my father and say to him: 'Joseph your son sends you this message: God has made me lord of all Egypt; so come down to me without delay;"
,"10":"you shall live in the land of Goshen and you shall be near me, you, your children and grandchildren, your flocks and your herds, all that you have."
,"11":"And there I will provide for you (for there will be five more years of famine) lest you and your household and all who belong to you, be in need."
,"12":"Now you can see for yourselves, and your brother Benjamin can see that it is I myself who speak to you."
,"13":"You will tell my father of the glory I have in Egypt and of all that you have seen. Go quickly and bring my father down here.'"
,"14":"Joseph then threw his arms around Benjamin and wept."
,"15":"Then weeping he kissed and embraced his brothers and they began to talk with him."
,"16":"The news spread through Pharaoh's house, 'Joseph's brothers are here,' and the news pleased both Pharaoh and his officials."
,"17":"Pharaoh told Joseph, 'Let your brothers load their beasts, return to the land of Canaan"
,"18":"and bring their father and their families back to me. I will give you the best of the land of Egypt and you will enjoy the fat of the land!"
,"19":"As for yourself give them this order: Take wagons from the land of Egypt for your little ones and for your wives; get your father and come!"
,"20":"Never mind the things you leave there, for the best in all Egypt is yours!'"
,"21":"The sons of Israel did this. Joseph gave them wagons as Pharaoh had ordered, and provisions for the journey."
,"22":"To each one he gave a festal garment but to Benjamin he gave three hundred silver coins and five festal garments."
,"23":"To his father he sent ten asses loaded with all the best goods in Egypt and ten donkeys loaded with grain, bread and provisions for his father on the journey."
,"24":"Then he sent his brothers away and as they left he said, 'Don't quarrel on the way.'"
,"25":"They returned from Egypt and came back to Jacob their father in Canaan."
,"26":"They told him, 'Joseph is alive and he is the ruler of all Egypt!' Jacob was stunned for he could not believe them."
,"27":"But they told him all that Joseph had said and showed him the wagons that Joseph sent to carry him. Then Jacob's spirit revived and he said,"
,"28":"'It's enough, my son Joseph is alive; I will go and see him before I die.'"
}`)
	CurrentBook.AddChapter(46, `{
"1":"Israel left with all he owned and reached Beersheba where he offered sacrifices to the God of his father Isaac."
,"2":"God spoke to Israel in visions that he had during the night, 'Jacob! Jacob!' 'Here I am,' he said."
,"3":"'I am God, the God of your father. Do not be afraid to go to Egypt, for there I will make you into a great nation."
,"4":"I will go with you to Egypt and I will bring you back again and Joseph's hand will close your eyes.'"
,"5":"Jacob left Beersheba and the sons of Israel carried Jacob their father with their little children and their wives in the wagons that Joseph had sent to fetch him."
,"6":"They also took their flocks and all that they had acquired in Canaan. And so it was that Jacob came to Egypt and with him all his family,"
,"7":"his sons and his grandsons, his daughters and his granddaughters, in short all his children he took with him to Egypt."
,"8":"Here are the names of the descendants of Israel who came to Egypt: Reuben, Jacob's firstborn, "
,"9":"and the sons of Reuben: Hanoch, Pallu, Hezron, and Carmi."
,"10":"the sons of Simeon: Jemuel, Jamin, Ohad, Jachin, Zohar, and Shaul, whose mother was a Canaanite."
,"11":"The sons of Levi: Gershon, Kohath, and Merari."
,"12":"The sons of Judah: Er, Onan, Shelah, Perez, and Zerah (but Er and Onan died in the land of Canaan); and the sons of Perez were Hezron and Hamul."
,"13":"The sons of Issachar: Tola, Puvah, Job, and Shimron."
,"14":"The sons of Zebulun: Sered, Elon, and Jah'leel"
,"15":"(these are the sons of Leah, Jacob's wife, who were born in Paddan-aram, together with his daughter Dinah; altogether his sons and his daughters numbered thirty-three)."
,"16":"The sons of Gad: Zip'ion, Haggai, Shuni, Ezbon, Eri, Arodi, and Areli."
,"17":"The sons of Asher: Imnah, Ishvah, Ishvi, Beriah, with Serah their sister. And the sons of Beri'ah: Heber and Malchiel."
,"18":"These are the sons of Zilpah, whom Laban gave to Leah his daughter; and Jacob was their father - sixteen persons."
,"19":"The sons of Rachel, Jacob's wife: Joseph and Benjamin."
,"20":"And to Joseph in the land of Egypt were born Manasseh and Ephraim, whose mother was Asenath, the daughter of Potiphera, the priest of On."
,"21":"And the sons of Benjamin: Bela, Becher, Ashbel, Gera, Naaman, Ehi, Rosh, Muppim, Huppim, and Ard"
,"22":"(these are the sons of Rachel - fourteen)."
,"23":"The children of Dan: Hushim."
,"24":"The sons of Naphtali: Jahzeel, Guni, Jezer, and Shillem"
,"25":"(these are the sons of Bilhah, whom Laban gave to Rachel his daughter, and Jacob was their father - seven persons in all)."
,"26":"The total number of all the persons who came to Egypt with Jacob, all who were of his own blood, not counting the wives of his sons, was sixty-six."
,"27":"With the two sons born to Joseph in Egypt, the total number of Jacob's household that came to Egypt was seventy."
,"28":"Jacob sent Judah ahead to let Joseph know he was coming and that he would soon arrive in the land of Goshen."
,"29":"Joseph got his chariot ready in order to meet Israel his father in Goshen. He presented himself, threw his arms around his father and wept on his shoulder for a long time."
,"30":"Israel said to Joseph, 'Now I can die, for I have seen your face and know you are alive.'"
,"31":"After that Joseph said to his brothers and all his father's family, 'I will go and give the news to Pharaoh and tell him that my brothers and my father's family who were in the land of Canaan have come to me."
,"32":"I will also tell him that you are shepherds, keeping livestock, and have brought your flocks and cattle and all your belongings."
,"33":"So when Pharaoh summons you and says: 'What is your occupation?'"
,"34":"you will say: 'Your servants keep flocks and herds; it has been so since our youth, and for our fathers before us.' Then you will settle in the land of Goshen, for the Egyptians detest all shepherds.'"
}`)
	CurrentBook.AddChapter(47, `{
"1":"Joseph went and told Pharaoh, 'My father and brothers with their sheep and cattle and all their possessions have come from the land of Canaan to Goshen.'"
,"2":"He then presented five of his brothers to Pharaoh."
,"3":"Pharaoh asked, 'What are your occupations?' and they replied, 'Your servants are shepherds as were our fathers before us."
,"4":"We have come to settle in the land for there is no more pasture for our sheep, so severe is the famine in the land of Canaan. And now we pray you, may we stay in the land of Goshen?'"
,"5":"Pharaoh then spoke to Joseph, 'Your father and your brothers have come to you."
,"6":"The land of Egypt is before you; let your father and brothers settle in the best part; let them settle in Goshen, and if among them there are capable men, put them in charge of my cattle.'"
,"7":"Joseph brought in Jacob his father and presented him to Pharaoh"
,"8":"who then asked him, 'How old are you?'"
,"9":"Jacob replied, 'The years of my wanderings are one hundred and thirty. Brief and difficult have been the years of my life, and not as many as those of my fathers.'"
,"10":"Then Jacob blessed Pharaoh and withdrew from his presence."
,"11":"So Joseph had his father and brothers settled, giving them property in the best part of Egypt, in the land of Rameses as Pharaoh had commanded."
,"12":"Joseph provided his father, his brothers and his father's entire household with food according to the number of their dependents."
,"13":"Now so severe was the famine that no bread was to be had in all the land. Both Egypt and Canaan were exhausted because of the famine."
,"14":"Joseph then collected all the money that had been given to buy bread in the lands of Egypt and Canaan. All this money Joseph took to Pharaoh's house."
,"15":"When all the money of the people of Egypt and Canaan was gone, all Egypt came to Joseph saying, 'Give us bread! Why must we die before your eyes, for want of money?'"
,"16":"Joseph told them, 'Give me your cattle to pay for bread since you have no money.'"
,"17":"So they brought their livestock and Joseph gave them bread in exchange for their horses, sheep and cattle and even their donkeys. In that way he supplied them with food for that year."
,"18":"The following year they came to him again and said, 'We will not hide from our lord that all our money is gone and that our cattle now belong to you. All that is left to us are our persons and our land."
,"19":"Why should we die while you look on, ourselves and our land? So buy us and our land for bread; we shall be in bondage to you and Pharaoh. Give us grain that we may live and not die and our land remain desolate.'"
,"20":"So it was that Joseph acquired all the land of Egypt for Pharaoh; all the Egyptians sold their fields, so cruelly hard-pressed were they by the famine. Pharaoh became owner of the land"
,"21":"and Joseph reduced the people to servitude from one end of Egypt to the other."
,"22":"Only the land of the priests he did not buy, because by a decree of Pharaoh they lived on what had been given to them by Pharaoh. For that reason they did not sell the land that belonged to them."
,"23":"Then Joseph said to the people, 'Now that I have bought you and your land for Pharaoh, here is seed for you to sow the land."
,"24":"At harvest time you will give a fifth to Pharaoh, and four fifths will be yours for seed for sowing, for food for yourselves and your families.'"
,"25":"They said, 'You have saved our lives. If it please my lord, we shall be Pharaoh's serfs.'"
,"26":"So Joseph introduced a statute that remains to this day, whereby a fifth of the produce goes to Pharaoh. Only the land of the priests did not become Pharaoh's."
,"27":"So Israel lived in Egypt in the land of Goshen. They became owners of this land; they had many children and greatly increased in number."
,"28":"Jacob lived for one hundred and forty-seven years, seventeen of them in the land of Egypt."
,"29":"When his life was drawing to a close he called for his son Joseph and said to him, 'If you wish to be faithful and kind to me, place your hand under my thigh and promise me that you will not bury me in Egypt!"
,"30":"But when I rest with my fathers, carry me out of Egypt and bury me in their tomb.' Joseph said, 'I will do as you say.'"
,"31":"Jacob insisted, 'Swear to it!' He swore to him and Israel fell back on his pillow."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Some time later, when Joseph was told that his father was ill, he took with him his two sons, Manasseh and Ephraim."
,"2":"So they told Jacob that Joseph his son had come. Then Israel, mustering his strength, sat up in bed."
,"3":"And he said to Joseph, 'God Almighty appeared to me at Luz in the land of Canaan and blessed me"
,"4":"saying, 'I will make you fruitful and increase your number, and I will make of you a group of nations, and I will give this land to you and to your descendants after you as an everlasting possession.'"
,"5":"From now on your two sons who were born in Egypt, before I came to you here, are mine! Ephraim and Manasseh shall be mine just as Reuben and Simeon are mine."
,"6":"Only the children born after them will be yours and the land they inherit shall be known by the names of Ephraim and Manasseh."
,"7":"When I was returning from Paddan, to my sorrow Rachel died on the journey at some distance from Ephrath, and I buried her there on the way to Ephrath, that is Bethlehem.'"
,"8":"When Israel saw Joseph's sons he said, 'Who are these?'"
,"9":"Joseph told his father, 'They are the sons that God has given me here.' Jacob said, 'Bring them to me that I may bless them.'"
,"10":"As Israel's eyes were dim with age, he could no longer see. When Jacob brought them near, he kissed and embraced them,"
,"11":"and said to Joseph, 'I didn't expect to see you again and now God is letting me see your children as well!'"
,"12":"Joseph lifted them from Israel's knees and he himself bowed low, his face to the ground."
,"13":"Joseph then took them both, Ephraim by his right hand to Israel's left, and Manasseh by his left hand to Israel's right."
,"14":"Israel raised his right hand and placed it on Ephraim's head, although he was the younger, and placed his left hand on Manasseh's head even though Manasseh was the firstborn."
,"15":"Then he blessed Joseph and said, 'May the God in whose presence my fathers Abraham and Isaac walked, the God who has been my shepherd from my birth to this day,"
,"16":"the Angel who has saved me from every evil, bless these boys. And in them may my name live on and that of my fathers Abraham and Isaac. And may they increase greatly on the earth!'"
,"17":"Joseph was displeased when he saw his father had placed his right hand on Ephraim's head. So he took his father's hand from Ephraim's head to place it on Manasseh"
,"18":"and said, 'Not like that father, for this one is the elder. Place your right hand on his head.'"
,"19":"But his father refused and said, 'I know, my son, I know; he too will be great and become a nation. Nevertheless his younger brother will be greater than he, and his descendants will become a group of nations.'"
,"20":"He blessed them that day in these words: 'Through you Israel will bestow this blessing: May God make you like Ephraim and Manasseh!',So he placed Ephraim ahead of Manasseh. "
,"21":"Then Israel said to Joseph, 'I am going to die. God will be with you and he will bring you back to the land of your fathers."
,"22":"And to you, over and above what goes to your brothers, I give a mountain slope that I took from the Amorites with my sword and my bow.'"
}`)
	CurrentBook.AddChapter(49, `{
"1":"Jacob then called his sons and said,"
,"2":"'Gather round, sons of Jacob. And listen to your father Israel!"
,"3":"Reuben, you are my firstborn, my strength and the firstfruits of my manhood! excelling in honor and excelling in power."
,"4":"Restless as water, you will excel no more for you went to your father's wife, on to my bed and defiled it."
,"5":"Simeon and Levi are brothers; their swords are weapons of violence."
,"6":"Let me not share their counsel! Let my heart keep far from their company, for in anger they killed men, and hamstrung oxen at their pleasure."
,"7":"A curse on their anger for it is fierce; a curse on their fury, so cruel! I will divide them among Jacob, and scatter them among Israel."
,"8":"Judah, your brothers will praise you!,You shall seize your enemies by the neck!,Your father's sons shall bow before you."
,"9":"Judah, a young lion!,You return from the prey, my son!,Like a lion he stoops and crouches, and like a lioness, who dares to rouse him?"
,"10":"The scepter shall not be taken from Judah, nor the ruler's staff from between his feet, until he comes to whom it belongs, and who has the obedience of the nations."
,"11":"He ties his foal to a vine, and his ass' colt to the choicest branch. He washes his garments in wine,and his robe in the juice of grapes."
,"12":"His eyes shall be red with wine, and his teeth whiter than milk."
,"13":"Zebulun lives by the seashore; he is a haven for the ships, and his flank stretches to Sidon."
,"14":"Issachar is a sturdy ass, lolling beside the sheepfolds."
,"15":"He saw that a resting place was good, and that the land was pleasant. He bends his back to the burden and submits to forced labor."
,"16":"Dan shall judge his people as one of the tribes of Israel."
,"17":"Dan shall be a serpent in the way, a viper on the path, that bites the horse's heels, making the rider fall backwards!"
,"18":"In your salvation, I hope, O Yahweh!"
,"19":"Raiders shall raid Gad, but he shall raid at their heels."
,"20":"Asher's food will be rich, and he will provide delicacies fit for a king!"
,"21":"Naphtali is a doe let loose that bears beautiful fawns."
,"22":"Joseph is a fruitful vine, a fruitful vine near a spring, whose branches climb over a wall."
,"23":"Archers attacked him fiercely,and sorely provoked him;"
,"24":"but his bow remained steady, and his arms nimble, because of the hand of the Mighty One of Jacob; because of the Shepherd, the Rock of Israel;"
,"25":"because of the God of your father, your Helper!,because of God Almighty who blesses you,with blessings from heaven above, with blessings from the deep below!,with blessings of the breast and the womb!"
,"26":"The blessings of your father are greater than the blessings of the ancient mountains, the bounty of the everlasting hills! May they all rest on the head of Joseph, on the brow of the one who is a prince among his brothers!"
,"27":"Benjamin is a ravenous wolf!,In the morning he devours his prey, and in the evening he divides the spoil!'"
,"28":"These are all the twelve tribes of Israel, and this is what his father said when he blessed them, giving each one a special and appropriate blessing."
,"29":"He then gave them these instructions: 'I am soon to be gathered to my people; bury me near my fathers, in the cave in the field of Ephron, the Hittite;"
,"30":"in the cave in the field of Machpelah, to the east of Mamre in Canaan, the field that Abraham bought from Ephron the Hittite as a burial place."
,"31":"It was there that Abraham and his wife Sarah were buried. There they buried Leah."
,"32":"The field and the cave in it were purchased from the Hittites.'"
,"33":"When Jacob had given these instructions to his sons, he drew his feet up into the bed; he breathed his last and was gathered to his people."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Joseph threw himself on his father, wept over him and kissed him."
,"2":"Then as Joseph had instructed them, his physicians embalmed Israel his father."
,"3":"This took a full forty days, the length of time required for embalming. The Egyptians mourned him for seventy days."
,"4":"When the days of mourning were over, Joseph spoke to Pharaoh's household, 'If you wish to show me kindness, please let Pharaoh know"
,"5":"that when my father was dying he made me swear that I would bury him in the tomb he had made ready for himself in Canaan. Ask him to let me go up and bury my father. I will come back again.'"
,"6":"Pharaoh said, 'Go and bury your father as he made you swear to do.'"
,"7":"Joseph went up to bury his father and with him went all Pharaoh's officials, the elders of his household and all the elders of Egypt,"
,"8":"as well as all belonging to the household of Joseph, his brothers and his father's household. Only their children, their flocks and herds were left in the land of Goshen."
,"9":"With the chariots and horsemen that went up with him it was a very imposing caravan."
,"10":"When they came to the threshing floor of Atad, near the Jordan, they carried out a solemn and long lamentation and there Joseph mourned his father for seven days."
,"11":"When the Canaanites witnessed this mourning they said, 'This is a solemn mourning ceremony of the Egyptians.' That is why this place which is east of the Jordan was called Abel Mizraim."
,"12":"Jacob's sons did as he had ordered them."
,"13":"They carried him to the land of Canaan and buried him in the cave in the field of Machpelah near Mamre that Abraham had bought from Ephron the Hittite for a burial place."
,"14":"After he had buried his father, Joseph returned to Egypt with his brothers and all those who had gone up with him for the burial."
,"15":"When Joseph's brothers realized that their father was dead they said, 'What if Joseph turns against us in hate because of the evil we did him?'"
,"16":"So they sent word to Joseph saying, 'Before he died your father told us to say this to you:"
,"17":"Please forgive the crime and the sin of your brothers in doing evil to you. Forgive the crime of the servants of your father's God.' When he was given the message, Joseph wept."
,"18":"His brothers went and threw themselves down before him. 'We are your slaves,' they said."
,"19":"But Joseph reassured them, 'Don't be afraid! Am I in the place of God?"
,"20":"You intended to do me harm, but God intended to turn it to good in order to bring about what is happening today - the survival of many people."
,"21":"So have no fear! I will provide for you and your little ones.' In this way he touched their hearts and consoled them."
,"22":"Joseph remained in Egypt together with all his father's family. He lived for a hundred and ten years,"
,"23":"long enough to see Ephraim's great-grandchildren, and also to have the children of Machir, the son of Manasseh, placed on his knees after their birth."
,"24":"Then Joseph said to his brothers, 'I am going to die, but God will surely remember you and take you from this country to the land he promised to Abraham, Isaac and Jacob.'"
,"25":"Joseph then made the sons of Israel swear, saying, 'When God comes to bring you out from here, carry my bones with you.'"
,"26":"Joseph died at the age of one hundred and ten; they embalmed him and laid him in a coffin in Egypt."
}`)

}
func EN_CCB_LoadVPLVChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Yahweh called Moses, and from the Tent of Meeting addressed him, saying,"
,"2":"'Speak to the people of Israel; say to them: When anyone brings an offering of an animal to Yahweh it can be from either his cattle or sheep and goats."
,"3":"If the offering is a burnt offering of one of his cattle, he is to offer a bull without any defect. He shall offer it at the entrance to the Tent of Meeting, so that his offering may be accepted before Yahweh."
,"4":"He is to lay his hand on the bull's head, and it shall be accepted as a sacrifice to take away his sins."
,"5":"Then he shall kill the bull before Yahweh, and the sons of Aaron, the priests, shall offer the blood. They will pour it out on the sides of the altar which stands at the entrance to the Tent of Meeting."
,"6":"Then he shall skin the victim and quarter it."
,"7":"The sons of Aaron, the priests, must put fire on the altar and arrange wood on this fire."
,"8":"Then the sons of Aaron, the priests, are to put the pieces, the head and the fat on the wood on the altar fire."
,"9":"The man shall wash the internal organs and legs in water, and the priest is to burn all of it on the altar. This will be a burnt offering and its sweet-smelling odor will please Yahweh."
,"10":"If his offering is an animal out of the flock, a lamb or a goat offered as a burnt offering, he is to offer a male without any defect."
,"11":"He shall kill it on the north side of the altar before Yahweh, and the sons of Aaron, the priests, shall pour out the blood on the sides of the altar."
,"12":"Then he is to quarter it, and the priest is to arrange the quarters, as well as the head and the fat on the wood on the altar fire."
,"13":"The man shall wash the internal organs and legs in water, and the priest shall burn all of it on the altar. This will be a burnt offering and its sweet-smelling odor will please Yahweh."
,"14":"If the man is offering a bird as a burnt offering, he is to offer a turtledove or a young pigeon."
,"15":"The priest shall offer it at the altar and wring off its head, which he is to burn on the altar; then its blood is to be drained out on the side of the altar."
,"16":"Then he shall remove the crop and the feathers: these he is to throw on the eastern side of the altar, where the ashes from the fat are placed."
,"17":"He is to divide it in two halves with a wing on each side, but without separating the two parts. Then the priest shall burn it on the altar, on the wood that is on the fire. This will be a burnt offering and its sweet-smelling odor will please Yahweh."
}`)
	CurrentBook.AddChapter(2, `{
"1":"If anyone offers Yahweh a grain offering, his offering is to be fine flour on which he is to pour wine and put incense."
,"2":"He shall bring it to the sons of Aaron, the priests; he is to take a handful of the fine flour and oil and all the incense, and the priest shall burn it on the altar as a memorial, a burnt offering whose sweet-smelling odor will please Yahweh."
,"3":"The remainder of the grain offering belongs to Aaron and his sons; this is a most holy share for it comes from the burnt offerings of Yahweh."
,"4":"When you are going to offer a grain offering of bread baked in the oven, the fine flour is to be prepared either in the form of unleavened cakes mixed with oil, or in the form of unleavened wafers spread with oil."
,"5":"If your offering is a grain offering fried on the griddle, the fine flour mixed with oil is to have no leavening."
,"6":"You must break it in pieces and pour oil over it. It is a grain offering."
,"7":"If your offering is a grain offering cooked in the pan, the fine flour is to be prepared in oil."
,"8":"You must bring to Yahweh the grain offering that has been thus prepared, presenting it to the priest, who is to bring it to the altar."
,"9":"The priest shall take part of this offering and burn it on the altar to recall before Yahweh the person who is offering it. And it will be an offering whose sweet-smelling odor will please Yahweh."
,"10":"The remainder of the grain offering belongs to Aaron and his sons; this is a most holy share of Yahweh's burnt offering."
,"11":"None of the grain offering that you offer to Yahweh is to be prepared with yeast for you must never burn yeast or honey as a burnt offering for Yahweh."
,"12":"You may offer them up to Yahweh, as an offering of firstfruits, but they must not go up as a sweet-smelling odor to please Yahweh."
,"13":"You must salt every grain offering that you offer, and you must never fail to put on your grain offering the salt of the Covenant with your God: to every offering you are to join an offering of salt to Yahweh your God."
,"14":"If you offer Yahweh a grain offering of firstfruits, it may be from either roasted corn or bread made from ground corn."
,"15":"You are to add oil to it and put incense on it; it is a grain offering"
,"16":"and the priest is to burn part of the bread and oil (together with all the incense) as a burnt offering for Yahweh."
}`)
	CurrentBook.AddChapter(3, `{
"1":"If anyone offers a peace sacrifice, offering from his cattle, male or female, whatever he offers before Yahweh must be without any defect."
,"2":"He is to lay his hand on the victim's head and kill it at the entrance to the Tent of Meeting. Then the sons of Aaron, the priests, shall pour out the blood on the sides of the altar."
,"3":"Then he is to offer the following as a burnt offering for Yahweh: the fat that covers the internal organs, all the fat that is on the internal organs,"
,"4":"the two kidneys, the fat on them and on the loins, the best part which he is to remove from the liver and kidneys."
,"5":"The sons of Aaron shall burn all this on the altar along with the burnt offering, on the wood on the fire. It will be a burnt offering and its sweet-smelling odor will please Yahweh."
,"6":"If he offers a sheep or goat as a peace offering for Yahweh, he is to offer a male or female without any defect."
,"7":"If he offers a sheep, he is to offer it before Yahweh;"
,"8":"he is to lay his hand on the sheep's head and kill it in front of the Tent of Meeting; then the sons of Aaron shall pour out its blood on the sides of the altar."
,"9":"Of the peace offering he is to offer the following as a burnt offering for Yahweh: the fat, all the tail taken off near the backbone, the fat that covers the internal organs, all the fat that is on the internal organs,"
,"10":"the two kidneys, the fat that is on them and on the loins, the best part which he will remove from the liver and kidneys."
,"11":"The priest shall burn this part on the altar as food, as a burnt offering for Yahweh."
,"12":"If his offering is a goat, he is to offer it before Yahweh:"
,"13":"he is to lay his hand on the goat's head and kill it in front of the Tent of Meeting, and the sons of Aaron shall pour out its blood on the sides of the altar."
,"14":"Then he is to offer the following as a burnt offering for Yahweh: the fat that covers the internal organs, all the fat that is on the internal organs,"
,"15":"the two kidneys, the fat that is on them and on the loins, the best part which he will remove from the liver and kidneys."
,"16":"The priest shall burn these pieces on the altar as food, as a burnt offering for Yahweh."
,"17":"All the fat belongs to Yahweh. This is a law forever for all your descendants, wherever they may live: never eat either fat or blood.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Yahweh spoke to Moses; he said:"
,"2":"'Speak to the people of Israel and say: Anyone may sin without intending to do so against any of the commandments of Yahweh and do one of the forbidden things; in such a case:"
,"3":"If the one who sins is the anointed priest, his sin defiles the people. Then, for the sin which he has committed, he is to offer to Yahweh a young bull, an animal from the herd without any defect, as a sacrifice for sin."
,"4":"He is to bring the bull before Yahweh at the entrance to the Tent of Meeting, and lay his hand on its head and kill it before Yahweh."
,"5":"Then the anointed priest shall take a little of the blood of the bull and take it into the Tent of Meeting."
,"6":"He shall dip his finger in the blood and sprinkle it over the veil of the sanctuary seven times, before Yahweh."
,"7":"Then the priest shall put a little of the blood of the bull on the corners of the altar of incense that sends up smoke before Yahweh in the Tent of Meeting and he is to pour all the rest of the bull's blood at the foot of the altar for burnt offerings that is at the entrance to the Tent of Meeting."
,"8":"From this bull offered as a sacrifice for sin, the priest will remove all the fat: the fat that covers the internal organs, all the fat that is on the internal organs,"
,"9":"the two kidneys, the fat that is on them and on the loins, the best part which he will remove from the liver and kidneys,"
,"10":"exactly as was done with what was set apart in the peace offering, and the priest shall burn these on the altar for burnt offerings."
,"11":"The bull's skin, all its flesh, its head, legs, internal organs and intestines,"
,"12":"the whole of the bull, must be carried outside the camp to a place that is clean, the place where the ashes from the fat are thrown away, and the bull must be burnt there."
,"13":"If the whole community of Israel has sinned without intending to do so, and, without being aware of it, has done something that is forbidden by the commandments of Yahweh,"
,"14":"the community is to offer a young bull as sacrifice for sin, an animal of the herd without any defect, as soon as the sin of which they have been guilty is discovered. The animal must be brought before the Tent of Meeting;"
,"15":"the elders of the community shall lay their hands on the bull's head before Yahweh, and it must be killed before Yahweh."
,"16":"Then the anointed priest is to carry a little of the blood of the bull into the Tent of Meeting."
,"17":"He is to dip his finger in the blood and sprinkle it on the veil before Yahweh seven times."
,"18":"Then he shall put a little of the blood on the corners of the altar that stands before Yahweh inside the Tent of Meeting, and pour out all the rest of the blood at the foot of the altar for burnt offerings at the entrance to the Tent of Meeting."
,"19":"Then the priest shall remove all the fat from the animal and burn it on the altar."
,"20":"He shall do the same thing with this bull as he did with the bull for the sacrifice of sin. When the priest has performed the sacrifice for the people's sin, they will be forgiven."
,"21":"The priest must have the bull taken out of the camp and burn it as he burned the first one. This is the sacrifice for the sin of the community."
,"22":"When a leader sins and without intending to do so does one of the things forbidden by the commandments of Yahweh his God, thus becoming guilty,"
,"23":"and after that he recalls it, or anyone calls his attention to the sin thus committed, he is to bring a goat as an offering, a male without any defect."
,"24":"He is to lay his hand on the goat's head and kill it in the place where the animals for the burnt offerings are killed. This is a sacrifice for sin:"
,"25":"the priest shall take a little of the goat's blood on his finger and put it on the corners of the altar for burnt offerings. Then he shall pour out its blood at the foot of the altar for burnt offering"
,"26":"and burn all the fat on the altar, as with the fat in the peace offering. This is how the priest is to offer the sacrifice for the sin of this leader to free him from his sin, and he will be forgiven."
,"27":"If one of the people sins without intending to do so and makes himself guilty by doing something forbidden by the commandments of Yahweh,"
,"28":"and after that he recalls it or anyone calls his attention to the sin he has committed, he is to bring a goat as an offering, a female without any defect."
,"29":"He is to lay his hand on the goat's head and kill it in the place where the animals for the burnt offerings are killed."
,"30":"The priest shall take a little of the goat's blood on his finger and put it on the corners of the altar for burnt offerings. Then he shall pour out all the rest of the blood at the foot of the altar."
,"31":"He shall remove all the fat, as the fat was removed for the peace offering, and the priest shall burn it on the altar as a sweet-smelling sacrifice pleasing to Yahweh. This is how the priest is to offer the sacrifice for the man's sin, and he will be forgiven."
,"32":"If anyone wishes to bring a lamb as an offering for this kind of sacrifice, he is to bring a female without any defect."
,"33":"He is to lay his hand on the lamb's head and kill it as a sacrifice for sin in the place where the animals for the burnt offerings are killed."
,"34":"The priest shall take a little of the blood of this sacrifice on his finger and put it on the corners of the altar for burnt offerings. Then he shall pour out all the rest of the blood at the foot of the altar."
,"35":"He shall remove its fat as was done for the sheep in the peace offering, and the priest shall burn it all on the altar, in addition to the burnt offering for Yahweh. This is how the priest is to offer the sacrifice for the man's sin, and he will be forgiven."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Sacrifice for sin is required in the following cases: A man should have come forward to give evidence in court when officially summoned; but he did not speak and give information about something he had seen or heard; and so he is guilty."
,"2":"Or else he accidentally touches something unclean, whatever it may be - the dead body of an unclean animal, wild or tame; or the dead body of one of the unclean beings that swarm - and so without realizing it, he becomes unclean, and guilty."
,"3":"Or else he accidentally touches some human uncleanness, whatever it may be, and contact with it makes him unclean; so he becomes guilty as soon as he realizes what he has done."
,"4":"Or else a man makes a careless vow to do either evil or good in any of those matters on which a man may swear unthinkingly; he does not notice it, then, but when he realizes it later, he becomes guilty."
,"5":"He who is guilty in any of these cases, shall confess the sin committed,"
,"6":"and bring to Yahweh as a sacrifice for the sin committed a female of the flock (sheep or goat); and the priest shall offer the sacrifice for the man's sin to free him from his sin."
,"7":"If a man cannot afford a sheep or a goat, he shall offer to Yahweh, as payment for the sin he has committed, two turtledoves or two young pigeons, one for a sacrifice for sin and the other for a burnt offering."
,"8":"He will bring them to the priest who is to offer first the one intended for the sacrifice for sin. The priest shall wring its neck, without removing the head."
,"9":"He shall sprinkle the side of the altar with the victim's blood, and then drain out the rest of the blood at the foot of the altar. This is a sacrifice for sin."
,"10":"Of the other bird he is to make a burnt offering according to the regulations. When the priest offers the sacrifice for the man's sin, he will be forgiven."
,"11":"If this man cannot afford two turtledoves or two young pigeons, he is to bring two pounds of flour as an offering for the sin committed; but he shall not mix oil with it or put incense on it, for it is a sacrifice for sin."
,"12":"He is to bring it to the priest, who is to take a handful of it to be put on the burnt offering for Yahweh in order to recall this man to Yahweh. This is a sacrifice for sin."
,"13":"This is how the priest is to offer the sacrifice for the sin the man committed in any of these cases, and he will be forgiven. In this case, as in the case of a grain offering, the rest of the flour belongs to the priest.'"
,"14":"Yahweh spoke to Moses; he said:"
,"15":"'If anyone is guilty of unintentionally cheating by failing to hand over the payments that are sacred to Yahweh, he is to bring to Yahweh as a sacrifice of payment a ram with no defects. This ram is to be valued according to the official standard. This is a sacrifice of repayment."
,"16":"He must make the payments he has failed to hand over, pay an extra fifth as well, and give it to the priest. The priest shall offer the ram as a sacrifice for the man's sin and he will be forgiven."
,"17":"If anyone sins and does one of the things forbidden by the commandments of Yahweh without realizing it, he is guilty and must pay the penalty for his fault."
,"18":"As a sacrifice of repayment he is to bring to the priest a ram without any defect. Its value will be according to the official standard. The priest shall offer the sacrifice for the sin he has committed without realizing it and he will be forgiven."
,"19":"This is a sacrifice of repayment for the man was guilty in the eyes of Yahweh.'"
,"20":"Yahweh spoke to Moses; he said:"
,"21":"'This refers to the man who sins against Yahweh by not returning to his neighbor a deposit or a security, or withholding something due to him or cheating him;"
,"22":"and also to the one who finds lost property and swears he has not found it; and also to the man who swears falsely in one of the cases in which people usually swear."
,"23":"In all these cases the man who sins and becomes guilty is to give back what he has taken or demanded that does not belong to him: the deposit entrusted to him, the lost property that he found,"
,"24":"or any object about which he has sworn untruthfully. He must repay the owner in full and give an extra fifth as well on the day when he is found guilty."
,"25":"Then he is to bring a ram without any defect to Yahweh as a sacrifice of repayment."
,"26":"The priest shall offer the sacrifice for the man's sin and he will be forgiven, whatever the act of which he became guilty.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Yahweh spoke to Moses; he said:"
,"2":"'Give these regulations to Aaron and his sons. This is the regulation for burnt offerings: the burnt offering shall stay on the altar all night until morning and the fire is to be kept burning."
,"3":"The priest is to put on his linen shirt and his linen drawers. Then he must remove the greasy ashes of the sacrifice consumed by the altar fire and place them at the side of the altar."
,"4":"Then he is to change his clothes and carry the ashes to some place that is clean, outside the camp."
,"5":"The fire that consumes the burnt offering on the altar must not be allowed to go out. Every morning the priest must put firewood on it, arrange the burnt offering on it and burn the fat from the peace offerings."
,"6":"An undying fire is always to burn on the altar; it must not go out."
,"7":"This is the regulation for the grain offering: One of the priests, a son of Aaron, is to bring it into the presence of Yahweh in front of the altar;"
,"8":"he is to take a handful of the fine flour (with the oil and incense which have been added to it) and burn it on the altar as a memorial, to recall to Yahweh the person making the offering so that it becomes a sweet-smelling odor pleasing to Yahweh."
,"9":"After that, the remainder is to be given to Aaron and his sons; they shall eat it in the form of unleavened loaves. They are to eat it in a sacred place within the courtyard of the Tent of Meeting."
,"10":"The share I give them of my burnt offering must not be baked with yeast. It is most holy, like the sacrifice for sin and the sacrifice of repayment."
,"11":"All the males of Aaron's family may eat this part of Yahweh's burnt offering - this is a law forever for all your descendants. Everything that touches the offering becomes consecrated as well.'"
,"12":"Yahweh spoke to Moses; he said:"
,"13":"'This is the offering that Aaron and his sons are to make to Yahweh on the day of their anointing as priests: two pounds of flour as a daily offering, half in the morning and half in the evening."
,"14":"It must be fried on the griddle and mixed with oil; you must bring the paste as a grain offering in several pieces, offering them as a sweet-smelling odor pleasing to Yahweh."
,"15":"Every descendant of Aaron who succeeds him as high priest shall do the same. This is a law forever. This grain offering shall be completely burned as a sacrifice for Yahweh."
,"16":"Every grain offering made by a priest must be a total sacrifice; none of it is to be eaten.'"
,"17":"Yahweh spoke to Moses; he said,"
,"18":"'Say to Aaron and his sons: This is the regulation for the sacrifice for sin: The victim for the sacrifice is to be killed before Yahweh in the place where the animals for the burnt offerings are killed. It is a most holy offering. "
,"19":"The priest who offers this sacrifice is to eat it. It must be eaten in a holy place within the courtyard of the Tent of Meeting."
,"20":"Everything that touches the flesh of this animal will become consecrated; if any of the blood splashes on clothing, the stain must be cleaned in some holy place."
,"21":"The clay pot in which the meat is cooked must be broken; if a bronze pot has been used for the cooking, it must be scrubbed and thoroughly rinsed with water."
,"22":"Any male who is a priest may eat the meat. It is a most holy thing."
,"23":"But no one may eat any part of the animals offered for sin, whenever any of the blood is brought into the Tent and used in the sacrifice to take away sin. The meat must be thrown on the fire."
}`)
	CurrentBook.AddChapter(7, `{
"1":"This is the regulation for the sacrifice of repayment:"
,"2":"It is a most holy offering. The animal for this offering is to be killed in the place where the animals for the burnt offerings are killed, and the priest must pour out the blood on the sides of the altar."
,"3":"Then he is to offer all the fat: the tail, the fat that covers the internal organs,"
,"4":"the two kidneys, the fat that is on them and on the loins, and the best part which he will remove from the liver and kidneys."
,"5":"The priest must burn these pieces on the altar as a burnt offering for Yahweh. This is a sacrifice of repayment."
,"6":"Any male who is a priest may eat it, but it must be eaten in a holy place because it is a most holy thing."
,"7":"As with the sacrifice for sin, so with the sacrifice of repayment; the regulation is the same for both. The offering which he has used in the sacrifice for sin belongs to the priest."
,"8":"The skin of the animal presented by a man to the priest to be offered as a burnt offering belongs to the priest."
,"9":"Every grain offering baked in the oven, every grain offering fried in the pan or on the griddle shall belong to the priest who offered it."
,"10":"Every grain offering, mixed with oil or dry, is to belong to all the sons of Aaron equally."
,"11":"This is the regulation for the peace offering presented to Yahweh:"
,"12":"If it is offered as a thanksgiving offering, there must be added to it an offering of unleavened cakes mixed with oil, unleavened wafers spread with oil, and fine flour in the form of cakes mixed with oil."
,"13":"This offering, then, must be added to the loaves of leavened bread and to the thanksgiving offering."
,"14":"One of the cakes of this offering is to be presented as an offering to Yahweh; it shall belong to the priest who pours out the blood of the peace offering."
,"15":"The flesh of the animal must be eaten on the day when the offering is made; nothing must remain until the next morning."
,"16":"If the animal is presented before Yahweh as a sacrifice freely offered, it is to be eaten on the day it is offered and also on the following day;"
,"17":"but on the third day whatever remains of the animal's flesh must be thrown on the fire."
,"18":"If the meat offered as a peace offering is eaten on the third day, the man who has offered it shall not be accepted nor receive credit for it, for it is defiled meat, and the man who eats it should suffer the penalty of his fault."
,"19":"If this meat has touched anything unclean, it cannot be eaten; and must be thrown on the fire."
,"20":"Anyone who is clean may eat meat of the peace offering, but whoever eats the meat of a peace offering presented to Yahweh even though he is unclean shall be cut off from his people."
,"21":"If anyone touches anything unclean, whether human or animal, or any crawling creature, and then eats the meat of a peace offering presented to Yahweh, this man shall be cut off from his people."
,"22":"Yahweh spoke to Moses; he said,"
,"23":"'Speak to the people of Israel and say to them: You must not eat the fat of ox, sheep or goat. "
,"24":"The fat of an animal that has died a natural death or been killed by a wild animal may be used for any other purpose, but you must not eat it."
,"25":"Anyone who eats the fat of an animal offered as a burnt offering to Yahweh shall be cut off from his people."
,"26":"Wherever you live, you must not eat blood, whether it be of bird or animal."
,"27":"Anyone who eats blood, whoever he may be, shall be cut off from his people.'"
,"28":"Yahweh spoke to Moses; he said,"
,"29":"'Speak to the people of Israel and say to them: Anyone who offers a peace offering to Yahweh is to bring himself the part of his sacrifice that is offered to Yahweh. "
,"30":"He is to bring Yahweh's burnt offering, that is, the fat that is near the breast and also the breast, with his own hands. Then he will make the gesture of offering before Yahweh."
,"31":"The priest shall burn the fat on the altar, and the breast shall belong to Aaron and his sons."
,"32":"You must set aside and give to the priest the right hind leg from your peace offering."
,"33":"The right hind leg shall be the share of the son of Aaron who offers the blood and fat of the peace offering."
,"34":"Thus, I keep back this breast and hind leg out of every peace offering presented by the sons of Israel, and give these to Aaron the priest and to his sons: this is a law for the sons of Israel forever.'"
,"35":"This is the share of Aaron and his sons in Yahweh's burnt offerings since the day he called them to be his priests."
,"36":"This is what Yahweh commands the sons of Israel to give them from the day they are ordained as priests: this is a law for all their descendants for all time to come."
,"37":"Such is the regulation for burnt offerings, grain offerings, sacrifices for sin, sacrifices of repayment, ordination and peace offerings."
,"38":"This is what Yahweh commanded Moses on Mount Sinai when he told the people of Israel to make their offerings to Yahweh in the wilderness of Sinai."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Yahweh spoke to Moses; he said:"
,"2":"'Take Aaron, his sons with him, and the vestments, the anointing oil, the bull for the sacrifice for sin, the two rams and the basket of unleavened bread."
,"3":"Then call the whole community together at the entrance to the Tent of Meeting.'"
,"4":"Moses did as Yahweh commanded; the community gathered at the entrance to the Tent of Meeting,"
,"5":"and Moses said to them, 'This is what Yahweh has commanded.'"
,"6":"He made Aaron and his sons come forward, and washed them with water."
,"7":"He put the shirt on Aaron, passed the sash around his waist, dressed him in the robe and put the Ephod on him. Then he tied around his waist the woven band of the Ephod with which he clothed him."
,"8":"He put the embroidered linen Breastpiece on him, and placed the Urim and Thummim in it."
,"9":"He put the turban on his head, with the golden ornament on the front; this is the sacred sign of dedication as Yahweh commanded Moses to do."
,"10":"Then Moses took the anointing oil and anointed the Holy Tent and everything in it, to consecrate them."
,"11":"He sprinkled the altar seven times, and anointed the altar and its furnishings, the basin and its stand, to dedicate them all to Yahweh."
,"12":"Then he ordained Aaron by pouring the anointing oil on his head."
,"13":"Then Moses made Aaron's sons come forward; he put the shirts on them, tied the sashes around their waists and put on their headdresses, as Yahweh had commanded him to do."
,"14":"Then he had the bull for the sacrifice for sin brought forward. Aaron and his sons laid their hands on the bull's head"
,"15":"and Moses slaughtered it. Then he took the blood and with his finger put some of it on the corners around the altar, to take away its sin. Then he poured out the rest of the blood at the foot of the altar, which he dedicated to Yahweh by performing the atonement over it."
,"16":"Then he took all the fat that covers the internal organs, the best part of the liver, the two kidneys and their fat; and he burned them all on the altar."
,"17":"After that he burned outside the camp the bull's skin, its flesh and its intestines as Yahweh had commanded him to do."
,"18":"Then he had the ram for the burnt offering brought forward. Aaron and his sons laid their hands on its head"
,"19":"and Moses slaughtered it. He poured its blood out on the sides of the altar."
,"20":"Then he quartered the ram and burned the head, the pieces and the fat."
,"21":"He washed the internal organs and legs, and burned the whole ram on the altar. This was a burnt offering, a sweet-smelling offering to Yahweh, a burnt offering by fire for Yahweh, as Yahweh had commanded Moses."
,"22":"Then he had the other ram brought forward, for the sacrifice of ordination of priests. Aaron and his sons laid their hands on the ram's head"
,"23":"and Moses slaughtered it. He took some of its blood and put it on the lobe of Aaron's right ear, the thumb of his right hand, and the big toe of his right foot."
,"24":"Then he made the sons of Aaron come forward and he put some of the blood on the lobes of their right ears, the thumbs of their right hands and the big toes of their right feet. Next Moses poured the rest of the blood on the sides of the altar."
,"25":"Then he took the fat: the tail, all the fat that is on the internal organs, the best part of the liver, the two kidneys and their fat, and the right hind leg."
,"26":"From the basket of unleavened bread placed before Yahweh, he took an unleavened cake, a loaf of bread made with oil, and a wafer; he placed these on the fat and the right hind leg,"
,"27":"put it all into Aaron's hands and those of his sons, who waved them before Yahweh."
,"28":"Then Moses took them back and burned them on the altar in addition to the burnt offering. This was the sacrifice for ordination of priests, a sweet-smelling offering to Yahweh, an offering by fire to Yahweh."
,"29":"Then Moses took the breast and made the gesture of offering before Yahweh. This was the share of the ram of ordination for Moses, as Yahweh had commanded."
,"30":"Then Moses took the anointing oil and the blood that was on the altar and sprinkled Aaron and his vestments with it, and his sons and their vestments. In this way he consecrated Aaron and his vestments, and his sons and their vestments to Yahweh."
,"31":"Then Moses said to Aaron and his sons, 'Cook the meat at the entrance to the Tent of Meeting, and eat it there, and also the bread for the sacrifice of priestly ordination that is in the basket, as I commanded, when I said: Aaron and his sons are to eat it."
,"32":"What remains of the meat and bread you will burn."
,"33":"For seven days you must not leave the entrance to the Tent of Meeting, until the time of your ordination is over, for your hands will be consecrated for seven days."
,"34":"All that we have done today is the rite of atonement for you as Yahweh has commanded us to do"
,"35":"and for seven days, day and night, you must remain at the entrance to the Tent of Meeting, doing what Yahweh has commanded, lest you die. For this is the commandment I received.'"
,"36":"And Aaron and his sons did everything that Yahweh had commanded through Moses."
}`)
	CurrentBook.AddChapter(9, `{
"1":"On the eighth day Moses called Aaron and his sons and the elders of Israel."
,"2":"He said to Aaron, 'Take a calf to offer a sacrifice for sin, and a ram for a burnt offering, both without any defect, and bring them before Yahweh."
,"3":"Then say to the people of Israel, 'Take a goat to be offered as a sacrifice for sin, and as burnt offering a calf and a lamb both one year old and without any defect,"
,"4":"and for peace offering an ox and a ram to be slaughtered before Yahweh; and finally a grain offering mixed with oil. For Yahweh will appear to you today.'"
,"5":"They brought what Moses had commanded in front of the Tent of Meeting; then the whole community gathered and stood before Yahweh."
,"6":"Moses said, 'This is what Yahweh has commanded to be done, so that his glory may appear to you.'"
,"7":"Moses then said to Aaron, 'Go to the altar and offer your sacrifice for sin and your burnt offering to take away your sins. Then present the people's offering to take away their sins as Yahweh has commanded.'"
,"8":"Aaron went to the altar and slaughtered the calf as a sacrifice for his own sin."
,"9":"Then the sons of Aaron presented the blood to him; he dipped his finger in it and put some on the corners of the altar, and then poured out the rest of the blood at the foot of the altar."
,"10":"The fat of the sacrifice for sin and the kidneys and the best part of the liver, he burned on the altar, as Yahweh had commanded Moses;"
,"11":"the flesh and the skin he burned outside the camp."
,"12":"Next Aaron slaughtered the animal which was for his own burnt offering; his sons handed him the blood and he poured it on the sides of the altar."
,"13":"Then they handed him the quartered animal and its head too, and he burned these on the altar."
,"14":"He washed the internal organs and legs and burned them on the altar in addition to the burnt offering."
,"15":"He then presented the people's offering. He took the goat for the people's sacrifice for sin, killed it and offered it as a sacrifice for sin in the same way as the first."
,"16":"Then he had the animal for the burnt offering brought forward and offered it according to the regulations."
,"17":"Next he had the grain offering brought forward, took a handful of it and burned it on the altar in addition to the morning burnt offering."
,"18":"Finally, he slaughtered the ox and the ram as a peace offering for the people. Aaron's sons handed him the blood and he poured it out on the sides of the altar."
,"19":"The fat of the ox and of the ram - the tail, the fatty covering, the kidneys, the best part of the liver -"
,"20":"all of this he laid on the breasts and burned it all on the altar."
,"21":"With the breasts and the right hind leg Aaron made the gesture of offering by waving them as Yahweh had commanded."
,"22":"Then Aaron raised his hands toward the people and blessed them. Having thus performed the sacrifice for sin, the burnt offering and the peace offering,"
,"23":"he came down and entered the Tent of Meeting with Moses. Then they came out together to bless the people and the Glory of Yahweh appeared to the whole people -"
,"24":"a flame leaped forth from before Yahweh and consumed the burnt offering and the fat that was on the altar. At this sight the people shouted for joy and fell on their faces."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Nadab and Abihu, sons of Aaron, each took his censer, put fire in it and incense on the fire, and presented unlawful fire before Yahweh, fire which he had not commanded them to present."
,"2":"Then from Yahweh's presence a flame leaped out and burned them to death in the presence of Yahweh."
,"3":"And Moses said to Aaron, 'That is what Yahweh meant when he said: 'I will show my holiness through those who approach me, and before all the people I will show my glory.',And Aaron had to remain silent."
,"4":"Moses called Mishael and Elzaphan, sons of Aaron's uncle Uzziel, and said to them, 'Come and take the corpses of your brothers far away from the sanctuary, out of the camp.'"
,"5":"They came and carried them away, still in their shirts, out of the camp as Moses had commanded."
,"6":"Moses said to Aaron and his sons Eleazar and Ithamar, 'Do not leave your hair uncombed nor tear your clothes to show that you are mourning; lest you die and the punishment extend to the whole community. All the people of Israel shall mourn the death of your brothers, who died because of Yahweh's fire."
,"7":"But you shall not leave the entrance to the Tent of Meeting, lest you die; for the anointing oil of Yahweh is on you.' And they obeyed Moses."
,"8":"Yahweh spoke to Aaron; he said:"
,"9":"'Before coming to the Tent of Meeting, you and your sons with you, do not drink wine or strong drink; lest you die. This is a law for all your descendants for all time to come,"
,"10":"so that you may be able to recognize the difference between what belongs to God and what is for general use, between what is clean and what is unclean."
,"11":"For you must teach the people of Israel all the laws that Yahweh has given for them through Moses.'"
,"12":"Moses said to Aaron and his two remaining sons, Eleazar and Ithamar, 'Take the grain offering that is left over from Yahweh's burnt offering, and eat it without leaven beside the altar, because it is a most holy thing."
,"13":"Eat it in a holy place for it is the share of Yahweh's burnt offering which belongs to you and your sons. This is what Yahweh commanded me."
,"14":"The breast that was offered up and the hind leg that was set aside you will eat in some place that is clean, you and your sons and your daughters with you; this is the share of the peace offerings of the people of Israel that belongs to you and your sons."
,"15":"The hind leg that was set aside and the breast that was offered up, when the fat was burned, belong to you, to you and your sons with you, after they have been presented before Yahweh by the gesture of offering, because Yahweh has commanded this forever.'"
,"16":"Then Moses inquired about the goat offered as a sacrifice for sin, and found that they had burned it. He was angry with Eleazar and Ithamar, Aaron's two remaining sons."
,"17":"'Why,' he asked, 'did you not eat this goat in the holy place? For it is a most holy thing given to you to bear and take away the fault of the community."
,"18":"Since its blood was not taken inside the sanctuary, you should have eaten its flesh there, as I commanded you.'"
,"19":"Aaron said to Moses, 'They have offered their sacrifice for sin and their burnt offering before Yahweh on this day of mourning. If I had eaten the goat offered in sacrifice for sin today, would that have seemed good to Yahweh?'"
,"20":"And when Moses heard this, he was satisfied."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Yahweh spoke to Moses and Aaron and said to them,"
,"2":"'Speak to the people of Israel and say: 'Of all the animals on the earth these are the animals you may eat. "
,"3":"You may eat any animal that has divided hoofs, divided into two parts, and that also chews the cud."
,"4":"You may not eat: the camel, because though it chews the cud, it does not have divided hoofs;"
,"5":"the rabbit, because though it chews the cud, it does not have divided hoofs;"
,"6":"the hare, as well;"
,"7":"the pig, because though it has divided hoofs, it does not chew the cud."
,"8":"You must not eat the meat of such animals nor their dead bodies; they are unclean for you."
,"9":"Of all that lives in water you may eat anything that has fins and scales, and lives in sea or river."
,"10":"But anything living in sea or river that does not have both fins and scales must not be eaten."
,"11":"They are unclean for you; you shall not eat their flesh nor even touch their dead bodies."
,"12":"Anything that lives in water, but does not have fins and scales, is unclean for you."
,"13":"Among the birds, here are those you must consider unclean and not eat:"
,"14":"the vulture, the eagle, the osprey, the hawk, the several kinds of buzzards,"
,"15":"all kinds of ravens,"
,"16":"the ostrich, the screech owl, the seagull,"
,"17":"the horned owl, the night owl, the seabird, the barn owl,"
,"18":"the ibis, the pelican, the white vulture,"
,"19":"the stork, the several kinds of heron, and the bat."
,"20":"All winged insects that move on four feet shall be unclean for you."
,"21":"Of all the winged insects you may eat only the following: those that have legs above their feet so that they can leap over the ground."
,"22":"These are the ones you may eat: the several kinds of locusts, crickets and grasshoppers."
,"23":"But all other winged insects that have four legs you are to consider unclean."
,"24":"Anyone who touches"
,"25":"or picks up the dead bodies of one of these animals will be unclean until evening."
,"26":"The same with animals that have hoofs, unless their hoofs are divided and they chew the cud;"
,"27":"and also four-footed animals which walk on the flat of their feet."
,"28":"Anyone who picks up their dead bodies must wash his clothing and will be unclean until evening."
,"29":"These are the small animals crawling on the ground that shall be unclean for you: rats, mice and several kinds of lizards:"
,"30":"the gecko, the chameleon, the agama, the skink and the mole."
,"31":"Anyone who touches them when they are dead will be unclean until evening."
,"32":"Anything on which the dead body of any of these creatures falls becomes unclean: wooden utensil, clothing, skin, sackcloth - any utensil at all. It must be dipped in water and will remain unclean until evening: then it will be clean."
,"33":"If the creature falls into a clay pot, the pot must be broken; whatever the pot contains is unclean."
,"34":"Any food on which water from such a pot has poured will be unclean."
,"35":"Anything on which the dead body of such a creature may fall will be unclean: if it is a clay stove or oven, this must be broken; for they are unclean and you must treat them as unclean."
,"36":"A spring or cistern for collecting water remains clean; but whoever touches the dead body becomes unclean."
,"37":"If one of their dead bodies falls on any seed whatever, the seed will remain clean;"
,"38":"but if the seed has been wet, and such a dead body falls on it, then you must consider it unclean."
,"39":"If one of the animals that you use as food dies, then anyone who touches the dead body will be unclean until evening;"
,"40":"anyone who eats the meat of the dead animal must wash his clothing and will be unclean until the evening. And anyone who picks up the dead body will also be unclean until the evening and has to wash his clothing."
,"41":"All the creatures that swarm on the ground are unclean and may not be eaten."
,"42":"Everything that crawls on its belly or goes on four legs, or has many legs, may not be eaten."
,"43":"Do not defile yourselves with any swarming creature that might defile you,"
,"44":"for I am Yahweh your God. Take the way of holiness and be holy, for I am holy. Do not make yourselves unclean with any of the creatures that swarm on the ground, "
,"45":"for I am Yahweh who brought you from the land of Egypt, that I might be your God. Be holy because I am holy."
,"46":"This is the law for animals and birds and for every living creature that moves in the water or that crawls on the ground."
,"47":"Let everyone distinguish between the clean and the unclean, between creatures that may be eaten and creatures that may not.'"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Yahweh spoke to Moses:"
,"2":"'Say to the Israelites: when a woman gives birth to a male child, she shall be unclean for seven days as in the days of her monthly period."
,"3":"On the eighth day the child is to be circumcised;"
,"4":"then she shall wait for thirty-three days to be purified of her bleeding. She shall not touch anything that is consecrated nor enter the sanctuary until the days of her purification are completed."
,"5":"If she gives birth to a daughter she shall be unclean for two weeks as in her menstruation; then she shall wait sixty-six days to be purified from her bleeding."
,"6":"And when the days of her purification are completed whether for a son or daughter, she shall bring to the priest at the door of the Tent of Meeting, a lamb born that year for a burnt offering, and a young pigeon or a turtledove for a sin offering."
,"7":"The priest shall then offer it to Yahweh to make atonement for her and she shall be cleansed from the flow of her blood. This is the law for the woman who gives birth to a child, male or female. "
,"8":"But if she cannot offer a lamb, she shall take two turtledoves or two young pigeons, the one for a burnt offering, the other for a sin offering. The priest shall make atonement for her and she will be purified.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Yahweh said to Moses and Aaron,"
,"2":"'If someone has a boil, an inflammation or a sore on his skin which could develop into leprosy, he must be brought to Aaron the priest, or to one of the priests, his descendants."
,"3":"The priest shall examine him and if the hair on the sore has turned white and the sore appears to be deeper than the surrounding skin, then it is indeed the sore of leprosy. When the priest sees this, he shall declare that person unclean."
,"4":"But if the sore is white and does not appear to be deeper than the skin around it and the hairs have not turned white, the priest is to isolate the sick person for seven days."
,"5":"On the seventh day the priest shall again examine him. If he sees that the sore looks the same and has not spread on the skin, he shall isolate the sick person for another seven days and once more examine him on the seventh day."
,"6":"If the sore has faded and has not spread on the skin, the priest shall declare that person clean: it was only eczema. Let him wash his clothes and he will be clean."
,"7":"But if the sore spreads over the skin after the sick person has been examined by the priest and declared clean, then he must present himself again to the priest."
,"8":"After examining him and finding that the sore has spread over the skin, the priest must declare him unclean: it is leprosy."
,"9":"When a leprous disease strikes a man, he must be taken to the priest,"
,"10":"who must examine him, and if he finds on the skin a whitish swelling which turns the hairs white and an ulcer is forming,"
,"11":"then it is leprosy in the skin and the priest must declare him unclean. It is useless to isolate him for a time; he is unclean."
,"12":"But if the leprosy spreads all through the skin, if it covers him entirely from head to foot so far as the priest can see,"
,"13":"then the priest must examine the sick person and, if he finds that the leprosy covers his whole body, declare the sick person clean. Since it has all turned white, he is clean."
,"14":"But as soon as an open sore appears on him, he will be unclean."
,"15":"After examining the sore, the priest is to declare him unclean: the open sore is leprous."
,"16":"But if the sore becomes white again, the man must go to the priest."
,"17":"The priest shall examine him and if he finds that the disease has turned white, he shall declare the sick person clean: he is clean."
,"18":"When an ulcer appears on a person's skin, which, after healing,"
,"19":"leaves a whitish swelling or a shiny spot of reddish white, that person must show himself to the priest."
,"20":"The priest shall examine him, and if he finds a spot deeper than the surrounding skin and the hairs in it have turned white he shall declare him unclean: it is a case of leprosy that has broken out in a boil."
,"21":"But if on examination the priest finds neither white hair in it nor a deep spot on the skin, but it is lighter in color, he shall isolate the sick person for seven days."
,"22":"If the disease has indeed spread over the skin, he shall declare him unclean: it is a case of leprosy."
,"23":"But if the shiny spot remains unchanged and has not spread, then it is only the scar of a boil and the priest is to declare the man clean."
,"24":"If someone has had a burn, and on the burn an ulcer forms, a shiny spot reddish white or whitish in color,"
,"25":"then the priest must examine it. If he finds that the hairs in that spot have turned white and it seems to be deeper than the surrounding skin, this means that leprosy has broken out in the burn. The priest shall declare the man unclean: it is a case of leprosy."
,"26":"If on the other hand the priest on examination does not find white hair on the mark and it is not deeper than the surrounding skin, but is light in color, then the priest shall isolate him for seven days."
,"27":"On the seventh day he shall examine him, and if the disease has spread on the skin, he shall declare him unclean: it is a case of leprosy."
,"28":"If the mark is still unchanged and has not spread over the skin, but instead is light in color, this means that it is only a swelling due to the burn. The priest shall declare the man clean: it is merely a burn scar."
,"29":"If a man or woman has a sore on the head or chin,"
,"30":"the priest must examine this sore; and if it seems to be deeper than the surrounding skin, with the hair on it yellow and thin, he must declare the sick person unclean. It is a dreaded skin disease, that is to say, leprosy of the head or chin."
,"31":"If on examining this case the priest finds no spot which seems deeper than the surrounding skin, and no yellow hair, he shall isolate the person for seven days."
,"32":"He shall examine the infected part on the seventh day, and if he finds that the disease has not spread, that the hair on it is not yellow, and that there is no spot which seems deeper than the surrounding skin,"
,"33":"the sick person will shave his hair, all except the part affected with the disease, and the priest is to isolate him again for seven days."
,"34":"He must examine the infected part on the seventh day, and if he finds that it has not spread over the skin, and that there is no spot which seems deeper than the surrounding skin, the priest shall declare the sick person clean. After washing his clothes he will be clean."
,"35":"But if after this purification the disease does spread over the skin,"
,"36":"the priest must examine him; if he finds that it has indeed spread over the skin, this means that the sick person is unclean, and there is no need to look and see whether the hair is yellow."
,"37":"Whereas if, so far as he can see, the disease has not spread and dark hair is beginning to grow on it, this means that the sick person is cured. He is clean, and the priest is to declare him clean."
,"38":"If shiny spots break out on the skin of a man or woman, and if these spots are white,"
,"39":"the priest must examine them. If he finds them to be a dull white, it is a rash that has broken out on the skin: the sick person is clean."
,"40":"If a man loses the hair on top of his head, this is baldness of the scalp but the man is clean."
,"41":"If he loses his hair from the front of the head, this is baldness of the forehead but the man is clean."
,"42":"If, however, a reddish white sore appears on the top of his head or forehead, this means that leprosy has broken out."
,"43":"The priest must examine it, and if he finds a reddish white swelling on the head or forehead, which looks like leprosy of the skin,"
,"44":"this means that the man is leprous: he is unclean. The priest shall declare him unclean; he is suffering from leprosy of the head."
,"45":"A person infected with leprosy must wear torn clothing and leave his hair uncombed; he must cover his upper lip and cry, 'Unclean, unclean.'"
,"46":"As long as the disease lasts he must be unclean; and therefore he must live away from others: he must live outside the camp."
,"47":"When a mark of mildew appears on a piece of clothing - woolen or linen clothing,"
,"48":"linen or woolen textile material or covering, leather or leatherwork -"
,"49":"and if this clothing, textile material, covering, leather or leather-work appears greenish or reddish, it is a spreading mildew to be shown to the priest."
,"50":"The priest must examine it and put the object away for seven days."
,"51":"If on the seventh day he observes that the mildew has spread on the garment, textile material, covering, leather or leatherwork, whatever it may be, it is a case of spreading mildew and the object is unclean."
,"52":"The priest will burn this clothing, textile material, linen or woolen covering, leather article of any kind, on which the mildew has spread and which must be destroyed by fire."
,"53":"But if on examination the priest finds that the mildew has not spread on the clothing, textile material, covering or leather object whatever it may be,"
,"54":"he is to order the object to be washed and is to isolate it again for a period of seven days."
,"55":"After the cleansing he must examine it again and if he finds that the mildew has not changed color, even though it has not spread, the article is unclean. It must be destroyed by fire."
,"56":"But if on examination the priest finds that the mildew has faded after washing, he is to cut it out of the clothing, leather, textile material or covering."
,"57":"But if the mildew reappears on the same clothing, textile material, covering or leather article whatever it may be, this means that the mildew is spreading again and the owner must destroy the article by fire."
,"58":"The clothing, textile material, covering or leather article whatever it may be, from which the mildew disappears after washing, is to be clean after it has been washed a second time."
,"59":"Such is the law for a case of leprosy in a linen or woolen garment, in textile material, in clothing or in anything of skin - for judging whether it is clean or unclean.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Yahweh spoke to Moses:"
,"2":"'This shall be the law for the leper on the day of his purification. He shall be brought to the priest "
,"3":"and the priest shall take him outside the camp and examine him. And if the person has been healed from leprosy,"
,"4":"the priest shall order two live, clean birds, cedar wood, scarlet yarn and hyssop for the one who is to be cleansed."
,"5":"The priest shall also give orders that one of the birds be slain on an earthenware pot over fresh water."
,"6":"He shall take the live bird and also the cedar wood, the crimson yarn and the hyssop, and he will plunge them together, including the live bird, in the blood of the bird that was slain over fresh water."
,"7":"Then he will sprinkle the one to be purified seven times. After that he shall declare him clean and he shall let the live bird go free over the open fields."
,"8":"The person to be purified must wash his clothes and shave off all his hair and bathe himself in water; then he will be clean. After this he may enter the camp but he must stay outside his tent for seven days."
,"9":"On the seventh day he shall shave off all the hair on his head, chin and eyebrows. He shall wash his clothes, bathe himself in water and then he will be clean."
,"10":"On the eighth day he is to take two lambs and a yearling ewe lamb, all without defect, and three-tenths of a measure of fine flour mixed with oil for a grain offering and a log of oil."
,"11":"The priest who declares him clean shall present the man to be purified and his offerings before Yahweh at the entrance to the Tent of Meeting."
,"12":"The priest will then take the first lamb and present it as a guilt offering together with the log of oil. He shall wave them before Yahweh."
,"13":"He shall slaughter the male lamb in the place where they slaughter the sin offering and the burnt offering - the holy place. For the guilt offering, like the sin offering, belongs to the priest; it is most holy."
,"14":"The priest shall then take some of the blood of the guilt offering and put it on the lobe of the right ear of the one to be purified, on the thumb of his right hand and on the big toe of his right foot."
,"15":"The priest shall take the log of oil and pour it on the palm of his own left hand."
,"16":"Then, dipping his right forefinger in it, he shall sprinkle it seven times before Yahweh."
,"17":"Then he is to take a little of the oil that remains in the palm of his hand and put it on the lobe of the right ear of the man who is being purified, and on the thumb of his right hand and on the big toe of his right foot, over the blood of the sacrifice of reparation."
,"18":"The rest of the oil which is in his palm, he shall put on the head of the man who is being purified. In this way he shall perform over him the rite of atonement before Yahweh."
,"19":"Then the priest shall offer the sacrifice for sin, and perform the rite of atonement for the man who is being purified. After this he must slaughter the animal for the burnt offering"
,"20":"and offer it with the grain offering on the altar. When the priest has performed the rite of atonement over him in this way, the man will be clean."
,"21":"If the leper is poor and cannot afford all this, he shall take only one lamb for the guilt offering to be offered with the gesture of offering in the rite of atonement. And for the grain offering he will bring only one tenth of wheaten flour mixed with oil, and the log of oil,"
,"22":"and finally two turtledoves or two young pigeons - if he can afford them - one to be used as a sacrifice for sin and the other for the burnt offering."
,"23":"On the eighth day he must bring them to the priest at the entrance to the Tent of Meeting before Yahweh, for his purification."
,"24":"The priest is to take the lamb for the guilt offering and the log of oil, and present them before Yahweh with the gesture of offering."
,"25":"Then he must slaughter the lamb for the guilt offering, take some of its blood and put it on the lobe of the right ear of the man who is being purified, on the thumb of his right hand and on the big toe of his right foot."
,"26":"He is to pour the oil into the palm of his left hand,"
,"27":"and with this oil he must make seven sprinklings with his finger before Yahweh."
,"28":"He is to put some of it on the lobe of the right ear of the man who is being purified, on the thumb of his right hand and on the big toe of his right foot as he did with the blood of the guilt offering."
,"29":"The remainder of the oil in the palm of his hand he must put on the head of the man who is being purified, performing the rite of atonement over him before Yahweh."
,"30":"Of the two turtledoves or two young pigeons - if he can afford them - he is to offer"
,"31":"a sacrifice for sin with one, and with the other a burnt offering together with a grain offering - if he can afford them. In this way the priest will have performed before Yahweh the rite of atonement over the person who is being purified."
,"32":"Such is the law concerning a person afflicted by leprosy who cannot afford the means for his purification.'"
,"33":"Yahweh spoke to Moses and Aaron; he said:"
,"34":"'When you reach the land of Canaan, which I am giving you as your inheritance, if I strike a house with mildew in the land you are to possess,"
,"35":"the owner must come and warn the priest; he must say, 'I have seen something like mildew in the house.'"
,"36":"The priest is to give orders for the house to be emptied before he goes to examine the infection; thus nothing in the house will be declared unclean. Then the priest must go and look at the house;"
,"37":"and if on examination he finds reddish or greenish spots that appear to be eating into the wall,"
,"38":"the priest is to go out of the house, to the door, and shut it up for seven days."
,"39":"On the seventh day he shall go back again and if on examination he finds that the infection has spread over the walls of the house,"
,"40":"he shall give orders for the affected stones to be removed and thrown into some unclean place outside the town."
,"41":"Then he shall have all the inside of the house scraped, and the plaster that comes off must be emptied out into an unclean place outside the town."
,"42":"The stones must be replaced by new ones and the house given a new coat of plaster."
,"43":"If the infection spreads again after the stones have been removed and the house scraped and replastered,"
,"44":"the priest is to come and examine it. If he finds that the infection has spread, this means that mildew is affecting the house: it is unclean."
,"45":"It must be pulled down and the stones, woodwork and all the plaster be taken to an unclean place outside the town."
,"46":"Anyone who enters the house while it is closed will be unclean until evening."
,"47":"Anyone who sleeps there must wash his clothing."
,"48":"But if the priest finds, when he comes to examine the infection, that it has not spread in the house since it was plastered, he is to declare the house clean, for the infection is cured."
,"49":"As a sacrifice for the sin of the house, he is to take two birds, cedar wood, red cord and a sprig of hyssop."
,"50":"He shall slaughter one of the birds in an earthenware pot over running water."
,"51":"Then he shall take the cedar wood, the hyssop, the red cord and the live bird, and dip them into the blood of the bird that was slaughtered and into the running water."
,"52":"He shall sprinkle the house seven times; and after having offered a sacrifice for the sin of the house with the blood of the bird, the running water, the live bird, the cedar wood, the hyssop and the red cord"
,"53":"he shall set the live bird free to fly out of the town into the open country. When the rite of atonement has been performed over the house in this way it will be clean."
,"54":"Such is the law for all cases"
,"55":"of dreaded skin diseases, mildew of clothing and houses,"
,"56":"swellings, scabs and shiny spots. It defines the cases when things are unclean and when they are clean."
,"57":"Such is the law on leprosy.'"
}`)
	CurrentBook.AddChapter(15, `{
"1":"Yahweh spoke to Moses and Aaron; he said,"
,"2":"'Speak to the sons of Israel and say to them:"
,"3":"When a man has a discharge from his body, that discharge makes him unclean. The rules about his uncleanness are: Whether his body allows the discharge to flow or whether it retains it, he is unclean. "
,"4":"Any bed the man lies on and any seat he sits on shall be unclean."
,"5":"Anyone who touches his bed must wash his clothing and take a bath and will be unclean until evening."
,"6":"Anyone who sits on a seat where the man has sat must wash his clothing and take a bath and will be unclean until evening."
,"7":"Anyone who touches the body of a man so affected must wash his clothing and take a bath and will be unclean until evening."
,"8":"If the sick man spits on someone who is clean, that person must wash his clothing and take a bath and will be unclean until evening."
,"9":"Any saddle the sick man travels on will be unclean."
,"10":"All those who touch any object that may be under him will be unclean until evening. Anyone who picks up such an object must wash his clothing and take a bath and will be unclean until evening."
,"11":"All those whom the sick man touches without washing his hands must wash their clothing and take a bath and will be unclean until evening."
,"12":"Any clay pot the sick man touches must be broken and any wooden utensil must be rinsed."
,"13":"When the man suffering from a discharge is cured, he must allow seven days for his purification. He must wash his clothing and take a bath in running water and he will be clean."
,"14":"On the eighth day he must take two turtledoves or two young pigeons and come before Yahweh at the entrance to the Tent of Meeting, and give them to the priest."
,"15":"The priest is to offer a sacrifice for sin with one of them, and with the other a burnt offering. So the priest will perform the rite of atonement before Yahweh for the man's discharge."
,"16":"When a man has a seminal discharge, he must bathe his whole body with water and he shall be unclean until evening."
,"17":"Any clothing or leather touched by a seminal discharge must be washed and it will be unclean until evening."
,"18":"When a woman has slept with a man, both of them must take a bath and they will be unclean until evening."
,"19":"When a woman has a discharge of blood, and blood flows from her body, this uncleanness of her monthly periods shall last for seven days. Anyone who touches her will be unclean until evening."
,"20":"Any bed she lies on will be unclean; any seat she sits on will be unclean."
,"21":"Anyone who touches her bed must wash his clothing and take a bath and will be unclean until evening."
,"22":"Anyone who touches any seat she has sat on must wash his clothing and take a bath and will be unclean until evening."
,"23":"If there is anything on the bed or the chair on which she sat, anyone who touches it will be unclean until evening."
,"24":"If a man sleeps with a woman who is unclean because of her monthly period, he shall be unclean for seven days. Any bed he lies on will be unclean."
,"25":"If a woman has a flow of blood for several days outside her period, or if her period is prolonged, during the time this flow lasts she shall be unclean as during her monthly periods."
,"26":"Any bed she lies on during the time this flow lasts will be unclean as during her monthly period. Any seat she sits on will be unclean; as it would be during her monthly periods."
,"27":"Anyone who touches them will be unclean; he must wash his clothing and take a bath and will be unclean until evening."
,"28":"When she is cured of her flow, she will let seven days pass; then she will be clean."
,"29":"On the eighth day she is to take two turtledoves or two young pigeons and bring them to the priest at the entrance to the Tent of Meeting."
,"30":"With one of them the priest is to offer a sacrifice for sin and with the other a burnt offering. This is the way in which the priest will perform the rite of atonement over her before Yahweh for the flow that made her unclean."
,"31":"Make the sons of Israel aware of everything unclean, lest they die because of defiling the Tent of my presence among them."
,"32":"Such is the law concerning a man with a discharge, anyone made unclean by a seminal discharge,"
,"33":"a woman unclean because of her monthly periods, a man or a woman with discharge, a man who sleeps with an unclean woman.'"
}`)
	CurrentBook.AddChapter(16, `{
"1":"Yahweh spoke to Moses after the death of the two sons of Aaron who died when they approached the presence of Yahweh."
,"2":"Yahweh said to Moses, 'Tell your brother, Aaron, not to enter at any time he pleases the Most Holy Place inside the veil, before the mercy Seat which is on the ark, lest he die, for I appear in the cloud over the mercy Seat."
,"3":"This is how Aaron will enter the Holy Place with a bullock for a sin offering and a ram for a burnt offering."
,"4":"He is to put on the sacred linen tunic and linen undergarments next to his body; he is to have the linen sash around him and wear the linen turban. These are sacred garments, so he must bathe in water before he puts them on."
,"5":"The assembly of the sons of Israel has to give him two male goats for a sin offering and one ram for a burnt offering."
,"6":"Then Aaron shall offer the bullock for a sin offering for himself to make atonement for himself and for his household."
,"7":"He shall take the two male goats and present them to Yahweh at the entrance to the Tent of Meeting."
,"8":"He is to cast lots for the two goats, one lot for Yahweh and one lot for Azazel."
,"9":"Aaron shall offer the goat on which the lot fell for Yahweh as a sin offering."
,"10":"But the goat on which the lot fell for Azazel will be placed alive before Yahweh to make atonement by being sent into the wilderness as a scapegoat."
,"11":"Aaron will then bring the bullock as a sin offering for himself to make atonement for himself and his household and he shall slaughter the bullock for the sin offering which is for himself."
,"12":"Then he shall take a censer full of coals from the fire above the altar before Yahweh and two handfuls of powdered, fragrant incense and take them inside the veil."
,"13":"He shall put the incense on the fire before Yahweh and the cloud of incense will cover the mercy Seat that is on the ark of the Statement, so that he will not die."
,"14":"He will take the blood of the bullock and sprinkle it with his finger on the mercy Seat to the east and also in front of the mercy Seat he shall sprinkle blood seven times."
,"15":"Then he shall slay the goat for the sin offering of the people and take its blood inside the veil and do with its blood what he did with the blood of the bullock. He shall sprinkle it on the mercy Seat and in front of it."
,"16":"In this way he shall make atonement for the Holy Place because of the uncleanness of the Israelites and because of all their sins. And he shall do the same for the Tent of Meeting which stands among them in the midst of all their uncleanness."
,"17":"No one shall be in the Tent of Meeting from the time Aaron goes to make atonement until he comes out. After he has made atonement for himself, for his household and for the whole assembly of Israel,"
,"18":"he shall go out to the altar before Yahweh and make atonement for it. Then he shall take some of the bullock's blood and some of the goat's blood and put it on the horns of the altar on all sides."
,"19":"He shall sprinkle it with blood seven times, and cleanse it and consecrate it from the uncleanness of the Israelites."
,"20":"When he has finished making atonement for the Holy Place, for the Tent of Meeting and for the altar, he shall bring forward the live goat."
,"21":"He shall lay his hands on the head of the goat and confess over it all the wickedness of the sons of Israel and all the sins they have committed against me. So he will charge them on the head of the goat and the wickedness of the sons of Israel and all the sins they have committed against me. So he will charge them on the head of the goat and send it away to the wilderness by the hand of an assistant."
,"22":"So the goat will carry away all their wickedness to an arid land, when the man releases it in the wilderness."
,"23":"Then Aaron is to go into the Tent of Meeting and take off the linen garments he had put on before he entered the sacred place. He shall leave them there,"
,"24":"bathe himself with water in a sacred place and put on his clothes. After that he will come out and sacrifice the burnt offering for himself and the burnt offering for the people to make atonement for himself and the people."
,"25":"The fat of the sin offering he shall burn on the altar."
,"26":"The man who releases the scapegoat shall wash his clothes and bathe himself with water, after which he may re-enter the camp."
,"27":"The bullock of the sin offering and the goat of the sin offering whose blood was brought in to make atonement in the Holy Place, shall be brought outside the camp and they shall burn their hides, their flesh and their dung in the fire."
,"28":"The one who burns them shall wash his clothes and bathe himself in water, after which he may re-enter the camp."
,"29":"This shall be a lasting ordinance for you: on the tenth day of the seventh month you must deny yourselves and do no work - neither the native nor the stranger living among you -"
,"30":"for on this day atonement will be made for you to cleanse you. You shall be cleansed of your sins before Yahweh."
,"31":"It is a sabbath of solemn rest when you must deny yourselves. It is a lasting ordinance."
,"32":"The priest who is anointed and ordained to succeed his father will make atonement. He shall put on the linen garments, the holy garments,"
,"33":"and will make atonement for the Holy Place, for the Tent of Meeting and for the altar. He shall also make atonement for the priests and all the people of the assembly."
,"34":"This shall be for you a lasting ordinance to make atonement for the people of Israel once a year, because of all their sins.',And Moses did as Yahweh commanded him."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Yahweh said to Moses,"
,"2":"'Speak to Aaron, his sons and all the Israelites and say to them: This is what Yahweh has commanded:"
,"3":"Any man from the house of Israel who kills an ox, or a lamb or a goat in the camp or outside the camp"
,"4":"and does not bring it to the entrance of the Tent of Meeting to make an offering of it to Yahweh before the tabernacle of Yahweh - that man shall be considered guilty of bloodshed. He has shed blood and he shall be cut off from among his people."
,"5":"The reason for this ordinance is so that the sons of Israel may bring the sacrifices that they used to slay in the fields to Yahweh at the entrance to the Tent of Meeting, to the priests, and sacrifice them as sacrifices of peace to Yahweh."
,"6":"The priest shall sprinkle the blood on the altar of Yahweh at the entrance to the Tent of Meeting and burn the fat as a sweet-smelling offering to Yahweh."
,"7":"This way they shall no longer slay their sacrifices for the goat idols to whom they prostituted themselves. This is to be a lasting ordinance for them in the generations to come."
,"8":"Then you shall give them this ordinance: Any man from the house of Israel or any alien living among them who offers a burnt offering or sacrifice"
,"9":"and does not bring it to the entrance of the Tent of Meeting to sacrifice it to Yahweh, that man shall be cut off from his people."
,"10":"If any man from the house of Israel or any alien living among them eats blood, I will set my face against that person and I will cut him off from among his people."
,"11":"For the life of the flesh is in the blood, and I have given it to you to rescue your life on the altar. Offered blood makes atonement because of the life within it. That is why I said to the sons of Israel: No one among you shall eat blood, nor may any alien who lives among you eat blood."
,"12":"If any Israelite or any alien living among you snares in hunting any beast or bird that may be eaten,"
,"13":"he shall pour out its blood and cover it with dust."
,"14":"For the blood of every creature contains its life and I have therefore said to the people of Israel: You are not to eat the blood of any flesh, for the life of all flesh is within its blood; whoever eats it shall be cut off."
,"15":"And every person who eats an animal that dies or that is torn by wild beasts, whether he be a native or an alien, shall wash his clothes and bathe in water and remain unclean until evening; then he will be purified."
,"16":"But if he does not wash his clothes or bathe his body, he shall carry his guilt.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Yahweh spoke to Moses and said,"
,"2":"'Speak to the sons of Israel and say to them: I am Yahweh, your God."
,"3":"You shall not do what is done in the land of Egypt where you used to live, nor shall you do what is done in the land of Canaan where I am bringing you; you shall not follow their practices."
,"4":"My practices instead you will follow, and you will carry out my ordinances; I am Yahweh your God."
,"5":"Keep my practices and ordinances, for whoever keeps them finds life; I am Yahweh."
,"6":"None of you shall have sexual intercourse with a blood relative; I am Yahweh."
,"7":"Do not have intercourse with your father or your mother; she is your mother, don't have intercourse with her."
,"8":"Do not have intercourse with your father's wife: Respect your father."
,"9":"Do not have intercourse with your sister or your stepsister, whether born in the same house or elsewhere."
,"10":"Do not have intercourse with your granddaughter; that would dishonor you."
,"11":"Do not have intercourse with a half sister; she, too, is your sister."
,"12":"Do not have intercourse with an aunt, whether she is your father's sister"
,"13":"or your mother's sister."
,"14":"Do not have intercourse with your uncle's wife; she, too, is your aunt."
,"15":"Do not have intercourse with your daughter-in-law"
,"16":"or with your brother's wife."
,"17":"Do not have intercourse with both a woman and her daughter or her granddaughter; they are blood relatives; that is wickedness."
,"18":"While your wife is living, do not take her sister as a wife so that you make her jealous."
,"19":"Do not have intercourse with a woman during her monthly period."
,"20":"Do not have intercourse with your neighbor's wife and defile yourself with her."
,"21":"Do not give any of your children to be sacrificed to Molech and do not profane the name of your God; I am Yahweh."
,"22":"Do not lie with a man as one lies with a woman; it is an abomination."
,"23":"Also do not have sexual relations with an animal; that is infamous."
,"24":"Do not defile yourselves in any of these ways for this is how the nations I am driving out before you, became defiled."
,"25":"As the land was defiled I came to punish it, and it has vomited out its inhabitants."
,"26":"You shall keep my practices and ordinances, and you shall not do any of these abominations, neither the native nor the alien living among you."
,"27":"Recall the people who did all these things before you in these lands and became defiled."
,"28":"If you defile the land it will vomit you out as it did the nations before you."
,"29":"The one who does any of these abominations shall be cut off from his people."
,"30":"Keep my laws and do not follow any of these abominable customs which were practiced before you, so as not to defile yourselves by them; I am Yahweh, your God.'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"Yahweh spoke to Moses and said,"
,"2":"'Speak to the entire assembly of the people of Israel and say to them: Be holy for I, Yahweh, your God, am holy."
,"3":"Each of you must revere his mother and father; and you shall keep my sabbaths; I am Yahweh, your God."
,"4":"Do not turn to idols or make for yourselves molten gods; I am Yahweh, your God."
,"5":"When you offer a sacrifice of peace offering to Yahweh, sacrifice it so that you may be accepted."
,"6":"It shall be eaten on the day you offer it or on the next day. And whatever remains shall be burned on the third day."
,"7":"If it is eaten on the third day it is unclean and will not be accepted."
,"8":"Whoever eats it will pay for his sin, for he has profaned a holy thing of Yahweh and this person shall be cut off from his people."
,"9":"When you reap the harvest of your land do not reap to the extreme limits of your field or gather the gleanings after your harvest."
,"10":"Do not strip your vineyard bare and do not gather the grapes that have fallen; leave them for the needy and the stranger. I am Yahweh, your God."
,"11":"Do not steal or lie or deceive one another."
,"12":"Do not swear falsely by my name so as to profane the name of your God; I am Yahweh."
,"13":"Do not oppress your neighbor or rob him. The wages of a hired man are not to remain with you all night until morning."
,"14":"You shall not curse a deaf man nor put a stumbling block in the way of the blind; but you shall fear your God; I am Yahweh."
,"15":"Do not pervert justice; do not show partiality to the poor nor bow to the great; you are to judge your neighbor fairly so as not to share in his guilt."
,"16":"Do not go about as a slanderer of your people and do not seek the death of your neighbor; I am Yahweh."
,"17":"Do not hate your brother in your heart; rebuke your neighbor frankly so as not to share in his guilt."
,"18":"Do not seek revenge or nurture a grudge against one of your people, but love your neighbor as yourself; I am Yahweh."
,"19":"Keep my practices. You shall not let your cattle breed with another kind. You shall not sow your field with two kinds of seed and you shall not wear clothing made of two different materials."
,"20":"If a man lies with a woman who is a slave promised to another man, and she has not been ransomed or given her freedom, there shall be punishment. They shall not be put to death because she was not free,"
,"21":"but he shall bring a ram as a guilt offering to Yahweh for himself, to the door of the Tent of Meeting."
,"22":"The priest is to make atonement for him before Yahweh with the ram of the guilt offering, and the sin he has committed will be forgiven."
,"23":"When you enter the land and plant all kinds of trees for food, you shall count the fruit as unclean. For three years it shall be unclean for you and it must not be eaten."
,"24":"In the fourth year all the fruit shall be holy, an offering of praise to the Lord."
,"25":"But in the fifth year you may eat of the fruit, that its yield may increase for you. I am Yahweh, your God."
,"26":"Do not eat anything over the blood nor practice divination or astrology."
,"27":"Do not round off the side-growth of your heads or clip off the edges of your beard."
,"28":"Do not make cuttings in your flesh on account of the dead or make tattoo marks on yourselves. I am Yahweh."
,"29":"You shall not profane your daughter by making her a prostitute, lest the land turn to prostitution and be filled with wickedness."
,"30":"Keep my sabbaths and revere my sanctuary. I am Yahweh."
,"31":"Do not turn to mediums or spiritists for you will be defiled by them. I am Yahweh, your God."
,"32":"Rise in the presence of the aged and honor the elderly; in doing this you honor your God. I am Yahweh."
,"33":"When a stranger stays with you in your land, do him no wrong."
,"34":"He shall be to you as the native among you. Love him as yourself for you have been strangers in the land of Egypt. I am Yahweh, your God."
,"35":"Do no wrong in judgment or in measure or weight or quantity."
,"36":"Use honest scales and honest weights and exact containers. I am Yahweh, your God who brought you out of the land of Egypt."
,"37":"You shall keep all my laws and all my practices and follow them. I am Yahweh.'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"Yahweh spoke to Moses"
,"2":"saying, 'To the sons of Israel you shall say this: Any man from the people of Israel or from among the aliens living in Israel who gives any of his children for the Molech sacrifice, shall be put to death. The people of the land shall stone him. "
,"3":"I shall set my face against that man and cut him off from among his people, for by giving his children to Molech he has defiled my sanctuary and profaned my holy name."
,"4":"And if the people of the land hide their eyes from what that man does and do not put him to death,"
,"5":"then I will set my face against them and against their family and cut them off from their people. I will do the same to all who follow him in prostituting themselves to Molech."
,"6":"I will set my face against the person who turns to mediums and spiritists and prostitutes himself by following them, and I will cut him off from his people."
,"7":"Take the way of holiness so that you be holy for I am Yahweh, your God."
,"8":"You shall keep my laws and practice them. I, Yahweh, your God am the one who makes you holy."
,"9":"The man who curses his father or mother shall be put to death. He has cursed his father or mother. He himself shall account for his blood."
,"10":"If a man commits adultery with another man's wife, the wife of his neighbor, both the adulterer and the adulteress shall be put to death."
,"11":"If a man lies with his father's wife, he has dishonored his father, both of them shall be put to death. They themselves shall account for their blood."
,"12":"If a man sleeps with his daughter-in-law, both of them shall be put to death for they have committed incest. They themselves shall account for their blood."
,"13":"When a man lies with a man as one lies with a woman, both have committed a detestable act and they shall be put to death. They themselves shall account for their blood."
,"14":"It is wicked for a man to marry both a woman and her mother. He and they must be burned in the fire so that there may be no wickedness among you."
,"15":"A man who has sexual relations with an animal must be put to death and the animal killed."
,"16":"If a woman approaches an animal to mate with it, kill the woman and the animal. They shall be put to death. They themselves shall account for their blood."
,"17":"If a man takes his sister, the daughter of his father or his mother and they have sexual relations, it is a shameful thing and they shall be cut off before the eyes of their people. He has dishonored his sister and carries his guilt."
,"18":"A man who lies with a woman during her monthly period and has intercourse with her has exposed the source of her flow and she has uncovered it. Both of them shall be cut off from among their people."
,"19":"You shall not have intercourse with the sister of your father or mother, for that would dishonor a close relative. Both would be guilty."
,"20":"The man who lies with his aunt dishonors his uncle. They will be guilty and die childless."
,"21":"It is a wickedness for a man to take his brother's wife. He has dishonored his brother and they will be childless."
,"22":"Keep, therefore, all my decrees and laws and act according to them so that the land where I am bringing you to live may not vomit you out of it."
,"23":"You shall not follow the customs of the nations I shall drive out before you. I felt hatred for them for they did all these things."
,"24":"Because of this I said to you: You will possess their land and it is I who give it to you as your possession, a land flowing with milk and honey. I, Yahweh, your God have set you apart from the nations. "
,"25":"You must therefore set the clean beast apart from the unclean, and the clean bird apart from the unclean and you shall not defile yourselves by animal or by bird or by anything that creeps along the ground, which I have separated from you as unclean."
,"26":"You are to be holy for me as I am holy, Yahweh, your God, and I have set you apart from the nations to be mine."
,"27":"Now a man or a woman who is a spiritist shall be put to death; he or she shall be stoned and they shall account for their own blood.'"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Yahweh said to Moses, 'Speak to the priests, sons of Aaron and tell them that not one of them shall make himself unclean for a dead person among his people"
,"2":"except for those relatives nearest to him, that is for his mother, father, son, daughter or brother,"
,"3":"or for an unmarried sister who is dependent on him because she has had no husband. For her, he may make himself unclean."
,"4":"As a husband he must not make himself unclean for his family-in-law and so profane himself."
,"5":"They shall not make tonsures on their heads nor shave off the edges of their beards, nor make any cuts in their flesh."
,"6":"They shall be holy to their God and not profane the name of their God, for it is they who present offerings by fire, the bread of their God, so they shall be holy."
,"7":"They must not marry women unclean by prostitution or a woman divorced by her husband, for the priest is holy to his God."
,"8":"You shall regard the priest as holy for he offers up the food of your God. Holy he shall be for you because I, Yahweh, am holy who makes you holy."
,"9":"If a priest's daughter defiles herself by becoming a prostitute, she profanes her father and shall be burned in the fire."
,"10":"The high priest, the one among his brothers on whose head the anointing oil has been poured, and who has been consecrated to wear the garments, shall not uncover his head or tear his clothes."
,"11":"He shall not go near any dead person or defile himself either for his father or his mother."
,"12":"He shall not leave the sanctuary nor profane the sanctuary of his God for he has on him the consecration of the anointing oil of his God. I am Yahweh."
,"13":"The woman he marries must be a virgin."
,"14":"He shall not take as wife a widow or a divorced woman or a woman defiled by prostitution, but only a virgin of his own people,"
,"15":"that he may not defile his children among his people. I am Yahweh who makes him holy.'"
,"16":"Yahweh said to Moses,"
,"17":"'Say to Aaron: No man among your descendants in future generations who has a defect shall approach to offer the bread of his God."
,"18":"No man who has a defect may come near, no man who is blind or lame, disfigured or deformed"
,"19":"or who has a broken foot or hand,"
,"20":"or is a hunchback or dwarf, or who has an eye defect or eczema or scabs or damaged testicles."
,"21":"The descendant of Aaron the priest who has a defect shall not approach to offer the burnt offering to Yahweh. He must not approach to offer the bread of his God because of the defect he has."
,"22":"He may eat the bread of his God, both the most holy and the holy,"
,"23":"but he may not go as far as the veil or advance towards the altar because he has a defect. Let him not defile my sanctuary, for it is I, Yahweh, who make them holy.'"
,"24":"Thus spoke Moses to Aaron and to his sons and to all Israel."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Yahweh spoke to Moses; he said:"
,"2":"'Tell Aaron and his sons when they have to abstain from the holy offerings of the people of Israel, lest they profane my holy name; for I am the one who makes them holy. I am Yahweh."
,"3":"Tell them this: Anyone of your descendants, in any generation, who in a state of uncleanness approaches the holy offerings consecrated to Yahweh by the people of Israel, shall be outlawed from my presence. I am Yahweh."
,"4":"Anyone of Aaron's line who is afflicted with leprosy or a discharge must not eat holy things until he is clean. Anyone who touches something made unclean by a dead body, or has a seminal discharge,"
,"5":"or is made unclean by touching either some creeping thing or some man who has communicated to him his own uncleanness of whatever kind,"
,"6":"in short, anyone who has had any such contact shall be unclean until evening, and must not eat holy things until he has taken a bath."
,"7":"At sunset he will be clean and may then eat holy things, for these are his food."
,"8":"He must not eat an animal that has died a natural death or been killed by wild animals; he would become unclean by doing this. I am Yahweh."
,"9":"Let them keep these rules and not burden themselves with sin lest they die because of having defiled this food. I am Yahweh who makes them holy."
,"10":"No lay person may eat any of the sacred offerings: neither the guest of a priest, nor his hired servant."
,"11":"But if the priest has acquired a slave by purchase, the slave may eat them. Likewise anyone born in the house may eat a share of the food."
,"12":"If a priest's daughter marries someone who is not a priest, she must not eat the holy portion set aside;"
,"13":"but if she is widowed or divorced and, being childless, has had to return to her father's house as when she was young, she may eat her father's food. No lay person may eat it;"
,"14":"if someone does eat a holy thing unintentionally, he shall restore it to the priest with one fifth added."
,"15":"They must not profane the holy offerings which the people of Israel have set aside for Yahweh."
,"16":"If they ate of them, they would have to pay a guilt offering. I am Yahweh, who have sanctified these offerings.'"
,"17":"Yahweh spoke to Moses; he said:"
,"18":"'Tell this to Aaron, to his sons, and to all the people of Israel:"
,"19":"This rule refers to anyone of the Israelites or to any stranger living in Israel who brings anything for a burnt offering either in payment of a vow or as a voluntary gift. To be welcomed, he must offer a male ox, sheep or goat without any defect,"
,"20":"You must not offer one that has defects; for it would not make you acceptable."
,"21":"If anyone offers to Yahweh a peace offering either to fulfill a vow or as a voluntary offering, the animal - from the herd or from the flock - will not please Yahweh unless it be without any defect."
,"22":"You must not offer to Yahweh an animal that is blind, lame, mutilated, ulcerous, or suffering from skin disease or a sore. No part of such an animal shall be laid on the altar as a burnt offering for Yahweh."
,"23":"As a voluntary offering, you may offer a bull or a lamb that is underdeveloped or deformed; but such will not be accepted in payment of a vow."
,"24":"Don't offer to Yahweh an animal if its testicles have been bruised, crushed, removed or cut. This is not permitted in your land,"
,"25":"and you are not to accept any such from the hands of a stranger, to offer as food for your God. Their deformity is a defect and they would not make you acceptable.'"
,"26":"Yahweh spoke to Moses; he said:"
,"27":"'A calf, lamb, or kid shall stay with its mother seven days after birth. From the eighth day it will be acceptable as a burnt offering to Yahweh."
,"28":"No animal, whether cow or ewe, shall be slaughtered on the same day as its young."
,"29":"If you offer Yahweh a sacrifice of thanksgiving, do it so that Yahweh may be pleased."
,"30":"You must eat it the same day, and nothing should be left till the morning. I am Yahweh."
,"31":"You must keep my commands and put them into practice. I am Yahweh."
,"32":"You must not profane my holy name, so that I may be proclaimed holy among the people of Israel, I, Yahweh who sanctify you."
,"33":"I who brought you out of the land of Egypt to be your God, I am Yahweh.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Yahweh spoke to Moses,"
,"2":"'Speak to the sons of Israel and say to them: You proclaim holy assemblies on the appointed feasts of Yahweh, which are these:"
,"3":"After six days in which work shall be done, there is a sabbath of complete rest on the seventh day, a holy assembly when no work shall be done; it is a sabbath to Yahweh in all your houses."
,"4":"Then there are the appointed feasts of Yahweh at the times fixed for them, when you are to proclaim holy assemblies."
,"5":"At twilight on the fourteenth day of the first month is Yahweh's Passover."
,"6":"And on the fifteenth day of this month it is Yahweh's feast of Unleavened Bread. For seven days you shall eat bread without leaven."
,"7":"On the first day there will be a sacred assembly and no work of a worker shall be done."
,"8":"For seven days you shall present an offering by fire to Yahweh and on the seventh day you shall hold a sacred assembly and do no work of a worker.'"
,"9":"Yahweh spoke to Moses and said,"
,"10":"'Speak to the sons of Israel and say to them: When you enter the land that I will give you and you reap its harvest, you will bring to the priest a sheaf, the firstfruits of your harvest"
,"11":"and he shall wave the sheaf before Yahweh for you to be accepted; on the day after the sabbath the priest shall wave it."
,"12":"The day when you wave the sheaf, you shall sacrifice a lamb without defect, born that year, as a burnt offering to Yahweh."
,"13":"And the grain offering with it shall be two tenths of a measure of fine flour mixed with oil, an offering by fire to Yahweh, a sweet-smelling offering, with its drink offering of a quarter of a measure of wine."
,"14":"You shall eat neither bread nor grain, whether roasted or new, until the very day you bring the offering to your God. This is to be an everlasting ordinance for all generations throughout your residences."
,"15":"From the day after the sabbath, on which you bring the sheaf of offering, you are to count seven full weeks."
,"16":"The day after the seventh sabbath will be the fiftieth day and then you are to offer Yahweh a new offering."
,"17":"You must bring bread from your houses to present with the gesture of offering - two loaves, made of two tenths of wheaten flour baked with leaven; these are firstfruits for Yahweh."
,"18":"In addition to the bread you must offer seven one-year-old lambs without any defect, a young bull and two rams, as a burnt offering to Yahweh together with a grain offering and drink offering, as a sweet-smelling offering to Yahweh."
,"19":"You are also to offer a goat as a sacrifice for sin, and two one-year-old lambs as a peace offering."
,"20":"The priest shall present them before Yahweh with the gesture of offering, in addition to the bread of the firstfruits. These, and the two lambs, are holy things for Yahweh, and will belong to the priest."
,"21":"This same day you are to hold an assembly; this shall be a sacred assembly for you; you will do no work of a worker. This is a perpetual law for your descendants wherever you live."
,"22":"When you gather the harvest in your country, you are not to harvest to the very end of your field, and you are not to gather the gleanings of the harvest. You are to leave them for the poor and the stranger. I am Yahweh your God.'"
,"23":"Yahweh spoke to Moses; he said:"
,"24":"'Speak to the sons of Israel and say to them: The first day of the seventh month shall be a day of rest for you, a sacred assembly proclaimed with trumpet call."
,"25":"You must not do any work of a worker and you must offer a burnt offering to Yahweh.'"
,"26":"Yahweh spoke to Moses; he said:"
,"27":"'The tenth day of this seventh month shall be the Day of Atonement. You are to hold a sacred assembly. You must fast, and you must offer a burnt offering to Yahweh."
,"28":"You are not to do any work that day, for it is the Day of Atonement, on which the rite of atonement will be performed over you before Yahweh your God."
,"29":"Indeed, anyone who fails to fast that day shall be outlawed from his people;"
,"30":"anyone who works that day I will remove from his people."
,"31":"No work must be done - this is a perpetual law for your descendants wherever you live."
,"32":"This is to be a day of sabbath rest for you. You must fast; on the evening of the ninth day of the month, from this to the following evening, you must cease to work.'"
,"33":"Yahweh spoke to Moses; he said:"
,"34":"'Speak to the sons of Israel and say to them: The fifteenth day of this seventh month shall be the feast of Tents for Yahweh, lasting seven days. "
,"35":"The first day you shall hold an assembly; you must do no work of a worker."
,"36":"For seven days you must offer a burnt offering to Yahweh. On the eighth day you are to hold a sacred assembly and you must offer a burnt offering to Yahweh. It is a day of solemn assembly in which you shall do no work of a worker."
,"37":"These are the appointed feasts of Yahweh in which you are to proclaim holy assemblies for the purpose of offering offerings by fire, burnt offerings, grain offerings and drink offerings to Yahweh, according to the ritual of each day,"
,"38":"besides the sabbaths of Yahweh and the presents, and the votive and voluntary gifts that you make to Yahweh."
,"39":"On the fifteenth day of the seventh month, when you have harvested the produce of the land, you are to celebrate the feast of Yahweh for seven days. On the first and eighth days there shall be a complete rest."
,"40":"On the first day you shall take choice fruits, palm branches, boughs of leafy trees and willows from the riverbank, and for seven days you shall rejoice in the presence of Yahweh your God."
,"41":"You are to celebrate a feast for Yahweh in this way for seven days every year. This is a perpetual law for your descendants."
,"42":"You are to keep this feast in the seventh month. For seven days you are to live in tents and shelters: all natives of Israel must live in tents and shelters,"
,"43":"so that your descendants may know that I made the sons of Israel live in tents when I brought them out of the land of Egypt. I am Yahweh your God.'"
,"44":"These are the regulations that Moses gave to the sons of Israel regarding the feasts of Yahweh."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Yahweh spoke to Moses and said,"
,"2":"'Command the Israelites to bring you oil from pressed olives for the light, that a lamp may be kept burning continually."
,"3":"Aaron shall keep the flame in order from evening until morning in the Tent of Meeting, outside the veil of the Statement. It shall be a lasting ordinance for all generations."
,"4":"He shall set the lamps on the pure gold lampstand to burn continually before Yahweh."
,"5":"Then you shall take fine flour and make twelve cakes, two-tenths of a measure in each cake."
,"6":"Place them in two rows, six in each, on the pure gold table before Yahweh."
,"7":"On each row put pure frankincense, so that the bread may be a memorial, as an offering by fire to Yahweh."
,"8":"Every sabbath Aaron shall set the bread in order before Yahweh on behalf of the Israelites as a lasting covenant."
,"9":"The bread will be for Aaron and his sons; they are to consider it as a most holy portion of the sacrifices by fire to Yahweh and they shall eat it in a holy place. This is a lasting law.'"
,"10":"The son of an Israelite woman quarreled with a man of Israel in the camp and"
,"11":"the son of the Israelite woman blasphemed the name of Yahweh with a curse, so they brought him to Moses. (His mother was Shelomith, the daughter of Dibri of the tribe of Dan)."
,"12":"They put him under guard until a decision from Yahweh would be made known."
,"13":"Yahweh said to Moses, 'Take the man who has cursed out of the camp."
,"14":"All who have heard him curse will lay their hands on his head and the entire assembly shall stone him to death."
,"15":"Then say this to the sons of Israel: The man who curses God shall pay for his sin"
,"16":"and whoever blasphemes the name of Yahweh shall be put to death. The whole assembly shall stone him; the alien, like the native, shall be put to death when he blasphemes the Name."
,"17":"Whoever kills a man shall be put to death."
,"18":"Whoever kills an animal shall replace the loss, life for life."
,"19":"If a man injures his neighbor, as he has done, so shall it be done to him."
,"20":"Fracture for fracture, eye for eye, tooth for tooth, just as he has injured another, so shall it be done to him."
,"21":"He who kills a beast shall make up for it, and he who kills a man shall be put to death."
,"22":"There shall be one law, the same for the alien and the native, for I am Yahweh, your God.'"
,"23":"So Moses spoke to the Israelites and they brought the man who had cursed outside the camp and stoned him. In this way the Israelites did as Yahweh had commanded Moses."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Yahweh spoke to Moses on Mount Sinai:"
,"2":"'Speak to the Israelites and tell them: When you enter the land I am giving you, let the land rest for Yahweh every seventh year."
,"3":"For six years you shall sow your field, prune your vineyard and harvest the produce,"
,"4":"but in the seventh year the land shall have a rest, or sabbath, a sabbath for Yahweh. You shall not sow your field nor prune your vineyard;"
,"5":"you shall not reap the aftergrowth of your harvest nor gather the grapes of your uncultivated vines. This shall be a year of rest for the land, "
,"6":"but whatever it produces of itself will provide food for you, for your male and female slaves, for your hired servant and for the stranger who lives with you."
,"7":"Its produce will likewise provide food for your livestock and for the wild animals on your land."
,"8":"When seven sabbaths of years have passed, that is, seven times seven years, there shall be the time of the seven weeks of years, that is forty-nine years."
,"9":"Then on the tenth day of the seventh month sound the trumpet loudly. On this Day of Atonement sound the trumpet all through the land."
,"10":"Keep holy the fiftieth year and proclaim freedom for all the inhabitants of the land. It shall be a jubilation year for you when each one shall recover his property and go back to his family."
,"11":"In this fiftieth year, your year of Jubilee, you shall neither sow nor reap the aftergrowth, nor gather the grapes from the uncultivated vines."
,"12":"This Jubilee year shall be holy for you, and you shall eat what the field yields of itself without cultivation."
,"13":"In this year of Jubilee each of you shall recover his own property."
,"14":"When you sell something to your neighbor or buy something from him, do not wrong one another."
,"15":"According to the number of years after the Jubilee, you shall buy it from your neighbor and according to the number of years left for harvesting crops he shall sell to you."
,"16":"When the years are many the price shall be greater and when the years are few the price shall be less, for it is the number of crops that he is selling to you."
,"17":"So you shall not wrong one another but you shall fear your God, for I am Yahweh, your God."
,"18":"Carry out my precepts and obey my laws. In that way you will live securely in the land."
,"19":"The land will give its fruit so that you may have food in abundance and live securely."
,"20":"But if you ask: What will we eat in the seventh year if we do not sow or gather crops?; see that"
,"21":"I will send you my blessing in the sixth year that it may produce enough for three years."
,"22":"So in the eighth year the remains of the old crop will provide you with what to sow and to eat until the harvest of the ninth year is ready."
,"23":"The land shall not be sold forever for the land is mine, where you are but strangers and guests of mine."
,"24":"In all the territory you occupy, the land is to be redeemed."
,"25":"When your brother becomes poor and sells his property, his nearest relative is to come and buy back what his relative has sold."
,"26":"If the man has no relatives to buy back his property, but later has sufficient means to redeem it,"
,"27":"he will calculate the value based on the number of years since he sold it and refund the balance to the man to whom he sold it and in that way he shall re-cover his property."
,"28":"But if he does not find the means to repay him, what has been sold shall remain with the buyer until the Jubilee year when it must be given back to its original owner."
,"29":"In the same way, if a man sells a house in a walled city, his right of redemption shall last until the end of a year from the time of its sale; his right of redemption lasts a whole year."
,"30":"If it is not redeemed by the end of a complete year, the house in the walled city shall belong permanently to the one who bought it and to his descendants, and it shall not be released in the Jubilee year."
,"31":"Houses in villages which have no surrounding wall are considered as fields; they have redemption rights and may be released in a Jubilee year."
,"32":"As for the towns of the Levites, their houses belong to the Levites and they have a permanent right to redeem what is bought from them."
,"33":"Any house in a town of the Levites can return to them at the time of the Jubilee, for the houses in the towns of the Levites are their possession among the Israelites."
,"34":"The field also belonging to their towns must not be sold forever; it is their permanent possession."
,"35":"If your brother becomes poor and is unable to support himself, help him. Help this stranger or this guest that he may live with you."
,"36":"Do not take interest from him, but fear your God, so that your brother may live among you."
,"37":"Do not give him your silver at interest nor your food for gain."
,"38":"I am Yahweh, your God, who brought you out of Egypt to give you the land of the Canaanites and to be your God."
,"39":"If your brother becomes poor and sells himself to you, do not make him work as a slave,"
,"40":"but let him remain with you as a hired servant and an alien until the year of Jubilee."
,"41":"He shall then leave you, he and his sons with him, and return to his own family and to the property of his fathers."
,"42":"For they are my servants whom I brought out of the land of Egypt and they are not to be sold as slaves."
,"43":"Do not rule over them harshly, but fear your God."
,"44":"As for the male and female slaves, it is from the nations around you that you are to buy them."
,"45":"You may also buy from among the aliens who live with you and from their families, born in your land, and they may be your property."
,"46":"So you may leave them to your children as inherited possessions and make them slaves for life. But regarding your Israelite brothers, you must not rule over them harshly."
,"47":"If an alien or temporary resident becomes prosperous and one of your brothers becomes so poor as to sell himself to a stranger who is living with you or to a member of the stranger's family,"
,"48":"he shall have the right of redemption. One of his brothers may redeem him,"
,"49":"or his uncle or the son of his uncle or a near relative may redeem him."
,"50":"If he becomes rich, let him redeem himself. He shall reckon with his buyer from the time he sold himself until the year of Jubilee and the price of his sale shall correspond to the number of years. If many years remain, he shall be reckoned at the price of a hired servant, according to the number of years."
,"51":"If redeemed when many years remain, he shall refund out of the price paid for him, according to the remaining time."
,"52":"If only a few years remain until the Jubilee year, he will calculate and refund accordingly."
,"53":"He shall be with him as a servant hired year by year and he shall not be harshly dealt with."
,"54":"If he is redeemed in any of these ways, he shall be released in the Jubilee year, he and his sons with him."
,"55":"For it is to me that the sons of Israel are servants; they are my servants whom I brought out of the land of Egypt. I am Yahweh, your God."
}`)
	CurrentBook.AddChapter(26, `{
"1":"You shall not make for yourselves idols or set up an image or pillar or carved stone in your land to bow before it for I am Yahweh, your God."
,"2":"You shall keep my sabbaths and reverence my sanctuary. I am Yahweh."
,"3":"If you walk according to my precepts and obey my commandments, if you carry them out,"
,"4":"I will give you rain in its season and the land will yield its produce, the trees in the field their fruit;"
,"5":"the threshing time will last to vintage time and the vintage till sowing time. You will have food in abundance and you will live securely in your land."
,"6":"I will give you peace in your country and you will sleep without anyone disturbing you. I will banish the wild beast and keep the sword of war from passing through the land."
,"7":"You will rout your enemies and they will fall before your sword;"
,"8":"five of you will pursue a hundred of them and a hundred of you ten thousand of them, and they will fall before you by the sword."
,"9":"I will turn towards you to make your families fruitful and your people numerous, and I will confirm my covenant with you."
,"10":"When you are still eating from the old harvest you will have to discard what is stored to make place for the new."
,"11":"I will make my Dwelling among you and I will not reject you."
,"12":"I will walk among you; I will be your God and you will be my people."
,"13":"I am Yahweh your God, who brought you out of Egypt to be their slaves no longer. I have broken the bars of your yoke letting you walk erect."
,"14":"But if you do not heed me and keep my commandments,"
,"15":"if you reject my precepts and ignore my decrees, refusing to obey all my commandments and so break my covenant,"
,"16":"I, in turn, will do this: I will bring upon you a terror, a tuberculosis and fever, weakening your eyes and draining your life. In vain will you sow, for your enemies will eat it."
,"17":"I will turn away from you until you are beaten by your enemies. Those who hate you shall rule over you and you shall flee when no one pursues you."
,"18":"If after all this you do not obey me, I will continue to punish you sevenfold for your sins."
,"19":"I will break the pride of your power; I will make your sky like iron and your earth like bronze."
,"20":"Your strength shall be spent in vain; your land will give no produce and the trees no fruit."
,"21":"If you defy me and are unwilling to obey me, I will bring seven times as many plagues on you for your sins."
,"22":"I will let loose the wild animals and they will rob you of your children and destroy your cattle and make you so few that your roads will be deserted."
,"23":"If, with all this, you do not repent but remain hostile towards me,"
,"24":"then I will be hostile towards you and strike you seven times for your sins."
,"25":"The sword I will bring against you, and with the sword I will avenge my covenant with you; and when you gather together in your cities I will send pestilence on you and you shall be delivered into enemy hands."
,"26":"When I cut off your supply of bread and ten women bake bread in one oven and bring back rationed bread, you will eat and not be satisfied."
,"27":"But if with all that you do not obey me and remain defiant towards me,"
,"28":"I will go against you in fury and punish you sevenfold for your sins."
,"29":"You shall eat the flesh of your sons and the flesh of your daughters."
,"30":"I will destroy your high places and cut down your incense altars; I will cast your corpses on those of your idols and I shall hate you."
,"31":"I will lay waste your cities and make desolate your sanctuaries and no longer shall I relish your sweet-smelling offerings."
,"32":"I will make the land desolate so that your enemies who settle in it will be astonished."
,"33":"I will scatter you among the nations and unsheathe the sword behind you, as your land becomes desolate and your cities lie in ruins."
,"34":"Then the land shall enjoy its sabbaths as long as it lies waste while you are in the land of your enemies;"
,"35":"then the land will rest and observe its sabbaths. As long as the land lies desolate it shall have the sabbath rest that it did not have when you inhabited it."
,"36":"As for those of you who are left, I will make them faint-hearted in the land of their enemies. The sound of a wind-blown leaf will chase them and even when no one pursues them,"
,"37":"they will flee as from the sword and will fall. They will stumble against each other as if running from the sword even when they are not pursued, and you will be unable to stand up before your enemies."
,"38":"You shall perish among the nations and die in the land of your enemies."
,"39":"Those among you who remain will rot away because of their wickedness in the land of your enemies and because of the wickedness of their fathers they will rot away with them."
,"40":"Then they will confess their sins and the sins of their fathers. They will admit that their treacheries and their hostility towards me made me hostile towards them"
,"41":"and caused me to bring them to the land of their enemies, and then their uncircumcised hearts may become humble and they will accept the punishment for their sin."
,"42":"Then I will remember my covenant with Jacob and my covenant with Isaac and my covenant with Abraham as well, and I will remember the land."
,"43":"For the land will be abandoned by them and it shall observe its sabbath; it will be desolate without them, while they pay for their sin because they spurned my ordinances and ignored my statutes."
,"44":"Yet even so, when they are in the land of their enemies I will not reject them or ignore them to the point of destroying them and breaking my covenant with them, for I am Yahweh, their God."
,"45":"For their sake I will remember my covenant with their forefathers whom I brought out of the land of Egypt in the sight of the na-tions, that I might be their God. I am Yahweh.'"
,"46":"These are the statutes, the ordinances and the teachings of the covenant Yahweh made with the sons of Israel, through Moses, on Mount Sinai."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Yahweh spoke to Moses and said,"
,"2":"'Tell the sons of Israel about the fixed price for those who have to be ransomed because of a vow."
,"3":"A man between twenty and sixty years of age shall be valued at fifty pieces of silver - the official standard;"
,"4":"a woman shall be valued at thirty silver coins;"
,"5":"between five and twenty years, a boy shall be valued at twenty silver coins, a girl at ten silver coins;"
,"6":"between one month and five years, a boy shall be valued at five silver coins, a girl at three silver coins;"
,"7":"at sixty years and over, a man shall be valued at fifteen silver coins and a woman at ten silver coins."
,"8":"If the person who made the vow is too poor to pay the standard price, he must present the person concerned to the priest, and the priest shall set a value proportionate to the re-sources of the person who made the vow."
,"9":"As for an animal suitable for offering to Yahweh, any such animal given to Yahweh is holy."
,"10":"It cannot be exchanged or a substitute offered - good for bad, bad for good. If one animal is substituted for another, both of them shall belong to Yahweh."
,"11":"If it is an unclean animal, and not suitable for offering to Yahweh, whatever it may be it must be presented to the priest"
,"12":"and he shall set a price for it, judging it good or bad."
,"13":"You must abide by his price. The person who wishes to buy it back must add one fifth to the price set."
,"14":"If a man dedicates his house to Yahweh, the priest shall set a price for it, judging whether its value is great or little. You must abide by the priest's price."
,"15":"If the man who has vowed his house wishes to buy it back, he must add one fifth to the price and it shall be given back to him."
,"16":"If a man dedicates one of the fields of his patrimony to Yahweh, its value shall be calculated according to its productivity, at the rate of fifty silver coins to one bushel of barley."
,"17":"If he dedicates the field during the Jubilee year, he must stand by this price."
,"18":"But if he dedicates it after the Jubilee, the priest shall calculate the price on the basis of the number of years still to run until the next Jubilee and the price shall be reduced accordingly."
,"19":"If he wishes to buy back the field, he shall add one fifth to the price, and the field shall be given back to him."
,"20":"If he does not buy it back but sells it to another, the right of redemption ceases;"
,"21":"when the buyer has to give it up at the Jubilee year, it becomes a thing dedicated to Yahweh, the same as a field laid under the ban: the man's property passes to the priest."
,"22":"If he dedicates to Yahweh a field which he has bought, but which is not part of his patrimony,"
,"23":"the priest shall assess the price on the basis of the number of years still to run before the Jubilee year; and the man shall pay this sum the same day, as for a thing dedicated to Yahweh."
,"24":"In the Jubilee year, the field shall return to the seller, to the man to whose patrimony the land belongs."
,"25":"All prices must be made according to the official sanctuary standards at the rate of twenty gerahs to one silver piece."
,"26":"No one may dedicate the firstborn of his cattle, for it belongs to Yahweh by right: whether ox or sheep, it belongs to Yahweh."
,"27":"But if it is an unclean animal it may be bought back at the price with one fifth added; if it is not bought back, the animal shall be sold at the price set."
,"28":"Nothing that is dedicated to Yahweh by anathema may be bought back; nothing whether a man, an animal, or a field of patrimony. What is dedicated by anathema becomes a most holy thing and belongs to Yahweh."
,"29":"A human being dedicated by anathema cannot be bought back, he must be put to death."
,"30":"One tenth of all the produce of the earth or the fruits of trees, belongs to Yahweh."
,"31":"If a man wishes to buy back part of his tithe, he must add one fifth to its value."
,"32":"In all tithes of flock or herd, the tenth animal of all that pass under the herdsman's staff shall be a thing dedicated to Yahweh;"
,"33":"there must be no picking out of good and bad, no substitution. If substitution takes place, both the animal and its substitute shall be things dedicated without possibility of buying them back.'"
,"34":"These are the commandments that Yahweh laid down for Moses on Mount Sinai, for the people of Israel."
}`)

}
func EN_CCB_LoadVPNMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Yahweh spoke to Moses, in the desert of Sinai, in the Tent of Meeting, on the first day of the second month, in the second year after their departure from the land of Egypt. He said:"
,"2":"'Take a census of the whole community of Israel, by clans and families, taking a count of the names of all the males, head by head."
,"3":"You and Aaron will enlist all men of Israel, twenty years of age and over, able to give military service."
,"4":"From each tribe you shall take a man, the head of his family, to help you in this."
,"5":"These are the names of those who are to be your helpers: For Reuben, Elizur son of Shedeur."
,"6":"For Simeon, Shelumiel son of Zurishaddai."
,"7":"For Judah, Nahshon son of Amminadab."
,"8":"For Issachar, Nethanel son of Zuar."
,"9":"For Zebu-lun, Eliab son of Helon."
,"10":"Of the sons of Joseph: for Ephraim, Elishama son of Ammihud; for Manasseh, Gamaliel son of Pedahzur."
,"11":"For Benjamin, Abidan son of Gideoni."
,"12":"For Dan, Ahiezer son of Ammishaddai."
,"13":"For Asher, Pagiel son of Ochran."
,"14":"For Gad, Eliasaph son of Reuel."
,"15":"For Naphtali, Ahira son of Enan.'"
,"16":"These men were elected by public acclamation; they were leaders of their ancestral clans, chiefs of Israel's hosts."
,"17":"Moses and Aaron took these men who had been named,"
,"18":"and on the first day of the second month they called together the whole community. The sons of Israel listed their names according to their clans and families, and one by one the names of all men of twenty years and over were recorded and counted."
,"19":"As Yahweh had commanded, Moses took a census of them in the desert of Sinai."
,"20":"When the tribe of Reuben, Israel's firstborn, had been listed by clans and families, the names of all the males of twenty years and over, able to give military service, were recorded one by one."
,"21":"The total of these for the tribe of Reuben was 46,500."
,"22":"When the tribe of Simeon had been listed by clans and families, the names of all the males of twenty years and over, able to give military service, were recorded one by one."
,"23":"The total of these for the tribe of Simeon was 59,300."
,"24":"When the tribe of Gad had been listed by clans and families, the names of all the males of twenty years and over, able to give military service were recorded one by one."
,"25":"The total of these for the tribe of Gad was 45,650."
,"26":"When the tribe of Judah had been listed by clans and families, the names of all the males of twenty years and over, able to give military service, were recorded one by one."
,"27":"The total of these for the tribe of Judah was 74,600."
,"28":"When the tribe of Issachar had been listed by clans and families, the names of all the males of twenty years and over, able to give military service were recorded one by one."
,"29":"The total of these for the tribe of Issachar was 54,400."
,"30":"When the tribe of Zebulun had been listed by clans and families, the names of all the males of twenty years and over, able to give military service, were recorded one by one."
,"31":"The total of these for the tribe of Zebulun was 57,400."
,"32":"The descendants of Joseph: when the tribe of Ephraim had been listed by clans and families, the names of all the males of twenty years and over, able to give military service, were recorded one by one."
,"33":"The total of these for the tribe of Ephraim was 40,500."
,"34":"When the tribe of Manasseh had been listed by clans and families, the names of all the males of twenty years and over, able to give military service, were recorded one by one."
,"35":"The total of these for the tribe of Manasseh was 32,200."
,"36":"When the tribe of Benjamin had been listed by clans and families, the names of all the males of twenty years and over, able to give military service, were recorded one by one."
,"37":"The total of these for the tribe of Benjamin was 35,400."
,"38":"When the tribe of Dan had been listed by clans and families, the names of all the males of twenty years and over, able to give military service were recorded one by one."
,"39":"The total of these for the tribe of Dan was 62,700."
,"40":"When the tribe of Asher had been listed by clans and families, the names of all the males of twenty years and over, able to give military service, were recorded one by one."
,"41":"The total of these for the tribe of Asher was 41,500."
,"42":"When the tribe of Napthali had been listed by clans and families, the names of all the males of twenty years and over, able to give military service, were recorded one by one."
,"43":"The total of these for the tribe of Napthali was 53,400."
,"44":"Such were the men registered by Moses, Aaron and the twelve leaders of Israel, each representing his tribe."
,"45":"Every man of Israel of twenty years and over, able to give military service, was counted according to his tribe."
,"46":"Altogether the full total was 603,550."
,"47":"But the Levites and their tribe were not included in the count."
,"48":"Yahweh spoke to Moses and said:"
,"49":"'Do not take any census of the Levites, or register them among the sons of Israel."
,"50":"You yourself must enlist the Levites to serve the Holy Tent of the Testimony and to look after its furnishings and its belongings. They are to carry the Holy Tent, and all its furnishings; they are to take care of it and set up their camp around it."
,"51":"Whenever the Holy Tent is to be moved, the Levites shall take it down; whenever the Holy Tent is to be set up again, they shall do this. Any layman coming near it must be put to death."
,"52":"The sons of Israel are to set up their tents in formation, each man with his own group and under his own banner."
,"53":"But the Levites are to set up their tents around the Holy Tent of the Testimony, lest God's anger fall on the whole community of Israel. The Levites will take care of the Holy Tent of the Testimony.'"
,"54":"The sons of Israel did exactly as Yahweh had commanded Moses."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Yahweh spoke to Moses and Aaron. He said:"
,"2":"'The Israelites are to camp, every man by his own banner, under the flag of his tribe. They are to camp all around the Holy Tent of the Testimony, but at some distance from it."
,"3":"Those who are to camp on the east side, towards the sunrise: the camp of Judah around his banner, in battle arrangement. Leader of the sons of Judah: Nahshon son of Amminadab."
,"4":"His command: 74,600 men."
,"5":"Encamped next to him: The tribe of Issachar. Leader of the sons of Issachar: Nethanel son of Zuar. "
,"6":"His command: 54,400 men."
,"7":"The tribe of Zebulun. Leader of the sons of Zebulun: Eliab son of Helon."
,"8":"His command: 57,400."
,"9":"The assembled strength of the camp of Judah numbers in all 186,400. These are to be first in marching."
,"10":"On the south side, the banner of the camp of Reuben, in battle formation. Leader of the sons of Reuben: Elizur son of Shedeur."
,"11":"His command: 46,500 men."
,"12":"Beside him shall camp: the tribe of Simeon. Leader of the sons of Simeon: Shelumiel son of Zurishaddai."
,"13":"His comand: 59,300 men."
,"14":"The tribe of Gad. Leader of the sons of Gad: Eliasaph son of Reuel."
,"15":"His command: 45,650 men."
,"16":"The assembled strength of the camp of Reuben numbers in all 151,450. They are to be second in order of marching."
,"17":"Next the Tent of Meeting will move, since the camp of the Levites is located in the middle of the other camps. The order of marching is to be the same order as in camping, every man under his own banner."
,"18":"On the west side, the banner of the camp of Ephraim, in battle formation. Leader of the sons of Ephraim: Elishama son of Ammihud."
,"19":"His command: 40,500 men."
,"20":"Next to him: the tribe of Manasseh. Leader of the tribe of Manasseh: Gamaliel son of Pedahzur."
,"21":"His command: 32,200 men."
,"22":"The tribe of Benjamin. Leader of the sons of Benjamin: Abidan son of Gideoni."
,"23":"His command: 35,400 men."
,"24":"The assembled strength of the camp of Ephraim numbers in all 108,100. They are to be third in order of marching."
,"25":"On the north side, the banner of the camp of Dan, in battle formation. Leader of the sons of Dan: Ahiezer son of Ammishaddai."
,"26":"His command: 62,700 men."
,"27":"Beside him shall camp"
,"28":"the tribe of Asher. Leader of the sons of Asher: Pagiel son of Ochran. His command: 41,500 men."
,"29":"The tribe of Naphtali. Leader of the sons of Naphtali: Ahira son of Enan."
,"30":"His command: 53,400 men."
,"31":"The assembled strength of the camp of Dan numbers in all 157,600. They are to be last in order of marching.'"
,"32":"Such was the total count of the sons of Israel when the census was made according to tribes. The full count of the entire camp, grouped under the various commands, was 603,550."
,"33":"The Levites, as Yahweh had commanded Moses, were not included in this census of the sons of Israel."
,"34":"The sons of Israel did exactly as Yahweh had commanded Moses. This was how they camped, grouped by banners. This was how they broke camp, each in his own clan, every man with his own family."
}`)
	CurrentBook.AddChapter(3, `{
"1":"These are the descendants of Aaron and Moses, at the time when Yahweh spoke to Moses on Mount Sinai."
,"2":"These are the names of the sons of Aaron: Nadab the eldest, then Abihu, Eleazar and Ithamar."
,"3":"These are the names of Aaron's sons, priests anointed and invested with the powers of the priesthood."
,"4":"Nadab and Abihu died in the presence of Yahweh, in the desert of Sinai, when they offered fire that was unlawful. They left no children and so it fell to Eleazar and Ithamar to exercise the priesthood under their father Aaron."
,"5":"Yahweh spoke to Moses and said:"
,"6":"'Call for the tribe of Levi and appoint them as servants to Aaron the priest."
,"7":"They are to perform the duties that are laid on him and on the entire community before the Tent of Meeting, in their service of the Holy Tent."
,"8":"They shall take care of the furnishings for the Tent of Meeting, and serve me in the Holy Tent as representatives of the sons of Israel."
,"9":"You are to give the Levites to Aaron and his sons; they are given to him by the sons of Israel."
,"10":"You are to enroll also Aaron and his sons, and they are to carry out the priestly duty. But any layman who comes near is to be put to death.'"
,"11":"Yahweh spoke to Moses and said:"
,"12":"'I myself have chosen the Levites from among the sons of Israel, in place of the firstborn, those who open the mother's womb among the sons of Israel; the Levites therefore belong to me,"
,"13":"for every firstborn belongs to me. On the day I struck all the firstborn of the Egyptians, I consecrated for my own all the firstborn of Israel, of both man and beast. They are mine; I am Yahweh.'"
,"14":"Yahweh spoke to Moses in the desert of Sinai. He said:"
,"15":"'You are to take a census of the sons of Levi by families and clans; all the males of the age of one month and over must be counted.'"
,"16":"Moses took this census, as Yahweh had ordered."
,"17":"These are the names of the sons of Levi: Gershon, Kohath and Merari."
,"18":"These are the names of Gershon's sons by their clans: Libni and Shimei;"
,"19":"Kohath's sons by their clans: Amran, Izhar, Hebron and Uzziel;"
,"20":"Merari's sons by their clans: Mahli and Mushi. These are the clans of Levi, grouped according to their ancestral families."
,"21":"From Gershon are descended the Libnite and the Shimeite clans; these are the Gershonite clans."
,"22":"Their number, counting the males of one month and over, came to 7,500."
,"23":"The Gershonite clans camped behind the Holy Tent, on the west side."
,"24":"The leader of the clan of Gershon was Eliasaph son of Lael."
,"25":"In the Tent of Meeting the sons of Gershon had charge of the Holy Tent, its inner and outer covers,"
,"26":"the screen for the entrance and curtains for the court which is around the Holy Tent and the altar, and the ropes needed for all this work."
,"27":"From Kohath are descended the Amramite, the Izharite, the Hebronite and the Uzzielite clans; these are the Kohathite clans."
,"28":"Their full number, counting the males of one month and over, came to 8,300. They were in charge of the sanctuary."
,"29":"The Kohathite clans camped on the south side of the Holy Tent."
,"30":"The leader of the Kohathite clans was Elizaphan son of Uzziel."
,"31":"They were in charge of the ark, the table, the lampstand, the altars, the sacred vessels used in the liturgy, and the screen."
,"32":"The chief of the Levite leaders was Eleazar, son of Aaron the priest. He was the head of all those who were in charge of the sanctuary."
,"33":"From Merari are descended the Mahlite and the Mushite clans; these are the Merarite clans."
,"34":"Their full number, counting the males of one month and over, came to 6,200."
,"35":"The leader of the Merarite clans was Zuriel, son of Abihail. They camped on the north side of the Holy Tent."
,"36":"The sons of Merari were in charge of the framework of the Holy Tent, with its crossbars, posts and bases, all its fittings,"
,"37":"and also the posts around the court, with their bases, pegs and ropes."
,"38":"Finally, on the east side, facing the Holy Tent and the Tent of Meeting, toward the sunrise, was the camp of Moses and Aaron and his sons, who had charge of the sanctuary for the people of Israel. Anyone else coming near was to be put to death."
,"39":"Altogether, the total count of Levites of the age of one month and over, whom Moses numbered by clans as Yahweh had ordered, came to 22,000."
,"40":"Yahweh said to Moses: 'Take a census of all the firstborn among the sons of Israel, all the males from the age of one month and over; take a census of them by name. "
,"41":"Then you will take the Levites for me, Yahweh, instead of the firstborn of Israel; in the same way you will give me their cattle instead of the firstborn cattle of the sons of Israel.'"
,"42":"As Yahweh commanded, Moses took a census of all the firstborn of the sons of Israel."
,"43":"The total count, by name, of the firstborn from the age of one month and over came to 22,273."
,"44":"Then Yahweh spoke to Moses and said,"
,"45":"'Take the Levites instead of all the firstborn of Israel's sons, and the cattle of the Levites instead of their cattle; the Levites shall be my own."
,"46":"But you have to buy back the 273 of the firstborn of the sons of Israel who outnumber the Levites."
,"47":"So for each one you are to pay five pieces of silver, according to the official standard,"
,"48":"and you shall give this money to Aaron and his sons.'"
,"49":"Moses received the 1,365 pieces of silver as ransom from those who were left when the rest had been redeemed by the Levites."
,"50":"From the firstborn of the Israelites he received one thousand three hundred and sixty-five pieces of silver according to the sanctuary standard."
,"51":"And he gave them to Aaron and his sons as Yahweh had ordered."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Yahweh spoke to Moses and Aaron. He said:"
,"2":"'Take a census of those Levites who are sons of Kohath, by sub-clans and families"
,"3":"count all the men between thirty and fifty years of age, those able to give military service who will be given tasks in the Tent of Meeting."
,"4":"These are the duties of the sons of Kohath in the Tent of Meeting: they are to have charge of the most holy things."
,"5":"When it is time to move from the camp, Aaron and his sons are to come and take down the veil of the screen. With it they shall cover up the ark of the Statement."
,"6":"On top of this they shall put a covering of fine leather, and spread over the whole a cloth all of violet. Then they are to fix the poles to the ark."
,"7":"Over the offertory table they are to spread a violet cloth and put on it the dishes, cups, bowls and jars for the wine offering; the bread offered to the Lord shall be perpetually on it."
,"8":"Over these they shall spread a cloth of scarlet and cover the whole with a covering of fine leather. Then they are to fix the poles to the table."
,"9":"They are then to take a cloth of violet and cover the light-bearing lampstand together with the lamps, tongs, trays and all the oil jars that belong to it."
,"10":"They are to put it, with all its utensils, on a covering of fine leather and place it on the carrying frame."
,"11":"Over the golden altar they must spread a violet cloth, and cover that with a covering of fine leather. Then they are to fix the poles to it."
,"12":"They are also to take all the other objects used in the service of the sanctuary. They must put them all on a violet cloth, cover them with a covering of fine leather and place them together on the carrying frame."
,"13":"When they have removed the ashes from the altar, they must spread a scarlet cloth over it,"
,"14":"and place on this all the objects used in the service at the altar: the fire pans, hooks, shovels, sprinkling basins and all the altar vessels. Over the whole they must spread a covering of fine leather. Then they are to fix the poles to it."
,"15":"When Aaron and his sons have finished covering all the sacred objects and all the equipment in preparation for moving from camp, the sons of Kohath are to come to carry the sacred things, but without touching any of them; otherwise they would die. This is the duty given to the sons of Kohath in the Tent of Meeting."
,"16":"Eleazar, son of Aaron the priest, is to watch over the oil for the light, the sweet-smelling incense, the grain offerings and the anointing oil; he must watch over the whole Holy Tent and everything in it: the sacred objects and their equipment.'"
,"17":"Yahweh spoke to Moses and Aaron. He said:"
,"18":"'Do not let the families of Kohath be cut off from the number of the Levites."
,"19":"This is what you shall do for them, lest they die when they approach the most holy things: Aaron and his sons must go in and assign to each of them his task."
,"20":"In this way they can go in and yet not look, even for a moment, on any of the holy things; if they do, they will die.'"
,"21":"Yahweh spoke to Moses and said to him:"
,"22":"'Take a census also of the sons of Gershon, by families and sub-clans:"
,"23":"count the men between thirty and fifty years of age, those able to give military service, who will be given tasks in the Tent of Meeting."
,"24":"These are the duties of the Gershonites:"
,"25":"They are to carry the curtains of the Holy Tent, the Tent of Meeting with its covering and the other covering of fine leather that goes over it,"
,"26":"the screen for the entrance to the Tent of Meeting, the curtains for the court, the screen for the entrance to the court that is around the Holy Tent and the altar, the ropes and all the necessary equipment."
,"27":"They are to be responsible for these things. These are the duties of the sons of Gershon. Their functions and their tasks are to be carried out under the direction of Aaron and his sons: you must see that they fulfill their duties."
,"28":"Such shall be the duties of the Gershonites in the Tent of Meeting. Their work will be supervised by Ithamar, son of Aaron the priest."
,"29":"You are to count the sons of Merari, by sub-clans and families."
,"30":"Count all the men between thirty and fifty years of age, those able to give military service, who will be given tasks in the Tent of Meeting."
,"31":"The burden they are to carry and the duties that are to fall to them in the Tent of Meeting shall be as follows: the framework of the Holy Tent, its crossbars, its posts and bases,"
,"32":"the posts around the court with their bases, pegs, ropes and all the fittings used in setting them up. You are to draw up a list of their names with the duty that each man must fulfill."
,"33":"These are the duties of the Merarite clans. All their duties in the Tent of Meeting will be supervised by Ithamar, son of Aaron the priest.'"
,"34":"Moses, Aaron and the leaders of the community took a census of the sons of Kohath, by sub-clans and families,"
,"35":"of every man between thirty and fifty years of age, able to give military service and to be given tasks in the Tent of Meeting,"
,"36":"the total of their clans was 2,750 men."
,"37":"This was the number of the Kohathites, of all those who were given tasks in the Tent of Meeting whom Moses and Aaron counted at the Lord's command given through Moses."
,"38":"A census was taken of the sons of Gershon,"
,"39":"by sub-clans and families, of every man between thirty and fifty years of age able to give military service and to be given tasks in the Tent of Meeting."
,"40":"The total was 2,630 men."
,"41":"This was the number of the Gershonites, of all those who were given tasks in the Tent of Meeting, whom Moses and Aaron counted at the Lord's command."
,"42":"A census was taken of the sons of Merari, by sub-clans and families,"
,"43":"of every man between thirty and fifty years of age, able to give military service and to be given tasks in the Tent of Meeting."
,"44":"The total was 3,200 men."
,"45":"This was the number of the Merarites whom Moses and Aaron counted at the Lord's command through Moses."
,"46":"The total number of Levites, counted according to clans and families -"
,"47":"all the men between thirty and fifty years of age, able to give military service and to be given tasks of carrying burdens in the Tent of Meeting"
,"48":"amounted to 8,580."
,"49":"At Yahweh's command given through Moses, the census was taken to assign to every man his duty and his task; they were numbered as Yahweh had commanded Moses."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Yahweh spoke to Moses and said:"
,"2":"'Order the Israelites to put out of the camp all lepers, and all who suffer from a contagious infection, or who have become unclean by touching a corpse."
,"3":"Man or woman, you must put them out and forbid them to return to the camp. The Israelites must not allow the camp where I dwell among them to become unclean in this way.'"
,"4":"The Israelites did so: they put them out of the camp. The Israelites did as Yahweh had commanded Moses."
,"5":"Yahweh spoke to Moses and said,"
,"6":"'Tell the people of Israel: If anyone commits a fault against another person, and thus is unfaithful to Yahweh, "
,"7":"that person must confess the sin committed and give back in full the amount which was taken plus 20' more. Payment is to be made to the person who was wronged."
,"8":"If, however, that person has died and there is no near relative to whom the ill-gotten goods can be returned, this payment owed to Yahweh shall be given to the priest, in addition to the ram of atonement with which the priest makes atonement for the guilty person."
,"9":"For of everything consecrated by Israelites and brought to the priest he has a right to the share set aside."
,"10":"Whatever a person consecrates is his own; whatever is given to the priest belongs to the priest.'"
,"11":"Yahweh spoke to Moses and said,"
,"12":"'Say this to the people of Israel: If anyone has a wife who goes astray and is unfaithful to him, "
,"13":"sleeping with some other man without the husband's knowledge, and she disgraces herself in secret in this way, without any witness against her, and without anyone catching her in the act;"
,"14":"then, perhaps the spirit of jealousy will come over the husband and make him jealous for the wife who has disgraced herself. But perhaps the spirit of jealousy comes upon the husband, and makes him jealous of his wife even though she is innocent."
,"15":"In these cases the man must bring his wife before the priest, and on her behalf make an offering of two pounds of barley flour. He is not to pour oil on it or put incense on it, because this is an 'offering for jealousy,' a memorial offering to record a fault."
,"16":"The priest is then to bring the woman forward and stand her before Yahweh."
,"17":"Then he shall take living water in an earthen jar, and on the water throw dust that he has taken from the floor of the Holy Tent."
,"18":"After he has placed the woman before Yahweh, he shall loosen her hair and put in her hands the commemorative offering (that is, the offering for jealousy). In his own hands the priest will hold the bowl containing bitter water that brings a curse."
,"19":"He is then to make the woman agree to an oath. He shall say to her: If it is not true that a man has slept with you, that you have gone astray and disgraced yourself while under your husband's authority, then may this water of bitterness and cursing do you no harm."
,"20":"But if it is true that you have gone astray, and have disgraced yourself by sharing your bed with a man other than your husband,"
,"21":"may Yahweh make of you an example and a curse among your people, making your breast shrink and your stomach swell!"
,"22":"May this water of cursing enter your body to swell your stomach and to shrink your breast! The woman must answer: Amen! Amen!"
,"23":"Then the priest shall write these curses down and wash them off in the bowl of bitter water."
,"24":"He must make the woman drink this water of bitterness and of cursing, and this water of cursing shall go into her and be bitter inside her."
,"25":"The priest shall then take the offering for jealousy from the woman's hands, and hold it up before Yahweh with a gesture of offering, and so carry it up to the altar."
,"26":"He shall take a handful of the flour as a memorial, and burn it on the altar. He shall then make the woman drink the water. "
,"27":"After he has made her drink it, if it is true that she has disgraced herself, deceiving her husband, then the water of cursing that goes into her shall indeed be bitter: her belly will swell and her breast shrink, and she will be a curse among her people."
,"28":"But if she has not disgraced herself and is clean, then she will go unharmed and will bear children."
,"29":"This is the law in cases of jealousy, when a woman has gone astray and disgraced herself while under her husband's authority,"
,"30":"or when a spirit of jealousy has come over a man and made him jealous for his wife. When a husband brings such a woman before Yahweh, the priest must apply this law to her in full."
,"31":"The husband shall be guiltless, but the woman must bear the punishment for her sin.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Yahweh spoke to Moses, 'Speak to the people of Israel"
,"2":"and say to them: When either a man or a woman makes a special vow, the vow of a Nazirite, to dedicate himself to Yahweh,"
,"3":"he shall abstain from wine and strong drink. He shall not drink vinegar made from wine or strong drink; nor shall he drink the juice of the grape or eat fresh or dried grapes."
,"4":"All the time he lives as a Nazirite he shall eat nothing produced by the grapevine, from the pips to the skin."
,"5":"All the days of his vow of separation no razor shall touch his head. Until the time of his dedication to Yahweh is over, he will be a consecrated person and he shall let his hair grow freely."
,"6":"For all the time of his separation in honor of Yahweh he shall not go near a dead person,"
,"7":"not even for his father, mother, brother or sister, lest he be defiled, for he bears on his head the sign of his consecration to God."
,"8":"All the time he lives as a Nazirite he is consecrated to Yahweh."
,"9":"If someone suddenly dies near him, his dedicated head is defiled. He then shall be purified on the seventh day and shave his head on that day."
,"10":"Then on the eighth day he shall bring two turtledoves or two young pigeons to the priest at the entrance to the Tent of Meeting."
,"11":"The priest shall offer one as a sin offering and the other as a burnt offering; so he shall make atonement for his sin because of the dead person."
,"12":"And that same day the Nazirite shall again consecrate his head and bring a yearling lamb as a guilt offering. The time of his consecration begins again from that day. The former days are not valid for his separation has been defiled."
,"13":"This is the ritual regarding the Nazirite on the day when his period of consecration is completed. He is to be led to the entrance of the Tent of Meeting,"
,"14":"and must make his offering to Yahweh: a one-year-old male lamb without any defect for burnt offering, a one-year-old lamb without any defect for sacrifice for sin; a ram without any defect for peace offering;"
,"15":"and a basket of unleavened loaves made of fine flour mixed with oil, and of unleavened wafers spread with oil, with the required offerings of grain and wine."
,"16":"When he has brought all this before Yahweh, the priest must offer the sacrifice for sin and the burnt offering for the Nazirite."
,"17":"Then he shall offer the peace offering with the ram and the unleavened bread in the basket, and finally the priest shall offer the accompanying offerings of grain and wine."
,"18":"Then the Nazirite shall shave off his consecrated hair at the entrance to the Tent of Meeting, and put it in the fire of peace offering."
,"19":"The priest is to take the shoulder of the ram, as soon as it is cooked, with an unleavened cake from the basket, and an unleavened wafer. He is to put them into the hands of the Nazirite who has just shaved off his hair."
,"20":"With them he must make the gesture of offering before Yahweh; as it is a holy thing, it belongs by law to the priest, in addition to the breast that has been presented and the leg of the ram that has been set aside. After this the Nazirite may once more drink wine."
,"21":"Such is the ritual for the Nazirite, if, besides the hair, he has also vowed a personal offering to Yahweh, he must fulfill the vow he has made, in addition to what the ritual prescribes for his hair.'"
,"22":"Then Yahweh spoke to Moses saying,"
,"23":"'Speak to Aaron and his sons and say to them: This is how you shall bless the people of Israel; you shall say:"
,"24":"May Yahweh bless you and keep you!"
,"25":"May Yahweh let his face shine on you, and be gracious to you!"
,"26":"May Yahweh look kindly on you, and give you his peace!"
,"27":"In that way shall they put my name on the people of Israel and I will bless them.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"On the day Moses finished setting up the Holy Tent, he anointed and consecrated it with all its furniture, as well as the altar and all its equipment. When he had anointed and consecrated it all,"
,"2":"the leaders of Israel made an offering; these were the heads of the clans, who were leaders of tribes and had supervised the census."
,"3":"They brought their offering before Yahweh: six covered wagons and twelve oxen, one wagon for every two leaders and one ox each. They brought them before the Holy Tent."
,"4":"Yahweh then spoke to Moses and said,"
,"5":"'Accept these from them, and let them be set apart for the service of the Tent of Meeting. You are to give them to the Levites, to each as his duties require.'"
,"6":"Moses took the wagons and the oxen, and gave them to the Levites."
,"7":"To the sons of Gershon he gave two wagons and four oxen for the duties they had to perform."
,"8":"To the sons of Merari he gave four wagons and eight oxen, for the duties they had to perform under the direction of Ithamar, son of Aaron the priest."
,"9":"But to the sons of Kohath he gave none at all, because the sacred duty given to them had to be carried on their shoulders."
,"10":"The leaders then made an offering for the dedication of the altar, on the day it was anointed. They brought their offering before the altar,"
,"11":"and Yahweh said to Moses, 'Let the leaders each bring an offering each day for a period of twelve days for the dedication of the altar.'"
,"12":"On the first day an offering was brought by Nahshon son of Amminadab, of the tribe of Judah."
,"13":"His offering was: one silver bowl weighing 50 ounces, one silver sprinkling bowl weighing 30 ounces by the official standard, both of them filled for the grain offering with fine flour mixed with oil,"
,"14":"one golden bowl weighing four ounces, filled with incense,"
,"15":"one young bull, one ram and one male one-year-old lamb for the burnt offering;"
,"16":"one goat for the sacrifice for sin;"
,"17":"and, for the peace offering: two oxen, five rams, five goats, and five male one-year-old lambs. This was the offering of Nahshon son of Amminadab."
,"18":"On the second day an offering was brought by Nethanel son of Zuar, leader of Issachar."
,"19":"His offering was: one silver bowl weighing 50 ounces, one silver sprinkling bowl weighing 30 ounces by the official standard, both of them filled for the grain offering with fine flour mixed with oil,"
,"20":"one golden bowl weighing four ounces, filled with incense,"
,"21":"one young bull, one ram and one male one-year-old lamb for the burnt offering,"
,"22":"one goat for the sacrifice for sin,"
,"23":"and, for the peace offering: two oxen, five rams, five goats, and five male one-year-old lambs. This was the offering of Nethanel son of Zuar."
,"24":"On the third day an offering was brought by Eliab son of Helon, leader of the sons of Zebulun."
,"25":"His offering was: one silver bowl weighing 50 ounces, one silver sprinkling bowl weighing ounces by the official standard, both of them filled for the grain offering with fine flour mixed with oil,"
,"26":"one golden bowl weighing 50 ounces, filled with incense,"
,"27":"one young bull, one ram and one male one-year-old lamb for the burnt offering;"
,"28":"one goat for the sacrifice for sin,"
,"29":"and for the peace offering: two oxen, five rams, five goats, and five male one-year-old lambs. This was the offering of Eliab son of Helon."
,"30":"On the fourth day an offering was brought by Elizur son of Shedeur, leader of the sons of Reuben."
,"31":"His offering was: one silver bowl weighing 50 ounces, one silver sprinkling bowl weighing 30 ounces by the official standard, both of them filled for the grain offering with fine flour mixed with oil,"
,"32":"one golden bowl weighing four ounces, filled with incense,"
,"33":"one young bull, one ram, and one male one-year-old lamb for the burnt offering,"
,"34":"one goat for the sacrifice for sin,"
,"35":"and, for the peace offering: two oxen, five rams, five goats, and five male one-year-old lambs. This was the offering of Elizur son of Shedeur."
,"36":"On the fifth day an offering was brought by Shelumiel son of Zurishaddai, leader of the sons of Simeon."
,"37":"His offering was: one silver bowl weighing 50 ounces, one silver sprinkling bowl weighing 30 ounces by the official standard, both of them filled for the grain offering with fine flour mixed with oil, 38 one golden bowl weighing four ounces, filled with incense,"
,"39":"one young bull, one ram and one male one-year-old lamb for the burnt offering,"
,"40":"one goat for the sacrifice for sin;"
,"41":"and, for the peace offering: two oxen, five rams, five goats, and five male one-year-old lambs. This was the offering of Shelumiel son of Zurishaddai."
,"42":"On the sixth day an offering was brought by Eliasaph son of Reuel, leader of the sons of Gad."
,"43":"His offering was: one silver bowl weighing 50 ounces, one silver sprinkling bowl weighing 30 ounces by the official standard, both of them filled for the grain offering with fine flour mixed with oil,"
,"44":"one golden bowl weighing four ounces, filled with incense,"
,"45":"one young bull, one ram and one male one-year-old lamb for the burnt offering,"
,"46":"one goat for sacrifice for sin,"
,"47":"and, for the peace offering: two oxen, five rams, five goats, and five male one-year-old lambs. This was the offering of Eliasaph son of Reuel."
,"48":"On the seventh day an offering was brought by Elishama son of Ammihud, leader of the sons of Ephraim."
,"49":"His offering was: one silver bowl weighing 50 ounces, one silver sprinkling bowl weighing 30 ounces by the official standard, both of them filled for the grain offering with fine flour mixed with oil,"
,"50":"one golden bowl weighing four ounces filled with incense,"
,"51":"one young bull, one ram and one male one-year-old lamb for the burnt offering;"
,"52":"one goat for the sacrifice for sin,"
,"53":"and, for the peace offering, two oxen, five rams, five goats, and five male one-year-old lambs. This was the offering of Elishama, son of Ammihud."
,"54":"On the eighth day an offering was brought by Gamaliel son of Pedahzur, leader of the sons of Manasseh."
,"55":"His offering was: one silver bowl weighing 50 ounces, one silver sprinkling bowl weighing 30 ounces by the official standard, both of them filled for the grain offering with fine flour mixed with oil,"
,"56":"one golden bowl weighing four ounces, filled with incense,"
,"57":"one young bull, one ram and one male one-year-old lamb for the burnt offering:"
,"58":"one goat for the sacrifice for sin;"
,"59":"and, for the peace offering: two oxen, five rams, five goats, and five male one-year-old lambs. This was the offering of Gamaliel son of Pedahzur."
,"60":"On the ninth day an offering was brought by Abidan son of Gideoni, leader of the sons of Benjamin."
,"61":"His offering was: one silver bowl weighing 50 ounces, one sprinkling bowl weighing 30 ounces by the official standard, both of them filled for the grain offering with fine flour mixed with oil,"
,"62":"one golden bowl weighing four ounces, filled with incense,"
,"63":"one young bull, one ram and one male one-year-old lamb for the burnt offering;"
,"64":"one goat for the sacrifice for sin,"
,"65":"and, for the peace offering: two oxen, five rams, five goats, and five male one-year-old lambs. This was the offering of Abidan son of Gideoni."
,"66":"On the tenth day an offering was brought by Ahiezer son of Ammishaddai, leader of the sons of Dan."
,"67":"His offering was: one silver bowl weighing 50 ounces, one silver sprinkling bowl weighing 30 ounces by the official standard, both of them filled, for the grain offering, with fine flour mixed with oil,"
,"68":"one golden bowl weighing four ounces, filled with incense,"
,"69":"one young bull, one ram, and one male one-year-old lamb for the burnt offering,"
,"70":"one goat for the sacrifice for sin,"
,"71":"and, for the peace offering: two oxen, five rams, five goats, and five male one-year-old lambs. This was the offering of Ahiezer son of Ammishaddai."
,"72":"On the eleventh day an offering was brought by Pagiel son of Ochran, leader of the sons of Asher."
,"73":"His offering was: one silver bowl weighing 50 ounces, one silver sprinkling bowl weighing 30 ounces by the official standard, both of them filled for the grain offering with fine flour mixed with oil,"
,"74":"one golden bowl weighing four ounces, filled with incense,"
,"75":"one young bull, one ram and one male one-year-old lamb for the burnt offering;"
,"76":"one goat for the sacrifice for sin;"
,"77":"and, for the peace offering: two oxen, five rams, five goats, and five male one-year-old lambs. This was the offering of Pagiel son of Ochran."
,"78":"On the twelfth day an offering was brought by Ahira son of Enan, leader of the sons of Naphtali."
,"79":"His offering was: one silver bowl weighing 50 ounces, one silver sprinkling bowl weighing 30 ounces by the official standard, both of them filled for the grain offering with fine flour mixed with oil,"
,"80":"one golden bowl weighing four ounces, filled with incense,"
,"81":"one young bull, one ram and one male one-year-old lamb for the burnt offering;"
,"82":"one goat for the sacrifice for sin,"
,"83":"and, for the peace offering: two oxen, five rams, five goats, and five male one-year-old lambs. This was the offering of Ahira son of Enan."
,"84":"These were the offerings made by the leaders of Israel for the dedication of the altar on the day it was anointed: twelve silver bowls, twelve silver sprinkling bowls, and twelve golden bowls."
,"85":"Each silver bowl weighed 50 ounces, and each sprinkling bowl 30 ounces, the silver of these objects weighing in all 60 pounds."
,"86":"The twelve golden bowls filled with incense weighed four ounces each, the gold of these bowls weighing in all 48 ounces."
,"87":"The sum total of animals for the burnt offering: twelve bulls, twelve rams, twelve male one-year-old lambs, together with their accompanying grain offering. For the sacrifice for sin, twelve goats."
,"88":"The sum total of animals for the peace offering: twenty-four bulls, sixty rams, sixty goats, and sixty male one-year-old lambs. These were the offerings for the dedication of the altar, after it had been anointed."
,"89":"When Moses went into the Tent of Meeting to speak with Him, he heard the voice speaking to him from above the Mercy Seat which was on the Ark of the Covenant, from between the two cherubim."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Yahweh spoke to Moses and said:"
,"2":"'Say this to Aaron: Set up the lamps, so that the seven lamps throw their light toward the front of the lampstand.'"
,"3":"Aaron set up the lamps to the front of the lampstand, as the Lord had commanded Moses."
,"4":"This lampstand was made of hammered gold; from its stem to its petals, it was of hammered gold. This lampstand had been made according to the pattern Yahweh had shown to Moses."
,"5":"Yahweh spoke to Moses and said:"
,"6":"'Separate the Levites from the other Israelites and purify them."
,"7":"You shall sprinkle them with the water of purification, and they shall shave their bodies all over and wash their clothing. They will then be clean."
,"8":"They shall next take a young bull, with the accompanying grain offering of fine flour mixed with oil, and you shall take a second young bull for a sacrifice for sin."
,"9":"Then bring the Levites before the Tent of Meeting, and call together the whole community of Israel."
,"10":"When you have brought the Levites before Yahweh, the sons of Israel must lay their hands on them."
,"11":"Aaron shall then offer the Levites, and make the gesture of offering waving them before Yahweh on behalf of the Israelites. From that time, they will be dedicated to the service of Yahweh."
,"12":"The Levites must then lay their hands on the heads of the bulls, one of which you are to offer as a sacrifice for sin, and the other as a burnt offering to Yahweh; this is the rite of atonement for the Levites."
,"13":"Having brought the Levites before Aaron and his sons, you will present them to Yahweh and wave them before him."
,"14":"So you shall set the Levites apart from the rest of the sons of Israel, so that they may be mine."
,"15":"The Levites may begin their ministry in the Tent of Meeting when you have purified them and offered them with the gesture of offering."
,"16":"They are given me from among all the sons of Israel. They are to replace all the firstborn of all the sons of Israel. I have taken them for my own."
,"17":"For all the firstborn among the sons of Israel, man and beast, belong to me: the day I struck all the firstborn in the land of Egypt, I consecrated them to myself,"
,"18":"and now, in place of all the firstborn among the sons of Israel, I have taken the Levites."
,"19":"But now I give them to Aaron and his sons from among the sons of Israel and they will minister in the Tent of Meeting on behalf of the sons of Israel, and perform the rite of atonement over them, so that none of the sons of Israel may be struck down for approaching the sanctuary.'"
,"20":"Moses, Aaron and the whole community of the sons of Israel dealt with the Levites exactly as Yahweh had ordered Moses; this is what the sons of Israel did with them."
,"21":"The Levites purified themselves and washed their clothes, and Aaron presented them and waved them before Yahweh. Then he performed the rite of atonement over them."
,"22":"The Levites were then allowed to perform their ministry in the Tent of Meeting in the presence of Aaron and his sons. As Yahweh had ordered Moses concerning the Levites, so it was done to them."
,"23":"Yahweh spoke to Moses and said:"
,"24":"'This concerns the Levites. The Levite shall exercise his ministry and do his duties in the Tent of Meeting from the age of twenty-four onward."
,"25":"After the age of fifty, he is no longer bound to the ministry; he shall have no further duties;"
,"26":"but he can still help his brothers to perform the services in the Tent of Meeting, though he himself will no longer have any ministry. See that this is the rule for the ministry of the Levites.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Yahweh spoke to Moses in the wilderness of Sinai, in the second year after the exodus from Egypt, in the first month. He said:"
,"2":"'Let the sons of Israel keep the Passover at its appointed time."
,"3":"The fourteenth day of this month, between the two evenings, is the appointed time for you to keep it. Then you must celebrate the Passover according to all the laws and customs proper to it.'"
,"4":"So Moses gave orders for the sons of Israel to celebrate the Passover."
,"5":"They celebrated it in the wilderness of Sinai, in the first month, on the fourteenth day of the month, between the two evenings. The people of Israel did exactly as Yahweh had ordered Moses."
,"6":"It happened that some men had become unclean by touching a dead body and they could not celebrate the Passover that day. They came the same day to Moses and Aaron,"
,"7":"and said to them, 'We have become unclean by touching a dead body. Why should we be forbidden to celebrate the sacrifice to Yahweh at the proper time with the rest of the Israelites?'"
,"8":"Moses answered them, 'Wait there till I hear what Yahweh tells me about you.'"
,"9":"Yahweh spoke to Moses and said,"
,"10":"'Say this to the Israelites: If anyone, among you or your descendants, becomes unclean by touching a dead body or is far away on a journey, he can still celebrate the Passover for Yahweh."
,"11":"He shall do it one month later instead, on the fourteenth day, between the two evenings. Then you shall celebrate it with unleavened bread and bitter herbs;"
,"12":"nothing of the victim must be left over until morning, nor must they break any of its bones: You shall keep all the regulations of the Passover."
,"13":"But anyone who is clean and not away on a journey, and who fails to celebrate the Passover, shall be cut off from his people because he did not bring the offering to Yahweh at its appointed time. So he must suffer the punishment for his sin."
,"14":"If a stranger is living among you and wants to celebrate the Passover for Yahweh, he must celebrate it in accordance with the laws and customs of the Passover. There is to be only one law among you, for settler and native alike.'"
,"15":"On the day the Holy Tent, that is the Tent of Meeting, was set up, the Cloud covered it. At nightfall the Cloud took the appearance of fire over the Holy Tent and remained so until the morning."
,"16":"The Cloud covered it continually in daytime and at night it looked like fire."
,"17":"Whenever the Cloud lifted above the Tent, the Israelites took down their tents and continued their journey; whenever the Cloud stopped, there the Israelites camped."
,"18":"The Israelites left at the command of Yahweh, and at his command they camped. The people remained in camp as long as the Cloud rested on the Holy Tent. "
,"19":"As long as the Cloud stayed above the Holy Tent the Israelites obeyed Yahweh and did not move on."
,"20":"Whether the Cloud happened to stay for many days above the Holy Tent or only one day, they camped at Yahweh's command and moved on at Yahweh's command."
,"21":"If the Cloud happened to remain only from evening to morning, they moved on when it lifted the next morning. Or, if it stayed for a whole day and night, they moved on only when it lifted."
,"22":"Sometimes it stayed there for two days, a month, or a year; however long the Cloud stayed above the Holy Tent, the Israelites remained in camp in the same place, and when it lifted they moved on."
,"23":"At Yahweh's command they camped, and at Yahweh's command they moved on. They obeyed Yahweh's command given through Moses."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Yahweh spoke to Moses and said:"
,"2":"'Make two trumpets of hammered silver that you shall use for calling the people together, and for sounding the order to move on."
,"3":"Whenever both trumpets are sounded, the whole community is to gather around you, at the entrance to the Tent of Meeting."
,"4":"But if only one trumpet is sounded, then only the leaders, the chiefs of clans are to gather around you."
,"5":"When the trumpet sounds shrilly, the camps to the east shall move on."
,"6":"At the second shrill blast, the camps pitched to the south shall move on. The trumpet blast shall be shrill when they are to leave;"
,"7":"but to gather the people, the trumpet shall be sounded plainly."
,"8":"The sons of Aaron, the priests, are to sound the trumpets; this is a law for you and your descendants for all time to come."
,"9":"When you are in your own land and are to go to war against an enemy who oppresses you, you shall sound the trumpet shrilly so Yahweh your God will remember you, and you will be delivered from your enemies."
,"10":"On joyful occasions, on your festival and new-moon feast, you will sound the trumpet at the time of your burnt offering and your communion sacrifices, and they will call you to the remembrance of your God. I am Yahweh your God.'"
,"11":"On the twentieth day of the second month in the second year after the people left Egypt, the Cloud lifted over the Holy Tent of the Covenant"
,"12":"and the Israelites moved on, in marching order, from the desert of Sinai. The Cloud came to rest in the desert of Paran."
,"13":"This was the first stage of the Israelites' journey at the command of Yahweh given through Moses:"
,"14":"in the front was the banner of the camp of the tribe of Judah, in battle formation. In command of Judah's force was Nahshon son of Amminadab;"
,"15":"in command of the tribe of Issachar, in battle formation, was Nethanel son of Zuar;"
,"16":"in command of the tribe of Zebulun, in battle formation, was Eliab son of Helon."
,"17":"Then, the Holy Tent was taken down and the sons of Gershon and the sons of Merari started out, carrying the Holy Tent."
,"18":"Then came the banner of the camp of the tribe of Reuben, in battle formation. In command of Reuben's force was Elizur son of Shedeur;"
,"19":"in command of the tribe of Simeon, in battle formation, was Shelumiel son of Zurishaddai;"
,"20":"in command of the tribe of Gad, in battle formation, was Eliasaph, son of Reuel."
,"21":"Then came the sons of Kohath, who carried the sanctuary (the Holy Tent was set up before their arrival.)"
,"22":"Then came the banner of the camp of the sons of Ephraim, in battle formation. In command of Ephraim's force was Elishama son of Ammihud;"
,"23":"in command of the tribe of Manasseh, in battle formation, was Gamaliel son of Pedahzur;"
,"24":"in command of the tribe of Benjamin was Abidan son of Gideoni."
,"25":"Last of all, serving as rearguard of all the camps, came the sons of Dan, in battle formation. In command of the force of Dan was Ahiezer son of Ammishaddai;"
,"26":"in command of the tribe of the sons of Asher, in battle formation, was Pagiel son of Ochran;"
,"27":"in command of the sons of Naphtali, in battle formation, was Ahira son of Enan."
,"28":"Such was the order of march for the Israelites, in battle formation. So they set out."
,"29":"Moses said to Hobab, son of Moses' father-in-law, Reuel the Midianite, 'We are setting out for the land which Yahweh has promised to give us. Come with us, and we will treat you well, for Yahweh has promised happiness to Israel.' He answered,"
,"30":"'I will not come with you. I would rather go to my own land and my own family.' Moses replied,"
,"31":"'Do not leave us, for you know where we can camp in the desert, and so you will be our eyes."
,"32":"If you come with us, you will share in the blessing with which Yahweh blesses us.'"
,"33":"They moved on from the Mountain of Yahweh, a three days' journey, and for three days the Ark of the Covenant of Yahweh went before them,"
,"34":"seeking out a resting place for them. Yahweh's cloud was over them by day when they left the camp. "
,"35":"Whenever the Ark left, Moses would say, 'Arise, Yahweh, and let your enemies be scattered and let those who hate you flee before you.'"
,"36":"And when it came to rest, he would say, 'Come back, Yahweh, to the multitude - the armies of Israel.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Now the people were seeking a quarrel with Yahweh. Yahweh heard and his anger was aroused. A fire from Yahweh flared out against them and burned the outer part of the camp."
,"2":"Then the people cried out to Moses and he interceded for them to Yahweh and the fire died out."
,"3":"They called the place Taberah, because the fire of Yahweh was inflamed against them."
,"4":"Now the rabble that was among them had greedy desires and even the Israelites wept and said, 'Who will give us meat to eat?"
,"5":"We remember the fish we ate without cost in Egypt, the cucumbers, the melons, the leeks, the onions and garlic."
,"6":"Now our appetite is gone; there's nothing to look at, nothing but manna.'"
,"7":"Now the manna was like coriander seed and had the appearance of bedellium."
,"8":"The people went about gathering it up and then ground it between millstones or pounded it in a mortar. They boiled it in a pot and made cakes with it which tasted like cakes made with oil."
,"9":"As soon as dew fell at night in the camp, the manna came with it."
,"10":"Moses heard the people crying, family by family at the entrance to their tent and Yahweh became very angry. This displeased Moses. "
,"11":"Then Moses said to Yahweh, 'Why have you treated your servant so badly? Is it because you do not love me that you burdened me with this people?"
,"12":"Did I conceive all these people and did I give them birth? And now you want me to carry them in my bosom as a nurse carries an infant, to the land you promised on oath to their fathers?"
,"13":"Where would I get meat for all these people, when they cry to me saying: 'Give us meat that we may eat?'"
,"14":"I cannot, myself alone, carry all these people; the burden is too heavy for me."
,"15":"Kill me rather than treat me like this, I beg of you, if you look kindly on me, and let me not see your anger.'"
,"16":"Yahweh said to Moses, 'Assemble seventy men from the elders of Israel whom you recognize as elders and men of authority over them and bring them to the Tent of Meeting and let them take their stand there with you."
,"17":"I shall come down to speak with you and I shall take some of the spirit that is in you and put it in them. From now on they will share with you the burden of the people so that no longer will you bear it alone."
,"18":"You shall say to the people of Israel: Consecrate yourselves for tomorrow and you shall eat meat, for you have wept in the hearing of Yahweh, saying: Who will give us meat to eat? For it was well with us in Egypt! Yahweh will give you meat and"
,"19":"you shall eat, not only one day, or two, or five or ten or twenty days"
,"20":"but a whole month until it comes out of your nostrils and becomes loathsome to you. For you have rejected Yahweh who is in your midst and have wept before him saying: Why did we ever leave Egypt?'"
,"21":"And Moses said, 'The people I am with are six hundred thousand on foot and yet you say, 'I will give them meat and they shall eat it for a whole month!'"
,"22":"Will sheep and cattle be slaughtered in sufficient number for them? All the fish of the sea would not be enough for them.'"
,"23":"And Yahweh said to Moses, 'Is Yahweh's arm shortened? Now you shall see whether or not my word is true.'"
,"24":"Moses then went out and told the people what Yahweh had said. He assembled seventy men from among the elders and placed them round about the Tent."
,"25":"Yahweh came down in the cloud and spoke to him. He took some of the spirit that was upon him and put it on the seventy elders. Now when the spirit rested upon them, they prophesied. But this they did not do again."
,"26":"Two men had remained in the camp; the name of one was Eldad, the name of the other Medad. However, the spirit came on them for they were among those who were registered though they had not gone out to the Tent. As they prophesied inside the camp,"
,"27":"a young man ran and told Moses, 'Eldad and Medad are prophesying in the camp.'"
,"28":"Joshua, the son of Nun, who ministered to Moses from his youth said, 'My lord Moses, stop them!'"
,"29":"But Moses said to him, 'Are you jealous on my behalf? Would that all Yahweh's people were prophets and that Yahweh would send his spirit upon them!'"
,"30":"Then Moses and all the elders of the people returned to the camp."
,"31":"A wind arose, sent by Yahweh, that drove in quails from the sea and let them down beside the camp covering the distance of a day's walk on one side and almost a day's walk on the other side around the camp; they were about three feet deep on the ground."
,"32":"The people spent that day, the whole night and all the next day gathering the quail. He who gathered the least had ten homers; and they spread them out for themselves around the camp."
,"33":"The meat was still between their teeth when already the anger of Yahweh was kindled against the people and he struck them with a very severe plague."
,"34":"That place was named Kibroth-hattaavah because there they buried these greedy people."
,"35":"From Kibroth-hattaavah the people moved on towards Hazeroth where they remained."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Miriam and Aaron spoke against Moses because of the Cushite woman he had married"
,"2":"and they said, 'Has Yahweh only spoken through Moses? Has he not also spoken through us?' And Yahweh heard."
,"3":"Now Moses was a very humble man, more humble than any man on the face of the earth."
,"4":"Yet suddenly Yahweh said to Moses, Aaron and Miriam, 'Come out, all three of you, to the Tent of Meeting.' The three of them came out."
,"5":"Yahweh came down in the pillar of cloud and, standing at the door of the Tent, called Aaron and Miriam. They both went out and"
,"6":"he said, 'Listen carefully to what I say, If there is a prophet among you, I reveal myself to him in a vision,and I speak to him in a dream."
,"7":"It is not so for my servant, Moses, my trusted steward in all my household."
,"8":"To him I speak face to face, openly, and not in riddles, and he sees the presence of Yahweh. Why then did you not fear to speak against my servant, against Moses?'"
,"9":"Yahweh became angry with them and he departed."
,"10":"The cloud moved away from above the Tent and Miriam was there white as snow with leprosy. Aaron turned towards Miriam and he saw that she was leprous."
,"11":"And he said to Moses, 'My lord, I beg you, do not charge us with this sin that we have foolishly committed."
,"12":"Let her not be like the stillborn whose flesh is half-eaten when it comes from its mother's womb.'"
,"13":"Then Moses cried to Yahweh, 'Heal her, O God, I beg of you.'"
,"14":"But Yahweh said to Moses, 'If her father spat in her face, would she not hide in shame for seven days? Let her then be confined outside the camp for seven days; only then shall she be admitted again.'"
,"15":"And so Miriam was confined for seven days outside the camp and the people did not move on until she had been readmitted."
,"16":"After that the people set out from Hazeroth and camped in the wilderness of Paran."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Yahweh then spoke to Moses, saying,"
,"2":"'Send men to explore the land of Canaan that I am giving to the sons of Israel; send one man from each of the ancestral tribes, all of them leaders.'"
,"3":"So Moses sent these men from the wilderness of Paran as Yahweh commanded. All were leaders among the Israelites"
,"4":"and these were their names: from the tribe of Reuben, Shammua the son of Zaccur;"
,"5":"from the tribe of Simeon, Shaphat the son of Hori;"
,"6":"from the tribe of Judah, Caleb the son of Jephunneh;"
,"7":"from the tribe of Issachar, Igal;"
,"8":"from the sons of Joseph and from the tribe of Ephraim, Hoshea the son of Nun;"
,"9":"from the tribe of Benjamin, Palti the son of Raphu;"
,"10":"from the tribe of Zebulun, Gaddiel the son of Sodi;"
,"11":"from the sons of Joseph and from the tribe of Manasseh, Gaddi the son of Susi;"
,"12":"from the tribe of Dan, Ammiel the son of Gemalli;"
,"13":"from the tribe of Asher, Sethur the son of Michael;"
,"14":"from the tribe of Naphtali, Nahbi the son of Vophsi;"
,"15":"from the tribe of Gad, Geuel the son of Mahci."
,"16":"These are the names of the men sent by Moses to explore the country. But Hoshea, the son of Nun, Moses called Joshua."
,"17":"So Moses sent them to explore the land of Canaan and said to them, 'Go up by the south and then into the hill country"
,"18":"and see what the land is like, whether the people there are strong or weak, many or few."
,"19":"See also whether the land they live in is good or barren. See what their cities are like, if they are open camps or fortresses."
,"20":"See if the soil is fertile or poor, if the land is wooded or not. Be courageous and take some of the fruit of the land.' It was the season for early grapes."
,"21":"They went up and surveyed the land from the wilderness of Zin to Rehob near the entrance of Hamath."
,"22":"They went up by the south and reached Hebron, an old city which had been built seven years before Zoan in Egypt; the Anakites, Ahiman, Sheshai and Talmai were living there."
,"23":"And they came to the valley of Eshcol where they cut down a branch with a cluster of grapes. Two of them carried this by means of a pole. They also brought pomegranates and figs."
,"24":"Because of the cluster that the sons of Israel had cut, they called that place the Valley of Eshcol."
,"25":"After forty days of exploration, they returned."
,"26":"They went and met Moses, Aaron and the whole community of Israelites in the wilderness of Paran at Kadesh. They gave an account to them and the whole community and showed them the fruit of this land."
,"27":"And they said, 'We entered the land where you sent us, truly a land flowing with milk and honey and here is the fruit."
,"28":"But how strong are the people who inhabit the land! The cities are fortified with walls and bars, and we even saw there descendants of the Anakites."
,"29":"Amalekites live in the region of the Negeb; Hittites, Jebusites and Amorites live in the hill country; the Canaanites are by the sea and along the banks of the Jordan.'"
,"30":"Caleb then quieted the people who rose up against Moses and said, 'We should go up and take over the land, for we shall surely overcome it.'"
,"31":"But the men who had gone up with him said, 'We cannot advance against these people for they are stronger than we are.'"
,"32":"And they spread an unfavorable report about the land that they had explored, saying to the Israelites,'The land we went through to explore is a land that devours its inhabitants and all the people we saw there are men of great size."
,"33":"We even saw giants (these giants were the Anakites). We felt like grasshoppers before them, and to them we must have seemed the same.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Then all the community broke out in loud cries and wept during the night."
,"2":"All the people grumbled against Aaron and Moses; and the whole congregation said to them, 'Would that we had died in Egypt or died in the wilderness."
,"3":"Why is Yahweh bringing us to this country where we shall fall under the sword, and our women and little children become part of the plunder? Would it not be better for us to return to Egypt?'"
,"4":"And they said to one another, 'Let us choose a leader and return to Egypt.'"
,"5":"Moses and Aaron fell on their faces before all the assembly of the Israelite community."
,"6":"Joshua, son of Nun, and Caleb, son of Jephunneh from those who had explored the country, tore their clothes"
,"7":"and then spoke to the whole community of Israel, saying, 'The land we went through to explore is, indeed, a very good land."
,"8":"If Yahweh is pleased with us, he will lead us to this land and give it to us, a land flowing with milk and honey."
,"9":"Only do not rebel against Yahweh, and don't be afraid of the people of the land for they will be bread for us: their protection is withdrawn and Yahweh is with us. Have no fear of them!'"
,"10":"All the community spoke of stoning them when the Glory of Yahweh appeared before all the people of Israel in the Tent of Meeting."
,"11":"Yahweh said to Moses, 'How long will this people spurn me? How long will they refuse to believe me, in spite of the signs I performed among them?"
,"12":"I will strike them with a plague and destroy them, and then I will make of you a greater and more powerful nation than they are.'"
,"13":"And Moses said to Yahweh, 'The Egyptians know that you have brought out this people from their midst by your power,"
,"14":"and they told it to the inhabitants of the land. They know that you, Yahweh, are in the midst of your people, and that they have seen you face to face. They know that your cloud stands with your people and that you go before them in a pillar of cloud by day and a pillar of fire by night."
,"15":"And now you would destroy this people at one stroke!,Then the nations that have heard of you will say:"
,"16":"Yahweh was not able to bring this people to the land he had promised them in oath, so he slaughtered them in the desert."
,"17":"Now let your power be seen, my Lord. For, according to your words,"
,"18":"you are slow to anger and rich in steadfast love: you forgive sin and rebellion, yet you do not declare innocent those who are guilty, but you punish children to the third and fourth generation for the wickedness of their fathers."
,"19":"Pardon then, I pray you, the sin of this people according to the greatness of your mercy just as you have pardoned them from Egypt even until now.'"
,"20":"Then Yahweh said, 'I pardon them as you have pleaded,"
,"21":"but as truly as I live and the Glory of Yahweh fills the earth,"
,"22":"I swear that they will not see the land I promised to their fathers. For all these have seen my Glory and the signs I performed in Egypt and in the desert, and yet have put me to the test ten times and have not heeded my voice."
,"23":"Only my servant Caleb will enter it,"
,"24":"because he has a different spirit and because he has followed me faithfully. I will bring him to the land where he has already been and his descendants shall possess it,"
,"25":"while the Amalekites and the Canaanites will remain in the valley. So you shall turn tomorrow and leave for the desert by way of the Red Sea.'"
,"26":"Then Yahweh spoke to Moses and Aaron saying,"
,"27":"'How long will this wicked community grumble against me?' I have heard the grumblings of the people of Israel against me."
,"28":"Say to them: As truly as I live, it is Yahweh who speaks, I will do to you what you have said in my hearing."
,"29":"All of you of twenty years or more, numbered in the census, who grumbled against me, your corpses will fall in the desert."
,"30":"You will not enter the land where I swore to settle you, except Caleb, son of Jephunneh and Joshua, son of Nun."
,"31":"But your children, whom you said would be part of the plunder, them I will bring and they will know the land that you have rejected."
,"32":"Your corpses will fall in the desert"
,"33":"and your sons will wander with their flocks for forty years in the desert, bearing the guilt of your faithlessness till the last of you lies dead in the desert."
,"34":"According to the number of days spent in exploring the land - forty days, for every day a year - for forty years you shall bear the guilt of your sins and you shall know what it is to oppose me."
,"35":"I, Yahweh, have spoken. Surely this is what I will do to this wicked community that has conspired against me. In this wilderness they shall be destroyed and this is where they shall die.'"
,"36":"The men sent by Moses to explore the land and who on their return had made the community grumble against him,"
,"37":"those men who wickedly spread a bad report on the land, died of a plague before Yahweh."
,"38":"Only Joshua, son of Nun, and Caleb, son of Jephunneh, survived out of those who went to explore the land."
,"39":"When Moses related this to the Israelites, the people mourned bitterly."
,"40":"They rose early in the morning and went up to the mountain saying, 'Here we are! We have sinned but now we are ready to go to the place that Yahweh spoke of.'"
,"41":"But Moses said, 'Why are you going to disobey Yahweh's command? You will not succeed."
,"42":"Do not go up lest you be struck down by your enemies for Yahweh is not with you."
,"43":"The Amalekites and the Canaanites are there ahead of you and you will fall by the sword, for you turned away from following Yahweh and he will not be with you.'"
,"44":"They insisted on going up to the top of the mountain but neither the Ark of the Covenant of Yahweh nor Moses moved from inside the camp."
,"45":"Then the Amalekites and the Canaanites who lived in the hill country came down and defeated them, beating them back as far as Hormah."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Yahweh spoke to Moses and said,"
,"2":"'Tell this to the people of Israel: This is a rule for you when you have entered the land I give to you."
,"3":"When you make a fragrant offering to Yahweh, either as a burnt offering or in payment of a vow, or as a voluntary gift, or on the occasion of one of your solemn feasts, whoever takes from his herds and flocks for a fragrant offering to Yahweh"
,"4":"shall bring also, as a gift to Yahweh, a grain offering of two pounds of fine flour mixed with two pints of oil."
,"5":"He shall also make a wine offering, two pints for each lamb, in addition to the burnt offering or sacrifice."
,"6":"For a man, he shall make a grain offering of four pounds of fine flour mixed with three pints of oil,"
,"7":"and a wine offering of three pints of wine, offering it as a sweet-smelling offering for Yahweh."
,"8":"If he offers a bull as a burnt offering or sacrifice, in payment of a vow or as a peace offering to Yahweh,"
,"9":"he shall offer also a grain offering of six pounds of fine flour mixed with four pints of oil,"
,"10":"and a wine offering of four pints of wine, as a burnt offering, sweet-smelling offering to Yahweh."
,"11":"This must be done for every bull, every ram, every lamb or goat."
,"12":"Whatever the number of victims you have for sacrifice, you must do the same for each of them."
,"13":"This must be done by every man of your people who makes a burnt offering, as a sweet-smelling offering for Yahweh."
,"14":"If any stranger living among you, or among your descendants, will also make a burnt offering, as a sweet-smelling offering for Yahweh: just as you act, so must the stranger do."
,"15":"There shall be only one law for you and for the foreigner among you. This is a law that shall bind your descendants forever before Yahweh: you and the stranger are alike."
,"16":"There is to be the same law, and the same regulation for you and for the stranger who lives among you.'"
,"17":"Yahweh spoke to Moses and said,"
,"18":"'Speak to the people of Israel and say to them: When you have entered the land to which I am bringing you,"
,"19":"and you eat the bread of this country, you shall set aside a share for Yahweh."
,"20":"You must set aside one loaf as the first fruits of your grain, and set this offering aside like the one set aside from your threshing."
,"21":"You are to set aside for Yahweh a share of the best of your flour, and your descendants are to do the same, from generation to generation."
,"22":"If without meaning to do so, you fail in any of these commands that Yahweh has given to Moses"
,"23":"and that Yahweh has commanded you through Moses, this is what you have to do, you and your descendants."
,"24":"If it is an unintentional fault of the community, the community as a whole must make a burnt offering of a young bull, a sweet-smelling offering for Yahweh, with the required offering of flour and wine, and a he-goat must be offered as a sacrifice for sin."
,"25":"The priest must perform the ceremony of atonement over the entire community of Israel, and pardon will be given, since it was an unintentional fault and they have brought their offering as a burnt offering to Yahweh, not counting their sacrifice for sin for their unintentional fault."
,"26":"The entire community of Israel will be forgiven, as also the stranger who lives among them, since the entire people have sinned without meaning to do so."
,"27":"If it is an individual who has sinned unintentionally, he must offer a one-year-old goat in sacrifice for sin."
,"28":"The priest shall perform the ceremony of atonement before Yahweh over the person who has gone astray by this sin of inadvertence; when the ceremony of atonement has been performed over him, he will be forgiven,"
,"29":"whether he is an Israelite, or a stranger living among them. There shall be only one law among you for the one who sins by an unintentional fault."
,"30":"But the one who sins deliberately, whether native or stranger, angers Yahweh himself. Such a person must be cut off from the community;"
,"31":"he has rejected the word of Yahweh and broken his command. This person must be entirely cut off because of sin.'"
,"32":"While the people of Israel were in the wilderness, a man was caught gathering wood on the sabbath day."
,"33":"Those who caught him gathering wood brought him before Moses, Aaron and the whole community."
,"34":"He was kept under guard because the penalty he should undergo had not yet been decided."
,"35":"Yahweh said to Moses, 'This man must be put to death: the whole community shall stone him outside the camp.'"
,"36":"The whole community took him outside the camp and stoned him till he was dead, as Yahweh had commanded Moses."
,"37":"Yahweh spoke to Moses and said,"
,"38":"'Speak to the people of Israel and tell them to put a fringe on the hems of their garments and a violet cord on this fringe."
,"39":"You must then have a fringe, and the sight of it will remind you of all the commands of Yahweh. You are then to put them into practice, and no longer follow the desires of your heart and your eyes, which would lead you to go astray."
,"40":"So you will remember all my commandments to put them into practice, and you will be consecrated to your God."
,"41":"It is I, Yahweh your God, who have brought you out of the land of Egypt so that I may be your God, I, Yahweh, your God.'"
}`)
	CurrentBook.AddChapter(16, `{
"1":"Korah, son of Izhar, son of Kohath, from the tribe of Levi - and also Dathan and Abiram, sons of Eliab, son of Peleth, from the tribe of Reuben - rebelled against Moses."
,"2":"Two hundred fifty Israelites followed him; all were well known leaders in the community and members of the council."
,"3":"They came together and addressed Moses and Aaron saying, 'It is enough! The whole community is consecrated to Yahweh and he lives among them. Why then, do you set yourselves over the community of Yahweh?'"
,"4":"When Moses, heard this, he threw himself face downward on the ground."
,"5":"Then he said to Korah and all his followers, 'Tomorrow morning Yahweh will make known who belongs to him, and who is consecrated to him and may approach him. He himself will let the one he has chosen approach.'"
,"6":"You Korah with all your followers, take your censers tomorrow."
,"7":"Then you will fill them with burning coals and put incense in them before Yahweh, and Yahweh will indicate the one who is holy. Sons of Levi, you have gone too far!'"
,"8":"Moses said to Korah, 'Listen to me now, you sons of Levi."
,"9":"Is it not enough for you that the God of Israel has set you apart from the rest of the community of Israel, and called you close to himself for service in the Holy Tent of Yahweh, to stand before this community and perform the sacred service on their behalf?"
,"10":"He has called you to be near him, you and all your brother Levites with you, and now you want the office of priesthood as well!"
,"11":"What is the misdeed of Aaron that you complain against him? It is against Yahweh himself that you and your followers have rebelled.'"
,"12":"Moses sent messengers to summon Dathan and Abiram, the sons of Eliab, but they said, 'We will not come up."
,"13":"Is it not enough that you have brought us up out of a land flowing with milk and honey to die in the wilderness? Do you also want to lord it over us?"
,"14":"You did not bring us into a land flowing with milk and honey, nor give us an inheritance of fields and vineyards. Do you suppose that all these people are blind? We will not come.'"
,"15":"Moses then became angry and said to Yahweh, 'Do not look favorably on their offering. I have not taken a single donkey, nor have I harmed any of them.'"
,"16":"Moses said to Korah, 'You and all your company be present before Yahweh tomorrow, you and they, together with Aaron."
,"17":"Each of you take his censer, put incense in it and present it before Yahweh - 250 censers! - and Aaron will do the same.'"
,"18":"So every man took his censer and put incense in it and they stood at the entrance to the Tent of Meeting with Moses and Aaron."
,"19":"Korah assembled all the community against them at the entrance to the Tent of Meeting and the Glory of Yahweh appeared to all the community."
,"20":"Then Yahweh spoke to Moses and Aaron,"
,"21":"'Stand aside from this community so that I may immediately destroy them.'"
,"22":"They fell on their faces and said, 'God, God of the spirits of all mortals, for one man's sin will you become angry with the whole congregation?'"
,"23":"Yahweh answered Moses,"
,"24":"'Speak to the community and say this: Move away from the tents of Korah, Dathan and Abiram.'"
,"25":"Moses got up and went towards Dathan and Abiram, and the elders of Israel followed him."
,"26":"He spoke to the community saying, 'Move away from the tents of these wicked men and touch nothing that belongs to them lest you perish because of all their sins.'"
,"27":"They withdrew from the area near the tents of Korah, Dathan and Abiram; they came out and were standing with their wives, their sons and little ones."
,"28":"Then Moses said, 'By this you shall know that Yahweh sent me to do all these deeds and that it is not my doing."
,"29":"If these men die a natural death, merely suffering the fate of all men, then Yahweh has not sent me."
,"30":"But if Yahweh works a miracle and the earth, opening its mouth, swallows them, together with all they possess, and they descend alive to Sheol, you will know that these men have rejected Yahweh.'"
,"31":"As Moses finished saying all this, the earth under them split in two,"
,"32":"opened its mouth and engulfed them with their household and all the men who belonged to Korah with their possessions."
,"33":"They descended alive to Sheol with all that belonged to them; the earth covered them and they perished from the midst of the assembly."
,"34":"On hearing their cries, all the Israelites who were around them fled, for they said, 'Let not the earth swallow us as well!'"
,"35":"A fire then came forth from Yahweh and consumed the 250 men who were offering incense."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Yahweh spoke to Moses saying,"
,"2":"'Tell Eleazar, son of Aaron the priest, to take the censers from the blaze and scatter the fire some distance away, for the censers are now holy"
,"3":"because these men sinned at the cost of their lives. Let the censers be made into plates to cover the altar, because they have been offered before Yahweh and are sacred. Let them be a sign to the Israelites.'"
,"4":"So Eleazar the priest took the bronze censers of those men who were burned during the offering and had them hammered out to make a covering for the altar"
,"5":"and to serve as a reminder to the sons of Israel that no one who is not a priest, a descendant of Aaron, should draw near to burn incense before Yahweh, lest he become like Korah and his followers, just as Yahweh had said to Eleazer through Moses."
,"6":"On the following day, the entire community of Israel grumbled against Moses and Aaron, saying, 'You have brought death to the people of Yahweh.'"
,"7":"As the community was rising together against Moses and Aaron, they turned toward the Tent of Meeting; and there was the Cloud covering it, and the Glory of Yahweh appeared."
,"8":"And Moses and Aaron went to the door of the Tent of Meeting."
,"9":"Yahweh spoke to Moses and said,"
,"10":"'Stand away from this community; I am going to destroy them here and now.' The two of them threw themselves face downward on the ground."
,"11":"Then Moses said to Aaron, 'Take the firepan, fill it with burning coals from the altar, put incense in it and hurry to the community to ask the mercy of Yahweh for them. The anger has come down from Yahweh and the terrible disease has begun.'"
,"12":"Aaron did as Moses said and ran among the community, but the terrible disease was already at work among them. He put in the incense and asked for the mercy of Yahweh on the people."
,"13":"Then he stood between the living and the dead, and the terrible disease stopped."
,"14":"There were 14,700 victims of the terrible disease, not counting those who died because of Korah."
,"15":"Then Aaron came back to Moses at the Tent of Meeting; the terrible disease had been stopped."
,"16":"Yahweh spoke to Moses and said,"
,"17":"'Tell the people of Israel to give you walking sticks, one for each tribe; that is twelve sticks for the leaders of the twelve tribes, and write the name of each on his stick;"
,"18":"and on the stick of Levi write the name of Aaron because he is the first among the families of Levi."
,"19":"Then put them in the Tent of Meeting before the ark, at the place where I meet you."
,"20":"The man whose stick sprouts will be the one I have chosen; this is how I shall stop the complaints that the Israelites make against you.'"
,"21":"Moses spoke to the Israelites, and each of their leaders gave him a stick, twelve sticks in all for their tribes; and Aaron's stick was among them."
,"22":"Moses placed them before Yahweh in the Tent of the Meeting."
,"23":"On the following day, Moses came to the Tent of the Testimony and there, already sprouting, was Aaron's stick, standing for the tribe of Levi. Buds had opened, flowers had blossomed, and almonds had already ripened."
,"24":"Moses took all the sticks away from before Yahweh and brought them back to all the people of Israel; they examined them and each one took back his own stick."
,"25":"Then Yahweh said to Moses, 'Put back Aaron's stick before the Ark and keep it as a sign to these rebels, so that I will no longer hear their complaints and they may not die.'"
,"26":"Moses did as Yahweh had commanded."
,"27":"The people of Israel said to Moses, 'We are lost! We are all to die!"
,"28":"Anyone who draws near the Holy Tent of Yahweh dies! Are we doomed to die to the last one?'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Then Yahweh said to Aaron: 'You and your sons, and your whole family shall be responsible for the sanctuary. You and your sons with you shall suffer the guilt for any faults committed while serving as priests in the Holy Tent."
,"2":"Let your brothers of the tribe of Levi, your father's tribe, come with you too. They are to join you and serve you, yourselves and your sons, before the Tent of the Statement."
,"3":"They are to be at your service and the service of the whole Tent. But let them not come near the sacred vessels or the altar, lest they die and you as well."
,"4":"They are to help you, they are to take charge of the Tent of Meeting for the entire ministry of the Tent, and no layman shall come near you."
,"5":"You yourselves must take charge of the sanctuary and the altar, and my anger will never again fall on the Israelites."
,"6":"I myself have chosen your relatives, the Levites, from among the Israelites as a gift to you. They will belong to Yahweh, to serve at the Tent of Meeting."
,"7":"But you and your sons will undertake the priestly duties in all that concerns the altar and all the sacred things that lie behind the veil. You will perform the worship services, the duties of which I entrust to your priesthood. But the layman who comes near shall die.'"
,"8":"Yahweh said to Aaron: 'I myself have given you all that is set aside for me, from every offering of the people of Israel. I give it to you and to your sons as your share forever."
,"9":"This is what shall be yours of the most holy things, of the consecrated food: every offering that the Israelites give back to me, whether it be a grain offering or a sacrifice for sin or a sacrifice of repayment is a thing most holy; it shall belong to you and your sons."
,"10":"You may eat these most holy things. Every male may eat them. You are to consider them sacred."
,"11":"To you also shall belong all the firstfruits that are set aside and offered by the Israelites; this I give to you, as well as to your sons and daughters, forever. Every person in your house who is clean may eat it."
,"12":"All the best of the oil, all the best of the wine and wheat, the firstfruits given by them to Yahweh, these I give to you."
,"13":"All the first harvest of their land which they bring to Yahweh shall be yours. Every person in your house who is clean may eat them."
,"14":"Everything in Israel which has been dedicated to me shall be yours."
,"15":"Every firstborn brought to Yahweh shall be yours, the firstborn of all living creatures, whether child or animal. Nevertheless, you must make the people buy back the firstborn child and the firstborn of an unclean animal."
,"16":"They must buy back the child in the month in which it is born at the price of five pieces of silver according to the official standard."
,"17":"The firstborn of cow, sheep and goat - these alone you shall not buy back. They are holy: you must sprinkle their blood on the altar and burn the fat as a burnt offering, a sweet-smelling offering for Yahweh;"
,"18":"the meat shall be yours, together with the breast that has been presented with the gesture of offering, and the right hind leg."
,"19":"All that the Israelites set aside for Yahweh from the holy things, this I give to you, and to your sons and daughters, forever. This is a covenant of salt, an everlasting covenant before Yahweh, for you and your descendants after you.'"
,"20":"Yahweh said to Aaron: 'You shall have no property in the land of Israel, no share of it shall be yours. It is I who will be your share and your inheritance among the people of Israel."
,"21":"See, to the Levites I give as their inheritance all the tithes collected in Israel, in return for their services, for the ministry they render in the Tent of Meeting."
,"22":"In this way the Israelites will no longer go near the Tent of Meeting; this sin would carry the death to them."
,"23":"The Levites will take care of the Tent of Meeting, and have the full responsibility for it. This is a law forever for all your descendants: because of this the Levites are to have no inheritance among the Israelites."
,"24":"The tithe that the people of Israel set aside for Yahweh, I give to the Levites for their inheritance. For this reason I have told them that they are to have no inheritance among the people of Israel.'"
,"25":"Yahweh spoke to Moses and said,"
,"26":"'You are to say to the Levites: When you receive the tithe that the people of Israel must pay and which I am giving you as your inheritance, you are to set aside a part of this as a special contribution for Yahweh."
,"27":"This will take the place of the offerings of new grain and new wine that all the people have to give me."
,"28":"Thus you too will set aside a share for Yahweh, of all the tithes you receive from the Israelites, and you will give to Aaron the priest this part you have set aside for Yahweh."
,"29":"Out of all the gifts you receive you will set aside the best as a share for Yahweh."
,"30":"This best part that the Levites set aside shall be credited to you as an offering of the threshing floor and the wine press."
,"31":"You may eat them anywhere, you and your families: this is your payment for serving in the Tent of Meeting."
,"32":"You will not be guilty of any sin because of this, as long as you have presented the best part to Yahweh. You will not eat any of the gifts before the best part is offered. In this way you will not defile the sacred gifts of the Israelites and you will not die.'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"Yahweh spoke to Moses and Aaron. He said:"
,"2":"'This is a regulation and a law that Yahweh gives to you. Say to the people of Israel that they are to bring you a red cow which has no defects and has never been made to work."
,"3":"You will give it to Eleazar the priest so that it may be taken outside the camp and slaughtered in his presence."
,"4":"Then Eleazar the priest is to take some of the cow's blood on his finger, and sprinkle this blood seven times toward the entrance to the Tent of Meeting."
,"5":"The cow shall then be burned in his presence; including hide, flesh, blood, and the intestines too."
,"6":"Then the priest is to take cedar wood, a twig of hyssop leaves and a red cord, and throw them on the fire where the cow is burning."
,"7":"Finally he shall wash his clothing and bathe his body in water, after which he may go back to the camp, but he will remain unclean until evening."
,"8":"The man who has burned the cow shall also wash his clothing and bathe his body in water and will remain unclean until evening."
,"9":"A clean man shall gather up the ashes of the cow and put them outside the camp, in a clean place. They must be kept for the community of Israel to prepare the water of purification."
,"10":"The man who has gathered up the ashes of the cow shall wash his clothing and will remain unclean until evening. This will be a law forever, for the people of Israel as well as for the stranger living among them."
,"11":"Anyone who touches a corpse of any person whatsoever, will be unclean for seven days."
,"12":"He shall purify himself with these waters on the third and the seventh day, and he will be clean; but if he does not purify himself on the third and the seventh day he will not be clean."
,"13":"Anyone who touches a dead person, the body of a man that has died, and has not purified himself, defiles the Holy Tent of Yahweh; such a person must be cut off from Israel because the waters for purification have not flowed over him; he is unclean, and his uncleanness remains in him."
,"14":"This is the law when a person dies in a house. Anyone who goes into the house, or anyone who is already there, becomes unclean for seven days."
,"15":"Equally unclean shall be every open jar and pot in the house that has not been closed with a lid or fastening."
,"16":"Anyone in the open country who touches a person who has been killed, or a person who had died, or human bones or a tomb, becomes unclean for seven days."
,"17":"For the unclean, you shall take some of the ashes of the cow that was offered for the sin and you shall throw it into water in a vessel."
,"18":"A clean man shall dip a twig of hyssop in the water and sprinkle it on the house and everything in it, and on the persons as well who were there. And he shall sprinkle it on the one who touched the bone or the dead body or the one slain, or the grave."
,"19":"The clean man shall sprinkle water on the unclean on the third and the seventh days. So, on the seventh day the unclean is cleansed; he shall wash his clothes and bathe himself on this day and in the evening he will become clean."
,"20":"But if the unclean man does not cleanse himself, he shall be cut off from the assembly, lest he defile the sanctuary of Yahweh. As long as the water of purification has not been thrown upon him, he is unclean."
,"21":"This shall be a lasting ordinance for you. The man who sprinkles the water of purification shall wash his clothes and those who touch this water are unclean until the evening."
,"22":"Whatever the unclean person touches shall be unclean and whoever touches it shall be unclean until evening.'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"The whole congregation of Israel came to the wilderness of Zin in the first month and the people stayed in Kadesh. Miriam died and was buried there."
,"2":"Now there was no water for the community, and the people gathered together against Moses and Aaron."
,"3":"They disputed with Moses saying, 'Would that we had perished with our kinsmen in the presence of Yahweh!"
,"4":"Why have you led Yahweh's community to this desert to die here with our cattle?"
,"5":"And why did you bring us out of Egypt to this wretched place? It's no place for grain or figs or vines or pomegranates and there's not even water for drinking.'"
,"6":"Moses and Aaron fled from the assembly to the entrance of the Tent of Meeting and fell on their faces. Then the Glory of Yahweh appeared"
,"7":"and Yahweh spoke to Moses,"
,"8":"'Take your rod and assemble the community, you and Aaron, your brother. In their presence command the rock to give forth water and you will make water gush from the rock for the community and their livestock to drink.'"
,"9":"So Moses took the rod from before Yahweh as he had been ordered."
,"10":"Then Moses and Aaron gathered the assembly in front of the rock and said to them, 'Listen, you rebels. Shall we bring water for you from this rock?'"
,"11":"Moses raised his hand and struck the rock twice with his rod. And then water in abundance gushed out for the community and their livestock to drink."
,"12":"But Yahweh said to Moses and Aaron, 'You did not trust me nor treat me as the Holy One in the sight of the Israelites; because of that you shall not lead this community into the land that I am giving you.'"
,"13":"It was at the waters of Meribah that the sons of Israel quarreled with Yahweh and where he showed his holiness to them."
,"14":"Moses sent messengers from Kadesh to the king of Edom, and they said to him, 'This is the petition of your brother Israel: you know the trials we had to suffer."
,"15":"Our fathers went down to Egypt and we lived there for a long time. But the Egyptians treated us badly as they did our fathers."
,"16":"Then we cried to Yahweh and he listened to us. He sent an angel to bring us out of Egypt and now we are in Kadesh, the town which is on the borders of your territory."
,"17":"We want you to let us pass through your land. We will not cross any fields or vineyards, or drink any water from the wells, but we will keep to the king's road without turning to right or left until we are out of your land.'"
,"18":"Edom answered, 'You shall not pass through my land. If you do, I will come out to attack you.'"
,"19":"The Israelites then said, 'We will keep to the road and we will even pay for the water we and our cattle drink. We ask only for your permission to pass through with our sheep.'"
,"20":"Edom answered, 'You shall not pass through.' And the Edomites marched out to meet Israel with many armed men and a strong army."
,"21":"Thus, Edom refused to let Israel pass through his land, and Israel had to turn away."
,"22":"The Israelites set out from Kadesh and the whole community came to Mount Hor."
,"23":"There, on the border of the land of Edom, Yahweh said to Moses and Aaron,"
,"24":"'Aaron must now be gathered to his people. You shall not enter the land that I am giving to Israel since you rebelled against me at the waters of Meribah."
,"25":"Take Aaron and Eleazar, his son, and bring them up Mount Hor."
,"26":"There, strip Aaron of his garments and put them on Eleazar his son, before Aaron is gathered to his people. For he is to die there.'"
,"27":"Moses did as Yahweh ordered. In the sight of the whole community they went up Mount Hor."
,"28":"There Moses stripped Aaron of his garments and put them on Eleazar his son, and Aaron died there on top of the mountain."
,"29":"When the Israelites saw that Aaron had died, the whole community wept for him for thirty days."
}`)
	CurrentBook.AddChapter(21, `{
"1":"When the Canaanite king of Arad, in the Negeb, heard that Israel was coming by the way of Atharim, he attacked Israel and took some prisoners."
,"2":"Then Israel made this vow to Yahweh, 'If you put these people into my hand, I will consecrate their towns by anathema.'"
,"3":"Yahweh heard the voice of Israel and delivered the Canaanites into their hands. They were wiped out and their towns were destroyed according to the anathema. Because of this that place was named Hormah."
,"4":"From Mount Hor they set out by the Red Sea road to go around the land of Edom. The people were discouraged by the journey"
,"5":"and began to complain against God and Moses, 'Why have you brought us out of Egypt to die in the wilderness? There is neither bread nor water here and we are disgusted with this tasteless manna.'"
,"6":"Yahweh then sent fiery serpents against them. They bit the people and many of the Israelites died."
,"7":"Then the people came to Moses and said, 'We have sinned, speaking against Yahweh and against you. Plead with Yahweh to take the serpents away.',Moses pleaded for the people "
,"8":"and Yahweh said to him, 'Make a fiery serpent and set it on a standard; whoever has been bitten and then looks at it shall live.'"
,"9":"So Moses made a bronze serpent and set it on a standard. Whenever a man was bitten, he looked towards the bronze serpent and he lived."
,"10":"The Israelites set out and camped at Oboth,"
,"11":"Then they left Oboth and camped at Iye-abarim, in the wilderness that borders Moab, toward the sunrise."
,"12":"They set out from there and camped in the Valley of Zered."
,"13":"They set out from there and camped beyond the Arnon. This valley in the desert begins in the land of the Amorites and is on the border of Moab, between the Moabites and the Amorites."
,"14":"Because of this, it is written in the book of the Wars of Yahweh: Waheb, by Suphah, and the Valley of Arnon"
,"15":"and the slope of the ravine that runs down to Ar along the border of Moab."
,"16":"From there they went on to Beer. This is the well of which Yahweh said to Moses, 'Call the people together and I will give them water.'"
,"17":"Then it was that Israel sang this song, 'Let the water spring! Sing out for the well;"
,"18":"the well sunk by princes, the well dug by the leaders of the people with their sticks, with their staves.',From the desert they went to Mattanah; "
,"19":"from Mattanah to Nahaliel; from Nahaliel to Bamoth;"
,"20":"from Bamoth to the valley that gives on to the country of Moab, toward the heights of Pisgah which looks down on the desert."
,"21":"Israel sent this message to Sihon, king of the Amorites,"
,"22":"'We want to pass through your land. We will not cross any fields or vineyards or drink any water from the wells. We will keep to the king's road until we are out of your land.'"
,"23":"But Sihon refused to let Israel pass through his land. He gathered all his people, marched into the desert to meet Israel and reached Jahaz. There he gave battle to Israel."
,"24":"But Israel struck him down and conquered his country from the Arnon to the Jabbok, which is the frontier of the Ammorites because this frontier was well-defended."
,"25":"Israel occupied all the cities and the towns of the Amorites, including Heshbon and the towns depending on it."
,"26":"Heshbon was the capital of Sihon, king of the Amorites, who had fought against the former king of Moab and captured from him all this territory as far as the Arnon."
,"27":"Because of this the poets continue singing this song, 'Courage, Heshbon, city of Sihon, well built and well founded!"
,"28":"A fire came out of Heshbon, a flame from the city of Sihon. It devoured Ar of Moab and the Baals of the high places of Moab."
,"29":"Woe to you, Moab! You are lost, people of Chemosh! Your sons have fled; your daughters were taken captive."
,"30":"For Sihon, king of the Amorites, has destroyed Heshbon. The little children and the women were brought as far as Dibon and Nophah, the men were taken as far as Medeba.'"
,"31":"When the Israelites settled in the country of the Amorites,"
,"32":"Moses sent spies to explore Jazer. Israel took this city with all the towns depending on it, and the Amorites who lived there were evicted."
,"33":"After that the Israelites turned and went up to Bashan. Og, king of Bashan, set out with all his people to meet them and gave them battle in Edrei."
,"34":"Then Yahweh said to Moses, 'Do not be afraid of him, for I have given him into your hands with all his people and his land. You shall deal with him as you did with Sihon, king of the Amorites, who lived in Heshbon.'"
,"35":"The Israelites killed him, his sons and all his people to the last. And they took possession of his land."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Then the Israelites journeyed on and camped in the plains of Moab along the Jordan opposite Jericho."
,"2":"Now Balak, the son of Zippor, saw all that the Israelites had done to the Amorites."
,"3":"And the Moabites were afraid of Israel, because they were a very numerous people. In fact, they were terrified."
,"4":"So the Moabites said to the elders of Midian, 'Look, this horde is destroying everything around us as easily as the ox eats the grass of the field.',So Balak, son of Zippor, king of Moab at the time, "
,"5":"sent messengers to summon Balaam, son of Beor, at Pethor near the river in the land of the Amonites. Balak said, 'A people has come out of Egypt; they cover the face of the earth and are settling opposite me."
,"6":"Come and put a curse on these people because they are too powerful for me. Then perhaps I may be able to defeat them and drive them out of the land, for I well know that those you bless are indeed blessed and those you curse are cursed.'"
,"7":"The elders of Moab and Midian set out, taking with them the fee for divination. They went to Balaam and gave him Balak's message."
,"8":"Balaam said to them, 'Stay here tonight and I will give you whatever answer Yahweh will have given me.' So the Moabite elders stayed in Balaam's house."
,"9":"God came to Balaam and asked him, 'Who are these men with you?'"
,"10":"Balaam said to God, 'Balak, son of Zippor, king of Moab, sent them to me with this message:"
,"11":"A people has come out of Egypt and covers the face of the earth. Now come and put a curse on them for me. Perhaps I shall then be able to fight and drive them away.'"
,"12":"But God said to Balaam, 'Do not go with them; you must not put a curse on them because they are blessed.'"
,"13":"Next morning Balaam got up and said to the elders of Balak, 'Return to your country for Yahweh has refused to let me go with you.'"
,"14":"So the Moabite elders returned to Balak and said, 'Balaam refused to come with us.'"
,"15":"Balak sent other leaders, more numerous and more distinguished than the first."
,"16":"They went to Balaam and said, 'This is what Balak, son of Zippor says: Do not refuse to come to me;"
,"17":"I will greatly honor you; whatever you ask of me I will do for you. Please come and lay a curse on this people for me.'"
,"18":"Balaam answered the servants of Balak, 'Even if Balak gave me his house full of silver and gold I could not do anything great or small beyond the command of Yahweh, my God."
,"19":"Now you, too, stay here tonight as the others did, till I wait for what else Yahweh may tell me.'"
,"20":"God came to Balaam at night and said, 'If these men have come to summon you, go with them, but you may only do what I tell you.'"
,"21":"Balaam got up next morning, saddled his donkey and went with the Moabite leaders."
,"22":"But the anger of God was aroused because of his going and Yahweh's angel posted himself on the road, a drawn sword in his hand. Balaam was riding on the donkey and his two boys were with him."
,"23":"When the donkey saw the angel, she turned off the road and went into the field. Then Balaam hit the donkey to get her back on to the road."
,"24":"But the angel of Yahweh stood on a narrow lane between vineyards with a stone wall in either side."
,"25":"When the donkey saw the angel of Yahweh, she shrank against the wall crushing Balaam's foot against it so he beat her again."
,"26":"Then Yahweh's angel went ahead and stopped at a narrow place where there was no room to go either to the right or left."
,"27":"When the donkey saw Yahweh's angel there, she lay down under Balaam; he was angry and beat her with a stick."
,"28":"But now Yahweh opened the mouth of the donkey and she said to Balaam, 'What have I done to you to make you beat me three times?'"
,"29":"Balaam answered, 'You have made a fool of me. If I had a sword just now I would kill you.'"
,"30":"And the donkey said to Balaam, 'Am I not your own donkey that you have ridden to this day? Have I ever dared to do this to you?' He said, 'No!'"
,"31":"Then Yahweh opened Balaam's eyes and he saw Yahweh's angel standing on the road with a drawn sword. He bowed and fell downward, his face to the ground."
,"32":"Yahweh's angel said to him, 'Why did you strike your donkey three times? I have come here to oppose you because you are going a wrong way."
,"33":"The donkey saw me and turned away three times. Otherwise I would have killed you, but not her.'"
,"34":"And Balaam said to Yahweh's angel, 'I did not want to sin. I did not know you were posted against me on the road. But if this journey displeases you I will go back.'"
,"35":"Yahweh's angel said to Balaam, 'Go with these men, but you may say only what I tell you.' So Balaam went on with Balak's men."
,"36":"When Balak heard that Balaam had come, he went to meet him at the boundary city of Moab on the Arnon border."
,"37":"Then Balak said to Balaam, 'I sent an urgent summons to you; why didn't you come? Did you think I would not pay you well enough?'"
,"38":"Balaam then said to Balak, 'Now I have come to you; but what can I say? Only what Yahweh puts on my lips.'"
,"39":"So Balaam went with Balak and they came to Kiriath-huzoth."
,"40":"There Balak sacrificed cattle and sheep and gave some to Balaam and the leaders who were with him."
,"41":"Next morning Balak took Balaam up to the high places of Baal and from there he saw some of the people of Israel."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Balaam said, 'Build me seven altars here and prepare seven bullocks and seven rams for me,'"
,"2":"Balak did just as Balaam had ordered and Balak and Balaam offered up a bullock and a ram on each altar."
,"3":"Balaam said to Balak, 'Stand here beside your offering while I go aside. Perhaps Yahweh will meet me and whatever he lets me see I will tell you.' So he went to a barren hill."
,"4":"God met Balaam who said, 'I have prepared the seven altars and on each altar I have offered a bullock and a ram.'"
,"5":"Yahweh then put a message on Balaam's lips and said, 'Go back to Balak and give him this message.'"
,"6":"Balaam returned and found Balak standing beside his offering, together with the leaders of Moab."
,"7":"Then Balaam pronounced his oracle: 'From Aram, Balak has brought me, the king of Moab from the eastern mountains. 'Come, curse Jacob for me!,Come, denounce Israel! "
,"8":"How can I curse him whom God has not cursed? How can I de-nounce him whom God has not denounced?"
,"9":"From the peak of the crags I see him, from the heights I behold him. I see a people that lives apart, a people different from all the nations."
,"10":"Who can count the dust of Jacob, or number the fourth part of Israel? Let me die the death of the upright and may my end be like theirs!'"
,"11":"Then Balak said to Balaam, 'What have you done to me? I took you to curse my ene-mies and you have actually blessed them.'"
,"12":"And Balaam answered, 'Must I not take care to say what Yahweh puts on my lips?'"
,"13":"Balak said to him, 'Come with me to another place where you will see them. You will not see all of them, only the tail end, and there you shall curse them for me.'"
,"14":"So he took him to the field of Zophim, to the top of Pisgah and built seven altars and offered a bullock and a ram on each altar."
,"15":"Balaam said to Balak, 'Stay here beside your burnt offering while I go and meet Yahweh over there.'"
,"16":"Yahweh met Balaam and put words on his lips and said, 'Go back to Balak and give him this message.'"
,"17":"He returned and found Balak posted beside his burnt offering with the leaders of Moab. Balak asked, 'What did Yahweh say?'"
,"18":"Balaam then pronounced his oracle, 'Be ready to hear, Balak; listen to me, son of Zippor. "
,"19":"God is not a man that he should lie, nor a son of man that he should repent. Has he said he will do something and will not do it? Has he promised something and not fulfilled it?"
,"20":"See, I have received a command to bless; when he has blessed I cannot change it."
,"21":"He has not seen misfortune in Jacob or observed misery in Israel. Yahweh, their God is with them, and the shout of a king among them."
,"22":"God has brought them out of Egypt; he is for them like the horns of a wild ox."
,"23":"There are no diviners or magicians in Israel. But it shall be made known to them what God will do with them."
,"24":"Behold a people that rises like a lioness, that rouses itself like a lion. It shall not lie down before it devours its prey and drinks the blood of its victims.'"
,"25":"Balak said to Balaam, 'Even though you cannot curse them, do not bless them.'"
,"26":"But Balaam answered, 'Did I not tell you that whatever Yahweh says, I will do?'"
,"27":"And Balak said to Balaam, 'Come, I will take you to another place. Perhaps it is God's will that you curse them for me there.'"
,"28":"Then Balak took Balaam to the top of Peor which overlooks the wasteland,"
,"29":"and Balaam said to Balak, 'Build seven altars for me here and prepare seven bullocks and seven rams.'"
,"30":"Balak did just as Balaam ordered and offered a bullock and a ram on each altar."
}`)
	CurrentBook.AddChapter(24, `{
"1":"But Balaam saw that Yahweh willingly blessed Israel. He did not seek out signs as he had done before, but turned towards the desert."
,"2":"He looked up and saw Israel camping, tribe by tribe; and the spirit of God came upon him"
,"3":"and he uttered his song: 'Word of Balaam, son of Beor, the seer, the one who hears the words of God,"
,"4":"and beholds the vision of the Almighty, in ecstasy, with eyes unveiled."
,"5":"How goodly are your tents, Jacob, your encampments, Israel!"
,"6":"Like valleys stretching far, like gardens beside a stream, like aloes planted by Yahweh, like cedars beside the waters."
,"7":"His buckets are overflowing and his seeds are always watered. His king becomes stronger than Agag, and his kingdom grows."
,"8":"His God brought him out of Egypt and fights for him like the horns of a wild ox. He devours the carcasses of his enemies and crushes their bones in pieces."
,"9":"He lies like a lion, or like a lioness; who dares rouse him?,Blessed is he who blesses you!,And cursed is he who curses you!'"
,"10":"Balak's anger burned against Balaam; he beat his hands together and said, 'I called you to curse my enemy and you have blessed him three times!"
,"11":"So flee to your place now. I said I would greatly reward you but Yahweh has taken away your reward.'"
,"12":"Balaam said to Balak, 'Did I not tell your messengers:"
,"13":"though Balak were to give me his house full of silver and gold, I could not do anything, good or bad, of my own accord beyond Yahweh's command? What Yahweh speaks, I speak."
,"14":"Now, before I return to my people, come that I may warn you what this people will do to your people in the days to come.'"
,"15":"Then Balaam pronounced his oracle: 'Word of Balaam, son of Beor, the seer,"
,"16":"the one who hears the words of God, who has knowledge from the Most High, and sees the vision of the Almighty, in ecstasy, with eyes unveiled."
,"17":"I see a figure, but not really. I behold him but not near. A star shall come forth from Jacob, he rises with a staff in his hand; he shatters the forehead of Moab,and tears down all the sons of Sheth."
,"18":"He conquers the land of Edom, and takes the cities of his enemies. Israel grows strong;"
,"19":"Jacob dominates.'"
,"20":"Then Balaam looked to Amalek's country; he said, 'Amalek, the first of the nations, will finally meet with destruction.'"
,"21":"Then he looked to the Kainite's land and continued his oracle: Your dwelling place is enduring, your nest is set in the rock,"
,"22":"but you shall be destroyed; and finally Asshur shall take you captive.'"
,"23":"Balaam continued his oracle and said: 'Alas! Who will live when God does this?"
,"24":"Ships shall come from Kittim and shall conquer Asshur, but also Eber; they too shall be destroyed.'"
,"25":"Then Balaam rose and set out on his journey home while Balak also went on his way."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Israel settled at Shittim and the men began to enjoy themselves with the Moabite women and to have sex with them."
,"2":"These women invited the people to the sacrifices of their gods. There the people ate and bowed down before their gods."
,"3":"The Israelites prostituted themselves to the god of Peor, so Yahweh's anger flared against them."
,"4":"He said to Moses, 'Take all the leaders of these people and hang them in broad daylight before Yahweh, so that his fierce anger may turn away from Israel.'"
,"5":"So Moses told the Israelite judges, 'Each of you shall slay any of your men who have joined in worshiping the Baal of Peor.'"
,"6":"Then a man, an Israelite, came back bringing a Midianite woman to his family in view of Moses and the Israelite community while they were weeping at the entrance to the Tent of Meeting."
,"7":"When Phinehas, a son of Eleazar, son of Aaron the priest saw this, he left the assembly, took a spear in his hand"
,"8":"and followed the Israelite into the tent. There he drove the spear through both the man and the woman. So the plague against the Israelites was checked"
,"9":"but those who had already died numbered twenty-four thousand."
,"10":"Yahweh spoke to Moses,"
,"11":"'Phinehas, son of Eleazar, son of Aaron the priest, has turned away the blows of my anger from the sons of Israel, zealous as he was for me; he has defended my honor among you. Because of this, I did not feel zealous for my honor so that I should destroy the people of Israel."
,"12":"Therefore tell him that I am making with him a covenant of friendship."
,"13":"I grant to him and his descendants that they be my priests forever, because he was zealous for his God and made atonement for the sons of Israel.'"
,"14":"The Israelite slain with the Midianite woman was Zimri, son of Salu, a leader of a Simeonite family."
,"15":"And the name of the Midianite woman who was slain was Cozbi, daughter of Zur, a tribal chief of a Midianite family."
,"16":"Yahweh said to Moses,"
,"17":"'Attack the Midianites and crush them,"
,"18":"for they have been your enemies, deceiving you with regard to Peor and with regard to Cozbi, their kinswoman, daughter of a Midianite leader, who was slain on the day of the plague because of Peor.',After the plague, it happened that..."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Yahweh spoke to Moses and to Eleazar, son of Aaron the priest. He said:"
,"2":"'Take a census of all the community of Israel, by families: all those of twenty years and over, able to give military service.'"
,"3":"So Moses and Eleazar the priest enlisted the people in the plains of Moab, near the Jordan opposite Jericho as Yahweh had commanded Moses."
,"4":"They counted the men twenty years and over among the Israelites who had come out of the land of Egypt."
,"5":"Reuben, the firstborn of Israel. The tribe of Reuben: for Hanoch, the Hanochite clan; for Pallu, the Palluite clan;"
,"6":"for Hezron, the Hezronite clan; for Carmi, the Carmite clan."
,"7":"These were the Reubenite clans. They numbered 43,730 men."
,"8":"The descendants of Pallu: Eliab."
,"9":"The sons of Eliab: Nemuel, Dathan and Abiram. These two, Dathan and Abiram, councillors of the community, were the ones who rebelled against Moses and Aaron; they belonged to the followers of Korah who rebelled against Yahweh."
,"10":"The earth opened its mouth and swallowed them (Korah died with his followers), when fire destroyed the 250 men as a warning to the people."
,"11":"The sons of Korah were not killed."
,"12":"The tribe of Simeon by clans: for Nemuel, the Nemuelite clan; for Jamin, the Jaminite clan; for Jachin, the Jachinite clan;"
,"13":"for Zerah, the Zerahite clan; for Shaul, the Shaulite clan."
,"14":"These were the Simeonite clans. They numbered 22,200 men."
,"15":"The tribe of Gad by clans: for Zephon, the Zephonite clan; for Haggi, the Haggite clan; for Shuni, the Shunite clan;"
,"16":"for Ozni, the Oznite clan; for Eri, the Erite clan;"
,"17":"for Arod, the Arodite clan; for Areli, the Arelite clan."
,"18":"These were the clans of the tribe of Gad. They numbered 40,500 men."
,"19":"The tribe of Judah: Er and Onan. Er and Onan died in the land of Canaan."
,"20":"The other sons of Judah became clans: for Shelah, the Shelanite clan; for Perez, the Perezzite clan; for Zerah, the Zerahite clan."
,"21":"The sons of Perez were: for Hezron, the Hezronite clan; for Hamul, the Hamulite clan."
,"22":"These were the clans of Judah. They numbered 76,500 men."
,"23":"The tribe of Issachar, by clans: for Tola, the Tolaite clan; for Puvah, the Puvite clan;"
,"24":"for Jashub, the Jashubite clan; for Shimron, the Shimronite clan."
,"25":"These were the clans of Issachar. They numbered 64,300 men."
,"26":"The tribe of Zebulun by clans: for Sered, the Seredite clan; for Elon, the Elonite clan; for Jahleel, the Jahleelite clan."
,"27":"These were the clans of Zebulun. They numbered 60,500 men."
,"28":"The tribe of Joseph, by clans: Manasseh and Ephraim."
,"29":"The tribe of Manasseh: for Machir, the Machirite clan; Machir was the father of Gilead: for Gilead, the Gileadite clan."
,"30":"These were the clans of Gilead; for Iezer, the Iezerite clan; for Helek, the Helekite clan;"
,"31":"Asriel, the Asrielite clan; Shechem, the Shechemite clan;"
,"32":"Shemida, the Shemidaite clan; Hepher, the Hepherite clan."
,"33":"Zelophehad son of Hepher had no sons but only daughters; these are the names of Zelophehad's daughters: Mahlah, Noah, Hoglah, Milcah and Tirzah."
,"34":"These were the clans of Manasseh. They numbered 52,700 men."
,"35":"The tribe of Ephraim by clans: for Shuthelah, the Shuthelahite clan; for Becher, the Becherite clan; for Tahan, the Tahanite clan."
,"36":"These are the sons of Shuthelah: for Eran, the Eranite clan."
,"37":"These were the clans of Ephraim. They numbered 32,500 men. These were the descendants of Joseph, by clans."
,"38":"The tribe of Benjamin, by clans: for Bela, the Belaite clan; for Ashbel, the Ashbelite clan; for Ahiram, the Ahiramite clan;"
,"39":"for Shephupham, the Shephuphamite clan; for Hupham, the Huphamite clan."
,"40":"Bela had Ard and Naaman for sons: the Ardite clan; for Naaman, the Naamite clan."
,"41":"The tribe of Benjamin by clans numbered 45,600 men."
,"42":"The tribe of Dan, by clans: for Shuham, the Shuhamite clan."
,"43":"All the Shuhamite clans numbered 64,400 men."
,"44":"The tribe of Asher, by clans: for Imnah, the Imnite clan; for Ishvi, the Ishvite clan; for Beriah, the Beriite clan."
,"45":"The clans of Heber and Malchiel were descendants of Beriah."
,"46":"The daughter of Asher was called Serah."
,"47":"These were the clans of Asher. They numbered 53,400 men."
,"48":"The tribe of Naphtali, by clans: for Jahzeel, the Jahzeelite clan; for Guni, the Gunite clan;"
,"49":"for Jezer, the Jezerite clan; for Shillem, the Shillemite clan."
,"50":"The clans of Naphtali numbered 45,400 men."
,"51":"The sons of Israel numbered in all 601,730 men."
,"52":"Yahweh spoke to Moses and said,"
,"53":"'The land is to be divided among the tribes as a heritage, according to the number of those registered."
,"54":"To a tribe large in number you are to give a large area of land; to a small one in number, a small area; to each the heritage will be in proportion to the number registered."
,"55":"The dividing of the land is, however, to be done by lot."
,"56":"Each tribe is to receive its inheritance according to the number of men registered.'"
,"57":"These are, by clans, the Levites that were registered: for Gershon, the Gershonite clan; for Kohath, the Kohathite clan; for Merari, the Merarite clan."
,"58":"These are the Levite subclans: the Libnites, the Hebronites, the Mahlites, the Mushites, the Kohathites. Kohath was the father of Amram,"
,"59":"who married Jochebed, descendant of Levi, born in Egypt. She bore Aaron, Moses and Miriam their sister."
,"60":"Aaron was the father of Nadab and Abihu, Eleazar and Ithamar."
,"61":"Nadab and Abihu died when they offered unlawful fire before Yahweh."
,"62":"Altogether there were registered 23,000 males of one month and over. They were listed separately from the rest of the Israelites, because they would receive no property in Israel."
,"63":"These were the men registered by Moses and Eleazar the priest who took this census of the Israelites in the plains of Moab, near the Jordan River, opposite Jericho."
,"64":"Not one of them was among those whom Moses and Aaron had listed in the desert of Sinai;"
,"65":"for Yahweh had told them that these were to die in the desert and none would remain, except Caleb, son of Jephunneh, and Joshua, son of Nun."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Then the daughters of Zelophehad came forward. Zelophehad was the son of Hepher, son of Gilead, son of Machir, son of Manasseh, son of Joseph. These are the names of his daughters: Mahlah, Noah, Hoglah, Milcah and Tirzah."
,"2":"They appeared before Moses, before Eleazer the priest, and before the leaders and the whole community, at the entrance to the Tent of Meeting, and said,"
,"3":"'Our father died in the desert. He was not one of those who rebelled against Yahweh, nor among the followers of Korah; but he died for his own sin as all the people and he did not leave any sons."
,"4":"Why must our father's name disappear from among his clan? Since he had no son, give us some property among our father's relatives.'"
,"5":"Moses took their case before Yahweh,"
,"6":"and Yahweh spoke to Moses. He said,"
,"7":"'The daughters of Zelophehad have a just case. Give them property for their inheritance among their father's relatives; pass on to them their father's inheritance."
,"8":"Then say this to the people of Israel, If a man dies without sons, his inheritance is to be given to his daughter."
,"9":"If he has no daughters, the inheritance is to go to his brothers."
,"10":"If he has no brothers, it is to go to his father's brothers."
,"11":"If his father has no brothers, it is to go to the member of his clan who is most nearly related: he is to hold it as his own property. This shall be a law for the people of Israel, as Yahweh has commanded Moses.'"
,"12":"Yahweh said to Moses, 'Climb this mountain of the Abarim range, and look on the land I give to the Israelites."
,"13":"After you have seen it, you will die, as Aaron your brother did."
,"14":"For you both rebelled against my command in the desert of Zin when the community complained against me, when I commanded you to proclaim my holy power before their eyes in the matter of the water.' (These are the waters of Meribah of Kadesh, in the desert of Zin)."
,"15":"Moses said to Yahweh,"
,"16":"'May Yahweh, God of the spirits that give life to all living creatures, appoint a leader for this community,"
,"17":"who shall go out and come in at their head, who shall lead them out and bring them in; so that the community of Yahweh may not be like sheep without a shepherd.'"
,"18":"Yahweh answered Moses, 'Take Joshua, son of Nun, a man in whom the Spirit dwells, and lay your hands on him."
,"19":"Then bring him before Eleazar, the priest, and the whole community, to instruct him in their presence"
,"20":"and to give him a share of your authority, so that the whole community of the sons of Israel may obey him."
,"21":"Eleazar the priest shall consult me for him and tell him my decisions by means of the Urim and Thummim. Then Joshua will direct all the Israelites, the whole community, in all their affairs.'"
,"22":"Moses did as Yahweh had commanded. He took Joshua and brought him before Eleazar the priest and the whole community,"
,"23":"laid his hands on him and instructed him, as Yahweh had directed through Moses."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Yahweh spoke to Moses and said,"
,"2":"'Give the sons of Israel this command: Take care to bring the food offerings, my sweet-smelling offerings at the times I have appointed."
,"3":"Say to them: These are the burnt offerings you must offer to Yahweh: Every day, two one-year-old lambs without any defect. "
,"4":"The first lamb you must offer in the morning, the second in the evening,"
,"5":"together with a grain offering of two pounds of fine flour mixed with two pints of purest oil."
,"6":"This is the everlasting burnt offering which was first offered at Mount Sinai as a sweet-smelling offering for Yahweh."
,"7":"The accompanying wine offering to be poured out at the altar is two pints of wine for each lamb."
,"8":"The second lamb you must offer in the evening; do this in the same way as the morning offering, together with the wine offering."
,"9":"On the sabbath day, you must offer two one-year-old lambs without any defect, and four pounds of fine flour as a grain offering, mixed with oil, as well as the accompanying wine offering."
,"10":"This burnt offering is to be offered every sabbath in addition to the daily offering with its accompanying wine offering."
,"11":"At the beginning of each of your months you must offer a burnt offering to Yahweh: two young bulls, one ram and seven one-year-old lambs without any defect;"
,"12":"for each bull a grain offering of six pounds of fine flour mixed with oil;"
,"13":"for each lamb, four pounds of fine flour mixed with oil. These burnt offerings are sweet-smelling offerings to Yahweh."
,"14":"The accompanying wine offering is four pints of wine for a bull, three pints for a ram, two pints for a lamb. This must be the monthly burnt offering, month after month, every month of the year."
,"15":"In addition to the daily burnt offering, a he-goat must be offered to Yahweh, as a sacrifice for sin, with its accompanying wine offering."
,"16":"The fourteenth day of the first month is the Passover of Yahweh,"
,"17":"and the fifteenth day of this month is a feast day. For seven days unleavened bread must be eaten."
,"18":"On the first day you shall gather for worship and not do work of a worker."
,"19":"You shall offer to Yahweh a burnt offering: two young bulls, a ram, seven one-year-old sheep without any defect."
,"20":"The accompanying grain offering of fine flour mixed with oil is to be six pounds for the bull, four pounds for the ram,"
,"21":"and two pounds for each of the seven lambs."
,"22":"There must also be a he-goat for the sacrifice for sin, for the atonement over you."
,"23":"This must be done in addition to the daily morning offering."
,"24":"You must do this every day for seven days. It is food, a burnt offering, a fragrant offering to Yahweh; it is to be offered in addition to the daily offering and its accompanying wine offering."
,"25":"On the seventh day you shall gather for worship and not do work of a worker."
,"26":"On the first day of the harvest, when you make your offering of new fruits to Yahweh at your Feast of Weeks, you are to gather for worship; you must do no work of workers."
,"27":"You must offer as a burnt offering: two young bulls, one ram, seven one-year-old lambs."
,"28":"The ac-companying grain offering of fine flour mixed with oil is to be six pounds for each bull,"
,"29":"four pounds for the ram, and two pounds for each of the seven lambs."
,"30":"There must also be a he-goat for the sacrifice for sin, for the atonement over you."
,"31":"This must be done in addition to the daily offering and its accompanying wine offering."
}`)
	CurrentBook.AddChapter(29, `{
"1":"In the seventh month, on the first day of the month, you shall gather for worship and do no work of a worker. It shall be a day on which you sound the trumpets."
,"2":"You must offer as a burnt offering: one young bull, one ram, seven one-year-old lambs without any defect."
,"3":"The accompanying grain offering of fine flour mixed with oil is to be six pounds for the bull, four pounds for the ram,"
,"4":"and two pounds for each of the seven lambs."
,"5":"There must also be a he-goat for the sacrifice for sin, for the atonement over you."
,"6":"All this must be done in addition to the monthly burnt offering with its grain offering, the daily offering with its grain offering, and the accompanying wine offering according to the law, as a burnt offering and sweet-smelling offering to Yahweh."
,"7":"On the tenth day of this seventh month, you shall gather for worship. You must fast and do no work of a worker."
,"8":"You must offer a burnt offering and a sweet-smelling offering to Yahweh: one young bull, one ram, and seven one-year-old lambs of your choice without any defect."
,"9":"The accompanying grain offering of fine flour mixed with oil is to be six pounds for the bull, four pounds for the ram,"
,"10":"and two pounds for each of the seven lambs."
,"11":"A he-goat must be offered for the sacrifice for sin. This is in addition to the sacrifice for the feast of Atonement, and to the daily burnt offering with its accompanying grain offering and wine offerings."
,"12":"On the fifteenth day of the seventh month you are to gather for worship and do no work of a worker, and for the space of seven days you are to celebrate a feast for Yahweh."
,"13":"You must offer as a burnt offering and sweet-smelling offering to Yahweh: thirteen young bulls, two rams, fourteen one-year-old lambs without any defect."
,"14":"The accompanying grain offering of fine flour mixed with oil is to be six pounds for each of the thirteen bulls, four pounds for each of the two rams,"
,"15":"two pounds for each of the fourteen lambs;"
,"16":"also one he-goat as a sacrifice for sin. This is in addition to the daily burnt offering and its grain offering and wine offering."
,"17":"On the second day: twelve young bulls, two rams, fourteen one-year-old lambs without any defect;"
,"18":"the accompanying grain offering and wine offering, as required, in proportion to the number of bulls, rams and lambs;"
,"19":"also one he-goat for sacrifice for sin. This is in addition to the daily burnt offering with its grain offering and wine offering."
,"20":"On the third day: eleven bulls, two rams, fourteen one-year-old lambs without any defect,"
,"21":"the accompanying grain offering and wine offering, as required, in proportion to the number of bulls, rams and lambs;"
,"22":"also one he-goat for the sacrifice for sin. This is in addition to the daily burnt offering with its grain offering and wine offering."
,"23":"On the fourth day: ten bulls, two rams, fourteen one-year-old lambs without any defect:"
,"24":"the accompanying grain offering and wine offering, as required, in proportion to the number of bulls, rams and lambs;"
,"25":"also one he-goat for the sacrifice for sin. This is in addition to the daily burnt offering with its grain offering and wine offering."
,"26":"On the fifth day: nine bulls, two rams, fourteen one-year-old lambs without any defect:"
,"27":"the accompanying grain offering and wine offering, as required, in proportion to the number of bulls, rams and lambs;"
,"28":"also one he-goat for the sacrifice for sin. This is in addition to the daily burnt offering with its grain offering and wine offering."
,"29":"On the sixth day: eight bulls, two rams, fourteen one-year-old lambs without any defect;"
,"30":"the accompanying grain offering and wine offering, as required, in proportion to the number of bulls, rams and lambs;"
,"31":"also one he-goat for the sacrifice for sin. This is in addition to the daily burnt offering with its grain offering and wine offering."
,"32":"On the seventh day: seven bulls, two rams, fourteen one-year-old lambs without any defect;"
,"33":"the accompanying grain offering and wine offering, as required, in proportion to the number of bulls, rams and lambs;"
,"34":"also one he-goat for the sacrifice for sin. This is in addition to the daily burnt offering with its grain offering and wine offering."
,"35":"On the eighth day you shall all gather for worship and do no work of a worker."
,"36":"You shall offer as a burnt offering and sweet-smelling offering to Yahweh: one bull, one ram, seven one-year-old lambs without any defect;"
,"37":"the accompanying grain offering and wine offering, as required, in proportion to the number of bulls, rams"
,"38":"and lambs; also one he-goat for the sacrifice for sin. This is in addition to the daily burnt offering with its grain offering and wine offering."
,"39":"This is what you are to do for Yahweh at your solemn feasts, besides whatever burnt offerings, grain offerings and wine offerings you present as your free-will offerings.'"
}`)
	CurrentBook.AddChapter(30, `{
"1":"Moses told the people of Israel exactly what Yahweh had commanded him."
,"2":"Moses spoke to the leaders of the tribes of Israel. He said, 'This is what Yahweh has commanded:"
,"3":"If a man makes a vow to give something to Yahweh or a solemn promise to abstain from something, he must not break his promise: whatever he promises by word of mouth he must do."
,"4":"If a woman makes a vow to give something to the Lord or a solemn promise to abstain from something while she is still young and lives in her father's house,"
,"5":"and if he hears about this vow or promise made by her and says nothing to her about it, she must do whatever she has promised."
,"6":"But if the father on the day he learns of it expresses his disapproval of it, then she is not required to keep her promise. Yahweh will not hold her to her promise, since her father has expressed his disapproval."
,"8":"If a woman makes a vow before being married or makes a solemn promise to abstain from something, either deliberately or without giving it much thought, she must do everything she vowed even after she marries if her husband learns of it and says nothing about it."
,"9":"But if on the day he learns of it he expresses his disapproval to her, she is not required to keep her promise. Yahweh will not hold her to it."
,"10":"Any vow of a widow or of a divorced woman, or any pledge to which she binds herself is valid."
,"11":"If she has made a vow or a solemn promise to abstain from something while in her husband's house,"
,"12":"and if when the husband learns of it he says nothing to her and does not express disapproval to her, then she must do whatever she has vowed or solemnly promised to abstain from."
,"13":"But if the husband forbids it on the day he learns of it, she is not required to do whatever she has vowed or solemnly promised. Yahweh will not hold her to it."
,"14":"Any vow or solemn promise to abstain from something that the wife makes, must be allowed or forbidden by the husband."
,"15":"If by the following day the husband has said nothing to her, it means that he approves or allows her vow, whatever it may be, or her solemn promise, whatever it may be. He confirms the vows of his wife by saying nothing on the day he learns of them."
,"16":"But if he forbids them a long time after he learned of them, then he must suffer what results from the wife's failure to fulfill the vow or solemn promise.'"
,"17":"These are the laws given by Yahweh to Moses, concerning the relationship between man and wife, and between a father and his daughter while still young and living in her father's home."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Yahweh spoke to Moses and said,"
,"2":"'Fully avenge the Israelites for what they have suffered from the Midianites. After that you will be joined to your people.'"
,"3":"Moses said to the people, 'Let some of you go off to the war and attack the Midianites, for you have to carry out Yahweh's vengeance."
,"4":"Put a thousand men in the field from each of the tribes of Israel.'"
,"5":"In this way the Israelites provided twelve thousand men equipped for war, one thousand from each tribe."
,"6":"Moses put them in the field, one thousand from each tribe, with Phinehas, son of Eleazar the priest, to go with them carrying the sacred vessels and the trumpets for sounding the alarm."
,"7":"They attacked the Midianites, as Yahweh had commanded Moses, and they put every male to death."
,"8":"And further, they killed the kings of Midian, Evi, Rekem, Zur, Hur and Reba, the five Midianite kings; they also put Balaam son of Beor to the sword."
,"9":"The sons of Israel took the Midianite women captive with their young children, and took for themselves all their cattle, all their flocks and all their goods."
,"10":"They set fire to the towns where they lived and all their camps."
,"11":"Then, taking all the spoils, all that they had captured, man and beast,"
,"12":"they brought the captives and the spoils to Moses, Eleazer the priest, and all the community of the sons of Israel, at the camp in the plains of Moab, near the Jordan River opposite Jericho."
,"13":"Moses, Eleazar the priest, and all the leaders of the community went out of the camp to meet them."
,"14":"Moses was angry with the commanders of the army, the captains of thousands and the captains of hundreds, who had come back from this battle."
,"15":"He said, 'Why have you spared the lives of all the women?"
,"16":"These were the very ones who, on Balaam's advice, tempted the people of Israel and made them unfaithful to Yahweh at Peor: hence the epidemic which struck the community of Israel."
,"17":"So kill all the male children. Kill also all the women who have slept with a man."
,"18":"Spare the lives only of the young girls who have not slept with a man, and take them for yourselves."
,"19":"As for you, you must camp for seven days outside the camp, all of you who have killed a man or touched a corpse. Purify yourselves, you and your prisoners, on the third and seventh days;"
,"20":"purify also all clothing, everything made of skin, everything woven of goats' hair and everything made of wood.'"
,"21":"Eleazar, the priest, said to the soldiers who had come back from this battle, 'These are the regulations given by Yahweh to Moses."
,"22":"The gold, silver, bronze, iron, tin and lead, everything that is not melted by fire, must be passed through the fire to become clean, and also be purified by the water for purification."
,"23":"But whatever would be melted by fire you must pass through water."
,"24":"On the seventh day you will wash your clothes and then be clean. You may then come back to the camp.'"
,"25":"Yahweh spoke to Moses and said:"
,"26":"'With Eleazar, the priest, and the heads of families in the community, count the prizes of battle and the captives, man and beast."
,"27":"Then share out the spoils, half and half, between those who fought the battle and the rest of the community."
,"28":"As Yahweh's share you will set aside, from the share of the soldiers who took part in the battle, one out of every 500 persons, oxen, donkeys and sheep."
,"29":"These are to be taken from the half share which is their due, and given to Eleazar, the priest, as an offering to Yahweh."
,"30":"From the half which is due to the community of Israel, you will take one out of every fifty persons, oxen, donkeys, sheep, and all other animals, and give them to the Levites who have charge of the Holy Tent of Yahweh.'"
,"31":"Moses and Eleazar, the priest, did as Yahweh had commanded Moses."
,"32":"The prizes of battle, the remainder of the spoil captured by the soldiers, came to 675,000 head of sheep and goats,"
,"33":"72,000 head of cattle,"
,"34":"61,000 donkeys,"
,"35":"and, in persons, women who had never slept with a man, 32,000 in all."
,"36":"The half assigned to those who had taken part in the war amounted to 337,500 head of sheep and goats,"
,"37":"of which Yahweh's share was 675;"
,"38":"36,000 head of cattle, of which Yahweh's share was seventy-two;"
,"39":"30,500 donkeys, of which Yahsweh's share was sixty-one,"
,"40":"and 16,000 persons, of which Yahweh's share was thirty-two."
,"41":"Moses gave Eleazar, the priest, the share set aside for Yahweh, in accordance with Yahweh's instructions to Moses."
,"42":"As for the half due to the Israelite community, which Moses had separated from that of the soldiers,"
,"43":"this half, the community's share, came to 337,500 head of sheep and goats,"
,"44":"36,000 head of cattle,"
,"45":"30,500 donkeys"
,"46":"and 16,000 persons."
,"47":"From this half, the share of the community of Israel, Moses took one out of every fifty, man and beast, and gave them to the Levites who had charge of the Holy Tent of Yahweh, according to what Yahweh said to Moses."
,"48":"Then the officers of the army, the captains of thousands and the captains of hundreds, came to Moses"
,"49":"and said, 'Your servants have numbered the soldiers under their command; not one is missing."
,"50":"And further, we bring as an offering for Yahweh the gold ornaments we have found, armlets and bracelets, signet rings, earrings and necklaces, to make atonement for ourselves before Yahweh.'"
,"51":"Moses and Eleazar, the priest, accepted this gold from them, all this jewelry."
,"52":"This offering of gold given by them to Yahweh weighed over 400 pounds, all given by the captains of thousands and the captains of hundreds."
,"53":"Each of the soldiers took his own loot."
,"54":"But Moses and Eleazar, the priest, received the gold from the captains of thousands and of hundreds, and carried it to the Tent of Meeting as a reminder to Yahweh of the people of Israel."
}`)
	CurrentBook.AddChapter(32, `{
"1":"The tribes of Reuben and Gad owned great herds of fine cattle. Now they saw that the land of Jazer and Gilead was good for raising livestock."
,"2":"Because of this they went to Moses, Eleazar the priest, and the leaders of the community, and said to them,"
,"3":"'The land around Ataroth, Dibon, Jazer, Nimrah, Heshbon, Elealeh, Sebam, Nebo and Beon,"
,"4":"which Yahweh has conquered in the sight of the community of Israel, is good land for raising cattle, and we have livestock."
,"5":"If we have deserved your friendship, give us this land for our own; do not make us cross the Jordan River.'"
,"6":"Moses replied, 'Shall you stay here while your brothers are off to the war?"
,"7":"Why do you discourage the people of Israel from entering the land that Yahweh has given them?"
,"8":"This is what your fathers did when I sent them from Kadesh-barnea to inspect the land."
,"9":"They went up as far as the Valley of Eshcol and inspected the land; but they kept the people of Israel from entering the land Yahweh had given them."
,"10":"Because of this Yahweh was angry that day and swore this oath,"
,"11":"'These men of twenty years and over, who came out from Egypt, will never see the land that I promised on oath to Abraham, Isaac and Jacob. For they have not followed me faithfully,"
,"12":"except Caleb son of Jephunneh the Kenizzite, and Joshua son of Nun: these indeed have followed Yahweh faithfully.'"
,"13":"The anger of Yahweh blazed out against Israel and he made them wander in the desert for forty years, until the generation that offended Yahweh had all disappeared."
,"14":"And now, will you do as your fathers did? You, new generation of sinful people, will you add still more to the burning anger of Yahweh against Israel!"
,"15":"If you turn away from him, he will make your roaming in the desert still longer, and all this people will perish because of you.'"
,"16":"But they explained their purpose to Moses, 'We would like to build sheepfolds here for our flocks and towns for our young children."
,"17":"Then we ourselves will take up arms to lead the people of Israel until we have brought them to the place appointed for them: only our young children will stay in the fortified towns, safe from the inhabitants of the country."
,"18":"As for us we will not return to our homes until every one of the Israelites has taken possession of his inheritance."
,"19":"For we shall have no inheritance with them on the other bank of the Jordan River or beyond, since our inheritance has fallen to us here, east of the Jordan.'"
,"20":"Moses said to them, 'If you mean what you have said, if you are prepared to go to battle in the presence of Yahweh,"
,"21":"and if all your fighting men cross the Jordan River under the command of Yahweh, until he has defeated all his enemies,"
,"22":"then, once Yahweh has taken possession of the land, you may go back; you shall be free of your obligation toward Yahweh and Israel, and this country shall be your inheritance before Yahweh."
,"23":"But if you do not, you will sin against Yahweh, and you can be sure that your sin will follow you."
,"24":"Build towns, then, for your young children and fenced places for your sheep; but do what you have promised.'"
,"25":"The sons of Gad and the sons of Reuben said to Moses, 'Your servants will do as you order, sir."
,"26":"Our children, our wives, our sheep and all our livestock will stay in the towns of Gilead,"
,"27":"but we, every man armed for war, will cross over the Jordan before Yahweh to fight as you have ordered.'"
,"28":"Then Moses gave instructions about them to Eleazar, the priest, to Joshua, son of Nun, and to the other leaders of Israel."
,"29":"Moses said to them, 'If the sons of Gad and the sons of Reuben, all who are armed for battle, cross the Jordan before Yahweh to fight with you, then once you have conquered the land, you will give them the country of Gilead for their possession."
,"30":"But if they do not cross over and go into battle with you, then they must have their possessions among you in the land of Canaan.'"
,"31":"The sons of Gad and the sons of Reuben replied, 'What Yahweh has said to us, we will do."
,"32":"We will cross into the land of Canaan and go into battle under Yahweh's command; but our inheritance shall be beyond the Jordan.'"
,"33":"Moses gave to the tribes of Gad and Reuben and to half the tribe of Manasseh, the territory of Sihon, king of the Amorites, as well as that of Og, king of Bashan, and all the land and towns surrounding them."
,"34":"The sons of Gad built Dibon, Ataroth, Aroer,"
,"35":"Atroth-shophan, Jazer, Jogbehah,"
,"36":"Beth-nimrah, Beth-haran, fortified towns, and fenced places for the sheep."
,"37":"The sons of Reuben built Heshbon, Elealeh, Kiriathaim,"
,"38":"Nebo, Baal-meon (their names were changed), and Sibmah. They gave names to the towns they had built."
,"39":"The sons of Machir son of Manasseh went to Gilead. They conquered it and drove out the Amorites who were there."
,"40":"Moses gave Gilead to Machir son of Manasseh, and he settled there."
,"41":"Jair son of Manasseh attacked and captured some villages and called them villages of Jair."
,"42":"Nobah attacked and captured Kenath with its outlying villages, and called it Nobah after himself."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Here are the stages of the journey of the people of Israel when they left the land of Egypt by divisions, under the leadership of Moses and Aaron."
,"2":"Moses followed Yahweh's instructions and wrote down the starting place for each stage of the journey. Here are the stages or, better, the starting places."
,"3":"They left Egypt on the fifteenth day of the first month of the year. On the day following the Passover, the people of Israel set out triumphantly in the sight of all the Egyptians,"
,"4":"when they were burying their dead. For Yahweh had killed all their firstborn; he had also passed judgment on the gods of Egypt."
,"5":"The people of Israel left Rameses and camped at Succoth."
,"6":"Then they left Succoth and camped at Etham which is on the edge of the wilderness."
,"7":"They left Etham, turned back to Pi-hahiroth which faces Baal-zephon, and camped before Migdol."
,"8":"They left Pi-hahiroth, crossed over the sea into the wilderness, and after marching for three days in the desert of Etham, they camped at Marah."
,"9":"They left Marah and reached Elim. At Elim, there were twelve springs of water and seventy palm trees; they camped there."
,"10":"They left Elim and camped by the Sea of Reeds."
,"11":"They left the Sea of Reeds and camped in the wilderness of Sin."
,"12":"They left the wilderness of Sin and camped at Dophkah."
,"13":"They left Dophkah and camped at Alush."
,"14":"They left Alush and camped at Rephidim; the people found no drinking water there."
,"15":"They left Rephidim and camped in the wilderness of Sinai."
,"16":"They left the wilderness of Sinai and camped at Kibroth-hattaavah."
,"17":"They left Kibroth-hattaavah and camped at Hazeroth."
,"18":"They left Hazeroth and camped at Rithmah."
,"19":"They left Rithmah and camped at Rimmon-perez."
,"20":"They left Rimmon-perez and camped at Libnah."
,"21":"They left Libnah and camped at Rissah."
,"22":"They left Rissah and camped at Kehelathah."
,"23":"They left Kehelathah and camped at Mount Shepher."
,"24":"They left Mount Shepher and camped at Haradah."
,"25":"They left Haradah and camped at Makheloth."
,"26":"They left Makheloth and camped at Tahath."
,"27":"They left Tahath and camped at Terah."
,"28":"They left Terah and camped at Mithkah."
,"29":"They left Mithkah and camped at Hashmonah."
,"30":"They left Hashmonah and camped at Moseroth."
,"31":"They left Moseroth and camped at Bene-jaakan."
,"32":"They left Bene-jaakan and camped at Hor-haggidgad."
,"33":"They left Hor-haggidgad and camped at Jotbathah."
,"34":"They left Jotbathah and camped at Abronah."
,"35":"They left Abronah and camped at Ezion-geber."
,"36":"They left Ezion-geber and camped in the wilderness of Zin; that is Kadesh."
,"37":"They left Kadesh and camped at Mount Hor, on the borders of the land of Edom."
,"38":"There Aaron, the priest, went up Mount Hor at Yahweh's command and there he died, in the fortieth year of the journey of the Israelites from the land of Egypt, in the fifth month, on the first day of the month."
,"39":"Aaron was 123 years old when he died at Mount Hor."
,"40":"The king of Arad, a Canaanite who lived in the Negeb in the land of Canaan, was informed when the people of Israel arrived."
,"41":"So they left Mount Hor and camped at Zalmonah."
,"42":"They left Zalmonah and camped at Punon."
,"43":"They left Punon and camped at Oboth."
,"44":"They left Oboth and camped in Moabite territory at Iye-abarim."
,"45":"They left Iye-abarim and camped at Dibon-gad."
,"46":"They left Dibon-gad and camped at Almon-diblathaim."
,"47":"They left Almon-diblathaim and camped in the Abarim mountains facing Nebo."
,"48":"They left the Abarim mountains and camped in the plains of Moab, near the Jordan opposite Jericho."
,"49":"There they camped near the Jordan between Bethha-jeshimoth and Abel-hashshittim, in the plains of Moab."
,"50":"Yahweh spoke to Moses in the plains of Moab, near the Jordan River opposite Jericho. He said:"
,"51":"'Say this to the people of Israel: When you have crossed the Jordan into the land of Canaan,"
,"52":"you must drive out all the inhabitants of the country. You must destroy their stones, and their idols and all their places of worship."
,"53":"You will take possession of this land and settle in it for I have given it to you for your own."
,"54":"You are to divide it by drawing lots among your clans. To a large clan you will give a larger piece of property, to a small clan a smaller one. Where the lot falls for each, that will be his. Make this division according to tribes."
,"55":"But if you do not drive out the inhabitants of the country, then those you have allowed to remain will be as splinters in your eyes and thorns in your side; they will harass you in the land where you are to live"
,"56":"and I will treat you as I meant to treat them.'"
}`)
	CurrentBook.AddChapter(34, `{
"1":"Yahweh spoke to Moses and said,"
,"2":"'Give the people of Israel this order: When you go into the land of Canaan, this territory will be your inheritance. This is the land of Canaan with its boundaries:"
,"3":"The southern part of your country will stretch from the wilderness of Zin along the borders of Edom. It will start on the east at the southern end of the Salt Sea."
,"4":"It will then turn south toward the Ascent of the Scorpions and go through Zin as far as Kadeshbarnea. Then it will go northwest toward Hazar-addar and pass through Azmon."
,"5":"From Azmon the boundary will turn toward the valley at the border of Egypt and end at the Big Sea (the Mediterranean Sea)."
,"6":"The Big Sea will be your western boundary."
,"7":"For your northern boundary you will draw a line from the Big Sea to Mount Hor,"
,"8":"then from Mount Hor you will draw a line to the Pass of Hamath, and the boundary will end at Zedad."
,"9":"From there it will go on to Ziphron and end at Hazar-enan. This will be your northern boundary."
,"10":"You will then draw your eastern boundary from Hazar-enan to Shepham."
,"11":"The boundary will go south from Shepham toward Riblah on the east side of Ain and on to the hills on the eastern shore of Lake Galilee."
,"12":"The boundary will then follow the Jordan and end at the Dead Sea. This will be your land with the boundaries surrounding it.'"
,"13":"Moses then gave this instruction to the people of Israel: 'This is the land you are to divide by lot, which Yahweh has commanded to be given to the remaining nine and a half tribes."
,"14":"The tribe of Reuben and the tribe of Gad with its clans and also the half tribe of Manasseh have already been given their land"
,"15":"beyond the Jordan opposite Jericho, to the east, toward the sunrise.'"
,"16":"Yahweh spoke to Moses and said:"
,"17":"'These are the names of those who will share out the land: Eleazar the priest and Joshua son of Nun,"
,"18":"with one leader from each tribe."
,"19":"Here are the names of these men: For the tribe of Judah, Caleb son of Jephunneh; "
,"20":"for the tribe of Simeon, Shemuel son of Ammihud;"
,"21":"for the tribe of Benjamin, Elidad son of Chislon;"
,"22":"for the tribe of Dan, the leader, Bukki son of Jogli;"
,"23":"for the tribe of Manasseh, the leader Hanniel son of Ephod;"
,"24":"and for the tribe of Ephraim, the leader Kemuel son of Shiphtan;"
,"25":"for the tribe of Zebulun, the leader Elizaphan son of Parnach;"
,"26":"for the tribe of Issachar, the leader Paltiel, son of Azzan;"
,"27":"for the tribe of Asher, the leader Ahihud son of Shelomi;"
,"28":"for the tribe of Naphtali, the leader Pedahel son of Ammi-hud.'"
,"29":"These are the men whom Yahweh commanded to divide the land of Canaan among the tribes of Israel as their inheritance."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Yahweh spoke to Moses in the plains of Moab, near the Jordan opposite Jericho. He said:"
,"2":"'Tell the people of Israel to give to the Levites, out of the property they possess, towns in which to live and pasture land around the towns."
,"3":"They will live in the towns and the surrounding pasture land is to be for their cattle and all their animals."
,"4":"The pasture land surrounding the towns that you give to the Levites shall extend from the walls of the towns 500 yards in each direction,"
,"5":"so that there is a square area measuring 1,000 yards on each side, with the town in the middle."
,"6":"The towns you give to the Levites will be the six towns of refuge to which a person can escape who causes another's death; and you are to give them forty-two more towns."
,"7":"Altogether you will give forty-eight towns to the Levites, towns together with their pasture lands."
,"8":"You will take these towns from the property of the sons of Israel, taking more towns from the tribes who own more, and less from tribes who own less. Every tribe will give towns to the Levites in proportion to the land they themselves have received.'"
,"9":"Yahweh spoke to Moses and said:"
,"10":"'Say this to the people of Israel: When you cross the Jordan River and reach the land of Canaan,"
,"11":"you are to select towns which you will make into towns of refuge to which a person who has killed someone accidentally may escape."
,"12":"In these towns they will be safe from the dead person's relative who wants revenge, so that the killer may not die without being brought to trial before the community."
,"13":"The towns you give will serve you as six cities of refuge:"
,"14":"the three that you give beyond the Jordan and the three that you give in the land of Canaan are to be cities of refuge."
,"15":"These six towns will be a refuge for the people of Israel as well as for the stranger and the foreigner among you, where anyone who has killed accidentally may find safety."
,"18":"But if the killer has struck someone with an iron object, or with a stone or wooden instrument and has killed that person, he is a murderer and must be put to death."
,"19":"The dead person's nearest relative must put the murderer to death. When he finds him he must kill him."
,"20":"If a person hates someone and causes his death by pushing him down or by throwing something at him"
,"21":"or by hitting him with his fist, he is a murderer and is to be put to death. The dead person's nearest relative must put him to death when he finds him."
,"22":"If, however, a person has accidentally killed someone whom he does not hate, either by pushing him down or throwing him down or throwing something at him"
,"23":"or, without looking, has thrown a stone that kills someone,"
,"24":"then the community shall judge in favor of the one who caused death rather than in favor of the dead person's relative who seeks revenge."
,"25":"They will send the person who killed someone accidentally back to the city of refuge where he went for safety, and there he must stay until the death of the high priest."
,"26":"If the killer should leave the city of refuge to which he had gone for safety"
,"27":"and the dead person's nearest relative meets him outside the city of refuge, the relative may kill him without fear of punishment"
,"28":"since the killer should stay in his city of refuge until the death of the high priest. Only after the death of the high priest is he free to go back to his own home."
,"29":"These regulations are for you and your descendants wherever you may be."
,"30":"In case of murder, the accused may be found guilty and put to death only on the evidence of two or more witnesses; the evidence of only one witness is not enough to uphold an accusation of murder."
,"31":"You shall not accept payment to save the life of a murderer condemned to death; he must die."
,"32":"Nor are you to accept payment from anyone who wishes to leave his city of refuge to return and live in his own home before the death of the high priest."
,"33":"You must not defile the land you live in. Murder defiles the land and there is no other atonement for the land where blood has been shed than through the blood of the murderer."
,"34":"You must not defile the land you live in, the land in which I live; for I, Yahweh, live among the people of Israel.'"
}`)
	CurrentBook.AddChapter(36, `{
"1":"Then the heads of families in the clan of Gilead, son of Machir, grandson of Manasseh, one of the clans of Joseph, came forward. They spoke before Moses and the heads of the families of Israel"
,"2":"and said: 'Yahweh has commanded you to give the land to the people of Israel, sharing it out by drawing lots; and Yahweh has commanded you to give the inheritance of our brother Zelophehad to his daughters. "
,"3":"Now, if they marry someone from another tribe in Israel, their property will be taken away from the inheritance of our fathers. The property of the tribe to which they will belong will be increased, while the property given to us will be decreased."
,"4":"And when the jubilee year comes, the property of these women will be added to the inheritance of the tribe to which they then belong, and lost to the inheritance of our own tribe.'"
,"5":"Moses, at Yahweh's command, gave the following ruling to the people of Israel. He said: 'The tribe of Joseph is right. "
,"6":"This is Yahweh's decision for the daughters of Zelophehad: They may marry whom they please, but they must marry into a clan of their father's tribe."
,"7":"The property of the people of Israel is not to be transferred from tribe to tribe; the property of every Israelite is to remain attached to his own tribe."
,"8":"Every woman who has inherited property in one of the tribes of Israel must marry into a clan of her own tribe, so that each Israelite may inherit the property of his ancestors."
,"9":"No property may be transferred from one tribe to another: every tribe of Israel will always keep its own property.'"
,"10":"The daughters of Zelophehad did as Yahweh had commanded Moses."
,"11":"Mahlah, Tirzah, Hoglah, Milcah and Noah, daughters of Zelophehad, married the sons of their father's brothers."
,"12":"Since they married into the clans of Manasseh, son of Joseph, their property remained with the tribe of their father's clan."
,"13":"These are the commandments and laws that Yahweh gave to the people of Israel through Moses in the plains of Moab near the Jordan opposite Jericho."
}`)

}
func EN_CCB_LoadVSCCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"The Sublime Song: it has come from Solomon."
,"2":"Shower me with kisses of your mouth: your love is more delicious than wine"
,"3":"Your oil smells sweeter than any perfume, your name spreads out like balm; no wonder the maidens long for you."
,"4":"Lure me to you, let us fly!,bring me, O king, into your room, and be our joy, our excitement. We will praise your caresses more than wine, how rightly are you loved."
,"5":"I am sunburned yet lovely, O daughters of Jerusalem, dark as the tents of Kedar, as the tent curtains of Solomon."
,"6":"Stare not at my dark complexion; it is the sun that has darkened me. My mother's sons were angry with me,and made me work in the vineyards; for I had failed to tend my own."
,"7":"Tell me, my soul's beloved, where do you graze your flock, where do you rest your sheep at noon?,Why must I be wandering,beside the flocks of your companions?"
,"8":"If you do not know yourself, most beautiful woman, follow the tracks of the flock,and pasture your young goats,beside the shepherds' tents."
,"9":"To a mare in Pharaoh's chariot,would I liken you, my love."
,"10":"Your cheeks look lovely between pendants, your neck beautiful with strings of beads."
,"11":"We will make you earrings of gold,and necklaces of silver."
,"12":"While the king rests on his couch, my perfume gives forth its fragrance."
,"13":"My lover is for me a sachet of myrrh,lying between my breasts."
,"14":"My lover is for me a cluster of henna,from the vineyards of Engedi."
,"15":"How beautiful you are, my love, how beautiful! Your eyes are doves!"
,"16":"How handsome you are, my love, how handsome! Our bed is ever green!"
,"17":"The beams of our house are cedar, our rafters are fir."
}`)
	CurrentBook.AddChapter(2, `{
"1":"I am the rose of Sharon, the lily of the valley."
,"2":"As a lily among thorns, so is my love among women."
,"3":"As an apple tree in a forest, so is my lover among men. I sought his shade, there I sat; his fruit is sweet to my taste."
,"4":"He has taken me to the winestore; his banner over me reads: 'Love.'"
,"5":"Oh, strengthen me with raisin cakes, refresh me with apples, for love makes me sick!"
,"6":"His left hand is under my head; his right arm embraces me."
,"7":"I beg you, daughters of Jerusalem, by the gazelles and hinds of the field, not to arouse or stir up love,before her time has come."
,"8":"The voice of my lover! Behold he comes, springing across the mountains, jumping over the hills,"
,"9":"like a gazelle or a young stag. Now he stands behind our wall, looking through the windows, peering through the lattice."
,"10":"My lover speaks to me, 'Arise, my love, my beautiful one!"
,"11":"Come, the winter is gone, the rains are over."
,"12":"Flowers have appeared on earth; the season of singing has come; the cooing of doves is heard."
,"13":"The fig tree forms its early fruit, the vines in blossom are fragrant. Arise, my beautiful one, come with me, my love, come."
,"14":"O my dove in the rocky cleft, in the secret places of the cliff, let me see your face, let me hear your voice. Your face - how lovely!,Your voice - how sweet!'"
,"15":"Capture the foxes, the little foxes,that spoil the vineyards, our vineyards in flower."
,"16":"My lover is mine and I am his; he shepherds his flock among the lilies."
,"17":"Before the dusk blows and shadows flee, return, my lover, be like a gazelle,or a young stag on the rugged hills."
}`)
	CurrentBook.AddChapter(3, `{
"1":"On my bed at night,I looked for the one I love, I sought him without finding him;"
,"2":"I will rise and go about the city, through the streets and the squares; I will seek the love of my heart..."
,"3":"I sought him without finding him; the watchmen came upon me, those who patrol the city. 'Have you seen the love of my heart?'"
,"4":"As soon as I left them, I found the love of my heart. I held him and would not let him go,till I had brought him to my mother's house,to the room of her who conceived me."
,"5":"I beg you, daughters of Jerusalem, by the gazelles and hinds of the field, not to arouse or stir up love,before her time has come."
,"6":"Who is this coming from the wilderness?,There seems to be a pillar of smoke, with fumes of myrrh and frankincense."
,"7":"Look, it is Solomon's carriage!,sixty warriors escort him, the strongest of Israel,"
,"8":"all girded with swords, all seasoned in battle; each is ready with sword at his side, each prepared for the terrors of the night."
,"9":"King Solomon has made for himself,a carriage of wood from Lebanon,"
,"10":"its columns of silver, its back of gold, its seat of purple cloth, its framework inlaid with ivory."
,"11":"Come, daughters of Zion, see King Solomon wearing the diadem,with which his mother crowned him,on the day of his wedding, on the day his heart rejoiced."
}`)
	CurrentBook.AddChapter(4, `{
"1":"You are beautiful, my love, oh, how beautiful you are!,Your eyes behind your veil are doves. Your hair is like a flock of goats, streaming down the heights of Gilead."
,"2":"Your teeth are like sheep newly shorn, coming in droves from the washing, each one opposing its twin, not one has been left alone."
,"3":"Your lips are like a thread scarlet; your voice is enchanting; your cheeks behind your veil,are like halves of a pomegranate."
,"4":"Your neck is the tower of David, a display of trophies,a thousand bucklers hang on it, all of them worn by heroes of war."
,"5":"Your breasts are like twin fawns,of a gazelle feeding among the lilies."
,"6":"Before the dawn breaks and shadows flee, I will hasten to the mountain of myrrh, to the hill of frankincense."
,"7":"You are wholly beautiful, my love, perfect and unblemished."
,"8":"Come from Lebanon, my bride, come with me from Lebanon. Come down from the summit of Amana, from the crest of Senir and Hermon, from the dens of lions, from the mountain haunts of leopards."
,"9":"You have ravished my heart, my sister, my bride; you have ravished my heart,with one of your glances, with one bead of your necklace."
,"10":"How sweet is your love, my sister, my bride!,How delicious is your love more than wine, and the fragrance of your perfume, than any spice!"
,"11":"Your lips distill nectar, my bride; milk and honey are under your tongue. Your garments have the scent of Lebanon."
,"12":"You are a garden enclosed, my sister, my bride; a spring enclosed, a sealed fountain."
,"13":"Your plants are an orchard,of pomegranates, all with choice fruits, with henna and nard,"
,"14":"nard and saffron, calamus, and cinnamon,with every kind of incense trees, myrrh and aloes,and all the finest spices."
,"15":"You are a garden fountain, a well of living water,streaming down from Lebanon."
,"16":"Arise, north wind! Awake, south wind!,Blow upon my garden,and spread its fragrance abroad. Let my lover come to his garden,and eat its choicest fruits."
}`)
	CurrentBook.AddChapter(5, `{
"1":"I have come to my garden, my sister, my bride; I have gathered my myrrh with spices, I have eaten my honey and my honeycomb, I have drunk my milk and my wine. Friends, eat and drink!,Drink your fill, my dearest ones!"
,"2":"I slept, but my heart kept vigil. I heard the knock of my beloved. 'Open to me, my sister, my love, my perfect one, my dove!,My head is wet with dew, my hair with the drops of the night.'"
,"3":"I have taken off my robe; must I put it on again?,I have washed my feet; must I soil them again?"
,"4":"My lover thrust his hand,through the lock opening,and my heart thrilled for him."
,"5":"I rose to open the door. Myrrh from my hands dripped,on the handle of the lock."
,"6":"I opened to my lover,but he had turned and gone -,my soul went after him!,I sought him but did not find him; I called him but he did not answer."
,"7":"The watchmen came upon me,those who patrol the city; they beat me and wounded me; they took away my mantle -,oh, those guardians of the walls!"
,"8":"I beg you, O daughters of Jerusalem, if you ever find my lover -,Oh, what will you tell him?,Tell him that love makes me sick."
,"9":"How is your lover better than others, most beautiful woman?,How is your lover better than others, that you do so beg us?"
,"10":"Radiant and ruddy, my lover,stands out among thousands."
,"11":"Pure gold is his head, palm fronds are his hair, glossy black like the raven."
,"12":"His eyes are doves,beside running waters, bathed in milk,and set like jewels."
,"13":"His fragrant cheeks,are like beds of spice; his lips like lilies,dripping with myrrh."
,"14":"His hands are rods of gold,adorned with jewels; his body is polished ivory,covered with sapphires,"
,"15":"set upon bases of gold; his legs are pillars of alabaster. He has the stature of Lebanon, excelling like the cedars."
,"16":"His mouth is sweetness itself; he is most worthy of desire. O daughters of Jerusalem, such is my friend and lover."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Where has your lover gone, most beautiful woman?,Where has your lover turned, that we may help you look for him?"
,"2":"My lover has gone down to his garden, to the beds of spices, to pasture his flock in the garden,and to gather lilies."
,"3":"My lover is mine, and I am his; he shepherds his flock among the lilies."
,"4":"My love, you are lovely,as Tirzah, beautiful as Jerusalem, majestic as bannered troops."
,"5":"Turn your eyes away from me,for they bewitch me. Your hair is like a flock of goats,streaming down the heights of Gilead."
,"6":"Your teeth are like sheep,coming in droves from the washing, each one opposing its twin, not one has been left alone."
,"7":"Your cheeks behind your veil,are like halves of a pomegranate."
,"8":"Sixty queens, eighty concubines, virgins beyond number -"
,"9":"but my dove, my perfect one, is unique, the only daughter,and favorite of her mother. She was called blessed by the virgins,and praised by queens and concubines:"
,"10":"'Who is this coming like the dawn, fair as the moon, bright as the sun, majestic as bannered troops?'"
,"11":"I went to the nut orchard,to look over the valley in bloom, to see if the vines had flowered, or if the pomegranates had blossomed."
,"12":"Before I became aware of it, my desire had set me on the chariot,with the daughter of the prince."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Return, return, O Shulammite, return, that we may look at you!,Why would you look at the Shulammite, as dancing between two rows?"
,"2":"How beautiful are your feet in sandals, daughter of the prince!,Your shapely thighs are like jewels, the work of a master artist."
,"3":"Your navel is a bowl well-rounded, never lacking exquisitely blended wine. Your belly is a mound of wheat,with lilies around it."
,"4":"Your breasts are two fawns, twins of a gazelle."
,"5":"Your neck is an ivory tower. Your eyes are pools in Heshbon,by the gate of Bath-rabbim; your nose, the tower of Lebanon,looking towards Damascus."
,"6":"Your crowned head is Mount Carmel; your flowing hair is royal purple, which holds a king captive in its tresses."
,"7":"How beautiful you are, how lovely, my beloved, in your delights!"
,"8":"Like a palm tree, you are stately,and like its clusters are your breasts."
,"9":"I said, 'I will climb the palm tree,and take hold of its fruits.',May your breasts be clusters of the vine, your breath sweet-scented as apples, and your mouth like the best wine."
,"10":"May the wine flow straight to my lover, flowing over from my lips."
,"11":"I am my lover's,but it is he who depends on me."
,"12":"Come, my love, let us go to the countryside, and pass the night in the villages."
,"13":"Let us go early to the vineyards,to see if the vines have flowered, if the buds have opened, and the pomegranates have blossomed. There I will give you my love."
,"14":"The mandrakes yield their fragrance; at our doors are the rarest fruits; both new and old I have stored,for you, my love."
}`)
	CurrentBook.AddChapter(8, `{
"1":"If only you were my brother, nursed at my mother's breasts, I could kiss you outside if we met, without anyone despising me for it."
,"2":"I would lead and bring you,into the house of my mother, and you would teach me there. I would give you wine with spice,and the juice of my pomegranates."
,"3":"His left hand is under my head; his right arm embraces me."
,"4":"I beg you, daughters of Jerusalem, by the powers of nature, not to arouse or stir up love,before her time has come."
,"5":"Who is this coming from the wilderness,leaning upon her lover?,I woke you under the apple tree, where you were conceived by your mother, where she who bore you was in travail."
,"6":"Set me as a seal on your heart, set me as a seal on your arm. For love is strong as death; its jealousy lasting as the power of death, it burns like a blazing fire, it blazes like a mighty flame."
,"7":"No flood can extinguish love,nor river submerge it. If a man were to buy love,with all the wealth of his house, contempt is all he would purchase."
,"8":"We have a little sister,with her breasts yet unformed. What shall we do for her,when her courtship is begun?"
,"9":"If she were a rampart, we would build towers of silver on it. If she were a gate, we would enclose it with panels of cedar."
,"10":"I am a rampart,and my breasts are towers; thus I have become, in his eyes, like one who brings peace."
,"11":"At Baal-hamon Solomon had a vineyard, which he gave over to caretakers; for its fruit, each had to pay: a thousand pieces of silver."
,"12":"But my vineyard is mine and I myself keep it. You, Solomon, may have the thousand, and the fruit keepers two hundred pieces."
,"13":"You wh-o dwell in the gardens, with your friends in attendance, let me hear your utterance."
,"14":"Make haste, my love; be like a gazelle or a young stag,on the spice-laden hills!"
}`)

}
func EN_CCB_LoadVSEEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Here are the words of the Teacher, son of David, king in Jerusalem:"
,"2":"All is meaningless - says the Teacher - meaningless, meaningless!"
,"3":"What profit is there for a man in all his work for which he toils under the sun?"
,"4":"A generation goes, a generation comes and the earth remains forever."
,"5":"The sun rises, the sun sets, hastening towards the place where it again rises."
,"6":"Blowing to the south, turning to the north, the wind goes round and round and after all its rounds it has to blow again."
,"7":"All rivers go to the sea but the sea is not full; to the place where the rivers come from, there they return again."
,"8":"All words become weary and speech comes to an end, but the eye has never seen enough nor the ear heard too much."
,"9":"What has happened before will happen again; what has been done before will be done again: there is nothing new under the sun."
,"10":"If they say to you, 'See, it's new!' know that it has already been centuries earlier."
,"11":"There is no remembrance of ancient people, and those to come will not be remembered by those who follow them."
,"12":"I, the teacher, have been king of Israel in Jerusalem."
,"13":"I set my heart on studying and examining critically all that is done under heaven."
,"14":"It is a burdensome task which God has given to the sons of men! I have seen everything that is done under the sun, but all is meaningless: it is chasing the wind."
,"15":"What is bent cannot be straightened; what is not will not come to be."
,"16":"I thought to myself, 'See, I have increased and promoted wisdom more than anyone who ruled Jerusalem before me and I have experienced to the full both wisdom and knowledge.'"
,"17":"I set my heart on comparing wisdom with foolishness and stupidity, and I discovered that this also is chasing the wind."
,"18":"For the wiser you are, the more worries you have, and the more you learn, the more you suffer."
}`)
	CurrentBook.AddChapter(2, `{
"1":"I said in my heart, 'I will try pleasure! taste happiness!' But I found that was useless."
,"2":"Laughter is foolishness! As for pleasure, what good is it?"
,"3":"I thought of cheering my body with wine while my heart searched for wisdom. So I gave myself to folly in order to find out what would be good for man to do under the sun throughout his life."
,"4":"I did great things: I built houses and planted vineyards."
,"5":"I made gardens and parks and planted all kinds of fruit trees."
,"6":"I constructed reservoirs to irrigate the orchards."
,"7":"I bought slaves and servants and had slaves born in my household. I had flocks and herds in abundance more than anyone before me in Jerusalem."
,"8":"I acquired silver and gold - the wealth of kings and nations. I had choirmaster and singers and besides that, what most delights men."
,"9":"I became great, surpassing all my predecessors in Jerusalem without losing wisdom."
,"10":"I refused myself nothing that my eyes desired nor did I deprive my heart of any pleasure. I enjoyed all I undertook and that was my reward for my work."
,"11":"Then I considered all I had achieved by my work and all the toil it had entailed and found that it was all meaningless and chasing wind. There is no profit under the sun."
,"12":"I then decided to compare wisdom with folly and madness and I thought, 'What will my successor as king do?' (We know what he did!)"
,"13":"I understood that wisdom is more profitable than folly, just as light is better than darkness:"
,"14":"The wise man has eyes in his head, while the fool walks in darkness. But it dawned on me that the same fate overtakes them both. "
,"15":"And I thought, 'If the fate of the fool will be mine as well, what did my wisdom profit me?' I thought to myself that, too, is meaningless."
,"16":"There is no more remembrance of the wise man than of the fool: both will be forgotten in the days to come. Why is a wise man's death like that of a fool?"
,"17":"So I hated life seeing the wrong in everything that is done under the sun: all is meaningless and chasing wind."
,"18":"I hated all I had labored for under the sun and which I must leave to my successor."
,"19":"Who knows whether he will be foolish or wise? Yet he will be master of all"
,"20":"I have achieved by my own efforts and wisdom: that too is meaningless. And I began to despair in my heart over all my labor under the sun. "
,"21":"For here was a man who toiled in all wisdom, knowledge and skill and he must leave all to someone who has not worked for it. This is meaningless and a great misfortune."
,"22":"For what profit is there for a man in all his work and heart-searching under the sun?"
,"23":"All his days bring sorrow, his work grief; he hasn't, moreover, peaceful rest at night: that too is meaningless."
,"24":"There is nothing better for man to do than to eat and drink and find satisfaction in his work. I understood that this too comes from the hand of God."
,"25":"For without him who can eat or find enjoyment?"
,"26":"To the man who pleases him, he gives wisdom, knowledge and joy, while to the sinner he gives the task of gathering and storing up what will be given to another who pleases God: this too is meaningless and chasing wind."
}`)
	CurrentBook.AddChapter(3, `{
"1":"There is a given time for everything and a time for every happening under heaven:"
,"2":"A time for giving birth, a time for dying; a time for planting, a time for uprooting."
,"3":"A time for killing, a time for healing; a time for knocking down, a time for building."
,"4":"A time for tears, a time for laughter; a time for mourning, a time for dancing."
,"5":"A time for throwing stones, a time for gathering stones; a time for embracing, a time to refrain from embracing."
,"6":"A time for searching, a time for losing; a time for keeping, a time for throwing away."
,"7":"A time for tearing, a time for sewing: a time to be silent and a time to speak."
,"8":"A time for loving, a time for hating; a time for war, a time for peace."
,"9":"What profit is there for a man from all his toils?"
,"10":"Finally I considered the task God gave to the sons of men."
,"11":"He made everything fitting in its time, but he also set eternity in their hearts, although man is not able to embrace the work of God from the beginning to the end."
,"12":"I know that there is nothing better for him to do than to seek pleasure and well-being during his life."
,"13":"To eat, drink and find satisfaction in his work is a gift from God."
,"14":"I know that everything God does remains forever; there is nothing to add, nothing to take from it. Yet God has ordained that men fear him."
,"15":"What has happened comes again; what is now has already been; God recovers what has gone."
,"16":"I have also seen under the sun, instead of justice, wickedness, and in the place of the just, the wicked."
,"17":"And I said to myself, 'God will judge the just and the wicked for there is a time for everything, and a judgment for every deed.'"
,"18":"I also thought about men, how God wants to test them and let them see that they themselves are animals."
,"19":"For the destiny of man and animal is identical: death for one as for the other."
,"20":"Both have the same spirit; man has no superiority over animals for all pass away like wind. Both go to the same place, both come from dust and return to dust."
,"21":"Who knows if the spirit of man rises upward and if the spirit of the beast descends earthward?"
,"22":"I understood that the best man can do is to be happy in what he does, for that is his lot. For who will take him to see the beyond?"
}`)
	CurrentBook.AddChapter(4, `{
"1":"I considered also how much oppression there is under the sun: the tears of the oppressed and no one to console them, the violence of the oppressors and no one to hold them back."
,"2":"More fortunate are the dead for being dead, than the living who have to live,"
,"3":"and even more fortunate than both is the one not yet born who has not seen the abuses under the sun."
,"4":"I saw that all that is done, all that succeeds, results from rivalry with the neighbor: all is meaningless and chasing the wind."
,"5":"The fool folds his arms and eats his meat."
,"6":"Yet better half a fistful of rest than fistfuls of toil and chasing the wind."
,"7":"I saw another senseless thing under the sun:"
,"8":"a man alone, without son or brother, working endlessly, his greed never satisfied with wealth: 'For whom do I work and deprive myself of pleasure?' This, too, is nonsense and mistaken investment."
,"9":"Happier two than one alone, for their work brings a higher salary,"
,"10":"and when one falls the other lifts up his companion. Unfortunate he who is alone and has no one to lift him up."
,"11":"Moreover it's warmer with two in bed; how can one alone be warm?"
,"12":"One person may be overcome by an aggressor, but two can easily oppose him; triple-stranded thread is not easily broken."
,"13":"Better a youth who is poor and wise than a fool of an old king who shuns advice."
,"14":"He may even pass from prison to the throne, though born poor in his kingdom."
,"15":"I saw all who live under the sun follow the youth who replaced the latter and there was no end to the people who sided with him."
,"16":"And yet those who will come after will not be satisfied. This too makes no sense; it's nothing but chasing wind."
,"17":"Watch your step when you go to God's house; it's a better offering to listen, than to present sacrifices as do the fools; for they do not know the evil they do."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Don't be impulsive and hasty with words in the presence of God, for God is in heaven and you are on earth. For that reason let your words be few."
,"2":"For dreams come from over-anxiety and foolish talk from too many words."
,"3":"When you make a vow to God, waste no time in fulfilling it, for he takes no pleasure in fools. Do what you vowed."
,"4":"Better not to make a vow than to fail to fulfill it."
,"5":"Don't let your speech cause you to sin, and then tell God's minister it was a mistake. Why anger God by what you say and destroy the work of your hands? From much dreaming and many words comes emptiness."
,"6":"So fear God."
,"7":"If you see the poor oppressed, right and justice denied in the province, do not be surprised, for over a high-placed official a higher one watches, and over both of these a still higher one watches."
,"8":"The produce of the land benefits everyone and the king serves the land."
,"9":"Whoever loves money will not be satisfied with money. Whoever loves wealth hasn't sufficient income. This is senseless."
,"10":"When there is abundance of good things there is abundance of consumers. What profit is there for the owner except to look on?"
,"11":"Sweet the sleep of the laborer, whether he eats little or much. But the rich man who has had his fill cannot sleep."
,"12":"There is a great evil that I found under the sun, the rich man who kept his wealth to his own harm."
,"13":"A mistaken investment and these riches are lost; a son is born but there is nothing to leave him."
,"14":"Naked he came from his mother's womb, he returns as he came - naked. Nothing of the fruit of his toil is he able to take with him."
,"15":"That, too, is a grievous evil: As he came, so he goes. So what did he gain from chasing the wind?"
,"16":"Why did he eat in darkness all through his life, amidst great sorrow, suffering and vexation?"
,"17":"This is what I saw as most fitting for man: to eat, drink and be happy in all the work he does under the sun during the days God grants him; this is his reward."
,"18":"And when God gives a man riches and property with the possibility of enjoying them and being happy in his work, this is a gift from God."
,"19":"As long as God keeps him occupied in the gladness of his heart, he is not concerned about how long he will live."
}`)
	CurrentBook.AddChapter(6, `{
"1":"There is another very evil thing which I saw under the sun: a man has riches, property, honor, and lacks nothing he could desire,"
,"2":"yet God does not permit him to benefit from them; a stranger has the enjoyment. That is nonsense and a grievous hurt."
,"3":"What if a man had a hundred sons and lived many years but without tasting happiness and even without a tomb! More fortunate, I would say, the one untimely-born."
,"4":"For he came in vain and goes to darkness and in darkness will his name be hidden."
,"5":"He has not seen the sun and has not known it. Finally he has had more rest than that man."
,"6":"Even if he should live a thousand years twice over, but without tasting happiness; do not both go to the same place?"
,"7":"Man works to fill his stomach, yet he himself is not satisfied."
,"8":"Has the wise man more than the fool? What is the benefit of wisdom to one overwhelmed by poverty?"
,"9":"What the eye sees seems better than what the heart desires. That, too, is senseless and chasing wind."
,"10":"Everything has already been evaluated. One knows what man is and that he cannot dispute with the one stronger than himself."
,"11":"Many words, much emptiness; what does it profit?"
,"12":"Who knows what is the good way of life for man, during the days of his meaningless life which pass like a shadow? Who will let him know what will happen after he has gone?"
}`)
	CurrentBook.AddChapter(7, `{
"1":"An honorable name is better than perfumed oil. Better the day of death than the day of birth."
,"2":"Better to go to a house of mourning than to a house of feasting, for to this end all come, and let the living take this to heart:"
,"3":"Sorrow is better than laughter, for a sad face brings healing to the soul."
,"4":"The heart of the wise man is in the house of mourning, while the heart of the fool is in the house of feasting."
,"5":"Better to heed the rebuke of a wise man than to listen to a fool's song."
,"6":"Like the crackling of thorns under a pot is the fool's laugh."
,"7":"Oppression makes a wise man mad, but a bribe corrupts his heart."
,"8":"Better to reach the end than to begin. Better patience than a haughty spirit."
,"9":"Don't be easily dejected, for dejection resides in the womb of fools."
,"10":"Do not ask why former times were better than the present. It is not wisdom that prompts such a question."
,"11":"Wisdom is as precious as an inheritance; it is a blessing for those on whom the sun shines."
,"12":"If wisdom protects you, money will do the same. This is the benefit of acquiring wisdom: it makes its owner live."
,"13":"See the work of God. Who can straighten what he has bent?"
,"14":"Be happy in the day of prosperity and in the day of sorrow reflect:"
,"15":"God has given both one and the other and many may discover what comes later."
,"16":"Do not be over-righteous or excessively wise, lest you harm yourself."
,"17":"Do not be too wicked or too stupid, lest you die before your time."
,"18":"It is well to hold to one and not to loosen your grasp on the other. The God-fearing man copes with both."
,"19":"Wisdom makes the wise man stronger than ten rulers in the city."
,"20":"There is no righteous man on earth who always does good and never sins."
,"21":"Don't take seriously all that you hear, lest you hear your servant speak ill of you."
,"22":"You know well how many times you have spoken ill of others!"
,"23":"After having examined all this critically I said, 'I will be wise!'"
,"24":"But how far it is from me! more remote than anything, and deep, very deep. Who could discover it?"
,"25":"I set myself in all earnestness to know, study and pursue wisdom and reason, so I saw that wickedness is folly, and foolishness, stupidity."
,"26":"I find woman more bitter than death. She is a pitfall; her heart is a snare and her arms, chains. He who pleases God will escape from her, but the sinner will be caught."
,"27":"See what I discovered - says the Teacher - after considering them one after another, anxious to understand."
,"28":"I have been searching but have not yet found; for a man among a thousand I may find, but not a woman among all of them."
,"29":"See what I discovered: God made man simple, but they get lost in their many thoughts."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Who is like the wise man? Who else can solve a problem? A man's wisdom lights up his expression - his stern look is changed."
,"2":"Obey the command of the king because of the oath before God and"
,"3":"don't be eager to ignore it. Do not stubbornly support a bad cause, for he will do what he pleases."
,"4":"The king's word holds. Who will say to him, 'What are you doing?'"
,"5":"Whoever obeys a royal precept avoids trouble. The wise man knows the time and the judgment -"
,"6":"the time to act and the value of everything. This misfortune weighs heavily on man: "
,"7":"he has no knowledge of what will happen. Who can tell him what will happen?"
,"8":"No man controls the wind or holds back the day of death. Struggle is useless and not even wickedness saves its author."
,"9":"I have observed this and set myself to consider everything that is done under the sun, when man is given the power of harming another."
,"10":"And so I have seen the wicked buried and people come from the holy place to honor them, forgetting how they acted. This, too, is futile."
,"11":"It is because sentence against wrongdoing is not passed at once that men turn to evil designs."
,"12":"The sinner may do wrong a hundred times and yet survive."
,"13":"but there will be no happiness for the wicked; and because he doesn't fear God, he will pass like a shadow and his days will not last.)"
,"14":"Another kind of nonsense is found in what humans do on earth: the righteous are treated as the wicked deserve, and the wicked, as the righteous deserve. This, too, is meaningless."
,"15":"So I praise joy, since for man there is no happiness under the sun other than eating, drinking and taking pleasure in his work throughout the life God gives him under the sun."
,"16":"When I set out to get wisdom and considered the human condition on earth, by day or by night when people sleep and are not conscious,"
,"17":"I saw that with regard to God's work, as a whole, no man is able to discover what the work is that goes on under the sun; though he tire himself searching, he will not find out. And if the wise man claims to know, he does not."
}`)
	CurrentBook.AddChapter(9, `{
"1":"I have pondered on all this and now I understand that the just, the wise and all they do are in the hand of God. Man does not know whether hate or love is in store for him."
,"2":"What is most senseless is that the same destiny awaits all, the virtuous and the wicked, the clean and the unclean, the one who sacrifices and the one who doesn't. It is then the same for the good man and the sinner, for the one who swears and the one who refrains from swearing."
,"3":"The same fate comes to all: this is the evil which corrupts all that is done under the sun. This is why man's heart is full of evil and foolishness during his life and his end is with the dead."
,"4":"As long as he shares with the living there is hope, a live dog being better than a dead lion."
,"5":"The living at least know they will die but the dead know nothing; neither do they await anything; the memory of them has vanished."
,"6":"Their love, hate and jealousy have already perished and they no longer have a share in all that is done under the sun."
,"7":"Go, eat your bread with gladness and drink your wine joyfully; this is God's approval of your work."
,"8":"Dress in white and perfume your head."
,"9":"Enjoy life with the wife you love all the days of the meaningless life given you by God under the sun, for this is your lot in life and in the work you do under the sun."
,"10":"Fulfill your projects while you are able, for among the dead where you are going there is no work, no planning, no knowledge, no wisdom."
,"11":"I saw something else under the sun: the race is not won by the swift, nor the battle by the strong, nor does bread go to the wise nor riches to the intelligent; favor is not for the learned, for fortune and misfortune overtake them all."
,"12":"For man is not aware of his time: just as fish are caught in the treacherous net and sparrows trapped in the snare, man, like them, is caught by misfortune suddenly befalling him."
,"13":"I have considered something else very grave under the sun."
,"14":"There was a small town with few inhabitants. A king set out to attack it, laid siege to it and built great siege-works around it."
,"15":"But a poverty-stricken wise man was found, who by his wisdom saved the town. No one, however, remembered the poor man."
,"16":"So I said, 'Better wisdom than heroism,' but the wisdom of the poor is despised and his words are not heeded."
,"17":"The words of the wise spoken calmly are heard above the shouts of a ruler of fools."
,"18":"Wisdom is better than weapons; one sinner spoils much happiness."
}`)
	CurrentBook.AddChapter(10, `{
"1":"As dead flies spoil a jar of perfumed oil, a little folly weighs heavier than wisdom and honor."
,"2":"The heart of the wise man leads him to the right, the heart of the fool leads him to the left."
,"3":"When the fool is on the road, he goes the wrong way and to all he meets he says, 'There goes another fool.'"
,"4":"If the ruler gets angry with you, do not stir, for composure prevents many grave mistakes."
,"5":"An evil I discovered under the sun, an error of rulers:"
,"6":"folly is exalted to the heights while rich men take the lowest places."
,"7":"I have seen slaves riding on horses, princes going on foot like slaves."
,"8":"He who digs a pit may fall into it and he who pierces a wall may be bitten by a serpent;"
,"9":"he who quarries stones may be hurt by them and he who splits logs may be wounded;"
,"10":"if the axe is blunt and the edge not sharpened, you must strike stronger blows, in all this gain with wisdom."
,"11":"But if the serpent doesn't allow itself to be charmed and bites, what did the charmer gain?"
,"12":"The words from the lips of a wise man are gracious but the lips of a fool bring about his own ruin."
,"13":"Folly marks the beginning of his speech and pure madness, the end."
,"14":"Let him multiply his words! (Man does not know what will happen and who will let him know what comes after him?)"
,"15":"Any work wearies the fool; he doesn't even know the way to go to town."
,"16":"Alas for you, O land! if your ruler is a young man whose princes feast in the morning."
,"17":"Happy the land where the king is nobly born and where the princes eat at appropriate times, as fitting to men, rather than being drunk."
,"18":"Laziness in man causes a ceiling to sag and because of a man's slackness a house leaks."
,"19":"Man prepares a meal for pleasure; wine gives cheer to life while money is the answer to everything."
,"20":"Even in your mind do not curse the king and in your bedroom do not curse the rich, for the birds of the air may tell what you say and winged carriers will make it known."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Cast your bread on the water for after a given time you will find it again."
,"2":"Share with seven or even with eight for you never know what misfortune may strike the earth."
,"3":"When clouds are heavy rain falls on the earth and when a tree falls facing south or north there in that place it will lie."
,"4":"He who watches the wind will not sow and he who watches the clouds will not reap."
,"5":"Just as you do not know how the spirit pervades the members in the mother's womb, neither will you understand the work of God, creator of all things."
,"6":"Sow your seed in the morning and do not be idle until the evening for you don't know whether one or the other will succeed. What if both prove to be good?"
,"7":"Light is pleasant and it is good for the eyes to see the sun."
,"8":"If a man lives for many years, let him rejoice in them all, thinking that dark days will be many and all that comes after will be meaningless."
,"9":"Rejoice, young man, in your youth and direct well your heart when you are young; follow your desires and achieve your ambitions but recall that God will take account of all you do."
,"10":"Drive sorrow from your heart and pain from your flesh, for youth and dark hair will not last."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Be mindful of your Creator when you are young, before the time of sorrow comes when you have to say, 'This gives me no pleasure,'"
,"2":"and before the sun, moon and stars withdraw their light, before the clouds gather again after the rain."
,"3":"On the day when the guardians of the house tremble, when sturdy men are bowed and those at the mill stop working because they are too few, when it grows dim for those looking through the windows,"
,"4":"and the doors are shut and the noise of the mill grows faint, the sparrow stops chirping and the bird-song is silenced,"
,"5":"when one fears the slopes and to walk is frightening; yet the almond tree blossoms, the grasshopper is fat and the caperberry bears fruit that serves no purpose, because man goes forward to his eternal home and mourners gather in the street,"
,"6":"even before the silver chain is snapped or the golden globe is shattered, before the pitcher is broken at the fountain or the wheel at the mill,"
,"7":"before the dust returns to the earth from which it came and the spirit returns to God who gave it."
,"8":"Meaningless! meaningless! the Teacher says; all is meaningless!"
,"9":"Besides being a wise man Qoheleth taught the people; he listened, studied and classified a great number of proverbs."
,"10":"Qoheleth tried to write in a pleasant style and express frankly words of truth."
,"11":"The words of the wise are spurs, their collected sayings are like a fence whose many pegs have been assembled by one shepherd."
,"12":"Beware, my son, of searching beyond. Writing many books would be useless, and intense study wearies the body."
,"13":"Conclusion: fear God and obey his precepts; for man depends entirely on this."
,"14":"God brings every deed to judgment, all that is hidden, be it good or bad."
}`)

}
func EN_CCB_LoadVSEIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"All wisdom comes from the Lord and endures with him forever."
,"2":"The grains of sand, the drops of rain and the days of eternity, who can count them?"
,"3":"The height of heaven, the extent of the earth and the depths of the abyss, who can measure them?"
,"4":"Wisdom was created before all things and the prudent intellect before the beginning of time."
,"6":"To whom was the source of Wisdom revealed? Who has known her secret designs?"
,"8":"One alone is wise and greatly to be feared. The One who is seated upon his throne."
,"9":"The Lord himself created Wisdom. He looked on her and knew her value. He poured her out over all his works;"
,"10":"upon all mortal beings, in accordance with his goodness. He lavished her on those who love him."
,"11":"The fear of the Lord is our glory and honor, it is joy and a triumphant crown."
,"12":"The fear of the Lord gladdens the heart; it gives joy, gaiety and long life."
,"13":"For the one who fears the Lord all will go well at the end of his life, and he will be blessed on the day of his death."
,"14":"The fear of the Lord is the beginning of wisdom; he put wisdom into the hearts of his faithful ones before their birth."
,"15":"Founded from eternity she has made her home among men and she will remain faithful to their descendants."
,"16":"The fear of the Lord is the fullness of wisdom. It will fill you with its fruits."
,"17":"It will fill your whole house with desirable things. It will fill your houses with its riches."
,"18":"The fear of the Lord is the crown of wisdom."
,"19":"Wherever it is, peace and good health flourish; knowledge and prudence rain down. Wisdom exalts those who possess her."
,"20":"The fear of the Lord is the root of wisdom. Its branches are long life."
,"22":"Unjust violence cannot be justified, it will destroy itself by its own excesses."
,"23":"The patient man will hold out until the appointed time; but finally joy will be given to him."
,"24":"He will guard his words until the appointed time and in the end many will recognize his worth."
,"25":"Proverbs rich in content are among wisdom's treasures but the sinner does not want to know about God."
,"26":"Do you desire wisdom? Keep the commandments and the Lord will give her to you without measure;"
,"27":"for fear of the Lord is wisdom and learning; what pleases him is faithfulness and gentleness."
,"28":"Do not put aside fear of the Lord; approach him with a sincere heart."
,"29":"Do not be a hypocrite before men; watch well your words."
,"30":"Do not praise yourself lest you fall and bring dishonor on yourself. For the Lord will reveal your secrets and throw you to one side in the midst of the assembly, if you have no fear of the Lord and your heart is full of deceit."
}`)
	CurrentBook.AddChapter(2, `{
"1":"My son, if you have decided to serve the Lord, prepare yourself for trials."
,"2":"Keep your heart upright and remain resolute; do not be upset in the time of adversity."
,"3":"Hold fast to the Lord, do not separate yourself from him so that you may be successful to the end of your days."
,"4":"Accept all that happens to you, be patient when you are humbled,"
,"5":"for as gold is tested in the fire, so those acceptable to God are tested in the crucible of humiliation."
,"6":"Have confidence in him and he will take care of you; follow the right path and hope in him."
,"7":"You who fear the Lord, wait for his mercy and do not turn away lest you fall."
,"8":"You who fear the Lord, trust him and you will not lose your reward."
,"9":"You who fear the Lord, hope for all good things; hope for eternal joy and mercy."
,"10":"Remember what happened to your ancestors. Who has ever trusted in the Lord and been confounded? Who has persevered in fear of the Lord and been abandoned? Who has called upon him and not been heard?"
,"11":"For the Lord is compassion and loving-kindness; he forgives our sins and saves us in time of distress."
,"12":"Woe to faint hearts and weak hands, to the sinner who wavers between two paths."
,"13":"Woe to the fainthearted who lack confidence, because of this they will not be protected."
,"14":"Woe to you who have lost patience! What will you do when the Lord calls you to account?"
,"15":"Those who fear the Lord do not disobey his commandments; those who love him faithfully keep his laws."
,"16":"Those who fear the Lord seek to please him; those who love him are filled with his law."
,"17":"Those who fear the Lord keep their hearts ready and humble themselves in his presence saying,"
,"18":"'Let us fall into the hands of the Lord and not into the hands of men, for great as his power is his mercy.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"My children, it is your father who speaks, listen to me and follow my advice and so be saved."
,"2":"For the Lord established that children should respect their father; he confirmed the right of the mother over her sons."
,"3":"Whoever honors his father atones for his sins;"
,"4":"he who gives glory to his mother prepares a treasure for himself."
,"5":"Whoever honors his father will receive joy from his own children and will be heard when he prays."
,"6":"Whoever glorifies his father will have a long life. Whoever obeys the Lord gives comfort to his mother."
,"7":"He serves those who brought him to birth as he would serve the Lord."
,"8":"Honor your father in word and deed so that his blessing may come on you."
,"9":"For a father's blessing secures the future of his children, but a mother's curse destroys them at their roots."
,"10":"Do not rejoice at the humiliation of your father because his dishonor is no glory for you."
,"11":"For a man's glory comes from his father's reputation; a mother who is not respected is a disgrace to her children."
,"12":"My son, take care of your father in his old age, do not cause him sorrow as long as he lives."
,"13":"Even if he has lost his mind, have patience; do not be disrespectful to him while you are in full health."
,"14":"For kindness done to one's father will never be forgotten, it will serve as reparation for your sins."
,"15":"In the day of adversity the Lord will remember it to your advantage; for just as ice melts in the heat, so will your sins melt away."
,"16":"The man who abandons his father is like a blasphemer; he who annoys his mother is cursed by the Lord."
,"17":"My son, conduct your affairs with discretion and you will be loved by those who are acceptable to God."
,"18":"The greater you are, the more you should humble yourself and thus you will find favor with God."
,"20":"For great is the power of the Lord and it is the humble who give him glory."
,"21":"Do not seek what is beyond your powers nor search into what is beyond your ability."
,"22":"Reflect on what you are commanded to do; there is no need for you to know things that are hidden."
,"23":"Do not tire yourself in resolving useless questions since the knowledge you already have goes beyond human understanding."
,"24":"For many have been led astray by their personal theories and false pretension has undermined reason."
,"26":"The obstinate man will eventually fall into evil, and he who loves danger will perish therein."
,"27":"The obstinate man will be weighed down with sufferings; the sinner heaps up sin upon sin."
,"28":"For the sufferings of the proud man there is no remedy, the roots of evil are implanted in him."
,"29":"The wise man reflects on proverbs. What the wise man desires is an attentive ear. Almsgiving"
,"30":"As water extinguishes the burning flames, almsgiving obtains pardon for sins."
,"31":"The man who responds by doing good prepares for the future, at the moment of his downfall he will find support."
}`)
	CurrentBook.AddChapter(4, `{
"1":"My son, do not deny the poor his food and do not make the man who looks at you with pleading eyes wait."
,"2":"Do not sadden the hungry person nor annoy anyone who is in need."
,"3":"Do not exasperate an angry man nor withhold alms from the beggar."
,"4":"Do not drive away the beggar who is weighed down with afflictions, nor turn away your face from the poor;"
,"5":"do not snub the needy nor give anyone a reason to curse you."
,"6":"If someone curses you in the bitterness of his heart, the Creator will hear his prayer."
,"7":"Make yourself acceptable to the community; bow your head before the one in authority."
,"8":"Listen to the poor man and reply to him with kind words and with peace."
,"9":"Deliver the oppressed from the hands of the oppressor. Do not be weak when you administer justice."
,"10":"Be like a father towards orphans and like a husband towards their mothers. Then you will be like a son of the Most High and he will love you more than your own mother."
,"11":"Wisdom brings up her children and takes care of those who look for her."
,"12":"Whoever loves her loves life. Those who rise early in the morning in search of her will be filled with joy."
,"13":"Whoever possesses her will have glory and wherever he goes blessings will follow."
,"14":"Those who serve her are ministers of the Holy One; those who love her are loved of the Lord."
,"15":"He who listens to her will have good judgment. He who obeys her will rest in safety."
,"16":"Whoever trusts in her will possess her and his children after him will inherit her."
,"17":"For in the beginning she will lead him by rough paths, causing him to fear and be terrified; she will plague him with her discipline until she can count on him; and she will put him to the test by her demands."
,"18":"Then she will lead him on a level path, give him joy and reveal her secrets to him."
,"19":"But if he wanders from the path, she will abandon him and allow him to be lost."
,"20":"In every situation weigh the pros and cons and avoid evil. A wrong kind of shame could harm you."
,"21":"There is a shame which leads to sin and there is a shame which merits praise and respect."
,"22":"Do not act against your better self to win favor from others. Do not let this kind of shame lead you into sin."
,"23":"Do not remain silent when it is necessary to speak. Do not, through pride, hide your wisdom."
,"24":"It is in speech that wisdom is recognized and learning in the spoken discourse."
,"25":"Do not contradict the truth; rather confess your lack of knowledge."
,"26":"Have no shame in confessing your sins, do not swim against the tide."
,"27":"Do not cringe before a foolish man; do not be influenced by the powerful."
,"28":"Fight for the truth till death and the Lord will fight for you."
,"29":"Do not be daring in your speech, but lazy and negligent in works."
,"30":"Do not be like a lion in your household, finding fault with your servants and oppressing those under you."
,"31":"Do not open your hand to receive and keep it closed when you should give."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Do not rely on your wealth. Do not say, 'I am self-sufficient.'"
,"2":"Do not let yourself be carried away by greed and violence; they would make you their slave."
,"3":"Do not say, 'Who can stop me?' For the Lord has power to punish you."
,"4":"Do not say, 'I have sinned and nothing has happened!' For the Lord bides his time."
,"5":"Do not be so sure of pardon when you are heaping sin upon sin."
,"6":"Do not say, 'His compassion is great! He will forgive the vast number of my sins!' For with him is mercy but also anger; his fury will be poured out on sinners."
,"7":"Do not delay your return to the Lord, do not put it off from day to day. For suddenly the anger of the Lord will blaze forth and you will perish on the day of reckoning."
,"8":"Do not rely on riches wrongfully acquired for they will be of no use to you on the day of wrath."
,"9":"Do not be swayed by every wind nor try to walk by every path, as does the sinner who is accustomed to lie."
,"10":"Remain firm in your convictions, and be consistent in your speech."
,"11":"Be ready to listen, and know how to wait before giving your reply."
,"12":"If you know what you are saying, answer your neighbor; if not, it is better to say nothing."
,"13":"Your words can bring you honor and dishonor; a man's tongue brings about his downfall."
,"14":"Do not let yourself be known as a scandalmonger or a deceiver. For if shame is the lot of the robber, severe condemnation is the lot of the liar."
,"15":"Do not sin in big things nor in little things, and from being a friend do not turn into an enemy. An evil reputation brings in its train shame and disgrace; such is the lot of the sinner who is accustomed to lying."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Just as the wicked man inherits confusion and shame so will the sinner accustomed to lying."
,"2":"Do not give yourself over to your passions; they will turn against you and, like a bull, tear you to pieces."
,"3":"They will devour the foliage and destroy the fruit, leaving you like a dry stump."
,"4":"An evil passion will destroy the one who is held in its power; it will make him the laughingstock of his enemies."
,"5":"A gentle word makes many friends, an agreeable tongue calls forth gracious replies."
,"6":"Let your friends be many; but your counselors, one in a thousand!"
,"7":"If you would gain a friend, begin by testing him and do not put your confidence in him too quickly."
,"8":"For there is the friend who is such when it suits him but he does not remain faithful in the time of your adversity."
,"9":"There is the friend who becomes an enemy and, to your confusion, makes known why you quarreled."
,"10":"There is the friend who shares your table but does not remain faithful when things go against you."
,"11":"In times of prosperity he will be like your shadow and he will speak freely to those of your household."
,"12":"But if you are humiliated, he will turn against you and will avoid meeting you."
,"13":"Distance yourself from your enemies and be careful about your friends."
,"14":"The faithful friend is a secure refuge; whoever has found one has found a treasure."
,"15":"A faithful friend is beyond all price; hold him as priceless."
,"16":"A faithful friend is a life-saving remedy, and those who fear the Lord will find one."
,"17":"Whoever fears the Lord will make true friends for, as a man is, such will his friend be."
,"18":"My son, dedicate yourself to learning from your youth, and you will grow in wisdom until old age."
,"19":"Work at it like the worker and the sower, cultivate wisdom and wait for her excellent fruits. For in cultivating her you will have some trouble, but soon you will enjoy her fruits."
,"20":"Wisdom is very severe with the ignorant. A foolish man will not persevere."
,"21":"She will be like a heavy weight or a difficult test which he will quickly throw away."
,"22":"For wisdom brings her own honor, she does not reveal herself to everyone."
,"23":"Listen, my son, and receive my teaching, do not reject my counsel."
,"24":"Put her constraints on your feet and her yoke on your neck."
,"25":"Put your shoulder to the burden and bear her yoke; do not rebel against her chains."
,"26":"Come to her with all your soul and with all your strength observe her ways."
,"27":"Pursue her, search for her, she will make herself known to you; when you have her, do not let her go."
,"28":"For, in the end, you will find in her your rest and she will become your joy."
,"29":"Her constraints will strengthen your steps and her collar will be like a glorious garment."
,"30":"Her yoke will become an ornament of gold and her chains like precious girdles of hyacinth blue."
,"31":"You will adorn yourself as with a garment of glory and you will put her on like a crown of jubilation."
,"32":"If you wish, my son, you will be learned; if you pay attention, you will become clever."
,"33":"If you love to listen, you will learn; if you really pay attention, you will become wise."
,"34":"Be on your guard in the assembly of the elders and if there is a wise man there, attach yourself to him."
,"35":"Be willing to listen to all discourses on divine things, and do not let the sayings of the wise escape you."
,"36":"If you see an intelligent man, follow him from daybreak and let your feet beat a pathway to his door."
,"37":"Meditate on the precepts of the Lord and apply yourself unceasingly to his commandments. He will strengthen your heart and the wisdom you desire will be given to you."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Do no evil and evil will not take hold of you."
,"2":"Keep away from wrongdoing and it will leave you alone."
,"3":"Son, do not sow in the furrows of injustice for fear of reaping its harvest sevenfold."
,"4":"Do not demand authority from the Lord nor from the king a place of honor."
,"5":"Do not make yourself out to be a just man before the Lord nor a wise man in front of the king."
,"6":"Do not seek a position of responsibility lest you not be powerful enough to root out injustice and, overawed by a powerful man, you lose your integrity."
,"7":"Do not offend the city's assembly; do not grovel before the people."
,"8":"Do not commit the same sin twice; once is enough to bring punishment upon you."
,"9":"Do not say, 'When I sacrifice to God, the Most High will take into account the number of gifts and he will accept them.'"
,"10":"Pray with a strong spirit and do not neglect to give alms."
,"11":"Do not despise a man when he is downcast, for there is one who casts down and who raises up."
,"12":"Do not lie about your brother; likewise, do not lie about your friend."
,"13":"Do not allow yourself any kind of lie for nothing good will come of it."
,"14":"Do not gossip in front of the council of the elders, nor keep on repeating your words in prayer."
,"15":"Do not hate hard work nor the tilling of the land as instituted by the Most High."
,"16":"Do not join the company of sinners, remember that the wrath of God will not be delayed."
,"17":"Remain humble, because the godless are punished with fire and worms."
,"18":"Do not exchange your friend for money, nor a real brother for the gold of Ophir."
,"19":"Do not separate yourself from a wise and good woman, because a gracious wife is worth more than gold."
,"20":"Do not maltreat the servant who works honestly, nor the laborer who works diligently."
,"21":"Love the intelligent slave as yourself and do not deprive him of his freedom."
,"22":"Have you any cattle? Take care of them. If they are profitable to you, keep them."
,"23":"Have you children? Educate them and teach them to obey from their childhood."
,"24":"Have you any daughters? Guard their virginity and do not be indulgent towards them."
,"25":"If you marry off your daughter you will have accomplished something of importance, but give her to an intelligent man."
,"26":"Have you a wife who is according to your liking? Do not send her away. As for the one you dislike, do not trust her."
,"27":"Honor your father with your whole heart and do not be forgetful of the sufferings of your mother."
,"28":"Remember that they gave you birth. How can you repay them for what they have done for you?"
,"29":"Reverence the Lord with all your being and respect the priests."
,"30":"Love your Creator with all your strength and do not abandon his ministers."
,"31":"Fear the Lord and honor the priest. Give him the share which has been commanded: the first harvest, the sin-offering, the shoulders of the victims, the holy offerings and the first fruits of sacred things."
,"32":"Stretch out your hand to the poor and you will receive a blessing from the Lord."
,"33":"May your gifts benefit the living and do not forget the dead."
,"34":"Do not turn away from those who weep, and grieve with those who are in sorrow."
,"35":"Do not neglect to visit the sick because it is for such acts that you will be loved."
,"36":"In all your actions remember your last end and you will never sin."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Do not argue with a powerful man lest you fall into his hands."
,"2":"Do not quarrel with a rich man lest he throw his weight into the scale against you."
,"3":"Do not argue with a talkative person; do not heap up wood on his fire."
,"4":"Do not joke with an ignorant man for fear your ancestors will be insulted."
,"5":"Do not offend the man who repents of his sins, remember that we are all deserving punishment."
,"6":"Do not despise a man in his old age, because we ourselves will grow old."
,"7":"Do not rejoice at the death of any man, remember that we shall all die."
,"8":"Do not neglect the teaching of the wise, apply yourself well to their precepts. Through them you will learn how to live and how to serve the great."
,"9":"Do not set aside the teachings of the elders for they also learnt it from their fathers; they will open up your understanding and enable you to reply at the right moment."
,"10":"Do nothing to arouse the sinner for fear of being burned by the flames of his fire."
,"11":"Do not annoy the angry man for fear that he will twist your words to his own advantage."
,"12":"Do not lend to those more powerful than yourself; if you have lent anything, consider it as lost."
,"13":"Do not stand surety beyond your means; if you have done so, be ready to pay."
,"14":"Do not go to law with a judge because, due to his position, judgment will be given in his favor."
,"15":"Do not travel with an adventurer lest he impose himself on you and, as he does whatever he pleases, you both perish through his folly."
,"16":"Do not quarrel with a bad-tempered person nor get involved with him in a lonely place; blood counts for little in his eyes and, when he sees you defenseless, he will attack you."
,"17":"Do not take counsel with a fool because he will not be able to remain silent about what you have said."
,"18":"Do nothing which should be secret before a stranger because you do not know how he will react."
,"19":"Do not reveal your secrets to any man, he will not be grateful to you for doing so."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Do not be jealous of your own wife; do not give her reason to disgrace you."
,"2":"Do not put yourself into the power of any woman to the point where she can dominate you."
,"3":"Do not go near a woman of ill-repute for fear of falling into her nets."
,"4":"Do not dally with a singing girl for fear of being caught in her snare."
,"5":"Do not fix your gaze on a young girl for fear of being involved in her condemnation."
,"6":"Do not deliver yourself into the power of prostitutes lest you lose your inheritance."
,"7":"Do not glance about you in the streets of the town; do not loiter in lonely places."
,"8":"Turn your eyes away from a good-looking woman and do not stare at a beautiful foreigner. For the beauty of a woman has caused many to fall; in her presence love blazes up like a fire."
,"9":"Never sit near a married woman or drink wine with her, for fear that your feelings towards her be roused and that in your passion you slide towards your downfall."
,"10":"Do not abandon an old friend, for a new one has not the same value. New wine, new friend; let them mature, then you will enjoy them with pleasure."
,"11":"Do not envy the success of the sinner, you do not know what his end will be."
,"12":"Do not take pleasure in what pleases the godless, remember that they will be punished before they die."
,"13":"Keep well away from the man who has power to kill and you will not experience the fear of death. But if you go with him avoid all offense for fear that he will deprive you of life: realize that you are passing through deathtraps and that you are walking on top of the wall."
,"14":"As far as you can, be sociable and take counsel with learned men."
,"15":"Love to speak with intelligent men and let all your discourses be about the law of the Most High."
,"16":"Let just men be your companions at table; take pride in your fear of the Lord."
,"17":"An artisan is judged by his work and a leader of the community, by the wisdom of his words."
,"18":"A talkative man is dreaded in his town and the gossip makes himself disliked."
}`)
	CurrentBook.AddChapter(10, `{
"1":"The wise leader will teach his people; the government of the intelligent man will be well-ordered."
,"2":"As the leader is, so will his ministers be; as the leader of the city is, so will be its inhabitants."
,"3":"A king without wisdom will ruin his people; a city will prosper through the wisdom of its rulers."
,"4":"The government of the earth is in the hands of the Lord; in his own time he will raise up the right leader."
,"5":"The success of every man is in the hands of the Lord and he clothes the rulers with his glory."
,"6":"Do not store up resentment against your neighbor, no matter what his offense; do nothing in a fit of anger."
,"7":"Pride is odious to both God and man; injustice is abhorrent to both of them."
,"8":"Sovereignty passes from one nation to another because of injustice, violence and wealth."
,"9":"How can there be such pride in someone who is nothing but dust and ashes? Even while he is living, man's bowels are full of rottenness."
,"10":"Look: the illness lasts while the doctor makes light of it; and one who is king today will die tomorrow."
,"11":"Once a man is dead, grubs, insects and worms are his lot."
,"12":"The beginning of man's pride is to separate himself from the Lord and to rebel against his Creator."
,"13":"The beginning of pride is sin. Whoever perseveres in sinning opens the floodgates to everything that is evil. For this the Lord has inflicted dire punishment on sinners; he has reduced them to nothing."
,"14":"The Lord has overturned the thrones of princes and set up the meek in their place."
,"15":"The Lord has torn up the proud by the roots and has planted the humble in their place."
,"16":"The Lord has overturned the land of the pagans and totally destroyed them."
,"17":"He has devastated several of them, destroyed them and removed all remembrance of them from the face of the earth."
,"18":"Pride was not created for man nor violent anger, for those born of woman."
,"19":"Which race is worthy of honor? The human race. Which race is worthy of honor? Those who fear the Lord. Which race is despicable? The human race. Which race is despicable? Those who break the commandments."
,"20":"The leader is worthy of respect in the midst of his brethren, but he has respect for those who fear the Lord."
,"22":"Whether they be rich, honored or poor, their pride should be in fearing the Lord."
,"23":"It is not right to despise the poor man who keeps the law; it is not fitting to honor the sinful man."
,"24":"The leader, the judge, and the powerful man are worthy of honor, but no one is greater than the man who fears the Lord."
,"25":"A prudent slave will have free men as servants, and the sensible man will not complain."
,"26":"Do not feel proud when you have only accomplished your work; do not put on airs when times are difficult for you."
,"27":"Of greater worth is the man who works and lives in abundance than the one who shows off and yet has nothing to live on."
,"28":"My son, have a modest appreciation of yourself, estimate yourself at your true value."
,"29":"Who will defend the man who makes an attempt on his own life? Who will respect the man who despises himself?"
,"30":"The poor man will be honored for his wisdom and the rich man, for his riches."
,"31":"Honored when poor - how much more honored when rich!,Dishonored when rich - how much more dishonored when poor!"
}`)
	CurrentBook.AddChapter(11, `{
"1":"The poor man who is wise carries his head high and sits among the great."
,"2":"Do not praise a man because he is handsome and do not hold a man in contempt because of his appearance."
,"3":"The bee is one of the smallest winged insects but she excels in the exquisite sweetness of her honey."
,"4":"Do not be proud because of the clothes you wear; do not be proud when people honor you. Do you know what the Lord is preparing in a mysterious way?"
,"5":"Many tyrants have been overthrown and someone unknown has received the crown."
,"6":"Many powerful men have been completely disgraced and famous men handed over into the power of others."
,"7":"Do not reprehend anyone unless you have first been fully informed, consider the case first and thereafter make your reproach."
,"8":"Do not reply before you have listened; do not interrupt the one who is speaking."
,"9":"Do not interfere in what is not your business; do not meddle in the disputes of sinners."
,"10":"My son, do not undertake too many activities. If you keep adding to them, you will not be without reproach; if you run after them, you will not succeed nor will you ever be free, although you try to escape."
,"11":"There are those who exhaust themselves, tire themselves out and become anxious, yet in the end they are only the poorer."
,"12":"There are those who are weak, needing support, lacking goods and in great poverty, yet the eyes of the Lord look on them with favor. The Lord will redress their humiliation."
,"13":"He will raise their heads and many people will marvel on this account."
,"14":"Good and evil, life and death, poverty and riches, all come from the Lord."
,"17":"The just can count on the generosity of the Lord and his goodness will guide them forever."
,"18":"A man may become rich through being careful and miserly and this is his reward."
,"19":"The day on which he thinks, 'I have earned my rest, now I can live on my possessions,' he does not know how long he is going to live. He will have to die and leave his goods to others."
,"20":"Remain faithful to your duty, give your life to it and grow old in your work."
,"21":"Do not be disconcerted at the success of sinners but have confidence in God and persevere in your own efforts. It is easy for the Lord in an instant to make the poor man rich."
,"22":"The blessing of the Lord is the just man's reward and quickly, in an instant, his benediction will bear fruit."
,"23":"Do not say, 'What do I need? What more could I have or desire?'"
,"24":"Do not say, 'I have all that is necessary, what misfortune can harm me now?'"
,"25":"On good days, one forgets the bad; and on bad days one forgets the good."
,"26":"Even when the end draws near, it is easy for the Lord to reward a man according to the way he has lived."
,"27":"The hour of adversity makes one forget pleasure; at the end of a man's life his deeds will be revealed."
,"28":"Do not consider anyone as blessed before his death, for only then he will be known."
,"29":"Do not invite just anybody into your house for many are clever deceivers."
,"30":"Like a partridge in its cage acting as a decoy, so is the heart of the proud man; like a spy he watches out for your weaknesses."
,"31":"He changes good things into evil, he lays his traps and criticizes even the best things."
,"32":"Just as a spark sets coals on fire, the wicked man prepares his snares in order to draw blood."
,"33":"Beware of the wicked man for he is planning evil. He might dishonor you forever."
,"34":"If you take a stranger into your house, he will cause you trouble; he will estrange you from your household."
}`)
	CurrentBook.AddChapter(12, `{
"1":"If you do good, know to whom you are doing it and you will receive thanks for your kindness."
,"2":"Do good to the godly man and you will receive a reward, if not from the man himself, at least from the Most High."
,"3":"Blessings are not for those who persist in evildoing, nor for those who refuse to show compassion."
,"4":"Give to the godly man, do not help the sinner;"
,"5":"do good to the humble, do not give to the ungodly; deny him bread, do not give it to him lest he eventually dominate you. He will repay you with a double evil for all the good that you have done for him."
,"6":"For the Most High himself detests sinners and carries out his vengeance on the ungodly."
,"7":"Give to the good man but do not help the sinner."
,"8":"A friend does not become an enemy in the time of prosperity, nor does an enemy remain hidden in the time of adversity."
,"9":"When a man is doing well, his enemies are sad; when he is suffering misfortune, even his friends hasten to abandon him."
,"10":"Never trust an enemy, for his malice is like bronze covered in rust."
,"11":"Even if he should act as a humble man and walk with head bowed down, watch yourself and be on your guard against him. Behave towards him as a man who polishes a bronze mirror. Know that the rust will not remain until the end."
,"12":"Do not place him near you lest he overthrow you and take your place. Do not make him sit on your right hand lest he covet your seat. Let it not be that in the end you understand my words and regret not having listened to my advice."
,"13":"Who will have pity on the snake-charmer bitten by a snake or on those who go near wild beasts?"
,"14":"It is the same for the man who joins company with a sinner and finds himself involved in his wrongdoing."
,"15":"The sinner will remain quietly with you for an hour but when you are distracted he will throw away his mask."
,"16":"The enemy is all sweetness in his speech, but in his heart he is planning to throw you in the ditch. The enemy has tears in his eyes but, if he finds an opportunity, he cannot have enough of your blood."
,"17":"If misfortune comes to you, you will find him there before you; pretending to help you, he will be scheming to get rid of you."
,"18":"He will wag his head in mockery and clap his hands, he will whisper unceasingly and will show his true face."
}`)
	CurrentBook.AddChapter(13, `{
"1":"He who touches tar will be soiled; he who associates with an arrogant man will become like him."
,"2":"Do not carry too heavy a load; do not make friends with someone stronger and richer than you. Why put the earthen pot near the iron one? One will bang the other and break it."
,"3":"The rich man does wrong and is unconcerned; the poor man is insulted and apologizes."
,"4":"The rich man uses you as long as you are useful to him; when you have nothing left he deserts you."
,"5":"He will stay with you as long as you have something; he will drain you without a second thought."
,"6":"If he really needs you he will deceive you, smile at you and raise your hopes; he will speak smooth words and say, 'What would you like?'"
,"7":"He will show his gratitude by entertaining you until he has taken all you possess, and he will make fun of you in the end. Afterwards, when he sees you, he will have nothing to do with you, shaking his head when he meets you."
,"8":"Take care not to be deceived and humiliated through stupidity."
,"9":"When an influential person invites you, delay and he will call you all the more."
,"10":"Do not go so far forward that you are pushed aside or so far back that you are overlooked."
,"11":"Do not try to talk to him as an equal or trust his many words. With all this verbiage he is only trying to test you and, under pretense of kindness, he is weighing you up."
,"12":"He will repeat your words without pity and will not spare you either blows or chains."
,"13":"Be wary and take great care because you are walking with your own stumbling block."
,"15":"All that lives loves its own kind and each person, his own neighbor."
,"16":"Every animal relates to its own species and man to his own kind."
,"17":"What has the wolf in common with the lamb? It is the same with the sinner and the virtuous man."
,"18":"What kind of peace can exist between the hyena and the dog? What peace between the rich man and the poor man?"
,"19":"Wild donkeys are the prey of desert lions; so, also, are the poor the prey of the rich."
,"20":"The proud man hates humility; so, also, the poor man is detestable to the rich."
,"21":"When the rich man stumbles, his friends support him, but when the poor man falls, his friends desert him."
,"22":"When the rich man gets into trouble, there are many who come to his rescue; if he speaks nonsense, they congratulate him. When the poor man makes a mistake, they criticize him; if he speaks sensibly, they pay no attention."
,"23":"When the rich man speaks, all are silent and they praise his words to the skies. The poor man speaks and people ask, 'Who is this?' And if he stumbles, they push him down."
,"24":"Wealth is good if there is no sin in it and poverty is evil when it is the reward for godlessness."
,"25":"Man's heart is reflected in his face, for better or for worse."
,"26":"Does he show a happy face? All is going well to him. Has he found words of wisdom? He has reflected on suffering."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Happy the one who has not sinned in speech or who feels no remorse for his faults."
,"2":"Happy is he whose own conscience does not condemn him and who has not fallen from his ideals."
,"3":"Wealth does not befit the small-minded man; why would you give the greedy man riches?"
,"4":"He who hoards, depriving himself, is hoarding for others: others will enjoy his goods."
,"5":"He who is mean to himself, with whom will he be good? He does not even enjoy his own riches."
,"6":"There is nothing worse than one who is mean to himself, this is how his evil repays him."
,"7":"If he does good, he does it without realizing it but, in the end, his evil will be revealed."
,"8":"Evil is the greedy-eyed man who does not pay attention to persons and looks down on people."
,"9":"The ambitious man is not content with what he has, wicked injustice shrivels up the heart."
,"10":"The envious eye covets the food of others; there will be misery and famine at his table."
,"11":"My son, use well whatever you have and give worthy offerings to the Lord."
,"12":"Remember that death will not delay and your time has not yet been revealed to you."
,"13":"Be good to your friend before you die and be generous to him in any way you can."
,"14":"Enjoy happiness and do not reject lawful pleasure when it comes your way."
,"15":"Will you not have to leave to another the fruit of your works? The fruit of your labor, will it not be shared out by lot?"
,"16":"Give, take and treat yourself well, for in the netherworld there are no pleasures to seek."
,"17":"All living things grow old like clothing. This is the eternal law: 'You will die.'"
,"18":"Like green leaves on a bushy tree: some sprout and others fall off, so are the generations of flesh and blood: one dies and another is born."
,"19":"All finite things pass away and their maker with them."
,"20":"Happy the one who is intent on wisdom and who can reply to those who question him;"
,"21":"who makes his own the ways of wisdom and meditates on her secrets;"
,"22":"who pursues her like a hunter, lies in wait by her paths,"
,"23":"peeps in at her windows and listens at her doors;"
,"24":"he sets up camp near her house, fixing his stakes in her walls."
,"25":"He places his tent in the hands of wisdom; he stays in a happy lodging."
,"26":"He places his sons beneath her protection and finds shelter beneath her branches."
,"27":"He is shaded by her from the heat and makes his camp in her glory."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Such is the one who fears the Lord; whoever embraces the Law will obtain wisdom."
,"2":"She will come out to meet him like a mother and greet him like a virgin bride;"
,"3":"she will feed him with the bread of understanding and give him the water of wisdom to drink."
,"4":"He will rely on her and will not waver; he will lean on her and will not be let down."
,"5":"Wisdom will make him greater than his friends and he will be able to speak in the full assembly."
,"6":"He will be crowned with happiness and joy. He will inherit an everlasting name."
,"7":"The fool will never possess her, and sinners will never set eyes on her."
,"8":"She is far away from pride, and liars will know nothing of her."
,"9":"Praise is not fitting on the lips of sinners since it does not come from the Lord."
,"10":"Praise must come from the wise man; so the Lord himself inspires it."
,"11":"Do not say, 'It was God who made me sin.' God does not cause what he hates."
,"12":"Do not say, 'He made me do wrong,' for he has nothing to do with a sinner."
,"13":"The Lord hates all evil and those who fear him hate it as well."
,"14":"When he created man in the beginning, he left him free to make his own decisions."
,"15":"If you wish, you can keep the commandments and it is in your power to remain faithful."
,"16":"He has set fire and water before you; you stretch out your hand to whichever you prefer."
,"17":"Life and death are set before man: whichever a man prefers will be given him."
,"18":"How magnificent is the wisdom of the Lord! He is powerful and all-seeing."
,"19":"His eyes are on those who fear him. He knows all the works of man."
,"20":"He has commanded no one to be godless and has given no one permission to sin."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Do not long for a brood of worthless children, and take no joy in godless sons."
,"2":"However many you have, do not rejoice in them if they have no fear of God."
,"3":"Do not depend on their having a long life, or trust in their number, because one is better than a thousand and their death is preferable to their being godless."
,"4":"A city can arise from one man who is prudent. Yet, even though the wicked become a great tribe, they will be destroyed."
,"5":"I have seen such things with my own eyes and my ears have heard of still greater things."
,"6":"Fire has come upon the meeting of sinners and God's wrath is kindled against rebellious people."
,"7":"God did not pardon the leaders of old who rebelled in their pride of strength."
,"8":"He did not spare the city where Lot lived; he detested their pride."
,"9":"He showed no pity on the people doomed to destruction; they were annihilated for their sins."
,"10":"In the same way, he dealt with the six hundred thousand men who, in the hardness of their hearts, had revolted."
,"11":"Had there been only one stubborn man it would have been amazing if he had escaped unpunished, since mercy and anger belong to the Lord who is powerful both in forgiveness and in punishment."
,"12":"His justice is as great as his mercy and he judges men by their deeds."
,"13":"Just as the sinner will not escape with his booty, the patience of the upright man will not go unrewarded."
,"14":"God will reward every act of mercy; each person will be treated according to his deeds."
,"17":"Do not say, 'I will hide from the Lord; who will remember me up there? I will not be recognized in the midst of so many. What am I in the immensity of creation?'"
,"18":"Look: the sky and the heavens above the sky, the sea and the earth tremble when he comes."
,"19":"The mountains, together with the foundations of the earth, are filled with dread before his sight."
,"20":"But nobody thinks of such things: who is interested in the ways of God?"
,"21":"Most of his works go unnoticed and man does not see where the storm originates."
,"22":"'Who tells us of the interventions of God? Who expects them? The Covenant is far away.'"
,"23":"Such are the thoughts of the man of little sense, the foolish, dissolute man who loves his illusions."
,"24":"Listen to me, my sons; acquire knowledge and apply your heart to my words."
,"25":"I will expound the teaching step by step and impart knowledge carefully."
,"26":"God created his works from the beginning and, as he made them, he assigned to each its place."
,"27":"He arranged them for all time, their beginning and their unfolding. They do not hunger or grow weary and they never cease from their duties."
,"28":"Not one has collided with its neighbor; they will never disobey his commands."
,"29":"Afterwards, the Lord looked down on the earth and filled it with his riches."
,"30":"He covered its surface with all kinds of living things which must return to it."
}`)
	CurrentBook.AddChapter(17, `{
"1":"The Lord created man from the earth and let him return to earth."
,"2":"He settled a fixed time for them and a set number of days, giving them power over everything on earth."
,"3":"He endowed them with a strength like his own, making them in his own image."
,"4":"He put the fear of men in all living things, thus they had mastery over the animals and birds."
,"6":"He endowed them with knowledge; he gave them tongue and eyes, ears and a mind to think with."
,"7":"He filled them with wisdom and knowledge; he taught them good and evil."
,"8":"He put his own eye in their hearts so they would understand the greatness of his works."
,"10":"They will praise his holy Name and relate the magnificence of his creation."
,"11":"He gave them revealed knowledge as well and handed over to them the Law of life."
,"12":"He established an everlasting covenant with them and let them know his judgments."
,"13":"Human eyes saw the splendor of the Glory of God; their ears heard the grandeur of his voice."
,"14":"He said to them, 'Keep yourselves from all wrongdoing,' and to each of them he gave commands regarding his neighbor."
,"15":"Their conduct is always before the Lord; they cannot escape his sight."
,"17":"He has placed a leader over each nation, but Israel is the Lord's own portion."
,"19":"Their deeds are as clear as the sun to him, he always observes their ways."
,"20":"Their misdeeds cannot be hidden from him, all their sins are before the Lord."
,"22":"He holds a man's almsgiving dear as a priceless signet ring; he cherishes a good deed like the apple of his eye."
,"23":"One day he will rise and reward them; he will place their prize on their heads."
,"24":"He allows those who repent to return; he comforts those whose hopes are fading."
,"25":"Be converted to the Lord and give up your sins, plead with him to lessen your offense."
,"26":"Return to the Almighty, turn aside from wrongdoing and totally detest evil."
,"27":"For who in the grave will praise the Almighty, if the living do not give him glory?"
,"28":"The dead man is as if he did not exist and cannot give praise; he who has life and health can praise the Lord."
,"29":"How great is the mercy of the Lord and his forgiveness for those who turn to him!"
,"30":"Man cannot have everything in his power since he is not immortal."
,"31":"What is brighter than the sun? Yet it disappears. Man is no more than flesh and blood, yet he thinks of doing evil."
,"32":"While the sun surveys the stars in the lofty sky, all men remain dust and ashes."
}`)
	CurrentBook.AddChapter(18, `{
"1":"He who lives forever created all without exception."
,"2":"The Lord alone will be found righteous."
,"4":"He has made no one powerful enough to proclaim his works; who then, will reveal his marvels?"
,"5":"Who can calculate the power of his majesty and relate his great goodness?"
,"6":"Nothing can be added to him or taken away; no one can fathom the wonders of the Lord."
,"7":"When man thinks he has finished, then he is only beginning and when he stops he is puzzled by it all."
,"8":"What is man? What is his purpose? What is the good in him and what the bad?"
,"9":"Take the length of his life: a hundred years is long."
,"10":"Like a drop of water from the sea, a grain of sand, such are his few years compared with eternity."
,"11":"For this reason, the Lord has patience with them and pours out his mercy on them."
,"12":"He sees and realizes how miserable their end is and so he heaps his forgiveness upon them."
,"13":"Man's mercy is for his neighbor but the compassion of the Lord reaches all people; he rebukes, corrects, teaches and brings back his flock like a shepherd."
,"14":"He takes pity on those who accept correction and eagerly seek his will."
,"15":"My son, do not mix your favors with unkind remarks or your gifts with bitter words."
,"16":"Does not dew temper the heat? So, too, a kind word is much better than a gift."
,"17":"The gift is not as valuable as the words which accompany it, but a generous man brings both."
,"18":"The fool intends to please but insults, a grudging man's gift makes the eyes smart."
,"19":"Find out the facts before you speak; look after yourself before you become ill."
,"20":"Examine yourself before judgment comes and, on the day of God's visitation, you will be forgiven."
,"21":"Humble yourself before you become ill and show repentance for your sins."
,"22":"Let nothing prevent you from fulfilling your vow on time; do not wait until death to put things in order."
,"23":"Prepare yourself before praying and do not be one of those who tempt the Lord."
,"24":"Keep in mind the justice of the last days; God will turn his face from you on the day of vengeance."
,"25":"When you experience abundance, remember the days of famine; when you enjoy riches, think of poverty and misery."
,"26":"Time slips by between morning and evening, all things pass quickly before the Lord."
,"27":"The prudent man is cautious in everything; when sin abounds he will keep away from wrongdoing."
,"28":"Every sensible man recognizes wisdom and respects those who obtain her."
,"29":"Those who speak sensibly are wise, and marvelous sayings flow from them."
,"30":"Do not let your passions rule you and restrain your desires."
,"31":"If you satisfy your lusts you will make yourself the laughingstock of your enemies."
,"32":"Do not take pleasure in great luxury, lest you become impoverished by its expense."
,"33":"Do not impoverish yourself by feasting on credit when you have nothing in your pocket."
}`)
	CurrentBook.AddChapter(19, `{
"1":"A drunken worker will never be rich; he who is careless in small things will soon fall."
,"2":"Wine and women corrupt the best of men; whoever frequents prostitutes loses all sense of shame."
,"3":"He will be the victim of grubs and worms and lose his life because of his stupidity."
,"4":"He who is too quick to trust others reveals a shallow mind, whoever sins injures himself."
,"5":"One who revels in pleasure will be condemned,"
,"6":"hating gossip will save one from evil."
,"7":"Never repeat what you are told and you will come to no harm."
,"8":"Report nothing to friend or foe and, unless silence is sinful, reveal it to no one."
,"9":"They will listen, distrust you and you will end up being hated."
,"10":"Have you heard something? Let it die with you, remain calm; you will not burst with it."
,"11":"A fool suffers like a woman in childbirth over something he is told."
,"12":"Like an arrow stuck in his thigh, such is a secret inside a fool."
,"13":"Speak with your friend: perhaps he has done nothing and, if he has, he will not do it again."
,"14":"Speak with your friend: perhaps he has not said anything and, if he has, he will not say it again."
,"15":"Speak with your friend for there is much slander; do not believe all that you hear."
,"16":"Often, unintentional slips are made; for who has never sinned by evil tongues?"
,"17":"Speak with your neighbor before you heap accusations on him; then leave room for the Law of the Almighty."
,"20":"All wisdom is in the fear of the Lord; in all wisdom is the fulfillment of the Law."
,"22":"Knowledge of evil is not wisdom, and prudence is not found in the advice of sinners."
,"23":"There is a cleverness that is loathsome; it belongs to the evildoer who lacks wisdom."
,"24":"Better to lack sense and be full of the fear of the Lord, than to be clever in violating the Law."
,"25":"There is an ingenious shrewdness which carries out injustice; it is the art of dissimulating in order to do evil."
,"26":"One pretends to be grieving and weighed down with burdens but in his heart there is only cunning;"
,"27":"he hides his face and pretends to be deaf, but as soon as you are distracted, he will take advantage of you."
,"28":"One does not sin when the means are lacking; at the first opportunity, he will do wrong."
,"29":"You can tell a man by his appearance; the responsible man can be recognized by his face."
,"30":"A man's way of dressing reveals who he is, as does his manner of laughing and walking."
}`)
	CurrentBook.AddChapter(20, `{
"1":"There are rebukes which are inopportune; there is the silence of a sensible man."
,"2":"Better to rebuke than nurse a grudge. He who recognizes his fault diminishes its consequences."
,"4":"Like a eunuch desiring to violate a girl, such is he who uses force in pretending to be just."
,"5":"One keeps silent and is thought to be wise, the other makes himself hated because of his gossiping."
,"6":"One remains silent because he does not know how to reply; the other keeps quiet, waiting for the right moment."
,"7":"The wise man keeps silent until the right moment; the chatterer and fool speak out of turn."
,"8":"He who speaks too much makes himself hated; he who wishes to impose himself stirs up ill will."
,"9":"Man can turn his troubles to his advantage; a lucky chance can turn to loss."
,"10":"There is a type of generosity which will not reward you and another which will repay you double."
,"11":"One is humiliated for having had honors; another is humiliated, and then lifts up his head."
,"12":"One buys much with little money; another pays seven times its value."
,"13":"The wise man makes himself lovable through his words alone, while the favors of the fool are lost."
,"14":"The fool's gift is not to your advantage; he gives with greedy eyes."
,"15":"He gives little but puts on a great outward appearance and exclaims for all to hear; he lends today and recovers the loan tomorrow; he is a despicable man."
,"16":"The fool says, 'I have no friends, no one welcomes my favors."
,"17":"Those who eat my bread have evil tongues.' How often they will mock him, and by how many!"
,"18":"Better to stumble on the ground than to make a slip with the tongue; this is how easily the wicked fall."
,"19":"The rough-mannered man is like an indiscreet story that ill-mannered people tell out of time."
,"20":"The proverb told by a fool will fail, since he does not speak it at an appropriate time."
,"21":"One keeps himself from sin because he does not have the means to act; when he gets the chance, he will have no remorse."
,"22":"One loses his soul out of false shame; he loses himself for fear of what a foolish man thinks."
,"23":"Out of false shame he wants to win a friend; he gets an enemy, in fact, for nothing."
,"24":"Lying is a shameful defect in a man; fools are used to it."
,"25":"Better to be a thief than a liar, yet both are heading for disaster."
,"26":"Habitual lying is detestable; disgrace never leaves the liar."
,"27":"The wise man's words advance his cause; the shrewd man will gain favor with the powerful."
,"28":"He who tills the earth increases his produce; he who pleases the great is forgiven his wickedness."
,"29":"Presents and gifts blind a wise man's eyes; like a muzzle they silence the conscientious."
,"30":"Concealed wisdom and hidden treasure: what good are these?"
,"31":"The man who conceals his stupidity is better than one who conceals his wisdom."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Have you sinned, my son? Do not do it again and beg forgiveness for your past sins."
,"2":"Escape from sin as you would from a snake; if you go near, it will bite you. Its teeth are like those of a lion and destroy human lives."
,"3":"All evil is like a double-edged sword which inflicts wounds past remedy."
,"4":"Violence and pride bring down the rich; the arrogant man's house will be brought low."
,"5":"The poor man's prayer reaches the ears of the Lord and his judgment will not delay."
,"6":"Whoever hates correction goes the way of sinners; he who fears the Lord turns to him in his heart."
,"7":"The chatterer is known everywhere, but the discreet man recognizes his weakness."
,"8":"Building a house with borrowed money is like collecting stones for your own tomb."
,"9":"The meeting of sinners is like a pile of rope which will go up in fire and flames."
,"10":"The path of sinners is well paved but it ends in the fiery abyss."
,"11":"He who keeps the Law is in control of his thoughts; the fear of the Lord brings wisdom."
,"12":"The man who is not clever will never be taught; but there is a cleverness which leads to bitterness."
,"13":"The wise man's knowledge spreads out like a flood and his advice is like a spring."
,"14":"The fool's heart is like a broken glass which cannot hold any teaching."
,"15":"If an educated man hears a wise saying he values it and adds another. If the good-for-nothing hears it he is annoyed and tosses it over his shoulder."
,"16":"The fool's talk weighs like a load while the wise man's words give rest."
,"17":"The assembly awaits the wise man's words; each one takes to heart whatever he says."
,"18":"The fool's wisdom is like a house in ruins, the knowledge of the fool amounts to nonsense."
,"19":"As far as the fool is concerned, instruction is no more than handcuffs and fetters."
,"20":"The idiot laughs aloud while the intelligent man merely smiles quietly."
,"21":"Instruction is like a golden ornament to the shrewd man, like a bracelet on his right arm."
,"22":"The fool steps inside the house immediately, the experienced man would not be so bold."
,"23":"The fool looks in through the door, the polite man remains outside."
,"24":"Listening outside doors reveals a bad upbringing, the upright man would be ashamed of doing so."
,"25":"Strangers speak thoughtlessly of everything, while wise men's words are carefully weighed."
,"26":"The heart of fools is in their mouth, but the mouth of the wise is in their heart."
,"27":"When the godless man curses his opponent, the curse descends on himself."
,"28":"The slanderer taints himself and makes himself hated by all around him."
}`)
	CurrentBook.AddChapter(22, `{
"1":"The idler is like a dirty stone, his disgrace is laughed at."
,"2":"The idler is like a heap of dung, all who touch it shake it off their hands."
,"3":"Badly brought up sons are the shame of their father, and daughters, a humiliation."
,"4":"A sensible daughter is a treasure to her husband, but the disgraceful one is a burden to her father."
,"5":"A shameless daughter brings disgrace on her father as well as her husband; both hate her."
,"6":"The untimely word is like music at a funeral but beating and correction guided by wisdom are never out of place."
,"9":"Teaching a fool is like gluing a broken jar, it is easier to awaken a man from deep sleep."
,"10":"Reasoning with a fool is like reasoning with a drowsy man; in the end, he will ask you, 'What is it all about?'"
,"11":"Weep for the dead man since the light has deserted him, weep for the fool because understanding has deserted him. Cry less for the dead man; he has found his rest but the fool's life is worse than death."
,"12":"Mourning the dead lasts seven days, but it lasts a lifetime for the fool and godless man."
,"13":"Do not waste words on the fool or go with the stupid man; beware of him lest he bring you trouble and his contact leave you contaminated. Stay away from him if you want rest and do not want to be worn out by his requests."
,"14":"What is heavier than lead? What is its name but 'Fool'?"
,"15":"Sand, salt and a load of iron are easier to bear than a fool."
,"16":"The wooden joint in a building is not dislodged by an earthquake; a determined heart, after careful reflection, will not be moved when crises come."
,"17":"A decision based on serious reflection stands like plaster on a firm wall."
,"18":"Stakes set on a height do not resist the wind; the fool's heart, frightened by his own imaginings, cannot withstand fear."
,"19":"Striking the eye brings tears; if you strike the heart, lucidity will come forth."
,"20":"Whoever throws stones at birds scares them off; reproach a friend and you will kill the friendship."
,"21":"If you have drawn your sword against a friend, do not despair, it can be put back;"
,"22":"if you have spoken harshly to a friend, do not fear, reconciliation is possible; but in the event of insult, contempt, betrayal of a confidence or treacherous blow, any friend would desert you."
,"23":"Win your neighbor's confidence when he is poor so that you may enjoy his goods with him when he grows rich; be loyal in his hour of trouble and you will win, in the end, a share in his inheritance."
,"24":"Smoke and fumes precede the fire; so, too, insults herald the blows."
,"25":"I will not be ashamed of protecting a friend nor will I avoid him;"
,"26":"if evil comes to me from him, all who hear of it will beware of him."
,"27":"Who will put a guard on my mouth and effectively lock up my lips to prevent me from sinning and my tongue from hastening my ruin?"
}`)
	CurrentBook.AddChapter(23, `{
"1":"O Lord, Father and master of my life, do not abandon me to the thoughtless words of my lips or allow me to fall because of them."
,"2":"Who will deal out punishment to my thoughts and apply the discipline of wisdom to my heart?"
,"3":"Let them not be indulgent at my sins or the mistakes of my mind, lest my errors increase and sins multiply, and I fall into the hands of my enemies, to the joy of my foes."
,"4":"Lord, Father and God of my life, do not allow me to become haughty;"
,"5":"keep greed far away from me."
,"6":"Do not let lust and lechery take hold of me; do not deliver me to filthy passions."
,"7":"Children, learn how to control your language; if you are able to watch over it, you will not be taken by surprise."
,"8":"The sinner will be caught in his own words, as happens to the proud man and to him who curses."
,"9":"Do not get used to swearing, taking the name of the Holy One."
,"10":"For, just as the slave who is constantly watched will not escape without blows so you, also, will not be found guiltless after constantly calling upon his name."
,"11":"The man who swears habitually will be found full of sins, and disgrace will not depart from his house. If he fails to keep his oath due to carelessness, punishment will descend upon him; if he fails knowingly, his sin is double and if he has sworn falsely, he will not be forgiven; in any case, his house will be filled with disasters."
,"12":"There is a way of talking which deserves death; let it not be used by Jacob's descendants. Virtuous men keep far away from it and do not wallow in sin."
,"13":"Do not accustom your mouth to foul language for it will be sinful talk."
,"14":"Remember your father and mother when you are sitting in the company of the great, lest you forget yourself in their presence and act like a fool. Then you would wish you had never been born, and curse the day of your birth."
,"15":"A man used to indecent talk will never be reformed in his lifetime."
,"16":"Two types of men multiply sins and a third attracts the Lord's anger: A blazing passion which burns like fire will not be extinguished until it burns itself up. A man who seeks pleasure from his own body, he will not give up until he catches fire; "
,"17":"to the indecent man, all food tastes sweet and he will not be satisfied until death."
,"18":"The man unfaithful to the marriage bed who thinks like this, 'Who sees me? Darkness surrounds me, the walls hide me; nobody can see me. Why should I worry? The Almighty will not take note of my faults.'"
,"19":"He fears the scrutiny of men and does not realize that the Lord's eyes are a thousand times brighter than the sun, that they watch the conduct of all men and penetrate into the most secret corners."
,"20":"All things were present to him before they were created and so will they be after their end."
,"21":"This man will be punished in view of the whole city, he will be caught when he least expects it."
,"22":"In the same way, the woman who is unfaithful to her husband and gives him an heir by another man will be punished."
,"23":"First, she has disobeyed the Law of the Almighty. Secondly, she has sinned against her husband and thirdly, she is tainted with adultery, for she has had children by another man."
,"24":"She will be taken before the assembly and questioned about her children."
,"25":"The children will not be able to take root; their branches will not bear fruit."
,"26":"She will leave behind a cursed memory and her shame will never be blotted out."
,"27":"People who have seen her will know that nothing matters more than the fear of the Lord and nothing is sweeter than fulfilling his commands."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Listen to wisdom singing her own praises and extolling herself in the midst of her people."
,"2":"See, she opens her mouth in the assembly of the Most High, she glories in herself before the Almighty."
,"3":"I came out from the mouth of God and covered the face of the earth like a mist; although"
,"4":"my dwelling place is in the highest heavens, my throne is within a pillar of cloud."
,"5":"I alone have seen and understood the vault of the skies and strolled through the depths of the abyss,"
,"6":"taking possession of the raging sea and of the earth as well, with all its peoples and nations."
,"7":"In all of these, I looked for a place to rest; in which territory would I set up my abode?"
,"8":"Then the creator of the universe commanded me, he who created me assigned the place of my rest, 'Pitch your tent in Jacob; Israel will be your homeland.'"
,"9":"He created me from the beginning, before time began, and I will never cease to be,"
,"10":"I celebrate in his presence the liturgy of his Holy Dwelling and this is why I settled in Zion."
,"11":"The Lord let me rest in his beloved city and Jerusalem is the heart of my kingdom."
,"12":"I took root in the people God has favored, in the land of the Lord, in their inheritance."
,"13":"I grew like a cedar in Lebanon, as the cypress on Mount Hermon."
,"14":"I grew like the palm trees in Engedi and the rosebuds of Jericho; as a magnificent olive on the plains and like a plane tree I grew tall."
,"15":"I poured out my perfume like a fragrant flower, like exquisite myrrh I have given choice scent; like fragrant plants and as the smoke of incense which burns in the Sanctuary of God."
,"16":"I spread out my branches like a vine; these are Glory and Grace."
,"17":"As a vine I put out graceful shoots and my blossoms are riches and glory."
,"19":"Come to me, you who desire me and take your fill of my fruits."
,"20":"To experience me is sweeter than honey and to possess me sweeter than any honeycomb."
,"21":"Those who eat me will hunger still; those who drink me will thirst for more."
,"22":"Those who obey me will not be put to shame; those who serve me will not fall into sin."
,"23":"All this is in the Bible, the Testament of the Most High God, the book of the Law which Moses entrusted to us, the inheritance of the congregations of Israel."
,"25":"This Law feeds the springs of wisdom, like the Pishon or Tigris in the season of fruit."
,"26":"Waters overflowing with understanding come from it, as from the Euphrates and Jordan at harvest time;"
,"27":"the floods of instruction run like the Nile or the Gihon in time of vintage."
,"28":"He who comes first is unable to grasp her fully and neither will the last exhaust her."
,"29":"For her thoughts are wider than the sea and her designs, deeper than the abyss."
,"30":"I, for my part, went forth like a brook from a river, a stream diverted into a delightful garden."
,"31":"I thought, 'Let me irrigate my orchard and water my flowers.' But now my brook has grown into a river and the river, into a sea."
,"32":"May my teaching shine forth like the dawn; may I carry its light to faraway places."
,"33":"I will spread my teaching like a prophecy and leave it to future generations."
,"34":"See, all of you, that I have not worked for myself alone but for all those who seek wisdom."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Three things delight me and are delightful to God and men: agreement between brothers, friendship between neighbors, and perfect harmony between husband and wife."
,"2":"There are three kinds of persons whom I detest and whose existence I cast away from me: a poor man full of pride, a rich man who is a liar, and an adulterous old man who is a fool."
,"3":"If you have saved nothing in your youth, what will you have in old age?"
,"4":"What a great thing is old age with sound judgment, an old man who can counsel!"
,"5":"What a great thing is wisdom in those who are old, or understanding and prudence in the great."
,"6":"Rich experience is the crown of the old, their pride is the fear of the Lord."
,"7":"I think of nine things which I consider happy and a tenth to which I will also refer: the man who finds his happiness in his children; the man who sees the ruin of his enemies in his lifetime."
,"8":"Happy the man who lives with a sensible wife; he who does not plow with a donkey and ox; he who has done no wrong in speech; he who does not serve an unworthy master."
,"9":"Happy he who has acquired good sense and is able to speak before an attentive audience!"
,"10":"Great is he who has gained wisdom, but no one surpasses the man who fears the Lord."
,"11":"Since the fear of the Lord excels everything, who can compare with the one who possesses it?"
,"13":"Any wound rather than the wound of the heart; any wickedness rather than the wickedness of a woman;"
,"14":"any sadness rather than that inflicted by an enemy; any vengeance rather than the vengeance of a foe."
,"15":"There is no poison worse than a snake's venom, there is no rage worse than an enemy's."
,"16":"Better to live with a lion and a snake than to share a house with a wicked woman."
,"17":"Wickedness disfigures a woman's appearance, it saddens the face, making her look like a bear."
,"18":"When her husband dines with his neighbor, he sighs bitterly, in spite of himself."
,"19":"All wickedness is nothing compared with a woman's wickedness. Let her lot be that of a sinner!"
,"20":"As a sandhill is to an old man's feet, so is the talkative woman to her quiet husband."
,"21":"Do not be fooled by a woman's beauty or fall in love with her."
,"22":"Expect anger, reproach and plenty of shame when the wife rules the husband."
,"23":"Dejected spirits, a sad face and unseen wounds, these are the work of a wicked woman. Idle hands and unsteady knees are found when a wife brings her husband no happiness."
,"24":"For sin began with woman and we all die because of the inheritance of the congregations of Israel."
,"25":"Do not let water leak out or give free rein to a wicked woman. If she does not do as you tell her, get rid of her."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Happy the husband of a good wife, the number of his days will be doubled."
,"2":"A woman of character is her husband's joy, he will live in peace all the years of his life."
,"3":"A good wife is the best of gifts, reserved for those who fear the Lord;"
,"4":"rich or poor, he will have a serene heart and a happy face."
,"5":"Three things disturb me and a fourth frightens me: neighborhood gossip, a rioting mob, a false accusation, all these are worse than death."
,"6":"But the woman jealous of another woman brings heartbreak, her tongue lashes out at everyone."
,"7":"A bad wife is like a badly fixed yoke; taking her is like grasping a scorpion."
,"8":"A drunken wife causes scandal; her disgrace will not remain hidden."
,"9":"A licentious woman is noticed by her secretive looks and recognized by her lively eyes."
,"10":"Keep a firm eye on a defiant daughter, so that she may not take advantage of some occasion."
,"11":"Guard against the provocative woman and do not be surprised if she wishes to drag you into disgrace."
,"12":"She opens her mouth like a thirsty traveler to drink any water coming her way; she sits by any pole and opens her quiver to every arrow."
,"13":"A wife's grace gladdens her husband and her prudence refreshes his body."
,"14":"A wife who knows how to be silent is a gift from the Lord; the well-trained wife is invaluable."
,"15":"A modest wife is a favor among favors; the chaste wife is priceless."
,"16":"Like the sun rising over the mountains of the Lord, such is the enchantment of a good wife in a well-kept house."
,"17":"Like the light which shines from the sacred lampstand, such is a beautiful face in a well-shaped body."
,"18":"Like pillars of gold on a silver base, such are beautiful legs on sturdy feet."
,"28":"There are two things which grieve me and a third which makes me angry: a warrior who suffers want; intelligent men who are treated contemptuously; a man who turns from virtue to sin. The Lord singles this man out to strike him down."
,"29":"The merchant can barely avoid greed; the shopkeeper cannot remain sinless."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Many sin for love of gain, he who desires riches silences his conscience."
,"2":"Just as the stake is settled between two stones, so sin wedges itself between buying and selling."
,"3":"The house of him who does not keep himself firmly in the fear of the Lord will soon be knocked to the ground."
,"4":"When a sieve is shaken the dirt falls through; so, too, the defects of a man are seen when he begins to speak."
,"5":"The kiln tests the potter's handiwork; a man is tested by his conversation."
,"6":"A well-tended tree is shown by its fruits so a man's feelings can be detected in what he says."
,"7":"Praise no one before he has spoken, since this is the acid test."
,"8":"If you pursue righteousness, you will achieve it and wear it like a festive garment."
,"9":"Birds associate with their own kind, so, too, does truth greet those who are faithful."
,"10":"The lion lurks in wait for its prey; so, too, does sin lie in wait for those who do wrong."
,"11":"The wise man's conversation follows wisdom all the time. In contrast, the fool changes like the moon."
,"12":"When among fools, be sparing with your time; among thoughtful people, be lavish with it."
,"13":"The conversation of fools is hateful, their laughter is coarse and raucous."
,"14":"No one can bear those who swear all the time. Their quarrels make you cover your ears."
,"15":"Blood is spilt when proud men quarrel and their insults are painful to the ear."
,"16":"He who betrays a secret is no longer trusted; he will no longer find reliable friends."
,"17":"Love your friend and be loyal; if you have revealed his secrets, go with him no longer."
,"18":"It is like having lost some of your relatives: his friendship to you has died."
,"19":"Like a bird, you have let your friend go, you will not get him back. When you open your hand, the bird flies off;"
,"20":"do not pursue him: he is far away and has fled like a gazelle from the snare."
,"21":"For a wound can be bandaged and an insult forgiven, but if you betray a secret there is no hope."
,"22":"The man who winks an eye is plotting evil, no one can persuade him to change."
,"23":"He is all sweetness to your face, praising your words, but behind your back he speaks differently and twists your words."
,"24":"I hate many things but nothing more than this man; the Lord, also, hates and curses him."
,"25":"When one tosses a stone in the air it falls back on his head; whoever deals a treacherous blow, wounds himself."
,"26":"He who digs a pit will fall into it; he who sets a snare will be caught in it."
,"27":"If you do evil, evil will befall you and you will not know from where it comes."
,"28":"The proud man makes use of mockery and insults, but vengeance lies in wait for him like a lion."
,"29":"Those who gloat over the downfall of good men will fall into the snare; suffering will consume them before they die."
,"30":"Grudge and wrath, these also are abominations in which sinful people excel."
}`)
	CurrentBook.AddChapter(28, `{
"1":"He who demands revenge will suffer the vengeance of the Lord who keeps a strict account of his sins."
,"2":"Forgive the mistakes of your neighbor and you may ask that your sins be forgiven."
,"3":"If a man bears resentment against another, how can he ask God for healing?"
,"4":"If he has no compassion on others, how can he pray for forgiveness for his sins?"
,"5":"As long as he, mere flesh, is resentful, who will obtain his pardon?"
,"6":"Remember your end and give up hatred; keep in mind your final corruption in the grave and keep the commandments."
,"7":"Remember the commandments and do not bear grudges against your neighbor. Remember the covenant with the Most High and overlook the offense."
,"8":"Refrain from quarreling and you will avoid sin; the hot-headed man sparks off disputes."
,"9":"The sinner causes trouble between friends, sowing discord among peaceful people."
,"10":"Fire burns when fuel is thrown on it; stubbornness drags out the discussion. The more powerful the man, the greater his rage; his anger will be in proportion to his riches."
,"11":"A sudden quarrel sparks off a fire; a hasty dispute leads to bloodshed."
,"12":"Blow on a spark and it ignites; spit on it and it dies out: both come from your mouth."
,"13":"Cursed be the gossiper with his spiteful tongue. He has destroyed many who lived peacefully."
,"14":"The vicious tongue has demolished many and hounded them from nation to nation. It has ruined powerful cities and laid low great households."
,"15":"The vicious tongue has cast out wives who were beyond reproach, depriving them of the fruit of their work."
,"16":"Whoever listens to it will never find rest or be able to live in peace."
,"17":"The whip leaves a mark but the lash of the tongue shatters bones."
,"18":"Many have been felled by the sword but many more have perished by the tongue."
,"19":"Happy he who has escaped it and has not been exposed to its fury, who has not been weighed down by its yoke or been tied up in its chains."
,"20":"For it is a yoke of iron and its chains are bronze."
,"21":"It brings a miserable death. Actual death is better!"
,"22":"But it will not tyrannize those who keep faith, it will not consume their soul."
,"23":"Those who desert the Lord will be its victims, it will burn them without being burnt up itself; it will lunge at them like a lion, and rip them apart like a leopard."
,"24":"Look, you put a fence around your property and protect your silver and gold."
,"25":"In the same way, make weights and scales for your words and put a bolted door at your mouth."
,"26":"Beware of a slip of the tongue when you speak, lest you fall in front of those who lie in wait for you."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Lending to your neighbor is an act of mercy, going to his aid fulfills the commandments."
,"2":"Learn to lend to your neighbor when he is in need and, in turn, repay him any loan on time."
,"3":"Keep your word, remain faithful and you will find what you need on every occasion."
,"4":"Many think of a loan as a quick deal and put those who help them in a fix."
,"5":"The moment they receive it, they kiss the hand of the moneylender and humble themselves in deference to his wealth. But on the day repayment is due, they prolong the time, repay with reproaches and blame the current situation."
,"6":"If they can repay, they pay barely half and the moneylender will be grateful for that much. They have robbed him of his money and, moreover, he has gained enemies, for they repay him with curses and insults and reproaches instead of gratitude."
,"7":"Many a good person refuses to lend, not for any malicious reason: he is afraid of being cheated without cause."
,"8":"Nevertheless, be kind to those who have fallen on hard times, do not keep them waiting for your help."
,"9":"For the commandments' sake, help the poor man; see his need and do not turn him away empty-handed."
,"10":"Better to spend your money on a brother or friend than to let it rust under a stone, to your discredit."
,"11":"Use your money according to the commandments of the Most High and you will find it more valuable than gold."
,"12":"Fill your barns with good deeds and these will rescue you from misfortune."
,"13":"They will fight for you against your enemy better than any strong shield and mighty spear."
,"14":"A good man goes surety for his neighbor; the scoundrel leaves him to his fate."
,"15":"Do not forget the favors of your guarantor: he has risked his life for you."
,"16":"The sinner wastes his guarantor's money; the ungrateful man forgets the one who saved him."
,"17":"Acting as guarantor has ruined many a good man and has tossed him like the waves of the sea."
,"18":"It has banished powerful men and forced them to wander among foreign nations."
,"19":"The sinner is anxious to be a guarantor but he will be condemned as a loan shark."
,"20":"Help your neighbor as far as you can but beware of falling into the same plight."
,"21":"Some things you cannot live without: water, bread, clothes and a house for shelter."
,"22":"Better a poor man's life in his wooden shack than lavish banquets in another man's house."
,"23":"Be content with whatever you have, be it great or small; this is better than to go elsewhere and be reproached as an outsider."
,"24":"It is hard to go from house to house;"
,"25":"when you are an outsider, do not risk opening your mouth. You will eat and drink without much welcome and, on top of that, hear bitter remarks:"
,"26":"'Come, stranger, set the table and whatever you have, give it to me to eat.'"
,"27":"'Be off, stranger, make room for somebody more important; my brother is coming to see me, I need the house.'"
,"28":"It is hard for a good man to have hospitality denied him and to be treated like a debtor."
}`)
	CurrentBook.AddChapter(30, `{
"1":"The man who loves his son makes use of the rod; later on he will be proud of him."
,"2":"The man who corrects his son will reap the benefit and be proud of him among his acquaintances."
,"3":"By instructing his son he makes his enemy envious; he will be well pleased with him in the company of his friends."
,"4":"If such a father dies it is as if he had not died, for he leaves behind him another man like himself."
,"5":"In life he had the joy of his company and he is not sorrowful when death comes."
,"6":"He leaves it to his family to take revenge on his enemies and to return gifts to his friends."
,"7":"The man who coddles his son will be constantly bandaging his wounds; at his every cry he will be troubled."
,"8":"Just as a badly broken-in horse cannot be mounted, so a spoiled son becomes insolent."
,"9":"Pamper your child and later he will terrify you; play with him and he will bring you sorrow."
,"10":"Do not laugh at him lest you have to suffer and grind your teeth."
,"11":"Do not let him be independent as a child,"
,"12":"but rather bruise his ribs while he is still young, lest he grow stubborn and refuse to obey."
,"13":"Be strict with your son and persevere in this, so as not to suffer because of his misconduct."
,"14":"Better a poor man healthy and fit, than a rich man tormented in body."
,"15":"Health and vigor are worth more than gold, a robust body, more than great wealth."
,"16":"No riches are preferable to physical well-being, and no joy is greater than a cheerful heart."
,"17":"Death is better than a wretched life and eternal rest preferable to lasting sickness."
,"18":"Dishes of food placed on an empty tomb are like good things offered to one who cannot eat."
,"19":"What good is a sacrifice offered to an idol? It can neither eat nor smell. So is it with the one whom the Lord has stricken;"
,"20":"he sees with his eyes and groans, like a eunuch embracing a virgin and sighing."
,"21":"Do not give yourself over to sadness or torment yourself with brooding."
,"22":"Joy of heart is life to a man; gladness gives him length of days."
,"23":"Delight your soul and console your heart; chase sorrow far away, for sorrow has destroyed many and never did good to anyone."
,"24":"Jealousy and anger shorten your life; worry makes you old before the time."
,"25":"A cheerful and kindly person will have a good appetite and enjoy his food."
}`)
	CurrentBook.AddChapter(31, `{
"1":"The sleeplessness that wealth brings makes a man lose weight; his worries drive sleep away."
,"2":"The cares of the day prevent sleep; in the same way, serious illness makes rest impossible."
,"3":"The rich man toils to increase his wealth and then sits back and lives in luxury;"
,"4":"the poor man toils to survive and is in want as soon as he leaves off."
,"5":"He who loves gold cannot be righteous; whoever runs after gain will be led astray."
,"6":"Many have been ruined because of gold; disgrace went to meet them."
,"7":"Gold is a snare for those who are possessed by love of it. The senseless will be caught in it."
,"8":"Happy is the rich man who has not sinned in this way and has not gone after gold!"
,"9":"Who is he? Let us say: Fortunate man! For he has given a wonderful example."
,"10":"Who has been tested in this and found perfect? He has reason to be proud. Who could have sinned but resisted, who could have done wrong and did not do it?"
,"11":"His fortune is firmly established and the assembly will acknowledge his generosity."
,"12":"Are you seated at a lavish banquet? Don't be over-ready to eat and don't say, 'What a feast!'"
,"13":"Remember that a greedy eye is an evil thing. What is worse than such an eye? That is why it was condemned to weep."
,"14":"Do not stretch out your hand to everything you see or be quick in reaching for a dish."
,"15":"Judge the needs of your fellow guest by your own and in all things act prudently."
,"16":"Eat what is set before you like an educated person and don't be a glutton, lest you be detested."
,"17":"Like a well-mannered man, be the first to stop; don't be voracious if you are to avoid difficulties."
,"18":"If important people are present, do not be the first to serve yourself."
,"19":"A little is sufficient for a well-bred person; your breathing moreover will be easier when you go to bed."
,"20":"Healthy sleeping is for the moderate eater. He rises early and feels fit! Sleeplessness and stomach trouble attend the overindulgent."
,"21":"If you are obliged to eat too much, go off and vomit and you will be at ease."
,"22":"Listen to me, my friend, and do not neglect what I say; in the end you will see the truth of it. Be moderate in all that you do and you will be without illness."
,"23":"A generous host is appreciated: he is justly praised,"
,"24":"but everyone will complain about a stingy host and their complaints will be justified."
,"25":"Do not try to show how much wine you can take, for wine has been the ruin of many."
,"26":"As the furnace tests the temper of steel, so wine proves hearts and makes proud men quarrel."
,"27":"Wine is life for man if taken in moderation. What is life without wine?"
,"28":"Wine makes for a glad heart and a cheerful mind, if taken moderately and at the right time."
,"29":"But if taken to excess it brings bitterness of soul, excitement and a fumbling step."
,"30":"Drunkenness inflames the anger of a stupid person to the point of scandal. It reduces his strength and brings him blows."
,"31":"Do not reproach a neighbor during a wine feast, and don't look down on him when he is merry; do not speak harshly to him or annoy him by asking him to settle a debt."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Have you been chosen to preside at a party? Don't give yourself airs! Just be like everyone else in the group; see to their needs and then sit down."
,"2":"When you have done what you should, take your place and enjoy yourself with the others. They will congratulate you for a job well done."
,"3":"If you are older, speak as befits your age, but know what you are talking about and do not interrupt the music."
,"4":"If there is a concert, refrain from speaking; it is not the time for playing the wise man."
,"5":"A musical concert at a wine banquet is like a ruby set in gold."
,"6":"As an emerald signet set in a work of gold, so is the music with good wine."
,"7":"If you are young, speak if you have to, but not more than twice and only if requested."
,"8":"Keep to the point and say it all in a few words. Show that you are well informed but not over-anxious to speak."
,"9":"Do not try to be the equal of eminent people and do not chat when someone else is speaking."
,"10":"As lightning goes before thunder, the reputation of a modest man goes before him."
,"11":"Leave the party at the right time and do not be slow about it; no lingering, go straight home!"
,"12":"There you may relax and do as you please, but do not sin by bragging."
,"13":"And thank your Creator for the enjoyment of all good things."
,"14":"Whoever fears the Lord will accept his correction, and those who rise at dawn will win his favor."
,"15":"The man who follows his Law will be nourished by it, but the hypocrite will find it a stumbling block."
,"16":"Those who fear the Lord will please him and their good deeds will shine as a light."
,"17":"The sinner refuses correction and excuses himself for doing what he wants."
,"18":"A person of judgment reflects beforehand; the stubborn and proud man goes ahead without worrying about anything."
,"19":"Never act without first reflecting, and you will have no regrets."
,"20":"Do not go along a rough road lest you stumble on stones."
,"21":"And do not be too sure of your step on a smooth path."
,"22":"Beware even of your own children."
,"23":"Be careful in whatever you do. In so doing you keep the commandments."
,"24":"Those who trust in the Law will keep the commandments and those who obey the Lord will come to no harm."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Evil will not go to meet the one who fears the Lord; if he is in danger he will be rescued."
,"2":"The wise man never departs from the Law; he who only pretends to keep it is like a storm-tossed boat."
,"3":"An intelligent man has faith in the Law, which for him is as trustworthy as an oracle."
,"4":"If you want people to listen to you, prepare what you have to say; recall what you have learned before you give an answer."
,"5":"A cart wheel! That is what the feelings of a fool are like. His mind resembles a turning axle."
,"6":"A mocking friend is like a wild horse, neighing when anyone rides him."
,"7":"Why is one day holier than another, when the light of the sun shines on every day of the year?"
,"8":"By the Lord's decision they were made different; he arranged the different seasons and feasts."
,"9":"Some of these he chose to make holy, others he made ordinary days."
,"10":"All men come from clay just as Adam himself was formed."
,"11":"In the fullness of his wisdom the Lord made each one unique and diversified his conditions."
,"12":"Some he made holy, keeping them near to himself. Others he cursed and humiliated, removing them from where they were."
,"13":"As clay in the hand of the potter to be molded as he pleases, so are all in the hands of the Creator to be dealt with as he sees fit."
,"14":"Good is the opposite of evil, and life, of death, and the sinner is the opposite of the upright."
,"15":"Consider all the works of the Most High and you will see how they go in pairs, by opposites."
,"16":"As for me I have been the last to keep watch, like a gleaner following the grape-pickers."
,"17":"By the blessing of the Lord I have taken the lead and like the grape-picker I have filled the winepress."
,"18":"Note that not only for myself have I toiled, but for all who seek instruction."
,"19":"Hear me, rulers of the people, leaders of the assembly hear!"
,"20":"Neither to son, wife, brother nor friend give power over yourself during your life. Do not give your property to another in case you regret it and have to beg them to return it."
,"21":"As long as you live and there is breath in you, do not give power over yourself to anyone."
,"22":"It is preferable for your children to be dependent on you, than that you be obliged to depend on them."
,"23":"Be master of all that you do; let not others stain your reputation."
,"24":"Wait until the end of your days, until death is near, to distribute your inheritance."
,"25":"Fodder, stick and burdens are for the donkey; bread, correction and work are for the slave."
,"26":"Put your slave to work and you will have peace. Let him take it easy and he will want to be free."
,"27":"Yoke and harness will bow the neck. For a criminal slave there are torture and the stocks."
,"28":"Send him to work or he will be idle, and idleness teaches much evil."
,"29":"Give him work that is appropriate for him; if he does not obey, put his feet in chains."
,"30":"But do not be over-demanding with anyone and do nothing without discernment."
,"31":"You have a slave? Let him be like you; for you bought him through blood."
,"32":"You have a slave? Treat him like a brother. You need him as you need yourself."
,"33":"If you ill-treat him and he escapes, where will you go to look for him?"
}`)
	CurrentBook.AddChapter(34, `{
"1":"The foolish are deceived by vain and false hopes; dreams give them wings."
,"2":"To rely on dreams is like grasping a shadow or chasing the wind."
,"3":"What you see in dreams are only reflections: a person sees his own image."
,"4":"What clean thing can come from what is unclean? What truth comes from what is false?"
,"5":"Divinations, omens and dreams are empty like the fantasies of a woman in labor."
,"6":"Unless they come as messengers of the Most High, do not pay attention to them."
,"7":"For dreams have led many people astray. Those who hoped in them have fallen."
,"8":"Not so the Law, which never fails but comes true. Wisdom from the truthful lips of God is the highest truth."
,"9":"One who has traveled knows a great deal, and a man of wide experience will talk soundly."
,"10":"A person who has not had trials knows very little. But the traveled man is competent in many ways."
,"11":"I have made many discoveries on my travels and understood more than I can express."
,"12":"I have often been in danger of death but have been saved thanks to my experience."
,"13":"The spirit of those who fear the Lord will live, for their hope is placed in the One who saves."
,"14":"He who fears the Lord is in dread of nothing. He will not be cowardly for he is his hope."
,"15":"He who fears the Lord is a happy person. To whom does he turn? Who is his support?"
,"16":"The eyes of the Lord are on those who love him. For them he is powerful protection, strong support, shelter against scorching wind and the midday sun. He is a safeguard against stumbling and assurance against a fall."
,"17":"He lifts up the soul and gives a sparkle to the eyes; he gives healing, life and blessing."
,"18":"An offering to God from stolen goods is a stained offering, the sacrifices of the wicked do not please God."
,"19":"The Most High takes no pleasure in the offering of the godless. It is not the number of victims that obtains pardon for sin."
,"20":"Offering to God from what belongs to the poor is like slaughtering a son in the presence of his father."
,"21":"Bread is life to the poor; he who takes it from them is a murderer."
,"22":"He who deprives others of a livelihood kills them, and whoever withdraws the salary of a worker is guilty of blood."
,"23":"If one builds and the other destroys, what do they gain besides trouble?"
,"24":"If one prays and the other curses, whose voice will the Master listen to?"
,"25":"If a man is cleansed after touching a corpse and then touches it again, what good was there in his cleansing?"
,"26":"If anyone fasts for his sins and then commits the same sins, who will hear his prayer? What value is there in his fasting?"
}`)
	CurrentBook.AddChapter(35, `{
"1":"Keeping the Law is worth many offerings. Being faithful to the commandments is like a peace offering."
,"2":"Returning kindness is an offering of fine flour; giving alms is a sacrifice of praise."
,"3":"Renouncing sin pleases the Lord, and shunning injustice is a sacrifice of atonement."
,"4":"Do not appear before the Lord with empty hands. The commandment requires that you bring an offering."
,"5":"When the offering of the righteous is burned on the altar, the fat drips down and a fragrant aroma rises to the Most High."
,"6":"The sacrifice of the just man pleases God and will not be forgotten."
,"7":"Honor the Lord with a generous heart and do not be stingy with the first fruits of your harvest."
,"8":"Offer your gifts with a smiling face and when you pay your tithes do it gladly."
,"9":"Give to the Most High as he has given to you; give generously to the Lord according to what you have;"
,"10":"the Lord will repay, he will reward you sevenfold."
,"11":"If you attempt to bribe him with gifts he will not accept them; do not rely on offerings from dishonest gain."
,"12":"The Lord is judge and shows no partiality."
,"13":"He will not disadvantage the poor, he who hears the prayer of the oppressed."
,"14":"He does not disdain the plea of the orphan, nor the complaint of the widow."
,"15":"When tears flow down her cheeks, is she not crying out against the one who caused her to weep?"
,"16":"The one who serves God wholeheartedly will be heard; his petition will reach the clouds."
,"17":"The prayer of the humble person pierces the clouds, and he is not consoled until he has been heard."
,"18":"His prayer will not cease until the Most High has looked down, until justice has been done in favor of the righteous."
,"19":"And the Lord will not delay, nor will he be patient with the wicked,"
,"20":"but he will crush the backbone of the merciless and have vengeance on the nations,"
,"21":"until he has completely destroyed the hordes of the violent and broken the power of the wicked,"
,"22":"until he has repaid each one according to his deeds,"
,"23":"until he has judged his people and made them rejoice because of his mercy."
,"24":"Blessed is his mercy in the time of adversity! It is like rain clouds during a drought!"
}`)
	CurrentBook.AddChapter(36, `{
"1":"Have mercy on us, Master, God of all, and look on us; make every nation stand in fear of you."
,"2":"Take action against the pagan nations and let them see your power."
,"3":"You have shown them your holiness through what happened to us, so now let us see your great power in acting among them."
,"4":"Let them acknowledge, as we have acknowledged, that there is no God but you, Lord."
,"5":"Give new signs, do fresh wonders, stretch out your hand and be glorified in your strength."
,"6":"Kindle your fury and rouse your anger, destroy your opponents, crush your enemy."
,"7":"Hasten the day, remember your covenant so that we may speak of your great deeds."
,"8":"Let the survivors be consumed in fiery wrath, let those who oppress send to perdition."
,"9":"Crush the heads of hostile rulers - those who say they alone count."
,"10":"Gather all the tribes of Jacob, give them back their inheritance as in the beginning."
,"11":"Have pity, Lord, on the people known by your Name, on Israel whom you called your firstborn."
,"12":"Show compassion to the holy city, to Jerusalem where you rest."
,"13":"Fill Zion with the fame of your wonders, and your people with your glory."
,"14":"Confirm the promises made to your people long ago and fulfill the promises made in your name."
,"15":"Reward those who wait for you and fulfill the words of your prophets."
,"16":"Hear the prayer of your servants, Lord; hear your priests giving Aaron's blessing to your people."
,"17":"So that all on earth may acknowledge that you are Lord and everlasting God."
,"18":"The stomach takes in all kinds of food but one food is better than another."
,"19":"Just as the tongue can distinguish the flavor of game, so does the alert mind detect lies."
,"20":"A crooked heart causes sorrow, but an experienced person knows how to get even with him."
,"21":"A woman will accept any husband but some daughters are better than others."
,"22":"Woman's beauty rejoices people and is beyond all that could be wished for."
,"23":"If she is kindly-spoken and gentle he is the most fortunate of men."
,"24":"When a man marries he acquires a fortune, someone who understands him and who will help and support him."
,"25":"When there is no hedge the property will be destroyed; and when a man has no wife he is a fretful wanderer."
,"26":"Who would trust a clever robber flitting from town to town?"
,"27":"And who would trust a man without a nest, who lodges wherever nightfall finds him?"
}`)
	CurrentBook.AddChapter(37, `{
"1":"Every friend says, 'I am your friend, too,' but some friends are only friends in name."
,"2":"Is it not a deadly grief when a companion or friend turns into an enemy?"
,"3":"O evil intention! From where have you sprung, to cover the earth with deceit?,One kind of comrade takes advantage of his friend's good fortune; in time of trouble he turns against him. "
,"5":"Another kind shares his friend's suffering, for the sake of a meal; when it comes to a fight, he thinks only of saving himself."
,"6":"Do not neglect a friend or forget him once you are wealthy."
,"7":"All advisers give advice but some seek only their own gain."
,"8":"Distrust the person who offers advice, lest he take advantage of you; first of all, ask yourself what he lacks, and what his own interest suggests to him."
,"9":"Perhaps he says to you, 'You are on the right road,' while he keeps his distance, to see what happens to you."
,"10":"Do not seek advice from one who looks at you suspiciously; hide your plans from those who envy you."
,"11":"Do not consult a woman about her rival, or a coward about war, or a merchant about exchange rates, or a buyer about selling, or a jealous man about gratitude, or a selfish person about generosity, or an idler about any kind of work, or a casual worker about finishing a job, or a lazy servant about an important task. Do not rely on these people for any advice."
,"12":"But go to a trustworthy man whom you know to be a keeper of the commandments, whose soul reflects your own and who will suffer with you, if you fail."
,"13":"In the end, keep to your own heart's advice, since no one deserves to be trusted more than your heart."
,"14":"For a man's soul often gives better advice than seven watchmen placed on a height."
,"15":"Besides all this, implore the Almighty to guide your steps in the truth."
,"16":"A plan must be at the beginning of all work; reflection comes before every action."
,"17":"When you decide, four ways are open before you:"
,"18":"good, evil, life and death. Your own decision makes the choice."
,"19":"A clever man may teach many but do no good for himself."
,"20":"A man may be wise, but if his words are rejected he will end up starving,"
,"21":"not having won the favor of the Lord and being destitute of all wisdom."
,"22":"Another man is wise for himself. He himself takes advantage of his wisdom."
,"23":"The truly wise man teaches his people, and they benefit by his knowledge."
,"24":"The wise man is full of blessings; those who see him call him happy."
,"25":"Man's days are numbered but Israel's days are countless."
,"26":"The wise man will win the confidence of his people; his name will live forever."
,"27":"My son, test yourself during the course of your life; see what is harmful and avoid it."
,"28":"For everything does not suit everybody, nor is everyone satisfied with all things."
,"29":"Do not be insatiable in every pleasure, or be excessive in what you eat;"
,"30":"for overeating leads to sickness and gluttony brings indigestion."
,"31":"Many have died because of gluttony; he who takes care prolongs his life."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Give due honor to the doctor, for you need him and God himself established him."
,"2":"Healing, in fact, comes from the Most High; the gift of healing comes from the Sovereign."
,"3":"The doctor's expertise gives him prestige and wins for him the admiration of the powerful."
,"4":"The Lord created the medicinal herbs which grow on the earth, and these a sensible person will not despise."
,"5":"Remember that he used a simple wooden rod to purify water and so make known his power to everyone."
,"6":"It is he who gives knowledge to men so that his power be glorified;"
,"7":"the doctor uses it to heal and comfort, the chemist to make his mixtures."
,"8":"In that way the Lord's work never ceases and well-being prevails on the earth."
,"9":"My son, when you are sick do not be anxious; pray to the Lord to heal you."
,"10":"Give up bad habits, keep your hands unsoiled, and purify your heart from all sin."
,"11":"Offer incense and a memorial gift of fine flour and rich offerings according to your means."
,"12":"Then consult the doctor; remember that he was established by the Lord, so do not disregard him - you need him."
,"13":"There are cases when good health depends on doctors."
,"14":"They, too, will pray to the Most High to grant them success in healing in order to save life."
,"15":"May he who sins before his Maker, fall into the hands of the doctor!"
,"16":"My son, weep for the dead, lament to express your sorrow and bury the dead with fitting ceremony, and do not fail to honor his tomb."
,"17":"Weep bitterly, cry out with full voice, and observe the period of mourning in accordance with the merits of the deceased. Let it be for one or two days, and so avoid criticism, and then be consoled in your grief."
,"18":"For sorrow may lead to death and a dejected heart loses its vitality."
,"19":"Let your affliction cease with the funeral; a life of sorrow is intolerable."
,"20":"Do not let your heart give way to grief; bear up and think of your own end."
,"21":"Remember! There is no coming back, you do the dead no good, but rather harm yourself."
,"22":"Keep in mind my sentence which will be yours as well: mine yesterday, yours today!"
,"23":"When the dead person is at rest, let his memory be one of peace; be comforted on his account once his spirit has departed."
,"24":"A law student acquires wisdom during his leisure hours; free from business he is capable of becoming wise."
,"25":"How can the man who guides a plow become wise, he whose pride lies in snapping a whip and driving a bullock, who works continually and talks of nothing but cattle?"
,"26":"His heart is set on plowing furrows and all his attention is given to fattening heifers."
,"27":"It is the same for all craftsmen and skilled workers who toil day and night, professional engravers and designers of seals. All are intent on creating different designs and reproducing the model, and they work even at night in order to succeed."
,"28":"So, too, is the smith standing beside the anvil intent on forging iron; his face is scorched by flames from the fire and he struggles in the heat of the furnace; the clang of the hammer is deafening; his eyes are fixed on the model to be copied, he makes every effort to work well and spends time at night in bringing his task to perfection."
,"29":"It is the same for the potter seated at his work, his foot turning the wheel, always concentrating on what he is molding, every movement purposefully controlled."
,"30":"His arm kneads the clay, his feet make it pliable. All his attention is needed in applying the glaze and at night he sees to the cleaning of the furnace."
,"31":"All these craftsmen depend on their hands for gaining skill in their different crafts."
,"32":"Without them a city could not be built; no settlers or travelers would come to it."
,"33":"But they are not to be found in the councils of people, nor do their words carry weight in an assembly. They do not occupy the judge's seat and they are not familiar with the Law."
,"34":"They are not cultured people or skilled in judgment and they are not found among authors of proverbs. They uphold creation and civilization, and their prayer is in their life's work."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Quite different is it with the person who spends his life reflecting on the Law of the Most High. He examines the wisdom of the sages in times past and in his free time he studies prophecies."
,"2":"He keeps in mind what men of renown have said and penetrates the mystery of parables."
,"3":"He searches for the inner meaning of proverbs and is interested in the secret of parables."
,"4":"He is at the service of great men and is seen in the company of leaders. He travels in foreign lands and has experience of both the good and the evil in mankind."
,"5":"Early in the morning his heart is set on turning to the Lord, his Maker, and raising his being to the Most High. He opens his mouth in prayer and makes supplication because of his sins."
,"6":"If such is the will of the great Lord he will be filled with the spirit of discernment. He will then speak words of wisdom and celebrate the Lord in prayer."
,"7":"He will acquire just judgment and knowledge and reflect on the Lord's hidden mysteries."
,"8":"In his teaching he discloses what he has learned and glories in the law of the Lord's covenant."
,"9":"Many people praise his discernment and never will he be forgotten. His memory will not fade and his name will live on from generation to generation."
,"10":"Nations will proclaim his wisdom and the assembly will celebrate his praise."
,"11":"As long as he lives his name will be more glorious than a thousand others, and when he dies that fame will be enough."
,"12":"I wish to share still more of my reflections; I am filled with them just as the moon is said to be full."
,"13":"Hear me, devoted people, and grow as a rose planted near a stream."
,"14":"Spread fragrance around you like incense; blossom and perfume the air like a lily; sing a hymn and bless Yahweh for all his works."
,"15":"Magnify his Name and proclaim his praise with song and lyre, expressing this with thanksgiving."
,"16":"How magnificent are the works of the Lord! All his commands are appropriately timed and satisfy every need. No one should say: 'What is this? Why is that?' All must be studied in its time."
,"17":"At his word the waters ceased to flow and piled up, his voice caused the reservoir of water to open;"
,"18":"at his order his every wish is fulfilled, and no one hinders his work of salvation."
,"19":"The deeds of every man are before him, nothing is hidden from his eyes;"
,"20":"he sees all from eternity to eternity and nothing surprises him."
,"21":"No one must say: 'What is that? Why is it so?' for everything is created for a purpose."
,"22":"His blessing covers all things and like a river drenches the land as in a flood."
,"23":"Similarly he may pour out his wrath on the nations, just as he has turned fresh water into salt."
,"24":"If his ways are smooth for holy people they are full of obstacles for the wicked."
,"25":"From the beginning, good things have been created for the good and likewise evil things for the wicked."
,"26":"Most necessary for man's life are water, fire, iron and salt, wheaten flour, milk, honey, the juice of the grape, oil and clothing."
,"27":"All these are good for those who are good, but for sinners they become evil."
,"28":"Certain winds are created as a means of punishment and in their fury they are a scourge, unleashing their violence in the time of destruction and satisfying the wrath of their Creator."
,"29":"Fire, hail, famine and death have all been created for punishment."
,"30":"The fangs of wild beasts, scorpions, vipers and the avenging sword for the destruction of the wicked,"
,"31":"all joyfully carry out his commands, all are ready when need arises and at a given moment they will not fail to obey his word."
,"32":"For that reason I reflected and from the beginning I decided to write:"
,"33":"All the works of the Lord are good and he will satisfy every need in due time."
,"34":"You must not say: This is less good than that, for in its time everything will serve a purpose."
,"35":"So now, with all your heart and in full voice, sing and bless the Name of the Lord."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Painful is the lot of all men, a heavy yoke is upon the sons of Adam from the day they leave their mother's womb to the day they return to the mother of us all."
,"2":"What is on their mind, what they fear in their heart, is the day of their death."
,"3":"From the king, glorious on his throne, robed in purple and wearing a crown,"
,"4":"to the lowliest person sitting in dust and ashes and covered with sackcloth, there is anger, envy, trouble and unrest, fear of death, rivalry and quarrels."
,"5":"And at night when we lie down we have fresh worries:"
,"6":"scarcely are we at rest and asleep when we are troubled by dreams as vivid as if it were day and we were fleeing from a battle."
,"7":"When it is time to wake up, we feel surprised to find that there is nothing to fear."
,"8":"This is the fate of every living creature, man and beast, but for sinners it is seven times worse,"
,"9":"in death, bloodshed, strife, sword, misfortune, famine, affliction and calamity."
,"10":"All these were created for the wicked, and the flood as well was sent on their account."
,"11":"Everything that comes from the earth goes back to the earth, and what comes from the waters returns to the sea."
,"12":"All bribery, all injustice will disappear but good faith will last forever."
,"13":"The unjust riches will vanish like a stream that dries up; they will crash like a clap of thunder during a downpour."
,"14":"A generous man has reason to rejoice, whereas sinners go to their ruin."
,"15":"The children of the ungodly will not be blessed with large families; they are like plants taking root on sheer rock,"
,"16":"like reeds in water and along the river bank, withering sooner than other plants."
,"17":"Kindness is like a garden of blessings and charity endures forever."
,"18":"Life is pleasant both for an independent person and a self-reliant worker, but still better off is the one who finds a treasure."
,"19":"The name of a man who has children or who has established a town will live on, but to have found wisdom is a greater good. Owning cattle and plantations brings fame, but a perfect wife is a richer blessing."
,"20":"Wine and music gladden the heart, but better still is the love of wisdom."
,"21":"The flute and harp make fine music, but even more appreciated is a pleasant voice."
,"22":"Gracefulness and beauty delight the eye, but not as much as the fresh growth of fields."
,"23":"It is always good for friends and companions to meet, better still for husband and wife."
,"24":"Brothers and protectors are useful in hard times, but it will be of greater help to have been a giver of alms."
,"25":"Gold and silver make for security but good advice is better."
,"26":"Wealth and strength give confidence, but good counsel is more esteemed than either. You cannot suffer loss when you fear the Lord, with it you have all the support you need."
,"27":"The fear of the Lord is like a garden of blessings; it clothes a person better than any glory."
,"28":"My son, do not live the life of a beggar; it would be better to die than to beg."
,"29":"When a man is always eyeing another's table, it cannot be said that he is really living, for he is defiling himself with another's food; an intelligent and educated man will avoid this."
,"30":"That for which a shameless man begs may seem sweet to his mouth but his inner being is burning."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Death! What a bitter thought for someone who lives happily among his possessions, a prosperous and successful man who is still able to enjoy his food!"
,"2":"Your sentence, Death, is welcome to a needy person whose strength is failing, who is old, worn out, and full of worries; to one who is angry and without hope!"
,"3":"Do not be afraid of Death's sentence; think of those who have gone before you and those who will follow."
,"4":"The Lord has decreed it for every living creature; why should you rebel against the good pleasure of the Most High?,Whether you live for ten, a hundred or a thousand years, no one in the netherworld is concerned."
,"5":"Abominable people, such are the children of sinners who gather in the houses of the ungodly."
,"6":"The inheritance of the sons of sinners will perish; their prosperity will be a lasting reproach."
,"7":"An ungodly father will be insulted by his children, for they hold him responsible for their disgrace."
,"8":"Woe to you, wicked people who have forsaken the law of the Most High!"
,"9":"At birth you are born to be cursed and you will be cursed at death."
,"10":"All that comes from the earth returns to the earth, and the ungodly go from curse to ruin."
,"11":"People grieve because their bodies will perish, but even the evil names of sinners will be blotted out."
,"12":"Have regard for your reputation, for it will live on, of greater value than a thousand hoards of gold."
,"13":"Few perhaps are the days of the just man's life but an honored name endures forever."
,"14":"My children, keep my teaching and live in peace. Of what use is hidden wisdom and unseen treasure?"
,"15":"It is better for a man to hide his foolishness than to hide his wisdom."
,"16":"Therefore, feel shame according to what I say. It is not always fitting to feel shame, but this is not understood by everyone."
,"17":"Be ashamed of licentiousness before your father and mother, and of a lie before a ruler or an important person."
,"18":"Be ashamed of criminal behavior before a judge, and of iniquity before an assembly of people."
,"19":"Feel ashamed of dishonesty before your partner or friend, and of a theft in the place where you live."
,"20":"Be ashamed before the truth of God and his covenant. Be ashamed of keeping the loaves for yourself,"
,"21":"of being unable to give and to receive, of not returning a greeting,"
,"22":"of staring at a prostitute, of rejecting a compatriot,"
,"23":"of depriving someone of what is his, of gazing at another man's wife,"
,"24":"of being too familiar with your maidservant - keep away from her bed!"
,"25":"of insulting words to a friend -,do not follow up a gift with a reproach!"
,"26":"of repeating what you have heard and betraying secrets."
,"27":"On these occasions feel genuine shame and you will be respected by all."
}`)
	CurrentBook.AddChapter(42, `{
"1":"But do not let yourself be led astray by any of the things that follow."
,"2":"Do not be ashamed,of the law of the Most High and his covenant, of judging even the wicked fairly,"
,"3":"of keeping accounts with a traveling companion, and of sharing your inheritance with friends,"
,"4":"of checking weights and scales,"
,"5":"of making a profit whether small or great, of bargaining with traders, and of being strict with children, of severe corporal punishment for a servant who deserves it."
,"6":"With a prying wife or when many people are around, it is wise to make use of seal and lock!"
,"7":"For deposits it is essential to reckon by number and weight and keep a written record of what you give and receive."
,"8":"Do not be ashamed of correcting someone who is foolish or stupid or an old man who has become childish. Doing that, you prove that you are a well-educated person and you will be generally respected."
,"9":"A daughter causes her father hidden worries; anxiety on her account keeps him awake: Is she young? She may not marry. Is she married? She may be disliked;"
,"10":"Is she a virgin? She may be seduced and become pregnant in her father's house!,Is she married? She may be unfaithful or unable to have children!"
,"11":"Your daughter is unruly? Watch her well, or she may make you a laughingstock to your enemies, the talk of the town and a public disgrace."
,"12":"Do not be taken by human beauty and do not sit down in the company of women;"
,"13":"for just as a moth comes out of a garment, woman's wickedness comes out of a woman."
,"14":"Better a man's wickedness than a woman's kindness; women bring shame and disgrace."
,"15":"Now I Shall remind you of the works of The Lord and relate what I have seen. The Lord's works depend on his word, and creation obeys his will."
,"16":"The sun shines on everything and the work of the Lord is filled with his glory."
,"17":"Not even to his holy ones has the Lord given full knowledge of all his marvelous works. The Lord, Master of the universe, has ordained that all should stand firm in his glory."
,"18":"He penetrates both the depth of the abyss and the human heart and knows their secrets. For the Most High has full knowledge and ordains the signs of the heavens."
,"19":"He knows the past and foretells the future and reveals the traces of the world's mysteries."
,"20":"No thought escapes him, no word is hidden from him."
,"21":"He has ordered the marvelous works of his wisdom, from ever and for ever. Nothing can be added, nothing can be taken away and he has no need of counsel."
,"22":"All his works are beautiful, even to the smallest spark of light."
,"23":"All this lives and endures forever: all is useful and obedient to his will."
,"24":"All things are in pairs, one opposite the other, and nothing he makes is in any way deficient."
,"25":"One thing emphasizes the excellence of the other; who could ever weary of admiring his glory?"
}`)
	CurrentBook.AddChapter(43, `{
"1":"The pride of the heights above is the clear firmament. How glorious is the spectacle of the heavens!"
,"2":"When the sun rises and appears, it proclaims: 'I am your marvelous work, Most High!'"
,"3":"At noon, it dries up the land; who can bear its burning heat?"
,"4":"You may stoke a furnace to produce heat, but three times greater is the heat of the sun burning the mountains, and sending out fiery vapors, blinding the eyes with its rays."
,"5":"How great is the Lord who made it and whose word directs its rapid course!"
,"6":"He also made the moon, exact in marking the months and the passage of time."
,"7":"With its full light gradually decreasing, the moon determines and rules over the feast days."
,"8":"The month also takes its name from the moon. How marvelously does it increase in its phases, providing a signal for the heavenly hosts, brightly shining in the expanse of the sky!"
,"9":"The bright radiance of the stars accounts for the beauty of the sky. What a brilliant ornament they are for the heights of the Lord!"
,"10":"At the command of the All Holy they stand as appointed and never fail to keep watch."
,"11":"Look at the rainbow and praise the One who made it. How magnificent it is in splendor!"
,"12":"It forms a circle of glory in the sky, a bow that is bent by the hands of its Maker."
,"13":"At his order the snow falls and lightning strikes according to his decrees."
,"14":"The storerooms of heaven are opened and clouds fly away like birds."
,"15":"It is his power that thickens the clouds, making them freeze and break into hailstones."
,"16a":"He has only to look and the mountains are shaken;"
,"17a":"the voice of his thunder terrifies the earth."
,"16b":"At his will the south wind blows,"
,"17b":"as do cyclones and hurricanes from the north."
,"18":"The snow flutters down like birds and alights on the ground like locusts. The eye marvels at the beauty of its whiteness and the mind is amazed to see it fall."
,"19":"He sprinkles frost on the earth like salt; it freezes and becomes like thorny spikes."
,"20":"The cold north wind blows and turns the water into ice. Ice forms on all stagnant water giving it a freezing coat of armor."
,"21":"He wears down the mountains and scorches the desert, withering the green grass as if by fire."
,"22":"A mist is a timely remedy, and dew after the heat restores it all to life."
,"23":"According to his plan he stilled the great deep and planted islands in it."
,"24":"Those who cross the seas tell of its dangers, and we listen in astonishment to what they relate:"
,"25":"It is all about strange and marvelous adventures with marine animals and monsters of all kinds."
,"26":"Thanks be to God, all turns out well and everything is held together by his word."
,"27":"We shall not give further examples; one last word: He is everything."
,"28":"Where shall we find the strength to glorify him? For he is the Mighty One, greater than all his works."
,"29":"The Lord is awesome and sovereignly great, and admirable in his power."
,"30":"Let your praise exalt the Lord as best you can, he is greater than you could even express. Honor him with all your strength and do not tire, for you can never praise him enough."
,"31":"Who has seen him and can describe what he has seen? Who can glorify him as he merits?"
,"32":"Many mysteries greater than these still remain, for we have only seen a fraction of his works. The Lord has created all things and to upright men he has given wisdom."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Let us now glorify illustrious men, the ancestors of our people."
,"2":"The Lord gave them great glory according to his own greatness from the beginning."
,"3":"Some ruled kingdoms and were renowned for their achievements, others were wise and able to counsel, or spoke as prophets."
,"4":"They led the people with their warnings or with their knowledge of the popular writings."
,"5":"Some cultivated music and poetry,"
,"6":"others were rich and powerful men living peacefully in their homes."
,"7":"All were highly respected in their days and honored by the people they lived with."
,"8":"The names of some lived on and people still praise them today;"
,"9":"others are not remembered and have disappeared as if they never existed. It is the same for their children."
,"10":"But now consider the godly men whose good deeds have not been forgotten."
,"11":"Those who came after them benefited from the rich legacy they left;"
,"12":"their race remained faithful to the Covenant, their children followed their example."
,"13":"Their family will endure forever and never will its glory be tarnished."
,"14":"Their bodies were buried in peace but their memory lives through generations."
,"15":"Peoples will speak of their wisdom and the assembly will celebrate their praise."
,"16":"Enoch pleased the Lord and was taken up, calling future generations to repentance."
,"17":"Noah was found to be perfectly just; at the time of divine anger he was the ransom; through him a remnant was left on earth after the flood."
,"18":"Eternal covenants were made with him to ensure that never again would life be destroyed by flood."
,"19":"No one has been found to equal Abraham in glory, the great ancestor of many nations."
,"20":"He was faithful to the Law of the Most High who made a covenant with him, a covenant that was marked on his flesh, and on the day he was tested he was found faithful."
,"21":"That is why God promised by oath to bless all the nations through his descendants, that he would make them as numerous as the dust of the earth and exalt his posterity like the stars. He promised that their land would stretch from sea to sea, from the River to the ends of the earth."
,"22":"The Lord renewed his Covenant with Isaac for the sake of his father, Abraham."
,"23":"This Covenant and the blessing of all mankind he made to rest on the head of Jacob. He assured Jacob of his blessing, giving him the land that would be his and determining the portions to be shared among the twelve tribes."
}`)
	CurrentBook.AddChapter(45, `{
"1":"From Jacob's descendants the Lord brought forth an upright man who won the favor of everyone and was loved by God and men - Moses. Blessed be his memory!"
,"2":"The Lord gave him glory equal to his holy angels and power that terrified his enemies."
,"3":"At Moses' word he halted disaster; the Lord exalted him in the presence of kings. He gave him commandments for his people and let him glimpse something of his glory."
,"4":"He chose him from among the living to become holy by being faithful and humble."
,"5":"God let him hear his voice and led him into darkness, where face to face he gave him the commandments, the law of life and knowledge, to teach Jacob the covenant and make his decrees known to Israel."
,"6":"He raised up Aaron, the brother of Moses, a holy man like Moses, of the tribe of Levi."
,"7":"He made an eternal covenant with him and conferred on him the priesthood of the people. He honored him by giving him majesty and putting a glorious robe upon him. "
,"8":"His vestments and ornaments were splendid in their perfection - breeches, cloak and ephod."
,"9":"As a fringe to his vestment he gave him pomegranates and many golden bells to tinkle as he walked and to be heard in the Temple as a reminder to the sons of his people."
,"10":"The Lord gave Aaron sacred vestments of gold, blue and purple, the work of artists, the pectoral of judgment, the Urim and Thummim, scarlet yarn spun by a craftsman,"
,"11":"precious stones with engravings in a setting of gold, the work of a jeweler, to serve as a memorial with their graven inscriptions of the tribes of Israel."
,"12":"He gave him the turban with a golden diadem engraved with the words of his consecration, a superb ornament, expertly crafted and a delight to the eyes."
,"13":"Such things had never been seen before Aaron's time; no outsider ever put them on or ever will, only his children and descendants."
,"14":"His sacrifices were to be completely burned twice daily, in perpetuity."
,"15":"It was Moses who consecrated him and anointed him with holy oil. It was for him an eternal covenant and for his descendants, for as long as the heavens would last, to serve the Lord as his priests and bless the people in his name."
,"16":"He chose him from among all the living to offer sacrifice to the Lord and sweet smelling incense as a memorial, to make atonement for the people."
,"17":"The Lord gave him authority to interpret his commandments and utter decisions, to teach Jacob the divine words and enlighten Israel with his Law."
,"18":"Outsiders conspired against him and were jealous of him in the desert - Dathan, Abiram and their followers and the supporters of Korah, all violent men full of hate."
,"19":"The Lord saw it and was angry; in his wrath he destroyed them. He wrought wonders against them, consuming them in the flames of fire."
,"20":"He increased Aaron's glory by giving him a heritage. He allotted to him the first fruits and to begin with, bread in abundance."
,"21":"For their food is the sacrifice offered to the Lord, which he gave to Aaron and his descendants."
,"22":"But he was to inherit no land as patrimony, no special portion was to be his own, for the Lord himself is his portion and inheritance."
,"23":"As for Phinehas, son of Eleazar, he is the third in glory, for he was full of zeal in the fear of the Lord when he stood firm among a rebellious people with noble courage and made atonement for Israel."
,"24":"Consequently, a covenant of peace was concluded with him, making him the leader of the sanctuary and of his people. He and his descendants were to have the dignity of high priesthood forever."
,"25":"It is not like the covenant established with David, the son of Jesse, of the tribe of Judah, for the kingship passes only from father to one of his sons, but the heritage of Aaron passes to all his descendants."
,"26":"May the Lord give them wisdom of heart to judge his people with justice, so that their prosperity may not dwindle and their glory may live on in their descendants!"
}`)
	CurrentBook.AddChapter(46, `{
"1":"Joshua, son of Nun, was a valiant arrior and as a prophet he was the successor of Moses. He lived up to his name, proving himself to be a savior of God's chosen people, punishing the enemies that attacked them and leading Israel to claim their land."
,"2":"How magnificent to see him, arm raised and with sword ready to attack the cities!"
,"3":"Who before him had such staying power? He was, indeed, Yahweh's warrior."
,"4":"Was it not he who held back the sun, making one day as long as two?"
,"5":"He called on the Most High when the enemy pressed on every side, and the Mighty Lord responded with hailstones of exceptional size."
,"6":"He attacked the enemy nation and destroyed the assailants at the pass of Beth-horan, so that the nations might know the strength of Joshua and that they were fighting against the Lord."
,"7":"Joshua was loyal and devoted to the Almighty in the time of Moses, he and Caleb, son of Jephunneh. They stood firm against the assembly and tried to keep them from sinning by silencing their wicked murmuring."
,"8":"Because of this, they were the only two spared out of six hundred thousand people on foot. And they took possession of their inheritance in a land flowing with milk and honey."
,"9":"The Lord gifted Caleb with strength; this he enjoyed to the end of his days, and he went into the hill country that was given to his children in heritage."
,"10":"With this it was clear to all Israel that it is good to follow the Lord."
,"11":"After that came the judges. Although each of them won his own renown, all were men of faithful heart who did not turn away from the Lord. Blessed be their memory!"
,"12":"May their bones spring to life from the tomb and the names of these illustrious men live on in their children!"
,"13":"Samuel was a prophet and beloved of the Lord. He established the kingdom and anointed rulers to govern his people."
,"14":"He judged the assembly according to the Law of the Lord and the Lord protected Jacob."
,"15":"He was accepted as prophet because of his faithfulness, and proved that his words were of a trustworthy seer."
,"16":"He called on the Almighty Lord when the enemy pressed from all directions and he offered a sucking lamb."
,"17":"Then with a mighty roar the Lord thundered from heaven"
,"18":"and destroyed all the enemy's leaders and the tyrants of Philistia."
,"19":"Before his time came for eternal rest, Samuel called men to witness before the Lord and his anointed: 'I have not taken anyone's belongings, not even his sandals,' and there was no one to accuse him."
,"20":"Even after he died, he prophesied and revealed to the king his death. From the grave he spoke as a prophet to blot out the wickedness of his people."
}`)
	CurrentBook.AddChapter(47, `{
"1":"After him the Lord raised Nathan to prophesy in the time of David."
,"2":"As fat is selected from the peace offering, so David was chosen from among the Israelites."
,"3":"He played with lions and bears as if they were lambs or young goats."
,"4":"He was still young when he slew a giant to restore the honor of his people; with a sling he aimed a stone that killed the arrogant Goliath."
,"5":"He invoked the Lord Most High, who gave him strength to slay a mighty warrior, and so exalt the power of his people."
,"6":"So they glorified him for his ten thousands and praised him as a blessing from the Lord when he was chosen king."
,"7":"For he wiped out his enemies on all sides and annihilated his adversaries, the Philistines, crushing their power forever."
,"8":"In all that he did he gave thanks to the Most High, and showed his love for his Maker by singing with all his heart."
,"9":"He placed singers accompanied by harps before the altar to make beautiful music;"
,"10":"he gave splendor to feasts and even greater magnificence to the more solemn occasions, exalting the holy Name of the Lord and having the sanctuary ring with his praises from early morning."
,"11":"The Lord forgave David's sins and established his power forever; he made a covenant with him for the benefit of the kings and gave him a glorious throne in Israel."
,"12":"A wise son succeeded him and fared well because of him."
,"13":"Solomon reigned during times of peace, and God gave him rest from war to enable him to build a house for his Name, a sanctuary that would stand forever."
,"14":"How wise you were in your youth, Solomon! as full of understanding as a river."
,"15":"Your spirit covered the earth, you filled it with proverbs and parables."
,"16":"Your reputation reached distant islands and you were loved for your peace."
,"17":"Your songs, proverbs, parables and interpretation drew the admiration of the world."
,"18":"In the name of the Lord God, called the God of Israel, you accumulated gold like tin and gathered silver like lead."
,"19":"But you gave your body to women and became the slave of your senses;"
,"20":"you stained your reputation and defiled your descendants, bringing wrath and disaster upon your children because of your foolishness."
,"21":"So the nation was divided; from Ephraim came a kingdom in revolt."
,"22":"But God's mercy never fails nor does he forget his promises; he did not deprive his chosen one of descendants nor destroy the race of the one he loved. So to Jacob he gave a remnant and allowed David's family to survive."
,"23":"Solomon rested with his forefathers and left one of his sons to rule after him, the most foolish of men and without intelligence; this was Rehoboam who drove the people to rebellion."
,"24":"As for Jeroboam, son of Nebat, it was he who caused Israel to sin and taught Ephraim the way of evil. From then on their sins increased and later brought about their exile, "
,"25":"for they were intent on doing every sort of evil until vengeance fell on them."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Then came the prophet Elijah like a fire, his words a burning torch."
,"2":"He brought a famine on the people and in his zealous love had them reduced in number."
,"3":"Speaking in the name of the Lord he closed the heavens, and on three occasions called down fire."
,"4":"How marvelous you were, Elijah, in your wondrous deeds! Who could ever boast of being your equal?"
,"5":"By the word of the Most High you brought a dead man back to life;"
,"6":"you brought kings to destruction and thrust famous men from their beds."
,"7":"You heard a rebuke at Sinai and sentences of punishment at Horeb;"
,"8":"you anointed kings to be avengers and prophets to succeed you."
,"9":"You were taken up by a whirlwind of flames in a chariot drawn by fiery horses."
,"10":"It was written that you should be the one to calm God's anger in the future before it broke out in fury, to turn the hearts of fathers to their sons and to restore the tribes of Jacob."
,"11":"Happy are those who will see you and those who die in love, for we too shall live."
,"12":"Such was Elijah, taken up in a whirlwind, and Elisha was filled with his spirit. During his life no leader could shake him, no one dominated him. "
,"13":"Nothing was too difficult for him and even in death his body prophesied."
,"14":"In life he worked wonders, in death his deeds were amazing."
,"15":"Despite all this, the people were not converted and did not turn away from sin; not until they were deported far from their country and scattered over the earth."
,"16":"The people were greatly reduced in number but they still had a ruler from the line of David. Some of them were upright people, others became sinful."
,"17":"Hezekiah fortified his city and brought water within its walls, tunneling the rock with iron tools to construct cisterns."
,"18":"During his reign Sennacherib began his campaigns and sent off Rabshakeh, and insolent and arrogant as he was, he raised his arm against Zion."
,"19":"Then their courage was shaken, their hands trembled, they felt anguish like women in labor."
,"20":"They stretched out their hands and called on the merciful Lord. From heaven the Holy One quickly heard them and saved them by the hand of Isaiah. "
,"21":"The Lord struck the Assyrian camp and his angel wiped them out."
,"22":"For Hezekiah did what was pleasing to the Lord and was firm in following the ways of David, his father, as the great and faithful prophet Isaiah ordered, a man of trustworthy vision."
,"23":"In his time the sun went back and he lengthened the life of the king."
,"24":"In the power of the spirit he foresaw the last things and consoled the afflicted people of Zion."
,"25":"He revealed what would happen until the end of time and made hidden events known before they occurred."
}`)
	CurrentBook.AddChapter(49, `{
"1":"The memory of Josiah is like blended incense carefully prepared by the perfumer; it is like delicious honey to every mouth, like music during a banquet."
,"2":"He followed the right way in converting the people and removing the horror of idolatry."
,"3":"He set his heart on the Lord and succeeded in having godliness prevail over wickedness."
,"4":"With the exception of David, Hezekiah and Josiah, the kings were very sinful men. they abandoned the Law of the Most High bringing an end to the kings of Judah."
,"5":"They surrendered their power and their honor to foreign nations."
,"6":"Their enemies set fire to the holy city, making its streets desolate"
,"7":"as Jeremiah had foretold."
,"8":"It was Ezekiel who saw the vision of Glory when the Lord showed it to him above the chariot of the cherubim."
,"9":"He also remembered Job, the one who always followed the way of justice."
,"10":"As for the twelve prophets, may their bones spring to life from the tomb, for they comforted the people of Jacob and saved them with confident hope."
,"11":"Can we ever adequately praise Zerubbabel who was like a ring at the finger of God, and"
,"12":"likewise Joshua, son of Jozadak? They were men who, in their days, built the Temple to the Lord, a sanctuary destined for everlasting glory."
,"13":"Lasting too is the memory of Nehemiah, who rebuilt our ruined walls, provided gates and bars and rebuilt our homes."
,"14":"No one on earth was created to equal Enoch for he was taken up from the earth."
,"15":"And never was there a man like Joseph, the greatest among his brothers, the leader of his people; his bones were honored."
,"16":"Shem and Seth were exalted among men, but Adam's glory was greater than any other living being."
}`)
	CurrentBook.AddChapter(50, `{
"1":"The High Priest Simon, son of Onias, repaired the sanctuary and fortified the Temple during his lifetime."
,"2":"He laid the foundations for the high double wall and for the fortifications surrounding the Temple."
,"3":"In his days a reservoir for water, a cistern as great as a sea, was excavated."
,"4":"Anxious lest his people might perish, he fortified the city against a siege."
,"5":"How magnificent he was when, surrounded by his people, he emerged from the inner sanctuary"
,"6":"like the morning star amidst the clouds, like the full moon,"
,"7":"like the sun shining on the Temple of the Most High or a rainbow in a glory of clouds!"
,"8":"He was like a rose in spring, a lily beside a stream, a green shoot on a summer day,"
,"9":"or incense burning in the censer. He could be likened to a massive, golden vase adorned with every kind of precious stone, "
,"10":"to an olive tree heavy with fruit, or to a cypress rising to the clouds,"
,"11":"when, robed in ceremonial garb and in perfect splendor, he went to the sacred altar filling the court of the sanctuary with glory."
,"12":"There he would receive from the hand of the priests the portions of the sacrifice, as he stood by the hearth of the altar encircled by his brethren like a young cedar on Lebanon."
,"13":"It was as if he was surrounded by palm trees when all the sons of Aaron in their splendor, with the offerings to the Lord in their hands, stood before the assembly of Israel."
,"14":"When he had completed the service at the altar and presented with dignity the offering to the Almighty and Most High,"
,"15":"he took the cup in his hand and poured out a libation of the juice of the grape at the foot of the altar, a pleasing aroma to the Most High, King of the world."
,"16":"Then the sons of Aaron shouted; they blew their trumpets of solid silver, making a great noise as a memorial before the Most high."
,"17":"Then suddenly all the people bowed down with their faces to the ground and adored the Lord, the Almighty and most High God."
,"18":"The choir as well sang his praises, making beautiful music."
,"19":"And the people made supplication to the Most High and prayed to their merciful Lord, until the ceremony was over and the service of the Lord completed."
,"20":"The High Priest then came down and raised his hands towards the whole assembly of the people of Israel to give them in a loud voice the blessing of the Lord and to have the honor of pronouncing his name."
,"21":"Then for a second time the people bowed in worship to receive the blessing of the Most High:"
,"22":"'And now, bless the Lord of the universe who everywhere does great things, who exalts our days from birth and is merciful to us."
,"23":"May he give us happiness and grant peace to Israel in our days and forever!"
,"24":"May he continue to give us his blessings and be a savior to us in our days.'"
,"25":"There are two nations I greatly dislike, the third is not a nation:"
,"26":"they are the inhabitants of Mount Seir, the Philistines and the foolish people who live in Shechem."
,"27":"Instruction in understanding and knowledge, that is what Jesus the son of Sira, the son of Eleazar of Jerusalem, has written in this book as he poured out the wisdom of his heart."
,"28":"Happy the one who pays attention to this teaching and gains wisdom by taking it to heart."
,"29":"Doing that, he will be strong in all circumstances, for the light of the Lord is his path."
}`)
	CurrentBook.AddChapter(51, `{
"1":"I will give thanks to you, O Lord and King; I praise you, my God and Savior, I give thanks to your Name."
,"2":"For you are my protector and helper, you have delivered my body from destruction, from the snare of the wicked tongue and from lips that speak lies. In the presence of those who stood against me, you were my helper, my deliverer."
,"3":"In the fullness of mercy and the glory of your Name, you delivered me from the teeth of those ready to devour me, from the hand of those wanting to take my life and from my many trials."
,"4":"You rescued me from choking fire on every side; you saved me from a fire I had not kindled."
,"5":"You delivered me from the depths of the netherworld, from an impure tongue and lying words,"
,"6":"from vicious slander reported to the king. I was near to death, I was already at the gates of the netherworld."
,"7":"They surrounded me on every side with no one to help me. I looked for human comfort and there was none."
,"8":"Then, Lord, I remembered your mercy and your deeds from all eternity, knowing that you deliver those who hope in you and save them from the hands of their enemies."
,"9":"I sent up my prayer from the earth, begging to be delivered from death."
,"10":"I called on the Lord, the Father of my Lord: 'Do not forsake me in the day of my affliction, when I am helpless against arrogant enemies; I will praise your name continually and sing to you my thanksgiving.'"
,"11":"And my prayer was heard, you saved me from destruction and delivered me from an evil plight."
,"12":"That is why I will give you thanks and praise and bless the Name of the Lord."
,"13":"In my youth, before I set out on my travels, I openly sought wisdom in prayer;"
,"14":"before the Temple I asked for her and I will pursue her to the end of my days."
,"15":"While she blossomed like a ripening cluster, my heart was delighted in her; my feet followed the right path, because from my youth I searched for her."
,"16":"As soon as I began listening to her she was given to me, and with her, much instruction."
,"17":"With her help I made progress and I will glorify him who gives me wisdom,"
,"18":"for I decided to put it into practice and ardently seek what is good. I shall not regret it."
,"19":"My soul has struggled to possess her. I have been attentive to observe the Law, and after my faults I have stretched out my hands to heaven and lamented my ignorance of her."
,"20":"My love of her increased and I found her in repentance. It was through her from the beginning that I learned to possess my heart. She will not forsake me."
,"21":"With my whole being I sought her; that is why I won what is best."
,"22":"In return for this, the Lord has given me words to praise him."
,"23":"come near, you who are without understanding and join her school."
,"24":"Why do you say you are deprived of all this and that your souls are thirsty?"
,"25":"This is what I say: Buy this without money;"
,"26":"put your neck under her yoke and let your minds receive instruction; it is very near and within your reach."
,"27":"See for yourselves: my toil has been slight and I found deep rest."
,"28":"Be instructed, whatever the cost, and you will gain what is better than gold."
,"29":"Let your soul find joy in the mercy of the Lord, and do not be ashamed to praise him."
,"30":"Do your work within the appointed time, and the Lord in his time will give you your reward."
}`)

}
func EN_CCB_LoadVSIBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Job, a blameless and upright man who feared God and shunned evil, once lived in the land of Uz."
,"2":"He had seven sons and three daughters."
,"3":"Owner of seven thousand sheep, three thousand camels, five hundred yoke of oxen, five hundred donkeys and a large number of servants, he was considered the greatest man among the people of the East."
,"4":"His sons used to take turns holding banquets in their homes and they would invite their three sisters to dine and drink with them."
,"5":"After each series of banquets, Job would send for his sons and daughters and have them purified. He would rise early in the morning, offer a holocaust for each of his children, thinking, 'Perhaps they have sinned and blasphemed God in their hearts.' This had been quite a routine for Job."
,"6":"One day the sons of God came to present themselves before Yahweh, and Satan came with them."
,"7":"Yahweh asked Satan, 'Where have you been?',Satan answered, 'Going up and down the earth, roaming about.'"
,"8":"Yahweh asked again, 'Have you noticed my servant Job? No one on earth is as blameless and upright as he, a man who fears God and avoids evil.'"
,"9":"But Satan returned the question, 'Does Job fear God for nothing?"
,"10":"Have you not built a protective wall around him and his family and all his possessions? You have blessed and prospered him, with his livestock all over the land."
,"11":"But stretch out your hand and strike where his riches are, and I bet he will curse you to your face.'"
,"12":"Yahweh said to Satan, 'Very well, all that he has is in your power. But do not lay a finger upon the man himself.' So Satan left the presence of Yahweh."
,"13":"One day, while his sons and daughters were feasting in the house of their eldest brother,"
,"14":"a messenger came to Job and said, 'Your oxen were plowing, and your donkeys were grazing nearby"
,"15":"when the Sabaeans came and carried them off. They killed the herdsmen. I alone escaped to tell you.'"
,"16":"While he was still speaking, another messenger came, 'God's fire fell from the sky and burned all your sheep and the shepherds as well. I alone have escaped to tell you.'"
,"17":"He had hardly finished speaking when another messenger arrived, 'Three raiding teams of Chaldeans have killed your servants and carried off your camels. I alone have escaped to tell you.'"
,"18":"He was still speaking when a third messenger came and said to Job, 'Your sons and daughters were eating and drinking in the house of their eldest brother"
,"19":"when suddenly a great wind blew across the desert and struck the house. It collapsed on the young people and they all died. I alone have escaped to tell you.'"
,"20":"In grief Job tore his clothes and shaved his head. Then he fell to the ground and worshiped,"
,"21":"saying, 'Naked I came from my mother's womb, naked shall I return. Yahweh gave, Yahweh has taken away. Blessed be his name!'"
,"22":"In spite of this calamity, Job did not sin by blaspheming God."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Once more the sons of God came to present themselves before Yahweh, and again Satan was with them."
,"2":"Yahweh asked Satan, 'Where have you been?',Satan answered, 'Going up and down the earth, roaming about.'"
,"3":"Yahweh asked again, 'Have you noticed my servant Job? No one on earth is as blameless and upright as he, a man who fears God and avoids evil. He still holds fast to his integrity even if you provoked me to ruin him without cause.'"
,"4":"Satan replied, 'Skin for skin! For his own life, anyone will give everything he owns."
,"5":"But lay your hand against his own flesh and bones and he will curse you to your face.'"
,"6":"Yahweh said to Satan, 'Very well, he is in your power. But spare his life.'"
,"7":"So Satan left the presence of Yahweh and afflicted Job with festering sores from the soles of his feet to the top of his head."
,"8":"Job took a potsherd to scrape himself and sat among the ashes."
,"9":"His wife said to him, 'Do you still hold on to your integrity? Curse God and die!'"
,"10":"Job replied, 'You talk foolishly. If we receive good things from God, why can't we accept evil from him?' In spite of this calamity, Job did not utter a sinful word."
,"11":"Three of Job's friends - Eliphaz the Temanite, Bildad the Shuhite, and Zophar the Naamathite - heard of the misfortune that came upon him. They set out from their own homes and journeyed together to offer their sympathy and consolation to Job."
,"12":"Failing to recognize him from the distance, they wept aloud, tore their garments and poured dust upon their heads."
,"13":"For seven days and seven nights, they sat on the ground beside him. They did not say a word to Job, for they saw how terribly he suffered."
}`)
	CurrentBook.AddChapter(3, `{
"1":"At length it was Job who spoke, cursing the day of his birth. This is what he said:"
,"3":"Cursed be the day I was born, and the night which whispered: A boy has been conceived."
,"4":"May that day be dark, may God on high ignore it. May no light shine upon it."
,"5":"May the shadow of death claim it as its own. May a cloud settle over it; may blackness obstruct its light."
,"6":"Let darkness swallow that night,let it not add to the rest of the year,let it not be included in the month."
,"7":"That night - oh, let it be barren, untouched by shouts of joy."
,"8":"Let it be cursed by those who hate the light, sorcerers who call on the Devil."
,"9":"Let its morning stars no longer shine; let it wait for light in vain,and never see the first rays of dawn,"
,"10":"since it did not close the womb,to keep my eyes from seeing doom."
,"11":"Why didn't I die at birth, or come from the womb without breath?"
,"12":"Why the knees that received me, why the breasts that suckled me?"
,"13":"For then I should have lain down,asleep and been at rest"
,"14":"with kings and rulers of the earth,who built for themselves lonely tombs;"
,"15":"or with princes who had gold to spare,and houses stuffed with silver."
,"16":"Why was I not stillborn, like others who did not see the light of morn?"
,"17":"There the trouble of the wicked ceases, there the weary find repose."
,"18":"There the prisoners are at ease; they no longer hear the taskmaster's voice."
,"19":"Great and small fare equally there, where the slave is free from his master."
,"20":"Why is light given to the miserable, and life to the embittered?"
,"21":"To those who long for death,more than for hidden treasure?"
,"22":"They rejoice at the sight of their end, they are happy upon reaching the grave."
,"23":"Why give light to a man whose path has vanished, whose ways God blocks at every side?"
,"24":"Instead of bread I feed on sighs. My groans are like water poured out."
,"25":"For what I fear has come upon me, what I dread has befallen me."
,"26":"I find no rest, I find no ease; only turmoil, nothing of peace!"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Eliphaz the Temanite spoke next:"
,"2":"Shall we speak? Do you mind?,For who could remain silent?"
,"3":"Remember how you have taught many others, how you have strengthened their feeble hands."
,"4":"Your words have supported those who wavered, have steadied the knees that faltered."
,"5":"But when your turn has come, you are discouraged; as soon as you are struck, you are dismayed."
,"6":"Should you not rely on your piety, and find assurance in your integrity?"
,"7":"Have you seen a guiltless man perish, or an upright man done away with?"
,"8":"As I see it, those who plow evil,or those who sow trouble reap the same."
,"9":"By the breath of God they are swept away; by the blast of his wrath they are destroyed."
,"10":"The lion may roar and growl; it will fall, the teeth of its cubs will be broken."
,"11":"The lion will die for lack of prey, and the whelps of its mate will stray."
,"12":"I had a secret revelation; a whisper of it reached my ear."
,"13":"Amid thoughts from night visions, when men are heavily wrapped in slumber,"
,"14":"I was seized with fear and trembling,that shook me to my very bones."
,"15":"A spirit passed over my face, and the hair of my body stood on end."
,"16":"It stopped and stood before my eyes, but I could not make out what it was. Silence... and then - a voice was heard:"
,"17":"'Can a mortal be just in the eyes of God?,Can a man be pure before his Maker?"
,"18":"If God can put no trust in his servants, if he can charge his angels with error,"
,"19":"how much more those who live in houses of clay, whose foundation is in the dust, who are crushed as easily as moths!"
,"20":"Between dawn and dusk they perish, and unheeded, vanish forever,"
,"21":"Their tent has been unpegged,and they died without knowing why."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Call then, but who will answer you?,Who of the Saints will you turn to?"
,"2":"Resentment kills the fool, and anger slays the simple."
,"3":"I have seen a fool taking root when suddenly his household collapsed."
,"4":"His sons went about without security, crushed in court without a defender."
,"5":"The hungry consumed his harvest,and carried it to a hiding place; his surplus was taken away, the thirsty hankered after his wealth."
,"6":"For affliction comes not from the earth, nor does sorrow sprout from the ground;"
,"7":"but it is man who carries about trouble, as an eagle in the heights brings down lightning flash."
,"8":"If I were you, I would appeal to God,and lay before him my case,"
,"9":"for wonders are past all reckoning, his miracles beyond all counting."
,"10":"He pours rain down on the earth,and sends water upon the fields."
,"11":"He sets the lowly on high, turns grief into joy."
,"12":"He wrecks the plans of the crafty, so that their hands achieve no success."
,"13":"He traps the clever in their devices,and puts an end to the schemes of the wily."
,"14":"Darkness comes upon them in the daytime; they grope at noon as in the night."
,"15":"He rescues the despoiled from the despoiler, the weak from the hands of the violent."
,"16":"Thus hope comes to the lowly, and injustice shuts its mouth."
,"17":"Blessed is the man whom God corrects; reject not, therefore, the lessons of the Almighty,"
,"18":"He cures the wounds he has inflicted; he strikes but he also heals."
,"19":"From six troubles he will rescue you; at the seventh no harm will touch you."
,"20":"In famine he saves you from death; in war, from the threat of the sword."
,"21":"You will be protected from the lash of the tongue, and have no dread of marauding bands."
,"22":"You will laugh at destruction and want; and have no fear of the wild animals."
,"23":"No more stones in your fields, the soil will serve you, and wild animals be at peace with you."
,"24":"You will find your tent secure, your household untouched when you come home."
,"25":"You will have children in plenty,and descendants like the grass of the hills."
,"26":"You will come to the grave in a ripe age, like a sheaf of grain gathered in season."
,"27":"This we have examined and found true. This we have heard, and you should know."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Job replied:"
,"2":"If only my anguish could be measured,and my misery put on the scales;"
,"3":"they would outweigh the sands of the seashore!,It is for this that I speak impetuously."
,"4":"Pierced by the arrows of the Almighty, my spirit absorbs their poison; my heart fails before the terrors of God."
,"5":"Does a wild ass bray when it has fodder?,Does an ox bellow when it has grass?"
,"6":"What taste would food have without salt?,What flavor is there in the white of an egg?"
,"7":"So everything is tasteless for me, I am bored with my bread."
,"8":"Would that I get my request, that God grant me what I want -"
,"9":"that he would decide to crush me, let loose his hand and strike me down!"
,"10":"Then this at least would comfort me, my only joy in merciless dread, that I have not cursed the will of the Holy one."
,"11":"Will I be able to go on hoping, what expectation to keep on waiting?"
,"12":"Have I the strength of stone, and is my flesh of bronze?"
,"13":"There is no one to help me, all aid has departed from me."
,"14":"Friends without compassion,made me lose the fear of the Almighty,"
,"15":"My brothers have been fickle, like the flowing of seasonal waters."
,"16":"They were but melted ice,running from under the snow."
,"17":"But summer comes and the river dries, under the blazing sun no water is left."
,"18":"Because of this caravans get lost, go to wastelands and perish."
,"19":"The merchants of Tema search for the brooks, the travelers of Sheba look for them."
,"20":"In vain they expected, they are frustrated on arriving there."
,"21":"Now you too are unable to help me; you see a horror and draw back in fear."
,"22":"Have I asked you to give me anything?,Did I say, 'Pay a ransom for me,"
,"23":"deliver me from the enemy,or rescue me from a tyrant?'"
,"24":"Teach me and I will keep silent; show me where I have been wrong."
,"25":"Honest words I must not resent, but what have your arguments shown?"
,"26":"Do you mean to scorn my words, or throw to the wind a cry of despair?"
,"27":"Would you cast lots for the orphan,and bargain over your friend?"
,"28":"But now, give me your attention; surely I will not lie to your face."
,"29":"Relent, and grant me justice; reconsider, my case is not yet tried."
,"30":"Is there insincerity on my tongue?,Have I misunderstood misery?"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Man's life on earth is a thankless jo his days are those of a mercenary."
,"2":"Like a slave he longs for the shade of evening, like a hireling waiting for his wages."
,"3":"Thus I am allotted months of boredom and nights of grief and misery."
,"4":"In bed I say, 'When shall the day break?',On rising, I think, 'When shall evening come?',and I toss restless till dawn."
,"5":"My body is full of worms and scabs; my skin festers with its boils and cracks."
,"6":"My days pass swifter than a weaver's shuttle, heading without hope to their end."
,"7":"My life is like wind, you well know it, O God; never will I see happiness again."
,"8":"The eye that saw me will see me no more; when you look for me, I shall have gone."
,"9":"As a cloud dissolves and vanishes, so he who goes to the grave never returns."
,"10":"He will never come back to his house; or be seen by his household."
,"11":"So I will not restrain my words, I will speak out in anguish; and complain with embittered soul,"
,"12":"'Am I the sea or a monster of the deep, that you keep me under watch?'"
,"13":"When I think my bed will comfort me,and my couch will soothe my pain,"
,"14":"then you frighten me with dreams,and terrify me with visions,"
,"15":"I would prefer death by strangling,rather than such a trial."
,"16":"See I am dying, never to live again. Leave me alone; I am finished."
,"17":"What is man that you make much of him, that you give him so much attention,"
,"18":"that every morning you examine him,and check him all the time?"
,"19":"Will you never take your eyes off me,and give me respite to swallow my spittle?"
,"20":"Suppose I sinned, what has it done to you, O keeper of mankind?,Why choose me as your target?,Have I become a burden to you?"
,"21":"Why not pardon my sin,and take away my guilt?,For in the dust I will soon lie down; when you search for me, I shall have gone."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Bildad the Shuhite spoke:"
,"2":"How long will you say such things?,Your words are long-winded blusterings."
,"3":"Does God pervert judgment?,Does the Almighty distort justice?"
,"4":"If your children did him wrong, he has made them pay for their sins."
,"5":"But if you will have recourse to God,and plead with the Almighty,"
,"6":"if you are faultless and righteous, even now he will care for you,and restore you to your rightful place."
,"7":"And your prosperity will be such,as to make you forget former times."
,"8":"Inquire of the past generations,and learn from their fathers' experience;"
,"9":"for born but yesterday, we know nothing,and our days on earth are but a shadow."
,"10":"They will correct and teach you,with words that come from the heart."
,"11":"Can papyrus thrive without marsh?,Can reeds flourish without water?"
,"12":"Even if still growing and uncut, they wither more quickly than any plant."
,"13":"Such is the end of him who forgets God; the hope of the godless man perishes."
,"14":"His trust is hanging by a thread; a spider's web is what he relies on."
,"15":"He leans on his house, but it does not stand; he clings to it, but it crumbles."
,"16":"He is sturdy under the sun, spreading its shoots in the garden,"
,"17":"its roots entwined around the rocks, holding fast to each stone."
,"18":"But when uprooted, the place rejects it: 'I have never known you.'"
,"19":"And there it lies rotting by the road, while other plants grow in its place."
,"20":"Indeed God does not reject the blameless, nor lend his hand to the evildoer."
,"21":"He will again fill your mouth with laughter,and your lips with joyful shouts."
,"22":"Your enemies will be confused, and the tent of the wicked will disappear."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Then Job answered:"
,"2":"Very well I know that it is so. But how can a mortal be just before God?"
,"3":"If one were to contend with him, not once in a thousand times would he answer."
,"4":"His power is vast, his wisdom profound. Who has resisted him and come out unharmed?"
,"5":"He moves mountains before they are aware; he overturns them in his rage."
,"6":"He makes the earth tremble,and its pillars quake."
,"7":"He commands the sun, and it does not shine; he seals off the light of the stars."
,"8":"He alone stretches out the skies,and treads on the waves of the seas."
,"9":"He made the Bear and Orion, the Pleiades and every constellation."
,"10":"His wonders are past all reckoning, his miracles beyond all counting."
,"11":"He passes by, but I do not see him; he moves on, but I do not notice him."
,"12":"If he snatches away, who can stop him?,Who can say to him, 'What are you doing?'"
,"13":"God does not turn back when angered; before him Rahab's cohorts cowered."
,"14":"How then can I answer him,and find words to argue with him?"
,"15":"If he does not answer when I am right, shall I plead with my judge for mercy?"
,"16":"Even if I appealed and he answered, I do not believe that he would have heard."
,"17":"He who crushes me for a trifle,and multiplies my hurt for no reason."
,"18":"He does not give me time to breathe, but fills me with grief without pause."
,"19":"If it is a contest of strength, he is mighty. If a matter of justice, who will summon him?"
,"20":"If I were innocent, my own mouth would condemn me; if blameless, it would pronounce me guilty."
,"21":"But am I innocent, after all? I do not know, and so I find my life despicable."
,"22":"It is all the same! And this I dare say: both blameless and wicked - he destroys."
,"23":"When disaster brings sudden death, he mocks the despair of the innocent."
,"24":"When a nation falls into a tyrant's hand, it is he who makes the judges blind. But if it is not he - who else then?"
,"25":"Swifter than a runner are my days; without a shred of joy they fly away."
,"26":"They skim along like reed canoes,or like eagles swooping on their prey."
,"27":"If I resolve to forget my affliction, to smile and change my expression,"
,"28":"my trials make me fear,for I know I shall be held accountable."
,"29":"In any case if I am to be condemned, why should I bother in vain?"
,"30":"If I washed my body with snow,and cleansed my hands with soap,"
,"31":"you would plunge me into the dung pit, and my very clothes would abhor me."
,"32":"He is not a man like me that I might say, 'let us go to court together.'"
,"33":"Would that there were an arbiter between us, who could lay his hand upon both of us."
,"34":"He would remove from me the rod of God,and his terrors which frighten me."
,"35":"But it is not so. Then I will speak,to myself alone without fear."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Since I loathe my life, I shall pour forth my complaint; I shall speak of my soul's torment."
,"2":"I shall say to God: Do not condemn me, but tell me what is your quarrel with me?"
,"3":"Would it be good for you to oppress me, to spurn the work of your hands,and favor the designs of the wicked?"
,"4":"Have you human eyes?,Do you see as man sees?"
,"5":"Are your days as the days of man, or your years as a mortal's lifetime?"
,"6":"Why do you seek guilt in me,and search for my faults?"
,"7":"You know I have not sinned, but who can rescue me from your hand?"
,"8":"You have formed and made me. Will you then turn and destroy me?,Will you then turn and destroy me?"
,"9":"Remember that you molded me from clay. Will you turn me to dust again?"
,"10":"Did you not pour me out like milk,and curdle me like cheese?"
,"11":"You wrapped me up in skin and flesh, knit me together with bones and sinews."
,"12":"In your goodness you gave me life,and watched over my breathing with care."
,"13":"Yet this is what you hid in your heart, I know what was in your mind:"
,"14":"You wanted to see if I sinned, and not let my fault be forgiven."
,"15":"If I am guilty - alas for me!,If innocent - I dare not lift my head, humbled and shamed in my affliction."
,"16":"Exhausted, you hunt me like a lion, you want to prove that you are stronger."
,"17":"You renew your attack on me; you intensify your rage, wave upon wave, your forces assail me."
,"18":"Why did you bring me out of the womb?,I wish I had died unseen,"
,"19":"a being that had not been -,carried from the womb direct to the tomb."
,"20":"Are not my days almost over?,Turn away; leave me a while to recover"
,"21":"before I go to the place of no return, to the land of gloom and shadow,"
,"22":"to the land of chaos and deepest night, where darkness is the only light."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Zophar the Naamithite spoke:"
,"2":"Must these words go unanswered?,Must you be right for talking so much?"
,"3":"Will your prattle keep us silent?,Will no one answer your mocking?"
,"4":"You say to God that your way is right, that you are clean in his sight."
,"5":"How I wish that God would speak,and open his lips against you,"
,"6":"to show you the secrets of wisdom,which put intelligence to shame, then you would know,that God is recalling your sins."
,"7":"Can you fathom the mysteries of God, probe the extent of his perfection?"
,"8":"It is higher than heaven -,what can you do?,Deeper than the world of death -,what can you know?"
,"9":"Its measure is wider than the earth, broader than the sea."
,"10":"Who can stop him when he passes, when he imprisons and calls to judgment?"
,"11":"He sees evil; he recognizes deceit. Will he not then take note of it?"
,"12":"So stupid men learn to be wise,as wild donkeys become tame."
,"13":"If you set your heart aright,and stretch out your hands to him,"
,"14":"if you wash your hand of sin,and allow no evil in your tent,"
,"15":"you will then raise your face in honor; having no fear, you will feel secure."
,"16":"You will forget your suffering,and recall it only as waters gone by."
,"17":"Your life will be brighter than noonday,and its darkness like the morning."
,"18":"You will be comforted, for there is hope; you will be protected when you sleep."
,"19":"You will lie down with no one to fear; many will come to court your favor."
,"20":"But the eyes of the wicked will fail; they will lose all way of escape, their one hope - that death will come."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Then Job answered:"
,"2":"No doubt you are the people's voice; when you die, wisdom dies with you!"
,"3":"But I have a mind as well as you, I know all that you have said."
,"4":"To my friends I am a laughingstock,when I call on God who does not answer; the just and blameless man,is made fun of."
,"5":"'Contempt for the unfortunate,' so think the prosperous, 'a blow for those who are staggering.'"
,"6":"Yet the robbers' tents are undisturbed, those who provoke God are in peace, those who make a god of their strength."
,"7":"But ask the beasts to teach you, the birds of the air to tell you,"
,"8":"the plants of the earth to instruct you, the fish of the sea to inform you."
,"9":"Who among them does not understand,that behind all this is God's hand?"
,"10":"He holds the life of every creature,and the breath of all mankind."
,"11":"The ear surely can test the words,as the tongue tastes food;"
,"12":"wisdom is found in the old, and understanding in great age;"
,"13":"in God however is wisdom and power; his are counsel and understanding."
,"14":"What he tears down, none can rebuild; the one he imprisons, none can release."
,"15":"If he withholds water, there is drought; if he lets it loose, there is flood."
,"16":"In him are strength and perception; deceived and deceiver are in his power."
,"17":"He leads counselors away stripped,and makes fools of judges."
,"18":"He loosens the belt of kings,and ties a loincloth about their waist."
,"19":"He leads priests away, barefoot, and overthrows those in power."
,"20":"He compels advisers to keep silent, and strips elders of their discernment."
,"21":"He puts princes to shame; he unties the girdle of the strong."
,"22":"(He uncovers the gloomy recesses,and brings the deep darkness to light.)"
,"23":"He makes a nation rise and fall, a people to grow and to dwindle."
,"24":"He deprives leaders of their judgment, leaving them to roam in a trackless waste."
,"25":"Without light, they grope in the dark,and stagger like drunkards."
}`)
	CurrentBook.AddChapter(13, `{
"1":"My eyes have seen all this, my ears have heard and understood."
,"2":"What you know, I also know; I am not inferior to you."
,"3":"But I would like to speak to the Almighty, I want to plead my case with God."
,"4":"You are glossing over the problem,and offering false remedies."
,"5":"If only you would keep silent, that would at least be wisdom."
,"6":"Hear now my argument; listen to my defense."
,"7":"Will you speak falsely for God?,Will you defend him with false inventions?"
,"8":"Will you side with him,and advocate on his behalf?"
,"9":"What if he examines you?,Could he be deceived as men are?"
,"10":"He will rebuke you for sure,if in secret you show partiality."
,"11":"You will be terrified by his majesty, and you will be in dread of him."
,"12":"Heaps of ashes are your maxims; mounds of clay are your defenses."
,"13":"So keep silent and let me speak; this will be at my own risk."
,"14":"I am putting myself in jeopardy,and gambling for my life."
,"15":"Though he may slay me, I will still argue with him;"
,"16":"and this might even save me,for no godless man dares draw near him."
,"17":"Carefully listen to my words, give my case a hearing."
,"18":"I will proceed in due form,believing that I am guiltless."
,"19":"If anyone makes good his charges, I am ready to be silenced and die."
,"20":"Only grant me these two things, O God, and from you I will not hide:"
,"21":"Withdraw your hand far from me, and do not frighten me with your terrors."
,"22":"Summon me and I will respond; or let me speak and then have your reply."
,"23":"What are my faults, what are my sins?,Make them all known to me."
,"24":"Why hide your face from me,and consider me your enemy?"
,"25":"Why torment a wind-blown leaf,or pursue a withered straw?"
,"26":"But you search for accusations,and you recall the sins of my youth."
,"27":"You shackle my feet, keep watch on all my paths,and mark out my footsteps."
,"28":"He falls apart like worm-eaten wood, like cloth devoured by the moths."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Man born of woman,has a short life full of sorrow."
,"2":"Like a flower he blossoms and withers; transient and fleeting as a shadow."
,"3":"Is he the one you look on,and bring before you for judgment?"
,"4":"Who can bring the clean from the unclean?,No one!"
,"5":"Since his days are measured,and you have decreed the number of his months, set him bounds he cannot pass,"
,"6":"then leave him alone. Turn away from him,till he completes his day like a hireling."
,"7":"There is hope for a tree: if cut down it will sprout again, its new shoots will still appear."
,"8":"Though its roots grow old in the ground,and its stump withers in the soil,"
,"9":"at the scent of water it will bud,and put forth shoots like a young plant."
,"10":"But when man is cut down, he comes undone; he breathes his last - where will he be?"
,"11":"The waters of the sea may disappear, rivers drain away,"
,"12":"but the one who lies down will not rise again; the heavens will vanish before he wakes, before he rises from his sleep."
,"13":"If only you would hide me in the grave,and shelter me till your wrath is past!,If only you would set a time for me,and then remember me!"
,"14":"Will a man live again if he dies?,All the days of my service,I would wait for my release."
,"15":"You would call and I would answer; you would long for the work of your hands again."
,"16":"Now you watch my every step, but then you would stop counting my sins."
,"17":"My offenses would be sealed in a bag, and you would do away with my guilt."
,"18":"But as mountains erode and crumble, as rock is moved from its place,"
,"19":"as waters wear away stones,and floods wash away the soil, so you destroy the hope of man."
,"20":"You crush him once for all, and he is gone; you change his appearance and send him away."
,"21":"If his sons are honored, he does not know it; if brought low, he does not see it."
,"22":"Only the pain of his own body does he feel; only for himself does he mourn."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Eliphaz the Temanite spoke:"
,"2":"Should a wise man answer with airy notions, puff himself up with senseless opinions?"
,"3":"Should he argue in empty talk, in words that are meaningless?"
,"4":"You are undermining piety,and meditation in God's presence."
,"5":"Your iniquity instructs your mouth, and you talk like the crafty."
,"6":"Your own mouth condemns you, your own lips, not mine."
,"7":"Are you mankind's firstborn?,Were you brought forth before the hills?"
,"8":"Are you privy to God's counsels?,Do you alone possess wisdom?"
,"9":"What knowledge have you that we do not have?,What do you understand that is obscure to us?"
,"10":"The gray-haired and the aged are among us, men older than your father."
,"11":"Are God's consolations too small for you, and the words spoken gently to you?"
,"12":"Why does your heart carry you away, why do your eyes flash"
,"13":"when you turn your wrath against God,and utter such words as these?"
,"14":"What is man to claim innocence, the child of woman to be cleared of guilt?"
,"15":"If God puts no trust in his holy ones, and (the) heavens are not clean in his eyes,"
,"16":"how much less man who is vile and corrupt, who drinks evil as if it were water!"
,"17":"Listen and I will explain; I will tell you of my experience"
,"18":"and of the sages' teachings,passed on to them by their fathers,"
,"19":"to whom alone the land was given,when no foreigner moved among them."
,"20":"The wicked are in torment all their days. During the years allotted to the tyrant"
,"21":"his ears are filled with terrifying sounds, his peace shattered by the attack of marauders."
,"22":"He despairs of escaping the darkness,and sees himself given to the sword,"
,"23":"then left as a prey for vultures, he knows his destruction is at hand."
,"24":"The hour of darkness fills him with dread, as distress and anguish close in on him."
,"25":"But look: he challenged God, he raised his hand against the Almighty,"
,"26":"charging stubbornly against him,behind a thick, sturdy shield."
,"27":"His face had grown full and fat, his thighs bulged with flesh."
,"28":"He would dwell in ruined cities, in deserted and crumbling houses."
,"29":"He will not prosper or take root; he will not escape from darkness;"
,"30":"a flame will wither his shoots; the wind will carry off his blossom."
,"31":"Let him not trust in greatness,for he will get nothing in return."
,"32":"He will be paid in full before his time, and his branches will never again be green."
,"33":"Like a vine he will be stripped of unripe grapes; like the olive, he will shed his blossoms."
,"34":"For the breed of the godless will be barren, and fire will consume the tents of extortioners."
,"35":"Who conceives mischief will bring forth evil, deceit will spring from his own womb."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Then Job answered:"
,"2":"I have heard many such things. What miserable comforters you are!"
,"3":"When will your airy words end?,What ails you and keeps you arguing?"
,"4":"I too could talk as you do, if you were in my place; I could declaim over you,and shake my head at you."
,"5":"I would give you strength, and comfort you with words."
,"6":"Yet if I talk, my suffering is not eased, if I refrain, it does not go far from me."
,"7":"I am upset with such ill will; an evil band "
,"8":"takes hold of me. They stand to testify against me; and answer me with slanders."
,"9":"They assail me with fury,and gnash their teeth at me; my enemies lord it over me."
,"10":"With open mouths they jeer at me; they strike my cheek, and together,they mass themselves against me."
,"11":"God has given me over to evil men,and cast me into the clutches of the wicked."
,"12":"All was well until he shattered me, but he seized me and dashed me to pieces. Having set me up for a target,"
,"13":"he had his arrows pointed at me, striking from every direction, piercing my sides without pity, spilling my gall on the ground."
,"14":"Like a warrior he bears down on me, thrusting me unceasingly."
,"15":"I have fastened sackcloth over my skin,and buried my brow in dust."
,"16":"My face is red with weeping, deep shadows ring my eyes;"
,"17":"yet my hands are free of violence, and my prayer sincere."
,"18":"O earth, do not cover my blood; let not my cry come to rest!"
,"19":"Even now my witness is in heaven,and my defender is on high."
,"20":"Now my prayer has gone up to God,as I poured out my tears before him."
,"21":"Would that man could discuss with God,as he does with his fellows."
,"22":"My years are numbered, and soon,I will take the road of no return."
}`)
	CurrentBook.AddChapter(17, `{
"1":"My spirit is broken, my days are over,and the grave awaits me."
,"2":"Mockers surround me; my eyes grow dim with nights of bitterness."
,"3":"Sponsor me, O God, since no one will support me."
,"4":"You have closed their minds,so they will not dare."
,"5":"Who will help a friend when his sons are in need?"
,"6":"I have been made everybody's byword, a man in whose face people spit."
,"7":"My eyes have grown dim with grief, my frame shrunken to a shadow."
,"8":"At this, upright men are appalled, and the guiltless rail against the wicked."
,"9":"The righteous feel at ease,and those with clean hands are strengthened."
,"10":"But come on again, all of you; I will not find a single sage among you."
,"11":"My days are ended, my plans shattered, and so my heart desires"
,"12":"the night when it is day, the coming of light as soon as it darkens."
,"13":"Where is my hope? The grave is my home, in the darkness I spread out my bed,"
,"14":"I must call corruption 'my father,',and the worm 'my mother' or 'my sister.'"
,"15":"What can I wait for, and who will see any hope for me?"
,"16":"Will it go down to the bars of death, shall we descend together into the dust?"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Bildad the Shuhite replied:"
,"2":"When will your empty words end?,Listen, and then we can talk."
,"3":"Why do you regard us like beasts?,Are we stupid in your sight?"
,"4":"You who tear yourself in your wrath, must the earth be lost on your account,the rocks be moved out of their place?"
,"5":"Surely the evil man's lamp is snuffed out; his fire stops burning."
,"6":"The light dims in his tent; the lamp shining on him goes out."
,"7":"His vigorous steps weaken; his own schemes make him stumble."
,"8":"His feet take him to a net,or lead him into a pitfall."
,"9":"A trap seizes him by the heel; a snare lays hold of him."
,"10":"Hidden in the ground is a noose for him; pitfalls await him along the way."
,"11":"Terrors assail him on every side; they harry him at every step."
,"12":"Hungering among his goods, doom awaits him if he falls."
,"13":"Sickness eats his skin; death's firstborn devours his limbs."
,"14":"Torn from the security of his tent, he is marched off to the king of terror."
,"15":"His tent is no longer his: take it! Brimstone is scattered over his field."
,"16":"Dried up below are his roots; withered above are his branches."
,"17":"His memory perishes in the land, his name is forgotten on the earth."
,"18":"From light he is driven into darkness; he is banished from the world."
,"19":"He has no descendants among his people, no survivor where once he lived."
,"20":"All in the west are appalled at his fate; those of the east are seized with fright."
,"21":"Such is the lot of the wicked; such is the place of one who knows not God."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Job answered:"
,"2":"How long will you vex me, crush me with your words?"
,"3":"Ten times now you have reviled me, you have attacked me shamelessly."
,"4":"If indeed I am at fault, I alone am concerned with it."
,"5":"If you want to gloat over me,and use my humiliation as argument,"
,"6":"know then that God has treated me unfairly,and surrounded me with torment."
,"7":"Though I cry injustice I am not heard; though I call for help it is in vain."
,"8":"He has blocked my way to prevent me from passing; he has shrouded my path and made it dark."
,"9":"He has stripped me of honor, and removed the crown from my head."
,"10":"On every side he tears me down,and uproots my hope till it is gone."
,"11":"He directs his anger against me,and counts me as his enemy."
,"12":"Against me his troops build a siege ramp, and around my tent they encamp."
,"13":"He has distanced me from my brothers, completely estranged me from my friends."
,"14":"My kinsfolk and companions have gone away; my guests have forsaken me,"
,"15":"my maidservants count me as an alien,as if they had never known me"
,"16":"I summon my servant, but he does not answer, even when I plead with him."
,"17":"To my wife my breath is offensive; to my own brothers I am loathsome."
,"18":"Even little children ridicule me: Come! let us make fun of him!"
,"19":"All my intimate friends detest me; those I love have turned against me."
,"20":"I have become skin and bone,and have escaped with only my gums."
,"21":"Have pity my friends, have pity, for God's hand has struck me!"
,"22":"Why do you hound me as God does?,Will you never have enough of my flesh?"
,"23":"Oh, that my words were written, or recorded on bronze"
,"24":"with an iron tool, a chisel,or engraved forever on rock!"
,"25":"For I know that my Redeemer lives, and he, the last, will take his stand on earth"
,"26":"I will be there behind my skin, and in my flesh I shall see God."
,"27":"With my own eyes I shall see him -,I and not another. How my heart yearns!"
,"28":"If you say, 'We will pursue him!,let us find a charge against him',"
,"29":"be afraid of the sword yourselves; when Wrath is enflamed against wrong, you will know there is judgment."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Zophar of Naamath spoke next:"
,"2":"My troubled thoughts move me to reply,for I have been feeling impatient."
,"3":"I hear a rebuke which puts me to shame, and I am inspired to give an answer."
,"4":"You know how it has been from of old, since man was placed on earth,"
,"5":"that the triumph of the wicked is short,and the joy of the godless is but a moment."
,"6":"Though his pride reach to the heavens,and his head touch the clouds,"
,"7":"he vanishes like a phantom; those who have seen him ask where he is."
,"8":"Like a dream he takes flight, like a vision of the night."
,"9":"The eye that met him sees him no more; neither shall his dwelling shelter him again."
,"11":"His youthful frame that was full of vigor,shall at last lie with him in the dust."
,"12":"E vil was sweet in his mouth, and he hid it under his tongue,"
,"13":"He liked it and did not let it go,and still kept it within his mouth,"
,"14":"yet his food turns sour,and becomes venom in his stomach."
,"15":"He vomits the riches he swallowed; God compels his belly to belch it out."
,"16":"Because he sucked the poison of a viper, he will be killed by the fangs of an adder."
,"17":"He will no longer see the streams of oil, no rivers of honey and milk."
,"18":"He gives back the fruit of his toil: he could not swallow it."
,"19":"For he has oppressed the poor,and seized houses instead of building them."
,"10":"His children must make amends to his victims; his own hands must pay back his riches."
,"20":"For his greed had no limit, and no one could escape his appetite;"
,"21":"he devoured them, one and all. This is why his prosperity will not endure."
,"22":"In the midst of plenty, distress seizes him, the full force of misery falls upon him."
,"23":"When his belly is filled God unloads his wrath upon him,and pelts him with his arrows."
,"24":"While he flees from an iron weapon, the bronze bow strikes him down."
,"25":"A dart sticks in his back, in his liver an arrow. He is in the grip of a terrible fear;"
,"26":"total darkness has been stored for him, a fire which he did not kindle devours him and consumes whatever was left in his tent."
,"27":"The heavens will expose his guilt; the earth will rise up against him."
,"28":"A flood will sweep away his house, the waters of God's wrath."
,"29":"Such is the fate of the wicked -,their lot which comes from God."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Job replied:"
,"2":"Listen at least to my words, enough of your consolation."
,"3":"Bear with me while I speak; and then you can mock."
,"4":"Is my grudge against humans?,Why then should I not be impatient?"
,"5":"Look at me and be appalled; cover your mouth for a moment."
,"6":"When I think about this I am troubled,and trembling seizes my body."
,"7":"Why do the wicked live, increase in age and in power?"
,"8":"Their descendants fluorish in their sight, their kinsfolk and their offspring."
,"9":"Their homes are safe, free from fear; they do not feel the scourge of God."
,"10":"Their bulls breed without fail; their cows calve and do not miscarry."
,"11":"They have children as they have lambs,their little ones dance like deer."
,"12":"They sing to the rhythm of timbrel and harp; make merry to the sound of the flute."
,"13":"They live out their days in happiness,and go down to Sheol in peace."
,"14":"Yet they said to God, 'Go away!,We have no desire to learn your way."
,"15":"Who is the Almighty that we should serve him?,What will it profit us if we pray to him?'"
,"16":"Though they planned everything far from God,prosperity is in their hands."
,"17":"How often is their lamp put out?,How often does calamity befall them?,How often does God's anger wipe them out?"
,"18":"How often are they like straw before the wind, like chaff which the storm sweeps away?"
,"19":"You say, 'His children will pay for his sin.',Let the man himself pay for his iniquity;"
,"20":"let his own eyes see his misfortune; let him drink the wrath of the Almighty!"
,"21":"What does he care about his family when he dies, when his months have been cut off?"
,"22":"Can anyone teach God knowledge, since he judges even the highest?"
,"23":"One man dies in full vigor, at ease and completely secure;"
,"24":"full and nourished is his figure, rich in marrow are his bones."
,"25":"Another dies in bitterness, never having enjoyed happiness."
,"26":"But in the dust they lie down,side by side, covered with worms."
,"27":"I know your thoughts fully,and your schemes about me."
,"28":"For you say, 'Where is the house of the great prince?,Where is the tent of the wicked?'"
,"29":"Have you never asked the travelers, or have you misunderstood what they say -"
,"30":"that the evil man is spared from calamity, delivered from the day of God's fury?"
,"31":"Who will denounce his conduct to his face,or pay him back for what he has done?"
,"32":"When people have carried him to the grave his image watches from his tomb."
,"33":"The soft earth is sweet to him; behind him you see everyone follow,and before him a countless horde."
,"34":"How then can you console me with your nonsense?,Pure falsehood is all you have said."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Eliphaz the Temanite replied:"
,"2":"Can man be of any use to God?,Only himself a wise man benefits."
,"3":"What would the Almighty gain if you were upright?,What profit if you were blameless in your ways?"
,"4":"Is it for your piety that he reproves,and brings you to judgment?"
,"5":"Is it not for your great wickedness, for there is no end to your sins?"
,"6":"Without any need you kept your kinsmen's goods,and stripped them naked of their clothing."
,"7":"You denied drink to the thirsty,and withheld bread from the hungry."
,"8":"The powerful control the land,and allot it to their cronies."
,"9":"You have sent widows away empty-handed,and crushed the arms of orphans."
,"10":"No wonder snares are round about you,and sudden terror makes you dismayed,"
,"11":"you are blinded by darkness,and covered by flood."
,"12":"Is not God above the heavens?,See how lofty are the highest stars."
,"13":"Yet you say, 'What does God know?,Can he see through deep shadows?"
,"14":"He cannot see for thick clouds veil him,as he walks upon the vault of the heavens.'"
,"15":"Will you keep to the old path,that the wicked have trod?"
,"16":"In a moment they were carried off,and their foundation washed away."
,"17":"They said to God, 'Away from us!,What can the Almighty do to us?'"
,"18":"He had filled their houses with good things, but the thoughts of the wicked were far from him."
,"19":"The righteous see their ruin and are glad, the innocent laugh at them and say,"
,"20":"'Now the great have come to nothing, fire has devoured their heritage.'"
,"21":"Come to terms with God and make peace; in this way you will prosper."
,"22":"Listen to his teaching,and keep his words in your heart."
,"23":"If you return humbled to the Almighty, if you drive injustice from your tent,"
,"24":"then you will look on gold as dust, gold of Ophir as pebbles from a stream."
,"25":"For the Almighty will be your gold,and your sparkling silver."
,"26":"For then you will delight in the Almighty,and lift up your face to God."
,"27":"You will pray to him and he will hear, and you will fulfill your vows."
,"28":"You will succeed in your decision, and light will shine upon your way."
,"29":"For God brings down the proud,and saves the downcast."
,"30":"He who rescues the innocent man, will rescue you too if your hands are clean."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Job answered and said:"
,"2":"Again today my complaint is rebellious; I groan under his heavy hand."
,"3":"If only I knew where to find him, if only I could go to his dwelling,"
,"4":"I would bring my case before him,and lay out in full my arguments."
,"5":"I would find out his answer,and understand what he would say."
,"6":"Would he need great power to debate with me?,No! he needs only to listen!"
,"7":"He would know the complainant to be an upright man,and I would be free of my judge."
,"8":"But if I go eastward, he is not there; if I go westward, I still cannot see him."
,"9":"Seeking him in the north, I do not find him; looking for him in the south, he is not there."
,"10":"But he knows my every step, and I will come out as gold in his test."
,"11":"I have always walked along his path; I have kept his ways and not turned aside."
,"12":"I have not departed from his commands, instead I have treasured his words."
,"13":"But who can oppose once he has decided?,He does what he desires."
,"14":"He will carry out his decree,and other plans laid out for me."
,"15":"That is why I am terrified,when I think of all this."
,"16":"God has made me lose courage; the Almighty has made me afraid,"
,"17":"but I am not silenced by darkness, by the thick gloom that covers my face."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Why is what happens hidden from God?,Why do his faithful never see his justice?"
,"2":"The wicked remove landmarks,and steal both flocks and shepherds."
,"3":"They seize the orphan's ass,and for a pledge take the widow's ox."
,"4":"The needy stay far from the road, the poor go into hiding."
,"5":"Like wild asses in the wasteland, they look for food; the poor toil in the night, there is no food for their children!"
,"6":"They gather fodder in the fields, work in the vineyards of the wicked."
,"7":"Destitute, they lie down naked, shivering in the freezing cold."
,"8":"Drenched with mountain rains, they hug the rocks for lack of shelter."
,"9":"The fatherless child is snatched from the breast, the infant of the poor seized for a debt."
,"10":"Without clothes, they go naked, starving as they carry the sheaves."
,"11":"Between the millstones they crush olives; they tread the winepress but suffer thirst."
,"12":"In the city the dying groan, and the wounded cry out for help,but God pays no attention."
,"13":"Many rebel against the light, they do not know its way or stay in its path."
,"14":"When dawn breaks, the murderer rises,to kill the poor and the helpless."
,"15":"The adulterer waits for dusk, thinking that no eye watches him. At night the thief walks about,and puts a mask over his face,"
,"16":"ready to break into the houses,that he chose during the day."
,"17":"Morning is their darkest hour,the time for them to fear."
,"18":"The wicked are foam on the face of the waters; their portion of the land is cursed, and no one goes to their vineyards."
,"19":"As drought and heat snap up the thawed snow, so Sheol swallows up the sinner,"
,"20":"and the womb which formed him, forgets him. Evil men are no longer remembered, like a fallen tree they are broken."
,"21":"They preyed on the barren, childless woman, and showed no kindness to the widow."
,"22":"But the Powerful stands against them and drags away the mighty."
,"23":"He may let them feel secure, but his eyes are upon their ways."
,"24":"They are momentarily exalted, and then gone; they wither and fade like a weed. They are cut off like heads of grain."
,"25":"If this is not so, who can prove me wrong,and reduce my words to nothing?"
}`)
	CurrentBook.AddChapter(25, `{
"1":"Then Bildad the Shuhite answered:"
,"2":"His is dominion and awesome power, he who establishes peace in the heavens."
,"3":"Can his armies be numbered?,Upon whom does his light not rise?"
,"4":"How can man be righteous before God?,How can one born of woman be pure?"
,"5":"Even the moon is not bright,nor are the stars pure in his sight -"
,"6":"how much less man - this insect, the son of man - a worm?"
}`)
	CurrentBook.AddChapter(26, `{
"1":"Job answered then:"
,"2":"What help have you given to the powerless, what strength to the enfeebled arm?"
,"3":"What advice have you offered to the foolish, and what great insight have you shown?"
,"4":"Who has inspired in you these words?,Whose spirit spoke from your mouth?"
,"5":"The shades of the deep are terrified, the waters and their inhabitants tremble."
,"6":"Sheol is naked before God; destruction lies uncovered."
,"7":"Over the void he spreads out the northern skies; over emptiness he suspends the earth."
,"8":"He wraps up the waters in his clouds, yet the clouds do not burst their seams."
,"9":"He covers the face of the moon,and spreads his clouds over it."
,"10":"On the face of the waters he draws the horizon as a boundary between light and darkness."
,"11":"The pillars of the heavens quake, stunned at his thunderous rebuke."
,"12":"By his power he stilled the sea; by his wisdom he smote Rahab."
,"13":"By his wind the skies were cleared; his hand pierced the fleeing serpent."
,"14":"These are but hints of his power; a whisper is all that we hear of him. But who can understand the thunder of his might?"
}`)
	CurrentBook.AddChapter(27, `{
"1":"Job continued his discourse:"
,"2":"As surely as God lives, who denies my right, the Almighty, who has made me bitter,"
,"3":"as long as I have life within me,and God's breath in my nostrils,"
,"4":"my lips will not speak falsehood,nor my tongue utter deceit."
,"5":"Never will I admit you are right, nor deny my integrity till I die."
,"6":"Never will I let go of my righteousness; my conscience is not put to shame."
,"7":"Let my enemy be as the wicked,and my adversary as the unrighteous."
,"8":"For what hope has the godless,when God cuts him off, when God takes away his life?"
,"9":"God will not listen to his call,when he is beset by trouble."
,"10":"For he did not delight in the Almighty,or call upon him constantly."
,"11":"See, I tell you the deeds of God,and do not conceal the ways of the Almighty."
,"12":"You have witnessed this yourselves. Why then these empty words?,Third discourse of Nahama"
,"13":"This is a wicked man's portion from God, the heritage of an oppressor,which he receives from the Almighty."
,"14":"Though his children be many, the sword is their destiny. His offspring will go hungry."
,"15":"The plague will bury those who survive, and their widows will not mourn for them."
,"16":"He may heap up silver like dust,and pile up clothes like clay,"
,"17":"but what he stores, the just will wear, and the innocent divide his silver."
,"18":"He builds his house like a cobweb, or like the hut a watchman makes."
,"19":"Once more he lies down rich,and wakes to see his wealth all gone."
,"20":"Terrors rush upon him by day; at night a whirlwind carries him away."
,"21":"The east wind lifts him up, and he disappears,as it sweeps him out of his place."
,"22":"People strike at him without mercy,as he flees headlong from their hands."
,"23":"They clap their hands in mockery,and hiss at him from where they are."
}`)
	CurrentBook.AddChapter(28, `{
"1":"There is a silver mine,and a place where gold is refined."
,"2":"Iron is taken from earth,and copper is smelted from ore."
,"3":"Man tries to conquer darkness, piercing to the uttermost depths,in darkness for the gloomy stone."
,"4":"Strange people cut a shaft,in places remote and long forgotten, and there they labor, dangling and swaying."
,"5":"The earth which produces food,is plowed up as if by fire."
,"6":"Sapphires come from its rocks, gold nuggets from its dust."
,"7":"No bird of prey knows the hidden path, no falcon's eye has seen it yet."
,"8":"No proud beast has trodden it, no prowling lion has passed over it."
,"9":"Man attacks the flinty rocks, upturns mountains by their roots."
,"10":"Tunneling through earth's layers, he sees all its treasures."
,"11":"He searches the source of rivers, and brings hidden things to light."
,"12":"But where does wisdom come from?,Where does understanding dwell?"
,"13":"Man has known no way to wisdom; it is not found in the land of the living."
,"14":"The deep says, 'It is not in me'; the sea says, 'It is not with me.'"
,"15":"It cannot be purchased with the finest gold, nor can its price be weighed in silver."
,"16":"It cannot be bought with the gold of Ophir, nor with precious onyx or sapphire."
,"17":"It is beyond comparison with gold or crystal; its worth is unmatched by any golden vessel."
,"18":"Not worth mentioning are coral and jasper; the price of wisdom is above the biggest pearl."
,"19":"The topaz of Cush cannot equal it; it cannot be valued in pure gold."
,"20":"Where then does wisdom come from?,Where does understanding dwell?"
,"21":"It is hidden from the eyes of all the living, concealed from the birds in the sky."
,"22":"Destruction and Death can only say, 'We have heard of it.'"
,"23":"God alone knows the way to wisdom, his eye enters its dwelling place."
,"24":"When he looked to the ends of the earth, and watched everything under the heavens,"
,"25":"when he gave the wind its force,and measured out the waters,"
,"26":"when he set a bound for the rain,and a way for the thunder and lightning,"
,"27":"then he looked at wisdom and appraised it; he established it, knowing it in depth."
,"28":"And to man he said: The fear of the Lord is wisdom; avoiding evil is understanding."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Job continued his discourse:"
,"2":"Oh, that I were in months gone by, in the days when God watched over me,"
,"3":"when his light shone upon my head,and I walked with it through darkness."
,"4":"Oh, that I were in my prime, when God's friendship blessed my home,"
,"5":"when the Almighty was still with me,and my children were around me,"
,"6":"when milk bathed my footsteps,and olive oil flowed from the rock."
,"7":"When I went to the city gate,and took up my seat in the square"
,"8":"the young men stepped aside,and the old men rose to their feet;"
,"9":"the chief men dared not speak,but laid their hands on their mouths;"
,"10":"the princes were silenced, their tongues stuck to the palate."
,"21":"They listened to me and waited in silence,for my counsel."
,"22":"Once I spoke they said no more, but drop by drop my words kept falling on them."
,"23":"They waited for me as people wait for showers; they drank in my words as spring rain."
,"24":"If I smiled at them, they did not dare believe it; not a glance of mine was lost."
,"25":"I pointed out the way, as a leader,and took a king's place among the troops. Wherever I led them, they went."
,"11":"Whoever heard me, spoke well of me, and those who saw me commended me,"
,"12":"for I rescued the poor who cried for help, the fatherless and the unassisted."
,"13":"I was blessed by the dying man; I turned to peace the widow's pining."
,"14":"I was wearing my honesty like a garment, my integrity was my robe and turban."
,"15":"I was eyes to the blind and feet to the lame,"
,"16":"father to the needy, the stranger's advocate."
,"17":"I broke the jaws of the wicked, and from his teeth forced out the prey."
,"18":"I said to myself: 'I will die old, my days as many as the grains of sand."
,"19":"My roots will reach to the water; at night my branches will be wet with dew."
,"20":"My glory will remain fresh, the bow ever strong in my grip.'"
}`)
	CurrentBook.AddChapter(30, `{
"1":"And now I am the laughing-stock,of people much younger,whose fathers I considered unfit,to put with the dogs of my flock."
,"2":"Not even their arms were helpful to me for all their vigor had gone,"
,"3":"worn out by hunger and want. They roamed the parched wasteland,"
,"4":"they gathered salt herbs from the brushwood, their food was the roots of the broom plant."
,"5":"They were banished by their fellowmen,who shouted at them as if they were thieves."
,"6":"They were forced to seek a home in caves, among the ravines and rock crevices."
,"7":"They brayed among the bushes,and huddled in the underbrush."
,"8":"They were driven from the land,for being base and senseless men."
,"9":"And now their sons sing of my disgrace; I have become a byword among them."
,"10":"They do not hesitate to spit before me; they abhor me and keep their distance."
,"11":"Seeing that God has unstrung my bow, they have cast off restraint in my presence."
,"12":"On my right the rabble rise, build siege ramps and lay snares."
,"13":"They attack, with none to restrain them."
,"14":"They advance, as through a wide breach; they come in waves amid the uproar."
,"15":"Terror grips me; my dignity is blown by the wind,my safety has vanished like a passing cloud."
,"16":"And now my soul is poured out,because of my days of grief and suffering."
,"17":"At night gnawing pain pierces my bones. My veins have no rest."
,"18":"With power God has caught my garment, binding me about as the collar of my coat;"
,"19":"throwing me into the mire, where I am now like dust."
,"20":"I cry to you, O God, but there's no answer; I stand but you merely look on."
,"21":"You have become cruel to me, you pursue me,mercilessly with your strong hand."
,"22":"You lift me up and make me ride,till the storm tosses and throws me down like rain."
,"23":"I know you will bring me down to death, the destiny of all the living."
,"24":"I did not raise my hand against the poor,when he cried for help in his disaster."
,"25":"Have I not wept for those in trouble?,Has not my soul grieved for the poor?"
,"26":"But when I looked for good, I encountered evil; when I waited for light, darkness came."
,"27":"My heart in turmoil is never at peace, for days of distress have come upon me..."
,"28":"I go about darkened, but not by the sun; if I rise in council, it is to voice my grief."
,"29":"I have become a brother of jackals, a companion of owls."
,"30":"My skin blackens and peels; my bones burn with fever."
,"31":"My harp is tuned to laments, and my flute to sounds of weeping."
}`)
	CurrentBook.AddChapter(31, `{
"1":"I have made a covenant with my eyes,not even to gaze at a virgin."
,"2":"For what is man's lot from God on high, his heritage from the Almighty above?"
,"3":"Is it not ruin for the wicked, disaster for the wrongdoer?"
,"4":"Does he not see my ways,and number all my steps?"
,"5":"Have I walked in falsehood?,Have my feet hastened towards deceit?"
,"6":"Let me be weighed in honest scales, that God may know I am guiltless."
,"7":"If my steps have turned from the way,and my heart's desire has gone astray, if my hands have been stained,"
,"8":"then may others eat what I have sown, or may my crops be stricken down."
,"9":"If I have been enticed by a woman, if I have lurked at my neighbor's door,"
,"10":"then may my wife grind for another, and may other men sleep with her."
,"11":"(For that is enough to make one ashamed, a crime that should be utterly condemned.)"
,"12":"For it is a fire that burns to destruction; it would have consumed all my possessions."
,"13":"If I have denied justice to my servants,when they had a grievance against me,"
,"14":"what would I do when confronted by God?,What would I answer when called to account?"
,"15":"No less than I, they too were formed in the womb,by the same God who formed us all within our mothers."
,"16":"Have I denied anything to the poor, or allowed the widow's eyes to languish?"
,"17":"Have I eaten my food alone, not sharing it with the fatherless?"
,"18":"No! since youth I have fostered him, and from my mother's womb, I have guided the widow."
,"19":"Have I seen a man cold and shivering, destitute, in need of clothing,"
,"20":"who did not bless me from his heart,for giving him the warmth of my fleece?"
,"21":"If I have raised my hand against the orphan, trusting in my power and influence,"
,"22":"then let my shoulder fall from its socket, let my arm be broken at the joint."
,"23":"For I feared God-sent calamity, and how could I stand in his presence?"
,"24":"If I have put my trust in gold,or have sought my security from it,"
,"25":"if I have gloated over my wealth, my fortune and accomplishments,"
,"26":"if I have regarded the sun in its radiance,or the moon in its splendor,"
,"27":"and having been enticed offered them,a kiss of my hand in homage,"
,"28":"then these also would be sins to judge,for I would have been unfaithful to God."
,"29":"Have I rejoiced at my enemy's misfortune,or gloated over disaster that came his way?"
,"30":"I have not even allowed my mouth to sin,by invoking a curse against him."
,"31":"Those of my household used to say, 'Who has not been fed with Job's meat?'"
,"32":"No sojourner ever spent the night in the street, for my door was always open to wayfarers."
,"33":"Have I, out of human weakness, hidden my sins and concealed guilt in my heart,"
,"34":"keeping silent by myself, because I feared the crowd and their contempt?"
,"35":"Oh, that I had someone to hear me!,Let the Almighty answer! This is my plea. Let my accuser write his indictment"
,"36":"and I will wear it on my shoulder, or bind it round my head like a turban."
,"37":"I would give him an account of my every step, and go as boldly as a prince to meet him. This is the end of the words of Job."
,"38":"If my land has cried against me,and its furrows wept"
,"39":"because I have eaten its fruits unjustly,after getting rid of its owners,"
,"40":"let thorns grow instead of wheat,and weeds in the place of barley."
}`)
	CurrentBook.AddChapter(32, `{
"1":"The three men made no further reply to Job, because in their opinion, he was guiltless."
,"2":"But Elihu, son of Barachel the Buzite, of the family of Ram, became angry with Job for justifying himself before God."
,"3":"He was also angry with the three friends for their failure to refute Job, because they had allowed God to be condemned."
,"4":"Because they were older than he, Elihu had bided his time;"
,"5":"but when the three gave up the argument, his anger burst out."
,"6":"Thus Elihu, son of Barachel the Buzite, spoke: I am young and you are quite old; therefore I was timid and afraid,and dared not tell you of what I know."
,"7":"'Age should speak,' I thought; 'advanced years should teach wisdom.'"
,"8":"But it is the spirit in man, the breath of the Almighty, that makes him understand."
,"9":"It is not the old alone who are wise, nor the aged who understand what is right."
,"10":"Therefore I said: 'Listen, let me also show my knowledge."
,"11":"I waited for you to speak, listening for your reasons, as you searched for words."
,"12":"I gave you my full attention,but none of you has proved Job wrong, none has refuted his arguments."
,"13":"Stop saying, 'We have met wisdom; God has instructed us, not man.'"
,"14":"I will not resume your argument,or answer Job with your reasoning."
,"15":"They keep quiet for they are dismayed,and have nothing more to say."
,"16":"Must I wait, now that they are silent, making no effort to reply?"
,"17":"I, too, will show my knowledge."
,"18":"For I am full of words,and prodded on by the spirit."
,"19":"I am like bottled-up wine, or a wineskin bursting with wine."
,"20":"I have to speak to find relief, open my lips and make reply."
,"21":"I will be partial to no one,and will not flatter any man."
,"22":"For if I were skilled in flattery, my Maker would soon do away with me."
}`)
	CurrentBook.AddChapter(33, `{
"1":"So now, O Job, hear my discourse, listen to everything I say."
,"2":"My words are on the tip of my tongue,"
,"3":"words from an upright heart, words full of knowledge and sincerity."
,"4":"The Spirit of God has made me; the breath of the Almighty keeps me alive."
,"5":"Answer me if you can; draw up your arguments and take your stand."
,"6":"Like yourself, I too have been taken,by God from the same clay."
,"7":"Thus no fear of me need alarm you, nor should my presence lie heavy on you."
,"8":"But I heard what you said, none of your words escaped my hearing:"
,"9":"'I am clean and without sin; I am innocent, guiltless."
,"10":"Yet God has found fault with me,and considers me his enemy;"
,"11":"he shackles my feet, keeps watch of all my paths.'"
,"12":"I tell you, you are wrong in this, for greater than man is God."
,"13":"Why then do you complain,that he will answer none of your words?"
,"14":"See God gives a warning,but does not repeat it a second time."
,"15":"In a dream, in a night vision, when deep sleep falls on men, while they slumber in their beds,"
,"16":"it is then he opens the ears of men,and gives warning by terrifying them."
,"17":"So he turns man from wrongdoing,and keeps him away from pride,"
,"18":"God preserves his soul from the pit, his life from perishing by the sword."
,"19":"Man is also chastened on his bed by pain,and constant distress upon his frame,"
,"20":"so that he finds food repulsive, even the choicest meal loathsome."
,"21":"His flesh wastes away to naught; his bones, once unseen, now protrude."
,"22":"His soul draws near to the pit, and his life to the place of death."
,"23":"Yet if there is an angel by his side -,a mediator, one in a thousand -,to show him what is right for man, to give him justice once again,"
,"24":"God will have mercy on him and say, 'Deliver him from going down to the pit; I have found for him a ransom.'"
,"25":"Then his flesh will be renewed as a child's, restored as in the days of his youth."
,"26":"He will pray and find favor with God; he will see God's face and rejoice."
,"27":"He will witness to men and say, 'I sinned and perverted what was right, but I was not punished as I deserved."
,"28":"He rescued my soul from going down into the pit, and gave me life to enjoy the light.'"
,"29":"God does all this to man -,twice, even thrice -"
,"30":"to turn him back from the pit, to lead him with the light of life."
,"31":"Pay attention, Job, listen to me; be silent, and I will continue to speak."
,"32":"But if you have anything to say, say it then; speak up, for I wish to see you justified."
,"33":"If not, then do listen; be silent as I teach you wisdom."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Elihu continued speaking:"
,"2":"Hear my words, you wise men; listen to me, you who know."
,"3":"The ear tests the word, as the palate tastes the food."
,"4":"Let us discern what is right, learn between us what is good."
,"5":"Job has said, 'I am innocent, but God denies me justice"
,"6":"and disregards my right. Though guiltless, my wound is hopeless.'"
,"7":"What man is like Job, who drinks in blasphemies like water?"
,"8":"He keeps company with evildoers,and follows the path of wicked men."
,"9":"For has he not said, 'It does not profit a man,if he tries to please God?'"
,"10":"So hear me, you men of understanding, far be it from God to do evil, far from the Almighty to do wrong!"
,"11":"Rather, he repays man for what he has done; he gives him what his conduct deserves."
,"12":"How unthinkable that God would do wrong, that the Almighty would pervert justice!"
,"13":"Who gave him charge over the earth?,Who else laid out the whole world?"
,"14":"If he were to take back his spirit, to withdraw his breath to himself,"
,"15":"all flesh would perish together,and man would return to dust."
,"16":"If you have any intelligence, listen, Job, hear what I say."
,"17":"Can an enemy of justice govern?,Or do you condemn him who is mighty and just,"
,"18":"who says to kings, 'You are worthless,',and to nobles, 'You are wicked,'"
,"19":"who is impartial to princes,and favors not the rich over the poor, for they are all his handiwork?"
,"20":"They die in a moment, even at midnight; people are shaken and pass away. Without effort he removes a tyrant."
,"21":"His eyes are upon the ways of men, and he sees their every step."
,"22":"For him there is no dense darkness,where evildoers can hide."
,"23":"He forewarns no man of his time,to come before God in judgment."
,"24":"He shatters the mighty without inquiry, and sets in his place another strongman."
,"25":"Because he knows their evil deeds, he turns at night and crushes them."
,"26":"He punishes them for their wickedness,in a judgment that men witness."
,"27":"For they had turned away from him, heeded none of his ways,"
,"28":"and oppressed the poor so much,that their cries of suffering reached him."
,"29":"If he remains silent, who stirs him up?,If he hides his face, who can see him?,Yet he watches man and nation alike,"
,"30":"and restrains those who mislead the people."
,"31":"If a wicked man says to God, 'I was misguided but will offend no more."
,"32":"Teach me what I do not see; if I have done wrong, I will do so no more.'"
,"33":"In such a case, do you think God will punish?,Speak, you who reject his decisions,and think you know more than I do; tell us what you know."
,"34":"Men of understanding, wise men who hear my views will say to me:"
,"35":"'Job speaks without knowledge; his words are without insight."
,"36":"Let Job be tried to the utmost,for answering as wicked men do!"
,"37":"To his sin he adds rebellion,by scornfully brushing off our arguments,and multiplying his words against God.'"
}`)
	CurrentBook.AddChapter(35, `{
"1":"Elihu continued and said:"
,"2":"Do you presume you are right,and innocent before God,"
,"3":"when you say, 'What is it to you, am I doing you harm with my sins?'"
,"4":"I will answer you and your friends as well."
,"5":"Look up to the sky and see, gaze at the clouds above."
,"6":"If you sin, what is that for God?,Do your many offenses hurt him?"
,"7":"If you are just, what do you give him?,or what does he receive from your hand?"
,"8":"It's a man like yourself that your sin touches, a son of man that your justice affects."
,"9":"Men cry out when greatly oppressed; they plead for relief under the tyrant's reign."
,"10":"But no one says, 'Where is God, my Maker, whose songs of jubilation are heard in the night,"
,"11":"who teaches us through the beasts of the earth, who makes us wise through the birds of the air?'"
,"12":"This is why he does not answer when they cry out: because of man's arrogance."
,"13":"In vain! God does not listen, the Almighty takes no heed of it."
,"14":"How much less then will he listen,when you say you do not see him and wait, for your case is before him!"
,"15":"And you say that though he is angry,he does not know how to punish,for he has taken no notice of wickedness."
,"16":"So Job opens his mouth in empty talk, without knowledge he multiplies words."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Elihu proceeded further:"
,"2":"Bear with me a little and I will explain, for I have more to say on God's behalf."
,"3":"I will spread my knowledge afar,to do justice to my Maker."
,"4":"Be assured that my words are not false, for you have before you an enlightened man."
,"5":"God is mighty indeed,but he does not despise the pure of heart."
,"6":"He cuts off the power of the sinner,and restores the right of the oppressed,"
,"7":"he does not forsake their claim. He sets kings on their thrones,and makes them firm forever. But if they raise themselves in pride,"
,"8":"he has them bound with fetters,and held fast by bonds of affliction."
,"9":"Then he tells them what they have done, all their sins and arrogance."
,"10":"He opens their ears to correction,and exhorts them to repentance."
,"11":"If they obey and serve him, they spend their days in prosperity,and their years in contentment."
,"12":"But if they do not listen, they go to the grave: knowledge would have saved them."
,"13":"These hypocrites harbor resentment: they do not pray for help in their bonds,"
,"14":"therefore they die in their youth,and perish among the reprobate."
,"15":"God saves the wretched through their suffering, God instructs the unfortunate."
,"16":"In like manner, he brings you from distress,to a free and broad space, to a table filled with rich food."
,"17":"Then you will judge the wicked; justice and judgment will be yours."
,"18":"Take care lest you be seduced by generosity; do not yield to arrogance, bribery and corruption."
,"19":"Your wealth and all your mighty efforts,will not bail you out of distress."
,"20":"Do not long for the coming of night,to drag people away from their homes."
,"21":"Beware of turning to iniquity; because of it you have been tried by affliction."
,"22":"God is exalted in his power. What teacher is there like him?"
,"23":"Who has prescribed his ways for him, or said to him that he has done wrong?"
,"24":"Remember to extol his work, of which many men have sung."
,"25":"All mankind has seen it; men gaze on it from afar."
,"26":"God is great beyond our understanding; the number of his years is past reckoning."
,"27":"He holds in check the waterdrops,which distill from the mist as rain,"
,"28":"then the clouds pour them down,and drop them upon the earth as showers."
,"31":"This is the way he nourishes the land,that provides food in abundance."
,"29":"Who can understand how he spreads the clouds, how he thunders from his pavilion?"
,"30":"He unfurls his mists,and covers the expanse of the sea."
,"32":"With both hands he lifts up lightning,and commands it to strike the target."
,"33":"His thunder warns the shepherd,and the flock senses the tempest."
}`)
	CurrentBook.AddChapter(37, `{
"1":"This is why my heart pounds,and leaps from its place."
,"2":"Listen to the thunder of his voice,as it comes rumbling from his mouth."
,"3":"Under the heavens, he hurls his lightning, sending it to the ends of the earth."
,"4":"Then comes the sound of God's roar-,the majestic peal of his thunder. He does not check his thunderbolts,until his voice has fully resounded."
,"5":"God thunders and his voice works marvels; he does great things we cannot perceive."
,"6":"He says to the snow, 'Fall on the earth'; and to the rainshower, 'Be a strong downpour.'"
,"7":"So he keeps people under cover,to let them acknowledge his work."
,"8":"Wild beasts go back into their lairs,and remain quietly in their dens."
,"9":"The storm comes out from its chamber, and the cold from the driving winds."
,"10":"The breath of God forms ice, and the broad waters become frozen."
,"11":"With thunderbolts he loads the clouds, and through them scatters his lightning."
,"12":"At his direction they do their rounds, upon the face of the habitable world."
,"13":"He commands nature to punish men, to water his land or to show his mercy."
,"14":"Listen to this, O Job: pause and consider God's marvels."
,"15":"Do you know how he controls the clouds, how he makes his lightning flash?"
,"16":"Do you know how the clouds hang poised, all these wonders wrought by his perfect knowledge?"
,"17":"You who swelter in your clothes,when the earth lies still under the south wind,"
,"18":"can you, like him, spread out the skies, hard as a mirror of molten bronze?"
,"19":"Teach us then what we shall say to him; we cannot draw up our case because of darkness."
,"20":"Does it take an angel,to bring this to God's attention?"
,"21":"A while ago we could not see the light,and the clouds darkened the sky, but the storm has just cast them out."
,"22":"A blaze comes from the north, a dreadful glory around God."
,"23":"The Almighty is beyond our reach; exalted in power, great in judgment; the Master of justice oppresses no one."
,"24":"Therefore, people revere him; wise men are nothing in his sight."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Then Yahweh answered Job out of the storm:"
,"2":"Who is this that obscures divine plans,with ignorant words?"
,"3":"Gird up your loins like a man; I will question you and you must answer."
,"4":"Where were you when I founded the earth?,Answer, and show me your knowledge."
,"5":"Do you know who determined its size, who stretched out its measuring line?"
,"6":"On what were its bases set?,Who laid its cornerstone,"
,"7":"while the morning stars sang together,and the sons of God shouted for joy?"
,"8":"Who shut the sea behind closed doors,when it burst forth from the womb,"
,"9":"when I made the clouds its garment,and thick darkness its swaddling clothes;"
,"10":"when I set its limits,with doors and bars in place,"
,"11":"when I said, 'You will not go beyond these bounds; here is where your proud waves must halt?'"
,"12":"Have you ever commanded the morning, or shown the dawn its place,"
,"13":"that it might grasp the earth by its edges,and shake the wicked out of it,"
,"14":"when it takes a clay color,and changes its tint like a garment;"
,"15":"when the wicked are denied their own light, and their proud arm is shattered?"
,"16":"Have you journeyed to where the sea begins,or walked in its deepest recesses?"
,"17":"Have the gates of death been shown to you?,Have you seen the gates of Shadow?"
,"18":"Have you an idea of the breadth of the earth?,Tell me, if you know all this."
,"19":"Where is the way to the home of light, and where does darkness dwell?"
,"20":"Can you take them to their own regions, and set them on their homeward paths?"
,"21":"You know, for you were born before them, and great is the number of your years!"
,"22":"Have you entered the storehouse of the snow,or seen the storehouse of the hail,"
,"23":"which I reserve for times of woe, for days of war and battle?"
,"24":"What is the way to the place,where lightning is dispersed, or the place whence the east wind,begins spreading over the earth?"
,"25":"Who has cut a channel for the torrents of rain, and a path for the thunderstorm,"
,"26":"to bring rain to no-man's-land,and to the unpeopled wilderness,"
,"27":"to enrich the wasted and desolate ground, to make the desert bloom with green?"
,"28":"Does the rain have a father?,Who fathers the drops of dew?"
,"29":"From whose womb comes the ice, and who gives birth to the frost from the skies,"
,"30":"when the waters lie as hard as stone, when the surface of the deep is frozen?"
,"31":"Can you bind the chains of the Pleiades, or loosen the bonds of Orion?"
,"32":"Can you guide the morning star in its season, or lead the Bear with its train?"
,"33":"Do you know the laws of the heavens, and can you establish their rule on earth?"
,"34":"Can you raise your voice to the clouds,and order their waters to pour down?"
,"35":"Will lightnings flash at your command,and report to you, 'Here we are?'"
,"36":"Who has given the ibis foresight,or endowed the cock with foreknowledge?"
,"37":"Who has the wisdom to count the clouds?,Who tilts the water jars of heaven"
,"38":"so that the dust cakes into a mass,and clods of earth stick together?"
,"39":"Can you hunt the woods to appease,the hunger of the lioness and her whelps,"
,"40":"as they crouch in their dens,or lie in wait in the thicket?"
,"41":"Who provides prey for the raven,when its young cry out to God,and roam about desperate for food?"
}`)
	CurrentBook.AddChapter(39, `{
"1":"Do you know how mountain goats breed?,Have you observed the hinds in labor,"
,"2":"numbered the months they must fulfill, and fixed the time they must give birth?"
,"3":"Have you watched them end their labor,as they crouch and drop their young,"
,"4":"how they wait for them to grow, until they leave never to return?"
,"5":"Who has given the wild ass his freedom, and loosed the bonds of the wild donkey?"
,"6":"I have given him the desert for a home, the salt plains for a shelter."
,"7":"For he scorns the city's tumult, and is free of the driver's shout and insult;"
,"8":"he prefers the hills for his pasture, ranging for food in the rich verdure."
,"9":"Is the wild ox willing to serve you, to pass the night by your manger?"
,"10":"Can you make him work with a plow or harrow,if you provide him with the proper gear?"
,"11":"Can you rely on his great strength,and leave him to do your heavy work?"
,"12":"Can you depend on him to come home alone, carrying your grain to your threshing floor?"
,"13":"Can the wing of the ostrich be compared,with the plumage of the stork or falcon?"
,"14":"She lays her eggs on the ground,and lets them warm in the sand,"
,"15":"not knowing that a foot may step on them,or some wild beast may crush them."
,"16":"Cruel to her chicks as if they were not hers, she cares not that her labor be in vain,"
,"17":"for God has given her no wisdom,nor a share of good sense."
,"18":"Yet in the swiftness of foot, she makes sport of horse and rider."
,"19":"Is it you who give the horse strength,and clothe his neck with splendor,"
,"20":"who make him leap like a grasshopper,and his proud snorting strike terror?"
,"21":"Rejoicing in his strength, he fiercely paws,and charges into the fray,"
,"22":"afraid of nothing, laughing at fear, not shying away from the sword."
,"23":"Against his side rattles the quiver, along with the lance and flashing spear."
,"24":"In frenzied excitement he eats up the ground; there is no holding him when the trumpets sound."
,"25":"He cries 'Hurrah!' at each trumpet blast. He catches the scent of battle from afar, the shout of commanders and the battle cry."
,"26":"Is it by your wisdom that the hawk takes flight,and spreads his wings toward the south?"
,"27":"Is it at your command that eagles fly,and build their nests on high?"
,"28":"They dwell on cliffs and spend the night; their stronghold is the rocky crag."
,"29":"From there they look out for food, which they detect even from afar."
,"30":"They and their young feast on blood, and where the slain lie, there they are."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Yahweh said to Job:"
,"2":"Must a faultfinder contend with the Almighty?,Let him who would correct God answer."
,"3":"Job said:"
,"4":"How can I reply, unworthy as I am!,All I can do is put my hand over my mouth."
,"5":"I have spoken once, now I will not answer; oh, yes, twice, but I will do no further. Yahweh's discourse continues"
,"6":"Then Yahweh addressed Job out of the storm:"
,"7":"Gird up your loins like a man; I will question you, and you must answer."
,"8":"Would you deny my right,and condemn me that you may be justified?"
,"9":"Have you an arm like that of God, and can you thunder with a voice like this?"
,"10":"Then adorn yourself with glory and splendor, array yourself with grandeur and majesty."
,"11":"Unleash the fury of your wrath;"
,"12":"look for every proud man and abase him; crush the wicked where they stand."
,"13":"Bury them all in the dust, lock them in the dungeon."
,"14":"If you can do this, I myself will praise you, admittting that your right hand can save you."
,"15":"Just think about Behemoth, who feeds on grass like the ox."
,"16":"What strength he has in his loins, what power in the muscles of his belly!"
,"17":"Like a cedar his tail sways, the sinews of his thighs are like cables."
,"18":"His bones like tubes of bronze, his limbs like iron rods."
,"19":"He is first among the works of God, created to dominate his companions."
,"20":"The mountains give him their produce, as do all the wild beasts who play there."
,"21":"Under the lotus trees he lies, hidden among the reeds of the marsh."
,"22":"The lotus trees cover him with their shade; the poplar trees on the bank surround him."
,"23":"He is not alarmed though the river rages and torrents surge against his mouth."
,"24":"Who can capture him by the eyes, or trap him and pierce his nose?"
,"25":"Can you pull in Leviathan with a hook, or curb his tongue with a bit?"
,"26":"Can you put a ring through his nose,or pierce his jaw with a hook?"
,"27":"Will he keep begging you for mercy, or speak to you with tender words?"
,"28":"Will you make him your slave forever?"
,"29":"Will you make a pet of him like a bird, or put him on a leash for your maids?"
,"30":"Will traders bargain for him?,Will merchants sell him retail?"
,"31":"Can you fill his hide with harpoons,or his head with fish spears?"
,"32":"Just try and lay a hand on him -,you will not forget the struggle, and you will never do it again!"
}`)
	CurrentBook.AddChapter(41, `{
"1":"Any hope of subduing him is vain, for the mere sight of him is overpowering."
,"2":"He grows so ferocious when aroused,that no one dares face him."
,"3":"Who has attacked him and come off unharmed?,No one under the sky."
,"4":"I need hardly mention his limbs, nor,describe his matchless strength."
,"5":"Who can strip off his outer garment,and penetrate his double breastplate?"
,"6":"Who can dare open the gates of his mouth,to confront the terrors of his rows of teeth?"
,"7":"Rows of scales are on his back -,rows of shields that are tightly sealed."
,"8":"So closely fitted are they,that no space intervenes;"
,"9":"so closely joined,that they hold fast and cannot be parted."
,"10":"Light flashes forth when he sneezes; like the light of dawn are his eyes."
,"11":"Flaming torches and sparks of fire flash from his mouth"
,"12":"Smoke comes from his nostrils, like hot steam from a boiling pot."
,"13":"His mere breath sets coals afire, with the flame pouring from his mouth."
,"14":"Strength is in his neck, and terror dances before him."
,"15":"Tightly set are the folds of his flesh, firmly cast and immovable."
,"16":"His heart is hard as stone, as hard as the lower millstone."
,"17":"When he rises up, the mighty are terrified, the waves of the sea fall back."
,"18":"Should the sword reach him, it will not pierce him, nor will the spear, the dart, or the javelin."
,"19":"Iron is to him no more than straw; and bronze, no more than rotten wood."
,"20":"Arrows will not put him to flight; slingstones will be as wisps of hay."
,"21":"Clubs are as splinters to him; he laughs at the whirring javelin."
,"22":"His belly is as sharp as pottery sherds; he moves across the mire like a harrow."
,"23":"He churns the depths into a seething caldron; he makes the sea fume like a burner."
,"24":"Behind him he leaves a white gleaming wake, making the deep appear a hoary head of age."
,"25":"He has no equal on earth: such a horrible creature he was made!"
,"26":"He makes all, however lofty, afraid; he is king over all the sons of pride."
}`)
	CurrentBook.AddChapter(42, `{
"1":"This was the answer Job gave to Yahweh:"
,"2":"I know that you are all powerful; no plan of yours can be thwarted."
,"3b":"I spoke of things I did not understand, too wonderful for me to know."
,"5":"My ears had heard of you, but now my eyes have seen you."
,"6":"Therefore I retract all I have said, and in dust and ashes I repent."
,"7":"After Yahweh had spoken to Job, he turned to Eliphaz the Temanite, 'I am angry with you and your two friends because you have not spoken of me rightly, as has my servant Job."
,"8":"Now, take seven bulls and seven rams, go to my servant Job, offer a holocaust for yourselves and let him pray for you. I will accept his prayer and excuse your folly in not speaking of me properly as my servant Job has done.'"
,"9":"Then Eliphaz the Temanite, Bildad the Shuhite, and Zophar the Naamathite went and did as Yahweh had ordered. Yahweh accepted Job's intercession."
,"10":"After Job had prayed for his friends, Yahweh restored his fortunes, giving him twice as much as he had before."
,"11":"All his brothers and sisters and his former friends came to his house and dined with him. They showed him sympathy and comforted him for all the evil that Yahweh had brought to him. Each of them gave him a silver coin and a gold ring."
,"12":"Yahweh blessed Job's latter days much more than his earlier ones. He came to own fourteen thousand sheep, six thousand camels, a thousand yoke of oxen, and a thousand she-donkeys."
,"13":"He was also blessed with seven sons and three daughters."
,"14":"The first daughter he named Dove, the second Cinnamon, and the third Bottle of Perfume."
,"15":"Nowhere in the land was there found any woman who could compare in beauty with Job's daughters. Their father granted them an inheritance along with their brothers."
,"16":"Job lived a hundred and forty years; he saw his children and their children to the fourth generation."
,"17":"He died old and full of years."
}`)

}
func EN_CCB_LoadVSPRChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"These are proverbs of Solomon, son of David, king of Israel:"
,"2":"for you to obtain wisdom and instruction, to penetrate words of significance,"
,"3":"to acquire well-ordered knowledge, and become just with discernment and integrity."
,"4":"Simple people will become clever,and the young will acquire understanding and foresight."
,"5":"Let the wise man listen: he will add to his learning, and the man of sound judgment will acquire skill,"
,"6":"to understand the proverbs and sayings, the words of the wise and their riddles."
,"7":"The beginning of knowledge is the fear of Yahweh, only fools have contempt for wisdom and discipline."
,"8":"Listen, my son, to the teaching of your father, do not ignore your mother's instruction:"
,"9":"for they will be your graceful crown, a precious chain around your neck."
,"10":"My son, if sinners try to tempt you, do not give in."
,"11":"They will invite you, 'Come with us, let us spill blood, let us ambush the innocent without a second thought."
,"12":"We will engulf them as does the netherworld and snatch them suddenly as does death."
,"13":"We will help ourselves to many riches and fill our houses with booty."
,"14":"Join forces with us; one purse will be shared between us!'"
,"15":"My son, do not go with them, do not set foot along their way."
,"16":"See how they speed on to evil! How they hasten to spill blood!"
,"17":"What bird would fall into a trap if you set it up in its sight?"
,"18":"But these men stalk themselves and set a trap for their own lives."
,"19":"Such is the lot of all who live by plunder: plunder will rob them of their own lives."
,"20":"Wisdom shouts aloud in the streets, she raises her voice in the marketplace;"
,"21":"at street corners she cries; she delivers her speeches at the city gates:"
,"22":"'You ignorant people, how long will you continue to cling to your foolishness? How long will mockers revel in,their mockery, and fools have contempt for knowledge?"
,"23":"Listen to my warning. I will now pour my spirit upon you and make you know my words."
,"24":"Indeed if I cry out and you refuse to listen, if I offer my hand and no one cares,"
,"25":"if you ignore my advice and reject my warning,"
,"26":"I, in turn, will laugh at your disaster, I will sneer when terror grips you;"
,"27":"when terror comes down on you like a hurricane, and distress and anxiety befall you."
,"28":"Then people will cry to me but I will not respond. They will seek me but will not find me,"
,"29":"because they despised knowledge and did not choose the fear of Yahweh;"
,"30":"they would not listen to any advice and they rejected all my warnings."
,"31":"They will harvest the fruit of their evil ways and have their fill of their own designs."
,"32":"For the error of the ignorant leads to death, the idleness of fools brings about their ruin."
,"33":"But whoever listens to me will feel secure and at ease, without fear of evil.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"My son, if you heed my words and value my commands,"
,"2":"with your ear attentive to wisdom and your heart obedient to understanding;"
,"3":"if you call for perception and raise your voice for insight;"
,"4":"if you seek it as silver and search for it more than any treasure"
,"5":"then you will understand the fear of Yahweh, and you will find the knowledge of God."
,"6":"For Yahweh gives wisdom and from his mouth come knowledge and insight."
,"7":"He reserves his help for the upright and is a shield for those who walk in integrity;"
,"8":"he guards the ways of the just and protects the steps of his faithful."
,"9":"Then you will understand justice, discernment and integrity - all that leads you to happiness."
,"10":"Wisdom will abide in your heart and knowledge will comfort your inner self."
,"11":"Foresight will guide you and understanding will protect you."
,"12":"It will guard you from evil, from people of misleading speech,"
,"13":"from those who have abandoned the ways of honesty to walk the roads of darkness;"
,"14":"they rejoice in evildoing, they revel in perversions;"
,"15":"their paths are crooked and their ways devious."
,"16":"Wisdom keeps you from the alien woman, from the stranger with her smooth words,"
,"17":"who deserts the partner of her youth and forgets the covenant of her God."
,"18":"For her house inclines towards death, her paths towards the grave."
,"19":"Those who go to her never return, they do not regain the paths of life."
,"20":"So you will walk along the way of the good, and keep to the paths of the virtuous."
,"21":"For the honest will inherit the land; the people of integrity will live on it."
,"22":"The evildoers instead will be cut off from the land. The wicked will be rooted out of it."
}`)
	CurrentBook.AddChapter(3, `{
"1":"My son,do not forget my instruction, my commands; keep them in your heart."
,"2":"For they will bring you length of days, years of life and peace."
,"3":"Let loyalty and kindness never leave you; tie them around your neck, write them on the tablet of your heart,"
,"4":"that you may find favor and a good name in the eyes of God and man."
,"5":"Trust in Yahweh with all your heart; do not rely on your own insight."
,"6":"Let his presence pervade all your ways and he will protect your foot from the snare."
,"7":"Do not consider yourself wise, fear God, and turn away from evil."
,"8":"This will be a medicine to your body and a relief to your bones."
,"9":"Honor Yahweh, giving him from what you have, the first fruits of all your produce."
,"10":"Then your barns will be filled to overflowing, your vats will brim over with wine."
,"11":"My son, do not scorn the discipline of Yahweh; do not ignore his correction."
,"12":"For Yahweh corrects those he loves, as a father does his beloved son."
,"13":"Happy the one who finds wisdom and gains insight."
,"14":"For she is of more value than silver and more useful than gold."
,"15":"She is more precious than pearls; nothing you could wish for would compare with her."
,"16":"With her right hand she offers you length of days, with her left, riches and glory."
,"17":"She leads you through delightful ways; all her roads are peace."
,"18":"She is a tree of life for those who clasp her; those who possess her are happy."
,"19":"It is by his wisdom that Yahweh founded the earth; by his understanding that he made firm the heavens."
,"20":"By his knowledge the depths were scooped out, and the clouds rained down dew."
,"21":"My son, hold on to sound judgment and discretion and do not let them out of your sight."
,"22":"They will give life to your inner self, and adorn your neck."
,"23":"Then you can go your way safely and your foot will not stumble."
,"24":"You will have no fear when you lie down and your sleep will be peaceful."
,"25":"You will not fear sudden terror or the attack of evildoers."
,"26":"For Yahweh is at your side and he guards your steps from the snare."
,"27":"Do not hold back from those who ask your help, when it is in your power to do it."
,"28":"Do not say to your neighbor, 'Go away! Come another time; tomorrow I will give it to you!' when you can help him now."
,"29":"Do not plot evil against your neighbor who lives trustingly beside you,"
,"30":"nor fight a man without cause when he has done you no wrong."
,"31":"Do not envy the man of violence or follow his example."
,"32":"For Yahweh hates the wicked but guides the honest."
,"33":"He curses the house of the evildoer but blesses the home of the upright."
,"34":"If there are mockers, he mocks them in turn but he shows his favor to the humble. The wise will possess his glory while the foolish will inherit disgrace."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Listen, my sons, to a father's instruction and pay attention so that you may gain insight."
,"2":"For I have given you good principles; do not discard my teaching!"
,"3":"For when I, too, was a young boy, and my mother fondly looked on me as special,"
,"4":"my father taught me and said to me: Treasure my words in your heart; listen to my directions and you will live."
,"5":"Acquire wisdom and insight and do not forget or reject the words of my mouth."
,"6":"Do not abandon wisdom for she will protect you. Love her and she will be your salvation."
,"7":"The beginning of wisdom is to work to acquire it. At the cost of all you possess, strive to gain insight."
,"8":"Hold her close, for she will exalt you and bring you honor if you embrace her."
,"9":"She will crown you with grace and put a diadem of splendor on your head."
,"10":"Listen, my son, and take my words to heart; then the years of your life will be multiplied."
,"11":"Because I have taught you the way of wisdom and have guided you along honest ways,"
,"12":"you will walk with ease and run without falling."
,"13":"Hold firm to discipline; never let her go. Guard her well for she is your salvation."
,"14":"Do not follow the way of the wicked nor walk with evildoers."
,"15":"Avoid them, turn your back on them and pass on."
,"16":"For they do not sleep unless they have done evil; they cannot rest unless they have caused someone's downfall."
,"17":"Wickedness is their bread and violence their wine."
,"18":"The way of the upright is like the dawn that becomes brighter until the fullness of day."
,"19":"The way of the wicked is total darkness and they do not notice that which will make them fall."
,"20":"My son, be attentive and listen carefully to my words."
,"21":"Never let them out of your sight but guard them in the bottom of your heart."
,"22":"For they are life to those who cling to them and healing for the inner spirit."
,"23":"Above all else, guard your heart, for therein is the source of life."
,"24":"Keep your mouth from,lies,and,let,not,deceit,come,from,your lips."
,"25":"Keep your sight on what is ahead and your eyes directed straight in front of you."
,"26":"Test the ground under your feet and all your ways will be secure."
,"27":"Turn neither to left nor to right and keep your path from evil."
}`)
	CurrentBook.AddChapter(5, `{
"1":"My son, pay heed to my wisdom and listen to my insights;"
,"2":"remember my counsel and let your lips not depart from this knowledge."
,"3":"Know that the lips of the adulteress are sweet as honey and her words smoother than oil,"
,"4":"but the outcome is bitter as herbs. It is as sharp as a double-edged sword."
,"5":"Her feet go down to the grave and her steps lead to death."
,"6":"She pays no attention to the path of life and strays without knowing it."
,"7":"Now then, my son, listen to me and do not forget my words:"
,"8":"Stay away from her and never approach the door of her house,"
,"9":"lest you surrender your honor to strangers and your best years to cruel men,"
,"10":"lest others benefit from your goods, and your earnings go to an alien house."
,"11":"You will complain in the end, when your body and flesh are already devoured and"
,"12":"you will say, 'Why did I reject instruction and turn my back on sound advice?"
,"13":"Why did I not listen to the voice of my teachers and follow their counsel?"
,"14":"For I have come to the depths of disgrace in the midst of the whole community.'"
,"15":"Drink, then, from the water of your own cistern, from that which flows in your own well."
,"16":"Do not let your fountains be wasted elsewhere nor in the public streets."
,"17":"They are for you alone and not for strangers."
,"18":"May your fountainhead be blessed and may you find joy in the wife of your youth,"
,"19":"your beautiful hind and graceful gazelle! May her breasts be your delight at all times: be always in love with her."
,"20":"My son, why be infatuated with an adulteress and embrace a strange woman?"
,"21":"For Yahweh watches the ways of men and he observes all their paths."
,"22":"The wicked will be caught in his own evil and remain entangled in the nets of his own sin."
,"23":"He will die for want of discipline and will drown in the rising tide of his own evil."
}`)
	CurrentBook.AddChapter(6, `{
"1":"My son, if you have stood bail for your neighbor or guaranteed the word of a stranger;"
,"2":"if you have committed yourself with your own lips, know that you have trapped yourself with your own words."
,"3":"Then do this, my son: release yourself. If you have fallen into the hands of your neighbor, go speedily, kneel down and plead with him;"
,"4":"do not give sleep to your eyes or rest to your eyelids."
,"5":"Break free, like a gazelle from the trap or a bird from the hand."
,"6":"You idler, go to the ant, watch her ways and be wise."
,"7":"She has no master, no steward or overseer."
,"8":"She secures food in summer and stores up provisions during harvest time."
,"9":"How long, you idler, are you going to lie around? When do you intend to rise from sleep?"
,"10":"A little sleep, a little drowsiness and your laziness creeps upon you and then, like a tramp,"
,"11":"poverty comes, bringing misery like a vagabond."
,"12":"The villain, the unjust man, goes about with a sneer on his lips,"
,"13":"winking his eye, shuffling his feet and beckoning with his finger."
,"14":"His heart is deceitful; he is forever plotting evil and causing arguments."
,"15":"Therefore, disaster will suddenly and irrevocably overtake him."
,"16":"There are six things Yahweh hates; seven his inner being detests:"
,"17":"the proud look, the lying tongue, hands which spill innocent blood,"
,"18":"the depraved heart, feet which speed towards evil,"
,"19":"a false and lying witness and the one who sows discord among people."
,"20":"My son, respect your father's instruction and do not reject your mother's teaching."
,"21":"Hold them forever in your heart and hang them around your neck."
,"22":"These will guard your footsteps, protect you when you sleep and speak to you on waking."
,"23":"For the commandment is a lamp and the teaching a light; correction teaches you the way of life."
,"24":"It will protect you from the evil woman, the smooth talking of the stranger."
,"25":"Do not covet her beauty in your heart or let her captivate you with her looks."
,"26":"For the prostitute deserves a piece of bread but the adulteress hunts after your worthy life."
,"27":"Can you hold fire in your pocket without setting fire to your clothes or"
,"28":"walk on hot coals without burning your feet?"
,"29":"So it is for the man who approaches his neighbor's wife: all who touch her will be punished."
,"30":"One does not condemn the hungry thief who steals to fill his stomach;"
,"31":"nevertheless, if he is caught, he must pay sevenfold and give all the goods in his house."
,"32":"How senseless is the adulterer! Whoever commits adultery destroys himself."
,"33":"He will reap blows and contempt and his disgrace will not be erased."
,"34":"Jealousy inflames the husband's heart and when he can take revenge he will have no mercy."
,"35":"He will accept nothing, neither reparation nor lavish gifts."
}`)
	CurrentBook.AddChapter(7, `{
"1":"My son, keep my words and remain faithful to my commands."
,"2":"Hold fast to my instruction and you will have life; treasure my teachings as the apple of your eye."
,"3":"Bind them on your fingers, write them on the tablets of your heart."
,"4":"Let wisdom be your sister and knowledge your friend,"
,"5":"so that you will be saved from the adulterous woman, from the stranger with her enticing words."
,"6":"From my window I was looking out through the lattice and"
,"7":"I saw among the young men, an inexperienced youth"
,"8":"who walked along the road near her corner, towards the path to her house."
,"9":"It was dusk, daylight was fading - the time of darkness and shadow."
,"10":"And look! Out comes this woman to meet him, dressed like a prostitute, covered with a veil."
,"11":"She is brazen and shameless, unable to remain in the house."
,"12":"Now at the corner, now in the square, she is on the lookout."
,"13":"She throws herself at him, kisses him and confidently says,"
,"14":"'I have to offer sacrifices and terminate my vows; because of this"
,"15":"I came out to meet you. I sought and found you."
,"16":"I have spread on my bed quilts and fine Egyptian sheets and"
,"17":"sprinkled it with myrrh, aloes and cinnamon."
,"18":"Come, let us abandon ourselves to pleasure and drink our fill of love all night,"
,"19":"for my husband is not at home but away on a long journey."
,"20":"He has taken his moneybags and will not return before the full moon.'"
,"21":"She led him astray with such smooth and seductive words."
,"22":"At once he followed her, as an ox led to slaughter or a deer caught in a snare"
,"23":"until its liver is pierced by an arrow; as a bird springs at the snare unaware that its life is at stake."
,"24":"Now then, my sons, listen and pay attention to my words."
,"25":"Do not be led astray or lose yourself on her paths."
,"26":"For she has brought many to their death and the strongest were all her victims."
,"27":"Her house leads to hell and death."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Who calls? Is it not Wisdom?,Who lifts up her voice?"
,"2":"Is it not Knowledge?,She shouts from the hilltops,and waits by the crossroads;"
,"3":"in the vicinity of the city gates she speaks,"
,"4":"'It is you, O men, I address,for my message is directed to all mankind,"
,"5":"so that the ignorant may learn,and the thoughtless come to their senses."
,"6":"Listen to me for I speak of vital things,and everything I say is true."
,"7":"Truthful words come from my mouth,and my lips do not lend themselves to evil."
,"8":"All my words are right, none are twisted or deceitful."
,"9":"The intelligent will verify their truth, the wise perceive their sincerity."
,"10":"Prefer my teaching to silver,and seek wisdom rather than gold,"
,"11":"because wisdom has more value than any jewel,and none of men's desires can equal it."
,"12":"I, Wisdom, dwell with discretion,and count prudence among my friends."
,"13":"The fear of Yahweh is rejection of evil. I hate all pride, arrogance, wicked ways and lies,"
,"14":"but I love counsel, discretion, prudence and strength."
,"15":"Kings reign by my power, their ministers issue just laws;"
,"16":"by me princes govern, and the great and noble of the earth as well."
,"17":"I love those who love me,and go to meet those who seek me."
,"18":"Riches and honor are with me, true well-being and upright living."
,"19":"More precious than silver and gold,are my fruit and my yield."
,"20":"I proceed on the path of righteousness,and make use of the ways of justice,"
,"21":"giving riches to those who love me, and filling their cellars."
,"22":"Yahweh created me first, at the beginning of his works."
,"23":"He formed me from of old, from eternity, even before the earth."
,"24":"The abyss did not exist when I was born, the springs of the sea had not gushed forth,"
,"25":"the mountains were still not set in their place,nor the hills, when I was born"
,"26":"before he made the earth or countryside, or the first grains of the world's dust."
,"27":"I was there when he made the skies,and drew the earth's compass on the abyss,"
,"28":"when he formed the clouds above,and when the springs of the ocean emerged;"
,"29":"when he made the sea with its limits, that it might not overflow. When he laid the foundations of the earth,"
,"30":"I was close beside him, the designer of his works, and I was his daily delight, forever playing in his presence,"
,"31":"playing throughout the world,and delighting to be with the sons of men."
,"32":"Now then, my sons, listen to me: happy are those who follow my ways."
,"33":"Listen to my teaching and gain wisdom; do not ignore it."
,"34":"Happy are those who listen to me,and wait at my gates every day, watching, close to my threshold."
,"35":"Those who find me find life: theirs is Yahweh's blessing."
,"36":"Those who offend me will undergo affliction; they hate me for they love death."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Wisdom has built her house,set upon seven pillars;"
,"2":"she has slaughtered her beasts, prepared her wine and laid her table."
,"3":"Next, she sent her servants to call,from the central square of the city,"
,"4":"'Pass by here, you who are fools.',To the senseless she says,"
,"5":"'Come, eat and drink,of the bread and wine I have prepared."
,"6":"Give up your foolishness and you will live; take the straight path of discernment.'"
,"7":"He who corrects a mocker gains insults; and he who reprimands an evildoer receives abuse."
,"8":"Do not rebuke the mocker lest he hate you, but counsel the wise who will be grateful."
,"9":"Give to the wise man and he will become wiser each day; teach an upright man and he will increase his wisdom."
,"10":"Fear of Yahweh is the beginning of wisdom and to know the Holy One brings discernment."
,"11":"Then I will multiply your days and increase your years of life."
,"12":"If you are wise your wisdom will work to your advantage, but if you mock you alone will be harmed."
,"13":"Lady Foolishness is impetuous, a simpleton who knows nothing."
,"14":"She sits at the door of her house, on a throne in the central square of the city,"
,"15":"to invite all passersby, 'Come here, whoever is ignorant.'"
,"16":"To the foolish she says,"
,"17":"'Stolen waters are sweet and pilfered bread is the tastiest.'"
,"18":"But he does not see the Shadow world lying there; nor realize that its guests are heading towards the abyss of death."
}`)
	CurrentBook.AddChapter(10, `{
"1":"A wise son is his father's joy, a foolish one his mother's heartbreak."
,"2":"Treasures wrongfully acquired are of no value but upright living saves from death."
,"3":"Yahweh does not let the upright man go hungry but he denies satisfaction to the evildoers."
,"4":"The lazy hand brings poverty; the diligent hand brings wealth."
,"5":"The prudent man reaps in summer; the one who sleeps at harvest time deserves scorn."
,"6":"Blessings on the head of the upright man! Violence silences the cry of the wicked."
,"7":"The upright man will be remembered with blessings, the name of the wicked will rot away."
,"8":"The sensible man is open to instruction, the chattering fool speeds towards ruin."
,"9":"He who behaves honorably will walk safely, but the follower of crooked ways will be punished."
,"10":"The wink of an eye brings trouble; but a rebuke wins peace."
,"11":"The mouth of an upright man is a source of life, but violence is concealed in the mouths of evildoers."
,"12":"Hatred enkindles disputes, love covers over all offenses."
,"13":"Wisdom is to be found on the lips of the discerning man; the stick is for the fool's back."
,"14":"The wise man stores up learning but the mouth of the fool makes way for ruin."
,"15":"The rich man's fortune is his fortress, the poverty of the poor is their undoing."
,"16":"The virtuous man's toil brings him life, while the sins of the evil man destroy him."
,"17":"Respect for discipline is the path of life; he who ignores correction is doomed."
,"18":"Hypocritical is he who tolerates hatred; he who slanders is a fool."
,"19":"Sin will not be lacking where too many words are spoken; the prudent man controls his tongue."
,"20":"The upright man's tongue is pure silver, but the hearts of evildoers have little value."
,"21":"The lips of one upright man feed many people while fools die for lack of sense."
,"22":"The blessing of Yahweh brings riches, no effort can replace it."
,"23":"The fool delights in doing evil and the wise man in acquiring wisdom."
,"24":"The evildoer will encounter the evil he dreaded whereas the upright man will receive what he looked forward to."
,"25":"After the storm the wicked man is seen no more, but the upright man remains forever."
,"26":"The lazy man is like vinegar to the teeth and smoke to the eyes of his master."
,"27":"Fear of Yahweh lengthens one's life, but the years of the wicked will be cut short."
,"28":"The hope of the upright ends in happiness but the expectations of the wicked come to nothing."
,"29":"The ways of Yahweh are a fortress for the upright but for evildoers only ruin."
,"30":"The virtuous man will never be disturbed but evildoers will not survive on the land."
,"31":"Wisdom springs forth from the mouth of the virtuous but the corrupt tongue will be torn out."
,"32":"Goodness dwells on the lips of the upright, corruption in the mouth of the wicked."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Yahweh detests a false scale but a just weight pleases him."
,"2":"Disgrace always accompanies pride; wisdom resides with the humble."
,"3":"Honesty illumines the path of the upright; but the corrupt are confounded by their own evil."
,"4":"On the day of vengeance riches will prove useless but honest living will save from death."
,"5":"The virtuous man's integrity smooths his way, while the wicked man falls by his own evil."
,"6":"Upright living saves the virtuous while evildoers are caught in their own greed."
,"7":"The hope of the wicked is buried with them and their trust in riches is of no avail."
,"8":"The upright will escape from distress; a wicked man will take his place."
,"9":"The godless man uses his mouth to destroy his neighbor but the virtuous use their wisdom to save themselves."
,"10":"The city rejoices in the good fortune of the upright and delights in the ruin of the wicked."
,"11":"A city is raised on the blessing of honest men and destroyed by the mouth of the wicked."
,"12":"Whoever mocks his neighbor is a fool; the wise man chooses silence."
,"13":"The gossip reveals secrets, but the trustworthy man keeps a secret."
,"14":"Lack of guidance leads to a nation's decline whereas numerous counselors bring success."
,"15":"He who stands bail for a stranger harms himself; he who avoids going bail will be safe."
,"16":"A gracious woman wins renown, and bold men acquire riches."
,"17":"The generous man does himself a favor while a cruel man wounds his own flesh."
,"18":"The pay of the wicked is an illusion; while the upright man reaps a sure reward."
,"19":"Upright living leads to life but the way of evil leads to death."
,"20":"Yahweh detests the corrupt of heart but loves those whose life is upright."
,"21":"Be assured that the wicked will not go unpunished, and the sons of the virtuous will be saved."
,"22":"The pretty woman without discretion is like a gold ring in the snout of a pig."
,"23":"The upright desire nothing but good; the desires of the wicked are in vain."
,"24":"Those who are generous increase their riches; others are misers and impoverish themselves."
,"25":"The warmhearted soul will prosper; he who waters will himself be watered."
,"26":"He who hoards wheat is cursed by the people; blessed is he who sells his seeds."
,"27":"Yahweh rewards the one who seeks good; but he who pursues evil will be caught by it."
,"28":"He who trusts in riches will stumble; while the upright will flourish like leaves."
,"29":"Whoever mismanages his house will inherit only wind; the fool will end up a slave of the wise."
,"30":"The fruit of the upright is a tree of life while the wicked are uprooted before their time."
,"31":"If here on earth the upright get their due, how much more the wicked and the sinner!"
}`)
	CurrentBook.AddChapter(12, `{
"1":"He who loves discipline, loves knowledge; foolish is he who rejects correction."
,"2":"The good man wins the favor of Yahweh who condemns the one of evil schemes."
,"3":"No man is made secure by evil but nothing undermines the roots of the upright."
,"4":"A good wife is her husband's crown while the shameless woman is like a cancer in his bones."
,"5":"The plans of the upright are honest and the plottings of the wicked deceitful."
,"6":"The words of the wicked are mortal snares but the virtuous refute and elude them."
,"7":"The evildoers are thrown down and are no more; but the house of the virtuous will never crumble."
,"8":"Everyone is praised in proportion to his prudence; while the corrupt of heart will be met with contempt."
,"9":"Better to be a common man and have a servant than to feel oneself great and run short of bread."
,"10":"The upright man looks after his animals but the wicked are heartless."
,"11":"He who cultivates the earth will have his fill of bread, while the fool chases after illusions."
,"12":"The desires of the wicked produce evil, but the roots of the virtuous produce fruit."
,"13":"The wicked man is entangled in his own lies, but the virtuous man will be saved from misfortune."
,"14":"Those who meditates on wisdom will attain all that is good; each one is rewarded according to the works of his hands."
,"15":"The fool considers his way right while the wise man listens to advice."
,"16":"The fool shows his annoyance immediately, but the discreet man overlooks an insult."
,"17":"The trustworthy witness leads to the truth, and the liar to confusion."
,"18":"The one who speaks thoughtlessly pierces like a sword; but the words of the wise bring healing."
,"19":"Truthful words endure forever but lies, for only a moment."
,"20":"Deceit dwells in the heart of the schemer, happiness in those who pursue peace."
,"21":"No misfortune will befall the virtuous but the wicked will have their fill of troubles."
,"22":"Yahweh hates the lips of liars and loves those who speak the truth."
,"23":"The discreet man conceals his wisdom while fools make public their nonsense."
,"24":"The hardworking hand will rule; and the lazy will have to obey."
,"25":"Intense grief depresses the heart while a friendly word makes it glad."
,"26":"The just man guides his neighbor while the way of the wicked leads them astray."
,"27":"The lazy hand will have no game to cook: being industrious is the secret of wealth."
,"28":"Life is to be found on the path of virtue, the way of the wicked leads to death."
}`)
	CurrentBook.AddChapter(13, `{
"1":"An intelligent son listens to his father's advice, but a mocker listens to no correction."
,"2":"A man can taste goodness from the fruit of his own mouth, but the treacherous feed on violence."
,"3":"He who guards his mouth preserves his life, the constant talker is lost."
,"4":"The lazy man hopes but his desires are in vain, whereas hard workers have their desires fulfilled."
,"5":"The upright man hates lying words but the evildoer slanders and defames."
,"6":"Virtue protects men of honest life; while sin brings ruin to the wicked."
,"7":"One pretends to be rich but has nothing, another, of great wealth, feigns poverty."
,"8":"A man's wealth lets him ransom his life but the poor man has nothing with which to do so."
,"9":"The light of the virtuous is bright, the lamp of the godless is extinguished."
,"10":"Arrogance only brings trouble; wisdom is found in those who take advice."
,"11":"Sudden riches will decrease, he who gathers little by little will be enriched."
,"12":"Delayed hope makes the heart languish, but desire fulfilled is a tree of life."
,"13":"The one who scorns teaching will be in want, those who respect the commandment will be rewarded."
,"14":"The wise man's teaching is a life-giving fountain for escaping the snares of death."
,"15":"Prudent intelligence wins favor, the way of liars leads nowhere."
,"16":"Every prudent man acts with reflection, the fool parades his stupidity."
,"17":"A wicked messenger falls on misfortune, the reliable one brings healing."
,"18":"Poverty and shame to the one who rejects correction; honor to him who accepts rebuke."
,"19":"Desire fulfilled is sweet to the soul; but fools spurn rejection of evil."
,"20":"Walk with the wise and you will gain wisdom; those who befriend fools become wicked."
,"21":"Misfortune hounds the sinner, while the upright abound in good fortune."
,"22":"A good man's inheritance is for his children's children, a sinner's wealth will be kept for the virtuous."
,"23":"The tillage of the poor supplies food, while others perish because of their lack of righteousness."
,"24":"Unloved is the child whom the father hates to punish; the loving father frequently corrects."
,"25":"The upright man eats his fill, while the stomach of the wicked goes hungry."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Wisdom builds her house, foolishness destroys it with her own hands."
,"2":"Upright living is fear of Yahweh, but he who is devious in his ways scorns him."
,"3":"From the fool's mouth comes the rod of his pride, the wise man's lips protect him."
,"4":"Where there's no oxen, there's no wheat, in the oxen's strength there's abundant harvest."
,"5":"The truthful witness does not lie; the false witness breathes deceit."
,"6":"The mocker searches for wisdom in vain; knowledge comes easily to the discreet man."
,"7":"Keep away from the fool for you will find no wisdom in his words."
,"8":"The wisdom of the discreet man lies in guarding his conduct, but the foolishness of fools is full of deceit."
,"9":"Fools never make amends, while goodwill dwells among the upright."
,"10":"The heart understands its own grief; no stranger can share in its joy."
,"11":"The house of the wicked will be destroyed, but the tent of the upright will stand firm."
,"12":"To one, his way appears correct, but in the end it leads to death."
,"13":"The heart feels pain in the midst of laughter, and joy ends in sorrow."
,"14":"The reckless man reaps the fruit of his ways; the good man will earn reward."
,"15":"The simpleton believes all he's told, the prudent man watches his step."
,"16":"The wise man fears and avoids evil, the fool goes near and feels safe."
,"17":"The angry man does foolish things, the crafty man makes himself hated."
,"18":"Foolishness is the inheritance of fools, the prudent choose wisdom as their crown."
,"19":"The wicked shall kneel before the good, and the godless, before the gates of the virtuous."
,"20":"The poor man is detestable even to his neighbor while the rich man has many friends."
,"21":"A sinner is he who looks down on his neighbor, happy is he who shows pity to the poor."
,"22":"Does evil plotting not lead to ruin? Do goodness and sincerity not belong to those devoted to good?"
,"23":"Hard work yields a profit but the idler brings misfortune."
,"24":"Wealth is the wise man's crown, foolishness the diadem of fools."
,"25":"A truthful witness saves lives; he who lies will be lost."
,"26":"There is great security in the fear of Yahweh, his sons find refuge in him."
,"27":"The fear of Yahweh is a life-giving fountain for escaping the snares of death."
,"28":"Numerous people are a king's glory; lack of subjects ruins a prince."
,"29":"The discerning man is slow to anger, the impatient one displays stupidity."
,"30":"A peaceful heart is the body's life but the passions are a cancer in the bones."
,"31":"Oppression of the weak insults their creator, he is honored by those who have compassion on the needy."
,"32":"The evildoer is overthrown by his own evil, the upright man feels safe up to death."
,"33":"Wisdom resides in the heart of the discerning; who ever sees her among fools?"
,"34":"Virtue makes a nation great; the sinner disgraces a people."
,"35":"The clever servant enjoys the king's favor but the fool has to suffer his anger."
}`)
	CurrentBook.AddChapter(15, `{
"1":"A kind answer soothes anger; while a cutting word increases wrath."
,"2":"The tongue of the wise speaks knowledge, but the mouth of fools spreads stupidity."
,"3":"The eyes of Yahweh are everywhere, watching the good and the evil."
,"4":"The pacifying tongue is a tree of life, while the viper's tongue destroys the heart."
,"5":"Paternal correction is scorned by the fool, but the one who listens shows discretion."
,"6":"Abundance resides in the house of the virtuous, but disgrace descends on the profits of the wicked."
,"7":"Wise men's lips sow knowledge whereas the fool's thoughts are not safe."
,"8":"Yahweh detests the sacrifice of the wicked, but listens to the prayer of the honest man."
,"9":"Yahweh abhors the conduct of the wicked but loves him who seeks virtue."
,"10":"Correct severely him who strays from the way; whoever hates being rebuked will die."
,"11":"Yahweh sees into hell and the abyss; how much more into the hearts of the sons of men!"
,"12":"The mocker does not like being reprimanded; he does not go to the wise."
,"13":"A glad heart brightens the face, a sad one weighs down the spirit."
,"14":"A discerning heart seeks knowledge, but the mouth of fools feeds on stupidity."
,"15":"Every day is evil to the afflicted one; while the happy heart is always feasting."
,"16":"Better to have little but fear the Lord than to have a fortune accompanied by anxiety."
,"17":"Better to have vegetables where there is love than to have a fattened ox with nothing but hatred."
,"18":"The hotheaded man provokes disputes, while the one slow to anger reconciles differences."
,"19":"The way of the lazy man is strewn with thorns, but the path of hard workers is a spacious road."
,"20":"The wise son is his father's joy, the foolish man despises his mother."
,"21":"Foolishness appeals to the man with no sense but the discerning man goes on his way."
,"22":"Plans fall through for lack of deliberation; a multitude of counselors ensures success."
,"23":"Happy is he who knows how to answer. Welcome indeed is the apt word!"
,"24":"To the discerning man, the way of life leads upward; he will be saved from the place of darkness below."
,"25":"Yahweh tears down the house of the proud, but he strengthens the widow's boundaries."
,"26":"Yahweh detests corrupt designs but words of goodness are pleasing to him."
,"27":"He who craves dishonest gain brings trouble on his house; he who accepts no tempting bribes will live."
,"28":"The man of upright heart thinks before he speaks, the mouth of the wicked pours out evil."
,"29":"Yahweh stays far away from the wicked but hears the prayer of the virtuous."
,"30":"A kind look delights the heart, good news revives one's strength."
,"31":"The ear which listens to helpful correction is found among the wise."
,"32":"He who ignores correction despises himself, he who heeds the reprimand acquires discernment."
,"33":"The fear of Yahweh is a school of wisdom; humility precedes praise."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Man's heart makes plans but it is Yahweh who answers."
,"2":"Although people are satisfied with all of their deeds Yahweh considers the motives."
,"3":"Entrust all you do to Yahweh and your plans will be realized."
,"4":"Yahweh made everything for a purpose, even the evildoer for the day of punishment."
,"5":"Yahweh hates the arrogant heart; you can be sure it will not go unpunished."
,"6":"With goodness and faithfulness you atone for your sin; with fear of Yahweh you may turn away from evil."
,"7":"When Yahweh is pleased with a man's conduct, he reconciles even his enemies with him."
,"8":"Better to have little but be just than to have a great income without honesty."
,"9":"Man's heart seeks the right way but it is Yahweh who makes his footsteps sure."
,"10":"The lips of the king utter oracles; he will not be mistaken when he judges."
,"11":"Yahweh demands a just balance and scales; the weights are the work of his hands."
,"12":"Kings who do evil are an abomination; it is justice that supports the kingship."
,"13":"He who judges according to justice wins the king's favor, honest men are pleasing to him."
,"14":"The king's anger is a messenger of death but the wise man knows how to appease him."
,"15":"The king's serene countenance means life, his favor is like the spring rain."
,"16":"Better to have acquired wisdom rather than gold, discernment rather than silver."
,"17":"The way of the honest man is to turn away from evil; he who watches his steps keeps his life safe."
,"18":"Pride goes before destruction, an arrogant spirit before a fall."
,"19":"Better be humble among the lowly than share loot with the proud."
,"20":"He who listens to the word will find happiness; blessed is he who trusts in Yahweh."
,"21":"He whose heart is wise will be proclaimed discerning; moderate speech brings knowledge."
,"22":"Good sense is a life-giving fountain to those who possess it, foolishness is the punishment of fools."
,"23":"The wise man's heart keeps guard over his mouth, making his words more effective."
,"24":"Kind words are like a honeycomb: sweet to the spirit and healthy to the body."
,"25":"To one, his way seems honest, but ultimately it leads to death."
,"26":"The worker's appetite works to his benefit; the need to eat spurs him on."
,"27":"The troublemaker prepares disgrace, a scorching fire is on his lips."
,"28":"The scoundrel stirs up trouble; his critical comments split up friends."
,"29":"A violent man deceives his neighbor and leads him along a path that is not good."
,"30":"He who closes his eyes and purses his lips to plot deceit already commits evil."
,"31":"White hairs are a magnificent crown for the one who has followed the path of virtue."
,"32":"The patient man is to be preferred to the hero; better the man who masters himself than the conqueror of cities."
,"33":"Fate is thrown in the bag but the decision depends on Yahweh."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Better a crust of dry bread in peace than the discord of a house full of feasting."
,"2":"A shrewd servant will replace the foolish son of the master and will share the inheritance as one of the brothers."
,"3":"A crucible for silver and a furnace for gold but Yahweh is the tester of hearts."
,"4":"The evil plotter listens to the lips of liars; and the liar gives an ear to the corrupt tongue."
,"5":"He who mocks the poor insults their Creator, he who laughs at the deprived will not go unpunished."
,"6":"The crown of the aged is their children's children, the children's glory is their father."
,"7":"Noble language does not suit the fool and even less do lies suit a prince."
,"8":"The giver of gifts possesses a treasure, wherever he goes he will succeed."
,"9":"Whoever covers over a fault promotes friendships, but he who reveals a word divides friends."
,"10":"A discerning man is more impressed by a reprimand than a fool is by a hundred lashes."
,"11":"The wicked man seeks nothing but rebellion; a cruel messenger will be sent against him."
,"12":"It is better to meet with a bear deprived of her cubs than with a fool in his foolishness."
,"13":"He who repays good with evil will not rid his house of evil."
,"14":"To begin legal proceedings is like opening a dam; withdraw before the dispute erupts."
,"15":"To excuse the guilty and condemn the just: both are detestable to Yahweh."
,"16":"What good is money in a fool's hand? How can he buy wisdom? He has no sense."
,"17":"A friend will love you at all times, a brother has been born to you for times of adversity."
,"18":"He who is full of promises and goes bail for his neighbor has no sense."
,"19":"The sinner loves disputes, the man of arrogant words hastens his own ruin."
,"20":"The man of double-dealing does not find happiness, the sly tongue falls into disgrace."
,"21":"He who fathers a fool has acquired misery, there is no joy for a fool's father."
,"22":"A joyful heart gives health to the body, while a sad spirit dries up the bones."
,"23":"The corrupt man takes bribes to pervert the course of justice."
,"24":"The discerning man keeps wisdom before his eyes; the fool's eyes are on every corner of the world."
,"25":"The foolish son is a worry to his father and distress to her who gave him birth."
,"26":"It is not right to fine the upright; the noble ought not to be beaten."
,"27":"The prudent of speech are wise; he who keeps his temper is an educated man."
,"28":"Then the fool, if silent, can pass as wise; the clever man keeps his lips sealed."
}`)
	CurrentBook.AddChapter(18, `{
"1":"He who holds himself aloof follows his own whims and is annoyed at others' advice."
,"2":"The fool does not relish reflection but only the airing of his own views."
,"3":"When the wicked come, scorn also comes, and offense brings shame."
,"4":"Man's words are like deep waters; an overflowing torrent is the fountain of wisdom."
,"5":"It is not good to give consideration to the wicked or to harm the virtuous when giving judgment."
,"6":"The fool's lips cause disputes and his mouth attracts blows."
,"7":"The fool's mouth is his undoing; his lips will ensnare his life."
,"8":"The gossiper's words are tasty mouthfuls which go right to the bottom of the stomach."
,"9":"He who dawdles at work is a brother of the destroyer."
,"10":"Yahweh's name is a strong tower, the virtuous rely on it and are safe."
,"11":"The rich man's wealth is his fortress; he relies on it as on a high wall."
,"12":"Before its downfall, the heart is wrapped in pride; while humility goes before honor."
,"13":"To argue before listening to the facts shows stupidity which leads to disgrace."
,"14":"The spirit of man sustains him when ill but who will lift the one of broken spirit?"
,"15":"The discerning heart obtains wisdom, the ear of the wise searches out knowledge."
,"16":"A present opens all doors to you and brings you into the company of the powerful."
,"17":"The first to plead his case seems to be right, but his opponent appears and there is matter for trial."
,"18":"Casting lots terminates disputes and decides between the powerful."
,"19":"A brother who is helped is more steadfast than a,fortress but quarrels are like the bars of a castle."
,"20":"A man is filled with what comes from his mouth and is nourished by what his lips provide."
,"21":"The tongue has power over life and death, those who like speaking will eat its fruit."
,"22":"He who finds a wife finds happiness, he has won Yahweh's favor."
,"23":"The poor man pleads, while the rich man responds harshly."
,"24":"Some friends only bring ruin, others are closer than a brother."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Better the poor man who lives honestly than the fool who lies."
,"2":"It is bad for men not to reflect, and acting too quickly can lead one astray."
,"3":"A man spoils his chances through his own stupidity but it is against Yahweh that his heart rages."
,"4":"Wealth multiplies friends, but the poor man is deprived of his only friend."
,"5":"The false witness will not go unpunished, the liar will not escape."
,"6":"Many are the flatterers of the noble man, the whole world is a friend to the rich man."
,"7":"A poor man is hated by all his brothers, and even more so do his friends desert him. He searches for someone to talk to but finds no one."
,"8":"He who acquires wisdom loves himself, he who respects knowledge will be happy."
,"9":"The false witness will not go unpunished, the liar will perish."
,"10":"It is not good that a fool live luxuriously, still less that a slave command princes."
,"11":"A clever man is slow to anger; his glory lies in forgetting offenses."
,"12":"The angry king is like a roaring lion but his favor is like the dew on the grass."
,"13":"The foolish son is the ruination of his father; the nagging wife is like a dripping gutter."
,"14":"House and wealth are inherited from a father but a sensible wife is a gift from Yahweh."
,"15":"Laziness makes a man fall asleep, the idler will go hungry."
,"16":"He who keeps the commandment keeps his life; he who despises it dies."
,"17":"He who shows compassion to the poor lends to Yahweh, who will repay his good deed."
,"18":"Correct your son as long as there is hope, lest you be responsible for his death."
,"19":"The violent man leaves himself open to a fine; if you spare him he will continue."
,"20":"Listen to counsel and accept correction, and you will be wise in the end."
,"21":"Plans abound in the human heart but only Yahweh's purpose will be realized."
,"22":"Goodness is attractive in a person; better a poor man than a liar."
,"23":"Love of Yahweh leads you to life; you will have your fill and live without fear."
,"24":"The lazy man dips his hand in the dish but he cannot even lift it to his mouth."
,"25":"Punish the mocker and the ignorant will be more careful; rebuke a discerning man and he will listen to reason."
,"26":"He who dispossesses his father and evicts his mother is a shameful and degenerate son."
,"27":"My son, listen to instruction and stop straying from the words of wisdom."
,"28":"An unworthy witness makes a mockery of justice; the mouth of the wicked feeds on evil."
,"29":"Punishments were made for mockers and blows, for the backs of fools."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Wine leads to vulgarity and strong drink, to bravado; he who strays in it will never be wise."
,"2":"The angry king is like a roaring lion; whoever provokes him risks his life."
,"3":"It is good for man to avoid quarrels; it is the fool who does not master himself."
,"4":"Autumn is over, yet the fool does no work; come the harvest, he searches and finds nothing."
,"5":"Counsel is like deep water in the heart, the discerning man has only to draw it out."
,"6":"Many are called good but where can the trustworthy man be found?"
,"7":"The upright man who works honestly will make his sons happy after him."
,"8":"The king who sits in judgment discovers evil at a single glance."
,"9":"Who can say, 'I have purified my heart, I am cleansed from sin?'"
,"10":"The crooked measure and scales - these are the things that Yahweh detests."
,"11":"The child reveals himself in his deeds: whether his actions are honest and upright."
,"12":"The ear that hears, the eye that sees, Yahweh has made them both."
,"13":"Do not love sleep lest you become poor; keep your eyes open and you will have your fill of bread."
,"14":"'No good, no good,' says the buyer but off he goes congratulating himself."
,"15":"Although you have gold and abundance of pearls, the most valuable adornment is lips which speak wisely."
,"16":"Get rid of his clothes because he has stood bail for a stranger; arrest him for the profit of those unknown!"
,"17":"Stolen bread tastes good but later on your mouth is full of sand."
,"18":"Plans take shape, thanks to advice; do battle, then, with wise strategies."
,"19":"The gossiper reveals secrets; have nothing to do with chatterers."
,"20":"Whoever curses his father and mother will see his lamp extinguished in the midst of darkness."
,"21":"Advantage hastily gained in the beginning will not be blessed in the long run."
,"22":"Never say, 'I will take revenge.' Trust in Yahweh; he will save you."
,"23":"Yahweh detests false weights; it does no good to have false scales."
,"24":"Yahweh directs a man's steps, who can know where his way leads?"
,"25":"It is dangerous to make hasty promises to Yahweh and only then reflect on them."
,"26":"A king throws evildoers to the wind and runs the thresher over them."
,"27":"Man's spirit is Yahweh's lamp which searches the hidden places of the heart."
,"28":"Goodness and loyalty keep guard over the king; his throne stands due to goodness."
,"29":"Energy is the adornment of youth, white hair the dignity of age."
,"30":"Bleeding wounds purify evil, blows bring healing to the inner self."
}`)
	CurrentBook.AddChapter(21, `{
"1":"In the hands of Yahweh, the heart of the king is like running water; he directs it wherever he wishes."
,"2":"To the eyes of man all his ways are honest but it is Yahweh who weighs the heart."
,"3":"To do what is upright and just pleases Yahweh more than sacrifice."
,"4":"Haughty looks, proud heart, the light of the wicked is sin."
,"5":"The plans of a hardworking man result in earnings; poverty is for those who act too hastily."
,"6":"To make a fortune by means of deceit is like running after the wind; the end is death."
,"7":"The violence of the wicked carries them away because they refuse to practice justice."
,"8":"The way of the criminal is devious; but honest are the ways of the innocent man."
,"9":"Better the corner of a barn to live in than a house shared with a raging woman."
,"10":"The soul of the wicked desires nothing but evil; not even his friend is treated with compassion."
,"11":"When the mocker is punished the ignorant man grows wise; when the wise man is instructed he grows in knowledge."
,"12":"The Just One watches the house of the evildoer and hurls the wicked into misfortune."
,"13":"He who is deaf to the poor man's cry will not be heard when he himself calls out."
,"14":"A discreet gift pacifies anger, a bribe diverts violent rage."
,"15":"Upright men are glad when justice reigns but evildoers tremble."
,"16":"He who departs from the ways of prudence will sleep in the assembly of the Shades."
,"17":"Pleasure-lovers remain poor, he who loves wine and perfume will never grow rich."
,"18":"The wicked man will pay for the virtuous and the treacherous man, for the honest."
,"19":"Better to live in a deserted place than with a raging and abusive woman."
,"20":"There is oil and precious treasure in the wise man's house, things which the fool squanders."
,"21":"He who seeks justice and mercy will gain life, prosperity and honor."
,"22":"The wise man conquers a city of warriors and tears down the walls they trust in."
,"23":"He who keeps guard over his mouth and tongue saves himself from anguish."
,"24":"'Mocker' is the name of the arrogant and haughty, he in whom pride abounds."
,"25":"The idler's desires lead him to death because his hands refuse to work."
,"26":"He covets all day long while the upright man gives without stinting."
,"27":"Yahweh detests the sacrifice of the wicked, above all when they offer it for an unjust cause."
,"28":"The lying witness will perish but he who listens wisely will be given time to speak."
,"29":"The wicked man tries to appear firm and table while the honest man confirms his way."
,"30":"No wisdom, prudence or advice can withstand the look of Yahweh."
,"31":"The horse is equipped for the day of battle but it is Yahweh who gives the victory."
}`)
	CurrentBook.AddChapter(22, `{
"1":"A good name is better than great wealth; fame is preferable to silver or gold."
,"2":"Rich and poor have something in common, Yahweh has made them all."
,"3":"The discreet man foresees disgrace and hides, the ignorant keep going at their own expense."
,"4":"The reward of humility is fear of Yahweh, wealth, honor and life."
,"5":"The path of the wicked is paved with thorns and traps, he who loves his life will keep his distance."
,"6":"Teach a child the way he should go, he will not stray from it while he lives."
,"7":"The rich man lords it over the poor, the borrower is the moneylender's slave."
,"8":"Whoever sows injustice reaps disaster; the power of the wicked will be broken."
,"9":"The warmhearted man will be blessed since he shares his bread with the poor."
,"10":"Throw out the mocker and the dispute will cease, fighting and insults will end."
,"11":"He who loves purity of heart and speaks sensibly will find a friend in the king."
,"12":"Yahweh's look protects the wise man and discredits the words of the liar."
,"13":"The lazy man says, 'There is a lion outside, he will kill me in the street.'"
,"14":"The adulterous woman's mouth is a deep pit, he whom Yahweh wishes to punish will fall into it."
,"15":"The heart of the child is naturally foolish, the beating of instruction will cure it."
,"16":"When you oppress the poor, you make them grow; when you give to the rich, you waste everything."
,"17":"Give ear, listen to the words of the wise and apply yourself to understanding them,"
,"18":"because it will be your delight to keep them deep within you, to have them always ready on your lips."
,"19":"I wish now to teach you, so that you will place your trust in Yahweh."
,"20":"Have I not written for you thirty chapters of advice and knowledge"
,"21":"so that you may recognize the truth and be able to answer rightly him who sent you?"
,"22":"Do not take from the poor man just because he is poor or condemn the one in misfortune,"
,"23":"because Yahweh will intercede for them and will carry off the life of their oppressors."
,"24":"Do not befriend the angry man or be a companion to the one of rage,"
,"25":"for fear you adopt their ways and lose your life in their midst."
,"26":"Do not be one of those who undertake a commitment and act as guarantor of debts;"
,"27":"if you cannot pay, they will take from you the very bed in which you sleep."
,"28":"Do not move the ancient boundaries established by your forefathers."
,"29":"You see a clever man at work? He will enter the service of kings; he will not stay in the service of people of no renown."
}`)
	CurrentBook.AddChapter(23, `{
"1":"If you sit at a table with a great man, beware of what is in front of you;"
,"2":"if your appetite is too great, put a knife to your throat."
,"3":"Do not greedily desire his fine food for it is deceptive nourishment."
,"4":"Do not wear yourself out trying to be rich, do not dwell on it."
,"5":"Set your eyes on wealth and it no longer exists; it sprouts wings and flies into the sky like an eagle."
,"6":"Do not eat with the wicked man or be greedy for his choice food."
,"7":"All is appearance, for he plots in his heart. 'Eat and drink,' he says but he is not to be trusted."
,"8":"You will spit it out as soon as it is tasted and your words of praise will be wasted."
,"9":"Do not speak with a fool; he will not be able to appreciate your remarks."
,"10":"Do not move the ancient boundaries or take possession of the orphan's land because his Avenger is powerful;"
,"11":"he will take sides against you."
,"12":"Apply your heart to instruction and your ears to words of wisdom."
,"13":"Do not hold back from correcting a youth; the rod will not kill him."
,"14":"With several strokes, you save him from death."
,"15":"My son, if your heart is wise, then my own heart is glad,"
,"16":"and my whole being will rejoice when you speak the truth."
,"17":"Do not envy sinners but, each day, fear Yahweh; then you will have a future and"
,"18":"your hope will not be in vain."
,"19":"Listen, my son, and you will be wise and you will make your heart go straight on its way."
,"20":"Do not be one of those who get drunk with wine or who stuff themselves with meat,"
,"21":"since the drunkard and the glutton impoverish themselves and the sleepyhead is clothed in rags."
,"22":"Listen to your father who begot you; do not despise your mother in her old age."
,"23":"Acquire truth and never sell it; gain wisdom, discipline and discernment."
,"24":"Happy the father of a virtuous man! How he will rejoice,"
,"25":"he who fathers a wise man! May your father and mother rejoice and may she who bore you be glad."
,"26":"My son, give me your heart, that your eyes may delight in my ways."
,"27":"You should know that the prostitute is a deep abyss and the unknown woman a narrow well."
,"28":"Like a thief she lies in wait and she increases the sinners among men."
,"29":"For whom are the cries and laments? For whom the complaints and sighs? For whom the blows without reason? For whom the eyes which see double?"
,"30":"For those who abandon themselves to wine and go in search of the well-blended wine."
,"31":"Do not consider the wine: how red it is and how sparkling the glass! How smoothly it flows!"
,"32":"In the end, it bites like a snake and stings like a viper."
,"33":"Your eyes will see strange things and you will end up speaking nonsense."
,"34":"You will be like a man asleep on the high seas or at the rudder: 'They hit me but I am not hurt."
,"35":"They beat me but I feel nothing. When will I wake up? I will go in search of more.'"
}`)
	CurrentBook.AddChapter(24, `{
"1":"Do not envy the wicked or desire their company,"
,"2":"for their hearts dream only of violence and their lips speak nothing but evil."
,"3":"With wisdom a house is built."
,"4":"It is strengthened by prudence. Its granaries are filled by knowledge with all that is good, precious and desirable."
,"5":"The wise man is powerful; the one of knowledge adds to his strength."
,"6":"Because of this, he goes into battle with wise plans, since success depends on many advisers."
,"7":"Wisdom is beyond the reach of the fool; let him not open his mouth in the assembly."
,"8":"The plotter of evil is called an unscrupulous mastermind."
,"9":"The fool dreams only of sin, the mocker deserves only contempt."
,"10":"If you lose heart when misfortune comes, miserable is your strength."
,"11":"Rescue those who are being carried away to die; save those who are being dragged away to torture."
,"12":"Afterwards you will say, 'We did not know.' But he who weighs the heart, does he not understand? He who watches over the soul is aware and he will give to each one according to his deeds."
,"13":"Eat honey, my son, because it is good; the honeycomb is sweet to the taste."
,"14":"So also will wisdom be to your soul. If you find it, you have a future and your hope will not be in vain."
,"15":"Evildoer, do not spy on the house of the virtuous man, do not disturb his home."
,"16":"Because even though the virtuous man falls seven times, he gets up again, while the wicked sink in their adversity."
,"17":"Do not rejoice if your enemy falls or let your heart be glad if he stumbles,"
,"18":"lest Yahweh see and be displeased and his anger be turned on you."
,"19":"Do not be incensed by the wicked or envious of the ungodly,"
,"20":"since there is no future in evil and the lamp of the wicked will be extinguished."
,"21":"Fear Yahweh and the king, my son; make no deals with agitators,"
,"22":"for disaster will befall them without warning and who knows when their ruin will come?"
,"23":"It is not good for judges to show partiality. People curse and nations hate him"
,"24":"who says to the wicked man, 'You are just.'"
,"25":"But those who punish the evildoer can boast; blessing and happiness will be theirs."
,"26":"An honest answer is like a kiss on the lips."
,"27":"Finish your work out-of-doors and plan your work in the fields; afterwards, you can think of building your house."
,"28":"Do not lightly bear witness against your neighbor lest you lie."
,"29":"Do not say, 'I will do to him what he did to me; I will repay him for his deeds.'"
,"30":"I passed by the lazy man's field, near the vineyard of the senseless man."
,"31":"Everywhere it was full of weeds; thistles covered the ground and the stonewall was fallen apart."
,"32":"Seeing all this, I reflected and drew this lesson from what I saw."
,"33":"A little sleep, a little drowsiness and"
,"34":"your laziness creeps upon you and then, like a tramp, poverty comes, bringing misery like a vagabond."
}`)
	CurrentBook.AddChapter(25, `{
"1":"These are also Proverbs of Solomon, recorded in the time of Heze- kiah, king of Judah."
,"2":"The glory of God is in hiding secrets and the glory of the king, in revealing them."
,"3":"As high as the skies, as deep as the earth, such is the heart of kings."
,"4":"Remove the impurity from silver and it will become a vessel in the hands of the silversmith."
,"5":"Remove the wicked from the king's presence and he will affirm his power through justice."
,"6":"Do not boast before the king or put yourself among the great."
,"7":"It would be better to be invited, 'Come up here,' than to be humiliated after having seen the prince."
,"8":"Do not be too hasty in accusing your neighbor for what would happen to you should he confound you?"
,"9":"Defend your case against your neighbor but do not reveal the secret of another,"
,"10":"lest he overhear it and despise you and your reputation be lost."
,"11":"An opportune word is like golden apples encased in silver."
,"12":"A gold ring or an ornament of fine gold, such is the wise man's rebuke to a responsive person."
,"13":"The trustworthy messenger is like the coolness of snow at harvest time, to him who sends him: he revives the soul of his master."
,"14":"Clouds and wind but no rain, such is the one who promises but does not fulfill."
,"15":"With a little patience you will persuade the judge; a soft tongue can break bones."
,"16":"If you find honey, eat enough but not too much, lest you bring it up again."
,"17":"Go rarely to your neighbor's house lest he tire of you and grow to hate you."
,"18":"A mace, a sword, a keen arrow: such is the one who lies about his neighbor."
,"19":"A decaying tooth, a lame foot, such is the trust put in the ungodly on the day of trouble."
,"20":"Singing songs to a grieving person is like taking off your cloak in frosty weather or pouring vinegar into a wound."
,"21":"If your enemy is hungry give him something to eat, if thirsty, something to drink;"
,"22":"thus you pile up red-hot coals on his head and Yahweh will reward you."
,"23":"As the north wind brings the rain, so the gossiping tongue leaves angry faces."
,"24":"Better the corner of a barn to live in than a house shared with a whimsical woman."
,"25":"Good news from a distant country is like cool water to a dry throat."
,"26":"A churning river or a polluted spring is like the virtuous man who trembles before the evildoer."
,"27":"It is not good to eat too much honey and even less good to be greedy for honors."
,"28":"The man who cannot contain his anger is like an open city, without defenses."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Honors do not suit the fool any more than snow in summer and rain at harvest."
,"2":"The sparrow escapes, the swallow flies off, so the motiveless curse will have no effect."
,"3":"A whip for the horse, a bridle for the donkey, a stick for the backs of fools."
,"4":"Do not answer the stupidity of fools lest you become like them."
,"5":"Answer the stupidity of the fool lest he consider himself intelligent."
,"6":"He who sends messages by a fool is cutting his own feet."
,"7":"Like the unsteady legs of a lame man, such is a proverb in the mouth of fools."
,"8":"Honoring a fool is like tying a stone in a sling."
,"9":"Like a thorn branch in a drunkard's hands, such is a proverb in the mouth of fools."
,"10":"Like an archer wounding all passersby, so is he who employs a fool."
,"11":"The fool reverts to his stupidity just as a dog returns to his vomit."
,"12":"See that man who thinks himself wise? There is more hope for a fool!"
,"13":"'There's a lion in the street,' the lazy man says, 'a lion in the square.'"
,"14":"The door turns on its hinges and the lazy man, on his bed."
,"15":"The idler dips his hand in the dish but is too tired to lift it to his mouth."
,"16":"The idler considers himself wiser than many people who answer tactfully."
,"17":"Interfering in the disputes of others is like grabbing a passing dog by the tail."
,"18":"As a madman hurls flaming, deadly arrows,"
,"19":"so does the one who lies to his friend and then says, 'It was just a joke.'"
,"20":"For lack of wood, the fire goes out; for want of a gossiper, the quarrel dies down."
,"21":"Charcoal on hot coals, wood on a fire, and a quarrelsome man for stirring up disputes."
,"22":"The words of the gossiper are delicious mouthfuls which go right down to the bottom of the stomach."
,"23":"Like silver on earthenware, so are smooth lips with a corrupt heart."
,"24":"The one who hates, disguises his words and keeps his treachery inside;"
,"25":"do not trust his sweet language for seven evils fill his heart."
,"26":"But although he conceals his hatred like a hypocrite, his evil will be revealed in the assembly."
,"27":"He who digs a pit falls in it and the rock he rolls away falls back on him."
,"28":"The liar hates his victims, the flattering mouth brings destruction."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Do not feel confident about tomorrow since you do not know how today will end."
,"2":"Let another praise you but not your own mouth; a stranger but not your own lips."
,"3":"Heavy the stone and weighty the sand but the fool's anger outweighs both."
,"4":"Wrath is cruel and anger, impulsive but who can withstand jealousy?"
,"5":"Better an honest rebuke than false affection."
,"6":"Worthy of trust is the friend who speaks honestly; the enemy is he who multiplies caresses."
,"7":"The full mouth looks down on honey, the hungry one finds any bitter thing sweet."
,"8":"Like a bird far from its nest, so is the one who wanders from his own place."
,"9":"Oil and perfume gladden the heart; so too does the sweetness of friendship comfort the soul."
,"10":"Never desert your friend or your father's friend; do not hasten to your brother's house when troubles strike: better a friend nearby than a brother far away."
,"11":"Learn to be wise, my son, and make me happy so that I can reply to those who insult me."
,"12":"The discerning man foresees danger and takes cover, but fools keep going, to their own loss."
,"13":"Get rid of his clothes since he has gone surety for a stranger, seize him for the benefit of those unknown."
,"14":"If he, at dawn, blesses his neighbor in a loud voice, it shall be interpreted as a curse."
,"15":"The constant dripping of a gutter on a rainy day and a nagging woman have something in common."
,"16":"Stopping her is like stopping the wind and grasping oil in one's hand."
,"17":"Iron is sharpened with iron, contact with a neighbor sharpens a man's wit."
,"18":"He who tends the fig tree eats its fruit, he who looks after his master will be honored."
,"19":"As the face is reflected in water, so man finds himself in his own heart."
,"20":"Death and hell are never satisfied; so, also, the eyes of men."
,"21":"A crucible for silver, a furnace for gold; you will know a man by his reputation."
,"22":"Even though you grind the fool in a mortar, you will not rid him of his stupidity."
,"23":"Know well the state of your herd and tend to your flock"
,"24":"because wealth does not last forever and riches are not handed down from generation to generation."
,"25":"Once the pasture is mowed and the aftergrowth appears and the hay is gathered in from the hills,"
,"26":"you should have lambs to clothe you and goats to pay for your fields,"
,"27":"sufficient goats' milk to feed you, to sustain your household and provide for your serving girls."
}`)
	CurrentBook.AddChapter(28, `{
"1":"The wicked man runs away even when no one is after him but the virtuous man feels as safe as a lion."
,"2":"A country, for its sins, has many rulers; but with one wise ruler there is stability."
,"3":"The evildoer oppressing the poor is like destructive floods which leave no food."
,"4":"Those who foresake the Law applaud evil; those faithful to the Law fight evil."
,"5":"The wicked have no understanding of justice but those who seek Yahweh understand all."
,"6":"Better the poor but honest life than devious living, with riches."
,"7":"A clever man keeps the Law, while he who associates with scoundrels brings shame to his father."
,"8":"He who adds to his wealth by usury and greed amasses it for another who has compassion on the poor."
,"9":"If anyone turns a deaf ear to the Law, even his prayer is contaminated by sin."
,"10":"He who leads the virtuous astray will fall into his own trap. The upright will inherit happiness."
,"11":"The rich man thinks himself wise while the poor but sensible man knows how to show him up."
,"12":"When the virtuous triumph, there is great feasting, but when the wicked dominate, everybody hides."
,"13":"Whoever conceals his faults will not prosper, but he who confesses and renounces them will be shown mercy."
,"14":"Happy the one who always lives in the fear of God; he who hardens his heart will fall on disaster."
,"15":"A roaring lion, a hungry bear, such is the bad leader of a poor people."
,"16":"The ruler lacking intelligence multiplies oppression; but he who abhors greed will endure."
,"17":"The man wanted for murder will be on the run until death. Let him go!"
,"18":"He who goes his way honestly will be saved, he who vacillates between two ways will fall in one of them."
,"19":"He who tends his land will have an abundance of bread, while he who chases illusions will have his fill of misery."
,"20":"The trustworthy man will be heaped with blessings, but he who is preoccupied with getting rich will not be guiltless."
,"21":"It is not good to show partiality but a man will do wrong for a mouthful of bread."
,"22":"The greedy-eyed man is on the lookout for wealth not knowing that misfortune will befall him."
,"23":"He who reproves another will eventually enjoy more favor than the flatterer."
,"24":"He who steals from his father and mother saying, 'It's not a sin,' is just like a criminal."
,"25":"The greedy man brings about trouble; but he who trusts in Yahweh will be filled with good things."
,"26":"He who trusts in himself is just like a fool; while he who walks wisely will be saved."
,"27":"He who gives to the poor will not be in need; but he who turns a blind eye to them will have his fill of disgrace."
,"28":"When the wicked triumph, everybody hides; but when they perish, the virtuous multiply."
}`)
	CurrentBook.AddChapter(29, `{
"1":"He who resists correction will be broken suddenly and without remedy."
,"2":"When the virtuous rule, the people are happy, but they groan when the wicked are in power."
,"3":"He who loves wisdom makes his father happy, but whoever maintains prostitutes will lose his wealth."
,"4":"Through justice a king makes his country prosper; but the extortioner brings it to ruin."
,"5":"The one who flatters his neighbor lays a snare at his feet."
,"6":"In the wicked man's sins lies a snare for himself, while the upright man runs on rejoicing."
,"7":"The virtuous man is concerned about the problems of the poor; the evildoer, however, understands nothing."
,"8":"Mockers create disturbances in the city but the wise turn troubles away."
,"9":"When the wise man argues with the fool, whether he is annoyed or joking, he will get nowhere."
,"10":"The violent hate the blameless man but the virtuous seek out his presence."
,"11":"The fool gives free rein to his rage; while the wise man restrains it."
,"12":"When a ruler listens to false reports, all his ministers will be scoundrels."
,"13":"The poor man and usurer have something in common: both receive the light of day from God."
,"14":"The king who judges the poor with justice will affirm his throne forever."
,"15":"Both the stick and rebuke bring wisdom, while the spoilt child brings shame to his mother."
,"16":"When the wicked rule, sin abounds, but the virtuous shall witness their downfall."
,"17":"Correct your son and he will bring you rest; you will be happy in him."
,"18":"Where prophets are lacking, the people get out of hand; happy is he who obeys the Law."
,"19":"A slave is not corrected by words; even if he understands he will take no notice."
,"20":"You see a man dying to speak? There is more hope for a fool."
,"21":"If you spoil your slave from childhood, he will end up a rebel."
,"22":"The hot-tempered man provokes disputes, his anger multiplies his sins."
,"23":"A man's pride results in his humiliation, but he who humbles himself will achieve honors."
,"24":"He who shares with the thief harms himself; even you who kept silent when you should have denounced him."
,"25":"To be afraid of men is a trap; but whoever trusts in Yahweh will be safe."
,"26":"Many seek a ruler's favor but each one's fate comes from God."
,"27":"The upright man detests the wicked and the evildoer hates the honest man."
}`)
	CurrentBook.AddChapter(30, `{
"1":"The sayings of Agur, Son of Jakeh, of Massa."
,"2":"He says, 'My God, my God, I am worn-out and weary. Too stupid to be human, I am devoid of intelligence;"
,"3":"I have not acquired wisdom or grasped the knowledge of the Holy One.'"
,"4":"Who has ascended the heavens and descended? Who has gathered the wind in his hands? Who has encircled the waters with his cloak? Who has established the limits of the earth? What is his name or the name of his son?"
,"5":"Every word of God is true, he is a shield in whom man can find refuge."
,"6":"Add nothing to his words lest he rebuke you and take you for a liar."
,"7":"O God, two things I beg of you, do not deny me them before I die."
,"8":"Keep lying and falsehood far away from me, give me neither poverty nor riches. Give me just as much food as I need lest,"
,"9":"satisfied, I deny you and say, 'Who is Yahweh?' Or else, out of necessity, I steal and profane the name of my God."
,"10":"Do not accuse a slave to his master's face lest he curse you and you have to pay."
,"11":"What a people are those who curse their father and do not bless their mother,"
,"12":"who consider themselves pure but their sins have not been cleansed!"
,"13":"They have a haughty look and disdainful eye;"
,"14":"their teeth are like daggers and their fangs, like blades to devour the weak of the land and the poor of the people."
,"15":"The leech has two daughters, 'Give me!' and 'Give me!'"
,"16":"There are three insatiable things and four which never say, 'Enough': the grave, the sterile womb, the earth longing for water and the fire which never cries, 'Enough.'"
,"17":"The eye which challenges a father and despises his aging mother, will be gouged out by the ravens of the valley and devoured by the eagles."
,"18":"There are three things which I cannot comprehend and four which I do not understand:"
,"19":"the way of the eagle through the sky, the way of the snake on the rock, the way of the ship on high seas and the way of the human being within the mother."
,"20":"What can I say of the adulterous woman? She eats, and having wiped her mouth, she says, 'I have done nothing wrong.'"
,"21":"Three things make the earth tremble; there are four which it cannot withstand:"
,"22":"the slave who becomes king, the fool stuffed with bread,"
,"23":"the unbearable woman who marries and the maid who inherits from her mistress."
,"24":"There are four tiny creatures on the earth that are among the wisest of the wise:"
,"25":"the ants that are without strength, but in summer make sure of their supplies;"
,"26":"the rock-rabbits that are without vigor, but make their home in the rocks;"
,"27":"the locusts that have no king, but move forward in organized groups;"
,"28":"the lizard which can be caught by hand, but lives in the palaces of kings."
,"29":"Three things have a stately step and four have a noble bearing:"
,"30":"the lion, the bravest of animals, that retreats before nothing;"
,"31":"the cock that struts proudly among the hens; the he-goat that leads his flock, and the king at the head of his army."
,"32":"If you have been foolish enough to get angry and afterwards regret it, cover your mouth with your hand."
,"33":"Since by churning the milk butter is produced, by squeezing the nose blood flows, and by stirring up anger arguments arise."
}`)
	CurrentBook.AddChapter(31, `{
"1":"The sayings of Lemuel, king of Massa, taught him by his mother."
,"2":"No, my son! Son of my womb, no!,No, my most beloved son!"
,"3":"Do not waste your strength on women, or your life on those who destroy kings."
,"4":"It is not for kings, O Lemuel, not for kings to drink wine or for rulers to love strong drink."
,"5":"Lest in drinking they forget what they have decreed and override the cause of the helpless."
,"6":"Give strong drink to the one about to die and wine to the heart full of bitterness:"
,"7":"so that he may drink and forget his misfortune and remember his pain no more."
,"8":"Speak on behalf of the dumb and defend the cause of all who are destitute."
,"9":"Open your mouth, pronounce just sentences, defend the needy and the poor."
,"10":"The woman of character, where is she to be found? She is more precious than any jewel."
,"11":"Her husband has complete confidence in her; she will be of great benefit to him."
,"12":"She brings him only good and not evil, all the days of her life."
,"13":"She has obtained wool and flax, and works them with skillful hands."
,"14":"She is like the merchant ships which bring provisions from afar."
,"15":"She gets up while it is still dark, feeds her household and allots tasks to the servants."
,"16":"If she sets her heart on a field, she buys it and plants a vineyard with her own hands."
,"17":"She is full of energy and her arms show her strength."
,"18":"She knows her work is successful and, at night, her light remains unextinguished."
,"19":"She puts her hand to the distaff and her fingers hold the spindle."
,"20":"She reaches out her hand to the helpless and gives to the poor."
,"21":"When snow comes, she has no fears for her household since they are all doubly clothed."
,"22":"She makes her own quilts and her clothes are purple and fine linen."
,"23":"Her husband is well-respected; he sits in council with the elders of the people."
,"24":"She weaves linen cloth and sells it; she supplies the merchants with sashes."
,"25":"She is strong and dignified and looks with confidence to the future."
,"26":"She speaks wisely and her words are kind."
,"27":"She keeps an eye on the conduct of her household and is never idle."
,"28":"Her sons rise up and call her blessed, her husband sings her praises:"
,"29":"'Many women have done wonders but you surpass them all.'"
,"30":"Charm is deceptive and beauty useless; the woman who is wise is the one to praise."
,"31":"May she enjoy the fruits of her labor and may all praise her for her works."
}`)

}
func EN_CCB_LoadVSPSChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Blessed is the one,who does not go where the wicked gather, or stand in the way of sinners, or sit where the scoffers sit!"
,"2":"Instead, he finds delight in the law of the Lord,and meditates day and night,on his commandments."
,"3":"He is like a tree beside a brook,producing its fruit in due season, its leaves never withering. Everything he does is a success."
,"4":"But it is different with the wicked. They are like chaff,driven away by the wind."
,"5":"The wicked will not stand when judgment comes, nor the sinners when the righteous assemble."
,"6":"For the Lord knows the way of the righteous,but cuts off the way of the wicked."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Why do the nations conspire?,Why do the peoples plot in vain?"
,"2":"The kings of the earth brace themselves,and the rulers together take their stand,against the Lord and his anointed."
,"3":"They say, 'Let us break their bonds!,Let us cast away their chains!'"
,"4":"The One enthroned in heaven laughs; the Lord looks at them in derision."
,"5":"Then in anger he speaks to them, terrifying them in the fury of his wrath:"
,"6":"'Behold the king I have installed, in Zion, upon my holy hill!'"
,"7":"I will proclaim the decree of the Lord. He said to me: 'You are my son. This day I have begotten you."
,"8":"Ask of me and I will give you,the nations for your inheritance, the ends of the earth for your possession."
,"9":"You shall rule them with iron scepter,and shatter them as a potter's vase.'"
,"10":"Now therefore, learn wisdom, O kings; be warned, O rulers of the earth."
,"11":"Serve the Lord with fear,and fall at his feet; lest he be angry and you perish,when his anger suddenly flares. Blessed are all who take refuge in him!"
}`)
	CurrentBook.AddChapter(3, `{
"1":"O Lord, how great in number are my foes!,How numerous are they who rise against me!"
,"3":"How many are they who say of my soul: 'There is no help for him in God!'"
,"4":"But you are my shield, O Lord, my glory, you lift up my head."
,"5":"Aloud I cry to the Lord, and from his holy hill he answers me."
,"6":"If I lie down to sleep, again I awake, for the Lord supports me;"
,"7":"no fear of the thousands standing against me."
,"8":"Arise, O Lord!,Deliver me, O my God!,You strike all my enemies on the jaw, you have broken the teeth of the wicked."
,"9":"Salvation comes from the Lord. May your blessing be upon your people!"
}`)
	CurrentBook.AddChapter(4, `{
"2":"Answer when I call, O God, my justice!,When I was in distress, you gave me solace. Have compassion on me and hear my plea."
,"3":"And you people, how long,will you harden your hearts?,How long will you delight in deceit,and go in search of falsehood?"
,"4":"But you must know that the Lord,has shown his kindness to me. When I call to him, he hears me."
,"5":"Be angry, but don't offend. Keep your words to yourself, when you are in bed, and be still."
,"6":"Offer the sacrifice commanded by the Law,and put your trust in the Lord your God."
,"7":"Many ask, 'Who will give us a happy time?,Would that his favor shine upon us!'"
,"8":"You, O Lord, have put joy in my heart; more than by giving me wine and food."
,"9":"I lie down and sleep in peace, for you alone, O Lord, make me feel safe and secure."
}`)
	CurrentBook.AddChapter(5, `{
"2":"O Lord, listen to my words and hear my complaint,"
,"3":"give heed to my sighs, my King and my God."
,"4":"From daybreak you hear my voice, from dawn I am in your presence watching for you."
,"5":"You are not a God who delights in wickedness; evil has no place in you."
,"6":"The arrogant cannot stand before you. You hate all who do evil;"
,"7":"you destroy all who speak falsehood, who thirst for blood and live on lies; all of them the Lord detests."
,"8":"But I, by your love and grace, may come into your house. In reverence I bow down and worship at your holy temple."
,"9":"Lead me, O Lord, through your path of righteousness; make your way straight before me, for my enemies lie in wait."
,"10":"Not a word of their mouth can be trusted, for their heart is full of mischief. Their tongue flatters with deceit, but their throat is an open grave."
,"11":"O Lord, make them pay for their guilt. Let their snares trap them. Cast them out for their many sins - for their offense and rebellion."
,"12":"But for those who take refuge in you, let them ever sing and rejoice. Let your deliverance shield them, that they may praise you in gladness - those who love your name, O Lord."
,"13":"You bless all who live in righteousness; your favor covers them as a shield."
}`)
	CurrentBook.AddChapter(6, `{
"2":"O Lord, in your anger do not reprove; nor punish me in your fury."
,"3":"Have mercy on me, O Lord, for I have no strength left. O Lord, heal me, for my bones are in torment."
,"4":"My soul also is greatly troubled. How long, O Lord, how long? How long will you be?"
,"5":"Come back to me, O Lord, save my life; rescue me for the sake of your love."
,"6":"For no one remembers you in the grave; who will praise you in the world of the dead?"
,"7":"I am weary with moaning; I weep every night, drenching my bed with tears."
,"8":"My eyes have grown dim from troubles; I have weakened because of my foes."
,"9":"Away from me, you evildoers, for the Lord has heard my plaintive voice."
,"10":"The Lord has heard my plea; the Lord will grant all that I pray for."
,"11":"Let my enemies fall back in shame, all of a sudden - the whole bunch of them!"
}`)
	CurrentBook.AddChapter(7, `{
"2":"O Lord, my God, in you I take shelter; deliver me and save me from all my pursuers,"
,"3":"lest lions tear me to pieces with no one to rescue me."
,"4":"O Lord, my God, if my hands are stained with guilt -"
,"5":"if with evil I have repaid good, if I have plundered unjustly my opponent,"
,"6":"let the enemy hound me, let him crush me to the ground and lay down my glory in the dust."
,"7":"Arise, O Lord, in your wrath; rise up against the fury of my foes. Awake, O my God and judge the nations, for the time of judgment has come."
,"8":"Let the nations gather around you; and you take your seat high above them."
,"9":"Proclaim, O Lord, my righteousness; you see that I am blameless."
,"10":"Bring to an end the power of the wicked, but affirm the just, O righteous God, searcher of mind and heart."
,"11":"You cover me as a shield, Oh God, for you protect the upright."
,"12":"A righteous judge is God, his anger ever awaiting those who refuse to repent."
,"13":"God has his sword ready and sharpened, his bow bent and arrows aimed."
,"14":"He has in hand, always ready, his deadly weapons and fiery darts."
,"15":"Look at the one who conceived iniquity and is pregnant with mischief: miscarriage will result."
,"16":"He digs a pit and makes it deep, he will fall into the trap he made."
,"17":"His evil intent recoils upon his head; his wicked design comes back in his face."
,"18":"I will rejoice in the Lord for his justice, and sing to the Most High in gratitude and praise."
}`)
	CurrentBook.AddChapter(8, `{
"2":"O Lord, our Lord, how great is your name throughout the earth!,And your glory in the heavens above."
,"3":"Even the mouths of children and infants,exalt your glory in front of your foes,and put to shame enemies and rebels."
,"4":"When I observe the heavens, the work of your hands, the moon and the stars you set in their place -"
,"5":"what is the mortal that you be mindful of him, the son of man, that you should care for him?"
,"6":"Yet you made him a little lower than the angels; you have crowned him with glory and honor."
,"7":"You made him rule over the works of your hands; you have put all things under his feet -"
,"8":"sheep and oxen without number,and even the beasts of the field,"
,"9":"the birds of the air, the fish of the sea, and all that swim the paths of the ocean."
,"10":"O Lord, our Lord, how great is your name all over the earth!"
}`)
	CurrentBook.AddChapter(9, `{
"2":"Let my heart give thanks to the Lord, I yearn to proclaim your marvelous deeds,"
,"3":"and rejoice and exult in you, and sing praise to your name, O Most High."
,"4":"For my enemies fell back in retreat, they stumbled and perished before you."
,"5":"You have upheld my right and my cause, you have sentenced from your throne, O just judge."
,"6":"You have turned back the nations; you have beaten down the wicked and blotted out their names forever."
,"7":"Your enemies lay in endless ruin, their cities trampled, their memory perished."
,"8":"But the Lord reigns forever, having set up his throne for judgment."
,"9":"He will judge the nations with justice and govern the peoples in righteousness."
,"10":"The Lord is a rampart for the oppressed, a refuge in times of distress."
,"11":"Those who cherish your name, O Lord, can rely on you, for you have never forsaken those who look to you."
,"12":"Sing praises to the Lord enthroned in Zion, proclaim his deeds among the nations."
,"13":"For he who avenges blood remembers, he does not ignore the cry of the lowly."
,"14":"Have mercy on me, O Lord. See how they afflict me. Oh, lift me up from the gates of death,"
,"15":"that I may declare your praise, that I may rejoice in your salvation in the gates of Zion."
,"16":"The pagans have sunk into the pit they have dug, their own feet ensnared by the trap they laid."
,"17":"The Lord has shown his presence, he has judged and the wicked plotters have been trapped by the work of their hands."
,"18":"To the netherworld the wicked will depart, all the nations that have no thought of God."
,"19":"For the needy will not always be forgotten, nor the hope of the poor perish forever."
,"20":"Rise, O Lord! Do not let mortals prevail; let the nations stand on trial before you."
,"21":"Bring terror, O Lord, strike at them; let these pagans realize that they are but humans."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Why, O Lord, do you stand afar? Why hide from us in times of distress?"
,"2":"The wicked are in power; the weak suffer harassment; the poor become victims of evil schemes."
,"3":"Exploiters boast in their power and greed; the covetous blasphemes and defies God."
,"4":"In their pride the wicked say, 'There is no God.' He sees no further."
,"5":"The wicked prosper in their ways, your laws are far from their minds; haughtily they sneer at their rivals,"
,"6":"all of them saying in their heart, 'Nothing will trouble me. I am secure, powerful and happy.'"
,"7":"Their mouths are filled with cursing, deceit and threats; spite and mischief are under their tongues."
,"8":"They lie in ambush near the villages, murdering the innocent and the unfortunate, spying upon their next victim."
,"9":"The evil one lurks in secret, like a lion in its covert, waiting to seize his prey and drag him off in a net."
,"10":"Lying prone or crouching, he waits and the unfortunate falls into his power."
,"11":"He thinks to himself: 'God has forgotten; he has hidden his face and will never see this.'"
,"12":"Rise, Lord, O God, raise your hand, do not forget the lowly."
,"13":"Why do the wicked revile God and say, 'He cannot make me account'?"
,"14":"But you see those in misery, O God, and you take it in hand. The unfortunate commits himself to you; the orphan turns to you for help."
,"15":"Break the power of the wicked - seek out their wickedness till there is none to be found."
,"16":"The Lord is king forever and the pagans have vanished from his land."
,"17":"For you hear, O Lord, the longings of the lowly, and you strengthen their hearts;"
,"18":"you give heed to the orphans and the oppressed. Let no human raise from earth and strike terror."
}`)
	CurrentBook.AddChapter(11, `{
"1":"In the Lord I take refuge. How, then, can you say to me, 'Flee to the mountains like a bird;"
,"2":"for the wicked are bending their bows,and fit their arrows to the string. They get ready to shoot in the dark, they take aim at the upright of heart."
,"3":"When foundations fall to ruin, what can the righteous do?'"
,"4":"The Lord is in his holy place -,our God whose throne is in heaven. He looks down to earth,to observe the race of Adam."
,"5":"The Lord searches both righteous and wicked. He hates those who delight in violence."
,"6":"Upon the wicked, he will rain,coals of fire and brimstone; a burning blast will be their lot."
,"7":"For the Lord is righteous; he loves justice. The upright will see his face."
}`)
	CurrentBook.AddChapter(12, `{
"2":"Help us, O Lord, none of the godly are left, the faithful have vanished."
,"3":"Everyone lies; with flattering lips they speak from a double heart."
,"4":"May the Lord cut off insincere lips, every glib tongue that utters deceit."
,"5":"Many say, 'Our strength lies in our tongue. We know how to speak, who will lord it over us?'"
,"6":"'The poor are despoiled and the needy suffer, now I will save them,' says the Lord. 'I will give them security.'"
,"7":"The promises of the Lord are sure and lasting - silver refined in the furnace seven times and freed from dross."
,"8":"Hold us, O Lord, in your keeping; protect us always from this generation,"
,"9":"where the wicked prowl on all sides, and the basest are exalted."
}`)
	CurrentBook.AddChapter(13, `{
"2":"How long, O Lord, will you forget me,and hide your face from me?"
,"3":"How long must I suffer pain in my soul,and grief in my heart all the day long?,How long shall my enemy triumph over me?"
,"4":"Look upon me and answer, O Lord my God! Give light to my eyes, lest I sleep the sleep of death;"
,"5":"lest my enemy say, 'I have routed him,',lest my foes rejoice of my fall."
,"6":"But I put my trust in your unfailing love, my heart will rejoice on seeing your salvation. I will sing to the Lord, for he has been good to me!"
}`)
	CurrentBook.AddChapter(14, `{
"1":"The fool says in his heart, 'God does not exist.',All have strayed, all are perverted, there is no one who does good."
,"2":"The Lord looks down from heaven,upon the race of Adam, to see if there are any,who seek God and act wisely."
,"3":"They have all turned aside: corrupt - all of them alike."
,"4":"Will they ever learn - these doers of evil?,For they devour my people, - that is their food -,and do not call upon the Lord."
,"5":"But suddenly terror strikes them: God was on the side of the just!"
,"6":"You may confound the hope of the poor, but the Lord is their refuge."
,"7":"Oh would that I see,Israel's salvation coming from Zion!,When the Lord brings home the exiles, what joy it will be for Jacob, what happiness for Israel!"
}`)
	CurrentBook.AddChapter(15, `{
"1":"O Lord, who will dwell in your tent,and reside on your holy mount?"
,"2":"Those who walk blamelessly,and do what is right, who speak truth from their heart"
,"3":"and control their words, who do no harm to their neighbors,and cast no discredit on their companions,"
,"4":"who look down on evildoers,but highly esteem God's servants; who at all cost stand by a pledged word,"
,"5":"who do not lend money at interest,and refuse a bribe against the innocent. Do this, and you will soon be shaken."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Keep me safe, O God, for in you I take refuge."
,"2":"I say to the Lord, 'You are my Lord, my only good.'"
,"3":"The gods of th'e earth are but nothing, cursed be those who delight in them."
,"4":"Those who run after foreign gods,only have their sorrows multiplied. Let me not shed blood for them, nor their names be heard on my lips."
,"5":"O Lord, my inheritance and my cup, my chosen portion - hold secure my lot."
,"6":"The best part has been allotted to me. Delightful indeed is my inheritance!"
,"7":"I bless the Lord who counsels me; even at night my inmost self instructs me."
,"8":"I keep the Lord always before me; for with him at my right hand, I will never be shaken."
,"9":"My heart, therefore, exults, my soul rejoices; my body too will rest assured."
,"10":"For you will not abandon,my soul to the grave, nor will you suffer your holy one,to see decay in the land of the dead."
,"11":"You will show me the path of life, in your presence the fullness of joy, at your right hand happiness forever."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Hear a just cause, O Lord, listen to my complaint. Give heed to my prayer,for there is no deceit on my lips."
,"2":"Let my defense come forth from you; your eyes see what is right."
,"3":"You have probed my heart, searched me at night, tested me by fire, and you have seen no wickedness in me."
,"4":"I have not sinned by my words,as others do; I have kept your word,and followed your ways."
,"5":"Hold firm my steps upon your path, that my feet may not stumble."
,"6":"I call on you, you will answer me, O God; incline your ear and hear my word."
,"7":"For you do wonders for your faithful, you save those fleeing from the enemy,as they seek refuge at your right hand."
,"8":"Keep me as the apple of your eye; under the shadow of your wings hide me,"
,"9":"far from my violent pursuers, from the onslaught of the wicked despoilers."
,"10":"Their mouths speak arrogantly; they have shut their hearts to mercy."
,"11":"Now they surround me and track me down, their eyes eager to see me overthrown."
,"12":"Like lions made fierce by hunger, they want only to kill and tear."
,"13":"Arise, O Lord, confront them, overthrow them!,May your sword deliver me from the wicked."
,"14":"O Lord, strike them with your hand,and give them no share with the living. May their belly be filled,with what you have stored for them, and their children have more than enough,to leave to their descendants."
,"15":"As for me, righteous in your sight, I shall see your face and, awakening, gaze my fill on your likeness."
}`)
	CurrentBook.AddChapter(18, `{
"2":"I love you, O Lord, my strength."
,"3":"The Lord is my rock, my fortress, my deliverer and my God. He is the rock in whom I take refuge. He is my shield, my powerful savior, my stronghold."
,"4":"I call on the Lord, who is worthy of praise: he saves me from my enemies!"
,"5":"A deadly flood surrounded me, devilish torrents rushed at me;"
,"6":"caught by the cords of the grave, I was brought to the snares of death."
,"7":"But I called upon the Lord in my distress, I cried to my God for help; and from his temple he heard my voice, my cry of grief reached his ears."
,"8":"Then the earth reeled and rocked; the foundations of the mountains shook; they trembled at his fury."
,"9":"Smoke rose from his nostrils, from his mouth a devouring fire,throwing off live embers."
,"10":"He bent the heavens and came down,with dark clouds under his feet."
,"11":"He rode on a cherub and flew, borne on the swift wings of the wind."
,"12":"Veiled with darkness surrounding him, he made misty rain clouds his tent."
,"13":"Then from the brightness of his presence,hail and fiery embers broke forth."
,"14":"From heaven the Lord thundered; the voice of the Most High resounded."
,"15":"Sending out a hail of arrows, he scattered them; flashing forth bolts of lightning, he routed them."
,"16":"The beds of the seas appeared, the foundations of the world were laid bare,at the rebuke of the Lord, at the blast of his breath."
,"17":"Reaching down from above, he drew me out of the deep waters."
,"18":"Too strong for me were my enemies, but he rescued me from my adversaries."
,"19":"They launched their attack on an opportune day, but the Lord was my support."
,"20":"He has set me out in the open, he saved me because he cares for me!"
,"21":"The Lord rewarded me for my justice, according to my righteousness."
,"22":"For I have been faithful to the Lord's way,and have not departed from my God."
,"23":"All his ordinances are before me, I have always followed his statutes."
,"24":"Before him I have done uprightly,and kept myself from iniquity."
,"25":"The Lord treats me according to my merits, according to the cleanness of my hands."
,"26":"With the faithful you are faithful; with the blameless you are blameless;"
,"27":"with the pure you are pure but with the crooked you are astute."
,"28":"For you raise up the humble,and bring down the arrogant."
,"29":"Lord, you give light to my lamp. O my God, you brighten my darkness."
,"30":"Yes, with you I charge the armed bands, and by my God I leap over the wall."
,"31":"This God - his way is perfect; the word of the Lord can stand fire. He is a shield for those who seek refuge in him."
,"32":"There is no other God but Yahweh. There is no other rock but our God."
,"33":"He is the God who girds me with strength,and prepares my ways."
,"34":"He makes my feet as swift as the deer's; he sets me securely on the heights."
,"35":"He trains my hands for war,and my arms to bend the bronze-bow."
,"36":"You give me your shield for protection, your right hand upholds me, and your help makes me great."
,"37":"You enlarge the space before me, my step will not falter."
,"38":"I pursue my enemies and overtake them, I do not turn back till I have destroyed them."
,"39":"Thrusting them through, I do not give them time to rise; they fall under my feet."
,"40":"You give me strength for the battle; you subdue my adversaries beneath me;"
,"41":"you put my enemies to flight,and destroy those who hate me."
,"42":"They cry for help, but no one comes. They cry to the Lord; he does not answer them."
,"43":"I pulverize them as dust before the wind; like mud in the streets I trample them."
,"44":"You delivered me from my people's quarrels,and made me head over the nations. They came to serve me - people I have not known."
,"45":"At the sound of my voice, they rose to obey, foreigners fawned before me."
,"46":"Staggering out of their fortresses, they came to me cringing and trembling."
,"47":"The Lord lives! Praised be my rock!,Exalted be my savior God -"
,"48":"the God who grants me vengeance,and subdues the peoples for me."
,"49":"He delivers me from my foes; he exalts me above my adversaries; he rescues me from violent people."
,"50":"For this I extol you, O Lord, among the nations; I will sing praise to your name, saying:"
,"51":"'He has given victories to his king; he has shown his love to his anointed ones, to David, and to his descendants forever.'"
}`)
	CurrentBook.AddChapter(19, `{
"2":"The heavens declare the glory of God; the firmament proclaims the work of his hands."
,"3":"Day talks it over with day; night hands on the knowledge to night."
,"4":"No speech, no words, no voice is heard -"
,"5":"but the call goes on throughout the universe, the message is felt to the ends of the earth."
,"6":"High above, he pitched a tent for the sun, who comes out as a bridegroom from his pavilion, or like a racer joyfully runs his course."
,"7":"Rising from one end, it makes its circuit of the heavens, and sets at the other end; and nothing is hidden from its heat."
,"8":"The law of the Lord is perfect: it gives life to the soul. The word of the Lord is trustworthy: it gives wisdom to the simple."
,"9":"The precepts of the Lord are right: they give joy to the heart. The commandments of the Lord are clear: they enlighten the eyes."
,"10":"The fear of the Lord is pure, it endures forever; the judgments of the Lord are true, all of them just and right."
,"11":"They are more precious than gold -,pure gold of a jeweller; they are much sweeter than honey,which drops from the honeycomb."
,"12":"They are a light to your servant, in keeping them they win a great reward."
,"13":"But who can discern one's own errors?,Forgive the failings of which I am unaware."
,"14":"Preserve me from willful sin; do not let it get the better of your servant. Then shall I walk blameless,and innocent of serious sin."
,"15":"May the words of my mouth,and the meditations of my heart,find favor in your sight, O Lord - my redeemer, my rock!"
}`)
	CurrentBook.AddChapter(20, `{
"2":"May the Lord answer you in the day of distress; may the name of Jacob's God give you protection."
,"3":"May he send you help from the sanctuary,and give you support from Mount Zion."
,"4":"May he remember all your oblations,and look favorably on your burnt offerings."
,"5":"May he grant you your heart's desire,and fulfill all your plans."
,"6":"In your victory let us shout for joy,and raise our banner in the name of our God. May the Lord grant all your requests."
,"7":"Now I know that the Lord saves his anointed; he has answered him from his holy heaven,with victories from his right hand."
,"8":"Some boast of chariots, some of horses; but we boast in the name of the Lord our God."
,"9":"Their forces will collapse and be crushed, but ours shall rise, and stand firm."
,"10":"When we call, answer us, O Lord, make the king victorious!"
}`)
	CurrentBook.AddChapter(21, `{
"2":"The king rejoices in your strength, O Lord, and exults in your saving help."
,"3":"You have granted him his desire; you have not rejected his request."
,"4":"You have come to him with rich blessings; you have placed a golden crown upon his head."
,"5":"When he asked, you gave him life - length of days forever and ever."
,"6":"He glories in the victory you gave him; you shall bestow on him splendor and majesty."
,"7":"You have given him eternal blessings, and gladdened him with the joy of your presence."
,"8":"The king trusts in the Lord, and through the love of the Most High, he will not be shaken."
,"9":"Your hand, O Lord, will reach your enemies, and lay hold of all your foes."
,"10":"Your mere appearance will turn them into a blazing furnace. Your wrath will engulf them like a fire."
,"11":"You will wipe their fruit from the earth and destroy their posterity."
,"12":"Though they plot evil against you and devise wicked schemes, they will never win;"
,"13":"they will turn back in fear, when you aim arrows at them."
,"14":"Be exalted, O Lord, in your strength! We will sing in praise of your might."
}`)
	CurrentBook.AddChapter(22, `{
"2":"My God, my God, why have you forsaken me? Why are you so far from me, from the sound of my groaning?"
,"3":"My God, I call by day, but you never answer; by night and I find no rest."
,"4":"Yet you are enthroned the Holy One, the praise of Israel."
,"5":"In you our fathers trusted, and you delivered them."
,"6":"They cried to you and they were saved; they trusted in you and were not overcome."
,"7":"But I am a worm and not human, scorned by everyone, despised by the people."
,"8":"All who see me make a jest of me; they sneer and shake their heads."
,"9":"'He put his trust in the Lord, let the Lord rescue him! If the Lord is his friend, let him help him!'"
,"10":"Yet it is you who drew me from the womb and kept me safe at my mother's breasts."
,"11":"I have been yours from birth; from my mother's womb you have been my God."
,"12":"Be not far from me for trouble is near, and there is no one to help me."
,"13":"A herd of bulls surround me - strong bulls of Bashan closing in on me,"
,"14":"their mouths open, like lions roaring for their prey."
,"15":"I am like water draining away; all my bones are out of joint, my heart melts away like wax."
,"16":"My throat is dried up like a potsherd; my tongue clings to my palate. You have laid me down in the dust of death."
,"17":"Round about me are vicious dogs, villainous rogues encircling me. They have tied up my hands and feet."
,"18":"They can count all my bones, for they are looking and watching me,"
,"19":"dividing my garments among them and casting lots for my raiment."
,"20":"O Lord, be not far from me! O my strength, come quickly to my help."
,"21":"Deliver my soul from the sword, my life from the powerful grip of the dog."
,"22":"Rescue me from the jaws of the lion, my soul from the horns of the wild bull."
,"23":"I will proclaim your name to my brothers, I will praise you in the assembly,"
,"24":"'All you who fear the Lord, praise him! All you sons of Jacob, glorify him! All you sons of Israel, revere him!"
,"25":"For he has not scorned or loathed the afflicted in his misery. He has not hidden his face from me but has listened when I cried to him.'"
,"26":"I will praise you in the great assembly, fulfill my vows before all who revere you."
,"27":"The lowly will eat and be satisfied. Those who seek the Lord will praise him. May your hearts live forever!"
,"28":"The whole earth from end to end will acknowledge and turn to the Lord; the families of nations will worship him."
,"29":"For dominion belongs to the Lord and he reigns over the nations."
,"30":"Before him all those who rest in the earth will bow down, all who go down to the dust. My soul will live for him. "
,"31":"My descendants will serve him and proclaim the Lord to coming generations;"
,"32":"they will announce his salvation to a people yet unborn, 'These are the things that he has done.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"The Lord is my shepherd, I shall not want."
,"2":"He makes me lie down in green pastures. He leads me beside the still waters,"
,"3":"he restores my soul. He guides me through the right paths,for his name's sake."
,"4":"Although I walk through the valley of the shadow of death, I fear no evil, for you are beside me: your rod and your staff comfort me."
,"5":"You spread a table before me,in the presence of my foes. You anoint my head with oil; my cup is overflowing."
,"6":"Goodness and kindness will follow me,all the days of my life, I shall dwell in the house of the Lord,as long as I live."
}`)
	CurrentBook.AddChapter(24, `{
"1":"The earth and its fullness belong to the Lord, the world and all that dwell in it."
,"2":"He has founded it upon the ocean,and set it firmly upon the waters."
,"3":"Who will ascend the mountain of the Lord?,Who will stand in his holy place?"
,"4":"Those with clean hands and pure heart, who desire not what is vain, and never swear to a lie."
,"5":"They will receive blessings from the Lord, a reward from God, their savior."
,"6":"Such are the people who seek him, who seek the face of Jacob's God."
,"7":"Lift up, O gateways, your lintels, open up, you ancient doors, that the King of glory may enter!"
,"8":"Who is the King of glory?,The Lord, the strong, the mighty, the Lord, valiant in battle."
,"9":"Lift up your lintels, O gateways, open up, you ancient doors, that the King of glory may enter!"
,"10":"Who is the King of glory?,The Lord of Hosts, he is the King of glory!"
}`)
	CurrentBook.AddChapter(25, `{
"1":"To you, O Lord, I lift up my soul."
,"2":"In you my God I trust; let me not be put to shame, let not my enemies exult over me."
,"3":"Those who hope in you will never be humbled; those who turn away from you will suffer disgrace!"
,"4":"Teach me your ways, O Lord; make known to me your paths."
,"5":"Guide me in your truth and instruct me, for you are my God, my savior; I hope in you all day long."
,"6":"Remember your compassion, O Lord, your unfailing love from of old."
,"7":"Remember not the sins of my youth, but in your love remember me."
,"8":"Good and upright, the Lord teaches sinners his way."
,"9":"He teaches the humble of heart and guides them in what is right."
,"10":"The ways of the Lord are love and faithfulness for those who keep his covenant and precepts."
,"11":"For the sake of your name, Lord, forgive my iniquity, for it is great."
,"12":"To those who fear the Lord, he will teach the way to choose."
,"13":"They will live in prosperity, and their descendants will inherit the land."
,"14":"The Lord gives advice to those who revere him and makes his covenant known to them."
,"15":"My eyes are always on the Lord, for he will free my feet from the snare."
,"16":"Turn to me and have compassion, for I am lonely and afflicted."
,"17":"Free my heart of bitterness; relieve me of this distress."
,"18":"See my pain and sufferings, and forgive all my sins."
,"19":"See how my enemies have increased and how violently they hate me."
,"20":"Deliver me from them; let me not be put to shame, for I have trusted you."
,"21":"Let integrity and uprightness be my protection, for all my hope, O Lord, is in you."
,"22":"Redeem, O God, redeem Israel from all its troubles!"
}`)
	CurrentBook.AddChapter(26, `{
"1":"Declare me innocent, O Lord, for I have lived with integrity; I have put my trust in the Lord, I shall never waver."
,"2":"Prove me, O Lord, put me to the test; examine my soul and my heart."
,"3":"For your love is ever before my eyes, and I live in truth and faithfulness."
,"4":"I do not associate with the deceitful nor do I go with hypocrites;"
,"5":"I hate the party of the corrupt and avoid the company of the wicked."
,"6":"I wash my hands free of guilt and walk in procession round your altar,"
,"7":"singing hymns of praise and thanksgiving and proclaiming your wondrous deeds."
,"8":"O Lord, I love the house where you dwell, the place of your Glory."
,"9":"Let me not share the fate of sinners, nor lose my life with the violent;"
,"10":"their hands are guilty of crimes, their right hands are weighed down with bribes."
,"11":"But I will walk in integrity. Redeem me, O God, be gracious to me."
,"12":"My foot stands firm in the straight path, I will praise you, O Lord, in your assemblies."
}`)
	CurrentBook.AddChapter(27, `{
"1":"The Lord is my light and my salvation,- whom shall I fear?,The Lord is the rampart of my life; I will not be afraid."
,"2":"When the wicked rush at me,to devour my flesh, it is my foes who stumble, my enemies fall."
,"3":"Though an army encamp against me, my heart will not fail; though war break out against me, I will still be confident."
,"4":"One thing I ask of the Lord, one thing I seek -,that I may dwell in his house all the days of my life, to gaze at his jewel and to visit his sanctuary."
,"5":"For he will keep me safe in his shelter,in times of misfortune; he will hide me beneath his roof, and set me high upon a rock."
,"6":"Then my head will be lifted up,over the enemies round about me. I will offer sacrifices at his Tent with shouts of joy; I will sing and make music in praise of the Lord."
,"7":"Hear my voice when I call, O Lord, have mercy on me and answer."
,"8":"My heart says to you, 'I seek your face, O Lord.'"
,"9":"Do not hide your face from me,nor turn away your servant in anger. You are my protector, do not reject me,abandon me not, O God my savior!"
,"10":"Though my father and mother forsake me, yet will the Lord receive me."
,"11":"Teach me, O Lord your way; lead me along a straight path."
,"12":"Save me from the plot of my enemies, for false witnesses have risen against me,to pin me down in their violence."
,"13":"I hope, I am sure, that I will see the goodness of the Lord,in the land of the living."
,"14":"Trust in the Lord, be strong and courageous,- yes, put your hope in the Lord!"
}`)
	CurrentBook.AddChapter(28, `{
"1":"To you, O Lord, I call; my rock, be not deaf to me. For if you heed me not, I shall go down to the pit like the rest."
,"2":"Hear my cry for mercy as I call to you for help, as I lift up my hands toward your innermost sanctuary."
,"3":"Drag me not away with the wicked, with those who do evil, who mouth words of peace while they sow mischief and confusion."
,"4":"Punish them for their evil designs and wicked deeds; give them their due reward."
,"5":"Since they have no regard for the works of the Lord, he will tear them down and never let them rise again."
,"6":"Blessed be the Lord! He has heard my cry for help."
,"7":"The Lord is my strength, my shield. My heart was sure of him, I have been helped and my heart exults, with my song I give him thanks."
,"8":"The Lord is the strength of his people, the saving refuge of his anointed."
,"9":"Save your people, and bless your inheritance. Be their shepherd and carry them forever."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Give the Lord, O sons of God, give the Lord glory and strength,"
,"2":"give the Lord the glory due his name; worship the Lord in great liturgy."
,"3":"The voice of the Lord is over the waters; the God of glory thunders, the Lord thunders over vast waters."
,"4":"How powerful is the voice of the Lord, How splenderous if the voice of the Lord."
,"5":"The voice of the Lord tears up the cedars, the Lord is shattering the cedars of Lebanon."
,"6":"He makes Lebanon skip like a calf, and Sirion like a young wild bull."
,"7":"The voice of the Lord breaks forth with flashes of fire,"
,"8":"the voice of the Lord makes the wilderness quake, The Lord is shaking the wilderness of Kadesh."
,"9":"The voice of the Lord makes the oaks shudder, the Lord strips the forests bare, and in his temple all cry, 'Glory!'"
,"10":"Over the flood the Lord was sitting; the Lord is king and he reigns forever."
,"11":"May the Lord give his people strength; may the Lord bless his people with peace!"
}`)
	CurrentBook.AddChapter(30, `{
"2":"I extol you, O Lord, for you have rescued me; my enemies will not gloat over me."
,"3":"O Lord my God, I called to you for help, and you healed me."
,"4":"O Lord, you have brought me up from the grave, you gave me life when I was going to the pit."
,"5":"Sing to the Lord, O you his saints, give thanks and praise to his holy name."
,"6":"For his anger lasts but a little while, and his kindness all through life. Weeping may tarry for the night, but rejoicing comes with the dawn."
,"7":"Once in my prosperity I said, 'I shall not be troubled.'"
,"8":"Yet it was you, O Lord, who had me stand on the rock; as soon as you hid your face, I wavered!"
,"9":"To you, O Lord, I called; to you I begged for mercy:"
,"10":"'What good would there be in my destruction, in my going down to the pit?,Would my dust give you praise?,Would it prove your faithfulness?"
,"11":"Hear, O Lord, and have mercy on me; O Lord, be my protector.'"
,"12":"But now, you have turned my mourning into rejoicing; you have taken off my sackcloth and wrapped me in the garments of gladness."
,"13":"And so my soul, no longer silent, now sings praise without ceasing. O Lord my God, forever will I give you thanks."
}`)
	CurrentBook.AddChapter(31, `{
"2":"In you, O Lord, I take refuge, may I never be disgraced; deliver me in your justice."
,"3":"Give heed to my plea, and make haste to rescue me. Be a rock of refuge for me, a strong fortress for my safety."
,"4":"For you are my rock and my stronghold, lead me for your name's sake;"
,"5":"free me from the snare that they have set for me. Indeed you are my protector."
,"6":"Into your hands I commend my spirit; you have redeemed me, O Lord, faithful God."
,"7":"You hate those who worship worthless idols; but I put all my trust in the Lord."
,"8":"I will rejoice and be glad in your love, for you have seen my affliction, you know the agony of my soul."
,"9":"The hand of the enemy did not grab me; you gave me room to move."
,"10":"Be merciful to me, O Lord, in my affliction; my eyes have grown dim with sorrow, my body emaciated."
,"11":"For my days are wracked with grief, and my years worn out in anguish. My strength fails because of my misery."
,"12":"I have become an object of reproach for my foes and for my neighbors; so horrible to my friends that they hurry away when they see me in the streets."
,"13":"I am like the dead, unremembered; I have become like a broken pot, thrown away, discarded."
,"14":"I hear whispering among the crowd, rumors that frighten me from every side - their conspiracies, their schemes, their plot to take my life."
,"15":"But I put my trust in you, O Lord. You are my God;"
,"16":"my days are in your hand. Deliver me from the hand of my enemies, from those after my skin."
,"17":"Make your face shine upon your servant; save me in your love."
,"18":"Let me not be dishonored, O Lord, for I have called on you; but let the wicked lie dishonored and go to the pit never to speak."
,"19":"Let lying lips close in silence, these speaking against the just with malice and arrogance."
,"20":"How great is the goodness which you have stored for those who fear you, which you show, for all to see, to those who take refuge in you!"
,"21":"In the shelter of your presence you hide them from human wiles; you keep them in your dwelling, safe from the intrigues of wagging tongues."
,"22":"Blessed be the Lord for his wonderful love! He has strenghtened my heart."
,"23":"I said in my fright: 'I have been cut off from your sight!',Yet when I was crying, you heard; when I called for mercy, you listened."
,"24":"Love the Lord, all you his saints! The Lord preserves his faithful, but he fully requites the arrogant."
,"25":"Be strong and take courage, all you who hope in the Lord."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Blessed is the one whose sin is forgiven, whose iniquity is wiped away."
,"2":"Blessed are those in whom the Lord sees no guilt,and in whose spirit is found no deceit."
,"3":"When I kept my sin secret, my body wasted away, I was moaning all day long."
,"4":"Your hand day and night lay heavy upon me; draining my strength, parching my heart,as in the heat of a summer drought."
,"5":"Then I made known to you my sin,and uncovered before you my fault, saying to myself, 'To the Lord I will now confess my wrong.',And you, you forgave my sin, you removed my guilt."
,"6":"So let the faithful ones pray,to you in time of distress; the overflowing waters will not reach them."
,"7":"You are my refuge; you protect me from distress,and surround me with songs of deliverance."
,"8":"I will teach you, I will show you the way to follow. I will watch over you and give you counsel."
,"9":"Do not be like the horse or the mule -,senseless and led by bit and bridle."
,"10":"Many woes befall the wicked, but the Lord's mercy enfolds those who trust in him."
,"11":"Rejoice in the Lord, and be glad, you who are upright; sing and shout for joy, you who are clean of heart."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Rejoice in the Lord, you who are just, praise is fitting for the upright."
,"2":"Give thanks to him on the harp and lyre, making melody and chanting praises."
,"3":"Amid loud shouts of joy, sing to him a new song,and play the ten-stringed harp."
,"4":"For upright is the Lord's word,and worthy of trust is his work."
,"5":"The Lord loves justice and righteousness; the earth is full of his kindness."
,"6":"The heavens were created by his word, the breath of his mouth formed their starry host."
,"7":"He gathered the waters of the sea into a heap, and stored the deep in cellars."
,"8":"Let the whole earth fear the Lord, let the inhabitants of the world stand in awe of him."
,"9":"For he spoke and so it was, he commanded, and everything stood firm."
,"10":"The Lord frustrates the plans of the nations,and brings to nothing the peoples' designs."
,"11":"But his plan stands forever, and his heart's design through all generations."
,"12":"Blessed is the nation whose God is the Lord -,the people he has chosen for his inheritance."
,"13":"The Lord looks down from heaven,and sees the whole race of mortals."
,"14":"From where he sits he watches,all those who dwell on the earth -"
,"15":"he who fashions every heart,observes all their deeds."
,"16":"A king is not saved by a powerful army, nor a warrior rescued by his great strength."
,"17":"Don't think that a horse will save you; its great strength does not assure victory."
,"18":"But the Lord's eyes are upon those who fear him, upon those who trust in his loving-kindness"
,"19":"to deliver them from death,and preserve them from famine."
,"20":"In hope we wait for the Lord, for he is our help and our shield."
,"21":"Our hearts rejoice in him, for we trust in his holy name."
,"22":"O Lord, let your love rest upon us, even as our hope rests in you."
}`)
	CurrentBook.AddChapter(34, `{
"2":"I will bless the Lord all my days; his praise will be ever on my lips."
,"3":"My soul makes its boast in the Lord; let the lowly hear and rejoice."
,"4":"Oh, let us magnify the Lord, together let us glorify his name!"
,"5":"I sought the Lord, and he answered me; from all my fears he delivered me."
,"6":"They who look to him are radiant with joy, their faces never clouded with shame."
,"7":"When the poor cry out, the Lord hears,and saves them from distress."
,"8":"The Lord's angel encamps and patrols,to keep safe those who fear him."
,"9":"Oh, see and taste the goodness of the Lord!,Blessed is the one who finds shelter in him!"
,"10":"Revere the Lord, all you his saints, for those who fear him do not live in want."
,"11":"The mighty may be hungry and in need, but those who seek the Lord lack nothing."
,"12":"Come, listen to me, my sons; I will show you how to fear the Lord."
,"13":"If you desire long life, if you want to enjoy prosperity,"
,"14":"keep your tongue from falsehood, keep your lips from deceit;"
,"15":"turn away from evil and do good; seek peace and pursue it."
,"16":"The eyes of the Lord are fixed on the righteous; his ears are inclined to their cries."
,"17":"But his face is set against the wicked,to destroy their memory from the earth."
,"18":"The Lord hears the cry of the righteous,and rescues them from all their troubles."
,"19":"The Lord is close to the brokenhearted,and saves the distraught."
,"20":"Many are the troubles of the just, but the Lord delivers them from all."
,"21":"He keeps all their bones intact, and none of them will be broken."
,"22":"Evil will slay the wicked; the enemies of the just will be doomed."
,"23":"But the Lord will redeem the life of his servants; none of those who trust in him will be doomed."
}`)
	CurrentBook.AddChapter(35, `{
"1":"O Lord, attack those who attack me; fight against those who fight against me."
,"2":"Come to my aid with armour and shield;"
,"3":"stand with your spear and war ax, halt my pursuers. Say to my soul, 'I am your deliverer.'"
,"4":"Let them be shamed and dishonored, those who seek my life. Let them be routed and destroyed, those who plot my ruin."
,"5":"Let them be like chaff before the wind, when the Lord's angel drives them away."
,"6":"Let their escape path be dark and precipitous, with the Lord's angel always at their heels."
,"7":"They set their net against me for no cause, they dug a pit for me without reason."
,"8":"Let ruin come upon them unexpectedly, let them be entangled in their own snare; let them fall into the trap of their own making."
,"9":"Then will my soul rejoice in the Lord and exult in his salvation."
,"10":"My whole being will exclaim, 'O Lord, who is like you? You who deliver the oppressed from those too strong for them, you who rescue the poor and the afflicted from their oppressors.'"
,"11":"False witnesses take the stand, accusing me of crimes of which I am innocent."
,"12":"For my kindness they return evil, bringing my life to despair."
,"13":"When they were sick, I wore sackcloth and fasted; I prayed hard with head bowed,"
,"14":"as if I were bereft of a friend or brother; I shed tears in grief, as one mourning the death of his mother."
,"15":"But when I stumbled they gathered in glee and, began to strike me; like strangers they disowned me and accused me falsely."
,"16":"Like an ungodly circle of mockers, they gnashed their teeth and made me the butt of all their ridicule."
,"17":"How long, O Lord, will you look on? Deliver my life, my only one, from these lions."
,"18":"Then I will thank you in the great assembly; I will praise you in the mighty throng."
,"19":"Do not let them gloat over me - those who, unprovoked, have become my foes. Do not let them wink maliciously - those who hate me without cause."
,"20":"Sowing discontent with their tongue and mind, they devise false accusations against the peace-loving people of the land."
,"21":"They open wide their mouths against me: 'Aha, aha!' they say, 'We have seen it with our own eyes!'"
,"22":"But you, O Lord, who have seen, do not keep silent. Do not stand far from me."
,"23":"Stir yourself up, stand up for my rights and my cause, my God and my Lord!"
,"24":"Declare me innocent, O Lord, my God, according to your justice. Let them not gloat over me."
,"25":"Never give them reason to say, 'We have trampled him down!'"
,"26":"Let them be utterly disgraced and confounded, who exult over my calamity. Let them be ashamed and dishonored, who rejoice at my distress."
,"27":"But let them be glad and rejoice, who are in sympathy with my cause. And may they ever say, 'Great is the Lord, who has justified his servant.'"
,"28":"Then will my tongue proclaim your righteousness, and sing your praises all day long."
}`)
	CurrentBook.AddChapter(36, `{
"2":"Wickedness speaks to the wicked in the depths of his heart: there is no fear of God before his eyes."
,"3":"Blinded by conceit, he fails to see his guilt."
,"4":"With mouths full of malice and deceit, they no longer think of doing good."
,"5":"They plot mischief even in bed; committed to a life of sin, they know not how to reject evil."
,"6":"Your love, O God, reaches the heavens; your faithfulness, to the clouds."
,"7":"Your justice is like the mighty mountains; your judgment like the unfathomable deep. You preserve, O Lord, humans and beasts."
,"8":"How precious, O God, is your constant love! Mortals take refuge in the shadow of your wings."
,"9":"In your house they find rich food and they drink from your spring of delight,"
,"10":"for with you is the fountain of life. In your light we see light."
,"11":"Bestow on your faithful your love and give salvation to the upright of heart."
,"12":"Let not the foot of the arrogant trample on me, nor the hand of the wicked drive me away."
,"13":"But what! See how the evildoers lie fallen, flung down and never to rise again."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Do not be annoyed with evil people nor be envious of wrongdoers."
,"2":"For they will fade as any green herb and soon be gone like withered grass."
,"3":"Trust in the Lord and do good, dwell in the land and live on it."
,"4":"Make the Lord your delight, and he will grant your heart's desire."
,"5":"Commit your way to the Lord; put your trust in him and let him act."
,"6":"Then will your revenge come, beautiful as the dawn, and the justification of your cause, bright as the noonday sun."
,"7":"Keep calm before the Lord, wait for him in patience; do not fret if others succeed when they carry out evil schemes."
,"8":"Refrain from anger, turn away from wrath; fret not, for it only leads to evil."
,"9":"Remember this: the wicked will perish, but those who hope in the Lord will inherit the land."
,"10":"Wait a moment: the wicked are no more. Though you look for them, they cannot be found;"
,"11":"but the humble will inherit the land and enjoy peace in abundance."
,"12":"The wicked plot against the virtuous and gnash their teeth at them;"
,"13":"but the Lord laughs at the wicked, for he sees their day coming."
,"14":"The wicked draw their swords and bend their bows; they aim at the poor and the afflicted, they get ready to slay the righteous."
,"15":"But their bows will be shattered; the sword thrust into their own heart."
,"16":"The little that the righteous possess is better than the abundance of the wicked."
,"17":"For the arms of the wicked will be broken, and the righteous will be upheld by the Lord."
,"18":"The Lord watches over the lives of the upright; forever will their inheritance abide."
,"19":"They are not crushed in times of calamity; when famine strikes, they still are satisfied."
,"20":"But the wicked will perish; the enemies of the Lord will vanish like smoke, disappear like the wild flowers."
,"21":"The wicked borrow and do not repay, but the righteous have mercy and share."
,"22":"They will inherit the land - those whom the Lord blesses; but those whom the Lord curses he will cut off."
,"23":"The Lord is the one who makes people stand, he gives firmness to those he likes."
,"24":"They may stumble, but they will not fall, for the Lord holds them by the hand."
,"25":"From my youth to old age, I have yet to see the righteous forsaken or their children begging for alms."
,"26":"He lends and gives, and his children are blessed. The whole day he succeeds."
,"27":"Do good and shun evil, so that you will live secure forever."
,"28":"For the Lord loves justice and right, and never forsakes his faithful ones. The wicked instead will perish and their breed will be cut off."
,"29":"The righteous will possess the land; they will make it their home forever."
,"30":"The mouth of the virtuous utters wisdom and his tongue speaks of what is right."
,"31":"His steps have never faltered, for the law of God is in his heart."
,"32":"The wicked spies on the just man and lies in wait to slay him."
,"33":"But the Lord does not hand him over, or let him be condemned when he is tried."
,"34":"Hope in the Lord and follow his way, for he will exalt you and give you the land. You will see how the wicked perish."
,"35":"I have seen an oppressor mighty, towering like a cedar of Lebanon."
,"36":"But when I passed by again, he was no longer there. I looked for him but could not find him."
,"37":"Mark the blameless, watch the upright, and you will see that there is a future for the person of peace."
,"38":"But all sinners will be destroyed; the future of the wicked will be shattered."
,"39":"The Lord is the salvation of the righteous; in time of distress, he is their refuge."
,"40":"The Lord helps them, and rescues them from the oppressor; he saves them for they sought shelter in him."
}`)
	CurrentBook.AddChapter(38, `{
"2":"O Lord, rebuke me not in your rage, punish me not in your fury."
,"3":"Your arrows have struck me; your hand has come down heavily upon me."
,"4":"Your anger has spared no part of my body, my sin gives no peace to my bones."
,"5":"For my transgressions overwhelm me; they weigh me down like an unbearable load."
,"6":"My wounds stink and fester within me, the outcome of my sinful folly."
,"7":"Stooped and bowed down, I go about mourning all day."
,"8":"My loins burn, my flesh is diseased,"
,"9":"my body, worn out and utterly crushed; I groan in pain and anguish of heart."
,"10":"All my longing, O Lord, is known to you; my sighing is not hidden from you."
,"11":"My heart pounds as my strength ebbs; even the light has deserted my eyes."
,"12":"My friends avoid me because of my wounds; my neighbors stay far off."
,"13":"Those who seek my life lay snares for me; those who wish to hurt me speak of my ruin and plot against me all day long."
,"14":"But like a deaf-mute, I neither hear nor open my mouth."
,"15":"I am like one whose ears hear not and whose mouth has no answer."
,"16":"For I put my trust in you, O Lord; you will answer for me, Lord God."
,"17":"I pray, 'Don't let them gloat over me, nor take advantage of my helplessness when my foot slips.'"
,"18":"For I am about to fall, my pain is ever with me."
,"19":"I confess my transgression, I repent of my sin."
,"20":"Many are my foes; many are those who hate me for no reason,"
,"21":"those who pay me evil for good and harass me because I seek good."
,"22":"Forsake me not, O Lord, stay not far from me, O my God."
,"23":"Come quickly to help me, O Lord, my savior!"
}`)
	CurrentBook.AddChapter(39, `{
"2":"I said, 'I will watch my ways and keep my tongue from sin; I will muzzle my mouth in front of the wicked.'"
,"3":"So I did. But as I kept silent, their happiness made my anguish grow."
,"4":"My heart began to burn within, and finally, I blurted out:"
,"5":"'Lord, let me know when my end will come, let me know the number of my days; show me how frail and fleeting is my life.'"
,"6":"You allow me to live but a short span; before you, all my years are nothing. Human existence is a mere whiff of breath."
,"7":"Humans are mere shadows that go about relentlessly. Being but a breath they toil and rake in wealth, not knowing who will take it next."
,"8":"But now, O Lord, what do I await? All my hope rests in you."
,"9":"Rescue me from all my sins and let me not be derided by fools."
,"10":"I shall keep silent and not open my mouth, since this is your work."
,"11":"Only remove from me your scourge; for I am done in with your blows."
,"12":"When you want to correct the mortals and punish their sin, you eat like moth what they hold dear. Mortals are a mere puff of wind!"
,"13":"Hear, O Lord, my supplication, listen to my cry for protection; do not be deaf to my lamentation. For I dwell with you as an alien - a pilgrim, as all my ancestors have been."
,"14":"Turn from me awhile, that I may find relief, before I depart and be no more.'"
}`)
	CurrentBook.AddChapter(40, `{
"2":"With resolve I waited for the Lord; he listened and heard me beg."
,"3":"Out of the horrid pit he drew me, out of deadly quicksand. He settled my feet upon a rock and made my steps steady."
,"4":"He put a new song in my mouth, a song of praise to our God. Many will see and be awed and put their trust in the Lord."
,"5":"Blessed is the one who relies on the Lord and does not look to the proud nor go astray after false gods."
,"6":"How numerous, O Lord, are your wonderful deeds! In your marvelous plans for us you are beyond compare! How many they are - I cannot tell them or count their number."
,"7":"Sacrifice and oblation you did not desire; this you had me understand. Burnt offering and sin offering you do not require."
,"8":"Then I said, 'Here I come! as the scroll says of me."
,"9":"To do your will is my delight, O God, for your law is within my heart.'"
,"10":"In the great assembly I have proclaimed your saving help. My lips, O Lord, I did not seal - you know that very well."
,"11":"I have not locked up in my heart your saving help, but have spoken about it - your deliverance and your faithfulness; I have made no secret of your truth and your kindness in the great assembly."
,"12":"Do not withhold from me, O Lord, your mercy; let your love and faithfulness preserve me constantly."
,"13":"For troubles beyond number have closed in on me; I am all covered by sins and I cannot see. They are more than the hairs of my head, and I am losing courage."
,"14":"May it please you, O Lord, to rescue me. Make haste, O Lord, to help me!"
,"15":"May those who seek my life be brought to shame and disgrace; may those who want me destroyed be turned back in confusion."
,"16":"May those who taunt me with, 'Aha, aha!' be filled with shame and consternation."
,"17":"But may all those who seek you rejoice and be glad in you; and may all who love your saving grace continually say, 'The Lord is great.'"
,"18":"Though I am afflicted and poor, yet the Lord thinks of me. You are my help and my savior - O Lord, do not delay!"
}`)
	CurrentBook.AddChapter(41, `{
"2":"Blessed the one who has regard for the poor; the Lord delivers him in time of trouble."
,"3":"The Lord protects him, preserves his life, and gives him happiness in the land; he yields him not to the will of his foes."
,"4":"The Lord helps him when he gets sick, and heals him of all his ailments."
,"5":"I have pleaded, 'O Lord, have mercy on me; heal me, in spite of all my iniquity.'"
,"6":"My enemies ask of me in malice, 'When will he die and his name perish?',When they come in to see, they talk emptily gathering slanderous gossip. No sooner have they left, that they tell their comments."
,"7":"Then all my enemies whisper together, imagining the worst for me:"
,"8":"'A deadly disease has fastened on him. He will never get up again!'"
,"9":"Even my most trusted friend, with whom I shared my food, has lifted his heel against me."
,"10":"But you, O Lord, have mercy on me; lift me up to give them recompense."
,"11":"This will assure me that I enjoy your favor: if my enemies do not triumph over me,"
,"12":"if you uphold my integrity,and let me stand in your presence forever."
,"13":"Praise the Lord, the God of Israel, from all eternity and forever!,Amen. Amen!"
}`)
	CurrentBook.AddChapter(42, `{
"2":"As a deer longs for flowing streams, so my soul longs for you, O God."
,"3":"My soul thirsts for God, for the living God. When shall I go and see the face of God?"
,"4":"Day and night my tears have been my food, as people ask me day after day, 'Where is your God?'"
,"5":"Now as I pour out my soul, I remember all this -,how I used to lead the faithful,in procession to the house of God, amid shouts of joy and thanksgiving, among the feasting throng."
,"6":"Why are you so downcast, my soul, why so troubled within me?,Hope in God, for I will praise him again, my savior and my God."
,"7":"My soul is downcast when I remember,from these lands of Jordan and Hermon, 'Where are you, small mountain?'"
,"8":"Deep calls to deep as your cataracts thunder; your waves and torrents have gone over me."
,"9":"May the Lord bestow his love by day, by night his song is upon my lips -,a prayer to the God of my life."
,"10":"I say to God, my rock, 'Why have you forgotten me?,Why do I go about mourning, oppressed by the enemy?'"
,"11":"My whole being suffers in mortal agony, as my adversaries continually taunt me, 'Where is your God?'"
,"12":"Why are you so downcast, my soul, why so troubled within me?,Hope in God, for again I will praise him -,my savior and my God."
}`)
	CurrentBook.AddChapter(43, `{
"1":"Make justice, O God, and defend my cause,against an ungodly people; deliver me from the wicked and deceitful."
,"2":"You are my God, my stronghold, why have you cast me out?,Why should I go about mourning, oppressed by the enemy?"
,"3":"Send forth your light and your truth; let them be my guide, let them take me to your holy mountain, to the place where you reside."
,"4":"Then will I go to the altar of God, to God, my gladness and delight. I will praise you with the lyre and harp, O God, my God."
,"5":"Why are you so downcast, my soul, why so troubled within me?,Hope in God, for again I will praise him -,my savior and my God."
}`)
	CurrentBook.AddChapter(44, `{
"2":"With our ears, O God, we have heard; our fathers have declared to us the works you did in their days of old."
,"3":"You drove out the nations and settled our fathers in their land; you conquered the peoples to make room for them."
,"4":"For it was not with their own sword that they conquered the land nor were they victors by their own hand; but it was by your right hand and arm and by the light of your countenance; for you truly loved them."
,"5":"It is you, my King and my God, who ordain victories for Jacob."
,"6":"Through you we batter down our foes; through your name we shatter our enemies."
,"7":"For it is not in my bow that I trust, nor in my sword to make me victorious."
,"8":"But it is you who give us victory, you who bring our adversaries to shame."
,"9":"It is always in God that we find glory. Forever shall we praise your name."
,"10":"Yet now you have rejected and humbled us; you no longer go forth with our armies."
,"11":"You have let our enemies drive us back and our adversaries plunder us."
,"12":"You have let us be driven for slaughter like sheep, scattered among nations as captives."
,"13":"You have handed us over to them for nothing: the sale was of no benefit for you."
,"14":"You have made us the butt of our neighbors' insult, the scorn and laughingstock of those around us."
,"15":"You have made us a byword among the nations; they look at us and shake their heads."
,"16":"All day long my disgrace is before me and shame covers my face,"
,"17":"at the voice of the one who mocks and reviles, in the presence of the enemy and the avenger."
,"18":"All this has happened to us, although we have not forgotten you, nor have we been untrue to your covenant."
,"19":"Our heart has not turned back nor have our steps faltered;"
,"20":"yet you have crushed us in the desert of the snakes and covered us with deep darkness."
,"21":"Had we forgotten the name of our God and stretched forth our hands to an alien god,"
,"22":"God would have discovered this, for the secrets of the heart are not hidden from him."
,"23":"For your sake we are slain all day and accounted as sheep for slaughter."
,"24":"Awake, O Lord! Why are you asleep? Arise! Reject us not forever."
,"25":"Why hide your face from us? Why forget our misery and woes?"
,"26":"Our souls are humbled in the dust, our bodies smashed to the ground."
,"27":"Come to our help, deliver us for the sake of your kindness."
}`)
	CurrentBook.AddChapter(45, `{
"2":"My heart is moved by an exalted theme,as I deliver my ode to the king, my tongue as nimble as a writer's pen."
,"3":"You are the finest among all others, your lips are anointed with graciousness, for God has blessed you forever."
,"4":"Gird your sword upon your thigh, O mighty one, array yourself with splendor and majesty."
,"5":"Glorious and triumphant, ride on,for the sake of truth, for a just cause. You will see marvelous deeds of your right hand."
,"6":"Your arrows are sharp, O king, they pierce the hearts of your enemies; nations fall beneath your feet."
,"7":"Your throne, O God, will last forever; a scepter of justice is your scepter."
,"8":"You love righteousness and hate wickedness; therefore God, your God, has anointed you,with the oil of gladness, above your fellow kings."
,"9":"Your robes are fragrant,with myrrh, aloes and cassia. The music of strings gladdens your palace,adorned and glowing with ivory."
,"10":"Among your ladies of honor,are daughters of kings; at your right hand, in gold of Ophir, stands the queen."
,"11":"Listen, O daughter, pay attention; forget your father's house and your nation,"
,"12":"and your beauty will charm the King, for he is your lord."
,"13":"The people of Tyre will bow before him. The wealthiest nations will seek your favor."
,"14":"All glorious as she enters,is the princess in her gold-woven robes."
,"15":"She is led in royal attire to the king, following behind is her train of virgins."
,"16":"Amid cheers and general rejoicing, they enter the palace of the king."
,"17":"Forget your fathers and think of your sons, you will make them princes throughout the land."
,"18":"I will make your name famous through all generations; may all nations praise you forever!"
}`)
	CurrentBook.AddChapter(46, `{
"2":"God is our strength and protection, an ever-present help in affliction."
,"3":"We will not fear, therefore, though the earth be shaken,and the mountains plunge into the seas,"
,"4":"though its waters foam and roar, though the mountains quake and totter. For the Lord of hosts is with us, the God of Jacob, our stronghold."
,"5":"There is a river whose streams bring joy to the city of God, the holy place where the Most High dwells."
,"6":"God is within, the city cannot quake, for God's help is upon it at the break of day."
,"7":"Kingdoms tottered, nations were in turmoil; at the sound of his voice the earth melts away."
,"8":"For with us is the Lord of hosts, the God of Jacob, our refuge."
,"9":"Come, see the works of the Lord -,the marvelous things he has done in the world."
,"10":"He has put an end to wars, broken the bows and splintered the spears, set the shields and chariots afire."
,"11":"Be still, know that I am God. I am exalted among the nations, exalted over the earth!"
,"12":"With us is the Lord of hosts, the God of Jacob, our refuge."
}`)
	CurrentBook.AddChapter(47, `{
"2":"Clap your hands, all you peoples; acclaim God with shouts of joy."
,"3":"For the Lord, the Most High, is to be feared; he is a great king all over the earth."
,"4":"He brings peoples under our dominion,and puts nations under our feet."
,"5":"He chose our inheritance for us -,the pride of Jacob whom he loves!"
,"6":"God ascends amid joyful shouts, the Lord amid trumpet blasts."
,"7":"Sing praises to God, sing praises!,Sing praises to our King, sing praises!"
,"8":"God is king of all the earth; sing to him a hymn of praise."
,"9":"For God now rules over the nations, God reigns from his holy throne."
,"10":"The leaders of the nations rally together,with the people of the God of Abraham. For in his hands are the great of the earth, God reigns far above."
}`)
	CurrentBook.AddChapter(48, `{
"2":"Great is the Lord, most worthy of praise in the city of God, his holy mountain."
,"3":"Beautifully elevated, it is the joy of all the earth,- Mount Zion, heavenly mountain, the city of the great King."
,"4":"Here within her lines of defense, God has shown himself to be a sure fortress."
,"5":"The kings assembled together, advanced toward the city."
,"6":"But as soon as they saw it, they were astounded; they panicked and took to flight."
,"7":"Seized with fear, they trembled, like a woman in travail,"
,"8":"or like the ships of Tarshish, shattered by a strong wind from the east."
,"9":"As we have heard, so have we seen, in the city of the Lord of hosts, in the city of our God, the city God founded forever."
,"10":"Let us recall your unfailing love, O God, inside your temple."
,"11":"Let your praise as does your name, O God, reach to the ends of the earth. Your right hand is ever victorious."
,"12":"Let Mount Zion rejoice, let the villages of Judah be glad, for your justice prevails."
,"13":"Walk around Zion, count her towers,"
,"14":"consider her ramparts, examine her castles, that you may tell the next generation"
,"15":"that such is God; God is our guide forever."
}`)
	CurrentBook.AddChapter(49, `{
"2":"Hear this, all you peoples!,Listen, all you inhabitants of the world,"
,"3":"high and low together, rich and poor alike!"
,"4":"My mouth will speak wisdom, my deep thoughts will bring discernment."
,"5":"To a proverb I will incline my ear, and solve my riddle to the rhythm of my lyre."
,"6":"Why should I fear when evil days come, when wicked deceivers ring me round -"
,"7":"those who trust in their wealth,and boast of their great riches?"
,"8":"For no ransom avails for one's life, there is no price one can give to God for it."
,"9":"For redeeming one's life,demands too high a price, and all is lost forever."
,"10":"Who can remain forever alive,and never see the grave?"
,"11":"For we see that the wise die, and pass away like the fool and the stupid,leaving to others their fortune and wealth."
,"12":"Their graves are their eternal homes, from generation to generation, no matter how big the tracts of land they own."
,"13":"People of wealth have no thought, they will be silenced like the beasts."
,"14":"This is the fate of people trusting themselves, the future of those who rely on their strength."
,"15":"Like sheep led to the grave, they have death as their shepherd and ruler; quickly their form will be consumed,in the world of the dead, which is their home."
,"16":"But God will rescue my soul from the grave,by receiving me unto himself."
,"17":"Fear not when someone grows rich, when his power becomes oppressively great,"
,"18":"for nothing will he take when he dies; his wealth and pomp he will leave behind."
,"19":"Though he praised himself in his lifetime, 'All will say that I have enjoyed life,'"
,"20":"he will join the generation of his forebears, who will never again see the light."
,"21":"People of wealth have no thought, they will be silenced like the beasts."
}`)
	CurrentBook.AddChapter(50, `{
"1":"The God of gods, the Lord has spoken, he summons the earth from the rising of the sun to its setting."
,"2":"God has shone from Zion, perfect in beauty."
,"3":"God is no longer silent, he comes; before him is a devouring fire, around him a raging storm."
,"4":"He calls to the heavens above, and to the earth below, that he may judge his people:"
,"5":"'Gather before me my faithful ones, who made a covenant with me by sacrifice.'"
,"6":"The heavens will proclaim his sentence, for God himself is the judge."
,"7":"'Hear, O my people, for I am speaking. I will accuse you, O Israel, I am God, your God!"
,"8":"Not for your sacrifices do I reprove you, for your burnt offerings are ever before me."
,"9":"I need no bull from your stalls, nor he-goat from your pens."
,"10":"For I own all the beasts of the forest,and the animals of my thousand hills."
,"11":"All the birds of the air I know; all that move in the fields are mine."
,"12":"I need not tell you if I were hungry, for mine is the world and all that it contains."
,"13":"Do I eat the flesh of bulls,or drink the blood of goats?"
,"14":"Yet offer to God a sacrifice of thanks, and fulfill your vows to the Most High."
,"15":"Call on me in time of calamity; I will deliver you, and you will glorify me.'"
,"16":"But God says this to the wicked: 'What right have you to mouth my laws, or to talk about my covenant?"
,"17":"You hate my commands,and cast my words behind you."
,"18":"You join a thief when you meet one; you keep company with adulterers."
,"19":"You have a mouth of evil,and a deceitful tongue."
,"20":"You speak ill of your brother, and slander your own mother's son."
,"21":"Because I was silent while you did these things, you thought I was like you. But now I rebuke you,and make this charge against you."
,"22":"Give this a thought, you who forget God, lest I tear you to pieces with no one to help you."
,"23":"Those who give with thanks offerings honor me, but the one who walks blamelessly, I will show him the salvation of God.'"
}`)
	CurrentBook.AddChapter(51, `{
"3":"Have mercy on me, O God, in your love. In your great compassion blot out my sin."
,"4":"Wash me thoroughly of my guilt; cleanse me of evil."
,"5":"For I acknowledge my wrongdoings,and have my sins ever in mind."
,"6":"Against you alone have I sinned; what is evil in your sight I have done. You are right when you pass sentence,and blameless in your judgment."
,"7":"For I have been guilt-ridden from birth, a sinner from my mother's womb."
,"8":"I know you desire truth in the heart, teach me wisdom in my inmost being."
,"9":"Cleanse me with hyssop and I shall be clean, wash me, I shall be whiter than snow."
,"10":"Fill me with joy and gladness; let the bones you have crushed rejoice."
,"11":"Turn your face away from my sins,and blot out all my offenses."
,"12":"Create in me, O God, a pure heart; give me a new and steadfast spirit."
,"13":"Do not cast me out of your presence,nor take your holy spirit from me."
,"14":"Give me again the joy of your salvation,and sustain me with a willing spirit."
,"15":"Then I will show wrongdoers your ways,and sinners will return to you."
,"16":"Deliver me, O God, from the guilt of blood, and of your justice I shall sing aloud."
,"17":"O Lord, open my lips, and I will declare your praise."
,"18":"You take no pleasure in sacrifice; were I to give a burnt offering, you would not delight in it."
,"19":"O God, my sacrifice is a broken spirit; a contrite heart you will not despise."
,"20":"Shower Zion with your favor: rebuild the walls of Jerusalem."
,"21":"Then you will delight in fitting sacrifices, in burnt offerings and bulls offered on your altar."
}`)
	CurrentBook.AddChapter(52, `{
"3":"Why boast of your wickedness, strong man? Why boast all day long"
,"4":"that you are plotting crimes?,Your tongue is like a sharp razor; "
,"5":"you love evil more than good, and falsehood more than truth."
,"6":"You love words that inflict harm, O you deceitful tongue!"
,"7":"But God will bring you down forever; he will snatch you, tear you away from your tent; he will uproot you from the land of the living."
,"8":"The good will know fear at the sight; they will say concerning his fate:"
,"9":"'See the one who would not rely on God, but trusted in riches and drew strength from wickedness.'"
,"10":"But I am as a green olive tree that thrives in the house of God: I trust in God's unfailing love forever and ever."
,"11":"I will praise you forever for all you have done, and proclaim your good name before the faithful ones."
}`)
	CurrentBook.AddChapter(53, `{
"2":"The fool says in his heart, 'There is no God.' They are corrupt, their ways are wicked; not one of them does good."
,"3":"From heaven God looks down upon the sons of men, to see if there is anyone who seeks God and understands."
,"4":"None! They have all fallen away. Depraved - they are all alike. There is no one who does good, no, not even one."
,"5":"Will these evildoers never learn? They devour my people just as they devour food and never call on God."
,"6":"There they are - afraid when there is nothing to be feared. God will scatter their bones; they will be put to shame because God has rejected them."
,"7":"May I see Israel's salvation coming forth from Zion! When God restores his people's fortune, Jacob will be glad, Israel will rejoice."
}`)
	CurrentBook.AddChapter(54, `{
"3":"By your name, O God, save me; you, the Valiant, uphold my cause."
,"4":"Hear my prayer, O God; listen to the words of my mouth."
,"5":"Strangers are against me - the ruthless seek my life; they have no regard for God."
,"6":"See, God is my helper; the Lord upholds my life."
,"7":"May their evil plots rebound on them; in your faithfulness destroy them!"
,"8":"Freely will I offer sacrifice to you and praise your name, O Lord, for it is good."
,"9":"You have delivered me from calamity, and I look down on my foes."
}`)
	CurrentBook.AddChapter(55, `{
"2":"Listen to my prayer, O God, do not be deaf to my pleading;"
,"3":"give heed to me and answer me. I am greatly troubled "
,"4":"at the outcry of the enemy and the clamor of the wicked. I am distraught at the way they revile me and persecute me in their fury."
,"5":"My heart agonizes within me; the terrors of death fall upon me."
,"6":"I tremble in fear - horror has got the better of me."
,"7":"I said, 'If I had wings like a dove, I would fly away and be at rest;"
,"8":"I would seek a home in the desert"
,"9":"or hurry to find a cave for shelter from the tempest.'"
,"10":"O Lord, shatter their plans. In the city I see strife and violence;"
,"11":"day and night they prowl about its walls, while inside, evil prevails."
,"12":"Forces of tyranny and treachery are at work undermining the city."
,"13":"If it were a rival insulting me, I could bear with him; if it were a foe in pursuit of me, I could hide from him."
,"14":"But it is you, an equal of mine, my bosom friend, my companion"
,"15":"whose fellowship I enjoyed as we walked together in the house of God."
,"16":"Let death come upon them suddenly, let them go down to the grave alive, for within them evil and mischief thrive."
,"17":"But in God I seek refuge; the Lord will rescue me."
,"18":"Morning, evening, and even at noon, I cry out my grievance and moan; surely he will hear my voice."
,"19":"He will deliver me in safety from my opponents, for they are many."
,"20":"God who is enthroned forever will hear me and humble them, for they do not repent nor do they stand in awe of God."
,"21":"My friend has attacked his associates and has violated his pact with them."
,"22":"His words were smoother than butter, yet war was in his heart; his utterances, more soothing than oil, were swords ready and drawn."
,"23":"Place your burden on the Lord, and he will sustain you, for he never allows the upright to fall."
,"24":"But you, O God, will cast the wicked into a pit; bloodthirsty and treacherous, they will not live out half their days. As for me, I trust in you alone, O Lord."
}`)
	CurrentBook.AddChapter(56, `{
"2":"O God, show your mercy to me, for my foes are in hot pursuit; they press their attack on me all the time."
,"3":"My accusers pursue me all day long, many attack me."
,"4":"But when I am afraid, O Mighty One, I put my trust in you,"
,"5":"In God whose word I praise, in God I trust without fear. What can mortals do against me?"
,"6":"All day long they hatch their evil plans, plotting mischief to injure my cause."
,"7":"They conspire and lurk around, watching my every move, bent upon taking my life."
,"8":"They must not be allowed to go unpunished; therefore, O God, in your fury bring the nations down."
,"9":"You have a record of my laments; my tears are stored in your wineskin. Are they not written on your scroll?"
,"10":"My enemies turn back when I call on you for help; now I know that God is for me."
,"11":"In God whose word I praise,"
,"12":"in God I trust without fear. What can mortals do against me?"
,"13":"I am bound to you by vows, O God; I shall offer my thanksgiving."
,"14":"For you have rescued my soul from death and my feet from stumbling, that I might walk in God's presence in the light of the living."
}`)
	CurrentBook.AddChapter(57, `{
"2":"Have mercy on me, O God, have mercy, for my soul takes refuge in you; I will find shelter in the shadow of your wings till the disaster has passed."
,"3":"I call on God the Most High, on God who has done everything for me:"
,"4":"may he send from heaven a savior and put my oppressors to shame. May God send me his love and faithfulness."
,"5":"I lie prostrate in the midst of lions that greedily devour people, their teeth are pointed spears and arrows, their tongues, sharpened swords."
,"6":"Be exalted, O God, above the heavens! Your glory be over all the earth!"
,"7":"They have set a snare for my steps; my soul was bowed down in distress. They dug a pit along my path, but they themselves fell into it."
,"8":"My heart is steadfast, O God, my heart is steadfast. I will sing and make music."
,"9":"Awake, my soul, awake, O harp and lyre! I will wake the dawn."
,"10":"I will give thanks to you, O Lord, among the peoples; I will sing praise to you among the nations."
,"11":"For your love reaches to the heavens, and your faithfullness, to the clouds."
,"12":"Be exalted, O God, above the heavens! Let your Glory be over all the earth!"
}`)
	CurrentBook.AddChapter(58, `{
"2":"You gods, are your decrees just, and are your judgments upright?"
,"3":"No, you willfully commit crimes; you deal in violence and corruption."
,"4":"Even from the womb the wicked go astray; from birth they are wayward liars."
,"5":"They are poisonous like deadly snakes, deaf as the adder"
,"6":"that blocks its ears so as not to hear the charmer's voice casting spells."
,"7":"Break the teeth in their mouths, O God; tear out the fangs of the lions, O Lord."
,"8":"Let them vanish like spilled water; let them be trodden down like grass that withers."
,"9":"Let them be like snails that sink into slime, like untimely births that never see the sun."
,"10":"Like green grass that is burned before the thorns are dry, let them be swept away!"
,"11":"The upright will rejoice when they are avenged; they will bathe their feet in the blood of the wicked."
,"12":"Then will people say, 'Surely the righteous are rewarded; surely there is a God who gives judgment on earth.'"
}`)
	CurrentBook.AddChapter(59, `{
"2":"Deliver me from my enemies, O God, from those who rise up against me."
,"3":"Deliver me from evildoers; rescue me from the bloodthirsty."
,"4":"Look, they lie in wait for my life; the mighty conspiring against me, for no fault of mine, O Lord."
,"5":"I have done them no wrong, yet they prepare to attack me. Rise and help me, look on my plight,"
,"6":"O Lord God of hosts, God of Israel! Arise and punish the nations; have no mercy on the wicked traitors."
,"7":"Each evening they return, howling like dogs, prowling about the city."
,"8":"To their mind, God does not hear or see their wicked deeds."
,"9":"But you, O Lord, laugh at them; you look down upon the wicked."
,"10":"O my Strength, I look up to you, for you, O God, are my fortress."
,"11":"My loving God will come to help me and let me see my enemies fall."
,"12":"But slay them not, lest my people forget; just shake them by your power, and bring them down, O Lord, our shield."
,"13":"Give us your help against the foe, for human help is worthless. For the curses and lies they utter, "
,"14":"destroy them in your vengeance, destroy them till they are no more. Then it will be known that God rules over Jacob to the ends of the earth."
,"15":"Each evening let them return, howling like dogs, prowling about the city,"
,"16":"roaming about for food, growling and never filled."
,"17":"But I will sing of your might; in the morning I will sing of your love. For you have been a fortress to me, a refuge in time of distress."
,"18":"O my Strength, I will sing praises to you, for you, O God, are my stronghold; you are a loving God."
}`)
	CurrentBook.AddChapter(60, `{
"3":"O God, you have rejected us and have broken our defenses; you have been angry, but now turn back to us."
,"4":"You have shaken the land and torn it open; mend its cracks for it totters."
,"5":"You have made your people suffer; you have given us wine that makes us stagger."
,"6":"You set the banner behind us and your people fled from bow and arrow."
,"7":"Help us and listen to us, that your beloved may be rescued."
,"8":"God has spoken in his sanctuary: 'In triumph I will divide up Shechem and parcel out the Valley of Succoth."
,"9":"Gilead is mine; Manasseh is mine; Ephraim is my helmet, Judah my scepter."
,"10":"Moab is my washbasin; upon Edom I cast my sandal; over Philistia I shout in triumph.'"
,"11":"Who will take me to the fortified city? Who will lead me to Edom?"
,"12":"Have you not rejected us, O God? You no longer go with our armies."
,"13":"Give us aid against the foe, for human help is not worth a straw."
,"14":"With God we will gain victory; he will crush the enemy for us."
}`)
	CurrentBook.AddChapter(61, `{
"2":"Hear my cry, O God; listen to my prayer."
,"3":"I call to you from the ends of the earth; my heart grows faint. Set me high upon a rock;"
,"4":"be my refuge, a strong tower against the enemy."
,"5":"Let me dwell in your tent forever and take refuge in your wings' shelter."
,"6":"Indeed you have heard my vows, O God, and the wish of those who fear your name."
,"7":"Increase the days of the king's life; prolong his years for many generations."
,"8":"May he ever be enthroned in God's presence; let your love and loyalty watch over him."
,"9":"So I will sing praises to your name and fulfill my vows day after day."
}`)
	CurrentBook.AddChapter(62, `{
"2":"My soul finds rest in God alone; from him comes my salvation."
,"3":"He alone is my rock and salvation; with him as my stronghold, I shall not be overcome."
,"4":"How long will you assail with your threats, all of you, to bring someone down -,as you would pull a wall or smash a fence?"
,"5":"Indeed they plan to topple me. They take pleasure in telling lies; with their mouths they bless, but in their hearts they curse."
,"6":"Find rest in God alone, O my soul; from him comes my hope."
,"7":"He alone is my rock and my salvation; with him as my stronghold, I shall not be overcome."
,"8":"On God rests my salvation and my honor; he is my refuge, my mighty rock."
,"9":"Trust in him at all times, my people; pour out your hearts before him; God is our refuge."
,"10":"People of low rank are only a breath, important people, merely an illusion. If weighed together they are nothing, even lighter than a puff of wind."
,"11":"Do not set your heart on extortion, nor your hopes upon corrupt gain. Even if wealth accumulates, keep your heart detached."
,"12":"God has spoken one word, and I have heard two things: that power belongs to God,"
,"13":"and yours, O God, is also mercy: you reward each one according to his deeds."
}`)
	CurrentBook.AddChapter(63, `{
"2":"O God, you are my God, it is you I seek; for you my body longs and my soul thirsts, as a dry and weary land without water."
,"3":"Thus have I gazed upon you in the sanctuary, to see your power and your glory."
,"4":"Your love is better than life, my lips will glorify you."
,"5":"I will bless you as long as I live, lift up my hands and call on your name."
,"6":"As with the richest food my soul will feast; my mouth will praise you with joyful lips."
,"7":"When I remember you on my bed,I think of you all through the night,"
,"8":"for you have been my help; I sing in the shadow of your wings."
,"9":"My soul clings to you, your right hand upholds me."
,"10":"In vain they are after my life, they will go down to the depths of the earth;"
,"11":"they will be delivered to the sword, and become the prey of jackals."
,"12":"The king will rejoice in God. All who swear by God's name will boast: 'At last slanderers' tongues have been silenced.'"
}`)
	CurrentBook.AddChapter(64, `{
"2":"Hear, O God, my voice as I plead, protect my life from the enemy's threat."
,"3":"Hide me from the scheming of the wicked, from the designs of the evil-plotters,"
,"4":"who sharpen their tongues like swords and aim bitter words like arrows,"
,"5":"shooting at the innocent from cover, shooting suddenly without fear."
,"6":"They invite each other to evil-doing, they conspire to lay snares, saying, 'No one will see us,"
,"7":"who will uncover our scheme?',Who peers into man will uncover them."
,"8":"And now God fires his arrows at them and suddenly they are struck down."
,"9":"Their own tongue brought them to ruin and all who see them shake their heads."
,"10":"Everyone will stand in awe; they proclaim the works of God and ponder on his deeds."
,"11":"The upright will rejoice and take refuge in the Lord; the upright of heart will glory in him."
}`)
	CurrentBook.AddChapter(65, `{
"2":"Praise belongs to you, O God, in Zion; here people come to fulfill their vows."
,"3":"All mortals bring to you their evil deeds, to you, who answer prayers."
,"4":"Though our faults prevail over us, you forgive our sins."
,"5":"Blessed is the one you choose to approach you,and take to dwell in your courts. In your house we are satisfied,with the good things of your holy temple."
,"6":"With awesome deeds of righteousness,you answer us, O God our savior, hope of all the ends of the earth,and of distant islands."
,"7":"By your power you set up the mountains."
,"8":"By your strength the seas were calmed; you lull their roaring waves,and the turmoil of the nations."
,"9":"Those who dwell at the ends of the earth,stand in awe of your marvelous deeds. You make joyful the dawn,and the coming of dusk."
,"10":"You water the land and care for it, enriching it with natural resources. God's stream is filled with water; so you prepare the earth,to give us its fruits."
,"11":"You drench the furrows in the land,and level the ridges, you soften the soil with showers,and bless its crops."
,"12":"You crown the year with your goodness; abundance flows everywhere."
,"13":"The deserts have become pasture land, the hills are clothed with gladness,"
,"14":"the meadows covered with flocks, the valleys decked with grain -,they shout and sing for joy."
}`)
	CurrentBook.AddChapter(66, `{
"1":"Shout with joy to God, all you on earth;"
,"2":"sing to the glory of his name; proclaim his glorious praise."
,"3":"Say to God, 'How great are your deeds!,How formidable your power,that makes your enemies cower!"
,"4":"All the earth bows down to you, making music in praise of you, singing in honor of your name.'"
,"5":"Come and see God's wonders, his deeds awesome for humans."
,"6":"He has turned the sea into dry land, and the river was crossed on foot. Let us, therefore, rejoice in him."
,"7":"He rules by his might forever, his eyes keeping watch on the peoples, his arm holding the rebels in check."
,"8":"Praise our God, O nations, let the sound of his praise be heard,"
,"9":"for he has preserved us among the living,and kept our feet from stumbling."
,"10":"Why did you test us, O God; and refine us like silver?"
,"11":"You let us fall into the snare; you burdened us with disgrace."
,"12":"You allowed a nobody to rule over us, and we have gone through fire and water, but you have brought us to safety at last."
,"13":"I will bring offerings to your house,in fulfillment of my vows -"
,"14":"Those I made when assailed with troubles."
,"15":"I will offer holocausts of fatlings, sending up smoke of burning rams, and a sacrifice of goats and bulls."
,"16":"All you who fear God, come and listen; let me tell you what he has done."
,"17":"I cried aloud to him, extolling him with my tongue."
,"18":"If I had nurtured wickedness in my heart, then he would not have heard."
,"19":"But God has listened; he gave heed to my prayer."
,"20":"May God be blessed!,He has not rejected my prayer; nor withheld his love from me."
}`)
	CurrentBook.AddChapter(67, `{
"2":"May God be gracious and bless us; may he let his face shine upon us,"
,"3":"that your way be known on earth,and your salvation among the nations."
,"4":"May the peoples praise you, O God, may all the peoples praise you!"
,"5":"May the countries be glad and sing for joy, for you rule the peoples with justice,and guide the nations of the world."
,"6":"May the peoples praise you, O God, may all the peoples praise you!"
,"7":"The land has given its harvest; God, our God, has blessed us."
,"8":"May God bless us and be revered, to the very ends of the earth."
}`)
	CurrentBook.AddChapter(68, `{
"2":"Arise, O God, scatter your enemies; let your foes flee before you."
,"3":"As smoke is blown by the wind, so blow them away; as wax melts before the fire, so let the wicked perish before you."
,"4":"But let the righteous be glad and exult before God; let them sing to God and shout for joy."
,"5":"Sing to God, sing praises to his name; open the way to him who rides upon the clouds; the Lord is his name. Rejoice in his presence."
,"6":"Father of orphans and protector of widows - such is our God in his holy dwelling."
,"7":"He gives shelter to the homeless, sets the prisoners free, but keeps the rebels in their jail."
,"8":"O God, when you went forth to lead your people through the desert,"
,"9":"the earth trembled, the heavens poured down rain, at the presence of God, the God of Israel."
,"10":"Then you gave a rain of blessings to comfort your weary children."
,"11":"Your people found a dwelling and in your mercy, O God, you provided for the needy."
,"12":"The Lord has dispatched messengers: 'The Lord has shattered an army!'"
,"13":"The kings and their armies flee, yes, they flee, they flee!"
,"14":"A woman at home divides the spoils: wings of dove covered with silver, their pinions with shining gold."
,"15":"When the Lord routed the kings, snow fell on the Dark Mountain."
,"16":"O mighty mountain of Bashan, high and rugged mountain,"
,"17":"why look with envy upon the mountain where God chooses to reign, where the Lord will dwell forever?"
,"18":"With myriads of powerful chariots, the Lord came from Sinai into his sanctuary."
,"19":"He ascended the high mountain, leading captives in his train, taking people as tributes, even rebels, to his dwelling."
,"20":"Blessed be the Lord, God our savior, who daily bears our burdens!"
,"21":"Ours is a God who saves; our Lord lets us escape from death."
,"22":"But he crushes the heads of his enemies, the hairy crowns of the criminals."
,"23":"The Lord said, 'I will bring them back from Bashan, back from the depths of the sea,"
,"24":"that you may bathe your feet in blood, and the tongues of your dogs may have their share of your foes.'"
,"25":"I remember the procession of the King, of my God, as they came into the sanctuary:"
,"26":"the singers in front, the musicians last, between them maidens playing tambourines."
,"27":"Praise God in the great congregation, praise the Lord in the feasts of Israel."
,"28":"There in the lead is the least of them, the tribe of Benjamin; the princes of Judah in a body; the princes of Naphtali, and of Zebulun."
,"29":"Summon your power, O God, with the strength you have wielded for us."
,"30":"To your temple in Jerusalem, kings will come with gifts."
,"31":"Rebuke the beast that dwell in the reeds, and the herd of bulls. Humble them; let them bring gold and silver. Scatter the nations who delight in war."
,"32":"Let wealth come from Egypt; let Ethiopia extend its hands to God."
,"33":"Sing to God, O kingdoms of the world; sing praises to the Lord,"
,"34":"to him who rides the ancient heavens and speaks in the voice of thunder."
,"35":"Proclaim the might of God; he is great in Israel, powerful in heavens."
,"36":"Awesome in his sanctuary is the God of Israel. He gives his people power and strength. Blessed be God!"
}`)
	CurrentBook.AddChapter(69, `{
"2":"Save me, O God, for the waters have come up to my neck."
,"3":"I am sunk in the miry depths where there is no foothold; I have come into deep waters, swept and engulfed by the flood."
,"4":"I am weary from calling for help; my throat is hoarse and parched. My eyes have grown dim looking for my God."
,"5":"More than the hairs of my head are those who hate me for no reason; mighty are those who attack me, many are my enemies without cause. What I did not steal I am forced to restore."
,"6":"Had I done wrong, O God, you would know it; my faults would not be hidden from you."
,"7":"Let me not bring disgrace to those who hope in you, O Lord God of hosts; may I cause no dishonor to those who seek you, O God of Israel -"
,"8":"since I am held in contempt for your sake, and shame has covered my face."
,"9":"I have become a stranger to my kindred, an alien to my mother's sons."
,"10":"Zeal for your house consumes me as fire and those who insult you insult me as well."
,"11":"When I humbled myself with fasting, I was scorned for it."
,"12":"When I put on sackcloth, I was made a laughingstock."
,"13":"I have become the talk of those who sit at the gates, the topic of the drunkards' songs."
,"14":"But I pray to you, O Lord, at a time most favorable to you. In your great love, O God, answer me with your unfailing help."
,"15":"Rescue me, lest I sink in the mire; deliver me from the storm and the deep waters."
,"16":"Let not the flood engulf me, nor the deep suck me in, let not the pit close its mouth upon me."
,"17":"In your mercy, O Lord, give me a good answer; in your great compassion, turn to me."
,"18":"Hide not your face from your servant; answer me at once for I am in distress."
,"19":"Come and rescue me; set me free from my enemies."
,"20":"You know the disgrace I suffer, and you know my oppressors and my humiliations."
,"21":"Dishonor has driven me to despair; I looked for sympathy and there was none, for comforters and there was no one."
,"22":"They gave me poison for food and vinegar to drink."
,"23":"May snares be set for them in their banquets and traps in their sacred feasts."
,"24":"May their eyes grow dim, so that they will not see; may their loins be stricken with palsy."
,"25":"Pour out your fury upon them, and let your burning anger overtake them."
,"26":"Make their camp desolate; may no one dwell in their tents,"
,"27":"for they persecute the one you have wounded, and increased the pain of the one you have struck."
,"28":"Charge them with crime upon crime, and do not acquit them."
,"29":"Blot them out of the book of life, and do not enroll them among the upright."
,"30":"But I myself am humbled and wounded; your salvation, O God, will lift me up."
,"31":"I will praise the name of God in song; I will glorify him with thanksgiving."
,"32":"This will please the Lord more than an ox or a bull with horns and divided hoofs."
,"33":"Let the lowly witness this and be glad. You who seek God, may your hearts be revived."
,"34":"For the Lord hears the needy and does not despise those in captivity."
,"35":"Let heaven and earth praise him, the seas and whatever moves in them."
,"36":"For God will save Zion and rebuild the cities of Judah. His people shall dwell in the land and possess it;"
,"37":"the children of his servants shall inherit it, and those who love his name will dwell in it."
}`)
	CurrentBook.AddChapter(70, `{
"2":"Be pleased, O God, to rescue me! Make haste to help me!"
,"3":"Let those who seek my life be put to shame and disgrace. Let those who want me destroyed be turned back in confusion."
,"4":"Let those who say, 'Aha, Aha!' to me feel consternation."
,"5":"May all who seek you be glad and rejoice in you. May all who love your saving power say evermore, 'Great is the Lord!'"
,"6":"But I am afflicted and needy; come to me quickly, O God, my help and my Savior. O God, do not delay!"
}`)
	CurrentBook.AddChapter(71, `{
"1":"In you, O Lord, I seek refuge; let me not be disgraced."
,"2":"In your justice help me and deliver me, turn your ear to me and save me!"
,"3":"Be my rock of refuge, a stronghold to give me safety, for you are my rock and my fortress."
,"4":"Rescue me, O my God, from the hand of the wicked, from the grasp of cruel and violent people."
,"5":"For you, O Lord, have been my hope, my trust, O God, from my youth."
,"6":"I have relied on you from birth: from my mother's womb you brought me forth. My praise is of you continually."
,"7":"I have become like a portent to many, but you are my strong refuge."
,"8":"My mouth is filled with your praise, announcing your glory day by day."
,"9":"Do not cast me off in my old age, do not desert me when my strength fails."
,"10":"For my enemies speak ill of me; awaiting my death they set plans."
,"11":"They say, 'God has forsaken him; let us pursue and seize him, for no one will rescue him.'"
,"12":"O God, be not far from me; my God, make haste to help me!"
,"13":"Let my accusers be destroyed in shame; let those who seek my ruin be covered with disgrace and scorn."
,"14":"Then I may trust in you and praise you."
,"15":"My lips will proclaim your intervention and tell of your salvation all day, little though it is what I can understand."
,"16":"I will come to your strength, O Lord, and announce your justice, yours alone."
,"17":"You have taught me from my youth and until now I proclaim your marvels."
,"18":"When I grow old and gray, do not leave me, O God; give me time to declare your might, your power to all generations to come."
,"19":"Your justice, O God, reaches to heaven; you have done great things. Who is like you, O God?"
,"20":"Many have been my hardships and misery, but once more you come to revive me; from the depths of the earth you will bring me up again."
,"21":"You will restore me and comfort me again."
,"22":"I will praise you with the harp, for your faithfulness, O my God; I will sing your praise with the lyre, O Holy One of Israel."
,"23":"My lips will rejoice, and my soul, too, which you have rescued."
,"24":"I will recall your intervention the whole day long, 'Yes, those who sought to do me harm have been confused and put to shame.'"
}`)
	CurrentBook.AddChapter(72, `{
"1":"O God, endow the king with your justice, the royal son with your righteousness."
,"2":"May he rule your people justly,and defend the rights of the lowly."
,"3":"Let the mountains bring peace to the people, and the hills justice."
,"4":"He will defend the cause of the poor, deliver the children of the needy, and crush the oppressor."
,"5":"He will endure as the sun,and as the moon through all generations."
,"6":"He will be like rain falling on the fields, or showers watering the earth."
,"7":"Justice will flower in his days, and peace abound till the moon be no more."
,"8":"For he reigns from sea to sea, from the River to the ends of the earth;"
,"9":"his foes are crushed before him, and his enemies lick the dust."
,"10":"The kings of Tarshish and the islands,render him tribute, the kings of Sheba and Seba bring gifts,"
,"11":"all kings bow down to him, and all nations serve him."
,"12":"He delivers the needy who call on him, the afflicted with no one to help them."
,"13":"His mercy is upon the weak and the poor, he saves the life of the poor."
,"14":"He rescues them from oppression and strife, for their life is precious to him."
,"15":"May he live long, may gold from Sheba be given him. May people always pray for him, and blessings be invoked for him all day."
,"16":"May grain abound throughout the land, waving and rustling as in Lebanon; may cities teem with people, as fields with grass."
,"17":"May his name endure forever; may his name be as lasting as the sun. All the races will boast about him, and he will be blessed by all nations."
,"18":"Praised be the Lord, God of Israel, who alone works so marvelously."
,"19":"Praised be his glorious name forever; may the whole earth be filled with his glory!,Amen. Amen."
,"20":"This concludes the prayers,of David, son of Jesse."
}`)
	CurrentBook.AddChapter(73, `{
"1":"Surely God is good to Israel, I mean, to the clean of heart."
,"2":"But, as for me, I almost stumbled, I nearly lost my foothold,"
,"3":"for I was envious of the arrogant, when I saw the wicked prosper."
,"4":"For they suffer no pain; they are strong and sound of body,"
,"5":"free from troubles common to mortals; they are not stricken by human ills."
,"6":"That is why pride becomes their necklace, and violence the robe that covers them."
,"7":"Evil comes from their callous hearts, boundless evil from their corrupt minds."
,"8":"They scoff and speak with malice, and they threaten arrogantly."
,"9":"Their mouths defy the heavens,and their tongues dictate on earth."
,"10":"People, therefore, look up to them,because they are well-watered."
,"11":"'Does God see?' they say. 'Has the Most High some knowledge of this?"
,"12":"Such are the wicked - always carefree,while they rake in riches. "
,"13":"In vain have I kept my heart clean,and washed my hands in innocence"
,"14":"if all day long I am stricken,and punished every morning.'"
,"15":"Had I spoken like this, I would not be acting as one of your children."
,"16":"Although I tried to understand this, it was difficult for me,"
,"17":"until I entered the secrets of God. Then I perceived their approaching doom."
,"18":"You place them on slippery ground,and make them fall into the pit."
,"19":"How suddenly they are destroyed, completely swept away in terror!"
,"20":"As one awakes from a nightmare, so when you arise, O Lord, you shake them off like a dream."
,"21":"When my heart was embittered, and my spirit distraught"
,"22":"it was folly, not wisdom; I did not know you better than the beasts."
,"23":"Yet I am always with you; you hold my right hand,"
,"24":"you guide me on the way you chose,and your Glory brings me along."
,"25":"I have no one in heaven but you; on earth I desire nothing but you."
,"26":"My flesh and my heart waste away,for you, O God, O my rock, you are mine forever."
,"27":"Those who abandon you will perish; you destroy all who are unfaithful to you."
,"28":"But as for me, my joy is to be near God; I have made the Lord my refuge, and I will proclaim all his works."
}`)
	CurrentBook.AddChapter(74, `{
"1":"O God, have you rejected us forever? Why vent your anger on the sheep of your own fold?"
,"2":"Remember the people you have formed of old, the tribe you have redeemed as your inheritance. Remember Mount Zion where you once lived."
,"3":"Climb and visit these hopeless ruins, the enemy has ravaged everything in the sanctuary."
,"4":"Your foes have roared triumphantly in the holy place, and set up their banner of victory."
,"5":"Like lumbermen felling trees,"
,"6":"they smashed the carved paneling with hatchets, hammers and axes."
,"7":"They defiled your sanctuary and set aflame the dwelling place of your name."
,"8":"They said in fury, 'Let us destroy them all.' They razed to the ground all the shrines of God in the land."
,"9":"With no signs and no prophets, no one can tell how long this will last."
,"10":"How long, O God, will the foe blaspheme? How long will the enemy revile your name?"
,"11":"Why do you hold back your right hand? Why keep your hand hidden?"
,"12":"Are you not O God, my king since birth, you who bring salvation to the land?"
,"13":"You split the sea in two by your power; you broke the monsters' heads in the water;"
,"14":"you crushed the heads of Leviathan and fed him to the dolphins."
,"15":"You opened up rivers and springs and dried up ever-flowing streams."
,"16":"You own the day as well as the night; you have set the course of the sun and the light."
,"17":"You fixed the earth's borders, you created summer and winter."
,"18":"Remember, O Lord, how the lawless scoff at your name, a party of fools cast you off."
,"19":"Do not betray your turtledove to the beast, do not forget forever the life of your poor."
,"20":"See how they keep your covenant in the dark caves of the land."
,"21":"Do not let the oppressed be put to shame; may the poor and needy praise your name."
,"22":"Arise, O God, and defend your cause, see how the thoughtless laugh at you all day long."
,"23":"Do not forget the clamor of your foes, the continuous uproar of your enemies."
}`)
	CurrentBook.AddChapter(75, `{
"2":"We give you thanks, O God, we give thanks. Those who invoke your name, will recount your wonderful deeds."
,"3":"'At a set time I will judge fairly."
,"4":"The earth wobbles with its inhabitants, but I will restore its foundations."
,"5":"To the proud I say, 'Boast no more.'And to the wicked, 'Raise not your head."
,"6":"Do not lift yourself so high, do not insult God.''"
,"7":"God comes, though not from the east or the west, nor from the mountains or desert;"
,"8":"God comes to judge, putting one down and lifting up another."
,"9":"In the hand of the Lord is a cup of spiced and foaming wine; he pours it out for the wicked to drain to the dregs."
,"10":"As for me, I will rejoice forever and sing praises to the God of Jacob."
,"11":"He will break the power of the wicked, but the power of the virtuous will be exalted."
}`)
	CurrentBook.AddChapter(76, `{
"2":"God is now famous in Judah, in Israel his name is great."
,"3":"Salem is indeed his tent; he has made Zion his dwelling place."
,"4":"There he broke the flashing arrow, the shield and sword, the spear and bow."
,"5":"You are glorious and majestic, enthroned on everlasting mountains."
,"6":"The stouthearted lie despoiled, sleeping their last sleep, not one able to lift a hand."
,"7":"At your rebuke, O God of Jacob, both rider and horse lay stunned."
,"8":"But you - how terrible you are!,Who can oppose the fury of your onslaught?"
,"9":"You thundered judgment from the heavens; while the earth trembled and lay still,"
,"10":"as you, O God, arose to judge, to save all the humble of the earth."
,"11":"Pagan nations will bring you praise, their survivors will celebrate your name."
,"12":"Make vows to the Lord, your God, and fulfill them; let the peoples,bring offerings to the Fearsome One,"
,"13":"who breaks the spirit of rulers, and is formidable to the kings of the earth."
}`)
	CurrentBook.AddChapter(77, `{
"2":"I cry aloud to God - aloud that he may hear me."
,"3":"In the day of trouble I seek the Lord, and stretch out my hand untiringly, my soul refusing to be consoled."
,"4":"When I think of God I sigh; when I meditate my spirit fails."
,"5":"You keep my eyes watchful; I am so troubled I cannot speak,"
,"6":"I remember the days of old. I consider the years of long ago"
,"7":"and the whole night my soul remains disturbed, my spirit wonders,"
,"8":"'Will the Lord keep silent forever? Will he never show his favor again?"
,"9":"Has he locked his love and ended his promise for all time?"
,"10":"Is God forgetting his mercy? Has he in anger withheld his compassion?'"
,"11":"This is what makes me distraught - that the Most High no longer acts as before."
,"12":"I remember the deeds of the Lord; I recall his marvels of old."
,"13":"I meditate on all your work, and consider your mighty deeds."
,"14":"Your way, O God, is most holy. Is there any god greater than you, our God?"
,"15":"You alone are the God who works wonders, who has made known his power to the nations."
,"16":"With power you have redeemed your people, the descendants of Jacob and Joseph."
,"17":"When the waters saw you, O God, they were afraid, the depths of the sea trembled."
,"18":"The clouds poured down rain; the skies resounded with thunder; your arrows flashed from every side."
,"19":"Your thunder crashed in the midst of the whirlwind; your lightning lit up the world; the earth shook and trembled."
,"20":"Your path led through the sea, your way through the great water, but your footprints were nowhere to be seen."
,"21":"You led your people as a flock by the hand of Moses and Aaron."
}`)
	CurrentBook.AddChapter(78, `{
"1":"Give heed, O my people, to my teaching; listen to the words of my mouth!"
,"2":"I will speak in parables, I will talk of old mysteries"
,"3":"which we have heard and known, which our ancestors have told us."
,"4":"We will not keep them hidden from our children; we will announce them to the coming generation: the glorious deeds of the Lord, his might and the wonders he has done."
,"5":"He issued decrees for Jacob and set up a law in Israel, which he commanded our ancestors to teach their children,"
,"6":"so the next generation would learn and teach their own children."
,"7":"They would then put their trust in God, and not forget his deeds and his commands."
,"8":"And not be like their ancestors, stubborn and rebellious people, a people of inconstant heart whose spirit was fickle."
,"9":"Well-armed with bow, the Ephraimites took flight when the time came to do battle."
,"10":"It is because they did not keep God's covenant and refused to live by his law."
,"11":"They forgot the marvels he had done,"
,"12":"what their ancestors had seen in the land of Egypt, in the fields of Zoan."
,"13":"He divided the sea and led them across; he made the water stand like a wall."
,"14":"By day he led them with a cloud, and by night with a fiery light."
,"15":"In the desert he split rocks to give them abundant drink."
,"16":"He made streams come out of a rock and caused water to flow like a river."
,"17":"Yet they sinned even more against him and rebelled against the Most High in the desert."
,"18":"They tested God, demanding the food they craved."
,"19":"They blasphemed against God, saying: 'Can God spread a table in the desert?"
,"20":"He made water flow out of the rock; can he also give his people bread or meat?'"
,"21":"When the Lord heard this he was enraged; a fire raged against Jacob, his anger flared against Israel,"
,"22":"for they had no faith in God nor trust in his deliverance."
,"23":"Yet he commanded the skies above and opened the doors of heaven;"
,"24":"he rained down manna upon them and fed them with the heavenly grain."
,"25":"They ate and had more than their fill of the bread of angels."
,"26":"Then from heaven he stirred the east wind, and by his power let loose the south wind,"
,"27":"to rain down meat on them like dust. Birds as thick as the sand on the seashore "
,"28":"fell inside their camp, lying all around their tents."
,"29":"They ate till they were satisfied, for he had given them what they craved."
,"30":"But even before they were finished, while the food was still in their mouths,"
,"31":"God's anger rose against them; he slew the strongest among them and laid low the flower of Israel."
,"32":"In spite of all this, they kept on sinning and did not believe,"
,"33":"so he swept away their days suddenly as a storm, and their years in terror."
,"34":"When he slew them, they repented and sought him earnestly."
,"35":"They remembered that God was their rock, the Most High, their redeemer."
,"36":"But they flattered him with their mouths, they lied to him with their tongues,"
,"37":"while their hearts were unfaithful; they were untrue to his covenant."
,"38":"Even then, in his compassion, he forgave their offenses and did not destroy them. Many a time he restrained his anger and did not fully stir up his wrath."
,"39":"He remembered that they were but flesh, a breeze that passes and never returns."
,"40":"How often did they rebel against him in the wilderness, how often did they grieve him in the desert!"
,"41":"Again and again they tested him, and provoked the Holy One of Israel."
,"42":"They did not remember his power in redeeming them from the oppressor;"
,"43":"neither his marvels shown in Egypt nor his wonders in the fields of Zoan,"
,"44":"when he turned the rivers to blood and the oppressors had nothing to drink."
,"45":"He sent swarms of flies that devoured them, frogs that devastated them."
,"46":"He gave their crops to the caterpillar and their produce to the locust."
,"47":"He destroyed their vines with hail and their sycamores with frost."
,"48":"He struck their herds with plague and their flocks with thunderbolts."
,"49":"He unleashed his fury against them, his wrath, indignation and strife - a band of destroying angels."
,"50":"Giving vent to his anger, he did not spare them from death, but gave them over to the plague."
,"51":"He struck down Egypt's firstborn, manhood's firstfruits in the tents of Ham."
,"52":"Then he led forth his people like a flock, and guided them like sheep through the desert."
,"53":"He led them safely, they did not fear, but the sea engulfed their enemies."
,"54":"He brought them to his holy land, to the mountain his right hand had won."
,"55":"He drove out peoples before them and gave them the land as their inheritance; they pitched their tents in it."
,"56":"But they challenged and rebelled against God the Most High, and disobeyed his decrees."
,"57":"They were unfaithful like their ancestors, deceitful and crooked as a twisted bow."
,"58":"They angered him with their high places; they aroused his jealousy with their idols."
,"59":"Filled with wrath, God rejected Israel."
,"60":"He abandoned his dwelling at Shiloh, the tent where he dwelt among humans."
,"61":"He lead his glory into captivity, his ark into the hand of the enemy."
,"62":"He gave his people over to the sword, so furious was he at his inheritance."
,"63":"Fire devoured their young men; their maidens were deprived of wedding songs."
,"64":"As their priests fell by the sword, no lament was heard from their widows."
,"65":"Then the Lord awoke, shouting, as from sleep induced by wine;"
,"66":"he struck his enemies on their back and put them to everlasting shame."
,"67":"He rejected the house of Joseph, and did not choose the tribe of Ephraim,"
,"68":"but the tribe of Judah and Zion, his beloved mountain."
,"69":"He built his sanctuary like heaven, like the earth he founded forever."
,"70":"He chose David his servant and took him from the sheepfolds;"
,"71":"from tending the sheep and their young, he brought him to shepherd Jacob, the people of Israel, his inheritance."
,"72":"And with upright heart David pastured them; with skillful hands he led them."
}`)
	CurrentBook.AddChapter(79, `{
"1":"O God, the pagans have invaded your inheritance; they have defiled your holy temple and reduced Jerusalem to rubble."
,"2":"They have given your servants' corpses to the birds, and the flesh of your saints to the beasts of the earth."
,"3":"They have poured out the blood of your faithful like water around Jerusalem, and there was no one to bury them."
,"4":"Mocked and reviled by those around us, we are scorned by our neighbors."
,"5":"How long will this last, O Lord? Will you be angry forever? Will your wrath always burn to avenge your rights?"
,"6":"Pour out your anger on the nations that do not acknowledge you; on the kingdoms that do not call on your name."
,"7":"For they have devoured Jacob and laid waste his homeland."
,"8":"Do not remember against us the sins of our fathers. Let your compassion hurry to us, for we have been brought very low."
,"9":"Help us, God, our savior, for the glory of your name; forgive us for the sake of your name."
,"10":"Give not the nations a chance to say, 'Where is their God?' Before our eyes let them know that you avenge the blood of your servants."
,"11":"Listen to the groans of the prisoners; by the strength of your arm, deliver those doomed to die."
,"12":"Return our neighbors sevenfold, O Lord, the taunts with which they have taunted you."
,"13":"Then we, your people, the flock of your pasture, will thank you forever. We will recount your praise from generation to generation."
}`)
	CurrentBook.AddChapter(80, `{
"2":"Listen, O shepherd of Israel, you who lead Joseph like a flock, you who sit enthroned between the cherubim."
,"3":"Shine forth before Ephraim, Benjamin and Manasseh. Stir up your might and come to save us."
,"4":"Restore us, O God of hosts; make your face shine upon us, that we may be saved."
,"5":"O Lord of hosts, how long will your anger burn against the prayers of your people?"
,"6":"You have fed them with the bread of woe, and have given them tears to drink in their sorrow."
,"7":"You have made us the scorn of our neighbors and the laughingstock of our oppressors."
,"8":"Restore us, O God of hosts; make your face shine upon us, that we may be saved."
,"9":"You had a vine you brought from Egypt. You drove nations out, to plant it in their land."
,"10":"On the ground that you cleared, it took root, and filled the land."
,"11":"Its shade covered the mountains, its shoots went through the mighty cedars,"
,"12":"its branches reached out to the sea and its shoots to the River."
,"13":"Why, then, have you broken down its walls, so that all who pass by pluck its fruits?"
,"14":"The beasts of the forest ravage it and all creatures of the field feed on it."
,"15":"Turn again, O Lord of hosts, look down from heaven and see; care for this vine,"
,"16":"and protect the stock your hand has planted."
,"17":"Let those who burned it down perish at your rebuke."
,"18":"But lay your hand on your instrument, on the son of man whom you make strong for yourself."
,"19":"Then we will never turn away from you; give us life, and we will call on your name."
,"20":"Restore us, O Lord, God of hosts; make your face shine on us, that we may be saved."
}`)
	CurrentBook.AddChapter(81, `{
"2":"Sing joyfully to God, our strength; acclaim aloud the God of Jacob."
,"3":"Start the music, strike the timbrel, play melodies on the harp and lyre."
,"4":"Sound the trumpet at the new moon, on our feast day when the moon is full."
,"5":"This is a decree for Israel, an ordinance of the God of Jacob,"
,"6":"a statute he wrote for Joseph,when he went out of Egypt. They heard a voice they did not know: 'Open wide your mouth and I will fill it,"
,"7":"I relieved your shoulder from burden; I freed your hands."
,"8":"You called in distress, and I saved you; unseen, I answered you in thunder; I tested you at the waters of Meribah."
,"9":"Hear, my people, as I admonish you. If only you would listen, O Israel!"
,"10":"There shall be no strange god among you, you shall not worship any alien god,"
,"11":"for I the Lord am your God, who led you forth from the land of Egypt."
,"12":"But my people did not listen; Israel did not obey."
,"13":"So I gave them over to their stubbornness,and they followed their own counsels."
,"14":"If only my people would listen, if only Israel would walk in my ways,"
,"15":"I would quickly subdue their adversaries,and turn my hand against their enemies."
,"16":"Those who hate the Lord would cringe before him, and their panic would last forever."
,"17":"I would feed you with the finest wheat,and satisfy you with honey from the rock.'"
}`)
	CurrentBook.AddChapter(82, `{
"1":"God presides in the divine council; he gives judgment among the gods:"
,"2":"'How long will you judge unjustly,and show partiality to the wicked?"
,"3":"Give justice to the weak and the orphan; defend the poor and the oppressed."
,"4":"Rescue the helpless and the needy; deliver them from the hand of the wicked.'"
,"5":"Without knowledge and understanding, they walk about in darkness; all the earth's foundations are shaken."
,"6":"'You are gods,' I said, 'you are all sons of the Most High.'"
,"7":"But now you will die like the others; you will all fall like any mortal."
,"8":"Rise, O God, judge the earth, you who guide all the nations."
}`)
	CurrentBook.AddChapter(83, `{
"2":"Do not be silent, O God, hold not your peace, be not unmoved!"
,"3":"See how your enemies are astir; those who hate you rear their heads."
,"4":"Craftily they plot against your people, they conspire against those you protect."
,"5":"They say, 'Let us finish them as a nation. Let the name of Israel be forgotten!'"
,"6":"With one heart they devise a scheme and form an alliance against you:"
,"7":"the people of Edom and the Ishmaelites, Moab and the progeny of Hagar,"
,"8":"Gebal and Ammon and Amalek, Philistia, with the people of Tyre."
,"9":"Those from Sur are in league with them and lend support to Lot's descendants."
,"10":"Deal with them as you did with Midian, with Sisera and Yabin at the river Kishon;"
,"11":"they perished at Endor and became dung for the ground."
,"12":"Make their nobles like Oreb and Zeeb, all their chiefs like Zebah and Zalmunna,"
,"13":"who said, 'Let us seize the pasture lands of God.'"
,"14":"O my God, make them like leaves caught in a whirlwind, like chaff helpless before the wind."
,"15":"As fire consumes the forest, as flames set the mountains ablaze,"
,"16":"drive them out with your tempest and terrify them with your storm."
,"17":"Cover their faces with shame, O Lord, that they may seek your name."
,"18":"Let them be dismayed and abashed forever; let them perish in disgrace."
,"19":"Let them know that you alone, whose name is the Lord, are the Most High over all the world."
}`)
	CurrentBook.AddChapter(84, `{
"2":"How lovely are your rooms, O Lord of hosts!"
,"3":"My soul yearns, pines, for the courts of the Lord. My heart and my flesh,cry out for the living God."
,"4":"Even the sparrow finds a home, and the swallow a nest,where she may lay her young, at your altars, O Lord of hosts, my King and my God!"
,"5":"Happy are those who live in your house, continually singing your praise!"
,"6":"Happy the pilgrims whom you strengthen, to make the ascent to you."
,"7":"As they pass through the Valley, they make it a place of springs, the early rain covers it with blessings."
,"8":"They go from strength to strength,till they appear before God in Zion."
,"9":"O Lord of hosts, hear my prayer; give ear, O God of Jacob!"
,"10":"Look upon our shield, O God; look upon the face of your anointed!"
,"11":"One day in your courts is better,than a thousand elsewhere. I would rather be left at the threshold,in the house of my God,than to dwell in the tents of the wicked."
,"12":"For the Lord God is a sun and a shield; he bestows favor and glory. The Lord withholds no good thing,from those who walk in uprightness."
,"13":"O Lord of hosts, blessed are those who trust in you."
}`)
	CurrentBook.AddChapter(85, `{
"2":"You have favored your land, O Lord; you have brought back the exiles of Jacob."
,"3":"You have forgiven the sin of your people; you have pardoned their offenses."
,"4":"You have withdrawn your wrath,and turned from your burning rage."
,"5":"But restore us, God our savior; put away altogether your indignation."
,"6":"Will your anger be ever with us, carried over to all generations?"
,"7":"Will you not give us life anew, that your people may rejoice in you?"
,"8":"Show us, O Lord, your unfailing love,and grant us your saving help."
,"9":"Would that I hear God's proclamation, that he promise peace to his people, his saints - lest they come back to their folly."
,"10":"Yet his salvation is near to those who fear him, and his Glory will dwell in our land."
,"11":"Love and faithfulness have met; righteousness and peace have embraced."
,"12":"Faithfulness will reach up from the earth,while justice bends down from heaven."
,"13":"The Lord will give what is good, and our land will yield its fruit."
,"14":"Justice will go before him, and peace will follow along his path."
}`)
	CurrentBook.AddChapter(86, `{
"1":"Listen, O Lord, and answer me, for I am afflicted and needy."
,"2":"Preserve my life for I am God-fearing; save your servant who trusts in you."
,"3":"Have mercy on me, O Lord, for I cry to you all day."
,"4":"Bring joy to the soul of your servant, for you, O Lord, I lift up my soul."
,"5":"You are good and forgiving, O Lord, caring for those who call on you."
,"6":"Listen, O Lord, to my prayer, hear the voice of my pleading."
,"7":"I call on you in the time of my trouble for you will answer me."
,"8":"None is like you among the gods, your works are beyond compare."
,"9":"All the nations you have made will come; they will worship before you, O Lord, and bring glory to your name."
,"10":"For you are great, and wonderful are your deeds; you alone are God."
,"11":"Teach me, O Lord, how to walk in your truth, that my heart may fear your name."
,"12":"I give thanks to you, O Lord my God; I will glorify your name forever,"
,"13":"for great has been your love for me, you have saved me from the grave."
,"14":"O God, the insolent are against me; a band of cut-throats, evildoers who do not hold you in reverence."
,"15":"But you, O Lord God, are merciful, slow to anger, loving and faithful."
,"16":"Turn to me, take pity on me; give your strength to your servant, and save the child of your handmaid."
,"17":"Give me a sign of your grace, that my foes may see to their disgrace, that you, O Lord, are my help and comfort."
}`)
	CurrentBook.AddChapter(87, `{
"1":"He himself has built it in his holy mountain;"
,"2":"the Lord prefers the gates of Zion,to all of Jacob's towns."
,"3":"Great things have been foretold,of you, O city of God:"
,"4":"Between friends we speak of Egypt and Babylon; and also Philistia, Tyre, Ethiopia: 'Here so-and-so was born.'"
,"5":"But of Zion it shall be said, 'More and more are being born in her.',For the Most High himself has founded her."
,"6":"And the Lord notes in the people's register: 'All these were also born in Zion.'"
,"7":"And all will dance and sing,joyfully for you."
}`)
	CurrentBook.AddChapter(88, `{
"2":"O Lord, my God, I call for help by day; before you I cry out by night."
,"3":"May my prayer come to you; incline your ear to my cry for help."
,"4":"My soul is deeply troubled; my life draws near to the grave."
,"5":"I am like those without strength. Counted among those going down into the pit - "
,"6":"I lie forsaken among the dead, like those lying in the grave, like those you remember no more, cut off from your care."
,"7":"You have plunged me into the darkest depths of the pit."
,"8":"With your wrath heavy upon me, you have battered me with all your waves."
,"9":"You have taken away my closest friends; you have made me repulsive to them. I cannot escape from my confinement."
,"10":"My eyes have grown dim with grief; spreading out my hands to you, I call upon you every day, O Lord."
,"11":"Are your wonders meant for the dead? Will ghosts rise to give you thanks?"
,"12":"Is your love and faithfulness remembered among those gone to the netherworld?"
,"13":"Are your wonders known in the dark, your salvation in the land of oblivion?"
,"14":"But to you, O Lord, I cry for help; every morning I pray to you."
,"15":"O Lord, why do you reject me, why do you hide your face?"
,"16":"Afflicted and close to death from youth, I have suffered terrors and helplessness."
,"17":"Your wrath has swept over me; your assaults have destroyed me."
,"18":"Now they surround me like a flood; and completely engulf me."
,"19":"Bereft of loved ones and now alone, only darkness is my companion."
}`)
	CurrentBook.AddChapter(89, `{
"2":"I will sing forever, O Lord, of your love and proclaim your faithfulness from age to age."
,"3":"I will declare how steadfast is your love, how firm your faithfulness."
,"4":"You said, 'I have made a covenant with David, my chosen one; I have made a pledge to my servant."
,"5":"I establish his descendants forever; I build his throne for all generations.'"
,"6":"The heavens proclaim your wonders, O Lord; the assembly of the holy ones recalls your faithfulness."
,"7":"Who in the skies can compare with the Lord; who of the heaven-born is like him?"
,"8":"A God feared in the council of the holy ones, awesome to those who approach him."
,"9":"O Lord God of hosts, who is like you, clothed in might and faithfulness?"
,"10":"You reign over the surging sea; you calm its raging waves."
,"11":"You split Rahab like a carcass; with your strong arm you routed your foes."
,"12":"Yours are the heavens and the earth; you founded the world and everything in it."
,"13":"You created the north and the south - Tabor and Hermon rejoice at your name."
,"14":"You have a powerful arm, mighty and exalted is your right hand!"
,"15":"Justice and righteousness are the foundation of your throne; love and faithfulness go before you."
,"16":"Blessed is the people who know your praise. They walk in the light of your face."
,"17":"They celebrate all day your name and your protection lifts them up."
,"18":"You give us glory and power; and your favor gives us victory."
,"19":"Our king is in the hands of the Lord; the God of Israel is our shield."
,"20":"In the past you spoke in a vision; you said of your faithful servant: 'I have set the crown upon a mighty one; on one chosen from the people."
,"21":"I have found David my servant, and with my holy oil I have anointed him."
,"22":"My hand will be ever with him and my arm will sustain him,"
,"23":"no enemy shall outwit him nor the wicked oppress him."
,"24":"I will crush his foes before him and strike down his adversaries."
,"25":"My faithfulness and love will be with him, and by my help he will be strong."
,"26":"I will set his hand over the sea, his right hand over the rivers."
,"27":"He will call on me, 'You are my Father, my God, my Rock, my Savior.'"
,"28":"I will make him the firstborn, the highest of the kings of the earth."
,"29":"I will keep my covenant firm forever, and my love for him will endure."
,"30":"His dynasty will last forever, and his throne as long as the heavens."
,"31":"If his sons forsake my law and fail to follow my decrees,"
,"32":"if they violate my statutes and do not keep my commandments,"
,"33":"I will punish their crime with the rod and their offenses with the scourge;"
,"34":"yet I will not withdraw my love from him, nor will I withdraw my faithfulness."
,"35":"I will be true to my promises and not break my covenant."
,"36":"Did I not swear by my holiness? I will not lie to David."
,"37":"His dynasty will last forever, and his throne endure as the sun before me."
,"38":"It will shine forever like the moon, the unfailing watch of heavens.'"
,"39":"But now you have rejected, disowned and raged at your anointed."
,"40":"You have disregarded your covenant and cast off the crown of your servant."
,"41":"You have destroyed his walls and reduced his strongholds to rubble."
,"42":"The victim of despoilers, he has become the scorn of his neighbors."
,"43":"You have exalted the right hand of his foes; you have made his enemies rejoice."
,"44":"You have turned the edge of his sword, and have not stood by him in battle."
,"45":"You have wrenched the scepter from his hand and flung his throne to the ground."
,"46":"You have shortened the time of his splendor and covered him with shame."
,"47":"How long, O Lord, will you hide? How long will anger burn like a fire?"
,"48":"Consider how short my life is, how shadowy the human destiny."
,"49":"What mortal can live and never see death? Who will escape from the netherworld?"
,"50":"O Lord, where is your former great love, the faithfulness you pledged to David?"
,"51":"Remember, O Lord, how your servant is despised, how I suffer the scorn of the peoples,"
,"52":"the taunts with which your enemies have mocked every step of your anointed."
,"53":"Blessed be the Lord forever! Amen, Amen."
}`)
	CurrentBook.AddChapter(90, `{
"1":"Lord, you have been our refuge through all generations."
,"2":"Before the mountains were formed, before you made the earth and the world, from eternity to eternity - you are God."
,"3":"You turn humans back to dust, saying, 'Return, O mortals!'"
,"4":"A thousand years in your sight are like a day that has passed, or like a watch in the night."
,"5":"You sow them in their time, at dawn they peep out."
,"6":"In the morning they blossom, but the flower fades and withers in the evening."
,"7":"Your fury consumes us like fire, and we are helpless before your anger."
,"8":"Our evils lie before you who scrutinize our hidden sins."
,"9":"Our days pass away in your wrath; our years are gone in no time."
,"10":"Seventy years to our life or eighty if we are strong, yet most of them are sorrow and trouble; speeding by, they sweep us along."
,"11":"Who knows the extent of your anger? Who has seen the end of your wrath?"
,"12":"So make us know the shortness of our life, that we may gain wisdom of heart."
,"13":"How long will you be angry, O Lord? Have mercy on your servant."
,"14":"Fill us at daybreak with your goodness, that we may be glad all our days."
,"15":"Make joy endure as the misery did, and the years in which we were afflicted."
,"16":"Let your work be seen by your servants and your glorious power by their children."
,"17":"May the sweetness of the Lord be upon us; may he prosper the work of our hands."
}`)
	CurrentBook.AddChapter(91, `{
"1":"You who dwell in the shelter of the Most High, who rest in the shadow of the Almighty,"
,"2":"say to the Lord, 'My stronghold, my refuge, my God in whom I trust!'"
,"3":"He will rescue you from the fowler's snare,and from the deadly pestilence."
,"4":"He will cover you with his pinions,and give you refuge under his wings."
,"5":"You shall not fear the terror of the night,nor the arrows that fly by day,"
,"6":"nor the pestilence that stalks by night, and the plague that destroys at noonday."
,"7":"A thousand may fall at your side, ten thousand at your right hand, but nothing shall befall you, his faithfulness is your shield."
,"8":"Open your eyes: you will see how the wicked are repaid."
,"9":"If you have made the Lord your refuge, the Most High your stronghold,"
,"10":"no harm will come upon you, no disaster will draw near your home."
,"11":"For he will command his angels,to guard you in all your ways."
,"12":"They will lift you up with their hands,so that your foot will not hit a stone."
,"13":"You will tread on wildcats and snakes,and trample the lion and the dragon."
,"14":"'Because they cling to me, I will rescue them,',says the Lord. 'I will protect those who know my name."
,"15":"When they call to me, I will answer; in time of trouble I will be with them; I will deliver and honor them."
,"16":"I will satisfy them with long life,and show them my salvation.'"
}`)
	CurrentBook.AddChapter(92, `{
"2":"It is good to give thanks to the Lord, to sing praise to your name, O Most High,"
,"3":"to proclaim your grace in the morning, to declare your faithfulness at night,"
,"4":"accompanied by music from the lyre,and the melody of lute and harp."
,"5":"For you make me glad with your deeds, O Lord, and I sing for joy at the work of your hands."
,"6":"How great are your works, O Lord, how deep your thoughts!"
,"7":"The senseless will not know, nor will the stupid understand them."
,"8":"For though the wicked prosper,and evildoers flourish like grass, they are doomed to vanish for good."
,"9":"But you, O Lord, are exalted forever."
,"10":"Time will come when your enemies will perish, evildoers will be scattered."
,"11":"You have made me stronger than the wild ox; you have poured fresh oil on me."
,"12":"I look down on my enemies; I take for granted their doom."
,"13":"The virtuous will flourish like palm trees, they will thrive like the cedars of Lebanon."
,"14":"Planted in the house of the Lord, they will prosper in the courts of our God."
,"15":"In old age they will still bear fruit,they will stay fresh and green,"
,"16":"to proclaim that the Lord is upright, 'He is my Rock,' they say, 'he never fails.'"
}`)
	CurrentBook.AddChapter(93, `{
"1":"The Lord reigns, robed in majesty; the Lord is girded with strength. The world now is firm, it cannot be moved."
,"2":"Your throne stands from long ago, O Lord, from all eternity you are."
,"3":"The floods have lifted up, O Lord, the floods have lifted up their roaring, the floods have lifted up their pounding waves."
,"4":"Mightier than the thunder of great waters, mightier than the breakers of the sea, the Lord on high is mighty!"
,"5":"Your decrees can be trusted; holiness dwells in your house,day after day without end, O Lord."
}`)
	CurrentBook.AddChapter(94, `{
"1":"O Lord God, vengeance is yours; O God who avenges, show yourself!"
,"2":"Judge of the world, repay the proud with what they deserve."
,"3":"How long shall the wicked, O Lord, how long shall the wicked exult?"
,"4":"Pouring out words of arrogance, evildoers make a show of their insolence."
,"5":"They crush your people, O Lord, they oppress your inheritance."
,"6":"They murder the widow and the lonely, they massacre the helpless;"
,"7":"'The Lord does not see,' they say, 'the God of Jacob does not care.'"
,"8":"Remember this, you stupid people, when will you understand, you fools!"
,"9":"He who made the ear, will he not hear? He who formed the eye, will he not see?"
,"10":"He who rebukes nations, will he not punish them?"
,"11":"The Lord knows the thoughts of humans, that they are a puff of wind."
,"12":"Fortunate the one you correct, O Lord, the one you teach your law;"
,"13":"you give them relief from distress while a pit is dug for the wicked."
,"14":"The Lord will not reject his people nor will he forsake his heritage."
,"15":"Justice will return to the just, and the upright will follow in its wake."
,"16":"Who stands up for me against the wicked? Who stands by me against evildoers?"
,"17":"Had the Lord not helped me, I would have fallen into the silence of death."
,"18":"No sooner did I say, 'My foot is slipping,' your kindness, O Lord, held me up."
,"19":"The more worries and trouble assailed me, the more you consoled me."
,"20":"You shun wicked rulers who impose injustice by law."
,"21":"They plot together against the virtuous and condemn the innocent."
,"22":"But the Lord is my stronghold, my God, my rock of refuge."
,"23":"He will repay them for their evil and destroy them for their wickedness; the Lord, our God, will blot them out."
}`)
	CurrentBook.AddChapter(95, `{
"1":"Come, let us sing to the Lord, let us make a joyful sound,to the Rock of our salvation."
,"2":"Let us come before him giving thanks, with music and songs of praise."
,"3":"For the Lord is the great God, the great King above all gods."
,"4":"In his hand are the depths of the earth,and the mountain heights."
,"5":"The sea is his, for he made it, and his hand shaped the dry land."
,"6":"Come and worship; let us bow down, kneel before the Lord, our Maker."
,"7":"He is our God, and we his people; the flock he leads and pastures. Would that today you heard his voice!"
,"8":"Do not be stubborn, as at Meribah, in the desert, on that day at Massah,"
,"9":"when your ancestors challenged me, and they put me to the test."
,"10":"For forty years they wearied me and I said, 'They are a people of inconstant heart; they have not known my ways.'"
,"11":"So I declared on oath in my anger, 'Never shall they enter my rest.'"
}`)
	CurrentBook.AddChapter(96, `{
"1":"Sing to the Lord a new song, sing to the Lord, all the earth!"
,"2":"Sing to the Lord, bless his name; proclaim his salvation day after day."
,"3":"Recall his glory among the nations, tell all the peoples his wonderful deeds."
,"4":"How great is the Lord and worthy of praise!,Above all gods he is to be feared."
,"5":"For all other gods are worthless idols, but Yahweh is the one who made the heavens."
,"6":"Splendor and majesty go before him; power and glory fill his sanctuary."
,"7":"Give to the Lord, you families of nations, give to the Lord glory and strength."
,"8":"Give to the Lord the glory due his name; bring gifts and enter his courts."
,"9":"Worship the Lord with holy celebrations; stand in awe of him, all the earth."
,"10":"Say among the nations, 'The Lord reigns!',He will judge the peoples with justice."
,"11":"Let the heavens be glad, the earth rejoice; let the sea and all that fills it resound;"
,"12":"let the fields exult and everything in them; let the forest, all the trees, sing for joy."
,"13":"Let them sing before the Lord,who comes to judge the earth. He will rule the world with justice,and the peoples with fairness."
}`)
	CurrentBook.AddChapter(97, `{
"1":"The Lord reigns; let the earth rejoice; let the distant islands be glad."
,"2":"Clouds and darkness surround him; justice and right are his throne."
,"3":"Fire goes before him, burning his foes on every side."
,"4":"His lightning lights up the world; the earth watches and trembles."
,"5":"The mountains melt like wax,before the Lord, the Lord of all the earth."
,"6":"The heavens proclaim his justice, all peoples see his glory."
,"7":"Shame on worshipers of idols, on those proud of their worthless images. Let all spirits bow before him."
,"8":"Zion hears and rejoices, and the cities of Judah exult, because of your judgments, O God."
,"9":"For you are the Master of the universe, exalted far above all gods."
,"10":"You who love the Lord, hate evil, for he preserves the lives of his faithful, he delivers them from their foes."
,"11":"He sheds light upon the upright, and gladness upon the just."
,"12":"Rejoice in the Lord, you who are blameless, and give praise to his holy name."
}`)
	CurrentBook.AddChapter(98, `{
"1":"Sing to the Lord a new song, for he has done wonders; his right hand, his holy arm, has won victory for him."
,"2":"The Lord has shown his salvation, revealing his justice to the nations."
,"3":"He has not forgotten his love nor his faithfulness to Israel. To the farthest ends of the earth all have seen God's saving power."
,"4":"All you lands, make a joyful noise to the Lord, break into song and sing praise,"
,"5":"with melody of the lyre and with music of the harp."
,"6":"With trumpet blast and sound of the horn, rejoice before the King, the Lord!"
,"7":"Let the sea resound and everything in it, the world and all its peoples."
,"8":"Let rivers clap their hands, hills and mountains sing with joy"
,"9":"before the Lord, for he comes to rule the earth. He will judge the world with justice and the peoples with fairness."
}`)
	CurrentBook.AddChapter(99, `{
"1":"The Lord reigns and the nations tremble. He is enthroned upon the cherubim; the earth gets distraught."
,"2":"Great is the Lord in Zion; he is high over all the nations."
,"3":"May they give glory to your name, great and terrible: 'Holy is he:"
,"4":"this is the mighty King who loves justice.',For you come to install fairness, to establish in Jacob right and justice."
,"5":"Extol the Lord, our God; worship at his footstool. Holy is he! And mighty!"
,"6":"Among his priests were Moses and Aaron, and Samuel among those who called on his name. They called to the Lord, and he answered them."
,"7":"In the pillar of cloud he spoke to them, and they kept his statutes and the decrees he gave them."
,"8":"O Lord our God, you responded to them; you were a patient God for them, but you punished their wrongs."
,"9":"Extol the Lord our God; worship at his holy mountain. Holy is the Lord our God!"
}`)
	CurrentBook.AddChapter(100, `{
"1":"All you lands, acclaim the Lord!"
,"2":"Serve the Lord with gladness; come before him with joyful songs."
,"3":"Know that the Lord is God; he created us and we are his people, the sheep of his fold."
,"4":"Enter his gates with thanksgiving, his courts with praise. Give thanks to him and bless his name."
,"5":"For the Lord is good; his love lasts forever and his faithfulness through all generations."
}`)
	CurrentBook.AddChapter(101, `{
"1":"I will sing of your love and justice; to you, O Lord, I will sing praise."
,"2":"I will walk the way of integrity - O Lord, when will you come to me? With a blameless heart I will walk within my house."
,"3":"I will not set before my eyes anything that is base. I hate the deeds of faithless people; I will have no part in them."
,"4":"I will banish all wicked hearts, and evil I will not know."
,"5":"He who deals with others treacherously, I will silence. He who talks and acts arrogantly, I will not endure."
,"6":"I will choose from the faithful of the land those who may dwell with me; only the upright shall be my servant."
,"7":"No double-dealer shall live in my house; no one who utters falsehood shall stand before my eyes."
,"8":"Each morning I will clear the land and silence all the wicked; I will uproot all the evildoers from the city of the Lord."
}`)
	CurrentBook.AddChapter(102, `{
"2":"O Lord, hear my prayer; let my cry for help come to you."
,"3":"Do not hide your face from me when I am in trouble. Turn your ear to me; make haste to answer me when I call."
,"4":"For my days are passing away like smoke, my bones burning like a furnace."
,"5":"Like withered grass, my heart is blighted, and I forget to eat my bread."
,"6":"Because of my great grief I am reduced to skin and bones."
,"7":"I am like an owl in the wilderness, like a vulture among the ruins."
,"8":"I awake moaning like a lonely bird on the housetop."
,"9":"All day long I am taunted by my enemies; they use my name as a curse."
,"10":"The bread I eat is ashes, my drink is mingled with tears,"
,"11":"for your wrath, your fury; for you have thrown me aside."
,"12":"My days are vanishing like the shadows at night; I wither away like grass."
,"13":"But you, O Lord, you sit forever; your name endures through all generations."
,"14":"Arise, have mercy on Zion; this is the time to show her your mercy."
,"15":"For your servants cherish her stones, and are moved to pity by her dust."
,"16":"O Lord, the nations will revere your name, and the kings of the earth your glory,"
,"17":"when the Lord will rebuild Zion and appear in all his splendor."
,"18":"For he will answer the prayer of the needy and will not despise their plea."
,"19":"Let this be written for future ages, 'the Lord will be praised by a people he will form.'"
,"20":"From his holy height in heaven, the Lord has looked on the earth"
,"21":"to hear the groaning of the prisoners, and free those condemned to death."
,"22":"Then the name of the Lord will be declared in Zion, and his praise in Jerusalem,"
,"23":"when the peoples and the kingdoms assemble to worship him."
,"24":"My walk has exhausted me, he has cut short my days."
,"25":"I cry to him, 'My God, do not take my life in mid-course, you whose days are from age to age.'"
,"26":"In the beginning you laid the earth's foundation, the heavens are the work of your hands."
,"27":"Although they perish, you will remain; they will all wear out like a garment, you change them like clothes: they pass away,"
,"28":"but you remain the same, your years unending."
,"29":"Your servants' children will dwell secure; their posterity will endure without fail."
}`)
	CurrentBook.AddChapter(103, `{
"1":"Bless the Lord, my soul; all my being, bless his holy name!"
,"2":"Bless the Lord, my soul, and do not forget all his kindness;"
,"3":"he forgives all your sins and heals all your sickness;"
,"4":"he redeems your life from destruction and crowns you with love and compassion;"
,"5":"he gives fulfillment to your years, and renews your youth like the eagle's."
,"6":"The Lord restores justice and secures the rights of the oppressed."
,"7":"He has made known his ways to Moses and his deeds to the people of Israel."
,"8":"The Lord is gracious and merciful, abounding in love and slow to anger;"
,"9":"he will not always scold nor will he be angry forever."
,"10":"He does not treat us according to our sins, nor does he punish us as we deserve."
,"11":"As the heavens are high above the earth, so great is his love for those fearing him;"
,"12":"as far as the east is from the west, so far does he remove from us our sins."
,"13":"As a father has compassion on his children, so the Lord pities those who fear him."
,"14":"For he knows how we are formed, he remembers that we are dust."
,"15":"The days of mortals are like grass; they bloom like a flower of the field;"
,"16":"but the wind passes over it, and it is gone, his field will not see him again."
,"17":"But the Lord's kindness is forever with those who fear him; so is his justice, for their children's children,"
,"18":"for those who keep his covenant and remember his commands, for those who put them into practice."
,"19":"The Lord has set his throne in heaven; he rules, he has power everywhere."
,"20":"Praise the Lord, all you his angels, you mighty ones who do his bidding, you who obey his word."
,"21":"Praise the Lord, all his hosts, all his servants who do his will."
,"22":"Praise the Lord, all his works, everywhere he rules."
}`)
	CurrentBook.AddChapter(104, `{
"1":"Bless the Lord, my soul!,Clothed in majesty and splendor; O Lord, my God, how great you are!"
,"2":"You are wrapped in light as with a garment; you stretch out the heavens like a tent,"
,"3":"you build your upperrooms above the waters. You make the clouds your chariot,and ride on the wings of the wind;"
,"4":"you make the winds your messengers, and fire and flame your ministers."
,"5":"You set the earth on its foundations, and never will it be shaken."
,"6":"You covered it with the ocean like a garment, and waters spread over the mountains."
,"7":"But at your rebuke the waters flee, at the sound of your thunder they take to flight."
,"8":"Brought to the mountains, they flow down again,to settle in the valleys."
,"9":"You set a limit they could not cross, never again to flood the earth."
,"10":"You make springs gush forth in valleys,winding among mountains and hills,"
,"11":"giving drink to the beasts of the field, quenching the thirst of wild donkeys."
,"12":"Birds build their nests close by,and sing among the branches of trees."
,"13":"You water the mountains from your abode,and fill the earth with the fruit of your work."
,"14":"You make grass grow for cattle,and plants for man to cultivate, that he may bring forth food from the earth:"
,"15":"wine to gladden his heart, oil to make his face shine, and bread to make him strong."
,"16":"The Lord waters his trees to their fill, the cedars of Lebanon which he planted."
,"17":"The birds build their nests, the stork has its home in the pine trees."
,"18":"High mountains are for wild goats, the cliffs a refuge for badgers."
,"19":"You made the moon to mark the seasons, and the sun that knows when to set;"
,"20":"when you bring the darkness of the night, all the beasts of the forest begin to prowl:"
,"21":"the young lions roaring for their prey,claiming their food from God."
,"22":"When the sun rises, the beasts steal away, returning to rest in their dens."
,"23":"Man then goes out to his work, and toils till evening comes."
,"24":"How varied O Lord, are your works!,In wisdom you have made them all -,the earth full of your creatures."
,"25":"Behold the sea, wide and vast, teeming with countless creatures, living things both great and small,"
,"26":"a strange world reserved for the ships, for Leviathan, the dragon you made to play with."
,"27":"They all look to you,for their food in due time."
,"28":"You give it to them, and they gather it up; you open your hand, they are filled with good things."
,"29":"When you hide your face they vanish, you take away their breath, they expire,and return to dust."
,"30":"When you send forth your spirit, they are created, and the face of the earth is renewed."
,"31":"May the glory of the Lord endure forever; may the Lord rejoice in his works!"
,"32":"He looks on the earth, and it quakes; he touches the mountain, and it smokes."
,"33":"I will sing to the Lord all my life; I will sing praise to God while I live."
,"34":"May my song give him pleasure, as the Lord gives me delight."
,"35":"May sinners vanish from the earth, and may the wicked be no more. Bless the Lord, my soul!"
}`)
	CurrentBook.AddChapter(105, `{
"1":"Give thanks to the Lord, call on his name; make known his works among the nations."
,"2":"Sing to him, sing his praise, proclaim all his wondrous deeds."
,"3":"Glory in his holy name; let those who seek the Lord rejoice."
,"4":"Look to the Lord and be strong; seek his face always."
,"5":"Remember his wonderful works, his miracles and his judgments,"
,"6":"you descendants of his servant Abraham, you sons of Jacob, his chosen ones!"
,"7":"He is the Lord our God; his judgments reach the whole world."
,"8":"He remembers his covenant forever, his promise to a thousand generations,"
,"9":"the covenant he made with Abraham, the promise he swore to Isaac."
,"10":"He confirmed his decree to Jacob, to Israel his eternal covenant:"
,"11":"'To you I will give the land of Canaan as part of your inheritance.'"
,"12":"When they were few in number, strangers in the land,"
,"13":"wandering from nation to nation, from one kingdom to another,"
,"14":"he allowed no one to oppress them, and for their sake he rebuked kings:"
,"15":"'Touch not my anointed ones,' he warned, 'do my prophets no harm!'"
,"16":"Then he sent a famine and ruined the crop that sustained the land;"
,"17":"he sent a man ahead of them, Joseph, who was sold as a slave;"
,"18":"his feet in shackles, his neck in irons"
,"19":"till what he foretold came to pass, and the Lord's word proved him true."
,"20":"The king sent for him, set him free, the ruler of the peoples released him."
,"21":"He put him in charge of his household and made him ruler of all his possessions,"
,"22":"that he might train his princes and teach his elders wisdom."
,"23":"Then Israel came to Egypt, Jacob settled in the land of Ham."
,"24":"The Lord made his people fruitful and much stronger than their foes,"
,"25":"whose hearts he turned to hate his people, to deal deceitfully with his servants."
,"26":"Then he sent Moses his servant and Aaron whom he had chosen."
,"27":"They performed his signs among them, his miracles in the land of Ham."
,"28":"He sent darkness to the land, but they rebelled against his words."
,"29":"He turned their waters into blood, causing their fish to die."
,"30":"Their land teemed with frogs, invading even the king's bedroom."
,"31":"He spoke, and flies and gnats swarmed throughout the country."
,"32":"He gave them hail for rain, and lightning flashed over the land."
,"33":"He blighted their vines and fig trees, shattered the trees in the countryside."
,"34":"He spoke and locusts came, grasshoppers without number;"
,"35":"they devoured all the vegetation and the produce of the soil;"
,"36":"then he smote all the firstborn, the firstfruits of their manhood."
,"37":"He led Israel out of the alien land, laden with silver and gold, and none were left behind."
,"38":"Egypt was glad when they departed, so filled were they with dread."
,"39":"He spread a cloud as covering, and fire to give them light at night."
,"40":"They asked for food; he gave them quails and fed them with bread from heaven."
,"41":"He opened the rock, and water gushed out, flowing like a river through the desert."
,"42":"For he remembered his promise to Abraham, his servant."
,"43":"So he led forth his people with joy, his chosen ones with singing."
,"44":"He gave them the lands of the nations, and let them take the fruit of others' toil,"
,"45":"that they might keep his statutes and remain obedient to his laws."
}`)
	CurrentBook.AddChapter(106, `{
"1":"Alleluia! Give thanks to the Lord, for he is good, for his love endures forever."
,"2":"Who can count the Lord's mighty deeds, or declare all his praises?"
,"3":"Blessed are they who always do just and right."
,"4":"Remember me, O Lord, when you show favor to your people; rescue me when you deliver them;"
,"5":"let me see the triumph of your faithful, let me share the joy of your nation, and join your people in praising you."
,"6":"We have sinned like our ancestors; we have done wrong and acted wickedly."
,"7":"When they were in Egypt, our ancestors had no regard for your wondrous deeds; they forgot the abundance of your love; they rebelled against the Most High by the Sea of Reeds."
,"8":"Yet he saved them for his name's sake, to make his mighty power known."
,"9":"He rebuked the sea, and it dried up; he led them through the deep as on dry land."
,"10":"He saved them from hostility, freeing them from the hand of the enemy."
,"11":"Waters covered their pursuers, and none of them was left alive."
,"12":"Then they believed his promises and all at once sang his praises."
,"13":"But soon they forgot his works and did not wait for his counsel."
,"14":"They gave way to wanton craving and tempted God in the desert."
,"15":"He gave them what they wanted, then sent them a wasting disease."
,"16":"In the camp they grew envious of Moses and Aaron, the holy one of the Lord."
,"17":"So the earth opened, swallowed Dathan, and buried the company of Abiram;"
,"18":"fire broke out against them, burning up the wicked."
,"19":"They made a calf at Horeb and worshiped the molten image."
,"20":"They exchanged the glory of God for the image of a bull that eats grass."
,"21":"They forgot their Savior God, who had done great things in Egypt,"
,"22":"wonderful works in the land of Ham, and awesome deeds by the Sea of Reeds."
,"23":"So he spoke of destroying them, but Moses, his chosen one, stood in the breach before him to shield them from destruction."
,"24":"Yet they despised the promised land, for they had no faith in his word."
,"25":"They grumbled in their tents and would not listen to the voice of the Lord."
,"26":"So he swore to them with his hand raised that he would let them perish in the desert,"
,"27":"scatter their descendants among the nations and disperse them over the lands."
,"28":"They joined the rites of Baal-peor and ate sacrifices to lifeless gods."
,"29":"Their deeds provoked the Lord to anger, and a plague broke out among them."
,"30":"But Phinehas stood up and intervened, and the plague came to an end."
,"31":"This was credited to his uprightness, making him remembered for all ages."
,"32":"Angered by them at Meribah's waters, the Lord took it out on Moses"
,"33":"for the rash words he uttered, when they rebelled against God."
,"34":"They dared not destroy the pagans, as the Lord commanded;"
,"35":"they mingled with these nations and learned to do as they did."
,"36":"In serving the idols of the pagans, they were trapped"
,"37":"into sacrificing children to demons,"
,"38":"shedding the innocent blood of their sons and daughters to the idols of Canaan, polluting the country with blood."
,"39":"They defiled themselves by what they did, playing the harlot in their worship."
,"40":"The anger of the Lord grew intense and he abhorred his inheritance."
,"41":"He handed them over to the nations, and their foes ruled them with arrogance."
,"42":"Brought by the enemy into subjection, they suffered the agony of oppression."
,"43":"He delivered them many a time, but they went on defying him and sinking deeper into their sin."
,"44":"But he heard their cry of affliction and looked on them with compassion."
,"45":"Remembering his covenant, he relented for their sake, because of his great love."
,"46":"He let them be pitied by all those who held them captive."
,"47":"Save us, O Lord, our God, gather us from among the nations, that we may give thanks to you and praise your holy name."
,"48":"Blessed be the Lord, God of Israel, from eternity to eternity. Let all the people say, 'Amen!' Praise the Lord!"
}`)
	CurrentBook.AddChapter(107, `{
"1":"Give thanks to the Lord, for he is good, for his love endures forever."
,"2":"Let the redeemed of the Lord say this, those he redeemed from the hand of the foe,"
,"3":"those he gathered from the lands, from east and west, from north and south."
,"4":"Some strayed in the wilderness and were lost, far away from the city."
,"5":"They wandered about hungry and thirsty, their lives ebbing away."
,"6":"Then they cried to the Lord in anguish, and he rescued them from their distress."
,"7":"He led them by a straight way to a city where they could dwell."
,"8":"Let them thank the Lord for his love and wondrous deeds for humans."
,"9":"He quenches the thirst of the soul and satisfies the hunger of the heart."
,"10":"They lived in the darkness of death like prisoners suffering in chains,"
,"11":"for they rebelled against the word of God and despised the counsel of the Most High."
,"12":"Their backs bent in hard labor, they fell down, and there was no one to help."
,"13":"Then they cried to the Lord in anguish, and he rescued them from their distress."
,"14":"He brought them out of the dark and gloom, and he tore asunder their bonds."
,"15":"Let them thank the Lord for his love and wondrous deeds for humans."
,"16":"For he breaks open gates of bronze and batters down bars of iron."
,"17":"They were sick because of their wrongs, they were afflicted for their iniquities."
,"18":"Unable to take any food they drew near the gates of death."
,"19":"Then they cried to the Lord in anguish, and he rescued them from their distress."
,"20":"He sent forth his word and healed them, and rescued them from destruction."
,"21":"Let them thank the Lord for his love and wondrous deeds for humans."
,"22":"Let them offer sacrifices of thanksgiving, and declare his deeds in joyful song."
,"23":"Those who went to the sea in ships, merchants on the mighty waters,"
,"24":"saw the marvels of the Lord, his wonderful deeds in the deep."
,"25":"For he spoke and stirred up a storm whipping up the waves of the sea."
,"26":"Flung upward and plunged to the depths, they lost courage in the ordeal;"
,"27":"reeling like drunkards, they were adrift, in spite of all their seamanship."
,"28":"Then they cried to the Lord in anguish, and he rescued them from their distress."
,"29":"He stilled the storm to a gentle breeze and hushed the billows to silent waves."
,"30":"How glad they were! He brought them safe and sound to the port where they were bound."
,"31":"Let them thank the Lord for his love and wondrous deeds for humans."
,"32":"Let them extol him in the congregation, praise him in the assembly of the people."
,"33":"He turned rivers into wastelands, flowing springs into parched grounds,"
,"34":"and fruitful valleys into salt-flats, because of the wickedness of their inhabitants."
,"35":"Yet he also turned deserts into watersheds and parched land into flowing springs."
,"36":"There he let the hungry settle and found a city where they could dwell."
,"37":"They planted vineyards, they sowed fields, and from them got fruitful harvests."
,"38":"By his blessing their numbers increased, and their herds and flocks did not diminish."
,"39":"But then they dwindled and were humbled through oppression, sorrow and distress."
,"40":"And he who pours contempt upon princes and makes them wander in trackless wastes"
,"41":"rescued the needy from their affliction and made their families flourish like flocks."
,"42":"The upright see it and are glad, but the wicked are silenced."
,"43":"Let the wise consider all this and understand the Lord's infinite love."
}`)
	CurrentBook.AddChapter(108, `{
"2":"My heart is ready, O God! I will sing praise and make music. Awake my soul!"
,"3":"Awake, harp and lyre! I will awake the dawn."
,"4":"I will thank you, O Lord, among the nations. I will sing praise to you among the peoples."
,"5":"For great is your love above the heavens, your faithfulness beyond the skies."
,"6":"Be exalted, O God, above the heavens. Let your glory be over the earth."
,"7":"Give help and save us by your right hand, and rescue those you love."
,"8":"God has spoken in his sanctuary: 'In triumph I will divide up Shechem and parcel out the Valley of Succoth."
,"9":"Gilead is mine; Manasseh is mine; Ephraim is my helmet, Judah my scepter."
,"10":"Moab is my washbasin; upon Edom I cast my sandal; over Philistia I shout in triumph.'"
,"11":"Who will take me to the fortified city? Who will lead me to Edom?"
,"12":"O God! Have you really rejected us? You no longer go with our armies."
,"13":"Give us aid against the foe, for the help of mortals is not worth a straw."
,"14":"With God we will gain victory; he will crush the enemy for us."
}`)
	CurrentBook.AddChapter(109, `{
"1":"Break your silence, O God whom I praise,"
,"2":"now that the wicked and deceitful hurl their false accusations at me."
,"3":"They assail me with words of hatred; they attack me for no valid cause."
,"4":"They return my friendship with slander, and yet I pray for them."
,"5":"They repay me evil for good, and hatred for my love."
,"6":"Appoint a wicked man against him; find an accuser to repeat this curse:"
,"7":"'Let him be found guilty when tried; let his own plea condemn him."
,"8":"May his days be numbered, his office be taken by another."
,"9":"May his children lose a father and his wife a husband."
,"10":"May his children go begging, driven out of their ruined homes."
,"11":"May the creditor seize all his belongings and strangers plunder the fruits of his toil."
,"12":"Let no one extend kindness to him or take pity on his orphaned children."
,"13":"May his posterity be destroyed, their names blotted out in the next generation."
,"14":"May his father's evil be remembered before the Lord; may his mother's sin never be effaced."
,"15":"May their sins be ever before the Lord, and their memory cut off from the earth.'"
,"16":"For he did not remember to show kindness, but hounded the poor, the needy, and the brokenhearted to their death."
,"17":"He loved to curse; may he be cursed. He loathed blessing; may it be far from him."
,"18":"He wrapped himself in cursing; may it soak into his body like water, penetrate his bones like oil."
,"19":"May it be like a garment he wears, like the belt he ties around himself."
,"20":"May the Lord reward my accusers with this, and others who speak evil of me."
,"21":"But as for me, O God my Lord, for your name's sake, act on my behalf, deliver me, in the goodness of your love."
,"22":"For I am poor and needy, my heart is stricken within me."
,"23":"Like an evening shadow, I fade away; like a locust, I am swept away."
,"24":"My knees have become weak from fasting, my body is wasted of its substance."
,"25":"I have become the butt for the scorn of my foes; people shake their heads at me in derision."
,"26":"Help me, O Lord my God, and save me for the sake of your love."
,"27":"Let them know that this is your hand, that it is you, Lord, who do this."
,"28":"They may curse, but you will bless; when they attack, they will be disgraced; but may your servant rejoice!"
,"29":"Let my accusers be clothed with dishonor; let them be wrapped in their own shame."
,"30":"To the Lord, I will give my thanks; I will praise him in the great assembly."
,"31":"He stands at the right hand of the needy, to save them from those who condemn him."
}`)
	CurrentBook.AddChapter(110, `{
"1":"The Lord said to my Lord, 'Sit at my right hand,till I make your foes your footstool.'"
,"2":"From Zion the Lord will extend your mighty scepter,and you will rule in the midst of your enemies."
,"3":"Yours is royal dignity,from the day you were born in holy majesty. Like dew from the womb of the dawn, I have begotten you."
,"4":"The Lord has sworn, and he will not take back his word: 'You are a priest forever,in the order of Melchizedek.'"
,"5":"The Lord is at your right hand,to crush the kings on his day of wrath."
,"6":"He will judge the nations, heaping up corpses, smashing heads on the wide plain."
,"7":"He has lapped up the water from the brook, this is why he will lift up his head."
}`)
	CurrentBook.AddChapter(111, `{
"1":"Alleluia!,I thank the Lord with all my heart,in the council of the just, in the assembly."
,"2":"The works of the Lord are great,and pondered by all who delight in them."
,"3":"Glorious and majestic are his deeds, his righteousness endures forever."
,"4":"He lets us remember his wondrous deeds; the Lord is merciful and kind."
,"5":"Always mindful of his covenant, he provides food for those who fear him."
,"6":"He shows his people the power of his arm,by giving them the lands of other nations."
,"7":"The works of his hands are faithful and just, trustworthy are all his precepts,"
,"8":"ordained to last forever, bearers of truth and uprightness."
,"9":"He has sent his people deliverances,and made with them a covenant forever. His holy name is to be revered!"
,"10":"The fear of the Lord is the beginning of wisdom; prudent are those who live by his precepts. To him belongs everlasting praise."
}`)
	CurrentBook.AddChapter(112, `{
"1":"Alleluia!,Blessed is the one who fears the Lord, who greatly delights in his commands."
,"2":"His children will be powerful on earth; the upright's offspring will be blessed."
,"3":"Wealth and riches are for his family, there his integrity will remain."
,"4":"He is for the righteous a light in darkness, he is kind, merciful and upright."
,"5":"It will be well with him who lends freely, who leads a life of justice and honesty."
,"6":"For the righteous will never be moved; he will be remembered and loved forever."
,"7":"He has no fear of evil news, for his heart is firm, trusting in the Lord."
,"8":"His heart is confident, he needs not fear, he shall prevail over his foes at the end."
,"9":"He gives generously to the poor, his merits will last forever,and his head will be raised in honor."
,"10":"The wicked will see this and be furious: they will gnash their teeth in seething envy. The desire of the wicked will fail."
}`)
	CurrentBook.AddChapter(113, `{
"1":"Alleluia!,Praise, O servants of the Lord, praise the name of the Lord!"
,"2":"Blessed be the name of the Lord,now and forever!"
,"3":"From eastern lands to the western islands, may the name of the Lord be praised!"
,"4":"The Lord is exalted over the nations, his glory above the heavens."
,"5":"Who is like the Lord our God, who sits enthroned on high,"
,"6":"but also bends down to see,on earth as in heaven?"
,"7":"He lifts up the poor from the dust,and the needy from the ash heap."
,"8":"He makes them sit with princes, with rulers of his people."
,"9":"He gives a home to the barren woman, and makes her a joyful mother. Praise the Lord!"
}`)
	CurrentBook.AddChapter(114, `{
"1":"Alleluia!,When Israel came out of Egypt, the family of Jacob,from a people of foreign language,"
,"2":"Judah became his sanctuary, Israel his possession."
,"3":"At his sight the sea fled,and the Jordan retreated;"
,"4":"the mountains skipped like rams, the hills frolicked like lambs."
,"5":"Why is it, sea, that you flee?,Jordan, that you turn back?"
,"6":"Mountains, that you skip like rams?,Hills, that you frolic like lambs?"
,"7":"Tremble, O earth, at your Master's presence, at the presence of the God of Jacob,"
,"8":"who turned the rock into a stream, and the flint into a spring."
}`)
	CurrentBook.AddChapter(115, `{
"1":"Not to us, O Lord, not to us, but to your name be the glory, for the sake of your love and faithfulness."
,"2":"Why should the pagans say, 'Where is their God?'"
,"3":"There in heaven is our God; whatever he wishes, he does."
,"4":"Not so the hand-made idols, crafted in silver and gold."
,"5":"They have mouths that cannot speak, eyes that cannot see,"
,"6":"ears that cannot hear, noses that cannot smell."
,"7":"They have hands but cannot feel, feet, but cannot walk; neither can they make a sound in their throat."
,"8":"Their makers will be like them, so will all who trust in them."
,"9":"O Israel, trust in the Lord; he is your help and your shield!"
,"10":"You, family of Aaron, trust in the Lord; he is your help and your shield!"
,"11":"You who fear the Lord, trust in him; he is your help and your shield!"
,"12":"The Lord remembers us and will bless us; he will bless the family of Israel; he will bless the family of Aaron;"
,"13":"he will bless those who fear the Lord, both the small and the great."
,"14":"May the Lord shower blessings, on you and your children as well."
,"15":"May you be blessed by the Lord, Maker of heaven and earth."
,"16":"Heaven belongs to the Lord, but the earth he has given to humans."
,"17":"It is not the dead who praise the Lord, for they have gone down to silence;"
,"18":"but it is we, the living, who bless the Lord, from now on and forever."
}`)
	CurrentBook.AddChapter(116, `{
"1":"Alleluia!,I am pleased that the Lord has heard,my voice in supplication,"
,"2":"that he has not been deaf to me, the day I called on him."
,"3":"When the cords of death entangled me, the snares of the grave laid hold of me, when affliction got the better of me,"
,"4":"I called upon the name of the Lord: 'O Lord, save my life!'"
,"5":"Gracious and righteous is the Lord; full of compassion is our God."
,"6":"the Lord protects the simple: he saved me when I was humbled."
,"7":"Return, O my soul, to your rest, for the Lord has taken care of you."
,"8":"He has freed my soul from death, my eyes from weeping, my feet from stumbling;"
,"9":"I will walk before the Lord,in the land of the living."
,"10":"I have kept faith even when I said, 'I am greatly afflicted.'"
,"11":"I have said in my dismay, 'To hope in humans is vain.'"
,"12":"How can I repay the Lord,for all his goodness to me?"
,"13":"I will lift up the cup of salvation,and call on the name of the Lord."
,"14":"I will fulfill my vows to the Lord,in the presence of all his people."
,"15":"It is painful to the Lord,to see the death of his faithful."
,"16":"O Lord, I am your servant, truly your servant, your handmaid's son. You have freed me from my bonds."
,"17":"I will offer you a thanksgiving sacrifice; I will call on the name of the Lord."
,"18":"I will carry out my vows to the Lord,in the presence of his people,"
,"19":"in the courts of the house of the Lord, in your midst, O Jerusalem."
}`)
	CurrentBook.AddChapter(117, `{
"1":"Alleluia!,Praise the Lord, all you nations; all you peoples, praise him."
,"2":"How great is his love for us!,His faithfulness lasts forever."
}`)
	CurrentBook.AddChapter(118, `{
"1":"Alleluia!,Give thanks to the Lord, for he is good, his loving kindness endures forever."
,"2":"Let Israel say, 'His loving kindness endures forever.'"
,"3":"Let the house of Aaron say, 'His loving kindness endures forever.'"
,"4":"Let those who fear the Lord say, 'His loving kindness endures forever.'"
,"5":"In anguish I cried to the Lord; he answered by setting me free."
,"6":"With the Lord beside me I need not fear. What can humans do to me?"
,"7":"The Lord is with me, ready to help; I can look in triumph upon my enemies."
,"8":"It is better to take refuge in the Lord,than to trust in the help of humans."
,"9":"It is better to take refuge in the Lord,than to trust in the might of princes."
,"10":"All the nations surrounded me; in the name of the Lord I crushed them."
,"11":"They surrounded me on every side; in the name of the Lord I crushed them."
,"12":"Like swarms of bees they encircled me; but like burning thorns they died down; in the name of the Lord I crushed them."
,"13":"I was pushed hard and about to fall, but the Lord came to my help."
,"14":"The Lord is my strength and my song; he has become my salvation."
,"15":"Joyful shouts of victory,are heard in the tents of the just: 'The right hand of the Lord strikes mightily,"
,"16":"the right hand of the Lord is lifted high, the right hand of the Lord strikes mightily!'"
,"17":"I shall not die, but live,to proclaim what the Lord has done."
,"18":"The Lord has stricken me severely, but he has saved me from death."
,"19":"Open to me the gates of the Just, and let me enter to give thanks."
,"20":"'This is the Lord's gate, through which the upright enter.'"
,"21":"I thank you for having answered me, for having rescued me."
,"22":"The stone rejected by the builders,has become the keystone."
,"23":"This was the Lord's doing,and we marvel at it."
,"24":"This is the day the Lord has made; so let us rejoice and be glad."
,"25":"Save us, O Lord, deliver us, O Lord!"
,"26":"Blessed is he who comes in the Lord's name!,We bless you from the house of the Lord."
,"27":"The Lord is God; may his light shine upon us. With branches, join in procession,up to the horns of the altar."
,"28":"You are my God, and I give you thanks. You are my God, and I give you praise."
,"29":"Give thanks to the Lord, for he is good; his steadfast love endures forever!"
}`)
	CurrentBook.AddChapter(119, `{
"1":"Blessed are they whose ways are upright, who follow the law of the Lord."
,"2":"Blessed are they who treasure his word and seek him with all their heart."
,"3":"They do no wrong; they walk in his ways."
,"4":"You have laid down precepts to be obeyed."
,"5":"O, that my ways were steadfast in observing your statutes!"
,"6":"Then I would not be put to disgrace, having paid attention to all your decrees."
,"7":"I will praise you with an upright spirit when I learn your just precepts by heart."
,"8":"I mean to observe your commandments. O, never abandon me."
,"9":"How can young people remain pure? By living according to your word."
,"10":"I seek you with my whole heart; let me not stray from your commands."
,"11":"In my heart I have kept your word, that I may not sin against my Lord."
,"12":"Praise to you, O Lord; instruct me in your statutes,"
,"13":"that with my lips I may declare all your spoken decrees."
,"14":"I delight in following your laws, more so than in all riches."
,"15":"I will meditate on your precepts and concentrate on your ways."
,"16":"In your laws I will rejoice and will not neglect your words."
,"17":"Be kind to your servant, that I may live to follow your word."
,"18":"Open my eyes that I may see the marvelous truths in your law."
,"19":"Do not hide your commandments from me, a wanderer on earth."
,"20":"My soul is consumed with desire for your ordinances at all times."
,"21":"You reprove the accursed ones who stray arrogantly from your commands."
,"22":"Remove from me their scorn and contempt, since I have followed your precepts."
,"23":"Although princes conspire against me, your servant will observe your decrees."
,"24":"Your laws are my delight, my counselors who uphold me."
,"25":"In the dust I lie prostrate; lift me up, as promised by your word."
,"26":"When I explained my ways, you responded; instruct me then in your precepts."
,"27":"Explain to me all your ordinances, and I will meditate on your wondrous deeds."
,"28":"My soul is weary with sorrow; strengthen me according to your word."
,"29":"Keep me away from deceitful paths; be gracious and teach me your law."
,"30":"I have chosen the way of truth; I have set my heart upon your laws."
,"31":"Since I cling to your decrees, O Lord, save me from disgrace."
,"32":"I will run in the way of your commands, for you have freed my heart."
,"33":"Explain to me, O Lord, your commandments, and I will be ever faithful to them."
,"34":"Give me understanding, that I may observe your law with all my heart."
,"35":"Guide me in obeying your instructions, for my pleasure lies in them."
,"36":"Incline my heart to follow your will and not my own selfish desire."
,"37":"Turn my eyes away from vanities and direct them to your life-giving word."
,"38":"Fulfill your promise to your servant, so that others may revere you."
,"39":"Ward off the reproach I fear, for your law is good."
,"40":"Oh, how I long for your precepts! Renew my life in your righteousness."
,"41":"Give me your unfailing love, O Lord, your salvation as you have promised."
,"42":"Strengthened by my trust in your word, I can answer my enemy's reproach."
,"43":"Take not the word of truth from my mouth, for I would also lose my hope in your word."
,"44":"May I always keep your word for ever and ever;"
,"45":"I shall walk in freedom, having sought out your laws."
,"46":"I will proclaim your word before kings, and I will not be confused or ashamed."
,"47":"For I delight in your word, which I fear."
,"48":"I will lift up my hands to you, and meditate on your commandments."
,"49":"Remember your word to your servant, your word which has given me hope."
,"50":"My consolation in suffering is this: that your promise renews my life."
,"51":"Although the arrogant mock me without end, I faithfully cling to your word."
,"52":"When I remember your ordinances of old, I find comfort in them, O Lord."
,"53":"I feel indignant at the wicked who have forsaken your law."
,"54":"Your decrees are the theme of my song, in this my place of exile."
,"55":"Each night I call on your name, O Lord, and renew my vow to keep your word."
,"56":"This has been my practice; I have kept your precepts."
,"57":"You are my portion, O Lord; I have promised to obey your word."
,"58":"With all my heart I have sought your face; be gracious to me according to your promise."
,"59":"I have considered my ways and have turned my steps to your paths."
,"60":"I hasten and no longer delay in keeping your commands."
,"61":"The wicked have me trapped in their snares, but I have not forgotten your laws."
,"62":"At midnight I rise to praise you for the justice of your ordinances."
,"63":"I am an ally for those who fear you, for those who keep your precepts."
,"64":"The earth is full of your love, O Lord! Teach me your decrees."
,"65":"You have been good to your servant, Lord, in accordance with your words."
,"66":"Give me knowledge and good judgment for I trust in your commands."
,"67":"Before I was afflicted I went astray, but now I obey your word."
,"68":"You are good, and your works are good; teach me your decrees."
,"69":"I am slandered by the arrogant, but I keep your precepts within my heart."
,"70":"Their hearts have become dull, but I delight in your laws."
,"71":"It is good for me to have been afflicted, for I have deeply learned your statutes."
,"72":"Your law is more precious to me than heaps of silver and gold."
,"73":"Give me insight to know your commands, since I have been formed by your hands."
,"74":"Those who fear you will be glad, seeing that I hope in your word."
,"75":"I know, O Lord, that your laws are just, and there is justice in my affliction."
,"76":"Comfort me then with your unfailing love, as you promised your servant."
,"77":"Let your mercy come to give me life, for your law is my delight."
,"78":"Humble the arrogant who oppress me as I meditate on your precepts."
,"79":"Let those who fear you turn to me, they will understand your statutes."
,"80":"May my heart be blameless in your decrees, that I may not be ashamed."
,"81":"My soul longs for your protection; your word is my hope of salvation."
,"82":"I have kept watch for your promise. 'When will you comfort me?' I ask."
,"83":"I have become as dry as a wineskin, yet I have not forgotten your statutes."
,"84":"How long must your servant endure? When will you judge my persecutors?"
,"85":"The arrogant have dug pitfalls for me in defiance of your law."
,"86":"Your law indeed is trustworthy, when they persecute me, help me."
,"87":"They have almost put an end to me on earth, and yet I have not forsaken your precepts."
,"88":"In your kindness give me life, that I may keep your commands."
,"89":"O Lord, your word stands forever, firmly fixed in the heavens."
,"90":"Your faithfulness lasts throughout the ages - as long as the earth you created."
,"91":"Your ordinances last to this day for all things are made to serve you."
,"92":"If your law had not been my pleasure, I would have perished in affliction."
,"93":"Never will I forget your precepts, for with them you give me life."
,"94":"Save me for I am yours, since I seek your statutes."
,"95":"The wicked lie in wait to destroy me, but I look to your word for salvation."
,"96":"I saw that all perfection is limited but your command is boundless."
,"97":"How I love your law, meditating on it all day!"
,"98":"Your command - mine forever - has made me wiser than my enemy."
,"99":"I have more insight than my teachers for I meditate on your decrees."
,"100":"I have more understanding than the elders for I abide by your precepts."
,"101":"I turn my feet from evil paths, that I may keep step with your word."
,"102":"I have not departed from your decrees for you yourself have instructed me."
,"103":"How sweet are your promises to my taste, sweeter than honey to my mouth!"
,"104":"Your precepts have given me knowledge, and I hate all that is false."
,"105":"Your word is a lamp to my feet, a light for my path."
,"106":"I have taken an oath to keep your just commands."
,"107":"I have suffered much, O Lord; renew my life according to your word."
,"108":"Accept my offerings of praise, O Lord, and teach me your decrees."
,"109":"I am ready to sacrifice my life for your Law that is always in my heart."
,"110":"Though the wicked have laid a snare for me, I do not stray from your precepts."
,"111":"Your statutes are my heritage forever, they are the joy of my heart."
,"112":"From age to age, I am determined to fulfill your decrees until the end."
,"113":"I detest double-dealing people, but I treasure your law."
,"114":"You are my shield, my refuge; my hope is in your word."
,"115":"Leave me, you evildoers; let me keep the commandments of my God."
,"116":"May your promise uphold me that I may live; let me not hope in vain."
,"117":"Support me and I shall be safe, and faithfully keep your decrees."
,"118":"You spurn all who stray from your decrees, for vain is their deceit."
,"119":"You discard all the wicked as dross; that is why I love your statutes."
,"120":"My flesh trembles in fear of you; I stand in awe before your laws."
,"121":"I have done what is just and right; do not leave me to my oppressors."
,"122":"Guarantee the well-being of your servant; let not the arrogant oppress me."
,"123":"I strain my eyes searching your saving help, watching for the fulfillment of your just promise."
,"124":"Treat your servant with compassion, and instruct me in your decrees."
,"125":"Give me knowledge; I am your servant who desires to understand your statutes."
,"126":"It is time for you, O Lord, to act, for they have broken your law."
,"127":"I love your commandments more than gold - the finest gold."
,"128":"Because my steps are guided by your precepts, I hate all false ways."
,"129":"Wonderful are your decrees; my soul cannot but keep them."
,"130":"As your words unfold, light is shed, and the simple-hearted understand."
,"131":"I gasp in ardent yearning for your commandments that I love."
,"132":"Turn to me then and be gracious as to those who love your name."
,"133":"You promised to direct my steps; free my path from evil."
,"134":"Rescue me from human oppression, and help me keep your precepts."
,"135":"Favor me with your smile and teach me your statutes."
,"136":"My eyes shed streams of tears for those who disobey your law."
,"137":"O Lord, you are just, and your judgments right."
,"138":"You have pronounced your decrees in justice and faithfulness."
,"139":"I burn with zeal, seeing how my foes ignore your words."
,"140":"Your promises have been tested; therefore our servants love them."
,"141":"Though I am lowly and despised, I do not forget your precepts."
,"142":"Your justice is eternal and your Law is true."
,"143":"In calamity and in anguish, your ordinances are my delight."
,"144":"Your statutes are just forever; give me understanding, that I may live."
,"145":"I call with all my heart; answer me, O Lord: help me keep your statutes."
,"146":"I call upon you, save me and I will do your will."
,"147":"Before dawn I rise and cry for help; all my hope is in your word."
,"148":"I lie awake through the night to ponder on your promises."
,"149":"Hear my voice, in your unfailing love; in your justice, O Lord, preserve my life."
,"150":"My persecutors close in with evil intent; they are far from your Law."
,"151":"But you, O Lord, are near, and all your commandments are true."
,"152":"Long have I known that your decrees were founded to last forever."
,"153":"Look upon my suffering and rescue me, for I have not forgotten your Law."
,"154":"Plead my cause and redeem me; and, as you promised, give me life."
,"155":"Salvation is far from the wicked, for they do not seek your statutes."
,"156":"Great is your compassion, O Lord; renew my life according to your word."
,"157":"Many foes persecute me, but I have not turned away from your law."
,"158":"I look upon the faithless with loathing, because they do not obey your ruling."
,"159":"See how I love your precepts; give me life, O Lord, in your kindness."
,"160":"The essence of your word is truth, everlasting are your just ordinances."
,"161":"Rulers persecute me for no cause, yet my heart stands in awe of your words."
,"162":"Your word filled me with joy: I found there great riches."
,"163":"I hate and abhor falsehood, but I love your law."
,"164":"Seven times a day I praise you for your just ordinances."
,"165":"Lovers of your Law have found great peace; nothing can make them stumble, not even distress."
,"166":"O Lord, I wait for your salvation, and I keep your commands in faith."
,"167":"My soul clings to your words for I truly cherish them."
,"168":"I obey your precepts and your decrees; my ways are always before you."
,"169":"Let my cry come to you, O Lord; give me understanding according to your word."
,"170":"May my prayer come before you; rescue me as you have promised."
,"171":"Let my lips overflow with praise, for you teach me your decrees."
,"172":"Let my tongue sing of your good news, for all you say is true."
,"173":"Let your hand be ready to help me, for I have chosen your precepts."
,"174":"I long for your salvation, O Lord; I delight in your law."
,"175":"Long may I live to sing your praise, may your ordinances always be my help!"
,"176":"Like a stray sheep I wandered about - come and look for your lost servant. See that I have not forgotten your commands."
}`)
	CurrentBook.AddChapter(120, `{
"1":"I called to the Lord in my distress, and he answered me."
,"2":"Deliver me, O Lord, from lying lips,and from deceitful tongues."
,"3":"How shall he pay you back, O deceitful and lying tongue?"
,"4":"He will punish you with arrows,hardened over the glowing coals!"
,"5":"Woe is me who live with barbarians, and dwell amid plunders."
,"6":"My soul is sick of dwelling,among those who hate peace;"
,"7":"I want peace, but they only think of quarrels."
}`)
	CurrentBook.AddChapter(121, `{
"1":"I lift up my eyes to the mountains -,from where shall come my help?"
,"2":"My help comes from the Lord, maker of heaven and earth."
,"3":"Will he not let your foot slip, the one watching over you?,Will he not slumber?"
,"4":"No, the guardian of Israel,neither slumbers nor sleeps."
,"5":"The Lord is your guardian, the Lord is at your side and you in his shade;"
,"6":"Sunstroke will not be for you by day, nor the spell of the moon by night."
,"7":"The Lord guards you from every evil; he will protect your life."
,"8":"The Lord watches over your coming and going,both now and forever."
}`)
	CurrentBook.AddChapter(122, `{
"1":"I rejoiced with those who said to me, 'Let us go to the house of the Lord!'"
,"2":"And now we have set foot,within your gates, O Jerusalem!"
,"3":"Jerusalem, just like a city, where everything falls into place!"
,"4":"There the tribes go up, the tribes of the Lord, the assembly of Israel, to give thanks to the Lord's name,"
,"5":"There stand the courts of justice,the offices of the house of David."
,"6":"Pray for the peace of Jerusalem: 'May those who love you prosper!"
,"7":"May peace be within your walls,and security within your citadels!'"
,"8":"For the sake of my relatives and friends,I will say, 'Peace be with you!'"
,"9":"For the sake of the house of our Lord, I will pray for your good."
}`)
	CurrentBook.AddChapter(123, `{
"1":"To you I lift up my eyes, to you whose throne is in heaven."
,"2":"As the eyes of servants look,to the hand of their master, as the eyes of maids look,to the hand of their mistress, so our eyes look to the Lord our God, till he shows us his mercy."
,"3":"Have mercy on us, O Lord, have mercy on us, for we have our fill of contempt."
,"4":"Too long have our souls been filled,with the scorn of the arrogant, with the ridicule of the insolent."
}`)
	CurrentBook.AddChapter(124, `{
"1":"Had not the Lord been on our side -,let Israel say -"
,"2":"had not the Lord been on our side, when people rose up against us,"
,"3":"then they would have swallowed us alive. such was their anger against us."
,"4":"A bit more and the flood would have engulfed us, the torrent would have swept over us,"
,"5":"the raging waters would have swept us away."
,"6":"Blessed be the Lord, who did not let us be devoured."
,"7":"Like a bird our soul escaped,from the snare of the fowler; the snare was broken and we were freed."
,"8":"Our help is in the name of the Lord, who made heaven and earth."
}`)
	CurrentBook.AddChapter(125, `{
"1":"Those who trust in the Lord,are like Mount Zion, immovable, it stands forever."
,"2":"As mountains surround Jerusalem, so the Lord encompasses his people."
,"3":"The scepter of the wicked will not remain,over the land allotted to the upright, for then the upright might be led,to put their hands to evil deeds."
,"4":"Be good, O Lord, to those who are good, to those who are upright in heart."
,"5":"But those who turn to crooked ways, the Lord will drive out with the evildoers. May peace remain upon Israel."
}`)
	CurrentBook.AddChapter(126, `{
"1":"When the Lord brought the exiles back to Zion, we were like those moving in a dream."
,"2":"Then our mouths were filled with laughter, and our tongues with songs of joy. Among the nations it was said, 'The Lord has done great things for them.'"
,"3":"The Lord had done great things for us, and we were glad indeed."
,"4":"Bring back our exiles, O Lord, like fresh streams in the desert."
,"5":"Those who sow in tears,will reap with songs and shouts of joy."
,"6":"They went forth weeping, bearing the seeds for sowing, they will come home with joyful shouts, bringing their harvested sheaves."
}`)
	CurrentBook.AddChapter(127, `{
"1":"Unless the Lord builds the house, in vain do its builders labor. Unless the Lord guards the city, in vain does the guard stay awake."
,"2":"It is in vain that you rise early,and stay up late, putting off your rest, toiling for your hard-earned bread; God gives it to his loved ones, and they sleep."
,"3":"Sons are a gift from the Lord; the fruit of the womb is a reward."
,"4":"Like arrows in the hands of a warrior,are the sons of one's youth."
,"5":"Blessed is the man who has filled,his quiver with arrows of this kind, their foes will not silence them,when they contend in court."
}`)
	CurrentBook.AddChapter(128, `{
"1":"Blessed are you who fear the Lord,and walk in his ways."
,"2":"You will eat the fruit of your toil; you will be blessed and favored."
,"3":"Your wife, like a vine, will bear fruits in your home; your children, like olive shoots,will stand around your table."
,"4":"Such are the blessings bestowed,upon the man who fears the Lord."
,"5":"May the Lord bless you from Zion. May you see Jerusalem prosperous,all the days of your life."
,"6":"May you see your children's children, and Israel at peace!"
}`)
	CurrentBook.AddChapter(129, `{
"1":"How they have oppressed me from my youth -,let Israel say,"
,"2":"how they have oppressed me from my youth -,they have not put me down."
,"3":"Upon my back plowers have plowed,long and deep furrows"
,"4":"But the Lord, who is just, has shattered the yoke of the wicked."
,"5":"May all who hate Zion,be thrown into confusion."
,"6":"May they be like grass in the garden, which withers before you uproot it."
,"7":"No reaper sets his hands on it, no one gathers it to fill his arms,"
,"8":"nor says of them the passersby, 'The blessing of the Lord be upon you!',We bless you in the name of the Lord!"
}`)
	CurrentBook.AddChapter(130, `{
"1":"Out of the depths I cry to you, O Lord,"
,"2":"O Lord, hear my voice!,Let your ears pay attention,to the voice of my supplication."
,"3":"If you should mark our evil, O Lord, who could stand?"
,"4":"But with you is forgiveness, and for that you are revered."
,"5":"I waited for the Lord, my soul waits, and I put my hope in his word."
,"6":"My soul expects the Lord,more than watchmen the dawn."
,"7":"O Israel, hope in the Lord, for with him is unfailing love,and with him full deliverance."
,"8":"He will deliver Israel,from all its sins."
}`)
	CurrentBook.AddChapter(131, `{
"1":"O Lord, my heart is not proud,nor do I have arrogant eyes. I am not engrossed in ambitious matters, nor in things too great for me."
,"2":"I have quieted and stilled my soul,like a weaned child on its mother's lap; like a contented child is my soul."
,"3":"Hope in the Lord, O Israel, now and forever."
}`)
	CurrentBook.AddChapter(132, `{
"1":"Remember David, O Lord, and all his readiness,"
,"2":"how he swore an oath to the Lord, to the Mighty One of Jacob."
,"3":"'I will not enter my house nor get into my bed,"
,"4":"I will give no sleep to my eyes, no slumber to my eyelids,"
,"5":"until I find a place for the Lord, a dwelling for the Mighty One of Jacob.'"
,"6":"Then came the news, 'The Ark is in Ephrathah, we found it in the fields of Jaar.'"
,"7":"Let us go to where he dwells and worship at his footstool!"
,"8":"Arise, O Lord, and come to your rest, you and the ark of your might."
,"9":"May your priests be arrayed as for a triumphing; may your faithful ones shout in gladness."
,"10":"For the sake of your servant, David, do not turn away the face of your anointed."
,"11":"The Lord swore to David a promise, and he will remain true to it: 'I will keep your descendance on your throne."
,"12":"If your sons keep my covenant and the decrees I have taught them, their sons, too, will sit forever upon your throne.'"
,"13":"For the Lord has chosen Zion; he has desired it for his dwelling:"
,"14":"'This is my resting place forever; this I prefer, here will I dwell."
,"15":"I will bless its fruits, its bread, and the poor will be satisfied."
,"16":"I will clothe its priests with glory and its faithful will sing in gladness."
,"17":"From here a savior shall come forth, a son of David; here shall shine forever the lamp of my anointed."
,"18":"In shame will I clothe his enemies, but upon his head a crown shall shine.'"
}`)
	CurrentBook.AddChapter(133, `{
"1":"How good and delightful to see,kindred living together in unity!"
,"2":"It is like precious oil poured,upon Aaron's head, running down his beard,onto the collar of his robes."
,"3":"It is like the dew of Hermon,coming down the mountains of Zion, where the Lord confers his blessing: life everlasting."
}`)
	CurrentBook.AddChapter(134, `{
"1":"Come, bless the Lord, all you servants of the Lord, who minister by night in the house of the Lord, in the courts of the house of our God."
,"2":"Raise your hands to the sanctuary,and bless the Lord."
,"3":"May the Lord bless you from Zion, he who made heaven and earth."
}`)
	CurrentBook.AddChapter(135, `{
"1":"Alleluia!,Praise the name of the Lord. O servants of the Lord, "
,"2":"praise him, you who serve in the house of the Lord, in the courts of the house of our God."
,"3":"Praise the Lord, for he is good, praise his name, for it is beautiful;"
,"4":"for the Lord has chosen Jacob as his own, Israel as his possession."
,"5":"I know that the Lord is great, that our Lord is above all gods."
,"6":"Whatever the Lord pleases, he does - in heaven and on earth, in the seas and in their depths."
,"7":"He raises clouds from the ends of the earth; he hurls down lightning with the rain; and from his vaults he lets loose the wind."
,"8":"It was he who killed the firstborn in Egypt, both people and beasts."
,"9":"It was he who worked signs and wonders in your land, O Egypt, against Pharaoh and all his officers."
,"10":"He destroyed mighty nations and slew powerful kings -"
,"11":"Sihon, king of the Amorites, Og, king of Bashan, all the kings of Canaan."
,"12":"He gave their land as an inheritance to Israel, his people."
,"13":"Your name, O Lord, will endure forever; your renown, O Lord, throughout the ages."
,"14":"For the Lord vindicates his people and shows mercy to his servants."
,"15":"The nations' idols are but gold and silver, the work of human hands."
,"16":"They have mouths that cannot speak, eyes that cannot see,"
,"17":"ears that cannot hear; neither is there breath in their mouths."
,"18":"Their makers will be like them, so will all who trust in them."
,"19":"Bless the Lord, house of Israel; bless the Lord, house of Aaron;"
,"20":"bless the Lord, house of Levi; bless the Lord, all you who fear him."
,"21":"Blessed be the Lord from Zion, he who dwells in Jerusalem."
}`)
	CurrentBook.AddChapter(136, `{
"1":"Alleluia!,Give thanks to the Lord, for he is good, his kindness endures forever."
,"2":"Give thanks to the God of gods, his kindness endures forever."
,"3":"Give thanks to the Lord of lords, his kindness endures forever."
,"4":"He alone does great marvels, his kindness endures forever."
,"5":"In wisdom he made the heavens, his kindness endures forever."
,"6":"He set the earth upon the waters, his kindness endures forever."
,"7":"He made the great lights, his kindness endures forever,"
,"8":"the sun to rule over the day, his kindness endures forever,"
,"9":"the moon and stars to rule the night, his kindness endures forever."
,"10":"He slew the firstborn of Egypt, his kindness endures forever,"
,"11":"and brought Israel out, his kindness endures forever,"
,"12":"with strong hand and outstretched arm, his kindness endures forever."
,"13":"He split the Sea of Reeds, his kindness endures forever,"
,"14":"and made Israel pass through it, his kindness endures forever,"
,"15":"drowning Pharaoh and his army, his kindness endures forever,"
,"16":"and led his people through the desert, his kindness endures forever."
,"17":"He struck down great kings, his kindness endures forever,"
,"18":"and killed mighty kings, his kindness endures forever,"
,"19":"Sihon, king of the Amorites, his kindness endures forever,"
,"20":"and Og, king of Bashan, his kindness endures forever."
,"21":"He gave their land as an inheritance, his kindness endures forever,"
,"22":"a heritage to Israel his servant, his kindness endures forever."
,"23":"He remembered us in our humiliation, his kindness endures forever,"
,"24":"and freed us from our oppressors, his kindness endures forever,"
,"25":"he who gives food to all creatures, his kindness endures forever."
,"26":"Give thanks to the God of heaven, his kindness endures forever!"
}`)
	CurrentBook.AddChapter(137, `{
"1":"By the streams of Babylon, we sat and then wept,as we remembered Zion."
,"2":"When on the poplars,we hung our harps"
,"3":"our captors asked for song. Our tormentors wanted songs of joy: 'Sing to us one of the songs of Zion!'"
,"4":"How could we sing the Lord's song,in a strange and alien land?"
,"5":"If I forget you, O Jerusalem, may my right hand fall useless!"
,"6":"May my tongue cleave to my palate,if I remember you not, if Jerusalem is not the first of my joys."
,"7":"Remember, Lord, the Edomites,- what did they do when Jerusalem fell?,They said 'Tear the city down, tear it down to its foundations!'"
,"8":"O daughter of Babylon, you will be sacked,happy is he who repays you,and does to you what you have done to us!"
,"9":"Happy is who seizes your infants,and dashes them against the rocks!"
}`)
	CurrentBook.AddChapter(138, `{
"1":"I thank you, O Lord, with all my heart, for you have heard the word of my lips. I sing your praise in the presence of the gods."
,"2":"I bow down towards your holy temple,and give thanks to your name, for your love and faithfulness, for your word which exceeds everything."
,"3":"You answered me when I called; you restored my soul and made me strong."
,"4":"O Lord, all kings on earth will give you praise, when they have heard your words."
,"5":"They will celebrate the ways of the Lord, 'great is the glory of the Lord!'"
,"6":"From above, the Lord watches over the lowly; from afar, he marks down the haughty."
,"7":"If I walk in the midst of trouble, you give me life. With outstretched arm, you save me from the wrath of my foes, with your right hand you deliver me."
,"8":"How the Lord cares for me!,Your kindness, O Lord, endures forever. Forsake not the work of your hands."
}`)
	CurrentBook.AddChapter(139, `{
"1":"O Lord, you know me: you have scrutinized me."
,"2":"You know when I sit and when I rise; beforehand you discern my thoughts."
,"3":"You observe my activities and times of rest; you are familiar with all my ways."
,"4":"Before a word is formed in my mouth, you know what it is all about, O Lord."
,"5":"From front to back you hedge me round, shielding me with your protecting hand."
,"6":"Your knowledge leaves me astounded, it is too high for me to reach."
,"7":"Where else could I go from your Spirit?,Where could I flee from your presence?"
,"8":"You are there if I ascend the heavens; you are there if I descend to the depths."
,"9":"If I ride on the wings of the dawn,and settle on the far side of the sea,"
,"10":"even there your hand shall guide me,and your right hand shall hold me safely."
,"11":"Shall I say, 'Let darkness hide me, I prefer the night as my light?'"
,"12":"But darkness for you is not dark,and night for you shines as the day."
,"13":"It was you who formed my inmost part,and knit me together in my mother's womb."
,"14":"I thank you for these wonders you have done, and my heart praises you for your marvelous deeds."
,"15":"Even my bones were known to you,when I was being formed in secret, fashioned in the depths of the earth."
,"16":"Your eyes saw the course of my days; they were all recorded in your book,before any of them came to be."
,"17":"How difficult it is to grasp your thoughts, O God!,Their number cannot be counted."
,"18":"If I tried to do so, they would outnumber the sands; I am never finished with you."
,"19":"If only you would slay the wicked, O God, and drive away from me the violent!"
,"20":"They rebel falseheartedly, your foes blaspheme your name."
,"21":"I hate those who hate you, O Lord, and loathe those who defy you."
,"22":"I hate them deeply, they have become my foes."
,"23":"Search me, O God, and know my heart; try me and know my thoughts."
,"24":"See if my steps are going astray, and lead me in your eternal way."
}`)
	CurrentBook.AddChapter(140, `{
"2":"O Lord, deliver me from the evil one, protect me from violent people,"
,"3":"forever plotting evil and stirring up strife."
,"4":"They have tongues sharp as a serpent's and venomous lips."
,"5":"Save me, O Lord, from the hands of the wicked, preserve me from the hands of the violent, who have planned to trip my feet."
,"6":"The arrogant have set a snare for me; they have spread out their nets to entrap me along my path."
,"7":"I say to the Lord, 'You are my God.' Hear, O Lord, my voice in supplication."
,"8":"O God, my Lord, my strength and salvation, in the day of battle you shield my head."
,"9":"Do not grant, O Lord, the desires of the wicked; do not let their evil schemes succeed."
,"10":"Let my attackers be overwhelmed by the mischief they prepared and not lift up their heads."
,"11":"Let burning coals rain upon them; let them be cast into the depths, never to rise again."
,"12":"Do not let the slanderer thrive on earth; let disaster hunt down the violent."
,"13":"I know that the Lord upholds the cause of the afflicted, and justice will be done to the poor."
,"14":"The just shall praise your name, the upright shall dwell in your presence."
}`)
	CurrentBook.AddChapter(141, `{
"1":"Lord, I call on you, hasten to help me! Listen to my plea when I call to you."
,"2":"Let my prayer rise to you like incense, as I lift up my hands as in an evening sacrifice."
,"3":"O Lord, set a guard at my mouth, keep watch at the gate of my lips."
,"4":"Let not my heart be drawn to evil; let me not be enticed into evil acts in company with sinners, and let me not partake of their delights."
,"5":"Rather the reproach and the just scourge, than the oil of the wicked anointing my head."
,"6":"When their rulers are flung upon the rock, only then will these wicked learn that I was tolerant with them,"
,"7":"when the earth opens to swallow them and their bones are scattered at the edge of the netherworld."
,"8":"But my eyes are turned to you, O God, my Lord; strip me not of life, for you are my refuge."
,"9":"Keep me from the trap they have set for me, keep me from the net laid by evildoers."
,"10":"Let the wicked fall into their own snares, while I alone escape safe and free."
}`)
	CurrentBook.AddChapter(142, `{
"2":"I cry aloud to the Lord, in a loud voice I beseech the Lord."
,"3":"Before him I pour out my sorrows, before him I lay bare my troubles"
,"4":"and my spirit grows faint. But you know my path. Along the way I walk,they have hidden a trap for me."
,"5":"Look to my right and see: no one recognizes me. I have lost all means of escape; no one wants to help me."
,"6":"I cry to you, O Lord; I say, 'You are my refuge, my portion in the land of the living.'"
,"7":"Listen to my groaning, for I am in deep despair. Rescue me from my pursuers, for they are too strong for me."
,"8":"O, set me free from captivity, that I may praise your name!,Then the righteous will gather about me,when they see that you took care of me."
}`)
	CurrentBook.AddChapter(143, `{
"1":"O Lord, hear my prayer, listen to my cry for mercy; answer me, you who are righteous and faithful."
,"2":"Do not bring your servant to judgment, for no mortal is just in your sight."
,"3":"The enemy has pursued me, crushing my life to the ground, sending me to darkness with those long dead."
,"4":"And so my spirit fails me, my heart is full of fear."
,"5":"I remember the days of long ago; I meditate on what you have done and consider the work of your hand."
,"6":"I stretch out my hands to you, and thirst for you like a parched land."
,"7":"O Lord, answer me quickly: my spirit is faint with yearning. Do not hide your face from me; save me from going down to the pit."
,"8":"Let the dawn bring me word of your love, for in you alone I put my trust. Show me the way I should walk, for to you I lift up my soul."
,"9":"Rescue me from my enemies, O Lord, for to you I flee for refuge."
,"10":"Teach me to do your will, for you are my God. Let your Spirit lead me on a safe path."
,"11":"Preserve me, O Lord, for your name's sake; free me from distress, in your justice."
,"12":"You who are merciful, crush my enemies and destroy all my foes, for I am your servant."
}`)
	CurrentBook.AddChapter(144, `{
"1":"Blessed be the Lord, my rock, who trains my hands for war and my fingers for battle -"
,"2":"my loving God, my fortress; my protector and deliverer, my shield where I take refuge, who conquers nations and subjects them to my rule."
,"3":"O Lord, what are humans that you should be mindful of them, the race of Adam, that you should care for them?"
,"4":"They are like a breath, their days pass like a shadow on earth."
,"5":"Bend your heavens, O Lord, and come down; touch the mountain and make it smoke."
,"6":"Flash forth lightning and rout the foe; shoot your arrows and scatter them."
,"7":"From above, reach down and draw me out of the deep waters, from the hands of foreigners"
,"8":"whose mouths speak falsehood, whose words are full of deceit."
,"9":"I will sing a new song to you, O God, I will make music on the ten-stringed harp,"
,"10":"for you who give victory to kings and deliver David, your servant."
,"11":"Rescue me from the evil sword and from the hands of foreigners, whose mouths speak falsehood, whose words are full of deceit."
,"12":"May our sons be like plants well-nurtured and full grown, and our daughters like pillars that adorn the corners of the temple."
,"13":"May our barns be full, with every kind of provision. May our sheep increase by thousands, even by tens of thousands, in our pastures."
,"14":"May our cattle be strong and fruitful; and may there be an end to raids and exile, to cries of distress in our streets."
,"15":"Happy are the people so blessed; happy the people whose God is the Lord!"
}`)
	CurrentBook.AddChapter(145, `{
"1":"I will extol you, my God and King; I will bless your name forever."
,"2":"I will praise you day after day and exalt your name forever."
,"3":"Great is the Lord, most worthy of praise; and his deeds are beyond measure."
,"4":"Parents commend your works to their children and tell them your feats."
,"5":"They proclaim the splendor of your majesty and recall your wondrous works."
,"6":"People will proclaim your mighty deeds, and I will declare your greatness."
,"7":"They will celebrate your abundant kindness, and rejoice in singing of your justice."
,"8":"Compassionate and gracious is the Lord, slow to anger and abounding in love."
,"9":"The Lord is good to everyone; his mercy embraces all his creation."
,"10":"All your works will give you thanks; all your saints, O Lord, will praise you."
,"11":"They will tell of the glory of your kingdom and speak of your power,"
,"12":"that all may know of your mighty deeds, your reign and its glorious splendor."
,"13":"Your reign is from age to age; your dominion endures from generation to generation. The Lord is true to his promises and lets his mercy show in all he does."
,"14":"The Lord lifts up those who are falling and raises those who are beaten down."
,"15":"All creatures look to you to be fed in due season;"
,"16":"with open hand you satisfy the living according to their needs."
,"17":"Righteous is the Lord in all his ways, his mercy shows in all his deeds."
,"18":"He is near those who call on him, who call trustfully upon his name."
,"19":"He fulfills the wish of those who fear him; he hears their cry and saves them."
,"20":"For those who love him, the Lord has compassion; but the wicked, he will destroy."
,"21":"Let my mouth speak in praise of the Lord, let every creature bless his holy name, for ever and ever."
}`)
	CurrentBook.AddChapter(146, `{
"1":"Alleluia!,Praise the Lord, my soul!"
,"2":"I will sing to the Lord all my life; I will sing praise to God while I live."
,"3":"Do not put your trust in princes, in a great one who cannot save."
,"4":"Not sooner his spirit has left, that he goes back to the earth; on that very day, any plan comes to nothing."
,"5":"Blessed are they whose help is the God of Jacob, whose hope is in the Lord their God,"
,"6":"maker of heaven and earth, the sea and all they contain. The Lord is forever faithful;"
,"7":"he gives justice to the oppressed,and gives food to the hungry. The Lord sets the prisoners free."
,"8":"The Lord gives sight to the blind, the Lord straightens the bent."
,"9":"The Lord protects the stranger, sustains the widow and the orphan."
,"8c":"The Lord loves the virtuous, but he brings to ruin the way of the wicked."
,"10":"The Lord will reign forever, your God, O Zion, from generation to generation. Alleluia!"
}`)
	CurrentBook.AddChapter(147, `{
"1":"Alleluia!,How good it is to sing to our God, how sweet and befitting to praise him!"
,"2":"The Lord rebuilds Jerusalem; he gathers the exiles of Israel;"
,"3":"he heals their broken hearts,and binds up their wounds."
,"4":"He determines the number of stars, he calls each of them by name."
,"5":"The Lord is great and mighty in power; his wisdom is beyond measure."
,"6":"The Lord lifts up the humble, but casts the wicked to the ground."
,"7":"Sing to the Lord with thanksgiving, make music on the harp for our God."
,"8":"With clouds he covers the sky, and provides the earth with rain; he covers the hills with grass, and with plants for man to cultivate."
,"9":"He provides food for the cattle, even for the young ravens when they call."
,"10":"He is not concerned with the strength of a horse; nor is he pleased in the speed of a runner;"
,"11":"The Lord delights in those who fear him,and expect him to care for them."
,"12":"Exalt the Lord, O Jerusalem; praise your God, O Zion!"
,"13":"For he strengthens the bars of your gates,and blesses your children within you."
,"14":"He grants peace on your borders,and feeds you with the finest grain."
,"15":"He sends his command to the earth,and swiftly runs his word."
,"16":"He spreads snow like wool; he scatters frost like ashes."
,"17":"He hurls down hail like pebbles; who will stand before his icy blasts?"
,"18":"But he sends his word and melts the snow; he makes his breeze blow, and again the waters flow."
,"19":"It is he who tells Jacob his words, his laws and decrees to Israel."
,"20":"This he has not done for other nations, so his laws remain unknown to them. Alleluia!"
}`)
	CurrentBook.AddChapter(148, `{
"1":"Alleluia! Praise the Lord from the heavens; praise him in the heavenly heights."
,"2":"Praise him, all his angels; praise him, all his heavenly hosts."
,"3":"Praise him, sun and moon; praise him, all you shining stars."
,"4":"Praise him, you highest heavens and you waters above the skies."
,"5":"Let them praise the name of the Lord, at whose command they were made."
,"6":"He established them forever and gave each a fixed and lasting duty."
,"7":"Praise the Lord from the earth, you sea creatures and all the depths,"
,"8":"clouds and snow, hail and lightning, storm winds that do his bidding,"
,"9":"you mountains and all you hills, you fruit trees and cedars,"
,"10":"you wild beasts and tame animals, you creeping things and winged fowl."
,"11":"Kings of the earth and nations, princes and all rulers of the world,"
,"12":"young men and maidens, old and young together -"
,"13":"let them praise the name of the Lord. For his name alone is exalted; his majesty is above earth and heaven."
,"14":"He has given his people glory; he has given a praise to his faithful, to Israel, the people close to him. Alleluia."
}`)
	CurrentBook.AddChapter(149, `{
"1":"Alleluia!,Sing to the Lord a new song, sing his praise in the assembly of his saints."
,"2":"Let Israel rejoice in his Maker, let the people of Zion glory in their King!"
,"3":"Let them dance in praise of his name,and make music for him with harp and timbrel."
,"4":"For the Lord delights in his people; he crowns the lowly with victory."
,"5":"The saints will exult in triumph; even at night on their couches."
,"6":"Let the praise of God be on their lips, and in their hands two-edged swords,"
,"7":"to wreak vengeance on the nations,and punishment on the peoples,"
,"8":"to bind their kings in chains,and their nobles in iron fetters,"
,"9":"to execute on them the written sentence: this is the glory of all his saints. Alleluia!"
}`)
	CurrentBook.AddChapter(150, `{
"1":"Alleluia!,Praise God in his sanctuary; praise him in the vault of heaven."
,"2":"Praise him for his mighty deeds; praise him for his own greatness."
,"3":"Praise him with trumpet blast; praise him with lyre and harp."
,"4":"Praise him with dance and tambourines; praise him with pipe and strings."
,"5":"Praise him with clashing cymbals; praise him with clanging cymbals."
,"6":"Let everything that breathes sing praise to the Lord. Alleluia!"
}`)

}
func EN_CCB_LoadVSSPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Love justice, you who rule over the world. Think rightly of God, seek him with simplicity of heart,"
,"2":"for he reveals himself to those who do not challenge him and is found by those who do not distrust him."
,"3":"Crooked thinking distances you from God, and his Omnipotence, put to the test, confounds the foolish."
,"4":"Wisdom does not enter the wicked nor remain in a body that is enslaved to sin."
,"5":"The Holy Spirit who instructs us shuns deceit; it keeps aloof from foolishness and is ill at ease when injustice is done."
,"6":"Wisdom is a spirit, a friend to man, and will not leave the blasphemous unpunished, because God knows his innermost feelings, truly sees his thoughts and hears what he says."
,"7":"For God's spirit has filled the whole world and he who holds together all things, knows each word that is spoken."
,"8":"So whoever speaks unjustly will not escape; the irrefutable sentence will reach him."
,"9":"The intentions of the unholy will be examined; what he has said will reach the Lord and his wickedness will be confounded."
,"10":"Remember that a jealous ear hears everything; even whispers are recorded."
,"11":"Beware then, of empty complaints and keep your tongue from faultfinding, since your most secret word will have consequences; a lying tongue brings death to the soul."
,"12":"Do not bring about your own death by your wrong way of living. And do not let the work of your hands destroy you."
,"13":"God did not make death, nor does he rejoice in the destruction of the living."
,"14":"Since he has created everything, all creatures of the universe are for our good; there is no deadly poison in them and the netherworld has no dominion over the earth,"
,"15":"because justice is not submitted to death."
,"16":"It is the godless that consider death a friend and call for it in every way. They have made a pact with it and they shall justly belong to it."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Led by mistaken reasons they think, 'Life is short and sad and there is no cure for death. It was never heard that anyone came back from the netherworld."
,"2":"By chance we were born; when life is over, it will be as if we never existed. The breath in our nostrils is like a puff of smoke, and thought is no more than a spark resulting from the movement of the heart."
,"3":"Put this out and the body turns to ashes, the spirit melts away like idle air."
,"4":"In time our name will be forgotten, no one will remember what we did."
,"5":"Life passes like the shadow of a cloud, disappears like mist chased by the sun and overpowered by its heat. Our days are like the passing of a shadow; from death there is no turning back, the seal is set: no one returns."
,"6":"Come then and enjoy all the good things; let us use creation with the zest of youth,"
,"7":"making the most of choicest wines and perfumes and not passing by any flower of spring."
,"8":"Let us crown ourselves with rosebuds before they fade."
,"9":"Let everyone take part in our orgy; let us post everywhere the signs of our joy, for that is our due, the lot assigned to us."
,"10":"Let us oppress the upright man who is poor, and have no thought for the widow, or respect for the white hair of old age."
,"11":"Let our strength be our right, since it is proved that weakness is useless."
,"12":"Let us set a trap for the righteous, for he annoys us and opposes our way of life; he reproaches us for our breaches of the Law and accuses us of being false to our upbringing."
,"13":"He claims knowledge of God and calls himself son of the Lord."
,"14":"He has become a reproach to our way of thinking; even to meet him is burdensome to us."
,"15":"He does not live like others and behaves strangely."
,"16":"According to him we have low standards, so he keeps aloof from us as if we were unclean. He emphasizes the happy end of the righteous and boasts of having God as father."
,"17":"Let us see the truth of what he says and find out what his end will be."
,"18":"If the righteous is a son of God, God will defend him and deliver him from his adversaries."
,"19":"Let us humble and torture him to prove his self-control and test his patience."
,"20":"When we have condemned him to a shameful death, we may test his words.'"
,"21":"This is the way they reason, but they are mistaken, blinded by their malice."
,"22":"They do not know the mysteries of God nor do they hope for the reward of a holy life; they do not believe that the blameless will be recompensed."
,"23":"Indeed God created man to be immortal in the likeness of his own nature,"
,"24":"but the envy of the devil brought death to the world, and those who take his side shall experience death."
}`)
	CurrentBook.AddChapter(3, `{
"1":"The souls of the just are in the hands of God and no torment shall touch them."
,"2":"In the eyes of the unwise they appear to be dead. Their going is held as a disaster;"
,"3":"it seems that they lose everything by departing from us, but they are in peace."
,"4":"Though seemingly they have been punished, immortality was the soul of their hope."
,"5":"After slight affliction will come great blessings, for God has tried them and found them worthy to be with him;"
,"6":"after testing them as gold in the furnace, he has accepted them as a holocaust."
,"7":"At the time of his coming they will shine like sparks that run in the stubble."
,"8":"They will govern nations and rule over peoples, and the Lord will be their king forever."
,"9":"Those who trust in him will penetrate the truth, those who are faithful will live with him in love, for his grace and mercy are for his chosen ones."
,"10":"But the godless who have ignored the upright and deserted the Lord, will meet the punishment their evil thoughts deserve."
,"11":"Unhappy are those who put no value on wisdom and instruction, their hope is vain, their efforts useless, their work without profit;"
,"12":"their wives are foolish, their children evil, their posterity cursed."
,"13":"Happy the childless wife if she is blameless and has not been guilty of adultery; she will be found fruitful on the day of judgment."
,"14":"And happy the impotent man who has done no evil or harbored resentful thoughts against the Lord. His fidelity will be richly rewarded with a special place in the Lord's heavenly sanctuary."
,"15":"The toil of the righteous bears choice fruit; and wise discernment is a tree that does not wither."
,"16":"But the children born of adultery die young and the offspring of an unlawful union disappear."
,"17":"If they live long, they count for nothing and are finally despised in their old age."
,"18":"If they die young, it is without hope, and they cannot comfort themselves with thinking of the Judgment."
,"19":"Cruel is the fate of an evil race."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Better to have no children and to be virtuous. People like this are highly considered by God and men. The memory of their life will never end."
,"2":"When virtue is present we imitate it; when it is absent we long for it; it is crowned in eternity for having triumphed in the blameless struggle."
,"3":"The numerous progeny of the wicked will be of no use. Offspring of doubtful plants, they will not have deep roots or lay solid foundations."
,"4":"For a time they may produce, but their weak branches shaken by the wind will be uprooted by the storm."
,"5":"Their twigs will be broken off before grown, their fruit useless, unripe for eating and good for nothing."
,"6":"Children born of unlawful intercourse witness, when God examines them, to the wrongdoing of their parents."
,"7":"The upright, even if he dies before his time, will be at rest."
,"8":"Honorable age does not depend on length of days, nor is the number of years a true measure of life."
,"9":"A man's gray hair is understanding, and a spotless life is ripe old age."
,"10":"The upright was pleasing to God, who loved him, and since he was living among sinners, he was taken up."
,"11":"God removed him lest evil impair his understanding and treachery seduce his soul."
,"12":"For the fascination of evil obscures true values and restless desire undermines a simple heart."
,"13":"Though his life soon ended, he traveled far."
,"14":"Because his soul was precious to the Lord, he was quickly removed from the wickedness around him."
,"15":"People saw but did not under-stand, and it did not occur to them that God's grace and mercy are with his chosen ones, his protection is for the holy."
,"16":"The just man who dies will condemn the wicked man who survives. A life fulfilled early in youth condemns the endless days of the wicked."
,"17":"They may see the death of the wise, but they will not understand God's design for him and why he has taken him to safety."
,"18":"They may see and sneer at him, but the Lord will also laugh at them"
,"19":"when they have become a useless corpse, a loathsome and dead thing forever. The Lord will dash them to the ground, voiceless, shaking them from their foundations; they will wither and suffer anguish; even their memory will fade."
,"20":"They will come trembling for the reckoning of their sins and they will be confounded when confronted with their wickedness."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Then the just man will stand with confidence,facing those who oppressed him, making light of his labors."
,"2":"Seeing him they will be seized with a terrible fear, amazed to find him unexpectedly saved. Stricken with remorse,and distress, "
,"3":"they will groan and say,"
,"4":"'He is the one we mocked, the one we reproached, fools that we were!,We considered his life foolishness, and his death, the supreme humiliation,"
,"5":"but see: he is counted among the sons of God,and is given his lot with the holy angels!"
,"6":"How far have we wandered from the truth!,The light of the upright did not enlighten us,nor did its sun rise for us."
,"7":"We trod the paths of injustice and death, traveling, more than enough, through trackless deserts, but we were unable to know the Lord's ways."
,"8":"What good has our pride been?,What profit in the wealth we boasted about?"
,"9":"All that has passed away like a shadow, like a fleeting rumor."
,"10":"Like a ship cutting the sea, leaving no trace of its course, and the mark of its keel - not seen in its wake;"
,"11":"like a bird flying across the sky,leaving no trace of its flight; it beats the light air with its pinions, cleaving a way by the force of its wings,but without a sign of its passing;"
,"12":"or like an arrow shot at a target, with the displaced air closing in on itself,and no one knowing what way it passed."
,"13":"It is the same for us; scarcely born we have disappeared. What sign of virtue are we able to show, spent as we are in our own wickedness?'"
,"14":"The hope of the godless is like chaff blown in the wind, like a light frost melted in the storm, like smoke dispersed by the wind; it fades like the memory of a guest of a single day."
,"15":"But the upright live forever, their reward is with the Lord, and the Most High has them in his care."
,"16":"This is why they receive, from the hands of the Lord, a royal crown, a splendid diadem. He will shelter them with his hand,and his arm will be their shield."
,"17":"God's jealous love will display his weapon; he will arm all creation to punish his enemies."
,"18":"He will put on justice as his breastplate,and right judgment as his helmet,"
,"19":"invincible holiness will be his shield,"
,"20":"implacable anger his sword, and the universe will march with him against the foolish."
,"21":"Well-aimed bolts of lightning will strike the target; the clouds will be a curved bow shooting arrows."
,"22":"The hailstones of his fury will rain on them, the ocean will rage against them and the rivers engulf them without mercy."
,"23":"A powerful wind will rise against them and blow them away like straw. In this way lawlessness will bring the whole earth to ruin, and evildoing topple the thrones of the mighty."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Listen, O kings, and understand; rulers of the most distant lands, take warning."
,"2":"Pay attention, you who rule multitudes and boast of the numerous subjects in your pagan nations."
,"3":"For authority was given you by the Lord, your kingship is from the Most High who will examine your works and scrutinize your intentions."
,"4":"If, as officials of his kingdom, you have not judged justly or observed his law or walked the way God pointed out,"
,"5":"he will oppose you swiftly and terribly; his sentence strikes the mighty suddenly."
,"6":"For the lowly there may be excuses and pardon, but the great will be severely punished."
,"7":"For the Lord of all makes no distinction, nor does he take account of greatness. Both great and lowly are his work and he watches over all,"
,"8":"but the powerful are to be judged more strictly."
,"9":"It is to you then, sovereigns, that I speak, that you may learn Wisdom and not stumble."
,"10":"For those who keep the holy laws in a holy way will be acknowledged holy, and those who accept the teaching will find in it their defense."
,"11":"Welcome my words, desire them and they will instruct you."
,"12":"Wisdom is luminous and never tarnished; she willingly lets herself be seen by those who love her, and known by those who look for her."
,"13":"She hastens to meet those who long for her."
,"14":"Seek her in the morning and you will not be disappointed; you will find her sitting at your door."
,"15":"To meditate on Wisdom is understanding fully grown; whoever is on the watch for her will be free of anxiety."
,"16":"She goes in search of those who are worthy of her, graciously meets them on the way and is present in their every thought."
,"17":"The beginning of Wisdom is a sincere desire for discipline; concern for discipline is love of her,"
,"18":"and loving her means keeping her laws;"
,"19":"the observance of her laws assures one of immortality, and immortality brings us close to God."
,"20":"In this way the desire for Wisdom leads to kingship."
,"21":"So then, sovereigns of nations, you who are fond of thrones and scepters, honor Wisdom if you wish to reign forever."
,"22":"What Wisdom is and how she came to be, I will tell you. I shall hide nothing from you, but trace her from the beginning and clearly make her known."
,"23":"I will not mislead you and hide the truth, for I am free of gnawing envy which has nothing in common with Wisdom."
,"24":"A great number of wise men could bring about the salvation of the world and a sensible king makes for the stability of his people;"
,"25":"so learn from what I say and profit from it."
}`)
	CurrentBook.AddChapter(7, `{
"1":"I, too, am a mortal man,like others, a descendant of the first human being formed from clay. My flesh was molded in a mother's womb; "
,"2":"her blood formed me for ten months from the seed of man, given in pleasure, the companion of sleep."
,"3":"Once born, I breathed the air common to everyone; I fell on the earth, the same for all; my first cry was like that of other infants."
,"4":"I was nourished, cared for and wrapped in swaddling clothes;"
,"5":"indeed, no other king began life differently."
,"6":"For there is but one way into life for all and one way out of it."
,"7":"I prayed and understanding was given to me; I asked earnestly and the spirit of Wisdom came to me."
,"8":"I preferred her to scepters and thrones and I considered wealth as nothing compared with her."
,"9":"I preferred her to any jewel of inestimable value, since gold beside her is nothing but a few grains of sand, and silver but mud."
,"10":"I loved her more than wealth and beauty and even preferred her to light, because her radiance never dies."
,"11":"She brought with her all other good things, untold riches in her hands."
,"12":"I rejoiced at all that came with Wisdom without knowing she was their mother."
,"13":"What I learned without self-interest I share freely and with no desire to conceal her value;"
,"14":"for she is an inexhaustible treasure for man and those who possess her have gained the friendship of God, commended to him by the fruits of her discipline."
,"15":"May God grant me to speak with discernment and reflect in a way worthy of the gifts I have received, for he is the guide of Wisdom and directs wise men."
,"16":"For we are in God's hands, we ourselves, our words, our understanding and technical knowledge."
,"17":"He, in fact, has given me true knowledge of what is, of the world and the properties of the elements;"
,"18":"the beginning, the end and the times in between; the alternation of the solstices and the succession of the seasons;"
,"19":"the cycles of the year and the position of the stars;"
,"20":"the natures of animal species and the ways of wild beasts; the power of spirits and human reasoning; the varieties of plants and medicinal properties of roots."
,"21":"I have come to know everything we see and everything hidden,"
,"22":"because Wisdom, who designed them all, taught me. In her is a spirit that is intelligent, saintly, unique, manifold, subtle, active, concise, pure and lucid. It cannot corrupt, loves what is good and nothing can restrain it; "
,"23":"it is beneficent, loving humankind, steadfast, dependable, calm though almighty. It sees everything and penetrates all spirits, however intelligent, subtle and pure they may be."
,"24":"Wisdom, in fact, surpasses in mobility all that moves, and being so pure pervades and permeates all things."
,"25":"She is a breath of the power of God, a pure emanation of the glory of the Almighty; nothing impure can enter her."
,"26":"She is a reflection of eternal light, a spotless mirror of God's action and an image of his goodness."
,"27":"She is but one, yet Wisdom can do all things and, herself unchanging, she renews all things. She enters holy souls, making them prophets and friends of God,"
,"28":"for God loves only those who live with Wisdom."
,"29":"She is indeed more beautiful than the sun and surpasses all the constellations; she outrivals light,"
,"30":"for light gives way to night, but evil cannot prevail against Wisdom."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Wisdom displays her strength from one end of the earth to the other, ordering all things rightly."
,"2":"I loved her and sought her from my youth; I strove to have her as my bride for I had fallen in love with her beauty."
,"3":"Her nearness to God tells of her noble birth. Because the Lord of all has loved her,"
,"4":"she is instructed in God's knowledge and chooses his works."
,"5":"If we desire riches in life, what is richer than Wisdom who is the active cause of everything?"
,"6":"If the intellect shows itself in action, still more does she who fashions everything."
,"7":"If you love righteousness, every virtue is the fruit of her labor, for she teaches temperance, prudence, justice, fortitude - all that is most valuable in life."
,"8":"If someone is eager for experience, she knows what took place in the past and forecasts the future. She has the art of interpretation and knows how to solve riddles, she foresees signs and wonders, the end of ages and eras."
,"9":"This is why I decided to have her as companion for life, knowing she would be a wise counselor and encourage me in times of worry and distress."
,"10":"I thought: With her I shall have glory among the nations and, although young, honor among the elderly;"
,"11":"I shall be found penetrating in judgment and be admired by the powerful."
,"12":"If I am silent they will wait to hear me; if I speak, they will pay attention; though I speak at length they will put their hand on their lips."
,"13":"Thanks to her I shall win immortality, and to those who come after me I shall leave an everlasting memory."
,"14":"I shall govern peoples, and nations will be subject to me."
,"15":"Terrible sovereigns will cower when they hear of my name, but to my people I shall show myself kind; in battle, courageous."
,"16":"When I come home I shall take my rest with her, for there is nothing bitter in her company and no suffering in sharing life with her, only pleasure and joy."
,"17":"Pondering over all this, I understood that I would achieve immortality by being united to Wisdom;"
,"18":"I would have pure delight through friendship with her, inexhaustible riches in what she does, understanding from being in her company and renown from sharing her conversation. Then I set out to seek and possess her."
,"19":"I had a pleasant personality even as a child and"
,"20":"was good-natured or rather, being good, I had entered an undefiled body."
,"21":"But knowing that I could only possess Wisdom if she were given me by God - it was a mark of intelligence to know who was the donor - I turned to the Lord and implored him, saying with all my heart:"
}`)
	CurrentBook.AddChapter(9, `{
"1":"God of our fathers and Lord of mercy, whose word has created everything and"
,"2":"who in Wisdom formed man to govern your creation,"
,"3":"to rule the world in holiness and justice, passing sentence with right judgment,"
,"4":"give me Wisdom that sits beside your throne and do not reject me from among your children."
,"5":"For I am your servant, son of your handmaid, a weak and mortal man with little understanding of judgment and laws."
,"6":"Even the most perfect among the sons of men counts for nothing, unless he has received Wisdom that comes from you."
,"7":"You have chosen me as king for your people, as judge over your sons and daughters."
,"8":"You have ordered me to build a temple on your holy mountain and an altar in the city where you live, in imitation of the holy Tent that was yours from the beginning."
,"9":"With you is Wisdom that knows your works, that was present when you made the world and is aware of what is pleasing in your eyes and what is right according to your commandments."
,"10":"Send her from the holy heavens, dispatch her from your holy throne to work beside me so that I may know what is pleasing to you."
,"11":"For she knows and understands everything; she will direct my actions with prudence and protect me with her power."
,"12":"Then my deeds will please you, and I shall judge your people in justice and be worthy of the throne of my father."
,"13":"Indeed, what man can know the intentions of God? Who can discern the plan of the Lord?"
,"14":"For human reasoning is timid, our notions misleading;"
,"15":"a perishable body is a burden for the soul and our tent of clay weighs down the active mind."
,"16":"We are barely able to know about the things of earth and it is a struggle to understand what is close to us; who then may hope to understand heavenly things?"
,"17":"Who has ever known your will unless you first gave him Wisdom and sent down your holy spirit to him?"
,"18":"In this way you directed the human race on the right path; they learned what pleases you and were saved by Wisdom."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Wisdom protected the father of the world, the first man to be formed, who was created alone."
,"2":"She delivered him from his fault and gave him power to govern all things."
,"3":"When a violent man turning in anger strayed from Wisdom, he perished in his fratricidal fury."
,"4":"Because of the violent, the earth was submerged by the flood, but Wisdom again saved it by piloting an upright man on a frail piece of wood."
,"5":"Again when the nations, united in evil, had been thrown into confusion, it was Wisdom who singled out a righteous man, keeping him blameless before God and steadfast, despite his pity for his child."
,"6":"It was she who, when the godless perished, saved the righteous man and let him flee from the fire pouring down on the Five Cities."
,"7":"To this day the arid land, a smoking waste, witnesses to their perversity, for plants there bear unripe fruit and a pillar of salt stands as a monument to an unbelieving woman."
,"8":"For having ignored Wisdom, not only were they kept from knowing what is good, but their ruins were left as a monument to their foolishness so that their failure might never be forgotten."
,"9":"But Wisdom rescued her servants from their trials."
,"10":"Along straight paths she led the upright man who fled from his brother's anger. She showed him God's kingdom and let him know the holy angels; she made him prosperous and successful in his toil."
,"11":"Wisdom stood by him against the greed of oppressors and made him rich."
,"12":"She protected him from his enemies and saved him from the traps they set for him; with Wisdom he triumphed in an arduous struggle, learning in this way that nothing is as strong as piety."
,"13":"She did not abandon the righteous man when he was sold; still more she kept him free from sin."
,"14":"She went down into the cistern with him; she did not leave him in chains, but made him the ruler of a kingdom, giving him authority over his oppressors. She denounced as liars those who accused him falsely and gave him everlasting honor."
,"15":"It was she who rescued an innocent and holy people from a nation of oppressors."
,"16":"She entered the soul of God's servant and through him withstood terrible kings with signs and wonders."
,"17":"To the holy people she gave the wages of their labor, leading them in a wonderful way, giving them shade during the day and the light of the stars at night."
,"18":"She brought them across the Red Sea, but drowned their enemies"
,"19":"and later washed them ashore from the depth of the abyss."
,"20":"So the righteous looted the godless, singing hymns, Lord, to your holy Name, and one in heart, they gave thanks for your saving hand."
,"21":"Wisdom gives speech to the dumb and makes infants speak clearly."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Wisdom gave success to their actions through a holy prophet;"
,"2":"they crossed an uninhabited wilderness and pitched camp in inaccessible places."
,"3":"They stood up to their enemies and fought off the hostile."
,"4":"When they were thirsty they called on you and you gave them water from hard flint, from a rocky cliff, a welcome relief for the parched."
,"5":"The same creatures you used to punish their enemies were of benefit to them in their trouble."
,"6":"For their enemies an ever-flowing source of river water was polluted with blood -"
,"7":"a stern response to the decree ordering the slaughter of infants. But, against all hope, you gave your people water in abundance,"
,"8":"showing them by the thirst they suffered, how you had punished their enemies."
,"9":"Their trials were no more than merciful reproofs. Through them, your people learned how severely the wicked were judged and punished."
,"10":"You tested them as does a father, while you examined their enemies like a stern king."
,"11":"Their enemies suffered at the time and also later."
,"12":"When they remembered the past, theirs was a double grief and groaning."
,"13":"They came to see that it was the work of the Lord when they realized that their punishment had benefited the others."
,"14":"Long before, they had exposed Moses; they had rejected him in derision; but now they admired him because of what had happened, and after they had suffered a thirst far different from that of the righteous."
,"15":"Their wickedness and foolish ideas led them astray, even to worshiping snakes and other repugnant animals; this is why you sent them hordes of similar creatures,"
,"16":"teaching them that punishment takes the same form as the sin."
,"17":"In fact, your almighty power that created the world from formless matter did not lack means to unleash upon them bears and savage lions,"
,"18":"or monsters freshly created, unknown and full of fury, breathing fire or noisily spitting smoke or flashing fearful sparks from their eyes,"
,"19":"creatures not only capable of destroying them at a single blow but whose mere appearance could make them die of fright."
,"20":"Even without this, they could have dropped dead at a single breath if pursued by your justice, or dispersed by the breath of your might; but you ordered all with measure, number and weight."
,"21":"You are able to show your power at any moment and who can resist the strength of your arm?"
,"22":"For the entire world lies before you, just enough to tip the scales, a drop of morning dew falling on the ground."
,"23":"But because you are almighty, you are merciful to all; you overlook sins and give your children time to repent."
,"24":"You love everything that exists and hate nothing that you have made; had you hated anything, you would not have formed it."
,"25":"How could anything endure if you did not will it? And how could anything last that you had not willed?"
,"26":"You have compassion on all because all is yours, O Lord, lover of life."
}`)
	CurrentBook.AddChapter(12, `{
"1":"In fact your immortal spirit is in all."
,"2":"And so by degrees you correct those who sin, you admonish them, reminding them how they have strayed so that turning away from evil they may trust in you, Lord."
,"3":"So it happened with those who once lived in your holy land."
,"4":"You hated them because of their detestable practices, their sorcery and unholy worship."
,"5":"They were used to the pitiless slaughter of children at the feasts in which they ate human flesh and blood and even bowels, while they fulfilled secret rituals."
,"6":"Because these parents murdered their defenseless children, you wished our ancestors to destroy them,"
,"7":"and the land dearest to you became the home of God's children who were worthy of it."
,"8":"But you even showed mercy to these sinners because they were human beings. You sent hornets ahead of your army to gradually destroy them."
,"9":"You could have given the wicked over to the righteous in battle, or destroyed them in one blow by means of savage beasts or with a harsh command;"
,"10":"but in punishng them gradually you gave them time to repent. Nevertheless you were aware of their evil nature, their innate malice and how fixed they were in their ways,"
,"11":"for it was a cursed race from the beginning. In any case, it was not through fear of anyone that you left their sins unpunished. "
,"12":"For who dares say to you, 'What have you done?' Who would dare to reject your sentence? Who could reproach you for destroying the nations you formed? Who would dare rise against you in defense of the guilty?"
,"13":"For there is no other god besides you, one who cares for everyone, who could ask you to justify your judgments;"
,"14":"there is no other king or sovereign who could confront you and support those you punish."
,"15":"You are just and you rule all with justice; had you condemned those who should not be punished, you would have misused your power."
,"16":"Your strength is the source of your justice and because you are the Lord of all, you can be merciful to everyone."
,"17":"To those who doubt your sovereign power you show your strength and you confound the insolence of those who ignore it."
,"18":"But you, the Lord of strength, judge with prudence and govern us with great patience, because you are able to do anything at the time you want."
,"19":"In this way you have taught your people that a righteous person must love his human fellows; you have also given your people cause for hope by prompting them to repent of their sin."
,"20":"For if you have been careful and patient in punishing the enemies of your people when they deserved to die, and have given them a time and a place to turn from their wickedness,"
,"21":"with what strict attention have you not judged your people, you who bound yourself to our fathers with oaths and covenants full of magnificent promises."
,"22":"Yes, you punish us, but you punish our enemies far more severely to teach us when we judge others to remember your kindness, and when we are judged to count on your mercy."
,"23":"Those who lived foolishly and wickedly, you tormented with their own abominations."
,"24":"For they had strayed into error to the point of,choosing vile and disgusting animals as gods, allowing themselves to be deceived like infants."
,"25":"And, as to children with no sense, you sent them a punishment to mock them;"
,"26":"but if they took no warning from these corrections, they were soon to receive a punishment worthy of God."
,"27":"In their suffering they became indignant at those animals they had taken as gods and who were now used to punish them. Then they saw clearly, and acknowledged as God, him whom before they had refused to know. That is why they suffered the supreme punishment."
}`)
	CurrentBook.AddChapter(13, `{
"1":"The natural helplessness of men is seen in their ignorance of God. The experience of good things did not lead them to the knowledge of Him who is. They were interested in his works, but they did not recognize the author of them."
,"2":"Fire, wind, air, the sphere of the stars, rushing water and the lights in the sky were held as the rulers of the world."
,"3":"If, charmed by such beauty, they took them for gods, let them know how far superior is their sovereign."
,"4":"And if they were impressed by their power and,activity, let them understand from this how much mightier is he who formed them. "
,"5":"For the grandeur and beauty of creatures lead us to ponder on their Author, greater and more magnificent."
,"6":"No doubt these men are not to be blamed severely, for possibly they strayed though they searched for God and desired to find him."
,"7":"They pondered over the created things that surrounded them and were captivated by the sight of such beauty."
,"8":"Even so they are not to be excused,"
,"9":"for if they were able to explore the world, why did they not discover first the world's Sovereign?"
,"10":"But unhappy, indeed, are those people who give to man-made artifacts the title of gods! Cursed is their hope in dead things, objects worked in gold and silver, likenesses of animals, and even useless stones carved long ago!"
,"11":"Take a woodcutter - he fells a tree that is easy to move, expertly strips off all the bark and with the wood makes a utensil needed in daily life;"
,"12":"he uses the bits left over as fuel for cooking his food and he has a good meal."
,"13":"Then he picks up an utterly useless left-over piece, all gnarled and knotted, and carves it in his leisure time, using his professional skill to give it the shape of a man or"
,"14":"maybe of a worthless animal. He covers it with ochre and paints the surface red, covering all its blemishes."
,"15":"He then makes a suitable niche for it in the wall and fastens it in place with iron nails."
,"16":"The craftsman is careful to keep it from falling, knowing that it is unable to help itself. It needs help because it is no more than an image."
,"17":"Even so, when it is a matter of his marriage, his children and his household, the man is not ashamed to pray to this lifeless object. He prays for his health to something without strength;"
,"18":"for life he prays to what is dead, for help he implores something insensitive, for a successful journey he has recourse to what cannot walk,"
,"19":"for his profit, his concerns and success in his craft he asks help of something that has no skill whatever in its hands."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Imagine someone who is about to set sail and cross the raging sea. He calls upon a piece of wood far more fragile than the boat that carries him."
,"2":"In fact, this boat has been built with gain in mind and proceeds from the wisdom of the shipwright."
,"3":"But it is your providence, Father, that guides it, for you are the one who prepares a path through the sea and a safe way over the waves."
,"4":"By this we understand that you are able to save us from any danger, and even the unskilled are able to sail."
,"5":"People are the work of your wisdom and you do not want them to remain idle. So they trust their lives to a small plank of wood and cross the sea safe and sound on a raft."
,"6":"At the beginning of time when proud giants perished, the hope of the world took refuge on a raft and, led by your hand, left to the world the seed of a new race."
,"7":"Blessed be the wood by which salvation was carried out!"
,"8":"But cursed be the idol and its maker, the idol made by human hands, this corruptible thing that is called a god, and the craftsman for having fashioned it."
,"9":"They are hateful to God, both the godless and the fruit of his godlessness;"
,"10":"the maker will be punished together with his work."
,"11":"Therefore the idols of the nations will also be judged. They have come to be the most abominable among the creatures of God. They are a stumbling block to the spirit of man, and the feet of the foolish are caught in the snare."
,"12":"The invention of idols was the origin of licentiousness; when they were invented, life became corrupt."
,"13":"For in the beginning they did not exist and they will not exist forever."
,"14":"Human vanity introduced them into the world, and God has set a term for them."
,"15":"Suppose a father, overwhelmed by grief for a child so swiftly taken from him, has an image made of him. From that time on a dead creature will be honored as a god, because the father handed on to his dependents secret rites and celebrations."
,"16":"Time will consolidate this unholy practice and eventually it will be observed by law. It has also happened that sculptured images were venerated by order of sovereigns. "
,"17":"Those who lived far away and were unable to honor them personally had copies made, that they might honor them as if present by means of their image."
,"18":"The ambition of the artist helped the veneration grow among those who did not even know the sovereign."
,"19":"As he wished to please his master, he made the portrait more attractive than reality,"
,"20":"and the people, seduced by the perfection of art work, began to worship someone previously honored as a man."
,"21":"In this way the image became a pitfall for the living, for people bent down, either by misfortune or tyranny, gave to stones and wood the incommunicable Name."
,"22":"But it was not enough for them to err in their knowledge of God; in the great trouble to which ignorance condemned them, they have called such an evil situation peace."
,"23":"With the sacrificial murder of children in their initiations, with secret mysteries and wild ceremonial orgies,"
,"24":"they no longer keep their lives and marriages pure; they treacherously murder one another or wound others through adultery."
,"25":"Everywhere it is a welter of blood, murder, fraud and theft, corruption, treachery, riots, perjury;"
,"26":"on all sides harassment of good people, forgetfulness of favors, the pollution of souls and sins against nature, widespread disorder in marriage, adultery, debauchery."
,"27":"Indeed the worship of gods which do not even deserve a name, is the beginning, cause and effect of every evil."
,"28":"Others delight in raving or uttering false prophecies; they live wickedly and casually perjure themselves."
,"29":"As they deal with lifeless images, they do not fear any punishment for their false oaths,"
,"30":"but a double punishment awaits them: as idolators for their base concept of God, as frauds for taking false oaths in defiance of all that is holy."
,"31":"Though the idols by which they swore are powerless, justice that pursues sinners always overtakes the sin of the wicked."
}`)
	CurrentBook.AddChapter(15, `{
"1":"But you, our God, are kind and true; you bear evil patiently and order everything with mercy."
,"2":"Even when we sin we belong to you and acknowledge your power, but aware that we belong to you, we shall not sin."
,"3":"To know you is perfect righteousness and to acknowledge your power is the root of immortality."
,"4":"So we have not been led astray by a deceptive invention of men - the sterile labor of painters - these idols daubed with colors,"
,"5":"the sight of which stirs yearning in fools attached to the lifeless face of a dead image."
,"6":"Really, idol-makers and those who serve and worship them are looking for disgrace and deserve to have false hope."
,"7":"The potter, laboriously working the soft clay, fashions each object for our use, and from the same clay he shapes vessels, some for food, and others for what is thrown away. The potter makes vessels for both clean and unclean uses and decides to what purpose each one is shaped."
,"8":"The same way and from the same clay he fashions a helpless god; cursed labor of a man recently formed from clay, who will shortly return to clay when he is called to give up his soul."
,"9":"He has no thought of dying soon, no thought of the short duration of life. None at all. He competes with those who work on silver and gold and, like the smith, he feels proud to make a counterfeit of God."
,"10":"Ashes, that is what his heart is; his hope cheaper than dust;"
,"11":"his life worth as much as clay, for he has not acknowledged his Maker, who has breathed into him an active soul, a living spirit."
,"12":"He looks on life as a game and its duration a market full of bargains, for as he says, 'a man must make the most of life whether by fair means or foul.'"
,"13":"This man, more than others, knows that he sins in fashioning with the same clay, vessels and sculptured gods."
,"14":"But utterly foolish and more pitiable than the soul of a newborn infant were the enemies that oppressed your people."
,"15":"They received as gods all the idols of the nations - idols that have no eyes to see, no nostrils to breathe the air, no ears to hear, no fingers to feel with, or feet that are able to walk. For these gods are the work of a man, a creature of borrowed breath made them."
,"16":"Man cannot even make a god that resembles himself;"
,"17":"a mortal's unholy hands produce a dead god. He is, in fact, superior to what he worships, since he at least lives, but they will never live."
,"18":"People worship the most repulsive animals, the most stupid of all who, unlike other animals, are devoid of beauty;"
,"19":"these are unattractive creatures who have missed the blessing of God and are not fit to give him praise."
}`)
	CurrentBook.AddChapter(16, `{
"1":"That is why this people received the punishment they deserved through similar animals and hordes of tormenting insects."
,"2":"But in contrast to this punishment it was kindness you showed to your people by providing quails - a delicious food - for them."
,"3":"As for the Egyptians, in spite of their fierce hunger, they were restrained by disgust from eating because of the repulsive sight of the creatures sent against them. But the Israelites after being deprived for a time were then given the finest food."
,"4":"It was necessary for their oppressors to suffer severe want, but enough for your people to know how the enemy was punished."
,"5":"Indeed when they experienced the fury of wild animals and the bites of writhing snakes, your anger did not endure."
,"6":"Their temporary affliction served as a warning; then they were given a sign of salvation to remind them of the prescriptions of your law."
,"7":"For whoever turned towards it was saved, not by the image he saw, but by you, Lord, the Savior of all."
,"8":"In that way you taught our enemies that it is you who deliver us from every evil."
,"9":"They were, in fact, killed by the sting of insects and flies for which there was no cure since they deserved punishment from these creatures."
,"10":"Your children instead were not overcome, even by the fangs of venomous serpents, for your mercy intervened and healed them."
,"11":"Bites quickly healed reminded them of your commands, lest they fall into deep oblivion and forget your kindness."
,"12":"No herb, no ointment healed them but your word, Lord, that heals all."
,"13":"You are Lord of life and death; you bring down to the gate of the netherworld and bring back again."
,"14":"Man in his wickedness is able to kill but he cannot bring back the departed spirit or rescue the snatched soul."
,"15":"It is impossible to escape your hand."
,"16":"The godless, refusing to acknowledge you, were scourged by the strength of your arm, lashed by relentless downpours, hail, and pitiless storms, and consumed by fire."
,"17":"But this was the most astounding: water, powerful to quench, made fire burn more fiercely. For the elements fight on the side of the righteous."
,"18":"At times the flame abated to spare the insects thrust against the wicked, that they might know they were pursued by God's sentence."
,"19":"At other times, in the midst of water the flame rose more fiercely than fire to destroy the harvest of an unholy land."
,"20":"But to your people you gave the food of angels and from heaven sent bread already prepared and suiting all tastes, having every flavor."
,"21":"In this way you revealed your loving kindness to your children."
,"22":"Satisfying all needs, this bread provided what each one wanted. That food, having the appearance of snow and ice, resisted fire and did not melt; thus they understood how their enemy's harvest was destroyed by fire in the midst of hail, while lightning flashed in the falling rain. "
,"23":"This same fire seemed to forget its own nature in order to spare the food of the righteous."
,"24":"Your creation is at your service for you are its Author. It works to punish the wicked and withdraws for the benefit of those who put their trust in you."
,"25":"In the service of your bounty which attends to everything, creation made itself manifold and adjusted to the wish of everyone."
,"26":"Then the children you love learned that it is not crops of whatever kind which nourish mankind, but your word that sustains those who trust you."
,"27":"That food which resisted fire, simply melted in the warmth of a fleeting sunbeam,"
,"28":"teaching us that we must rise before the sun to give thanks and pray to you at dawn."
,"29":"The hope of the ungrateful will melt like winter frost and flow away like water that is not being used."
}`)
	CurrentBook.AddChapter(17, `{
"1":"How great are your purposes and how difficult to explain! People who have not learned about them have gone astray."
,"2":"While the godless thought they had the holy nation in their power, they themselves were prisoners, captives of a long night, shut in under their own roofs, banished from eternal providence."
,"3":"Although they counted on their sins remaining hidden under the veil of forgetfulness, they were scattered and at the same time dismayed and terrified by visions."
,"4":"The dark places where they sheltered could not protect them from fear, they heard horrific noises and were confronted with ghastly and mournful apparitions."
,"5":"No fire could give them light, while the sparkling radiance of the stars dared not shine on that horrible night."
,"6":"All that shone for them was an inextinguishable and terrifying fire and, in their terror, when this vision ended, they imagined their situation to be worse than it was."
,"7":"Their magic arts failed and their pretence to intelligence was utterly confounded;"
,"8":"those who claimed to eliminate the fear and disturbance of the sick mind were themselves afflicted with a ridiculous fear."
,"9":"Although there was nothing to cause this fear, they were terrified by the buzz of insects and the hiss of snakes;"
,"10":"they died convulsed with fear, refusing to look even at the air from which no one may escape."
,"11":"Wickedness is cowardly and is condemned by itself; pursued by conscience it always assumes the worst."
,"12":"For fear is no more than giving up the help that reason is able to give."
,"13":"Inasmuch as this help is lacking interiorly, the unknown cause of one's torments seems greater."
,"14":"So all that night, a night issued from the powerless netherworld that took hold of them while they slept and made everyone powerless,"
,"15":"they were either pursued by monstrous ghosts or paralyzed by a sudden, unexpected fear."
,"16":"Whoever had fallen lay there, shut in a prison not made of iron."
,"17":"Whether plowman or shepherd or someone working by himself, he had to submit to an inevitable fate;"
,"18":"all were bound by the same chain of darkness. Everything held them paralyzed by fear: the sighing of the wind and the tuneful song of the birds in spreading branches, the continuous noise of rushing water "
,"19":"and the terrible crash of falling rocks, the swift, invisible bounding of animals and the terrifying roar of wild beasts, the echo rebounding from the mountains - all was a cause of fear."
,"20":"The whole world shone in brilliant light and continued its work without hindrance;"
,"21":"they alone were covered in the darkness of night, the image of night that would be their lot. But even heavier than the darkness was the burden they were for themselves."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Meanwhile, for your holy ones there was great light. The Egyptians heard their voice without seeing them; they called them fortunate because they had not suffered;"
,"2":"they also thanked them, for in spite of the injustice done to them they had not retaliated, and asked their pardon for previous wrongs."
,"3":"In contrast to this darkness, you gave your holy people a pillar of fire as a guide in their unmapped journey, as a mild sun during their glorious migration."
,"4":"The enemy deserved to be without light and imprisoned in darkness for having imprisoned your sons, the people through whom the imperishable light of your laws would be given to the world."
,"5":"They had intended to kill the infants of your holy people - and of those exposed only one child was saved. Because of that you retaliated by doing away with a multitude of their sons who perished together in the raging sea."
,"6":"That night had been foretold to our fathers, and knowing in what promise they trusted, they could rejoice in all surety."
,"7":"Your people waited for both the salvation of the just and the downfall of their enemies,"
,"8":"for the very punishment of our enemies brought glory to the people you have called - that is, to us."
,"9":"The holy race secretly offered the Passover sacrifice and really agreed on this worthy pact: that they would share alike both blessings and dangers. And forthwith they began to sing the hymns of their fathers."
,"10":"Then came discordant echoes from their enemies: plaintive voices mourning their children."
,"11":"The same sentence struck slave and master alike; the common man and the king endured equal suffering."
,"12":"They mourned together for innumerable victims, all stricken with the same kind of death. The living were not enough to bury them, for the flower of their race had perished in an instant."
,"13":"Although sorcery had turned them into unbelievers, after the death of their firstborn they acknowledged that your people were the children of God."
,"14":"While all was in quiet silence and the night was in the middle of its course,"
,"15":"your almighty Word leapt down from the Royal Throne - a stern warrior to a doomed world."
,"16":"Carrying your fearful command like a sharpened sword and stretching from heaven to earth, he filled the universe with death."
,"17":"Immediately they were overwhelmed with terrible dreams and hallucinations and assailed by sudden fears."
,"18":"Thrown half-dead, some here and some there, they made known why they were dying,"
,"19":"for the dreams that had troubled them had also instructed them, lest they perish without knowing the reason for their misfortune."
,"20":"Indeed the righteous, too, experienced death when a scourge struck a great number of them in the desert, but God's anger was short-lived."
,"21":"A blameless man hastened to their defense. Using the weapons of his sacred office - prayer and atonement incense - he confronted the divine Wrath, putting an end to their affliction, and was thus recognized as your servant."
,"22":"He vanquished your Wrath, but not by physical strength or by the force of arms. He won over the Punisher by reminding him of the sworn promises and covenants made with our fathers."
,"23":"The dead were already piled up, one on top of the other, when he intervened, beating back Wrath and cutting it off from the living."
,"24":"For the whole world was represented on his flowing robe, the glorious names of the fathers on the four rows of stones, and your majesty engraved on the diadem on his head."
,"25":"The Destroyer, afraid of these, recoiled; a mere taste of Wrath had been sufficient."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Instead, a pitiless fury raged against the wicked to the very end, for God knew beforehand what they would do:"
,"2":"that after allowing them to leave and hastening their departure, they would then pursue them."
,"3":"While the Egyptians were still mourning at the graves of their dead, they had the mad idea of pursuing them as fugitives."
,"4":"A well-deserved fate drove them to this extreme, making them forget what had happened and completing their punishment with further torment."
,"5":"While your people would experience a miraculous journey, their oppressors would suffer an extraordinary death."
,"6":"All creation in its different forms was fashioned anew at your command, in order to protect your people."
,"7":"The cloud covered the camp with its shadow, dry land emerged where water had been. A safe passage was opened through the Red Sea, the tempestuous flood became a green plain"
,"8":"where the whole nation of those protected by your hand passed across, witnessing your astounding deeds."
,"9":"They were like horses led to pasture, or like frolicking lambs, praising you, their Lord, who had delivered them."
,"10":"For they still remembered what they had seen in their exile: how the earth, in place of animals, had produced mosquitoes, and rivers, instead of providing fish, produced frogs."
,"11":"Later your people were to see a new way for birds to appear, for when they hungered for food,"
,"12":"quails came out of the sea to satisfy their need."
,"13":"Punishment befell the sinners after they had been warned by violent thunder; deservedly they suffered for their own wickedness, for they had given proof of a most cruel hatred towards strangers."
,"14":"Others had not welcomed unknown strangers, but the Egyptians enslaved guests who had been good to them."
,"15":"The former will be condemned for dealing badly with strangers;"
,"16":"worse still, the Egyptians who had welcomed them with celebrations and treated them as equals, but later made them suffer cruelly."
,"17":"For this they were afflicted with blindness like the men of Sodom who came to the door of the righteous man Lot and found themselves in utter darkness, each one groping around to find his own door."
,"18":"The elements interchanged their qualities as on a harp the notes change their tones while retaining their own pitch. Clearly this is what happened as is shown by a scrutiny of events."
,"19":"Creatures living on the land became aquatic and those that swam emerged on dry land."
,"20":"Fire burned more fiercely in water when water ceased to quench."
,"21":"On another occasion flames did not burn frail animals that passed through them nor did they melt the heavenly food that normally would have melted like frost."
,"22":"For in every way, Lord, you have exalted and glorified your people, never disdaining them, but standing by them always and everywhere."
}`)

}
