package bibles

func ES_LBL_LoadInfo(CurrentBible *Bible) {
	CurrentBible.SetInfo("es.lbl", "La Biblia Latinoamericana")
	CurrentBible.AddBook("VPGN", "Génesis")
	CurrentBible.AddBook("VPEX", "Éxodo")
	CurrentBible.AddBook("VPLV", "Levítico")
	CurrentBible.AddBook("VPNM", "Números")
	CurrentBible.AddBook("VPDT", "Deuteronomio")
	CurrentBible.AddBook("VHIE", "Josué")
	CurrentBible.AddBook("VHID", "Jueces")
	CurrentBible.AddBook("VH1S", "1 Samuel")
	CurrentBible.AddBook("VH2S", "2 Samuel")
	CurrentBible.AddBook("VH1R", "1 Reyes")
	CurrentBible.AddBook("VH2R", "2 Reyes")
	CurrentBible.AddBook("VH1P", "1 Crónicas")
	CurrentBible.AddBook("VH2P", "2 Crónicas")
	CurrentBible.AddBook("VHED", "Esdrás")
	CurrentBible.AddBook("VHNH", "Nehemias")
	CurrentBible.AddBook("VH1M", "1 Macabeos")
	CurrentBible.AddBook("VH2M", "2 Macabeos")
	CurrentBible.AddBook("VMIS", "Isaías")
	CurrentBible.AddBook("VMIE", "Jeremías")
	CurrentBible.AddBook("VMEZ", "Ezequiel")
	CurrentBible.AddBook("VNOS", "Oseas")
	CurrentBible.AddBook("VNIL", "Joel")
	CurrentBible.AddBook("VNAM", "Amós")
	CurrentBible.AddBook("VNAB", "Abdías")
	CurrentBible.AddBook("VNIN", "Jonás")
	CurrentBible.AddBook("VNMI", "Miqueas")
	CurrentBible.AddBook("VNNH", "Nahún")
	CurrentBible.AddBook("VNHA", "Habacuc")
	CurrentBible.AddBook("VNSO", "Sofonías")
	CurrentBible.AddBook("VNAG", "Ageo")
	CurrentBible.AddBook("VNZA", "Zacarías")
	CurrentBible.AddBook("VNML", "Malaquías")
	CurrentBible.AddBook("VMDN", "Daniel")
	CurrentBible.AddBook("VSIB", "Job")
	CurrentBible.AddBook("VSPR", "Proverbios")
	CurrentBible.AddBook("VSEE", "Qohélet")
	CurrentBible.AddBook("VSCC", "Cantar")
	CurrentBible.AddBook("VHRT", "Rut")
	CurrentBible.AddBook("VMLM", "Lamentaciones")
	CurrentBible.AddBook("VHET", "Ester")
	CurrentBible.AddBook("VHTB", "Tobías")
	CurrentBible.AddBook("VHIH", "Judit")
	CurrentBible.AddBook("VMBR", "Baruc")
	CurrentBible.AddBook("VSSP", "Sabiduría")
	CurrentBible.AddBook("VSEI", "Sirácida")
	CurrentBible.AddBook("VSPS", "Salmos")
	CurrentBible.AddBook("NEMT", "Mateo")
	CurrentBible.AddBook("NEMC", "Marcos")
	CurrentBible.AddBook("NELC", "Lucas")
	CurrentBible.AddBook("NEIO", "Juan")
	CurrentBible.AddBook("NTAA", "Hechos")
	CurrentBible.AddBook("NPRM", "Romanos")
	CurrentBible.AddBook("NP1C", "1 Corintios")
	CurrentBible.AddBook("NP2C", "2 Corintios")
	CurrentBible.AddBook("NPGA", "Gálatas")
	CurrentBible.AddBook("NPEP", "Efesios")
	CurrentBible.AddBook("NPPP", "Filipenses")
	CurrentBible.AddBook("NPCL", "Colosenses")
	CurrentBible.AddBook("NPPM", "Filemón")
	CurrentBible.AddBook("NP1E", "1 Tesalonicenses")
	CurrentBible.AddBook("NP2E", "2 Tesalonicenses")
	CurrentBible.AddBook("NP1I", "1 Timoteo")
	CurrentBible.AddBook("NP2I", "2 Timoteo")
	CurrentBible.AddBook("NPTT", "Tito")
	CurrentBible.AddBook("NTHB", "Hebreos")
	CurrentBible.AddBook("NCIB", "Santiago")
	CurrentBible.AddBook("NC1P", "1 Pedro")
	CurrentBible.AddBook("NC2P", "2 Pedro")
	CurrentBible.AddBook("NCID", "Judas")
	CurrentBible.AddBook("NC1I", "1 Juan")
	CurrentBible.AddBook("NC2I", "2 Juan")
	CurrentBible.AddBook("NC3I", "3 Juan")
	CurrentBible.AddBook("NTAI", "Apocalipsis")
}

func ES_LBL_LoadBooks(CurrentBible *Bible) {
	for x := range CurrentBible.Codes {
		var cb *Book = NewBook(CurrentBible.Codes[x], CurrentBible.Names[x])
		switch CurrentBible.Codes[x] {
		case "VPGN":
			ES_LBL_LoadVPGNChapters(cb)
		case "VPEX":
			ES_LBL_LoadVPEXChapters(cb)
		case "VPLV":
			ES_LBL_LoadVPLVChapters(cb)
		case "VPNM":
			ES_LBL_LoadVPNMChapters(cb)
		case "VPDT":
			ES_LBL_LoadVPDTChapters(cb)
		case "VHIE":
			ES_LBL_LoadVHIEChapters(cb)
		case "VHID":
			ES_LBL_LoadVHIDChapters(cb)
		case "VH1S":
			ES_LBL_LoadVH1SChapters(cb)
		case "VH2S":
			ES_LBL_LoadVH2SChapters(cb)
		case "VH1R":
			ES_LBL_LoadVH1RChapters(cb)
		case "VH2R":
			ES_LBL_LoadVH2RChapters(cb)
		case "VH1P":
			ES_LBL_LoadVH1PChapters(cb)
		case "VH2P":
			ES_LBL_LoadVH2PChapters(cb)
		case "VHED":
			ES_LBL_LoadVHEDChapters(cb)
		case "VHNH":
			ES_LBL_LoadVHNHChapters(cb)
		case "VH1M":
			ES_LBL_LoadVH1MChapters(cb)
		case "VH2M":
			ES_LBL_LoadVH2MChapters(cb)
		case "VMIS":
			ES_LBL_LoadVMISChapters(cb)
		case "VMIE":
			ES_LBL_LoadVMIEChapters(cb)
		case "VMEZ":
			ES_LBL_LoadVMEZChapters(cb)
		case "VNOS":
			ES_LBL_LoadVNOSChapters(cb)
		case "VNIL":
			ES_LBL_LoadVNILChapters(cb)
		case "VNAM":
			ES_LBL_LoadVNAMChapters(cb)
		case "VNAB":
			ES_LBL_LoadVNABChapters(cb)
		case "VNIN":
			ES_LBL_LoadVNINChapters(cb)
		case "VNMI":
			ES_LBL_LoadVNMIChapters(cb)
		case "VNNH":
			ES_LBL_LoadVNNHChapters(cb)
		case "VNHA":
			ES_LBL_LoadVNHAChapters(cb)
		case "VNSO":
			ES_LBL_LoadVNSOChapters(cb)
		case "VNAG":
			ES_LBL_LoadVNAGChapters(cb)
		case "VNZA":
			ES_LBL_LoadVNZAChapters(cb)
		case "VNML":
			ES_LBL_LoadVNMLChapters(cb)
		case "VMDN":
			ES_LBL_LoadVMDNChapters(cb)
		case "VSIB":
			ES_LBL_LoadVSIBChapters(cb)
		case "VSPR":
			ES_LBL_LoadVSPRChapters(cb)
		case "VSEE":
			ES_LBL_LoadVSEEChapters(cb)
		case "VSCC":
			ES_LBL_LoadVSCCChapters(cb)
		case "VHRT":
			ES_LBL_LoadVHRTChapters(cb)
		case "VMLM":
			ES_LBL_LoadVMLMChapters(cb)
		case "VHET":
			ES_LBL_LoadVHETChapters(cb)
		case "VHTB":
			ES_LBL_LoadVHTBChapters(cb)
		case "VHIH":
			ES_LBL_LoadVHIHChapters(cb)
		case "VMBR":
			ES_LBL_LoadVMBRChapters(cb)
		case "VSSP":
			ES_LBL_LoadVSSPChapters(cb)
		case "VSEI":
			ES_LBL_LoadVSEIChapters(cb)
		case "VSPS":
			ES_LBL_LoadVSPSChapters(cb)
		case "NEMT":
			ES_LBL_LoadNEMTChapters(cb)
		case "NEMC":
			ES_LBL_LoadNEMCChapters(cb)
		case "NELC":
			ES_LBL_LoadNELCChapters(cb)
		case "NEIO":
			ES_LBL_LoadNEIOChapters(cb)
		case "NTAA":
			ES_LBL_LoadNTAAChapters(cb)
		case "NPRM":
			ES_LBL_LoadNPRMChapters(cb)
		case "NP1C":
			ES_LBL_LoadNP1CChapters(cb)
		case "NP2C":
			ES_LBL_LoadNP2CChapters(cb)
		case "NPGA":
			ES_LBL_LoadNPGAChapters(cb)
		case "NPEP":
			ES_LBL_LoadNPEPChapters(cb)
		case "NPPP":
			ES_LBL_LoadNPPPChapters(cb)
		case "NPCL":
			ES_LBL_LoadNPCLChapters(cb)
		case "NPPM":
			ES_LBL_LoadNPPMChapters(cb)
		case "NP1E":
			ES_LBL_LoadNP1EChapters(cb)
		case "NP2E":
			ES_LBL_LoadNP2EChapters(cb)
		case "NP1I":
			ES_LBL_LoadNP1IChapters(cb)
		case "NP2I":
			ES_LBL_LoadNP2IChapters(cb)
		case "NPTT":
			ES_LBL_LoadNPTTChapters(cb)
		case "NTHB":
			ES_LBL_LoadNTHBChapters(cb)
		case "NCIB":
			ES_LBL_LoadNCIBChapters(cb)
		case "NC1P":
			ES_LBL_LoadNC1PChapters(cb)
		case "NC2P":
			ES_LBL_LoadNC2PChapters(cb)
		case "NCID":
			ES_LBL_LoadNCIDChapters(cb)
		case "NC1I":
			ES_LBL_LoadNC1IChapters(cb)
		case "NC2I":
			ES_LBL_LoadNC2IChapters(cb)
		case "NC3I":
			ES_LBL_LoadNC3IChapters(cb)
		case "NTAI":
			ES_LBL_LoadNTAIChapters(cb)
		}
		CurrentBible.Books = append(CurrentBible.Books, *cb)
	}
}

func ES_LBL_LoadNC1IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Aquí tienen lo que era desde el principio, lo que hemos oído, lo que hemos visto con nuestros ojos y palpado con nuestras manos -me refiero a la Palabra que es vida."
,"2":"Porque la vida se dio a conocer, hemos visto la Vida eterna, hablamos de ella y se la anunciamos, aquella que estaba con el Padre y que se nos dio a conocer."
,"3":"Lo que hemos visto y oído se lo anunciamos también a ustedes para que estén en comunión con nosotros, pues nosotros estamos en comunión con el Padre y con su Hijo, Jesucristo."
,"4":"Y les escribimos esto para que sea mayor nuestra alegría."
,"5":"Este es el mensaje que hemos recibido de él y que les anunciamos a ustedes: que Dios es luz y que en él no hay tinieblas."
,"6":"Si decimos que estamos en comunión con él mientras caminamos en tinieblas, somos unos mentirosos y no estamos haciendo la verdad."
,"7":"En cambio, si caminamos en la luz, lo mismo que él está en la luz, estamos en comunión unos con otros, y la sangre de Jesús, el Hijo de Dios, nos purifica de todo pecado."
,"8":"Si decimos que no tenemos pecado, nos estamos engañando a nosotros mismos, y la verdad no está en nosotros."
,"9":"Pero si confesamos nuestros pecados, él, que es fiel y justo, nos perdonará nuestros pecados y nos limpiará de toda maldad."
,"10":"Si dijéramos que no hemos pecado, sería como decir que él miente, y su palabra no estaría en nosotros."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Hijitos míos, les he escrito esto para que no pequen; pero si uno peca, tenemos un defensor ante el Padre, Jesucristo, el Justo."
,"2":"El es la víctima por nuestros pecados, y no sólo por los nuestros, sino por los del mundo entero."
,"3":"Vean cómo sabremos que lo conocemos: si cumplimos sus mandatos."
,"4":"Si alguien dice: 'Yo lo conozco', pero no guarda sus mandatos, ése es un mentiroso y la verdad no está en él."
,"5":"En cambio, si uno guarda su palabra, el auténtico amor de Dios está en él. Y vean cómo conoceremos que estamos en él: "
,"6":"si alguien dice: 'Yo permanezco en él', debe portarse como él se portó."
,"7":"Hijos queridos, no les escribo un mandamiento nuevo, sino el mandamiento antiguo, el que ustedes tenían desde el comienzo; este mandamiento antiguo es la palabra misma que han oído."
,"8":"Y, sin embargo, se lo doy como un mandamiento nuevo, porque es realmente novedad tanto en ustedes como en Jesucristo; ya se van disipando las tinieblas y brilla la luz verdadera."
,"9":"Si alguien piensa que está en la luz mientras odia a su hermano, está aún en las tinieblas."
,"10":"El que ama a su hermano permanece en la luz y no hay en él causas de tropiezo."
,"11":"En cambio, quien odia a su hermano está en las tinieblas y camina en tinieblas; y no sabe adónde va, pues las tinieblas lo han cegado."
,"12":"Esto les escribo, hijitos: ustedes recibieron ya el perdón de sus pecados."
,"13":"Esto les escribo, padres: ustedes conocen al que es desde el principio. Esto les escribo, jóvenes: ustedes han vencido al Maligno."
,"14":"Les he escrito, hijitos, porque ya conocen al Padre. Les he escrito, padres, porque conocen al que es desde el principio. Les he escrito, jóvenes, porque son fuertes, la Palabra de Dios permanece en ustedes y ya han vencido al Maligno."
,"15":"No amen al mundo ni lo que hay en el mundo. Si alguno ama al mundo, el amor del Padre no está en él. "
,"16":"Pues toda la corriente del mundo -la codicia del hombre carnal, los ojos siempre ávidos, y la arrogancia de los ricos- nada viene del Padre, sino del mundo."
,"17":"Pasa el mundo con todas sus codicias, pero el que hace la voluntad de Dios permanece para siempre."
,"18":"Hijitos, es la última hora, y han oído que va a venir un anticristo. Pero ya han venido varios anticristos, por lo cual conocemos que es la última hora."
,"19":"Esa gente salió de entre nosotros, pero no eran de los nuestros; si hubieran sido de los nuestros, se habrían quedado con nosotros. Así es como descubrimos que no todos son de los nuestros."
,"20":"Pero ustedes tienen esa unción que viene del Santo, por lo que todos tienen ya conocimiento."
,"21":"Les escribo, no porque no conozcan la verdad, sino porque la conocen y porque la mentira no puede salir de la verdad."
,"22":"¿Y quién es el mentiroso sino el que niega que Jesús es el Cristo? Ese es el mentiroso, el que niega a la vez al Padre y al Hijo."
,"23":"Pues el que niega al Hijo, ya no tiene al Padre; y el que reconoce al Hijo tiene también al Padre."
,"24":"Permanezca en ustedes lo que oyeron desde el principio; si permanece en ustedes lo que oyeron desde el comienzo, también ustedes permanecerán en el Hijo y en el Padre."
,"25":"Esta es la promesa que él mismo prometió, y que es la vida eterna."
,"26":"Les he escrito esto pensando en aquellos que tratan de desviarlos,"
,"27":"pues en ustedes permanece la unción que recibieron de Jesucristo, y no necesitan que nadie venga a enseñarles. El les ha dado la unción, y ella les enseña todo; ella es verdad y no mentira. Así, pues, quédense con lo que les ha enseñado."
,"28":"Y ahora, hijitos, permanezcan en él; haciéndolo, tendremos plena confianza cuando aparezca en su gloria, en vez de sentir vergüenza ante él cuando nos venga a pedir cuentas."
,"29":"Si saben que él es el Justo, reconozcan que todo el que practica la justicia ha nacido de Dios."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Miren qué amor tan singular nos ha tenido el Padre: que no sólo nos llamamos hijos de Dios, sino que lo somos. Por eso el mundo no nos conoce, porque no lo conoció a él."
,"2":"Amados, a pesar de que ya somos hijos de Dios, no se ha manifestado todavía lo que seremos; pero sabemos que cuando él aparezca en su gloria, seremos semejantes a él, porque lo veremos tal como es."
,"3":"Y si es esto lo que esperamos de él, querremos ser santos como él es santo."
,"4":"El que peca demuestra ser un rebelde; todo pecado es rebeldía."
,"5":"Bien saben que Este vino para quitar nuestros pecados, y que en él no hay pecado."
,"6":"Quien permanece en él no peca; quien peca no lo ha visto ni conocido."
,"7":"Hijitos míos, no se dejen extraviar: el que actúa con toda rectitud es justo como él es justo."
,"8":"En cambio quienes pecan son del Diablo, pues el Diablo peca desde el principio. Para esto se ha manifestado el Hijo de Dios: para deshacer las obras del Diablo. "
,"9":"El que ha nacido de Dios no peca, porque permanece en él la semilla de Dios. Y ni siquiera puede pecar, porque ha nacido de Dios."
,"10":"En esto se reconocen los hijos de Dios y los del Diablo: el que no sigue el camino de rectitud no es de Dios, y tampoco el que no ama a su hermano."
,"11":"Debemos amarnos unos a otros, pues éste es el mensaje que ustedes han oído desde el comienzo."
,"12":"No imitemos a Caín, que era del Maligno, y mató a su hermano. Y ¿por qué lo mató? Porque él hacía el mal, y su hermano hacía el bien."
,"13":"No se extrañen, hermanos, si el mundo los odia,"
,"14":"pues el amor a nuestros hermanos es para nosotros el signo de que hemos pasado de la muerte a la vida."
,"15":"El que no ama está en un estado de muerte. El que odia a su hermano es un asesino, y, como saben, ningún asesino tiene la vida eterna."
,"16":"El (Jesucristo) entregó su vida por nosotros; y en esto hemos conocido el amor; ahora también nosotros debemos dar la vida por los hermanos."
,"17":"Si uno goza de riquezas en este mundo y cierra su corazón cuando ve a su hermano en apuros, ¿cómo puede permanecer en él el amor de Dios?"
,"18":"Hijitos, no amemos con puras palabras y de labios para afuera, sino de verdad y con hechos."
,"19":"En esto conoceremos que somos de la verdad y se tranquilizará nuestra conciencia ante El."
,"20":"Pues si nuestra conciencia nos reprocha, pensemos que Dios es más grande que nuestra conciencia, y que lo conoce todo."
,"21":"Amadísimos, si nuestra conciencia no nos condena, tenemos plena confianza en Dios."
,"22":"Entonces, todo lo que pidamos nos lo concederá, porque guardamos sus mandatos y hacemos lo que le agrada."
,"23":"¿Y cuál es su mandato? Que creamos en el Nombre de su Hijo Jesucristo y nos amemos unos a otros, tal como él nos lo ordenó."
,"24":"El que guarda sus mandamientos permanece en Dios y Dios en él. Pues Dios permanece en nosotros, y lo sabemos por el Espíritu que nos ha dado."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Queridos míos, no se fíen de cualquier inspiración. Examinen los espíritus para ver si vienen de Dios, porque andan por el mundo muchos falsos profetas."
,"2":"¿Quieren reconocer al espíritu de Dios? Todo espíritu que reconoce a Jesús como el Mesías que ha venido en la carne, habla de parte de Dios."
,"3":"En cambio, si un inspirado no reconoce a Jesús, ese espíritu no es de Dios; es el mismo espíritu del Anticristo. Han oído que vendría un anticristo; pues bien, ya está en el mundo."
,"4":"Ustedes, hijitos, son de Dios, y ya han logrado la victoria sobre esa gente, pues el que está en ustedes es más poderoso que el que está en el mundo."
,"5":"Ellos son del mundo, por eso su lenguaje es el del mundo, y el mundo los escucha."
,"6":"Nosotros, en cambio, somos de Dios; el que conoce a Dios nos escucha, pero el que no conoce a Dios no nos hace caso. Así es como reconocemos el espíritu de la verdad y el espíritu del error."
,"7":"Queridos míos, amémonos unos a otros, porque el amor viene de Dios. Todo el que ama ha nacido de Dios y conoce a Dios."
,"8":"El que no ama no ha conocido a Dios, pues Dios es amor."
,"9":"Miren cómo se manifestó el amor de Dios entre nosotros: Dios envió a su Hijo único a este mundo para que tengamos vida por medio de él."
,"10":"En esto está el amor: no es que nosotros hayamos amado a Dios, sino que él nos amó primero y envió a su Hijo como víctima por nuestros pecados."
,"11":"Queridos, si Dios nos amó de esta manera, también nosotros debemos amarnos mutuamente."
,"12":"A Dios no lo ha visto nadie jamás; pero si nos amamos unos a otros, Dios está entre nosotros y su amor da todos sus frutos entre nosotros."
,"13":"Y ¿cómo sabemos que permanecemos en Dios y él en nosotros? Porque nos ha comunicado su Espíritu."
,"14":"Pero también nosotros hemos visto y declaramos que el Padre envió a su Hijo como Salvador del mundo."
,"15":"Quien reconozca que Jesús es el Hijo de Dios, Dios permanece en él y él en Dios."
,"16":"Por nuestra parte, hemos conocido el amor que Dios nos tiene, y hemos creído en él. Dios es amor: el que permanece en el amor permanece en Dios y Dios en él."
,"17":"Cuando el amor alcanza en nosotros su perfección, miramos con confianza al día del juicio, porque ya somos en este mundo como es El."
,"18":"En el amor no hay temor. El amor perfecto echa fuera el temor, pues hay temor donde hay castigo. Quien teme no conoce el amor perfecto."
,"19":"Amemos, pues, ya que él nos amó primero."
,"20":"Si uno dice 'Yo amo a Dios', y odia a su hermano, es un mentiroso. Si no ama a su hermano, a quien ve, no puede amar a Dios, a quien no ve."
,"21":"Pues éste es el mandamiento que recibimos de él: el que ama a Dios, ame también a su hermano."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Todo el que cree que Jesús es el Mesías ha nacido de Dios. Si amamos al que da la vida, amamos también a quienes han nacido de él;"
,"2":"y por eso, cuando amamos a Dios y cumplimos sus mandatos, con toda certeza sabemos que amamos a los hijos de Dios."
,"3":"Amar a Dios es guardar sus mandatos, y sus mandatos no son pesados."
,"4":"Todo lo que ha nacido de Dios vence al mundo, y la victoria en que el mundo ha sido vencido es nuestra fe."
,"5":"¿Quién ha vencido al mundo sino el que cree que Jesús es el Hijo de Dios?"
,"6":"El es el que viene por el agua y la sangre: Jesucristo; y no sólo por el agua, sino por el agua y la sangre; y el espíritu también da su testimonio, el Espíritu que es la verdad."
,"7":"Tres son, pues, los que dan testimonio:"
,"8":"el Espíritu, el agua y la sangre, y los tres coinciden en lo mismo."
,"9":"Si aceptamos el testimonio de los hombres, mucha más fuerza tiene el testimonio de Dios, y hay un testimonio de Dios, una declaración suya a favor de su Hijo."
,"10":"Quien cree en el Hijo de Dios está guardando en sí la declaración de Dios. Quien no cree, hace a Dios mentiroso, ya que no cree al testimonio de Dios en favor de su Hijo."
,"11":"Pues bien, éste es el testimonio: que Dios nos ha dado la vida eterna, y que dicha vida está en su Hijo."
,"12":"El que tiene al Hijo, tiene la vida; el que no tiene al Hijo de Dios, no tiene la vida."
,"13":"Les he escrito, pues, a ustedes que creen en el Nombre del Hijo de Dios, para que sepan que tienen vida eterna."
,"14":"Con él tenemos la certeza de que, si le pedimos algo conforme a su voluntad, nos escuchará."
,"15":"Y si nos escucha en todo lo que le pedimos, sabemos que ya tenemos lo que le hemos pedido."
,"16":"Si alguno ve a su hermano en el pecado -un pecado que no ha traído la muerte-, ore por él y Dios le dará vida. (Hablo de esos pecadores cuyo pecado no es para la muerte). Porque también hay un pecado que lleva a la muerte, y no pido oraciones en este caso. "
,"17":"Toda maldad es pecado, pero no es necesariamente pecado que lleva a la muerte."
,"18":"Sabemos que el que ha nacido de Dios no peca, pues lo protege lo que en él ha nacido de Dios, y el Maligno no puede tocarlo."
,"19":"Sabemos que somos de Dios, mientras el mundo entero está bajo el poder del Maligno."
,"20":"Sabemos también que el Hijo de Dios ha venido y nos ha dado inteligencia para que conozcamos al que es Verdadero. Nosotros estamos en el Verdadero, en su Hijo Jesucristo; ahí tienen el Dios verdadero y la Vida eterna."
,"21":"Hijitos, guárdense de los ídolos."
}`)

}
func ES_LBL_LoadNC1PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pedro, apóstol de Cristo Jesús, a los (judíos) que viven fuera de su patria, dispersos por el Ponto, Galacia, Capadocia, Asia y Bitinia,"
,"2":"a los elegidos, a quienes Dios Padre conoció de antemano y santificó por el Espíritu para acoger la fe y ser purificados por la sangre de Cristo Jesús: ¡Que la gracia y la paz abunden entre ustedes!"
,"3":"Bendito sea Dios, Padre de Cristo Jesús, nuestro Señor, por su gran misericordia. Al resucitar a Cristo Jesús de entre los muertos, nos dio una vida nueva y una esperanza viva."
,"4":"Reservaba para ustedes la herencia celestial, ese tesoro que no perece ni se echa a perder y que no se deshace con el tiempo."
,"5":"Y los protege el poder de Dios, por medio de la fe, con miras a la salvación que nos tiene preparada para los últimos tiempos."
,"6":"Por esto estén alegres, aunque por un tiempo tengan que ser afligidos con diversas pruebas."
,"7":"Si el oro debe ser probado pasando por el fuego, y es sólo cosa pasajera, con mayor razón su fe, que vale mucho más. Esta prueba les merecerá alabanza, honor y gloria el día en que se manifieste Cristo Jesús."
,"8":"Ustedes lo aman sin haberlo visto; ahora creen en él sin verlo, y nadie sabría expresar su alegría celestial"
,"9":"al tener ya ahora eso mismo que pretende la fe, la salvación de sus almas."
,"10":"Los profetas hablaron de ese favor que ustedes iban a recibir y se preguntaron o quisieron saber más al respecto."
,"11":"El Espíritu de Cristo estaba en ellos y les descubría de antemano los sufrimientos de Cristo y la gloria que iba a alcanzar, pero ellos se preguntaban quién sería y cuándo se realizaría eso."
,"12":"Estaban preparando lo que mantiene a los ángeles en suspenso, y que ahora les ha sido anunciado a ustedes por sus evangelizadores, al mismo tiempo que el Espíritu Santo les era enviado desde el cielo. Y les fue revelado que todo esto sería, no para ellos, sino para ustedes."
,"13":"Por tanto, tengan listo su espíritu y estén alerta, poniendo toda su esperanza en esta gracia que será para ustedes la venida gloriosa de Cristo Jesús."
,"14":"Si han aceptado la fe, no se dejen arrastrar ya por sus pasiones como lo hacían antes, cuando no sabían."
,"15":"Si es santo el que los llamó, también ustedes han de ser santos en toda su conducta,"
,"16":"según dice la Escritura: Serán santos, porque yo soy santo."
,"17":"El Padre que invocan no hace diferencias entre personas, sino que juzga a cada uno según sus obras; tomen, pues, en serio estos años en que viven fuera de la patria."
,"18":"No olviden que han sido rescatados de la vida vacía que aprendieron de sus padres; pero no con un rescate material de oro o plata,"
,"19":"sino con la sangre preciosa de Cristo, el Cordero sin mancha ni defecto."
,"20":"Dios pensaba en él desde antes de la creación del mundo, pero no fue revelado sino a ustedes al final de los tiempos."
,"21":"Gracias a él han creído en Dios que lo resucitó de entre los muertos y lo glorificó, precisamente con el fin de que pusieran su fe y su esperanza en Dios."
,"22":"Al aceptar la verdad, han logrado la purificación interior, de la que procede el amor sincero a los hermanos; ámense, pues, unos a otros de todo corazón,"
,"23":"ya que han nacido esta vez, no de semilla corruptible, sino de la palabra incorruptible del Dios que vive y permanece."
,"24":"Pues toda carne es como hierba y su gloria como flor del campo. La hierba se seca y la flor se cae,"
,"25":"pero la palabra del Señor permanece eternamente. Esta palabra es el Evangelio que se les ha anunciado a ustedes."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Rechacen, pues, toda maldad y engaño, la hipocresía, la envidia y toda clase de chismes."
,"2":"Como niños recién nacidos, busquen la leche no adulterada de la Palabra; gracias a ella crecerán y alcanzarán la plenitud."
,"3":"¿Acaso no han probado lo bueno que es el Señor?"
,"4":"Se han acercado al que es la piedra viva rechazada por los hombres, y que sin embargo es preciosa para Dios que la escogió."
,"5":"También ustedes, como piedras vivas, edifíquense y pasen a ser un Templo espiritual, una comunidad santa de sacerdotes que ofrecen sacrificios espirituales agradables a Dios por medio de Cristo Jesús."
,"6":"Dice la Escritura: Yo voy a colocar en Sión una piedra angular, escogida y preciosa: quien se afirme en ella no quedará defraudado."
,"7":"Ustedes, pues, que creen, recibirán honor. En cambio, para aquellos que no creen, él es la piedra rechazada por los constructores, que se ha convertido en la piedra angular;"
,"8":"piedra en la que la gente tropieza y roca que hace caer. Cuando se niegan a creer en la palabra, están tropezando con aquello en lo que debían afirmarse."
,"9":"Pero ustedes son una raza elegida, un reino de sacerdotes, una nación consagrada, un pueblo que Dios hizo suyo para proclamar sus maravillas; pues él los ha llamado de las tinieblas a su luz admirable."
,"10":"Ustedes antes no eran su pueblo, pero ahora son pueblo de Dios; no habían alcanzado su misericordia, mas ahora les ha sido concedida su misericordia."
,"11":"Amados hermanos, por ser aquí extranjeros y forasteros, les ruego que se abstengan de los deseos carnales que hacen la guerra al alma."
,"12":"Lleven una vida ejemplar en medio de los que no conocen a Dios; de este modo, esos mismos que los calumnian y los tratan de malhechores notarán sus buenas obras y darán gloria a Dios el día en que los visite."
,"13":"Sométanse a toda autoridad humana por causa del Señor: al rey, porque tiene el mando;"
,"14":"a los gobernadores, porque él los envía para castigar a los que obran mal y para animar a los que obran bien."
,"15":"La voluntad de Dios respecto de ustedes es que, obrando el bien, acallen la ignorancia de los imbéciles."
,"16":"Sean libres, pero no hagan de la libertad un pretexto para hacer el mal. Sean libres como servidores de Dios."
,"17":"Respeten a todos, amen a los hermanos, teman a Dios y respeten al que gobierna."
,"18":"Que los sirvientes obedezcan a sus patrones con todo respeto, no sólo a los que son buenos y comprensivos, sino también a los que son duros."
,"19":"Porque ahí está el mérito, en que soportan malos tratos sin haberlo merecido, habiendo actuado a conciencia y por Dios."
,"20":"Porque, ¿qué mérito habría en soportar el castigo cuando se ha faltado? En cambio, si pueden soportar que los traten mal cuando han actuado bien, eso es grande ante Dios."
,"21":"Para esto han sido llamados, pues Cristo también sufrió por ustedes, dejándoles un ejemplo, y deben seguir sus huellas."
,"22":"El no cometió pecado ni en su boca se encontró engaño."
,"23":"Insultado, no devolvía los insultos, y maltratado, no amenazaba, sino que se encomendaba a Dios que juzga justamente."
,"24":"El cargó con nuestros pecados en el madero de la cruz, para que, muertos a nuestros pecados, empezáramos una vida santa. Y por su suplicio han sido sanados."
,"25":"Pues eran ovejas descarriadas, pero han vuelto al pastor y guardián de sus almas."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Igualmente ustedes, mujeres, obedezcan a sus maridos. Si alguno de ellos se opone a la Palabra, será ganado por la conducta de sus mujeres mejor que por discursos,"
,"2":"pues les bastará ver su modo de ser responsable y sin reproche."
,"3":"No se preocupen tanto por lucir peinados rebuscados, collares de oro y vestidos lujosos, todas cosas exteriores,"
,"4":"sino que más bien irradie de lo íntimo del corazón la belleza que no se pierde, es decir, un espíritu suave y tranquilo. Eso sí que es muy precioso ante Dios."
,"5":"De ese modo se adornaban en otros tiempos las santas mujeres que esperaban en Dios y obedecían a sus maridos."
,"6":"Así obedecía Sara a Abrahán, al que llamaba su señor. Ustedes serán hijas de Sara si obran el bien sin tener miedo a nada."
,"7":"Y ustedes, maridos, sean a su vez comprensivos en la vida en común. Sabiendo que sus compañeras son seres más delicados, y que ambos comparten la gracia que lleva a la vida, eviten las amenazas. Este será un buen medio para que Dios escuche lo que ustedes le pidan."
,"8":"Finalmente, tengan todos un mismo sentir, compartan las preocupaciones de los demás con amor fraterno, sean compasivos y humildes."
,"9":"No devuelvan mal por mal ni insulto por insulto; más bien bendigan, pues para esto han sido llamados; y de este modo recibirán la bendición."
,"10":"El que de veras quiera gozar la vida y vivir días felices, guarde su lengua del mal y que de su boca no salgan palabras engañosas."
,"11":"Aléjese del mal y haga el bien, busque la paz y corra tras ella."
,"12":"Porque el Señor tiene los ojos puestos sobre los justos y los oídos atentos a sus peticiones; mas el Señor se opone a los que hacen el mal."
,"13":"Y ¿quién podrá hacerles daño si se esfuerzan en hacer el bien?"
,"14":"Felices ustedes si incluso tienen que sufrir por haber actuado bien. No compartan sus temores ni se asusten,"
,"15":"sino bendigan en sus corazones al Señor, a Cristo; estén siempre dispuestos para dar una respuesta a quien les pida cuenta de su esperanza,"
,"16":"pero háganlo con sencillez y deferencia, sabiendo que tienen la conciencia limpia. De este modo, si alguien los acusa, la vergüenza será para aquellos que calumnian la vida recta de los cristianos."
,"17":"Es mejor sufrir por hacer el bien, si tal es la voluntad de Dios, que por hacer el mal."
,"18":"Pues Cristo quiso morir por el pecado y para llevarnos a Dios, siendo ésta la muerte del justo por los injustos. Murió por ser carne, y luego resucitó por el Espíritu."
,"19":"Entonces fue a predicar a los espíritus encarcelados;"
,"20":"me refiero a esas personas que se negaron a creer en tiempo de Noé, cuando se iba acabando la paciencia de Dios y Noé ya estaba construyendo el arca. Pero algunas personas, ocho en total, entraron al arca y se salvaron a través del agua."
,"21":"Ustedes reconocen en esto la figura del bautismo que ahora los salva; no esperaban de él una limpieza corporal, sino que pidieron a Dios una renovación interior por medio de la resurrección de Cristo Jesús."
,"22":"El se ha ido al cielo y está a la derecha de Dios, después de someter a los ángeles, a las dominaciones y las potestades."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Dado que Cristo padeció en su carne, háganse fuertes con esta certeza: el que ha padecido en su carne ha roto con el pecado."
,"2":"Por ello, entreguen lo que les queda de esta vida, no ya a las pasiones humanas, sino a la voluntad de Dios."
,"3":"Ya es bastante el tiempo que dimos a todo lo que buscan los paganos: excesos, pasiones, borracheras, orgías y culto de los ídolos."
,"4":"A ellos les parece raro que ustedes ahora no corran con ellos hacia ese torrente de perdición, e incluso lo interpretan mal;"
,"5":"pero tendrán que rendir cuentas a Aquel que está preparado para juzgar a vivos y a muertos."
,"6":"Pues no sin razón el Evangelio ha sido anunciado a muchos que han muerto; si bien en cuanto seres humanos han recibido la sentencia de muerte, a través del Espíritu viven para Dios."
,"7":"El fin de todas las cosas está cerca; vivan, pues, con sensatez y dediquen sus noches a la oración."
,"8":"Sobre todo ámense de verdad unos a otros, pues el amor hace perdonar una multitud de pecados."
,"9":"Acójanse unos a otros en sus casas sin quejarse."
,"10":"Que cada uno ponga al servicio de los demás el carisma que ha recibido, y de este modo serán buenos administradores de los diversos dones de Dios."
,"11":"Si alguno habla, que sean palabras de Dios; si cumple algún ministerio, hágalo con el poder de Dios, para que Dios sea glorificado en todo por Cristo Jesús. A él sea la gloria y el poder por los siglos de los siglos. Amén."
,"12":"Queridos hermanos, no se sorprendan por el fuego que ha prendido en medio de ustedes para ponerlos a prueba. No es algo insólito lo que les sucede."
,"13":"Más bien alégrense de participar en los sufrimientos de Cristo, pues también se les concederán las alegrías más grandes el día en que se nos descubra su gloria."
,"14":"Si son insultados a causa del nombre de Cristo, felices ustedes, porque la gloria y el Espíritu de Dios descansan sobre ustedes."
,"15":"Sería una lástima que alguno tuviera que sufrir por asesino, ladrón, malhechor o delator;"
,"16":"pero si sufre por ser cristiano, no tiene por qué avergonzarse, sino que más bien debe dar gracias a Dios por llevar ese nombre."
,"17":"Ha llegado el tiempo del juicio, y éste empieza por la casa de Dios. Pues si comienza por nosotros, ¿qué fin tendrán los que se niegan a creer en el Evangelio?"
,"18":"Si el justo se salva a duras penas, ¿dónde se presentarán el pecador y el impío?"
,"19":"Así, pues, si sufren porque ésta es la voluntad de Dios, confíen sus almas al Creador, que es fiel, y continúen haciendo el bien."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Ahora me dirijo a sus Ancianos, dado que yo también soy anciano, y testigo de los sufrimientos de Cristo, y espero ser partícipe de la gloria que ha de manifestarse."
,"2":"Apacienten el rebaño de Dios cada cual en su lugar; cuídenlo no de mala gana, sino con gusto, a la manera de Dios; no piensen en ganancias, sino háganlo con entrega generosa;"
,"3":"no actúen como si pudieran disponer de los que están a su cargo, sino más bien traten de ser un modelo para su rebaño."
,"4":"Así, cuando aparezca el Jefe de los Pastores, recibirán en la Gloria una corona que no se marchita."
,"5":"También ustedes, los más jóvenes, sean sumisos a la autoridad de los Ancianos. Traten de rivalizar en sencillez y humildad unos con otros, porque Dios resiste a los orgullosos, pero da su gracia a los humildes."
,"6":"Humíllense, pues, bajo la poderosa mano de Dios, para que, llegado el momento, él los levante."
,"7":"Depositen en él todas sus preocupaciones, pues él cuida de ustedes."
,"8":"Sean sobrios y estén vigilantes, porque su enemigo, el diablo, ronda como león rugiente buscando a quién devorar."
,"9":"Resístanle firmes en la fe, sabiendo que nuestros hermanos en este mundo se enfrentan con persecuciones semejantes."
,"10":"Dios, de quien procede toda gracia, los ha llamado en Cristo para que compartan su gloria eterna, y ahora deja que sufran por un tiempo con el fin de amoldarlos, afirmarlos, hacerlos fuertes y ponerlos en su lugar definitivo."
,"11":"Gloria a él por los siglos de los siglos. Amén."
,"12":"He recurrido a Silvano, nuestro hermano, para escribirles estas breves líneas, pues lo considero digno de toda confianza. Quise animarlos y recalcar que esto es gracia de Dios: estén firmes."
,"13":"Los saluda la comunidad que Dios ha congregado en Babilonia, también los saluda mi hijo Marcos."
,"14":"Salúdense unos a otros con el beso fraterno. Paz a todos ustedes, que están en Cristo."
}`)

}
func ES_LBL_LoadNC2IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"El Anciano, a la Dama Elegida y a sus hijos. Los amo de verdad; y no sólo yo, sino también cuantos han conocido la verdad, "
,"2":"a causa de esta misma verdad que permanece en nosotros y estará siempre con nosotros."
,"3":"Reciban gracia, misericordia y paz de parte de Dios Padre y de su Hijo Cristo Jesús, en la verdad y el amor."
,"4":"Me alegré mucho al encontrar algunos hijos tuyos que viven según la verdad, de acuerdo con el mandato que recibimos del Padre."
,"5":"Y ahora te ruego, señora -aunque no te escribo un mandamiento nuevo, sino el que tenemos desde el comienzo-, que nos amemos unos a otros."
,"6":"Y el amor consiste en vivir de acuerdo a sus mandamientos. Este es el mandamiento que oyeron desde el comienzo, y así es como han de vivir."
,"7":"En este mundo se han presentado muchos seductores, que no reconocen a Jesús como el Mesías venido en la carne. En eso mismo se reconoce al impostor y al anticristo."
,"8":"Tengan cuidado, para que no pierdan el fruto de sus trabajos, sino que reciban el pleno salario."
,"9":"El que se aventura y no permanece en la doctrina de Cristo no posee a Dios; el que permanece en la doctrina, ése posee al Padre y al Hijo."
,"10":"Si alguno viene a ustedes y no trae esta doctrina, no lo reciban en sus casas ni le saluden;"
,"11":"pues el que le saluda se hace cómplice de sus malas obras."
,"12":"Tendría muchas más cosas que escribirles, pero prefiero no hacerlo por escrito con papel y tinta. Espero ir a verlos y hablarles personalmente, para que nuestro gozo sea completo."
,"13":"Te saludan los hijos de tu hermana Elegida."
}`)

}
func ES_LBL_LoadNC2PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Carta de Simeón Pedro, servidor y apóstol de Cristo Jesús, a todos aquellos que tuvieron la suerte, como la tuvimos nosotros, de recibir una fe tan preciosa y de ser renovados por nuestro Dios y Salvador Jesucristo."
,"2":"Que la gracia y la paz se les aumenten de día en día junto con el conocimiento de Dios y de Jesús, nuestro Señor."
,"3":"Su poder divino nos ha dado todo lo que necesitamos para la vida y la piedad, en primer lugar el conocimiento de Aquel que nos ha llamado por su propia gloria y fuerza."
,"4":"Por ellas nos ha concedido lo más grande y precioso que se pueda ofrecer: ustedes llegan a ser partícipes de la naturaleza divina, escapando de la corrupción que en este mundo va a la par con el deseo."
,"5":"Por eso, pongan el máximo empeño en incrementar su fe con la firmeza,"
,"6":"la firmeza con el conocimiento, el conocimiento con el dominio de los instintos, el dominio de los instintos con la constancia, la constancia con la piedad,"
,"7":"la piedad con el amor fraterno y el amor fraterno con la caridad."
,"8":"Pues si tienen todas estas virtudes en forma eminente, no serán inútiles ni estériles, sino que más bien alcanzarán el conocimiento de Cristo Jesús, nuestro Señor."
,"9":"En cambio, quien no tiene todo esto es ciego y corto de vista, y se ha olvidado de que fue purificado de sus pecados pasados."
,"10":"Por lo tanto, hermanos, esfuércense por confirmar el llamado de Dios que los ha elegido. Si obran así, no decaerán,"
,"11":"y se les facilitará generosamente la entrada al reino eterno de nuestro Señor y Salvador, Cristo Jesús."
,"12":"Por eso siempre trataré de recordarles estas cosas, aunque las sepan y se mantengan firmes en la verdad que poseen."
,"13":"Me parece bueno refrescar su memoria mientras esté en la presente morada,"
,"14":"sabiendo que pronto será desarmada esta tienda mía, según me lo ha manifestado nuestro Señor Jesucristo."
,"15":"Por eso procuro hacer todo lo necesario para que, después de mi partida, recuerden constantemente estas cosas."
,"16":"En efecto, no hemos sacado de fábulas o de teorías inventadas lo que les hemos enseñado sobre el poder y la venida de Cristo Jesús, nuestro Señor. Con nuestros propios ojos hemos contemplado su majestad"
,"17":"cuando recibió de Dios Padre gloria y honor. En ese momento llegó sobre él una palabra muy extraordinaria de la gloriosa Majestad: 'Este es mi Hijo muy querido, el que me agradó elegir.'"
,"18":"Nosotros mismos escuchamos esa voz venida del cielo estando con él en el cerro santo."
,"19":"A consecuencia de esto creemos más firmemente en el mensaje de los profetas, y deben tenerlo como una lámpara que luce en un lugar oscuro, hasta que se levante el día y el lucero de la mañana brille en sus corazones."
,"20":"Sépanlo bien: ninguna profecía de la Escritura puede ser interpretada por cuenta propia,"
,"21":"pues ninguna profecía ha venido por iniciativa humana, sino que los hombres de Dios han hablado movidos por el Espíritu Santo."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Así como hubo falsos profetas en el pueblo de Israel, también entre ustedes habrá falsos maestros. Introducirán novedades dañinas, pero sin tardar se perderán por renegar del Maestro que los rescató."
,"2":"Muchos imitarán sus vicios, y por su culpa será desprestigiado el camino de la verdad."
,"3":"Los inspirará el amor al dinero, y se aprovecharán de ustedes con palabras engañosas. Pero ya fue dictada su condenación, y su destrucción es inminente."
,"4":"En efecto, Dios no perdonó a los ángeles que pecaron, sino que los precipitó en el infierno y los encerró en cavernas tenebrosas, manteniéndolos allí hasta el día del juicio."
,"5":"Tampoco perdonó al mundo antiguo, cuando desencadenó las aguas del diluvio sobre el mundo de los malvados, y solamente protegió a Noé, el octavo portavoz del bien."
,"6":"También condenó Dios a las ciudades de Sodoma y Gomorra reduciéndolas a cenizas, para que sirvieran de escarmiento a los malvados del futuro."
,"7":"Pero en cambio salvó a Lot, hombre recto que se sentía profundamente afligido por la conducta desenfrenada de aquella gente viciosa."
,"8":"Este hombre recto vivía en medio de ellos, y su conciencia recta sufría día tras día viendo y oyendo sus crímenes."
,"9":"Pero el Señor sabe librar de la prueba a sus servidores y reserva a los malos para castigarlos el día del juicio."
,"10":"En especial esto vale para esa gente que corre tras los peores deseos de su naturaleza y desprecia la majestad del Señor. Son orgullosos y atrevidos, y no tienen miedo de insultar a los espíritus caídos,"
,"11":"mientras los ángeles, superiores a ellos en fuerza y en poder, no se permiten ninguna acusación injuriosa en presencia del Señor."
,"12":"Esos hombres son como animales irracionales, que vienen a la vida para ser capturados y muertos. Después de haber injuriado lo que no pueden entender, terminarán como animales"
,"13":"y recibirán lo merecido por su maldad. Se sienten felices por gozar placeres pasajeros. Gente sucia y viciosa, que se aprovechan de ustedes y se portan como glotones en sus comidas fraternas."
,"14":"No pueden ver a una mujer sin desearla, no se cansan de pecar y de seducir a las almas poco firmes. Son gente maldita, que tienen el corazón ejercitado en la codicia."
,"15":"Abandonaron el camino recto y tomaron el camino de Balaán, hijo de Bosor, al que le gustaba ganar dinero haciendo el mal."
,"16":"Pero ustedes saben quién lo reprendió por su torpeza: su burra empezó a hablar con voz humana y detuvo al profeta en su locura."
,"17":"Son fuentes sin agua, nubes arrastradas por el huracán, que se convierten en densas tinieblas."
,"18":"Con sus discursos altisonantes y vacíos alientan las pasiones y los deseos impuros en aquellos que acababan de liberarse, y los hacen recaer en el error."
,"19":"Prometen libertad, cuando ellos mismos son esclavos de la corrupción, pues cada uno es esclavo de aquello que lo domina."
,"20":"Y si éstos, que se habían liberado de los vicios del mundo por el conocimiento del Señor y Salvador Jesucristo, vuelven a esos vicios y se dejan dominar por ellos, su situación actual resulta peor que la primera."
,"21":"Más les valdría no haber conocido los caminos de la santidad que, después de haberlos conocido, apartarse de la santa doctrina que les fue enseñada."
,"22":"Se les aplica con razón lo que dice el proverbio: 'El perro vuelve a su propio vómito' y 'el cerdo lavado se revuelca en el barro.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Esta es ya, queridos, la segunda carta que les escribo. En ambas he intentado recordarles la sana doctrina."
,"2":"Acuérdense de las palabras dichas en el pasado por los santos profetas y del aviso de sus apóstoles, que era el del Señor y Salvador."
,"3":"Sepan, en primer lugar, que en los últimos días se presentarán burlones que no harán caso más que de sus propias codicias, y preguntarán en son de burla:"
,"4":"'¿En qué quedó la promesa de su venida? Desde que murieron nuestros padres en la fe todo sigue igual que al comienzo del mundo.'"
,"5":"Estos quieren ignorar que al principio hubo un cielo, y una tierra que surgió del agua y se mantuvo sobre ella por la palabra de Dios."
,"6":"Y por la misma palabra este mundo pereció anegado por las aguas del diluvio."
,"7":"Del mismo modo ahora la palabra de Dios es la que conserva nuestro cielo y nuestra tierra, pero serán destruidos por el fuego el día del Juicio, cuando los impíos también sean destruidos."
,"8":"No olviden, hermanos, que ante el Señor un día es como mil años y mil años son como un día."
,"9":"El Señor no se demora en cumplir su promesa, como algunos dicen, sino que es generoso con ustedes, y no quiere que se pierda nadie, sino que todos lleguen a la conversión."
,"10":"Llegará el día del Señor como hace un ladrón, y entonces los cielos se desarmarán entre un ruido ensordecedor, los elementos se derretirán por el calor y la tierra con todo lo que hay en ella se consumirá."
,"11":"Si el universo ha de descomponerse así, ¡cómo deberían ser ustedes! Les corresponde llevar una vida santa y piadosa,"
,"12":"mientras esperan y ansían la venida del día de Dios, en la que los cielos se desarmarán en el fuego y los elementos se derretirán por el calor."
,"13":"Mas nosotros esperamos, según la promesa de Dios, cielos nuevos y una tierra nueva en que reine la justicia."
,"14":"Con una esperanza así, queridos hermanos, esfuércense para que Dios los encuentre en su paz, sin mancha ni culpa."
,"15":"Consideren que las demoras de nuestro Señor son para nuestra salvación, como lo escribió nuestro querido hermano Pablo con la sabiduría que le fue dada,"
,"16":"e insiste sobre esto en todas sus cartas. Hay en ellas algunos puntos difíciles de entender, que los ignorantes y poco firmes en la fe interpretan torcidamente para su propio daño, como hacen también con las demás Escrituras."
,"17":"Así, pues, queridos, estando ya advertidos, tengan cuidado para que esa gente extraviada no arrastre a los que estaban firmes y los haga caer."
,"18":"Crezcan en la gracia y en el conocimiento de nuestro Señor y Salvador Jesucristo. A Él la gloria, ahora y hasta el día de la eternidad. Amén."
}`)

}
func ES_LBL_LoadNC3IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"El anciano, al queridísmo Gayo, a quien amo de verdad."
,"2":"Muy querido amigo, sabiendo que tu alma va por el buen camino, te deseo que goces de buena salud y que todos tus caminos te den satisfacción."
,"3":"Grande ha sido mi alegría al oir alabar tu verdad a los hermanos que llegaron, puesto que vives en la verdad."
,"4":"Nada me causa mayor alegría que el saber que mis hijos viven en la verdad."
,"5":"Hermano, obras muy bien al preocuparte por los hermanos, y más aún cuando llegan de otro lugar."
,"6":"Ellos han hablado de tu caridad ante la Iglesia reunida; has hecho muy bien en proverles de todo lo que necesitaban para su viaje, en una forma digna de Dios."
,"7":"En realidad salieron de viaje por el Nombre, y esto no tenía nada que ver con los no-cristianos."
,"8":"Debemos acoger a tales personas si queremos trabajar por la verdad."
,"9":"Convenía que yo escribiera a la Iglesia, pero a Diotrefes le gusta tanto el mando que no nos hace caso."
,"10":"Por eso, si yoy, le reprocharé su manera de actuar, pues nos desprestigia con palabras mal intencionadas. Y no contento con eso, ni siquiera recibe a los ehrmanos, y a los que quieren recibirlos no los deja y los expulsa de la Iglesia."
,"11":"Hermano muy querido, no imites lo malo, sino lo bueno. El que hace el bien es de Dios. El que hace el manl no ha visto a Dios."
,"12":"En cuanto a Demetrio, todos habalan bien de él, hasta la misma verdad. También nosostros lo alabamos, y tú sabes que cuando recomendamos a alguien lo hacemos según la verdad."
,"13":"Tendría muchas cosas más que decirte, pero no quiero hacerlo por escrito, con tinta y pluma."
,"14":"Espero verte pronto y hablaremos cara a cara."
,"15":"La paz sea contigo. Te saludan tus amigos. Saluda a los nuestros, a cada uno en particular."
}`)

}
func ES_LBL_LoadNCIBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Santiago, servidor de Dios y de Cristo Jesús el Señor, saluda a las doce tribus dispersas en medio de las naciones."
,"2":"Hermanos, considérense afortunados cuando les toca soportar toda clase de pruebas."
,"3":"Esta puesta a prueba de la fe desarrolla la capacidad de soportar,"
,"4":"y la capacidad de soportar debe llegar a ser perfecta, si queremos ser perfectos, completos, sin que nos falte nada."
,"5":"Si alguno de ustedes ve que le falta sabiduría, que se la pida a Dios, pues da con agrado a todos sin hacerse rogar. El se la dará."
,"6":"Pero hay que pedir con fe, sin vacilar, porque el que vacila se parece a las olas del mar que están a merced del viento."
,"7":"Esa gente no puede esperar nada del Señor,"
,"8":"son personas divididas y toda su existencia será inestable."
,"9":"El hermano de condición humilde debe alegrarse cuando su situación mejora,"
,"10":"y el rico, cuando se ve rebajado; porque pasará como la flor del campo."
,"11":"Se levanta el sol y empieza el calor, seca la hierba y marchita la flor, y pierde toda su gracia. Así también el rico verá decaer sus negocios."
,"12":"Feliz el hombre que soporta pacientemente la prueba, porque, después de probado, recibirá la corona de vida que el Señor prometió a los que lo aman."
,"13":"Que nadie diga en el momento de la prueba: 'Dios me quiere echar abajo.' Porque Dios está a salvo de todo mal y tampoco quiere echar abajo a ninguno."
,"14":"Cada uno es tentado por su propia codicia, que lo arrastra y lo seduce;"
,"15":"la codicia concibe y da a luz el pecado; el pecado crece y, al final, engendra la muerte."
,"16":"Hermanos muy queridos, no se equivoquen:"
,"17":"son las cosas buenas y los dones perfectos los que proceden de lo alto y descienden del Padre que es luz; allí no retornan las noches ni pasan las sombras."
,"18":"Muy libremente nos dio vida y nos hizo hijos suyos mediante la palabra de la verdad, para que fuéramos la flor de su creación."
,"19":"Hermanos muy queridos, sean prontos para escuchar, pero lentos para hablar y enojarse,"
,"20":"pues la ira del hombre no realiza la justicia de Dios."
,"21":"Por eso, rechacen la impureza y los excesos del mal y reciban con sencillez la palabra sembrada en ustedes, que tiene poder para salvarlos."
,"22":"Pongan por obra lo que dice la Palabra y no se conformen con oírla, pues se engañarían a sí mismos."
,"23":"El que escucha la palabra y no la practica es como aquel hombre que se miraba en el espejo,"
,"24":"pero apenas se miraba, se iba y se olvidaba de cómo era."
,"25":"Todo lo contrario el que fija su atención en la Ley perfecta de la libertad y persevera en ella, no como oyente olvidadizo, sino como activo cumplidor; éste será dichoso al practicarla."
,"26":"Si alguno se cree muy religioso, pero no controla sus palabras, se engaña a sí mismo y su religión no vale."
,"27":"La religión verdadera y perfecta ante Dios, nuestro Padre, consiste en esto: ayudar a los huérfanos y a las viudas en sus necesidades y no contaminarse con la corrupción de este mundo."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Hermanos, si realmente creen en Jesús, nuestro Señor, el Cristo glorioso, no hagan diferencias entre personas."
,"2":"Supongamos que entra en su asamblea un hombre muy bien vestido y con un anillo de oro y entra también un pobre con ropas sucias,"
,"3":"y ustedes se deshacen en atenciones con el hombre bien vestido y le dicen: 'Tome este asiento, que es muy bueno', mientras que al pobre le dicen: 'Quédate de pie', o bien: 'Siéntate en el suelo a mis pies'."
,"4":"Díganme, ¿no sería hacer diferencias y hacerlas con criterios pésimos?"
,"5":"Miren, hermanos, ¿acaso no ha escogido Dios a los pobres de este mundo para hacerlos ricos en la fe? ¿No les dará el reino que prometió a quienes lo aman?"
,"6":"Ustedes, en cambio, los desprecian. Sin embargo, son los ricos quienes los aplastan a ustedes y los arrastran ante los tribunales."
,"7":"¿Y no son ellos los que blasfeman el glorioso nombre de Cristo que ha sido pronunciado sobre ustedes?"
,"8":"Obran bien cuando cumplen la Ley del Reino, tal como está en la Escritura: Ama a tu prójimo como a ti mismo."
,"9":"Pero si hacen diferencias entre las personas, cometen pecado y la misma Ley los denuncia como culpables."
,"10":"Porque si alguien cumple toda la Ley, pero falla en un solo punto, es como si faltara en todo."
,"11":"Pues el que dijo: No cometerás adulterio, dijo también: No matarás. Si, pues, no cometes adulterio, pero matas, ya has violado la Ley."
,"12":"Hablen, por tanto, y obren como quienes han de ser juzgados por una ley de libertad."
,"13":"Habrá juicio sin misericordia para quien no ha sido misericordioso, mientras que la misericordia no tiene miedo al juicio."
,"14":"Hermanos, si uno dice que tiene fe, pero no viene con obras, ¿de qué le sirve? ¿Acaso lo salvará esa fe?"
,"15":"Si un hermano o una hermana no tienen con qué vestirse ni qué comer,"
,"16":"y ustedes les dicen: 'Que les vaya bien, caliéntense y aliméntense', sin darles lo necesario para el cuerpo, ¿de qué les sirve eso?"
,"17":"Lo mismo ocurre con la fe: si no produce obras, muere solita."
,"18":"Y sería fácil decirle a uno: 'Tú tienes fe, pero yo tengo obras. Muéstrame tu fe sin obras, y yo te mostraré mi fe a través de las obras."
,"19":"¿Tú crees que hay un solo Dios? Pues muy bien, pero eso lo creen también los demonios y tiemblan'."
,"20":"¿Será necesario demostrarte, si no lo sabes todavía, que la fe sin obras no tiene sentido?"
,"21":"Abrahán, nuestro padre, ¿no fue reconocido justo por sus obras cuando ofreció a su hijo Isaac sobre el altar?"
,"22":"Ya ves que la fe acompañaba a sus obras, y por las obras su fe llegó a la madurez."
,"23":"Esto es lo que recuerda la Escritura: Abrahán creyó en Dios, y por eso fue reconocido justo, y fue llamado amigo de Dios."
,"24":"Entiendan, pues, que uno llega a la verdadera rectitud a través de las obras y no sólo por la fe."
,"25":"Lo mismo pasó con Rajab, la prostituta: fue admitida entre los justos por sus obras, por haber dado hospedaje a los espías y porque los hizo partir por otro camino."
,"26":"Porque así como un cuerpo sin espíritu está muerto, así también la fe que no produce obras está muerta."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Hermanos, no se hagan todos maestros; ya saben que como maestros seremos juzgados con más severidad,"
,"2":"y todos tenemos nuestras fallas. El que no peca en palabras es un hombre perfecto de verdad, pues es capaz de dominar toda su persona. "
,"3":"Poniendo un freno en la boca del caballo podemos dominarlo, y sometemos así todo su cuerpo."
,"4":"Lo mismo ocurre con los barcos: con un pequeño timón el piloto los maneja como quiere, por grandes que sean, aun bajo fuertes vientos."
,"5":"Así también la lengua es algo pequeño, pero puede mucho; aquí tienen una llama que devora bosques."
,"6":"La lengua es un fuego, y es un mundo de maldad; rige nuestro organismo y mancha a toda la persona: el fuego del infierno se mete en ella y lo transmite a toda nuestra vida."
,"7":"Animales salvajes y pájaros, reptiles y animales marinos de toda clase han sido y de hecho son dominados por la raza humana."
,"8":"Pero nadie ha sido capaz de dominar la lengua. Es un azote que no se puede detener, un derrame de veneno mortal."
,"9":"Con ella bendecimos a nuestro Señor y Padre y con ella maldecimos a los hombres, hechos a imagen de Dios."
,"10":"De la misma boca salen la bendición y la maldición."
,"11":"Hermanos, esto no puede ser así. ¿Es que puede brotar de la misma fuente agua dulce y agua amarga?"
,"12":"La higuera no puede producir aceitunas ni la vid higos, y lo salobre no dará agua dulce."
,"13":"¿Así que eres sabio y entendido? Si tu sabiduría es modesta, veremos sus frutos en tu conducta noble."
,"14":"Pero si te vuelve amargo, celoso, peleador, no te fíes de ella, que eso sería mentira."
,"15":"Esa clase de sabiduría no viene de arriba sino de la tierra, de tu propio genio y del demonio."
,"16":"Y donde hay envidia y ambición habrá también inestabilidad y muchas cosas malas."
,"17":"En cambio la sabiduría que viene de arriba es, ante todo, recta y pacífica, capaz de comprender a los demás y de aceptarlos; está llena de indulgencia y produce buenas obras,"
,"18":"no es parcial ni hipócrita. Los que trabajan por la paz siembran en la paz y cosechan frutos en todo lo bueno."
}`)
	CurrentBook.AddChapter(4, `{
"1":"¿De dónde proceden esas guerras y esas riñas entre ustedes? De aquí abajo, por supuesto; son el fruto de las codicias, que hacen la guerra dentro de ustedes mismos."
,"2":"Ustedes quisieran tener y no tienen, entonces matan; tienen envidia y no consiguen, entonces no hay más que discusiones y peleas. Pero si ustedes no tienen es porque no piden, "
,"3":"o si piden algo, no lo consiguen porque piden mal; y no lo consiguen porque lo derrocharían para divertirse."
,"4":"¡Adúlteros! ¿No saben que la amistad con este mundo es enemistad con Dios? Quien desee ser amigo del mundo se hace enemigo de Dios."
,"5":"No sin razón dice la Escritura que el espíritu que habita en nosotros quiere tener cada vez más;"
,"6":"pero Dios tiene mejores cosas que dar. Y la Escritura añade: Dios resiste a los orgullosos, pero hace favores a los humildes."
,"7":"Sométanse, pues, a Dios; resistan al diablo y huirá de ustedes;"
,"8":"acérquense a Dios y él se acercará a ustedes. Purifíquense las manos, pecadores; santifiquen sus corazones, indecisos."
,"9":"Reconozcan su miseria, laméntenla y lloren. Lo que les conviene es llanto y no risa, tristeza y no alegría."
,"10":"Humíllense ante el Señor y él los ensalzará."
,"11":"Hermanos, no se critiquen unos a otros. El que habla mal de un hermano o se hace su juez, habla contra la Ley y se hace juez de la Ley. Pero a ti, que juzgas a la Ley, ¿te corresponde juzgar a la Ley o cumplirla?"
,"12":"Uno solo es juez: Aquel que hizo la Ley y que puede salvar y condenar. Pero, ¿quién eres tú para juzgar al prójimo?"
,"13":"Ahora les toca el turno a los que dicen: 'Hoy o mañana iremos a tal ciudad y pasaremos allí el año, haremos buenos negocios y obtendremos ganancias.'"
,"14":"Pero ustedes no saben lo que será el mañana. ¿Estarán con vida todavía? Pues no son más que humo que se ve por unos instantes y luego se disipa."
,"15":"¿Por qué no dicen más bien: 'Si Dios nos da vida, haremos esto o lo otro'?"
,"16":"Pero no, están seguros de sí mismos y esa manera de jactarse es mala."
,"17":"El que sabe, pues, lo que es correcto y no lo hace, está en pecado."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Ahora les toca a los ricos: lloren y laméntense porque les han venido encima desgracias."
,"2":"Los gusanos se han metido en sus reservas y la polilla se come sus vestidos,"
,"3":"su oro y su plata se han oxidado. El óxido se levanta como acusador contra ustedes y como un fuego les devora las carnes. ¿Cómo han atesorado, si ya eran los últimos tiempos?"
,"4":"El salario de los trabajadores que cosecharon sus campos se ha puesto a gritar, pues ustedes no les pagaron; las quejas de los segadores ya habían llegado a los oídos del Señor de los ejércitos."
,"5":"Han conocido sólo lujo y placeres en este mundo, y lo pasaron muy bien, mientras otros eran asesinados."
,"6":"Condenaron y mataron al inocente, pues ¿cómo podía defenderse?"
,"7":"Tengan paciencia, hermanos, hasta la venida del Señor. Miren cómo el sembrador cosecha los preciosos productos de la tierra, que ha aguardado desde las primeras lluvias hasta las tardías."
,"8":"Sean también ustedes pacientes y no se desanimen, porque la venida del Señor está cerca."
,"9":"Hermanos: no se peleen unos con otros, y así no serán juzgados; miren que el juez está a la puerta."
,"10":"Consideren, hermanos, lo que han sufrido los profetas que hablaron en nombre del Señor y tómenlos como modelo de paciencia."
,"11":"Fíjense que llamamos felices a aquellos que fueron capaces de perseverar. Han oído hablar de la constancia de Job y saben lo que al final el Señor hizo por él, pues el Señor es compasivo y misericordioso."
,"12":"Otro punto muy importante, hermanos: no juren, ni por el cielo, ni por la tierra, ni de ninguna otra forma. Que su sí sea sí, y su no, no; de otro modo serían reprensibles."
,"13":"¿Hay entre ustedes alguno desanimado? Que rece. ¿Está alguno alegre? Que cante himnos a Dios."
,"14":"¿Hay alguno enfermo? Que llame a los ancianos de la Iglesia, que oren por él y lo unjan con aceite en el nombre del Señor."
,"15":"La oración hecha con fe salvará al que no puede levantarse y el Señor hará que se levante; y si ha cometido pecados, se le perdonarán."
,"16":"Reconozcan sus pecados unos ante otros y recen unos por otros para que sean sanados. La súplica del justo tiene mucho poder con tal de que sea perseverante:"
,"17":"Elías era hombre y mortal como nosotros, pero cuando rogó insistentemente para que no lloviese en el país, no llovió durante tres años y medio;"
,"18":"después oró de nuevo y el cielo dio lluvia y la tierra produjo frutos."
,"19":"Hermanos, si alguno de ustedes se extravía lejos de la verdad y otro lo hace volver,"
,"20":"sepan que el que aparta a un pecador de su mal camino salva un alma de la muerte y hace olvidar muchos pecados."
}`)

}
func ES_LBL_LoadNCIDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Judas, servidor de Jesucristo y hermano de Santiago, a los que fueron llamados a la fe, amados por Dios Padre y guardados en Cristo Jesús."
,"2":"Reine entre ustedes la misericordia, la paz y el amor."
,"3":"Amadísimos, tenía un gran deseo de escribirles acerca de nuestra común salvación, y me sentí obligado a hacerlo para exhortarlos a luchar por la fe que Dios entregó de una vez para siempre a sus santos."
,"4":"Porque se han infiltrado en medio de ustedes ciertas personas ya señaladas para la condenación, gente impía que hacen de la gracia de nuestro Dios un pretexto para su libertinaje y niegan a nuestro único Dueño y Señor Jesucristo."
,"5":"Quiero recordarles algo que ya saben, y es que el Señor, después de liberar a su pueblo del país de Egipto, intervino por segunda vez para entregar a la muerte a los que no creyeron."
,"6":"Lo mismo hizo con los ángeles que no mantuvieron su dignidad y abandonaron su propia morada: Dios los encerró en cárceles eternas, en profundas tinieblas, hasta que llegue el gran día del Juicio."
,"7":"De igual modo sentenció a Sodoma, Gomorra y las ciudades vecinas que se entregaban a la prostitución y se dejaban llevar por sus instintos; éstas son ahora una advertencia del fuego eterno."
,"8":"Ahora, sin embargo, estos hombres se dejan llevar por locuras parecidas: envilecen sus cuerpos y desprecian a las autoridades celestiales."
,"9":"El arcángel Miguel, cuando pleiteaba con el diablo disputándose el cuerpo de Moisés, no se atrevió a pronunciar contra él ninguna palabra de insulto, sino que sencillamente dijo: '¡Que el Señor te reprenda!'"
,"10":"En cambio esa gente insulta y desprecia todo lo que no pueden entender, y lo que conocen por instinto como los animales, lo utilizan para su corrupción."
,"11":"¡Pobres de ellos! Siguen los pasos de Caín, se extravían por causa del dinero al igual que Balaán y se pierden como el rebelde Coré."
,"12":"Echan a perder las comidas de fraternidad que celebran ustedes, pues no piensan más que en sí mismos y comen desvergonzadamente. Son como nubes arrastradas por el viento que no dan lluvia, árboles que no dan fruto al final del otoño y que ya están muertos antes de ser arrancados de raíz; "
,"13":"olas embravecidas del mar que arrojan la espuma de sus vicios; estrellas errantes a las que esperan las tinieblas eternas."
,"14":"El patriarca Henoc, el séptimo después de Adán, dijo de ellos estas palabras: 'El Señor viene con miles de ángeles"
,"15":"para juzgar a todos. Pedirá cuentas a los que se burlan del bien por todas las veces en que actuaron burlándose de él, y castigará a los pecadores enemigos de Dios por todas las palabras injuriosas que profirieron contra él.'"
,"16":"Son descontentos y frustrados que sólo tratan de satisfacer sus pasiones; su boca está llena de palabras altisonantes y con ellas quieren impresionar a la gente para su propio provecho."
,"17":"Pero ustedes, amadísimos, recuerden lo que los apóstoles de Cristo nuestro Señor les anunciaron."
,"18":"Ellos les decían que al final de los tiempos aparecerán hombres que se burlarán de todo y no tendrán en cuenta a Dios, sino que se dejarán llevar por sus pasiones."
,"19":"En la actualidad éstos son los que causan divisiones, se mueven en lo humano y no tienen el Espíritu."
,"20":"En cambio ustedes, queridos hermanos, construyan su vida sobre los fundamentos de su santísima fe, oren en el Espíritu Santo"
,"21":"y manténganse en el amor de Dios, aguardando la misericordia de Jesucristo nuestro Señor, que los llevará a la vida eterna."
,"22":"Muestren comprensión con los que dudan;"
,"23":"a unos los salvarán arrancándolos del fuego eterno; con otros deberán actuar con mucho cuidado, sin tocar ni siquiera sus ropas por miedo a la contaminación."
,"24":"Al Dios único, que puede preservarlos de todo pecado y presentarlos alegres y sin mancha ante su propia Gloria;"
,"25":"al único que nos salva por medio de Cristo Jesús nuestro Señor, a él sea gloria, honor, fuerza y poder desde antes de todos los tiempos, ahora y por todos los siglos. Amén."
}`)

}
func ES_LBL_LoadNEIOChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"En el principio era la Palabra, y la Palabra estaba ante Dios, y la Palabra era Dios."
,"2":"Ella estaba ante Dios en el principio."
,"3":"Por Ella se hizo todo, y nada llegó a ser sin Ella. Lo que fue hecho "
,"4":"tenía vida en ella, y para los hombres la vida era luz."
,"5":"La luz brilla en las tinieblas, y las tinieblas no la recibieron."
,"6":"Vino un hombre, enviado por Dios, que se llamaba Juan."
,"7":"Vino para dar testimonio, como testigo de la luz, para que todos creyeran por él."
,"8":"Aunque no fuera él la luz, le tocaba dar testimonio de la luz."
,"9":"Ella era la luz verdadera, la luz que ilumina a todo hombre, y llegaba al mundo."
,"10":"Ya estaba en el mundo, este mundo que se hizo por Ella, o por El, este mundo que no lo recibió."
,"11":"Vino a su propia casa, y los suyos no lo recibieron;"
,"12":"pero a todos los que lo recibieron,les dio capacidad para ser hijos de Dios. Al creer en su Nombre "
,"13":"han nacido, no de sangre alguna, ni por ley de la carne, ni por voluntad de hombre, sino que han nacido de Dios."
,"14":"Y la Palabra se hizo carne, puso su tienda entre nosotros, y hemos visto su Gloria: la Gloria que recibe del Padre el Hijo único; en él todo era don amoroso y verdad."
,"15":"Juan dio testimonio de él; dijo muy fuerte: 'De él yo hablaba al decir: El que ha venido detrás de mí, ya está delante de mí, porque era antes que yo.'"
,"16":"De su plenitud hemos recibido todos, y cada don amoroso preparaba otro."
,"17":"Por medio de Moisés hemos recibido la Ley, pero la verdad y el don amoroso,nos llegó por medio de Jesucristo."
,"18":"Nadie ha visto a Dios jamás, pero Dios-Hijo único nos lo dio a conocer; él está en el seno del Padre,y nos lo dio a conocer."
,"19":"Este fue el testimonio de Juan, cuando los judíos enviaron sacerdotes y levitas desde Jerusalén para preguntarle: '¿Quién eres tú?'"
,"20":"Juan lo declaró y no ocultó la verdad: 'Yo no soy el Mesías.'"
,"21":"Le preguntaron: '¿Quién eres, entonces? ¿Elías?' Contestó: 'No lo soy.' Le dijeron: '¿Eres el Profeta?' Contestó: 'No.'"
,"22":"Le preguntaron de nuevo: '¿Quién eres, entonces? Pues tenemos que llevar una respuesta a los que nos han enviado. ¿Qué dices de ti mismo?'"
,"23":"Juan contestó: 'Yo soy, como dijo el profeta Isaías, la voz que grita en el desierto: Enderecen el camino del Señor.'"
,"24":"Los enviados eran del grupo de los fariseos,"
,"25":"y le hicieron otra pregunta: '¿Por qué bautizas entonces, si no eres el Mesías, ni Elías, ni el Profeta?'"
,"26":"Les contestó Juan: 'Yo bautizo con agua, pero en medio de ustedes hay uno a quien ustedes no conocen,"
,"27":"y aunque viene detrás de mí, yo no soy digno de soltarle la correa de su sandalia.'"
,"28":"Esto sucedió en Betabará, al otro lado del río Jordán, donde Juan bautizaba."
,"29":"Al día siguiente Juan vio a Jesús que venía a su encuentro, y exclamó: 'Ahí viene el Cordero de Dios, el que carga con el pecado del mundo."
,"30":"De él yo hablaba al decir: 'Detrás de mí viene un hombre que ya está delante de mí, porque era antes que yo'."
,"31":"Yo no lo conocía, pero mi bautismo con agua y mi venida misma eran para él, para que se diera a conocer a Israel.'"
,"32":"Y Juan dio este testimonio: 'He visto al Espíritu bajar del cielo como una paloma y quedarse sobre él."
,"33":"Yo no lo conocía, pero Aquel que me envió a bautizar con agua, me dijo también: 'Verás al Espíritu bajar sobre aquel que ha de bautizar con el Espíritu Santo, y se quedará en él'."
,"34":"Sí, yo lo he visto, y declaro que éste es el Elegido de Dios.'"
,"35":"Al día siguiente, Juan se encontraba de nuevo en el mismo lugar con dos de sus discípulos."
,"36":"Mientras Jesús pasaba, se fijó en él y dijo: 'Ese es el Cordero de Dios.'"
,"37":"Los dos discípulos le oyeron decir esto y siguieron a Jesús."
,"38":"Jesús se volvió y, al ver que lo seguían, les preguntó: '¿Qué buscan?' Le contestaron: 'Rabbí (que significa Maestro), ¿dónde vives?'"
,"39":"Jesús les dijo: 'Vengan y lo verán.' Fueron, vieron dónde vivía y se quedaron con él aquel día. Eran como las cuatro de la tarde."
,"40":"Andrés, el hermano de Simón Pedro, era uno de los dos que siguieron a Jesús por la palabra de Juan."
,"41":"Encontró primero a su hermano Simón y le dijo: 'Hemos encontrado al Mesías' (que significa el Cristo)."
,"42":"Y se lo presentó a Jesús. Jesús miró fijamente a Simón y le dijo: 'Tú eres Simón, hijo de Juan, pero te llamarás Kefas' (que quiere decir Piedra)."
,"43":"Al día siguiente Jesús resolvió partir hacia Galilea. Se encontró con Felipe y le dijo: 'Sígueme.'"
,"44":"Felipe era de Betsaida, el pueblo de Andrés y de Pedro."
,"45":"Felipe se encontró con Natanael y le dijo: 'Hemos hallado a aquél de quien escribió Moisés en la Ley y también los profetas. Es Jesús, el hijo de José de Nazaret.'"
,"46":"Natanael le replicó: '¿Puede salir algo bueno de Nazaret?' Felipe le contestó: 'Ven y verás.'"
,"47":"Cuando Jesús vio venir a Natanael, dijo de él: 'Ahí viene un verdadero israelita: éste no sabría engañar.'"
,"48":"Natanael le preguntó: '¿Cómo me conoces?' Jesús le respondió: 'Antes de que Felipe te llamara, cuando estabas bajo la higuera, yo te vi.'"
,"49":"Natanael exclamó: 'Maestro, tú eres el Hijo de Dios, tú eres el Rey de Israel.'"
,"50":"Jesús le dijo: 'Tú crees porque te dije que te vi bajo la higuera. Pero verás cosas mayores que éstas."
,"51":"En verdad les digo que ustedes verán los cielos abiertos y a los ángeles de Dios subiendo y bajando sobre el Hijo del Hombre.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Tres días más tarde se celebraba una boda en Caná de Galilea, y la madre de Jesús estaba allí."
,"2":"También fue invitado Jesús a la boda con sus discípulos."
,"3":"Sucedió que se terminó el vino preparado para la boda, y se quedaron sin vino. Entonces la madre de Jesús le dijo: 'No tienen vino.'"
,"4":"Jesús le respondió: 'Mujer, ¿por qué te metes en mis asuntos? Aún no ha llegado mi hora.'"
,"5":"Pero su madre dijo a los sirvientes: 'Hagan lo que él les diga.'"
,"6":"Había allí seis recipientes de piedra, de los que usan los judíos para sus purificaciones, de unos cien litros de capacidad cada uno."
,"7":"Jesús dijo: 'Llenen de agua esos recipientes.' Y los llenaron hasta el borde."
,"8":"'Saquen ahora, les dijo, y llévenle al mayordomo.' Y ellos se lo llevaron."
,"9":"Después de probar el agua convertida en vino, el mayordomo llamó al novio, pues no sabía de dónde provenía, a pesar de que lo sabían los sirvientes que habían sacado el agua."
,"10":"Y le dijo: 'Todo el mundo sirve al principio el vino mejor, y cuando ya todos han bebido bastante, les dan el de menos calidad; pero tú has dejado el mejor vino para el final.'"
,"11":"Esta señal milagrosa fue la primera, y Jesús la hizo en Caná de Galilea. Así manifestó su gloria y sus discípulos creyeron en él."
,"12":"Jesús bajó después a Cafarnaún con su madre, sus hermanos y sus discípulos, y permanecieron allí solamente algunos días."
,"13":"Se acercaba la Pascua de los judíos, y Jesús subió a Jerusalén."
,"14":"Encontró en el Templo a los vendedores de bueyes, ovejas y palomas, y a los cambistas sentados detrás de sus mesas."
,"15":"Hizo un látigo con cuerdas y los echó a todos fuera del Templo junto con las ovejas y bueyes; derribó las mesas de los cambistas y desparramó el dinero por el suelo."
,"16":"A los que vendían palomas les dijo: 'Saquen eso de aquí y no conviertan la Casa de mi Padre en un mercado.'"
,"17":"Sus discípulos se acordaron de lo que dice la Escritura: 'Me devora el celo por tu Casa.'"
,"18":"Los judíos intervinieron: '¿Qué señal milagrosa nos muestras para justificar lo que haces?'"
,"19":"Jesús respondió: 'Destruyan este templo y yo lo reedificaré en tres días.'"
,"20":"Ellos contestaron: 'Han demorado ya cuarenta y seis años en la construcción de este templo, y ¿tú piensas reconstruirlo en tres días?'"
,"21":"En realidad, Jesús hablaba de ese Templo que es su cuerpo."
,"22":"Solamente cuando resucitó de entre los muertos, sus discípulos se acordaron de que lo había dicho y creyeron tanto en la Escritura como en lo que Jesús dijo."
,"23":"Jesús se quedó en Jerusalén durante la fiesta de la Pascua, y muchos creyeron en él al ver las señales milagrosas que hacía. Pero Jesús no se fiaba de ellos, pues los conocía a todos"
,"24":"y no necesitaba pruebas sobre nadie,"
,"25":"porque él conocía lo que había en la persona."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Entre los fariseos había un personaje judío llamado Nicodemo. Este fue de noche a ver a Jesús y le dijo:"
,"2":"'Rabbí, sabemos que has venido de parte de Dios como maestro, porque nadie puede hacer señales milagrosas como las que tú haces, a no ser que Dios esté con él.'"
,"3":"Jesús le contestó: 'En verdad te digo que nadie puede ver el Reino de Dios si no nace de nuevo desde arriba.'"
,"4":"Nicodemo le dijo: '¿Cómo renacerá el hombre ya viejo? ¿Quién volverá al seno de su madre?'"
,"5":"Jesús le contestó: 'En verdad te digo: El que no renace del agua y del Espíritu no puede entrar en el Reino de Dios."
,"6":"Lo que nace de la carne es carne, y lo que nace del Espíritu es espíritu."
,"7":"No te extrañes de que te haya dicho: 'Necesitan nacer de nuevo desde arriba'."
,"8":"El viento sopla donde quiere, y tú oyes su silbido, pero no sabes de dónde viene ni adónde va. Lo mismo le sucede al que ha nacido del Espíritu.'"
,"9":"Nicodemo volvió a preguntarle: '¿Cómo puede ser eso?'"
,"10":"Respondió Jesús: 'Tú eres maestro en Israel, y ¿no sabes estas cosas?"
,"11":"En verdad te digo que nosotros hablamos de lo que sabemos, y damos testimonio de lo que hemos visto, pero ustedes no aceptan nuestro testimonio."
,"12":"Si ustedes no creen cuando les hablo de cosas de la tierra, ¿cómo van a creer si les hablo de cosas del Cielo?"
,"13":"Sin embargo, nadie ha subido al Cielo sino sólo el que ha bajado del Cielo, el Hijo del Hombre."
,"14":"Recuerden la serpiente que Moisés hizo levantar en el desierto: así también tiene que ser levantado el Hijo del Hombre,"
,"15":"y entonces todo el que crea en él tendrá por él vida eterna."
,"16":"¡Así amó Dios al mundo! Le dio al Hijo Unico, para que quien cree en él no se pierda, sino que tenga vida eterna."
,"17":"Dios no envió al Hijo al mundo para condenar al mundo, sino para que se salve el mundo gracias a él."
,"18":"Para quien cree en él no hay juicio. En cambio, el que no cree ya se ha condenado, por el hecho de no creer en el Nombre del Hijo único de Dios."
,"19":"Esto requiere un juicio: la luz vino al mundo, y los hombres prefirieron las tinieblas a la luz, porque sus obras eran malas."
,"20":"Pues el que obra el mal odia la luz y no va a la luz, no sea que sus obras malas sean descubiertas y condenadas."
,"21":"Pero el que hace la verdad va a la luz, para que se vea que sus obras han sido hechas en Dios.'"
,"22":"Después de esto, Jesús se fue con sus discípulos al territorio de Judea. Allí estuvo con ellos y bautizaba."
,"23":"Juan también estaba bautizando en Ainón, cerca de Salín, porque allí había mucha agua; la gente venía y se hacía bautizar."
,"24":"(Esto ocurría antes de que Juan hubiera sido encarcelado)."
,"25":"Un día los discípulos de Juan tuvieron una discusión con un judío sobre la purificación espiritual."
,"26":"Fueron donde Juan y le dijeron: 'Maestro, el que estaba contigo al otro lado del Jordán, y en cuyo favor tú hablaste, está ahora bautizando y todos se van a él.'"
,"27":"Juan respondió: 'Nadie puede atribuirse más de lo que el Cielo le quiere dar."
,"28":"Ustedes mismos son testigos de que yo dije: Yo no soy el Mesías, sino el que ha sido enviado delante de él."
,"29":"Es el novio quien tiene a la novia; el amigo del novio está a su lado y hace lo que él le dice y se alegra con sólo oír la voz del novio. Por eso me alegro sin reservas."
,"30":"Es necesario que él crezca y que yo disminuya."
,"31":"El que viene de arriba está por encima de todos. El que viene de la tierra pertenece a la tierra y sus palabras son terrenales. El que viene del Cielo,"
,"32":"por más que dé testimonio de lo que allí ha visto y oído, nadie acepta su testimonio."
,"33":"Pero aceptar su testimonio es como reconocer que Dios es veraz."
,"34":"Aquel que Dios ha enviado habla las palabras de Dios, y Dios le da el Espíritu sin medida."
,"35":"El Padre ama al Hijo y ha puesto todas las cosas en sus manos."
,"36":"El que cree en el Hijo vive de vida eterna, pero el que se niega a creer en el Hijo se queda con el Dios que condena: nunca conocerá la vida.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"El Señor se enteró de que los fariseos tenían noticias de él; se decía que Jesús bautizaba y atraía más discípulos que Juan,"
,"2":"aunque de hecho no bautizaba Jesús, sino sus discípulos."
,"3":"Jesús decidió, entonces, abandonar Judea y volvió a Galilea."
,"4":"Para eso tenía que pasar por el país de Samaría,"
,"5":"y fue así como llegó a un pueblo de Samaría llamado Sicar, cerca de la tierra que Jacob dio a su hijo José."
,"6":"Allí se encuentra el pozo de Jacob. Jesús, cansado por la caminata, se sentó al borde del pozo. Era cerca del mediodía. "
,"7":"Fue entonces cuando una mujer samaritana llegó para sacar agua, y Jesús le dijo: 'Dame de beber.'"
,"8":"Los discípulos se habían ido al pueblo para comprar algo de comer."
,"9":"La samaritana le dijo: '¿Cómo tú, que eres judío, me pides de beber a mí, que soy una mujer samaritana?' (Se sabe que los judíos no tratan con los samaritanos)."
,"10":"Jesús le dijo: 'Si conocieras el don de Dios, si supieras quién es el que te pide de beber, tú misma le pedirías agua viva y él te la daría.'"
,"11":"Ella le dijo: 'Señor, no tienes con qué sacar agua y el pozo es profundo. ¿Dónde vas a conseguir esa agua viva?"
,"12":"Nuestro antepasado Jacob nos dio este pozo, del cual bebió él, sus hijos y sus animales; ¿eres acaso más grande que él?'"
,"13":"Jesús le dijo: 'El que beba de esta agua volverá a tener sed,"
,"14":"pero el que beba del agua que yo le daré nunca volverá a tener sed. El agua que yo le daré se convertirá en él en un chorro que salta hasta la vida eterna.'"
,"15":"La mujer le dijo: 'Señor, dame de esa agua, y así ya no sufriré la sed ni tendré que volver aquí a sacar agua.'"
,"16":"Jesús le dijo: 'Vete, llama a tu marido y vuelve acá.'"
,"17":"La mujer contestó: 'No tengo marido.' Jesús le dijo: 'Has dicho bien que no tienes marido,"
,"18":"pues has tenido cinco maridos, y el que tienes ahora no es tu marido. En eso has dicho la verdad.'"
,"19":"La mujer contestó: 'Señor, veo que eres profeta."
,"20":"Nuestros padres siempre vinieron a este cerro para adorar a Dios y ustedes, los judíos, ¿no dicen que Jerusalén es el lugar en que se debe adorar a Dios?'"
,"21":"Jesús le dijo: 'Créeme, mujer: Llega la hora en que ustedes adorarán al Padre, pero ya no será 'en este cerro' o 'en Jerusalén'."
,"22":"Ustedes, los samaritanos, adoran lo que no conocen, mientras que nosotros, los judíos, adoramos lo que conocemos, porque la salvación viene de los judíos."
,"23":"Pero llega la hora, y ya estamos en ella, en que los verdaderos adoradores adorarán al Padre en espíritu y en verdad."
,"24":"Entonces serán verdaderos adoradores del Padre, tal como él mismo los quiere. Dios es espíritu, y los que lo adoran deben adorarlo en espíritu y en verdad.'"
,"25":"La mujer le dijo: 'Yo sé que el Mesías (que es el Cristo), está por venir; cuando venga nos enseñará todo.'"
,"26":"Jesús le dijo: 'Ese soy yo, el que habla contigo.'"
,"27":"En aquel momento llegaron los discípulos y se admiraron al verlo hablar con una mujer. Pero ninguno le preguntó qué quería ni de qué hablaba con ella."
,"28":"La mujer dejó allí el cántaro y corrió al pueblo a decir a la gente:"
,"29":"'Vengan a ver a un hombre que me ha dicho todo lo que he hecho. ¿No será éste el Cristo?'"
,"30":"Salieron, pues, del pueblo y fueron a verlo."
,"31":"Mientras tanto los discípulos le insistían: 'Maestro, come.'"
,"32":"Pero él les contestó: 'El alimento que debo comer, ustedes no lo conocen.'"
,"33":"Y se preguntaban si alguien le habría traído de comer."
,"34":"Jesús les dijo: 'Mi alimento es hacer la voluntad de aquel que me ha enviado y llevar a cabo su obra."
,"35":"Ustedes han dicho: 'Dentro de cuatro meses será tiempo de cosechar'. ¿No es verdad? Pues bien, yo les digo: Levanten la vista y miren los campos: ya están amarillentos para la siega."
,"36":"El segador ya recibe su paga y junta el grano para la vida eterna, y con esto el sembrador también participa en la alegría del segador."
,"37":"Aquí vale el dicho: Uno es el que siembra y otro el que cosecha."
,"38":"Yo los he enviado a ustedes a cosechar donde otros han trabajado y sufrido. Otros se han fatigado y ustedes han retomado de su trabajo.'"
,"39":"Muchos samaritanos de aquel pueblo creyeron en él por las palabras de la mujer, que declaraba: 'El me ha dicho todo lo que he hecho.'"
,"40":"Cuando llegaron los samaritanos donde él, le pidieron que se quedara con ellos. Y se quedó allí dos días."
,"41":"Muchos más creyeron al oír su palabra,"
,"42":"y decían a la mujer: 'Ya no creemos por lo que tú has contado. Nosotros mismos lo hemos escuchado y sabemos que éste es verdaderamente el Salvador del mundo.'"
,"43":"Pasados los dos días, Jesús partió de allí para Galilea."
,"44":"El había afirmado que un profeta no es reconocido en su propia tierra."
,"45":"Sin embargo los galileos lo recibieron muy bien al llegar, porque habían visto todo lo que Jesús había hecho en Jerusalén durante la fiesta, pues ellos también habían ido a la fiesta."
,"46":"Jesús volvió a Caná de Galilea, donde había convertido el agua en vino. Había un funcionario real en Cafarnaún que tenía un hijo enfermo."
,"47":"Al saber que Jesús había vuelto de Judea a Galilea, salió a su encuentro para pedirle que fuera a sanar a su hijo, que se estaba muriendo."
,"48":"Jesús le dio esta respuesta: 'Si ustedes no ven señales y prodigios, no creen.'"
,"49":"El funcionario le dijo: 'Señor, ten la bondad de venir antes de que muera mi hijo.'"
,"50":"Jesús le contestó: 'Puedes volver, tu hijo está vivo.',El hombre creyó en la palabra de Jesús y se puso en camino. "
,"51":"Al llegar a la bajada de los cerros, se topó con sus sirvientes que venían a decirle que su hijo estaba sano."
,"52":"Les preguntó a qué hora se había mejorado el niño, y le contestaron: 'Ayer, a la una de la tarde, se le quitó la fiebre.'"
,"53":"El padre comprobó que a esa misma hora Jesús le había dicho: 'Tu hijo está vivo.' Y creyó él y toda su familia."
,"54":"Esta es la segunda señal milagrosa que hizo Jesús. Acababa de volver de Judea a Galilea."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Después de esto se celebraba una fiesta de los judíos, y Jesús subió a Jerusalén."
,"2":"Hay en Jerusalén, cerca de la Puerta de las Ovejas, una piscina llamada en hebreo Betesda. Tiene ésta cinco pórticos,"
,"3":"y bajo los pórticos yacía una multitud de enfermos, ciegos, cojos, tullidos (y paralíticos. Todos esperaban que el agua se agitara,"
,"4":"porque un ángel del Señor bajaba de vez en cuando y removía el agua; y el primero que se metía después de agitarse el agua quedaba sano de cualquier enfermedad que tuviese.)"
,"5":"Había allí un hombre que hacía treinta y ocho años que estaba enfermo."
,"6":"Jesús lo vio tendido, y cuando se enteró del mucho tiempo que estaba allí, le dijo: '¿Quieres sanar?'"
,"7":"El enfermo le contestó: 'Señor, no tengo a nadie que me meta en la piscina cuando se agita el agua, y mientras yo trato de ir, ya se ha metido otro.'"
,"8":"Jesús le dijo: 'Levántate, toma tu camilla y anda.'"
,"9":"Al instante el hombre quedó sano, tomó su camilla y empezó a caminar. Pero aquel día era sábado. "
,"10":"Por eso los judíos dijeron al que acababa de ser curado: 'Hoy es día sábado, y la Ley no permite que lleves tu camilla a cuestas.'"
,"11":"El les contestó: 'El que me sanó me dijo: Toma tu camilla y anda.'"
,"12":"Le preguntaron: '¿Quién es ese hombre que te ha dicho: Toma tu camilla y anda?'"
,"13":"Pero el enfermo no sabía quién era el que lo había sanado, pues Jesús había desaparecido entre la multitud reunida en aquel lugar."
,"14":"Más tarde Jesús se encontró con él en el Templo y le dijo: 'Ahora estás sano, pero no vuelvas a pecar, no sea que te suceda algo peor.'"
,"15":"El hombre se fue a decir a los judíos que era Jesús el que lo había curado."
,"16":"Por eso los judíos perseguían a Jesús, porque hacía tales curaciones en día sábado."
,"17":"Pero Jesús les respondió: 'Mi Padre sigue trabajando, y yo también trabajo.'"
,"18":"Y los judíos tenían más ganas todavía de matarle, porque además de quebrantar la ley del sábado, se hacía a sí mismo igual a Dios, al llamarlo su propio Padre."
,"19":"Jesús les dirigió la palabra: 'En verdad les digo: El Hijo no puede hacer nada por su cuenta, sino sólo lo que ve hacer al Padre. Todo lo que haga éste, lo hace también el Hijo."
,"20":"El Padre ama al Hijo y le enseña todo lo que él hace, y le enseñará cosas mucho más grandes que éstas, que a ustedes los dejarán atónitos."
,"21":"Como el Padre resucita a los muertos y les da la vida, también el Hijo da la vida a los que quiere."
,"22":"Del mismo modo, el Padre no juzga a nadie, sino que ha entregado al Hijo la responsabilidad de juzgar,"
,"23":"para que todos honren al Hijo como honran al Padre. El que no honra al Hijo, tampoco honra al Padre que lo ha enviado."
,"24":"En verdad les digo: El que escucha mi palabra y cree en el que me ha enviado, vive de vida eterna; ya no habrá juicio para él, porque ha pasado de la muerte a la vida."
,"25":"Sepan que viene la hora, y ya estamos en ella, en que los muertos oirán la voz del Hijo de Dios, y los que la escuchen vivirán."
,"26":"Así como el Padre tiene vida en sí mismo, también ha dado al Hijo tener vida en sí mismo."
,"27":"Y además le ha dado autoridad para llevar a cabo el juicio, porque es hijo de hombre."
,"28":"No se asombren de esto; llega la hora en que todos los que estén en los sepulcros oirán mi voz."
,"29":"Los que obraron el bien resucitarán para la vida, pero los que obraron el mal irán a la condenación."
,"30":"Yo no puedo hacer nada por mi cuenta, sino que juzgo conforme a lo que escucho; así mi juicio es recto, porque no busco mi voluntad, sino la voluntad de Aquel que me envió."
,"31":"Si yo hago de testigo en mi favor, mi testimonio no tendrá valor."
,"32":"Pero Otro está dando testimonio de mí, y yo sé que es verdadero cuando da testimonio de mí."
,"33":"Ustedes mandaron interrogar a Juan, y él dio testimonio de la verdad."
,"34":"Yo les recuerdo esto para bien de ustedes, para que se salven, porque personalmente yo no me hago recomendar por hombres."
,"35":"Juan era una antorcha que ardía e iluminaba, y ustedes por un tiempo se sintieron a gusto con su luz."
,"36":"Pero yo tengo un testimonio que vale más que el de Juan: son las obras que el Padre me encomendó realizar. Estas obras que yo hago hablan por mí y muestran que el Padre me ha enviado. "
,"37":"Y el Padre que me ha enviado también da testimonio de mí. Ustedes nunca han oído su voz ni visto su rostro;"
,"38":"y tampoco tienen su palabra, pues no creen al que él ha enviado."
,"39":"Ustedes escudriñan las Escrituras pensando que encontrarán en ellas la vida eterna, y justamente ellas dan testimonio de mí."
,"40":"Sin embargo ustedes no quieren venir a mí para tener vida."
,"41":"Yo no busco la alabanza de los hombres."
,"42":"Sé sin embargo que el amor de Dios no está en ustedes,"
,"43":"porque he venido en nombre de mi Padre, y ustedes no me reciben. Si algún otro viene en su propio nombre, a ése sí lo acogerán."
,"44":"Mientras hacen caso de las alabanzas que se dan unos a otros y no buscan la gloria que viene del Unico Dios, ¿cómo podrán creer?"
,"45":"No piensen que seré yo quien los acuse ante el Padre. Es Moisés quien los acusa, aquel mismo en quien ustedes confían."
,"46":"Si creyeran a Moisés, me creerían también a mí, porque él escribió de mí."
,"47":"Pero si ustedes no creen lo que escribió Moisés, ¿cómo van a creer lo que les digo yo?'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Después Jesús pasó a la otra orilla del lago de Galilea, cerca de Tiberíades."
,"2":"Le seguía un enorme gentío a causa de las señales milagrosas que le veían hacer en los enfermos."
,"3":"Jesús subió al monte y se sentó allí con sus discípulos."
,"4":"Se acercaba la Pascua, la fiesta de los judíos."
,"5":"Jesús, pues, levantó los ojos y, al ver el numeroso gentío que acudía a él, dijo a Felipe: '¿Dónde iremos a comprar pan para que coma esa gente?'"
,"6":"Se lo preguntaba para ponerlo a prueba, pues él sabía bien lo que iba a hacer."
,"7":"Felipe le respondió: 'Doscientas monedas de plata no alcanzarían para dar a cada uno un pedazo.'"
,"8":"Otro discípulo, Andrés, hermano de Simón Pedro, dijo:"
,"9":"'Aquí hay un muchacho que tiene cinco panes de cebada y dos pescados. Pero, ¿qué es esto para tanta gente?'"
,"10":"Jesús les dijo: 'Hagan que se siente la gente.',Había mucho pasto en aquel lugar, y se sentaron los hombres en número de unos cinco mil. "
,"11":"Entonces Jesús tomó los panes, dio las gracias y los repartió entre los que estaban sentados. Lo mismo hizo con los pescados, y todos recibieron cuanto quisieron."
,"12":"Cuando quedaron satisfechos, Jesús dijo a sus discípulos: 'Recojan los pedazos que han sobrado para que no se pierda nada.'"
,"13":"Los recogieron y llenaron doce canastos con los pedazos que no se habían comido: eran las sobras de los cinco panes de cebada."
,"14":"Al ver la señal que Jesús había hecho, los hombres decían: 'Este es sin duda el Profeta que había de venir al mundo.'"
,"15":"Jesús se dio cuenta de que iban a tomarlo por la fuerza para proclamarlo rey, y nuevamente huyó al monte él solo."
,"16":"Al llegar la noche, sus discípulos bajaron a la orilla"
,"17":"y, subiendo a una barca, cruzaron el lago rumbo a Cafarnaún. Habían visto caer la noche sin que Jesús se hubiera reunido con ellos,"
,"18":"y empezaban a formarse grandes olas debido al fuerte viento que soplaba."
,"19":"Habían remado como unos cinco kilómetros cuando vieron a Jesús que caminaba sobre el mar y se acercaba a la barca, y se llenaron de espanto."
,"20":"Pero él les dijo: 'Soy Yo, no tengan miedo.'"
,"21":"Quisieron subirlo a la barca, pero la barca se encontró en seguida en la orilla adonde se dirigían."
,"22":"Al día siguiente, la gente que se había quedado al otro lado del lago se dio cuenta que allí no había habido más que una barca y que Jesús no había subido con sus discípulos en la barca, sino que éstos se habían ido solos."
,"23":"Mientras tanto algunas lanchas de Tiberíades habían atracado muy cerca del lugar donde todos habían comido el pan."
,"24":"Al ver que ni Jesús ni sus discípulos estaban allí, la gente subió a las lanchas y se dirigieron a Cafarnaún en busca de Jesús."
,"25":"Al encontrarlo al otro lado del lago, le preguntaron: 'Rabbí (Maestro), ¿cómo has venido aquí?'"
,"26":"Jesús les contestó: 'En verdad les digo: Ustedes me buscan, no porque han visto a través de los signos, sino porque han comido pan hasta saciarse."
,"27":"Trabajen, no por el alimento de un día, sino por el alimento que permanece y da vida eterna. Este se lo dará el Hijo del hombre; él ha sido marcado con el sello del Padre.'"
,"28":"Entonces le preguntaron: '¿Qué tenemos que hacer para trabajar en las obras de Dios?'"
,"29":"Jesús respondió: 'La obra de Dios es ésta: creer en aquel que Dios ha enviado.'"
,"30":"Le dijeron: '¿Qué puedes hacer? ¿Qué señal milagrosa haces tú, para que la veamos y creamos en ti? ¿Cuál es tu obra?"
,"31":"Nuestros antepasados comieron el maná en el desierto, según dice la Escritura: Se les dio a comer pan del cielo.'"
,"32":"Jesús contestó: 'En verdad les digo: No fue Moisés quien les dio el pan del cielo. Es mi Padre el que les da el verdadero pan del cielo."
,"33":"El pan que Dios da es Aquel que baja del cielo y que da vida al mundo.'"
,"34":"Ellos dijeron: 'Señor, danos siempre de ese pan.'"
,"35":"Jesús les dijo: 'Yo soy el pan de vida. El que viene a mí nunca tendrá hambre y el que cree en mí nunca tendrá sed."
,"36":"Sin embargo, como ya les dije, ustedes se niegan a creer aun después de haber visto."
,"37":"Todo lo que el Padre me ha dado vendrá a mí, y yo no rechazaré al que venga a mí,"
,"38":"porque yo he bajado del cielo, no para hacer mi voluntad, sino la voluntad del que me ha enviado."
,"39":"Y la voluntad del que me ha enviado es que yo no pierda nada de lo que él me ha dado, sino que lo resucite en el último día."
,"40":"Sí, ésta es la decisión de mi Padre: toda persona que al contemplar al Hijo crea en él, tendrá vida eterna, y yo lo resucitaré en el último día.'"
,"41":"Los judíos murmuraban porque Jesús había dicho: 'Yo soy el pan que ha bajado del cielo.'"
,"42":"Y decían: 'Conocemos a su padre y a su madre, ¿no es cierto? El no es sino Jesús, el hijo de José. ¿Cómo puede decir que ha bajado del cielo?'"
,"43":"Jesús les contestó: 'No murmuren entre ustedes."
,"44":"Nadie puede venir a mí si no lo atrae el Padre que me envió. Y yo lo resucitaré en el último día."
,"45":"Está escrito en los Profetas: Serán todos enseñados por Dios, y es así como viene a mí toda persona que ha escuchado al Padre y ha recibido su enseñanza."
,"46":"Pues, por supuesto que nadie ha visto al Padre: sólo Aquel que ha venido de Dios ha visto al Padre."
,"47":"En verdad les digo: El que cree tiene vida eterna."
,"48":"Yo soy el pan de vida."
,"49":"Sus antepasados comieron el maná en el desierto, pero murieron:"
,"50":"aquí tienen el pan que baja del cielo, para que lo coman y ya no mueran."
,"51":"Yo soy el pan vivo que ha bajado del cielo. El que coma de este pan vivirá para siempre. El pan que yo daré es mi carne, y lo daré para la vida del mundo.'"
,"52":"Los judíos discutían entre sí: '¿Cómo puede éste darnos a comer carne?'"
,"53":"Jesús les dijo: 'En verdad les digo que si no comen la carne del Hijo del Hombre y no beben su sangre, no tienen vida en ustedes."
,"54":"El que come mi carne y bebe mi sangre vive de vida eterna, y yo lo resucitaré el último día."
,"55":"Mi carne es verdadera comida y mi sangre es verdadera bebida."
,"56":"El que come mi carne y bebe mi sangre permanece en mí y yo en él."
,"57":"Como el Padre, que es vida, me envió y yo vivo por el Padre, así quien me come vivirá por mí."
,"58":"Este es el pan que ha bajado del cielo. Pero no como el de vuestros antepasados, que comieron y después murieron. El que coma este pan vivirá para siempre."
,"59":"Así habló Jesús en Cafarnaún enseñando en la sinagoga."
,"60":"Al escucharlo, cierto número de discípulos de Jesús dijeron: '¡Este lenguaje es muy duro! ¿Quién querrá escucharlo?'"
,"61":"Jesús se dio cuenta de que sus discípulos criticaban su discurso y les dijo: '¿Les desconcierta lo que he dicho?"
,"62":"¿Qué será, entonces, cuando vean al Hijo del hombre subir al lugar donde estaba antes?"
,"63":"El espíritu es el que da vida, la carne no sirve para nada. Las palabras que les he dicho son espíritu y vida."
,"64":"Pero hay entre ustedes algunos que no creen.',Porque Jesús sabía desde el principio quiénes eran los que no creían y quién lo iba a entregar. "
,"65":"Y agregó: 'Como he dicho antes, nadie puede venir a mí si no se lo concede el Padre.'"
,"66":"A partir de entonces muchos de sus discípulos se volvieron atrás y dejaron de seguirle."
,"67":"Jesús preguntó a los Doce: '¿Quieren marcharse también ustedes?'"
,"68":"Pedro le contestó: 'Señor, ¿a quién iríamos? Tú tienes palabras de vida eterna."
,"69":"Nosotros creemos y sabemos que tú eres el Santo de Dios.'"
,"70":"Jesús les dijo: '¿No los elegí yo a ustedes, a los Doce? Y sin embargo uno de ustedes es un diablo.'"
,"71":"Jesús se refería a Judas Iscariote, hijo de Simón, pues era uno de los Doce y lo iba a traicionar."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Después de esto, Jesús iba de un lugar a otro por Galilea; no quería estar en Judea porque los judíos deseaban matarle."
,"2":"Se acercaba la fiesta de los judíos llamada de las Tiendas."
,"3":"Sus hermanos le dijeron: 'No te quedes aquí, vete a Judea para que tus discípulos de allí vean las obras que realizas."
,"4":"Si uno quiere sobresalir, no actúa a escondidas. Tú, que haces maravillas, date a conocer al mundo.'"
,"5":"Sus hermanos hablaban así porque no creían en él."
,"6":"Jesús les contestó: 'Todavía no ha llegado mi tiempo, mientras que para ustedes todo tiempo es bueno."
,"7":"El mundo no puede odiarlos a ustedes, pero a mí sí que me odia, porque yo muestro que sus obras son malas."
,"8":"Suban ustedes a la fiesta; yo no voy a esta fiesta, porque mi tiempo aún no ha llegado.'"
,"9":"Así habló Jesús y se quedó en Galilea."
,"10":"Solamente después que sus hermanos fueron a la fiesta subió él también, pero sin decirlo y como en secreto."
,"11":"Los judíos lo estaban buscando durante la fiesta y preguntaban: '¿Dónde está ése?'"
,"12":"Corrían muchos comentarios sobre él entre la gente. Unos decían: 'Es muy buena persona.' Otros replicaban: 'En absoluto, ése está engañando al pueblo.'"
,"13":"Pero nadie hablaba abiertamente de él por miedo a los judíos."
,"14":"Hacia la mitad de la semana de la fiesta, Jesús subió al Templo y se puso a enseñar."
,"15":"Los judíos, admirados, decían: '¿Cómo puede conocer las Escrituras sin haber tenido maestro?'"
,"16":"Jesús les contestó: 'Mi doctrina no viene de mí, sino del que me ha enviado."
,"17":"El que haga la voluntad de Dios conocerá si mi doctrina viene de él o si hablo por mi propia cuenta."
,"18":"El que habla en nombre propio busca su propia gloria. Pero el que busca la gloria del que lo ha enviado, ése es un hombre sin maldad y que dice la verdad.'"
,"19":"'Moisés les dio la Ley, ¿no es cierto? Pero si ninguno de ustedes cumple la Ley, ¿por qué quieren matarme?'"
,"20":"Le gritaron: 'Eres víctima de un mal espíritu. ¿Quién quiere matarte?'"
,"21":"Jesús les respondió: 'Esta no es más que mi primera intervención, y todos ustedes están desconcertados."
,"22":"Pero miren: Moisés les ha dado la circuncisión (aunque en realidad no viene de Moisés sino de los patriarcas) y ustedes hacen la circuncisión incluso en día sábado."
,"23":"Un hombre debe recibir la circuncisión, aunque sea sábado, para no quebrantar la ley de Moisés; entonces, ¿por qué se enojan conmigo porque he salvado al hombre entero en día sábado?"
,"24":"No juzguen por las apariencias, sino juzguen lo que es justo.'"
,"25":"Algunos habitantes de Jerusalén decían: 'Pero, ¿no es éste al que quieren matar?"
,"26":"Pues ahí lo tienen hablando con toda libertad y no le dicen nada. ¿Será tal vez que nuestros dirigentes han reconocido que él es el Mesías?"
,"27":"Pero éste sabemos de dónde viene, mientras que cuando venga el Mesías, nadie sabrá de dónde viene.'"
,"28":"Entonces Jesús dijo en voz muy alta mientras enseñaba en el Templo: 'Ustedes dicen que me conocen. Ustedes saben de dónde vengo. Sepan que yo no he venido por mi propia cuenta: quien me envía es el Verdadero, y ustedes no lo conocen."
,"29":"El es el que me ha enviado, y yo lo conozco porque vengo de él.'"
,"30":"Los judíos hubieran querido llevarlo preso, pero nadie le puso las manos encima porque todavía no había llegado su hora."
,"31":"De todos modos, muchos del pueblo creyeron en él y decían: 'Cuando venga el Mesías, ¿hará más señales milagrosas que este hombre?'"
,"32":"Los fariseos se enteraron de los comentarios que hacía la gente sobre Jesús y, de acuerdo con los jefes de los sacerdotes, enviaron guardias del Templo para detenerlo."
,"33":"Entonces Jesús dijo: 'Todavía estaré con ustedes un poco más de tiempo, y después me iré al que me ha enviado."
,"34":"Ustedes me buscarán, pero no me encontrarán, porque ustedes no pueden venir donde yo estoy.'"
,"35":"Los judíos se preguntaban: '¿Adónde piensa ir éste para que no lo podamos encontrar? ¿Querrá tal vez visitar a los judíos dispersos entre los griegos y enseñar a los mismos griegos?"
,"36":"¿Qué quiere decir con eso de: 'Me buscarán y no me encontrarán', y 'Ustedes no pueden venir donde yo estoy'?'"
,"37":"El último día de la fiesta, que era el más solemne, Jesús, puesto en pie, exclamó con voz potente: 'El que tenga sed, que venga a mí."
,"38":"Pues el que cree en mí tendrá de beber. Lo dice la Escritura: De él saldrán ríos de agua viva.'"
,"39":"Decía esto Jesús refiriéndose al Espíritu Santo que recibirían los que creyeran en él. Todavía no se comunicaba el Espíritu, porque Jesús aún no había entrado en su gloria."
,"40":"Muchos de los que escucharon esto decían: 'Realmente este hombre es el Profeta.'"
,"41":"Unos afirmaban: 'Este es el Mesías.' Pero otros decían: '¿Cómo va a venir el Mesías de Galilea?"
,"42":"¿No dice la Escritura que el Mesías es un descendiente de David y que saldrá de Belén, la ciudad de David?'"
,"43":"La gente, pues, estaba dividida a causa de Jesús."
,"44":"Algunos querían llevarlo preso, pero nadie le puso las manos encima."
,"45":"Cuando los guardias del Templo volvieron a donde los sacerdotes y los fariseos, les preguntaron: '¿Por qué no lo han traído?'"
,"46":"Los guardias contestaron: 'Nunca hombre alguno ha hablado como éste.'"
,"47":"Los fariseos les dijeron: '¿También ustedes se han dejado engañar?"
,"48":"¿Hay algún jefe o algún fariseo que haya creído en él?"
,"49":"Pero esa gente que no conoce la Ley, ¡son unos malditos!'"
,"50":"Les respondió Nicodemo, el que había ido antes a ver a Jesús y que era uno de ellos. Dijo:"
,"51":"'¿Acaso nuestra ley permite condenar a un hombre sin escucharle antes y sin averiguar lo que ha hecho?'"
,"52":"Le contestaron: '¿También tú eres de Galilea? Estudia las Escrituras y verás que de Galilea no salen profetas.'"
,"53":"Y se fue cada uno a su casa."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Jesús, por su parte, se fue al monte de los Olivos."
,"2":"Al amanecer estaba ya nuevamente en el Templo; toda la gente acudía a él, y él se sentaba para enseñarles."
,"3":"Los maestros de la Ley y los fariseos le trajeron una mujer que había sido sorprendida en adulterio. La colocaron en medio"
,"4":"y le dijeron: 'Maestro, esta mujer es una adúltera y ha sido sorprendida en el acto."
,"5":"En un caso como éste la Ley de Moisés ordena matar a pedradas a la mujer. Tú, ¿qué dices?'"
,"6":"Le hacían esta pregunta para ponerlo en dificultades y tener algo de qué acusarlo. Pero Jesús se inclinó y se puso a escribir en el suelo con el dedo. "
,"7":"Como ellos insistían en preguntarle, se enderezó y les dijo: 'Aquel de ustedes que no tenga pecado, que le arroje la primera piedra.'"
,"8":"Se inclinó de nuevo y siguió escribiendo en el suelo."
,"9":"Al oír estas palabras, se fueron retirando uno tras otro, comenzando por los más viejos, hasta que se quedó Jesús solo con la mujer, que seguía de pie ante él."
,"10":"Entonces se enderezó y le dijo: 'Mujer, ¿dónde están? ¿Ninguno te ha condenado?'"
,"11":"Ella contestó: 'Ninguno, señor.' Y Jesús le dijo: 'Tampoco yo te condeno. Vete y en adelante no vuelvas a pecar.'"
,"12":"Jesús les habló de nuevo diciendo: 'Yo soy la luz del mundo. El que me sigue no caminará en tinieblas, sino que tendrá luz y vida.'"
,"13":"Los fariseos replicaron: 'Estás hablando en tu propio favor; tu testimonio no vale nada.'"
,"14":"Jesús les contestó: 'Aunque yo hable en mi favor, mi declaración vale, porque yo sé de dónde he venido y adónde voy. Ustedes son los que no saben de dónde he venido ni adónde voy."
,"15":"Ustedes juzgan con criterios humanos; yo no juzgo a nadie."
,"16":"Y si yo tuviera que juzgar, mi juicio sería válido, porque yo no estoy solo; el Padre que me envió está conmigo."
,"17":"En la Ley de ustedes está escrito que con dos personas el testimonio es válido."
,"18":"Yo doy testimonio de mí mismo, y también el Padre que me ha enviado da testimonio de mí.'"
,"19":"Le preguntaron: '¿Dónde está tu Padre?' Jesús les contestó: 'Ustedes no me conocen a mí ni a mi Padre; si me conocieran a mí, conocerían también a mi Padre.'"
,"20":"Jesús dijo estas cosas en el lugar donde se reciben las ofrendas, cuando estaba enseñando en el Templo, pero nadie lo detuvo, porque aún no había llegado su hora."
,"21":"De nuevo Jesús les dijo: 'Yo me voy y ustedes me buscarán. Pero ustedes no pueden ir a donde yo voy y morirán en su pecado.'"
,"22":"Los judíos se preguntaban: '¿Por qué dice que a donde él va nosotros no podemos ir? ¿Pensará tal vez en suicidarse?'"
,"23":"Pero Jesús les dijo: 'Ustedes son de abajo, yo soy de arriba. Ustedes son de este mundo, yo no soy de este mundo."
,"24":"Por eso les he dicho que morirán en sus pecados. Yo les digo que si ustedes no creen que Yo soy, morirán en sus pecados.'"
,"25":"Le preguntaron: 'Pero ¿quién eres tú?' Jesús les contestó: 'Exactamente lo que acabo de decirles."
,"26":"Tengo mucho que decir sobre ustedes y mucho que condenar, pero lo que digo al mundo lo aprendí del que me ha enviado: él es veraz.'"
,"27":"Ellos no comprendieron que Jesús les hablaba del Padre."
,"28":"Y añadió: 'Cuando levanten en alto al Hijo del hombre, entonces conocerán que Yo soy y que no hago nada por mi cuenta, sino que sólo digo lo que el Padre me ha enseñado."
,"29":"El que me ha enviado está conmigo y no me deja nunca solo, porque yo hago siempre lo que le agrada a él.'"
,"30":"Esto es lo que decía Jesús, y muchos creyeron en él."
,"31":"Jesús decía a los judíos que habían creído en él: 'Ustedes serán verdaderos discípulos míos si perseveran en mi palabra;"
,"32":"entonces conocerán la verdad, y la verdad los hará libres.'"
,"33":"Le respondieron: 'Somos descendientes de Abrahán y nunca hemos sido esclavos de nadie. ¿Por qué dices: 'Ustedes serán libres'?'"
,"34":"Jesús les contestó: 'En verdad, en verdad les digo: el que vive en el pecado es esclavo del pecado."
,"35":"Pero el esclavo no se quedará en la casa para siempre; el hijo, en cambio, permanece para siempre."
,"36":"Por tanto, si el Hijo los hace libres, ustedes serán realmente libres."
,"37":"Yo sé que ustedes son descendientes de Abrahán, pero mi palabra no tiene acogida en ustedes, y por eso tratan de matarme."
,"38":"Yo hablo de lo que he visto junto a mi Padre, y ustedes hacen lo que han aprendido de su padre.'"
,"39":"Ellos le cortaron la palabra: 'Nuestro padre es Abrahán.' Entonces Jesús les dijo: 'Si ustedes fueran hijos de Abrahán, actuarían como Abrahán."
,"40":"Pero viene alguien que les dice la verdad, la verdad que he aprendido de Dios, y ustedes quieren matarme. Esta no es la manera de actuar de Abrahán."
,"41":"Ustedes actúan como hizo su padre.',Los judíos le dijeron: 'Nosotros no somos hijos ilegítimos, no tenemos más que un solo padre: Dios.' "
,"42":"Jesús les replicó: 'Si Dios fuera su Padre, ustedes me amarían a mí, porque yo he salido de Dios para venir aquí. No he venido por iniciativa propia, sino que él mismo me ha enviado."
,"43":"¿Por qué no entienden mi lenguaje? Porque no pueden acoger mi mensaje."
,"44":"Ustedes tienen por padre al diablo y quieren realizar los malos deseos de su padre. Ha sido un asesino desde el principio, porque la verdad no está en él, y no se ha mantenido en la verdad. Lo que le ocurre decir es mentira, porque es un mentiroso y padre de toda mentira."
,"45":"Por eso ustedes no me creen cuando les digo la verdad."
,"46":"¿Quién de ustedes encontrará falsedad en mí? Y si les digo la verdad, ¿por qué no me creen?"
,"47":"El que es de Dios escucha las palabras de Dios; ustedes no las escuchan porque no son de Dios.'"
,"48":"Los judíos le replicaron: 'Tenemos razón en decir que eres un samaritano y que estás poseído por un demonio.'"
,"49":"Jesús les dijo: 'Yo no tengo un demonio, pero ustedes me deshonran a mí porque honro a mi Padre."
,"50":"Yo no tengo por qué defender mi honor, hay otro que se preocupa por mí y hará justicia."
,"51":"En verdad les digo: el que guarda mi palabra no probará la muerte jamás.'"
,"52":"Los judíos replicaron: 'Ahora sabemos que eres víctima de un mal espíritu. Abrahán murió y también los profetas, ¿y tú dices: 'Quien guarda mi palabra jamás probará la muerte'?"
,"53":"¿Eres tú más grande que nuestro padre Abrahán, que murió, lo mismo que murieron los Profetas? ¿Quién te crees?'"
,"54":"Jesús les contestó: 'Si yo me doy gloria a mí mismo, mi gloria no vale nada; es el Padre quien me da gloria, el mismo que ustedes llaman 'nuestro Dios'."
,"55":"Ustedes no lo conocen, yo sí lo conozco, y si dijera que no lo conozco, sería un mentiroso como ustedes. Pero yo lo conozco y guardo su palabra."
,"56":"En cuanto a Abrahán, padre de ustedes, se alegró pensando ver mi día. Lo vio y se regocijó.'."
,"57":"Entonces los judíos le dijeron: '¿Aún no tienes cincuenta años y has visto a Abrahán?'"
,"58":"Contestó Jesús: 'En verdad les digo que antes que Abrahán existiera, Yo soy.'"
,"59":"Entonces tomaron piedras para lanzárselas, pero Jesús se ocultó y salió del Templo."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Al pasar, Jesús vio a un hombre que era ciego de nacimiento."
,"2":"Sus discípulos le preguntaron: 'Maestro, ¿quién ha pecado para que esté ciego: él o sus padres?'"
,"3":"Jesús respondió: 'Esta cosa no es por haber pecado él o sus padres, sino para que unas obras de Dios se hagan en él, y en forma clarísima."
,"4":"Mientras es de día tenemos que hacer la obra del que me ha enviado; porque vendrá la noche, cuando nadie puede trabajar."
,"5":"Mientras estoy en el mundo, soy la luz del mundo.'"
,"6":"Dicho esto, hizo un poco de lodo con tierra y saliva, untó con él los ojos del ciego"
,"7":"y le dijo: 'Vete y lávate en la piscina de Siloé (que quiere decir el Enviado).' El ciego fue, se lavó y, cuando volvió, veía claramente."
,"8":"Sus vecinos y los que lo habían visto pidiendo limosna, decían: '¿No es éste el que se sentaba aquí y pedía limosna?'"
,"9":"Unos decían: 'Es él.' Otros, en cambio: 'No, es uno que se le parece'."
,"10":"Pero él afirmaba: 'Sí, soy yo.' Le preguntaron: '¿Cómo es que ahora puedes ver?'"
,"11":"Contestó: 'Ese hombre al que llaman Jesús hizo barro, me lo aplicó a los ojos y me dijo que fuera a lavarme a la piscina de Siloé. Fui, me lavé y veo.'"
,"12":"Le preguntaron: '¿Dónde está él?' Contestó: 'No lo sé.'"
,"13":"La gente llevó ante los fariseos al que había sido ciego."
,"14":"Pero coincidió que ese día en que Jesús hizo lodo y abrió los ojos al ciego era día de descanso."
,"15":"Y como nuevamente los fariseos preguntaban al hombre cómo había recobrado la vista, él contestó: 'Me puso barro en los ojos, me lavé y veo.'"
,"16":"Algunos fariseos, pues, dijeron: 'Ese hombre, que trabaja en día sábado, no puede venir de Dios.' Pero otros decían: '¿Puede ser un pecador el que realiza tales milagros?' Y estaban divididos."
,"17":"Entonces le preguntaron de nuevo al ciego: 'Ese te ha abierto los ojos, ¿qué piensas tú de él?' El contestó: 'Que es un profeta.'"
,"18":"Los judíos no quisieron creer que antes era ciego y que había recobrado la vista, hasta que no llamaran a sus padres."
,"19":"Y les preguntaron: '¿Es éste su hijo? ¿Y ustedes dicen que nació ciego? ¿Y cómo es que ahora ve?'"
,"20":"Los padres respondieron: 'Sabemos que es nuestro hijo y que nació ciego."
,"21":"Pero cómo es que ahora ve, no lo sabemos, y quién le abrió los ojos, tampoco. Pregúntenle a él, que es adulto y puede responder de sí mismo.'"
,"22":"Los padres contestaron así por miedo a los judíos, pues éstos habían decidido expulsar de sus comunidades a los que reconocieran a Jesús como el Mesías."
,"23":"Por eso dijeron: 'Es mayor de edad, pregúntenle a él.'"
,"24":"De nuevo los fariseos volvieron a llamar al hombre que había sido ciego y le dijeron: 'Confiesa la verdad; nosotros sabemos que ese hombre que te sanó es un pecador.'"
,"25":"El respondió: 'Yo no sé si es un pecador; lo que sé es que yo era ciego y ahora veo.'"
,"26":"Le preguntaron: '¿Qué te hizo? ¿Cómo te abrió los ojos?'"
,"27":"El les dijo: 'Ya se lo he dicho y no me han escuchado. ¿Para qué quieren oírlo otra vez? ¿También ustedes quieren hacerse discípulos suyos?'"
,"28":"Entonces comenzaron a insultarlo. 'Tú serás discípulo suyo. Nosotros somos discípulos de Moisés."
,"29":"Sabemos que a Moisés le habló Dios, pero ése no sabemos ni siquiera de dónde es.'"
,"30":"El hombre contestó: 'Esto es lo extraño: él me ha abierto los ojos y ustedes no entienden de dónde viene."
,"31":"Es sabido que Dios no escucha a los pecadores, pero al que honra a Dios y cumple su voluntad, Dios lo escucha."
,"32":"Jamás se ha oído decir que alguien haya abierto los ojos de un ciego de nacimiento."
,"33":"Si éste no viniera de Dios, no podría hacer nada.'"
,"34":"Le contestaron ellos: 'No eres más que pecado desde tu nacimiento, ¿y pretendes darnos lecciones a nosotros?' Y lo expulsaron."
,"35":"Jesús se enteró de que lo habían expulsado. Cuando lo encontró le dijo: '¿Tú crees en el Hijo del Hombre?'"
,"36":"Le contestó: '¿Y quién es, Señor, para que crea en él?'"
,"37":"Jesús le dijo: 'Tú lo has visto, y es el que está hablando contigo.'"
,"38":"El entonces dijo: 'Creo, Señor'. Y se arrodilló ante él."
,"39":"Jesús añadió: 'He venido a este mundo para llevar a cabo un juicio: los que no ven, verán, y los que ven, se volverán ciegos.'"
,"40":"Al oír esto, algunos fariseos que estaban allí con él le dijeron: '¿Así que también nosotros somos ciegos?'"
,"41":"Jesús les contestó: 'Si fueran ciegos, no tendrían pecado. Pero ustedes dicen: 'Vemos', y ésa es la prueba de su pecado.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"'En verdad les digo: el que no entra por la puerta en el corral de las ovejas, sino que salta por algún otro lado, ése es un ladrón y un salteador."
,"2":"El que entra por la puerta es el pastor de las ovejas."
,"3":"El cuidador le abre y las ovejas escuchan su voz; llama por su nombre a cada una de sus ovejas y las saca fuera."
,"4":"Cuando ha sacado todas sus ovejas, empieza a caminar delante de ellas, y las ovejas lo siguen porque conocen su voz."
,"5":"A otro no lo seguirían, sino que huirían de él, porque no conocen la voz de los extraños.'"
,"6":"Jesús usó esta comparación, pero ellos no comprendieron lo que les quería decir."
,"7":"Jesús, pues, tomó de nuevo la palabra: En verdad les digo que yo soy la puerta de las ovejas."
,"8":"Todos los que han venido eran ladrones y malhechores, y las ovejas no les hicieron caso."
,"9":"Yo soy la puerta: el que entre por mí estará a salvo; entrará y saldrá y encontrará alimento."
,"10":"El ladrón sólo viene a robar, matar y destruir, mientras que yo he venido para que tengan vida y la tengan en plenitud."
,"11":"Yo soy el Buen Pastor. El buen pastor da su vida por las ovejas."
,"12":"No así el asalariado, que no es el pastor ni las ovejas son suyas. Cuando ve venir al lobo, huye abandonando las ovejas, y el lobo las agarra y las dispersa."
,"13":"A él sólo le interesa su salario y no le importan nada las ovejas."
,"14":"Yo soy el Buen Pastor y conozco a los míos como los míos me conocen a mí,"
,"15":"lo mismo que el Padre me conoce a mí y yo conozco al Padre. Y yo doy mi vida por las ovejas."
,"16":"Tengo otras ovejas que no son de este corral. A esas también las llevaré; escucharán mi voz, y habrá un solo rebaño con un solo pastor."
,"17":"El Padre me ama porque yo doy mi vida para retomarla de nuevo."
,"18":"Nadie me la quita, sino que yo mismo la entrego. En mis manos está el entregarla y el recobrarla: éste es el mandato que recibí de mi Padre.'"
,"19":"Nuevamente se dividieron los judíos a causa de estas palabras."
,"20":"Algunos decían: 'Es víctima de un espíritu malo y habla locuras; ¿para qué escucharlo?'"
,"21":"Pero otros decían: 'Un endemoniado no habla de esa manera. ¿Puede acaso un demonio abrir los ojos de los ciegos?'"
,"22":"Era invierno y en Jerusalén se celebraba la fiesta de la Dedicación del Templo."
,"23":"Jesús se paseaba en el Templo, por el pórtico de Salomón,"
,"24":"cuando los judíos lo rodearon y le dijeron: '¿Hasta cuándo nos vas a tener en suspenso? Si tú eres el Mesías, dínoslo claramente.'"
,"25":"Jesús les respondió: 'Ya se lo he dicho, pero ustedes no creen. Las obras que hago en el nombre de mi Padre manifiestan quién soy yo,"
,"26":"pero ustedes no creen porque no son ovejas mías."
,"27":"Mis ovejas escuchan mi voz y yo las conozco. Ellas me siguen,"
,"28":"y yo les doy vida eterna. Nunca perecerán y nadie las arrebatará jamás de mi mano."
,"29":"Aquello que el Padre me ha dado es más fuerte que todo, y nadie puede arrebatarlo de la mano de mi Padre."
,"30":"Yo y el Padre somos una sola cosa.'"
,"31":"Entonces los judíos tomaron de nuevo piedras para tirárselas."
,"32":"Jesús les dijo: 'He hecho delante de ustedes muchas obras hermosas que procedían del Padre; ¿por cuál de ellas me quieren apedrear?'"
,"33":"Los judíos respondieron: 'No te apedreamos por algo hermoso que hayas hecho, sino por insultar a Dios; porque tú, siendo hombre, te haces Dios.'"
,"34":"Jesús les contestó: '¿No está escrito en su Ley: Yo he dicho que son dioses?"
,"35":"No se puede cambiar la Escritura, y en ese lugar llama dioses a los que recibieron esta palabra de Dios."
,"36":"Y yo, que fui consagrado y enviado al mundo por el Padre, ¿estaría insultando a Dios al decir que soy el Hijo de Dios?"
,"37":"Si yo no hago las obras del Padre, no me crean."
,"38":"Pero si las hago, si no me creen a mí, crean a esas obras, para que sepan y reconozcan que el Padre está en mí y yo en el Padre.'"
,"39":"Otra vez quisieron llevarlo preso, pero Jesús se les escapó de las manos."
,"40":"Se marchó de nuevo al otro lado del Jordán, donde Juan bautizaba al principio, y se quedó allí."
,"41":"Mucha gente acudió a él, y decían: 'Juan no hizo ninguna señal milagrosa, pero todo lo que dijo de éste era verdad.'"
,"42":"Y muchos creyeron en él en aquel lugar."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Había un hombre enfermo llamado Lázaro, que era de Betania, el pueblo de María y de su hermana Marta."
,"2":"Esta María era la misma que ungió al Señor con perfume y le secó los pies con sus cabellos. Su hermano Lázaro era el enfermo."
,"3":"Las dos hermanas mandaron a decir a Jesús: 'Señor, el que tú amas está enfermo.'"
,"4":"Al oírlo Jesús, dijo: 'Esta enfermedad no terminará en muerte, sino que es para gloria de Dios, y el Hijo del Hombre será glorificado por ella.'"
,"5":"Jesús quería mucho a Marta, a su hermana y a Lázaro."
,"6":"Sin embargo, cuando se enteró de que Lázaro estaba enfermo, permaneció aún dos días más en el lugar donde se encontraba."
,"7":"Sólo después dijo a sus discípulos: 'Volvamos de nuevo a Judea.'"
,"8":"Pero le replicaron: 'Maestro, hace poco querían apedrearte los judíos, ¿y tú quieres volver allá?'"
,"9":"Jesús les contestó: 'No hay jornada mientras no se han cumplido las doce horas. El que camina de día no tropezará, porque ve la luz de este mundo;"
,"10":"pero el que camina de noche tropezará; ése es un hombre que no tiene en sí mismo la luz.'"
,"11":"Después les dijo: 'Nuestro amigo Lázaro se ha dormido y voy a despertarlo.'"
,"12":"Los discípulos le dijeron: 'Señor, si duerme, recuperará la salud.'"
,"13":"En realidad Jesús quería decirles que Lázaro estaba muerto, pero los discípulos entendieron que se trataba del sueño natural."
,"14":"Entonces Jesús les dijo claramente: 'Lázaro ha muerto,"
,"15":"pero yo me alegro por ustedes de no haber estado allí, pues así ustedes creerán. Vamos a verlo.'"
,"16":"Entonces Tomás, apodado el Mellizo, dijo a los otros discípulos: 'Vayamos también nosotros a morir con él.'"
,"17":"Cuando llegó Jesús, Lázaro llevaba ya cuatro días en el sepulcro."
,"18":"Betania está a unos tres kilómetros de Jerusalén,"
,"19":"y muchos judíos habían ido a la casa de Marta y de María para consolarlas por la muerte de su hermano."
,"20":"Apenas Marta supo que Jesús llegaba, salió a su encuentro, mientras María permanecía en casa."
,"21":"Marta dijo a Jesús: 'Si hubieras estado aquí, mi hermano no habría muerto."
,"22":"Pero aun así, yo sé que puedes pedir a Dios cualquier cosa, y Dios te la concederá.'"
,"23":"Jesús le dijo: 'Tu hermano resucitará.'"
,"24":"Marta respondió: 'Ya sé que será resucitado en la resurrección de los muertos, en el último día.'"
,"25":"Le dijo Jesús: 'Yo soy la resurrección (y la vida). El que cree en mí, aunque muera, vivirá."
,"26":"El que vive, el que cree en mí, no morirá para siempre. ¿Crees esto?'"
,"27":"Ella contestó: 'Sí, Señor; yo creo que tú eres el Cristo, el Hijo de Dios, el que tenía que venir al mundo.'"
,"28":"Después Marta fue a llamar a su hermana María y le dijo al oído: 'El Maestro está aquí y te llama.'"
,"29":"Apenas lo oyó, María se levantó rápidamente y fue a donde él."
,"30":"Jesús no había entrado aún en el pueblo, sino que seguía en el mismo lugar donde Marta lo había encontrado."
,"31":"Los judíos que estaban con María en la casa consolándola, al ver que se levantaba aprisa y salía, pensaron que iba a llorar al sepulcro y la siguieron."
,"32":"Al llegar María a donde estaba Jesús, en cuanto lo vio, cayó a sus pies y le dijo: 'Señor, si hubieras estado aquí, mi hermano no habría muerto.'"
,"33":"Al ver Jesús el llanto de María y de todos los judíos que estaban con ella, su espíritu se conmovió profundamente y se turbó."
,"34":"Y preguntó: '¿Dónde lo han puesto?' Le contestaron: 'Señor, ven a ver.'"
,"35":"Y Jesús lloró."
,"36":"Los judíos decían: '¡Miren cómo lo amaba!'"
,"37":"Pero algunos dijeron: 'Si pudo abrir los ojos al ciego, ¿no podía haber hecho algo para que éste no muriera?'"
,"38":"Jesús, conmovido de nuevo en su interior, se acercó al sepulcro. Era una cueva cerrada con una piedra."
,"39":"Jesús ordenó: 'Quiten la piedra.' Marta, hermana del muerto, le dijo: 'Señor, ya tiene mal olor, pues lleva cuatro días.'"
,"40":"Jesús le respondió: '¿No te he dicho que si crees verás la gloria de Dios?'"
,"41":"Y quitaron la piedra. Jesús levantó los ojos al cielo y exclamó: 'Te doy gracias, Padre, porque me has escuchado. "
,"42":"Yo sabía que siempre me escuchas; pero yo lo digo por esta gente, porque así creerán que tú me has enviado.'"
,"43":"Al decir esto, gritó con fuerte voz: '¡Lázaro, sal fuera!'"
,"44":"Y salió el muerto. Tenía las manos y los pies atados con vendas y la cabeza cubierta con un velo. Jesús les dijo: 'Desátenlo y déjenlo caminar.'"
,"45":"Muchos judíos que habían ido a casa de María creyeron en Jesús al ver lo que había hecho."
,"46":"Pero otros fueron donde los fariseos y les contaron lo que Jesús había hecho."
,"47":"Entonces los jefes de los sacerdotes y los fariseos convocaron el Consejo y preguntaban: '¿Qué hacemos? Este hombre hace muchos milagros."
,"48":"Si lo dejamos que siga así, todos van a creer en él, y luego intervendrán los romanos y destruirán nuestro Lugar Santo y nuestra nación.'"
,"49":"Entonces habló uno de ellos, Caifás, que era el sumo sacerdote aquel año, y dijo: 'Ustedes no entienden nada."
,"50":"No se dan cuenta de que es mejor que muera un solo hombre por el pueblo y no que perezca toda la nación.'"
,"51":"Estas palabras de Caifás no venían de sí mismo, sino que, como era sumo sacerdote aquel año, profetizó en aquel momento; Jesús iba a morir por la nación;"
,"52":"y no sólo por la nación, sino también para reunir a los hijos de Dios que estaban dispersos."
,"53":"Y desde ese día estuvieron decididos a matarlo."
,"54":"Jesús ya no podía moverse libremente como quería entre los judíos. Se retiró, pues, a la región cercana al desierto y se quedó con sus discípulos en una ciudad llamada Efraín."
,"55":"Se acercaba la Pascua de los judíos, y de todo el país subían a Jerusalén para purificarse antes de la Pascua."
,"56":"Buscaban a Jesús y se decían unos a otros en el Templo: '¿Qué les parece? ¿Vendrá a la fiesta?'"
,"57":"Pues los jefes de los sacerdotes y los fariseos habían dado órdenes, y si alguien sabía dónde se encontraba Jesús, debía notificarlo para que fuera arrestado."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Seis días antes de la Pascua fue Jesús a Betania, donde estaba Lázaro, a quien Jesús había resucitado de entre los muertos."
,"2":"Allí lo invitaron a una cena. Marta servía y Lázaro estaba entre los invitados."
,"3":"María, pues, tomó una libra de un perfume muy caro, hecho de nardo puro, le ungió los pies a Jesús y luego se los secó con sus cabellos, mientras la casa se llenaba del olor del perfume."
,"4":"Judas Iscariote, el discípulo que iba a entregar a Jesús, dijo:"
,"5":"'Ese perfume se podría haber vendido en trescientas monedas de plata para ayudar a los pobres.'"
,"6":"En realidad no le importaban los pobres, sino que era un ladrón y, como estaba encargado de la bolsa común, se llevaba lo que echaban en ella."
,"7":"Pero Jesús dijo: 'Déjala, pues lo tenía reservado para el día de mi entierro."
,"8":"A los pobres los tienen siempre con ustedes, pero a mí no me tendrán siempre.'"
,"9":"Muchos judíos supieron que Jesús estaba allí y fueron, no sólo por ver a Jesús, sino también por ver a Lázaro, a quien había resucitado de entre los muertos."
,"10":"Entonces los jefes de los sacerdotes pensaron en dar muerte también a Lázaro,"
,"11":"pues por su causa muchos judíos se alejaban de ellos y creían en Jesús."
,"12":"Al día siguiente, muchos de los que habían llegado para la fiesta se enteraron de que Jesús también venía a Jerusalén."
,"13":"Entonces tomaron ramos de palma y salieron a su encuentro gritando: '¡Hosanna! ¡Bendito el que viene en nombre del Señor! ¡Bendito sea el Rey de Israel!'"
,"14":"Jesús encontró un burrito y se montó en él,"
,"15":"según dice la Escritura: No temas, ciudad de Sión, mira que viene tu Rey montado en un burrito."
,"16":"Los discípulos no se dieron cuenta de esto en aquel momento, pero cuando Jesús fue glorificado, recapacitaron que esto había sido escrito para él y que lo habían hecho para él."
,"17":"Toda la gente que había estado junto a Jesús cuando llamó a Lázaro del sepulcro y lo resucitó de entre los muertos, cantaba sus alabanzas,"
,"18":"y muchos otros vinieron a su encuentro a causa de la noticia de este milagro."
,"19":"Mientras tanto los fariseos comentaban entre sí: 'No hemos adelantado nada. Todo el mundo se ha ido tras él.'"
,"20":"También un cierto número de griegos, de los que adoran a Dios, habían subido a Jerusalén para la fiesta."
,"21":"Algunos se acercaron a Felipe, que era de Betsaida de Galilea, y le rogaron: 'Señor, quisiéramos ver a Jesús.'"
,"22":"Felipe habló con Andrés, y los dos fueron a decírselo a Jesús."
,"23":"Entonces Jesús dijo: 'Ha llegado la hora de que sea glorificado el Hijo del Hombre."
,"24":"En verdad les digo: Si el grano de trigo no cae en tierra y muere, queda solo; pero si muere, da mucho fruto."
,"25":"El que ama su vida la destruye; y el que desprecia su vida en este mundo, la conserva para la vida eterna."
,"26":"El que quiera servirme, que me siga, y donde yo esté, allí estará también mi servidor. Y al que me sirve, el Padre le dará un puesto de honor."
,"27":"Ahora mi alma está turbada. ¿Diré acaso: Padre, líbrame de esta hora? ¡Si precisamente he llegado a esta hora para enfrentarme con todo esto!"
,"28":"Padre, ¡da gloria a tu Nombre!' Entonces se oyó una voz que venía del cielo: 'Lo he glorificado y lo volveré a glorificar.'"
,"29":"Los que estaban allí y que escucharon la voz decían que había sido un trueno; otros decían: 'Le ha hablado un ángel.'"
,"30":"Entonces Jesús declaró: 'Esta voz no ha venido por mí, sino por ustedes."
,"31":"Ahora es el juicio de este mundo, ahora el que gobierna este mundo va a ser echado fuera,"
,"32":"y yo, cuando haya sido levantado de la tierra, atraeré a todos a mí.'"
,"33":"Con estas palabras Jesús daba a entender de qué modo iba a morir."
,"34":"La gente le replicó: 'Escuchamos la Ley y sabemos que el Mesías permanece para siempre. ¿Cómo dices tú que el Hijo del Hombre va a ser levantado? ¿Quién es ese Hijo del Hombre?'"
,"35":"Jesús les contestó: 'Todavía por un poco más de tiempo estará la luz con ustedes. Caminen mientras tienen luz, no sea que les sorprenda la oscuridad. El que camina en la oscuridad no sabe adónde va."
,"36":"Mientras tengan la luz, crean en la luz y serán hijos de la luz.',Así habló Jesús; después se fue y ya no se dejó ver más."
,"37":"Aunque había hecho tantas señales ante ellos no creían en él."
,"38":"Tenía que cumplirse lo dicho por el profeta Isaías: Señor, ¿quién ha dado crédito a nuestras palabras? ¿A quién fueron revelados los caminos del Señor?"
,"39":"¿Por qué no podían creer? Isaías lo había dicho también:"
,"40":"Cegó sus ojos y endureció su corazón para que no vieran, ni comprendieran, ni se volvieran a mí: de hacerlo, yo los habría sanado."
,"41":"Esto lo dijo Isaías, porque vio su gloria y habló de él."
,"42":"En realidad, de entre los mismos jefes, varios creyeron en él; pero no lo dijeron abiertamente por miedo a que los fariseos los echaran de la comunidad judía."
,"43":"Prefirieron ser honrados por los hombres antes que por Dios."
,"44":"Pero Jesús dijo claramente: 'El que cree en mí no cree solamente en mí, sino en aquel que me ha enviado."
,"45":"Y el que me ve a mí ve a aquel que me ha enviado."
,"46":"Yo he venido al mundo como luz, para que todo el que crea en mí no permanezca en tinieblas."
,"47":"Si alguno escucha mis palabras y no las guarda, yo no lo juzgo, porque yo no he venido para condenar al mundo, sino para salvarlo."
,"48":"El que me rechaza y no recibe mi palabra ya tiene quien lo juzgue: la misma palabra que yo he hablado lo condenará el último día."
,"49":"Porque yo no he hablado por mi propia cuenta, sino que el Padre, al enviarme, me ha mandado lo que debo decir y cómo lo debo decir."
,"50":"Yo sé que su mandato es vida eterna, y yo entrego mi mensaje tal como me lo mandó el Padre.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Antes de la fiesta de Pascua, sabiendo Jesús que le había llegado la hora de salir de este mundo para ir al Padre, como había amado a los suyos que quedaban en el mundo, los amó hasta el extremo."
,"2":"Estaban comiendo la cena y el diablo ya había depositado en el corazón de Judas Iscariote, hijo de Simón, el propósito de entregarle."
,"3":"Jesús, por su parte, sabía que el Padre había puesto todas las cosas en sus manos y que había salido de Dios y que a Dios volvía."
,"4":"Entonces se levantó de la mesa, se quitó el manto y se ató una toalla a la cintura."
,"5":"Echó agua en un recipiente y se puso a lavar los pies de los discípulos, y luego se los secaba con la toalla que se había atado."
,"6":"Cuando llegó a Simón Pedro, éste le dijo: '¿Tú, Señor, me vas a lavar los pies a mí?'"
,"7":"Jesús le contestó: 'Tú no puedes comprender ahora lo que estoy haciendo. Lo comprenderás más tarde.'"
,"8":"Pedro replicó: 'Jamás me lavarás los pies.' Jesús le respondió: 'Si no te lavo, no podrás tener parte conmigo.'"
,"9":"Entonces Pedro le dijo: 'Señor, lávame no sólo los pies, sino también las manos y la cabeza.'"
,"10":"Jesús le dijo: 'El que se ha bañado está completamente limpio y le basta lavarse los pies. Y ustedes están limpios, aunque no todos.'"
,"11":"Jesús sabía quién lo iba a entregar, por eso dijo: 'No todos ustedes están limpios.'"
,"12":"Cuando terminó de lavarles los pies, se puso de nuevo el manto, volvió a la mesa y les dijo: '¿Comprenden lo que he hecho con ustedes?"
,"13":"Ustedes me llaman Maestro y Señor, y dicen bien, porque lo soy."
,"14":"Pues si yo, siendo el Señor y el Maestro, les he lavado los pies, también ustedes deben lavarse los pies unos a otros."
,"15":"Yo les he dado ejemplo, y ustedes deben hacer como he hecho yo."
,"16":"En verdad les digo: El servidor no es más que su patrón y el enviado no es más que el que lo envía."
,"17":"Pues bien, ustedes ya saben estas cosas: felices si las ponen en práctica."
,"18":"No me refiero a todos ustedes, pues conozco a los que he escogido, y tiene que cumplirse lo que dice la Escritura: El que compartía mi pan se ha levantado contra mí."
,"19":"Se lo digo ahora, antes de que suceda, para que cuando suceda, crean que Yo Soy."
,"20":"En verdad les digo: el que reciba al que yo envíe, a mí me recibe, y el que me reciba a mí, recibe al que me ha enviado.'"
,"21":"Tras decir estas cosas, Jesús se conmovió en su espíritu y dijo con toda claridad: 'En verdad les digo: uno de ustedes me va a entregar.'"
,"22":"Los discípulos se miraron unos a otros, pues no sabían a quién se refería."
,"23":"Uno de sus discípulos, el que Jesús amaba, estaba recostado junto a él en la mesa,"
,"24":"y Simón Pedro le hizo señas para que le preguntara de quién hablaba."
,"25":"Se volvió hacia Jesús y le preguntó: 'Señor, ¿quién es?'"
,"26":"Jesús le contestó: 'Voy a mojar un pedazo de pan en el plato. Aquél al cual se lo dé, ése es.',Jesús mojó un pedazo de pan y se lo dio a Judas Iscariote, hijo de Simón. "
,"27":"Apenas Judas tomó el pedazo de pan, Satanás entró en él. Entonces Jesús le dijo: 'Lo que vas a hacer, hazlo pronto.'"
,"28":"Ninguno de los que estaban a la mesa comprendió por qué Jesús se lo decía."
,"29":"Como Judas tenía la bolsa común, algunos creyeron que Jesús quería decirle: 'Compra lo que nos hace falta para la fiesta...', o bien: 'da algo a los pobres.'"
,"30":"Judas se comió el pedazo de pan y salió inmediatamente. Era de noche."
,"31":"Cuando Judas salió, Jesús dijo: 'Ahora es glorificado el Hijo del Hombre y Dios es glorificado en él."
,"32":"Por lo tanto, Dios lo va a a introducir en su propia Gloria, y lo glorificará muy pronto."
,"33":"Hijos míos, yo estaré con ustedes por muy poco tiempo. Me buscarán, y como ya dije a los judíos, ahora se lo digo a ustedes: donde yo voy, ustedes no pueden venir."
,"34":"Les doy un mandamiento nuevo: que se amen los unos a los otros. Ustedes deben amarse unos a otros como yo los he amado."
,"35":"En esto reconocerán todos que son mis discípulos: en que se aman unos a otros.'"
,"36":"Simón Pedro le preguntó: 'Señor, ¿adónde vas?' Jesús le respondió: 'Adonde yo voy no puedes seguirme ahora, pero me seguirás más tarde.'"
,"37":"Pedro le dijo: 'Señor, ¿por qué no puedo seguirte ahora? Estoy dispuesto a dar mi vida por ti.'"
,"38":"Jesús le respondió: '¿Dar tú la vida por mí? En verdad te digo que antes de que cante el gallo me habrás negado tres veces.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"'No se turben; crean en Dios y crean también en mí."
,"2":"En la casa de mi Padre hay muchas habitaciones. De no ser así, no les habría dicho que voy a prepararles un lugar."
,"3":"Y después de ir y prepararles un lugar, volveré para tomarlos conmigo, para que donde yo esté, estén también ustedes."
,"4":"Para ir a donde yo voy, ustedes ya conocen el camino.'"
,"5":"Entonces Tomás le dijo: 'Señor, nosotros no sabemos adónde vas, ¿cómo vamos a conocer el camino?'"
,"6":"Jesús contestó: 'Yo soy el Camino, la Verdad y la Vida. Nadie va al Padre sino por mí."
,"7":"Si me conocen a mí, también conocerán al Padre. Pero ya lo conocen y lo han visto.'"
,"8":"Felipe le dijo: 'Señor, muéstranos al Padre, y eso nos basta.'"
,"9":"Jesús le respondió: 'Hace tanto tiempo que estoy con ustedes, ¿y todavía no me conoces, Felipe? El que me ve a mí ve al Padre. ¿Cómo es que dices: Muéstranos al Padre?"
,"10":"¿No crees que yo estoy en el Padre y que el Padre está en mí? Cuando les enseño, esto no viene de mí, sino que el Padre, que permanece en mí, hace sus propias obras."
,"11":"Yo estoy en el Padre y el Padre está en mí. Créanme en esto; o si no, créanlo por las obras mismas."
,"12":"En verdad les digo: El que crea en mí hará las mismas obras que yo hago y, como ahora voy al Padre, las hará aún mayores."
,"13":"Todo lo que pidan en mi Nombre lo haré, de manera que el Padre sea glorificado en su Hijo."
,"14":"Y también haré lo que me pidan invocando mi Nombre."
,"15":"Si ustedes me aman, guardarán mis mandamientos,"
,"16":"y yo rogaré al Padre y les dará otro Protector que permanecerá siempre con ustedes,"
,"17":"el Espíritu de Verdad, a quien el mundo no puede recibir, porque no lo ve ni lo conoce. Pero ustedes lo conocen, porque está con ustedes y permanecerá en ustedes."
,"18":"No los dejaré huérfanos, sino que volveré a ustedes."
,"19":"Dentro de poco el mundo ya no me verá, pero ustedes me verán, porque yo vivo y ustedes también vivirán."
,"20":"Aquel día comprenderán que yo estoy en mi Padre y ustedes están en mí y yo en ustedes."
,"21":"El que guarda mis mandamientos después de recibirlos, ése es el que me ama. El que me ama a mí será amado por mi Padre, y yo también lo amaré y me manifestaré a él.'"
,"22":"Judas, no el Iscariote, le preguntó: 'Señor, ¿por qué hablas de mostrarte a nosotros y no al mundo?'"
,"23":"Jesús le respondió: 'Si alguien me ama, guardará mis palabras, y mi Padre lo amará. Entonces vendremos a él para poner nuestra morada en él."
,"24":"El que no me ama no guarda mis palabras; pero el mensaje que escuchan no es mío, sino del Padre que me ha enviado."
,"25":"Les he dicho todo esto mientras estaba con ustedes."
,"26":"En adelante el Espíritu Santo, el Intérprete que el Padre les va a enviar en mi Nombre, les enseñará todas las cosas y les recordará todo lo que yo les he dicho."
,"27":"Les dejo la paz, les doy mi paz. La paz que yo les doy no es como la que da el mundo. Que no haya en ustedes angustia ni miedo."
,"28":"Saben que les dije: Me voy, pero volveré a ustedes. Si me amaran, se alegrarían de que me vaya al Padre, pues el Padre es más grande que yo."
,"29":"Les he dicho estas cosas ahora, antes de que sucedan, para que cuando sucedan ustedes crean."
,"30":"Ya no hablaré mucho más con ustedes, pues se está acercando el que gobierna este mundo. En mí no encontrará nada suyo,"
,"31":"pero con esto sabrá el mundo que yo amo al Padre y que hago lo que el Padre me ha encomendado hacer. Ahora levántense y vayámonos de aquí."
}`)
	CurrentBook.AddChapter(15, `{
"1":"'Yo soy la vid verdadera y mi Padre es el labrador."
,"2":"Toda rama que no da fruto en mí la corta. Y toda rama que da fruto la limpia para que dé más fruto."
,"3":"Ustedes ya están limpios gracias a la palabra que les he anunciado,"
,"4":"pero permanezcan en mí como yo permanezco en ustedes. Una rama no puede producir fruto por sí misma si no permanece unida a la vid; tampoco ustedes pueden producir fruto si no permanecen en mí."
,"5":"Yo soy la vid y ustedes las ramas. El que permanece en mí y yo en él, ése da mucho fruto, pero sin mí no pueden hacer nada."
,"6":"Al que no permanece en mí lo tiran y se seca; como a las ramas, que las amontonan, se echan al fuego y se queman."
,"7":"Mientras ustedes permanezcan en mí y mis palabras permanezcan en ustedes, pidan lo que quieran y lo conseguirán."
,"8":"Mi Padre es glorificado cuando ustedes producen abundantes frutos: entonces pasan a ser discípulos míos."
,"9":"Como el Padre me amó, así también los he amado yo: permanezcan en mi amor."
,"10":"Si cumplen mis mandamientos, permanecerán en mi amor, como yo he cumplido los mandamientos de mi Padre y permanezco en su amor."
,"11":"Les he dicho todas estas cosas para que mi alegría esté en ustedes y su alegría sea completa."
,"12":"Este es mi mandamiento: que se amen unos a otros como yo los he amado."
,"13":"No hay amor más grande que dar la vida por sus amigos,"
,"14":"y son ustedes mis amigos si cumplen lo que les mando."
,"15":"Ya no les llamo servidores, porque un servidor no sabe lo que hace su patrón. Los llamo amigos, porque les he dado a conocer todo lo que aprendí de mi Padre."
,"16":"Ustedes no me eligieron a mí; he sido yo quien los eligió a ustedes y los preparé para que vayan y den fruto, y ese fruto permanezca. Así es como el Padre les concederá todo lo que le pidan en mi Nombre."
,"17":"Amense los unos a los otros: esto es lo que les mando."
,"18":"Si el mundo los odia, sepan que antes me odió a mí."
,"19":"No sería lo mismo si ustedes fueran del mundo, pues el mundo ama lo que es suyo. Pero ustedes no son del mundo, sino que yo los elegí de en medio del mundo, y por eso el mundo los odia."
,"20":"Acuérdense de lo que les dije: el servidor no es más que su patrón. Si a mí me han perseguido, también los perseguirán a ustedes. ¿Acaso acogieron mi enseñanza? ¿Cómo, pues, acogerían la de ustedes?"
,"21":"Les harán todo esto por causa de mi nombre, porque no conocen al que me envió."
,"22":"Si yo no hubiera venido ni les hubiera hablado, no tendrían pecado. Pero ahora su pecado no tiene disculpa."
,"23":"El que me odia a mí, odia también a mi Padre."
,"24":"Si yo no hubiera hecho en medio de ellos obras que nadie hizo jamás, no serían culpables de pecado; pero las han visto y me han odiado a mí y a mi Padre."
,"25":"Así se cumple la palabra que se puede leer en su Ley: Me odiaron sin causa alguna."
,"26":"Cuando venga el Protector que les enviaré desde el Padre, por ser él el Espíritu de verdad que procede del Padre, dará testimonio de mí."
,"27":"Y ustedes también darán testimonio de mí, pues han estado conmigo desde el principio."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Les hablo de todo esto para que no se vayan a tambalear."
,"2":"Serán expulsados de las comunidades judías; más aún, se acerca el tiempo en que cualquiera que los mate pensará que está sirviendo a Dios."
,"3":"Y actuarán así porque no conocen ni al Padre ni a mí."
,"4":"Se lo advierto de antemano, para que cuando llegue la hora, recuerden que se lo había dicho. No les hablé de esto al principio porque estaba con ustedes. "
,"5":"Pero ahora me voy donde Aquel que me envió, y ninguno de ustedes me pregunta adónde voy."
,"6":"Se han llenado de tristeza al oír lo que les dije,"
,"7":"pero es verdad lo que les digo: les conviene que yo me vaya, porque mientras yo no me vaya, el Protector no vendrá a ustedes. Yo me voy, y es para enviárselo."
,"8":"Cuando venga él, rebatirá al mundo en lo que toca al pecado, al camino de justicia y al juicio."
,"9":"¿Qué pecado? Que no creyeron en mí."
,"10":"¿Qué camino de justicia? Mi partida hacia el Padre, y ustedes ya no me verán."
,"11":"¿Qué juicio? El del gobernador de este mundo: ya ha sido condenado."
,"12":"Aún tengo muchas cosas que decirles, pero es demasiado para ustedes por ahora."
,"13":"Y cuando venga él, el Espíritu de la Verdad, los guiará en todos los caminos de la verdad. El no viene con un mensaje propio, sino que les dirá lo que escuchó y les anunciará lo que ha de venir. "
,"14":"El tomará de lo mío para revelárselo a ustedes, y yo seré glorificado por él."
,"15":"Todo lo que tiene el Padre es mío. Por eso les he dicho que tomará de lo mío para revelárselo a ustedes.'"
,"16":"'Dentro de poco ya no me verán, pero después de otro poco me volverán a ver.'"
,"17":"Algunos discípulos se preguntaban: '¿Qué querrá decir con eso: 'Dentro de poco ya no me verán y después de otro poco me volverán a ver'? ¿Y qué significa: 'Me voy al Padre'?'"
,"18":"Y se preguntaban: '¿A qué se refiere ese 'dentro de poco'? No entendemos lo que quiere decir.'"
,"19":"Jesús se dio cuenta de que querían preguntarle y les dijo: 'Ustedes andan discutiendo sobre lo que les dije: 'Dentro de poco tiempo no me verán y después de otro poco me volverán a ver'."
,"20":"En verdad les digo que llorarán y se lamentarán, mientras que el mundo se alegrará. Ustedes estarán apenados, pero su tristeza se convertirá en gozo."
,"21":"La mujer se siente afligida cuando está para dar a luz, porque le llega la hora del dolor. Pero después que ha nacido la criatura, se olvida de las angustias por su alegría tan grande; piensen: ¡un ser humano ha venido al mundo!"
,"22":"Así también ustedes ahora sienten tristeza, pero yo los volveré a ver y su corazón se llenará de alegría, y nadie les podrá arrebatar ese gozo."
,"23":"Cuando llegue ese día ya no tendrán que preguntarme nada. En verdad les digo que todo lo que pidan al Padre en mi Nombre se lo concederá. "
,"24":"Hasta ahora no han pedido nada en mi Nombre. Pidan y recibirán, así conocerán el gozo completo."
,"25":"Hasta ahora los he instruido por medio de comparaciones. Pero está llegando la hora en que ya no los instruiré con comparaciones, sino que les hablaré claramente del Padre."
,"26":"Ese día ustedes pedirán en mi Nombre, y no será necesario que yo los recomiende ante el Padre,"
,"27":"pues el Padre mismo los ama, porque ustedes me aman a mí y creen que salí de Dios."
,"28":"Salí del Padre y vine al mundo. Ahora dejo el mundo y vuelvo al Padre.'"
,"29":"Los discípulos le dijeron: 'Ahora sí que hablas con claridad, sin usar parábolas."
,"30":"Ahora vemos que lo sabes todo y no hay por qué hacerte preguntas. Ahora creemos que saliste de Dios.'"
,"31":"Jesús les respondió: '¿Ustedes dicen que creen?"
,"32":"Está llegando la hora, y ya ha llegado, en que se dispersarán cada uno por su lado y me dejarán solo. Aunque no estoy solo, pues el Padre está conmigo."
,"33":"Les he hablado de estas cosas para que tengan paz en mí. Ustedes encontrarán la persecución en el mundo. Pero, ánimo, yo he vencido al mundo.'"
}`)
	CurrentBook.AddChapter(17, `{
"1":"Dicho esto, Jesús elevó los ojos al cielo y exclamó: 'Padre, ha llegado la hora; ¡glorifica a tu Hijo para que tu Hijo te dé gloria a ti!"
,"2":"Tú le diste poder sobre todos los mortales y quieres que comunique la vida eterna a todos aquellos que le encomendaste."
,"3":"Y ésta es la vida eterna: conocerte a ti, único Dios verdadero, y al que tú has enviado, Jesús, el Cristo."
,"4":"Yo te he glorificado en la tierra y he terminado la obra que me habías encomendado."
,"5":"Ahora, Padre, dame junto a ti la misma Gloria que tenía a tu lado antes que comenzara el mundo."
,"6":"He manifestado tu Nombre a los hombres: hablo de los que me diste, tomándolos del mundo. Eran tuyos, y tú me los diste y han guardado tu Palabra."
,"7":"Ahora reconocen que todo aquello que me has dado viene de ti."
,"8":"El mensaje que recibí se lo he entregado y ellos lo han recibido, y reconocen de verdad que yo he salido de ti y creen que tú me has enviado."
,"9":"Yo ruego por ellos. No ruego por el mundo, sino por los que son tuyos y que tú me diste"
,"10":"-pues todo lo mío es tuyo y todo lo tuyo es mío-; yo ya he sido glorificado a través de ellos."
,"11":"Yo ya no estoy más en el mundo, pero ellos se quedan en el mundo, mientras yo vuelvo a ti. Padre Santo, guárdalos en ese Nombre tuyo que a mí me diste, para que sean uno como nosotros."
,"12":"Cuando estaba con ellos, yo los cuidaba en tu Nombre, pues tú me los habías encomendado, y ninguno de ellos se perdió, excepto el que llevaba en sí la perdición, pues en esto había de cumplirse la Escritura."
,"13":"Pero ahora que voy a ti, y estando todavía en el mundo digo estas cosas para que tengan en ellos la plenitud de mi alegría."
,"14":"Yo les he dado tu mensaje y el mundo los ha odiado porque no son del mundo, como tampoco yo soy del mundo."
,"15":"No te pido que los saques del mundo, sino que los defiendas del Maligno."
,"16":"Ellos no son del mundo, como tampoco yo soy del mundo."
,"17":"Conságralos mediante la verdad: tu palabra es verdad."
,"18":"Así como tú me has enviado al mundo, así yo también los envío al mundo;"
,"19":"por ellos ofrezco el sacrificio, para que también ellos sean consagrados en la verdad."
,"20":"No ruego sólo por éstos, sino también por todos aquellos que creerán en mí por su palabra."
,"21":"Que todos sean uno, como tú, Padre, estás en mí y yo en ti. Que ellos también sean uno en nosotros, para que el mundo crea que tú me has enviado."
,"22":"Yo les he dado la Gloria que tú me diste, para que sean uno como nosotros somos uno:"
,"23":"yo en ellos y tú en mí. Así alcanzarán la perfección en la unidad, y el mundo conocerá que tú me has enviado y que yo los he amado a ellos como tú me amas a mí."
,"24":"Padre, ya que me los has dado, quiero que estén conmigo donde yo estoy y que contemplen la Gloria que tú ya me das, porque me amabas antes que comenzara el mundo."
,"25":"Padre justo, el mundo no te ha conocido, pero yo te conocía, y éstos a su vez han conocido que tú me has enviado."
,"26":"Yo les he dado a conocer tu Nombre y se lo seguiré dando a conocer, para que el amor con que tú me amas esté en ellos y también yo esté en ellos.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Cuando terminó de hablar, Jesús pasó con sus discípulos al otro lado del torrente Cedrón. Había allí un huerto, y Jesús entró en él con sus discípulos."
,"2":"Judas, el que lo entregaba, conocía también ese lugar, pues Jesús se había reunido allí muchas veces con sus discípulos."
,"3":"Judas hizo de guía a los soldados romanos y a los guardias enviados por los jefes de los sacerdotes y los fariseos, que llegaron allí con linternas, antorchas y armas."
,"4":"Jesús, que sabía todo lo que le iba a suceder, se adelantó y les dijo: '¿A quién buscan?'"
,"5":"Contestaron: 'A Jesús el Nazoreo.' Jesús dijo: 'Yo soy.' Y Judas, que lo entregaba, estaba allí con ellos."
,"6":"Cuando Jesús les dijo: 'Yo soy', retrocedieron y cayeron al suelo."
,"7":"Les preguntó de nuevo: '¿A quién buscan?' Dijeron: 'A Jesús el Nazoreo.'"
,"8":"Jesús les respondió: 'Ya les he dicho que soy yo. Si me buscan a mí, dejen que éstos se vayan.'"
,"9":"Así se cumplía lo que Jesús había dicho: 'No he perdido a ninguno de los que tú me diste.'"
,"10":"Simón Pedro tenía una espada, la sacó e hirió a Malco, siervo del sumo sacerdote, cortándole la oreja derecha."
,"11":"Jesús dijo a Pedro: 'Coloca la espada en su lugar. ¿Acaso no voy a beber la copa que el Padre me ha dado?'"
,"12":"Entonces los soldados, con el comandante y los guardias de los judíos, prendieron a Jesús, lo ataron"
,"13":"y lo llevaron primero a casa de Anás. Este Anás era suegro de Caifás, sumo sacerdote aquel año."
,"14":"Caifás era el que había dicho a los judíos: 'Es mejor que muera un solo hombre por el pueblo.'"
,"15":"Simón Pedro y otro discípulo seguían a Jesús. Como este otro discípulo era conocido del sumo sacerdote, pudo entrar con Jesús en el patio de la casa del sumo sacerdote,"
,"16":"mientras que Pedro se quedó fuera, junto a la puerta. Entonces salió el otro discípulo, el conocido del sumo sacerdote, y habló con la portera, que dejó entrar a Pedro."
,"17":"La muchacha que hacía de portera dijo a Pedro: '¿No eres tú también de los discípulos de ese hombre.' Pedro le respondió: 'No lo soy'."
,"18":"Los sirvientes y los guardias tenían unas brasas encendidas y se calentaban, pues hacía frío. También Pedro estaba con ellos y se calentaba."
,"19":"El sumo sacerdote interrogó a Jesús sobre sus discípulos y su enseñanza. Jesús le contestó:"
,"20":"'Yo he hablado abiertamente al mundo. He enseñado constantemente en los lugares donde los judíos se reúnen, tanto en las sinagogas como en el Templo, y no he enseñado nada en secreto."
,"21":"¿Por qué me preguntas a mí? Interroga a los que escucharon lo que he dicho.'"
,"22":"Al oír esto, uno de los guardias que estaba allí le dio a Jesús una bofetada en la cara, diciendo: '¿Así contestas al sumo sacerdote?'"
,"23":"Jesús le dijo: 'Si he respondido mal, demuestra dónde está el mal. Pero si he hablado correctamente, ¿por qué me golpeas?'"
,"24":"Al fin, Anás lo envió atado al sumo sacerdote Caifás."
,"25":"Simón Pedro estaba calentándose al fuego en el patio, y le dijeron: 'Seguramente tú también eres uno de sus discípulos.' El lo negó diciendo: 'No lo soy.'"
,"26":"Entonces uno de los servidores del sumo sacerdote, pariente del hombre al que Pedro le había cortado la oreja, le dijo: '¿No te vi yo con él en el huerto?'"
,"27":"De nuevo Pedro lo negó y al instante cantó un gallo."
,"28":"Llevaron a Jesús de la casa de Caifás al tribunal del gobernador romano. Los judíos no entraron para no quedar impuros, pues ése era un lugar pagano, y querían participar en la comida de la Pascua."
,"29":"Entonces Pilato salió fuera, donde estaban ellos, y les dijo: '¿De qué acusan a este hombre?'"
,"30":"Le contestaron: 'Si éste no fuera un malhechor, no lo habríamos traído ante ti.'"
,"31":"Pilato les dijo: 'Tómenlo y júzguenlo según su ley.' Los judíos contestaron: 'Nosotros no tenemos la facultad para aplicar la pena de muerte.'"
,"32":"Con esto se iba a cumplir la palabra de Jesús dando a entender qué tipo de muerte iba a sufrir."
,"33":"Pilato volvió a entrar en el palacio, llamó a Jesús y le preguntó: '¿Eres tú el Rey de los judíos?'"
,"34":"Jesús le contestó: '¿Viene de ti esta pregunta o repites lo que te han dicho otros de mí?'"
,"35":"Pilato respondió: '¿Acaso soy yo judío? Tu pueblo y los jefes de los sacerdotes te han entregado a mí; ¿qué has hecho?'"
,"36":"Jesús contestó: 'Mi realeza no procede de este mundo. Si fuera rey como los de este mundo, mis guardias habrían luchado para que no cayera en manos de los judíos. Pero mi reinado no es de acá.'"
,"37":"Pilato le preguntó: 'Entonces, ¿tú eres rey?' Jesús respondió: 'Tú lo has dicho: yo soy Rey. Yo doy testimonio de la verdad, y para esto he nacido y he venido al mundo. Todo el que está del lado de la verdad escucha mi voz.'"
,"38":"Pilato dijo: '¿Y qué es la verdad?',Dicho esto, salió de nuevo donde estaban los judíos y les dijo: 'Yo no encuentro ningún motivo para condenar a este hombre. "
,"39":"Pero aquí es costumbre que en la Pascua yo les devuelva a un prisionero. ¿Quieren ustedes que ponga en libertad al Rey de los Judíos?'"
,"40":"Ellos empezaron a gritar: '¡A ése no! Suelta a Barrabás.' Barrabás era un bandido."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Entonces Pilato tomó a Jesús y ordenó que fuera azotado."
,"2":"Los soldados hicieron una corona con espinas y se la pusieron en la cabeza, le echaron sobre los hombros una capa de color rojo púrpura"
,"3":"y, acercándose a él, le decían: '¡Viva el rey de los judíos!' Y le golpeaban en la cara."
,"4":"Pilato volvió a salir y les dijo: 'Miren, se lo traigo de nuevo fuera; sepan que no encuentro ningún delito en él.'"
,"5":"Entonces salió Jesús fuera llevando la corona de espinos y el manto rojo. Pilato les dijo: 'Aquí está el hombre.'"
,"6":"Al verlo, los jefes de los sacerdotes y los guardias del Templo comenzaron a gritar: '¡Crucifícalo! ¡Crucifícalo!' Pilato contestó: 'Tómenlo ustedes y crucifíquenlo, pues yo no encuentro motivo para condenarlo.'"
,"7":"Los judíos contestaron: 'Nosotros tenemos una Ley, y según esa Ley debe morir, pues se ha proclamado Hijo de Dios.'"
,"8":"Cuando Pilato escuchó esto, tuvo más miedo."
,"9":"Volvió a entrar en el palacio y preguntó a Jesús: '¿De dónde eres tú?' Pero Jesús no le contestó palabra."
,"10":"Entonces Pilato le dijo: '¿No me quieres hablar a mí? ¿No sabes que tengo poder tanto para dejarte libre como para crucificarte?'"
,"11":"Jesús respondió: 'No tendrías ningún poder sobre mí si no lo hubieras recibido de lo alto. Por esta razón, el que me ha entregado a ti tiene mayor pecado que tú.'"
,"12":"Pilato todavía buscaba la manera de dejarlo en libertad. Pero los judíos gritaban: 'Si lo dejas en libertad, no eres amigo del César: el que se proclama rey se rebela contra el César.'"
,"13":"Al oír Pilato estas palabras, hizo salir a Jesús al lugar llamado el Enlosado, en hebreo llamado Gábbata, y lo hizo sentar en la sede del tribunal."
,"14":"Era el día de la Preparación de la Pascua, hacia el mediodía. Pilato dijo a los judíos: 'Aquí tienen a su rey.'"
,"15":"Ellos gritaron: '¡Fuera! ¡Fuera! ¡Crucifícalo!' Pilato replicó: '¿He de crucificar a su Rey?' Los jefes de los sacerdotes contestaron: 'No tenemos más rey que el César.'"
,"16":"Entonces Pilato les entregó a Jesús para que lo crucificaran."
,"17":"Así fue como se llevaron a Jesús. Cargando con su propia cruz, salió de la ciudad hacia el lugar llamado Calvario (o de la Calavera), que en hebreo se dice Gólgota."
,"18":"Allí lo crucificaron y con él a otros dos, uno a cada lado y en el medio a Jesús."
,"19":"Pilato mandó escribir un letrero y ponerlo sobre la cruz. Estaba escrito: 'Jesús el Nazareno, Rey de los judíos.'"
,"20":"Muchos judíos leyeron este letrero, pues el lugar donde Jesús fue crucificado estaba muy cerca de la ciudad. Además estaba escrito en hebreo, latín y griego."
,"21":"Los jefes de los sacerdotes dijeron a Pilato: 'No escribas: 'Rey de los Judíos', sino: 'Este ha dicho: Yo soy el rey de los judíos'.'"
,"22":"Pilato contestó: 'Lo que he escrito, escrito está.'"
,"23":"Después de clavar a Jesús en la cruz, los soldados tomaron sus vestidos y los dividieron en cuatro partes, una para cada uno de ellos. En cuanto a la túnica, tejida de una sola pieza de arriba abajo sin costura alguna, se dijeron:"
,"24":"'No la rompamos, echémosla más bien a suerte, a ver a quién le toca.' Así se cumplió la Escritura que dice: Se repartieron mi ropa y echaron a suerte mi túnica. Esto es lo que hicieron los soldados."
,"25":"Cerca de la cruz de Jesús estaba su madre, con María, la hermana de su madre, esposa de Cleofás, y María de Magdala."
,"26":"Jesús, al ver a la Madre y junto a ella al discípulo que más quería, dijo a la Madre: 'Mujer, ahí tienes a tu hijo.'"
,"27":"Después dijo al discípulo: 'Ahí tienes a tu madre.' Y desde aquel momento el discípulo se la llevó a su casa."
,"28":"Después de esto, sabiendo Jesús que todo estaba cumplido, dijo: 'Tengo sed', y con esto también se cumplió la Escritura."
,"29":"Había allí un jarro lleno de vino agrio. Pusieron en una caña una esponja empapada en aquella bebida y la acercaron a sus labios."
,"30":"Jesús probó el vino y dijo: 'Todo está cumplido.' Después inclinó la cabeza y entregó el espíritu."
,"31":"Como era el día de la Preparación de la Pascua, los judíos no querían que los cuerpos quedaran en la cruz durante el sábado, pues aquel sábado era un día muy solemne. Pidieron a Pilato que hiciera quebrar las piernas a los crucificados y retiraran los cuerpos."
,"32":"Fueron, pues, los soldados y quebraron las piernas de los dos que habían sido crucificados con Jesús."
,"33":"Pero al llegar a Jesús vieron que ya estaba muerto, y no le quebraron las piernas,"
,"34":"sino que uno de los soldados le abrió el costado con la lanza, y al instante salió sangre y agua."
,"35":"El que lo vio da testimonio. Su testimonio es verdadero, y Aquél sabe que dice la verdad. Y da este testimonio para que también ustedes crean."
,"36":"Esto sucedió para que se cumpliera la Escritura que dice: No le quebrarán ni un solo hueso."
,"37":"Y en otro texto dice: Contemplarán al que traspasaron."
,"38":"Después de esto, José de Arimatea se presentó a Pilato. Era discípulo de Jesús, pero no lo decía por miedo a los judíos. Pidió a Pilato la autorización para retirar el cuerpo de Jesús, y Pilato se la concedió. Fue y retiró el cuerpo."
,"39":"También fue Nicodemo, el que había ido de noche a ver a Jesús, llevando unas cien libras de mirra perfumada y áloe."
,"40":"Tomaron el cuerpo de Jesús y lo envolvieron en lienzos con los aromas, según la costumbre de enterrar de los judíos."
,"41":"En el lugar donde había sido crucificado Jesús había un huerto, y en el huerto un sepulcro nuevo donde todavía no había sido enterrado nadie."
,"42":"Como el sepulcro estaba muy cerca y debían respetar el Día de la Preparación de los judíos, enterraron allí a Jesús."
}`)
	CurrentBook.AddChapter(20, `{
"1":"El primer día después del sábado, María Magdalena fue al sepulcro muy temprano, cuando todavía estaba oscuro, y vio que la piedra que cerraba la entrada del sepulcro había sido removida."
,"2":"Fue corriendo en busca de Simón Pedro y del otro discípulo a quien Jesús amaba y les dijo: 'Se han llevado del sepulcro al Señor y no sabemos dónde lo han puesto.'"
,"3":"Pedro y el otro discípulo salieron para el sepulcro."
,"4":"Corrían los dos juntos, pero el otro discípulo corrió más que Pedro y llegó primero al sepulcro."
,"5":"Como se inclinara, vio los lienzos tumbados, pero no entró."
,"6":"Pedro llegó detrás, entró en el sepulcro y vio también los lienzos tumbados."
,"7":"El sudario con que le habían cubierto la cabeza no se había caído como los lienzos, sino que se mantenía enrollado en su lugar."
,"8":"Entonces entró también el otro discípulo, el que había llegado primero, vio y creyó."
,"9":"Pues no habían entendido todavía la Escritura: ¡él 'debía' resucitar de entre los muertos!"
,"10":"Después los dos discípulos se volvieron a casa."
,"11":"María se quedaba llorando fuera, junto al sepulcro. Mientras lloraba se inclinó para mirar dentro"
,"12":"y vio a dos ángeles vestidos de blanco, sentados donde había estado el cuerpo de Jesús, uno a la cabecera y el otro a los pies."
,"13":"Le dijeron: 'Mujer, ¿por qué lloras?' Les respondió: 'Porque se han llevado a mi Señor y no sé dónde lo han puesto.'"
,"14":"Dicho esto, se dio vuelta y vio a Jesús allí, de pie, pero no sabía que era Jesús."
,"15":"Jesús le dijo: 'Mujer, ¿por qué lloras? ¿A quién buscas?' Ella creyó que era el cuidador del huerto y le contestó: 'Señor, si tú lo has llevado, dime dónde lo has puesto, y yo me lo llevaré.'"
,"16":"Jesús le dijo: 'María'. Ella se dio la vuelta y le dijo: 'Rabboní', que quiere decir 'Maestro'."
,"17":"Jesús le dijo: 'Suéltame, pues aún no he subido al Padre. Pero vete donde mis hermanos y diles: Subo a mi Padre, que es Padre de ustedes; a mi Dios, que es Dios de ustedes.'"
,"18":"María Magdalena se fue y dijo a los discípulos: 'He visto al Señor y me ha dicho esto.'"
,"19":"Ese mismo día, el primero después del sábado, los discípulos estaban reunidos por la tarde con las puertas cerradas por miedo a los judíos. Llegó Jesús, se puso de pie en medio de ellos y les dijo: '¡La paz esté con ustedes!'"
,"20":"Dicho esto, les mostró las manos y el costado. Los discípulos se alegraron mucho al ver al Señor."
,"21":"Jesús les volvió a decir: '¡La paz esté con ustedes! Como el Padre me envío a mí, así los envío yo también.'"
,"22":"Dicho esto, sopló sobre ellos y les dijo: 'Reciban el Espíritu Santo:"
,"23":"a quienes descarguen de sus pecados, serán liberados, y a quienes se los retengan, les serán retenidos.'"
,"24":"Tomás, uno de los Doce, llamado el Mellizo, no estaba con ellos cuando vino Jesús."
,"25":"Los otros discípulos le dijeron: 'Hemos visto al Señor.' Pero él contestó: 'Hasta que no vea la marca de los clavos en sus manos, no meta mis dedos en el agujero de los clavos y no introduzca mi mano en la herida de su costado, no creeré.'"
,"26":"Ocho días después, los discípulos de Jesús estaban otra vez en casa, y Tomás con ellos. Estando las puertas cerradas, Jesús vino y se puso en medio de ellos. Les dijo: 'La paz esté con ustedes.'"
,"27":"Después dijo a Tomás: 'Pon aquí tu dedo y mira mis manos; extiende tu mano y métela en mi costado. Deja de negar y cree.'"
,"28":"Tomás exclamó: 'Tú eres mi Señor y mi Dios.'"
,"29":"Jesús replicó: 'Crees porque me has visto. ¡Felices los que no han visto, pero creen!'"
,"30":"Muchas otras señales milagrosas hizo Jesús en presencia de sus discípulos que no están escritas en este libro."
,"31":"Estas han sido escritas para que crean que Jesús es el Cristo, el Hijo de Dios. Crean, y tendrán vida por su Nombre."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Después de esto, nuevamente se apareció Jesús a sus discípulos en la orilla del lago de Tiberíades. Y se hizo presente como sigue:"
,"2":"Estaban reunidos Simón Pedro, Tomás el Mellizo, Natanael, de Caná de Galilea, los hijos del Zebedeo y otros dos discípulos."
,"3":"Simón Pedro les dijo: 'Voy a pescar.' Contestaron: 'Vamos también nosotros contigo.' Salieron, pues, y subieron a la barca, pero aquella noche no pescaron nada."
,"4":"Al amanecer, Jesús estaba parado en la orilla, pero los discípulos no sabían que era él."
,"5":"Jesús les dijo: 'Muchachos, ¿tienen algo que comer?' Le contestaron: 'Nada.'"
,"6":"Entonces Jesús les dijo: 'Echen la red a la derecha y encontrarán pesca.' Echaron la red, y no tenían fuerzas para recogerla por la gran cantidad de peces."
,"7":"El discípulo al que Jesús amaba dijo a Simón Pedro: 'Es el Señor.'"
,"8":"Apenas Pedro oyó decir que era el Señor, se puso la ropa, pues estaba sin nada, y se echó al agua. Los otros discípulos llegaron con la barca -de hecho, no estaban lejos, a unos cien metros de la orilla; arrastraban la red llena de peces."
,"9":"Al bajar a tierra encontraron fuego encendido, pescado sobre las brasas y pan."
,"10":"Jesús les dijo: 'Traigan algunos de los pescados que acaban de sacar.'"
,"11":"Simón Pedro subió a la barca y sacó la red llena con ciento cincuenta y tres pescados grandes. Y, a pesar de que hubiese tantos, no se rompió la red."
,"12":"Entonces Jesús les dijo: 'Vengan a desayunar'. Ninguno de los discípulos se atrevió a preguntarle quién era, pues sabían que era el Señor."
,"13":"Jesús se acercó, tomó el pan y se lo repartió. Lo mismo hizo con los pescados."
,"14":"Esta fue la tercera vez que Jesús se manifestó a sus discípulos después de resucitar de entre los muertos."
,"15":"Cuando terminaron de comer, Jesús dijo a Simón Pedro: 'Simón, hijo de Juan, ¿me amas más que éstos?' Contestó: 'Sí, Señor, tú sabes que te quiero.' Jesús le dijo: 'Apacienta mis corderos.'"
,"16":"Le preguntó por segunda vez: 'Simón, hijo de Juan, ¿me amas?' Pedro volvió a contestar: 'Sí, Señor, tú sabes que te quiero.' Jesús le dijo: 'Cuida de mis ovejas.'"
,"17":"Insistió Jesús por tercera vez: 'Simón Pedro, hijo de Juan, ¿me quieres?' Pedro se puso triste al ver que Jesús le preguntaba por tercera vez si lo quería y le contestó: 'Señor, tú lo sabes todo, tú sabes que te quiero.' Entonces Jesús le dijo: 'Apacienta mis ovejas."
,"18":"En verdad, cuando eras joven, tú mismo te ponías el cinturón e ibas a donde querías. Pero cuando llegues a viejo, abrirás los brazos y otro te amarrará la cintura y te llevará a donde no quieras.'"
,"19":"Jesús lo dijo para que Pedro comprendiera en qué forma iba a morir y dar gloria a Dios. Y añadió: 'Sígueme.'."
,"20":"Pedro miró atrás y vio que lo seguía el discípulo al que Jesús amaba, el que en la cena se había inclinado sobre su pecho y le había preguntado: 'Señor, ¿quién es el que te va a entregar?'"
,"21":"Al verlo, Pedro preguntó a Jesús: '¿Y qué va a ser de éste?'"
,"22":"Jesús le contestó: 'Si yo quiero que permanezca hasta mi vuelta, ¿a ti qué te importa? Tú sígueme.'"
,"23":"Por esta razón corrió entre los hermanos el rumor de que aquel discípulo no iba a morir. Pero Jesús no dijo que no iba a morir, sino simplemente: 'Si yo quiero que permanezca hasta mi vuelta, ¿a ti qué te importa?'"
,"24":"Este es el mismo discípulo que da testimonio de estas cosas y que las ha escrito aquí, y nosotros sabemos que dice la verdad."
,"25":"Jesús hizo también otras muchas cosas. Si se escribieran una por una, creo que no habría lugar en el mundo para tantos libros."
}`)

}
func ES_LBL_LoadNELCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Algunas personas han hecho empeño por ordenar una narración de los acontecimientos que han ocurrido entre nosotros,"
,"2":"tal como nos han sido transmitidos por aquellos que fueron los primeros testigos y que después se hicieron servidores de la Palabra."
,"3":"Después de haber investigado cuidadosamente todo desde el principio, también a mí me ha parecido bueno escribir un relato ordenado para ti, ilustre Teófilo."
,"4":"De este modo podrás verificar la solidez de las enseñanzas que has recibido."
,"5":"Siendo Herodes rey de Judea, vivía allí un sacerdote llamado Zacarías. Pertenecía al grupo sacerdotal de Abías, y su esposa, llamada Isabel, era también descendiente de una familia de sacerdotes."
,"6":"Ambos eran personas muy cumplidoras a los ojos de Dios y se esmeraban en practicar todos los mandamientos y leyes del Señor."
,"7":"No tenían hijos, pues Isabel no podía tener familia, y los dos eran ya de edad avanzada."
,"8":"Mientras Zacarías y los otros sacerdotes de su grupo estaban oficiando ante el Señor,"
,"9":"le tocó a él en suerte, según las costumbres de los sacerdotes, entrar en el Santuario del Señor para ofrecer el incienso."
,"10":"Cuando llegó la hora del incienso, toda la gente estaba orando afuera, en los patios."
,"11":"En esto se le apareció un ángel del Señor, de pie, al lado derecho del altar del incienso."
,"12":"Zacarías se turbó al verlo y el temor se apoderó de él."
,"13":"Pero el ángel le dijo: 'No temas, Zacarías, porque tu oración ha sido escuchada. Tu esposa Isabel te dará un hijo y le pondrás por nombre Juan."
,"14":"Será para ti un gozo muy grande, y muchos más se alegrarán con su nacimiento,"
,"15":"porque este hijo tuyo será un gran servidor del Señor. No beberá vino ni licor, y estará lleno del Espíritu Santo ya desde el seno de su madre."
,"16":"Por medio de él muchos hijos de Israel volverán al Señor, su Dios."
,"17":"El mismo abrirá el camino al Señor con el espíritu y el poder del profeta Elías, reconciliará a padres e hijos y llevará a los rebeldes a la sabiduría de los buenos. De este modo preparará al Señor un pueblo bien dispuesto.'"
,"18":"Zacarías dijo al ángel: '¿Quién me lo puede asegurar? Yo ya soy viejo y mi esposa también.'"
,"19":"El ángel contestó: 'Yo soy Gabriel, el que tiene entrada al consejo de Dios, y he sido enviado para hablar contigo y comunicarte esta buena noticia."
,"20":"Mis palabras se cumplirán a su debido tiempo, pero tú, por no haber creído, te vas a quedar mudo y no podrás hablar hasta el día en que todo esto ocurra.'"
,"21":"El pueblo estaba esperando a Zacarías, y se extrañaban de que se demorase tanto en el Santuario."
,"22":"Cuando finalmente salió, no podía hablarles, y comprendieron que había tenido alguna visión en el Santuario. Intentaba comunicarse por señas, pues permanecía mudo."
,"23":"Al terminar el tiempo de su servicio, Zacarías regresó a su casa,"
,"24":"y poco después su esposa Isabel quedó embarazada. Durante cinco meses permaneció retirada, pensando:"
,"25":"'¡Qué no ha hecho por mí el Señor! Es ahora cuando quiso liberarme de mi vergüenza.'"
,"26":"Al sexto mes el ángel Gabriel fue enviado por Dios a una ciudad de Galilea, llamada Nazaret,"
,"27":"a una joven virgen que estaba comprometida en matrimonio con un hombre llamado José, de la familia de David. La virgen se llamaba María."
,"28":"Llegó el ángel hasta ella y le dijo: 'Alégrate, llena de gracia, el Señor está contigo.'"
,"29":"María quedó muy conmovida al oír estas palabras, y se preguntaba qué significaría tal saludo."
,"30":"Pero el ángel le dijo: 'No temas, María, porque has encontrado el favor de Dios."
,"31":"Concebirás en tu seno y darás a luz un hijo, al que pondrás el nombre de Jesús."
,"32":"Será grande y justamente será llamado Hijo del Altísimo. El Señor Dios le dará el trono de su antepasado David;"
,"33":"gobernará por siempre al pueblo de Jacob y su reinado no terminará jamás.'"
,"34":"María entonces dijo al ángel: '¿Cómo puede ser eso, si yo soy virgen?'"
,"35":"Contestó el ángel: 'El Espíritu Santo descenderá sobre ti y el poder del Altísimo te cubrirá con su sombra; por eso el niño santo que nacerá de ti será llamado Hijo de Dios."
,"36":"También tu parienta Isabel está esperando un hijo en su vejez, y aunque no podía tener familia, se encuentra ya en el sexto mes del embarazo."
,"37":"Para Dios, nada es imposible.'"
,"38":"Dijo María: 'Yo soy la servidora del Señor, hágase en mí tal como has dicho.' Después la dejó el ángel."
,"39":"Por entonces María tomó su decisión y se fue, sin más demora, a una ciudad ubicada en los cerros de Judá."
,"40":"Entró en la casa de Zacarías y saludó a Isabel."
,"41":"Al oír Isabel su saludo, el niño dio saltos en su vientre. Isabel se llenó del Espíritu Santo"
,"42":"y exclamó en alta voz: '¡Bendita tú eres entre las mujeres y bendito el fruto de tu vientre!"
,"43":"¿Cómo he merecido yo que venga a mí la madre de mi Señor?"
,"44":"Apenas llegó tu saludo a mis oídos, el niño saltó de alegría en mis entrañas."
,"45":"¡Dichosa tú por haber creído que se cumplirían las promesas del Señor!'"
,"46":"María dijo entonces: Proclama mi alma la grandeza del Señor,"
,"47":"y mi espíritu se alegra en Dios mi Salvador,"
,"48":"porque se fijó en su humilde esclava, y desde ahora todas las generaciones me llamarán feliz."
,"49":"El Poderoso ha hecho grandes cosas por mí: ¡Santo es su Nombre!"
,"50":"Muestra su misericordia siglo tras siglo,a todos aquellos que viven en su presencia."
,"51":"Dio un golpe con todo su poder: deshizo a los soberbios y sus planes."
,"52":"Derribó a los poderosos de sus tronos,y exaltó a los humildes."
,"53":"Colmó de bienes a los hambrientos,y despidió a los ricos con las manos vacías."
,"54":"Socorrió a Israel, su siervo, se acordó de su misericordia,"
,"55":"como lo había prometido a nuestros padres, a Abraham y a sus descendientes para siempre."
,"56":"María se quedó unos tres meses con Isabel, y después volvió a su casa."
,"57":"Cuando le llegó a Isabel su día, dio a luz un hijo,"
,"58":"y sus vecinos y parientes se alegraron con ella al enterarse de la misericordia tan grande que el Señor le había mostrado."
,"59":"Al octavo día vinieron para cumplir con el niño el rito de la circuncisión,"
,"60":"y querían ponerle por nombre Zacarías, por llamarse así su padre. Pero la madre dijo: 'No, se llamará Juan.'"
,"61":"Los otros dijeron: 'Pero si no hay nadie en tu familia que se llame así.'"
,"62":"Preguntaron por señas al padre cómo quería que lo llamasen."
,"63":"Zacarías pidió una tablilla y escribió: 'Su nombre es Juan', por lo que todos se quedaron extrañados."
,"64":"En ese mismo instante se le soltó la lengua y comenzó a alabar a Dios."
,"65":"Un santo temor se apoderó del vecindario, y estos acontecimientos se comentaban en toda la región montañosa de Judea."
,"66":"La gente que lo oía quedaba pensativa y decía: '¿Qué va a ser este niño?' Porque comprendían que la mano del Señor estaba con él."
,"67":"Su padre, Zacarías, lleno del Espíritu Santo, empezó a recitar estos versos proféticos:"
,"68":"Bendito sea el Señor, Dios de Israel, porque ha visitado y redimido a su pueblo."
,"69":"Ahora sale triunfante nuestra salvación,en la casa de David, su siervo,"
,"70":"como lo había dicho desde tiempos antiguos,por boca de sus santos profetas:"
,"71":"que nos salvaría de nuestros enemigos,y de la mano de todos los que nos odian;"
,"72":"que nos mostraría el amor que tiene a nuestros padres,y cómo recuerda su santa alianza."
,"73":"Pues juró a nuestro padre Abrahán"
,"74":"que nos libraría de nuestros enemigos,para que lo sirvamos sin temor, "
,"75":"justos y santos, todos los días de nuestra vida."
,"76":"Y tú, niño, serás llamado Profeta del Altísimo,porque irás delante del Señor para prepararle sus caminos,"
,"77":"para decir a su pueblo lo que será su salvación. Pues van a recibir el perdón de sus pecados,"
,"78":"obra de la misericordia de nuestro Dios, cuando venga de lo alto para visitarnos,cual sol naciente,"
,"79":"iluminando a los que viven en tinieblas, sentados en la sombra de la muerte, y guiar nuestros pasos por un sendero de paz."
,"80":"A medida que el niño iba creciendo, le vino la fuerza del Espíritu. Vivió en lugares apartados hasta el día en que se manifestó a Israel."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Por aquellos días salió un decreto del emperador Augusto, por el que se debía proceder a un censo en todo el imperio."
,"2":"Este fue el primer censo, siendo Quirino gobernador de Siria."
,"3":"Todos, pues, empezaron a moverse para ser registrados cada uno en su ciudad natal."
,"4":"José también, que estaba en Galilea, en la ciudad de Nazaret, subió a Judea, a la ciudad de David, llamada Belén, porque era descendiente de David;"
,"5":"allí se inscribió con María, su esposa, que estaba embarazada."
,"6":"Mientras estaban en Belén, llegó para María el momento del parto"
,"7":"y dio a luz a su hijo primogénito. Lo envolvió en pañales y lo acostó en un pesebre, pues no había lugar para ellos en la sala principal de la casa."
,"8":"En la región había pastores que vivían en el campo y que por la noche se turnaban para cuidar sus rebaños."
,"9":"Se les apareció un ángel del Señor, y la gloria del Señor los rodeó de claridad. Y quedaron muy asustados."
,"10":"Pero el ángel les dijo: 'No tengan miedo, pues yo vengo a comunicarles una buena noticia, que será motivo de mucha alegría para todo el pueblo:"
,"11":"hoy, en la ciudad de David, ha nacido para ustedes un Salvador, que es el Mesías y el Señor."
,"12":"Miren cómo lo reconocerán: hallarán a un niño recién nacido, envuelto en pañales y acostado en un pesebre.'"
,"13":"De pronto una multitud de seres celestiales aparecieron junto al ángel, y alababan a Dios con estas palabras:"
,"14":"'Gloria a Dios en lo más alto del cielo y en la tierra paz a los hombres: ésta es la hora de su gracia.'"
,"15":"Después de que los ángeles se volvieron al cielo, los pastores se dijeron unos a otros: 'Vayamos, pues, hasta Belén y veamos lo que ha sucedido y que el Señor nos ha dado a conocer.'"
,"16":"Fueron apresuradamente y hallaron a María y a José con el recién nacido acostado en el pesebre."
,"17":"Entonces contaron lo que los ángeles les habían dicho del niño."
,"18":"Todos los que escucharon a los pastores quedaron maravillados de lo que decían."
,"19":"María, por su parte, guardaba todos estos acontecimientos y los volvía a meditar en su interior."
,"20":"Después los pastores regresaron alabando y glorificando a Dios por todo lo que habían visto y oído, tal como los ángeles se lo habían anunciado."
,"21":"Cumplidos los ocho días, circuncidaron al niño y le pusieron el nombre de Jesús, nombre que había indicado el ángel antes de que su madre quedara embarazada."
,"22":"Asimismo, cuando llegó el día en que, de acuerdo con la Ley de Moisés, debían cumplir el rito de la purificación, llevaron al niño a Jerusalén para presentarlo al Señor,"
,"23":"tal como está escrito en la Ley del Señor: Todo varón primogénito será consagrado al Señor."
,"24":"También ofrecieron el sacrificio que ordena la Ley del Señor: una pareja de tórtolas o dos pichones."
,"25":"Había entonces en Jerusalén un hombre muy piadoso y cumplidor a los ojos de Dios, llamado Simeón. Este hombre esperaba el día en que Dios atendiera a Israel, y el Espíritu Santo estaba con él."
,"26":"Le había sido revelado por el Espíritu Santo que no moriría antes de haber visto al Mesías del Señor."
,"27":"El Espíritu también lo llevó al Templo en aquel momento. Como los padres traían al niño Jesús para cumplir con él lo que mandaba la Ley, "
,"28":"Simeón lo tomó en sus brazos y bendijo a Dios con estas palabras:"
,"29":"Ahora, Señor, ya puedes dejar que tu servidor muera en paz, como le has dicho."
,"30":"Porque mis ojos han visto a tu salvador,"
,"31":"que has preparado y ofreces a todos los pueblos,"
,"32":"luz que se revelará a las naciones,y gloria de tu pueblo, Israel."
,"33":"Su padre y su madre estaban maravillados por todo lo que se decía del niño."
,"34":"Simeón los bendijo y dijo a María, su madre: 'Mira, este niño traerá a la gente de Israel caída o resurrección. Será una señal impugnada en cuanto se manifieste,"
,"35":"mientras a ti misma una espada te atravesará el alma. Por este medio, sin embargo, saldrán a la luz los pensamientos íntimos de los hombres.'"
,"36":"Había también una profetisa muy anciana, llamada Ana, hija de Fanuel, de la tribu de Aser. No había conocido a otro hombre que a su primer marido, muerto después de siete años de matrimonio."
,"37":"Permaneció viuda, y tenía ya ochenta y cuatro años. No se apartaba del Templo, sirviendo día y noche al Señor con ayunos y oraciones."
,"38":"Llegó en aquel momento y también comenzó a alabar a Dios hablando del niño a todos los que esperaban la liberación de Jerusalén."
,"39":"Una vez que cumplieron todo lo que ordenaba la Ley del Señor, volvieron a Galilea, a su ciudad de Nazaret."
,"40":"El niño crecía y se desarrollaba lleno de sabiduría, y la gracia de Dios permanecía con él."
,"41":"Los padres de Jesús iban todos los años a Jerusalén para la fiesta de la Pascua."
,"42":"Cuando Jesús cumplió los doce años, subió también con ellos a la fiesta, pues así había de ser."
,"43":"Al terminar los días de la fiesta regresaron, pero el niño Jesús se quedó en Jerusalén sin que sus padres lo supieran."
,"44":"Seguros de que estaba con la caravana de vuelta, caminaron todo un día. Después se pusieron a buscarlo entre sus parientes y conocidos."
,"45":"Como no lo encontraran, volvieron a Jerusalén en su búsqueda."
,"46":"Al tercer día lo hallaron en el Templo, sentado en medio de los maestros de la Ley, escuchándolos y haciéndoles preguntas."
,"47":"Todos los que le oían quedaban asombrados de su inteligencia y de sus respuestas."
,"48":"Sus padres se emocionaron mucho al verlo; su madre le decía: 'Hijo, ¿por qué nos has hecho esto? Tu padre y yo hemos estado muy angustiados mientras te buscábamos.'"
,"49":"El les contestó: '¿Y por qué me buscaban? ¿No saben que yo debo estar donde mi Padre?'"
,"50":"Pero ellos no comprendieron esta respuesta."
,"51":"Jesús entonces regresó con ellos, llegando a Nazaret. Posteriormente siguió obedeciéndoles. Su madre, por su parte, guardaba todas estas cosas en su corazón."
,"52":"Mientras tanto, Jesús crecía en sabiduría, en edad y en gracia, ante Dios y ante los hombres."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Era el año quince del reinado del emperador Tiberio. Poncio Pilato era gobernador de Judea, Herodes gobernaba en Galilea, su hermano Filipo en Iturea y Traconítide, y Lisanias en Abilene;"
,"2":"Anás y Caifás eran los jefes de los sacerdotes. En este tiempo la palabra de Dios le fue dirigida a Juan, hijo de Zacarías, que estaba en el desierto."
,"3":"Juan empezó a recorrer toda la región del río Jordán, predicando bautismo y conversión, para obtener el perdón de los pecados."
,"4":"Esto ya estaba escrito en el libro del profeta Isaías: Oigan ese grito en el desierto: Preparen el camino del Señor, enderecen sus senderos."
,"5":"Las quebradas serán rellenadas y los montes y cerros allanados. Lo torcido será enderezado, y serán suavizadas las asperezas de los caminos."
,"6":"Todo mortal entonces verá la salvación de Dios."
,"7":"Juan decía a las muchedumbres que venían a él de todas partes para que las bautizara: 'Raza de víboras, ¿cómo van a pensar que escaparán del castigo que se acerca?"
,"8":"Produzcan los frutos de una sincera conversión, pues no es el momento de decir: 'Nosotros somos hijos de Abrahán'. Yo les aseguro que Dios puede sacar hijos de Abrahán también de estas piedras."
,"9":"El hacha ya está puesta a la raíz de los árboles, y todo árbol que no dé buen fruto será cortado y arrojado al fuego.'"
,"10":"La gente le preguntaba: '¿Qué debemos hacer?'"
,"11":"El les contestaba: 'El que tenga dos capas, que dé una al que no tiene, y el que tenga de comer, haga lo mismo.'"
,"12":"Vinieron también cobradores de impuestos para que Juan los bautizara. Le dijeron: 'Maestro, ¿qué tenemos que hacer?'"
,"13":"Respondió Juan: 'No cobren más de lo establecido.'"
,"14":"A su vez, unos soldados le preguntaron: 'Y nosotros, ¿qué debemos hacer?' Juan les contestó: 'No abusen de la gente, no hagan denuncias falsas y conténtense con su sueldo.'"
,"15":"El pueblo estaba en la duda, y todos se preguntaban interiormente si Juan no sería el Mesías,"
,"16":"por lo que Juan hizo a todos esta declaración: 'Yo les bautizo con agua, pero está para llegar uno con más poder que yo, y yo no soy digno de desatar las correas de su sandalia. El los bautizará con el Espíritu Santo y el fuego."
,"17":"Tiene la pala en sus manos para separar el trigo de la paja. Guardará el trigo en sus graneros, mientras que la paja la quemará en el fuego que no se apaga.'"
,"18":"Con estas instrucciones y muchas otras, Juan anunciaba la Buena Nueva al pueblo."
,"19":"Pero como reprochara al virrey Herodes que estuviera viviendo con Herodías, esposa de su hermano, y también por todo el mal que cometía, Herodes"
,"20":"no dudó en apresar a Juan, con lo que añadió otro crimen más a todos los anteriores."
,"21":"Un día fue bautizado también Jesús entre el pueblo que venía a recibir el bautismo. Y mientras estaba en oración, se abrieron los cielos:"
,"22":"el Espíritu Santo bajó sobre él y se manifestó exteriormente en forma de paloma, y del cielo vino una voz: 'Tú eres mi Hijo, hoy te he dado a la vida.'"
,"23":"Jesús ya había pasado los treinta años de edad cuando comenzó. Para todos era el hijo de José, hijo de Helí,"
,"24":"hijo de Matat, hijo de Leví, hijo de Melquí, hijo de Janaí, hijo de José,"
,"25":"hijo de Matatías, hijo de Amós, hijo de Nahúm, hijo de Eslí, hijo de Nagai,"
,"26":"hijo de Maat, hijo de Matatías, hijo de Semeí, hijo de José, hijo de Judá,"
,"27":"hijo de Joanán, hijo de Resí, hijo de Zorobabel, hijo de Salatiel, hijo de Nerib,"
,"28":"hijo de Melquí, hijo de Adí, hijo de Koram, hijo de Elmada, hijo de Er,"
,"29":"hijo de Jesús, hijo de Eliecer, hijo de Jarim, hijo de Matat, hijo de Leví,"
,"30":"hijo de Simeón, hijo de Judá, hijo de José, hijo de Jonán, hijo de Eliaquim,"
,"31":"hijo de Milea, hijo de Mená, hijo de Matatá, hijo de Natán,"
,"32":"hijo de David, hijo de Jesé, hijo de Obed, hijo de Booz, hijo de Salomón, hijo de Najasón,"
,"33":"hijo de Aminadab, hijo de Admín, hijo de Arní, hijo de Esrón, hijo de Farés, hijo de Judá,"
,"34":"hijo de Jacob, hijo de Isaac, hijo de Abrahán, hijo de Tara, hijo de Najor,"
,"35":"hijo de Seruc, hijo de Ragau, hijo de Falec, hijo de Eber, hijo de Sala,"
,"36":"hijo de Cainam, hijo de Arfaxad, hijo de Sem, hijo de Noé, hijo de Lamec,"
,"37":"hijo de Matusalén, hijo de Henoc, hijo de Jared, hijo de Malaleel, hijo de Cainam,"
,"38":"hijo de Enós, hijo de Set, hijo de Adán, que venía de Dios."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Jesús volvió de las orillas del Jordán lleno del Espíritu Santo y se dejó guiar por el Espíritu a través del desierto,"
,"2":"donde fue tentado por el demonio durante cuarenta días. En todo ese tiempo no comió nada, y al final sintió hambre."
,"3":"Entonces el diablo le dijo: 'Si eres Hijo de Dios, manda a esta piedra que se convierta en pan.'"
,"4":"Jesús le contestó: 'Dice la Escritura: El hombre no vive solamente de pan.'"
,"5":"Lo llevó después el diablo a un lugar más alto, le mostró en un instante todas las naciones del mundo"
,"6":"y le dijo: 'Te daré poder sobre estos pueblos, y sus riquezas serán tuyas, porque me las han entregado a mí y yo las doy a quien quiero."
,"7":"Si te arrodillas y me adoras, todo será tuyo.'"
,"8":"Jesús le replicó: 'La Escritura dice: Adorarás al Señor tu Dios y a él sólo servirás.'"
,"9":"A continuación el diablo lo llevó a Jerusalén y lo puso en la muralla más alta del Templo, diciéndole: 'Si tú eres Hijo de Dios, tírate de aquí abajo,"
,"10":"pues dice la Escritura: Dios ordenará a sus ángeles que te protejan;"
,"11":"y también: Ellos te llevarán en sus manos, para que tu pie no tropiece en ninguna piedra.'"
,"12":"Jesús le replicó: 'También dice la Escritura: No tentarás al Señor tu Dios.'"
,"13":"Al ver el diablo que había agotado todas las formas de tentación, se alejó de Jesús, a la espera de otra oportunidad."
,"14":"Jesús volvió a Galilea con el poder del Espíritu, y su fama corrió por toda aquella región."
,"15":"Enseñaba en las sinagogas de los judíos y todos lo alababan."
,"16":"Llegó a Nazaret, donde se había criado, y el sábado fue a la sinagoga, como era su costumbre. Se puso de pie para hacer la lectura,"
,"17":"y le pasaron el libro del profeta Isaías. Jesús desenrolló el libro y encontró el pasaje donde estaba escrito:"
,"18":"El Espíritu del Señor está sobre mí. El me ha ungido para llevar buenas nuevas a los pobres, para anunciar la libertad a los cautivos y a los ciegos que pronto van a ver, para despedir libres a los oprimidos"
,"19":"y proclamar el año de gracia del Señor."
,"20":"Jesús entonces enrolló el libro, lo devolvió al ayudante y se sentó, mientras todos los presentes tenían los ojos fijos en él."
,"21":"Y empezó a decirles: 'Hoy les llegan noticias de cómo se cumplen estas palabras proféticas.'"
,"22":"Todos lo aprobaban y se quedaban maravillados, mientras esta proclamación de la gracia de Dios salía de sus labios. Y decían: '¡Pensar que es el hijo de José!'"
,"23":"Jesús les dijo: 'Seguramente ustedes me van a recordar el dicho: Médico, cúrate a ti mismo. Realiza también aquí, en tu patria, lo que nos cuentan que hiciste en Cafarnaún.'"
,"24":"Y Jesús añadió: 'Ningún profeta es bien recibido en su patria."
,"25":"En verdad les digo que había muchas viudas en Israel en tiempos de Elías, cuando el cielo retuvo la lluvia durante tres años y medio y un gran hambre asoló a todo el país."
,"26":"Sin embargo Elías no fue enviado a ninguna de ellas, sino a una mujer de Sarepta, en tierras de Sidón."
,"27":"También había muchos leprosos en Israel en tiempos del profeta Eliseo, y ninguno de ellos fue curado, sino Naamán, el sirio.'"
,"28":"Todos en la sinagoga se indignaron al escuchar estas palabras;"
,"29":"se levantaron y lo empujaron fuera del pueblo, llevándolo hacia un barranco del cerro sobre el que está construido el pueblo, con intención de arrojarlo desde allí."
,"30":"Pero Jesús pasó por medio de ellos y siguió su camino."
,"31":"Jesús bajó a Cafarnaún, pueblo de Galilea. Enseñaba a la gente en las reuniones de los sábados,"
,"32":"y su enseñanza hacía gran impacto sobre la gente, porque hablaba con autoridad."
,"33":"Se hallaba en la sinagoga un hombre endemoniado, y empezó a gritar:"
,"34":"'¿Qué quieres de nosotros, Jesús de Nazaret? ¿Has venido a destruirnos? Yo sé quién eres: Tú eres el Santo de Dios.'"
,"35":"Jesús amenazó al demonio, ordenándole: 'Cállate y sal de ese hombre.' El demonio lo arrojó al suelo, pero luego salió de él sin hacerle daño alguno."
,"36":"La gente quedó aterrada y se decían unos a otros: '¿Qué significa esto? ¿Con qué autoridad y poder manda a los demonios? ¡Y miren cómo se van!'"
,"37":"Con esto la fama de Jesús se propagaba por todos los alrededores."
,"38":"Al salir Jesús de la sinagoga fue a casa de Simón. La suegra de Simón estaba con fiebre muy alta, y le rogaron por ella."
,"39":"Jesús se inclinó hacia ella, dio una orden a la fiebre y ésta desapareció. Ella se levantó al instante y se puso a atenderlos."
,"40":"Al ponerse el sol, todos los que tenían enfermos de diversos males se los llevaban a Jesús y él los sanaba imponiéndoles las manos a cada uno."
,"41":"También salieron demonios de varias personas; ellos gritaban: 'Tú eres el Hijo de Dios', pero él los amenazaba y no les permitía decir que él era el Mesías, porque lo sabían."
,"42":"Jesús salió al amanecer y se fue a un lugar solitario. La gente lo andaba buscando, y los que pudieron dar con él le insistían para que no se fuera de su pueblo."
,"43":"Pero Jesús les dijo: 'Yo tengo que anunciar también a las otras ciudades la Buena Nueva del Reino de Dios, porque para eso he sido enviado.'"
,"44":"Salió, pues, a predicar por las sinagogas del país judío."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Cierto día la gente se agolpaba a su alrededor para escuchar la palabra de Dios, y él estaba de pie a la orilla del lago de Genesaret."
,"2":"En eso vio dos barcas amarradas al borde del lago; los pescadores habían bajado y lavaban las redes."
,"3":"Subió a una de las barcas, que era la de Simón, y le pidió que se alejara un poco de la orilla; luego se sentó y empezó a enseñar a la multitud desde la barca."
,"4":"Cuando terminó de hablar, dijo a Simón: 'Lleva la barca mar adentro y echen las redes para pescar.'"
,"5":"Simón respondió: 'Maestro, por más que lo hicimos durante toda la noche, no pescamos nada; pero, si tú lo dices, echaré las redes.'"
,"6":"Así lo hicieron, y pescaron tal cantidad de peces, que las redes casi se rompían."
,"7":"Entonces hicieron señas a sus compañeros que estaban en la otra barca para que vinieran a ayudarles. Vinieron y llenaron tanto las dos barcas, que por poco se hundían."
,"8":"Al ver esto, Simón Pedro se arrodilló ante Jesús, diciendo: 'Señor, apártate de mí, que soy un hombre pecador.'"
,"9":"Pues tanto él como sus ayudantes se habían quedado sin palabras por la pesca que acababan de hacer."
,"10":"Lo mismo les pasaba a Santiago y a Juan, hijos de Zebedeo, compañeros de Simón. Jesús dijo a Simón: 'No temas; en adelante serás pescador de hombres.' "
,"11":"En seguida llevaron sus barcas a tierra, lo dejaron todo y siguieron a Jesús."
,"12":"Estando Jesús en uno de esos pueblos, se presentó un hombre cubierto de lepra. Apenas vio a Jesús, se postró con la cara en tierra y le suplicó: 'Señor, si tú quieres, puedes limpiarme.'"
,"13":"Jesús extendió la mano y lo tocó, diciendo: 'Lo quiero, queda limpio.'"
,"14":"Y al instante le desapareció la lepra. Jesús le dio aviso que no lo dijera a nadie. 'Vete, le dijo, preséntate al sacerdote y haz la ofrenda por tu purificación como ordenó Moisés, pues tienes que hacerles tu declaración.'"
,"15":"La fama de Jesús crecía más y más, a tal punto que multitudes acudían para oírle y ser curados de sus enfermedades."
,"16":"Pero él buscaba siempre lugares solitarios donde orar."
,"17":"Un día Jesús estaba enseñando, y había allí entre los asistentes unos fariseos y maestros de la Ley que habían venido de todas partes de Galilea, de Judea e incluso de Jerusalén. El poder del Señor se manifestaba ante ellos, realizando curaciones."
,"18":"En ese momento llegaron unos hombres que traían a un paralítico en su camilla. Querían entrar en la casa para colocar al enfermo delante de Jesús,"
,"19":"pero no lograron abrirse camino a través de aquel gentío. Entonces subieron al tejado, quitaron tejas y bajaron al enfermo en su camilla, poniéndolo en medio de la gente delante de Jesús."
,"20":"Viendo Jesús la fe de estos hombres, dijo al paralítico: 'Amigo, tus pecados quedan perdonados.'"
,"21":"De inmediato los maestros de la Ley y los fariseos empezaron a pensar: '¿Cómo puede blasfemar de este modo? ¿Quién puede perdonar los pecados fuera de Dios?'"
,"22":"Jesús leyó sus pensamientos y les dijo:"
,"23":"'¿Por qué piensan ustedes así? ¿Qué es más fácil decir: 'Tus pecados te quedan perdonados', o decir: 'Levántate y anda'?"
,"24":"Sepan, pues, que el Hijo del Hombre tiene poder en la tierra para perdonar los pecados.' Entonces dijo al paralítico: 'Yo te lo ordeno: levántate, toma tu camilla y vete a tu casa.'"
,"25":"Y al instante el hombre se levantó a la vista de todos, tomó la camilla en que estaba tendido y se fue a su casa dando gloria a Dios."
,"26":"Todos quedaron atónitos y alababan a Dios diciendo: 'Hoy hemos visto cosas increíbles.' Pues todos estaban sobrecogidos de un santo temor."
,"27":"Al salir, Jesús vio a un cobrador de impuestos, llamado Leví, que estaba sentado en el puesto donde cobraba. Jesús le dijo: 'Sígueme.'"
,"28":"Leví se levantó, lo dejó todo y empezó a seguirlo."
,"29":"Leví le ofreció un gran banquete en su casa, y con ellos se sentaron a la mesa un buen número de cobradores de impuestos y gente de toda clase."
,"30":"Al ver esto, los fariseos y los maestros de la Ley que eran amigos suyos expresaban su descontento en medio de los discípulos de Jesús: '¿Cómo es que ustedes comen y beben con los cobradores de impuestos y con personas malas?'"
,"31":"Pero Jesús tomó la palabra y les dijo: 'No son las personas sanas las que necesitan médico, sino las enfermas."
,"32":"No he venido para llamar a los buenos, sino para invitar a los pecadores a que se arrepientan.'"
,"33":"Algunos le dijeron: 'Los discípulos de Juan ayunan a menudo y rezan sus oraciones, y lo mismo hacen los discípulos de los fariseos, mientras que los tuyos comen y beben.'"
,"34":"Jesús les respondió: 'Ustedes no pueden obligar a los compañeros del novio a que ayunen mientras el novio está con ellos."
,"35":"Llegará el momento en que les será quitado el novio, y entonces ayunarán.'"
,"36":"Jesús les propuso además esta comparación: 'Nadie saca un pedazo de un vestido nuevo para remendar otro viejo. ¿Quién va a romper algo nuevo, para que después el pedazo tomado del nuevo no le venga bien al vestido viejo?"
,"37":"Nadie echa tampoco vino nuevo en envases de cuero viejos; si lo hace, el vino nuevo hará reventar los envases, se derramará el vino y se perderán también los envases."
,"38":"Pongan el vino nuevo en envases nuevos."
,"39":"Y miren: el que esté acostumbrado al añejo no querrá vino nuevo, sino que dirá: El añejo es el bueno.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Un sábado, Jesús atravesaba unos sembrados, y sus discípulos cortaban espigas, las desgranaban en las manos y se comían el grano."
,"2":"Algunos fariseos les dijeron: '¿Por qué hacen lo que no está permitido hacer en día sábado?'"
,"3":"Jesús les respondió: '¿Ustedes no han leído lo que hizo David, y con él sus hombres, un día que tuvieron hambre?"
,"4":"Pues entró en la Casa de Dios, tomó los panes de la ofrenda, los comió y les dio también a sus hombres, a pesar de que sólo estaba permitido a los sacerdotes comer de ese pan.'"
,"5":"Y Jesús añadió: 'El Hijo del Hombre es Señor y tiene autoridad sobre el sábado.'"
,"6":"Otro sábado Jesús había entrado en la sinagoga y enseñaba. Había allí un hombre que tenía paralizada la mano derecha."
,"7":"Los maestros de la Ley y los fariseos espiaban a Jesús para ver si hacía una curación en día sábado y encontrar así motivo para acusarlo."
,"8":"Pero Jesús, que conocía sus pensamientos, dijo al hombre que tenía la mano paralizada: 'Levántate y ponte ahí en medio.' El se levantó y permaneció de pie."
,"9":"Entonces Jesús les dijo: 'A ustedes les pregunto: ¿Qué permite hacer la Ley en día sábado: hacer el bien o hacer daño, salvar una vida o destruirla?'"
,"10":"Paseando entonces su mirada sobre todos ellos, dijo al hombre: 'Extiende tu mano.' Lo hizo, y su mano quedó sana."
,"11":"Pero ellos se llenaron de rabia y comenzaron a discutir entre sí qué podrían hacer contra Jesús."
,"12":"En aquellos días se fue a orar a un cerro y pasó toda la noche en oración con Dios."
,"13":"Al llegar el día llamó a sus discípulos y escogió a doce de ellos, a los que llamó apóstoles:"
,"14":"Simón, al que le dio el nombre de Pedro, y su hermano Andrés, Santiago, Juan, Felipe, Bartolomé,"
,"15":"Mateo, Tomás, Santiago, hijo de Alfeo, Simón, apodado Zelote,"
,"16":"Judas, hermano de Santiago, y Judas Iscariote, que fue el traidor."
,"17":"Jesús bajó con ellos y se detuvo en un lugar llano. Había allí un grupo impresionante de discípulos suyos y una cantidad de gente procedente de toda Judea y de Jerusalén y también de la costa de Tiro y de Sidón. Habían venido para oírlo y para que los sanara de sus enfermedades;"
,"18":"también los atormentados por espíritus malos recibían curación."
,"19":"Por eso cada cual trataba de tocarlo, porque de él salía una fuerza que los sanaba a todos."
,"20":"El, entonces, levantó los ojos hacia sus discípulos y les dijo:"
,"21":"'Felices ustedes los pobres, porque de ustedes es el Reino de Dios. Felices ustedes los que ahora tienen hambre, porque serán saciados. Felices ustedes los que lloran, porque reirán."
,"22":"Felices ustedes si los hombres los odian, los expulsan, los insultan y los consideran unos delincuentes a causa del Hijo del Hombre."
,"23":"Alégrense en ese momento y llénense de gozo, porque les espera una recompensa grande en el cielo. Recuerden que de esa manera trataron también a los profetas en tiempos de sus padres."
,"24":"Pero ¡pobres de ustedes los ricos, porque tienen ya su consuelo!"
,"25":"¡Pobres de ustedes los que ahora están satisfechos, porque después tendrán hambre!,¡Pobres de ustedes los que ahora ríen, porque van a llorar de pena!"
,"26":"¡Pobres de ustedes, cuando todos hablen bien de ustedes, porque de esa misma manera trataron a los falsos profetas en tiempos de sus antepasados!"
,"27":"Yo les digo a ustedes que me escuchan: amen a sus enemigos, hagan el bien a los que los odian,"
,"28":"bendigan a los que los maldicen, rueguen por los que los maltratan."
,"29":"Al que te golpea en una mejilla, preséntale también la otra. Al que te arrebata el manto, entrégale también el vestido."
,"30":"Da al que te pide, y al que te quita lo tuyo, no se lo reclames."
,"31":"Traten a los demás como quieren que ellos les traten a ustedes."
,"32":"Porque si ustedes aman a los que los aman, ¿qué mérito tienen? Hasta los malos aman a los que los aman."
,"33":"Y si hacen bien a los que les hacen bien, ¿qué gracia tiene? También los pecadores obran así."
,"34":"Y si prestan algo a los que les pueden retribuir, ¿qué gracia tiene? También los pecadores prestan a pecadores para que éstos correspondan con algo."
,"35":"Amen a sus enemigos, hagan el bien y presten sin esperar nada a cambio. Entonces la recompensa de ustedes será grande y serán hijos del Altísimo, que es bueno con los ingratos y los pecadores."
,"36":"Sean compasivos como es compasivo el Padre de ustedes."
,"37":"No juzguen y no serán juzgados; no condenen y no serán condenados; perdonen y serán perdonados."
,"38":"Den, y se les dará; se les echará en su delantal una medida colmada, apretada y rebosante. Porque con la medida que ustedes midan serán medidos ustedes.'"
,"39":"Jesús les puso también esta comparación: '¿Puede un ciego guiar a otro ciego? Ciertamente caerán ambos en algún hoyo."
,"40":"El discípulo no está por encima de su maestro, pero si se deja formar, se parecerá a su maestro."
,"41":"¿Y por qué te fijas en la pelusa que tiene tu hermano en un ojo, si no eres consciente de la viga que tienes en el tuyo?"
,"42":"¿Cómo puedes decir a tu hermano: 'Hermano, deja que te saque la pelusa que tienes en el ojo', si tú no ves la viga en el tuyo? Hipócrita, saca primero la viga de tu propio ojo para que veas con claridad, y entonces sacarás la pelusa del ojo de tu hermano."
,"43":"No hay árbol bueno que dé frutos malos, ni tampoco árbol malo que dé frutos buenos."
,"44":"Cada árbol se conoce por sus frutos. No se recogen higos de los espinos ni se sacan uvas de las zarzas."
,"45":"Así, el hombre bueno saca cosas buenas del tesoro que tiene en su corazón, mientras que el malo, de su fondo malo saca cosas malas. La boca habla de lo que está lleno el corazón."
,"46":"¿Por qué me llaman: ¡Señor! ¡Señor!, y no hacen lo que digo?"
,"47":"Les voy a decir a quién se parece el que viene a mí y escucha mis palabras y las practica."
,"48":"Se parece a un hombre que construyó una casa; cavó profundamente y puso los cimientos sobre la roca; vino una inundación y la corriente se precipitó sobre la casa, pero no pudo removerla porque estaba bien construida."
,"49":"Por el contrario, el que escucha, pero no pone en práctica, se parece a un hombre que construyó su casa sobre tierra, sin cimientos. La corriente se precipitó sobre ella y en seguida se desmoronó, siendo grande el desastre de aquella casa."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Cuando terminó de enseñar al pueblo con estas palabras, Jesús entró en Cafarnaún."
,"2":"Había allí un capitán que tenía un sirviente muy enfermo al que quería mucho, y que estaba a punto de morir."
,"3":"Habiendo oído hablar de Jesús, le envió algunos judíos importantes para rogarle que viniera y salvara a su siervo."
,"4":"Llegaron donde Jesús y le rogaron insistentemente, diciéndole: 'Este hombre se merece que le hagas este favor,"
,"5":"pues ama a nuestro pueblo y nos ha construido una sinagoga.'"
,"6":"Jesús se puso en camino con ellos. No estaban ya lejos de la casa cuando el capitán envió a unos amigos para que le dijeran: 'Señor, no te molestes, pues ¿quién soy yo, para que entres bajo mi techo?"
,"7":"Por eso ni siquiera me atreví a ir personalmente donde ti. Basta que tú digas una palabra y mi sirviente se sanará."
,"8":"Yo mismo, a pesar de que soy un subalterno, tengo soldados a mis órdenes, y cuando le ordeno a uno: 'Vete', va; y si le digo a otro: 'Ven', viene; y si digo a mi sirviente: 'Haz esto', lo hace.'"
,"9":"Al oír estas palabras, Jesús quedó admirado, y volviéndose hacia la gente que lo seguía, dijo: 'Les aseguro, que ni siquiera en Israel he hallado una fe tan grande.'"
,"10":"Y cuando los enviados regresaron a casa, encontraron al sirviente totalmente restablecido."
,"11":"Jesús se dirigió poco después a un pueblo llamado Naím, y con él iban sus discípulos y un buen número de personas."
,"12":"Cuando llegó a la puerta del pueblo, sacaban a enterrar a un muerto: era el hijo único de su madre, que era viuda, y mucha gente del pueblo la acompañaba."
,"13":"Al verla, el Señor se compadeció de ella y le dijo: 'No llores.'"
,"14":"Después se acercó y tocó el féretro. Los que lo llevaban se detuvieron. Dijo Jesús entonces: 'Joven, yo te lo mando, levántate.'"
,"15":"Se incorporó el muerto inmediatamente y se puso a hablar. Y Jesús se lo entregó a su madre."
,"16":"Un santo temor se apoderó de todos y alababan a Dios, diciendo: 'Es un gran profeta el que nos ha llegado. Dios ha visitado a su pueblo.'"
,"17":"Lo mismo se rumoreaba de él en todo el país judío y en sus alrededores."
,"18":"Los discípulos de Juan lo tenían informado de todo aquello. Llamó, pues, a dos de sus discípulos"
,"19":"y los envió a que preguntaran al Señor: '¿Eres tú el que ha de venir o tenemos que esperar a otro?'"
,"20":"Los hombres, al llegar donde Jesús, dijeron: 'Juan Bautista nos envía a preguntarte: ¿Eres tú el que ha de venir o tenemos que esperar a otro?'"
,"21":"En ese momento Jesús curó a varias personas afligidas de enfermedades, de achaques y de espíritus malignos y devolvió la vista a algunos ciegos."
,"22":"Contestó, pues, a los mensajeros: 'Vuelvan y cuéntenle a Juan lo que han visto y oído: los ciegos ven, los cojos andan, los leprosos quedan limpios, los sordos oyen, los muertos se despiertan, y una buena nueva llega a los pobres."
,"23":"Y ¡dichoso aquél para quien yo no soy un motivo de escándalo!'"
,"24":"Los mensajeros se fueron, y Jesús empezó a hablar de Juan a la gente: 'Cuando ustedes salieron al desierto, ¿qué iban a ver? ¿Una caña agitada por el viento?"
,"25":"¿Qué iban a ver? ¿Un hombre con ropas finas? Pero los que visten ropas finas y tienen comida regia están en palacios."
,"26":"Entonces, ¿qué fueron a ver? ¿Un profeta? Eso sí, y créanme, más que profeta."
,"27":"Este es el hombre de quien la escritura dice: Ahora envío a mi mensajero delante de ti para que te preceda y te abra el camino."
,"28":"Yo les digo que entre los hijos de mujer no hay ninguno más grande que Juan Bautista; y sin embargo, el más pequeño en el Reino de Dios es más que él."
,"29":"Todo el pueblo escuchó a Juan, incluso los publicanos; confesaron sus faltas y recibieron su bautismo."
,"30":"En cambio, los fariseos y los maestros de la Ley no pasaron por su bautismo, y con esto desoyeron el llamado que Dios les dirigía."
,"31":"¿Con quién puedo comparar a los hombres del tiempo presente? Son como niños sentados en la plaza, que se quejan unos de otros:"
,"32":"'Les tocamos la flauta y no han bailado; les cantamos canciones tristes y no han querido llorar.'"
,"33":"Porque vino Juan el Bautista, que no comía pan ni bebía vino, y dijeron:"
,"34":"Está endemoniado. Luego vino el Hijo del Hombre, que come y bebe, y dicen: Es un comilón y un borracho, amigo de cobradores de impuestos y de pecadores."
,"35":"Sin embargo, los hijos de la Sabiduría la reconocen en su manera de actuar.'"
,"36":"Un fariseo invitó a Jesús a comer. Entró en casa del fariseo y se reclinó en el sofá para comer."
,"37":"En aquel pueblo había una mujer conocida como una pecadora; al enterarse de que Jesús estaba comiendo en casa del fariseo, tomó un frasco de perfume, se colocó detrás de él, a sus pies,"
,"38":"y se puso a llorar. Sus lágrimas empezaron a regar los pies de Jesús y ella trató de secarlos con su cabello. Luego le besaba los pies y derramaba sobre ellos el perfume."
,"39":"Al ver esto el fariseo que lo había invitado, se dijo interiormente: 'Si este hombre fuera profeta, sabría que la mujer que lo está tocando es una pecadora, conocería a la mujer y lo que vale.'"
,"40":"Pero Jesús, tomando la palabra, le dijo: 'Simón, tengo algo que decirte.' Simón contestó: 'Habla, Maestro.' Y Jesús le dijo:"
,"41":"'Un prestamista tenía dos deudores: uno le debía quinientas monedas y el otro cincuenta."
,"42":"Como no tenían con qué pagarle, les perdonó la deuda a ambos. ¿Cuál de los dos lo querrá más?'"
,"43":"Simón le contestó: 'Pienso que aquel a quien le perdonó más.' Y Jesús le dijo: 'Has juzgado bien.'"
,"44":"Y volviéndose hacia la mujer, dijo a Simón: '¿Ves a esta mujer? Cuando entré en tu casa, no me ofreciste agua para los pies, mientras que ella me ha lavado los pies con sus lágrimas y me los ha secado con sus cabellos."
,"45":"Tú no me has recibido con un beso, pero ella, desde que entró, no ha dejado de cubrirme los pies de besos."
,"46":"Tú no me ungiste la cabeza con aceite; ella, en cambio, ha derramado perfume sobre mis pies."
,"47":"Por eso te digo que sus pecados, sus numerosos pecados, le quedan perdonados, por el mucho amor que ha manifestado. En cambio aquel al que se le perdona poco, demuestra poco amor.'"
,"48":"Jesús dijo después a la mujer: 'Tus pecados te quedan perdonados'."
,"49":"Y los que estaban con él a la mesa empezaron a pensar: '¿Así que ahora pretende perdonar pecados?'"
,"50":"Pero de nuevo Jesús se dirigió a la mujer: 'Tu fe te ha salvado, vete en paz.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Jesús iba recorriendo ciudades y aldeas predicando y anunciando la Buena Nueva del Reino de Dios. Lo acompañaban los Doce"
,"2":"y también algunas mujeres a las que había curado de espíritus malos o de enfermedades: María, por sobrenombre Magdalena, de la que habían salido siete demonios;"
,"3":"Juana, mujer de un administrador de Herodes, llamado Cuza; Susana, y varias otras que los atendían con sus propios recursos."
,"4":"Un día se congregó un gran número de personas, pues la gente venía a verlo de todas las ciudades, y Jesús se puso a hablarles por medio de comparaciones o parábolas:"
,"5":"'El sembrador salió a sembrar. Al ir sembrando, una parte del grano cayó a lo largo del camino, lo pisotearon y las aves del cielo lo comieron."
,"6":"Otra parte cayó sobre rocas; brotó, pero luego se secó por falta de humedad."
,"7":"Otra cayó entre espinos, y los espinos crecieron con la semilla y la ahogaron."
,"8":"Y otra cayó en tierra buena, creció y produjo el ciento por uno.' Al terminar, Jesús exclamó: 'Escuchen, pues, si ustedes tienen oídos para oír.'"
,"9":"Sus discípulos le preguntaron qué quería decir aquella comparación."
,"10":"Jesús les contestó: 'A ustedes se les concede conocer los misterios del Reino de Dios, mientras que a los demás les llega en parábolas. Así, pues, mirando no ven y oyendo no comprenden."
,"11":"Aprendan lo que significa esta comparación: La semilla es la palabra de Dios."
,"12":"Los que están a lo largo del camino son los que han escuchado la palabra, pero después viene el diablo y la arranca de su corazón, pues no quiere que crean y se salven."
,"13":"Lo que cayó sobre la roca son los que, al escuchar la palabra, la acogen con alegría, pero no tienen raíz; no creen más que por un tiempo y fallan en la hora de la prueba."
,"14":"Lo que cayó entre espinos son los que han escuchado la palabra, pero las preocupaciones, la riquezas y los placeres de la vida los ahogan con el paso del tiempo y no llegan a madurar."
,"15":"Y lo que cae en tierra buena son los que reciben la palabra con un corazón noble y generoso, la guardan y, perseverando, dan fruto."
,"16":"Nadie enciende una lámpara para cubrirla con una vasija o para colocarla debajo de la cama. Por el contrario, la pone sobre un candelero para que los que entren vean la luz."
,"17":"No hay nada escondido que no deba ser descubierto, ni nada tan secreto que no llegue a conocerse y salir a la luz."
,"18":"Por tanto, fíjense bien en la manera como escuchan. Porque al que produce se le dará, y al que no tiene se le quitará hasta lo que cree tener.'"
,"19":"Su madre y sus hermanos querían verlo, pero no podían llegar hasta él por el gentío que había."
,"20":"Alguien dio a Jesús este recado: 'Tu madre y tus hermanos están fuera y quieren verte.'"
,"21":"Jesús respondió: 'Mi madre y mis hermanos son los que escuchan la palabra de Dios y la cumplen.'"
,"22":"Un día subió Jesús a una barca con sus discípulos y les dijo: 'Crucemos a la otra orilla del lago.' Y remaron mar adentro."
,"23":"Mientras navegaban, Jesús se durmió. De repente se desencadenó una tempestad sobre el lago y la barca se fue llenando de agua a tal punto que peligraban."
,"24":"Se acercaron a él y lo despertaron: 'Maestro, Maestro, ¡estamos perdidos!' Jesús se levantó y amenazó al viento y a las olas encrespadas; se tranquilizaron y todo quedó en calma."
,"25":"Después les dijo: '¿Dónde está su fe?' Los discípulos se habían asustado, pero ahora estaban fuera de sí y se decían el uno al otro: '¿Quién es éste? Manda a los vientos y a las olas, y le obedecen.'"
,"26":"Llegaron a la tierra de los gerasenos, que se halla al otro lado del lago, frente a Galilea."
,"27":"Acababa Jesús de desembarcar, cuando vino a su encuentro un hombre de la ciudad que estaba poseído por demonios. Desde hacía mucho tiempo no se vestía ni vivía en casa alguna, sino que habitaba en las tumbas."
,"28":"Al ver a Jesús se puso a gritar y se echó a sus pies. Le decía a voces: '¿Qué quieres conmigo, Jesús, hijo del Dios Altísimo? Te lo ruego, no me atormentes.'"
,"29":"Es que Jesús ordenaba al espíritu malo que saliera de aquel hombre. En muchas ocasiones el espíritu se había apoderado de él y lo había llevado al desierto. En esos momentos, por más que lo ataran con cadenas y grillos para somerterlo, rompía las ataduras."
,"30":"Jesús le preguntó: '¿Cuál es tu nombre?' Y él contestó: 'Multitud.' Porque muchos demonios habían entrado en él;"
,"31":"y rogaban a Jesús que no les ordenara volver al abismo."
,"32":"Había en ese lugar un gran número de cerdos comiendo en el cerro. Los demonios suplicaron a Jesús que les permitiera entrar en los cerdos, y él se lo permitió."
,"33":"Salieron, pues, del hombre para entrar en los cerdos, y toda la piara se precipitó de lo alto del acantilado, ahogándose en el lago."
,"34":"Al ver los cuidadores lo que había ocurrido, huyeron y llevaron la noticia a la ciudad y a los campos."
,"35":"La gente salió a ver qué había pasado y llegaron a donde estaba Jesús. Encontraron junto a él al hombre del que habían salido los demonios, sentado a sus pies, vestido y en su sano juicio. Todos se asustaron. "
,"36":"Entonces los que habían sido testigos les contaron cómo el endemoniado había sido salvado."
,"37":"Un miedo muy fuerte se apoderó de ellos y todo el pueblo del territorio de los gerasenos pidió a Jesús que se alejara. Cuando Jesús subió a la barca para volver, "
,"38":"el hombre del que habían salido los demonios le rogaba que lo admitiera en su compañía. Pero Jesús lo despidió diciéndole:"
,"39":"'Vuélvete a tu casa y cuenta todo lo que Dios ha hecho por ti.' El hombre se fue y publicó en la ciudad entera todo lo que Jesús había hecho por él."
,"40":"Ya había gente para recibir a Jesús a su regreso, pues todos estaban esperándolo."
,"41":"En esto se presentó un hombre, llamado Jairo, que era dirigente de la sinagoga. Cayendo a los pies de Jesús, le suplicaba que fuera a su casa,"
,"42":"porque su hija única, de unos doce años, se estaba muriendo. Y Jesús se dirigió a la casa de Jairo, rodeado de un gentío que casi lo sofocaba."
,"43":"Entonces una mujer, que padecía hemorragias desde hacía doce años y a la que nadie había podido curar,"
,"44":"se acercó por detrás y tocó el fleco de su manto. Al instante se le detuvo el derrame."
,"45":"Jesús preguntó: '¿Quién me ha tocado?' Como todos decían: 'Yo, no', Pedro le replicó: 'Maestro, es toda esta multitud que te rodea y te oprime.'"
,"46":"Pero Jesús le dijo: 'Alguien me ha tocado, pues he sentido que una fuerza ha salido de mí.'"
,"47":"La mujer, al verse descubierta, se presentó temblando y se echó a los pies de Jesús. Después contó delante de todos por qué lo había tocado y cómo había quedado instantáneamente sana."
,"48":"Jesús le dijo: 'Hija, tu fe te ha salvado; vete en paz.'"
,"49":"Estaba aún Jesús hablando, cuando alguien vino a decir al dirigente de la sinagoga: 'Tu hija ha muerto; no tienes por qué molestar más al Maestro.'"
,"50":"Jesús lo oyó y dijo al dirigente: 'No temas: basta que creas, y tu hija se salvará.'"
,"51":"Al llegar a la casa, no permitió entrar con él más que a Pedro, Juan y Santiago y al padre y la madre de la niña."
,"52":"Los demás se lamentaban y lloraban en voz alta, pero Jesús les dijo: 'No lloren; la niña no está muerta, sino dormida.'"
,"53":"Pero la gente se burlaba de él, pues sabían que estaba muerta."
,"54":"Jesús la tomó de la mano y le dijo: 'Niña, levántate.'"
,"55":"Le volvió su espíritu; al instante se levantó, y Jesús insistió en que le dieran de comer."
,"56":"Sus padres estaban fuera de sí, y Jesús les ordenó que no dijeran a nadie lo que había sucedido."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Jesús reunió a los Doce y les dio autoridad para expulsar todos los malos espíritus y poder para curar enfermedades."
,"2":"Después los envió a anunciar el Reino de Dios y devolver la salud a las personas."
,"3":"Les dijo: 'No lleven nada para el camino: ni bolsa colgada del bastón, ni pan, ni plata, ni siquiera vestido de repuesto."
,"4":"Cuando los reciban en una casa, quédense en ella hasta que se vayan de ese lugar."
,"5":"Pero donde no los quieran recibir, no salgan del pueblo sin antes sacudir el polvo de sus pies: esto será un testimonio contra ellos.'"
,"6":"Ellos partieron a recorrer los pueblos; predicaban la Buena Nueva y hacían curaciones en todos los lugares."
,"7":"El virrey Herodes se enteró de todo lo que estaba ocurriendo y no sabía qué pensar, porque unos decían: 'Es Juan, que ha resucitado de entre los muertos';"
,"8":"y otros: 'Es Elías que ha reaparecido'; y otros: 'Es alguno de los antiguos profetas que ha resucitado.'"
,"9":"Pero Herodes se decía: 'A Juan le hice cortar la cabeza. ¿Quién es entonces éste, del cual me cuentan cosas tan raras?' Y tenía ganas de verlo."
,"10":"Al volver los apóstoles, contaron a Jesús todo lo que habían hecho. El los tomó consigo y se retiró en dirección a una ciudad llamada Betsaida para estar a solas con ellos."
,"11":"Pero la gente lo supo y partieron tras él. Jesús los acogió y volvió a hablarles del Reino de Dios mientras devolvía la salud a los que necesitaban ser atendidos."
,"12":"El día comenzaba a declinar. Los Doce se acercaron para decirle: 'Despide a la gente para que se busquen alojamiento y comida en las aldeas y pueblecitos de los alrededores, porque aquí estamos lejos de todo.'"
,"13":"Jesús les contestó: 'Denles ustedes mismos de comer.' Ellos dijeron: 'No tenemos más que cinco panes y dos pescados. ¿O desearías, tal vez, que vayamos nosotros a comprar alimentos para todo este gentío?'"
,"14":"De hecho había unos cinco mil hombres. Pero Jesús dijo a sus discípulos: 'Hagan sentar a la gente en grupos de cincuenta.'"
,"15":"Así lo hicieron los discípulos, y todos se sentaron."
,"16":"Jesús entonces tomó los cinco panes y los dos pescados, levantó los ojos al cielo, pronunció la bendición, los partió y se los entregó a sus discípulos para que los distribuyeran a la gente."
,"17":"Todos comieron hasta saciarse. Después se recogieron los pedazos que habían sobrado, y llenaron doce canastos."
,"18":"Un día Jesús se había apartado un poco para orar, pero sus discípulos estaban con él. Entonces les preguntó: 'Según el parecer de la gente, ¿quién soy yo?'"
,"19":"Ellos contestaron: 'Unos dicen que eres Juan Bautista, otros que Elías, y otros que eres alguno de los profetas antiguos que ha resucitado.'"
,"20":"Entonces les preguntó: 'Y ustedes, ¿quién dicen que soy yo?' Pedro respondió: 'Tú eres el Cristo de Dios.'"
,"21":"Jesús les hizo esta advertencia: 'No se lo digan a nadie'."
,"22":"Y les decía: 'El Hijo del Hombre tiene que sufrir mucho y ser rechazado por las autoridades judías, por los jefes de los sacerdotes y por los maestros de la Ley. Lo condenarán a muerte, pero tres días después resucitará.'"
,"23":"También Jesús decía a toda la gente: 'Si alguno quiere seguirme, que se niegue a sí mismo, que cargue con su cruz de cada día y que me siga."
,"24":"Les digo: el que quiera salvarse a sí mismo, se perderá; y el que pierda su vida por causa mía, se salvará."
,"25":"¿De qué le sirve al hombre ganar el mundo entero si se pierde o se disminuye a sí mismo?"
,"26":"Si alguien se avergüenza de mí y de mis palabras, también el Hijo del Hombre se avergonzará de él cuando venga en su gloria y en la gloria de su Padre con los ángeles santos."
,"27":"En verdad les digo que algunos de los aquí presentes no morirán sin antes haber visto el Reino de Dios.'"
,"28":"Unos ocho días después de estos discursos, Jesús tomó consigo a Pedro, a Santiago y a Juan y subió a un cerro a orar."
,"29":"Y mientras estaba orando, su cara cambió de aspecto y su ropa se volvió de una blancura fulgurante."
,"30":"Dos hombres, que eran Moisés y Elías, conversaban con él."
,"31":"Se veían en un estado de gloria y hablaban de su partida, que debía cumplirse en Jerusalén."
,"32":"Un sueño pesado se había apoderado de Pedro y sus compañeros, pero se despertaron de repente y vieron la gloria de Jesús y a los dos hombres que estaban con él."
,"33":"Como éstos estaban para irse, Pedro dijo a Jesús: 'Maestro, ¡qué bueno que estemos aquí! Levantemos tres chozas: una para ti, otra para Moisés y otra para Elías.' Pero no sabía lo que decía."
,"34":"Estaba todavía hablando, cuando se formó una nube que los cubrió con su sombra, y al quedar envueltos en la nube se atemorizaron."
,"35":"Pero de la nube llegó una voz que decía: 'Este es mi Hijo, mi Elegido; escúchenlo.'"
,"36":"Después de oírse estas palabras, Jesús estaba allí solo. Los discípulos guardaron silencio por aquellos días, y no contaron nada a nadie de lo que habían visto."
,"37":"Al día siguiente, cuando bajaban del cerro, les salió al encuentro un tropel de gente."
,"38":"De pronto un hombre de entre ellos empezó a gritar: 'Maestro, te lo suplico, mira a este muchacho, el único hijo que tengo."
,"39":"De repente un demonio se apodera de él y empieza a dar gritos, lo hace retorcerse con violencia y echar espumarajos, y no lo suelta sino cuando está totalmente molido."
,"40":"He pedido a tus discípulos que echaran el demonio, pero no han sido capaces.'"
,"41":"Jesús respondió: 'Gente incrédula y extraviada, ¿hasta cuándo estaré entre ustedes y tendré que soportarlos?"
,"42":"Trae acá a tu hijo.' Cuando el muchacho se acercaba, el demonio lo arrojó al suelo con violentas sacudidas. Pero Jesús habló al espíritu malo en tono dominante, curó al muchacho y se lo devolvió a su padre."
,"43":"Todos quedaron asombrados ante una tal intervención de Dios. Mientras todos quedaban admirados por las cosas que hacía, Jesús dijo a sus discípulos: "
,"44":"'Escuchen y recuerden lo que ahora les digo: El Hijo del Hombre va a ser entregado en manos de los hombres.'"
,"45":"Pero ellos no entendieron estas palabras. Algo les impedía comprender lo que significaban, y no se atrevían a pedirle una aclaración."
,"46":"A los discípulos se les ocurrió preguntarse cuál de ellos era el más importante."
,"47":"Jesús, que conocía sus pensamientos, tomó a un niño, lo puso a su lado"
,"48":"y les dijo: 'El que recibe a este niño en mi nombre, me recibe a mí, y el que me recibe a mí, recibe al que me envió. El más pequeño entre todos ustedes, ése es realmente grande.'"
,"49":"En ese momento Juan tomó la palabra y le dijo: 'Maestro, hemos visto a uno que hacía uso de tu nombre para echar fuera demonios, y le dijimos que no lo hiciera, pues no te sigue junto a nosotros.'"
,"50":"Pero Jesús le dijo: 'No se lo impidan, pues el que no está contra ustedes está con ustedes.'"
,"51":"Como ya se acercaba el tiempo en que sería llevado al cielo, Jesús emprendió resueltamente el camino a Jerusalén."
,"52":"Envió mensajeros delante de él, que fueron y entraron en un pueblo samaritano para prepararle alojamiento."
,"53":"Pero los samaritanos no lo quisieron recibir porque se dirigía a Jerusalén."
,"54":"Al ver esto sus discípulos Santiago y Juan, le dijeron: 'Señor, ¿quieres que mandemos bajar fuego del cielo que los consuma?'"
,"55":"Pero Jesús se volvió y los reprendió."
,"56":"Y continuaron el camino hacia otra aldea."
,"57":"Mientras iban de camino, alguien le dijo: 'Maestro, te seguiré adondequiera que vayas.'"
,"58":"Jesús le contestó: 'Los zorros tienen cuevas y las aves tienen nidos, pero el Hijo del Hombre ni siquiera tiene donde recostar la cabeza.'"
,"59":"Jesús dijo a otro: 'Sígueme'. El contestó: 'Señor, deja que me vaya y pueda primero enterrar a mi padre.'"
,"60":"Jesús le dijo: 'Sígueme, y deja que los muertos entierren a sus muertos. Tú vé a anunciar el Reino de Dios.'"
,"61":"Otro le dijo: 'Te seguiré, Señor, pero antes déjame despedirme de mi familia.'"
,"62":"Jesús le contestó: 'El que pone la mano en el arado y mira hacia atrás, no sirve para el Reino de Dios.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Después de esto, el Señor eligió a otros setenta y dos discípulos y los envió de dos, en dos delante de él, a todas las ciudades y lugares adonde debía ir."
,"2":"Les dijo: 'La cosecha es abundante, pero los obreros son pocos. Rueguen, pues, al dueño de la cosecha que envíe obreros a su cosecha."
,"3":"Vayan, pero sepan que los envío como corderos en medio de lobos."
,"4":"No lleven monedero, ni bolsón, ni sandalias, ni se detengan a visitar a conocidos."
,"5":"Al entrar en cualquier casa, bendíganla antes diciendo: La paz sea en esta casa."
,"6":"Si en ella vive un hombre de paz, recibirá la paz que ustedes le traen; de lo contrario, la bendición volverá a ustedes."
,"7":"Mientras se queden en esa casa, coman y beban lo que les ofrezcan, porque el obrero merece su salario."
,"8":"No vayan de casa en casa. Cuando entren en una ciudad y sean bien recibidos, coman lo que les sirvan,"
,"9":"sanen a los enfermos y digan a su gente: El Reino de Dios ha venido a ustedes."
,"10":"Pero si entran en una ciudad y no quieren recibirles, vayan a sus plazas y digan:"
,"11":"Nos sacudimos y les dejamos hasta el polvo de su ciudad que se ha pegado a nuestros pies. Con todo, sépanlo bien: el Reino de Dios ha venido a ustedes."
,"12":"Yo les aseguro que, en el día del juicio, Sodoma será tratada con menos rigor que esa ciudad."
,"13":"¡Pobre de ti, Corazaín! ¡Pobre de ti, Betsaida! Porque si los milagros que se han hecho en ustedes se hubieran realizado en Tiro y Sidón, hace mucho tiempo que sus habitantes habrían hecho penitencia, poniéndose vestidos de penitencia, y se habrían sentado en la ceniza."
,"14":"Con toda seguridad Tiro y Sidón serán tratadas con menos rigor que ustedes en el día del juicio."
,"15":"Y tú, Cafarnaún, ¿crees que te elevarás hasta el cielo? No, serás precipitada hasta el lugar de los muertos."
,"16":"Quien les escucha a ustedes, me escucha a mí; quien les rechaza a ustedes, me rechaza a mí; y el que me rechaza a mí, rechaza al que me ha enviado.'"
,"17":"Los setenta y dos discípulos volvieron muy contentos, diciendo: 'Señor, hasta los demonios nos obedecen al invocar tu nombre.'"
,"18":"Jesús les dijo: 'Yo veía a Satanás caer del cielo como un rayo."
,"19":"Miren que les he dado autoridad para pisotear serpientes y escorpiones y poder sobre toda fuerza enemiga: no habrá arma que les haga daño a ustedes."
,"20":"Sin embargo, alégrense no porque los demonios se someten a ustedes, sino más bien porque sus nombres están escritos en los cielos.'"
,"21":"En ese momento Jesús se llenó del gozo del Espíritu Santo y dijo: 'Yo te bendigo, Padre, Señor del cielo y de la tierra, porque has ocultado estas cosas a los sabios y entendidos y se las has dado a conocer a los pequeñitos. Sí, Padre, pues tal ha sido tu voluntad."
,"22":"Mi Padre ha puesto todas las cosas en mis manos; nadie sabe quién es el Hijo, sino el Padre; nadie sabe quién es el Padre sino el Hijo y aquel a quien el Hijo quiera dárselo a conocer.'"
,"23":"Después, volviéndose hacia sus discípulos, Jesús les dijo a ellos solos: '¡Felices los ojos que ven lo que ustedes ven!"
,"24":"Porque yo les digo que muchos profetas y reyes quisieron ver lo que ustedes ven y no lo vieron, y oír lo que ustedes oyen y no lo oyeron.'"
,"25":"Un maestro de la Ley, que quería ponerlo a prueba, se levantó y le dijo: 'Maestro, ¿qué debo hacer para conseguir la vida eterna?'"
,"26":"Jesús le dijo: '¿Qué está escrito en la Escritura? ¿Qué lees en ella?'"
,"27":"El hombre contestó: 'Amarás al Señor tu Dios con todo tu corazón, con toda tu alma, con todas tus fuerzas y con toda tu mente; y amarás a tu prójimo como a ti mismo.'"
,"28":"Jesús le dijo: '¡Excelente respuesta! Haz eso y vivirás.'"
,"29":"El otro, que quería justificar su pregunta, replicó: '¿Y quién es mi prójimo?'"
,"30":"Jesús empezó a decir: 'Bajaba un hombre por el camino de Jerusalén a Jericó y cayó en manos de unos bandidos, que lo despojaron hasta de sus ropas, lo golpearon y se marcharon dejándolo medio muerto."
,"31":"Por casualidad bajaba por ese camino un sacerdote; lo vió, tomó el otro lado y siguió."
,"32":"Lo mismo hizo un levita que llegó a ese lugar: lo vio, tomó el otro lado y pasó de largo."
,"33":"Un samaritano también pasó por aquel camino y lo vio; pero éste se compadeció de él."
,"34":"Se acercó, curó sus heridas con aceite y vino y se las vendó; después lo montó sobre el animal que traía, lo condujo a una posada y se encargó de cuidarlo."
,"35":"Al día siguiente sacó dos monedas y se las dio al posadero diciéndole: 'Cuídalo, y si gastas más, yo te lo pagaré a mi vuelta.'"
,"36":"Jesús entonces le preguntó: 'Según tu parecer, ¿cuál de estos tres fue el prójimo del hombre que cayó en manos de los salteadores?'"
,"37":"El maestro de la Ley contestó: 'El que se mostró compasivo con él.' Y Jesús le dijo: 'Vete y haz tú lo mismo.'"
,"38":"Siguiendo su camino, entraron en un pueblo, y una mujer, llamada Marta, lo recibió en su casa."
,"39":"Tenía una hermana llamada María, que se sentó a los pies del Señor y se quedó escuchando su palabra."
,"40":"Mientras tanto Marta estaba absorbida por los muchos quehaceres de la casa. En cierto momento Marta se acercó a Jesús y le dijo: 'Señor, ¿no te importa que mi hermana me haya dejado sola para atender? Dile que me ayude.'"
,"41":"Pero el Señor le respondió: 'Marta, Marta, tú andas preocupada y te pierdes en mil cosas:"
,"42":"una sola es necesaria. María ha elegido la mejor parte, que no le será quitada.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Un día estaba Jesús orando en cierto lugar. Al terminar su oración, uno de sus discípulos le dijo: 'Señor, enséñanos a orar, como Juan enseñó a sus discípulos.'"
,"2":"Les dijo: 'Cuando recen, digan: Padre, santificado sea tu Nombre, venga tu Reino."
,"3":"Danos cada día el pan que nos corresponde."
,"4":"Perdónanos nuestros pecados, porque también nosotros perdonamos,a todo el que nos debe. Y no nos dejes caer en la tentación.'"
,"5":"Les dijo también: 'Supongan que uno de ustedes tiene un amigo y va a medianoche a su casa a decirle: 'Amigo, préstame tres panes,"
,"6":"porque un amigo mío ha llegado de viaje y no tengo nada que ofrecerle'."
,"7":"Y el otro le responde a usted desde adentro: 'No me molestes; la puerta está cerrada y mis hijos y yo estamos ya acostados; no puedo levantarme a dártelos'."
,"8":"Yo les digo: aunque el hombre no se levante para dárselo porque usted es amigo suyo, si usted se pone pesado, al final le dará todo lo que necesita."
,"9":"Pues bien, yo les digo: Pidan y se les dará, busquen y hallarán, llamen a la puerta y les abrirán."
,"10":"Porque todo el que pide recibe, el que busca halla y al que llame a la puerta se le abrirá."
,"11":"¿Habrá un padre entre todos ustedes que dé a su hijo una serpiente cuando le pide pan?"
,"12":"Y si le pide un huevo, ¿le dará un escorpión?"
,"13":"Si ustedes, que son malos, saben dar cosas buenas a sus hijos, ¡cuánto más el Padre del Cielo dará espíritu santo a los que se lo pidan!'"
,"14":"Otro día Jesús estaba expulsando un demonio: se trataba de un hombre mudo. Apenas salió el demonio, el mudo empezó a hablar y la gente quedó admirada."
,"15":"Pero algunos de ellos dijeron: 'Este echa a los demonios con el poder de Belzebú, jefe de los demonios.'"
,"16":"Y otros, para ponerlo a prueba, le pedían una señal que viniera del cielo."
,"17":"Jesús, que conocía sus pensamientos, les dijo: 'Una nación dividida corre a la ruina, y los partidos opuestos caen uno tras otro."
,"18":"Si Satanás también está dividido, ¿podrá mantenerse su reino? ¿Cómo se les ocurre decir que yo echo los demonios invocando a Belzebú?"
,"19":"Si yo echo los demonios con la ayuda de Belzebú, los amigos de ustedes, ¿con ayuda de quién los echan? Ellos apreciarán lo que ustedes acaban de decir."
,"20":"En cambio, si echo los demonios con el dedo de Dios, comprendan que el Reino de Dios ha llegado a ustedes."
,"21":"Cuando el Fuerte, bien armado, guarda su casa, todas sus cosas están seguras;"
,"22":"pero si llega uno más fuerte y lo vence, le quitará las armas en que confiaba y distribuirá todo lo que tenía."
,"23":"El que no está conmigo, está contra mí; y el que no recoge conmigo, desparrama."
,"24":"Cuando el espíritu malo sale del hombre, empieza a recorrer lugares áridos buscando un sitio donde descansar. Como no lo encuentra, se dice: Volveré a mi casa, de donde tuve que salir."
,"25":"Al llegar la encuentra bien barrida y todo en orden."
,"26":"Se va, entonces, y regresa con otros siete espíritus peores que él; entran y se quedan allí. De tal modo que la nueva condición de la persona es peor que la primera.'"
,"27":"Mientras Jesús estaba hablando, una mujer levantó la voz de entre la multitud y le dijo: '¡Feliz la que te dio a luz y te crió!'"
,"28":"Jesús replicó: '¡Felices, pues, los que escuchan la palabra de Dios y la observan!'"
,"29":"Aumentaba la multitud por la gente que llegaba y Jesús empezó a decir: 'La gente de este tiempo es gente mala. Piden una señal, pero no tendrán más señal que la señal de Jonás."
,"30":"Porque así como Jonás fue una señal para los habitantes de Nínive, de igual manera el Hijo del Hombre será una señal para esta generación."
,"31":"La reina del Sur resucitará en el día del Juicio junto con la gente de hoy y los acusará, porque ella vino desde los confines de la tierra para escuchar la sabiduría de Salomón, y aquí tienen ustedes mucho más que Salomón."
,"32":"Los habitantes de Nínive resucitarán en el día del Juicio junto con la gente de hoy y los acusarán, porque ellos se convirtieron con la predicación de Jonás, y aquí ustedes tienen mucho más que Jonás."
,"33":"Nadie enciende una lámpara para esconderla o taparla con un cajón, sino que la pone en un candelero para que los que entren vean la claridad."
,"34":"Tu ojo es la lámpara de tu cuerpo. Si tu ojo recibe la luz, toda tu persona tendrá luz; pero si tu ojo está oscurecido, toda tu persona estará en oscuridad."
,"35":"Procura, pues, que la luz que hay dentro de ti no se vuelva oscuridad."
,"36":"Si toda tu persona se abre a la luz y no queda en ella ninguna parte oscura, llegará a ser radiante como bajo los destellos de la lámpara.'"
,"37":"Cuando Jesús terminó de hablar, un fariseo lo invitó a comer a su casa. Entró y se sentó a la mesa."
,"38":"El fariseo entonces se extrañó al ver que Jesús no se había lavado las manos antes de ponerse a comer."
,"39":"El Señor le dijo: 'Así son ustedes, los fariseos. Ustedes limpian por fuera las copas y platos, pero el interior de ustedes está lleno de rapiñas y perversidades. ¡Estúpidos!"
,"40":"El que hizo lo exterior, ¿no hizo también lo interior?"
,"41":"Pero, según ustedes, simplemente con dar limosnas todo queda purificado."
,"42":"¡Pobres de ustedes, fariseos! Ustedes dan para el Templo la décima parte de todo, sin olvidar la menta, la ruda y las otras hierbas, pero descuidan la justicia y el amor a Dios. Esto es lo que tienen que practicar, sin dejar de hacer lo otro."
,"43":"¡Pobres de ustedes, fariseos, que les gusta ocupar el primer puesto en las sinagogas y ser saludados en las plazas!"
,"44":"¡Pobres de ustedes!, porque son como esas tumbas que apenas se notan: uno no se da cuenta sino cuando ya las ha pisado.'"
,"45":"Un maestro de la Ley tomó entonces la palabra y dijo: 'Maestro, al hablar así nos ofendes también a nosotros.'"
,"46":"El contestó: '¡Pobres de ustedes también, maestros de la Ley, porque imponen a los demás cargas insoportables, y ustedes ni siquiera mueven un dedo para ayudarles!"
,"47":"¡Pobres de ustedes, que construyen monumentos a los profetas! ¿Quién los mató sino los padres de ustedes?"
,"48":"Así, pues, ustedes reconocen lo que hicieron sus padres, pero siguen en lo mismo: ellos se deshicieron de los profetas, y ustedes ahora pueden construir."
,"49":"La Sabiduría de Dios dice también: Yo les voy a enviar profetas y apóstoles, pero esta gente matará o perseguirá a varios de ellos."
,"50":"Por eso, a esta generación se le pedirá cuentas de la sangre de todos los profetas derramada desde la creación del mundo:"
,"51":"desde la sangre de Abel, hasta la de Zacarías, que fue asesinado entre el altar y el Santuario. Sí, yo se lo aseguro: la generación presente es la que tendrá que responder."
,"52":"¡Pobres de ustedes, maestros de la Ley, que se adueñaron de la llave del saber! Ustedes mismos no entraron, y cerraron el paso a los que estaban entrando."
,"53":"Cuando salió de allí, los maestros de la Ley y los fariseos comenzaron a hostigarlo muy duramente."
,"54":"Le pedían su parecer sobre un montón de cosas y le ponían trampas para sorprenderlo en alguna de sus respuestas."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Entre tanto se habían reunido miles y miles de personas, hasta el punto de que se aplastaban unos a otros. Entonces Jesús se puso a decir, especialmente para sus discípulos: 'Cuídense de la levadura de los fariseos, que es la hipocresía."
,"2":"Nada hay tan oculto que no haya de ser descubierto o tan escondido que no haya de ser conocido."
,"3":"Por el contrario, todo lo que hayan dicho en la oscuridad será oído a la luz del día, y lo que hayan dicho al oído en las habitaciones será proclamado desde las azoteas."
,"4":"Yo les digo a ustedes, mis amigos: No teman a los que matan el cuerpo y después ya no pueden hacer nada más."
,"5":"Yo les voy a mostrar a quién deben temer: Teman a Aquel que, después de quitarle a uno la vida, tiene poder para echarlo al infierno. Créanme que es a ése a quien deben temer."
,"6":"¿No se venden cinco pajaritos por dos monedas? Pues bien, delante de Dios ninguno de ellos ha sido olvidado."
,"7":"Incluso los cabellos de ustedes están contados. No teman, pues ustedes valen más que un sinnúmero de pajarillos."
,"8":"Yo les digo: Si uno se pone de mi parte delante de los hombres, también el Hijo del Hombre se pondrá de su parte delante de los ángeles de Dios;"
,"9":"pero el que me niegue delante de los hombres, será también negado él delante de los ángeles de Dios."
,"10":"Para el que critique al Hijo del Hombre habrá perdón, pero no habrá perdón para el que calumnie al Espíritu Santo."
,"11":"Cuando los lleven ante las sinagogas, los jueces y las autoridades, no se preocupen de cómo se van a defender o qué van a decir;"
,"12":"llegada la hora, el Espíritu Santo les enseñará lo que tengan que decir.'"
,"13":"Uno de entre la gente pidió a Jesús: 'Maestro, dile a mi hermano que me dé mi parte de la herencia.'"
,"14":"Le contestó: 'Amigo, ¿quién me ha nombrado juez o partidor de herencias?'"
,"15":"Después dijo a la gente: 'Eviten con gran cuidado toda clase de codicia, porque aunque uno lo tenga todo, no son sus posesiones las que le dan vida.'"
,"16":"A continuación les propuso este ejemplo: 'Había un hombre rico, al que sus campos le habían producido mucho."
,"17":"Pensaba: ¿Qué voy a hacer? No tengo dónde guardar mis cosechas."
,"18":"Y se dijo: Haré lo siguiente: echaré abajo mis graneros y construiré otros más grandes; allí amontonaré todo mi trigo, todas mis reservas."
,"19":"Entonces yo conmigo hablaré: Alma mía, tienes aquí muchas cosas guardadas para muchos años; descansa, come, bebe, pásalo bien.'"
,"20":"Pero Dios le dijo: '¡Pobre loco! Esta misma noche te van a reclamar tu alma. ¿Quién se quedará con lo que has preparado?'"
,"21":"Esto vale para toda persona que amontona para sí misma, en vez de acumular para Dios.'"
,"22":"Jesús dijo a sus discípulos: 'No se atormenten por su vida con cuestiones de alimentos, ni por su cuerpo con cuestiones de ropa."
,"23":"Miren que la vida es más que el alimento y el cuerpo más que el vestido."
,"24":"Aprendan de los cuervos: no siembran ni cosechan, no tienen bodegas ni graneros y, sin embargo, Dios los alimenta. ¡Y ustedes valen mucho más que las aves!"
,"25":"¿Quién de ustedes, por más que se preocupe, puede añadir algo a su estatura?"
,"26":"Si ustedes no tienen poder sobre cosas tan pequeñas, ¿cómo van a preocuparse por las demás?"
,"27":"Aprendan de los lirios del campo: no hilan ni tejen, pero yo les digo que ni Salomón, con todo su lujo, se pudo vestir como uno de ellos."
,"28":"Y si Dios da tan lindo vestido a la hierba del campo, que hoy está y mañana se echará al fuego, ¿qué no hará por ustedes, gente de poca fe?"
,"29":"No estén pendientes de lo que comerán o beberán: ¡no se atormenten!"
,"30":"Estas son cosas tras las cuales corren todas las naciones del mundo, pero el Padre de ustedes sabe que ustedes las necesitan."
,"31":"Busquen más bien el Reino, y se les darán también esas cosas."
,"32":"No temas, pequeño rebaño, porque al Padre de ustedes le agradó darles el Reino."
,"33":"Vendan lo que tienen y repártanlo en limosnas. Háganse junto a Dios bolsas que no se rompen de viejas y reservas que no se acaban; allí no llega el ladrón, y no hay polilla que destroce."
,"34":"Porque donde está tu tesoro, allí estará también tu corazón."
,"35":"Tengan puesta la ropa de trabajo y sus lámparas encendidas."
,"36":"Sean como personas que esperan que su patrón regrese de la boda para abrirle apenas llegue y golpee a la puerta."
,"37":"Felices los sirvientes a los que el patrón encuentre velando a su llegada. Yo les aseguro que él mismo se pondrá el delantal, los hará sentar a la mesa y los servirá uno por uno."
,"38":"Y si es la medianoche o la madrugada cuando llega y los encuentra así, ¡felices esos sirvientes!"
,"39":"Si el dueño de casa supiera a qué hora va a llegar el ladrón, ustedes entienden que se mantendría despierto y no le dejaría romper el muro."
,"40":"Estén también ustedes preparados, porque el Hijo del Hombre llegará a la hora que menos esperan.'"
,"41":"Pedro preguntó: 'Señor, esta parábola que has contado, ¿es sólo para nosotros o es para todos?'"
,"42":"El Señor contestó: 'Imagínense a un administrador digno de confianza y capaz. Su señor lo ha puesto al frente de sus sirvientes y es él quien les repartirá a su debido tiempo la ración de trigo."
,"43":"Afortunado ese servidor si al llegar su señor lo encuentra cumpliendo su deber."
,"44":"En verdad les digo que le encomendará el cuidado de todo lo que tiene."
,"45":"Pero puede ser que el administrador piense: 'Mi patrón llegará tarde'. Si entonces empieza a maltratar a los sirvientes y sirvientas, a comer, a beber y a emborracharse,"
,"46":"llegará su patrón el día en que menos lo espera y a la hora menos pensada, le quitará su cargo y lo mandará donde aquellos de los que no se puede fiar."
,"47":"Este servidor conocía la voluntad de su patrón; si no ha cumplido las órdenes de su patrón y no ha preparado nada, recibirá un severo castigo."
,"48":"En cambio, si es otro que hizo sin saber algo que merece azotes, recibirá menos golpes. Al que se le ha dado mucho, se le exigirá mucho; y cuanto más se le haya confiado, tanto más se le pedirá cuentas."
,"49":"He venido a traer fuego a la tierra y ¡cuánto desearía que ya estuviera ardiendo!"
,"50":"Pero también he de recibir un bautismo y ¡qué angustia siento hasta que no se haya cumplido!"
,"51":"¿Creen ustedes que he venido para establecer la paz en la tierra? Les digo que no; más bien he venido a traer división."
,"52":"Pues de ahora en adelante hasta en una casa de cinco personas habrá división: tres contra dos y dos contra tres."
,"53":"El padre estará contra del hijo y el hijo contra el padre; la madre contra la hija y la hija contra la madre; la suegra contra la nuera y la nuera contra la suegra.'"
,"54":"También decía Jesús a la gente: 'Cuando ustedes ven una nube que se levanta por el poniente, inmediatamente dicen: 'Va a llover', y así sucede."
,"55":"Y cuando sopla el viento sur, dicen: 'Hará calor', y así sucede."
,"56":"¡Gente superficial! Si ustedes saben interpretar el aspecto de la tierra y del cielo, ¿cómo es que no comprenden el tiempo presente?"
,"57":"¿Cómo no son capaces de juzgar por ustedes mismos lo que es justo?"
,"58":"Mientras vas donde las autoridades con tu adversario, aprovecha la caminata para reconciliarte con él, no sea que te arrastre ante el juez y el juez te entregue al carcelero, y el carcelero te encierre en la cárcel."
,"59":"Yo te aseguro que no saldrás de allí hasta que no hayas pagado el último centavo."
}`)
	CurrentBook.AddChapter(13, `{
"1":"En ese momento algunos le contaron a Jesús una matanza de galileos. Pilato los había hecho matar en el Templo, mezclando su sangre con la sangre de sus sacrificios."
,"2":"Jesús les replicó: '¿Creen ustedes que esos galileos eran más pecadores que los demás porque corrieron semejante suerte?"
,"3":"Yo les digo que no. Y si ustedes no renuncian a sus caminos, perecerán del mismo modo."
,"4":"Y aquellas dieciocho personas que quedaron aplastadas cuando la torre de Siloé se derrumbó, ¿creen ustedes que eran más culpables que los demás habitantes de Jerusalén?"
,"5":"Yo les aseguro que no. Y si ustedes no renuncian a sus caminos, todos perecerán de igual modo.'"
,"6":"Jesús continuó con esta comparación: 'Un hombre tenía una higuera que crecía en medio de su viña. Fue a buscar higos, pero no los halló."
,"7":"Dijo entonces al viñador: 'Mira, hace tres años que vengo a buscar higos a esta higuera, pero nunca encuentro nada. Córtala. ¿Para qué está consumiendo la tierra inútilmente?'"
,"8":"El viñador contestó: 'Señor, déjala un año más y mientras tanto cavaré alrededor y le echaré abono."
,"9":"Puede ser que así dé fruto en adelante y, si no, la cortas'.'"
,"10":"Un sábado Jesús estaba enseñando en una sinagoga."
,"11":"Había allí una mujer que desde hacía dieciocho años estaba poseída por un espíritu que la tenía enferma, y estaba tan encorvada que no podía enderezarse de ninguna manera."
,"12":"Jesús la vio y la llamó. Luego le dijo: 'Mujer, quedas libre de tu mal'."
,"13":"Y le impuso las manos. Al instante se enderezó y se puso a alabar a Dios."
,"14":"Pero el presidente de la sinagoga se enojó porque Jesús había hecho esta curación en día sábado, y dijo a la gente: 'Hay seis días en los que se puede trabajar; vengan, pues, en esos días para que los sanen, pero no en día sábado.'"
,"15":"El Señor le replicó: '¡Ustedes son unos falsos! ¿Acaso no desatan del pesebre a su buey o a su burro en día sábado para llevarlo a la fuente?"
,"16":"Esta es hija de Abrahán, y Satanás la mantenía atada desde hace dieciocho años; ¿no se la debía desatar precisamente en día sábado?'"
,"17":"Mientras Jesús hablaba, sus adversarios se sentían avergonzados; en cambio la gente se alegraba por las muchas maravillas que le veían hacer."
,"18":"Jesús continuó diciendo: '¿A qué puedo comparar el Reino de Dios? ¿Con qué ejemplo podría ilustrarlo?"
,"19":"Es semejante a un grano de mostaza que un hombre tomó y sembró en su jardín. Creció y se convirtió en un arbusto y los pájaros del cielo se refugiaron en sus ramas.'"
,"20":"Y dijo otra vez: '¿Con qué ejemplo podría ilustrar el Reino de Dios?"
,"21":"Es semejante a la levadura que tomó una mujer y la metió en tres medidas de harina hasta que fermentó toda la masa.'"
,"22":"Jesús iba enseñando por ciudades y pueblos mientras se dirigía a Jerusalén."
,"23":"Alguien le preguntó: 'Señor, ¿es verdad que son pocos los que se salvarán?'"
,"24":"Jesús respondió: 'Esfuércense por entrar por la puerta angosta, porque yo les digo que muchos tratarán de entrar y no lo lograrán."
,"25":"Si a ustedes les ha tocado estar fuera cuando el dueño de casa se levante y cierre la puerta, entonces se pondrán a golpearla y a gritar: ¡Señor, ábrenos! Pero les contestará: No sé de dónde son ustedes."
,"26":"Entonces comenzarán a decir: Nosotros hemos comido y bebido contigo, y tú has enseñado en nuestras plazas."
,"27":"Pero él les dirá de nuevo: No sé de dónde son ustedes. ¡Aléjense de mí todos los malhechores!"
,"28":"Habrá llanto y rechinar de dientes cuando vean a Abrahán, a Isaac, a Jacob y a todos los profetas en el Reino de Dios, y ustedes, en cambio, sean echados fuera."
,"29":"Gente del oriente y del poniente, del norte y del sur, vendrán a sentarse a la mesa en el Reino de Dios."
,"30":"¡Qué sorpresa! Unos que estaban entre los últimos son ahora primeros, mientras que los primeros han pasado a ser últimos.'"
,"31":"En ese momento unos fariseos llegaron para avisarle: 'Márchate de aquí, porque Herodes quiere matarte.'"
,"32":"Jesús les contestó: 'Vayan a decir a ese zorro: Hoy y mañana expulso demonios y realizo curaciones, y al tercer día llegaré a mi término."
,"33":"Pero tengo que seguir mi camino hoy, mañana y un poco más, porque no es correcto que un profeta sea asesinado fuera de Jerusalén."
,"34":"¡Jerusalén, Jerusalén, que matas a los profetas y apedreas a los que te son enviados! ¡Cuántas veces he querido reunir a tus hijos como la gallina reúne a sus polluelos debajo de sus alas, y tú no has querido!"
,"35":"Por eso se van a quedar con su Templo vacío y no me volverán a ver hasta que llegue el tiempo en que ustedes digan: '¡Bendito sea el que viene en Nombre del Señor!'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Un sábado Jesús fue a comer a la casa de uno de los fariseos más importantes, y ellos lo observaban."
,"2":"Por casualidad había delante de él un hombre que sufría de hinchazón."
,"3":"Jesús preguntó a los maestros de la Ley y a los fariseos: '¿Está permitido por la Ley curar en día sábado o no?'"
,"4":"Pero ninguno respondió. Jesús entonces se acercó al enfermo, lo curó y lo despidió."
,"5":"Después les dijo: 'Si a uno de ustedes se le cae su burro o su buey en un pozo en día sábado, ¿acaso no va en seguida a sacarlo?'"
,"6":"Y no pudieron contestarle."
,"7":"Jesús notó que los invitados trataban de ocupar los puestos de honor, por lo que les dio esta lección:"
,"8":"'Cuando alguien te invite a un banquete de bodas, no escojas el mejor lugar. Puede ocurrir que haya sido invitado otro más importante que tú,"
,"9":"y el que los invitó a los dos venga y te diga: Deja tu lugar a esta persona. Y con gran vergüenza tendrás que ir a ocupar el último lugar."
,"10":"Al contrario, cuando te inviten, ponte en el último lugar y así, cuando llegue el que te invitó, te dirá: Amigo, ven más arriba. Esto será un gran honor para ti ante los demás invitados."
,"11":"Porque el que se ensalza será humillado y el que se humilla será ensalzado.'"
,"12":"Jesús dijo también al que lo había invitado: 'Cuando des un almuerzo o una comida, no invites a tus amigos, hermanos, parientes o vecinos ricos, porque ellos a su vez te invitarán a ti y así quedarás compensado."
,"13":"Cuando des un banquete, invita más bien a los pobres, a los inválidos, a los cojos y a los ciegos."
,"14":"¡Qué suerte para ti si ellos no pueden compensarte! Pues tu recompensa la recibirás en la resurrección de los justos.'"
,"15":"Al oír estas palabras, uno de los invitados le dijo: 'Feliz el que tome parte en el banquete del Reino de Dios.'"
,"16":"Jesús respondió: 'Un hombre dio un gran banquete e invitó a mucha gente."
,"17":"A la hora de la comida envió a un sirviente a decir a los invitados: 'Vengan, que ya está todo listo.'"
,"18":"Pero todos por igual comenzaron a disculparse. El primero dijo: 'Acabo de comprar un campo y tengo que ir a verlo; te ruego que me disculpes.'"
,"19":"Otro dijo: 'He comprado cinco yuntas de bueyes y voy a probarlas; te ruego que me disculpes.'"
,"20":"Y otro dijo: 'Acabo de casarme y por lo tanto no puedo ir.'"
,"21":"Al regresar, el sirviente se lo contó a su patrón, que se enojó. Pero dijo al sirviente: 'Sal en seguida a las plazas y calles de la ciudad y trae para acá a los pobres, a los inválidos, a los ciegos y a los cojos.'"
,"22":"Volvió el sirviente y dijo: 'Señor, se hizo lo que mandaste y todavía queda lugar.'"
,"23":"El patrón entonces dijo al sirviente: 'Vete por los caminos y por los límites de las propiedades y obliga a la gente a entrar hasta que se llene mi casa."
,"24":"En cuanto a esos señores que había invitado, yo les aseguro que ninguno de ellos probará mi banquete.'"
,"25":"Caminaba con Jesús un gran gentío. Se volvió hacia ellos y les dijo:"
,"26":"'Si alguno quiere venir a mí y no se desprende de su padre y madre, de su mujer e hijos, de sus hermanos y hermanas, e incluso de su propia persona, no puede ser discípulo mío."
,"27":"El que no carga con su propia cruz para seguirme luego, no puede ser discípulo mío."
,"28":"Cuando uno de ustedes quiere construir una casa en el campo, ¿no comienza por sentarse y hacer las cuentas, para ver si tiene para terminarla?"
,"29":"Porque si pone los cimientos y después no puede acabar la obra, todos los que lo vean se burlarán de él,"
,"30":"diciendo: ¡Ese hombre comenzó a edificar y no fue capaz de terminar!"
,"31":"Y cuando un rey parte a pelear contra otro rey, ¿no se sienta antes para pensarlo bien? ¿Podrá con sus diez mil hombres hacer frente al otro que viene contra él con veinte mil?"
,"32":"Y si no puede, envía mensajeros mientras el otro está aún lejos para llegar a un arreglo."
,"33":"Esto vale para ustedes: el que no renuncia a todo lo que tiene, no podrá ser discípulo mío."
,"34":"La sal es una cosa buena, pero si la sal deja de ser sal, ¿con qué se la salará de nuevo?"
,"35":"Ya no sirve para el campo ni para estiércol; se la tirará fuera. Escuchen, pues, si tienen oídos.'"
}`)
	CurrentBook.AddChapter(15, `{
"1":"Los publicanos y pecadores se acercaban a Jesús para escucharle."
,"2":"Por esto los fariseos y los maestros de la Ley lo criticaban entre sí: 'Este hombre da buena acogida a los pecadores y come con ellos.'"
,"3":"Entonces Jesús les dijo esta parábola:"
,"4":"'Si alguno de ustedes pierde una oveja de las cien que tiene, ¿no deja las otras noventa y nueve en el desierto y se va en busca de la que se le perdió hasta que la encuentra?"
,"5":"Y cuando la encuentra, se la carga muy feliz sobre los hombros,"
,"6":"y al llegar a su casa reúne a los amigos y vecinos y les dice: 'Alégrense conmigo, porque he encontrado la oveja que se me había perdido.'"
,"7":"Yo les digo que de igual modo habrá más alegría en el cielo por un solo pecador que vuelve a Dios que por noventa y nueve justos que no tienen necesidad de convertirse."
,"8":"Y si una mujer pierde una moneda de las diez que tiene, ¿no enciende una lámpara, barre la casa y busca cuidadosamente hasta que la encuentra?"
,"9":"Y apenas la encuentra, reúne a sus amigas y vecinas y les dice: 'Alégrense conmigo, porque hallé la moneda que se me había perdido'."
,"10":"De igual manera, yo se lo digo, hay alegría entre los ángeles de Dios por un solo pecador que se convierte.'"
,"11":"Jesús continuó: 'Había un hombre que tenía dos hijos."
,"12":"El menor dijo a su padre: 'Dame la parte de la hacienda que me corresponde.' Y el padre repartió sus bienes entre los dos."
,"13":"El hijo menor juntó todos sus haberes, y unos días después se fue a un país lejano. Allí malgastó su dinero llevando una vida desordenada."
,"14":"Cuando ya había gastado todo, sobrevino en aquella región una escasez grande y comenzó a pasar necesidad."
,"15":"Fue a buscar trabajo y se puso al servicio de un habitante del lugar, que lo envió a su campo a cuidar cerdos."
,"16":"Hubiera deseado llenarse el estómago con la comida que daban a los cerdos, pero nadie le daba algo."
,"17":"Finalmente recapacitó y se dijo: '¡Cuántos asalariados de mi padre tienen pan de sobra, mientras yo aquí me muero de hambre!"
,"18":"Tengo que hacer algo: volveré donde mi padre y le diré: Padre, he pecado contra Dios y contra ti."
,"19":"Ya no merezco ser llamado hijo tuyo. Trátame como a uno de tus asalariados.'"
,"20":"Se levantó, pues, y se fue donde su padre. Estaba aún lejos, cuando su padre lo vio y sintió compasión; corrió a echarse a su cuello y lo besó. "
,"21":"Entonces el hijo le habló: 'Padre, he pecado contra Dios y ante ti. Ya no merezco ser llamado hijo tuyo.'"
,"22":"Pero el padre dijo a sus servidores: '¡Rápido! Traigan el mejor vestido y pónganselo. Colóquenle un anillo en el dedo y traigan calzado para sus pies."
,"23":"Traigan el ternero gordo y mátenlo; comamos y hagamos fiesta,"
,"24":"porque este hijo mío estaba muerto y ha vuelto a la vida; estaba perdido y lo hemos encontrado.' Y comenzaron la fiesta."
,"25":"El hijo mayor estaba en el campo. Al volver, cuando se acercaba a la casa, oyó la orquesta y el baile."
,"26":"Llamó a uno de los muchachos y le preguntó qué significaba todo aquello."
,"27":"El le respondió: 'Tu hermano ha regresado a casa, y tu padre mandó matar el ternero gordo por haberlo recobrado sano y salvo.'"
,"28":"El hijo mayor se enojó y no quiso entrar. Su padre salió a suplicarle."
,"29":"Pero él le contestó: 'Hace tantos años que te sirvo sin haber desobedecido jamás ni una sola de tus órdenes, y a mí nunca me has dado un cabrito para hacer una fiesta con mis amigos."
,"30":"Pero ahora que vuelve ese hijo tuyo que se ha gastado tu dinero con prostitutas, haces matar para él el ternero gordo.'"
,"31":"El padre le dijo: 'Hijo, tú estás siempre conmigo y todo lo mío es tuyo."
,"32":"Pero había que hacer fiesta y alegrarse, puesto que tu hermano estaba muerto y ha vuelto a la vida, estaba perdido y ha sido encontrado.'"
}`)
	CurrentBook.AddChapter(16, `{
"1":"Jesús dijo también a sus discípulos: 'Había un hombre rico que tenía un administrador, y le vinieron a decir que estaba malgastando sus bienes."
,"2":"Lo mandó llamar y le dijo: '¿Qué oigo decir de ti? Dame cuenta de tu administración, porque ya no continuarás en ese cargo.'"
,"3":"El administrador se dijo: '¿Qué voy a hacer ahora que mi patrón me despide de mi empleo? Para trabajar la tierra no tengo fuerzas, y pedir limosna me da vergüenza."
,"4":"Ya sé lo que voy a hacer para que, cuando me quiten el cargo, tenga gente que me reciba en su casa.'"
,"5":"Llamó uno por uno a los que tenían deudas con su patrón, y dijo al primero:"
,"6":"'¿Cuánto debes a mi patrón?' Le contestó: 'Cien barriles de aceite.' Le dijo el administrador: 'Toma tu recibo, siéntate y escribe en seguida cincuenta.'"
,"7":"Después dijo a otro: 'Y tú, ¿cuánto le debes?' Contestó: 'Cuatrocientos quintales de trigo.' Entonces le dijo: 'Toma tu recibo y escribe trescientos.'"
,"8":"El patrón admiró la manera tan inteligente de actuar de ese administrador que lo estafaba. Pues es cierto que los ciudadanos de este mundo sacan más provecho de sus relaciones sociales que los hijos de la luz."
,"9":"Por eso les digo: Utilicen el sucio dinero para hacerse amigos, para que cuando les llegue a faltar, los reciban a ustedes en las viviendas eternas."
,"10":"El que ha sido digno de confianza en cosas sin importancia, será digno de confianza también en las importantes; y el que no ha sido honrado en las cosas mínimas, tampoco será honrado en las cosas importantes."
,"11":"Por lo tanto, si ustedes no han sido dignos de confianza en manejar el sucio dinero, ¿quién les va a confiar los bienes verdaderos?"
,"12":"Y si no se han mostrado dignos de confianza con cosas ajenas, ¿quién les confiará los bienes que son realmente nuestros?"
,"13":"Ningún siervo puede servir a dos patrones, porque necesariamente odiará a uno y amará al otro o bien será fiel a uno y despreciará al otro. Ustedes no pueden servir al mismo tiempo a Dios y al Dinero."
,"14":"Los fariseos escuchaban todo esto, pero se burlaban de Jesús porque eran personas apegadas al dinero. El les dijo:"
,"15":"'Ustedes aparentan ser gente perfecta, pero Dios conoce los corazones, y lo que los hombres tienen por grande lo aborrece Dios."
,"16":"La época de la Ley y de los Profetas se cerró con Juan. Desde entonces se está proclamando el Reino de Dios, y cada cual se esfuerza por conquistarlo."
,"17":"Más fácil es que pasen el cielo y la tierra que no que deje de cumplirse una sola letra de la Ley."
,"18":"Todo hombre que se divorcia de su mujer y se casa con otra, comete adulterio. Y el que se casa con una mujer divorciada de su marido, también comete adulterio."
,"19":"Había un hombre rico que se vestía con ropa finísima y comía regiamente todos los días."
,"20":"Había también un pobre, llamado Lázaro, todo cubierto de llagas, que estaba tendido a la puerta del rico."
,"21":"Hubiera deseado saciarse con lo que caía de la mesa del rico, y hasta los perros venían a lamerle las llagas."
,"22":"Pues bien, murió el pobre y fue llevado por los ángeles al cielo junto a Abrahán. También murió el rico, y lo sepultaron."
,"23":"Estando en el infierno, en medio de los tormentos, el rico levantó los ojos y vio a lo lejos a Abrahán y a Lázaro con él en su regazo."
,"24":"Entonces gritó: 'Padre Abrahán, ten piedad de mí, y manda a Lázaro que moje en agua la punta de su dedo y me refresque la lengua, porque me atormentan estas llamas.'"
,"25":"Abrahán le respondió: 'Hijo, recuerda que tú recibiste tus bienes durante la vida, mientras que Lázaro recibió males. Ahora él encuentra aquí consuelo y tú, en cambio, tormentos."
,"26":"Además, entre ustedes y nosotros hay un abismo tremendo, de tal manera que los que quieran cruzar desde aquí hasta ustedes no puedan hacerlo, y tampoco lo puedan hacer del lado de ustedes al nuestro.'"
,"27":"El otro replicó: 'Entonces te ruego, padre Abrahán, que envíes a Lázaro a la casa de mi padre,"
,"28":"a mis cinco hermanos: que vaya a darles su testimonio para que no vengan también ellos a parar a este lugar de tormento.'"
,"29":"Abrahán le contestó: 'Tienen a Moisés y a los profetas: que los escuchen.'"
,"30":"El rico insistió: 'No lo harán, padre Abrahán; pero si alguno de entre los muertos fuera donde ellos, se arrepentirían.'"
,"31":"Abrahán le replicó: 'Si no escuchan a Moisés y a los profetas, aunque resucite uno de entre los muertos, no se convencerán.'"
}`)
	CurrentBook.AddChapter(17, `{
"1":"Dijo Jesús a sus discípulos: 'Es imposible que no haya escándalos y caídas, pero ¡pobre del que hace caer a los demás!"
,"2":"Mejor sería que lo arrojaran al mar con una piedra de molino atada al cuello, antes que hacer caer a uno de estos pequeños."
,"3":"Cuídense ustedes mismos. Si tu hermano te ofende, repréndelo; y si se arrepiente, perdónalo. "
,"4":"Si te ofende siete veces al día y otras tantas vuelve arrepentido y te dice: 'Lo siento', perdónalo.'"
,"5":"Los apóstoles dijeron al Señor: 'Auméntanos la fe.'"
,"6":"El Señor respondió: 'Si ustedes tienen un poco de fe, no más grande que un granito de mostaza, dirán a ese árbol: 'Arráncate y plántate en el mar', y el árbol les obedecerá."
,"7":"¿Acaso tienen un servidor que está arando o cuidando el rebaño? Y cuando éste vuelve del campo, ¿le dicen acaso: 'Entra y descansa?'"
,"8":"¿No le dirán más bien: 'Prepárame la comida y ponte el delantal para servirme hasta que yo haya comido y bebido, y después comerás y beberás tú?'"
,"9":"¿Y quién de ustedes se sentirá agradecido con él porque hizo lo que le fue mandado?"
,"10":"Así también ustedes, cuando hayan hecho todo lo que les ha sido mandado, digan: 'Somos servidores que no hacíamos falta, hemos hecho lo que era nuestro deber'.'"
,"11":"De camino a Jerusalén, Jesús pasaba por los confines entre Samaría y Galilea,"
,"12":"y al entrar en un pueblo, le salieron al encuentro diez leprosos. Se detuvieron a cierta distancia"
,"13":"y gritaban: 'Jesús, Maestro, ten compasión de nosotros.'"
,"14":"Jesús les dijo: 'Vayan y preséntense a los sacerdotes.'"
,"15":"Mientras iban quedaron sanos. Uno de ellos, al verse sano, volvió de inmediato alabando a Dios en alta voz,"
,"16":"y se echó a los pies de Jesús con el rostro en tierra, dándole las gracias. Era un samaritano."
,"17":"Jesús entonces preguntó: '¿No han sido sanados los diez? ¿Dónde están los otros nueve?"
,"18":"¿Así que ninguno volvió a glorificar a Dios fuera de este extranjero?'"
,"19":"Y Jesús le dijo: 'Levántate y vete; tu fe te ha salvado.'"
,"20":"Los fariseos preguntaron a Jesús: '¿Cuándo llegará el Reino de Dios?' Les contestó: 'La venida del Reino de Dios no es cosa que se pueda verificar."
,"21":"No van a decir: 'Está aquí, o está allá'. Y sepan que el Reino de Dios está en medio de ustedes.'"
,"22":"Jesús dijo además a sus discípulos: 'Llegará un tiempo en que ustedes desearán ver alguna de las manifestaciones del Hijo del Hombre, pero no la verán."
,"23":"Entonces les dirán: 'Está aquí, está allá.' No vayan, no corran."
,"24":"En efecto, como el fulgor del relámpago rasga el cielo desde un extremo hasta el otro, así sucederá con el Hijo del Hombre cuando llegue su día."
,"25":"Pero antes tiene que sufrir mucho y ser rechazado por esa gente."
,"26":"En los días del Hijo del Hombre sucederá lo mismo que en tiempos de Noé:"
,"27":"la gente comía, bebía, y se casaban hombres y mujeres, hasta el día en que Noé entró en el arca y vino el diluvio, que los hizo perecer a todos."
,"28":"Ocurrirá lo mismo que en tiempos de Lot: la gente comía y bebía, compraba y vendía, plantaba y edificaba."
,"29":"Pero el día que salió Lot de Sodoma cayó del cielo una lluvia de fuego y azufre que los mató a todos."
,"30":"Lo mismo sucederá el día en que se manifieste el Hijo del Hombre."
,"31":"Aquel día, el que esté en la terraza, que no baje a buscar sus cosas al interior de la casa; y el que esté en el campo, que no se vuelva atrás."
,"32":"Acuérdense de la mujer de Lot."
,"33":"El que intente guardar su vida la perderá, pero el que la entregue, la hará nacer a nueva vida."
,"34":"Yo les declaro que aquella noche, de dos personas que estén durmiendo en una misma cama, una será llevada y la otra dejada;"
,"35":"dos mujeres estarán moliendo juntas, pero una será llevada y la otra dejada.'"
,"36":"Entonces preguntaron a Jesús: '¿Dónde sucederá eso, Señor?'"
,"37":"Y él respondió: 'Donde esté el cuerpo, allí se juntarán los buitres.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Jesús les mostró con un ejemplo que debían orar siempre, sin desanimarse jamás:"
,"2":"'En una ciudad había un juez que no temía a Dios ni le importaba la gente."
,"3":"En la misma ciudad había también una viuda que acudía a él para decirle: 'Hazme justicia contra mi adversario'."
,"4":"Durante bastante tiempo el juez no le hizo caso, pero al final pensó: 'Es cierto que no temo a Dios y no me importa la gente,"
,"5":"pero esta viuda ya me molesta tanto que le voy a hacer justicia; de lo contrario acabará rompiéndome la cabeza'.'"
,"6":"Y el Señor dijo: '¿Se han fijado en las palabras de este juez malo?"
,"7":"¿Acaso Dios no hará justicia a sus elegidos si claman a él día y noche, mientras él deja que esperen?"
,"8":"Yo les aseguro que les hará justicia, y lo hará pronto. Pero cuando venga el Hijo del Hombre, ¿encontrará fe sobre la tierra?'."
,"9":"Jesús dijo esta parábola por algunos que estaban convencidos de ser justos y despreciaban a los demás."
,"10":"'Dos hombres subieron al Templo a orar. Uno era fariseo y el otro publicano."
,"11":"El fariseo, puesto de pie, oraba en su interior de esta manera: 'Oh Dios, te doy gracias porque no soy como los demás hombres, que son ladrones, injustos, adúlteros, o como ese publicano..."
,"12":"Ayuno dos veces por semana y doy la décima parte de todas mis entradas.'"
,"13":"Mientras tanto el publicano se quedaba atrás y no se atrevía a levantar los ojos al cielo, sino que se golpeaba el pecho diciendo: 'Dios mío, ten piedad de mí, que soy un pecador'."
,"14":"Yo les digo que este último estaba en gracia de Dios cuando volvió a su casa, pero el fariseo no. Porque el que se hace grande será humillado y el que se humilla será enaltecido.'"
,"15":"Le traían también niños pequeñitos para que los tocara, pero los discípulos empezaron a reprender a esas personas."
,"16":"Jesús pidió que se los trajeran, diciendo: 'Dejen que los niños vengan a mí y no se lo impidan, porque el Reino de Dios pertenece a los que son como ellos."
,"17":"En verdad les digo que el que no reciba el Reino de Dios como un niño no entrará en él.'"
,"18":"Cierto hombre importante le preguntó: 'Maestro bueno, ¿qué tengo que hacer para heredar la vida eterna?'"
,"19":"Jesús le dijo: '¿Por qué me llamas bueno? Sólo Dios es bueno, nadie más."
,"20":"Ya sabes los mandamientos: No cometas adulterio, no mates, no robes, no levantes falsos testimonios, honra a tu padre y a tu madre.'"
,"21":"Pero él contestó: 'Todo esto lo he cumplido ya desde joven.'"
,"22":"Al oír esto, Jesús le dijo: 'Todavía te falta una cosa: vende todo lo que tienes, reparte el dinero entre los pobres, y tendrás un tesoro en el cielo; después ven y sígueme.'"
,"23":"Ante tal respuesta, el hombre se puso triste, pues era muy rico."
,"24":"Al verlo, dijo Jesús: '¡Qué difícil es entrar en el Reino de Dios para los que tienen riquezas!"
,"25":"Es más fácil para un camello pasar por el ojo de una aguja que para un rico entrar en el Reino de Dios.'"
,"26":"Los presentes dijeron: '¿Quién podrá salvarse entonces?'"
,"27":"Jesús respondió: 'Lo que es imposible para los hombres es posible para Dios.'"
,"28":"En ese momento Pedro dijo: 'Ya ves que nosotros hemos dejado todo lo que teníamos y te hemos seguido.'"
,"29":"Jesús respondió: 'Yo les aseguro que ninguno dejará casa, esposa, hermanos, padre o hijos a causa del Reino de Dios"
,"30":"sin que reciba mucho más en el tiempo presente y, en el mundo venidero, la vida eterna.'"
,"31":"Jesús tomó aparte a los Doce y les dijo: 'Estamos subiendo a Jerusalén y allí se va a cumplir todo lo que escribieron los profetas sobre el Hijo del Hombre:"
,"32":"será entregado al poder extranjero; será burlado, maltratado y escupido;"
,"33":"y después de azotarlo, lo matarán. Pero al tercer día resucitará.'"
,"34":"Los Doce no entendieron nada de aquello. Este era un lenguaje misterioso para ellos y no comprendían lo que decía."
,"35":"Ya cerca de Jericó, había un ciego sentado al borde del camino pidiendo limosna."
,"36":"Al oír que pasaba mucha gente, preguntó qué era aquello,"
,"37":"y le dieron la noticia: '¡Es Jesús, el nazoreo, que pasa por aquí!'"
,"38":"Entonces empezó a gritar: '¡Jesús, hijo de David, ten compasión de mí!'"
,"39":"Los que iban delante le levantaron la voz para que se callara, pero él gritaba con más fuerza: '¡Jesús, hijo de David, ten compasión de mí!'"
,"40":"Jesús se detuvo y ordenó que se lo trajeran, y cuando tuvo al ciego cerca le preguntó:"
,"41":"'¿Qué quieres que haga por ti?' Le respondió: 'Señor, haz que vea.'"
,"42":"Jesús le dijo: 'Recobra la vista, tu fe te ha salvado.'"
,"43":"Al instante el ciego pudo ver. El hombre seguía a Jesús glorificando a Dios, y toda la gente que lo presenció también bendecía a Dios."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Habiendo entrado Jesús en Jericó, atravesaba la ciudad."
,"2":"Había allí un hombre llamado Zaqueo, que era jefe de los cobradores del impuesto y muy rico."
,"3":"Quería ver cómo era Jesús, pero no lo conseguía en medio de tanta gente, pues era de baja estatura."
,"4":"Entonces se adelantó corriendo y se subió a un árbol para verlo cuando pasara por allí."
,"5":"Cuando llegó Jesús al lugar, miró hacia arriba y le dijo: 'Zaqueo, baja en seguida, pues hoy tengo que quedarme en tu casa.'"
,"6":"Zaqueo bajó rápidamente y lo recibió con alegría."
,"7":"Entonces todos empezaron a criticar y a decir: 'Se ha ido a casa de un rico que es un pecador.'"
,"8":"Pero Zaqueo dijo resueltamente a Jesús: 'Señor, voy a dar la mitad de mis bienes a los pobres, y a quien le haya exigido algo injustamente le devolveré cuatro veces más.'"
,"9":"Jesús, pues, dijo con respecto a él: 'Hoy ha llegado la salvación a esta casa, pues también este hombre es un hijo de Abrahán."
,"10":"El Hijo del Hombre ha venido a buscar y a salvar lo que estaba perdido.'"
,"11":"Cuando Jesús estaba ya cerca de Jerusalén, dijo esta parábola, pues los que lo escuchaban creían que el Reino de Dios se iba a manifestar de un momento a otro."
,"12":"'Un hombre de una familia noble se fue a un país lejano para ser nombrado rey y volver después."
,"13":"Llamó a diez de sus servidores, les entregó una moneda de oro a cada uno y les dijo: 'Comercien con ese dinero hasta que vuelva.'"
,"14":"Pero sus compatriotas lo odiaban y mandaron detrás de él una delegación para que dijera: 'No queremos que éste sea nuestro rey.'"
,"15":"Cuando volvió, había sido nombrado rey. Mandó, pues, llamar a aquellos servidores a quienes les había entregado el dinero, para ver cuánto había ganado cada uno."
,"16":"Se presentó el primero y dijo: 'Señor, tu moneda ha producido diez más.'"
,"17":"Le contestó: 'Está bien, servidor bueno; ya que fuiste fiel en cosas muy pequeñas, ahora te confío el gobierno de diez ciudades.'"
,"18":"Vino el segundo y le dijo: 'Señor, tu moneda ha producido otras cinco más.'"
,"19":"El rey le contestó: 'Tú también gobernarás cinco ciudades.'"
,"20":"Llegó el tercero y dijo: 'Señor, aquí tienes tu moneda. La he guardado envuelta en un pañuelo"
,"21":"porque tuve miedo de ti. Yo sabía que eres un hombre muy exigente: reclamas lo que no has depositado y cosechas lo que no has sembrado.'"
,"22":"Le contestó el rey: 'Por tus propias palabras te juzgo, servidor inútil. Si tú sabías que soy un hombre exigente, que reclamo lo que no he depositado y cosecho lo que no he sembrado,"
,"23":"¿por qué no pusiste mi dinero en el banco? Así a mi regreso lo habría cobrado con los intereses.'"
,"24":"Y dijo el rey a los presentes: 'Quítenle la moneda y dénsela al que tiene diez.'"
,"25":"'Pero, señor, le contestaron, ya tiene diez monedas.'"
,"26":"Yo les digo que a todo el que produce se le dará más, pero al que no tiene, se le quitará aun lo que tiene."
,"27":"En cuanto a esos enemigos míos que no me quisieron por rey, tráiganlos aquí y mátenlos en mi presencia.'"
,"28":"Dicho esto, Jesús pasó adelante y emprendió la subida hacia Jerusalén."
,"29":"Cuando se acercaban a Betfagé y Betania, al pie del monte llamado de los Olivos, Jesús envió a dos de sus discípulos y les dijo:"
,"30":"'Vayan al pueblo de enfrente y al entrar en él encontrarán atado un burrito que no ha sido montado por nadie hasta ahora. Desátenlo y tráiganmelo."
,"31":"Si alguien les pregunta por qué lo desatan, contéstenle que el Señor lo necesita.'"
,"32":"Fueron los dos discípulos y hallaron todo tal como Jesús les había dicho."
,"33":"Mientras soltaban el burrito llegaron los dueños y les preguntaron: '¿Por qué desatan ese burrito?'"
,"34":"Contestaron: 'El Señor lo necesita.'"
,"35":"Trajeron entonces el burrito y le echaron sus capas encima para que Jesús se montara."
,"36":"La gente extendía sus mantos sobre el camino a medida que iba avanzando."
,"37":"Al acercarse a la bajada del monte de los Olivos, la multitud de los discípulos comenzó a alabar a Dios a gritos, con gran alegría, por todos los milagros que habían visto."
,"38":"Decían: '¡Bendito el que viene como Rey en nombre del Señor! ¡Paz en el cielo y gloria en lo más alto de los cielos!'"
,"39":"Algunos fariseos que se encontraban entre la gente dijeron a Jesús: 'Maestro, reprende a tus discípulos.'"
,"40":"Pero él contestó: 'Yo les aseguro que si ellos se callan, gritarán las piedras.'"
,"41":"Al acercarse y ver la ciudad, lloró por ella,"
,"42":"y dijo: '¡Si al menos en este día tú conocieras los caminos de la paz! Pero son cosas que tus ojos no pueden ver todavía."
,"43":"Vendrán días sobre ti en que tus enemigos te cercarán de trincheras, te atacarán y te oprimirán por todos los lados."
,"44":"Te estrellarán contra el suelo a ti y a tus hijos dentro de ti, y no dejarán en ti piedra sobre piedra, porque no has reconocido el tiempo ni la visita de tu Dios.'"
,"45":"Jesús entró después en el recinto del Templo y comenzó a expulsar a los comerciantes que estaban allí actuando."
,"46":"Les declaró: 'Dios dice en la Escritura: Mi casa será casa de oración. Pero ustedes la han convertido en un refugio de ladrones.'"
,"47":"Jesús enseñaba todos los días en el Templo. Los jefes de los sacerdotes y los maestros de la Ley buscaban el modo de acabar con él, al igual que las autoridades de los judíos,"
,"48":"pero no sabían qué hacer, pues todo el pueblo lo escuchaba y estaba pendiente de sus palabras."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Uno de esos días en que Jesús enseñaba en el Templo anunciando la Buena Nueva al pueblo, se acercaron los jefes de los sacerdotes y los maestros de la Ley con algunos jefes de los judíos, y le dijeron:"
,"2":"'Dinos con qué derecho haces estas cosas. ¿Quién te ha dado autoridad para hacer lo que haces?'"
,"3":"Jesús les contestó: 'Yo también les voy a hacer a ustedes una pregunta. Háblenme"
,"4":"del bautismo de Juan. Este asunto ¿venía de Dios o era cosa de los hombres?'"
,"5":"Ellos razonaron entre sí: 'Si contestamos que este asunto venía de Dios, él nos dirá: ¿Por qué entonces no le creyeron?"
,"6":"Y si respondemos que era cosa de hombres, todo el pueblo nos apedreará, pues está convencido de que Juan era un profeta.'"
,"7":"Por eso le contestaron: 'No lo sabemos'."
,"8":"Jesús les dijo entonces: 'Tampoco yo les diré a ustedes con qué autoridad hago estas cosas.'"
,"9":"Jesús se puso a contar a la gente esta parábola: 'Un hombre plantó una viña, la arrendó a unos trabajadores y después se fue al extranjero por mucho tiempo."
,"10":"En el momento oportuno envió a un servidor a los inquilinos para que le entregaran su parte del fruto de la viña. Pero los inquilinos lo golpearon y lo hicieron volver con las manos vacías."
,"11":"Volvió a mandar a otro servidor, que también lo golpearon, lo insultaron y lo echaron con las manos vacías."
,"12":"Todavía mandó a un tercero, pero también a éste lo hirieron y lo echaron."
,"13":"El dueño de la viña se dijo entonces: ¿Qué hacer? Enviaré a mi hijo querido, pues a él lo respetarán."
,"14":"Pero los trabajadores, apenas lo vieron, se dijeron unos a otros: 'Este es el heredero, matémoslo y nos quedaremos con la propiedad'."
,"15":"Lo arrojaron, pues, fuera de la viña y lo mataron. Ahora bien, ¿qué hará con ellos el dueño de la viña?"
,"16":"Vendrá, hará morir a esos trabajadores y entregará la viña a otros.',Al oír esto, algunos dijeron: '¡No lo quiera Dios!' "
,"17":"Jesús, fijando su mirada en ellos, les dijo: '¿Qué significan entonces esas palabras de la Escritura: La piedra que rechazaron los constructores ha venido a ser la piedra principal."
,"18":"El que caiga sobre esa piedra se hará pedazos, y al que le caiga encima quedará aplastado?'"
,"19":"Los maestros de la Ley y los jefes de los sacerdotes hubieran querido detenerlo en ese momento, pues habían entendido muy bien que esta parábola de Jesús aludía a ellos, pero tuvieron miedo de la multitud."
,"20":"Entonces empezaron a seguir a Jesús de cerca; le enviaron unos espías que fingieron buena fe para aprovecharse de sus palabras y poder así entregarlo al gobernador y su justicia."
,"21":"Le preguntaron: 'Maestro, sabemos que hablas y enseñas con rectitud, que no te dejas influenciar por nadie, sino que enseñas con absoluta franqueza el camino de Dios."
,"22":"¿Está permitido pagar impuestos al César o no?'"
,"23":"Jesús vio su astucia y les dijo: 'Muéstrenme una moneda."
,"24":"¿De quién es esa cara y el nombre que tiene escrito?' Le contestaron: 'Del César.'"
,"25":"Entonces les dijo: 'Pues bien, devuelvan al César las cosas del César, y a Dios lo que corresponde a Dios.'"
,"26":"Con esto no pudieron atraparlo en lo que decía en público, sino que quedaron muy sorprendidos por su respuesta y se callaron."
,"27":"Se acercaron a Jesús algunos saduceos. Esta gente niega que haya resurrección, y por eso le plantearon esta cuestión:"
,"28":"'Maestro, Moisés nos dejó escrito: Si un hombre tiene esposa y muere sin dejar hijos, el hermano del difunto debe tomar a la viuda para darle un hijo, que tomará la sucesión del difunto."
,"29":"Había, pues, siete hermanos. Se casó el primero y murió sin tener hijos."
,"30":"El segundo y el tercero se casaron después con la viuda."
,"31":"Y así los siete, pues todos murieron sin dejar hijos."
,"32":"Finalmente murió también la mujer."
,"33":"Si hay resurrección, ¿de cuál de ellos será esposa esta mujer, puesto que los siete la tuvieron?'"
,"34":"Jesús les respondió: 'Los de este mundo se casan, hombres y mujeres,"
,"35":"pero los que sean juzgados dignos de entrar en el otro mundo y de resucitar de entre los muertos, ya no toman marido ni esposa."
,"36":"Además ya no pueden morir, sino que son como ángeles. Son también hijos de Dios, por haber nacido de la resurrección."
,"37":"En cuanto a saber si los muertos resucitan, el mismo Moisés lo dio a entender en el pasaje de la zarza, cuando llama al Señor: Dios de Abrahán, Dios de Isaac y Dios de Jacob."
,"38":"El no es Dios de muertos, sino de vivos, y todos viven por él.'"
,"39":"Intervinieron algunos maestros de la Ley, y le dijeron: 'Maestro, has hablado bien.'"
,"40":"Pero en adelante no se atrevieron a hacerle más preguntas."
,"41":"Entonces él les dijo: '¿Cómo dice la gente que el Mesías es el hijo de David?"
,"42":"Porque David mismo dice en el libro de los Salmos: Dijo el Señor a mi Señor: Siéntate a mi derecha"
,"43":"hasta que ponga a tus enemigos bajo tus pies."
,"44":"Si David lo llama Señor, ¿cómo puede ser hijo suyo?'"
,"45":"Jesús dijo también a sus discípulos ante toda la gente que escuchaba:"
,"46":"'Cuídense de esos maestros de la Ley a los que les gusta llevar largas vestiduras, y ser saludados en las plazas, y ocupar los puestos reservados en las sinagogas y los lugares de honor en los banquetes."
,"47":"Se introducen con sus largas oraciones, y luego devoran los bienes de las viudas. Esos tendrán una sentencia muy rigurosa.'"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Jesús levantó la mirada y vio a unos ricos que depositaban sus ofrendas en el arca del tesoro del Templo."
,"2":"Vio también a una viuda muy pobre que echaba dos moneditas."
,"3":"Entonces dijo: 'En verdad les digo que esa viuda sin recursos ha echado más que todos ellos,"
,"4":"porque todos ésos han dado de lo que les sobra, mientras que ella, no teniendo recursos, ha echado todo lo que tenía para vivir.'"
,"5":"Como algunos estaban hablando del Templo, con sus hermosas piedras y los adornos que le habían sido regalados,"
,"6":"Jesús les dijo: 'Mírenlo bien, porque llegarán días en que todo eso será arrasado y no quedará piedra sobre piedra.'"
,"7":"Le preguntaron: 'Maestro, ¿cuándo sucederá eso, y qué señales habrá antes de que ocurran esas cosas?'"
,"8":"Jesús contestó: 'Estén sobre aviso y no se dejen engañar; porque muchos usurparán mi nombre y dirán: 'Yo soy el Mesías, el tiempo está cerca'. No los sigan."
,"9":"No se asusten si oyen hablar de guerras y disturbios, porque estas cosas tienen que ocurrir primero, pero el fin no llegará tan de inmediato.'"
,"10":"Entonces Jesús les dijo: 'Se levantará una nación contra otra y un reino contra otro."
,"11":"Habrá grandes terremotos, pestes y hambre en diversos lugares. Se verán también cosas espantosas y señales terribles en el cielo."
,"12":"Pero antes de que eso ocurra los tomarán a ustedes presos, los perseguirán, los entregarán a los tribunales judíos y los meterán en sus cárceles. Los harán comparecer ante reyes y gobernadores por causa de mi nombre,"
,"13":"y ésa será para ustedes la oportunidad de dar testimonio de mí."
,"14":"Tengan bien presente que no deberán preocuparse entonces por su defensa."
,"15":"Pues yo mismo les daré palabras y sabiduría, y ninguno de sus opositores podrá resistir ni contradecirles."
,"16":"Ustedes serán entregados por sus padres, hermanos, parientes y amigos,"
,"17":"y algunos de ustedes serán ajusticiados."
,"18":"Serán odiados por todos a causa de mi nombre. Con todo, ni un cabello de su cabeza se perderá."
,"19":"Manténganse firmes y se salvarán."
,"20":"Cuando vean a Jerusalén rodeada por ejércitos, sepan que muy pronto será devastada."
,"21":"Los que estén en Judea, que huyan a los montes; los que estén dentro de la ciudad, que salgan y se alejen; y los que estén en los campos, que no vuelvan a la ciudad."
,"22":"Porque esos serán los días en que se rendirán cuentas, y se cumplirán todas las cosas que fueron anunciadas en la Escritura."
,"23":"¡Pobres de las mujeres embarazadas o que estén criando en esos días! Porque una gran calamidad sobrevendrá al país y estallará sobre este pueblo la cólera de Dios."
,"24":"Morirán al filo de la espada, serán llevados prisioneros a todas las naciones y Jerusalén será pisoteada por las naciones hasta que se cumplan los tiempos de las naciones."
,"25":"Entonces habrá señales en el sol, la luna y las estrellas, y por toda la tierra los pueblos estarán llenos de angustia, aterrados por el estruendo del mar embravecido."
,"26":"La gente se morirá de espanto con sólo pensar en lo que va a caer sobre la humanidad, porque las fuerzas del universo serán sacudidas."
,"27":"Y en ese preciso momento verán al Hijo del Hombre venir en la Nube, con gran poder e infinita gloria.'"
,"28":"'Cuando se presenten los primeros signos, enderécense y levanten la cabeza, porque está cerca su liberación.'"
,"29":"Y Jesús propuso esta comparación: 'Fíjense en la higuera y en los demás árboles."
,"30":"Cuando echan los primeros brotes, ustedes saben que el verano ya está cerca."
,"31":"Así también, apenas vean ustedes que suceden las cosas que les dije, sepan que el Reino de Dios está cerca."
,"32":"Yo les aseguro que no pasará esta generación hasta que todo eso suceda."
,"33":"El cielo y la tierra pasarán, pero mis palabras no pasarán."
,"34":"Cuíden de ustedes mismos, no sea que una vida materializada, las borracheras o las preocupaciones de este mundo los vuelvan interiormente torpes y ese día caiga sobre ustedes de improviso,"
,"35":"pues se cerrará como una trampa sobre todos los habitantes de la tierra."
,"36":"Por eso estén vigilando y orando en todo momento, para que se les conceda escapar de todo lo que debe suceder y estar de pie ante el Hijo del Hombre.'"
,"37":"Durante el día Jesús enseñaba en el Templo, y luego salía e iba a pasar la noche al aire libre al monte de los Olivos."
,"38":"Y desde muy temprano todo el pueblo acudía donde él al Templo para escucharlo."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Se acercaba la fiesta de los Panes sin Levadura, llamada también fiesta de la Pascua."
,"2":"Los jefes de los sacerdotes y los maestros de la Ley no encontraban la manera de hacer desaparecer a Jesús, pues tenían miedo del pueblo."
,"3":"Pero Satanás entró en Judas, por sobrenombre Iscariote, que era uno de los Doce,"
,"4":"y fue a tratar con los jefes de los sacerdotes y con los jefes de la policía del Templo sobre el modo de entregarles a Jesús."
,"5":"Ellos se alegraron y acordaron darle una cantidad de dinero."
,"6":"Judas aceptó el trato y desde entonces buscaba una oportunidad para entregarlo cuando no estuviera el pueblo."
,"7":"Llegó el día de la fiesta de los Panes sin Levadura, en que se debía sacrificar el cordero de Pascua."
,"8":"Entonces Jesús envió a Pedro y a Juan diciéndoles: 'Vayan a preparar lo necesario para que celebremos la Cena de Pascua.'"
,"9":"Le preguntaron: '¿Dónde quieres que la preparemos?'"
,"10":"Jesús les contestó: 'Cuando entren en la ciudad, encontrarán a un hombre que lleva un jarro de agua."
,"11":"Síganlo hasta la casa donde entre, y digan al dueño de la casa: 'El Maestro manda a decirte: ¿Dónde está la pieza en la que comeré la Pascua con mis discípulos?'"
,"12":"El les mostrará una sala grande y amueblada en el piso superior. Preparen allí lo necesario.'"
,"13":"Se fueron, pues, hallaron todo tal como Jesús les había dicho y prepararon la Pascua."
,"14":"Llegada la hora, Jesús se sentó a la mesa con los apóstoles"
,"15":"y les dijo: 'Yo tenía gran deseo de comer esta Pascua con ustedes antes de padecer."
,"16":"Porque, se lo digo, ya no la volveré a comer hasta que sea la nueva y perfecta Pascua en el Reino de Dios.'"
,"17":"Jesús recibió una copa, dio gracias y les dijo: 'Tomen esto y repártanlo entre ustedes,"
,"18":"porque les aseguro que ya no volveré a beber del jugo de la uva hasta que llegue el Reino de Dios.'"
,"19":"Después tomó pan y, dando gracias, lo partió y se lo dio diciendo: 'Esto es mi cuerpo, que es entregado por ustedes. (Hagan esto en memoria mía.'"
,"20":"Hizo lo mismo con la copa después de cenar, diciendo: 'Esta copa es la alianza nueva sellada con mi sangre, que es derramada por ustedes')."
,"21":"Sepan que la mano del que me traiciona está aquí conmigo sobre la mesa."
,"22":"El Hijo del Hombre se va por el camino trazado desde antes. Pero ¡pobre del hombre que lo entrega!'"
,"23":"Entonces empezaron a preguntarse unos a otros quién de ellos iba a hacer tal cosa."
,"24":"Luego comenzaron a discutir sobre quién de ellos era el más importante."
,"25":"Jesús les dijo: 'Los reyes de las naciones las gobiernan como dueños, y los mismos que las oprimen se hacen llamar bienhechores."
,"26":"Pero no será así entre ustedes. Al contrario, el más importante entre ustedes debe portarse como si fuera el último, y el que manda, como si fuera el que sirve."
,"27":"Porque ¿quién es más importante: el que está a la mesa o el que está sirviendo? El que está sentado, por supuesto. Y sin embargo yo estoy entre ustedes como el que sirve."
,"28":"Ustedes son los que han permanecido conmigo compartiendo mis pruebas."
,"29":"Por eso les doy autoridad como mi Padre me la dio a mí haciéndome rey."
,"30":"Ustedes comerán y beberán a mi mesa en mi Reino, y se sentarán en tronos para gobernar a las doce tribus de Israel."
,"31":"¡Simón, Simón! Mira que Satanás ha pedido permiso para sacudirlos a ustedes como trigo que se limpia;"
,"32":"pero yo he rogado por ti para que tu fe no se venga abajo. Y tú, cuando hayas vuelto, tendrás que fortalecer a tus hermanos.'"
,"33":"Pedro dijo: 'Señor, estoy dispuesto a ir contigo a la prisión y a la muerte.'"
,"34":"Pero Jesús le respondió: 'Yo te digo, Pedro, que antes de que cante hoy el gallo, habrás negado tres veces que me conoces.'"
,"35":"Jesús también les dijo: 'Cuando les envié sin cartera ni equipaje ni calzado, ¿les faltó algo?' Ellos contestaron: 'Nada.'"
,"36":"Y Jesús agregó: 'Pues ahora, el que tenga cartera, que la tome, y lo mismo el equipaje. Y el que no tenga espada, que venda el manto para comprarse una."
,"37":"Pues les aseguro que tiene que cumplirse en mi persona lo que dice la Escritura: Ha sido contado entre los delincuentes. Ahora bien, todo lo que se refiere a mí está llegando a su fin.'"
,"38":"Ellos le dijeron: 'Mira, Señor, aquí hay dos espadas.' El les respondió: '¡Basta ya!'"
,"39":"Después Jesús salió y se fue, como era su costumbre, al monte de los Olivos, y lo siguieron también sus discípulos."
,"40":"Llegados al lugar, les dijo: 'Oren para que no caigan en tentación.'"
,"41":"Después se alejó de ellos como a la distancia de un tiro de piedra, y doblando las rodillas oraba"
,"42":"con estas palabras: 'Padre, si quieres, aparta de mí esta copa; pero no se haga mi voluntad, sino la tuya.'"
,"43":"(Entonces se le apareció un ángel del cielo para animarlo."
,"44":"Entró en agonía y oraba con mayor insistencia. Su sudor se convirtió en gotas de sangre que caían hasta el suelo.)"
,"45":"Después de orar, se levantó y fue hacia donde estaban los discípulos. Pero los halló dormidos, abatidos por la tristeza."
,"46":"Les dijo: '¿Ustedes duermen? Levántense y oren para que no caigan en tentación.'"
,"47":"Todavía estaba hablando cuando llegó un grupo encabezado por Judas, uno de los Doce. Como se acercara a Jesús para darle un beso,"
,"48":"Jesús le dijo: 'Judas, ¿con un beso traicionas al Hijo del Hombre?'"
,"49":"Los que estaban con Jesús vieron lo que iba a pasar y le preguntaron: 'Maestro, ¿sacamos la espada?'"
,"50":"Y uno de ellos hirió al servidor del sumo sacerdote cortándole la oreja derecha."
,"51":"Pero Jesús le dijo: '¡Basta ya!' Y tocando la oreja del hombre, lo sanó."
,"52":"Jesús se dirigió después a los que habían venido a prenderlo, a los jefes de los sacerdotes, de la policía del Templo y de los judíos y les dijo: 'Tal vez buscan a un ladrón, y por eso han venido a detenerme con espadas y palos."
,"53":"¿Por qué no me detuvieron cuando día tras día estaba entre ustedes en el Templo? Pero ahora reinan las tinieblas, y es la hora de ustedes.'"
,"54":"Entonces lo apresaron y lo llevaron a la casa del sumo sacerdote, donde entraron; Pedro los seguía a distancia."
,"55":"Prendieron un fuego en medio del patio y luego se sentaron alrededor; Pedro también se acercó y se sentó entre ellos."
,"56":"Al verlo sentado a la lumbre, una muchachita de la casa, después de mirarlo, dijo: 'Este también estaba con él'"
,"57":"Pero él lo negó diciendo: 'Mujer, yo no lo conozco.'"
,"58":"Momentos después otro exclamó al verlo: 'Tú también eres uno de ellos.' Pero Pedro respondió: 'No, hombre, no lo soy.'"
,"59":"Como una hora más tarde, otro afirmaba: 'Seguramente éste estaba con él, pues además es galileo.'"
,"60":"De nuevo Pedro lo negó diciendo: 'Amigo, no sé de qué hablas.',Todavía estaba hablando cuando un gallo cantó. "
,"61":"El Señor se volvió y fijó la mirada en Pedro. Y Pedro se acordó de la palabra del Señor, que le había dicho: 'Antes de que cante hoy el gallo, me habrás negado tres veces.'"
,"62":"Y, saliendo afuera, lloró amargamente."
,"63":"Los hombres que custodiaban a Jesús empezaron a burlarse de él y a darle golpes."
,"64":"Le cubrieron la cara, y después le preguntaban: 'Adivina quién te pegó.'"
,"65":"Y proferían toda clase de insultos contra él."
,"66":"Cuando amaneció, se reunieron los jefes de los judíos, los jefes de los sacerdotes y los maestros de la Ley, y mandaron traer a Jesús ante su Consejo."
,"67":"Le interrogaron: '¿Eres tú el Cristo? Respóndenos'. Jesús respondió: 'Si se lo digo, ustedes no me creerán, "
,"68":"y si les hago alguna pregunta, ustedes no me contestarán."
,"69":"Desde ahora, sin embargo, el Hijo del Hombre estará sentado a la derecha del Dios Poderoso.'"
,"70":"Todos dijeron: 'Entonces, ¿tú eres el Hijo de Dios?' Jesús contestó: 'Dicen bien, yo lo soy.'"
,"71":"Ellos dijeron: '¿Para qué buscar otro testimonio? Nosotros mismos lo hemos oído de su boca.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"El Consejo en pleno se levantó y llevaron a Jesús ante Pilato."
,"2":"Allí empezaron con sus acusaciones: 'Hemos comprobado que este hombre es un agitador. Se opone a que se paguen los impuestos al César y pretende ser el rey enviado por Dios.'"
,"3":"Entonces Pilato lo interrogó en estos términos: '¿Eres tú el rey de los judíos?' Jesús le contestó: 'Tú eres el que lo dice.'"
,"4":"Pilato se dirigió a los jefes de los sacerdotes y a la multitud. Les dijo: 'Yo no encuentro delito alguno en este hombre.'"
,"5":"Pero ellos insistieron: 'Está enseñando por todo el país de los judíos y sublevando al pueblo. Comenzó en Galilea y ha llegado hasta aquí.'"
,"6":"Al oír esto, Pilato preguntó si aquel hombre era galileo."
,"7":"Cuando supo que Jesús pertenecía a la jurisdicción de Herodes, se lo envió, pues Herodes se hallaba también en Jerusalén por aquellos días."
,"8":"Al ver a Jesús, Herodes se alegró mucho. Hacía tiempo que deseaba verlo por las cosas que oía de él, y esperaba que Jesús hiciera algún milagro en su presencia."
,"9":"Le hizo, pues, un montón de preguntas. Pero Jesús no contestó nada,"
,"10":"mientras los jefes de los sacerdotes y los maestros de la Ley permanecían frente a él y reiteraban sus acusaciones."
,"11":"Herodes con su guardia lo trató con desprecio; para burlarse de él lo cubrió con un manto espléndido y lo devolvió a Pilato."
,"12":"Y ese mismo día Herodes y Pilato, que eran enemigos, se hicieron amigos."
,"13":"Pilato convocó a los jefes de los sacerdotes, a los jefes de los judíos y al pueblo"
,"14":"y les dijo: 'Ustedes han traído ante mí a este hombre acusándolo de sublevar al pueblo. Pero después de interrogarlo en presencia de ustedes no he podido comprobar ninguno de los cargos que le hacen."
,"15":"Y tampoco Herodes, pues me lo devolvió. Es evidente que este hombre no ha hecho nada que merezca la muerte."
,"16":"Así que después de castigarlo lo dejaré en libertad.'"
,"18":"Pero todos ellos se pusieron a gritar: '¡Elimina a éste y devuélvenos a Barrabás!"
,"19":"Este Barrabás había sido encarcelado por algunos disturbios y un asesinato en la ciudad."
,"20":"Pilato, que quería librar a Jesús, les dirigió de nuevo la palabra,"
,"21":"pero ellos seguían gritando: '¡Crucifícalo, crucifícalo!'"
,"22":"Por tercera vez les dijo: 'Pero ¿qué mal ha hecho este hombre? Yo no he encontrado nada que merezca la muerte; por eso, después de azotarlo, lo dejaré en libertad.'"
,"23":"Pero ellos insistían a grandes voces pidiendo que fuera crucificado, y el griterío iba en aumento."
,"24":"Entonces Pilato pronunció la sentencia que ellos reclamaban."
,"25":"Soltó al que estaba preso por agitador y asesino, pues a éste lo querían, y entregó a Jesús como ellos pedían."
,"26":"Cuando lo llevaban, encontraron a un tal Simón de Cirene, que volvía del campo, y le cargaron con la cruz para que la llevara detrás de Jesús."
,"27":"Lo seguía muchísima gente, especialmente mujeres que se golpeaban el pecho y se lamentaban por él."
,"28":"Jesús, volviéndose hacia ellas, les dijo: 'Hijas de Jerusalén, no lloren por mí. Lloren más bien por ustedes mismas y por sus hijos."
,"29":"Porque llegarán días en que se dirá: 'Felices las mujeres que no tienen hijos. Felices las que no dieron a luz ni amamantaron.'"
,"30":"Entonces dirán: '¡Que caigan sobre nosotros los montes, y nos sepulten los cerros!'"
,"31":"Porque si así tratan al árbol verde, ¿qué harán con el seco?'"
,"32":"Junto con Jesús llevaban también a dos malhechores para ejecutarlos."
,"33":"Al llegar al lugar llamado de la Calavera, lo crucificaron allí, y con él a los malhechores, uno a su derecha y el otro a su izquierda."
,"34":"(Mientras tanto Jesús decía: 'Padre, perdónalos, porque no saben lo que hacen.') Después los soldados se repartieron sus ropas echándolas a suerte."
,"35":"La gente estaba allí mirando; los jefes, por su parte, se burlaban diciendo: 'Si salvó a otros, que se salve a sí mismo, ya que es el Mesías de Dios, el Elegido.'"
,"36":"También los soldados se burlaban de él. Le ofrecieron vino agridulce"
,"37":"diciendo: 'Si tú eres el rey de los judíos, sálvate a ti mismo.'"
,"38":"Porque había sobre la cruz un letrero que decía: 'Este es el rey de los judíos.'"
,"39":"Uno de los malhechores que estaban crucificados con Jesús lo insultaba: '¿No eres tú el Mesías? ¡Sálvate a ti mismo y también a nosotros.'"
,"40":"Pero el otro lo reprendió diciendo: '¿No temes a Dios tú, que estás en el mismo suplicio?"
,"41":"Nosotros lo hemos merecido y pagamos por lo que hemos hecho,"
,"42":"pero éste no ha hecho nada malo.' Y añadió: 'Jesús, acuérdate de mí cuando entres en tu Reino.'"
,"43":"Jesús le respondió: 'En verdad te digo que hoy mismo estarás conmigo en el paraíso.'"
,"44":"Hacia el mediodía se ocultó el sol y todo el país quedó en tinieblas hasta las tres de la tarde."
,"45":"En ese momento la cortina del Templo se rasgó por la mitad,"
,"46":"y Jesús gritó muy fuerte: 'Padre, en tus manos encomiendo mi espíritu'. Y dichas estas palabras, expiró."
,"47":"El capitán, al ver lo que había sucedido, reconoció la mano de Dios y dijo: 'Realmente este hombre era un justo.'"
,"48":"Y toda la gente que se había reunido para ver este espectáculo, al ver lo ocurrido, comenzó a irse golpeándose el pecho."
,"49":"Estaban a distancia los conocidos de Jesús, especialmente las mujeres que lo habían acompañado desde Galilea, y todo esto lo presenciaron ellas."
,"50":"Intervino entonces un hombre bueno y justo llamado José, que era miembro del Consejo Supremo,"
,"51":"pero que no había estado de acuerdo con los planes ni actos de los otros. Era de Arimatea, una ciudad de Judea, y esperaba el Reino de Dios."
,"52":"Se presentó, pues, ante Pilato y le pidió el cuerpo de Jesús."
,"53":"Después de bajarlo de la cruz, lo envolvió en una sábana y lo depositó en un sepulcro nuevo cavado en la roca, donde nadie había sido enterrado aún."
,"54":"Era el día de la Preparación de la Pascua y ya estaba para comenzar el día sábado."
,"55":"Las mujeres que habían venido desde Galilea con Jesús no se habían alejado; vieron de cerca el sepulcro y cómo colocaban su cuerpo."
,"56":"Después que volvieron a sus casas, prepararon perfumes y mirra, y el sábado descansaron, según manda la Ley."
}`)
	CurrentBook.AddChapter(24, `{
"1":"El primer día de la semana, muy temprano, fueron las mujeres al sepulcro, llevando los perfumes que habían preparado."
,"2":"Pero se encontraron con una novedad: la piedra que cerraba el sepulcro había sido removida,"
,"3":"y al entrar no encontraron el cuerpo del Señor Jesús."
,"4":"No sabían qué pensar, pero en ese momento vieron a su lado a dos hombres con ropas fulgurantes."
,"5":"Estaban tan asustadas que no se atrevían a levantar los ojos del suelo. Pero ellos les dijeron: '¿Por qué buscan entre los muertos al que vive?"
,"6":"No está aquí. Resucitó. Acuérdense de lo que les dijo cuando todavía estaba en Galilea:"
,"7":"'El Hijo del Hombre debe ser entregado en manos de los pecadores y ser crucificado, y al tercer día resucitará'.'"
,"8":"Ellas entonces recordaron las palabras de Jesús."
,"9":"Al volver del sepulcro, les contaron a los Once y a todos los demás lo que les había sucedido."
,"10":"Las que hablaban eran María de Magdala, Juana y María, la madre de Santiago. También las demás mujeres que estaban con ellas decían lo mismo a los apóstoles."
,"11":"Pero no les creyeron, y esta novedad les pareció puros cuentos."
,"12":"Pedro, sin embargo, se levantó y fue corriendo al sepulcro; se agachó y no vio más que los lienzos, por lo que volvió a casa preguntándose por lo ocurrido."
,"13":"Aquel mismo día dos discípulos se dirigían a un pueblecito llamado Emaús, que está a unos doce kilómetros de Jerusalén,"
,"14":"e iban conversando sobre todo lo que había ocurrido."
,"15":"Mientras conversaban y discutían, Jesús en persona se les acercó y se puso a caminar con ellos,"
,"16":"pero algo impedía que sus ojos lo reconocieran."
,"17":"El les dijo: '¿De qué van discutiendo por el camino?' Se detuvieron, y parecían muy desanimados."
,"18":"Uno de ellos, llamado Cleofás, le contestó: '¿Cómo? ¿Eres tú el único peregrino en Jerusalén que no está enterado de lo que ha pasado aquí estos días?'"
,"19":"'¿Qué pasó?', les preguntó. Le contestaron: '¡Todo el asunto de Jesús Nazareno!',Era un profeta poderoso en obras y palabras, reconocido por Dios y por todo el pueblo. "
,"20":"Pero nuestros sumos sacerdotes y nuestros jefes renegaron de él, lo hicieron condenar a muerte y clavar en la cruz."
,"21":"Nosotros pensábamos que él sería el que debía libertar a Israel. Pero todo está hecho, y ya van dos días que sucedieron estas cosas."
,"22":"En realidad, algunas mujeres de nuestro grupo nos han inquietado,"
,"23":"pues fueron muy de mañana al sepulcro y, al no hallar su cuerpo, volvieron hablando de una aparición de ángeles que decían que estaba vivo."
,"24":"Algunos de los nuestros fueron al sepulcro y hallaron todo tal como habían dicho las mujeres, pero a él no lo vieron.'"
,"25":"Entonces él les dijo: '¡Qué poco entienden ustedes y qué lentos son sus corazones para creer todo lo que anunciaron los profetas!"
,"26":"¿No tenía que ser así y que el Mesías padeciera para entrar en su gloria?'"
,"27":"Y les interpretó lo que se decía de él en todas las Escrituras, comenzando por Moisés y siguiendo por los profetas."
,"28":"Al llegar cerca del pueblo al que iban, hizo como que quisiera seguir adelante,"
,"29":"pero ellos le insistieron diciendo: 'Quédate con nosotros, ya está cayendo la tarde y se termina el día.' Entró, pues, para quedarse con ellos."
,"30":"Y mientras estaba en la mesa con ellos, tomó el pan, pronunció la bendición, lo partió y se lo dio."
,"31":"En ese momento se les abrieron los ojos y lo reconocieron, pero él desapareció."
,"32":"Entonces se dijeron el uno al otro: '¿No sentíamos arder nuestro corazón cuando nos hablaba en el camino y nos explicaba las Escrituras?'"
,"33":"De inmediato se levantaron y volvieron a Jerusalén, donde encontraron reunidos a los Once y a los de su grupo."
,"34":"Estos les dijeron: 'Es verdad: el Señor ha resucitado y se ha aparecido a Simón.'"
,"35":"Ellos, por su parte, contaron lo sucedido en el camino y cómo lo habían reconocido al partir el pan."
,"36":"Mientras estaban hablando de todo esto, Jesús se presentó en medio de ellos (y les dijo: 'Paz a ustedes.')"
,"37":"Quedaron atónitos y asustados, pensando que veían algún espíritu,"
,"38":"pero él les dijo: '¿Por qué se desconciertan? ¿Cómo se les ocurre pensar eso?"
,"39":"Miren mis manos y mis pies: soy yo. Tóquenme y fíjense bien que un espíritu no tiene carne ni huesos, como ustedes ven que yo tengo.'"
,"40":"(Y dicho esto les mostró las manos y los pies)."
,"41":"Y como no acababan de creerlo por su gran alegría y seguían maravillados, les dijo: '¿Tienen aquí algo que comer?'"
,"42":"Ellos, entonces, le ofrecieron un pedazo de pescado asado (y una porción de miel);"
,"43":"lo tomó y lo comió delante ellos."
,"44":"Jesús les dijo: 'Todo esto se lo había dicho cuando estaba todavía con ustedes; tenía que cumplirse todo lo que está escrito en la Ley de Moisés, en los Profetas y en los Salmos referente a mí.'"
,"45":"Entonces les abrió la mente para que entendieran las Escrituras."
,"46":"Les dijo: 'Todo esto estaba escrito: los padecimientos del Mesías y su resurrección de entre los muertos al tercer día."
,"47":"Luego debe proclamarse en su nombre el arrepentimiento y el perdón de los pecados, comenzando por Jerusalén, y yendo después a todas las naciones, invitándolas a que se conviertan."
,"48":"Ustedes son testigos de todo esto."
,"49":"Ahora yo voy a enviar sobre ustedes lo que mi Padre prometió. Permanezcan, pues, en la ciudad hasta que sean revestidos de la fuerza que viene de arriba.'"
,"50":"Jesús los llevó hasta cerca de Betania y, levantando las manos, los bendijo."
,"51":"Y mientras los bendecía, se separó de ellos (y fue llevado al cielo."
,"52":"Ellos se postraron ante él.) Después volvieron llenos de gozo a Jerusalén,"
,"53":"y continuamente estaban en el Templo alabando a Dios."
}`)

}
func ES_LBL_LoadNEMCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Este es el comienzo de la Buena Nueva de Jesucristo (Hijo de Dios)."
,"2":"En el libro del profeta Isaías estaba escrito: 'Mira, te voy a enviar a mi mensajero delante de ti para que te prepare el camino."
,"3":"Escuchen ese grito en el desierto: Preparen el camino del Señor, enderecen sus senderos.'"
,"4":"Es así como Juan el Bautista empezó a bautizar en el desierto. Allí predicaba bautismo y conversión, para alcanzar el perdón de los pecados."
,"5":"Toda la provincia de Judea y el pueblo de Jerusalén acudían a Juan para confesar sus pecados y ser bautizados por él en el río Jordán."
,"6":"Además de la piel que tenía colgada de la cintura, Juan no llevaba más que un manto hecho de pelo de camello. Su comida eran langostas y miel silvestre."
,"7":"Juan proclamaba este mensaje: 'Detrás de mí viene uno con más poder que yo. Yo no soy digno de desatar la correa de sus sandalias, aunque fuera arrodillándome ante él.'"
,"8":"Yo los he bautizado con agua, pero él los bautizará en el Espíritu Santo.'"
,"9":"En aquellos días Jesús vino de Nazaret, pueblo de Galilea, y se hizo bautizar por Juan en el río Jordán."
,"10":"Al momento de salir del agua, Jesús vio los Cielos abiertos: el Espíritu bajaba sobre él como lo hace la paloma,"
,"11":"mientras se escuchaban estas palabras del Cielo: 'Tú eres mi Hijo, el Amado, mi Elegido.'"
,"12":"En seguida el Espíritu lo empujó al desierto."
,"13":"Estuvo cuarenta días en el desierto y fue tentado por Satanás. Vivía entre los animales salvajes y los ángeles le servían."
,"14":"Después de que tomaron preso a Juan, Jesús fue a Galilea y empezó a proclamar la Buena Nueva de Dios."
,"15":"Decía: 'El tiempo se ha cumplido, el Reino de Dios está cerca. Cambien sus caminos y crean en la Buena Nueva.'"
,"16":"Mientras Jesús pasaba por la orilla del mar de Galilea, vio a Simón y a su hermano Andrés que echaban las redes en el mar, pues eran pescadores."
,"17":"Jesús les dijo: 'Síganme y yo los haré pescadores de hombres.'"
,"18":"Y de inmediato dejaron sus redes y le siguieron."
,"19":"Un poco más allá Jesús vio a Santiago, hijo de Zebedeo, con su hermano Juan, que estaban en su barca arreglando las redes."
,"20":"Jesús también los llamó, y ellos, dejando a su padre Zebedeo en la barca con los ayudantes, lo siguieron."
,"21":"Llegaron a Cafarnaún, y Jesús empezó a enseñar en la sinagoga durante las asambleas del día sábado."
,"22":"Su manera de enseñar impresionaba mucho a la gente, porque hablaba como quien tiene autoridad, y no como los maestros de la Ley."
,"23":"Entró en aquella sinagoga un hombre que estaba en poder de un espíritu malo, y se puso a gritar:"
,"24":"'¿Qué quieres con nosotros, Jesús de Nazaret? ¿Has venido a destruirnos? Yo sé que tú eres el Santo de Dios.'"
,"25":"Jesús le hizo frente con autoridad:"
,"26":"'¡Cállate y sal de ese hombre!' El espíritu malo revolcó al hombre en el suelo y lanzó un grito tremendo, pero luego salió de él."
,"27":"El asombro de todos fue tan grande que se preguntaban unos a otros: '¿Qué es esto? Una doctrina nueva, y ¡con qué autoridad! Miren cómo da órdenes a los espíritus malos ¡y le obedecen!'"
,"28":"Así fue como la fama de Jesús se extendió por todo el territorio de Galilea."
,"29":"Al salir de la Sinagoga, Jesús fue a la casa de Simón y Andrés con Santiago y Juan."
,"30":"La suegra de Simón estaba en cama con fiebre, por lo que en seguida le hablaron de ella."
,"31":"Jesús se acercó y, tomándola de la mano, la levantó. Se le quitó la fiebre y se puso a atenderlos."
,"32":"Antes del atardecer, cuando se ponía el sol, empezaron a traer a Jesús todos los enfermos y personas poseídas por espíritus malos."
,"33":"El pueblo entero estaba reunido ante la puerta."
,"34":"Jesús sanó a muchos enfermos con dolencias de toda clase y expulsó muchos demonios; pero no los dejaba hablar, pues sabían quién era."
,"35":"De madrugada, cuando todavía estaba muy oscuro, Jesús se levantó, salió y se fue a un lugar solitario. Allí se puso a orar."
,"36":"Simón y sus compañeros fueron a buscarlo,"
,"37":"y cuando lo encontraron le dijeron: 'Todos te están buscando.'"
,"38":"Él les contestó: 'Vámonos a los pueblecitos vecinos, para predicar también allí, pues para esto he salido.'"
,"39":"Y Jesús empezó a visitar las Casas de oración de aquella gente, recorriendo toda Galilea. Predicaba y expulsaba a los demonios."
,"40":"Se le acercó un leproso, que se arrodilló ante él y le suplicó: 'Si quieres, puedes limpiarme.'"
,"41":"Sintiendo compasión, Jesús extendió la mano y lo tocó diciendo: 'Quiero, queda limpio.'"
,"42":"Al instante se le quitó la lepra y quedó sano."
,"43":"Entonces Jesús lo despidió, pero le ordenó enérgicamente:"
,"44":"'No cuentes esto a nadie, pero vete y preséntate al sacerdote y haz por tu purificación la ofrenda que ordena la Ley de Moisés, pues tú tienes que hacer tu declaración.',Pero el hombre, en cuanto se fue, empezó a hablar y a divulgar lo ocurrido, "
,"45":"de tal manera que Jesús ya no podía entrar públicamente en el pueblo; tenía que andar por las afueras, en lugares solitarios. Pero la gente venía a él de todas partes."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Tiempo después, Jesús volvió a Cafarnaún. Apenas corrió la noticia de que estaba en casa,"
,"2":"se reunió tanta gente que no quedaba sitio ni siquiera a la puerta."
,"3":"Y mientras Jesús les anunciaba la Palabra, cuatro hombres le trajeron un paralítico que llevaban tendido en una camilla."
,"4":"Como no podían acercarlo a Jesús a causa de la multitud, levantaron el techo donde él estaba y por el boquete bajaron al enfermo en su camilla."
,"5":"Al ver la fe de aquella gente, Jesús dijo al paralítico: 'Hijo, se te perdonan tus pecados.'"
,"6":"Estaban allí sentados algunos maestros de la Ley, y pensaron en su interior:"
,"7":"'¿Cómo puede decir eso? Realmente se burla de Dios. ¿Quién puede perdonar pecados, fuera de Dios?'"
,"8":"Pero Jesús supo en su espíritu lo que ellos estaban pensando, y les dijo: '¿Por qué piensan así?"
,"9":"¿Qué es más fácil decir a este paralítico: Se te perdonan tus pecados, o decir: Levántate, toma tu camilla y anda?"
,"10":"Pues ahora ustedes sabrán que el Hijo del Hombre tiene en la tierra poder para perdonar pecados.'"
,"11":"Y dijo al paralítico: 'Levántate, toma tu camilla y vete a tu casa.',El hombre se levantó, y ante los ojos de toda la gente, cargó con su camilla y se fue. "
,"12":"La gente quedó asombrada, y todos glorificaban a Dios diciendo: 'Nunca hemos visto nada parecido.'"
,"13":"Jesús salió otra vez por las orillas del lago; todo el mundo venía a verlo y él les enseñaba."
,"14":"Mientras caminaba, vio a un cobrador de impuestos sentado en su despacho. Era Leví, hijo de Alfeo. Jesús le dijo: 'Sígueme.' Y él se levantó y lo siguió."
,"15":"Jesús estuvo comiendo en la casa de Leví, y algunos cobradores de impuestos y pecadores estaban sentados a la mesa con Jesús y sus discípulos; en realidad eran un buen número. Pero también seguían a Jesús"
,"16":"maestros de la Ley del grupo de los fariseos y, al verlo sentado a la misma mesa con pecadores y cobradores de impuestos, dijeron a los discípulos: '¿Qué es esto? ¡Está comiendo con publicanos y pecadores!'"
,"17":"Jesús los oyó y les dijo: 'No es la gente sana la que necesita médico, sino los enfermos. No he venido a llamar a justos, sino a pecadores.'"
,"18":"Un día estaban ayunando los discípulos de Juan el Bautista y los fariseos. Algunas personas vinieron a preguntar a Jesús: 'Los discípulos de Juan y los de los fariseos ayunan; ¿por qué no lo hacen los tuyos?'"
,"19":"Jesús les contestó: '¿Quieren ustedes que los compañeros del novio ayunen mientras el novio está con ellos? Mientras tengan al novio con ellos, claro que no pueden ayunar."
,"20":"Pero llegará el momento en que se les arrebatará el novio, y entonces ayunarán."
,"21":"Nadie remienda un vestido viejo con un pedazo de género nuevo, porque la tela nueva encoge, tira de la tela vieja, y se hace más grande la rotura."
,"22":"Y nadie echa vino nuevo en envases de cuero viejos, porque el vino haría reventar los envases y se echarían a perder el vino y los envases. ¡A vino nuevo, envases nuevos!'"
,"23":"Un sábado Jesús pasaba por unos sembrados con sus discípulos. Mientras caminaban, los discípulos empezaron a desgranar espigas en sus manos."
,"24":"Los fariseos dijeron a Jesús: 'Mira lo que están haciendo; esto está prohibido en día sábado.'"
,"25":"El les dijo: '¿Nunca han leído ustedes lo que hizo David cuando sintió necesidad y hambre, y también su gente?"
,"26":"Entró en la Casa de Dios, siendo sumo sacerdote Abiatar, y comió los panes de la ofrenda, que sólo pueden comer los sacerdotes; y les dio también a los que estaban con él.'"
,"27":"Y Jesús concluyó: 'El sábado ha sido hecho para el hombre, y no el hombre para el sábado."
,"28":"Sepan, pues, que el Hijo del Hombre también es dueño del sábado.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Otro día entró Jesús en la sinagoga y se encontró con un hombre que tenía la mano paralizada."
,"2":"Pero algunos estaban observando para ver si lo sanaba Jesús en día sábado. Con esto tendrían motivo para acusarlo."
,"3":"Jesús dijo al hombre que tenía la mano paralizada: 'Ponte de pie y colócate aquí en medio.'"
,"4":"Después les preguntó: '¿Qué nos permite la Ley hacer en día sábado? ¿Hacer el bien o hacer daño? ¿Salvar una vida o matar?' Pero ellos se quedaron callados."
,"5":"Entonces Jesús paseó sobre ellos su mirada, enojado y muy apenado por su ceguera, y dijo al hombre: 'Extiende la mano.' El paralítico la extendió y su mano quedó sana."
,"6":"En cuanto a los fariseos, apenas salieron, fueron a juntarse con los partidarios de Herodes, buscando con ellos la forma de eliminar a Jesús."
,"7":"Jesús se retiró con sus discípulos a orillas del lago y lo siguió una gran muchedumbre de Galilea. También de Judea,"
,"8":"de Jerusalén, de Idumea, del otro lado del Jordán y de las tierras de Tiro y de Sidón, muchísima gente venía a verlo con sólo oír todo lo que hacía."
,"9":"Jesús mandó a sus discípulos que tuvieran lista una barca, para que toda aquella gente no lo atropellase."
,"10":"Pues al verlo sanar a tantos, todas las personas que sufrían de algún mal se le echaban encima para tocarlo."
,"11":"Incluso los espíritus malos, apenas lo veían, se arrojaban a sus pies y gritaban: 'Tú eres el Hijo de Dios.'"
,"12":"Pero él no quería que lo dieran a conocer, y los hacía callar."
,"13":"Jesús subió al monte y llamó a los que él quiso, y se reunieron con él."
,"14":"Así instituyó a los Doce (a los que llamó también apóstoles), para que estuvieran con él y para enviarlos a predicar,"
,"15":"dándoles poder para echar demonios."
,"16":"Estos son los Doce: Simón, a quien puso por nombre Pedro;"
,"17":"Santiago y su hermano Juan, hijos de Zebedeo, a quienes puso el sobrenombre de Boanerges, es decir, hijos del trueno;"
,"18":"Andrés, Felipe, Bartolomé, Mateo, Tomás, Santiago, el hijo de Alfeo, Tadeo, Simón el Cananeo,"
,"19":"y Judas Iscariote, el que después lo traicionó."
,"20":"Vuelto a casa, se juntó otra vez tanta gente que ni siquiera podían comer."
,"21":"Al enterarse sus parientes de todo lo anterior, fueron a buscarlo para llevárselo, pues decían: 'Se ha vuelto loco.'"
,"22":"Mientras tanto, unos maestros de la Ley que habían venido de Jerusalén decían: 'Está poseído por Belzebú, jefe de los demonios, y con su ayuda expulsa a los demonios.'"
,"23":"Jesús les pidió que se acercaran y empezó a enseñarles por medio de ejemplos:"
,"24":"'¿Cómo puede Satanás echar a Satanás? Si una nación está con luchas internas, esa nación no podrá mantenerse en pie."
,"25":"Y si una familia está con divisiones internas, esa familia no podrá subsistir."
,"26":"De igual modo, si Satanás lucha contra sí mismo y está dividido, no puede subsistir, y pronto llegará su fin."
,"27":"La verdad es que nadie puede entrar en la casa del Fuerte y arrebatarle sus cosas si no lo amarra primero; entonces podrá saquear su casa."
,"28":"En verdad les digo: se les perdonará todo a los hombres, ya sean pecados o blasfemias contra Dios, por muchos que sean."
,"29":"En cambio el que calumnie al Espíritu Santo, no tendrá jamás perdón, pues se queda con un pecado que nunca lo dejará.'"
,"30":"Y justamente ése era su pecado cuando decían: Está poseído por un espíritu malo."
,"31":"Entonces llegaron su madre y sus hermanos, se quedaron afuera y lo mandaron a llamar."
,"32":"Como era mucha la gente sentada en torno a Jesús, le transmitieron este recado: 'Tu madre, tus hermanos y tus hermanas están fuera y preguntan por ti.'"
,"33":"Él les contestó: '¿Quiénes son mi madre y mis hermanos?'"
,"34":"Y mirando a los que estaban sentados a su alrededor, dijo: 'Estos son mi madre y mis hermanos."
,"35":"Porque todo el que hace la voluntad de Dios es hermano mío y hermana y madre.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Otra vez Jesús se puso a enseñar a orillas del lago. Se le reunió tanta gente junto a él que tuvo que subir a una barca y sentarse en ella a alguna distancia, mientras toda la gente estaba en la orilla."
,"2":"Jesús les enseñó muchas cosas por medio de ejemplos o parábolas. Les enseñaba en esta forma:"
,"3":"'Escuchen esto: El sembrador salió a sembrar."
,"4":"Al ir sembrando, una parte de la semilla cayó a lo largo del camino, vinieron los pájaros y se la comieron."
,"5":"Otra parte cayó entre piedras, donde había poca tierra, y las semillas brotaron en seguida por no estar muy honda la tierra."
,"6":"Pero cuando salió el sol, las quemó y, como no tenían raíces, se secaron."
,"7":"Otras semillas cayeron entre espinos: los espinos crecieron y las sofocaron, de manera que no dieron fruto."
,"8":"Otras semillas cayeron en tierra buena: brotaron, crecieron y produjeron unas treinta, otras sesenta y otras cien."
,"9":"Y Jesús agregó: El que tenga oídos para oír, que escuche.'"
,"10":"Cuando toda la gente se retiró, los que lo seguían se acercaron con los Doce y le preguntaron qué significaban aquellas parábolas."
,"11":"El les contestó: 'A ustedes se les ha dado el misterio del Reino de Dios, pero a los que están fuera no les llegan más que parábolas."
,"12":"Y se verifican estas palabras: Por mucho que miran, no ven; por más que oyen, no entienden; de otro modo se convertirían y recibirían el perdón.'"
,"13":"Jesús les dijo: '¿No entienden esta parábola? Entonces, ¿cómo comprenderán las demás?"
,"14":"Lo que el sembrador siembra es la Palabra de Dios."
,"15":"Los que están a lo largo del camino cuando se siembra, son aquellos que escuchan la Palabra, pero en cuanto la reciben, viene Satanás y se lleva la palabra sembrada en ellos."
,"16":"Otros reciben la palabra como un terreno lleno de piedras. Apenas reciben la palabra, la aceptan con alegría;"
,"17":"pero no se arraiga en ellos y no duran más que una temporada; en cuanto sobreviene alguna prueba o persecución por causa de la Palabra, al momento caen."
,"18":"Otros la reciben como entre espinos; éstos han escuchado la Palabra,"
,"19":"pero luego sobrevienen las preocupaciones de esta vida, las promesas engañosas de la riqueza y las demás pasiones, y juntas ahogan la Palabra, que no da fruto."
,"20":"Para otros se ha sembrado en tierra buena. Estos han escuchado la palabra, le han dado acogida y dan fruto: unos el treinta por uno, otros el sesenta y otros el ciento.'"
,"21":"Jesús les dijo también: 'Cuando llega la luz, ¿debemos ponerla bajo un macetero o debajo de la cama? ¿No la pondremos más bien sobre el candelero?"
,"22":"No hay cosa secreta que no deba ser descubierta; y si algo ha sido ocultado, será sacado a la luz."
,"23":"El que tenga oídos para escuchar, que escuche.'"
,"24":"Les dijo también: 'Presten atención a lo que escuchan. La medida con que ustedes midan, se usará para medir lo que reciban, y se les dará mucho más todavía."
,"25":"Sépanlo bien: al que produce se le dará más, y al que no produce se le quitará incluso lo que tiene.'"
,"26":"Jesús dijo además: 'Escuchen esta comparación del Reino de Dios. Un hombre esparce la semilla en la tierra,"
,"27":"y ya duerma o esté despierto, sea de noche o de día, la semilla brota y crece, sin que él sepa cómo."
,"28":"La tierra da fruto por sí misma: primero la hierba, luego la espiga, y por último la espiga se llena de granos."
,"29":"Y cuando el grano está maduro, se le mete la hoz, pues ha llegado el tiempo de la cosecha.'"
,"30":"Jesús les dijo también: '¿A qué se parece el Reino de Dios? ¿Con qué comparación lo podríamos expresar?"
,"31":"Es semejante a una semilla de mostaza; al sembrarla, es la más pequeña de todas las semillas que se echan en la tierra,"
,"32":"pero una vez sembrada, crece y se hace más grande que todas las plantas del huerto y sus ramas se hacen tan grandes que los pájaros del cielo buscan refugio bajo su sombra.'"
,"33":"Jesús usaba muchas parábolas como éstas para anunciar la Palabra, adaptándose a la capacidad de la gente."
,"34":"No les decía nada sin usar parábolas, pero a sus discípulos se lo explicaba todo en privado."
,"35":"Al atardecer de aquel mismo día, Jesús dijo a sus discípulos: 'Crucemos a la otra orilla del lago.'"
,"36":"Despidieron a la gente y lo llevaron en la barca en que estaba. También lo acompañaban otras barcas."
,"37":"De pronto se levantó un gran temporal y las olas se estrellaban contra la barca, que se iba llenando de agua."
,"38":"Mientras tanto Jesús dormía en la popa sobre un cojín. Lo despertaron diciendo: 'Maestro, ¿no te importa que nos hundamos?' "
,"39":"El entonces se despertó. Se encaró con el viento y dijo al mar: 'Cállate, cálmate.' El viento se apaciguó y siguió una gran calma."
,"40":"Después les dijo: '¿Por qué son tan miedosos? ¿Todavía no tienen fe?'"
,"41":"Pero ellos estaban muy asustados por lo ocurrido y se preguntaban unos a otros: '¿Quién es éste, que hasta el viento y el mar le obedecen?'"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Llegaron a la otra orilla del lago, que es la región de los gerasenos."
,"2":"Apenas había bajado Jesús de la barca, un hombre vino a su encuentro, saliendo de entre los sepulcros, pues estaba poseído por un espíritu malo."
,"3":"El hombre vivía entre los sepulcros, y nadie podía sujetarlo ni siquiera con cadenas."
,"4":"Varias veces lo habían amarrado con grillos y cadenas, pero él rompía las cadenas y hacía pedazos los grillos, y nadie lograba dominarlo."
,"5":"Día y noche andaba por los cerros, entre los sepulcros, gritando y lastimándose con piedras."
,"6":"Al divisar a Jesús, fue corriendo y se echó de rodillas a sus pies."
,"7":"Entre gritos le decía: '¡No te metas conmigo, Jesús, Hijo del Dios Altísimo! Te ruego por Dios que no me atormentes.'"
,"8":"Es que Jesús le había dicho: 'Espíritu malo, sal de este hombre.'"
,"9":"Cuando Jesús le preguntó: '¿Cómo te llamas?', contestó: 'Me llamo Multitud, porque somos muchos.'"
,"10":"Y rogaban insistentemente a Jesús que no los echara de aquella región."
,"11":"Había allí una gran piara de cerdos comiendo al pie del cerro."
,"12":"Los espíritus le rogaron: 'Envíanos a esa piara y déjanos entrar en los cerdos.' Y Jesús se lo permitió."
,"13":"Entonces los espíritus malos salieron del hombre y entraron en los cerdos; en un instante las piaras se arrojaron al agua desde lo alto del acantilado y todos los cerdos se ahogaron en el lago."
,"14":"Los cuidadores de los cerdos huyeron y contaron lo ocurrido en la ciudad y por el campo, de modo que toda la gente fue a ver lo que había sucedido."
,"15":"Se acercaron a Jesús y vieron al hombre endemoniado, el que había estado en poder de la Multitud, sentado, vestido y en su sano juicio. Todos se asustaron."
,"16":"Los testigos les contaron lo ocurrido al endemoniado y a los cerdos,"
,"17":"y ellos rogaban a Jesús que se alejara de sus tierras."
,"18":"Cuando Jesús subía a la barca, el hombre que había tenido el espíritu malo le pidió insistentemente que le permitiera irse con él."
,"19":"Pero Jesús no se lo permitió, sino que le dijo: 'Vete a tu casa con los tuyos y cuéntales lo que el Señor ha hecho contigo y cómo ha tenido compasión de ti.'"
,"20":"El hombre se fue y empezó a proclamar por la región de la Decápolis lo que Jesús había hecho con él; y todos quedaban admirados."
,"21":"Jesús, entonces, atravesó el lago, y al volver a la otra orilla, una gran muchedumbre se juntó en la playa en torno a él."
,"22":"En eso llegó un oficial de la sinagoga, llamado Jairo, y al ver a Jesús, se postró a sus pies"
,"23":"suplicándole: 'Mi hija está agonizando; ven e impón tus manos sobre ella para que se mejore y siga viviendo.'"
,"24":"Jesús se fue con Jairo; estaban en medio de un gran gentío, que lo oprimía."
,"25":"Se encontraba allí una mujer que padecía un derrame de sangre desde hacía doce años."
,"26":"Había sufrido mucho en manos de muchos médicos y se había gastado todo lo que tenía, pero en lugar de mejorar, estaba cada vez peor."
,"27":"Como había oído lo que se decía de Jesús, se acercó por detrás entre la gente y le tocó el manto."
,"28":"La mujer pensaba: 'Si logro tocar, aunque sólo sea su ropa, sanaré.'"
,"29":"Al momento cesó su hemorragia y sintió en su cuerpo que estaba sana."
,"30":"Pero Jesús se dio cuenta de que un poder había salido de él, y dándose vuelta en medio del gentío, preguntó: '¿Quién me ha tocado la ropa?'"
,"31":"Sus discípulos le contestaron: 'Ya ves cómo te oprime toda esta gente ¿y preguntas quién te tocó?'"
,"32":"Pero él seguía mirando a su alrededor para ver quién le había tocado."
,"33":"Entonces la mujer, que sabía muy bien lo que le había pasado, asustada y temblando, se postró ante él y le contó toda la verdad."
,"34":"Jesús le dijo: 'Hija, tu fe te ha salvado; vete en paz y queda sana de tu enfermedad.'"
,"35":"Jesús estaba todavía hablando cuando llegaron algunos de la casa del oficial de la sinagoga para informarle: 'Tu hija ha muerto. ¿Para qué molestar ya al Maestro?'"
,"36":"Jesús se hizo el desentendido y dijo al oficial: 'No tengas miedo, solamente ten fe.'"
,"37":"Pero no dejó que lo acompañaran más que Pedro, Santiago y Juan, el hermano de Santiago."
,"38":"Cuando llegaron a la casa del oficial, Jesús vio un gran alboroto: unos lloraban y otros gritaban."
,"39":"Jesús entró y les dijo: '¿Por qué este alboroto y tanto llanto? La niña no está muerta, sino dormida.'"
,"40":"Y se burlaban de él. Pero Jesús los hizo salir a todos, tomó consigo al padre, a la madre y a los que venían con él, y entró donde estaba la niña."
,"41":"Tomándola de la mano, dijo a la niña: 'Talitá kumi', que quiere decir: 'Niña, te lo digo, ¡levántate!'"
,"42":"La jovencita se levantó al instante y empezó a caminar (tenía doce años). ¡Qué estupor más grande! Quedaron fuera de sí."
,"43":"Pero Jesús les pidio insistentemente que no lo contaran a nadie, y les dijo que dieran algo de comer a la niña."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Al irse Jesús de allí, volvió a su tierra, y sus discípulos se fueron con él."
,"2":"Cuando llegó el sábado, se puso a enseñar en la sinagoga y mucha gente lo escuchaba con estupor. Se preguntaban: '¿De dónde le viene todo esto? ¿Y qué pensar de la sabiduría que ha recibido, con esos milagros que salen de sus manos?"
,"3":"Pero no es más que el carpintero, el hijo de María; es un hermano de Santiago, de Joset, de Judas y Simón. ¿Y sus hermanas no están aquí entre nosotros?' Se escandalizaban y no lo reconocían."
,"4":"Jesús les dijo: 'Si hay un lugar donde un profeta es despreciado, es en su tierra, entre sus parientes y en su propia familia.'"
,"5":"Y no pudo hacer allí ningún milagro. Tan sólo sanó a unos pocos enfermos imponiéndoles las manos."
,"6":"Jesús se admiraba de cómo se negaban a creer. Jesús recorría todos los pueblos de los alrededores enseñando. "
,"7":"Llamó a los Doce y comenzó a enviarlos de dos en dos, dándoles poder sobre los espíritus malos."
,"8":"Les ordenó que no llevaran nada para el camino, fuera de un bastón: ni pan, ni morral, ni dinero;"
,"9":"que llevaran calzado corriente y un solo manto."
,"10":"Y les decía: 'Quédense en la primera casa en que les den alojamiento, hasta que se vayan de ese sitio."
,"11":"Y si en algún lugar no los reciben ni los escuchan, no se alejen de allí sin haber sacudido el polvo de sus pies: con esto darán testimonio contra ellos.'"
,"12":"Fueron, pues, a predicar, invitando a la conversión."
,"13":"Expulsaban a muchos espíritus malos y sanaban a numerosos enfermos, ungiéndoles con aceite."
,"14":"El rey Herodes oyó hablar de Jesús, ya que su nombre se había hecho famoso. Algunos decían: 'Este es Juan el Bautista, que ha resucitado de entre los muertos, y por eso actúan en él poderes milagrosos.'"
,"15":"Otros decían: 'Es Elías', y otros: 'Es un profeta como los antiguos profetas'."
,"16":"Herodes, por su parte, pensaba: 'Debe de ser Juan, al que le hice cortar la cabeza, que ha resucitado.'"
,"17":"En efecto, Herodes había mandado apresar a Juan y lo había encadenado en la cárcel por el asunto de Herodías, mujer de su hermano Filipo, con la que se había casado."
,"18":"Pues Juan le decía: 'No te está permitido tener a la mujer de tu hermano.'"
,"19":"Herodías lo odiaba y quería matarlo, pero no podía,"
,"20":"pues Herodes veía que Juan era un hombre justo y santo, y le tenía respeto. Por eso lo protegía, y lo escuchaba con gusto, aunque quedaba muy perplejo al oírlo."
,"21":"Herodías tuvo su oportunidad cuando Herodes, el día de su cumpleaños, dio un banquete a sus nobles, a sus oficiales y a los personajes principales de Galilea."
,"22":"En esa ocasión entró la hija de Herodías, bailó y gustó mucho a Herodes y a sus invitados. Entonces el rey dijo a la muchacha: 'Pídeme lo que quieras y te lo daré.'"
,"23":"Y le prometió con juramento: 'Te daré lo que me pidas, aunque sea la mitad de mi reino.'"
,"24":"Salió ella a consultar a su madre: '¿Qué pido?' La madre le respondió: 'La cabeza de Juan el Bautista.'"
,"25":"Inmediatamente corrió a donde estaba el rey y le dijo: 'Quiero que ahora mismo me des la cabeza de Juan el Bautista en una bandeja.'"
,"26":"El rey se sintió muy molesto, pero no quiso negárselo, porque se había comprometido con juramento delante de los invitados."
,"27":"Ordenó, pues, a un verdugo que le trajera la cabeza de Juan. Este fue a la cárcel y le cortó la cabeza."
,"28":"Luego, trayéndola en una bandeja, se la entregó a la muchacha y ésta se la pasó a su madre."
,"29":"Cuando la noticia llegó a los discípulos de Juan, vinieron a recoger el cuerpo y lo enterraron."
,"30":"Al volver los apóstoles a donde estaba Jesús, le contaron todo lo que habían hecho y enseñado."
,"31":"Jesús les dijo: 'Vámonos aparte, a un lugar retirado, y descansarán un poco.' Porque eran tantos los que iban y venían que no les quedaba tiempo ni para comer."
,"32":"Y se fueron solos en una barca a un lugar despoblado."
,"33":"Pero la gente vio cómo se iban, y muchos cayeron en la cuenta y se dirigieron allá a pie. De todos los pueblos la gente se fue corriendo y llegaron antes que ellos."
,"34":"Al desembarcar, Jesús vio toda aquella gente, y sintió compasión de ellos, pues estaban como ovejas sin pastor. Y se puso a enseñarles largamente."
,"35":"Se había hecho tarde. Los discípulos se le acercaron y le dijeron: 'Estamos en un lugar despoblado y ya se ha hecho tarde;"
,"36":"despide a la gente para que vayan a las aldeas y a los pueblos más cercanos y se compren algo de comer.'"
,"37":"Jesús les contestó: 'Denles ustedes de comer.' Ellos dijeron: '¿Y quieres que vayamos nosotros a comprar doscientos denarios de pan para dárselo?'"
,"38":"Jesús les dijo: '¿Cuántos panes tienen ustedes? Vayan a ver.' Volvieron y le dijeron: 'Hay cinco, y además hay dos pescados.'"
,"39":"Entonces les dijo que hicieran sentar a la gente en grupos sobre el pasto verde."
,"40":"Se acomodaron en grupos de cien y de cincuenta."
,"41":"Tomó Jesús los cinco panes y los dos pescados, levantó los ojos al cielo, pronunció la bendición, partió los panes y los iba dando a los discípulos para que se los sirvieran a la gente. Asimismo repartió los dos pescados entre todos."
,"42":"Comieron todos hasta saciarse;"
,"43":"incluso se llenaron doce canastos con los pedazos de pan, sin contar lo que sobró de los pescados."
,"44":"Los que habían comido eran unos cinco mil hombres."
,"45":"Inmediatamente Jesús obligó a sus discípulos a que subieran a la barca y lo fueran a esperar a Betsaida, en la otra orilla, mientras él despachaba a la gente."
,"46":"Jesús despidió, pues, a la gente, y luego se fue al cerro a orar."
,"47":"Al anochecer, la barca estaba en medio del lago y Jesús se había quedado solo en tierra."
,"48":"Jesús vio que sus discípulos iban agotados de tanto remar, pues el viento les era contrario, y antes de que terminara la noche fue hacia ellos caminando sobre el mar, como si quisiera pasar de largo."
,"49":"Al verlo caminar sobre el mar, creyeron que era un fantasma y se pusieron a gritar,"
,"50":"pues todos estaban asustados al verlo así. Pero Jesús les habló: 'Animo, no teman, que soy yo.'"
,"51":"Y subió a la barca con ellos. De inmediato se calmó el viento, con lo cual quedaron muy asombrados."
,"52":"Pues no habían entendido lo que había pasado con los panes, tenían la mente cerrada."
,"53":"Terminada la travesía, llegaron a Genesaret y amarraron allí la barca."
,"54":"Apenas se bajaron, la gente lo reconoció"
,"55":"y corrieron a dar la noticia por toda aquella región. Empezaron a traer a los enfermos en sus camillas al lugar donde él estaba,"
,"56":"y en todos los lugares adonde iba, pueblos, ciudades o aldeas, ponían a los enfermos en las plazas y le rogaban que les dejara tocar al menos el fleco de su manto. Y todos los que lo tocaban quedaban sanos."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Los fariseos se juntaron en torno a Jesús, y con ellos había algunos maestros de la Ley llegados de Jerusalén."
,"2":"Esta gente se fijó en que algunos de los discípulos de Jesús tomaban su comida con manos impuras, es decir, sin habérselas lavado antes."
,"3":"Porque los fariseos, al igual que el resto de los judíos, están aferrados a la tradición de sus mayores, y no comen nunca sin haberse lavado cuidadosamente las manos."
,"4":"Tampoco comen nada al volver del mercado sin antes cumplir con estas purificaciones. Y son muchas las tradiciones que deben observar, como la purificación de vasos, jarras y bandejas."
,"5":"Por eso los fariseos y maestros de la Ley le preguntaron: '¿Por qué tus discípulos no respetan la tradición de los ancianos, sino que comen con manos impuras?'"
,"6":"Jesús les contestó: '¡Qué bien salvan ustedes las apariencias! Con justa razón profetizó de ustedes Isaías cuando escribía: Este pueblo me honra con los labios, pero su corazón está lejos de mí."
,"7":"El culto que me rinden de nada sirve; las doctrinas que enseñan no son más que mandatos de hombres."
,"8":"Ustedes descuidan el mandamiento de Dios por aferrarse a tradiciones de hombres.'"
,"9":"Y Jesús añadió: 'Ustedes dejan tranquilamente a un lado el mandato de Dios para imponer su propia tradición."
,"10":"Así, por ejemplo, Moisés dijo: Cumple tus deberes con tu padre y con tu madre, y también: El que maldiga a su padre o a su madre es reo de muerte."
,"11":"En cambio, según ustedes, alguien puede decir a su padre o a su madre: 'Lo que podías esperar de mí es 'consagrado', ya lo tengo reservado para el Templo.'"
,"12":"Y ustedes ya no dejan que esa persona ayude a sus padres."
,"13":"De este modo anulan la Palabra de Dios con una tradición que se transmiten, pero que es de ustedes. Y ustedes hacen además otras muchas cosas parecidas a éstas.'"
,"14":"Jesús volvió a llamar a la gente y empezó a decirles: 'Escúchenme todos y traten de entender."
,"15":"Ninguna cosa que de fuera entra en la persona puede hacerla impura; lo que hace impura a una persona es lo que sale de ella."
,"16":"El que tenga oídos, que escuche.'"
,"17":"Cuando Jesús se apartó de la gente y entró en casa, sus discípulos le preguntaron sobre lo que había dicho."
,"18":"El les respondió: '¿También ustedes están cerrados? ¿No comprenden que nada de lo que entra de fuera en una persona puede hacerla impura?"
,"19":"Pues no entra en el corazón, sino que va al estómago primero y después al basural.'"
,"20":"Así Jesús declaraba que todos los alimentos son puros. Y luego continuó: 'Lo que hace impura a la persona es lo que ha salido de su propio corazón. "
,"21":"Los pensamientos malos salen de dentro, del corazón: de ahí proceden la inmoralidad sexual, robos, asesinatos,"
,"22":"infidelidad matrimonial, codicia, maldad, vida viciosa, envidia, injuria, orgullo y falta de sentido moral."
,"23":"Todas estas maldades salen de dentro y hacen impura a la persona.'"
,"24":"Jesús decidió irse hacia las tierras de Tiro. Entró en una casa, y su intención era que nadie lo supiera, pero no logró pasar inadvertido."
,"25":"Una mujer, cuya hija estaba en poder de un espíritu malo, se enteró de su venida y fue en seguida a arrodillarse a sus pies."
,"26":"Esta mujer era de habla griega y de raza sirofenicia, y pidió a Jesús que echara al demonio de su hija."
,"27":"Jesús le dijo: 'Espera que se sacien los hijos primero, pues no está bien tomar el pan de los hijos para echárselo a los perritos.'"
,"28":"Pero ella le respondió: 'Señor, los perritos bajo la mesa comen las migajas que dejan caer los hijos.'"
,"29":"Entonces Jesús le dijo: 'Puedes irte; por lo que has dicho el demonio ya ha salido de tu hija.'"
,"30":"Cuando la mujer llegó a su casa, encontró a la niña acostada en la cama; el demonio se había ido."
,"31":"Saliendo de las tierras de Tiro, Jesús pasó por Sidón y, dando la vuelta al lago de Galilea, llegó al territorio de la Decápolis."
,"32":"Allí le presentaron un sordo que hablaba con dificultad, y le pidieron que le impusiera la mano."
,"33":"Jesús lo apartó de la gente, le metió los dedos en los oídos y con su saliva le tocó la lengua."
,"34":"En seguida levantó los ojos al cielo, suspiró y dijo: 'Effetá', que quiere decir: 'Abrete.'"
,"35":"Al instante se le abrieron los oídos, le desapareció el defecto de la lengua y comenzó a hablar correctamente."
,"36":"Jesús les mandó que no se lo dijeran a nadie, pero cuanto más insistía, tanto más ellos lo publicaban."
,"37":"Estaban fuera de sí y decían muy asombrados: 'Todo lo ha hecho bien; hace oír a los sordos y hablar a los mudos.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"En aquellos días se juntó otra vez muchísima gente, y no tenían nada que comer. Jesús llamó a sus discípulos y les dijo:"
,"2":"'Siento compasión por esta gente, pues hace ya tres días que están conmigo y no tienen nada para comer."
,"3":"Si los mando a sus casas sin comer, desfallecerán por el camino, pues algunos de ellos han venido de lejos.'"
,"4":"Sus discípulos le contestaron: '¿De dónde podemos sacar, en este lugar desierto, el pan que necesitan?'"
,"5":"Jesús les preguntó: '¿Cuántos panes tienen?' Respondieron: 'Siete.'"
,"6":"Entonces mandó a la gente que se sentara en el suelo y, tomando los siete panes, dio gracias, los partió y empezó a darlos a sus discípulos para que los repartieran. Ellos se los sirvieron a la gente."
,"7":"Tenían también algunos pescaditos. Jesús pronunció la bendición y mandó que también los repartieran."
,"8":"Todos comieron hasta saciarse, y de los pedazos que sobraron, recogieron siete cestos."
,"9":"Eran unos cuatro mil los que habían comido. Luego Jesús los despidió."
,"10":"En seguida subió a la barca con sus discípulos y se fue a la región de Dalmanuta."
,"11":"Vinieron los fariseos y empezaron a discutir con Jesús. Querían ponerlo en apuros, y esperaban de él una señal que viniera del Cielo."
,"12":"Jesús suspiró profundamente y exclamó: '¿Por qué esta gente pide una señal? Yo les digo que a esta gente no se le dará ninguna señal.'"
,"13":"Y dejándolos, subió a la barca y se fue al otro lado del lago."
,"14":"Los discípulos se habían olvidado de llevar panes, y tan sólo tenían un pan en la barca."
,"15":"De repente él les hizo esta advertencia: 'Abran los ojos y cuídense tanto de la levadura de los fariseos como de la de Herodes.'"
,"16":"Se dijeron unos a otros: 'La verdad es que no tenemos pan.'"
,"17":"Jesús se dio cuenta y les dijo: '¿Por qué estos cuchicheos? ¿Porque no tienen pan? ¿Todavía no entienden ni se dan cuenta? ¿Están ustedes tan cerrados que"
,"18":"teniendo ojos no ven y teniendo oídos no oyen? ¿No recuerdan"
,"19":"cuando repartí cinco panes entre cinco mil personas? ¿Cuántos canastos llenos de pedazos recogieron?' Respondieron: 'Doce'."
,"20":"'Y cuando repartí los siete panes entre cuatro mil, ¿cuántos cestos llenos de sobras recogieron?' Contestaron: 'Siete'."
,"21":"Entonces Jesús les dijo: '¿Y aún no entienden?'"
,"22":"Cuando llegaron a Betsaida, le trajeron un ciego y le pidieron que lo tocara."
,"23":"Jesús tomó al ciego de la mano y lo llevó fuera del pueblo. Después le mojó los ojos con saliva, le impuso las manos y le preguntó: '¿Ves algo?'"
,"24":"El ciego, que empezaba a ver, dijo: 'Veo como árboles, pero deben ser gente, porque se mueven.'"
,"25":"Jesús le puso nuevamente las manos en los ojos, y el hombre se encontró con buena vista; se recuperó plenamente y podía ver todo con claridad."
,"26":"Jesús, pues, lo mandó a su casa, diciéndole: 'Ni siquiera entres en el pueblo.'"
,"27":"Salió Jesús con sus discípulos hacia los pueblos de Cesarea de Filipo, y por el camino les preguntó: '¿Quién dice la gente que soy yo?'"
,"28":"Ellos contestaron: 'Algunos dicen que eres Juan Bautista, otros que Elías o alguno de los profetas.'"
,"29":"Entonces Jesús les preguntó: 'Y ustedes, ¿quién dicen que soy yo?' Pedro le contestó: 'Tú eres el Mesías.'"
,"30":"Pero Jesús les dijo con firmeza que no conversaran sobre él."
,"31":"Luego comenzó a enseñarles que el Hijo del Hombre debía sufrir mucho y ser rechazado por los notables, los jefes de los sacerdotes y los maestros de la Ley, que sería condenado a muerte y resucitaría a los tres días."
,"32":"Jesús hablaba de esto con mucha seguridad. Pedro, pues, lo llevó aparte y comenzó a reprenderlo. "
,"33":"Pero Jesús, dándose la vuelta, vio muy cerca a sus discípulos. Entonces reprendió a Pedro y le dijo: '¡Pasa detrás de mí, Satanás! Tus ambiciones no son las de Dios, sino de los hombres.'"
,"34":"Luego Jesús llamó a sus discípulos y a toda la gente y les dijo: 'El que quiera seguirme, que renuncie a sí mismo, tome su cruz y me siga."
,"35":"Pues el que quiera asegurar su vida la perderá, y el que sacrifique su vida (por mí y) por el Evangelio, la salvará."
,"36":"¿De qué le sirve a uno si ha ganado el mundo entero, pero se ha destruido a sí mismo?"
,"37":"¿Qué podría dar para rescatarse a sí mismo?"
,"38":"Yo les aseguro: si alguno se avergüenza de mí y de mis palabras en medio de esta generación adúltera y pecadora, también el Hijo del Hombre se avergonzará de él cuando venga con la Gloria de su Padre rodeado de sus santos ángeles.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Jesús les dijo: 'En verdad se lo digo: algunos de los que están aquí presentes no conocerán la muerte sin que ya hayan visto el Reino de Dios viniendo con poder.'"
,"2":"Seis días después, Jesús tomó consigo a Pedro, a Santiago y a Juan y los llevó a ellos solos a un monte alto. A la vista de ellos su aspecto cambió completamente."
,"3":"Incluso sus ropas se volvieron resplandecientes, tan blancas como nadie en el mundo sería capaz de blanquearlas."
,"4":"Y se les aparecieron Elías y Moisés, que conversaban con Jesús."
,"5":"Pedro tomó la palabra y dijo a Jesús: 'Maestro, ¡qué bueno es que estemos aquí! Levantemos tres chozas: una para ti, otra para Moisés y otra para Elías.'"
,"6":"En realidad no sabía lo que decía, porque estaban aterrados."
,"7":"En eso se formó una nube que los cubrió con su sombra, y desde la nube llegaron estas palabras: 'Este es mi Hijo, el Amado, escúchenlo.'"
,"8":"Y de pronto, mirando a su alrededor, no vieron ya a nadie; sólo Jesús estaba con ellos."
,"9":"Cuando bajaban del cerro, les ordenó que no dijeran a nadie lo que habían visto, hasta que el Hijo del Hombre resucitara de entre los muertos."
,"10":"Ellos guardaron el secreto, aunque se preguntaban unos a otros qué querría decir eso de 'resucitar de entre los muertos'."
,"11":"Entonces le preguntaron: '¿No dicen los maestros de la Ley que Elías ha de venir primero?'"
,"12":"Jesús les contestó: 'Ya lo sabemos: Elías viene primero y deja todo reordenado... Pero, ¿por qué dicen las Escrituras que el Hijo del Hombre sufrirá mucho y será despreciado?"
,"13":"Yo se lo digo: Elías ya ha venido, e hicieron con él todo lo que quisieron, tal como de él estaba escrito.'"
,"14":"Cuando volvieron a donde estaban los otros discípulos, los encontraron con un grupo de gente a su alrededor, y algunos maestros de la Ley discutían con ellos."
,"15":"La gente quedó sorprendida al ver a Jesús y corrieron a saludarlo."
,"16":"El les preguntó: '¿Sobre qué discutían ustedes con ellos?'"
,"17":"Y uno del gentío le respondió: 'Maestro, te he traído a mi hijo, que tiene un espíritu mudo."
,"18":"En cualquier momento el espíritu se apodera de él, lo tira al suelo y el niño echa espuma por la boca, rechina los dientes y se queda rígido. Les pedí a tus discípulos que echaran ese espíritu, pero no pudieron.'"
,"19":"Les respondió: '¡Qué generación tan incrédula! ¿Hasta cuándo tendré que estar con ustedes? ¿Hasta cuándo tendré que soportarlos? Tráiganme al muchacho.'"
,"20":"Y se lo llevaron. Apenas vio a Jesús, el espíritu sacudió violentamente al muchacho; cayó al suelo y se revolcaba echando espuma por la boca. "
,"21":"Entonces Jesús preguntó al padre: '¿Desde cuándo le pasa esto?'"
,"22":"Le contestó: 'Desde niño. Y muchas veces el espíritu lo lanza al fuego y al agua para matarlo. Por eso, si puedes hacer algo, ten compasión de nosotros y ayúdanos.'"
,"23":"Jesús le dijo: '¿Por qué dices 'si puedes'? Todo es posible para el que cree.'"
,"24":"Al instante el padre gritó: 'Creo, ¡pero ayuda mi poca fe!'"
,"25":"Cuando Jesús vio que se amontonaba la gente, dijo al espíritu malo: 'Espíritu sordo y mudo, yo te lo ordeno: sal del muchacho y no vuelvas a entrar en él.'"
,"26":"El espíritu malo gritó y sacudió violentamente al niño; después, dando un terrible chillido, se fue. El muchacho quedó como muerto, tanto que muchos decían que estaba muerto."
,"27":"Pero Jesús lo tomó de la mano y le ayudó a levantarse, y el muchacho se puso de pie."
,"28":"Ya dentro de casa, sus discípulos le preguntaron en privado: '¿Por qué no pudimos expulsar nosotros a ese espíritu?'"
,"29":"Y él les respondió: 'Esta clase de demonios no puede echarse sino mediante la oración.'"
,"30":"Se marcharon de allí y se desplazaban por Galilea. Jesús quería que nadie lo supiera,"
,"31":"porque iba enseñando a sus discípulos. Y les decía: 'El Hijo del Hombre va a ser entregado en manos de los hombres, y lo harán morir, pero tres días después de su muerte resucitará.'"
,"32":"De todos modos los discípulos no entendían lo que les hablaba, y tenían miedo de preguntarle qué quería decir."
,"33":"Llegaron a Cafarnaún, y una vez en casa, Jesús les preguntó: '¿De qué venían discutiendo por el camino?'"
,"34":"Ellos se quedaron callados, pues habían discutido entre sí sobre quién era el más importante de todos."
,"35":"Entonces se sentó, llamó a los Doce y les dijo: 'Si alguno quiere ser el primero, que se haga el último y el servidor de todos.'"
,"36":"Después tomó a un niño, lo puso en medio de ellos, lo abrazó y les dijo:"
,"37":"'El que recibe a un niño como éste en mi nombre, me recibe a mí; y el que me recibe, no me recibe a mí, sino al que me ha enviado.'"
,"38":"Juan le dijo: 'Maestro, hemos visto a uno que hacía uso de tu nombre para expulsar demonios, y hemos tratado de impedírselo porque no anda con nosotros.'"
,"39":"Jesús contestó: 'No se lo prohíban, ya que nadie puede hacer un milagro en mi nombre y luego hablar mal de mí."
,"40":"El que no está contra nosotros está con nosotros."
,"41":"Y cualquiera que les dé de beber un vaso de agua porque son de Cristo, yo les aseguro que no quedará sin recompensa.'"
,"42":"'El que haga caer a uno de estos pequeños que creen en mí, sería mejor para él que le ataran al cuello una gran piedra de moler y lo echaran al mar."
,"43":"Si tu mano te está haciendo caer, córtatela; pues es mejor para ti entrar con una sola mano en la vida, que ir con las dos a la gehenna, al fuego que no se apaga."
,"44":"Y si tu pie te está haciendo caer, córtatelo;"
,"45":"pues es mejor para ti entrar cojo en la vida que ser arrojado con los dos pies a la gehenna."
,"46":"Y si tu ojo prepara tu caída, sácatelo;"
,"47":"pues es mejor para ti entrar con un solo ojo en el Reino de Dios que ser arrojado con los dos al infierno,"
,"48":"donde su gusano no muere y el fuego no se apaga."
,"49":"Pues el mismo fuego los conservará."
,"50":"La sal es buena, pero si la sal pierde su sabor, ¿con qué se lo devolverán? Tengan sal en ustedes y vivan en paz unos con otros.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Jesús dejó aquel lugar y se fue a los límites de Judea, al otro lado del Jordán. Otra vez las muchedumbres se congregaron a su alrededor, y de nuevo se puso a enseñarles, como hacía siempre."
,"2":"En eso llegaron unos (fariseos que querían ponerle a prueba,) y le preguntaron: '¿Puede un marido despedir a su esposa?'"
,"3":"Les respondió: '¿Qué les ha ordenado Moisés?'"
,"4":"Contestaron: 'Moisés ha permitido firmar un acta de separación y después divorciarse.'"
,"5":"Jesús les dijo: 'Moisés, al escribir esta ley, tomó en cuenta lo tercos que eran ustedes."
,"6":"Pero al principio de la creación Dios los hizo hombre y mujer;"
,"7":"por eso dejará el hombre a su padre y a su madre para unirse con su esposa,"
,"8":"y serán los dos una sola carne. De manera que ya no son dos, sino uno solo."
,"9":"Pues bien, lo que Dios ha unido, que el hombre no lo separe.'"
,"10":"Cuando ya estaban en casa, los discípulos volvieron a preguntarle sobre lo mismo,"
,"11":"y él les dijo: 'El que se separa de su esposa y se casa con otra mujer, comete adulterio contra su esposa;"
,"12":"y si la esposa abandona a su marido para casarse con otro hombre, también ésta comete adulterio.'"
,"13":"Algunas personas le presentaban los niños para que los tocara, pero los discípulos les reprendían."
,"14":"Jesús, al ver esto, se indignó y les dijo: 'Dejen que los niños vengan a mí y no se lo impidan, porque el Reino de Dios pertenece a los que son como ellos."
,"15":"En verdad les digo: quien no reciba el Reino de Dios como un niño, no entrará en él.'"
,"16":"Jesús tomaba a los niños en brazos e, imponiéndoles las manos, los bendecía."
,"17":"Jesús estaba a punto de partir, cuando un hombre corrió a su encuentro, se arrodilló delante de él y le preguntó: 'Maestro bueno, ¿qué tengo que hacer para conseguir la vida eterna?'"
,"18":"Jesús le dijo: '¿Por qué me llamas bueno? Nadie es bueno, sino sólo Dios."
,"19":"Ya conoces los mandamientos: No mates, no cometas adulterio, no robes, no digas cosas falsas de tu hermano, no seas injusto, honra a tu padre y a tu madre.'"
,"20":"El hombre le contestó: 'Maestro, todo eso lo he practicado desde muy joven.'"
,"21":"Jesús fijó su mirada en él, le tomó cariño y le dijo: 'Sólo te falta una cosa: vete, vende todo lo que tienes y reparte el dinero entre los pobres, y tendrás un tesoro en el Cielo. Después, ven y sígueme.'"
,"22":"Al oír esto se desanimó totalmente, pues era un hombre muy rico, y se fue triste."
,"23":"Entonces Jesús paseó su mirada sobre sus discípulos y les dijo: '¡Qué difícilmente entrarán en el Reino de Dios los que tienen riquezas!'"
,"24":"Los discípulos se sorprendieron al oír estas palabras, pero Jesús insistió: 'Hijos, ¡qué difícil es entrar en el Reino de Dios!"
,"25":"Es más fácil para un camello pasar por el ojo de una aguja que para un rico entrar en el Reino de Dios.'"
,"26":"Ellos se asombraron todavía más y comentaban: 'Entonces, ¿quién podrá salvarse?'"
,"27":"Jesús los miró fijamente y les dijo: 'Para los hombres es imposible, pero no para Dios, porque para Dios todo es posible.'"
,"28":"Entonces Pedro le dijo: 'Nosotros lo hemos dejado todo para seguirte.'"
,"29":"Y Jesús contestó: 'En verdad les digo: Ninguno que haya dejado casa, hermanos, hermanas, madre, padre, hijos o campos por mi causa y por el Evangelio quedará sin recompensa."
,"30":"Pues, aun con persecuciones, recibirá cien veces más en la presente vida en casas, hermanos, hermanas, hijos y campos, y en el mundo venidero la vida eterna."
,"31":"Entonces muchos que ahora son primeros serán últimos, y los que son ahora últimos serán primeros.'"
,"32":"Continuaron el camino subiendo a Jerusalén, y Jesús marchaba delante de ellos. Los discípulos estaban desconcertados, y los demás que lo seguían tenían miedo. Otra vez Jesús reunió a los Doce para decirles lo que le iba a pasar:"
,"33":"'Estamos subiendo a Jerusalén y el Hijo del Hombre va a ser entregado a los jefes de los sacerdotes y a los maestros de la Ley; lo condenarán a muerte y lo entregarán a los extranjeros,"
,"34":"que se burlarán de él, le escupirán, lo azotarán y lo matarán. Pero tres días después resucitará.'"
,"35":"Santiago y Juan, hijos de Zebedeo, se acercaron a Jesús y le dijeron: 'Maestro, queremos que nos concedas lo que te vamos a pedir.'"
,"36":"El les dijo: '¿Qué quieren de mí?'"
,"37":"Respondieron: 'Concédenos que nos sentemos uno a tu derecha y otro a tu izquierda cuando estés en tu gloria.'"
,"38":"Jesús les dijo: 'Ustedes no saben lo que piden. ¿Pueden beber la copa que yo estoy bebiendo o ser bautizados como yo soy bautizado?'"
,"39":"Ellos contestaron: 'Sí, podemos.' Jesús les dijo: 'Pues bien, la copa que voy a beber yo, la beberán también ustedes, y serán bautizados con el mismo bautismo que voy a recibir yo;"
,"40":"pero el sentarse a mi derecha o a mi izquierda no me corresponde a mí el concederlo; eso ha sido preparado para otros.'"
,"41":"Cuando los otros diez oyeron esto, se enojaron con Santiago y Juan."
,"42":"Jesús los llamó y les dijo: 'Como ustedes saben, los que se consideran jefes de las naciones actúan como dictadores, y los que ocupan cargos abusan de su autoridad."
,"43":"Pero no será así entre ustedes. Por el contrario, el que quiera ser el más importante entre ustedes, debe hacerse el servidor de todos,"
,"44":"y el que quiera ser el primero, se hará esclavo de todos."
,"45":"Sepan que el Hijo del Hombre no ha venido para ser servido, sino para servir y dar su vida como rescate por una muchedumbre.'"
,"46":"Llegaron a Jericó. Al salir Jesús de allí con sus discípulos y con bastante más gente, un limosnero ciego se encontraba a la orilla del camino. Se llamaba Bartimeo (hijo de Timeo)."
,"47":"Al enterarse de que era Jesús de Nazaret el que pasaba, empezó a gritar: '¡Jesús, Hijo de David, ten compasión de mí!'"
,"48":"Muchas personas trataban de hacerlo callar. Pero él gritaba con más fuerza: '¡Hijo de David, ten compasión de mí!'"
,"49":"Jesús se detuvo y dijo: 'Llámenlo.' Llamaron, pues, al ciego diciéndole: 'Vamos, levántate, que te está llamando.'"
,"50":"Y él, arrojando su manto, se puso en pie de un salto y se acercó a Jesús."
,"51":"Jesús le preguntó: '¿Qué quieres que haga por ti?' El ciego respondió: 'Maestro, que vea.'"
,"52":"Entonces Jesús le dijo: 'Puedes irte, tu fe te ha salvado.' Y al instante pudo ver y siguió a Jesús por el camino."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Cuando se aproximaban a Jerusalén, cerca ya de Betfagé y de Betania, al pie del monte de los Olivos, Jesús envió a dos de sus discípulos"
,"2":"diciéndoles: 'Vayan a ese pueblo que ven enfrente; apenas entren encontrarán un burro amarrado, que ningún hombre ha montado todavía. Desátenlo y tráiganlo aquí."
,"3":"Si alguien les pregunta: ¿Por qué hacen eso?, contesten: El Señor lo necesita, pero se lo devolverá cuanto antes.'"
,"4":"Se fueron y encontraron en la calle al burro, amarrado delante de una puerta, y lo desataron."
,"5":"Algunos de los que estaban allí les dijeron: '¿Por qué sueltan ese burro?'"
,"6":"Ellos les contestaron lo que les había dicho Jesús, y se lo permitieron."
,"7":"Trajeron el burro a Jesús, le pusieron sus capas encima y Jesús montó en él."
,"8":"Muchas personas extendían sus capas a lo largo del camino, mientras otras lo cubrían con ramas cortadas en el campo."
,"9":"Y tanto los que iban delante como los que seguían a Jesús gritaban: '¡Hosanna! ¡Bendito el que viene en nombre del Señor!"
,"10":"¡Ahí viene el bendito reino de nuestro padre David! ¡Hosanna en las alturas!'"
,"11":"Entró Jesús en Jerusalén y se fue al Templo. Observó todo a su alrededor y, siendo ya tarde, salió con los Doce para volver a Betania."
,"12":"Al día siguiente, cuando salían de Betania, sintió hambre."
,"13":"A lo lejos divisó una higuera llena de hojas, y fue a ver si encontraba algo en ella. Se acercó, pero no encontró más que hojas, pues todavía no era tiempo de higos."
,"14":"Entonces Jesús dijo a la higuera: '¡Que nadie coma fruto de ti nunca jamás!' Y sus discípulos lo oyeron."
,"15":"Llegaron a Jerusalén, y Jesús fue al Templo. Comenzó a echar fuera a los que se dedicaban a vender y a comprar dentro del recinto mismo. Volcaba las mesas de los que cambiaban dinero y los puestos de los vendedores de palomas,"
,"16":"y no permitía a nadie transportar cosas por el Templo."
,"17":"Luego se puso a enseñar y les dijo: '¿No dice Dios en la Escritura: Mi casa será llamada casa de oración para todas las naciones? ¡Pero ustedes la han convertido en una guarida de ladrones!'"
,"18":"Los jefes de los sacerdotes y los maestros de la Ley se enteraron de lo ocurrido y pensaron deshacerse de él; le tenían miedo al ver el impacto que su enseñanza producía sobre el pueblo."
,"19":"Cada día salían de la ciudad al anochecer."
,"20":"Cuando pasaban de madrugada, los discípulos vieron la higuera, que estaba seca hasta la raíz."
,"21":"Pedro se acordó, y dijo a Jesús: 'Maestro, mira, la higuera que maldijiste se ha secado.'"
,"22":"Jesús respondió: 'Tengan fe en Dios."
,"23":"Yo les aseguro que el que diga a ese cerro: ¡Levántate de ahí y arrójate al mar!, si no duda en su corazón y cree que sucederá como dice, se le concederá."
,"24":"Por eso les digo: todo lo que pidan en la oración, crean que ya lo han recibido y lo obtendrán."
,"25":"Y cuando se pongan de pie para orar, si tienen algo contra alguien, perdónenlo,"
,"26":"para que su Padre del Cielo les perdone también a ustedes sus faltas.'"
,"27":"Volvieron a Jerusalén, y mientras Jesús estaba caminando por el Templo, se le acercaron los jefes de los sacerdotes, los maestros de la Ley y las autoridades judías,"
,"28":"y le preguntaron: '¿Con qué derecho has actuado de esa forma? ¿Quién te ha autorizado a hacer lo que haces?'"
,"29":"Jesús les contestó: 'Les voy a hacer yo a ustedes una sola pregunta, y si me contestan, les diré con qué derecho hago lo que hago. Háblenme"
,"30":"del bautismo de Juan. Este asunto ¿venía de Dios o era cosa de los hombres?"
,"31":"Ellos comentaron entre sí: 'Si decimos que este asunto era obra de Dios, nos dirá: Entonces, ¿por qué no le creyeron?'"
,"32":"Pero tampoco podían decir delante del pueblo que era cosa de hombres, porque todos consideraban a Juan como un profeta."
,"33":"Por eso respondieron a Jesús: 'No lo sabemos.' Y Jesús les contestó: 'Entonces tampoco yo les diré con qué autoridad hago estas cosas.'"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Jesús entonces les dirigió estas parábolas: 'Un hombre plantó una viña, la rodeó de una cerca, cavó en ella un lagar y construyó una casa para el celador. La alquiló después a unos trabajadores y se marchó al extranjero."
,"2":"A su debido tiempo envió a un sirviente para pedir a los viñadores la parte de los frutos que le correspondían."
,"3":"Pero ellos lo tomaron, lo apalearon y lo despacharon con las manos vacías."
,"4":"Envió de nuevo a otro servidor, y a éste lo hirieron en la cabeza y lo insultaron."
,"5":"Mandó a un tercero, y a éste lo mataron. Y envió a muchos otros, pero a unos los hirieron y a otros los mataron."
,"6":"Todavía le quedaba uno: ése era su hijo muy querido. Lo mandó por último, pensando: 'A mi hijo lo respetarán.'"
,"7":"Pero los viñadores se dijeron entre sí: 'Este es el heredero, la viña será para él; matémosle y así nos quedaremos con la propiedad.'"
,"8":"Tomaron al hijo, lo mataron y lo arrojaron fuera de la viña."
,"9":"Ahora bien, ¿qué va a hacer el dueño de la viña? Vendrá, matará a esos trabajadores y entregará la viña a otros.'"
,"10":"Y Jesús añadió: '¿No han leído el pasaje de la Escritura que dice: La piedra que rechazaron los constructores ha llegado a ser la piedra principal del edificio."
,"11":"Esta es la obra del Señor, y nos dejó maravillados?'"
,"12":"Los jefes querían apresar a Jesús, pero tuvieron miedo al pueblo; habían entendido muy bien que la parábola se refería a ellos. Lo dejaron allí y se fueron."
,"13":"Querían pillar a Jesús en algo que dijera. Con ese fin le enviaron algunos fariseos junto con partidarios de Herodes."
,"14":"Y dijeron a Jesús: 'Maestro, sabemos que eres sincero y que no te inquietas por los que te escuchan, sino que enseñas con franqueza el camino de Dios. Dinos, ¿es contrario a la Ley pagar el impuesto al César? ¿Tenemos que pagarlo o no?'"
,"15":"Pero Jesús vio su hipocresía y les dijo: '¿Por qué me ponen trampas? Tráiganme una moneda, que yo la vea.'"
,"16":"Le mostraron un denario, y Jesús les preguntó: '¿De quién es esta cara y lo que está escrito?' Ellos le respondieron: 'Del César.'"
,"17":"Entonces Jesús les dijo: 'Devuelvan al César las cosas del César, y a Dios lo que corresponde a Dios.' Jesús los dejó muy sorprendidos."
,"18":"Entonces se presentaron algunos saduceos. Esta gente defiende que no hay resurrección de los muertos, y por eso le preguntaron:"
,"19":"'Maestro, según la ley de Moisés, si un hombre muere antes que su esposa sin tener hijos, su hermano debe casarse con la viuda para darle un hijo, que será el heredero del difunto."
,"20":"Pues bien, había siete hermanos: el mayor se casó y murió sin tener hijos."
,"21":"El segundo se casó con la viuda y murió también sin dejar herederos, y así el tercero."
,"22":"Y pasó lo mismo con los siete hermanos. Después de todos ellos murió también la mujer."
,"23":"En el día de la resurrección, si han de resucitar, ¿de cuál de ellos será esposa? Pues los siete la tuvieron como esposa.'"
,"24":"Jesús les contestó: 'Ustedes están equivocados; a lo mejor no entienden la Escritura y tampoco el poder de Dios."
,"25":"Pues cuando resuciten de la muerte, ya no se casarán hombres y mujeres, sino que serán en el cielo como los ángeles."
,"26":"Y en cuanto a saber si los muertos resucitan, ¿no han leído en el libro de Moisés, en el capítulo de la zarza, cómo Dios le dijo: Yo soy el Dios de Abraham, el Dios de Isaac y el Dios de Jacob?"
,"27":"Dios no es un Dios de muertos, sino de vivos. Ustedes están muy equivocados.'"
,"28":"Entonces se adelantó un maestro de la Ley. Había escuchado la discusión y estaba admirado de cómo Jesús les había contestado. Entonces le preguntó: '¿Qué mandamiento es el primero de todos?'"
,"29":"Jesús le contestó: 'El primer mandamiento es: Escucha, Israel: El Señor nuestro Dios es un único Señor."
,"30":"Amarás al Señor tu Dios con todo tu corazón, con toda tu alma, con toda tu inteligencia y con todas tus fuerzas."
,"31":"Y después viene este otro: Amarás a tu prójimo como a ti mismo. No hay ningún mandamiento más importante que éstos.'"
,"32":"El maestro de la Ley le contestó: 'Has hablado muy bien, Maestro; tienes razón cuando dices que el Señor es único y que no hay otro fuera de él,"
,"33":"y que amarlo con todo el corazón, con toda la inteligencia y con todas las fuerzas y amar al prójimo como a sí mismo vale más que todas las víctimas y sacrificios.'"
,"34":"Jesús vio que ésta era respuesta sabia y le dijo: 'No estás lejos del Reino de Dios.' Y después de esto, nadie más se atrevió a hacerle nuevas preguntas."
,"35":"Mientras Jesús enseñaba en el Templo, preguntó: '¿Por qué los maestros de la Ley dicen que el Mesías será el hijo de David?"
,"36":"Porque el mismo David dijo, hablando por el Espíritu Santo: Dijo el Señor a mi Señor: Siéntate a mi derecha hasta que ponga a tus enemigos debajo de tus pies."
,"37":"Si David mismo lo llama 'Señor', ¿cómo puede entonces ser hijo suyo?',Mucha gente acudía a Jesús y lo escuchaba con agrado."
,"38":"En su enseñanza Jesús les decía también: 'Cuídense de esos maestros de la Ley"
,"39":"a quienes les gusta pasear con sus amplias vestiduras, ser saludados en las plazas y ocupar asientos reservados en las sinagogas y en los banquetes;"
,"40":"incluso devoran los bienes de las viudas, mientras se amparan detrás de largas oraciones. ¡Con qué severidad serán juzgados!'"
,"41":"Jesús se había sentado frente a las alcancías del Templo, y podía ver cómo la gente echaba dinero para el tesoro; pasaban ricos, y daban mucho,"
,"42":"pero también se acercó una viuda pobre y echó dos moneditas de muy poco valor."
,"43":"Jesús entonces llamó a sus discípulos y les dijo: 'Yo les aseguro que esta viuda pobre ha dado más que todos los otros."
,"44":"Pues todos han echado de lo que les sobraba, mientras ella ha dado desde su pobreza; no tenía más, y dio todos sus recursos.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Cuando Jesús salió del Templo, uno de sus discípulos le dijo: 'Maestro, mira qué inmensas piedras y qué construcciones.'"
,"2":"Jesús le respondió: '¿Ves esas grandiosas construcciones? Pues no quedará de ellas piedra sobre piedra. Todo será destruido.'"
,"3":"Poco después Jesús se sentó en el monte de los Olivos, frente al Templo, y entonces Pedro, Santiago, Juan y Andrés le preguntaron en privado:"
,"4":"'Dinos cuándo sucederá eso y qué señales habrá antes de que ocurran todas esas cosas.'"
,"5":"Y Jesús empezó a decirles: 'Estén sobre aviso y no se dejen engañar."
,"6":"Porque muchos reivindicarán lo que es mío, y dirán: 'Yo soy el que están esperando', y engañarán a muchos."
,"7":"Cuando oigan hablar de guerras y de rumores de guerra, no se alarmen, porque eso tiene que pasar, pero todavía no será el fin."
,"8":"Habrá conflictos: nación contra nación, y reino contra reino. Habrá terremotos y hambre en diversos lugares. Estos serán los primeros dolores del parto."
,"9":"Pero ustedes preocúpense de sí mismos, porque van a ser apresados y entregados a los tribunales judíos, serán azotados en las sinagogas y tendrán que presentarse ante los gobernadores y reyes por mi causa, para ser mis testigos ante ellos."
,"10":"Porque primero el Evangelio tiene que ser proclamado en todas las naciones."
,"11":"Cuando sean arrestados y los entreguen a los tribunales, no se preocupen por lo que van a decir, sino digan lo que se les inspire en ese momento; porque no serán ustedes los que hablarán, sino el Espíritu Santo."
,"12":"El hermano entregará a la muerte al hermano y el padre al hijo; los hijos se rebelarán contra sus padres y les darán muerte."
,"13":"Y serán odiados por todos a causa de mi nombre. Pero el que se mantenga firme hasta el fin se salvará."
,"14":"Cuando vean al ídolo del opresor instalado en el lugar donde no debe estar (el que lea, que entienda bien), entonces los que estén en Judea huyan a los cerros."
,"15":"Si estás en la parte superior de la casa, no bajes a recoger tus cosas."
,"16":"Si estás en el campo, no vuelvas a buscar tus ropas."
,"17":"¡Pobres de las mujeres que estén embarazadas o estén criando en aquellos días!"
,"18":"Oren para que esto no suceda en invierno."
,"19":"Porque en aquellos días habrá tal angustia como no hubo otra igual desde el principio de la creación hasta los días presentes, ni la habrá en el futuro."
,"20":"Tanto que si el Señor no acortara esos días, nadie se salvaría. Pero él ha decidido acortar esos días en consideración a sus elegidos."
,"21":"Si alguien entonces les dice: Mira, el Cristo está aquí o está allá, no lo crean."
,"22":"Aparecerán falsos mesías y falsos profetas, que harán señales y prodigios capaces de engañar incluso a los elegidos, si esto fuera posible."
,"23":"Estén alerta, yo se lo he advertido todo."
,"24":"Después de esa angustia llegarán otros días; entonces el sol dejará de alumbrar, la luna perderá su brillo,"
,"25":"las estrellas caerán del cielo y el universo entero se conmoverá."
,"26":"Y verán venir al Hijo del Hombre en medio de las nubes con gran poder y gloria."
,"27":"Enviará a los ángeles para reunir a sus elegidos de los cuatro puntos cardinales, desde el extremo de la tierra hasta el extremo del cielo."
,"28":"Aprendan de este ejemplo de la higuera: cuando las ramas están tiernas y brotan las hojas, saben que el verano está cerca."
,"29":"Así también ustedes, cuando vean que suceden estas cosas, sepan que todo se acerca, que ya está a las puertas."
,"30":"En verdad les digo que no pasará esta generación sin que ocurra todo eso."
,"31":"El cielo y la tierra pasarán, pero mis palabras no pasarán."
,"32":"Por lo que se refiere a ese Día y cuándo vendrá, no lo sabe nadie, ni los ángeles en el Cielo, ni el Hijo, sino solamente el Padre."
,"33":"Estén preparados y vigilando, porque no saben cuándo llegará ese momento."
,"34":"Cuando un hombre va al extranjero y deja su casa, entrega responsabilidades a sus sirvientes, cada cual recibe su tarea, y al portero le exige que esté vigilante."
,"35":"Lo mismo ustedes: estén vigilantes, porque no saben cuándo regresará el dueño de casa, si al atardecer, a medianoche, al canto del gallo o de madrugada;"
,"36":"no sea que llegue de repente y los encuentre dormidos."
,"37":"Lo que les digo a ustedes se lo digo a todos: Estén despiertos.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Faltaban dos días para la Fiesta de Pascua y de los Panes Azimos. Los jefes de los sacerdotes y los maestros de la Ley buscaban la manera de detener a Jesús con astucia para darle muerte,"
,"2":"pero decían: 'No durante la fiesta, para que no se alborote el pueblo.'"
,"3":"Jesús estaba en Betania, en casa de Simón el Leproso. Mientras estaban comiendo, entró una mujer con un frasco precioso como de mármol, lleno de un perfume muy caro, de nardo puro; quebró el cuello del frasco y derramó el perfume sobre la cabeza de Jesús."
,"4":"Entonces algunos se indignaron y decían entre sí: '¿Cómo pudo derrochar este perfume?"
,"5":"Se podría haber vendido en más de trescientas monedas de plata para ayudar a los pobres.' Y estaban enojados contra ella."
,"6":"Pero Jesús dijo: 'Déjenla tranquila. ¿Por qué la molestan? Lo que ha hecho conmigo es una obra buena."
,"7":"Siempre tienen a los pobres con ustedes y en cualquier momento podrán ayudarlos, pero a mí no me tendrán siempre."
,"8":"Esta mujer ha hecho lo que tenía que hacer, pues de antemano ha ungido mi cuerpo para la sepultura."
,"9":"En verdad les digo: dondequiera que se proclame el Evangelio, en todo el mundo, se contará también su gesto y será su gloria.'"
,"10":"Entonces Judas Iscariote, uno de los Doce, fue donde los jefes de los sacerdotes para entregarles a Jesús."
,"11":"Se felicitaron por el asunto y prometieron darle dinero. Y Judas comenzó a buscar el momento oportuno para entregarlo."
,"12":"El primer día de la fiesta en que se comen los panes sin levadura, cuando se sacrificaba el Cordero Pascual, sus discípulos le dijeron: '¿Dónde quieres que vayamos a prepararte la Cena de la Pascua?'"
,"13":"Entonces Jesús mandó a dos de sus discípulos y les dijo: 'Vayan a la ciudad, y les saldrá al encuentro un hombre que lleva un cántaro de agua. Síganlo"
,"14":"hasta la casa en que entre y digan al dueño: El Maestro dice: ¿Dónde está mi pieza, en que podré comer la Pascua con mis discípulos?"
,"15":"El les mostrará en el piso superior una pieza grande, amueblada y ya lista. Preparen todo para nosotros.'"
,"16":"Los discípulos se fueron, entraron en la ciudad, encontraron las cosas tal como Jesús les había dicho y prepararon la Pascua."
,"17":"Al atardecer llegó Jesús con los Doce."
,"18":"Y mientras estaban a la mesa comiendo, les dijo: 'Les aseguro que uno de ustedes me va a entregar, uno que comparte mi pan.'"
,"19":"Ellos se entristecieron mucho al oírle, y empezaron a preguntarle uno a uno: '¿Seré yo?'"
,"20":"El les respondió: 'Es uno de los Doce, uno que moja su pan en el plato conmigo."
,"21":"El Hijo del Hombre se va, conforme dijeron de él las Escrituras, pero ¡pobre de aquel que entrega al Hijo del Hombre! Sería mucho mejor para él no haber nacido.'"
,"22":"Durante la comida Jesús tomó pan, y después de pronunciar la bendición, lo partió y se lo dio diciendo: 'Tomen, esto es mi cuerpo.'"
,"23":"Tomó luego una copa, y después de dar gracias, se la entregó, y todos bebieron de ella."
,"24":"Y les dijo: 'Esto es mi sangre, la sangre de la Alianza, que será derramada por una muchedumbre."
,"25":"En verdad les digo que no volveré a probar el zumo de cepas hasta el día en que lo beba nuevo en el Reino de Dios.'"
,"26":"Después de cantar los himnos se dirigieron al monte de los Olivos."
,"27":"Y Jesús les dijo: 'Todos ustedes caerán esta noche, pues dice la Escritura: Heriré al pastor y se dispersarán las ovejas."
,"28":"Pero cuando resucite, iré delante de ustedes a Galilea.'"
,"29":"Entonces Pedro le dijo: 'Aunque todos tropiecen y caigan, yo no.'"
,"30":"Jesús le contestó: 'En verdad te digo que hoy, esta misma noche, antes de que el gallo cante por segunda vez, me habrás negado tres veces.'"
,"31":"Pero él insistía: 'Aunque tenga que morir contigo, no te negaré.' Y todos decían lo mismo."
,"32":"Llegaron a un lugar llamado Getsemaní, y Jesús dijo a sus discípulos: 'Siéntense aquí mientras voy a orar.'"
,"33":"Y llevó consigo a Pedro, a Santiago y a Juan. Comenzó a llenarse de temor y angustia,"
,"34":"y les dijo: 'Siento en mi alma una tristeza de muerte. Quédense aquí y permanezcan despiertos.'"
,"35":"Jesús se adelantó un poco, y cayó en tierra suplicando que, si era posible, no tuviera que pasar por aquella hora."
,"36":"Decía: 'Abbá, o sea, Padre, si para ti todo es posible, aparta de mí esta copa. Pero no se haga lo que yo quiero, sino lo que quieres tú.'"
,"37":"Volvió y los encontró dormidos. Y dijo a Pedro: 'Simón, ¿duermes? ¿De modo que no pudiste permanecer despierto una hora?"
,"38":"Estén despiertos y oren para no caer en la tentación; pues el espíritu es animoso, pero la carne es débil.'"
,"39":"Y se alejó de nuevo a orar, repitiendo las mismas palabras."
,"40":"Al volver otra vez, los encontró de nuevo dormidos, pues no podían resistir el sueño y no sabían qué decirle."
,"41":"Vino por tercera vez, y les dijo: 'Ahora ya pueden dormir y descansar. Está hecho, llegó la hora. El Hijo del Hombre va a ser entregado en manos de los pecadores."
,"42":"¡Levántense, vámonos!, ya viene el que me va a entregar.'"
,"43":"Jesús estaba aún hablando cuando se presentó Judas, uno de los Doce; lo acompañaba un buen grupo de gente con espadas y palos, enviados por los jefes de los sacerdotes, los maestros de la Ley y los jefes judíos."
,"44":"El traidor les había dado esta señal: 'Al que yo dé un beso, ése es; deténganlo y llévenlo bien custodiado.'"
,"45":"Apenas llegó Judas, se acercó a Jesús y le dijo: '¡Maestro, Maestro!' Y lo besó."
,"46":"Ellos entonces lo tomaron y se lo llevaron arrestado."
,"47":"En ese momento uno de los que estaban con Jesús sacó la espada e hirió al servidor del Sumo Sacerdote cortándole una oreja."
,"48":"Jesús dijo a la gente: 'A lo mejor buscan a un ladrón y por eso han salido a detenerme con espadas y palos."
,"49":"¿Por qué no me detuvieron cuando día tras día estaba entre ustedes enseñando en el Templo? Pero tienen que cumplirse las Escrituras.'"
,"50":"Y todos los que estaban con Jesús lo abandonaron y huyeron."
,"51":"Un joven seguía a Jesús envuelto sólo en una sábana, y lo tomaron;"
,"52":"pero él, soltando la sábana, huyó desnudo."
,"53":"Llevaron a Jesús ante el Sumo Sacerdote, y todos se reunieron allí. Estaban los jefes de los sacerdotes, las autoridades judías y los maestros de la Ley."
,"54":"Pedro lo había seguido de lejos hasta el patio interior del Sumo Sacerdote, y se sentó con los policías del Templo, calentándose al fuego."
,"55":"Los jefes de los sacerdotes y todo el Consejo Supremo buscaban algún testimonio que permitiera condenar a muerte a Jesús, pero no lo encontraban."
,"56":"Varios se presentaron con falsas acusaciones contra él, pero no estaban de acuerdo en lo que decían."
,"57":"Algunos lanzaron esta falsa acusación:"
,"58":"'Nosotros le hemos oído decir: Yo destruiré este Templo hecho por la mano del hombre, y en tres días construiré otro no hecho por hombres.'"
,"59":"Pero tampoco con estos testimonios estaban de acuerdo."
,"60":"Entonces el Sumo Sacerdote se levantó, pasó adelante y preguntó a Jesús: '¿No tienes nada que responder? ¿Qué es este asunto de que te acusan?'"
,"61":"Pero él guardaba silencio y no contestaba. De nuevo el Sumo Sacerdote le preguntó: '¿Eres tú el Mesías, el Hijo de Dios Bendito?'."
,"62":"Jesús respondió: 'Yo soy, y un día verán al Hijo del Hombre sentado a la derecha de Dios poderoso y viniendo en medio de las nubes del cielo.'"
,"63":"El Sumo Sacerdote rasgó sus vestiduras horrorizado y dijo: '¿Para qué queremos ya testigos?"
,"64":"Ustedes acaban de oír sus palabras blasfemas. ¿Qué les parece?' Y estuvieron de acuerdo en que merecía la pena de muerte."
,"65":"Después algunos empezaron a escupirle. Le cubrieron la cara y le golpeaban antes de decirle: '¡Hazte el profeta!' Y los policías del Templo lo abofeteaban."
,"66":"Mientras Pedro estaba abajo, en el patio, pasó una de las sirvientas del Sumo Sacerdote."
,"67":"Al verlo cerca del fuego, lo miró fijamente y le dijo: 'Tú también andabas con Jesús de Nazaret.'"
,"68":"El lo negó: 'No lo conozco, ni entiendo de qué hablas.' Y salió al portal."
,"69":"Pero lo vio la sirvienta y otra vez dijo a los presentes: 'Este es uno de ellos.'"
,"70":"Y Pedro lo volvió a negar. Después de un rato, los que estaban allí dijeron de nuevo a Pedro: 'Es evidente que eres uno de ellos, pues eres galileo.'"
,"71":"Entonces se puso a maldecir y a jurar: 'Yo no conozco a ese hombre de quien ustedes hablan.'"
,"72":"En ese momento se escuchó el segundo canto del gallo. Pedro recordó lo que Jesús le había dicho: 'Antes de que el gallo cante dos veces, tú me habrás negado tres', y se puso a llorar."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Muy temprano, los jefes de los sacerdotes, los ancianos y los maestros de la Ley (es decir, todo el Consejo o Sanedrín) celebraron consejo. Después de atar a Jesús con cadenas, lo llevaron y lo entregaron a Pilato."
,"2":"Pilato le preguntó: '¿Eres tú el rey de los judíos?' Jesús respondió: 'Así es, como tú lo dices.'"
,"3":"Como los jefes de los sacerdotes acusaban a Jesús de muchas cosas,"
,"4":"Pilato volvió a preguntarle: '¿No contestas nada? ¡Mira de cuántas cosas te acusan!'"
,"5":"Pero Jesús ya no le respondió, de manera que Pilato no sabía qué pensar."
,"6":"Cada año, con ocasión de la Pascua, Pilato solía dejar en libertad a un preso, a elección del pueblo."
,"7":"Había uno, llamado Barrabás, que había sido encarcelado con otros revoltosos por haber cometido un asesinato en un motín."
,"8":"Cuando el pueblo subió y empezó a pedir la gracia como de costumbre,"
,"9":"Pilato les preguntó: '¿Quieren que ponga en libertad al rey de los judíos?'"
,"10":"Pues Pilato veía que los jefes de los sacerdotes le entregaban a Jesús por una cuestión de rivalidad."
,"11":"Pero los sumos sacerdotes incitaron a la gente a que pidiera la libertad de Barrabás."
,"12":"Pilato les dijo: '¿Qué voy a hacer con el que ustedes llaman rey de los judíos?'"
,"13":"La gente gritó: '¡Crucifícalo!'"
,"14":"Pilato les preguntó: 'Pero ¿qué mal ha hecho?' Y gritaron con más fuerza: '¡Crucifícalo!'"
,"15":"Pilato quiso dar satisfacción al pueblo: dejó, pues, en libertad a Barrabás y sentenció a muerte a Jesús. Lo hizo azotar, y después lo entregó para que fuera crucificado."
,"16":"Los soldados lo llevaron al pretorio, que es el patio interior, y llamaron a todos sus compañeros."
,"17":"Lo vistieron con una capa roja y le colocaron en la cabeza una corona que trenzaron con espinas."
,"18":"Después comenzaron a saludarlo: '¡Viva el rey de los judíos!'"
,"19":"Y le golpeaban en la cabeza con una caña, le escupían y se arrodillaban ante él para rendirle homenaje."
,"20":"Después de haberse burlado de él, le quitaron la capa roja y le pusieron de nuevo sus ropas. Los soldados sacaron a Jesús fuera para crucificarlo. "
,"21":"En ese momento, un tal Simón de Cirene, el padre de Alejandro y de Rufo, volvía del campo; los soldados le obligaron a que llevara la cruz de Jesús."
,"22":"Lo llevaron al lugar llamado Gólgota, o Calvario, palabra que significa 'calavera'."
,"23":"Después de ofrecerle vino mezclado con mirra, que él no quiso tomar,"
,"24":"lo crucificaron y se repartieron sus ropas, sorteándolas entre ellos."
,"25":"Eran como las nueve de la mañana cuando lo crucificaron."
,"26":"Pusieron una inscripción con el motivo de su condena, que decía: 'El rey de los judíos.'"
,"27":"Crucificaron con él también a dos ladrones, uno a su derecha y otro a su izquierda."
,"28":"Así se cumplió la Escritura que dice: y fue contado entre los malhechores."
,"29":"Los que pasaban lo insultaban y decían moviendo la cabeza: 'Tú, que destruyes el Templo y lo levantas de nuevo en tres días,"
,"30":"sálvate a ti mismo y baja de la cruz.'"
,"31":"Igualmente los jefes de los sacerdotes y los maestros de la Ley se burlaban de él, y decían entre sí: 'Salvaba a los otros, pero no se salvará a sí mismo."
,"32":"Que ese Mesías, ese rey de Israel, baje ahora de la cruz: cuando lo veamos, creeremos.' Incluso lo insultaban los que estaban crucificados con él."
,"33":"Llegado el mediodía, la oscuridad cubrió todo el país hasta las tres de la tarde,"
,"34":"y a esa hora Jesús gritó con voz potente: 'Eloí, Eloí, lammá sabactani', que quiere decir: 'Dios mío, Dios mío, ¿por qué me has abandonado?'"
,"35":"Al oírlo, algunos de los que estaban allí dijeron: 'Está llamando a Elías.'"
,"36":"Uno de ellos corrió a mojar una esponja en vinagre, la puso en la punta de una caña y le ofreció de beber, diciendo: 'Veamos si viene Elías a bajarlo.'"
,"37":"Pero Jesús, dando un fuerte grito, expiró."
,"38":"En seguida la cortina que cerraba el santuario del Templo se rasgó en dos, de arriba abajo."
,"39":"Al mismo tiempo el capitán romano que estaba frente a Jesús, al ver cómo había expirado, dijo: 'Verdaderamente este hombre era hijo de Dios.'"
,"40":"Había unas mujeres que miraban de lejos, entre ellas María Magdalena, María, madre de Santiago el Menor y de José, y Salomé."
,"41":"Cuando Jesús estaba en Galilea, ellas lo seguían y lo servían. Con ellas estaban también otras más que habían subido con Jesús a Jerusalén."
,"42":"Había caído la tarde. Como era el día de la Preparación, es decir, la víspera del sábado,"
,"43":"intervino José de Arimatea. Ese miembro respetable del Consejo supremo era de los que esperaban el Reino de Dios, y fue directamente donde Pilato para pedirle el cuerpo de Jesús."
,"44":"Pilato se extrañó de que Jesús hubiera muerto tan pronto y llamó al centurión para saber si realmente era así."
,"45":"Después de escuchar al centurión, Pilato entregó a José el cuerpo de Jesús."
,"46":"José lo bajó de la cruz y lo envolvió en una sábana que había comprado, lo colocó en un sepulcro excavado en la roca e hizo rodar una piedra grande contra la entrada de la tumba."
,"47":"María Magdalena y María, la madre de José, estaban allí observando dónde lo depositaban."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Pasado el sábado, María Magdalena, María, la madre de Santiago, y Salomé, compraron aromas para embalsamar el cuerpo."
,"2":"Y muy temprano, el primer día de la semana, llegaron al sepulcro, apenas salido el sol. Se decían unas a otras:"
,"3":"'¿Quién nos quitará la piedra de la entrada del sepulcro?'"
,"4":"Pero cuando miraron, vieron que la piedra había sido retirada a un lado, a pesar de ser una piedra muy grande."
,"5":"Al entrar en el sepulcro, vieron a un joven sentado al lado derecho, vestido enteramente de blanco, y se asustaron."
,"6":"Pero él les dijo: 'No se asusten. Si ustedes buscan a Jesús Nazareno, el crucificado, no está aquí, ha resucitado; pero éste es el lugar donde lo pusieron."
,"7":"Ahora vayan a decir a los discípulos, y en especial a Pedro, que él se les adelanta camino de Galilea. Allí lo verán, tal como él les dijo.'"
,"8":"Las mujeres salieron corriendo del sepulcro. Estaban asustadas y asombradas, y no dijeron nada a nadie por el miedo que tenían."
,"9":"Jesús, pues, resucitó en la madrugada del primer día de la semana. Se apareció primero a María Magdalena, de la que había echado siete demonios."
,"10":"Ella fue a anunciárselo a los que habían sido compañeros de Jesús y que estaban tristes y lo lloraban."
,"11":"Pero al oírle decir que vivía y que lo había visto, no le creyeron."
,"12":"Después Jesús se apareció, bajo otra figura, a dos de ellos que se dirigían a un pueblito."
,"13":"Volvieron a contárselo a los demás, pero tampoco les creyeron."
,"14":"Por último se apareció a los once discípulos mientras comían, y los reprendió por su falta de fe y por su dureza para creer a los que lo habían visto resucitado."
,"15":"Y les dijo: 'Vayan por todo el mundo y anuncien la Buena Nueva a toda la creación."
,"16":"El que crea y se bautice se salvará, el que se niegue a creer se condenará."
,"17":"Estas señales acompañarán a los que crean: en mi Nombre echarán demonios y hablarán nuevas lenguas;"
,"18":"tomarán con sus manos serpientes y, si beben algún veneno, no les hará daño; impondrán las manos sobre los enfermos y quedarán sanos.'"
,"19":"Después de hablarles, el Señor Jesús fue llevado al cielo y se sentó a la derecha de Dios."
,"20":"Ellos, por su parte, salieron a predicar en todos los lugares. El Señor actuaba con ellos y confirmaba el mensaje con los milagros que lo acompañaban."
}`)

}
func ES_LBL_LoadNEMTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Libro de los orígenes de Jesucristo, hijo de David e hijo de Abrahán."
,"2":"Abrahán fue padre de Isaac, y éste de Jacob. Jacob fue padre de Judá y de sus hermanos."
,"3":"De la unión de Judá y de Tamar nacieron Farés y Zera. Farés fue padre de Esrón y Esrón de Aram."
,"4":"Aram fue padre de Aminadab, éste de Naasón y Naasón de Salmón."
,"5":"Salmón fue padre de Booz y Rahab su madre. Booz fue padre de Obed y Rut su madre. Obed fue padre de Jesé."
,"6":"Jesé fue padre del rey David. David fue padre de Salomón y su madre la que había sido la esposa de Urías."
,"7":"Salomón fue padre de Roboam, que fue padre de Abías. Luego vienen los reyes Asá,"
,"8":"Josafat, Joram, Ocías,"
,"9":"Joatán, Ajaz, Ezequías,"
,"10":"Manasés, Amón y Josías."
,"11":"Josías fue padre de Jeconías y de sus hermanos, en tiempos de la deportación a Babilonia."
,"12":"Después de la deportación a Babilonia, Jeconías fue padre de Salatiel y éste de Zorobabel."
,"13":"Zorobabel fue padre de Abiud, Abiud de Eliacim y Eliacim de Azor."
,"14":"Azor fue padre de Sadoc, Sadoc de Aquim y éste de Eliud."
,"15":"Eliud fue padre de Eleazar, Eleazar de Matán y éste de Jacob."
,"16":"Jacob fue padre de José, esposo de María, de la que nació Jesús, llamado Cristo."
,"17":"De modo que fueron catorce las generaciones desde Abrahán a David; otras catorce desde David hasta la deportación a Babilonia, y catorce más desde esta deportación hasta el nacimiento de Cristo."
,"18":"Este fue el principio de Jesucristo: María, su madre, estaba comprometida con José; pero antes de que vivieran juntos, quedó embarazada por obra del Espíritu Santo."
,"19":"Su esposo, José, pensó despedirla, pero como era un hombre bueno, quiso actuar discretamente para no difamarla."
,"20":"Mientras lo estaba pensando, el Ángel del Señor se le apareció en sueños y le dijo: 'José, descendiente de David, no tengas miedo de llevarte a María, tu esposa, a tu casa; si bien está esperando por obra del Espíritu Santo,"
,"21":"tú eres el que pondrás el nombre al hijo que dará a luz. Y lo llamarás Jesús, porque él salvará a su pueblo de sus pecados'."
,"22":"Todo esto sucedió para que se cumpliera lo que había dicho el Señor por boca del profeta:"
,"23":"La virgen concebirá y dará a luz un hijo, y le pondrán por nombre Emmanuel, que significa: Dios-con-nosotros."
,"24":"Cuando José se despertó, hizo lo que el Ángel del Señor le había ordenado y tomó consigo a su esposa."
,"25":"Y sin que hubieran tenido relaciones, dio a luz un hijo, al que puso por nombre Jesús."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Jesús había nacido en Belén de Judá durante el reinado de Herodes. Unos Magos que venían de Oriente llegaron a Jerusalén"
,"2":"preguntando: '¿Dónde está el rey de los judíos recién nacido? Porque hemos visto su estrella en el Oriente y venimos a adorarlo.'"
,"3":"Herodes y toda Jerusalén quedaron muy alborotados al oír esto."
,"4":"Reunió de inmediato a los sumos sacerdotes y a los que enseñaban la Ley al pueblo, y les hizo precisar dónde tenía que nacer el Mesías."
,"5":"Ellos le contestaron: 'En Belén de Judá, pues así lo escribió el profeta:"
,"6":"Y tú, Belén, tierra de Judá, no eres en absoluto la más pequeña entre los pueblos de Judá, porque de ti saldrá un jefe, el que apacentará a mi pueblo, Israel."
,"7":"Entonces Herodes llamó en privado a los Magos, y les hizo precisar la fecha en que se les había aparecido la estrella."
,"8":"Después los envió a Belén y les dijo: 'Vayan y averigüen bien todo lo que se refiere a ese niño, y apenas lo encuentren, avísenme, porque yo también iré a rendirle homenaje.'"
,"9":"Después de esta entrevista con el rey, los Magos se pusieron en camino; y fíjense: la estrella que habían visto en el Oriente iba delante de ellos, hasta que se detuvo sobre el lugar donde estaba el niño."
,"10":"¡Qué alegría más grande: habían visto otra vez la estrella!"
,"11":"Al entrar en la casa vieron al niño con María, su madre; se arrodillaron y le adoraron. Abrieron después sus cofres y le ofrecieron sus regalos de oro, incienso y mirra."
,"12":"Luego se les avisó en sueños que no volvieran donde Herodes, así que regresaron a su país por otro camino."
,"13":"Después de marchar los Magos, el Ángel del Señor se le apareció en sueños a José y le dijo: 'Levántate, toma al niño y a su madre y huye a Egipto. Quédate allí hasta que yo te avise, porque Herodes buscará al niño para matarlo.'"
,"14":"José se levantó; aquella misma noche tomó al niño y a su madre, y partió hacia Egipto,"
,"15":"permaneciendo allí hasta la muerte de Herodes. Así se cumplió lo que había anunciado el Señor por boca del profeta: Llamé de Egipto a mi hijo."
,"16":"Herodes se enojó muchísimo cuando se dio cuenta de que los Magos lo habían engañado, y fijándose en la fecha que ellos le habían dicho, ordenó matar a todos los niños menores de dos años que había en Belén y sus alrededores."
,"17":"Así se cumplió lo que había anunciado el profeta Jeremías:"
,"18":"En Ramá se oyeron gritos, grandes sollozos y lamentos: es Raquel que llora a sus hijos; éstos ya no están, y no quiere que la consuelen."
,"19":"Después de la muerte de Herodes, el Ángel del Señor se apareció en sueños a José en Egipto y le dijo:"
,"20":"'Levántate, toma contigo al niño y a su madre y regresa a la tierra de Israel, porque ya han muerto los que querían matar al niño.'"
,"21":"José se levantó, tomó al niño y a su madre, y volvieron a la tierra de Israel."
,"22":"Pero al enterarse de que Arquelao gobernaba en Judea en lugar de su padre Herodes, tuvo miedo de ir allá. Conforme a un aviso que recibió en sueños, se dirigió a la provincia de Galilea"
,"23":"y se fue a vivir a un pueblo llamado Nazaret. Así había de cumplirse lo que dijeron los profetas: Lo llamarán 'Nazoreo'."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Por aquel tiempo se presentó Juan Bautista y empezó a predicar en el desierto de Judea;"
,"2":"éste era su mensaje: 'Renuncien a su mal camino, porque el Reino de los Cielos está cerca.'"
,"3":"Es a Juan a quien se refería el profeta Isaías cuando decía: Una voz grita en el desierto: Preparen un camino al Señor; hagan sus senderos rectos."
,"4":"Además de la piel que llevaba colgada de la cintura, Juan no tenía más que un manto hecho de pelo de camello. Su comida eran langostas y miel silvestre."
,"5":"Venían a verlo de Jerusalén, de toda la Judea y de la región del Jordán."
,"6":"Y además de confesar sus pecados, se hacían bautizar por Juan en el río Jordán."
,"7":"Juan vio que un grupo de fariseos y de saduceos habían venido donde él bautizaba, y les dijo: 'Raza de víboras, ¿cómo van a pensar que escaparán del castigo que se les viene encima?"
,"8":"Muestren los frutos de una sincera conversión, pues de nada les sirve decir: 'Abrahán es nuestro padre'."
,"9":"Yo les aseguro que Dios es capaz de sacar hijos de Abrahán aun de estas piedras."
,"10":"El hacha ya está puesta a la raíz de los árboles, y todo árbol que no da buen fruto, será cortado y arrojado al fuego."
,"11":"Yo los bautizo en el agua, y es el camino a la conversión. Pero después de mí viene uno con mucho más poder que yo -yo ni siquiera merezco llevarle las sandalias-, él los bautizará en el Espíritu Santo y el fuego."
,"12":"Ya tiene la pala en sus manos para separar el trigo de la paja. Guardará el trigo en sus bodegas, mientras que la paja la quemará en el fuego que no se apaga.'"
,"13":"Por entonces vino Jesús de Galilea al Jordán, para encontrar a Juan y para que éste lo bautizara."
,"14":"Juan quiso disuadirlo y le dijo: '¿Tú vienes a mí? Soy yo quien necesita ser bautizado por ti.'"
,"15":"Jesús le respondió: 'Deja que hagamos así por ahora. De este modo respetaremos el debido orden.' Entonces Juan aceptó."
,"16":"Una vez bautizado, Jesús salió del agua. En ese momento se abrieron los Cielos y vio al Espíritu de Dios que bajaba como una paloma y se posaba sobre él."
,"17":"Al mismo tiempo se oyó una voz del cielo que decía: 'Este es mi Hijo, el Amado; éste es mi Elegido.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"El Espíritu condujo a Jesús al desierto para que fuera tentado por el diablo,"
,"2":"y después de estar sin comer cuarenta días y cuarenta noches, al final sintió hambre."
,"3":"Entonces se le acercó el tentador y le dijo: 'Si eres Hijo de Dios, ordena que estas piedras se conviertan en pan.'"
,"4":"Pero Jesús le respondió: 'Dice la Escritura: El hombre no vive solamente de pan, sino de toda palabra que sale de la boca de Dios.'"
,"5":"Después el diablo lo llevó a la Ciudad Santa y lo puso en la parte más alta de la muralla del Templo."
,"6":"Y le dijo: 'Si eres Hijo de Dios, tírate de aquí abajo, pues la Escritura dice: Dios dará ordenes a sus ángeles y te llevarán en sus manos para que tus pies no tropiecen en piedra alguna.'"
,"7":"Jesús replicó: 'Dice también la Escritura: No tentarás al Señor tu Dios.'"
,"8":"A continuación lo llevó el diablo a un monte muy alto y le mostró todas las naciones del mundo con todas sus grandezas y maravillas."
,"9":"Y le dijo: 'Te daré todo esto si te arrodillas y me adoras.'"
,"10":"Jesús le dijo: 'Aléjate, Satanás, porque dice la Escritura: Adorarás al Señor tu Dios, y a El sólo servirás.'"
,"11":"Entonces lo dejó el diablo y se acercaron los ángeles a servirle."
,"12":"Cuando Jesús oyó que Juan había sido encarcelado, se retiró a Galilea."
,"13":"No se quedó en Nazaret, sino que fue a vivir a Cafarnaún, a orillas del lago, en la frontera entre Zabulón y Neftalí."
,"14":"Así se cumplió lo que había dicho el profeta Isaías:"
,"15":"Tierra de Zabulón y tierra de Neftalí, en el camino hacia el mar, a la otra orilla del Jordán, Galilea, tierra de paganos, escuchen:"
,"16":"La gente que vivía en la oscuridad ha visto una luz muy grande; una luz ha brillado para los que viven en lugares de sombras de muerte."
,"17":"Desde entonces Jesús empezó a proclamar este mensaje: 'Renuncien a su mal camino, porque el Reino de los Cielos está ahora cerca.'"
,"18":"Mientras Jesús caminaba a orillas del mar de Galilea, vio a dos hermanos: uno era Simón, llamado Pedro, y el otro Andrés. Eran pescadores y estaban echando la red al mar."
,"19":"Jesús los llamó: 'Síganme, y yo los haré pescadores de hombres.'"
,"20":"Al instante dejaron las redes y lo siguieron."
,"21":"Más adelante vio a otros dos hermanos: Santiago, hijo de Zebedeo, con su hermano Juan; estaban con su padre en la barca arreglando las redes. Jesús los llamó,"
,"22":"y en seguida ellos dejaron la barca y a su padre y lo siguieron."
,"23":"Jesús empezó a recorrer toda la Galilea; enseñaba en las sinagogas de los judíos, proclamaba la Buena Nueva del Reino y curaba en el pueblo todas las dolencias y enfermedades."
,"24":"Su fama se extendió por toda Siria. La gente le traía todos sus enfermos y cuantos estaban aquejados por algún mal: endemoniados, lunáticos y paralíticos, y él los sanaba a todos."
,"25":"Empezaron a seguir a Jesús muchedumbres: gente de Galilea, Decápolis, Jerusalén, Judea y del otro lado del Jordán."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Jesús, al ver toda aquella muchedumbre, subió al monte. Se sentó y sus discípulos se reunieron a su alrededor."
,"2":"Entonces comenzó a hablar y les enseñaba diciendo:"
,"3":"'Felices los que tienen el espíritu del pobre, porque de ellos es el Reino de los Cielos."
,"4":"Felices los que lloran, porque recibirán consuelo."
,"5":"Felices los pacientes, porque recibirán la tierra en herencia."
,"6":"Felices los que tienen hambre y sed de justicia, porque serán saciados."
,"7":"Felices los compasivos, porque obtendrán misericordia."
,"8":"Felices los de corazón limpio, porque verán a Dios."
,"9":"Felices los que trabajan por la paz, porque serán reconocidos como hijos de Dios."
,"10":"Felices los que son perseguidos por causa del bien, porque de ellos es el Reino de los Cielos."
,"11":"Felices ustedes, cuando por causa mía los insulten, los persigan y les levanten toda clase de calumnias."
,"12":"Alégrense y muéstrense contentos, porque será grande la recompensa que recibirán en el cielo. Pues bien saben que así persiguieron a los profetas que vivieron antes de ustedes."
,"13":"Ustedes son la sal de la tierra. Pero si la sal deja de ser sal, ¿cómo podrá ser salada de nuevo? Ya no sirve para nada, por lo que se tira afuera y es pisoteada por la gente."
,"14":"Ustedes son la luz del mundo: ¿cómo se puede esconder una ciudad asentada sobre un monte?"
,"15":"Nadie enciende una lámpara para taparla con un cajón; la ponen más bien sobre un candelero, y alumbra a todos los que están en la casa."
,"16":"Hagan, pues, que brille su luz ante los hombres; que vean estas buenas obras, y por ello den gloria al Padre de ustedes que está en los Cielos."
,"17":"No crean que he venido a suprimir la Ley o los Profetas. He venido, no para deshacer cosa alguna, sino para llevarla a la forma perfecta."
,"18":"En verdad les digo: mientras dure el cielo y la tierra, no pasará una letra o una coma de la Ley hasta que todo se realice."
,"19":"Por tanto, el que ignore el último de esos mandamientos y enseñe a los demás a hacer lo mismo, será el más pequeño en el Reino de los Cielos. En cambio el que los cumpla y los enseñe, será grande en el Reino de los Cielos."
,"20":"Yo se lo digo: si no hay en ustedes algo mucho más perfecto que lo de los fariseos, o de los maestros de la Ley, ustedes no pueden entrar en el Reino de los Cielos."
,"21":"Ustedes han escuchado lo que se dijo a sus antepasados: 'No matarás; el homicida tendrá que enfrentarse a un juicio.'"
,"22":"Pero yo les digo: Si uno se enoja con su hermano, es cosa que merece juicio. El que ha insultado a su hermano, merece ser llevado ante el Tribunal Supremo; si lo ha tratado de renegado de la fe, merece ser arrojado al fuego del infierno."
,"23":"Por eso, si tú estás para presentar tu ofrenda en el altar, y te acuerdas de que tu hermano tiene algo contra ti,"
,"24":"deja allí mismo tu ofrenda ante el altar, y vete antes a hacer las paces con tu hermano; después vuelve y presenta tu ofrenda."
,"25":"Trata de llegar a un acuerdo con tu adversario mientras van todavía de camino al juicio. ¿O prefieres que te entregue al juez, y el juez a los guardias, que te encerrarán en la cárcel?"
,"26":"En verdad te digo: no saldrás de allí hasta que hayas pagado hasta el último centavo."
,"27":"Ustedes han oído que se dijo: 'No cometerás adulterio.'"
,"28":"Pero yo les digo: Quien mira a una mujer con malos deseos, ya cometió adulterio con ella en su corazón."
,"29":"Por eso, si tu ojo derecho te está haciendo caer, sácatelo y tíralo lejos; porque más te conviene perder una parte de tu cuerpo y no que todo tu cuerpo sea arrojado al infierno."
,"30":"Y si tu mano derecha te lleva al pecado, córtala y aléjala de ti; porque es mejor que pierdas una parte de tu cuerpo y no que todo tu cuerpo sea arrojado al infierno."
,"31":"También se dijo: 'El que se divorcie de su mujer, debe darle un certificado de divorcio.'"
,"32":"Pero yo les digo: Si un hombre se divorcia de su mujer, a no ser por motivo de infidelidad, es como mandarla a cometer adulterio: el hombre que se case con la mujer divorciada, cometerá adulterio."
,"33":"Ustedes han oído lo que se dijo a sus antepasados: 'No jurarás en falso, y cumplirás lo que has jurado al Señor.'"
,"34":"Pero yo les digo: ¡No juren! No juren por el cielo, porque es el trono de Dios;"
,"35":"ni por la tierra, que es la tarima de sus pies; ni por Jerusalén, porque es la ciudad del Gran Rey."
,"36":"Tampoco jures por tu propia cabeza, pues no puedes hacer blanco o negro ni uno solo de tus cabellos."
,"37":"Digan sí cuando es sí, y no cuando es no; cualquier otra cosa que se le añada, viene del demonio."
,"38":"Ustedes han oído que se dijo: 'Ojo por ojo y diente por diente.'"
,"39":"Pero yo les digo: No resistan al malvado. Antes bien, si alguien te golpea en la mejilla derecha, ofrécele también la otra."
,"40":"Si alguien te hace un pleito por la camisa, entrégale también el manto."
,"41":"Si alguien te obliga a llevarle la carga, llévasela el doble más lejos."
,"42":"Da al que te pida, y al que espera de ti algo prestado, no le vuelvas la espalda."
,"43":"Ustedes han oído que se dijo: 'Amarás a tu prójimo y no harás amistad con tu enemigo.'"
,"44":"Pero yo les digo: Amen a sus enemigos y recen por sus perseguidores,"
,"45":"para que así sean hijos de su Padre que está en los Cielos. Porque él hace brillar su sol sobre malos y buenos, y envía la lluvia sobre justos y pecadores."
,"46":"Si ustedes aman solamente a quienes los aman, ¿qué mérito tiene? También los cobradores de impuestos lo hacen."
,"47":"Y si saludan sólo a sus amigos, ¿qué tiene de especial? También los paganos se comportan así."
,"48":"Por su parte, sean ustedes perfectos como es perfecto el Padre de ustedes que está en el Cielo."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Guárdense de las buenas acciones hechas a la vista de todos, a fin de que todos las aprecien. Pues en ese caso, no les quedaría premio alguno que esperar de su Padre que está en el cielo."
,"2":"Cuando ayudes a un necesitado, no lo publiques al son de trompetas; no imites a los que dan espectáculo en las sinagogas y en las calles, para que los hombres los alaben. Yo se lo digo: ellos han recibido ya su premio."
,"3":"Tú, cuando ayudes a un necesitado, ni siquiera tu mano izquierda debe saber lo que hace la derecha:"
,"4":"tu limosna quedará en secreto. Y tu Padre, que ve en lo secreto, te premiará."
,"5":"Cuando ustedes recen, no imiten a los que dan espectáculo; les gusta orar de pie en las sinagogas y en las esquinas de las plazas, para que la gente los vea. Yo se lo digo: ellos han recibido ya su premio."
,"6":"Pero tú, cuando reces, entra en tu pieza, cierra la puerta y ora a tu Padre que está allí, a solas contigo. Y tu Padre, que ve en lo secreto, te premiará."
,"7":"Cuando pidan a Dios, no imiten a los paganos con sus letanías interminables: ellos creen que un bombardeo de palabras hará que se los oiga."
,"8":"No hagan como ellos, pues antes de que ustedes pidan, su Padre ya sabe lo que necesitan."
,"9":"Ustedes, pues, recen así: Padre nuestro, que estás en el Cielo, santificado sea tu Nombre,"
,"10":"venga tu Reino, hágase tu voluntad,así en la tierra como en el Cielo."
,"11":"Danos hoy el pan que nos corresponde;"
,"12":"y perdona nuestras deudas, como también nosotros perdonamos,a nuestros deudores;"
,"13":"y no nos dejes caer en la tentación, sino líbranos del Maligno."
,"14":"Porque si ustedes perdonan a los hombres sus ofensas, también el Padre celestial les perdonará a ustedes."
,"15":"Pero si ustedes no perdonan a los demás, tampoco el Padre les perdonará a ustedes."
,"16":"Cuando ustedes hagan ayuno, no pongan cara triste, como los que dan espectáculo y aparentan palidez, para que todos noten sus ayunos. Yo se lo digo: ellos han recibido ya su premio."
,"17":"Cuando tú hagas ayuno, lávate la cara y perfúmate el cabello."
,"18":"No son los hombres los que notarán tu ayuno, sino tu Padre que ve las cosas secretas, y tu Padre que ve en lo secreto, te premiará."
,"19":"No junten tesoros y reservas aquí en la tierra, donde la polilla y el óxido hacen estragos, y donde los ladrones rompen el muro y roban."
,"20":"Junten tesoros y reservas en el Cielo, donde no hay polilla ni óxido para hacer estragos, y donde no hay ladrones para romper el muro y robar."
,"21":"Pues donde está tu tesoro, allí estará también tu corazón."
,"22":"Tu ojo es la lámpara de tu cuerpo. Si tus ojos están sanos, todo tu cuerpo tendrá luz; pero si tus ojos están malos, todo tu cuerpo estará en obscuridad."
,"23":"Y si la luz que hay en ti ha llegado a ser obscuridad, ¡cómo será de tenebrosa tu parte más obscura!"
,"24":"Nadie puede servir a dos patrones: necesariamente odiará a uno y amará al otro, o bien cuidará al primero y despreciará al otro. Ustedes no pueden servir al mismo tiempo a Dios y al Dinero."
,"25":"Por eso yo les digo: No anden preocupados por su vida con problemas de alimentos, ni por su cuerpo con problemas de ropa. ¿No es más importante la vida que el alimento y más valioso el cuerpo que la ropa?"
,"26":"Fíjense en las aves del cielo: no siembran, ni cosechan, no guardan alimentos en graneros, y sin embargo el Padre del Cielo, el Padre de ustedes, las alimenta. ¿No valen ustedes mucho más que las aves?"
,"27":"¿Quién de ustedes, por más que se preocupe, puede añadir algo a su estatura?"
,"28":"Y ¿por qué se preocupan tanto por la ropa? Miren cómo crecen las flores del campo, y no trabajan ni tejen."
,"29":"Pero yo les digo que ni Salomón, con todo su lujo, se pudo vestir como una de ellas."
,"30":"Y si Dios viste así el pasto del campo, que hoy brota y mañana se echa al fuego, ¿no hará mucho más por ustedes? ¡Qué poca fe tienen!"
,"31":"No anden tan preocupados ni digan: ¿tendremos alimentos?, o ¿qué beberemos?, o ¿tendremos ropas para vestirnos?"
,"32":"Los que no conocen a Dios se afanan por esas cosas, pero el Padre del Cielo, Padre de ustedes, sabe que necesitan todo eso."
,"33":"Por lo tanto, busquen primero el Reino y la Justicia de Dios, y se les darán también todas esas cosas."
,"34":"No se preocupen por el día de mañana, pues el mañana se preocupará por sí mismo. A cada día le bastan sus problemas."
}`)
	CurrentBook.AddChapter(7, `{
"1":"No juzguen a los demás y no serán juzgados ustedes."
,"2":"Porque de la misma manera que ustedesjuzguen, así serán juzgados, y la misma medida que ustedes usen para los demás, será usada para ustedes."
,"3":"¿Qué pasa? Ves la pelusa en el ojo de tu hermano, ¿y no te das cuenta del tronco que hay en el tuyo?"
,"4":"¿Y dices a tu hermano: Déjame sacarte esa pelusa del ojo, teniendo tú un tronco en el tuyo?"
,"5":"Hipócrita, saca primero el tronco que tienes en tu ojo y así verás mejor para sacar la pelusa del ojo de tu hermano."
,"6":"No den lo que es santo a los perros, ni echen sus perlas a los cerdos, pues podrían pisotearlas y después se volverían contra ustedes para destrozarlos."
,"7":"Pidan y se les dará; busquen y hallarán; llamen y se les abrirá la puerta."
,"8":"Porque el que pide, recibe; el que busca, encuentra; y se abrirá la puerta al que llama."
,"9":"¿Acaso alguno de ustedes daría a su hijo una piedra cuando le pide pan?"
,"10":"¿O le daría una culebra cuando le pide un pescado?"
,"11":"Pues si ustedes, que son malos, saben dar cosas buenas a sus hijos, ¡con cuánta mayor razón el Padre de ustedes, que está en el Cielo, dará cosas buenas a los que se las pidan!"
,"12":"Todo lo que ustedes desearían de los demás, háganlo con ellos: ahí está toda la Ley y los Profetas."
,"13":"Entren por la puerta angosta, porque ancha es la puerta y espacioso el camino que conduce a la ruina, y son muchos los que pasan por él."
,"14":"Pero ¡qué angosta es la puerta y qué escabroso el camino que conduce a la salvación! y qué pocos son los que lo encuentran."
,"15":"Cuídense de los falsos profetas: se presentan ante ustedes con piel de ovejas, pero por dentro son lobos feroces."
,"16":"Ustedes los reconocerán por sus frutos. ¿Cosecharían ustedes uvas de los espinos o higos de los cardos?"
,"17":"Lo mismo pasa con un árbol sano: da frutos buenos, mientras que el árbol malo produce frutos malos."
,"18":"Un árbol bueno no puede dar frutos malos, como tampoco un árbol malo puede producir frutos buenos."
,"19":"Todo árbol que no da buenos frutos se corta y se echa al fuego."
,"20":"Por lo tanto, ustedes los reconocerán por sus obras."
,"21":"No bastará con decirme: ¡Señor!, ¡Señor!, para entrar en el Reino de los Cielos; más bien entrará el que hace la voluntad de mi Padre del Cielo."
,"22":"Aquel día muchos me dirán: ¡Señor, Señor!, hemos hablado en tu nombre, y en tu nombre hemos expulsado demonios y realizado muchos milagros."
,"23":"Entonces yo les diré claramente: Nunca les conocí. ¡Aléjense de mí ustedes que hacen el mal!"
,"24":"Si uno escucha estas palabras mías y las pone en práctica, dirán de él: aquí tienen al hombre sabio y prudente, que edificó su casa sobre roca."
,"25":"Cayó la lluvia, se desbordaron los ríos, soplaron los vientos y se arrojaron contra aquella casa, pero la casa no se derrumbó, porque tenía los cimientos sobre roca."
,"26":"Pero dirán del que oye estas palabras mías, y no las pone en práctica: aquí tienen a un tonto que construyó su casa sobre arena."
,"27":"Cayó la lluvia, se desbordaron los ríos, soplaron los vientos y se arrojaron contra esa casa: la casa se derrumbó y todo fue un gran desastre.'"
,"28":"Cuando Jesús terminó este discurso, la gente estaba admirada de cómo enseñaba,"
,"29":"porque lo hacía con autoridad y no como sus maestros de la Ley."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Jesús, pues, bajó del monte, y empezaron a seguirlo muchedumbres."
,"2":"Un leproso se acercó, se arrodilló delante de él y le dijo: 'Señor, si tú quieres, puedes limpiarme.'"
,"3":"Jesús extendió la mano, lo tocó y le dijo: 'Quiero, queda limpio.' Al momento quedó limpio de la lepra."
,"4":"Jesús le dijo: 'Mira, no se lo digas a nadie; pero ve a mostrarte al sacerdote y ofrece la ofrenda ordenada por la Ley de Moisés, pues tú tienes que hacerles una declaración.'"
,"5":"Al entrar Jesús en Cafarnaún, se le acercó un capitán de la guardia, suplicándole:"
,"6":"'Señor, mi muchacho está en cama, totalmente paralizado, y sufre terriblemente.'"
,"7":"Jesús le dijo: 'Yo iré a sanarlo.'"
,"8":"El capitán contestó: 'Señor, ¿quién soy yo para que entres en mi casa? Di no más una palabra y mi sirviente sanará."
,"9":"Pues yo, que no soy más que un capitán, tengo soldados a mis órdenes, y cuando le digo a uno: Vete, él se va; y si le digo a otro: Ven, él viene; y si ordeno a mi sirviente: Haz tal cosa, él la hace.'"
,"10":"Jesús se quedó admirado al oír esto, y dijo a los que le seguían: 'Les aseguro que no he encontrado a nadie en Israel con tanta fe."
,"11":"Yo se lo digo: vendrán muchos del oriente y del occidente para sentarse a la mesa con Abrahán, Isaac y Jacob en el Reino de los Cielos,"
,"12":"mientras que los que debían entrar al reino serán echados a las tinieblas de afuera: allí será el llorar y rechinar de dientes.'"
,"13":"Luego Jesús dijo al capitán: 'Vete a casa, hágase todo como has creído.' Y en ese mismo momento el muchacho quedó sano."
,"14":"Jesús fue a casa de Pedro; allí encontró a la suegra de éste en cama, con fiebre."
,"15":"Jesús le tocó la mano y se le pasó la fiebre. Ella se levantó y comenzó a atenderle."
,"16":"Al atardecer le llevaron muchos endemoniados. Él expulsó a los espíritus malos con una sola palabra, y sanó también a todos los enfermos."
,"17":"Así se cumplió lo que había anunciado el profeta Isaías: Él tomó nuestras debilidades y cargó con nuestras enfermedades."
,"18":"Jesús, al verse rodeado por la multitud, dio orden de cruzar a la otra orilla."
,"19":"Entonces se le acercó un maestro de la Ley y le dijo: 'Maestro, te seguiré adondequiera que vayas.'"
,"20":"Jesús le contestó: 'Los zorros tienen cuevas y las aves tienen nidos, pero el Hijo del Hombre ni siquiera tiene dónde recostar la cabeza.'"
,"21":"Otro de sus discípulos le dijo: 'Señor, deja que me vaya y pueda primero enterrar a mi padre.'"
,"22":"Jesús le contestó: 'Sígueme y deja que los muertos entierren a sus muertos.'"
,"23":"Jesús subió a la barca y sus discípulos le siguieron."
,"24":"Se levantó una tormenta muy violenta en el lago, con olas que cubrían la barca, pero él dormía."
,"25":"Los discípulos se acercaron y lo despertaron diciendo: '¡Señor, sálvanos, que estamos perdidos!'"
,"26":"Pero él les dijo: '¡Qué miedosos son ustedes! ¡Qué poca fe tienen!' Entonces se levantó, dio una orden al viento y al mar, y todo volvió a la más completa calma."
,"27":"Grande fue el asombro; aquellos hombres decían: '¿Quién es éste, que hasta los vientos y el mar le obedecen?'"
,"28":"Al llegar a la otra orilla, a la tierra de Gadara, dos endemoniados salieron de entre los sepulcros y vinieron a su encuentro. Eran hombres tan salvajes que nadie se atrevía a pasar por aquel camino."
,"29":"Y se pusieron a gritar: '¡No te metas con nosotros, Hijo de Dios! ¿Has venido aquí para atormentarnos antes de tiempo?'"
,"30":"A cierta distancia de allí había una gran piara de cerdos comiendo."
,"31":"Los demonios suplicaron a Jesús: 'Si nos expulsas, envíanos a esa piara de cerdos.' Jesús les dijo: 'Vayan'."
,"32":"Salieron y entraron en los cerdos. Al momento toda la piara se lanzó hacia el lago por la pendiente, y allí se ahogaron."
,"33":"Los cuidadores huyeron, fueron a la ciudad y contaron todo lo sucedido, y lo que había pasado con los endemoniados."
,"34":"Entonces todos los habitantes salieron al encuentro de Jesús y, no bien lo vieron, le rogaron que se alejase de sus tierras."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Jesús volvió a la barca, cruzó de nuevo el lago y vino a su ciudad."
,"2":"Allí le llevaron a un paralítico, tendido en una camilla. Al ver Jesús la fe de esos hombres, dijo al paralítico: '¡Animo, hijo; tus pecados quedan perdonados!'"
,"3":"Algunos maestros de la Ley pensaron: '¡Qué manera de burlarse de Dios!'"
,"4":"Pero Jesús, que conocía sus pensamientos, les dijo: '¿Por qué piensan mal?"
,"5":"¿Qué es más fácil: decir 'Quedan perdonados tus pecados' o 'Levántate y anda'?"
,"6":"Sepan, pues, que el Hijo del Hombre tiene autoridad en la tierra para perdonar pecados.' Entonces dijo al paralítico: 'Levántate, toma tu camilla y vete a casa.'"
,"7":"Y el paralítico se levantó y se fue a su casa."
,"8":"La gente, al ver esto, quedó muy impresionada y alabó a Dios por haber dado tal poder a los hombres."
,"9":"Jesús, al irse de allí, vio a un hombre llamado Mateo en su puesto de cobrador de impuestos, y le dijo: 'Sígueme.' Mateo se levantó y lo siguió."
,"10":"Como Jesús estaba comiendo en casa de Mateo, un buen número de cobradores de impuestos y otra gente pecadora vinieron a sentarse a la mesa con Jesús y sus discípulos."
,"11":"Los fariseos, al ver esto, decían a los discípulos: '¿Cómo es que su Maestro come con cobradores de impuestos y pecadores?'"
,"12":"Jesús los oyó y dijo: 'No es la gente sana la que necesita médico, sino los enfermos."
,"13":"Vayan y aprendan lo que significa esta palabra de Dios: Me gusta la misericordia más que las ofrendas. Pues no he venido a llamar a los justos, sino a los pecadores.'"
,"14":"Entonces se le acercaron los discípulos de Juan y le preguntaron: 'Nosotros y los fariseos ayunamos en muchas ocasiones, ¿por qué tus discípulos no ayunan?'"
,"15":"Jesús les contestó: '¿Quieren ustedes que los compañeros del novio estén de duelo mientras el novio está con ellos? Llegará el tiempo en que el novio les será quitado; entonces ayunarán."
,"16":"Nadie remienda un vestido viejo con un pedazo de tela nueva, porque el pedazo nuevo tiraría del vestido y la rotura se haría mayor."
,"17":"Y nadie echa vino nuevo en recipientes de cuero viejos, porque si lo hacen, se reventarán los cueros, el vino se desparramará y los recipientes se estropearán. El vino nuevo se echa en cueros nuevos, y así se conservan bien el vino y los recipientes.'"
,"18":"Mientras Jesús hablaba, llegó un jefe de los judíos, se postró delante de él y le dijo: 'Mi hija acaba de morir, pero ven, pon tu mano sobre ella, y vivirá.'"
,"19":"Jesús se levantó y lo siguió junto con sus discípulos."
,"20":"Mientras iba de camino, una mujer que desde hacía doce años padecía hemorragias, se acercó por detrás y tocó el fleco de su manto."
,"21":"Pues ella pensaba: 'Con sólo tocar su manto, me salvaré.'"
,"22":"Jesús se dio vuelta y, al verla, le dijo: 'Animo, hija; tu fe te ha salvado.' Y desde aquel momento, la mujer quedó sana."
,"23":"Al llegar Jesús a la casa del jefe, vio a los flautistas y el alboroto de la gente."
,"24":"Entonces les dijo: 'Váyanse, la niña no ha muerto sino que está dormida.' Ellos se burlaban de él."
,"25":"Después que echaron a toda la gente, Jesús entró, tomó a la niña por la mano, y la niña se levantó."
,"26":"El hecho se divulgó por toda aquella región."
,"27":"Al retirarse Jesús de allí, lo siguieron dos ciegos que gritaban: '¡Hijo de David, ten compasión de nosotros!'"
,"28":"Cuando Jesús estuvo en casa, los ciegos se le acercaron, y Jesús les preguntó: '¿Creen que puedo hacer esto?' Contestaron: 'Sí, Señor.'"
,"29":"Entonces Jesús les tocó los ojos, diciendo: 'Hágase así, tal como han creído'. Y sus ojos vieron."
,"30":"Después les ordenó severamente: 'Cuiden de que nadie lo sepa.'"
,"31":"Pero ellos, en cuanto se fueron, lo publicaron por toda la región."
,"32":"Apenas se fueron los ciegos, le trajeron a uno que tenía un demonio y no podía hablar."
,"33":"Jesús echó al demonio, y el mudo empezó a hablar. La gente quedó maravillada y todos decían: 'Jamás se ha visto cosa igual en Israel.'"
,"34":"En cambio, los fariseos comentaban: 'Este echa a los demonios con la ayuda del príncipe de los demonios.'"
,"35":"Jesús recorría todas las ciudades y pueblos; enseñaba en sus sinagogas, proclamaba la Buena Nueva del Reino y curaba todas las dolencias y enfermedades."
,"36":"Al contemplar aquel gran gentío, Jesús sintió compasión, porque estaban decaídos y desanimados, como ovejas sin pastor."
,"37":"Y dijo a sus discípulos: 'La cosecha es abundante, pero los trabajadores son pocos."
,"38":"Rueguen, pues, al dueño de la cosecha que envíe trabajadores a recoger su cosecha.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Jesús llamó a sus doce discípulos y les dio poder sobre los malos espíritus para expulsarlos y para curar toda clase de enfermedades y dolencias."
,"2":"Estos son los nombres de los doce apóstoles: primero Simón, llamado Pedro, y su hermano Andrés; Santiago, hijo de Zebedeo, y su hermano Juan;"
,"3":"Felipe y Bartolomé; Tomás y Mateo, el recaudador de impuestos; Santiago, el hijo de Alfeo, y Tadeo;"
,"4":"Simón, el cananeo y Judas Iscariote, el que lo traicionaría."
,"5":"A estos Doce Jesús los envió a misionar, con las instrucciones siguientes: 'No vayan a tierras de paganos ni entren en pueblos de samaritanos."
,"6":"Diríjanse más bien a las ovejas perdidas del pueblo de Israel."
,"7":"A lo largo del camino proclamen: ¡El Reino de los Cielos está ahora cerca!"
,"8":"Sanen enfermos, resuciten muertos, limpien leprosos y echen los demonios. Ustedes lo recibieron sin pagar, denlo sin cobrar."
,"9":"No lleven oro, plata o monedas en el cinturón."
,"10":"Nada de provisiones para el viaje, o vestidos de repuesto; no lleven bastón ni sandalias, porque el que trabaja se merece el alimento."
,"11":"En todo pueblo o aldea en que entren, busquen alguna persona que valga, y quédense en su casa hasta que se vayan."
,"12":"Al entrar en la casa, deséenle la paz."
,"13":"Si esta familia la merece, recibirá vuestra paz; y si no la merece, la bendición volverá a ustedes."
,"14":"Y si en algún lugar no los reciben ni escuchan sus palabras, salgan de esa familia o de esa ciudad, sacudiendo el polvo de los pies."
,"15":"Yo les aseguro que esa ciudad, en el día del juicio, será tratada con mayor rigor que Sodoma y Gomorra."
,"16":"Miren que los envío como ovejas en medio de lobos: sean, pues, precavidos como la serpiente, pero sencillos como la paloma."
,"17":"¡Cuídense de los hombres! A ustedes los arrastrarán ante sus consejos, y los azotarán en sus sinagogas."
,"18":"Ustedes incluso serán llevados ante gobernantes y reyes por causa mía, y tendrán que dar testimonio ante ellos y los pueblos paganos."
,"19":"Cuando sean arrestados, no se preocupen por lo que van a decir, ni cómo han de hablar. Llegado ese momento, se les comunicará lo que tengan que decir."
,"20":"Pues no serán ustedes los que hablarán, sino el Espíritu de su Padre el que hablará en ustedes."
,"21":"Un hermano denunciará a su hermano para que lo maten, y el padre a su hijo, y los hijos se sublevarán contra sus padres y los matarán."
,"22":"Ustedes serán odiados por todos por causa mía, pero el que se mantenga firme hasta el fin, se salvará."
,"23":"Cuando los persigan en una ciudad, huyan a otra. En verdad les digo: no terminarán de recorrer todas las ciudades de Israel antes de que venga el Hijo del Hombre."
,"24":"El discípulo no está por encima de su maestro, ni el sirviente por encima de su patrón."
,"25":"Ya es mucho si el discípulo llega a ser como su maestro y el sirviente como su patrón. Si al dueño de casa lo han llamado demonio, ¡qué no dirán de los demás de la familia!"
,"26":"Pero no les tengan miedo. Nada hay oculto que no llegue a ser descubierto, ni nada secreto que no llegue a saberse."
,"27":"Lo que yo les digo en la oscuridad, repítanlo ustedes a la luz, y lo que les digo en privado, proclámenlo desde las azoteas."
,"28":"No teman a los que sólo pueden matar el cuerpo, pero no el alma; teman más bien al que puede destruir alma y cuerpo en el infierno."
,"29":"¿Acaso un par de pajaritos no se venden por unos centavos? Pero ni uno de ellos cae en tierra sin que lo permita vuestro Padre."
,"30":"En cuanto a ustedes, hasta sus cabellos están todos contados."
,"31":"¿No valen ustedes más que muchos pajaritos? Por lo tanto no tengan miedo."
,"32":"Al que se ponga de mi parte ante los hombres, yo me pondré de su parte ante mi Padre de los Cielos."
,"33":"Y al que me niegue ante los hombres, yo también lo negaré ante mi Padre que está en los Cielos."
,"34":"No piensen que he venido a traer paz a la tierra; no he venido a traer paz, sino espada."
,"35":"Pues he venido a enfrentar al hombre contra su padre, a la hija contra su madre y a la nuera contra su suegra."
,"36":"Cada cual verá a sus familiares volverse enemigos."
,"37":"El que ama a su padre o a su madre más que a mí, no es digno de mí; y el que ama a su hijo o a su hija más que a mí, no es digno de mí."
,"38":"El que no carga con su cruz y viene detrás de mí, no es digno de mí."
,"39":"El que vive su vida para sí, la perderá, y el que sacrifique su vida por mi causa, la hallará."
,"40":"El que los recibe a ustedes, a mí me recibe, y el que me recibe a mí, recibe a Aquel que me ha enviado. El que recibe a un profeta porque es profeta, recibirá recompensa digna de un profeta."
,"41":"El que recibe a un hombre justo por ser justo, recibirá la recompensa que corresponde a un justo."
,"42":"Asimismo, el que dé un vaso de agua fresca a uno de estos pequeños, porque es discípulo, no quedará sin recompensa: soy yo quien se lo digo.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Cuando Jesús terminó de dar estas instrucciones a sus doce discípulos, se fue de allí para predicar y enseñar en las ciudades judías."
,"2":"Juan, que estaba en la cárcel, oyó hablar de las obras de Cristo, por lo que envió a sus discípulos"
,"3":"a preguntarle: '¿Eres tú el que ha de venir, o tenemos que esperar a otro?'"
,"4":"Jesús les contestó: 'Vayan y cuéntenle a Juan lo que ustedes están viendo y oyendo:"
,"5":"los ciegos ven, los cojos andan, los leprosos quedan limpios, los sordos oyen, los muertos resucitan, y una Buena Nueva llega a los pobres."
,"6":"¡Y dichoso aquél para quien yo no sea motivo de escándalo!'"
,"7":"Una vez que se fueron los mensajeros, Jesús comenzó a hablar de Juan a la gente: 'Cuando ustedes fueron al desierto, ¿qué iban a ver? ¿Una caña agitada por el viento?"
,"8":"¿Qué iban ustedes a ver? ¿Un hombre con ropas finas? Los que visten ropas finas viven en palacios."
,"9":"Entonces, ¿qué fueron a ver? ¿A un profeta? Eso sí y, créanme, más que un profeta."
,"10":"Este es el hombre de quien la escritura dice: Yo voy a enviar mi mensajero delante de ti, para que te preceda abriéndote el camino."
,"11":"Yo se lo digo: de entre los hijos de mujer no se ha manifestado uno más grande que Juan Bautista, y sin embargo el más pequeño en el Reino de los Cielos es más que él."
,"12":"Desde los días de Juan Bautista hasta ahora el Reino de Dios es cosa que se conquista, y los más decididos son los que se adueñan de él."
,"13":"Hasta Juan, todos los profetas y la Ley misma se quedaron en la profecía."
,"14":"Pero, si ustedes aceptan su mensaje, Juan es este Elías que había de venir."
,"15":"El que tenga oídos para oír, que lo escuche."
,"16":"¿Con quién puedo comparar a la gente de hoy? Son como niños sentados en la plaza, que se quejan unos de otros:"
,"17":"Les tocamos la flauta y ustedes no han bailado; les cantamos canciones tristes y no han querido llorar."
,"18":"Porque vino Juan, que no comía ni bebía, y dijeron:"
,"19":"Está endemoniado. Luego vino el Hijo del Hombre, que come y bebe, y dicen: Es un comilón y un borracho, amigo de cobradores de impuestos y de pecadores. Con todo, se comprobará que la Sabiduría de Dios no se equivoca en sus obras.'"
,"20":"Entonces Jesús comenzó a reprochar a las ciudades en que había realizado la mayor parte de sus milagros, porque no se habían arrepentido:"
,"21":"'¡Ay de ti, Corozaín! ¡Ay de ti, Betsaida! Porque si en Tiro y Sidón se hubiesen hecho los milagros que se han realizado en ustedes, seguramente se habrían arrepentido, poniéndose vestidos de penitencia y cubriéndose de ceniza."
,"22":"Yo se lo digo: Tiro y Sidón serán tratadas con menos rigor que ustedes en el día del juicio."
,"23":"Y tú, Cafarnaún, ¿subirás hasta el cielo? No, bajarás donde los muertos. Porque si los milagros que se han realizado en ti, se hubieran hecho en Sodoma, todavía hoy existiría Sodoma."
,"24":"Por eso les digo que, en el día del Juicio, Sodoma será tratada con menos rigor que ustedes.'"
,"25":"En aquella ocasión Jesús exclamó: 'Yo te alabo, Padre, Señor del Cielo y de la tierra, porque has mantenido ocultas estas cosas a los sabios y entendidos y las has revelado a la gente sencilla. Sí, Padre, pues así fue de tu agrado."
,"26":"Mi Padre ha puesto todas las cosas en mis manos."
,"27":"Nadie conoce al Hijo sino el Padre, y nadie conoce al Padre sino el Hijo y aquellos a quienes el Hijo se lo quiera dar a conocer."
,"28":"Vengan a mí los que van cansados, llevando pesadas cargas, y yo los aliviaré."
,"29":"Carguen con mi yugo y aprendan de mí, que soy paciente y humilde de corazón, y sus almas encontrarán descanso."
,"30":"Pues mi yugo es suave y mi carga liviana.'"
}`)
	CurrentBook.AddChapter(12, `{
"1":"En cierta ocasión pasaba Jesús por unos campos de trigo, y era un día sábado. Sus discípulos, que tenían hambre, comenzaron a desgranar espigas y a comerse el grano."
,"2":"Al advertirlo unos fariseos, dijeron a Jesús: 'Tus discípulos están haciendo lo que está prohibido hacer en día sábado.'"
,"3":"Jesús les contestó: '¿No han leído ustedes lo que hizo David un día que tenía hambre, él y su gente?"
,"4":"Pues entró en la casa de Dios y comieron el pan ofrecido a Dios, que les estaba prohibido tanto a él como a sus compañeros, pues estaba reservado a los sacerdotes."
,"5":"¿No han leído en la Ley que los sacerdotes en el Templo no observan el descanso, y no hay culpa en eso?"
,"6":"Yo se lo digo: ustedes tienen aquí algo más que el Templo."
,"7":"Y si ustedes entendieran estas palabras: Quiero misericordia, no sacrificios, ustedes no condenarían a quienes están sin culpa."
,"8":"Además, el Hijo del Hombre es Señor del sábado.'"
,"9":"Saliendo de aquel lugar, Jesús entró en una sinagoga de los judíos."
,"10":"Se encontraba allí un hombre que tenía una mano paralizada. Le preguntaron a Jesús, con intención de acusarlo después: '¿Está permitido hacer curaciones en día sábado?'"
,"11":"Jesús les dijo: 'Si alguno de ustedes tiene una sola oveja y se le cae a un barranco en día sábado, ¿no irá a sacarla?"
,"12":"¡Pues un ser humano vale mucho más que una oveja! Por lo tanto, está permitido hacer el bien en día sábado.'"
,"13":"Dijo entonces al enfermo: 'Extiende tu mano.' La extendió y le quedó tan sana como la otra."
,"14":"Al salir, los fariseos planearon la manera de acabar con él."
,"15":"Jesús lo supo y se alejó de allí, pero muchas personas lo siguieron, y él sanó a cuantos estaban enfermos."
,"16":"Pero les pedía insistentemente que no hablaran de él."
,"17":"Así debían cumplirse las palabras del profeta Isaías:"
,"18":"Viene mi siervo, mi elegido, el Amado, en quien me he complacido. Pondré mi Espíritu sobre él, para que anuncie mis juicios a las naciones."
,"19":"No discutirá, ni gritará, ni se oirá su voz en las plazas."
,"20":"No quebrará la caña resquebrajada ni apagará la mecha que todavía humea, hasta que haga triunfar la justicia."
,"21":"Las naciones pondrán su esperanza en su Nombre."
,"22":"Algunos le trajeron un endemoniado que era ciego y mudo. Jesús lo sanó, de modo que pudo ver y hablar."
,"23":"Ante esto, toda la gente quedó asombrada y preguntaban: '¿No será éste el hijo de David?'"
,"24":"Lo oyeron los fariseos y respondieron: '¡Este expulsa los demonios por obra de Beelzebú, príncipe de los demonios!'"
,"25":"Jesús sabía lo que estaban pensando, y les dijo: 'Todo reino que se divide, corre a la ruina; no hay ciudad o familia que pueda durar con luchas internas."
,"26":"Si Satanás expulsa a Satanás, está dividido; ¿cómo podrá mantenerse su reino?"
,"27":"Y si Beelzebú me ayuda a echar los demonios, ¿quién ayuda a la gente de ustedes cuando los echan? Ellos mismos les darán la respuesta."
,"28":"Pero si el Espíritu de Dios es el que me permite echar a los demonios, entiendan que el Reino de Dios ha llegado a ustedes."
,"29":"¿Quién entrará en la casa del Fuerte y le robará sus cosas, sino el que pueda amarrar al Fuerte? Sólo entonces le saqueará la casa."
,"30":"El que no está conmigo, está contra mí; y el que no recoge conmigo, desparrama."
,"31":"Por eso yo les digo: Se perdonará a los hombres cualquier pecado y cualquier insulto contra Dios. Pero calumniar al Espíritu Santo es cosa que no tendrá perdón."
,"32":"Al que calumnie al Hijo del Hombre se le perdonará; pero al que calumnie al Espíritu Santo, no se le perdonará ni en este mundo ni en el otro."
,"33":"Planten ustedes un árbol bueno, y su fruto será bueno; planten un árbol dañado, y su fruto será malo. Porque el árbol se conoce por sus frutos."
,"34":"Raza de víboras, si ustedes son tan malos, ¿cómo pueden decir algo bueno? La boca siempre habla de lo que está lleno el corazón."
,"35":"El hombre bueno saca cosas buenas del bien que guarda dentro, y el que es malo, de su mal acumulado saca cosas malas."
,"36":"Yo les digo que, en el día del juicio, los hombres tendrán que dar cuenta hasta de lo dicho que no podían justificar."
,"37":"Tus propias palabras te justificarán, y son tus palabras también las que te harán condenar.'"
,"38":"Entonces algunos maestros de la Ley y fariseos le dijeron: 'Maestro, queremos verte hacer un milagro.'"
,"39":"Pero él contestó: 'Esta raza perversa e infiel pide una señal, pero solamente se le dará la señal del profeta Jonás."
,"40":"Porque del mismo modo que Jonás estuvo tres días y tres noches en el vientre del gran pez, así también el Hijo del Hombre estará tres días y tres noches en el seno de la tierra."
,"41":"Los hombres de Nínive resucitarán en el día del juicio junto con esta generación y la condenarán, porque ellos cambiaron su conducta ante la predicación de Jonás, y aquí ustedes tienen mucho más que Jonás."
,"42":"La reina del Sur resucitará en el día del juicio junto con los hombres de hoy y los condenará, porque ella vino desde los confines de la tierra para escuchar la sabiduría de Salomón, y aquí ustedes tienen mucho más que Salomón."
,"43":"Cuando el espíritu malo sale del hombre, empieza a recorrer lugares áridos, buscando un sitio de descanso, y no lo encuentra."
,"44":"Entonces se dice: Volveré a mi casa de donde salí. Al llegar la encuentra desocupada, bien barrida y ordenada."
,"45":"Se va, entonces, y regresa con otros siete espíritus peores que él, entran y se quedan allí. La nueva condición de la persona es peor que la primera, y esto es lo que le va a pasar a esta generación perversa.'"
,"46":"Mientras Jesús estaba todavía hablando a la muchedumbre, su madre y sus hermanos estaban de pie afuera, pues querían hablar con él."
,"47":"Alguien le dijo: 'Tu madre y tus hermanos están ahí fuera y quieren hablar contigo.'"
,"48":"Pero Jesús dijo al que le daba el recado: '¿Quién es mi madre y quiénes son mis hermanos?'"
,"49":"E indicando con la mano a sus discípulos, dijo: 'Estos son mi madre y mis hermanos."
,"50":"Tomen a cualquiera que cumpla la voluntad de mi Padre de los Cielos, y ése es para mí un hermano, una hermana o una madre.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Ese día Jesús salió de casa y fue a sentarse a orillas del lago."
,"2":"Pero la gente vino a él en tal cantidad, que subió a una barca y se sentó en ella, mientras toda la gente se quedó en la orilla."
,"3":"Jesús les habló de muchas cosas, usando comparaciones o parábolas. Les decía: 'El sembrador salió a sembrar. "
,"4":"Y mientras sembraba, unos granos cayeron a lo largo del camino: vinieron las aves y se los comieron."
,"5":"Otros cayeron en terreno pedregoso, con muy poca tierra, y brotaron en seguida, pues no había profundidad."
,"6":"Pero apenas salió el sol, los quemó y, por falta de raíces, se secaron."
,"7":"Otros cayeron en medio de cardos: éstos crecieron y los ahogaron."
,"8":"Otros granos, finalmente, cayeron en buena tierra y produjeron cosecha, unos el ciento, otros el sesenta y otros el treinta por uno."
,"9":"El que tenga oídos, que escuche.'"
,"10":"Los discípulos se acercaron y preguntaron a Jesús: '¿Por qué les hablas en parábolas?'"
,"11":"Jesús les respondió: 'A ustedes se les ha concedido conocer los misterios del Reino de los Cielos, pero a ellos, no."
,"12":"Porque al que tiene se le dará más y tendrá en abundancia, pero al que no tiene, se le quitará aun lo que tiene."
,"13":"Por eso les hablo en parábolas, porque miran, y no ven; oyen, pero no escuchan ni entienden."
,"14":"En ellos se verifica la profecía de Isaías: Por más que oigan no entenderán, y por más que miren no verán."
,"15":"Este es un pueblo de conciencia endurecida. Sus oídos no saben escuchar, sus ojos están cerrados. No quieren ver con sus ojos, ni oír con sus oídos y comprender con su corazón... Pero con eso habría conversión y yo los sanaría."
,"16":"¡Dichosos los ojos de ustedes, que ven!; ¡dichosos los oídos de ustedes, que oyen!"
,"17":"Yo se lo digo: muchos profetas y muchas personas santas ansiaron ver lo que ustedes están viendo, y no lo vieron; desearon oír lo que ustedes están oyendo, y no lo oyeron."
,"18":"Escuchen ahora la parábola del sembrador:"
,"19":"Cuando uno oye la palabra del Reino y no la interioriza, viene el Maligno y le arrebata lo que fue sembrado en su corazón. Ahí tienen lo que cayó a lo largo del camino."
,"20":"La semilla que cayó en terreno pedregoso, es aquel que oye la Palabra y en seguida la recibe con alegría."
,"21":"En él, sin embargo, no hay raíces, y no dura más que una temporada. Apenas sobreviene alguna contrariedad o persecución por causa de la Palabra, inmediatamente se viene abajo."
,"22":"La semilla que cayó entre cardos, es aquel que oye la Palabra, pero luego las preocupaciones de esta vida y los encantos de las riquezas ahogan esta palabra, y al final no produce fruto."
,"23":"La semilla que cayó en tierra buena, es aquel que oye la Palabra y la comprende. Este ciertamente dará fruto y producirá cien, sesenta o treinta veces más.'"
,"24":"Jesús les propuso otra parábola: 'Aquí tienen una figura del Reino de los Cielos. Un hombre sembró buena semilla en su campo,"
,"25":"pero mientras la gente estaba durmiendo, vino su enemigo, sembró malas hierbas en medio del trigo y se fue."
,"26":"Cuando el trigo creció y empezó a echar espigas, apareció también la maleza."
,"27":"Entonces los trabajadores fueron a decirle al patrón: 'Señor, ¿no sembraste buena semilla en tu campo? ¿De dónde, pues, viene esa maleza?'"
,"28":"Respondió el patrón: 'Eso es obra de un enemigo.' Los obreros le preguntaron: '¿Quieres que arranquemos la maleza?'"
,"29":"'No, dijo el patrón, pues al quitar la maleza podrían arrancar también el trigo."
,"30":"Déjenlos crecer juntos hasta la hora de la cosecha. Entonces diré a los segadores: Corten primero las malas hierbas, hagan fardos y arrójenlos al fuego. Después cosechen el trigo y guárdenlo en mis bodegas.'"
,"31":"Jesús les propuso otra parábola: 'Aquí tienen una figura del Reino de los Cielos: el grano de mostaza que un hombre tomó y sembró en su campo."
,"32":"Es la más pequeña de las semillas, pero cuando crece, se hace más grande que las plantas de huerto. Es como un árbol, de modo que las aves vienen a posarse en sus ramas.'"
,"33":"Jesús les contó otra parábola: 'Aquí tienen otra figura del Reino de los Cielos: la levadura que toma una mujer y la introduce en tres medidas de harina. Al final, toda la masa fermenta.'"
,"34":"Todo esto lo contó Jesús al pueblo en parábolas. No les decía nada sin usar parábolas,"
,"35":"de manera que se cumplía lo dicho por el Profeta: Hablaré en parábolas, daré a conocer cosas que estaban ocultas desde la creación del mundo."
,"36":"Después Jesús despidió a la gente y se fue a casa. Los discípulos se le acercaron y le dijeron: 'Explícanos la parábola de las malas hierbas sembradas en el campo.'"
,"37":"Jesús les dijo: 'El que siembra la semilla buena es el Hijo del Hombre."
,"38":"El campo es el mundo. La buena semilla es la gente del Reino. La maleza es la gente del Maligno."
,"39":"El enemigo que la siembra es el diablo; la cosecha es el fin del mundo, y los segadores son los ángeles."
,"40":"Vean cómo se recoge la maleza y se quema: así sucederá al fin del mundo."
,"41":"El Hijo del Hombre enviará a sus ángeles; éstos recogerán de su Reino todos los escándalos y también los que obraban el mal,"
,"42":"y los arrojarán en el horno ardiente. Allí no habrá más que llanto y rechinar de dientes."
,"43":"Entonces los justos brillarán como el sol en el Reino de su Padre. Quien tenga oídos, que entienda."
,"44":"El Reino de los Cielos es como un tesoro escondido en un campo. El hombre que lo descubre, lo vuelve a esconder; su alegría es tal, que va a vender todo lo que tiene y compra ese campo."
,"45":"Aquí tienen otra figura del Reino de los Cielos: un comerciante que busca perlas finas."
,"46":"Si llega a sus manos una perla de gran valor, se va, vende cuanto tiene y la compra."
,"47":"Aquí tienen otra figura del Reino de los Cielos: una red que se ha echado al mar y que recoge peces de todas clases."
,"48":"Cuando está llena, los pescadores la sacan a la orilla, se sientan, escogen los peces buenos, los echan en canastos y tiran los que no sirven."
,"49":"Así pasará al final de los tiempos: vendrán los ángeles y separarán a los malos de entre los buenos"
,"50":"y los arrojarán al horno ardiente. Allí será el llorar y el rechinar de dientes.'"
,"51":"Preguntó Jesús: '¿Han entendido ustedes todas estas cosas?' Ellos le respondieron: 'Sí.'"
,"52":"Entonces Jesús dijo: 'Está bien: cuando un maestro en religión ha sido instruido sobre el Reino de los Cielos, se parece a un padre de familia que siempre saca de sus armarios cosas nuevas y viejas.'"
,"53":"Cuando Jesús terminó de decir estas parábolas, se fue de allí."
,"54":"Un día se fue a su pueblo y enseñó a la gente en su sinagoga. Todos quedaban maravillados y se preguntaban: '¿De dónde le viene esa sabiduría? ¿Y de dónde esos milagros?"
,"55":"¿No es éste el hijo del carpintero? ¡Pero si su madre es María, y sus hermanos son Santiago, y José, y Simón, y Judas!"
,"56":"Sus hermanas también están todas entre nosotros, ¿no es cierto? ¿De dónde, entonces, le viene todo eso?' Ellos se escandalizaban y no lo reconocían."
,"57":"Entonces Jesús les dijo: 'Si hay un lugar donde un profeta es despreciado, es en su patria y en su propia familia.'"
,"58":"Y como no creían en él, no hizo allí muchos milagros."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Por aquel tiempo, la fama de Jesús había llegado hasta el virrey Herodes."
,"2":"Y dijo a sus servidores: 'Éste es Juan Bautista; Juan ha resucitado de entre los muertos y por eso actúan en él poderes milagrosos.'"
,"3":"En efecto, Herodes había ordenado detener a Juan, lo había hecho encadenar y encerrar en la cárcel a causa de Herodías, esposa de su hermano Filipo."
,"4":"Porque Juan le decía: 'La Ley no te permite tenerla como esposa.'"
,"5":"Herodes quería matarlo, pero tenía miedo de la gente, que consideraba a Juan como un profeta."
,"6":"En eso llegó el cumpleaños de Herodes. La hija de Herodías salió a bailar en medio de los invitados, y le gustó tanto a Herodes"
,"7":"que le prometió bajo juramento darle todo lo que le pidiera."
,"8":"La joven, a instigación de su madre, le respondió: 'Dame aquí, en una bandeja, la cabeza de Juan Bautista.'"
,"9":"El rey se sintió muy molesto, porque se había comprometido bajo juramento en presencia de los invitados; aceptó entregársela,"
,"10":"y mandó decapitar a Juan en la cárcel."
,"11":"Su cabeza fue traída en una bandeja y entregada a la muchacha, quien a su vez se la llevó a su madre."
,"12":"Después vinieron los discípulos de Juan a recoger su cuerpo y lo enterraron. Y fueron a dar la noticia a Jesús."
,"13":"Al conocer esa noticia, Jesús se alejó discretamente de allí en una barca y fue a un lugar despoblado. Pero la gente lo supo y en seguida lo siguieron por tierra desde sus pueblos."
,"14":"Al desembarcar Jesús y encontrarse con tan gran gentío, sintió compasión de ellos y sanó a sus enfermos."
,"15":"Cuando ya caía la tarde, sus discípulos se le acercaron, diciendo: 'Estamos en un lugar despoblado y ya ha pasado la hora. Despide a esta gente para que se vayan a las aldeas y se compren algo de comer.'"
,"16":"Pero Jesús les dijo: 'No tienen por qué irse; denles ustedes de comer.'"
,"17":"Ellos respondieron: 'Aquí sólo tenemos cinco panes y dos pescados'."
,"18":"Jesús les dijo: 'Tráiganmelos para acá.'"
,"19":"Y mandó a la gente que se sentara en el pasto. Tomó los cinco panes y los dos pescados, levantó los ojos al cielo, pronunció la bendición, partió los panes y los entregó a los discípulos. Y los discípulos los daban a la gente."
,"20":"Todos comieron y se saciaron, y se recogieron los pedazos que sobraron: ¡doce canastos llenos!"
,"21":"Los que habían comido eran unos cinco mil hombres, sin contar mujeres y niños."
,"22":"Inmediatamente después Jesús obligó a sus discípulos a que se embarcaran; debían llegar antes que él a la otra orilla, mientras él despedía a la gente."
,"23":"Jesús, pues, despidió a la gente, y luego subió al cerro para orar a solas. Cayó la noche, y él seguía allí solo."
,"24":"La barca en tanto estaba ya muy lejos de tierra, y las olas le pegaban duramente, pues soplaba el viento en contra."
,"25":"Antes del amanecer, Jesús vino hacia ellos caminando sobre el mar."
,"26":"Al verlo caminando sobre el mar, se asustaron y exclamaron: '¡Es un fantasma!' Y por el miedo se pusieron a gritar."
,"27":"En seguida Jesús les dijo: 'Animo, no teman, que soy yo.'"
,"28":"Pedro contestó: 'Señor, si eres tú, manda que yo vaya a ti caminando sobre el agua.'"
,"29":"Jesús le dijo: 'Ven.' Pedro bajó de la barca y empezó a caminar sobre las aguas en dirección a Jesús."
,"30":"Pero el viento seguía muy fuerte, tuvo miedo y comenzó a hundirse. Entonces gritó: '¡Señor, sálvame!'"
,"31":"Al instante Jesús extendió la mano y lo agarró, diciendo: 'Hombre de poca fe, ¿por qué has vacilado?'"
,"32":"Subieron a la barca y cesó el viento,"
,"33":"y los que estaban en la barca se postraron ante él, diciendo: '¡Verdaderamente tú eres el Hijo de Dios!'"
,"34":"Terminada la travesía, desembarcaron en Genesaret."
,"35":"Los hombres de aquel lugar reconocieron a Jesús y comunicaron la noticia por toda la región, así que le trajeron todos los enfermos."
,"36":"Le rogaban que los dejara tocar al menos el fleco de su manto, y todos los que lo tocaron quedaron totalmente sanos."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Unos fariseos y maestros de la Ley habían venido de Jerusalén. Se acercaron a Jesús"
,"2":"y le dijeron: '¿Por qué tus discípulos no respetan la tradición de los antepasados? No se lavan las manos antes de comer.'"
,"3":"Jesús contestó: 'Y ustedes, ¿por qué quebrantan el mandamiento de Dios en nombre de sus tradiciones?"
,"4":"Pues Dios ordenó: Cumple tus deberes con tu padre y con tu madre. Y también: El que maldiga a su padre o a su madre debe ser condenado a muerte."
,"5":"En cambio, según ustedes, es correcto decir a su padre o a su madre: Lo que podías esperar de mí, ya lo tengo reservado para el Templo."
,"6":"En este caso, según ustedes, una persona queda libre de sus deberes para con su padre y su madre. Y es así como ustedes anulan el mandamiento de Dios en nombre de sus tradiciones."
,"7":"¡Qué bien salvan las apariencias! Con justa razón profetizó Isaías de ustedes cuando dijo:"
,"8":"Este pueblo me honra con los labios, pero su corazón está lejos de mí."
,"9":"El culto que me rinden no sirve de nada, las doctrinas que enseñan no son más que mandatos de hombres.'"
,"10":"Luego Jesús mandó acercarse a la gente y les dijo: 'Escuchen y entiendan:"
,"11":"Lo que entra por la boca no hace impura a la persona, pero sí mancha a la persona lo que sale de su boca.'"
,"12":"Poco después los discípulos se acercaron y le dijeron: '¿Sabes que los fariseos se han escandalizado de tu declaración?'"
,"13":"Jesús respondió: 'Toda planta que no haya plantado mi Padre celestial será arrancada de raíz."
,"14":"¡No les hagan caso! Son ciegos que guían a otros ciegos. Y si un ciego guía a otro ciego, los dos caerán en el hoyo.'"
,"15":"Entonces Pedro le pidió: 'Explícanos esta sentencia.'"
,"16":"Jesús le respondió: '¿También ustedes están todavía cerrados?"
,"17":"¿No comprenden que todo lo que entra por la boca va al estómago y después termina en el basural?"
,"18":"En cambio lo que sale de la boca procede del corazón, y eso es lo que hace impura a la persona."
,"19":"Del corazón proceden los malos deseos, asesinatos, adulterios, inmoralidad sexual, robos, mentiras, chismes."
,"20":"Estas son las cosas que hacen impuro al hombre; pero el comer sin lavarse las manos no hace impuro al hombre.'"
,"21":"Jesús marchó de allí y se fue en dirección a las tierras de Tiro y Sidón."
,"22":"Una mujer cananea, que llegaba de ese territorio, empezó a gritar: '¡Señor, hijo de David, ten compasión de mí! Mi hija está atormentada por un demonio.'"
,"23":"Pero Jesús no le contestó ni una palabra. Entonces sus discípulos se acercaron y le dijeron: 'Atiéndela, mira cómo grita detrás de nosotros.'"
,"24":"Jesús contestó: 'No he sido enviado sino a las ovejas perdidas del pueblo de Israel.'"
,"25":"Pero la mujer se acercó a Jesús y, puesta de rodillas, le decía: '¡Señor, ayúdame!'"
,"26":"Jesús le dijo: 'No se debe echar a los perros el pan de los hijos.'"
,"27":"La mujer contestó: 'Es verdad, Señor, pero también los perritos comen las migajas que caen de la mesa de sus amos.'"
,"28":"Entonces Jesús le dijo: 'Mujer, ¡qué grande es tu fe! Que se cumpla tu deseo.' Y en aquel momento quedó sana su hija."
,"29":"De allí Jesús volvió a la orilla del mar de Galilea y, subiendo al cerro, se sentó en ese lugar."
,"30":"Un gentío muy numeroso se acercó a él trayendo mudos, ciegos, cojos, mancos y personas con muchas otras enfermedades. Los colocaron a los pies de Jesús y él los sanó."
,"31":"La gente quedó maravillada al ver que hablaban los mudos y caminaban los cojos, que los lisiados quedaban sanos y que los ciegos recuperaban la vista; todos glorificaban al Dios de Israel."
,"32":"Jesús llamó a sus discípulos y les dijo: 'Siento compasión de esta gente, pues hace ya tres días que me siguen y no tienen comida. Y no quiero despedirlos en ayunas, porque temo que se desmayen en el camino.'"
,"33":"Sus discípulos le respondieron: 'Estamos en un desierto, ¿dónde vamos a encontrar suficiente pan como para alimentar a tanta gente?'"
,"34":"Jesús les dijo: '¿Cuántos panes tienen ustedes?' Respondieron: 'Siete, y algunos pescaditos.'"
,"35":"Entonces Jesús mandó a la gente que se sentara en el suelo."
,"36":"Tomó luego los siete panes y los pescaditos, dio gracias y los partió. Iba entregándolos a los discípulos, y éstos los repartían a la gente."
,"37":"Todos comieron hasta saciarse y llenaron siete cestos con los pedazos que sobraron."
,"38":"Los que habían comido eran cuatro mil hombres, sin contar mujeres y niños."
,"39":"Después Jesús despidió a la muchedumbre, subió a la barca y fue al territorio de Magadán."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Los fariseos y los saduceos se acercaron a Jesús. Querían ponerlo en apuros, y le pidieron una señal milagrosa que viniera del Cielo."
,"2":"Jesús respondió: 'Al atardecer ustedes dicen: Hará buen tiempo, pues el cielo está rojo y encendido."
,"3":"Y por la mañana: Con este cielo rojo obscuro, hoy habrá tormenta. Ustedes, pues, conocen e interpretan los aspectos del cielo, ¿y no tienen capacidad para las señales de los tiempos?"
,"4":"¡Generación mala y adúltera! Ustedes piden una señal, pero señal no tendrán, sino la señal de Jonás.',Jesús, pues, los dejó y se marchó."
,"5":"Los discípulos, al pasar a la otra orilla, se habían olvidado de llevar pan."
,"6":"Jesús les dijo: 'Tengan cuidado y desconfíen de la levadura de los fariseos y de los saduceos.'"
,"7":"Ellos empezaron a comentar entre sí: '¡Caramba!, no trajimos pan.'"
,"8":"Jesús se dio cuenta y les dijo: '¿Por qué se preocupan, hombres de poca fe? ¿Porque no tienen pan?"
,"9":"¿Es que aún no comprenden? ¿No se acuerdan de los cinco panes para los cinco mil hombres, y cuántas canastas recogieron?"
,"10":"¿Ni de los siete panes para los cuatro mil hombres, y cuántos cestos llenaron con lo que sobró?"
,"11":"Yo no me refería al pan cuando les dije: Cuídense de la levadura de los fariseos y de los saduceos. ¿Cómo puede ser que no me hayan comprendido?'"
,"12":"Entonces entendieron a lo que Jesús se refería: que debían tener los ojos abiertos, no para cosas de levadura, sino para las enseñanzas de los fariseos y saduceos."
,"13":"Jesús se fue a la región de Cesarea de Filipo. Estando allí, preguntó a sus discípulos: 'Según el parecer de la gente, ¿quién soy yo? ¿Quién es el Hijo del Hombre?'"
,"14":"Respondieron: 'Unos dicen que eres Juan el Bautista, otros que eres Elías o Jeremías, o alguno de los profetas.'"
,"15":"Jesús les preguntó: 'Y ustedes, ¿quién dicen que soy yo?'"
,"16":"Pedro contestó: 'Tú eres el Mesías, el Hijo del Dios vivo.'"
,"17":"Jesús le replicó: 'Feliz eres, Simón Barjona, porque esto no te lo ha revelado la carne ni la sangre, sino mi Padre que está en los Cielos."
,"18":"Y ahora yo te digo: Tú eres Pedro (o sea Piedra), y sobre esta piedra edificaré mi Iglesia; los poderes de la muerte jamás la podrán vencer."
,"19":"Yo te daré las llaves del Reino de los Cielos: lo que ates en la tierra quedará atado en el Cielo, y lo que desates en la tierra quedará desatado en el Cielo.'"
,"20":"Entonces Jesús les ordenó a sus discípulos que no dijeran a nadie que él era el Mesías."
,"21":"A partir de ese día, Jesucristo comenzó a manifestar a sus discípulos que él debía ir a Jerusalén y que las autoridades judías, los sumos sacerdotes y los maestros de la Ley lo iban a hacer sufrir mucho, que incluso debía ser muerto y que resucitaría al tercer día."
,"22":"Pedro lo llevó aparte y se puso a reprenderlo: '¡Dios no lo permita, Señor! Nunca te sucederán tales cosas.'"
,"23":"Pero Jesús se volvió y le dijo: '¡Pasa detrás de mí, Satanás! Tú me harías tropezar. Tus ambiciones no son las de Dios, sino las de los hombres.'"
,"24":"Entonces dijo Jesús a sus discípulos: 'El que quiera seguirme, que renuncie a sí mismo, cargue con su cruz y me siga."
,"25":"Pues el que quiera asegurar su vida la perderá, pero el que sacrifique su vida por causa mía, la hallará."
,"26":"¿De qué le serviría a uno ganar el mundo entero si se destruye a sí mismo? ¿Qué dará para rescatarse a sí mismo?"
,"27":"Sepan que el Hijo del Hombre vendrá con la gloria de su Padre, rodeado de sus ángeles, y entonces recompensará a cada uno según su conducta."
,"28":"En verdad les digo: algunos que están aquí presentes no pasarán por la muerte sin antes haber visto al Hijo del Hombre viniendo como Rey.'"
}`)
	CurrentBook.AddChapter(17, `{
"1":"Seis días después, Jesús tomó consigo a Pedro, a Santiago y a su hermano Juan, y los llevó aparte a un monte alto."
,"2":"A la vista de ellos su aspecto cambió completamente: su cara brillaba como el sol y su ropa se volvió blanca como la luz."
,"3":"En seguida vieron a Moisés y Elías hablando con Jesús."
,"4":"Pedro tomó la palabra y dijo a Jesús: 'Señor, ¡qué bueno es que estemos aquí! Si quieres, levantaré aquí tres tiendas: una para ti, otra para Moisés y otra para Elías.'"
,"5":"Estaba Pedro todavía hablando cuando una nube luminosa los cubrió con su sombra y una voz que salía de la nube dijo: '¡Este es mi Hijo, el Amado; éste es mi Elegido, escúchenlo!'"
,"6":"Al oír la voz, los discípulos se echaron al suelo, llenos de miedo."
,"7":"Pero Jesús se acercó, los tocó y les dijo: 'Levántense, no tengan miedo.'"
,"8":"Ellos levantaron los ojos, pero ya no vieron a nadie más que a Jesús."
,"9":"Mientras bajaban del monte, Jesús les ordenó: 'No hablen a nadie de esta visión hasta que el Hijo del Hombre haya resucitado de entre los muertos.'"
,"10":"Los discípulos le preguntaron: '¿Por qué dicen los maestros de la Ley que Elías ha de venir primero?'"
,"11":"Contestó Jesús: 'Bien es cierto que Elías ha de venir para reordenar todas las cosas."
,"12":"Pero créanme: ya vino Elías y no lo reconocieron, sino que lo trataron como se les antojó. Y así también harán sufrir al Hijo del Hombre.'"
,"13":"Entonces los discípulos comprendieron que Jesús se refería a Juan el Bautista."
,"14":"Cuando volvieron donde estaba la gente, se acercó un hombre a Jesús y se arrodilló ante él. Le dijo:"
,"15":"'Señor, ten piedad de mi hijo, que es epiléptico y su estado es lastimoso. A menudo se nos cae al fuego, y otras veces al agua."
,"16":"Lo he llevado a tus discípulos, pero no han podido curarlo.'"
,"17":"Jesús respondió: '¡Qué generación tan incrédula y malvada! ¿Hasta cuándo estaré entre ustedes? ¿Hasta cuándo tendré que soportarlos? Tráiganmelo acá.'"
,"18":"En seguida Jesús dio una orden al demonio, que salió, y desde ese momento el niño quedó sano."
,"19":"Entonces los discípulos se acercaron a Jesús y le preguntaron en privado: '¿Por qué nosotros no pudimos echar a ese demonio?'"
,"20":"Jesús les dijo: 'Porque ustedes tienen poca fe. En verdad les digo: si tuvieran fe, del tamaño de un granito de mostaza, le dirían a este cerro: Quítate de ahí y ponte más allá, y el cerro obedecería. Nada sería imposible para ustedes."
,"21":"(Esta clase de demonios sólo se puede expulsar con la oración y el ayuno).'"
,"22":"Un día, estando Jesús en Galilea con los apóstoles, les dijo: 'El Hijo del Hombre va a ser entregado en manos de los hombres,"
,"23":"y le matarán, pero resucitará al tercer día.' Ellos se pusieron muy tristes."
,"24":"Al volver a Cafarnaún, se acercaron a Pedro los que cobran el impuesto para el Templo. Le preguntaron: 'El maestro de ustedes, ¿no paga el impuesto?'"
,"25":"Pedro respondió: 'Claro que sí'. Y se fue a casa. Cuando entraba, se anticipó Jesús y le dijo: 'Dame tu parecer, Simón. ¿Quiénes son los que pagan impuestos o tributos a los reyes de la tierra: sus hijos o los que no son de la familia?' "
,"26":"Pedro contestó: 'Los que no son de la familia.' Y Jesús le dijo: 'Entonces los hijos no pagan.27 Sin embargo, para no escandalizar a esta gente, vete a la playa y echa el anzuelo. Al primer pez que pesques ábrele la boca, y hallarás en ella una moneda de plata. Tómala y paga por mí y por ti.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"En aquel momento los discípulos se acercaron a Jesús y le preguntaron: '¿Quién es el más grande en el Reino de los Cielos?'"
,"2":"Jesús llamó a un niñito, lo colocó en medio de los discípulos,"
,"3":"y declaró: 'En verdad les digo: si no cambian y no llegan a ser como niños, nunca entrarán en el Reino de los Cielos."
,"4":"El que se haga pequeño como este niño, ése será el más grande en el Reino de los Cielos."
,"5":"Y el que recibe en mi nombre a un niño como éste, a mí me recibe."
,"6":"Al que haga caer a uno de estos pequeños que creen en mí, mejor le sería que le amarraran al cuello una gran piedra de moler y que lo hundieran en lo más profundo del mar."
,"7":"¡Ay del mundo a causa de los escándalos! Tiene que haber escándalos, pero, ¡ay del que causa el escándalo!"
,"8":"Si tu mano o tu pie te está haciendo caer, córtatelo y tíralo lejos. Pues es mejor para ti entrar en la vida sin una mano o sin un pie que ser echado al fuego eterno con las dos manos y los dos pies."
,"9":"Y si tu ojo te está haciendo caer, arráncalo y tíralo lejos. Pues es mejor para ti entrar tuerto en la vida que ser arrojado con los dos ojos al fuego del infierno."
,"10":"Cuídense, no desprecien a ninguno de estos pequeños. Pues yo se lo digo: sus ángeles en el Cielo contemplan sin cesar la cara de mi Padre del Cielo."
,"12":"¿Qué pasará, según ustedes, si un hombre tiene cien ovejas y una de ellas se extravía? ¿No dejará las noventa y nueve en los cerros para ir a buscar la extraviada?"
,"13":"Y si logra encontrarla, yo les digo que ésta le dará más alegría que las noventa y nueve que no se extraviaron."
,"14":"Pasa lo mismo donde el Padre de ustedes, el Padre del Cielo: allá no quieren que se pierda ni tan sólo uno de estos pequeñitos."
,"15":"Si tu hermano ha pecado, vete a hablar con él a solas para reprochárselo. Si te escucha, has ganado a tu hermano."
,"16":"Si no te escucha, toma contigo una o dos personas más, de modo que el caso se decida por la palabra de dos o tres testigos."
,"17":"Si se niega a escucharlos, informa a la asamblea. Si tampoco escucha a la iglesia, considéralo como un pagano o un publicano."
,"18":"Yo les digo: 'Todo lo que aten en la tierra, lo mantendrá atado el Cielo, y todo lo que desaten en la tierra, lo mantendrá desatado el Cielo."
,"19":"Asimismo yo les digo: si en la tierra dos de ustedes se ponen de acuerdo para pedir alguna cosa, mi Padre Celestial se lo concederá."
,"20":"Pues donde están dos o tres reunidos en mi Nombre, allí estoy yo, en medio de ellos.'"
,"21":"Entonces Pedro se acercó con esta pregunta: 'Señor, ¿cuántas veces tengo que perdonar las ofensas de mi hermano? ¿Hasta siete veces?'"
,"22":"Jesús le contestó: 'No te digo siete, sino setenta y siete veces.'"
,"23":"'Aprendan algo sobre el Reino de los Cielos. Un rey había decidido arreglar cuentas con sus empleados,"
,"24":"y para empezar, le trajeron a uno que le debía diez mil monedas de oro."
,"25":"Como el hombre no tenía con qué pagar, el rey ordenó que fuera vendido como esclavo, junto con su mujer, sus hijos y todo cuanto poseía, para así recobrar algo."
,"26":"El empleado, pues, se arrojó a los pies del rey, suplicándole: 'Dame un poco de tiempo, y yo te lo pagaré todo.'"
,"27":"El rey se compadeció y lo dejó libre; más todavía, le perdonó la deuda."
,"28":"Pero apenas salió el empleado de la presencia del rey, se encontró con uno de sus compañeros que le debía cien monedas. Lo agarró del cuello y casi lo ahogaba, gritándole: 'Págame lo que me debes.'"
,"29":"El compañero se echó a sus pies y le rogaba: 'Dame un poco de tiempo, y yo te lo pagaré todo.'"
,"30":"Pero el otro no aceptó, sino que lo mandó a la cárcel hasta que le pagara toda la deuda."
,"31":"Los compañeros, testigos de esta escena, quedaron muy molestos y fueron a contárselo todo a su señor."
,"32":"Entonces el señor lo hizo llamar y le dijo: 'Siervo miserable, yo te perdoné toda la deuda cuando me lo suplicaste."
,"33":"¿No debías también tú tener compasión de tu compañero como yo tuve compasión de ti?'"
,"34":"Y tanto se enojó el señor, que lo puso en manos de los verdugos hasta que pagara toda la deuda."
,"35":"Y Jesús añadió: 'Lo mismo hará mi Padre Celestial con ustedes, a no ser que cada uno perdone de corazón a su hermano.'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"Después de terminar este discurso, Jesús partió de Galilea y llegó a las fronteras de Judea por la otra orilla del Jordán."
,"2":"También allí mucha gente vino a él y los sanó."
,"3":"Se le acercaron unos fariseos y lo pusieron a prueba con esta pregunta: '¿Está permitido a un hombre divorciarse de su mujer por cualquier motivo?'"
,"4":"Jesús respondió: '¿No han leído que el Creador al principio los hizo hombre y mujer"
,"5":"y dijo: El hombre dejará a su padre y a su madre y se unirá con su mujer, y serán los dos una sola carne?"
,"6":"De manera que ya no son dos, sino una sola carne. Pues bien, lo que Dios ha unido, no lo separe el hombre.'"
,"7":"Los fariseos le preguntaron: 'Entonces, ¿por qué Moisés ordenó que se firme un certificado en el caso de divorciarse?'"
,"8":"Jesús contestó: 'Moisés vio lo tercos que eran ustedes, y por eso les permitió despedir a sus mujeres, pero al principio no fue así."
,"9":"Yo les digo: el que se divorcia de su mujer, fuera del caso de infidelidad, y se casa con otra, comete adulterio.'"
,"10":"Los discípulos le dijeron: 'Si ésa es la condición del hombre que tiene mujer, es mejor no casarse.'"
,"11":"Jesús les contestó: 'No todos pueden captar lo que acaban de decir, sino aquellos que han recibido este don."
,"12":"Hay hombres que han nacido incapacitados para el sexo. Hay otros incapacitados, que fueron mutilados por los hombres. Hay otros todavía, que se hicieron tales por el Reino de los Cielos. ¡Entienda el que pueda!'"
,"13":"Entonces trajeron a Jesús algunos niños para que les impusiera las manos y rezara por ellos. Pero los discípulos los recibían muy mal."
,"14":"Jesús les dijo: 'Dejen a esos niños y no les impidan que vengan a mí: el Reino de los Cielos pertenece a los que son como ellos.'"
,"15":"Jesús les impuso las manos y continuó su camino."
,"16":"Un hombre joven se le acercó y le dijo: 'Maestro, ¿qué es lo bueno que debo hacer para conseguir la vida eterna?'"
,"17":"Jesús contestó: '¿Por qué me preguntas sobre lo que es bueno? Uno solo es el Bueno. Pero si quieres entrar en la vida, cumple los mandamientos.'"
,"18":"El joven dijo: '¿Cuáles?' Jesús respondió: 'No matar, no cometer adulterio, no hurtar, no levantar falso testimonio,"
,"19":"honrar al padre y a la madre y amar al prójimo como a sí mismo.'"
,"20":"El joven le dijo: 'Todo esto lo he guardado, ¿qué más me falta?'"
,"21":"Jesús le dijo: 'Si quieres ser perfecto, vende todo lo que posees y reparte el dinero entre los pobres, para que tengas un tesoro en el Cielo. Después ven y sígueme.'"
,"22":"Cuando el joven oyó esta respuesta, se marchó triste, porque era un gran terrateniente."
,"23":"Entonces Jesús dijo a sus discípulos: 'En verdad les digo: el que es rico entrará muy difícilmente en el Reino de los Cielos."
,"24":"Les aseguro: es más fácil para un camello pasar por el ojo de una aguja que para un rico entrar en el Reino de los cielos.'"
,"25":"Los discípulos, al escucharlo, se quedaron asombrados. Dijeron: 'Entonces, ¿quién puede salvarse?'"
,"26":"Fijando en ellos su mirada, Jesús les dijo: 'Para los hombres es imposible, pero para Dios todo es posible.'"
,"27":"Entonces Pedro tomó la palabra y dijo: 'Ya ves que nosotros lo hemos dejado todo para seguirte. ¿Qué recibiremos?'"
,"28":"Jesús contestó: 'A ustedes que me han seguido, yo les digo: cuando todo comience nuevamente y el Hijo del Hombre se siente en su trono de gloria, ustedes también se sentarán en doce tronos, para juzgar a las doce tribus de Israel."
,"29":"Y todo el que haya dejado casas, hermanos, hermanas, padre, madre, hijos o propiedades por causa de mi Nombre, recibirá cien veces más y tendrá por herencia la vida eterna."
,"30":"Muchos que ahora son primeros serán últimos, y otros que ahora son últimos, serán primeros.'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"Aprendan algo del Reino de los Cielos. Un propietario salió de madrugada a contratar trabajadores para su viña."
,"2":"Se puso de acuerdo con ellos para pagarles una moneda de plata al día, y los envió a su viña."
,"3":"Salió de nuevo hacia las nueve de la mañana, y al ver en la plaza a otros que estaban desocupados,"
,"4":"les dijo: 'Vayan ustedes también a mi viña y les pagaré lo que sea justo.' Y fueron a trabajar."
,"5":"Salió otra vez al mediodía, y luego a las tres de la tarde, e hizo lo mismo."
,"6":"Ya era la última hora del día, la undécima, cuando salió otra vez y vio a otros que estaban allí parados. Les preguntó: '¿Por qué se han quedado todo el día sin hacer nada?'"
,"7":"Contestaron ellos: 'Porque nadie nos ha contratado.' Y les dijo: 'Vayan también ustedes a trabajar en mi viña.'"
,"8":"Al anochecer, dijo el dueño de la viña a su mayordomo: 'Llama a los trabajadores y págales su jornal, empezando por los últimos y terminando por los primeros.'"
,"9":"Vinieron los que habían ido a trabajar a última hora, y cada uno recibió un denario (una moneda de plata)."
,"10":"Cuando llegó el turno a los primeros, pensaron que iban a recibir más, pero también recibieron cada uno un denario."
,"11":"Por eso, mientras se les pagaba, protestaban contra el propietario."
,"12":"Decían: 'Estos últimos apenas trabajaron una hora, y los consideras igual que a nosotros, que hemos aguantado el día entero y soportado lo más pesado del calor.'"
,"13":"El dueño contestó a uno de ellos: 'Amigo, yo no he sido injusto contigo. ¿No acordamos en un denario al día?"
,"14":"Toma lo que te corresponde y márchate. Yo quiero dar al último lo mismo que a ti."
,"15":"¿No tengo derecho a llevar mis cosas de la manera que quiero? ¿O será porque soy generoso y tú envidioso?'"
,"16":"Así sucederá: los últimos serán primeros, y los primeros serán últimos.'"
,"17":"Mientras iban subiendo a Jerusalén, Jesús tomó aparte a los Doce y les dijo por el camino:"
,"18":"'Ya estamos subiendo a Jerusalén; el Hijo del Hombre va a ser entregado a los jefes de los sacerdotes y a los maestros de la Ley, que lo condenarán a muerte."
,"19":"Ellos lo entregarán a los extranjeros, que se burlarán de él, lo azotarán y lo crucificarán. Pero resucitará al tercer día.'"
,"20":"Entonces la madre de Santiago y Juan se acercó con sus hijos a Jesús y se arrodilló para pedirle un favor."
,"21":"Jesús le dijo: '¿Qué quieres?' Y ella respondió: 'Aquí tienes a mis dos hijos. Asegúrame que, cuando estés en tu reino, se sentarán uno a tu derecha y otro a tu izquierda.'"
,"22":"Jesús dijo a los hermanos: 'No saben lo que piden. ¿Pueden ustedes beber la copa que yo tengo que beber?' Ellos respondieron: 'Podemos.'"
,"23":"Jesús replicó: 'Ustedes sí beberán mi copa, pero no me corresponde a mí el concederles que se sienten a mi derecha o a mi izquierda. Eso será para quienes el Padre lo haya dispuesto.'"
,"24":"Los otros diez se enojaron con los dos hermanos al oír esto."
,"25":"Jesús los llamó y les dijo: 'Ustedes saben que los gobernantes de las naciones actúan como dictadores y los que ocupan cargos abusan de su autoridad."
,"26":"Pero no será así entre ustedes. Al contrario, el que de ustedes quiera ser grande, que se haga el servidor de ustedes,27 y si alguno de ustedes quiere ser el primero entre ustedes, que se haga el esclavo de todos."
,"28":"Hagan como el Hijo del Hombre, que no vino a ser servido, sino a servir y dar su vida como rescate por una muchedumbre.'"
,"29":"Al salir de Jericó, les iba siguiendo una gran multitud de gente."
,"30":"En algún momento, dos ciegos estaban sentados a la orilla del camino, y al enterarse de que pasaba Jesús, comenzaron a gritar: '¡Señor, hijo de David, ten compasión de nosotros!'"
,"31":"La gente les decía que se callaran, pero ellos gritaban aún más fuerte: '¡Señor, hijo de David, ten compasión de nosotros!'"
,"32":"Jesús se detuvo, los llamó y les preguntó: '¿Qué quieren que haga por ustedes?'"
,"33":"Ellos dijeron: 'Señor, que se abran nuestros ojos.'"
,"34":"Jesús sintió compasión y les tocó los ojos. Y al momento recobraron la vista y lo siguieron."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Estaban ya cerca de Jerusalén. Cuando llegaron a Betfagé, junto al monte de los Olivos,"
,"2":"Jesús envió a dos discípulos con esta misión: 'Vayan al pueblecito que está al frente, y allí encontrarán una burra atada con su burrito al lado. Desátenla y tráiganmela."
,"3":"Si alguien les dice algo, contéstenle: El Señor los necesita, y los devolverá cuanto antes.'"
,"4":"Esto sucedió para que se cumpliera lo dicho por el profeta:"
,"5":"Digan a la hija de Sión: 'Mira que tu rey viene a ti con toda sencillez, montado en una burra, un animal de carga.'"
,"6":"Los discípulos se fueron e hicieron como Jesús les había mandado."
,"7":"Le trajeron la burra con su cría, le colocaron sus mantos sobre el lomo y él se sentó encima."
,"8":"Había muchísima gente; extendían sus mantos en el camino, o bien cortaban ramas de árboles, con las que cubrían el suelo."
,"9":"Y el gentío que iba delante de Jesús, así como los que le seguían, empezaron a gritar: '¡Hosanna al hijo de David! ¡Bendito sea el que viene en el nombre del Señor! ¡Hosanna en lo más alto de los cielos!'"
,"10":"Cuando Jesús entró en Jerusalén, toda la ciudad se alborotó y preguntaban: '¿Quién es éste?'"
,"11":"Y la muchedumbre respondía: '¡Este es el profeta Jesús, de Nazaret de Galilea!'"
,"12":"Jesús entró en el Templo y echó fuera a todos los que vendían y compraban en el Templo. Derribó las mesas de los que cambiaban monedas y los puestos de los vendedores de palomas. Les dijo:"
,"13":"'Está escrito: Mi casa será llamada Casa de Oración. Pero ustedes la han convertido en una cueva de ladrones.'"
,"14":"También en el Templo se le acercaron algunos ciegos y cojos, y Jesús los sanó."
,"15":"Los sacerdotes principales y los maestros de la Ley vieron las cosas tan asombrosas que Jesús acababa de hacer y a los niños que clamaban en el Templo: '¡Hosanna al hijo de David!'. Estaban furiosos"
,"16":"y le dijeron: '¿Oyes lo que dicen ésos?' Les respondió Jesús: 'Por supuesto. ¿No han leído, por casualidad, esa Escritura que dice: Tú mismo has puesto tus alabanzas en la boca de los niños y de los que aún maman?'"
,"17":"En seguida Jesús los dejó y salió de la ciudad en dirección a Betania, donde pasó la noche."
,"18":"Al regresar a la ciudad, muy de mañana, Jesús sintió hambre."
,"19":"Divisando una higuera cerca del camino, se acercó, pero no encontró más que hojas. Entonces dijo a la higuera: '¡Nunca jamás volverás a dar fruto!' Y al instante la higuera se secó."
,"20":"Al ver esto, los discípulos se maravillaron: '¿Cómo pudo secarse la higuera, y tan rápido?'"
,"21":"Jesús les declaró: 'En verdad les digo: si tienen tanta fe como para no vacilar, ustedes harán mucho más que secar una higuera. Ustedes dirán a ese cerro:"
,"22":"¡Quítate de ahí y échate al mar!, y así sucederá. Todo lo que pidan en la oración, con tal de que crean, lo recibirán.'"
,"23":"Jesús había entrado al Templo y estaba enseñando, cuando los sumos sacerdotes y las autoridades judías fueron a su encuentro para preguntarle: '¿Con qué derecho haces todas estas cosas? ¿Quién te lo ha encargado?'"
,"24":"Jesús les contestó: 'Yo también les voy a hacer a ustedes una pregunta. Si me la contestan, yo también les diré con qué autoridad hago todo esto."
,"25":"Háblenme del bautismo que daba Juan: este asunto ¿de dónde venía: de Dios o de los hombres?',Ellos reflexionaron: 'Si decimos que este asunto venía de Dios, él nos replicará: Pues ¿por qué no le creyeron? "
,"26":"Y si decimos que era cosa de hombres, ¡cuidado con el pueblo!, pues todos consideran a Juan como un profeta.'"
,"27":"Entonces contestaron a Jesús: 'No lo sabemos.',Y Jesús les replicó: 'Pues yo tampoco les diré con qué autoridad hago estas cosas.'"
,"28":"Jesús agregó: 'Pero, díganme su parecer. Un hombre tenía dos hijos. Se acercó al primero para decirle: 'Hijo, hoy tienes que ir a trabajar en la viña.'"
,"29":"Y él le respondió: 'No quiero'. Pero después se arrepintió y fue."
,"30":"Luego el padre se acercó al segundo y le mandó lo mismo. Este respondió: 'Ya voy, señor.' Pero no fue."
,"31":"Ahora bien, ¿cuál de los dos hizo lo que quería el padre?' Ellos contestaron: 'El primero.' Entonces Jesús les dijo: 'En verdad se lo digo: en el camino al Reino de los Cielos, los publicanos y las prostitutas andan mejor que ustedes."
,"32":"Porque Juan vino a abrirles el camino derecho y ustedes no le creyeron, mientras que los publicanos y las prostitutas le creyeron. Ustedes fueron testigos, pero ni con esto se arrepintieron y le creyeron."
,"33":"Escuchen este otro ejemplo: Había un propietario que plantó una viña. La rodeó con una cerca, cavó en ella un lagar y levantó una torre para vigilarla. Después la alquiló a unos labradores y se marchó a un país lejano."
,"34":"Cuando llegó el tiempo de la vendimia, el dueño mandó a sus sirvientes que fueran donde aquellos labradores y cobraran su parte de la cosecha."
,"35":"Pero los labradores tomaron a los enviados, apalearon a uno, mataron a otro y a otro lo apedrearon."
,"36":"El propietario volvió a enviar a otros servidores más numerosos que la primera vez, pero los trataron de la misma manera."
,"37":"Por último envió a su hijo, pensando: 'A mi hijo lo respetarán'."
,"38":"Pero los trabajadores, al ver al hijo, se dijeron: 'Ese es el heredero. Lo matamos y así nos quedamos con su herencia'."
,"39":"Lo tomaron, pues, lo echaron fuera de la viña y lo mataron."
,"40":"Ahora bien, cuando venga el dueño de la viña, ¿qué hará con esos labradores?'"
,"41":"Le contestaron: 'Hará morir sin compasión a esa gente tan mala y arrendará la viña a otros labradores que le paguen a su debido tiempo.'"
,"42":"Jesús agregó: '¿No han leído cierta Escritura? Dice así: La piedra que los constructores desecharon llegó a ser la piedra principal del edificio; ésa fue la obra del Señor y nos dejó maravillados."
,"43":"Ahora yo les digo a ustedes: se les quitará el Reino de los Cielos, y será entregado a un pueblo que le hará producir sus frutos.'"
,"45":"Al oír estos ejemplos, los jefes de los sacerdotes y los fariseos comprendieron que Jesús se refería a ellos."
,"46":"Hubieran deseado arrestarlo, pero tuvieron miedo del pueblo, que lo consideraba como un profeta."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Jesús siguió hablándoles por medio de parábolas:"
,"2":"'Aprendan algo del Reino de los Cielos. Un rey preparaba las bodas de su hijo,"
,"3":"por lo que mandó a sus servidores a llamar a los invitados a la fiesta. Pero éstos no quisieron venir."
,"4":"De nuevo envió a otros servidores con orden de decir a los invitados: 'He preparado un banquete, ya hice matar terneras y otros animales gordos y todo está a punto. Vengan, pues, a la fiesta de la boda'."
,"5":"Pero ellos no hicieron caso, sino que se fueron, unos a sus campos y otros a sus negocios."
,"6":"Los demás tomaron a los servidores del rey, los maltrataron y los mataron."
,"7":"El rey se enojó y envió a sus tropas, que dieron muerte a aquellos asesinos e incendiaron su ciudad."
,"8":"Después dijo a sus servidores: 'El banquete de bodas sigue esperando, pero los que habían sido invitados no eran dignos."
,"9":"Vayan, pues, a las esquinas de las calles e inviten a la fiesta a todos los que encuentren'."
,"10":"Los servidores salieron inmediatamente a los caminos y reunieron a todos los que encontraron, malos y buenos, de modo que la sala se llenó de invitados."
,"11":"Después entró el rey para conocer a los que estaban sentados a la mesa, y vio un hombre que no se había puesto el traje de fiesta."
,"12":"Le dijo: 'Amigo, ¿cómo es que has entrado sin traje de bodas?' El hombre se quedó callado."
,"13":"Entonces el rey dijo a sus servidores: 'Atenlo de pies y manos y échenlo a las tinieblas de fuera. Allí será el llorar y el rechinar de dientes'."
,"14":"Sepan que muchos son llamados, pero pocos son elegidos.'"
,"15":"Los fariseos se movieron para ver juntos el modo de atrapar a Jesús en sus propias palabras."
,"16":"Le enviaron, pues, discípulos suyos junto con algunos partidarios de Herodes a decirle: 'Maestro, sabemos que eres honrado y que enseñas con sinceridad el camino de Dios. No te preocupas por quién te escucha, ni te dejas influenciar por nadie."
,"17":"Danos, pues, tu parecer: ¿Está contra la Ley pagar el impuesto al César? ¿Debemos pagarlo o no?'"
,"18":"Jesús se dio cuenta de sus malas intenciones y les contestó: '¡Hipócritas! ¿Por qué me ponen trampas?"
,"19":"Muéstrenme la moneda que se les cobra.' Y ellos le mostraron un denario."
,"20":"Entonces Jesús preguntó: '¿De quién es esta cara y el nombre que lleva escrito?' Contestaron: 'Del César.'"
,"21":"Jesús les replicó: 'Devuelvan, pues, al César las cosas del César, y a Dios lo que corresponde a Dios.'"
,"22":"Con esta respuesta quedaron muy sorprendidos. Dejaron a Jesús y se marcharon."
,"23":"Ese mismo día vinieron a él algunos saduceos. Según ellos, no hay resurrección de los muertos, y por eso mismo le propusieron este caso:"
,"24":"'Maestro, Moisés dijo que si alguno muere sin tener hijos, el hermano del difunto debe casarse con la viuda para darle un hijo, que será considerado descendiente del difunto."
,"25":"Sucedió que había entre nosotros siete hermanos. Se casó el mayor y murió, y al no tener hijos, dejó su mujer a su hermano."
,"26":"Lo mismo pasó con el segundo y el tercero, hasta el séptimo."
,"27":"Después de todos ellos murió también la mujer."
,"28":"Ahora bien, cuando venga la resurrección de los muertos, ¿cuál de los siete se quedará con esta mujer, si todos la tuvieron?'"
,"29":"Jesús contestó: 'Ustedes andan muy equivocados. Ustedes no entienden ni las Escrituras ni el poder de Dios."
,"30":"Primeramente, en la resurrección no se toma mujer ni esposo, sino que son como ángeles en el Cielo."
,"31":"Y en cuanto a saber si hay resurrección de los muertos, ¿no han leído lo que Dios les dijo:"
,"32":"Yo soy el Dios de Abrahán, el Dios de Isaac y el Dios de Jacob? Él no es un Dios de muertos, sino de vivos.'"
,"33":"Era mucha la gente que escuchaba a Jesús, y estaba asombrada de sus enseñanzas."
,"34":"Cuando los fariseos supieron que Jesús había hecho callar a los saduceos, se juntaron en torno a él."
,"35":"Uno de ellos, que era maestro de la Ley, trató de ponerlo a prueba con esta pregunta:"
,"36":"'Maestro, ¿cuál es el mandamiento más importante de la Ley?'."
,"37":"Jesús le dijo: 'Amarás al Señor tu Dios con todo tu corazón, con toda tu alma y con toda tu mente."
,"38":"Este es el gran mandamiento, el primero."
,"39":"Pero hay otro muy parecido: Amarás a tu prójimo como a ti mismo."
,"40":"Toda la Ley y los Profetas se fundamentan en estos dos mandamientos.'"
,"41":"Aprovechando que los fariseos estaban allí reunidos,"
,"42":"Jesús les preguntó: '¿Qué piensan ustedes del Mesías? ¿De quién tiene que ser hijo?' Contestaron: 'De David.'"
,"43":"Jesús entonces añadió: '¿Cómo es que David llama al Mesías su Señor en un texto inspirado?"
,"44":"En un salmo dice: El Señor ha dicho a mi Señor: Siéntate a mi derecha hasta que ponga a tus enemigos bajo tus pies."
,"45":"Si David lo llama su Señor, ¿cómo puede ser hijo suyo?'"
,"46":"Y nadie supo qué contestarle. Desde ese día nadie se atrevió a hacerle más preguntas."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Entonces Jesús habló tanto para el pueblo como para sus discípulos:"
,"2":"'Los maestros de la Ley y los fariseos han ocupado el puesto que dejó Moisés."
,"3":"Hagan y cumplan todo lo que ellos dicen, pero no los imiten, porque ellos enseñan y no practican."
,"4":"Preparan pesadas cargas, muy difíciles de llevar, y las echan sobre las espaldas de la gente, pero ellos ni siquiera levantan un dedo para moverlas."
,"5":"Todo lo hacen para ser vistos por los hombres. Miren esas largas citas de la Ley que llevan en la frente y los largos flecos de su manto."
,"6":"Les gusta ocupar los primeros lugares en los banquetes y los asientos reservados en las sinagogas."
,"7":"Les agrada que los saluden en las plazas y que la gente los llame Maestro."
,"8":"Lo que es ustedes, no se dejen llamar Maestro, porque no tienen más que un Maestro, y todos ustedes son hermanos."
,"9":"No llamen Padre a nadie en la tierra, porque ustedes tienen un solo Padre, el que está en el Cielo."
,"10":"Tampoco se dejen ustedes llamar Guía, porque ustedes no tienen más Guía que Cristo."
,"11":"El más grande entre ustedes se hará el servidor de todos."
,"12":"Porque el que se pone por encima, será humillado, y el que se rebaja, será puesto en alto."
,"13":"Por lo tanto, ¡ay de ustedes, maestros de la Ley y fariseos, que son unos hipócritas! Ustedes cierran a la gente el Reino de los Cielos. No entran ustedes, ni dejan entrar a los que querrían hacerlo."
,"14":"¡Ay de ustedes, maestros de la Ley y fariseos, que son unos hipócritas!"
,"15":"Ustedes recorren mar y tierra para ganar un pagano y, cuando se ha convertido, lo transforman en un hijo del demonio, mucho peor que ustedes."
,"16":"¡Ay de ustedes, que son guías ciegos! Ustedes dicen: 'Jurar por el Templo no obliga, pero jurar por el tesoro del Templo, sí'."
,"17":"¡Torpes y ciegos! ¿Qué vale más, el oro mismo o el Templo que hace del oro una cosa sagrada?"
,"18":"Ustedes dicen: 'Si alguno jura por el altar, no queda obligado; pero si jura por las ofrendas puestas sobre el altar, queda obligado'. ¡Ciegos!"
,"19":"¿Qué vale más, lo que se ofrece sobre el altar o el altar, que hace santa la ofrenda?"
,"20":"El que jura por el altar, jura por el altar y por lo que se pone sobre él."
,"21":"El que jura por el Templo, jura por él y por Dios que habita en el Templo."
,"22":"El que jura por el Cielo, jura por el trono de Dios y por Aquel que está sentado en él."
,"23":"¡Ay de ustedes, maestros de la Ley y fariseos, que son unos hipócritas! Ustedes pagan el diezmo hasta sobre la menta, el anís y el comino, pero no cumplen la Ley en lo que realmente tiene peso: la justicia, la misericordia y la fe. Ahí está lo que ustedes debían poner por obra, sin descartar lo otro."
,"24":"¡Guías ciegos! Ustedes cuelan un mosquito, pero se tragan un camello."
,"25":"¡Ay de ustedes, maestros de la Ley y fariseos, que son unos hipócritas! Ustedes purifican el exterior del plato y de la copa, después que la llenaron de robos y violencias."
,"26":"¡Fariseo ciego! Purifica primero lo que está dentro, y después purificarás también el exterior."
,"27":"¡Ay de ustedes, maestros de la Ley y fariseos, que son unos hipócritas! Ustedes son como sepulcros bien pintados, que se ven maravillosos, pero que por dentro están llenos de huesos y de toda clase de podredumbre."
,"28":"Ustedes también aparentan como que fueran personas muy correctas, pero en su interior están llenos de falsedad y de maldad."
,"29":"¡Ay de ustedes, maestros de la Ley y fariseos, que son unos hipócritas! Ustedes construyen sepulcros para los profetas y adornan los monumentos de los hombres santos."
,"30":"También dicen: 'Si nosotros hubiéramos vivido en tiempos de nuestros padres, no habríamos consentido que mataran a los profetas'."
,"31":"Así ustedes se proclaman hijos de quienes asesinaron a los profetas."
,"32":"¡Terminen, pues, de hacer lo que sus padres comenzaron!"
,"33":"¡Serpientes, raza de víboras!, ¿cómo lograrán escapar de la condenación del infierno?"
,"34":"Desde ahora les voy a enviar profetas, sabios y maestros, pero ustedes los degollarán y crucificarán, y a otros los azotarán en las sinagogas o los perseguirán de una ciudad a otra."
,"35":"Al final recaerá sobre ustedes toda la sangre inocente que ha sido derramada sobre la tierra, desde la sangre del justo Abel hasta la sangre de Zacarías, hijo de Baraquías, al que ustedes mataron ante el altar, dentro del Templo."
,"36":"En verdad les digo: esta generación pagará por todo eso."
,"37":"¡Jerusalén, Jerusalén, qué bien matas a los profetas y apedreas a los que Dios te envía! ¡Cuántas veces he querido reunir a tus hijos, como la gallina reúne a sus pollitos bajo las alas, y tú no has querido!"
,"38":"Por eso se van a quedar ustedes con su templo vacío."
,"39":"Y les digo que ya no me volverán a ver hasta que digan: ¡Bendito sea el que viene en nombre del Señor!'"
}`)
	CurrentBook.AddChapter(24, `{
"1":"Jesús salió del Templo, y mientras caminaba, sus discípulos le hacían notar las imponentes construcciones del Templo."
,"2":"Jesús les dijo: '¿Ven todo eso? En verdad les digo: no quedará ahí piedra sobre piedra. Todo será destruido.'"
,"3":"Como Jesús después se sentara en el monte de los Olivos, los discípulos se acercaron y le preguntaron en privado: 'Dinos cuándo ocurrirá todo eso. ¿Qué señales anunciarán tu venida y el fin de la historia?'"
,"4":"Jesús les contestó: 'No se dejen engañar"
,"5":"cuando varios usurpen mi nombre y digan: Yo soy el Mesías. Pues engañarán a mucha gente."
,"6":"Ustedes oirán hablar de guerras y de rumores de guerra. Pero no se alarmen; todo eso tiene que pasar, pero no será todavía el fin."
,"7":"Unas naciones lucharán contra otras y se levantará un reino contra otro reino, habrá hambre y terremotos en diversos lugares."
,"8":"Esos serán los primeros dolores del parto."
,"9":"Entonces los denunciarán a ustedes y serán torturados y asesinados. Todas las naciones los odiarán por mi causa."
,"10":"En esos días muchos tropezarán y caerán; de repente se odiarán y se traicionarán unos a otros."
,"11":"Aparecerán falsos profetas, que engañarán a mucha gente,"
,"12":"y tanta será la maldad, que el amor se enfriará en muchos."
,"13":"Pero el que se mantenga firme hasta el fin se salvará."
,"14":"Esta Buena Nueva del Reino será proclamada en el mundo entero, y todas las naciones oirán el mensaje; después vendrá el fin."
,"15":"Cuando ustedes vean lo anunciado por el profeta Daniel: el ídolo del invasor instalado en el Templo (que el lector sepa entender),"
,"16":"entonces los que estén en Judea huyan a los montes."
,"17":"Si estás en la azotea de tu casa, no te demores ni bajes a buscar tus cosas."
,"18":"Si te hallas en el campo, no vuelvas a buscar tu manto."
,"19":"¡Pobres de las que en aquellos días estén embarazadas o criando!"
,"20":"Rueguen para que no les toque huir en invierno o en día sábado."
,"21":"Porque será una prueba tan enorme como no ha habido igual desde el principio del mundo hasta ahora, ni jamás la volverá a haber."
,"22":"Y si ese tiempo no fuera acortado, nadie saldría con vida. Pero Dios lo acortará en consideración a sus elegidos."
,"23":"Entonces, si alguien les dice: Miren, el Mesías está aquí o está allá, no le crean."
,"24":"Porque se presentarán falsos mesías y falsos profetas, que harán cosas maravillosas y prodigios capaces de engañar, si fuera posible, aun a los elegidos de Dios."
,"25":"Miren que yo se lo he advertido de antemano."
,"26":"Por tanto, si alguien les dice: ¡Está en el desierto!, no vayan. Si dicen: ¡Está en tal lugar retirado!, no lo crean."
,"27":"Pues así como refulge el relámpago desde el oriente e inflama el cielo hasta el poniente, así será la venida del Hijo del Hombre."
,"28":"En otras palabras: 'Donde hay un cadáver, allí se juntan los buitres.'"
,"29":"Después de esos días de angustia, el sol se oscurecerá, la luna perderá su brillo, caerán las estrellas del cielo y se bambolearán los mecanismos del universo."
,"30":"Entonces aparecerá en el cielo la señal del Hijo del Hombre. Mientras todas las razas de la tierra se golpearán el pecho, verán al Hijo del Hombre viniendo sobre las nubes del cielo con el poder divino y la plenitud de la gloria."
,"31":"Enviará a sus ángeles, que tocarán la trompeta y reunirán a los elegidos de los cuatro puntos cardinales, de un extremo al otro del mundo."
,"32":"Aprendan esta lección de la higuera: Cuando están ya tiernas sus ramas y empiezan a brotar las hojas, ustedes saben que se acerca el verano."
,"33":"Asimismo, cuando ustedes noten todas estas cosas que les he dicho, sepan que el tiempo ya está cerca, a las puertas."
,"34":"En verdad les digo: no pasará esta generación, hasta que sucedan todas estas cosas."
,"35":"Pasarán el cielo y la tierra, pero mis palabras no pasarán."
,"36":"Por lo que se refiere a ese Día y cuándo vendrá, nadie lo sabe, ni siquiera los ángeles de Dios, ni aun el Hijo, sino solamente el Padre."
,"37":"La venida del Hijo del Hombre recordará los tiempos de Noé."
,"38":"Unos pocos días antes del diluvio, la gente seguía comiendo y bebiendo, y se casaban hombres y mujeres, hasta el día en que Noé entró en el arca."
,"39":"No se dieron cuenta de nada hasta que vino el diluvio y se los llevó a todos. Lo mismo sucederá con la venida del Hijo del Hombre:"
,"40":"de dos hombres que estén juntos en el campo, uno será tomado, y el otro no;"
,"41":"de dos mujeres que estén juntas moliendo trigo, una será tomada, y la otra no."
,"42":"Por eso estén despiertos, porque no saben en qué día vendrá su Señor."
,"43":"Fíjense en esto: si un dueño de casa supiera a qué hora de la noche lo va a asaltar un ladrón, seguramente permanecería despierto para impedir el asalto a su casa."
,"44":"Por eso, estén también ustedes preparados, porque el Hijo del Hombre vendrá a la hora que menos esperan."
,"45":"Imagínense un administrador digno de confianza y capaz. Su señor lo ha puesto al frente de su familia, y es él quien les reparte el alimento a su debido tiempo."
,"46":"Afortunado será este servidor si, al venir su señor, lo encuentra cumpliendo su deber."
,"47":"En verdad les digo: su señor lo pondrá al cuidado de todo lo que tiene."
,"48":"No será así con el servidor malo que piensa: 'Mi señor se ha retrasado',"
,"49":"y empieza a maltratar a sus compañeros y a comer y a beber con borrachos."
,"50":"El patrón de ese servidor vendrá en el día que no lo espera y a la hora que menos piensa."
,"51":"Le quitará el puesto y lo mandará donde los hipócritas. Allí será el llorar y el rechinar de dientes."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Escuchen, pues, lo que pasará entonces en el Reino de los Cielos. Diez jóvenes salieron con sus lámparas para salir al encuentro del novio."
,"2":"Cinco de ellas eran descuidadas y las otras cinco precavidas."
,"3":"Las descuidadas tomaron sus lámparas como estaban, sin llevar más aceite consigo."
,"4":"Las precavidas, en cambio, junto con las lámparas, llevaron sus botellas de aceite."
,"5":"Como el novio se demoraba en llegar, se adormecieron todas y al fin se quedaron dormidas."
,"6":"A medianoche se oyó un grito: '¡Viene el novio, salgan a su encuentro!'"
,"7":"Todas las jóvenes se despertaron y prepararon sus lámparas."
,"8":"Entonces las descuidadas dijeron a las precavidas: 'Dennos un poco de su aceite, porque nuestras lámparas se están apagando.'"
,"9":"Las precavidas dijeron: 'No habría bastante para ustedes y para nosotras; vayan mejor a donde lo venden, y compren para ustedes.'"
,"10":"Mientras fueron a comprar el aceite llegó el novio; las que estaban listas entraron con él a la fiesta de las bodas, y se cerró la puerta."
,"11":"Más tarde llegaron las otras jóvenes y llamaron: 'Señor, Señor, ábrenos.'"
,"12":"Pero él respondió: 'En verdad se lo digo: no las conozco.'"
,"13":"Por tanto, estén despiertos, porque no saben el día ni la hora."
,"14":"Escuchen también esto. Un hombre estaba a punto de partir a tierras lejanas, y reunió a sus servidores para confiarles todas sus pertenencias."
,"15":"Al primero le dio cinco talentos de oro, a otro le dio dos, y al tercero solamente uno, a cada cual según su capacidad. Después se marchó."
,"16":"El que recibió cinco talentos negoció en seguida con el dinero y ganó otros cinco."
,"17":"El que recibió dos hizo otro tanto, y ganó otros dos."
,"18":"Pero el que recibió uno cavó un hoyo en la tierra y escondió el dinero de su patrón."
,"19":"Después de mucho tiempo vino el señor de esos servidores y les pidió cuentas."
,"20":"El que había recibido cinco talentos le presentó otros cinco más, diciéndole: 'Señor, tú me entregaste cinco talentos, pero aquí están otros cinco más que gané con ellos.'"
,"21":"El patrón le contestó: 'Muy bien, servidor bueno y honrado; ya que has sido fiel en lo poco, yo te voy a confiar mucho más. Ven a compartir la alegría de tu patrón.'"
,"22":"Vino después el que recibió dos, y dijo: 'Señor, tú me entregaste dos talentos, pero aquí tienes otros dos más que gané con ellos.'"
,"23":"El patrón le dijo: 'Muy bien, servidor bueno y honrado; ya que has sido fiel en lo poco, yo te confiaré mucho más. Ven a compartir la alegría de tu patrón'."
,"24":"Por último vino el que había recibido un solo talento y dijo: 'Señor, yo sabía que eres un hombre exigente, que cosechas donde no has sembrado y recoges donde no has invertido."
,"25":"Por eso yo tuve miedo y escondí en la tierra tu dinero. Aquí tienes lo que es tuyo.'"
,"26":"Pero su patrón le contestó: '¡Servidor malo y perezoso! Si sabías que cosecho donde no he sembrado y recojo donde no he invertido,"
,"27":"debías haber colocado mi dinero en el banco. A mi regreso yo lo habría recuperado con los intereses."
,"28":"Quítenle, pues, el talento y entréguenselo al que tiene diez."
,"29":"Porque al que produce se le dará y tendrá en abundancia, pero al que no produce se le quitará hasta lo que tiene."
,"30":"Y a ese servidor inútil, échenlo a la oscuridad de afuera: allí será el llorar y el rechinar de dientes.'"
,"31":"Cuando el Hijo del Hombre venga en su gloria rodeado de todos sus ángeles, se sentará en el trono de gloria, que es suyo."
,"32":"Todas las naciones serán llevadas a su presencia, y separará a unos de otros, al igual que el pastor separa las ovejas de los chivos."
,"33":"Colocará a las ovejas a su derecha y a los chivos a su izquierda."
,"34":"Entonces el Rey dirá a los que están a su derecha: 'Vengan, benditos de mi Padre, y tomen posesión del reino que ha sido preparado para ustedes desde el principio del mundo."
,"35":"Porque tuve hambre y ustedes me dieron de comer; tuve sed y ustedes me dieron de beber. Fui forastero y ustedes me recibieron en su casa."
,"36":"Anduve sin ropas y me vistieron. Estuve enfermo y fueron a visitarme. Estuve en la cárcel y me fueron a ver.'"
,"37":"Entonces los justos dirán: 'Señor, ¿cuándo te vimos hambriento y te dimos de comer, o sediento y te dimos de beber?"
,"38":"¿Cuándo te vimos forastero y te recibimos, o sin ropa y te vestimos?"
,"39":"¿Cuándo te vimos enfermo o en la cárcel y fuimos a verte?"
,"40":"El Rey responderá: 'En verdad les digo que, cuando lo hicieron con alguno de los más pequeños de estos mis hermanos, me lo hicieron a mí.'"
,"41":"Dirá después a los que estén a la izquierda: '¡Malditos, aléjense de mí y vayan al fuego eterno, que ha sido preparado para el diablo y para sus ángeles!"
,"42":"Porque tuve hambre y ustedes no me dieron de comer; tuve sed y no me dieron de beber;"
,"43":"era forastero y no me recibieron en su casa; estaba sin ropa y no me vistieron; estuve enfermo y encarcelado y no me visitaron.'"
,"44":"Estos preguntarán también: 'Señor, ¿cuándo te vimos hambriento o sediento, desnudo o forastero, enfermo o encarcelado, y no te ayudamos?'"
,"45":"El Rey les responderá: 'En verdad les digo: siempre que no lo hicieron con alguno de estos más pequeños, ustedes dejaron de hacérmelo a mí.'"
,"46":"Y éstos irán a un suplicio eterno, y los buenos a la vida eterna.'"
}`)
	CurrentBook.AddChapter(26, `{
"1":"Cuando Jesús terminó todos estos discursos, dijo a sus discípulos:"
,"2":"'Ustedes saben que la Pascua cae dentro de dos días, y el Hijo del Hombre será entregado para ser crucificado.'"
,"3":"Por entonces, los jefes de los sacerdotes y las autoridades judías se reunieron en el palacio del sumo sacerdote, que se llamaba Caifás,"
,"4":"y se pusieron de acuerdo para detener a Jesús con artimañas y darle muerte."
,"5":"Pero se decían: 'No será durante la fiesta, para que el pueblo no se alborote.'"
,"6":"Jesús se encontraba en Betania, en casa de Simón el leproso."
,"7":"Se acercó a él una mujer, mientras estaba a la mesa, con un frasco de mármol precioso lleno de un perfume muy caro, y se lo derramó en la cabeza."
,"8":"Al ver esto, los discípulos protestaban: '¿Para qué tanto derroche?"
,"9":"Este perfume se podía haber vendido muy caro para ayudar a los pobres.'"
,"10":"Jesús se dio cuenta y les dijo: '¿Por qué molestan a esta mujer? Lo que ha hecho conmigo es realmente una buena obra."
,"11":"Siempre tienen a los pobres con ustedes, pero a mí no me tendrán siempre."
,"12":"Al derramar este perfume sobre mi cuerpo, ella preparaba mi entierro."
,"13":"En verdad les digo: dondequiera que se proclame el Evangelio, en todo el mundo, se contará también su gesto, y será su gloria.'"
,"14":"Entonces uno de los Doce, que se llamaba Judas Iscariote, se presentó a los jefes de los sacerdotes"
,"15":"y les dijo: '¿Cuánto me darán si se lo entrego?' Ellos prometieron darle treinta monedas de plata."
,"16":"Y a partir de ese momento, Judas andaba buscando una oportunidad para entregárselo."
,"17":"El primer día de la Fiesta en que se comía el pan sin levadura, los discípulos se acercaron a Jesús y le dijeron: '¿Dónde quieres que preparemos la comida de la Pascua?'"
,"18":"Jesús contestó: 'Vayan a la ciudad, a casa de tal hombre, y díganle: El Maestro te manda decir: Mi hora se acerca y quiero celebrar la Pascua con mis discípulos en tu casa.'"
,"19":"Los discípulos hicieron tal como Jesús les había ordenado y prepararon la Pascua."
,"20":"Llegada la tarde, Jesús se sentó a la mesa con los Doce."
,"21":"Y mientras comían, les dijo: 'En verdad les digo: uno de ustedes me va a traicionar.'"
,"22":"Se sintieron profundamente afligidos, y uno a uno comenzaron a preguntarle: '¿Seré yo, Señor?'"
,"23":"El contestó: 'El que me va a entregar es uno de los que mojan su pan conmigo en el plato."
,"24":"El Hijo del Hombre se va, como dicen las Escrituras, pero ¡pobre de aquel que entrega al Hijo del Hombre! ¡Sería mejor para él no haber nacido!'"
,"25":"Judas, el que lo iba a entregar, le preguntó también: '¿Seré yo acaso, Maestro?' Jesús respondió: 'Tú lo has dicho.'"
,"26":"Mientras comían, Jesús tomó pan, pronunció la bendición, lo partió y lo dio a sus discípulos, diciendo: 'Tomen y coman; esto es mi cuerpo.'"
,"27":"Después tomó una copa, dio gracias y se la pasó diciendo: 'Beban todos de ella:"
,"28":"esto es mi sangre, la sangre de la Alianza, que es derramada por una muchedumbre, para el perdón de sus pecados."
,"29":"Y les digo que desde ahora no volveré a beber del zumo de cepas, hasta el día en que lo beba nuevo con ustedes en el Reino de mi Padre.'"
,"30":"Después de cantar los salmos, partieron para el monte de los Olivos."
,"31":"Entonces Jesús les dijo: 'Todos ustedes caerán esta noche: ya no sabrán qué pensar de mí. Pues dice la Escritura: Heriré al Pastor y se dispersarán las ovejas."
,"32":"Pero después de mi resurrección iré delante de ustedes a Galilea.'"
,"33":"Pedro empezó a decirle: 'Aunque todos tropiecen, yo nunca dudaré de ti.'"
,"34":"Jesús le replicó: 'Yo te aseguro que esta misma noche, antes de que cante el gallo, me habrás negado tres veces.'"
,"35":"Pedro insistió: 'Aunque tenga que morir contigo, jamás te negaré'. Y los demás discípulos le aseguraban lo mismo."
,"36":"Llegó Jesús con ellos a un lugar llamado Getsemaní, y dijo a sus discípulos: 'Siéntense aquí, mientras yo voy más allá a orar.'"
,"37":"Tomó consigo a Pedro y a los dos hijos de Zebedeo y comenzó a sentir tristeza y angustia."
,"38":"Y les dijo: 'Siento una tristeza de muerte. Quédense aquí conmigo y permanezcan despiertos.'"
,"39":"Fue un poco más adelante y, postrándose hasta tocar la tierra con su cara, oró así: 'Padre, si es posible, que esta copa se aleje de mí. Pero no se haga lo que yo quiero, sino lo que quieres tú.'"
,"40":"Volvió donde sus discípulos, los halló dormidos; y dijo a Pedro: '¿De modo que no pudieron permanecer despiertos ni una hora conmigo?"
,"41":"Estén despiertos y recen para que no caigan en la tentación. El espíritu es animoso, pero la carne es débil.'"
,"42":"De nuevo se apartó por segunda vez a orar: 'Padre, si esta copa no puede ser apartada de mí sin que yo la beba, que se haga tu voluntad.'"
,"43":"Volvió otra vez donde los discípulos y los encontró dormidos, pues se les cerraban los ojos de sueño."
,"44":"Los dejó, pues, y fue de nuevo a orar por tercera vez repitiendo las mismas palabras."
,"45":"Entonces volvió donde los discípulos y les dijo: '¡Ahora pueden dormir y descansar! Ha llegado la hora y el Hijo del Hombre es entregado en manos de pecadores."
,"46":"¡Levántense, vamos! El traidor está a punto de llegar.'"
,"47":"Estaba todavía hablando, cuando llegó Judas, uno de los Doce. Iba acompañado de una chusma armada con espadas y garrotes, enviada por los jefes de los sacerdotes y por las autoridades judías."
,"48":"El traidor les había dado esta señal: 'Al que yo dé un beso, ése es; arréstenlo.'"
,"49":"Se fue directamente donde Jesús y le dijo: 'Buenas noches, Maestro.' Y le dio un beso."
,"50":"Jesús le dijo: 'Amigo, haz lo que vienes a hacer.' Entonces se acercaron a Jesús y lo arrestaron."
,"51":"Uno de los que estaban con Jesús sacó la espada e hirió al sirviente del sumo sacerdote, cortándole una oreja."
,"52":"Entonces Jesús le dijo: 'Vuelve la espada a su sitio, pues quien usa la espada perecerá por la espada."
,"53":"¿No sabes que podría invocar a mi Padre y él, al momento, me mandaría más de doce ejércitos de ángeles?"
,"54":"Pero así había de suceder, y tienen que cumplirse las Escrituras.'"
,"55":"En ese momento, Jesús dijo a la gente: 'A lo mejor buscan un ladrón y por eso salieron a detenerme con espadas y palos. Yo sin embargo me sentaba diariamente entre ustedes en el Templo para enseñar, y no me detuvieron."
,"56":"Pero todo ha pasado para que así se cumpliera lo escrito en los Profetas.' Entonces todos los discípulos abandonaron a Jesús y huyeron."
,"57":"Los que tomaron preso a Jesús lo llevaron a casa del sumo sacerdote Caifás, donde se habían reunido los maestros de la Ley y las autoridades judías."
,"58":"Pedro lo iba siguiendo de lejos, hasta llegar al palacio del sumo sacerdote. Entró en el patio y se sentó con los policías del Templo, para ver en qué terminaba todo."
,"59":"Los jefes de los sacerdotes y el Consejo Supremo andaban buscando alguna declaración falsa contra Jesús, para poderlo condenar a muerte."
,"60":"Pero pasaban los falsos testigos y no se encontraba nada. Al fin llegaron dos"
,"61":"que declararon: 'Este hombre dijo: Yo soy capaz de destruir el Templo de Dios y de reconstruirlo en tres días.'"
,"62":"Entonces el sumo sacerdote se puso de pie y preguntó a Jesús: '¿No tienes nada que responder? ¿Qué es esto que declaran en contra tuya?'"
,"63":"Pero Jesús se quedó callado. Entonces el sumo sacerdote le dijo: 'En el nombre del Dios vivo te ordeno que nos contestes: ¿Eres tú el Mesías, el Hijo de Dios?' "
,"64":"Jesús le respondió: 'Así es, tal como tú lo has dicho. Y yo les digo más: a partir de ahora ustedes contemplarán al Hijo del Hombre sentado a la derecha del Dios Todopoderoso, y lo verán venir sobre las nubes del cielo.'"
,"65":"Entonces el sumo sacerdote se rasgó las ropas, diciendo: '¡Ha blasfemado! ¿Para qué necesitamos más testigos? Ustedes mismos acaban de oír estas palabras blasfemas."
,"66":"¿Qué deciden ustedes?' Ellos contestaron: '¡Merece la muerte!'"
,"67":"Luego comenzaron a escupirle en la cara y a darle bofetadas, mientras otros lo golpeaban"
,"68":"diciéndole: 'Mesías, ¡adivina quién te pegó!'"
,"69":"Mientras Pedro estaba sentado fuera, en el patio, se le acercó una sirvienta de la casa y le dijo: 'Tú también estabas con Jesús de Galilea.'"
,"70":"Pero él lo negó delante de todos, diciendo: 'No sé de qué estás hablando.'"
,"71":"Y como Pedro se dirigiera hacia la salida, lo vio otra sirvienta, que dijo a los presentes: 'Este hombre andaba con Jesús de Nazaret.'"
,"72":"Pedro lo negó por segunda vez, jurando: 'Yo no conozco a ese hombre.'"
,"73":"Un poco después se acercaron los que estaban allí y dijeron a Pedro: 'Sin duda que eres uno de los galileos: se nota por tu modo de hablar.'"
,"74":"Entonces Pedro empezó a proferir maldiciones y a afirmar con juramento que no conocía a aquel hombre. Y en aquel mismo momento cantó un gallo."
,"75":"Entonces Pedro se acordó de las palabras que Jesús le había dicho: 'Antes de que cante el gallo me negarás tres veces'. Y saliendo fuera, lloró amargamente."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Al amanecer, todos los jefes de los sacerdotes y las autoridades judías celebraron una reunión para decidir la manera de hacer morir a Jesús."
,"2":"Luego lo ataron y lo llevaron para entregárselo a Pilato, el gobernador."
,"3":"Cuando Judas, el traidor, supo que Jesús había sido condenado, se llenó de remordimientos y devolvió las treinta monedas de plata a los jefes de los sacerdotes y a los jefes judíos."
,"4":"Les dijo: 'He pecado: he entregado a la muerte a un inocente.' Ellos le contestaron: '¿Qué nos importa eso a nosotros? Es asunto tuyo.'"
,"5":"Entonces él, arrojando las monedas en el Templo, se marchó y fue a ahorcarse."
,"6":"Los jefes de los sacerdotes recogieron las monedas, pero dijeron: 'No se puede echar este dinero en el tesoro del Templo, porque es precio de sangre.'"
,"7":"Entonces se pusieron de acuerdo para comprar con aquel dinero el Campo del Alfarero y lo destinaron para cementerio de extranjeros."
,"8":"Por eso ese lugar es llamado Campo de Sangre hasta el día de hoy."
,"9":"Así se cumplió lo que había dicho el profeta Jeremías: Tomaron las treinta monedas de plata, que fue el precio en que lo tasaron los hijos de Israel,"
,"10":"y las dieron por el Campo del Alfarero, tal como el Señor me lo ordenó."
,"11":"Jesús compareció ante el gobernador, y éste comenzó a interrogarlo. Le preguntó: '¿Eres tú el rey de los judíos?' Jesús contestó: 'Tú eres el que lo dice.'"
,"12":"Los jefes de los sacerdotes y las autoridades judías lo acusaban, pero Jesús no contestó nada."
,"13":"Pilato le dijo: '¿No oyes todos los cargos que presentan contra ti?'"
,"14":"Pero Jesús no dijo ni una palabra, de modo que el gobernador se sorprendió mucho."
,"15":"Con ocasión de la Pascua, el gobernador tenía la costumbre de dejar en libertad a un condenado, a elección de la gente."
,"16":"De hecho el pueblo tenía entonces un detenido famoso, llamado Barrabás."
,"17":"Cuando se juntó toda la gente, Pilato les dijo: '¿A quién quieren que deje libre, a Barrabás o a Jesús, llamado el Cristo?'"
,"18":"Porque sabía que le habían entregado a Jesús por envidia."
,"19":"Mientras Pilato estaba en el tribunal, su mujer le mandó a decir: 'No te metas con ese hombre porque es un santo, y anoche tuve un sueño horrible por causa de él.'"
,"20":"Mientras tanto, los jefes de los sacerdotes y los jefes de los judíos persuadieron al gentío a que pidieran la libertad de Barrabás y la muerte de Jesús."
,"21":"Cuando el gobernador volvió a preguntarles: '¿A cuál de los dos quieren que les suelte?', ellos contestaron: 'A Barrabás.'"
,"22":"Pilato les dijo: '¿Y qué hago con Jesús, llamado el Cristo?' Todos contestaron: '¡Crucifícalo!'"
,"23":"Pilato insistió: '¿Qué ha hecho de malo?' Pero ellos gritaban cada vez con más fuerza: '¡Que sea crucificado!'"
,"24":"Al darse cuenta Pilato de que no conseguía nada, sino que más bien aumentaba el alboroto, pidió agua y se lavó las manos delante del pueblo. Y les dijo: 'Ustedes responderán por su sangre, yo no tengo la culpa.'"
,"25":"Y todo el pueblo contestó: '¡Que su sangre caiga sobre nosotros y sobre nuestros hijos!'"
,"26":"Entonces Pilato les soltó a Barrabás. Mandó azotar a Jesús y lo entregó a los que debían crucificarlo."
,"27":"Los soldados romanos llevaron a Jesús al patio del palacio y reunieron a toda la tropa en torno a él."
,"28":"Le quitaron sus vestidos y le pusieron una capa de soldado de color rojo."
,"29":"Después le colocaron en la cabeza una corona que habían trenzado con espinos y en la mano derecha le pusieron una caña. Doblaban la rodilla ante Jesús y se burlaban de él, diciendo: '¡Viva el rey de los judíos!'"
,"30":"Le escupían en la cara y con la caña le golpeaban en la cabeza."
,"31":"Cuando terminaron de burlarse de él, le quitaron la capa de soldado, le pusieron de nuevo sus ropas y lo llevaron a crucificar."
,"32":"Por el camino se encontraron con un hombre de Cirene, llamado Simón, y le obligaron a que cargara con la cruz de Jesús."
,"33":"Cuando llegaron al lugar que se llama Gólgota (o Calvario), o sea, 'calavera',"
,"34":"le dieron a beber vino mezclado con hiel. Jesús lo probó, pero no lo quiso beber."
,"35":"Allí lo crucificaron y después se repartieron entre ellos la ropa de Jesús, echándola a suertes."
,"36":"Luego se sentaron a vigilarlo."
,"37":"Encima de su cabeza habían puesto un letrero con el motivo de su condena, en el que se leía: 'Este es Jesús, el rey de los judíos.'"
,"38":"También crucificaron con él a dos ladrones, uno a su derecha y el otro a su izquierda."
,"39":"Los que pasaban por allí lo insultaban; movían la cabeza"
,"40":"y decían: '¡Vaya! ¡Tú que destruyes el Templo y lo levantas de nuevo en tres días! Si eres el Hijo de Dios, líbrate del suplicio y baja de la cruz.'"
,"41":"Los jefes de los sacerdotes, los jefes de los judíos y los maestros de la Ley también se burlaban de él. Decían:"
,"42":"'¡Ha salvado a otros y no es capaz de salvarse a sí mismo! ¡Que baje de la cruz el Rey de Israel y creeremos en él!"
,"43":"Ha puesto su confianza en Dios. Si Dios lo ama, que lo salve, pues él mismo dijo: Soy hijo de Dios.'"
,"44":"Hasta los ladrones que habían sido crucificados con él lo insultaban."
,"45":"Desde el mediodía hasta las tres de la tarde todo el país se cubrió de tinieblas."
,"46":"A eso de las tres, Jesús gritó con fuerza: Elí, Elí, lamá sabactani, que quiere decir: 'Dios mío, Dios mío, ¿por qué me has abandonado?'"
,"47":"Al oírlo, algunos de los presentes decían: 'Está llamando a Elías.'"
,"48":"Uno de ellos corrió, tomó una esponja, la empapó en vinagre y la puso en la punta de una caña para darle de beber."
,"49":"Los otros le decían: 'Déjalo, veamos si viene Elías a salvarlo.'"
,"50":"Pero nuevamente Jesús dio un fuerte grito y entregó su espíritu."
,"51":"En ese mismo instante la cortina del Santuario se rasgó de arriba abajo, en dos partes."
,"52":"La tierra tembló, las rocas se partieron, los sepulcros se abrieron y resucitaron varias personas santas que habían llegado ya al descanso."
,"53":"Estas salieron de las sepulturas después de la resurrección de Jesús, fueron a la Ciudad Santa y se aparecieron a mucha gente."
,"54":"El capitán y los soldados que custodiaban a Jesús, al ver el temblor y todo lo que estaba pasando, se llenaron de terror y decían: 'Verdaderamente este hombre era Hijo de Dios.'"
,"55":"También estaban allí, observándolo todo, algunas mujeres que desde Galilea habían seguido a Jesús para servirlo."
,"56":"Entre ellas estaban María Magdalena, María, madre de Santiago y de José, y la madre de los hijos de Zebedeo."
,"57":"Siendo ya tarde, llegó un hombre rico de Arimatea, llamado José, que también se había hecho discípulo de Jesús."
,"58":"Se presentó a Pilato y le pidió el cuerpo de Jesús, y el gobernador ordenó que se lo entregaran."
,"59":"José tomó entonces el cuerpo de Jesús, lo envolvió en una sábana limpia"
,"60":"y lo colocó en el sepulcro nuevo que se había hecho excavar en la roca. Después hizo rodar una gran piedra sobre la entrada del sepulcro y se fue."
,"61":"Mientras tanto, María Magdalena y la otra María estaban allí, sentadas frente al sepulcro."
,"62":"Al día siguiente (el día después de la Preparación de la Pascua), los jefes de los sacerdotes y los fariseos se presentaron a Pilato"
,"63":"y le dijeron: 'Señor, nos hemos acordado que ese mentiroso dijo cuando aún vivía: Después de tres días resucitaré."
,"64":"Ordena, pues, que sea asegurado el sepulcro hasta el tercer día, no sea que vayan sus discípulos, roben el cuerpo y digan al pueblo: Resucitó de entre los muertos. Este sería un engaño más perjudicial que el primero.'"
,"65":"Pilato les respondió: 'Ahí tienen una guardia. Vayan ustedes y tomen todas las precauciones que crean convenientes.'"
,"66":"Ellos, pues, fueron al sepulcro y lo aseguraron. Sellaron la piedra que cerraba la entrada y pusieron guardia."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Pasado el sábado, al aclarar el primer día de la semana, fueron María Magdalena y la otra María a visitar el sepulcro."
,"2":"De repente se produjo un violento temblor: el Angel del Señor bajó del cielo, se dirigió al sepulcro, hizo rodar la piedra de la entrada y se sentó sobre ella."
,"3":"Su aspecto era como el relámpago y sus ropas blancas como la nieve."
,"4":"Al ver al Angel, los guardias temblaron de miedo y se quedaron como muertos."
,"5":"El Angel dijo a las mujeres: 'Ustedes no tienen por qué temer. Yo sé que buscan a Jesús, que fue crucificado."
,"6":"No está aquí, pues ha resucitado, tal como lo había anunciado. Vengan a ver el lugar donde lo habían puesto,"
,"7":"pero vuelvan en seguida y digan a sus discípulos: Ha resucitado de entre los muertos y ya se les adelanta camino a Galilea. Allí lo verán ustedes. Con esto ya se lo dije todo.'"
,"8":"Ellas se fueron al instante del sepulcro, con temor, pero con una alegría inmensa a la vez, y corrieron a llevar la noticia a los discípulos."
,"9":"En eso Jesús les salió al encuentro en el camino y les dijo: 'Paz a ustedes.' Las mujeres se acercaron, se abrazaron a sus pies y lo adoraron."
,"10":"Jesús les dijo: 'No tengan miedo. Vayan ahora y digan a mis hermanos que se dirijan a Galilea. Allí me verán.'"
,"11":"Mientras las mujeres iban, unos guardias corrieron a la ciudad y contaron a los jefes de los sacerdotes todo lo que había pasado."
,"12":"Estos se reunieron con las autoridades judías y acordaron dar a los soldados una buena cantidad de dinero"
,"13":"para que dijeran: 'Los discípulos de Jesús vinieron de noche y, como estábamos dormidos, robaron el cuerpo."
,"14":"Si esto llega a oídos de Pilato, nosotros lo arreglaremos para que no tengan problemas.' Los soldados recibieron el dinero e hicieron como les habían dicho."
,"15":"De ahí salió la mentira que ha corrido entre los judíos hasta el día de hoy."
,"16":"Por su parte, los Once discípulos partieron para Galilea, al monte que Jesús les había indicado."
,"17":"Cuando vieron a Jesús, se postraron ante él, aunque algunos todavía dudaban."
,"18":"Jesús se acercó y les habló así: 'Me ha sido dada toda autoridad en el Cielo y en la tierra."
,"19":"Vayan, pues, y hagan que todos los pueblos sean mis discípulos. Bautícenlos en el Nombre del Padre y del Hijo y del Espíritu Santo,"
,"20":"y enséñenles a cumplir todo lo que yo les he encomendado a ustedes. Yo estoy con ustedes todos los días hasta el fin de la historia.'"
}`)

}
func ES_LBL_LoadNP1CChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"De Pablo, apóstol de Cristo Jesús por decisión de Dios que lo ha llamado, y de Sóstenes nuestro hermano,"
,"2":"a la Iglesia de Dios que está en Corinto: a ustedes que Dios santificó en Cristo Jesús. Pues fueron llamados a ser santos con todos aquellos que por todas partes invocan el Nombre de Cristo Jesús, Señor nuestro y de ellos."
,"3":"Reciban bendición y paz de Dios Padre y de Cristo Jesús, el Señor."
,"4":"Doy gracias sin cesar a mi Dios por ustedes y por la gracia de Dios que les ha sido otorgada en Cristo Jesús,"
,"5":"pues en él han llegado a ser ricos de mil maneras, recibiendo todos los dones de palabra y de conocimiento"
,"6":"a medida que se afianzaba entre ustedes el mensaje de Cristo."
,"7":"No les falta ningún don espiritual y sólo esperan la venida gloriosa de Cristo Jesús, nuestro Señor."
,"8":"El los mantendrá firmes hasta el fin, para que estén sin tacha el día en que venga Cristo Jesús, nuestro Señor."
,"9":"Dios es fiel, el que los ha llamado a esta comunión con su Hijo Jesucristo, nuestro Señor."
,"10":"Les ruego, hermanos, en nombre de Cristo Jesús, nuestro Señor, que se pongan todos de acuerdo y terminen con las divisiones, que encuentren un mismo modo de pensar y los mismos criterios."
,"11":"Personas de la casa de Cloe me han hablado de que hay rivalidades entre ustedes. Puedo usar esta palabra, ya que uno dice: 'Yo soy de Pablo', y otro:"
,"12":"'Yo soy de Apolo', o 'Yo soy de Cefas', o 'Yo soy de Cristo'."
,"13":"¿Quieren dividir a Cristo? ¿Acaso fue Pablo crucificado por ustedes? ¿O fueron bautizados en el nombre de Pablo?"
,"14":"Doy gracias a Dios de no haber bautizado a ninguno de ustedes, a excepción de Crispo y Gayo,"
,"15":"pues así nadie podrá decir que fue bautizado en mi nombre."
,"16":"Perdón, también bauticé a la familia de Estéfanas. Fuera de éstos no recuerdo haber bautizado a ningún otro."
,"17":"De todas maneras, no me envió Cristo a bautizar, sino a proclamar el Evangelio. ¡Y no con discursos sofisticados! Pues entonces la cruz de Cristo ya no tendría sentido."
,"18":"Porque el lenguaje de la cruz resulta una locura para los que se pierden; pero para los que se salvan, para nosotros, es poder de Dios."
,"19":"Ya lo dijo la Escritura: Destruiré la sabiduría de los sabios y haré fracasar la pericia de los instruidos."
,"20":"Sabios, entendidos, teóricos de este mundo: ¡cómo quedan puestos! ¿Y la sabiduría de este mundo? Dios la dejó como loca."
,"21":"Pues el mundo, con su sabiduría, no reconoció a Dios cuando ponía por obra su sabiduría; entonces a Dios le pareció bien salvar a los creyentes con esta locura que predicamos."
,"22":"Mientras los judíos piden milagros y los griegos buscan el saber,"
,"23":"nosotros proclamamos a un Mesías crucificado: para los judíos ¡qué escándalo! Y para los griegos ¡qué locura!"
,"24":"Pero para los que Dios ha llamado, judíos o griegos, este Mesías es fuerza de Dios y sabiduría de Dios."
,"25":"Pues las locuras de Dios tienen más sabiduría que los hombres, y la debilidad de Dios es más fuerte que los hombres."
,"26":"Fíjense, hermanos, en ustedes, los elegidos de Dios: ¿cuántos de ustedes tienen el saber humano o son de familias nobles e influyentes?"
,"27":"Dios ha elegido lo que el mundo considera necio para avergonzar a los sabios, y ha tomado lo que es débil en este mundo para confundir lo que es fuerte."
,"28":"Dios ha elegido lo que es común y despreciado en este mundo, lo que es nada, para reducir a la nada lo que es."
,"29":"Y así ningún mortal podrá alabarse a sí mismo ante Dios."
,"30":"Por gracia de Dios ustedes están en Cristo Jesús. El ha pasado a ser sabiduría nuestra venida de Dios, y nuestro mérito y santidad, y el precio de nuestra libertad."
,"31":"Así está escrito: El que se gloríe, que se gloríe en el Señor."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Pues yo, hermanos, cuando fui a ustedes para darles a conocer el proyecto misterioso de Dios, no llegué con oratoria ni grandes teorías."
,"2":"Con ustedes decidí no conocer más que a Jesús, el Mesías, y un Mesías crucificado."
,"3":"Yo mismo me sentí débil ante ustedes, tímido y tembloroso."
,"4":"Mis palabras y mi mensaje no contaron con los recursos de la oratoria, sino con manifestaciones de espíritu y poder,"
,"5":"para que su fe se apoyara no en sabiduría humana, sino en el poder de Dios."
,"6":"Es verdad que con los perfectos hablamos de sabiduría, pero es una sabiduría que no procede de este mundo ni de sus cabezas, ya que han sido eliminados."
,"7":"Enseñamos el misterio de la sabiduría divina, el plan secreto que estableció Dios desde el principio para llevarnos a la gloria."
,"8":"Esta sabiduría no fue conocida por ninguna de las cabezas de este mundo, pues de haberla conocido, no habrían crucificado al Señor de la Gloria."
,"9":"Recuerden la Escritura: Ni ojo vio, ni oído oyó, ni por mente humana han pasado las cosas que Dios ha preparado para los que lo aman."
,"10":"Pero a nosotros nos lo reveló Dios por medio de su Espíritu, pues el Espíritu escudriña todo, hasta las profundidades de Dios."
,"11":"En efecto, nadie nos conoce como nuestro espíritu, porque está en nosotros. De igual modo, sólo el Espíritu de Dios conoce las cosas de Dios."
,"12":"Y nosotros no hemos recibido el espíritu del mundo, sino el Espíritu que viene de Dios, y por él entendemos lo que Dios nos ha regalado."
,"13":"Hablamos, pues, de esto, no con los términos de la sabiduría humana, sino con los que nos enseña el Espíritu, expresando realidades espirituales para quienes son espirituales."
,"14":"El que se queda al nivel de la psicología no acepta las cosas del Espíritu. Para él son tonterías y no las puede apreciar, pues se necesita una experiencia espiritual."
,"15":"En cambio, el hombre espiritual lo juzga todo, y a él nadie lo puede juzgar."
,"16":"¿Quién ha conocido la forma de pensar del Señor y puede aconsejarle? Y precisamente nosotros tenemos la forma de pensar de Cristo."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Yo, hermanos, no pude hablarles como a personas espirituales, sino como a personas 'carnales', como a niños en Cristo."
,"2":"Les di leche y no alimento sólido, porque no estaba a su alcance, ni siquiera ahora,"
,"3":"pues continúan siendo carnales. ¿No hay rivalidades y envidias entre ustedes? Entonces son carnales y se portan como la otra gente."
,"4":"Mientras uno dice: 'Yo soy de Pablo', y otro: 'Yo soy de Apolo', ¿no son ustedes gente común y corriente?"
,"5":"¿Qué es Apolo? ¿Qué es Pablo? Son servidores que recibieron de Dios dones diferentes, y por medio de los cuales ustedes llegaron a la fe."
,"6":"Yo planté, Apolo regó, pero el que hizo crecer fue Dios."
,"7":"De modo que el que planta no es algo, ni tampoco el que riega, sino Dios que hace crecer."
,"8":"El que planta y el que riega están en la misma situación, y Dios pagará a cada uno según su trabajo."
,"9":"Nosotros trabajamos con Dios y para él, y ustedes son el campo de Dios y la construcción de Dios."
,"10":"Yo puse los cimientos como buen arquitecto, pues recibí ese talento de Dios, y otro construye encima. Que cada uno, sin embargo, se pregunte cómo construye encima."
,"11":"Pues nadie puede cambiar la base; ya está puesta, y es Cristo Jesús."
,"12":"Sobre este cimiento se puede construir con oro, plata, piedras preciosas, madera, caña o paja."
,"13":"Un día se verá el trabajo de cada uno. Se hará público en el día del juicio, cuando todo sea probado por el fuego. El fuego, pues, probará la obra de cada uno."
,"14":"Si lo que has construido resiste al fuego, serás premiado."
,"15":"Pero si la obra se convierte en cenizas, el obrero tendrá que pagar. Se salvará, pero no sin pasar por el fuego."
,"16":"¿No saben que son templo de Dios y que el Espíritu de Dios habita en ustedes?"
,"17":"Si alguno destruye el templo de Dios, Dios lo destruirá a él. El templo de Dios es sagrado, y ese templo son ustedes."
,"18":"Que nadie se engañe. Si uno es sabio según el mundo y pasa por tal entre ustedes, que se haga tonto y llegará a ser sabio."
,"19":"Porque la sabiduría de este mundo es tontería a los ojos de Dios. Ya lo dijo la Escritura: Dios atrapa a los sabios en su propia sabiduría."
,"20":"Y también: El Señor conoce los argumentos de los sabios y sabe que no valen nada."
,"21":"Así que no se sientan orgullosos de sus grandes hombres. Piensen que todo es para ustedes:"
,"22":"Pablo, Apolo, Cefas, el mundo, la vida, la muerte, lo presente y lo futuro, todo es de ustedes."
,"23":"Y ustedes son de Cristo y Cristo es de Dios."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Vean, pues, en nosotros a servidores de Cristo y a administradores de las obras misteriosas de Dios."
,"2":"Si somos administradores, entiendo que se nos exigirá cumplir."
,"3":"Pero a mí no me importa lo más mínimo cómo me juzgan ustedes o cualquier autoridad humana. Y tampoco quiero juzgarme a mí mismo."
,"4":"A pesar de que no veo nada que reprocharme, eso no basta para justificarme: el Señor me juzgará."
,"5":"Por lo tanto, no juzguen antes de tiempo; esperen que venga el Señor. El sacará a la luz lo que ocultaban las tinieblas y pondrá en evidencia las intenciones secretas. Entonces cada uno recibirá de Dios la alabanza que se merece."
,"6":"Con estas comparaciones, hermanos, me refería a Apolo y a mí. Aprendan a no valerse de uno a costa del otro para engreirse."
,"7":"¿Será necesario que se fijen en ti? ¿Qué tienes que no hayas recibido? Y si lo has recibido, ¿por qué te alabas a ti mismo como si no lo hubieras recibido?"
,"8":"Pero, ¿qué hacer? Ustedes ya son ricos, están satisfechos, y se sienten reyes sin nosotros. ¡Ojalá fueran reyes! Así nos darían un asiento a su lado."
,"9":"Porque me parece que a nosotros, los apóstoles, Dios nos ha colocado en el último lugar, como condenados a muerte; somos un espectáculo divertido para el mundo, para los ángeles y para los hombres."
,"10":"Nosotros somos unos locos por Cristo, ustedes tienen la sabiduría cristiana. Nosotros somos débiles y ustedes fuertes. Ustedes son gente considerada y nosotros despreciados."
,"11":"Hasta el presente pasamos hambre, sed, frío; somos abofeteados, y nos mandan a otra parte."
,"12":"Nos cansamos trabajando con nuestras manos. Si nos insultan, bendecimos; nos persiguen y lo soportamos todo."
,"13":"Nos calumnian y confortamos a los demás. Ya no somos sino la basura del mundo y nos pueden tirar al basural."
,"14":"No les escribo esto para avergonzarlos, sino para amonestarlos como a hijos muy queridos."
,"15":"Pues aunque tuvieran diez mil monitores de vida cristiana, no pueden tener muchos padres, y he sido yo quien les transmitió la vida en Cristo Jesús por medio del Evangelio."
,"16":"Por lo tanto les digo: sigan mi ejemplo."
,"17":"Con este fin les envío a Timoteo, mi querido hijo, hombre digno de confianza en el Señor. El les recordará mis normas de vida cristiana, las mismas que enseño por todas partes y en todas las Iglesias."
,"18":"A algunos de ustedes se les hinchó la cabeza pensando que yo no iría a visitarlos."
,"19":"Pero iré pronto, si el Señor quiere, y veré no lo que dicen esos orgullosos, sino de qué son capaces."
,"20":"Porque el Reino de Dios no es cuestión de palabras, sino de poder."
,"21":"¿Qué prefieren?, ¿que vaya con un palo o con amor y amabilidad?"
}`)
	CurrentBook.AddChapter(5, `{
"1":"De hecho se habla de inmoralidad sexual entre ustedes, y de un caso tal que ni siquiera se da entre los paganos: uno de ustedes convive con su propia madrastra."
,"2":"¡Y ustedes se sienten orgullosos! Más bien tendrían que estar de duelo y expulsar de entre ustedes a ese pecador."
,"3":"Sepan que ya he juzgado al culpable como si estuviese presente, pues estoy ausente en cuerpo pero presente en espíritu."
,"4":"Reunidos ustedes y mi espíritu, en el nombre de nuestro Señor Jesús y con su poder,"
,"5":"entreguen ese hombre a Satanás; que vengan sobre él desgracias, pero que se salve el espíritu en el día del juicio."
,"6":"No es éste el momento de sentirse orgullosos; ¿no saben que un poco de levadura hace fermentar toda la masa?"
,"7":"Echen fuera la vieja levadura y purifíquense; ustedes han de ser una masa nueva, pues si Cristo es para nosotros la víctima pascual, ustedes son los panes sin levadura."
,"8":"Entonces basta ya de vieja levadura, la levadura del mal y del vicio, y celebren la fiesta con el pan sin levadura, que es pureza y sinceridad."
,"9":"En mi carta les decía que no tuvieran trato con la gente de mala conducta."
,"10":"Por supuesto que no me refería a los no-cristianos que practican el libertinaje sexual, a los que quieren tener siempre más, a los que se aprovechan de los demás o a los que adoran a los ídolos. De ser así, ustedes tendrían que salir de este mundo."
,"11":"Yo les decía que no tuvieran trato con quienes, llamándose hermanos, se convierten en inmorales, explotadores, adoradores de ídolos, chismosos, borrachos o estafadores. Ni siquiera deben comer con ellos."
,"12":"Yo no tengo por qué juzgar a los que están fuera, pero, ¿no son ustedes quienes deben juzgar a los que están dentro?"
,"13":"Dejen que Dios juzgue a los que están fuera, pero ustedes ¡saquen al perverso de entre ustedes!"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Cuando alguien de ustedes tiene un conflicto con otro hermano, ¿cómo se atreve a ir ante jueces paganos en vez de someter el caso a miembros de la Iglesia?"
,"2":"¿No saben que un día nosotros, los santos, juzgaremos al mundo? Y si a ustedes les corresponde juzgar al mundo, ¿serán incapaces de juzgar asuntos tan pequeños?"
,"3":"¿No saben que juzgaremos a los ángeles? ¿Y por qué no, entonces, los problemas de cada día?"
,"4":"En esos asuntos deberían poner de jueces a los últimos de la comunidad."
,"5":"¡Qué vergüenza! ¿Así que entre ustedes no hay ni un solo entendido que pueda hacer de árbitro entre hermanos?"
,"6":"Pero, no; un hermano demanda a otro hermano y lleva la causa ante paganos."
,"7":"De todos modos ya es una desgracia que haya entre ustedes pleitos, pero, ¿por qué no mejor soportar la injusticia? ¿Por qué no aceptar perder algo?"
,"8":"¡Al contrario! ¡Son ustedes que cometen injusticias y perjudican a otros, que además son hermanos!"
,"9":"¿No saben acaso que los injustos no heredarán el Reino de Dios? No se engañen: ni los que tienen relaciones sexuales prohibidas, ni los que adoran a los ídolos, ni los adúlteros, ni los homosexuales y los que sólo buscan el placer,"
,"10":"ni los ladrones, ni los que no tienen nunca bastante, ni los borrachos, ni los chismosos, ni los que se aprovechan de los demás heredarán el Reino de Dios."
,"11":"Tal fue el caso de algunos de ustedes, pero han sido lavados, han sido santificados y rehabilitados por el Nombre de Cristo Jesús, el Señor, y por el Espíritu de nuestro Dios."
,"12":"Todo me está permitido, pero no todo me conviene. Todo me está permitido, pero no me haré esclavo de nada."
,"13":"La comida es para el estómago y el estómago para la comida; tanto el uno como la otra son cosas que Dios destruirá. En cambio el cuerpo no es para el sexo, sino para el Señor, y el Señor es para el cuerpo."
,"14":"Y Dios, que resucitó al Señor, nos resucitará también a nosotros con su poder."
,"15":"¿No saben que sus cuerpos son miembros de Cristo? ¿Puedo, entonces, tomar sus miembros a Cristo para hacerlos miembros de una prostituta? ¡Ni pensarlo!"
,"16":"Pues ustedes saben muy bien que el que se une a una prostituta se hace un solo cuerpo con ella. La Escritura dice: Los dos serán una sola carne."
,"17":"En cambio, el que se une al Señor se hace un solo espíritu con él."
,"18":"Huyan de las relaciones sexuales prohibidas. Cualquier otro pecado que alguien cometa queda fuera de su cuerpo, pero el que tiene esas relaciones sexuales peca contra su propio cuerpo."
,"19":"¿No saben que su cuerpo es templo del Espíritu Santo que han recibido de Dios y que está en ustedes? Ya no se pertenecen a sí mismos."
,"20":"Ustedes han sido comprados a un precio muy alto; procuren, pues, que sus cuerpos sirvan a la gloria de Dios."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Ustedes me han escrito sobre varios puntos: es algo excelente que un hombre no toque mujer alguna."
,"2":"Pero no ignoren las exigencias del sexo; por eso, que cada hombre tenga su esposa y cada mujer su marido."
,"3":"El marido cumpla con sus deberes de esposo y lo mismo la esposa."
,"4":"La esposa no dispone de su cuerpo, sino el marido. Igualmente el marido no dispone de su cuerpo, sino la esposa."
,"5":"No se nieguen ese derecho el uno al otro, a no ser que lo decidan juntos, y por cierto tiempo, con el fin de dedicarse más a la oración. Después vuelvan a estar juntos, no sea que caigan en las trampas de Satanás por no saberse dominar."
,"6":"Lo que les digo es a modo de consejo, no estoy dando órdenes."
,"7":"Me gustaría que todos fueran como yo; pero cada uno recibe de Dios su propia gracia, unos de una manera y otros de otra."
,"8":"A los solteros y a las viudas les digo que estaría bien que se quedaran como yo."
,"9":"Pero si no logran contenerse, que se casen, pues más vale casarse que estar quemándose por dentro."
,"10":"En cuanto a los casados, les doy esta orden, que no es mía sino del Señor: que la mujer no se separe de su marido."
,"11":"Y si se ha separado de él, que no se vuelva a casar o que haga las paces con su marido. Y que tampoco el marido despida a su mujer."
,"12":"A los demás les digo, como cosa mía y no del Señor: si algún hermano tiene una esposa que no es creyente, pero acepta vivir con él, que no la despida."
,"13":"Del mismo modo, si una mujer tiene un esposo que no es creyente, pero acepta vivir con ella, que no se divorcie."
,"14":"Pues el esposo no creyente es santificado mediante su esposa, y la esposa no creyente es santificada mediante su marido cristiano. De no ser así, también sus hijos estarían lejos de Dios, mientras que en realidad ya han sido consagrados."
,"15":"Si el esposo o la esposa no creyente se quiere separar, que se separe. En este caso el esposo o la esposa creyente no están esclavizados, pues el Señor nos ha llamado a vivir en paz."
,"16":"¿Estás segura tú, mujer, de que vas a salvar a tu esposo? Y tú, marido, ¿estás seguro de que podrás salvar a tu esposa?"
,"17":"Fuera de este caso, que cada uno siga en la condición en que lo puso el Señor, en la situación en que lo encontró la llamada de Dios. Esta es la regla que doy en todas las Iglesias."
,"18":"¿Estabas circuncidado cuando fuiste llamado? No lo disimules. ¿No eras judío? No debes circuncidarte por el hecho de haber sido llamado."
,"19":"Porque lo que importa no es el haber sido circuncidado o no, sino el observar los mandamientos de Dios."
,"20":"Que cada uno, pues, permanezca en la situación en que estaba cuando fue llamado."
,"21":"¿La llamada de Dios te alcanzó siendo esclavo? No te preocupes. Pero si puedes conseguir la libertad, no dejes pasar esa oportunidad."
,"22":"El que recibió la llamada del Señor siendo esclavo es un cooperador libre del Señor. Y el que fue llamado siendo libre se hace esclavo de Cristo."
,"23":"Ustedes han sido comprados a un precio muy alto; no se hagan esclavos de otros hombres."
,"24":"Por lo tanto, hermanos, que cada uno viva para Dios en el mismo estado en que se encontraba al ser llamado."
,"25":"Respecto a los que se mantienen vírgenes, no tengo mandato alguno del Señor; pero los consejos que les doy son los de un hombre a quien el Señor en su bondad ha hecho digno de crédito."
,"26":"Yo pienso que ésa es una decisión buena. En vista de las dificultades presentes, creo que es bueno vivir así."
,"27":"¿Tienes obligaciones con una mujer? No intentes liberarte. ¿No tienes obligaciones con una mujer? No busques esposa."
,"28":"Si te casas, no cometes pecado, y tampoco comete pecado la joven que se casa. Pero la condición humana les traerá conflictos que yo no quisiera para ustedes."
,"29":"Esto quiero decirles, hermanos: el tiempo se ha acortado. En adelante, los que tienen esposa deben vivir como si no la tuvieran;"
,"30":"los que lloran, como si no lloraran; los que están alegres, como si no lo estuvieran; los que compran, como si no hubieran adquirido nada;"
,"31":"y los que gozan la vida presente, como si no la gozaran. Piensen que todo lo actual está pasando."
,"32":"Yo quisiera verlos libres de preocupaciones. El que no se ha casado se preocupa de las cosas del Señor y de cómo agradarle."
,"33":"No así el que se ha casado, pues se preocupa de las cosas del mundo y de cómo agradar a su esposa, y está dividido."
,"34":"De igual manera la mujer soltera y la joven sin casar se preocupan del servicio del Señor y de ser santas en su cuerpo y en su espíritu. Mientras que la casada se preocupa de las cosas del mundo y de agradar a su esposo."
,"35":"Al decirles esto no quiero ponerles trampas; se lo digo para su bien, con miras a una vida más noble en la que estén enteramente unidos al Señor."
,"36":"Alguien puede sentirse incómodo respecto de su novia que es todavía virgen y está ya entrando en años. Si piensa que es mejor casarse, haga lo que le parezca, pues no comete pecado. Que se casen."
,"37":"Pero puede ser que otro se mantenga firme y decida con toda libertad y con mucha lucidez que su novia se conserve virgen. Este obra mejor."
,"38":"Así, pues, el que se casa con la joven que mantenía virgen obra bien, y el que no se casa obra mejor."
,"39":"La mujer está ligada a su marido mientras éste vive. Pero si se muere queda libre y puede casarse con quien desee, siempre que sea un matrimonio cristiano."
,"40":"De todos modos será más feliz si permanece sin casarse; éste es mi consejo. Y creo que yo también tengo el Espíritu de Dios."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Hablemos de la carne sacrificada a los ídolos. Todos, por supuesto, hemos alcanzado el saber; pero el saber infla al hombre, mientras que el amor edifica."
,"2":"El que cree que sabe (algo), es que no sabe todavía qué es conocer;"
,"3":"pero si uno ama (a Dios), éste ha sido conocido (por Dios)."
,"4":"Entonces, ¿se puede comer carne sacrificada a los ídolos? Sabemos que un ídolo no es nada en realidad y que no hay más Dios que el Unico."
,"5":"Ciertamente la gente habla de dioses en el cielo o en la tierra, y en ese sentido hay muchos dioses y señores."
,"6":"Pero para nosotros hay un solo Dios, el Padre: todo viene de él y nosotros vamos hacia él. Y hay un solo Señor, Cristo Jesús: todo depende de él y de él dependemos nosotros."
,"7":"Pero no todos tienen este conocimiento. Algunos estaban tan acostumbrados hasta hace poco, que para ellos comer lo que se ofreció al ídolo es como sacrificar al ídolo; y con esto manchan su conciencia poco formada."
,"8":"Ciertamente no es un alimento el que nos hará agradables a Dios; de comerlo, no será grande el provecho, y de no comer, no nos faltará."
,"9":"Cuídense, pues, de que sus derechos no hagan caer a los débiles."
,"10":"Si uno de ellos te ve a ti, con tu buen conocimiento, sentado a la mesa en un salón del templo, su conciencia poco formada se dejará arrastrar y comerá también él esa carne."
,"11":"Y así el débil, ese hermano por quien Cristo murió, se pierde a causa de tu saber."
,"12":"Cuando ustedes ofenden a sus hermanos hiriendo las conciencias que son todavía débiles, pecan contra el mismo Cristo."
,"13":"Por lo tanto, si algún alimento ha de llevar al pecado a mi hermano, mejor no como nunca más carne para no hacer caer a mi hermano."
}`)
	CurrentBook.AddChapter(9, `{
"1":"¿No soy yo acaso libre? ¿No soy yo un apóstol, y un apóstol, que ha visto a Jesús, nuestro Señor, y no son ustedes mi obra en el Señor?"
,"2":"Aunque otros no me reconozcan como apóstol, para ustedes lo soy, y ustedes son en el Señor la prueba de que hago obra de apóstol."
,"3":"Escuchen, pues, lo que replico a quienes me critican:"
,"4":"¿No tenemos acaso derecho a que nos den de comer y de beber?"
,"5":"¿No tenemos derecho a que nos acompañe en nuestros viajes alguna mujer hermana, como hacen los demás apóstoles, y los hermanos del Señor, y el mismo Cefas?"
,"6":"¿Solamente a Bernabé y a mí nos negarán el derecho a no trabajar?"
,"7":"¿Qué soldado va a la guerra a sus propias expensas? ¿Quién planta una viña y no come de sus frutos? ¿Quién cuida ovejas y no se alimenta con la leche del rebaño?"
,"8":"Esto que les recuerdo no son solamente costumbres del mundo, pues la Ley dice lo mismo."
,"9":"En efecto, en la ley de Moisés está escrito: No pongas bozal al buey que trilla. ¿Creen que Dios se preocupa de los bueyes?"
,"10":"No, eso ha sido escrito para nosotros. A nosotros se refiere la Escritura cuando dice que el labrador espera algo de su trabajo y que el que trilla tendrá parte en la cosecha."
,"11":"Si nosotros hemos sembrado en ustedes riquezas espirituales, ¿será mucho que cosechemos entre ustedes algunas cosas de este mundo?"
,"12":"Si otros compartieron lo que ustedes tenían, con mayor razón lo podíamos hacer nosotros, pero no hicimos uso de este derecho y lo soportamos todo para no crear obstáculos al Evangelio de Cristo."
,"13":"¿No saben que los que trabajan en el servicio sagrado son mantenidos por el Templo, y los que sirven al altar reciben su parte de lo que ha sido ofrecido sobre el altar?"
,"14":"El Señor ha ordenado, de igual manera, que los que anuncian el Evangelio vivan del Evangelio."
,"15":"Pero yo no he hecho uso de tales derechos ni tampoco les escribo ahora para reclamarles nada. ¡Antes morir! Eso es para mí una gloria que nadie me podrá quitar."
,"16":"Pues ¿cómo podría alardear de que anuncio el Evangelio? Estoy obligado a hacerlo, y ¡pobre de mí si no proclamo el Evangelio!"
,"17":"Si lo hiciera por decisión propia, podría esperar recompensa, pero si fue a pesar mío, no queda más que el cargo."
,"18":"Entonces, ¿cómo podré merecer alguna recompensa? Dando el Evangelio gratuitamente, y sin hacer valer mis derechos de evangelizador."
,"19":"Asimismo, sintiéndome libre respecto a todos, me he hecho esclavo de todos con el fin de ganar a esa muchedumbre."
,"20":"Me he hecho judío con los judíos para ganar a los judíos. ¿Estaban sometidos a la Ley? Pues yo también me sometí a la Ley, aunque estoy libre de ella, con el fin de ganar a los que se someten a la Ley."
,"21":"Con los que no estaban sujetos a la Ley me comporté como quien no tiene ley -en realidad no estoy sin ley con respecto a Dios, pues Cristo es mi ley-. Pero yo quería ganar a los que eran ajenos a la Ley."
,"22":"Compartí también los escrúpulos de los que tenían conciencia poco firme, para ganar a los inseguros. Me he hecho todo para todos con el fin de salvar, por todos los medios, a algunos."
,"23":"Y todo lo hago por el Evangelio, porque quiero tener también mi parte de él."
,"24":"¿No han aprendido nada en el estadio? Muchos corren, pero uno solo gana el premio. Corran, pues, de tal modo que lo consigan."
,"25":"En cualquier competición los atletas se someten a una preparación muy rigurosa, y todo para lograr una corona que se marchita, mientras que la nuestra no se marchita."
,"26":"Así que no quiero correr sin preparación, ni boxear dando golpes al aire."
,"27":"Castigo mi cuerpo y lo tengo bajo control, no sea que después de predicar a otros yo me vea eliminado."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Les recordaré, hermanos, lo que ocurrió a nuestros antepasados. Todos estuvieron bajo la nube y todos atravesaron el mar."
,"2":"Todos recibieron ese bautismo de la nube y del mar, para que así fueran el pueblo de Moisés;"
,"3":"y todos comieron del mismo alimento espiritual"
,"4":"y bebieron la misma bebida espiritual; el agua brotaba de una roca espiritual que los seguía, y la roca era Cristo."
,"5":"Sin embargo, la mayoría de ellos no agradaron a Dios y sus cuerpos quedaron en el desierto."
,"6":"Todo esto sucedió para ejemplo nuestro, pues debemos guardarnos de los malos deseos que ellos tuvieron."
,"7":"No se hagan servidores de ídolos, igual que algunos de ellos, como dice la Escritura: El pueblo se sentó a comer y a beber y se levantaron para divertirse."
,"8":"No caigan en la prostitución, como muchos de ellos hicieron, y en un solo día cayeron muertos veintitrés mil."
,"9":"No tentemos al Señor, como algunos de ellos lo tentaron y perecieron mordidos por las serpientes."
,"10":"Tampoco se quejen contra Dios, como se quejaron muchos de ellos y fueron eliminados por el ángel exterminador."
,"11":"Todo esto que les sucedió era nuestra misma historia, y fue escrito para instruir a los que vendrían en los últimos tiempos, es decir, a nosotros."
,"12":"Así, pues, el que crea estar en pie tenga cuidado de no caer."
,"13":"De hecho, ustedes todavía no han sufrido más que pruebas muy ordinarias. Pero Dios es fiel y no permitirá que sean tentados por encima de sus fuerzas. En el momento de la tentación les dará fuerza para superarla."
,"14":"Por lo tanto, hermanos muy queridos, huyan del culto a los ídolos."
,"15":"Les hablo como a personas sensatas, juzguen ustedes mismos lo que voy a decir."
,"16":"La copa de bendición que bendecimos, ¿no es comunión con la sangre de Cristo? Y el pan que partimos, ¿no es comunión con el cuerpo de Cristo?"
,"17":"Así, siendo muchos formamos un solo cuerpo, porque el pan es uno y todos participamos del mismo pan."
,"18":"Fíjense en los israelitas: para ellos comer de las víctimas es entrar en comunión con su altar."
,"19":"Con esto no quiero decir que la carne ofrecida al ídolo sea realmente consagrada o que el ídolo sea algo."
,"20":"Pero los sacrificios de los paganos van ofrecidos a los demonios y no a Dios, y no quiero que ustedes entren en comunión con los demonios."
,"21":"No pueden beber al mismo tiempo de la copa del Señor y de la copa de los demonios, ni pueden tener parte en la mesa del Señor y en la mesa de los demonios."
,"22":"¿Queremos provocar acaso los celos del Señor? ¿Seremos acaso más fuertes que él?"
,"23":"Todo está permitido, pero no todo me conviene. Todo está permitido, pero no todo me hace bien."
,"24":"Que cada uno piense no en sí, sino en los demás."
,"25":"Coman, pues, todo lo que se vende en el mercado sin plantearse problemas de conciencia,"
,"26":"pues del Señor es la tierra y todo lo que contiene."
,"27":"Si alguien que no comparte la fe los invita, vayan, si quieren, y coman de todo lo que les sirvan sin plantearse problemas de conciencia."
,"28":"Pero si alguien les dice: 'Esa es carne sacrificada a los ídolos', no coman. Piensen en el que les advirtió y respeten su conciencia."
,"29":"He dicho su conciencia, y no la tuya. ¿Será conveniente que yo haga uso de mi libertad para atraerme los reproches de otra conciencia?"
,"30":"¿Será correcto que yo me beneficie de los dones de Dios y le dé gracias, si va a ser mal interpretado?"
,"31":"Por lo tanto, ya coman, beban o hagan lo que sea, háganlo todo para gloria de Dios."
,"32":"No den escándalo ni a los judíos, ni a los griegos, ni a la Iglesia de Dios."
,"33":"Hagan como yo, que no busco mi propio interés sino el de los demás, es decir, su salvación, y me esfuerzo por complacer a todos."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Sigan mi ejemplo, como yo sigo el de Cristo."
,"2":"Les alabo porque me son fieles en todo y conservan las tradiciones tal como yo se las he transmitido."
,"3":"Pero quiero recordarles que la cabeza de todo varón es Cristo, y la cabeza de la mujer es el varón, y la cabeza de Cristo es Dios."
,"4":"Si un varón ora o profetiza con la cabeza cubierta, deshonra su cabeza."
,"5":"En cambio, la mujer que ora o profetiza con la cabeza descubierta falta al respeto a su cabeza; sería igual si se cortase el pelo al rape."
,"6":"¿No quiere cubrirse el pelo? Que se lo corte al rape. ¿Que le da vergüenza andar con el pelo cortado al rape? Pues que se ponga el velo."
,"7":"El varón no debe cubrirse la cabeza porque es imagen y reflejo de Dios, mientras que la mujer es reflejo del hombre."
,"8":"El varón no procede de la mujer, sino la mujer del varón;"
,"9":"tampoco fue creado el varón con miras a la mujer, sino la mujer con miras al varón."
,"10":"La mujer, pues, debe llevar sobre la cabeza el signo de su dependencia; de lo contrario, ¿qué pensarían los ángeles?"
,"11":"Bien es verdad que en el Señor ya no se puede hablar del varón sin la mujer ni de la mujer sin el varón,"
,"12":"pues si Dios ha formado a la mujer del varón, éste a su vez nace de la mujer, y ambos vienen de Dios."
,"13":"Juzguen ustedes mismos: ¿les parece decente que la mujer ore a Dios con la cabeza descubierta?"
,"14":"El sentido común nos enseña que es vergonzoso para el hombre hacerse un peinado,"
,"15":"mientras que la mujer se siente orgullosa de su cabellera. Precisamente usa el peinado a modo de velo."
,"16":"De todas maneras, si alguien desea discutir, sepa que ésa no es nuestra costumbre, ni tampoco lo es en las Iglesias de Dios."
,"17":"Siguiendo con mis advertencias, no los puedo alabar por sus reuniones, pues son más para mal que para bien."
,"18":"En primer lugar, según me dicen, cuando se reúnen como Iglesia, se notan divisiones entre ustedes, y en parte lo creo."
,"19":"Incluso tendrá que haber partidos, para que así se vea con claridad con quién se puede contar."
,"20":"Ustedes, pues, se reúnen, pero ya no es comer la Cena del Señor,"
,"21":"pues cada uno empieza sin más a comer su propia comida, y mientras uno pasa hambre, el otro se embriaga."
,"22":"¿No tienen sus casas para comer y beber? ¿O es que desprecian a la Iglesia de Dios y quieren avergonzar a los que no tienen nada? ¿Qué les diré? ¿Tendré que aprobarlos? En esto no."
,"23":"Yo he recibido del Señor lo que a mi vez les he transmitido. El Señor Jesús, la noche en que fue entregado, tomó pan"
,"24":"y, después de dar gracias, lo partió diciendo: 'Esto es mi cuerpo, que es entregado por ustedes; hagan esto en memoria mía.'"
,"25":"De igual manera, tomando la copa, después de haber cenado, dijo: 'Esta copa es la Nueva Alianza en mi sangre. Todas las veces que la beban háganlo en memoria mía.'"
,"26":"Fíjense bien: cada vez que comen de este pan y beben de esta copa están proclamando la muerte del Señor hasta que venga."
,"27":"Por tanto, el que come el pan o bebe la copa del Señor indignamente peca contra el cuerpo y la sangre del Señor."
,"28":"Cada uno, pues, examine su conciencia y luego podrá comer el pan y beber de la copa."
,"29":"El que come y bebe indignamente, come y bebe su propia condenación por no reconocer el cuerpo."
,"30":"Y por esta razón varios de ustedes están enfermos y débiles y algunos han muerto."
,"31":"Si nos examináramos a nosotros mismos, no seríamos juzgados."
,"32":"Pero si el Señor nos juzga, nos corrige, para que no seamos condenados con este mundo."
,"33":"En resumen, hermanos, cuando se reúnan para la Cena, espérense unos a otros;"
,"34":"y si alguien tiene hambre, que coma en su casa. Pero no se reúnan para ponerse en mala situación. Lo demás ya lo dispondré cuando vaya."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Ahora, hermanos, les recordaré lo siguiente respecto a los dones espirituales."
,"2":"Cuando aún eran paganos, perdían el control de sí mismos al ser llevados a sus ídolos sin voz ni vida."
,"3":"Ahora les digo que ninguno puede gritar: '¡Maldito sea Jesús!' si el espíritu es de Dios; y nadie puede decir: '¡Jesús es el Señor!', sino con un espíritu santo."
,"4":"Hay diferentes dones espirituales, pero el Espíritu es el mismo."
,"5":"Hay diversos ministerios, pero el Señor es el mismo."
,"6":"Hay diversidad de obras, pero es el mismo Dios quien obra todo en todos."
,"7":"La manifestación del Espíritu que a cada uno se le da es para provecho común."
,"8":"A uno se le da, por el Espíritu, palabra de sabiduría; a otro, palabra de conocimiento según el mismo Espíritu;"
,"9":"a otro, el don de la fe, por el Espíritu; a otro, el don de hacer curaciones, por el único Espíritu;"
,"10":"a otro, poder de hacer milagros; a otro, profecía; a otro, reconocimiento de lo que viene del bueno o del mal espíritu; a otro, hablar en lenguas; a otro, interpretar lo que se dijo en lenguas."
,"11":"Y todo esto es obra del mismo y único Espíritu, que da a cada uno como quiere."
,"12":"Las partes del cuerpo son muchas, pero el cuerpo es uno; por muchas que sean las partes, todas forman un solo cuerpo. Así también Cristo."
,"13":"Hemos sido bautizados en el único Espíritu para que formáramos un solo cuerpo, ya fuéramos judíos o griegos, esclavos o libres. Y todos hemos bebido del único Espíritu."
,"14":"Un solo miembro no basta para formar un cuerpo, sino que hacen falta muchos."
,"15":"Supongan que diga el pie: 'No soy mano, y por lo tanto yo no soy del cuerpo.' No por eso deja de ser parte del cuerpo."
,"16":"O también que la oreja diga: 'Ya que no soy ojo, no soy del cuerpo.' Tampoco por eso deja de ser parte del cuerpo."
,"17":"Si todo el cuerpo fuera ojo, ¿cómo podríamos oír? Y si todo el cuerpo fuera oído, ¿cómo podríamos oler?"
,"18":"Dios ha dispuesto los diversos miembros colocando cada uno en el cuerpo como ha querido."
,"19":"Si todos fueran el mismo miembro, ¿dónde estaría el cuerpo?"
,"20":"Pero hay muchos miembros, y un solo cuerpo."
,"21":"El ojo no puede decir a la mano: 'No te necesito'. Ni tampoco la cabeza decir a los pies: 'No los necesito'."
,"22":"Aun más, las partes del cuerpo que parecen ser más débiles son las más necesarias,"
,"23":"y a las que son menos honorables las tratamos con mayor respeto; cubrimos con más cuidado las que son menos presentables,"
,"24":"mientras que otras, más nobles, no lo necesitan. Dios, al organizar el cuerpo, tuvo más atenciones por lo que era último, "
,"25":"para que no se dividiera el cuerpo; todas sus partes han de tener la misma preocupación unas por otras."
,"26":"Si un miembro sufre, todos sufren con él; y si un miembro recibe honores, todos se alegran con él."
,"27":"Ustedes son el cuerpo de Cristo y cada uno en su lugar es parte de él."
,"28":"En primer lugar están los que Dios hizo apóstoles en la Iglesia; en segundo lugar los profetas; en tercer lugar los maestros; después vienen los milagros, luego el don de curaciones, la asistencia material, la administración en la Iglesia y los diversos dones de lenguas."
,"29":"¿Acaso son todos apóstoles?, ¿son todos profetas?, ¿son todos maestros?, ¿pueden todos hacer milagros,"
,"30":"curar enfermos, hablar lenguas o explicar lo que se dijo en lenguas?"
,"31":"Ustedes, con todo, aspiren a los carismas más elevados, y yo quisiera mostrarles un camino que los supera a todos."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Aunque hablara todas las lenguas de los hombres y de los ángeles, si me falta el amor sería como bronce que resuena o campana que retiñe."
,"2":"Aunque tuviera el don de profecía y descubriera todos los misterios -el saber más elevado-, aunque tuviera tanta fe como para trasladar montes, si me falta el amor nada soy."
,"3":"Aunque repartiera todo lo que poseo e incluso sacrificara mi cuerpo, pero para recibir alabanzas y sin tener el amor, de nada me sirve."
,"4":"El amor es paciente y muestra comprensión. El amor no tiene celos, no aparenta ni se infla."
,"5":"No actúa con bajeza ni busca su propio interés, no se deja llevar por la ira y olvida lo malo."
,"6":"No se alegra de lo injusto, sino que se goza en la verdad."
,"7":"Perdura a pesar de todo, lo cree todo, lo espera todo y lo soporta todo."
,"8":"El amor nunca pasará. Las profecías perderán su razón de ser, callarán las lenguas y ya no servirá el saber más elevado."
,"9":"Porque este saber queda muy imperfecto, y nuestras profecías también son algo muy limitado;"
,"10":"y cuando llegue lo perfecto, lo que es limitado desaparecerá."
,"11":"Cuando era niño, hablaba como niño, pensaba y razonaba como niño. Pero cuando me hice hombre, dejé de lado las cosas de niño."
,"12":"Así también en el momento presente vemos las cosas como en un mal espejo y hay que adivinarlas, pero entonces las veremos cara a cara. Ahora conozco en parte, pero entonces conoceré como soy conocido."
,"13":"Ahora, pues, son válidas la fe, la esperanza y el amor; las tres, pero la mayor de estas tres es el amor."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Busquen el amor y aspiren a los dones espirituales, especialmente al don de profecía."
,"2":"El que habla en lenguas habla a Dios, pero no a los hombres, pues nadie le entiende cuando habla en espíritu y dice cosas misteriosas."
,"3":"El que profetiza, en cambio, da a los demás firmeza, aliento y consuelo."
,"4":"El que habla en lenguas se fortalece a sí mismo, mientras que el profeta edifica a la Iglesia."
,"5":"Me alegraría que todos ustedes hablaran en lenguas, pero más me gustaría que todos fueran profetas. Es mucho mejor tener profetas que quien hable en lenguas, a no ser que haya quien las interprete y así toda la Iglesia saque provecho."
,"6":"Supongan, hermanos, que yo vaya donde ustedes hablando en lenguas. ¿De qué les serviría si no les llevase alguna revelación, con palabras de conocimiento, profecías o enseñanzas?"
,"7":"Tomen un instrumento musical, ya sea una flauta o el arpa; si no doy las notas con sus intervalos, ¿quién reconocerá la melodía que estoy tocando?"
,"8":"Y si el toque de la trompeta no se parece a nada, ¿quién correrá a su puesto de combate?"
,"9":"Lo mismo ocurre con ustedes y sus lenguas. ¿Quién sabrá lo que han dicho si no hay palabras que se entiendan? Habrá sido como hablar al viento."
,"10":"Por muchos idiomas que haya en el mundo, cada uno tiene sus palabras,"
,"11":"pero si yo no conozco el significado de las palabras, seré un extranjero para el que habla, y el que habla será un extranjero para mí."
,"12":"Tomen esto en cuenta, y si se interesan por los dones espirituales, ansíen los que edifican la Iglesia. Así no les faltará nada."
,"13":"El que habla en alguna lengua, pida a Dios que también la pueda interpretar."
,"14":"Cuando oro en lenguas, mi espíritu reza, pero mi entendimiento queda inactivo."
,"15":"¿Estará bien esto? Debo rezar con mi espíritu, pero también con mi mente. Cantaré alabanzas con el espíritu, pero también con la mente."
,"16":"Si alabas a Dios sólo con el espíritu, ¿qué hará el que se conforma con escuchar? ¿Acaso podrá añadir 'amén' a tu acción de gracias? Pues no sabe lo que has dicho."
,"17":"Tu acción de gracias habrá sido maravillosa, pero a él no le ayuda en nada."
,"18":"Doy gracias a Dios porque hablo en lenguas más que todos ustedes."
,"19":"Pero cuando me encuentro en la asamblea prefiero decir cinco palabras mías que sean entendidas y ayuden a los demás, antes que diez mil en lenguas."
,"20":"Hermanos, no sean niños en su modo de pensar. Sean como niños en el camino del mal, pero adultos en su modo de pensar."
,"21":"Dios dice en la Ley: Hablaré a este pueblo en lenguas extrañas y por boca de extranjeros, pero ni así me escucharán."
,"22":"Entiendan, pues, que hablar en lenguas es una señal para quienes no creen, pero no para los creyentes; en cambio, la profecía es para los creyentes, no para los que no creen."
,"23":"Con todo, supongan que la Iglesia entera estuviera reunida y todos hablasen en lenguas y entran algunas personas no preparadas o que todavía no creen. ¿Qué dirían? Que todos están locos."
,"24":"Por el contrario, supongan que todos están profetizando y entra alguien que no cree o que no tiene preparación, y todos le descubren sus errores, le dicen verdades y le hacen revelaciones."
,"25":"Este, al ver descubiertos sus secretos más íntimos, caerá de rodillas, adorará a Dios y proclamará: Dios está realmente entre ustedes."
,"26":"¿Qué podemos concluir, hermanos? Cuando ustedes se reúnen, cada uno puede participar con un canto, una enseñanza, una revelación, hablando en lenguas o interpretando lo que otro dijo en lenguas. Pero que todo los ayude a crecer."
,"27":"¿Quieren hablar en lenguas? Que lo hagan dos o tres al máximo, pero con limitación de tiempo, y que haya quien interprete."
,"28":"Si no hay nadie que pueda interpretar, que se callen en la asamblea y reserven su hablar en lenguas para sí mismos y para Dios."
,"29":"En cuanto a los profetas, que hablen dos o tres, y los demás hagan un discernimiento."
,"30":"Si alguno de los que están sentados recibe una revelación, que se calle el que hablaba."
,"31":"Todos ustedes podrían profetizar, pero uno por uno, para que todos aprendan y todos sean motivados,"
,"32":"pues los espíritus de los profetas están sometidos a los profetas."
,"33":"En todo caso, la obra de Dios no es confusión, sino paz."
,"34":"Hagan como se hace en todas las Iglesias de los santos: que las mujeres estén calladas en las asambleas. No les corresponde tomar la palabra. Que estén sometidas, como lo dice también la Ley."
,"35":"Y si desean saber más, que se lo pregunten en casa a su marido. Es feo que la mujer hable en la asamblea."
,"36":"¿Acaso la palabra de Dios partió de ustedes, o ha llegado tal vez sólo a ustedes?"
,"37":"Los que entre ustedes son considerados profetas o personas espirituales reconocerán que lo que les escribo es mandato del Señor."
,"38":"Y si alguien no lo reconoce, tampoco él será reconocido."
,"39":"Por lo tanto, hermanos, aspiren al don de la profecía y no impidan que se hable en lenguas,"
,"40":"pero que todo se haga en forma digna y ordenada."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Quiero recordarles, hermanos, la Buena Nueva que les anuncié. Ustedes la recibieron y perseveran en ella,"
,"2":"y por ella se salvarán si la guardan tal como yo se la anuncié, a no ser que hayan creído cosas que no son."
,"3":"En primer lugar les he transmitido esto, tal como yo mismo lo recibí: que Cristo murió por nuestros pecados, como dicen las Escrituras;"
,"4":"que fue sepultado; que resucitó al tercer día, también según las Escrituras;"
,"5":"que se apareció a Pedro y luego a los Doce."
,"6":"Después se dejó ver por más de quinientos hermanos juntos, algunos de los cuales ya han entrado en el descanso, pero la mayoría vive todavía."
,"7":"Después se le apareció a Santiago, y seguidamente a todos los apóstoles."
,"8":"Y se me apareció también a mí, iba a decir al aborto, el último de todos."
,"9":"Porque yo soy el último de los apóstoles y ni siquiera merezco ser llamado apóstol, pues perseguí a la Iglesia de Dios."
,"10":"Sin embargo, por la gracia de Dios soy lo que soy y el favor que me hizo no fue en vano; he trabajado más que todos ellos, aunque no yo, sino la gracia de Dios que está conmigo."
,"11":"Pues bien, esto es lo que predicamos tanto ellos como yo, y esto es lo que han creído."
,"12":"Ahora bien, si proclamamos un Mesías resucitado de entre los muertos, ¿cómo dicen algunos ahí que no hay resurrección de los muertos?"
,"13":"Si los muertos no resucitan, tampoco Cristo resucitó."
,"14":"Y si Cristo no resucitó, nuestra predicación no tiene contenido, como tampoco la fe de ustedes."
,"15":"Con eso pasamos a ser falsos testigos de Dios, pues afirmamos que Dios resucitó a Cristo, siendo así que no lo resucitó, si es cierto que los muertos no resucitan."
,"16":"Pues si los muertos no resucitan, tampoco Cristo pudo resucitar."
,"17":"Y si Cristo no resucitó, de nada les sirve su fe: ustedes siguen en sus pecados."
,"18":"Y, para decirlo sin rodeos, los que se durmieron en Cristo están totalmente perdidos."
,"19":"Si nuestra esperanza en Cristo se termina con la vida presente, somos los más infelices de todos los hombres."
,"20":"Pero no, Cristo resucitó de entre los muertos, siendo el primero y primicia de los que se durmieron."
,"21":"Un hombre trajo la muerte, y un hombre también trae la resurrección de los muertos."
,"22":"Todos mueren por estar incluidos en Adán, y todos también recibirán la vida en Cristo."
,"23":"Pero se respeta el lugar de cada uno: Cristo es primero, y más tarde le tocará a los suyos, cuando Cristo nos visite."
,"24":"Luego llegará el fin. Cristo entregará a Dios Padre el Reino después de haber desarmado todas las estructuras, autoridades y fuerzas del universo."
,"25":"Está dicho que debe ejercer el poder hasta que haya puesto a todos sus enemigos bajo sus pies,"
,"26":"y el último de los enemigos sometidos será la muerte."
,"27":"Dios pondrá todas las cosas bajo sus pies. Todo le será sometido, pero es evidente que se excluye a Aquel que le somete el universo."
,"28":"Y cuando el universo le quede sometido, el Hijo se someterá a Aquel que le sometió todas las cosas, para que en adelante Dios sea todo en todos."
,"29":"Pero, díganme, ¿qué buscan esos que se hacen bautizar por los muertos? Si los muertos de ningún modo pueden resucitar, ¿de qué sirve ese bautismo por ellos?"
,"30":"Y nosotros mismos, ¿para qué arriesgamos continuamente la vida?"
,"31":"Sí, hermanos, porque todos los días estoy muriendo, se lo juro por ustedes mismos que son mi gloria en Cristo Jesús nuestro Señor."
,"32":"Si no hay más que esta existencia, ¿de qué me sirve haber luchado contra leones en Efeso? Si los muertos no resucitan, comamos y bebamos, que mañana moriremos."
,"33":"No se dejen engañar: las doctrinas malas corrompen las buenas conductas."
,"34":"Despiértense y no pequen: de conocimiento de Dios algunos de ustedes no tienen nada, se lo digo para su vergüenza."
,"35":"Algunos dirán: ¿Cómo resurgen los muertos? ¿Con qué clase de cuerpo vuelven?"
,"36":"¡Necio! Lo que tú siembras debe morir para recobrar la vida."
,"37":"Y lo que tú siembras no es el cuerpo de la futura planta, sino un grano desnudo, ya sea de trigo o de cualquier otra semilla."
,"38":"Dios le dará después un cuerpo según lo ha dispuesto, pues a cada semilla le da un cuerpo diferente."
,"39":"Hablamos de carne, pero no es siempre la misma carne: una es la carne del hombre, otra la de los animales, otra la de las aves y otra la de los peces."
,"40":"Y si hablamos de cuerpos, el resplandor de los 'cuerpos celestes' no tiene nada que ver con el de los cuerpos terrestres."
,"41":"También el resplandor del sol es muy diferente del resplandor de la luna y las estrellas, y el brillo de una estrella difiere del brillo de otra."
,"42":"Lo mismo ocurre con la resurrección de los muertos. Se siembra un cuerpo en descomposición, y resucita incorruptible."
,"43":"Se siembra como cosa despreciable, y resucita para la gloria. Se siembra un cuerpo impotente, y resucita lleno de vigor."
,"44":"Se siembra un cuerpo animal, y despierta un cuerpo espiritual. Pues si los cuerpos con vida animal son una realidad, también lo son los cuerpos espirituales."
,"45":"Está escrito que el primer Adán era hombre dotado de aliento y vida; el último Adán, en cambio, será espíritu que da vida."
,"46":"La vida animal es la que aparece primero, y no la vida espiritual; lo espiritual viene después."
,"47":"El primer hombre, sacado de la tierra, es terrenal; el segundo viene del cielo."
,"48":"Los de esta tierra son como el hombre terrenal, pero los que alcanzan el cielo son como el hombre del cielo."
,"49":"Y del mismo modo que ahora llevamos la imagen del hombre terrenal, llevaremos también la imagen del celestial."
,"50":"Entiéndanme bien, hermanos: lo que es carne y sangre no puede entrar en el Reino de Dios. En la vida que nunca terminará no hay lugar para las fuerzas de descomposición."
,"51":"Por eso les enseño algo misterioso: aunque no todos muramos, todos tendremos que ser transformados"
,"52":"cuando suene la última trompeta. Será cosa de un instante, de un abrir y cerrar de ojos. Al toque de la trompeta los muertos resucitarán como seres inmortales, y nosotros también seremos transformados."
,"53":"Porque es necesario que nuestro ser mortal y corruptible se revista de la vida que no conoce la muerte ni la corrupción."
,"54":"Cuando nuestro ser corruptible se revista de su forma inalterable y esta vida mortal sea absorbida por la inmortal, entonces se cumplirá la palabra de la Escritura: ¡Qué victoria tan grande! La muerte ha sido devorada."
,"55":"¿Dónde está, oh muerte, tu victoria? ¿Dónde está, oh muerte, tu aguijón?"
,"56":"El aguijón de la muerte es el pecado, y la Ley lo hacía más poderoso."
,"57":"Pero demos gracias a Dios que nos da la victoria por medio de Cristo Jesús, nuestro Señor."
,"58":"Así, pues, hermanos míos muy amados, manténganse firmes y no se dejen conmover. Dedíquense a la obra del Señor en todo momento, conscientes de que con él no será estéril su trabajo."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Respecto a la colecta en favor de los santos, sigan también ustedes las normas que di a las Iglesias de Galacia."
,"2":"Cada domingo, cada uno de ustedes ponga aparte lo que pueda, y no esperen a que yo llegue para recoger las limosnas."
,"3":"Cuando llegue daré credenciales a los que ustedes hayan elegido para que lleven esas limosnas a Jerusalén."
,"4":"Y si puedo ir también yo, harán el viaje conmigo."
,"5":"Estaré con ustedes después de atravesar Macedonia, pues pienso ir por Macedonia."
,"6":"Tal vez me detenga entre ustedes algún tiempo y hasta pase ahí el invierno. Después ustedes me encaminarán a donde tenga que ir."
,"7":"Esta vez no quiero verlos sólo de pasada, pues espero quedarme algún tiempo con ustedes, si el Señor lo permite."
,"8":"De todos modos, me detendré en Efeso hasta Pentecostés,"
,"9":"pues se me ha abierto allí una puerta muy grande y con muchas esperanzas, a pesar de que los enemigos son numerosos."
,"10":"Si llega Timoteo, procuren que no se sienta incómodo entre ustedes. Tengan en cuenta que trabaja en la obra del Señor como yo."
,"11":"Que nadie, pues, lo menosprecie y que pueda regresar contento a mí. Yo lo estoy esperando con los hermanos."
,"12":"En cuanto a nuestro hermano Apolo, le he insistido mucho para que vaya donde ustedes con nuestros hermanos, pero se negó formalmente a hacerlo por ahora. Irá cuando se le presente una oportunidad."
,"13":"Estén alerta, manténganse firmes en la fe, sean hombres, sean fuertes."
,"14":"Háganlo todo con amor."
,"15":"Hermanos, todavía una recomendación más. Como ustedes saben, Estefanás y los suyos son los primeros que se convirtieron en Acaya, y se han puesto al servicio de los creyentes."
,"16":"Ustedes, a su vez, acepten su autoridad así como la de cualquiera que coopere y se dedique al servicio con ellos."
,"17":"La visita de Estefanás, Fortunato y Acaico me ha causado mucha alegría, pues les echaba mucho de menos a todos ustedes."
,"18":"Han tranquilizado mi espíritu y el de ustedes; sepan apreciar siempre a personas como éstas."
,"19":"Los saludan las Iglesias de Asia. Aquila y Prisca los saludan en el Señor, junto con la Iglesia que se reúne en su casa."
,"20":"Los saludan todos los hermanos. Salúdense unos a otros con el beso santo."
,"21":"El saludo es de mi puño y letra: Pablo."
,"22":"Maldito sea el que no ama al Señor. ¡Maran atha! ¡Ven, Señor"
,"23":"La gracia del Señor Jesús permanezca con ustedes."
,"24":"Los amo a todos en Cristo Jesús."
}`)

}
func ES_LBL_LoadNP1EChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, Silvano y Timoteo, a la Iglesia de los tesalonicenses, congregada en Dios Padre y en Cristo Jesús el Señor: Permanezcan con ustedes la gracia y la paz."
,"2":"En todo momento los tenemos presentes en nuestras oraciones y damos gracias sin cesar a Dios por ustedes, pues constantemente"
,"3":"recordamos ante Dios, nuestro Padre, su fe que produce frutos, su amor que sabe actuar, su espera de Cristo Jesús, nuestro Señor, que no se desanima."
,"4":"No olvidamos, hermanos amados por Dios, en qué circunstancias fueron llamados."
,"5":"El Evangelio que les llevamos no se quedó sólo en palabras, sino que hubo milagros y Espíritu Santo, dejándoles plena convicción. Y tampoco han olvidado cómo nos portamos entre ustedes y en atención a ustedes."
,"6":"A su vez ustedes se hicieron imitadores nuestros y del mismo Señor cuando, al recibir la palabra, probaron la alegría del Espíritu Santo en medio de fuertes oposiciones."
,"7":"De este modo pasaron a ser un modelo para todos los creyentes de Macedonia y de Acaya."
,"8":"De hecho, a partir de ustedes la palabra del Señor se difundió en Macedonia y Acaya, y más allá aún. Su fe en Dios se comenta en tantos lugares que no necesitamos decir más al respecto."
,"9":"Todos hablan del éxito que tuvimos entre ustedes y de cómo se pasaron de los ídolos a Dios. Pues empezaron a servir al Dios vivo y verdadero,"
,"10":"esperando que venga del cielo el que nos libera del juicio que se acerca: éste es Jesús, su Hijo, al que resucitó de entre los muertos."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Bien saben, hermanos, que esa visita nuestra no fue en vano."
,"2":"Acabábamos de ser muy maltratados e insultados en Filipos, pero, confiados en nuestro Dios, nos atrevimos a anunciarles el mensaje de Dios enfrentando nuevas luchas."
,"3":"Les dijimos verdades; no teníamos propósitos sucios y no hubo engaño. No."
,"4":"Dios mismo nos ha examinado y nos ha encargado su evangelio, y por tanto nuestra predicación procura agradar, no a los hombres, sino a Dios, que penetra los corazones."
,"5":"Nunca los halagamos con palabras bonitas, como ustedes saben; ni tampoco buscamos dinero, y esto lo sabe Dios."
,"6":"Tampoco buscamos que la gente nos rindiera honores, fueran ustedes u otros,"
,"7":"a pesar de que, como apóstoles de Cristo, hubiéramos podido ser pesados. Por el contrario nos hicimos pequeños entre ustedes, imitando a la madre que juega con su criatura. "
,"8":"Y era tal nuestra preocupación por ustedes, que estábamos dispuestos a darles, no sólo el Evangelio, sino también nuestra propia vida, tan queridos habían llegado a ser para nosotros."
,"9":"Recuerden, hermanos, nuestros trabajos y fatigas. Mientras les predicábamos el Evangelio de Dios, trabajábamos noche y día para no ser una carga para ninguno."
,"10":"Ustedes son testigos, y Dios también, de que nos portamos como santos, como hombres buenos y correctos respecto de todos ustedes que ahora creen."
,"11":"A cada uno lo seguimos como un padre a su hijo;"
,"12":"los animábamos y los urgíamos a que llevasen una vida digna del Dios que los ha llamado a su propio Reino y gloria."
,"13":"De ahí que no cesamos de dar gracias a Dios porque al recibir de nosotros la enseñanza de Dios la aceptaron, no como enseñanza de hombres, sino como Palabra de Dios. Porque eso es realmente y como tal actúa en ustedes los creyentes."
,"14":"De hecho, hermanos, les tocó imitar a las Iglesias de Dios en Judea, Iglesias de Cristo Jesús, pues han sido perseguidos por sus compatriotas del mismo modo que ellos lo fueron por los judíos."
,"15":"Estos son los que dieron muerte al Señor Jesús y a los profetas y los que nos persiguen a nosotros. No agradan a Dios y se portan como enemigos de todos los hombres"
,"16":"al impedirnos hablar a los paganos para que se salven. Lo hacen todo para colmar la medida de sus pecados, pero la condenación está para caer sobre ellos."
,"17":"Como hacía tiempo que nos veíamos privados de su compañía, aunque no alejados de corazón, teníamos grandes deseos de verlos y buscábamos el medio."
,"18":"Quisimos ir a visitarles y, en cuanto a mí, Pablo, lo intenté varias veces, pero Satanás nos puso trabas."
,"19":"En efecto, ¿quién sino ustedes es nuestra esperanza, nuestra alegría y la corona de la que nos sentiremos orgullosos ante Jesús, nuestro Señor, cuando venga?"
,"20":"Ustedes son nuestra gloria y nuestra alegría."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Como no podía soportarlo más, decidí quedarme solo en Atenas"
,"2":"y enviarles a Timoteo, hermano nuestro, que junto con nosotros trabaja con Dios por el Evangelio de Cristo. El debía fortalecerlos y animarlos en la fe"
,"3":"para que nadie se dejara conmover por las pruebas que ahora soportan. Saben que ése es nuestro destino. "
,"4":"Cuando estábamos con ustedes ya se lo decíamos: tendremos que enfrentar la persecución. Y sucedió, como bien saben."
,"5":"Por eso no pude esperar más y envié a Timoteo para tener noticias de la fe, no fuera que el Tentador los hubiera hecho tropezar, resultando inútil nuestro trabajo."
,"6":"Mas ahora Timoteo acaba de volver y nos trae buenas noticias de su fe y su caridad. Nos dice que conservan siempre buen recuerdo de nosotros y que tienen tantas ganas de vernos como nosotros a ustedes."
,"7":"Así que son ustedes, hermanos, y su fe lo que nos dio ánimo en nuestras angustias y pruebas;"
,"8":"si están firmes en el Señor, nosotros volvemos a vivir."
,"9":"¿Cómo podríamos dar suficientemente gracias a Dios por ustedes y por la gran alegría que nos hacen sentir ante Dios?"
,"10":"Noche y día le pedimos con la mayor insistencia que nos permita volver a verlos y completar lo que todavía falta a su fe."
,"11":"Quiera Dios, nuestro Padre, y Jesús, nuestro Señor, prepararnos el camino para ir a visitarlos."
,"12":"Que el Señor los haga crecer más y más en el amor que se tienen unos a otros y en el amor para con todos, imitando el amor que sentimos por ustedes."
,"13":"Que él los fortalezca interiormente para que sean santos e irreprochables delante de Dios, nuestro Padre, el día que venga Jesús, nuestro Señor, con todos sus santos."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Por lo demás, hermanos, les pedimos y rogamos en nombre del Señor Jesús: aprendieron de nosotros cómo han de portarse para agradar a Dios; ya viven así, pero procuren hacer nuevos progresos."
,"2":"Conocen las tradiciones que les entregamos con la autoridad del Señor Jesús:"
,"3":"la voluntad de Dios es que se hagan santos y que rehúyan la libertad sexual."
,"4":"Que cada uno se comporte con su esposa con santidad y respeto,"
,"5":"y no se deje llevar por el deseo, como hace la gente que no conoce a Dios."
,"6":"Que nadie ofenda a su hermano o hermana en esta materia o se aproveche de él. El Señor pedirá cuentas de todas estas cosas, como ya se lo hemos dicho y declarado."
,"7":"Pues Dios no nos llamó a vivir en la impureza, sino en la santidad."
,"8":"Por eso, el que no haga caso de estas advertencias desobedece, no a un hombre, sino al mismo Dios, que les da a ustedes su Espíritu Santo."
,"9":"En cuanto al amor mutuo de hermanos, no necesitan que les escriba, ya que Dios mismo les enseñó a amarse unos a otros."
,"10":"Ya lo practican con los hermanos de toda Macedonia, pero los invito a hacer todavía más."
,"11":"Piensen que es algo grande tener estabilidad, hacerse cargo de las propias necesidades y trabajar con las propias manos, como se lo hemos mandado."
,"12":"Al observar estas reglas serán estimados por los de fuera y no pasarán necesidad."
,"13":"Hermanos, deseo que estén bien enterados acerca de los que ya descansan. No deben afligirse como hacen los demás que no tienen esperanza."
,"14":"¿No creemos que Jesús murió y resucitó? De la misma manera, pues, Dios hará que Jesús se lleve con él a los que ahora descansan."
,"15":"Les damos esto como palabra del Señor: nosotros, los que ahora vivimos, si todavía estamos con vida cuando venga el Señor, no tendremos ventaja sobre los que ya han muerto."
,"16":"Cuando se dé la señal por la voz del arcángel y la trompeta divina, el mismo Señor bajará del cielo. Y primero resucitarán los que murieron en Cristo."
,"17":"Después nosotros, los vivos, los que todavía estemos, nos reuniremos con ellos, llevados en las nubes al encuentro del Señor, allá arriba. Y estaremos con el Señor para siempre."
,"18":"Guarden, pues, estas palabras y confórtense unos a otros."
}`)
	CurrentBook.AddChapter(5, `{
"1":"¿Cuándo sucederá eso? ¿Cómo será? Sobre esto, hermanos, no necesitan que se les hable,"
,"2":"pues saben perfectamente que el día del Señor llega como un ladrón en plena noche."
,"3":"Cuando todos se sientan en paz y seguridad, les caerá de repente la catástrofe encima, lo mismo que llegan los dolores de parto a la mujer embarazada, y nadie podrá escapar."
,"4":"Pero ustedes, hermanos, no andan en tinieblas, de modo que ese día no los sorprenderá como hace el ladrón."
,"5":"Todos ustedes son hijos de la luz e hijos del día: no somos de la noche ni de las tinieblas."
,"6":"Entonces no durmamos como los demás, sino permanezcamos sobrios y despiertos."
,"7":"A los que les gusta la cama duermen en la noche, y a los que les gusta tomar se emborrachan en la noche."
,"8":"Nosotros, en cambio, por ser del día, permanezcamos despiertos; revistámonos de la fe y del amor como de una coraza, y sea nuestro casco la esperanza de la salvación."
,"9":"Pues Dios no nos ha destinado a la condenación, sino a que hagamos nuestra la salvación por Cristo Jesús, nuestro Señor."
,"10":"El murió por nosotros, para que, sea que nos halle despiertos o descansando, entremos junto con él en la vida."
,"11":"Por eso anímense mutuamente y edifíquense juntos, como ya lo están haciendo."
,"12":"Hermanos, les rogamos que se muestren agradecidos con los que trabajan para ustedes, los dirigen en el Señor y los corrigen."
,"13":"Ténganles mucho aprecio y cariño por lo que hacen. Y vivan en paz entre ustedes."
,"14":"Les rogamos también, hermanos, que reprendan a los indisciplinados, animen a los indecisos, sostengan a los débiles y tengan paciencia con todos."
,"15":"Cuiden que nadie devuelva a otro mal por mal, sino constantemente procuren el bien entre ustedes y con los demás."
,"16":"Estén siempre alegres,"
,"17":"oren sin cesar"
,"18":"y den gracias a Dios en toda ocasión; ésta es, por voluntad de Dios, su vocación de cristianos."
,"19":"No apaguen el Espíritu,"
,"20":"no desprecien lo que dicen los profetas."
,"21":"Examínenlo todo y quédense con lo bueno."
,"22":"Eviten toda clase de mal, dondequiera lo encuentren."
,"23":"Que el Dios de la paz los haga santos en toda su persona. Que se digne guardarlos sin reproche en su espíritu, su alma y su cuerpo hasta la venida de Cristo Jesús, nuestro Señor."
,"24":"El que los llamó es fiel y así lo hará."
,"25":"Hermanos, rueguen también por nosotros."
,"26":"Saluden a todos los hermanos con el beso santo."
,"27":"Les ordeno, en nombre del Señor, que se lea esta carta a todos los hermanos."
,"28":"Que la gracia de Cristo Jesús, nuestro Señor, sea con ustedes."
}`)

}
func ES_LBL_LoadNP1IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, apóstol de Cristo Jesús por mandato de Dios, nuestro Salvador, y de Cristo Jesús, nuestra esperanza,"
,"2":"a Timoteo, verdadero hijo mío en la fe. Recibe gracia, misericordia y paz de Dios Padre y de Cristo Jesús nuestro Señor."
,"3":"Al partir para Macedonia te rogué que te quedaras en Efeso; debías advertir a algunos que no cambiaran la doctrina"
,"4":"ni se metieran en leyendas y recuentos interminables de ángeles. Esas cosas alimentan discusiones, pero no sirven para la obra de Dios, que es cuestión de fe."
,"5":"El fin de nuestra predicación es al amor que procede de una mente limpia, de una conciencia recta y de una fe sincera."
,"6":"Por haberse apartado de esta línea algunos se han enredado en palabrerías inútiles."
,"7":"Pretenden ser maestros de la Ley, cuando en realidad no entienden lo que dicen ni de lo que hablan con tanta seguridad."
,"8":"Ya sabemos que la Ley es buena siempre que tengamos presente su finalidad."
,"9":"La Ley no fue instituida para los justos, sino para la gente sin ley, para los rebeldes, impíos y pecadores, para los que no respetan a Dios ni la religión, para los corrompidos e impuros, para los que matan a sus padres y para los asesinos;"
,"10":"para los adúlteros y los que tienen relaciones sexuales entre hombres o con niños, para los mentirosos y para los que juran en falso. Habría que añadir todos los demás pecados que van en contra de la sana doctrina,"
,"11":"según el Evangelio glorioso del Dios bienaventurado, tal como a mí me fue encargado."
,"12":"Doy gracias al que me da la fuerza, a Cristo Jesús, nuestro Señor, por la confianza que tuvo al hacer de mí su encargado."
,"13":"Porque yo fui en un comienzo un opositor, un perseguidor y un violento. Pero él me perdonó porque obraba de buena fe cuando me negaba a creer,"
,"14":"y la gracia de nuestro Señor vino sobre mí muy abundante junto con la fe y el amor cristiano."
,"15":"Esto es muy cierto, y todos lo pueden creer, que Cristo Jesús vino al mundo para salvar a los pecadores, de los cuales soy yo el primero."
,"16":"Por esa razón fui perdonado, para que en mí se manifestara en primer lugar toda la generosidad de Cristo Jesús, y fuera así un ejemplo para todos los que han de creer en él y llegar a la vida eterna."
,"17":"Al Rey de los siglos, al Dios único que vive más allá del tiempo y de lo que se ve, honor y gloria por los siglos de los siglos. Amén."
,"18":"Al darte estas recomendaciones, Timoteo, hijo mío, pienso en las profecías que fueron pronunciadas sobre ti; que ellas te guíen en el buen combate que debes realizar."
,"19":"Conserva la fe y la buena conciencia, no como algunos que se despreocuparon de ella y naufragaron en la fe."
,"20":"Entre ellos están Himeneo y Alejandro, a quienes entregué a Satanás para que aprendieran a no enseñar barbaridades."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Ante todo recomiendo que se hagan peticiones, oraciones, súplicas y acciones de gracias por todos, sin distinción de personas;"
,"2":"por los jefes de estado y todos los gobernantes, para que podamos llevar una vida tranquila y en paz, con toda piedad y dignidad."
,"3":"Esto es bueno y agrada a Dios, nuestro Salvador,"
,"4":"pues él quiere que todos los hombres se salven y lleguen al conocimiento de la verdad."
,"5":"Dios es único, y único también es el mediador entre Dios y los hombres, Cristo Jesús hombre,"
,"6":"que en el tiempo fijado dio el testimonio: se entregó para rescatar a todos."
,"7":"Este es el mensaje del que Dios me ha hecho predicador y apóstol -yo no miento y es pura verdad-: enseño a las naciones en forma creíble y sin errores."
,"8":"Quiero, pues, que en todo lugar donde los hombres estén orando levanten al cielo manos limpias de todo enojo y discusión."
,"9":"Asimismo, que las mujeres sepan revestirse de gracia y buen juicio, en vez de adornarse con peinados rebuscados, oro, joyas o vestidos caros."
,"10":"Si una mujer ha recibido una formación realmente religiosa, las buenas obras han de ser sus adornos."
,"11":"Que la mujer sea sumisa y sepa aprender en vez de molestar."
,"12":"No permito que la mujer enseñe ni que quiera corregir a su marido; que se quede tranquila,"
,"13":"pues Adán fue formado primero y después Eva."
,"14":"Y no fue Adán el que se dejó engañar, sino la mujer, y por ella vino la desobediencia."
,"15":"Se salvará, por supuesto, gracias a la maternidad, con tal de que lleve una vida ordenada, perseverando en la fe, el amor y la obra de santificación."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Si alguien aspira al cargo de obispo, no hay duda de que ambiciona algo muy eminente."
,"2":"Es necesario, pues, que el obispo sea irreprochable, casado una sola vez, casto, dueño de sí, de buenos modales, que acoja fácilmente en su casa y con capacidad para enseñar."
,"3":"No debe ser bebedor ni peleador, sino indulgente, amigo de la paz y desprendido del dinero."
,"4":"Que sepa gobernar su propia casa y mantener a sus hijos obedientes y bien criados."
,"5":"Pues si no sabe gobernar su propia casa, ¿cómo podrá guiar a la asamblea de Dios?"
,"6":"No se debe escoger a un recién convertido, no sea que el cargo se le suba a la cabeza y el diablo lo haga caer."
,"7":"Es necesario también que goce de buena fama ante los que no pertenecen a la Iglesia, para que no hablen mal de él y caiga en las redes del diablo."
,"8":"Los diáconos también han de ser respetables y de una sola palabra, moderados en el uso del vino; que no busquen dinero mal ganado, y"
,"9":"que guarden el misterio de la fe con una conciencia limpia."
,"10":"Primero sean sometidos a prueba y después, si no hubiera nada que reprocharles, sean aceptados como diáconos."
,"11":"Las mujeres igualmente sean respetables, no chismosas, sino serias y dignas de confianza."
,"12":"Los diáconos sean casados una sola vez y gobiernen bien a sus hijos y su propia casa."
,"13":"Los que cumplan bien su oficio se ganarán un lugar de honor, llegando a ser hombres firmes en la fe cristiana."
,"14":"Te doy estas instrucciones con la esperanza de ir pronto a verte."
,"15":"Pero si me demoro, para que sepas cómo debes portarte en la casa de Dios, que es la Iglesia del Dios vivo, pilar y base de la verdad."
,"16":"Sin lugar a dudas, es grande el misterio de la Bondad: El se ha manifestado en la carne; rehabilitado por el Espíritu, ha sido presentado a los ángeles. Proclamado a todas las naciones,y creído en el mundo, ya fue elevado y glorificado."
}`)
	CurrentBook.AddChapter(4, `{
"1":"El Espíritu nos dice claramente que en los últimos tiempos algunos renegarán de la fe para seguir espíritus seductores y doctrinas diabólicas."
,"2":"Aparecerán hombres mentirosos con la conciencia marcada con la señal de los infames."
,"3":"Estos prohíben el matrimonio y no permiten el uso de ciertos alimentos, a pesar de que Dios los creó para que los comamos y luego le demos gracias. Así lo hacen los creyentes que conocen la verdad."
,"4":"Porque todo lo que Dios ha creado es bueno y no hay por qué rechazar un alimento que se toma dando gracias a Dios;"
,"5":"es santificado por la palabra de Dios y la oración."
,"6":"Si explicas estas cosas a los hermanos, serás un buen servidor de Cristo Jesús, alimentado con las enseñanzas de la fe y de la sana doctrina que has seguido."
,"7":"Rechaza las leyendas vergonzosas, verdaderos cuentos de viejas, y dedícate a la piedad como a tu deporte."
,"8":"Los ejercicios deportivos no es que sirvan de mucho; la piedad, en cambio, es útil fuera de toda discusión, pues Dios le prometió la vida, tanto la presente como la futura."
,"9":"Aquí tienes una doctrina segura en la que puedes confiar:"
,"10":"sufrimos y luchamos porque tenemos nuestra esperanza puesta en el Dios vivo, salvador de todos los hombres, en especial de los creyentes."
,"11":"Recomienda todas estas cosas y enséñalas."
,"12":"No dejes que te critiquen por ser joven. Trata de ser el modelo de los creyentes por tu manera de hablar, tu conducta, tu caridad, tu fe y tu vida irreprochable."
,"13":"Mientras llego, dedícate a la lectura, a la predicación y a la enseñanza."
,"14":"No descuides el don espiritual que recibiste de manos de profetas cuando el grupo de los presbíteros te impuso las manos."
,"15":"Ocúpate de estas cosas y fíjate en lo que dije; así todos serán testigos de tus progresos."
,"16":"Cuida de ti mismo y de cómo enseñas; persevera sin desanimarte, pues actuando así te salvarás a ti mismo y a los que te escuchan."
}`)
	CurrentBook.AddChapter(5, `{
"1":"No reprendas con dureza al anciano; al contrario, aconséjalo como si fuera tu padre; trata a los jóvenes como a hermanos;"
,"2":"a las mujeres mayores como a madres y a las jóvenes, con gran pureza, como a hermanas."
,"3":"Atiende a las viudas que son realmente viudas."
,"4":"Si una viuda tiene hijos o nietos, que aprendan éstos primero a cumplir sus deberes con su propia familia y a ayudar a sus padres. Esto es lo correcto ante Dios."
,"5":"La verdadera viuda es la que se queda sola, habiendo puesto en Dios su esperanza, y se dedica día y noche a la oración y a las súplicas."
,"6":"En cambio, la que quiere pasarlo bien, aunque viva, está muerta."
,"7":"Insiste en esto para que nadie pueda criticarlas."
,"8":"Quien no se preocupa de los suyos, especialmente de los de su casa, ha renegado de la fe y es peor que el que no cree."
,"9":"No inscribas entre las viudas más que a quien ya pasó los sesenta años, casada una sola vez"
,"10":"y recomendada por sus buenas obras: si educó a sus hijos, dio hospitalidad, sirvió humildemente a los santos y socorrió a los que sufren. En pocas palabras, que se haya dedicado a hacer el bien."
,"11":"No admitas a las viudas de menos edad, pues cuando ya se han cansado de Cristo quieren casarse"
,"12":"y, faltando a su primer compromiso, se ponen en una situación irregular."
,"13":"Aprenden además a no hacer nada y se acostumbran a andar de casa en casa. Como no tienen nada que hacer, hablan de más, se meten en lo que no les toca y dicen lo que no deben."
,"14":"Quiero, pues, que las viudas jóvenes se vuelvan a casar, que tengan hijos y sean amas de casa, antes que dar a nuestros adversarios algún pretexto para criticar."
,"15":"Algunas ya se han extraviado siguiendo a Satanás."
,"16":"Si alguna mujer creyente tiene viudas en su familia, que las atienda. Así la Iglesia no tendrá que cargar con ellas y podrá socorrer a las que son viudas en el justo sentido."
,"17":"Los presbíteros que son buenos dirigentes recibirán doble honor y remuneración, sobre todo los que llevan el peso de la predicación y de la enseñanza."
,"18":"Lo dijo la Escritura: No pongas bozal al buey que trilla, y también: El trabajador tiene derecho a su salario."
,"19":"No aceptes acusaciones contra un presbítero si no son presentadas al menos por dos o tres testigos."
,"20":"Reprenderás en público a los que están en pecado, para que los demás sientan temor."
,"21":"Te pido insistentemente ante Dios, Cristo Jesús y los santos ángeles que observes estas reglas con imparcialidad, sin hacer diferencias."
,"22":"No impongas a nadie las manos a la ligera, pues te harías cómplice de los pecados de otro;"
,"24":"consérvate sin mancha. Hay personas cuyos pecados son notorios antes de cualquier investigación; los de otros, en cambio, sólo después."
,"25":"Del mismo modo las buenas acciones pueden ser notorias; y si no lo son, tendrán que descubrirse."
,"23":"No sigas bebiendo agua sola. Toma un poco de vino a causa de tu estómago y de tus frecuentes malestares."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Los que están bajo el yugo de la esclavitud procuren ser muy respetuosos con sus amos, no sea que las críticas recaigan sobre el nombre de Dios y su doctrina."
,"2":"Los que tienen amos cristianos no deben perderles el respeto bajo el pretexto de que son hermanos; al contrario, sírvanlos mejor, ya que los que reciben sus servicios son creyentes y hermanos queridos. Esto es lo que debes enseñar e inculcar. "
,"3":"Si alguno enseña en otra forma y no se atiene a las palabras auténticas, que son las de Cristo Jesús, nuestro Señor, y a la enseñanza que honra a Dios,"
,"4":"es un ciego que no entiende nada. Ese padece la enfermedad de las discusiones y cuestiones inútiles, de donde proceden envidias, discordias, insultos, desconfianzas"
,"5":"y discusiones propias de los que tienen la mente pervertida. Están tan alejados de la verdad que para ellos la religión es un puro negocio."
,"6":"Es verdad que la religión es un buen negocio, pero en otro sentido, si gracias a ella nos conformamos con lo que tenemos."
,"7":"Pues al llegar al mundo no trajimos nada, y al dejarlo tampoco nos llevaremos nada."
,"8":"Conformémonos entonces con tener alimento y ropa."
,"9":"Los que quieren ser ricos caen en tentaciones y trampas; un montón de ambiciones locas y dañinas los hunden en la ruina hasta perderlos."
,"10":"Debes saber que la raíz de todos los males es el amor al dinero. Algunos, arrastrados por él, se extraviaron lejos de la fe y se han torturado a sí mismos con un sinnúmero de tormentos."
,"11":"Pero tú, hombre de Dios, huye de todo eso. Procura ser religioso y justo. Vive con fe y amor, constancia y bondad."
,"12":"Pelea el buen combate de la fe, conquista la vida eterna a la que has sido llamado y por la que hiciste tu hermosa declaración de fe en presencia de numerosos testigos."
,"13":"Ahora te doy una orden en presencia del Dios que da vida al universo entero, y de Cristo Jesús, que dio su magnífico testimonio ante Poncio Pilato:"
,"14":"guarda el mandato, presérvalo de todo lo que pueda mancharlo o adulterarlo hasta la venida gloriosa de Cristo Jesús, nuestro Señor."
,"15":"A su debido tiempo Dios lo manifestará, el Bienaventurado y único Soberano, Rey de reyes y Señor de señores."
,"16":"Al único inmortal, al que habita en la luz inaccesible,a quien ningún hombre ha visto ni puede ver, a él honor y poder por siempre jamás. ¡Amén!"
,"17":"Exige a los ricos que no sean arrogantes ni confíen en las riquezas, que son siempre inseguras; que más bien confíen en Dios, que nos proporciona todo generosamente para que lo disfrutemos."
,"18":"Que practiquen el bien, que se hagan ricos en buenas obras, que den de buen corazón, que sepan compartir."
,"19":"De esta forma amontonarán un capital sólido para el porvenir y conseguirán la vida verdadera."
,"20":"Timoteo, conserva el depósito, evita las palabrerías inútiles y mundanas así como las discusiones procedentes de una falsa ciencia."
,"21":"Por darle crédito, algunos se han alejado de la fe. La gracia esté con todos ustedes."
}`)

}
func ES_LBL_LoadNP2CChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, apóstol de Cristo Jesús por voluntad de Dios, y el hermano Timoteo saludan a la Iglesia de Dios que está en Corinto y a los santos que viven en toda Acaya."
,"2":"Reciban gracia y paz de Dios nuestro Padre y de Cristo Jesús, el Señor."
,"3":"Bendito sea Dios, Padre de Cristo Jesús, nuestro Señor, Padre lleno de ternura, Dios del que viene todo consuelo."
,"4":"El nos conforta en toda prueba, para que también nosotros seamos capaces de confortar a los que están en cualquier dificultad, mediante el mismo consuelo que recibimos de Dios."
,"5":"Pues en la misma medida en que los sufrimientos de Cristo recaen abundantemente sobre nosotros, el consuelo de Cristo también nos llega con mayor abundancia."
,"6":"Estas pruebas nuestras son para consuelo y salvación de ustedes, y de igual modo nuestro consuelo será consuelo para ustedes cuando tengan que soportar los mismos sufrimientos que ahora padecemos nosotros."
,"7":"Si ustedes comparten nuestros sufrimientos, también compartirán nuestro consuelo; se lo decimos y lo esperamos con mucha firmeza."
,"8":"Hermanos, deseamos que conozcan algo de lo que nos tocó padecer en Asia. Realmente fue tan grande el peso de esa prueba que ya habíamos perdido toda esperanza de salir con vida."
,"9":"Sentimos en nosotros una sentencia de muerte, pero eso fue sólo para que no confiáramos en nosotros mismos, sino en Dios, que resucita a los muertos."
,"10":"El nos libró de ese peligro de muerte tan grande, y nos seguirá protegiendo. En él hemos puesto nuestra esperanza y seguirá amparándonos,"
,"11":"siempre que ustedes nos ayuden con sus oraciones. Si son muchos los que piden por nosotros, serán también muchos los que darán gracias a Dios cuando nos toque recibir."
,"12":"Hay algo de lo que nos sentimos orgullosos: nuestra conciencia nos asegura que la santidad y la sinceridad de Dios han inspirado siempre nuestra conducta en este mundo, especialmente respecto a ustedes. No nos han movido razones humanas, sino la gracia de Dios."
,"13":"En lo que les escribimos no hay segundas intenciones, sino exactamente lo que leen y entienden, y espero que así lo entenderán para el futuro."
,"14":"Seguramente empiezan a comprender que deben sentirse orgullosos de nosotros, como también nosotros nos sentiremos orgullosos de ustedes en el día del Señor Jesús."
,"15":"Con esta seguridad quería ir primero a visitarlos, y esto habría sido para ustedes una segunda gracia."
,"16":"Desde ahí pensaba recorrer Macedonia, y de Macedonia volver otra vez a ustedes, para que me ayudasen a proseguir mi viaje a Judea."
,"17":"¿Acaso era una decisión muy apresurada? ¿O era tal vez sólo una decisión humana y en mí se daba al mismo tiempo un no y un sí?"
,"18":"Dios sabe que nuestro modo de proceder con ustedes no es sí y no,"
,"19":"al igual que el Hijo de Dios, Cristo Jesús, al que tanto yo como Silvano y Timoteo predicamos, no fue sí y no; en él no hubo más que un sí."
,"20":"En él todas las promesas de Dios han llegado a ser un sí, y por eso precisamente decimos 'Amén' en su nombre cuando damos gracias a Dios."
,"21":"Y Dios es el que nos da fuerza, a nosotros y a ustedes, para Cristo; él nos ha ungido"
,"22":"y nos ha marcado con su propio sello al depositar en nosotros los primeros dones del Espíritu."
,"23":"Dios sabe, y se lo juro por mi propia vida, que sólo la misericordia hacia ustedes me inspiró no volver a Corinto."
,"24":"No pretendo controlar autoritariamente su fe, sino darles motivos de alegría, y hablando de fe, ustedes se mantienen firmes."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Preferí no volver a visitarlos, si iba a causar otra vez tristezas."
,"2":"Pues si yo los aflijo, ¿quién me devolverá la alegría, sino aquel a quien he afligido?"
,"3":"Por eso les escribí: 'Ojalá que cuando vaya no tenga que entristecerme a causa de los mismos que deberían ser mi alegría. Confío y estoy seguro de que todos podrán compartir mi alegría.'"
,"4":"En efecto, les escribí profundamente preocupado y afligido, y hasta con lágrimas; no quería causarles tristeza, sino que se dieran cuenta del amor inmenso que les tengo."
,"5":"Si alguno ha causado molestia, no es a mí a quien ha molestado, sino a todos ustedes; y tampoco quisiera exagerar."
,"6":"Ya le basta la reprensión que recibió de la comunidad."
,"7":"Ahora es mejor que lo perdonen y le den ánimo, no sea que la pena sea más grande de lo que pueda soportar."
,"8":"Les ruego, pues, que le demuestren cariño."
,"9":"En realidad les escribí para comprobar si podía contar con ustedes y con su total obediencia."
,"10":"A quien ustedes perdonen, también yo le perdono, y lo que he perdonado, si realmente tenía algo que perdonar, lo perdoné en atención a ustedes, en presencia de Cristo."
,"11":"Así no se aprovechará Satanás de nosotros, pues conocemos muy bien sus propósitos."
,"12":"Así, pues, llegué a Tróade para predicar el Evangelio de Cristo, y gracias al Señor se me abrió una puerta."
,"13":"Mi espíritu, sin embargo, quedaba inquieto porque no había encontrado a mi hermano Tito, por lo que me despedí de ellos y salí para Macedonia."
,"14":"Gracias sean dadas a Dios, que siempre nos lleva en el desfile victorioso de Cristo y que por nuestro ministerio difunde por todas partes su conocimiento cual fragancia de incienso."
,"15":"Si Cristo es la víctima, nosotros somos la fragancia que sube del sacrificio hacia Dios, y la perciben tanto los que se salvan como los que se pierden."
,"16":"Para los que se pierden es olor de muerte que lleva a la muerte; para los que se salvan, fragancia de vida que conduce a la vida. Pero ¿quién está a la altura de esta misión? "
,"17":"Se encuentran con facilidad vendedores de la palabra de Dios, pero nosotros actuamos por convicción; todo procede de Dios y lo decimos en su presencia, en Cristo."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Pero ¿voy a recomendarme otra vez? ¿Debería acaso llevar cartas de recomendación de ustedes o para ustedes, como hacen otros?"
,"2":"Ustedes mismos son nuestra carta de recomendación; es una carta escrita en el interior de las personas pero que todos pueden leer y entender."
,"3":"Nadie puede negar que ustedes son una carta de Cristo, de la que hemos sido instrumentos, escrita no con tinta, sino con el Espíritu del Dios vivo; carta no grabada en tablas de piedra, sino en corazones humanos."
,"4":"Por eso nos sentimos seguros de Dios gracias a Cristo."
,"5":"¿Cómo podríamos atribuirnos algo a nosotros mismos? Nuestra capacidad nos viene de Dios."
,"6":"Incluso nos ha hecho encargados de una nueva alianza, que ya no es cosa de escritos, sino del Espíritu. Porque lo escrito da muerte, mientras que el Espíritu da vida."
,"7":"Cuando se dieron leyes grabadas en tablas de piedra, ese ministerio fue rodeado de gloria, a pesar de que no traía más que sentencias de muerte; eso no obstante, los israelitas no podían fijar su mirada en el rostro de Moisés a causa de su resplandor, aunque era fugaz."
,"8":"¡Qué gloria tan grande no les esperará, entonces, a los que comunican el Espíritu!"
,"9":"Si tan grande fue el ministerio que sentenciaba la condenación, ¿no lo será mucho más todavía el que procura la santidad?"
,"10":"Es algo tan glorioso bajo ese aspecto, que la gloria del otro ministerio no era nada en comparación."
,"11":"Aquel ministerio era momentáneo y no tuvo más que momentos de gloria, mientras que el nuestro permanece, y con toda su gloria."
,"12":"¡Qué esperanza tan grande! ¡Y qué seguridad nos da!"
,"13":"No es como Moisés, que se cubría el rostro con un velo para que los israelitas no vieran el momento en que se apagara su resplandor."
,"14":"Con todo, los israelitas se volvieron ciegos. El mismo velo les oculta el sentido de la antigua Alianza hasta el día de hoy, y nadie les hace ver que con Cristo ya no tiene valor."
,"15":"Por más que lean a Moisés, el velo cubre su entendimiento hasta hoy,"
,"16":"pero al que se vuelva al Señor se le quita el velo."
,"17":"El Señor es espíritu, y donde está el Espíritu del Señor hay libertad."
,"18":"Todos llevamos los reflejos de la gloria del Señor sobre nuestro rostro descubierto, cada día con mayor resplandor, y nos vamos transformando en imagen suya, pues él es el Señor del espíritu."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ese es nuestro ministerio, y como lo tenemos por gracia de Dios, no nos desanimamos."
,"2":"No nos callamos por falsa vergüenza; no andamos con rodeos ni desvirtuamos la palabra de Dios; manifestando la verdad, merecemos ante Dios que cualquier conciencia humana nos apruebe."
,"3":"Si a pesar de eso permanece oscuro el Evangelio que proclamamos, la oscuridad es para los que se pierden."
,"4":"Se niegan a creer, porque el dios de este mundo los ha vuelto ciegos de entendimiento y no ven el resplandor del Evangelio glorioso de Cristo, que es imagen de Dios."
,"5":"No nos pregonamos a nosotros mismos, sino que proclamamos a Cristo Jesús como Señor; y nosotros somos servidores de ustedes por Jesús."
,"6":"El mismo Dios que dijo: Brille la luz en medio de las tinieblas, es el que se hizo luz en nuestros corazones, para que se irradie la gloria de Dios tal como brilla en el rostro de Cristo."
,"7":"Con todo, llevamos este tesoro en vasos de barro, para que esta fuerza soberana se vea como obra de Dios y no nuestra."
,"8":"Nos sobrevienen pruebas de toda clase, pero no nos desanimamos; estamos entre problemas, pero no desesperados;"
,"9":"somos perseguidos, pero no eliminados; derribados, pero no fuera de combate."
,"10":"Por todas partes llevamos en nuestra persona la muerte de Jesús, para que también la vida de Jesús se manifieste en nuestra persona."
,"11":"Pues a los que estamos vivos nos corresponde ser entregados a la muerte a cada momento por causa de Jesús, para que la vida de Jesús se manifieste en nuestra existencia mortal."
,"12":"Y mientras la muerte actúa en nosotros, a ustedes les llega la vida."
,"13":"Tenemos el mismo don espiritual de fe que tenía el que escribió: Creí, y por eso hablé. También nosotros creemos, y por eso hablamos."
,"14":"Sabemos que aquel que resucitó a Jesús nos resucitará también con Jesús y nos pondrá cerca de él con ustedes."
,"15":"Y todo esto es para bien de ustedes; los favores de Dios se van multiplicando, y también se irá ampliando cada día más la acción de gracias que tantas personas rinden a Dios para gloria suya."
,"16":"Por eso no nos desanimamos; al contrario, aunque nuestro exterior está decayendo, el hombre interior se va renovando de día en día en nosotros."
,"17":"No se pueden equiparar esas ligeras pruebas que pasan aprisa con el valor formidable de la gloria eterna que se nos está preparando."
,"18":"Nosotros, pues, no nos fijamos en lo que se ve, sino en lo que no se ve; porque las cosas visibles duran un momento, pero las invisibles son para siempre."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Sabemos que si nuestra casa terrena o, mejor dicho, nuestra tienda de campaña, llega a desmontarse, Dios nos tiene reservado un edificio no levantado por mano de hombres, una casa para siempre en los cielos."
,"2":"Eso mismo nos mantiene inquietos y anhelamos el día en que nos pongan esa casa celestial por encima de la actual,"
,"3":"pero ¿quién puede saber si todavía estaremos vestidos con este cuerpo mortal o ya estaremos sin él?"
,"4":"Sí, mientras estamos bajo tiendas de campaña sentimos un peso y angustia: no querríamos que se nos quitase este vestido, sino que nos gustaría más que se nos pusiese el otro encima y que la verdadera vida se tragase todo lo que es mortal."
,"5":"Ha sido Dios quien nos ha puesto en esta situación al darnos el Espíritu como un anticipo de lo que hemos de recibir."
,"6":"Así, pues, nos sentimos seguros en cualquier circunstancia. Sabemos que vivir en el cuerpo es estar de viaje, lejos del Señor;"
,"7":"es el tiempo de la fe, no de la visión."
,"8":"Por eso nos viene incluso el deseo de salir de este cuerpo para ir a vivir con el Señor."
,"9":"Pero al final, sea que conservemos esta casa o la perdamos, lo que nos importa es agradar al Señor."
,"10":"Pues todos hemos de comparecer ante el tribunal de Cristo, para recibir cada uno lo que ha merecido en la vida presente por sus obras buenas o malas."
,"11":"Con esa visión del temor al Señor procuramos convencer a los hombres viviendo con sinceridad ante Dios, y confío que también ustedes se den cuenta de que no disimulamos nada."
,"12":"No queremos recomendarnos de nuevo ante ustedes, sino que deseamos darles motivo para que se sientan orgullosos de nosotros y para que sepan responder a los que están tan orgullosos de cosas superficiales pero no de lo interior."
,"13":"Si se nos pasó la mano, es por Dios; si hemos hablado con sensatez, es por ustedes."
,"14":"El amor de Cristo nos urge, y afirmamos que si él murió por todos, entonces todos han muerto."
,"15":"El murió por todos, para que los que viven no vivan ya para sí mismos, sino para él, que por ellos murió y resucitó."
,"16":"Así que nosotros no miramos ya a nadie con criterios humanos; aun en el caso de que hayamos conocido a Cristo personalmente, ahora debemos mirarlo de otra manera."
,"17":"Toda persona que está en Cristo es una creación nueva. Lo antiguo ha pasado, lo nuevo ha llegado."
,"18":"Todo eso es obra de Dios, que nos reconcilió con él en Cristo y que a nosotros nos encomienda el mensaje de la reconciliación."
,"19":"Pues en Cristo Dios estaba reconciliando el mundo con él; ya no tomaba en cuenta los pecados de los hombres, sino que a nosotros nos entregaba el mensaje de la reconciliación."
,"20":"Nos presentamos, pues, como embajadores de Cristo, como si Dios mismo les exhortara por nuestra boca. En nombre de Cristo les rogamos: ¡déjense reconciliar con Dios!"
,"21":"Dios hizo cargar con nuestro pecado al que no cometió pecado, para que así nosotros participáramos en él de la justicia y perfección de Dios."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Somos, pues, los ayudantes de Dios, y ahora les suplicamos que no hagan inútil la gracia de Dios que han recibido."
,"2":"Dice la Escritura: En el momento fijado te escuché, en el día de la salvación te ayudé. Este es el momento favorable, éste es el día de la salvación."
,"3":"Nos preocupamos en toda circunstancia de no dar a otro ningún pretexto para criticar nuestra misión;"
,"4":"al contrario, de mil maneras demostramos ser auténticos ministros de Dios que lo soportan todo: las persecuciones, las privaciones, las angustias,"
,"5":"los azotes, las detenciones, las oposiciones violentas, las fatigas, las noches sin dormir y los días sin comer."
,"6":"Se ve en nosotros pureza de vida, conocimiento, espíritu abierto y bondad, con la actuación del Espíritu Santo y el amor sincero,"
,"7":"con las palabras de verdad y con la fuerza de Dios, con las armas de la justicia, tanto para atacar como para defendernos."
,"8":"Unas veces nos honran y otras nos insultan; recibimos tanto críticas como alabanzas; pasamos por mentirosos, aunque decimos la verdad;"
,"9":"por desconocidos, aunque nos conocen. Nos dan por muertos, pero vivimos; se suceden los castigos, pero no somos ajusticiados;"
,"10":"nos tocan mil penas, y permanecemos alegres. Somos pobres, y enriquecemos a muchos, no tenemos nada, y lo poseemos todo."
,"11":"Corintios, les hablo con franqueza; les abro mi corazón."
,"12":"En mí no falta lugar para acogerlos, pero en ustedes todo es estrecho."
,"13":"Páguennos con la misma moneda. Les hablo como a hijos; sean más abiertos."
,"14":"No se junten con los que rechazan la fe: es cosa absurda. ¿Podrían unirse la justicia y la maldad? ¿Podrían convivir la luz y las tinieblas?"
,"15":"¿Podría haber armonía entre Cristo y Satanás? ¿Qué unión puede haber entre el que cree y el que ya no cree?"
,"16":"¿Qué tiene que ver el Templo de Dios con los ídolos?,Nosotros somos el Templo del Dios vivo. Dios lo dijo: Habitaré y viviré en medio de ellos; yo seré su Dios y ellos serán mi pueblo. "
,"17":"Por eso, salgan de en medio de ellos y apártense, dice el Señor. No toquen nada impuro y yo los miraré con agrado."
,"18":"Yo seré un padre para ustedes, y ustedes serán mis hijos e hijas, dice el Señor, Dueño del universo."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Teniendo, pues, tales promesas, queridos hermanos, purifiquémonos de toda mancha del cuerpo y del espíritu, haciendo realidad la obra de nuestra santificación en el temor de Dios."
,"2":"Hágannos un lugar entre ustedes: a nadie hemos perjudicado, a nadie hemos rebajado, a nadie hemos estafado."
,"3":"No les estoy acusando; ya les dije que los llevamos en nuestro corazón, para vivir unidos y morir juntos."
,"4":"Yo sé que puedo contar con ustedes, y estoy realmente orgulloso de ustedes; esto me conforta y me llena de alegría en todas estas amarguras."
,"5":"Les decía que, al llegar a Macedonia, no tuve descanso alguno, sino más bien toda clase de dificultades; por fuera enfrentamientos, y por dentro temores."
,"6":"Pero Dios, que consuela a los humildes, me confortó con la llegada de Tito."
,"7":"No solamente porque ya lo tenía a mi lado, sino también porque ustedes le habían dado una excelente acogida. Me comentó que ustedes me echaban de menos, que lamentaban lo ocurrido y que estaban muy preocupados por mí, con lo cual me alegré mucho."
,"8":"Si les causé tristeza con mi carta, no lo siento. Y si antes lo pude sentir, pues esa carta por un momento les causó pesar,"
,"9":"ahora me alegro, no por su tristeza, sino porque esa tristeza los llevó al arrepentimiento. Esa tristeza venía de Dios, de manera que ningún mal les sobrevino por causa nuestra."
,"10":"La tristeza que viene de Dios lleva al arrepentimiento y realiza una obra de salvación que no se perderá. Por el contrario, la tristeza que inspira el mundo provoca muerte."
,"11":"Aquella tristeza era según Dios, y miren lo que ha producido en ustedes: ¡qué preocupación tan grande por mí y cuántas disculpas!, ¡qué indignación, temor, exigencias, y qué deseo de desagraviarme y hacerme justicia!,En todo han demostrado que eran inocentes en este asunto. "
,"12":"Yo mismo, al escribirles, no pensaba en el ofensor ni tampoco en el ofendido; más bien quería que ustedes tomaran conciencia ante Dios de la preocupación que tienen por mí."
,"13":"Por eso me sentí confortado. Además de este consuelo, me alegró mucho ver a Tito tan contento de cómo ustedes lo tranquilizaron. "
,"14":"No quedé defraudado por lo bien que le había hablado de ustedes. Siempre digo las cosas como son, y también en esta oportunidad se confirmó el elogio que de ustedes hice a Tito."
,"15":"El ahora, al recordar la obediencia de todos y el respeto lleno de humildad con que lo recibieron, siente mucho más cariño por ustedes."
,"16":"Me alegro, pues, de poder confiar totalmente en ustedes."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Ahora queremos darles a conocer una gracia de Dios con que fueron favorecidas las Iglesias de Macedonia."
,"2":"A pesar de que han sido tan probadas y perseguidas, su gozo y su extrema pobreza se han convertido en riquezas de generosidad."
,"3":"Puedo atestiguar que lo hicieron según sus medios, e incluso por encima de sus medios; espontáneamente"
,"4":"nos recordaban, y con mucha insistencia, esa iniciativa generosa y ese compartir que es la ayuda a los santos."
,"5":"Superaron todas nuestras expectativas, y Dios quiso que se pusieran ellos mismos a disposición nuestra y del Señor."
,"6":"Por eso rogué a Tito que, habiendo él comenzado entre ustedes esta obra de caridad, la llevara también a cabo."
,"7":"Y ustedes que sobresalen en todo: en dones de fe, de palabra y de conocimiento, en entusiasmo, sin hablar del amor que me profesan, traten de sobresalir también en esta obra de generosidad."
,"8":"No es una orden, sino que sólo me baso en la generosidad de otros para ver si ustedes aman de verdad."
,"9":"Ya conocen la generosidad de Cristo Jesús, nuestro Señor, que, siendo rico, se hizo pobre por ustedes para que su pobreza los hiciera ricos."
,"10":"Les hago notar esto: les conviene que se muevan, pues hace ya un año que empezaron, e incluso el proyecto procedió de ustedes."
,"11":"Concluyan, pues, esa obra; lo que se ha decidido con entusiasmo debe ser llevado a cabo según las propias posibilidades."
,"12":"Si hay entusiasmo, cada uno es bien recibido con lo que tenga, y a nadie se le pide lo que no tiene."
,"13":"No se trata de que otros tengan comodidad y que a ustedes les falte, sino de que haya igualdad."
,"14":"Ustedes darán de su abundancia lo que a ellos les falta, y ellos, a su vez, darán de lo que tienen para que a ustedes no les falte. Así reinará la igualdad."
,"15":"Lo dice la Escritura: Al que tenía mucho no le sobraba y al que tenía poco no le faltaba."
,"16":"Den gracias a Dios que inspira a Tito el mismo interés por ustedes."
,"17":"Apenas recibió esta invitación, partió a donde ustedes con todo agrado."
,"18":"Con él enviamos a ese hermano que se ganó el aprecio de todas las Iglesias en la labor del Evangelio,"
,"19":"y que es además el que han designado las Iglesias para acompañarnos en esta obra bendita que organizamos para gloria del Señor, y también por convicción personal."
,"20":"Así lo dispusimos, para que nadie tenga sospechas respecto a estas sumas importantes que estamos manejando."
,"21":"Pues procuramos que todo sea limpio, no sólo ante Dios, sino también ante los hombres."
,"22":"Por eso enviamos con ellos a otro hermano, que nos dio en muchas ocasiones numerosas pruebas de su celo y que ahora se siente más entusiasta por la gran confianza que tiene en ustedes."
,"23":"Ahí tienen, pues, a Tito, mi compañero y ayudante cerca de ustedes, y con él tienen a hermanos nuestros, delegados de las Iglesias, personas que son la gloria de Cristo."
,"24":"Demuéstrenles que aman a sus hermanos y confirmen ante las Iglesias todo lo bien que les hablé de ustedes."
}`)
	CurrentBook.AddChapter(9, `{
"1":"En cuanto a la ayuda a los santos, a nuestros hermanos, no es necesario que se la recomiende,"
,"2":"pues conozco su buena disposición, y lo dije con orgullo ante los macedonios: 'En Acaya están preparados para la colecta desde el año pasado.' Y el entusiasmo de ustedes fue un estímulo para la mayoría de ellos."
,"3":"Ahora, pues, les envío a estos hermanos nuestros. ¡Ojalá que todo lo bueno que he hablado de ustedes al respecto no quede desmentido! Como les digo, estén preparados,"
,"4":"no sea que, al llegar conmigo los de Macedonia, los encuentren desprevenidos. ¡Sería para mí una vergüenza, por no decir para ustedes!"
,"5":"Por eso me pareció necesario rogar a nuestros hermanos que se me adelantaran y fueran a verlos para organizar esa largueza que se había acordado. Bien preparada, demostrará ser una largueza y no una limosna."
,"6":"Miren: el que siembra con mezquindad, con mezquindad cosechará, y el que siembra sin calcular, cosechará también fuera de todo cálculo."
,"7":"Cada uno dé según lo que decidió personalmente, y no de mala gana o a la fuerza, pues Dios ama al que da con corazón alegre."
,"8":"Y poderoso es Dios para bendecirles de mil maneras, de modo que nunca les falte nada y puedan al mismo tiempo cooperar en toda obra buena."
,"9":"La Escritura dice: Repartió, dio a los que tenían hambre; sus méritos permanecen para siempre."
,"10":"Si Dios proporciona la semilla al que siembra y el pan que va a comer, les dará también a ustedes la semilla y la multiplicará, y hará crecer los brotes de sus virtudes."
,"11":"Sean ricos en todo, den con generosidad, y nosotros lo transformaremos en acciones de gracias a Dios."
,"12":"Pues este servicio de carácter sagrado no sólo proporcionará a los hermanos lo que necesitan, sino que de él resultarán incontables acciones de gracias a Dios."
,"13":"Este servicio será para ellos una prueba concreta: darán gracias a Dios porque ustedes son consecuentes con el evangelio de Cristo y saben compartir generosamente con ellos y con todos."
,"14":"Rogarán a Dios por ustedes y les tendrán cariño por la maravillosa gracia que derramó sobre ustedes."
,"15":"Sí, ¡gracias sean dadas a Dios por su don, que nadie sabría expresar!"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Soy yo, Pablo en persona, quien les suplica por la mansedumbre y bondad de Cristo; ¡ese Pablo tan humilde entre ustedes y tan intrépido cuando está lejos!"
,"2":"No me obliguen, cuando esté ante ustedes, a actuar con autoridad, como estoy decidido y como me atreveré a hacerlo con algunos que piensan que yo no quiero crearme problemas."
,"3":"Humana es mi condición, pero no lo es mi combate."
,"4":"Nuestras armas no son las humanas, pero tienen la fuerza de Dios para destruir fortalezas: todos esos argumentos"
,"5":"y esa soberbia que se oponen al conocimiento de Dios. Todo pensamiento tendrá que rendirse a nosotros y someterse a Cristo,"
,"6":"y estamos dispuestos a castigar toda desobediencia en cuanto contemos con la total obediencia de ustedes."
,"7":"Miren las cosas cara a cara. Si alguien cree pertenecer a Cristo, piense lo siguiente: si él es de Cristo, lo soy también yo."
,"8":"Y aunque parezca demasiado seguro del poder que el Señor me dio para edificarlos, no para destruirlos, no me avergonzaré de haberlo dicho."
,"9":"¿Creen que sólo soy capaz de asustarlos con cartas?"
,"10":"'Las cartas son duras y fuertes, dicen algunos, pero tiene poca presencia y es un pobre orador.'"
,"11":"Que lo sepan: lo que mis cartas dicen desde lejos lo haré cuando vaya."
,"12":"¿Cómo me atrevería a igualarme o a compararme con esa gente que proclama sus propios méritos? ¡Tontos! No tienen otro modelo ni usan otro criterio que ellos mismos."
,"13":"Nosotros, en cambio, no pasaremos la medida cuando defendamos nuestra autoridad, pues respetaremos la medida que nos fijó Dios -que todo lo mide bien- al hacernos llegar hasta ustedes."
,"14":"No nos entrometemos entre ustedes como aquellos que no han sabido cómo llegar, pues somos los que les llevamos el Evangelio de Cristo."
,"15":"No llegamos con grandes pretensiones a donde otros han trabajado. Al contrario, esperamos que mientras más crezca su fe, también crezcamos nosotros gracias a ustedes, según nuestra propia pauta."
,"16":"Quiero decir que llevaremos el Evangelio más allá de ustedes en vez de buscar fama donde el trabajo ya está hecho, que es la pauta de los otros."
,"17":"El que se gloríe, gloríese en el Señor."
,"18":"Pues no queda aprobado el que se recomienda a sí mismo, sino aquel a quien le recomienda el Señor."
}`)
	CurrentBook.AddChapter(11, `{
"1":"¡Ojalá me aguantaran algunas tonterías! ¡Claro que las aguantan!"
,"2":"Estoy celoso de ustedes, y son celos de Dios, pues los he ofrecido a Cristo como una joven virgen a la que yo he desposado con el único esposo."
,"3":"Y mi temor es que la serpiente que sedujo a Eva con astucia, podría también pervertirles la mente a ustedes, para que dejen de ser sinceros con Cristo."
,"4":"Ahora vienen a predicarles a otro Jesús, no como se lo predicamos, y les proponen un espíritu diferente del que recibieron, y un evangelio diferente del que abrazaron. ¡Y lo aceptan sin dificultad!"
,"5":"Sin embargo, no creo ser inferior en nada a esos superapóstoles."
,"6":"¿Que mi oratoria deja mucho que desear? Tal vez; pero no mi conocimiento, como se lo he probado ya de mil maneras y en cualquier asunto."
,"7":"¿No habrá sido mi pecado el haberme rebajado para que ustedes crecieran? Yo les he entregado el Evangelio sin cobrarles nada."
,"8":"A otras Iglesias despojé, recibiendo de ellas el sustento para servirlos a ustedes."
,"9":"Cuando me encontraba entre ustedes y estuve necesitado, no molesté a nadie, sino que los hermanos venidos de Macedonia me dieron lo necesario. Me cuidé de ser un peso para ustedes, y todavía me cuidaré:"
,"10":"ahí está mi desafío, y se lo digo por la verdad de Cristo que está en mí, nadie en la tierra de Acaya me igualará en este punto."
,"11":"¿Por qué? ¿Acaso porque no los amo? ¡Dios lo sabe!"
,"12":"Pero lo hago y lo seguiré haciendo para quitar toda posibilidad a los que buscan cómo competir conmigo y pasar por iguales a mí."
,"13":"En realidad son falsos apóstoles, engañadores disfrazados de apóstoles de Cristo."
,"14":"Y no hay que maravillarse, pues si Satanás se disfraza de ángel de luz,"
,"15":"no es mucho que sus servidores se disfracen también de servidores del bien. Pero su fin será el que se merecen sus obras."
,"16":"Una vez más les digo que no me tomen por loco; pero si me toman por tal, acepten que lo sea y que cante un poco mis propias alabanzas."
,"17":"No hablaré el lenguaje del Señor, pues sería locura creer en mis propios méritos."
,"18":"Por eso, si tanta gente hace valer sus méritos en forma tan humana, yo también lo haré."
,"19":"Dicho sea de paso, ustedes, que son tan inteligentes, aguantan bastante bien a los locos."
,"20":"Les gusta que los traten como esclavos, que los exploten, los roben, los traten con desprecio y los golpeen en la cara."
,"21":"Empiezo ya a sentir vergüenza: nosotros fuimos demasiado blandos. Pero si otros son tan atrevidos, hablo como un loco, ¿por qué yo no? "
,"22":"¿Son hebreos? También yo lo soy. ¿Son israelitas? También yo. ¿Son descendientes de Abrahán? También yo. ¿Son ministros de Cristo?"
,"23":"Empiezo a hablar como un loco: yo lo soy más que ellos. Más por mis numerosas fatigas, más por el tiempo pasado en cárcel, mucho más por los golpes recibidos, y muchas veces me encontré en peligro de muerte. "
,"24":"Cinco veces fui condenado por los judíos a los treinta y nueve azotes,"
,"25":"tres veces fui apaleado, una vez fui apedreado, tres veces naufragué, y una vez pasé un día y una noche perdido en alta mar."
,"26":"Viajes frecuentes, peligros de ríos, peligros de bandidos, peligros por parte de mis compatriotas, peligros por parte de los paganos, peligros en la ciudad, peligros en lugares despoblados, peligros en el mar, peligros entre falsos hermanos."
,"27":"Trabajos y agotamiento, con noches sin dormir, con hambre y sed, con muchos días sin comer, con frío y sin abrigo."
,"28":"Además de estas y otras cosas, pesa sobre mí la preocupación por todas las Iglesias."
,"29":"¿Quién vacila que yo no vacile con él? ¿Quién se viene abajo sin que un fuego me devore?"
,"30":"Si hay que alabarse, me gloriaré de las ocasiones en las que me sentí débil."
,"31":"El Dios y Padre de Jesús el Señor, ¡bendito sea por todos los siglos!, sabe que no miento."
,"32":"En Damasco, el gobernador del rey Aretas hizo vigilar la ciudad con intención de apresarme,"
,"33":"y tuve que ser descolgado por una ventana muralla abajo, metido en un canasto. Así escapé de sus manos."
}`)
	CurrentBook.AddChapter(12, `{
"1":"De nada sirve alabarse; pero si hay que hacerlo, iré a las visiones y revelaciones del Señor."
,"2":"Sé de un cierto creyente, el cual hace catorce años fue arrebatado hasta el tercer cielo. Si fue con el cuerpo o fuera del cuerpo, eso no lo sé, lo sabe Dios."
,"3":"Y sé que ese hombre -sea con cuerpo o fuera del cuerpo, no lo sé, Dios lo sabe-"
,"4":"fue arrebatado al paraíso, donde oyó palabras no habladas y que nadie sabría expresar."
,"5":"Podría sentir orgullo pensando en ése, pero en cuanto a mí, sólo me gloriaré de mis debilidades."
,"6":"Si quisiera gloriarme, no sería locura, pues diría la verdad. Pero me abstendré, para que nadie se forme de mí una idea superior a lo que ve u oye decir de mí."
,"7":"Y precisamente para que no me pusiera orgulloso después de tan extraordinarias revelaciones, me fue clavado en la carne un aguijón, verdadero delegado de Satanás, cuyas bofetadas me guardan de todo orgullo."
,"8":"Tres veces rogué al Señor que lo alejara de mí,"
,"9":"pero me dijo: 'Te basta mi gracia, mi mayor fuerza se manifiesta en la debilidad'. Con mucho gusto, pues, me preciaré de mis debilidades, para que me cubra la fuerza de Cristo. "
,"10":"Por eso acepto con gusto lo que me toca sufrir por Cristo: enfermedades, humillaciones, necesidades, persecuciones y angustias. Pues si me siento débil, entonces es cuando soy fuerte."
,"11":"He dicho tonterías, pero ustedes me obligaron. Ustedes debían haber hecho mis elogios, pues en nada me ganan los superapóstoles, aunque nada soy."
,"12":"Cuando estuve entre ustedes, les hice ver todas las señales del verdadero apóstol: paciencia a toda prueba, señales, milagros y prodigios."
,"13":"¿En qué pudieron ustedes sentirse inferiores a las demás Iglesias? Solamente en que no he sido una carga para ustedes. ¡Perdónenme esta ofensa!"
,"14":"Ahora por tercera vez me preparo para visitarlos, y tampoco seré para ustedes una carga, pues no me intereso por lo que tienen, sino por ustedes mismos; y no son los hijos los que deben juntar dinero para sus padres, sino los padres para sus hijos."
,"15":"Por mi parte, de buena gana gastaré lo que tengo y hasta me entregaré entero por todos ustedes. Amándolos más, ¿seré yo menos amado?"
,"16":"Está claro que no fui una carga para ustedes, pero ¿no habrá sido para así estafarlos mejor?"
,"17":"Díganme: ¿cuál de mis enviados les ha sacado dinero?"
,"18":"Llamé a Tito para que fuera a verlos y con él envié a otro hermano. Pues bien, ¿les sacó dinero Tito? ¿No hemos actuado ambos con el mismo espíritu y no hemos seguido la misma pauta?"
,"19":"Tal vez les parecerá que de nuevo tratamos de justificarnos ante ustedes. Pero no; hablamos en Cristo y delante de Dios, y todo esto, amados, es por ustedes, para su provecho espiritual."
,"20":"Temo que, si voy a verlos, no los encuentre como quisiera y que ustedes, a su vez, no me encuentren a mí como desearían. Quizá haya rivalidades, envidias, rencores, disputas, calumnias, chismes, soberbia, desórdenes."
,"21":"Temo que en esa visita mi Dios me humille otra vez ante ustedes y tenga que lamentarme por muchos que anteriormente vivieron en el pecado, al ver que no han dejado aún las impurezas, la mala conducta y los horrores que cometían entonces."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Esta es la tercera vez que voy a verlos, y todo asunto se decidirá por declaración de dos o tres testigos."
,"2":"Ya se lo dije, y ahora que estoy lejos se lo repito como la segunda vez que estuve allá: cuando vuelva a visitarlos no tendré piedad. Que lo sepan tanto los que vivieron en pecado como los demás."
,"3":"Así podrán comprobar que Cristo habla por mí. El no se muestra débil con ustedes, sino que más bien actúa con poder."
,"4":"Si bien su debilidad lo llevó a la cruz, ahora vive por la fuerza de Dios. Así también nosotros compartimos su debilidad, pero viviremos con él por el poder de Dios que actúa en ustedes."
,"5":"Examínense y vean si permanecen en la fe. Pruébense a sí mismos. ¿Están seguros de que Cristo Jesús está en ustedes? ¿Y qué, si no superan la prueba?"
,"6":"Espero que reconozcan que nosotros no estamos reprobados."
,"7":"Pedimos a Dios que no hagan mal alguno, no para quedar bien nosotros, sino por ustedes, para que hagan el bien, aunque quedemos mal nosotros."
,"8":"Pues no tenemos poder alguno contra la verdad, sino sólo a favor de ella,"
,"9":"y nos alegramos cada vez que nos sentimos débiles y ustedes fuertes. Y pedimos a Dios que ustedes lleguen a la perfección."
,"10":"Todo esto se lo digo desde lejos, para no tener que mostrarme duro entre ustedes con la autoridad que el Señor me dio para edificar y no para destruir."
,"11":"Finalmente, hermanos, estén alegres, sigan progresando, anímense, tengan un mismo sentir y vivan en paz. Y el Dios del amor y de la paz estará con ustedes."
,"12":"Salúdense los unos a los otros con el beso santo."
,"13":"Les saludan todos los santos."
,"14":"La gracia de Cristo Jesús, el Señor, el amor de Dios y la comunión del Espíritu Santo sean con todos ustedes."
}`)

}
func ES_LBL_LoadNP2EChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, Silvano y Timoteo a la Iglesia de los tesalonicenses, congregada en Dios nuestro Padre y en Cristo Jesús, el Señor:"
,"2":"Reciban gracia y paz de Dios Padre y de Cristo Jesús, el Señor."
,"3":"Debemos dar gracias a Dios en todo tiempo por ustedes, hermanos. Es justo hacerlo, ya que siguen progresando en la fe y crece el amor de cada uno a los hermanos."
,"4":"Nosotros mismos hablamos de ustedes con orgullo en las Iglesias de Dios, porque se mantienen firmes y guardan su fe en medio de todas las persecuciones y pruebas que deben soportar."
,"5":"Estas han de ser para ustedes una muestra del justo juicio de Dios, pues deben mostrarse dignos de ese Reino de Dios por el cual ahora padecen."
,"6":"Pero también es justo que Dios devuelva sufrimientos a los perseguidores"
,"7":"y que a ustedes, los perseguidos, les dé el descanso con nosotros el día en que el Señor Jesús se manifieste glorioso y venga del cielo rodeado de su corte de ángeles."
,"8":"Entonces la llama ardiente castigará a los que no reconocen a Dios y no obedecen al Evangelio de Jesús, nuestro Señor."
,"9":"Serán condenados a la perdición eterna, lejos del rostro del Señor y de su Gloria irresistible."
,"10":"Vendrá aquel día para ser glorificado en la persona de sus santos y para que todos admiren su obra en los que creyeron, entre los que están ustedes, que acogieron nuestro testimonio."
,"11":"Estos son nuestros pensamientos en todo momento mientras rogamos por ustedes: que nuestro Dios los haga dignos de su llamada y que, por su poder, lleve a efecto sus buenos propósitos, haciendo que su fe sea activa y eficiente."
,"12":"De ese modo el nombre de Jesús, nuestro Señor, será glorificado a través de ustedes y ustedes lo serán en él, por gracia de nuestro Dios y de Cristo Jesús, el Señor."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Pero hablemos, hermanos, de esa venida de Cristo Jesús, nuestro Señor, y de nuestra reunión con él. Les rogamos"
,"2":"que no se dejen perturbar tan fácilmente. No se asusten por manifestaciones del Espíritu, o por rumores, o por alguna carta que pasa por nuestra, que dicen que el día del Señor es inminente."
,"3":"No se dejen engañar de ninguna manera. Primero tiene que producirse la apostasía y aparecer el adversario de la religión, el instrumento de la perdición,"
,"4":"el rebelde que se pone por encima de todo lo que es considerado divino y sagrado, que incluso pondrá su trono en el templo de Dios para mostrar que él es Dios."
,"5":"¿No recuerdan que se lo decía cuando estaba con ustedes?"
,"6":"Ustedes saben qué es lo que ahora lo detiene, para que sólo se manifieste a su debido tiempo."
,"7":"La fuerza antirreligiosa ya está obrando secretamente, pero falta que desaparezca el que la retiene."
,"8":"Entonces se manifestará el adversario, a quien el Señor ha de barrer con el soplo de su boca y al que derribará cuando venga en su gloria."
,"9":"Al presentarse este sin-ley con el poder de Satanás hará milagros, señales y prodigios al servicio de la mentira"
,"10":"para engañar y pervertir a todos los que han de perderse, a los que no aceptaron el amor de la verdad que los habría salvado."
,"11":"Por esta razón les dirige Dios las fuerzas del engaño, dejando que crean en la mentira."
,"12":"Así serán condenados al fin todos los que no quisieron creer en la verdad porque les gustaba más el mal."
,"13":"Pero nosotros tenemos que dar gracias en todo momento por ustedes, hermanos amados por el Señor, pues ustedes son la parte de Dios y fueron elegidos para que se salvaran mediante la fe verdadera y fueran santificados por el Espíritu."
,"14":"Con este fin los llamó mediante el Evangelio que predicamos, y los destinó a compartir la gloria de Cristo Jesús, nuestro Señor."
,"15":"Por lo tanto, hermanos, manténganse firmes y guarden fielmente las tradiciones que les enseñamos de palabra o por carta."
,"16":"Que los anime el propio Cristo Jesús, nuestro Señor, y Dios, nuestro Padre, que nos ha amado dándonos en su misericordia un consuelo eterno y una esperanza feliz."
,"17":"El les dará el consuelo interior y los hará progresar en todo bien de palabra o de obra."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Por lo demás, hermanos, rueguen por nosotros, para que la palabra del Señor prosiga su carrera y consiga el premio, como pasó entre ustedes."
,"2":"Que Dios nos libre también de los individuos indeseables y malos, ya que no todos creen."
,"3":"El Señor es fiel: a ustedes los fortalecerá y preservará del Maligno."
,"4":"Tenemos absoluta confianza en el Señor de que seguirán haciendo lo que les mandamos, como ya lo hacen."
,"5":"Que el Señor fije sus corazones en la buena dirección para que puedan amar a Dios y soportar cristianamente la adversidad."
,"6":"Hermanos, les ordenamos en nombre de Cristo Jesús, el Señor, que se aparten de todo hermano que viva sin control ni regla, a pesar de las tradiciones que les transmitimos."
,"7":"Ya saben cómo tienen que imitarnos, pues no vivimos sin control ni regla mientras estuvimos entre ustedes."
,"8":"No pedimos a nadie un pan que no hubiéramos ganado, sino que trabajamos duramente noche y día hasta cansarnos para no ser una carga para ninguno."
,"9":"Teníamos, por supuesto, el derecho de actuar en otra forma, pero quisimos ser para ustedes un modelo que imitar."
,"10":"Además, cuando estábamos con ustedes les dijimos claramente: el que no quiera trabajar, que tampoco coma."
,"11":"Pero ahora hemos oído que hay entre ustedes algunos que viven sin control ni regla y no hacen nada, muy ocupados en meterse en todo."
,"12":"A ésos les mandamos y les rogamos, por Cristo Jesús, nuestro Señor, que trabajen y se ganen la vida en vez de molestar."
,"13":"Por su parte, hermanos, no se cansen de hacer el bien."
,"14":"Si alguien no obedece lo que les mandamos en esta carta, señálenlo y no tengan más trato con él, para que se avergüence."
,"15":"Pero no lo consideren como enemigo, sino corríjanlo como a hermano."
,"16":"Que el Señor de la paz les dé su paz en todo tiempo y en todo. Que el Señor esté con todos ustedes."
,"17":"Este saludo es de mi propia mano: Pablo. Es la contraseña en todas mis cartas. Esta es mi letra."
,"18":"Que la gracia de Cristo Jesús, nuestro Señor, esté con todos ustedes."
}`)

}
func ES_LBL_LoadNP2IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, apóstol de Cristo Jesús por decisión de Dios, que nos prometió la vida en Cristo Jesús,"
,"2":"a su querido hijo Timoteo. Vengan sobre ti de Dios Padre y de Cristo Jesús, nuestro Señor, la gracia, la misericordia y la paz."
,"3":"Doy gracias a Dios, a quien sirvo con conciencia limpia como mis antepasados, cuando constantemente te recuerdo en mis oraciones noche y día."
,"4":"Al acordarme de tus lágrimas, siento un gran deseo de verte, para llenarme de alegría."
,"5":"Recuerdo tu fe sincera. Así eran tu abuela Loide y tu madre, Eunice, y estoy convencido de que la recibiste de ellas."
,"6":"Por eso te invito a que reavives el don de Dios que recibiste por la imposición de mis manos."
,"7":"Porque Dios no nos dio un espíritu de timidez, sino un espíritu de fortaleza, de amor y de buen juicio."
,"8":"No te avergüences, pues, del martirio de nuestro Señor ni de mí al verme preso. Al contrario, sufre por el Evangelio, sostenido por la fuerza de Dios."
,"9":"El nos ha salvado y nos ha llamado para una vocación santa, no como premio a nuestros méritos, sino gratuitamente y por iniciativa propia. Esta llamada, que nos concedió en Cristo Jesús desde la eternidad,"
,"10":"acaba de manifestarse ahora con la aparición de Cristo Jesús, nuestro Salvador, que ha destruido la muerte y ha hecho resplandecer en su Evangelio la vida y la inmortalidad."
,"11":"Este es el mensaje para el que fui hecho predicador, apóstol y maestro,"
,"12":"y por el que ahora padezco esta nueva prueba. Pero no me avergüenzo, porque sé en quién he puesto mi confianza y estoy convencido de que tiene poder para guardarme hasta aquel día lo que deposité en sus manos."
,"13":"Toma como norma la sana doctrina que has oído de mí sobre la fe y el amor según Cristo Jesús."
,"14":"Conserva el precioso depósito con la ayuda del Espíritu Santo que habita en nosotros."
,"15":"Ya sabes que todos los de Asia me han abandonado, entre ellos Figelo y Hermógenes."
,"16":"Que el Señor bendiga a la familia de Onesíforo, pues a menudo vino a confortarme y no se avergonzó de mis cadenas."
,"17":"Apenas llegó a Roma, se puso a buscarme hasta que me encontró."
,"18":"El Señor le conceda que alcance misericordia ante el Señor aquel día; tú conoces mejor que nadie los servicios que me prestó en Efeso."
}`)
	CurrentBook.AddChapter(2, `{
"1":"En cuanto a ti, hijo, que tu fuerza sea la gracia que tienes en Cristo Jesús."
,"2":"Cuanto has aprendido de mí, confirmado por numerosos testigos, confíalo a personas que merezcan confianza y que puedan instruir después a otros."
,"3":"Soporta las dificultades como un buen soldado de Cristo Jesús."
,"4":"El que se alista en el ejército trata de complacer al que lo contrató, y no se mete en negocios civiles."
,"5":"El atleta no será premiado si no ha competido según el reglamento."
,"6":"Al agricultor que trabaja duro le corresponden en primer lugar los frutos de la cosecha. Entiende lo que quiero decirte;"
,"7":"seguramente el Señor hará que lo comprendas todo."
,"8":"Acuérdate de Cristo Jesús, descendiente de David y resucitado de entre los muertos, según mi evangelio."
,"9":"Por él sufro hasta llevar cadenas como un malhechor; pero la palabra de Dios no está encadenada."
,"10":"Por eso lo soporto todo por el bien de los elegidos, para que también ellos alcancen la salvación que se nos dio en Cristo Jesús y participen de la gloria eterna."
,"11":"Una cosa es cierta: si hemos muerto con él, también viviremos con él."
,"12":"Si sufrimos pacientemente con él, también reinaremos con él. Si lo negamos, también él nos negará."
,"13":"Si somos infieles, él permanece fiel, pues no puede desmentirse a sí mismo."
,"14":"Recuerda a tu gente estas cosas y diles insistentemente en nombre de Dios que dejen las discusiones de palabras, que no son de ningún provecho y desconciertan a quienes las escuchan."
,"15":"Trata de que Dios pueda contar contigo; sé como obrero irreprensible, experto en el manejo de la palabra de la verdad."
,"16":"No participes en conversaciones inútiles y extrañas a la fe, que solamente hacen progresar en la ignorancia de Dios."
,"17":"Son doctrinas que se propagan como la gangrena. Pienso en Himeneo y Fileto,"
,"18":"que se apartaron de la verdad afirmando que la resurrección ya tuvo lugar, con lo que desconciertan la fe de algunos."
,"19":"A pesar de todo no se hunden los sólidos cimientos puestos por Dios, en los cuales está inscrito: El Señor conoce a los suyos, y: Aléjese de la maldad el que invoca el nombre del Señor."
,"20":"En una casa rica no hay sólo vajillas de oro y plata, sino también de madera y de barro. Unas son tratadas con mucho cuidado, y las otras no."
,"21":"Si alguno, pues, trata de no cometer las faltas de que hablo, será como vajilla noble: será santo, útil al Señor, apropiado para toda obra buena."
,"22":"Evita los deseos desordenados, propios de la juventud. Busca la rectitud, la fe, el amor, y ten buenas relaciones con aquellos que invocan al Señor con corazón puro."
,"23":"Pero evita las cuestiones tontas e inútiles, pues sabes que originan peleas."
,"24":"Un servidor del Señor no debe ser peleador, sino comprensivo con todos, buen pedagogo, paciente en las incomprensiones."
,"25":"Reprenderá a los rebeldes con dulzura: quizá Dios les conceda que se conviertan y descubran la verdad,"
,"26":"liberándose de los lazos del diablo que los tiene sometidos a su voluntad."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Has de saber que en los últimos días vendrán momentos difíciles;"
,"2":"los hombres serán egoístas, amantes del dinero, farsantes, orgullosos, chismosos, rebeldes con sus padres, ingratos, sin respeto a la religión;"
,"3":"no tendrán cariño ni sabrán perdonar; serán calumniadores, desenfrenados, crueles, enemigos del bien,"
,"4":"traidores, sinvergüenzas, llenos de orgullo, más amigos de los placeres que de Dios;"
,"5":"ostentarán apariencias de piedad, pero rechazarán sus exigencias. Evita a esa gente. "
,"6":"De esta clase son los que se meten por las casas engatusando a mujeres infelices, llenas de pecados, movidas por toda clase de pasiones,"
,"7":"que siempre están aprendiendo y nunca llegan al conocimiento de la verdad."
,"8":"Del mismo modo que Janés y Jambrés se opusieron a Moisés, también ellos se oponen a la verdad. Son hombres de mente pervertida, descalificados en cuanto a la fe."
,"9":"Pero no irán muy lejos, pues su locura será desenmascarada a la vista de todos, como les pasó a aquéllos."
,"10":"Tú, en cambio, has seguido de cerca mi enseñanza, mi modo de vida, mis proyectos, mi fe, mi paciencia, mi caridad,"
,"11":"mi valentía, mis persecuciones y sufrimientos; sabes lo que me pasó en Antioquía, Iconio y Listra. ¡Cuántas persecuciones tuve que sufrir! Pero de todas me libró el Señor."
,"12":"De igual manera serán perseguidos todos los que quieran servir a Dios en Cristo Jesús."
,"13":"Mientras tanto los pecadores y los embusteros irán de mal en peor, yendo juntos los engañadores y los engañados."
,"14":"Tú, en cambio, quédate con lo que has aprendido y de lo que estás seguro, sabiendo de quiénes lo recibiste."
,"15":"Además, desde tu niñez conoces las Sagradas Escrituras. Ellas te darán la sabiduría que lleva a la salvación mediante la fe en Cristo Jesús."
,"16":"Toda Escritura está inspirada por Dios y es útil para enseñar, rebatir, corregir y guiar en el bien."
,"17":"Así el hombre de Dios se hace un experto y queda preparado para todo trabajo bueno."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Te ruego delante de Dios y de Cristo Jesús, juez de vivos y muertos, que ha de venir y reinar, y te digo:"
,"2":"predica la Palabra, insiste a tiempo y a destiempo, rebatiendo, amenazando o aconsejando, siempre con paciencia y dejando una doctrina."
,"3":"Pues llegará un tiempo en que los hombres ya no soportarán la sana doctrina, sino que se buscarán maestros a su gusto, hábiles en captar su atención;"
,"4":"cerrarán los oídos a la verdad y se volverán hacia puros cuentos."
,"5":"Por eso debes estar siempre alerta. No hagas caso de tus propias penas, dedícate a tu trabajo de evangelizador, cumple bien tu ministerio."
,"6":"Yo, por mi parte, estoy llegando al fin y se acerca el momento de mi partida."
,"7":"He combatido el buen combate, he terminado mi carrera, he guardado lo que depositaron en mis manos."
,"8":"Sólo me queda recibir la corona de toda vida santa con la que me premiará aquel día el Señor, juez justo; y conmigo la recibirán todos los que anhelaron su venida gloriosa."
,"9":"Apresúrate a venir a mí lo antes posible,"
,"10":"pues Demás me ha abandonado; estaba apegado a este mundo y ha vuelto a Tesalónica. Crescente se ha ido a Galacia y Tito a Dalmacia."
,"11":"Solamente Lucas está conmigo. Toma contigo a Marcos, pues me será muy útil para el ministerio."
,"12":"A Tíquico lo mandé a Efeso."
,"13":"Cuando vengas, tráeme la capa que dejé en Tróade, en casa de Carpo, y también los libros, sobre todo los pergaminos."
,"14":"Alejandro, el herrero, me ha causado mucho daño. El Señor le dará su merecido por lo que ha hecho."
,"15":"Ten cuidado con él también tú, pues habla contra lo que predicamos."
,"16":"La primera vez que presenté mi defensa, nadie estuvo a mi lado, todos me abandonaron. ¡Que Dios no se lo tenga en cuenta!"
,"17":"Pero el Señor estuvo conmigo llenándome de fuerza, para que el mensaje fuera proclamado por medio de mí y llegara a oídos de todas las naciones; y quedé libre de la boca del león."
,"18":"El Señor me librará de todo mal y me salvará llevándome a su reino celestial. A él la gloria por los siglos de los siglos. Amén."
,"19":"Saluda a Prisca y Aquila, y a la familia de Onesíforo."
,"20":"Erasto se quedó en Corinto. A Trófimo lo dejé enfermo en Mileto."
,"21":"Haz todo lo posible por venir antes del invierno. Te saludan Eúbulo, Pudente, Lino, Claudia y todos los hermanos. El Señor sea contigo. "
,"22":"La gracia sea con ustedes."
}`)

}
func ES_LBL_LoadNPCLChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"De Pablo, apóstol de Cristo Jesús por voluntad de Dios, y del hermano Timoteo,"
,"2":"a los santos y creyentes que viven en Colosas, verdaderos hermanos míos en Cristo: Reciban gracia y paz de Dios nuestro Padre."
,"3":"En todo momento oramos por ustedes y damos gracias a Dios, Padre de Cristo Jesús, nuestro Señor,"
,"4":"por lo que hemos sabido de su fe en Cristo Jesús y de su caridad para con todos los santos."
,"5":"Pues están esperando la herencia que les está reservada en el cielo y que conocieron por la palabra de la verdad, el Evangelio."
,"6":"Ya está entre ustedes, y lo mismo que va creciendo y dando frutos por todas partes en el mundo, también lo hace entre ustedes desde aquel día en que recibieron y conocieron el don de Dios en toda su verdad."
,"7":"Se lo enseñó Epafras, compañero nuestro muy querido en el servicio de Cristo y para ustedes fiel ministro de Cristo,"
,"8":"quien también ha venido a recordarme el cariño que me tienen en el Espíritu."
,"9":"Por eso, tampoco nosotros hemos cesado de rezar por ustedes desde el día en que recibimos esas noticias, y pedimos a Dios que alcancen el pleno conocimiento de su voluntad mediante dones de sabiduría y entendimiento espiritual."
,"10":"Que lleven una vida digna del Señor y de su total agrado, produciendo frutos en toda clase de buenas obras y creciendo en el conocimiento de Dios."
,"11":"Que se muestren fuertes en todo sentido, fortalecidos por la gloria de Dios; que puedan sufrir y perseverar sin perder la alegría."
,"12":"Y que den gracias al Padre que nos preparó para recibir nuestra parte en la herencia reservada a los santos en su reino de luz."
,"13":"El nos arrancó del poder de las tinieblas y nos trasladó al Reino de su Hijo amado."
,"14":"En él nos encontramos liberados y perdonados."
,"15":"El es la imagen del Dios que no se puede ver, y para toda criatura es el Primogénito,"
,"16":"porque en él fueron creadas todas las cosas,en el cielo y en la tierra, el universo visible y el invisible, Tronos, Gobiernos, Autoridades, Poderes... Todo fue hecho por medio de él y para él."
,"17":"El existía antes que todos, y todo se mantiene en él."
,"18":"Y él es la cabeza del cuerpo, es decir, de la Iglesia, él que renació primero de entre los muertos, para que estuviera en el primer lugar en todo."
,"19":"Así quiso Dios que 'el todo' se encontrara en él"
,"20":"y gracias a él fuera reconciliado con Dios, porque la sangre de su cruz ha restablecido la paz,tanto sobre la tierra como en el mundo de arriba."
,"21":"Ustedes mismos en otro tiempo se quedaron aparte y con sus obras malas actuaron como rebeldes."
,"22":"Pero con su muerte Cristo los reconcilió y los integró a su mismo ser humano mortal, de modo que ahora son santos, sin culpa ni mancha ante él."
,"23":"Pero, por supuesto, perseveren en la fe; muéstrense firmes, cimentados en ella; no se desvíen de su esperanza, tengan siempre presente el Evangelio que han oído, que ha sido predicado a toda criatura en este mundo, y del que yo, Pablo, he llegado a ser encargado."
,"24":"Ahora me alegro cuando tengo que sufrir por ustedes, pues así completo en mi carne lo que falta a los sufrimientos de Cristo para bien de su cuerpo, que es la Iglesia."
,"25":"Esta me ha sido encargada por cuanto recibí de Dios la misión de llevar a efecto entre ustedes su proyecto,"
,"26":"su plan misterioso que permaneció secreto durante siglos y generaciones. Este secreto acaba de ser revelado a sus santos."
,"27":"Quiso darles a conocer la gloria tan grande que su plan misterioso reservaba a las naciones paganas. ¡Ustedes tienen a Cristo y esperan la Gloria!"
,"28":"A ese Cristo anunciamos cuando amonestamos a cada uno y le enseñamos la sabiduría, pues queremos que cada uno llegue a ser 'perfecto' en Cristo."
,"29":"Este es mi trabajo, al que me entrego con la energía que viene de Cristo y que obra poderosamente en mí."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Quiero que sepan cuán duro es el combate que debo soportar por ustedes, por los de Laodicea y por tantos otros que jamás me han visto."
,"2":"Pido que tengan ánimo, que se afiancen en el amor y que tengan plenamente desarrollados los dones de entendimiento, para que puedan penetrar en el gran secreto de Dios, que es Cristo."
,"3":"En él están escondidas todas las riquezas de la sabiduría y del entendimiento."
,"4":"Les digo esto para que nadie los engañe con discursos bonitos."
,"5":"Aunque estoy corporalmente lejos, mi espíritu está con ustedes, y me alegro al ver el equilibrio y la solidez de su fe en Cristo."
,"6":"Han recibido a Cristo Jesús como el Señor; tomen, pues, su camino."
,"7":"Permanezcan arraigados en él y edificados sobre él; estén firmes en la fe, tal como fueron instruidos, y siempre dando gracias."
,"8":"Cuídense de que nadie los engañe con sabidurías o con cualquier teoría hueca, que no son más que doctrinas humanas; pues éste es el camino del mundo y no el de Cristo."
,"9":"Piensen que en él permanece toda la plenitud de Dios en forma corporal."
,"10":"En él ustedes lo tienen todo, pues él está por encima de todos los poderes y autoridades sobrenaturales."
,"11":"En Cristo recibieron una circuncisión no humana, no quirúrgica, que los despojó enteramente del cuerpo carnal. Esta 'circuncisión de Cristo'"
,"12":"es el bautismo, en el cual fueron sepultados con Cristo. Y en él fueron luego resucitados por haber creído en el poder de Dios que lo resucitó de entre los muertos."
,"13":"Ustedes estaban muertos por sus pecados y su misma persona no estaba circuncidada, pero Dios los hizo revivir junto a Cristo: ¡nos perdonó todas nuestras faltas!"
,"14":"Anuló el comprobante de nuestra deuda, esos mandamientos que nos acusaban; lo clavó en la cruz y lo suprimió."
,"15":"Les quitó su poder a las autoridades del mundo superior, las humilló ante la faz del mundo y las llevó como prisioneros en el cortejo triunfal de su cruz."
,"16":"Por tanto, que nadie los venga a criticar por lo que comen o beben, por no respetar fiestas, lunas nuevas o el día sábado."
,"17":"Tales cosas no eran más que sombras, mientras que lo real es la persona de Cristo."
,"18":"No permitan que se lo quiten quienes vienen con una religión muy temerosa y que sirven a los ángeles. En realidad sólo hacen caso de sus propias visiones y se inflan con sus propios pensamientos,"
,"19":"en vez de mantenerse en contacto estrecho con aquel que es la cabeza. El mantiene la unidad del cuerpo entero por un conjunto de nervios y ligamentos y le da firmeza haciéndolo crecer según Dios."
,"20":"Si ustedes han muerto con Cristo y así se han liberado de los reglamentos del mundo, ¿por qué se dejan adoctrinar ahora como si todavía fueran del mundo?"
,"21":"'No tomes esto, no gustes eso, no toques aquello.'"
,"22":"Siempre se trata de cosas que se usan, se desgastan y desaparecen, lo que es propio de mandatos y doctrinas de hombres."
,"23":"Todo eso quiere ser sabiduría, religión, humildad y desprecio del cuerpo, pero no sirve de nada cuando la carne se rebela."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Si han sido resucitados con Cristo, busquen las cosas de arriba, donde Cristo está sentado a la derecha de Dios."
,"2":"Preocúpense por las cosas de arriba, no por las de la tierra."
,"3":"Pues han muerto, y su vida está ahora escondida con Cristo en Dios."
,"4":"Cuando se manifieste el que es nuestra vida, también ustedes se verán con él en la gloria."
,"5":"Por tanto, hagan morir en ustedes lo que es 'terrenal', es decir, libertinaje, impureza, pasión desordenada, malos deseos y el amor al dinero, que es una manera de servir a los ídolos."
,"6":"Tales cosas atraen los castigos de Dios."
,"7":"Ustedes siguieron un tiempo ese camino, y su vida era así."
,"8":"Pues bien, ahora rechacen todo eso: enojo, arrebatos, malas intenciones, ofensas y todas las palabras malas que se pueden decir."
,"9":"No se mientan unos a otros: ustedes se despojaron del hombre viejo y de sus vicios"
,"10":"y se revistieron del hombre nuevo que no cesa de renovarse a la imagen de su Creador hasta alcanzar el perfecto conocimiento."
,"11":"Ahí no se hace distinción entre judío y griego, pueblo circuncidado y pueblo pagano; ya no hay extranjero, bárbaro, esclavo u hombre libre, sino que Cristo es todo en todos."
,"12":"Pónganse, pues, el vestido que conviene a los elegidos de Dios, sus santos muy queridos: la compasión tierna, la bondad, la humildad, la mansedumbre, la paciencia."
,"13":"Sopórtense y perdónense unos a otros si uno tiene motivo de queja contra otro. Como el Señor los perdonó, a su vez hagan ustedes lo mismo."
,"14":"Por encima de esta vestidura pondrán como cinturón el amor, para que el conjunto sea perfecto."
,"15":"Así la paz de Cristo reinará en sus corazones, pues para esto fueron llamados y reunidos. Finalmente, sean agradecidos."
,"16":"Que la palabra de Cristo habite en ustedes y esté a sus anchas. Tengan sabiduría, para que se puedan aconsejar unos a otros y se afirmen mutuamente con salmos, himnos y alabanzas espontáneas. Que la gracia ponga en sus corazones un cántico a Dios,"
,"17":"y todo lo que puedan decir o hacer, háganlo en el nombre del Señor Jesús, dando gracias a Dios Padre por medio de él."
,"18":"Esposas, sométanse a sus maridos como conviene entre cristianos."
,"19":"Maridos, amen a sus esposas y no les amarguen la vida."
,"20":"Hijos, obedezcan a sus padres en todo, porque eso es lo correcto entre cristianos."
,"21":"Padres, no sean pesados con sus hijos, para que no se desanimen."
,"22":"Siervos, obedezcan en todo a sus amos de la tierra; no sólo en presencia del patrón o para ganar en consideración, sino con sinceridad, porque tienen presente al Señor."
,"23":"Cualquier trabajo que hagan, háganlo de buena gana, pensando que trabajan para el Señor y no para los hombres."
,"24":"Bien saben que el Señor los recompensará dándoles la herencia prometida. Su señor es Cristo y están a su servicio."
,"25":"El que no cumple recibirá lo que merece su maldad, pues Dios no hará excepciones a favor de nadie."
}`)
	CurrentBook.AddChapter(4, `{
"1":"En cuanto a ustedes, patrones, den a sus servidores lo que es justo y razonable, sabiendo que también ustedes tienen un Señor en el cielo."
,"2":"Sean constantes en la oración, quédense velando para dar gracias,"
,"3":"oren también por nosotros, para que Dios nos dé palabras y pueda yo anunciar el misterio de Cristo. Por ese misterio estoy,atado con cadenas; "
,"4":"pidan que pueda darlo a conocer cuando presente mi defensa."
,"5":"Pórtense con prudencia con los de afuera y aprovechen todas las oportunidades."
,"6":"Que su conversación sea agradable y no le falte su granito de sal. Sepan contestar a cada uno lo que corresponde."
,"7":"Tíquico, mi hermano querido, les dará noticias de todo lo referente a mí; es para mí un ayudante fiel y un compañero en el servicio del Señor."
,"8":"Se lo envío expresamente para que les lleve noticias mías y les dé ánimo."
,"9":"Envío con él a Onésimo, nuestro hermano fiel y muy querido, que es uno de ustedes. Ellos les dirán todo lo que aquí pasa."
,"10":"Los saluda Aristarco, mi compañero de cárcel, y Marcos, primo de Bernabé, acerca del cual ya recibieron instrucciones. Si va para allá, denle una buena acogida."
,"11":"Los saluda también Jesús, apodado Justo. Son los únicos de raza judía que están trabajando conmigo por el Reino de Dios y que han sido para mí un consuelo."
,"12":"Reciban saludos de su compatriota Epafras; es un buen servidor de Cristo Jesús que siempre está orando fervientemente por ustedes para que sean perfectos y produzcan todos los frutos que Dios desea."
,"13":"Les puedo asegurar que los ha echado mucho de menos, lo mismo que a los de Laodicea y de Hierápolis."
,"14":"Reciban los saludos de Lucas, nuestro querido médico, y de Demás."
,"15":"Saluden a los hermanos que están en Laodicea, sin olvidar a Ninfa y a la Iglesia que se reúne en su casa."
,"16":"Después de que sea leída esta carta entre ustedes, procuren que sea leída también en la Iglesia de Laodicea, y consigan, por su parte, la que ellos recibieron, para leerla ustedes."
,"17":"Digan a Arquipo: 'No descuides el servicio que te fue encargado en el Señor y trata de cumplirlo bien.'"
,"18":"El saludo es de mi propia mano: Pablo. Acuérdense de que estoy con cadenas. La gracia sea con ustedes."
}`)

}
func ES_LBL_LoadNPEPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Carta de Pablo, apóstol de Cristo Jesús por voluntad de Dios, a los santos que (en Efeso),están y perseveran en Cristo:"
,"2":"Reciban gracia y paz de Dios, nuestro Padre, y de Jesús, el Señor."
,"3":"¡Bendito sea Dios, Padre de Cristo Jesús nuestro Señor, que nos ha bendecido en el cielo, en Cristo, con toda clase de bendiciones espirituales!"
,"4":"En Cristo Dios nos eligió,antes de que creara el mundo, para estar en su presencia santos y sin mancha. En su amor "
,"5":"nos destinó de antemano,para ser hijos suyos en Jesucristo,y por medio de él. Así lo quiso y le pareció bien"
,"6":"sacar alabanzas de esta gracia tan grande,que nos hacía en el Bien Amado."
,"7":"En él y por su sangre fuimos rescatados, y se nos dio el perdón de los pecados, fruto de su generosidad inmensa"
,"8":"-"
,"9":"que se derramó sobre nosotros. Ahora nos ha dado a conocer, mediante dones de sabiduría e inteligencia, este proyecto misterioso suyo, fruto de su absoluta complacencia en Cristo."
,"10":"Pues Dios quiso reunir en él, cuando llegara la plenitud de los tiempos, tanto a los seres celestiales como a los terrenales."
,"11":"En Cristo fuimos elegidos nosotros: Aquel que dispone de todas las cosas,y las somete a su voluntad,decidió que fuéramos pueblo suyo"
,"12":"y lleváramos la espera del Mesías, con el fin de que sea alabada su Gloria."
,"13":"También ustedes, al escuchar la Palabra de la Verdad, el Evangelio que los salva, creyeron en él, quedando sellados con el Espíritu Santo prometido,"
,"14":"que es el anticipo de nuestra herencia. Por él va liberando al pueblo que hizo suyo, para que al fin sea alabada su Gloria."
,"15":"He sabido cómo ustedes viven en Cristo Jesús la fe y el amor para con todos los santos, quiero decir, para con los hermanos,"
,"16":"por lo que no dejo de dar gracias a Dios y de recordarlos en mis oraciones."
,"17":"Que el Dios de Cristo Jesús nuestro Señor, el Padre que está en la gloria, se les manifieste dándoles espíritu de sabiduría para que lo puedan conocer."
,"18":"Que les ilumine la mirada interior, para que entiendan lo que esperamos a raíz del llamado de Dios, qué herencia tan grande y gloriosa reserva Dios a sus santos,"
,"19":"y con qué fuerza tan extraordinaria actúa en favor de los que creemos. Es la misma fuerza todopoderosa "
,"20":"que actuó en Cristo cuando lo resucitó de entre los muertos y lo hizo sentar a su lado en el mundo de arriba."
,"21":"Pues está muy por encima de todo Poder, Autoridad, Dominio y de toda otra Fuerza o Gobierno, más arriba de todo lo que cuenta en este mundo y en el otro."
,"22":"Dios colocó todo bajo sus pies, y lo constituyó Cabeza de la Iglesia."
,"23":"Ella es su cuerpo y en ella despliega su plenitud el que lo llena todo en todos."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Ustedes estaban muertos a causa de sus faltas y sus pecados."
,"2":"Con ellos seguían la corriente de este mundo y al soberano que reina entre el cielo y la tierra, el espíritu que ahora está actuando en los corazones rebeldes."
,"3":"De ellos éramos también nosotros, y nos dejamos llevar por las codicias humanas, obedeciendo a los deseos de nuestra naturaleza y consintiendo sus proyectos, e íbamos directamente al castigo, lo mismo que los demás."
,"4":"Pero Dios es rico en misericordia: ¡con qué amor tan inmenso nos amó!"
,"5":"Estábamos muertos por nuestras faltas y nos hizo revivir con Cristo: ¡por pura gracia ustedes han sido salvados!"
,"6":"Nos resucitó en Cristo Jesús y con él, para sentarnos con él en el mundo de arriba."
,"7":"En Cristo Jesús Dios es todo generosidad para con nosotros, por lo que quiere manifestar en los siglos venideros la extraordinaria riqueza de su gracia."
,"8":"Ustedes han sido salvados por la fe, y lo han sido por gracia. Esto no vino de ustedes, sino que es un don de Dios;"
,"9":"tampoco lo merecieron por sus obras, de manera que nadie tiene por qué sentirse orgulloso."
,"10":"Lo que somos es obra de Dios: hemos sido creados en Cristo Jesús con miras a las buenas obras que Dios dispuso de antemano para que nos ocupáramos en ellas."
,"11":"Acuérdense de que fueron gente pagana; los que se llaman a sí mismos circuncisos, por una circuncisión quirúrgica, los llamaban a ustedes incircuncisos."
,"12":"En aquel tiempo no esperaban un Mesías, no tenían parte en el pueblo de Israel y no les correspondían las alianzas de Dios ni sus promesas; ustedes vivían en este mundo sin esperanza y sin Dios."
,"13":"Pero ahora, en Cristo Jesús y por su sangre, ustedes que estaban lejos han venido a estar cerca."
,"14":"El es nuestra paz. El ha destruido el muro de separación, el odio, y de los dos pueblos ha hecho uno solo. En su propia carne"
,"15":"destruyó el sistema represivo de la Ley e hizo la paz; reunió a los dos pueblos en él, creando de los dos un solo hombre nuevo."
,"16":"Destruyó el odio en la cruz y, habiendo reunido a los dos pueblos, los reconcilió con Dios por medio de la misma cruz."
,"17":"Vino como evangelizador de la paz: paz para ustedes que estaban lejos, y paz para los judíos que estaban cerca."
,"18":"Y por él los dos pueblos llegamos al Padre en un mismo Espíritu."
,"19":"Así, pues, ya no son extranjeros ni huéspedes, sino ciudadanos de la ciudad de los santos; ustedes son de la casa de Dios."
,"20":"Están cimentados en el edificio cuyas bases son los apóstoles y profetas, y cuya piedra angular es Cristo Jesús."
,"21":"En él se ajustan los diversos elementos, y la construcción se eleva hasta formar un templo santo en el Señor."
,"22":"En él ustedes se van edificando hasta ser un santuario espiritual de Dios."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Por eso yo, Pablo, el prisionero de Cristo por ustedes, los no-judíos..."
,"2":"A lo mejor han sabido de las gracias que Dios me concedió para bien de ustedes."
,"3":"Por una revelación se me dio a conocer su proyecto misterioso, tal como acabo de exponérselo en pocas palabras."
,"4":"Según esto pueden apreciar el conocimiento que tengo del misterio de Cristo."
,"5":"Este misterio no se dio a conocer a los hombres en tiempos pasados, pero ahora acaba de ser revelado mediante los dones espirituales de los santos apóstoles y profetas:"
,"6":"que en Cristo Jesús los pueblos paganos tienen derecho a la herencia, que ya no están aparte y que van a gozar de la promesa. Esta es la Buena Nueva "
,"7":"de la que he llegado a ser servidor sin mérito alguno mío, pues Dios me concedió esta gracia en el momento que su fuerza actuó en mí."
,"8":"A mí, el menor de todos los creyentes, se me concedió esta gracia de anunciar a los pueblos paganos la incalculable riqueza de Cristo"
,"9":"y de esclarecer en qué forma se va realizando el proyecto secreto escondido desde siempre en Dios, Creador del universo."
,"10":"En adelante los poderes y autoridades del mundo de arriba podrán descubrir, mirando a la Iglesia, los más diversos aspectos de la sabiduría de Dios,"
,"11":"conforme al plan que Dios trazó desde el principio en Cristo Jesús, nuestro Señor."
,"12":"En él ahora nos acercamos a Dios con plena confianza, con la fe que él nos ha dejado."
,"13":"Por eso, yo les ruego que no se desanimen al ver las pruebas que soporto por ustedes. Más bien han de sentirse orgullosos de ellas."
,"14":"Pensando en todo esto, doblo las rodillas en presencia del Padre,"
,"15":"al que se refiere toda patria en la tierra y toda familia celestial, pues 'patria' viene de 'padre'."
,"16":"Que él se digne, según la riqueza de su gloria, fortalecer en ustedes, por su Espíritu, al hombre interior."
,"17":"Que Cristo habite en sus corazones por la fe, que estén arraigados en el amor y en él puedan edificarse."
,"18":"Que sean capaces de comprender, con todos los creyentes, cuán ancho, y cuán largo, y alto y profundo es,"
,"19":"en una palabra, que conozcan este amor de Cristo que supera todo conocimiento. En fin, que queden colmados hasta recibir toda la plenitud de Dios."
,"20":"A Dios, cuya fuerza actúa en nosotros y que puede realizar mucho más de lo que pedimos o imaginamos,"
,"21":"a él la gloria en la Iglesia y en Cristo Jesús por todas las generaciones y todos los tiempos. Amén."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Yo, 'el prisionero de Cristo', les exhorto, pues, a que se muestren dignos de la vocación que han recibido."
,"2":"Sean humildes y amables, sean comprensivos y sopórtense unos a otros con amor."
,"3":"Mantengan entre ustedes lazos de paz y permanezcan unidos en el mismo espíritu."
,"4":"Un solo cuerpo y un mismo espíritu, pues ustedes han sido llamados a una misma vocación y una misma esperanza."
,"5":"Un solo Señor, una sola fe, un solo bautismo,"
,"6":"un solo Dios y Padre de todos, que está por encima de todos, que actúa por todos y está en todos."
,"7":"Cada uno de nosotros ha recibido su talento y Cristo es quien fijó la medida de sus dones para cada uno."
,"8":"Pues se dijo: Subió a las alturas, llevó cautivos, y dio sus dones a los hombres."
,"9":"Subió. Se refiere al que antes había bajado con los muertos al mundo inferior."
,"10":"El mismo que bajó, subió después por encima de todos los cielos para llenarlo todo."
,"11":"Y ¿dónde están sus dones? Unos son apóstoles, otros profetas, otros evangelistas, otros pastores y maestros."
,"12":"Así prepara a los suyos para las obras del ministerio en vista de la construcción del cuerpo de Cristo;"
,"13":"hasta que todos alcancemos la unidad en la fe y el conocimiento del Hijo de Dios y lleguemos a ser el Hombre perfecto, con esa madurez que no es menos que la plenitud de Cristo."
,"14":"Entonces no seremos ya niños a los que mueve cualquier oleaje o viento de doctrina o cualquier invento de personas astutas, expertas en el arte de engañar."
,"15":"Estaremos en la verdad y el amor, e iremos creciendo cada vez más para alcanzar a aquel que es la cabeza, Cristo."
,"16":"El hace que el cuerpo crezca, con una red de articulaciones que le dan armonía y firmeza, tomando en cuenta y valorizando las capacidades de cada uno. Y así el cuerpo se va construyendo en el amor."
,"17":"Les digo, pues, y con insistencia les advierto en el Señor que no imiten a los paganos, que se mueven por cosas inútiles."
,"18":"Su inteligencia está en tinieblas; la ignorancia en que se quedan, así como su conciencia ciega, los mantienen muy lejos de la vida de Dios."
,"19":"Después de perder el sentido moral se han dejado llevar por el libertinaje y buscan con avidez toda clase de inmoralidad."
,"20":"Pero ustedes no aprendieron así a Cristo,"
,"21":"si es que de veras fueron enseñados y formados según él, sabiendo que la verdad está en Jesús."
,"22":"Se les pidió despojarse del hombre viejo al que sus pasiones van destruyendo, pues así fue su conducta anterior,"
,"23":"y renovarse por el espíritu desde dentro."
,"24":"Revístanse, pues, del hombre nuevo, el hombre según Dios que él crea en la verdadera justicia y santidad."
,"25":"Por eso, no más mentiras; que todos digan la verdad a su prójimo, ya que todos somos parte del mismo cuerpo."
,"26":"Enójense, pero sin pecar; que el enojo no les dure hasta la puesta del sol,"
,"27":"pues de otra manera se daría lugar al demonio."
,"28":"El que robaba, que ya no robe, sino que se fatigue trabajando con sus manos en algo útil y así tendrá algo que compartir con los necesitados."
,"29":"No salga de sus bocas ni una palabra mala, sino la palabra que hacía falta y que deja algo a los oyentes."
,"30":"No entristezcan al Espíritu santo de Dios; éste es el sello con el que ustedes fueron marcados y por el que serán reconocidos en el día de la salvación."
,"31":"Arranquen de raíz de entre ustedes disgustos, arrebatos, enojos, gritos, ofensas y toda clase de maldad."
,"32":"Más bien sean buenos y comprensivos unos con otros, perdonándose mutuamente como Dios los perdonó en Cristo."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Como hijos amadísimos de Dios, esfuércense por imitarlo."
,"2":"Sigan el camino del amor, a ejemplo de Cristo, que nos amó y se entregó por nosotros, como esas ofrendas y víctimas cuyo olor agradable subía a Dios."
,"3":"Y ya que son santos, no se hable de inmoralidad sexual, de codicia o de cualquier cosa fea; ni siquiera se las nombre entre ustedes."
,"4":"Lo mismo se diga de las palabras vergonzosas, de los disparates y tonterías. Nada de todo eso les conviene, sino más bien dar gracias a Dios."
,"5":"Sépanlo bien: ni el corrompido, ni el impuro, ni el que se apega al dinero, que es servir a un dios falso, tendrán parte en el reino de Cristo y de Dios."
,"6":"Que nadie los engañe con razonamientos vacíos, pues son estas cosas las que Dios se prepara a condenar en los enemigos de la fe:"
,"7":"no sea que ustedes compartan su suerte."
,"8":"En otro tiempo ustedes eran tinieblas, pero ahora son luz en el Señor. Pórtense como hijos de la luz,"
,"9":"con bondad, con justicia y según la verdad, pues ésos son los frutos de la luz."
,"10":"Busquen lo que agrada al Señor."
,"11":"No tomen parte en las obras de las tinieblas, donde no hay nada que cosechar; al contrario, denúncienlas."
,"12":"Sólo decir lo que esa gente hace a escondidas da vergüenza;"
,"13":"pero al ser denunciado por la luz se vuelve claro, y lo que se ha aclarado llegará incluso a ser luz."
,"14":"Por eso se dice: 'Despierta, tú que duermes, levántate de entre los muertos,y la luz de Cristo brillará sobre ti.'"
,"15":"Examinen, pues, con mucho esmero su conducta. No anden como tontos, sino como hombres responsables."
,"16":"Aprovechen el momento presente, porque estos tiempos son malos."
,"17":"Por tanto, no se dejen estar, sino traten de comprender cuál es la voluntad del Señor."
,"18":"No se emborrachen, pues el vino lleva al libertinaje; más bien llénense del Espíritu."
,"19":"Intercambien salmos, himnos y cánticos espirituales. Que el Señor pueda oír el canto y la música de sus corazones."
,"20":"Den gracias a Dios Padre en nombre de Cristo Jesús, nuestro Señor, siempre y por todas las cosas."
,"21":"Expresen su respeto a Cristo siendo sumisos los unos a los otros."
,"22":"Lo sean así las esposas a sus maridos, como al Señor."
,"23":"El hombre es cabeza de la mujer, como Cristo es cabeza de la Iglesia, cuerpo suyo, del cual es asimismo salvador."
,"24":"Que la esposa, pues, se someta en todo a su marido, como la Iglesia se somete a Cristo."
,"25":"Maridos, amen a sus esposas como Cristo amó a la Iglesia y se entregó a sí mismo por ella."
,"26":"Y después de bañarla en el agua y la Palabra para purificarla, la hizo santa,"
,"27":"pues quería darse a sí mismo una Iglesia radiante, sin mancha ni arruga ni nada parecido, sino santa e inmaculada."
,"28":"Así deben también los maridos amar a sus esposas como aman a sus propios cuerpos: amar a la esposa es amarse a sí mismo."
,"29":"Y nadie aborrece su cuerpo; al contrario, lo alimenta y lo cuida. Y eso es justamente lo que Cristo hace por la Iglesia,"
,"30":"pues nosotros somos parte de su cuerpo."
,"31":"La Escritura dice: Por eso dejará el hombre a su padre y a su madre para unirse con su esposa y los dos formarán un solo ser."
,"32":"Es éste un misterio muy grande, pues lo refiero a Cristo y a la Iglesia."
,"33":"En cuanto a ustedes, cada uno ame a su esposa como a sí mismo, y la mujer, a su vez, respete a su marido."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Hijos, obedezcan a sus padres, pues esto es un deber: Honra a tu padre y a tu madre."
,"2":"Es, además, el primer mandamiento que va acompañado de una promesa:"
,"3":"para que seas feliz y goces de larga vida en la tierra."
,"4":"Y ustedes, padres, no sean pesados con sus hijos, sino más bien edúquenlos usando las correcciones y advertencias que pueda inspirar el Señor."
,"5":"Siervos, obedezcan a sus patrones de este mundo con respeto y responsabilidad, con corazón sincero, como quien obedece a Cristo."
,"6":"No se fijen en si son vigilados o si ganarán consideración, pues ustedes son siervos de Cristo que hacen con gusto la voluntad de Dios."
,"7":"Hagan su trabajo con empeño, por el Señor y no por los hombres,"
,"8":"sabiendo que el Señor retribuirá a cada uno según el bien que haya hecho, sea siervo o sea libre."
,"9":"Y ustedes, patrones, actúen con sus siervos de la misma manera y dejen a un lado las amenazas; tengan presente que ellos y ustedes tienen en el cielo un mismo Señor, y que ése no hace distinción de personas."
,"10":"Por lo demás, fortalézcanse en el Señor con su energía y su fuerza."
,"11":"Lleven con ustedes todas las armas de Dios para que puedan resistir las maniobras del diablo."
,"12":"Pues no nos estamos enfrentando a fuerzas humanas, sino a los poderes y autoridades que dirigen este mundo y sus fuerzas oscuras, los espíritus y fuerzas malas del mundo de arriba."
,"13":"Por eso pónganse la armadura de Dios, para que en el día malo puedan resistir y mantenerse en la fila valiéndose de todas sus armas."
,"14":"Tomen la verdad como cinturón y la justicia como coraza;"
,"15":"tengan buen calzado, estando listos para propagar el Evangelio de la paz."
,"16":"Tengan siempre en la mano el escudo de la fe, y así podrán atajar las flechas incendiarias del demonio."
,"17":"Por último, usen el casco de la salvación y la espada del Espíritu, o sea, la Palabra de Dios."
,"18":"Vivan orando y suplicando. Oren en todo tiempo según les inspire el Espíritu. Velen en común y perseveren en sus oraciones sin desanimarse nunca, intercediendo en favor de todos los santos, sus hermanos."
,"19":"Rueguen también por mí, para que, al hablar, se me den palabras y no me falte el coraje para dar a conocer el misterio del Evangelio"
,"20":"cuando tenga que presentar mi defensa, pues yo soy embajador encadenado de este Evangelio."
,"21":"Si quieren noticias de mí y de lo que hago, se las dará Tíquico, nuestro hermano querido y ministro fiel en el Señor."
,"22":"Lo mando precisamente para que les dé noticias nuestras y los conforte a todos."
,"23":"Que la paz, el amor y la fe vengan de Dios Padre y de Cristo Jesús, el Señor, sobre los hermanos."
,"24":"Y que la gracia esté con todos aquellos que aman a Cristo Jesús, nuestro Señor, con amor auténtico."
}`)

}
func ES_LBL_LoadNPGAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, apóstol, enviado no por los hombres ni por intervención de hombres, sino por Cristo Jesús y por Dios Padre que lo resucitó de entre los muertos."
,"2":"Yo y todos los hermanos que están conmigo saludamos a las Iglesias de Galacia."
,"3":"Reciban gracia y paz de Dios nuestro Padre y de Cristo Jesús nuestro Señor."
,"4":"El se entregó por nuestros pecados para arrancarnos de nuestra mala condición presente, cumpliendo así la voluntad de Dios nuestro Padre."
,"5":"Gloria a él por los siglos de los siglos. Amén."
,"6":"Me sorprende que ustedes abandonen tan pronto a Aquel que según la gracia de Cristo los llamó y se pasen a otro evangelio."
,"7":"Pero no hay otro; solamente hay personas que tratan de dar vuelta al Evangelio de Cristo y siembran confusión entre ustedes."
,"8":"Pero aunque nosotros mismos o un ángel del cielo viniese a evangelizarlos en forma diversa a como lo hemos hecho nosotros, yo les digo: ¡Fuera con él!"
,"9":"Se lo dijimos antes y de nuevo se lo repito: si alguno viene con un evangelio que no es el que ustedes recibieron, ¡fuera con él! ¡Anatema!"
,"10":"¿Con quién tratamos de conciliarnos?: ¿con los hombres o con Dios? ¿Acaso tenemos que agradar a los hombres? Si tratara de agradar a los hombres, ya no sería siervo de Cristo."
,"11":"Les recordaré, hermanos, que el Evangelio con el que los he evangelizado no es doctrina de hombres."
,"12":"No lo he recibido de un hombre, ni me fue enseñado, sino que lo recibí por una revelación de Cristo Jesús."
,"13":"Ustedes han oído hablar de mi actuación anterior, cuando pertenecía a la comunidad judía, y saben con qué furor perseguía a la Iglesia de Dios y trataba de arrasarla."
,"14":"Estaba más apegado a la religión judía que muchos compatriotas de mi edad y defendía con mayor fanatismo las tradiciones de mis padres."
,"15":"Pero un día, a Aquel que me había escogido desde el seno de mi madre, por pura bondad le agradó llamarme"
,"16":"y revelar en mí a su Hijo para que lo proclamara entre los pueblos paganos. En ese momento no pedí consejos humanos,"
,"17":"ni tampoco subí a Jerusalén para ver a los que eran apóstoles antes que yo, sino que fui a Arabia, y de allí regresé después a Damasco."
,"18":"Más tarde, pasados tres años, subí a Jerusalén para entrevistarme con Pedro y permanecí con él quince días."
,"19":"Pero no vi a ningún otro apóstol fuera de Santiago, hermano del Señor."
,"20":"Todo esto lo digo ante Dios; él sabe que no miento."
,"21":"Luego me fui a las regiones de Siria y Cilicia,"
,"22":"de manera que las Iglesias de Cristo en Judea no me conocían personalmente."
,"23":"Tan sólo habían oído decir de mí: 'El que en otro tiempo nos perseguía, ahora anuncia la fe que trataba de destruir.'"
,"24":"Y glorificaban a Dios por mí."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Después de catorce años subí de nuevo a Jerusalén con Bernabé, llevando a Tito con nosotros."
,"2":"Siguiendo una revelación, fui para exponerles el evangelio que anuncio a los paganos. Me entrevisté con los dirigentes en una reunión privada, no sea que estuviese haciendo o hubiera hecho un trabajo que no sirve."
,"3":"Pero ni siquiera obligaron a circuncidarse a Tito, que es griego, y estaba conmigo;"
,"4":"y esto a pesar de que había intrusos, pues unos falsos hermanos se habían introducido para vigilar la libertad que tenemos en Cristo Jesús y querían hacernos esclavos (de la Ley)."
,"5":"Pero nos negamos a ceder, aunque sólo fuera por un momento, a fin de que el Evangelio se mantenga entre ustedes en toda su verdad."
,"6":"En cuanto a los dirigentes de más consideración (lo que hayan sido antes no me importa, pues Dios no se fija en la condición de las personas), no me pidieron que hiciera marcha atrás."
,"7":"Por el contrario, reconocieron que a mí me había sido encomendada la evangelización de los pueblos paganos, lo mismo que a Pedro le había sido encargada la evangelización de los judíos."
,"8":"Pues de la misma manera que Dios hizo de Pedro el apóstol de los judíos, hizo también de mí el apóstol de los paganos."
,"9":"Santiago, Cefas y Juan reconocieron la gracia que Dios me ha concedido. Estos hombres, que son considerados pilares de la Iglesia, nos estrecharon la mano a mí y a Bernabé en señal de comunión: nosotros nos dirigiríamos a los paganos y ellos a los judíos."
,"10":"Sólo debíamos acordarnos de los hermanos pobres de Jerusalén, lo cual he tenido cuidado en cumplir."
,"11":"Tiempo después, cuando Cefas vino a Antioquía, le enfrenté en circunstancias en que su conducta era reprensible."
,"12":"En efecto, antes de que vinieran algunos allegados de Santiago, comía con los hermanos de origen no judío; pero después de que llegaron éstos empezó a alejarse, y ya no se juntaba con ellos por temor al grupo judío."
,"13":"Los demás de raza judía lo siguieron en este doble juego, y hasta Bernabé se dejó arrastrar en esta falsedad."
,"14":"Cuando advertí que no andaban derecho según la verdad del Evangelio, le dije a Cefas delante de todos: 'Si tú, que has nacido judío, te has pasado del modo de vivir de los judíos al de los otros pueblos, ¿por qué ahora impones a esos pueblos el modo de vivir de los judíos?"
,"15":"Nosotros somos judíos de nacimiento; no pertenecemos a esos pueblos pecadores."
,"16":"Sin embargo hemos reconocido que las personas no son justas como Dios las quiere por haber observado la Ley, sino por la fe en Cristo Jesús. Por eso hemos creído en Cristo Jesús, para ser hechos justos a partir de la fe en Cristo Jesús, y no por las prácticas de la Ley. Porque el cumplimiento de la Ley no hará nunca de ningún mortal una persona justa según Dios."
,"17":"Escogimos esta rectitud verdadera, propia de Cristo, y ¿estaríamos ahora en pecado? Entonces Cristo tendría parte en el pecado. ¡Esto no puede ser!"
,"18":"Pero miren: si echamos abajo algo y luego lo restablecemos, reconocemos que hemos actuado mal."
,"19":"En cuanto a mí, la misma Ley me llevó a morir a la Ley a fin de vivir para Dios. He sido crucificado con Cristo, "
,"20":"y ahora no vivo yo, es Cristo quien vive en mí. Todo lo que vivo en lo humano lo vivo con la fe en el Hijo de Dios, que me amó y se entregó por mí."
,"21":"Esta es para mí la manera de no despreciar el don de Dios; pues si la verdadera rectitud es fruto de la Ley, quiere decir que Cristo murió inútilmente."
}`)
	CurrentBook.AddChapter(3, `{
"1":"¡Qué tontos son ustedes, gálatas! ¿Cómo se han dejado hipnotizar ustedes, a quienes se les presentó a Cristo Jesús crucificado como si lo vieran?"
,"2":"Les preguntaré sólo esto: ¿recibieron el Espíritu por haber practicado la Ley o por haber aceptado la fe?"
,"3":"¡Qué tontos son! ¡Empezar con el espíritu para terminar con la carne!"
,"4":"¡Haber probado inútilmente favores tan grandes! Pues en ese caso no les habrían servido de nada."
,"5":"Cuando Dios reparte los dones del Espíritu y obra milagros entre ustedes, ¿qué tiene que ver con la Ley? ¿No será más bien porque han acogido la fe?"
,"6":"Acuérdense de Abrahán: Creyó a Dios, que se lo tomó en cuenta y lo consideró un justo."
,"7":"Entiendan, pues, que quienes toman el camino de la fe son hijos de Abrahán."
,"8":"La Escritura anticipó que Dios daría a los paganos la verdadera rectitud por el camino de la fe. Por eso Abrahán recibió esta promesa: La bendición pasará de ti a todas las naciones."
,"9":"Así los que entran por la fe reciben la bendición junto con el creyente Abrahán."
,"10":"Por el contrario, pesa una maldición sobre todos los que se van a las observancias, pues está escrito: Maldito el que no cumple siempre todo lo que está escrito en la Ley."
,"11":"Con la Ley nadie llega a ser justo a los ojos de Dios; la cosa es cierta, pues el justo vivirá por la fe,"
,"12":"y la Ley no da lugar a la fe cuando dice: El que cumple estas cosas tendrá vida por medio de ellas."
,"13":"Pero Cristo nos ha rescatado de la maldición de la Ley, al hacerse maldición por nosotros, como dice la Escritura: Maldito todo el que está colgado de un madero."
,"14":"De este modo la bendición de Abrahán alcanzó a las naciones paganas en Cristo Jesús: por la fe recibimos la promesa, que es el Espíritu."
,"15":"Hermanos, tomemos una comparación. Cuando alguien ha hecho su testamento en debida forma, nadie puede anularlo ni agregarle nada."
,"16":"En el caso de Abrahán, las promesas eran para él y para su descendencia. La Escritura no dice para los descendientes, como si hubiera varios, sino que habla en singular: para tu descendencia, y ésta es Cristo."
,"17":"Ahora digo lo siguiente: si Dios ha hecho un testamento en debida forma, la Ley, que vino cuatrocientos treinta años después, no pudo anularlo ni dejar sin efecto la promesa de Dios."
,"18":"Si la herencia es el fruto de la Ley, ya no es fruto de la promesa, y precisamente la herencia era promesa y don de Dios a Abrahán."
,"19":"Entonces, ¿para qué la Ley? Fue añadida con miras a las desobediencias; pero solamente valía hasta que llegara ese descendiente de Abrahán para quien era la promesa, y fueron ángeles los que la concertaron, haciendo de mediador Moisés"
,"20":"(no se hablaría de un mediador si hubiera una sola parte, y Dios es uno solo)."
,"21":"¿Acaso la Ley contradice las promesas de Dios? En absoluto. Si se hubiera dado una ley capaz de darnos vida, nuestro paso a la verdadera justicia podría resultar de esa Ley."
,"22":"Pero no; la Escritura lo encerró todo en los marcos del pecado, de tal manera que lo prometido llega a los creyentes por medio de la fe en Cristo Jesús."
,"23":"Hasta que no llegaran los tiempos de la fe, la Ley nos guardaba bajo llave, a la espera de la fe que se iba a revelar."
,"24":"La Ley nos conducía al maestro, a Cristo, para que creyéramos y así fuéramos justos."
,"25":"Pero al llegar la fe, ya no obedecemos a la que nos llevaba al maestro."
,"26":"Ustedes están en Cristo Jesús, y todos son hijos de Dios gracias a la fe."
,"27":"Todos se han revestido de Cristo, pues todos fueron entregados a Cristo por el bautismo."
,"28":"Ya no hay diferencia entre judío y griego, entre esclavo y hombre libre; no se hace diferencia entre hombre y mujer, pues todos ustedes son uno solo en Cristo Jesús."
,"29":"Y si ustedes son de Cristo, también son descendencia de Abrahán y herederos de la promesa."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ahora yo digo: mientras el hijo del dueño de casa es aún niño, no tiene ninguna ventaja sobre los esclavos, a pesar de que es dueño de todos ellos."
,"2":"Está sometido a quienes lo cuidan o se encargan de sus asuntos hasta la fecha fijada por su padre."
,"3":"De igual modo, también nosotros pasamos por una etapa de niñez y estuvimos sometidos a las normas y principios que rigen el mundo."
,"4":"Pero, cuando llegó la plenitud de los tiempos, Dios envió a su Hijo, que nació de mujer y fue sometido a la Ley,"
,"5":"con el fin de rescatar a los que estaban bajo la Ley, para que así recibiéramos nuestros derechos como hijos."
,"6":"Ustedes ahora son hijos, por lo cual Dios ha mandado a nuestros corazones el Espíritu de su propio Hijo que clama al Padre: ¡Abbá!, o sea: ¡Papá!"
,"7":"De modo que ya no eres esclavo, sino hijo, y siendo hijo, Dios te da la herencia."
,"8":"En otros tiempos no conocían a Dios y sirvieron a los que no son dioses;"
,"9":"pero si ahora conocen a Dios o, más bien, Dios los ha conocido a ustedes, ¿cómo pueden volver a normas y principios miserables y sin fuerza? ¿Quieren ser de nuevo sus esclavos?"
,"10":"Y van a observar ciertos días, y las lunas nuevas, y tal tiempo, y ese año..."
,"11":"Me temo que todas mis penas hayan sido inútiles."
,"12":"Les ruego, hermanos, que me imiten a mí como yo me hice semejante a ustedes. Siempre me han tratado bien."
,"13":"Recuerden que en los comienzos, cuando les anuncié el Evangelio, yo estaba enfermo."
,"14":"Aunque mis pruebas eran una prueba para ustedes, no me despreciaron ni me rechazaron, sino que me acogieron como a un ángel de Dios, como a Cristo Jesús."
,"15":"¿Por qué se perdió la alegría de aquel tiempo? No miento, pero se habrían sacado los ojos para dármelos."
,"16":"¿Y me he vuelto un enemigo ahora porque les digo la verdad?"
,"17":"Esa gente les demuestra mucho interés, pero no es para bien; quieren apartarlos de mí y que se interesen por ellos."
,"18":"¡Ojalá ustedes fueran siempre objeto de gran atención, y no solamente de la mía cuando estoy con ustedes!"
,"19":"Hijitos míos, de nuevo sufro por ustedes dolores de alumbramiento, hasta que Cristo haya tomado forma en ustedes."
,"20":"Cuánto desearía estar ahora con ustedes y hablarles de viva voz, porque ya no sé qué hacer por ustedes."
,"21":"Ustedes, que quieren obedecer a la Ley, díganme: ¿acaso la entienden?"
,"22":"Está escrito que Abrahán tuvo dos hijos: uno de la esclava y el otro de la mujer libre, su esposa."
,"23":"El hijo de la esclava le nació como cualquier ser humano, mientras que el hijo de la libre se lo debía a una promesa de Dios."
,"24":"Aquí hay una figura, y reconocemos dos alianzas. La primera, la del monte Sinaí, es Agar, que da a luz a esclavos."
,"25":"Agar era de Arabia, donde está el monte Sinaí, y representa a la Jerusalén actual, que es esclava, lo mismo que sus hijos."
,"26":"En cambio, la Jerusalén de arriba es libre y es nuestra madre."
,"27":"La Escritura dice: Alégrate, mujer estéril y sin hijos; estalla en gritos de alegría, tú que no has conocido los dolores de parto, pues muchos serán los hijos de la madre abandonada, más que los de la que tenía marido."
,"28":"Hermanos, ustedes, como Isaac, son hijos de la promesa."
,"29":"Pero así como entonces el hijo según la carne perseguía a Isaac, hijo según el espíritu, lo mismo pasa ahora."
,"30":"Y ¿qué dice la Escritura? Echa a la esclava y a su hijo, porque el hijo de la esclava no puede compartir la herencia junto al hijo de la mujer libre."
,"31":"Hermanos, nosotros somos hijos de la mujer libre y no de la esclava."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Cristo nos liberó para ser libres. Manténganse, pues, firmes y no se sometan de nuevo al yugo de la esclavitud."
,"2":"Yo, Pablo, se lo digo: si ustedes se hacen circuncidar, Cristo ya no les servirá de nada."
,"3":"De nuevo declaro a todo el que se haga circuncidar: ahora estás obligado a practicar toda la Ley."
,"4":"Ustedes, que se ganan méritos con las observancias de la Ley, se han desligado de Cristo y se han apartado de la gracia."
,"5":"A nosotros, en cambio, el Espíritu nos da la convicción de que por la fe seremos tales como Dios nos quiere."
,"6":"Para los que están en Cristo Jesús ya no son ventajas el tener o no tener la circuncisión; solamente vale la fe que actúa mediante el amor."
,"7":"Ustedes caminaban bien; ¿quién les dio la señal de detenerse, para que ahora no sigan la verdad?"
,"8":"Porque ésa no era la voz de Aquel que los llamó."
,"9":"Aunque la levadura sea poca, hace fermentar toda la masa."
,"10":"Tengo la convicción en el Señor de que piensan como yo, pero el que los perturba, sea quien fuere, debe ser juzgado."
,"11":"Por mi parte, hermanos, si mantuviera la circuncisión: ¿creen que seguiría siendo perseguido? Pero con eso habría removido el escándalo de la cruz."
,"12":"¿Y por qué no llegan hasta mutilarse esos que los perturban?"
,"13":"Nuestra vocación, hermanos, es la libertad. No hablo de esa libertad que encubre los deseos de la carne, sino del amor por el que nos hacemos esclavos unos de otros."
,"14":"Pues la Ley entera se resume en una frase: Amarás al prójimo como a ti mismo."
,"15":"Pero si se muerden y se devoran unos a otros, ¡cuidado!, que llegarán a perderse todos."
,"16":"Por eso les digo: caminen según el espíritu y así no realizarán los deseos de la carne."
,"17":"Pues los deseos de la carne se oponen al espíritu y los deseos del espíritu se oponen a la carne. Los dos se contraponen, de suerte que ustedes no pueden obrar como quisieran."
,"18":"Pero dejarse guiar por el Espíritu no significa someterse a la Ley."
,"19":"Es fácil reconocer lo que proviene de la carne: libertad sexual, impurezas y desvergüenzas;"
,"20":"culto de los ídolos y magia; odios, ira y violencias; celos, furores, ambiciones, divisiones, sectarismo"
,"21":"y envidias; borracheras, orgías y cosas semejantes. Les he dicho, y se lo repito: los que hacen tales cosas no heredarán el Reino de Dios."
,"22":"En cambio, el fruto del Espíritu es caridad, alegría, paz, comprensión de los demás, generosidad, bondad, fidelidad,"
,"23":"mansedumbre y dominio de sí mismo. Estas son cosas que no condena ninguna Ley."
,"24":"Los que pertenecen a Cristo Jesús han crucificado la carne con sus impulsos y deseos."
,"25":"Si ahora vivimos según el espíritu, dejémonos guiar por el Espíritu;"
,"26":"depongamos toda vanagloria, dejemos de querer ser más que los demás y de ser celosos."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Hermanos, si alguien cae en alguna falta, ustedes, los espirituales, corríjanlo con espíritu de bondad. Piensa en ti mismo, porque tú también puedes ser tentado."
,"2":"Lleven las cargas unos de otros, y así cumplirán la ley de Cristo."
,"3":"Si alguno se cree algo, cuando no es nada, se engaña a sí mismo."
,"4":"Que cada uno examine sus propias obras y, si siente algún orgullo por ellas, que lo guarde para sí y no lo haga pesar sobre los demás."
,"5":"Para esto sí, que cada uno cargue con lo suyo."
,"6":"El que se hace instruir, debe retribuir al que lo instruye con cualquier cosa que tenga."
,"7":"No se engañen, nadie se burla de Dios: al final cada uno cosechará lo que ha sembrado. El que siembra en la carne, y en la propia, cosechará de la carne corrupción y muerte."
,"8":"El que siembra en el espíritu, cosechará del espíritu la vida eterna."
,"9":"Así, pues, hagamos el bien sin desanimarnos, que a su debido tiempo cosecharemos si somos constantes."
,"10":"Por consiguiente, mientras tengamos oportunidad, hagamos el bien a todos, y especialmente a los de casa, que son nuestros hermanos en la fe."
,"11":"Miren qué letras tan grandes estoy trazando: ésta es mi letra."
,"12":"Los que tratan de imponerles la circuncisión son sobre todo gente preocupada por ser más considerados en el mundo; no quieren que la cruz de Cristo les acarree problemas."
,"13":"Por estar circuncidados no es que observen la Ley; tan sólo les interesa la marca en el cuerpo, y se sentirían orgullosos de que ustedes la tuvieran."
,"14":"En cuanto a mí, no quiero sentirme orgulloso más que de la cruz de Cristo Jesús, nuestro Señor. Por él el mundo ha sido crucificado para mí y yo para el mundo."
,"15":"No hagamos ya distinción entre pueblo de la circuncisión y mundo pagano, porque una nueva creación ha empezado."
,"16":"Que la paz y la misericordia acompañen a los que viven según esta regla, que son el Israel de Dios."
,"17":"Por lo demás, que nadie venga a molestarme, pues me basta con llevar en mi cuerpo las señales de Jesús."
,"18":"Hermanos, que la gracia de Cristo Jesús, nuestro Señor, esté con su espíritu. Amén."
}`)

}
func ES_LBL_LoadNPPMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Carta de Pablo, preso de Cristo Jesús, y Timoteo nuestro hermano, a Filemón, nuestro querido compañero de trabajo,"
,"2":"a nuestra hermana Apia, a Arquipo, fiel compañero en nuestras luchas, y a toda la comunidad que se reúne en su casa:"
,"3":"Tengan gracia y paz de Dios nuestro Padre y de Cristo Jesús el Señor."
,"4":"Doy gracias sin cesar a mi Dios al recordarte en mis oraciones,"
,"5":"pues oigo alabar el amor y la fe que te animan tanto hacia el Señor como en beneficio de los santos."
,"6":"Ojalá esa fe se vea en las obras y manifieste todo lo bueno que tenemos en Cristo."
,"7":"Pues tuve mucho gozo y consuelo al tener noticias de tu caridad, ya que nuestros hermanos se sienten confortados por ti."
,"8":"Por eso, aunque tengo en Cristo plena libertad para ordenarte lo que tendrías que hacer,"
,"9":"prefiero pedírtelo por amor. El rogante es Pablo, ya anciano, y ahora preso por Cristo Jesús,"
,"10":"y la petición es para mi hijo Onésimo, a quien transmití la vida mientras estaba preso."
,"11":"Este Onésimo por un tiempo no te fue útil, pero ahora te va a ser muy útil, como lo ha sido para mí."
,"12":"Te lo devuelvo; recibe en su persona mi propio corazón."
,"13":"Hubiera deseado retenerlo a mi lado para que me sirviera en tu lugar mientras estoy preso por el Evangelio."
,"14":"Pero no quise hacer nada sin tu acuerdo, ni imponerte una obra buena, sino dejar que la hagas libremente."
,"15":"A lo mejor Onésimo te fue quitado por un momento para que lo ganes para la eternidad."
,"16":"Ya no será esclavo, sino algo mucho mejor, pues ha pasado a ser para mí un hermano muy querido, y lo será mucho más todavía para ti."
,"17":"Por eso, en vista de la comunión que existe entre tú y yo, recíbelo como si fuera yo."
,"18":"Y si te ha perjudicado o te debe algo, cárgalo en mi cuenta."
,"19":"Yo, Pablo, lo escribo y firmo de mi propia mano; yo te lo pagaré... sin hablar de la deuda que tienes conmigo, y que eres tú mismo."
,"20":"Vamos, hermano, espero de ti este servicio en el Señor; reconfórtame en Cristo."
,"21":"Te escribo con plena confianza en tu docilidad; sé que harás mucho más de lo que te pido."
,"22":"Además, prepárame alojamiento, pues, gracias a la oración de todos ustedes, espero serles devuelto."
,"23":"Te saluda Epafras, mi compañero de cautividad en Cristo Jesús,"
,"24":"y también Marcos, Aristarco, Demás y Lucas, mis ayudantes."
,"25":"Que la gracia de Cristo Jesús, el Señor, esté con ustedes. Amén."
}`)

}
func ES_LBL_LoadNPPPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Carta de Pablo y Timoteo, siervos de Cristo Jesús, a los filipenses, a todos ustedes, con sus obispos y sus diáconos, que en Cristo Jesús son santos."
,"2":"Reciban gracia y paz de Dios nuestro Padre y de Cristo Jesús, el Señor."
,"3":"Doy gracias a mi Dios cada vez que me acuerdo de ustedes,"
,"4":"es decir, en mis oraciones por todos ustedes a cada instante. Y lo hago con alegría,"
,"5":"recordando la cooperación que me han prestado en el servicio del Evangelio desde el primer día hasta ahora."
,"6":"Y si Dios empezó tan buen trabajo en ustedes, estoy seguro de que lo continuará hasta concluirlo el día de Cristo Jesús."
,"7":"No puedo pensar de otra manera, pues los llevo a todos en mi corazón; ya esté en la cárcel o tenga que defender y promover el Evangelio, todos están conmigo y participan de la misma gracia."
,"8":"Bien sabe Dios que la ternura de Cristo Jesús no me permite olvidarlos."
,"9":"Pido que el amor crezca en ustedes junto con el conocimiento y la lucidez."
,"10":"Quisiera que saquen provecho de cada cosa y cada circunstancia para que lleguen puros e irreprochables al día de Cristo,"
,"11":"habiendo hecho madurar, gracias a Cristo Jesús, el fruto de la santidad. Esto será para gloria de Dios y un honor para mí."
,"12":"Hermanos, quiero que sepan que, con todo lo que me sucede, el Evangelio más bien ha progresado."
,"13":"Entre la gente del palacio, y también fuera, mis cadenas han hecho circular el nombre de Cristo."
,"14":"Mi condición de preso ha animado a la mayoría de nuestros hermanos en el Señor, los cuales ahora se atreven a proclamar la Palabra más abiertamente y sin miedo."
,"15":"Algunos, es cierto, lo hacen por envidia y quieren hacerme competencia, pero otros predican a Cristo con buena intención."
,"16":"Estos últimos se dan cuenta de que estoy aquí para defender el Evangelio, y los inspira el amor."
,"17":"A los primeros, en cambio, les falta sinceridad; anuncian a Cristo por llevarme la contraria, y creen que con eso me hacen más amarga la cárcel."
,"18":"Pero, al fin, ¿qué importa? Sea con sinceridad o por hipocresía, de todas formas se anuncia a Cristo y eso me alegra. Yo tengo de qué alegrarme, "
,"19":"pues sé que todo esto se convertirá en bien para mí gracias a sus oraciones y a la asistencia que me presta el Espíritu de Cristo Jesús."
,"20":"Tengo esperanza y estoy seguro de que no seré defraudado. Al contrario, no me cabe duda de que esta vez, como las anteriores, Cristo aparecerá más grande a través de mí, sea que viva o que muera."
,"21":"Cristo es mi vida, y de la misma muerte saco provecho."
,"22":"Pero veo que, mientras estoy en este cuerpo, mi trabajo da frutos, de modo que ya no sé qué escoger."
,"23":"Estoy apretado por los dos lados: por una parte siento gran deseo de largarme y estar con Cristo, lo que sería sin duda mucho mejor."
,"24":"Pero, pensando en ustedes, conviene que yo permanezca en esta vida."
,"25":"Esto me convence; veo que me quedaré y permaneceré con todos ustedes; su fe progresará con esto y será más alegre."
,"26":"A causa de mí y con mi presencia ustedes se sentirán todavía más contentos de Cristo Jesús."
,"27":"Solamente procuren que su vida esté a la altura del Evangelio de Cristo. Permanezcan firmes en un mismo espíritu y luchen con un solo corazón por la fe del Evangelio. Ojalá lo pueda comprobar si voy donde ustedes y, si no voy, pueda al menos oírlo."
,"28":"No se dejen intimidar por los adversarios. Este será un signo seguro de que ellos van a la ruina y ustedes a la salvación. Todo eso viene de Dios,"
,"29":"y es una gracia para ustedes que no solamente hayan creído en Cristo, sino también que padezcan por él"
,"30":"en el mismo tipo de lucha que soporto yo, como lo han podido ver y ahora lo escuchan de mí."
}`)
	CurrentBook.AddChapter(2, `{
"1":"¿Puedo pedirles algo en nombre de Cristo, hablarles del amor? ¿Han recibido el Espíritu y son capaces de compasión y ternura?"
,"2":"Entonces denme esta alegría: pónganse de acuerdo, estén unidos en el amor, con una misma alma y un mismo proyecto."
,"3":"No hagan nada por rivalidad o vanagloria. Que cada uno tenga la humildad de creer que los otros son mejores que él mismo."
,"4":"No busque nadie sus propios intereses, sino más bien preocúpese cada uno por los demás."
,"5":"Tengan unos con otros las mismas disposiciones que estuvieron en Cristo Jesús:"
,"6":"El, siendo de condición divina, no se apegó a su igualdad con Dios, sino que se redujo a nada,"
,"7":"tomando la condición de servidor, y se hizo semejante a los hombres. Y encontrándose en la condición humana,"
,"8":"se rebajó a sí mismo,haciéndose obediente hasta la muerte, y muerte en una cruz."
,"9":"Por eso Dios lo engrandeció,y le dio el Nombre,que está sobre todo nombre,"
,"10":"para que al Nombre de Jesús,se doble toda rodilla en los cielos, en la tierra y entre los muertos,"
,"11":"y toda lengua proclame,que Cristo Jesús es el Señor, para gloria de Dios Padre."
,"12":"Por tanto, amadísimos míos, que siempre me han escuchado, sigan procurando su salvación con temor y temblor; y si lo hicieron cuando me tenían presente, háganlo más todavía cuando estoy lejos."
,"13":"Pues Dios es el que produce en ustedes tanto el querer como el actuar para agradarle."
,"14":"Cumplan todo sin quejas ni discusiones;"
,"15":"así no tendrán falla ni defecto y serán hijos de Dios sin reproche en medio de una raza descarriada y pervertida. Ustedes son luz en medio de ellos, como las estrellas en el universo,"
,"16":"al presentarles la palabra de vida. De ese modo me sentiré orgulloso de ustedes en el día de Cristo, porque mis esfuerzos y mis afanes no habrán sido inútiles. "
,"17":"Y aunque deba dar mi vida por su fe, que vale más que cualquier celebración y sacrificio, me siento feliz y me alegro con todos ustedes."
,"18":"Y también ustedes han de sentirse felices y alegrarse conmigo."
,"19":"El Señor Jesús me da la esperanza de que pronto les podré enviar a Timoteo, y será para mí un consuelo que pueda tener por su intermedio noticias de ustedes."
,"20":"De hecho, no tengo a ningún otro que se preocupe tanto como él por sus problemas."
,"21":"Todos buscan sus propios intereses, no los de Cristo Jesús."
,"22":"Pero Timoteo, como saben, ha dado pruebas, y como un hijo al lado de su padre, ha estado conmigo al servicio del Evangelio."
,"23":"Por eso pienso enviárselo apenas vea claros mis problemas."
,"24":"Por lo demás, tengo confianza en el Señor que pronto podré ir personalmente."
,"25":"Me pareció necesario devolverles a nuestro hermano Epafrodito, que trabajó y luchó a mi lado, y al que ustedes enviaron para que atendiera mis necesidades."
,"26":"En realidad, él los echaba mucho de menos y estaba preocupado al saber que ustedes estaban al tanto de su enfermedad."
,"27":"Es cierto que estuvo enfermo y a las puertas de la muerte, pero Dios tuvo piedad de él y también de mí, ahorrándome penas sobre penas."
,"28":"Por eso me apresuro en mandárselo, para que tengan la alegría de verlo y yo mismo quede más tranquilo."
,"29":"Celebren, pues, alegremente su llegada, como conviene en el Señor, y estimen mucho a personas como él,"
,"30":"que casi murió por la obra de Cristo. Pues no escatimó sacrificios para servirme personalmente en nombre de todos ustedes, que no los tenía a mi lado."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Por lo demás, hermanos míos, alégrense en el Señor. A mí no me cansa escribirles otra vez las mismas cosas, y para ustedes es más seguro. "
,"2":"¡Cuídense de los perros, cuídense de los obreros malos, cuídense de los que se hacen incisiones!"
,"3":"Nosotros somos los verdaderos circuncidados, pues servimos a Dios en espíritu y confiamos no en cosas humanas, sino en Cristo Jesús."
,"4":"Porque, hablando de méritos humanos, yo también tendría con qué sentirme seguro. Si alguno cree que puede confiar en tales cosas, ¡cuánto más lo puedo yo!"
,"5":"Nací de la raza de Israel, de la tribu de Benjamín, hebreo e hijo de hebreos, y fui circuncidado a los ocho días. ¿Observaba yo la Ley? Por supuesto, pues era fariseo, "
,"6":"y convencido, como lo demostré persiguiendo a la Iglesia; y en cuanto a ser justo según la Ley, fui un hombre irreprochable."
,"7":"Pero al tener a Cristo consideré todas mis ventajas como cosas negativas."
,"8":"Más aún, todo lo considero al presente como peso muerto en comparación con eso tan extraordinario que es conocer a Cristo Jesús, mi Señor. A causa de él ya nada tiene valor para mí y todo lo considero como pelusas mientras trato de ganar a Cristo."
,"9":"Y quiero encontrarme en él, no teniendo ya esa rectitud que pretende la Ley, sino aquella que es fruto de la fe de Cristo, quiero decir, la reordenación que Dios realiza a raíz de la fe."
,"10":"Quiero conocerlo, quiero probar el poder de su resurrección y tener parte en sus sufrimientos; y siendo semejante a él en su muerte,"
,"11":"alcanzaré, Dios lo quiera, la resurrección de los muertos."
,"12":"No creo haber conseguido ya la meta ni me considero un 'perfecto', sino que prosigo mi carrera hasta conquistarlo, puesto que ya he sido conquistado por Cristo."
,"13":"No, hermanos, yo no me creo todavía calificado, pero para mí ahora sólo vale lo que está adelante; y olvidando lo que dejé atrás,"
,"14":"corro hacia la meta, con los ojos puestos en el premio de la vocación celestial, quiero decir, de la llamada de Dios en Cristo Jesús."
,"15":"Todos nosotros, si somos de los 'perfectos', tenemos que pensar así; y si no ven todavía las cosas en esta forma, Dios los iluminará."
,"16":"Mientras tanto, sepamos conservar lo que hemos conquistado."
,"17":"Sean imitadores míos, hermanos, y fíjense en los que siguen nuestro ejemplo."
,"18":"Porque muchos viven como enemigos de la cruz de Cristo; se lo he dicho a menudo y ahora se lo repito llorando."
,"19":"La perdición los espera; su Dios es el vientre, y se sienten muy orgullosos de cosas que deberían avergonzarlos. No piensan más que en las cosas de la tierra."
,"20":"Nosotros tenemos nuestra patria en el cielo, y de allí esperamos al Salvador que tanto anhelamos, Cristo Jesús, el Señor."
,"21":"Pues él cambiará nuestro cuerpo miserable usando esa fuerza con la que puede someter a sí el universo, y lo hará semejante a su propio cuerpo, del que irradia su gloria."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Por eso, hermanos míos, a quienes tanto quiero y echo de menos, que son mi alegría y mi corona, sigan así firmes en el Señor, amadísimos."
,"2":"Ruego a Evodia y también a Síntique que trabajen juntas en el Señor."
,"3":"Y a ti, Sícigo, verdadero compañero, te pido que las ayudes; no olvides que ellas lucharon conmigo por el Evangelio, lo mismo que Clemente y los demás colaboradores míos, cuyos nombres están escritos en el libro de la vida."
,"4":"Estén siempre alegres en el Señor;"
,"5":"se lo repito, estén alegres y den a todos muestras de un espíritu muy abierto. El Señor está cerca. No se inquieten por nada; "
,"6":"antes bien, en toda ocasión presenten sus peticiones a Dios y junten la acción de gracias a la súplica."
,"7":"Y la paz de Dios, que es mayor de lo que se puede imaginar, les guardará sus corazones y sus pensamientos en Cristo Jesús."
,"8":"Por lo demás, hermanos, fíjense en todo lo que encuentren de verdadero, noble, justo y limpio; en todo lo que es fraternal y hermoso, en todos los valores morales que merecen alabanza."
,"9":"Pongan en práctica todo lo que han aprendido, recibido y oído de mí, todo lo que me han visto hacer, y el Dios de la paz estará con ustedes."
,"10":"Sentí mucho gozo en el Señor al ver florecer en ustedes esa preocupación por mí. En realidad pensaban en mí, sólo que les faltaba una ocasión."
,"11":"No digo esto porque esté necesitado, pues he aprendido a arreglarme con lo que tengo."
,"12":"Sé pasar privaciones y vivir en la abundancia. Estoy entrenado para todo y en todo momento: a estar satisfecho o hambriento, en la abundancia o en la escasez."
,"13":"Todo lo puedo en aquel que me fortalece."
,"14":"Sin embargo, hicieron bien en compartir mis pruebas."
,"15":"Filipenses, ustedes saben que en los principios de la evangelización, cuando me alejé de Macedonia, ninguna Iglesia me abrió una cuenta de gastos e ingresos excepto ustedes."
,"16":"Durante mi permanencia en Tesalónica me mandaron dos veces todo lo que necesitaba."
,"17":"No es que yo busque regalos; más me interesa que la cuenta de ustedes vaya subiendo."
,"18":"Por el momento tengo todo lo que necesito y más de lo que necesito. Tengo de sobra con lo que Epafrodito me entregó de parte de ustedes y que recibí como un sacrificio 'agradable a Dios y cuyo olor sube hasta él'."
,"19":"Mi Dios, a su vez, proveerá a todas sus necesidades, según su inmensa riqueza en Cristo Jesús."
,"20":"Gloria a Dios, nuestro Padre, por los siglos de los siglos. Amén."
,"21":"Saluden a los hermanos, como a santos en Cristo Jesús. Los saludan los hermanos que están conmigo."
,"22":"Los saludan todos los hermanos de aquí, especialmente los del palacio del César."
,"23":"La gracia de Cristo Jesús, el Señor, sea con su espíritu."
}`)

}
func ES_LBL_LoadNPRMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"De Pablo, siervo de Cristo Jesús, apóstol por un llamado de Dios, escogido para el Evangelio de Dios."
,"2":"Esta Buena Nueva,anunciada de antemano por sus profetas en las Santas Escrituras"
,"3":"se refiere a su Hijo, que nació de la descendencia de David según la carne,"
,"4":"y que al resucitar de entre los muertos por obra del Espíritu de santidad, ha sido designado Hijo de Dios revestido de su poder. De él, Cristo Jesús, nuestro Señor, "
,"5":"hemos recibido gracia y misión, para que en todos los pueblos no-judíos sea recibida la fe, para gloria de su nombre."
,"6":"A estos pueblos pertenecen ustedes, elegidos de Cristo Jesús"
,"7":"que están en Roma, a quienes Dios ama y ha llamado y consagrado. Que de Dios, nuestro Padre, y de Cristo Jesús, el Señor, les lleguen la gracia y la paz."
,"8":"Ante todo doy gracias a mi Dios, por medio de Cristo Jesús, por todos ustedes, pues su fe es alabada en el mundo entero."
,"9":"Dios sabe que los recuerdo constantemente en mis oraciones, mientras le rindo ese culto espiritual que es trabajar por la Buena Nueva de su Hijo."
,"10":"Pues yo desearía, si tal es su voluntad, que se me allane el camino para ir a visitarles."
,"11":"Tengo muchas ganas de verlos para comunicarles algún don espiritual que los fortalezca"
,"12":"y, al compartir nuestra fe, nos animaremos mutuamente."
,"13":"Quiero que sepan, hermanos, que muchas veces me he propuesto ir donde ustedes, pero hasta el momento no he tenido la posibilidad de ir a cosechar algún fruto entre ustedes, como he hecho en otros países."
,"14":"Pues me siento en obligación con todos, ya sean griegos o extranjeros, cultos o sin estudios,"
,"15":"y estoy dispuesto a ir hasta ustedes a Roma para dar el Evangelio."
,"16":"Como ven, no me avergüenzo del Evangelio. Es una fuerza de Dios y salvación para todos los que creen, en primer lugar para los judíos, y también para los griegos."
,"17":"El Evangelio manifiesta cómo Dios nos hace justos, es decir, nos reforma por medio de la fe y para la vida de fe, como dice la Escritura: El que es justo por la fe vivirá."
,"18":"Desde el cielo nos amenaza la indignación de Dios por todas las maldades e injusticias de aquellos que sofocan la verdad con el mal."
,"19":"Todo lo que se puede conocer de Dios lo tienen ante sus ojos, pues Dios se lo manifestó."
,"20":"Lo que es y que no podemos ver ha pasado a ser visible gracias a la creación del universo, y por sus obras captamos algo de su eternidad, de su poder y de su divinidad. De modo que no tienen disculpa. "
,"21":"A pesar de que conocían a Dios, no le rindieron honores ni le dieron gracias como corresponde. Al contrario, se perdieron en sus razonamientos y su conciencia cegada se convirtió en tinieblas."
,"22":"Creyéndose sabios, se volvieron necios."
,"23":"Incluso reemplazaron al Dios de la Gloria, al Dios inmortal, con imágenes de todo lo pasajero: imágenes de hombres, de aves, de animales y reptiles."
,"24":"Por eso Dios los abandonó a sus pasiones secretas, se entregaron a la impureza y deshonraron sus propios cuerpos."
,"25":"Cambiaron la verdad de Dios por la mentira. Adoraron y sirvieron a seres creados en lugar del Creador, que es bendecido por todos los siglos: ¡Amén!"
,"26":"Por esto Dios dejó que fueran presa de pasiones vergonzosas: ahora sus mujeres cambian las relaciones sexuales normales por relaciones contra la naturaleza."
,"27":"Los hombres, asimismo, dejan la relación natural con la mujer y se apasionan los unos por los otros; practican torpezas varones con varones, y así reciben en su propia persona el castigo merecido por su aberración."
,"28":"Ya que juzgaron inútil conocer a Dios, Dios a su vez los abandonó a los errores de su propio juicio, de tal modo que hacen absolutamente todo lo que es malo."
,"29":"En ellos no se ve más que injusticia, perversidad, codicia y maldad. Rebosan de envidia, crímenes, peleas, engaños, mala fe, chismes"
,"30":"y calumnias. Desafían a Dios, son altaneros, orgullosos, farsantes, hábiles para lo malo y no obedecen a sus padres."
,"31":"Son insensatos, desleales, sin amor, despiadados."
,"32":"Conocen las sentencias de Dios y saben que son dignos de muerte quienes obran de esa forma. Pero no solamente lo hacen, sino que aprueban a los que actúan de igual modo."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Por lo tanto, amigo mío, si eres capaz de juzgar, ya no tienes disculpa. Te condenas a ti mismo cuando juzgas a los demás, pues tú haces lo que estás condenando."
,"2":"Nos parece bien que Dios condene a los que hacen tales cosas,"
,"3":"pero tú, que haces lo mismo, ¿piensas que escaparás del juicio de Dios porque tanto tú como él condenan a los demás?"
,"4":"Esto sería aprovecharte de Dios y de su inmensa bondad, paciencia y comprensión, y no ver que esa bondad te quiere llevar a la conversión."
,"5":"Si tu corazón se endurece y te niegas a cambiar, te estás preparando para ti mismo un gran castigo para el día del juicio, cuando Dios se presente como justo Juez."
,"6":"El pagará a cada uno de acuerdo con sus obras."
,"7":"Dará vida eterna a quien haya seguido el camino de la gloria, del honor y la inmortalidad, siendo constante en hacer el bien;"
,"8":"y en cambio habrá sentencia de reprobación para quienes no han seguido la verdad, sino más bien la injusticia."
,"9":"Habrá sufrimientos y angustias para todos los seres humanos que hayan hecho el mal, en primer lugar para el judío, y también para el griego."
,"10":"La gloria, en cambio, el honor y la paz serán para todos los que han hecho el bien, en primer lugar para el judío, y también para el griego,"
,"11":"porque Dios no hace distinción de personas."
,"12":"Quienes pecaron sin conocer la Ley, serán eliminados sin que se hable de la Ley; y los que pecaron conociendo la Ley, serán juzgados por la Ley."
,"13":"Porque no son justos ante Dios los que escuchan la Ley, sino los que la cumplen."
,"14":"Cuando los paganos, que no tienen ley, cumplen naturalmente lo que manda la Ley, están escribiendo ellos mismos esa ley que no tienen,"
,"15":"y así demuestran que las exigencias de la Ley están grabadas en sus corazones. Serán juzgados por su propia conciencia, y los acusará o los aprobará su propia razón"
,"16":"el día en que Dios juzgue lo más íntimo de las personas por medio de Jesucristo. Es lo que dice mi Evangelio."
,"17":"Porque imagina lo siguiente: tú eres judío, y te apoyas en la Ley y te sientes orgulloso de tu Dios;"
,"18":"conoces su voluntad porque la Ley te la enseñó, y sabes cómo actuar según las circunstancias...;"
,"19":"tú te crees guía de ciegos, luz en la oscuridad,"
,"20":"maestro de los que no saben, el que enseña a los pequeños, y posees en la Ley todo lo esencial, y las normas del conocimiento y de la verdad..."
,"21":"Pues bien, tú que enseñas a los demás, ¿por qué no te instruyes a ti mismo? Dices que no hay que robar, ¡y tú robas!"
,"22":"Dices que no se debe engañar a la propia esposa, ¡y tú lo haces! Afirmas que aborreces a los ídolos, pero ¡robas en sus templos!"
,"23":"Te sientes orgulloso de la Ley, pero pasas por encima de ella, de tal manera que deshonras a tu Dios."
,"24":"Ya lo dice la Escritura: Ustedes son causa de que los paganos insulten el nombre de Dios."
,"25":"La circuncisión te sirve si cumples la Ley; pero si no la cumples, te colocas entre los que no están circuncidados."
,"26":"Por el contrario, si uno de ellos cumple los mandatos de la Ley, será considerado exactamente como un circuncidado."
,"27":"El que cumple la Ley sin estar marcado físicamente con la circuncisión podrá juzgarte a ti, que eres infiel a la Ley a pesar de que tienes a la vez la circuncisión y la Ley."
,"28":"Porque lo que a uno lo hace judío no es algo exterior, y la circuncisión real no es la que está hecha en el cuerpo."
,"29":"Ser judío es una realidad íntima, y la circuncisión debe ser la del corazón, obra espiritual y no cuestión de leyes escritas. No es algo que puedan valorar los hombres, sino sólo Dios."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Entonces, ¿cuál es la ventaja de ser judío?, ¿cuál la utilidad de la circuncisión?"
,"2":"Grande, bajo todo punto de vista. En primer lugar, fue a los judíos a quienes confió Dios su palabra."
,"3":"Es verdad que algunos de ellos no le respondieron, pero ¿hará su infidelidad que Dios no sea fiel? ¡Ni pensarlo!"
,"4":"Se comprobará que Dios es fidelidad, mientras que el hombre siempre defrauda, como dice la Escritura: Será probado que tus palabras son verdaderas y saldrás vencedor si te quieren juzgar."
,"5":"Pero si nuestra maldad demuestra que Dios es justo, se podría preguntar: ¿No es Dios injusto al castigarnos?"
,"6":"De ninguna manera, pues si no, ¿cómo podría Dios juzgar al mundo?"
,"7":"Pero tal vez replicarán: Si la mentira mía hace resaltar la verdad de Dios, aumentando así su gloria, ¿cómo me tratarán de pecador?"
,"8":"¡Muy bien! Entonces hagamos el mal para que venga el bien... Algunos calumniadores dicen que ésa es nuestra enseñanza, pero tendrán que responder de tales palabras."
,"9":"¿Tenemos, entonces, alguna superioridad? Sí y no. Acabamos de demostrar que todos, judíos y no judíos, están bajo el dominio del pecado,"
,"10":"como dice la Escritura:"
,"11":"No hay nadie bueno, ni siquiera uno. No hay ninguno sensato, nadie que busque a Dios."
,"12":"Todos se han extraviado, ya no sirven para nada. No hay quien obre el bien, ni siquiera uno."
,"13":"Su garganta es un sepulcro abierto, y con su lengua urden engaños."
,"14":"Sus labios esconden veneno de serpiente y su boca está llena de maldiciones y amargura."
,"15":"Corren a donde puedan derramar sangre."
,"16":"Detrás de ellos dejan ruina y miseria."
,"17":"No conocen el camino de la paz,"
,"18":"el temor de Dios es lo que menos recuerdan."
,"19":"Pero sabemos que todo lo que dice la Escritura está dicho para el mismo pueblo que recibió la Ley. Que todos, pues, se callen y el mundo entero se reconozca culpable ante Dios."
,"20":"Porque en base a la observancia de la Ley no será justificado ningún mortal ante Dios. El fruto de la Ley es otro: nos hace conscientes del pecado."
,"21":"Ahora se nos ha revelado cómo Dios nos reordena y hace justos sin hablar de la Ley, pero ya lo daban a entender la Ley y los profetas."
,"22":"Mediante la fe según Jesucristo Dios reordena y hace justos a todos los que llegan a la fe. No hay distinción de personas, "
,"23":"pues todos pecaron y están faltos de la gloria de Dios."
,"24":"Pero todos son reformados y hechos justos gratuitamente y por pura bondad, mediante la redención realizada en Cristo Jesús."
,"25":"Dios lo puso como la víctima cuya sangre nos consigue el perdón, y esto es obra de fe. Así demuestra Dios cómo nos hace justos, perdonando los pecados del pasado"
,"26":"que había soportado en aquel tiempo; y demuestra también cómo nos reforma en el tiempo presente: él, que es justo, nos hace justos y santos por la fe propia de Jesús."
,"27":"Y ahora, ¿dónde están nuestros méritos? Fueron echados fuera."
,"28":"¿Quién los echó? ¿La Ley que pedía obras? No, otra ley, que es la fe. Nosotros decimos esto: la persona es reformada y hecha justa por la fe, y no por el cumplimiento de la Ley."
,"29":"De otra manera Dios sería sólo Dios de los judíos. ¿No lo es también de las demás naciones?"
,"30":"¡Claro que también es Dios de esas naciones! Pues solamente él es Dios, quien salva al pueblo circuncidado a causa de su fe y a los otros pueblos cuando llegan a la fe."
,"31":"¿Creen ustedes que con la fe suprimimos la Ley? De ninguna manera; más bien la colocamos en su verdadero lugar."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Hablemos, pues, de Abrahán, nuestro padre según la carne. ¿Qué fue lo novedoso en él?"
,"2":"Abrahán fue justo ante Dios, y si lo hubiera conseguido por sus obras, podría ostentar sus méritos, pero no los tiene ante Dios."
,"3":"En efecto, ¿qué dice la Escritura? Abrahán creyó a Dios, quien se lo tomó en cuenta para hacerlo justo."
,"4":"Cuando alguien ha realizado una obra o trabajo, no se le entrega el salario como un favor, sino como una deuda."
,"5":"Por el contrario, al que no puede presentar obras, pero cree en Aquel que hace justos a los pecadores, se le toma en cuenta su fe para hacerlo justo."
,"6":"Así David felicita al que Dios cuenta entre los justos sin que sea el fruto de sus obras:"
,"7":"Felices aquellos cuyos pecados han sido perdonados, y cuyas ofensas han sido olvidadas."
,"8":"Feliz el hombre a quien Dios no le toma en cuenta su pecado."
,"9":"Esta felicidad, ¿está reservada sólo para los circuncidados o es también para los incircuncisos? Acabamos de decir que se tomó en cuenta la fe de Abrahán para contarlo entre los justos."
,"10":"Pero ¿cuándo se dio eso: antes de circuncidarse o después? No después, sino antes."
,"11":"Justamente recibió el rito de la circuncisión, cuando aún no estaba circuncidado, como un sello o como una señal de que por su fe Dios lo había puesto en un estado de justicia. De manera que Abrahán es el padre de todos los que creen sin haber sido circuncidados, y Dios se lo toma en cuenta para hacerlos justos y santos. "
,"12":"Y también es el padre del pueblo judío con tal que no tengan sólo la circuncisión, sino que sigan además las huellas de nuestro padre Abrahán, que creyó cuando todavía no estaba circuncidado."
,"13":"Es fácil ver que si Dios prometió a Abrahán, o más bien a su descendiente, que el mundo le pertenecería, esto no tiene nada que ver con la Ley, sino con la manera de ser justo propia del creyente."
,"14":"Si debiéramos cumplir la Ley para conseguir la promesa, la fe ya no tendría sentido y la promesa también se quedaría en nada."
,"15":"Pues la Ley solamente trae castigos: Ley y transgresión van juntas."
,"16":"Por eso la fe es el camino, y todo es don. De este modo la promesa de Abrahán queda asegurada para toda su raza, no sólo para sus hijos según la Ley, sino también para aquellos que por la fe son hijos suyos."
,"17":"Abrahán es el padre de todos nosotros, como dice la Escritura: Te hago padre de muchas naciones. Y llegó a serlo cuando creyó en Aquel que da vida a los muertos y llama a lo que aún no existe como si ya existiera."
,"18":"Abrahán creyó y esperó contra toda esperanza, llegando a ser padre de muchas naciones, según le habían dicho: ¡Mira cuán numerosos serán tus descendientes!"
,"19":"No vaciló en su fe, olvidando que su cuerpo ya no podía dar vida -tenía entonces unos cien años- y que su esposa Sara ya no podía tener hijos."
,"20":"No dudó de la promesa de Dios ni dejó de creer; por el contrario, su fe le dio fuerzas y dio gloria a Dios,"
,"21":"plenamente convencido de que cuando Dios promete algo, tiene poder para cumplirlo."
,"22":"Y Dios tomó en cuenta esa fe para hacerlo justo."
,"23":"Se le tomó en cuenta su fe. Estas palabras de la Escritura no sólo van dirigidas a él,"
,"24":"sino también a nosotros; se nos tomará en cuenta nuestra fe en Aquel que resucitó de entre los muertos a Jesús, nuestro Señor."
,"25":"Si bien fue entregado por nuestros pecados, fue resucitado para que entráramos a la vida justa."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Por la fe, pues, hemos sido reordenados, y estamos en paz con Dios por medio de Jesucristo, nuestro Señor."
,"2":"Por él hemos tenido acceso a un estado de gracia e incluso hacemos alarde de esperar la misma Gloria de Dios."
,"3":"Al mismo tiempo nos sentimos seguros incluso en las tribulaciones, sabiendo que la prueba ejercita la paciencia,"
,"4":"que la paciencia nos hace madurar y que la madurez aviva la esperanza,"
,"5":"la cual no quedará frustrada, pues ya se nos ha dado el Espíritu Santo, y por él el amor de Dios se va derramando en nuestros corazones."
,"6":"Fíjense cómo Cristo murió por los pecadores, cuando llegó el momento, en un tiempo en que no servíamos para nada."
,"7":"Difícilmente aceptaríamos morir por una persona buena; tratándose de una persona muy buena, tal vez alguien se atrevería a sacrificar su vida."
,"8":"Pero Dios dejó constancia del amor que nos tiene: Cristo murió por nosotros cuando todavía éramos pecadores."
,"9":"Con mucha más razón ahora nos salvará del castigo si, por su sangre, hemos sido hechos justos y santos."
,"10":"Cuando éramos enemigos, fuimos reconciliados con él por la muerte de su Hijo; con mucha más razón ahora su vida será nuestra plenitud."
,"11":"No sólo eso: nos sentiremos seguros de Dios gracias a Cristo Jesús, nuestro Señor, por medio del cual hemos obtenido la reconciliación."
,"12":"Un solo hombre hizo entrar el pecado en el mundo, y por el pecado la muerte. Después la muerte se propagó a todos los hombres, ya que todos pecaban."
,"13":"No había Ley todavía, pero el pecado ya estaba en el mundo. Mientras no había Ley, nadie podía ser tenido por rebelde, pero no obstante el pecado estaba en el mundo."
,"14":"Por eso, desde Adán hasta Moisés, la muerte tuvo poder, incluso sobre aquellos que no desobedecían abiertamente como en el caso de Adán. Pero otro Adán superior a éste había de venir."
,"15":"Así fue la caída, pero el don de Dios no tiene comparación. Todos mueren por la falta de uno solo, pero la gracia de Dios se multiplica más todavía cuando este don gratuito pasa de un solo hombre, Jesucristo, a toda una muchedumbre."
,"16":"No hay comparación entre lo que pasó con este pecador único y el don de Dios en la hora presente. La condenación procedía de una sentencia individual, pero ahora son rehabilitados una multitud de pecadores."
,"17":"Y si bien reinó la muerte por culpa de uno y debido a uno solo, con mucha mayor razón la vida reinará gracias a uno solo, Jesucristo, en todos aquellos que aprovechan el derroche de la gracia y el don de la verdadera rectitud."
,"18":"Es verdad que una sola transgresión acarreó sentencia de muerte para todos, pero del mismo modo la rehabilitación merecida por uno solo procuró perdón y vida a todos."
,"19":"Y así como la desobediencia de uno solo hizo pecadores a muchos, así también por la obediencia de uno solo una multitud accede a la verdadera rectitud."
,"20":"Al sobrevenir la Ley, el pecado tuvo más auge, pero donde abundó el pecado, sobreabundó la gracia."
,"21":"Y del mismo modo que el pecado estableció su reinado de muerte, así también debía reinar la gracia y, después de restablecernos en la amistad con Dios, nos llevará a la vida eterna por medio de Cristo Jesús, nuestro Señor."
}`)
	CurrentBook.AddChapter(6, `{
"1":"¿Qué conclusión sacaremos? ¿Continuaremos pecando para que la gracia venga más abundante? ¡Por supuesto que no!"
,"2":"Si hemos muerto al pecado, ¿cómo volveremos a vivir en él?"
,"3":"Como ustedes saben, todos nosotros, al ser bautizados en Cristo Jesús, hemos sido sumergidos en su muerte."
,"4":"Por este bautismo en su muerte fuimos sepultados con Cristo, y así como Cristo fue resucitado de entre los muertos por la Gloria del Padre, así también nosotros empezamos una vida nueva."
,"5":"Una figura de su muerte nos injertó en él, pero compartiremos también su resurrección."
,"6":"Como ustedes saben, el hombre viejo que está en nosotros ha sido crucificado con Cristo. Las fuerzas vivas del pecado han sido destruidas para que no sirvamos más al pecado."
,"7":"Hemos muerto, ¿no es cierto? Entonces ya no le debemos nada."
,"8":"Pero si hemos muerto junto a Cristo, debemos creer que también viviremos con él."
,"9":"Sabemos que Cristo, una vez resucitado de entre los muertos, ya no muere más; desde ahora la muerte no tiene poder sobre él."
,"10":"Así, pues, hay una muerte y es un morir al pecado de una vez para siempre. Y hay un vivir que es vivir para Dios."
,"11":"Así también ustedes deben considerarse a sí mismos muertos para el pecado y vivos para Dios en Cristo Jesús."
,"12":"No dejen que el pecado tenga poder sobre este cuerpo -¡es un muerto!- y no obedezcan a sus deseos."
,"13":"No le entreguen sus miembros, que vendrían a ser como malas armas al servicio del pecado. Por el contrario, ofrézcanse ustedes mismos a Dios, como quienes han vuelto de la muerte a la vida, y que sus miembros sean como armas santas al servicio de Dios."
,"14":"El pecado ya no los volverá a dominar, pues no están bajo la Ley, sino bajo la gracia."
,"15":"Díganme: el hecho de que ya no estemos bajo la Ley sino bajo la gracia, ¿nos autoriza a pecar? Claro que no."
,"16":"Si se entregan a alguien como esclavos, pasan a ser sus esclavos y obedecen sus órdenes, ¿no es así? Si ese dueño es el pecado, irán a la muerte, mientras que obedeciendo a la fe, alcanzarán una vida santa."
,"17":"Así, pues, demos gracias a Dios, porque antes tenían como dueño al pecado, pero han obedecido de todo corazón a esa doctrina a la cual se han entregado."
,"18":"Y, liberados del pecado, se hicieron esclavos del camino de justicia."
,"19":"Ven que uso figuras muy humanas, pues tal vez les cueste entender. Hubo un tiempo en que llevaron una vida desordenada e hicieron de sus cuerpos esclavos de la impureza y del desorden; conviértanlos ahora en servidores de la justicia verdadera, para llegar a ser santos."
,"20":"Cuando eran esclavos del pecado, se sentían muy libres respecto al camino de justicia."
,"21":"Pero con todas esas cosas de las que ahora se avergüenzan, ¿cuál ha sido el fruto? Al final está la muerte."
,"22":"Ahora, en cambio, siendo libres del pecado y sirviendo a Dios, trabajan para su propia santificación, y al final está la vida eterna."
,"23":"El pecado paga un salario, y es la muerte. La vida eterna, en cambio, es el don de Dios en Cristo Jesús, nuestro Señor."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Les hablaré, hermanos, como a gente instruida en la Ley. Ustedes saben que la Ley tiene autoridad sobre las personas solamente mientras viven."
,"2":"La mujer casada, por ejemplo, está ligada por ley a su marido mientras éste vive. En cuanto muere el marido, ya no tiene obligaciones hacia él."
,"3":"Mientras éste vivía, cometía un adulterio entregándose a otro; pero, muerto el esposo, queda libre de sus deberes, y si se entrega a otro hombre, no será un adulterio."
,"4":"Lo mismo pasa con ustedes, hermanos, pues han muerto a la Ley en la persona de Cristo, y han pasado a pertenecer a otro, al que resucitó de entre los muertos, a fin de que diéramos fruto para Dios."
,"5":"Cuando no éramos más que 'carne', la Ley estimulaba las pasiones propias del pecado, que actuaban en nuestro cuerpo produciendo frutos de muerte."
,"6":"Pero ahora hemos muerto a lo que nos tenía aprisionados, y la Ley ya no vale para nosotros. Ya no estamos sirviendo a una ley escrita, cosa propia del pasado, sino al Espíritu: esto es lo nuevo."
,"7":"¿Qué significa esto? ¿Que la Ley es pecado? De ninguna manera. Pero yo no habría conocido el pecado si no fuera por la Ley. Yo no tendría conciencia de lo que es codiciar si la Ley no me hubiera dicho: 'No codiciarás'."
,"8":"El pecado encontró ahí su oportunidad y se aprovechó del precepto para despertar en mí toda suerte de codicias, mientras que sin ley el pecado es cosa muerta."
,"9":"Hubo un tiempo en que no había Ley, y yo vivía. Pero llegó el precepto, dio vida al pecado,"
,"10":"y yo morí. Así, pues, el precepto que había sido dado para la vida me trajo la muerte."
,"11":"El pecado se aprovechó del precepto y me engañó, para que después el precepto me causara la muerte."
,"12":"Pero la Ley es santa y también es santo, justo y bueno el precepto."
,"13":"¿Será posible que algo bueno produzca en mí la muerte? En absoluto. Esto viene del pecado, y se ve mejor lo que es el pecado cuando se vale de algo bueno para producir en mí la muerte. Gracias al precepto, el pecado deja ver toda la maldad que lleva en sí."
,"14":"Sabemos que la Ley es espiritual, pero yo soy hombre de carne y vendido al pecado."
,"15":"No entiendo mis propios actos: no hago lo que quiero y hago las cosas que detesto."
,"16":"Ahora bien, si hago lo que no quiero, reconozco que la Ley es buena."
,"17":"No soy yo quien obra el mal, sino el pecado que habita en mí. Bien sé que el bien no habita en mí, quiero decir, en mi carne."
,"18":"Puedo querer hacer el bien, pero hacerlo, no."
,"19":"De hecho no hago el bien que quiero, sino el mal que no quiero."
,"20":"Por lo tanto, si hago lo que no quiero, eso ya no es obra mía sino del pecado que habita en mí."
,"21":"Ahí me encuentro con una ley: cuando quiero hacer el bien, el mal se me adelanta."
,"22":"En mí el hombre interior se siente muy de acuerdo con la Ley de Dios,"
,"23":"pero advierto en mis miembros otra ley que lucha contra la ley de mi espíritu, y paso a ser esclavo de esa ley del pecado que está en mis miembros."
,"24":"¡Infeliz de mí! ¿Quién me librará de este cuerpo, o de esta muerte?"
,"25":"¡Gracias sean dadas a Dios por Jesucristo, nuestro Señor!,En resumen: por mi conciencia me someto a la Ley de Dios, mientras que por la carne sirvo a la ley del pecado."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Ahora bien, esta condenación ya no existe para los que viven en Cristo Jesús."
,"2":"En Cristo Jesús la ley del Espíritu de vida te ha liberado de la ley del pecado y de la muerte."
,"3":"Esto no lo podía hacer la Ley, por cuanto la carne era débil y no le respondía. Dios entonces quiso que su propio Hijo llevara esa carne pecadora; lo envió para enfrentar al pecado, y condenó el pecado en esa carne."
,"4":"Así, en adelante, la perfección que buscaba la Ley había de realizarse en los que no andamos por los caminos de la carne, sino por los del Espíritu."
,"5":"Los que viven según la carne van a lo que es de la carne, y los que viven según el Espíritu van a las cosas del espíritu."
,"6":"Pero no hay sino muerte en lo que ansía la carne, mientras que el espíritu anhela vida y paz."
,"7":"Los proyectos de la carne están en contra de Dios, pues la carne no se somete a la ley de Dios, y ni siquiera puede someterse."
,"8":"Por eso los que viven según la carne no pueden agradar a Dios."
,"9":"Ustedes ya no están en la carne, sino que viven en el espíritu, pues el Espíritu de Dios habita en ustedes. Si alguno no tuviera el Espíritu de Cristo, éste no le pertenecería."
,"10":"Pero Cristo está en ustedes, y aunque el cuerpo lleve en sí la muerte a consecuencia del pecado, el espíritu es vida por haber sido santificado."
,"11":"Y si el Espíritu de Aquel que resucitó a Cristo de entre los muertos está en ustedes, el mismo que resucitó a Jesús de entre los muertos dará también vida a sus cuerpos mortales por medio de su Espíritu, que habita en ustedes."
,"12":"Entonces, hermanos, no vivamos según la carne, pues no le debemos nada."
,"13":"Si viven según la carne, necesariamente morirán; más bien den muerte a las obras del cuerpo mediante el espíritu, y vivirán."
,"14":"Todos aquellos a los que guía el Espíritu de Dios son hijos e hijas de Dios."
,"15":"Entonces no vuelvan al miedo; ustedes no recibieron un espíritu de esclavos, sino el espíritu propio de los hijos, que nos permite gritar: ¡Abba!, o sea: ¡Papá!"
,"16":"El Espíritu asegura a nuestro espíritu que somos hijos de Dios."
,"17":"Siendo hijos, son también herederos; la herencia de Dios será nuestra y la compartiremos con Cristo. Y si hemos sufrido con él, estaremos con él también en la Gloria."
,"18":"Estimo que los sufrimientos de la vida presente no se pueden comparar con la Gloria que nos espera y que ha de manifestarse."
,"19":"Algo entretiene la inquietud del universo, y es la esperanza de que los hijos e hijas de Dios se muestren como son."
,"20":"Pues si la creación se ve obligada a no lograr algo duradero, esto no viene de ella misma, sino de aquel que le impuso este destino. Pero le queda la esperanza;"
,"21":"porque el mundo creado también dejará de trabajar para que sea destruido, y compartirá la libertad y la gloria de los hijos de Dios."
,"22":"Vemos que la creación entera gime y sufre dolores de parto."
,"23":"Y también nosotros, aunque ya tengamos el Espíritu como un anticipo de lo que hemos de recibir, gemimos en nuestro interior mientras esperamos nuestros derechos de hijos y la redención de nuestro cuerpo."
,"24":"Estamos salvados, pero todo es esperanza. ¿Quieres ver lo que esperas? Ya no sería esperar; porque, ¿puedes esperar lo que ya ves?"
,"25":"Esperemos, pues, sin ver, y lo tendremos, si nos mantenemos firmes."
,"26":"Somos débiles, pero el Espíritu viene en nuestra ayuda. No sabemos cómo pedir ni qué pedir, pero el Espíritu lo pide por nosotros, sin palabras, como con gemidos."
,"27":"Y Aquel que penetra los secretos más íntimos entiende esas aspiraciones del Espíritu, pues el Espíritu quiere conseguir para los santos lo que es de Dios."
,"28":"También sabemos que Dios dispone todas las cosas para bien de los que lo aman, a quienes él ha escogido y llamado."
,"29":"A los que de antemano conoció, también los predestinó a ser como su Hijo y semejantes a él, a fin de que sea el primogénito en medio de numerosos hermanos."
,"30":"Así, pues, a los que él eligió los llamó; a los que llamó los hizo justos y santos; a los que hizo justos y santos les da la Gloria."
,"31":"¿Qué más podemos decir? Si Dios está con nosotros, ¿quién estará contra nosotros?"
,"32":"Si ni siquiera perdonó a su propio Hijo, sino que lo entregó por todos nosotros, ¿cómo no nos va a dar con él todo lo demás?"
,"33":"¿Quién acusará a los elegidos de Dios? Dios mismo los declara justos."
,"34":"¿Quién los condenará? ¿Acaso será Cristo, el que murió y, más aún, resucitó y está a la derecha de Dios intercediendo por nosotros?"
,"35":"¿Quién nos separará del amor de Cristo? ¿Acaso las pruebas, la aflicción, la persecución, el hambre, la falta de todo, los peligros o la espada?"
,"36":"Como dice la Escritura: Por tu causa nos arrastran continuamente a la muerte, nos tratan como ovejas destinadas al matadero."
,"37":"Pero no; en todo eso saldremos triunfadores gracias a Aquel que nos amó."
,"38":"Yo sé que ni la muerte ni la vida, ni los ángeles ni las fuerzas del universo, ni el presente ni el futuro, ni las fuerzas espirituales,"
,"39":"ya sean del cielo o de los abismos, ni ninguna otra criatura podrán apartarnos del amor de Dios, manifestado en Cristo Jesús, nuestro Señor."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Quiero hablarles en Cristo; todo será verdad y no miento, tal como mi conciencia me lo atestigua en el Espíritu Santo."
,"2":"Siento una tristeza muy grande y una pena continua,"
,"3":"hasta el punto que desearía ser rechazado y alejado de Cristo en lugar de mis hermanos; me refiero a los de mi raza."
,"4":"Ellos son los israelitas, a quienes Dios adoptó; entre ellos descansa su gloria con las alianzas, el don de la Ley, el culto y las promesas de Dios."
,"5":"Suyos son los grandes antepasados, y Cristo es uno de ellos según la carne, el que como Dios está también por encima de todo. ¡Bendito sea por todos los siglos! Amén."
,"6":"No quiero hablar de un fracaso de las promesas de Dios, porque no todos los israelitas son Israel,"
,"7":"como tampoco los descendientes de Abrahán eran todos hijos suyos. Pues le fue dicho: Los hijos de Isaac serán considerados tus descendientes."
,"8":"O sea, que no basta ser hijo suyo según la carne para ser hijo de Dios; la verdadera descendencia de Abrahán son los hijos que le han nacido a raíz de la promesa de Dios."
,"9":"Y la promesa es ésta: Por este tiempo volveré y Sara tendrá ya un hijo."
,"10":"Fíjense también en el caso de Rebeca, esposa de nuestro padre Isaac, que estaba esperando mellizos."
,"11":"Como todavía no habían hecho ni bien ni mal, la elección de Dios era totalmente libre y todo dependía,"
,"12":"no de los méritos de alguno, sino de su propio llamado. Y fue entonces cuando se le dijo: El mayor servirá al más joven."
,"13":"La Escritura dice al respecto: Elegí a Jacob y rechacé a Esaú."
,"14":"¿Diremos, entonces, que Dios es injusto? ¡Claro que no!"
,"15":"Dice sin embargo a Moisés: Seré misericordioso con quien quiera serlo y me compadeceré de quien quiera compadecerme."
,"16":"Debemos concluir que lo importante no es querer, o llegar primero, sino que Dios tenga misericordia."
,"17":"En la Escritura dice a Faraón: Te hice Faraón con el fin de manifestar en ti mi poder y para que toda la tierra conozca mi Nombre."
,"18":"Así que Dios usa de misericordia con quien quiere y endurece el corazón de quien quiere."
,"19":"Tú me vas a decir: Dios no tiene por qué reprocharme, dado que nadie puede oponerse a su voluntad."
,"20":"Pero, amigo, ¿quién eres tú para pedir cuentas a Dios? ¿Acaso dirá la arcilla al que la modeló: Por qué me hiciste así?"
,"21":"¿No dispone el alfarero de su barro y hace con el mismo barro una vasija preciosa o una para el menaje?"
,"22":"Dios ha aguantado con mucha paciencia vasijas que solamente merecían su ira y que después de hacerlas serían reducidas a pedazos; con ellas quería manifestar su justicia y dar a conocer su poder."
,"23":"Asimismo quiere manifestar las riquezas de su gloria con otras vasijas, las vasijas de la misericordia, que ha preparado de antemano para la gloria."
,"24":"Así nos ha llamado Dios, no sólo de entre los judíos, sino también de entre los paganos."
,"25":"Lo dijo con el profeta Oseas: Llamaré 'pueblo mío' al que no es mi pueblo, y 'amada mía' a la que no es mi amada."
,"26":"Así como se les dijo: 'Ustedes no son mi pueblo', serán llamados 'hijos del Dios vivo'."
,"27":"Respecto a Israel, Isaías dice sin vacilar: Aunque los hijos de Israel fueran tan numerosos como la arena del mar, sólo un resto se salvará."
,"28":"El Señor lo hará en esta tierra sin fallar y sin demora."
,"29":"También Isaías anunció: Si el Señor de los Ejércitos no nos hubiera dejado alguna descendencia, seríamos como Sodoma, parecidos a Gomorra."
,"30":"Entonces, ¿en qué quedamos? En que los paganos, que no buscaban el camino de rectitud, lo encontraron (hablo de la rectitud que es fruto de la fe)."
,"31":"Israel, en cambio, que buscaba en la Ley un camino de rectitud, no alcanzó la finalidad de la Ley. ¿Y por qué?"
,"32":"Porque se ataba a las observancias y no a la fe. Y tropezaron con Aquel que es la piedra de tropiezo,"
,"33":"como está escrito: Mira que pongo en Sión una piedra para tropezar, una roca que hace caer, pero el que crea en él no será confundido."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Hermanos, deseo de todo corazón y pido a Dios que los judíos se salven."
,"2":"Declaro en su favor que son fanáticos del servicio de Dios, pero en una forma equivocada."
,"3":"No entienden cómo Dios nos da la verdadera rectitud y se empeñan en construir la suya, y por esta razón no hicieron caso del camino de Dios."
,"4":"Porque la Ley lleva a Cristo, y es entonces cuando por la fe se llega a ser justo."
,"5":"Moisés habla de ser justo en base a la Ley, pues escribe: Quien la cumpla, hallará por ella la vida."
,"6":"Pero hay otra justicia que es fruto de la fe, y dice así: No digas en tu corazón: ¿quién subirá al cielo? (era una manera de decir que Cristo bajaría de allí)."
,"7":"Y luego: ¿Quién bajará al abismo? (es una manera de decir que Cristo subiría de entre los muertos)."
,"8":"Y luego se dice: Muy cerca de ti está la Palabra, ya está en tus labios y en tu corazón. Ahí tienen nuestro mensaje, y es la fe."
,"9":"Porque te salvarás si confiesas con tu boca que Jesús es Señor y crees en tu corazón que Dios lo resucitó de entre los muertos."
,"10":"La fe del corazón te procura la verdadera rectitud, y tu boca, que lo proclama, te consigue la salvación."
,"11":"La Escritura ya lo dijo: El que cree en él no quedará defraudado."
,"12":"Así que no hay diferencia entre judío y griego; todos tienen el mismo Señor, que es muy generoso con todo el que lo invoca;"
,"13":"porque todo el que invoque el Nombre del Señor se salvará."
,"14":"Pero ¿cómo invocarán al Señor sin haber creído en él? Y ¿cómo podrán creer si no han oído hablar de él? Y ¿cómo oirán si no hay quien lo proclame?"
,"15":"Y ¿cómo lo proclamarán si no son enviados? Como dice la Escritura: Qué bueno es ver los pasos de los que traen buenas noticias."
,"16":"Pero es un hecho que no todos aceptaron la Buena Noticia, como decía Isaías: Señor, ¿quién nos ha escuchado y ha creído?"
,"17":"Así, pues, la fe nace de una proclamación, y lo que se proclama es el mensaje cristiano."
,"18":"Me pregunto: ¿Será porque no oyeron? ¡Claro que oyeron! Esta voz resonó en toda la tierra y sus palabras se oyeron hasta en el último rincón del mundo."
,"19":"Y sigo preguntando: ¿Cómo puede ser que Israel no entendiera? Y de inmediato Moisés nos dice: Yo haré que te pongas celoso de una nación que ni siquiera es nación, excitaré tu enojo contra una nación insensata."
,"20":"Isaías luego se atreve a decir: Fui hallado por los que no me buscaban y me manifesté a quienes no preguntaban por mí."
,"21":"Pero añade, y se refiere a Israel: Todo el día extendí mis manos hacia un pueblo desobediente y rebelde."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Entonces debo preguntar: ¿Es posible que Dios haya rechazado a su pueblo? ¡Por supuesto que no! Yo también soy israelita, descendiente de Abrahán y de la tribu de Benjamín."
,"2":"No, Dios no ha rechazado a su pueblo, al que de antemano conoció. ¿No se acuerdan de lo que dice la Escritura acerca de Elías, cuando éste acusaba a Israel ante Dios?"
,"3":"Señor, han dado muerte a tus profetas, han derribado tus altares; he quedado yo solo y, además, quieren matarme."
,"4":"Y ¿cuál fue la respuesta? Me he reservado siete mil hombres que no se han arrodillado ante Baal."
,"5":"Lo mismo ocurre ahora: queda un resto escogido por pura gracia."
,"6":"Yo digo por gracia, y no porque cumplían. De otra manera la gracia no sería gracia."
,"7":"Y entonces, ¿qué? Israel no encontró lo que buscaba, pero sí lo encontraron esos elegidos mientras los demás se endurecían."
,"8":"Dice la Escritura: Dios los embruteció, sus ojos no ven y sus oídos no oyen hasta el día de hoy."
,"9":"Y David dice: Que sus banquetes sean trampa y un lazo, una piedra donde caigan ellos mismos y encuentren ahí su castigo."
,"10":"Que sus ojos se oscurezcan y no vean, y que anden siempre con la espalda encorvada."
,"11":"De nuevo pregunto: ¿Tropezaron y cayeron para no volver a levantarse? De ninguna manera. A consecuencia de su traspié la salvación ha sido llevada a los paganos, y esto será un desafío para ellos."
,"12":"Si la caída de Israel fue una riqueza para el mundo, y lo que perdieron enriqueció a las naciones paganas, ¡como será cuando Israel alcance su plenitud!"
,"13":"A ustedes, que no son judíos, les digo: si yo, apóstol de los no-judíos, pongo tanto empeño en cumplir con mi oficio,"
,"14":"es porque quiero despertar los celos de mi raza y así salvar a algunos de ellos."
,"15":"Si al caer ellos el mundo se reconcilió con Dios, ¿qué significará su reintegración sino que la vida resurge de entre los muertos?"
,"16":"Cuando se consagran a Dios las primicias, queda todo bendecido. Si la raíz es santa, lo serán también las ramas."
,"17":"Ves que algunas ramas han sido cortadas, mientras que a ti te tomaron de un árbol silvestre para injertarte en el árbol bueno de ellos, beneficiándote así de la raíz y de la savia del olivo."
,"18":"¡No desprecies a esas ramas! ¿Cómo puedes sentirte superior? No eres tú el que sostiene la raíz, sino que es la raíz la que te sostiene a ti."
,"19":"Dirás tal vez: 'Cortaron las ramas para injertarme a mí.'"
,"20":"Muy bien, no creyeron y fueron suprimidos, mientras que tú estás ahí gracias a la fe. Pero no seas orgulloso y vigila tus pasos."
,"21":"Porque si Dios no perdonó a las ramas naturales, menos aún te perdonará a ti."
,"22":"Fíjate que Dios es a la vez bondadoso y severo: severo con ellos, que cayeron, y bondadoso contigo, siempre que perseveres en el bien, pues de lo contrario tú también serás cortado."
,"23":"En cuanto a ellos, si no se obstinan en rechazar la fe, serán injertados, pues Dios es capaz de injertarlos de nuevo."
,"24":"Si tú fuiste sacado del olivo silvestre, que era tu misma especie, para ser injertado en el olivo bueno, que no era de tu especie, será mucho más fácil para ellos, que son de la misma especie del olivo."
,"25":"Quiero, hermanos, que entiendan este misterio y no se sientan superiores. Una parte de Israel va a quedarse endurecida hasta que el conjunto de las naciones haya entrado;"
,"26":"entonces todo Israel se salvará, según dice la Escritura: De Sión saldrá el libertador que limpiará a los hijos de Jacob de todas sus faltas."
,"27":"Y ésta es la alianza que yo haré con ellos después de borrar todos sus pecados."
,"28":"Si los miramos desde el Evangelio, ellos son enemigos, lo que es para el bien de ustedes. Pero ateniéndose a la elección, ellos son amados en atención a sus padres."
,"29":"Porque Dios no se arrepiente de su llamado ni de sus dones."
,"30":"Pues bien, ustedes, que no obedecían a Dios, fueron perdonados a través de la rebeldía de los judíos."
,"31":"Ellos, a su vez, serán perdonados después de la actual rebeldía que les ha traído el perdón a ustedes."
,"32":"Así Dios hizo pasar a todos por la desobediencia, a fin de mostrar a todos su misericordia."
,"33":"¡Qué profunda es la riqueza, la sabiduría y la ciencia de Dios! ¿Cómo indagar sus decisiones o reconocer sus caminos?"
,"34":"¿Quién entró jamás en los pensamientos del Señor? ¿A quién llamó para que fuera su consejero?"
,"35":"¿Quién le dio primero, para que Dios tenga que devolvérselo?"
,"36":"Todo viene de él, por él acontece y volverá a él. A él sea la gloria por siempre. ¡Amén!"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Les ruego, pues, hermanos, por la gran ternura de Dios, que le ofrezcan su propia persona como un sacrificio vivo y santo capaz de agradarle; este culto conviene a criaturas que tienen juicio."
,"2":"No sigan la corriente del mundo en que vivimos, sino más bien transfórmense a partir de una renovación interior. Así sabrán distinguir cuál es la voluntad de Dios, lo que es bueno, lo que le agrada, lo que es perfecto."
,"3":"La gracia que Dios me ha dado me autoriza a decirles a todos y cada uno de ustedes que actúen, pero no estorben. Que cada uno actúe sabiamente según la capacidad que Dios le ha entregado."
,"4":"Miren cuántas partes tiene nuestro cuerpo, y es uno, aunque las distintas partes no desempeñan la misma función."
,"5":"Así también nosotros formamos un solo cuerpo en Cristo. Dependemos unos de otros"
,"6":"y tenemos capacidades diferentes según el don que hemos recibido. Si eres profeta, transmite las luces que te son entregadas;"
,"7":"si eres diácono, cumple tu misión; si eres maestro, enseña;"
,"8":"si eres predicador, sé capaz de animar a los demás; si te corresponde la asistencia, da con la mano abierta; si eres dirigente, actúa con dedicación; si ayudas a los que sufren, muéstrate sonriente."
,"9":"Que el amor sea sincero. Aborrezcan el mal y procuren todo lo bueno."
,"10":"Que entre ustedes el amor fraterno sea verdadero cariño, y adelántense al otro en el respeto mutuo."
,"11":"Sean diligentes y no flojos. Sean fervorosos en el Espíritu y sirvan al Señor."
,"12":"Tengan esperanza y sean alegres. Sean pacientes en las pruebas y oren sin cesar."
,"13":"Compartan con los hermanos necesitados, y sepan acoger a los que estén de paso."
,"14":"Bendigan a quienes los persigan; bendigan y no maldigan."
,"15":"Alégrense con los que están alegres, lloren con los que lloran."
,"16":"Vivan en armonía unos con otros. No busquen grandezas y vayan a lo humilde; no se tengan por sabios."
,"17":"No devuelvan a nadie mal por mal, y que todos puedan apreciar sus buenas disposiciones."
,"18":"Hagan todo lo posible para vivir en paz con todos."
,"19":"Hermanos, no se tomen la justicia por su cuenta, dejen que sea Dios quien castigue, como dice la Escritura: Mía es la venganza, yo daré lo que se merece, dice el Señor."
,"20":"Y añade: Si tu enemigo tiene hambre, dale de comer; si tiene sed, dale de beber: éstas serán otras tantas brasas sobre su cabeza."
,"21":"No te dejes vencer por el mal, más bien derrota al mal con el bien."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Cada uno en esta vida debe someterse a las autoridades. Pues no hay autoridad que no venga de Dios, y los cargos públicos existen por voluntad de Dios."
,"2":"Por lo tanto, el que se opone a la autoridad se rebela contra un decreto de Dios y tendrá que responder por esa rebeldía."
,"3":"No hay por qué temer a las autoridades cuando se obra bien, pero sí cuando se obra mal. ¿Quieres vivir sin tener miedo a las autoridades? Pórtate bien y te felicitarán."
,"4":"Han recibido de Dios la misión de llevarte al bien. Y si te portas mal, témelas, pues no tienen las armas sin razón. También tienen misión de Dios para castigar a los malhechores."
,"5":"Así, pues, hay que obedecer, pero no solamente por miedo al castigo, sino por deber de conciencia."
,"6":"Por la misma razón pagan los impuestos, y deben considerar a quienes los cobran como funcionarios de Dios."
,"7":"Den, pues, a cada uno lo que le corresponde: el impuesto, si se le debe impuesto; las tasas, si se le deben tasas; obediencia, si corresponde obedecer; respeto, si se le debe respeto."
,"8":"No tengan deuda alguna con nadie, fuera del amor mutuo que se deben, pues el que ama a su prójimo ya ha cumplido con la Ley."
,"9":"Pues los mandamientos no cometas adulterio, no mates, no robes, no tengas envidia... y todos los demás se resumen en estas palabras: Amarás a tu prójimo como a ti mismo."
,"10":"El amor no hace nada malo al prójimo; el amor, pues, es la manera de cumplir la Ley."
,"11":"Comprendan en qué tiempo estamos, y que ya es hora de despertar. Nuestra salvación está ahora más cerca que cuando llegamos a la fe."
,"12":"La noche va muy avanzada y está cerca el día: dejemos, pues, las obras propias de la oscuridad y revistámonos de una coraza de luz."
,"13":"Comportémonos con decencia, como se hace de día: nada de banquetes y borracheras, nada de prostitución y vicios, nada de pleitos y envidias."
,"14":"Más bien revístanse del Señor Jesucristo, y no se dejen arrastrar por la carne para satisfacer sus deseos."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Sean comprensivos con el que no tiene segura su fe y dejen las discusiones que terminan en división."
,"2":"Hay quien cree que puede comer de todo, mientras que otros, menos seguros, comen sólo verduras."
,"3":"El que come de todo no debe despreciar al que se abstiene; y el que no come de todo, que no critique al que come, pues Dios lo ha tomado tal como es."
,"4":"¿Y quién eres tú para criticar al servidor de otro? Si se mantiene en pie o se cae es asunto de su patrón. Pero no se caerá, porque su Señor tiene poder para mantenerlo en pie."
,"5":"Para unos hay días buenos y días malos, mientras que para otros todos los días son iguales. Que cada uno, pues, siga su propio parecer."
,"6":"El que se preocupa por un día de buena suerte, lo hace por el Señor; y el que come, lo hace por el Señor, pues al comer le da gracias. Y también el que no come lo hace por el Señor y le da igualmente gracias."
,"7":"De hecho, ninguno de nosotros vive para sí mismo y ninguno muere para sí mismo."
,"8":"Si vivimos, vivimos para el Señor, y si morimos, morimos para el Señor. Tanto en la vida como en la muerte pertenecemos al Señor."
,"9":"Por esta razón Cristo experimentó la muerte y la vida, para ser Señor de los muertos y de los que viven."
,"10":"Entonces tú, ¿por qué criticas a tu hermano? O ¿por qué lo desprecias? Todos hemos de comparecer ante el tribunal de Dios."
,"11":"Está escrito: Juro por mí mismo, palabra del Señor, que toda rodilla se doblará ante mí, y toda lengua confesará la verdad ante Dios."
,"12":"Quede bien claro que cada uno de nosotros dará cuenta a Dios de sí mismo."
,"13":"Dejemos, pues, de juzgarnos los unos a los otros. Examinémonos, más bien, no sea que pongamos delante de nuestro hermano algo que lo haga tropezar."
,"14":"Yo sé, y estoy seguro de ello en el Señor Jesús, que ninguna cosa es impura de por sí, pero sí lo es para quien la considera impura."
,"15":"Entonces, si tú ofendes a tu hermano con lo que comes, ya no vives según el amor. No vayas a destruir con tu dieta a aquel por quien murió Cristo."
,"16":"No den motivo de escándalo, aun cuando tengan la razón."
,"17":"Piensen que el Reino de Dios no es cuestión de comida o bebida, sino de justicia, de paz y alegría en el Espíritu Santo."
,"18":"Quien de esta forma sirve a Cristo, agrada a Dios y también es apreciado por los hombres."
,"19":"Busquemos, pues, lo que contribuye a la paz y nos hace crecer juntos."
,"20":"No destruyas la obra de Dios por cuestión de alimentos; si bien todos son puros, es malo comerlos cuando la conciencia te reprocha."
,"21":"Mejor es abstenerse de carne, vino o de cualquier otra cosa, si eso puede ser causa de tropiezo para tu hermano."
,"22":"Mantén tus propias convicciones ante Dios. Dichoso aquel a quien su conciencia no le reprocha su decisión."
,"23":"Pero si uno come cuando su conciencia se lo reprocha, se condena a sí mismo, pues su convicción era otra, y todo lo que uno hace en contra de su convicción es pecado."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Nosotros, si realmente somos fuertes, debemos cargar con la debilidad de quienes no tienen esa fuerza y no buscar nuestro propio agrado."
,"2":"Que cada uno busque lo que agrada a su prójimo, ayudándole a crecer en el bien."
,"3":"El mismo Cristo no hizo lo que le agradaba, como dice la Escritura: Los insultos de los que te insultaban cayeron sobre mí."
,"4":"Todas esas escrituras proféticas se escribieron para enseñanza nuestra, de modo que, perseverando y teniendo el consuelo de las Escrituras, no nos falte la esperanza."
,"5":"Que Dios, de quien procede toda perseverancia y consuelo, les conceda también a todos vivir en buen acuerdo, según el espíritu de Cristo Jesús."
,"6":"Entonces ustedes, con un mismo entusiasmo, alabarán a una sola voz a Dios, Padre de nuestro Señor Jesucristo."
,"7":"Acójanse unos a otros como Cristo los acogió para gloria de Dios."
,"8":"Entiéndanme: Cristo se puso al servicio del pueblo judío para cumplir las promesas hechas a sus padres, porque Dios es fiel."
,"9":"¿Y los otros pueblos? Esos darán gracias a Dios por su misericordia. Lo dice la Escritura: Por eso te bendeciré entre las naciones y alabaré tu Nombre."
,"10":"Y también: Alégrense, naciones paganas, junto con el pueblo de Dios."
,"11":"Y de nuevo: Canten al Señor todos los pueblos y alábenlo todas las naciones."
,"12":"A su vez Isaías dice: Cual renuevo en una raíz surgirá un descendiente de Jesé y se levantará para guiar las naciones. En él pondrán éstas su esperanza."
,"13":"Que el Dios de toda esperanza los colme de gozo y paz en el camino de la fe y haga crecer en ustedes la esperanza por el poder del Espíritu Santo."
,"14":"Personalmente estoy convencido, hermanos, de que también ustedes están llenos de buena voluntad, con un conocimiento auténtico, y que son capaces de instruirse mutuamente."
,"15":"Sin embargo, me atreví a hablarles con franqueza para recordarles algunas cosas. Lo hago con la autoridad que Dios me dio"
,"16":"cuando hizo de mí el encargado de Cristo Jesús entre las naciones paganas. He pasado a ser el sacerdote del Evangelio de Dios para hacer de esas naciones una ofrenda agradable a Dios, santificada por el Espíritu Santo."
,"17":"Por eso en las cosas de Dios tengo el orgullo que se puede tener en Cristo Jesús."
,"18":"Pero no me atrevería a hablar de otra cosa fuera de lo que Cristo ha hecho valiéndose de mí para que los paganos reciban la fe: mis palabras y mis obras,"
,"19":"con cantidad de milagros y prodigios, y el poder del Espíritu Santo. Desde Jerusalén hasta el Ilírico, por todas partes he esparcido la Buena Nueva de Cristo."
,"20":"Pero he tenido cuidado, y de esto me honro, de no predicar en lugares donde ya se conocía a Cristo, y de no aprovecharme de bases puestas por otros."
,"21":"Me guié por la Escritura: Lo verán aquellos a quienes no había sido anunciado, y lo conocerán los que nada habían oído."
,"22":"Ese trabajo me tenía tan ocupado que no pude llegar hasta ustedes."
,"23":"Pero como lo deseo desde hace varios años, y ahora ya no hay lugar para mí en esas regiones,"
,"24":"lo haré cuando vaya a España. Espero pasar por donde ustedes y verlos. Y cuando haya disfrutado plenamente de su compañía, me ayudarán a seguir viaje hacia allá."
,"25":"Ahora me dirijo a Jerusalén para asistir a esa comunidad,"
,"26":"pues en Macedonia y Acaya les pareció bien hacer una colecta en favor de los pobres de la comunidad de Jerusalén."
,"27":"Quisieron hacerlo, y de hecho estaban en deuda con ellos, pues si han participado de los bienes espirituales de los judíos, es justo que los sirvan en lo material."
,"28":"Cuando haya cumplido este encargo y entregado las ayudas recibidas, me dirigiré a España pasando por donde ustedes,"
,"29":"y sé muy bien que llegaré donde ustedes con toda la bendición de Cristo."
,"30":"Pero les ruego, hermanos, en nombre de Cristo Jesús nuestro Señor y del amor, fruto del Espíritu, que recen a Dios por mí. Luchen conmigo rogando por mí"
,"31":"para que pueda escapar de los enemigos de la fe en Judea y para que la comunidad reciba con agrado la ayuda que le llevo."
,"32":"Así llegaré con alegría donde ustedes y, si Dios quiere, descansaré en su compañía."
,"33":"El Dios de la paz esté con ustedes. Amén."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Les recomiendo a nuestra hermana Febe, diaconisa de la iglesia de Cencreas."
,"2":"Recíbanla bien, como debe hacerse entre cristianos y santos hermanos, y ayúdenla en todo lo que necesite, pues muchos están en deuda con ella, y yo también."
,"3":"Saluden a Prisca y a Aquila, colaboradores míos en Cristo Jesús,"
,"4":"que arriesgaron su vida para salvar la mía. Yo les estoy muy agradecido, y lo están también todas las Iglesias del mundo pagano."
,"5":"Saluden también a la Iglesia que se reúne en su casa. Saluden a mi querido Epéneto, el primer convertido cristiano en la provincia de Asia."
,"6":"Saluden a María, que ha hecho tanto por ustedes."
,"7":"Saluden a Andrónico y Junías, mis parientes y compañeros de cárcel. Son apóstoles muy conocidos y se entregaron a Cristo antes que yo."
,"8":"Saluden a Ampliato, a quien tanto quiero en el Señor."
,"9":"Saluden a Urbano, nuestro compañero de trabajo, y a mi querido amigo Estaquis."
,"10":"Saluden a Apeles, siempre firme en Cristo, y a la familia de Aristóbulo."
,"11":"Saluden a mi pariente Herodión y a los de la familia de Narciso que creen en el Señor."
,"12":"Saluden a Trifena y a Trifosa, que trabajan en la obra del Señor."
,"13":"Saluden a Rufo, elegido del Señor, y a su madre, que ha sido para mí como una segunda madre."
,"14":"Saluden a Asíncrito, a Flegón, a Hermes, a Patrobas, a Hermas y a los hermanos que están con ellos."
,"15":"Saluden a Filólogo y a Julia, a Nereo y a su hermana, a Olimpas y a todos los santos que están con ellos."
,"16":"Salúdense unos a otros con el beso santo. Todas las Iglesias de Cristo les mandan saludos."
,"17":"Hermanos, les ruego que tengan cuidado con esa gente que va provocando divisiones y dificultades, saliéndose de la doctrina que han aprendido. Aléjense de ellos."
,"18":"Esas personas no sirven a Cristo, nuestro Señor, sino a sus propios estómagos, engañando a los ingenuos con palabras bonitas y piadosas."
,"19":"Todos saben que ustedes están muy abiertos a la fe, y eso me alegra; pero quiero que sean ingeniosos para el bien y firmes contra el mal."
,"20":"El Dios de la paz aplastará pronto a Satanás y lo pondrá bajo sus pies. La gracia de Cristo Jesús, nuestro Señor, esté con ustedes."
,"21":"Timoteo, que está conmigo, les manda saludos, y también Lucio, Jasón y Sosípatro, parientes míos."
,"22":"Yo, Tercio, que he escrito esta carta, les saludo también en el Señor."
,"23":"Los saluda Gayo, que me ha dado alojamiento y que presta también su casa para las reuniones de la Iglesia."
,"24":"Los saludan Erasto, tesorero de la ciudad, y nuestro hermano Cuarto."
,"25":"¡Gloria sea dada al que tiene poder para afirmarlos en el Evangelio que anuncio y en la proclamación de Cristo Jesús!,Pues se está descubriendo el plan misterioso mantenido oculto desde tantos siglos, "
,"26":"y que acaba de ser llevado a la luz mediante los libros proféticos. Esta es decisión del Dios eterno, y todas las naciones tendrán que aceptar la fe."
,"27":"¡A Dios, el único sabio, por medio de Cristo Jesús, a él sea la gloria por siempre! Amén."
}`)

}
func ES_LBL_LoadNPTTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pablo, servidor de Dios, apóstol de Cristo Jesús para comunicar a los elegidos de Dios la fe y el conocimiento de la verdad que es parte de la religión..."
,"2":"Esperamos la vida eterna que nos había prometido desde siempre el Dios que no miente jamás."
,"3":"El habló con toda claridad en el tiempo fijado, y ése es el mensaje que me ha sido encargado por decisión de Dios, nuestro Salvador."
,"4":"Te saludo, Tito, verdadero hijo mío en la fe que compartimos: recibe gracia y paz de Dios Padre y de Cristo Jesús, nuestro Salvador."
,"5":"Te dejé en Creta para que solucionaras los problemas existentes y pusieras presbíteros en todas las ciudades, de acuerdo con mis instrucciones."
,"6":"Deben ser hombres intachables, casados una sola vez. Es preciso que sus hijos sean creyentes y que no puedan ser acusados de mala conducta o de ser rebeldes."
,"7":"Pues el supervisor (u obispo), siendo el encargado de la Casa de Dios, debe ser irreprensible: no debe ser autoritario ni de mal genio, ni bebedor, ni peleador o que busque dinero."
,"8":"Al contrario, que reciba con facilidad en su casa, que sea amigo del bien, hombre de buen juicio, justo, piadoso, dueño de sí mismo."
,"9":"Cuando habla, que esté apegado a lo que es seguro, de acuerdo con la doctrina, y sea capaz de predicar la sana doctrina y al mismo tiempo sepa rebatir a los que la atacan."
,"10":"Porque hay muchos espíritus rebeldes, charlatanes y engañadores, sobre todo entre los de origen judío."
,"11":"Hay que taparles la boca, pues enseñan en forma muy interesada cosas que no conviene y desconciertan a familias enteras."
,"12":"Fue precisamente uno de su raza, a quien ellos tienen por profeta, el que dijo: 'Cretenses, siempre mentirosos, malas bestias y vientres perezosos.'"
,"13":"Es la pura verdad. Por eso repréndelos con firmeza para mantenerlos en una fe sana"
,"14":"y que no hagan caso de las leyendas judías ni sigan las prácticas de gente que da la espalda a la verdad."
,"15":"Todo es limpio para los limpios, pero para los manchados que se niegan a creer, nada es limpio: hasta la mente y la conciencia la tienen corrompida."
,"16":"Pretenden conocer a Dios, pero lo niegan con su modo de actuar; son seres rebeldes que Dios no puede soportar y no sirven para ninguna obra buena."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Tus palabras deben fortalecer la sana doctrina."
,"2":"Los ancianos han de ser sobrios, respetables, juiciosos, maduros en su fe, caridad y perseverancia."
,"3":"Que las ancianas igualmente se porten como corresponde a santas mujeres; que no sean chismosas ni aficionadas al vino, sino más bien personas de buen consejo."
,"4":"Así enseñarán a las jóvenes a amar a su marido y a querer a sus hijos,"
,"5":"a ser juiciosas y puras, a cuidar bien de su hogar, a ser buenas y obedientes a sus maridos. De este modo nadie podrá hablar mal de nuestra fe."
,"6":"Invita también a los jóvenes a que sean responsables en todo."
,"7":"Tú mismo serás un ejemplo para ellos cuando vean tu conducta, tu enseñanza desinteresada, tu honradez,"
,"8":"tu predicación sana e intachable. Con esto los de fuera no encontrarán cosa alguna que criticar, y más bien se sentirán avergonzados."
,"9":"Los siervos, que se sometan a sus amos en forma habitual; que traten de complacerlos y no los contradigan."
,"10":"Que no roben a sus patrones, sino que se muestren dignos de toda confianza; así atraerán elogios sobre la doctrina de Dios, nuestro Salvador."
,"11":"Porque la generosidad del Dios Salvador acaba de manifestarse a todos los hombres;"
,"12":"nos enseña a rechazar la vida sin Dios y las codicias mundanas, y a vivir en el mundo presente como seres responsables, justos y que sirven a Dios."
,"13":"Ahora nos queda aguardar la feliz esperanza, la manifestación gloriosa de nuestro magnífico Dios y Salvador, Cristo Jesús,"
,"14":"que se entregó por nosotros para rescatarnos de todo pecado y purificar a un pueblo que fuese suyo, dedicado a toda obra buena."
,"15":"Tú enseña estas cosas, aconsejando y reprendiendo con toda autoridad. No dejes que nadie te menosprecie."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Recuerda a los creyentes que se sometan a los jefes y a las autoridades, que sepan obedecer y estén listos para todo lo que sirve."
,"2":"Que no insulten a nadie, que sean pacíficos y comprensivos y traten a todos con toda cortesía."
,"3":"Pues también nosotros fuimos de esos que no piensan y viven sin disciplina: andábamos descarriados, esclavos de nuestros deseos, buscando siempre el placer. Vivíamos en la malicia y la envidia, éramos insoportables y nos odiábamos unos a otros."
,"4":"Pero se manifestó la bondad de Dios, nuestro Salvador, y su amor a los hombres;"
,"5":"no se fijó en lo bueno que hubiéramos hecho, sino que tuvo misericordia de nosotros y nos salvó. En el bautismo volvimos a nacer y fuimos renovados por el Espíritu Santo "
,"6":"que Dios derramó sobre nosotros por Cristo Jesús, nuestro Salvador."
,"7":"Habiendo sido reformados por gracia, esperamos ahora nuestra herencia, la vida eterna."
,"8":"Una cosa es cierta, y en ella debes insistir: los que creen en Dios han de destacarse en el bien que puedan hacer. Ahí está lo bueno y lo que realmente aprovecha a la sociedad."
,"9":"Evita, en cambio, las cuestiones tontas, las genealogías, las discusiones y polémicas a propósito de la Ley; no son ni útiles ni importantes."
,"10":"Reprende al que deforma el mensaje. Después de dos advertencias romperás con él,"
,"11":"sabiendo que es un descarriado y culpable que se condena a sí mismo."
,"12":"Cuando te mande a Artemas o a Tíquico, date prisa en venir donde mí a Nicópolis, pues decidí pasar allí el invierno."
,"13":"Toma todas las medidas necesarias para el viaje del abogado Zenas y de Apolo, de modo que nada les falte."
,"14":"Y que los nuestros aprendan a moverse apenas se presente alguna necesidad, en vez de quedarse como unos inútiles."
,"15":"Te saludan todos los que están conmigo. Saluda a los que nos aman en la fe. La gracia sea con todos ustedes."
}`)

}
func ES_LBL_LoadNTAAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"En mi primer libro, querido Teófilo, hablé de todo lo que Jesús comenzó a hacer y enseñar."
,"2":"Al final del libro, Jesús, lleno del Espíritu Santo, daba instrucciones a los apóstoles que había elegido y era llevado al cielo."
,"3":"De hecho, se presentó a ellos después de su pasión y les dio numerosas pruebas de que vivía. Durante cuarenta días se dejó ver por ellos y les habló del Reino de Dios."
,"4":"En una ocasión en que estaba reunido con ellos les dijo que no se alejaran de Jerusalén y que esperaran lo que el Padre había prometido. 'Ya les hablé al respecto, les dijo:"
,"5":"Juan bautizó con agua, pero ustedes serán bautizados en el Espíritu Santo dentro de pocos días.'"
,"6":"Los que estaban presentes le preguntaron: 'Señor, ¿es ahora cuando vas a restablecer el Reino de Israel?'"
,"7":"Les respondió: 'No les corresponde a ustedes conocer los plazos y los pasos que solamente el Padre tenía autoridad para decidir."
,"8":"Pero recibirán la fuerza del Espíritu Santo cuando venga sobre ustedes, y serán mis testigos en Jerusalén, en toda Judea, en Samaría y hasta los extremos de la tierra.'"
,"9":"Dicho esto, Jesús fue levantado ante sus ojos y una nube lo ocultó de su vista."
,"10":"Ellos seguían mirando fijamente al cielo mientras se alejaba. Pero de repente vieron a su lado a dos hombres vestidos de blanco,"
,"11":"que les dijeron: 'Amigos galileos, ¿qué hacen ahí mirando al cielo? Este Jesús que les han llevado volverá de la misma manera que ustedes lo han visto ir al cielo.'"
,"12":"Entonces volvieron a Jerusalén desde el monte llamado de los Olivos, que dista de la ciudad como media hora de camino."
,"13":"Entraron en la ciudad y subieron a la habitación superior de la casa donde se alojaban. Allí estaban Pedro, Juan, Santiago y Andrés, Felipe y Tomás, Bartolomé y Mateo, Santiago, hijo de Alfeo, Simón el Zelotes, y Judas, hijo de Santiago."
,"14":"Todos ellos perseveraban juntos en la oración en compañía de algunas mujeres, de María, la madre de Jesús, y de sus hermanos."
,"15":"Uno de aquellos días, Pedro tomó la palabra en medio de ellos -había allí como ciento veinte personas- y les dijo:"
,"16":"'Hermanos, era necesario que se cumpliera la Escritura, pues el Espíritu Santo había anunciado por boca de David el gesto de Judas; este hombre, que guió a los que prendieron a Jesús,"
,"17":"era uno de nuestro grupo y había sido llamado a compartir nuestro ministerio común."
,"18":"-Sabemos que con el salario de su pecado se compró un campo, se tiró de cabeza, su cuerpo se reventó y se desparramaron sus entrañas."
,"19":"Este hecho fue conocido por todos los habitantes de Jerusalén, que llamaron a aquel campo, en su lengua, Hakeldamá, que significa: Campo de Sangre-."
,"20":"Esto estaba escrito en el libro de los Salmos: Que su morada quede desierta y que nadie habite en ella. Pero también está escrito: Que otro ocupe su cargo."
,"21":"Tenemos, pues, que escoger a un hombre de entre los que anduvieron con nosotros durante todo el tiempo en que el Señor Jesús actuó en medio de nosotros,"
,"22":"desde el bautismo de Juan hasta el día en que fue llevado de nuestro lado. Uno de ellos deberá ser, junto con nosotros, testigo de su resurrección.'"
,"23":"Presentaron a dos: a José, llamado Barsabás, por sobrenombre Justo, y a Matías."
,"24":"Entonces oraron así: 'Tú, Señor, conoces el corazón de todos. Múestranos a cuál de los dos has elegido"
,"25":"para ocupar este cargo y recibir este ministerio y apostolado del que Judas se retiró para ir al lugar que le correspondía.'"
,"26":"Echaron a suertes entre ellos y le tocó a Matías, que fue agregado a los once apóstoles."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Cuando llegó el día de Pentecostés, estaban todos reunidos en el mismo lugar."
,"2":"De repente vino del cielo un ruido, como el de una violenta ráfaga de viento, que llenó toda la casa donde estaban,"
,"3":"y aparecieron unas lenguas como de fuego que se repartieron y fueron posándose sobre cada uno de ellos."
,"4":"Todos quedaron llenos del Espíritu Santo y comenzaron a hablar en otras lenguas, según el Espíritu les concedía que se expresaran."
,"5":"Estaban de paso en Jerusalén judíos piadosos, llegados de todas las naciones que hay bajo el cielo."
,"6":"Y entre el gentío que acudió al oír aquel ruido, cada uno los oía hablar en su propia lengua. Todos quedaron muy desconcertados"
,"7":"y se decían, llenos de estupor y admiración: 'Pero éstos ¿no son todos galileos? ¡Y miren cómo hablan!"
,"8":"Cada uno de nosotros les oímos en nuestra propia lengua nativa."
,"9":"Entre nosotros hay partos, medos y elamitas, habitantes de Mesopotamia, Judea, Capadocia, del Ponto y Asia,"
,"10":"de Frigia, Panfilia, Egipto y de la parte de Libia que limita con Cirene. Hay forasteros que vienen de Roma, unos judíos y otros extranjeros, que aceptaron sus creencias,"
,"11":"cretenses y árabes. Y todos les oímos hablar en nuestras propias lenguas las maravillas de Dios.'"
,"12":"Todos estaban asombrados y perplejos, y se preguntaban unos a otros qué querría significar todo aquello."
,"13":"Pero algunos se reían y decían: '¡Están borrachos!'"
,"14":"Entonces Pedro, con los Once a su lado, se puso de Pie, alzó la voz y se dirigió a ellos diciendo: 'Amigos judíos y todos los que se encuentran en Jerusalén, escúchenme, pues tengo algo que enseñarles."
,"15":"No se les ocurra pensar que estamos borrachos, pues son apenas las nueve de la mañana,"
,"16":"sino que se está cumpliendo lo que anunció el profeta Joel:"
,"17":"Escuchen lo que sucederá en los últimos días, dice Dios: derramaré mi Espíritu sobre cualesquiera que sean los mortales. Sus hijos e hijas profetizarán, los jóvenes tendrán visiones y los ancianos tendrán sueños proféticos."
,"18":"En aquellos días derramaré mi Espíritu sobre mis siervos y mis siervas, que profetizarán."
,"19":"Haré prodigios arriba en el cielo y señales milagrosas abajo en la tierra."
,"20":"El sol se convertirá en tinieblas y la luna en sangre antes de que llegue el Día grande del Señor."
,"21":"Y todo el que invoque el Nombre del Señor se salvará."
,"22":"Israelitas, escuchen mis palabras: Dios acreditó entre ustedes a Jesús de Nazaret. Hizo que realizara entre ustedes milagros, prodigios y señales que ya conocen."
,"23":"Ustedes, sin embargo, lo entregaron a los paganos para ser crucificado y morir en la cruz, y con esto se cumplió el plan que Dios tenía dispuesto."
,"24":"Pero Dios lo libró de los dolores de la muerte y lo resucitó, pues no era posible que quedase bajo el poder de la muerte."
,"25":"Escuchen lo que David decía a su respecto: Veo constantemente al Señor delante de mí; está a mi derecha para que no vacile."
,"26":"Por eso se alegra mi corazón y te alabo muy gozoso, y hasta mi cuerpo esperará en paz."
,"27":"Porque no me abandonarás en el lugar de los muertos ni permitirás que tu Santo experimente la corrupción."
,"28":"Me has dado a conocer los caminos de la vida, me colmarás de gozo con tu presencia."
,"29":"Hermanos, no voy a demostrarles que el patriarca David murió y fue sepultado: su tumba se encuentra entre nosotros hasta el día de hoy."
,"30":"Pero era profeta y Dios le había jurado que uno de sus descendientes se sentaría sobre su trono. Sabiéndolo,"
,"31":"se refería a la resurrección del Mesías, viéndola de antemano, con estas palabras: no será abandonado en el lugar de los muertos, ni su cuerpo experimentará la corrupción."
,"32":"Y es un hecho que Dios resucitó a Jesús; de esto todos nosotros somos testigos."
,"33":"Después de haber sido exaltado a la derecha de Dios, ha recibido del Padre el don que había prometido, me refiero al Espíritu Santo que acaba de derramar sobre nosotros, como ustedes están viendo y oyendo."
,"34":"También es cierto que David no subió al cielo, pero estas palabras son suyas: Dijo el Señor a mi Señor: 'Siéntate a mi derecha,"
,"35":"hasta que ponga a tus enemigos debajo de tus pies.'"
,"36":"Sepa entonces con seguridad toda la gente de Israel, que Dios ha hecho Señor y Cristo a este Jesús a quien ustedes crucificaron.'"
,"37":"Al oír esto se afligieron profundamente y dijeron a Pedro y a los demás apóstoles: '¿Qué tenemos que hacer, hermanos?'"
,"38":"Pedro les contestó: 'Arrepiéntanse, y que cada uno de ustedes se haga bautizar en el Nombre de Jesús, el Mesías, para que sus pecados sean perdonados. Entonces recibirán el don del Espíritu Santo."
,"39":"Porque el don de Dios es para ustedes y para sus hijos, y también para todos aquellos a los que el Señor, nuestro Dios, quiera llamar, aun cuando se hayan alejado.'"
,"40":"Pedro siguió insistiendo con muchos otros discursos. Los exhortaba diciendo: 'Aléjense de esta generación perversa y sálvense.'"
,"41":"Los que acogieron la palabra de Pedro se bautizaron, y aquel día se unieron a ellos unas tres mil personas."
,"42":"Acudían asiduamente a la enseñanza de los apóstoles, a la convivencia, a la fracción del pan y a las oraciones."
,"43":"Toda la gente sentía un santo temor, ya que los prodigios y señales milagrosas se multiplicaban por medio de los apóstoles."
,"44":"Todos los que habían creído vivían unidos; compartían todo cuanto tenían,"
,"45":"vendían sus bienes y propiedades y repartían después el dinero entre todos según las necesidades de cada uno."
,"46":"Todos los días se reunían en el Templo con entusiasmo, partían el pan en sus casas y compartían sus comidas con alegría y con gran sencillez de corazón."
,"47":"Alababan a Dios y se ganaban la simpatía de todo el pueblo; y el Señor agregaba cada día a la comunidad a los que quería salvar."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Un día, cuando Pedro y Juan subían al Templo para la oración de las tres de la tarde,"
,"2":"acababan de dejar allí a un tullido de nacimiento. Todos los días lo colocaban junto a la Puerta Hermosa, que es una de las puertas del Templo, para que pidiera limosna a los que entraban en el recinto."
,"3":"Cuando Pedro y Juan estaban para entrar en el Templo, el hombre les pidió una limosna."
,"4":"Pedro, con Juan a su lado, fijó en él su mirada, y le dijo: 'Míranos.'"
,"5":"El hombre los miró, esperando recibir algo."
,"6":"Pero Pedro le dijo: 'No tengo oro ni plata, pero te doy lo que tengo: En nombre del Mesías Jesús, el Nazareno, camina.'"
,"7":"Y tomándolo de la mano derecha, lo levantó."
,"8":"Inmediatamente tomaron fuerza sus tobillos y sus pies, y de un salto se puso en Pie y empezó a caminar. Luego entró caminando con ellos en el recinto del Templo, saltando y alabando a Dios."
,"9":"Todo el pueblo lo vio caminar y alabar a Dios,"
,"10":"y lo reconocieron: '¡Es el tullido que pedía limosna junto a la Puerta Hermosa!'. Y quedaron sin palabras, asombrados por lo que había sucedido."
,"11":"El hombre sanado no se separaba de Pedro y Juan, por lo que toda la gente, fuera de sí, acudió y se reunió alrededor de ellos en el pórtico llamado de Salomón."
,"12":"Al ver esto, Pedro se dirigió al pueblo y les dijo: 'Israelitas, ¿por qué se quedan tan maravillados? Ustedes nos miran como si hubiéramos hecho caminar a este hombre por nuestro propio poder o por ser unos santos. "
,"13":"Pero no; es el Dios de Abraham, de Isaac y de Jacob, el Dios de nuestros padres, el que acaba de glorificar a su siervo Jesús. Ustedes lo entregaron y, cuando Pilato decidió dejarlo en libertad, renegaron de él."
,"14":"Ustedes pidieron la libertad de un asesino y rechazaron al Santo y al Justo."
,"15":"Mataron al Señor de la vida, pero Dios lo resucitó de entre los muertos, y nosotros somos testigos de ello."
,"16":"Miren lo que puede la fe en su Nombre, pues en su Nombre acaba de ser restablecido este hermano al que ustedes ven y conocen. La fe que él nos inspira es la que lo ha sanado totalmente en presencia de todos ustedes."
,"17":"Yo sé, hermanos, que ustedes obraron por ignorancia, al igual que sus jefes,"
,"18":"y Dios cumplió de esta manera lo que había dicho de antemano por boca de todos los profetas: que su Mesías tendría que padecer."
,"19":"Arrepiéntanse, pues, y conviértanse, para que sean borrados sus pecados. Así el Señor hará llegar el tiempo del alivio,"
,"20":"enviándoles al Mesías que les ha sido destinado, que es Jesús."
,"21":"Pues el cielo debe guardarlo hasta que llegue el tiempo de la restauración del universo, según habló Dios en los tiempos pasados por boca de los santos profetas."
,"22":"Moisés afirmó: El Señor Dios hará que un profeta como yo surja de entre sus hermanos. Escuchen todo lo que les diga."
,"23":"El que no escuche a ese profeta será eliminado del pueblo."
,"24":"Y después todos los profetas, empezando por Samuel, anunciaron estos días."
,"25":"Ustedes son los hijos de los profetas y los herederos de la alianza que Dios pactó con nuestros padres, al decir a Abrahán: A través de tu descendencia serán bendecidas todas las familias de la tierra."
,"26":"Por ustedes, en primer lugar, Dios ha resucitado a su Siervo y lo ha enviado para bendecirles, con tal que cada uno renuncie a su mala vida.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Pedro y Juan estaban aún hablando al pueblo, cuando se presentaron los sacerdotes, el jefe de la guardia del Templo y los saduceos;"
,"2":"toda esa gente se sentía muy molesta porque enseñaban al pueblo y afirmaban la resurrección de los muertos a propósito de Jesús."
,"3":"Los apresaron y los pusieron bajo custodia hasta el día siguiente, pues ya estaba anocheciendo."
,"4":"Pero muchos de los que habían oído la Palabra creyeron, y su número llegó a unos cinco mil hombres."
,"5":"Al día siguiente, los jefes de los saduceos se reunieron con los ancianos y los maestros de la Ley de Jerusalén."
,"6":"Allí estaban el sumo sacerdote Anás, Caifás, Jonatán, Alejandro y todos los que pertenecían a la alta clase sacerdotal."
,"7":"Mandaron traer a Pedro y Juan ante ellos y empezaron a interrogarles: '¿Con qué poder han hecho ustedes eso? ¿A qué ser celestial han invocado?'"
,"8":"Entonces Pedro, lleno del Espíritu Santo, les dijo: 'Jefes del pueblo y Ancianos:"
,"9":"Hoy debemos responder por el bien que hemos hecho a un enfermo. ¿A quién se debe esa sanación?"
,"10":"Sépanlo todos ustedes y todo el pueblo de Israel: este hombre que está aquí sano delante de ustedes ha sido sanado por el Nombre de Jesucristo el Nazareno, a quien ustedes crucificaron, pero a quien Dios ha resucitado de entre los muertos."
,"11":"El es la piedra que ustedes los constructores despreciaron y que se ha convertido en piedra angular."
,"12":"No hay salvación en ningún otro, pues bajo el cielo no se ha dado a los hombres ningún otro Nombre por el que debamos ser salvados.'"
,"13":"Quedaron admirados al ver la seguridad con que hablaban Pedro y Juan, que eran hombres sin instrucción ni preparación, pero sabían que habían estado con Jesús."
,"14":"Los jefes veían al hombre que había sido sanado allí, de Pie a su lado, de modo que nada podían decir contra ellos."
,"15":"Mandaron, pues, que los hicieran salir del tribunal mientras deliberaban entre ellos. Decían:"
,"16":"'¿Qué vamos a hacer con estos hombres? Todos los habitantes de Jerusalén saben que han hecho un milagro clarísimo, y nosotros no podemos negarlo."
,"17":"Pero prohibámosles que hablen más de ese Nombre ante ninguna persona, no sea que esto se extienda entre el pueblo.'"
,"18":"Llamaron, pues, a los apóstoles y les ordenaron que de ningún modo enseñaran en el nombre de Jesús, que ni siquiera lo nombraran."
,"19":"Pedro y Juan les respondieron: 'Juzguen ustedes si es correcto delante de Dios que les hagamos caso a ustedes, en vez de obecedecer a Dios."
,"20":"Nosotros no podemos dejar de hablar de lo que hemos visto y oído.'"
,"21":"Insistieron ellos en sus amenazas y los dejaron en libertad. No encontraron manera de castigarlos a causa del pueblo,"
,"22":"pues todos glorificaban a Dios por lo que había sucedido, sabiéndose además que el hombre milagrosamente sanado tenía más de cuarenta años."
,"23":"Apenas quedaron libres, Pedro y Juan fueron a los suyos y les contaron todo lo que les habían dicho los jefes de los sacerdotes y los ancianos."
,"24":"Los escucharon, y después todos a una elevaron su voz a Dios, diciendo: 'Señor, tú hiciste el cielo, la tierra, el mar y todo lo que hay en ellos."
,"25":"Tú, por el Espíritu Santo, pusiste en boca de tu siervo David estas palabras: ¿Por qué se agitan las naciones y los pueblos traman planes vanos?"
,"26":"Se han aliado los reyes de la tierra y los príncipes se han unido contra el Señor y contra su Mesías."
,"27":"Es verdad que en esta ciudad hubo una conspiración de Herodes con Poncio Pilato, los paganos y el pueblo de Israel contra tu santo siervo Jesús, a quien tú ungiste."
,"28":"Pero solamente consiguieron lo que tú habías decidido y llevabas a efecto."
,"29":"Y ahora, Señor, fíjate en sus amenazas; concede a tus siervos anunciar tu Palabra con toda valentía,"
,"30":"mientras tú manifiestas tu poder y das grandes golpes, realizando curaciones, señales y prodigios por el Nombre de tu santo siervo Jesús.'"
,"31":"Terminada la oración, tembló el lugar donde estaban reunidos. Todos quedaron llenos del Espíritu Santo y se pusieron a anunciar con valentía la Palabra de Dios."
,"32":"La multitud de los fieles tenía un solo corazón y una sola alma. Nadie consideraba como propios sus bienes, sino que todo lo tenían en común."
,"33":"Los apóstoles daban testimonio de la resurrección del Señor Jesús con gran poder, y aquél era para todos un tiempo de gracia excepcional."
,"34":"Entre ellos ninguno sufría necesidad, pues los que poseían campos o casas los vendían, traían el dinero"
,"35":"y lo depositaban a los pies de los apóstoles, que lo repartían según las necesidades de cada uno."
,"36":"Así lo hizo José, un levita nacido en Chipre, a quien los apóstoles llamaban Bernabé (que quiere decir: 'El Animador')."
,"37":"Éste vendió un campo de su propiedad, trajo el dinero de la venta y lo puso a los pies de los apóstoles."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Otro hombre llamado Ananías, de acuerdo con su esposa Safira, vendió también una propiedad,"
,"2":"pero se guardó una parte del dinero, siempre de acuerdo con su esposa; la otra parte la llevó y la entregó a los apóstoles."
,"3":"Pedro le dijo: 'Ananías, ¿por qué has dejado que Satanás se apoderara de tu corazón? Te has guardado una parte del dinero; ¿por qué intentas engañar al Espíritu Santo?"
,"4":"Podías guardar tu propiedad y, si la vendías, podías también quedarte con todo. ¿Por qué has hecho eso? No has mentido a los hombres, sino a Dios.'"
,"5":"Al oír Ananías estas palabras, se desplomó y murió. Un gran temor se apoderó de cuantos lo oyeron."
,"6":"Se levantaron los jóvenes, envolvieron su cuerpo y lo llevaron a enterrar."
,"7":"Unas tres horas más tarde llegó la esposa de Ananías, que no sabía nada de lo ocurrido."
,"8":"Pedro le preguntó: '¿Es cierto que vendieron el campo en tal precio?' Ella respondió: 'Sí, ese fue el precio.'"
,"9":"Y Pedro le replicó: '¿Se pusieron, entonces, de acuerdo para desafiar al Espíritu del Señor? Ya están a la puerta los que acaban de enterrar a tu marido y te van a llevar también a ti.'"
,"10":"Y al instante Safira se desplomó a sus pies y murió. Cuando entraron los jóvenes la hallaron muerta y la llevaron a enterrar junto a su marido."
,"11":"A consecuencia de esto un gran temor se apoderó de toda la Iglesia y de todos cuantos oyeron hablar del hecho."
,"12":"Por obra de los apóstoles se producían en el pueblo muchas señales milagrosas y prodigios. Los creyentes se reunían de común acuerdo en el pórtico de Salomón,"
,"13":"y nadie de los otros se atrevía a unirse a ellos, pero el pueblo los tenía en gran estima."
,"14":"Más aún, cantidad de hombres y mujeres llegaban a creer en el Señor, aumentando así su número."
,"15":"La gente incluso sacaba a los enfermos a las calles y los colocaba en camas y camillas por donde iba a pasar Pedro, para que por lo menos su sombra cubriera a alguno de ellos."
,"16":"Acudían multitudes de las ciudades vecinas a Jerusalén trayendo a sus enfermos y a personas atormentadas por espíritus malos, y todos eran sanados."
,"17":"El sumo sacerdote y toda su gente, que eran el partido de los saduceos, decidieron actuar en la forma más enérgica."
,"18":"Apresaron a los apóstoles y los metieron en la cárcel pública."
,"19":"Pero un ángel del Señor les abrió las puertas de la cárcel durante la noche y los sacó fuera, diciéndoles:"
,"20":"'Vayan, hablen en el Templo y anuncien al pueblo el mensaje de vida.'"
,"21":"Entraron, pues, en el Templo al amanecer, y se pusieron a enseñar. Mientras tanto el sumo sacerdote y sus partidarios reunieron al Sanedrín con todos los ancianos de Israel y enviaron a buscar a los prisioneros a la cárcel. "
,"22":"Pero cuando llegaron los guardias no los encontraron en la cárcel. Volvieron a dar la noticia y les dijeron:"
,"23":"'Hemos encontrado la cárcel perfectamente cerrada y a los centinelas fuera, en sus puestos, pero al abrir las puertas no hemos encontrado a nadie dentro.'"
,"24":"El jefe de la policía del Templo y los jefes de los sacerdotes quedaron desconcertados al oír esto y se preguntaban qué podía haber sucedido."
,"25":"En esto llegó uno que les dijo: 'Los hombres que ustedes encarcelaron están ahora en el Templo enseñando al pueblo.'"
,"26":"El jefe de la guardia fue con sus ayudantes y los trajeron, pero sin violencia, porque tenían miedo de ser apedreados por el pueblo."
,"27":"Los trajeron y los presentaron ante el Consejo. El sumo sacerdote los interrogó diciendo:"
,"28":"'Les habíamos advertido y prohibido enseñar en nombre de ése. Pero ahora en Jerusalén no se oye más que su predicación, y quieren echarnos la culpa por la muerte de ese hombre.'"
,"29":"Pedro y los apóstoles respondieron: 'Hay que obedecer a Dios antes que a los hombres."
,"30":"El Dios de nuestros padres resucitó a Jesús, a quien ustedes dieron muerte colgándolo de un madero."
,"31":"Dios lo exaltó y lo puso a su derecha como Jefe y Salvador, para dar a Israel la conversión y el perdón de los pecados."
,"32":"Nosotros somos testigos de esto y lo es también el Espíritu Santo, que Dios ha dado a los que le obedecen.'"
,"33":"Ellos escuchaban rechinando los dientes de rabia y querían matarlos."
,"34":"Entonces se levantó uno de ellos, un fariseo llamado Gamaliel, que era doctor de la Ley y persona muy estimada por todo el pueblo. Mandó que hicieran salir a aquellos hombres durante unos minutos"
,"35":"y empezó a hablar así al Consejo: 'Colegas israelitas, no actúen a la ligera con estos hombres. "
,"36":"Recuerden que tiempo atrás se presentó un tal Teudas, que pretendía ser un gran personaje y al que se le unieron unos cuatrocientos hombres. Más tarde pereció, sus seguidores se dispersaron y todo quedó en nada."
,"37":"Tiempo después, en la época del censo, surgió Judas el Galileo, que arrastró al pueblo en pos de sí. Pero también éste pereció y todos sus seguidores se dispersaron."
,"38":"Por eso les aconsejo ahora que se olviden de esos hombres y los dejen en paz. Si su proyecto o su actividad es cosa de hombres, se vendrán abajo."
,"39":"Pero si viene de Dios, ustedes no podrán destruirlos, y ojalá no estén luchando contra Dios.',El Consejo le escuchó "
,"40":"y mandaron entrar de nuevo a los apóstoles. Los hicieron azotar y les ordenaron severamente que no volviesen a hablar de Jesús Salvador. Después los dejaron ir."
,"41":"Los apóstoles salieron del Consejo muy contentos por haber sido considerados dignos de sufrir por el Nombre de Jesús."
,"42":"Y durante todo el día no cesaban de enseñar y proclamar a Jesús, el Mesías, en el Templo y por las casas."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Por aquellos días, como el número de los discípulos iba en aumento, hubo quejas de los llamados helenistas contra los llamados hebreos, porque según ellos sus viudas eran tratadas con negligencia en la atención de cada día."
,"2":"Los Doce reunieron la asamblea de los discípulos y les dijeron: 'No es correcto que nosotros descuidemos la Palabra de Dios por hacernos cargo de las mesas."
,"3":"Por lo tanto, hermanos, elijan entre ustedes a siete hombres de buena fama, llenos del Espíritu y de sabiduría; les confiaremos esta tarea"
,"4":"mientras que nosotros nos dedicaremos de lleno a la oración y al ministerio de la Palabra.'"
,"5":"Toda la asamblea estuvo de acuerdo y eligieron a Esteban, hombre lleno de fe y Espíritu Santo, a Felipe, Prócoro, Nicanor, Timón, Pármenas y Nicolás, que era un prosélito de Antioquía."
,"6":"Los presentaron a los apóstoles, quienes se pusieron en oración y les impusieron las manos."
,"7":"La Palabra de Dios se difundía; el número de los discípulos en Jerusalén aumentaba considerablemente, e incluso un buen grupo de sacerdotes había aceptado la fe."
,"8":"Esteban, hombre lleno de gracia y de poder, realizaba grandes prodigios y señales milagrosas en medio del pueblo."
,"9":"Se le echaron encima algunos de la sinagoga llamada de los libertos y otros llegados de Cirene, Alejandría, Cilicia y Asia. Se pusieron a discutir con Esteban,"
,"10":"pero no lograban hacer frente a la sabiduría y al Espíritu con que hablaba."
,"11":"Al no poder resistir a la verdad, sobornaron a unos hombres para que afirmaran: 'Hemos oído hablar a este hombre contra Moisés y contra Dios.'"
,"12":"Con esto alborotaron el pueblo, a los ancianos y a los maestros de la Ley; llegaron de improviso, lo arrestaron y lo llevaron ante el Sanedrín."
,"13":"Allí se presentaron testigos falsos que declararon: 'Este hombre no cesa de hablar contra nuestro Lugar Santo y contra la Ley."
,"14":"Le hemos oído decir que Jesús el Nazareno destruirá este Lugar Santo y cambiará las costumbres que nos dejó Moisés.'"
,"15":"En ese momento todos los que estaban sentados en el Sanedrín fijaron los ojos en Esteban, y su rostro les pareció como el de un ángel."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Entonces el sumo sacerdote le preguntó: '¿Es verdad lo que dicen?'"
,"2":"Esteban respondió: 'Hermanos y padres, escúchenme: El Dios glorioso se apareció a nuestro padre Abrahán mientras estaba en Mesopotamia, antes de que fuera a vivir a Jarán, "
,"3":"y le dijo: 'Deja tu país y tu parentela y vete al país que te indicaré.'"
,"4":"Entonces abandonó el país de los caldeos y se estableció en Jarán. Después de la muerte de su padre, Dios hizo que se trasladara a este país en que ustedes habitan ahora. "
,"5":"Y no le dio en él propiedad alguna, ni siquiera un pedacito de tierra donde poner el Pie, sino que le prometió dárselo en posesión a él y a su descendencia después de él. Se lo dijo a pesar de que no tenía hijos."
,"6":"Dios le habló así: 'Tus descendientes vivirán en tierra extranjera y serán esclavizados y maltratados durante cuatrocientos años."
,"7":"Pero yo pediré cuentas a la nación a la que sirvan como esclavos. Después saldrán y me darán culto en este lugar."
,"8":"Luego hizo con él el pacto de la circuncisión. Y así, al nacer su hijo Isaac, Abrahán lo circuncidó al octavo día. Lo mismo hizo Isaac con Jacob, y Jacob con los doce patriarcas."
,"9":"Los patriarcas se pusieron celosos de José, hasta que lo vendieron, y fue llevado a Egipto. Pero Dios estaba con él"
,"10":"y lo libró de todas sus tribulaciones; le concedió sabiduría y lo hizo grato a los ojos de Faraón, rey de Egipto, que lo nombró gobernador de Egipto y de toda su casa."
,"11":"Sobrevino el hambre por toda la tierra de Egipto y de Canaán, y la miseria fue tan enorme que nuestros padres no encontraban qué comer."
,"12":"Al enterarse Jacob de que había trigo en Egipto, mandó allí a nuestros padres una primera vez."
,"13":"La segunda vez José se dio a conocer a sus hermanos y así Faraón conoció a la raza de José."
,"14":"Luego José mandó buscar a su padre Jacob con toda su familia, que se componía de setenta y cinco personas."
,"15":"Jacob entonces bajó a Egipto, donde murió él, y más tarde también nuestros padres."
,"16":"Sus cuerpos fueron llevados a Siquem y descansan en la tumba que Abrahán había comprado en Siquem a los hijos de Hamor por cierta suma de plata."
,"17":"Ya se iba acercando el tiempo de la promesa que Dios había hecho a Abrahán; el pueblo creció y se multiplicó en Egipto,"
,"18":"hasta que llegó otro rey a Egipto que no había conocido a José."
,"19":"Este rey, actuando con astucia contra nuestra raza, obligó a nuestros padres a que abandonaran a sus hijos recién nacidos para que no tuvieran más familia."
,"20":"Fue en ese tiempo cuando nació Moisés, al que Dios amaba. Durante tres meses fue criado en la casa de su padre,"
,"21":"y cuando tuvieron que abandonarlo, la hija de Faraón lo recogió y lo crió como hijo suyo."
,"22":"Así Moisés fue educado en toda la sabiduría de los egipcios,"
,"23":"y llegó a ser poderoso en sus palabras y en sus obras. Tenía cuarenta años cumplidos cuando sintió deseos de visitar a sus hermanos, los israelitas. "
,"24":"Al ver cómo uno de ellos era maltratado, salió en defensa del oprimido y mató al egipcio."
,"25":"¿Comprenderían sus hermanos que Dios lo enviaba a ellos como un libertador? Moisés lo creía, pero ellos no lo entendieron."
,"26":"Al día siguiente vio a dos israelitas que se estaban peleando y trató de pacificarlos, diciéndoles: 'Ustedes son hermanos, ¿por qué se hacen daño el uno al otro?'"
,"27":"Pero el que maltrataba a su compañero lo rechazó diciendo:"
,"28":"'¿Quién te ha nombrado jefe y juez sobre nosotros? ¿Quieres matarme a mí como hiciste ayer con el egipcio?'"
,"29":"Al oír esto Moisés huyó y fue a vivir en la tierra de Madián, donde tuvo dos hijos."
,"30":"Pasados cuarenta años se le apareció un ángel en el desierto del monte Sinaí en la llama de una zarza que ardía."
,"31":"Moisés quedó perplejo ante esta visión y, al acercarse para mirar, oyó la voz del Señor:"
,"32":"'Yo soy el Dios de tus padres, el Dios de Abrahán, de Isaac y de Jacob.' Moisés sintió tanto miedo que no se atrevía ni a mirar."
,"33":"Pero el Señor le dijo: 'Quítate las sandalias, porque el lugar que estás pisando es tierra santa."
,"34":"He visto cómo maltratan a mi pueblo en Egipto, he oído su llanto y he bajado para liberarlo. Y ahora ven, que te voy a enviar a Egipto.'"
,"35":"A este Moisés, al que rechazaron diciendo: '¿Quién te nombró jefe y juez?', Dios lo envió como jefe y libertador, con la asistencia del ángel que se le apareció en la zarza."
,"36":"Y los hizo salir de aquel país, realizando prodigios y señales en Egipto, en el mar Rojo y en el desierto durante cuarenta años."
,"37":"Este Moisés es el que dijo a los israelitas: 'Dios les dará un profeta como yo de entre sus hermanos.'"
,"38":"Este es el que estaba con nuestros padres en la asamblea del desierto, con el ángel que le hablaba en el monte Sinaí, y el que recibió las palabras de vida para comunicárselas a ustedes."
,"39":"Nuestros padres no quisieron obedecerle, lo rechazaron y pensaron volverse a Egipto."
,"40":"Incluso dijeron a Aarón: 'Danos dioses que vayan delante de nosotros, porque no sabemos qué ha sido de este Moisés que nos sacó de Egipto.'"
,"41":"Y fabricaron en aquellos días un becerro, ofrecieron sacrificios al ídolo y festejaron la obra de sus manos."
,"42":"Entonces Dios se apartó de ellos y dejó que adoraran a los astros del cielo, como está escrito en el Libro de los Profetas: '¿Acaso me ofrecieron ustedes víctimas y sacrificios durante cuarenta años en el desierto?"
,"43":"Más bien llevaban con ustedes la tienda de Moloc y la estrella del dios Refán, imágenes que ustedes mismos se fabricaron para adorarlas. Por eso yo los desterraré más allá de Babilonia.'"
,"44":"Nuestros padres tenían en el desierto la Tienda del Testimonio; el que hablaba a Moisés le había ordenado que la fabricara según el modelo que había visto."
,"45":"Después de recibirla, nuestros padres la introdujeron, al mando de Josué, en la tierra conquistada a los paganos, a quienes Dios expulsó delante de ellos. Esto duró hasta los días de David."
,"46":"David agradó a Dios y quiso darle un lugar donde descansara entre los hijos de Jacob."
,"47":"De hecho fue Salomón quien le edificó un templo."
,"48":"En realidad, el Altísimo no vive en casas fabricadas por manos de hombres, como dice el Profeta:"
,"49":"El cielo es mi trono y la tierra el apoyo de mis pies. ¿Qué casa me podrían edificar?, dice el Señor. ¿Cuál sería el lugar de mi descanso?"
,"50":"¿No fui yo quien hizo todas estas cosas?"
,"51":"Ustedes son un pueblo de cabeza dura, y la circuncisión no les abrió el corazón ni los oídos. Ustedes siempre resisten al Espíritu Santo, al igual que sus padres."
,"52":"¿Hubo algún profeta que sus padres no hayan perseguido? Ellos mataron a los que anunciaban la venida del Justo, y ustedes ahora lo han entregado y asesinado;"
,"53":"ustedes, que recibieron la Ley por medio de ángeles, pero que no la han cumplido.'"
,"54":"Al oír este reproche se enfurecieron y rechinaban los dientes de rabia contra Esteban."
,"55":"Pero él, lleno del Espíritu Santo, fijó sus ojos en el cielo y vio la gloria de Dios y a Jesús a su derecha,"
,"56":"y exclamó: 'Veo los cielos abiertos y al Hijo del Hombre a la derecha de Dios.'"
,"57":"Entonces empezaron a gritar, se taparon los oídos y todos a una se lanzaron contra él. Lo empujaron fuera de la ciudad y empezaron a tirarle piedras."
,"58":"Los testigos habían dejado sus ropas a los pies de un joven llamado Saulo."
,"59":"Mientras era apedreado, Esteban oraba así: 'Señor Jesús, recibe mi espíritu.'"
,"60":"Después se arrodilló y dijo con fuerte voz: 'Señor, no les tomes en cuenta este pecado.' Y dicho esto, se durmió en el Señor."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Saulo estaba allí y aprobaba el asesinato. Este fue el comienzo de una gran persecución contra la Iglesia de Jerusalén. Todos, excepto los apóstoles, se dispersaron por las regiones de Judea y Samaría."
,"2":"Unos hombres piadosos enterraron a Esteban e hicieron un gran duelo por él."
,"3":"Saulo, por su parte, trataba de destruir a la Iglesia. Entraba casa por casa, hacía salir a hombres y mujeres y los metía en la cárcel."
,"4":"Mientras tanto, los que se habían dispersado anunciaban la Palabra en los lugares por donde pasaban."
,"5":"Así Felipe anunció a Cristo a los samaritanos en una de sus ciudades adonde había bajado."
,"6":"Al escuchar a Felipe y ver los prodigios que realizaba, toda la población se interesó por su predicación."
,"7":"Pues espíritus malos salían de los endemoniados dando gritos, y varios paralíticos y cojos quedaron sanos."
,"8":"Hubo, pues, gran alegría en aquella ciudad."
,"9":"Había llegado a aquella ciudad antes que Felipe un hombre llamado Simón. Tenía muy impresionada a la gente de Samaría con sus artes mágicas y se hacía pasar por un gran personaje."
,"10":"Todos estaban pendientes de él, pequeños y grandes, y decían: 'Este es el poder de Dios', pues se hablaba de un tal 'gran poder de Dios'."
,"11":"Desde hacía tiempo los tenía alucinados con sus artes mágicas, y la gente lo seguía."
,"12":"Pero cuando Felipe les habló del Reino de Dios y del poder salvador de Jesús, el Mesías, tanto los hombres como las mujeres creyeron y empezaron a bautizarse."
,"13":"Incluso Simón creyó y se hizo bautizar. No se separaba de Felipe, y no salía de su asombro al ver las señales milagrosas y los prodigios que se realizaban."
,"14":"Cuando los apóstoles que estaban en Jerusalén tuvieron noticia de que los samaritanos habían aceptado la Palabra de Dios, les enviaron a Pedro y a Juan."
,"15":"Bajaron y oraron por ellos para que recibieran el Espíritu Santo,"
,"16":"ya que todavía no había descendido sobre ninguno de ellos y sólo habían sido bautizados en el nombre del Señor Jesús."
,"17":"Pero entonces les impusieron las manos y recibieron el Espíritu Santo."
,"18":"Al ver Simón que mediante la imposición de las manos de los apóstoles se transmitía el Espíritu, les ofreció dinero,"
,"19":"diciendo: 'Denme a mí también ese poder, de modo que a quien yo imponga las manos reciba el Espíritu Santo.'"
,"20":"Pedro le contestó: '¡Al infierno tú y tu dinero! ¿Cómo has pensado comprar el Don de Dios con dinero?"
,"21":"Tú no puedes esperar nada ni tomar parte en esto, porque tus pensamientos no son rectos ante Dios."
,"22":"Arrepiéntete de esa maldad tuya y ruega al Señor que te perdone por tus intenciones, si es posible."
,"23":"Porque en tus caminos solamente veo amargura y lazos de maldad.'"
,"24":"Simón respondió: 'Rueguen ustedes al Señor por mí, para que no venga sobre mí nada de lo que han dicho.'"
,"25":"Pedro y Juan dieron testimonio y, después de predicar la Palabra del Señor, volvieron a Jerusalén. Por el camino evangelizaron varios pueblos de Samaría."
,"26":"Un ángel del Señor se presentó a Felipe y le dijo: 'Dirígete hacia el sur, por el camino que baja de Jerusalén a Gaza; no pasa nadie en estos momentos.'"
,"27":"Felipe se levantó y se puso en camino. Y justamente pasó un etíope, un eunuco de Candaces, reina de Etiopía, un alto funcionario al que la reina encargaba la administración de su tesoro. Había ido a Jerusalén a rendir culto a Dios"
,"28":"y ahora regresaba, sentado en su carro, leyendo al profeta Isaías."
,"29":"El Espíritu dijo a Felipe: 'Acércate a ese carro y quédate pegado a su lado.'"
,"30":"Y mientras Felipe corría, le oía leer al profeta Isaías. Le preguntó: '¿Entiendes lo que estás leyendo?'"
,"31":"El etíope contestó: '¿Cómo lo voy a entender si no tengo quien me lo explique?' En seguida invitó a Felipe a que subiera y se sentara a su lado."
,"32":"El pasaje de la Escritura que estaba leyendo era éste: Fue llevado como oveja al matadero, como cordero mudo ante el que lo trasquila, no abrió su boca."
,"33":"Fue humillado y privado de sus derechos. ¿Quién podrá hablar de su descendencia? Porque su vida fue arrancada de la tierra."
,"34":"El etíope preguntó a Felipe: 'Dime, por favor, ¿a quién se refiere el profeta? ¿A sí mismo o a otro?'"
,"35":"Felipe empezó entonces a hablar y a anunciarle a Jesús, partiendo de este texto de la Escritura."
,"36":"Siguiendo el camino llegaron a un lugar donde había agua. El etíope dijo: 'Aquí hay agua. ¿Qué impide que yo sea bautizado?' ("
,"37":"Felipe respondió: 'Puedes ser bautizado si crees con todo tu corazón.' El etíope replicó: 'Creo que Jesucristo es el Hijo de Dios.')"
,"38":"Entonces hizo parar su carro. Bajaron ambos al agua y Felipe bautizó al eunuco"
,"39":"Apenas salieron del agua, el Espíritu del Señor arrebató a Felipe y el etíope no volvió a verlo. Prosiguió, pues, su camino con el corazón lleno de gozo."
,"40":"En cuanto a Felipe, se encontró en Azoto y salió a evangelizar uno tras otro todos los pueblos hasta llegar a Cesarea."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Saulo no desistía de su rabia, proyectando violencias y muerte contra los discípulos del Señor. Se presentó al sumo sacerdote"
,"2":"y le pidió poderes escritos para las sinagogas de Damasco, pues quería detener a cuantos seguidores del Camino encontrara, hombres y mujeres, y llevarlos presos a Jerusalén."
,"3":"Mientras iba de camino, ya cerca de Damasco, le envolvió de repente una luz que venía del cielo."
,"4":"Cayó al suelo y oyó una voz que le decía: 'Saulo, Saulo, ¿por qué me persigues?'"
,"5":"Preguntó él: '¿Quién eres tú, Señor?' Y él respondió: 'Yo soy Jesús, a quien tú persigues."
,"6":"Ahora levántate y entra en la ciudad. Allí se te dirá lo que tienes que hacer.'"
,"7":"Los hombres que lo acompañaban se habían quedado atónitos, pues oían hablar, pero no veían a nadie,"
,"8":"y Saulo, al levantarse del suelo, no veía nada por más que abría los ojos. Lo tomaron de la mano y lo llevaron a Damasco."
,"9":"Allí permaneció tres días sin comer ni beber, y estaba ciego."
,"10":"Vivía en Damasco un discípulo llamado Ananías. El Señor lo llamó en una visión: '¡Ananías!' Respondió él: 'Aquí estoy, Señor.'"
,"11":"Y el Señor le dijo: 'Vete en seguida a la calle llamada Recta y pregunta en la casa de Judas por un hombre de Tarso llamado Saulo. Lo encontrarás rezando,"
,"12":"pues acaba de tener una visión: un varón llamado Ananías entraba y le imponía las manos para que recobrara la vista.'"
,"13":"Ananías le respondió: 'Señor, he oído a muchos hablar del daño que este hombre ha causado a tus santos en Jerusalén."
,"14":"Y ahora está aquí con poderes del sumo sacerdote para llevar presos a todos los que invocan tu Nombre.'"
,"15":"El Señor le contestó: 'Vete. Este hombre es para mí un instrumento excepcional, y llevará mi Nombre a las naciones paganas y a sus reyes, así como al pueblo de Israel."
,"16":"Yo le mostraré todo lo que tendrá que sufrir por mi Nombre.'"
,"17":"Salió Ananías, entró en la casa y le impuso las manos diciendo: 'Hermano Saulo, el Señor Jesús, el que se te apareció en el camino por donde venías, me ha enviado para que recobres la vista y quedes lleno del Espíritu Santo.'"
,"18":"Al instante se le cayeron de los ojos una especie de escamas y empezó a ver. Se levantó y fue bautizado."
,"19":"Después comió y recobró las fuerzas. Saulo permaneció durante algunos días con los discípulos en Damasco, "
,"20":"y en seguida se fue por las sinagogas proclamando a Jesús como el Hijo de Dios."
,"21":"Los que lo oían quedaban maravillados y decían: '¡Y pensar que en Jerusalén perseguía a muerte a los que invocaban este Nombre! Pero ¿no ha venido aquí para encadenarlos y llevarlos ante los jefes de los sacerdotes?"
,"22":"Saulo se mostraba cada vez más fuerte cuando demostraba que Jesús era el Mesías, y refutaba todas las objeciones de los judíos de Damasco."
,"23":"Después de bastante tiempo los judíos decidieron matarlo,"
,"24":"pero Saulo llegó a conocer su plan. Día y noche eran vigiladas las puertas de la ciudad para poder matarlo."
,"25":"Entonces sus discípulos lo tomaron una noche y lo bajaron desde lo alto de la muralla metido en un canasto."
,"26":"Al llegar a Jerusalén intentó juntarse con los discípulos; pero todos le tenían miedo, pues no creían que fuese realmente discípulo."
,"27":"Entonces Bernabé lo tomó consigo, lo presentó a los apóstoles y les contó cómo Saulo había visto al Señor en el camino y cómo el Señor le había hablado. También les expuso la valentía con que había predicado en Damasco en nombre de Jesús."
,"28":"Saulo empezó a convivir con ellos. Se movía muy libremente por Jerusalén y predicaba abiertamente el Nombre del Señor."
,"29":"Hablaba a los helenistas y discutía con ellos, pero planearon matarle."
,"30":"Los hermanos se enteraron y lo llevaron a Cesarea, y desde allí lo enviaron a Tarso."
,"31":"La Iglesia por entonces gozaba de paz en toda Judea, Galilea y Samaría. Se edificaba, caminaba con los ojos puestos en el Señor y estaba llena del consuelo del Espíritu Santo."
,"32":"Pedro, que recorría todos los lugares, fue también a visitar a los santos que vivían en Lida."
,"33":"Allí encontró a un tal Eneas, que era paralítico y desde hacía ocho años yacía en una camilla."
,"34":"Pedro le dijo: 'Eneas, Jesucristo te sana. Levántate y arregla tu cama.' Y de inmediato se levantó."
,"35":"Todos los habitantes de Lida y Sarón lo vieron y se convirtieron al Señor."
,"36":"En Jope había una discípula llamada Tabita (o Dorcas en griego), que quiere decir Gacela. Hacía muchas obras buenas y siempre ayudaba a los pobres."
,"37":"Por aquellos días enfermó y murió: después de lavar su cuerpo, lo pusieron en la habitación del piso superior."
,"38":"Como Lida está cerca de Jope, los discípulos, al saber que Pedro estaba allí, mandaron a dos hombres con este recado: 'Ven inmediatamente a donde nosotros.'"
,"39":"Pedro se fue sin más con ellos. Apenas llegó lo hicieron subir a la habitación del piso superior, donde le presentaron a todas las viudas, que estaban llorando, y le mostraban las túnicas y mantos que Tabita hacía mientras vivía con ellas."
,"40":"Pedro hizo salir a todos, se puso de rodillas y oró. Luego se volvió al cadáver y dijo: 'Tabita, levántate.'"
,"41":"Ella abrió los ojos, reconoció a Pedro y se sentó. El le dio la mano y la ayudó a levantarse; luego llamó a los santos y a las viudas y se la presentó viva."
,"42":"Esto se supo en todo Jope, y muchos creyeron en el Señor."
,"43":"Pedro permaneció en Jope bastante tiempo, en casa de un curtidor llamado Simón."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Vivía en la ciudad de Cesarea un hombre llamado Cornelio, que era un capitán del batallón Itálico."
,"2":"Era un hombre piadoso y, al igual que toda su familia, era de los 'que temen a Dios'. Daba muchas limosnas a los judíos pobres y oraba constantemente a Dios."
,"3":"Una tarde, alrededor de las tres, tuvo una visión de la que no pudo dudar: un ángel de Dios entraba a su habitación y le llamaba: '¡Cornelio!'"
,"4":"El lo miró frente a frente y se llenó de miedo. Le dijo: '¿Qué pasa, señor?' El ángel respondió: 'Tus oraciones y tus limosnas han subido hasta Dios y acaban de ser recordadas ante él."
,"5":"Ahora envía algunos hombres a Jope para que traigan a un tal Simón, llamado Pedro,"
,"6":"que se aloja en la casa de Simón, el curtidor, que está junto al mar.'"
,"7":"Apenas desapareció el ángel que le hablaba, Cornelio llamó a dos criados y a un soldado piadoso que estaba a su servicio."
,"8":"Les explicó todo y los envió a Jope."
,"9":"Al día siguiente, mientras iban de camino, ya cerca de la ciudad, Pedro subió a la azotea para orar. Era el mediodía."
,"10":"Sintió hambre y quiso comer. Mientras le preparaban la comida tuvo un éxtasis:"
,"11":"vio el cielo abierto y algo que descendía del cielo: era como una tienda de campaña grande, cuyas cuatro puntas venían a posarse sobre el suelo."
,"12":"Dentro había toda clase de animales cuadrúpedos, reptiles y aves."
,"13":"Entonces una voz le habló: 'Pedro, levántate, mata y come.'"
,"14":"Pedro contestó: '¡De ninguna manera, Señor! Jamás he comido nada profano o impuro.'"
,"15":"Y se le habló por segunda vez: 'Lo que Dios ha purificado no lo llames tú impuro.'"
,"16":"Esto se repitió por tres veces. Después aquella cosa grande fue levantada hacia el cielo."
,"17":"Después de volver en sí, Pedro buscaba en vano el significado de aquella visión, cuando justamente se presentaron los hombres enviados por Cornelio. Habían preguntado por la casa de Simón y ahora estaban a la puerta."
,"18":"Llamaron y preguntaron si se alojaba allí Simón, llamado Pedro."
,"19":"Como Pedro aún seguía recapacitando sobre la visión, el Espíritu le dijo: 'Abajo están unos hombres que te buscan."
,"20":"Baja y vete con ellos sin vacilar, pues los he enviado yo.'"
,"21":"Pedro bajó adonde ellos y les dijo: 'Yo soy el que ustedes buscan. ¿Cuál es el motivo que los trae aquí?'"
,"22":"Ellos respondieron: 'Nos envía el capitán Cornelio. Es un hombre recto, de los 'que temen a Dios', y lo aprecian todos los judíos. Ha recibido de un santo ángel la orden de hacerte venir a su casa para aprender algo de ti.'"
,"23":"Entonces Pedro los invitó a pasar y les dio alojamiento. Al día siguiente partió con ellos, y algunos hermanos de Jope le acompañaron. "
,"24":"Al otro día llegaron a Cesarea. Cornelio los estaba esperando, y había reunido a sus parientes y amigos más íntimos."
,"25":"Cuando Pedro estaba para entrar, Cornelio le salió al encuentro, se arrodilló y se inclinó ante él."
,"26":"Pedro lo levantó diciendo: 'Levántate, que también yo soy un ser humano.'"
,"27":"Entró conversando con él y, al ver a todas aquellas personas reunidas,"
,"28":"les dijo: 'Ustedes saben que no está permitido a un judío juntarse con ningún extranjero ni entrar en su casa. Pero a mí me ha manifestado Dios que no hay que llamar profano a ningún hombre ni considerarlo impuro."
,"29":"Por eso he venido sin dudar apenas me llamaron. Ahora desearía saber por qué me han mandado a buscar.'"
,"30":"Cornelio respondió: 'Hace cuatro días, a esta misma hora, estaba yo orando en mi casa, cuando se presentó delante de mí un hombre con ropas muy brillantes, que me dijo:"
,"31":"'Cornelio, tu oración ha sido escuchada y tus limosnas han sido recordadas ante Dios."
,"32":"Envía mensajeros a Jope y haz buscar a Simón, llamado Pedro, que se hospeda en casa del curtidor Simón, junto al mar.'"
,"33":"Te mandé a buscar en seguida y tú has tenido la amabilidad de venir. Ahora estamos todos aquí, en la presencia de Dios, dispuestos a escuchar todo lo que el Señor te ha ordenado.'"
,"34":"Entonces Pedro tomó la palabra y dijo: 'Verdaderamente reconozco que Dios no hace diferencia entre las personas."
,"35":"En toda nación mira con benevolencia al que teme a Dios y practica la justicia."
,"36":"Ahora bien, Dios ha enviado su Palabra a los israelitas dándoles un mensaje de paz por medio de Jesús, el Mesías, que también es el Señor de todos."
,"37":"Ustedes ya saben lo que ha sucedido en todo el país judío, comenzando por Galilea, después del bautismo que predicó Juan."
,"38":"Jesús de Nazaret fue consagrado por Dios, que le dio Espíritu Santo y poder. Y como Dios estaba con él, pasó haciendo el bien y sanando a los oprimidos por el diablo."
,"39":"Nosotros somos testigos de todo lo que hizo en el país de los judíos y en la misma Jerusalén. Al final lo mataron colgándolo de un madero. "
,"40":"Pero Dios lo resucitó al tercer día e hizo que se dejara ver,"
,"41":"no por todo el pueblo, sino por los testigos que Dios había escogido de antemano, por nosotros, que comimos y bebimos con él después de que resucitó de entre los muertos."
,"42":"El nos ordenó predicar al pueblo y dar testimonio de que Dios lo ha constituido Juez de vivos y muertos."
,"43":"A El se refieren todos los profetas al decir que quien cree en él recibe por su Nombre el perdón de los pecados.'"
,"44":"Todavía estaba hablando Pedro, cuando el Espíritu Santo bajó sobre todos los que escuchaban la Palabra."
,"45":"Y los creyentes de origen judío, que habían venido con Pedro, quedaron atónitos: '¡Cómo! ¡Dios regala y derrama el Espíritu Santo también sobre los que no son judíos!'"
,"46":"Y así era, pues les oían hablar en lenguas y alabar a Dios."
,"47":"Entonces Pedro dijo: '¿Podemos acaso negarles el agua y no bautizar a quienes han recibido el Espíritu Santo como nosotros?'"
,"48":"Y mandó bautizarlos en el nombre de Jesucristo. Luego le pidieron que se quedara algunos días con ellos."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Los apóstoles y los hermanos de Judea tuvieron noticias de que también personas no judías habían acogido la Palabra de Dios. Por eso,"
,"2":"cuando Pedro subió a Jerusalén, los creyentes judíos comenzaron a criticar su actitud:"
,"3":"'¡Has entrado en la casa de gente no judía y has comido con ellos!'"
,"4":"Entonces Pedro se puso a explicarles los hechos punto por punto:"
,"5":"'Estaba yo haciendo oración en la ciudad de Jope cuando en un éxtasis tuve una visión. Algo bajaba del cielo, algo que se parecía a una gran tienda de campaña, y llegaba hasta mí, posándose en el suelo sobre sus cuatro puntas."
,"6":"Miré atentamente y vi en ella cuadrúpedos, bestias del campo, reptiles y aves."
,"7":"Oí también una voz que me decía: 'Pedro, levántate, mata y come.'"
,"8":"Yo contesté: '¡De ninguna manera, Señor! Nunca ha entrado en mi boca nada profano o impuro.'"
,"9":"La voz me habló por segunda vez: 'Lo que Dios ha purificado, no lo llames tú impuro.'"
,"10":"Esto se repitió por tres veces y después fue retirado todo al cielo."
,"11":"En aquel momento, tres hombres que habían sido enviados a mí desde Cesarea, llegaron a la casa donde nosotros estábamos."
,"12":"El Espíritu me dijo que los siguiera sin vacilar. Me acompañaron estos seis hermanos y entramos en la casa de aquel hombre."
,"13":"El nos contó cómo había visto a un ángel que se presentó en su casa y le dijo: 'Envía a alguien a Jope, y que traiga a Simón, llamado Pedro."
,"14":"El te dará un mensaje por el que te salvarás tú y toda tu familia'."
,"15":"Apenas había comenzado yo a hablar, cuando el Espíritu Santo bajó sobre ellos, como había bajado al principio sobre nosotros."
,"16":"Entonces me acordé de la palabra del Señor, que dijo: 'Juan bautizó con agua, pero ustedes serán bautizados en el Espíritu Santo.'"
,"17":"Si ellos creían en el Señor Jesucristo y Dios les comunicaba el mismo don que a nosotros, ¿quién era yo para oponerme a Dios?'"
,"18":"Cuando oyeron esto se tranquilizaron y alabaron a Dios diciendo: 'También a los que no son judíos les ha dado Dios la conversión que lleva a la vida.'"
,"19":"Algunos que se habían dispersado a raíz de la persecución cuando el asunto de Esteban llegaron hasta Fenicia, Chipre y Antioquía, pero sólo predicaban la Palabra a los judíos."
,"20":"Sin embargo, unos hombres de Chipre y de Cirene, que habían llegado a Antioquía, se dirigieron también a los griegos y les anunciaron la Buena Noticia del Señor Jesús."
,"21":"La mano del Señor estaba con ellos y fueron numerosos los que creyeron y se convirtieron al Señor."
,"22":"La noticia de esto llegó a oídos de la Iglesia de Jerusalén y enviaron a Bernabé a Antioquía."
,"23":"Al llegar fue testigo de la gracia de Dios y se alegró; animaba a todos a que permaneciesen fieles al Señor con firme corazón,"
,"24":"pues era un hombre excelente, lleno del Espíritu Santo y de fe. Así fue como un buen número de gente conoció al Señor."
,"25":"Bernabé salió para Tarso en busca de Saulo,"
,"26":"y apenas lo encontró lo llevó a Antioquía. En esta Iglesia trabajaron juntos durante un año entero, instruyendo a muchísima gente, y fue en Antioquía donde los discípulos por primera vez recibieron el nombre de cristianos."
,"27":"Por aquel tiempo bajaron algunos profetas de Jerusalén a Antioquía."
,"28":"Uno de ellos, llamado Agabo, dio a entender con gestos proféticos que una gran hambre vendría sobre todo el mundo, que de hecho sobrevino en tiempos del emperador Claudio."
,"29":"Entonces cada uno de los discípulos empezó a ahorrar según sus posibilidades, destinando esta ayuda a los hermanos de Judea."
,"30":"Así lo hicieron, enviándosela a los presbíteros por medio de Bernabé y Saulo."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Por aquel tiempo el rey Herodes decidió apresar a algunos miembros de la Iglesia para maltratarlos."
,"2":"Hizo matar a espada a Santiago, hermano de Juan,"
,"3":"y, al ver que esto agradaba a los judíos, mandó detener también a Pedro: eran precisamente los días de la fiesta de los Panes Azimos."
,"4":"Después de detenerlo lo hizo encerrar en la cárcel bajo la vigilancia de cuatro piquetes de cuatro soldados cada uno, pues su intención era juzgarlo ante el pueblo después de la Pascua."
,"5":"Y mientras Pedro era custodiado en la cárcel, toda la Iglesia oraba incesantemente por él a Dios."
,"6":"Llegaba el día en que Herodes iba a hacerlo comparecer; aquella misma noche Pedro estaba durmiendo entre dos soldados, atado con dos cadenas, y otros guardias custodiaban la puerta de la cárcel."
,"7":"De repente la celda se llenó de luz: ¡estaba el ángel del Señor! El ángel tocó a Pedro en el costado y lo despertó diciéndole: '¡Levántate en seguida!' Y se le cayeron las cadenas de las manos."
,"8":"El ángel le dijo en seguida: 'Ponte el cinturón y las sandalias.' Así lo hizo, y el ángel agregó: 'Ponte el manto y sígueme.'"
,"9":"Pedro salió tras él; no se daba cuenta de que lo que estaba ocurriendo con el ángel era realidad, y todo le parecían visiones."
,"10":"Pasaron la primera y la segunda guardia y llegaron a la puerta de hierro que daba a la ciudad, la cual se les abrió sola. Salieron y se metieron por un callejón, y de repente lo dejó el ángel."
,"11":"Entonces Pedro volvió en sí y dijo: 'Ahora no cabe duda: el Señor ha enviado a su ángel para rescatarme de las manos de Herodes y de todo lo que proyectaban los judíos contra mí.'"
,"12":"Pedro se orientó y fue a casa de María, madre de Juan, llamado también Marcos, donde muchos estaban reunidos en oración."
,"13":"Llamó a la puerta, y fue a atender una muchacha llamada Rodesa."
,"14":"Reconoció la voz de Pedro, y fue tanta su alegría, que en vez de abrir la puerta entró corriendo a contar que Pedro estaba a la puerta."
,"15":"Los demás le dijeron: '¡Estás loca!' Como ella seguía insistiendo, ellos dijeron: 'Será su ángel.'"
,"16":"Pedro seguía llamando. Cuando abrieron y vieron que era él, se quedaron sin palabras."
,"17":"Les hizo señas con la mano pidiendo silencio, y les contó cómo el Señor lo había sacado de la cárcel. En seguida les dijo: 'Comuniquen esto a Santiago y a los hermanos.' Luego salió y se fue a otro lugar."
,"18":"Al amanecer no fue poco el alboroto entre los soldados: ¿Qué había pasado con Pedro?"
,"19":"Herodes ordenó buscarlo y, como no lo encontraron, hizo procesar y ejecutar a los guardias. Después bajó de Judea a Cesarea y se quedó allí."
,"20":"Por aquel entonces Herodes estaba muy irritado con los ciudadanos de Tiro y de Sidón. De común acuerdo se presentaron ante él y, después de ganarse a Blasto, tesorero del rey, buscaron una solución pacífica, ya que su país dependía del de Herodes para su abastecimiento."
,"21":"El día señalado, Herodes, vestido con el manto real, se sentó en la tribuna y les dirigió la palabra."
,"22":"Entonces el pueblo lo empezó a aclamar: '¡Esta es la voz de Dios, no de un hombre!'"
,"23":"Pero de repente lo hirió el ángel del Señor por no haber devuelto a Dios el honor, y empezó a llenarse de gusanos que lo comían, hasta que murió."
,"24":"Mientras tanto la Palabra de Dios crecía y se difundía."
,"25":"Bernabé y Saulo habían terminado su misión y se volvieron a Jerusalén; traían con ellos a Juan, llamado también Marcos."
}`)
	CurrentBook.AddChapter(13, `{
"1":"En Antioquía, en la Iglesia que estaba allí, había profetas y maestros: Bernabé, Simeón, llamado el Negro, Lucio de Cirene, Manahem, que se había criado con Herodes, y Saulo."
,"2":"Un día, mientras celebraban el culto del Señor y ayunaban, el Espíritu Santo les dijo: 'Sepárenme a Bernabé y a Saulo y envíenlos a realizar la misión para la que los he llamado.'"
,"3":"Ayunaron e hicieron oraciones, les impusieron las manos y los enviaron."
,"4":"Enviados por el Espíritu Santo, Bernabé y Saulo bajaron al puerto de Seleucia y de allí navegaron hasta Chipre."
,"5":"Llegados a Salamina, comenzaron a anunciar la Palabra de Dios en las sinagogas de los judíos. Juan les hacía de asistente."
,"6":"Atravesando toda la isla hasta Pafos, encontraron a un mago judío, un falso profeta llamado Bar-Jesús,"
,"7":"que estaba con el gobernador Sergio Paulo, el cual era un hombre muy abierto. Este hizo llamar a Bernabé y Saulo, pues deseaba escuchar la Palabra de Dios,"
,"8":"pero el otro ponía trabas. El Elimas (éste era su nombre, que significa el Mago), intentaba apartar al gobernador de la fe."
,"9":"Entonces Saulo, que no es otro que Pablo, lleno del Espíritu Santo, fijó en él sus ojos"
,"10":"y le dijo: 'Tú, hijo del diablo, enemigo de todo bien, eres un sinvergüenza y no haces más que engañar. ¿Cuándo terminarás de torcer los rectos caminos del Señor?"
,"11":"Pues ahora la mano del Señor va a caer sobre ti, quedarás ciego y no verás la luz del sol por cierto tiempo.' Al instante quedó envuelto en oscuridad y tinieblas, y daba vueltas buscando a alguien que lo llevase de la mano."
,"12":"Al ver lo acontecido, el gobernador abrazó la fe, pues quedó muy impresionado por la doctrina del Señor."
,"13":"Pablo y sus compañeros se embarcaron en Pafos y llegaron a Perge de Panfilia. Allí Juan se separó de ellos y regresó a Jerusalén,"
,"14":"mientras ellos, dejando Perge, llegaban a Antioquía de Pisidia. El sábado entraron en la sinagoga y se sentaron."
,"15":"Después de la lectura de la Ley y los Profetas, los jefes de la sinagoga les mandaron a decir: 'Hermanos, si ustedes tienen alguna palabra de aliento para los presentes, hablen.'"
,"16":"Pablo, pues, se levantó, hizo señal con la mano pidiendo silencio y dijo: 'Hijos de Israel y todos ustedes que temen a Dios, escuchen: "
,"17":"El Dios de Israel, nuestro pueblo, eligió a nuestros padres. Hizo que el pueblo se multiplicara durante su permanencia en Egipto, los sacó de allí con hechos poderosos"
,"18":"y durante unos cuarenta años los llevó por el desierto."
,"19":"Luego destruyó siete naciones en la tierra de Canaán y les dio su territorio en herencia."
,"20":"Durante unos cuatrocientos cincuenta años les dio jueces, hasta el profeta Samuel."
,"21":"Entonces pidieron un rey, y Dios les dio a Saúl, hijo de Cis, de la tribu de Benjamín, que reinó cuarenta años."
,"22":"Pero después Dios lo rechazó y les dio a David, de quien dio este testimonio: Encontré a David, hijo de Jesé, un hombre a mi gusto, que llevará a cabo mis planes."
,"23":"Ahora bien, Dios ha cumplido su promesa: ha hecho surgir de la familia de David un salvador para Israel, ese es Jesús."
,"24":"Antes de que se manifestara, Juan había predicado a todo el pueblo de Israel un bautismo de conversión."
,"25":"Y cuando estaba para terminar su carrera, Juan declaró: 'Yo no soy el que ustedes piensan, pero detrás de mí viene otro al que yo no soy digno de desatarle la sandalia.'"
,"26":"Hermanos israelitas, hijos y descendientes de Abrahán, y también ustedes los que temen a Dios, a todos nosotros se nos ha dirigido este mensaje de salvación."
,"27":"Es un hecho que los habitantes de Jerusalén y sus jefes no lo reconocieron, sino que lo procesaron, cumpliendo con esto las palabras de los profetas que se leen todos los sábados."
,"28":"Aunque no encontraron en él ningún motivo para condenarlo a muerte, pidieron a Pilato que fuera ejecutado."
,"29":"Y cuando cumplieron todo lo que sobre él estaba escrito, lo bajaron de la cruz y lo pusieron en un sepulcro."
,"30":"Pero Dios lo resucitó de entre los muertos."
,"31":"Durante muchos días se apareció a los que habían subido con él desde Galilea a Jerusalén, y que habían de ser sus testigos ante el pueblo."
,"32":"Nosotros mismos les traemos ahora la promesa que Dios hizo a nuestros padres,"
,"33":"y que cumplió para nosotros, sus hijos, al resucitar a Jesús, como está escrito en el Salmo: Tú eres mi hijo, yo te he engendrado hoy."
,"34":"Dios lo resucitó de entre los muertos, y no volverá a conocer muerte ni corrupción. Pues así lo dijo: Les daré las cosas santas, las realidades verdaderas que reservaba para David."
,"35":"Asimismo está dicho en otro lugar: No permitirás que tu santo experimente la corrupción."
,"36":"Bien saben que David, después de haber servido durante su vida a los designios de Dios, murió, se reunió con sus padres y experimentó la corrupción."
,"37":"Otro, pues, es el que no sufre la corrupción, y ése es Jesús, al que Dios resucitó."
,"38":"Sepan, pues, hermanos, cuál es la promesa: por su intermedio ustedes recibirán el perdón de los pecados y de todas esas cosas de las cuales buscaron en vano ser liberados por la Ley de Moisés."
,"39":"Quien cree en este Jesús es liberado de todo esto."
,"40":"Tengan, pues, cuidado de que no les ocurra lo que dijeron los profetas:"
,"41":"Atiendan ustedes, gente engreída, asómbrense y desaparezcan. Porque voy a realizar en sus días una obra tal, que si se la contaran no la creerían.'"
,"42":"Al salir Pablo y Bernabé de la sinagoga, les rogaban que de nuevo les volvieran a hablar de este tema el sábado siguiente."
,"43":"Y cuando se dispersó la asistencia, muchos judíos y de los que temen a Dios les siguieron. Pablo y Bernabé continuaron conversando con ellos, y los exhortaban a perseverar en la gracia de Dios."
,"44":"El sábado siguiente casi toda la ciudad acudió para escuchar a Pablo, que les habló largamente del Señor."
,"45":"Los judíos se llenaron de envidia al ver todo aquel gentío y empezaron a contradecir con insultos lo que Pablo decía."
,"46":"Entonces Pablo y Bernabé les hablaron con coraje: 'Era necesario que la Palabra de Dios fuera anunciada a ustedes en primer lugar. Pues bien, si ustedes la rechazan y se condenan a sí mismos a no recibir la vida eterna, sepan que ahora nos dirigimos a los que no son judíos."
,"47":"El mismo Señor nos dio la orden: Te he puesto como luz de los paganos, y llevarás mi salvación hasta los extremos del mundo."
,"48":"Los que no eran judíos se alegraban al oír estas palabras y tomaban en consideración el mensaje del Señor. Y creyeron todos los que estaban destinados para una vida eterna."
,"49":"Con esto la Palabra de Dios empezó a difundirse por toda la región."
,"50":"Pero los judíos incitaron a mujeres distinguidas de entre las que temían a Dios y también a los hombres importantes de la ciudad y promovieron una persecución contra Pablo y Bernabé hasta que los echaron de su territorio."
,"51":"Así que los apóstoles se fueron a la ciudad de Iconio, pero al salir sacudieron el polvo de sus pies en protesta contra ellos."
,"52":"Dejaban a los discípulos llenos de gozo y Espíritu Santo."
}`)
	CurrentBook.AddChapter(14, `{
"1":"En Iconio ocurrió lo mismo. Pablo y Bernabé entraron en la sinagoga de los judíos y hablaron de tal manera que un gran número de judíos y griegos abrazaron la fe."
,"2":"Pero entonces los judíos que se negaron a creer excitaron y envenenaron los ánimos de los paganos contra los hermanos."
,"3":"Con todo, permanecieron allí un buen número de días. Predicaban sin miedo, confiados en el Señor, que confirmaba este anuncio de su gracia con las señales milagrosas y los prodigios que les concedía realizar."
,"4":"La población de la ciudad se dividió, unos a favor de los judíos y otros a favor de los apóstoles."
,"5":"Un grupo compuesto de paganos y judíos con sus jefes al frente, se preparó para ultrajar y apedrear a los apóstoles."
,"6":"Ellos, al enterarse, huyeron a la provincia de Licaonia, a las ciudades de Listra, Derbe y alrededores,"
,"7":"donde se quedaron evangelizando."
,"8":"Había en Listra un hombre tullido, que se veía sentado y con los pies cruzados. Era inválido de nacimiento y nunca había podido caminar."
,"9":"Un día, como escuchaba el discurso de Pablo, éste fijó en él su mirada y vio que aquel hombre tenía fe para ser sanado."
,"10":"Le dijo entonces en voz alta: 'Levántate y ponte derecho sobre tus pies.' El hombre se incorporó y empezó a andar."
,"11":"Al ver la gente lo que Pablo había hecho, comenzó a gritar en la lengua de Licaonia: '¡Los dioses han venido a nosotros en forma de hombres!'"
,"12":"Según ellos, Bernabé era Zeus, y Pablo Hermes, porque era el que hablaba."
,"13":"Incluso el sacerdote del templo de Zeus, que estaba fuera de la ciudad, trajo hasta las puertas de la misma toros y guirnaldas y, de acuerdo con la gente, quiso ofrecerles un sacrificio."
,"14":"Al escuchar esto, Bernabé y Pablo rasgaron sus vestidos para manifestar su indignación y se lanzaron en medio de la gente gritando:"
,"15":"'Amigos, ¿qué hacen? Nosotros somos humanos y mortales como ustedes, y acabamos de decirles que deben abandonar estas cosas que no sirven y volverse al Dios vivo, que hizo el cielo, la tierra, el mar y cuanto hay en ellos."
,"16":"El permitió en las generaciones pasadas que cada nación siguiera su propio camino,"
,"17":"pero no por eso dejó de manifestarse, pues continuamente derrama sus beneficios. El es quien desde el cielo les da las lluvias, y los frutos a su tiempo, dando el alimento y llenando los corazones de alegría.'"
,"18":"Aun con estas palabras, difícilmente consiguieron que el pueblo no les ofreciera un sacrificio, y que volvieran cada uno a su casa."
,"19":"Se quedaron allí algún tiempo enseñando. Luego llegaron unos judíos de Antioquía e Iconio y hablaron con mucha seguridad, afirmando que no había nada de verdadero en aquella predicación, sino que todo era una mentira. Persuadieron a la gente a que les dieran la espalda y al final apedrearon a Pablo. Después lo arrastraron fuera de la ciudad, convencidos de que ya estaba muerto."
,"20":"Pero sus discípulos se juntaron en torno a él, y se levantó. Entró en la ciudad, y al día siguiente marchó con Bernabé para Derbe."
,"21":"Después de haber evangelizado esa ciudad, donde hicieron muchos discípulos, regresaron de nuevo a Listra y de allí fueron a Iconio y Antioquía."
,"22":"A su paso animaban a los discípulos y los invitaban a perseverar en la fe; les decían: 'Es necesario que pasemos por muchas pruebas para entrar en el Reino de Dios.'"
,"23":"En cada Iglesia designaban presbíteros y, después de orar y ayunar, los encomendaban al Señor en quien habían creído."
,"24":"Atravesaron la provincia de Pisidia y llegaron a la de Panfilia."
,"25":"Predicaron la Palabra en Perge y bajaron después a Atalía."
,"26":"Allí se embarcaron para volver a Antioquía, de donde habían partido encomendados a la gracia de Dios para la obra que acababan de realizar."
,"27":"A su llegada reunieron a la Iglesia y les contaron todo lo que Dios había hecho por medio de ellos y cómo había abierto las puertas de la fe a los pueblos paganos."
,"28":"Permanecieron allí bastante tiempo con los discípulos."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Llegaron algunos de Judea que aleccionaban a los hermanos con estas palabras: 'Ustedes no pueden salvarse, a no ser que se circunciden como lo manda Moisés.'"
,"2":"Esto ocasionó bastante perturbación, así como discusiones muy violentas de Pablo y Bernabé con ellos. Al fin se decidió que Pablo y Bernabé junto con algunos de ellos subieran a Jerusalén para tratar esta cuestión con los apóstoles y los presbíteros."
,"3":"La Iglesia los encaminó, y atravesaron Fenicia y Samaría. Al pasar contaban con todo lujo de detalles la conversión de los paganos, lo que produjo gran alegría en todos los hermanos."
,"4":"Al llegar a Jerusalén fueron recibidos por la Iglesia, por los apóstoles y los presbíteros, y les expusieron todo lo que Dios había hecho por medio de ellos."
,"5":"Pero se levantaron algunos del grupo de los fariseos que habían abrazado la fe, y dijeron: 'Es necesario circuncidar a los no judíos y pedirles que observen la ley de Moisés.'"
,"6":"Entonces los apóstoles y los presbíteros se reunieron para tratar este asunto."
,"7":"Después de una acalorada discusión, Pedro se puso en Pie y dijo: 'Hermanos: ustedes saben cómo Dios intervino en medio de ustedes ya en los primeros días, cuando quiso que los paganos escucharan de mi boca el anuncio del Evangelio y abrazaran la fe. "
,"8":"Y Dios, que conoce los corazones, se declaró a favor de ellos, al comunicarles el Espíritu Santo igual que a nosotros."
,"9":"No ha hecho ninguna distinción entre nosotros y ellos, sino que purificó sus corazones por medio de la fe."
,"10":"¿Quieren ustedes mandar a Dios ahora? ¿Por qué quieren poner sobre el cuello de los discípulos un yugo que nuestros padres no fueron capaces de soportar, ni tampoco nosotros?"
,"11":"Según nuestra fe, la gracia del Señor Jesús es la que nos salva, del mismo modo que a ellos.'"
,"12":"Toda la asamblea guardó silencio y escucharon a Bernabé y a Pablo, que contaron las señales milagrosas y prodigios que Dios había realizado entre los paganos a través de ellos."
,"13":"Cuando terminaron de hablar, Santiago tomó la palabra y dijo: 'Hermanos, escúchenme:"
,"14":"Simeón acaba de recordar cómo Dios, desde el primer momento, intervino para formarse con gentes paganas un pueblo a su nombre."
,"15":"Los profetas hablan el mismo lenguaje, pues está escrito:"
,"16":"Después de esto volveré y construiré de nuevo la choza caída de David. Reconstruiré sus ruinas y la volveré a levantar,"
,"17":"para que el resto de los hombres busque al Señor, todas las naciones sobre las cuales ha sido invocado mi Nombre. Así lo dice el Señor, que hoy realiza"
,"18":"lo que tenía preparado desde siempre."
,"19":"Por esto pienso que no debemos complicar la vida a los paganos que se convierten a Dios."
,"20":"Digámosles en nuestra carta tan sólo que se abstengan de lo que es impuro por haber sido ofrecido a los ídolos, de las relaciones sexuales prohibidas, de la carne de animales sin sangrar y de comer sangre."
,"21":"Porque desde tiempos antiguos leen a Moisés en las sinagogas todos los sábados, y tiene predicadores en cada ciudad.'"
,"22":"Entonces los apóstoles y los presbíteros, de acuerdo con toda la Iglesia, decidieron elegir algunos hombres de entre ellos para enviarlos a Antioquía con Pablo y Bernabé. Fueron elegidos Judas, llamado Barsabás, y Silas, ambos dirigentes entre los hermanos."
,"23":"Debían entregar la siguiente carta: 'Los apóstoles y los hermanos con título de ancianos saludan a los hermanos no judíos de Antioquía, Siria y Cilicia. "
,"24":"Nos hemos enterado de que algunos de entre nosotros los han inquietado y perturbado con sus palabras. No tenían mandato alguno nuestro."
,"25":"Pero ahora, reunidos en asamblea, hemos decidido elegir algunos hombres y enviarlos a ustedes junto con los queridos hermanos Bernabé y Pablo,"
,"26":"que han consagrado su vida al servicio de nuestro Señor Jesucristo."
,"27":"Les enviamos, pues, a Judas y a Silas, que les expondrán de viva voz todo el asunto."
,"28":"Fue el parecer del Espíritu Santo y el nuestro no imponerles ninguna otra carga fuera de las indispensables:"
,"29":"que no coman carne sacrificada a los ídolos, ni sangre, ni carne de animales sin desangrar y que se abstengan de relaciones sexuales prohibidas. Observen estas normas dejándose guiar por el Espíritu Santo. Adiós.'"
,"30":"Después de despedirse fueron a Antioquía, reunieron a la asamblea y entregaron la carta."
,"31":"Cuando la leyeron, todos se alegraron con aquel mensaje de aliento."
,"32":"Judas y Silas, que también eran profetas, dieron ánimo y confortaron a los hermanos con un largo discurso."
,"33":"Se quedaron allí algún tiempo, y los hermanos los despidieron en paz para volver a la comunidad que los había enviado."
,"34":"Pero Silas prefirió quedarse con ellos y Judas volvió solo."
,"35":"En cuanto a Pablo y Bernabé, se detuvieron en Antioquía, enseñando y anunciando con muchos otros la Palabra de Dios."
,"36":"Pero un día Pablo dijo a Bernabé: 'Volvamos a visitar a los hermanos y veamos cómo están en cada una de las ciudades donde hemos anunciado la Palabra del Señor.'"
,"37":"Bernabé quería llevar con ellos también a Juan, llamado Marcos,"
,"38":"pero Pablo consideraba que no debían llevar consigo a quien los había abandonado en Panfilia, cuando debía haber compartido sus trabajos."
,"39":"Se acaloraron tanto que acabaron por separarse el uno del otro. Bernabé tomó consigo a Marcos y se embarcó rumbo a Chipre."
,"40":"Pablo, por su parte, eligió a Silas. Los hermanos lo encomendaron a la gracia de Dios y partió."
,"41":"Recorrió Siria y Cilicia confirmando a las Iglesias y entregando las decisiones de los presbíteros."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Pablo se dirigió a Derbe y después a Listra. Había allí un discípulo llamado Timoteo, hijo de una mujer judía que había abrazado la fe, y de padre griego;"
,"2":"los hermanos de Listra e Iconio hablaban muy bien de él."
,"3":"Pablo quiso llevarlo consigo y de partida lo circuncidó, pensando en los judíos que había por aquellos lugares, pues todos sabían que su padre era griego."
,"4":"A su paso de ciudad en ciudad iban entregando las decisiones tomadas por los apóstoles y presbíteros en Jerusalén y exhortaban a que las observaran."
,"5":"Estas Iglesias se iban fortaleciendo en la fe y reunían cada día más gente."
,"6":"Atravesaron Frigia y la región de Galacia, pues el Espíritu Santo no les dejó que fueran a predicar la Palabra en Asia."
,"7":"Estando cerca de Misia intentaron dirigirse a Bitinia, pero no se lo consintió el Espíritu de Jesús."
,"8":"Atravesaron entonces Misia y bajaron a Tróade."
,"9":"Por la noche Pablo tuvo una visión. Ante él estaba de Pie un macedonio que le suplicaba: 'Ven a Macedonia y ayúdanos.'"
,"10":"Al despertar nos contó la visión y comprendimos que el Señor nos llamaba para evangelizar a Macedonia."
,"11":"Nos embarcamos en Tróade y navegamos rumbo a la isla de Samotracia; al día siguiente salimos para Neápolis."
,"12":"De allí pasamos a Filipos, una de las principales ciudades del distrito de Macedonia, con derechos de colonia romana. Nos detuvimos allí algunos días, "
,"13":"y el sábado salimos a las afueras de la ciudad, a orillas del río, donde era de suponer que los judíos se reunían para orar. Nos sentamos y empezamos a hablar con las mujeres que habían acudido."
,"14":"Una de ellas se llamaba Lidia, y era de las que temen a Dios. Era vendedora de púrpura y natural de la ciudad de Tiatira. Mientras nos escuchaba, el Señor le abrió el corazón para que aceptase las palabras de Pablo."
,"15":"Recibió el bautismo junto con los de su familia, y luego nos suplicó: 'Si ustedes piensan que mi fe en el Señor es sincera, vengan y quédense en mi casa.' Y nos obligó a aceptar."
,"16":"Mientras íbamos un día al lugar de oración, salió a nuestro encuentro una muchacha esclava que estaba poseída por un espíritu adivino. Adivinando la suerte producía mucha plata a sus amos."
,"17":"Empezó a seguirnos a nosotros y a Pablo gritando: 'Estos hombres son siervos del Dios Altísimo y les anuncian el camino de la salvación.'"
,"18":"Esto se repitió durante varios días, hasta que Pablo se cansó, Se volvió y dijo al espíritu: 'En el nombre de Jesucristo te ordeno que salgas de ella' Y en ese mismo instante el espíritu la dejó."
,"19":"Al ver sus amos que con ello se esfumaban también sus ganancias, tomaron a Pablo y a Silas y los arrastraron a la plaza ante el tribunal."
,"20":"Y los presentaron a los magistrados diciendo: 'Estos hombres son judíos y están alborotando nuestra ciudad;"
,"21":"predican unas costumbres que a nosotros, los romanos, no nos está permitido aceptar ni practicar.'"
,"22":"La gente se les echó encima. Los oficiales mandaron arrancarles las ropas y los hicieron apalear."
,"23":"Después de haberles dado muchos golpes, los echaron a la cárcel, dando orden al carcelero de vigilarlos con todo cuidado."
,"24":"Este, al recibir dicha orden, los metió en el calabozo interior y les sujetó los pies con cadenas al piso del calabozo."
,"25":"Hacia media noche Pablo y Silas estaban cantando himnos a Dios, y los demás presos los escuchaban."
,"26":"De repente se produjo un temblor tan fuerte que se conmovieron los cimientos de la cárcel; todas las puertas se abrieron de golpe y a todos los presos se les soltaron las cadenas."
,"27":"Se despertó el carcelero y vio todas las puertas de la cárcel abiertas. Creyendo que los presos se habían escapado, sacó la espada para matarse,"
,"28":"pero Pablo le gritó: 'No te hagas daño, que estamos todos aquí.'"
,"29":"El hombre pidió una luz, entró de un salto y, después de encerrar bien a los demás presos, se arrojó temblando a los pies de Pablo y Silas."
,"30":"Después los sacó fuera y les preguntó: 'Señores, ¿qué debo hacer para salvarme?'"
,"31":"Le respondieron: 'Ten fe en el Señor Jesús y te salvarás tú y tu familia.'"
,"32":"Le anunciaron la Palabra del Señor a él y a todos los de su casa."
,"33":"El carcelero, sin más demora, les lavó las heridas y se bautizó con toda su familia a aquella hora de la noche."
,"34":"Los había llevado a su casa; allí preparó la mesa e hicieron fiesta con todos los suyos por haber creído en Dios."
,"35":"Por la mañana los magistrados enviaron a unos oficiales con esta orden: 'Deja en libertad a esos hombres.'"
,"36":"El carcelero se lo comunicó a Pablo y Silas, diciendo: 'Los magistrados han dado orden de dejarlos en libertad. Salgan, pues, y marchen en paz.'"
,"37":"Pero Pablo le contestó: 'A nosotros, ciudadanos romanos, nos han azotado públicamente y nos han metido en la cárcel sin juzgarnos, ¿y ahora quieren echarnos fuera a escondidas? Eso no. Que vengan ellos a sacarnos.'"
,"38":"Los oficiales transmitieron esto a los magistrados, que se llenaron de miedo al escuchar que eran ciudadanos romanos."
,"39":"Fueron a la prisión acompañados por un grupo de amigos de Pablo y les pidieron que se marcharan, diciéndoles: '¡Cómo íbamos a pensar que ustedes fueran muy buena gente!' Y cuando Pablo y Silas estaban para irse, les rogaron: 'Ahora que se van libres, por favor, no nos creen problemas por haberles hablado duramente'."
,"40":"Apenas dejaron la cárcel fueron a casa de Lidia. Allí se encontraron con los hermanos, a los que dieron ánimo antes de marcharse."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Pablo y Silas atravesaron Anfípolis y Apolonia, y llegaron a Tesalónica, donde los judíos tenían una sinagoga."
,"2":"Pablo, según su costumbre, fue a visitarlos y por tres sábados discutió con ellos, basándose en las Escrituras."
,"3":"Las interpretaba y les demostraba que el Mesías debía padecer y resucitar de entre los muertos. Y les decía: 'Este Mesías es precisamente el Jesús que yo les anuncio.'"
,"4":"Hubo algunos que se convencieron y formaron un grupo en torno a Pablo y Silas. Lo mismo hicieron un buen número de griegos, de los 'que temen a Dios', y no pocas mujeres de la alta sociedad."
,"5":"Los judíos no se quedaron pasivos: reunieron a unos cuantos vagos y maleantes, armaron un motín y alborotaron la ciudad. Hicieron una demostración frente a la casa de Jasón, pues querían a Pablo y Silas para llevarlos ante la asamblea del pueblo."
,"6":"Pero al no encontrarlos allí, arrastraron a Jasón y a otros creyentes ante los magistrados de la ciudad, gritando: 'Esos hombres que han revolucionado todo el mundo han llegado también hasta aquí"
,"7":"y Jasón los ha hospedado en su casa. Todos ellos objetan los decretos del César, pues afirman que hay otro rey, Jesús.'"
,"8":"Lograron impresionar al pueblo y a los magistrados que los oían,"
,"9":"los cuales exigieron una fianza a Jasón y a los demás hermanos antes de dejarlos en libertad."
,"10":"Aquella misma noche los hermanos enviaron a Pablo y Silas a la ciudad de Berea. Al llegar se dirigieron a la sinagoga de los judíos. "
,"11":"Estos eran mejores que los de Tesalónica, y recibieron el mensaje con mucha disponibilidad. Diariamente examinaban las Escrituras para comprobar si las cosas eran así."
,"12":"Un buen número de ellos abrazó la fe y, de entre los griegos, algunas mujeres distinguidas y también bastantes hombres."
,"13":"Pero cuando los judíos de Tesalónica se enteraron de que Pablo estaba predicando la Palabra de Dios en Berea, fueron también allí para agitar al pueblo y crear disturbios."
,"14":"Inmediatamente los hermanos hicieron salir a Pablo hacia la costa, mientras Silas y Timoteo se quedaban en Berea."
,"15":"Los que acompañaban a Pablo lo llevaron a Atenas, y después regresaron a Berea con instrucciones para Timoteo y Silas de que fueran a reunirse con él lo antes posible."
,"16":"Mientras Pablo los esperaba en Atenas, su espíritu hervía viendo la ciudad plagada de ídolos."
,"17":"Empezó a tener contactos en la sinagoga con judíos y con griegos que temían a Dios, hablando también con los que diariamente se encontraban en las plazas de la ciudad."
,"18":"Algunos filósofos epicúreos y estoicos entablaron conversación con él. Unos preguntaban: '¿Qué querrá decir este charlatán?', mientras otros comentaban: 'Parece ser un predicador de dioses extranjeros.' Porque le oían hablar de 'Jesús' y de 'la resurrección'."
,"19":"Lo tomaron, lo llevaron con ellos a la sala del Areópago y le preguntaron: '¿Podemos saber cuál es esa nueva doctrina que enseñas?"
,"20":"Nos zumban los oídos con esas cosas tan raras que nos cuentas, y nos gustaría saber de qué se trata.'"
,"21":"Se sabe que para todos los atenienses y los extranjeros que viven allí no hay mejor pasatiempo que contar o escuchar las últimas novedades."
,"22":"Entonces Pablo se puso de Pie en medio del Areópago, y les dijo: 'Ciudadanos de Atenas, veo que son personas sumamente religiosas."
,"23":"Mientras recorría la ciudad contemplando sus monumentos sagrados, he encontrado un altar con esta inscripción: 'Al Dios desconocido.' Pues bien, lo que ustedes adoran sin conocer, es lo que yo vengo a anunciarles."
,"24":"El Dios que hizo el mundo y todo lo que hay en él no vive en santuarios fabricados por humanos, pues es Señor del Cielo y de la tierra,"
,"25":"y tampoco necesita ser servido por manos humanas, pues ¿qué le hace falta al que da a todos la vida, el aliento y todo lo demás?"
,"26":"Habiendo sacado de un solo tronco toda la raza humana, quiso que se estableciera sobre toda la faz de la tierra, y fijó para cada pueblo cierto lugar y cierto momento de la historia."
,"27":"Habían de buscar por sí mismos a Dios, aunque fuera a tientas: tal vez lo encontrarían."
,"28":"En realidad no está lejos de cada uno de nosotros, pues en él vivimos, nos movemos y existimos, como dijeron algunos poetas suyos: 'Somos también del linaje de Dios.'"
,"29":"Si de verdad somos del linaje de Dios, no debemos pensar que la divinidad se parezca a las creaciones del arte y de la fantasía humanas, ya sean de oro, plata o piedra."
,"30":"Ahora precisamente Dios quiere superar esos tiempos de ignorancia, y pide a todos los hombres de todo el mundo un cambio total."
,"31":"Tiene ya fijado un día en que juzgará a todo el mundo con justicia, valiéndose de un hombre que ha designado, y al que todos pueden creer, pues él lo ha resucitado de entre los muertos.'"
,"32":"Cuando oyeron hablar de resurrección de los muertos, unos empezaron a burlarse de Pablo, y otros le decían: 'Sobre esto te escucharemos en otra ocasión.'"
,"33":"Así fue como Pablo salió de entre ellos."
,"34":"Algunos hombres, sin embargo, se unieron a él y abrazaron la fe, entre ellos Dionisio, miembro del Areópago, una mujer llamada Damaris y algunos otros."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Tiempo después Pablo dejó Atenas y se fue a Corinto."
,"2":"Allí se encontró con un judío llamado Aquila, natural del Ponto, que acababa de llegar de Italia con su esposa Priscila, a consecuencia de un decreto del emperador Claudio; porque todos los judíos habían recibido la orden de abandonar Roma. Pablo se acercó a ellos,"
,"3":"pues eran del mismo oficio y se dedicaban a fabricar tiendas. Y se quedó a vivir y a trabajar con ellos."
,"4":"Todos los sábados Pablo entablaba discusiones en la sinagoga, tratando de convencer tanto a los judíos como a los griegos."
,"5":"Al llegar de Macedonia Silas y Timoteo, Pablo se dedicó por entero a la Palabra, y aseguraba a los judíos que Jesús era el Mesías."
,"6":"Como se oponían y le respondían con insultos, se sacudió el polvo de sus vestidos mientras les decía: 'Nada tengo ya que ver con lo que les suceda; ustedes son los únicos responsables. En adelante me dirigiré a los paganos.'"
,"7":"Pablo cambió de lugar y se fue a la casa de un tal Tito Justo, de los que temen a Dios, que estaba pegada a la sinagoga."
,"8":"Crispo, uno de los dirigentes de la sinagoga, creyó en el Señor con toda su familia; y de los corintios que escuchaban a Pablo, muchos creían y se hacían bautizar."
,"9":"Una noche el Señor le dijo a Pablo en una visión: 'No tengas miedo, sigue hablando y no calles,"
,"10":"pues en esta ciudad me he reservado un pueblo numeroso. Yo estoy contigo y nadie podrá hacerte daño.'"
,"11":"Pablo siguió enseñando entre ellos la Palabra de Dios, y permaneció allí un año y seis meses."
,"12":"Siendo Galión gobernador de Acaya, los judíos acordaron unánimemente hacer una manifestación contra Pablo; lo llevaron ante el tribunal y lo acusaron:"
,"13":"'Este hombre incita a la gente a que adoren a Dios de una manera que prohíbe nuestra Ley.'"
,"14":"Pablo iba a contestar, cuando Galión dijo a los judíos: 'Judíos, si se tratara de una injusticia o de algún crimen, sería correcto que yo los escuchara."
,"15":"Pero como se trata de discusiones sobre mensajes, poderes superiores y sobre su Ley, arréglense entre ustedes mismos. Yo no quiero ser juez de tales asuntos. '"
,"16":"Y los echó del tribunal."
,"17":"Entonces toda la chusma agarró a Sóstenes, que era un dirigente de la sinagoga, y empezaron a golpearlo delante del tribunal, pero Galión no se preocupó de ello."
,"18":"Pablo se quedó en Corinto todavía por algún tiempo. Después se despidió de los hermanos y se embarcó para Siria, acompañado por Priscila y Aquila. Había hecho un voto, y solamente en el puerto de Cencreas se cortó el pelo."
,"19":"Así fue como llegaron a Efeso, y allí dejó que ellos se fueran. Pablo entró en la sinagoga y empezó a discutir con los judíos. "
,"20":"Le rogaban que se quedara en Efeso por más tiempo, pero Pablo no aceptó,"
,"21":"y se despidió de ellos con estas palabras: 'Si Dios quiere, volveré de nuevo por aquí.' Y se fue de Efeso por mar."
,"22":"Desembarcó en Cesarea. Subió a saludar a aquella Iglesia y después bajó a Antioquía."
,"23":"Permaneció allí por algún tiempo, y luego se fue a recorrer una ciudad tras otra, las regiones de Galacia y Frigia, fortaleciendo a los discípulos."
,"24":"Un judío llamado Apolo, natural de Alejandría, había llegado a Efeso. Era un orador elocuente y muy entendido en las Escrituras."
,"25":"Le habían enseñado algo del camino del Señor, y hablaba con mucho entusiasmo. Enseñaba en forma acertada lo referente a Jesús, aunque sólo se había quedado con el bautismo de Juan."
,"26":"Hablaba, pues, con mucha convicción en la sinagoga. Al oírlo Aquila y Priscila, lo llevaron consigo y le expusieron con mayor precisión el camino."
,"27":"Como pensaba pasar por Acaya, los hermanos lo alentaron y escribieron a los discípulos para que lo recibieran. De hecho, cuando llegó, ayudó muchísimo a los que la gracia de Dios había llevado a la fe,"
,"28":"pues rebatía públicamente y con gran acierto a los judíos, demostrando con las Escrituras que Jesús es el Mesías."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Mientras Apolo estaba en Corinto, Pablo llegó a Efeso atravesando las regiones altas; encontró allí a algunos discípulos"
,"2":"y les preguntó: '¿Recibieron el Espíritu Santo cuando abrazaron la fe?' Le contestaron: 'Ni siquiera hemos oído decir que se reciba el Espíritu Santo.'"
,"3":"Pablo les replicó: 'Entonces, ¿qué bautismo han recibido?' Respondieron: 'El bautismo de Juan.'"
,"4":"Entonces Pablo les explicó: 'Si bien Juan bautizaba con miras a un cambio de vida, pedía al pueblo que creyeran en aquel que vendría después de él, esto es, en Jesús.'"
,"5":"Al oír esto se hicieron bautizar en el nombre del Señor Jesús,"
,"6":"y al imponerles Pablo las manos, el Espíritu Santo bajó sobre ellos y empezaron a hablar lenguas y a profetizar."
,"7":"Eran unos doce hombres."
,"8":"Pablo entró en la sinagoga y durante tres meses les habló con convicción sobre el Reino de Dios, tratando de persuadirles."
,"9":"Al ver que algunos, en vez de creer, se endurecían más y criticaban públicamente el camino, se separó de ellos. Tomaba aparte a sus discípulos y diariamente les enseñaba en la escuela de un tal Tirano desde las once hasta las cuatro de la tarde."
,"10":"Hizo esto durante dos años, de tal manera que todos los habitantes de la provincia de Asia, tanto judíos como griegos, pudieron escuchar la Palabra del Señor."
,"11":"Dios obraba prodigios extraordinarios por las manos de Pablo,"
,"12":"hasta tal punto que imponían a los enfermos pañuelos o ropas que él había usado, y mejoraban. También salían de ellos los espíritus malos."
,"13":"Incluso algunos judíos ambulantes que echaban demonios, trataron de invocar el nombre del Señor Jesús sobre los que tenían espíritus malos, diciendo: 'Yo te ordeno en el nombre de ese Jesús a quien Pablo predica.'"
,"14":"Entre los que hacían esto estaban los hijos de un sacerdote judío, llamado Escevas. Un día entraron en una casa y se atrevieron a hacer eso,"
,"15":"pero el espíritu malo les contestó: 'Conozco a Jesús y sé quién es Pablo, pero ustedes, ¿quiénes son?'"
,"16":"Y el hombre que tenía el espíritu malo se lanzó sobre ellos, los sujetó a ambos y los maltrató de tal manera que huyeron de la casa desnudos y malheridos."
,"17":"La noticia llegó a todos los habitantes de Efeso, tanto judíos como griegos. Todos quedaron muy atemorizados, y el Nombre del Señor Jesús fue tenido en gran consideración."
,"18":"Muchos de los que habían aceptado la fe venían a confesar y exponer todo lo que antes habían hecho."
,"19":"No pocos de los que habían practicado la magia hicieron un montón con sus libros y los quemaron delante de todos. Calculado el precio de los libros, se estimó en unas cincuenta mil monedas de plata."
,"20":"De esta forma la Palabra de Dios manifestaba su poder, se extendía y se robustecía."
,"21":"Después de todos estos acontecimientos, Pablo tomó su decisión en el Espíritu: ir a Jerusalén pasando por Macedonia y Acaya. Y decía: 'Después de llegar allí, tengo que ir también a Roma.'"
,"22":"Envió a Macedonia a dos de sus auxiliares, a Timoteo y a Erasto, mientras él se quedaba por algún tiempo más en Asia."
,"23":"Fue en ese tiempo cuando se produjo un gran tumulto en la ciudad a causa del camino."
,"24":"Un platero, llamado Demetrio, fabricaba figuritas de plata del templo de Artemisa, y con esto procuraba buenas ganancias a los artífices."
,"25":"Reunió a éstos junto con otros que vivían de artes parecidas y les dijo: 'Compañeros, ustedes saben que esta industria es la que nos deja las mayores ganancias."
,"26":"Pero como ustedes mismos pueden ver y oír, ese Pablo ha cambiado la mente de muchísimas personas, no sólo en Efeso, sino en casi toda la provincia de Asia. Según él, los dioses no pueden salir de manos humanas."
,"27":"No son sólo nuestros intereses los que salen perjudicados, sino que también el templo de la gran diosa Artemisa corre peligro de ser desprestigiado. Al final se acabará la fama de aquella a quien adora toda el Asia y el mundo entero.'"
,"28":"Este discurso despertó el furor de los oyentes y empezaron a gritar: '¡Grande es la Artemisa de los Efesios!'"
,"29":"El tumulto se propagó por toda la ciudad. La gente se precipitó al teatro arrastrando consigo a Gayo y Aristarco, dos macedonios, compañeros de viaje de Pablo."
,"30":"Pablo quería enfrentarse con la muchedumbre, pero los discípulos no lo dejaron."
,"31":"Incluso algunos consejeros, amigos suyos, de la provincia de Asia, le mandaron a decir que no se arriesgara a ir al teatro."
,"32":"Mientras tanto la asamblea estaba sumida en una gran confusión. Unos gritaban una cosa, otros otra, y la mayor parte no sabían ni por qué estaban allí."
,"33":"En cierto momento algunos hicieron salir de entre la gente a un tal Alejandro, a quien los judíos empujaban adelante. Quería justificarlos ante el pueblo y pidió silencio con la mano."
,"34":"Pero cuando se dieron cuenta de que era judío, todos a una voz se pusieron a gritar, y durante casi dos horas sólo se oyó este grito: '¡Grande es la Artemisa de los efesios!'"
,"35":"Al fin el secretario de la ciudad logró calmar a la multitud y dijo: 'Ciudadanos de Efeso, ¿quién no sabe que la ciudad de Éfeso guarda el templo de la gran Artemisa y su imagen caída del cielo?"
,"36":"Siendo esto algo tan evidente, conviene que ustedes se calmen y no cometan ninguna locura."
,"37":"Estos hombres que han traído aquí no han profanado el templo ni han insultado a nuestra diosa."
,"38":"Si Demetrio y sus artífices tienen cargos contra alguno, para eso están las audiencias y los magistrados: que presenten allí sus acusaciones."
,"39":"Y si el asunto es de mayor importancia, que se resuelva en la asamblea legal."
,"40":"¿Han pensado ustedes que podríamos ser acusados de rebelión por lo ocurrido hoy? No tendríamos excusa alguna para justificar este tumulto.'"
,"41":"Y dicho esto, disolvió la asamblea."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Cuando se calmó el tumulto, Pablo mandó llamar a sus discípulos para animarlos. Se despidió de ellos y se fue a Macedonia."
,"2":"Después de recorrer aquellas regiones, en las que multiplicó sus predicaciones para confortar a los discípulos, llegó a Grecia."
,"3":"Pasó allí tres meses y luego pensó en volver a Siria por barco. Pero supo que los judíos tramaban algo contra él, y decidió regresar por Macedonia."
,"4":"Al marcharse de Asia, se fueron también con él Sópatros, hijo de Pirro, de Berea; Aristarco y Segundo, de Tesalónica; Gayo, de Derbe, y Timoteo; Tíquico y Trófimo, de Asia."
,"5":"Todos estos se fueron por delante y nos esperaron en Tróade."
,"6":"Nosotros nos embarcamos en Filipos apenas terminaron las fiestas de los Panes Azimos. Cinco días después nos reunimos con ellos en Tróade, donde nos detuvimos siete días."
,"7":"El primer día de la semana estábamos reunidos para la fracción del pan, y Pablo, que debía irse al día siguiente, comenzó a conversar con ellos. Pero su discurso se alargó hasta la medianoche."
,"8":"Había bastantes lámparas encendidas en la pieza del piso superior donde estábamos reunidos."
,"9":"Un joven, llamado Eutico, estaba sentado en el borde de la ventana, y como Pablo no terminaba de hablar, el sueño acabó por vencerle. Se durmió y se cayó desde el tercer piso al suelo. Lo recogieron muerto."
,"10":"Pablo, entonces, bajó, se inclinó sobre él, y después de tomarlo en sus brazos, dijo: 'No se alarmen, pues su alma está en él.'"
,"11":"Subió de nuevo, partió el pan y comió. Luego siguió conversando con ellos hasta el amanecer, y se fue."
,"12":"En cuanto al joven, lo trajeron vivo, lo que fue para todos un gran consuelo."
,"13":"Nosotros tomamos el barco para Aso; debíamos llegar antes que Pablo y recogerlo allí, pues se había decidido que él haría el viaje por tierra."
,"14":"Efectivamente, nos encontró en Aso. Subió a la nave con nosotros y llegamos a Mitilene."
,"15":"Al día siguiente zarpamos y llegamos a Quíos. Al otro día llegamos a Samos y un día después a Mileto, con una escala en Trogilón."
,"16":"Pablo había decidido no hacer escala en Efeso ni demorarse más en Asia, pues, de ser posible, quería estar en Jerusalén para el día de Pentecostés."
,"17":"Debido a eso, desde Mileto Pablo envió un mensaje a Efeso para convocar a los presbíteros de la Iglesia."
,"18":"Cuando ya estuvieron a su lado, les dijo: 'Ustedes han sido testigos de mi forma de actuar durante todo el tiempo que he pasado entre ustedes, desde el primer día que llegué a Asia."
,"19":"He servido al Señor con toda humildad, entre las lágrimas y las pruebas que me causaron las trampas de los judíos."
,"20":"Saben que nunca me eché atrás cuando algo podía ser útil para ustedes. Les prediqué y enseñé en público y en las casas,"
,"21":"exhortando con insistencia tanto a judíos como a griegos a la conversión a Dios y a la fe en Jesús, nuestro Señor."
,"22":"Ahora voy a Jerusalén, atado por el Espíritu, sin saber lo que allí me sucederá;"
,"23":"solamente que en cada ciudad el Espíritu Santo me advierte que me esperan prisiones y pruebas."
,"24":"Pero ya no me preocupo por mi vida, con tal de que pueda terminar mi carrera y llevar a cabo la misión que he recibido del Señor Jesús: anunciar la Buena Noticia de la gracia de Dios."
,"25":"Ahora sé que ya no me volverán a ver todos ustedes, entre quienes pasé predicando el Reino."
,"26":"Por eso hoy les quiero declarar que no me siento culpable si ustedes se pierden,"
,"27":"pues nunca ahorré esfuerzos para anunciarles plenamente la voluntad de Dios."
,"28":"Cuiden de sí mismos y de todo el rebaño en el que el Espíritu Santo les ha puesto como obispos (o sea, supervisores): pastoreen la Iglesia del Señor, que él adquirió con su propia sangre."
,"29":"Sé que después de mi partida se introducirán entre ustedes lobos voraces que no perdonarán al rebaño."
,"30":"De entre ustedes mismos surgirán hombres que enseñarán doctrinas falsas e intentarán arrastrar a los discípulos tras sí."
,"31":"Estén, pues, atentos, y recuerden que durante tres años no he dejado de aconsejar a cada uno de ustedes noche y día, incluso entre lágrimas."
,"32":"Ahora los encomiendo a Dios y a su Palabra portadora de su gracia, que tiene eficacia para edificar sus personas y entregarles la herencia junto a todos los santos."
,"33":"De nadie he codiciado plata, oro o vestidos."
,"34":"Miren mis manos: con ellas he conseguido lo necesario para mí y para mis compañeros, como ustedes bien saben."
,"35":"Con este ejemplo les he enseñado claramente que deben trabajar duro para ayudar a los débiles. Recuerden las palabras del Señor Jesús: 'Hay mayor felicidad en dar que en recibir.'"
,"36":"Dicho esto, Pablo se arrodilló con ellos y oró."
,"37":"Entonces empezaron todos a llorar y le besaban abrazados a su cuello."
,"38":"Todos estaban muy afligidos porque les había dicho que no le volverían a ver. Después lo acompañaron hasta el barco."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Cuando llegó la hora de partir, nos separamos a la fuerza de ellos y nuestro barco salió rumbo a Cos. Al día siguiente llegamos a Rodas, y de allí, a Pátara,"
,"2":"donde encontramos otro barco que estaba para salir hacia Fenicia. Subimos a bordo y partimos."
,"3":"Divisamos la isla de Chipre y, dejándola a la izquierda, navegamos rumbo a Siria. Atracamos en Tiro, pues el barco debía dejar su carga en aquel puerto."
,"4":"Aquí encontramos a los discípulos y nos detuvimos siete días. Advertían a Pablo con mensajes proféticos que no subiera a Jerusalén; "
,"5":"pero a pesar de ello, cuando llegó la fecha en que debíamos marchar, partimos. Nos acompañaron todos con sus mujeres y niños hasta fuera de la ciudad, y llegados a la playa, nos arrodillamos y oramos."
,"6":"Después de los abrazos subimos a la nave, mientras ellos volvían a sus casas."
,"7":"De Tiro fuimos a Tolemaida, terminando así nuestra travesía. Saludamos a los hermanos y nos quedamos un día con ellos."
,"8":"Al día siguiente nos dirigimos a Cesarea. Entramos en casa de Felipe, el evangelista, que era uno de los siete, y nos hospedamos allí;"
,"9":"tenía cuatro hijas que se habían quedado vírgenes y tenían el don de profecía."
,"10":"Llevábamos allí algunos días, cuando nos salió al encuentro un profeta de Judea, llamado Agabo."
,"11":"Se acercó a nosotros, tomó el cinturón de Pablo, se ató con él de pies y manos y dijo: 'Esto dice el Espíritu Santo: Así atarán los judíos al dueño de este cinturón y lo entregarán en manos de los extranjeros.'"
,"12":"Al oír esto, nosotros y los de Cesarea rogamos a Pablo que no subiera a Jerusalén."
,"13":"Pero él nos contestó: '¿Por qué me destrozan el corazón con sus lágrimas? Yo estoy dispuesto no sólo a ser encarcelado, sino también a morir en Jerusalén por el Nombre del Señor Jesús.'"
,"14":"Como no logramos convencerlo, dejamos de insistir y dijimos: 'Hágase la voluntad del Señor.'"
,"15":"Pasados aquellos días, terminamos los preparativos del viaje y subimos a Jerusalén."
,"16":"Algunos discípulos de Cesarea que nos acompañaban nos llevaron a casa de un chipriota, llamado Nasón, discípulo desde los primeros tiempos, donde nos íbamos a hospedar."
,"17":"Al llegar a Jerusalén, los hermanos nos recibieron con alegría."
,"18":"Al día siguiente acompañamos a Pablo a casa de Santiago, donde se habían reunido todos los presbíteros."
,"19":"Pablo los saludó y fue contando detalladamente todas las cosas que Dios había realizado entre los paganos por su ministerio."
,"20":"Todos, por supuesto, dieron gloria a Dios por lo que escuchaban, pero luego le dijeron: 'Bien sabes, hermano, cuántas decenas de millares de judíos han abrazado la fe en Judea, y todos ellos son celosos partidarios de la Ley."
,"21":"Por otra parte han oído decir que enseñas a todos los judíos del mundo pagano que se aparten de Moisés, que no circunciden a sus hijos ni vivan según las tradiciones judías."
,"22":"De todos modos se van a enterar de que has llegado, y entonces ¿qué hacer?"
,"23":"Reuniremos la asamblea, y harás lo que te vamos a decir. Hay entre nosotros cuatro hombres que han hecho un voto"
,"24":"y tú los vas a apadrinar. Te purificarás con ellos y pagarás los gastos cuando se hagan cortar el pelo. Así verán todos que es falso lo que han oído decir de ti y que, por el contrario, tú también cumples la Ley."
,"25":"En cuanto a los creyentes de origen no judío, ya les hemos enviado instrucciones, pidiéndoles que se abstengan de carne sacrificada a los ídolos, de la sangre y de la carne de animales sin sangrar y de las relaciones sexuales prohibidas.'"
,"26":"Pablo, pues, apadrinó a aquellos hombres. Al día siguiente se purificó con ellos y entró en el Templo para notificar qué día concluiría su tiempo de purificación y se ofrecería el sacrificio por cada uno de ellos."
,"27":"Estaban para cumplirse los siete días, cuando unos judíos de Asia vieron a Pablo en el Templo y empezaron a alborotar a la gente. Agarraron a Pablo"
,"28":"y gritaron: '¡Israelitas, ayúdennos! Este es el hombre que por todas partes predica a todos en contra de nuestro pueblo, de la Ley y de este Lugar Santo. Y ahora incluso ha introducido a unos griegos dentro del Templo, profanando este Lugar Santo.'"
,"29":"Decían esto porque poco antes habían visto a Pablo en la ciudad acompañado de Trófimo, natural de Efeso, y pensaron que Pablo lo había llevado al Templo."
,"30":"La ciudad entera se alborotó. Concurrió la gente de todas partes, y tomando a Pablo, lo arrastraron hacia la salida del Templo, cerrando inmediatamente las puertas."
,"31":"Querían matarlo, pero llegó al comandante del batallón la noticia de que toda Jerusalén estaba alborotada."
,"32":"En seguida tomó consigo algunos oficiales y soldados y bajaron corriendo hacia la multitud. Al ver al comandante y a los soldados, dejaron de golpear a Pablo."
,"33":"El comandante se acercó, hizo arrestar a Pablo y ordenó que lo ataran con dos cadenas. Después preguntó quién era y qué había hecho."
,"34":"Pero entre la gente unos gritaban una cosa y otros otra. Al ver el comandante que no podía sacar nada en claro a causa del alboroto, dio orden de que llevaran a Pablo a la fortaleza."
,"35":"Al llegar a las escalinatas, los soldados tuvieron que levantarlo y llevarlo a hombros a causa de la violencia de la multitud,"
,"36":"pues un montón de gente lo seguía gritando: '¡Mátalo!'"
,"37":"Cuando estaban ya para meterlo dentro de la fortaleza, Pablo dijo al comandante: '¿Me permites decirte una palabra?' Le contestó: '¡Pero tú hablas griego!"
,"38":"¿No eres, entonces, el egipcio que últimamente se rebeló y llevó al desierto a cuatro mil terroristas?'"
,"39":"Pablo respondió: 'Yo soy judío, ciudadano de Tarso, ciudad muy conocida de Cilicia. Permíteme, por favor, hablar al pueblo.'"
,"40":"El comandante se lo permitió. Entonces Pablo, de Pie en la escalinata, hizo un gesto con la mano y se produjo un gran silencio. Después empezó a hablar al pueblo en lengua hebrea."
}`)
	CurrentBook.AddChapter(22, `{
"1":"'Hermanos y padres, escúchenme, pues les quiero dar algunas explicaciones.'"
,"2":"Al oír que les hablaba en hebreo, se calmó más aún su agitación. Y Pablo continuó:"
,"3":"'Yo soy judío, nacido en Tarso de Cilicia, pero educado en esta ciudad. Teniendo a Gamaliel de maestro, fui instruido en la Ley de nuestros padres en la forma más seria, y era un fanático del servicio de Dios, como ustedes ahora."
,"4":"Así que perseguí a muerte a este camino e hice encadenar y meter en la cárcel a hombres y mujeres;"
,"5":"esto lo saben muy bien el sumo sacerdote y el Consejo de los Ancianos. Incluso me entregaron cartas para nuestros hermanos de Damasco, y salí para detener a los cristianos que allí había y traerlos encadenados a Jerusalén para que fueran castigados."
,"6":"Iba de camino, y ya estaba cerca de Damasco, cuando a eso de mediodía se produjo un relámpago y me envolvió de repente una luz muy brillante que venía del cielo."
,"7":"Caí al suelo y oí una voz que me decía: 'Saulo, Saulo, ¿por qué me persigues?'"
,"8":"Yo respondí: '¿Quién eres, Señor?' Y él me dijo: 'Yo soy Jesús el Nazareno, a quien tú persigues.'"
,"9":"Los que me acompañaban vieron la luz y se asustaron, pero no oyeron al que me hablaba."
,"10":"Entonces yo pregunté: 'Qué debo hacer, Señor?' Y el Señor me respondió: 'Levántate y vete a Damasco. Allí te hablarán de la misión que te ha sido asignada.'"
,"11":"El resplandor de aquella luz me dejó ciego, y entré en Damasco llevado de la mano por mis compañeros."
,"12":"Allí vino a verme un tal Ananías, un hombre muy observante de la Ley y muy estimado por todos los judíos que vivían en Damasco."
,"13":"Me dijo: 'Saulo, hermano mío, recobra la vista'. Y en el mismo instante pude verle."
,"14":"Entonces agregó: 'El Dios de nuestros padres te ha elegido para que conozcas su voluntad, veas al Justo y oigas su propia voz."
,"15":"Con todo lo que has visto y oído serás en adelante su testigo ante las personas más diversas."
,"16":"Y ahora, ¿a qué esperas? Levántate, recibe el bautismo y lava tus pecados invocando su Nombre.'"
,"17":"Después de regresar a Jerusalén, mientras un día me encontraba orando en el Templo, tuve un éxtasis."
,"18":"Vi al Señor que me decía: 'Muévete y sal pronto de Jerusalén, pues no escucharán el testimonio que les des de mí.'"
,"19":"Yo respondí: 'Señor, ellos saben que yo recorría las sinagogas encarcelando y azotando a los que creían en ti."
,"20":"Y cuando se derramó la sangre de tu testigo Esteban, yo me encontraba allí; estaba de acuerdo con ellos e incluso guardaba las ropas de los que le daban muerte.'"
,"21":"Pero el Señor me dijo: 'Anda; ahora te voy a enviar lejos, a las naciones paganas.'"
,"22":"Hasta este punto la gente estuvo escuchando a Pablo, pero al oír estas últimas palabras se pusieron a gritar: '¡Mata a ese hombre! ¡No tiene derecho a vivir!'"
,"23":"Vociferaban, agitaban sus vestidos y tiraban tierra al aire."
,"24":"Entonces el comandante ordenó que lo metieran dentro de la fortaleza y lo azotaran para que confesara por qué motivo gritaban de aquella manera contra él."
,"25":"Pero cuando quisieron quitarle la ropa, Pablo preguntó al oficial que estaba allí presente: '¿Es conforme a la ley azotar a un ciudadano romano sin haberlo antes juzgado?'"
,"26":"Al oír esto, el oficial fue donde el comandante y le dijo: '¡Qué ibas a hacer! Ese hombre es un ciudadano romano.'"
,"27":"El comandante vino y le preguntó: 'Dime, ¿eres ciudadano romano?' 'Sí', respondió Pablo."
,"28":"El comandante comentó: 'A mí me costó mucho dinero hacerme ciudadano romano.' Pablo le contestó: 'Yo lo soy por nacimiento.'"
,"29":"Al momento se retiraron los que estaban para torturarlo, y el mismo comandante tuvo miedo porque había hecho encadenar a un ciudadano romano."
,"30":"Al día siguiente hizo soltar a Pablo. Quería conocer con certeza cuáles eran los cargos que los judíos tenían contra él, y mandó que se reunieran los jefes de los sacerdotes y todo el Consejo que llaman Sanedrín. Después hizo bajar a Pablo para que compareciera ante ellos."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Pablo miró fijamente al Sanedrín y les dijo: 'Hermanos, hasta el día de hoy he actuado rectamente ante Dios.'"
,"2":"A este punto el sumo sacerdote Ananías ordenó a sus asistentes que le golpearan en la boca."
,"3":"Pablo entonces le dijo: 'Dios te golpeará a ti, pared blanqueada. Estás ahí sentado para juzgarme según la Ley, y tú violas la Ley ordenando que me golpeen.'"
,"4":"Los que estaban a su lado le dijeron: 'Estás insultando al sumo sacerdote de Dios.'"
,"5":"Pablo contestó: 'Hermanos, yo no sabía que fuera el sumo sacerdote, pues está escrito: No insultarás al jefe de tu pueblo.'"
,"6":"Pablo sabía que una parte de ellos eran saduceos y la otra fariseos. Así que declaró en medio del Sanedrín: 'Hermanos, yo soy fariseo e hijo de fariseos. Y ahora me están juzgando a causa de nuestra esperanza, a causa de la resurrección de los muertos.'"
,"7":"Apenas hizo esta declaración, se originó una gran discusión entre los fariseos y los saduceos, y la asamblea se dividió."
,"8":"Porque los saduceos dicen que no hay resurrección, ni ángeles, ni espíritu, mientras que los fariseos admiten todo eso."
,"9":"Se armó, pues, un enorme griterío. Algunos maestros de la Ley que eran del partido de los fariseos se pusieron en Pie, afirmando: 'Nosotros no hallamos nada malo en este hombre. Tal vez le haya hablado un espíritu o un ángel.'"
,"10":"La discusión se hizo tan violenta que el capitán tuvo miedo de que despedazaran a Pablo. Ordenó, entonces, que vinieran los soldados, sacaran a Pablo de allí y lo llevaran de nuevo a la fortaleza."
,"11":"Aquella misma noche el Señor se acercó a Pablo y le dijo: '¡Animo! Así como has dado testimonio de mí aquí en Jerusalén, tendrás que darlo también en Roma.'"
,"12":"Al amanecer se reunieron algunos judíos y se comprometieron con juramento a no comer ni beber hasta dar muerte a Pablo."
,"13":"Los comprometidos en esta conjuración eran más de cuarenta."
,"14":"Se presentaron, pues, a los jefes de los sacerdotes y a los ancianos y les dijeron: 'Nos hemos comprometido bajo juramento a no probar comida alguna hasta que no hayamos dado muerte a Pablo."
,"15":"Ahora les toca a ustedes, con el Consejo, obtener del comandante que haga bajar de nuevo a Pablo con pretexto de examinar más a fondo su caso. Nosotros, por nuestra parte, estamos preparados para matarlo antes de que llegue.'"
,"16":"Pero el sobrino de Pablo, hijo de su hermana, se enteró de esta emboscada y fue a la fortaleza a informarle."
,"17":"Entonces Pablo llamó a un oficial y le dijo: 'Lleva a este joven ante el comandante, pues tiene algo que contarle.'"
,"18":"El oficial se lo llevó ante el comandante y le dijo: 'El preso Pablo me llamó y me pidió que te trajera a este joven, pues tiene algo que decirte.'"
,"19":"El comandante lo tomó de la mano, lo llevó aparte y le preguntó: '¿Qué tienes que contarme?'"
,"20":"El joven respondió: 'Los judíos han decidido pedirte que mañana lleves a Pablo al Sanedrín con el pretexto de examinar más de cerca su caso."
,"21":"Pero no les creas, porque hay más de cuarenta hombres de ellos listos para tenderle una trampa. Se han comprometido bajo juramento a no comer ni beber hasta que no le hayan dado muerte. Ya están preparados esperando tu decisión.'"
,"22":"El comandante despidió al joven con esta advertencia: 'Que nadie se entere de que me has dado esta información.'"
,"23":"Después llamó a dos oficiales y les dijo: 'Estén listos para salir hacia Cesarea esta noche después de las doce con doscientos soldados, setenta de caballería y doscientos auxiliares."
,"24":"Preparen también cabalgaduras para llevar a Pablo y entregarlo sano y salvo al gobernador Félix.'"
,"25":"El comandante escribió la siguiente carta al gobernador:"
,"26":"'Claudio Lisias saluda al excelentísimo gobernador Félix y le comunica lo siguiente:"
,"27":"Los judíos habían detenido a este hombre y estaban a punto de matarlo, cuando me enteré de que era un ciudadano romano e intervine con la tropa para arrancarlo de sus manos."
,"28":"Como quería saber de qué lo acusaban, lo presenté ante el Sanedrín,"
,"29":"y descubrí que lo acusaban por cuestiones de su Ley, pero que no había ningún cargo que mereciera la muerte o la prisión."
,"30":"Después me enteré de que los judíos preparaban una emboscada contra este hombre, por lo que decidí enviártelo, y dije a sus acusadores que presentaran sus quejas ante ti. Adiós.'"
,"31":"De acuerdo a las instrucciones recibidas, los soldados tomaron a Pablo y lo llevaron de noche a Antípatris."
,"32":"Al día siguiente regresaron a la fortaleza, y los de caballería siguieron viaje con él."
,"33":"Al llegar a Cesarea, entregaron la carta al gobernador y le presentaron a Pablo."
,"34":"Félix se informó y preguntó a Pablo de qué comarca era; al saber que era de Cilicia,"
,"35":"le dijo: 'Te oiré cuando estén presentes tus acusadores.' Y mandó que lo custodiaran en el palacio de Herodes."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Cinco días después, el sumo sacerdote Ananías bajó a Cesarea con algunos ancianos y un abogado llamado Tértulo, y presentaron una demanda contra Pablo ante el gobernador."
,"2":"Fue llamado Pablo, y Tértulo empezó su acusación:"
,"3":"'Excelentísimo Félix, gozamos de gran paz gracias a ti y las reformas que supiste promover para bien de esta nación. Todo esto lo reconocemos de mil maneras y en cualquier lugar, y te estamos plenamente agradecidos."
,"4":"Pero no quisiera abusar más de tu tiempo y solamente te ruego nos escuches un momento con tu acostumbrada comprensión."
,"5":"Nos consta que este hombre es peor que la peste, crea divisiones entre los judíos de todo el mundo y es un dirigente de la secta de los Nazarenos."
,"6":"Incluso intentaba profanar el Templo cuando lo tomamos preso. Queríamos juzgarlo según nuestra Ley,"
,"7":"pero el comandante Lisias intervino en forma muy violenta y nos obligó a soltarlo."
,"8":"Luego declaró que sus acusadores tenían que presentarse ante ti. Si tú lo interrogas, podrás comprobar todas las cosas de que lo acusamos.'"
,"9":"Los judíos lo apoyaron, afirmando que realmente las cosas eran así."
,"10":"Entonces el gobernador dio la palabra a Pablo, que contestó: 'Sé que has administrado esta nación durante muchos años, y esto me hace sentir muy confiado para exponer mi defensa. "
,"11":"Tú mismo podrás comprobar que no hace más de doce días que subí a Jerusalén en peregrinación,"
,"12":"y que nadie me sorprendió discutiendo en el Templo o alborotando a la gente ni en las sinagogas ni en la ciudad;"
,"13":"de modo que no pueden probar las cargos de que ahora me acusan."
,"14":"Pero sí admito ante ti que sirvo al Dios de nuestros padres según nuestro camino, que ellos llaman secta. Creo en todo lo que está escrito en la Ley y los Profetas"
,"15":"y espero de Dios, como ellos mismos esperan, la resurrección de los muertos, tanto de los justos como de los pecadores."
,"16":"Por eso yo también me esfuerzo por tener siempre la conciencia limpia ante Dios y ante los hombres."
,"17":"Después de muchos años he vuelto a traer ayuda a los de mi nación y a ofrecer sacrificios."
,"18":"Y esta es la razón por la que me encontraron en el Templo. Me había purificado según la Ley, y no había aglomeración de gente ni tumulto."
,"19":"Todo empezó por causa de unos judíos de Asia que hoy deberían estar aquí para acusarme, si es que tienen algo contra mí."
,"20":"Que los aquí presentes digan qué crimen hallaron en mí cuando comparecí ante el Sanedrín,"
,"21":"a no ser esto que dije en voz alta ante ellos: 'Yo soy juzgado hoy por ustedes a causa de la resurrección de los muertos'.'"
,"22":"Félix, que estaba bien informado sobre el Camino, postergó el caso con estas palabras: 'Cuando baje el comandante Lisias, resolveré este caso.'"
,"23":"Dio instrucciones al oficial para que vigilara a Pablo, pero dejándole cierta libertad y sin impedir a los suyos que lo atendieran."
,"24":"Algunos días después vino Félix con su esposa, Drusila, que era judía. Mandó llamar a Pablo y lo dejó hablar de la fe en Cristo."
,"25":"Pero cuando habló de la justicia, del dominio de los instintos y del juicio futuro, Félix se asustó y le dijo: 'Por ahora puedes irte; te llamaré en otra oportunidad.'"
,"26":"Félix tenía esperanza de que Pablo le ofreciese dinero, y por eso lo llamaba a menudo para conversar con él."
,"27":"Pasaron así dos años. Entonces Felix fue reemplazado por Porcio Festo, y como quería quedar bien con los judíos, dejó a Pablo preso."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Tres días después de su llegada a la provincia, Festo subió de Cesarea a Jerusalén."
,"2":"Allí los jefes de los sacerdotes y las autoridades de los judíos volvieron a acusar a Pablo. Insistieron"
,"3":"y pidieron a Festo, como un favor, que lo trajera a Jerusalén, pues ellos todavía planeaban matarlo en el camino."
,"4":"Festo les respondió que Pablo estaba bajo custodia en Cesarea y que él volvería muy pronto allá."
,"5":"'Los que entre ustedes tienen más autoridad, les dijo, bajen conmigo a Cesarea; y si ese hombre hizo algo condenable, presentarán sus acusaciones.'"
,"6":"Festo no permaneció en Jerusalén más de ocho o diez días y luego volvió a Cesarea. Al día siguiente se sentó en el tribunal y mandó llamar a Pablo."
,"7":"Apenas se presentó, los judíos que habían bajado de Jerusalén lo acosaron con numerosas y graves acusaciones. Pero no podían probar lo que alegaban."
,"8":"Pablo se defendió diciendo: 'Yo no he cometido ninguna falta contra la Ley de los judíos, ni contra el Templo, ni contra el César.'"
,"9":"Entonces Festo, que quería ganarse la amistad de los judíos, preguntó a Pablo: 'Si soy yo el que te va a juzgar, ¿quieres subir a Jerusalén?'"
,"10":"Pablo contestó: 'Estoy ante el tribunal del César; ahí debo ser juzgado. No he hecho ningún mal a los judíos, como tú muy bien sabes."
,"11":"Si he cometido algún delito que merezca la muerte, acepto morir. Pero si no he hecho nada de lo que me acusan, nadie tiene derecho a entregarme a ellos. Apelo al César.'"
,"12":"Entonces Festo, después de hablar con su consejo, decidió: 'Has apelado al César; al César irás.'"
,"13":"Transcurridos unos días, llegaron a Cesarea el rey Agripa y su hermana Berenice para saludar a Festo."
,"14":"Permanecieron allí algún tiempo, y Festo expuso al rey el caso de Pablo, diciéndole: 'Tenemos aquí a un hombre que Félix dejó preso. "
,"15":"Cuando estuve en Jerusalén, los jefes de los sacerdotes y los ancianos de los judíos presentaron quejas contra él y me pidieron que lo condenara."
,"16":"Yo les contesté que los romanos no acostumbran entregar a un hombre sin que haya tenido la oportunidad de defenderse de los cargos en presencia de sus acusadores."
,"17":"Vinieron, pues, conmigo y, sin demora, me senté al día siguiente en el tribunal y mandé traer al hombre."
,"18":"Se presentaron los acusadores, pero no lo demandaron por ninguno de los delitos que yo sospechaba."
,"19":"Sólo tenían contra él cuestiones referentes a sus creencias y a un cierto Jesús, ya muerto, de quien Pablo afirma que vive."
,"20":"Como yo me perdía en esos asuntos, le pregunté si quería ir a Jerusalén para ser juzgado allí sobre esas cosas."
,"21":"Pero Pablo apeló y pidió que el sumario lo hiciera el tribunal del emperador. Entonces ordené que lo mantuvieran bajo custodia hasta que pueda enviarlo al César.'"
,"22":"Agripa le dijo: 'Me gustaría escuchar a ese hombre.' Festo le contestó: 'Mañana lo oirás.'"
,"23":"Al día siguiente llegaron Agripa y Berenice con gran pompa y entraron en la sala de la audiencia acompañados por los jefes militares y las autoridades de la ciudad. Festo ordenó que trajeran a Pablo"
,"24":"y dijo: 'Rey Agripa y todos los presentes: aquí tienen al hombre contra quien toda la comunidad de los judíos ha venido a reclamarme, tanto en Jerusalén como aquí, pidiendo a gritos que no lo dejara con vida. "
,"25":"Yo, por mi parte, me convencí de que no había hecho nada digno de muerte, y como él mismo apelaba al emperador, decidí enviárselo."
,"26":"Pero todavía no tengo nada seguro para escribir a nuestro soberano respecto a él, y por eso lo presento aquí ante ustedes, y especialmente ante ti, rey Agripa, para que pueda escribir algo cuando se esclarezcan un poco más las cosas."
,"27":"Porque me parece absurdo enviar a un detenido sin señalar los cargos en su contra.'"
}`)
	CurrentBook.AddChapter(26, `{
"1":"Agripa dijo a Pablo: 'Puedes hablar en tu defensa.' Entonces Pablo extendió su mano y empezó a hablar así:"
,"2":"'Rey Agripa, me siento afortunado de poderme defender hoy ante ti de todo lo que me reprochan los judíos,"
,"3":"pues tú conoces perfectamente sus costumbres y las discusiones propias de ellos. Por eso te ruego tengas la bondad de escucharme."
,"4":"Todos los judíos saben cómo he vivido desde mi juventud tanto en la comunidad judía como en Jerusalén."
,"5":"Me han visto de tan cerca que, si quisieran, podrían testificar que he vivido como un fariseo en la secta más rigurosa de nuestra religión."
,"6":"Y si ahora soy aquí procesado, es por esperar la promesa hecha por Dios a nuestros padres;"
,"7":"de hecho, el culto perpetuo que nuestras doce tribus rinden a Dios noche y día no tiene otro propósito que el de alcanzar esta promesa. Por esta esperanza, oh rey, me acusan los judíos."
,"8":"Pero ¿por qué no quieren ustedes creer que Dios resucite a los muertos?"
,"9":"Yo mismo, al principio, consideré que era mi deber usar todos los medios para combatir el nombre de Jesús el Nazareno."
,"10":"Así lo hice en Jerusalén con los poderes que me dieron los jefes de los sacerdotes: hice encarcelar a muchos creyentes, y cuando eran condenados a muerte, yo di también mi voto."
,"11":"Recorría las sinagogas y multiplicaba los castigos para obligarlos a renegar de su fe, y tal era mi furor contra ellos, que los perseguía hasta fuera de nuestras fronteras."
,"12":"Con este propósito iba a Damasco con plenos poderes y por encargo de los jefes de los sacerdotes."
,"13":"En el camino, oh rey, a eso del mediodía, vi una luz que venía del cielo, más resplandeciente que el sol, que nos deslumbró a mí y a los que me acompañaban."
,"14":"Todos caímos al suelo y yo oí una voz que me decía en hebreo: 'Saulo, Saulo, ¿por qué me persigues? En vano pataleas contra el aguijón.'"
,"15":"Yo dije: '¿Quién eres, Señor?' Y el Señor dijo: 'Yo soy Jesús, a quien tú persigues."
,"16":"Ahora levántate y ponte en Pie: me he manifestado a ti para hacerte servidor y testigo de lo que has visto de mí y de lo que te mostraré más adelante."
,"17":"Yo te protegeré tanto de tu pueblo como de los paganos a quienes te envío."
,"18":"Tú les abrirás los ojos para que se conviertan de las tinieblas a la luz y del poder de Satanás a Dios: creyendo en mí se les perdonarán los pecados y compartirán la herencia de los santos.'"
,"19":"Yo, rey Agripa, no rechacé esta visión celestial."
,"20":"Muy por el contrario, empecé a predicar, primero a la gente de Damasco, luego en Jerusalén y en el país de los judíos, y por último en las naciones paganas. Y les pedía que se arrepintieran y se convirtieran a Dios, mostrando en adelante los frutos de una verdadera conversión."
,"21":"Por cumplir esta misión los judíos me detuvieron en el Templo y trataron de matarme."
,"22":"Pero, con la ayuda de Dios, seguí dando mi testimonio a grandes y pequeños hasta el día de hoy. En ningún momento me aparto de lo que Moisés y los Profetas dijeron de antemano:"
,"23":"que el Mesías tenía que morir; que sería el primero en resucitar de entre los muertos, y después anunciaría la luz tanto a su pueblo como a las demás naciones.'"
,"24":"Al llegar Pablo a este punto de su defensa, Festo exclamó con voz muy alta: 'Pablo, ¡tú estás loco! Tus muchos estudios te han trastornado la mente.'"
,"25":"'No estoy loco, excelentísimo Festo, contestó Pablo; estoy diciendo cosas verdaderas con mucho sentido."
,"26":"El rey está bien enterado de estas cosas, por eso le hablo con tanta libertad. Estoy convencido de que no ignora nada de este asunto, pues esas cosas no han sucedido en un rincón."
,"27":"Rey Agripa, ¿crees a los Profetas? Yo sé que crees.'"
,"28":"Agripa le contestó: '¡Un poco más y vas a pensar que ya me has hecho cristiano!'"
,"29":"Pablo le respondió: 'Por poco o por mucho, quiera Dios que no sólo tú, sino también todos los que hoy me escuchan, llegaran hasta donde yo he llegado, a excepción de estas cadenas.'"
,"30":"En ese momento el rey se levantó, y con él el gobernador, Berenice y todos los asistentes."
,"31":"Mientras se retiraban, conversaban entre sí y decían: 'Este no es hombre para hacer cosas que merezcan la muerte o la cárcel.'"
,"32":"Agripa dijo a Festo: 'Si no hubiese apelado al César, se le habría podido dejar en libertad.'"
}`)
	CurrentBook.AddChapter(27, `{
"1":"Cuando se decidió que nos debíamos embarcar rumbo a Italia, Pablo y otros prisioneros fueron entregados a un tal Julio, capitán del batallón Augusto."
,"2":"Subimos a bordo de un barco de Adrumeto que se dirigía a las costas de Asia y zarpamos; nos acompañaba Aristarco, un macedonio de la ciudad de Tesalónica."
,"3":"Llegamos a Sidón al día siguiente. Julio se mostró muy humano con Pablo y le permitió visitar a sus amigos y que pudieran atenderle."
,"4":"Partiendo de allí nos desviamos hacia Chipre, pues los vientos eran contrarios."
,"5":"Atravesamos los mares de Cilicia y Panfilia y llegamos a Mira de Licia."
,"6":"Allí el capitán encontró un barco de Alejandría que se dirigía a Italia, y nos hizo subir a bordo."
,"7":"Durante varios días navegamos lentamente, y con muchas dificultades llegamos frente a Cnido. Como el viento no nos dejaba entrar en ese puerto, navegamos al abrigo de Creta, dando vista al cabo Salmón."
,"8":"Lo costeamos con dificultad y llegamos a un lugar llamado Puertos Buenos, cerca de la ciudad de Lasea."
,"9":"El tiempo transcurría; ya había pasado la fiesta del Ayuno y la navegación empezaba a ser peligrosa."
,"10":"Entonces Pablo les dijo: 'Amigos, yo veo que la travesía es muy arriesgada, y vamos a perder no sólo la carga y la nave, sino también nuestras vidas.'"
,"11":"Pero el oficial romano confiaba más en el piloto y en el patrón del barco que en las palabras de Pablo."
,"12":"Como además este puerto era poco apropiado para pasar el invierno, la mayoría acordó partir, esperando alcanzar, con un poco de suerte, el puerto de Fénix, que está abierto hacia el suroeste y el noroeste, y donde pensaban pasar el invierno."
,"13":"Comenzó entonces a soplar un ligero viento del sur, y pensaron que lograrían su objetivo. Levaron anclas y costearon la isla de Creta."
,"14":"Pero poco después la isla fue barrida por un viento huracanado que llaman Euroaquilón."
,"15":"El barco fue arrastrado y no se logró hacer frente al viento, de manera que nos quedamos a la deriva."
,"16":"Mientras pasábamos al abrigo de una pequeña isla llamada Cauda, logramos con mucho esfuerzo recuperar el bote salvavidas."
,"17":"Una vez subido a bordo, hubo que asegurar el casco ciñéndolo por debajo con cables. Ante el peligro de encallar en las arenas de Sirte, soltaron el ancla flotante y nos dejamos arrastrar."
,"18":"El temporal era tan violento que al día siguiente tuvieron que arrojar al agua parte del cargamento."
,"19":"Al tercer día los marineros arrojaron al mar con sus propias manos también el aparejo del barco."
,"20":"Como la tempestad seguía con la misma violencia, los días pasaban y no se veían ni el sol ni las estrellas: estábamos perdiendo ya toda esperanza."
,"21":"Como hacía días que no comíamos, Pablo se puso en medio y les dijo: 'Amigos, ustedes tenían que haberme escuchado y no salir de Creta, pues nos habríamos ahorrado este peligro y esta pérdida."
,"22":"Pero ahora los invito a que recobren el ánimo; sepan que se va a perder el barco, pero no habrá pérdida de vidas."
,"23":"Anoche estuvo a mi lado un ángel del Dios a quien pertenezco y a quien sirvo,"
,"24":"y me dijo: 'Pablo, no tengas miedo: comparecerás ante el César, y Dios te concede la vida de todos los que navegan contigo.'"
,"25":"Animo, pues, amigos míos: yo confío en Dios y todo sucederá tal como me ha dicho."
,"26":"Acabaremos en alguna isla.'"
,"27":"Hacía ya catorce noches que éramos arrastrados a la deriva por el mar Adriático, cuando hacia la medianoche los marineros presintieron la proximidad de tierra."
,"28":"Midieron la profundidad del agua, y era de treinta y siete metros. Poco después la midieron de nuevo, y era de veintisiete metros."
,"29":"Temerosos de que fuéramos a chocar contra unas rocas, tiraron cuatro anclas desde la popa y esperaron ansiosamente a que amaneciera."
,"30":"En cierto momento los marineros intentaron huir del barco y bajaban el bote salvavidas al mar como si quisieran alargar los cables de las anclas de proa."
,"31":"Pero Pablo dijo al capitán y a los soldados: 'Si esos hombres abandonan el barco, ustedes no se salvarán.'"
,"32":"Entonces los soldados cortaron las amarras del bote y lo dejaron caer al agua."
,"33":"Como aún no amanecía, Pablo los invitó a que se alimentaran, diciéndoles: 'Hace catorce días que no tomamos nada; no hacemos más que esperar y permanecemos en ayunas."
,"34":"Si quieren salvarse, ¿por qué no comen? Les aseguro que ninguno de ustedes perecerá, y ni siquiera uno de sus cabellos se perderá.'"
,"35":"Dicho esto tomó pan, dio gracias a Dios delante de todos, lo partió y se puso a comer."
,"36":"Los otros se animaron y al fin todos se pusieron a comer."
,"37":"En total éramos (doscientas) setenta y seis personas en el barco."
,"38":"Una vez satisfechos, tiraron el trigo al mar para reducir el peso del barco."
,"39":"Cuando amaneció no reconocieron la tierra, pero divisaron una bahía con su playa, y acordaron hacer lo posible por encallar en ella el barco."
,"40":"Soltaron las anclas y las dejaron caer al mar mientras aflojaron las cuerdas de los timones; izaron al viento la vela delantera y se dejaron arrastrar hacia la playa."
,"41":"Pero chocaron contra un banco de arena y el barco quedó encallado: la proa se clavó y quedó inmóvil, mientras la popa se iba destrozando por los golpes violentos de las olas."
,"42":"Entonces los soldados pensaron en dar muerte a los presos por temor a que alguno se escapara nadando."
,"43":"Pero el capitán, que quería salvar a Pablo, no se lo permitió. Ordenó que los que supieran nadar se tiraran los primeros al agua y se dirigieran a la playa;"
,"44":"los demás se agarrarían a tablones o a restos de la nave. Así todos llegamos sanos y salvos a tierra."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Una vez a salvo, supimos que la isla se llamaba Malta."
,"2":"Los nativos nos trataron con una cordialidad poco común, encendieron una gran hoguera y nos cuidaron a todos, ya que llovía y hacía frío."
,"3":"Pablo había juntado una brazada de ramas secas y, al echarlas al fuego, una víbora que escapaba del calor se le enroscó en la mano."
,"4":"Al ver los nativos a la víbora colgando de la mano de Pablo, se dijeron unos a otros: 'Sin duda éste es un asesino. Aunque se haya salvado del mar, la justicia divina no lo deja vivir.'"
,"5":"Pero Pablo sacudió la víbora echándola al fuego y no sufrió daño alguno."
,"6":"Pensaban que se iba a hinchar o caer muerto de repente, pero después de esperar largo rato, vieron que no le pasaba nada. Entonces cambiaron de parecer y decían que era un dios."
,"7":"Los terrenos cercanos pertenecían al hombre principal de la isla, llamado Publio, quien nos recibió y hospedó amigablemente tres días."
,"8":"Precisamente el padre de Publio estaba en cama con fiebre y disentería. Pablo entró a verlo, oró, le impuso las manos y lo sanó."
,"9":"A consecuencia de esto todos los enfermos de la isla acudieron a él y fueron sanados;"
,"10":"luego nos colmaron de atenciones y, al marchar, nos proveyeron de todo lo necesario."
,"11":"Al cabo de tres meses subimos a bordo de un barco de Alejandría que había pasado el invierno en la isla y llevaba por insignia los Dióscuros."
,"12":"Navegamos hacia Siracusa, donde permanecimos tres días."
,"13":"De allí, bordeando la costa, llegamos a Regio. Al día siguiente comenzó a soplar el viento sur, y al cabo de dos días llegamos a Pozzuoli."
,"14":"Allí encontramos algunos hermanos que nos invitaron a quedarnos una semana con ellos, y así es como llegamos a Roma."
,"15":"Allí los hermanos salieron a nuestro encuentro hasta el Foro Apio y Tres Tabernas, pues ya tenían noticia de nuestra llegada. Pablo, al verlos, dio gracias a Dios y se llenó de ánimo."
,"16":"Llegados a Roma, el capitán entregó los presos al gobernador militar, pero dio permiso a Pablo para alojarse en una casa particular con un soldado que lo vigilara."
,"17":"Tres días después Pablo convocó a los judíos principales. Una vez reunidos, les dijo: 'Hermanos, acaban de traerme preso de Jerusalén. He sido entregado a los romanos sin que yo haya ofendido a las autoridades de nuestro pueblo ni las tradiciones de nuestros padres."
,"18":"Los romanos querían dejarme en libertad después de haberme interrogado, pues no encontraban en mí nada que mereciera la muerte."
,"19":"Pero los judíos se opusieron y me vi obligado a apelar al César, sin la menor intención de acusar a las autoridades de mi pueblo."
,"20":"Por este motivo yo quise poder verlos y conversar con ustedes, pues en realidad, por la esperanza de Israel yo llevo estas cadenas.'"
,"21":"Le respondieron: 'Nosotros no hemos recibido ninguna carta de Judea referente a ti, y ninguno de los hermanos que han venido de allá nos ha dicho o transmitido mensaje alguno contra ti."
,"22":"Pero nos gustaría escuchar de ti mismo cómo te defines, pues sabemos que esa secta encuentra oposición en todas partes.'"
,"23":"Fijaron con él un día y vinieron en gran número donde se hospedaba. Pablo les hizo una exposición; desde la mañana hasta la noche les habló del Reino de Dios, partiendo de la Ley de Moisés y los Profetas, y trataba de convencerlos acerca de Jesús."
,"24":"Unos se convencían por sus palabras y otros no."
,"25":"Al final los judíos se retiraron muy divididos. Pablo los despidió con estas palabras: 'Es muy acertado lo que dijo el Espíritu Santo cuando hablaba a sus padres por boca del profeta Isaías:"
,"26":"Ve al encuentro de este pueblo y dile: Por más que oigan no entenderán, y por más que miren no verán."
,"27":"El corazón de este pueblo se ha endurecido. Se han tapado los oídos y cerrado los ojos; tienen miedo de ver con sus ojos y de oír con sus oídos, pues entonces comprenderían y se convertirían, y yo los sanaría."
,"28":"Por eso sepan que esta salvación de Dios ya ha sido proclamada a los paganos; ellos la escucharán.'"
,"30":"Pablo, pues, arrendaba esta vivienda privada y permaneció allí dos años enteros. Recibía a todos los que lo venían a ver,"
,"31":"proclamaba el Reino de Dios y les enseñaba con mucha seguridad lo referente a Cristo Jesús, el Señor, y nadie le ponía trabas."
}`)

}
func ES_LBL_LoadNTAIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Esta es la Revelación de Jesucristo. Dios quiso que enseñara a sus servidores, mediante esta revelación, lo que va a suceder pronto. Envió a su ángel para que se lo transmitiera en forma de visiones a su servidor Juan, "
,"2":"el cual afirma que todo lo que ha visto es palabra de Dios y testimonio solemne de Jesucristo."
,"3":"Feliz el que lea en público estas palabras proféticas y felices quienes las escuchan y hacen caso de este mensaje, porque el tiempo está cerca."
,"4":"Juan, a las siete Iglesias de Asia. Reciban gracia y paz de parte de Aquel que Es, que era y que viene, y de parte de los siete espíritus que están ante su trono,"
,"5":"y de parte de Cristo Jesús, el testigo fiel, el primer nacido de entre los muertos, el rey de los reyes de la tierra. El nos ama"
,"6":"y por su sangre nos ha purificado de nuestros pecados, haciendo de nosotros un reino y una raza de sacerdotes de Dios, su Padre. A él la gloria y el poder por los siglos de los siglos. Amén."
,"7":"Miren, viene entre nubes; lo verán todos, incluso los que lo hirieron, y llorarán por su muerte todas las naciones de la tierra. Sí, así será."
,"8":"Yo soy el Alfa y la Omega, dice el Señor Dios, Aquel que Es, que era y que ha de venir, el Todopoderoso."
,"9":"Yo, Juan, hermano de ustedes, con quienes comparto las pruebas, el reino y la perseverancia en Jesús, me encontraba en la isla de Patmos a causa de la palabra de Dios y por haber proclamado a Jesús."
,"10":"Se apoderó de mí el Espíritu el día del Señor y oí a mis espaldas una voz que sonaba como trompeta:"
,"11":"'Escribe en un libro lo que veas y envíalo a las siete Iglesias: a Efeso, Esmirna, Pérgamo, Tiatira, Sardes, Filadelfia y Laodicea.'"
,"12":"Me volví para ver quién me hablaba. Detrás de mí había siete candeleros de oro,"
,"13":"y en medio de los candeleros vi como a un hijo de hombre vestido con una túnica que le llegaba hasta los pies y un cinturón de oro a la altura del pecho."
,"14":"Su cabeza y sus cabellos son blancos como la lana blanca, como la nieve; sus ojos parecen llamas de fuego,"
,"15":"sus pies son como bronce pulido acrisolado en el horno, su voz resuena como estruendo de grandes olas."
,"16":"En su mano derecha tiene siete estrellas; de su boca sale una espada aguda de doble filo y su cara brilla como el sol cuando está en su máximo esplendor."
,"17":"Al verlo caí como muerto a sus pies; pero me tocó con la mano derecha y me dijo: 'No temas, soy yo, el Primero y el Ultimo,"
,"18":"el que vive. Estuve muerto, pero ahora estoy vivo por los siglos de los siglos y tengo las llaves de la Muerte y de su reino."
,"19":"Escribe, pues, lo que has visto, tanto lo presente como lo que ha de suceder después."
,"20":"Escucha el significado de las siete estrellas que has visto en mi mano derecha y de los siete candeleros de oro: las siete estrellas son los ángeles de las siete Iglesias, y los siete candeleros son las siete Iglesias.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Al ángel de la Iglesia que está en Efeso, escribe: Esto dice el que tiene las siete estrellas en su mano y camina en medio de los siete candeleros de oro:"
,"2":"Conozco tus obras, tus dificultades y tu perseverancia. Sé que no puedes tolerar a los malos y que pusiste a prueba a los que se llaman a sí mismos apóstoles y los hallaste mentirosos."
,"3":"Tampoco te falta la constancia y has sufrido por mi nombre sin desanimarte,"
,"4":"pero tengo algo en contra tuya, y es que has perdido tu amor del principio."
,"5":"Date cuenta, pues, de dónde has caído, recupérate y vuelve a lo que antes sabías hacer; de lo contrario iré donde ti y cambiaré tu candelero de su lugar. Eso haré si no te arrepientes."
,"6":"Pero ya es algo positivo que rechaces la conducta de los nicolaítas, que yo también aborrezco."
,"7":"El que tenga oídos, escuche este mensaje del Espíritu a las Iglesias: 'Al vencedor le daré de comer del árbol de la vida, que está en el Paraíso de Dios.'"
,"8":"Escribe al ángel de la Iglesia de Esmirna: Así habla el Primero y el Ultimo, el que estuvo muerto y volvió a la vida."
,"9":"Sé que sufres y eres pobre y, sin embargo, eres rico. Sé cómo te calumnian los que pretenden ser judíos y no lo son, pues su sinagoga es la de Satanás."
,"10":"No tengas miedo por lo que vas a padecer. El diablo meterá a algunos de ustedes en la cárcel para ponerlos a prueba. Serán diez días de prueba. Permanece fiel hasta la muerte y te daré la corona de la vida."
,"11":"El que tenga oídos, escuche este mensaje del Espíritu a las Iglesias: 'El vencedor no tiene nada que temer de la segunda muerte.'"
,"12":"Escribe esto al ángel de la Iglesia de Pérgamo: Así habla el que tiene la espada aguda de doble filo:"
,"13":"Sé dónde vives, y ahí está el trono de Satanás. Pero te aferras firmemente a mi Nombre y no has renegado de tu fe ni siquiera cuando mataron a Antipas, mi fiel testigo, ahí donde vives, en esa tierra de Satanás."
,"14":"Pero tengo alguna cosa contra ti: toleras a los que tienen la doctrina de Balaán, el que enseñó a Balac a hacer tropezar a los israelitas con la prostitución y las carnes sacrificadas a los ídolos."
,"15":"Lo mismo hacen los que siguen la doctrina de los nicolaítas ahí donde ti."
,"16":"Recupérate, pues si no iré pronto donde ti para combatir a esa gente con la espada de mi boca."
,"17":"El que tenga oídos, oiga este mensaje del Espíritu a las Iglesias: 'Al vencedor le daré un maná misterioso. Le daré también una piedra blanca con un nombre nuevo grabado en ella que sólo conoce el que lo recibe.'"
,"18":"Escribe al ángel de la Iglesia de Tiatira: Así habla el Hijo de Dios, cuyos ojos son como llama de fuego y cuyos pies parecen de bronce brillante:"
,"19":"Conozco tu proceder, tu amor, tu fe, tu servicio, tu perseverancia y tus últimas obras, más numerosas que las primeras."
,"20":"Pero tengo contra ti que dejas actuar a tu Jezabel, esa mujer que se llama a sí misma profetisa, que enseña a mis servidores y los hace descarriar, pues se prostituyen y comen carnes sacrificadas a los ídolos."
,"21":"Le he dado tiempo para que se arrepienta, pero no quiere dejar su prostitución."
,"22":"Por eso ahora la voy a arrojar a un lecho de dolor y también enviaré una prueba terrible a los que cometen adulterio con ella, a no ser que se arrepientan de sus maldades."
,"23":"A sus hijos los heriré de muerte; así entenderán todas las Iglesias que yo soy el que escudriña el corazón y la mente, dando a cada uno según sus obras."
,"24":"Ahora escúchenme los demás de Tiatira que no comparten esa doctrina: no los heriré a ustedes que no han conocido sus 'misterios', como ellos dicen, que son los misterios de Satanás."
,"25":"Pero mantengan lo que tienen hasta que yo venga."
,"26":"Al que venza y se mantenga en mis caminos hasta el fin, le daré poder sobre las naciones,"
,"27":"las regirá con vara de hierro y las quebrará como vasos de barro. Será como yo, que recibí de mi Padre este poder."
,"28":"Y le daré la estrella de la mañana."
,"29":"El que tenga oídos, oiga este mensaje del Espíritu a las Iglesias."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Escribe al ángel de la Iglesia de Sardes: Así habla el que tiene los siete espíritus de Dios y las siete estrellas: Conozco tus obras; te creen vivo, pero estás muerto. "
,"2":"Despiértate y reanima lo que todavía no ha muerto, pues tus obras me parecen muy mediocres a la luz de Dios."
,"3":"Recuerda lo que recibiste y oíste, ponlo en práctica y arrepiéntete. Porque si no te mantienes despierto vendré como un ladrón, sin que sepas a qué hora te sorprenderé."
,"4":"Tengo, sin embargo, los nombres de unos pocos de Sardes que no mancharon sus ropas; ésos me acompañarán vestidos de blanco, porque se lo merecen."
,"5":"El vencedor vestirá de blanco. Nunca borraré su nombre del libro de la vida, sino que proclamaré su nombre delante de mi Padre y de sus ángeles."
,"6":"El que tenga oídos, escuche este mensaje del Espíritu a las Iglesias."
,"7":"Escribe al ángel de la Iglesia de Filadelfia: Así habla el Santo, el Verdadero, el que guarda la llave de David: si él abre, nadie puede cerrar, y si cierra, nadie puede abrir."
,"8":"Sé lo que vales; he abierto ante ti una puerta que nadie podrá cerrar, pues, por pocas que sean tus fuerzas, has guardado mi palabra y no has renegado de mí."
,"9":"Mira que voy a tomar a algunos de la sinagoga de Satanás, de esos que se llaman judíos y no lo son, sino que mienten. Yo haré que vayan y se postren a tus pies, porque habrán visto que te amo."
,"10":"Has guardado mis palabras, que ponen a prueba la constancia, pues yo te protegeré en la hora de la prueba que va a venir sobre el mundo entero y que probará a los habitantes de la tierra."
,"11":"Vengo pronto. Mantén con firmeza lo que tienes, para que nadie te arrebate la corona."
,"12":"Al vencedor lo pondré como columna en el Templo de mi Dios, de donde nadie lo sacará. Grabaré en él el nombre de mi Dios, el nombre de la ciudad que baja del cielo, la nueva Jerusalén que viene de Dios, y mi nombre nuevo."
,"13":"El que tenga oídos, oiga este mensaje del Espíritu a las Iglesias."
,"14":"Escribe al ángel de la Iglesia de Laodicea: Así habla el Amén, el testigo fiel y verdadero, el principio de la creación de Dios:"
,"15":"Conozco tus obras: no eres ni frío ni caliente. ¡Ojalá fueras frío o caliente!"
,"16":"Pero porque eres tibio y no frío o caliente, voy a vomitarte de mi boca."
,"17":"Tú piensas: 'Soy rico, tengo de todo, nada me falta'. Y no te das cuenta de que eres un infeliz, digno de compasión, pobre, ciego y desnudo."
,"18":"Te aconsejo que me compres oro refinado para que te hagas rico, ropas blancas para que te cubras y no tengas que avergonzarte de tu desnudez; por último pídeme un colirio que te pondrás en los ojos para ver."
,"19":"Yo reprendo y corrijo a los que amo. Vamos, anímate y conviértete."
,"20":"Mira que estoy a la puerta y llamo: si uno escucha mi voz y me abre, entraré en su casa y comeré con él y él conmigo."
,"21":"Al vencedor lo sentaré junto a mí en mi trono, del mismo modo que yo, después de vencer, me senté junto a mi Padre en su trono."
,"22":"El que tenga oídos, oiga este mensaje del Espíritu a las Iglesias."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Después de esto miré. Vi una puerta abierta en el cielo y la voz que antes había oído semejante a una trompeta me decía: 'Sube aquí y te mostraré lo que va a suceder en seguida.'"
,"2":"En ese mismo momento me tomó el Espíritu: vi un trono colocado en el cielo y alguien sentado en el trono."
,"3":"El que estaba sentado parecía de jaspe y cornalina, y un arco iris de color esmeralda rodeaba el trono."
,"4":"Veinticuatro sillones rodean el trono, y en ellos están sentados veinticuatro ancianos con vestiduras blancas y coronas de oro en la cabeza."
,"5":"Del trono salen relámpagos, voces y truenos. Ante el trono arden siete antorchas, que son los siete espíritus de Dios."
,"6":"Una pileta transparente como cristal se extiende delante del trono. Cuatro Seres Vivientes, llenos de ojos por delante y por detrás, ocupan el espacio entre el trono y lo que hay a su alrededor. "
,"7":"El primer Ser Viviente se parece a un león, el segundo a un toro, el tercero tiene un rostro como de hombre y el cuarto es como un águila en vuelo."
,"8":"Cada uno de los cuatro Seres Vivientes tiene seis alas llenas de ojos alrededor y por dentro, y no cesan de repetir día y noche: Santo, santo, santo,es el Señor Dios, el Todopoderoso, el que era, es y ha de venir."
,"9":"Cada vez que los Seres Vivientes dan gloria, honor y acción de gracias al que está sentado en el trono y que vive por los siglos de los siglos,"
,"10":"los veinticuatro ancianos se arrodillan ante el que está sentado en el trono, adoran al que vive por los siglos de los siglos y arrojan sus coronas delante del trono diciendo:"
,"11":"Vuelvan a ti, Señor y Dios nuestro,la gloria, el honor y el poder, pues tú lo mereces. Tú creaste todas las cosas, y por tu voluntad existen y fueron creadas."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Vi entonces en la mano derecha del que está sentado en el trono un libro en forma de rollo escrito por los dos lados y sellado con siete sellos."
,"2":"Vi también a un ángel formidable que proclamaba con voz potente: '¿Quién es digno de abrir el libro y de romper los sellos?'"
,"3":"Y no se encontró a nadie, ni en el cielo, ni en la tierra, ni en el mundo de abajo, que fuera capaz de abrir el libro y de leerlo."
,"4":"Yo lloraba mucho al ver que nadie había sido hallado digno de abrir el libro ni de leerlo."
,"5":"Entonces uno de los ancianos me dijo: 'No llores más; acaba de triunfar el león de la tribu de Judá, el brote de David; él abrirá el libro y sus siete sellos.'"
,"6":"Entonces vi esto: entre el trono con sus cuatro Seres Vivientes y los veinticuatro ancianos un Cordero estaba de pie, a pesar de haber sido sacrificado. Tenía siete cuernos y siete ojos, que son los siete espíritus de Dios enviados a toda la tierra."
,"7":"El Cordero se adelantó y tomó el libro de la mano derecha del que está sentado en el trono."
,"8":"Cuando lo tomó, los cuatro Seres Vivientes se postraron ante el Cordero. Lo mismo hicieron los veinticuatro ancianos que tenían en sus manos arpas y copas de oro llenas de perfumes, que son las oraciones de los santos."
,"9":"Y cantaban este cántico nuevo: Eres digno de tomar el libro,y de abrir sus sellos, porque fuiste degollado,y con tu sangre compraste para Dios,hombres de toda raza, lengua, pueblo y nación."
,"10":"Los hiciste reino y sacerdotes para nuestro Dios, y reinarán sobre la tierra."
,"11":"Yo seguía mirando, y oí el clamor de una multitud de ángeles que estaban alrededor del trono, de los Seres Vivientes y de los Ancianos. Eran millones, centenares de millones"
,"12":"que gritaban a toda voz: Digno es el Cordero degollado,de recibir poder y riqueza, sabiduría y fuerza, honor, gloria y alabanza."
,"13":"Y les respondían todas las criaturas del cielo, de la tierra, del mar y del mundo de abajo. Oí que decían: Al que está sentado en el trono y al Cordero, la alabanza, el honor, la gloria y el poder,por los siglos de los siglos."
,"14":"Y los cuatro Seres Vivientes decían 'Amén', mientras los Ancianos se postraban y adoraban."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Mientras estaba mirando el Cordero abrió el primero de los siete sellos, y oí al primero de los cuatro Seres Vivientes que gritaba como con voz de trueno: 'Ven.'"
,"2":"Apareció un caballo blanco; el que lo montaba tenía un arco, le dieron una corona y partió como vencedor y para vencer."
,"3":"Cuando abrió el segundo sello, oí al segundo Ser Viviente gritar: 'Ven.'"
,"4":"Salió entonces otro caballo de color rojo fuego. Al que lo montaba se le ordenó que desterrara la paz de la tierra y se le dio una gran espada para que los hombres se mataran unos a otros."
,"5":"Cuando abrió el tercer sello, oí gritar al tercer Ser Viviente: 'Ven.' Esta vez el caballo era negro; el que lo montaba tenía una balanza en la mano."
,"6":"Entonces se escuchó una voz de en medio de los cuatro Seres que decía: 'Una medida de trigo por una moneda de plata; tres medidas de cebada por una moneda también; ya no gastes el aceite y el vino.'"
,"7":"Cuando abrió el cuarto sello, oí el grito del cuarto Ser Viviente: 'Ven.'"
,"8":"Se presentó un caballo verdoso. Al que lo montaba lo llamaban Muerte, y detrás de él iba otro: el Mundo del Abismo. Se le dio poder para exterminar a la cuarta parte de los habitantes de la tierra por medio de la espada, el hambre, la peste y las fieras."
,"9":"Cuando abrió el quinto sello, divisé debajo del altar las almas de los que fueron degollados a causa de la palabra de Dios y del testimonio que les correspondía dar."
,"10":"Se pusieron a gritar con voz muy fuerte: 'Santo y justo Señor, ¿hasta cuándo vas a esperar a hacer justicia y tomar venganza por nuestra sangre a los habitantes de la tierra?'"
,"11":"Entonces se les dio a cada uno un vestido blanco y se les dijo que esperaran todavía un poco, hasta que se completara el número de sus hermanos y compañeros de servicio, que iban a ser muertos como ellos."
,"12":"Y mi visión continuó. Cuando el Cordero abrió el sexto sello, se produjo un violento terremoto, el sol se puso negro como vestido de luto, la luna entera se tiñó como de sangre"
,"13":"y las estrellas del cielo cayeron a la tierra como una higuera deja caer sus higos verdes al ser agitada por el huracán."
,"14":"El cielo se replegó como un pergamino que se enrolla y no quedó cordillera o continente que no fueran arrancados de su lugar."
,"15":"Los reyes de la tierra, los ministros, los generales, los ricos, los poderosos y toda la gente, tanto esclavos como hombres libres, se escondieron en las cavernas y entre las rocas de los cerros,"
,"16":"y decían: 'Caigan sobre nosotros, cerros y rocas y ocúltennos del que se sienta en el trono y de la cólera del Cordero,"
,"17":"porque ha llegado el gran día de su enojo, y ¿quién lo podrá aguantar?'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Después de esto vi cuatro ángeles de pie en las cuatro esquinas de la tierra, que sujetaban a los cuatro vientos de la tierra para que no soplaran sobre la tierra, ni sobre el mar, ni sobre los árboles."
,"2":"Luego vi a otro ángel que subía desde el oriente y llevaba el sello del Dios vivo. Gritó con voz poderosa a los cuatro ángeles autorizados para causar daño a la tierra y al mar:"
,"3":"'No hagan daño a la tierra ni al mar ni a los árboles hasta que marquemos con el sello la frente de los servidores de nuestro Dios.'"
,"4":"Entonces oí el número de los marcados con el sello: ciento cuarenta y cuatro mil, de todas las tribus de los hijos de Israel:"
,"5":"De la tribu de Judá: doce mil marcados. De la tribu de Rubén: doce mil marcados. De la tribu de Gad: doce mil marcados."
,"6":"De la tribu de Aser: doce mil marcados. De la tribu de Neftalí: doce mil marcados. De la tribu de Manasés: doce mil marcados."
,"7":"De la tribu de Simeón: doce mil marcados. De la tribu de Leví: doce mil marcados. De la tribu de Isacar: doce mil marcados."
,"8":"De la tribu de Zabulón: doce mil marcados. De la tribu de José: doce mil marcados. De la tribu de Benjamín: doce mil marcados."
,"9":"Después de esto vi un gentío inmenso, imposible de contar, de toda nación y raza, pueblo y lengua, que estaban de pie delante del trono y del Cordero, vestidos con vestiduras blancas y con palmas en sus manos,"
,"10":"y gritaban con voz poderosa: '¿Quién salva fuera de nuestro Dios, que se sienta en el trono, y del Cordero?'"
,"11":"Todos los ángeles estaban de pie alrededor del trono, de los Ancianos y de los cuatro Seres Vivientes; se postraron ante el trono rostro en tierra y adoraron a Dios,"
,"12":"diciendo: ¡Amén! Alabanza, gloria, sabiduría, acción de gracias, honor, poder y fuerza a nuestro Dios,por los siglos de los siglos. Amén."
,"13":"Uno de los Ancianos tomó la palabra y me dijo: 'Esos que están vestidos con vestiduras blancas, ¿quiénes son y de dónde vienen?'"
,"14":"Yo contesté: 'Señor, tú lo sabes.' El Anciano me replicó: 'Esos son los que vienen de la gran persecución; han lavado y blanqueado sus vestiduras con la sangre del Cordero."
,"15":"Por eso están ante el trono de Dios y le sirven día y noche en su templo; el que está sentado en el trono extenderá su tienda sobre ellos;"
,"16":"ya no sufrirán más hambre ni sed ni se verán agobiados por el sol ni por viento abrasador alguno,"
,"17":"porque el Cordero que está junto al trono será su pastor y los guiará a los manantiales de las aguas de la vida; y Dios enjugará las lágrimas de sus ojos.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Cuando el Cordero abrió el séptimo sello, se produjo en el Cielo un silencio como de media hora."
,"2":"Luego vi a los siete ángeles que están de pie delante de Dios; se les entregaron siete trompetas."
,"3":"Otro ángel vino y se paró delante del altar de los perfumes con un incensario de oro. Se le dieron muchos perfumes: las oraciones de todos los santos que iba a ofrecer en el altar de oro colocado delante del trono."
,"4":"Y la nube de perfumes, con las oraciones de los santos, se elevó de las manos del ángel hasta la presencia de Dios."
,"5":"Después, el ángel tomó su incensario, lo llenó con brasas del altar y las arrojó sobre la tierra: hubo tremendos truenos, relámpagos y terremotos."
,"6":"Los siete ángeles de las siete trompetas se prepararon para tocar."
,"7":"Tocó el primero, y se produjo granizo y fuego mezclado con sangre, que fueron lanzados sobre la tierra: se quemó la tercera parte de la tierra, la tercera parte de los árboles ardió y toda la hierba verde se abrasó."
,"8":"Tocó el segundo ángel su trompeta, y algo así como un inmenso cerro fue echado al mar: la tercera parte del mar se convirtió en sangre,"
,"9":"la tercera parte de los seres que viven en el mar pereció y un tercio de los navíos naufragó."
,"10":"Tocó el tercer ángel su trompeta, y una estrella grande, que parecía un globo de fuego, cayó del cielo sobre la tercera parte de los ríos y de los manantiales de agua."
,"11":"La estrella se llama Ajenjo: la tercera parte de las aguas se convirtió en ajenjo, y mucha gente murió a causa de las aguas que se habían vuelto amargas."
,"12":"Tocó el cuarto ángel su trompeta, y quedó afectada la tercera parte del sol, de la luna y de las estrellas: perdieron un tercio de su claridad, la luz del día disminuyó un tercio, y lo mismo la de la noche."
,"13":"Y mi visión continuó: oí a un águila que volaba por lo más alto del cielo y que decía con voz potente: '¡Ay, ay, ay de los habitantes de la tierra cuando resuene el sonido de las trompetas que los tres últimos ángeles van a tocar!'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Y tocó el quinto ángel. Vi entonces una estrella que había caído del cielo a la tierra. Le fue entregada la llave del pozo del abismo."
,"2":"Abrió, pues, el pozo del abismo, y del pozo subió una humareda como la de un horno inmenso que oscureció el sol y el aire."
,"3":"De esa humareda salieron langostas, que se esparcieron por la tierra, y se les dio la misma capacidad que tienen los alacranes de la tierra."
,"4":"Se les ordenó que no causaran daño a las praderas, ni a las hierbas, ni a los árboles, sino sólo a los hombres que no llevaran el sello de Dios en la frente."
,"5":"No podían matarlos, sino únicamente atormentarlos durante cinco meses con un dolor semejante al que produce la picadura del alacrán."
,"6":"En aquellos días los hombres buscarán la muerte, pero no la hallarán; querrán morir, pero la muerte huirá de ellos."
,"7":"Estas langostas se parecen a caballos aparejados para la guerra. Pareciera que tienen en la cabeza coronas de oro y rostros como de seres humanos;"
,"8":"sus cabellos son como los de mujer y sus dientes como los de leones."
,"9":"Tienen corazas de hierro y sus alas hacen el mismo ruido que un ejército de carros con muchos caballos que corren al combate."
,"10":"Tienen colas como de alacranes, y en las colas aguijones para torturar durante cinco meses a los hombres."
,"11":"Tienen un rey, el ángel del Abismo, que en hebreo se llama Abadón, y en griego, Apolión (en castellano, Destrucción)."
,"12":"El primer ¡ay! ha pasado. Vienen todavía otros dos detrás."
,"13":"Tocó el sexto ángel su trompeta. Entonces oí una voz que salía de las cuatro esquinas del altar de oro que está delante de Dios."
,"14":"Decía la voz al ángel de la sexta trompeta: 'Suelta a los cuatro ángeles inmovilizados a orillas del gran río Eufrates.'"
,"15":"Y fueron soltados los cuatro ángeles que esperaban la hora, el día, el mes y el año para exterminar a la tercera parte de la humanidad."
,"16":"El número de los soldados de a caballo era de doscientos millones; es el número que oí."
,"17":"Así vi a los caballos y a los que los montaban: tenían corazas color fuego, jacinto y azufre; las cabezas de los caballos son como cabezas de leones y de sus bocas sale fuego, humo y azufre."
,"18":"La tercera parte de la humanidad fue exterminada por estas tres plagas: fuego, humo y azufre, que salían de la boca de los caballos."
,"19":"Es temible la boca de los caballos, pero también lo son las colas. Pues las colas son como serpientes y terminan en cabezas con las que causan daño."
,"20":"Pero los sobrevivientes, los que no fueron exterminados por estas plagas, no renunciaron a sus prácticas: continuaron adorando a los demonios, con esos ídolos de oro, plata, bronce, piedra y madera, que no pueden ver, oír ni caminar."
,"21":"No se arrepintieron de sus crímenes, ni de sus brujerías, ni de su inmoralidad sexual, ni de sus robos."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Vi después a otro ángel formidable que bajaba del cielo envuelto en una nube; el arco iris rodeaba su cabeza, su cara era como el sol y sus piernas como columnas de fuego."
,"2":"En la mano tenía un librito abierto. Colocó el pie derecho sobre el mar y el izquierdo sobre la tierra"
,"3":"y gritó su anuncio con voz tremenda, parecida al rugido del león; al momento los siete truenos entregaron su propio mensaje."
,"4":"Yo me preparaba a escribir lo que habían dicho los siete truenos, cuando una voz desde el cielo me dijo: 'Guarda en secreto las palabras de los siete truenos, no escribas nada.'"
,"5":"Entonces el ángel que había visto de pie sobre el mar y la tierra levantó su mano derecha al cielo"
,"6":"y juró por el que vive por los siglos de los siglos, el que creó el cielo, la tierra, el mar y cuanto hay en ellos: 'Ya no habrá más demora;"
,"7":"apenas se oiga el sonido de la trompeta del séptimo ángel, se habrá cumplido el plan misterioso de Dios, tal como lo había hecho anunciar por medio de sus siervos los profetas.'"
,"8":"La voz que me había hablado desde el cielo se dirigió de nuevo a mí y me dijo: 'Acércate al ángel que está de pie sobre el mar y la tierra, y toma el librito que tiene abierto en la mano.'"
,"9":"Me acerqué al ángel y le dije que me diera el librito. Me respondió: 'Toma, cómetelo; en tu boca será dulce como la miel, pero te producirá acidez en el estómago.'"
,"10":"Tomé el librito de la mano del ángel y me lo comí; en la boca era dulce como la miel, pero cuando terminé de comerlo se me volvió amargo en el estómago."
,"11":"Entonces me dijeron: 'Tienes que profetizar de nuevo amenazando a muchos pueblos, naciones, lenguas y reinos.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Después me entregaron una vara de medir, diciéndome: 'Vete, mide el Templo de Dios y el altar, y haz el censo de los que vienen a adorar."
,"2":"No midas el patio exterior ni lo tomes en cuenta, pues ha sido entregado a los paganos, quienes pisotearán la Ciudad Santa durante cuarenta y dos meses."
,"3":"Yo enviaré a mis dos testigos vestidos con ropa de penitencia para que proclamen mi palabra durante mil doscientos sesenta días."
,"4":"Estos son los dos olivos y las dos lámparas que están ante el Dueño de la tierra."
,"5":"Si alguien intenta hacerles mal, saldrá de su boca fuego y devorará a sus enemigos; así perecerá el que intente maltratarlos.'"
,"6":"Tienen poder para cerrar el cielo y que no caiga lluvia mientras dure su misión profética; tienen también poder para convertir las aguas en sangre y castigar la tierra con toda clase de plagas siempre que quieran."
,"7":"Cuando hayan concluido su misión, la bestia que sube del abismo les hará la guerra, los vencerá y los matará."
,"8":"Ahora sus cadáveres están tendidos en la plaza de la Gran Ciudad, que los creyentes llaman Sodoma o Egipto, en la que también su Señor fue crucificado."
,"9":"Y durante tres días y medio, gente de todos los pueblos, razas, lenguas y naciones contemplan sus cadáveres, pues no está permitido sepultarlos."
,"10":"Los habitantes de la tierra se alegran y se felicitan por ello, y se intercambian regalos, porque estos dos profetas eran para ellos un tormento."
,"11":"Pero pasados los tres días y medio, un espíritu de vida procedente de Dios entró en ellos y se pusieron de pie, lo que provocó gran espanto entre los mirones."
,"12":"Entonces una voz poderosa les gritó desde el cielo: 'Suban.' Y subieron al cielo en medio de la nube a la vista de sus enemigos."
,"13":"En ese momento se produjo un violento terremoto y se derrumbó la décima parte de la ciudad, pereciendo en el cataclismo siete mil personas. Los supervivientes se llenaron de espanto y reconocieron al Dios del cielo."
,"14":"El segundo ¡ay! ya pasó. El tercero está para llegar en seguida."
,"15":"Tocó el séptimo ángel su trompeta; entonces resonaron grandes voces en el cielo: 'Ahora el mundo ha pasado a ser reino de nuestro Dios y de su Cristo. Sí, reinará por los siglos de los siglos.'"
,"16":"Los veinticuatro Ancianos que estaban sentados en sus tronos delante de Dios se postraron para adorar a Dios,"
,"17":"diciendo: Te damos gracias, Señor Dios, Todopoderoso, el que eres y que eras, porque has empezado a reinar, valiéndote de tu poder invencible."
,"18":"Las naciones se habían enfurecido, pero tu enojo las sorprendió: ha llegado el momento de juzgar a los muertos, de premiar a tus siervos los profetas, a tus santos y a cuantos honran tu Nombre, ya sean grandes o pequeños, y de destruir a los que destruyen la tierra."
,"19":"Entonces se abrió el Santuario de Dios en el Cielo y pudo verse el arca de la Alianza de Dios dentro del Santuario. Se produjeron relámpagos, fragor y truenos, un terremoto y una fuerte granizada."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Apareció en el cielo una señal grandiosa: una mujer, vestida del sol, con la luna bajo sus pies y una corona de doce estrellas sobre su cabeza."
,"2":"Está embarazada y grita de dolor, porque le ha llegado la hora de dar a luz."
,"3":"Apareció también otra señal: un enorme dragón rojo con siete cabezas y diez cuernos, y en las cabezas siete coronas;"
,"4":"con su cola barre la tercera parte de las estrellas del cielo, precipitándolas sobre la tierra. El dragón se detuvo delante de la mujer que iba a dar a luz para devorar a su hijo en cuanto naciera. "
,"5":"Y la mujer dio a luz un hijo varón, que ha de gobernar a todas las naciones con vara de hierro; pero su hijo fue arrebatado y llevado ante Dios y su trono,"
,"6":"mientras la mujer huyó al desierto, donde tiene un lugar que Dios le ha preparado. Allí la alimentarán durante mil doscientos sesenta días."
,"7":"Entonces se desató una batalla en el cielo: Miguel y sus ángeles combatieron contra el dragón. Lucharon el dragón y sus ángeles,"
,"8":"pero no pudieron vencer, y ya no hubo lugar para ellos en el cielo."
,"9":"El dragón grande, la antigua serpiente, conocida como el Demonio o Satanás, fue expulsado; el seductor del mundo entero fue arrojado a la tierra y sus ángeles con él."
,"10":"Oí entonces una fuerte voz en el cielo que decía: Por fin ha llegado la salvación, el poder y el reinado de nuestro Dios, y la soberanía de su Ungido. Pues echaron al acusador de nuestros hermanos, el que los acusaba día y noche ante nuestro Dios."
,"11":"Ellos lo vencieron con la sangre del Cordero, con su palabra y con su testimonio, pues hablaron sin tener miedo a la muerte."
,"12":"Por eso, alégrense, cielos,y los que habitan en ellos. Pero ¡ay de la tierra y del mar!, porque el Diablo ha bajado donde ustedes,y grande es su furor, al saber que le queda poco tiempo."
,"13":"Cuando el dragón vio que había sido arrojado a la tierra, se puso a perseguir a la mujer que había dado a luz al varón."
,"14":"Pero se le dieron a la mujer las dos alas del águila grande para que volara al desierto, a su lugar; allí será mantenida lejos del dragón por un tiempo, dos tiempos y la mitad de un tiempo."
,"15":"Entonces la serpiente vomitó de su boca como un río de agua detrás de la mujer para que la arrastrara,"
,"16":"pero la tierra vino en ayuda de la mujer. Abrió la tierra su boca y se tragó el río que el dragón había vomitado."
,"17":"Entonces el dragón se enfureció contra la mujer y se fue a hacer la guerra al resto de sus hijos, es decir, a los que observan los mandamientos de Dios y guardan el mensaje de Jesús."
,"18":"Y se quedó a orillas del mar."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Entonces vi una bestia que sube del mar; tiene siete cabezas y diez cuernos, con diez coronas en los cuernos, y en las cabezas un título que ofende a Dios."
,"2":"La bestia que vi se parecía a un leopardo, aunque sus patas eran como las de un oso y su boca como de un león. El dragón le entregó su poder y su trono con un imperio inmenso."
,"3":"Una de sus cabezas parecía herida de muerte, pero su llaga mortal se le curó. Entonces toda la tierra se maravilló, siguiendo a la bestia."
,"4":"Se postraron ante el dragón que había entregado el poderío a la bestia y se postraron también ante la bestia diciendo: '¿Quién hay como la bestia? ¿Quién puede competir con ella?'"
,"5":"Se le concedió hablar en un tono altanero que desafiaba a Dios, y se le concedió ejercer su poder durante cuarenta y dos meses."
,"6":"Abrió, pues, su boca para insultar a Dios, insultar su Nombre y su santuario, es decir, a los que habitan en el cielo."
,"7":"Se le concedió hacer la guerra a los santos y vencerlos; se le concedió autoridad sobre toda raza, pueblo, lengua y nación."
,"8":"Y la van a adorar todos los habitantes de la tierra, todos aquellos cuyos nombres no están inscritos desde la creación del mundo en el libro de la vida del Cordero degollado."
,"9":"El que tenga oídos para oír, que oiga:"
,"10":"'El que está destinado a la cárcel, a la cárcel irá; el que está destinado a morir a espada, a espada morirá.' Esta es la hora de la perseverancia y de la fe para los santos."
,"11":"Vi luego otra bestia que surgía de la tierra y tenía dos cuernos de cordero, pero hablaba como un dragón."
,"12":"Esta segunda bestia está al servicio de la primera y dispone de todo su poder y autoridad; hace que la tierra y todos sus habitantes adoren a la primera bestia, cuya herida mortal ha sido curada."
,"13":"Realiza grandes prodigios, incluso hace descender fuego del cielo a la tierra en presencia de toda la gente."
,"14":"Por medio de estos prodigios que le ha sido concedido obrar al servicio de la bestia, engaña a los habitantes de la tierra y los persuade a que hagan una estatua en honor de la bestia que, después de ser herida por la espada, se había recuperado."
,"15":"Se le concedió dar vida a la estatua de la bestia, hasta el punto de hacerla hablar y que fueran exterminados todos los que no la adorasen."
,"16":"Hace, pues, que todos, grandes y pequeños, ricos y pobres, libres y esclavos, se pongan una marca en la mano derecha o en la frente;"
,"17":"ya nadie podrá comprar o vender si no está marcado con el nombre de la bestia o con la cifra de su nombre. ¡Vean quién es sabio! "
,"18":"El que sea inteligente, que interprete la cifra de la bestia. Es la cifra de un ser humano, y su cifra es 666."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Tuve otra visión: el Cordero estaba de pie sobre el monte Sión y lo rodeaban ciento cuarenta y cuatro mil personas que llevaban escrito en la frente el nombre del Cordero y el nombre de su Padre."
,"2":"Un ruido retumbaba en el cielo, parecido al estruendo de las olas o al fragor del trueno: era como un coro de cantores que se acompañan tocando sus arpas."
,"3":"Cantan un cántico nuevo delante del trono y delante de los cuatro Vivientes y de los Ancianos. Y nadie podía aprender aquel canto, a excepción de los ciento cuarenta y cuatro mil que han sido rescatados de la tierra."
,"4":"Estos son los que no se mancharon con mujeres: son vírgenes. Estos siguen al Cordero adondequiera que vaya; estos son como las primicias, pues han sido rescatados de entre los hombres para Dios y el Cordero."
,"5":"En su boca no se encontró mentira: son intachables."
,"6":"Luego vi a otro ángel que volaba por lo alto del cielo, trayendo la buena nueva definitiva, la que tenía que anunciar a los habitantes de la tierra, a toda nación, raza, lengua y pueblo."
,"7":"Gritaba con fuerza: 'Rindan a Dios gloria y honor, porque ha llegado la hora de su juicio. Adoren al que hizo el cielo, la tierra, el mar y los manantiales de agua.'"
,"8":"Lo siguió otro ángel gritando: 'Cayó, cayó Babilonia la grande, la prostituta que servía su vino capcioso a todas las naciones y las emborrachaba con su desatada prostitución.'"
,"9":"Un tercer ángel pasó después, clamando con voz fuerte: 'Si alguno adora a la bestia y a su imagen y se deja marcar la frente o la mano,"
,"10":"tendrá que beber también el vino embriagante de Dios, que está preparado, puro, en la copa de su enojo. Será atormentado con fuego y azufre ante los santos ángeles y ante el Cordero.'"
,"11":"No hay reposo, ni de día ni de noche, para los que adoran a la bestia y a su imagen, ni para quienes se dejan marcar con la marca de su nombre. El humo de su tormento se eleva por los siglos de los siglos."
,"12":"Este es el tiempo de aguantar para los santos, para todos aquellos que guardan los mandamientos de Dios y la fe de Jesús."
,"13":"Entonces oí una voz que decía desde el cielo: 'Escribe esto: Felices desde ahora los muertos que mueren en el Señor. Sí, dice el Espíritu, que descansen de sus fatigas, pues sus obras los acompañan.'"
,"14":"Continuó la visión. Apareció una nube blanca y, sentado sobre la nube, uno como Hijo de Hombre, que llevaba una corona de oro en la cabeza y una hoz afilada en la mano."
,"15":"Salió del santuario otro ángel clamando con potente voz al que estaba sentado en la nube: 'Mete tu hoz y cosecha, porque ha llegado el tiempo de cosechar y la cosecha de la tierra está en su punto.'"
,"16":"Y el que estaba sentado en la nube lanzó su hoz a la tierra, y la tierra fue segada."
,"17":"Entonces un ángel, que también llevaba una hoz afilada, salió del santuario celeste."
,"18":"Otro ángel, el que está encargado del fuego, salió del altar y gritó al que llevaba la hoz afilada: 'Mete tu hoz afilada y cosecha los racimos de la viña de la tierra, porque ya están bien maduros.'"
,"19":"Entonces el ángel metió la hoz e hizo la vendimia, echando todos los racimos de uva en el gran lagar de la cólera de Dios."
,"20":"Las uvas fueron exprimidas fuera de la ciudad, y del lagar brotó tanta sangre que llegó hasta la altura de los frenos de los caballos, en una extensión de mil seiscientos estadios."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Vi luego en el cielo otra señal grande y maravillosa: siete ángeles que llevaban siete plagas, las últimas, porque con ellas se consuma la cólera de Dios."
,"2":"Vi también como un mar de cristal destellante, y a los vencedores de la bestia, de su imagen y de la cifra de su nombre, que se colocaban sobre el mar de cristal, llevando las arpas celestiales en sus manos."
,"3":"Estos cantan el cántico de Moisés, servidor de Dios, y el cántico del Cordero: Grandes y maravillosas son tus obras, Señor Dios, Todopoderoso. Justicia y verdad guían tus pasos, oh Rey de las naciones."
,"4":"¿Quién no dará honor y gloria a tu Nombre, oh Señor?,Tú solo eres santo, y todas las naciones vendrán,y se postrarán ante ti, porque tus fallos se han dado a conocer."
,"5":"Después se abrió el Santuario de la Tienda del Testimonio"
,"6":"y salieron del Santuario los siete ángeles portadores de las siete plagas, vestidos de lino puro resplandeciente y ceñido su pecho con cinturones de oro."
,"7":"Uno de los cuatro Vivientes entregó a los siete ángeles siete copas de oro llenas del furor de Dios, que vive por siglos sin fin."
,"8":"Entonces el Santuario se llenó de humo por estar allí la gloria de Dios y su poder, de modo que nadie podía entrar en él hasta que se consumaran las siete plagas de los siete ángeles."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Y oí una voz potente que desde el Santuario gritaba a los siete ángeles: 'Vayan y derramen sobre la tierra las siete copas del furor de Dios.'"
,"2":"Salió el primero, vació su copa sobre la tierra y se produjeron úlceras malignas y dolorosas en las personas que llevaban la marca de la bestia y se postraban ante su imagen."
,"3":"El segundo ángel vació su copa sobre el mar, y hubo sangre como de desangrado, y todo lo que vive en el mar pereció."
,"4":"El tercer ángel vació su copa sobre los ríos y sobre los manantiales de agua, que se convirtieron en sangre."
,"5":"Y oí al ángel de las aguas que decía: 'Tú, el que eras y eres, el Santo, eres justo al castigarlos de este modo,"
,"6":"pues ellos derramaron la sangre de los santos y de los profetas, y tú les has dado a beber sangre. Bien se lo merecían.'"
,"7":"Entonces oí otro grito que venía del altar: 'Sí, Señor y Dios, Todopoderoso, tus juicios son verdaderos y justos.'"
,"8":"El cuarto ángel derramó su copa sobre el sol, y su calor comenzó a quemar a la gente."
,"9":"Los hombres fueron abrasados y empezaron a insultar a Dios, que tiene poder sobre tales plagas, en vez de reconocerle y darle gloria."
,"10":"El quinto ángel vació su copa sobre el trono de la bestia, y al instante su reino quedó sumido en tinieblas y la gente se mordía la lengua de dolor."
,"11":"Insultaron al Dios Altísimo a causa de sus dolores y de sus llagas, pero no se arrepintieron ni dejaron de hacer el mal."
,"12":"El sexto ángel derramó su copa en el gran río Eufrates, y sus aguas se secaron, dejando un paso libre para los reyes de oriente."
,"13":"Y vi que de la boca del dragón, de la bestia y del falso profeta salían tres espíritus inmundos que tenían aspecto de ranas."
,"14":"Estos son espíritus diabólicos que pueden hacer milagros, y se dirigen a los reyes del mundo entero para convocarlos para la batalla del gran día de Dios, el Todopoderoso."
,"15":"'Miren que vengo como un ladrón. Feliz el que se mantiene despierto y no se quita la ropa, porque así no tendrá que andar desnudo y no se verán sus vergüenzas'."
,"16":"Los reunieron en el lugar llamado en hebreo Harmaguedón (o sea, cerros de Meguido)."
,"17":"El séptimo ángel vació su copa en el aire. Entonces salió una voz del trono que se escuchó fuera del Santuario, y decía: 'Está hecho.'"
,"18":"Se produjeron relámpagos, retumbar de truenos y un violento terremoto. Nunca hubo terremoto tan violento como éste desde que hay hombres sobre la tierra."
,"19":"La Gran Ciudad se abrió en tres partes y las ciudades de las naciones se desplomaron. Acababan de acordarse ante Dios de la Gran Babilonia y le iban a pasar la copa del vino puro de su ira."
,"20":"Entonces los continentes huyeron y las cordilleras desaparecieron."
,"21":"Enormes granizos como de un quintal cayeron del cielo sobre la gente, y los hombres insultaron a Dios por la desastrosa granizada, pues fue una plaga tremenda."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Entonces vino uno de los siete ángeles de las siete copas y me dijo: 'Ven, que te voy a mostrar el juicio de la famosa prostituta que se sienta al borde de las grandes aguas;"
,"2":"con ella pecaron los reyes de la tierra, y los habitantes de la tierra se emborracharon con el vino de su idolatría.'"
,"3":"El ángel me llevó en espíritu al desierto: era una nueva visión. Había allí una mujer sentada sobre una bestia de color rojo, que tenía siete cabezas y diez cuernos. Esta bestia estaba cubierta de títulos y frases que ofendían a Dios."
,"4":"La mujer vestía ropas de púrpura y escarlata, y resplandecía de oro, piedras preciosas y perlas. Tenía en la mano una copa de oro llena de cosas repugnantes, que eran las impurezas y la lujuria de la tierra entera."
,"5":"En su frente se podía leer su nombre, escrito en forma cifrada: Babilonia la Grande, la madre de las prostitutas y de los abominables ídolos del mundo entero."
,"6":"Y observé que la mujer se había embriagado con la sangre de los santos y de los mártires de Jesús. Esta visión me dejó muy sorprendido, "
,"7":"pero el ángel me dijo: '¿Por qué te maravillas? Voy a explicarte el misterio de esta mujer y de la bestia que la lleva, la de las siete cabezas y los diez cuernos."
,"8":"La bestia que has visto era, pero ya no es. Sube del abismo, pero camina hacia su perdición. Los habitantes de la tierra, cuyo nombre no fue escrito en el libro de la vida desde la creación del mundo, se asombrarán al descubrir que la bestia era, pero ya no es y pasa pronto."
,"9":"A ver si ustedes lo adivinan. Las siete cabezas son siete colinas sobre las que la mujer está asentada."
,"10":"Y son también siete reyes, de los cuales cinco han caído ya, uno está en el poder y el otro no ha llegado aún, y cuando llegue, habrá de durar poco tiempo."
,"11":"La bestia que era y ya no es, hace el octavo, pero es uno de los siete, y camina hacia su destrucción."
,"12":"Los diez cuernos son diez reyes que todavía no han recibido el reino, pero tendrán poder por una hora junto a la bestia."
,"13":"Persiguen todos una sola meta, y pondrán su autoridad y sus fuerzas al servicio de la bestia."
,"14":"Harán la guerra al Cordero, pero el Cordero los vencerá, porque es Señor de señores y Rey de reyes, y con él vencerán los suyos, los llamados y elegidos y que se mantienen fieles.'"
,"15":"El ángel prosiguió: 'Las aguas que has visto, a cuyo borde está sentada la prostituta, representan pueblos, multitudes y naciones de todos los idiomas."
,"16":"Los diez cuernos y la misma bestia planearán maldades contra la prostituta, la arruinarán y la dejarán desnuda, comerán sus carnes y la consumirán por el fuego."
,"17":"Porque Dios se vale de ellos para ejecutar su plan, y les ha inspirado la misma intención de poner sus fuerzas al servicio de la bestia hasta que se cumplan las palabras de Dios."
,"18":"Esa mujer que has visto es la Gran Ciudad, la que reina sobre los reyes del mundo entero.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Después de esto vi bajar del cielo a otro ángel. Era tan grande su poder, que toda la tierra quedó iluminada por su resplandor."
,"2":"Gritó con voz potente: '¡Cayó, cayó la Gran Babilonia!,Se ha convertido en guarida de demonios, en refugio de espíritus inmundos, en nido de aves impuras,y asquerosas;"
,"3":"porque con el vino de su prostitución,se han emborrachado todas las naciones; los reyes de la tierra pecaron con ella, y los comerciantes del mundo se hicieron ricos con ella, pues era buena para gastar.'"
,"4":"Oí otra voz que venía del cielo y decía: 'Aléjate de ella, pueblo mío, no sea que te hagas cómplice de su maldad,y tengas que compartir sus castigos;"
,"5":"porque sus pecados se han apilado hasta el cielo,y Dios se ha acordado de sus maldades."
,"6":"Devuélvanle según ella ha dado, páguenle el doble de lo que ha hecho, viértanle doble medida de lo que ella daba de beber."
,"7":"Que sufra tantos tormentos y penas,como fueron su orgullo y su lujo. Se dice a sí misma: '¡Domino como reina, no soy viuda, nunca conoceré el lamento.'"
,"8":"Por eso, y en un solo día, caerán sobre ella sus plagas: muerte, lamentos y hambre, y quedará consumida por el fuego; pues poderoso es su juez, que es Dios, el Señor.'"
,"9":"Llorarán y harán duelo por ella los reyes de la tierra que con ella se acostaban y lo pasaban bien cuando vean la humareda de su incendio."
,"10":"Se detendrán a distancia aterrados ante su suplicio y exclamarán: '¡Ay, ay de la gran ciudad, de Babilonia, ciudad poderosa, que en una hora te arrasó el juicio!'"
,"11":"Llorarán y se lamentarán por ella los comerciantes de la tierra, porque ya no hay quien compre sus mercaderías:"
,"12":"sus cargamentos de oro, plata, piedras preciosas y perlas; telas de lino fino y púrpura, vestidos de seda y escarlata; maderas perfumadas, objetos de marfil y muebles muy costosos; bronce, hierro y mármol;"
,"13":"especias, perfumes, mirra e incienso; vino y aceite, harina y trigo, vacunos y corderos, caballos y carruajes, esclavos y mercadería humana."
,"14":"Dirán: 'Ya no verás más las frutas que ansiabas. Se acabó para ti el lujo y esplendor, y jamás volverán.'"
,"15":"Los que traficaban con estas cosas y con ella se enriquecían, se mantendrán a distancia horrorizados por su castigo. Llorando y lamentándose"
,"16":"dirán a gritos: '¡Ay, ay, de la Gran Ciudad, la que se vestía de lino, púrpura y escarlata y resplandecía de oro, piedras preciosas y perlas! "
,"17":"¡En una hora se acabó tanta riqueza!',Todos los capitanes, navegantes, marineros y cuantos se ocupan en los trabajos del mar se detuvieron a distancia "
,"18":"y gritaron al contemplar la humareda de su incendio: '¿Dónde se ha visto jamás ciudad como ésta?'"
,"19":"Y echando polvo sobre su cabeza, decían llorando y lamentándose: '¡Ay, ay de la Gran Ciudad, donde se hicieron muy ricos, gracias a su lujo, cuantos tenían naves en el mar! ¡En una hora ha quedado devastada!'"
,"20":"¡Alégrense por ella, cielos, y también ustedes los santos, los apóstoles y los profetas!,Porque Dios les ha hecho justicia y le hizo pagar."
,"21":"Entonces un ángel poderoso tomó una piedra, tan enorme como una piedra de molino, y la arrojó al mar, diciendo: 'Así, con igual violencia, será arrojada Babilonia, la Gran Ciudad, y no se volverá a ver más."
,"22":"Nunca más se oirán en ti,el son de arpas y cítaras, flautas y trompetas; no trabajarán más en ti,artesanos de ningún arte; no se oirá más en ti ruido de molino, ni brillará luz de lámpara;"
,"23":"no se oirán más en ti,los cantos del novio y de la novia. Porque tus comerciantes eran los magnates de la tierra, y con tus hechicerías,se extraviaron las naciones."
,"24":"En esta ciudad fue hallada sangre de profetas y santos,y de todos los que fueron degollados en la tierra.'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"Después oí en el cielo algo como el canto de un inmenso gentío, que decía: ¡Aleluya! ¿Quién salva y quién tiene gloria y poder sino nuestro Dios? "
,"2":"Sus juicios son verdaderos y justos: ha condenado a la gran prostituta que corrompía la tierra con su inmoralidad y le ha hecho pagar la sangre de sus servidores."
,"3":"Y volvieron a clamar: ¡Aleluya! De ella sube humo por los siglos de los siglos."
,"4":"Entonces los veinticuatro ancianos y los cuatro vivientes se postraron adorando a Dios, que está sentado en el trono, diciendo: Amén. Aleluya."
,"5":"Y salió del trono una voz que decía: 'Alaben a nuestro Dios todos sus servidores, todos los que honran a Dios, pequeños y grandes.'"
,"6":"Y oí el ruido de una multitud inmensa como el ruido del estruendo de las olas, como el fragor de fuertes truenos. Y decían: Aleluya. Ahora reina el Señor Dios, el Todopoderoso."
,"7":"Alegrémonos, regocijémonos,démosle honor y gloria, porque han llegado las bodas del Cordero. Su esposa se ha engalanado,"
,"8":"la han vestido de lino fino, deslumbrante de blancura,-el lino son las buenas acciones de los santos-."
,"9":"Después el ángel me dijo: 'Escribe: Felices los que han sido invitados al banquete de bodas del Cordero.' Y añadió: 'Estas son palabras verdaderas de Dios.'"
,"10":"Caí a sus pies para adorarlo, pero él me dijo: 'No lo hagas, yo no soy más que un servidor como tú y como tus hermanos que transmiten las declaraciones de Jesús (son declaraciones de Jesús las que vienen del espíritu de los profetas). Sólo debes adorar a Dios.'"
,"11":"Vi el cielo abierto y apareció un caballo blanco. El que lo monta se llama 'Fiel' y 'Veraz'. Es el que juzga y lucha con justicia."
,"12":"Sus ojos son llamas de fuego, tiene en la cabeza muchas coronas y lleva escrito un nombre que sólo él entiende."
,"13":"Viste un manto empapado de sangre y su nombre es: La Palabra de Dios."
,"14":"Lo siguen los ejércitos del cielo en caballos blancos, vestidos con ropas de lino de radiante blancura."
,"15":"De su boca sale una espada afilada, para herir con ella a las naciones; él las gobernará con vara de hierro; él mismo pisará el lagar del vino de la ardiente cólera de Dios, el Todopoderoso."
,"16":"En el manto y en el muslo lleva escrito este título: 'Rey de reyes y Señor de señores.'"
,"17":"Vi luego a un ángel parado sobre el sol, que gritó con voz potente a todas las aves que volaban por el cielo: 'Vengan acá, reúnanse para el gran banquete de Dios."
,"18":"Vengan y devoren carne de reyes, de generales, de hombres valientes; devoren al caballo con su jinete, a hombres libres y esclavos, a pequeños y grandes.'"
,"19":"Vi entonces a la bestia y a los reyes de la tierra con sus ejércitos, reunidos para combatir contra el que iba montado en el caballo blanco y contra su ejército."
,"20":"Pero la bestia fue capturada y con ella el falso profeta que había realizado maravillas al servicio de la bestia, engañando con ellas a los que habían aceptado la marca de la bestia y a los que adoraban su estatua. Los dos fueron arrojados vivos al lago del fuego que arde con azufre."
,"21":"Todos los demás fueron exterminados por la espada que sale de la boca del que monta el caballo, y todas las aves se hartaron de su carne."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Vi después a un ángel que bajaba del cielo llevando en la mano la llave del Abismo y una cadena enorme."
,"2":"Sujetó al monstruo, la serpiente antigua, que es Satanás o el diablo, y lo encadenó por mil años."
,"3":"Lo arrojó al Abismo, cerró con llave y además puso sellos para que no pueda seducir más a las naciones hasta que pasen los mil años. Después tendrá que ser soltado por poco tiempo."
,"4":"También vi unos tronos, y sentados en ellos los que tienen poder para juzgar. Vi también las almas de aquellos a quienes les cortaron la cabeza por causa de las enseñanzas de Jesús y de la Palabra de Dios. Vi a todos los que no habían adorado a la bestia ni a su imagen y no habían recibido su marca en la frente o en la mano. Volvieron a la vida y reinaron mil años con el Mesías."
,"5":"Esta es la primera resurrección. El resto de los muertos no volvieron a la vida hasta que se cumplieron los mil años."
,"6":"¡Feliz y santo es el que participa en la primera resurrección! La segunda muerte ya no tiene poder sobre ellos: serán sacerdotes de Dios y de su Mesías y reinarán con él mil años."
,"7":"Y cuando se terminen los mil años, Satanás será soltado de su prisión,"
,"8":"saldrá a engañar a Gog y Magog, es decir, a las naciones de los cuatro extremos de la tierra, una multitud tan numerosa como las arenas del mar."
,"9":"Invadieron el país entero y cercaron el campamento de los santos, la Ciudad muy amada, pero bajó fuego del cielo y los devoró."
,"10":"Entonces el diablo, el seductor, fue arrojado al lago de fuego y azufre, donde ya se encontraban la bestia y el falso profeta. Allí serán atormentados día y noche por los siglos de los siglos."
,"11":"Luego vi un trono grande y espléndido y a uno que estaba sentado en él; el cielo y la tierra huyeron al verlo sin que quedaran huellas de ellos."
,"12":"Y vi a los muertos, grandes y pequeños, de pie ante el trono, mientras eran abiertos unos libros. Luego fue abierto otro, el libro de la vida. Entonces fueron juzgados los muertos de acuerdo con lo que está escrito en esos libros, es decir, cada uno según sus obras."
,"13":"El mar devolvió los muertos que guardaba, y también la Muerte y el Lugar de los muertos devolvieron los muertos que guardaban, y cada uno fue juzgado según sus obras."
,"14":"Después la Muerte y el Lugar de los muertos fueron arrojados al lago de fuego: este lago de fuego es la segunda muerte."
,"15":"Y todo el que no se halló inscrito en el libro de la vida fue arrojado al lago de fuego."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Después vi un cielo nuevo y una tierra nueva, pues el primer cielo y la primera tierra habían desaparecido y el mar no existe ya."
,"2":"Y vi a la Ciudad Santa, la nueva Jerusalén, que bajaba del cielo, de junto a Dios, engalanada como una novia que se adorna para recibir a su esposo."
,"3":"Y oí una voz que clamaba desde el trono: 'Esta es la morada de Dios con los hombres; él habitará en medio de ellos; ellos serán su pueblo y él será Dios-con-ellos;"
,"4":"él enjugará las lágrimas de sus ojos. Ya no habrá muerte ni lamento, ni llanto ni pena, pues todo lo anterior ha pasado.'"
,"5":"Y el que estaba sentado en el trono dijo: 'Ahora todo lo hago nuevo'. Luego me dijo: 'Escribe, que estas palabras son ciertas y verdaderas.'"
,"6":"Y añadió: 'Ya está hecho. Yo soy el Alfa y la Omega, el Principio y el Fin. Al que tenga sed yo le daré de beber gratuitamente del manantial del agua de la vida."
,"7":"Esa será la herencia del vencedor: yo seré Dios para él y él será hijo para mí."
,"8":"Pero para los cobardes, los renegados, los corrompidos, los asesinos, los impuros, los hechiceros, los idólatras, en una palabra, para todos los falsos, su lugar y su parte es el lago que arde con fuego de azufre, que es la segunda muerte.'"
,"9":"Se acercó a mí uno de los siete ángeles de las siete copas llenas de las siete últimas plagas y me dijo: 'Ven, que te voy a mostrar a la novia, a la esposa del Cordero.'"
,"10":"Me trasladó en espíritu a un cerro muy grande y elevado y me mostró la Ciudad Santa de Jerusalén, que bajaba del cielo de junto a Dios,"
,"11":"envuelta en la gloria de Dios. Resplandecía como piedra muy preciosa con el color del jaspe cristalino. "
,"12":"Tenía una muralla grande y alta con doce puertas, y sobre las puertas doce ángeles y nombres grabados, que son los nombres de las doce tribus de los hijos de Israel."
,"13":"Tres puertas dan a oriente y otras tres miran al norte; tres puertas al sur y otras tres al poniente."
,"14":"La muralla de la ciudad descansa sobre doce bases en las que están escritos los nombres de los doce Apóstoles del Cordero."
,"15":"El ángel que me hablaba tenía una caña de medir de oro, para medir la ciudad, las puertas y la muralla."
,"16":"La ciudad es un cuadrado: su longitud es igual a su anchura. Midió la ciudad con la caña, y tenía doce mil estadios. Su longitud, anchura y altura son iguales."
,"17":"Midió después la muralla, y tenía ciento cuarenta y cuatro codos de altura. El ángel usaba las mismas medidas que nosotros."
,"18":"La muralla está hecha con jaspe y la ciudad es de oro puro, como cristal."
,"19":"Las bases de la muralla de la ciudad están adornadas con toda clase de piedras preciosas: la primera base es de jaspe; la segunda, de zafiro; la tercera, de calcedonia; la cuarta, de esmeralda;"
,"20":"la quinta, de sardónica; la sexta, de sardio; la séptima, de crisólito; la octava, de berilio; la novena, de topacio; la décima, de crisopraso; la undécima, de jacinto; la duodécima, de amatista."
,"21":"Las doce puertas son doce perlas, cada puerta está hecha de una sola perla. La plaza de la ciudad está pavimentada con oro refinado, transparente como cristal."
,"22":"No vi templo alguno en la ciudad, porque su templo es el Señor Dios, el Todopoderoso, y el Cordero."
,"23":"La ciudad no necesita luz del sol ni de la luna, porque la gloria de Dios la ilumina y su lámpara es el Cordero."
,"24":"A su luz caminarán las naciones, y los reyes de la tierra llevarán a ella sus riquezas."
,"25":"No habrá que cerrar sus puertas al fin del día, ya que allí no habrá noche."
,"26":"Traerán a ella las riquezas y el esplendor de las naciones."
,"27":"Nada manchado entrará en ella, ni los que cometen maldad y mentira, sino solamente los inscritos en el libro de la vida del Cordero."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Después el ángel me mostró el río de agua de la vida, transparente como el cristal, que brotaba del trono de Dios y del Cordero."
,"2":"En medio de la ciudad, a uno y otro lado del río, hay árboles de la vida, que dan fruto doce veces, una vez cada mes, y sus hojas sirven de medicina para las naciones."
,"3":"No habrá ya maldición alguna; el trono de Dios y del Cordero estará en la ciudad, y sus servidores le rendirán culto."
,"4":"Verán su rostro y llevarán su nombre en la frente. Ya no habrá noche."
,"5":"No necesitarán luz de lámpara ni de sol, porque Dios mismo será su luz, y reinarán por los siglos para siempre."
,"6":"Después me dijo el ángel: 'Estas palabras son ciertas y verdaderas. El Señor, que es Dios de los profetas y sus espíritus, ha enviado a su ángel para que muestre a sus servidores lo que ha de suceder pronto."
,"7":"Y voy a llegar pronto. Feliz el que guarda las palabras proféticas de este libro.'"
,"8":"Yo, Juan, vi y oí todo esto. Al terminar las palabras y las visiones caí a los pies del ángel que me había mostrado todo esto, para adorarlo,"
,"9":"pero él me dijo: 'No lo hagas, yo soy un servidor como tú y tus hermanos los profetas y como todos los que escuchan las palabras de este libro. A Dios tienes que adorar.'"
,"10":"También me dijo: 'No pongas en lenguaje cifrado los mensajes proféticos de este libro, porque el tiempo está cerca."
,"11":"Que el pecador siga pecando y el manchado siga ensuciándose, que el bueno siga practicando el bien y el santo creciendo en santidad."
,"12":"Voy a llegar pronto, y llevo conmigo el salario para dar a cada uno conforme a su trabajo."
,"13":"Yo soy el Alfa y la Omega, el Primero y el Ultimo, el Principio y el Fin."
,"14":"Felices los que lavan sus ropas, porque así tendrán acceso al árbol de la vida y se les abrirán las puertas de la ciudad."
,"15":"Fuera los perros, los hechiceros, los impuros, los asesinos, los idólatras y todos los que aman y practican la mentira."
,"16":"Yo, Jesús, he enviado a mi ángel para decirles lo que se refiere a las Iglesias. Yo soy el Brote y el Descendiente de David, la estrella radiante de la mañana.'"
,"17":"El Espíritu y la Esposa dicen: '¡Ven!' Que el que escucha diga también: '¡Ven!' El que tenga sed, que se acerque; y el que lo desee, reciba gratuitamente el agua de la vida."
,"18":"Yo, por mi parte, advierto a todo el que escuche las palabras proféticas de este libro: 'Si alguno se atreve a añadir algo, Dios echará sobre él todas las plagas descritas en este libro."
,"19":"Y si alguno quita algo a las palabras de este libro profético, Dios le quitará su parte en el árbol de la vida y en la Ciudad Santa descritos en este libro.'"
,"20":"El que da fe de estas palabras dice: 'Sí, vengo pronto.',Amén. Ven, Señor Jesús."
,"21":"Que la gracia del Señor Jesús esté con todos."
}`)

}
func ES_LBL_LoadNTHBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"En diversas ocasiones y bajo diferentes formas Dios habló a nuestros padres por medio de los profetas,"
,"2":"hasta que en estos días, que son los últimos, nos habló a nosotros por medio del Hijo, a quien hizo destinatario de todo, ya que por él dispuso las edades del mundo."
,"3":"El es el resplandor de la Gloria de Dios y en él expresó Dios lo que es en sí mismo. El, cuya palabra poderosa mantiene el universo, también es el que purificó al mundo de sus pecados, y luego se sentó en los cielos, a la derecha del Dios de majestad."
,"4":"Ahora, pues, él está tanto más por encima de los ángeles cuanto más excelente es el Nombre que recibió."
,"5":"En efecto, ¿a qué ángel le dijo Dios jamás: Tú eres mi Hijo, yo te he dado la vida hoy? ¿Y de qué ángel dijo Dios: Yo seré para él un Padre y él será para mí un Hijo?"
,"6":"Al introducir al Primogénito en el mundo, dice: Que lo adoren todos los ángeles de Dios."
,"7":"Tratándose de los ángeles, encontramos palabras como éstas: Dios envía a sus ángeles como espíritus y a sus servidores como llamas ardientes."
,"8":"Al Hijo, en cambio, se le dice: Tu trono, oh Dios, permanece por siglos y siglos, y tu gobierno es gobierno de justicia."
,"9":"Amas la justicia y aborreces la maldad; por eso, oh Dios, tu Dios te concedió una consagración real que es fuente de alegría, con preferencia a tus compañeros."
,"10":"Y también leemos: Tú, Señor, en el principio pusiste la tierra sobre sus bases, y los cielos son obra de tus manos."
,"11":"Ellos desaparecerán, pero tú permaneces. Serán para ti como un vestido viejo;"
,"12":"los doblarás como una capa, y los cambiarás. Pero tú eres siempre el mismo y tus años no terminarán jamás."
,"13":"A ninguno de sus ángeles dijo Dios: Siéntate a mi derecha hasta que ponga a tus enemigos como tarima de tus pies."
,"14":"Pues todos ellos no son más que funcionarios espirituales, y reciben una misión para bien de los que recibirán la salvación."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Por eso debemos prestar más atención al mensaje que escuchamos, no sea que vayamos a la deriva."
,"2":"Miren cuán inflexible era la Ley entregada por los ángeles, pues toda falta o desobediencia recibía su castigo."
,"3":"¿Cómo, pues, escaparemos nosotros, si despreciamos una salvación tan trascendente? El Señor mismo la proclamó primero y luego la confirmaron aquellos que le oyeron."
,"4":"Dios ha confirmado su testimonio con señales, prodigios y milagros de toda clase, sin hablar de los dones del Espíritu, que reparte como quiere."
,"5":"En efecto, Dios no sometió a ángeles el mundo nuevo del cual estamos hablando."
,"6":"Alguien dijo en algún lugar: ¿Qué es el hombre para que te acuerdes de él, el Hijo del hombre para que lo tomes en cuenta?"
,"7":"Por un momento lo hiciste más bajo que los ángeles y luego lo coronaste de gloria y honor;"
,"8":"todo lo pusiste bajo sus pies. Como ven, todo le ha sido sometido, y no se hace ninguna excepción. Es verdad que, por el momento, no se ve que todo le esté sometido, "
,"9":"pero el texto dice: por un momento lo hiciste más bajo que los ángeles. Esto se refiere a Jesús, que, como precio de su muerte dolorosa, ha sido coronado de gloria y honor. Fue una gracia de Dios que experimentara la muerte por todos. "
,"10":"Dios, del que viene todo y que actúa en todo, quería introducir en la Gloria a un gran número de hijos, y le pareció bien hacer perfecto por medio del sufrimiento al que se hacía cargo de la salvación de todos;"
,"11":"de este modo el que comunicaba la santidad se identificaría con aquellos a los que santificaba. Por eso él no se avergüenza de llamarnos hermanos, cuando dice:"
,"12":"Señor, yo te daré a conocer a mis hermanos, en medio de la asamblea celebraré tu nombre."
,"13":"Y también: Mantendré mi confianza en Dios. Aquí estoy yo y los hijos que Dios me ha dado."
,"14":"Puesto que esos hijos son de carne y sangre, Jesús también experimentó esta misma condición y, al morir, le quitó su poder al que reinaba por medio de la muerte, es decir, al diablo."
,"15":"De este modo liberó a los hombres que, por miedo a la muerte, permanecían esclavos en todos los aspectos de su vida."
,"16":"Jesús no vino para hacerse cargo de los ángeles, sino de la raza de Abrahán."
,"17":"Por eso tuvo que hacerse semejante en todo a sus hermanos, y llegó a ser el sumo sacerdote lleno de comprensión, pero también fiel en el servicio de Dios, que les consigue el perdón."
,"18":"El mismo ha sido probado por medio del sufrimiento, por eso es capaz de ayudar a aquellos que son puestos a prueba."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Hermanos santos, que gozan de una vocación sobrenatural, fíjense en Jesús, el apóstol y sumo sacerdote de nuestra fe;"
,"2":"él merece la confianza de Dios que le dio este cargo, lo mismo que la mereció Moisés en la casa de Dios."
,"3":"En realidad Jesús aventaja en mucho a Moisés, pues no hay comparación entre una casa y el que la construye."
,"4":"Toda casa necesita un constructor, y hay un constructor de todo, que es Dios."
,"5":"Moisés actuaba en toda la casa de Dios como fiel servidor, dando a conocer lo que le habían dicho."
,"6":"Cristo, en cambio, está en su casa como el Hijo, y nosotros somos la gente de su casa, con tal que sigamos esperando con firmeza y entusiasmo."
,"7":"Escuchemos lo que dice el Espíritu Santo: Ojalá escuchen hoy la voz del Señor;"
,"8":"no endurezcan su corazón, como ocurrió en el día amargo, el día de la tentación en el desierto,"
,"9":"cuando me tentaron sus padres, me pusieron a prueba y vieron mis prodigios"
,"10":"durante cuarenta años. Por eso me cansé de aquella generación y dije: 'Siempre andan extraviados, no han conocido mis caminos. "
,"11":"Me enojé y declaré con juramento: No entrarán jamás en mi lugar de descanso'."
,"12":"Cuidado, hermanos, que no haya entre ustedes alguien de mal corazón y bastante incrédulo como para apartarse del Dios vivo."
,"13":"Más bien anímense mutuamente cada día, mientras dura ese 'hoy'; que ninguno de ustedes se deje arrastrar por el pecado y llegue a endurecerse."
,"14":"Hemos pasado a ser solidarios de Cristo, pero con tal de que mantengamos hasta el fin nuestra convicción del principio."
,"15":"Fíjense en lo que dice la Escritura: Ojalá escuchen hoy la voz del Señor; no endurezcan su corazón, como ocurrió en el día amargo."
,"16":"¿Quiénes son esos que, después de haber oído, amargaron a Dios? Todos los que salieron de Egipto gracias a Moisés."
,"17":"¿Quiénes son los que cansaron a Dios durante cuarenta años? Los que habían pecado, por lo que perecieron y sus cadáveres quedaron en el desierto."
,"18":"¿A quiénes juró Dios que no entrarían en su lugar de descanso? A aquellos rebeldes, por supuesto,"
,"19":"y vemos que se les prohibió la entrada a causa de su falta de fe."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Cuidémonos, pues; no sea que alguno de ustedes deje pasar esta oferta de entrar en el descanso de Dios y no lo alcance."
,"2":"Nosotros, igual que ellos, recibimos una Buena Nueva, pero a ellos de nada les sirvió haberla oído, porque no creyeron ni se unieron a los que escucharon esas palabras."
,"3":"Es preciso, pues, que creamos, si queremos entrar en el lugar de descanso recién mencionado: Por eso me enojé y declaré con juramento: No entrarán jamás en mi lugar de descanso. Aquí se trata del descanso de Dios después de la creación del mundo."
,"4":"Ya se habló de este descanso a propósito del día séptimo: Y Dios descansó de todas sus obras el día séptimo."
,"5":"Aquí lo volvemos a encontrar: No entrarán jamás en mi descanso."
,"6":"Dos cosas, pues, se nos dicen: algunos entrarán; y los que recibieron primero la Buena Nueva no entraron por causa de su falta de fe."
,"7":"Por esta razón, mucho más tarde, Dios fija nuevamente un día que llama hoy, diciendo por boca de David lo que se recordó más arriba: Ojalá hoy escuchen la voz del Señor, no endurezcan su corazón."
,"8":"No creamos que Josué los introdujo en el lugar donde debían descansar; de ser así Dios no habría indicado posteriormente otro día."
,"9":"Un descanso sagrado, pues, espera todavía al pueblo de Dios,"
,"10":"y el que entre en ese descanso descansará de todos sus trabajos, como lo hizo Dios."
,"11":"Esforcémonos, pues, para entrar en ese descanso, y que nadie merezca, por su falta de fe, el castigo de que hablamos."
,"12":"En efecto, la palabra de Dios es viva y eficaz, más penetrante que espada de doble filo, y penetra hasta donde se dividen el alma y el espíritu, los huesos y los tuétanos, haciendo un discernimiento de los deseos y los pensamientos más íntimos."
,"13":"No hay criatura a la que su luz no pueda penetrar; todo queda desnudo y al descubierto a los ojos de aquél al que rendiremos cuentas."
,"14":"Tenemos, pues, un sumo sacerdote excepcional, que ha entrado en el mismo cielo, Jesús, el Hijo de Dios. Esto es suficiente para que nos mantengamos firmes en la fe que profesamos."
,"15":"Nuestro sumo sacerdote no se queda indiferente ante nuestras debilidades, pues ha sido probado en todo igual que nosotros, a excepción del pecado."
,"16":"Por lo tanto, acerquémonos con plena confianza al Dios de bondad, a fin de obtener misericordia y hallar la gracia del auxilio oportuno."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Todo sumo sacerdote es tomado de entre los hombres, y le piden representarlos ante Dios y presentar sus ofrendas y víctimas por el pecado."
,"2":"Es capaz de comprender a los ignorantes y a los extraviados, pues también lleva el peso de su propia debilidad;"
,"3":"por esta razón debe ofrecer sacrificios por sus propios pecados al igual que por los del pueblo."
,"4":"Pero nadie se apropia esta dignidad, sino que debe ser llamado por Dios, como lo fue Aarón."
,"5":"Y tampoco Cristo se atribuyó la dignidad de sumo sacerdote, sino que se la otorgó aquel que dice: Tú eres mi Hijo, te he dado vida hoy mismo."
,"6":"Y en otro lugar se dijo: Tú eres sacerdote para siempre a semejanza de Melquisedec."
,"7":"En los días de su vida mortal presentó ruegos y súplicas a aquel que podía salvarlo de la muerte; éste fue su sacrificio, con grandes clamores y lágrimas, y fue escuchado por su religiosa sumisión."
,"8":"Aunque era Hijo, aprendió en su pasión lo que es obedecer."
,"9":"Y ahora, llegado a su perfección, es fuente de salvación eterna para todos los que le obedecen,"
,"10":"conforme a la misión que recibió de Dios: sacerdote a semejanza de Melquisedec."
,"11":"A propósito de esto tendríamos muchas cosas que decir, pero nos cuesta exponerlas, porque se han vuelto lentos para comprender."
,"12":"Ustedes deberían ser maestros después de tanto tiempo, y, en cambio, necesitan que se les vuelvan a enseñar los primeros elementos de las enseñanzas de Dios. Necesitan leche y no alimento sólido."
,"13":"El que se queda con la leche no entiende todavía el lenguaje de la vida en santidad, no es más que un niño pequeño."
,"14":"A los adultos se les da el alimento sólido, pues han adquirido la sensibilidad interior y son capaces de distinguir lo bueno y lo malo."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Con todo, dejemos las primeras enseñanzas sobre Cristo y pasemos a cosas más avanzadas. No vamos a echar una vez más las bases, es decir, el arrepentimiento de las obras de muerte, la fe en Dios,"
,"2":"la doctrina referente a los bautismos, la imposición de las manos, la resurrección de los muertos y el juicio definitivo."
,"3":"Haremos, pues, como dijimos, si Dios nos lo permite."
,"4":"De todas maneras, es imposible renovar a los que ya fueron iluminados, que probaron el don sobrenatural y recibieron el Espíritu Santo,"
,"5":"y saborearon la maravillosa palabra de Dios con una experiencia del mundo futuro."
,"6":"Si a pesar de todo esto recayeron, es imposible renovarlos por la penitencia cuando vuelven a crucificar por su cuenta al Hijo de Dios y se burlan de él."
,"7":"Si una tierra absorbe las lluvias que la riegan a su debido tiempo y produce pasto provechoso para quienes la cultivan, recibe la bendición de Dios;"
,"8":"pero la que produce zarzas y espinas pierde su valor; un poco más y la maldicen, y terminarán por prenderle fuego."
,"9":"Ustedes se encuentran en una situación mejor y tienen salvación; lo creemos, amadísimos, aun cuando hablemos de este modo."
,"10":"Dios no es injusto para olvidar lo que han hecho y cómo han ayudado y todavía ayudan a los santos por amor de su Nombre."
,"11":"Solamente deseamos que cada uno demuestre hasta el fin el mismo interés por alcanzar lo que han esperado."
,"12":"No se vuelvan flojos, sino más bien imiten a aquellos que por su fe y constancia consiguieron al fin lo prometido."
,"13":"Tomen el ejemplo de Abrahán. Dios le hizo una promesa que confirmó con juramento y, como no había nadie más grande que Dios por quien jurar, juró invocando su propio Nombre:"
,"14":"Te colmaré de bendiciones y te multiplicaré sin medida."
,"15":"Y, perseverando, Abrahán vio realizarse las promesas de Dios."
,"16":"Los hombres juran por alguien mayor que ellos, y cuando algo es dudoso, el juramento pone fin a la discusión."
,"17":"Por eso Dios también confirmó su promesa con un juramento, para demostrar a sus destinatarios que nunca cambiaría su decisión."
,"18":"Tenemos, pues, promesa y juramento, dos cosas irrevocables en las que Dios no puede mentir y que nos dan plena seguridad cuando dejamos todo para aferrarnos a nuestra esperanza."
,"19":"Esta es nuestra ancla espiritual, segura y firme, que se fijó más allá de la cortina del Templo, en el santuario mismo."
,"20":"Allí entró Jesús para abrirnos el camino, hecho sumo sacerdote para siempre a semejanza de Melquisedec."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Se sabe que Melquisedec, rey de Salem, sacerdote del Dios Altísimo, salió al encuentro de Abrahán cuando volvía de derrotar a los reyes; bendijo a Abrahán"
,"2":"y Abrahán le dio la décima parte de todo el botín. El nombre de Melquisedec significa 'rey de justicia', y además era rey de Salem, o sea, 'rey de paz'. "
,"3":"No se mencionan ni su padre ni su madre; aparece sin antepasados. Tampoco se encuentra el principio ni el fin de su vida. Aquí tienen, pues, la figura del Hijo de Dios, el sacerdote que permanece para siempre."
,"4":"¡Imagínense quién puede ser este hombre al que nuestro antepasado Abrahán entrega la décima parte del botín!"
,"5":"Solamente los sacerdotes de la tribu de Leví están facultados por la Ley para cobrar el diezmo de manos del pueblo, es decir, de sus hermanos de la misma raza de Abrahán."
,"6":"Y aquí Melquisedec, que no tiene nada que ver con los hijos de Leví, cobra de Abrahán el diezmo y después bendice a Abrahán, el hombre de las promesas de Dios;"
,"7":"pero no cabe duda que corresponde al superior bendecir al inferior."
,"8":"En el primer caso, los hijos de Leví que cobran el diezmo son hombres que mueren; en cambio, Melquisedec es presentado como el que vive."
,"9":"Además, por así decirlo, cuando Abrahán paga el diezmo, lo paga con él la familia de Leví,"
,"10":"pues de alguna manera Leví estaba en su abuelo Abrahán cuando Melquisedec le vino al encuentro."
,"11":"Así, pues, si bien el sacerdocio de los levitas es el fundamento de las instituciones de Israel, no son capaces de llevar al pueblo a la religión perfecta. Si no, ¿qué necesidad habría de otro sacerdocio, no a semejanza de Aarón, sino a semejanza de Melquisedec?"
,"12":"Y si hay un cambio en el sacerdocio, necesariamente la Ley también ha de cambiar."
,"13":"Jesús, al que se refiere todo esto, pertenecía a una tribu de la que nadie sirvió jamás al altar."
,"14":"Pues es notorio que nuestro Señor salió de la tribu de Judá, de la que Moisés no habló cuando trató de los sacerdotes."
,"15":"Todo esto se hace más claro si el sacerdote a semejanza de Melquisedec recibe su cargo"
,"16":"no por efecto de una ley humana, sino por el poder de la vida que no conoce ocaso."
,"17":"Pues la Escritura dice: Tú eres sacerdote para siempre a semejanza de Melquisedec."
,"18":"Con esto se cancela la disposición anterior, que resultó insuficiente e ineficaz,"
,"19":"pues la Ley no trajo nada definitivo, y al mismo tiempo se nos abre una esperanza mucho mejor: la de tener acceso a Dios."
,"20":"Y aquí tenemos un juramento, lo que no se dio cuando los otros fueron hechos sacerdotes."
,"21":"El fue confirmado con este juramento: El Señor lo ha jurado y no se vuelve atrás: Tú eres sacerdote para siempre."
,"22":"Esta es la prueba de que Jesús viene con una alianza mucho mejor."
,"23":"Los sacerdotes anteriores se sucedían el uno al otro porque, siendo mortales, no podían permanecer."
,"24":"Jesús, en cambio, permanece para siempre y no se le quitará el sacerdocio."
,"25":"Por eso es capaz de salvar de una vez a los que por su medio se acercan a Dios. El sigue viviendo e intercediendo en favor de ellos."
,"26":"Así había de ser nuestro sumo sacerdote: santo, sin ningún defecto ni pecado, apartado del mundo de los pecadores y elevado por encima de los cielos."
,"27":"A diferencia de los sumos sacerdotes, él no tiene necesidad de ofrecer diariamente sacrificios, primero por sus pecados, y luego por los del pueblo. Y para el pueblo no lo hizo sino una sola vez ofreciéndose a sí mismo."
,"28":"Así, pues, todo es insuficiente en los sumos sacerdotes que la Ley establece, mientras que ahora, después de la Ley, Dios habla y pronuncia un juramento para establecer al Hijo eternamente perfecto."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Tratemos de resumir lo que hemos dicho: tenemos un sumo sacerdote que está sentado a la derecha del Dios de Majestad en los cielos;"
,"2":"él está a cargo del santuario y de la tienda verdadera, levantada no por hombres, sino por el Señor."
,"3":"Todo sumo sacerdote es instituido para presentar a Dios ofrendas y sacrificios y, por tanto, Jesús tiene que ofrecer algún sacrificio."
,"4":"Si se hubiera quedado en la tierra, ni siquiera sería sacerdote, puesto que son otros, designados por la Ley, los que ofrecen los sacrificios."
,"5":"Su liturgia, en realidad, no es sino una figura y una sombra de las cosas sobrenaturales, como lo indica la palabra de Dios a Moisés cuando estaba para construir el Santuario. Le dijo: Mira, harás todo conforme al modelo que se te mostró en el cerro."
,"6":"Pero ahora Jesús celebra una liturgia tanto superior cuanto es mediador de una alianza mucho mejor y que promete mejores beneficios."
,"7":"Si la primera alianza no mereciera críticas, no habría que buscar otra."
,"8":"Pero Dios mismo la critica cuando dice: Vienen días, palabra del Señor, en que pactaré una alianza nueva con la casa de Israel y de Judá. "
,"9":"No será como la alianza que hice con sus padres, cuando los tomé de la mano para sacarlos del país de Egipto. Ellos no permanecieron fieles a mi alianza, por lo cual yo también los descuidé, dice el Señor."
,"10":"Esta es la alianza que pactaré con la raza de Israel en esos tiempos que han de venir, palabra del Señor: Pondré mis leyes en su mente y las grabaré en su corazón, y yo seré su Dios y ellos serán mi pueblo."
,"11":"Nadie tendrá ya que enseñar a su compatriota o a su hermano diciéndoles: 'Conoce al Señor', porque todos me conocerán, desde el más chico al más grande."
,"12":"Yo perdonaré sus maldades y no volveré a acordarme de sus pecados."
,"13":"Se nos habla de una alianza nueva, lo que significa que la primera ha quedado anticuada; y lo que es anticuado y viejo está a punto de desaparecer."
}`)
	CurrentBook.AddChapter(9, `{
"1":"La primera alianza tenía una liturgia y un santuario como los hay en este mundo."
,"2":"Una primera habitación fue destinada para el candelabro y la mesa con los panes ofrecidos; esta parte se llama el Lugar Santo."
,"3":"A continuación, detrás de la segunda cortina, hay otra habitación, llamada el Lugar Santísimo,"
,"4":"donde está el altar de oro de los perfumes y el arca de la alianza enteramente cubierta de oro. El arca contenía un vaso de oro con el maná, la vara de Aarón que había florecido y las tablas de la Ley."
,"5":"Por encima el arca están los querubines de la Gloria, cubriendo con sus alas el Lugar del Perdón. Pero no cabe aquí describirlo todo con más detalles."
,"6":"Estando todo dispuesto de esta manera, los sacerdotes entran en todo tiempo en la primera habitación para cumplir su ministerio;"
,"7":"pero en la segunda tan sólo entra el sumo sacerdote una sola vez al año, y nunca sin la sangre que va a ofrecer por sus extravíos y por los del pueblo."
,"8":"De este modo el Espíritu nos enseña que mientras esté en pie la primera habitación, el camino que lleva al Santuario no está abierto."
,"9":"Todo eso contiene una enseñanza para el tiempo presente: las ofrendas y sacrificios que se presentan a Dios no pueden llevar a la perfección interior a quienes los ofrecen."
,"10":"Estos alimentos, bebidas y diferentes clases de purificación por el agua son ritos de hombres, y solamente valen hasta el tiempo de la reforma."
,"11":"Cristo vino como el sumo sacerdote que nos consigue los nuevos dones de Dios, y entró en un santuario más noble y más perfecto, no hecho por hombres, es decir, que no es algo creado."
,"12":"Y no fue la sangre de chivos o de novillos la que le abrió el santuario, sino su propia sangre, cuando consiguió de una sola vez la liberación definitiva."
,"13":"La sangre de chivos y de toros y la ceniza de ternera, con la que se rocía a los que tienen alguna culpa, les dan tal vez una santidad y pureza externa,"
,"14":"pero con toda seguridad la sangre de Cristo, que se ofreció a Dios por el Espíritu eterno como víctima sin mancha, purificará nuestra conciencia de las obras de muerte, para que sirvamos al Dios vivo."
,"15":"Por eso Cristo es el mediador de un nuevo testamento o alianza. Por su muerte fueron redimidas las faltas cometidas bajo el régimen de la primera alianza, y desde entonces la promesa se cumple en los que Dios llama para la herencia eterna."
,"16":"Cuando hay un testamento, se debe esperar a la muerte del testador."
,"17":"El testamento no tiene fuerza mientras vive el testador, y la muerte es necesaria para darle validez."
,"18":"Por eso se derramó sangre al iniciarse el antiguo testamento."
,"19":"Cuando Moisés terminó de proclamar ante el pueblo todas las ordenanzas de la Ley, tomó sangre de terneros y de chivos, la mezcló con agua, lana roja e hisopo y roció el propio libro del testamento y al pueblo, diciendo:"
,"20":"Esta es la sangre del testamento que pactó Dios con ustedes."
,"21":"Roció asimismo con sangre el santuario y todos los objetos del culto."
,"22":"Además, según la Ley, la purificación de casi todo se ha de hacer con sangre, y sin derramamiento de sangre no se quita el pecado."
,"23":"Tal vez fuera necesario purificar aquellas cosas que sólo son figuras de las realidades sobrenaturales, pero esas mismas realidades necesitan sacrificios más excelentes."
,"24":"Pues ahora no se trata de un santuario hecho por hombres, figura del santuario auténtico, sino que Cristo entró en el propio cielo, donde está ahora ante Dios en favor nuestro."
,"25":"El no tuvo que sacrificarse repetidas veces, a diferencia del sumo sacerdote que vuelve todos los años con una sangre que no es la suya;"
,"26":"de otro modo hubiera tenido que padecer muchísimas veces desde la creación del mundo. De hecho se manifestó una sola vez, al fin de los tiempos, para abolir el pecado con su sacrificio. "
,"27":"Los hombres mueren una sola vez, y después viene para ellos el juicio;"
,"28":"de la misma manera Cristo se sacrificó una sola vez para quitar los pecados de una multitud. La segunda vez se manifestará a todos aquellos que lo esperan como a su salvador, pero ya no será por causa del pecado."
}`)
	CurrentBook.AddChapter(10, `{
"1":"La religión de la Ley tiene una sombra de los bienes por venir, pero no la verdadera figura de las cosas. Por eso no puede llevar a la perfección mediante los sacrificios a los que vuelven a ofrecerlos año tras año."
,"2":"De otro modo quedarían puros de una vez gracias a su culto; ya no se sentirían culpables de ningún pecado y dejarían de ofrecer sus sacrificios."
,"3":"Pero no, cada año estos sacrificios recuerdan sus pecados;"
,"4":"es que la sangre de los toros y de los chivos no tiene valor para quitar los pecados."
,"5":"Por eso, al entrar Cristo en el mundo dice: Tú no quisiste sacrificios ni ofrendas, sino que me formaste un cuerpo. "
,"6":"No te agradaron los holocaustos ni los sacrificios por el pecado;"
,"7":"entonces dije: 'Aquí estoy yo, oh Dios, como en un capítulo del libro está escrito de mí, para hacer tu voluntad'."
,"8":"Comienza por decir: No quisiste sacrificios ni ofrendas, ni te agradaron holocaustos o sacrificios por el pecado. Y sin embargo esto es lo que pedía la Ley."
,"9":"Entonces sigue: Aquí estoy yo para hacer tu voluntad. Con esto anula el primer orden de las cosas para establecer el segundo."
,"10":"Esta voluntad de Dios, de que habla, es que seamos santificados por la ofrenda única del cuerpo de Cristo Jesús."
,"11":"Los sacerdotes están de servicio diariamente para cumplir su oficio, ofreciendo repetidas veces los mismos sacrificios, que nunca tienen el poder de quitar los pecados."
,"12":"Cristo, por el contrario, ofreció por los pecados un único y definitivo sacrificio y se sentó a la derecha de Dios,"
,"13":"esperando solamente que Dios ponga a sus enemigos debajo de sus pies."
,"14":"Su única ofrenda lleva a la perfección definitiva a los que santifica."
,"15":"Nos lo declara el Espíritu Santo. Después de decir:"
,"16":"Esta es la alianza que pactaré con ellos en los tiempos que han de venir, el Señor añade: Pondré mis leyes en su corazón y las grabaré en su mente."
,"17":"No volveré a acordarme de sus errores ni de sus pecados."
,"18":"Pues bien, si los pecados han sido perdonados, ya no hay sacrificios por el pecado."
,"19":"Así, pues, hermanos, no podemos dudar de que entraremos en el Santuario en virtud de la sangre de Jesús;"
,"20":"él nos abrió ese camino nuevo y vivo a través de la cortina, es decir, su carne."
,"21":"Teniendo un sacerdote excepcional a cargo de la casa de Dios,"
,"22":"acerquémonos con corazón sincero, con fe plena, limpios interiormente de todo lo que mancha la conciencia y con el cuerpo lavado con agua pura."
,"23":"Sigamos profesando nuestra esperanza sin que nada nos pueda conmover, ya que es digno de confianza aquel que se comprometió."
,"24":"Tratemos de superarnos el uno al otro en la forma de amar y hacer el bien."
,"25":"No abandonen las asambleas, como algunos acostumbran hacer, sino más bien anímense unos a otros, tanto más cuanto ven que se acerca el día."
,"26":"Si pecamos voluntariamente después de haber recibido el pleno conocimiento de la verdad, no puede haber ya sacrificio por el pecado;"
,"27":"solamente queda la perspectiva tremenda del juicio y del fuego que devorará a los rebeldes."
,"28":"No hay misericordia para el que desprecia la Ley de Moisés: es condenado a muerte por el testimonio de dos o tres personas."
,"29":"¿Qué pasará entonces con el que pisoteó al Hijo de Dios? ¿Qué castigo merecerá, según ustedes, el que ha profanado la sangre de la alianza con la cual fue santificado y ha insultado al Espíritu, don de Dios?"
,"30":"Conocemos al que dijo: A mí me corresponde la venganza, daré a cada cual su merecido. Y también: El Señor juzgará a su pueblo."
,"31":"Es espantoso caer en las manos del Dios vivo."
,"32":"Recuerden aquellos primeros tiempos, poco después de haber sido iluminados, en que tuvieron que soportar un duro y doloroso combate."
,"33":"Fueron expuestos públicamente a humillaciones y pruebas, tuvieron que participar del sufrimiento de otros que fueron tratados de esta manera."
,"34":"Sufrieron con los que iban a la cárcel, les quitaron sus bienes, y lo aceptaron gozosos, sabiendo que les esperaba una riqueza mejor y más duradera."
,"35":"Por eso no pierdan ahora su resolución, que tendrá una recompensa grande."
,"36":"Es necesario que sean constantes en hacer la voluntad de Dios, para que consigan su promesa."
,"37":"Acuérdense: dentro de poco, muy poquito tiempo, el que ha de venir llegará; no tardará."
,"38":"Mi justo, si cree, vivirá; pero si desconfía, ya no lo miraré con amor."
,"39":"Nosotros no somos de los que se retiran y pierden, sino que somos hombres de fe que salvan sus almas."
}`)
	CurrentBook.AddChapter(11, `{
"1":"La fe es como aferrarse a lo que se espera, es la certeza de cosas que no se pueden ver."
,"2":"Esto mismo es lo que recordamos en nuestros antepasados."
,"3":"Por la fe creemos que las etapas de la creación fueron dispuestas por la palabra de Dios y entendemos que el mundo visible tiene su origen en lo que no se palpa."
,"4":"Por la fe de Abel, su sacrificio fue mejor que el de su hermano Caín. Por eso fue considerado justo, como Dios lo dio a entender aprobando sus ofrendas. Y aun después de muerto, por su fe sigue clamando."
,"5":"Por su fe también Henoc fue trasladado al cielo en vez de morir, y los hombres no volvieron a verlo, porque Dios se lo había llevado. Antes de que fuera arrebatado al cielo, se nos dice que había agradado a Dios;"
,"6":"pero sin la fe es imposible agradarle, pues nadie se acerca a Dios si antes no cree que existe y que recompensa a los que lo buscan."
,"7":"Por la fe Noé escuchó el anuncio de acontecimientos que no se podían anticipar, y construyó el arca en que iba a salvarse con su familia. La fe de Noé condenaba a sus contemporáneos, y por ella alcanzó la verdadera rectitud, fruto de la fe."
,"8":"Por la fe Abrahán, llamado por Dios, obedeció la orden de salir para un país que recibiría en herencia, y partió sin saber adónde iba."
,"9":"La fe hizo que se quedara en la tierra prometida, que todavía no era suya. Allí vivió en tiendas de campaña, lo mismo que Isaac y Jacob, a los que beneficiaba la misma promesa."
,"10":"Pues esperaban la ciudad de sólidos cimientos, cuyo arquitecto y constructor es Dios."
,"11":"Por la fe pudo tener un hijo a pesar de su avanzada edad y de que Sara era también estéril, pues tuvo confianza en el que se lo prometía."
,"12":"Por eso de este hombre únicamente, ya casi impotente, nacieron descendientes tan numerosos como las estrellas del cielo e innumerables como los granos de arena de las orillas del mar."
,"13":"Todos murieron como creyentes. No habían conseguido lo prometido, pero lo habían visto de lejos y contemplado con gusto, reconociendo que eran extraños y peregrinos en la tierra."
,"14":"Los que así hablan, hacen ver claramente que van en busca de una patria;"
,"15":"pues si hubieran añorado la tierra de la que habían salido, tenían la oportunidad de volver a ella."
,"16":"Pero no, aspiraban a una patria mejor, es decir, a la del cielo. Por eso Dios no se avergüenza de ellos ni de llamarse su Dios, pues él les preparó la ciudad."
,"17":"Por la fe Abrahán fue a sacrificar a Isaac cuando Dios quiso ponerlo a prueba; estaba ofreciendo al hijo único que debía heredar la promesa,"
,"18":"y Dios le había dicho: Por Isaac tendrás descendientes que llevarán tu nombre."
,"19":"Abrahán pensó seguramente: Dios es capaz de resucitar a los muertos. Por eso recobró a su hijo, lo que tiene un sentido para nosotros."
,"20":"Por la fe también Isaac dio a Jacob y a Esaú las bendiciones que decidían el porvenir."
,"21":"Por la fe Jacob, moribundo, dio bendiciones diferentes a los hijos de José y se inclinó apoyándose en su bastón."
,"22":"Por la fe José, próximo a su fin, recordó que los hijos de Israel saldrían de Egipto y dio órdenes referentes a sus propios restos."
,"23":"Por la fe los padres del recién nacido Moisés lo escondieron durante tres meses, pues vieron que el niño era muy hermoso, y no temieron el decreto del rey."
,"24":"Por la fe Moisés, ya crecido, se negó a ser llamado hijo de una hija del faraón,"
,"25":"y quiso compartir no el goce pasajero del pecado, sino los malos tratos del pueblo de Dios."
,"26":"Se fijó en que Dios retribuiría a cada uno, y consideró que ser humillado con Cristo tenía más valor que todas las riquezas de Egipto."
,"27":"Por la fe abandonó Egipto sin temor al enojo del rey, porque se fijaba en otro enojo, pero invisible."
,"28":"Por la fe celebró la Pascua y rociaron con sangre las puertas para que el exterminador no diera muerte a sus hijos primogénitos."
,"29":"Por la fe atravesaron el mar Rojo como si fuera tierra seca, mientras que los egipcios trataron de pasarlo y se ahogaron."
,"30":"Por la fe cayeron los muros de Jericó después de dar la vuelta a su alrededor durante siete días."
,"31":"Por su fe la prostituta Rahab dio buena acogida a los espías y escapó a la muerte de los incrédulos."
,"32":"¿Qué más diré? Me faltaría tiempo para hablar de Gedeón, Barac, Sansón, Jefté, David, lo mismo que de Samuel y de los profetas."
,"33":"Ellos, gracias a la fe, sometieron a otras naciones, impusieron la justicia, vieron realizarse promesas de Dios, cerraron bocas de leones,"
,"34":"apagaron la violencia del fuego, escaparon del filo de la espada, sanaron de enfermedades, se mostraron valientes en la guerra y rechazaron a los invasores extranjeros."
,"35":"Hubo mujeres que recobraron resucitados a sus muertos; pero también hubo otros que, en vista de una resurrección mejor, se negaron a hacer el gesto que les habría salvado la vida: me refiero a los torturados."
,"36":"Otros sufrieron la prueba de las cadenas y de la cárcel."
,"37":"Fueron apedreados, torturados, aserrados, murieron a espada, anduvieron errantes de una parte para otra, sin otro vestido que pieles de corderos y de cabras, faltos de todo, oprimidos, maltratados."
,"38":"Esos hombres, de los cuales no era digno el mundo, tenían que vagar por los desiertos y las montañas y refugiarse en cuevas y escondites."
,"39":"Todos éstos merecieron que se recordara su fe, pero no por eso consiguieron el objeto de la promesa."
,"40":"Es que Dios veía más lejos y pensaba en nosotros, y no debían llegar al término antes que nosotros."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Innumerables son estos testigos, y nos envuelven como una nube. Depongamos, pues, toda carga inútil, y en especial las amarras del pecado, para correr hasta el final la prueba que nos espera."
,"2":"Levantemos la mirada hacia Jesús, que dirige esta competición de la fe y la lleva a su término. El escogió la cruz en vez de la felicidad que se le ofrecía; no tuvo miedo a la humillación, y ahora está sentado a la derecha del trono de Dios."
,"3":"Piensen en Jesús, que sufrió tantas contradicciones de parte de gente mala, y no les faltarán las fuerzas ni el ánimo."
,"4":"Ustedes se enfrentan con el mal, pero todavía no han tenido que resistir hasta la sangre."
,"5":"Tal vez hayan olvidado la palabra de consuelo que la sabiduría les dirige como a hijos: Hijo, no te pongas triste porque el Señor te corrige, no te desanimes cuando te reprenda;"
,"6":"pues el Señor corrige al que ama y castiga al que recibe como hijo."
,"7":"Ustedes sufren, pero es para su bien, y Dios los trata como a hijos: ¿a qué hijo no lo corrige su padre?"
,"8":"Si no conocieran la corrección, que ha sido la suerte de todos, serían bastardos y no hijos."
,"9":"Además, cuando nuestros padres según la carne nos corregían, los respetábamos. ¿No deberíamos someternos con mayor razón al Padre de los espíritus para tener vida?"
,"10":"Nuestros padres nos corregían sin ver más allá de la vida presente, tan corta, mientras que El mira a lo que nos ayudará a alcanzar su propia santidad."
,"11":"Ninguna corrección nos alegra en el momento, más bien duele; pero con el tiempo, si nos dejamos instruir, traerá frutos de paz y de santidad."
,"12":"Por lo tanto, levanten las manos caídas y fortalezcan las rodillas que tiemblan,"
,"13":"enderecen los caminos tortuosos por donde han de pasar, para que el cojo no se pierda y más bien se mejore."
,"14":"Procuren estar en paz con todos y progresen en la santidad, pues sin ella nadie verá al Señor."
,"15":"Cuídense, no sea que alguno de ustedes pierda la gracia de Dios y alguna raíz amarga produzca brotes, perjudicando a muchos."
,"16":"Que no haya ningún inmoral, impío como Esaú, que por un guiso entregó sus derechos sagrados de hijo mayor."
,"17":"Ustedes saben que después, cuando quiso obtener la bendición, fue rechazado y no pudo cambiar la decisión, aunque lo pidió con lágrimas."
,"18":"Recuerden su iniciación. No hubo aquel fuego físico que ardía junto a la nube oscura y la tempestad,"
,"19":"con el sonido de trompetas y una voz tan potente que los hijos de Israel suplicaron que no se les hablara más."
,"20":"De este modo acataron aquella orden de no acercarse: Quien toque el monte, aunque sea un animal, deberá ser apedreado."
,"21":"Lo que se veía era tan terrible que Moisés dijo: Estoy temblando de miedo."
,"22":"Ustedes, en cambio, se han acercado al cerro de Sión, a la ciudad del Dios vivo, a la Jerusalén celestial con sus innumerables ángeles,"
,"23":"a la asamblea en fiesta de los primeros ciudadanos del cielo; a Dios, juez universal, al que rodean los espíritus de los justos que ya alcanzaron su perfección;"
,"24":"a Jesús, el mediador de la nueva alianza, llevando la sangre que purifica y que clama a Dios con más fuerza que la sangre de Abel."
,"25":"Cuidado, pues, de hacerse los sordos con el que habla. Pues si no se salvaron en aquel tiempo los que desoyeron las palabras del profeta en la tierra, menos todavía nosotros si nos desentendemos del que habla desde los cielos."
,"26":"Su voz conmovió entonces la tierra, pero ahora se nos da este aviso: Esta última vez haré temblar no sólo la tierra, sino también el cielo."
,"27":"Las palabras esta última vez indican que serán cambiadas las cosas que pueden ser conmovidas, es decir, las creadas, y sólo permanecerán las que no se conmueven."
,"28":"Por eso, si hemos recibido el reino que no se puede conmover, conservemos esta gracia y sirvamos a Dios como él desea, con amor y de verdad,"
,"29":"pues nuestro Dios es fuego devorador."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Manténgase el amor fraterno."
,"2":"No dejen de practicar la hospitalidad, pues saben que algunos dieron alojamiento a ángeles sin saberlo."
,"3":"Acuérdense de los presos como si estuvieran con ellos en la cárcel, y de los que sufren, pues ustedes también tienen cuerpo."
,"4":"Que todos respeten el matrimonio y ninguno manche la unión conyugal. Dios castigará a los licenciosos y a los que cometen adulterio."
,"5":"No corran tras el dinero, sino más bien confórmense con lo que tienen, pues Dios ha dicho: Nunca te dejaré ni te abandonaré."
,"6":"Y nosotros hemos de responder confiados: El Señor es mi socorro, no temeré. ¿Qué pueden hacerme los hombres?"
,"7":"Acuérdense de sus dirigentes que les enseñaron la palabra de Dios; miren cómo dejaron esta vida e imiten su fe."
,"8":"Cristo Jesús permanece hoy como ayer y por la eternidad."
,"9":"No se dejen engañar por las novedades y las doctrinas extrañas a la fe. La gracia de Dios es un buen medio para fortalecer la vida interior; no cuenten con otros alimentos de los que nadie sacó provecho."
,"10":"Nosotros tenemos una mesa sagrada en la cual no pueden sentarse los que todavía sirven en el Templo."
,"11":"Y fíjense: después de que el sumo sacerdote ha llevado al Santuario la sangre que ofrece por el pecado, los cuerpos de las víctimas son quemados fuera del recinto sagrado."
,"12":"Por eso mismo también Jesús salió de la ciudad santa para sufrir su pasión y purificar al pueblo con su propia sangre."
,"13":"Salgamos, pues, del recinto sagrado para ir a su encuentro, y carguemos con su misma humillación,"
,"14":"sabiendo que no tenemos aquí una patria permanente, sino que andamos en busca de la futura."
,"15":"Ofrezcamos a Dios en todo tiempo, por medio de Jesús, el sacrificio de alabanza, que consiste en celebrar su Nombre."
,"16":"No se olviden de compartir y de hacer el bien, pues tales sacrificios son los que agradan a Dios."
,"17":"Obedezcan a sus dirigentes y estén sumisos, pues ellos se desvelan por sus almas, de las cuales deberán rendir cuenta. Ojalá esto sea para ellos motivo de alegría y no un peso, pues no les traería a ustedes ventaja de ninguna clase."
,"18":"Rueguen por nosotros, que sólo deseamos proceder en todo con rectitud y estamos seguros de que nuestras intenciones son limpias."
,"19":"Les ruego encarecidamente que recen a Dios para que cuanto antes pueda volver a ustedes."
,"20":"Que los bendiga el Dios de la paz,que rescató de entre los muertos a Jesús, nuestro Señor, Pastor Supremo de las ovejas por haber derramado la sangre de la Alianza eterna;"
,"21":"que les haga adquirir todo lo que es perfecto, para que así cumplan su voluntad, pues él pone en nosotros lo que le agrada, por Cristo Jesús, a quien sea la gloria por los siglos de los siglos. Amén"
,"22":"Hermanos, les ruego que acepten estas palabras de exhortación, pues les escribí un poco apurado."
,"23":"Sepan que nuestro hermano Timoteo fue puesto en libertad. Si viene pronto, iré con él a visitarlos."
,"24":"Saluden a todos sus dirigentes y a todos los santos hermanos nuestros. Los de Italia los saludan."
,"25":"La gracia sea con todos ustedes."
}`)

}
func ES_LBL_LoadVH1MChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Alejandro, hijo de Filipo, rey de Macedonia, que venía,del país de Quitim, reinaba en toda la Grecia. Después de haber,vencido a Darío, rey de los persas, reinó en su lugar. "
,"2":"Sostuvo numerosas batallas, se apoderó de ciudades,fortificadas y dio muerte a los reyes de esas regiones. "
,"3":"Llegó,hasta los confines del mundo, amontonando riquezas de muchos,países. La tierra tuvo que callarse ante él y su orgullo no tuvo,límites. "
,"4":"Reunió a un ejército muy numeroso, dominó a,provincias, pueblos y reyes y los hizo sus súbditos. "
,"5":"Pero,después de todo eso cayó enfermo y vio que se iba a morir; "
,"6":"entonces convocó a sus compañeros, a los que habían sido,educados con él desde la infancia, y les repartió su reino estando,aún con vida."
,"7":"Alejandro murió después de doce años de reinado;"
,"8":"sus,compañeros tomaron el poder, cada cual en su sector. "
,"9":"Luego de,su muerte, todos ellos se hicieron coronar como reyes y lo mismo,hicieron sus hijos después de ellos durante largos años: el mal,fue aumentando en la tierra."
,"10":"De su descendencia salió aquel retoño impío, Antíoco,Epífanes, hijo del rey Antíoco. Había estado primero como rehén en,Roma, pero el año ciento treinta de la realeza de los griegos,subió al trono. "
,"11":"Fue entonces cuando surgieron en Israel,unos renegados que arrastraron a muchos consigo: 'Reconciliémonos,con las naciones que nos rodean, pues desde que nos separamos de,ellos, nos han ocurrido muchas desgracias'."
,"12":"Esta sugerencia tuvo buena acogida:"
,"13":"algunas personas de,nuestro pueblo fueron a ver al rey quien los autorizó para que,siguieran las costumbres de los paganos. "
,"14":"Construyeron en,Jerusalén un gimnasio, tal como lo hacían los paganos, "
,"15":"se repusieron los prepucios y renegaron de la Alianza,Santa para engancharse al mismo carro que los paganos; se,vendieron para hacer el mal."
,"16":"Cuando Antíoco creyó que tenía ya el reino en sus manos, quiso también reinar en Egipto y ser así el soberano de los dos,reinos. "
,"17":"Invadió Egipto con un poderoso ejército, con carros, elefantes, caballería y muchos barcos. "
,"18":"Atacó a Tolomeo, rey,de Egipto, quien no opuso resistencia y emprendió la fuga; muchos,de sus hombres cayeron muertos. "
,"19":"Antíoco se apoderó de las,fortalezas de Egipto y arrasó con todas las riquezas del país. "
,"20":"Después de haber vencido a Egipto, tomó el camino de,regreso, el año ciento cuarenta y tres. Fue entonces cuando se,abalanzó sobre Israel y sobre Jerusalén con un poderoso ejército."
,"21":"Lleno de orgullo, Antíoco entró en el santuario y sacó el,altar de oro, el candelabro en el que brilla la luz, con todos sus,accesorios, "
,"22":"la mesa y las vasijas para las ofrendas, las,copas, los incensarios de oro, el velo, las coronas; arrancó todas,las placas de oro que adornaban la fachada del Templo. "
,"23":"Juntó todo el oro y la plata, objetos preciosos y todos,los tesoros escondidos que pudo descubrir "
,"24":"y se fue a su país,llevándoselo todo. Derramó mucha sangre e hizo declaraciones,injuriosas contra Dios."
,"25":"Todos los pueblos de Israel están de duelo,"
,"26":"los,jefes y los ancianos gimen, las muchachas y los jóvenes están,macilentos y las mujeres han perdido su belleza. "
,"27":"Las,canciones de boda se han cambiado en lamentaciones y la recién,casada está de duelo en su pieza. "
,"28":"La tierra se estremece,al ver quiénes la ocupan, y toda la casa de Jacob está cubierta de,vergüenza."
,"29":"Dos años después, el rey envió a un jefe a las ciudades,de Judá, quien llegó a Jerusalén con un poderoso ejército. "
,"30":"Engañó a los habitantes con palabras pacíficas, pero, cuando,se hubo ganado su confianza, se lanzó por sorpresa sobre la,ciudad, la castigó brutalmente y dio muerte a mucha gente de,Israel. "
,"31":"Saqueó la ciudad, la incendió, demolió sus casas y,sus murallas. "
,"32":"Sus soldados se llevaron cautivas a las mujeres,y a los niños y arriaron con todo el ganado."
,"33":"Después reconstruyeron la ciudad de David, haciendo allí una,fortaleza con una muralla muy ancha y con poderosas torres. "
,"34":"Dentro de la fortaleza pusieron gente sin conciencia, a,renegados que se hicieron fuertes allí. "
,"35":"Almacenaron allí,armas y provisiones, y amontonaron dentro todo lo que habían,reunido en Jerusalén; pasó a ser una terrible amenaza. "
,"36":"Era,un peligro para el Lugar Santo y el enemigo amenazaba desde allí a,Israel a cada momento."
,"37":"Derramaron sangre inocente alrededor del Santuario, profanaron el Lugar Santo. "
,"38":"Los habitantes de Jerusalén,huyeron, y ésta se convirtió en una guarida de extranjeros; pasó a,ser una extranjera para sus hijos, y éstos la abandonaron."
,"39":"Su templo se convirtió en un desierto, sus fiestas se,cambiaron en días de luto, sus sábados fueron burlados, era el,desprecio en vez del respeto. "
,"40":"Era tan grande su vergüenza, que su gloria de otrora, su grandeza, cedió el lugar al duelo."
,"41":"El rey ordenó después que todos en su imperio,formasen un solo pueblo; "
,"42":"cada cual debía renunciar a sus,propias costumbres. Todos los paganos se sometieron a las órdenes,del rey "
,"43":"e incluso en Israel muchas personas dieron buena,acogida a su culto, sacrificando a los ídolos y profanando el,sábado. "
,"44":"El rey mandó mensajeros a Jerusalén y a las ciudades,de Judá para que les transmitieran sus órdenes: en adelante tenían,que seguir costumbres extranjeras, "
,"45":"acabar con los,holocaustos del Templo, los sacrificios y las libaciones. Había,que profanar los sábados y las fiestas, "
,"46":"ensuciar el,Santuario y todo lo que es santo, "
,"47":"instalar altares, lugares,de culto y templos a los ídolos, inmolar cerdos y animales,impuros. "
,"48":"Debían dejar sin circuncisión a los hijos y,ensuciarse con toda clase de impurezas y profanaciones. "
,"49":"En,una palabra, tenían que olvidarse de la Ley y enterrar todas sus,prescripciones; "
,"50":"el que no obedeciera las órdenes del rey,debería ser condenado a muerte."
,"51":"Así se expresaban las cartas que envió el rey a todo su,reino; le impuso inspectores a todo el pueblo y ordenó a todas las,ciudades de Judá que ofrecieran sacrificios. "
,"52":"Mucha gente,del pueblo obedeció, todos aquellos que abandonaron la Ley; hicieron el mal en el país, "
,"53":"obligando a Israel a esconderse,en refugios."
,"54":"El día quince del mes de Quisleu, el año ciento cuarenta,y cinco, el rey instaló la Abominación de la Desolación en el,altar de los holocaustos, y se levantaron altares en las ciudades,vecinas de Judá. "
,"55":"Se quemaba incienso en las puertas de las,casas y en las plazas, "
,"56":"se rompían y se echaban al fuego los,libros de la Ley cuando se los encontraba, "
,"57":"y si se descubría,en la casa de alguien un libro de la Alianza o si alguien obedecía,a la Ley de Dios, se lo condenaba a muerte según el decreto del,rey."
,"58":"Mes a mes en sus ciudades se castigaba a los israelitas que,eran sorprendidos contraviniendo lo dispuesto, "
,"59":"y el,veinticinco de cada mes se ofrecían sacrificios en el altar,instalado en el lugar del altar de los holocaustos. "
,"60":"Según esa ley se condenó a muerte a mujeres que habían,hecho circuncidar a sus hijos, "
,"61":"junto con sus niñitos,abrazados a su cuello; también eran condenados a muerte sus,familiares y los que habían hecho la circuncisión. "
,"62":"A pesar,de todo eso, muchos continuaron siendo fieles en Israel y fueron,lo bastante valientes como para no comer alimentos impuros. "
,"63":"Preferían morir antes que volverse impuros con alimentos,que iban en contra de la Alianza Santa, y fueron ejecutados. "
,"64":"Esto fue una gran prueba para Israel."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Por esos días, un sacerdote de nombre Matatías, hijo,de Juan, hijo de Simeón, de la descendencia de Yoarib, salió de,Jerusalén y se estableció en Modín. "
,"2":"Tenía cinco hijos: Juan, apellidado Gadi, "
,"3":"Simón, apellidado Tassi,"
,"4":"Judas, apellidado Macabeo, "
,"5":"Eleazar, apellidado Avaram, y Jonatán, apellidado Afús. "
,"6":"Al ver todos esos pecados que se cometían en,Judá y en Jerusalén, "
,"7":"exclamó: '¡Qué desgracia! ¡No nací para,ver la ruina de mi pueblo y la ruina de la ciudad santa! Mientras,permanezco aquí sentado, la ciudad está en manos de los enemigos, y el Templo en poder de los extranjeros."
,"8":"El Templo de Dios es ahora como un hombre despreciado."
,"9":"Todo lo que constituía su gloria partió para el cautiverio. Sus hijos fueron asesinados en las plazas, y sus jóvenes, muertos por la espada del enemigo."
,"10":"¿Hay alguna nación que no haya recibido sus bienes en,herencia; que no se haya apoderado de sus despojos?"
,"11":"Le han robado toda su belleza, la que era libre, es ahora esclava."
,"12":"El Lugar santo, nuestra maravilla y nuestra gloria, no es ahora más que un desierto, pues lo han profanado los paganos."
,"13":"¿De qué me sirve seguir aún con vida?'"
,"14":"Matatías y sus hijos rasgaron sus ropas, se vistieron de,sacos e hicieron un gran duelo."
,"15":"Llegaron por entonces a Modín los oficiales del rey, que,debían imponer la apostasía y obligar a ofrecer sacrificios. "
,"16":"Muchos israelitas se pusieron de su parte, pero Matatías y,sus hijos, no. "
,"17":"Los oficiales del rey dijeron a Matatías: 'Tú,eres un personaje importante y respetado en esta ciudad, tú tienes,hijos y hermanos que te siguen; "
,"18":"ven tú, el primero, a,obedecer las órdenes del rey, tal como lo han hecho todas las,naciones, los jefes de Judá y los que se quedaron en Jerusalén. Si,lo haces, tú y tus hijos serán admitidos entre los amigos del rey, y serán recompensados con oro y plata y con muchas otras cosas'."
,"19":"Matatías respondió con todas sus fuerzas: 'Aunque le,obedeciesen al rey todos los pueblos que conforman su imperio, aunque todos abandonasen el culto de sus padres para seguir sus,ordenanzas, "
,"20":"yo, mis hijos y mis hermanos seguiremos la,Alianza de nuestros padres. "
,"21":"¡Líbrenos Dios de abandonar la,Ley y sus prescripciones! "
,"22":"No obedeceremos pues las órdenes,del rey ni nos apartaremos de nuestra religión ni a la derecha ni,a la izquierda'."
,"23":"Apenas terminó de hablar, se adelantó un judío, delante de,todo el pueblo, para sacrificar en el altar de Modín, según el,decreto del rey. "
,"24":"Al ver eso, Matatías, lleno de indignación,y de cólera, dando rienda suelta a su furor, se abalanzó sobre el,hombre y lo degolló ante el altar. "
,"25":"Luego mató al oficial del,rey que obligaba a sacrificar y derribó el altar. "
,"26":"Su,celo por la Ley fue igual al de Pinjas, cuando hirió de muerte a,Zimri, hijo de Salú."
,"27":"Luego Matatías salió gritando por medio de la ciudad: '¡Los,que quieran defender la Ley y continuar con la Alianza, que me,sigan!' "
,"28":"Huyó a los cerros junto con sus hijos, dejando en,la ciudad todo lo que tenía."
,"29":"Muchas personas que respetaban la justicia y los,decretos de la Ley, se fueron a instalar en el desierto. "
,"30":"Llegaron allá con sus hijos, sus mujeres y su ganado, porque,la vida se había vuelto imposible. "
,"31":"Les comunicaron a los,oficiales del rey y a las tropas acantonadas en Jerusalén, en la,ciudad de David, que mucha gente rechazaba las órdenes del rey y,buscaba refugio en los escondites del desierto. "
,"32":"Salió,entonces un fuerte destacamento a perseguirlos y atacarlos; se,apostó frente a ellos y se dispuso a atacarlos siendo día sábado."
,"33":"Les dijeron: '¡Basta ya, salgan! ¡Obedezcan la orden del rey,y salvarán su vida!' "
,"34":"Pero ellos respondieron: '¡No,saldremos! No cumpliremos el decreto del rey y no violaremos el,día sábado'. "
,"35":"Entonces los atacaron."
,"36":"Ellos se negaron a,responder, a lanzar piedras o a formar barricadas en sus,escondites: "
,"37":"'Muramos todos, decían, así nadie nos reprochará,algo; el cielo y la tierra son testigos de que ustedes nos matan,injustamente'. "
,"38":"Los otros emprendieron el asalto siendo día,sábado, y ellos murieron junto con sus mujeres, sus niños y su,ganado; había allí alrededor de unas mil personas."
,"39":"Cuando Matatías y sus amigos supieron lo sucedido, hicieron,un gran duelo. "
,"40":"Pero se dijeron entre sí: 'Si hacemos lo mismo,que nuestros hermanos, si no nos defendemos de los paganos para,salvar nuestra vida y nuestras observancias, muy pronto nos,eliminan de este país'. "
,"41":"Por eso tomaron ese mismo día esta,decisión: 'Si alguien viene a atacarnos un día sábado, lo,enfrentaremos y no nos dejaremos aplastar como lo hicieron,nuestros hermanos que murieron en sus refugios'."
,"42":"Se les unieron luego un grupo de Asideos, israelitas,valientes y devotos de la Ley. "
,"43":"Todos los que huían del,peligro fueron a reforzarlos y a engrosar sus filas; "
,"44":"así,fueron organizando su ejército. Comenzaron después a descargar su,cólera sobre los renegados, y su furor sobre los que habían,abandonado la Ley. Estos tuvieron que huir a los poblados paganos,en busca de refugio. "
,"45":"Matatías y sus amigos llevaron a cabo,expediciones para destruir los altares "
,"46":"y circuncidar a la,fuerza a los niños no circuncidados que encontraban en el,territorio de Israel. "
,"47":"Persiguieron a los insolentes y,tuvieron pleno éxito; "
,"48":"recuperaron su religión de manos de,las naciones paganas y de su rey, y redujeron al silencio a los,pecadores."
,"49":"Cuando la vida de Matatías llegaba a su fin, reunió a sus,hijos: 'Ustedes ven ahora el reinado de la insolencia y del,menosprecio, les dijo, el tiempo de los trastornos y el desborde,de la cólera. "
,"50":"Ustedes, hijos míos, dedíquense por entero a,la Ley y den sus vidas por la Alianza de nuestros padres."
,"51":"Acuérdense de lo que nuestros padres realizaron en su tiempo, y conseguirán una gran gloria y un nombre inmortal. "
,"52":"Abrahán,fue hallado fiel en la prueba y por eso fue considerado como un,justo. "
,"53":"José, en el tiempo de la desgracia, supo cumplir la,Ley y llegó a ser dueño de Egipto. "
,"54":"Pinjas, nuestro padre, ardía de celo y recibió por eso la alianza de un sacerdocio,eterno."
,"55":"Josué cumplió fielmente su misión y llegó a ser juez de,Israel. "
,"56":"Caleb proclamó la verdad en medio de la asamblea y,recibió una herencia en el país. "
,"57":"David, por su piedad, recibió un trono real que perdurará más allá de los siglos. "
,"58":"Elías, que ardía de celo por la Ley, fue llevado al cielo."
,"59":"Ananías, Azarías, Misael tuvieron confianza y fueron,salvados de las llamas. "
,"60":"Daniel, que no transigió, fue,salvado de las fauces de los leones."
,"61":"Sepan pues que, de generación en generación, los que esperan,en Dios no serán vencidos. "
,"62":"No teman las amenazas de un,hombre que va en contra de Dios, porque su gloria terminará en la,basura y en la podredumbre. "
,"63":"Hoy lo honran, pero mañana ya,nadie lo conoce; volverá al polvo de donde salió y nada quedará de,sus proyectos."
,"64":"Hijos míos, sean pues valientes y sigan fieles a la Ley, porque de ella provendrá su gloria. "
,"65":"Miren a su hermano,Simeón, sé que tiene buen criterio. Háganle siempre caso, él será,un padre para ustedes. "
,"66":"Judas Macabeo ha sido valiente desde,su infancia, él será el comandante del ejército, él dirigirá la,guerra contra las naciones. "
,"67":"Vayan a reunir a todos los que,observan la Ley y venguen a su pueblo. "
,"68":"Devuelvan a las,naciones paganas el mal que les hicieron a ustedes y manténganse,firmes a los mandamientos de la Ley'."
,"69":"Luego los bendijo y fue a reunirse con sus padres."
,"70":"Murió el año ciento cuarenta y seis; lo enterraron en la,tumba de sus padres en Modín, e Israel hizo un gran duelo por él."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Lo reemplazó su hijo Judas, por sobrenombre Macabeo."
,"2":"Sus hermanos y todos los que estaban con su padre le,entregaron su apoyo, y llevaron exitosamente la lucha de Israel."
,"3":"Expandió la fama de su pueblo, era un gigante cuando se ponía,la coraza y tomaba sus armas para entrar en la batalla. Su espada,protegía el campamento de Israel."
,"4":"En las batallas era como un león, como un leoncito que ruge,tras su presa."
,"5":"Persiguió a los renegados, buscando y condenando a la hoguera,a los que perturbaban a su pueblo."
,"6":"Sembró el terror entre los renegados; los que habían,transgredido la Ley estaban aterrorizados, y gracias a él se logró,la liberación."
,"7":"Les amargaba la vida a los reyes, pero sus hazañas eran,motivo de alegría para Jacob; su memoria será bendita para,siempre."
,"8":"Recorrió las ciudades de Judá, exterminando a los impíos y,apartando de Israel la cólera divina."
,"9":"Reunió a los que estaban perdidos, y su fama alcanzó hasta,los confines del mundo."
,"10":"Apolonio reunió a paganos y a mucha gente de Samaría,para luchar contra Israel. "
,"11":"Cuando lo supo Judas, salió a su,encuentro, lo atacó y le dio muerte; muchos cayeron heridos de,muerte y los demás huyeron. "
,"12":"Cuando se recogieron los,despojos, Judas tomó para sí la espada de Apolonio; a partir de,entonces la usó siempre en los combates."
,"13":"Serón, el general del ejército de Siria, supo que Judas había,reunido en torno a él a muchos creyentes y soldados. "
,"14":"Entonces pensó: 'Esta es la oportunidad para hacerme célebre,y para cubrirme de gloria en el reino. Voy a combatir con Judas y,sus hombres que desprecian las órdenes del rey'. "
,"15":"Llegó pues,con un poderoso ejército de impíos para vengarse de los hijos de,Israel. "
,"16":"Cuando se acercaba a la subida de Bet-Horón, Judas salió a su encuentro con un pequeño contingente."
,"17":"Al ver el ejército que avanzaba contra ellos, los hombres de,Judas le dijeron: '¿Cómo podremos combatir con un ejército tan,grande si somos tan pocos? Además estamos sin fuerza porque hoy no,hemos comido nada.' "
,"18":"Judas les respondió: 'No es difícil,que muchos hombres sean vencidos por unos pocos. Para el Cielo da,lo mismo conceder la salvación con muchos hombres o con unos,pocos; "
,"19":"sepan que en la guerra la victoria no es de los más,numerosos, sino que la fuerza proviene del Cielo. "
,"20":"Es el,orgullo y la impiedad que los llevan, porque quieren acabar con,nosotros, nuestras mujeres y nuestros hijos, y apoderarse de,nuestros bienes. "
,"21":"Nosotros, en cambio, defendemos nuestras,vidas y nuestras leyes, "
,"22":"y el Cielo los hará añicos ante,nuestros ojos. ¡No les teman, pues!'"
,"23":"Apenas terminó de hablar, se abalanzó sobre ellos de,improviso: Serón y sus hombres fueron derrotados. "
,"24":"Los,persiguieron por la bajada de Bet-Horón hasta la llanura; murieron,como ochocientos hombres y los demás huyeron al país de los,filisteos."
,"25":"Comenzaron a temer a Judas y a sus hermanos, y se apoderó el,pánico de todas las naciones vecinas; "
,"26":"su fama llegó hasta el,rey y todos los pueblos comentaron las batallas de Judas. "
,"27":"Antíoco se enojó mucho cuando lo supo, y dio orden de,concentrar todas las tropas de su reino: era un ejército,formidable. "
,"28":"Abrió sus cofres y dio a las tropas el sueldo de,un año, pidiéndoles que se quedaran en pie de guerra."
,"29":"Luego se dio cuenta de que faltaba el dinero en sus arcas y,que habían disminuido los impuestos de la provincia a causa de las,divisiones y de otros problemas que él mismo había provocado al,suprimir en el país las leyes que existían desde siempre. "
,"30":"Acostumbraba gastar y regalar, como no lo habían hecho los,reyes que habían estado antes que él, pero entonces tuvo miedo de,que no tuviera lo suficiente para hacer frente a tantos gastos. "
,"31":"Al verse en serias dificultades, decidió dirigirse a Persia,para recaudar los impuestos de las provincias y regresar con mucho,dinero."
,"32":"Dejó pues a Lisias, un noble de la familia real, como,encargado de sus asuntos desde el Eufrates hasta la frontera con,Egipto. "
,"33":"Lisias debía cuidar de su hijo Antíoco hasta su,vuelta. "
,"34":"Le pasó la mitad de su ejército con los elefantes y,le dio instrucciones sobre todo y muy especialmente sobre los,habitantes de Judá y de Jerusalén. "
,"35":"Tenía que despachar en,contra de ellos a un ejército para que los aplastase, eliminar las,fuerzas de Israel y el pequeño resto de Jerusalén, para que no se,volviera a hablar más de esa ciudad. "
,"36":"Después de eso,instalaría extranjeros en todo el territorio y les distribuiría,esas tierras. "
,"37":"El rey tomó la otra mitad del ejército y salió,de su capital de Antioquía el año ciento cincuenta y siete; atravesó el Eufrates y se adentró en las provincias de la montaña."
,"38":"Lisias escogió entre los amigos del rey a Tolomeo, hijo,de Dorimeneo, Nicanor y Gorgías, todos personajes influyentes. "
,"39":"Junto con ellos envió a cuarenta mil soldados de infantería,y siete mil de caballería para invadir y destruir el territorio de,Judá, según la orden del rey. "
,"40":"Gorgías se puso en marcha con,todo ese ejército y llegó hasta cerca de Emaús, en la llanura,costera; allí instaló su campamento. "
,"41":"Cuando los comerciantes,de la provincia se enteraron de eso, llegaron cargados de oro y,plata, con muchas esposas para apresar y se presentaron en el,campamento listos para comprar prisioneros israelitas. También se,les juntaron gente de Idumea y del territorio de los filisteos."
,"42":"Cuando Judas y sus hermanos vieron los ejércitos acampando,en su territorio, se dieron cuenta de que las cosas iban muy mal. Se informaron también de la consigna que había dado el rey: destruir totalmente a su pueblo. "
,"43":"Entonces se dijeron unos a,otros: 'Salvemos a nuestro pueblo de la destrucción y luchemos por,nuestro pueblo y por nuestro Lugar Santo'. "
,"44":"Se convocó a una,asamblea; allí se prepararon para la batalla, se oró y se imploró,piedad y misericordia."
,"45":"Jerusalén, despoblada, era un desierto. Ninguno de sus hijos,entraba allí, ni nadie tampoco salía; el santuario había sido,pisoteado; extranjeros vivían en la ciudadela, que se había,convertido en una guarida de paganos. En Jacob se habían acabado,los bailes, y ya no se oía el sonido de la flauta ni de la lira."
,"46":"Todos se reunieron en Masfa, frente a Jerusalén, porque,Masfa había sido antes un lugar de oración para Israel. "
,"47":"Ese,día ayunaron, se vistieron con sacos, se echaron ceniza en sus,cabezas y rasgaron sus ropas."
,"48":"Se desenrolló el Libro de la Ley para hallar allí,respuestas, las mismas que los paganos pedían a sus ídolos. "
,"49":"Se trajeron las vestimentas de los sacerdotes, primicias y,diezmos; también pidieron que fueran allá los nazireos que habían,terminado el tiempo de su manda, "
,"50":"y todos se pusieron a clamar,al cielo diciendo: '¿Qué haremos con esa gente? ¿A dónde los,llevaremos? "
,"51":"Tu Lugar Santo ha sido pisoteado y profanado. Tus sacerdotes están de duelo, humillados. "
,"52":"Las naciones se,han aliado en contra de nosotros para hacernos desaparecer. Tú,conoces bien sus intenciones. "
,"53":"¿Cómo podremos resistirles si,tú mismo no vienes a ayudarnos?' "
,"54":"Entonces tocaron las,trompetas y lanzaron grandes aclamaciones."
,"55":"En seguida designó Judas jefes para el pueblo, jefes de,mil, de cien, de cincuenta y de diez. "
,"56":"A los que estaban,construyendo una casa, a los que se habían casado recién o,acababan de plantar una viña, y a todos los que tenían miedo, les,dijeron que se volvieran a su casa, tal como lo autorizaba la Ley. "
,"57":"Después el ejército se puso en marcha y fue a acampar al sur,de Emaús. "
,"58":"Judas les dijo: '¡Cada cual tome su equipo y sean,valientes! Estén listos para pelear mañana con esas naciones que,se han congregado en contra de nosotros para destruirnos a,nosotros y a nuestro santuario. "
,"59":"Es mejor para nosotros morir,en la batalla que contemplar la destrucción de nuestro pueblo y de,nuestro Lugar Santo. ¡Que sea lo que el cielo quiera!'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Gorgías salió de noche, llevando consigo a cinco mil,soldados de infantería y a mil de los mejores de caballería, "
,"2":"para asaltar el campamento de los judíos y tomarlos por,sorpresa. Lo guiaban hombres de la ciudadela. "
,"3":"Le avisaron a,Judas, quien salió entonces con sus hombres para atacar al,ejército del rey que estaba en Emaús, "
,"4":"aprovechándose de que,dichas tropas se habían alejado del campamento. "
,"5":"Gorgías llegó,de noche al campamento de Judas, pero, como no encontró allí a,nadie, se puso a buscar a los judíos por los cerros, pues se,decía: 'Han huido ante nosotros'. "
,"6":"Mientras, al amanecer, apareció Judas en la llanura con tres mil hombres. No tenían, en,realidad, ni las armaduras ni las espadas adecuadas, "
,"7":"y veían,ante sí el campamento de los paganos, poderoso y bien fortificado, con toda la caballería en derredor; era gente que sabía combatir."
,"8":"Judas dijo entonces a sus hombres: 'No teman a esa muchedumbre,ni tiemblen ante su ataque. "
,"9":"Recuerden cómo fueron liberados,nuestros padres en el Mar Rojo cuando el faraón los perseguía con,su ejército. "
,"10":"¡Clamemos pues al Cielo! Si él lo quiere, se,acordará de su Alianza con nuestros padres y hoy mismo aplastará a,ese ejército que ven ante ustedes. "
,"11":"Entonces sabrán todas las,naciones que Alguien rescata y salva a Israel!'"
,"12":"Al levantar la vista, los extranjeros vieron a los judíos que,se dirigían hacia ellos, "
,"13":"y salieron del campamento para,combatir. Los soldados de Judas tocaron las trompetas "
,"14":"y,entraron en la batalla. Los paganos fueron derrotados y,emprendieron la fuga a través de la llanura, "
,"15":"pero todos los,rezagados cayeron bajo la espada. Los persiguieron hasta Gazer, hasta las llanuras de Idumea, de Azoto y de Jamnia; hubo más o,menos tres mil muertos."
,"16":"Cuando volvió de la persecución con su ejército,"
,"17":"Judas,dijo al pueblo: 'Todavía no es el momento de pensar en el pillaje, porque nos espera aún otro combate: "
,"18":"Gorgías y sus hombres,están en los cerros muy cerca de nosotros. Quédense listos para,enfrentar a nuestros enemigos; después de eso, podrán recoger el,botín sin miedo'."
,"19":"Recién había Judas pronunciado esas palabras, cuando,divisaron a las tropas enemigas que los observaban de lo alto de,los cerros. "
,"20":"Habían visto que los suyos habían emprendido la,fuga y que las llamas habían devorado su campamento; les bastó con,ver el humo para darse cuenta de todo. "
,"21":"Ese espectáculo los,llenó de terror; pero cuando vieron en la llanura al ejército de,Judas en orden de batalla, "
,"22":"emprendieron la fuga hacia el,territorio de los filisteos. "
,"23":"Entonces Judas regresó para,saquear el campamento; juntaron muchas monedas de oro y plata, telas de púrpura violeta y de púrpura roja y muchas otras,riquezas. "
,"24":"A su regreso, los judíos alababan y bendecían,al Cielo cantando: '¡Es bueno, eterno es su amor!' "
,"25":"Ese día,logró Israel una gran victoria."
,"26":"Los extranjeros que pudieron huir contaron a Lisias todo lo,sucedido. "
,"27":"Esa noticia lo molestó y lo desalentó, pues los,asuntos de Israel no se habían desarrollado tal como lo deseaba y,el resultado era todo lo contrario de lo que el rey le había,ordenado."
,"28":"Al año siguiente, reunió Lisias a sesenta mil de sus,mejores hombres y a cinco mil soldados de caballería, para acabar,con los judíos. "
,"29":"Llegaron a Idumea y acamparon en Bet-Sur. Judas salió a su encuentro con diez mil hombres. "
,"30":"Al ver,ese poderoso ejército, hizo esta oración: '¡Tú eres bendito, tú,que salvas a Israel! Tú hiciste fracasar el ataque del poderoso,guerrero por medio de tu servidor David, tú entregaste el,campamento de los filisteos en manos de Jonatán, hijo de Saúl, y,de su escudero; "
,"31":"¡pon pues ahora ese ejército en manos de,tu pueblo Israel! ¡Que se sientan avergonzados de sus tropas y de,su caballería! "
,"32":"Siembra el pánico en sus filas, desarma la,confianza que tienen en sus fuerzas y que su derrota los,desaliente. "
,"33":"Haz que caigan bajo la espada de los que te aman, y que los que conocen tu nombre te alaben con cánticos'."
,"34":"Se lanzaron al ataque unos contra otros y en la batalla,cayeron cinco mil hombres del ejército de Lisias. "
,"35":"Al ver la,derrota de su ejército y la valentía de los soldados de Judas, decididos a vivir o a morir valientemente, Lisias se volvió a,Antioquía, donde reclutó a extranjeros para atacar de nuevo a,Judea con un ejército aún más numeroso."
,"36":"Judas y sus hermanos dijeron: 'Aprovechemos ahora la,derrota de nuestros enemigos para purificar el Santuario y,celebrar su consagración'. "
,"37":"Se reunió entonces todo el,ejército y subió al cerro Sión. "
,"38":"Allí vieron que el Lugar,Santo estaba abandonado. El altar había sido profanado, las,puertas quemadas; en los patios crecían los arbustos como en un,bosque o en un cerro y los aposentos estaban destruidos. "
,"39":"Entonces rasgaron sus ropas e hicieron un gran duelo,echándose ceniza en la cabeza. "
,"40":"Se postraron con el rostro en,tierra y al toque de las trompetas lanzaron gritos al cielo."
,"41":"Judas designó a unos hombres para que fuesen a combatir a la,gente de la ciudadela mientras se limpiara el Santuario. "
,"42":"Luego seleccionó a sacerdotes puros y llenos de celo por la,Ley; "
,"43":"purificaron el Santuario y echaron en un lugar impuro,las piedras del altar pagano. "
,"44":"Se preguntaron qué harían con,el altar de los holocaustos que había sido profanado; "
,"45":"tuvieron la buena idea de destruirlo, porque era para ellos,motivo de humillación el hecho de que los paganos lo hubieran,manchado. "
,"46":"Lo demolieron y depositaron las piedras de ese,altar en el cerro de la Morada, en un sitio conveniente, esperando,que llegara algún profeta para que se pronunciara al respecto."
,"47":"Tomaron piedras que no habían sido talladas, tal como lo,manda la Ley, e hicieron un nuevo altar según el modelo del,anterior. "
,"48":"Repararon el santuario y el interior de la Morada, y purificaron los patios. "
,"49":"Después que hicieron nuevos,utensilios sagrados, instalaron en el Templo los candelabros, el,altar de los perfumes y la mesa para los panes. "
,"50":"Quemaron,incienso en el altar, encendieron las velas del candelabro que,brillaron en el interior del Templo. "
,"51":"Pusieron en la mesa los,panes, colocaron las cortinas y terminaron todo su trabajo."
,"52":"El veinticinco del noveno mes, llamado el mes de Quisleu, el,año ciento cuarenta y ocho, se levantaron de madrugada, "
,"53":"y,ofrecieron un sacrificio, como lo manda la Ley, en el nuevo altar,de los holocaustos que habían hecho. "
,"54":"La inauguración del,altar fue al son de cantos, de cítaras, arpas y címbalos, en el,mismo mes y día en que había sido profanado por los paganos. "
,"55":"Todo el pueblo se postró para adorar, y elevó su alabanza al,cielo que había permitido todo eso."
,"56":"Durante ocho días celebraron la consagración del altar, ofrecieron holocaustos con alegría, y también un sacrificio de,comunión y acción de gracias. "
,"57":"Decoraron la fachada del,Templo con coronas de oro y con escudos, repararon las entradas y,pusieron puertas a las piezas. "
,"58":"El pueblo estaba muy alegre; ya se había borrado la vergüenza que les habían infligido los,paganos. "
,"59":"Junto con sus hermanos y toda la asamblea de,Israel, Judas decidió que los días de la consagración fueran,celebrados anualmente la misma fecha, durante ocho días, a partir,del veinticinco del mes de Quisleu, con júbilo y fiesta."
,"60":"Por esos mismos días rodearon de murallas y de torres,fortificadas al cerro Sión, para que los paganos no vinieran a,profanar de nuevo esos lugares. "
,"61":"Judas puso allí un,destacamento para custodiarlo, y fortificó además Bet-Sur para que,el pueblo tuviera una fortaleza frente a Idumea."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Cuando las naciones vecinas supieron que el altar y,el Santuario habían sido reconstruidos tal como antes, se enojaron,mucho "
,"2":"y decidieron acabar con los descendientes de Jacob que,vivían entre ellos. Comenzaron pues los asesinatos y las,expulsiones de la gente de nuestro pueblo."
,"3":"Judas declaró la guerra a los hijos de Esaú en Idumea; avanzó,contra los habitantes del territorio de Acrabatane, que asaltaban,a los israelitas; los atacó violentamente, los derrotó y se,apoderó de sus despojos. "
,"4":"Se acordó también de la maldad de la,gente de Bayán, que eran una amenaza y un peligro para el pueblo,porque armaban emboscadas en los caminos. "
,"5":"Los obligó a,encerrarse en sus torres, los sitió y los condenó al anatema; prendió fuego a sus torres y las quemó con todos los que estaban,dentro. "
,"6":"De allí se dirigió donde los amoneos; se topó allí,con un poderoso ejército y un pueblo numeroso mandado por Timoteo. "
,"7":"Los atacó, los venció y los aplastó completamente."
,"8":"Se,apoderó luego de Yazer y de las aldeas vecinas y regresó después a,Judea."
,"9":"Los paganos de Galaad se coaligaron para acabar con los,israelitas que vivían en su territorio, y éstos se refugiaron en,la fortaleza de Datema. "
,"10":"Les mandaron cartas a Judas y a sus,hermanos, en las que les decían: 'Los paganos que nos rodean han,venido a sitiarnos para acabar con nosotros, "
,"11":"y se preparan,para tomar por asalto la fortaleza en que estamos refugiados. Quien comanda su ejército es Timoteo. "
,"12":"Ven pues a librarnos,de sus manos, porque ya muchos de nosotros han muerto. "
,"13":"Todos nuestros hermanos que eran del territorio de,Tobías han sido asesinados, sus mujeres y sus hijos han sido,llevados cautivos, y se han apoderado de sus bienes; ya han,perecido en este lugar como mil hombres'."
,"14":"Estaban todavía leyendo esas cartas, cuando llegaron unos,mensajeros de Galilea, con sus ropas hechas tiras y que traían,noticias parecidas: "
,"15":"'Tolemaida, Tiro y Sidón, decían, se,han unido contra nosotros junto con la Galilea de los paganos para,hacernos desaparecer'."
,"16":"Al saber eso, Judas y el pueblo convocaron a una gran,asamblea: ¿Qué se puede hacer por esos hermanos que están en,problemas y que tienen que luchar por su vida? "
,"17":"Judas dijo a,su hermano Simón: 'Escoge a algunos hombres y ve a salvar a los,hermanos que están en Galilea. Yo y mi hermano Jonatán iremos al,territorio de Galaad'. "
,"18":"Dejó en Judea, para que mantuvieran,la guardia, a José, hijo de Zacarías y a Azarías, jefe del,ejército, con el resto del pueblo. "
,"19":"Pero les dio esta orden: 'Ustedes quedan al frente del pueblo, pero no combatan con los,paganos hasta nuestro regreso'. "
,"20":"Le dieron tres mil hombres a,Simón para la Galilea, y ocho mil a Judas para el territorio de,Galaad."
,"21":"Simón salió para Galilea, sostuvo varias batallas con,los paganos, a los que barrió. "
,"22":"Los persiguió hasta las,puertas de Tolemaida, cayendo muertos cerca de tres mil de ellos, cuyos despojos recogió. "
,"23":"Juntó luego a los judíos de Galilea,y de Arbata con sus mujeres, hijos y cuanto poseían, y se los,llevó a Judea en medio de la alegría general."
,"24":"Mientras tanto Judas Macabeo y Jonatán, su hermano, atravesaron el Jordán y caminaron tres días por el desierto. "
,"25":"Se toparon con los nabateos que los acogieron bien y que los,pusieron al corriente de lo que les pasaba a sus hermanos en el,territorio de Galaad: "
,"26":"'Muchos de ellos, les dijeron, están,encerrados en las ciudades fortificadas de Bosora, de Bosor, cerca,de Alena, de Casfo, de Maqued y de Carnaín. "
,"27":"Otros están,siendo sitiados en las demás ciudades del territorio de Galaad y,sus enemigos han resuelto atacar mañana esas fortalezas, apoderarse de ellas y acabar, en un solo día, con todos los que se,encuentren allí'."
,"28":"Judas ordenó entonces a su ejército que se dirigiera al,desierto de Bosora; se apoderó de la ciudad, dio muerte a todos,los varones y después de haber recogido todo el botín, le prendió,fuego. "
,"29":"Se fue de noche y llegó muy cerca de la fortaleza de,Tatema. "
,"30":"Al amanecer pudieron ver que una gran multitud,instalaba escalas y máquinas de guerra para asaltar la ciudad."
,"31":"Judas vio que el ataque había ya comenzado, y se oía el,clamor que subía desde la ciudad al Cielo, como también el sonido,de las trompetas. "
,"32":"Dijo, pues, a los hombres de su ejército: '¡Combatan hoy por sus hermanos!' "
,"33":"Sus hombres atacaron al,enemigo por la espalda, dispuestos en tres grupos, se tocó la,trompeta y lanzaron el grito de guerra. "
,"34":"Cuando el ejército de,Timoteo reconoció a las tropas de Macabeo, salieron todos huyendo, pero él los derrotó de tal forma que ese día dejaron cerca de ocho,mil hombres en el campo de batalla. "
,"35":"Luego se volvió contra,Anema, la atacó, se apoderó de ella, y después de haber dado,muerte a todos los varones y de haber recogido el botín, le,prendió fuego. "
,"36":"De allí fue a apoderarse de Casfo, de Maqued, de Bosor y de las otras ciudades del territorio de Galaad."
,"37":"Después de todo eso, Timoteo volvió a organizar otro ejército,que fue a acampar frente a Rafón, al otro lado del torrente. "
,"38":"Judas mandó a algunos hombres que fueran a reconocer el,terreno, y éstos le dijeron: 'Todos los paganos que nos rodean se,han reagrupado en torno a ese jefe y conforman un ejército muy,grande. "
,"39":"Contrataron además como auxiliares a los árabes que,están acampados al otro lado del torrente y que están listos para,atacarnos'. En vista de eso, Judas partió a su encuentro. "
,"40":"Mientras Judas y su tropa se acercaban al torrente, Timoteo dijo a sus generales: 'Si él pasa primero hacia acá, no,podremos resistirle, pues nos llevará la delantera. "
,"41":"Pero si,tiene miedo y se queda al otro lado del arroyo, entonces nosotros,atravesaremos y acabaremos con él'."
,"42":"Al llegar junto al torrente, Judas dispuso a los,oficiales del pueblo a lo largo del torrente y les dio esta orden: 'No dejen que la gente instale sus carpas, sino que vayan todos a,combatir'. "
,"43":"Y él fue el primero en franquear el torrente y,marchar contra el enemigo, siendo seguido por todo el pueblo. Derrotó a todos los paganos, que tiraron sus armas y corrieron a,refugiarse en el santuario de Carnaín. "
,"44":"Los judíos se,apoderaron de la ciudad e incendiaron luego el templo con todos,los que allí estaban; Carnaín fue arrasado y en adelante nadie más,fue capaz de oponer resistencia a Judas."
,"45":"Judas juntó después a todos los israelitas que vivían en el,territorio de Galaad, desde el más pequeño hasta el más grande; las mujeres y los niños con sus pertenencias formaban una columna,inmensa que tomó el camino de Judá. "
,"46":"Llegaron a Efrón, que era,una ciudad grande y fortificada. Como quedaba en medio del camino,y no se podía desviar ni a la derecha ni a la izquierda, había que,atravesarla. "
,"47":"Sus habitantes les negaron el paso y bloquearon,las puertas con piedras. "
,"48":"Judas sin embargo les mandó un,mensaje de paz: 'Tenemos que pasar por el territorio de ustedes,para llegar hasta el nuestro, pero nadie les hará daño. Atravesaremos como simples viajeros'. Pero ellos no quisieron,abrirles las puertas."
,"49":"Judas ordenó entonces que se transmitiera esta orden entre,las filas: 'Cada cual póngase en posición de combate allí donde,esté'. "
,"50":"Todos los hombres de su tropa tomaron posiciones y,Judas emprendió el asalto de la ciudad durante todo el día y toda,la noche; al final ésta cayó. "
,"51":"Exterminó a todos los varones y,atravesó la ciudad por encima de los cadáveres. "
,"52":"Después,atravesó el Jordán entrando a la Gran Llanura frente a Bet-seán. "
,"53":"Judas, por su parte, fue reagrupando a los rezagados y,animando al pueblo durante todo el trayecto hasta su arribo al,territorio de Judá. "
,"54":"Subieron el cerro Sión en medio de,alegría y fiesta, y ofrecieron allí holocaustos, porque todos,habían vuelto sanos y salvos sin que nadie se perdiera."
,"55":"José, hijo de Zacarías, y Azarías, jefe del,ejército, se informaron de todo lo que habían hecho "
,"56":"Judas y,Jonatán en el territorio de Galaad y su hermano Simón que sitiaba,Tolemaida en Galilea, de sus actos de heroísmo y de sus combates. "
,"57":"Entonces dijeron: 'Hagámonos célebres también nosotros, vayamos a atacar a los paganos que nos rodean'. "
,"58":"Dieron pues,órdenes a las tropas que comandaban para que se dirigieran a,Jamnia. "
,"59":"Pero Gorgías y sus hombres salieron de la ciudad a su,encuentro y los atacaron. "
,"60":"José y Azarías se dieron a la,fuga; los persiguieron hasta las fronteras de Judea y ese día,perecieron alrededor de dos mil hombres del pueblo de Israel."
,"61":"Fue una gran derrota para el pueblo, y esto, por no haber,escuchado a Judas y a sus hermanos. Quisieron dárselas de,valientes, "
,"62":"pero no eran de esos hombres a los que se les,concedió salvar a Israel."
,"63":"El valeroso Judas y sus hermanos, en cambio, se hacían,merecedores de las alabanzas de todo Israel y de todas las,naciones donde se oía hablar de ellos. "
,"64":"La gente iba a verlos,para felicitarlos. "
,"65":"Judas y sus hermanos llevaron a cabo una,expedición contra los hijos de Esaú, en la región del sur; se,apoderó de Hebrón y de las aldeas circunvecinas, derribó las,fortificaciones y prendió fuego a las torres de defensa. "
,"66":"Levantó después su campamento y se dirigió al territorio de,los filisteos; atravesó Marisa. "
,"67":"Ese día, algunos sacerdotes, queriendo dárselas de valientes, atacaron de manera temeraria y,fueron muertos. "
,"68":"Judas continuó su camino hasta Azoto, en,territorio de los filisteos, destruyó sus altares, quemó los,ídolos de sus dioses, saqueó las ciudades y luego regresó al,territorio de Judá."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Mientras el rey Antíoco recorría las provincias de la,montaña, oyó hablar de la ciudad de Elimaida, en Persia, célebre,por sus riquezas, su plata y su oro. "
,"2":"El templo de esa ciudad,era muy rico, y tenía tapices de oro, corazas y armas que había,dejado allí Alejandro, hijo de Filipo, rey de Macedonia (el que,reinó primero sobre los griegos). "
,"3":"Llegó pues allá y quiso,apoderarse de esa ciudad para saquearla, pero no lo logró, porque,los habitantes de la ciudad estaban alerta. "
,"4":"Lo recibieron con,las armas en la mano y tuvo que emprender la fuga y abandonar el,lugar muy amargado, regresando a Babilonia."
,"5":"Cuando todavía estaba en Persia, recibió esta noticia: 'Los,ejércitos que invadieron el territorio de Judá fueron derrotados. "
,"6":"Lisias, que había llegado allí con un poderoso ejército, tuvo,que ceder el terreno a los judíos. Estos se han reforzado en armas,y en hombres, sin contar todo lo que han quitado a las columnas,que han derrotado. "
,"7":"Derrocaron la abominación que había,instalado el rey sobre el altar de Jerusalén, rodearon de altas,murallas igual que antes su Lugar Santo y también Bet-Sur, una de,las ciudades reales'."
,"8":"Al enterarse de esas noticias, el rey se impresionó mucho y,se sintió muy abatido, se dejó caer en su cama enfermo de pena, porque las cosas no se habían dado como lo quería. "
,"9":"Permaneció,así por muchos días, hundiéndose cada vez más en una profunda,depresión. Cuando vio que estaba a punto de morir, "
,"10":"convocó a,todos sus amigos: 'El sueño, les dijo, ha huido de mis ojos y mi,corazón está repleto de inquietud. "
,"11":"Me pregunto: ¿Hasta qué,grado de angustia he llegado? ¿Cómo he llegado a caer en una tal,depresión, yo, que era bueno y que era querido cuando era,poderoso? "
,"12":"Ahora me acuerdo de todo el mal que hice a,Jerusalén, de cuando me apoderé de todos los objetos de plata y,oro que allí había y de cuando mandé a mis hombres para que,acabaran, sin haber motivo, con todos los habitantes de Judá. "
,"13":"Reconozco que esa es la causa de las desgracias que ahora me,acosan. Miren cómo voy a morir miserablemente en una tierra,extraña'."
,"14":"Mandó llamar a Filipo, uno de sus amigos, y le encargó todo,su reino. "
,"15":"Le dio su corona, su manto y su anillo, para que,cuidara de la educación y de la manutención de su hijo Antíoco,hasta que ascendiera al trono. "
,"16":"El rey Antíoco murió en ese,lugar, el año ciento cuarenta y nueve. "
,"17":"Al enterarse de su,muerte, Lisias nombró como su sucesor a su hijo Antíoco, al que,había educado desde la infancia y al que había puesto el,sobrenombre de Eupator."
,"18":"Los defensores de la ciudadela bloqueaban a Israel alrededor,del templo; se aprovechaban de cualquier circunstancia para,provocar daño y eran un punto de apoyo para los paganos. "
,"19":"Judas decidió eliminarlos y convocó a todo el pueblo para,sitiarlos. "
,"20":"Se reunieron todos y empezaron el sitio de la,ciudadela el año ciento cincuenta; construyeron torres y máquinas,de asalto."
,"21":"Sin embargo, algunos de los sitiados lograron escapar. Se les,adhirieron israelitas impíos, "
,"22":"y juntos fueron a ver al rey. Le dijeron: '¿Hasta cuándo vas a esperar para hacernos justicia y,vengarnos de nuestros hermanos? "
,"23":"Nosotros nos declaramos a,favor de tu padre, obedecimos sus órdenes y observamos sus,decretos, "
,"24":"y por eso nos asedian la gente de nuestro pueblo y,nos ponen en entredicho. Más aún, asesinaron a los nuestros que,cayeron en sus manos y se apoderaron de nuestros bienes. "
,"25":"Pero,no sólo les ha dado con nosotros sino también con tus territorios. "
,"26":"Actualmente están sitiando la ciudadela de Jerusalén para,apoderarse de ella y fortificaron el Templo y Bet-Sur. "
,"27":"Si no,tomas la delantera, harán mucho más daño aún y ya no podrás,detenerlos'."
,"28":"El rey se enojó mucho al oír todo eso, reunió a sus amigos, a los jefes de su ejército y a los comandantes. "
,"29":"Le llegaron,además tropas mercenarias de otros reinos y de las islas del mar. "
,"30":"Su ejército contaba con cien mil soldados de infantería, veinte mil de caballería y treinta y dos elefantes entrenados para,la guerra. "
,"31":"Llegaron por Idumea y sitiaron Bet-Sur con sus,máquinas; el sitio se prolongó mucho porque los defensores,efectuaban salidas, prendían fuego a las máquinas y luchaban,valientemente."
,"32":"Judas, en vista de eso, dejó el sitio de la,ciudadela y fue a acampar en Bet-Zacarías frente al ejército del,rey. "
,"33":"Habiéndose levantado muy temprano, el rey condujo a sus,tropas muy entusiasmadas por los caminos de Bet-Zacarías, donde,tomaron posiciones para el combate."
,"34":"Tocaron la trompeta, pusieron bajo los ojos de los elefantes,jugo de uva y jugo de mora para excitarlos al ataque, "
,"35":"se,repartieron los animales entre los diversos batallones del,ejército; alrededor de cada elefante había filas de mil hombres,con corazas de hierro y cascos de bronce; acompañaban además a,cada elefante quinientos de entre los mejores hombres de a,caballo. "
,"36":"Observaban todos los movimientos del animal y lo,acompañaban a todas partes sin apartarse nunca de él. "
,"37":"En cada,elefante, servía como defensa una sólida torre de madera, que iba,sujeta con cinchas y en la que iban tres guerreros que combatían,sobre el lomo del elefante, fuera de su conductor. "
,"38":"El resto,de la caballería había sido distribuido por el rey en los dos,lados del ejército, para combatir al enemigo y proteger a los,batallones del ejército."
,"39":"Cuando el sol brilló sobre los escudos de oro y de bronce, los cerros se iluminaron y resplandecieron como antorchas,encendidas. "
,"40":"Una parte del ejército del rey se desplazó por,la cumbre de los cerros y la otra, al pie. Avanzaban en formación,regular y bien ordenada. "
,"41":"Bastaba con oír el ruido de esa,masa, el paso de esa multitud y el estruendo de las armas que,chocaban entre sí para sentirse lleno de espanto; en realidad era,un ejército grande y poderoso."
,"42":"A pesar de eso, Judas y sus hombres se lanzaron al combate y,cayeron seiscientos hombres del ejército del rey. "
,"43":"Eleazar, por sobrenombre Anaram, divisó a uno de los elefantes que llevaba,arneses reales; como era mucho más alto que los otros, pensó que,el rey iba en él. "
,"44":"Sacrificó su vida para salvar a su pueblo y,hacerse célebre para siempre. "
,"45":"Audazmente, corrió hacia el,animal, matando a diestra y siniestra, de tal modo que los,enemigos se apartaban a su paso. "
,"46":"Se deslizó debajo del,elefante, lo hirió por debajo y lo mató; la bestia se derrumbó en,tierra encima de Eleazar, quien murió allí mismo."
,"47":"Al percartarse los judíos de las fuerzas del rey y del ardor,de sus soldados, les cedieron el terreno. "
,"48":"Una parte del,ejército del rey subió a Jerusalén para atacarla y el rey declaró,el estado de sitio en Judea y el cerro Sión. "
,"49":"Al mismo,tiempo hizo la paz con la gente de Bet-Sur, quienes abandonaron la,ciudad porque no tenían alimentos para seguir resistiendo el,sitio, ya que era el año sabático en que la tierra descansaba. "
,"50":"El rey tomó posesión de Bet-Sur e instaló allí una,guarnición para defenderla. "
,"51":"Sitió el Templo durante largos,días con sus torres y sus máquinas de asalto, con sus máquinas,para lanzar fuego y rocas, y con las más pequeñas para las flechas,y las piedras. "
,"52":"Los sitiados, por su parte, instalaron también,máquinas contra las de los sitiadores y el sitio se prolongó por,mucho tiempo."
,"53":"Ya no quedaban provisiones en los almacenes porque era el,año séptimo y además porque los israelitas que habían sido,rescatados de los países paganos y traídos a Judea habían,consumido las últimas reservas. "
,"54":"Quedaban pues sólo algunos,hombres en el Lugar Santo, porque la hambruna era muy grande y,cada cual se había ido a su casa."
,"55":"Fue entonces cuando recibió Lisias noticias de Filipo, al que el rey Antíoco había elegido, aún en vida, para que educara,a su hijo Antíoco y lo preparara para reinar. "
,"56":"Había vuelto,de Persia y de Media con las tropas que habían acompañado al rey, y trataba en esos momentos de tomar en sus manos los asuntos. "
,"57":"Lisias quiso dar la señal de partida lo más pronto posible. Dijo pues al rey, a los jefes del ejército y a los soldados: 'Estamos debilitándonos, tenemos pocos víveres y la plaza que,asediamos está muy bien fortificada; mientras tanto nos esperan,los asuntos del reino. "
,"58":"Hagamos la paz con estos hombres, hagamos las paces con ellos y con todo su pueblo. "
,"59":"Permitámosles que vivan según sus costumbres como antes, pues,fue justamente a causa de esas costumbres que nosotros suprimimos,que ellos se rebelaron y llegaron hasta esto'."
,"60":"Estas palabras agradaron al rey y a los generales; el rey,mandó a unos hombres para ofrecer la paz a los judíos, quienes,aceptaron. "
,"61":"El rey y los generales se comprometieron bajo,juramento y los sitiados salieron de la fortaleza. "
,"62":"Pero,cuando el rey entró en el cerro Sión y vio la inexpugnabilidad de,esa plaza, faltó al juramento que había prestado y dio órdenes de,destruir toda la muralla. "
,"63":"Desde allí salió rápidamente rumbo,a Antioquía. Allí se encontró con que Filipo era dueño de la,ciudad, le presentó batalla y recuperó a la fuerza la ciudad."
}`)
	CurrentBook.AddChapter(7, `{
"1":"El año ciento cincuenta y uno, Demetrio, hijo de Seleuco, abandonó Roma y desembarcó con algunos hombres en un puerto, de,donde comenzó a reinar. "
,"2":"Al ver que retomaba el reino de sus,antepasados, el ejército tomó presos a Antíoco y a Lisias para,entregárselos. "
,"3":"Cuando se enteró de la cosa, declaró: 'No,quiero ver sus caras'. "
,"4":"Inmediatamente el ejército los ejecutó,y Demetrio se sentó en su trono."
,"5":"Todos los renegados de Israel, esos hombres sin fe ni ley, fueron a verlo; al frente de ellos iba Alquimes, que pretendía el,puesto de sumo sacerdote. "
,"6":"Acusaron a su pueblo ante el rey,diciendo: 'Judas y sus hermanos dieron muerte a todos tus amigos y nos,echaron de nuestro país. "
,"7":"Envía pues ahora a un hombre de,confianza, para que vea todo el daño que nos ha hecho Judas, a,nosotros y a los territorios del rey, y castigue a esa gente junto,con todos los que los ayudaron'."
,"8":"El rey eligió a Baquides, gobernador de la provincia al,oeste del Eufrates. Era uno de sus amigos, un gran personaje y,fiel al rey. "
,"9":"El rey lo mandó junto con Alquimes, ese hombre,impío al que nombró sumo sacerdote, y le ordenó que reprimiera a,los israelitas. "
,"10":"Emprendieron pues el trayecto y llegaron al,territorio de Judá con un numeroso ejército. Enviaron a Judas y a,sus hermanos mensajeros con buenos recados para engañarlos, "
,"11":"pero éstos no les creyeron, pues habían visto que llegaban,con un poderoso ejército. "
,"12":"Hubo, sin embargo, una reunión,entre los maestros de la Ley y Alquimes y Baquides, para hallar,una solución justa."
,"13":"Los asideos eran los primeros entre los israelitas en pedir,la paz, "
,"14":"pues decían: 'Ya que un sacerdote de la raza de Aarón,ha venido con este ejército, no nos hará daño'. "
,"15":"Este les,presentó palabras de paz e incluso les juró: 'No queremos hacerles,daño ni a ustedes ni a sus amigos'. "
,"16":"Le creyeron, pero mandó,arrestar a sesenta de ellos y fueron ejecutados en un solo día, según la palabra de la Escritura: "
,"17":"Han dejado en el suelo,los cuerpos de tus fieles y derramado sangre alrededor de,Jerusalén, y nadie les dio sepultura. "
,"18":"Ante eso, todo el,pueblo, presa del miedo y del pánico, decía: 'No tienen palabra ni,sentido alguno de justicia, porque violaron el acuerdo y el,juramento que habían hecho'."
,"19":"Baquides abandonó Jerusalén y fue a acampar en Bet-Zet; desde allí mandó detener a algunas personas importantes que se,habían pasado a su bando, y junto con ellas a algunos del pueblo; mandó que los degollaran y los echaran en un gran pozo. "
,"20":"Luego confió la provincia a Alquimes, dejándole tropas para,que lo apoyaran, y regresó donde el rey. "
,"21":"Alquimes trató de,imponerse como sumo sacerdote, "
,"22":"y todos los que perturbaban,al país fueron a unírsele. Se adueñaron del territorio de Judá e,hicieron mucho mal a Israel. "
,"23":"Al ver Judas que Alquimes y sus,partidarios hacían más daño a los israelitas que los mismos,paganos, "
,"24":"empezó a recorrer la Judea para vengarse de los que,se habían pasado al enemigo e impedirles que anduvieran por el,país."
,"25":"Alquimes, viendo que Judas y sus partidarios iban,reforzándose, comprendió que no podría resistirle. Volvió pues,donde el rey y los acusó de los peores crímenes. "
,"26":"El rey,mandó inmediatamente a Nicanor, uno de sus más ilustres generales,y que además sentía un gran odio y desprecio por Israel. Le ordenó,que exterminara a ese pueblo. "
,"27":"Nicanor llegó pues a Jerusalén,con un numeroso ejército. Transmitió a Judas y a sus hermanos buenas palabras: "
,"28":"'No nos,hagamos la guerra, iré a verlos con espíritu de paz junto a una,pequeña escolta'. Pero no era más que un ardid. "
,"29":"Cuando llegó,donde Judas, se saludaron pacíficamente, pero los enemigos estaban,listos para capturar a Judas. "
,"30":"Este se dio cuenta de que,Nicanor había venido con malas intenciones, desconfió de él y se,negó a recibirlo de nuevo. "
,"31":"Al ver que su plan había sido,descubierto, Nicanor avanzó para enfrentarse con Judas cerca de,Cafarsalama. "
,"32":"Nicanor perdió quinientos hombres y los demás,se refugiaron en la ciudad de David."
,"33":"Después de eso, Nicanor subió al cerro Sión; algunos,sacerdotes salieron del Lugar Santo con ancianos del pueblo para,saludarlo pacíficamente y mostrarle el holocausto que se estaba,ofreciendo por el rey. "
,"34":"Pero Nicanor se burló de ellos, los,puso en ridículo, y los despreció multiplicando los insultos. "
,"35":"En el colmo de su rabia, hizo este juramento: 'Si Judas no,cae ahora en mis manos junto con su ejército, quemaré este Templo,cuando regrese victorioso'. Y se fue muy enojado."
,"36":"Los sacerdotes, a su vez, se fueron a parar delante del,altar. Frente al Templo se pusieron a llorar: "
,"37":"'Tú,elegiste esta Casa para que lleve tu Nombre, para que sea para tu,pueblo una casa de oración y de súplica. "
,"38":"Véngate de ese,hombre y de su ejército, que perezca a espada. Acuérdate de sus,insultos y no tengas piedad de él'."
,"39":"Nicanor salió pues de Jerusalén e instaló su campamento,en Bet-Horón, en donde se le juntó el ejército de Siria. "
,"40":"Judas, por su parte, acampó en Adasa con tres mil hombres. Hizo esta oración: "
,"41":"'Cuando blasfemaron los enviados del,rey, salió tu ángel e hirió a ciento ochenta y cinco mil. "
,"42":"Aplasta de igual forma ante nosotros a ese ejército, para,que sepan todos que fueron sus insultos a tu Santuario lo que,provocó su desgracia."
,"43":"Los ejércitos comenzaron la batalla el trece del mes de Adar; el ejército de Nicanor fue aplastado y él mismo cayó en la,batalla. "
,"44":"Cuando los soldados de Nicanor vieron que había,caído, arrojaron sus armas y emprendieron la fuga. "
,"45":"Los,judíos los persiguieron todo el día, desde Adasa hasta las,inmediaciones de Gazer, y mientras los perseguían, tocaban la,trompeta con todas sus fuerzas. "
,"46":"De todas las aldeas de Judea,salía gente para cercar a los fugitivos y obligarlos a detenerse,para que se defendieran; así fue como perecieron todos a espada y,no escapó ni uno solo."
,"47":"Juntaron sus despojos y todo lo que encontraron; cortaron la,cabeza de Nicanor, más su mano derecha, y las llevaron a,Jerusalén, donde fueron expuestas. "
,"48":"El pueblo estaba alegre y,ese día se hizo una gran fiesta; "
,"49":"decidieron que ese día sería,celebrado cada año, el trece del mes de Adar. "
,"50":"Después de eso,el territorio de Judá gozó de paz durante un tiempo."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Judas oyó hablar de los romanos. 'Son poderosos, le,dijeron, comprensivos con todos los que se ponen de su parte y,ofrecen su amistad a los que se dirigen a ellos. Además, su,ejército es de los mejores'. "
,"2":"Le contaron a Judas sobre sus,guerras y sus hazañas entre los Galos, de cómo habían dominado a,ese pueblo y lo habían obligado a pagar impuestos. "
,"3":"Le,contaron también todo lo que habían hecho en España para,apoderarse de las minas de plata y oro de ese país, "
,"4":"y cómo se,habían adueñado de todo ese país, muy distante del suyo, gracias a,su inteligencia y su perseverancia. Habían aplastado además a,todos los reyes que habían venido de los extremos de la tierra a,combatirlos, les habían infligido una gran derrota, de tal forma,que los sobrevivientes tuvieron que pagarles cada año un impuesto. "
,"5":"Por último, habían triunfado por medio de las armas sobre,Filipo, sobre Perseo, rey de los griegos, y sobre los que se,habían alzado contra ellos; los habían sometido a todos. "
,"6":"Antíoco Magno, rey de Asia, había marchado en su contra con,ciento veinte elefantes, caballos, carros y un inmenso ejército, pero había sido completamente derrotado. "
,"7":"Incluso lo habían,capturado vivo, y habían gravado a él y a sus sucesores con un,pesado impuesto que debían pagar en una fecha determinada, y con,la entrega de rehenes. "
,"8":"Le habían quitado el territorio de la,India, Media, Lidia y varias de sus más hermosas provincias y se,las habían dado al rey Eumeno. "
,"9":"Como los griegos quisiesen,librarse de los romanos, "
,"10":"al saberlo éstos, habían mandado en,su contra a un solo general, quien los había derrotado, haciendo,numerosas víctimas. Los romanos habían luego llevado cautivas a,las mujeres y a los niños, se habían apoderado de sus bienes y,sometido al país, destruido sus fortalezas y reducido a la,esclavitud a mucha gente que se encontraba todavía allí. "
,"11":"Los,demás reinos e islas que habían presentado resistencia, habían,sido destruidos y sometidos por los romanos."
,"12":"'Pero, le dijeron, ellos mantienen su amistad con los que,les son fieles y confían en ellos; como han sometido a reyes,cercanos o lejanos, todos los que oyen hablar de ellos les temen. "
,"13":"Los que ellos apoyan y quieren que reinen, reinan, y cambian,a los que quieren cambiar; su poder es considerable. "
,"14":"A pesar,de eso, nadie de entre ellos se ha puesto la corona ni revestídose,del manto real para adquirir gloria. "
,"15":"Instituyeron un consejo,de trescientos veinte miembros que deliberan diariamente sobre los,asuntos públicos para que todo esté en orden. "
,"16":"Anualmente,confían a un solo hombre la autoridad y el poder sobre todo el,país; todos obedecen a ese hombre y no hay entre ellos ni envidia,ni celos'."
,"17":"Judas eligió entonces a Eupolemo, hijo de Juan, de la,familia de Accos, y a Jasón, hijo de Eleazar, y los mandó a Roma,para que hicieran con los romanos un tratado de alianza y de,amistad. "
,"18":"Con eso quería romper el yugo de los griegos, pues,veía que esta gente mantenía a Israel en la esclavitud. "
,"19":"Al,cabo de un largo viaje, llegaron a Roma, entraron en el Senado, donde hablaron así: "
,"20":"'Judas, apellidado Macabeo, sus hermanos,y el pueblo judío nos han mandado donde ustedes para firmar con,ustedes un tratado de alianza y paz. Queremos que nos consideren,entre sus aliados y amigos'. "
,"21":"Esta petición agradó a los,senadores "
,"22":"y esta es la copia de la carta que escribieron,en tablillas de bronce y que enviaron a Jerusalén para que allí la,tuvieran como un documento de paz y de alianza:"
,"23":"'¡Haya paz entre los romanos y la nación de los judíos, tanto en mar como en tierra, para siempre! ¡Aléjense de ellos la,espada y el enemigo! "
,"24":"Si llegare a haber una guerra con Roma,o con alguno de sus aliados, doquiera se extiende su poder, "
,"25":"la nación de los judíos combatirá lealmente a su lado según,lo indiquen las circunstancias. "
,"26":"No darán ni proporcionarán a,sus adversarios trigo, armas, dinero ni barcos, ateniéndose en eso,a las decisiones de Roma; serán fieles a sus compromisos sin,recibir paga alguna. "
,"27":"De igual modo, si hubiere alguna guerra,con la nación de los judíos, los romanos combatirán lealmente a su,lado, según lo indiquen las circunstancias. "
,"28":"No,proporcionarán a los enemigos ni trigo ni armas, ni dinero ni,barcos, pues así lo ha decidido Roma, y serán fieles a sus,promesas sin paga alguna. "
,"29":"Este es el acuerdo que han,concluido los romanos con el pueblo judío. "
,"30":"Si en adelante,unos u otros quieren añadir o quitar algo, lo decidirán con toda,libertad, y lo que añadan o quiten tendrá fuerza de ley. "
,"31":"Respecto a los males que el rey Demetrio ha hecho a los,judíos, le hemos escrito esto: ¿Por qué oprimes a los judíos?,¡Ellos son nuestros amigos y aliados! "
,"32":"Si llegan a acusarte,de nuevo, les haremos justicia y te combatiremos por mar y,tierra'."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Cuando supo Demetrio que Nicanor había perecido junto con,sus hombres, mandó de nuevo a Baquides y a Alquimes a la cabeza,del ala derecha del ejército rumbo al territorio de Judá. "
,"2":"Tomaron el camino de Galilea y pusieron sitio a Mesalot, en,el territorio de Arbeles; se apoderaron de ella y masacraron a,muchos de sus habitantes. "
,"3":"El primer mes del año ciento,cincuenta y dos, instalaron su campamento frente a Jerusalén, "
,"4":"y luego se dirigieron a Berea, llevando consigo veinte mil,soldados de infantería y dos mil de caballería."
,"5":"Judas, por su parte, había levantado su campamento en Eleasa y,tenía consigo a tres mil de entre los mejores soldados. "
,"6":"Cuando,vieron que los enemigos eran tan numerosos, se asustaron y muchos,huyeron del campamento; no quedaron más que ochocientos."
,"7":"Judas vio que su ejército se desintegraba en el preciso,momento en que el combate les venía encima; quedó consternado, pues ya no tenía tiempo para reunir a los fugitivos. "
,"8":"A pesar,de eso, dijo a los que se habían quedado con él: '¡De pie!,¡Ataquemos a nuestros enemigos y veamos si podemos vencerlos!' "
,"9":"Sus compañeros trataron de disuadirlo, diciéndole: ' Por ahora,lo único que podemos hacer es salvar nuestras vidas. Volveremos,luego a reemprender la lucha junto con nuestros hermanos, pues en,realidad somos muy pocos'. "
,"10":"Judas les respondió: '¡Nunca haré,eso, líbreme Dios de huir frente a ellos! Si ha llegado nuestra,hora, muramos como valientes por nuestros hermanos, pero no,hagamos algo que pueda mancillar nuestro honor'."
,"11":"El ejército salió del campamento para enfrentarlos, habiendo,dividido en dos la caballería; los honderos y los arqueros,marchaban adelante y las primeras filas estaban formadas por los,más valientes. "
,"12":"Baquides iba con el ala derecha, la infantería,avanzaba por ambos lados al son de la trompeta. Los que estaban,con Judas tocaron también la trompeta, "
,"13":"y la tierra se,estremeció con los gritos de los ejércitos. El combate comenzó en,la mañana y duró hasta la tarde. "
,"14":"Judas vio que Baquides y sus,tropas más firmes se hallaban a la derecha; junto con los más,valientes que se congregaron a su alrededor, "
,"15":"rompieron el ala,derecha de Baquides y la persiguieron hasta el cerro Azara. "
,"16":"Pero al ver que el ala derecha había flaqueado, los sirios,que formaban el ala izquierda se lanzaron tras Judas y sus,compañeros y los pillaron por atrás. "
,"17":"El combate se hizo,encarnizado y cayeron muchos en ambos bandos; "
,"18":"Judas también,cayó y el resto de sus hombres huyó. "
,"19":"Jonatán y Simón tomaron,el cuerpo de su hermano Judas y lo sepultaron en la tumba de sus,padres en Modín. "
,"20":"Todo Israel lo lloró e hicieron por él un,gran duelo, repitiendo por muchos días esta lamentación: "
,"21":"'¿Cómo es que ha caído el héroe que salvaba a Israel?'"
,"22":"El resto de las acciones de Judas, sus guerras, sus actos,de valentía y sus títulos de gloria no fueron escritos porque eran,demasiados."
,"23":"Después de la muerte de Judas, los renegados salieron de,la oscuridad en todo el territorio de Israel, y volvieron a,figurar todos los que hacían el mal. "
,"24":"Por esos días azotó al,país una gran hambruna y mucha gente se pasó al otro bando. "
,"25":"Baquides eligió entonces a hombres sin fe ni ley para,gobernar el país. "
,"26":"Sometieron a los partidarios de Judas a,pesquisas y sumarios, los hacían comparecer ante Baquides, quien,los castigaba y humillaba. "
,"27":"Israel experimentó una,opresión tan terrible como no la había tenido desde el fin del,tiempo de los profetas."
,"28":"Entonces se reunieron todos los partidarios de Judas y le,dijeron a Jonatán: "
,"29":"'Desde que murió tu hermano Judas ya no,tenemos a un hombre de su valentía para que dirija la guerra,contra nuestros enemigos, contra la gente de Baquides y de todos,aquellos que odian a nuestra nación. "
,"30":"Por eso te hemos elegido,para que lo reemplaces como nuestro jefe y general; tu dirigirás,nuestros combates'. "
,"31":"Y desde ese momento, Jonatán tomó el,mando y la sucesión de su hermano Judas."
,"32":"Al informarse de eso Baquides, trató de asesinar a Jonatán."
,"33":"Cuando lo supieron Jonatán, su hermano Simón y todos sus,compañeros, huyeron al desierto de Tecoa y acamparon cerca de la,cisterna de Asfar. "
,"34":"Baquides lo supo un día sábado, y,atravesó también el Jordán con todo su ejército."
,"35":"Jonatán mandó a su hermano, que ocupaba un puesto de mando,en el ejército, donde sus amigos nabateos; quería guardar donde,ellos su equipaje, que era considerable. "
,"36":"Pero la gente de,Medaba, los Yambritas, salieron para apoderarse de Juan y de todo,lo que tenía, y emprendieron luego la fuga con el botín. "
,"37":"Poco tiempo después, Jonatán y su hermano Simón se,informaron de que los Yambritas iban a celebrar una boda y que,traerían desde Nabata a la novia en medio de un gran cortejo; ella,era hija de uno de los grandes personajes de Canaán. "
,"38":"Se,acordaron entonces de la muerte de su hermano Juan y fueron a,esconderse en la montaña. "
,"39":"Divisaron pronto a una muchedumbre,numerosa y bullanguera que se acercaba con tamboriles, música y,ricos trajes militares; allí estaba el novio con sus amigos y sus,parientes. "
,"40":"Los judíos, de lo alto de la emboscada, se,abalanzaron sobre ellos y los masacraron; mataron a muchos y los,sobrevivientes huyeron a los cerros. Se apoderaron de todos sus,despojos. "
,"41":"Así fue como la boda se transformó en un duelo y la,alegre música en lamentaciones. "
,"42":"De ese modo se vengaron,de la sangre de su hermano y luego retornaron a las orillas,fangosas del Jordán."
,"43":"Al saberlo Baquides, avanzó un día sábado hasta las márgenes,del Jordán con un numeroso ejército. "
,"44":"Jonatán dijo entonces a,sus hombres: '¡De pie, defendámonos, pues este día no va a ser,como las otras veces! "
,"45":"El combate está frente a nosotros, y,tras nosotros está el agua del Jordán: no hay pantano o espesura,por donde batirse en retirada. "
,"46":"Clamemos pues ahora al Cielo,para que nos salve de nuestros enemigos!' "
,"47":"Cuando comenzó la,batalla, Jonatán extendió su brazo para asestarle un golpe a,Baquides, pero éste se echó para atrás. "
,"48":"Jonatán y sus,hombres se tiraron al Jordán y alcanzaron a nado la otra orilla, pero los enemigos no atravesaron el río para perseguirlos. "
,"49":"Ese día cayeron alrededor de mil hombres del bando de,Baquides."
,"50":"Baquides regresó a Jerusalén y se puso a construir,fortalezas en Judea: Jericó, Emaús, Bet-Horón, Betel, Tamnata, Faratón y Tefón. Hizo allí grandes murallas, con puertas,guarnecidas de cerrojos. "
,"51":"Dejó una guarnición en cada una,para mantener la represión en contra de Israel. "
,"52":"Fortificó,Bet-Sur, Gazer y la ciudadela, y puso allí hombres armados, con,víveres de reserva. "
,"53":"Tomó como rehenes a los hijos de los,jefes del país, y los mantuvo bajo una buena custodia en la,ciudadela de Jerusalén."
,"54":"En el décimo mes del año ciento cincuenta y tres, Alquimes,ordenó demoler el muro del patio interior del Santuario. Esto no,significaba menos que destruir la obra de los profetas. Comenzaron,a demolerlo, "
,"55":"pero Alquimes tuvo un ataque y sus planes,quedaron allí. Tenía la boca paralizada y no podía pronunciar,palabra alguna ni dar órdenes respecto a su casa. "
,"56":"Así murió,Alquimes en medio de grandes sufrimientos. "
,"57":"Al ver que,Alquimes había muerto, Baquides regresó donde el rey, de tal modo,que el territorio de Judá quedó en paz por dos años."
,"58":"Tuvieron una reunión todos los renegados, y dijeron: 'Jonatán y los suyos viven ahora en paz y seguridad. Llamemos de,nuevo a Baquides para que los detenga a todos en una sola noche'. "
,"59":"Fueron pues a verlo y lo discutieron con él."
,"60":"Baquides,emprendió, una vez más, el camino con una poderosa tropa y,despachó en secreto cartas a todos sus partidarios de Judea, para,pedirles que arrestaran a Jonatán y a sus compañeros. Pero no le,resultó, porque los otros se habían enterado de su plan. "
,"61":"Jonatán y sus compañeros tomaron presos en el país a unos,cincuenta hombres que eran los causantes de ese plan criminal y,los ejecutaron."
,"62":"Después de eso, Jonatán y Simón se retiraron, junto con sus,partidarios, al desierto de Bet-Basi. Repararon esa ciudad en,ruina y la fortificaron. "
,"63":"Cuando Baquides lo supo, reunió a,todos sus hombres y convocó a sus partidarios de Judea. "
,"64":"Instaló su campamento cerca de Bet-Basi y durante largos días,mandó que se construyeran máquinas para el ataque. "
,"65":"Jonatán, dejando a su hermano Simón en la ciudad, recorrió los alrededores,con un destacamento. "
,"66":"Atacó el campamento de Odomera y de sus,hermanos, y el de la gente de Fasirón. Los enemigos también se,decidieron a atacar y subieron con sus tropas. "
,"67":"Simón y sus,hombres, por su parte, efectuaron una salida y quemaron las,máquinas sitiadoras. "
,"68":"Después atacaron a Baquides y le,infligieron una tal derrota que cayó éste en un profundo,abatimiento, porque su proyecto y su ataque habían fracasado. "
,"69":"Se enfureció entonces con los renegados que le habían,aconsejado que viniera al país; dio muerte a un gran número de,ellos y decidió volverse a casa con los suyos."
,"70":"Al enterarse de eso, Jonatán le envió a algunos hombres para,proponerle la paz y el canje de prisioneros. "
,"71":"Baquides aceptó,y cumplió sus promesas. Y juró a Jonatán que hasta el día de su,muerte no le perjudicaría en nada. "
,"72":"Baquides liberó a los,prisioneros que había tomado antes en el territorio de Judá, luego,regresó a su casa para nunca más volver al país de los judíos. "
,"73":"Hubo un tiempo de paz en Israel, y Jonatán se estableció en,Micmas, de donde juzgaba al pueblo; hizo que desaparecieran los,impíos de en medio de Israel."
}`)
	CurrentBook.AddChapter(10, `{
"1":"El año ciento sesenta, Alejandro, hijo de Antíoco Epífanes, organizó una expedición y ocupó Tolemaida. Fue bien recibido, comenzando allí su reinado. "
,"2":"En cuanto supo la noticia, el rey,Demetrio reunió un ejército muy poderoso y marchó, en son de,guerra, contra aquél. "
,"3":"Demetrio envió a Jonatán cartas,amistosas en las que le prometía colmarlo de honores. "
,"4":"Pues,decía: 'Hagamos pronto la paz con esos hombres, antes que la hagan,con Alejandro en contra nuestra, "
,"5":"pues seguramente Jonatán no,se habrá olvidado de todo el mal que les hicimos, tanto a sus,hermanos como a su nación'. "
,"6":"Le dio, pues, permiso para que,formara un ejército, fabricara armas y se presentara como su,aliado, además ordenó que le entregaran los rehenes retenidos en,la ciudadela."
,"7":"Jonatán llegó pues a Jerusalén y leyó el mensaje ante todo el,pueblo y ante los hombres de la ciudadela. "
,"8":"Cuando éstos,oyeron que el rey lo autorizaba a reclutar tropas, la gente de la,ciudadela se llenó de temor. "
,"9":"Entregaron los rehenes a,Jonatán, quien se los pasó a sus padres. "
,"10":"Jonatán se,estableció en Jerusalén y comenzó a reconstruir y a reparar la,ciudad. "
,"11":"En especial dio órdenes a los encargados de los,trabajos de reconstruir la muralla y el contorno del cerro Sión,con piedras talladas, para que fuera así una defensa; lo que se,hizo. "
,"12":"Los extranjeros que ocupaban las fortalezas,construidas por Baquides emprendieron la fuga; "
,"13":"abandonaron,sus puestos y retornaron a su país. "
,"14":"En Bet-Sur, sin embargo, quedaron algunos hombres que habían desertado de la Ley y de los,preceptos, pues este era un lugar de refugio."
,"15":"El rey Alejandro supo de las promesas que Demetrio había,hecho a Jonatán; le contaron sobre las guerras y las hazañas en,las que se habían distinguido tanto aquel como sus hermanos, como,asimismo las pruebas que habían tenido que sufrir. "
,"16":"Entonces,el rey exclamó: '¿Dónde hallaremos un hombre como él? Hagámoslo,nuestro amigo y nuestro aliado'. "
,"17":"Le escribió pues una carta,redactada en estos términos: "
,"18":"'El rey Alejandro saluda a su,hermano Jonatán. "
,"19":"Como nos han hecho saber que eres un hombre,muy valiente, mereces ser nuestro amigo. "
,"20":"Por eso te hacemos,ahora el sumo sacerdote de tu nación y te otorgamos el título de,Amigo del rey (al mismo tiempo le mandó un manto de púrpura y una,corona de oro), así tú serás uno de los nuestros y nos mantendrás,tu amistad'."
,"21":"Así fue como, en el séptimo mes del año ciento sesenta, para,la fiesta de las Tiendas, Jonatán se revistió de los ornamentos,sagrados; reclutó tropas y fabricó muchas armas. "
,"22":"Demetrio,quedó muy contrariado con eso. "
,"23":"'¿Qué hemos hecho? decía. Alejandro ha sido más rápido que nosotros para ganarse la amistad,de los judíos y reforzar su posición. "
,"24":"Pues bien, yo también,les voy a escribir para persuadirlos, ofreciéndoles honores y,beneficios, para que así vengan a ayudarme'."
,"25":"Les escribió pues esto: 'El rey Demetrio saluda a la nación,de los judíos. "
,"26":"Ustedes han respetado los acuerdos anteriores,entre nosotros y ustedes; nos han mantenido su amistad en vez de,pasarse al lado de nuestros enemigos, lo que al saberlo nos dejó,muy felices. "
,"27":"Permanezcan pues fieles y sabremos,recompensarles lo que hacen por nosotros. "
,"28":"Los liberaremos de,muchas obligaciones y les haremos muchos favores. "
,"29":"Desde ya,dispenso a todos los judíos y los libero de los impuestos, de las,contribuciones a la sal y de la tasa real. "
,"30":"Desde ahora y,para siempre dejo de percibir el tercio de los productos de la,tierra y la mitad de las frutas de los árboles que hasta aquí me,correspondían, tanto en el territorio de Judá como en los tres,distritos de la Samaría-Galilea que están anexos. "
,"31":"Jerusalén,será una ciudad santa, dispensada de diezmos y de gabelas, como,también sus alrededores. "
,"32":"Renuncio a la posesión de la,ciudadela de Jerusalén y se la doy al sumo sacerdote, quien,elegirá personalmente a los hombres encargados de custodiarla. "
,"33":"Otorgo la libertad, sin necesidad de rescate, a cualquier,persona de origen judío que haya sido llevada fuera del país de,Judá y que esté cautiva en cualquier parte dentro de mi reino. Todos quedarán exentos de impuestos, incluso de aquel al ganado. "
,"34":"Quiero que todas las fiestas, los sábados, las lunas nuevas, los días determinados por la Ley y los tres días que los preceden,y que siguen, sean días en los que se perdonen las deudas y los,derechos de consumo a todos los judíos de mi reino. "
,"35":"Durante,esos días nadie podrá exigir un pago o inquietar a un judío por,cualquier negocio. "
,"36":"Los ejércitos reales reclutarán de entre,los judíos hasta treinta mil soldados, los que recibirán el mismo,sueldo que las demás tropas del rey. "
,"37":"Se los ubicará en las,más importantes fortalezas reales y en los cargos de confianza de,mi reino. Sus supervisores y sus jefes saldrán de sus filas y,vivirán según su Ley, tal como el rey lo ha ordenado para todo el,país de Judá. "
,"38":"Los tres distritos que han pasado a depender,de Judea, a expensas de la provincia de Samaría, serán anexados a,Judea; se los considerara como dependientes de un solo hombre, obedeciendo únicamente al sumo sacerdote. "
,"39":"Doy la ciudad,de Tolemaida y el territorio dependiente al Templo de Jerusalén,para asegurar así los gastos necesarios para el culto. "
,"40":"Daré,personalmente, cada año, quince mil monedas de plata, que se,deducirán de la parte que le corresponde al rey en los lugares que,se designarán. "
,"41":"En adelante los funcionarios entregarán, para,los trabajos del Templo, todo el excedente de los impuestos que no,haya sido gastado, como en los años anteriores. "
,"42":"Se,descontaban cada año, de los ingresos y rentas del Templo, cinco,mil monedas de plata; en adelante esta cantidad se destinará para,beneficio de los sacerdotes que ejecutan el servicio litúrgico. "
,"43":"Si alguien es perseguido por deuda al tesoro real o por,cualquier otra deuda, y se refugia en Jerusalén o en sus,inmediaciones, quedará libre de pago, al igual que todos los,bienes que posea en mi reino. "
,"44":"Los gastos necesarios para,los trabajos de construcción o de restauración del Templo, serán,cargados a la cuenta del rey. "
,"45":"También se cargará a la cuenta,del rey el dinero necesario para reconstruir los muros de,Jerusalén, fortificar su entorno y reparar las murallas de las,ciudades de Judea'."
,"46":"Cuando Jonatán y el pueblo oyeron esas palabras, no las,creyeron y se negaron a confiar en ellas, pues recordaban muy bien,el mal que Demetrio había hecho a Israel y cómo los había,oprimido. "
,"47":"Optaron pues por el partido de Alejandro, que,veían más ventajoso para ellos, y fueron sus fieles aliados. "
,"48":"El rey Alejandro organizó por entonces un gran ejército y,avanzó contra Demetrio; "
,"49":"los dos reyes se trenzaron en,combate y el ejército de Demetrio dio vuelta la espalda. Alejandro,lo persiguió y logró imponerse. "
,"50":"Luchó enérgicamente hasta la,puesta del sol y Demetrio fue muerto ese mismo día."
,"51":"Entonces Alejandro mandó unos embajadores donde el rey de,Egipto, Tolomeo, para decirle: "
,"52":"' He vuelto a mi reino y me,he sentado en el trono de mis padres. Me he apoderado del poder, aplasté a Demetrio y tomé posesión de mi país. "
,"53":"Pues sostuve,una batalla con él, siendo aplastado por nosotros él y su,ejército. Ahora que he subido a mi trono real, "
,"54":"hagamos un,tratado de amistad entre ambos. Dame a tu hija por esposa, yo seré,tu yerno y les haré a ti y a ella regalos dignos de ti'. "
,"55":"El,rey Tolomeo le respondió así: '¡Sea bendito el día en que,regresaste al país de tus padres y en que ocupaste el trono real'. "
,"56":"Haré por ti lo que me pides, pero ven a mi encuentro en,Tolemaida para que nos veamos el uno al otro, y luego seré tu,suegro, como tú lo dices'."
,"57":"Tolomeo salió de Egipto con su hija Cleopatra y llegó a,Tolemaida el año ciento sesenta y dos. "
,"58":"El rey Alejandro fue,a encontrarse con Tolomeo quien le dio a su hija Cleopatra, y se,celebró en Tolemaida el matrimonio con mucha solemnidad, tal como,convenía a reyes."
,"59":"El rey Alejandro escribió a Jonatán que fuera a,visitarlo; "
,"60":"en vista de eso, Jonatán se dirigió a Tolemaida,con un gran cortejo. Se encontró allí con los dos reyes; les dio, tanto a ellos como a sus amigos, plata y oro; distribuyó muchos,regalos y conquistó su favor. "
,"61":"Algunos renegados, la peste de,Israel, se habían juntado y se presentaron para quejarse de él, pero el rey no les prestó ninguna atención. "
,"62":"Ordenó más bien,que Jonatán dejara la ropa que llevaba para vestirlo de púrpura, lo que así se hizo. "
,"63":"Luego el rey lo hizo sentarse cerca de,él y dijo a sus secretarios: 'Vayan con él a la ciudad y proclamen,esto: Nadie venga a quejarse de él por cualquier asunto y nadie,trate de molestarlo por cualquier motivo'. "
,"64":"Cuando sus,acusadores vieron los honores que se le habían hecho, y cuando,oyeron la proclamación que se hacía, salieron todos huyendo. "
,"65":"El rey le concedió el honor de contarlo entre sus primeros,Amigos y lo nombró jefe supremo y gobernador, "
,"66":"después de lo,cual Jonatán regresó muy feliz a Jerusalén, sano y salvo."
,"67":"El año ciento sesenta y cinco, Demetrio, hijo de Demetrio, llegó al país de sus padres, procedente de Creta. "
,"68":"Cuando el,rey Alejandro lo supo, quedó muy desconcertado y regresó a,Antioquía. "
,"69":"Demetrio confirmó a Apolonio en el cargo de,gobernador de Elesiria. Este reunió un poderoso ejército y,estableció su campamento cerca de Jamnia. Luego mandó decir al,sumo sacerdote Jonatán: "
,"70":"'¿Serás tú el único en tomar partido,en contra de nosotros? ¿No ves que se burlan de mí y que me,insultan por culpa tuya? ¿Por qué quieres sustraerte a nuestra,autoridad en tus montañas? "
,"71":"Si tanta confianza tienes en tu,ejército, baja a la llanura donde nosotros, y allí nos mediremos, porque conmigo está el ejército de las ciudades. "
,"72":"Infórmate y,sabrás quién soy yo y quiénes son los que están conmigo; me han,dicho que ustedes no podrán oponernos resistencia, pues tus padres,salieron huyendo dos veces en su propio país. "
,"73":"Ahora tú no,podrás hacer frente a mi caballería y a un ejército tan poderoso, en esta llanura donde no hay rocas ni piedras ni senderos para,refugiarse'."
,"74":"Cuando Jonatán oyó las palabras de Apolonio se impactó,mucho. Reclutó a diez mil hombres y salió de Jerusalén; su hermano,Simón fue a reunírsele y a ayudarlo. "
,"75":"Instaló su campamento,frente a Jope; la gente de la ciudad le cerraron las puertas, porque había en Jope una guarnición de Apolonio. Atacaron la,ciudad; "
,"76":"presas del pánico, los habitantes de Jope abrieron,las puertas, y Jonatán se adueñó de la ciudad. "
,"77":"Cuando,Apolonio lo supo, equipó tres mil soldados de caballería y una,numerosa infantería y tomó la dirección de Azoto, como si quisiese,atravesar el país. Se adentró así en la llanura, confiando en la,importancia de su caballería. "
,"78":"Jonatán lo persiguió en,dirección a Azoto y los dos ejércitos entraron en batalla."
,"79":"Apolonio había dejado escondidos tras él a mil soldados de,caballería, "
,"80":"pero Jonatán se enteró de esa emboscada a sus,espaldas. La caballería rodeó a su ejército y le dispararon,flechas desde la mañana hasta la tarde. "
,"81":"El ejército,resistió, tal como Jonatán se lo había ordenado, mientras se,cansaban los caballos del enemigo. "
,"82":"Cuando la caballería,estuvo agotada, Simón con sus tropas atacó los batallones. Los,enemigos fueron derrotados y huyeron, "
,"83":"mientras que la,caballería se dispersaba por la llanura. Los fugitivos llegaron a,Azoto y entraron en Bet-Dagón, el templo de su ídolo, buscando,allí refugio. "
,"84":"Pero Jonatán incendió Azoto y las ciudades,vecinas; juntó todo en el terreno y quemó el templo de Dagón con,todos los que se habían refugiado allí. "
,"85":"El número de los que,habían muerto a espada o habían sido quemados llegaba a ocho mil."
,"86":"Jonatán se fue de allí e instaló su campamento cerca de,Ascalón, los habitantes de esa ciudad salieron a su encuentro y lo,recibieron con muchos miramientos. "
,"87":"Después regresó Jonatán a,Jerusalén con sus compañeros llevando un inmenso botín. "
,"88":"Cuando el rey Alejandro se enteró de eso, le otorgó a,Jonatán muchos honores. "
,"89":"Le envió un broche de oro, como se,acostumbra hacer con los parientes de los reyes, y le dio en,propiedad Acarón con todos sus alrededores."
}`)
	CurrentBook.AddChapter(11, `{
"1":"El rey de Egipto reunió un ejército tan numeroso como la,arena que está a orilla del mar; juntó también muchos barcos, porque quería apoderarse del reino de Alejandro por la astucia, para así agregarlo a su propio reino. "
,"2":"Emprendió el camino a,Siria con muy buenos pretextos; la gente le abría las puertas de,sus ciudades y salían a recibirlo, porque el rey Alejandro había,dado la orden de que acogieran bien a su suegro. "
,"3":"Pero en,cuanto entraba a las ciudades, Tolomeo instalaba allí a sus,propios soldados. "
,"4":"Cuando se aproximaba a Azoto, le mostraron,el templo de Dagón que había sido incendiado. Azoto y sus,alrededores habían sido devastados, los cadáveres yacían por el,suelo, como también los restos de los que había quemado Jonatán,durante la guerra; los habían amontonado a lo largo del camino que,seguía el rey. "
,"5":"Contaron al rey lo que había hecho Jonatán,para que lo condenara, pero el rey se quedó callado. "
,"6":"Jonatán,fue pues al encuentro del rey en Jope con un hermoso cortejo; intercambiaron saludos y pernoctaron en ese lugar. "
,"7":"Jonatán,acompañó al rey hasta el río llamado Eleuterio y luego regresó a,Jerusalén."
,"8":"El rey Tolomeo, por su parte, se adueñó de las ciudades de la,costa hasta Seleucia marítima, con malas intenciones respecto a,Alejandro. "
,"9":"Envió embajadores donde el rey Demetrio, para que,le dijeran: 'Ven, hagamos una alianza, te daré a mi hija, que di,antes a Alejandro, y tú reinarás en el reino de tu padre. "
,"10":"Estoy arrepentido de haberle dado a mi hija, porque quiso,asesinarme'. "
,"11":"Le hacía esas imputaciones, pero en realidad,sólo quería apoderarse de su reino. "
,"12":"Apenas recuperó a su,hija, la dio a Demetrio y cambió de actitud con Alejandro, manifestándose públicamente su enemistad. "
,"13":"Tolomeo entró en,Antioquía y se coronó rey de Asia: pasaba a ser dueño de ambos,reinos, Egipto y Asia."
,"14":"El rey Alejandro estaba por ese entonces en Cilicia, porque,la gente de esa región se había rebelado. "
,"15":"Al enterarse de,todo, Alejandro vino a presentar batalla a Tolomeo; Tolomeo salió,a enfrentársele con un poderoso ejército que lo puso en fuga. "
,"16":"Alejandro corrió a refugiarse en Arabia, mientras el rey,Tolomeo salía triunfante. "
,"17":"Ante eso, el árabe Zabdiel le,cortó la cabeza a Alejandro y se la envió a Tolomeo."
,"18":"Tres días después murió también el rey Tolomeo, y los,egipcios que ocupaban las ciudades fortificadas fueron masacrados,por sus habitantes. "
,"19":"De esta manera Demetrio obtuvo el,reinado el año ciento sesenta y siete. "
,"20":"Por esos días Jonatán,reunió a la gente de Judea para atacar la ciudadela de Jerusalén, dispuso contra ella numerosas máquinas de guerra. "
,"21":"Entonces,un pequeño número de renegados, que odiaban a su nación, fueron a,ver al rey para avisarle que Jonatán sitiaba la ciudadela. "
,"22":"Al saberlo el rey, montó en cólera. Inmediatamente se puso,en camino y llegó a Tolemaida. Desde allí escribió a Jonatán que,levantara el sitio y que fuera inmediatamente a verlo a Tolemaida,para conversar con él."
,"23":"Después de haber recibido la carta, Jonatán ordenó continuar,con el sitio. Luego eligió a algunos compañeros, a ancianos de,Israel y a sacerdotes, y no tuvo miedo de afrontar personalmente,el peligro. "
,"24":"Llevando consigo plata, oro, trajes y muchos,otros regalos, se presentó ante el rey en Tolemaida y se ganó su,favor. "
,"25":"Algunos renegados de su pueblo lo acusaron de toda,clase de cosas, "
,"26":"pero el rey se portó con él igual que sus,predecesores y lo honró en presencia de todos sus Amigos. "
,"27":"Lo,confirmó en el cargo de sumo sacerdote, en todas las demás,distinciones que había recibido y lo agregó al número de los,primeros amigos del rey. "
,"28":"Jonatán pidió al rey que,dispensara de los impuestos a Judea y a los tres distritos de,Samaría; le prometió en cambio trescientos talentos de plata. "
,"29":"El rey lo aceptó y mandó redactar una carta en estos,términos:"
,"30":"'El rey Demetrio saluda a su hermano Jonatán y a la nación,de los judíos. "
,"31":"Aquí encontrarán copia de la carta que,acabamos de escribir a nuestro pariente Lástenes respecto de,ustedes. Conózcanla pues: "
,"32":"'¡El rey Demetrio saluda a,Lástenes, su padre! "
,"33":"Queremos hacerle el bien a la nación de,los judíos en vista de sus buenos sentimientos hacia nosotros. Son,amigos nuestros y se han comportado correctamente con nosotros. "
,"34":"Confirmamos su autoridad sobre la Judea y los tres distritos,de Aferena, Lidia y Ramataim; han sido quitados a Samaría y,anexados a Judea con todos sus alrededores para beneficiar a todos,los que sacrifican en Jerusalén. En cambio recibiremos las tasas,reales que recibía antes anualmente el rey sobre los productos de,la tierra y las frutas de los árboles "
,"35":"Pero los eximimos,totalmente de los diezmos y de los impuestos que percibíamos por,las lagunas salinas, así como también de las otra tasas reales. "
,"36":"No se cuestionarán nunca más estos privilegios."
,"37":"Haz, por favor, una copia que entregarás a Jonatán, para que sea puesta,en el Cerro Santo, en un lugar bien visible'."
,"38":"Viendo el rey Demetrio que el país estaba en paz y que no,tenía que temer ninguna oposición, disolvió todas sus tropas y,cada cual se fue a su casa, con excepción de las tropas,extranjeras que había reclutado en las islas. Se atrajo así el,odio de todas las tropas que había heredado. "
,"39":"Al ver que todo,el ejército murmuraba en contra de Demetrio, Trifón, que había,pertenecido antes al partido de Alejandro, fue a ver al árabe,Imalcué que educaba a Antíoco, el joven hijo de Alejandro. "
,"40":"Lo convenció de que le entregara al niño para hacerlo reinar,en lugar de su padre; le contó todo lo que Demetrio había hecho y,el odio de sus tropas contra él, y permaneció allí largos días."
,"41":"Por ese mismo tiempo Jonatán pidió al rey Demetrio que,retirara las tropas de la ciudadela de Jerusalén y de las demás,fortalezas, porque estaban siempre en guerra con Israel. "
,"42":"Demetrio le mandó esta respuesta: 'No sólo haré eso por ti y,por tu nación, sino que te colmaré de honores, como también a tu,nación, en cuanto tenga la oportunidad. "
,"43":"Pero por ahora harías,muy bien mandándome tropas, porque todos mis ejércitos me,abandonaron'."
,"44":"Jonatán le envió a Antioquía tres mil de los mejores hombres,y el rey quedó muy feliz al verlos llegar. "
,"45":"Cerca de veinte,mil habitantes se reunieron en el centro de la ciudad con la,intención de dar muerte al rey. "
,"46":"Demetrio se refugió en el,palacio mientras los habitantes ocupaban las calles de la ciudad y,empezaban el ataque. "
,"47":"Entonces el rey llamó a los judíos en,su ayuda. Se agruparon estos alrededor de él y luego se,dispersaron por la ciudad; mataron ese día cerca de cien mil,hombres. "
,"48":"Incendiaron la ciudad y juntaron ese día un,considerable botín; salvaron al rey. "
,"49":"Cuando los habitantes,de la ciudad vieron que los judíos eran dueños de la ciudad, depusieron su entereza y volvieron donde el rey con gritos,suplicantes: "
,"50":"'¡Tiéndenos la mano y que los judíos dejen de,maltratarnos a nosotros y a la ciudad!'"
,"51":"Depusieron las armas e hicieron la paz; para los judíos fue,un motivo de gran gloria, tanto a los ojos del rey como de los,habitantes de su reino. Regresaron luego a Jerusalén llevando un,rico botín; "
,"52":"el trono de Demetrio se mantuvo firme y el país,quedó en paz bajo su autoridad. "
,"53":"Pero luego faltó a todas sus,promesas. Cambió de actitud con respecto a Jonatán; se olvidó de,los servicios que le había prestado y lo humilló de mil maneras."
,"54":"Trifón regresó por ese entonces, trayendo consigo a Antíoco,que todavía era un niño; lo proclamó rey y le puso la corona. "
,"55":"Se le juntaron todas esas tropas que habían sido licenciadas,por Demetrio, y combatieron a éste, quien salió huyendo y fue,derrotado. "
,"56":"Trifón se apoderó de los elefantes y ocupó,Antioquía. "
,"57":"Entonces el joven Antíoco escribió esta carta a,Jonatán: 'Te confirmo en el cargo de sumo sacerdote; te pongo al,frente de las cuatro provincias y te cuento entre los Amigos del,rey'. "
,"58":"Al mismo tiempo le mandó unos vasos de oro, un servicio,de mesa con la autorización de beber en una copa de oro, vestirse,de púrpura y llevar un broche de oro. "
,"59":"A su hermano Simón, por otra parte, lo designó general desde la Escala de Tiro hasta,las fronteras con Egipto."
,"60":"En vista de eso salió Jonatán y se puso a reconocer el,territorio y las ciudades que estaban más al oeste del Río. Todas,las tropas de Siria se pusieron a su lado para luchar detrás de,él. Llegó a Ascalón, donde los habitantes lo recibieron,magníficamente. "
,"61":"Desde allí se dirigió a Gaza, pero Gaza le,cerró las puertas; la sitió y condenó al fuego y al pillaje sus,alrededores. "
,"62":"Como los habitantes de Gaza le pidieran la paz, se la concedió, pero tomó como rehenes a los hijos de sus jefes y,los mandó a Jerusalén. Así fue como recorrió toda la región hasta,Damasco."
,"63":"Supo Jonatán que los generales de Demetrio estaban en Cadés,de Galilea con un numeroso ejército, decididos a quitarle su,cargo. "
,"64":"Marchó pues a su encuentro, después de haber dejado,el país a cargo de su hermano Simón. "
,"65":"Simón avanzó hasta Bet-,Sur, le puso sitio y dejó encerrados a sus habitantes. "
,"66":"Le,solicitaron entonces la paz, la que les concedió, pero los hizo,salir de la ciudad, y después de haber tomado posesión de ella, dejó allí una guarnición. "
,"67":"Jonatán y su ejército acamparon,cerca de las aguas de Genesaret y a la mañana siguiente llegaron a,la llanura de Azor. "
,"68":"El ejército de los extranjeros marchaba,delante de él en la llanura, pero habían mandado unas tropas a los,cerros para tomar a Jonatán por la espalda; los otros mientras,tanto se dirigían de frente contra los judíos."
,"69":"Cuando los hombres de la emboscada salieron de su escondite y,emprendieron el ataque, "
,"70":"todos los que rodeaban a Jonatán,salieron huyendo, menos sus dos generales, Matatías, hijo de,Absalón y Judas, hijo de Calfi. "
,"71":"Entonces Jonatán rasgó sus,ropas, se echó polvo en la cabeza y oró. "
,"72":"Luego se lanzó al,combate, los hizo retroceder y huir. "
,"73":"Al ver eso, sus hombres,que habían huido volvieron donde él, y juntos persiguieron al,enemigo hasta Cadés, donde estaba el campamento de éste; establecieron su campamento allí mismo. "
,"74":"El ejército de los,extranjeros perdió ese día tres mil hombres; Jonatán, por su,parte, regresó a Jerusalén."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Cuando Jonatán vio que las cosas se daban favorables para él, escogió unos hombres, a los que mandó a Roma para confirmar y,renovar la amistad con los romanos. "
,"2":"Despachó cartas parecidas,a Esparta y a otras ciudades. "
,"3":"Sus enviados llegaron a Roma, entraron en el Senado y dijeron: 'El sumo sacerdote Jonatán y la,nación de los judíos nos han mandado para que se renueve la,amistad y la alianza que ustedes habían acordado anteriormente con,ellos'. "
,"4":"El senado les entregó cartas de recomendación para,que en cada país los encaminaran en paz hasta el territorio de,Judá."
,"5":"Esta es la copia de la carta que Jonatán escribió a la gente,de Esparta:"
,"6":"'El sumo sacerdote Jonatán, el senado de la nación, los,sacerdotes y todo el pueblo judío saludan a los habitantes de,Esparta, sus hermanos. "
,"7":"Ya en tiempos pasados le llegó al,sumo sacerdote Onías una carta de parte de Arios, rey de ustedes; en ella se sostenía que ustedes son hermanos nuestros, como lo,demuestra la copia adjunta. "
,"8":"Onías acogió con honores al,hombre que habían enviado, y recibió la carta en la que se hablaba,claramente de alianza y de amistad. "
,"9":"No pretendemos con esto,pedirles ahora que nos ayuden, pues los libros santos que están en,nuestras manos son nuestro consuelo. "
,"10":"Pero no quisiéramos ser,unos extraños para ustedes, por eso hemos querido reafirmar,nuestra fraternidad y nuestra amistad, porque han pasado ya muchos,años desde que les enviamos una carta. "
,"11":"No dejamos de pensar,en ustedes en cualquier oportunidad, en nuestras fiestas y en,nuestros días santos, en los sacrificios que ofrecemos y en,nuestras oraciones, tal como es justo y conveniente hacerlo por,los hermanos. "
,"12":"¡Nos sentimos felices por el éxito de ustedes!"
,"13":"En cuanto a nosotros hemos estado colmados de pruebas y de,guerras continuas, porque los reyes que nos rodean nos han,atacado. "
,"14":"Con ocasión de esas guerras, no hemos querido ser,una carga ni para ustedes ni para nuestros aliados y amigos, "
,"15":"y como nos ha venido a ayudar el auxilio del Cielo, nos hemos,liberado y nuestros enemigos han sido humillados. "
,"16":"Por eso,elegimos a Numenios, hijo de Antíoco y a Antípater, hijo de Jasón, los mismos que enviamos donde los romanos para renovar con ellos,la amistad y la alianza de otrora. "
,"17":"Les encargamos que fueran,donde ustedes para saludarlos y llevarles esta carta que reafirma,nuestra fraternidad. "
,"18":"Tengan ahora la bondad de respondernos'."
,"19":"Esta es la copia de la carta que había sido enviada a Onías:"
,"20":"'¡Arios, rey de los espartanos, saluda al sumo sacerdote,Onías! "
,"21":"Se ha descubierto en un escrito que los espartanos y,los judíos son hermanos, pues son de la raza de Abrahán. "
,"22":"Ahora que sabemos eso, sería bueno que nos escribieran para,que nos digan si les va bien en todo. "
,"23":"Por nuestra parte, nosotros les decimos que sus ganados y sus bienes son nuestros y,los nuestros son de ustedes. Hemos dado las instrucciones,respectivas para que se lo hagan saber'."
,"24":"Jonatán se enteró que los generales de Demetrio habían,vuelto para atacarlo con un ejército más poderoso que antes. "
,"25":"Salió pues de Jerusalén y se dirigió a su encuentro en el,territorio de Hamat, no dándole así tiempo para invadir su país. "
,"26":"Mandó espías al campamento de ellos y a su regreso le,informaron que los sirios hacían preparativos para sorprenderlo,durante la noche. "
,"27":"Por eso, cuando se puso el sol, Jonatán,ordenó a sus hombres que estuvieran en vela y con las armas en la,mano toda la noche, listos para combatir, y dispuso centinelas,avanzados alrededor del campamento. "
,"28":"Cuando los enemigos,supieron que Jonatán y los suyos estaban listos para el combate, se llenaron de miedo y pavor; encendieron fogatas en su campamento,y se dieron a la fuga. "
,"29":"Como veían fogatas, Jonatán y sus,hombres no se percataron hasta la mañana siguiente de la partida,de aquellos."
,"30":"Jonatán los persiguió pero no logró alcanzarlos porque,habían atravesado el río Eleuterio. "
,"31":"Jonatán se volvió,entonces contra los árabes llamados zabadeos, los derrotó y se,apoderó de sus bienes, "
,"32":"luego levantó su campamento, llegó a,Damasco y recorrió toda la provincia. "
,"33":"Simón por su parte,había salido y había avanzado hasta Ascalón y las fortalezas,vecinas; luego regresó hasta Jope y la ocupó, "
,"34":"pues se había,informado que los habitantes de esa fortaleza tenían la intención,de entregársela a Demetrio; dejó allí una guarnición para,custodiar la ciudad."
,"35":"De regreso en Jerusalén, Jonatán convocó a los ancianos del,pueblo y decidió con ellos construir fortalezas en Judea, "
,"36":"elevar las murallas de Jerusalén y construir un muro,elevado entre la ciudadela y la ciudad para aislarla de ésta y,para que sus habitantes, así aislados, no pudiesen más comprar ni,vender. "
,"37":"Se juntaron para reconstruir la ciudad, porque una,parte de la muralla que da hacia la quebrada que está al este se,había caído. Renovaron también el barrrio llamado Cafenata. "
,"38":"Simón por su parte reconstruyó Adida en la planicie costera, la fortificó y le puso puertas guarnecidas de cerrojos."
,"39":"Trifón quería reinar en Asia, coronarse como rey y apresar,al rey Antíoco, "
,"40":"pero tenía miedo de que Jonatán se lo,impidiese y le declarase la guerra. Por eso Trifón buscaba la,manera de apoderarse de él y de darle muerte; se puso en camino y,llegó a Bet-Chean. "
,"41":"Jonatán salió a su encuentro con cuarenta,mil de entre los mejores hombres y marchó contra Bet-seán."
,"42":"Cuando Trifón vio que Jonatán llegaba con un poderoso,ejército, no se atrevió a apresarlo. "
,"43":"Lo recibió con todos los,honores, se lo recomendó a todos sus Amigos, le ofreció regalos y,ordenó a sus Amigos y a sus soldados que le obedecieran como si,fuera él. "
,"44":"Dijo luego a Jonatán: '¿Por qué cansas a todos,esos hombres, siendo que no tenemos conflicto? "
,"45":"Mándalos de,vuelta a su casa, quédate sólo con algunos para acompañarte y ven,conmigo a Tolemaida. Pondré esa ciudad en tus manos como también,las demás fortalezas, las otras tropas y a todos los servidores,del rey, luego me volveré a Antioquía, pues para eso vine'."
,"46":"Jonatán le creyó e hizo como el otro le decía; despachó a,sus hombres, que volvieron a Judea, "
,"47":"no reservándose para sí,más que tres mil. Mandó dos mil a Galilea y se quedó con mil para,que lo acompañaran. "
,"48":"Pero en cuanto Jonatán entró en,Tolemaida, los habitantes cerraron las puertas, lo tomaron,prisionero y mataron a espada a todos los que lo acompañaban."
,"49":"Trifón mientras tanto había mandado un ejército y una,caballería a Galilea para aplastar en la Gran Llanura a todos los,hombres de Jonatán. "
,"50":"Pero cuando éstos supieron que Jonatán,había sido apresado y que había caído junto con todos sus,compañeros, se dieron ánimo los unos a los otros y empezaron a,caminar en filas apretadas, listos para combatir. "
,"51":"Viendo que,estaban decididos a defender su vida, los que los perseguían,dieron media vuelta, "
,"52":"y así fue como todos aquellos,regresaron sin problema al territorio de Judá; lloraron a Jonatán,y a sus compañeros y un gran terror se apoderó de ellos. Todo Israel hizo un gran duelo. "
,"53":"Todas las naciones de los,alrededores no pensaban más que en eliminarlos, pues decían: '¡Ya,no tienen ni jefe ni aliados; ataquémoslos ahora y borremos su,memoria de en medio de los hombres!'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Supo Simón que Trifón había formado un gran ejército para,invadir el territorio de Judá y devastarlo. "
,"2":"Viendo que el,pueblo tenía miedo, que reinaba el terror, subió a Jerusalén y,reunió al pueblo. "
,"3":"Lo arengó con estas palabras: 'Saben,ustedes todo lo que mis hermanos, yo mismo y toda la casa de mi,padre hemos hecho por nuestras leyes y por nuestra religión. "
,"4":"Todos mis hermanos dieron la vida por Israel y he quedado yo,solo; "
,"5":"pero, líbreme Dios de ponerme a resguardo en momentos,difíciles, porque mi vida no vale más que la de mis hermanos. "
,"6":"Ya que las naciones que nos odian se han puesto de acuerdo,para destruirnos, yo haré justicia a mi pueblo, al Templo, a,nuestras mujeres y a nuestros hijos'."
,"7":"Al oír esas palabras, se despertó el espíritu del pueblo,"
,"8":"y respondieron con grandes aclamaciones: '¡Tú serás nuestro,jefe en lugar de Judas y de tu hermano Jonatán! "
,"9":"¡Dirígenos en,el combate y haremos todo lo que nos digas!'"
,"10":"Simón reunió entonces a todos los hombres aptos para la,guerra. Terminó rápidamente las murallas de Jerusalén y fortificó,todo el contorno de la ciudad. "
,"11":"Mandó luego a Jope a,Jonatán, hijo de Absalón, con un poderoso ejército; éste desalojó,a los que allí estaban y se instaló en la ciudad."
,"12":"Trifón salió de Tolemaida con un poderoso ejército para,invadir el territorio de Judá; llevaba consigo prisionero a,Jonatán. "
,"13":"Simón, por su parte, estableció su campamento en,Adida, frente a la llanura. "
,"14":"Cuando Trifón supo que Simón,había tomado el mando en lugar de su hermano Jonatán y que estaba,listo para atacarlo, le mandó unos mensajeros: "
,"15":"'Tenemos,preso a tu hermano Jonatán, dijeron, a causa del dinero que debe,al erario real como alto funcionario. "
,"16":"Mándanos pues cien,talentos de plata y a dos de sus hijos como rehenes para que, una,vez en libertad, no se nos escape; entonces lo soltaremos'. "
,"17":"Simón comprendió que sus palabras no eran sinceras; mandó,sin embargo el dinero y a los dos jóvenes para que no cayera sobre,él la cólera del pueblo, porque podrían luego decir: "
,"18":"'Como,no mandó el dinero ni los jóvenes, mataron a Jonatán'. "
,"19":"Mandó,pues a los niños y los cien talentos de plata, pero Trifón no,cumplió su promesa ni soltó a Jonatán."
,"20":"Trifón avanzó luego para invadir el país y devastarlo; dio,un rodeo, tomando el camino de Adora, pero Simón y su ejército se,le interponían doquiera él iba. "
,"21":"Los hombres de la ciudadela,mandaron unos mensajeros donde Trifón para suplicarle que fuera,rápidamente por el desierto y les llevara víveres. "
,"22":"Trifón,dispuso toda su caballería para ir allá, pero como esa noche hubo,una fuerte caída de nieve, la nieve impidió el paso. Levantó su,campamento y se dirigió a Galaad. "
,"23":"Antes de llegar a Bascama, ordenó ejecutar a Jonatán, al que enterraron en ese lugar. "
,"24":"Luego Trifón emprendió el regreso para volver a su país."
,"25":"Simón mandó recoger los restos de su hermano Jonatán y los,enterró en Modín, en la ciudad de sus padres. "
,"26":"Todo Israel,hizo un gran duelo por él y lo lloraron durante muchos días. "
,"27":"Simón mandó construir un mausoleo en la tumba de sus padres,y de sus hermanos; estaba hecho de piedras labradas por delante y,por detrás y era lo bastante alto como para que se viera de lejos. "
,"28":"Mandó erigir siete pirámides, unas frente a otras, por su,padre, su madre y sus cuatro hermanos, "
,"29":"para así conservar su,recuerdo para siempre. Rodeó estas pirámides con un círculo de,altas columnas rematadas con armaduras, al lado de esas armaduras,ordenó que se esculpieran barcos que podrían ser vistos por todos,los que navegan por el mar. "
,"30":"Ese es, hasta el día de hoy, el,monumento que Simón ordenó construir en Modín."
,"31":"Trifón, que actuaba con doblez con el joven rey Antíoco, acabó por asesinarlo "
,"32":"y reinó en su lugar. Tomó la corona de,los reyes de Asia e hizo mucho daño al país. "
,"33":"Simón,reconstruyó las fortalezas de Judá, instaló en ellas altas torres, murallas elevadas, puertas y cerrojos y dejó allí provisiones de,reserva. "
,"34":"Simón, además, escogió a algunos hombres que mandó,donde el rey Demetrio para que hiciera al país exento de,impuestos, porque Trifón no hacía más que robar y asaltar. "
,"35":"El rey Demetrio respondió a su demanda con esta carta:"
,"36":"'¡El rey Demetrio saluda a Simón, sumo sacerdote y amigo de,los reyes, a los ancianos y a la nación de los judíos! "
,"37":"Hemos recibido la corona de oro y la palma que nos,enviaste, estamos dispuestos a firmar con ustedes una paz total y,a escribir a los recaudadores reales para que les hagan diferentes,concesiones. "
,"38":"Todos nuestros compromisos con ustedes se,mantienen firmes, las fortalezas que han construido ustedes son,suyas. "
,"39":"Queremos olvidarnos de todas las faltas y de las,ofensas cometidas hasta ahora, como también de la tasa real que,nos debían; y si por casualidad se cobraba en Jerusalén algún otro,impuesto, que no se cobre más. "
,"40":"Si hay entre ustedes gente,dispuesta a enrolarse en nuestra guardia personal, que vaya a,enrolarse y que reine la paz entre nosotros'."
,"41":"Así fue quitado, el año ciento setenta, el yugo de las,naciones que pesaba sobre Israel. "
,"42":"El pueblo de Israel,comenzó a fechar sus actas y sus contratos de esta manera: 'El,primer año de Simón, eminente sumo sacerdote, general y gobernador,de los judíos'."
,"43":"Por esos días, Simón se dirigió a Gaza y la hizo sitiar por,sus tropas; construyó torres rodantes y las emplazó para atacar la,ciudad; logró hacer un hoyo desde una de esas torres y entrar en,la ciudad. "
,"44":"Los que estaban en la torre rodante saltaron,afuera y cundió el pánico; "
,"45":"los habitantes, sus mujeres y sus,hijos subieron a las murallas, con sus ropas hechas tiras y,lanzando grandes gritos, le pidieron a Simón que les concediera la,paz. "
,"46":"Le decían: '¡No nos trates según nuestra maldad sino,según tu misericordia!' "
,"47":"Simón tuvo compasión de ellos y,detuvo el combate, pero expulsó a los habitantes de la ciudad, purificó las casas en las que habían ídolos e hizo una entrada,solemne, entonando himnos, cánticos y salmos de acción de gracia. "
,"48":"Después de haber sacado de la ciudad todas las impurezas, puso allí hombres fieles a la Ley, luego la fortificó y se,construyó allí una casa."
,"49":"Durante todo ese tiempo, los hombres que ocupaban la,ciudadela de Jerusalén no podían ya ni salir ni circular por el,país ni comprar ni vender; estaban sufriendo de hambre y eran,muchos los que morían de inanición. "
,"50":"Le suplicaron a Simón,que hiciera la paz con ellos. Este se la concedió, pero los echó,de allí y purificó la ciudadela de cualquier impureza. "
,"51":"Entró,allí solemnemente el día vigésimo tercero del segundo mes, el año,ciento setenta y uno, con palmas y cantos de alabanza, al son de,cítaras, címbalos, arpas, himnos y cánticos, porque había sido,derrotado un gran enemigo de Israel. "
,"52":"Ordenó que se celebrara,ese día anualmente. "
,"53":"Fortificó la colina del Templo situada,al lado de la ciudadela y residió allí con los suyos. "
,"54":"Viendo,que su hijo Juan era ya un hombre, Simón le confió el mando de,todas las tropas y le dio como residencia Gazer."
}`)
	CurrentBook.AddChapter(14, `{
"1":"El año ciento setenta y dos, el rey Demetrio reunió sus,fuerzas y partió para Media para reclutar allí tropas auxiliares, porque quería combatir con Trifón. "
,"2":"Arsaces, rey de Persia y,Media, al saber que Demetrio había entrado en su territorio, mandó,contra él a uno de sus generales para que lo capturara vivo. "
,"3":"Este se puso en marcha, derrotó a la columna de Demetrio y lo,apresó; se lo llevó a Arsaces, quien lo arrojó en una prisión. "
,"4":"El país estuvo por eso en paz durante todo el reinado de,Simón. Este sólo procuró el bien del pueblo y durante todos sus días el,pueblo apreció su autoridad y su fama. "
,"5":"Añadió a sus títulos,de gloria la toma de Jope; mandó hacer allí un puerto que le abría,el camino de las islas del mar. "
,"6":"Extendió las fronteras de su,nación y fue el dueño del país. "
,"7":"Hizo que volvieran un gran,número de prisioneros, se apoderó de Gazer, de Bet-Sur y de la,ciudadela, retiró de allí todas las impurezas y nadie más pudo,oponerle resistencia. "
,"8":"Cada cual trabajaba sus campos en paz, la tierra daba sus productos y los árboles de los campos, sus,frutas. "
,"9":"Sentados en las plazas, los viejos hablaban de la,prosperidad del país y a la gente joven le gustaba ponerse,vistosos trajes de guerra."
,"10":"Simón proveyó a las ciudades de víveres y de todo lo,necesario para su defensa; su fama llegó hasta los confines de la,tierra. "
,"11":"Devolvió la paz al país e Israel disfrutó de una,gran prosperidad. "
,"12":"Cada cual pudo sentarse bajo su parra o,su higuera sin que nadie los amenazara. "
,"13":"Habían dejado de,atacarlos en su país, y los reyes habían sido vencidos. "
,"14":"Simón fue el apoyo de los humildes y de su pueblo; como,estaba lleno de celo por la Ley, hizo que desaparecieran los,renegados y los malvados. "
,"15":"Devolvió al Templo su gloria y,multiplicó los objetos sagrados."
,"16":"Cuando se enteraron en Roma y en Esparta de la muerte de,Jonatán, se sintieron muy apenados; "
,"17":"pero cuando supieron que,su hermano Simón había pasado a ser sumo sacerdote en lugar de,aquél, que era dueño de todo el país y de todas las ciudades que,había en él, "
,"18":"le escribieron en tablillas de bronce para,renovar con él la alianza y la amistad que habían concertado con,sus hermanos Judas y Jonatán. "
,"19":"Se leyó ese documento ante,toda la asamblea en Jerusalén; esta es la copia de la carta que,enviaron los espartanos:"
,"20":"'Los jefes de los espartanos y la ciudad saludan al sumo,sacerdote Simón, a los ancianos, a los sacerdotes y a todo el,pueblo de los judíos. "
,"21":"Los embajadores que ustedes enviaron a,nuestro pueblo nos hablaron de su gloria y de su prosperidad. Hemos quedado felices con su visita "
,"22":"y así hemos,registrado su declaración en las actas de nuestro pueblo: Numenios, hijo de Antíoco, y Antípater, hijo de Jasón, embajadores,de los judíos, vinieron donde nosotros para renovar su amistad con,nosotros. "
,"23":"Ha sido un placer para el pueblo recibir a esos,hombres con honor y depositar la copia de su discurso en los,archivos de la nación, para que el pueblo de Esparta conserve su,memoria; mandamos hacer esta copia para el sumo sacerdote Simón'."
,"24":"Simón mandó después a Roma a Numenios con un gran escudo de,oro que pesaba más de cincuenta quilos, para confirmar la alianza,con los romanos."
,"25":"Al saber todo eso, el pueblo dijo: '¿Cómo podremos,testimoniar nuestro reconocimiento a Simón y a sus hijos? "
,"26":"El, sus hermanos y la familia de su padre han animado la,resistencia; vengaron a Israel de sus enemigos y le aseguraron su,libertad'. Grabaron pues una inscripción en tablillas de bronce,que fijaron en una columna en el cerro Sión. "
,"27":"Esta es su,copia: 'El dieciocho del mes de Elul, el año ciento setenta y dos, el,tercer año del sumo sacerdote Simón, en el patio interior del,Templo, "
,"28":"tuvieron una gran asamblea los sacerdotes y el,pueblo, los príncipes de la nación y los ancianos del país. Publicaron este decreto: "
,"29":"Simón, hijo de Matatías, de la,familia de Joarib, y sus hermanos se han expuesto al peligro en,los continuos combates que han tenido lugar en el país; se han,levantado contra los enemigos de la nación para mantener el Templo,y la Ley, cubriendo así de gloria a su nación. "
,"30":"Jonatán,unificó a la nación y llegó a ser sumo sacerdote, luego fue a,reunirse con sus padres. "
,"31":"Los enemigos de los judíos quisieron,entonces invadir el país para devastar su territorio y apoderarse,del Lugar Santo, "
,"32":"pero se levantó Simón y luchó por su,nación. Ha gastado mucho de sus propias riquezas para proveer de,armas a los combatientes de su nación y darles un sueldo. "
,"33":"Fortificó las ciudades de Judá y también Bet-Sur, en los,límites de Judea; en esa ciudad, que hasta ese entonces había,estado ocupada por los enemigos, instaló una guarnición judía. "
,"34":"Fortificó Jope en la costa, y Gazer en la frontera con,Azoto; antes estaba habitada por los enemigos pero él instaló allí,colonos judíos y se preocupó de todo lo necesario para su,sustento. "
,"35":"Viendo la fidelidad de Simón y la gloria que,quería dar a su nación, el pueblo lo nombró gobernador y sumo,sacerdote, en reconocimiento a todos los servicios que había,prestado, y a la justicia y fidelidad que había demostrado con su,nación, porque en cualquier ocasión, había tratado de exaltar a su,pueblo. "
,"36":"En sus días y gracias a él, los judíos arrojaron a,los extranjeros de la provincia, especialmente a los que se habían,hecho fuertes en la ciudad de David en Jerusalén, de donde hacían,incursiones para manchar los alrededores del Templo y profanar su,santidad. "
,"37":"Colocó allí soldados judíos y la fortificó para,asegurar la defensa del país y de la ciudad; también alzó las,murallas de Jerusalén.'"
,"38":"Después de eso, el rey Demetrio le asignó el cargo de sumo,sacerdote, "
,"39":"lo nombró entre sus amigos y le concedió los más,altos honores; "
,"40":"pues se había informado que los romanos,trataban a los judíos de amigos, aliados y hermanos, y que habían,recibido con honores a los enviados de Simón."
,"41":"El rey tomó en cuenta lo que pareció bueno a los judíos,y los sacerdotes: que Simón fuera príncipe y sumo sacerdote para,siempre, hasta el día en que aparezca un profeta digno de fe; "
,"42":"que él comandara sus ejércitos, que tuviera a su cargo los,Lugares Santos y nombrara a los responsables de los servicios,públicos y de la administración del país; que también se,preocupara de los armamentos y de la defensa de las fortalezas. "
,"43":"Tendría a su cargo el pueblo santo, y sería de todos,obedecido. Todos los actos públicos del país serían escritos en su,nombre y él se vestiría de púrpura y de oro. "
,"44":"Nadie del,pueblo ni de los sacerdotes podría objetar cualquiera de estos,puntos, contradecir cualquiera de sus órdenes o convocar sin su,autorización a una asamblea en el país, ni llevar ropa de púrpura,o broche de oro. "
,"45":"Cualquiera que procediere de manera,contraria a este decreto o violare uno solo de sus artículos sería,castigado."
,"46":"El pueblo estimó que era bueno que Simón actuara según este,decreto "
,"47":"y Simón aceptó. Quiso desempeñar el cargo de sumo,sacerdote, de jefe del ejército y de gobernador de los judíos y de,los sacerdotes, en una palabra, de ejercer el mando supremo."
,"48":"Decidieron que se grabaría este documento en tablillas de,bronce y se las pondría en la galería del Templo, en un lugar bien,visible; "
,"49":"también depositaron una copia en la cámara del,tesoro para uso de Simón y de sus hijos."
}`)
	CurrentBook.AddChapter(15, `{
"1":"El rey Antíoco, hijo de Demetrio, mandó desde las islas del,mar una carta a Simón, sumo sacerdote y gobernador de los judíos y,a toda la nación. "
,"2":"Esto era lo que allí se leía: 'El rey,Antíoco saluda a Simón, sumo sacerdote y gobernador y también a la,nación de los judíos. "
,"3":"Unos bandidos se han apoderado del,reino de mis padres, pero yo quiero recuperarlo para restablecerlo,tal como era antes. Para eso he reclutado numerosas tropas y,armado muchos barcos de guerra. "
,"4":"Tengo la intención de,desembarcar en el país para vengarme de los que lo han arruinado y,que han destruido un gran número de ciudades de ese reino. "
,"5":"Te,confirmo, pues, todas las exenciones de impuestos que te,concedieron los reyes que estuvieron antes que yo y todas las,otras eximiciones que te otorgaron. "
,"6":"Puedes acuñar moneda a tu,nombre en todo el país, "
,"7":"Jerusalén y el Templo serán libres, las armas que fabricaste, las fortalezas que construiste y que,ocupas quedarán en tu poder. "
,"8":"Todo lo que debiste o debas al,tesoro real te será condonado ahora y para siempre. "
,"9":"Cuando,hayamos tomado posesión de nuestro reino, te colmaremos de honores,a ti, a tu nación y al Templo, de tal modo que la gloria de,ustedes resplandecerá en toda la tierra'."
,"10":"Antíoco emprendió el trayecto rumbo al país de sus padres el,año ciento setenta y cuatro; todas las tropas fueron a agruparse,en torno a él, de tal modo que le quedaron a Trifón solo unos,pocos hombres. "
,"11":"El rey Antíoco se lanzó en su persecución y,Trifón huyó a Dora, en la costa. "
,"12":"Veía que se cernía sobre él,la desgracia y que su ejército lo abandonaba. "
,"13":"Antíoco llegó,para acampar frente a Dora con ciento veinte mil hombres y ocho,mil de caballería. "
,"14":"Puso sitio a la ciudad y sus barcos, por,su parte, la bloqueaban por el lado del mar; así la cercó por,tierra y por mar, no dejando que nadie entrara o saliera de allí."
,"15":"Llegaron por ese entonces de Roma Numenio y sus,compañeros con cartas para los reyes y para los países. Esto se,leía en ellas: "
,"16":"'Lucio, cónsul de Roma, saluda al rey,Tolomeo. "
,"17":"El sumo sacerdote Simón y el pueblo judío nos,enviaron embajadores como amigos y aliados, para renovar la,antigua amistad y la antigua alianza. "
,"18":"Nos trajeron un escudo,de oro de más de cincuenta quilos, "
,"19":"por eso nos ha parecido,conveniente escribirles a los reyes y a los países para que no les,hagan daño, ni los ataquen, respeten sus ciudades y su país, y no,proporcionen ayuda a los que quisieran hacerles la guerra. "
,"20":"Estimamos que era bueno recibir su escudo."
,"21":"Por lo,tanto, si malos sujetos han huido de su país al de ustedes, entréguenlos al sumo sacerdote Simón para que los castigue según,sus leyes'. "
,"22":"Mandaron la misma carta al rey Demetrio, a,Atala, a Ariartes, a Arsaces "
,"23":"y a todos los países: a,Sampsamo, a los espartanos, a Delos, a Mindos, a Sicione, a Caria, a Samos, a Panfilia, a Licia, a Halicarnaso, a Rodas, a Fasélida, a Cos, a Side, a Arados, a Gortina, a Guido, a Chipre y a Cirene. "
,"24":"Y se hizo una copia de esas cartas para el sumo sacerdote,Simón."
,"25":"El rey Antíoco atacó el barrio nuevo de Dora; sus hombres,avanzaban poco a poco y construían máquinas. Sitió a Trifón de tal,modo que ya no se podía entrar ni salir. "
,"26":"Simón le mandó dos,mil de sus mejores guerreros para ayudarlo, junto con plata, oro y,muchos materiales. "
,"27":"Pero el rey no quiso recibirlos, al,contrario, anuló todos los compromisos que había contraído antes,con Simón y cambió de actitud para con él. "
,"28":"Le mandó a uno de,sus Amigos, Atenobio, para hablar con él: 'Ustedes, mandaba,decirle, ocupan Jope, Gazer y la ciudadela de Jerusalén, que son,ciudades de mi reino. "
,"29":"Ustedes han asolado sus alrededores, devastado el país y se han adueñado de muchas de las ciudades de,mi reino. "
,"30":"Pues bien, devuélvannos ahora las ciudades que han,tomado y los impuestos de las ciudades que ustedes han recaudado,fuera del territorio de Judá. "
,"31":"Si no, dennos en vez de eso,quinientos talentos de plata y otros quinientos por las,devastaciones que han cometido y por los impuestos que pagaban,esas ciudades. En caso contrario, les declararemos la guerra'."
,"32":"Cuando Atenobio, Amigo del rey, llegó a Jerusalén, vio la,riqueza de Simón, el aparador lleno de vasos de oro y plata, y el,lujo que lo rodeaba. Quedó estupefacto. Cuando transmitió las,palabras del rey, "
,"33":"Simón le respondió: 'No hemos conquistado,una tierra extranjera ni nos hemos apoderado de los bienes ajenos, sino que era la herencia de nuestros padres, que nuestros enemigos,nos habían robado por un tiempo. "
,"34":"Como la ocasión era,favorable, nos aprovechamos de ella para reconquistar la herencia,de nuestros padres. "
,"35":"Jope y Gazer, que tú reclamas, son dos,ciudades que han hecho mucho daño a nuestro pueblo y a nuestro,país; por eso, sólo daremos por ellas cien talentos'. Atenobio nada respondió, "
,"36":"sino que partió furioso donde el,rey y le transmitió la respuesta de Simón. Le habló de su riqueza,y de todo lo que había visto, y eso le produjo al rey una gran,indignación."
,"37":"Trifón había huido en barco a Ortosia."
,"38":"El rey eligió,entonces a Cendebo como gobernador de la zona marítima y le pasó,un ejército de infantería y de caballería. "
,"39":"Le ordenó que,instalara su campamento frente a la Judea, que reconstruyera,Cedrón, reforzara sus puertas y combatiese al pueblo; el rey, por,su parte, iría a perseguir a Trifón. "
,"40":"Cendebo llegó hasta,Jamnia y comenzó a desafiar al pueblo. Hacía incursiones en Judea, mataba gente y se llevaba prisioneros. "
,"41":"Fortificó Cedrón, instalando allí una tropa de caballería e infantería que hacían,incursiones y patrullaban los caminos de Judea, tal como el rey lo,había mandado."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Juan subió desde Gazer para comunicar a su padre lo que,Cendebo estaba haciendo. "
,"2":"Simón llamó entonces a sus dos hijos,mayores, Judas y Juan, y les dijo: 'La familia de mi padre, mis,hermanos y yo hemos combatido a los enemigos de Israel desde,nuestra juventud hasta el día de hoy, y gracias a nosotros Israel,se ha salvado muchas veces. "
,"3":"Ahora, ya soy mayor, mientras que,ustedes, gracias al Cielo, están en la flor de la edad. Tomen pues,mi lugar y el de mi hermano. Partan a combatir por su nación y que,la ayuda del Cielo los acompañe'."
,"4":"Reclutó entonces en el país a veinte mil hombres de infantería,y de caballería que marcharon contra Cendebo y pasaron la noche en,Modín. "
,"5":"Cuando se levantaron por la mañana, avanzaron por la,llanura, pero salió a enfrentarlos un poderoso ejército compuesto,de infantería y caballería; sólo los separaba un torrente. "
,"6":"Juan pensaba instalar su campamento frente al enemigo, pero,vio que sus hombres tenían miedo de atravesar el torrente. Entonces lo pasó él primero. Al ver eso, sus hombres pasaron,detrás de él. "
,"7":"Dividió su ejército en dos, ubicando a la,caballería en medio de la infantería, porque la caballería de los,enemigos era mucho más numerosa."
,"8":"Tocaron la trompeta y Cendebo tuvo que huir con su ejército; cayeron muchos de sus hombres y los que lograron escapar se,refugiaron en la fortaleza. "
,"9":"Entonces fue herido Judas, hermano de Juan, pero éste persiguió al enemigo hasta que Cendebo,llegó a Cedrón, que había fortificado. "
,"10":"Como los demás se,habían refugiado en unas torres, en las afueras de Azoto, Juan les,prendió fuego; sucumbieron dos mil de ellos y Juan volvió en paz a,Judea."
,"11":"Tolomeo, hijo de Abubos, había sido nombrado gobernador de,la llanura de Jericó; era rico en oro y plata, "
,"12":"y era yerno,del sumo sacerdote. "
,"13":"En su orgullo anhelaba ser el dueño del,país, y en su maldad, se puso a pensar cómo acabar con Simón y sus,hijos. "
,"14":"Pues bien, Simón, preocupado del bienestar de las,ciudades, andaba haciendo una gira de inspección; fue así como,llegó a Jericó con sus dos hijos, Matatías y Judas, en el mes de,Sebat, el undécimo mes del año ciento setenta y siete."
,"15":"El hijo de Abubos los recibió hipócritamente en una pequeña,fortaleza que había construido y cuyo nombre era Doc. Les preparó,un gran banquete, pero había escondido a unos hombres, "
,"16":"y,cuando Simón y sus hijos estuvieron ebrios, Tolomeo y sus hombres,tomaron armas y se abalanzaron sobre Simón en el comedor; lo,mataron junto con sus dos hijos y algunos de sus compañeros. "
,"17":"Era un gesto odioso, por el cual devolvía mal por bien."
,"18":"Tolomeo escribió al rey para contarle lo que había hecho. Le,pidió que le mandara tropas para que así entregara al rey el país,y las ciudades de los judíos. "
,"19":"También mandó unos hombres a,Gazer para que asesinaran a Juan, y pidió por carta a los,generales que se juntaran con él, ofreciéndoles plata, oro y otros,regalos. "
,"20":"Por último mandó a otros para que se apoderaran de,Jerusalén y de la colina del Templo."
,"21":"Pero hubo un hombre que se les adelantó corriendo. Informó a,Juan, que estaba en Gazer, del asesinato de su padre y de sus,hermanos. También le dijo: 'Mandó unos hombres para matarte'. "
,"22":"Al saberlo, Juan se quedó pasmado. Pero apresó a los hombres,que venían a matarlo y los mandó ejecutar, pues sabía que venían,para asesinarlo."
,"23":"El resto de la historia de Juan, sus guerras, sus actos de,valentía, las murallas que edificó y todo lo que hizo, "
,"24":"¿no,está escrito en los archivos de los sumos sacerdotes, a contar de,la fecha en que recibió ese cargo en el que sucedió a su padre?"
}`)

}
func ES_LBL_LoadVH1PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Adán, Set, Enós,"
,"2":"Quenán, Mahaliel, Jered;"
,"3":"Henoc, Matusalén, Lamec,"
,"4":"Noé, Sem, Cam y Jafet."
,"5":"Hijos de Jafet: Gómer, Magog, los medos, Javán, Tubal, Mésec y Tirás."
,"6":"Hijos de Gómer: Asquenas, Rifat y Togormá."
,"7":"Hijos de Javán: Elizá, Tarsis, Quittim y Rodanim."
,"8":"Hijos de Cam: Cus y Misraim Put, y Canaán."
,"9":"Hijos de Cus: Sebá, Javilá, Sabtá, Ramá y Sabtecá. Hijos de Ramá: Sebá y Dedán."
,"10":"Cus engendró a Nimrod, que fue el primer hombre poderoso de la tierra."
,"11":"Misraim engendró a los luditas, anamitas, lehabitas, naftujitas,"
,"12":"patrusitas, caslujitas y caftoritas, de donde proceden los filisteos."
,"13":"Canán engendró a Sidón su primogénito, a Het,"
,"14":"y al jebuseo, al amorreo, al guirgaseo,"
,"15":"al jeveo, al arquita, al sinita,"
,"16":"al arvadita, al semarita y al jamatita."
,"17":"Hijos de Sem: Elam, Asur, Arfaxad, Lud y Aram. Hijos de Aram: Us, Jul, Guéter y Mésec."
,"18":"Arfaxad engendró a Selaj y Selaj engendró a Héber."
,"19":"A Héber le nacieron dos hijos: el nombre del primero era Péleg, porque en sus días fue dividida la tierra, y el nombre de su hermano era Yogtán."
,"20":"Yogtán engendró a Almodad, Selef, Jasarmávet, Yéraj,"
,"21":"Hadoram, Uzal Diglá,"
,"22":"Ebal, Abimael, Seba,"
,"23":"Ofir, Javilá, Yobab. Todos ellos hijos de Yogtán."
,"24":"Sem, Arfaxad, Selaj,"
,"25":"Héber, Péleg, Reú,"
,"26":"Serug, Najor, Teraj,"
,"27":"Abram, o sea Abraham."
,"28":"Hijos de Abraham: Isaac e Ismael."
,"29":"Sus descendientes son éstos: El primogénito de Ismael: Nebayot; después, Quedar, Abdeel, Mibsam, "
,"30":"Mismá, Dumá, Masá, Jadad, Temá,"
,"31":"Yetur, Nafis y Quedmá. Estos son los hijos de Ismael. Hijos de Queturá, concubina de Abraham. Dio a luz a Zimrán, Jocsán, Medán, Madián, Jisbaq y Súaj. "
,"32":"Hijos de Yoqsán: Sebá y Dedán."
,"33":"Hijos de Madián: Efá, Efer, Henoc, Abidá y Eldaá. Todos ellos son hijos de Queturá."
,"34":"Abraham engendró a Isaac. Hijos de Isaac: Esaú e Israel."
,"35":"Hijos de Esaú: Elifaz, Reuel, Jeus, Yalam y Coré."
,"36":"Hijos de Elifaz: Temán, Omar, Sefi, Gatam, Quenaz, Timmá y Amalec."
,"37":"Hijos de Reuel: Nájat, Zéraj, Sammá y Miza."
,"38":"Hijos de Seír: Lotán, Sobal, Sibón, Aná, Disón, Eser y Disán."
,"39":"Hijos de Lotán: Jori y Homá. Hermana de Lotán fue Timná."
,"40":"Hijos de Sobá: Alyán, Manájat, Ebal, Sefi y Onam. Hijos de Sibón: Ayá y Aná."
,"41":"Hijos de Aná: Disón. Hijos de Disón: Jamrán, Esbam, Jitram y Keram."
,"42":"Hijos de Eser: Bilán, Zayán y Yacán. Hijos de Disón: Us y Aran."
,"43":"Estos son los reyes que reinaron en el país de Edom antes que hubiera rey entre los israelitas: Bela, hijo de Beor; el nombre de su ciudad era Dinaba."
,"44":"Murió Bela, y reinó en su lugar Yobab, hijo de Zéraj, de Bosrá."
,"45":"Murió Yobab y reinó en su lugar Jusam, del país de los teranitas."
,"46":"Murió Jusam, y en su lugar reinó Abad, hijo de Bedad, que derrotó a los madianitas en los campos de Moab; el nombre de su ciudad fue Avit."
,"47":"Murió Adad, y reinó en su lugar Samlá, de Marecá."
,"48":"Murió Samlá y reinó en su lugar Saúl, de Rejobot-han-Nahar."
,"49":"Murió Saúl y reinó en su lugar Baal-Janán, hijo de Acbor."
,"50":"Murió Baal-Janán y reinó en su lugar Hadad. El nombre de su ciudad era Paí, y el de su mujer Mehetabel, hija de Matred, hija de Mezahab."
,"51":"Murió Hadad y hubo gobernadores, llamados jeques, en Edom: el jeque Timmá, el jeque Alyá, el jeque Yetet,"
,"52":"el jeque Olibamá, el jeque Elá, el jeque Pinón,"
,"53":"el jeque Quenaz, el jeque Temán, el jeque Mibsar,"
,"54":"el jeque Magdiel, el jeque Iram. Estos fueron los jeques de Edom."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Estos son los hijos de Israel: Rubén, Simeón, Leví y Judá, Isacar y Zabulón,"
,"2":"Dan, José y Benjamín, Neftalí, Gad y Aser."
,"3":"Hijos de Judá: Er, Onán y Selá; los tres le nacieron de la hija de Suá, la cananea. Er, primogénito de Judá, era malo a los ojos de Yavé, que le quitó la vida."
,"4":"Tamar, nuera de Judá, le dio a luz a Fares y Zéraj. Todos los hijos de Judá fueron cinco."
,"5":"Hijos de Fares: Hesrón y Jamul."
,"6":"Hijos de Zéraj: Zimrí, Hetán, Hemán, Calcol y Darda, en total cinco."
,"7":"Hijos de Carmi: Acar, que perturbó a Israel por haber violado el anatema."
,"8":"Hijos de Etam: Azarías."
,"9":"Hesrón fue padre de Jerajmeel, Ram y Kelubay."
,"10":"Ram fue padre de Aminadab y éste de Najasón, príncipe de los hijos de Judá."
,"11":"Najasón fue padre de Salmá, éste de Booz,"
,"12":"éste de Obed y éste de Jesé."
,"13":"Jesé tuvo siete hijos, el primogénito Eliab, y después Abinadab, Sama,"
,"14":"Netanel, Raday,"
,"15":"Osem y David."
,"16":"Sus hermanas fueron Sarvia y Abigaíl. Hijos de Sarvia: Abisay, Joab y Asael, tres."
,"17":"Abigaíl dio a luz a Amasá, cuyo padre fue Jeter el ismaelita."
,"18":"Caleb, hijo de Hesrón, engendró a Azubá, Isá y Jeriot. Estos son sus hijos: Jéser, Sobab y Ardón."
,"19":"Murió Azubá y Caleb tomó por mujer a Efratá, de la que tuvo a Jur."
,"20":"Jur engendró a Uri, y Uri engendró a Besaleel."
,"21":"Después se unió Hesrón a la hija de Maquir, padre de Galaad. Tenía él sesenta años cuando la tomó por mujer y le dio a luz a Segub."
,"22":"Segub engendró a Jaír, que poseyó veintitrés ciudades en el país de Galaad."
,"23":"Pero los guesuritas y los arameos se apoderaron de las aldeas de Jaír, con Quenat y sus campamentos: sesenta ciudades. Todos éstos son los hijos de Maquir, padre de Galaad."
,"24":"Después de morir Hesrón, Caleb se unió a Efratá, mujer de su padre Hesrón, la cual le dio a luz a Asjur padre de Tecoa."
,"25":"Los hijos de Jerajmeel, primogénito de Hesrón, fueron: Ram, el primogénito, Buná, Orén, Osem y Ajías."
,"26":"Jerajmeel tuvo otra mujer cuyo nombre era Atará, que fue madre de Onam."
,"27":"Los hijos de Ram, primogénito de Jerajmeel, fueron: Maás, Yamín y Equer."
,"28":"Y los hijos de Onam fueron Samay y Yadá. Los hijos de Samay, Nadab y Abisur."
,"29":"La mujer de Abisur se llamaba Abigaíl, que dio a luz a Ajbán y Molid."
,"30":"Los hijos de Nadab fueron Séled y Apaim; Séled murió sin hijos."
,"31":"Hijo de Apaim fue Jisí; hijo de Jisí, Sesán; hijo de Sesán, Ajlay."
,"32":"Hijos de Yadá, hermano de Samay, fueron Jéter y Jonatán; Jéter murió sin hijos."
,"33":"Hijos de Jonatán: Pélet y Zazá. Estos fueron los descendientes de Jerajmeel."
,"34":"Sesán no tuvo hijos, sino hijas; tenía Sesán un siervo egipcio que se llamaba Yarjá."
,"35":"Y dio Sesán una hija suya a su siervo Yarjá por esposa, la cual le engendró a Atay."
,"36":"Atay engendró a Natán, Natán engendró a Zabad,"
,"37":"Zabad engendró a Efal, Efal engendró a Obed,"
,"38":"Obed engendró a Jehú, Jehú engendró a Azarías,"
,"39":"Azarías engendró a Jeles, Jeles engendró a Elasá,"
,"40":"Elasá engendró a Sismay, Sismay engendró a Sal-lum,"
,"41":"Sal-lum engendró a Jecamías, Jecamías engendró a Elisama."
,"42":"Hijos de Caleb, hermano de Jerajmeel: Mesá, su primogénito, que fue padre de Zif; tuvo por hijo a Maresá, padre de Hebrón."
,"43":"Hijos de Hebrón: Coré, Tapnaf, Requem y Sema."
,"44":"Sema engendró a Rajam, padre de Yorqueam, Requem engendró a Samay."
,"45":"Hijo de Samay fue Maón y Maón fue padre de Bet-Sur."
,"46":"Efá, concubina de Caleb, dio a luz a Jarán, Mosá y Gazes; Jarán engendró a Gazes."
,"47":"Hijos de Yadav: Reguem, Jotam, Guesán, Pelet, Efá y Saaf."
,"48":"Maacá, concubina de Caleb, dio a luz a Séber y Tirjama."
,"49":"Engendró también a Saaf, padre de Madmaná, y a Sevá, padre de Majbená y padre de Guibeá. Hija de Caleb fue Axá."
,"50":"Estos fueron los hijos de Caleb. Hijos de Jur, primogénito de Efratá: Sobal, padre de Cariatiarim; "
,"51":"Salmá, padre de Belén; Járef, padre de Bet-Gader."
,"52":"Sobal, padre de Cariatiarim, tuvo por hijos a Haroé, es decir, la mitad de los manajistas"
,"53":"y las familias de Cariatiarim; los jitríes, los putíes, los sumatíes y los misraíes. De ellos salieron los soratíes y los de Estol."
,"54":"Hijos de Salmá: Belén y los netofatíes, Atrot-Ben-Joab, la otra mitad de los manajitas, los soríes y"
,"55":"las familias de los sofríes que habitaban en Jabés, los tiratíes, los simatíes, los sucatíes. Estos son quenitas descendientes de Jamat, padre de la familia de Recab."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Estos son los hijos que le nacieron a David en Hebrón: el primogénito Amnón, hijo de Ajinoam, de Jizreel; el segundo, Daniel, hijo de Abigaíl de Carmelo;"
,"2":"el tercero Absalón, hijo de Maacá, hija de Talmay, rey de Guesur; el cuarto, Adonías, hijo de Jaguit;"
,"3":"el quinto, Sefatías, de Abital; el sexto, Jitream, de su mujer Eglá."
,"4":"Estos seis le nacieron en Hebrón, donde reinó siete años y seis meses. Reinó en Jerusalén treinta y tres años. "
,"5":"Estos son los que le nacieron en Jerusalén: Simá, Sobab, Natán, Salomón, los cuatro de Betsabé, hija de Ammiel. Además,"
,"6":"Jibjar, Elisamá, Elifelet,"
,"7":"Nogah, Néfeg, Yafia,"
,"8":"Elisamá, Elyadá, Elifélet: nueve."
,"9":"Estos son los hijos de David, sin contar los hijos de las concubinas. Hermana de ellos fue Tamar."
,"10":"Salomón fue padre de Roboam, éste de Abías, éste de Asá, éste de Josafat,"
,"11":"éste de Joram, éste de Ocozías, éste de Joás,"
,"12":"éste de Amasías, éste de Azarías, éste de Jotam,"
,"13":"éste de Ajaz, éste de Ezequías, éste de Manasés,"
,"14":"éste de Amón, éste de Josías."
,"15":"Hijos de Josías: Yojanán, el primogénito; Joaquim, el segundo; Sedecías, el tercero; Salum, el cuarto."
,"16":"Hijos de Joaquim: su hijo Joaquín y su hijo Sedecías."
,"17":"Hijos de Joaquín el desterrado: Sealtiel. Sus hijos:"
,"18":"Malquiram, Pedaías, Senasar, Jeconías, Hosamá, Nedabías. Hijos de Pedías: Zorobabel y Semí."
,"19":"Hijos de Zorobabel: Mesulam, Henanías y Selomit, hermana de ellos."
,"20":"Hijos de Mesulam: Hasubá, Ohel, Berequías, Hasadías y Yusab-Jesed: cinco."
,"21":"Hijos de Hananías: Pelatías; Isaías, hijo suyo; Refaías, hijo suyo; Arnán, hijo suyo; Abdías, hijo suyo; Secanías, hijo suyo. Hijos de Secanías:"
,"22":"Semaías, Jatús, Jigal, Bariaj, Nearías y Safal: seis."
,"23":"Hijos de Nearías: Elyoenay, Ezequías, Azricam: tres."
,"24":"Hijos de Elyoenay: Jodaías, Elyasib, Pelaías, Acub, Jojanán, Delaías y Ananí: siete."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Hijos de Judá: Fares, Hesrón, Carmí, Jur y Sobal."
,"2":"Reaías, hijo de Sobal, engendró a Yajat, Yajat engendró a Ajuma y Lahad. Estas son las familias de los soreatitas."
,"3":"Estos fueron los hijos de Etam: Jizrael, Jismás y Jibdás. Su hermana se llamaba Haselponí."
,"4":"Penuel fue padre de Guedor, y Ezer, padre de Jusá."
,"5":"Estos son los hijos de Jur, primogénito de Efratá, padre de Belén. Asjur, padre de Tecoa, tuvo dos mujeres: Elea y Naará."
,"6":"Naará dio a luz a Ajuzam, Jéfer, los timeítas y los ajastaritas. Estos son los hijos de Naará."
,"7":"Hijos de Elea: Seret, Jesojar, Etnán."
,"8":"Cos engendró a Anub y Sobeba y las familias de Ajarjel, hijo de Harum."
,"9":"Pero Jabés fue más ilustre que sus hermanos, y su madre le dio el nombre de Jabés, diciendo: 'Di a luz con dolor.'"
,"10":"Jabés invocó al Dios de Israel, exclamando: 'Si de verdad me bendices, se ensancharán mis términos, tu mano estará conmigo y alejarás el mal para que no padezca aflicción.' Y le concedió Dios lo que pedía."
,"11":"Caleb, hermano de Sujá, engendró a Mejir, que fue padre de Estón."
,"12":"Estón engendró a Bet-Rafá, Paseaj y Tejiná, padre de Ir-Najás, hermano de Eselón el queniceo. Estos son los hombres de Recab."
,"13":"Hijos de Quenaz: Otoniel y Seraías. Hijos de Otoniel: Jatat y Meonotay."
,"14":"Meonotay engendró a Ofrá, y Seraías engendró a Joab, padre de Gue-Jarasim, pues eran artesanos."
,"15":"Hijos de Caleb, hijo de Jefuné: Iru, Elá y Naán; hijo de Elá: Quenaz."
,"16":"Hijos de Jehaled: Zif, Zifá, Tiryá y Asavel."
,"17":"Hijos de Ezra: Jéter, Méred, Efer y Yalón. Jéter fue padre de María, Samay y Jisbaj, padre de Estemoa."
,"18":"Su mujer, la de Judá, dio a luz a Jered, padre de Guedor, a Jéber, padre de Socó, y a Jecutiel, padre de Zanóaj. Estos son los hijos de Bitía, hija de faraón, que Méred había tomado por esposa."
,"19":"Hijos de la mujer de Odías, hermana de Nájam: el padre de Queilá el garmita y Estemoa el macateo."
,"20":"Hijos de Simón: Ammón y Riná, Ben-Janán y Tilón. Hijos de Jisí: Zojet y Ben-Zojet."
,"21":"Hijos de Selá, hijo de Judá: Er, padre de Lecá, y Ladá, padre de Maresá y las familias de los que trabajan el lino en Bet-Asbea."
,"22":"Joaquim, los hombres de Cozebá y Joás y Saraf, que se casaron en Moab, antes de volver a Belén. Estas son cosas muy antiguas."
,"23":"Ellos eran alfareros y habitaban en Netaim y Gaderá; moraban allí con el rey, trabajando a su servicio."
,"24":"Hijos de Simeón: Nemuel, Yanun, Yarib, Zéraj y Saúl."
,"25":"Salum, su hijo; Mibsam, su hijo; Mismá, su hijo."
,"26":"Hijos de Mismá: Jamuel, hijo suyo; Zacur, hijo suyo; Simí, hijo suyo."
,"27":"Simí tuvo dieciséis hijos y seis hijas, pero sus hermanos no tuvieron muchos hijos, ni se multiplicaron todas sus familias como los hijos de Judá."
,"28":"Habitaban en Bersebá, Moladá, Jasar-Sual,"
,"29":"Bilá, Esem y Tolad, Betuel, Jormá, Siquelag,"
,"30":"Bet-Marjabot, Jasar-Susim, Bet-Birí y Saarayim."
,"31":"Estas fueron sus ciudades hasta el reino de David."
,"32":"También sus aldeas: Etam, Ain, Rimmón, Toquen y Asán, cinco ciudades,"
,"33":"y todas sus aldeas que están en torno a aquellas ciudades, hasta Baalat. Aquí habitaron y se distribuyeron por grupos."
,"34":"Mesobab, Yamlec, Yosá, hijo de Amasías,"
,"35":"Joel, Jehú, hijo de Yosibías, hijo de Seraías, hijo de Aviel;"
,"36":"Elyoenay, Yaacobá, Jesojaías, Asaías, Adiel, Jesimiel y Benaías,"
,"37":"Zizá, hijo de Sifi, hijo de Alón, hijo de Jedaías, hijo de Simrí, hijo de Semaías."
,"38":"Estos que han sido citados por sus nombres son los que vinieron con sus familias y sus casas paternas y se multiplicaron grandemente."
,"39":"Se dirigieron a la entrada de Guedor, hasta el oriente del valle, buscando pastos para sus ganados."
,"40":"Y hallaron pastos abundantes y buenos y una tierra espaciosa, tranquila y segura, pues antes habían morado allí los descendientes de Cam."
,"41":"Estos que se han citado por sus nombres vinieron en tiempos de Ezequías, rey de Judá, y destruyeron las tiendas de aquéllos, y los refugios que allí se encontraban, entregándolos al anatema hasta el día de hoy; y habitaron en lugar de ellos, ya que había allí pastos para sus ganados."
,"42":"Algunos de los hijos de Simeón, en número de quinientos hombres, se fueron a la montaña de Seír, siendo sus jefes Selatías, Nearías, Refaías, Uziel, hijo de Ysí;"
,"43":"derrotaron a los restos de Amalec, que habían escapado, y habitaron allí hasta el día de hoy."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Hijos de Rubén, primogénito de Israel. Rubén había nacido el primero, pero porque fue con la concubina de su padre, sus derechos de primogénito pasaron a los hijos de José, hijo de Israel. Con todo, José no fue inscrito en las genealogías como el primogénito,"
,"2":"pues Judá se hizo poderoso entre sus hermanos y de él procede el príncipe, pero los derechos de primogénito pertenecen a José."
,"3":"Hijos de Rubén, primogénito de Israel: Henoc, Palú, Hesrón y Carmí."
,"4":"Hijos de Joel: Semaías, hijo suyo; Gog, hijo suyo; Simí, hijo suyo;"
,"5":"Mica, hijo suyo; Reaías, hijo suyo; Baal, hijo suyo;"
,"6":"Beerá, hijo suyo, al cual Teglatfalasar, rey de Asiria, llevó cautivo. Era jefe de los rubenitas."
,"7":"Hermanos suyos, por familias, agrupados según sus genealogías: el primero, Jeiel, Zacarías,"
,"8":"Belá, hijo de Azaz, hijo de Sema, hijo de Joel. Estos habitaban en Aroer y hasta Nebo y Baal-Meón. "
,"9":"Habitaban, asimismo, al oriente desde el río Eufrates hasta el borde del desierto, pues sus ganados se habían multiplicado en la tierra de Galaad."
,"10":"En los días de Saúl hicieron guerra contra los agareos, que cayeron en sus manos; y habitaron en sus tiendas por toda la parte oriental de Galaad."
,"11":"Los hijos de Gad habitaban frente a ellos en la tierra de Basán hasta Salcá."
,"12":"Joel fue el primero, Safán, el segundo; luego Yany y Safat, en Basán."
,"13":"Sus hermanos, por casas paternas, fueron: Miguel, Mesulam, Seba, Yoraim, Yacán, Zía y Héber: siete."
,"14":"He aquí los hijos de Abigaíl, hijo de Jurí, hijo de Jaroaj, hijo de Galaad, hijo de Miguel, hijo de Jesisay, hijo de Yajó, hijo de Buz."
,"15":"Ají, hijo de Abdiel, hijo de Guní, era cabeza de sus casas paternas."
,"16":"Habitaban en Galaad, en Basán y sus aldeas, y en todos los pastizales comunes de Sarón hasta sus confines."
,"17":"Todos ellos fueron alistados en los días de Jotam, rey de Judá, y en los días de Jeroboam, rey de Israel."
,"18":"Los hijos de Rubén, los de Gad y la media tribu de Manasés, eran hombres valientes, llevaban escudo y espada, manejaban el arco y eran diestros en la guerra. Eran 44.760, listos para la guerra."
,"19":"Hicieron guerra contra los agareos, contra Jetur, Nafis y Nodab,"
,"20":"y Dios los ayudó contra ellos, de suerte que los agareos y todos los que con ellos estaban fueron derrotados, pues en la batalla clamaron a Dios y les fue propicio, por cuanto confiaban en él."
,"21":"Capturaron sus ganados: sus camellos, en número de 50.000, 250.000 ovejas, 2.000 burros y 100.000 personas, pues"
,"22":"por ser guerra de Dios, cayeron muertos muchos. Habitaron el lugar de ellos hasta el destierro."
,"23":"Los hijos de la media tribu de Manasés habitaron en el país desde Basán hasta Baal-Hermón, Senir y la montaña de Hermón."
,"24":"Eran muy numerosos. He aquí los jefes de sus casas paternas: Efer, Jisí, Eliel, Azriel, Jeremías, Jodavías y Yajdiel, hombres valerosos, gente famosa, jefes de sus casas paternas."
,"25":"Pero fueron infieles al Dios de sus padres y se prostituyeron siguiendo a los dioses de los pueblos del país que Dios había destruido delante de ellos."
,"26":"Por lo cual el Dios de Israel excitó contra ellos a Teglatfalasar, rey de Asiria, que deportó a los rubenitas, los gaditas y la media tribu de Manasés, y los llevó a Calaj, Haber, Jará y el río Gozan, hasta el día de hoy."
,"27":"Hijos de Leví: Guersón, Quehat y Merarí."
,"28":"Hijos de Quehat: Amram, Jishar, Hebrón y Uziel."
,"29":"Hijos de Amram: Aarón, Moisés y María. Hijos de Aarón: Nadab, Abihú, Eleazar e Itamar."
,"30":"Eleazar fue padre de Finjas, éste de Abisua, éste de Buqui, éste de Uzi,"
,"31":"éste de Zarajías, éste de Merayot,"
,"32":"éste de Amarías, éste de Ajitub,"
,"33":"éste de Sadoc, éste de Ajimaas,"
,"34":"éste de Azarías, éste de Yojanán,"
,"35":"éste de Azarías, el cual ejerció el sacerdocio en la Casa que Salomón edificó en Jerusalén."
,"36":"Azarías fue padre de Amarías, éste de Ajitub,"
,"37":"éste de Saco, éste de Salum,"
,"38":"éste de Hilquías, éste de Azarías,"
,"39":"éste de Seraías, éste de Josadec."
,"40":"Este salió cuando Yavé deportó a Judá y Jerusalén por mano de Nabucodonosor."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Hijos de Leví: Guersón, Quehat y Merarí."
,"2":"Estos son los nombres de los hijos de Guersón: Libní y Simí."
,"3":"Hijos de Quehat: Amram, Jishar, Hebrón y Uziel."
,"4":"Hijos de Merarí: Majlí y Musi. Estas son las familias de los levitas, según sus casas paternas."
,"5":"De Guersón: Libní, hijo suyo; Yajat, hijo suyo; Zimmá, hijo suyo;"
,"6":"Yoaj, hijo suyo; Iddó, hijo suyo; Zéraj, hijo suyo; Yeatray, hijo suyo."
,"7":"Hijos de Quehat: Aminadab, hijo suyo; Coré, hijo suyo; Assir, hijo suyo;"
,"8":"Elcaná, hijo suyo; Ebyasaf, hijo suyo; Asir, hijo suyo;"
,"9":"Tajat, hijo suyo; Uriel, hijo suyo; Saúl, hijo suyo."
,"10":"Hijos de Elcaná: Amasay y Ajimot."
,"11":"Elcaná, hijo suyo; Sufay, hijo suyo; Nájat, hijo suyo;"
,"12":"Eliab, su hijo; Jerojaim, su hijo; Elcaná, hijo suyo."
,"13":"Hijos de Samuel: Joel, el primogénito, y Abías, el segundo."
,"14":"Hijos de Merarí: Majlí; Libní, hijo suyo; Simí, hijo suyo; Uzá, hijo suyo;"
,"15":"Simca, hijo suyo; Jagguías, hijo suyo; Asaías, hijo suyo."
,"16":"Estos son los que puso David para dirigir el canto en la casa de Yavé, desde que el Arca tuvo un lugar de reposo."
,"17":"Ejercían el ministerio de cantores ante la Morada de la Tienda de Reunión, hasta que Salomón edificó la Casa de Yavé en Jerusalén. Cumplían su servicio conforme a su reglamento."
,"18":"Estos son los que ejercían ese ministerio con sus hijos: De los hijos de Quehat: Hemán, el cantor, hijo de Joel, hijo de Samuel, "
,"19":"hijo de Elcaná, hijo de Jerojam, hijo de Eliel, hijo de Tóaj,"
,"20":"hijo de Suf, hijo de Elcaná, hijo de Májat, hijo de Amasay,"
,"21":"hijo de Elcaná, hijo de Joel, hijo de Azarías, hijo de Sofonías,"
,"22":"hijo de Tájat, hijo de Asir, hijo de Ebyasaj, hijo de Coré,"
,"23":"hijo de Jisear, hijo de Quehat, hijo de Leví, hijo de Israel."
,"24":"Su hermano Asaf, que asistía a su derecha: Asaf, hijo de Berequías, hijo de Simá,"
,"25":"hijo de Miguel, hijo de Basías, hijo de Malaquías,"
,"26":"hijo de Etni, hijo de Zéraj, hijo de Adaías,"
,"27":"hijo de Etán, hijo de Zima, hijo de Simí,"
,"28":"hijo de Yájat, hijo de Guersón, hijo de Leví."
,"29":"Los hijos de Merarí, hermanos de ellos, asistían a la izquierda: Etán, hijo de Quisí, hijo de Abadí, hijo de Maluc,"
,"30":"hijo de Asabías, hijo de Amasías, hijo de Ilquías,"
,"31":"hijo de Amasí, hijo de Baní, hijo de Sémer,"
,"32":"hijo de Majalí, hijo de Musí, hijo de Merarí, hijo de Leví."
,"33":"Sus hermanos, los levitas, estaban dedicados al servicio de la morada de la Casa de Dios."
,"34":"Aarón y sus hijos quemaban las ofrendas en el altar del holocausto y en el altar de los perfumes, según todo el servicio de las cosas sacratísimas, y hacían la expiación por todo Israel, conforme a todo cuanto había mandado Moisés, siervo de Dios."
,"35":"Estos son los hijos de Aarón: Eleazar, su hijo; Finjas, su hijo; Abisúa, su hijo;"
,"36":"Buquí, su hijo; Uzí, su hijo; Zerajías, su hijo;"
,"37":"Merayot, su hijo; Amarías, su hijo; Ajitub, su hijo;"
,"38":"Sadoq, su hijo; Ajimas, su hijo."
,"39":"He aquí las residencias según el orden de sus territorios. A los hijos de Aarón, de la familia de los quehatitas -según la suerte cayó para ellos-, "
,"40":"se les dio Hebrón, en la tierra de Judá, con sus pastizales circundantes;"
,"41":"pero el campo de la ciudad y sus aldeas se dieron a Caleb, hijo de Jefunné."
,"42":"Se dio a los hijos de Aarón como ciudades de asilo: Hebrón, Libná con sus pastizales, Jatir con sus pastizales,"
,"43":"Debir con sus pastizales,"
,"44":"Asán con sus pastizales, y Betsemés con sus pastizales. De la tribu de Benjamín: Guebá con sus pastizales, Alémet con sus pastizales y Anatot con sus pastizales."
,"45":"El total de todas sus ciudades: trece ciudades según sus familias."
,"46":"A los otros hijos de Quehat les dieron por sorteo, conforme a sus familias, diez ciudades de la tribu de Efraím, de la tribu de Dan y de la media tribu de Manasés."
,"47":"A los hijos de Guersón, según sus familias, trece ciudades de la tribu de Isacar, de la tribu de Aser, de la tribu de Neftalí y de la tribu de Manasés, en el Basán."
,"48":"A los hijos de Merarí, según sus familias, les tocaron en suerte doce ciudades de la tribu de Rubén, de la tribu de Gad y de la tribu de Zabulón;"
,"49":"los hijos de Israel dieron a los levitas estas ciudades con sus pastizales."
,"50":"De la tribu de los hijos de Judá, de la tribu de los hijos de Simeón y de la tribu de los hijos de Benjamín, les tocaron en suerte las ciudades a las que pusieron sus nombres."
,"51":"En la tribu de Efraím se tomaron ciudades para algunas familias de los hijos de Quehat."
,"52":"Se les asignó como ciudades de asilo: Siquem con sus pastizales, en la montaña de Efraím, Gezer con sus pastizales,"
,"53":"Yoqmean con sus pastizales y Betorón con sus pastizales,"
,"54":"Ayalón con sus pastizales, Gat-Rimón con sus pastizales."
,"55":"Y de la media tribu de Manasés: Aner con sus pastizales, Gat-Rimón con sus pastizales."
,"56":"Para los hijos de Guersón: De las familias de la media tribu de Manasés, Golán, en Basán, con sus pastizales. Astarot con sus pastizales."
,"57":"De la tribu de Isacar, Cadés con sus pastizales, Dobrat con sus pastizales,"
,"58":"Ramot con sus pastizales, Anen con sus pastizales."
,"59":"De la tribu de Aser, Masal con sus pastizales, Abdón con sus pastizales,"
,"60":"Horac con sus pastizales y Rejob con sus pastizales."
,"61":"De la tribu de Neftalí: Cadés en Galilea con sus pastizales, Jammón con sus pastizales y Cariatiarim con sus pastizales."
,"62":"Para los demás hijos de Merarí: De la tribu de Zabulón: Rimmón con sus pastizales y Tabor con sus pastizales."
,"63":"Y en la otra parte del Jordán, frente a Jericó, al oriente del Jordán, de la tribu de Rubén: Béser en el desierto, con sus pastizales, y Yasá con sus pastizales."
,"64":"Quedemot con sus pastizales y Mefat con sus pastizales."
,"65":"De la tribu de Gad: Ramot en Galaad con sus pastizales, Majanaim con sus pastizales,"
,"66":"Hesbón con sus pastizales y Yazer con sus pastizales."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Hijos de Isacar: Tolá, Puá, Yasub, Simrón: cuatro."
,"2":"Hijos de Tolá: Uzí, Refaías, Yeriel, Yajmay, Yibsam y Samuel, jefe de las casas paternas de Tolá. Su número, en los días de David, era, según sus genealogías, de veintidós mil seiscientos, valientes guerreros. Hijos de Uzí: Yizrajías."
,"3":"Hijos de Yizrajías: Miguel, Abdías, Joel, Yisías: en total cuatro jefes."
,"4":"Tenían el cargo según sus genealogías, de mantener tropas de guerra con hombres armados en número de treinta y seis mil; pues tenían muchas mujeres e hijos."
,"5":"Sus hermanos, de todas las familias de Isacar, eran ochenta y siete mil esforzados guerreros, inscritos todos ellos en las genealogías."
,"6":"Hijos de Benjamín: Bela, Béker, Yedaiel: tres."
,"7":"Hijos de Bela: Esbón, Uzí, Uzziel, Yerimot e Irí: cinco jefes de las casas paternas, esforzados guerreros, inscritos en las genealogías en número de veintidós mil treinta y cuatro."
,"8":"Hijos de Béker: Zamirá, Joás, Eliezar, Elyoneay, Omrí, Yeremot, Abías, Anatot y Alemet; todos éstos, hijos de Béker."
,"9":"Estaban inscritos según sus linajes y los jefes de sus casas paternas tenían veinte mil doscientos guerreros esforzados."
,"10":"Hijos de Jedaiel: Bilán. Hijos de Bilán: Jeús, Benjamín, Ehúd, Kemaná, Zefán, Tarsís y Ajisajar."
,"11":"Todos éstos fueron hijos de Jedaiel, cabezas de familia, esforzados guerreros, en número de diecisiete mil doscientos, aptos para la milicia y la guerra."
,"12":"Supim y Jupim, hijos de Ir; Jusin, otro hijo suyo."
,"13":"Hijos de Neftalí: Jaijasiel, Gumí, Jeser, Salum, hijos de Bilá."
,"14":"Hijos de Manasés: Asriel, que le dio a luz su concubina aramea. Esta le dio también a luz a Maquir, padre de Galaad."
,"15":"Maquir tomó una mujer para Jupim y para Supim, y el nombre de su hermana era Maaca. El nombre del segundo era Selofjad; Selofjad tuvo hijas:"
,"16":"Maaca, mujer de Maquir, dio a luz un hijo, a quien llamó Fares. Su hermano se llamaba Seres y sus hijos Ulam y Requem."
,"17":"Hijos de Ulam: Bedan. Estos son los hijos de Galaad, hijo de Maquir, hijo de Manasés."
,"18":"Su hermana, Amoleket, dio a luz a Isjod, Abiézer y Majlá."
,"19":"Los hijos de Semidá fueron: Ajyam, Sique, Liqjí y Anian."
,"20":"Hijos de Efraím: Sutélaj, Bered, su hijo; Tájat, su hijo; Zabad, su hijo; Sutélaj, su hijo; Ezer y Elad."
,"21":"A estos dos los hombres de Gat los mataron, pues habían bajado a apoderarse de sus ganados."
,"22":"Su padre Efraím los lloró durante muchos días y sus hermanos vinieron a consolarlo."
,"23":"Después se unió a su esposa, que quedó embarazada y le dio un hijo, a quien llamó Beriá, porque la desgracia estaba en su casa."
,"24":"Hija suya fue Será, que edificó Betorón de arriba y de abajo y Ulen-Será."
,"25":"Refaj, hijo suyo; Resef, hijo suyo; Telaj, hijo suyo; Tajan, hijo suyo;"
,"26":"Laedán, hijo suyo; Ammihud, hijo suyo; Elisamá, hijo suyo;"
,"27":"Nun, hijo suyo; Josué, hijo suyo."
,"28":"Tenían propiedades y habitaban en Betel y sus aldeas anexas, en Narán, hacia el oriente, en Guézer y sus aldeas anexas, hacia el occidente, en Siquem y sus aldeas, hasta Acyá y sus aldeas."
,"29":"Y en manos de los hijos de Manasés estaban Betsan y sus aldeas anexas, Meguidó y sus aldeas, Dor y sus aldeas. En ellas habitaron los hijos de José, hijo de Israel."
,"30":"Hijos de Aser: Yimmá, Yisvá, Yisví, Beriá, y Seraj, hermana de éstos."
,"31":"Hijos de Beriá:"
,"32":"Jéber y Malkiel, el cual fue padre de Birzavit. Jeber engendró a Jaflet, Semer, Jotam y Suá, hermana de ellos."
,"33":"Hijos de Jaflet: Pasak, Zimhal y Asvat. Estos son los hijos de Jaflet."
,"34":"Hijos de Semer: Ají, Roegá, Jubá y Aran."
,"35":"Hijos de Hélem, su hermano: Sofaj, Yimmá, Seles y Amal."
,"36":"Hijos de Sofaj: Suaj, Jarnefer, Sual, Berí y Yimrá;"
,"37":"Béser, Hob, Sammá, Silsá, Yitrán y Beerá."
,"38":"Hijos de Yeter: Yefunné, Pispá y Ará."
,"39":"Hijos de Ulá: Araj, Janiel y Risías."
,"40":"Todos éstos fueron hijos de Aser, jefes de familia, gente escogida, esforzados guerreros, jefes de príncipes. En los registros genealógicos estaban inscritos en número de veintiséis mil hombres, aptos para la milicia y la guerra."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Benjamín engendró a Bela, su primogénito; Asbel, el segundo; Ajram, el tercero;"
,"2":"Nojá, el cuarto, y Rafá, el quinto."
,"3":"Los hijos de Bela fueron: Addar y Guerá, padre de Ehúd,"
,"4":"Abisúa, Namán, Ajoaj,"
,"5":"Guerá, Sefufán y Juram."
,"6":"Estos son los hijos de Ehúd, los jefes de familia de los que moraban en Guebá y a los que deportaron a Manájat:"
,"7":"Namán, Ajías y Guerá. Este los deportó y engendró a Uzá y Ajud."
,"8":"Sajaraim tuvo dos hijos cuando estaba en los campos de Moab, después de haber despedido a sus mujeres Jusim y Bará."
,"9":"Y de su mujer Odés engendró Jobab, Sibías, Mesá, Malkom,"
,"10":"Jeus, Sakías y Mirmá. Estos son sus hijos, jefes de casas paternas."
,"11":"Y de Jusim tuvo dos hijos: a Abitub y Elpaal."
,"12":"Hijos de Elpaal: Heber, Misam y Semed, el cual edificó Onó, Luc y sus aldeas anexas."
,"13":"Beriá y Sema fueron cabezas de familia de los habitantes de Ayalón, que pusieron en fuga a los moradores de Gat."
,"14":"Ajio: Sesaq, Yemerot,"
,"15":"Zebadías, Arad, Eder,"
,"16":"Miguel, Yispá, Yojá; eran hijos de Beraí."
,"17":"Zebadías, Mesulam, Jizquí, Jáber,"
,"18":"Yismeray, Yislías y Yoab, hijos de Elpaal."
,"19":"Juaquim, Zikri, Zabdí,"
,"20":"Elienay, Siletay, Eliel,"
,"21":"Adaías, Beraías y Simrat, hijos de Simi."
,"22":"Jispán, Héber, Eliel,"
,"23":"Abdón, Zikri, Janán,"
,"24":"Jananías, Elam, Anatotía,"
,"25":"Jifdías y Penuel: hijos de Sesaq."
,"26":"Samseray, Sejarías, Atalías,"
,"27":"Jarsías, Elías y Zikrí: hijos de Yerojam."
,"28":"Estos eran los jefes de las casas paternas, según sus linajes, que habitaban en Jerusalén."
,"29":"En Gabaón habitaba Yoel, padre de Gabaón, cuya esposa se llamaba Maacá,"
,"30":"su hijo primogénito: Abdón, después Sur, Quis, Baal, Ner, Nadab,"
,"31":"Guedor, Akyó, Zaker."
,"32":"Miclot engendró a Simá. También éstos habitaron, igual que sus hermanos, en Jerusalén."
,"33":"Ner fue padre de Quis; éste de Saúl, éste de Jonatán, Malquisúa, Abinadab e Isbaal."
,"34":"Jonatán fue padre de Meribaal, éste de Mica,"
,"35":"éste de Pitón, Melec, Tacrea, Ajaz."
,"36":"Este fue padre de Jedada, éste de Alemet, Azmanet y Zinri, éste de Mosa,"
,"37":"éste de Bina, éste de Rafá, éste de Elasa, éste de Asel."
,"38":"Este tuvo seis hijos: Azricam, Bocri, Ismael, Searías, Abdías y Janán. Todos éstos fueron hijos de Asel."
,"39":"Su hermano Esec fue padre de Ulam, su primogénito, Jeus y Elifelet."
,"40":"Los hijos de Ulam eran valientes guerreros y manejaban el arco. Tuvieron numerosos hijos y nietos: ciento cincuenta. Todos éstos eran de los hijos de Benjamín."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Todos los israelitas estaban registrados en las genealogías e inscritos en el Libro de los Reyes de Israel. En cuanto a los de Judá, fueron deportados a Babilonia por sus infidelidades de la Ley."
,"2":"Los primeros que volvieron a habitar en sus propiedades y ciudades fueron israelitas, sacerdotes, levitas y donados."
,"3":"En Jerusalén habitaron hijos de Judá, hijos de Benjamín, hijos de Efraím y de Manasés."
,"4":"De los hijos de Judá, Utay, hijo de Amihúd, hijo de Omrí, hijo de Imrí, hijo de Baní, de los hijos de Peres, hijo de Judá."
,"5":"De los selanitas: Asaías, el primogénito, y de sus hijos."
,"6":"De los hijos de Zéraj: Seuel y sus hermanos: seiscientos noventa."
,"7":"De los hijos de Benjamín: Salu, hijo de Mesulam, hijo de Hodavías, hijo de Hasenúa;"
,"8":"Jibneías, hijo de Jerojam; Elá, hijo de Uzí, hijo de Mikrí, y Mesulam, hijo de Sefatía, hijo de Reuel, hijo de Jibnías,"
,"9":"y sus hermanos, según sus genealogías: novecientos cincuenta y seis. Todos éstos eran jefes de familias en sus respectivas casas paternas."
,"10":"De los sacerdotes: Jedaías, Jehoyarib, Juaquim,"
,"11":"Azarías, hijo de Hilquías, hijo de Mesulam, hijo de Sadoc, hijo de Merayot, hijo de Ajitub, príncipe de la Casa de Dios."
,"12":"Adaías, hijo de Jerojam, hijo de Pasjur, hijo de Malkías; Hasay, hijo de Adiel, hijo de Yajzerá, hijo de Mesulam, hijo de Mesilemit, hijo de Immer;"
,"13":"y sus hermanos, jefes de sus casas paternas: mil setecientos sesenta hombres aptos para los ejercicios del culto de la Casa de Dios."
,"14":"De los levitas: Semaías, hijo de Jasub, hijo de Azricam, hijo de Jazabías, de los hijos de Merarí,"
,"15":"Baqbacar, Heras, Galal y Matanías, hijo de Micá, hijo de Zikrí, hijo de Asaf;"
,"16":"Abdías, hijo de Semaías, hijo de Galal, hijo de Jedutún; y Berekías, hijo de Asá, hijo de Elcaná, que habitaban en los poblados de los netofatíes."
,"17":"Los porteros: Salum, Acub, Talmón, Ajimán y sus hermanos."
,"18":"Salum era el jefe; y están hasta el presente junto a la puerta del rey, al oriente; éstos son los porteros del campamento de los hijos de Leví."
,"19":"Salum, hijo de Coré, hijo de Ebiasaf, hijo de Coré, y sus hermanos los coreítas, de la misma casa paterna, tenían el servicio de culto como guardianes de los umbrales de la Tienda, pues sus padres habían tenido a su cargo la guardia de acceso al campamento de Yavé."
,"20":"Antiguamente su jefe había sido Finjas, hijo de Eleazar, con el que estaba Yavé."
,"21":"Zacarías, hijo de Meselemías, era portero de la entrada de la Tienda de Reunión."
,"22":"El total de esos hombres escogidos para porteros era de doscientos doce, y estaban inscritos en sus poblados. David y Samuel el vidente los habían establecido en sus cargos permanentes."
,"23":"Tanto ellos como sus hijos tenían a su cargo las puertas de la Casa de Yavé, la Casa de la Tienda."
,"24":"Había porteros a los cuatro vientos; al oriente, al occidente, al norte y al mediodía."
,"25":"Sus hermanos, que habitaban en poblados, tenían que venir periódicamente a estar con ellos durante siete días,"
,"26":"porque los cuatro jefes de los porteros eran permanentes; algunos levitas estaban al cuidado de las cámaras y de los tesoros de la Casa de Dios."
,"27":"Pasaban la noche alrededor de la Casa de Dios, pues les incumbía su vigilancia y tenían las llaves para abrirlas todas las mañanas."
,"28":"Unos tenían el cuidado de los utensilios del culto, y los contaban al meterlos y al sacarlos."
,"29":"Otros estaban encargados de los utensilios y de todos los instrumentos del Santuario, de la flor de harina, el vino, el aceite, el incienso y los aromas."
,"30":"Pero los que hacían la mezcla para los aromas eran sacerdotes."
,"31":"Matatías, uno de los levitas, primogénito de Salum el coreíta, estaba al cuidado constante de las cosas que se freían en sartén."
,"32":"Y entre sus hermanos estaban los hijos de Quehatitas, que estaban encargados de poner en fila los panes de cada sábado."
,"33":"Ellos eran también cantores, cabezas de familia de los levitas y moraban aparte en las habitaciones de la Casa, pues se ocupaban de día y de noche en su ministerio."
,"34":"Estos son, según sus genealogías, los cabezas de familia de los levitas, jefes de sus linajes que habitaban en Jerusalén."
,"35":"En Gabaón vivían el padre de Gabaón, Jeuel, cuya esposa se llamaba Maacá,"
,"36":"y su hijo primogénito Abdán. Después, Sur, Quis, Baal, Ner, Nadab,"
,"37":"Guedor, Ajyó, Zacarías y Miclot. Miclot engendró a Simam."
,"38":"También éstos habitaron en Jerusalén junto a sus hermanos a instigación de éstos."
,"39":"Ner fue padre de Quis, éste de Saúl, éste de Jonatán, Malquisua, Abinadab e Isbaal."
,"40":"Jonatán fue padre de Meribaal y éste de Mica."
,"41":"Mica fue padre de Piton, Melec, Tacrea y Ajaz."
,"42":"Este fue padre de Yara, éste de Alemet, Azmavet y Zimrí; éste fue padre de Mosa"
,"43":"y éste de Bina, éste de Refaías, éste de Elasa, éste de Asel."
,"44":"Asel tuvo seis hijos, cuyos nombres son: Azricam, su primogénito, Ismael, Searías, Obdías y Janán. Estos fueron los hijos de Asel."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Los filisteos pelearon contra Israel; huyeron los hombres de Israel ante los filisteos, y cayeron heridos de muerte en el monte Gelboé."
,"2":"Los filisteos apretaron de cerca a Saúl y a sus hijos, y mataron a Jonatán, Abinadab y Malquisua, hijos de Saúl."
,"3":"El peso de la batalla cargó sobre Saúl, los arqueros lo descubrieron y fue herido por ellos."
,"4":"Saúl dijo a su escudero: 'Saca tu espada y traspásame con ella; no sea que vengan esos incircuncisos y se burlen de mí.' Pero el escudero no quiso, pues estaba lleno de temor. Entonces tomó Saúl la espada y se arrojó sobre ella. "
,"5":"Viendo el escudero que Saúl había muerto se arrojó también él sobre su espada y murió."
,"6":"Así murió Saúl con sus tres hijos; y toda su gente murió juntamente con él."
,"7":"Todos los hombres de Israel, que estaban en el valle, vieron que las tropas de Israel se daban a la fuga y que Saúl y sus hijos habían muerto. Entonces abandonaron sus ciudades y huyeron; vinieron los filisteos y se establecieron en ellas."
,"8":"Al otro día vinieron los filisteos para despojar a los muertos, y encontraron a Saúl y a sus hijos caídos en el monte Gelboé."
,"9":"Despojándolo, se llevaron su cabeza y sus armas, y mandaron anunciar la buena nueva por todo el país de los filisteos, en medio de sus ídolos y de toda su gente."
,"10":"Depositaron las armas de Saúl en el templo de sus dioses y clavaron su cráneo en el templo de Dagón."
,"11":"Todos los habitantes de Jabés de Galaad supieron lo que los filisteos habían hecho con Saúl,"
,"12":"se levantaron todos los valientes, tomaron el cadáver de Saúl y los de sus hijos, y los llevaron a Jabés. Enterraron sus huesos bajo el terebinto de Jabés, y ayunaron siete días."
,"13":"Saúl murió a causa de la infidelidad que había cometido contra Yavé, porque no guardó la palabra de Yavé, y también por haber interrogado y consultado a los espiritistas."
,"14":"No consultó a Yavé, por lo que éste lo hizo morir, y transfirió el reino a David, hijo de Jesé."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Todo Israel se congregó en torno a David, en Hebrón, y le dijeron: 'Somos nosotros de tu carne y de tus huesos."
,"2":"Ya antes, cuando Saúl era nuestro rey, eras tú el que dirigía a Israel; Yavé, tu Dios, te ha dicho: Tú apacentarás a mi pueblo Israel, tú serás el jefe de mi pueblo Israel.'"
,"3":"Vinieron todos los jefes de Israel a donde el rey, a Hebrón; David hizo allí un pacto con ellos en presencia de Yavé y ellos lo ungieron como rey de Israel, según la palabra que Yavé había pronunciado por boca de Samuel."
,"4":"David marchó con todo Israel, contra Jerusalén, o sea Jebús."
,"5":"Los habitantes del país eran los jebuseos, y decían a David: 'No entrarás aquí.' Pero David se apoderó de la fortaleza de Sión, que es la ciudad de David."
,"6":"Dijo David: 'El que primero ataque a los jebuseos, ése será jefe y príncipe.',Subió el primero Joab, hijo de Sarvia, y pasó a ser jefe. "
,"7":"Se instaló David en la fortaleza; por esto la llamaron ciudad de David."
,"8":"Edificó alrededor de la ciudad desde el valle del Milo hasta el otro extremo. Joab reparó el resto de la ciudad."
,"9":"David iba creciendo de día en día y Yavé Sebaot estaba con él."
,"10":"Estos son los jefes de los valientes de David que, durante todo su reino, se esforzaron con él y con todo Israel para que reinara según la palabra dicha por Yavé, respecto a Israel."
,"11":"Esta es la lista de los héroes de David: Isbaal, hijo de Jakmoní, jefe de los tres que con su lanza mató a trescientos en una sola batalla."
,"12":"Después de él, Eleazar, hijo de Dodó, el ajojita, que era uno de los tres héroes."
,"13":"Este estaba con David en Pas Dammim, donde los filisteos se habían concentrado para la batalla. Había allí una parcela toda de cebada, y el pueblo estaba huyendo de los filisteos."
,"14":"El, Eleazar, se mantuvo firme en medio de la parcela, la defendió y derrotó a los filisteos. Yavé obró allí una gran victoria."
,"15":"Tres de los Treinta bajaron al principio de la siega a la cueva de Adullam, donde estaba David, mientras los filisteos se hallaban acampados en el valle de los Rafaím."
,"16":"Estando, pues, David en la cueva, una guarnición de filisteos ocupaba Belén."
,"17":"Le vino entonces a David un deseo y dijo: 'Quién me diera a beber agua de la cisterna que hay en la puerta de Belén.'"
,"18":"Al punto estos tres irrumpieron en medio del campamento de los filisteos, sacaron agua de la cisterna que hay en la puerta de Belén, se la llevaron y se la ofrecieron a David. Pero David no quiso beberla, sino que la derramó en el suelo y la ofreció a Yavé, diciendo:"
,"19":"'No quiera Dios que yo haga tal cosa, no voy yo a beber esta agua, pues sería beber la sangre de estos hombres, ya que la trajeron arriesgando su vida.' No quiso beberla. Esto es lo que hicieron los tres héroes."
,"20":"Abisay, hermano de Joab, era el jefe de los Treinta. Hirió con su lanza a trescientos hombres y conquistó renombre entre los Treinta."
,"21":"Fue el más famoso de los Treinta, llegando a ser su capitán, pero no igualó a los tres."
,"22":"Benaías, hijo de Yoyada, hombre valeroso y autor de grandes hazañas, natural de Cabseel, mató a los dos hijos de Ariel de Moab; además bajó y mató a un león dentro de una cisterna, en un día de nieve."
,"23":"Mató también a un egipcio que tenía cinco codos de altura; el egipcio tenía en su mano una lanza del tamaño de un enjullo de telar. Arremetió contra él con un palo, le arrebató la lanza que tenía en la mano, y con la misma lo mató."
,"24":"Esto hizo Banaías, hijo de Yoyada, y se conquistó gran fama entre los treinta héroes."
,"25":"Fue muy famoso entre los Treinta, pero no igualó a los Tres. David lo admitió en su guardia personal."
,"26":"Los héroes valientes fueron: Azael, hermano de Joab; Elkanan, hijo de Dodó, natural de Belén;"
,"27":"Sammot, de Harod; Jeles, de Pelet;"
,"28":"Irá, hijo de Iques, de Tecoa; Abiezer, de Anatot;"
,"29":"Sibeka, de Jusá; Ilay, el ajojita;"
,"30":"Mahray, de Netofá; Jéled, hijo de Baaná, de Netofá;"
,"31":"Itai, hijo de Ribay, de Guibea, de los hijos de Benjamín; Benaías, de Piraton;"
,"32":"Juray, de los torrentes de Gas; Abiel, el arbatita;"
,"33":"Azmavet, de Bajurim; Elyajabá, de Saalbón;"
,"34":"los hijos de Gasem el guisonita; Jonatán, hijo de Sagué, de Haror;"
,"35":"Ajiam, hijo de Sakar, el haratita; Elifal, hijo de Ur;"
,"36":"Efer, de Mekerá; Ajías, de Giloh;"
,"37":"Jesró, de Carmelo; Naray, hijo de Esbay;"
,"38":"Joel, hermano de Natán; Mibjar, hijo de Agrí;"
,"39":"Seleq, el amonita; Najraí, de Berot, escudero de Joab, hijo de Salvia;"
,"40":"Irá, de Yatir; Gareb, de Yatir;"
,"41":"Urías, el heteo. Zabad, hijo de Ajlay; "
,"42":"Adina, hijo de Sizá, el rubenita, jefe de los rubenitas, y con él treinta;"
,"43":"Janan, hijo de Maaká, Josafat, el mitnita;"
,"44":"Uzías, de Astarot; Sama y Yoel, hijos de Jotam, de Aroer;"
,"45":"Jediael, hijo de Simrí; Joya, su hermano, el tisita;"
,"46":"Eliel, el majavita; Yeribay y Yosabías, hijos de Elanam, Yitmá, el moabita;"
,"47":"Eliel, Obde y Yasiel, de Sobá."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Estos son los que vinieron a juntarse con David, en Siquelag, mientras se mantenía alejado de Saúl, hijo de Quis; estaban entre los guerreros de refuerzo para los combates."
,"2":"Manejaban el arco y la honda lo mismo con la derecha que con la izquierda para tirar flechas y lanzar piedras. De los hermanos de Saúl, el benjaminita: "
,"3":"Ajiezer, el jefe y Joás, hijos de Semá, de Guibeá; Jeziel y Pélet, hijos de Azmavet; Bereká y Jehú, de Anatot;"
,"4":"Jismaías, de Gabaón, valeroso como los Treinta y tal vez más que ellos;"
,"5":"Jeremías, Jajaziel, Yojanan, Yozabed, de Guederot;"
,"6":"Eluzay, Jerimot, Bealías, Semerías, y Sefatías, de Jafir; Elcaná, Jisjiva, Azarel."
,"7":"Yoézer, Yasobam, los coeritas:"
,"8":"Joel y Zebadías, hijos de Jerojam de Guedor."
,"9":"Hubo también gaditas que se pasaron a David cuando éste estaba en su refugio en el desierto, guerreros valientes, hombres de guerra, diestros con el escudo y la lanza, sus rostros como el león y ligeros como la gacela salvaje."
,"10":"Su jefe era Ezer; Obdías el segundo; Eliab, el tercero;"
,"11":"Mismaná, cuarto; Jeremías, el quinto;"
,"12":"Atay, el sexto; Eliel, el séptimo;"
,"13":"Yojanán, el octavo; Elzabad, el noveno;"
,"14":"Jeremías, el décimo; Makbanay, el undécimo;"
,"15":"éstos eran, entre los hijos de Gad, jefes del ejército; el que menos, valía por cien hombres y el que más, valía por mil."
,"16":"Estos fueron los que atravesaron el Jordán en el primer mes, cuando suele desbordarse por todas sus riberas, y pusieron en fuga a todos los habitantes de los valles, a oriente y occidente. También vinieron al escondite donde estaba David"
,"17":"algunos de los hijos de Benjamín y Judá."
,"18":"David se presentó delante de ellos y les dijo: 'Si vienen a mí en son de paz para ayudarme, mi corazón se unirá con el de ustedes; pero si es para engañarme y ayudar a mis enemigos, puesto que yo tengo las manos limpias de todo pecado, el Dios de nuestros padres sea testigo y juez.'"
,"19":"Entonces el Espíritu estuvo sobre Amasías, jefe de los Treinta; dijo: 'Tuyos somos, oh David, y contigo estamos, oh hijo de Jesé; paz, paz a ti; y paz a quienes te ayuden; ya que a ti te defiende tu Dios.' David los recibió y los hizo jefes de sus tropas."
,"20":"También de Manasés se pasaron algunos a David, cuando éste iba con los filisteos al combate contra Saúl, si bien no peleó al lado de ellos; porque los príncipes de los filisteos después de haberlo hablado entre ellos, lo hicieron volver, diciendo: 'A costa de nuestra vida, este hombre se reconciliará con Saúl su señor.'"
,"21":"Cuando regresó a Siquelag, se unieron a él algunos de los hijos de Manasés: Adná, Yazaba, Jediael, Miguel, Yozabad, Elihú y Siletay, jefes de millares de Manasés."
,"22":"Estos ayudaron a David al frente de sus banderas, pues todos eran hombres valientes, y llegaron a ser jefes en el ejército."
,"23":"Cada día, en efecto, acudía gente a David para ayudarlo, hasta que el campamento llegó a ser grande, como un campamento de Dios."
,"24":"Este es el número de los guerreros preparados para la guerra que vinieron donde David, a Hebrón, para transferirle el reino de Saúl, conforme a la orden de Yavé."
,"25":"De los hijos de Judá, llevando escudo y lanza, seis mil ochocientos, armados para la guerra."
,"26":"De los hijos de Simeón, hombres valerosos para la guerra, siete mil cien."
,"27":"De los hijos de Leví, cuatro mil seiscientos"
,"28":"y también Jehoyadá, príncipe de los hijos de Aarón, con otros tres mil setecientos."
,"29":"Sadoc, joven y valeroso, con los veintidós jefes de su casa paterna."
,"30":"De los hijos de Benjamín, hermano de Saúl, tres mil: hasta entonces la mayor parte de ellos había permanecido fiel a la familia de Saúl."
,"31":"De los hijos de Efraím, veinte mil ochocientos hombres valientes, famosos en sus casas paternas."
,"32":"De la media tribu de Manasés, dieciocho mil, nominalmente designados para ir a proclamar rey a David."
,"33":"De los hijos de Isacar, expertos en distinguir las oportunidades y saber lo que Israel debía hacer, doscientos jefes, y todos sus hermanos bajo sus órdenes."
,"34":"De Zabulón, cincuenta mil, aptos para salir a campaña, ejercitados en todas las armas de guerra, que se ordenaban con resolución."
,"35":"De Neftalí, mil jefes, y con ellos treinta y siete mil hombres con escudo y lanza."
,"36":"De los danitas, preparados para la batalla, veintiocho mil seiscientos."
,"37":"De Aser, aptos para salir a campaña y preparados para la batalla, cuarenta mil."
,"38":"Y de Transjordania, de los rubenitas, de los gaditas y de la media tribu de Manasés, provistos de todos los pertrechos de guerra para la batalla, ciento veinte mil."
,"39":"Todos estos hombres listos para el combate vinieron espontáneamente a Hebrón a proclamar a David rey de todo Israel; y los demás israelitas estaban unánimes en hacer rey a David."
,"40":"Permanecieron allí con David tres días comiendo y bebiendo, porque sus hermanos les habían preparado víveres."
,"41":"Además, de los pueblos vecinos e incluso de Isacar, Zabulón y Neftalí, traían comida, en burros, camellos, mulos y bueyes; provisiones de harina, tortas de higo y pasas, vino, aceite, ganado mayor y menor en abundancia, pues reinaba la alegría en Israel."
}`)
	CurrentBook.AddChapter(13, `{
"1":"David consultó con los jefes de millar y cien y con todos los oficiales."
,"2":"Luego dijo a toda la asamblea de Israel: 'Si les parece bien y la cosa conviene a Yavé, nuestro Dios, vamos a mandar un mensaje a nuestros hermanos que han quedado en todas las regiones de Israel y, además, a los sacerdotes y levitas en sus ciudades y aldeas, para que se reúnan con nosotros;"
,"3":"y volvamos a traer a nuestro lado el Arca de nuestro Dios, ya que no nos hemos preocupado por ella en tiempos de Saúl."
,"4":"Toda la asamblea acordó hacerlo así, pues la propuesta pareció bien a todo el pueblo."
,"5":"David entonces congregó a todo Israel, desde Sijor de Egipto hasta la entrada de Jamat, para traer el Arca de Yavé desde Cariatiarim."
,"6":"Subió, pues, David con todo Israel, hacia Baalá, a Cariatiarim de Judá, para subir de allí el Arca de Dios que lleva el Nombre de Yavé que está sobre los querubines."
,"7":"Cargaron el Arca de Yavé en una carreta nueva, y se la llevaron de la casa de Abinadab; Uzzá y Ajyó conducían la carreta."
,"8":"David y todo Israel bailaba delante de Yavé con todas sus fuerzas, cantando y tocando cítaras, salterios y panderos, címbalos y trompetas."
,"9":"Al llegar a la era de Quidom, Uzzá extendió su mano para sostener el Arca, porque los bueyes amenazaban volcarla."
,"10":"Yavé se enojó contra Uzzá y lo hirió por haber tocado el Arca, cayendo muerto allí delante de Dios."
,"11":"David se enojó porque Yavé había castigado a Uzzá; y se llamó aquel lugar Peres Uzzá hasta el día de hoy."
,"12":"David tuvo miedo aquel día a Yavé y dijo: '¿Cómo voy a llevar a mi casa el Arca de Dios?'"
,"13":"Por eso no la llevó a su casa, a la ciudad de David, sino que la hizo llevar a la casa de Obededom de Gat."
,"14":"El Arca de Dios habitó tres meses en la casa de Obededom y Yavé hizo prosperar su casa y cuanto tenía."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Hiram, rey de Tiro, envió a David mensajeros y maderas de cedro y también albañiles y carpinteros para edificarle una casa."
,"2":"Entonces David conoció que Yavé lo había confirmado como rey de Israel, ya que su reino había sido ensalzado a causa de Israel, su pueblo."
,"3":"David tomó por esposas otras mujeres en Jerusalén y tuvo más hijos e hijas."
,"4":"Estos son los nombres de los que tuvo en Jerusalén: Samúa, Sobad, Natán, Salomón,"
,"5":"Gibjar, Elisúa, Elfalet,"
,"6":"Nogah, Nefec, Yafia,"
,"7":"Elisamá, Baalyadá y Elifelet."
,"8":"Cuando los filisteos supieron que David había sido ungido rey sobre todo Israel, subieron todos a buscarlo. David se enteró y les salió al paso."
,"9":"Los filisteos, siguiendo su marcha, extendieron sus tropas por el valle de Rafaim."
,"10":"Entonces David consultó a Yavé diciendo: '¿Acaso debo atacar a los filisteos y me los entregarás en mis manos?'"
,"11":"Yavé le respondió: 'Sube, pues yo los entregaré en tus manos.' Los filisteos avanzaron hasta Baalfarasim y allí los derrotó David y dijo: 'Yavé ha disipado por mi mano a los enemigos, como se disipan las aguas.' Y por esto se llamó aquel lugar Baalfarasim."
,"12":"Los filisteos abandonaron allí sus ídolos, que fueron arrojados al fuego por orden de David."
,"13":"Nuevamente los filisteos invadieron el valle y, de nuevo,"
,"14":"David consultó a Yavé, el cual le contestó: 'No subas detrás de ellos sino que das un rodeo y les vienes al encuentro por el lado donde están los árboles que dan bálsamo,"
,"15":"y cuando escuches el ruido como de alguien que anda por la copa de los árboles, entonces darás la batalla, porque Yavé va delante de ti para derrotar al ejército de los filisteos.'"
,"16":"David hizo como le había mandado Yavé y persiguió a los filisteos desde Gabaón hasta Guezer."
,"17":"La fama de David se extendió por todas las regiones, pues Yavé difundía su terror sobre todas las naciones."
}`)
	CurrentBook.AddChapter(15, `{
"1":"David se hizo casas en la Ciudad de David, preparó un lugar para el Arca y le levantó una tienda de campaña."
,"2":"Entonces dijo David: 'Solamente los levitas llevarán el Arca, pues a ellos los escogió Yavé para llevarla y servirle a él para siempre.'"
,"3":"David, pues, congregó a todo Israel en Jerusalén para subir el Arca de Yavé al lugar que había preparado para ella."
,"4":"David reunió también a los hijos de Aarón y a los levitas."
,"5":"De los hijos de Quehat: a Uriel, el jefe y a sus hermanos, ciento veinte;"
,"6":"de los hijos de Merarí: a Asaías, el jefe y a sus hermanos, doscientos veinte;"
,"7":"de los hijos de Guersom, a Joel, el jefe y a sus hermanos, ciento treinta; de los hijos de Elisafán:"
,"8":"a Semaías, el jefe y sus hermanos, doscientos;"
,"9":"de los hijos de Hebrón a Eliel, el jefe y sus hermanos, ochenta;"
,"10":"de los hijos de Uziel: a Aminadab, el jefe y a sus hermanos, ciento doce."
,"11":"También llamó David a los sacerdotes Sadoq y Abiatar y a los levitas Uriel, Asaías, Semanías, Eliel y Aminadab"
,"12":"y les dijo: 'Ustedes son los cabezas de familia de los levitas. Santifíquense ustedes y sus hermanos, para subir el Arca de Yavé, el Dios de Israel, al lugar que para ella tengo preparado;"
,"13":"pues Yavé, nuestro Dios, nos castigó cuando, en su ausencia, no lo consultamos según está establecido.'"
,"14":"Se santificaron, pues, los sacerdotes y levitas, para subir el Arca de Yavé, Dios de Israel."
,"15":"Luego los levitas trasladaron a hombros el Arca de Yavé, como lo había ordenado Moisés, según la palabra de Yavé, llevando las varas sobre los hombros."
,"16":"David dijo a los jefes de los levitas que dispusieran a sus hermanos, los cantores, con instrumentos musicales, salterios y címbalos para que los hicieran resonar, con voz de júbilo."
,"17":"Los levitas designaron a Hemán, hijo de Joel; y de sus hermanos, a Asaf, hijo de Berekías; y de los hijos de Merarí, hermanos suyos, a Etán, hijo de Quisaías."
,"18":"Con ellos a sus hermanos de segundo orden: Zacarías, Aziel, Semiramot, Jejiel, Uní, Eliab, Bananías, Maseías, Matatías, Elifele, Micneas, Obededom y Jeiel, porteros."
,"19":"Los cantores Heman, Asaf y Etam hacían resonar címbalos de bronce."
,"20":"Zacarías, Uziel, Semiramot, Jejiel, Uní, Eliab, Maseías y Benaías tenían arpas de tonos bajos."
,"21":"Matatías, Elifele, Micneas, Obededom, Jeiel y Ozazías tenían cítaras de tonos altos para dirigir el canto."
,"22":"Kenonías, jefe de los levitas, dirigía el traslado, porque era hombre entendido en esas cosas."
,"23":"Berekías y Elcaná eran porteros del Arca."
,"24":"Sebanías, Josafat, Nataniel, Amasay, Zacarías, Benaías y Eliezer, sacerdotes, tocaban las trompetas delante del Arca de Dios. Obededom y Jejías eran porteros del arca."
,"25":"Así, pues, David, los ancianos de Israel y los jefes militares fueron a traer el Arca de la Alianza de Yavé, desde la casa de Obededom a Jerusalén con gran fiesta y alegría."
,"26":"Y mientras Dios ayudaba a los levitas portadores del Arca de Yavé, sacrificaron siete terneros y siete carneros."
,"27":"David iba revestido de una manta de lino fino, lo mismo que todos los levitas que portaban el Arca, los cantores y Kenonías, el jefe que dirigía el traslado. También David llevaba un efod de lino. "
,"28":"Todo Israel subía el Arca de Yavé entre clamores y resonar de cuernos, con trompetas y címbalos y haciendo sonar los salterios y las cítaras."
,"29":"Cuando el Arca de la Alianza de Yavé entró en la ciudad de David, Micol, hija de Saúl, estaba mirando por una ventana; vio al rey David que saltaba y lo despreció en su corazón."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Trajeron el Arca de Yavé y la colocaron en medio de la tienda que David había hecho levantar para ella; y ofrecieron ante Dios víctimas quemadas y sacrificios de comuniones."
,"2":"Cuando David hubo acabado de ofrecer las víctimas consumidas por el fuego y los sacrificios de comunión, bendijo al pueblo en nombre de Yavé,"
,"3":"y repartió a todo el pueblo de Israel, hombres y mujeres, a cada uno, una torta de pan, una porción de carne asada y un pastel de pasas."
,"4":"David estableció delante del Arca de Yavé a los levitas, cuyo servicio sería celebrar, glorificar y alabar a Yavé, Dios de Israel."
,"5":"Asaf era el jefe; Zacarías era el segundo; luego Uziel, Semiramot, Jejiel, Matatías, Eliab, Benaías, Obededom y Jeiel con sus instrumentos, salterios y cítaras. Asaf hacía sonar los címbalos."
,"6":"Los sacerdotes Benaías y Yajaziel tocaban sin interrupción las trompetas delante del Arca de la Alianza de Dios."
,"7":"Aquel día David estableció por primera vez que Yavé sería alabado por medio de Asaf y sus hermanos en la forma siguiente:"
,"8":"Celebren al Señor, alaben su nombre, proclamen sus maravillas a todo el mundo."
,"9":"Entónenle cantos y que todos mediten sus prodigios."
,"10":"Que su santo Nombre sea nuestro orgullo. Que se llenen de alegría los que buscan al Señor."
,"11":"Piensen en el Señor y en su poder, busquen siempre su mirada."
,"12":"Recuerden cuántas maravillas ha obrado, sus prodigios y sus decisiones."
,"13":"Descendientes de Israel su siervo; hijos de Jacob, su elegido."
,"14":"El Señor en persona es nuestro Dios, sus sentencias abarcan toda la tierra."
,"15":"Recuerda eternamente su alianza, la promesa que hizo a tantas generaciones."
,"16":"El pacto conseguido con Abraham, el juramento que hizo a Isaac."
,"17":"Para que fuera la ley de Jacob su alianza eterna con Israel."
,"18":"Cuando le dijo: Te daré la tierra de Canaán como parte de tu herencia."
,"19":"Cuando aún eran muy pocos y escasos y forasteros en esa tierra."
,"20":"Iban como peregrinos de pueblo en pueblo y emigraban de una nación a otra."
,"21":"No consintió que nadie los maltratara y por ellos castigó a los reyes."
,"22":"Diciéndoles: No toquen a mis elegidos, ni hagan daño a mis profetas."
,"23":"Cante al Señor toda la tierra, de día en día anuncien su salvación."
,"24":"Proclamen su gloria entre las naciones y digan sus maravillas entre los pueblos."
,"25":"Grande es el Señor y digno de alabanza, más tremendo que todos los dioses."
,"26":"No existen esos dioses de las gentes: no son más que ídolos. Fue el Señor quien hizo los cielos."
,"27":"Majestad y gloria van delante de él, poder y esplendor llenan su santuario."
,"28":"Adoren al Señor todas las familias de la tierra. Reconozcan su poder."
,"29":"Den gloria a su santo nombre. Ofrézcanle sacrificios, entren en su templo. Póstrense ante él con vestidos sagrados."
,"30":"Que la tierra entera se estremezca ante él: el mundo ahora no se conmoverá."
,"31":"Haya júbilo en el cielo y en la tierra; digan entre las naciones: El Señor reina."
,"32":"Que resuene el mar y cuanto lo llena. Alégrese el campo y todo lo que en él vive."
,"33":"Y salten de gozo todos los árboles, gócense delante del Señor que ya viene, viene para juzgar a la tierra."
,"34":"Alaben al Señor porque es bueno. Porque es eterna su misericordia."
,"35":"Digan: Sálvanos, Señor, Dios nuestro, y júntanos de entre las naciones, a fin de celebrar tu nombre santo y tener nuestra gloria en alabarte."
,"36":"Bendito sea el Señor, Dios de Israel, desde siempre hasta siempre: Que todo el pueblo diga: Amén. Aleluya. Todo el pueblo contestó 'Amén' y alabó a Yavé."
,"37":"David dejó allí, ante el Arca de la Alianza de Yavé, a Asaf y a sus hermanos, para celebrar el culto constantemente delante del Arca según el rito de cada día;"
,"38":"y a Obededom, hijo de Jedutún, y a Josá, como porteros."
,"39":"David dejó al sacerdote Sadoq y a sus hermanos, los sacerdotes, delante de la Morada de Yavé en el alto de Gabaón,"
,"40":"para que ofrecieran continuamente sacrificios a Yavé en el altar de los holocaustos, por la mañana y por la tarde, según todo lo escrito en la ley que Yavé había mandado a Israel."
,"41":"Con ellos estaban Hemán y Jedutún, y el resto de los hombres escogidos y señalados cada cual por su nombre para alabar a Yavé, y cantar: 'Porque es eterna su misericordia.'"
,"42":"Y con estos Hemán y Jedutún había trompetas, címbalos e instrumentos para los cánticos de Dios. Los hijos de Jedutún permanecían a la puerta."
,"43":"Después el pueblo se fue a sus casas, y David a la suya para bendecirla."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Cuando David ya estuvo en su casa, dijo al profeta Natán: 'Mira que yo vivo en una casa de madera de cedro mientras el Arca de la Alianza de Yavé está bajo pieles.'"
,"2":"Le respondió Natán: 'Haz todo cuanto te inspira tu corazón, porque Dios está contigo.'"
,"3":"Aquella misma noche Yavé habló a Natán, para decirle: 'Ve y transmite este recado a mi siervo David:"
,"4":"Esto dice Yavé: No me edificarás tú la casa en que yo habite."
,"5":"Pues no he habitado en casa alguna desde el día en que hice subir a los hijos de Israel, hasta el día de hoy; sino que he andado de tienda en tienda y de morada en morada."
,"6":"Durante todo el tiempo que he ido de un lado a otro con todo Israel, ¿he dicho acaso a alguno de los jueces de Israel, a los que encargué el gobierno de mi pueblo: Por qué no me edifican una casa de cedro?"
,"7":"Di, pues, ahora, esto a mi siervo David: Así habla Yavé Sebaot: Yo te saqué de detrás de las ovejas para que fueras jefe de mi pueblo Israel,"
,"8":"y he estado contigo en todas tus empresas, he eliminado a todos tus enemigos de delante de ti y voy a hacerte un nombre grande como el nombre de los grandes de la tierra."
,"9":"Fijaré un lugar a mi pueblo de Israel y lo plantaré allí para que no se mueva más; no será ya perturbado y los malvados no seguirán oprimiéndolo como antes."
,"10":"Desde los días en que instituí jueces sobre mi pueblo de Israel, te sometí a todos tus enemigos, y te anuncié que Yavé te edificará una casa."
,"11":"Cuando se cumplan tus días para ir con tus padres, afirmaré después de ti a uno de tus descendientes, a uno de tu sangre, y aseguraré tu reino."
,"12":"El me edificará una Casa y yo afirmaré su trono para siempre."
,"13":"Yo seré para él un padre, y él será para mí un hijo, y no apartaré de él mi amor, como lo aparté del que estaba ante ti."
,"14":"Yo lo mantendré en mi casa y en mi reino para siempre y su trono estará firme eternamente.'"
,"15":"Y Natán habló a David conforme a todas estas palabras y conforme a esta visión."
,"16":"Vino entonces el rey David a sentarse delante de Yavé, y dijo: '¿Quién soy yo, oh Yavé Dios, y qué es mi casa para que hayas hecho por mí tales cosas?,"
,"17":"y aun esto es poco a tus ojos, oh Dios, que también haces promesas a mi descendencia para el futuro lejano. Me has mirado como si fuera un hombre distinguido, ¡oh Yavé Dios!"
,"18":"¿Qué más le queda que desear a David? Tú me conoces a mí, tu siervo."
,"19":"¡Oh, Señor!, por amor de tu siervo y según tu corazón has realizado toda esta obra, para dar a conocer todas tus grandezas."
,"20":"¡Oh Yavé! Nadie hay como tú, ni hay Dios fuera de ti, según todo lo que hemos oído con nuestros oídos."
,"21":"Y ¿qué otro pueblo hay sobre la tierra como tu pueblo de Israel, a quien Dios haya ido a rescatar para hacerlo su pueblo, dándole renombre por medio de cosas grandes y terribles, arrojando naciones de delante de él y librándolo en la esclavitud de Egipto?"
,"22":"Tú has constituido a Israel tu pueblo, como pueblo tuyo para siempre, y tú, Yavé, te has hecho su Dios."
,"23":"Ahora, pues, oh Yavé, que se verifique eternamente la palabra que has dirigido respecto a tu siervo y a su casa; y haz según tu palabra."
,"24":"Sí, que todo se verifique; y sea tu nombre engrandecido por siempre y que se diga: Yavé Sebaot, el Dios de Israel, es un Dios para Israel. Y que la familia de tu siervo David subsista en tu presencia."
,"25":"¡Oh Dios mío! Acabas de revelar a tu siervo que vas a edificarle una casa, y por esto he encontrado valor para orar en tu presencia."
,"26":"Ahora, pues, Yavé, tú eres Dios y tú has prometido esta dicha a tu siervo,"
,"27":"y ahora te has dignado bendecir la casa de tu siervo para que permanezca por siempre en tu presencia. ¡Oh Yavé! Tú eres el que bendice y mi casa, pues, será bendita para siempre.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Después de esto David derrotó a los filisteos y los sometió, tomando Gat y sus aldeas de manos de los filisteos."
,"2":"Venció también a los moabitas, que quedaron sometidos a David y le pagaban impuestos."
,"3":"David derrotó a Hadadezer, rey de Sobá, en Jamat, cuando éste iba a establecer su dominio sobre la región del río Eufrates."
,"4":"David tomó mil carros de guerra, siete mil soldados de caballería y veinte mil de infantería; luego cortó los jarretes a todos los caballos de los carros, a excepción de cien carros que guardó."
,"5":"Los arameos de Damasco vinieron en socorro de Hadadezer rey de Sobá, y David mató a veintidós mil arameos."
,"6":"David estableció gobernadores en Aram de Damasco, y los arameos quedaron sometidos a David, pagándole impuestos. Así Yavé hizo triunfar a David dondequiera que iba."
,"7":"David tomó los escudos de oro que llevaban los servidores de Hadadezer y los llevó a Jerusalén. De Tibjat y Kun, ciudades de Hadadezer,"
,"8":"David tomó una gran cantidad de bronce, con el cual Salomón hizo el Mar de Bronce, las columnas y los utensilios de bronce."
,"9":"Cuando Toú, rey de Jamat, supo que David había derrotado a todas las fuerzas de Hadadezer, rey de Sobá,"
,"10":"envió a Hadoram, su hijo, donde el rey David para saludarlo y para felicitarlo por haber atacado y vencido a Hadadezer, ya que Toú estaba en guerra con Hadadezer. Hadoram traía toda clase de objetos de oro, de plata y de bronce. "
,"11":"El rey David los consagró también a Yavé con la plata y el oro que había tomado a todas las naciones; a Edom, a Moab, a los hijos de Ammón, a los filisteos y a los amalecitas."
,"12":"David se hizo famoso cuando volvió después de derrotar a dieciocho mil edomitas en el Valle de la Sal."
,"13":"Puso gobernadores en Edom; y todos los edomitas quedaron sometidos a David. Yavé hizo triunfar a David en todas las expediciones que emprendió."
,"14":"David reinó sobre todo Israel. Su administración era honrada, y juzgaba con justicia a todo su pueblo."
,"15":"Joab, hijo de Sarvia, era jefe del ejército; Josafat, hijo de Ajitub, era el canciller;"
,"16":"Sadoq, hijo de Ajitub, y Abimelec, hijo de Abiatar eran sacerdotes;"
,"17":"Sivsa era secretario; Benaías, hijo de Jeovadá, mandaba a los cereteos y peleteos. Pero los hijos de David eran primeros al lado del rey."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Después de esto, murió Najás, rey de los amonitas, y en su lugar reinó su hijo."
,"2":"Entonces David dijo: 'Tendré con Janún, hijo de Najás, la misma benevolencia que su padre tuvo conmigo', y envió David mensajeros para que lo consolaran por la muerte de su padre. Pero cuando los servidores de David llegaron al país de Ammón, donde Janún, para consolarlo,"
,"3":"los príncipes de los hijos de Ammón dijeron a Janún: '¿Es que David ha enviado a consolarte para honrar la memoria de tu padre o más bien para explorar, espiar y poder destruir el país?'"
,"4":"Janún tomó presos a los enviados de David, les rapó la cabeza y la barba, les cortó a media altura sus vestidos hasta las nalgas y así los despidió."
,"5":"David supo lo que les había pasado y envió gente a su encuentro ya que venían muy avergonzados. El rey dijo: 'Quédense en Jericó hasta que les crezca la barba, y después vuelvan.'"
,"6":"Cuando los hijos de Ammón vieron que se habían hecho odiosos a David, Janún y los amonitas enviaron mil talentos de plata para tomar a sueldo carros de guerra y hombres para manejarlos, de Aram de Mesopotamia, Aram de Maacá y de Sobá."
,"7":"Tomaron a sueldo treinta y dos mil carros de guerra y al rey de Maacá con su ejército, los cuales vinieron y acamparon frente a Medebá, mientras los hijos de Ammón se congregaban desde sus ciudades y llegaban para la batalla."
,"8":"David lo supo, y envió a Joab con toda la tropa y con los valientes."
,"9":"Los amonitas salieron a campaña y se ordenaron en batalla a la entrada de la ciudad, mientras que los reyes que habían venido estaban aparte en el campo."
,"10":"Viendo Joab que tenía un frente de combate por delante y otro por detrás, escogió los mejores de Israel y los puso en línea contra los arameos."
,"11":"Puso el resto del ejército al mando de su hermano Abisay y lo ordenó en batalla frente a los amonitas."
,"12":"Dijo Joab: 'Si los arameos me dominan, ven en mi ayuda; y si los hijos de Ammón te dominan a ti, iré a socorrerte."
,"13":"Ten fortaleza y esforcémonos por nuestro pueblo y por las ciudades de nuestro Dios, que Yavé haga lo que le parezca bueno.'"
,"14":"Joab avanzó con su ejército para luchar contra los arameos, que huyeron delante de él."
,"15":"Viendo los amonitas que los arameos emprendían la fuga, huyeron también ellos ante Abisay, hermano de Joab, y volvieron a la ciudad, mientras que Joab regresó a Jerusalén."
,"16":"Al ver los arameos que Israel los había vencido enviaron mensajeros a los arameos del otro lado del río para que vinieran a ayudarlos: Sofac jefe de las tropas de Hadadezer estaba a su frente."
,"17":"Avisaron a David, que reuniendo a todo Israel pasó el Jordán, llegó donde estaban ellos y tomó posición frente a ellos. David se puso en orden de batalla contra los arameos, y éstos trabaron combate con él."
,"18":"Los arameos huyeron ante Israel: David mató a siete mil soldados de infantería de los carros y a cuarenta mil de infantería. Mató también a Sofac, jefe del ejército."
,"19":"Cuando los hombres de Hadadezer vieron que Israel los derrotó, hicieron la paz con David y le quedaron sometidos. En adelante, los arameos ya no se atrevieron a seguir ayudando a los amonitas."
}`)
	CurrentBook.AddChapter(20, `{
"1":"A la vuelta del año, en el tiempo en que los reyes salen a pelear, Joab se fue con la mayor parte del ejército para asolar el país de los hijos de Ammón; después fue a sitiar a Raba, mientras David se quedó en Jerusalén. Entre tanto, Joab conquistó a Raba y la destruyó."
,"2":"David tomó la corona del dios Milcom de encima de su cabeza. Comprobaron que pesaba un talento de oro, con una piedra preciosa que fue puesta en la cabeza de David. Se llevó además un gran botín de la ciudad."
,"3":"Sacó de la ciudad a todos sus habitantes y los hizo despedazar con sierras, con trillos de dientes de acero y con hoces. Así hizo con todas las ciudades de los amonitas. Luego David regresó con todo su ejército a Jerusalén."
,"4":"Después de esto, tuvo lugar una batalla en Guezer contra los filisteos; entonces Sibekay, jusasita, mató a Sipay, uno de los descendientes de Rafá. Los filisteos tuvieron que someterse."
,"5":"Hubo otra guerra contra los filisteos y Eljanán, hijo de Jair, mató a Lajmi, hermano de Goliat, el de Gat; el asta de su lanza era como un enjullo de telar."
,"6":"Hubo guerra de nuevo en Gat, y había un hombre de gran estatura que tenía veinticuatro dedos, seis en cada mano y pie."
,"7":"También éste descendía de Rafá. Desafió a Israel y lo mató Jonatán, hijo de Simá, hermano de David."
,"8":"Estos son los que descendían de Rafá de Gat, que murieron en manos de David y de sus tropas."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Satanás se levantó contra Israel e incitó a David a hacer el censo de Israel."
,"2":"Dijo, pues, David a Joab y a los jefes del pueblo: 'Vayan y cuenten a los israelitas desde Bersebá a Dan, y prepárenme un informe para que yo sepa su número.'"
,"3":"Respondió Joab: 'Multiplique Yavé su pueblo cien veces más de lo que es. ¿Acaso no son todos ellos siervos de mi señor? ¿Por qué, pues, pides esto? ¿Por qué acarrear una culpa sobre Israel?'"
,"4":"De todos modos prevaleció la orden del rey y Joab recorrió todo Israel, volviéndose después a Jerusalén."
,"5":"Joab entregó a David la cifra del censo del pueblo: había en todo Israel un millón cien mil hombres capaces de manejar las armas, y en Judá, cuatrocientos setenta mil."
,"6":"No incluyó en este censo a la tribu de Leví, ni a la de Benjamín, porque Joab detestaba la orden del rey."
,"7":"Esto desagradó a Yavé, por lo cual castigó a Israel."
,"8":"David, entonces, dijo a Yavé: 'He cometido un gran pecado haciendo esto. Pero ahora perdona, te ruego, la falta de tu siervo, pues he sido muy estúpido.'"
,"9":"Y Yavé habló a Gad, profeta de David, para decirle:"
,"10":"'Transmite a David este recado: Así dice Yavé: Te propongo tres cosas, la que escojas, la llevaré a cabo.'"
,"11":"Llegó Gad donde David y le dijo: 'Así dice Yavé: Elige para ti"
,"12":"tres años de hambre o tres meses de derrotas ante tus enemigos que te perseguirán con su espada, o bien tres días durante los cuales la espada de Yavé, la peste, aqueje el país y el Angel de Yavé haga estragos en todo el territorio de Israel. Ahora, pues, contéstame, ya que tengo que responder al que me envía.'"
,"13":"David respondió a Gad: 'Estoy en gran angustia. Pero caiga yo en manos de Yavé, porque es grande su misericordia, y no caiga en manos de los hombres.'"
,"14":"Yavé, pues, envió la peste sobre Israel y murieron setenta mil hombres."
,"15":"Yavé mandó un Angel contra Jerusalén para destruirla; pero cuando ya lo estaba haciendo Yavé miró y se arrepintió del mal y dijo al Angel exterminador: 'Basta ya, retira tu mano.',El Angel de Yavé estaba junto a la era de Ornán el jebuseo. "
,"16":"Alzando David los ojos vio el Angel que estaba entre el cielo y la tierra con una espada desenvainada en su mano, extendida sobre Jerusalén. Entonces David y los jefes, vestidos con sacos, se postraron rostro en tierra."
,"17":"Y David dijo a Yavé: 'Yo fui quien ordenó hacer el censo del pueblo. Yo fui quien pequé; yo cometí el mal; pero estas ovejas ¿qué culpa tienen? Oh Yavé, Dios mío, caiga tu mano sobre mí, y sobre la familia de mi padre, pero que no haya plaga en tu pueblo.'"
,"18":"El Angel de Yavé ordenó a Gad que dijera a David de subir para alzar un altar a Yavé en la era de Ornán el jebuseo."
,"19":"Subió David cumpliendo la orden que Yavé le había dado por boca de Gad."
,"20":"Ornán, que estaba trillando el trigo, se volvió y vio al Angel; sus cuatro hijos que estaban con él se escondieron."
,"21":"Cuando David llegó junto a Ornán, éste miró y, al verlo, salió de la era para postrarse ante él, rostro en tierra."
,"22":"David dijo a Ornán: 'Dame el sitio de esta era para erigir en él un altar a Yavé; dámelo por su justo valor en plata, para que la plaga se retire del pueblo.'"
,"23":"Ornán respondió a David: 'Tómalo; que mi señor, el rey, haga lo que mejor le parezca; doy también los bueyes para los holocaustos, los trillos para la leña y el trigo para la ofrenda; todo lo doy.'"
,"24":"El rey David replicó a Ornán: 'No, quiero comprártelo por su justo precio, pues no tomaré para Yavé lo que es tuyo, ni quiero ofrecerle sacrificios que no me cuesten.'"
,"25":"Y David dio a Ornán por el sitio la suma de seiscientos siclos de oro."
,"26":"Allí erigió un altar a Yavé y ofreció víctimas quemadas y sacrificios de comunión e invocó a Yavé, el cual le respondió con fuego del cielo que cayó sobre el altar del holocausto."
,"27":"Entonces Yavé ordenó al Angel que volviera la espada a la vaina."
,"28":"Inmediatamente David, al ver que Yavé había escuchado su oración en la era de Ornán el jebuseo, ofreció allí sacrificios."
,"29":"La Morada de Yavé, que Moisés había construido en el desierto, y el Altar de los holocaustos estaban en aquel entonces en el santuario de lomas de Gabaón;"
,"30":"pero David no se había atrevido a presentarse delante de Yavé para consultarle, porque estaba aterrado de miedo ante la espada del Angel."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Entonces dijo David: 'Aquí estará la Casa de Yavé, Dios, y aquí el altar de los holocaustos para Israel.'"
,"2":"David, pues, mandó reunir a los forasteros residentes en la tierra de Israel, y designó canteros para que preparasen piedras talladas para la construcción de la Casa de Dios."
,"3":"Preparó también hierro en abundancia para la clavazón de las hojas de las puertas y para las grapas; preparó también incalculable cantidad de bronce"
,"4":"y madera de cedro sin número, pues los sidonios y los tirios trajeron a David madera de cedro en abundancia."
,"5":"David se decía: 'Mi hijo Salomón es todavía un joven delicado y la casa que ha de edificar para Yavé debe ser extraordinariamente grandiosa, para que se hable de ella y sea famosa en todos los países. Así que yo le haré los preparativos.',Así, pues, David hizo grandes preparativos antes de su muerte. "
,"6":"Después llamó a su hijo Salomón y le mandó que edificase una Casa para Yavé, el Dios de Israel."
,"7":"Dijo David a Salomón: 'Hijo mío, yo había deseado edificar una Casa al nombre de Yavé, mi Dios."
,"8":"Pero me fue dirigida la palabra de Yavé que me dijo: Tú has derramado mucha sangre y has hecho grandes guerras; no podrás edificar la Casa a mi nombre porque has derramado mucha sangre delante de mí."
,"9":"Mira que te nacerá un hijo que será hombre de paz; le concederé paz con todos sus enemigos en derredor, porque Salomón será su nombre, y durante su vida concederé paz y tranquilidad a Israel."
,"10":"El edificará una Casa a mi nombre; él será para mí un hijo y yo para él un padre y afirmaré el trono de su reino sobre Israel para siempre."
,"11":"Ahora, pues, hijo mío, que Yavé sea contigo, para que logres edificar la Casa de Yavé, tu Dios, según lo que dijo referente a ti."
,"12":"Quiera Yavé concederte prudencia y entendimiento en el momento en que te establece sobre Israel, para que guardes la Ley de Yavé tu Dios."
,"13":"Entonces prosperarás si cuidas de cumplir los preceptos y decretos que Yavé ha prescrito a Moisés para Israel. ¡Sé fuerte y ten buen ánimo! ¡No temas ni desmayes!"
,"14":"Mira lo que yo he preparado con mucha dificultad para la Casa de Yavé: cien mil talentos de oro, un millón de talentos de plata. En cuanto al bronce y al hierro, hay tanto que no se puede contar. He preparado también maderas y piedras que tú podrás aumentar."
,"15":"Tienes también muchos obreros, canteros, artesanos en piedra y en madera y expertos en toda clase de obras."
,"16":"El oro, la plata, el bronce y el hierro son incalculables. Levántate, pues, manos a la obra, y que Yavé sea contigo.'"
,"17":"David mandó a todos los jefes de Israel que ayudaran a su hijo Salomón."
,"18":"'¿No está con ustedes Yavé, su Dios? ¿Y no les ha dado paz por todos lados? Pues él ha entregado en mis manos a los habitantes del país; y el país está sujeto ante Yavé y ante su pueblo."
,"19":"Dedíquense, pues, de todo corazón y alma a buscar a Yavé, su Dios. Levántense y edifiquen el Santuario de Yavé, su Dios, y que se traslade el Arca de la Alianza y las cosas sagradas de Dios a la casa edificada al nombre de Yavé.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Siendo ya David anciano y lleno de días proclamó a su hijo Salomón rey de Israel."
,"2":"Reunió a todos los jefes de Israel, a los sacerdotes y a los levitas"
,"3":"y se hizo el censo de los levitas de treinta años para arriba; su número, contados uno a uno, fue de treinta y ocho mil varones."
,"4":"David dijo: 'De éstos, veinticuatro mil estarán al frente del servicio de la Casa de Yavé, seis mil serán escribas y jueces;"
,"5":"cuatro mil serán porteros y cuatro mil alabarán a Yavé con los instrumentos que hice para su alabanza.'"
,"6":"David los distribuyó por turnos según las familias de los hijos de Leví: Guersón, Quehat y Merarí."
,"7":"De los guersonitas: Ladán y Semí."
,"8":"Hijos de Ladán: Jejiel el primero, Zetam y Joel, tres."
,"9":"Hijos de Semí: Selomit, Jaziel y Heran, tres. Estos son los jefes de las casas paternas de Ladán."
,"10":"Hijos de Semí: Yajat, Zizá, Jeus y Bería."
,"11":"Estos eran los cuatro hijos de Semí: Yajat era el jefe, Zizá, el segundo; Jeus y Bería no tuvieron muchos hijos, por lo cual representaron en el censo una sola casa paterna."
,"12":"Hijos de Quehat: Amram, Jisear, Hebrón y Uziel, cuatro. Hijos de Amram: Aarón y Moisés."
,"13":"Aarón fue separado juntamente con sus hijos para consagrar por siempre las cosas muy sagradas, para quemar incienso ante Yavé, para servirlo y para bendecir en su nombre por siempre."
,"14":"En cuanto a Moisés, varón de Dios, sus hijos fueron contados en la tribu de Leví."
,"15":"Hijos de Moisés: Guersom y Eliezer."
,"16":"Hijos de Guersom: Sebuel, el primero. Hijos de Eliezer: Rejabías, el primero."
,"17":"Eliezer no tuvo más hijos, pero los hijos de Rejabías fueron muy numerosos."
,"18":"Hijos de Jisecar: Selomit, el primero."
,"19":"Hijos de Hebrón: Yeria, el primero; Amarías, el segundo; Yajaziel, el tercero y Yecamam el cuarto."
,"20":"Hijos de Uziel: Mika, el primero, y Jisías el segundo."
,"21":"Hijos de Merarí: Majlí y Musí."
,"22":"Hijos de Majlí: Eleazar y Quis. Eleazar murió sin tener hijos; sólo tuvo hijas, a las que los hijos de Quis, sus hermanos, tomaron por esposas."
,"23":"Hijos de Musí: Majlí, Eder y Jerimot, tres."
,"24":"Estos son los hijos de Leví, según sus familias paternas, los cabezas de familIa, según el censo de ellos, contados uno por uno. Estaban encargados del servicio de la Casa de Yavé desde la edad de veinte años en adelante,"
,"25":"pues David había dicho: 'Yavé, el Dios de Israel, ha dado reposo a su pueblo y mora en Jerusalén para siempre,"
,"26":"de manera que los levitas ya no tendrán que transportar la Morada, con todos los utensilios de su servicio.'"
,"27":"Conforme a estas últimas disposiciones de David, se hizo el censo de los hijos de Leví de veinte años para arriba."
,"28":"Ayudaban a los hijos de Aarón para el servicio de la Casa de Yavé, teniendo a su cargo los atrios y las cámaras, la limpieza de todas las cosas sagradas y la obra del servicio de la Casa de Yavé;"
,"29":"asimismo tenían a su cargo disponer en filas los panes, la flor de harina para la ofrenda, las tortas sin levadura fritas en la sartén, o cocinadas, y toda clase de medidas de capacidad y longitud."
,"30":"Tenían que estar presentes todas las mañanas para celebrar y alabar a Yavé, y todas las tardes"
,"31":"para ofrecer todos los holocaustos a Yavé. Lo mismo en los sábados, lunas nuevas y solemnidades, según el número y el rito establecido delante de Yavé para siempre,"
,"32":"guardando en el servicio de la Casa de Yavé el ritual de la Tienda de Reunión, el ritual del santuario y el ritual de los hijos de Aarón, sus hermanos."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Estas son las clases de los hijos de Aarón."
,"2":"Hijos de Aarón: Nadab, Abihú, Eleazar e Itamar. Nadab y Abihú murieron en presencia de su padre, sin tener hijos, de modo que Eleazar e Itamar ejercieron las funciones sacerdotales."
,"3":"David, junto con Sadoq, de los hijos de Eleazar, y Ajimelec de los hijos de Itamar, los clasificó y los inscribió en el registro según sus funciones."
,"4":"Se hallaron entre los hijos de Eleazar más varones que entre los hijos de Itamar, por lo que se dividió a los hijos de Eleazar en dieciséis jefes de casas paternas; y a los hijos de Itamar, en ocho jefes de casas paternas."
,"5":"Los repartieron por suertes a unos y otros; porque había jefes sagrados y jefes divinos, tanto entre los hijos de Eleazar como entre los hijos de Itamar;"
,"6":"Semaías, hijo de Natanael, escriba, uno de los levitas, los inscribió en presencia del rey y de los jefes, y en presencia del sacerdote Sadoc, de Ajimelec, hijo de Abiatar, y de los jefes de familias sacerdotales y levíticas. Se sacaba a suertes: una vez para Itamar y dos veces para Eleazar."
,"7":"Tocó la primera suerte a Yoyarib; la segunda a Jedaías;"
,"8":"la tercera a Jarim; la cuerta a Seorim;"
,"9":"la quinta a Malaquías; la sexta a Miyamim; la séptima a Hacos;"
,"10":"la octava a Abías; la novena a Jesúa;"
,"11":"la décima a Secanías; la once a Elyasib;"
,"12":"la doce a Yaquim; la trece a Jupá; la catorce a Yesebab;"
,"13":"la quince a Bilgá; la dieciséis a Inmer;"
,"14":"la diecisiete a Jezir;"
,"15":"la dieciocho a Apises;"
,"16":"la diecinueve a Petajías;"
,"17":"la veinte a Ezequiel; la veintiuno a Yaquim; la veintidós a Gamul;"
,"18":"la veintitrés a Delaías; la veinticuatro a Maazías."
,"19":"Fueron inscritos en el registro según sus servicios para entrar en la Casa de Yavé conforme al reglamento que Yavé, el Dios de Israel, había prescrito por medio de Aarón, padre de ellos."
,"20":"Respecto de los otros hijos de Leví: De los hijos de Amram: Subael. De los hijos de Subael: Jejdeías."
,"21":"De Rejabías: de los hijos de Rejabías: Jisía era el primero."
,"22":"De los Jisbaritas, Selemot; de los hijos de Selemot, Yajat."
,"23":"Hijos de Hebrón: Jerías el primero; Amarías, el segundo; Yajaziel, el tercero; Yecaman, el cuarto."
,"24":"Hijos de Uziel: Miká;"
,"25":"de los hijos de Miká, Samir; Jisías era hermano de Miká;"
,"26":"de los hijos de Jisías, Zacarías. Hijos de Merarí: Majlí y Musí,"
,"27":"hijos de Merarí por la línea de Uzías, su hijo: Soham, Zakur y Jibrí."
,"28":"De Majlí: Eleazar, que no tuvo hijos."
,"29":"De Quis: Los hijos de Quis: Yerajmeel."
,"30":"Hijos de Musí: Majlí, Eder y Jerimot. Estos fueron los hijos de los levitas, según sus casas paternas. "
,"31":"También éstos entraron en suerte de la misma manera que sus hermanos, los hijos de Aarón, en presencia del rey David, en presencia de Sadoq, Ajimelec y los cabezas de familias de sacerdotes y de levitas, siendo tratadas las primeras familias igual que las últimas."
}`)
	CurrentBook.AddChapter(25, `{
"1":"David y los jefes del ejército separaron para el servicio a los hijos de Asaf, Hemán y Jedutún, que profetizaban acompañándose con cítaras, salterios y címbalos. Este es el número de personas que se encargaban de este servicio:"
,"2":"De los hijos de Asaf: Zakur, José, Netanías, Asarelá. Los hijos de Asaf estaban bajo la dirección de Asaf, que profetizaba bajo la dirección del rey."
,"3":"De Jedutún: Los hijos de Jedutún: Guedalías, Serí, Semeí, Isaías, Jasabías y Matatías, seis, bajo la dirección de su padre Jedutún, que profetizaba al son de la cítara para celebrar y alabar a Yavé."
,"4":"De Hemán: Los hijos de Hemán: Buguías, Matanías, Uziel, Sebuel, Jerimot, Jamanías, Jamaní, Eliatá, Guidalti, Romamtí-Ezer, Yosbecasa, Malotí, Hotir, Majaziot."
,"5":"Todos éstos eran hijos de Hemán, profeta del rey, que debía hacer sonar la trompa cuando llegaba la palabra de Yavé. Dios había dado a Hemán catorce hijos y tres hijas."
,"6":"Todos ellos se hallaban bajo la dirección de su padre para el canto de la Casa de Yavé, con címbalos, salterios y cítaras al servicio de la Casa de Yavé, siguiendo las indicaciones del rey, de Asaf, Jedutún y Hemán."
,"7":"Su número, contando a sus hermanos, los que estaban instruidos en el canto de Yavé, todos ellos maestros, era de doscientos ochenta y ocho."
,"8":"Echaron a suertes el turno del servicio de todos, tanto del pequeño como del grande, del maestro como del discípulo."
,"9":"La primera suerte recayó para Asaf sobre José; él y sus hijos y hermanos, doce. La segunda sobre Guedalías con sus hermanos e hijos, doce."
,"10":"La tercera, sobre Zakur, sus hijos y hermanos, doce."
,"11":"La cuarta, sobre Yisrí, sus hijos y hermanos, doce."
,"12":"La quinta, sobre Netanías, sus hijos y hermanos, doce."
,"13":"La sexta, sobre Buquías, sus hijos y hermanos, doce."
,"14":"La séptima, sobre Yesarela, sus hijos y hermanos, doce."
,"15":"La octava, sobre Isaías, sus hijos y hermanos, doce. La novena, sobre Matanías, sus hijos y hermanos, doce."
,"16":"La décima, sobre Semí, sus hijos y hermanos, doce."
,"17":"La undécima, sobre Azarael, sus hijos y hermanos, doce."
,"18":"La duodécima, sobre Jasabías, sus hijos y hermanos, doce."
,"19":"La decimotercera, sobre Subael, sus hijos y hermanos, doce."
,"20":"La decimocuarta, sobre Matatías, sus hijos y hermanos, doce."
,"21":"La decimoquinta, sobre Jeremot, sus hijos y hermanos, doce."
,"22":"La decimosexta, sobre Jananías, sus hijos y hermanos, doce."
,"23":"La decimoséptima, sobre Yosbecasa, sus hijos y hermanos, doce."
,"24":"La decimoctava, sobre Jananí, sus hijos y hermanos, doce."
,"25":"La decimonovena, sobre Malotí, sus hijos y hermanos, doce."
,"26":"La vigésima, sobre Eliyatá, sus hijos y hermanos, doce."
,"27":"La vigésimo primera, sobre Hotir, sus hijos y hermanos, doce."
,"28":"La vigésimo segunda, sobre Guidaltí, sus hijos y hermanos, doce."
,"29":"La vigésimo tercera, sobre Majaziot, sus hijos y hermanos, doce."
,"30":"La vigésimo cuarta, sobre Romamtí-Ezer, sus hijos y hermanos, doce."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Estas son las clases de porteros: de los coreítas: Meselemías, hajo de Coré, de los hijos de Ebiasaf."
,"2":"Meselemías tuvo hijos: el primogénito, Zacarías; el segundo, Jedaiel; el tercero, Zebadías; el cuarto, Yataniel;"
,"3":"el quinto, Elam; el sexto, Jehojanan; el séptimo Elyehoenay."
,"4":"Hijos de Obededom: Semaías, el primogénito; Jehozabad, el segundo; Yoaj, el tercero; Sacar, el cuarto; Natanael, el quinto;"
,"5":"Amiel, el sexto; Isacar, el séptimo; Peualty, el octavo; pues Yavé le había bendecido."
,"6":"A su hijo Semaías le nacieron hijos, que se impusieron en sus familias paternas, pues eran hombres valerosos."
,"7":"Hijos de Semaías: Otní, Rafael, Obed, Elzabad y sus hermanos, hombres valerosos, Elihú y Semakías."
,"8":"Todos éstos eran hijos de Obededom, ellos y sus hijos y sus hermanos eran hombres de gran valor para el servicio. Sesenta y dos de Obededom."
,"9":"Mesalemías tuvo hijos y hermanos, dieciocho hombres valerosos."
,"10":"Josías, de los hijos de Merarí, tuvo como hijos a Simrí, que hizo de primero porque, después de perder a su primogénito, su padre lo puso al frente,"
,"11":"Jilquías, el segundo; Tebalías, el tercero; Zacarías, el cuarto. El total de los hijos y hermanos de Josá fue de trece."
,"12":"Estas secciones de los porteros, todo el personal masculino, igual que sus hermanos, tenían el cuidado del ministerio de la Casa de Yavé."
,"13":"Echaron suertes para cada puerta, sobre pequeños y grandes según sus casas paternas."
,"14":"Para la puerta oriental la suerte cayó sobre Selemías. Después echaron suertes para la puerta del norte, la cual le tocó a su hijo Zacarías, que era un prudente consejero."
,"15":"A Obededom le tocó el sur, y a sus hijos los almacenes."
,"16":"A Supim y a Josá, el occidente, junto a la puerta de la sala en el camino de la subida, correspondiéndose un puesto de guardia con el otro."
,"17":"Al oriente se nombraban seis levitas por día, al norte cuatro por día, al mediodía, cuatro por día, y en los almacenes de dos en dos;"
,"18":"en el anexo del occidente había cuatro para la subida, dos para el anexo."
,"19":"Estas son las clases de los porteros, tanto de los hijos de los coreítas como de los hijos de Medarí."
,"20":"Los levitas sus hermanos, custodiaban los tesoros de la Casa de Yavé y los tesoros de las cosas consagradas."
,"21":"Entre los hijos de Ladán, hijos de Guersón por la línea de Ladán y jefes de familia de Ladán el guersonita, se contaban los hijos de Jejiel."
,"22":"Los hijos de Jejiel, de Zetan y de su hermano Joel, estaban al frente de los tesoros de la Casa de Yavé."
,"23":"Juntamente con los amramíes, los jisharitas, los hebronitas y los uzelitas."
,"24":"Sabuel, hijo de Guersón, hijo de Moisés, era el tesorero mayor."
,"25":"Sus hermanos por parte de Eliezer: Rejabías, hijo suyo; Isaías, hijo suyo; Joram, hijo suyo; Zikri, hijo suyo; Selomit, hijo suyo."
,"26":"Este Selomit y sus hermanos estaban al cuidado de las cosas que el rey David, los cabezas de las casas paternas, los jefes de mil y de cien y los demás jefes del ejército habían consagrado a Yavé."
,"27":"Aquí había una parte del botín de guerra y de los despojos que los jefes habían consagrado para el sostenimiento de la Casa de Yavé."
,"28":"Además, todo lo que habían consagrado el profeta Samuel, Saúl, hijo de Quis, Abner, hijo de Ner y Joab, hijo de Sarvia; todo lo consagrado estaba al cuidado de Selomit y sus hermanos."
,"29":"De los yeseritas: Kenanías y sus hijos administraban como secretarios y jueces los negocios exteriores de Israel."
,"30":"De los hebronitas: Jesabías y sus hermanos, hombres muy valerosos en número de mil setecientos, gobernaban la parte de Israel que está al otro lado del Jordán hacia el poniente, en todos los negocios concernientes al servicio de Yavé y del rey."
,"31":"El jefe de los hebronitas era Jería, según la genealogía paterna de los hebronitas. Se hicieron investigaciones al respecto en el año cuarenta del reinado de David y se hallaron entre ellos hombres valerosos que habían estado en Yaser de Galaad."
,"32":"También los hermanos de Jería eran hombres valerosos, en número de dos mil setecientos jefes de familias."
,"33":"El rey David les dio el mando sobre los rubenitas y gaditas, y la media tribu de Manasés, en todo lo tocante al servicio de Yavé y del rey."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Censo de los hijos de Israel, jefes de familia, jefes de mil y de cien y escribas que estaban al servicio del rey para todo lo referente a las clases, la que entraba y la que partía cada mes durante todo el año. Cada clase contaba veinticuatro mil hombres."
,"2":"Al frente de la primera sección de veinticuatro mil hombres para el primer mes, estaba Jesboam, hijo de Zabdiel,"
,"3":"de la familia de Fares, y era jefe de todos los oficiales del primer mes."
,"4":"Al frente de la sección del segundo mes estaba Doday, el ajonita, y tenía por ayudante a uno llamado Miclot. Su sección era de veinticuatro mil hombres."
,"5":"El tercer jefe para el tercer mes era Banaías, sacerdote hijo de Joyadá. Su sección era de veinticuatro mil hombres a su mando."
,"6":"Este es aquel Banaías, uno de los Treinta valientes y sobre ellos. En su sección estaba su hijo Amizabad."
,"7":"El cuarto jefe para el cuarto mes era Azael, hermano de Joab, y después de él Zabadías, su hijo. Su sección era de veinticuatro mil hombres."
,"8":"El quinto jefe para el quinto mes era Samut, el zarjita, y su sección era de veinticuatro mil hombres."
,"9":"El sexto jefe para el sexto mes era Hira, hijo de Iques de Tecoa; su sección era de veinticuatro mil hombres."
,"10":"El séptimo jefe para el séptimo mes era Jeles de Pelet, de la tribu de Efraím; su sección era de veinticuatro mil hombres."
,"11":"El octavo jefe, para el octavo mes, era Sobcaí de Husat, de la familia de Zarají. Su sección era de veinticuatro mil hombres."
,"12":"El noveno, para el mes noveno, Abiezer de Anatot, de los hijos de Benjamín. Su sección era de veinticuatro mil hombres."
,"13":"El jefe décimo para el décimo mes era Maraí de Netofat, de la familia de Zarjí. Su sección era de veinticuatro mil hombres."
,"14":"El undécimo jefe para el mes undécimo era Banaías de Faratón, de la tribu de Efraím, y su sección era de veinticuatro mil hombres."
,"15":"El duodécimo jefe para el mes duodécimo era Holdai de Netofat, de la familia de Otoniel. Su sección era de veinticuatro mil hombres."
,"16":"Al frente de las tribus de Israel: De la tribu de Rubén era encargado Eliezer, hijo de Zecrí. De la de Simeón, Safatías, hijo de Maacá."
,"17":"De la de Leví, Jasabías, hijo de Camuel, pero Sadoq era jefe de los descendientes de Aarón."
,"18":"De la tribu de Judá, Eliú, hermano de David."
,"19":"De la de Isacar, Amrí, hijo de Micael. De la de Zabulón, Jesmaías, hijo de Abdías. De la de Neftalí, Jerimot Asriel."
,"20":"De la de Efraím, Oseas, hijo de Azazía. De la media tribu de Manasés, Joel, hijo de Fodaya."
,"21":"De la media tribu de Manasés, en Galaad, era el jefe Jidon, hijo de Zacarías. De la tribu de Benjamín, Jasiel, hijo de Abner."
,"22":"De la de Dan, Ezrihel, hijo de Jeroyam; éstos eran los jefes de los hijos de Israel."
,"23":"David no hizo el censo de los que tenían menos de veinte años, porque Yavé había dicho que multiplicaría a Israel como las estrellas del cielo."
,"24":"Joab, hijo de Sarvia, comenzó a hacer el censo, pero no lo acabó porque esto hizo enojar a Yavé, quien descargó su cólera sobre Israel; por esta razón el número de los que fueron contados no fue incluido en el libro de las Crónicas del rey David."
,"25":"Azmavet, hijo de Adiel, tenía a su cargo los tesoros del rey. Jonatán, hijo de Uzías, tenía a su cargo los depósitos que estaban en el campo, en las ciudades, aldeas y torres."
,"26":"Ezrí, hijo de Jelub, era el encargado de los labradores del campo que cultivaban las tierras;"
,"27":"Semí, de los que cultivaban las viñas; Sabdí, de Sefa, encargado de las provisiones de vino de las viñas."
,"28":"De los olivares y sicomoros que había en la tierra baja, Baaljanan de Gueder era el encargado."
,"29":"De los almacenes de aceite, Joas. De los rebaños de vacas que pacían en Sarón, Sitray el saronita; los que pacían en los valles estaban bajo cuidado de Safat, hijo de Adalay."
,"30":"De los camellos, Obiel el ismaelita; de las burras, Jeideías, de Meronot;"
,"31":"de las ovejas, Yazis el hagrita. Todos estos eran intendentes administradores de los bienes y propiedades del rey."
,"32":"Jonatán, tío de David, hombre prudente e instruido, era consejero del rey. Jilíel, hijo de Jakmení, cuidaba de los hijos del rey."
,"33":"Ajitofel era consejero del rey, y Jusay el arquita era el amigo del rey."
,"34":"Después de Ajitofel, lo fueron Jeoyadá, hijo de Benaías, y Abiatar. Joab era el jefe del ejército del rey."
}`)
	CurrentBook.AddChapter(28, `{
"1":"David reunió en Jerusalén a todos los jefes de Israel, los jefes de las tribus, los jefes de las secciones al servicio del rey, los jefes de mil y de cien, los administradores de las posesiones y ganados del rey, y de sus hijos, a los funcionarios, a los héroes y a los más valientes del ejército."
,"2":"Poniéndose en pie el rey David dijo: 'Escúchenme, hermanos y pueblo mío: Yo me preocupaba por edificar una Casa donde descansara el Arca de la Alianza de Yavé, que es la tarima de los pies de nuestro Dios. Ya había hecho yo preparativos para su construcción, "
,"3":"pero Dios me dijo: No edificarás la Casa para mi nombre, pues eres hombre de guerra y has derramado sangre."
,"4":"Sin embargo, Yavé, el Dios de Israel, me ha elegido de entre toda la familia de mi padre, para que fuese rey de Israel para siempre. Pues escogió a la tribu de Judá para tener el mando y entre las familias de Judá a la de mi padre, y de entre los hijos de mi padre, me escogió a mí para hacerme rey de todo Israel."
,"5":"Y de entre todos mis hijos, pues Yavé me ha dado muchos hijos, eligió a mi hijo Salomón para que se siente en el trono del reino de Yavé sobre Israel."
,"6":"Y él me dijo: Tu hijo Salomón edificará mi Casa y mis patios; porque le he escogido a él por hijo mío, y yo seré para él padre."
,"7":"Afirmaré su reino para siempre, con tal de que se mantenga firme en el cumplimiento de mis mandamientos y mis normas como lo hace hoy."
,"8":"Ahora, pues, a los ojos de todo el pueblo de Israel, que es la asamblea de Yavé, y a oídos de nuestro Dios, guarden y mediten todos los mandamientos de Yavé su Dios, para que puedan poseer esta tierra espléndida y la dejen como heredad a sus hijos después de ustedes para siempre."
,"9":"Y tú, Salomón, hijo mío, reconoce al Dios de tu padre, y sírvele con corazón entero y con ánimo cariñoso, porque Yavé sondea a todos los corazones y penetra los pensamientos en todas sus formas. Si lo buscas, se dejará encontrar, pero si lo dejas, él te arrojará para siempre."
,"10":"Mira ahora que Yavé te ha elegido para edificar una Casa que sea su santuario. Sé fuerte y manos a la obra.'"
,"11":"Entonces David dio a su hijo Salomón el diseño del vestíbulo y de los demás edificios, de los almacenes, de las salas altas, de las salas interiores y de la pieza donde estaría el lugar del Perdón;"
,"12":"y también el diseño de todo lo que había pensado respecto de los patios de la Casa de Yavé, y de todas las cámaras de alrededor para los tesoros de la Casa de Dios, y los tesoros de la Casa de Dios y los tesoros de las cosas consagradas."
,"13":"Asimismo respecto a las clases de los sacerdotes y de los levitas y del ejercicio del servicio de la Casa de Yavé, como también de todos los utensilios del servicio de la Casa de Yavé."
,"14":"Referente al oro le señaló el peso en oro que tendría cada uno de los utensilios de cada servicio, y también la plata, según el peso que correspondía a cada uno de los utensilios de cada clase de servicio;"
,"15":"asimismo el peso de los candelabros de oro y sus lámparas y para los candelabros de plata según el peso de cada candelabro y sus lámparas, conforme al uso de cada candelabro;"
,"16":"y el peso de oro para cada una de las mesas de los panes de la ofrenda y el peso de plata para las mesas de plata;"
,"17":"oro puro para los tenedores, los acetres y los jarros; y asimismo lo correspondiente para las copas de oro, según el peso de cada copa y para las copas de plata, según el peso de cada copa; para el altar del incienso, oro acrisolado según el peso."
,"18":"Asimismo el modelo del carro, con los querubines que extienden las alas y cubren el Arca de la Alianza de Yavé."
,"19":"Todo esto está en un escrito de la mano de Yavé, que me dio a conocer todos los detalles del diseño."
,"20":"David dijo además a su hijo Salomón: '¡Sé fuerte y ten buen ánimo; y manos a la obra! No temas ni desmayes, porque Yavé, Dios, el Dios mío, está contigo, no te dejará ni te desamparará, hasta que acabes toda la obra para el servicio de la Casa de Yavé."
,"21":"Ahí tienes las clases de los sacerdotes y de los levitas para todo el servicio de la Casa de Yavé; estarán a tu lado, para cada tipo de obra, todos los hombres de buena voluntad y hábiles para cualquier clase de servicio; también los jefes y el pueblo entero están a tus órdenes.'"
}`)
	CurrentBook.AddChapter(29, `{
"1":"El rey David dijo a toda la asamblea: 'Mi hijo Salomón, al que Dios eligió, es todavía muy joven, y la obra es grande; pues esta Casa no es para un hombre, sino para Yavé, Dios."
,"2":"Con todas mis fuerzas he preparado para la Casa de Dios el oro para los objetos de oro, la plata para los objetos de plata, el bronce para los objetos de bronce, el hierro para los de hierro y la madera para los de madera; piedras de ónice y de engaste, piedras brillantes y de varios colores, toda clase de piedras preciosas y piedras de alabastro en abundancia."
,"3":"Fuera de esto, en mi amor por la Casa de mi Dios, doy a la casa de mi Dios el oro y la plata que tengo, además de todo lo que tengo preparado para la Casa del Santuario:"
,"4":"tres mil talentos de oro, del oro de Ofir, y siete mil talentos de plata acrisolada para recubrir las paredes de los edificios."
,"5":"El que quiera, pues, puede hacer una ofrenda a manos llenas a Yavé, oro para los objetos de oro, plata para los de plata y para todas las obras de los artesanos.'"
,"6":"Entonces los cabezas de familia, los jefes de las tribus de Israel, los jefes de mil y de cien, los encargados de las obras reales,"
,"7":"se comprometieron a dar, para el servicio de la Casa de Dios, cinco mil talentos de oro, diez mil monedas de oro y diez mil talentos de plata, dieciocho mil talentos de bronce y cien mil talentos de hierro."
,"8":"Los que tenían piedras preciosas las entregaron para el tesoro de la Casa de Yavé, en manos de Jejiel el guersonita."
,"9":"Y el pueblo se alegró por estas ofrendas voluntarias; porque de todo corazón lo habían ofrecido espontáneamente a Yavé. También el rey David tuvo una gran alegría."
,"10":"Después David bendijo a Yavé en presencia de toda la asamblea. Dijo: 'Bendito tú, oh Yavé, Dios de nuestro padre Israel, desde siempre hasta siempre."
,"11":"Tuya, oh Yavé, es la grandeza, la fuerza, la magnificencia, la duración y la gloria; pues tuyo es cuanto hay en el cielo y en la tierra."
,"12":"Tuya, oh Yavé, es la realeza; tú estás por encima de todo. Te acompañan la gloria y las riquezas. Tú eres dueño de todo; en tu mano están el poder y la fortaleza y es tu mano la que todo lo engrandece y a todo da consistencia."
,"13":"Pues bien, oh Dios nuestro, te celebramos y alabamos tu nombre magnífico."
,"14":"¿Quién soy yo, y quién es mi pueblo para que tengamos con qué ofrecerte todo esto? Porque todo viene de ti, y de tu mano proviene lo que te damos."
,"15":"Porque somos forasteros y huéspedes delante de ti como todos nuestros padres; nuestros días sobre la tierra pasan como sombras y no hay esperanza."
,"16":"Yavé, Dios nuestro, todo lo que amontonamos para edificar una Casa para tu Santo Nombre viene de tu mano; todo es tuyo."
,"17":"Bien sé, Dios mío, que tú pones a prueba los corazones y amas la rectitud de corazón. Tú sabes que todo te lo ofrecí espontáneamente y ahora veo con alegría que tu pueblo, que está aquí, te ofrece espontáneamente sus dones."
,"18":"Oh, Yavé, Dios de nuestros padres Abraham, Isaac e Israel, conserva perpetuamente estos pensamientos en el corazón de tu pueblo, y dirige tú su corazón hacia ti."
,"19":"Da a mi hijo Salomón un corazón perfecto, para que guarde tus mandamientos, tus instrucciones y tus preceptos, y lo ponga todo por obra y edifique la Casa que yo he preparado.'"
,"20":"Después dijo David a toda la asamblea: 'Bendigan a Yavé su Dios', y toda la asamblea bendijo a Yavé, el Dios de sus padres, y se arrodillaron para postrarse ante Yavé y ante el rey."
,"21":"Al día siguiente sacrificaron víctimas a Yavé y le ofrecieron holocaustos: mil novillos, mil carneros y mil corderos, con sus libaciones, y muchos sacrificios por todo Israel."
,"22":"Aquel día comieron y bebieron ante Yavé con gran gozo. Luego proclamaron segundo rey a Salomón hijo de David, lo ungieron en nombre de Yavé y del sacerdote Sadoq."
,"23":"Salomón se sentó como rey sobre el trono de Yavé en el lugar de su padre David. Prosperó y todo Israel le obedeció."
,"24":"Todos los jefes, los valientes y también todos los hijos del rey David, juraron obediencia al rey Salomón."
,"25":"Yavé engrandeció en gran manera a Salomón a los ojos de todo el pueblo de Israel, y le dio un reinado glorioso como nunca había tenido ninguno de los que habían tenido el mando en Israel antes que él."
,"26":"David, hijo de Jesé, había reinado sobre todo Israel."
,"27":"El tiempo que duró su reinado sobre Israel fue de cuarenta años. En Hebrón reinó siete años y en Jerusalén treinta y tres."
,"28":"Murió al fin de una vejez dichosa, lleno de días, de riquezas y gloria; y le sucedió en el trono su hijo Salomón."
,"29":"Los hechos del rey David, desde los primeros a los últimos, están escritos en el libro de la historia del vidente Samuel, en el libro del profeta Natán y en el del vidente Gad,"
,"30":"con la historia de todo su reinado y sus hazañas y las cosas que le sobrevinieron a él, a Israel y a todos los reinos de los demás países."
}`)

}
func ES_LBL_LoadVH1RChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"El rey David se estaba poniendo viejo, tenía mucha edad; aunque lo tapaban con frazadas, no podía calentarse."
,"2":"Sus servidores le dijeron: 'Que vayan a buscar para el rey mi señor a una joven virgen, que esté a su servicio, lo cuide, duerma con él y dé calor al rey mi señor'."
,"3":"Buscaron pues a través de todo el territorio de Israel a una joven hermosa y hallaron a Abisag de Sunam; la llevaron donde el rey."
,"4":"Esa joven era realmente muy hermosa, cuidaba al rey, lo servía, pero éste no tuvo relaciones con ella."
,"5":"Por ese entonces, Adonías, hijo de Jaguit, se adelantaba: 'Yo soy quien reinará', decía. Se había comprado un carro con caballos y cincuenta hombres corrían delante de él."
,"6":"Su padre nunca le habíado parado los pies y ni siquiera le había dicho: '¿Qué estás haciendo?' Su madre lo había dado a luz después de Absalón y era también muy buen mozo."
,"7":"Sostuvo conversaciones con Joab, hijo de Seruya, con el sacerdote Ebiatar, quienes le prestaron ayuda,"
,"8":"pero el sacerdote Sadoc, Benaías hijo de Yoyada, el profeta Natán, Simei y Rei, como también los valientes de David, no lo siguieron."
,"9":"Un día Adonías inmoló ovejas, bueyes y terneros gordos cerca de la Roca que se desliza, al lado de la fuente de Fulón. Invitó a todos sus hermanos, los hijos del rey y a todos los hombres de Judá que estaban al servicio del rey;"
,"10":"pero no invitó al profeta Natán, ni a Benaías, ni a los valientes ni a su hermano Salomón."
,"11":"Entonces Natán dijo a Betsabé, la madre de Salomón: '¿No sabes que tenemos un nuevo rey, Adonías, hijo de Jaguit? Y David, nuestro señor, no tiene ni idea de esto."
,"12":"Ahora te doy un consejo si es que quieres salvar tu cabeza y la de tu hijo Salomón."
,"13":"Anda a ver al rey David y dile: El rey mi señor se dignó hacer este juramento a su sirvienta: Quien reinará después de mí es tu hijo Salomón, él se sentará en mi trono. ¿Cómo es que Adonías ahora se hace rey?"
,"14":"Y mientras estés tú hablando con el rey, yo entraré luego y reafirmaré tus palabras.'"
,"15":"Betsabé se dirigió pues a la pieza del rey, que era muy viejo y era cuidado por Abisag de Sunam."
,"16":"Se arrodilló y se postró delante del rey, éste le dijo: '¿Qué quieres?'"
,"17":"Le respondió: '¿No hizo mi señor este juramento a su sirvienta por Yavé su Dios: Tu hijo Salomón reinará después de mí, él se sentará en mi trono?"
,"18":"Pues bien, Adonías se ha proclamado rey sin que tú, mi señor rey, lo sepas."
,"19":"Inmoló una cantidad de bueyes, de terneros gordos, de carneros; invitó a todos los hijos del rey como también al sacerdote Ebiatar y al general Joab, pero no a tu servidor Salomón."
,"20":"Mientras tanto todo Israel tiene los ojos fijos en ti, el rey mi señor, para que tú designes a tu sucesor."
,"21":"¿No ves que cuando el rey mi señor se acueste con sus padres, yo y mi hijo Salomón pagaremos todo esto?'"
,"22":"Aún no había terminado de hablar cuando llegó el profeta Natán."
,"23":"Le anunciaron al rey: 'Aquí está el profeta Natán'. Entró donde el rey, se postró con el rostro en tierra,"
,"24":"y luego dijo: 'Señor rey, a lo mejor decidiste que Adonías sea rey después de ti y que se siente en tu trono,"
,"25":"pues ahora bajó a inmolar una cantidad de bueyes, de terneros gordos y de carneros. Invitó a todos los hijos del rey, a los jefes del ejército y al sacerdote Ebiatar, y en estos momentos están comiendo y tomando con él y exclaman: '¡Viva el rey Adonías!"
,"26":"Pero yo, tu servidor, el sacerdote Sadoc, Benaías, hijo de Yoyada, y tu servidor Salomón no fuimos invitados."
,"27":"¿Es posible que esto proceda del rey mi señor? ¿Es posible que haya ocultado a sus servidores el nombre del que se sentará en el trono después de él?'"
,"28":"El rey David respondió: 'Llámenme a Betsabé'. Entró ésta donde el rey y se detuvo ante él."
,"29":"El rey hizo este juramento: 'Te juro por la vida de Yavé, que me libró de todas mis dificultades, que hoy mismo voy a ratificar el juramento que hice por Yavé, Dios de Israel."
,"30":"Porque lo dije muy bien: 'Tu hijo Salomón reinará después de mí, él se sentará en mi trono en vez de mí'."
,"31":"Betsabé se arrodilló, se postró con el rostro en tierra delante del rey y dijo: '¡Viva para siempre mi señor el rey David!'"
,"32":"Luego ordenó el rey David: 'Llámenme al sacerdote Sadoc, al profeta Natán y a Benaías hijo de Yoyada'. Y se presentaron ante el rey."
,"33":"El rey les dijo: 'Reúnan a los servidores de su señor, hagan que mi hijo Salomón monte en mi propia mula y bajarán con él a la fuente de Guijón."
,"34":"Allí, el sacerdote Sadoc y el profeta Natán lo consagrarán como rey de Israel; tocarán el cuerno y todo el mundo exclamará: ¡Viva el rey Salomón!"
,"35":"Luego subirán tras él y vendrá a sentarse en mi trono. Porque él va a reinar en mi lugar, a él lo he elegido para que dirija a Israel y a Judá'."
,"36":"Benaías, hijo de Yoyada respondió al rey: '¡Amén! ¡Que Yavé, el Dios de mi señor el rey lleve todo eso a cabo!"
,"37":"¡Que Yavé esté ahora con Salomón como lo estuvo con el rey mi señor, que haga su trono más glorioso aún que el trono de mi señor el rey David!'"
,"38":"El sacerdote Sadoc, el profeta Natán y Benaías, hijo de Yoyada, hicieron montar a Salomón en la mula del rey David y lo condujeron a Guijón escoltado por los quereteos y los peleteos."
,"39":"El sacerdote Sadoc tomó el cuerno de aceite de la Tienda y consagró a Salomón, al toque del cuerno, mientras todo el pueblo exclamaba: '¡Viva el rey Salomón!'"
,"40":"Luego subió todo el pueblo tras él; la gente tocaba la flauta y daba muestras de una gran alegría; la tierra temblaba con el bullicio que hacían."
,"41":"Adonías y todos sus invitados escucharon el eco cuando terminaban su banquete. Joab oyó el sonido del cuerno: '¿Por qué, dijo, ese bullicio de una ciudad en fiesta?'"
,"42":"Todavía estaba hablando cuando llegó Jonatán, el hijo del sacerdote Ebiatar. Adonías le dijo: 'Acércate, porque eres hombre y seguramente traes buenas noticias'."
,"43":"Pero Jonatán le respondió: '¡Todo lo contrario! Nuestro señor el rey David ha consagrado a Salomón como rey."
,"44":"El rey lo mandó junto con el sacerdote Sadoc, el profeta Natán, Benaías hijo de Yoyada, los quereteos y los peleteos. Lo subieron a la mula del rey"
,"45":"y luego, en Guijón, el sacerdote Sadoc y el profeta Natán lo consagraron como rey. Subieron lanzando gritos de alegría y la ciudad está de fiesta, ese es el ruido que ustedes oyeron."
,"46":"Y más aún. Salomón se sentó en el trono del rey"
,"47":"y los servidores del rey han venido a felicitar a nuestro señor el rey David: Que tu Dios, decían, haga el nombre de Salomón más glorioso aún que el tuyo, que ensalce su trono aún más que el tuyo. Hasta el mismo rey se ha inclinado en su lecho,"
,"48":"y ha dicho esto: ¡Bendito sea Yavé, el Dios de Israel, porque ha permitido que mis ojos vean a uno de mis descendientes sentado en mi trono!'"
,"49":"Ante esas palabras, todos los invitados de Adonías fueron presa del pánico, se levantaron y salieron cada cual para su lado."
,"50":"Adonías tuvo miedo de Salomón, se levantó y fue a asirse a los cuernos del altar."
,"51":"Le comunicaron a Salomón: Mira cómo Adonías tiene miedo del rey Salomón, se ha asido de los cuernos del altar y ha dicho: Que me jure ahora el rey Salomón que no me hará morir a espada'."
,"52":"Salomón respondió: 'Si se comporta como un hombre honrado, ni uno solo de sus cabellos caerá en tierra, pero si se porta mal, morirá'."
,"53":"El rey mandó gente para que lo bajaran del altar, y Adonías fue a postrarse ante el rey Salomón. Este le dijo: 'Regresa a tu casa'."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Cuando David sintió que se acercaba el día de su muerte, le dio sus instrucciones a su hijo Salomón:"
,"2":"Me voy por el camino de todo el mundo, muéstrate valiente y sé un hombre."
,"3":"Permanece fiel a Yavé, tu Dios, anda por sus caminos, observa sus leyes, sus mandamientos, sus ordenanzas y sus preceptos, tales como están escritos en la ley de Moisés. De ese modo te irá bien en todo lo que hagas"
,"4":"y Yavé mantendrá la palabra que me dijo: Si tus hijos vigilan su comportamiento, si caminan delante de mí sinceramente con todo su corazón y con toda su alma, tendrás siempre un descendiente en el trono de Israel."
,"5":"Tú sabes muy bien lo que me hizo Joab, hijo de Seruya, quien dio muerte a dos jefes del ejército de Israel, Abner, hijo de Ner, y Amasa, hijo de Yeter. Derramó en tiempo de paz la sangre de guerra; esa sangre de guerra ha rebotado en el cinturón puesto alrededor de mis riñones y en las sandalias que llevo en los pies."
,"6":"Tú pues no dejes que sus cabellos blancos bajen en paz a la morada de los muertos."
,"7":"Te mostrarás generoso con los hijos de Barcilay de Galaad: comerán a tu mesa porque salieron a recibirme cuando huía de tu hermano Absalón."
,"8":"Cerca de ti tienes a Simei, hijo de Guera, el benjaminita de Bajurim que me insultó cuando huía hacia Majanayim. Me maldijo de una manera horrible pero, cuando fue a recibirme en el Jordán, le juré por Yavé que no lo condenaría a muerte."
,"9":"Ya que tú eres sabio y sabes lo que debes hacer, no dejarás sin castigo su falta y harás que sus cabellos blancos bajen con sangre a la morada de los muertos'."
,"10":"Después David se acostó con sus padres y lo enterraron en la ciudad de David."
,"11":"David había reinado cuarenta años en Israel: siete años en Hebrón y treinta y tres en Jerusalén."
,"12":"Salomón se sentó en el trono de David su padre, y su realeza se afirmó."
,"13":"Un día fue Adonías, hijo de Jaguit, donde Betsabé, la madre de Salomón. Ella le dijo: '¿Vienes con buenas intenciones?' Respondió: 'Sí'."
,"14":"Y agregó: 'Quisiera hablarte'. Ella le dijo: 'Habla'."
,"15":"Entonces él dijo: 'Tú sabes que la realeza me pertenecía; todos los israelitas estaban conmigo para que fuese su rey, pero se me escapó la realeza y mi hermano la heredó, Yavé se la dio."
,"16":"Tengo sin embargo que pedirte algo, no me lo niegues'. Ella le dijo: 'Habla'."
,"17":"Quisiera, dijo, que hablaras con el rey Salomón, pues no te rechazará. Dile que me dé como mujer a Abisag la sunamita'."
,"18":"Betsabé le respondió: 'Muy bien, hablaré de eso al rey'."
,"19":"Betsabé entró en la casa de Salomón para transmitirle el pedido de Adonías. El rey salió a recibirla, se inclinó delante de ella y luego se sentó en su trono. Pusieron un trono para la madre del rey, la que se sentó a su derecha."
,"20":"Ella entonces le dijo: 'Sólo tengo que pedirte una pequeña cosa, óyeme'. El rey le dijo: 'Madre, pide, te escucho'."
,"21":"Ella le dijo: 'Permite que Abisag la sunamita sea dada como esposa a tu hermano Adonías'."
,"22":"El rey Salomón respondió a su madre: '¿Por qué pides a Abisag la sunamita para Adonías? Pide mejor para él la realeza, pues es mi hermano mayor y están con él el sacerdote Ebiatar y Joab, hijo de Seruya'."
,"23":"Entonces el rey Salomón juró por Yavé: '¡Que Dios me maldiga una y otra vez si Adonías no paga con su vida esa palabra que ha dicho!"
,"24":"Lo juro por Yavé, que ha confirmado mi poder, que me hizo sentar en el trono de David mi padre y que me dio una casa como lo había prometido, que hoy mismo Adonías será ejecutado'."
,"25":"El rey Salomón encargó el asunto a Benaías, hijo de Yoyada, quien hirió de muerte a Adonías."
,"26":"En cuanto al sacerdote Ebiatar, el rey le dijo: 'Vuélvete a tu propiedad de Anatot. Mereces la muerte, pero no te condenaré ahora a muerte, porque tú transportaste el Arca de Dios delante de mi padre y compartiste los sufrimientos de mi padre'."
,"27":"Salomón expulsó pues a Ebiatar, lo privó de su cargo de sacerdote de Yavé; así se cumplió la palabra que Yavé había dicho en contra de la casa de Helí en Silo."
,"28":"Llegó la noticia donde Joab. Joab, si bien no había seguido a la facción de Absalón, había en cambio seguido el partido de Adonías. Se refugió pues en la Tienda de Yavé y se asió a los cuernos del altar."
,"29":"Avisaron al rey Salomón que Joab se había refugiado al lado del altar en la Tienda de Yavé. Salomón mandó decir a Joab: '¿Por qué te refugiaste junto al altar?' Joab le dijo: 'Tuve miedo de ti y me refugié al lado de Yavé'. Entonces Salomón mandó a Banaías, hijo de Yoyada, con esta orden: 'Ve y mátalo'."
,"30":"Benaías entró en la Tienda de Yavé y le dijo: 'El rey te ordena que salgas'. Pero él respondió: '¡No, moriré aquí!' Benaías transmitió esas palabras al rey: 'Esto es lo que dije a Joab, y esto fue lo que me respondió'."
,"31":"El rey le dijo: 'Haz como él dice: mátalo y luego entiérralo. Así apartarás lejos de mí y de la casa de mi padre la sangre inocente que derramó Joab."
,"32":"Yavé hará que recaiga su sangre sobre su propia cabeza, porque hirió de muerte a dos hombres más justos y mejores que él. Mató a espada, a espaldas de David mi padre, a Abner hijo de Ner, jefe del ejército de Israel, y a Amasa hijo de Yeter, jefe del ejército de Judá."
,"33":"La sangre de ellos recaerá sobre la cabeza de Joab y sobre su familia para siempre, pero David y su descendencia, su casa y su trono estarán en paz con Yavé para siempre'."
,"34":"Benaías, hijo de Yoyada, subió pues e hirió de muerte a Joab. Lo enterraron en su casa en el desierto."
,"35":"El rey puso luego a Benaías, hijo de Yoyada, al frente del ejército en reemplazo de Joab; también el rey puso al sacerdote Sadoc en vez de Ebiatar."
,"36":"Después el rey mandó llamar a Simei y le dijo: 'Constrúyete una casa en Jerusalén, vivirás en ella y no saldrás de allí."
,"37":"El día en que salgas y atravieses el torrente del Cedrón, ten por seguro que morirás, y tú serás responsable de tu propia muerte'."
,"38":"Simei respondió al rey: '¡Muy bien! Tu servidor hará como el rey mi señor lo acaba de decir'. Y Simei se quedó muchos días en Jerusalén."
,"39":"Sin embargo, después de tres años, dos de los siervos de Simei huyeron a donde el rey de Gat, Aquis, hijo de Maacay. Le avisaron a Simei: 'Tus siervos están en Gat'."
,"40":"Simei se arregló, ensilló su burro y se dirigió a Gat, donde Aquis, para recuperar a sus siervos. Luego Simei trajo de vuelta de Gat a sus siervos."
,"41":"Le comunicaron a Salomón que Simeí había ido de Jerusalén a Gat y que había vuelto."
,"42":"El rey entonces mandó llamar a Simei: 'En nombre de Yavé te lo había dicho y te lo había advertido solemnemente: El día en que salgas y vayas para acá o para allá, morirás. Tú entonces respondiste: Muy bien."
,"43":"¿Por qué entonces no respetaste tu juramento hecho en nombre de Yavé ni la orden que te había dado?'"
,"44":"El rey dijo además a Simei: 'Tú sabes el mal que hiciste a mi padre David y todas las desgracias que pediste para él. Ahora, Yavé hace recaer sobre tu cabeza la desgracia,"
,"45":"y al contrario, el rey Salomón será bendito y el trono de David se mantendrá para siempre delante de Yavé'."
,"46":"El rey dio una orden a Benaías, hijo de Yoyada, quien salió e hirió a Simei, que murió. De ese modo se afirmó el poder real en las manos de Salomón."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Salomón pasó a ser yerno del Faraón de Egipto; se casó con la hija del Faraón y se la llevó a la ciudad de David, porque aún no había terminado de construir su casa, la Casa de Yavé y la fortaleza de Jerusalén."
,"2":"El pueblo ofrecía entonces sacrificios en los Lugares Altos porque aún no había sido construida la Casa destinada al Nombre de Yavé."
,"3":"Por este mismo motivo Salomón ofrecía sacrificios en los Lugares Altos y quemaba allí perfumes, a pesar de que amaba a Yavé y seguía los preceptos de David, su padre."
,"4":"El rey se dirigió a Gabaón para ofrecer allí sacrificios, pues era el principal Lugar Alto. Salomón ofreció muchos sacrificios en ese altar, más de mil holocaustos."
,"5":"Allí en Gabaón Yavé se le apareció en sueños a Salomón durante la noche. Le dijo: 'Pídeme lo que quieras y te lo daré'."
,"6":"Salomón le respondió: 'Tú has mostrado una bondad muy grande para con tu servidor David, mi padre; es cierto que caminó en tu presencia en la fidelidad, la justicia y la sinceridad. Tú no has puesto fin a esa bondad hacia él, pues has querido que su hijo esté ahora sentado en su trono."
,"7":"Tú me has hecho rey, Yavé, Dios mío, en lugar de mi padre David. Pero yo soy todavía muy joven y no sé aún actuar."
,"8":"Tu servidor se las tiene que ver con tu pueblo, al que tú mismo elegiste, y es un pueblo tan numeroso que no se lo puede ni calcular ni contar."
,"9":"Concéde pues a tu servidor que sepa juzgar a tu pueblo y pueda distinguir entre el bien y el mal. ¿Quién podría en realidad gobernar bien a un pueblo tan importante?"
,"10":"Le agradó al Señor el pedido de Salomón,"
,"11":"y Dios le dijo: 'No has pedido para ti una larga vida, ni la riqueza ni la muerte de tus enemigos, y en cambio me pediste la inteligencia para ejercer la justicia."
,"12":"Pues bien te voy a conceder lo que me pediste. Te doy un corazón tan sabio e inteligente como nadie lo ha tenido antes que tú y como nadie lo tendrá después de ti."
,"13":"Y además te daré lo que tú no has pedido: tendrás riquezas y gloria más que ningún otro rey de la tierra durante tu vida."
,"14":"Si andas por mis caminos, si observas mis ordenanzas y mis mandamientos como lo hizo tu padre David, te daré larga vida'."
,"15":"Entonces se despertó Salomón y comprendió que había sido un sueño. Cuando regresó a Jerusalén, fue a rendir homenaje al Arca de la Alianza de Yavé y ofreció holocaustos y sacrificios de comunión; después dio un gran banquete a todos sus servidores."
,"16":"Fueron dos prostitutas al tribunal del rey."
,"17":"Una de ellas le dijo: 'Señor, atiéndeme; esa mujer y yo vivíamos en la misma casa y en esa casa di a luz a un niño."
,"18":"Tres días después del parto, ella dio a luz también a un niño. Estábamos juntas, ninguna persona extraña estaba con nosotras, éramos las únicas en la casa."
,"19":"Pues bien, durante la noche murió el hijo de esa mujer porque ella se acostó encima de él."
,"20":"Entonces se levantó a medianoche, tomó a mi hijo que estaba a mi lado mientras yo dormía, lo acostó a su lado y puso al niño muerto al lado mío."
,"21":"Por la mañana, cuando me levanté para dar de mamar a mi hijo, vi que estaba muerto, pero al mirarlo con más atención, me di cuenta de que no era el hijo que había dado a luz'."
,"22":"En ese momento la otra mujer se puso a gritar: '¡Mi hijo es el que está vivo y el tuyo es el que está muerto!' Y la primera replicó: '¡No es cierto, tu hijo es el que está muerto y el mío está vivo!' Y ambas discutían en presencia del rey."
,"23":"El rey tomó la palabra: 'Tú dices: Mi hijo está vivo y el tuyo está muerto. Y tú dices: ¡No! porque es tu hijo el que está muerto mientras que el mío está vivo'."
,"24":"El rey ordenó: 'Tráiganme una espada'. Le llevaron al rey una espada."
,"25":"Entonces el rey dijo: 'Corten en dos al niño que está vivo y denle una mitad a una y la otra mitad, a la otra'."
,"26":"Entonces la mujer cuyo hijo estaba vivo dijo al rey, porque se le conmovieron sus entrañas de madre: 'No, por favor, señor, denle a ella mejor el niño que está vivo, pero que no lo maten'. Pero la otra replicaba: 'Pártanlo, así no será ni mío ni tuyo'."
,"27":"El rey entonces decidió: 'Den el niño que está vivo a la primera, no lo maten, porque ella es su madre'."
,"28":"Todo Israel oyó hablar de la sentencia que había pronunciado el rey; desde entonces hubo un gran respeto por el rey porque se veía que la sabiduría de Dios estaba con él cuando administraba justicia."
}`)
	CurrentBook.AddChapter(4, `{
"1":"El rey Salomón reinó en todo Israel."
,"2":"Estos fueron los funcionarios que tenía a su servicio: Azarías, hijo de Sadoc, era sacerdote;"
,"3":"Elijaf y Ajías, hijo de Sisa, eran secretarios; Josafat, hijo de Ayilud, era archivero;"
,"4":"Benaías, hijo de Yoyada, comandaba el ejército; Sadoc y Ebiatar eran sacerdotes;"
,"5":"Azarías, hijo de Natán, era jefe de los prefectos; Zabud, hijo de Natán, era consejero del rey;"
,"6":"Ajisar era mayordomo de palacio; Eliab, hijo de Joab, estaba encargado del ejército; Adoram, hijo de Abda, era jefe de los obreros públicos."
,"7":"Salomón tenía doce gobernadores establecidos en todo Israel; aprovisionaban al rey y a su palacio cada cual durante un mes por año."
,"8":"Estos son sus nombres: Ben-Hur en la montaña de Efraín;"
,"9":"Ben-Dequer en Majas, Saalbim, Bet-Semés, Ayalón y Bet-Janán;"
,"10":"Ben-Yeud en Arubot, también tenía a su cargo Soco y todo el territorio de Jefer;"
,"11":"Ben-Abinadab en las lomas de Dor, su mujer Tabaat era hija de Salomón;"
,"12":"Baana, hijo de Ajilud, en Tanac y Megido y hasta más allá de Jocneam, también tenía a Bet-seán abajo de Yisreel y de Bet-seán hasta Abel-Mejola, en dirección a Sartán."
,"13":"Ben-Gueber en Ramot de Galaad: tenía los campamentos de Yair, hijo de Manasés, en Galaad, y el territorio de Argob en el Basán, o sea sesenta ciudades fortificadas, con murallas y candados de bronce."
,"14":"Ajinadab, hijo de Ido, en Majanayim;"
,"15":"Ajimaas en Neftalí, quien se casó también con una hija de Salomón, llamada Basemat."
,"16":"Baana, hijo de Jusai, para Aser y para la costa rocosa;"
,"17":"Josafat, hijo de Paruaj, para Isacar;"
,"18":"Simei, hijo de Ela, para Benjamín;"
,"19":"Gueber, hijo de Uri, para el territorio de Gad y el territorio de Sijón, rey de los amorreos y de Og, rey de Basán, y cuidaba todo lo de aquel país."
,"20":"Judá e Israel eran tan numerosos como la arena en la orilla del mar; se comía, se tomaba y se vivía feliz."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Salomón extendió su autoridad sobre todos los reinos, desde el Río hasta el territorio de los filisteos y hasta la frontera con Egipto. Todos esos pueblos estaban sometidos a Salomón y le entregaban su tributo."
,"6":"Salomón tenía cuatro mil establos para sus carros y sus doce mil caballos."
,"9":"Dios le dio a Salomón la sabiduría, una inteligencia muy grande, y una ciencia tan amplia como la arena que está en la orilla del mar."
,"10":"La sabiduría de Salomón superaba a la sabiduría de cualquier sabio de Oriente y a toda la sabiduría de Egipto."
,"11":"Fue más sabio que cualquier otro, más sabio que Etán el Ezrajita, más que Jemán, Calcol y Darda, los hijos de Majol. Su fama se extendió por todos los países vecinos."
,"12":"Pronunció tres mil sentencias, compuso mil cinco cánticos,"
,"13":"habló sobre las plantas, desde el cedro del Líbano hasta el musgo que brota en los muros; habló sobre los animales, los pájaros, los reptiles y los peces."
,"14":"De todos los países venían a oír la sabiduría de Salomón y recibió regalos de todos los reyes de la tierra que habían oído hablar de su sabiduría."
,"15":"Cuando Hiram, rey de Tiro, supo que Salomóon había sido consagrado como rey en lugar de su padre, le envió una embajada, porque Hiram se había mostrado siempre como el amigo de David."
,"16":"Salomón mandó luego este mensaje a Hiram:"
,"17":"Como tú lo sabes, Yavé puso al final a todos los enemigos de David bajo la planta de sus pies, pero esas guerras le impidieron a mi padre construir un templo para el Nombre de Yavé, su Dios."
,"18":"Ahora que Yavé, mi Dios, me ha dado la paz por todos los lados, y que no hay más enemigos ni pestes,"
,"19":"pienso edificar ese templo para el Nombre de Yavé, mi Dios. El mismo declaró a David, mi padre: 'Tu hijo, al que pondré en tu trono en vez de ti, será quien construya la Casa de mi Nombre'."
,"20":"Sabes que nadie entre nosotros es tan hábil para cortar los árboles como la gente de Sidón; ordena pues que corten para mí cedros del Líbano. Mis sirvientes trabajarán con los tuyos y yo pagaré lo que me digas para el salario de tus sirvientes'."
,"21":"Hiram se sintió muy contento al oír las palabras de Salomón, dijo: '¡Bendito sea ahora Yavé, porque dio a David un hijo tan sabio para que gobierne a ese gran pueblo!'."
,"22":"Hiram respondió a Salomón: 'Recibí tu mensaje, haré lo que me pides respecto a la madera de cedro y de ciprés."
,"23":"Mis sirvientes los bajarán desde el Líbano hasta el mar y luego haré que los remolquen en balsas hasta el lugar que me indiques; allí los haré desembarcar y tú los tomarás. Por mi parte te pido que me proporciones víveres para mi casa'."
,"24":"Hiram entregó a Salomón toda la madera de cedro y de ciprés que quería;"
,"25":"Salomón por su parte dio a Hiram veinte mil medidas de trigo para la mantención de su casa y veinte mil medidas de aceite de oliva. Eso fue lo que Salomón entregaba cada año a Hiram."
,"26":"Yavé dio la sabiduría a Salomón tal como lo había prometido, de tal modo que reinó la paz entre Hiram y Salomón: los dos firmaron una alianza."
,"27":"El rey Salomón reclutó entre los israelitas a treinta mil hombres para trabajos públicos,"
,"28":"los mandó al Líbano por turno: diez mil por mes. Estaban un mes en el Líbano y dos meses en sus casas. Adoram era responsable de esos trabajos."
,"29":"Salomón disponía de setenta mil hombres para transportar la carga y de otros ochenta mil para tallar la piedra en las montañas,"
,"30":"sin contar los tres mil trecientos jefes de obra puestos por Salomón para supervisar al pueblo que trabajaba en las canteras."
,"31":"El rey ordenó extraer grandes piedras, piedras seleccionadas, para hacer los fundamentos del Templo con piedra tallada."
,"32":"Los obreros de Salomón, los obreros de Hiram y los habitantes de Biblos tallaron las piedras y prepararon la madera para la construcciòn del Templo."
}`)
	CurrentBook.AddChapter(6, `{
"1":"El año 480 después de la salida de los israelitas de Egipto, el cuarto año del reinado de Salomón en Israel, el segundo mes, el mes de Ziv, comenzó la obra de la Casa o Templo de Yavé."
,"2":"Tenía treinta metros de largo, diez de ancho y quince metros de alto."
,"3":"El vestíbulo que precedía al Santuario de la Casa tenía diez metros de ancho y cinco metros de fondo."
,"4":"Las ventanas de la Casa estaban guarnecidas de rejas."
,"5":"A lo largo de los muros de la Casa se construyó una galería que rodeaba el Santuario y el Santo de los Santos. En derredor se abrían piezas laterales."
,"6":"La galería de abajo tenía un ancho de dos metros y medio, la intermedia tenía tres, y la tercera tres metros y medio, porque se habían dispuesto retretes por el contorno exterior de la Casa para no cortar los muros."
,"7":"Para construir la Casa, se usaban piedras talladas en las canteras; mientras duró la construcción no se oyó en la Casa ni martillo ni hacha ni ninguna herramienta de fierro."
,"8":"La entrada de la galería inferior estaba al lado derecho de la Casa. A la galería intermedia se subía por escaleras, y de allí, a la galería superior."
,"9":"Salomón comenzó la obra de la Casa y la terminó. Le puso un cielo raso con molduras y tableros de cedro."
,"10":"A la galería que rodeaba completamente la Casa le dio dos metros de alto. Sus postes de cedro se apoyaban en la casa."
,"11":"Una palabra de Yavé fue dirigida a Salomón para decirle:"
,"12":"Si caminas según mis leyes y pones en práctica mis ordenanzas, si observas mis mandamientos y regulas tu conducta por ellos, yo cumpliré, por medio de esta Casa que estás construyendo, la promesa que hice a tu padre David:"
,"13":"Habitaré en medio de los israelitas y no abandonaré a mi pueblo Israel'."
,"14":"Salomón construyó la Casa y la terminó.)"
,"15":"En el interior, los muros estaban cubiertos desde el suelo hasta el cielo raso con planchas de cedro; todo el interior estaba cubierto de madera y el suelo estaba cubierto con un piso de ciprés."
,"16":"El fondo de la Casa estaba recubierto de planchas de cedro desde el suelo hasta el cielo raso: allí construyó el Santo de los Santos."
,"17":"La Casa por delante del Santo de los Santos tenía veinte metros."
,"18":"En el interior de la Casa, el cedro había sido esculpido en forma de calabazas y de guirnaldas de flores: todo estaba revestido de cedro y no se veían las piedras."
,"19":"El Santo de los Santos, en lo más interior de la Casa, había sido preparado para poner allí el Arca de la Alianza de Yavé."
,"20":"Delante del Santo de los Santos, que tenía diez metros de largo, diez de ancho y diez de alto, se levantó un altar de cedro recubierto de oro fino."
,"21":"Salomón revistió de oro fino el interior de la Casa y una cadena enchapada en oro cerraba el Santo de los Santos."
,"22":"Toda la Casa estaba pues recubierta de oro; también estaba recubierto de oro el altar ubicado delante del Santo de los Santos."
,"23":"En el Santo de los Santos puso dos Querubines de madera de olivo silvestre de cinco metros de alto."
,"24":"Cada una de las alas del querubín tenía dos metros y medio de largo, de manera que había cinco metros de una punta a la otra de las alas."
,"25":"El segundo querubín medía también cinco metros; ambos querubines tenían el mismo porte y la misma forma."
,"26":"La altura del primero y del segundo era de cinco metros."
,"27":"Salomón puso los querubines en el centro de la Casa, con las alas desplegadas; el ala del primero rozaba uno de los muros y el ala del segundo tocaba el otro muro, y sus alas se tocaban una con otra en el medio de la Casa."
,"28":"Salomón revistió de oro a los querubines."
,"29":"Hizo esculpir en relieve en todas las paredes de la Casa, por todo el derredor, tanto por fuera como por dentro, querubines, palmas y flores."
,"30":"Por dentro y por fuera, el piso de la Casa estaba recubierto de oro."
,"31":"Las puertas del Santo de los Santos eran de madera de olivo silvestre, el dintel y los postes ocupaban la quinta parte de la puerta,"
,"32":"ambas puertas de madera de olivo silvestre estaban esculpidas con querubines, palmas y flores; todo estaba recubierto de oro, incluso los querubines y las palmas."
,"33":"De igual modo la entrada del Santuario estaba guarnecida de postes de madera de olivo silvestre, que ocupaban un cuarto de la puerta."
,"34":"Las dos puertas eran de madera de ciprés; cada una estaba constituida por dos paneles que se articulaban;"
,"35":"allí habían esculpido querubines, palmas y flores, todo recubierto de oro."
,"36":"Se construyó el patio interior con tres hileras de piedra tallada y una hilera de postes de cedro."
,"37":"El año cuarto, en el mes de Ziv, se pusieron los cimientos de la Casa de Yavé,"
,"38":"y en el undécimo año, en el mes de Bul, el mes octavo, se terminó el Templo con todos sus detalles, de acuerdo al plano que se había diseñado; Salomón construyó el Templo en siete años."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Salomón construyó también su palacio: demoró trece años en terminarlo."
,"2":"Construyó la casa del Bosque del Líbano; tenía cincuenta metros de largo, veinticinco de ancho y quince de alto. Se alzaba sobre postes de cedro que descansaban en bases de cedro."
,"3":"Un cielo raso de cedro que cubría los cuartos era soportado por cuarenta y cinco columnas repartidas en tres filas de a quince."
,"4":"También había tres filas de cuartos cuyas ventanas se enfrentaban cada tres pasos."
,"5":"Las puertas y ventanas eran cuadradas y las ventanas estaban frente a frente cada tres pasos."
,"6":"Se hizo un vestíbulo de columnas; su largo era de veinticinco metros y su ancho de quince; por delante se alzaba un pórtico con columnas y peldaños."
,"7":"También hizo Salomón el Vestíbulo del Trono donde administraba justicia, lo llamaban el vestíbulo del Juicio; estaba recubierto de cedro desde el piso hasta el cielo raso."
,"8":"Su casa privada estaba construida de la misma forma, en un segundo patio, luego del Vestíbulo. Salomón construyó para la hija del Faraón, con la que se había casado, una casa igual al Vestíbulo."
,"9":"Todas esas construcciones, desde sus cimientos hasta sus cornisas, habían sido hechas con piedras talladas a la medida y cortadas con cincel."
,"10":"Los cimientos también eran de piedra seleccionada, piedras de grandes dimensiones, de cuatro a cinco metros."
,"11":"Por encima también había piedras seleccionadas talladas a la medida, como asimismo madera de cedro."
,"12":"El gran patio había sido hecho de tres hileras de piedra tallada y de una hilera de postes de cedro, igual que el patio interior y que el vestíbulo de la Casa."
,"13":"Salomón mandó a buscar a Juram de Tiro,"
,"14":"que era hijo de una viuda de la tribu de Neftalí, pero cuyo padre era de Tiro, y que trabajaba el bronce. Era un hombre muy hábil, lleno de sabiduría y de destreza para todo lo que fuera bronce. Llegó pues donde Salomón para ejecutar todos sus trabajos."
,"15":"Fundió las dos columnas de bronce; cada columna tenía nueve metros de alto, un hilo de seis metros medía su circunferencia; la segunda columna era como la primera."
,"16":"Fundió dos capiteles de bronce para la parte superior de las columnas; cada capitel medía dos metros y medio de alto."
,"17":"Los capiteles que se situaban encima de las columnas estaban revestidos de cintas y cadenitas de bronce; había siete en cada capitel."
,"18":"Luego hizo las granadas, que en hileras de a dos, rodeaban a cada cinta, para cubrir los capiteles puestos encima de las columnas."
,"19":"Los capiteles puestos encima de las columnas en el vestíbulo tenían forma de lirio; tenían dos metros de alto."
,"20":"Doscientas granadas rodeaban los capiteles puestos sobre las dos columnas, por encima del zócalo guarnecido de cinta de bronce."
,"21":"Salomón levantó las columnas delante del vestíbulo de la Casa; colocó la primera a la derecha y le puso el nombre de Yaquin; colocó la segunda a la izquierda y le dio el nombre de Boaz."
,"22":"Así terminó la obra de las columnas."
,"23":"También hizo el mar de bronce. Era redondo con cinco metros de diámetro y dos y medio de alto; un cordel de quince metros medía su circunferencia."
,"24":"Debajo del borde había una hilera doble de calabazas de metal fundido."
,"25":"El Mar de bronce se apoyaba en doce bueyes, tres que miraban al norte, tres al oeste, tres al sur y tres al este; la parte posterior de su cuerpo estaba tapada por el Mar que se apoyaba en ellos."
,"26":"El espesor del Mar era de una palma, su borde tenía la forma de una copa, parecido a una azucena; podía contener dos mil medidas."
,"27":"Se fabricaron también diez sustentáculos de bronce; cada uno medía dos metros de largo, dos de ancho y uno y medio de alto."
,"28":"Los sustentáculos eran así: estaban formados de paneles y los paneles se encajaban en marcos."
,"29":"En los paneles encajados en los marcos había leones, toros y querubines; en los marcos, por arriba y abajo, se veían en relieve leones y bueyes."
,"30":"Cada sustentáculo tenía cuatro ruedas de bronce con ejes de bronce; los cuatro pies tenían patas de bronce que sostenían la pileta; estaban fundidas junto con los pies, vueltas hacia adentro."
,"31":"La boca para recibir a la pileta estaba en el interior de la corona del sustentáculo, a la que sobrepasaba por medio metro; esta boca era redonda, tenía un espesor de setenta y cinco centímetros. En esta boca había esculturas, los paneles eran cuadrados y no redondos."
,"32":"Las cuatro ruedas estaban bajo los paneles; los ejes de las ruedas estaban fijos a las patas de bronce; cada rueda tenía setenta y cinco centímetros de alto."
,"33":"Las ruedas eran parecidas a las de un carro. Todo estaba fundido: sus ejes, sus llantas, sus rayos y sus cubiertas."
,"34":"En los cuatro ángulos de los sustentáculos de bronce había junturas y éstas conformaban un cuerpo con el sustentáculo."
,"35":"La corona, que sobresalía medio metro del sustentáculo, conformaba un todo con los apoyos y los paneles."
,"36":"En las placas de los apoyos y en los paneles se grabaron querubines, leones y palmeras, según el espacio disponible; había guirnaldas en derredor."
,"37":"Así fue como se hicieron los diez sustentáculos de bronce fundidos de igual modo, de la misma dimensión y de la misma forma."
,"38":"También se hicieron diez piletas de bronce: cada pileta contenía cuarenta medidas, cada pileta tenía dos metros de diámetro; descansaban en los sustentáculos, cada pileta en el suyo."
,"39":"Pusieron los diez sustentáculos, cinco al lado derecho de la Casa y cinco al lado izquierdo; pusieron el Mar al lado derecho de la Casa cuando se mira al este, es decir hacia el sur."
,"40":"Juram hizo también los calderos, las palas y las copas. Así terminó Juram todos los trabajos que le había encargado el rey Salomón para la Casa de Yavé: "
,"41":"las dos columnas, los capiteles puestos en la parte superior de las columnas, junto con las redes de bronce que los cubrían,"
,"42":"las cuatrocientas granadas repartidas en dos filas y adosadas a la red de bronce que cubrían los capiteles,"
,"43":"los diez sustentáculos de bronce junto con la pileta,"
,"44":"el Mar de bronce y los doce bueyes que lo sostenían,"
,"45":"los calderos, las palas y las copas. Juram hizo en bronce bruñido todos esos objetos que le había encargado el rey Salomón para la Casa de Yavé."
,"46":"El rey los hizo fundir en la llanura del Jordán, cerca del vado de Adán, entre Sucot y Sartán."
,"47":"La cantidad de bronce era tal que era imposible contarla."
,"48":"Salomón hizo también todos los otros objetos que estaban en la Casa de Yavé: el altar de oro, la mesa de oro en la que se ponían los panes de la proposición,"
,"49":"los candelabros de oro puro puestos delante del Santo de los Santos: cinco a un lado y cinco al otro; las flores, las lámparas, los extinguidores de oro,"
,"50":"las palanganas, las vasijas, las escudillas, los incensarios de oro, y también los goznes de oro para el Santo de los Santos y para las puertas de la Casa."
,"51":"Con eso se terminaron los trabajos que había emprendido el rey Salomón para la Casa de Yavé. Entonces mandó traer todo lo que su padre David había dado y consagrado, el oro, la plata y los vasos y lo depositó todo en el tesoro de la Casa de Yavé."
}`)
	CurrentBook.AddChapter(8, `{
"1":"El rey Salomón reunió luego en Jerusalén a los ancianos de Israel, a todos los jefes de las tribus y a los ancianos de las familias israelitas, para trasladar el Arca de la Alianza de Yavé que estaba todavía en la ciudad de David, llamada Sión."
,"2":"Todos los israelitas se reunieron en torno a Salomón para la fiesta de las Tiendas; era el mes de Etanim, el séptimo mes del año."
,"3":"Cuando llegaron los ancianos de Israel, los sacerdotes efectuaron el traslado del Arca."
,"4":"Hicieron que subiera el Arca de Yavé como también la Tienda de las Citas y todos los objetos sagrados que se encontraban en la Tienda."
,"5":"El rey Salomón y toda la comunidad de Israel reunida a su alrededor estaban allí delante del Arca. Ofrecieron sacrificios de ganado menor y mayor en tal cantidad que era imposible contarlos."
,"6":"Los sacerdotes trasladaron el Arca de la Alianza de Yavé a su lugar, en la pieza más santa de la Casa, el Santo de los Santos, debajo de las alas de los Querubines."
,"7":"Los querubines extendían sus alas por encima del sitio donde se ubicaba el Arca y así cubrían el Arca y sus andas."
,"8":"Estas barras eran tan largas que sus puntas se veían desde el Lugar Santo que precede al Lugar Santísimo; pero no se veían desde afuera. Allí han estado hasta hoy día."
,"9":"En el Arca no hay nada más que las dos tablas de piedra que Moisés colocó allí en el Horeb, cuando Yavé pactó la Alianza con los israelitas cuando salieron de Egipto."
,"10":"Cuando los sacerdotes salían del Santo, la nube ocupó la Casa de Yavé."
,"11":"Los sacerdotes no pudieron continuar su servicio litúrgico debido a la nube, porque la Gloria de Yavé ocupaba toda la Casa de Yavé."
,"12":"Entonces Salomón declaró: 'Yavé dijo que habita en la nube;"
,"13":"lo que yo he construido es pues la Casa donde tú moras, el lugar donde tú residirás para siempre'."
,"14":"El rey se volvió para bendecir a toda la comunidad de Israel que estaba allí de pie."
,"15":"¡Bendito sea Yavé, dijo, el Dios de Israel! Lo que su boca había anunciado a mi padre David, su mano acaba de ejecutarlo. Pues él había dicho:"
,"16":"Desde el día en que saqué de Egipto a mi pueblo de Israel, no escogí a ninguna ciudad de entre las tribus de Israel para que se construyese allí un templo donde habitara mi Nombre, sólo elegí a David para que reinara en mi pueblo de Israel."
,"17":"David, mi padre, quiso construir una Casa para el Nombre de Yavé, Dios de Israel."
,"18":"Pero Yavé dijo a David mi padre: Es muy bueno que tengas ese deseo de construir un templo en honor de mi Nombre."
,"19":"Pero, no serás tú quien construya el Templo sino tu hijo, el que nacerá de ti. El construirá la Casa en honor de mi Nombre."
,"20":"Yavé ha cumplido pues la palabra que dijo: yo sucedí a mi padre David y me senté en el trono de Israel, tal como Yavé lo había dicho. Luego edifiqué la Casa en honor de Yavé, Dios de Israel,"
,"21":"y allí le reservé un lugar donde reside el Arca de la Alianza de Yavé, la alianza que concluyó con nuestros padres cuando los sacó de Egipto'."
,"22":"Salomón estaba de pie delante del altar de Yavé, frente a toda la comunidad de Israel. Levantó entonces sus manos al cielo,"
,"23":"y dijo: '¡Yavé, Dios de Israel! Ningún dios arriba en los cielos, abajo en la tierra es semejante a ti, porque tú respetas tu Alianza y tu fidelidad para con tus servidores cuando caminan delante de ti con todo su corazón."
,"24":"Mantuviste la promesa que habías hecho a tu servidor David, mi padre, y hoy has llevado a cabo por ti mismo lo que habías prometido."
,"25":"Ahora Yavé, Dios de Israel, mantén la promesa que hiciste a tu servidor David, mi padre: Si tus hijos velan por su conducta, si caminan delante mío como tú has caminado ante mí, entonces nunca te faltará un descendiente que se siente delante de mí en el trono de Israel."
,"26":"Ahora, Dios de Israel, que se cumpla esa promesa que hiciste a tu servidor David mi padre."
,"27":"¿Podría Dios en realidad habitar en la tierra? ¡Si los cielos y los cielos de los cielos no pueden contenerte, cuánto menos lo podrá esta Casa que he construido!"
,"28":"Sin embargo, Yavé mi Dios, pon atención a la oración y a la súplica de tu servidor, escucha el grito alegre y la oración que tu servidor hace hoy ante ti."
,"29":"Que tus ojos estén abiertos día y noche sobre esta Casa, sobre este lugar del cual has dicho: Allí habitará mi Nombre. Escucha la oración que hará tu servidor en este lugar."
,"30":"Escucha la súplica de tu servidor y de tu pueblo Israel cuando vengan a orar a este lugar. Escúchala desde lo alto del cielo, del lugar donde tú habitas, escucha y perdona."
,"31":"Si alguien peca contra su hermano y éste lo obliga a hacer un juramento solemne, cuando aquél venga a hacer ese juramento en tu Casa delante de tu altar,"
,"32":"escúchalo desde lo alto del cielo e intervén. Juzga a tus servidores, condena al culpable y haz recaer sobre su cabeza su falta, pero haz justicia al inocente proclamando su inocencia."
,"33":"Cuanto tu pueblo Israel haya pecado contra ti y sea aplastado por sus enemigos, si se vuelve a ti y da gloria a tu Nombre, cuando te dirija su oración y su súplica en esta Casa,"
,"34":"escúchalo desde lo alto del cielo. Perdona el pecado de tu pueblo Israel y devuélvelo al país que diste a sus padres."
,"35":"Cuando tu pueblo haya pecado contra ti y se cierre el cielo y no haya más lluvia, si viene a este lugar a orar y a rendir gloria a tu Nombre, si renuncia al pecado por el que lo humillaste,"
,"36":"escúchalo desde lo alto del cielo y perdona el pecado de tus servidores y de tu pueblo Israel. Tú le indicarás el buen camino por donde deben caminar, tú harás caer la lluvia sobre la tierra que diste como herencia a tu pueblo."
,"37":"Cuando haya en el país una hambruna, una peste, una plaga en el trigo, langostas, saltamontes, cuando el enemigo ponga sitio a una de sus ciudades, o también cuando haya una catástrofe o una enfermedad,"
,"38":"si un hombre, si Israel tu pueblo viene a orarte y a suplicarte, si reconoce su falta desde el fondo de su corazón y extiende sus manos hacia esta Casa,"
,"39":"entonces tú, desde lo alto de los cielos donde habitas, escucha y perdona. Tú conoces su corazón, pues tú y nadie más que tú conoce el corazón de todos los hombres: premia a cada uno según sus obras."
,"40":"De esta manera, a lo largo de su vida te temerán en este país que diste a sus padres."
,"41":"Cuando un extranjero que no es de tu pueblo Israel, pero que venga de un país lejano debido a tu Nombre,"
,"42":"porque oyó hablar de tu gran Nombre, de tu mano poderosa y de los grandes golpes que propinas, si viene a orar en esta Casa,"
,"43":"escúchalo desde lo alto del cielo donde habitas, y acoge la solicitud de ese extranjero. De ese modo todos los pueblos de la tierra conocerán tu Nombre, te temerán como lo hace tu pueblo Israel, y sabrán que tu Nombre permanece en esta Casa que he construido."
,"44":"Cuando tu pueblo vaya a la guerra contra sus enemigos por el camino por donde tú lo hayas enviado, si se vuelve hacia esta ciudad que tu elegiste, a esta Casa que construí para tu Nombre,"
,"45":"escucha de lo alto del cielo sus oraciones y sus súplicas y hazle justicia."
,"46":"Cuando hayan pecado contra ti porque nadie está sin pecado cuando estés encolerizado con ellos, los entregues a sus enemigos y sus vencedores los lleven cautivos a su país, lejos o cerca,"
,"47":"si del fondo de su exilio se arrepienten, si se convierten y te dirijen sus oraciones en ese país adonde fueron deportados, si te dicen: Hemos pecado, hicimos lo que es malo, cometimos un crimen,"
,"48":"si del fondo de su destierro se vuelven a ti con todo su corazón y con toda su alma, si te dirijen sus oraciones volviéndose al país que habías dado a sus padres, hacia la ciudad que has elegido y hacia esta Casa que edifiqué en honor de tu Nombre,"
,"49":"escucha desde el cielo donde habitas."
,"50":"Perdona a tu pueblo sus faltas y todos los pecados que ha cometido contra ti; haz que sus vencedores tengan piedad de él,"
,"51":"porque ellos son tu pueblo y tu propiedad personal, a los que sacaste de Egipto, de en medio del horno de hierro."
,"52":"Y tus ojos estarán atentos a la súplica de tu servidor, a la súplica de tu pueblo Israel y los escucharás en todas sus peticiones."
,"53":"Porque tú, Señor Yavé, los has puesto aparte de todos los pueblos de la tierra para que sean tu herencia, tal como lo dijiste por boca de Moisés tu servidor cuando sacaste a nuestros padres de Egipto'."
,"54":"Durante toda esta oración y esta súplica Salomón estuvo de rodillas, con las manos extendidas hacia el cielo frente al altar de Yavé. Cuando hubo terminado,"
,"55":"se levantó y bendijo a toda la comunidad de Israel en voz alta:"
,"56":"Bendito sea Yavé, dijo, porque dio la paz a su pueblo Israel tal como lo había prometido. Ha hecho que se cumplan todas las buenas palabras que dio a oír por boca de Moisés su servidor."
,"57":"Que Yavé, nuestro Dios, esté con nosotros así como lo estuvo con nuestros padres, que no nos abandonde ni nos rechace."
,"58":"Que vuelva nuestros corazones hacia él para que sigamos todos sus caminos y observemos sus mandamientos, las leyes y las ordenanzas que dio a nuestros padres."
,"59":"Que las palabras de esta súplica que he dirigido a Yavé estén presentes día y noche delante de Yavé, nuestro Dios, para que responda a su servidor y a su pueblo Israel según las necesidades de cada día."
,"60":"Y todos los pueblos de la tierra sabrán que Yavé es Dios, y que no hay nadie más que él."
,"61":"Que el corazón de ustedes sea totalmente de Yavé, nuestro Dios; caminen según sus leyes, observen sus mandamientos tal como lo hacemos hoy'."
,"62":"El rey y todo Israel ofrecieron sacrificios delante de Yavé:"
,"63":"Salomón ofreció a Yavé, como sacrificios de comunión, veintidós mil bueyes y ciento veinte mil ovejas. Así fue como el rey y todos los israelitas consagraron la Casa de Yavé."
,"64":"Ese día, el rey consagró también el interior del patio que está delante de la Casa de Yavé; allí ofreció los holocaustos, las ofrendas y las grasas de los sacrificios de comunión, porque el altar de bronce que está delante se hizo muy chico para recibir todos los holocaustos, las ofrendas y las grasas de los sacrificios de comunión."
,"65":"Salomón celebró la fiesta durante siete días junto con todo el pueblo de Israel, una gran muchedumbre que había llegado para congregarse delante de Yavé, desde la entrada de Jamat hasta el Torrente de Egipto."
,"66":"Al octavo día despidió al pueblo; bendijeron al rey y cada uno regresó a su casa, feliz y con el corazón contento por todo el bien que Yavé había hecho a David, su servidor, y a su pueblo Israel."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Cuando Salomón hubo terminado la Casa de Yavé, el palacio real y todo cuanto quiso construir,"
,"2":"se le apareció Yavé por segunda vez, tal como se le había aparecido en Gabaón."
,"3":"Yavé le dijo: 'He escuchado la oración y la súplica que tú has elevado hasta mí, y consagré esta Casa que tú construiste para que en ella habitara mi Nombre para siempre."
,"4":"Si caminas delante de mí como caminó tu padre David, con sinceridad de corazón, con rectitud, si pones en práctica lo que te he mandado, si observas mis leyes y mis ordenanzas,"
,"5":"afirmaré para siempre el trono de tu realeza en Israel tal como se lo prometí a tu padre David: tendrás siempre a uno de tus descendientes en el trono de Israel."
,"6":"Pero si se apartan de mí, ustedes y sus hijos, si no obedecen mis mandamientos ni las leyes que puse ante ustedes, si se van a servir a otros dioses y se arrodillan delante de ellos,"
,"7":"entonces suprimiré a Israel del país que le he dado. Alejaré de mí la Casa que he consagrado a mi Nombre; Israel será motivo de desprecio y de burla entre todos los pueblos,"
,"8":"y esta Casa será causa de asombro para cualquiera que pase por aquí. Dirán: ¿Por qué Yavé ha tratado así a este país y a esta Casa?"
,"9":"Y se les responderá: Abandonaron a Yavé, su Dios, que sacó a sus padres de la tierra de Egipto, se apegaron a otros dioses, se postraron ante ellos y los sirvieron; por eso Yavé les ha mandado todas esas calamidades.'"
,"10":"Durante los veinte años en que Salomón estuvo construyendo las dos casas, la Casa de Yavé y el palacio real,"
,"11":"Jiram, rey de Tiro, proveyó a Salomón de madera de cedro y de ciprés, en la cantidad que quisiese; al cabo de ese tiempo el rey Salomón dio a Jiram veinte ciudades en Galilea."
,"12":"Jiram dejó Tiro para ir a ver las ciudades que Salomón le había dado; muy decepcionado dijo a Salomón:"
,"13":"¿Qué pueblos son esos que tú me has dado, hermano mío? Y las llamó 'Tierra de Cabul', que es el nombre que han conservado hasta hoy día."
,"14":"Jiram había mandado a Salomón ciento veinte talentos de oro."
,"15":"Aquí viene lo referente al trabajo forzado, a esos hombres que Salomón había requisado para construir la Casa de Yavé, su propio palacio, el Millo, la muralla de Jerusalén, Jazor, Meguido y Gacer ("
,"16":"pues el faraón, rey de Egipto, había subido y se había apoderado de Gacer; incendió la ciudad y mató a todos los cananeos que allí vivían, luego dio la ciudad como dote a su hija, mujer de Salomón."
,"17":"Salomón reconstruyó pues Gacer), Bethorón de abajo,"
,"18":"Baalat, Tamar en el desierto,"
,"19":"todas las ciudades de depósito que tenía Salomón, las ciudades para los carros y para los caballos y todo lo que Salomón quiso construir en Jerusalén, en el Líbano, y en todos los territorios que le estaban sometidos."
,"20":"Fueron requisados todo lo que quedaba de los amorreos, de los hititas, de los pereseos, de los jeveos y de los jebuseos, en una palabra, todos los que no eran israelitas."
,"21":"A todos sus hijos que quedaban en el territorio, y que no habían sido exterminados por los israelitas, Salomón los sometió a trabajos forzados y lo están aún hoy."
,"22":"Pero no requisó a los israelitas; estos servían como soldados, integraban la guardia, eran oficiales, escuderos, jefes de carros o soldados de caballería."
,"23":"Capataces nombrados por los prefectos eran los encargados de los trabajos del rey: eran ciento cincuenta que mandaban a los trabajadores en los talleres."
,"24":"Luego que la hija del faraón subió de la ciudad de David a la casa que Salomón se había construido, éste edificó el Millo."
,"25":"Salomón ofrecía tres veces al año holocaustos y sacrificios de comunión en el altar que había mandado hacer para Yavé. Allí hacía que se quemaran sus ofrendas en el fuego ante Yavé y se preocupaba por el buen estado de la Casa."
,"26":"El rey Salomón construyó una flota en Asiongaber, al lado de Elat, a orillas del Mar Rojo, en el territorio de Edom."
,"27":"Jiram envió a sus servidores, marineros que conocían bien el mar, para que ayudaran a los servidores de Salomón en sus embarcaciones."
,"28":"Llegaron hasta Ofir donde consiguieron oro, cuatrocientos veinte talentos que llevaron al rey Salomón."
}`)
	CurrentBook.AddChapter(10, `{
"1":"La fama de Salomón llegó hasta donde la reina de Saba; fue a ponerlo a prueba con enigmas de sabiduría."
,"2":"Entró en Jerusalén con un considerable cortejo y con camellos que llevaban perfumes, oro en una gran cantidad y piedras preciosas. Cuando fue introducida a donde estaba Salomón, le dijo todo lo que tenía en la cabeza."
,"3":"Salomón respondió a todas sus preguntas; nada había de oculto para el rey, nada quedaba sin respuesta."
,"4":"La reina de Saba pudo ver el orden instaurado por Salomón: el palacio que había construido,"
,"5":"lo que se servía en su mesa, los departamentos de sus servidores, los trajes de sus ministros, los uniformes de sus mozos, los holocaustos que ofrecía en la Casa de Yavé; se le cortó la respiración."
,"6":"Entonces dijo al rey: '¡Realmente era verdad todo lo que había oído decir en mi país de ti y de tu sabiduría!"
,"7":"No creía lo que se decía sin antes verlo con mis propios ojos, pero es un hecho que no me habían dicho ni la mitad. Tú superas en sabiduría y en gloria lo que tu fama me había transmitido."
,"8":"¡Felices tus mujeres, felices tus servidores que están continuamente delante de ti y que oyen tus sabias decisiones!"
,"9":"¡Bendito sea Yavé tu Dios que te eligió para que te sentaras en el trono de Israel! Yavé ama a Israel para siempre y es por eso que te ha puesto como rey, para que hagas reinar el derecho y la justicia'."
,"10":"Ella regaló al rey ciento veinte talentos de oro, perfumes en gran cantidad y piedras preciosas; nunca se había visto llegar una tal cantidad de perfumes como la que la reina de Saba obsequió al rey Salomón."
,"11":"La flota de Jiram que había traído oro de Ofir, había también transportado madera de sándalo en gran cantidad y además piedras preciosas."
,"12":"Con la madera de sándalo el rey hizo un balcón para la Casa de Yavé, y otro para su palacio. Igualmente mandó hacer con esa madera cítaras y arpas para los músicos; nunca se había visto tal cantidad de sándalo."
,"13":"El rey Salomón dio a la reina de Saba todo lo que ésta podía desear, todo lo que pidió, sin contar los regalos que le hizo con una generosidad real; luego ella se despidió y se volvió a su país con todos sus servidores."
,"14":"En un solo año llevaban a Salomón seiscientos sesenta y seis talentos de oro,"
,"15":"sin contar las tasas a los viajeros, los impuestos a los comerciantes y todo lo que venía de los reyes de Arabia y de los gobernadores del país."
,"16":"El rey Salomón hizo doscientos grandes escudos de oro; en cada escudo se emplearon seiscientos siclos de oro."
,"17":"También hizo trescientos escuditos de oro, en los que se utilizaron tres minas de oro por escudo; el rey los puso en la casa del Bosque del Líbano."
,"18":"El rey hizo además un gran trono de marfil cubierto de oro."
,"19":"El trono tenía seis gradas, era un sillón con un respaldo redondo y a ambos lados del trono, brazos que se apoyaban en leones."
,"20":"También había doce leones que estaban de pie al lado de las seis gradas del trono; en ningún reino se había hecho algo semejante."
,"21":"Todas las copas del rey Salomón eran de oro, como también los objetos de la casa del Bosque del Líbano; no había nada de plata, a la que se la consideraba sin valor en los días de Salomón."
,"22":"Salomón tenía en el mar, junto con la flota de Jiram, navíos para las expediciones lejanas. Cada tres años volvía la flota de ultramar, trayendo oro, plata, marfil, monos y pavos reales."
,"23":"El rey Salomón sobrepasó en riqueza y sabiduría a todos los reyes de la tierra."
,"24":"Todo el mundo quería ser recibido en audiencia por Salomón y escuchar la sabiduría que Dios le había dado."
,"25":"Cada cual traía su regalo, objetos de plata y objetos de oro, trajes, armaduras, perfumes, caballos y mulas; y esto era año tras año."
,"26":"Salomón adquirió una gran cantidad de carros y caballos, y los distribuyó en las ciudades de carros y en Jerusalén cerca del rey."
,"27":"El rey actuó tan bien que en Jerusalén la plata era tan común como las piedras, y los cedros tan numerosos como los sicómoros de la planicie costera."
,"28":"Los caballos de Salomón venían de Musur y de Cilicia; los mercaderes del rey los compraban en Cilicia y los trasladaban."
,"29":"Un carro importado de Musur costaba seiscientas piezas de plata, y un caballo ciento cincuenta; también se los exportaba para los reyes de los Hititas y los reyes de Aram."
}`)
	CurrentBook.AddChapter(11, `{
"1":"El rey Salomón amó a muchas mujeres extranjeras:"
,"3":"tuvo setecientas mujeres que eran princesas y trescientas concubinas, (además de la hija del faraón): Moabitas, amorreas, edomitas, sidonias e hititas (y sus mujeres pervirtieron su corazón)."
,"2":"Eran de esas naciones de las cuales había dicho Yavé: 'Ustedes no entrarán en sus casas ni ellas en las de ustedes, porque seguramente los arrastrarán tras otros dioses'. Pero Salomón se apegó a ellas, las amó."
,"4":"Cuando Salomón fue de edad, sus mujeres arrastraron su corazón tras otros dioses; ya no fue totalmente de Yavé Dios como lo había sido su padre David."
,"5":"Salomón siguió a Astarté, la diosa de los sidonios y a Milcom, la abominación de los amorreos."
,"6":"Hizo lo que no gusta a Yavé en vez de obedecer perfectamente como su padre David."
,"7":"Por ese entonces construyó en el cerro, al este de Jerusalén, un santuario a Quemos, la abominación de Moab, y otro a Milcom, la abominación de los amorreos."
,"8":"Eso hizo para todas sus mujeres extranjeras que ofrecían incienso y sacrificios a sus dioses."
,"9":"Yavé se enojó con Salomón porque se había apartado de Yavé Dios de Israel, el que, sin embargo, se le había aparecido dos veces"
,"10":"y le había prohibido que siguiera a otros dioses. Salomón no respetó las órdenes de Yavé,"
,"11":"y Yavé le dijo: 'Ya que tú me has tratado así y no has observado mi alianza ni las leyes que te había dado, te quitaré el reino y se lo daré a tu servidor; está decidido."
,"12":"No haré esto mientras vivas, en consideración a tu padre David, pero a tu hijo se lo quitaré."
,"13":"Y aún así, no le quitaré todo el reino, le dejaré una tribu en consideración a David mi servidor y a Jerusalén que yo elegí'."
,"14":"Yavé le dio a Salomón un adversario, Hadad, que era de la familia real de Edom."
,"15":"Cuando David venció a Edom y Joab, el jefe del ejército, fue allá a enterrar a los muertos, dio muerte a todos los varones de Edom."
,"16":"Joab estuvo seis meses con Israel hasta exterminar completamente a todos los varones de Edom."
,"17":"Pero Hadad había huido junto con edomitas servidores de su padre y refugiádose en Egipto; Hadad era aún muy joven en ese tiempo."
,"18":"Partiendo de Madián, llegaron a Parán, luego continuaron llevando consigo a hombres de Parán. Así llegaron a Egipto donde el faraón, rey de Egipto, quien le dio una casa, víveres y tierras."
,"19":"El faraón apreciaba a Hadad, le dio como esposa a la hermana de su mujer (esposa real se dice Tafnés en egipcio)."
,"20":"La hermana de Tafnés dio un hijo a Hadad, al que llamó Genubat. Tafnés educó a Genubat en la casa del faraón; vivía en el palacio junto con los hijos del faraón."
,"21":"Hadad se enteró en Egipto que había muerto David y también Joab, jefe del ejército; entonces dijo al faraón: 'Déjame volver a mi país'."
,"22":"El faraón le respondió: 'Si nada te falta a mi lado, ¿para qué vas a volver a tu país?' Le dijo: 'Es cierto que nada me falta, pero, déjame volver'. Hadad regresó pues a su país lleno de odio contra Israel, y llegó a ser rey de Edom."
,"23":"Dios le dio otro adversario a Salomón, Rezón hijo de Elyadá. Había huido de la casa de su patrón Hadadecer, rey de Soba,"
,"24":"se le había juntado gente y se había convertido en jefe de bandidos. Cuando David quiso acabar con ellos, se fueron a Damasco y se instalaron allí. Rezón llegó a ser rey de Damasco"
,"25":"y creó problemas a Israel durante toda la vida de Salomón."
,"26":"Jeroboam también se rebeló contra el rey mientras estaba a su servicio. Era hijo de Nabat, originario de Sereda en la tribu de Efraín, y su madre, Seruya, era viuda."
,"27":"Esto fue lo que aconteció: Salomón estaba edificando el Millo y cerrando la brecha de la ciudad de David su padre."
,"28":"Ese Jeroboam era un hombre fuerte y de gran valor, y Salomón se había fijado en la calidad de su trabajo. Lo hizo jefe de los hombres sometidos a trabajos forzados de la casa de José."
,"29":"Un día en que Jeroboam había salido de Jerusalén, el profeta Ajías de Silo lo encontró. El profeta iba vestido con un manto nuevo y estaban los dos solos en el campo."
,"30":"Ajías tomó el manto nuevo que llevaba, lo partió en doce pedazos y dijo a Jeroboam:"
,"31":"Toma para ti diez pedazos, porque esto dice Yavé, el Dios de Israel: Arrancaré el reino de la mano de Salomón, y te daré diez tribus."
,"32":"Sin embargo dejaré una tribu a Salomón en consideración a mi servidor David y a Jerusalén, la ciudad que escogí en medio de todas las tribus de Israel."
,"33":"Haré eso porque me abandonó, porque se postró delante de Astarté, la diosa de los sidonios, delante de Quemós, el dios de Moab, y delante de Milcom, el dios de los amorreos, porque no siguió por mis caminos para hacer lo que es justo a mis ojos, porque no obedeció mis leyes ni mis ordenanzas como David su padre."
,"34":"Sin embargo, mientras viva, no le quitaré nada del reino y lo mantendré en el trono, en atención a David, mi servidor, al que elegí y quien observó mis mandamientos y mis leyes."
,"35":"Le quitaré el reino a su hijo para darte a ti diez tribus;"
,"36":"daré sin embargo una tribu a su hijo para que David mi servidor tenga siempre una lámpara delante de mí en Jerusalén, la ciudad que escogí para que en ella habitara mi Nombre."
,"37":"Haré que reines sobre todo lo que deseas; reinarás en Israel."
,"38":"Si obedeces mis mandamientos, si sigues por mis caminos y haces lo que es justo a mis ojos, observando mis leyes y mis mandamientos tal como lo hizo David, mi servidor, yo estaré contigo. Te construiré una casa tan sólida como la que le edifiqué a David ("
,"39":")'."
,"40":"Salomón trató de asesinar a Jeroboam, pero éste se refugió en Egipto junto a Sesonc, rey de Egipto, y se quedó en Egipto hasta la muerte de Salomón."
,"41":"El resto de los hechos de Salomón, todo lo que hizo y su sabiduría está escrito en el libro de los hechos de Salomón."
,"42":"Salomón reinó en todo Israel desde Jerusalén cuarenta años."
,"43":"Luego fue a acostarse con sus padres y lo enterraron en la ciudad de David, su padre. En su lugar reinó Roboam, su hijo."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Roboam se dirigió a Siquem, porque todo Israel había ido allá para proclamarlo rey."
,"2":"Avisaron de eso a Jeroboam, hijo de Nabat, cuando todavía estaba en Egipto, a donde había huido lejos del rey Salomón; inmediatamente regresó de Egipto."
,"3":"Lo mandaron a buscar, después de lo cual Jeroboam y toda la comunidad de Israel fueron a ver a Roboam y le dijeron:"
,"4":"Tu padre nos impuso un duro yugo. Si nos liberas de esos trabajos forzados, de ese pesado yugo que nos ha impuesto tu padre, te serviremos'."
,"5":"Les respondió: 'Váyanse y vuelvan a verme en tres días'. Y el pueblo se fue."
,"6":"El rey Roboam consultó a los ancianos que habían sido consejeros de su padre Salomón mientras éste vivía. Les dijo: '¿Qué me aconsejan que responda a ese pueblo?'"
,"7":"Le respondieron: 'Si ahora te haces su servidor, si te muestras conciliador en tu respuesta, estarán para siempre a tu servicio'."
,"8":"Pero Roboam no atendió al consejo de los ancianos, más bien se volvió hacia los jóvenes que habían crecido con él, y les pidió su opinión."
,"9":"Les dijo: '¿Qué me aconsejan que le responda a ese pueblo? Saben lo que me dicen: 'Haz que sea menos penoso el yugo que nos ha impuesto tu padre'."
,"10":"Los jóvenes que habían crecido con él le respondieron: 'Ya que esa gente te ha dicho: Tu padre nos impuso un pesado yugo, alivia nuestra carga, tú les responderás: Mi dedo meñique es más fuerte que las espaldas de mi padre."
,"11":"Si mi padre les impuso un pesado yugo, conmigo será peor. Si mi padre los castigaba con correas de cuero, conmigo los látigos tendrán puntas de fierro'."
,"12":"Al tercer día Jeroboam y todo el pueblo de Israel volvieron donde Roboam, pues el rey les había dicho: 'Vuelvan dentro de tres días'."
,"13":"El rey habló al pueblo ásperamente; no tuvo en cuenta el consejo de los ancianos,"
,"14":"sino que les dijo lo que querían los jóvenes: 'Si mi padre hizo pesado su yugo, conmigo será peor. Si mi padre los castigaba con correas de cuero, conmigo los látigos serán de puntas de fierro'."
,"15":"El rey, pues, no escuchó al pueblo; en eso hubo una intervención de Yavé para que se cumpliera lo que había dicho a Jeroboam, hijo de Nabat, por boca de Ajías de Silo."
,"16":"Cuando todo Israel vio que el rey no les hacía caso, el pueblo replicó al rey: '¿Qué tenemos que ver con David? No tenemos nada que heredar del hijo de Jesé. ¡Vamos Israel! ¡A tus tiendas! ¡Que David se las arregle con los suyos!' Y todo Israel regresó a sus hogares."
,"17":"(Los israelitas que vivían en las ciudades de Judá reconocieron a Roboam como rey.)"
,"18":"El rey Roboam envió a Adoniram, jefe de los trabajadores obligados, pero todo Israel lo recibió con piedras y murió. Roboam tuvo que subir a su carro y huyó a Jerusalén."
,"19":"Y hasta ahora, Israel ha renegado de la casa de David."
,"20":"Cuando todo Israel supo que Jeroboam había vuelto, lo mandaron a buscar para una asamblea, y lo hicieron rey de todo Israel; únicamente la tribu de Judá siguió fiel a la casa de David."
,"21":"Después que regresó a Jerusalén, Roboam convocó a toda la casa de Judá y a la tribu de Benjamín, unos ciento ochenta mil hombres preparados para el combate, con el fin de pelear con la casa de Israel y devolver el reino a Roboam hijo de Salomón."
,"22":"Pero en ese momento llegó una palabra de Dios a Semaya, el hombre de Dios:"
,"23":"'Esto dirás a Roboam, hijo de Salomón, rey de Judá, a toda la casa de Judá y de Benjamín, y al resto del pueblo:"
,"24":"No vayan a pelear con sus hermanos, los hijos de Israel. Que cada uno vuelva a su casa porque yo he sido el que dispuso todo eso'. Escucharon la palabra de Yavé y, así como se les dijo, se volvieron a su casa."
,"25":"Jeroboam fortificó Siquem, en la montaña de Efraín; allí vivió un tiempo, luego la dejó por Penuel, a la que también fortificó."
,"26":"Jeroboam pensó: 'El reino podría muy bien volver a la casa de David."
,"27":"Si este pueblo sigue subiendo a Jerusalén para ofrecer sacrificios en la Casa de Yavé, el corazón del pueblo se volverá de nuevo hacia Roboam, rey de Judá, su señor, y me matarán'."
,"28":"Después de haber pedido consejo, el rey Jeroboam mandó hacer dos terneros de oro y dijo al pueblo: '¡No suban más a Jerusalén, ya basta! Israel, aquí está tu Dios que te sacó de la tierra de Egipto.'"
,"29":"Colocó uno de los terneros en Betel y el otro en Dan."
,"30":"De allí partió el pecado de Israel; el pueblo escoltó a uno de los terneros hasta Betel, y fueron en procesión delante del otro hasta Dan."
,"31":"Jeroboam construyó santuarios o Altos Lugares e instaló allí a sacerdotes sacados de entre el pueblo, que no pertenecían a la tribu de Leví."
,"32":"Jeroboam instituyó una fiesta el día quince del octavo mes, como la fiesta que existía en Judá, y sacrificó en el altar. Lo hizo en Betel, donde ofreció sacrificios a los terneros que había hecho, y fue en Betel donde estableció los sacerdotes para los Altos Lugares que había construido."
,"33":"Subió pues al altar el día quince del octavo mes, una fecha que él mismo había elegido y que había convertido en fiesta para los hijos de Israel; subió al altar y quemó en él incienso."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Por orden de Dios, un hombre de Dios llegó a Betel desde Judá, cuando Jeroboam estaba junto al altar quemando el incienso."
,"2":"El hombre de Dios gritó en contra del altar por orden de Yavé: '¡Altar, altar!, esto dice Yavé: nacerá en la casa de David un hijo de nombre Josías. Sacrificará sobre ti a los sacerdotes de los Altos Lugares, a los que queman el incienso en ti, y se quemarán en ti huesos humanos'."
,"3":"Y ese mismo día dio esta señal: 'Esta es la señal que les da Yavé: el altar se partirá y la ceniza que está encima se desparramará'."
,"4":"Cuando el rey Jeroboam escuchó esa maldición del hombre de Dios contra el altar de Betel, extendió la mano y ordenó: '¡Deténganlo!' Pero la mano que había extendido contra el hombre de Dios quedó tiesa y no pudo encogerla."
,"5":"El altar se rompió y la ceniza del altar se desparramó; esa era la señal que había dado el hombre de Dios por orden de Yavé."
,"6":"El rey tomó entonces la palabra y dijo al hombre de Dios: 'Por favor, apacigua a Yavé tu Dios, ruega por mí para que vuelva a mover mi mano'. El hombre de Dios apaciguó a Yavé y la mano del rey volvió a moverse; estaba como antes."
,"7":"El rey dijo entonces al hombre de Dios: 'Ven conmigo a mi casa, recupera tus fuerzas y te daré un regalo'."
,"8":"Pero el hombre de Dios dijo al rey: 'Aunque me dieras la mitad de tu casa, no entraría allí contigo. No comeré pan ni beberé agua en este lugar,"
,"9":"porque la palabra de Dios traía también una orden para mí: No comerás pan ni beberás agua, ni regresarás por el mismo camino por el que viniste'."
,"10":"Se fue pues por otro camino, desviándose del camino por donde había subido a Betel."
,"11":"Había en Betel un viejo profeta, cuyos hijos le fueron a contar todo lo que el hombre de Dios había hecho ese día en Betel; repitieron a su padre todas las palabras que ese hombre había dicho al rey."
,"12":"Su padre les dijo: '¿Por qué camino se fue?' Y sus hijos le indicaron el camino por donde el hombre de Dios, venido de Judá, se había vuelto."
,"13":"Dijo entonces a sus hijos: 'Ensillen mi burro'. Le ensillaron el burro y montó en él."
,"14":"Se fue pues tras el hombre de Dios y lo encontró sentado bajo un terebinto. Le dijo: '¿Tú eres el hombre de Dios que vino de Judá?' Respondió: 'Sí, soy yo'."
,"15":"Le dijo: 'Ven a mi casa para que comas un poco'."
,"16":"El otro respondió: 'No puedo volverme contigo ni entrar en tu casa. No comeré pan ni beberé agua contigo en ese lugar,"
,"17":"porque esta fue la palabra de Yavé: No comerás pan ni beberás agua y no te volverás por el camino por donde te fuiste'."
,"18":"Pero el viejo profeta le replicó: 'Yo también soy un profeta como tú y un ángel me habló. Me transmitió esta orden de Yavé: Haz que se venga contigo a tu casa para que coma pan y beba agua'. Era una mentira."
,"19":"El hombre de Dios se volvió pues con él, comió pan y bebió agua en su casa."
,"20":"Cuando estaban sentados a la mesa, una palabra de Dios fue dirigida al profeta que lo había traído de vuelta."
,"21":"Habló fuerte al hombre de Dios que había subido de Judá: 'Así habla Yavé: Ya que te has rebelado a la orden de Yavé y no has cumplido el mandato que te dio Yavé tu Dios,"
,"22":"puesto que has vuelto sobre tus pasos y has comido aquí pan y bebido agua, siendo que tú habías recibido la orden de no comer ni beber, tu cadáver no entrará en la tumba de tus padres'."
,"23":"Después de haber comido y bebido, el profeta que lo había traído de vuelta le ensilló su burro"
,"24":"y el hombre se fue. Un león lo atacó en el camino y lo mató. Su cadáver quedó en el camino, el burro no lo abandonó y el león se quedó también al lado del cuerpo."
,"25":"La gente que pasaba por allí vio el cadáver en el camino y al león que estaba echado a su lado; cuando llegaron a su casa, contaron lo que habían visto en la ciudad donde vivía el viejo profeta"
,"26":"que lo había desviado de su camino. En cuanto lo supo el profeta, dijo: 'Es el hombre de Dios que desobedeció la orden de Yavé, y Yavé lo entregó al león que lo desgarró y le dio muerte, según la palabra que Yavé había dicho'."
,"27":"Se dirigió en seguida a sus hijos: 'Ensíllenme mi burro', les dijo. Se lo ensillaron."
,"28":"Salió y halló el cadáver atravesado en el camino, junto con el burro y el león que estaban todavía allí, a un lado cada uno. El león no había devorado el cuerpo, ni tampoco había atacado al burro."
,"29":"El profeta levantó el cadáver del hombre de Dios, lo puso sobre su burro y lo trajo de vuelta; cuando llegó a la ciudad, se encargó de los funerales y del entierro."
,"30":"Depositó el cadáver en su propia tumba e hizo duelo por él: '¡Ay, hermano mío!'"
,"31":"Después que lo hubo sepultado, dijo a sus hijos: 'Cuando yo muera, me pondrán en la tumba donde enterré al hombre de Dios. Depositarán mis huesos al lado de los suyos."
,"32":"Porque, se lo digo, se cumplirá la maldición que pronunció por orden de Yavé contra el altar de Betel y contra todos los Lugares Altos de las ciudades de Samaría'."
,"33":"A pesar de eso, Jeroboam no se apartó de su mala conducta. Volvió a elegir sacerdotes entre el pueblo para los Lugares Altos; instituía como sacerdotes a todos los que querían y pasaban a formar parte de los sacerdotes de los Lugares Altos."
,"34":"Esto fue un motivo de pecado para la casa de Jeroboam, por eso fue destruida y exterminada de la tierra."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Por ese tiempo cayó enfermo Abías, hijo de Jeroboam."
,"2":"Jeroboam dijo a su mujer: 'Tú debes hacer esto: disfrázate para que no sepan que eres la mujer de Jeroboam, y luego ve a Silo. Allí está el profeta Ajías que me anunció que reinaría en este pueblo."
,"3":"Llévate diez panes, tortas y un frasco de miel, entrarás en su casa y él te dirá lo que sucederá con el niño'."
,"4":"Así lo hizo la mujer de Jeroboam: se fue para Silo y entró en la casa de Ajías. Este ya no podía ver, tenía fija la vista por su avanzada edad."
,"5":"Pero Yavé había transmitido una palabra a Ajías: 'La mujer de Jeroboam viene a consultarte respecto de su hijo que está enfermo, le dirás esto. Cuando se presente, se hará pasar por otra'."
,"6":"Así pues, cuando cruzó el umbral de la puerta y Ajías oyó el ruido de sus pasos, éste le dijo: 'Entra, mujer de Jeroboam. ¿Por qué te hacer pasar por otra? Se me ha encargado para ti un terrible mensaje."
,"7":"Tú repetirás a Jeroboam esta palabra de Yavé, Dios de Israel: Te elegí en medio de mi pueblo para hacerte el jefe de mi pueblo Israel."
,"8":"Le quité el reino a la casa de David para dártelo a ti. Pero tú no has sido como mi servidor David, quien cumplía mis mandamientos, caminaba con todo su corazón siguiéndome, y hacía lo que es recto a mis ojos."
,"9":"Tú has actuado peor que todos los anteriores a ti, te has hecho otros dioses, ídolos de metal que sólo me irritan y me has dejado tirado."
,"10":"Por todo eso haré que sobrevenga la desgracia a la casa de Jeroboam, exterminaré a todos los varones, sean esclavos o libres en Israel. Barreré con la casa de Jeroboam como se barre la basura, hasta que no quede nada."
,"11":"El de la casa de Jeroboam que muera en la ciudad será devorado por los perros, y el que muera en el campo será devorado por las aves: Yavé es quien lo dice'."
,"12":"Y en cuanto a ti, levántate y vuelve a tu casa. Apenas atraviesen tus pasos la puerta de la ciudad, el niño morirá."
,"13":"Todo Israel lo llorará y lo enterrarán; será el único de la casa de Jeroboam que reciba una sepultura, porque es el único de la casa de Jeroboam en quien Yavé, Dios de Israel, encontró algo bueno."
,"14":"Yavé instalará en Israel un rey que hará desaparecer la estirpe de Jeroboam; el castigo está cerca; ya está ahí."
,"15":"Yavé sacudirá a Israel como una caña llevada por la corriente, arrancará a Israel de este buen país que dio a sus padres, los dispersará al otro lado del Río, porque han provocado la cólera de Yavé con sus postes sagrados."
,"16":"Entregará a Israel por culpa de los pecados que cometió Jeroboam y que hizo cometer a Israel'."
,"17":"La mujer de Jeroboam se levantó y se fue a Tirsa. En los momentos en que atravesaba el umbral de su casa, el niño murió."
,"18":"Lo enterraron y todo Israel lo lloró, según la palabra que Yavé había dicho por medio de su servidor Ajías, el profeta."
,"19":"El resto de los hechos de Jeroboam, sus guerras y su reinado, todo eso está escrito en el libro de las Crónicas de los reyes de Israel."
,"20":"Jeroboam reinó veintidós años, luego se acostó con sus padres y reinó en su lugar su hijo Nadab."
,"21":"Roboam, hijo de Salomón, reinó en Judá; tenía cuarenta y un años cuando subió al trono. Reinó diecisiete años en Jerusalén, la ciudad que había elegido Yavé entre todas las tribus de Israel para que en ella habitara su Nombre. Su madre era Naama la amorrea."
,"22":"Judá hizo lo que disgusta a Yavé, y provocaron su cólera con sus pecados mucho más que sus padres."
,"23":"También edificaron Altos Lugares con piedras paradas y postes sagrados en todas las altas colinas y bajo cualquier árbol verde."
,"24":"Hubo además homosexuales sagrados en el país e imitaron todas las prácticas vergonzosas de los paganos que había expulsado Yavé ante los israelitas."
,"25":"El quinto año del reinado de Roboam, Sesonc, rey de Egipto, atacó Jerusalén."
,"26":"Se apoderó de los tesoros de la Casa de Yavé y de los tesoros del palacio real: se apoderó de todo. Tomó todos los escudos de oro que había hecho Salomón;"
,"27":"en vez de ellos, el rey Roboam mandó hacer escudos de bronce, y los puso en las manos de los que iban corriendo delante de su carro y de los guardias de la entrada del palacio real."
,"28":"Cada vez que iba el rey al Templo de Yavé, los que corrían delante de él los tomaban y luego los devolvían a la sala de guardia."
,"29":"El resto de los hechos de Roboam, todo lo que hizo, está escrito en el libro de las Crónicas de los reyes de Judá."
,"30":"Hubo una guerra continua entre Roboam y Jeroboam."
,"31":"Cuando Roboam se acostó con sus padres, lo enterraron en la ciudad de David; en su lugar reinó Abiam, su hijo."
}`)
	CurrentBook.AddChapter(15, `{
"1":"El décimo octavo año del reinado de Jeroboam, hijo de Nabat, pasó a ser rey de Judá Abiam."
,"2":"Reinó tres años en Jerusalén; su madre era Maaca, hija de Absalón."
,"3":"Imitó todos los pecados que sus padres habían cometido antes que él, su corazón no fue totalmente de Yavé como lo había sido el corazón de su antepasado David."
,"4":"Pero Yavé quería conservar una lámpara a David en Jerusalén: su hijo reinó en su lugar después de él y Jerusalén fue protegida."
,"5":"Es que David había hecho lo que es recto a los ojos de Yavé, no se había apartado durante toda su vida de los mandamientos que había recibido, excepto en el caso de Urías el hitita."
,"7":"El resto de los hechos de Abiam, todo lo que hizo, está escrito en el libro de las Crónicas de los reyes de Judá. Hubo guerra entre Abiam y Jeroboam."
,"8":"Cuando Abiam se acostó con sus padres, lo enterraron en la ciudad de David; en su lugar reinó Azá, su hijo."
,"9":"El vigésimo año de Jeroboam, rey de Israel, Azá pasó a ser rey de Judá."
,"10":"Reinó cuarenta y un años en Jerusalén; su abuela era Maaca, hija de Absalón."
,"11":"Azá hizo lo que es justo a los ojos de Yavé, tal como David su padre;"
,"12":"hizo que desaparecieran del país los prostitutos y destruyó todos los ídolos que habían hecho sus padres."
,"13":"Incluso quitó a su abuela Maaca la dignidad de Gran Dama, porque ella había hecho un ídolo vergonzoso en honor de Astarté; Azá derribó ese ídolo vergonzoso y lo quemó en el valle del Cedrón."
,"14":"Los Altos Lugares no desaparecieron; eso no impidió que Azá cumpliera fielmente sus deberes con Yavé toda su vida."
,"15":"Depositó en la Casa de Yavé los objetos que había consagrado su padre, como también los que había consagrado él: plata, oro y vasos."
,"16":"Hubo guerra entre Azá y Basá, rey de Israel, durante toda su vida."
,"17":"Basá, rey de Israel, invadió Judá y fortificó Ramá para cortarle las comunicaciones a Azá rey de Judá."
,"18":"Azá juntó entonces toda la plata y todo el oro que quedaban en los tesoros de la Casa de Yavé y en los tesoros del palacio real, se los pasó a sus servidores y los envió donde Ben-Hadad, hijo de Tabinom, hijo de Hezión, que era rey de Aram, en Damasco. Le llevaron este mensaje: "
,"19":"Haya una alianza entre tú y yo, entre mi padre y tu padre. Te mando una gran cantidad de plata y oro, pero con tal que rompas tu alianza con Basá, rey de Israel, para que se aleje de mí'."
,"20":"Ben-Hadad escuchó al rey Azá, envió a sus comandantes a asaltar las ciudades de Israel. Atacó Iyón, Dan, Abel-Bet-Maaca, toda la región del lago de Genezaret y todo el territorio de Neftalí."
,"21":"Al ver eso, Basá suspendió los trabajos de fortificación de Ramá y regresó a Tirsa."
,"22":"El rey Azá entonces convocó a todo Judá, sin que nadie faltara, y sacaron las piedras y madera con que Basá fortificaba Ramá, y el rey Azá las utilizó para fortificar Gueba de Benjamín y Mispá."
,"23":"El resto de los hechos de Azá, sus hazañas, todo lo que hizo, las ciudades que construyó, está escrito en el libro de las Crónicas de los reyes de Judá. Fuera de eso, en su vejez, se enfermó de los pies."
,"24":"Cuando Azá se acostó con sus padres, lo enterraron junto con éstos en la ciudad de David, su antepasado, y en su lugar reinó su hijo Josafat."
,"25":"Nadab, hijo de Jeroboam, pasó a ser rey de Israel en el segundo año de Azá, rey de Judá; reinó dos años en Israel."
,"26":"Hizo lo que es malo a los ojos de Yavé, siguió las huellas de su padre y el pecado a que había arrastrado a Israel."
,"27":"Basá, hijo de Ajías, de la tribu de Isacar, conspiró contra él, y cuando Nadab, junto con todo Israel, sitiaban la ciudad filistea de Guibetón, lo asesinó."
,"28":"Basá lo mató en el tercer año del reinado de Azá de Judá y reinó en su lugar."
,"29":"En cuanto fue rey, acabó con toda la gente de Jeroboam; no le dejó ningún sobreviviente, sino que los mató a todos, según la palabra que Yavé había dicho por medio de su servidor Ajías de Silo."
,"30":"Pues Jeroboam había provocado la cólera de Yavé, Dios de Israel, con los pecados que había cometido y en los cuales había arrastrado a Israel."
,"31":"El resto de los hechos de Nadab, todo lo que hizo, está escrito en el libro de las Cronicas de los reyes de Israel."
,"33":"El tercer año del reinado de Azá de Judá, comenzó a reinar en Israel, desde Tirsa, Basá, hijo de Ajías; reinó veinticuatro años."
,"34":"Hizo lo que es malo a los ojos de Yavé, siguió las huellas de Jeroboam y el pecado en el que había arrastrado a Israel."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Una palabra de Yavé fue dirigida a Jehú, hijo de Janani, en contra de Basá:"
,"2":"'Te saqué del polvo y te hice jefe de mi pueblo Israel, pero tú has seguido las huellas de Jeroboam y has hecho que mi pueblo Israel cometa los pecados que provocan mi cólera."
,"3":"Por eso voy a barrer con Basá y su casa, dejaré tu familia igual a la de Jeroboam, hijo de Nabat."
,"4":"Aquel de la familia de Basá que muera en la ciudad será devorado por los perros, y el que muera en el campo será comido por las aves del cielo'."
,"5":"El resto de los hechos de Basá, lo que hizo y sus hazañas, está escrito en el libro de las Crónicas de los reyes de Israel."
,"6":"Cuando Basá se acostó con sus padres, lo enterraron en Tirsa, y su hijo reinó en su lugar, en esa misma ciudad."
,"7":"Pero estaba esa palabra de Yavé dirigida al profeta Jehú, hijo de Janani, en contra de Basá y de su casa, debido al mal que había hecho a los ojos de Yavé: había provocado su cólera con su conducta, imitando a la casa de Jeroboam, pero también por la manera como había acabado con esa familia."
,"8":"El año vigésimo sexto del reinado de Azá de Judá, Elá, hijo de Basá, pasó a ser rey de Israel y reinó dos años en Tirsa."
,"9":"Su servidor Zimri, jefe de la mitad de los carros, conspiró contra él; el rey estaba entonces en Tirsa, tomando y embriagándose en la casa de Arsa, el comandante del palacio real de Tirsa."
,"10":"Era el año vigésimo séptimo del reinado de Azá de Judá; Zimri entró y le dio muerte, y reinó en su lugar."
,"11":"Una vez rey, apenas se sentó en el trono, acabó con toda la gente de Basá; niños, parientes y amigos: no perdonó a ninguno."
,"12":"Así exterminó Zimri a toda la familia de Basá, según la palabra que Yavé había dicho contra Basá por medio del profeta Jehú."
,"13":"Es que los pecados de Basá y de su hijo Elá, quienes arrastraron a Israel a su pecado y sus ídolos, habían provocado la cólera de Yavé, Dios de Israel."
,"14":"El resto de los hechos de Elá, todo lo que hizo, está escrito en el libro de las Crónicas de los reyes de Israel."
,"15":"El año vigésimo séptimo del reinado de Azá de Judá, Zimri llegó a ser rey por siete días en Tirsa. El pueblo sitiaba la ciudad filistea de Guibetón."
,"16":"En el campamento, el pueblo se enteró de la noticia: 'Zimri conspiró contra el rey y lo asesinó'. Ese mismo día, en el campamento, todo Israel proclamó a Omri, comandante en jefe del ejército, como rey de Israel."
,"17":"Omri y todo Israel subieron entonces de Guibetón para sitiar Tirsa."
,"18":"Cuando Zimri vio que la ciudad estaba a punto de caer, se encerró en la fortaleza del palacio, le prendió fuego y así murió en el incendio del palacio."
,"19":"Pues también había cometido los pecados que disgustan a Yavé, había seguido las huellas de Jeroboam y el pecado con que éste había arrastrado a Israel."
,"20":"El resto de los hechos de Zimri, la conspiración que tramó, todo eso está escrito en el libro de las Crónicas de los reyes de Israel."
,"21":"El pueblo de Israel se dividió: unos querían nombrar rey a Tibni, hijo de Guinat, otros estaban con Omri;"
,"22":"los partidarios de Omri ganaron a los de Tibni, hijo de Guinat: Tibni murió y Omri pasó a ser rey."
,"23":"Omri llegó a ser rey de Israel el año treinta y uno del reinado de Azá en Judá; reinó doce años."
,"24":"Después de haber reinado seis años en Tirsa, compró a Semer la colina de Samaría en dos talentos de plata y comenzó a construir en esa colina."
,"25":"Omri hizo lo que es malo a los ojos de Yavé, imitó la mala conducta de todos los que habían reinado antes que él,"
,"26":"siguió las huellas de Jeroboam, hijo de Nabat, y los pecados que había cometido y a los que había arrastrado a Israel: sus ídolos provocaron la cólera de Yavé, Dios de Israel."
,"27":"El resto de los hechos de Omri, lo que hizo, sus hazañas, todo eso está escrito en el libro de las Crónicas de los reyes de Israel."
,"28":"Cuando Omri se acostó con sus padres, lo enterraron en Samaría; en su lugar reinó su hijo Ajab."
,"29":"Ajab, hijo de Omri, llegó a ser rey de Israel el año trigésimo octavo del reinado de Azá de Judá. Ajab, hijo de Omri, reinó veintidós años en Israel desde Samaría."
,"30":"Ajab hizo lo que es malo a los ojos de Yavé y fue peor que todos los reyes anteriores."
,"31":"No le bastó con imitar los pecados de Jeroboam, hijo de Nabat; habiendo tomado como esposa a Jezabel, hija de Itobaal, rey de los sidonios, se puso a servir a su Baal y a postrarse ante él."
,"32":"Le levantó un altar en el templo a Baal que construyó en Samaría."
,"33":"Ajab levantó también un poste sagrado y por sus muchos otros pecados provocó la cólera de Yavé, Dios de Israel, mucho más que todos los demás reyes de Israel que habían venido antes que él."
,"34":"En su tiempo, Jiel de Betel refundó Jericó. Puso sus cimientos a costa de su primogénito Abiram, y cuando instaló las puertas, sacrificó a su segundo hijo Segub, según la palabra que había dicho Yavé por medio de Josué, hijo de Nun."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Elías, que era de Tisbé de Galaad, fue a decir a Ajab: 'Tan cierto como que vive Yavé, Dios de Israel, a quien sirvo, que no habrá estos años ni rocío ni lluvia, a menos que yo lo ordene'."
,"2":"Una palabra de Yavé fue dirigida a Elías:"
,"3":"Sal de aquí y anda al este. Te esconderás en el torrente de Queret, al este del Jordán."
,"4":"Tomarás agua del torrente y he ordenado a los cuervos para que te provean allá abajo'."
,"5":"Salió pues Elías e hizo lo que Yavé le había dicho; fue a instalarse en el torrente de Querit, al este del Jordán,"
,"6":"y los cuervos le traían pan en la mañana y carne en la tarde."
,"7":"Pero al cabo de un tiempo el torrente se secó, porque no caía más lluvia en el país."
,"8":"Le fue dirigida entonces una palabra de Yavé:"
,"9":"Levántate, anda a instalarte en Sarepta, en la región de Sidón. He dado órdenes allá a una viuda para que te alimente'."
,"10":"Se levantó y partió para Sarepta. Cuando llegó a la puerta de la ciudad, había allí una viuda que recogía leña. La llamó y le dijo: '¿Quieres traeme un poco de agua en ese cántaro para que yo beba?'"
,"11":"Cuando iba a buscarla, la llamó y le dijo: ¿Podrías traerme también un trozo de pan?'"
,"12":"Ella le respondió: 'Tan cierto como que vive Yavé, tu Dios, que no tengo nada cocido; sólo tengo un poco de harina en un tiesto y un poco de aceite en un cántaro. Estaba recogiendo dos atados de leña y vuelvo a mi casa para prepararlo para mí y para mi hijo. Lo comeremos y luego vendrá la muerte'."
,"13":"Elías le dijo: 'No temas, anda y haz lo que te digo; sólo que prepara primero un pancito que me traerás, luego harás otro para ti y para tu hijo."
,"14":"Porque esto dice Yavé, Dios de Israel: 'La harina del tiesto no se acabará y el aceite del cántaro no se terminará hasta el día en que Yavé haga llover sobre la tierra'."
,"15":"Ella se fue e hizo tal como le había dicho Elías, y durante mucho tiempo tuvieron qué comer, éste, ella y el hijo."
,"16":"La harina del tiesto no se acabó y el aceite del cántaro no se terminó, según la palabra que Yavé había dicho por boca de Elías."
,"17":"Sucedió después que el hijo de la dueña de casa cayó enfermo; su enfermedad empeoró y exhaló el último suspiro."
,"18":"Entonces ella dijo a Elías: '¿Por qué te has metido en mi vida, hombre de Dios? ¿Has venido a mi casa para poner delante de Dios todas mis faltas y para hacer morir a mi hijo?'"
,"19":"Le respondió: 'Dame a tu hijo'. Elías lo tomó de los brazos de esa mujer, subió al cuarto de arriba, donde se alojaba, y lo acostó en su cama."
,"20":"Luego invocó a Yavé: 'Yavé, Dios mío, dijo, ¿harás que recaiga la desgracia aun sobre esta viuda que me aloja, haciendo que muera su hijo?'"
,"21":"Entonces se tendió tres veces sobre el niño e invocó a Yavé: 'Yavé, Dios mío, devuélvele a este niño el soplo de vida'."
,"22":"Yavé oyó la súplica de Elías y le volvió al niño la respiración: ¡estaba vivo!"
,"23":"Elías tomó al niño, lo bajó del cuarto alto a la casa y se lo devolvió a su madre. Elías le dijo: 'Mira, tu hijo está vivo'."
,"24":"Entonces la mujer dijo a Elías: '¡Ahora sé que tú eres un hombre de Dios y cuando tú dices la palabra de Dios, es verdad!'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Mucho tiempo después -hacía ya tres años- fue dirigida la palabra de Dios a Elías: 'Vete y preséntate a Ajab, pues haré caer la lluvia sobre la tierra'."
,"2":"Partió pues Elías para presentarse ante Ajab. El hambre era terrible en Samaría."
,"3":"Ajab acababa de enviar a Obadías, administrador del palacio real; ese Obadías tenía realmente el temor de Yavé."
,"4":"Cuando Jezabel masacró a los profetas de Yavé, Obadías había tomado a cien de ellos y los había escondido de a cincuenta en cavernas, a donde les llevaba pan y agua."
,"5":"Ajab dijo a Obadías: 'Recorre el país, inspecciona todos los manantiales y todos los torrentes. A lo mejor encontramos hierba para mantener con vida a los caballos y a las mulas en vez de sacrificarlos'."
,"6":"Se repartieron pues el país para recorrerlo: Ajab se fue solo por un camino, y Obadías se fue solo por otro."
,"7":"Cuando Obadías iba de camino, le salió al encuentro Elías. Obadías lo reconoció, se echó con el rostro en tierra y dijo: '¿Eres tú Elías, mi señor?'"
,"8":"Este le respondió: 'Sí, yo soy. Vete a decir a tu amo que he llegado'."
,"9":"Obadías le respondió: '¿Qué pecado cometí para que pongas a tu servidor en manos de Ajab? ¡Me hará morir!"
,"10":"Pues tan cierto como que Yavé, tu Dios, vive, que no hay territorio ni reino a donde mi amo no haya mandado buscarte. Y cuando decían: 'Elías no está aquí', hacía que ese reino o ese territorio jurara que no te había visto."
,"11":"¿Y ahora tendré que decir a mi amo que tú llegaste?"
,"12":"Mientras te deje para ir a informar a Ajab, el espíritu de Yavé te habrá trasladado quién sabe a dónde, y como no te encontrarán, él me mandará ejecutar. Tú sabes, sin embargo, que tu servidor teme a Yavé desde niño."
,"13":"¿No le contaron a mi señor lo que hice mientras Jezabel masacraba a los profetas de Yavé? Escondí a cien profetas de Yavé de a cincuenta en algunas cavernas y les proporcioné pan y agua."
,"14":"Y ¿quieres que vaya a decir a mi amo: '¡Elías está aquí!?' Ciertamente me matará'."
,"15":"Elías le respondió: 'Por Yavé Sabaot, a quien sirvo, hoy mismo yo me presentaré a Ajab'."
,"16":"Obadías fue pues a ver a Ajab para transmitirle la noticia; Ajab fue al encuentro de Elías."
,"17":"En cuanto Ajab divisó a Elías, le dijo: '¡Ah! Aquí está el causante de la desgracia de Israel!'"
,"18":"Elías le respondió: 'No soy yo el causante de la desgracia de Israel, sino tú y la casa de tu padre, porque han abandonado los mandamientos de Yavé y se han vuelto a los Baales."
,"19":"Anda pues a reunir a Israel; que vengan conmigo al monte Carmelo, y con ellos los cuatrocientos cincuenta profetas de Baal que comen de la mesa de Jezabel'."
,"20":"Ajab convocó a todo Israel al monte Carmelo, y también reunió a los profetas."
,"21":"Entonces Elías se acercó al pueblo y dijo: '¿Hasta cuándo saltarán de un pie al otro? Si Yavé es Dios, síganlo; si lo es Baal, síganlo'. El pueblo no respondió."
,"22":"Elías dijo al pueblo: 'Soy el único que queda de los profetas de Yavé, y ustedes ven aquí a cuatrocientos cincuenta profetas de Baal."
,"23":"¡Dennos dos toros! Ellos tomarán uno, lo descuartizarán y lo pondrán sobre la leña sin prenderle fuego. Yo, prepararé el otro toro y lo pondré sobre la leña sin prenderle fuego."
,"24":"Luego invocarán el nombre de su dios; yo invocaré el nombre de Yavé. El Dios que responda enviando fuego, ese es Dios'. Todo el pueblo respondió: '¡Muy bien!'"
,"25":"Elías dijo a los profetas de Baal: 'Como ustedes son más, elijan primero su toro. Prepárenlo, invoquen el nombre de su dios, pero sin prender fuego'."
,"26":"Tomaron pues el toro que les pasaron, lo prepararon e invocaron el nombre de Baal desde la mañana hasta la noche, gritando: '¡Baal, respóndenos!' Pero no se oyó nada ni hubo respuesta alguna mientras saltaban delante del altar que habían levantado."
,"27":"Llegó el mediodía; Elías se mofaba de ellos: '¡Griten más fuerte, les decía. Si bien es dios, tal vez está meditando, o está ocupado o anda viajando; a lo mejor está durmiendo y tienen que despertarlo'."
,"28":"Gritaban pues cada vez más fuerte mientras se hacían, según sus costumbres, incisiones con cuchillos para que corriera la sangre."
,"29":"Siguieron gesticulando toda la tarde hasta el momento en que se presenta la ofrenda vespertina, pero no se oía nada: ¡ni una respuesta, ni tampoco reacción alguna!"
,"30":"Elías dijo entonces a todo el pueblo: 'Acérquense a mí'. Todo el pueblo se acercó a Elías mientras éste levantaba de nuevo el altar de Yavé que había sido derribado."
,"31":"Tomó doce piedras, según el número de las tribus de Jacob, del hombre que había recibido esta palabra de Yavé: 'Tu nombre será Israel'."
,"32":"Elías arregló las piedras, después cavó alrededor del altar una zanja que podía contener como treinta litros de agua."
,"33":"Acomodó la leña, partió en trozos el toro y lo puso sobre la leña."
,"34":"Luego dijo: 'Llenen con agua cuatro cántaros y vacíenla sobre el holocausto y la leña'. Así lo hicieron y les dijo: '¡Háganlo de nuevo!' Lo hicieron por segunda vez. Añadió: '¡Una vez más!' Y lo hicieron por tercera vez."
,"35":"El agua escurría del altar y llenó toda la zanja."
,"36":"En la hora en que se presenta la ofrenda de la tarde, Elías el profeta se adelantó y dijo: 'Yavé, Dios de Abrahán, de Isaac y de Israel, que sepan hoy que tú eres Dios de Israel, que yo soy tu servidor, y que en todo actúo según tu palabra."
,"37":"¡Respóndeme, Yavé, respóndeme! ¡Que sepa este pueblo que tú eres Dios, tú Yavé, y que tú eres el que convierte su corazón!'."
,"38":"Bajó entonces el fuego de Yavé, que consumió el holocausto y la leña y absorbió toda el agua que había en la zanja."
,"39":"Al ver esto, todo el pueblo se echó con el rostro en tierra, gritando: '¡Yavé es Dios! ¡Yavé es Dios!'."
,"40":"Entonces Elías les dijo: '¡Detengan a los profetas de Baal, que no escape ninguno!' Los apresaron; Elías mandó que los bajaran al torrente Cisón y allí los degolló."
,"41":"Elías dijo a Ajab: 'Ahora sube, come y bebe, porque ya está aquí el trueno que anuncia la lluvia'."
,"42":"Ajab subió para comer y beber, mientras Elías subía a la cumbre del Carmelo. Allí se inclinó y puso la cara entre sus rodillas,"
,"43":"luego dijo a su sirviente: 'Sube y mira para el lado del mar'. El muchacho miró y dijo: 'No hay nada'. Elías le dijo: '¡Vuelve de nuevo!' "
,"44":"Cuando volvió la séptima vez, subía desde el mar una nubecita no más grande que la palma de la mano. Elías le dijo entonces: 'Anda a decir a Ajab que enganche su carro y baje, porque si no lo, va a pillar la lluvia'."
,"45":"En poco tiempo el cielo se oscureció, el viento empujó las nubes y cayó la lluvia a torrentes; Ajab se subió a su carro y se volvió a Yizreel."
,"46":"Entonces la mano de Yavé se posó sobre Elías; éste se apretó el cinturón y corrió delante de Ajab hasta la entrada de Yizreel."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Ajab contó a Jezabel todo lo que había hecho Elías y cómo había dado muerte a cuchillo a todos los profetas."
,"2":"Jezabel mandó a decir a Elías: 'Que los dioses me maldigan una y otra vez si mañana, a la misma hora, no he acabado contigo como tú lo hiciste con ellos'."
,"3":"Elías tuvo miedo y huyó para salvar su vida. Llegó a Berseba en el territorio de Judá y allí dejó a su sirviente."
,"4":"Se adentró en el desierto durante todo un día de camino, luego fue a sentarse bajo un retamo y pidió la muerte: 'Basta, dijo. Yavé, toma mi vida, porque ya no valgo más que mis padres'."
,"5":"Se acostó y se quedó dormido. Un ángel tocó a Elías y le dijo: 'Levántate y come'."
,"6":"Miró y vio que había allí cerca de él una tortilla cocida sobre piedras y un cántaro de agua. Comió, bebió y se volvió a acostar."
,"7":"Por segunda vez el ángel de Yavé se le acercó, lo tocó y le dijo: 'Levántate y come, porque el camino es demasiado largo para ti'."
,"8":"Comió y bebió. Confortado con ese alimento, caminó cuarenta días y cuarenta noches hasta llegar al cerro de Dios, el Horeb."
,"9":"Allí se dirigió hacia la caverna y pasó la noche en ese lugar. He aquí que le fue dirigida la palabra de Dios: '¿Elías, qué haces aquí?'"
,"10":"Respondió: 'Ardo de indignación por Yavé Sabaot, porque los hijos de Israel te han abandonado. Han derribado tus altares, dado muerte a cuchillo a tus profetas; sólo he quedado yo y tratan de matarme'."
,"11":"Yavé le respondió: 'Sal fuera y quédate en el monte delante de Yavé'. Y Yavé pasa. Un viento fuerte y violento pasa delante de Yavé, hiende los montes y parte las rocas, pero Yavé no está en el viento. Después del viento viene un terremoto, pero Yavé no está en el terremoto."
,"12":"Después del terremoto, un fuego, pero Yavé no está en el fuego. Después del fuego, se sintió el murmullo de una suave brisa."
,"13":"Cuando Elías la oyó, se cubrió el rostro con el manto, salió y se mantuvo a la entrada de la caverna. Entonces se oyó una voz: '¿Elías, qué haces aquí?'"
,"14":"Respondió: 'Ardo de indignación por Yavé Sabaot, porque los hijos de Israel te han abandonado. Han derribado tus altares, dado muerte a cuchillo a tus profetas; sólo he quedado yo y tratan de matarme'."
,"15":"Yavé le dijo: 'Vuélvete por el mismo camino y anda hasta el desierto de Damasco. Cuando hayas llegado allá consagrarás como rey de Aram a Jazael,"
,"16":"consagrarás a Jehú, hijo de Nimsi, como rey de Israel, y consagrarás a Eliseo, hijo de Safat, de Abel-Mejolá, como profeta en vez de ti."
,"17":"Al que escape a la espada de Jazael, lo hará morir Jehú. Al que escape a la espada de Jehú, lo hará morir Eliseo."
,"18":"Pero dejaré con vida a siete mil hombres en Israel, que son todos aquellos cuyas rodillas no se doblaron delante de Baal y cuya boca no le dio un beso'."
,"19":"Partió de allí Elías y encontró a Eliseo, hijo de Safat, quien estaba arando; tenía doce medias hectáreas de tierra para arar y estaba en la duodécima. Elías se le acercó y le tiró encima su manto."
,"20":"Inmediatamente, dejando sus bueyes, Eliseo corrió tras Elías: 'Permíteme, le dijo, que vaya a abrazar a mi padre y te seguiré'. Pero Elías le respondió: '¡Puedes volverte, era algo sin importancia!'"
,"21":"Eliseo se alejó pero para tomar la yunta de bueyes y sacrificarlos; asó su carne con el yugo y se la sirvió a su gente, luego se levantó, salió tras Elías y entró a su servicio."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Ben-Hadad, rey de Aram, reunió a todo su ejército. Tenía a su lado a treinta y dos reyes, caballos y carros cuando salió para sitiar a Samaría con el fin de apoderarse de ella."
,"2":"Mandó mensajeros a la ciudad donde Ajab, rey de Israel,"
,"3":"para que le entregaran este mensaje: 'Así habla Ben-Hadad: Tu ejército y tu oro son míos, tus mujeres y tus hijos son míos'."
,"4":"El rey de Israel le respondió: 'Tú lo has dicho, rey mi señor, soy tuyo con todo lo que me pertenece'."
,"5":"Pero los mensajeros volvieron a decir a Ajab de parte de Ben-Hadad: 'Si te dije: Dame tu oro y tu plata, tus mujeres y tus hijos,"
,"6":"ten por seguro que mañana a la misma hora enviaré a mis servidores a tu casa. Registrarán tu casa y las casas de tus servidores, y recogerán y traerán para acá todo lo que les guste'."
,"7":"Entonces el rey de Israel convocó a los ancianos del país y les dijo: 'Miren, es evidente que este nos odia. Cuando me reclamó mis mujeres y mis hijos, mi plata y mi oro, nada le negué'."
,"8":"Todos los ancianos y todo el pueblo le dijeron: 'No le hagas caso. No hay que aceptarlo'."
,"9":"Entonces dijo a los mensajeros de Ben-Hadad: 'Digan esto al rey mi señor: Haré lo que me pediste la primera vez, pero esta nueva exigencia no la puedo aceptar'. Los mensajeros se fueron llevando esa respuesta."
,"10":"Entonces Ben-Hadad le mandó a decir: '¡Maldíganme los dioses una y otra vez si de Samaría queda bastante polvo para que cada uno de mis soldados se llene con él la cuenca de su mano'."
,"11":"El rey de Israel respondió a los mensajeros: '¡Digan a su patrón que el que toma la espada no debe enorgullecerse tanto como el que la deja!'"
,"12":"El otro estaba tomando con los reyes en su tienda cuando le transmitieron esa respuesta; dijo entonces a sus servidores: '¡A sus puestos de combate!' Y tomaron ubicación frente a la ciudad."
,"13":"En ese momento se acercó al rey de Israel un profeta quien le dijo: 'Escucha esta palabra de Yavé: ¿Ves ese gran ejército? Hoy lo entregaré en tus manos y sabrás así que yo soy Yavé'."
,"14":"Ajab le dijo: '¿Quién hará eso?' Le respondió: 'Yavé dijo: Los jóvenes de los jefes de provincias'. Ajab le replicó: '¿Quién iniciará el ataque?' Le respondió: 'Tú'."
,"15":"Ajab pasó revista a los jóvenes de los jefes de provincias, que eran doscientos treinta y dos. En seguida pasó revista a todo el pueblo, a todos los israelitas: eran siete mil."
,"16":"Al mediodía hicieron una salida, justo cuando Ben-Hadad se estaba emborrachando en su tienda junto con los treinta y dos reyes que habían venido con él."
,"17":"Primero salieron los jóvenes de los jefes de provincias. Se lo comunicaron a Ben-Hadad: 'Han salido unos hombres de Samaría'."
,"18":"El respondió: '¡Ya sea que hayan salido para pelear o para pedir la paz, de todos modos aprésenlos!'"
,"19":"Pero detrás de los jóvenes de los jefes de provincias, salió todo el ejército de la ciudad."
,"20":"Cada uno eliminó a su enemigo, los arameos dieron vuelta la espalda e Israel se lanzó en su persecución. Ben-Hadad, rey de Aram, saltó a un caballo y salió huyendo con sus caballeros."
,"21":"Salió el rey de Israel, reunió a los caballos y a los carros e infligió a Aram una gran derrota."
,"22":"Entonces se acercó al rey de Israel el profeta, quien le dijo: 'Refuérzate y mejora tus defensas, porque a comienzos del próximo año el rey de Aram vendrá de nuevo a atacarte'."
,"23":"Los consejeros del rey de Aram, por su parte, dijeron a éste: 'Los dioses de Israel son dioses de montaña, por eso fueron más poderosos que nosotros. Pero atraigámoslos a la llanura y seguramente tendremos ventaja."
,"24":"Además haz esto: saca de su puesto a todos esos reyes y pon en su lugar a gobernadores."
,"25":"Reúne un ejército tan numerosos como el que perdiste con todos esos caballos y carros, y ataquémoslos en la llanura; con seguridad sacaremos ventaja'. El rey siguió pues su consejo."
,"26":"Al comienzo del año siguiente, Ben-Hadad pasó revista a los arameos y subió a Afec para atacar a Israel."
,"27":"También se pasó revista a los israelitas, recibieron víveres y avanzaron al encuentro de los arameos. Los israelitas acamparon frente a ellos como si fueran dos rebaños de cabras, mientras que los arameos repletaban toda la llanura."
,"28":"En ese momento, un hombre de Dios se acercó al rey de Israel diciéndole: 'Esto dice Yavé: Los arameos afirman que Yavé es un dios de montaña y no un dios de la llanura; por esa razón voy a poner en tus manos a todo ese gran ejército, y ustedes sabrán que yo soy Yavé'."
,"29":"Estuvieron acampados unos frente a otros durante siete días; al séptimo día se inició la batalla y los israelitas dieron muerte a cien mil soldados de infantería arameos en un solo día."
,"30":"Los que sobrevivieron se refugiaron en la ciudad de Afec, pero la muralla se desplomó sobre los diecisiete mil que quedaban. Ben-Hadad había huido y pasaba en la ciudad de una a otra casa."
,"31":"Sus servidores le dijeron: 'Hemos oído decir que los reyes de Israel son reyes generosos, permítenos que nos pongamos sacos en la cintura y cuerdas en nuestro cuello y así iremos a ver al rey de Israel; a lo mejor te perdona la vida'."
,"32":"Se pusieron pues sacos en su cintura y cuerdas en su cuello y fueron a decir al rey de Israel: 'Tu servidor Ben-Hadad te manda a decir esto: '¡Permíteme tan solo que siga con vida!' El rey Ajab respondió: '¿Todavía está vivo? ¡Pero si es mi hermano!'"
,"33":"Los otros, que no esperaban tanto, dijeron inmediatamente: '¡Sí, Ben-Hadad es tu hermano!' El rey respondió: '¡Vayan a buscarlo!',Ben-Hadad fue pues a donde estaba Ajab y éste lo hizo subir a su carro."
,"34":"Ben-Hadad le dijo: 'Te devolveré las ciudades que mi padre quitó a tu padre, y tú podrás instalar casas de negocio en Damasco así como mi padre las había instalado en Samaría'. Ajab le respondió: 'No te dejaré ir sin hacer antes un tratado'. Firmó pues con él un tratado y lo dejó irse."
,"35":"En ese mismo momento un hermano profeta decía a su compañero por orden de Yavé: '¡Pégame!' Pero el otro no quiso pegarle."
,"36":"Entonces le dijo: 'Ya que no hiciste caso a la voz de Yavé, te atacará un león después que me hayas dejado'. Se fue, lo pilló un león y lo mató."
,"37":"El profeta fue a buscar a otro compañero y le dijo: '¡Pégame!' El hombre comenzó a pegarle y lo dejó herido."
,"38":"Entonces el hermano profeta fue a ponerse por donde debía pasar el rey; se había disfrazado con un pañuelo en los ojos."
,"39":"Cuando pasaba el rey, le gritó: 'Llegué al campo de batalla justo cuando otro se retiraba. Me encargó a un prisionero diciéndome: Vigila bien a este hombre, porque si se escapa pagarás con tu vida o me darás un talento de plata."
,"40":"Pues bien, mientras estaba ocupado en una y otra cosa, el prisionero desapareció'. El rey de Israel le respondió: '¡Tú mismo has pronunciado tu sentencia!' "
,"41":"Inmediatamente el profeta se quitó el pañuelo que tenía sobre los ojos y el rey de Israel lo reconoció como uno de los profetas."
,"42":"Entonces dijo al rey: 'Escucha esta palabra de Yavé: Como dejaste que escapara el hombre que yo había condenado al anatema, tu vida pagará por la suya, y tu pueblo por su pueblo'."
,"43":"El rey de Israel se fue muy desmoralizado y de muy mal humor; regresó a su casa en Samaría."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Nabot de Jezrael tenía una viña al lado de la casa de Ajab, rey de Samaría."
,"2":"Ajab dijo a Nabot: 'Ya que tu viña está al lado de mi casa, dámela para que haga allí un huerto. En lugar de ella te daré otra viña mejor o, si prefieres, te pagaré el debido precio'."
,"3":"Nabot respondió a Ajab: '¡Líbreme Yavé de abandonar la herencia de mis padres!'"
,"4":"Ajab volvió a su casa descorazonado y muy enojado por esa respuesta de Nabot de Jezrael: 'No cederé la herencia de mis padres'. Se acostó en su cama, volvió la cara para la pared y no quería comer."
,"5":"Jezabel, su mujer, fue a verlo y le dijo: '¿Por qué estás así? ¿Por qué no comes?'"
,"6":"Le respondió: 'Acabo de decir a Nabot de Jezrael: Dame tu viña, te la pagaré o, si prefieres, te daré otra por ella. Pero me respondió: no te daré mi viña'."
,"7":"Entonces su mujer Jezabel le dijo: '¡Y tú eres el rey de Israel! ¡Vamos! Levántate, come y no estés triste. Yo te voy a dar la viña de Nabot de Jezrael'."
,"8":"Escribió en nombre del rey una carta y la selló con el timbre del rey, luego se la envió a los ancianos y a los jefes de la ciudad, vecinos de Nabot."
,"9":"La carta decía: 'Ordenen un ayuno y citen a Nabot a comparecer ante el pueblo."
,"10":"Consíganse a dos malvados para que le lancen esta acusación: ¡Tú maldeciste a Dios y al rey! Entonces lo sacarán fuera y lo matarán a pedradas'."
,"11":"La gente de la ciudad, los ancianos y los jefes que vivían con Nabot, hicieron lo que Jezabel les ordenaba en la carta que les había enviado."
,"12":"Proclamaron un ayuno e hicieron comparecer a Nabot ante el pueblo."
,"13":"Entonces se presentaron dos malvados, se pusieron frente a Nabot para testimoniar contra él, y ante todo el pueblo dijeron: '¡Nabot maldijo a Dios y al rey!' Lo sacaron fuera de la ciudad y lo apedrearon. Y Nabot murió."
,"14":"Le comunicaron a Jezabel: 'Nabot fue apedreado y murió'."
,"15":"Apenas supo Jezabel la muerte de Nabot, dijo a Ajab: 'Levántate y toma posesión de la viña de Nabot de Jezrael, que no quería vendértela a ningún precio; Nabot ya no existe, porque murió'."
,"16":"Cuando Ajab oyó que Nabot había muerto, se levantó, bajó a Jezrael y tomó posesión de la viña de Nabot."
,"17":"Pero una palabra de Yavé fue dirigida a Elías de Tisbé:"
,"18":"Levántate, baja al encuentro de Ajab, rey de Israel. En este momento está en Samaría, pues fue a la viña de Nabot para tomar posesión de ella."
,"19":"Le dirás esta palabra de Yavé: '¡Así que matas y luego te apoderas de la herencia! Escucha pues esto: allí donde los perros han lamido la sangre de Nabot, lamerán también tu propia sangre'."
,"20":"Ajab dijo a Elías: '¡Me pillaste, enemigo mío!' Elías le respondió: 'Sí, te pillé, porque te vendiste para hacer lo que es malo a los ojos de Yavé:"
,"21":"Yo acarrearé sobre ti la desgracia. Barreré todo tras de ti, haré que desaparezcan todos los varones de la casa de Ajab, ya sean esclavos o ya sean hombres libres en Israel."
,"22":"Ya que provocaste mi cólera e hiciste pecar a Israel, trataré a tu casa como a la casa de Jeroboam, hijo de Nabat, y como a la casa de Basá, hijo de Ajía'."
,"23":"También hubo una palabra de Yavé respecto a Jezabel: 'Los perros se comerán a Jezabel al pie del muro de Jezrael."
,"24":"Aquel de la casa de Ajab que muera en la ciudad será devorado por los perros, y el que muera en el campo será comido por los pájaros del cielo'."
,"25":"No hubo nadie como Ajab para venderse y para hacer lo que es malo a los ojos de Yavé; era arrastrado a eso por su mujer Jezabel."
,"26":"Se comportó de manera espantosa, sirvió a los ídolos como lo hacían los amorreos, a los que Yavé había echado ante los israelitas."
,"27":"Al oír las palabras de Elías, Ajab rasgó su ropa, se vistió de saco y ayunó; dormía con el saco puesto y andaba cabizbajo."
,"28":"Entonces se le dirigió a Elías de Tisbé una palabra de Yavé: '¿Te has fijado como Ajab ha hecho penitencia en mi presencia?"
,"29":"Ya que ha hecho penitencia ante mí, no le haré sobrevenir la desgracia durante su vida, sino que acarrearé la desgracia a su casa, durante la vida de su hijo'."
}`)
	CurrentBook.AddChapter(22, `{
"1":"La paz entre Aram e Israel duró tres años."
,"2":"Al tercer año, habiendo bajado Josafat, rey de Judá, donde el rey de Israel,"
,"3":"éste dijo a sus servidores: '¿Ya se han olvidado que Ramot de Galaad es nuestro? Nada hemos hecho para quitárselo al rey de Aram'."
,"4":"Dijo entonces a Josafat: '¿Vendrías tú conmigo para recuperar Ramot de Galaad?' Josafat respondió al rey de Israel: 'Yo, mi pueblo y mis caballos haremos una sola cosa contigo, tu pueblo y tus caballos'."
,"5":"Sin embargo, Josafat dijo al rey de Israel: 'Me gustaría consultar la palabra de Yavé'."
,"6":"El rey de Israel reunió a los profetas, eran cerca de cuatrocientos, y les dijo: '¿Debo atacar a Ramot de Galaad o debo renunciar a ello?' Le respondieron: 'Dirígete allá, que el Señor la pondrá en manos del rey'."
,"7":"Josafat dijo entonces: '¿No hay aquí algún profeta de Yavé, por medio del cual podamos consultarlo?'"
,"8":"El rey de Israel respondió a Josafat: 'Sí, todavía queda un hombre por cuyo intermedio se podría consultar a Yavé, pero lo detesto, porque nunca me profetiza algo bueno sino sólo cosas malas; es Miqueas, hijo de Jimla'. Josafat le dijo: '¡No diga eso el rey!'"
,"9":"El rey de Israel llamó a un servidor y le dijo: 'Anda en seguida a buscar a Miqueas, hijo de Jimla'."
,"10":"El rey de Israel y Josafat, rey de Judá, estaban sentados cada uno en su trono, en traje de ceremonia, en la era que está a la entrada de la puerta de Samaría, y todos los profetas seguían profetizando delante de ellos."
,"11":"Sedecías, hijo de Quenaana, se había hecho unos cuernos de fierro y decía: 'Esto dice Yavé: Te los doy para que acabes hasta con el último de los arameos'."
,"12":"Y todos los profetas no hacían más que decir: 'Lleva a cabo la expedición contra Ramot de Galaad, tú serás el vencedor, Yavé lo entregará en manos del rey!'"
,"13":"El mensajero que había ido a buscar a Miqueas le dijo: 'Todos los profetas animan al rey como si fueran un solo hombre. Trata de hablar como ellos; anuncia buenos resultados'."
,"14":"Pero Miqueas respondió: 'Tan cierto como que Yavé vive que sólo diré lo que él me diga'."
,"15":"Llegó pues delante del rey y éste le preguntó: '¿Miqueas, debemos aliarnos para atacar a Ramot de Galaad o tenemos que renunciar a ello?' Miqueas respondió: '¡Haz no más la expedición y serás el vencedor; Yavé lo pondrá en las manos del rey!'"
,"16":"Pero el rey le dijo: '¿Hasta cuándo tengo que exigirte en nombre de Yavé que me digas la verdad?'"
,"17":"Entonces Miqueas le respondió: 'Vi a todo Israel disperso por los cerros como ovejas que no tienen pastor, y Yavé decía: 'Ya no tienen patrón, que cada uno se vuelva a su casa'."
,"18":"El rey de Israel se volvió a Josafat: 'Ya te lo decía: éste nunca profetiza algo bueno sino sólo cosas malas'."
,"19":"Miqueas agregó: 'Escucha esta palabra de Yavé: Vi a Yavé sentado en su trono con todo el ejército de los cielos a su derecha y a su izquierda."
,"20":"Y Yavé decía: '¿Quién engañará al rey de Israel para que salga en campaña y se deje matar en Ramot de Galaad? Uno respondía de una manera, y otro, de otra."
,"21":"Entonces el Espíritu se acercó y se puso delante de Yavé: Yo, dijo, lo engañaré. Yavé le preguntó: ¿Cómo lo harás?"
,"22":"Respondió: Iré y me haré espíritu de mentira en la boca de todos sus profetas. Entonces le dijo Yavé: Tú lograrás engañarlo: anda y haz como lo has dicho."
,"23":"Has de saber pues que Yavé puso un espíritu de mentira en la boca de todos los profetas que están aquí, porque Yavé ha decidido tu muerte'."
,"24":"En ese momento Sedecías, hijo de Quenaana, se acercó y dio una bofetada a Miqueas, diciéndole: '¿Por dónde salió de mí el espíritu de Yavé para hablarte a ti?'"
,"25":"Miqueas le respondió: 'Lo sabrás el día en que vayas huyendo de habitación en habitación para esconderte'."
,"26":"Entonces tomó la palabra el rey: 'Detengan a ese hombre y entréguenselo a Amón, gobernador de la ciudad, y a Joás, hijo del rey."
,"27":"Díganles: Esta es la orden del rey: Encarcelen a este hombre, no le den más que una pequeña porción de pan y de agua hasta que yo regrese victorioso'."
,"28":"Miqueas le replicó: 'Si tú vuelves victorioso, eso será señal de que Yavé no habló por medio de mí'."
,"29":"El rey de Israel y el rey de Judá, Josafat, se dirigieron pues contra Ramot de Galaad."
,"30":"El rey de Israel dijo a Josafat: 'Me voy a disfrazar para entrar en combate, pero tú lleva tu mismo traje'. Y el rey de Israel se disfrazó para ir a combatir."
,"31":"El rey de Aram había dado esta orden a sus treinta y dos jefes de carros: 'No ataquen a ningún chico ni grande, sino sólo al rey de Israel'."
,"32":"Cuando los jefes de carros vieron a Josafat, dijeron: '¡Ese es el rey de Israel!' Y se lanzaron contra él para atacarlo. Pero Josafat lanzó su grito de guerra;"
,"33":"cuando los jefes de carros vieron que no era el rey de Israel, se apartaron de él."
,"34":"En ese preciso instante, un soldado disparó con su arco sin saber a quién e hirió al rey de Israel entre las correas y la coraza. El rey dijo al conductor de su carro: 'Da media vuelta y sácame de la pelea, porque estoy herido'."
,"35":"Pero como el combate era tan intenso, hubo que mantener al rey de pie en su carro frente a los amorreos, y a la tarde murió. La sangre de su herida se había derramado dentro del carro."
,"36":"Al ponerse el sol, corrió la voz por el campamento: '¡Cada cual a su ciudad, cada cual vuelva a su tierra. El rey ha muerto!'"
,"37":"Lo llevaron a Samaría, donde lo enterraron."
,"38":"Lavaron el carro en la laguna de Samaría, los perros lamieron la sangre y las prostitutas se bañaron allí, tal como lo había anunciado Yavé."
,"39":"El resto de los hechos de Ajab, todo lo que hizo, el palacio de marfil que edificó, las ciudades que fundó, está escrito en el libro de las Crónicas de los reyes de Israel."
,"40":"Ajab se acostó con sus padres y en su lugar reinó su hijo Ocozías."
,"41":"Josafat, hijo de Azá, pasó a ser rey de Judá el año cuarto de Ajab de Israel."
,"42":"Josafat tenía treinta y cinco años cuando comenzó a ser rey y reinó veinticinco años en Jerusalén; su madre Azuba era hija de Silji."
,"43":"Siguió paso a paso las huellas de su padre Azá, sin apartarse de ellas; hizo lo que es justo a los ojos de Yavé."
,"44":"Pero no desaparecieron los Altos Lugares; el pueblo seguía ofreciendo sacrificios e incienso en los Altos Lugares."
,"45":"Josafat hizo la paz con el rey de Israel."
,"46":"El resto de los hechos de Josafat, sus hazañas, las guerras que llevó a cabo, todo eso está escrito en el libro de las Crónicas de los reyes de Judá."
,"47":"Eliminó también a los homosexuales sagrados que habían seguido en tiempos de su padre Azá."
,"48":"Por ese entonces no había rey en Edom, sino solamente un gobernador real."
,"49":"Josafat construyó diez barcos de Tarsis para ir a buscar oro a Ofir, pero no pudieron ir porque los barcos fueron destrozados en Eción-Gueber."
,"50":"En esa oportunidad Ocozías, hijo de Ajab, dijo a Josafat: 'Permite que mis servidores se embarquen con los tuyos en tus barcos'. Pero Josafat no quiso."
,"51":"Cuando Josafat se acostó con sus padres, lo enterraron junto a éstos en la ciudad de David, su antepasado. En su lugar reinó Joram, su hijo."
,"52":"Ocozías, hijo de Ajab, llegó a ser rey de Israel en Samaría el año décimo séptimo del reinado de Josafat de Judá; reinó dos años en Israel."
,"53":"Hizo lo que es malo a los ojos de Yavé y siguió las huellas de su padre y de su madre; imitó la conducta de Jeroboam, hijo de Nabat, que había hecho pecar a Israel."
,"54":"Provocó la cólera de Yavé, Dios de Israel, tal como lo había hecho su padre, porque servía a Baal y se postraba ante él."
}`)

}
func ES_LBL_LoadVH1SChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Había un hombre de Ramátayim, un sufita de la montaña de Efraín, que se llamaba Elcana. Era hijo de Jerojam, hijo de Elijú, hijo de Tojú, hijo de Suf, de la tribu de Efraín."
,"2":"Tenía dos mujeres, una se llamaba Ana, la otra, Penina. Penina había tenido hijos, pero Ana, no."
,"3":"Ese hombre subía cada año de su pueblo para adorar y ofrecer sacrificios a Yavé Sabaot en el santuario de Silo; los dos hijos de Helí, Jofni y Finjas, servían como sacerdotes de Yavé en ese lugar."
,"4":"Un día Elcana ofreció un sacrificio; dio sus porciones a su mujer Penina y también a sus hijos e hijas;"
,"5":"a Ana, en cambio, le sirvió una doble porción pues era su preferida, a pesar de que Yavé la había vuelto estéril."
,"6":"Su rival la humillaba por esto y no hacía más que aumentar su pena."
,"7":"Cada año, cuando ella subía a la casa de Yavé, pasaba lo mismo: la otra revivía su pena y Ana se ponía a llorar y no comía más."
,"8":"Elcana, su marido, le dijo: 'Ana, ¿por qué lloras, por qué no comes, por qué estás tan triste? ¿No valgo para ti más que diez hijos?'"
,"9":"Ese día, después que comieron y bebieron en Silo, Ana vino a presentarse ante Yavé mientras el sacerdote Helí estaba sentado en su sillón junto a la puerta del Santuario de Yavé."
,"10":"Muy apenada rezó a Yavé sin dejar de llorar;"
,"11":"le hizo esta promesa: 'Yavé de los ejércitos, mira con bondad la pena de tu sirvienta y acuérdate de mí. No te olvides de tu sirvienta, sino que dale un niñito. Lo consagraré a Yavé para el resto de sus días y la navaja no pasará por su cabeza'."
,"12":"Estuvo orando allí un largo rato delante de Yavé mientras Helí la miraba."
,"13":"Como Ana oraba en el fondo de su corazón, casi no movía los labios y no se oía lo que decía."
,"14":"Helí pensó que estaba ebria y le dijo: '¿Hasta cuándo te vas a quedar ahí en ese estado? ¡Vete a dormir la mona!'"
,"15":"Ana le respondió: 'Señor, yo sólo soy una mujer que tiene pena; no he tomado vino ni bebida alcohólica, sino que estaba expandiendo mi corazón delante de Yavé."
,"16":"No tomes a tu sirvienta por una mujer cualquiera; si me quedé tanto rato orando ha sido porque mi sufrimiento y mi pena son muy grandes'."
,"17":"Helí retomó la palabra y le dijo: 'Vete en paz, y que el Dios de Israel atienda la oración que acabas de hacerle'."
,"18":"Ella le dijo a su vez: '¡Ojalá tu sirvienta sea bien vista por ti!' Se levantó, comió, y su cara tenía otro aspecto."
,"19":"Se levantó muy temprano y después de haberse postrado ante Yavé, emprendieron el regreso a su casa de Ramá."
,"20":"Elcana tuvo relaciones con su mujer Ana y Yavé se acordó de ella. Cuando se hubo cumplido el plazo, Ana dio a luz un niño, al que puso el nombre de Samuel, porque decía: 'Se lo pedí a Yavé'."
,"21":"Elcana, su marido, subió con toda su familia para ofrecer a Yavé el sacrificio como lo hacía cada año y cumplir su promesa."
,"22":"Ana no subió sino que dijo a su marido: 'Cuando el niño deje de mamar, lo llevaré yo misma donde Yavé y se quedará allí para siempre'."
,"23":"Elcana le respondió: 'Haz como mejor te parezca. Quédate aquí hasta que no le des más pecho, y que Yavé realice lo que acabas de decir'. La mujer se quedó, y dio de mamar a su hijo hasta que fue destetado."
,"24":"Después que le hubo quitado el pecho, lo hizo subir junto con ella a la casa de Yavé en Silo; llevaba también un toro de tres años, una medida de harina y un cuero de vino. El niño era aún muy pequeño."
,"25":"Sacrificaron el toro y llevaron el niño a Helí."
,"26":"Ana le dijo: 'Perdona, señor, tan cierto como que tú vives, señor, que yo soy la mujer que estuvo cerca de ti orándole a Yavé."
,"27":"Yo rezaba por este niño y Yavé me concedió lo que le pedía."
,"28":"Yo ahora se lo cedo a Yavé para el resto de sus días; él será donado a Yavé'. Así fue como se quedó al servicio de Yavé."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Entonces Ana pronunció este cántico: 'Mi corazón se alegra con Yavé, lleno de fuerza me siento con Yavé; ya puedo responder a mis enemigos,porque me salvaste, y soy feliz."
,"2":"No hay otro Santo que Yavé, nadie hay fuera de ti,ni otra roca fuera de nuestro Dios."
,"3":"Basta de palabras altaneras, no salga más la arrogancia de su boca. Yavé es un Dios que todo lo sabe, él es quien pesa las acciones."
,"4":"Se hace trizas el arco del forzudo, pero de fuerza se ciñen los débiles."
,"5":"Los satisfechos trabajan por un pan, pero los hambrientos ahora descansan; la que era estéril tiene siete partos, otra, con muchos hijos, queda sola;"
,"6":"Yavé da muerte y vida, hace bajar al lugar de los muertos,y hace que de allí vuelvan."
,"7":"Yavé empobrece y enriquece, El humilla, pero luego levanta."
,"8":"Saca del polvo al pequeño,y retira al pobre del estiércol,para que se siente entre los grandes,y para darle un trono de gloria. De Yavé son la tierra y sus columnas, sobre ellas el mundo estableció."
,"9":"Cuida los pasos de sus fieles, pero los malos perecen en las tinieblas: la fuerza del hombre no da la victoria."
,"10":"¡Cuando truena en los cielos el Altísimo, los que odian a Yavé son aplastados!,Yavé manda hasta el confín del mundo, da la fuerza a su rey,y hace invencible a su Mesías'."
,"11":"Elcana se volvió a su casa en Ramá, mientras que el niño se quedó al servicio de Yavé, bajo la custodia del sacerdote Helí."
,"12":"Los hijos de Helí eran unos desalmados, no respetaban a Yavé"
,"13":"ni la ley de los sacerdotes con respecto al pueblo. Cuando alguien ofrecía un sacrificio, venía el sirviente del sacerdote mientras se estaba cociendo la carne y con un tenedor de tres dientes"
,"14":"picaba en el caldero, o en la olla, o en el cántaro o en la vasija, y todo lo que pescaba el tenedor era para el sacerdote. Así se hacía con todos los israelitas que iban a Silo."
,"15":"Incluso antes de que se quemara la grasa, llegaba el sirviente del sacerdote y decía al que estaba ofreciendo el sacrificio: 'Dame carne para asársela al sacerdote, él no aceptará carne cocida, sino únicamente carne para asarla'."
,"16":"Y si alguien le respondía: 'Espera primero a que se queme la carne, luego toma lo que quieras', le replicaba: '¡No, tienes que dármelo en seguida, si no lo tomaré a la fuerza!'"
,"17":"El pecado de esos jóvenes era muy grande a los ojos de Yavé porque desacreditaban la ofrenda que se hace a Yavé."
,"18":"Samuel era todavía un niño, estaba al servicio de Yavé y llevaba un pantaloncito de lino."
,"19":"Su madre le confeccionaba todos los años una pequeña túnica que le llevaba cuando subía con su marido para el sacrificio anual."
,"20":"En una de esas ocasiones Helí bendijo a Elcana y a su mujer: 'Yavé, le dijo, te dé hijos de esta mujer a cambio del hijo que ella consagró a Yavé'. Después de lo cual regresaron a su casa."
,"21":"Yavé se acordó de Ana: concibió y dio a luz tres hijos y dos hijas. Samuel mientras tanto crecía bajo la mirada de Yavé."
,"22":"Helí era muy viejo. Supo lo mal que se portaban sus hijos ante todo Israel, pues se acostaban con las mujeres que estaban de servicio a la entrada de la Tienda de las Citas."
,"23":"Les dijo: '¿Por qué se portan así? Todo el mundo me habla de sus fechorías."
,"24":"¡No, hijos míos! Lo que oigo no es nada de bueno: ustedes pecan contra Yavé."
,"25":"Si un hombre peca contra otro hombre, Dios hará de mediador, pero si uno peca contra Yavé, ¿quién intercederá por él?' Sin embargo no hicieron caso a los consejos de su padre, pues Yavé ya había decidido su perdición."
,"26":"Samuel mientras tanto día a día crecía y se hacía mejor tanto a los ojos de Yavé como a los de los hombres."
,"27":"Un hombre de Dios fue a ver a Helí y le dijo: 'Escucha esta palabra de Yavé: Me di a conocer claramente a la casa de tu padre cuando estaban en Egipto a las órdenes del Faraón."
,"28":"Lo elegí entre todas las tribus de Israel para que fuera mi sacerdote, para que subiera a mi altar, quemara el incienso y llevara el efod delante de mí. Le di a la casa de tu padre todas las ofrendas que los Israelitas sacrifican por medio del fuego."
,"29":"¿Por qué ahora desacreditan los sacrificios y las ofrendas que he ordenado en mi casa? Has tenido más miramientos con tus hijos que conmigo y has dejado que engorden con lo mejor de las ofrendas que presenta mi pueblo de Israel."
,"30":"Por eso, esto dice Yavé, el Dios de Israel: Yo había declarado que tu casa, la de tu padre, permanecería para siempre a mi servicio. ¡Pero ahora, dice Yavé, se acabó! Porque honro a los que me honran, pero los que me desprecian serán menospreciados."
,"31":"Vendrá un día en que te romperé los brazos a ti y a la familia de tu padre, y ya no habrá más viejos en tu casa."
,"32":"Verás todo el bien que haré a Israel, mientras que tu morada quedará sumergida en la angustia: nunca más se verá en ella gente de edad."
,"33":"Haré que permanezca siempre cerca de mi altar uno de tus descendientes para que lo vean sus ojos y sea humillado, pero todos los demás que nazcan en tu casa perecerán por la espada de los hombres."
,"34":"Tú mismo tendrás una señal de lo que sucederá: tus dos hijos, Jofni y Finjas, morirán ambos el mismo día."
,"35":"Haré que surja un sacerdote fiel que actuará según mi corazón y según mi alma; le haré una casa inamovible y cumplirá siempre su cargo bajo la mirada de aquel que he elegido."
,"36":"Los que queden de tu casa vendrán a arrodillarse ante él por una monedita o por un mendrugo de pan y dirán: Dame, por favor, algún cargo en el sacerdocio para tener un pedazo de pan que comer'."
}`)
	CurrentBook.AddChapter(3, `{
"1":"El joven Samuel servía a Yavé bajo la mirada de Helí. En ese tiempo la palabra de Yavé era muy rara y las visiones poco frecuentes."
,"2":"Ese día estaba Helí acostado en su cama; sus ojos estaban tan débiles que ya no veía."
,"3":"Todavía no se había apagado la lámpara de Dios y Samuel estaba acostado en el santuario de Yavé, allí donde estaba el arca de Dios."
,"4":"Yavé lo llamó: '¡Samuel! ¡Samuel!' Respondió: 'Aquí estoy'."
,"5":"Corrió donde Helí y le dijo: 'Aquí estoy ya que me llamaste'. Helí le respondió: 'Yo no te he llamado, vuelve a acostarte'. Y Samuel se fue a acostar."
,"6":"Yavé lo llamó de nuevo: '¡Samuel! ¡Samuel!' Se levantó y se presentó ante Helí: 'Aquí estoy, le dijo, puesto que tú me llamaste'. Helí le respondió: 'Yo no te he llamado, hijo mío, vuelve a acostarte'."
,"7":"Samuel no conocía todavía a Yavé: la palabra de Yavé no le había sido todavía revelada."
,"8":"Cuando Yavé llamó a Samuel por tercera vez, se levantó y fue a ver a Helí: 'Aquí estoy, le dijo, ya que me llamaste'. Helí comprendió entonces que era Yavé quien llamaba al muchacho,"
,"9":"y dijo a Samuel: 'Anda a acostarte; si te llaman, responde: 'Habla, Yavé, que tu servidor escucha'. Y Samuel volvió a acostarse."
,"10":"Yavé entró, se detuvo y llamó igual que las veces anteriores: '¡Samuel! ¡Samuel!' Samuel respondió: 'Habla, que tu servidor escucha'."
,"11":"Yavé dijo entonces a Samuel: 'Voy a realizar en Israel una cosa tan tremenda que le tintinearán las orejas a quien lo oiga."
,"12":"Haré que caiga sobre Helí la condena que he pronunciado contra su casa, desde principio a fin."
,"13":"Le dirás que condeno su casa para siempre porque sabía que sus hijos maldecían a Dios y no los corrigió."
,"14":"Por eso, se lo juro a su casa, que ningún sacrificio, ninguna ofrenda podrá borrar el pecado cometido por la familia de Helí'."
,"15":"Samuel se acostó de nuevo hasta la mañana, luego abrió las puertas del santuario de Yavé. Samuel tenía miedo de contarle a Helí la visión,"
,"16":"pero Helí lo llamó y le dijo: 'Samuel, hijo mío'. 'Aquí estoy', le respondió."
,"17":"Helí le preguntó: '¿Cuál fue la palabra que se te dijo? No me ocultes nada. Te maldiga Dios y te remaldiga si me ocultas una sola palabra de lo que te dijo'."
,"18":"Entonces Samuel se lo contó todo sin ocultarle nada. Helí dijo: 'Es Yavé, que haga como mejor le parezca'."
,"19":"Samuel había crecido; Yavé estaba con él y sus palabras nunca dejaban de cumplirse."
,"20":"De esta manera todo Israel, desde Dan hasta Bersabé, supo que Samuel era verdaderamente un profeta de Yavé."
,"21":"Yavé continuó manifestándose en Silo; allí se revelaba a Samuel mientras Helí seguía envejeciendo y sus hijos hundiéndose en su mala conducta."
}`)
	CurrentBook.AddChapter(4, `{
"1":"En esos días los filisteos se reunieron para atacar a Israel y los Israelitas salieron a su encuentro para enfrentarlos. Acamparon cerca de Eben-Ha-Ezer, mientras que los filisteos acampaban en Afec."
,"2":"Los filisteos se dispusieron para la batalla frente a los israelitas y el combate fue violento. Israel fue vencido por los filisteos, quienes dieron muerte a más o menos cuatro mil en el campo de batalla."
,"3":"Cuando el pueblo regresó al campamento, los ancianos de Israel se preguntaron: '¿Por qué Yavé nos aplastó hoy ante los filisteos? ¡Vamos a Silo y traigamos el arca de Dios! Que esté aquí con nosotros y que nos salve de nuestros enemigos'."
,"4":"El pueblo mandó entonces a buscar a Silo el arca de Yavé de los ejércitos, que se sienta sobre los querubines. Los dos hijos de Helí, Jofni y Finjas, la acompañaban."
,"5":"Cuando el arca de Yavé entró en el campamento, todo Israel se puso a gritar haciendo temblar el suelo."
,"6":"Al oír esos gritos, los filisteos se dijeron: '¿Qué significará esa inmensa aclamación en el campamento de los hebreos?' Cuando supieron que el arca de Yavé había llegado al campamento,"
,"7":"los filisteos tuvieron miedo: 'Dios ha llegado a su campamento, dijeron, ay de nosotros, porque hasta ahora nunca había ocurrido eso."
,"8":"¡Ay de nosotros! ¿Quién nos librará de la mano de esos dioses poderosos? ¿No fueron ellos los que castigaron a los egipcios con toda clase de plagas en los tiempos del desierto?"
,"9":"¡Animo, filisteos! Luchemos como hombres, no vayamos a someternos a esos hebreos como ellos se han sometido a nosotros hasta ahora; ¡seamos valientes y luchemos!'"
,"10":"Los filisteos presentaron batalla; los israelitas fueron derrotados y cada cual huyó para su casa. Fue un gran desastre: treinta mil combatientes cayeron de entre las filas de Israel."
,"11":"El arca de Dios cayó prisionera y los dos hijos de Helí, Jofni y Finjas, murieron."
,"12":"Un hombre de Benjamín se escapó y llegó ese mismo día a Silo, con la ropas hecha tiras y la cabeza cubierta de polvo."
,"13":"Cuando llegó, Helí estaba sentado en su sillón muy cerca del camino porque su corazón temblaba por el arca de Dios. Cuando el hombre llegó al pueblo llevando la noticia, surgió de allí una gran lamentación."
,"14":"Cuando Helí la oyó, preguntó: '¿A qué se debe esa lamentación?' El hombre corrió donde Helí para comunicárselo;"
,"15":"él tenía entonces noventa y ocho años, su mirada estaba fija y ya no veía."
,"16":"El mensajero dijo a Helí: 'Vengo del campo de batalla, hoy mismo huí de las líneas'. Helí le preguntó: '¿Qué pasó, hijo mío?'"
,"17":"El mensajero respondió: 'Israel huyó ante los filisteos, fue una terrible derrota para el pueblo. Tus dos hijos murieron también y el arca de Dios fue capturada'."
,"18":"En cuanto mencionó el arca de Dios, Helí cayó de espaldas de su silla, atravesándose en la puerta. Se rompió la nuca y murió, porque el viejo era pesado. Había juzgado a Israel durante cuarenta años."
,"19":"Su nuera, la mujer de Finjas, estaba embarazada y a punto de dar a luz. Al saber la captura del arca de Dios, la muerte de su suegro y de su marido, le vinieron los dolores, se puso en cuclillas y dio a luz."
,"20":"Las mujeres que la asistían, al verla que estaba a punto de morir, le dijeron: '¡Animo! ¡Animo! ¡Has dado a luz un niño! Pero ella no respondió ni puso atención."
,"21":"Puso al niño el nombre de Icabod (¿Dónde está la Gloria?) porque dijo: 'La Gloria ha sido arrancada de Israel'. Pensaba tanto en el Arca como en su suegro y en su marido."
,"22":"Al decir: 'La Gloria', se refería al arca de Dios'."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Los filisteos que habían capturado el arca de Dios la llevaron de Eben-Ha-Ezer a Asdod."
,"2":"Tomaron el arca de Dios y la pusieron en el templo de Dagón al lado de la estatua de Dagón."
,"3":"A la mañana siguiente, cuando se levantaron los habitantes de Asdod, muy temprano, Dagón estaba en el suelo: estaba caído con su cara delante del arca de Yavé. Lo levantaron y lo pusieron de nuevo en su lugar."
,"4":"A la mañana siguiente, cuando se levantaron, Dagón estaba de nuevo en el suelo delante del arca de Yavé. El tronco estaba en su lugar, pero le faltaban la cabeza y las dos manos que estaban tiradas en el umbral;"
,"5":"es por eso que los sacerdotes de Dagón y todos los que entran en el templo de Dagón en Asdod, aún hoy, no pisan el umbral de Dagón."
,"6":"La mano de Yavé se dejó caer sobre los habitantes de Asdod, los atormentó y les envió tumores tanto a Asdod como a sus alrededores."
,"7":"Al ver lo que les pasaba, dijeron: 'Que el arca del Dios de Israel no quede más con nosotros : vean cómo ha tenido pesada la mano con nosotros y con nuestro dios Dagón'."
,"8":"Mandaron pues una citación a todos los príncipes de los filisteos y los reunieron en su ciudad. Les dijeron: '¿Qué haremos con el arca del Dios de Israel?' Los demás respondieron: 'El arca del Dios de Israel irá a Gat'. Llevaron allá el arca del Dios de Israel."
,"9":"Pero, apenas llegaron con ella, el peso de la mano de Dios se hizo sentir en la ciudad: se produjo un gran pánico. Castigó a los habitantes, desde el más chico al más grande, haciéndoles salir tumores."
,"10":"Enviaron entonces el arca de Dios a Ecrón; pero cuando el arca de Dios llegó a Ecrón, los habitantes de la ciudad se pusieron a gritar: '¡Nos han traído el arca del Dios de Israel para que perezcamos nosotros y nuestro pueblo!'"
,"11":"Se reunieron todos los príncipes de los filisteos: 'Devolvamos el arca del Dios de Israel, dijeron, que vuelva al lugar de donde vino. Porque si no, vamos a morir nosotros y nuestro pueblo'. Se había producido en toda la ciudad un pánico terrible pues la mano de Dios se había vuelto muy pesada."
,"12":"Los que no morían se llenaban de tumores, y desde la ciudad subía al cielo una gran lamentación."
}`)
	CurrentBook.AddChapter(6, `{
"1":"El arca de Yavé estuvo siete meses en territorio filisteo."
,"2":"Los filisteos llamaron finalmente a los sacerdotes y a los adivinos: '¿Qué haremos con el arca de Yavé?, dijeron, dígannos cómo debemos devolverla a su lugar'."
,"3":"Estos respondieron: 'Si devuelven el arca del Dios de Israel, no la devuelvan sola; háganle una ofrenda de reparación, de ese modo sanarán ustedes y sabrán por qué se abatió sobre ustedes la mano de Dios'."
,"4":"Les preguntaron también: '¿Qué reparación podríamos enviar?' Los adivinos dijeron: 'Cinco tumores de oro y cinco ratas de oro, de acuerdo al número de los príncipes de los filisteos, pues la misma plaga los hirió a ustedes y a sus príncipes."
,"5":"Hagan estatuas de sus tumores y de las ratas que asolan su país, y den gloria al Dios de Israel. A lo mejor así dejará su mano de castigarlos, tanto a ustedes como a sus dioses y a su país."
,"6":"¿Por qué son tan testarudos como los egipcios y su Faraón? Dios los castigó de tal manera que al final tuvieron que dejarlos partir."
,"7":"Por lo que toca a ustedes, preparen ahora una carreta nueva, tomen dos vacas que todavía estén dando leche a sus crías y que nunca han sido enyugadas. Enyugarán las vacas a la carreta y dejarán en el establo a sus terneros."
,"8":"Tomarán el arca de Yavé y la pondrán en la carreta, y los objetos de oro que le ofrecerán en reparación los pondrán en un cofre al lado del Arca, y dejarán que se vayan."
,"9":"Miren entonces. Si el Arca se va a su país en dirección a Bet-Semés, su Dios fue seguramente el que nos trajo estas plagas. Si no, sabremos que no fue su mano la que nos castigó, sino que todo esto nos pasó por casualidad'."
,"10":"Lo hicieron pues así: tomaron dos vacas que todavía daban leche a sus terneros, las enyugaron a la carreta y dejaron a sus crías en el establo."
,"11":"Pusieron el arca de Yavé en la carreta junto con el cofre que contenía las ratas de oro y las estatuas de los tumores."
,"12":"Inmediatamente las vacas se fueron por el camino a Bet-Semés; seguían su camino mugiendo, sin apartarse a derecha ni a izquierda. Los príncipes de los filisteos las siguieron hasta la frontera con Bet-Semés."
,"13":"La gente de Bet-Semés estaba cosechando el trigo en la llanura. Al levantar la vista, divisaron el Arca y muy contentos salieron a su encuentro."
,"14":"Cuando la carreta llegó al campo de Josué de Bet-Semés, se detuvo. Había allí una gran roca. Partieron la madera de la carreta y ofrecieron las vacas como holocausto a Yavé."
,"15":"Los levitas habían bajado el arca de Yavé junto con el cofre que estaba a su lado y que contenía los objetos de oro. Lo pusieron todo encima de la roca. Los hombres de Bet-Semés ofrecieron ese día a Yavé holocaustos y sacrificios."
,"16":"Los cinco príncipes de los filisteos fueron testigos de todo eso; el mismo día regresaron a Ecrón."
,"17":"Esta es la lista de tumores de oro que los filisteos habían ofrecido como reparación a Yavé: uno por Asdod, uno por Gaza, uno por Asquelón, uno por Gat y uno por Ecrón."
,"18":"Había tantas ratas de oro cuantas ciudades, contando las ciudades fortificadas de los cinco príncipes y también las aldeas. La gran roca en la que se depositó el arca de Yavé conserva su recuerdo: todavía está allí en el campo de Josué de Bet-Semés."
,"19":"Los hijos de Jeconías, de Bet-Semés, no participaron en la fiesta cuando volvieron a ver el arca de Yavé. Yavé castigó a setenta de ellos y el pueblo hizo duelo porque Yavé lo había corregido duramente."
,"20":"Entonces la gente de Bet-Semés se dijo: '¿Quién podrá comparecer ante Yavé, el Dios Santo? ¿A dónde podríamos enviar el Arca?'"
,"21":"Mandaron mensajeros a los habitantes de Quiriat-Yearim: 'Los filisteos, les decían, han devuelto el arca de Yavé, bajen y llévensela a su casa'."
}`)
	CurrentBook.AddChapter(7, `{
"1":"La gente de Quiriat-Yearim fue y subió el arca de Yavé. La dejaron en la casa de Abinadab en la colina, y consagraron a su hijo Eleazar como guardián del arca de Yavé."
,"2":"Transcurrieron muchos años desde que el Arca fue instalada en Quiriat-Yearim; cerca de veinte. Todo el pueblo de Israel se volvió entonces a Yavé."
,"3":"Samuel declaró a todo el pueblo de Israel: 'Si realmente ustedes quieren volver a Yavé, quiten de en medio de ustedes los dioses extranjeros y las Astartés. Pongan su corazón en Yavé y sólo sírvanlo a él; sólo así los librará de las manos de los filisteos'."
,"4":"Los israelitas se desprendieron de los Baales y de las Astartés para servir sólo a Yavé."
,"5":"Samuel añadió: 'Reúnase todo Israel en Mispá: allí intercederé por ustedes a Yavé'."
,"6":"Se reunieron en Mispá. Sacaron agua la que derramaron delante de Yavé, y ayunaron todo el día, porque reconocían que habían pecado contra Yavé. Y allí, en Mispá, Samuel actuó como jefe de los israelitas."
,"7":"Cuando los filisteos supieron que los israelitas se habían reunido en Mispá, se pusieron en marcha para atacar a Israel. Los israelitas al saberlo, tuvieron miedo de los filisteos."
,"8":"Dijeron entonces a Samuel: 'No dejes de suplicar a Yavé nuestro Dios por nosotros para que nos salve de las manos de los filisteos'."
,"9":"Samuel tomó entonces un corderito y lo ofreció en holocausto a Yavé. Samuel suplicó a Yavé por Israel, y Yavé lo escuchó."
,"10":"Mientras Samuel ofrecía el sacrificio, los filisteos se acercaron para atacar a Israel, pero ese día Yavé tronó con gran fuerza contra los filisteos. Salieron huyendo y fueron vencidos por Israel."
,"11":"Los israelitas salieron de Mispá y persiguieron a los filisteos; los acosaron hasta más abajo de Bet-Car."
,"12":"Samuel tomó entonces una gran piedra y la puso entre Mispá y Yesana, y le puso el nombre de Eben-Ha-Ezer, porque dijo: 'Hasta aquí llegó Yavé con su socorro'."
,"13":"Los filisteos habían sido humillados y no regresaron más al territorio de Israel. La mano de Israel se dejó sentir pesada sobre los filisteos durante toda la vida de Samuel."
,"14":"Israel recuperó los pueblos que le habían conquistado los filisteos desde Ecrón a Gat; Israel logró que su territorio quedara libre de las manos de los filisteos. Entonces hubo paz entre Israel y los amoreos."
,"15":"Samuel fue el juez de Israel durante toda su vida."
,"16":"Cada año hacía una gira por Betel, Guilgal y Mispá y desde allí gobernaba a Israel."
,"17":"Luego se volvía a Ramá donde estaba su casa y desde allí también gobernaba a Israel. En Ramá levantó un altar para Yavé."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Cuando Samuel fue de edad, estableció a sus hijos como jueces de Israel."
,"2":"El mayor se llamaba Joel y el menor, Abiya; gobernaban desde Bersabé."
,"3":"Pero sus hijos no siguieron su ejemplo, se dejaron seducir por el dinero, y en vez de hacer justicia aceptaban cohechos."
,"4":"Todos los ancianos de Israel se congregaron en la casa de Samuel en Ramá."
,"5":"Le dijeron: 'Te has vuelto viejo y tus hijos no siguen tus pasos, ya es tiempo de que nos des un rey para que nos gobierne como se hace en todas las naciones'."
,"6":"Lo que disgustó a Samuel fue: '¡Danos un rey para que nos gobierne!' Samuel se dirigió entonces a Yavé,"
,"7":"y Yavé dijo a Samuel: 'Atiende a todo lo que te dice este pueblo, porque no es a ti a quien rechazan sino a mí. Ya no quieren que reine sobre ellos."
,"8":"Actúan contigo como lo han hecho siempre conmigo, desde el día en que los saqué de Egipto, cuando me abandonaron y sirvieron a dioses extranjeros."
,"9":"Acoge su demanda, pero diles bien cómo mandará el rey que los gobernará'."
,"10":"Samuel transmitió a la gente que le había pedido un rey todas las palabras de Yavé."
,"11":"Y les dijo: 'Miren cómo mandará el rey que reinará sobre ustedes: tomará a los hijos de ustedes para que cuiden de sus carros y de sus caballos y corran delante de su carro."
,"12":"Los tomará como jefes de mil y jefes de cincuenta, los tomará para que trabajen sus campos, para que cosechen su trigo, para que fabriquen sus armas de guerra y los arneses de sus carros."
,"13":"Tomará a las hijas de ustedes para que sean sus perfumistas, sus cocineras o sus panaderas."
,"14":"Tomará lo mejor de los campos, de las viñas y de los olivares de ustedes y se lo dará a sus servidores."
,"15":"Cobrará el diezmo de sus cosechas y de su uva para dárselo a sus eunucos y a sus servidores."
,"16":"Tomará lo mejor de sus sirvientes, de sus sirvientas, de sus jóvenes, de sus burros y los empleará en sus trabajos."
,"17":"Les cobrará el diezmo de su ganado y ustedes pasarán a ser sus esclavos."
,"18":"Entonces se lamentarán a causa del rey que se eligieron, pero ese día Yavé no les responderá'."
,"19":"El pueblo no quiso hacerle caso a Samuel. Le dijeron: 'No importa, queremos un rey."
,"20":"Así seremos como todas las naciones, nuestro rey nos gobernará; irá al frente de nosotros y comandará nuestras guerras'."
,"21":"Samuel oyó todas las palabras del pueblo y las transmitió a Yavé."
,"22":"Yavé dijo entonces a Samuel: 'Hazle caso a ese pueblo y dale un rey'. Y Samuel dijo a los hombres de Israel: 'Váyase cada uno a su pueblo'."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Había un hombre que se llamaba Quis, hijo de Seor, hijo de Becoral, hijo de Afiaj, de la tribu de Benjamín. Vivía en Guibea de Benjamín y era un hombre valeroso."
,"2":"Saúl, su hijo, era joven y buen mozo, no podría haberse encontrado un hombre más hermoso en Israel: era más alto que todos los demás por una cabeza."
,"3":"Como se perdieran las burras de Quis, el padre de Saúl, aquél dijo a su hijo Saúl: 'Llévate contigo a uno de los sirvientes y anda a buscar las burras'."
,"4":"Fueron a la montaña de Efraín y atravesaron el territorio de Salisa, pero no encontraron nada. Atravesaron luego el territorio de Saalim, pero tampoco estaban allí. Recorrieron el territorio de Benjamín sin hallar nada."
,"5":"Cuando llegaron al territorio de Suf, Saúl dijo a su sirviente: 'Mejor regresemos, pues nuestro padre se va a preocupar más por nosotros que por las burras'."
,"6":"El sirviente le respondió: 'En ese pueblo hay un hombre de Dios. Es un hombre muy estimado, todo lo que predice ocurre. Vamos a verlo, a lo mejor nos indica el camino que debemos seguir'."
,"7":"Saúl dijo al muchacho: 'Si vamos a verlo, ¿qué podremos ofrecer a ese hombre? Ya no tenemos pan en nuestros bolsos y no tenemos ningún regalo que ofrecer al hombre de Dios. ¿Qué podemos obsequiarle?'"
,"8":"El sirviente le respondió: 'Me queda todavía un cuarto de siclo de plata, se lo daré a ese hombre de Dios para que nos indique el camino'."
,"10":"Saúl dijo a su sirviente: 'Tienes la razón, vamos para allá'. Y se dirigieron al pueblo donde estaba el hombre de Dios."
,"11":"En el camino que subía al pueblo se encontraron con algunas jóvenes que iban a buscar agua. Les preguntaron: '¿Está allí el vidente?'"
,"9":"Porque antes se decía en Israel: 'Vamos donde el vidente' para decir que iban a consultar a Dios. Porque no se hablaba de profetas como ahora sino de videntes."
,"12":"Ellas respondieron: 'Sí, está allí; acaba de llegar a la ciudad, porque hoy se hará un sacrificio por el pueblo en el santuario alto."
,"13":"Apenas lleguen a la ciudad, vayan inmediatamente a verlo antes de que suba al santuario para la comida, porque el pueblo no comerá antes de que llegue. El es quien debe ofrecer el sacrificio y los invitados sólo comerán después. Suban pues rápido, para que lo encuentren'."
,"14":"Siguieron caminando a la ciudad, y apenas entraron, se encontraron con Samuel: salía para ir al santuario."
,"15":"Ahora bien, la víspera de la llegada de Saúl, Yavé había hecho una revelación a Samuel:"
,"16":"Mañana a esta hora te enviaré a un hombre del territorio de Benjamín, al que consagrarás como jefe de mi pueblo Israel. Ese hombre va a salvar a mi pueblo de las manos de los filisteos, porque he visto la aflicción de mi pueblo y su clamor ha subido hasta mí'."
,"17":"Cuando Samuel divisó a Saúl, Yavé le dijo: 'Ese es el hombre de que te hablé, él gobernará a mi pueblo'."
,"18":"Saúl se dirigió a Samuel que estaba en medio de la puerta y le preguntó: '¿Podrías indicarme dónde está la casa del vidente?'"
,"19":"Samuel respondió a Saúl: 'Yo soy el vidente, sube delante de mí al Lugar Alto. Ustedes comerán ahora conmigo, y mañana te diré todo lo que te preocupa; luego dejaré que te vayas."
,"20":"Sobre todo no te preocupes por las burras que perdiste hace tres días, porque ya las hallaron. Pero ¿para quién serán los primeros puestos en Israel? ¿Tal vez para ti y la casa de tu padre?'"
,"21":"Saúl respondió: 'Soy de la tribu de Benjamín, la más pequeña de las tribus de Israel, y en la tribu de Benjamín mi familia es la más pequeña. ¿Por qué me dices esas palabras?'"
,"22":"Samuel hizo pasar a Saúl y a su sirviente al salón donde había unos treinta invitados, y les dio el primer puesto."
,"23":"Luego Samuel dijo al cocinero: 'La parte que te pasé para que la pusieras aparte, sírvela ahora'."
,"24":"El cocinero sacó entonces la paleta y todo lo que la rodea y la puso delante de Saúl. Samuel le dijo: 'Ante ti tienes la parte que se puso aparte, cómela'. Y ese día Saúl comió con Samuel."
,"25":"Cuando bajaron del santuario a la ciudad, prepararon a Saúl una cama en la terraza"
,"26":"y se acostó allí. Al amanecer Samuel llamó a Saúl, que estaba en la terraza, y le dijo: 'Levántate porque te voy a indicar tu camino'. Saúl se levantó y ambos, él y Samuel, salieron."
,"27":"Cuando se acercaban a la salida de la ciudad, Samuel dijo a Saúl: 'Dile a tu sirviente que se adelante un poco, pero tú quédate aquí para que te comunique una palabra de Dios'."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Samuel tomó su alcuza de aceite y la derramó sobre la cabeza de Saúl, luego lo abrazó y le dijo: 'Yavé te ha consagrado como jefe de su pueblo Israel. Tú gobernarás el pueblo de Yavé y tú lo librarás de las manos de sus enemigos. ¿Quieres estar seguro de que Yavé te consagró como jefe de su heredad? Estas serán las señales:"
,"2":"Hoy mismo, después que me hayas dejado, hallarás a dos hombres cerca de la tumba de Raquel, en el territorio de Benjamín, ellos te dirán: 'Encontraron las burras que saliste a buscar; tu padre ya no está preocupado ahora por las burras sino por ustedes, y se pregunta qué hacer por su hijo'."
,"3":"Seguirás tu camino y llegarás a la Encina de Tabor. Allí te encontrarás con tres hombres que van al santuario de Dios en Betel. Uno llevará tres cabritos, otro, tres panes redondos, y el último, un cuero de vino."
,"4":"Te saludarán y te darán dos panes, los que tú aceptarás."
,"5":"Después llegarás a Guibea de Dios, donde hay un comisario filisteo. En cuanto entres al pueblo, te cruzarás con una banda de profetas que bajan del santuario alto con arpas, tamboriles, flautas y cítaras, en actitud de profetizar."
,"6":"Entonces te tomará el espíritu de Yavé y serás cambiado en otro hombre."
,"7":"Cuando se cumplan estas señales, tú harás lo que mejor te parezca, porque Dios está contigo."
,"8":"Tú llegarás primero que yo a Guilgal, y allí me reuniré contigo para ofrecer holocaustos y sacrificios de comunión. Me esperarás allí siete días y después te daré a conocer lo que tienes que hacer'."
,"9":"Apenas Saúl volvió la espalda para alejarse de Samuel, Dios le cambió el corazón y ese mismo día se cumplieron todas las señales."
,"10":"Al llegar a Guibea, Saúl y su sirviente se encontraron con la banda de profetas: el espíritu de Dios se apoderó de él y se puso a profetizar en medio de ellos."
,"11":"Al verlo que profetizaba junto con los profetas, todos los que lo conocían de antes se decían unos a otros: '¿Qué le pasó al hijo de Quis? ¿Así que Saúl entró a los profetas?'"
,"12":"Uno de ellos respondió: '¡De gente cuyo padre es un don nadie!' Y así fue como surgió ese refrán: '¡Saúl entró a los profetas!'"
,"13":"Después que terminó de profetizar, regresó a su casa."
,"14":"Su tío les preguntó a él y a su sirviente: '¿Dónde anduvieron?' Respondió: 'Hicimos un recorrido buscando las burras, pero como no las hallamos, fuimos a ver a Samuel'."
,"15":"Su tío le dijo: 'Cuéntame lo que les dijo Samuel'."
,"16":"Saúl respondió a su tío: 'Unicamente nos dijo que habían encontrado las burras'. No le conversó de lo que Samuel le había dicho respecto a la realeza."
,"17":"Samuel convocó al pueblo junto a Yavé en Mispá."
,"18":"Dijo a los israelitas: 'Esto dice Yavé, el Dios de Israel: 'Yo saqué a Israel de Egipto, yo los libré de las manos de los egipcios y de las manos de todos los reyes que los oprimían."
,"19":"Pero ahora ustedes están hastiados con su Dios que los salvó de todas sus desgracias y de todas sus aflicciones; le dijeron: ¡Basta, danos un rey! Pues bien, preséntense ahora ante Yavé por tribu y por familia'."
,"20":"Samuel ordenó entonces que se acercaran todas las tribus de Israel y la suerte recayó en la tribu de Benjamín."
,"21":"Ordenó que se acercaran las diferentes familias de la tribu de Benjamín y la suerte recayó en la familia de Matri. Pidió que se acercaran los hombres de la familia de Matri, y fue elegido a la suerte Saúl, hijo de Quis. Lo buscaron pero no lo encontraron."
,"22":"Hicieron entonces esta pregunta a Yavé: '¡Vino para acá Saúl?' Yavé respondió: 'Fue a esconderse donde está el equipaje'."
,"23":"Corrieron allá y lo trajeron para presentarlo al pueblo: ¡era más alto que todo el mundo por una cabeza!"
,"24":"Samuel dijo a todo el pueblo: 'Vean al elegido de Yavé. No hay nadie como él en todo el pueblo'. Y todos lanzaron exclamaciones gritando: '¡Viva el rey!'"
,"25":"Samuel dijo luego al pueblo cuáles eran los derechos del rey y los anotó en un libro que depositó ante Yavé; después Samuel mandó a todo el pueblo a su casa."
,"26":"Saúl también se fue a su casa en Guibea y algunos hombres valientes, a los que Dios les había tocado el corazón, se fueron con él."
,"27":"Pero hubo gente malvada que dijo: '¡Qué nos va a librar ése!' Lo despreciaron y no le ofrecieron ningún regalo."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Poco más de un mes después, Najaz el amonita puso sitio a Yabés de Galaad. Toda la gente de Yabés dijo a Najaz: '¡Haz la paz con nosotros y te serviremos!'"
,"2":"Pero Najaz el amonita respondió: 'Haré la paz con ustedes con esta condición: les sacaré a todos el ojo derecho, para que así quede humillado todo Israel'."
,"3":"Los ancianos de Yabés le dijeron: 'Danos una tregua de siete días para que mandemos mensajeros a todo el territorio de Israel, y si nadie viene a ayudarnos, nos rendiremos a ti'."
,"4":"Llegaron los mensajeros a Guibea de Saúl y le contaron todo el problema al pueblo: todo el pueblo lanzó una gran lamentación y se pusieron a llorar."
,"5":"Pues bien, en ese momento Saúl regresaba del campo arriando sus bueyes. Preguntó: '¿Por qué está llorando así el pueblo?' Le repitieron las palabras de la gente de Yabés."
,"6":"Al oír Saúl esas palabras se apoderó de él el espíritu de Dios y se puso furioso."
,"7":"Tomó el par de bueyes, los despedazó y distribuyó los pedazos por todo el territorio de Israel por intermedio de los mensajeros de Yabés; estos tenían el encargo de decir: 'Al que no marche tras Saúl y tras Samuel le haré lo que hice con estos bueyes'. Entonces se apoderó de todo el pueblo el temor de Yavé y todos marcharon como un solo hombre."
,"8":"Saúl les pasó revista en Bezeq, los israelitas eran trescientos mil y los hombres de Judá, treinta mil."
,"9":"Entonces despidieron a los mensajeros con esta respuesta: 'Digan esto a la gente de Yabés de Galaad: Mañana, cuando comience el sol a calentar, recibirán ayuda'. Y los de Yabés, llenos de alegría con esta noticia,"
,"10":"dijeron a Najaz: 'Mañana nos rendiremos a ti y ustedes podrán hacer con nosotros lo que les parezca'."
,"11":"A la mañana siguiente, Saúl distribuyó al pueblo en tres grupos, los que invadieron el campamento de los amonitas antes que amaneciera y lucharon con ellos hasta lo más caluroso del día. Los que no murieron se dispersaron y no quedaron ni dos de ellos juntos."
,"12":"El pueblo dijo entonces a Samuel: '¿Quiénes fueron los que se atrevieron a decir: Saúl no reinará sobre nosotros? Entréganos a esos hombres para que les demos muerte'."
,"13":"Pero Samuel respondió: 'Hoy no morirá nadie, porque hoy es un día en que Yavé ha salvado a Israel'."
,"14":"Samuel añadió: 'Vengan y reunámonos en Guilgal: vamos a inaugurar la realeza'."
,"15":"Todo el pueblo se reunió en Guilgal y allí fue proclamado rey Saúl ante Yavé. Ofrecieron a Yavé sacrificios de comunión, y fue un día de gran fiesta para Saúl y para todos los israelitas."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Samuel dijo a todo Israel: 'Los he atendido en todo lo que me han pedido y les he dado un rey."
,"2":"Pues bien, que el rey se encargue ahora de los asuntos de ustedes, porque yo ya soy viejo, tengo blancos los cabellos, y mis hijos están ahora con ustedes. Desde mi juventud y hasta el día de hoy he ido al frente de ustedes; "
,"3":"digan, pues, y atestigüen ante Yavé y ante su elegido si he tomado el buey o el burro de alguno de ustedes. ¿Le he robado a alguien o lo he maltratado? ¿He aceptado algún regalo para callarme con respecto a la conducta de tal o cual? Estoy listo a devolverlo'."
,"4":"Todos respondieron: 'Tú nunca nos has maltratado, nunca le has robado a nadie ni has aceptado regalo de la mano de nadie'."
,"5":"Samuel les dijo: 'Pues bien, Yavé es testigo y el que acaba de ser elegido puede atestiguarlo ahora: ustedes no tienen nada de qué reprocharme'. Le respondieron: 'Ellos son testigos'."
,"6":"Entonces Samuel dijo al pueblo: ' Yavé es testigo, él que les dio a Moisés y a Aarón y que sacó a sus padres del país de Egipto."
,"7":"Comparezcan pues conmigo ante el tribunal de Yavé: quiero recordarles todo lo bueno que ha hecho Yavé por ustedes y por sus padres."
,"8":"Cuando Jacob llegó a Egipto, los egipcios los oprimieron y los padres de ustedes clamaron a Yavé. El les mandó entonces a Moisés y a Aarón para sacar a sus padres de Egipto e instalarlos en este lugar."
,"9":"Después de eso se olvidaron de Yavé su Dios, quien permitió que cayeran en manos de Sísera, el general del ejército de Jasor, en manos de los filisteos y del rey de Moab que les declararon la guerra."
,"10":"Entonces clamaron a Yavé: Hemos pecado y hemos abandonado a Yavé. Hemos servido a los Baales y a las Astartés, líbranos ahora de manos de nuestros enemigos y te serviremos."
,"11":"Yavé les dio entonces a Jerubaal, Barac, Jefté y Samuel, los libró de sus enemigos y les volvió a dar la paz."
,"12":"Sin embargo, cuando vieron ustedes a Najaz, rey de los amoneos, marchar con su ejército contra ustedes, me dijeron: ¡No! Necesitamos un rey que gobierne sobre nosotros. Y sin embargo Yavé, su Dios, reinaba sobre ustedes."
,"13":"Yavé les ha dado ahora al rey que ustedes se eligieron. Si temen a Yavé y le sirven, si le obedecen sin rebelarse contra sus órdenes,"
,"14":"si ustedes y el rey que reina sobre ustedes siguen a Yavé su Dios, todo irá bien."
,"15":"Pero si no obedecen a Yavé, si se rebelan contra sus órdenes, la mano de Yavé se hará pesada para ustedes y para su rey."
,"16":"No se vayan todavía, para que vean este gran prodigio que Yavé va a realizar ante sus ojos."
,"17":"¿No es ahora la cosecha del trigo? Pues bien, voy a invocar a Yavé y él va a mandar truenos y lluvia. Entonces comprenderán que cometieron un gran pecado con Yavé al pedirle un rey'."
,"18":"Samuel invocó a Yavé y Yavé mandó ese mismo día truenos y lluvia. Todo el pueblo se llenó de temor ante Yavé y ante Samuel."
,"19":"El pueblo decía a Samuel: 'Intercede ante Yavé tu Dios por tus siervos, para que no muramos, porque al pedir un rey hemos llegado al colmo de nuestros pecados'."
,"20":"Samuel dijo al pueblo: 'No teman. Es cierto que cometieron un pecado, pero no se aparten de Yavé y sírvanlo de todo corazón."
,"21":"Si se apartan de él, ¿a quién seguirán? A ídolos que son nada, ni nada valen, que son incapaces de salvarlos porque nada son."
,"22":"Pero Yavé no abandonará a su pueblo porque sería desacreditar a su nombre, después de lo que ha hecho por su propio pueblo."
,"23":"En cuanto a mí, si dejara de orar por ustedes, pecaría contra Yavé; les indicaré pues el camino bueno y derecho."
,"24":"Ustedes teman a Yavé, sírvanle sinceramente, desde el fondo de su corazón, ahora que lo han visto hacer cosas tan extraordinarias."
,"25":"Si hacen el mal, ciertamente que perecerán ustedes y su rey."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Saúl era rey y gobernaba a Israel."
,"2":"Se eligió a tres mil hombres de entre los israelitas; dos mil estaban con él en Micmás y en la montaña de Betel, y los mil restantes se los confió a Jonatán, en Guibea de Benjamín. Por lo que toca a los demás, Saúl los mandó de vuelta a su tienda."
,"3":"Jonatán mató al jefe de los filisteos que estaba en Guibea, y los filisteos supieron la noticia."
,"4":"Saúl ordenó entonces que se tocara el cuerno en todo el país para decir: '¡Sépanlo los hebreos!' Y todo Israel supo la noticia: 'Saúl mató al jefe de los filisteos, Israel se ha vuelto odioso para los filisteos'. Inmediatamente se reunió el pueblo tras Saúl en Guilgal."
,"5":"Los filisteos se movilizaron para atacar a Israel. Tenían tres mil carros y seis mil jinetes, su pueblo era tan numeroso como la arena de la orilla del mar. Subieron para acampar en Micmás, al este de Bet-Avén."
,"6":"Los israelitas tuvieron que retroceder. Al verse en peligro se escondían en las cavernas, los matorrales, las rocas, las grutas y en las cisternas."
,"7":"Algunos hebreos atravesaron el Jordán rumbo a Gad y al territorio de Galaad. Saúl estaba todavía esperando en Guilgal, pero todo el pueblo que estaba con él temblaba."
,"8":"Saúl esperó siete días de acuerdo al plazo que había fijado Samuel, pero como Samuel no llegaba nunca a Guilgal, la gente comenzó a irse."
,"9":"Entonces Saúl dijo: 'Tráiganme el holocausto y los sacrificios de comunión'. Y él ofreció el holocausto."
,"10":"Recién acababa de ofrecer el holocausto, cuando llegó Samuel. Saúl salió a su encuentro para saludarlo."
,"11":"Samuel le dijo: '¿Qué hiciste?' Y Saúl le respondió: 'Vi que la gente empezaba a irse porque tú no llegabas para la fecha convenida, y ya los filisteos se reunían en Micmás."
,"12":"Entonces me dije: Los filisteos van a bajar a atacarme en Guilgal sin que haya tenido tiempo para implorar a Yavé. Por eso decidí ofrecer un sacrificio por mi cuenta'."
,"13":"Samuel le dijo: 'Te has portado como un tonto: no cumpliste la orden que te había dado Yavé tu Dios cuando te dijo que te haría rey de Israel para siempre."
,"14":"Por eso ahora tu realeza no se mantendrá. Yavé ya se buscó un hombre según su corazón para ponerlo como jefe de su pueblo, porque tú no respetaste las órdenes de Yavé'."
,"15":"Samuel se fue, dejó Guilgal y siguió su camino. El resto del pueblo salió tras Saúl para enfrentar a los enemigos. De Guilgal subió a Guibea de Benjamín, donde Saúl pasó revista a la gente que estaba con él, eran más o menos seiscientos."
,"16":"Saúl, su hijo Jonatán y la gente que estaba con ellos, se quedaron en Guibea de Benjamín mientras que los filisteos acampaban en Micmás."
,"17":"Salió del campamento de los filisteos una tropa, dividida en tres secciones. Una se dirigió por el camino de Ofra al territorio de Sual,"
,"18":"otra tomó la dirección de Bet-Horón y una tercera se dirigió a la colina que domina el valle de Jienes, hacia el desierto."
,"19":"En ese tiempo no había herreros en todo el territorio de Israel, porque los filisteos se habían dicho: 'De ningún modo los hebreos se fabricarán espadas o lanzas'."
,"20":"Por eso, todos los israelitas bajaban donde los filisteos para afilar su arado, su hacha, sus guadañas o su azadón."
,"21":"Por afilar los arados y las hojas se pagaban dos tercios de siclo; por afilar las hachas o enderezar las horquetas, se pagaba un tercio de siclo."
,"22":"A eso se debía que el día del combate ninguno de los hombres que estaban con Saúl y Jonatán tenía en su mano una lanza o una espada. Unicamente Saúl y Jonatán portaban armas."
,"23":"Salió un destacamento filisteo para ocupar el paso de Micmás."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Jonatán, el hijo de Saúl, dijo al joven que llevaba sus armas. 'Vamos y pasemos al puesto de los filisteos que está al otro lado'. Pero nada le dijo a su padre."
,"2":"Saúl mientras tanto se había instalado en la frontera de Guibea, bajo el granado que está al lado de la era, y con él había alrededor de seiscientos hombres."
,"3":"Ajiya, hijo de Ajitub, hermano de Icabod, hijo de Finjas, llevaba el efod. Nadie de la tropa se dio cuenta de que Jonatán había partido."
,"4":"En el desfiladero que trataba de atravesar Jonatán para llegar al puesto filisteo, hay dos rocas sobresalientes a uno y otro lado; una se llama Bosés y la otra Senné."
,"5":"La primera roca se sitúa al norte, frente a Micmás, la segunda al sur frente a Gueba."
,"6":"Jonatán dijo al joven que llevaba sus armas: 'Vamos y atravesemos hasta el puesto de esos incircuncisos. A lo mejor Yavé hace algo por nosotros, porque nada detiene a Yavé. Ya sea con muchos o con pocos, él puede siempre salvar'."
,"7":"El joven le respondió: 'Haz lo que mejor te parezca, estoy contigo y haré lo que tú me digas'."
,"8":"Jonatán le dijo: 'Escucha, iremos donde esos hombres y dejaremos que nos vean."
,"9":"Si nos dicen: ¡Deténganse, esperen que vayamos! nos quedaremos donde estemos y no subiremos donde ellos."
,"10":"Pero si nos dicen: ¡Suban donde nosotros!, subamos. Esa será la señal de que Yavé los ha puesto en nuestras manos."
,"11":"Se dejaron ver pues ambos por el destacamento de los filisteos. Estos pensaron: 'Miren a los hebreos que salen de los hoyos donde se habían escondido'."
,"12":"Los hombres del puesto se dirigieron a Jonatán y al joven que transportaba sus armas, diciéndoles: 'Suban hacia nosotros, tenemos algo que enseñarles'. Jonatán dijo a su compañero: 'Sube detrás de mí, porque Yavé los ha entregado a las manos de Israel'."
,"13":"Jonatán subió escalando con manos y pies, y su compañero lo seguía. Los filisteos caían ante Jonatán y su compañero los remataba detrás de él."
,"14":"Jonatán y su compañero hicieron allí una primera masacre: veinte hombres cayeron en un espacio que no medía más de un medio surco."
,"15":"Cundió el terror por el campamento, por el campo y por todo el pueblo. Se apoderó también el miedo del puesto y de toda la tropa de soldados, la tierra tembló, era como un terror que venía de Dios."
,"16":"Los centinelas de Saúl que estaban en Guibea de Benjamín vieron que el campamento de los filisteos se dispersaba por todos los lados."
,"17":"Entonces Saúl dijo a los que estaban con él: 'Pasen revista al pueblo y vean quién salió de entre nosotros'. Pasaron revista al pueblo y sólo faltaban Jonatán y el joven que llevaba sus armas."
,"18":"Saúl dijo a Ajiya: 'Trae el efod'. Pues él era quien llevaba el efod ante todo Israel."
,"19":"Pero mientras Saúl conversaba con el sacerdote, fue creciendo la confusión en el campamento de los filisteos. Por último Saúl le dijo al sacerdote: 'Saca tu mano'. "
,"20":"Luego Saúl y toda su tropa se juntaron y llegaron al sitio del combate. Allí se había producido un pánico enorme: se atacaban con su espada unos a otros."
,"21":"Los hebreos que se habían enrolado con los filisteos y que habían subido con ellos al campamento, desertaron para juntarse con los israelitas que estaban con Saúl y Jonatán."
,"22":"Todos los israelitas que se habían escondido en la montaña de Efraín, se lanzaron también en persecución de los filisteos que huían delante de ellos."
,"23":"Ese día Yavé dio la victoria a Israel. La batalla se extendió más allá de Bet-Avén. "
,"24":"En el momento en que los israelitas estaban cercados por todas partes, Saúl había declarado solemnemente delante de todo el pueblo: '¡Maldito sea el que coma algo antes del anochecer, antes de que me haya vengado de mis enemigos!' Y todo el pueblo se quedó en ayunas."
,"25":"Había miel en ese lugar."
,"26":"El pueblo entró en el bosque y vio la miel que goteaba. Pero nadie llevó su mano a la boca porque el pueblo tenía presente la maldición que había pronunciado el rey."
,"27":"Jonatán, empero, no había oído el juramento de su padre, acercó la punta de su bastón, lo hundió en el panal de miel y lo llevó a su boca: sus ojos se iluminaron."
,"28":"Alguien de los soldados le dijo: 'Tu padre declaró solemnemente delante de todo el pueblo: Maldito sea el que coma algo hoy'."
,"29":"Jonatán respondió: 'Mi padre le ha hecho un gran daño al país; fíjense cómo se iluminaron mis ojos en cuanto probé un poco de miel."
,"30":"Si todo el pueblo hubiera hoy tomado algo para comer del botín de sus enemigos, la derrota de los filisteos habría sido con toda seguridad más grande'."
,"31":"Ese día aplastaron a los filisteos desde Micmás hasta Ayalón, pero el pueblo estaba completamente agotado."
,"32":"El pueblo se abalanzó entonces sobre el botín, tomó cabras u ovejas, bueyes, terneros, los mataron allí mismo y comieron encima de la sangre."
,"33":"Le avisaron a Saúl: 'El pueblo está pecando contra Yavé: la gente come carne al lado de la sangre'. Saúl exclamó: '¡Todos ustedes son unos infieles! Hagan rodar hasta aquí una piedra grande'."
,"34":"Luego añadió Saúl: 'Dispérsense entre medio del pueblo y díganles que cada cual traiga aquí su buey o su carnero. Los inmolarán y los comerán, pero no pequen contra Yavé comiendo encima de la sangre'. Cada cual llevó lo que tenía en su mano esa tarde e hicieron la inmolación en ese lugar."
,"35":"Saúl levantó allí un altar para Yavé; fue el primer altar que le levantó."
,"36":"Saúl les dijo luego: 'Bajemos para perseguir a los filisteos durante la noche; ataquémoslos hasta que brille el alba y no dejemos a nadie de ellos con vida'. Le respondieron: '¡Haz lo que piensas!' El sacerdote dijo entonces: 'Tenemos que consultar a Dios'."
,"37":"Saúl consultó a Dios: '¿Tengo que bajar para perseguir a los filisteos? ¿Los pondrás en manos de Israel?' Pero ese día Dios no le respondió."
,"38":"Entonces dijo Saúl: 'Acérquense ustedes, jefes del pueblo, y verifiquen en qué consistió el pecado."
,"39":"Lo juro por la vida de Yavé que acaba de salvar a Israel: aunque sea mi hijo Jonatán el que haya pecado, morirá'. Pero nadie de todo el pueblo le respondió."
,"40":"Luego dijo a todo Israel: 'Ustedes se pondrán a un lado, yo y mi hijo Jonatán nos pondremos al otro'. El pueblo dijo a Saúl: '¡Haz como piensas!'"
,"41":"Saúl preguntó a Yavé: 'Dios de Israel, ¿por qué no respondiste hoy a tu servidor? Si ese pecado está en mí o en mi hijo Jonatán, da los Urim. Pero si ese pecado se halla en el lado de tu pueblo Israel, da los Tumim'. Resultaron designados Jonatán y Saúl, mientras que el pueblo salió libre de culpa."
,"42":"Saúl dijo: 'Hagan el sorteo entre mí y mi hijo Jonatán'. Y salió sorteado Jonatán."
,"43":"Entonces Saúl dijo a Jonatán: 'Dime lo que hiciste'. Jonatán le respondió: 'Simplemente probé un poco de miel con la punta del bastón que tenía en la mano, pero estoy dispuesto a morir'."
,"44":"Saúl respondió: '¡Maldígame Dios, y remaldígame si tú no mueres, Jonatán!'"
,"45":"Pero el pueblo dijo a Saúl: '¿Cómo es posible que muera Jonatán, que le ha dado a Israel una victoria tan grande? ¡Ni siquiera pensarlo! Por la vida de Yavé, no caerá en tierra ni un solo cabello de su cabeza porque él actuó hoy con Dios'. Y así fue como el pueblo salvó la cabeza de Jonatán."
,"46":"Saúl dejó de perseguir a los filisteos; subió de vuelta mientras que los filisteos se volvían a sus casas."
,"47":"Saúl había afirmado su realeza en Israel; combatió con todos sus enemigos: Moab, los hijos de Amón, Edom, los reyes de Soba y los filisteos. Doquiera se volviera, resultaba vencedor."
,"48":"Aplastó a Amalec a lo largo de una gran expedición, y libró a Israel de los ataques de los asaltantes."
,"49":"Los hijos de Saúl eran Jonatán, Isyo y Malqui-Suá. Tuvo dos hijas, la mayor se llamaba Merob y la segunda Mical."
,"50":"La mujer de Saúl era Ajinoam, hija de Ajimaas. El jefe de su ejército era Abner, hijo de Ner, tío de Saúl."
,"51":"Quis, el padre de Saúl y Ner, el padre de Abner, eran hijos de Abniel."
,"52":"Durante toda la vida de Saúl hubo una guerra encarnizada contra los filisteos. Cada vez que Saúl veía a un hombre robusto y valiente, lo enrolaba en su servicio."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Samuel dijo a Saúl: 'Yavé me envió para consagrarte como rey de su pueblo Israel. Escucha ahora a Yavé."
,"2":"Esto dice Yavé de los ejércitos. Quiero castigar a Amalec por lo que hizo a Israel cuando subía de vuelta de Egipto: le cerró el camino."
,"3":"Anda pues a castigar a Amalec y lanza el anatema sobre todo lo que le pertenece. No tendrás piedad de él, darás muerte a los hombres, a las mujeres, a los niños, a los bueyes y corderos, a los camellos y burros'."
,"4":"Saúl reunió al pueblo y le pasó revista en Telam; había doscientos mil hombres de a pie y diez mil de Judá."
,"5":"Saúl avanzó hasta la ciudad de Amalec y se escondió en la quebrada."
,"6":"Saúl les mandó decir entonces a los quenitas: 'Aléjense, sepárense de los amalecitas porque si no serán exterminados junto con ellos, siendo que ustedes se mostraron bondadosos con los israelitas cuando subían de Egipto'. Los quenitas se alejaron de los amalecitas."
,"7":"Saúl aplastó a Amalec desde Javila hasta Sur que está al este de Egipto."
,"8":"Hizo prisionero a Agag, rey de los amalecitas y pasó a cuchillo a toda la población debido al anatema."
,"9":"Pero Saúl y su ejército no quisieron condenar al anatema a Agag y a lo mejor del ganado menor y mayor, los animales gordos y los corderos, en una palabra, todo lo que era bueno. Al contrario, exterminaron todo lo que, en el ganado, era malo y sin valor."
,"10":"Le llegó entonces a Samuel una palabra de Yavé:"
,"11":"Me pesa de haber dado la realeza a Saúl, porque se apartó de mí y no obedeció mis órdenes'. Samuel se sintió muy disgustado por eso y suplicó a Yavé toda la noche."
,"12":"Muy de mañana Samuel salió para encontrarse con Saúl, y le dijeron: 'Saúl fue a Carmel para levantar allí un monumento en recuerdo de su victoria, luego partió de allí y bajó a Guilgal'."
,"13":"Cuando Samuel llegó donde estaba Saúl, éste le dijo: 'Yavé te bendiga, he ejecutado las órdenes de Yavé'."
,"14":"Pero Samuel le contestó: '¿Qué ruido es ese que siento de cabras y ovejas? ¿Qué ruido es ese que siento también de bueyes y burros?'"
,"15":"Saúl respondió: 'Los trajimos de los amalecitas. El pueblo separó lo mejor del ganado menor y del mayor para ofrecerlo en sacrificio a Yavé tu Dios, pero todo lo demás fue condenado al anatema'."
,"16":"Entonces Samuel dijo a Saúl: '¡Basta! Voy a comunicarte lo que me dijo Yavé esta noche'. Saúl le dijo: 'Habla'."
,"17":"Samuel le dijo: '¿No te convertiste en jefe de las tribus de Israel? ¿No te consagró Yavé como rey de Israel cuando eras tan poca cosa a tus propios ojos?"
,"18":"Yavé te había confiado una misión, te había dicho: Anda, condena al anatema a los amalecitas; harás la guerra a esos pecadores hasta exterminarlos."
,"19":"¿Por qué no hiciste caso a las palabras de Yavé? ¿Por qué te abalanzaste sobre el botín? ¿Por qué hiciste lo que es malo a los ojos de Yavé?"
,"20":"Saúl respondió a Samuel: 'Hice caso a la voz de Yavé, hice una expedición por donde Yavé me había mandado. Capturé a Agag, rey de Amalec, y condené a Amalec al anatema."
,"21":"Pero el pueblo separó del botín lo mejor del ganado menor y mayor. Lo excluyó del anatema para ofrecérselo a Yavé tu Dios en sacrificio, en Guilgal'."
,"22":"Samuel le contestó: '¿Piensas acaso que a Yavé le gustan más los holocaustos y los sacrificios que la obediencia a su palabra? La obediencia vale más que el sacrificio, y la fidelidad, más que la grasa de los carneros."
,"23":"La rebelión es un pecado tan grave como la brujería; la desobediencia es un crimen tan grave como la idolatría. ¡Ya que rechazaste la palabra de Yavé, Yavé te echa de la realeza!'"
,"24":"Saúl dijo a Samuel: 'Tuve miedo al pueblo e hice lo que me pedía, por esta razón pequé y desobedecí la orden de Yavé y sus palabras."
,"25":"Ahora, por favor, perdona mi pecado y ven conmigo para que me postre delante de Yavé'."
,"26":"Pero Samuel dijo a Saúl: 'Esta vez no iré contigo. Ya que despreciaste la palabra de Yavé, Yavé te ha desechado: ya no reinarás más sobre Israel'."
,"27":"Y como Samuel hiciera ademán de irse a su casa, Saúl quiso retenerlo tomándolo del borde de su manto, que se rasgó."
,"28":"Entonces Samuel le dijo: 'Hoy Yavé te ha arrancado la realeza de Israel, y se la ha dado a tu prójimo que es mejor que tú."
,"29":"El que es la Gloria de Israel no puede mentir ni arrepentirse'."
,"30":"Saúl dijo: 'Es cierto, he pecado. Pero no me vayas a humillar ante los ancianos de mi pueblo y ante Israel. Ven conmigo para que vaya a postrarme delante de Yavé tu Dios'."
,"31":"Samuel se fue pues con Saúl y éste se postró delante de Yavé."
,"32":"Luego dijo Samuel: 'Tráiganme a Agag, rey de Amalec'. Agag se decía a sí mismo: 'seguramente se alejó la amargura de la muerte'; cuando llegó temblando,"
,"33":"Samuel le dijo: 'Así como tu espada privó a las mujeres de sus hijos, así también tu madre será una mujer privada de su hijo'. Y Samuel despedazó a Agag en presencia de Yavé, en Guilgal."
,"34":"Samuel se volvió a Ramá, mientras que Saúl regresaba a su casa de Guibea de Saúl."
,"35":"Samuel no volvió a ver más a Saúl hasta el día de su muerte, pues se sentía molesto por el hecho de que a Yavé ahora le pesaba haber hecho a Saúl rey de Israel."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Yavé dijo a Samuel: '¿Hasta cuándo seguirás llorando por Saúl? ¿No fui yo quien lo rechazó para que no reine más en Israel? Llena pues tu cuerno de aceite y anda. Te envío donde Jesé de Belén, porque me escogí un rey entre sus hijos'."
,"2":"Samuel respondió: '¿Cómo podré ir? Si Saúl se entera, me matará'. Pero Yavé le dijo: 'Tomarás una ternera y dirás que has ido a ofrecer un sacrificio a Yavé."
,"3":"Invitarás al sacrificio a Jesé, y yo te daré a conocer lo que tienes que hacer: me consagrarás al que te mostraré'."
,"4":"Samuel hizo como le había dicho Yavé. Cuando llegó a Belén, los ancianos salieron temblando a su encuentro. Le dijeron: '¿Vienes en son de paz?'"
,"5":"Sí, respondió, en son de paz. He venido a ofrecer un sacrificio a Yavé. Purifíquense y vengan conmigo al sacrificio'. Fue a purificar a Jesé y a invitarlo al sacrificio junto con sus hijos."
,"6":"Cuando entraron, Samuel divisó a Eliab y pensó: 'Seguramente ése será el que Yavé va a consagrar'."
,"7":"Pero Yavé dijo a Samuel: 'Olvídate de su apariencia y de su gran altura, lo he descartado. Porque Dios no ve las cosas como los hombres: el hombre se fija en las apariencias pero Dios ve el corazón'."
,"8":"Jesé llamó a Abinadab y lo hizo pasar ante Samuel. Pero Samuel le dijo: 'Este tampoco es el elegido de Yavé'."
,"9":"Jesé hizo pasar a Samma, pero Samuel le dijo: 'Yavé tampoco lo ha elegido'."
,"10":"Finalmente Jesé hizo pasar a sus siete hijos ante Samuel, y Samuel decía a Jesé: 'Yavé no ha elegido a ninguno de estos'."
,"11":"Entonces Samuel dijo a Jesé: '¿Esos son todos tus hijos?' Respondió: 'Todavía falta el menor, que cuida el rebaño'. Samuel le dijo: 'Mándalo a buscar porque no nos sentaremos a la mesa hasta que no esté aquí'."
,"12":"Fueron pues a buscarlo y llegó; era rubio con hermosos ojos y una bella apariencia. Yavé dijo entonces: 'Párate y conságralo; es él'."
,"13":"Samuel tomó su cuerno con aceite y lo consagró en medio de sus hermanos. Desde entonces y en adelante el espíritu de Yavé se apoderó de David. Por lo que respecta a Samuel, se levantó y se volvió a Ramá."
,"14":"El espíritu de Yavé se retiró de Saúl y un mal espíritu que provenía de Yavé le producía terror."
,"15":"Los servidores de Saúl le dijeron: 'Un mal espíritu de Dios te produce esos sustos."
,"16":"Basta con que nuestro señor lo ordene, ya que tus servidores estamos para atenderte, y buscaremos a un hombre que sepa tocar la cítara, y en cuanto se deje caer sobre ti el mal espíritu, él tocará y tú te mejorarás'."
,"17":"Saúl dijo, pues, a sus servidores: 'Búsquenme a un hombre que sea un buen músico y tráiganmelo'."
,"18":"Uno de los servidores pidió la palabra y dijo: 'Conozco a un hijo de Jesé de Belén que sabe tocar música. Es un muchacho valiente, un buen guerrero; es inteligente, es buen mozo y Yavé está con él'."
,"19":"Saúl mandó a uno de sus mensajeros donde Jesé para que le dijera: 'Mándame a tu hijo David, el que cuida el rebaño'."
,"20":"Jesé tomó un pan, un cuero de vino y un cabrito, y se los mandó a Saúl por intermedio de su hijo David."
,"21":"Así fue como David llegó a la casa de Saúl y se puso a su servicio. Saúl lo quería mucho y David llegó a ser el que llevaba sus armas."
,"22":"Saúl mandó a decir a Jesé: 'Dale permiso a David para que se quede a mi servicio porque me cae simpático'."
,"23":"Y así, cuando el espíritu de Dios maltrataba a Saúl, David tomaba la cítara y la tocaba; eso le hacía bien a Saúl, se sentía aliviado y el mal espíritu se alejaba de él."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Los filisteos movilizaron sus tropas para la guerra. Se reunieron en Soco de Judá: su campamento se situaba en Efés-Damim, entre Soco y Azeca."
,"2":"Saúl y los Israelitas se concentraron también, instalaron su campamento en el valle del Terebinto y se dispusieron en orden de batalla frente a los filisteos."
,"3":"Los filisteos estaban en una de las laderas de los cerros y los israelitas, en la otra; solamente los separaba un valle."
,"4":"Un guerrero destacado, de nombre Goliat, salió de las filas de los filisteos; era un hombre de Gat que medía más de dos metros."
,"5":"Tenía en su cabeza un casco de bronce e iba revestido de una coraza de escamas. El peso de su coraza de bronce era de sesenta kilos."
,"6":"Llevaba polainas de bronce y a la espalda una lanza de bronce;"
,"7":"el palo de su lanza era tan grueso como el que conforma el marco de un telar y la punta de hierro de su lanza pesaba nada menos que siete kilos. Un escudero iba delante de él."
,"8":"Se puso frente a las filas de Israel y les gritó: '¿Por qué han salido en son de guerra? ¿No soy yo el filisteo, y ustedes, los servidores de Saúl? Elijan pues al que me enfrentará en nombre de ustedes."
,"9":"Si es capaz de vencerme y derribarme, entonces seremos sus esclavos; pero si yo lo venzo y lo derribo, ustedes serán nuestros esclavos y nos servirán'."
,"10":"El filisteo agregó: 'Les lanzo pues, hoy, un desafío a las tropas de Israel: denme un hombre para que me enfrente solo a solo'."
,"11":"Cuando Saúl e Israel oyeron las palabras del filisteo, quedaron asustados y desmoralizados."
,"12":"David era hijo de Jesé, un efrateo de Belén de Judá, quien tenía ocho hijos."
,"13":"En tiempos de Saúl, Jesé ya era viejo, pero había enviado hombres al ejército. Sus tres hijos mayores Eliab, el primogénito, Abinadab, el segundo, y Samá, el tercero, se fueron a la guerra con Saúl."
,"14":"David era el menor, y como los tres mayores se habían ido con Saúl,"
,"15":"David alternaba sus viajes al campamento de Saúl con el cuidado del rebaño de su padre en Belén."
,"16":"El filisteo se presentaba cada mañana y cada tarde, y así lo hizo durante cuarenta días."
,"17":"Jesé dijo a David: 'Toma para tus hermanos una bolsa de trigo tostado y diez panes. Se los llevarás al campamento a tus hermanos,"
,"18":"y darás estos diez quesillos al jefe de mil. Preguntarás por la salud de tus hermanos y me traerás algún recuerdo de ellos.'"
,"19":"Tanto ellos como los hombres de Israel estaban con Saúl en el valle del Terebinto, peleando contra los filisteos."
,"20":"David se levantó de madrugada, dejó el rebaño encargado a un pastor, tomó su bolsa y se fue tal como Jesé se lo había ordenado. Cuando llegó, el ejército estaba dejando el campamento para tomar sus posiciones y lanzar el grito de guerra."
,"21":"Los israelitas y los filisteos se pusieron en fila frente a frente."
,"22":"David encargó su bolsa al que cuidaba los equipajes y corrió al frente de la tropa. Fue a saludar a sus hermanos."
,"23":"Mientras estaba conversando con ellos salió de las filas Goliat, el coloso filisteo de Gat, a lanzar su desafío, y David lo oyó."
,"24":"Los israelitas, apenas lo vieron, empezaron a retroceder, llenos de miedo."
,"25":"Un hombre de Israel dijo: '¿Han visto a ese hombre que sale de las filas filisteas para insultar a Israel? Al que logre derrotarlo, el rey lo colmará de riquezas, le dará a su hija, y eximirá a la casa de su padre de cualquier impuesto'."
,"26":"David preguntó a los hombres que estaban a su rededor: '¿Qué le harán al que venza a ese filisteo y logre vengar el insulto que se hace a Israel? ¡Quién es ese filisteo incircunciso para que insulte así a las tropas del Dios vivo!'"
,"27":"Y la gente repitió las mismas palabras: 'Esto harán con el hombre que lo venza'."
,"28":"Eliab, su hermano mayor, oyó que conversaba con los soldados y se enojó con David. Le dijo: '¿Por qué viniste para acá? ¿A quién dejaste encargadas las ovejas que tenemos en el desierto? ¡Ah, ya sé, tú andas buscando la ocasión y viniste acá sólo para ver la batalla'."
,"29":"David le respondió: 'Pero, ¿qué he hecho yo? ¿Acaso uno no tiene derecho a hablar?'"
,"30":"Se dirigió a otro y le hizo la misma pregunta, pero las personas le dieron la misma respuesta que la primera vez."
,"31":"Oyeron las palabras de David y se las transmitieron a Saúl, quien lo mandó llamar."
,"32":"David dijo a Saúl: '¡No hay por qué tenerle miedo a ése! Yo, tu servidor, iré a pelear con ese filisteo'."
,"33":"Pero Saúl dijo a David: 'Tú no podrás pelear con él, eres sólo un niño y él en cambio es un hombre que pelea desde su juventud'."
,"34":"David dijo a Saúl: 'Cuando estaba guardando el rebaño de mi padre y aparecía un león o un oso para llevarse una oveja del rebaño,"
,"35":"yo lo perseguía y lo golpeaba y le quitaba la presa del hocico. Y si se volvía contra mí, lo tomaba de la quijada y lo golpeaba hasta matarlo. Yo he matado leones y osos; lo mismo haré con ese filisteo que ha insultado a los ejércitos del Dios vivo."
,"36":"¡Así como tu servidor ha vencido al león y al oso, lo mismo hará con ese filisteo que ha insultado las tropas del Dios vivo!'"
,"37":"David dijo además: 'De la misma manera que Yavé me ha librado de las garras del león y de las zarpas del oso, así también me librará de las manos de ese filisteo'. Entonces Saúl dijo a David: 'Anda y que Yavé esté contigo'."
,"38":"Saúl pasó a David su propio equipo de combate; le puso en la cabeza un casco de bronce y lo revistió con una coraza."
,"39":"David se ciñó la espada por encima de su traje, trató de caminar, pero no estaba acostumbrado a eso. Entonces dijo a Saúl: 'No puedo caminar con todo esto porque no tengo costumbre'. Y David se quitó todo."
,"40":"Tomó su palo y recogió del lecho del arroyo cinco piedras bien planas. Las puso en su morral de pastor, en su bolsa de cuero, tomó la honda en la mano y avanzó hacia el filisteo."
,"41":"El filisteo iba y venía y se acercó a David; su escudero iba delante de él."
,"42":"El filisteo dio a David una mirada de desprecio, porque no era más que un muchacho, (David era rubio y de buena apariencia)."
,"43":"El filisteo dijo a David: '¿Acaso soy un perro para que vengas a atacarme con palos? El filisteo maldijo a David por todos sus dioses,"
,"44":"y en seguida le dijo: 'Ven para acá para entregarte como comida a los buitres y a las fieras'."
,"45":"David respondió al filisteo: 'Tú me atacas con la espada, la lanza y la jabalina, pero yo me lanzo contra ti en nombre de Yavé de los ejércitos, el Dios de las tropas de Israel que has insultado."
,"46":"Hoy Yavé te entregará en mis manos, te derribaré y te arrancaré la cabeza. Hoy mismo daré tu cadáver y los cadáveres del ejército filisteo a las aves de rapiña y a las fieras salvajes. Toda la tierra sabrá que hay un Dios en Israel,"
,"47":"y todos los que están aquí reunidos sabrán que Yavé no necesita espada o lanza para dar la victoria, porque la suerte de la batalla está en sus manos: él los va a poner a ustedes en nuestras manos'."
,"48":"En ese momento el filisteo avanzó y se acercó a David. Este salió hacia adelante al encuentro del filisteo,"
,"49":"metió rápidamente la mano en el morral, sacó de allí una piedra y la lanzó con la honda. Le dio al filisteo en la frente, la piedra se le hundió en la frente y cayó de bruces al suelo."
,"50":"Así es como David venció al filisteo con una honda y una piedra: lo derribó y le dio muerte. Pero no tenía espada."
,"51":"Entonces corrió, se detuvo ante el filisteo, le quitó la espada que tenía en la vaina, y espada en mano, le cortó la cabeza. Así acabó con él. Los filisteos, que habían visto la muerte de su campeón, salieron huyendo. "
,"52":"Los hombres de Israel y de Judá se levantaron, lanzaron su grito de guerra y persiguieron a los filisteos hasta la entrada de Gat y hasta las puertas de Ecrón. Y los cadáveres de los filisteos quedaron esparcidos por todo el camino, desde Saarayim hasta Gat y Ecrón."
,"53":"Cuando regresaron los israelitas de esa persecución a los filisteos, saquearon su campamento."
,"54":"David tomó la cabeza del filisteo y la llevó a Jerusalén; sus armas, en cambio, las dejó en su propia tienda."
,"55":"Al ver como David iba a enfrentarse con el filisteo, Saúl había dicho a Abner, el jefe de su ejército: 'Abner, ¿de quién es hijo ese muchacho?' Abner le respondió: 'Por mi vida, oh rey, que no lo sé'."
,"56":"El rey le dijo: 'Infórmate para saber de quién es hijo ese muchacho'."
,"57":"Cuando David regresó después de haber derrotado al filisteo, Abner lo llevó donde Saúl; tenía en la mano la cabeza del filisteo."
,"58":"Saúl le dijo: 'Joven, ¿de quién eres hijo?' Y David le respondió: 'Soy hijo de tu servidor Jesé de Belén'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Aún no había terminado de hablar David, cuando el corazón de Jonatán sintió afecto por David, y desde ese día, Jonatán amó a David tanto como a sí mismo."
,"2":"Ese día Saúl alojó a David en su casa y no dejó que volviera donde su padre."
,"3":"Jonatán por su parte hizo un pacto con David porque lo amaba como a sí mismo."
,"4":"Jonatán se quitó el manto que llevaba puesto y se lo dio a David junto con su traje, su espada, su casco y su cinturón."
,"5":"En todas las expediciones a donde lo enviaba Saúl, David tenía pleno éxito y Saúl lo puso a la cabeza de todos sus hombres de guerra. Era querido por todo el pueblo y también por los servidores del rey."
,"6":"Cuando volvieron, después que David hubo dado muerte al filisteo, las mujeres de todas las ciudades de Israel salieron al encuentro del rey Saúl, cantando y bailando, con tamboriles y arpas, canciones festivas."
,"7":"El coro de las bailarinas entonaba este canto: 'Saúl mató a mil, pero David mató a diez mil'."
,"8":"Eso le disgustó mucho a Saúl quien se enojó. Se dijo: 'Le han dado diez mil a David y a mí sólo mil, no le falta más que la realeza'."
,"9":"Desde ese día, Saúl miró a David con malos ojos."
,"10":"Al día siguiente, se apoderó de Saúl un mal espíritu de Dios, y estaba como loco en su casa. David le tocaba la cítara como todos los días, pero Saúl había tomado su lanza."
,"11":"Le disparó la lanza pensando: 'Voy a clavar a David en el muro'. Pero David eludió el golpe las dos veces."
,"12":"Saúl empezó a temer a David porque Yavé estaba con él mientras que se retiraba de Saúl."
,"13":"Saúl alejó a David de su casa y lo hizo jefe de mil: éste iba y venía a la cabeza del pueblo."
,"14":"David resultaba victorioso en todas sus expediciones, porque Yavé estaba con él."
,"15":"Saúl vio el éxito de David y le temió."
,"16":"Todo Israel y Judá amaban a David porque éste iba y venía al frente del pueblo."
,"17":"Saúl dijo entonces a David: 'Conoces a mi hija mayor Merob. Te la daré como esposa si demuestras ser valiente a mi servicio cuando dirijas las guerras de Yavé'. Pues Saúl se decía: 'Que no muera por mis manos sino por las de los filisteos'."
,"18":"David dijo a Saúl: '¿Quién soy yo? ¿Qué vale mi vida? ¿Qué es la familia de mi padre en Israel para que yo llegue a ser el yerno del rey?'"
,"19":"Pero cuando llegó el día en que debía dársele a David la hija de Saúl, ésta había sido dada como esposa a Adriel de Mejola."
,"20":"Mical, la segunda hija de Saúl, amaba a David, y se lo dijeron a Saúl, quien se sintió feliz por eso."
,"21":"Pues se dijo: 'Se la daré, pero será para él una trampa. Así conseguiré que caiga en manos de los filisteos'. Saúl llamó a David por segunda vez: 'Ahora sí que serás mi yerno'."
,"22":"Saúl dio esta orden a sus servidores: 'Conversen discretamente con David y díganle: El rey te quiere. Sabes que todos sus servidores te aman, acepta pues ser ahora el yerno del rey'."
,"23":"Los servidores de Saúl transmitieron estas palabras a David, y David les respondió: 'Parece que para ustedes es muy sencillo llegar a ser yerno del rey. Pero ¿se han fijado en que yo soy un hombre sin dinero y humilde?'"
,"24":"Los servidores de Saúl se lo repitieron: 'Esta es la respuesta de David'."
,"25":"Saúl les dijo: 'Así hablarán a David: Para ese matrimonio el rey no quiere dinero sino únicamente cien prepucios de filisteos, para vengarse así de sus enemigos'. De ese modo pensaba Saúl que David iba a caer en manos de los filisteos."
,"26":"Los servidores transmitieron esas palabras a David a quien le pareció que sería bueno ser el yerno del rey. Aún no se cumplía el plazo,"
,"27":"cuando David salió de campaña con sus hombres. Mató a doscientos filisteos y se trajo sus prepucios, que mandó al rey para ser así su yerno. Entonces Saúl le dio como esposa a su hija Mical."
,"28":"En esa oportunidad Saúl se dio cuenta de que Yavé estaba con David; Mical, por su parte, la hija de Saúl, quería a David."
,"29":"Saúl temía a David cada vez más, su odio a David se había vuelto habitual."
,"30":"Cada vez que los jefes de los filisteos salían de campaña, David tenía más éxito que los demás servidores de Saúl. Se hizo célebre."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Saúl dijo a su hijo Jonatán y a todos sus servidores que sería bueno asesinar a David; pero Jonatán, el hijo de Saúl, era muy amigo de David."
,"2":"Le advirtió pues a David: 'Saúl, mi padre, trata de matarte; manténte en guardia mañana temprano, ponte a resguardo y escóndete."
,"3":"Yo saldré y me pondré al lado de mi padre en el campo donde tú estés; hablaré de ti a mi padre y veré lo que pasa. Te lo comunicaré en seguida'."
,"4":"Jonatán defendió a David ante su padre Saúl diciéndole: 'No haga daño el rey a su servidor David, pues él no te ha hecho ningún daño y lo que ha hecho te ha servido mucho."
,"5":"Arriesgó su vida para derribar al filisteo y Yavé dio allí una gran victoria a todo Israel. Cuando tú lo viste, te sentías bien contento. ¿Por qué pues pecarías manchándote con sangre inocente si mandas asesinar a David sin razón?'"
,"6":"Saúl escuchó a Jonatán y le juró: 'Por la vida de Yavé que David no morirá'."
,"7":"Inmediatamente Jonatán llamó a David y le contó esa conversación; luego llevó a David donde Saúl, y se puso a su servicio como antes."
,"8":"La guerra se reinició. David salió de campaña contra los filisteos y les infligió una gran derrota; salieron huyendo ante él."
,"9":"Mientras Saúl estaba sentado en su casa con la lanza en la mano, se apoderó de él un mal espíritu de Yavé. David se puso a tocarle la cítara."
,"10":"Saúl trató de clavar a David en el muro con su lanza, pero David esquivó el golpe de Saúl, y la lanza se enterró en el muro. David salió huyendo y escapó una vez más. Esa misma noche, "
,"11":"Saúl mandó unos hombres para que cercaran la casa de David y lo asesinaran en la mañana. Pero Mical, la mujer de David, le dio este aviso: 'Si no escapas esta misma noche, serás asesinado mañana'."
,"12":"Mical ayudó a David a bajar por la ventana; se alejó, salió huyendo y se puso a resguardo."
,"13":"Mical acostó entonces en la cama uno de los ídolos que tenía en la casa, le puso en la cabeza una peluca de pelo de cabra y lo tapó con una manta."
,"14":"A los hombres que Saúl había mandado para apresar a David les dijo: 'Está enfermo'."
,"15":"Pero Saúl mandó de nuevo a sus hombres con el encargo de que vieran a David, diciéndoles: 'Tráiganmelo en su cama, para que le dé muerte'."
,"16":"Entraron los mensajeros y encontraron al ídolo en la cama con la peluca de pelo de cabra en la cabeza."
,"17":"Saúl dijo a Mical: '¿Por qué te has burlado de mí? Dejaste que mi enemigo se fuera, y escapó'. Mical respondió a Saúl: 'Es que él me dijo: Si no me dejas salir, te mato'."
,"18":"David se libró pues al huir y llegó a la casa de Samuel en Ramá; le contó a éste todo lo que le había hecho Saúl. Con Samuel se fue a vivir a las Celdas de los profetas."
,"19":"Le avisaron a Saúl: 'David está en las Celdas, cerca de Ramá'."
,"20":"Saúl mandó entonces unos hombres para que se apoderaran de David. Cuando se encontraron con un grupo de profetas que estaban profetizando, y Samuel los presidía, el espíritu de Dios se apoderó de los enviados de Saúl, quienes se pusieron a profetizar."
,"21":"Se lo comunicaron a Saúl, quien mandó a otros mensajeros, los que también profetizaron. Por tercera vez Saúl mandó mensajeros y éstos también se pusieron a profetizar."
,"22":"Salió él mismo entonces rumbo a Ramá y llegó a la gran cisterna que está en Secú. Allí preguntó: '¿Dónde están Samuel y David?' Le respondieron: 'Están en las Celdas, cerca de Ramá'."
,"23":"Y mientras se dirigía a las Celdas cerca de Ramá, el espíritu de Dios se apoderó de él y continuó su camino profetizando hasta que entró a las Celdas, cerca de Ramá."
,"24":"Además se quitó sus ropas y profetizó delante de Samuel hasta que se desmayó. Permaneció desnudo en el suelo todo el día y toda la noche. Por eso se dice: '¿Así que también Saúl está entre los profetas?'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"David había huido de las Celdas de Ramá. Fue a ver a Jonatán y le dijo: '¿Qué hice? ¿Cuál es mi falta y cuál es mi pecado con tu padre para que quiera matarme?'"
,"2":"Jonatán respondió: 'No, tú no morirás. Mi padre nada me oculta de lo que hace, sea importante o no. ¿Por qué pues mi padre me irá a ocultar eso? Tú te equivocas'."
,"3":"Pero David le dijo: 'Tu padre conoce muy bien la amistad que tú sientes por mí y se dice: Jonatán no debe saberlo porque le parecerá muy mal. Pero, te lo juro por la vida de Yavé y por mi propia cabeza: no hay más que un paso entre la muerte y yo'."
,"4":"Entonces Jonatán dijo a David: '¿Qué puedo hacer por ti?'"
,"5":"David le respondió: 'Mañana es luna nueva y yo tengo que sentarme al lado del rey para cenar; sin embargo déjame que me vaya y me esconderé en el campo hasta la tercera noche."
,"6":"Si tu padre se da cuenta de mi ausencia, le dirás: David me pidió permiso para ir a Belén, su pueblo natal, pues celebran allí el sacrificio anual para la familia."
,"7":"Si tu padre te responde: Está bien, tu servidor nada tendrá que temer; pero si se enoja, sabrás que ya decidió mi muerte."
,"8":"Ya que tú hiciste un pacto conmigo en nombre de Yavé, te pido en base a esa amistad que si hay en mí algún pecado, mejor me mates. ¿Para qué me llevarías donde tu padre?'"
,"9":"Jonatán respondió: 'De ninguna manera; si llego a saber que mi padre decidió tu muerte, yo mismo te avisaré'."
,"10":"David dijo a Jonatán: '¿Quién me avisaría en el caso en que tu padre te mintiera?'"
,"11":"Jonatán dijo a David: 'Ven, vamos al campo'. Y ambos salieron al campo."
,"12":"Jonatán dijo entonces a David: 'Por Yavé Dios de Israel, que desde mañana o pasado mañana veré lo que mi padre tiene en la cabeza. Si todo va bien para ti, te enviaré a alguien para que te lo comunique."
,"13":"Si no lo hago, ¡que Dios me maldiga una y otra vez! Y si mi padre quiere hacerte daño, también te lo comunicaré. Te dejaré pues irte en paz; Yavé estará contigo así como lo estuvo con mi padre."
,"14":"Si todavía estoy en este mundo, no me des muerte; que tu bondad para conmigo sea como la de Yavé."
,"15":"No apartes jamás tu benevolencia de mi familia cuando Yavé haya exterminado a tus enemigos de la superficie de la tierra."
,"16":"Si el nombre de Jonatán desapareciera junto con la familia de Saúl, Yavé le pedirá cuenta de ello a la familia de David'."
,"17":"Y de nuevo Jonatán hizo un juramento a David en nombre de su amistad porque lo amaba como a sí mismo."
,"18":"Jonatán le dijo: 'Mañana es la luna nueva y se notará tu ausencia cuando vean tu puesto vacío."
,"19":"Espera hasta el tercer día; entonces bajarás y vendrás al lugar donde te escondiste la primera vez. Te quedarás al lado del deslinde,"
,"20":"y yo dispararé tres flechas para el lado donde tú estés como si ese fuera el blanco."
,"21":"Luego mandaré a mi sirviente, diciéndole: Anda a buscarme las flechas. Si le digo: Mira, las flechas están detrás de ti, tráemelas. Entonces podrás venir porque no tendrás de qué temer; por la vida de Yavé que no habrá ningún peligro para ti."
,"22":"Pero si digo al sirviente: Mira, las flechas están delante de ti, entonces ponte a salvo, pues Yavé mismo te lo pide."
,"23":"Por lo que respecta a nuestro pacto, Yavé mismo estará entre tú y yo para siempre'."
,"24":"David fue a esconderse en los campos. Cuando llegó la luna nueva, el rey se sentó a la mesa para la cena."
,"25":"Se sentó igual que siempre en el asiento que estaba pegado a la muralla. Jonatán estaba sentado al frente y Abner al lado de Saúl, pero el puesto de David estaba desocupado."
,"26":"Ese día Saúl nada dijo pues pensó: 'No está puro, es algo que pasa. Seguramente no está puro'."
,"27":"Al día siguiente de la luna nueva, el puesto de David seguía desocupado. Saúl dijo a su hijo Jonatán: '¿Por qué el hijo de Jesé no ha venido a la comida ni ayer ni hoy?'"
,"28":"Jonatán respondió a Saúl: 'David me pidió permiso para ir a Belén."
,"29":"Me dijo: Permíteme que vaya, porque tenemos un sacrificio en familia en mi pueblo natal, y mi hermano me lo pidió; dame permiso para ausentarme y ver a mis hermanos. Por eso que no ha venido a comer con el rey'."
,"30":"Al oír esas palabras, Saúl se enojó con Jonatán y le dijo: '¡Hijo de prostituta! Ya lo sabía que tú tomaste partido por el hijo de Jesé, para vergüenza tuya y de la desnudez de tu madre."
,"31":"Mientras el hijo de Jesé esté en este mundo no habrá paz ni para ti ni para tu reino. Manda pues a buscarlo porque merece la muerte'."
,"32":"Jonatán respondió a su padre Saúl: '¿Por qué tendrá que morir? ¿Qué ha hecho?'"
,"33":"Pero Saúl tomó su lanza amenazándolo con tirársela, y Jonatán entendió que su padre había decidido la muerte de David."
,"34":"Jonatán estaba tan sentido que se levantó de la mesa. Ese segundo día de la luna nueva no se sirvió nada; sentía mucha pena por David, y también porque su padre lo había insultado."
,"35":"A la mañana siguiente, Jonatán salió al campo para reunirse con David; con él iba su muchacho."
,"36":"Jonatán le dijo: 'Corre y tráeme las flechas que tire'. El muchacho corría pero Jonatán tiraba las flechas mucho más allá de él,"
,"37":"y mientras el joven iba a buscar la flecha donde la había tirado Jonatán, éste le gritaba: 'Oye, ¿no estará más lejos la flecha?'"
,"38":"Jonatán gritó de nuevo a su sirviente: 'Rápido, apresúrate, no te detengas'. El joven recogió la flecha y volvió donde su patrón."
,"39":"El no sabía nada de todo eso, sólo Jonatán y David estaban enterados."
,"40":"Luego Jonatán pasó sus armas a su muchacho diciéndole: 'Anda y llévatelas a la ciudad'."
,"41":"Cuando se fue, David salió de su escondite, se echó de bruces en el suelo y se inclinó tres veces. En seguida se abrazaron y lloraron un largo rato el uno sobre el otro, pero había llegado el momento de la partida para David."
,"42":"Entonces Jonatán le dijo: 'Anda en paz. Nos hemos hecho un juramento el uno al otro en nombre de Yavé, Yavé estará entre tú y yo, entre mi raza y tu raza para siempre'."
}`)
	CurrentBook.AddChapter(21, `{
"1":"David se levantó, se fue y Jonatán regresó a la ciudad."
,"2":"David llegó a Nob, a la casa del sacerdote Ajimelec. Este salió temblando al encuentro de David y le preguntó: '¿Por qué estás solo? ¿Por qué no hay nadie contigo?'"
,"3":"David respondió al sacerdote Ajimelec: 'El rey me dio una orden, me dijo: Nadie debe saber la misión que te he encargado ni la orden que te he dado. Por eso cité a mis hombres en este lugar."
,"4":"Ahora, ¿qué tienes a mano? Si tuvieras unos cinco panes o alguna otra cosa, dámelos'."
,"5":"El sacerdote dijo a David: 'No tengo a mano ningún pan común sino sólo pan consagrado. Con tal que tus hombres no hayan tenido relaciones con mujeres...'"
,"6":"David respondió al sacerdote: 'Hasta ahora se nos prohibía la mujer cada vez que salía; mis hombres se mantenían puros en lo que se refiere al sexo, y además se trataba de expediciones profanas. Con cuanta mayor razón ahora. Todos están en estado de pureza con respecto al sexo'."
,"7":"Entonces el sacerdote le dio pan consagrado porque no había más pan que los panes que se retiran de delante de Yavé para reemplazarlos por pan fresco el día en que se reponen."
,"8":"Ahora bien, uno de los sirvientes de Saúl se había detenido ese mismo día en el santuario de Yavé; se llamaba Doeg el edomita, y era el más importante de los pastores de Saúl."
,"9":"David dijo a Ajimelec: '¿Por casualidad no tienes a mano alguna lanza o espada? El asunto del rey era tan urgente que no tuve tiempo de tomar mi espada ni mis armas'."
,"10":"El sacerdote le respondió: 'Aquí está la espada del filisteo Goliat al que mataste en el valle del Terebinto; está envuelta en una manta detrás del efod. Si la quieres, tómala, no hay ninguna otra'. David le respondió: 'No hay ninguna otra como esa, dámela'."
,"11":"Ese día David huyó lejos de Saúl y llegó donde Aquis, rey de Gat."
,"12":"Los servidores de Aquis le dijeron: '¡Pero, majestad, si ése es David! ¿No era a propósito de él que bailaban y cantaban: Saúl mató a mil, y David, diez mil?'"
,"13":"Esos comentarios preocuparon mucho a David y tuvo miedo de Aquis, rey de Gat."
,"14":"Entonces les hizo creer que estaba loco, y se comportó como un insano en medio de ellos: tamborileaba las puertas y dejaba correr la baba por su barba."
,"15":"Aquis dijo a sus servidores: 'Si vieron que está loco, ¿para qué me lo trajeron?"
,"16":"¿Es que me hacen falta locos, para que me traigan a éste y que me moleste con sus locuras? ¡Falta poco para que entre en mi casa!'"
}`)
	CurrentBook.AddChapter(22, `{
"1":"David salió de allí y se refugió en la caverna de Adulam. Sus hermanos y su familia lo supieron y bajaron por él a ese lugar."
,"2":"Se le juntaban todos los que tenían problemas, todos los que eran perseguidos por un acreedor o que se sentían descontentos. Se hizo su jefe, y con él había más o menos unos cuatrocientos."
,"3":"De allí se fue David a Mispé de Moab. Dijo al rey de Moab: 'Me gustaría que mi padre y mi madre se quedaran contigo hasta que sepa lo que Dios me tiene reservado'."
,"4":"Llevó pues a sus padres donde el rey de Moab y allí permanecieron hasta el día en que David abandonó ese refugio."
,"5":"El profeta Gad dijo un día a David: 'No te quedes en ese refugio, vuelve al territorio de Judá'. David salió de allí y llegó al bosque de Jeret."
,"6":"Supo Saúl que había noticias de David y de los hombres que andaban con él. Por esos días estaba Saúl sentado en Guibea bajo el tamarindo que está en la colina: tenía en la mano su lanza y todos sus servidores estaban de pie a su alrededor."
,"7":"Saúl dijo entonces a sus servidores reunidos a su alrededor: '¡Oigan, hombres de Benjamín! ¿Creen que el hijo de Jesé les dará a todos ustedes campos y viñas, y que los hará jefes de mil y de cien?"
,"8":"¿Por qué se han puesto todos de acuerdo en contra mía? Nadie me comunicó que mi hijo había hecho un pacto con el hijo de Jesé. Ninguno de ustedes se preocupó de mí, nadie me comunicó que mi hijo había soliviantado contra mí a mi servidor, convirtiéndolo en mi adversario, como es ahora el caso'."
,"9":"Doeg el edomita, que era uno de los jefes de los sirvientes de Saúl, pidió la palabra: 'Vi al hijo de Jesé cuando llegaba a Nob a la casa de Ajimelec hijo de Ajitub."
,"10":"Este consultó por él a Yavé, le dio provisiones y le pasó la espada de Goliat, el filisteo'."
,"11":"Entonces Saúl mandó llamar al sacerdote Ajimelec hijo de Ajitub y a toda su familia, los sacerdotes de Nob; todos fueron a la casa del rey."
,"12":"Saúl le dijo: 'Oyeme bien, hijo de Ajitub'. Este respondió: 'Aquí me tienes, señor'."
,"13":"Saúl le dijo: '¿Por qué has conspirado contra mí tú y el hijo de Jesé? ¿Así que le diste pan y una espada, consultaste a Dios por él, para que se sublevara contra mí y se convirtiera en mi adversario como se ve ahora?'"
,"14":"Ajimelec respondió al rey: '¿Quién es más fiel que David entre todos los servidores del rey? El es yerno del rey, está adscrito a su guardia personal y recibe honores en su casa."
,"15":"Ciertamente no es la primera vez que consulto a Dios por él. El rey nada tiene que reprocharme, ni menos a toda la familia de mi padre, pues tu servidor nada sabía de eso, absolutamente nada'."
,"16":"Pero el rey le dijo: 'Ajimelec vas a morir, y contigo toda la familia de tu padre'."
,"17":"Luego el rey dijo a los soldados que estaban a su alrededor: 'Adelante, den muerte a los sacerdotes de Yavé porque ellos también apoyan a David. Sabían que estaba huyendo de mí y no me lo dijeron'. Pero los servidores del rey no quisieron herir a los sacerdotes de Yavé."
,"18":"Entonces el rey dijo a Doeg: 'Ven tú y mata a los sacerdotes'. Y Doeg el edomita dio unos pasos adelante e hirió de muerte a los sacerdotes. Ese día dio muerte a ochenta y cinco hombres que llevan entrepiernas de lino."
,"19":"Nob, la ciudad de los sacerdotes, fue pasada a cuchillo, incluyendo hombres y mujeres, niños y bebés, todo fue pasado a cuchillo hasta los bueyes, burros y corderos."
,"20":"Sólo se salvó un hijo de Ajimelec hijo de Ajitub, que se llamaba Ebiatar. Corrió a juntarse con David."
,"21":"Ebiatar contó a David cómo Saúl había dado muerte a los sacerdotes de Yavé,"
,"22":"y David le dijo: 'Doeg el edomita estaba allí ese día y yo sabía que le avisaría a Saúl. Yo fui el causante de la muerte de toda tu familia."
,"23":"Quédate conmigo y no temas, el que atente contra tu vida atentará contra la mía; a mi lado estarás seguro'."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Le llevaron esta noticia a David: 'Los filisteos llegaron para atacar a Queila y se apoderaron de las eras'."
,"2":"Entonces David consultó a Yavé, preguntándole: '¿Debo marchar contra los filisteos?' Yavé respondió a David: 'Anda, derrotarás a los filisteos y librarás a Queila'."
,"3":"Pero los hombres de David le dijeron: '¿No tenemos ya bastante que temer aquí en Judá para que vayamos ahora a buscar a los filisteos en Queila?'"
,"4":"David consultó de nuevo a Yavé y éste le respondió: 'Levántate, baja a Queila porque yo he puesto a los filisteos en tus manos'."
,"5":"Partió pues David para Queila con sus hombres y se trabó en combate con los filisteos. Les quitó sus rebaños y les infligió una gran derrota; así fue como David libró a los habitantes de Queila."
,"6":"(Cuando Ebiatar hijo de Ajimelec había huido donde David a Queila, había bajado con el efod)."
,"7":"Le avisaron a Saúl que David había entrado en Queila; Saúl dijo: 'Dios lo ha puesto en mis manos, pues al entrar en una ciudad con puertas y candados se ha encerrado solo'."
,"8":"Saúl convocó a todo el pueblo para la guerra y bajaron a Queila para sitiar a David y a sus hombres."
,"9":"Cuando David supo que Saúl tramaba algo en su contra, dijo al sacerdote Ebiatar: 'Trae el efod'."
,"10":"David hizo esta consulta: 'Yavé, Dios de Israel, tu servidor ha sabido que Saúl trata de apoderarse de Queila y destruir la ciudad por mi culpa. ¿Bajará realmente Saúl tal como tu servidor lo oyó decir?"
,"11":"Yavé, Dios de Israel, comunícamelo, por favor'. Yavé respondió: 'Vendrá'."
,"12":"David dijo: '¿Los habitantes de Queila me entregarán a Saúl junto con mis hombres?' Yavé respondió: 'Los entregarán'."
,"13":"Entonces David se levantó junto con sus hombres, que eran más o menos unos seiscientos, salieron de Queila y anduvieron errantes. Cuando Saúl supo que David había huido de Queila, desistió de su expedición."
,"14":"David permaneció en los refugios del desierto, en la montaña y en el desierto de Zif. Saúl lo buscaba todos los días, pero Dios no lo puso en sus manos."
,"15":"Cuando David estaba en Jorsa, en el desierto de Zif, supo que Saúl había organizado una expedición para matarlo."
,"16":"Fue entonces cuando Jonatán, hijo de Saúl, fue a Jorsa a visitar a David, para darle ánimo de parte de Dios."
,"17":"Le dijo: 'No temas, mi padre no te hallará. Tú reinarás en Israel y yo seré tu segundo, mi padre Saúl lo sabe muy bien'."
,"18":"Ambos concluyeron un pacto ante Yavé. David se quedó en Jorsa, mientras que Jonatán regresó a su casa."
,"19":"La gente de Zif fue a Guibea a ver a Saúl para decirle: '¿Sabes que David está escondido en medio de nosotros en los refugios de Jorsa, en la colina de Jaquila que se sitúa al sur de la estepa?"
,"20":"Vaya cuando quiera nuestro señor y nosotros entregaremos a David en las manos del rey'."
,"21":"Saúl les dijo: 'Que Yavé los bendiga por haber tenido piedad de mí."
,"22":"Regresen ahora e infórmenme exactamente del lugar donde se esconde, porque me han dicho que es muy astuto."
,"23":"Observen e infórmense de todos los escondites donde pudiere hallarse, y vuelvan a verme. Entonces yo me iré con ustedes. Si está en esa región lo buscaré en todos los clanes de Judá'. Regresaron pues a Zif precediendo a Saúl. "
,"24":"David y sus hombres se encontraban en el desierto de Maón, en el valle que está al sur de la Estepa."
,"25":"Saúl y sus hombres fueron a buscarlo, pero David lo supo y bajó a la Roca. Se quedó en el desierto de Maón. Lo supo Saúl y se puso a perseguir a David por el desierto de Maón."
,"26":"Saúl iba por un lado del cerro, y David con sus hombres, por el otro. David y sus hombres caminaban rápido para escapar de Saúl, mientras que éste y sus hombres trataban de cercar a David y a sus compañeros para apresarlos."
,"27":"Llegó entonces un mensajero donde estaba Saúl diciéndole: 'Ven inmediatamente pues los filisteos acaban de invadir nuestro país'."
,"28":"En vista de eso Saúl desistió de perseguir a David y se fue a combatir a los filisteos; por eso ese lugar se llamó la Roca de las Separaciones."
}`)
	CurrentBook.AddChapter(24, `{
"1":"De allí subió David a los refugios de Engadi y se instaló allí."
,"2":"Cuando regresó Saúl de su expedición contra los filisteos, le dijeron: 'David está en el desierto de Engadi'."
,"3":"Saúl eligió entonces de entre todo Israel a tres mil hombres y salió con ellos en busca de David al este del Cerro de las Gamuzas."
,"4":"Llegó a unos corrales para ovejas que están a la orilla del camino; había allí una caverna donde entró Saúl para hacer sus necesidades. Ahora bien, David y sus hombres estaban sentados en el fondo de la caverna."
,"5":"Los compañeros de David le dijeron: 'Ahora Yavé te entrega en tus manos a tu enemigo. Puedes hacerle ahora todo lo que quieras'."
,"7":"Les dijo: '¡Oh no! ¡Por la vida de Yavé que no pondré mi mano sobre él. ¡No puedo hacerle a mi señor tal cosa porque es el ungido de Yavé!"
,"8":"Y mediante esas palabras David impidió que sus hombres se lanzaran contra Saúl. David se paró y fue a cortar suavemente un trozo del manto de Saúl,"
,"6":"pero después de eso le saltaba el corazón por haber cortado un trozo del manto de Saúl. Saúl se paró, salió de la caverna y siguió su camino. "
,"9":"David a su vez se paró también, salió de la caverna y se puso a gritar detrás de Saúl: '¡Señor rey!' Saúl se dio vuelta y David se postró con la cara contra el suelo."
,"10":"Entonces David dijo a Saúl: '¿Por qué les haces caso a los que te dicen que trato de matarte?"
,"11":"Míralo tú mismo, hoy Yavé te puso en mis manos en esa caverna, y me dijeron que te matara, pero tuve piedad de ti. Me dije: No pondré mi mano sobre mi señor, porque es el ungido de Yavé."
,"12":"Mira, padre mío, mira el trozo de tu manto que tengo en la mano. Cuando corté ese pedazo del manto, podría haberte matado. Reconoce entonces que no hay en mí ni malicia ni maldad; yo no te he hecho daño, tú en cambio me buscas para matarme."
,"13":"Que Yavé juzgue entre tú y yo. Que Yavé me vengue de ti, pero mi mano no se alzará contra ti."
,"14":"Como bien dice el proverbio de los antiguos: La maldad sale de los malvados. Por eso mi mano no se levantará contra ti."
,"15":"¿Tras quién salió el rey de Israel? ¿A quién persigue? ¿A un perro muerto, a una pulga?"
,"16":"Que Yavé juzgue entre tú y yo. Que él examine y asuma mi defensa, que me haga justicia y me libre de tu mano'."
,"17":"Cuando David hubo terminado de pronunciar esas palabras, Saúl dijo: '¿Es realmente tu voz, hijo mío David?' Y Saúl estalló en sollozos."
,"18":"Dijo a David: 'Eres más bueno que yo, porque tú me haces el bien y yo te había hecho el mal."
,"19":"Hoy demostraste tu bondad para conmigo, porque Yavé me puso en tus manos pero tú no me mataste."
,"20":"Cuando un hombre encuentra a su enemigo, ¿lo deja proseguir su camino? Yavé te recompensará el bien que me has hecho hoy."
,"21":"Ya lo sé desde ahora: tú reinarás y tu realeza en Israel será inamovible."
,"22":"Júrame pues por Yavé que no suprimirás mi descendencia después de mi muerte ni que harás desaparecer mi nombre de la familia de mi padre'."
,"23":"David entonces le juró a Saúl. Y Saúl se volvió a su casa mientras que David y sus compañeros subían a su refugio."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Por esos días murió Samuel. Se reunió todo Israel e hizo una lamentación por él; lo enterraron en su casa en Ramá. David bajó entonces al desierto de Maón."
,"2":"Había en Maón un hombre cuya finca estaba en Carmel. Era un hombre muy importante, tenía tres mil ovejas y mil cabras; por ese entonces estaba en Carmel para la esquila de sus ovejas."
,"3":"Ese hombre se llamaba Nabal y su mujer, Abigaíl. La mujer tenía mucho criterio y era hermosa, pero el hombre era duro y malo: pertenecía al clan de Caleb."
,"4":"Mientras estaba en el desierto, supo David que Nabal estaba esquilando sus ovejas."
,"5":"Mandó entonces David a diez de sus hombres con este encargo: 'Suban a Carmel, entren en la casa de Nabal y salúdenlo de mi parte."
,"6":"Le hablarán así: '¡Hermano, que tengas salud y haya paz en tu casa y paz en todo lo que te pertenece!"
,"7":"Sé que los esquiladores están ahora en tu casa. Debes saber que cuando tus pastores estaban con nosotros, no les creamos ningún problema, nada de lo que les pertenecía desapareció mientras estuvieron en Carmel."
,"8":"Pregúnta a tus sirvientes y te lo dirán. Ten pues hoy un gesto de amistad con mis muchachos ya que llegamos en un día de fiesta. Por favor, dales a tus servidores y a tu hijo David lo que te dicte tu corazón'."
,"9":"Los muchachos de David fueron donde Nabal a transmitirle el mensaje de David, y luego se pusieron a descansar."
,"10":"Nabal dio esta respuesta a los hombres de David: '¿Quién es ese David? ¿Quién es el hijo de Jesé? ¡Hay ahora muchos esclavos escapados de la casa de su dueño!'"
,"11":"¿¡Y voy a tomar mi pan, mi vino, la carne de los animales que he degollado para los esquiladores y dar todo eso a esa gente que viene de no se sabe dónde!?'"
,"12":"Los muchachos de David retomaron su camino, volvieron y transmitieron a David todas esas palabras."
,"13":"David les dijo: 'Tome cada uno su espada'. Cada cual tomó su espada y David tomó la suya. Los que subieron tras David eran cuatrocientos, y los que se quedaron custodiando el equipaje, doscientos."
,"14":"Uno de sus mozos le comunicó a Abigaíl, la mujer de Nabal, lo que había pasado, diciéndole: 'David envió desde el desierto unos mensajeros para que saludaran a nuestro patrón, pero éste los mandó de vuelta."
,"15":"Sin embargo esos hombres siempre fueron correctos con nosotros, nunca nos trataron mal mientras estuvimos en el campo, ni tampoco perdimos nada mientras estuvimos con ellos."
,"16":"Han sido para nosotros como una protección tanto de día como de noche, por todo el tiempo que hemos tenido nuestros rebaños en medio de ellos."
,"17":"Ahora piensa y ve qué es lo que se debe hacer porque la suerte de nuestro patrón y de toda su casa ya está echada y él es muy malo para poder conversarle'."
,"18":"Abigaíl juntó rápidamente doscientos panes, dos cueros de vino, cinco ovejas ya preparadas, cinco bolsas de trigo tostado, cien racimos de uva seca y dos tortas de higo, y lo puso todo en unos burros."
,"19":"En seguida dijo a sus mozos: 'Vayan delante mío, que yo los seguiré'. Pero nada le dijo a su marido Nabal."
,"20":"Montada en su burro bajó por un lado del cerro mientras David y sus hombres bajaban por el otro."
,"21":"David se decía: 'Protegí todo lo que ese hombre tenía en el desierto y cuidé de que nada de lo que le pertenecía desapareciera, pero fue por nada, ya que ahora me devuelve mal por bien."
,"22":"Maldiga Dios a David si de aquí a mañana dejo con vida a uno solo de sus hombres'."
,"23":"Al divisar a David, Abigaíl saltó del burro, se puso con la cara contra el suelo delante de David y se agachó."
,"24":"Agachada a sus pies le dijo: 'Señor, perdona mi audacia. Permítele a tu sirvienta decir una palabra; escucha las palabras de tu sirvienta."
,"25":"No tome en cuenta, señor, a ese bruto de Nabal, pues su nombre quiere decir El Loco, y él se ha dejado llevar por su locura. Yo, tu sirvienta, no pude ver a los muchachos que mandó mi señor."
,"26":"¡Por la vida de Yavé y por tu propia vida, que tus enemigos y que todos los que buscan tu mal, señor, conozcan ahora la suerte de Nabal. Pero fíjate: Yavé te ha impedido que te mancharas con sangre haciéndote justicia por ti mismo."
,"27":"Que los jóvenes que acompañan a mi señor tomen los regalos que su sirvienta le trae ahora."
,"28":"Perdona, por favor, la falta de tu sierva. En verdad Yavé hará inconmovible la casa de mi señor porque tú eres el combatiente de las guerras de Yavé y nunca se te ha sorprendido en una falta durante toda tu vida."
,"29":"Si un hombre quisiera perseguirte y quitarte la vida, el alma de mi señor estará segura al lado de Yavé. Yavé te protegerá, y en cambio lanzará lejos de sí, como una honda, el alma de tus enemigos."
,"30":"De ese modo, cuando Yavé haya cumplido contigo todas las promesas que te hizo, cuando te haya establecido como jefe de Israel,"
,"31":"tú no podrás sentir remordimiento de haber derramado sangre sin motivo y de haberte hecho justicia por ti mismo. ¡Cuando Yavé colme a mi señor, acuérdese de su sierva!'"
,"32":"David respondió a Abigaíl: '¡Bendito sea Yavé, Dios de Israel, que te mandó hoy a encontrarme!"
,"33":"Bendita seas por tu prudencia, bendita porque me has impedido hoy que me manche con sangre y que haga justicia por mí mismo."
,"34":"Porque, te lo juro por la vida de Yavé, el Dios de Israel, que me impidió hacer el mal, si tú no hubieras venido tan rápido a verme, aun antes de que se levantara el sol no le habría quedado a Nabal un solo hombre con vida'."
,"35":"David recibió en sus manos todo lo que ella le había traído, y luego le dijo: 'Vuelve en paz a tu casa, ya te escuché y cuenta conmigo'."
,"36":"Cuando regresó Abigaíl, Nabal estaba sentado a la mesa en su casa para un banquete real. Nabal estaba muy alegre, completamente borracho, pero ella no le contó nada hasta la mañana siguiente."
,"37":"Al día siguiente cuando se le hubo pasado la borrachera, su mujer le contó lo que le había pasado. Le dio un ataque y quedó como piedra."
,"38":"Más o menos diez días después, Yavé hirió a Nabal, quien murió."
,"39":"Cuando David supo que Nabal había muerto, dijo: '¡Bendito sea Yavé que hizo pagar a Nabal quien me había insultado y me ahorró a mí una mala acción! Yavé hizo que recayera sobre la cabeza de Nabal su propia maldad'. David entonces mandó a decir a Abigaíl que la tomaría por mujer."
,"40":"Los servidores de David llegaron pues a Carmel a la casa de Abigaíl, y le dijeron esto: 'David nos ha mandado donde ti; quiere que seas su mujer'."
,"41":"Ella se levantó, se postró en tierra y dijo: 'Tu sirvienta será para ti como una esclava, para lavar los pies de los sirvientes de mi señor'."
,"42":"Abigaíl se decidió inmediatamente y subió a su burro acompañada de cinco sirvientas jóvenes. Salió tras los enviados de David y pasó a ser su mujer."
,"43":"David había tomado también por mujer a Ajinoam de Jezrael, y ambas fueron sus esposas."
,"44":"En cuanto a su otra esposa, Micol, hija de Saúl, había sido dada a Paltí, hijo de Lais, del pueblo de Galim."
}`)
	CurrentBook.AddChapter(26, `{
"1":"La gente de Zif fue a Guibea a ver a Saúl: '¿No sabes, le dijeron, que David está escondido en la colina de Jaquila, al este de la Estepa?'"
,"2":"Saúl bajó inmediatamente al desierto de Zif con tres mil hombres selectos de Israel; fue en busca de David al desierto de Zif."
,"3":"Mientras Saúl acampaba en la colina de Jaquila, que está a orillas del camino al este de la Estepa, avisaron a David, que vivía en el desierto, que Saúl venía a buscarlo en su desierto."
,"4":"Mandó espías y supo que Saúl había llegado."
,"5":"Entonces David fue al mismo lugar donde acampaba Saúl. David observó el sitio donde estaban acostados Saúl y Abner, hijo de Ner, el jefe del ejército. Saúl estaba acostado al centro y la gente de su tropa en derredor de él."
,"6":"David preguntó a Ajimelec el hitita y a Abisaí hijo de Seruya, hermano de Joab: '¿Quién quiere venir conmigo hasta el campamento donde está Saúl?' Abisaí respondió: 'Yo iré contigo'."
,"7":"David y Abisaí llegaron pues de noche hasta el campamento. Saúl dormía en el centro del campamento y su lanza estaba clavada de pie a su lado, y todos sus hombres dormían a su derredor."
,"8":"Abisaí dijo entonces a David: 'Hoy puso Dios a tu enemigo en tus manos. Déjame clavarlo en tierra con su lanza, no tendré necesidad de hacerlo por segunda vez'."
,"9":"Pero David respondió a Abisaí: '¡No lo hieras! ¿Quién podría poner su mano en el ungido de Yavé y quedar sin castigo?'"
,"10":"David le dijo además: 'Por Dios, Yavé mismo lo castigará; o bien morirá porque ese será el día, o bien morirá en el combate."
,"11":"Pero no pongas la mano encima del ungido de Yavé. Tan sólo toma la lanza que está a su lado y la cantimplora de agua, y vámonos'."
,"12":"David tomó la lanza y la cantimplora que estaban al lado de Saúl y se fueron. Nadie lo vio, nadie lo supo, nadie se movió; todos dormían porque Yavé les había enviado un sueño muy pesado."
,"13":"David pasó al otro lado y se puso bien distante en la cima del cerro; los separaba un gran espacio."
,"14":"David llamó entonces a los hombres de la tropa y a Abner, hijo de Ner: '¿Abner, no respondes?' Abner respondió: '¿Quién me llama?'"
,"15":"David dijo a Abner: '¿No eres tú un valiente? ¿Y quién como tú en Israel? ¿Por qué entonces proteges tan mal al rey, tu señor? Cualquiera puede entrar y asesinar al rey, tu señor."
,"16":"Has actuado muy mal; ustedes merecen la muerte por no haber protegido a su patrón, al que Yavé consagró. Mira dónde están la lanza y la cantimplora de agua que estaban al lado del rey'."
,"17":"Saúl reconoció la voz de David y dijo: '¿Es esa tu voz, hijo mío David?' David respondió: '¡Sí, yo soy, señor rey!'"
,"18":"Y añadió: '¿Por qué mi señor se lanza a perseguir a su servidor? ¿Qué he hecho? ¿Qué crimen cometí?"
,"19":"Por favor, señor, oiga bien las palabras de su servidor. Si fue Yavé quien te incitó contra mí, le presentaré una ofrenda para apaciguarlo. Pero si son los hombres, que Yavé los maldiga, porque ahora me han echado de la heredad de Yavé, tal como si dijeran: ¡Anda y sirve a otros dioses!"
,"20":"Y el rey de Israel organiza expediciones para cazar a un hombre como si se tratara de perseguir a una perdiz por los cerros. ¡Que no caiga mi sangre en una tierra extraña, lejos de Yavé!'"
,"21":"Saúl le respondió: '¡Pequé! Vuelve, hijo mío David, ya no te haré mal. ¡Tú me respetaste hoy la vida, y yo me he comportado como un tonto, he cometido un gran pecado!'"
,"22":"David le dijo: Aquí está tu lanza, señor, que venga uno de tus muchachos a buscarla."
,"23":"Yavé recompensará a cada cual según su justicia y su fidelidad. Hoy Yavé te había puesto en mis manos y yo no quise poner mi mano encima del que Yavé consagró."
,"24":"Así como hoy he tenido un gran respeto por tu vida, así también Yavé tendrá un gran respeto por la mía y me librará de todo peligro'."
,"25":"Saúl dijo a David: 'Bendito seas, hijo mío. Ciertamente te irá bien en todo lo que hagas'. Después de eso, David siguió su camino y Saúl se regresó a su casa."
}`)
	CurrentBook.AddChapter(27, `{
"1":"David se dijo: 'Un día de estos Saúl me va a matar. Es mejor que me refugie entre los filisteos. Así dejará Saúl de buscarme en todo el territorio de Israel y yo me escaparé de sus manos'."
,"2":"Pasó entonces David con seiscientos hombres a donde el rey de Gat, Aquis, hijo de Maoc."
,"3":"David se instaló con sus hombres cerca de Aquis, en Gat. Cada cual había traído a su familia; David a sus dos mujeres: Ajinoam de Yizreel y Abigaíl, mujer de Nabal de Carmel."
,"4":"Le informaron a Saúl que David había huido a Gat, y Saúl dejó de perseguirlo."
,"5":"David dijo a Aquis: 'Si realmente cuento con tu amistad, dame un sitio en uno de los pueblos de los alrededores y me instalaré allí. No hay ningún motivo para que viva a tu lado aquí en la capital'."
,"6":"Aquis le dio ese día Siclag y desde entonces Siclag pertenece a los reyes de Judá."
,"7":"David permaneció en territorio filisteo un año y cuatro meses."
,"8":"David y sus hombres hicieron incursiones contra los guesuritas, los guergueseos y los amalecitas: esas tribus ocupan la región que se extiende desde Telam en dirección a Sur y al Egipto."
,"9":"David devastó el territorio; no dejaba a nadie con vida, ni hombre ni mujer; les quitaba las ovejas, los bueyes, los burros, los camellos y todas sus prendas de vestir; luego regresaba donde Aquis."
,"10":"Aquis le decía: '¿A dónde fueron hoy?' Y David respondía: 'Al Negueb de Judá, o al Negueb de Yerajmeel o al Negueb de los quenitas'."
,"11":"David no dejaba hombre ni mujer con vida, para no tener que llevarlos a Gat, pues decía: 'No sea que hablen contra nosotros y nos denuncien a los filisteos.',Así actuó David mientras vivió entre los filisteos. "
,"12":"Pero Aquis tenía confianza en David y se decía: 'Como los israelitas, la gente de su pueblo ya no pueden aguantarlo más y se quedará para siempre a mi servicio'."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Por esos días, los filisteos concentraron todas sus tropas en un solo ejército para atacar a Israel. Aquis dijo a David: 'Quiero comunicarte que vendrás conmigo a la guerra junto con tus hombres'."
,"2":"David le respondió: 'Así sabrás tú también de lo que es capaz tu servidor'. Aquis dijo además a David: 'Desde ahora te hago el guardián de mi persona'."
,"3":"Samuel había muerto, todo Israel lo había llorado y lo habían enterrado en su ciudad, Ramá."
,"4":"Los filisteos se reunieron en Sunem e instalaron allí su campamento. Saúl movilizó también a todo Israel, e instaló su campamento en Guelboé."
,"5":"Cuando Saúl vio el campamento de los filisteos, tuvo miedo y su corazón se estremeció."
,"6":"Saúl consultó a Yavé, pero Yavé no respondió, ni por los sueños, ni por el urim ni por los profetas."
,"7":"Saúl dijo entonces a sus servidores: 'Búsquenme a una mujer que invoque a los muertos e iré a consultarla'. ("
,"3b":"Saúl había echado del país a los adivinos y a los que consultan a los espíritus de los muertos.),Sus servidores le dijeron: 'En En-Dor hay una mujer que invoca a los muertos'."
,"8":"Saúl se disfrazó, se puso otras ropas y salió acompañado de dos hombres. Llegaron de noche a la casa de esa mujer y Saúl le dijo: 'Anúnciame el futuro invocando a los espíritus: haz que suba de la morada de los muertos al que yo te diga'."
,"9":"La mujer le respondió: 'Debes saber que Saúl hizo desaparecer del país a todos los adivinos y a los que invocan a los espíritus, ¿me estás tendiendo una trampa?'"
,"10":"Saúl le juró por Yavé: 'Por Yavé que vive, nada te pasará por eso'."
,"11":"La mujer le dijo: '¿A quién debo hacer salir de la morada de los muertos?' Respondió: 'Haz que suba Samuel'."
,"12":"Cuando la mujer vio a Samuel lanzó un grito. Dijo a Saúl: '¿Por qué me engañaste? ¡Tú eres Saúl!'"
,"13":"El rey le dijo: 'No temas. ¿Qué viste?' La mujer dijo: 'Veo a un ser superior que sube desde lo profundo de la tierra'."
,"14":"Saúl preguntó: '¿Cómo es?' Ella respondió: 'El que sube es un anciano, envuelto en su manto'. Saúl comprendió que se trataba de Samuel, se arrodilló, la cara contra el suelo y se inclinó. "
,"15":"Samuel dijo entonces a Saúl: '¿Por qué me has molestado y me haces subir desde la morada de los muertos?' Saúl le respondió: 'Me siento muy angustiado, los filisteos me hacen la guerra, Dios se ha retirado de mí y ya no me responde ni por medio de los profetas ni por los sueños. Te he llamado para que me digas lo que debo hacer'."
,"16":"Samuel le dijo: '¿Por qué me consultas? ¿Porque Yavé se retiró de ti y está ahora con tu prójimo?"
,"17":"Yavé ya realizó lo que me había encargado de anunciarte: te quitó la realeza de tu mano y se la dio a tu servidor David."
,"18":"Acuérdate que no has obedecido la voz de Yavé cuando te ordenó que fueras el instrumento de su venganza contra los amalecitas. Por eso Yavé te trata hoy de esta manera."
,"19":"Yavé te va a entregar a ti y a Israel en manos de los filisteos. Mañana, tú y tus hijos estarán aquí conmigo, y Yavé dejará que caiga el campamento de Israel en manos de los filisteos."
,"20":"Saúl se estremeció y cayó de bruces en tierra; además le faltaban fuerzas porque no había comido nada durante ese día ni esa noche."
,"21":"Al verlo tan abatido, la mujer se acercó a Saúl y le dijo: 'Tu sirvienta te obedeció, arriesgué mi vida por hacer lo que me pedías."
,"22":"Escúchame ahora, acepta este trozo de pan que te ofrezco; cómelo y recupera tus fuerzas para que prosigas tu camino'."
,"23":"Pero él se negaba y decía: 'No comeré'. Los servidores y la mujer insistieron tanto que terminó por hacerles caso: se levantó y se sentó en el diván."
,"24":"La mujer tenía un ternero gordo; fue inmediatamente a matarlo. Tomó harina, la amasó e hizo panes sin levadura,"
,"25":"luego les sirvió esa comida a Saúl y a sus servidores. Comieron, después se pararon y se fueron esa misma noche."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Los filisteos concentraron todas sus fuerzas en Afec; los israelitas, por su parte, acampaban al lado de la fuente que está en la llanura de Yizreel."
,"2":"Los jefes de los filisteos desfilaban con sus compañías de cien y de mil; David y sus hombres iban a la retaguardia con Aquis."
,"3":"Los jefes de los filisteos preguntaron a Aquis: '¿Quiénes son esos hebreos?' Aquis les respondió: 'Pero si es David, el servidor de Saúl rey de Israel. Hace ya mucho tiempo, tal vez dos años, que está conmigo y nunca he tenido que quejarme de él desde que se pasó a mi lado'."
,"4":"Los jefes de los filisteos se enojaron con Aquis y le dijeron: '¡Despide a ese hombre y que vuelva al lugar de donde vino! Que no venga con nosotros a la batalla pues bien podría volverse en contra nuestra. ¿De qué otra manera podría comprar el perdón de su amo sino con las cabezas de nuestros hombres?"
,"5":"¿No era con respecto a ese David que bailaban y cantaban: Saúl mató mil, pero David, diez mil?'"
,"6":"En vista de eso, Aquis llamó a David y le dijo: 'Tan cierto como que Yavé vive que tú eres un hombre honrado. Por lo que a mí respecta, me siento feliz de que estés conmigo, porque no has merecido ninguna crítica desde que llegaste hasta ahora, pero eres muy mal visto por los jefes."
,"7":"Regrésate, pues, ándate en paz y no nos indispongamos con los jefes de los filisteos'."
,"8":"David dijo a Aquis: '¿Qué he hecho? ¿Qué tienes que criticarle a tu servidor desde que llegué hasta ahora para que no me permitas que combata a los enemigos del rey mi señor?'"
,"9":"Aquis respondió a David: 'Lo sé, tú nos das tanta seguridad como un ángel de Dios, pero los jefes de los filisteos han decidido que tú no entres al combate con nosotros."
,"10":"Levántate pues muy temprano, tú y los que vinieron contigo, y regresen al lugar que les asigné. No lo tomes a mal, pues sabes que te estimo. Mañana temprano se levantarán rápidamente, y apenas aclare el día, se irán'."
,"11":"David y sus hombres se levantaron pues muy de mañana y partieron temprano al país de los filisteos; los filisteos, en cambio, subieron hasta Yizreel."
}`)
	CurrentBook.AddChapter(30, `{
"1":"David llegó a Siclag con sus hombres dos días después. Ahora bien, los amalecitas habían hecho una incursión por el Negueb hasta Siclag, se habían apoderado del pueblo y lo habían incendiado."
,"2":"También habían capturado a las mujeres y a todos los que se encontraban allí, pequeños y grandes, pero sin matar a nadie; y se habían vuelto por donde habían venido llevándose a todo el mundo."
,"3":"Cuando David y sus compañeros llegaron al pueblo, lo encontraron incendiado, y vieron que sus mujeres, hijos e hijas habían sido llevados cautivos."
,"4":"David y el pueblo que lo acompañaba se pusieron a gritar y a llorar hasta que quedaron sin aliento para llorar."
,"5":"Las dos mujeres de David, Ajinoam de Yizreel y Abigaíl, mujer de Nabal de Carmel, también habían sido llevadas cautivas."
,"6":"David se vio en un gran apuro porque su gente hablaba de apedrearlo, pues tan grande era la desesperación de cada uno por sus hijos e hijas. Pero David recuperó su confianza en Yavé su Dios."
,"7":"Dijo al sacerdote Ebiatar, hijo de Ajimelec: 'Tráeme el efod'. Ebiatar trajo el efod a David."
,"8":"David consultó a Yavé: 'Tengo que perseguir a esa banda? ¿La alcanzaré?' La respuesta fue: 'Persíguelos, los alcanzarás y librarás a los cautivos'."
,"9":"David salió; caminaron con él seiscientos compañeros hasta el torrente de Besor,"
,"10":"pero sólo cuatrocientos prosiguieron la persecución con David, porque los otros doscientos estaban muy cansados para atravesar el torrente de Besor, y allí se detuvieron."
,"11":"Hallaron en descampado a un egipcio y lo llevaron donde David. Le dieron pan y agua, comió y bebió."
,"12":"Además le dieron un trozo de torta de higos y dos racimos de pasas; después que comió recuperó sus sentidos, porque no había comido ni bebido hacía tres días y tres noches."
,"13":"David le dijo: '¿A quién perteneces y de dónde vienes?' Dijo: 'Soy un joven egipcio esclavo de un amalecita; mi amo me abandonó hace tres días porque estaba enfermo."
,"14":"Nosotros habíamos hecho una incursión por el Negueb de los quereteos, por el Negueb de Judá y por el Negueb de Caleb; además incendiamos Siclag."
,"15":"David le dijo: '¿Puedes llevarnos donde esos salteadores?' Respondió: 'Si me juras por tu Dios que no me matarás ni me entregarás a mi amo, te llevaré donde esos salteadores'."
,"16":"Los llevó allá. Los salteadores estaban dispersos, comiendo, tomando, celebrando una fiesta con todo el botín que habían juntado en territorio filisteo y de Judá."
,"17":"David los masacró desde el alba hasta el atardecer y acabó con ellos. No escapó ninguno, salvo cuatrocientos jóvenes que huyeron en sus camellos."
,"18":"David recuperó todo lo que le habían quitado los amalecitas, y recuperó también a sus dos mujeres."
,"19":"No quedó nadie de los amalecitas, ni chico ni grande, ni joven ni muchacha; tampoco les quedó algo de todo el botín que habían juntado; David se lo llevó todo."
,"20":"David tomó el ganado menor y mayor y su gente lo arriaba delante de él, diciendo: '¡Este es el botín de David!'"
,"21":"Cuando David llegó cerca de los doscientos hombres que se habían detenido, demasiado cansados, ante el torrente de Besor, éstos salieron al encuentro de David y de la tropa que lo acompañaba. David se dirigió donde ellos y los saludó,"
,"22":"pero los más malos y mañosos de sus acompañantes tomaron la palabra: 'Ya que esos hombres no vinieron con nosotros, no les daremos ninguna cosa del botín que hemos ganado. Sólo les devolveremos a sus mujeres e hijos y dejaremos que se vayan'."
,"23":"Pero David les dijo: 'No, hermanos, no hagan tal cosa después de lo que Yavé ha hecho por nosotros. Vean cómo nos protegió entregando en nuestras manos a esa banda de salteadores que habían venido a atacarnos."
,"24":"¿Quién podría estar de acuerdo con ustedes? El combatiente y el que custodia el equipaje tendrán partes iguales'."
,"25":"Desde ese día, esta ha sido la regla y ha pasado a ser una costumbre en Israel."
,"26":"Cuando regresó a Siclag, David envió una parte del botín a los ancianos de Judá, diciéndoles: 'Ahí tienen un regalo del botín que arrebatamos a los enemigos de Yavé'."
,"27":"Lo envió a Betul, a Ramá del Neguev, a Yatir,"
,"28":"a Aroer, a Sifmot, a Estemoa,"
,"29":"a Carmel, a las ciudades de Yerajmeel, a las ciudades de los quenitas,"
,"30":"a Jorma, a Bor-Asán, a Eter,"
,"31":"a Hebrón, y a todos los lugares que había frecuentado David con sus compañeros; cada uno recibió su parte."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Los filisteos atacaron a Israel y los hombres de Israel salieron huyendo ante los filisteos. Fueron muchos los que cayeron heridos de muerte en los cerros de Guelboé."
,"2":"Los filisteos se ensañaron con Saúl y sus hijos, y mataron a Jonatán, Abinadab y Malquisúa, los tres hijos de Saúl."
,"3":"Luego dirigieron el ataque contra Saúl; los arqueros lo descubrieron y lo hirieron muy gravemente."
,"4":"Entonces Saúl dijo a su escudero: 'Toma tu espada y mátame, no sea que vengan esos incircuncisos a matarme y ultrajarme'. Su escudero no quería hacerlo porque tenía miedo; entonces Saúl tomó su espada y se dejó caer sobre ella."
,"5":"Al ver que Saúl estaba muerto, el escudero se dejó caer también sobre su espada y murió con él."
,"6":"Así fue como el mismo día murieron Saúl y sus tres hijos, su escudero y todos sus hombres."
,"7":"Cuando se supo que los israelitas habían huido y que Saúl y sus hijos habían muerto, los israelitas que estaban al otro lado de la llanura y los que estaban a este lado del Jordán abandonaron sus ciudades y huyeron. Llegaron allí los filisteos y se instalaron en su lugar."
,"8":"Al día siguiente los filisteos fueron a despojar a los muertos; hallaron muertos a Saúl y a sus tres hijos en los cerros de Guelboé."
,"9":"Le cortaron la cabeza y le quitaron sus armas, y después mandaron que se publicara la noticia en todo el país de los filisteos, en los templos de sus ídolos y entre el pueblo."
,"10":"Depositaron las armas de Saúl en el templo de Astarté y colgaron su cadáver de las murallas de Bet-seán."
,"11":"Cuando los habitantes de Yabés de Galaad supieron lo que los filisteos habían hecho con Saúl,"
,"12":"los más valientes de entre ellos salieron y caminaron toda la noche. Retiraron de las murallas de Bet-seán los cuerpos de Saúl y de sus hijos, regresaron a Yabés y los quemaron."
,"13":"Tomaron sus huesos y los enterraron debajo del tamarindo de Yabés, y después ayunaron siete días."
}`)

}
func ES_LBL_LoadVH2MChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"¡Salud a los hermanos que están en Egipto! Sus hermanos judíos de Jerusalén y del territorio de Judea les desean una verdadera paz."
,"2":"Dios los colme de sus bendiciones, se acuerde de su Alianza con Abrahán, Isaac y Jacob, sus fieles servidores;"
,"3":"les dé a todos un corazón para adorarlo y hacer su voluntad generosa y sinceramente;"
,"4":"les abra el corazón a su Ley y a sus mandamientos y ponga en él la paz."
,"5":"Atienda sus plegarias y se reconcilie con ustedes, porque él no los abandonará en el día de la desgracia."
,"6":"Nosotros, por nuestra parte, oramos desde aquí por ustedes."
,"7":"Nosotros, los judíos, les habíamos ya escrito el año ciento sesenta y nueve, bajo el reinado de Demetrio, en lo más duro de la prueba que nos tocó sobrellevar esos años, cuando Jasón y sus partidarios traicionaron la causa de la Tierra Santa y del reino,"
,"8":"quemaron las puertas del Templo y derramaron sangre inocente. Pero nosotros nos volvimos hacia el Señor y fuimos escuchados. Ahora podemos ofrecer el sacrificio y la ofrenda de harina flor, encendemos las lámparas y exponemos los panes de la ofrenda."
,"9":"Por eso los invitamos a celebrar los días de la fiesta de las Tiendas el mes de Casleu. Fecha de esta carta: año ciento ochenta y ocho»."
,"10":"«Los habitantes de Jerusalén y de Judea, el Senado y Judas saludan y le desean buena salud a Aristóbulo, consejero del rey Tolomeo y miembro de la familia de los sacerdotes consagrados, como también a los judíos que están en Egipto."
,"11":"Acabamos de ser salvados por Dios de grandes peligros, y le agradecemos mucho que nos haya ayudado contra el rey."
,"12":"El mismo eliminó a los que se habían lanzado armados contra la Ciudad Santa."
,"13":"Pues habiendo su jefe partido para Persia con una escolta que se parecería a un ejército, él y los suyos fueron eliminados en el templo de Nanea, gracias a una trampa de los sacerdotes de la diosa."
,"14":"Antíoco había ido a ese lugar con el pretexto de casarse con la diosa Nanea, pero en realidad quería que le dieran como dote el tesoro."
,"15":"Los sacerdotes del templo de Nanea habían expuesto el tesoro y Antíoco, más algunos amigos, habían entrado en el templo; pero los sacerdotes cerraron las puertas cuando estuvieron dentro,"
,"16":"y luego de haber abierto una puerta secreta en el entretecho, lo mataron a peñascazos. En seguida lo descuartizaron y lanzaron su cabeza a los que estaban afuera."
,"17":"¡Bendito sea Dios en todas las cosas, pues ha entregado los impíos a la muerte!"
,"18":"Ya que vamos a celebrar la purificación del Templo el veinticinco del mes de Casleu, pensamos que es bueno avisarles para que ustedes también celebren la fiesta de las Tiendas y del Fuego que apareció cuando Nehemías ofreció sacrificios, después de haber reconstruido el Santuario y el altar."
,"19":"Pues deben ustedes saber que cuando nuestros padres fueron llevados a Persia, algunos sacerdotes celosos de esa época tomaron fuego del altar, lo escondieron secretamente en un hoyo, muy parecido a un pozo seco, y lo dejaron tan seguro que nadie conocía el lugar."
,"20":"Al cabo de muchos años, según el beneplácito de Dios, el rey persa mandó a Nehemías. Este ordenó entonces a los descendientes de los sacerdotes que lo habían escondido que buscaran el fuego. Cuando éstos le explicaron que no habían encontrado fuego sino un líquido espeso, Nehemías les ordenó que sacaran de él y se lo llevaran."
,"21":"En el momento en que los sacrificios estaban listos, Nehemías ordenó a los sacerdotes que derramaran ese líquido sobre la leña y sobre las ofrendas que se habían puesto encima; y se hizo tal como lo ordenó."
,"22":"Hasta ese instante el sol estaba oculto por las nubes, pero cuando brilló de repente, se encendió un enorme fuego, quedando todo el mundo admirado."
,"23":"Mientras se quemaban las ofrendas, los sacerdotes hacían la oración junto con todos los que estaban presentes. Jonatán y los sacerdotes comenzaban, y Nehemías y los demás respondían."
,"24":"Esto decía esa oración: «¡Señor! ¡Señor Dios, creador de todo, tú eres terrible y poderoso, justo y lleno de misericordia! Sólo tú eres rey, sólo tú eres bueno,"
,"25":"sólo tú eres generoso, justo, todopoderoso y eterno. Tú salvas a Israel de todo mal, tú elegiste a nuestros padres y los santificaste."
,"26":"Recibe este sacrificio en nombre de todo tu pueblo de Israel, guarda tu herencia y santifícalo."
,"27":"Reúne a los nuestros que están dispersos, libra a los que están cautivos en medio de las naciones y allí son despreciados, mira con bondad a los que son menospreciados y considerados una nada; así sabrán las naciones que tú eres nuestro Dios."
,"28":"Reprime a los que nos oprimen, nos insultan y nos tratan con desprecio."
,"29":"Instala a tu pueblo en tu Lugar Santo, tal como lo prometió Moisés»."
,"30":"Los sacerdotes acompañaban los cánticos con arpas."
,"31":"Cuando el sacrificio se quemó entero, Nehemías ordenó derramar el líquido sobrante sobre grandes piedras;"
,"32":"se encendió un fuego que fue pronto eclipsado por el resplandor del fuego del altar."
,"33":"Se difundió este hecho y al mismo rey de los Persas le llevaron esta noticia:"
,"34":"Después de verificar los hechos, el rey hizo levantar una cerca y decretó que sería lugar sagrado."
,"35":"Regalaba este líquido y se lo devolvían, de manera que obtuvo importantes ganancias con ello."
,"36":"Nehemías y sus hombres llamaron a ese líquido , que quiere decir purificación, pero comúnmente se lo llama nafta."
}`)
	CurrentBook.AddChapter(2, `{
"1":"En otros archivos también se lee que el profeta Jeremías dio a los desterrados la orden de recuperar el fuego, tal como se dijo."
,"2":"También recomendaba a los desterrados no olvidarse de los mandamientos del Señor y no dejarse engañar cuando vieran estatuas de oro y plata adornadas y vestidas."
,"3":"De mil maneras les recomendaba que no dejaran que la Ley se alejara de su corazón."
,"4":"En esos mismos archivos se lee que por orden de Dios el profeta tomó la Tienda y el Arca, y subió al cerro a donde había subido Moisés y de donde había contemplado la herencia de Dios."
,"5":"Al llegar allá, Jeremías encontró una gruta que servía de habitación y depositó allí la Tienda y el Arca con el altar de los perfumes y luego clausuró la entrada."
,"6":"Algunos de sus compañeros fueron en seguida a marcar el camino con señales, pero no pudieron hallarlo."
,"7":"Cuando Jeremías lo supo, les llamó la atención: «Ese lugar, les dijo, debe permanecer oculto hasta el día en que Dios reúna a su pueblo y tenga misericordia de él."
,"8":"Entonces revelará el Señor todo esto, la Gloria del Señor aparecerá en la nube, tal como se apareció en tiempos de Moisés, o cuando Salomón pronunció su oración con motivo de la consagración solemne del Templo»."
,"9":"A propósito del sacrificio que ese rey ofreció para la dedicación y la inauguración del Templo en el tiempo de su sabiduría, se lee también esto:"
,"10":"«Igual como Moisés había orado al Señor y cayó del cielo un fuego que consumó la víctima, así también a la oración de Salomón bajó el fuego y consumió los holocaustos."
,"11":"Moisés lo había dicho: Como la víctima por el pecado no tenía que ser comida, fue consumida."
,"12":"Eso mismo ocurrió cuando Salomón celebró los ocho días de la fiesta de la Dedicación.»"
,"13":"Todo esto se contaba en los archivos y en las crónicas del tiempo de Nehemías. Allí también se dice que Nehemías inició una biblioteca y depositó allí los libros sobre los reyes y los profetas, los libros de David y las instrucciones de los reyes respecto a los sacrificios."
,"14":"Judas también ha reunido todos los libros que se habían dispersado durante la guerra que hemos tenido, y están ahora en nuestras manos."
,"15":"Si ustedes necesitan esos libros, mándennos a algunos mensajeros para que se los lleven."
,"16":"Les enviamos esta carta mientras nos preparamos para celebrar la fiesta de la Purificación; sería bueno que celebraran esos días junto con nosotros."
,"17":"Dios ha salvado a su pueblo; les ha devuelto a todos su herencia, haciendo de ellos un reino, un sacerdocio y un pueblo santo,"
,"18":"tal como se lee en la Ley. Al ver cómo nos ha librado de grandes desgracias y purificó el Templo, esperamos que pronto tendrá piedad de nosotros y nos reunirá de todas partes en el Lugar Santo."
,"19":"La historia de Judas Macabeo y de sus hermanos, la purificación del Templo, la dedicación del altar,"
,"20":"las guerras contra Antíoco Epífanes y su hijo Eupator,"
,"21":"las manifestaciones celestes que tuvieron lugar en favor de aquellos que luchaban heroicamente por el judaísmo, porque a pesar de su número reducido reconquistaron toda la región e hicieron huir a los ejércitos bárbaros,"
,"22":"y cómo recuperaron el Templo célebre en todo el universo, liberaron la ciudad y restablecieron las leyes que querían abolir, cuando el Señor siempre justo les fue favorable,"
,"23":"todo eso fue expuesto por Jasón de Cirene en cinco libros que trataremos de resumir en uno solo."
,"24":"Pues nos fijamos en la gran cantidad de cifras que hay allí, y creemos que una documentación tan abundante se hará pesada a los que quieran interiorizar los relatos de la historia."
,"25":"Por eso tuvimos la preocupación de ofrecer un texto agradable a los que se contentan con una simple lectura, práctico para los que gustan recordar esos hechos, y útil para todos."
,"26":"Para nosotros que nos hemos encargado del trabajo penoso de este resumen, no ha sido una obra fácil, sino que nos ha costado harto hacerla,"
,"27":"lo mismo que no resulta nada fácil preparar un banquete que sea del gusto de todos. Pero hacemos como el organizador del banquete y soportamos con gusto esta fatiga para complacer a otros."
,"28":"Dejando que el autor averigüe y pormenorice los hechos, nos esforzamos por resumirlos."
,"29":"Actuamos como el arquitecto de una nueva casa que debe tener en mente el conjunto de la construcción, mientras que el encargado de las pinturas y de la cera estudia lo que mejor conviene para la decoración."
,"30":"Analizar los pormenores, debatir los puntos discutibles, dedicar mucho tiempo a los detalles, corresponde al historiador;"
,"31":"pero al que intenta adaptarla se le permite resumir y no presentar una narración completa de los hechos."
,"32":"Comencemos pues nuestro relato sin añadir más a lo ya dicho, porque sería ridículo ser largo en el prefacio de la obra y luego breve en la historia misma."
}`)
	CurrentBook.AddChapter(3, `{
"1":"En la época en que los habitantes de la ciudad santa gozaban de una verdadera paz, y en que las leyes eran escrupulosamente observadas gracias a la piedad del sumo sacerdote Onías, quien odiaba el mal,"
,"2":"hasta los mismos reyes honraban el Santo Lugar y adornaban el Templo con magníficos presentes."
,"3":"Así fue como Seleuco, rey de Asia, pagaba, de sus ingresos personales, todos los gastos necesarios para el servicio de los sacrificios."
,"4":"Pero sucedió que un tal Simón, de la tribu de Benjamín, que era administrador del Templo, tuvo un problema con el sumo sacerdote con respecto a la fiscalización de los mercados de la ciudad."
,"5":"Como no logró ganarle a Onías, fue a ver a Apolonio, hijo de Traseos, que en esa época era el gobernador de Celesiria y Fenicia."
,"6":"Le contó que el tesoro de Jerusalén contenía enormes sumas, una cantidad increíble de riquezas que no tenían relación con los gastos necesarios para los sacrificios, y que era posible, por tanto, traspasar todo ese tesoro a manos del rey."
,"7":"Una vez que se encontró con el rey, Apolonio le habló de las riquezas que le habían mencionado y el rey designó a Heliodoro, que estaba al frente de sus asuntos; lo mandó con la orden de que confiscara todas las riquezas de las que se hablaba."
,"8":"Heliodoro emprendió el viaje inmediatamente, so pretexto de que iba a inspeccionar las ciudades de Celesiria y Fenicia, pero en realidad para poner en ejecución la orden del rey."
,"9":"Al llegar a Jerusalén, Heliodoro fue recibido amigablemente por el sumo sacerdote y por la ciudad. Contó entonces lo que le habían dicho, manifestó el objetivo de su visita y preguntó si todo eso era exacto."
,"10":"El sumo sacerdote le explicó que el tesoro contenía los depósitos de las viudas y de los huérfanos,"
,"11":"que una parte pertenecía a Hircano, hijo de Tobías, un hombre muy importante, pero que al contrario de las mentiras de Simón, ese hombre impío, el tesoro se reducía a cuatrocientos talentos de plata y doscientos de oro."
,"12":"Por otra parte era imposible quitarles lo que era suyo a los que habían puesto su confianza en la santidad de ese lugar y en la majestad intocable de un templo venerado en todo el universo."
,"13":"Pero Heliodoro, basándose en las órdenes que había recibido del rey, sostenía que de todos modos ese dinero tenía que ser confiscado para el tesoro real."
,"14":"El día acordado para entrar en la cámara del tesoro y para hacer el conteo de esas riquezas, toda la ciudad estaba trastornada."
,"15":"Los sacerdotes se habían postrado ante el altar, revestidos con sus ornamentos sacerdotales, e invocando al Cielo que había dado la ley sobre los depósitos, le pedían que conservara esos bienes intactos para los que los habían depositado."
,"16":"Al ver el rostro del sumo sacerdote cualquiera se impresionaba, porque su rostro extenuado, su palidez, demostraban bien la angustia de su alma."
,"17":"Era presa de un terror que hacía temblar todo su cuerpo, y todos eran testigos del sufrimiento que experimentaba."
,"18":"Los habitantes salían de sus casas y en grupos oraban para que el Lugar Santo no conociera esa vergüenza."
,"19":"Las mujeres con sacos ceñidos a su cintura repletaban las calles, las jovencitas que se habían quedado en casa corrían a las puertas o subían al muro, otras se inclinaban sobre las ventanas."
,"20":"Todas las manos estaban tendidas al Cielo clamando su plegaria;"
,"21":"daba pena ver la angustia de esa muchedumbre unida en un mismo abatimiento y la ansiosa espera del sumo sacerdote."
,"22":"Mientras se suplicaba al Señor Todopoderoso que guardara intactos y salvos los depósitos a los que los habían efectuado,"
,"23":"Heliodoro procedía a hacer lo que había dicho."
,"24":"Ya estaba con su guardia cerca del tesoro, cuando el Soberano de los espíritus y poderes de todo orden produjo una gran aparición en ese mismo lugar; todos los que se habían atrevido a entrar quedaron sin fuerza y sin ánimo, como paralizados por la fuerza de Dios."
,"25":"Se les apareció un caballo montado por un jinete terrible y ricamente equipado, que parecía llevar una armadura de oro; se lanzó directamente hacia Heliodoro, amenazándolo con sus patas delanteras."
,"26":"Al mismo tiempo aparecieron dos jóvenes, rebosantes de energía, deslumbrantes de luz, y vestidos con magníficos trajes. Se pusieron a ambos lados de Heliodoro y empezaron a azotarlo, dejando caer sobre él una lluvia de golpes."
,"27":"Heliodoro cayó a tierra y se halló sumido en profundas tinieblas. Lo tomaron y lo pusieron en una camilla,"
,"28":"y ese hombre que acababa de entrar en la cámara del tesoro con un numeroso séquito de guardias y hombres armados, fue llevado afuera, incapaz de ayudarse a sí mismo; así se había manifestado a todos el poder de Dios."
,"29":"Mientras Heliodoro, golpeado por la fuerza divina, yacía enmudecido y sin esperanza de curación,"
,"30":"los judíos bendecían al Señor que había glorificado su Santo Lugar. El Templo que, hacía apenas un momento estaba invadido por el espanto y la inquietud, se llenaba ahora de gozo y de alegría como consecuencia de la manifestación del Señor Todopoderoso."
,"31":"Inmediatamente algunos compañeros de Heliodoro pidieron a Onías su intercesión para que el Altísimo concediera la vida a aquel que estaba tendido en tierra medio muerto."
,"32":"El Sumo Sacerdote, por su parte, temía que el rey sospechara alguna maquinación de los judíos contra Heliodoro, y ofreció un sacrificio por su salud."
,"33":"Cuando el sumo sacerdote ofrecía el sacrificio de reparación, aparecieron de nuevo a Heliodoro los mismos jóvenes vestidos con los mismos trajes, y poniéndose de pie al lado de él le dijeron: "
,"34":". Después de decir eso, desaparecieron."
,"35":"Heliodoro ofreció un sacrificio al Señor e hizo largas oraciones al que le había conservado la vida; luego, después de haber prometido a Onías su amistad, regresó con sus hombres donde el rey."
,"36":"A todos contaba esa intervención del Dios Grandísimo que había visto con sus propios ojos."
,"37":"Cuando el rey preguntó a Heliodoro quién sería el más indicado para que fuera de nuevo a Jerusalén, Heliodoro le respondió:"
,"38":"«Si tienes algún enemigo o hay alguien que ha hecho un perjuicio al Estado, mándalo allá abajo para que vuelva desgarrado a azotes, si es que logra escapar, porque realmente hay allá una fuerza divina;"
,"39":"el que mora en el Cielo vigila ese lugar y lo protege. Castiga y da muerte a los que van con malas intenciones»."
,"40":"Esto es lo que ocurrió a Heliodoro y así fue como se salvó el tesoro."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ese mentado Simón, que había delatado el tesoro y a su propia patria, comenzó a calumniar a Onías; según él era Onías quien había ordenado que se atacase a Heliodoro y quien era el causante de todas esas dificultades»."
,"2":"Más aún, se atrevía a hacer pasar por enemigo del Estado al que era el bienhechor de la ciudad, el defensor de sus compatriotas y que observaba tan fielmente la Ley."
,"3":"Llegó tan lejos ese odio que uno de los partidarios de Simón cometió crímenes."
,"4":"Onías comprendió el peligro de esa rivalidad y vio que Apolonio, hijo de Menesteo, el gobernador de Celesiria y Fenicia, estimulaba la maldad de Simón."
,"5":"Por eso fue a ver al rey, no para acusar a sus compatriotas sino porque estaba preocupado del interés general y del bien particular de todo su pueblo;"
,"6":"bien veía que sin una intervención del rey los problemas no se solucionarían y Simón continuaría con sus locuras."
,"7":"Seleuco había muerto y sucedióle en el trono Antíoco, apellidado Epífanes. Jasón, hermano de Onías, se apoderó entonces del soberano pontificado."
,"8":"En una entrevista con el rey, le prometió trescientos sesenta talentos de plata y ochenta talentos provenientes de otras entradas."
,"9":"Además estaba dispuesto a comprometerse por escrito con ciento cuarenta talentos más si lo autorizaban a construir por su cuenta un gimnasio y una escuela militar, y a otorgar a habitantes de Jerusalén el título de . El rey consintió en todo."
,"10":"En cuanto Jasón obtuvo el poder, comenzó a introducir entre sus conciudadanos las costumbres griegas."
,"11":"Suprimió las franquicias que por humanidad habían otorgado los reyes a los judíos (éstas habían sido conseguidas por Juan, padre de ese Eupolemo que más tarde fue enviado a Roma como embajador para firmar un tratado de alianza y amistad con los romanos). Suprimió también las legítimas instituciones e inauguró costumbres contrarias a la Ley."
,"12":"Disfrutó construyendo un gimnasio al pie de la fortaleza y trajo lo mejor de la juventud a los ejercicios del gimnasio."
,"13":"Jasón se comportaba como un impío y no como sumo sacerdote. Con su descarada corrupción, hubo una invasión de costumbres extranjeras y vivir a la griega estuvo de moda."
,"14":"Los sacerdotes ya no mostraban interés por el servicio del altar, despreciaban el Templo y descuidaban los sacrificios; en cuanto oían el llamado para ir a lanzar el disco, corrían al estadio para tomar parte en competencias prohibidas por la Ley."
,"15":"Se burlaban de los valores tradicionales, pues estaban convencidos de la superioridad griega."
,"16":"Con esto ellos mismos se preparaban tiempos difíciles, porque aquellos cuyas maneras de vivir trataban de copiar y a los que querían asemejarse en todo, iban a convertirse en sus enemigos y en sus verdugos."
,"17":"El siguiente período mostrará que no se violan las leyes divinas sin castigo."
,"18":"Como se celebraran en Tiro, en presencia del rey, los juegos que se efectuaban cada cuatro años,"
,"19":"el despreciable Jasón envió allá, como delegados de Jerusalén, a unos que llevaban trescientas dracmas de plata para el sacrificio en honor de Heracles. Afortunadamente los que llevaban el dinero no quisieron donarlo para el sacrificio, pensando que no era conveniente, y pidieron que se hiciera otro uso de él."
,"20":"Por eso el dinero que había donado Jasón para el sacrificio en honor de Heracles fue destinado a la construcción de barcos de guerra, debido a la solicitud de los que lo habían traído."
,"21":"Apolonio, hijo de Menesteo, había sido enviado a Egipto para asistir al casamiento de rey Filometor. Antíoco supo que ese rey se había vuelto hostil a su política, de ahí que se preocupara de su propia seguridad; por eso llegó a Jope, y luego alcanzó hasta Jerusalén."
,"22":"Jasón y la ciudad lo recibieron solemnemente, haciendo su entrada a la luz de antorchas y en medio de aclamaciones; después de eso se dirigió a Fenicia con sus tropas."
,"23":"Al cabo de tres años, Jasón envió a Menelao, hermano de ese Simón del que se habló antes, para llevarle un dinero al rey y arreglar algunos problemas importantes."
,"24":"Menelao se consiguió recomendaciones ante el rey y se presentó como un hombre importante; le ofreció trescientos talentos de plata más de lo que había hecho Jasón y logró que le atribuyeran el soberano pontificado."
,"25":"Después de haber recibido los documentos reales que lo confirmaban en el cargo, regresó, pero nada tenía para merecer ese título de sumo sacerdote, a no ser la violencia de un tirano cruel y la rabia de una fiera salvaje que poseía."
,"26":"Así pues Jasón, que se había apoderado del lugar de su hermano, veía ahora como otro ocupaba su lugar y lo obligaba a huir a Ammantida."
,"27":"Menelao se apoderó del poder, pero no entregó nada del dinero que había prometido al rey,"
,"28":"a pesar de los reclamos de Sóstrato, prefecto de la fortaleza, que estaba encargado de recaudar los impuestos. Por eso ambos fueron citados ante el rey."
,"29":"Menelao dejó en su reemplazo como sumo sacerdote a su hermano Lisímaco, y Sóstrato dejó a Crates, jefe de los chipriotas."
,"30":"Fue entonces cuando se sublevaron los habitantes de Tarso y de Malos porque su ciudad había sido dada como regalo a Antióquida, concubina del rey."
,"31":"El rey partió inmediatamente para allá con el fin de arreglar ese asunto, dejando como su reemplazante a Andrónico, alto funcionario."
,"32":"Menelao pensó que era el momento propicio para sustraer algunos vasos de oro del Santuario y ofrecérselos a Andrónico; logró vender otros en Tiro y en las ciudades vecinas."
,"33":"Cuando Onías lo supo con certeza, fue a refugiarse en un lugar de asilo, en Dafne, cerca de Antioquía, y desde allí lo denunció."
,"34":"Por eso Menelao habló en privado con Andrónico y lo presionó para que asesinara a Onías. Andrónico fue pues a ver a Onías con malas intenciones, le hizo un juramento tendiéndole la mano derecha y lo convenció, a pesar de las sospechas de éste, a salir de su asilo; en cuanto salió le dio muerte sin el menor respeto por la justicia."
,"35":"No solo los judíos sino también muchos de los no judíos quedaron indignados y encontraron escandaloso el criminal asesinato de ese hombre."
,"36":"Cuando el rey volvió de la región de Cilicia, los judíos de la ciudad y los griegos que detestaban el mal, fueron a verlo para hablarle del injusto asesinato de Onías."
,"37":"Al acordarse de la sabiduría y de la irreprochable vida de la víctima, Antíoco lloró, pues estaba sinceramente apenado y conmovido hasta lo más profundo de su ser."
,"38":"Luego se apoderó de él la ira, le quitó su cargo a Andrónico y le ordenó que le rasgaran su ropa; hizo pasear a ese asesino por toda la ciudad y mandó ejecutarlo en el mismo lugar donde había asesinado a Onías; así fue como el Señor le dio el castigo que merecía."
,"39":"Durante ese tiempo, Lisímaco, de acuerdo con Menelao, había cometido muchos robos sacrílegos en la ciudad. Como el rumor crecía, el pueblo se rebeló contra Lisímaco después que muchos de los objetos de oro habían ya salido."
,"40":"Para reprimir el levantamiento del pueblo encolerizado, Lisímaco armó a cerca de tres mil hombres y adoptó la vía de la violencia; había puesto al frente de ellos a un tal Auranos, tan loco como viejo."
,"41":"Al verse atacados por Lisímaco, unos tomaron piedras, otros palos y unos terceros tomaron en sus manos brasas que allí había y todos juntos se lanzaron en medio de la trifulca contra la gente de Lisímaco,"
,"42":"a tal extremo que muchos de éstos quedaron heridos y algunos hasta muertos; hicieron huir a los demás y lincharon cerca del tesoro al sacrílego ladrón."
,"43":"Por todos esos hechos se inició un proceso contra Menelao."
,"44":"Cuando el rey llegó a Tiro, tres hombres enviados por los ancianos fueron a exponerle su acusación."
,"45":"Al verse perdido, Menelao prometió una gruesa suma de dinero a Tolomeo, hijo de Dorimenes, para que intercediera por él ante el rey."
,"46":"Tolomeo llevó al rey aparte bajo una galería, con el pretexto de tomar el fresco, y le hizo cambiar de decisión."
,"47":"El rey declaró a Menelao inocente de todos esos cargos, siendo que en realidad era culpable de todos esos males, y condenó a muerte a unos desdichados que habrían sido declarados inocentes incluso entre los bárbaros."
,"48":"Esos hombres, que habían asumido la defensa de la ciudad, del pueblo y de los objetos sagrados, sufrieron inesperadamente esa pena injusta."
,"49":"Hasta los mismos habitantes de Tiro quedaron escandalizados e hicieron a las víctimas solemnes funerales."
,"50":"Menelao, por su parte, conservó su cargo gracias a la gente en el poder que sólo estaba interesada en el dinero; siguió creciendo en mal y en crueldad, siendo el látigo de sus compatriotas."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Antíoco preparó, por ese entonces, su segunda invasión de Egipto."
,"2":"Pues bien, por esa misma época, hubo apariciones en toda la ciudad, durante cerca de cuarenta días: jinetes cuyos trajes estaban bordados en oro galopaban por el cielo, tropas armadas desfilaban en formación,"
,"3":"escuadrones montados se aprestaban para la batalla, con ataques y cargas de una y otra parte, movimientos de escudos, bosques de lanzas, espadas desenvainadas, flechas que volaban, armaduras de oro brillando con todo su esplendor, y corazas de todo tipo."
,"4":"Ante eso todos deseaban que esas apariciones sólo anunciaran algún acontecimiento feliz."
,"5":"Basándose en un falso rumor sobre la muerte de Antíoco, Jasón juntó a unos mil hombres y fue a atacar la ciudad de improviso; los que defendían las murallas fueron superados y la ciudad fue tomada, obligando a Menelao a refugiarse en la fortaleza."
,"6":"Jasón se dedicó a matar a sus propios conciudadanos sin piedad alguna, sin pensar que una victoria que se obtiene sobre sus compatriotas es la mayor derrota; los masacró viendo en ellos enemigos y no gente de su nación."
,"7":"No logró, sin embargo, apoderarse del poder; su expedición terminó en un fracaso y se vio obligado a refugiarse nuevamente en la región de Ammán."
,"8":"Su conducta criminal llegó a su fin; acusado primero ante Aretas, rey de los árabes, trató de refugiarse de una ciudad en otra. Perseguido por todos, detestado por haber renegado de las leyes, repudiado como verdugo de su patria y de sus compatriotas, se fue a Egipto."
,"9":"El que había desterrado a tanta gente lejos de su patria murió al final en una tierra extraña, porque se había ido a Lacedemonia donde pensaba que lo acogerían debido a nuestro parentesco de raza con ese pueblo."
,"10":"El que había dejado tantos cadáveres sin enterrar, no fue enterrado en el sepulcro de sus padres: nadie lo lloró, nadie cumplió las últimas obligaciones con él."
,"11":"Cuando el rey se enteró de eso, pensó que la Judea se quería independizar; salió pues de Egipto, furioso como una fiera salvaje y se apoderó de la ciudad a mano armada."
,"12":"Ordenó a sus soldados que mataran sin piedad a los que encontraran y que degollaran a los que se refugiaran en sus casas."
,"13":"Así se dio muerte a jóvenes y ancianos, se eliminó a mujeres y niños, se degolló a muchachas y a niños de pecho."
,"14":"En tres días hubo ochenta mil víctimas; cuarenta mil cayeron bajo los golpes y los otros fueron vendidos como esclavos."
,"15":"Como si eso no bastara, el rey penetró en el Santuario más santo de toda la tierra, guiado por Menelao que hasta allí había llegado en su traición a las leyes y a la patria."
,"16":"Con sus manos impuras tomó los vasos sagrados, con sus manos profanas cogió las ofrendas que otros reyes habían depositado allí para aumentar más aún la gloria de ese lugar."
,"17":"Henchido de orgullo, Antíoco no veía que el Señor descuidaba ese lugar por unos momentos, porque estaba enojado con los habitantes de la ciudad a causa de sus pecados."
,"18":"Si éstos no hubieran sido culpables de un gran número de pecados, Antíoco habría sido vapuleado en cuanto hubiera entrado, y castigado por su audacia, tal como ese Heliodoro al que había enviado el rey Seleuco para inspeccionar el tesoro;"
,"19":"pero Dios no eligió al pueblo por ese lugar, sino a ese lugar por el pueblo."
,"20":"Por eso ese lugar ha participado de las desgracias del pueblo y también ha estado asociado a las bendiciones del Señor ; fue abandonado por el Todopoderoso en su enojo y también fue restablecido en toda su gloria cuando el Señor todopoderoso se reconcilió con su pueblo."
,"21":"Antíoco había sacado del Templo mil ochocientos talentos y se había vuelto rápidamente a Antioquía, tan orgulloso que se hubiera creído capaz de navegar en tierra firme y de trazar caminos en el mar."
,"22":"Dejó a algunos funcionarios para reprimir a nuestra raza: en Jerusalén a Filipo, originario de Frigia, que era más cruel aún que el que lo había puesto allí;"
,"23":"en Garizim a Andrónico y, fuera de ésos, a Menelao, cuya maldad hacia sus hermanos era peor aún: odiaba a sus compatriotas judíos."
,"24":"El rey mandó al gobernador Apolonio al frente de un ejército de veintidós mil hombres, con orden de degollar a todos los que estuvieran en la flor de su edad y de vender como esclavos a las mujeres y a los niños."
,"25":"Llegó a Jerusalén simulando ser hombre pacífico y esperó hasta el santo día sábado. Aprovechándose del descanso de los judíos, ordenó a sus hombres que efectuaran un desfile;"
,"26":"luego mandó matar a todos los que habían salido para presenciar el espectáculo y recorriendo la ciudad con sus soldados, dio muerte a una gran cantidad de personas."
,"27":"Fue entonces cuando Judas, apellidado Macabeo, se retiró al desierto con una decena de personas; con sus compañeros vivía como fiera salvaje por los cerros, obligándose a un régimen vegetariano antes que volverse impuro."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Poco tiempo después, el rey mandó a Geronte, el Ateniense, para obligar a los judíos a abandonar el culto de sus padres y para que no vivieran más según las leyes de Dios;"
,"2":"quería profanar el Templo de Jerusalén consagrándolo a Zeus Olímpico, y el templo de Garizim a Zeus Hospitalario, según lo habían pedido los habitantes del lugar."
,"3":"Esta agravación del mal fue penosa y difícil de soportar para todos."
,"4":"El Santuario estaba lleno de desenfrenos y orgías de los paganos que se entretenían con prostitutas, que hacían el amor con mujeres en los portales sagrados y que además llevaban allí cosas prohibidas."
,"5":"El altar estaba cubierto de víctimas inaceptables, prohibidas por las leyes;"
,"6":"ya no había derecho para celebrar el sábado, observar las fiestas de nuestros padres y ni siquiera para confesar que uno era judío."
,"7":"Cada cual estaba obligado por una dura necesidad a participar cada mes en la comida ritual, el día del nacimiento del rey, y cuando llegaban las fiestas de Dionisio, había que acompañar el cortejo de la divinidad llevando coronas de hiedra."
,"8":"Por iniciativa de Tolomeo, se publicó un decreto para las ciudades griegas de los alrededores: debía reprimirse a los judíos de la misma manera y obligarlos a tomar parte en las comidas rituales;"
,"9":"y a los que se negaran a adoptar las costumbres griegas había que degollarlos. Todo eso era el anuncio de terribles desgracias."
,"10":"Así fue como dos mujeres fueron llevadas al tribunal por haber circuncidado a sus hijos; las pasearon públicamente por la ciudad, con sus niños colgando de su seno, antes de lanzarlas de lo alto de las murallas."
,"11":"Otros, que se habían reunido en cavernas vecinas para celebrar secretamente el día sábado, fueron denunciados a Filipo. Fueron todos condenados a la hoguera; no quisieron defenderse por creer que eso era ir en contra de la santidad de ese día."
,"12":"Les suplico a quienes tengan este libro en sus manos que no se escandalicen por tantas desgracias, sino que tengan confianza en que las persecuciones no acabarán con nuestra raza; ellas, más bien, sirven para corregirnos."
,"13":"Cuando los pecadores no permanecen tranquilos por mucho tiempo sino que rápidamente les sobreviene el castigo, eso es señal de gran bondad."
,"14":"Vemos que con las demás naciones el Señor espera con paciencia a que lleguen al colmo de sus pecados, pero no ha estimado conveniente actuar así con nosotros."
,"15":"No ha querido esperar para castigarnos que nuestros pecados llegaran hasta el tope."
,"16":"El no abandona a su pueblo, más bien nos corrige por medio de la prueba y no nos priva de su misericordia."
,"17":"Bástenos con haber recordado esta verdad; retomaremos nuestro relato después de estas breves reflexiones."
,"18":"Eleazar era uno de los principales doctores de la Ley, un hombre de edad y de noble aspecto. Quisieron abrirle la boca a la fuerza para hacerle comer carne de cerdo,"
,"19":"pero prefirió una muerte gloriosa a una existencia vergonzosa y marchó voluntariamente al suplicio de la rueda."
,"20":"Escupió lo que tenía en la boca, tal como deben hacerlo los que tienen la valentía de rechazar lo que está prohibido, antes de comérselo por apego a la vida."
,"21":"Los que presidían esa comida ritual, prohibida por la ley, lo llamaron aparte, porque conocían a ese hombre desde hacía mucho tiempo. Lo invitaron a que simulara comer la carne ofrecida en sacrificio según la orden del rey, pero que en realidad fueran carnes autorizadas por la Ley y que él mismo hubiera preparado."
,"22":"Al actuar así, y gracias a esa vieja amistad que los unía, se libraría de la muerte."
,"23":"Pero él tomó una noble decisión, digna de su edad, de la autoridad que le otorgaban su vejez y sus venerables cabellos blancos por la edad, digna también de su conducta irreprochable desde su niñez y conforme a las santas leyes establecidas por Dios mismo. Respondió que mejor lo enviaran al lugar de los muertos."
,"24":"Y añadió esto: «A nuestra edad no es conveniente hacer tal cosa; muchos jóvenes podrían pensar que Eleazar, con sus noventa años, se dejó conquistar por los extranjeros."
,"25":"Y así ellos se descarriarían junto conmigo debido a mi doble juego, en un momento en que me queda tan poco para vivir. De esa manera atraería sobre mi vejez la vergüenza y la deshonra."
,"26":"Y si por ahora escapara al castigo de los hombres, no escaparé vivo o muerto de las manos del Todopoderoso."
,"27":"Al abandonar ahora la vida valientemente, me mostraré digno de mi vejez,"
,"28":"y dejaré a los jóvenes el noble ejemplo de una muerte voluntaria y generosa en defensa de las venerables y santas leyes». Y así hablando, caminó derecho al suplicio de la rueda."
,"29":"Para los que lo llevaban, las palabras que acababa de pronunciar no eran más que locura, y la generosidad que hacía poco habían tenido con él se trocó en maldad."
,"30":"Cuando estaba a punto de morir a golpes, dijo en un suspiro: «El Señor que posee el exacto conocimiento, ve cuán crueles dolores soporto bajo los golpes en mi cuerpo, siendo que podría haber escapado a la muerte; pero él ve que en mi alma los sufro con alegría por el temor que le tengo»."
,"31":"Así entregó la vida, dejando con su muerte un ejemplo de valentía y el recuerdo de su virtud, no sólo a la juventud sino a la gran mayoría de la nación."
}`)
	CurrentBook.AddChapter(7, `{
"1":"También fueron detenidos siete hermanos con su madre, y el rey quiso obligarlos, haciéndoles azotar con correas de cuero, a comer carne de cerdo prohibida por la Ley."
,"2":"Uno de ellos tomó la palabra en nombre de todos y dijo: «¿Qué exiges y qué quieres saber de nosotros? Estamos dispuestos a morir antes que desobedecer a la Ley de nuestros padres»."
,"3":"Furioso, el rey ordenó poner en el fuego ollas y sartenes. En cuanto estuvieron calientes,"
,"4":"ordenó que le cortaran la lengua al que había hablado en nombre de todos, que le arrancaran el cuero cabelludo y le cortaran las extremidades ante los ojos de sus hermanos y de su madre."
,"5":"Cuando estuvo completamente mutilado, ordenó el rey que lo acercaran al fuego y lo cocieran en la sartén, siendo que aún respiraba. Mientras el humo de la sartén se expandía a lo lejos, sus hermanos y su madre se daban ánimo unos a otros para morir valientemente, diciendo: "
,"6":"«El Señor Dios que nos mira tendrá seguramente piedad de nosotros, según la palabra de Moisés en el Cántico que pronunció frente a todos. Allí se dice: Tendrá piedad de sus servidores»."
,"7":"Cuando el primero hubo así pasado a la otra vida, llevaron al segundo al suplicio, le arrancaron la piel de su cabeza junto con sus cabellos y le preguntaron si quería comer cerdo en vez de ser torturado en todos los miembros de su cuerpo."
,"8":"Respondió en la lengua de sus padres: Por lo cual sufrió a su vez los mismos suplicios que el primero."
,"9":"En el momento de dar su último suspiro dijo: «¡No eres más que un criminal! Nos quitas la vida presente, pero el Rey del Universo nos resucitará a una vida eterna, a nosotros que morimos por fidelidad a sus leyes»."
,"10":"Después de éste torturaron al tercero; cuando el verdugo se lo pidió, presentó inmediatamente la lengua y extendió sin vacilar sus manos."
,"11":"Tuvo la valentía de declarar: «Del Cielo he recibido estas manos, pero las sacrifico por sus leyes, y de él espero que me las devuelva»."
,"12":"Hasta el mismo rey y su corte quedaron asombrados de la valentía de ese joven que no tomaba en cuenta para nada sus sufrimientos."
,"13":"Cuando murió, sometieron al cuarto a los mismos suplicios."
,"14":"Estando a punto de morir, dijo: «Felices los que mueren a manos de los hombres, teniendo la esperanza recibida de Dios de ser resucitados por él; pero para ti no habrá resurrección para la vida»."
,"15":"Trajeron después al quinto y lo torturaron. Con sus ojos fijos en el rey, le dijo:"
,"16":"«Aunque eres mortal, tienes autoridad sobre los hombres y haces lo que quieres, pero no creas que nuestra raza esté abandonada de Dios."
,"18":"Después de él trajeron al sexto. Cuando estaba a punto de morir, dijo: «No te hagas ninguna ilusión, porque si hemos atraído sobre nosotros estas desgracias y si nos tocan ahora pruebas poco comunes es porque pecamos contra nuestro Dios."
,"19":"Pero tú, que te atreves a hacerle la guerra a Dios, no creas que quedarás sin castigo»."
,"20":"¡Esa madre que vio morir a sus siete hijos en el transcurso de un solo día fue realmente admirable y merece ser famosa! Lo soportó todo sin flaquear, basada en la esperanza que ponía en el Señor."
,"21":"Fue animando a cada uno de ellos en la lengua de sus padres, y llena de los más bellos sentimientos, sostuvo con coraje viril su ternura de madre."
,"22":"Les decía: «No sé cómo aparecieron ustedes en mis entrañas, pues no soy yo quien les dio el espíritu y la vida, ni quien ensambló los diferentes miembros que conforman su cuerpo."
,"23":"El Creador del mundo, que formó al hombre en el comienzo y dispuso les propiedades de cada naturaleza, les dará a ustedes en su misericordia el espíritu y la vida, ya que ahora se menosprecian a sí mismos por amor a sus leyes»."
,"24":"Antíoco pensaba que lo estaba insultando y maldiciendo. Como el menor aún estaba vivo, el rey le dijo que si dejaba las tradiciones de sus antepasados lo haría rico y feliz, e incluso le prometió con juramento que lo haría su amigo y que le encomendaría altas funciones."
,"25":"Como el joven no le hiciera caso, el rey ordenó que se acercara la madre y le insistió a que aconsejara al niño que salvara su vida."
,"26":"En vista de tanta insistencia, ella aceptó persuadir a su hijo."
,"27":"Se aproximó pues donde él y, engañando al cruel tirano, habló así a su hijo en la lengua de sus padres: «¡Hijo mío, ten piedad de mí! Te llevé en mis entrañas nueve meses, te amamanté durante tres años, te he alimentado y educado hasta la edad que tienes; me he preocupado en todo de ti."
,"28":"Te suplico pues, hijo mío, que mires el cielo y la tierra, y contemples todo lo que contienen; has de saber que Dios fue quien los hizo de la nada; así apareció la raza humana."
,"29":"No le temas a ese verdugo, sino que muéstrate digno de tus hermanos, acepta la muerte para que te encuentre con tus hermanos en el tiempo de la misericordia»."
,"30":"Todavía le estaba hablando, cuando el joven dijo: «¿Qué están esperando? Yo no obedezco a las órdenes del rey, obedezco más bien a las prescripciones de la Ley dada por Moisés a nuestros padres."
,"31":"¡Pero tú que has acarreado tantas desgracias sobre los hebreos, no escaparás de las manos de Dios!"
,"32":"Nosotros sufrimos por nuestros pecados,"
,"33":"Nuestro Señor que vive nos ha mostrado por un momento su cólera para corregirnos y educarnos, pero se reconciliará con sus servidores."
,"34":"Tú en cambio, impío y el más impuro de los hombres, no te infles de orgullo, abandona tus sueños y deja de levantar tu mano contra los servidores de Dios,"
,"35":"porque no has escapado aún al juicio del Dios Todopoderoso que vela por todo."
,"36":"Mis hermanos sufrieron una prueba pasajera a cambio de una vida que no se acaba y ya están cubiertos por la Alianza de Dios. Tú empero, por la justicia de Dios, experimentarás el castigo de tu orgullo."
,"37":"Al igual que mis hermanos entrego mi cuerpo y mi vida por las leyes de mis padres. Le suplico a Dios que tenga pronto piedad de nuestra raza y que te lleve mediante tormentos y sufrimientos a reconocer que El es el único Dios."
,"38":"Ojalá la cólera del Todopoderoso, que se ha desencadenado justamente contra nuestra raza, se detenga por fin en mí y en mis hermanos»."
,"39":"El rey se sintió profundamente herido por esas palabras desafiantes. Muy furioso, torturó a éste más cruelmente que a los otros."
,"40":"Así murió ese joven, en la rectitud y en la total confianza en el Señor."
,"41":"Al último murió la madre, después de sus hijos."
,"42":"Pero ya es bastante sobre la cuestión de las comidas rituales y los suplicios espantosos."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Entretanto Judas Macabeo y sus hombres se introducían secretamente en las aldeas. Reunían a sus parientes y se llevaban consigo a los que permanecían fieles al judaísmo; fue así como juntaron cerca de seis mil hombres."
,"2":"Suplicaban al Señor que mirara a su pueblo al que todos pisoteaban y que tuviera piedad de su Templo profanado por los impíos,"
,"3":"que tuviera piedad de la ciudad destruida y poco menos que nivelada, que escuchara la voz de la sangre que clamaba hacia él,"
,"4":"que se acordara de la muerte criminal de pequeños inocentes, y de los insultos inferidos a su Nombre, en fin, que mostrara su odio contra los malvados."
,"5":"En cuanto Macabeo tuvo una tropa organizada, los paganos no pudieron oponerle resistencia, porque la cólera del Señor se había cambiado en misericordia."
,"6":"Cayendo sorpresivamente sobre ciudades y aldeas, las quemaba; ocupaba las posiciones más favorables y desde allí infligía al enemigo severas pérdidas."
,"7":"La noche era su mejor aliado para ese tipo de expediciones; su fama de valiente se difundió por todas partes."
,"8":"Viendo Filipo que ese hombre no dejaba de progresar y que sus victorias eran cada vez más frecuentes, escribió a Tolomeo, que era el jefe militar de Celesiria y Fenicia, para que restableciera los asuntos del rey."
,"9":"Tolomeo eligió inmediatamente a Nicanor, hijo de Patroclo, uno de los principales Amigos del rey, y lo mandó con un ejército de más o menos veinte mil hombres de diversas naciones a exterminar toda la raza de los judíos; junto con él mandó también a Gorgías, un general que tenía buena experiencia en asuntos de guerra."
,"10":"Como el rey debía a los romanos un tributo de dos mil talentos, Nicanor pensó pagarlo con la venta de los cautivos que se harían en Judea."
,"11":"Rápidamente envió, pues, una invitación a las ciudades marítimas para que fueran a comprar esclavos judíos, ofreciéndoles noventa de ellos por un talento. Pero no contaba con la venganza del Todopoderoso, pronta a caer sobre él."
,"12":"Judas se informó de la expedición de Nicanor y comunicó a sus compañeros la llegada de ese ejército."
,"13":"Los que carecían de valor y no creían en la justicia de Dios huyeron a otros lugares."
,"14":"Los otros, en cambio, vendieron todo lo que les quedaba, y suplicaron al Señor que los librara del impío Nicanor que los había vendido antes de comenzar la batalla."
,"15":"Le pedían que interviniera, no por ellos mismos, sino en consideración a las alianzas concluidas con sus padres, y porque ellos mismos llevaban su Nombre augusto y lleno de majestad."
,"16":"Macabeo reunió pues a los que se habían quedado con él, unos seis mil hombres, y los arengó a que no se acobardaran frente al enemigo ni se dejaran impresionar por el número de esos paganos que los atacaban sin ningún derecho. Debían pelear como valientes,"
,"17":"pensando en la profanación escandalosa del Lugar Santo, en el trato que aquellos infligieron a la ciudad ultrajada, y en la ruina de las instituciones de sus padres."
,"18":"Macabeo les decía: «Ellos creen sólo en sus armas y en su intrepidez, mientras que nosotros contamos con Dios, el Dueño del universo, que con un gesto puede derribar a los que nos atacan, y con ellos a todo el mundo»."
,"19":"Ante sus ojos pasó revista a los antiguos ejemplos de la protección de Dios, como aconteció con esos ciento ochenta mil hombres que perecieron en tiempos de Senaquerib."
,"20":"Les recordó la batalla que tuvieron con los gálatas en Babilonia; los judíos que participaban en la batalla al lado de los cuatro mil macedonios no eran más que ocho mil hombres, y como los macedonios se encontraran en apuros, esos ocho mil derrotaron a ciento veinte mil enemigos, gracias a la ayuda venida del Cielo, juntando además un cuantioso botín."
,"21":"Después de haber renovado su confianza con esos ejemplos y de haberlos predispuesto a morir por las leyes y por la patria, dividió su ejército en cuatro destacamentos."
,"22":"Puso a sus hermanos Simón, José y Jonatán al frente de cada uno de esos destacamentos y dio a cada uno de ellos mil quinientos hombres. También estaba allí Eleazar."
,"23":"Efectuó la lectura del Libro Santo, y dando como consigna , encabezó el primer destacamento y atacó a Nicanor."
,"24":"El Dueño del universo fue a ayudarlo: mataron a más de nueve mil enemigos, hirieron y mutilaron a la mayor parte de los hombres de Nicanor y los hicieron huir."
,"25":"Juntaron el dinero de los que habían ido a comprarlos y persiguieron bastante lejos al enemigo, pero debieron detenerse porque les faltó tiempo."
,"26":"Como empezaba la víspera del sábado, dejaron de perseguirlos."
,"27":"Una vez que juntaron las armas de los enemigos y les quitaron sus pertenencias, celebraron el sábado; bendecían a Dios miles de veces y alababan al Señor que los había librado ese día y había tenido para con ellos un primer gesto de misericordia."
,"28":"Después del sábado distribuyeron una parte del botín a los que habían sufrido la persecución, a las viudas y a los huérfanos; el resto se lo repartieron entre ellos y sus hijos."
,"29":"Luego se pusieron a orar todos juntos, suplicándole al Señor misericordioso que se reconciliara totalmente con sus servidores."
,"30":"Después enfrentaron a los hombres de Timoteo y Baquides, dando muerte a más de veinte mil de ellos; se apoderaron de fortalezas elevadas y repartieron de nuevo el botín conformando dos partes: una para ellos, y otra para las víctimas de la persecución, los huérfanos, las viudas y los ancianos."
,"31":"Recogieron las armas y las depositaron cuidadosamente en los sitios más convenientes, luego transportaron a Jerusalén el resto del botín."
,"32":"Ejecutaron al jefe de los guardias de Timoteo, que era un hombre muy malo y que había hecho mucho daño a los judíos."
,"33":"Cuando estaban celebrando su victoria en su capital, quemaron también a los que habían incendiado las puertas santas y que se habían refugiado con Calístenes en una pequeña casa; así recibieron el justo pago por su impiedad."
,"34":"Ese tres veces criminal de Nicanor, que había convocado a mil mercaderes para efectuar la venta de los judíos,"
,"35":"fue humillado, con la ayuda del Señor, por gente que él pensaba era lo peor de todos. Nicanor tiró sus ropas principescas y emprendió la fuga a través de los campos como un esclavo fugitivo, sin acompañamiento. Tuvo la inesperada suerte de llegar hasta Antioquía después del desastre de su ejército."
,"36":"Y él, que había prometido pagar el tributo que se debía a los romanos con el dinero por los cautivos de Jerusalén, anunciaba ahora que los judíos tenían a Dios como defensor y que eran invencibles porque obedecían las leyes que éste les había ordenado."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Por ese entonces Antíoco estaba regresando muy humillado de las regiones de Persia."
,"2":"Pues había ido a una ciudad llamada Persépolis, y como intentara robar al templo y someter la ciudad, la muchedumbre se amotinó. Los habitantes del lugar tomaron las armas y derrotaron a Antíoco, el que se retiró sin gloria."
,"3":"Cuando estaba en la región de Ecbatana, se enteró de lo que había ocurrido con Nicanor y con el ejército de Timoteo."
,"4":"Loco de rabia, pensó hacer pagar a los judíos la audacia de los que lo habían obligado a huir. Ordenó pues al conductor de su carro que continuara sin parar para llegar lo más pronto posible; pero la venganza del cielo lo perseguía, pues en su orgullo había dicho: «En cuanto llegue a Jerusalén, convertiré a esa ciudad en la tumba de los judíos»."
,"5":"Pero el Señor Dios de Israel, que lo ve todo, lo castigó con una llaga incurable y horrible a la vista. No acababa aún de pronunciar esas palabras, cuando contrajo un malestar a los intestinos, sin esperanza de curación, con agudos dolores al vientre."
,"6":"Era eso muy justo, porque había desgarrado las entrañas de otros en medio de suplicios crueles e increíbles."
,"7":"No disminuyó con eso, sin embargo, su insolencia y, repleto siempre de orgullo, avivó más aún el fuego de su cólera contra los judíos, ordenando que se acelerara la marcha. De repente cayó de su carro, y fue tan violenta la caída que se dislocaron todos los miembros de su cuerpo."
,"8":"Poco antes se consideraba un superhombre, listo para dar órdenes a las olas del mar o para pesar en una balanza la masa de las montañas: ahora estaba tirado en tierra y tenían que llevarlo en una camilla. Entonces resplandeció a los ojos de todos el poder de Dios."
,"9":"Del cuerpo de ese impío que aún estaba vivo salían los gusanos, sus carnes se desprendían a pedazos en medio de atroces dolores, y el hedor de la podredumbre que salía de él molestaba a todo el ejército."
,"10":"Debido a esa hediondez insoportable nadie podía ahora estar cerca de aquel que antes parecía tocar los mismos astros del cielo."
,"11":"Entonces, en medio de sus terribles sufrimientos, comenzó a volver de su orgullo y a reconocer su condición bajo el castigo divino que a cada momento redoblaba sus dolores."
,"12":"Como ni siquiera él mismo podía soportar ya su propia fetidez, reconoció: «Es justo someterse a Dios y, siendo mortal, no igualarse con la Divinidad»."
,"13":"Ese hombre impuro hizo entonces un voto al Señor que ya no tenía piedad de él."
,"14":"Hablando de esa Ciudad Santa, a la que quería llegar pronto para arrasarla y convertirla en tumba de sus habitantes, prometió que la declararía libre."
,"15":"Prometió igualar con los atenienses a esos judíos que, hacía unos momentos, no consideraba dignos de sepultura y los entregaba a ellos y a sus hijos como alimento de las aves de rapiña y de las fieras salvajes."
,"16":"Prometió adornar con las más hermosas ofrendas el Templo Santo que había antes saqueado, devolverle con creces todos los objetos sagrados y pagar con sus propias rentas los gastos de los sacrificios."
,"17":"Más aún, prometió que se haría judío y que recorrería todos los lugares habitados para proclamar la omnipotencia de Dios."
,"18":"Pero sus sufrimientos no se calmaban, porque se había abatido sobre él el justo castigo de Dios; entonces, viéndose en una situación desesperada, escribió a los judíos esta carta, que más parecía una súplica, y que estaba redactada así:"
,"19":"«El rey y general Antíoco saluda a los judíos, sus excelentes ciudadanos, y les desea salud y felicidad perfectas."
,"20":"Tendremos una razón más de confiar en Dios si ustedes y sus hijos están bien y sus negocios prosperan,"
,"21":"pues recuerdo afectuosamente las señales de honor y bondad que recibí de parte de ustedes. Al regresar de las regiones de Persia, he contraído una cruel enfermedad, por eso he creído conveniente preocuparme del futuro de ustedes en todo."
,"22":"No es que desespere de mi situación, pues aún tengo esperanza de salir de esta enfermedad,"
,"23":"sino que pienso en mi padre que designaba a su sucesor cuando salía de expedición a las provincias lejanas."
,"24":"El quería que en caso de una desgracia imprevista o de una mala noticia, la gente del reino no quedara desconcertada sino que supiera a quién le correspondía el gobierno."
,"25":"También me doy cuenta que los príncipes establecidos sobre las fronteras del reino están atisbando la ocasión y están al acecho de todo lo que pueda ocurrir. Por eso he designado como rey a mi hijo Antíoco. Más de una vez, cuando tuve que ir a las provincias lejanas, lo he recomendado a la mayoría de ustedes, y le he escrito respecto de ustedes la carta reproducida más abajo."
,"26":"Les pido pues y les suplico que se acuerden de los beneficios que han recibido de mí, todos ustedes o alguno en particular, y que sigan siendo benevolentes conmigo y con mi hijo."
,"27":"Estoy cierto que él continuará con moderación y humanidad mi política respecto a ustedes y que se mostrará benigno con ustedes»."
,"28":"Así fue como ese asesino, ese blasfemo, pasó por terribles sufrimientos, tal como se los había hecho experimentar a otros, antes de morir de una muerte miserable en una tierra extraña, en medio de las montañas."
,"29":"Filipo, su compañero de infancia, ordenó que trasladaran su cuerpo; luego se refugió en Egipto al lado de Tolomeo Filometor, porque temía al joven Antíoco."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Macabeo y sus compañeros, con la ayuda del Señor, recuperaron el Templo y la ciudad."
,"2":"Destruyeron los altares levantados por los extranjeros en las plazas, como también los recintos sagrados."
,"3":"Después de haber purificado el Templo, hicieron un nuevo altar y, después de sacar fuego del pedernal, ofrecieron sacrificios. Luego de dos años de interrupción, hicieron humear el incienso, encendieron las lámparas y depositaron en la mesa los panes de la proposición."
,"4":"En seguida, postrados y tendidos en el suelo, le rogaron al Señor que no los dejase más caer en esas desgracias. Le pedían que si volvían a pecar los corrigiera como es debido, pero que no los entregase más a naciones impías y bárbaras."
,"5":"El Templo fue purificado el mismo día en que había sido profanado por los paganos, esto es, el veinticinco del mes de Casleu."
,"6":"Se celebró jubilosamente la fiesta durante ocho días, como se hace en los días de las Tiendas; podían recordar que hasta hacía poco tiempo se había celebrado la fiesta de las Tiendas en las montañas, escondiéndose en cavernas como animales salvajes."
,"7":"Por eso, llevando ramos, ramas y palmas, entonaron cánticos a la gloria del que había llevado a cabo la purificación de su Templo."
,"8":"Después de una declaración pública y de una votación, decidieron que toda la nación judía celebraría anualmente esos mismos días."
,"9":"Acabamos de decir cuál fue el fin de Antíoco, llamado Epífanes."
,"10":"Hablaremos ahora de Antíoco Eupator, el hijo de ese rey impío, resumiendo las desgracias ocasionadas por las guerras."
,"11":"Después de haber heredado el reino, Antíoco Eupator, puso al frente de sus asuntos a un tal Lisias, al que también nombró general supremo de Celesiria y Fenicia."
,"12":"Allí sucedió a Tolomeo, llamado Macrón. Ese hombre trataba de solucionar los problemas de los judíos de una manera pacífica; incluso había sido el primero en reparar con justicia las injusticia cometidas con los judíos."
,"13":"Por eso los Amigos del rey lo acusaron a Eupator. Oía a cada rato que lo llamaban traidor; le criticaban que hubiera abandonado Chipre, la que le había sido confiada por Filometor y que se hubiera pasado al lado de Antíoco Epífanes. Viendo que no podía más desempeñar su cargo con honor, se envenenó."
,"14":"Gorgías, que fue nombrado general en la misma región, mantenía mercenarios con los que hostigaba a los judíos."
,"15":"Al mismo tiempo, los idumeos que poseían fortalezas bien ubicadas, no dejaban de molestar a los judíos. Acogían a los que habían sido expulsados de Jerusalén y hacían todo para prolongar las hostilidades."
,"16":"Macabeo y sus hombres hicieron rogativas públicas. Le pidieron a Dios que se pusiera de su lado y luego se lanzaron al ataque de las fortalezas de los idumeos."
,"17":"En medio de un violento combate se adueñaron de esas posiciones, después de haber hecho retroceder a todos los que combatían en las murallas. Luego degollaron a cuantos caían en sus manos, matando al menos a veinte mil."
,"18":"Nueve mil se habían refugiado en dos torres bien fortificadas y provistas de todo lo necesario para resistir un sitio."
,"19":"Macabeo dejó allí a Simón y a José, como también a Zaqueo y a sus compañeros, en número suficiente para mantener el asedio y él partió a combatir a donde era más urgente."
,"20":"Pero los hombres de Simón, por amor al dinero, se dejaron sobornar por algunos de los que estaban en las torres; dejaron escapar un cierto número por setenta mil dracmas."
,"21":"En cuanto se enteró Macabeo de lo que había pasado, reunió a los jefes del pueblo y acusó a esos hombres que habían vendido a sus hermanos y que habían dejado escapar a sus enemigos por dinero."
,"22":"Mandó ejecutar a esos traidores y se apoderó luego de las dos torres."
,"23":"Tuvo pleno éxito con las armas en la mano y dio muerte en esas dos fortalezas a más de veinte mil hombres."
,"24":"Mientras tanto Timoteo, que había sido vencido anteriormente por los judíos, regresó. Había reclutado numerosas tropas extranjeras, entre ellas una numerosa caballería que venía de Asia, y pensaba apoderarse de Judea por las armas."
,"25":"Cuando se aproximaba, Macabeo y sus hombres se vistieron de saco para suplicarle a Dios y se echaron polvo en la cabeza."
,"26":"Se postraron al pie del altar, pidiendo al Señor que les demostrara su bondad, haciéndose el enemigo de sus enemigos y el adversario de sus adversarios, tal como la Ley lo dice."
,"27":"Terminada su oración, tomaron sus armas y avanzaron bastante lejos de la ciudad. Cuando llegaron cerca del enemigo, tomaron posiciones."
,"28":"Cuando el sol apenas acababa de salir, ambos bandos se lanzaron al ataque. Unos contaban para obtener el éxito y la victoria con su valentía pero sobre todo con la ayuda del Señor, los otros no tenían más guía que su pasión."
,"29":"En lo mejor de la refriega, los enemigos vieron que venían del cielo cinco hombres magníficamente montados en caballos con riendas de oro, los que avanzaban al frente de los judíos."
,"30":"Pusieron a Macabeo en medio de ellos, y protegiéndolo con sus armaduras lo volvían invulnerable. Al mismo tiempo lanzaban a los enemigos flechas y rayos, y éstos, enceguecidos y aterrorizados, salían huyendo para todas partes."
,"31":"Murieron veinte mil quinientos y seiscientos de caballería."
,"32":"Timoteo, por su parte, se refugió en una plaza llamada Gazara, una importante fortaleza cuyo general se llamaba Quereas."
,"33":"Llenos de entusiasmo, Macabeo y sus hombres sitiaron la fortaleza durante cuatro días."
,"34":"Los que estaban dentro, contando con la solidez de sus defensas, pronunciaban toda clase de blasfemias y palabras que no se pueden repetir."
,"35":"Al inicio del quinto día, veinte jóvenes del ejército de Macabeo, furiosos por esas blasfemias, se lanzaron contra la muralla con gran valentía y golpearon salvajemente a todos los que cayeron en sus manos."
,"36":"Los otros atacaron también a los sitiados tomándolos por la espalda y prendieron fuego a las torres; encendieron hogueras, donde fueron quemados vivos los que habían blasfemado. Otros rompieron las puertas y le abrieron un boquete al resto del ejército que se apoderó de la ciudad."
,"37":"A Timoteo, que se había escondido en una cisterna, lo degollaron junto con su hermano Quereas y Apolofane."
,"38":"Cuando terminaron, bendijeron al Señor con himnos y cantos de acción de gracias, porque acababa de conceder a Israel un gran favor al otorgarle la victoria."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Lisias, el tutor y pariente del rey y que gobernaba el reino, se sintió muy contrariado con lo que estaba pasando."
,"2":"Poco tiempo después reunió alrededor de ochenta mil hombres y toda la caballería, y fue al encuentro de los judíos, muy decidido a convertir la ciudad santa en una localidad griega,"
,"3":"a retirar el dinero del Templo igual como se hacía con el de los santuarios paganos, y a subastar cada año el cargo de sumo sacerdote."
,"4":"Se dejaba enceguecer por la multitud de sus soldados de infantería, por los miles de caballería y sus ochenta elefantes, y no tomaba en cuenta para nada la fuerza de Dios."
,"5":"Entró pues en Judea y se aproximó a Bet-Sur, una fortaleza que distaba más o menos treinta kilómetros de Jerusalén, y la sitió."
,"6":"Cuando Macabeo y sus hombres supieron que Lisias venía a sitiar las fortalezas, suplicaron al Señor con clamores y lágrimas; junto con todo el pueblo suplicaban al Señor para que enviara a su buen ángel para salvar a Israel."
,"7":"Macabeo fue el primero en tomar las armas, arengando a los demás a desafiar con él el peligro en defensa de sus hermanos. Y juntos emprendieron valientemente el camino."
,"8":"Cuando aún estaban cerca de Jerusalén, apareció marchando al frente de ellos un jinete vestido de blanco y que llevaba una armadura de oro."
,"9":"Todos juntos bendijeron al Dios lleno de misericordia, pues a partir de ese momento se sentían llenos de coraje, dispuestos a enfrentar no sólo a los hombres sino a las fieras más feroces y a derribar murallas de fierro."
,"10":"Avanzaron pues en orden de batalla junto con ese aliado venido del cielo: el Señor había tenido piedad de ellos y venía a socorrerlos."
,"11":"Se lanzaron como leones sobre los enemigos y mataron once mil de ellos, más mil seiscientos de a caballo, obligando a huir a todos los demás."
,"12":"La mayoría de ellos huyeron heridos y sin armas y el mismo Lisias salvó su vida gracias a una huida vergonzosa."
,"13":"Pero Lisias era inteligente, y reflexionó sobre la derrota que acababa de sufrir. Comprendió que los hebreos eran invencibles porque el Dios poderoso combatía por ellos."
,"14":"Por eso les mandó un emisario para persuadirlos a firmar la paz sobre bases justas, y añadía que convencería al rey de que debía ser amigo de ellos."
,"15":"Macabeo aceptó todo lo que Lisias le proponía, porque no tenía más interés que el bienestar del pueblo, y efectivamente el rey concedió a los judíos todo lo que Macabeo había exigido a Lisias por escrito."
,"16":"Esto decían las cartas enviadas por Lisias a los judíos: «Lisias saluda a la comunidad de los judíos."
,"17":"Sus emisarios Juan y Absalón, después de entregar las peticiones de ustedes, aguardaban una respuesta a los problemas que han planteado."
,"18":"He expuesto al rey todo lo que le incumbe y ha otorgado todo lo que era conveniente."
,"19":"Si ustedes conservan pues sus buenos sentimientos hacia el estado, trataré de hacer en el futuro todo lo que pueda favorecerles."
,"20":"Respecto a los detalles, he ordenado a los emisarios de ustedes y a los míos que los discutan con ustedes."
,"21":"Pórtense bien. Año ciento cuarenta y ocho, veinticuatro de Zeus Corintio»."
,"22":"Así estaba escrita la carta del rey: «El rey Antíoco saluda a su hermano Lisias."
,"23":"Habiéndose ido nuestro padre a reunir con los dioses, queremos ahora que los súbditos de nuestro reino puedan ocuparse de sus asuntos sin inquietud."
,"24":"Sabiendo que los judíos no aceptan seguir las costumbres de los griegos, como lo quería nuestro padre, sino que prefieren vivir a su manera y piden que les respeten sus costumbres,"
,"25":"y queriendo que esa nación salga de sus tribulaciones, hemos decidido que le sea devuelto su Templo y que puedan vivir según las costumbres de sus antepasados."
,"26":"Harás bien en tomar contacto con ellos en son de paz, para que conozcan nuestras buenas intenciones, y puedan dedicarse a sus asuntos sin que los molesten»."
,"27":"Aquí va ahora el texto de la carta del rey a la nación: «¡El rey Antíoco saluda al consejo de los ancianos de los judíos y a todos los demás judíos!"
,"28":"Deseamos que estén gozando de buena salud como lo estamos nosotros."
,"29":"Menelao nos ha manifestado el deseo de ustedes de regresar a sus hogares y de ocuparse de sus asuntos."
,"30":"Por eso tendemos la mano y ofrecemos la paz a todos los que regresen a sus casas antes del treinta del mes de Xántico."
,"31":"Los judíos podrán comer sus alimentos y seguir sus leyes como antes. Ninguno de ellos será molestado de cualquier modo por las faltas que haya cometido por ignorancia."
,"32":"Les envío además a Menelao para que los tranquilice."
,"33":"Pórtense bien. El año ciento cuarenta y ocho, el quince del mes de Xántico»."
,"34":"Los romanos por su parte mandaron la siguiente carta: «Quinto Memmio, Tito Manilio, Manio Sergio, embajadores de Roma, saludan al pueblo judío."
,"35":"Estamos totalmente de acuerdo con lo que Lisias, pariente del rey, les ha concedido."
,"36":"En cuanto a los problemas que Lisias decidió someter a la consideración del rey, mándennos rápidamente a alguien para que podamos examinarlos y presentárselos al rey como ustedes lo quieren. Porque ahora nos dirigimos a Antioquía."
,"37":"No tarden pues en enviarnos a alguien para que sepamos lo que ustedes piensan."
,"38":"Tengan buena salud. El año ciento cuarenta y ocho, el quince del mes de Xántico»."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Una vez firmados esos acuerdos, Lisias regresó donde el rey, y los judíos volvieron a los trabajos de sus campos."
,"2":"Pero muchos de los jefes militares de la región: Timoteo, Apolonio, hijo de Geneo, Jerónimo, Demofón y Nicanor, el jefe de los mercenarios de Chipre, no dejaban tranquilos ni en paz a los judíos."
,"3":"Por otra parte, los habitantes de Jope cometieron un odioso crimen. Invitaron a los judíos que vivían entre ellos a que fueran a pasear en unos barcos que habían preparado, junto con sus mujeres e hijos;"
,"4":"eso respondía a un decreto de la ciudad que no dejaba entrever ninguna mala intención. Los judíos aceptaron como gente que quiere la paz y no tiene desconfianza alguna; pero cuando estuvieron en alta mar, los echaron a pique; eran cerca de doscientos."
,"5":"Apenas se enteró Judas de esa cruel acción cometida con la gente de su nación, se lo hizo saber a sus hombres."
,"6":"Después de haberle suplicado a Dios, el justo Juez, fue a sorprender a los asesinos de sus hermanos. Incendió el puerto durante la noche, quemó todos los barcos y dio muerte a todos los que se habían allí refugiado."
,"7":"Como la ciudad estaba cerrada, se fue muy decidido a volver para dar muerte a todos los habitantes de Jope."
,"8":"Supo que los habitantes de Jamnia querían hacer lo mismo a los judíos que vivían entre ellos."
,"9":"Entonces, de noche, atacó Jamnia y prendió fuego al puerto y a las embarcaciones; el incendio era tan grande que la iluminación de las llamas se veía desde Jerusalén, distante de allí unos cincuenta kilómetros."
,"10":"Desde allí se encaminaron contra Timoteo. Cuando se habían alejado uno o dos kilómetros, se dejaron caer sobre Judas los árabes, en número de cinco mil hombres y quinientos jinetes."
,"11":"El combate fue serio, pero los hombres de Judas, con la ayuda de Dios, obtuvieron la victoria. Los derrotados nómades pidieron a Judas que les tendiera la mano, le prometieron proveerlo de ganado y prestarle servicios en el futuro."
,"12":"Judas pensó que podrían serles útiles para muchas cosas y aceptó firmar la paz con ellos. Los árabes, luego de haber hecho las paces, se retiraron a sus tiendas."
,"13":"Judas atacó después una ciudad fortificada, protegida por terraplenes y murallas, cuya población era muy mezclada y que se llamaba Caspín."
,"14":"Los del interior contaban con la solidez de sus murallas y sus reservas de alimento. Se mostraron groseros con Judas y sus hombres; los insultaban y proferían blasfemias con palabras horribles."
,"15":"Judas y sus hombres suplicaron entonces al Gran Soberano del mundo, que había hecho caer a Jericó sin arietes ni máquinas de guerra en tiempos de Josué. Luego se lanzaron con furia contra la muralla."
,"16":"Se apoderaron de la ciudad por voluntad de Dios e hicieron allí una matanza tan increíble que el estanque vecino, que tiene más de cien metros de largo, parecía lleno de sangre."
,"17":"Después de haber caminado unos ciento cuarenta kilómetros, llegaron a Jaraca, en el territorio de los judíos tubienses,"
,"18":"pero no encontraron allí a Timoteo. Se había ido sin haber hecho nada, pero había dejado, en un determinado lugar, una guarnición muy poderosa."
,"19":"Dositeo y Sosípater, generales de Macabeo, efectuaron una expedición hasta allá y dieron muerte a los diez mil hombres que Timoteo había dejado en esa plaza."
,"20":"El Macabeo, entonces, dividió su ejército en batallones y puso jefes al frente de ellos, luego se lanzó contra Timoteo. Timoteo tenía consigo ciento veinte mil soldados de infantería y dos mil quinientos de caballería."
,"21":"Cuando Timoteo se informó del avance de Judas, envió a las mujeres, los niños y todo el equipaje a un lugar llamado Carnión. Era una fortaleza inexpugnable, porque los pasos por ese sector son muy estrechos y el acceso muy difícil."
,"22":"En cuanto apareció la vanguardia de Judas, los enemigos se llenaron de miedo; también los asustó una manifestación del que todo lo ve, de tal modo que huyeron por todas partes. Se atravesaban unos a otros y muchos quedaron heridos por sus propios compañeros."
,"23":"Judas los persiguió sin descanso, derrotó a esos bandidos y dio muerte a más de treinta mil hombres."
,"24":"El mismo Timoteo cayó en manos de los hombres de Dositeo y de Sosípater, pero fue lo bastante hábil para pedirles que lo dejaran sano y salvo, al decirles que tenía prisioneros a parientes y hermanos de muchos de ellos y que podría ocurrirles alguna desgracia."
,"25":"Por eso, después que se comprometió de palabra a dejar libres a esas personas, lo soltaron para salvar a sus hermanos."
,"26":"Judas efectuó una expedición a Carnión y a Atargateión y masacró allí a veinticinco mil hombres."
,"27":"Después de haber hecho huir o destruido a sus enemigos, Judas organizó una expedición contra Efrón, ciudad fortificada donde vivía Lisias. Jóvenes vigorosos, puestos en fila al pie de las murallas, combatían con coraje y en el interior había numerosas máquinas con reservas de proyectiles."
,"28":"Pero, luego de haber implorado al Soberano que rompe con su poder la fuerza de los enemigos, los judíos se apoderaron de la ciudad y dejaron en tierra a más o menos veinticinco mil hombres de los que allí había."
,"29":"Saliendo de allí, se dirigieron a Escitópolis, a unos cien kilómetros de Jerusalén."
,"30":"Los judíos que residían allí les declararon que la gente de Escitópolis se había portado bien con ellos y se había preocupado de ellos en los días de desgracia."
,"31":"Judas y sus hombres se lo agradecieron a los habitantes de Escitópolis y los comprometieron a que continuaran con su buena disposición hacia los de su raza. Después de eso regresaron a Jerusalén poco antes de la fiesta de las Semanas."
,"32":"Después de esa fiesta, llamada de Pentecostés, se lanzaron contra Gorgias, general de la Idumea."
,"33":"Ese Gorgias avanzaba con tres mil soldados de infantería y cuatro cientos de caballería."
,"34":"Luego de iniciarse la batalla, cayeron algunos judíos."
,"35":"Un vigoroso jinete de la tropa de Baquenor, llamado Dositeo, atrapó a Gorgias en persona por su capa; lo tiraba con fuerza porque quería capturar vivo a ese hombre maldito, pero un jinete tracio se lanzó sobre Dositeo y le partió el hombro, lo que permitió a Gorgias huir a Marisa."
,"36":"Como el combate se prolongaba, los hombres de Esdrias comenzaron a rendirse de fatiga. Entonces Judas pidió al Señor que se mostrara en el combate como su aliado y su guía."
,"37":"En alta voz, en la lengua de sus padres, lanzó el grito de guerra y entonó himnos, luego cayó de improviso sobre los hombres de Gorgias y los hizo huir."
,"38":"Judas condujo su ejército hasta la ciudad de Odolam. Cuando llegó el séptimo día de la semana, se purificaron según la costumbre y celebraron el sábado en ese lugar."
,"39":"Al día siguiente, no se podía esperar más para levantar los cadáveres de los que habían caído en el combate, y los hombres de Judas fueron a sepultarlos con sus parientes en las tumbas de sus padres;"
,"40":"y se encontraron con que bajo las túnicas de cada muerto había idolitos de Jamnia, lo que está prohibidos a los judíos por la Ley. Todos, pues, comprendieron que este era el motivo por el que esos hombres habían sucumbido."
,"41":"Entonces bendijeron el comportamiento del Señor, justo Juez, que saca a la luz las cosas ocultas,"
,"42":"y le pidieron que el pecado cometido fuera completamente borrado. El heroico Judas animó a la asamblea a que se abstuviera de cualquier pecado, pues acababan de ver con sus propios ojos lo que había ocurrido a sus compañeros, caídos a causa de sus pecados."
,"43":"Luego efectuó una colecta que le permitió mandar a Jerusalén unas dos mil monedas de plata para que se ofreciese allí un sacrificio por el pecado. Era un gesto muy bello y muy noble, motivado por el convencimiento de la resurrección. "
,"44":"Porque si no hubiera creído que los que habían caído resucitarían, habría sido inútil y ridículo orar por los muertos."
,"45":"Pero él presumía que una hermosa recompensa espera a los creyentes que se acuestan en la muerte, de ahí que su inquietud fuera santa y de acuerdo con la fe. Mandó pues ofrecer ese sacrificio de expiación por los muertos para que quedaran libres de sus pecados."
}`)
	CurrentBook.AddChapter(13, `{
"1":"El año ciento cuarenta y nueve, Judas y sus hombres supieron que Antíoco Eupator avanzaba hacia Judea con un gran ejército."
,"2":"Iba acompañado por su tutor Lisias, administrador del reino. Cada uno tenía un ejército griego de ciento diez mil soldados de infantería, cinco mil trescientos de caballería, veintidós elefantes y trescientos carros armados de cuchillas."
,"3":"Se les había juntado Menelao, quien con gran astucia incitaba a Antíoco, no para salvar a su patria, sino con la esperanza de recuperar su cargo."
,"4":"Pero el Rey de Reyes despertó la ira de Antíoco contra ese malvado. Como Lisias hiciera ver al rey que Menelao era la causa de todos los males, Antíoco ordenó que lo llevaran a Berea para hacerlo morir según la costumbre del lugar."
,"5":"Hay allí una torre de veinticinco metros de alto, repleta de ceniza y provista de un mecanismo que da vueltas y que de todos los lados hace caer en la ceniza."
,"6":"Allí precipitan para darle muerte al que ha robado cosas sagradas o ha cometido algún crimen odioso."
,"7":"Esa muerte le tocó a Menelao, el impío; hasta la misma tierra se negaba a recibirlo."
,"8":"Justo castigo para el que había cometido muchos pecados contra el altar, cuyo fuego y cenizas son sagradas; en la ceniza encontró la muerte."
,"9":"Avanzaba pues el rey con bárbaras intenciones: quería que los judíos vieran cosas peores aún que las experimentadas bajo el reinado de su padre."
,"10":"Al saberlo Judas, ordenó al pueblo que invocara al Señor día y noche para que una vez más, tal como lo había hecho tantas otras veces, viniera en ayuda de aquellos a los que se quería privar de la Ley, de su patria y del Templo Santo."
,"11":"No podía abandonar al pueblo que acababa de recuperar la vida y dejarlo caer de nuevo en manos de paganos infames."
,"12":"Cuando todo el mundo terminó de orar al Señor lleno de misericordia con lágrimas, ayunos y postraciones continuas durante tres días, Judas les dirigió la palabra y les ordenó que estuviesen preparados."
,"13":"Luego se retiró con los ancianos y todos decidieron no esperar que el ejército del rey invadiera Judea y tomara Jerusalén, sino salir y, Dios mediante, buscar una decisión con las armas."
,"14":"Después de encomendar esta decisión al Creador del mundo, Judas animó a sus compañeros para que combatieran valientemente hasta la muerte, por las leyes, el Templo, la ciudad, la patria y las instituciones; luego instaló su campamento en los alrededores de Modín."
,"15":"Les dio a sus hombres esta contraseña: Y de noche atacó la tienda del rey con lo más selecto de los jóvenes. Mató en el campamento a más o menos dos mil hombres y traspasó al elefante que iba al frente junto con el que estaba en su torre."
,"16":"Sembró el terror y la confusión en el campamento y todos se retiraron después de un éxito total."
,"17":"Apenas comenzaba a clarear el día cuando ya todo estaba terminado, gracias a la constante protección del Señor en favor de Judas."
,"18":"El rey había podido apreciar el coraje de los judíos. Trató entonces de apoderarse de las plazas fuertes efectuando algunas maniobras."
,"19":"Atacó a Bet-Sur que era una plaza fuerte de los judíos, pero fue rechazado, puesto en jaque y vencido."
,"20":"Mientras tanto Judas pasaba a los sitiados todo lo que necesitaban."
,"21":"Rodocos, del ejército judío, entregaba los secretos a los enemigos; por lo cual hicieron una investigación, lo detuvieron y lo eliminaron."
,"22":"El rey volvió a tener contacto con la gente de Bet-Sur, hizo la paz con ellos y se retiró para atacar a los hombres de Judas, pero fue vencido."
,"23":"Supo entonces que Filipo, a quien había dejado en Antioquía para que gobernara el reino, se había rebelado. Quedó consternado. Pidió a los judíos una tregua y aceptó bajo juramento todas sus condiciones. Se reconcilió con ellos y ofreció un sacrificio, honró al Templo y trató con generosidad al Lugar Santo."
,"24":"Le brindó una buena acogida a Macabeo y dejó a Hegemónides como gobernador desde Tolemaida hasta el país de los Gerenios."
,"25":"Se dirigió luego a Tolemaida, cuyos habitantes estaban muy disgustados por aquel acuerdo, pues ellos mismos habían inspirado los decretos que se suprimían."
,"26":"Entonces subió al estrado Lisias para defenderlos. Convenció a la gente de Tolemaida, los calmó y los dejó bien dispuestos, luego se fue a Antioquía. Así fue como se desarrolló la ofensiva y retirada del rey."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Tres años después los partidarios de Judas oyeron hablar de Demetrio, hijo de Seleuco, que acababa de desembarcar en el puerto de Trípoli con un gran ejército y una flota."
,"2":"Se había apoderado del país y había dado muerte a Antíoco y a su tutor Lisias."
,"3":"Entonces apareció un tal Alcimo, que había desempeñado antes el cargo de sumo sacerdote y que se había vuelto impuro voluntariamente en tiempos de la revuelta. Comprendía que ya no tenía ningún futuro y que jamás recuperaría su lugar junto al santo altar."
,"4":"Por eso, el año ciento cincuenta y uno, fue a ver al rey Demetrio y le ofreció una corona de oro con una palma, y según la costumbre, además ramos de olivo en nombre del Templo. Ese día no hizo nada más."
,"5":"Pero su perversidad halló una buena ocasión cuando Demetrio lo convocó al Consejo y lo interrogó sobre las intenciones y los planes de los judíos. Respondió entonces: "
,"6":"«Un grupo judío, el de los Asideos, cuya dirección ha tomado Judas Macabeo, mantiene la guerra y la sedición. Ellos no permitirán que el reino encuentre su estabilidad."
,"7":"Por mi parte, me privaron del cargo que me venía de mis antepasados, hablo del soberano sacerdocio. Si he venido hasta aquí ahora,"
,"8":"ha sido, en primer lugar, con la sincera preocupación de los intereses del rey, pero también porque quiero el bien de mis conciudadanos. Porque toda mi raza experimenta una verdadera miseria por culpa de esos insensatos que acabo de nombrar."
,"9":"Infórmate en detalles, oh rey, y luego haz algo por nuestro país y por nuestra raza tan amenazada, con esa benevolente humanidad que muestras en todo."
,"10":"Porque mientras esté allá Judas, el estado no conocerá la paz»."
,"11":"En cuanto terminó de hablar, los demás amigos del rey, que detestaban también a Judas, hicieron todo lo posible para irritar aún más a Demetrio."
,"12":"Este designó inmediatamente a Nicanor, que había llegado a ser jefe de los elefantes, como general para la Judea."
,"13":"Lo mandó con la orden de hacer desaparecer a Judas, de dispersar a sus hombres y de restablecer a Alcimo como sumo sacerdote del Sublime Templo."
,"14":"Los paganos que habían huido de Judea por temor a Judas se fueron en masa con Nicanor, pensando que las miserias y desgracias de los judíos causarían su propia dicha."
,"15":"Cuando los judíos se enteraron de la venida de Nicanor y de la agresión de los paganos, se cubrieron de polvo para implorar al que había establecido a su pueblo para siempre y que, cada vez, ayudaba personalmente a los suyos con alguna manifestación."
,"16":"Luego dio el jefe sus órdenes y, caminando rápido, se trenzó en combate con el enemigo más arriba de Desau."
,"17":"Simón, hermano de Judas, atacó a Nicanor, pero sorprendido por la respuesta del enemigo, tuvo un pequeño revés."
,"18":"A Nicanor, sin embargo, le informaron de la bravura de Judas y de sus hombres, su coraje en los combates que sostenían por la patria, y temía tener que someterse a la decisión de una batalla."
,"19":"Por eso envió a Posidanio, Teodoto y Matatías para que tendieran la mano a los judíos."
,"20":"Examinaron cuidadosamente sus propuestas; el jefe se las comunicó a las tropas y como todos eran de la misma opinión, los acuerdos fueron aprobados."
,"21":"Se determinó un día en el cual se reunirían particularmente los jefes. Avanzó un carro de cada lado, y pusieron asientos de honor."
,"22":"Judas había ubicado en sitios estratégicos a hombres armados, preparados para todo, en caso de una traición repentina de parte de los enemigos; pero la entrevista se desarrolló correctamente."
,"23":"Nicanor se quedó en Jerusalén sin hacer nada malo, incluso despidió a la gente que se le había juntado."
,"24":"Como Judas estaba a su lado, sentía cada vez más inclinación por ese hombre."
,"25":"Le aconsejó que se casara y tuviera hijos; Judas se casó, disfrutó de la paz y llevó una vida normal."
,"26":"Alcimo se dio cuenta de esa mutua comprensión. Se consiguió entonces una copia del tratado que habían firmado. Se presentó a Demetrio y le dijo que Nicanor exponía los intereses del estado; entre otras cosas había designado como su lugarteniente a Judas, el enemigo del reino."
,"27":"Fuera de sí y excitado por las calumnias de ese miserable, el rey escribió a Nicanor para comunicarle su disgusto por esos acuerdos. Le ordenaba que mandara inmediatamente a Antioquía a Macabeo, cargado de cadenas."
,"28":"Cuando supo eso Nicanor, quedó consternado porque le costaba violar los acuerdos sin que Judas hubiera faltado en algo."
,"29":"Pero, como no podía chocar con el rey, buscó una ocasión favorable para cumplir esa orden."
,"30":"Macabeo, por su parte, se dio cuenta que Nicanor le daba un trato más reservado y se ponía más duro en las entrevistas acostumbradas, y comprendió que aquella conducta no anunciaba nada bueno. Llamó pues a su lado a un buen número de sus partidarios y no se dejó ver ya por Nicanor."
,"31":"Cuando Nicanor vio que sus planes habían sido frustrados de buena manera, fue al Templo tan grande y santo a la hora en que los sacerdotes ofrecen los sacrificios habituales y les ordenó que le entregaran a ese hombre."
,"32":"Los sacerdotes declararon con juramento que no sabían dónde se hallaba aquel que buscaban."
,"33":"Entonces extendió su mano derecha hacia el Templo y juró: no me entregan encadenado a Judas, arrasaré este lugar consagrado a Dios, demoleré el altar y en este mismo lugar construiré un templo magnífico en honor a Dionisio."
,"34":"Después de esas palabras se alejó. Los sacerdotes alzaron sus manos al Cielo, invocando al perpetuo Defensor de nuestra nación."
,"35":"«A ti, Señor del universo, que nada necesitas, te agradó tener entre nosotros un Templo donde moras."
,"36":"Ahora, pues, Señor, Santo de toda Santidad, mira a esta casa que acaba de ser purificada, y protégela para siempre de cualquier inmundicia»."
,"37":"Denunciaron ante Nicanor a un tal Razis, uno de los ancianos de Jerusalén. Era un hombre de muy buena fama que amaba a sus conciudadanos y al que llamaban, por su bondad, «el padre de los judíos»."
,"38":"En los primeros momentos de la rebelión había sido acusado de judaísmo y se había dedicado en cuerpo y alma, de mil maneras, a defender el judaísmo."
,"39":"Nicanor, queriendo dar pruebas de que les daba duro a los judíos, mandó a más de quinientos soldados para que lo detuvieran."
,"40":"Pues pensaba que deteniendo a ese hombre causaría un grave perjuicio a los judíos."
,"41":"Cuando ya los soldados ocupaban la torre y mandaban a buscar fuego para incendiar la puerta de entrada y forzarla, Razis, viéndose cercado, se traspasó con su espada;"
,"42":"prefería morir noblemente antes que caer en manos de esos bandidos y sufrir ultrajes indignos de su nobleza."
,"43":"Pero había actuado precipitadamente y no acertó el golpe. Así pues, cuando franqueaban ya su puerta, se subió valientemente a lo alto del muro y desde allí se lanzó sobre la turba."
,"44":"Al retroceder la gente, Razis cayó en medio de la plaza vacía."
,"45":"Respiraba aún; lleno de ardor se levantó chorreando sangre y cubierto de terribles heridas. Atravesó corriendo por medio de la turba y se paró en una roca"
,"46":"y allí, casi sin sangre, se sacó sus entrañas y tomándolas con sus dos manos se las tiró a la turba. Luego, después de pedir al dueño de la vida y del espíritu, que se los devolviera algún día, dejó esta vida."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Cuando Nicanor se enteró que Judas y sus hombres estaban por el lado de Samaría, se decidió a atacarlos sin riesgo un día sábado."
,"2":"Los judíos que lo seguían por obligación le dijeron: «No les des muerte de una manera tan salvaje y bárbara. Respeta ese día al que confirió excelencia y santidad Aquel que todo lo ve»."
,"3":"Entonces ese triple criminal preguntó si era soberano en el cielo el que ordenó celebrar el día sábado."
,"4":"Los judíos le respondieron: «El Señor vivo, el Soberano del cielo es quien ha ordenado celebrar el séptimo día»."
,"5":"Pero el otro declaró: «Muy bien, yo que soy soberano en la tierra, ordeno que tomen las armas y que obedezcan a la voluntad del rey». No pudo, sin embargo, realizar su sanguinario proyecto."
,"6":"Con mucha suficiencia y presunción, Nicanor había decidido hacer una exposición con los restos de Judas y de sus hombres."
,"7":"Macabeo, por su parte, no tenía menos confianza, pues contaba firmemente con la ayuda del Señor."
,"8":"Animó a sus hombres a que no temieran el ataque de los paganos; los invitaba a recordar las ayudas que les habían llegado del Cielo en el pasado, por lo cual debían estar seguros que el Todopoderoso les daría ahora la victoria."
,"9":"Les volvió a leer las palabras de la Ley y de los profetas y reanimó su entusiasmo trayéndoles a la memoria las victorias anteriores."
,"10":"Después de haber reavivado así su ardor, reafirmó sus palabras haciendo ver a sus hombres la deslealtad de los paganos y cómo habían violado su juramento."
,"11":"De ese modo cada uno de sus hombres quedó bien equipado, no con la seguridad que dan los escudos y las lanzas, sino con el vigor que aportan buenas palabras. Para terminar les contó un sueño digno de fe o, mejor dicho, una visión que los llenó de alegría."
,"12":"Esto fue lo que había visto: El sumo sacerdote Onías, que había sido un hombre recto, humilde y delicado en sus modales, distinguido en su lenguaje y dedicado a practicar la virtud desde su infancia, ese Onías pues, oraba con las manos alzadas al cielo por todo el pueblo judío."
,"13":"Luego había aparecido en la misma actitud un hombre que se distinguía por sus cabellos blancos y por su dignidad, revestido de una majestuosidad portentosa y prodigiosa."
,"14":"Onías tomó luego la palabra y dijo: «Ese hombre preocupado de sus hermanos es Jeremías, el profeta de Dios; él reza mucho por el pueblo y por la Ciudad Santa»."
,"15":"Jeremías había extendido entonces la mano derecha, le había entregado a Judas una espada de oro y al pasársela había pronunciado estas palabras:"
,"16":"«¡Toma esta espada santa que es un don de Dios! Con ella destrozarás a los enemigos»."
,"17":"Reanimados con esas hermosas palabras de Judas, capaces de estimular el coraje y de dar a los jóvenes un alma viril, decidieron no defender el campamento sino tomar valientemente la ofensiva. Querían obtener una decisión lanzándose a la batalla con toda valentía por la ciudad, el Lugar Santo y el Templo que estaban en peligro."
,"18":"Su preocupación por sus mujeres y sus hijos, por sus hermanos y sus padres pasaba a un segundo plano; su principal y mayor aprehensión era por el Santuario sagrado."
,"19":"En cuanto a aquellos que se habían quedado en la ciudad, su ansiedad no era pequeña, pues temían por el resultado de ese enfrentamiento en descampado."
,"20":"Todos esperaban el próximo desenlace. Los enemigos estaban reunidos y ordenados en filas para la batalla; habían colocado a los elefantes en la mejor ubicación y la caballería estaba por los costados."
,"21":"Macabeo vio delante de sí a esa muchedumbre, la variedad de sus armas y el terrible aspecto de sus elefantes. Entonces alzó sus manos al Cielo e invocó al Señor que realiza prodigios, pues sabía muy bien que no son las armas, sino su voluntad, la que consigue la victoria a los que son dignos."
,"22":"Pronunció esta oración: «Tú, Soberano, enviaste a tu ángel en tiempos de Ezequías, rey de Judá, e hizo perecer a más de ciento ochenta y cinco mil hombres en el ejército de Senaquerib."
,"23":"Ahora, pues, Soberano de los Cielos, envía a tu buen ángel delante de nosotros para que siembre el pánico y el terror."
,"24":"¡Que tus poderosos golpes dejen aterrorizados a los que atacan a tu pueblo santo profiriendo blasfemias!». Así acabó su oración."
,"25":"La gente de Nicanor avanzó al son de trompetas y cuernos;"
,"26":"Judas y sus hombres, por su parte, entraron al combate con invocaciones y plegarias."
,"27":"Combatían con sus manos, pero con todo su corazón oraban a Dios; entusiasmados por la manifestación de Dios, derribaron a no menos de treinta y cinco mil hombres."
,"28":"Cuando terminó la batalla y volvían todos felices, reconocieron a Nicanor que estaba caído con su armadura."
,"29":"En medio de los gritos y de la confusión general, bendijeron al Soberano en la lengua de sus padres."
,"30":"Entonces, aquel que había combatido en primera fila por sus conciudadanos con todo su corazón y con todas sus fuerzas, aquel que había entregado a su nación los buenos sentimientos de su juventud, ordenó que cortaran la cabeza de Nicanor y su brazo hasta el hombro y que los llevaran a Jerusalén."
,"31":"Cuando llegó allá, reunió a todo el pueblo, puso a los sacerdotes delante del altar y mandó avisar a los hombres de la ciudadela."
,"32":"Les mostró la cabeza del infame Nicanor y la mano que ese blasfemo había alzado con orgullo contra el Santo Templo del Todopoderoso."
,"33":"En seguida, después de haber cercenado la lengua del impío Nicanor, ordenó que se la dieran en pedacitos a los pájaros y que colgaran frente al Templo el brazo que había extendido en un gesto insensato."
,"34":"Todos hicieron subir al Cielo una alabanza al Señor que acababa de manifestarse: «Bendito sea, decían, El que no dejó que profanaran su Lugar santo»."
,"35":"Judas mandó colgar en la ciudadela la cabeza de Nicanor como una prueba evidente para todos de la ayuda del Señor."
,"36":"Todos decidieron por un voto público no dejar pasar ese día sin conmemorarlo; se lo celebraría el día trece del duodécimo mes, que en arameo se llama el mes de Adar, la víspera del día llamado de Mardoqueo."
,"37":"Así fue como sucedieron los acontecimientos relativos a Nicanor. Como a partir de entonces la ciudad ha permanecido en manos de los hebreos, yo suspenderé aquí mi relato."
,"38":"Si la composición ha sido buena y acertada, eso era lo que quería. Si ha sido pobre y mediocre, era todo lo que pude hacer."
,"39":"Así como no es bueno tomar vino solo o agua pura, siendo que el vino mezclado con agua es agradable y da mucho gusto, así también la bella disposición del relato encanta a los oídos de los que leen la obra. Aquí pongo punto final."
}`)

}
func ES_LBL_LoadVH2PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Salomón, hijo de David, se afirmó en su reino; Yavé, su Dios, estaba con él y lo engrandeció sobremanera."
,"2":"Salomón reunió a todo Israel, a los jefes de mil y de cien, a los jueces, a los príncipes de todo Israel, a los jefes de las casas paternas;"
,"3":"luego se fue con toda la asamblea al Santuario de Loma de Gabaón, donde estaba la Tienda de las Citas Divinas, que Moisés, siervo de Yavé, había hecho en el desierto."
,"4":"Pero el Arca de Dios había sido trasladada por David de Cariatiarim al lugar que él le había preparado, pues había alzado para ella una tienda en Jerusalén."
,"5":"El altar de bronce que había hecho Betsaleel, hijo de Urí, hijo de Jur, estaba allí ante la Morada de Yavé en que Salomón y la asamblea vinieron a adorar a Yavé."
,"6":"Salomón sacrificó allí en el altar de bronce que estaba ante la Tienda de las Citas, ofreciendo mil holocaustos a Yavé."
,"7":"Durante la noche se apareció Yavé a Salomón y le dijo: 'Pide lo que quieras que te dé',"
,"8":"y Salomón respondió a Yavé: 'Tú hiciste con David, mi padre, gran misericordia, y a mí me has hecho reinar en su lugar."
,"9":"Ahora, pues, ¡oh Yavé!, se cumple tu promesa a David, mi padre, ya que me has hecho rey de un pueblo numeroso como el polvo de la tierra."
,"10":"Dame, pues, la sabiduría y el entendimiento para que pueda conducir a este pueblo, porque ¿quién podrá gobernar a este gran pueblo?'"
,"11":"Yavé dijo a Salomón: 'Ya que éste es tu deseo y no has pedido riquezas ni bienes, ni gloria ni la muerte de tus enemigos, ni tampoco has pedido larga vida, sino que me has pedido la sabiduría y el entendimiento para gobernar a mi pueblo, del cual te he hecho rey,"
,"12":"por eso desde ahora te doy sabiduría y entendimiento, y además te daré riquezas, bienes y gloria como no las tuvieron nunca los reyes que fueron antes de ti, ni las tendrá ninguno de los que vengan después de ti.'"
,"13":"Salomón dejó el Santuario de Gabaón, y volvió a Jerusalén lejos de la Tienda de las Citas y reinó sobre Israel."
,"14":"Salomón juntó carros y caballerías; tuvo mil cuatrocientos carros, doce mil caballos, que distribuyó entre las ciudades donde tenía los carros, y en Jerusalén, cerca del rey."
,"15":"El rey hizo que la plata y el oro fueran abundantes en Jerusalén como las piedras, y los cedros como los sicómoros en la Tierra Baja."
,"16":"Los caballos de Salomón procedían de Cilicia; los mercaderes del rey los adquirían en Cilicia por su precio en dinero."
,"17":"Traían de allí un carro por seiscientos siclos de plata, y un caballo por ciento cincuenta. Los traían también como intermediarios para todos los reyes de los heteos y todos los reyes de Aram."
,"18":"Decidió, pues, Salomón edificar una Casa al nombre de Yavé y otra para sí."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Salomón alistó setenta mil hombres para transportar cargas, ochenta mil canteros en el monte y tres mil seiscientos capataces para ellos."
,"2":"Salomón mandó a decir a Hiram, rey de Tiro: 'Haz conmigo como hiciste con mi padre David, enviándole maderas de cedro para que se construyera una casa en que vivir."
,"3":"Te hago saber que voy a edificar una Casa al nombre de Yavé, mi Dios, para consagrársela, para quemar ante él incienso aromático, para la ofrenda perpetua de los panes presentados, y para los holocaustos de la mañana y de la tarde, de los sábados, lunas nuevas, solemnidades de Yavé, nuestro Dios, como se hace siempre en Israel."
,"4":"La Casa que voy a edificar será grande, porque nuestro Dios es mayor que todos los dioses."
,"5":"Pero ¿quién será capaz de construirle una Casa, cuando los cielos y los Cielos de los cielos no pueden contenerlo? ¿Y por qué le edificaría yo una Casa, sino solamente para quemar incienso en su presencia?"
,"6":"Mándame, pues, un hombre hábil en trabajar el oro, la plata, el bronce, el hierro, la púrpura escarlata, el carmesí y la púrpura violeta, y que sepa grabar; estará con los artesanos que tengo conmigo en Judá y en Jerusalén, y que mi padre David ya puso a mi disposición."
,"7":"Envíame también madera de cedro, de ciprés y de sándalo, pues yo sé que tus siervos entienden de cortar los árboles del Líbano;"
,"8":"y los míos trabajarán con los tuyos para preparar la gran cantidad de madera, pues la casa que yo deseo construir ha de ser grande y magnífica."
,"9":"Yo daré a tus siervos que se ocupen de cortar y derribar los árboles veinte mil cargas de trigo y otras tantas de cebada, veinte mil medidas de vino y veinte mil medidas de aceite: todo esto para su mantenimiento.'"
,"10":"Hiram, rey de Tiro, respondió en una carta que dirigió a Salomón: 'Porque ama Yavé a su pueblo, te ha hecho rey de él.'"
,"11":"Y decía también: 'Bendito Yavé, Dios de Israel, que ha hecho los cielos y la tierra y ha dado al rey David un hijo sabio, entendido y prudente, digno de edificar la Casa de Yavé y la Casa real."
,"12":"Yo, pues, te mando un hombre hábil y entendido, a Hiram-Abi,"
,"13":"hijo de una mujer de la tribu de Dan y de padre tirio, que sabe trabajar el oro, la plata, el bronce, el hierro, la piedra, la madera, la púrpura, el jacinto, el lino y la escarlata, y grabar toda clase de figuras; es capaz de realizar cualquier cosa que le pidas. El trabajará con sus obreros y con los de David, mi señor, tu padre. "
,"14":"Manda tú, pues, mi señor, a tus siervos el trigo y la cebada, el aceite y el vino que has ofrecido."
,"15":"Nosotros cortaremos en el Líbano toda la madera que necesites, y la pondremos en balsas, para llevarla por mar hasta Jope; luego la llevarás de allí a Jerusalén.'"
,"16":"Salomón hizo la cuenta de todos los extranjeros que había en la tierra de Israel, según el censo hecho por David, su padre; y se halló que eran ciento cincuenta y tres mil seiscientos."
,"17":"De ellos destinó setenta mil para el transporte de cargas, ochenta mil para las canteras en las montañas y tres mil seiscientos como capataces para hacer trabajar al pueblo."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Salomón comenzó, pues, a edificar la Casa de Yavé en Jerusalén, en el monte Moria, donde Dios se había manifestado a su padre David. Era el lugar preparado por David, la era de Ornán el jebuseo."
,"2":"Dio comienzo a las obras el día dos del segundo mes del año cuarto de su reinado."
,"3":"La Casa de Dios que Salomón edificó tenía sesenta codos de longitud, en codos de medida antigua; y veinte codos de anchura."
,"4":"El vestíbulo que estaba delante tenía una longitud de veinte codos, correspondientes al ancho de la casa, y una altura de ciento veinte. Salomón lo recubrió por dentro de oro puro."
,"5":"Revistió la sala grande de madera de ciprés y la recubrió de oro fino, haciendo esculpir en ella palmas y cadenillas."
,"6":"Para adornar la Casa la revistió también de piedras preciosas; el oro era oro de Parvaim."
,"7":"Recubrió de oro la Casa, las vigas, los umbrales, sus paredes y sus puertas, y esculpió querubines sobre las paredes."
,"8":"Construyó también la sala del Lugar Santísimo, cuya longitud, correspondiente al ancho de la Casa, era de veinte codos y su anchura igualmente de veinte codos. Lo revistió de oro puro, por seiscientos talentos."
,"9":"Los clavos de oro pesaban cincuenta siclos. Cubrió también de oro las salas altas."
,"10":"En el interior de la sala del Lugar Santísimo hizo los querubines de metal forjado, que revistió de oro."
,"11":"Las alas de los querubines se extendían por todo el largo, es decir, veinte codos. Cada ala tenía cinco codos; una tocaba la pared de la sala; la otra tocaba el ala del otro querubín."
,"12":"El ala del segundo querubín era de cinco codos y tocaba la pared de la sala; la otra ala tenía también cinco codos y estaba pegada con el ala del primer querubín."
,"13":"Las alas desplegadas de estos querubines medían veinte codos. Estaban de pie, y con sus caras vueltas hacia la Casa."
,"14":"Hizo también la cortina de púrpura violeta, púrpura escarlata, carmesí y lino fino, y en ella hizo poner querubines."
,"15":"Delante de la sala hizo dos columnas de treinta y cinco codos de alto. El capitel que las coronaba tenía cinco codos."
,"16":"Hizo cadenillas y las colocó sobre los remates de las columnas, hizo también cien granadas, que puso en las cadenillas."
,"17":"Alzó las columnas delante del Lugar Santo, una a la derecha y otra a la izquierda, llamó a la de la derecha Yakim y a la de la izquierda Boaz."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Construyó también un altar de bronce de veinte codos de largo, veinte codos de ancho y diez codos de alto."
,"2":"Hizo una gran pileta de metal fundido, llamado el mar, de diez codos de borde a borde, enteramente redondo y de cinco codos de alto. Un cordón de treinta codos medía su contorno."
,"3":"Debajo del borde había en todo el contorno unas como figuras de granadas, diez por cada lado, colocadas en dos órdenes, fundidas en una sola masa."
,"4":"Se apoyaba sobre doce bueyes; tres mirando al norte, tres mirando al oeste, tres mirando al sur y tres mirando al este. El mar estaba sobre ellos, quedando sus partes traseras hacia el interior. "
,"5":"El espesor de este vaso era de un palmo y su borde era como el de una copa, o como el de un lirio abierto: hacía tres mil medidas."
,"6":"Hizo diez pilas, que dispuso cinco a la derecha y cinco a la izquierda, para hacer en ellas las purificaciones. En ellas se lavaban las víctimas del holocausto mientras el mar servía para las purificaciones de los sacerdotes."
,"7":"Hizo candelabros de oro según la forma ordenada, y los colocó en el Lugar Santo, cinco a la derecha y cinco a la izquierda."
,"8":"Hizo también cien tazas de oro."
,"9":"Construyó también el patio de los sacerdotes y el patio grande con sus puertas, revistiendo las puertas de bronce."
,"10":"Colocó el mar al lado derecho, hacia el sureste."
,"11":"Hiram hizo también las ollas, las paletas y las tazas."
,"12":"Así acabó la obra que le había encargado el rey Salomón en la Casa de Dios: las dos columnas; las molduras de los capiteles que coronaban las columnas; los dos trenzados para cubrir las dos molduras de los capiteles que estaban sobre las columnas;"
,"13":"las cuatrocientas granadas de los dos trenzados, dos filas de granadas para cada trenzado;"
,"14":"las diez basas y las diez pilas sobre las basas;"
,"15":"el mar con los doce bueyes debajo de él, las ollas, las paletas y las tazas."
,"16":"Todos los utensilios que hizo Hiram-Abi para el rey Salomón, para la Casa de Yavé, eran de bronce bruñido."
,"17":"El rey los hizo fundir en la vega del Jordán, al vado de Adma, entre Surot y Sereda."
,"18":"Salomón fabricó todos estos utensilios en tan gran cantidad que no se pudo calcular el peso del bronce."
,"19":"Salomón hizo todos los objetos destinados a la Casa de Dios: el altar de oro, las mesas para los panes de la Ofrenda,"
,"20":"los candelabros con sus lámparas de oro fino que ardieran según el rito, delante del Lugar Santísimo;"
,"21":"las flores, las lámparas y las tijeras para cortar las mechas, todo de oro puro."
,"22":"Igualmente los cuchillos, las copas, las tazas y los incensarios, de oro puro. Eran también de oro los goznes de las puertas interiores de la Casa hacia el Lugar Santísimo, y de las puertas de la Casa hacia el Lugar Santo."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Así fue concluida toda la obra que hizo Salomón para la Casa de Yavé. Salomón hizo traer todo lo que había sido consagrado por su padre David, la plata, el oro y todos los objetos, y lo puso en los tesoros de la Casa de Dios."
,"2":"Entonces congregó Salomón en Jerusalén a todos los jefes de Israel, a todos los jefes de las tribus y a los principales de las casas paternas de los hijos de Israel, para hacer subir el Arca de la Alianza de Yavé desde la ciudad de David, que es Sión."
,"3":"Se reunieron junto al rey todos los hombres de Israel, en la fiesta del mes séptimo."
,"4":"Cuando llegaron todos los jefes de Israel, los levitas alzaron el Arca"
,"5":"y la llevaron junto a la Tienda de las Citas y todos los utensilios sagrados que había en la Tienda; los llevaron los sacerdotes y los levitas."
,"6":"El rey Salomón, con toda la comunidad de Israel que se había reunido en torno a él, ante el Arca, sacrificaron ovejas y bueyes sin número; no se pudo contar la muchedumbre de las víctimas."
,"7":"Los sacerdotes introdujeron el Arca de la Alianza de Yavé a su lugar, al Santuario de la Casa, al Lugar Santísimo, bajo las alas de los querubines."
,"8":"Pues los querubines extendían las alas por encima del Arca, cubriendo el Arca y sus varas por encima."
,"9":"Las varas eran tan largas que se veían sus puntas desde el Lugar Santo, desde la parte anterior al Lugar Santísimo, pero no se veían desde fuera; y allí están hasta el día de hoy."
,"10":"En el Arca había solamente las dos tablas que Moisés puso en ella, en el Horeb, cuando Yavé hizo alianza con los hijos de Israel a su salida de Egipto."
,"11":"Cuando los sacerdotes salieron del santuario (porque todos los sacerdotes que se hallaban presentes se habían santificado, sin hacer distinciones de clases,"
,"12":"mientras que todos los levitas cantores, Asaf, Hemán y Jedutún con sus hijos y hermanos, vestidos de lino fino, estaban de pie al oriente del altar tocando címbalos, salterios y cítaras y con ellos ciento veinte sacerdotes que tocaban las trompetas);"
,"13":"cuando, pues, se oyeron al mismo tiempo y al unísono los que tocaban las trompetas y los cantores, alabando y celebrando a Yavé; cuando alzaron la voz con las trompetas y con los címbalos y otros instrumentos de música para alabar a Yavé diciendo: 'Porque es bueno, porque es eterno su amor',"
,"14":"en ese momento la Casa se llenó de la nube de la Gloria de Yavé y los sacerdotes no pudieron continuar en su servicio a causa de la nube, porque la Gloria de Yavé llenaba la Casa de Dios."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Entonces dijo Salomón: 'Yavé ha dicho que habita en una espesa nube."
,"2":"Yo te he edificado una Casa, un lugar donde habites para siempre.'"
,"3":"Se volvió el rey y bendijo a la asamblea de Israel, mientras todos estaban en pie. Dijo:"
,"4":"'Bendito sea Yavé, Dios de Israel, que habló por boca de mi padre David, y ha cumplido por su mano lo que dijo:"
,"5":"Desde que saqué a mi pueblo de la tierra de Egipto, no he elegido ninguna ciudad entre todas las tribus de Israel, para edificar una Casa en la que esté mi nombre; ni elegí varón que estuviera al frente de mi pueblo Israel,"
,"6":"sino que he elegido a Jerusalén, para que esté allí mi Nombre, y elegí a David, para que esté al frente de mi pueblo Israel."
,"7":"Mi padre David se preocupó por edificar una Casa para el Nombre de Yavé, Dios de Israel."
,"8":"Pero Yavé dijo a mi padre David: Has hecho bien en preocuparte por edificar una Casa a mi Nombre."
,"9":"Pero no edificarás tú la Casa, sino un hijo tuyo, nacido de tu sangre."
,"10":"Yavé ha cumplido la promesa que dijo; he sucedido a mi padre David, me he sentado en el trono de Israel, como Yavé había dicho, y he construido la Casa para el Nombre de Yavé, Dios de Israel."
,"11":"Allí he puesto el Arca, en la cual está la alianza de Yavé, el que pactó su alianza con los hijos de Israel.'"
,"12":"Salomón se puso ante el altar de Yavé en presencia de toda la asamblea de Israel y extendió las manos."
,"13":"Salomón había hecho un estrado de bronce de cinco codos de largo, cinco codos de ancho y tres codos de alto, que había colocado en medio del patio; poniéndose sobre él se arrodilló frente a toda la asamblea de Israel. Y extendiendo sus manos hacia el cielo dijo:"
,"14":"'Yavé, Dios de Israel, no hay Dios como tú en el cielo ni en la tierra; tú que guardas tu alianza y tu amor a tus siervos que te sirven con todo su corazón;"
,"15":"tú que has cumplido a favor de mi padre David la promesa que le hiciste, pues por tu boca lo prometiste, y con tu mano lo has cumplido este día."
,"16":"Ahora, pues, Yavé, Dios de Israel, cumple a favor de tu siervo David, mi padre, la promesa que le hiciste cuando dijiste: Nunca será quitado de mi presencia el de los tuyos que te suceda sentado en el trono de Israel, con tal de que tus hijos sigan tu camino y anden en mi Ley, como tú has andado delante de mí."
,"17":"Ahora, Yavé, Dios de Israel, que se cumpla la palabra que dijiste a tu siervo David."
,"18":"Pero ¿es que verdaderamente habitará Dios con los hombres sobre la tierra? Si los cielos y los Cielos de los cielos no pueden contenerte, ¡cuánto menos esta casa que yo te he construido!"
,"19":"Atiende a la plegaria de tu siervo y a su petición, Yavé, Dios mío; escucha el clamor y la plegaria que tu siervo hace en tu presencia."
,"20":"Que tus ojos estén abiertos día y noche sobre esta Casa, sobre este lugar del que dijiste que pondrías en él tu Nombre. ¡Escucha la oración que te dirige tu siervo en este lugar!"
,"21":"Oye, pues, las plegarias de tu siervo y las de Israel, tu pueblo, cuando recen en este lugar. Escucha tú desde el lugar de tu morada, desde los cielos; escucha y perdona."
,"22":"Cuando un hombre peque contra su prójimo, y éste pronuncie una imprecación sobre él, haciéndolo jurar delante de tu altar en esta casa,"
,"23":"escucha tú desde los cielos y obra; juzga a tus siervos y castiga al culpable, haciendo recaer su conducta sobre su cabeza y declarando inocente al justo, dándole según lo que merece."
,"24":"Si Israel, tu pueblo, es vencido por el enemigo por haber pecado contra ti, pero se vuelven ellos y alaban tu nombre, rezando y suplicando ante ti en esta Casa,"
,"25":"escucha tú desde los cielos, perdona el pecado de tu pueblo Israel, y vuélvelos a la tierra que les diste a ellos y a sus padres."
,"26":"Cuando los cielos estén cerrados y no haya lluvia porque pecaron contra ti, si rezan en este lugar y alaban tu nombre, y se convierten de su pecado porque los humillaste,"
,"27":"escucha tú desde los cielos y perdona el pecado de tus siervos y de tu pueblo Israel (pues les enseñarás el camino bueno por el que deben andar) y manda lluvia sobre tu tierra, la que diste a tu pueblo por herencia."
,"28":"Cuando haya hambre en esta tierra, cuando haya peste, tizón, plaga en los árboles frutales, langostas, o pulgón, cuando su enemigo lo tenga bloqueado en una de sus ciudades, en todo azote y toda enfermedad;"
,"29":"si un hombre cualquiera, o todo Israel, tu pueblo, hace oraciones y súplicas, y reconociendo su plaga y su dolor, tiende sus manos hacia esta Casa,"
,"30":"escucha tú desde los cielos, lugar de tu morada, y perdona, dando a cada uno según sus caminos, pues tú conoces su corazón, y sólo tú conoces el corazón de todos los hijos de los hombres,"
,"31":"para que te teman, caminando en tus caminos todos los días que vivan en la tierra que has dado a nuestros padres."
,"32":"También al extranjero que no es de tu pueblo Israel, el que viene de un país lejano a causa de tu gran nombre, tu mano fuerte y tu brazo fuerte, cuando venga a rezar en esta Casa,"
,"33":"escucha tú desde los cielos, lugar de tu morada, y haz cuanto te pida el extranjero, para que todos los pueblos de la tierra conozcan tu nombre y te teman como tu pueblo Israel, y sepan que tu nombre es invocado sobre esta Casa que yo he construido."
,"34":"Si tu pueblo va a la guerra contra tus enemigos por el camino que tú le envías, si rezan a ti, vueltos hacia esta ciudad que tú has elegido, y hacia la Casa que yo he construido a tu nombre,"
,"35":"escucha tú desde los cielos su oración y su plegaria y hazles justicia."
,"36":"Cuando pequen contra ti, pues no hay hombre que no peque, y tú, irritado contra ellos, los entregues al enemigo, y sus conquistadores los lleven cautivos a un país lejano o cercano,"
,"37":"si se convierten en la tierra a que hayan sido llevados, si se arrepienten y te suplican en la tierra de su destierro, diciendo: Hemos pecado, hemos sido perversos, somos culpables;"
,"38":"si se vuelven a ti con todo su corazón y con toda su alma en el país de su destierro al que fueron deportados, y te suplican vueltos hacia la tierra que tú diste a sus padres y hacia la ciudad que tú has elegido y hacia la Casa que yo he edificado a tu nombre,"
,"39":"escucha tú desde los cielos, lugar de tu morada, su oración y su plegaria; hazles justicia y perdona a tu pueblo los pecados que cometieron contra ti."
,"40":"Que tus ojos, Dios mío, estén abiertos, y tus oídos atentos a la oración que se haga en este lugar."
,"41":"Y ahora: ¡levántate, Yavé Dios, hacia tu reposo, tú y el Arca de tu fuerza! ¡Que tus sacerdotes, Yavé Dios, se revistan de tu fuerza salvadora y tus fieles gocen de la felicidad!"
,"42":"Yavé, Dios mío, no rechaces el rostro de tu Ungido; acuérdate de tus favores a David, tu siervo.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Cuando Salomón acabó de rezar, bajó fuego del cielo que devoró el holocausto y los sacrificios mientras la Gloria de Yavé llenó la Casa."
,"2":"Los sacerdotes no podían entrar en la Casa de Yavé, porque su Gloria la llenaba."
,"3":"Entonces todos los hijos de Israel, viendo descender el fuego y la Gloria de Yavé sobre la Casa, se postraron sobre el pavimento, adoraron y alabaron a Yavé: 'Porque es bueno, porque es eterno su amor.'"
,"4":"Luego el rey y todo el pueblo ofrecieron sacrificios ante Yavé."
,"5":"El rey Salomón ofreció en sacrificio veintidós mil bueyes y ciento veinte mil ovejas. Ese día el rey y todo el pueblo inauguraron la Casa de Dios. "
,"6":"Los sacerdotes estaban de pie en sus puestos, lo mismo que los levitas, con los instrumentos que el rey David hizo para celebrar a Yavé, 'porque es eterno su amor'. Por medio de sus manos, Salomón celebraba a Yavé en tanto que los sacerdotes estaban delante de ellos tocando las trompetas, y todo Israel se mantenía de pie."
,"7":"Salomón consagró el interior del patio que está delante de la Casa de Yavé. Allí ofreció los holocaustos y las grasas de los sacrificios de comunión, ya que el altar de bronce que había hecho Salomón no podía contener los holocaustos, las ofrendas y las grasas."
,"8":"Entonces Salomón celebró la fiesta durante siete días y con él todo Israel. Era una asamblea inmensa venida desde la Entrada de Jamat hasta el Torrente de Egipto."
,"9":"El día octavo finalizó la fiesta, pues habían celebrado la fiesta de la inauguración del altar durante siete días."
,"10":"El día veintitrés del mes séptimo, Salomón mandó al pueblo a sus tierras alegre y contento por el bien que Yavé había hecho a David, a Salomón y a su pueblo Israel."
,"11":"Salomón acabó la Casa de Yavé y la casa del rey, y llevó a cabo cuanto se había propuesto hacer en la Casa de Yavé y en su propia casa."
,"12":"Entonces Yavé se le apareció a Salomón por la noche y le dijo: 'He oído tu oración y me he elegido este lugar como Casa en que me ofrezcan sacrificios."
,"13":"Si yo cierro el cielo para que no llueva, si yo mando a la langosta devorar la tierra, o envío la peste contra mi pueblo;"
,"14":"y mi pueblo, sobre el cual es invocado mi Nombre, se humilla, rezando y buscando mi rostro, y se vuelven de sus malos caminos, yo entonces los oiré desde los cielos, perdonaré su pecado y sanaré su tierra."
,"15":"Mis ojos estarán abiertos y mis oídos atentos a la oración que se haga en este lugar;"
,"16":"pues ahora he escogido y santificado esta Casa, para que en ella permanezca mi Nombre para siempre. Allí estarán mis ojos y mi corazón todos los días."
,"17":"Y en cuanto a ti, si me sirves como me sirvió tu padre David, y haces todo lo que te he mandado guardando mis decretos y mis sentencias,"
,"18":"afianzaré tu trono, como prometí a tu padre David: A ninguno de tus descendientes quitaré el mando de Israel."
,"19":"Pero si se apartan, abandonando los decretos y los mandamientos que les he dado, y van a servir a otros dioses, postrándose ante ellos,"
,"20":"los arrancaré de mi tierra que les he dado; arrojaré de mi presencia esta Casa que yo he consagrado a mi Nombre y haré que todos los pueblos se burlen de ella."
,"21":"Y esta casa tan sublime vendrá a ser el espanto de todos los que pasen cerca, de modo que dirán: '¿Por qué Yavé ha tratado así a este país y a esta Casa?'"
,"22":"Y se responderá: 'Porque abandonaron a Yavé, el Dios de sus padres, que los sacó de la tierra de Egipto, y han seguido a otros dioses, se han postrado ante ellos y les han servido; por eso ha traído sobre ellos todo este mal.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Al cabo de los veinte años que empleó Salomón en edificar la Casa de Yavé y su propia casa,"
,"2":"reconstruyó las ciudades que Hiram le había dado y estableció allí a los hijos de Israel."
,"3":"Salomón marchó contra Jamat de Sobá y se apoderó de ella;"
,"4":"reedificó Tadmor en el desierto, y todas las ciudades de almacenamiento que había edificado cerca de Jamat."
,"5":"Edificó Betorón, el alto y el bajo, ciudades fuertes, amuralladas, con puertas y barras,"
,"6":"Balat y todas las ciudades de almacenamiento que le pertenecían y las ciudades de los carros y de la caballería, y todo lo que quiso edificar en Jerusalén, en el Líbano y en todo el país de su dominio."
,"7":"Todo el pueblo que había quedado de los heteos, amorreos, fereceos, jeveos y jebuseos, que no eran parte de Israel,"
,"8":"cuyos descendientes habían quedado después de ellos en el país y a los que los israelitas no habían exterminado, Salomón los sometió a servidumbre que dura hasta el día de hoy."
,"9":"Pero no empleó a ninguno de los hijos de Israel como esclavo para sus obras, sino como hombres de guerra, jefes y escuderos, comandantes de sus carros y de sus caballos."
,"10":"Los jefes nombrados por los intendentes del rey Salomón eran doscientos cincuenta que dirigían al pueblo."
,"11":"Salomón hizo subir a la hija de faraón desde la ciudad de David a la casa que había edificado para ella; pues se decía: 'No puedo dejar a una mujer en la casa de David, rey de Israel; porque los lugares donde ha estado el Arca de Yavé son sagrados.'"
,"12":"Entonces Salomón ofrecía sacrificios a Yavé sobre el altar de Yavé que había levantado delante del vestíbulo de la Casa;"
,"13":"los ofrecía según el rito de cada día, conforme a lo ordenado por Moisés; lo mismo en los sábados, las lunas nuevas y las solemnidades, tres veces al año; en la fiesta de los Azimos, en la fiesta de las Semanas y en la fiesta de las Tiendas."
,"14":"Estableció también las secciones de los sacerdotes en su servicio conforme al reglamento de su padre David; estableció a los levitas en sus cargos de alabar y servir junto a los sacerdotes según el rito de cada día; y a los porteros con arreglo a sus secciones, en cada puerta, porque ésta era la orden de David, hombre de Dios."
,"15":"No se apartaron en nada de la orden del rey en lo tocante a los sacerdotes y los levitas, ni tampoco en lo relativo a los tesoros."
,"16":"Así fue dirigida toda la obra de Salomón, desde el día en que se echaron los cimientos de la Casa de Yavé hasta su terminación. Así fue acabada la Casa de Yavé."
,"17":"Entonces Salomón fue a Asiongaber y a Elat a orillas del mar, en el país de Edom."
,"18":"Hiram le envió, por medio de sus siervos, barcos y marinos conocedores del mar, que fueron con los siervos de Salomón a Ofir, de donde tomaron cuatrocientos cincuenta talentos de oro, que trajeron al rey Salomón."
}`)
	CurrentBook.AddChapter(9, `{
"1":"La reina de Saba había oído la fama de Salomón, y vino a Jerusalén a probarlo por enigmas. Vino con muchos servidores y con camellos que traían aromas, gran cantidad de oro y piedras preciosas. Fue donde Salomón y conversó con él sobre todas sus inquietudes."
,"2":"Salomón contestó todas sus preguntas sin que hubiera nada que él no pudiera explicarle."
,"3":"Cuando la reina de Saba vio la sabiduría de Salomón y la Casa que había edificado,"
,"4":"los manjares de su mesa, las habitaciones de sus servidores, el porte de sus ministros y sus vestidos, sus coperos, con sus trajes, y los sacrificios que ofrecía en la Casa de Yavé, se quedó sin aliento,"
,"5":"y dijo al rey: 'Todo cuanto oí decir en mi tierra de tus palabras y de tu sabiduría era verdad."
,"6":"Yo no daba crédito a lo que oía, hasta que he venido y lo he visto con mis propios ojos; y encuentro que no se me había contado ni la mitad de la grandeza de tu sabiduría, pues tú superas todo lo que oí decir."
,"7":"¡Dichosa toda tu gente! ¡Dichosos estos servidores, que están siempre en tu presencia y escuchan las palabras de tu sabiduría!"
,"8":"Bendito sea Yavé, tu Dios, que te quiere y te ha puesto sobre su trono como rey en su nombre. Yavé, tu Dios, ama a Israel y lo quiere conservar para siempre, y por eso te ha puesto por rey sobre ellos para administrar derecho y justicia.'"
,"9":"Dio al rey ciento veinte talentos de oro, gran cantidad de aromas y piedras preciosas. Nunca se vieron aromas como los que la reina de Saba dio al rey Salomón."
,"10":"Los siervos de Hiram y los siervos de Salomón que habían traído oro de Ofir, trajeron también madera de sándalo y piedras preciosas."
,"11":"Con la madera de sándalo el rey hizo pisos para la casa de Yavé y la casa del rey, cítaras y salterios para los cantores. No se había visto nunca en la tierra de Judá semejante madera."
,"12":"El rey Salomón retribuyó a la reina de Saba lo que ella le había traído. Además, le dio todo cuanto ella quiso pedir. Después se volvió ella y regresó a su país con sus servidores."
,"13":"El peso del oro que llegaba a Salomón cada año era de seiscientos sesenta y seis talentos de oro,"
,"14":"sin contar las contribuciones de los mercaderes y comerciantes. Todos los reyes de Arabia y los intendentes del país traían oro y plata a Salomón."
,"15":"El rey Salomón hizo doscientos grandes escudos de oro batido, aplicando seiscientos siclos de oro batido en cada escudo,"
,"16":"y trescientos escudos pequeños de oro batido, aplicando trescientos siclos de oro en cada escudo; el rey los colocó en la casa 'Bosque del Líbano'."
,"17":"El rey hizo un gran trono de marfil y lo revistió de oro puro."
,"18":"El trono tenía seis gradas y un peldaño por detrás y brazos a uno y otro lado del asiento con dos leones de pie, junto a los brazos,"
,"19":"más doce leones de pie sobre las seis gradas a uno y otro lado. No se había hecho cosa semejante en ningún reino."
,"20":"Todas las copas del rey Salomón eran de oro, y toda la vajilla de la casa 'Bosque del Líbano' era de oro fino. Nada de plata, pues no se estimaba en nada en tiempo del rey Salomón."
,"21":"Porque el rey tenía naves que navegaban a Tarsis con los servidores de Hiram, y cada tres años venía la flota de Tarsis trayendo oro y plata, marfil, monos y pavos reales."
,"22":"Así el rey Salomón aventajó a todos los reyes de la tierra en riqueza y sabiduría."
,"23":"Todos los reyes de la tierra querían ver el rostro de Salomón, para probar la sabiduría que Dios había puesto en su corazón."
,"24":"Y cada uno de ellos traía su presente, objetos de plata y objetos de oro, vestidos, armas, aromas, caballos y mulos, año tras año."
,"25":"Salomón tenía cuatro mil caballerizas para sus caballos y carros, y doce mil jinetes que puso en cuarteles en las ciudades de los carros y en Jerusalén junto al rey."
,"26":"Dominaba sobre todos los reyes desde el río hasta el país de los filisteos y hasta la frontera de Egipto."
,"27":"El rey hizo que la plata fuese tan abundante en Jerusalén como las piedras, y los cedros como los sicómoros de la Tierra Baja."
,"28":"Traían también caballos para Salomón de Musur y de todos los países."
,"29":"El resto de los hechos de Salomón, del comienzo al fin, ¿no están escritos en la historia del profeta Natán, en la profecía de Ajías el silonita, y en las visiones de Idó, el profeta, sobre Jeroboam, hijo de Nabat?"
,"30":"Salomón reinó en Jerusalén sobre todo Israel cuarenta años."
,"31":"Luego se acostó con sus padres y fue sepultado en la ciudad de David, su padre. En su lugar reinó su hijo Roboam."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Fue Roboam a Siquem, porque todo Israel había ido a Siquem para proclamarlo rey."
,"2":"Apenas lo supo Jeroboam, hijo de Nabat, estando todavía en Egipto, adonde había ido huyendo del rey Salomón, volvió de Egipto, pues habían enviado a llamarlo."
,"3":"Vino entonces Jeroboam con toda la asamblea, y hablaron a Roboam diciendo:"
,"4":"'Tu padre ha hecho pesado nuestro yugo; ahora tú aligera la dura servidumbre de tu padre y el pesado yugo que puso sobre nosotros y te serviremos.'"
,"5":"El les dijo: 'Vuelvan a mí de aquí a tres días.' Y el pueblo se fue."
,"6":"El rey Roboam pidió consejo a los ancianos que habían servido a su padre Salomón, en vida de éste, diciendo: '¿Qué me aconsejan que responda a este pueblo?'"
,"7":"Ellos le respondieron: 'Si eres bueno con este pueblo y condesciendes con ellos y les das buenas palabras, serán siervos tuyos para siempre.'"
,"8":"Pero él abandonó el consejo que los ancianos le aconsejaron y les pidió consejo a los jóvenes que se habían criado con él y estaban a su servicio."
,"9":"Les dijo: '¿Qué me aconsejan que responda a este pueblo que me ha dicho: Aligera el yugo que tu padre puso sobre nosotros?'"
,"10":"Los jóvenes que se habían criado con él le respondieron: 'Esto debes responder al pueblo que te ha dicho: Tu padre hizo pesado nuestro yugo, ahora tú aligera nuestro yugo; diles: Mi dedo meñique es más grueso que los lomos de mi padre."
,"11":"Un yugo pesado les cargó mi padre, pero yo les haré más pesado el yugo: mi padre los ha azotado con azotes, pero yo los azotaré con escorpiones.'"
,"12":"Al tercer día volvió Jeroboam con una muchedumbre y se presentó ante Roboam, según lo que había dicho el rey: 'Vuelvan a mí de aquí a tres días.'"
,"13":"El rey les respondió con dureza, abandonando el consejo de los ancianos, y hablándoles según el consejo de los jóvenes."
,"14":"Les dijo: 'Mi padre hizo pesado el yugo de ustedes, yo lo haré más pesado todavía; mi padre los azotó con azotes, pero yo los azotaré con escorpiones.'"
,"15":"No escuchó el rey al pueblo, pues se trataba de una intervención de Dios para dar cumplimiento a la promesa que Yavé había hecho a Jeroboam, hijo de Nabat, por medio de Ajías de Silo."
,"16":"Israel vio que el nuevo rey no los atendía y replicaron al rey: '¿Qué parte tenemos nosotros con David? No tenemos herencia que recibir del hijo de Jesé. ¡A tus tiendas, Israel! Mira ahora por tu casa, David.'"
,"17":"Y todo Israel volvió a sus pueblos. Roboam reinó solamente sobre los hijos de Israel que habitaban en las ciudades de Judá."
,"18":"El rey Roboam envió a Adoram, que estaba al frente de los trabajos del rey, pero los hijos de Israel lo mataron a pedradas y murió."
,"19":"Entonces el rey Roboam se apresuró a subir a su carro y huir hacia Jerusalén. Así los israelitas se apartaron de la familia de David hasta el día de hoy."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Cuando Roboam volvió a Jerusalén reunió a toda la tribu de Judá y la de Benjamín, ciento ochenta mil combatientes escogidos, para pelear contra Israel, para que reconocieran la autoridad de Roboam y se sumaran a su reino."
,"2":"Pero la palabra de Yavé fue dirigida a Semaías, hombre de Dios. Le decía:"
,"3":"'Habla a Roboam, hijo de Salomón, rey de Judá, y a todos los israelitas de Judá y Benjamín, y diles de parte mía:"
,"4":"No suban a combatir con sus hermanos; que cada uno se vuelva a su casa porque estos acontecimientos vienen de mí.' Ellos escucharon la palabra de Yavé y abandonaron sus propósitos de marchar contra Jeroboam."
,"5":"Roboam volvió a Jerusalén y edificó ciudades fortificadas en Judá."
,"6":"Fortificó Belén, Etam, Tecoa,"
,"7":"Betsur, Socó, Adulam,"
,"8":"Gat, Meresa, Ziv,"
,"9":"Adoraim, Laquis, Azeca,"
,"10":"Sora, Ayalón y Hebrón, las cuales están ubicadas en Judá y Benjamín."
,"11":"Construyó las murallas de estas ciudades y puso en ellas comandantes con provisiones de víveres, de aceite y vino."
,"12":"En todas estas ciudades había escudos y lanzas, y las hizo sumamente fuertes. Judá y Benjamín reconocían su autoridad."
,"13":"Los sacerdotes y levitas de todo el territorio de Israel se pasaron a Roboam y llegaron a él de todas partes;"
,"14":"los levitas abandonaron sus campos y sus posesiones y se fueron a Judá y a Jerusalén, pues Jeroboam y sus hijos les habían quitado sus privilegios de sacerdotes de Yavé."
,"15":"Jeroboam instituyó sus propios sacerdotes para sus santuarios altos, para el culto de los machos cabríos y de los becerros que había hecho."
,"16":"Tras ellos vinieron a Jerusalén, para ofrecer sacrificios a Yavé, el Dios de sus padres, aquéllos de entre todas las tribus de Israel que buscaban sinceramente a Yavé, el Dios de Israel;"
,"17":"y con su llegada se fortaleció el reino de Judá y el poder de Roboam, hijo de Salomón, por tres años. Pues siguieron el camino de David y de Salomón durante tres años."
,"18":"Roboam tomó por esposa a Majalat, hija de Jerimot, hijo de David, y de Abigaíl, hija de Eliab, hijo de Jesé."
,"19":"Esta le dio hijos: Jeús, Samarías y Zaham."
,"20":"Después de ésta tomó a Maacá, hija de Absalón, la cual le dio a Abías, Attay, Ziza y Selonit."
,"21":"Roboam amó a Maacá, hija de Absalón, más que a todas sus mujeres y concubinas, pues tuvo dieciocho mujeres y sesenta concubinas; y fue padre de veintiocho hijos y sesenta hijas."
,"22":"Roboam puso a Abías, hijo de Maacá, como cabeza y jefe de sus hermanos, porque quería hacerlo rey."
,"23":"Repartió hábilmente a todos sus hijos por toda la tierra de Judá y de Benjamín, en todas las ciudades fortificadas, dándoles todo lo necesario y procurando que se casaran."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Cuando Roboam se sintió firme y fuerte en su reino, abandonó la Ley de Yavé y con él todo Israel."
,"2":"Y sucedió que el año quinto del rey Roboam subió Sosaq, rey de Egipto, contra Jerusalén, pues sus habitantes no eran fieles a Yavé;"
,"3":"llegaban con mil doscientos carros y sesenta mil caballos; no se podía contar la gente que venía con él de Egipto: libios, sukitas y etíopes."
,"4":"Tomó las ciudades fortificadas de Judá y llegó hasta Jerusalén."
,"5":"El profeta Semaías vino a Roboam y a los jefe de Judí que se habían reunido en Jerusalén para hacer frente a Sosaq y les dijo: 'Así dice Yavé: Ustedes me han abandonado y por esto también yo los abandono en manos de Sosaq.'"
,"6":"Entonces los jefes de Israel y el rey se humillaron y dijeron: '¡Yavé es justo!'"
,"7":"Cuando Yavé vio que se habían humillado, dirigió nuevamente su palabra a Semaías: 'Ustedes se han humillado y por esta razón no los destruiré, sino que dentro de poco les daré la salvación y no derramaré mi cólera sobre Jerusalén por mano de Sosaq."
,"8":"Pero serán sus esclavos, para que puedan comparar lo que es servirme y ser esclavo de reyes extranjeros.'"
,"9":"Subió, pues, Sosaq, rey de Egipto, contra Jerusalén y se apoderó de los tesoros de la Casa de Yavé y de los tesoros de la casa del rey. De todo se apoderó. Tomó también los escudos de oro que había hecho Salomón."
,"10":"Entonces el rey Roboam hizo en su lugar escudos de bronce que confió a los jefes de la guardia que custodiaban la entrada de la casa del rey."
,"11":"Cuando el rey iba a la Casa de Yavé, los hombres de la guardia los llevaban, y después los devolvían a la sala de la guardia."
,"12":"La ira de Yavé se apartó de Roboam y no lo destruyó todo porque se había humillado."
,"13":"Había todavía cosas buenas en Judá. Se afianzó, pues, el poder del rey Roboam en Jerusalén. Roboam tenía cuarenta y un años cuando comenzó a reinar y reinó diecisiete años en Jerusalén, la ciudad que había elegido Yavé de entre todas las tribus de Israel para poner en ella su nombre. La madre de Roboam era amonita y se llamaba Noama."
,"14":"Roboam hizo lo que era malo, porque no se había dedicado a buscar a Yavé."
,"15":"Los hechos de Roboam, del comienzo al fin, ¿no están escritos según el orden genealógico en la historia del profeta Semaías y del vidente Idó? Hubo guerra continua entre Roboam y Jeroboam."
,"16":"Roboam se acostó con sus padres y fue sepultado en la ciudad de David. Reinó en su lugar su hijo Abías."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Abías comenzó a reinar sobre Judá el año dieciocho del rey Jeroboam."
,"2":"Reinó tres años en Jerusalén. Su madre era Micaya, hija de Uriel, de Guibea. Siguió la guerra entre Abías y Jeroboam."
,"3":"Abías entró en combate con un ejército de cuatrocientos mil hombres escogidos, todos valientes guerreros; Jeroboam le hizo frente con ochocientos mil guerreros escogidos y valerosos."
,"4":"Abías, de pie en el monte Semaraím, que está en los cerros de Efraím, les gritó: 'Escúchenme, Jeroboam y todo Israel."
,"5":"¿Acaso no saben que Yavé, el Dios de Israel, dio el reino de Israel para siempre a David, a él y a sus hijos, comprometiéndose para siempre?"
,"6":"Pero Jeroboam, hijo de Nabat, siervo de Salomón, se rebeló orgullosamente contra su señor."
,"7":"Se juntaron con él unos hombres vanos y malvados y se opusieron a Roboam, hijo de Salomón, de manera que Roboam, que era joven y sin experiencia, no los resistió."
,"8":"Y ahora ustedes quieren dominar el reino de Yavé, que está en manos de los hijos de David. Ustedes son una muchedumbre, pero tienen los becerros de oro que Jeroboam les puso por dioses."
,"9":"¿No han expulsado a los sacerdotes de Yavé, los hijos de Aarón y los levitas? ¿No se han hecho sacerdotes a la manera de los pueblos de los demás países? Cualquiera que viene con un novillo y siete carneros y pide ser consagrado es hecho sacerdote de los que no son dioses."
,"10":"En cuanto a nosotros, Yavé es nuestro Dios y no lo hemos abandonado; los sacerdotes hijos de Aarón sirven a Yavé, igual que los levitas."
,"11":"Cada mañana y cada tarde ofrecemos a Yavé víctimas consumidas por el fuego y le presentamos el incienso aromático; los panes ofrecidos están sobre la mesa pura y cada tarde se encienden las lámparas del candelabro de oro, pues nosotros guardamos el ritual de Yavé nuestro Dios, en tanto que ustedes lo han abandonado."
,"12":"Miren que Dios está con nosotros, a nuestra cabeza, con sus sacerdotes y las trompetas que se van a tocar frente a ustedes. Hijos de Israel, no hagan la guerra contra Yavé, el Dios de sus padres, porque nada conseguirán.'"
,"13":"Entre tanto, Jeroboam hizo dar un rodeo para poner una emboscada y atacarlos por detrás, de manera que él estaba frente a Judá y la emboscada a espaldas de éstos."
,"14":"Cuando los hombres de Judá se dieron cuenta, vieron que se presentaba el combate de frente y por detrás."
,"15":"Entonces clamaron a Yavé y mientras los sacerdotes tocaban las trompetas, los hombres de Judá lanzaron el grito de guerra; y cuando los hombres de Judá lanzaron el grito de guerra, Dios desbarató a Jeroboam y a todo Israel delante de Abías y de Judá."
,"16":"Huyeron los hijos de Israel delante de Judá, y Dios los entregó en sus manos."
,"17":"Abías y su tropa les causaron una gran derrota; cayeron quinientos mil hombres escogidos de Israel."
,"18":"Quedaron entonces humillados los hijos de Israel y prevalecieron los hijos de Judá por haberse apoyado en Yavé, el Dios de sus padres."
,"19":"Abías persiguió a Jeroboam y le tomó las ciudades de Betel con sus aldeas, Jesaná con sus aldeas y Efrón con sus aldeas."
,"20":"Jeroboam ya no pudo restablecerse en los días de Abías, pues Yavé lo hirió y murió."
,"21":"En cambio, Abías se fortaleció; tomó catorce mujeres y fue padre de veintidós hijos y dieciséis hijas."
,"22":"El resto de los hechos de Abías, sus actos y palabras están escritos en el relato del profeta Idó."
,"23":"Se acostó Abías con sus padres y lo sepultaron en la ciudad de David. Reinó en su lugar su hijo Asá. En su tiempo el país estuvo en paz durante diez años."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Asá hizo lo que es bueno y recto a los ojos de Yavé su Dios."
,"2":"Suprimió los altares del culto extranjero y los santuarios altos de las lomas, derribó los monumentos y abatió los troncos sagrados."
,"3":"Invitó a los judíos a que buscaran a Yavé, el Dios de sus padres, y cumplieran la Ley y el mandamiento."
,"4":"Hizo desaparecer de todas las ciudades de Judá los santuarios altos y las columnas dedicadas al sol; y el reino estuvo en paz bajo su reinado."
,"5":"Edificó ciudades fuertes en Judá, porque el país estaba en paz, y no hubo guerra contra él por aquellos años; pues Yavé le había dado tranquilidad."
,"6":"Dijo a Judá: 'Edifiquemos estas ciudades, y cerquémoslas de murallas, torres, puertas y barras, mientras el país esté a nuestra disposición; pues hemos buscado a Yavé, nuestro Dios, y por haberlo buscado, él nos ha dado paz por todas partes.'"
,"7":"Edificaron y prosperaron. Asá tenía un ejército de trescientos mil hombres de Judá, que llevaban escudos grandes y lanzas, y doscientos ochenta mil de Benjamín, que llevaban el escudo pequeño y eran arqueros, todos ellos esforzados guerreros."
,"8":"Salió contra ellos Zéraj, el etíope, con un ejército de un millón de hombres y trescientos carros, y llegó hasta Maresá."
,"9":"Salió Asá contra él y se pusieron en orden de batalla en el valle al norte de Maresá."
,"10":"Asá invocó a Yavé su Dios, y dijo: 'Oh Yavé, puedes ayudar al desvalido como al poderoso. ¡Ayúdanos, pues, Yavé Dios nuestro, porque en ti nos apoyamos, en tu nombre marchamos contra esta inmensa muchedumbre! Yavé, tú eres nuestro Dios: ¡No prevalezca contra ti hombre alguno!'"
,"11":"Yavé derrotó a los etíopes ante Asá y los hombres de Judá; y los etíopes se pusieron en fuga."
,"12":"Asá y la gente que estaba con él los persiguieron hasta Guerar y cayeron de los etíopes hasta no quedar uno vivo, pues fueron destrozados delante de Yavé y su campamento; y se recogió un botín inmenso."
,"13":"Se apoderaron de todas las ciudades, alrededor de Guerar, pues el terror de Yavé pesaba sobre ellos y saquearon las ciudades, pues había en ellas gran botín."
,"14":"Asimismo atacaron las tiendas donde se recogían los ganados, capturando gran cantidad de ovejas y camellos. Después se volvieron a Jerusalén."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Vino entonces el Espíritu de Dios sobre Azarías, hijo de Obed,"
,"2":"el cual salió al encuentro de Asá y le dijo: '¡Escúchenme ustedes, Asá y toda la gente de Judá y Benjamín! Yavé estará con ustedes mientras ustedes estén con él; si ustedes lo buscan, él se dejará hallar, pero si ustedes lo abandonan, él los abandonará a ustedes."
,"3":"Durante mucho tiempo estará Israel sin el verdadero Dios y sin sacerdotes que enseñen su Ley,"
,"4":"pero cuando en medio de la tribulación se vuelvan a Yavé, Dios de Israel, y lo busquen, entonces lo encontrarán."
,"5":"En aquellos tiempos no habrá paz para quien entre ni para quien salga, sino muchas angustias sobre todos los habitantes de la tierra;"
,"6":"porque un pueblo se levantará contra otro, una ciudad contra otra ciudad, porque Dios los perturbará con plagas de toda clase."
,"7":"Entre tanto, ustedes tengan ánimo y no desmayen, esfuércense y que no se debiliten los brazos; puesto que recibirán la recompensa de sus obras.'"
,"8":"Al oír Asá estas palabras y esta profecía cobró ánimo e hizo desaparecer los ídolos abominables de todo el país de Judá y Benjamín y de las ciudades que había conquistado en los cerros de Efraím, y restauró el altar de Yavé que estaba delante de la Casa."
,"9":"Congregó a todo Judá y Benjamín, y a los de Efraím, Manasés y Simeón que habitaban entre ellos; pues se habían pasado a él muchos de los israelitas al ver que Yavé, su Dios, estaba con él."
,"10":"Se reunieron en Jerusalén en el mes tercero del año quince del reinado de Asá."
,"11":"Aquel día ofrecieron a Yavé víctimas consumidas por el fuego, tomando para esto setecientos bueyes y siete mil ovejas del botín que habían recogido."
,"12":"Acordaron buscar a Yavé, el Dios de sus padres, con todo su corazón y toda su alma: en esto consiste la Alianza;"
,"13":"e incluso dijeron que todo aquel que no buscara a Yavé, el Dios de Israel, sería muerto, fuera pequeño o grande, hombre o mujer."
,"14":"Juraron, pues, a Yavé en alta voz, con gritos de júbilo y al son de trompetas y cuernos,"
,"15":"y todo Judá se alegró con motivo del juramento, porque de todo corazón habían prestado juramento, y con plena voluntad habían buscado a Yavé. Por eso él se dejó hallar de ellos; y les dio paz por todas partes."
,"16":"El rey Asá llegó a quitar a Maacá, su madre, el título de Gran Dama, porque había hecho un Horror para Aserá. Asá destruyó este Horror, lo hizo pedazos y lo quemó en el torrente Cedrón."
,"17":"Pero no desaparecieron los santuarios altos de en medio de Israel, aun cuando el corazón de Asá fue perfecto todos los días de su vida."
,"18":"Llevó a la Casa de Yavé las ofrendas consagradas por su padre y sus propias ofrendas: plata, oro y utensilios."
,"19":"No hubo guerra hasta el año treinta y cinco del reinado de Asá."
}`)
	CurrentBook.AddChapter(16, `{
"1":"El año treinta y seis del reinado de Asá subió Basá, rey de Israel, contra Judá, y fortificó a Ramá, para cortar las comunicaciones a Asá, rey de Judá."
,"2":"Sacó entonces Asá plata y oro de los tesoros de la Casa de Yavé y de la casa del rey, y los envió a Ben-Hadad, rey de Aram, que vivía en Damasco, al que dijo:"
,"3":"'Hagamos una alianza como la hubo entre mi padre y tu padre; te envío plata y oro; ven, rompe tu alianza con Basá, rey de Israel, para que se aleje de mí.'"
,"4":"Ben-Hadad escuchó al rey Asá y envió a los jefes de su ejército contra las ciudades de Israel; conquistó Iyón, Dan, Abel-Maim y todos los depósitos de las ciudades situadas en Neftalí."
,"5":"Cuando Basá lo supo, suspendió las fortificaciones de Ramá e hizo parar su obra."
,"6":"Entonces el rey Asá tomó a todo el pueblo de Judá y se llevaron de Rama las piedras y maderas que Basá había empleado para la construcción; y con ellas fortificó Gueba y Masfá."
,"7":"En aquel tiempo el vidente Janani fue donde Asá, rey de Judá, y le dijo: 'Porque te has apoyado en el rey de Aram y no en Yavé, tu Dios, por eso se ha escapado de tu mano el ejército del rey de Aram."
,"8":"¿Acaso los etíopes y los libios no formaban un ejército numeroso con carros e innumerables caballerías? Y, sin embargo, porque pusiste tu confianza en Yavé, él los entregó en tu mano."
,"9":"Porque los ojos de Yavé recorren toda la tierra para fortalecer a los que le sirven de todo corazón. Pero has procedido neciamente en esta ocasión y por eso de aquí en adelante tendrás guerras.'"
,"10":"Asá se enojó contra el vidente y lo encadenó en la cárcel, pues estaba enojado con él por lo que había dicho. En este tiempo Asá maltrató también a gente del pueblo."
,"11":"Los hechos de Asá, del comienzo al fin, están escritos en el Libro de los Reyes de Judá y de Israel."
,"12":"El año treinta y nueve de su reinado, Asá enfermó de los pies, de una enfermedad muy grave. En su enfermedad no consultó a Yavé, sino a los médicos."
,"13":"Murió Asá el año cuarenta y uno de su reinado"
,"14":"y lo sepultaron en el sepulcro que se había hecho en la ciudad de David. Lo pusieron sobre un lecho que habían llenado de aromas preparados según el arte de perfumería y, por él, se quemaron perfumes en enorme cantidad."
}`)
	CurrentBook.AddChapter(17, `{
"1":"En su lugar reinó su hijo Josafat, el cual se fortificó contra Israel."
,"2":"Puso guarniciones en todas las ciudades amuralladas de Judá, gobernadores en todo el país de Judá y en las ciudades de Efraím que Asá, su padre, había conquistado."
,"3":"Yavé estuvo con Josafat porque anduvo por los caminos que había seguido su padre David y no buscó a los baales,"
,"4":"sino que buscó al Dios de sus padres, andando conforme a sus mandamientos, sin imitar lo que hacía Israel."
,"5":"Yavé fortaleció su poder. Todo Judá traía regalos a Josafat, que iba adquiriendo grandes riquezas y honores."
,"6":"Se entusiasmó por las cosas de Yavé, hasta que hizo desaparecer del país de Judá los santuarios de lomas y los troncos sagrados."
,"7":"El año tercero de su reinado envió a sus oficiales Ben-Jail, Abdías, Zacarías, Natanael y Miqueas para que enseñasen en las ciudades de Judá,"
,"8":"y con ellos a los levitas Semaías, Netanías, Zebadías, Asael, Semiramot, Jonatán, Adonías, Tobías, Tabadonías y con estos levitas a los sacerdotes Elisamá y Joram."
,"9":"Enseñaron, pues, en Judá, llevando consigo el libro de la Ley de Yavé. Recorrieron todas las ciudades de Judá enseñando al pueblo."
,"10":"El terror de Yavé se apoderó de todos los reinos y países que rodeaban a Judá, de manera que no hicieron guerra contra Josafat."
,"11":"Había filisteos que traían a Josafat presentes y plata como tributo, también los árabes le traían ganado menor: siete mil setecientos carneros y siete mil setecientos machos cabríos."
,"12":"Así Josafat iba haciéndose cada vez más poderoso y edificó en Judá castillos y ciudades de almacenamiento."
,"13":"Josafat tenía mucha mano de obra en las ciudades de Judá, y tuvo una guarnición de guerreros escogidos en Jerusalén."
,"14":"Esta es la lista por sus casas paternas: Por la tribu de Judá: Adua mandaba los jefes de millares; trescientos mil hombres valientes estaban a su cargo."
,"15":"Sus ayudantes eran: Yojanan, el cual mandaba a doscientos ochenta mil hombres,"
,"16":"y Amasías, hijo de Zicrí, que servía como voluntario para Yavé y mandaba a doscientos mil hombres valientes."
,"17":"Para la tribu de Benjamín: Eliada, valiente guerrero, tenía a sus órdenes doscientos mil hombres armados con arco y escudo."
,"18":"A su lado estaba Jozabad con ciento ochenta mil hombres armados."
,"19":"Estos eran los que estaban al servicio del rey, sin contar los que había puesto de guarnición en las ciudades amuralladas por todo el país de Judá."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Josafat tuvo grandes riquezas y honores, emparentó con Ajab"
,"2":"y al cabo de algunos años, bajó a visitarlo a Samaria. Ajab sacrificó gran número de ovejas y bueyes para él y para la gente que lo acompañaba; luego le persuadió que lo acompañara para ir contra Ramot de Galaad."
,"3":"Ajab, rey de Israel, dijo a Josafat, rey de Judá: '¿Quieres marchar conmigo contra Ramot de Galaad?' Le contestó: 'Somos uno solo yo y tú. Tanto mi pueblo como el tuyo estaremos contigo en la batalla.'"
,"4":"Pero Josafat dijo al rey de Israel: 'Consulta antes, por favor, la palabra de Yavé.'"
,"5":"El rey de Israel reunió a los profetas en número de cuatrocientos y les dijo: '¿Debo atacar a Ramot de Galaad o no?' Ellos le repondieron: 'Ataca, porque Yavé la entregará en manos del rey.'"
,"6":"Josafat preguntó: '¿No hay aquí algún otro profeta a quien podamos consultar?'"
,"7":"El rey de Israel le dijo: 'Sí, hay un hombre por quien podríamos consultar a Yavé, pero yo le tengo odio, pues nunca me profetiza el bien, sino el mal. Es Miqueas, hijo de Jimlá.' Josafat lo reprendió: 'No hables de esta manera.'"
,"8":"El rey de Israel llamó a un eunuco y le dijo: 'Trae en seguida a Miqueas, hijo de Jimlá.'"
,"9":"El rey de Israel y Josafat, rey de Judá, estaban sentados cada cual en su trono, vestidos de gala, en el terreno que hay a la entrada de la puerta de Samaria, mientras que todos los profetas profetizaban delante de ellos."
,"10":"Sedecías, hijo de Kenaná, se había hecho unos cuernos de hierro y decía: 'Así dice Yavé: Con esto acometerás a Aram hasta acabar con ellos.'"
,"11":"Y todos los profetas hablaban del mismo modo diciendo: 'Sube contra Ramot de Galaad y tendrás éxito. Yavé la entregará en manos del rey.'"
,"12":"El mensajero que había ido a llamar a Miqueas le dijo: 'Mira que los profetas, todos a una voz, predicen feliz éxito al rey; procura tú decir lo mismo.'"
,"13":"Miqueas respondió: 'Por la vida de Yavé anunciaré lo que mi Dios me diga.' Llegó donde el rey"
,"14":"y éste le dijo: 'Miqueas, ¿debemos subir contra Ramot de Galaad para atacar, o no?' Miqueas le respondió: 'Suban, pues tendrán éxito. Ellos serán entregados en manos de ustedes.'"
,"15":"Pero el rey le dijo: '¿Cuántas veces he de rogarte que no me digas más que la verdad en nombre de Yavé?'"
,"16":"Entonces Miqueas dijo: 'He visto todo Israel disperso por los montes como ovejas sin pastor; Yavé ha dicho: Estos ya no tienen quién los guíe; que vuelvan en paz cada cual a su casa.'"
,"17":"El rey de Israel dijo a Josafat: '¿No te dije que nunca me anuncia el bien, sino el mal?'"
,"18":"Miqueas le dijo entonces: 'Escuchen la palabra de Yavé. He visto a Yavé sentado en su trono, y todo el ejército de los cielos estaba a su derecha y a su izquierda."
,"19":"Preguntó Yavé: ¿Quién engañará a Ajab, rey de Israel, para que suba y caiga en Ramot de Galaad? Unos decían una cosa y otros otra."
,"20":"Entonces se adelantó el Espíritu, se puso ante Yavé y le dijo: Yo lo engañaré. Le preguntó Yavé: ¿Y cómo lo harás?"
,"21":"Respondió: Iré y me haré espíritu de mentira en la boca de todos sus profetas. Yavé le dijo: Tú conseguirás engañarlo. Vete y hazlo así."
,"22":"Ahora, pues, Yavé ha puesto un espíritu de mentira en la boca de todos estos profetas tuyos, pues Yavé ha predicho el mal contra ti.'"
,"23":"Se acercó entonces Sedecías, hijo de Kenaná, y dio una bofetada a Miqueas en la mejilla diciendo: '¿Por qué camino se ha ido de mí el espíritu de Yavé para hablarte a ti?'"
,"24":"Miqueas replicó: 'Tú mismo lo verás el día en que pases de casa en casa para esconderte.'"
,"25":"El rey de Israel dijo: 'Tomen preso a Miqueas y llévenlo a Amón, gobernador de la ciudad, y a Joás, hijo del rey;"
,"26":"y le dirán: Así habla el rey: Metan a éste en la cárcel y le dan el pan y el agua racionado, hasta que yo vuelva victorioso.'"
,"27":"Miqueas le dijo: 'Si tú vuelves victorioso, Yavé no ha hablado por mi boca.'"
,"28":"El rey de Israel y Josafat, rey de Judá, subieron contra Ramot de Galaad."
,"29":"El rey de Israel dijo a Josafat: 'Yo voy a disfrazarme para ir a la pelea, mientras tú te pondrás tus vestidos.',El rey de Israel se disfrazó y así empezaron a pelear. "
,"30":"Ahora bien, el rey de Aram había ordenado a los jefes de sus carros de guerra: 'No ataquen a nadie, ni a los grandes ni a los chicos, tan sólo al rey de Israel.'"
,"31":"Cuando los jefes de los carros de guerra vieron a Josafat, pensaron que era el rey de Israel y lo rodearon para cargar contra él. Pero Josafat invocó a gritos a Yavé y éste lo socorrió y los alejó de él."
,"32":"Al darse cuenta de que no era el rey de Israel, los jefes de carros se apartaron de él."
,"33":"Sucedió que uno de los soldados arameos disparó su arco sin saber a quién apuntaba, hiriendo al rey de Israel, por entre las hombreras y la coraza. El rey dijo al que guiaba su carro: 'Date vuelta y sácame de la batalla, porque me siento malherido.'"
,"34":"Pero el combate se puso más duro, de modo que tuvieron que sostener al rey en pie en su carro de guerra frente a los arameos hasta la tarde; a la caída del sol, murió."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Cuando Josafat, rey de Judá, regresaba sano y salvo a su casa, a Jerusalén,"
,"2":"le salió al encuentro Jehú, hijo de Jananí, el vidente, y le dijo al rey: '¿Debías tú ayudar al malo y favorecer a los que aborrecen a Yavé? Por esto ha caído sobre ti la cólera de Yavé."
,"3":"Sin embargo, algo bueno ha sido hallado en ti: quitaste de tu país los troncos sagrados y te dedicaste a buscar a Dios.'"
,"4":"Josafat permaneció en Jerusalén, pero volvió a visitar al pueblo desde Bersebá hasta los cerros de Efraím, y los convirtió a Yavé, el Dios de sus padres."
,"5":"Estableció jueces en todo el país, en todas y cada una de las ciudades amuralladas de Judá,"
,"6":"y les dijo a los jueces: 'Miren bien lo que hacen, porque ustedes no juzgan en nombre de los hombres, sino en nombre de Yavé, que está con ustedes cuando administran justicia."
,"7":"Que el temor a Yavé esté con ustedes. Cuiden bien lo que hacen, porque Yavé, nuestro Dios, no tolera que se hagan favores a uno más que a otro; no soporta a los jueces pervertidos ni a los que se dejan comprar con regalos.'"
,"8":"También en Jerusalén Josafat estableció levitas, sacerdotes y jefes de familias de Israel, que administraran la justicia de Yavé y arreglaran los pleitos. Estos vivían en Jerusalén."
,"9":"Les dio esta orden: 'Obrarán en todo con el temor de Yavé, siendo íntegros y correctos en todo."
,"10":"En todo pleito que les llegue de parte de sus hermanos que habitan en sus ciudades, ya sean causas de sangre o cuestiones de la Ley, de los mandamientos, decretos y sentencias, tienen que instruirlos, a fin de que no pequen contra Yavé. De otro modo, Yavé se enojaría contra ustedes y contra sus hermanos."
,"11":"Actúen así y no cometan pecados. El sumo sacerdote Amarías los dirigirá en todos los asuntos de Yavé, y Zabedías, hijo de Ismael, príncipe de la tribu de Judá, en todos los asuntos del rey. Los levitas les servirán de escribas. Sean valientes y eficaces. ¡Yavé esté con el bueno!'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"Después de esto, los hombres de Moab y la gente de Amón, y con ellos algunos maonitas, vinieron a pelear contra Josafat."
,"2":"Le avisaron a Josafat diciendo: 'Viene contra ti una gran muchedumbre de gente del otro lado del mar de Edom, que están ya en Jesasón-Tamor, o sea, Engadí.'"
,"3":"Josafat tuvo miedo y consultó a Yavé, ordenando un ayuno a todo Judá."
,"4":"Los judíos se reunieron para suplicar a Yavé y, de todas las ciudades de Judá, llegaron para rogar a Yavé."
,"5":"Entonces Josafat se puso de pie en medio de la asamblea de Judá en Jerusalén, en la Casa de Yavé, delante del patio nuevo."
,"6":"Dijo: 'Yavé, Dios de nuestros padres, ¿no eres tú Dios en el cielo y no dominas tú en todos los reinos de las naciones? En tu mano está el poder y la fortaleza sin que nadie pueda resistirte."
,"7":"¿No has sido tú, oh Dios nuestro, el que expulsaste a los habitantes de esta tierra delante de tu pueblo Israel, y la diste a los descendientes de tu amigo Abraham para siempre?"
,"8":"Ellos la han habitado y han edificado un santuario para tu nombre diciendo:"
,"9":"Si viene sobre nosotros algún mal, espada, castigo, peste o hambre, nos presentaremos delante de esa Casa y delante de ti, porque tu Nombre reside en esta Casa. Clamaremos a ti en nuestra angustia, y tú oirás y nos salvarás."
,"10":"Pero mira a los hijos de Amón, de Moab y del norte de Seír, adonde no dejaste entrar a Israel cuando salía de la tierra de Egipto, y por orden tuya Israel se apartó de ellos sin destruirlos."
,"11":"Ahora nos pagan viniendo a echarnos de la heredad que tú nos has dado."
,"12":"Oh Dios nuestro, ¿no harás justicia con ellos? Pues nosotros no tenemos fuerza para hacer frente a esta gran multitud que viene contra nosotros y no sabemos qué hacer. Pero nuestros ojos se vuelven a ti.'"
,"13":"Todo Judá estaba de pie ante Yavé con sus niños, mujeres e hijos."
,"14":"Entonces en medio de la asamblea vino el Espíritu de Yavé sobre Jazaziel, hijo de Zacarías, hijo de Benaías, hijo de Jeiel, hijo de Matanías, levita de los hijos de Asaf,"
,"15":"y dijo: 'Atiende, pueblo de Judá entero y habitantes de Jerusalén, y tú, oh rey Josafat. Esto les dice Yavé: No teman ni se asusten ante esta gran muchedumbre; porque esta guerra no es de ustedes sino de Yavé."
,"16":"Bajen contra ellos mañana; ellos van a subir por la cuesta de Sis, de manera que los encontrarán al extremo del torrente, junto al desierto de Jeruel."
,"17":"No tendrán que pelear en este lugar sino que se pararán y verán la salvación de Yavé sobre ustedes, oh Judá y Jerusalén. No teman ni se acobarden, salgan mañana al encuentro de ellos pues Yavé estará con ustedes.'"
,"18":"Entonces Josafat se inclinó rostro en tierra; y todo Judá y los habitantes de Jerusalén se postraron ante Yavé para adorarlo."
,"19":"Los levitas de las familias quehatita y coreíta se levantaron y alabaron con gritos a Yavé, el Dios de Israel."
,"20":"Al día siguiente se levantaron temprano y salieron al desierto de Tecoa. Mientras iban saliendo, Josafat, puesto en pie, dijo: 'Escuchen, Judá y habitantes de Jerusalén, tengan confianza en Yavé su Dios y estarán seguros, tengan confianza en sus profetas y triunfarán.'"
,"21":"Después, habiendo conversado con el pueblo, dispuso a los cantores de Yavé y a los salmistas que marcharían al frente de las tropas vestidos de ornamentos sagrados: 'Alaben a Yavé porque es eterno su amor.'"
,"22":"En el momento en que comenzaron las aclamaciones y las alabanzas, Yavé preparó una trampa en que cayeron los hijos de Amón, los de Moab y los del monte Seír que habían venido para atacar a Judá."
,"23":"Pues los amonitas y los moabitas se echaron sobre los habitantes de los cerros de Seír para destruirlos y acabar con ellos; y cuando acabaron con ellos, se mataron unos a otros."
,"24":"Cuando los de Judá llegaron a la cumbre desde donde se divisa el desierto, vieron todo el campo cubierto de cadáveres sin que uno solo hubiera quedado con vida."
,"25":"Entonces Josafat con todo su ejército llegaron para recoger los despojos y hallaron gran cantidad de ganado, vestidos y objetos preciosos. Fue tanto el botín, que tres días no fueron suficientes para juntarlo todo, y no sabían cómo llevarlo."
,"26":"Al cuarto día se reunieron en el valle de Beraká. Por eso se llama aquel lugar valle de Beraká, que significa bendición, hasta el día de hoy, pues allí los bendijo Yavé."
,"27":"Después, todos los hombres de Judá y de Jerusalén, con Josafat al frente, regresaron con gran alegría a Jerusalén, porque Yavé los había colmado de gozo a expensas de sus enemigos."
,"28":"Entraron en Jerusalén con salterios, cítaras y trompetas dirigiéndose a la Casa de Yavé."
,"29":"El terror de Yavé cayó sobre todos los países vecinos cuando supieron que él había vencido a los enemigos de Israel."
,"30":"Entre tanto el reinado de Josafat fue tranquilo, y su Dios le dio paz por todos lados."
,"31":"Josafat reinó sobre Judá. Tenía treinta y cinco años cuando comenzó a reinar y reinó veinticinco años en Jerusalén. Su madre Azubá era hija de Siljí."
,"32":"Siguió en todo el camino de su padre Asá, sin desviarse de él, haciendo lo que era correcto a los ojos de Yavé."
,"33":"Con todo, no desaparecieron los santuarios de las lomas, pues el pueblo aún no se había convertido al Dios de sus padres."
,"34":"Lo demás referente a Josafat, del comienzo al fin, está escrito en la historia de Jehú, hijo de Jananí, que se halla insertada en el libro de los Reyes de Israel."
,"35":"Después de esto, Josafat, rey de Judá, se alió con Ocozías, rey de Israel, que hacía el mal."
,"36":"Se asoció con él para construir barcos que hicieran viajes a Tarsis y fabricaron los barcos en Asiongaber."
,"37":"Entonces Eliezer, hijo de Bodavías, de Maresá, profetizó contra Josafat, diciendo: 'Porque te has aliado con Ocozías, Yavé ha destruido tus proyectos.' En efecto, las naves fueron destrozadas y no llegaron a Tarsis."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Cuando Josafat murió lo sepultaron con sus padres en la ciudad de David y su hijo Joram lo sucedió."
,"2":"Joram tenía seis hermanos, hijos de Josafat, que eran: Azarías, Jejiel, Zacarías, Azarías, Miguel y Sefatías. Todos éstos eran hijos de Josafat, rey de Israel."
,"3":"Su padre les había dado grandes cantidades de plata, oro y objetos preciosos y ciudades amuralladas en Judá; pero entregó el reino a Joram, porque era el primogénito."
,"4":"Joram tomó posesión del trono de su padre; y cuando se sintió fuerte, pasó a cuchillo a todos sus hermanos y también a algunos de los jefes de Israel."
,"5":"Treinta y dos años tenía Joram cuando empezó a reinar y reinó ocho años en Jerusalén."
,"6":"Se portó como los reyes de Israel e hizo como había hecho la gente de Ajab, porque se había casado con una mujer de la familia de Ajab y se portó mal con Yavé."
,"7":"Pero Yavé no quiso destruir la descendencia de David, a causa de la alianza que había hecho con David, cuando le prometió que le guardaría siempre una lámpara a él y a sus hijos."
,"8":"Por aquellos días se rebeló Edom, sacudiendo el yugo de Judá, y se proclamó un rey propio."
,"9":"Joram con sus jefes y con todos sus carros de guerra salió de noche y derrotó a los edomitas, que lo tenían cercado, a él y a los jefes de sus carros de guerra."
,"10":"Así se rebeló Edom del yugo de Judá hasta el día de hoy. Por ese mismo tiempo Libná se rebeló también contra él, porque había abandonado a Yavé, el Dios de sus padres."
,"11":"Construyó asimismo santuarios altos en los montes de Judá, incitó a la prostitución a los habitantes de Jerusalén y empujó a ella a todo Judá."
,"12":"Le llegó un escrito de parte del profeta Elías que decía: 'Así dice Yavé, el Dios de tu padre David: No has seguido los caminos de tu padre Josafat, ni los caminos de Asá, rey de Judá,"
,"13":"sino que has andado por los caminos de los reyes de Israel, y has prostituido a Judá y a los habitantes de Jerusalén siguiendo las prostituciones de la familia de Ajab; también has dado muerte a tus hermanos de la familia de tu padre que eran mejores que tú."
,"14":"Por eso, Yavé castigará con terribles azotes a tu pueblo, tus hijos, tus mujeres y todos tus bienes;"
,"15":"tú mismo padecerás una enfermedad en el vientre tan maligna, que irás echando las entrañas poco a poco un día tras otro.'"
,"16":"Yavé hizo que se levantaran contra Joram los filisteos y los árabes, vecinos de los etíopes."
,"17":"Subieron contra Judá y lo invadieron, llevándose todas las riquezas que hallaron en la casa del rey y también a sus hijos y a sus mujeres, no dejándole otro hijo que Ocozías, el menor."
,"18":"Después de todo esto lo hirió Yavé con una enfermedad incurable en el vientre"
,"19":"y al cabo de un tiempo, al fin del segundo año, se le salieron las entrañas y murió en medio de terribles dolores. El pueblo no quemó perfumes por él, como lo había hecho por su padre."
,"20":"Tenía treinta y dos años cuando empezó a reinar y reinó en Jerusalén ocho años. Se fue sin que nadie lo llorara; y lo sepultaron en la ciudad de David, pero no en los sepulcros de los reyes."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Los habitantes de Jerusalén proclamaron rey en su lugar a su hijo menor Ocozías, porque una banda de árabes que había invadido el campamento dio muerte a todos los mayores; así llegó a ser rey Ocozías, hijo de Joram, rey de Judá."
,"2":"Ocozías tenía veintidós años cuando comenzó a reinar, y reinó un año en Jerusalén. Su madre se llamaba Atalía, hija de Omrí."
,"3":"También él siguió los caminos de la familia de Ajab, pues su madre le aconsejaba mal."
,"4":"Se portó mal con Yavé, como los de la familia de Ajab, porque después de la muerte de su padre, fueron ellos sus consejeros para su perdición."
,"5":"También por consejo de ellos fue con Joram, hijo de Ajab, rey de Israel, para combatir a Jezael, rey de Aram, en Ramot de Galaad; los arameos hirieron a Joram,"
,"6":"que se retiró a Jizrael para curarse de las heridas que había recibido en Ramá, en la batalla contra Jazael, rey de Aram. Ocozías, hijo de Joram, rey de Judá, bajó a Jizrael para visitar a Joram, hijo de Ajab, que se encontraba enfermo; "
,"7":"esta visita a Joram vino de Dios para ruina de Ocozías, pues llegado allí, salió con Joram contra Jehú, hijo de Nimsí, a quien Yavé había ungido para exterminar la familia de Ajab."
,"8":"Mientras Jehú hacía justicia con la familia de Ajab, se encontró con los jefes de Judá y con los parientes de Ocozías que estaban a su servicio, y los mató."
,"9":"Buscó luego a Ocozías, al que agarraron en Samaria, donde se había escondido. Lo llevaron donde Jehú, que lo mató, pero le dieron sepultura, pues decían: 'Es hijo de Josafat, el que buscó a Yavé con todo su corazón.',No quedó de la familia de Ocozías nadie que fuera capaz de reinar. "
,"10":"Cuando Atalía, madre de Ocozías, vio que había muerto su hijo, se levantó y exterminó a toda la descendencia de los reyes de Judá."
,"11":"Pero Josabá, hija del rey, tomó a Joás, hijo de Ocozías, lo sacó de entre los hijos del rey a quienes estaban matando y los puso a él y a su nodriza en el dormitorio. Josabá, hija del rey Joram, esposa del sacerdote Jovadá y hermana de Ocozías, lo escondió de la vista de Atalía, que no pudo asesinarlo. "
,"12":"Seis años estuvo escondido en la Casa de Dios, mientras Atalía reinaba en el país."
}`)
	CurrentBook.AddChapter(23, `{
"1":"El año séptimo, Joyadá cobró ánimo y mandó a buscar a los jefes de cien que dependían de Azarías, hijo de Jerojam, de Israel, hijo de Jojanán, de Azarías, hijo de Obed, de Masaías, hijo de Adarías, y de Elisafat, hijo de Sikrí. Había arreglado un pacto con ellos."
,"2":"Recorrieron Judá y reunieron a los levitas de todas las ciudades de Judá, y a los cabezas de familia de Israel, que vinieron a Jerusalén."
,"3":"Toda la asamblea hizo pacto con el rey en la casa de Dios. Joyadá les dijo: 'Aquí tienen ustedes al hijo del rey; él reinará como dijo Yavé a los hijos de David."
,"4":"Esto es lo que tienen que hacer: Un tercio de ustedes, sacerdotes y levitas, los que entran en sábado, se quedarán de porteros en las entradas;"
,"5":"otra tercera parte en la casa del rey; y otro tercio en la Puerta del Fundamento; mientras que todo el pueblo estará en los patios de la Casa de Yavé."
,"6":"Nadie podrá entrar en la Casa de Yavé fuera de los sacerdotes y los levitas que estén de servicio; éstos podrán entrar por estar consagrados. Pero todo el pueblo hará la guardia de Yavé."
,"7":"Los levitas se pondrán alrededor del rey, cada uno con sus armas en la mano, y cualquiera que entre en la Casa morirá. Sólo ellos acompañarán al rey cuando entre y cuando salga.'"
,"8":"Los levitas y todo Judá hicieron todo lo que les había mandado el sacerdote Joyadá. Cada uno reunió a sus hombres, tanto los que entraban el sábado como los que salían el sábado; pues el sacerdote Joyadá no exceptuó a ninguna de las secciones."
,"9":"El sacerdote Joyadá entregó a los jefes de cien lanzas y los escudos grandes y pequeños del rey David que se encontraban en la Casa de Dios,"
,"10":"y apostó a todo el pueblo, cada uno con su lanza en la mano, desde el ala oriental de la Casa hasta el ala occidental, entre el altar y la Casa, para que rodeasen al rey."
,"11":"Entonces hicieron salir de allí al hijo del rey y le pusieron la corona y las cadenillas. Lo proclamaron rey; Joyadá y sus hijos lo ungieron y gritaron: '¡Viva el rey!'"
,"12":"Atalía, al escuchar los gritos del pueblo que corría y aclamaba al rey, vino a la Casa de Yavé, donde estaba el pueblo."
,"13":"Miró, y vio al rey junto a la columna, a la entrada, y a los jefes y las trompetas junto al rey, a todo el pueblo lleno de alegría que tocaba las trompetas, y a los cantores que, con instrumentos de música, dirigían los cánticos de alabanza. Entonces Atalía rasgó sus vestidos y gritó: '¡Traición, traición!'"
,"14":"Pero el sacerdote Joyadá dio la siguiente orden a los jefes de cien que estaban al frente de las tropas: 'Háganla salir de las filas, y el que la siga sea pasado por espada.' Porque había dicho el sacerdote: 'No la maten en la Casa de Yavé.'"
,"15":"Cuando llegó a la casa del rey por el camino de la Entrada de los Caballos, allí la mataron."
,"16":"Joyadá pactó con todo el pueblo y el rey una alianza según la cual se comprometían a ser el pueblo de Yavé."
,"17":"Después fue todo el pueblo a la casa de Baal y la destruyeron, rompiendo sus altares y sus imágenes, y mataron a Matán, sacerdote de Baal, ante los altares."
,"18":"Joyadá puso centinelas en la Casa de Yavé, a las órdenes de los sacerdotes y levitas que David había repartido en la Casa de Yavé, conforme a lo escrito en la Ley de Moisés, para ofrecer los sacrificios con alegría y cánticos, según los reglamentos de David."
,"19":"Puso porteros junto a las puertas de la Casa de Yavé para que no entrara ninguno que por cualquier causa fuera impuro."
,"20":"Después encabezó a los jefes de cien, a los notables, a los dirigentes del pueblo y a toda la población del país; y haciendo bajar al rey de la Casa de Yavé, entraron por la puerta superior en la casa del rey y lo sentaron en el trono del reino."
,"21":"Todo el pueblo del país estaba contento, y la ciudad quedó tranquila; en cuanto a Atalía, la habían matado a espada."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Joás tenía siete años cuando empezó a reinar y reinó cuarenta años en Jerusalén. Su madre se llamaba Sibia y era de Bersebá."
,"2":"Joás hizo lo que es bueno delante de Yavé mientras vivió el sacerdote Joyadá."
,"3":"Este lo casó con dos mujeres y le nacieron hijos e hijas."
,"4":"Después de esto Joás resolvió reparar la Casa de Yavé."
,"5":"Reunió a los sacerdotes y a los levitas y les dijo: 'Recorran las ciudades de Judá y junten cada año plata en todo Israel para reparar la Casa de nuestro Dios. Y dense prisa en esto.' Pero los levitas no se apuraron."
,"6":"Entonces llamó el rey al sumo sacerdote Joyadá, y le dijo: '¿Por qué no has tenido cuidado de que los levitas trajeran de Judá y de Jerusalén la contribución que Moisés, siervo de Yavé, y la asamblea de Israel determinaron para la Tienda de las Citas?'"
,"7":"Los partidos de la impía Atalía y sus hijos habían arruinado la Casa de Dios, llegando incluso a emplear para los baales todas las cosas consagradas de la Casa de Yavé."
,"8":"Mandó el rey que se hiciera una caja, que fue colocada junto a la puerta de la Casa de Yavé, por la parte de afuera;"
,"9":"y publicaron por todo Judá y Jerusalén que debían traer para Yavé la contribución que Moisés, siervo de Dios, había impuesto a Israel en el desierto."
,"10":"Todos los jefes y todo el pueblo se alegraron; y traían la contribución y la echaban en la caja hasta que se llenaba."
,"11":"Cuando llevaban la caja a los inspectores del rey, por medio de los levitas, si veían que había mucho dinero, venía el secretario del rey y el inspector del sumo sacerdote para vaciar la caja; luego la tomaban y volvían a su lugar. Así lo hacían cada día, y recogían dinero en abundancia."
,"12":"El rey y Joyadá se lo daban a los encargados de las reparaciones de la Casa de Yavé, y éstos tomaban a sueldo canteros y carpinteros, y también artesanos en hierro y bronce, para reparar la Casa de Yavé."
,"13":"Así lo hicieron los encargados de la obra, y con sus trabajos adelantaron las reparaciones del edificio; restituyeron la Casa de Dios a su primer estado y la consolidaron."
,"14":"Acabado el trabajo, entregaron al rey y a Joyadá el resto del dinero, con el cual hicieron objetos para la Casa de Yavé: utensilios para el ministerio y para los holocaustos, vasos y objetos de oro y plata. Durante toda la vida de Joyadá los holocaustos se ofrecieron constantemente en la Casa de Yavé. "
,"15":"Envejeció y murió colmado de días. Tenía ciento treinta años cuando murió."
,"16":"Lo sepultaron en la ciudad de David con los reyes, porque había hecho el bien en Israel, con Dios y con su Casa."
,"17":"Después de la muerte de Joyadá los jefes de Judá vinieron a postrarse delante del rey, y el rey les prestó oídos."
,"18":"Abandonaron la Casa de Yavé, el Dios de sus padres, y se interesaron por los troncos sagrados y los ídolos; la cólera estalló contra Judá y Jerusalén, a causa de esta culpa suya."
,"19":"Yavé les mandó profetas que dieron testimonio contra ellos para que volvieran a él, pero no les prestaron oídos."
,"20":"Entonces el Espíritu de Dios revistió a Zacarías, hijo del sacerdote Joyadá, que, presentándose delante del pueblo, les dijo: 'Así dice Dios: ¿Por qué traspasan los mandamientos de Yavé? No tendrán éxito; porque han abandonado a Yavé, él los abandonará a ustedes.'"
,"21":"Mas ellos conspiraron contra él y, por mandato del rey, lo apedrearon en el atrio de la Casa de Yavé."
,"22":"El rey Joás no se acordó de la benevolencia que había tenido con él Joyadá, padre de Zacarías, sino que mató a su hijo, el cual exclamó al morir. 'Véalo Yavé, y haga justicia.'"
,"23":"A la vuelta de un año, subió contra Joás el ejército de los arameos, que invadieron Judá y Jerusalén, mataron de entre la población a todos los jefes del pueblo, y mandaron todo el botín al rey de Damasco,"
,"24":"pues aunque el ejército de los arameos había venido con poca gente, Yavé entregó en sus manos a un ejército muy grande; porque habían abandonado a Yavé, el Dios de sus padres. De este modo los arameos hicieron justicia con Joás. "
,"25":"Y cuando se alejaron de él, dejándolo gravemente enfermo, sus servidores se conjuraron contra él, por la sangre del hijo del sacerdote Joyadá, y lo asesinaron en su cama. Lo sepultaron en la ciudad de David, pero no en el sepulcro de los reyes."
,"26":"Los que conspiraron contra él fueron Zabad, hijo de Simot, la amonita, y Jozabal, hijo de Simrit, la moabita."
,"27":"Lo tocante a sus hijos, la gran cantidad de impuestos que percibió y la restauración de la Casa de Dios, se halla escrito en el comentario del libro de los Reyes. En su lugar reinó su hijo Amasías."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Amasías tenía veinticinco años cuando comenzó a reinar. Reinó veintinueve años en Jerusalén. Su madre Yahadán era de Jerusalén."
,"2":"Obró lo que es bueno a los ojos de Yavé, aunque no de todo corazón."
,"3":"Cuando se sintió fuerte, dio muerte a los servidores que habían asesinado al rey, su padre."
,"4":"Pero no hizo morir a los hijos de ellos, conforme a lo escrito en la Ley, en el libro de Moisés, donde Yavé tenía prescrito: 'No morirán los padres por los hijos ni los hijos por los padres, sino que cada uno morirá por su propio pecado.'"
,"5":"Amasías reunió a todos los judíos de Judá y de Benjamín y los organizó con jefes de millar y de cien; hizo el censo de ellos, desde los veinte años para arriba, y encontró trescientos mil hombres escogidos, aptos para la guerra y el manejo de la lanza y el escudo grande."
,"6":"Tomó también a sueldo en Israel, por cien talentos de plata, cien mil hombres valientes."
,"7":"Pero vino donde él un hombre de Dios que le dijo: 'Oh rey, que no salga contigo el ejército de Israel, porque Yavé no está con Israel, ni con ninguno de los hijos de Efraím."
,"8":"Si vienen contigo, Dios te hará caer ante el enemigo, aunque tengas muchas tropas, porque Dios tiene poder para ayudar y para derribar.'"
,"9":"Amasías respondió al hombre de Dios: '¿Y qué haré con los cien talentos que he dado a la tropa de Israel?' Contestó el hombre de Dios: 'Yavé tiene poder para darte mucho más que eso.'"
,"10":"Y Amasías separó los destacamentos que le habían venido de Efraím, para que se volvieran a sus lugares. Ellos se enojaron mucho contra Judá y se volvieron a sus casas enfurecidos."
,"11":"Amasías cobró ánimo y, tomando el mando de su pueblo, marchó al Valle de la Sal, donde derrotó a diez mil hombres de los hijos de Seír."
,"12":"Los hijos de Judá apresaron vivos a diez mil de ellos y, llevándolos a la cumbre de la Peña, los precipitaron desde allí, quedando todos ellos reventados."
,"13":"Entre tanto, las tropas que Amasías había despedido para que no fueran con él a la guerra se desparramaron por las ciudades de Judá, desde Samaria hasta Betorón, pero fueron derrotados tres mil de ellos y se recogió mucho botín."
,"14":"Después de que regresó Amasías de su victoria sobre los edomitas, introdujo los dioses del pueblo de Seír, y los escogió para que fueran dioses suyos y postrándose ante ellos les quemó incienso."
,"15":"Entonces se enojó Yavé contra Amasías y le mandó un profeta a decirle: '¿Por qué has ido a buscar a los dioses de ese pueblo, que no han podido librar de tu mano a su propia gente?'"
,"16":"Mientras él le hablaba, Amasías lo interrumpió: '¿Acaso te hemos hecho consejero del rey? ¡Cállate!, no sea que yo dé la orden de matarte.' Entonces el profeta terminó con estas palabras: 'Ya veo que Dios ha determinado destruirte, porque después de actuar así no quieres escuchar mis advertencias.'"
,"17":"Amasías, rey de Judá, después de haber consultado, mandó mensajeros a Joás, hijo de Joacaz, hijo de Jehú, rey de Israel, para decirle: 'Sube y nos veremos las caras.'"
,"18":"Pero Joás, rey de Israel, mandó decir a Amasías, rey de Judá: 'El cardo del Líbano mandó a decir al cedro el Líbano: Dame tu hija para mujer de mi hijo. Pero las bestias salvajes del Líbano pasaron y pisotearon el cardo."
,"19":"Tú te dices: 'He derrotado a Edom.' Por esto te sientes muy glorioso, pero quédate ahora en tu casa. ¿Por qué exponerte a una calamidad y a caer tú y Judá contigo?'"
,"20":"Pero Amasías no lo escuchó, pues Dios había decidido entregarlo en manos de sus enemigos, por haberse dirigido a los dioses de Edom."
,"21":"Subió Joás, rey de Israel, y se enfrentaron, él y Amasías, rey de Judá, en Bet-Semes de Judá."
,"22":"Los de Judá fueron derrotados por Israel y huyeron cada uno a su casa."
,"23":"Joás, rey de Israel, capturó a Amasías, rey de Judá, hijo de Joás, hijo de Ocozías, en Bet-Semes, y lo llevó a Jerusalén; y echó abajo la muralla de Jerusalén, desde la puerta de Efraím hasta la puerta del Angulo."
,"24":"Luego tomó todo el oro y la plata y todos los objetos que se encontraban al cuidado de Obededom en la Casa de Dios y los tesoros de la casa del rey; tomó rehenes y se volvió a Samaria."
,"25":"Amasías, hijo de Joás, rey de Judá, vivió quince años después de la muerte de Joás, hijo de Joacaz, rey de Israel."
,"26":"Lo demás referente a Amasías, del comienzo al fin, ¿no está escrito en el libro de los Reyes de Judá y de Israel?"
,"27":"Después de que Amasías se apartó de Yavé, se conjuraron contra él en Jerusalén, por lo que huyó a Laquis; pero mandaron gente en su persecución hasta Laquis y allí lo mataron."
,"28":"Y transportando el cadáver en caballos, lo sepultaron con sus padres en la ciudad de David."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Todo el pueblo de Judá tomó a Ozías, que tenía dieciséis años, y lo proclamaron rey en lugar de su padre, Amasías."
,"2":"Reconstruyó Elat y la devolvió a Judá, después que el rey se hubo acostado con sus padres."
,"3":"Ozías tenía dieciséis años cuando empezó a reinar y reinó cincuenta y dos años en Jerusalén. Su madre, Jecolía, era de Jerusalén."
,"4":"Hizo lo que es bueno delante de Yavé, como lo había hecho su padre, Amasías."
,"5":"Buscó a Dios durante la vida de Zacarías, que enseñaba el temor de Dios; y mientras buscó a Yavé, Dios le dio prosperidad."
,"6":"Salió a pelear contra los filisteos y los obligó a arrasar una parte de las murallas de Gat, de Jabné y de Asdod; luego construyó ciudades frente a Asdod y a los filisteos."
,"7":"Dios lo asistió contra los filisteos, contra los árabes que vivían en Gur-Baal y contra los maonitas."
,"8":"Los maonitas pagaron tributo a Ozías y su fama llegó hasta la frontera de Egipto porque se había hecho sumamente poderoso."
,"9":"Ozías construyó torres en Jerusalén sobre la Puerta del Angulo, sobre la Puerta del Valle y en el Angulo y las fortificó."
,"10":"Construyó torres en el desierto y excavó muchas cisternas, pues tenía numeroso ganado en la tierra baja, y en la llanura, así como labradores y viñadores en las montañas y en los campos fértiles, porque se interesaba por la agricultura."
,"11":"Ozías tenía un ejército que hacía la guerra; eran tropas que salían a campaña por grupos, conforme al número de su censo hecho bajo la vigilancia de Jejiel, el escriba, y Maseías, el notario, a las órdenes de Janaías, uno de los jefes del rey."
,"12":"El número total de los jefes de familias paternas entre estos valientes era de dos mil seiscientos."
,"13":"A sus órdenes estaba un ejército de trescientos siete mil quinientos hombres que hacían la guerra con gran valor, para ayudar al rey contra el enemigo."
,"14":"Ozías proporcionó a todo aquel ejército escudos, lanzas, cascos, corazas, arcos y hondas para tirar piedras."
,"15":"Hizo construir en Jerusalén máquinas inventadas por un ingeniero, que colocó en las torres y en los ángulos de los muros para disparar saetas y piedras grandes. Su fama se extendió lejos porque fue prodigioso el modo como supo buscarse colaboradores hasta hacerse fuerte."
,"16":"Pero una vez fortalecido en su poder, se puso muy orgulloso hasta corromperse; desobedeció a Yavé, su Dios, entrando en el templo de Yavé para quemar incienso sobre el altar del incienso."
,"17":"Fue tras él Azarías, el sacerdote, y con él ochenta sacerdotes de Yavé, hombres valientes,"
,"18":"que se opusieron al rey Ozías y le dijeron: 'No te corresponde a ti, Ozías, quemar incienso a Yavé, sino a los sacerdotes, los hijos de Aarón, que han sido consagrados para quemar el incienso. Sal del santuario, porque estás renegando, lo que no te merecerá honor ante Yavé tu Dios.'"
,"19":"Entonces Ozías, que tenía en la mano un incensario para ofrecer incienso, se enfureció y mientras que se enojaba contra los sacerdotes brotó la lepra en su frente, a vista de los sacerdotes, en la Casa de Yavé, junto al altar del incienso."
,"20":"El sumo sacerdote Azarías y todos los sacerdotes, al mirarlo, vieron que tenía lepra en la frente. Por lo cual lo echaron de allí rápidamente; y él mismo se apresuró a salir porque Yavé lo había herido."
,"21":"El rey Ozías quedó leproso hasta el día de su muerte y vivió en una casa aislada como leproso, porque había sido excluido de la Casa de Yavé; su hijo Jotam estaba al frente de la Casa del rey y gobernaba al pueblo."
,"22":"El resto de los hechos de Ozías, del comienzo al fin, los escribió el profeta Isaías, hijo de Amís."
,"23":"Al fin fue Ozías a descansar con sus padres, y lo sepultaron en el terreno donde está el sepulcro de los reyes, porque decían: 'Es un leproso.' En su lugar reinó su hijo Jotam."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Jotam tenía veinticinco años cuando comenzó a reinar, y reinó dieciséis años en Jerusalén. Su madre Jerubá era hija de Sadoq."
,"2":"Jotam se portó bien con Yavé, como lo había hecho su padre Ozías. Sin embargo, no iba a la Casa de Yavé, y el pueblo seguía corrompiéndose."
,"3":"Construyó la puerta superior de la Casa de Yavé, e hizo muchas obras en los muros de Ofel."
,"4":"Edificó también ciudades en los cerros de Judá, y edificó castillos y torres en los bosques."
,"5":"Declaró la guerra al rey de los amonitas, a los que venció. Los hijos de Amón le dieron aquel año cien talentos de plata, diez mil cargas de trigo y diez mil de cebada. Los amonitas le trajeron lo mismo el año segundo y el tercero."
,"6":"Jotam llegó a ser poderoso, porque se afirmó en los caminos de Yavé, su Dios."
,"7":"El resto de los hechos de Jotam, todas sus guerras y sus obras, están escritas en el libro de los Reyes de Israel y de Judá."
,"8":"Tenía veinticinco años cuando comenzó a reinar, y reinó dieciséis años en Jerusalén."
,"9":"Finalmente, Jotam fue a descansar con sus padres y lo sepultaron en la ciudad de David, sucediéndole su hijo Ajaz."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Ajaz tenía veinte años cuando empezó a reinar, y reinó dieciséis años en Jerusalén. No hizo lo que es recto a los ojos de Yavé, como su padre David,"
,"2":"sino que siguió los senderos de los reyes de Israel e incluso fundió ídolos de los baales."
,"3":"Además, quemó incienso en el valle de Ben-Hinom y sacrificó sus hijos por el fuego, imitando las costumbres abominables de los paganos a los que Yavé quitó el país para dárselo a Israel."
,"4":"Ofrecía sacrificios y quemaba incienso en los santuarios altos, sobre las lomas y bajo todo árbol frondoso."
,"5":"Yavé, su Dios, le entregó en manos del rey de los arameos; éstos lo derrotaron, haciéndole gran número de prisioneros, que fueron llevados a Damasco. También él fue entregado en manos del rey de Israel, que le causó una gran derrota."
,"6":"Pecaj, hijo de Remalías, mató en un solo día a ciento veinte mil judíos, todos ellos hombres valientes; es que habían abandonado a Yavé, el Dios de sus padres."
,"7":"Zikrí, uno de los valientes de Efraím, mató a Masías, hijo del rey, a Azricam, mayordomo del palacio, y a Elcaná, segundo después del rey."
,"8":"Los hijos de Israel se llevaron de entre sus hermanos de Judá a doscientos mil prisioneros: mujeres, hijos e hijas; se apoderaron también de un enorme botín que se llevaron a Samaria."
,"9":"Había allí un profeta de Yavé, llamado Obred, que salió al encuentro del ejército que volvía a Samaria y les dijo: 'Miren que Yavé, el Dios de sus padres, estaba irritado contra la gente de Judá y por esto los ha entregado en manos de ustedes. Pero ustedes los han matado con una crueldad increíble."
,"10":"Y ahora quieren someter a esclavitud a la población de Judá y de Jerusalén y que en adelante sean esclavos y esclavas de ustedes. Miren que ustedes mismos no son inocentes ante Yavé, su Dios. "
,"11":"Oigan, pues, devuelvan a sus hermanos que han tomado prisioneros, porque si no el furor de la ira de Yavé está sobre nosotros.'"
,"12":"Entonces algunos hombres de los jefes de Israel, Azarías, hijo de Jojanan, Berejías, hijo de Mesilemot, Ezequías, hijo de Salum, y Amasá, hijo de Jadlay, se opusieron a los que volvían de la guerra."
,"13":"Y les dijeron: 'No traigan aquí a estos prisioneros. Ya somos culpables contra Yavé, y ustedes ¿quieren aumentar todavía el número de nuestros pecados? Pues grande es nuestro delito y el furor de la ira de Dios amenaza a Israel.'"
,"14":"Entonces la tropa dejó los prisioneros y el botín delante de los jefes y de toda la asamblea."
,"15":"Se levantaron los hombres antes mencionados, reanimaron a los prisioneros y vistieron con prendas tomadas del botín a todos los que estaban desnudos, dándoles además calzado. Les dieron de comer y beber y los lavaron; transportando en burros a todos los que estaban más débiles, los llevaron a la frontera de su patria, a Jericó, ciudad de las Palmeras, y luego se volvieron a Samaria."
,"16":"En aquel tiempo el rey Ajaz envió mensajeros a los reyes de Asur para que lo socorrieran."
,"17":"Porque los edomitas habían venido otra vez y habían derrotado a Judá, llevándose prisioneros."
,"18":"También los filisteos invadieron las ciudades de la tierra baja y del Negueb de Judá, y tomaron Bet-Semes, Ayalón, Guederot, Socó con sus aldeas, Timná con sus aldeas y Guimzó con sus aldeas, y se establecieron allí."
,"19":"Así Yavé humillaba a Judá por culpa de Ajaz, su rey, que corrompía a su país y se había apartado de Yavé."
,"20":"Vino contra él Teglatfalasar, rey de Asur, lo sitió, pero no llegó a dominarlo."
,"21":"Ajaz despojó la Casa de Yavé y la casa del rey y de los jefes para hacer regalos al rey de Asur, pero de nada le sirvió."
,"22":"Aun en el tiempo del asedio, el rey Ajaz persistió en su infidelidad a Yavé."
,"23":"Ofrecía sacrificios a los dioses de Damasco que lo habían derrotado, pues se decía: 'Los dioses de los reyes de Aram los ayudan a ellos; les ofreceré, pues, sacrificios y me ayudarán a mí.' Ellos fueron la causa de su ruina y la de todo Israel."
,"24":"Ajaz juntó algunos de los utensilios de la Casa de Dios y los hizo añicos, luego cerró las puertas de la Casa de Yavé y fabricó altares en todas las esquinas de Jerusalén."
,"25":"Hizo santuarios altos en cada una de las ciudades de Judá para quemar incienso a otros dioses, provocando así la ira de Yavé, el Dios de sus padres."
,"26":"El resto de sus hechos y todas su obras, del comienzo al fin, están escritos en el libro de los Reyes de Judá e Israel."
,"27":"Se acostó Ajaz con sus padres y lo sepultaron dentro de la ciudad en Jerusalén; pues no lo pusieron en el sepulcro de los reyes de Israel. En su lugar reinó su hijo Ezequías."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Ezequías tenía veinticinco años cuando comenzó a reinar, y reinó veintinueve años en Jerusalén. Su madre se llamaba Abía, hija de Zacarías."
,"2":"Hizo lo que era bueno a los ojos de Yavé, como David su padre."
,"3":"En el año primero de su reinado, el primer mes, abrió las puertas de la Casa de Yavé y las reparó."
,"4":"Hizo venir a los sacerdotes y levitas, los reunió en la plaza oriental"
,"5":"y les dijo: 'Escúchenme, levitas. Santifíquense ahora y santifiquen la Casa de Yavé, el Dios de nuestros padres, y saquen fuera del santuario todas las cosas impuras."
,"6":"Porque nuestros padres han sido infieles y se han portado mal con Yavé, nuestro Dios; lo han abandonado y se han puesto indiferentes a la morada de Yavé; le han vuelto las espaldas."
,"7":"Hasta llegaron a cerrar las puertas del vestíbulo, apagaron las lámparas y no quemaron más incienso, ni ofrecieron holocaustos al Dios de Israel en el santuario."
,"8":"Por eso, la ira de Yavé ha venido sobre Judá y Jerusalén, y él los ha convertido en objeto de espanto, terror y rechifla, como lo estamos viendo con nuestros ojos."
,"9":"Por eso han caído a espada nuestros padres; y nuestros hijos, hijas y mujeres han sido llevados presos."
,"10":"Pero ahora he decidido hacer alianza con Yavé, el Dios de Israel, para que aparte de nosotros el furor de su ira."
,"11":"Hijos míos, no sean ya descuidados, porque Yavé los ha elegido a ustedes para que le sirvan en su ministerio, para ser sus ministros y para quemarle incienso.'"
,"12":"Se levantaron entonces los levitas: de los hijos de Quehat, Májat, hijo de Amasay, y Joel, hijo de Azarías; de los hijos de Merari, Quis, hijo de Abdí, y Azarías, hijo de Jelaleel; de los hijos de Guersón, Joaj, hijo de Zimmá, y Edem, hijo de Joaj;"
,"13":"Simrí y Yeiel, de los hijos de Elisafán; Zacarías y Matanías, de los hijos de Asaf;"
,"14":"Jejiel y Simí, de los hijos de Hemán; Semaías y Uzziel, de los hijos de Jedutún."
,"15":"Estos reunieron a sus hermanos, se santificaron y vinieron a purificar la Casa de Yavé, conforme al mandato del rey, según las palabras de Yavé."
,"16":"Los sacerdotes entraron en el interior de la Casa de Yavé para purificarla, y sacaron de la Casa de Yavé al patio todas las impurezas que encontraron en el santuario de Yavé. Los levitas, por su parte, las amontonaron para llevarlas fuera, al torrente Cedrón."
,"17":"Comenzaron la consagración el día primero del primer mes, y el día octavo del mes entraron al Vestíbulo de Yavé. Pasaron dieciocho días consagrando la Casa de Yavé. Y terminaron el día dieciséis del mes primero."
,"18":"Fueron luego a las habitaciones del rey Ezequías y le dijeron: 'Hemos purificado toda la Casa de Yavé, el altar del holocausto con todos sus utensilios, y la mesa de los panes ofrecidos con todos sus utensilios."
,"19":"Hemos reparado y santificado todos los objetos que, llevado por su infidelidad, el rey Ajaz profanó durante su reinado, y están ante el altar de Yavé.'"
,"20":"Entonces se levantó el rey Ezequías de mañana, reunió a los jefes de la ciudad y subió a la Casa de Yavé."
,"21":"Trajeron siete novillos, siete carneros, siete corderos, siete machos cabríos que se sacrificaron por los pecados del reino, del santuario y de todo el país de Judá; y mandó a los sacerdotes hijos de Aarón que ofrecieran holocaustos sobre el altar de Yavé."
,"22":"Sacrificaron los novillos, y los sacerdotes recogieron la sangre que derramaron sobre el altar; luego inmolaron los carneros y rociaron con su sangre el altar; degollaron los corderos y con la sangre rociaron el altar."
,"23":"Acercaron después los machos cabríos por el pecado, ante el rey y la asamblea, y éstos pusieron las manos sobre ellos."
,"24":"Los sacerdotes los sacrificaron y ofrecieron la sangre en sacrificio por el pecado junto al altar como expiación por todo Israel; porque el rey había ordenado que el holocausto y el sacrificio por el pecado fuesen por todo Israel."
,"25":"Luego apostó en la Casa de Yavé a los levitas con címbalos, salterios y cítaras, según las disposiciones de David, de Gad, vidente del rey, y de Natán, profeta, pues Yavé da sus mandamientos por medio de sus profetas."
,"26":"Cuando ocuparon su sitio con los instrumentos de David y los sacerdotes con las trompetas,"
,"27":"Ezequías mandó ofrecer el holocausto sobre el altar. Y al comenzar el holocausto comenzaron también los cantos y tocaron las trompetas junto con el coro de los instrumentos de David, rey de Israel."
,"28":"Toda la asamblea, estando postrada, cantaron los cánticos y tocaron las trompetas hasta que se consumió el holocausto."
,"29":"Consumido el holocausto, el rey y todos los presentes doblaron las rodillas y se postraron."
,"30":"Después el rey Ezequías y los jefes mandaron a los levitas que alabaran a Yavé con las palabras de David y del vidente Asaf; y ellos cantaron alabanzas con alegría, se pusieron de rodillas y se postraron."
,"31":"Después tomó la palabra Ezequías y dijo: 'Ahora ustedes se han consagrado totalmente a Yavé; acérquense y traigan sacrificios de acción de gracias a la Casa de Yavé.' Y la asamblea ofreció sacrificios en acción de gracias, y los de corazón generoso, también holocaustos."
,"32":"El número de los holocaustos ofrecidos fue de setenta bueyes, cien carneros y doscientos corderos; todos ellos consumidos por el fuego para Yavé."
,"33":"Se sacrificaron también seiscientos bueyes y tres mil ovejas."
,"34":"Pero como los sacerdotes eran pocos y no daban abasto para desollar todas estas víctimas, los ayudaron sus hermanos los levitas hasta terminar la labor, y hasta que los sacerdotes se purificaron. Pues los levitas estaban más instruidos que los sacerdotes sobre los ritos de purificación."
,"35":"Hubo muchos holocaustos además de las grasas de los sacrificios de comunión y de las libaciones para los holocaustos. Así quedó restablecido el culto de la Casa de Yavé."
,"36":"Ezequías y el pueblo entero se pusieron alegres por lo que Dios acababa de hacer en medio de ellos; pues todo se hizo rápidamente."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Ezequías mandó mensajeros a todo Israel y Judá, y escribió también cartas a Efraím y Manasés para que vinieran a la Casa de Yavé a Jerusalén, a fin de celebrar la Pascua en honor de Yavé, el Dios de Israel."
,"2":"El rey y sus jefes y toda la asamblea de Jerusalén acordaron celebrar la Pascua en el mes segundo,"
,"3":"ya que no podían celebrarla a su debido tiempo porque los sacerdotes no se habían santificado en número suficiente y el pueblo no se había reunido en Jerusalén."
,"4":"Esto le pareció bien al rey y a toda la asamblea."
,"5":"Y decidieron enviar aviso a todo Israel, desde Bersebá hasta Dan, para que vinieran a Jerusalén a celebrar la Pascua en honor de Yavé, el Dios de Israel, porque hacía mucho tiempo que no se celebraba según el rito prescrito."
,"6":"Los correos con las cartas del rey y de sus jefes recorrieron todo Israel y Judá, como el rey lo había mandado, para decir: 'Hijos de Israel, vuelvan a Yavé, el Dios de Abraham, de Isaac y de Israel, para que tenga compasión del resto que ha quedado de ustedes, los que han escapado de las manos de los reyes de Asur."
,"7":"No sean como nuestros padres y hermanos, que fueron infieles a Yavé, el Dios de sus padres, por lo cual él dejó que fueran arruinados, como están viendo."
,"8":"No endurezcan sus corazones como nuestros padres, sino que den la mano a Yavé, vengan a su santuario que él ha santificado para siempre, sirvan a Yavé, nuestro Dios, y el furor de su ira se apartará de ustedes."
,"9":"Porque si ustedes vuelven a Yavé, nuestros hermanos y nuestros hijos encontrarán misericordia ante aquellos que los llevaron cautivos, y volverán a esta tierra, pues Yavé, nuestro Dios, es clemente y misericordioso, y no apartará de nosotros su rostro si nos arrepentimos ante él.'"
,"10":"Los correos pasaron de ciudad en ciudad"
,"11":"por el país de Efraím y de Manasés llegando hasta Zabulón. Pero se reían y se burlaban de ellos. Sin embargo, hombres de Aser, Manasés y Zabulón hicieron penitencia y vinieron a Jerusalén."
,"12":"También en Judá se dejó sentir la mano de Dios que les dio un mismo corazón para cumplir el mandato del rey y de los jefes, según la palabra de Yavé."
,"13":"Se reunió en Jerusalén mucha gente para celebrar la fiesta de los Azimos en el mes segundo; era una asamblea muy grande."
,"14":"Se levantaron y quitaron los altares que había en Jerusalén, quitaron también todos los altares en que se quemaba incienso y los arrojaron al torrente Cedrón."
,"15":"Sacrificaron la Pascua el día catorce del mes segundo. También los sacerdotes y los levitas, llenos de confusión, se santificaron y trajeron holocaustos a la Casa de Yavé."
,"16":"Ocuparon sus puestos según su reglamento, conforme a la Ley de Moisés, hombre de Dios; y los sacerdotes rociaban con la sangre que recibían de mano de los levitas."
,"17":"Y como muchos de la asamblea no se habían santificado, los levitas fueron los encargados de inmolar los corderos pascuales para todos los que no se hallaban puros, a fin de santificarlos para Yavé."
,"18":"Pues una gran parte del pueblo, muchos de Efraím, de Manasés, de Isacar, y de Zabulón, no se habían purificado y con todo comieron la Pascua sin observar lo escrito. Pero Ezequías rezó por ellos diciendo: 'Que Yavé que es bueno perdone "
,"19":"a todos aquellos cuyo corazón está dispuesto a buscar a Yavé Dios, el Dios de sus padres, aunque no tengan la pureza requerida para las cosas sagradas.'"
,"20":"Y Yavé escuchó a Ezequías y no castigó al pueblo por este incumplimiento."
,"21":"Los hijos de Israel que estaban en Jerusalén celebraron la fiesta de los Azimos por siete días con gran alegría, mientras los levitas y los sacerdotes alababan a Yavé todos los días con todas sus fuerzas."
,"22":"Ezequías habló al corazón de todos los levitas, que demostraban tener perfecto conocimiento de Yavé. Celebraron la solemnidad durante siete días sacrificando sacrificios de comunión y alabando a Yavé, el Dios de sus padres."
,"23":"Toda la asamblea decidió celebrar la solemnidad por otros siete días y la celebraron con júbilo siete días más."
,"24":"Ezequías, rey de Judá, había reservado para toda la asamblea mil novillos y siete mil ovejas. Los jefes, por su parte, habían reservado para la asamblea mil novillos y diez mil ovejas. Y muchos sacerdotes estaban listos después de cumplir los ritos de purificación."
,"25":"Toda la asamblea de Judá, los sacerdotes y los levitas, y también toda la asamblea que había venido de Israel y los forasteros venidos de la tierra de Israel, lo mismo que los que vivían en Judá, estaban muy alegres."
,"26":"Hubo gran gozo en Jerusalén porque desde los días de Salomón, hijo de David, rey de Israel, no se había visto cosa semejante."
,"27":"Los sacerdotes y levitas bendijeron al pueblo; y fue escuchada su voz y su oración penetró en el cielo a su santa Morada."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Terminado todo esto, salieron todos los israelitas que se encontraban presentes a recorrer las ciudades de Judá y rompieron las piedras paradas, abatieron los troncos sagrados y derribaron los santuarios de lomas y los altares en todo Judá y Benjamín, y también en Efraím y Manasés, hasta acabar con ellos. Después volvieron todos los hijos de Israel, cada cual a su propiedad, a sus ciudades."
,"2":"Ezequías restableció las clases de los sacerdotes y de los levitas, cada uno en su sección según su servicio, ya fuera sacerdote, ya levita, ya se tratara de holocaustos y sacrificios de comunión, ya de servicio litúrgico, acción de gracias o himnos en las puertas del campamento de Yavé."
,"3":"El rey destinó una parte de sus riquezas para los holocaustos de los sábados, de las lunas nuevas y de las solemnidades, según lo escrito en la Ley de Yavé."
,"4":"Mandó al pueblo que habitaba en Jerusalén que entregara a los sacerdotes y levitas la parte que les corresponde, a fin de que pudieran perseverar en la Ley de Yavé."
,"5":"Cuando se promulgó esta disposición, los hijos de Israel trajeron en abundancia las primicias del trigo, del vino, del aceite y de la miel y de todos los productos del campo: ofrecieron abundantes diezmos de todo."
,"6":"Los hijos de Israel y de Judá que vivían en las ciudades trajeron también el diezmo del ganado mayor y menor y el diezmo de las cosas sagradas, consagradas a Yavé, su Dios, y los dieron por montones."
,"7":"En el tercer mes comenzaron a apilar los montones y terminaron el séptimo mes."
,"8":"Ezequías y los jefes vinieron a ver los montones y bendijeron a Yavé y a su pueblo Israel."
,"9":"Cuando Ezequías preguntó a los sacerdotes y levitas acerca de los montones,"
,"10":"respondió el sumo sacerdote Azarías, de la familia de Sadoq, y dijo: 'Desde que comenzaron a traer las ofrendas reservadas a la Casa de Yavé, hemos comido y nos hemos saciado, y aún sobra muchísimo, porque Yavé ha bendecido a su pueblo; y esta gran cantidad es la que sobra.'"
,"11":"Ezequías entonces mandó que prepararan salas en la Casa de Yavé. Las prepararon,"
,"12":"y llevaron allí constantemente las ofrendas reservadas, los diezmos y las cosas sagradas. El levita Gonanías fue nombrado intendente, y Simí, hermano suyo, era el segundo."
,"13":"Jejiel, Azarías, Najot, Azael, Jerimot, Josabat, Eliel, Kimakías, Majot y Benaías eran inspectores, a las órdenes de Konanías y de Simí, su hermano, bajo la vigilancia del rey Ezequías y de Ozarías, príncipe de la Casa de Dios."
,"14":"El levita Coré, hijo de Jimná, portero de la puerta oriental, estaba encargado de las ofrendas voluntarias hechas a Dios y debía repartir las ofrendas reservadas a Yavé y las cosas sacratísimas."
,"15":"En las ciudades sacerdotales estaban permanentemente bajo sus órdenes Edem, Mibyamín, Jesua, Semaías, Amarías y Sekanías para repartir a sus hermanos, así grandes como chicos, según sus clases,"
,"16":"sin perjudicar a los hombres de treinta años para arriba inscritos en las genealogías, a todos los que entraban en la Casa de Yavé para las tareas de cada día, para cumplir los servicios de su ministerio, conforme a sus clases."
,"17":"Los sacerdotes estaban inscritos en las genealogías, conforme a sus casas paternas, igual que los levitas, desde los veinte años en adelante, según sus obligaciones y sus clases."
,"18":"Hubo que inscribir a todos sus niños, sus mujeres, sus hijos e hijas, junto con toda la asamblea, mientras ellos permanecían atareados en las cosas sagradas."
,"19":"Para los sacerdotes, hijos de Aarón, que vivían en el campo en las aldeas de sus ciudades, había en cada ciudad hombres designados nominalmente, para dar las porciones a todos los varones de familia sacerdotal y a todos los levitas inscritos en las genealogías."
,"20":"Así procedió Ezequías en todo Judá haciendo lo que era bueno y recto y verdadero, ante Yavé su Dios. Todas las obras que realizó en servicio de la Casa de Yavé, de la Ley y los mandamientos, las hizo buscando a su Dios con todo su corazón y tuvo éxito."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Después de todas estas pruebas de fidelidad de Ezequías vino Senaquerib, rey de Asur, invadió Judá, sitió dos ciudades fortificadas y mandó derribar las murallas."
,"2":"Cuando Ezequías vio que Senaquerib venía con intención de atacar a Jerusalén"
,"3":"se reunió con todos los jefes y hombres valerosos y llegaron al acuerdo de cortar las fuentes de agua que había fuera de la ciudad."
,"4":"Se juntó mucha gente y cortaron todas las fuentes de agua y los esteros que corrían por el medio del territorio, diciendo: 'Si vienen los asirios, que tengan el agua medida.'"
,"5":"Con gran ánimo reparó la parte de la muralla que estaba derribada, alzando torres sobre ella. Levantó, además, otra muralla exterior, fortificó el Milo en la ciudad de David y fabricó gran cantidad de armas y escudos."
,"6":"Nombró generales al frente de las tropas, los reunió a todos en la plaza de la puerta de la ciudad y hablándoles al corazón les dijo:"
,"7":"'Sean fuertes y tengan ánimo, no teman ni desmayen ante el rey de Asur ni ante todo el ejército que viene con él, porque es más el que está con nosotros que lo que está con él."
,"8":"Con él hay una fuerza humana, pero con nosotros está Yavé, nuestro Dios, para ayudarnos y combatir nuestros combates.',El pueblo quedó confortado con las palabras de Ezequías, rey de Judá."
,"9":"Después de esto, Senaquerib, rey de Asur, que estaba sitiando Laquis con todas sus tropas, envió mensajeros a Ezequías, rey de Judá, y a los judíos en Jerusalén para decirles:"
,"10":"'Así dice Senaquerib, rey de Asur: ¿En quién tienen puesta su confianza, para permanecer cercados en Jerusalén?"
,"11":"¿No los engaña Ezequías cuando les dice: Yavé, nuestro Dios, nos librará de la mano del rey de Asiria? ¿No es culpable de que van a morir de hambre y sed?"
,"12":"¿No es este mismo Ezequías el que ha quitado los santuarios altos y los altares y ha dicho a Judá y a Jerusalén: Ante un solo altar se postrarán y sobre él quemarán incienso?"
,"13":"¿Acaso ignoran ustedes lo que yo y mis padres hemos hecho con todos los pueblos de los demás países? ¿Por ventura los dioses de estas naciones han sido capaces de liberar sus territorios de mi mano?"
,"14":"¿Quién de entre todos los dioses de aquellas naciones que mis padres exterminaron pudo liberar a su pueblo de mi mano? ¿Es que el Dios de ustedes podrá librarse de mi mano?"
,"15":"Así, pues, que no los engañe Ezequías ni los seduzca con vanas promesas. No lo crean. Ningún Dios de ninguna nación o reino ha podido salvar a su pueblo de mi mano, ni de la mano de mis padres. ¡Cuánto menos podrán los dioses de ustedes librarlos de mi mano!'"
,"16":"Sus mensajeros dijeron todavía más cosas contra Yavé y contra Ezequías, su siervo."
,"17":"Escribió además cartas para insultar a Yavé, Dios de Israel, hablando contra él de este modo: 'Así como los dioses de las naciones de otros países no las han salvado de mi mano, así tampoco el Dios de Ezequías salvará a su pueblo de mi mano.'"
,"18":"Los mensajeros gritaban en voz alta, en lengua judía, al pueblo de Jerusalén que estaba sobre la muralla, para atemorizarlos y asustarlos y así poder conquistar la ciudad."
,"19":"Hablaban del Dios de Jerusalén como de los dioses de los pueblos de la tierra, que son obras de manos de hombre."
,"20":"En esta situación, el rey Ezequías y el profeta Isaías, hijo de Amós, oraron y clamaron al cielo."
,"21":"Y Yavé envió un ángel que exterminó a todos los mejores guerreros de su ejército, a los príncipes y a los jefes que había en el campamento del rey de Asur. Este volvió a su tierra con gran vergüenza y al entrar a la casa de su dios, allí mismo, sus propios hijos lo mataron a espada."
,"22":"Así salvó Yavé a Ezequías y a los habitantes de Jerusalén de la mano de Senaquerib, rey de Asur, y de la mano de todos sus enemigos, y les dio paz por todos lados."
,"23":"Muchos trajeron entonces ofrendas a Yavé, a Jerusalén, y presentes a Ezequías, rey de Judá; el cual desde aquel entonces adquirió gran prestigio a los ojos de todas las naciones."
,"24":"En aquellos días Ezequías cayó enfermo de muerte; pero hizo oración a Yavé, que le habló y le otorgó una señal maravillosa."
,"25":"Sin embargo, Ezequías no correspondió al bien que había recibido, pues se puso orgulloso su corazón, por lo cual la cólera vino sobre él, sobre Judá y Jerusalén."
,"26":"Mas, después de haberse puesto orgulloso, se humilló Ezequías, él y los habitantes de Jerusalén; y por eso no estalló contra ellos la cólera de Yavé en los días de Ezequías."
,"27":"Ezequías tuvo riquezas y gloria en gran abundancia. Adquirió tesoros de plata, oro, piedras preciosas, bálsamos, joyas y de toda suerte de objetos de valor."
,"28":"Se hizo también grandes almacenes para las rentas del trigo, mosto y aceite, pesebres para toda clase de ganado y tenía rebaños en sus pesebres."
,"29":"Se construyó ciudades y adquirió ganado mayor y menor en abundancia, pues Yavé le había dado muchísimas riquezas."
,"30":"Este mismo Ezequías cortó la salida superior a las aguas del Guijón y las condujo bajo tierra, a la parte occidental de la ciudad de David. Ezequías tuvo éxito en todas sus empresas."
,"31":"Sin embargo, cuando los príncipes de Babilonia enviaron embajadores para enterarse de la señal maravillosa ocurrida en el país, Yavé lo abandonó para probarlo y descubrir todo lo que tenía en su corazón."
,"32":"Lo demás referente a Ezequías y sus obras piadosas está escrito en las visiones del profeta Isaías, hijo de Amós, y en el libro de los Reyes de Judá y de Israel."
,"33":"Murió y lo sepultaron en la subida de los sepulcros de los hijos de David; y todo Judá y los habitantes de Jerusalén le rindieron honores a su muerte. En su lugar reinó su hijo Manasés."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Manasés tenía doce años cuando comenzó a reinar, y reinó cincuenta y cinco años en Jerusalén."
,"2":"Hizo el mal a los ojos de Yavé imitando las costumbres abominables de las naciones a las que Yavé quitó el país para dárselo a Israel."
,"3":"Volvió a edificar los santuarios altos que su padre Ezequías había derribado, levantó altares a los baales, hizo troncos sagrados, se postró ante todo el ejército de los cielos y les sirvió."
,"4":"Construyó también altares en la Casa de Yavé, de la que Yavé había dicho: 'En Jerusalén estará mi Nombre para siempre.'"
,"5":"Edificó altares a todo el ejército de los cielos en los dos patios de la Casa de Yavé"
,"6":"y sacrificó a sus hijos por el fuego en el valle de Ben-Hinom; practicó la adivinanza, la magia y la hechicería, estableció espiritistas y adivinos, haciendo mucho mal a los ojos de Yavé y provocando su cólera."
,"7":"Colocó el ídolo que había fabricado en la Casa de Yavé, de la cual había dicho Dios a David y a Salomón su hijo: 'En esta Casa y en Jerusalén, que he elegido entre las tribus de Israel, pondré mi Nombre para siempre."
,"8":"Y no apartaré más el pie de Israel de sobre la tierra que di a sus padres, con tal que procuren hacer según todo lo que les he mandado, según toda la Ley, los decretos y las normas ordenadas por Moisés.'"
,"9":"Manasés desvió a Judá y a los habitantes de Jerusalén para que hicieran mayores males que las naciones que Yavé había exterminado delante de los hijos de Israel."
,"10":"Habló Yavé a Manasés y a su pueblo, pero no le hicieron caso."
,"11":"Entonces Yavé hizo venir sobre ellos a los jefes del ejército del rey de Asur, que apresaron a Manasés con ganchos, lo ataron con cadenas de bronce y lo llevaron a Babilonia."
,"12":"Cuando se vio en angustia, quiso aplacar a Yavé, su Dios, humillándose profundamente en presencia del Dios de sus padres."
,"13":"Rezó a él y Dios accedió, escuchó su oración y le concedió que volviera a Jerusalén y reinara nuevamente. Entonces supo Manasés que sólo Yavé es Dios."
,"14":"Después de esto edificó la muralla exterior de la Ciudad de David al occidente de Guijón, en el torrente, hasta la entrada de la Puerta de los Peces, cercando el Ofel, y la llevó a gran altura. Puso también jefes del ejército en todas las plazas fuertes de Judá."
,"15":"Quitó de la Casa de Yavé todos los dioses extraños, el ídolo y todos los altares que había construido en el cerro de la Casa de Yavé y en Jerusalén, y los echó fuera de la ciudad."
,"16":"Reedificó el altar de Yavé y ofreció sacrificios de comunión y de alabanza; y mandó a Judá que sirviera a Yavé, el Dios de Israel."
,"17":"El pueblo aún ofrecía sacrificios en los lugares altos, pero nada más que a Yavé."
,"18":"Los demás hechos de Manasés, su oración a Dios, y las palabras de los videntes que le hablaron en nombre de Yavé, Dios de Israel, se encuentran en los Hechos de los Reyes de Israel."
,"19":"Asimismo su oración, y cómo fue escuchada, y todos sus pecados y apostasía: los sitios en que edificó santuarios altos y levantó troncos sagrados e ídolos antes de hacer penitencia, están escritos en los Hechos de Josay."
,"20":"Se acostó Manasés con sus padres y lo sepultaron en el huerto de su casa. En su lugar reinó su hijo Amón."
,"21":"Amón tenía veintidós años cuando empezó a reinar, y reinó dos años en Jerusalén."
,"22":"Hizo el mal a los ojos de Yavé, como había hecho su padre Manasés, y sirvió a todos los ídolos que había hecho."
,"23":"Pero no se humilló delante de Yavé como lo había hecho su padre Manasés. Al contrario, Amón cometió aún más pecados."
,"24":"Sus servidores conspiraron contra él y le dieron muerte en su casa."
,"25":"Pero el pueblo mató a todos los conspiradores y proclamó rey en su lugar a su hijo Josías."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Josías tenía ocho años cuando comenzó a reinar, y reinó treinta y un años en Jerusalén."
,"2":"Hizo lo que era bueno a los ojos de Yavé, siguiendo los caminos de su padre David, sin apartarse de ellos de ninguna manera."
,"3":"El año octavo de su reinado, siendo todavía joven, comenzó a buscar al Dios de su padre David; y en el año doce comenzó a purificar a Judá y Jerusalén de los santuarios altos, de los troncos sagrados, de las estatuas y de los ídolos fundidos."
,"4":"Derribaron en su presencia los altares de los baales y las piedras paradas que había sobre ellos, y rompió los troncos sagrados, las imágenes y los ídolos fundidos, reduciéndolos a polvo que esparció sobre las sepulturas de los que les habían ofrecido sacrificios."
,"5":"Quemó los huesos de sus sacerdotes sobre sus altares y purificó a Judá y Jerusalén."
,"6":"En las ciudades de Manasés, de Efraím y de Simeón, y hasta en Neftalí y en los territorios asolados que las rodeaban,"
,"7":"derribó los altares, demolió los troncos sagrados y las estatuas y las redujo a polvo, y destruyó las piedras paradas en toda la tierra de Israel. Después regresó a Jerusalén."
,"8":"El año dieciocho de su reinado, con el fin de purificar el país y la Casa, mandó a Safán, hijo de Asalías, a Maasías, comandante de la ciudad, y a Joaj, hijo de Joajaz, heraldo, que reparasen la Casa de Yavé, su Dios."
,"9":"Fueron, pues, donde el sumo sacerdote Helquías y le entregaron el dinero traído a la Casa de Dios, es decir, todo lo que los levitas y porteros habían recibido de Manasés y de Efraím y de todo el resto de Israel, de todo Judá y Benjamín y de los habitantes de Jerusalén."
,"10":"Lo pusieron en manos de los que hacían el trabajo, los encargados de la Casa de Yavé, y éstos se lo dieron a los obreros para restaurar y reparar la Casa."
,"11":"Lo dieron a los carpinteros y obreros de la construcción para comprar piedras de cantera y madera para las vigas y la armazón de los edificios destruidos por los reyes de Judá."
,"12":"Estos trabajaban permanentemente en la obra. Estaban bajo la vigilancia de Yajat y Abdías, levitas de los hijos de Merarí, y de Zacarías y Mesulam, de los hijos de los quehatitas, que los dirigían, y de otros levitas, todos ellos maestros en tocar instrumentos de música."
,"13":"También dirigían a los peones de carga y a todos los que trabajaban en la obra en los distintos servicios. Entre los levitas había además escribas, notarios y porteros."
,"14":"Cuando estaban sacando el dinero traído de la Casa de Yavé, el sacerdote Helquías encontró el libro de la Ley de Yavé dada a Moisés."
,"15":"Tomó la palabra y dijo al secretario Safán: 'He encontrado el libro de la Ley en la Casa de Yavé'; y Helquías entregó el libro a Safán."
,"16":"Safán llevó el libro al rey, y le rindió cuentas diciendo: 'Tus servidores están haciendo todo lo que les ha sido encargado."
,"17":"Han fundido el dinero traído a la Casa de Yavé y lo han entregado a los encargados y a los que trabajaban en la obra."
,"18":"Luego el secretario Safán anunció al rey: 'El sacerdote Helquías me ha entregado un libro.' Y Safán leyó una parte de dicho libro en presencia del rey."
,"19":"Cuando el rey escuchó las palabras de la Ley, rasgó sus vestidos"
,"20":"y ordenó a Helquías, a Ajicam, hijo de Safán, a Abdón, hijo de Miká, a Safán, secretario, y a Asaías, servidor del rey:"
,"21":"'Vayan, consulten a Yavé por mí y por el resto de Israel y de Judá, acerca de las palabras del libro que ha sido encontrado. Seguramente Yavé está muy enojado contra nosotros, pues nuestros padres no han guardado la palabra de Yavé y no han obrado conforme a todo lo escrito en este libro.'"
,"22":"Helquías y los enviados del rey fueron donde la profetisa Juldá, esposa de Salum, hijo de Yoquejat, hijo de Jasrá, encargado del vestuario. Ella vivía en Jerusalén, en la ciudad nueva. Ellos le hablaron conforme a lo indicado"
,"23":"y ella respondió: 'Escuchen la palabra que dirige Yavé a ese hombre que los ha enviado a mí."
,"24":"Así habla Yavé: Voy a traer la desgracia sobre este lugar y sobre sus habitantes, conforme a todas las maldiciones escritas en el libro que se ha leído delante del rey de Judá."
,"25":"Ellos me han abandonado y han quemado incienso a otros dioses, irritándome con todas las obras de sus manos, y por eso mi cólera se ha derramado sobre este lugar y no se apagará."
,"26":"Y al rey de Judá que los ha enviado para consultar a Yavé, le dirán: Así dice Yavé, Dios de Israel, acerca de las palabras que has oído."
,"27":"Tu corazón se ha conmovido y te has humillado delante de Dios al oír mis palabras contra este lugar y sus habitantes; te has humillado ante mí, has rasgado tus vestidos y has llorado ante mí; por eso yo, a mi vez, he oído, palabra de Yavé."
,"28":"Voy a reunirte con tus padres y serás recibido en paz en tu sepulcro; y no verán tus ojos ninguno de los males que voy a traer sobre este lugar y sus habitantes.'"
,"29":"Entonces el rey envió un mensajero para reunir a todos los jefes de Judá y de Jerusalén."
,"30":"Subió el rey a la Casa de Yavé con todos los hombres de Judá y los habitantes de Jerusalén, los sacerdotes y los levitas, y todo el pueblo desde el mayor hasta el menor, y leyó a sus oídos todas las palabras del Libro de la Alianza que había sido encontrado en la Casa de Yavé."
,"31":"El rey se mantuvo de pie sobre su estrado y celebró la Alianza en presencia de Yavé, tomando el compromiso de caminar tras Yavé y guardar sus mandamientos, sus testimonios y sus preceptos con todo su corazón y con toda su alma, cumpliendo las palabras de la Alianza escritas en aquel libro."
,"32":"Hizo que se adhirieran a la Alianza cuantos se hallaban en Jerusalén y en Benjamín, y los habitantes de Jerusalén tuvieron que actuar de acuerdo con la Alianza de Dios, el Dios de sus padres."
,"33":"Josías hizo desaparecer todas las abominaciones de las provincias en que vivían los hijos de Israel y obligó a todos los que se encontraban en Jerusalén a servir a Yavé, su Dios. Y mientras él vivió no se apartaron más de Yavé, el Dios de sus padres."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Josías celebró una Pascua en honor de Yavé en Jerusalén; inmolaron la Pascua el día catorce del primer mes."
,"2":"Estableció a los sacerdotes en sus funciones y les dio ánimo para servir en la Casa de Yavé."
,"3":"Dijo a los levitas que enseñan a todo Israel y están consagrados a Yavé: 'Pongan el Arca Santa en la Casa que construyó Salomón, hijo de David, rey de Israel, porque ya no habrán de llevarla en los hombros. Ahora sirvan a Yavé nuestro Dios y a Israel, su pueblo."
,"4":"Estén preparados según las casas paternas y las clases de ustedes conforme a lo escrito por David, rey de Israel, y lo escrito por su hijo Salomón."
,"5":"Ocupen el sitio que les corresponde en el santuario según los grupos de sus casas paternas y el orden establecido en la tribu de Leví para estar a disposición de sus hermanos, la gente del pueblo."
,"6":"Luego inmolen la Pascua, santifíquense y prepárenla para sus hermanos cumpliendo la orden de Yavé, dada por medio de Moisés.'"
,"7":"Josías reservó para la gente del pueblo corderos y cabritos en número de treinta mil, todos ellos como víctimas pascuales, para cuantos se hallaban presentes, y tres mil bueyes. Todo ello de la hacienda del rey."
,"8":"También sus jefes reservaron ofrendas voluntarias para el pueblo, los sacerdotes y los levitas. Los intendentes de la Casa de Dios, Helquías, Zacarías y Jejiel, dieron a los sacerdotes dos mil seiscientas ovejas y trescientos bueyes;"
,"9":"Kononías, Semaías y Natanael, su hermano, y Jasabías, Jeiel y Josabad, jefes de los levitas, reservaron para los levitas cinco mil corderos pascuales y quinientos bueyes."
,"10":"Preparado así el servicio, los sacerdotes ocuparon sus puestos, lo mismo los levitas, según sus clases, conforme a la orden del rey."
,"11":"Se inmolaron las víctimas pascuales, y mientras los sacerdotes por su propia mano rociaban con la sangre, los levitas las desollaban."
,"12":"Apartaban lo destinado al holocausto para darlo al pueblo, repartido según las secciones de sus casas paternas, a fin de que lo ofrecieran a Yavé conforme a lo escrito en el Libro de Moisés. Lo mismo se hizo con los bueyes."
,"13":"Asaron la Pascua al fuego, según el ritual; cocieron las cosas sagradas en ollas, calderas y cazuelas, y las repartieron con rapidez entre la gente del pueblo."
,"14":"Después prepararon la Pascua para sí y los sacerdotes, porque los sacerdotes, hijos de Aarón, estuvieron ocupados hasta la noche en ofrecer holocaustos y grasas. Por eso los levitas la prepararon para sí y para los sacerdotes, hijos de Aarón."
,"15":"También los cantores, hijos de Asaf, estaban en su puesto, conforme a lo dispuesto por David, Asaf, Hemán y Jedutún, vidente del rey; lo mismo los porteros, cada uno en su puerta. No tenían necesidad de retirarse de su servicio, porque sus hermanos, los levitas, se lo prepararon todo."
,"16":"De esta manera se organizó aquel día todo el servicio de Yavé para celebrar la Pascua y ofrecer los holocaustos sobre el altar de Yavé, según la orden del rey Josías."
,"17":"Los hijos de Israel que se encontraban allí celebraron en este tiempo la Pascua, y también la fiesta de los Azimos durante siete días."
,"18":"No se había celebrado Pascua como ésta en Israel desde los días del profeta Samuel y ningún rey de Israel celebró una Pascua como la que celebraron Josías, los sacerdotes y los levitas, todo Judá e Israel, que allí se hallaban presentes, y los habitantes de Jerusalén."
,"19":"Esta Pascua se celebró el año dieciocho del reinado de Josías."
,"20":"Después de todo esto, cuando Josías había reparado la Casa de Yavé, subió Nekó, rey de Egipto, para combatir en Karkemis, junto al Eufrates. Josías le salió al encuentro."
,"21":"Nekó le mandó mensajeros para decirle: '¿Qué tengo yo que ver contigo, rey de Judá? No he venido hoy contra ti, sino contra otro con el cual estoy en guerra; y Dios me ha mandado que me apresure. Deja de oponerte a Dios, que está conmigo, no sea que él te destruya.'"
,"22":"Pero Josías no se apartó de él, pues estaba decidido a darle batalla, y no escuchó las palabras de Nekó, que venían de boca de Dios. Y avanzó para librar batalla en la llanura de Meguidó."
,"23":"Los arqueros tiraron contra el rey Josías, y dijo el rey a sus servidores: 'Llévenme fuera, pues estoy gravemente herido.'"
,"24":"Sus servidores lo sacaron del carro y, pasándolo a otro carro que tenía, lo llevaron a Jerusalén, donde murió. Fue sepultado en los sepulcros de sus padres y todo Judá y Jerusalén hicieron duelo por Josías."
,"25":"Jeremías compuso un canto fúnebre sobre Josías, y todos los cantores y cantoras hablan todavía hoy de Josías en sus cantos fúnebres, lo cual se ha hecho costumbre en Israel. Están escritos entre las Lamentaciones."
,"26":"Lo demás referente a Josías y todo lo bueno que hizo de acuerdo con la Ley de Yavé"
,"27":"y sus hechos del comienzo al fin están escritos en el libro de los Reyes de Israel y de Judá."
}`)
	CurrentBook.AddChapter(36, `{
"1":"El pueblo del país tomó a Joacab, hijo de Josías, para proclamarlo rey de Jerusalén, en lugar de su padre."
,"2":"Joacaz tenía veintitrés años cuando comenzó a reinar, y reinó tres meses en Jerusalén."
,"3":"El rey de Egipto lo destituyó en Jerusalén, e impuso al país una contribución de cien talentos de plata y un talento de oro."
,"4":"El rey de Egipto proclamó rey de Judá y de Jerusalén a Eliaquim, hermano de Joacaz, cambiándole el nombre por el de Joaquim."
,"5":"Y a Joacaz, su hermano, lo llevó preso a Egipto. Joaquim tenía veinticinco años cuando comenzó a reinar, y reinó once años en Jerusalén. "
,"6":"Hizo el mal a los ojos de Yavé su Dios. Nabucodonosor, rey de Babilonia, vino a atacarlo y lo ató con cadenas de bronce para conducirlo a Babilonia."
,"7":"Nabucodonosor llevó también a Babilonia los objetos de la casa de Yavé, que depositó en su santuario en Babilonia."
,"8":"Lo demás referente a Joaquim, las maldades que cometió y todo lo que le sucedió, está escrito en el libro de los Reyes de Israel y de Judá. En su lugar reinó su hijo Joaquim."
,"9":"Joaquim tenía dieciocho años cuando empezó a reinar, y reinó tres meses y diez días en Jerusalén; hizo el mal a los ojos de Yavé."
,"10":"A la vuelta del año, el rey Nabucodonosor mandó que lo llevaran a Babilonia, juntamente con los objetos más preciosos de la Casa de Yavé, y puso por rey en Judá y Jerusalén a Sedecías, hermano de su padre."
,"11":"Sedecías tenía veintiún años cuando comenzó a reinar, y reinó once años en Jerusalén."
,"12":"Hizo el mal a los ojos de Yavé, su Dios, y no se humilló ante el profeta Jeremías que le hablaba en nombre de Yavé."
,"13":"También él se rebeló contra el rey Nabucodonosor, que le había hecho jurar por Dios; se porfió y se obstinó en su corazón, en vez de volverse a Yavé, su Dios de Israel."
,"14":"Del mismo modo todos los jefes, los sacerdotes y el pueblo multiplicaron sus infidelidades, según todas las costumbres abominables de las naciones paganas, y mancharon la Casa de Yavé, que él se había consagrado en Jerusalén."
,"15":"Yavé, el Dios de sus padres, les enviaba desde el principio avisos por medio de mensajeros, porque tenía compasión de su pueblo y de su Morada."
,"16":"Pero ellos maltrataron a los mensajeros de Dios, despreciaron sus palabras y se burlaron de sus profetas, hasta que estalló la ira de Yavé contra su pueblo y ya no hubo remedio."
,"17":"Entonces hizo subir contra ellos al rey de los caldeos, que mató a espada a los mejores hasta dentro de su santuario, sin perdonar a joven ni a virgen, a viejo ni a canoso; a todos los entregó Dios en su mano."
,"18":"Todos los objetos de la Casa de Dios, grandes y pequeños, los tesoros de la Casa de Yavé y los tesoros del rey y de sus jefes, todo se lo llevó a Babilonia."
,"19":"Incendiaron la Casa de Dios y derribaron las murallas de Jerusalén, prendieron fuego a todos sus palacios y destruyeron todos los objetos preciosos."
,"20":"Y a los que escaparon de la espada, los llevó prisioneros a Babilonia, donde fueron esclavos de él y de sus hijos hasta que se estableciera el reino de los persas."
,"21":"Así se cumplió la palabra de Yavé, por boca de Jeremías: 'Hasta que el país haya pagado sus sábados, quedará desolado y descansará todos los días hasta que se cumplan los setenta años.'"
,"22":"En el año primero de Ciro, rey de Persia, en cumplimiento de la palabra de Yavé dicha por boca de Jeremías, Yavé movió el espíritu de Ciro, rey de Persia, que mandó comunicar de palabra y por escrito en todo su reino:"
,"23":"'Así habla Ciro, rey de Persia: Yavé, el Dios de los cielos, me ha dado todos los reinos de la tierra. El me ha encargado que le edifique una Casa en Jerusalén, en Judá. ¡Quien de entre ustedes pertenezca a su pueblo, sea su Dios con él y suba!'"
}`)

}
func ES_LBL_LoadVH2RChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Después de la muerte de Ajab, Moab se rebeló contra Israel."
,"2":"Ocozías se cayó desde la ventana de su segundo piso en Samaría, y como no se sintiera bien, envió a algunos hombres diciéndoles: 'Vayan a consultar a Baalcebub, dios de Ecrón, para saber si me sanaré de este mal'."
,"3":"Pero el ángel de Yavé dijo a Elías de Tisbé: 'Levántate y sal al encuentro de los mensajeros del rey de Samaría. Les dirás: ¿Así que ya no hay más Dios en Israel que van a consultar a Baalcebub, el dios de Ecrón?"
,"4":"Ya que has procedido así, dice Yavé, no te levantarás de la cama en que te has acostado; has de saber que morirás'. Y Elías se alejó."
,"5":"Volvieron los mensajeros donde el rey; éste les dijo: '¿Por qué regresaron?'"
,"6":"Respondieron: 'Un hombre salió a nuestro encuentro y nos dijo: Váyanse, regresen donde el rey que los envió, y repítan esta palabra de Yavé: ¿Así que ya no hay más Dios en Israel que vas a consultar a Baalcebub, el dios de Ecrón? ¡Por eso, no te levantarás de la cama en la que te has acostado, sino que morirás, ya está decidido!'"
,"7":"Les dijo: '¿Cómo era ese hombre que salió a encontrarlos y que les dijo eso?'"
,"8":"Respondieron: 'El hombre iba vestido con un manto de pelo y con una faja de piel ceñida a su cintura.' Ocozías exclamó: '¡Es Elías de Tisbé!'"
,"9":"Despachó entonces a cincuenta hombres con su jefe, que subieron para buscar a Elías; éste estaba sentado en la cumbre de un cerro. El jefe le gritó: '¡Hombre de Dios, por orden del rey, baja!'"
,"10":"Elías respondió al jefe de los cincuenta: '¡Si soy un hombre de Dios, que baje fuego del cielo y te devore a ti y a tus ciencuenta hombres!' Y bajó fuego del cielo, y lo devoró a él y a sus cincuenta hombres."
,"11":"El rey despachó de nuevo a cincuenta hombres con su jefe; éste también le gritó: '¡Hombre de Dios, esta es la orden del rey: Apresúrate en bajar!'"
,"12":"Elías le respondió: '¡Si soy hombre de Dios, que baje fuego del cielo y te devore a ti y a tus cincuenta hombres!' Y el fuego de Dios bajó del cielo, y lo devoró a él y a sus cincuenta hombres."
,"13":"Envió el rey por tercera vez a cincuenta hombres con su jefe; cuando llegó cerca de Elías, el tercer jefe se arrodilló y le suplicó diciéndole: '¡Hombre de Dios, soy tu servidor; ojalá mi vida y la de mis hombres tenga algún valor para ti! ¡El fuego de Dios ya ha bajado dos veces del cielo para devorar a los dos primeros jefes con sus cincuenta hombres, perdóname ahora mi vida!'"
,"15":"Entonces el ángel de Yavé dijo a Elías: 'Baja con él, pues nada tienes que temer de su parte'. Se levantó pues y bajó con ellos hasta donde estaba el rey."
,"16":"Le dijo a éste: 'Esto dice Yavé: ¡Debido a que enviaste mensajeros para consultar a Baalcebub, el dios de Ecrón, no te levantarás más de la cama donde estás acostado, sino que morirás, ya está decidido!'"
,"17":"Efectivamente murió Ocozías conforme a la palabra de Yavé que había sido transmitida a Elías. En su lugar reinó Yoram, su hermano, porque no tenía hijos, (era el décimo año de Joram hijo de Josafat, rey de Judá)."
,"18":"El resto de los hechos de Ocozías, lo que hizo, todo eso está escrito en el libro de las Crónicas de los reyes de Israel."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Yavé hizo subir a Elías al cielo en un torbellino; así fue. Cuando Elías salía de Guilgal en compañía de Eliseo,"
,"2":"dijo a éste: 'Quédate aquí por favor. Yavé me manda a Betel'. Pero Eliseo respondió: 'Tan cierto como que Yavé vive y que yo vivo, que no te dejaré'. Y bajaron juntos a Betel."
,"3":"Los hermanos profetas que vivían en Betel salieron a encontrar a Eliseo y le dijeron: '¿Sabes que hoy día Yavé te llevará a tu maestro por encima de ti?' Respondió: 'Lo sé, pero no digan nada'."
,"4":"Elías le dijo: 'Eliseo, quédate aquí por favor, porque Yavé me manda a Jericó'. Pero él respondió: 'Tan cierto como que Yavé vive y que yo vivo, que no te dejaré'. Y así llegaron a Jericó."
,"5":"Los hermanos profetas que estaban en Jericó se acercaron a Eliseo: '¿Sabes, le dijeron, que hoy día Yavé te llevará a tu maestro por encima de ti?' Respondió: 'Lo sé, pero quédense tranquilos'."
,"6":"Elías le dijo: 'Quédate aquí por favor, porque Yavé me manda al Jordán'. Le respondió: ' 'Tan cierto como que Yavé vive y que yo vivo, que no te dejaré'. Y los dos siguieron su camino."
,"7":"Los seguían unos cincuenta profetas, que se quedaron a cierta distancia mientras ambos se detenían a orillas del Jordán."
,"8":"Entonces Elías tomó su manto, lo enrolló y golpeó con él el agua y ésta se dividió, de modo que ambos atravesaron en seco."
,"9":"Cuando lo atravesaron, Elías dijo a Eliseo: '¿Qué quieres que haga por ti? Pídelo antes que sea llevado lejos de ti'. Eliseo respondió: 'Que venga sobre mí el doble de tu espíritu'."
,"10":"Elías le replicó: '¡Pides algo difícil! Pero si me ves mientras soy llevado de tu lado, lo tendrás; si no, no'."
,"11":"Iban conversando mientras caminaban, cuando un carro de fuego con sus caballos de fuego los separó al uno del otro: Elías subió al cielo en un torbellino."
,"12":"Eliseo lo vio y gritaba: '¡Padre mío! ¡Padre mío! ¡Carro de Israel y su caballería!' Luego no lo vio más. Tomó entonces su ropa y la partió en dos."
,"13":"Eliseo recogió el manto de Elías que había caído cerca de él y se volvió. Al llegar a orillas del Jordán se detuvo,"
,"14":"tomó el manto de Elías y golpeó el agua con él, pero ésta no se dividió. Entonces dijo: '¿Dónde etá el Dios de Elías, dónde?' Y como volviera a golpear el agua, ésta se dividió en dos, y Eliseo atravesó."
,"15":"Los hermanos profetas lo vieron de lejos y dijeron: '¡El espíritu de Elías reposa sobre Eliseo!' Salieron a su encuentro y se postraron en tierra delante de él."
,"16":"Le dijeron: 'Hay aquí entre tus servidores cincuenta hombres valerosos. Permíteles que salgan en busca de tu maestro. A lo mejor el Espíritu de Yavé lo ha tomado y depositado en algún cerro o en uno de los valles'. Pero él les respondió: '¡No, no manden a nadie!'"
,"17":"Pero como siguieran insistiendo hasta el punto de ser cargantes, Eliseo les dijo: '¡Muy bien, mándenlos!' Mandaron a cincuenta hombres que buscaron durante tres días sin encontrarlo."
,"18":"Cuando regresaron donde él en Jericó, les dijo: '¿No les dije que no fueran?'"
,"19":"La gente de la ciudad dijo a Eliseo: 'Aquí se está bien, como mi señor lo puede ver, pero el agua es malsana y las mujeres de la zona son estériles'."
,"20":"Les dijo: 'Denme un plato nuevo y pongan en él sal'. Se lo pasaron."
,"21":"Se dirigió a la fuente y echó la sal en el agua, luego dijo: 'Esto dice Yavé: He sanado esta agua, de ella ya no saldrá más ni muerte ni esterilidad'."
,"22":"Y el agua siguió sana hasta el día de hoy, según la palabra que había pronunciado Eliseo."
,"23":"De allí se fue a Betel; cuando iba por el camino que sube, salieron de la ciudad unos muchachos que se burlaban de él: '¡Vamos calvo, sube! ¡Vamos calvo, sube!' decían."
,"24":"Se volvió y mirándolos los maldijo en nombre de Yavé; salieron del bosque dos osas y desgarraron a cuarenta y dos de esos muchachos."
,"25":"Desde allí se dirigió al monte Carmelo y luego regresó a Samaría."
}`)
	CurrentBook.AddChapter(3, `{
"1":"El año décimo octavo del reinado de Josafat de Judá, llegó a ser rey de Samaría Joram hijo de Ajab. Reinó doce años;"
,"2":"hizo lo que le disgusta a Yavé, pero no tanto como su padre y su madre, porque mandó quitar la piedra que había levantado su padre en honor a Baal."
,"3":"Sin embargo siguió apegado al pecado de Jeroboam hijo de Nabat, quien había arrastrado a Israel en su pecado: no se apartó de él."
,"4":"Mesa, rey de Moab, tenía rebaños. Le pagaba al rey de Israel un tributo de cien mil corderos y cien mil carneros, y además la lana."
,"5":"Pero a la muerte de Ajab, el rey de Moab se rebeló contra el rey de Israel."
,"6":"Entonces el rey Yoram salió de Samaría y pasó revista a Israel;"
,"7":"se puso en camino y mandó decir a Josafat, rey de Judá: 'El rey de Moab se ha rebelado contra mí, ¿vas a venir conmigo a atacar a Moab?' Josafat le respondió: 'Iré, será tanto asunto mío como tuyo, de mi pueblo como de tu pueblo, y de mis caballos como de tus caballos'."
,"8":"Y agregó: '¿Por qué camino irás?' Yoram respondió: 'Por el camino del desierto de Edom'."
,"9":"El rey de Israel, el rey de Judá y el rey de Edom comenzaron a avanzar, pero después de siete días de marcha ya no había más agua ni para el ejército ni para los animales."
,"10":"Entonces el rey de Israel dijo: '¡Ay, ay! ¡Yavé ha reunido a estos tres reyes para entregarlos en las manos de Moab!'"
,"11":"Josafat le preguntó: '¿No hay aquí algún profeta de Yavé por cuyo intermedio podamos consultar a Yavé?' Uno de los servidores del rey de Israel le dijo: 'Aquí está Eliseo hijo de Safat, el que derramaba el agua en las manos de Elías'."
,"12":"Josafat dijo: 'La palabra de Yavé está con él'. Así pues el rey de Israel, Josafat y el rey de Edom bajaron a su encuentro."
,"13":"Eliseo dijo al rey de Israel: '¿Qué tengo que ver con tus problemas? ¡Anda a buscar a los profetas de tu padre!' Pero el rey de Israel insistió: '¿Acaso Yavé, que hizo venir a estos tres reyes, los va a entregar ahora en manos de Moab?'"
,"14":"Eliseo le dijo: 'Tan cierto como que vive Yavé de los ejércitos, al que sirvo, que si no tuviera consideración por Josafat rey de Judá, no te habría mirado ni visto."
,"15":"Tráeme ahora a alguien que toque el arpa'. Mientras el arpista tocaba, la mano de Yavé se puso sobre Eliseo."
,"16":"Entonces dijo: 'Así habla Yavé: ¡Caven zanjas y zanjas en este valle!"
,"17":"Porque esto dice Yavé: No verán viento ni lluvia y sin embargo el valle se llenará de agua. Entonces beberán ustedes, sus rebaños y sus bestias de carga."
,"18":"Pero todo eso es poco a los ojos de Yavé, quien quiere además entregar a Moab en las manos de ustedes."
,"19":"Demolerán todas las ciudades fortificadas, cortarán todos los árboles frutales, taparán todos los manantiales y estropearán todos los mejores campos echando en ellos piedras'."
,"20":"Por la mañana, a la hora en que se presenta el Sacrificio, llegó el agua por el camino de Edom y la tierra se llenó de agua."
,"21":"Todos los moabitas sabían que los reyes avanzaban para atacarlos; se reclutó pues a todos los hombres capaces de portar armas y se los apostó en la frontera."
,"22":"Se habían levantado muy temprano, y cuando el sol brilló sobre el agua, los moabitas vieron frente a ellos el agua roja como sangre."
,"23":"Entonces comentaron: '¡ Eso es sangre! ¡Los reyes se pusieron a pelear y se hirieron unos a otros! ¡Moabitas, vamos al pillaje!'"
,"24":"Se abalanzaron sobre el campamento de Israel, pero los israelitas se levantaron y contraatacaron a Moab, el que salió huyendo ante ellos; penetraron en el territorio de Moab y lo devastaron."
,"25":"Devastaron las ciudades y cada uno echó su piedra en los mejores campos, hasta taparlos con ellas. Taparon todos los manantiales y cortaron todos los árboles frutales, de tal modo que en Quir-Herés quedaron sólo piedras. Los honderos que la habían cercado la castigaron."
,"26":"Cuando el rey de Moab vio que le iba mal en la batalla, reunió a setecientos hombres armados de espada para romper el cerco frente al rey de Edom, pero no lo logró."
,"27":"Entonces tomó a su hijo mayor, al que debía reinar en su lugar y lo ofreció en holocausto encima de la muralla. Luego de esto, los israelitas tuvieron graves dificultades, se retiraron de allí y regresaron a su país."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Una de las mujeres de los hermanos profetas mandó llamar a Eliseo: 'Tu servidor, mi marido, ha muerto, dijo ella, y tú sabes que tu servidor temía a Yavé. Pues bien, un hombre a quien debíamos dinero vino a tomar a mis dos hijos para hacerlos sus esclavos'."
,"2":"Eliseo le dijo: '¿Qué puedo hacer por ti? Dime ¿qué tienes en tu casa?' Respondió: 'Tu sirvienta no tiene nada en tu casa, excepto un cantarito de aceite'."
,"3":"Le dijo: 'Anda a pedirles a todos tus vecinos cántaros, cántaros vacíos, todos los que puedas."
,"4":"Cuando estés de vuelta, cierra la puerta tras de ti y de tus hijos, echa tu aceite en todos esos cántaros y a medida que se vayan llenando, ponlos aparte'."
,"5":"Fue a hacer eso, se encerró en la casa con sus hijos, los que le pasaban los cántaros y ella los llenaba."
,"6":"Cuando los cántaros estuvieron llenos, dijo a su hijo: 'Pásame uno más'. Pero éste le dijo: 'Ya no hay más'. Y el aceite dejó de correr."
,"7":"Fue a contar todo eso al hombre de Dios, el cual le dijo: 'Anda a vender el aceite y paga así tu deuda; lo que quede te permitirá vivir junto con tus hijos'."
,"8":"Un día pasaba Eliseo por Sunam. Había allí una mujer rica que lo invitó para que se quedara a comer, y desde ese día, cada vez que pasaba por allí, se detenía en su casa."
,"9":"Ella dijo a su marido: 'He sabido que ese hombre que pasa a menudo por nuestra casa es un santo hombre de Dios;"
,"10":"construyámosle en la terraza un pequeño cuarto y pongámosle allí una cama, una mesa, una silla y una lámpara. Así, cuando pase por nuestra casa, podrá quedarse ahí'."
,"11":"Un día que pasaba por allí, se fue al cuarto de arriba y se acostó."
,"12":"Le dijo a su sirviente Guejazí: '¡Llama a esa buena sunamita! Cuando la hayas llamado y esté cerca de ti,"
,"13":"dile: Tú te preocupas mucho por nosotros, ¿qué podemos hacer por ti? ¿Quieres que digamos por ti una palabra al rey o al jefe del ejército?' Pero ella respondió: 'Estoy bien en medio de mi familia'."
,"14":"Eliseo volvió un día a tocar el tema: 'Pues bien, ¿qué se puede hacer por ella?' Guejazí respondió: 'No tiene hijos y su marido ya es viejo'."
,"15":"Eliseo le dijo: '¡Llámala!' El sirviente la llamó y ella se presentó a la entrada del cuarto."
,"16":"Eliseo le dijo entonces: 'Por esta misma fecha el año entrante, estarás acariciando a un hijo'. Ella respondió: '¡No, señor mío, tú eres un hombre de Dios; no engañes así a tu sirvienta!'"
,"17":"Ahora bien, la mujer concibió y, al año siguiente por esa misma fecha, tuvo un hijo tal como Eliseo se lo había anunciado."
,"18":"El niño creció. Un día que había ido donde su padre que estaba con los segadores, dijo a su padre: '¡Ay mi cabeza! ¡mi cabeza!' El padre dijo a un sirviente: '¡Llévalo inmediatamente donde su madre!'"
,"20":"El sirviente lo llevó y se lo entregó a su madre; el niño permaneció sentado en sus rodillas, y al mediodía falleció."
,"21":"Ella entonces subió a acostarlo en la cama del hombre de Dios, después cerró la puerta y salió."
,"22":"Llamó a su marido y le dijo: 'Mándame a uno de los mozos con una burra. Voy a ir corriendo donde el hombre de Dios y luego regresaré'."
,"23":"El le preguntó: '¿Por qué quieres ir ahora donde él, siendo que no es día de luna nueva ni sábado?' Ella le respondió: 'No te preocupes'."
,"24":"Ensilló la burra y dijo al sirviente: 'Vamos, llévame y no te detengas en el camino a menos que te lo pida'."
,"25":"Partió y llegó donde el hombre de Dios que estaba en el monte Carmelo. Cuando el hombre de Dios la divisó de lejos, dijo a Guejazí, su sirviente: 'Allí viene la Sunamita."
,"26":"Corre a encontrarla y pregúntale: ¿Cómo estás? ¿Tu marido se porta bien? ¿Cómo está el niño?' Ella respondió: '¡Bien!'"
,"27":"Pero en cuanto llegó donde el hombre de Dios que estaba en el monte, le abrazó las piernas. Guejazí se acercó para separarla, pero el hombre de Dios le dijo: '¡Déjala! Su corazón está repleto de tristeza, Yavé me lo ha ocultado y no me lo ha dado a conocer'."
,"28":"Entonces ella dijo: '¿Fui yo acaso quien pidió un hijo a mi señor? Yo te dije muy bien: ¡No me engañes!'"
,"29":"Eliseo dijo a Guejazí: '¡Ponte mi cinturón, toma mi bastón y ándate! Si te encuentras con alguien no te detengas a saludarlo, y si alguien te saluda, no le respondas. Pondrás mi bastón en la cara del niño'."
,"30":"Pero la madre del niño le dijo: 'Por la vida de Yavé y por tu propia vida, que no te dejaré'. Entonces él se levantó y la siguió."
,"31":"Guejazí se había adelantado; puso el bastón sobre el rostro del niño, pero no tuvo voz ni respuesta. Se volvió donde Eliseo y se lo comunicó: 'El niño no se despertó'."
,"32":"Eliseo entró en la casa; allí estaba el niño muerto, tendido en su cama."
,"33":"Entró, cerró la puerta y luego oró a Yavé."
,"34":"Después se tendió encima del niño, puso su boca en la del niño, sus ojos en los de él, sus manos en las de él, así estuvo recostado sobre él, y la carne del niño se calentó."
,"35":"Bajó luego a la casa y caminó de un lado al otro, subió de nuevo y volvió a tenderse sobre el niño. Así lo hizo siete veces. Al final el niño se movió y abrió los ojos."
,"36":"Eliseo llamó a Guejazí y le dijo: 'Di a la sunamita que venga'. La llamó, ella subió y le dijo: 'Toma a tu hijo'."
,"37":"Ella se echó a sus pies y se postró en tierra, luego tomó a su hijo y salió."
,"38":"Eliseo volvió a Guilgal; había hambruna en la región. Cuando los hermanos profetas estaban sentados a su lado, dijo a su sirviente: 'Toma la olla grande y prepara un caldo para los hermanos profetas'."
,"39":"Uno de ellos salió al campo a recoger hierbas, halló una especie de uva silvestre, recogió varios racimos hasta llenar su manto. Al volver, los fue desgranando en el tiesto en que se preparaba el caldo, sin que nadie supiera lo que era."
,"40":"Sirviéronles sopa a todos esos hombres, pero en cuanto la probaron exclamaron: '¡Hombre de Dios, la olla está envenenada!' Y no pudieron comer."
,"41":"El les dijo: 'Tráiganme harina'. La echó en la olla y añadió: 'Sírvan sopa a los hombres y que coman'. Y ya no había nada venenoso en la olla."
,"42":"Llegó un hombre que venía de Baal-Salisa; en su saco traía al hombre de Dios veinte panes de cebada y de trigo que habían hecho con harina recién cosechada. Eliseo le dijo: 'Dáselos a esos hombres para que coman'."
,"43":"Pero el sirviente le dijo: 'No me alcanza para repartírselo a cien personas'. Replicó: 'Dáselos y que coman, porque esto dice Yavé: Comerán y sobrará'."
,"44":"Les sirvieron, comieron y les sobró tal como lo había dicho Yavé."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Naamán era el comandante en jefe del ejército del rey de Aram. Era un hombre muy estimado por su señor; era su favorito porque por su intermedio había Yavé dado la victoria a los arameos. Pero ese hombre valiente era leproso."
,"2":"En una incursión, los arameos habían traído del territorio de Israel a una adolescente que quedó como sirvienta de la mujer de Naamán."
,"3":"Ella dijo a su patrona: '¡Ojalá mi señor se presentara al profeta que hay en Samaria, pues él le sanaría lalepra!'"
,"4":"Naamán se lo comunicó a su señor: 'Mira lo que dice esa joven que vino del territorio de Israel'."
,"5":"El rey de Aram le dijo: '¡Anda inmediatamente! Te voy a entregar una carta para el rey de Israel'. Se puso en camino, llevando diez talentos de plata, seis mil piezas de oro y diez trajes para cambiarse."
,"6":"Presentó al rey de Israel la carta en la que estaba escrito: 'Junto con esta carta te envío a mi servidor Naamán para que lo sanes de la lepra'."
,"7":"Al leer la carta, el rey de Israel rasgó su ropa diciendo: '¿Acaso soy un dios para hacer morir o devolver la vida? ¡Ese me pide que le quite a éste la lepra! ¡Fíjense y díganme si esto no es más que para buscarme pelea!'"
,"8":"Eliseo, el hombre de Dios, supo que el rey de Israel había rasgado su ropa, y mandó decir al rey: '¿Por qué rasgaste tu ropa? ¡Que venga a verme y así sabrá si hay o no profeta en Israel!'"
,"9":"Fue pues Naamán con sus caballos y su carro y se detuvo a la puerta de la casa de Eliseo."
,"10":"Eliseo le mandó decir por medio de un mensajero: 'Ve a bañarte siete veces en el Jordán y tu carne será como antes y quedarás saño'."
,"11":"Naamán se enojó y se fue diciendo: 'Yo pensaba que saldría a verme en persona, que invocaría el nombre de Yavé su Dios, que pasaría su mano por la parte enferma y que me libraría de la lepra. ¿No son los ríos de Damasco, el Abna y el Parpar, mejores que todos los de Israel? ¡Me habría bastado con lavarme allí para sanarme!',Muy enojado dio media vuelta para irse."
,"13":"Pero sus sirvientes se acercaron y le dijeron: 'Padre mío, si el profeta te hubiera pedido algo difícil ¿no lo habrías hecho? ¿Por qué pues no lo haces cuando tan sólo te dice: Lávate y quedarás sano?' Bajó pues y se sumergió en el Jordán siete veces tal como le había dicho el hombre de Dios. ¡Y después de eso su carne se volvió como la carne de un niñito; estaba sano!"
,"15":"Entonces regresó donde el hombre de Dios con todos sus acompañantes, entró en su casa y se presentó ante él: 'Ahora, dijo, sé que no hay más Dios en toda la tierra que el Dios de Israel. Acepta pues este presente de parte de tu servidor'."
,"16":"Eliseo le respondió: 'Por la vida de Yavé a quien sirvo que no aceptaré nada'. El otro insistió para que aceptara, pero él se negó."
,"17":"Entonces Naamán le dijo: 'Muy bien, pero me gustaría al menos que dieras a tu servidor un poco de tierra para cargar un par de mulas, porque en adelante tu servidor no ofrecerá más sacrificios u holocaustos a otros dioses sino sólo a Yavé."
,"18":"Sin embargo que Yavé perdone a este su servidor, pues cuando mi señor entra en el templo de Rimmón para postrarse, se apoya en mi brazo y yo tengo que postrarme junto con él en el templo de Rimmón. Que Yavé se digne perdonar esto a tu servidor'."
,"19":"Eliseo le dijo: '¡Vete en paz!',Ya estaba bastante lejos,"
,"20":"cuando Guejazí, el sirviente de Eliseo, se dijo para sí: 'Mi patrón ha sido demasiado considerado con ese arameo. ¡Pensar que no aceptó nada de lo que Naamán traía! Por la vida de Yavé, si puedo alcanzarlo le sacaré algo'."
,"21":"Salió pues Guejazí tras Naamán, quien se dio cuenta de que corría tras él. Saltó de su carro diciéndole: '¿Algún problema?'"
,"22":"Guejazí le respondió: 'No, ninguno, pero mi patrón me encargó que te dijera: Hace un momento dos jóvenes de la montaña de Efraín, de los hermanos profetas, acaban de llegar a mi casa. ¿Podrías darme para ellos un talento de plata y dos trajes para cambiarse?'"
,"23":"Naamán le dijo: 'Mejor toma dos talentos'. Lo obligó a aceptarlos y puso los dos talentos de plata en dos sacos junto con los trajes de recambio, luego se los encargó a dos de sus sirvientes para que fueran delante de Guejazí transportándolos."
,"24":"Cuando Guejazí llegó a Ofel, lo recibió todo de sus manos y lo guardó en su casa, y despidió a los hombres, quienes se fueron."
,"25":"El, por su parte, volvió a presentarse ante su patrón. Eliseo le dijo: '¿De dónde vienes Guejazí?' Este le dijo: 'Tu sirviente ha andado por aquí y por acullá'."
,"26":"Eliseo añadió: '¿No estaba contigo mi espíritu cuando ese hombre saltó de su carro para ir a tu encuentro? Ahora tienes plata, ropas, olivares, viñas, ovejas, bueyes, sirvientes y sirvientas..."
,"27":"¡Pero también tienes la lepra de Naamán, la que se te pegará a ti y a tu familia para siempre!',Y Guejazí se alejó de su presencia con una lepra blanca como la nieve."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Los hermanos profetas dijeron a Eliseo: 'El lugar donde vivimos contigo se ha hecho muy estrecho para nosotros."
,"2":"Bajemos al Jordán, y allí, cada uno tomará un tronco y construiremos una cabaña para alojarnos'. Les dijo: '¡Vayan!"
,"3":"Pero uno de ellos le dijo: '¿Por qué no vienes con tus sirvientes?' Respondió: Bueno, iré'."
,"4":"Se fue pues con ellos;"
,"5":"Mientras uno de ellos cortaba un tronco, cayó el hacha al agua. Se puso a gritar: '¡Ay de mí, mi señor, esa era un hacha que me habían prestado!'"
,"6":"El hombre de Dios le dijo: '¿Dónde cayó?' El otro le mostró el lugar. Eliseo cortó entonces un palo, lo tiró al agua y el hierro salió a flote."
,"7":"Añadió: 'Tómalo ahora'. El otro extendió su mano y pescó el hierro."
,"8":"El rey de Aram estaba en guerra con Israel. Tuvo una sesión de consejo con sus servidores y les dijo: 'Iré a tender una emboscada en tal y cual sitio'."
,"9":"Pero el hombre de Dios mandó a decir al rey de Israel: 'No pases por ese lugar, porque ahí van a bajar los arameos'."
,"10":"El rey de Israel mandó instrucciones al lugar que le había indicado el hombre de Dios. Así lo ponía en aviso Eliseo y esto no sólo una o dos veces, y el rey se mantenía en guardia."
,"11":"El rey de Aram se preocupó mucho por eso; convocó a sus servidores y les dijo: 'Díganme quién de nosotros está con el rey de Israel'."
,"12":"Uno de sus servidores respondió: 'Nadie, señor rey, sino que es Eliseo, el profeta de Israel, quien revela al rey de Israel hasta las palabras que pronuncias tú en tu cuarto al acostarte'."
,"13":"El rey le dijo: 'Vayan a ver dónde está para que lo detengamos'. Le informaron que estaba en Dotán."
,"14":"Entonces el rey despachó para allá abajo caballos, carros y un numeroso destacamento; llegaron de noche y cercaron la ciudad."
,"15":"El sirviente del hombre de Dios se levantó muy temprano y, cuando salió, vio que un regimiento rodeaba la ciudad con sus caballos y carros. El muchacho dijo a Eliseo: '¡Ay, señor mío! ¿Qué vamos a hacer?'"
,"16":"Le respondió: 'No temas porque los que están con nosotros son más numerosos que los que están con ellos'."
,"17":"Eliseo se puso a orar: 'Yavé, abre sus ojos para que vea'. Y Yavé abrió los ojos del joven, quien vio la montaña cubierta de caballos y carros de fuego que rodeaban a Eliseo."
,"18":"Los arameos bajaron donde Eliseo. Este hizo esta oración a Yavé: '¡Dígnate dejar ciega a esa tropa!' Y Yavé los dejó ciegos según la palabra de Eliseo."
,"19":"Eliseo les dijo: 'Este no es el camino, ni esta la ciudad, síganme y los guiaré donde el hombre que buscan'. Y los llevó hasta Samaría."
,"20":"Cuando ya habían entrado en Samaría, Eliseo dijo: '¡Yavé, abre los ojos de estos hombres para que vean!' Yavé les abrió los ojos y vieron que estaban en Samaría."
,"21":"Al verlos, el rey de Israel dijo a Eliseo: '¿Padre mío, debo matarlos?'"
,"22":"Este respondió: 'Si no matas a los que apresas con espada y con arco, ¿cómo matarías a éstos? Mejor dales pan y agua para que coman y beban; en seguida, que vuelvan donde su señor'."
,"23":"El rey les sirvió entonces una buena comida, y comieron y bebieron. Después los despidió y regresaron donde su amo; desde ese día las bandas arameas dejaron de hacer incursiones en el territorio de Israel."
,"24":"Mucho después, Ben-Hadad rey de Aram reunió a todo su ejército y subió para poner sitio a Samaría."
,"25":"Grande fue el hambre en Samaría; era tal la situación que la cabeza de un burro valía ochenta piezas de plata y un puñado de garbanzos, cinco."
,"26":"Cierta vez que pasaba el rey por la muralla, una mujer le gritó: '¡Sálvame, oh rey mi señor!'"
,"27":"Este respondió: 'Si Yavé mismo no te salva, ¿qué puedo hacer yo?"
,"28":"Luego el rey añadió: '¿Qué te pasa?' Ella respondió: 'Esta mujer me dijo: Dame tu hijo para que lo comamos ahora, y mañana comeremos el mío."
,"29":"Pues bien cocimos a mi hijo y lo comimos, pero cuando al día siguiente le digo: Dame a tu hijo para que lo comamos, lo escondió'."
,"30":"Al oír las palabras de la mujer, el rey rasgó su ropa y como estaba sobre la muralla, el pueblo vio que debajo de su ropa llevaba un saco pegado a su cuerpo."
,"31":"El rey dijo: '¡Castígueme Dios una y otra vez si la cabeza de Eliseo hijo de Safat le queda hoy sobre sus hombros!'"
,"32":"Eliseo mientras tanto estaba sentado en su casa junto con los ancianos que estaban a su alrededor. El rey mandó a uno de sus hombres, pero antes que llegara el emisario, Eliseo había dicho a los ancianos: '¿Saben que ese asesino mandó a alguien para que me corte la cabeza? ¡Pongan atención! Cuando llegue el emisario, cierren la puerta y denle con ésta en las narices. Seguramente se oirán los pasos de su amo detrás de los suyos'."
,"33":"Todavía estaba hablando Eliseo con ellos cuando llegó a la casa el rey: 'Esta desgracia viene de Yavé, dijo, ¿qué puedo ya esperar de Yavé?'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Eliseo dijo: '¡Escuchen la palabra de Yavé! Esto dice Yavé: 'Mañana a esta misma hora, en la puerta de Samaría, una medida de flor de harina se venderá por una moneda, y dos medidas de cebada, por una moneda'. El oficial en cuyo brazo se apoyaba el rey dijo al hombre de Dios: '¡Aunque Yavé abriera las ventanas del cielo, eso no ocurriría!' Eliseo le dijo: 'Muy bien, tú lo verás con tus ojos, pero no comerás!'"
,"3":"Cuatro leprosos que estaban cerca de la puerta de la ciudad, se dijeron unos a otros: '¿Para qué nos quedamos aquí esperando la muerte? Si nos decidimos a entrar en la ciudad, moriremos, pues hay hambre en la ciudad. Si nos quedamos aquí también moriremos. Mejor desertemos y vayamos al campamento de los arameos. Si nos dejan con vida, viviremos, y si nos matan, moriremos'."
,"5":"Poco después de la puesta del sol se dirigieron al campamento de los arameos, pero cuando llegaron a la entrada del mismo, vieron que no había nadie."
,"6":"Es que el Señor había hecho que se oyera en el campamento de los arameos un ruido de carros y de caballos, el estruendo de un inmenso ejército, ante lo cual se dijeron unos a otros: 'Seguramente el rey de Israel les pagó a los reyes de los hititas y de los egipcios para que vinieran a combatir con nosotros'."
,"7":"Habían pues huido al ponerse el sol, abandonando sus tiendas, caballos y burros, en una palabra, el campamento tal cual estaba, pensando sólo en salvar su vida."
,"8":"Al llegar pues los leprosos a la entrada del campamento, penetraron en una tienda, y comieron y bebieron. Luego tomaron oro, plata y ropas que fueron a esconder. Después volvieron y entraron en otra tienda donde desvalijaron todo lo que había y fueron de nuevo a esconderlo."
,"9":"Entonces se dijeron unos a otros: ' Lo que hacemos no está bien, porque hoy es un día de buena noticia y no decimos nada. Si esperamos hasta que salga el sol, no nos irá bien. Vayamos pues a llevar la noticia al palacio del rey'."
,"10":"Regresaron a la ciudad, llamaron a los guardias de la puerta y les contaron: 'Fuimos al campamento de los arameos y no hay nadie, ninguna presencia humana, sino sólo los caballos y los burros atados y las tiendas tales como las dejaron'."
,"11":"Los porteros gritaron y llegó la noticia al palacio del rey."
,"12":"El rey se levantó de noche y dijo a sus consejeros: 'Les diré lo que hicieron los arameos: como saben que estamos hambrientos, abandonaron el campamento para ir a esconderse en el campo. Dijeron: Cuando los israelitas salgan de la ciudad, los tomaremos presos y luego entraremos en la ciudad'."
,"13":"Pero uno de los consejeros le respondió: 'Tomemos cinco caballos de los que quedan. De todos modos están destinados a morir al igual que el total de los israelitas. Mandémoslos y veamos qué pasa'."
,"14":"Tomaron pues a los carros con sus caballos y el rey los envió tras el ejército de los arameos. '¡Vayan y vean!' les dijo."
,"15":"Siguieron sus huellas hasta el Jordán y fueron viendo que todo el camino estaba jalonado de ropas y objetos que los arameos habían abandonado en su fuga. Los enviados regresaron para decírselo al rey."
,"16":"Salió entonces el pueblo y saqueó el campamento de los arameos; por una moneda de plata se conseguía una gran medida de harina o dos grandes medidas de cebada, tal como lo había dicho Yavé."
,"17":"El rey había asignado a la puerta de la ciudad al oficial en cuyo brazo se apoyaba, para que la vigilara, pero fue pisoteado ahí mismo por la muchedumbre, y murió tal como lo había anunciado el hombre de Dios cuando había bajado el rey a su casa."
,"18":"Pues cuando el hombre de Dios había dicho al rey: 'Mañana, y ese era el caso, se conseguirá en la puerta de Samaría dos grandes medidas de cebada o una gran medida de harina por una moneda de plata',"
,"19":"el oficial había comentado al hombre de Dios: '¡Aunque Yavé abriera las ventanas del cielo, eso no sucederá!' Y Eliseo le había contestado: '¡Muy bien, lo verás con tus ojos, pero no lo comerás!'"
,"20":"Y así ocurrió: la gente lo pisoteó en la puerta de la ciudad, y murió."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Eliseo dijo a la mujer cuyo hijo había resucitado: 'Levántate, sal con tu familia e instálate donde puedas, porque Yavé mandó que venga el hambre a este país y ya llegó. Durará siete años."
,"2":"La mujer se levantó e hizo tal como le había dicho el hombre de Dios; se fue con su familia y estuvo siete años en el territorio de los filisteos."
,"3":"Al cabo de los siete años, volvió la mujer del territorio de los filisteos y fue a reclamar al rey su casa y su campo."
,"4":"El rey estaba hablando con Guejazí, sirviente del hombre de Dios: 'Cuéntame, le decía, todas las cosas extraordinarias que ha hecho Eliseo'."
,"5":"Cuando el sirviente contaba al rey cómo su patrón le había devuelto la vida a un muerto, llegó justamente la mujer a cuyo hijo había resucitado Eliseo, y le solicitó al rey su casa y su campo. Guejazí le dijo: '¡Mi señor rey, esta es justamente la mujer y este es el hijo al que Eliseo le devolvió la vida!'"
,"6":"El rey interrogó a la mujer y ésta le contó todos los detalles, después de lo cual el rey se la encargó a un servidor al que ordenó: 'Haz que devuelvan a esta mujer todo lo que le pertenece, como también las ganancias de su campo desde el día en que dejó este país hasta ahora'."
,"7":"Eliseo se fue a Damasco. El rey de Aram, Ben-Hadad, estaba enfermo y le comunicaron la noticia de que el hombre de Dios había llegado."
,"8":"Entonces el rey dijo a Jazael: 'Prepara un regalo y ve a ver al hombre de Dios. Pídele que consulte a Yavé para saber si sanaré de esta enfermedad'."
,"9":"Jazael fue pues a ver al hombre de Dios, llevándole como regalo de todo lo mejor que hay en Damasco, lo que era transportado en cuarenta camellos. Llegó a la casa del hombre de Dios y, cuando lo hicieron entrar, le dijo: 'Tu hijo Ben-Hadad, rey de Aram, me envió donde ti para saber si sanará de su enfermedad'."
,"10":"Eliseo le respondió: 'Dile que es seguro que sanará, pero Yavé me hizo ver que es seguro que morirá'."
,"11":"Entonces el rostro del hombre de Dios se contrajo y su mirada quedó fija, poniéndose después a llorar."
,"12":"Jazael le dijo: '¿Por qué lloras, señor?' Respondió: 'Porque veo todo el mal que harás a los israelitas. Quemarás sus fortalezas, matarás a espada a sus jóvenes, aplastarás a los niños y abrirás el vientre a las mujeres embarazadas'."
,"13":"Jazael le dijo: '¿Cómo podré yo que soy menos que un perro llevar a cabo tales hazañas?' Eliseo le respondió: 'Yavé me lo ha hecho ver; te vi como rey de Aram'."
,"14":"Jazael se despidió de Eliseo y regresó a la casa de su señor. Este le dijo: '¿Qué te dijo Eliseo?' Respondió: 'Me dijo que es seguro que sanarás'."
,"15":"Pero a la mañana siguiente, tomó una frazada, la sumergió en el agua y la apretó sobre la cara de Ben-Hadad hasta que murió. Y Jazael reinó en su lugar."
,"16":"Yoram, hijo de Josafat, pasó a ser rey de Judá el año quinto del reinado de Yoram, hijo de Ajab, rey de Israel."
,"17":"Tenía treinta y dos años cuando llegó a ser rey, y reinó ocho años en Jerusalén."
,"18":"Se había casado con una hija de Ajab, por eso hizo lo que es malo a los ojos de Yavé, imitó la conducta de los reyes de Israel tal como lo había hecho la familia de Ajab."
,"19":"Pero Yavé no quiso destruir a Judá, en consideración a David su servidor, y a la promesa que le había hecho de darle siempre un heredero entre sus hijos."
,"20":"Durante su reinado, Edom se rebeló contra el dominio de Judá y se dio un rey."
,"21":"El rey Yoram bajó a Seir con todos sus carros, pero los edomitas lo cercaron. Se levantó de noche y junto con los jefes de carros, rompió las líneas edomitas, pero todo el ejército había huido, yéndose cada cual a su casa."
,"22":"Desde entonces hasta hoy día, Edom no ha estado más bajo el dominio de Judá. En ese tiempo también se rebeló Libná."
,"23":"El resto de la historia de Yoram, todos sus hechos, está escrito en el libro de las Crónicas de los reyes de Judá."
,"24":"Yoram se acostó con sus padres y lo enterraron junto a estos en la ciudad de David; en su lugar pasó a ser rey su hijo Ocozías."
,"25":"Ocozías hijo de Yoram comenzó a ser rey de Judá el año duodécimo del reinado de Yoram hijo de Ajab, rey de Israel."
,"26":"Ocozías tenía veintidós años cuando llegó a ser rey, y reinó un año en Jerusalén. Su madre se llamaba Atalía y era hija de Omri, rey de Israel."
,"27":"Se eligió una esposa en la familia de Ajab; después siguió las huellas de la familia de Ajab e hizo lo que disgusta a Yavé."
,"28":"Junto con Yoram, hijo de Ajab, fue a guerrear con Jazael, rey de Aram, en Ramot de Galaad; pero los arameos derrootarron a Yoram."
,"29":"El rey Yoram regresó a Yizreel para que lo curaran pues los arameos lo habían herido en Ramot cuando combatía con Jazael, rey de Aram. Ocozías, hijo de Yoram, rey de Judá, bajó entonces a Yizreel para ver a Yoram hijo de Ajab, que estaba herido."
}`)
	CurrentBook.AddChapter(9, `{
"1":"El profeta Eliseo llamó a uno de los hermanos profetas y le dijo: 'Ponte el cinturón, llévate esta alcuza de aceite y parte para Ramot de Galaad."
,"2":"Cuando hayas llegado, busca a Jehú, hijo de Josafat, hijo de Nimsi, acércate a él y sácalo de entre sus compañeros. Llévalo a un aposento privado,"
,"3":"y luego toma la alcuza de aceite y derrámala sobre su cabeza, diciéndole: Esto dice Yavé: ¡Te he consagrado como rey de Israel! Después abre la puerta y sal huyendo sin tardanza'."
,"4":"El joven profeta partió pues para Ramot de Galaad."
,"5":"Cuando llegó, los jefes del ejército estaban sentados en una reunión; dijo: '¡Jefe, tengo algo que decirte!' Jehú respondió: '¿A cuál de nosotros' Le dijo: '¡A ti, jefe!'"
,"6":"Jehú se paró y entró en la casa, entonces el hermano profeta derramó aceite sobre su cabeza diciéndole: 'Esto dice Yavé, Dios de Israel: Te he consagrado como rey del pueblo de Yavé, de Israel."
,"7":"Tú castigarás a la casa de tu señor Ajab. Haré pagar a Jezabel la sangre de mis servidores los profetas y la sangre de todos los servidores de Yavé."
,"8":"¡Exterminaré a toda la casa de Ajab; eliminaré a todos los varones de la casa de Ajab, tanto al esclavo como al libre en Israel!"
,"9":"¡Trataré a la casa de Ajab como traté a la casa de Jeroboam, hijo de Nabat, y a la de Basa, hijo de Ajía!"
,"10":"¡Los perros se comerán a Jezabel en el campo de Yizreel y nadie la enterrará!' Luego abrió la puerta y salió huyendo."
,"11":"Cuando Jehú volvió donde los oficiales de su señor, éstos le preguntaron: '¿Qué pasa? ¿Para qué te buscaba ese loco?' Les respondió: '¡Ustedes ya conocen a ese hombre y lo que dice!'"
,"12":"Pero le dijeron: '¡No sabemos nada. Cuéntanos lo que pasó!' Les respondió: 'Me dijo esto y aquello, y agregó: Esto dice Yavé: Te he consagrado como rey de Israel'."
,"13":"Entonces, sin esperar más, todos pusieron sus mantos sobre una tarima, y tocaron la trompeta diciendo: '¡Jehú es rey!'"
,"14":"Inmediatamente, Jehú, hijo de Josafat, hijo de Nimsi, conspiró contra Yoram. Yoram, junto con todo Israel, defendía Ramot de Galaad contra el asedio de Jazael, rey de Aram."
,"15":"Pero el rey Yoram había ido a curarse a Yizreel, porque había sido herido por los arameos mientras combatía con Jazael, rey de Aram. Jehú dijo entonces: 'Si les parece, que no salga nadie de la ciudad para llevar la noticia a Yizreel'."
,"16":"Jehú subió a su carro y partió para Yizreel. Yoram estaba en cama y Ocozías, rey de Judá, había ido a visitarlo."
,"17":"El vigía que estaba en la torre de Yizreel vio la tropa que venía con Jehú; dijo entonces: 'Veo una tropa'. Yoram le dijo: 'Búscate a un jinete y mándalo a su encuentro para que les pregunte si vienen como amigos o no'."
,"18":"Salió a su encuentro el jinete y les dijo: 'Esto dice el rey: ¿Ustedes vienen como amigos?' Jehú le respondió: '¡Que te importa a ti! Da media vuelta y sígueme'. El vigía avisó al rey: 'El mensajero llegó donde ellos pero no vuelve'."
,"19":"Enviaron a un segundo jinete, que al toparse con la tropa les dijo: 'Esto dice el rey: ¿Ustedes vienen como amigos?' Jehú le respondió: '¡Y a ti qué te importa! Da media vuelta y sígueme'."
,"20":"El vigía avisó al rey diciéndole: 'Llegó donde ellos pero no regresa. Por la manera de montar diría que es Jehú, hijo de Nimsi; cabalga como un loco'."
,"21":"Entonces Yoram dijo: '¡Enganchen los caballos!' Y los engancharon a su carro. Yoram, rey de Israel y Ocozías, rey de Judá, fueron a encontrar a Jehú cada uno en su carro; y se toparon con él en el campo de Nabot de Yizreel."
,"22":"Cuando Yoram vio a Jehú le dijo: '¿Jehú, vienes como amigo?' Pero éste le respondió: '¿Puede haber paz mientras perduran las prostituciones de tu madre Jezabel y sus muchas hechicerías?'"
,"23":"Entonces Yoram dio media vuelta y emprendió la fuga, gritándole a Ocozías: '¡Nos han traicionado, Ocozías!'"
,"24":"Jehú tendió su arco y disparó una flecha a Yoram, la que penetró por la espalda y le atravesó el corazón; el rey se desplomó en su carro."
,"25":"Jehú dijo entonces a su escudero Bidcar: '¡Tómalo y échalo en el campo de Nabot de Yizreel! Acuérdate de la palabra que Yavé pronunció en su contra cuando tú y yo cabalgábamos detrás de su padre Ajab:"
,"26":"Ayer vi la sangre de Nabot y la sangre de sus hijos, oráculo de Yavé; yo te la haré pagar en este campo. Tómalo pues y tíralo en ese campo, como dijo Yavé'."
,"27":"Al ver todo eso, Ocozías rey de Judá se había dado a la fuga por el camino de Bet-Hagán. Jehú lo persiguió: '¡Maten a ése también!'. Lo hirieron en su carro en la subida de Gur, cerca de Jibleam; se refugió en Meguido y allí murió."
,"28":"Sus servidores lo llevaron en carro a Jerusalén donde lo enterraron en su tumba en la ciudad de David."
,"29":"Ocozías había comenzado a ser rey de Judá el año undécimo de Yoram, hijo de Ajab."
,"30":"Jehú entró en Yizreel; Jezabel ya conocía la noticia. Se pintó los ojos, se arregló el cabello y se asomó a la ventana."
,"31":"Cuando Jehú traspasaba la puerta de la ciudad, le dijo: '¿Cómo te va, Zimri, asesino de tu señor?'"
,"32":"El levantó la vista hacia la ventana y exclamó: '¿Quién está conmigo?' Inmediatamente se inclinaron dos o tres sirvientes."
,"33":"Les dijo: '¡Láncenla por la ventana!' Y la lanzaron. Su sangre salpicó el muro y los caballos que pasaban la pisotearon."
,"34":"Después Jehú entró, comió y bebió; luego dijo: 'Preocúpense de esa maldita y denle sepultura, pues es una hija de rey'."
,"35":"Fueron los sirvientes a sepultarla, pero sólo encontraron el cráneo, los pies y las manos."
,"36":"Volvieron para decírselo a Jehú, quien exclamó: 'Acaba de cumplirse la palabra de Yavé, quien había dicho por medio de su servidor Elías de Tisbé: Los perros se comerán el cuerpo de Jezabel en el campo de Yizreel."
,"37":"El cadáver de Jezabel será como un abono que se esparce y ni siquiera se podrá decir: 'Esta es Jezabel'."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Vivían en Samaría setenta hijos de Ajab. Jehú escribió unas cartas y las envió a Samaría. Mandaba decir a los jefes de la ciudad, a los ancianos y a los que educaban a los hijos de Ajab:"
,"2":"'Ustedes tienen a los hijos de su amo, carros y caballos; su ciudad está fortificada y ustedes tienen armas. Pues bien, cuando reciban esta carta,"
,"3":"elijan al mejor y más valiente de los hijos de su amo, instálenlo en el trono de su padre y prepárense para luchar por la casa de su amo'."
,"4":"Quedaron aterrorizados y se dijeron: 'Si dos reyes no fueron capaces de hacerle frente, ¿cómo podremos hacerlo nosotros?'"
,"5":"El mayordomo del palacio, el gobernador de la ciudad, los ancianos y los que educaban a los hijos del rey dieron a Jehú esta respuesta: 'Somos tus servidores y haremos todo lo que nos pidas. No proclamaremos rey. Haz lo que mejor te parezca'."
,"6":"Jehú les escribió entonces una segunda carta en la que les decía: 'Si están conmigo y si están dispuestos a servirme, tomen las cabezas de los hijos de su amo y vengan a verme mañana a la misma hora en Yizreel'. Los hijos de los reyes eran setenta y eran educados por los nobles de la ciudad."
,"7":"En cuanto recibieron la carta, apresaron a los hijos del rey, degollaron a los setenta, pusieron sus cabezas en unos canastos y se las enviaron a Yizreel."
,"8":"Llegó un mensajero a avisarle a Jehú: '¡Acaban de traer las cabezas de los hijos del rey!' Jehú respondió: 'Hagan con ellas dos montones a la entrada de la puerta de la ciudad hasta mañana'. A la mañana siguiente Jehú salió y se presentó ante el pueblo, diciéndole: 'Ustedes no han cometido delito alguno, mientras que yo conspiré contra mi señor y le di muerte... Pero, ¿quién dio muerte a todos éstos?"
,"10":"Vean como ninguna de las palabras que pronunció Yavé contra la casa de Ajab ha quedado sin cumplirse. Yavé llevó a cabo todo lo que había anunciado por boca de su servidor Elías'."
,"11":"Jehú dio muerte a todos los que aún estaban vivos de la casa de Ajab en Yizreel: a sus consejeros, sirvientes, sacerdotes; no dejó a nadie con vida."
,"12":"Después se encaminó Jehú a Samaría. Cuando llegó a Bet-Equed-de los Pastores,"
,"13":"se encontró con los hermanos de Ocozías, rey de Judá. Les preguntó: '¿Quiénes son ustedes?' Respondieron: 'Somos los hermanos de Ocozías y hemos bajado para saludar a los hijos del rey y a los hijos de la reina'."
,"14":"Entonces Jehú dijo: '¡Deténganlos!' Los apresaron y los degollaron en la Cisterna de Bet-Equed. Eran cuarenta y dos, a ninguno de los cuales dejó Jehú con vida."
,"15":"Saliendo de allí encontró a Yonadab, hijo de Recab, que le salía al encuentro. Lo saludó y le dijo: '¿Serás leal conmigo como yo quiero serlo contigo?' Yonadab le respondió: 'Sí'. 'Si es sí, le dijo, dame la mano'. Yonadab le tendió la mano y Jehú lo hizo subir a su carro al lado de él."
,"16":"Lo llevó en su carro diciéndole: 'Ven conmigo y verás mi celo por Yavé'."
,"16":"Cuando hubo entrado en Samaría, Jehú dio muerte a todos los que quedaban de la familia de Ajab en Samaría; los mató a todos según la palabra de Yavé dicha por Elías."
,"18":"Después reunió Jehú a todo el pueblo e hizo esta proclama: 'Ajab sirvió sólo un poco a Baal, Jehú lo servirá mucho mejor."
,"19":"Que se reúnan en torno a mí todos los profetas de Baal, todos sus ayudantes, todos sus sacerdotes, que no falte nadie porque tengo que ofrecer un gran sacrificio a Baal. Los que no vengan serán condenados a muerte'. Era una trampa, pues así quería Jehú dar muerte a todos los que servían a Baal."
,"20":"Jehú añadió: 'Convoquen a una asamblea solemne en honor de Baal'. Ellos la convocaron."
,"21":"Jehú despachó emisarios por todo Israel y se reunieron todos los servidores de Baal; no faltó ninguno. Entraron en la casa de Baal, la que se llenó de bote en bote."
,"22":"Jehú había dicho al hombre encargado de las vestimentas: 'Saca las vestimentas para todos los servidores de Baal', y aquél había sacado las vestimentas."
,"23":"Cuando Jehú llegó a la casa de Baal junto con Yonadab hijo de Reab, dijo a los seguidores de Baal: 'Averigüen y cerciórense de que aquí no haya ningún servidor de Yavé sino sólo los secuaces de Baal'. Luego entró para ofrecer los sacrificios y los holocaustos. Jehú había ubicado afuera a ochenta hombres, a los que había dicho: 'Entregaré a esos hombres en sus manos, si alguno de ustedes deja escapar a uno solo, pagará con su vida'."
,"25":"En cuanto terminó el holocausto, Jehú dijo a los guardias y a sus oficiales: 'Entren, maten y que no escape nadie'. Los guardias y sus oficiales les dieron muerte a espada; mientras avanzaban hasta el santuario del templo de Baal, iban tirando para afuera los cadáveres."
,"26":"Botaron el poste sagrado de la casa de Baal y lo quemaron,"
,"27":"en seguida demolieron el altar de Baal y lo convirtieron en un basural que existe todavía hoy."
,"28":"Así fue como Jehú hizo que desapareciera el culto a Baal en Israel."
,"29":"Sin embargo Jehú no se apartó de los pecados a los cuales Jeroboam hijo de Nabat había arrastrado a Israel, a saber, los terneros de oro que estaban en Betel y en Dan."
,"30":"Yavé dijo a Jehú: 'Ya que has actuado bien, ya que has hecho lo que es justo a mis ojos, y has llevado a cabo todo lo que había decidido en contra de la casa de Ajab, tus hijos reinarán en Israel hasta la cuarta generación'."
,"31":"Pero Jehú no se preocupó de caminar con todo su corazón según la ley de Yavé, Dios de Israel. No se apartó de los pecados a los que Jeroboam había arrastrado a Israel."
,"32":"Por esos días, Yavé comenzó a reducir el territorio de Israel: Jazael derrotó a los israelitas en todo el territorio"
,"33":"al este del Jordán, en el territorio de Galaad, en el de Gad, Rubén y Manasés, desde Aroer que está encima del torrente Arnón; en una palabra, en Galaad y en Basán."
,"34":"El resto de las acciones de Jehú, todo lo que hizo y toda su valentía, está escrito en el Libro de las Crónicas de los reyes de Israel."
,"35":"Jehú se acostó con sus padres y lo enterraron en Samaría; en su lugar reinó YoAjaz, su hijo."
,"36":"Jehú había reinado en Israel desde Samaría durante veintiocho años."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Al ver que había muerto su hijo Ocozías, Atalía su madre decidió asesinar a toda la descendencia del rey."
,"2":"Mientras se daba muerte a todos los hijos del rey, Yoseba, hija del rey Yoram y hermana de Ocozías, ocultó discretamente a uno de ellos, Yoás hijo de Ocozías. Metió al niño junto con su nodriza en el dormitorio. Así pudo esconderlo de Atalía, quien no le dio muerte."
,"3":"Estuvo escondido seis años junto con Yoseba en la casa de Yavé, mientras Atalía reinaba en el país."
,"4":"Al séptimo año, el sacerdote Yoyada mandó a buscar a los oficiales de los carios y de la guardia. Los hizo entrar a donde él estaba en la casa de Yavé e hizo con ellos un pacto; después de haberlos hecho jurar en la casa de Yavé, les mostró al hijo del rey."
,"5":"Luego les dijo: 'Ustedes van a hacer esto: una tercera parte de ustedes, los que están de guardia el día sábado, vigilarán el palacio real; otra tercera parte se pondrá en la Puerta de Fundación y otra, en la puerta que está frente a los guardias; se irán turnando en la guardia de la Casa."
,"7":"Dos secciones de ustedes, es decir, todos los que acaben su guardia el día sábado, vigilarán el Templo de Yavé, alrededor del rey."
,"8":"Formarán un círculo alrededor del rey, cada cual con su arma en la mano, y si alguien trata de traspasar su formación, lo matarán. Estarán constantemente al lado del rey'. Los sacerdotes hicieron todo lo que les había mandado el sacerdote Yoyada; cada cual tomó a sus hombres, a los que comenzaban su guardia el día sábado y a los que la terminaban y se juntaron alrededor del sacerdote Yoyada."
,"10":"El sacerdote les pasó a los oficiales las lanzas y escudos del rey David que se guardaban en la casa de Yavé;"
,"11":"los guardias se pusieron en sus puestos, con su arma en la mano cada uno, desde el lado derecho de la Casa hasta el lado izquierdo, rodeando el altar y la Casa."
,"12":"Entonces el sacerdote pidió al hijo del rey que se acercara, y le puso la corona y los brazaletes reales. Lo proclamaron rey y lo consagraron; todo el mundo aplaudía y gritaba '¡Viva el rey!'"
,"13":"Al oír los gritos del pueblo, Atalía se dirigió hacia el tumulto que había en la casa de Yavé."
,"14":"Y allí vio que el rey estaba de pie en el estrado como era costumbre, los jefes y los que tocaban la trompeta rodeaban al rey, y todo el pueblo estaba de fiesta y tocaban la trompeta. Entonces Atalía rasgó su vestido y exclamó: '¡Traición, traición!'"
,"15":"El sacerdote Yoyada dio esta orden a los oficiales: '¡Sáquenla del Templo y si alguien está de su parte, mátenlo con la espada!' Pues el sacerdote pensaba: 'No hay que darle muerte dentro de la casa de Yavé'."
,"16":"La apresaron y la llevaron por el camino que conduce a la Entrada de los Caballos hasta el palacio real; allí le dieron muerte."
,"17":"Yoyada hizo un pacto entre Yavé, el rey y el pueblo, para que todo el pueblo se portara realmente como pueblo de Yavé."
,"18":"Todo el pueblo fue a la casa de Baal y la demolieron, rompieron los altares y las estelas; y a Matán, el sacerdote de Baal, lo mataron delante de los altares. El sacerdote puso guardias a la casa de Yavé,"
,"19":"y llevando consigo a los oficiales, a los carios, a los guardias y a todo el pueblo, pidió al rey que bajara desde la casa de Yavé al palacio real por el camino de la Puerta de la Guardia y allí se sentó en el trono real."
,"20":"Toda la población del país estaba de fiesta, y la ciudad había recuperado la paz; Atalía había sido ejecutada a espada en el palacio real."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Yoás llegó a ser rey a la edad de siete años;"
,"2":"era el séptimo año del reinado de Jehú. Reinó cuarenta años en Jerusalén; su madre se llamaba Sibia y era de Berseba."
,"3":"Yoás hizo lo que agrada a Yavé todo el tiempo que estuvo bajo la tutela del sacerdote Yoyada."
,"4":"Pero no desaparecieron los Altos lugares, y el pueblo siguió sacrificando y quemando incienso en los Altos lugares."
,"5":"Yoás dijo a los sacerdotes: 'Todo el dinero que llegue a la casa de Yavé, tanto el de los impuestos personales como el que provenga de las ofrendas voluntarias para la Casa, lo recibirá cada sacerdote de las personas que se dirijan a él. Después lo utilizarán para reparar la Casa donde sea necesario'."
,"7":"Pues bien, el año vigésimo tercero del reinado de Yoás, los sacerdotes todavía no habían hecho las reparaciones de la Casa."
,"8":"El rey Yoás llamó entonces al sacerdote Yoyada y a los demás sacerdotes, y les dijo: '¿Por qué no han hecho las reparaciones de la Casa? En adelante ustedes no les recibirán más el dinero a la gente sino que lo destinarán para la reparación del Templo'."
,"9":"Los sacerdotes aceptaron no recibir más ese dinero y de no tener más a su cargo la reparación del Templo."
,"10":"El sacerdote Yoyada tomó después una caja y mandó hacerle un hoyo en la tapa; la puso al lado del altar, a la derecha de la entrada a la casa de Yavé. Los sacerdotes que custodiaban la puerta de la Casa depositaban en ella todo el dinero que se traía a la casa de Yavé."
,"11":"Cuando veían que no cabía más dinero en la caja, venían el secretario del rey y el sumo sacerdote para recolectar y contar el dinero que había en la casa de Yavé."
,"12":"Después de haberlo contado, se lo pasaban a los que estaban haciendo el trabajo y a los encargados de la mantención de la casa de Yavé; lo invertían en los carpinteros y en los obreros que trabajaban en la casa de Yavé,"
,"13":"en los albañiles y en los picapedreros y también en la compra de la madera y de las piedras talladas para hacer las reparaciones del Templo de Yavé; en una palabra, lo gastaban en todas las reparaciones que eran necesarias en la casa de Yavé."
,"14":"Con el dinero que se aportaba a la casa de Yavé no se hacían ni palanganas de plata, ni cuchillos, ni vasijas ni trompetas, ni ningún otro objeto de oro o plata para la casa de Yavé,"
,"15":"sino que se lo entregaban a los que estaban haciendo el trabajo, los que lo empleaban en hacer las reparaciones de la casa de Yavé."
,"16":"No se pedía cuenta a los hombres a quienes se pasaba el dinero para pagar a los trabajadores, porque eran hombres honrados."
,"17":"Unicamente no era destinado al Templo de Yavé sino que era para los sacerdotes, el dinero de los sacrificios por el pecado y de los sacrificios en reparación de algo."
,"18":"Fue en ese tiempo cuando Jazael, rey de Aram, subió para atacar a Gat y apoderarse de ella. Jazael quería atacar a Jerusalén, pero Yoás, rey de Judá, tomó todos los objetos que habían sido consagrados por Josafat, Yoram y Ocozías, sus antecesores, reyes de Judá, tomó también todo lo que él había dedicado, todo el oro que había en los tesoros del Templo de Yavé y del palacio real, y se lo mandó a Jazael, rey de Aram. Este se alejó de Jerusalén."
,"20":"El resto de los hechos de Yoás, todo lo que hizo, está escrito en el Libro de las Crónicas de los reyes de Judá."
,"21":"Los servidores de Yoás tramaron una conspiración para asesinarlo en Bet-Milo; allí le dieron muerte Yosacar, hijo de Simeat y Yozabad hijo de Somer. Lo enterraron junto a sus padres en la Ciudad de David y en su lugar reinó Amasías, su hijo."
}`)
	CurrentBook.AddChapter(13, `{
"1":"El año vigésimo tercero del reinado de Yoás hijo de Ocozías de Judá, pasó a ser rey en Samaría YoAjaz, hijo de Jehú; reinó diecisiete años en Israel."
,"2":"Hizo lo que desagrada a Yavé e imitó el pecado al que Jeroboam hijo de Nabat había arrastrado a Israel; no se apartó de él."
,"3":"Yavé se enojó con los israelitas y los entregó en manos de Jazael rey de Aram y de Ben-Hadad hijo de Jazael, durante mucho tiempo."
,"4":"YoAjaz suplicó a Yavé y éste lo escuchó porque había visto hasta qué punto el rey de Aram oprimía a los israelitas."
,"5":"Por eso Yavé dio un salvador a Israel, los israelitas lograron librarse de la opresión de Aram y morar de nuevo en sus tiendas tal como en el pasado."
,"6":"Pero no se apartaron de los pecados a los que la casa de Jeroboam había arrastrado a Israel, sino que muy por el contrario siguió en pie hasta el poste sagrado de Samaría."
,"7":"De todo su ejército sólo le quedaron a YoAjaz cincuenta soldados de caballería, diez carros y diez mil soldados de infantería, pues el rey de Aram lo había aplastado y reducido a polvo."
,"8":"El resto de los hechos de YoAjaz, lo que hizo y su valentía, todo eso está escrito en el Libro de las Crónicas de los reyes de Israel."
,"9":"YoAjaz se acostó con sus padres y lo enterraron en Samaría; en su lugar reinó Yoás, su hijo."
,"10":"El año trigésimo séptimo del reinado de Yoás de Judá, Yoás, hijo de YoAjaz, llegó a ser rey de Samaría; reinó seis años en Israel."
,"11":"Hizo lo que no gusta a Yavé, y no se apartó del pecado a que había arrastrado a Israel Jeroboam hijo de Nabat, muy por el contrario."
,"12":"El resto de los hechos de Yoás, todo lo que hizo y la valentía con que luchó con Amasías, rey de Judá, está escrito en el Libro de las Crónicas de los reyes de Israel."
,"13":"Yoás se acostó con sus padres y se sentó en el trono Jeroboam. Enterraron a Yoás en Samaría junto con los reyes de Israel."
,"14":"Eliseo estaba mal de salud por la enfermedad que lo llevó a la muerte. Yoás, rey de Israel, bajó donde él y lloró: '¡Padre mío, padre mío! ¡Carro de Israel y su caballería!'"
,"15":"Eliseo le respondió: 'Toma un arco y flechas'; Yoás fue pues a tomar un arco y flechas."
,"16":"Eliseo dijo al rey de Israel: 'Toma tu arco con las manos'. Lo hizo. Eliseo puso sus manos sobre las del rey,"
,"17":"luego dijo: '¡Abre la ventana del lado este!' La abrió. Eliseo añadió: '¡Dispara!' Disparó. Eliseo dijo entonces: '¡Flecha de la victoria de Yavé! ¡Flecha de la victoria de Aram! Derrotarás a Aram en Afec, hasta que no quede nadie'."
,"18":"En seguida le dijo: 'Junta las flechas'. Las juntó. Eliseo dijo al rey de Israel: 'Golpea el suelo'. Y el rey lo golpeó tres veces y se detuvo."
,"19":"Entonces el hombre de Dios se enojó con el rey y dijo: '¡Tenías que haber golpeado cinco o seis veces! Así habrías derrotado a Aram hasta que no quedara nadie. Pero ahora sólo derrotarás a Aram tres veces'."
,"20":"Murió Eliseo y lo enterraron. Bandas de moabitas incursionaban cada año en el país,"
,"21":"y sucedió que unas personas que llevaban a enterrar a un difunto, divisaron a una de esas bandas. Depositaron entonces al muerto en la tumba de Eliseo y se pusieron a salvo. Cuando el hombre tocó los huesos de Eliseo, revivió e inmediatamente se puso de pie."
,"12":"Jazael rey de Aram había oprimido a los israelitas durante todo el reinado de YoAjaz."
,"23":"Pero después Yavé los perdonó y tuvo compasión de ellos; se volvió hacia ellos a causa de la alianza que había hecho con Abrahán, Isaac y Jacob y no quiso destruirlos. Todavía no los había echado lejos."
,"24":"Jazael rey de Aram murió y en su lugar reinó Ben-Hadad su hijo."
,"25":"Entonces Yoás arrebató a Ben-Hadad las ciudades que su padre Jazael había quitado a YoAjaz, padre de Yoás, durante esas guerras Yoás lo derrotó tres veces y reconquistó las ciudades de Israel."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Amasías hijo de Yoás, rey de Judá, comenzó a reinar el décimo año de Yoás hijo de YoAjaz, rey de Israel."
,"2":"Tenía veinticinco años cuando subió al trono y reinó veintinueve años en Jerusalén."
,"3":"Hizo lo que es justo a los ojos de Yavé, pero no como su padre David. De todos modos, se portó como su padre Yoás."
,"4":"Los Altos Lugares no desaparecieron y el pueblo continuó ofreciendo sacrificios y quemando incienso en los Altos Lugares."
,"5":"En cuanto Amasías fue dueño de la situación en su reino, condenó a muerte a sus servidores que habían dado muerte a su padre,"
,"6":"pero no condenó a muerte a los hijos de los asesinos de acuerdo a lo que está escrito en el Libro de la Ley de Moisés. Yavé, en efecto, dio este mandato: 'Los padres no serán condenados a muerte por los hijos, ni éstos por sus padres; sino que cada cual será condenado a muerte por su propio pecado'."
,"7":"Amasías derrotó a los edomitas en el valle de la Sal y se apoderó de la meseta a costa de un duro combate; le dio el nombre de Yoctel, el que lleva hasta el día de hoy."
,"8":"Entonces Amasías envió mensajeros a Yoás hijo de YoAjaz, hijo de Jehú, rey de Israel: 'Ven a pelear conmigo', le decía."
,"9":"Yoás rey de Israel mandó decir a Amasías rey de Judá: 'El espino del Líbano mandó decir al cedro del Líbano: Da tu hija a mi hijo como esposa. Pero el animal salvaje del Líbano pasó y arrasó con el espino."
,"10":"Venciste a Edom y estás orgulloso de ello. Muy bien, ufánate y quédate en casa. ¿Para qué vas a atraer la desgracia y la muerte sobre ti y sobre Judá?'"
,"11":"Pero Amasías no le hizo caso. Entonces Yoás rey de Israel avanzó y se enfrentaron en Bet-Semés, que está en Judá."
,"12":"Judá fue derrotado por Israel y todos huyeron a sus tiendas."
,"13":"Yoás, rey de Israel, tomó prisionero a Amasías rey de Judá, hijo de Yoás, hijo de Ocozías, en Bet-Semés y se lo llevó a Jerusalén. Demolió la muralla de Jerusalén en más de cien metros, desde la puerta de Efraín hasta la puerta del Angulo;"
,"14":"se apoderó de todo el oro y la plata, de todos los objetos que había en la casa de Yavé y en el tesoro del palacio real como también de los rehenes, y regresó después a Samaría."
,"15":"El resto de los hechos de Yoás y lo que hizo, su valentía, la manera como combatió con Amasías, rey de Judá, todo eso está escrito en el Libro de las Crónicas de los reyes de Israel."
,"16":"Yoás se acostó con sus padres y lo enterraron en Samaría junto a los reyes de Israel; en su lugar reinó Jeroboam, su hijo."
,"17":"Después de la muerte de Yoás hijo de YoAjaz, rey de Israel, Amasías hijo de Yoás, rey de Judá, vivió aún quince años."
,"18":"El resto de los hechos de Amasías está escrito en el Libro de las Crónicas de los reyes de Judá."
,"19":"Hubo una conspiración en su contra en Jerusalén y tuvo que huir a Laquis, pero lo persiguieron hasta allá y murió en esa ciudad."
,"20":"Lo trajeron de vuelta a caballo y lo enterraron en Jerusalén junto a sus padres en la ciudad de David."
,"21":"Todo el pueblo de Judá fue donde Azarías, que no tenía más que dieciseis años, y lo proclamaron rey en lugar de su padre Amasías."
,"22":"Reconstruyó Elat y se la devolvió a Judá después que su padre fue a acostarse con sus padres."
,"23":"El año quince de Amasías hijo de Yoás, rey de Judá, pasó a ser rey en Samaría, Jeroboam hijo de Yoás, rey de Israel. Reinó cuarenta y un años."
,"24":"Hizo lo que es malo a los ojos de Yavé y no se apartó de todos los pecados a que Jeroboam hijo de Nabat había arrastrado a Israel."
,"25":"Fue él quien restableció las fronteras de Israel desde la entrada de Jamat hasta el mar de Arabá, tal como Yavé, Dios de Israel, lo había dicho por boca de su servidor, el profeta Jonás, hijo de Amitai, que era de Gat- Jefer."
,"26":"Es que Yavé había visto la misérrima situación de Israel: ya no había nadie, ni esclavo ni hombre libre, capaz de ayudar a Israel."
,"27":"Yavé no había decidido todavía borrar el nombre de Israel de debajo de los cielos y lo libró por la mano de Jeroboam, hijo de Yoás."
,"28":"El resto de los hechos de Jeroboam, todo lo que hizo y su valentía, la manera como luchó y reconquistó Damasco y Jamat para Israel, todo eso está escrito en el Libro de las Crónicas de los reyes de Israel."
,"29":"Jeroboam se acostó con sus padres y lo enterraron en Samaría junto a los reyes de Israel; en su lugar reinó Zacarías, su hijo."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Azarías, hijo de Amasías, rey de Judá, comenzó a reinar el año vigésimo séptimo de Jeroboam, rey de Israel."
,"2":"Tenía dieciseis años cuando subió al trono y reinó cincuenta y dos años en Jerusalén; su madre se llamaba Jecolías y era de Jerusalén."
,"3":"Hizo lo que es justo a los ojos de Yavé, tal como lo había hecho su padre Amasías."
,"4":"Los Altos Lugares, sin embargo, no desaparecieron, y el pueblo siguió ofreciendo sacrificios y quemando incienso en los Altos Lugares."
,"5":"Yavé castigó al rey, quien fue leproso hasta su muerte y tuvo que vivir en una casa aislada; Yotam, el hijo del rey, era el administrador del palacio y gobernaba a la población del país."
,"6":"El resto de los hechos de Azarías, todo lo que hizo, está escrito en el Libro de las Crónicas de los reyes de Judá."
,"7":"Azarías se acostó con sus padres y lo enterraron junto a sus padres en la Ciudad de David; en su lugar reinó su hijo Yotam."
,"8":"El año treinta y ocho de Azarías, rey de Judá, Zacarías, hijo de Jeroboam pasó a ser rey de Israel en Samaría por seis meses."
,"9":"Hizo lo que es malo a los ojos de Yavé, tal como lo habían hecho sus padres. No se apartó de los pecados a que había arrastrado a Israel Jeroboam, hijo de Nabat."
,"10":"Salum, hijo de Yabés, conspiró contra él: lo asesinó en Jibleam y fue rey en su lugar."
,"11":"El resto de los hechos de Zacarías está escrito en el Libro de las Crónicas de los reyes de Israel."
,"12":"Yavé había dicho a Jehú: 'Tus hijos se sentarán en el trono de Israel hasta la cuarta generación'. Y eso fue lo que sucedió."
,"13":"Salum hijo de Jabés comenzó a reinar el año treinta y nueve de Ozías, rey de Judá. Reinó sólo un mes en Samaría."
,"14":"Menajem hijo de Gadi subió desde Tirsa y entró en Samaría donde asesinó a Salum, hijo de Jabés; después de eso pasó a ser rey en su lugar."
,"15":"El resto de los hechos de Salum y la manera como conspiró, está escrito en el Libro de las Crónicas de los reyes de Israel."
,"16":"Después Menajem castigó a Tapúa y a todos sus habitantes como también a todo su territorio desde Tirsa porque no le habían abierto las puertas; y a todas las mujeres embarazadas les abrió el vientre."
,"17":"Menajem hijo de Gadi comenzó a reinar en Israel desde Samaría el año treinta y nueve de Azarías, rey de Judá. Reinó diez años."
,"18":"Hizo lo que es malo a los ojos de Yavé y no se apartó de los pecados a que había arrastrado a Israel Jeroboam hijo de Nabat. En su tiempo,"
,"19":"Pul rey de Asur, invadió el país; Menajem le dio mil talentos de plata para que le proporcionara ayuda y afirmara el poder real en sus manos."
,"20":"Menajem recaudó este dinero en todo Israel: todos los nobles tuvieron que entregar cincuenta monedas de plata por persona para dárselas al rey de Asur. Después de eso el rey de Asur abandonó el país y se volvió."
,"21":"El resto de los hechos de Menajem, todo lo que hizo, está escrito en el Libro de las Crónicas de los reyes de Israel."
,"22":"Menajem se acostó con sus padres y en su lugar reinó su hijo Pecajía."
,"23":"Pecajía, hijo de Menajem, empezó a reinar en Israel desde Samaría el año cincuenta de Azarías, rey de Judá. Su reinado duró dos años. Hizo lo que es malo a los ojos de Yavé y no se apartó de los pecados a que Jeroboam hijo de Nabat había arrastrado a Israel."
,"25":"Pecaj, hijo de Remalías, su escudero, conspiró contra él y lo asesinó en Samaría en la torre del palacio real. Había contratado a cincuenta hombres de Galaad para asesinar al rey y reinar en su lugar."
,"26":"El resto de los hechos de Pecajía y todo lo que hizo está escrito en el Libro de las Crónicas de los reyes de Israel."
,"27":"Pecaj hijo de Remalías comenzó a reinar en Samaría el año cincuenta y dos de Azarías, rey de Judá y reinó veinte años."
,"28":"Hizo lo que es malo a los ojos de Yavé y no se apartó de los pecados a que había arrastrado a Israel Jeroboam hijo de Nabat."
,"29":"En tiempo de Pecaj, rey de Israel, Teglat-Falesar, rey de Asur, se apoderó de Iyón, de Abel-Bet-Maacá, de Jamaj, de Quedés, de Jazor, de Galaad y de la Galilea, de todo el territorio de Neftalí, y deportó a Asur a sus habitantes."
,"30":"Oseas, hijo de Elá, tramó entonces una conspiración contra Pecaj, hijo de Remalías; lo asesinó y reinó en su lugar el año veinte de Yotam hijo de Ozías."
,"31":"El resto de los hechos de Pecaj y todo lo que hizo está escrito en el Libro de las Crónicas de los reyes de Israel."
,"32":"Yotam, hijo de Ozías, rey de Judá, comenzó a reinar el segundo año de Pecaj hijo de Remalías, rey de Israel."
,"33":"Tenía veinticinco años cuando subió al trono y reinó dieciseis años en Jerusalén; su madre se llamaba Jerusa y era hija de Sadoc."
,"34":"Hizo lo que es justo a los ojos de Yavé, tal como lo había hecho su padre Ozías;"
,"35":"sólo que no desaparecieron los Altos Lugares. El pueblo siguió ofreciendo sacrificios y quemando incienso en los Altos Lugares. El fue quien construyó la Puerta Alta del Templo de Yavé."
,"36":"El resto de los hechos de Yotam, todo lo que hizo, está escrito en el Libro de las Crónicas de los reyes de Judá."
,"37":"En aquellos días, Yavé comenzó a lanzar contra Judá a Razón, rey de Aram, y a Pecaj hijo de Remalías."
,"38":"Yotam se acostó con sus padres y lo enterraron junto a éstos en la Ciudad de David su antepasado; en su lugar reinó Ajaz, su hijo."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Ajaz, hijo de Yotam, rey de Judá, comenzó a reinar el año décimo séptimo de Pecaj, hijo de Remalías."
,"2":"Ajaz tenía veinte años cuando subió al trono y reinó dieciseis en Jerusalén. No hizo lo que es justo a los ojos de Yavé, su Dios, tal como su antepasado David."
,"3":"Siguió más bien as huellas de los reyes de Israel, y hasta llegó a sacrificar a su hijo en la hoguera, según las prácticas odiosas de los pueblos que Yavé había echado ante los israelitas."
,"4":"Ofreció sacrificios y quemó incienso en los Altos Lugares, en las colinas y bajo cualquier árbol verde."
,"5":"Entonces Razón, rey de Aram, y Pecaj, hijo de Remalías, rey de Israel, subieron a Jerusalén para atacarla. Sitiaron a Ajaz, pero no pudieron vencerlo."
,"6":". En ese tiempo el rey de Edom recuperó Elat y expulsó a los judíos que se habían instalado allí; los edomitas tomaron posesión de ella y permanecen allí hasta hoy."
,"7":"Ajaz mandó mensajeros a Teglat-Falazar, rey de Asur: 'Soy tu sirviente y tu hijo, le decía, ven a salvarme del rey de Aram y del rey de Israel que vinieron a atacarme'."
,"8":"Ajaz tomó la plata y el oro que había en la casa de Yavé y en el tesoro del palacio real, y se lo dio al rey de Asur."
,"9":"El rey de Asur lo atendió, y marchó para atacar a Damasco, la que conquistó; deportó a sus habitantes a Quir y mandó ejecutar a Razón."
,"10":"Cuando el rey Ajaz fue a Damasco para entrevistarse con Teglat-Falazar, rey de Asur, vio un altar que había en Damasco; mandó un dibujo de ese altar y un modelo del mismo, con todos sus detalles, al sacerdote Urías."
,"11":"Antes que regresara de Damasco el rey Ajaz, el sacerdote Urías construyó un altar exactamente igual a las indicaciones que había enviado el rey Ajaz."
,"12":"Cuando el rey vio el altar a su regreso de Damasco, subió personalmente a él para ofrecer sacrificios."
,"13":"Quemó su holocausto y su ofrenda, derramó la libación y roció el altar con la sangre de los sacrificios pacíficos."
,"14":"Trasladaron el altar de bronce que estaba delante de Yavé; lo sacaron de delante de la Casa donde se encontraba entre el altar nuevo y la casa de Yavé, y lo pusieron al lado del altar nuevo hacia el norte."
,"15":"El rey Ajaz dio esta orden al sacerdote Urías: En este gran altar quemarás el holocausto de la mañana y la ofrenda de la tarde, el holocausto del rey y su ofrenda, el holocausto por toda la población del país, su ofrenda y sus libaciones. Desde allí harás la aspersión de la sangre de todos los holocaustos y sacrificos. En cuanto al altar de bronce, ya veré lo que se hace'."
,"16":"El sacerdote Urías hizo todo lo que le había ordenado el rey Ajaz."
,"17":"El rey Ajaz rompió los paneles y las bases, quitó los lavatorios que estaban encima, bajó el Mar de Bronce de encima de los bueyes que lo sostenían y lo puso en un embaldosado de piedras."
,"18":"Como deferencia al rey de Asur transformó el Pórtico del Sábado, que se había construido dentro del Templo de Yavé, y la Entrada del rey que estaba fuera del mismo."
,"19":"El resto de los hechos de Ajaz está escrito en el Libro de las Crónicas de los reyes de Judá."
,"20":"Ajaz se acostó con sus padres y lo enterraron junto a éstos en la Ciudad de David; en su lugar reinó Ezequías, su hijo."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Oseas, hijo de Elá, comenzó a reinar en Israel desde Samaría, el año duodécimo de Ajaz, rey de Judá; reinó nueve años."
,"2":"Hizo lo que es malo a los ojos de Yavé, pero no tanto como los reyes de Israel que lo habían precedido."
,"3":"Salmanazar rey de Asur fue a atacarlo y Oseas tuvo que sometérsele, pagándole un tributo."
,"4":"Pero el rey de Asur supo que Oseas estaba conspirando contra él, ya que había enviado mensajeros a Saís, donde el rey de Egipto, y no pagaba más el tributo al rey de Asur, como debía hacerlo cada año. Aquel, entonces, lo mandó arrestar y lo metió encadenado a la cárcel."
,"5":"El rey de Asur invadió todo el país; llegó a Samaría y la sitió tres años."
,"6":"El año noveno de Oseas, el rey de Asur se apoderó de Samaría y deportó a Asur a los israelitas. Los instaló en Jala a orillas del Jabor, el río de Gozán, y además en las ciudades de Media."
,"7":"Eso ocurrió porque los hijos de Israel habían pecado contra Yavé su Dios, quien los había hecho subir del territorio de Egipto y los había librado de las manos del Faraón, rey de Egipto, y se habían vuelto hacia otros dioses."
,"8":"Los israelitas imitaron las costumbres de los pueblos que Yavé había expulsado delante de los hijos de Israel."
,"9":"Pronunciaron contra Yavé, su Dios, palabras indecentes, se construyeron Altos Lugares en todas sus ciudades, desde la torre de vigía hasta en la ciudad fortificada."
,"10":"Instalaron piedras paradas y postes sagrados en cualquier colina sobresaliente y bajo cualquier árbol verde."
,"11":"Y allí, en todos esos Altos Lugares, quemaban incienso tal como lo hacían las naciones que Yavé había expulsado ante ellos; cometieron además toda clase de malas acciones para irritar a Yavé."
,"12":"Se pusieron a servir a ídolos inmundos siendo que Yavé les había dicho: 'No hagan eso'."
,"13":"Yavé, sin embargo, les había llamado la atención a Israel y a Judá por boca de todos los profetas y de todos los videntes: 'Renuncien a su mal comportamiento y observen mis mandatos y mis órdenes, según esa Ley que ordené a sus padres y que les comuniqué por boca de mis servidores los profetas'."
,"14":"Pero no hicieron caso, y se mostraron más tercos que sus padres que no habían creído en Yavé, su Dios."
,"15":"Despreciaron sus mandatos, la Alianza que había pactado con sus padres, y las ordenanzas que les había dado. Se apegaron a ídolos inútiles y se hicieron tan inútiles como sus ídolos, igual que las naciones que los rodeaban, siendo que Yavé les había mandado que no las imitaran."
,"16":"Abandonaron todos los mandamientos de Yavé, su Dios, y se hicieron ídolos de metal ¡sus dos terneros! Erigieron postes sagrados, se postraron ante todos los poderes del cielo, y sirvieron a Baal."
,"17":"Sacrificaron en la hoguera a sus hijos y a sus hijas, practicaron la hechicería y la magia, se prestaron para hacer lo que es malo a los ojos de Yavé, para provocar su cólera."
,"18":"Al final, Yavé se enojó con Israel y lo echó lejos. Unicamente quedó la tribu de Judá."
,"19":"Pero Judá tampoco cumplió los mandamientos de Yavé, su Dios; imitaron las prácticas que se habían hecho una costumbre en Israel."
,"20":"Por eso Yavé rechazó a toda la raza de Israel, los castigó, los entregó en manos de salteadores, y por último, los echó lejos de su presencia."
,"21":"Cuando Jeroboam hijo de Nabat separó Israel de la casa de David, cuando lo consagraron como rey, apartó a Israel lejos de Yavé, haciéndo que cometiera un gran pecado."
,"22":"Los israelitas persistieron en todos los pecados que había cometido Jeroboam, y no se apartaron de ellos,"
,"23":"de tal modo que al último Yavé echó a Israel lejos de él, tal como lo había dicho por boca de todos sus servidores los profetas; Israel fue deportado a Asur lejos de su tierra hasta el día de hoy."
,"24":"El rey de Asur trasladó gente de Babilonia, de Cuta, de Avá, de Jamat, y de Sefarvayim, y la instaló en las ciudades de Samaría en lugar de los israelitas. Así tomaron posesión de Samaría y se establecieron en sus ciudades."
,"25":"Cuando estaban recién instalados en ese lugar, esa gente no honraba a Yavé, por eso Yavé les mandó unos leones que hicieron con ellos una carnicería."
,"26":"Entonces dijeron al rey de Asur: 'Los pueblos que trasladaste e instalaste en las ciudades de Samaría no conocen la Ley del dios del país. Por eso envió contra nosotros leones, los que los mataron porque no conocían la Ley del dios de este país'."
,"27":"El rey de Asur dio entonces esta orden: 'Manden de vuelta allá a uno de los sacerdotes que he deportado, que se establezca allí y que les enseñe la Ley del dios del país."
,"28":"Uno de los sacerdotes de Samaría que había sido deportado fue pues para allá; se instaló en Betel y les enseñó cómo debían honrar a Yavé."
,"29":"Pero cada pueblo se hacía sus propios dioses y los ponía en las ermitas de los Altos Lugares que habían construido los samaritanos, cada pueblo lo hacía en las ciudades donde vivía."
,"30":"Fue así como la gente de Babilonia se hizo un Sucot-Benot; la gente de Cuta, un Nergal; los de Jamat, un Asima; los de Avá se hicieron un Nibjaz y un Tartac; los de Sefarvayim quemaban en la hoguera a sus hijos en honor a Adramalec y a Amamelec, las divinidades de Sefarvayim."
,"32":"También servían a Yavé, por eso eligieron entre ellos a sacerdotes para los Altos Lugares, para que sirvieran en su nombre en las ermitas de los Altos Lugares."
,"33":"Servían a Yavé y al mismo tiempo a sus dioses, según las costumbres de las naciones de donde provenían."
,"34":"Hasta el día de hoy siguen con sus antiguas costumbres. No honran realmente a Yavé porque no toman en cuenta sus ritos ni sus costumbres, de acuerdo a la Ley y el mandato que Yavé dio a los hijos de Jacob, el hombre a quien dio el nombre de Israel."
,"35":"Yavé había pactado con ellos una Alianza y les había dado esta orden: 'No sirvan a dioses extranjeros, no se postren ante ellos, no les rindan culto ni les ofrezcan sacrificios; ustedes no tienen más que a Yavé, quien los hizo subir del territorio de Egipto demostrando su fuerza y dando grandes golpes. A él tienen que servir, ante él deben postrarse y a él tienen que ofrecer sacrificios."
,"37":"Ustedes tienen que respetar y poner en práctica diariamente los preceptos, las ordenanzas, la Ley y los mandamientos que escribió para ustedes; no sirvan a otros dioses."
,"38":"No se olviden de la Alianza que pacté con ustedes ni sirvan a otros dioses."
,"39":"A Yavé, su Dios es a quien deben servir, a él que los librará de las manos de todos sus enemigos'."
,"40":"Pero no hicieron caso y siguen con sus antiguas costumbres."
,"41":"Así pues esos pueblos si bien temían a Yavé servían también a sus ídolos, y sus hijos y nietos actúan hasta el día de hoy como lo hacían sus padres."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Ezequías, hijo de Ajaz, rey de Judá, llegó a ser rey el tercer año de Oseas hijo de Elá, rey de Israel."
,"2":"Tenía veinticinco años cuando subió al trono y reinó veintinueve años en Jerusalén. Su madre se llamaba Abija, y era hija de Zacarías."
,"3":"Hizo lo que es recto a los ojos de Yavé, tal como lo había hecho su antepasado David."
,"4":"Hizo desaparecer los Altos Lugares, rompió las piedras paradas, derribó los postes sagrados y destruyó hasta la serpiente de bronce que había hecho Moisés, porque hasta ese entonces los israelitas la llamaban Nejustán y le ofrecían incienso."
,"5":"Puso su confianza en Yavé, el Dios de Israel, y entre los reyes de Judá que le siguieron, ninguno se comparó con él."
,"6":"Permaneció fiel a Yavé y nunca se apartó de él, sino que respetó los mandamientos que Yavé había ordenado a Moisés."
,"7":"Por este motivo Yavé estuvo con él y tuvo éxito en todo lo que llevó a cabo. Se rebeló contra el rey de Asur y dejó de servirle;"
,"8":"combatió a los filisteos hasta Gaza y sus alrededorese, destruyendo sus torres de vigilancia y sus ciudades fortificadas."
,"9":"El cuarto año del reinado de Ezequías -era el séptimo año de Oseas hijo de Elá, rey de Israel- Salmanazar, rey de Asur, subió a Samaría, la sitió y se apoderó de ella."
,"10":"Al cabo de tres años, el año sexto de Ezequías y el noveno de Oseas, rey de Israel, Samaría fue conquistada."
,"11":"El rey de Asur deportó a Asur a los israelitas y los instaló en Jalaj, a orillas del río de Gozán llamado Jabor, y en las ciudades de los medos."
,"12":"Todo eso sucedió porque no habían obedecido la palabra de Yavé, su Dios, y porque habían violado su Alianza; no habían tomado en cuenta todo lo que había ordenado Moisés, el servidor de Yavé ni lo habían puesto en práctica."
,"13":"El año décimo cuarto del rey Ezequías, Senaquerib rey de Asur fue a atacar todas las ciudades fortificadas de Judá y se apoderó de ellas."
,"14":"Entonces Ezequías rey de Judá mandó este mensaje al rey de Asur, que estaba en Laquis: '¡Me he portado mal! Aléjate de mí y haré lo que me pidas'. El rey de Asur exigió a Ezequías rey de Judá trecientos talentos de plata y treinta talentos de oro."
,"15":"Ezequías le entregó todo el dinero que había en la casa de Yavé y en las arcas del palacio real."
,"16":"Fue entonces cuando Ezequías rey de Judá sacó de las puertas del Templo de Yavé y de sus postes el oro con que el mismo las había cubierto, para dárselo al rey de Asur."
,"17":"Desde Laquis el rey de Asur mandó a Jerusalén donde el rey Ezequías a su comandante en jefe, a su gran eunuco y a su copero mayor junto con una numerosa tropa; caminaron y llegaron a Jerusalén. Se detuvieron cerca del canal de la piscina superior que está junto al camino del campo del Batanero"
,"18":"y llamaron al rey. Entonces subieron a su encuentro Elyaquim hijo de Jilquim, mayordomo de Palacio, el secretario Sobná y el archivero Yoás hijo de Asaf. El copero mayor les dijo: 'Transmitan a Ezequías estas palabras del gran rey, del rey de Asur: ¿Con qué puedes contar todavía?"
,"20":"¿Crees acaso que para hacer la guerra algunas declaraciones reemplazan a la sabiduría y al coraje? ¿En quién te apoyaste para rebelarte contra mí?"
,"21":"Te apoyaste en Egipto, una caña rota que clava y traspasa la mano del que se apoya en ella. ¡Eso es el Faraón para los que confían en él!"
,"22":"A lo mejor me dirás: ¡Nosotros confiamos en Yavé, nuestro Dios! Pero, ¿no fue Ezequías quien hizo desaparecer los Altos Lugares y los altares de Yavé cuando dijo a Judá y a Jerusalén: Ustedes sólo se postrarán en Jerusalén, delante de este altar?"
,"23":"Haz ahora una apuesta con mi señor el rey de Asur: te doy dos mil caballos si tienes jinetes para montarlos."
,"24":"Pero, ¡si ni siquieras puedes hacer retroceder al último de los oficiales que sirven a mi señor! Mientras tú confiabas en Egipto para recibir carros y caballería,"
,"25":"yo, por voluntad de Yavé, subía hasta este lugar para devastarlo. Yavé, en efecto, me dijo: '¡Ataca a ese país y devástalo!'"
,"26":"Elyaquim, Sobná y Yoás respondieron al copero mayor: 'Por favor, hábla a tus servidores en arameo, que entendemos, pero no nos hables en judío delante de toda esa gente que se encuentra en la muralla'."
,"27":"El copero mayor les dijo: '¿Acaso mi señor me mandó transmitir estas palabras sólo a tu patrón y a ti? ¿No fue más bien a todos esos hombres parados en la muralla, los que pronto tendrán igual que ustedes que comer sus excrementos y tomarse la orina?'"
,"28":"El copero mayor se paró entonces y gritó con fuerza en judío: 'Oigan la palabra del gran rey de Asur:"
,"29":"¡Ezequías los engaña! Es incapaz de salvarlos de mis manos."
,"30":"Que no les diga: 'Confíen en Yavé, pues seguramente Yavé nos librará y esta ciudad no caerá en manos del rey de Asur'."
,"31":"No hagan caso a Ezequías, sino más bien al rey de Asur que les dice: Hagan la paz conmigo, ríndanse, y cada uno de ustedes seguirá comiendo de su viña y de su higuera, y bebiendo el agua de su cisterna."
,"32":"Pronto volveré para llevarlos a un país parecido al de ustedes, un país de trigo y de vino, un país de pan y de viñas, un país de aceite fresco y de miel. Allí vivirán y no morirán. Pero no le hagan caso a Ezequías porque los engaña diciéndoles que Yavé los librará."
,"33":"¿Acaso pudieron los diversos dioses de las naciones salvar cada uno a su país de las manos del rey de Asur?"
,"34":"¿Dónde están los dioses de Jamat y de Arpad, dónde los dioses de Sefarvaim, de Hena y de Ivva? ¿Dónde están los dioses de Samaría? ¿Pudieron librar de mis manos a Samaría?"
,"35":"¿Entre todos los dioses de esos países, quién ha sido capaz de librar a su país de mis manos? ¡Y Yavé va a librar ahora a Jerusalén!'"
,"36":"El pueblo guardó silencio; nadie le respondió una palabra, porque el rey había dado esta orden: '¡No le respondan!'"
,"37":"Después de eso, Elyaquim hijo de Jilquiyas, el secretario Sobna y el archivero Yoás hijo de Asaf volvieron donde Ezequías, con sus ropas rasgadas, y le transmitieron las palabras del copero mayor."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Apenas oyó esas palabras el rey Ezequías rasgó su ropa, se cubrió con un saco y se dirigió a la casa de Yavé."
,"2":"Después mandó donde el profeta Isaías, hijo de Amós, al mayordomo de palacio Elyaquim, al secretario Sobná y a los sacerdotes más ancianos, todos iban vestidos con sacos."
,"3":"Le dijeron: 'Esto dice Ezequías: Este día es de desgracia, de castigo y de vergüenza. Los niños están a punto de nacer, pero falta fuerza para darlos a luz."
,"4":"¡Que Yavé tu Dios oiga todas las palabras del copero mayor al que mandó el rey de Asur, su señor, para insultar al Dios vivo! ¡Que Yavé tu Dios castigue las palabras que ha oído! y tú eleva una oración por el resto que aún queda'."
,"5":"Los servidores del rey Ezequías llegaron donde Isaías."
,"6":"Isaías les dijo: 'Transmítan a su señor esta palabra de Yavé: No tengas miedo de las palabras que oíste, de esas blasfemias que pronunciaron en mi contra los sirvientes del rey de Asur."
,"7":"Lo voy a impresionar por una noticia que recibirá, de manera que vuelva a su país, y en su país será asesinado'."
,"8":"El copero mayor se fue y encontró al rey de Asur ocupado en atacar a Libna; el copero mayor ya sabía que el rey había dejado Laquis"
,"9":"después de haber recibido esta noticia: 'Taraca, rey de Etiopía, ha salido a atacarte'. Nuevamente el rey mandó mensajeros a Ezequías, diciéndoles:"
,"10":"'A Ezequías rey de Judá le dirán esto: Tú pones tu confianza en tu Dios y dices que Jerusalén no caerá en manos del rey de Asur, pero es cierto que te va a defraudar."
,"11":"Oíste lo que los reyes de Asur hicieron a todos los países: los condenaron al anatema. ¿Y tú piensas que te vas a librar?"
,"12":"¿Los dioses de las naciones que mis padres exterminaron, Gozán, Jarán, Recef y los edenitas de Tel-Basar, pudieron salvarlos?"
,"13":"¿Dónde están los reyes de Jamat, de Arpad, de Lair, de Safarvaim, de Hena y de Ivva?'"
,"14":"Ezequías recibió la carta de manos de los mensajeros y la leyó; después se dirigió a la casa de Yavé. Allí Ezequías la desenrolló delante de Yavé,"
,"15":"e hizo esta oración: 'Yavé, Dios de Israel, Dios que te sientas sobre los querubines, no hay más Dios que tú en todos los reinos de la tierra; tú hiciste el cielo y la tierra."
,"16":"¡Pon atención, Yavé, óyeme, abre los ojos, Yavé, y mira!"
,"17":"Es cierto, Yavé, que los reyes de Asur han arrasado las naciones paganas."
,"18":"Echaron sus dioses al fuego, pero esos no eran dioses, sino sólo la obra de las manos del hombre, hechos de madera y de piedra; por eso los destruyeron."
,"19":"¡Pues bien, Yavé, Dios nuestro, líbranos ahora de su mano, te lo suplico, y así sabrán todos los reinos de la tierra que sólo tú, Yavé, eres Dios!'"
,"20":"Isaías hijo de Amós mandó a decir a Ezequías: 'Esto dice Yavé, el Dios de Israel: He atendido la oración que me dirigiste acerca de Senaquerib, rey de Asur."
,"21":"Pues bien, esta es la palabra que pronuncia Yavé contra él: La virgen de Sión te desprecia, se burla de ti, la hija de Jerusalén mueve la cabeza al mirarte."
,"22":"¿A quién has insultado con tus blasfemias?,¿Contra quién alzaste la voz y elevaste tu mirada llena de orgullo?,¡Contra el Santo de Israel!"
,"23":"¡Por boca de tus emisarios insultaste al Señor! Dijiste: Con mis numerosos carros ascendí las cumbres de los cerros, las faldas del Líbano. Talé el bosque de cedros y los cipreses más hermosos. Llegué hasta el más lejano de sus refugios y hasta su jardín boscoso."
,"24":"Cavé, y bebí aguas extranjeras, y dejé secos al pasar todos los ríos de Egipto."
,"25":"Hace mucho tiempo que tengo eso preparado, -¿no te lo habían dicho? En el comienzo pensé un proyecto que ahora estoy llevando a cabo. Tú debías convertir en ruinas ciudades fortificadas;"
,"26":"sus habitantes, quedaban sin fuerza, estaban asustados, llenos de miedo; eran como la hierba del campo, como el césped aún verde, como el musgo que crece sobre los techos, como el grano que se pasma antes de ser espiga."
,"27":"Pero yo sé cuando te sientas, cuando sales y cuando entras..."
,"28":"Pues bien, ya que te enojaste conmigo y que ha llegado a mis oídos tu insolencia, voy a poner mi anillo en tus narices, y mi freno en tus labios, y te haré volver por el camino por donde viniste."
,"29":"Aquí tienes una señal para ti, Ezequías: este año comerán los restos de lo que se sembró; el próximo, el grano que brotó solo; pero el tercer año siembren y cosechen, planten parras y coman su fruto."
,"30":"Los del pueblo de Judá que logren salvarse echarán raíces por abajo y darán frutos por arriba,"
,"31":"porque de Jerusalén saldrá un resto y del cerro Sión, sobrevivientes. Eso será obra de Yavé Sabaot y de su celosa preocupación."
,"32":"Por eso, esto dice Yavé respecto al rey de Asur: No entrará en esta ciudad ni le lanzará sus flechas. No la atacará con torres rodantes ni levantará un terraplén,"
,"33":"sino que se volverá por el mismo camino por donde vino. No entrará en esta ciudad. ¡Palabra de Yavé!"
,"34":"Protegeré a esta ciudad y la salvaré, en consideración a mí mismo y mi servidor David'."
,"35":"Esa misma noche salió el ángel de Yavé y dio muerte en el campamento de los asirios a ciento ochenta y cinco mil hombres. ¡A la mañana siguiente, a la hora de levantarse, sólo había cadáveres, estaban todos muertos!"
,"36":"Senaquerib, rey de Asur, se fue y se volvió para quedarse en Nínive."
,"37":"Allí mientras estaba postrado en la casa de su dios Nisroc, sus hijos Adramelec y Sarecer lo mataron a espada y huyeron al territorio de Ararat. En su lugar pasó a ser rey Asaradón, su hijo."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Por ese tiempo, contrajo Ezequías una enfermedad mortal. Fue a verlo el profeta Isaías, hijo de Amós, y le dijo: 'Esto dice Yavé: Arregla las cosas de tu familia porque vas a morir. No te sanarás'."
,"2":"Entonces Ezequías dio vuelta la cara contra la pared e hizo a Yavé esta súplica:"
,"3":"'¡Oh Yavé, te lo suplico, acuérdate como he caminado delante de ti con sinceridad y con un corazón fiel! He hecho lo que es justo a tus ojos'. Y Ezequías lloró y lloró mucho."
,"4":"Todavía no salía Isaías del patio central cuando le fue dirigida la palabra de Yavé:"
,"5":"'Vuelve y di a Ezequías, el jefe de mi pueblo. Esto dice Yavé, el Dios de David, tu padre: Oí tu plegaria y vi tus lágrimas. Voy a sanarte, dentro de tres días subirás a la casa de Yavé."
,"6":"Agregaré quince años a tu vida. Además te libraré a ti y a esta ciudad de manos del rey de Asur, protegeré esta ciudad debido a mí mismo y a mi servidor David'."
,"8":"Ezequías dijo a Isaías: '¿Cómo estaré seguro de que Yavé me sanará y de que en tres días más subiré a la casa de Yavé? Quisiera una prueba de ello'."
,"9":"Isaías le respondió: 'Esta es la prueba que te da Yavé para mostrarte que cumplirá la palabra que dijo: ¿Quieres que la sombra avance diez grados o que retroceda otro tanto? '"
,"10":"Ezequías le dijo: 'No es difícil para la sombra avanzar diez grados, pero es muy distinto que la sombra retroceda diez'."
,"11":"Entonces el profeta Isaías oró a Yavé e hizo que la sombra retrocediera diez grados de los que ya había recorrido en la graduación de Ajaz."
,"7":"Isaías dijo entonces: 'Traigan una torta de higos'. La trajeron y se la pusieron en la úlcera, y el rey sanó."
,"12":"En aquel tiempo Merodoc-Baladán, hijo de Baladán, rey de Babilonia, mandó a Ezequías unas cartas con un regalo; pues se había informado de como se había Ezequías sanado de su enfermedad."
,"13":"Ezequías se sintió tan contento que mostró a los embajadores todos sus tesoros, la plata, el oro, los perfumes, el aceite perfumado, las armas, en una palabra, todo lo que se guardaba en sus almacenes. Ezequías les mostró absolutamente todo lo que había en su palacio y en sus dependencias."
,"14":"Entonces el profeta Isaías fue a ver al rey y le dijo: '¿Qué te dijeron esos hombres? ¿De dónde vinieron a verte?' Ezequías respondió: 'Vienen de un lejano país, de Babilonia'."
,"15":"Isaías le dijo: '¿Qué vieron en tu palacio?' Ezequías le respondió: 'Vieron todo lo que hay en mi palacio. No quedó nada en mis almacenes que no les mostré'."
,"16":"Isaías dijo a Ezequías: 'Escucha esta palabra de Yavé:"
,"17":"Llegará el día en que se llevarán a Babilonia todo lo que hay en tu palacio, todo lo que tus padres juntaron hasta el día de hoy; no quedará nada, dice Yavé."
,"18":"Se apoderarán de tus hijos salidos de ti, los que tú engendraste, y servirán como eunucos en el palacio del rey de Babilonia'."
,"19":"Ezequías respondió a Isaías: '¡Es buena esa palabra de Yavé que acabas de pronunciar!' Pues pensaba: '¡Qué me importa, con tal que durante mi vida haya paz y tranquilidad!'"
,"20":"El resto de los hechos de Ezequías, toda su valentía, la manera como hizo la pileta y el canal para traer el agua a la ciudad, todo eso está escrito en el Libro de las Crónicas de los reyes de Judá."
,"21":"Ezequías se acostó con sus padres y en su lugar reinó su hijo Manasés."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Manasés tenía doce años cuando subió al trono y reinó cincuenta y cinco años en Jerusalén. Su madre se llamaba Hepsiba."
,"2":"Hizo lo que es malo a los ojos de Yavé, siguiendo las prácticas vergonzosas de las naciones a las que Yavé había quitado el país parra dárselo a los israelitas."
,"3":"Reconstruyó los Altos Lugares que su padre Ezequías había hecho desaparecer. Erigió un altar a Baal e hizo un poste sagrado tal como lo había hecho Ajab, rey de Israel; se postró ante todo el ejército de los Cielos y se puso a servirlo."
,"4":"Levantó altares en la casa de Yavé, en ese templo del cual había dicho Yavé: ' Instalaré mi nombre en Jerusalén'."
,"5":"Levantó altares a todo el Ejército de los cielos en los dos patios de la casa de Yavé."
,"6":"Ofreció a su hijo como sacrificio en el fuego, practicó la astrología y la magia, instaló brujos y adivinos, y de muchas maneras provocó la cólera de Yavé haciendo lo que es malo a sus ojos."
,"7":"Colocó la estatua de Asera que había hecho en la Casa de la cual Yavé había dicho a David y a su hijo Salomón: 'En este templo, en esta ciudad de Jerusalén que elegí entre todas las tribus de Israel, instalaré mi Nombre para siempre."
,"8":"Si cumplen todo lo que les mandé, si practican la Ley que les ordenó mi servidor Moisés, haré que no vague más Israel lejos de la tierra que di a sus padres'."
,"9":"Pero no hicieron caso y Manasés los arrastró a hacer cosas peores aún que las hechas por las naciones que había destruido Yavé ante los israelitas."
,"10":"Por eso declaró Yavé por boca de sus servidores los profetas:"
,"11":"'Manasés, rey de Judá, ha hecho cosas vergonzosas. Ha actuado peor aún que los amorreos que vivían antes aquí, y con sus ídolos ha hecho pecar a Judá."
,"12":"Por lo cual, dice Yavé, Dios de Israel, voy a mandar sobre Jerusalén y Judá una desgracia tan grande que le tintinearán las orejas a quienes la oigan."
,"13":"Arrasaré a Jerusalén tal como lo hice con Samaría, la trataré tal como a la casa de Ajab. Limpiaré a Jerusalén tal como se limpia un plato, al que lavan y luego lo ponen boca abajo."
,"14":"Tiraré el resto de los que me pertenecen, los entregaré en manos de sus enemigos y se convertirán en la presa y el botín de todos sus enemigos."
,"15":"Porque desde el día en que sus padres subieron desde Egipto hasta ahora, han hecho lo que es malo a mis ojos; y no han hecho más que enojarme'."
,"16":"Además del pecado que Manasés hizo cometer a Judá, haciendo lo que es malo a los ojos de Yavé, derramó hasta tal punto la sangre inocente que Jerusalén quedó repleta de un extremo al otro."
,"17":"El resto de los hechos de Manasés, todo lo que hizo, el pecado que cometió, todo eso está escrito en el Libro de las Crónicas de los reyes de Judá."
,"18":"Manasés se acostó con sus padres y lo enterraron en el jardín de su casa, en el jardín de Uzza. En su lugar reinó Amón su hijo."
,"19":"Amón tenía veintidós años cuando subió al trono, y reinó dos años en Jerusalén; su madre era Mesulemet, hija de Jarús, de la ciudad de Yotbá."
,"20":"Hizo lo que es malo a los ojos de Yavé, tal como su padre Manasés."
,"21":"Siguió en todo los pasos de su padre, sirvió a las basuras a las que había servido su padre y se postró ante ellas."
,"22":"Abandonó a Yavé, el Dios de sus padres, en vez de seguir por sus caminos."
,"23":"Los servidores de Amón conspiraron contra él y asesinaron al rey en su palacio."
,"24":"Pero los ciudadanos dieron muerte a todos los que habían conspirado contra el rey Amón; y en su lugar pusieron como rey a Josías, su hijo."
,"25":"El resto de los hechos de Amón, lo que hizo, todo eso está escrito en el Libro de las Crónicas de los reyes de Judá."
,"26":"Lo enterraron en la tumba de su padre, en el jardín de Uzza, y en su lugar reinó su hijo Josías."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Josías tenía ocho años cuando subió al trono y reinó treinta y un años en Jerusalén."
,"2":"Hizo lo que es justo a los ojos de Yavé y caminó tras las huellas de su antepasado David, no apartándose ni a derecha ni a izquierda."
,"3":"El año décimo octavo del rey Josías, el rey mandó a la casa de Yavé al secretario Safán, hijo de Asalías, hijo de Mesulam."
,"4":"Le dijo: 'Anda a ver al sumo sacerdote Helquías. Que cuente exactamente el dinero que ha sido depositado en la casa de Yavé y que los guardias de la puerta han recibido del pueblo."
,"5":"Que se lo pase a los que dirigen los trabajos, a los que tienen a su cargo la casa de Yavé. Estos, a su vez, se lo darán a los obreros que ejecutan las obras en la casa de Yavé y que hacen las reparaciones de la Casa,"
,"6":"a los carpinteros, a los obreros de la construcción y a los albañiles, y con él se comprará también la madera y las piedras talladas para reparar la Casa."
,"7":"Pero no se les pida cuentas del dinero que se les entregue porque son gente honrada'."
,"8":"El sumo sacerdote Helquías dijo entonces al secretario Safán: 'En la casa de Yavé encontré el Libro de la Ley'. Después se lo pasó a Safán quien lo leyó."
,"9":"El secretario Safán fue luego a ver al rey y le entregó un informe, diciéndole: 'Tus servidores reunieron el dinero que estaba en la Casa y se lo entregaron a los obreros encargados de la casa de Yavé'."
,"10":"En seguida el secretario Safán comunicó la noticia al rey: 'El sacerdote Helquías, le dijo, me pasó un libro'. Y Safán lo leyó en presencia del rey."
,"11":"Cuando el rey oyó las palabras del libro, rasgó su ropa."
,"12":"El rey dio esta orden al sacerdote Helquías, a Ajicam hijo de Safán, a Acbor hijo de Micaías, al secretario Safán y a su ministro Asaías: 'Vayan a consultar a Yavé por mí, por el pueblo y por todo Judá respecto a las palabras de este libro que se acaba de encontrar. Yavé debe estar listo para descargar sobre nosotros toda su cólera porque nuestros padres desobedecieron las palabras de ese libro y no pusieron en práctica todo lo que allí está escrito'."
,"14":"Entonces el sacerdote Helquías, Ajicam, Acbor, Safán y Asaías fueron donde la profetisa Julda, que era esposa de Salum, hijo de Ticva, hijo de Jarjas, el custodio de la ropería, y que vivía en el barrio nuevo de Jerusalén. Cuando la pusieron al tanto de lo sucedido,"
,"15":"les respondió: 'Esto dice Yavé, Dios de Israel: Transmítan al hombre que los mandó donde mí"
,"16":"esta palabra de Yavé: 'Haré que caigan sobre este lugar y sobre sus habitantes todas las desgracias anunciadas en el libro que leyó el rey de Judá."
,"17":"Porque me abandonaron y ofrecieron incienso a otros dioses. Provocaron mi cólera con su conducta, por eso mi cólera en contra de este lugar será como un fuego que no se apaga."
,"18":"Y al rey de Judá que los mandó a consultar a Yavé, le repetirán esta palabra de Yavé, Dios de Israel:"
,"19":"Tu corazón se ha conmovido y te has humillado delante de Yavé al oír lo que se dice en contra de este lugar y de sus habitantes, cuya suerte será espantosa, como una verdadera maldición. Rasgaste tu ropa y lloraste delante de mí y yo te he atendido -¡oráculo de Yavé!"
,"20":"Por eso te reuniré con tus padres y te haré descender en paz a la tumba, para que no veas todas las desgracias que acarrearé sobre este lugar'. Le llevaron al rey esa respuesta."
}`)
	CurrentBook.AddChapter(23, `{
"1":"El rey cursó una invitación, y todos los ancianos de Judá y de Jerusalén se congregaron junto a él."
,"2":"Subió a la casa de Yavé acompañado de todos los hombres de Judá, de todos los habitantes de Jerusalén, de los sacerdotes y de los profetas, de todo el pueblo desde el más chico hasta el más grande. Delante de ellos leyó todas las palabras del Libro de la Alianza que había sido encontrado en la casa de Yavé."
,"3":"El rey estaba de pie en el estrado, y en presencia de Yavé, renovó la alianza: Se comprometió a seguir a Yavé, a observar sus mandamientos, sus órdenes y sus preceptos, con todo su corazón y con toda su alma. Se comprometió a respetar las palabras de esa alianza tales como estaban escritas en ese libro, e hizo que todo el pueblo se comprometiera con la Alianza."
,"4":"El rey ordenó al sumo sacerdote Helquías, al sacerdote que lo seguía en jerarquía y a los guardias de la puerta que echaran fuera de la casa de Yavé todos los objetos que habían sido hechos para Baal, para Asera y para todo el ejército de los cielos. Mandó quemarlos fuera de Jerusalén en una hogueraa en el Cedrón y las cenizas las llevaron a Betel."
,"5":"Acabó con los falsos sacerdotes que habían instaurado los reyes de Judá y que ofrecían incienso en los Altos Lugares, en las ciudades de Judá y en los alrededores de Jerusalén. También acabó con los que ofrecían incienso a los Baales, al sol, a la luna, a las estrellas y a todo el ejército de los cielos."
,"6":"Sacó de la casa de Yavé la Asera, la botó fuera de Jerusalén en el valle del Cedrón, y allí la mandó quemar y reducirla a cenizas, después tiró sus cenizas a la fosa común."
,"7":"Demolió las casas de los homosexuales sagrados que había en la casa de Yavé, y en donde las mujeres tejían velos para la Asera."
,"8":"Llamó a todos los sacerdotes de las ciudades de Judá; profanó los Altos Lugares donde esos sacerdotes ofrecían incienso, desde Guebá hasta Berseba. Demolió el Alto Lugar de las puertas, que estaba a la entrada de la Puerta de Josué, gobernador de la ciudad, a la izquierda de la entrada a la ciudad."
,"9":"Esos sacerdotes de los Altos Lugares no tuvieron acceso al altar de Yavé en Jerusalén, conformándose con comer panes sin levadura en medio de sus hermanos."
,"10":"Josías destruyó el fogón del valle de Ben-Hinón, para que nadie más pudiese sacrificar en el fuego a su hijo o a su hija en honor a Molec."
,"11":"Eliminó los caballos que los reyes de Judá habían consagrado al sol, y que estaban a la entrada de la casa de Yavé, cerca de la habitación del eunuco Netán-Melec, (la que estaba dentro de las dependencias) y echó al fuego el carro del sol."
,"12":"El rey derribó también y redujo a polvo los altares que habían sido instalado por los reyes de Judá en la terraza del segundo piso de Ajaz, y los altares que había puesto Manasés en los dos patios de la casa de Yavé. Tiró el polvo al torrente del Cedrón."
,"13":"El rey destruyó también los Altos Lugares que había frente a Jerusalén, al sur del cerro de los Olivos. Estos habían sido construidos por Salomón, rey de Israel en honor de Astarté, la inmundicia de los sidonios, de Quemós, la inmundicia de los moabitas, y de Milcom, la vergüenza de los amoneos."
,"14":"También rompió las piedras paradas, hizo cortar los postes sagrados y rellenó el lugar con huesos humanos."
,"15":"Demolió el altar que había en Betel, el Alto Lugar construido por Jeroboam, hijo de Nabat, quien había arrastrado a Israel en su pecado. Demolió ese Alto Lugar, partió las piedras y las redujo a polvo, después de lo cual quemó el poste sagrado."
,"16":"Al darse vuelta Josías vio tumbas cavadas en los cerros. Mandó buscar los huesos de esas tumbas y los quemó en el altar para profanarlo; así se cumplió la palabra de Yavé que un hombre de Dios había proclamado un día de fiesta, cuando Jeroboam ofrecía sacrificios en el altar. Al mirar de nuevo se fijó Josías en la tumba del hombre de Dios que había proclamado esas palabras."
,"17":"Preguntó entonces: '¿A quién pertenece ese mausoleo que veo allá abajo?' La gente de la ciudad respondió: 'Es la tumba del hombre de Dios que vino de Judá para anunciar lo que acabas de hacer con el altar de Betel'."
,"18":"El rey les dijo: '¡Déjenlo, que nadie toque sus huesos!' Se respetaron pues sus huesos como también los del profeta que habían venido de Samaría."
,"19":"Josías hizo desaparecer todas las casas de los Altos Lugares que los reyes de Israel habían instalado en las ciudades de Samaría y que habían provocado la cólera de Yavé. Las trató igual como lo hizo con Betel."
,"20":"Mandó a ejecutar en sus altares a todos los sacerdotes de los Altos Lugares que estaban allí; mandó quemar allí huesos humanos y después regresó a Jerusalén."
,"21":"El rey ordenó a todo el pueblo: 'Celebren la Pascua en honor de Yavé su Dios, de acuerdo a lo que está escrito en el libro de la Alianza'."
,"22":"No se había celebrado nunca una Pascua como ésa, desde la época de los jueces, durante todo el tiempo de los reyes de Judá y de Israel."
,"23":"Hubo que esperar el año décimo octavo del rey Josías para que se celebrara en Jerusalén una Pascua como ésa."
,"24":"Josías barrió con los hechiceros y los adivinos, los ídolos y las basuras, en una palabra, con todos los horrores que se veían en el territorio de Judá y en Jerusalén. De esa manera puso en práctica las palabras de la Ley que estaban escritas en el libro que había encontrado el sacerdote Helquías en la casa de Yavé."
,"25":"Ningún rey antes que él se había vuelto hacia Yavé con todo su corazón, con toda su alma, con todas sus fuerzas, estando totalmente de acuerdo con la Ley de Moisés, como lo hizo él, y como él no surgió ningún rey posterior."
,"26":"A pesar de eso no se le pasó a Yavé su gran enojo contra Judá a causa de todas las acciones de Manasés que lo habían escandalizado."
,"27":"Por eso Yavé declaró: 'También echaré lejos de mí a Judá, tal como lo hice con Israel. Ya no tomaré en consideración a Jerusalén, esa ciudad que había elegido, ni a la Casa de la que había dicho: allí estará mi Nombre'."
,"28":"El resto de los hechos de Josías, todo lo que hizo, está escrito en el Libro de las Crónicas de los reyes de Judá."
,"29":"En ese tiempo, el faraón Necao, rey de Egipto, llevó a cabo una expedición hasta el Eufrates para combatir con el rey de Asur. El rey Josías salió a enfrentarlo, pero Necao dio orden de matarlo en cuanto lo vio."
,"30":"Sus servidores trajeron su cuerpo en carro desde Meguido y lo llevaron a Jerusalén donde lo sepultaron en su tumba; luego el pueblo eligió a Yoacaz, hijo de Josías, lo consagraron y lo instalaron como rey en lugar de su padre."
,"31":"Yoacaz tenía veintitrés años cuando subió al trono y reinó tres meses en Jerusalén. Su madre era Jamutal, hija de Jeremías, de Libna."
,"32":"Hizo lo que es malo a los ojos de Yavé, tal como lo habían hecho sus antepasados."
,"33":"En Ribla, en el territorio de Jamat, el faraón Necao lo mandó encadenar, poniendo fin a su reinado en Jerusalén; después impuso al país un tributo de cien talentos de plata y diez talentos de oro."
,"34":"El faraón Necao instaló como rey a Eliaquim, hijo de Josías, en lugar de su padre Josías y le cambió el nombre por el de Joaquim. Después de eso se llevó a Yoacaz a Egipto donde murió."
,"35":"Joaquim entregó al faraón el oro y la plata, pero para entregar al faraón la suma exigida tuvo que gravar al país con impuestos. Le descontó a cada cual, de acuerdo a su fortuna, la plata y el oro que debía al faraón Necao."
,"36":"Joaquim tenía veinticinco años cuando subió al trono y reinó once años en Jerusalén; su madre era Zebida, hija de Pedraías, de Ruma."
,"37":"Hizo lo que es malo a los ojos de Yavé, tal como lo habían hecho sus antepasados."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Por ese entonces, Nabucodonosor rey de Babilonia invadió el país, y durante tres años Joaquim estuvo sometido a aquél, pero luego se rebeló."
,"2":"Yavé envió contra Joaquim a bandas de caldeos, de arameos, de moabitas y de amoneos, las mandó contra Judá para hacerlo desaparecer, según la palabra que había dicho Yavé por boca de sus servidores los profetas."
,"3":"Todo eso pasó por orden de Yavé. El quería apartar a Judá lejos de sí a causa de los pecados de Manasés,"
,"4":"pero también a causa de la sangre inocente derramada de tal forma en Jerusalén que ésta se había repletado de ella. Yavé ya no quería perdonar."
,"5":"El resto de los hechos de Joaquim, todo lo que hizo, está escrito en el Libro de las Crónicas de los reyes de Judá."
,"6":"Joaquim se acostó con sus padres, y en su lugar reinó Joaquín, su hijo."
,"7":"El rey de Egipto no salió más fuera de sus fronteras porque el rey de Babilonia se había apoderado de todo lo que pertenecía al rey de Egipto, desde el torrente de Egipto hasta el río Eufrates."
,"8":"Joaquín tenía dieciocho años cuando subió al trono y reinó tres meses en Jerusalén; su madre era Nejusta, hija de Elnatán de Jerusalén."
,"9":"Hizo lo que es malo a los ojos de Yavé tal como su padre."
,"10":"En ese tiempo, los hombres de Nabucodonosor, rey de Babilonia, marcharon contra Jerusalén y sitiaron la ciudad."
,"11":"Nabucodonosor rey de Babilonia, llegó para atacar la ciudad mientras sus hombres la sitiaban."
,"12":"Joaquín, rey de Judá, salió para rendirse al rey de Babilonia junto con su madre, sus servidores, sus jefes y sus eunucos; el rey de Babilonia lo tomó prisionero el año ocho de su reinado."
,"13":"Sacó todos los tesoros de la casa de Yavé y los tesoros del palacio real. Rompió todos los objetos de oro que Salomón, rey de Israel, había hecho para la casa de Yavé, tal como Yavé lo había predicho."
,"14":"Desterró a todo Jerusalén, a todos los jefes y a todos los militares; en total, diez mil desterrados contando a todos los herreros y cerrajeros; del pueblo sólo dejó a la gente humilde."
,"15":"Desterró a Joaquín a Babilonia; mandó desterrados a Babilonia a la madre del rey, a sus mujeres, a sus eunucos y a las personas importantes del país."
,"16":"El rey de Babilonia mandó desterrados a Babilonia a siete mil hombres que servían: mil herreros y cerrajeros y todos los hombres que podían portar armas."
,"17":"El rey de Babilonia puso como rey en lugar de Joaquín a su tío Matanía, al que cambió el nombre por el de Sedecías."
,"18":"Sedecías tenía veintiún años cuando subió al trono y reinó once años en Jerusalén; su madre era Jamital, hija de Jeremías, de Libna."
,"19":"Hizo lo que es malo a los ojos de Yavé tal como lo había hecho Joaquim."
,"20":"Entonces la cólera de Yavé dirigió los acontecimientos para que al final echara lejos de sí a Jerusalén y a Judá: Sedecías se rebeló contra el rey de Babilonia."
}`)
	CurrentBook.AddChapter(25, `{
"1":"El noveno año del reinado de Sedecías, el décimo día del décimo mes, Nabucodonosor, rey de Babilonia, llegó a Jerusalén con todo su ejército. Acamparon frente a la ciudad y cavaron trincheras en todo su derredor;"
,"2":"estuvo sitiada hasta el undécimo año de Sedecías."
,"3":"El nueve del cuarto mes, era tal el hambre en la ciudad que ya no había más pan para la población."
,"4":"Abrieron entonces un boquete en el muro y, de noche, huyeron todos los soldados por la Puerta-entre-las dos-murallas que da al jardín del rey, y tomaron el camino del desierto."
,"5":"El ejército de los caldeos se lanzó en persecución del rey; lo alcanzaron en la llanura de Jericó y toda su tropa se dispersó."
,"6":"Apresaron al rey y lo llevaron a Ribla donde el rey de Babilonia, quien lo sometió a juicio."
,"7":"El rey de Babilonia mandó degollar a los hijos de Sedecías ante sus propios ojos, luego le sacó los ojos y lo llevó encadenado a Babilonia con una doble cadena de bronce."
,"8":"El siete del quinto mes, Nebuzaradán, jefe de los guardias y oficial del rey de Babilonia, entró a Jerusalén- era el décimo noveno año de Nabucodonosor, rey de Babilonia."
,"9":"Quemó la casa de Yavé, el palacio real y todas las casas de Jerusalén."
,"10":"Las tropas caldeas que acompañaban al jefe de los guardias demolieron la muralla que rodeaba a Jerusalén."
,"11":"Nebuzaradán, jefe de los guardias, desterró al resto de la población: a los que habían quedado en la ciudad, a los que habían desertado para pasarse al lado del rey de Babilonia y al resto de los artesanos."
,"12":"El jefe de los guardias sólo dejó a la gente humilde del país para que trabajaran como viñateros y labradores."
,"13":"Los caldeos rompieron las columnas de bronce de la casa de Yavé, las bases y el Mar de bronce que había en la casa de Yavé y se llevaron todo ese bronce a Babilonia."
,"14":"También se llevaron los calderos, las paletas, los cuchillos, las copas y todos los objetos de bronce que se usaban para el culto."
,"15":"El jefe de los guardias se apoderó también de los incensarios y de las vasijas, de todo lo que era de oro y plata."
,"16":"Las dos columnas, el Mar de bronce y sus bases que había hecho Salomón para la casa de Yavé, todo eso equivalía a una cantidad incalculable de bronce."
,"17":"Pues, la altura de cada columna era de cinco metros, encima de ella iba puesto un capitel de bronce, cuya altura era de un metro y medio. Además estaban la red y las granadas que rodeaban al capitel, que eran también de bronce; ambas columnas eran iguales."
,"18":"El jefe de los guardias tomó preso a Seraías, el primero de los sacerdotes, a Sefanías, su segundo y a los tres guardias de las puertas."
,"19":"También tomó presos a un eunuco de la ciudad que estaba encargado de la gente del ejército, a cinco hombres del servicio privado del rey que estaban en la ciudad, al secretario del jefe del ejército, encargado del reclutamiento de los ciudadanos, y a sesenta ciudadanos más que estaban entonces en la ciudad."
,"20":"Nebuzaradán, jefe de los guardias, los arrestó y los mandó a Ribla donde el rey de Babilonia."
,"21":"El rey de Babilonia los condenó a muerte en Ribla, en el territorio de Jamat. De ese modo fue desterrado Judá lejos de su tierra."
,"22":"Nabucodonosor, rey de Babilonia, había dejado a una parte de la población de Judá en el país; puso como gobernador a Godolías, hijo de Ajiam, hijo de Safán."
,"23":"Cuando los jefes del ejército y sus hombres supieron que el rey de Babilonia había puesto como gobernador a Godolías, fueron a Mispá a verlo; eran Ismael, hijo de Netanías, Yojanán, hijo de Careaj, Seraías, hijo de Tanjumet que era de Netofa y Jazanías del territorio de Maacá. Fueron donde él junto con sus tropas."
,"24":"Godolías les declaró con juramento a ellos y a sus hombres: 'No tengan miedo de los caldeos, quédense en el país, sirvan al rey de Babilonia y no les pasará nada'."
,"25":"Pero al séptimo mes, Ismael hijo de Netanías, hijo de Elisama, que pertenecía a la familia real, llegó con diez de sus hombres y dio muerte a Godolías y a los judíos y caldeos que estaban con él en Mispá."
,"26":"Entonces todo el pueblo, desde el más chico hasta el más grande, huyeron a Egipto junto con los jefes del ejército por miedo a los caldeos."
,"27":"El trigésimo séptimo año de la deportación de Joaquín, rey de Judá, el duódecimo mes, el día veintisiete del mes, Evil- Merodoc, rey de Babilonia, indultó a Joaquín, rey de Judá, y lo sacó de la prisión. Evil-Merodoc, que había subido al trono ese año,"
,"28":"trabó amistad con Joaquín y puso el trono de éste encima de los tronos de los otros reyes deportados igual que él a Babilonia."
,"29":"Le quitó sus ropas de prisionero, y en adelante, hasta el fin de la vida de Joaquín, comió éste en la mesa del rey. Su manutención fue asegurada constantemente por el rey de Babilonia, día tras día, hasta el fin de su vida."
}`)

}
func ES_LBL_LoadVH2SChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"La muerte de Saúl aconteció poco después que David hubo aplastado a los amalecitas: hacía ya dos días que había regresado a Siclag."
,"2":"Al tercer día llegó un hombre del campamento de Saúl: tenía la ropa hecha tiras y tierra en la cabeza. Apenas llegó donde David, se tiró al suelo y se postró."
,"3":"David le dijo: '¿De dónde vienes?' Respondió: 'Fui uno de los que se salvaron del campamento de Israel'."
,"4":"David le dijo: '¿Cómo pasaron allá las cosas? Dímelo pues'. Ese hombre respondió: 'El pueblo huyó del campo de batalla, muchos del pueblo cayeron, y también murieron Saúl y su hijo Jonatán'."
,"5":"David dijo al joven que le traía esa noticia: '¿Cómo sabes que murieron Saúl y su hijo Jonatán?'"
,"6":"Respondió: 'Me encontraba por casualidad en los cerros de Guelboé. Saúl estaba apoyado en su lanza, los carros y los jinetes lo tenían cercado."
,"7":"Entonces él me vio, se dio vuelta y me llamó. Le dije: 'Aquí me tienes."
,"8":"Me dijo: ¿Quién eres tú? Le dije: Soy un amalecita."
,"9":"Me dijo: Acércate y dame muerte, todavía me quedan fuerzas pero siento que me voy a desmayar."
,"10":"Entonces me acerqué y lo maté porque bien sabía que no sobreviviría una vez que cayera al suelo; luego tomé la corona que tenía en la cabeza, la pulsera que llevaba en el brazo y se los traje a usted, señor'."
,"11":"David rasgó su ropa, y todos los que estaban con él hicieron lo mismo."
,"12":"Se lamentaron mucho, lloraron y ayunaron hasta el atardecer por Saúl y su hijo Jonatán, por el pueblo de Yavé y por la casa de Israel que habían perecido a espada."
,"13":"Después le dijo David al joven que le había llevado la noticia: '¿De dónde eres?' Respondió: 'Soy extranjero en este país, soy hijo de un amalecita'."
,"14":"David le dijo: '¿Cómo te atreviste a matar al ungido de Yavé?'"
,"15":"Llamó David a uno de sus compañeros y le dijo: 'Anda y mátalo'. Le dio un golpe y murió."
,"16":"David dijo entonces: 'Recaiga tu sangre sobre tu cabeza. Tú mismo te condenaste cuando dijiste que habías herido de muerta al ungido de Yavé'."
,"17":"Luego entonó David una lamentación por Saúl y su hijo Jonatán,"
,"18":"y ordenó que se la aprendieran los hijos de Judá; es el canto del arco que se puede leer en el Libro del Justo."
,"19":"¡Ay, la gloria de Israel pereció en los montes!,¿Cómo cayeron esos héroes?"
,"20":"¡No lo anuncien en Gat, ni cuenten la noticia por las calles de Asquelón; no den esa alegría a las mujeres filisteas, a las hijas de los incircuncisos!"
,"21":"Que nunca más caiga sobre ustedes ni rocío ni lluvia, montañas de Guelboé, campos verdes: porque allí fue profanado el escudo de los héroes. El escudo de Saúl no necesitaba aceite"
,"22":"sino sangre de heridos y grasa de héroes. Ni el arco de Jonatán retrocedía, ni en el vacío hería la espada de Saúl."
,"23":"Amados, deseados eran Saúl y Jonatán: ni la vida ni la muerte pudieron separarlos. Más rápidos eran que las águilas, tenían más fuerza que los leones."
,"24":"¡Lloren por Saúl, hijas de Israel!,Las vestía con ropas de colores, joyas de oro ponía en sus trajes de fiesta."
,"25":"¿Cómo? ¿Han muerto esos héroes?,¿Quién hirió de muerte a Jonatán en el combate?"
,"26":"¡Jonatán, hermano mío, por ti tengo partido el corazón, pues te quería tanto! Tu amor era para mí,más maravilloso que el amor de las mujeres."
,"27":"¿Cómo? ¿Han muerto esos héroes?,¿Cómo fueron rotas sus armas?"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Después de eso David consultó a Yavé: '¿Debo subir a una de las ciudades de Judá?' Yavé le respondió: 'Sube'. David añadió: 'A cuál?' Y Yavé respondió: 'A Hebrón'."
,"2":"Subió pues David con sus dos mujeres, Ajinoam de Yizreel y Abigaíl, mujer de Nabal de Carmel."
,"3":"Con él subieron sus hombres, cada cual con su familia, y se instalaron en las aldeas de Hebrón."
,"4":"Entonces se reunieron los hombres de Judá y allí consagraron a David como rey de la casa de Judá. Le informaron a David que la gente de Yabés de Galaad había enterrado a Saúl. "
,"5":"David mandó entonces a sus hombres donde la gente de Yabés de Galaad con este mensaje: 'Que Yavé los bendiga por haber enterrado a Saúl, su señor, pues se lo debían."
,"6":"Que Yavé les muestre su bondad y su fidelidad; por mi parte también los recompensaré por esa hermosa acción."
,"7":"Y ahora sigan valientes y animosos. Aunque Saúl ha muerto, los hombres de la casa de Judá me han consagrado como su rey'."
,"8":"Abner, hijo de Ner, era el jefe del ejército de Saúl. Tomó a Isbaal, hijo de Saúl y se lo llevó a Majanayim."
,"9":"Allí lo proclamó rey de Galaad, de la tribu de Aser, de Yizreel, de Efraín y Benjamín; en una palabra, de todo Israel."
,"10":"Isbaal, hijo de Saúl, tenía cuarenta años cuando pasó a ser rey de Israel y reinó dos años, mientras que la casa de Judá seguía a David."
,"11":"David reinó en Hebrón siete años y seis meses sobre la casa de Judá."
,"12":"Abner, hijo de Ner, y la guardia de Isbaal, hijo de Saúl, dejaron Majanayim para dirigirse a Gabaón."
,"13":"Joab, hijo de Seruya, y la guardia de David marcharon también hacia allá, y ambas tropas se encontraron cerca de la laguna de Gabaón. Los primeros se estacionaron a un lado de la laguna, y los segundos, al otro lado."
,"14":"Abner dijo a Joab: 'Que salgan los jóvenes a pelear ante nosotros'. Joab respondió: 'De acuerdo, que salgan'."
,"15":"Se pararon y los contaron: había doce de la tribu de Benjamín por Isbaal, hijo de Saúl, y doce de la guardia de David."
,"16":"Cada uno tomó a su adversario por los cabellos y le hundió la espada en el costado, de tal modo que cayeron todos juntos. A ese lugar lo llamaron el Campo de los costados, y se ubica al lado de Gabaón."
,"17":"Hubo allí ese día una dura batalla; Abner y la gente de Israel fueron derrotados por la guardia de David."
,"18":"Allí estaban los tres hijos de Seruya, Joab, Abisaí y Azael. Azael, que corría tan rápido como una gacela salvaje,"
,"19":"se lanzó en persecución de Abner sin desviarse ni a la derecha ni a la izquierda."
,"20":"Abner se dio vuelta y le dijo: '¿Eres tú Azael?' Respondió: 'Sí, yo soy'."
,"21":"Abner le dijo entonces: 'Apártate a la derecha o a la izquierda y lánzate sobre uno de esos jóvenes si es que quieres apoderarte de su equipo'. Pero Azael no quiso apartarse de él."
,"22":"Abner le repitió a Azael: 'Apártate de mí, si no te dejaré tirado en el suelo; pero, ¿cómo podría después hablar a tu hermano?'"
,"23":"Como no quisiera apartarse de él, Abner le clavó en el estómago la punta de su lanza y la lanza le salió por la espalda. Cayó allí mismo y murió. Todos se detenían a medida que iban llegando al lugar donde Azael había caído herido de muerte."
,"24":"Joab y Abisaí se lanzaron en persecución de Abner, y cuando el sol ya se ponía, llegaron a la colina de Amma, al este de Guiaj por el camino del desierto de Gabaón."
,"25":"La gente de Benjamín se agrupó entonces detrás de Abner en una formación cerrada, y se instalaron en la cumbre de una colina."
,"26":"Abner gritó a Joab: '¿Seguirá devorando la espada? ¿No sabes que esto acabará en lágrimas? ¿Qué esperas para ordenar a tus hombres que dejen de perseguir a sus hermanos?'"
,"27":"Joab respondió: 'Tan cierto como que Yavé vive que si tú no hubieras hablado, esta gente habría seguido persiguiendo a sus hermanos hasta la madrugada'."
,"28":"Entonces Joab tocó el cuerno y se detuvo todo el ejército, y así dejaron de perseguir a Israel y terminó la batalla."
,"29":"Abner y sus hombres caminaron toda la noche por la Arabá, cruzaron el Jordán y después de haber caminado además toda la mañana, llegaron a Majanayim."
,"30":"Joab, por su parte, reunió a sus tropas después de haber puesto fin a la persecución de Abner; la guardia de David había perdido a diecinueve de sus hombres además de Azael,"
,"31":"pero había dado muerte a trescientos sesenta hombres de Benjamín, en el ejército de Abner."
,"32":"Se llevaron a Azael y lo enterraron en la tumba de su padre en Belén. Joab y sus hombres caminaron toda la noche y llegaron a Hebrón al despuntar el día."
}`)
	CurrentBook.AddChapter(3, `{
"1":"La guerra entre la casa de Saúl y la de David se prolongó. David se iba imponiendo cada vez más, mientras que el partido de Saúl se desmoronaba."
,"2":"David tuvo hijos en Hebrón: el mayor fue Amnón, nacido de Ajinoam de Yizreel,"
,"3":"el segundo fue Quileab, nacido de Abigaíl, mujer de Nabal de Carmel; el tercero, Absalón, hijo de Maaca, que era hija de Talmai, rey de Guesur;"
,"4":"el cuarto fue Adonías, nacido de Jagit; el quinto, Sefatías, nacido de Abital,"
,"5":"el sexto, Yitream nacido de Egla, mujer de David. Todos esos hijos de David nacieron en Hebrón."
,"6":"Durante la guerra entre la casa de Saúl y la casa de David, Abner fue haciéndose cada vez más importante en la casa de Saúl."
,"7":"Saúl tenía una concubina llamada Rispá, hija de Ayía, la que Abner tomó para sí. Isbaal dijo a Abner: '¿Por qué tomaste la concubina de mi padre?'"
,"8":"Ante esas palabras Abner se enojó violentamente con Isbaal: '¿Así que yo soy una cabeza de perro? He tenido todas las atenciones con la casa de Saúl tu padre, con sus hermanos y sus amigos, no he dejado que caigas en manos de David, ¿y ahora me haces toda una escena por una historia de mujer?"
,"9":"Maldígame Dios una y otra vez si no ayudo desde ahora a David para que se cumpla lo que Yavé ha dicho,"
,"10":"que quitaría la realeza a la casa de Saúl y haría a David rey de Israel y de Judá, desde Dan a Bersabé."
,"11":"Isbaal no se atrevió a contestarle una palabra a Abner porque le tenía miedo."
,"12":"Abner mandó mensajeros a David: 'Haz un pacto conmigo y yo te ayudaré a reunir alrededor tuyo a todo Israel'."
,"13":"David le respondió: 'De acuerdo, haré un pacto contigo, pero con una condición: Cuando vengas, tráeme a Mical, la hija de Saúl; si no, nada sacarás con presentarte ante mí'."
,"14":"David mandó mensajeros a Isbaal, hijo de Saúl: 'Devuélveme a Mical mi mujer, la que me dieron a cambio de cien prepucios de filisteos'."
,"15":"Isbaal mandó entonces que la fueran a sacar de la casa de su último marido Paltiel, hijo de Layis."
,"16":"Su marido salió detrás de ella y la acompañó llorando hasta Bajurim. Allí le dijo Abner: 'Vuélvete a tu casa'. Y se volvió."
,"17":"Abner sostuvo conversaciones con los ancianos de Israel; les dijo: 'Hace tiempo que desean tener a David por rey."
,"18":"Pasen ahora a las acciones, porque Yavé habló a David en estos términos: Por la mano de mi servidor David salvaré a mi pueblo de Israel de las manos de los filisteos y de todos sus enemigos'."
,"19":"Así habló Abner a los hombres de Benjamín, y luego fue a Hebrón a transmitir a David todo lo que habían decidido la gente de Israel y de Benjamín."
,"20":"Abner fue con veinte hombres a Hebrón a visitar a David, y éste dio un banquete a Abner y a los hombres que lo acompañaban."
,"21":"Abner dijo entonces a David: 'Ojalá pueda reunir alrededor de mi señor el rey a todo Israel; harán una alianza contigo, y tú reinarás sobre todo lo que pudieras desear'. Luego David se despidió de Abner, que se fue en paz."
,"22":"Sucedió que Joab y la guardia de David regresaban de una incursión, en la que habían reunido un enorme botín. Abner, por su parte, había dejado a David en Hebrón; David lo había despedido y se volvía tranquilamente."
,"23":"Cuando llegaron Joab y su tropa, le comunicaron a Joab que Abner, hijo de Ner, había estado en casa del rey y que éste se había despedido de aquél amigablemente."
,"24":"Entonces Joab entró en la casa del rey y le dijo: '¿Qué hiciste? ¿Así que Abner vino a tu casa y dejaste que se fuera?"
,"25":"Conoces bien a Abner, hijo de Ner; vino sólo para engañarte, para saber lo que haces y sientes, y averiguar tus planes'."
,"26":"Apenas salió de la casa de David, y sin decirle nada a éste, Joab mandó unos mensajeros a la cisterna de Sirá para que volviera Abner."
,"27":"Cuando Abner llegó a Hebrón, Joab lo llevó detrás de la puerta so pretexto de conversar privadamente con él, y allí lo hirió en el estómago para vengar la sangre de su hermano Azael. Abner murió."
,"28":"David sólo supo después lo sucedido. Exclamó: 'Yo y mi reino seremos para siempre inocentes ante Yavé de la sangre de Abner, hijo de Ner."
,"29":"Caiga esa sangre sobre la cabeza de Joab y sobre toda la casa de su padre. ¡Que haya siempre en la casa de Joab enfermos de algún flujo o de lepra, hombres que sean buenos para trabajar con el huso, víctimas de la espada, y gente que carezca de pan!'"
,"30":"De este modo Joab y su hermano Abisaí dieron muerte a Abner por causa de su hermano Azael, al que Abner había dado muerte en la batalla de Gabaón."
,"31":"David dijo después a Joab y a toda la gente que estaba a su alrededor: 'Rasguen sus ropas, pónganse sacos en su cintura y hagan duelo por Abner'. El rey David iba detrás del cadáver."
,"32":"Durante el entierro en Hebrón, el rey habló en alta voz y lloró ante la tumba; todo el pueblo lloró con él."
,"33":"El rey entonó entonces esta lamentación por Abner: '¿Por qué tenía que morir Abner,como un hombre cualquiera?"
,"34":"Tus manos no estaban atadas, tus pies no estaban apretados,por cadenas de bronce, pero caíste como cae uno,en manos de criminales'. Todo el pueblo se puso a llorar."
,"35":"Todos insistían a David para que comiera algo mientras era de día, pero David hizo este juramento: 'Que Dios me maldiga y remaldiga si pruebo pan o alguna otra cosa antes de la puesta del sol'."
,"36":"La gente del pueblo quedó muy impresionada y encontraron que eso estaba bien; además encontraban que todo lo que hacía el rey estaba muy bien."
,"37":"Todo el pueblo y todo Israel comprendieron que el rey nada había tenido que ver con el asesinato de Abner, hijo de Ner."
,"38":"El rey dijo a sus servidores: '¿No saben acaso que un jefe, un gran jefe ha caído hoy en Israel?"
,"39":"Yo, por ahora, a pesar de que he recibido la consagración real, puedo hacer bien poca cosa; esos hombres, los hijos de Seruya, son más duros que yo. ¡Que Yavé haga pagar el mal al que lo hizo!'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Cuando el hijo de Saúl supo que Abner había sido asesinado en Hebrón, se le cayeron los brazos y todo Israel se estremeció."
,"2":"El hijo de Saúl tenía dos jefes de banda, dos hijos de Rimón de Beerot, uno se llamaba Baana y el otro, Recab. (Eran de la tribu de Benjamín porque Beerot formaba parte del territorio de Benjamín."
,"3":"La gente de Beerot se había refugiado en Gitayim, y han permanecido allí hasta ese día)."
,"4":"Había también allí un hijo de Jonatán, hijo de Saúl, que tenía cinco años cuando llegó a Yizreel la noticia de la muerte de Saúl y de Jonatán. Su nodriza lo tomó y huyó, pero en el apuro se le cayó el niño y quedó cojo; se llamaba Meribaal."
,"5":"Los hijos de Rimón de Beerot, Recab y Baana, se dirigieron a la casa de Isbaal; llegaron cuando hacía más calor en el día, mientras éste dormía la siesta."
,"6":"La mujer que custodiaba la puerta se había adormilado y quedado dormida mientras limpiaba trigo. Recab y su hermano se acercaron despacito,"
,"7":"entraron en la casa y encontraron a Isbaal tendido en la cama de su dormitorio. Lo golpearon y le cortaron la cabeza, después caminaron toda la noche por el camino de la Arabá, llevando la cabeza."
,"8":"Trajeron a David, en Hebrón, la cabeza de Isbaal y dijeron al rey: 'Esta es la cabeza de Isbaal, el hijo de tu enemigo Saúl que quería quitarte la vida. Hoy Yavé vengó al rey mi señor de Saúl y de su raza'."
,"9":"Pero David respondió a Recab y a su hermano Baana, hijos de Rimón de Beerot: 'Por Yavé que vive y que me ha librado de todos mis problemas,"
,"10":"cuando vino un hombre a verme con la noticia de que Saúl había muerto, creía que era portador de una buena noticia, pero lo hice arrestar y ejecutar en Siclag, en vez de recompensarlo por esa buena noticia."
,"11":"¡Con mayor razón ahora que unos malhechores han asesinado en su casa a un hombre bueno mientras dormía, les voy a hacer pagar la sangre que derramaron, y los voy a barrer de la tierra!'"
,"12":"David dio órdenes a unos jóvenes que estaban presentes, quienes les dieron muerte. En seguida les cortaron las manos y los pies y los colgaron encima de la pileta de Hebrón. Tomaron también la cabeza de Isbaal y la depositaron en la tumba de Abner en Hebrón."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Todas las tribus de Israel se congregaron en torno a David en Hebrón y le dijeron: 'Somos de tus mismos huesos y de tu misma carne."
,"2":"Ya antes, cuando Saúl era todavía nuestro rey, tú eras el que conducía a Israel. Yavé bien te dijo: Tú serás el pastor de mi pueblo Israel, tú serás el jefe de Israel'."
,"3":"Todos los ancianos de Israel fueron a Hebrón a ver al rey y el rey David firmó con ellos una alianza en Hebrón en presencia de Yavé. Después de lo cual consagraron a David como rey de Israel."
,"4":"Cuando David fue rey tenía treinta años; reinó cuarenta años."
,"5":"Había reinado ya siete años y seis meses desde Hebrón en Judá, y reinó en todo Israel y Judá treinta y tres años desde Jerusalén."
,"6":"El rey y sus hombres avanzaron sobre Jerusalén para atacar a los jebuseos que vivían por entonces en la región. Estos dijeron a David: 'Tú no entrarás aquí, aunque los ciegos y los cojos fueran los defensores'."
,"7":"Pero David se apoderó de la fortaleza de Sión, que es la ciudad de David."
,"8":"Pues ese día había dicho David: 'El que quiera derrotar a los jebuseos, que suba por el canal. David maldice a esos cojos y a esos ciegos'. De ahí que se diga ahora: 'Los ciegos y los cojos no entrarán en la Casa de Dios'."
,"9":"David se instaló en la fortaleza y la llamó la ciudad de David, luego construyó en su derredor, desde el Milo hacia el interior."
,"10":"David seguía creciendo sin cesar, y Yavé Sabaot estaba con él."
,"11":"El rey de Tiro, Hiram, despachó una misión donde David con madera de cedro, carpinteros y canteros, que construyeron una casa para David."
,"12":"Entonces David comprendió que Yavé lo había confirmado como rey de Israel y que haría glorioso su reinado por su pueblo de Israel."
,"13":"Después que llegó David de Hebrón, se escogió en Jerusalén a otras mujeres y concubinas; tuvo de ellas hijos e hijas."
,"14":"Estos son los nombres de los hijos que tuvo en Jerusalén: Samúa, Sobab, Natán, Salomón,"
,"15":"Yibjar, Elisúa, Nefeg, Yafia,"
,"16":"Elisama, Baal-Jada y Elifelet."
,"17":"Cuando supieron los filisteos que David había sido consagrado como rey de todo Israel, subieron todos para apoderarse de él; le avisaron a David y éste bajó al refugio."
,"18":"Llegaron los filisteos y se desplegaron en el valle de los Refaím,"
,"19":"y David consultó a Yavé: '¿Debo atacar a los filisteos? ¿Los pondrás en mis manos?' Yavé respondió a David: 'Atácalos, pues pondré a los filisteos en tus manos'."
,"20":"David se dirigió a Baal-Perasim, y allí los derrotó. 'Yavé, dijo, fue como un torrente, me abrió una brecha en las filas enemigas'. Por eso llamaron a ese lugar Baal-Perasim (el Señor de la Brecha)."
,"21":"Los filisteos dejaron allí sus ídolos, los que fueron tomados por David y sus hombres."
,"22":"De nuevo subieron los filisteos y se desplegaron en el valle de los Refaím."
,"23":"David consultó a Yavé quien le respondió: 'No los ataques de frente, tómalos por la retaguardia, pasa por el lado del bosque."
,"24":"Cuando oigas un ruido de pasos por encima de los árboles, apresúrate porque es Yavé que va delante de ti para aplastar al ejército de los filisteos'."
,"25":"David hizo lo que Yavé le había ordenado, y atacó a los filisteos desde Gabaón hasta la entrada de Guezer."
}`)
	CurrentBook.AddChapter(6, `{
"1":"David reunió entonces a todo lo mejor de Israel, unos treinta mil hombres,"
,"2":"y se dirigió a Baala de Judá, acompañado de todo su pueblo. Quería traer el Arca de Dios sobre la cual ha sido pronunciado el Nombre de Yavé Sabaot, quien se sienta en ella sobre los Querubines."
,"3":"Sacaron el Arca de Dios de la casa de Abinadab, en la cumbre de la colina, y la pusieron en una carreta nueva; la había sacado de la casa de Abinadab. Uza y Ajío, los hijos de Abinadab, conducían la carreta;"
,"4":"Uza iba al lado del Arca de Dios y Ajío iba delante de ella."
,"5":"David y todos los israelitas bailaban delante de Yavé con todas sus fuerzas; cantaban al son de guitarras, arpas, tamboriles, címbalos y toda clase de instrumentos."
,"6":"Cuando se acercaban a la era de Nacón, los bueyes dieron un paso en falso. Uza quiso sujetar el Arca de Dios y le puso la mano."
,"7":"Entonces Yavé se enojó con Uza y Dios lo hirió allí mismo; murió al lado del Arca de Dios."
,"8":"David quedó indignado porque Yavé había herido de muerte a Uza; luego de ese incidente este lugar se llamó Perez-Uza."
,"9":"Ese día sintió David un verdadero temor por Yavé y se dijo: '¿Y el Arca de Yavé va a entrar en mi casa?'"
,"10":"David no quiso pues guardar el Arca de Yavé en su casa, en la ciudad de David, y ordenó que la llevaran donde Obed-Edom de Gat."
,"11":"El Arca de Yavé permaneció tres meses en casa de Obed-Edom de Gat, y Yavé bendijo a Obed-Edom y a toda su familia."
,"12":"Le comunicaron a David que Yavé había bendecido a la familia de Obed-Edom y todo lo que le pertenecía debido al Arca de Dios. David entonces fue para allá y con gran alegría hizo transportar el Arca de Dios desde la casa de Obed-Edom hasta la ciudad de David."
,"13":"Cuando los hombres que llevaban el Arca de Yavé dieron los seis primeros pasos, se ofreció como sacrificio un buey y un ternero gordo."
,"14":"David bailaba y hacía piruetas con todas sus fuerzas delante de Yavé; estaba sólo en paños menores."
,"15":"David y todos los israelitas fueron llevando el Arca de Yavé al son de la fanfarria y del cuerno."
,"16":"Cuando el Arca entró en la ciudad de David, Mical, hija de Saúl, estaba mirando en la ventana. Vio al rey que saltaba y se contorneaba delante de Yavé, y lo despreció en su corazón."
,"17":"Trajeron pues el Arca de Yavé y la colocaron en su sitio en medio de la tienda que David había levantado para ella, y David ofreció a Yavé holocaustos y sacrificios de comunión."
,"18":"Cuando David hubo terminado de ofrecer holocaustos y sacrificios de comunión, bendijo al pueblo en nombre de Yavé Sabaot;"
,"19":"después distribuyó a todo el mundo, a todos los israelitas, tanto hombres como mujeres, a cada uno, un pastel, una porción de carne, un dulce de pasas, y todo el mundo regresó a su casa."
,"20":"David también regresó a su casa para bendecirla. Entonces Mical, la hija de Saúl, salió al encuentro de David y le dijo: '¡Realmente el rey de Israel se ha cubierto de gloria hoy día! Te has quitado la ropa ante los ojos de las mujeres de tus servidores como lo haría un hombre cualquiera'."
,"21":"Pero David respondió a Mical: 'Bailaba en presencia de Yavé. Por Yavé que vive, por él que me eligió prefiriéndome a tu padre y a toda tu familia para hacerme el jefe de su pueblo Israel, yo seguiré bailando en presencia de Yavé."
,"22":"Me rebajaré más aún y seré nada a tus ojos, pero en cambio seré grande a los ojos de esas mujeres de las que hablabas'."
,"23":"Y Mical, hija de Saúl, no tuvo nunca hijos."
}`)
	CurrentBook.AddChapter(7, `{
"1":"El rey se había trasladado a su casa, y Yavé había limpiado de enemigos todos los alrededores."
,"2":"Entonces dijo al profeta Natán: 'Yo vivo en una casa de cedro, mientras que el Arca de Dios está todavía en una tienda; ¿qué dices de eso?'"
,"3":"Natán respondió al rey: 'Haz todo lo que estimes conveniente, porque Yavé está contigo'."
,"4":"Pero esa noche le fue dirigida a Natán la palabra de Yavé:"
,"5":"Le dirás a mi servidor David: Esto dice Yavé: ¿Así que tú me vas a construir una casa para que habite en ella?"
,"6":"Desde el día en que saqué a los israelitas de Egipto hasta el día de hoy, no he tenido casa donde morar, sino que estaba con ellos y tenía como morada sólo una tienda."
,"7":"Todo el tiempo que he caminado en medio de los israelitas, jamás he dicho a alguno de los jueces de Israel, a los que había puesto como pastores de mi pueblo de Israel: ¿Por qué no me construyen una casa de cedro?"
,"8":"Le transmitirás pues a mi servidor David esta palabra de Yavé Sabaot: Te fui a buscar al potrero cuando andabas detrás de las ovejas, e hice de ti el jefe de mi pueblo de Israel."
,"9":"Doquiera ibas yo estaba contigo, eliminé delante de ti a todos tus enemigos. Haré grande tu nombre tanto como el de los más grandes de la tierra"
,"10":"y pondré en el lugar que le corresponde a mi pueblo de Israel. Allí lo plantaré y allí se quedará. Ya no será más sacudido; los malvados ya no seguirán oprimiéndolo como antes,"
,"11":"cuando establecí jueces en mi pueblo Israel; lo libraré de todos sus enemigos. Y Yavé te manda a decir esto: Yo te construiré una casa."
,"12":"Cuando tus días hayan concluido y te acuestes con tus padres, levantaré después de ti a tu descendiente, al que brota de tus entrañas, y afirmaré su realeza."
,"13":"El me construirá una casa y yo, por mi parte, afirmaré su trono real para siempre."
,"14":"Seré para él un padre y él será para mí un hijo; si hace el mal lo corregiré como lo hacen los hombres, lo castigaré a la manera humana."
,"15":"Pero no me apartaré de él así como me aparté de Saúl y lo eché de mi presencia."
,"16":"Tu casa y tu realeza estarán para siempre ante mí, tu trono será firme para siempre'."
,"17":"Fue pues Natán a hablar con David y le transmitió todas esas palabras y esa visión."
,"18":"Entonces el rey David fue a sentarse ante Yavé: '¿Quién soy yo Señor Yavé? ¿Qué es mi familia para que me hayas conducido hasta acá?"
,"19":"Pero eso te parece todavía muy poco, Señor Yavé, ya que ahora extiendes tus promesas a la familia de tu servidor para un futuro lejano; ¿es ese un destino normal para un hombre, Señor Yavé?"
,"20":"¿Qué podría añadir tu servidor David? Tú lo conoces, Señor Yavé."
,"21":"Tú has llevado a cabo libremente esas grandes cosas para honrar tus promesas, que acabas de comunicar a tu servidor."
,"22":"Eres grande, Señor Yavé; nadie es como tú; de acuerdo a todo lo que hemos escuchado con nuestros propios oídos, no hay otro Dios fuera de ti."
,"23":"Y ¿quién es como tu pueblo Israel? ¿Hay otra nación en la tierra que haya sido comprada por un Dios para hacerla su pueblo, para darle un nombre, para ejecutar en favor de ella grandes y terribles cosas y para expulsar ante ese pueblo a las demás naciones con sus dioses?"
,"24":"Tú estableciste a tu pueblo Israel para que fuera tu pueblo para siempre, y tú, Yavé, llegaste a ser su Dios."
,"25":"Ahora pues, Señor Yavé, haz que sea siempre cierta la palabra que acabas de pronunciar respecto a tu servidor y a su familia; haz lo que dijiste."
,"26":"Entonces será glorificado tu nombre para siempre y dirán: ¡Yavé Sabaot es Dios de Israel!,La casa de tu servidor David permanecerá firme delante de ti, "
,"27":"ya que eres tú Yavé Sabaot, el Dios de Israel, quien ha hecho esta revelación a tu servidor: 'Te edificaré una casa'. Por eso tu servidor tiene la audacia de dirigirte esta plegaria:"
,"28":"Señor Yavé, tú eres realmente Dios, tus palabras son verdaderas, y tú eres quien hace la promesa a tu servidor."
,"29":"Ahora dígnate bendecir la familia de tu servidor; que tu bendición acompañe siempre a mi familia, como tú, Señor Yavé, lo has dicho'."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Después de eso David venció a los filisteos, quienes se declararon sus súbditos; así puso fin David al dominio filisteo."
,"2":"Venció igualmente a los moabitas. Los hacía tender en tierra y medir con un cordel: dos cordeles para los que estaban destinados a la muerte, y un cordel, a los que se perdonaba la vida. Los moabitas quedaron sometidos a David y le pagaron contribuciones."
,"3":"David venció a Hadadezer, hijo de Rejob, rey de Saba, cuando éste llevó a cabo una expedición para ser nuevamente dueño del Río."
,"4":"Le capturó mil setecientos combatientes en carros y veinte mil hombres de infantería. David cortó los jarretes a todos los caballos y se quedó sólo con cien."
,"5":"Los arameos de Damasco quisieron socorrer a Hadadezer, rey de Saba, pero David les mató veinte mil hombres."
,"6":"Después de eso, David puso gobernadores en la región de Damasco y los arameos pasaron a ser súbditos de David; le pagaban un tributo. Así fue como Yavé daba la victoria a David adondequiera que iba."
,"7":"David tomó los escudos de oro que llevaban los guardias de Hadadezer y los llevó a Jerusalén."
,"8":"Asimismo en Tebaj y Berotai, las ciudades de Hadadezer, se apoderó de gran cantidad de bronce."
,"9":"Cuando Tuú, rey de Jamat, supo que David había aplastado al ejército de Hadadezer,"
,"10":"envió donde David a su hijo Hadoram para que lo saludara y lo felicitara por haber luchado con Hadadezer y haberlo vencido. Pues Hadadezer estaba constantemente en guerra con Tuú. Hadoram llevó consigo objetos de plata, oro y bronce."
,"11":"El rey David lo consagró todo a Yavé junto con la plata y el oro provenientes de todas las naciones que le estaban sometidas:"
,"12":"Aram, Moab, los amonitas, los filisteos, Amalec; también estaba allí el tesoro que había quitado a Hadadezer, hijo de Rejob, rey de Saba."
,"13":"David se hizo más célebre todavía cuando regresó después de haber vencido a los edomitas en el valle de la Sal: eran dieciocho mil."
,"14":"Puso gobernadores en Edom y todos los edomitas fueron súbditos de David. Yavé daba la victoria a David doquiera éste iba."
,"15":"David reinó en todo Israel, hacía respetar el derecho y administraba justicia a su pueblo."
,"16":"Joab, hijo de Seruya comandaba el ejército; Josafat, hijo de Ajilud, era el archivero;"
,"17":"Sadoc y Ebiatar, hijos de Ajimelec, hijo de Ajitub, eran sacerdotes; Seraya era secretario;"
,"18":"Benayas, hijo de Yoyada, comandaba la guardia de los quereteos y peleteos; los hijos de David eran sacerdotes."
}`)
	CurrentBook.AddChapter(9, `{
"1":"David preguntó: '¿Hay todavía algún sobreviviente de la familia de Saúl para que lo trate con bondad en recuerdo de Jonatán?'"
,"2":"Ahora bien, la familia de Saúl tenía un mayordomo que se llamaba Siba. Lo llevaron donde David y el rey le dijo: '¿Tú eres Siba?' Respondió: 'Para servirte'."
,"3":"El rey le preguntó: '¿Queda todavía algún sobreviviente de la familia de Saúl para que lo trate con bondad digna de Dios?' Siba respondió al rey: 'Todavía queda un hijo de Jonatán que está tullido de ambas piernas'."
,"4":"¿Dónde está?' preguntó el rey. Siba respondió al rey: 'Está en la casa de Maquir, hijo de Ammiel, en Lo-Debar'."
,"5":"El rey David lo mandó buscar a la casa de Maquir, hijo de Ammiel, en Lo-Debar."
,"6":"Cuando llegó donde David, Meribaal, hijo de Jonatán, hijo de Saúl, se postró con el rostro en tierra. David le dijo: '¡Meribaal!' Respondió: 'Soy yo tu servidor'."
,"7":"Entonces David le dijo: 'No temas, quiero tratarte con bondad debido a tu padre Jonatán. Te devolveré todas las tierras de Saúl tu abuelo, y todos los días comerás a mi mesa'."
,"8":"Se postró de nuevo y dijo: '¿Quién es tu servidor para que pongas atención en un perro despanzurrado como yo?'"
,"9":"El rey llamó a Siba, el servidor de Saúl, y le dijo: 'Doy a tu patrón todo lo que pertenecía a Saúl y a su familia."
,"10":"Tú, junto con tus hijos y tus esclavos, trabajarás la tierra para él, harás las cosechas y así asegurarás para la familia de tu patrón el alimento que necesita. Pero Meribaal, el hijo de tu patrón, comerá todos los días a mi mesa'. Siba tenía quince hijos y veinte esclavos,"
,"11":"y respondió al rey: 'Tu servidor hará lo que el rey mi señor mandó a su servidor'. De ese modo Meribaal comía a la mesa de David como uno de los hijos del rey; "
,"12":"Meribaal tenía un pequeño hijo que se llamaba Mica. Toda la gente de Siba trabajaba para Meribaal,"
,"13":"pero Meribaal residía en Jerusalén donde todos los días comía a la mesa del rey. Era tullido de ambas piernas."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Por ese entonces murió el rey de los amonitas, y su hijo Amún reinó en su lugar."
,"2":"David se dijo: 'Le haré atenciones a Amún, hijo de Najaz, así como su padre lo hizo conmigo'. David envió pues a sus servidores para presentarle sus condolencias con motivo de la muerte de su padre. Pero cuando los servidores de David llegaron donde los amonitas,"
,"3":"los príncipes de los amonitas dijeron a su señor Amún: '¿Crees tú que David mandó a sus mensajeros con condolencias sólo para honrar a tu padre? Seguramente los mandó para que vinieran a espiar la ciudad, para que conocieran sus defensas y poder así apoderarse de ella'."
,"4":"Amún tomó entonces a los servidores de David, les rasuró la mitad de su barba, les cortó la ropa a la altura de las nalgas y los mandó de vuelta."
,"5":"Al saber eso, David envió a alguien que fuera a encontrarlos, pues esos hombres estaban llenos de vergüenza. Les mandó decir: 'Quédense en Jericó hasta que les crezca la barba, y después regresen'."
,"6":"Los amonitas se dieron cuenta de que se habían vuelto odiosos para David; contrataron por tanto a su servicio a los arameos de Bet-Rejob y a los arameos de Soba, en una cantidad de veinte mil hombres, y doce mil hombres de Tob."
,"7":"Cuando David supo eso, mandó a Joab con todo el ejército y los de la guardia."
,"8":"Los amonitas salieron y se pusieron en orden de batalla a la entrada de la puerta, mientras que los arameos de Soba y de Rejob más la gente de Tob y de Maacá se quedaban a pleno campo."
,"9":"Joab se encontró pues con enemigos tanto delante como detrás de él. Separó la guardia de Israel y la formó en filas frente a los arameos,"
,"10":"luego encomendó a su hermano Abisaí el resto del pueblo, y éste lo formó frente a los arameos."
,"11":"Dijo entonces: 'Si los arameos son más poderosos que yo, tú vendrás a ayudarme, y si los amonitas son más poderosos que tú, yo iré a ayudarte."
,"12":"Ten valor, demostremos que somos valientes por nuestro pueblo y por las ciudades de nuestro Dios; Yavé hará lo que mejor le parezca'."
,"13":"Cuando avanzó Joab con su ejército para atacar a los arameos, éstos salieron huyendo."
,"14":"Al ver los amonitas que huían los arameos, dieron también la espalda a Abisaí y entraron en la ciudad. Entonces Joab puso fin a la expedición en contra de los amonitas y regresó a Jerusalén."
,"15":"Al ver que habían sido derrotados por Israel, los arameos reunieron sus fuerzas."
,"16":"Hadadezer mandó mensajeros para convocar a todos los arameos que vivían al otro lado del río y se concentraron en Jelam; Sobac, el jefe del ejército de Hadadezer, los mandaba a todos."
,"17":"Cuando David lo supo, reunió a todo Israel, atravesó el Jordán y llegó a Jelam."
,"18":"Los arameos se pusieron en orden de batalla frente a David y se trabó el combate. Los arameos dieron vuelta la espalda ante Israel y David les mató setecientos caballos y cuarenta mil hombres. Sobac, su comandante en jefe, fue derribado y murió allí mismo."
,"19":"Cuando todos los reyes vasallos de Hadadezer vieron que habían sido derrotados por Israel, solicitaron la paz a los israelitas y se declararon sus súbditos; desde ese día los arameos no se atrevieron más a socorrer a los amonitas."
}`)
	CurrentBook.AddChapter(11, `{
"1":"A vuelta de año, en la época en que los reyes hacen sus campañas, David mandó a Joab con su guardia y todo Israel. Derrotaron completamente a los amonitas y sitiaron Rabbá, mientras David se quedaba en Jerusalén."
,"2":"Una tarde en que David se había levantado de su siesta y daba un paseo por la terraza, divisó desde lo alto de la terraza a una mujer que se estaba bañando; la mujer era muy hermosa."
,"3":"David preguntó por la mujer y le respondieron: 'Es Betsabé, hija de Eliam, la esposa de Urías el hitita'."
,"4":"David mandó a algunos hombres para que se la trajeran. Cuando llegó a la casa de David, éste se acostó con ella justamente después que se había purificado de su regla, luego se volvió a su casa."
,"5":"Al ver que tenía atraso, la mujer le mandó decir a David: 'Estoy embarazada'."
,"6":"Entonces David envió este mensaje a Joab: 'Mándame a Urías el hitita'. Y Joab mandó a Urías donde David."
,"7":"Cuando llegó Urías, David le pidió noticias del ejército y de la guerra,"
,"8":"después dijo a Urías: 'Anda a tu casa, te has ganado el derecho de lavarte los pies'. Apenas salió Urías de la casa del rey, éste despachó detrás de él un presente de su mesa."
,"9":"Pero Urías no entró en su casa, sino que se acostó a la puerta del palacio con todos los guardias de su señor."
,"10":"Le dijeron a David: 'Urías no ha ido a su casa'. David preguntó a Urías: '¿No vienes de un viaje? ¿Por qué no has bajado a tu casa?'"
,"11":"Urías respondió a David: 'El Arca de Dios, Israel y Judá se alojan en tiendas. Mi jefe Joab y la guardia del rey, mi señor, están acampando a pleno campo, y ¿yo voy a entrar a mi casa para comer y beber y para acostarme con mi mujer? Juro por Yavé que vive y por tu vida que nunca haré tal cosa'."
,"12":"Entonces David dijo a Urías: 'Quédate por hoy aquí y mañana te irás de vuelta'. Urías se quedó pues en Jerusalén aquel día. Al día siguiente"
,"13":"David lo invitó a su mesa a comer y a tomar y lo emborrachó. Sin embargo, Urías tampoco bajó a su casa esa noche; se acostó con los sirvientes de su señor."
,"14":"A la mañana siguiente, David escribió una carta a Joab y se la pasó a Urías para que se la llevara."
,"15":"En la carta escribió esto: 'Coloca a Urías en lo más duro de la batalla, luego déjenlo solo para que lo ataquen y muera'."
,"16":"Joab, que estaba sitiando la ciudad, colocó a Urías en el lugar donde estaban los mejores defensores."
,"17":"La gente de la ciudad efectuó una salida y atacaron a Joab; hubo varios muertos entre los oficiales de David y uno de ellos fue Urías el hitita."
,"18":"Joab mandó a David noticias de las operaciones,"
,"19":"y dio esta orden al mensajero: 'Cuando hayas terminado de contar al rey todos los detalles de la batalla,"
,"20":"a lo mejor el rey se va a enojar y te dirá: ¿Por qué se acercaron a la ciudad? ¿No saben que les disparan desde lo alto de las murallas?"
,"21":"¿Quién mató a Abimelec, hijo de Yerubaal? ¿No fue una mujer que dejó caer sobre él una piedra de molino de lo alto de los muros de Tebés, y así murió? ¿Por qué se acercaron tanto a las murallas? Entonces tú sencillamente le responderás: 'Tu servidor Urías el hitita murió también'."
,"22":"Partió el mensajero y a su arribo le transmitió a David todo el mensaje de Joab. David se enojó."
,"23":"Entonces el mensajero le respondió: 'Esos hombres trataron de efectuar un ataque en contra nuestra, hicieron una salida a descampado, y nosotros los hicimos retroceder hasta la puerta de la ciudad."
,"24":"Pero entonces los arqueros dispararon desde lo alto de las murallas contra tus servidores, murieron varios guardias del rey y entre ellos estaba Urías el hitita'."
,"25":"David dijo al mensajero: 'Dile a Joab que no se preocupe más por este asunto, porque la espada devora tanto aquí como acullá. Dile que refuerce su ataque contra la ciudad hasta que la destruya; que se mantenga firme'."
,"26":"Supo la mujer de Urías que su marido había muerto. Hizo duelo por él,"
,"27":"y cuando se terminaron los días de duelo, David la mandó a buscar. La llevó a su casa, la tomó por mujer y ella le dio un hijo; pero lo que David había hecho le pareció pésimo a Yavé."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Yavé mandó donde David al profeta Natán. Este fue y le dijo: 'Había en una ciudad dos hombres: uno era rico y el otro, pobre."
,"2":"El rico tenía mucho ganado mayor y menor;"
,"3":"el pobre, en cambio, sólo tenía una oveja que había comprado. La alimentaba, crecía a su lado junto con sus hijos, comía de su pan, tomaba de su copa y dormía en su regazo; era para él como una hija."
,"4":"Un día el rico recibió a una visita. Como no quería sacrificar ningún animal de su ganado para preparar una cena al que acababa de llegar, robó la oveja del pobre y se la preparó a su visita'."
,"5":"David se enojó mucho con ese hombre y dijo a Natán: 'Por Yavé que vive, el hombre que hizo eso merece la muerte."
,"6":"Devolverá cuatro veces más por la oveja por haber actuado así sin ninguna compasión'."
,"7":"Entonces Natán dijo a David: 'Ese hombre eres tú. Esto dice Yavé, el Dios de Israel: Te consagré como rey de Israel, te libré de las manos de Saúl,"
,"8":"te di la casa de tu señor y las mujeres de tu señor, te di la casa de Israel y la de Judá, y por si esto fuera poco, habría hecho mucho más por ti."
,"9":"¿Por qué pues despreciaste la palabra de Yavé? ¿Por qué hiciste esa cosa tan mala a sus ojos de matar por la espada a Urías el hitita? Te apoderaste de su mujer y lo mataste por la espada de los amonitas."
,"10":"Por eso, la espada ya no se apartará más de tu casa, porque me despreciaste y tomaste a la mujer de Urías el hitita para hacerla tu propia mujer."
,"11":"Esto dice Yavé: Haré que te sobrevenga la desgracia desde tu propia casa; tomaré a tus mujeres ante tus propios ojos y se las daré a tu prójimo que se acostará con ellas a plena luz del sol."
,"12":"Tú hiciste esto en secreto, pero yo llevaré a cabo eso en presencia de todo Israel, a pleno día'."
,"13":"David dijo a Natán: '¡Pequé contra Yavé!' Y Natán le respondió: 'Yavé te perdona tu pecado, no morirás."
,"14":"Sin embargo, puesto que con esto despreciaste a Yavé, el hijo que te nació morirá'"
,"15":"Mientras Natán regresaba a su casa, Yavé hirió al hijo que la mujer de Urías había dado a David, que cayó enfermo."
,"16":"David pidió a Dios por su hijo, se negaba a comer y cuando regresó a su casa, dormía en el suelo."
,"17":"Los ancianos de su casa le insistían para que se levantara, pero se negaba y no ingirió ningún alimento con ellos."
,"18":"Al séptimo día, el niño murió. Los servidores de David no se atrevían a comunicarle la noticia, pues se decían: 'Si cuando el niño estaba todavía vivo, le hablábamos y no quería hacernos caso, ¿qué no hará ahora cuando le comuniquemos que el niño murió?'"
,"19":"David se dio cuenta de que los servidores cuchicheaban entre sí; comprendió entonces que el niño había muerto y dijo a sus servidores: '¿Murió el niño?' Le respondieron: 'Sí, murió'."
,"20":"Entonces David se levantó, se bañó, se perfumó y se cambió de ropa. Entró en la Casa de Yavé donde se postró; luego regresó a su casa y pidió que le sirvieran algo y comió."
,"21":"Sus servidores le dijeron: '¿Qué haces? Cuando el niño estaba vivo, ayunabas, llorabas, y ahora que está muerto, te levantas y comes'."
,"22":"Respondió: 'Mientras el niño estaba aún con vida, ayunaba y lloraba, pues me decía: ¿Quién sabe? A lo mejor Yavé tiene piedad de mí y sana al niño."
,"23":"Pero ahora que está muerto, ¿para qué ayunar? ¿Puedo acaso hacer que reviva? En vez de que vuelva a mí, seré yo más bien quien vaya donde él'."
,"24":"David consoló a su mujer Betsabé, la fue a ver y se acostó con ella, quien concibió y dio a luz a un niño, al que le puso el nombre de Salomón. Yavé amó a ese niño,"
,"25":"y mandó al profeta Natán, que lo llamó Yedidya, es decir, amado de Yavé, por encargo suyo."
,"26":"Joab atacó Rabbá de los amonitas y se apoderó de esa ciudad real;"
,"27":"después mandó mensajeros donde David para decirle: 'Ataqué Rabbá y me apoderé de la ciudad baja."
,"28":"Ya es tiempo de que congregues al resto del pueblo. Ven pues a acampar frente a la ciudad y a apoderarte de ella; no vaya a ser que la tome yo y que le den mi nombre'."
,"29":"Congregó pues David a todo el pueblo y salió rumbo a Rabbá; atacó la ciudad y se apoderó de ella."
,"30":"Le quitó al dios Milcom su corona que pesaba un talento de oro y que tenía engarzada una piedra preciosa, la que pronto lució en la cabeza de David. Se apoderó de un inmenso botín."
,"31":"Después desterró a todos los habitantes de la ciudad, los condenó a trabajos forzados con el serrucho, la picota o el hacha y los empleó en la fabricación de ladrillos. Así actuó David con todas las ciudades de los amonitas, y después regresó a Jerusalén con todo su ejército."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Poco después aconteció esto: Absalón, hijo de David, tenía una hermana que era muy bella y que se llamaba Tamar; Amnón, otro hijo de David, se enamoró de ella."
,"2":"Amnón se atormentaba de tal forma que hasta se enfermó pensando en su media hermana Tamar; ésta era virgen y Amnón no veía cómo lo podría hacer."
,"3":"Amnón tenía un amigo que se llamaba Yonadab, hijo de Simea, hermano de David; Yonadab era muy astuto."
,"4":"Le dijo: '¿Qué te pasa, hijo de rey, que tan temprano te ves ya alicaído? ¿Quieres decírmelo?' Amnón le respondió: 'Es que quiero a Tamar, la hermana de mi hermano Absalón'."
,"5":"Entonces Yonadab le dijo: 'Anda a acostarte, pon cara de enfermo, y cuando vaya tu padre a verte, dile: Dale permiso a mi hermana Tamar para que venga a servirme la comida. Que prepare un guiso ante mi vista y me lo sirva de su mano'."
,"6":"Amnón se fue a acostar y se hizo el enfermo. El rey lo fue a ver y Amnón dijo al rey: 'Dale permiso a mi hermana Tamar para que venga, prepare unos pastelillos en mi presencia y me los sirva de su mano'."
,"7":"David mandó a buscar a Tamar a la casa: 'Anda a la casa de tu hermano Amnón y prepárale alguna comida'."
,"8":"Tamar fue a casa de su hermano Amnón que estaba en cama, preparó la masa, la sobó y ante la vista de él moldeó unos pastelillos que puso a cocer."
,"9":"Tomó después la sartén y la vació delante de él, pero no quiso comer. Amnón dijo entonces: 'Manden a todos afuera', y salieron todos."
,"10":"Amnón dijo entonces a Tamar: 'Trae la comida a la pieza para que la reciba de tus manos'. Tamar tomó los pastelillos que había preparado y se los llevó a su hermano Amnón a su pieza."
,"11":"Cuando ella se los presentó, la agarró y le dijo: 'Hermana mía, ven a acostarte conmigo'."
,"12":"Pero ella le respondió: 'No, hermano mío, no me tomes a la fuerza, pues no se actúa así en Israel. No cometas esta falta."
,"13":"¿A dónde iría con mi vergüenza? Y tú serías como un maldito en Israel. Habla mejor con el rey, que no se negará a darme a ti'."
,"14":"Pero él no quiso hacerle caso, la agarró a la fuerza y se acostó con ella."
,"15":"Pero luego Amnón la detestó. Era un odio más grande aún que el amor que le tenía. Amnón le dijo: '¡Párate y ándate!"
,"16":"Ella respondió: '¡No, hermano mío, no me eches! Eso sería peor que lo que acabas de hacer'."
,"17":"Pero no quiso oírla, sino que llamó a un joven que estaba a su servicio y le dijo: 'Echala fuera, lejos de mí, y cuando salga cierra la puerta con candado'."
,"18":"Ella llevaba una túnica con mangas, porque así se vestían las hijas del rey cuando todavía eran vírgenes. El sirviente la echó fuera y cuando salió cerró la puerta con candado."
,"19":"Tamar se echó ceniza en la cabeza, rasgó su túnica con mangas y se puso una mano en la cabeza, luego partió lanzando gritos."
,"20":"Su hermano Absalón le dijo: '¿Así que tu hermano Amnón se acostó contigo? Escúchame, hermana mía, no digas nada a nadie. ¿No es tu hermano? No tomes tan a pecho lo sucedido'. Tamar se quedó desamparada en la casa de su hermano Absalón."
,"21":"Cuando el rey David se enteró del asunto, se enojó mucho pero no quiso llamarle la atención a su hijo Amnón, porque era su preferido por ser el mayor."
,"22":"Absalón tampoco le dijo nada, ni buenas ni malas palabras, pero sentía odio por él debido a que había violado a su hermana Tamar."
,"23":"Dos años después, Absalón iba a hacer la esquila en Baal-Jazor, al lado de Efraín. Absalón invitó a ella a todos los hijos del rey."
,"24":"Absalón dijo al rey: 'Ahora que tu servidor va a recibir a los esquiladores, venga el rey con toda su gente a mi casa'."
,"25":"Pero el rey respondió a Absalón: 'No, hijo mío, no podemos ir todos, pues sería demasiado gasto para ti'. Absalón siguió insistiendo ante el rey, quien no quiso ir y se contentó con bendecirlo."
,"26":"Absalón le dijo entonces: '¡De acuerdo, pero al menos acepta que venga conmigo mi hermano Amnón'. El rey le respondió: '¿Por qué tiene que ir contigo?'"
,"27":"Pero Absalón insistió tanto que el rey dio permiso para que fuera Amnón con los demás hijos del rey. Absalón preparó un banquete real "
,"28":"y dio esta orden a sus muchachos: 'Cuando Amnón esté borracho, les diré: ¡Denle a Amnón! E inmediatamente lo matarán. No teman nada, pues yo soy quien se lo ordena. ¡Animo, no se acobarden!'"
,"29":"Los servidores de Absalón hicieron con Amnón tal como Absalón se lo había ordenado. Al ver eso, todos los demás hijos del rey se levantaron, cada cual ensilló su mula y huyeron."
,"30":"Todavía estaban en camino cuando llegó la noticia donde David: 'Absalón mató a todos los hijos del rey y nadie escapó'."
,"31":"El rey se levantó, rasgó su ropa y se acostó en el suelo; todas las personas que estaban con él rasgaron también su ropa."
,"32":"Yonadab, hijo de Simea, hermano de David, tomó entonces la palabra, diciendo: 'Señor, no crea que murieron todos los hijos del rey; sólo murió Amnón, pues era una idea fija en la cabeza de Absalón desde el día en que Amnón violó a su hermana Tamar."
,"33":"No tome, mi señor, tan en serio la cosa, ni piense tampoco que murieron todos los hijos del rey. No, sólo murió Amnón, y Absalón seguramente salió huyendo'."
,"34":"El joven que estaba de vigía divisó un grupo importante que bajaba por el camino de Bajurim, y fue a informar al rey: 'Vi unos hombres que bajan por el camino de Bajurim por la falda del cerro'."
,"35":"Yonadab dijo entonces al rey: 'Ves que tu servidor no estaba equivocado'."
,"36":"Todavía estaba hablando cuando entraron los hijos del rey, lanzando exclamaciones y llorando. El rey se puso a llorar también junto con sus servidores."
,"37":"Mientras tanto Absalón había huido y se había refugiado en casa de Talmai, hijo de Ammijud, rey de Guesur;"
,"38b":"allí estuvo tres años."
,"38":"El rey hizo duelo por largos días por su hijo,"
,"39":"después se consoló de la muerte de Amnón y se le pasó el enojo con Absalón."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Joab, hijo de Seruya, se dio cuenta de que el rey estaba preocupado por Absalón,"
,"2":"y mandó buscar a Tecoa, una mujer astuta: 'Oyeme bien, le dijo, vas a ponerte ropa de luto; no te perfumarás y te comportarás como una mujer que está de luto mucho tiempo por un difunto."
,"3":"Irás donde el rey y le contarás toda la historia que te voy a decir'."
,"4":"La mujer de Tecoa fue donde el rey, se postró con el rostro en tierra y se puso a gritar: '¡Ayúdame, señor rey!'"
,"5":"El rey le preguntó: '¿Qué tienes?' Respondió: '¡Ay! Soy viuda, mi marido murió."
,"6":"Tu sirvienta tenía dos hijos. Se pelearon en el campo, no había allí nadie para separarlos, y uno mató al otro."
,"7":"Ahora toda la familia se lanzó en mi contra. Me dicen: Entréganos al que dio muerte a su hermano para que lo matemos y así pague por la vida de su hermano. ¡Pero me van a quitar al heredero! Van a apagar la brasita que me queda todavía, me dejaran en la tierra sin marido, sin nombre, sin descendencia'."
,"8":"El rey dijo a la mujer: 'Regresa a tu casa y yo mismo intervendré en tu asunto'."
,"9":"La mujer de Tecoa dijo al rey: '¡Señor rey, que este problema me afecte sólo a mí y a mi familia, pero que el rey y su trono no tengan por qué preocuparse!'"
,"10":"El rey replicó: 'Tráeme al que te amenazó y te prometo que no volverá más a hacerte el mal'."
,"11":"Ella le dijo: 'Que me prometa el rey en nombre de Yavé su Dios que el vengador de la sangre no aumentará mi pena ni hará que perezca mi hijo'. El le dijo: '¡Por Yavé que vive, no caerá en tierra un solo cabello de tu hijo!'"
,"12":"La mujer retomó la palabra diciendo: 'Permítale el señor rey a su sirvienta decir todavía una palabra'."
,"13":"Le dijo: 'Habla'. La mujer respondió: 'Al pronunciar ese juramento el rey se condenó solo; pues lesiona al pueblo de Dios cuando se niega a que regrese el que desterró."
,"14":"Todos estamos condenados a morir: no se recupera el agua que se derrama en el suelo; Dios no hace que vuelvan los muertos. Que el rey, pues, busque los medios para que regrese el que fue exiliado."
,"15":"Por eso vine a contarle al rey toda esa historia de personas que me atemorizaban. Me dije: Hablaré al rey, a lo mejor hará lo que le pide su sirvienta."
,"16":"A lo mejor el rey me atiende y quiere librarme del que quiere cercenarnos a mí y a mi hijo de la herencia de Dios."
,"17":"Y me dije: 'Ojalá el señor rey pudiera decir tan sólo una palabra apaciguante, porque el rey es como un ángel de Dios, que comprende el bien y el mal. Que Yavé tu Dios esté contigo'."
,"18":"El rey respondió a la mujer: 'No me ocultes nada y respóndeme esta pregunta'. La mujer le dijo: 'Hable mi señor rey'."
,"19":"El rey le dijo: '¿Detrás de todo este asunto no está acaso Joab?' La mujer le respondió: 'Tan cierto como que tú vives, señor rey, que uno no puede desviarse ni a derecha ni a izquierda de todo lo que dice el rey mi señor. Sí, fue tu servidor Joab quien me encargó esto. El fue quien puso todas esas palabras en mi boca."
,"20":"Tu servidor Joab disfrazó la situación pendiente con esta historia, pero la sabiduría del rey mi señor es como la sabiduría de un ángel de Dios, pues sabe todo lo que pasa en la tierra'."
,"21":"Entonces el rey dijo a Joab: '¿Así que tú inventaste este cuento? Trae de vuelta al joven Absalón'."
,"22":"Joab se postró con el rostro en tierra y bendijo al rey, diciendo: 'Ahora que el rey solucionó el problema de su servidor, tengo la prueba de que está lleno de atenciones para mí'."
,"23":"Joab partió para Guesur y trajo a Absalón a Jerusalén."
,"24":"Sin embargo el rey dijo: 'Que se vaya a su casa y que no se presente ante mí'. Absalón se retiró pues a su casa y no se presentó ante el rey."
,"25":"Nadie era más buen mozo que Absalón en todo el territorio de Israel. Todos cantaban sus alabanzas: de pies a cabeza no había en él ningún defecto."
,"26":"Absalón se cortaba el cabello cuando ya le pesaba mucho, y cuando se lo cortaba se lo pesaba. Pues bien, pesaba doscientos siclos según el peso del rey (un kilo y medio)."
,"27":"Absalón tuvo tres hijos y una hija a la que llamó Tamar: ésta era muy hermosa."
,"28":"Absalón estuvo dos años en Jerusalén sin presentarse ante el rey;"
,"29":"transcurrido ese tiempo mandó buscar a Joab para mandarlo donde el rey, pero Joab no quiso ir. Lo mandó buscar por segunda vez, pero tampoco quiso ir."
,"30":"Entonces dijo a sus sirvientes: '¿Ven ustedes el campo de Joab que está al lado del mío, en el que se sembró cebada? Pues bien, vayan y préndanle fuego'. Los sirvientes de Absalón prendieron fuego al campo. Inmediatamente fueron los sirvientes de Joab a buscarlo con la ropa hecha tiras y le dijeron: 'Los sirvientes de Absalón prendieron fuego a todo el campo'."
,"31":"Joab se paró y fue a la casa de Absalón, y le dijo: '¿Por qué tus sirvientes prendieron fuego a mi campo?'"
,"32":"Absalón respondió a Joab: 'Te mandé a buscar con este recado: Ven que quiero mandarte donde el rey. Le preguntarás por qué ordenó que volviera de Guesur. Me hubiera valido más quedarme allá abajo. Ahora quiero presentarme al rey; si cometí un crimen, que me condene a muerte'."
,"33":"Joab fue a contar todo eso al rey, quien mandó llamar a Absalón. Este llegó a la casa del rey, se postró con el rostro en tierra, y el rey lo abrazó."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Después de eso Absalón se compró un carro, caballos y contrató a cincuenta hombres que iban corriendo delante de él."
,"2":"Muy temprano iba Absalón a pararse al lado del camino que lleva a la puerta de la ciudad. Cada vez que un hombre tenía un pleito y debía presentarse en casa del rey para el juicio, Absalón lo llamaba y le preguntaba: '¿De qué ciudad eres tú?' Si el otro respondía: 'Tu servidor es de tal tribu de Israel',"
,"3":"Absalón le decía: 'Mira, tu causa es buena y justa, pero no habrá nadie en la casa del rey para escucharte'."
,"4":"Luego Absalón agregaba: '¡Ah, si yo estuviera encargado de la justicia en este país! Todos los que tuvieran un pleito vendrían a verme y yo les haría justicia'."
,"5":"Y cuando alguien se acercaba para postrarse ante él, Absalón le tendía la mano, lo levantaba y lo abrazaba."
,"6":"Así se comportaba Absalón con todos los israelitas que iban a ver al rey por algún pleito, y con eso se ganaba el corazón de todos los israelitas."
,"7":"Al cabo de cuatro años, Absalón dijo al rey: 'Déjame ir a Hebrón a cumplir una manda que hice a Yavé."
,"8":"Cuando estaba en Guesur, en Aram, hice esta manda: 'Si Yavé permite que vuelva a Jerusalén, iré a honrarlo a Hebrón'."
,"9":"El rey le dijo: 'Anda en paz'. Absalón entonces se preparó y partió para Hebrón."
,"10":"Absalón mandó a decir a todas las tribus de Israel: 'En cuanto oigan el sonido del cuerno, ustedes proclamarán: ¡Absalón es rey en Hebrón!'"
,"11":"Doscientas personas invitadas por Absalón habían salido con él de Jerusalén, pero iban sin saber, sin conocer nada de lo que se tramaba."
,"12":"Mientras Absalón ofrecía sacrificios, mandó buscar a Guiló a un consejero de David que se llamaba Ajitofel de Guiló. La conspiración aumentaba día a día y los partidarios de Absalón iban siendo cada vez más numerosos."
,"13":"Alguien fue a informarle a David: 'Los hombres de Israel se pasaron a Absalón'."
,"14":"David entonces dijo a sus servidores y a los que estaban con él en Jerusalén: '¡Rápido, huyamos, porque en caso contrario no escaparemos de Absalón! Salgamos inmediatamente, porque si nos alcanza, nos derrotará y pasará a cuchillo la ciudad'."
,"15":"Los servidores del rey le dijeron: 'Adondequiera que vaya nuestro señor el rey, allí estarán sus servidores'."
,"16":"El rey salió a pie con toda su familia, dejando en la ciudad a diez concubinas para que cuidaran el palacio."
,"17":"El rey iba a pie acompañado de toda su gente, e hicieron un alto a la última casa."
,"18":"Todos sus servidores estaban a su lado mientras desfilaban delante del rey los mercenarios quereteos y peleteos: éstos eran seiscientos hombres que habían venido de Gat con él."
,"19":"El rey dijo a Itaí de Gat: '¿Por qué vienes también con nosotros? Vuélvete y quédate con el nuevo rey. Tú eres un extranjero y ya has tenido que dejar tu país."
,"20":"Has llegado hace poco y ¿voy a hacerte salir cuando no sé a dónde voy? Regresa con tus hermanos y que Yavé te pague tu bondad y tu fidelidad'."
,"21":"Pero Itaí respondió al rey: 'Por Yavé que vive y por la vida del rey mi señor, donde esté mi señor el rey allí estarán para mí la vida y la muerte'."
,"22":"David dijo entonces a Itaí: 'Adelante, pasa'. E Itaí siguió adelante con todos sus hombres y sus familias."
,"23":"El pueblo iba pasando y todos lloraban a gritos. El rey atravesó el torrente del Cedrón y toda la gente pasó al este del camino que pasa por el desierto."
,"24":"También estaba allí Sadoc junto con todos los levitas que transportaban el Arca de la Alianza de Dios; habían dejado el Arca en el suelo mientras el pueblo que venía de la ciudad subía y desfilaba."
,"25":"El rey dijo entonces a Sadoc: 'Lleva el Arca de Dios a la ciudad. Si merezco consideración a los ojos de Yavé, me traerá de vuelta y volveré a ver el Arca y su Morada."
,"26":"Pero si dice: Ya no quiero más de ti; aquí estoy, que me trate como mejor le parezca'."
,"27":"El rey dijo además al sacerdote Sadoc: 'Vuelve en paz a la ciudad con tu hijo Ajimaas y con Jonatán, hijo de Ebiatar."
,"28":"Fíjense, me quedaré en los desfiladeros del desierto hasta que reciba de ustedes algún mensaje con noticias'."
,"29":"Sadoc y Ebiatar llevaron pues de vuelta a Jerusalén el Arca de Dios y se quedaron allí."
,"30":"Mientras David subía el cerro de los Olivos, iba llorando, con un velo en la cabeza y caminando descalzo. Todos los que estaban con él llevaban también la cabeza cubierta y subían llorando."
,"31":"Transmitieron a David esta noticia: '¡Ajitofel es uno de los conjurados, está con Absalón!' David entonces exclamó: '¡Oh Yavé, vuelve locos los consejos de Ajitofel!'"
,"32":"Cuando David llegó a la cumbre, allí donde se adora a Dios, vio que venía a su encuentro uno de sus familiares, Jusaí el arquita, quien llevaba rota su túnica y la cabeza cubierta de polvo."
,"33":"David le dijo: 'Si vienes conmigo, serás una carga para mí."
,"34":"Podrías volver a la ciudad y decir a Absalón: Estaré a tu servicio, señor rey; antes serví a tu padre pero ahora te sirvo a ti. Así me harás un servicio embrollando los consejos de Ajitofel."
,"35":"Contigo estarán los sacerdotes Sadoc y Ebiatar. Todo lo que veas en el palacio se lo transmitirás a los sacerdotes Sadoc y Ebiatar."
,"36":"Sus dos hijos, Ajimaas, hijo de Sadoc y Jonatán, hijo de Ebiatar, están con ellos y por su intermedio me darán a conocer todo lo que sepan'."
,"37":"Jusaí, familiar de David, entró de vuelta en la ciudad, en el mismo momento en que Absalón llegaba a Jerusalén."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Cuando David llegó a la cumbre, Siba, el servidor de Meribaal, salió a su encuentro con un par de burros. Llevaba doscientos panes, cien racimos de pasas, cien frutas de la estación y un cuero de vino."
,"2":"El rey dijo a Siba: '¿Qué vas a hacer con todo eso?' Siba le respondió: 'Los burros servirán para que monten en ellos la familia del rey; el pan, las frutas de la estación servirán como alimento de sus compañeros. Y a los que se cansen en el desierto les darán a beber vino'."
,"3":"Entonces le dijo el rey: 'Pero, dónde está el hijo de tu señor Saúl?' Siba dijo al rey: 'Se quedó en Jerusalén, pues piensa que la casa de Israel le devolverá hoy la realeza de su padre'."
,"4":"El rey dijo a Siba: 'Todo lo que tiene Meribaal te pertenece'. Siba respondió: '¡Sólo puedo inclinarme, que siempre cuente con el favor del rey mi señor!'"
,"5":"Como el rey David se acercara a Bajurim, salió un hombre de la familia de Saúl que se llamaba Simeí, hijo de Guera. Mientras caminaba, iba lanzando toda clase de maldiciones."
,"6":"Y tiraba piedras a David y a los servidores del rey, mientras el rey David caminaba rodeado a derecha e izquierda por el pueblo y su guardia."
,"7":"Simeí lo maldecía: '¡Andate, ándate! No eres más que un sanguinario y un criminal!"
,"8":"Yavé ha hecho recaer sobre ti la sangre de la familia de Saúl; así como tú le quitaste el trono, así también ahora Yavé se lo da a tu hijo Absalón. Te ha venido la desgracia porque eres un sanguinario'."
,"9":"Abisaí, hijo de Seruya, dijo al rey: '¿Por qué ese perro despanzurrado maldice al rey mi señor? Déjame pasar el torrente y le corto la cabeza'."
,"10":"Pero el rey le respondió: 'Hijo de Seruya, no te metas en mis asuntos; tal vez me maldice porque Yavé le dijo: ¡Maldice a David! ¿y quién tendrá derecho a preguntarle por qué lo hace?'"
,"11":"David dijo entonces a Abisaí y a sus servidores: 'Si mi hijo, el que salió de mí, quiere atentar contra mi vida, con cuánta mayor razón ese hombre de Benjamín. Déjenlo que maldiga si Yavé se lo dijo."
,"12":"A lo mejor Yavé toma en cuenta esta mi pena para devolverme la felicidad después de la maldición de hoy'."
,"13":"David y sus hombres continuaron su camino mientras Simeí seguía en la misma dirección pero al otro lado de la quebrada; maldecía, tiraba piedras y levantaba polvo."
,"14":"El rey y todo su pueblo, agotados, se detuvieron por fin para respirar un poco."
,"15":"Absalón y todo el pueblo de Israel entraron en Jerusalén; con él iba Ajitofel."
,"16":"Jusaí el arquita, consejero de David, fue a presentarse a Absalón, le dijo: '¡Viva el rey! ¡Viva el rey!'"
,"17":"Absalón le respondió: '¡Esa es la fidelidad a tu amigo! ¿Por qué no fuiste a reunirte con tu amigo?'"
,"18":"Pero Jusaí respondió a Absalón: ' ¿No fue a ti a quien eligieron Yavé, todo ese pueblo y todos los hombres de Israel? Te pertenezco pues y me quedo contigo."
,"19":"Y además, ¿a quién voy a servir? ¿No eres tú su hijo? Te serviré pues igual como serví a tu padre'."
,"20":"Absalón dijo a Ajitofel: 'Reunamos al consejo para saber lo que vamos a hacer'."
,"21":"Ajitofel dijo a Absalón: 'Anda donde las concubinas de tu padre, las que dejó para que cuidaran el palacio. Así sabrá todo Israel que te has vuelto odioso para tu padre, y todos tus partidarios se sentirán más comprometidos contigo'."
,"22":"Instalaron, pues, una tienda en la terraza del palacio y ante los ojos de todo Israel Absalón se unió a las concubinas de su padre."
,"23":"Por ese entonces todos los consejos de Ajitofel eran como palabras de Dios; así los consideraban tanto David como Absalón."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Ajitofel dijo a Absalón: 'Permíteme que elija a doce mil hombres, pues quiero perseguir a David esta misma noche."
,"2":"Lo atacaré mientras se encuentra fatigado y con las manos cansadas, sembraré el pánico entre el pueblo y el pueblo huirá. Entonces me bastará con ultimar al rey,"
,"3":"y te traeré a todo el pueblo tal como vuelve una novia donde su novio. No necesitas más que la vida de un hombre, y al pueblo no le pasará nada'."
,"4":"Le pareció buena la cosa a Absalón y a todos los dirigentes de Israel."
,"5":"Pero Absalón dijo: 'Llamen a Jusaí el arquita, para que oigamos su consejo'."
,"6":"Jusaí se acercó a Absalón y éste le dijo: 'Ajitofel nos dio este consejo. ¿Tenemos que seguirlo? Porque si no, ¿qué propones tú?'."
,"7":"Jusaí respondió a Absalón: 'Por esta vez el consejo de Ajitofel no es bueno'."
,"8":"Y Jusaí añadió: 'Sabes bien que tu padre y sus compañeros son valientes, están enfurecidos igual que una osa salvaje a la que le han quitado sus crías, o como el jabalí en la pradera. Tu padre es un buen soldado, y ciertamente no dejará que el ejército cierre los ojos;"
,"9":"en este momento, con toda seguridad, debe estar oculto en alguna caverna o en cualquier otro lugar. Si los nuestros pierden hombres desde el comienzo, correrá el rumor y dirán: El ejército de Absalón sufrió una derrota."
,"10":"Entonces hasta los más valientes, los que tienen un corazón de león, se desanimarán, porque todo Israel sabe que tu padre y los que están con él son valientes."
,"11":"Por eso más bien te aconsejo que mandes reunir a todo Israel, desde Dan hasta Bersebá, y tú mismo marcharás al frente de ese ejército tan numeroso como las arenas del mar."
,"12":"Lo atacaremos, esté donde esté, nos dejaremos caer sobre él tal como cae el rocío en el suelo y no dejaremos con vida ni a él ni a sus compañeros."
,"13":"Si se atrinchera en una ciudad, todo Israel juntará cordeles para tirar esa ciudad al torrente, de tal modo que no se encontrará allí ni una piedra'."
,"14":"Absalón y toda la gente de Israel exclamaron: 'El consejo de Jusaí el arquita es mejor que el de Ajitofel'. Es que Yavé había decidido que no se tomara en cuenta el consejo de Ajitofel que era el bueno, para que así le fuera mal a Absalón."
,"15":"Jusaí dijo entonces a los sacerdotes Sadoc y Ebiatar: 'Ajitofel dio este consejo a Absalón y a los ancianos de Israel, pero esto es lo que yo les aconsejé."
,"16":"Vayan ahora rápidamente a avisarle a David. Díganle: No te quedes esta noche en los desfiladeros del desierto. Apresúrate en atravesar, si no el rey y su ejército corren el riesgo de ser aniquilados'."
,"17":"Jonatán y Ajimaas estaban cerca de la fuente de Roguel y una sirvienta tenía que comunicarse con ellos para que llevaran la noticia al rey, porque no querían entrar en la ciudad y que los vieran."
,"18":"Pero un joven los vio y dio aviso a Absalón. Entonces ambos salieron huyendo y se refugiaron en casa de un hombre de Bajurim. Había en el patio un pozo donde se escondieron."
,"19":"La mujer tomó un pedazo de cuero, lo extendió sobre el brocal del pozo y desparramó encima grano, de tal modo que no se veía nada."
,"20":"Los servidores de Absalón llegaron donde la mujer y le preguntaron: '¿Dónde están Ajimaas y Jonatán?' La mujer les respondió: 'Siguieron su camino hacia el Jordán'. Los buscaron, y como no los encontraron, retornaron a Jerusalén."
,"21":"Después que se fueron, Ajimaas y Jonatán salieron del pozo y fueron a prevenir a David: 'Salgan inmediatamente, apresúrense en atravesar, porque esto fue lo que respecto a ustedes aconsejó Ajitofel'."
,"22":"David y todo el ejército que lo acompañaba iniciaron la marcha, pasaron el Jordán y al alba todos habían atravesado el Jordán."
,"23":"Cuando Ajitofel vio que no se había seguido su consejo, ensilló su burro y regresó a la casa que tenía en la ciudad, puso todo en orden en su casa y se ahorcó."
,"24":"Mientras Absalón atravesaba el Jordán con todos los israelitas, David ya había llegado a Majanayim."
,"25":"Absalón había nombrado comandante en jefe del ejército a Amasa en vez de Joab (Amasa era hijo de Yitra el ismaelita, quien se había unido a Abigaíl, hija de Jesé, y hermana de Seruya, la madre de Joab)."
,"26":"Israel y Absalón instalaron su campamento en el territorio de Galaad."
,"27":"Cuando David llegó a Majanayim, Sobi, hijo de Najaz de Rabbá de los amonitas, Matri, hijo de Ammiel de Lo-Debar, y Barcillai de Roglim de Galaad,"
,"28":"le llevaron colchonetas, frazadas, copas y vajilla. También le llevaron trigo y cebada, harina, trigo tostado, habas y lentejas,"
,"29":"miel y leche cuajada, quesos de oveja y de vaca, para que se alimentaran David y el pueblo que lo acompañaba. Pues se habían dicho: 'Después de la caminata por el desierto, este pueblo debe estar fatigado, con hambre y con sed'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"David pasó revista a los hombres que estaban con él y puso al frente de ellos a jefes de mil y de cien."
,"2":"Luego David dividió al ejército en tres: un tercio se lo pasó a Joab, otro a Abisaí, hijo de Seruya y hermano de Joab, y el último a Itaí de Gat. El rey dijo a la tropa: 'Yo también iré con ustedes'."
,"3":"Pero la tropa respondió: 'No, es mejor que no vengas, porque si damos vuelta la espalda, nadie se fijará en eso. Si muere la mitad de nosotros, nadie reparará en ello, pero tú, tú eres como diez mil de nosotros. Es mejor que te quedes en la ciudad para que así puedas ayudarnos'."
,"4":"El rey les dijo: 'Haré lo que a ustedes mejor les parezca'. Se quedó pues en la puerta de la ciudad y salió toda la tropa en destacamentos de a cien y de a mil."
,"5":"El rey dio esta orden a Joab, Abisaí y a Itaí: 'Por respeto a mí traten bien al joven Absalón'. Todo el ejército oyó la orden que había dado el rey a los jefes con respecto a Absalón."
,"6":"El ejército de David salió al encuentro de Israel y la batalla tuvo lugar en los bosques de Efraín."
,"7":"Fue una gran derrota para el ejército de Israel, la gente de David los aplastaron y perdieron veinte mil hombres."
,"8":"La batalla prosiguió luego por todo el sector y ese día perecieron más hombres en las barrancas del bosque que en el combate."
,"9":"Los hombres de David hallaron a Absalón por casualidad; iba montado en su mula y ésta pasó debajo de las ramas de una gran encina. Sus cabellos se enredaron en la encina y quedó colgando entre el cielo y la tierra mientras la mula seguía su carrera."
,"10":"Un hombre lo vio y le avisó a Joab: 'Vi a Absalón que está colgado de una encina'."
,"11":"Joab dijo al que le trajo la noticia: '¡Así que lo viste! ¿Y por qué no lo mataste allí mismo? Te habría dado diez piezas de plata y un cinturón'."
,"12":"Pero el hombre le respondió: 'Aunque tuviera en mis manos mil piezas de plata, no pondría la mano encima del hijo del rey. Ante todos nosotros el rey dio esta orden a ti, a Abisaí y a Itaí: Por respeto a mí, no maten al joven Absalón."
,"13":"Aunque yo no lo hubiera dicho, el rey lo habría sabido, y tú te habrías corrido'."
,"14":"Joab le dijo: 'Estoy perdiendo el tiempo contigo'. Y yendo al árbol de donde colgaba Absalón, le clavó personalmente tres dardos en el corazón, cuando aún estaba vivo."
,"15":"Entonces se acercaron diez jóvenes escuderos de Joab y lo remataron."
,"16":"Joab tocó entonces el cuerno para que la tropa se detuviera y dejara de perseguir a Israel."
,"17":"Tomaron a Absalón y lo echaron en una gran fosa en medio del bosque, y amontonaron piedras encima. Los israelitas, por su parte, habían huido, yendo cada cual a su lugar."
,"18":"Absalón se había levantado en vida una estela en el Valle del rey, porque decía: 'No tengo hijos para que se conserve mi nombre'. Le puso su nombre a la piedra que erigió y todavía hoy se la llama 'el monumento de Absalón'."
,"19":"Ajimaas hijo de Sadoc dijo entonces: 'Voy a ir corriendo donde el rey a comunicarle esta buena noticia de que Yavé le ha hecho justicia y lo libró de sus enemigos'."
,"20":"Pero Joab le dijo: 'Tú no serás por ahora el mensajero, pues la noticia no es buena, sino mala, siendo que ha muerto el hijo del rey. Será para otra vez'."
,"21":"Joab dijo entonces al Cusita: 'Anda a anunciar al rey lo que viste'. El cusita se inclinó ante Joab y salió corriendo."
,"22":"Ajimaas hijo de Sadoc retomó la palabra y dijo a Joab: 'No importa lo que pase. Yo también quiero correr tras ese cusita'. Joab le dijo: '¿Para qué vas a correr, hijo, si no obtendrás ninguna recompensa?'"
,"23":"El respondió: 'No importa, quiero ir'. Joab le dijo entonces: 'Muy bien, corre'. Ajimas salió corriendo, tomó el camino de la llanura y adelantó al cusita."
,"24":"David estaba sentado entre las dos puertas y el centinela hacía la ronda por el techo de la puerta encima de las murallas. Levantó la vista y divisó a un hombre que corría solo."
,"25":"El centinela gritó la noticia al rey, quien exclamó: 'Si viene solo, es porque trae buenas noticias'."
,"26":"Mientras se acercaba el hombre, el centinela divisó a otro que corría detrás, llamó al portero y le dijo: 'Hay otro hombre que también viene corriendo solo'. El rey dijo: 'También ese trae buenas noticias'."
,"27":"El centinela replicó: 'Reconozco al primero por su manera de correr: es Ajimaas, hijo de Sadoc'. El rey dijo: 'Es un hombre valioso, seguramente trae una buena noticia'."
,"28":"Cuando Ajimaas estuvo muy cerca, gritó: ¡Salud!' Luego se postró con el rostro en tierra ante el rey. '¡Bendito sea Yavé tu Dios, dijo, porque destruyó a los hombres que se habían rebelado contra el rey mi señor!'"
,"29":"El rey dijo entonces: '¿Está a salvo el joven Absalón?' Ajimaas respondió: 'Cuando tu servidor Joab me envió, vi una gran confusión, pero no supe qué era'."
,"30":"El rey le dijo: 'Ponte allí y aguardemos'. Se puso a un lado y esperó."
,"31":"Detrás de él llegó el cusita, quien dijo: 'Reciba esta buena noticia el rey mi señor: Yavé te hizo hoy justicia, te libró de todos los que se habían alzado contra ti'."
,"32":"El rey preguntó al cusita: '¿Está a salvo el joven Absalón?' El cusita le respondió: 'Que los enemigos del rey mi señor, que todos los que se rebelan contra él para hacerle mal corran la misma suerte que ese joven'."
}`)
	CurrentBook.AddChapter(19, `{
"1":"El rey entonces se conmocionó, subió a la pieza que había encima de la puerta y se puso a llorar. Caminando de uno a otro lado hablaba así: '¡Hijo mío Absalón! ¡Hijo mío! ¡Hijo mío Absalón! ¿Por qué no morí yo en vez de ti? ¡Absalón, hijo mío! ¡Hijo mío!'"
,"2":"Le dijeron a Joab: 'El rey llora y se lamenta por Absalón'."
,"3":"Ese día la victoria se transformó en duelo para todo el pueblo, porque todo el pueblo se dio cuenta de que el rey estaba desesperado a causa de su hijo."
,"4":"Por eso, ese día el pueblo regresó sin ruido a la ciudad, como gente que han huido durante la batalla y que regresan avergonzados pasando inadvertidos."
,"5":"El rey, mientras tanto, se había puesto un velo en la cara y exclamaba en alta voz: '¡Hijo mío Absalón! ¡Absalón hijo mío! ¡Hijo mío!'"
,"6":"Joab entró en la pieza del rey y le dijo: 'Hoy cubres de vergüenza a todos tus servidores. Te salvaron la vida, la vida de tus hijos y de tus hijas, la vida de tus mujeres y de tus concubinas."
,"7":"Pero tú amas a los que te odian y odias a los que te aman. Lo estás demostrando ahora: tus servidores y sus jefes son nada para ti, y si Absalón estuviera ahora con vida y todos nosotros muertos, tú estarías muy feliz."
,"8":"¡Arréglate pues, sal y habla a tus servidores! Lo juro por Yavé, si no sales, nadie quedará a tu lado esta noche, y será para ti una desgracia más grande que todas las que te han sobrevenido desde tu juventud hasta hoy'."
,"9":"Salió entonces el rey y fue a sentarse al lado de la puerta. Cuando se supo que el rey estaba sentado a la puerta, todo el pueblo se presentó ante el rey. La gente de Israel había huido a su casa, "
,"10":"y en todas las tribus de Israel se discutía y se decía: 'El rey nos libró de las manos de todos nuestros enemigos, nos libró de los filisteos y ahora por culpa de Absalón tuvo que huir del país."
,"11":"Ese Absalón al que habíamos consagrado como rey murió en la batalla, entonces, ¿no haremos nada para reponer al rey?'"
,"12":"Todo lo que se decía en Israel llegaba a oídos del rey. El rey dio este encargo a los sacerdotes Sadoc y Ebiatar: 'Transmitan este mensaje a los ancianos de Judá: '¿Por que han de ser ustedes los últimos en reinstalar al rey en su casa?"
,"13":"¿No son ustedes mis hermanos, y mi carne y mis huesos? ¿Por qué van a ser los últimos en reinstaurar al rey?"
,"14":"También dirán a Amasa: ¿No eres tú como mi carne y mis huesos? Maldígame Dios si no te nombro comandante en jefe en vez de Joab'."
,"15":"Con esas palabras se ganó la confianza de todos los hombres de Judá, quienes de común acuerdo enviaron al rey este mensaje: 'Vuelve donde tus servidores'."
,"16":"En vista de eso el rey volvió y llegó al Jordán. La gente de Judá había venido a su encuentro y lo esperaba en Guilgal, para ayudarlo a atravesar el río."
,"17":"Simei hijo de Guera, el benjaminita de Bajurim, bajó junto con la gente de Judá a encontrar al rey,"
,"18":"y lo acompañaban mil hombres de la tribu de Benjamín. También Siba, el mayordomo de la casa de Saúl, había bajado al Jordán junto con sus quince hijos y sus veinte sirvientes al encuentro del rey David,"
,"19":"para ayudar a atravesar a la familia del rey y para cualquier otra cosa que pudiera éste necesitar. Simei hijo de Guera se echó a los pies del rey cuando éste empezaba a atravesar el Jordán. "
,"20":"Dijo al rey: 'Olvide mi señor mi falta, y no me guarde rencor. Olvídese del mal que tu servidor hizo al señor mi rey, el día en que salía de Jerusalén."
,"21":"Tu servidor sabe muy bien que pecó, pero ahora ha sido el primero de toda la casa de Israel en venir al encuentro del rey mi señor'."
,"22":"Abisaí, hijo de Seruya, tomó la palabra y dijo: 'Simei merece la muerte porque maldijo al rey ungido por Yavé'."
,"23":"Pero David respondió: 'No se metan en mis asuntos, hijos de Seruya, ustedes me perjudicarían si muriera ahora alguien en Israel. Sé muy bien que soy ahora rey de todo Israel'."
,"24":"Y el rey le hizo a Simei este juramento: 'No morirás'."
,"25":"También Meribaal, el hijo de Saúl, había bajado para encontrar al rey. Desde el día en que el rey se había ido, hasta ese día en que retornaba en paz, Meribaal no se había lavado ni los pies ni las manos, tampoco se había recortado el bigote ni lavado su ropa."
,"26":"Cuando llegó desde Jerusalén ante el rey, éste le dijo: '¿Por qué no viniste conmigo, Meribaal?'"
,"27":"Respondió: 'Señor rey, mi servidor me engañó. Como tú sabes, yo soy enfermo, y yo le había dicho: 'Ensilla mi burra, la montaré para irme con el rey'."
,"28":"Pero mira cómo me ha calumniado ante ti. Mas mi señor el rey es como el ángel de Yavé, que actúe ahora como mejor le parezca."
,"29":"La familia de mi padre sólo podía esperar del rey mi señor la muerte y sin embargo tú me has puesto entre los que comen a tu mesa. ¿Con qué derecho podría pedirle ahora algo al rey?'"
,"30":"El rey le dijo: '¡Basta de discursos! Desde ahora tú y Siba compartirán las tierras'."
,"31":"Meribaal dijo al rey: 'Que se quede con todo, ya que el rey mi señor ha vuelto a su casa en paz'."
,"32":"Barcilay de Galaad había bajado desde Roglim, había pasado el Jordán con el rey antes de despedirse de éste."
,"33":"Ahora bien, Barcilay era muy anciano, tenía ochenta años; él fue quien aprovisionó al rey mientras estuvo en Majanayim, porque era un hombre muy rico."
,"34":"El rey dijo a Barcilay: 'Quédate conmigo y yo te mantendré en Jerusalén'."
,"35":"Pero Barcilay le respondió: '¿Cuántos días, cuántos años de vida me quedan para que vaya con el rey a Jerusalén?"
,"36":"Tengo ya ochenta años y no distingo bien entre lo que es bueno y lo que es malo, no siento gusto a lo que como o a lo que tomo, ni tampoco oigo la voz de los cantores y de las cantantes. ¿Para qué pues va a ser tu servidor una carga más para el rey mi señor?"
,"37":"Tu servidor te acompañará todavía un poco más allá del Jordán, pero ¿por qué el rey me va a dar tal recompensa?"
,"38":"Permíteme regresar y morir en mi ciudad, cerca de la tumba de mi padre y de mi madre. Pero mi hijo Quinján, tu servidor, acompañará al rey mi señor y tú harás para él lo que estimes conveniente'."
,"39":"El rey le dijo: 'Muy bien, que Quinján se quede conmigo. Haré para él lo que tú quieras y todo lo que me pidas lo haré por ti'."
,"40":"Todo el pueblo atravesó el Jordán después del rey. Este abrazó a Barcilay y lo bendijo, y así regresó a su casa."
,"41":"El rey se dirigió a Guilgal en compañía de Quinján; todo el pueblo de Judá acompañaba al rey, como también la mitad del pueblo de Israel."
,"42":"Fue entonces cuando los hombres de Israel fueron donde el rey y le dijeron: '¿Por qué nuestros hermanos, los hombres de Judá, fueron a buscarte junto con tu familia para ayudarte a atravesar el Jordán siendo que tenías allí a toda tu guardia?'"
,"43":"Los hombres de Judá respondieron a los israelitas: '¿No es el rey de nuestra tribu? ¿Por qué pues se enojan? ¿Acaso el rey nos dio de comer o alguna otra cosa?'"
,"44":"Los israelitas respondieron a los hombres de Judá: 'Nosotros teníamos diez veces más derechos que ustedes sobre el rey. ¿Por qué pues nos despreciaron? Nosotros fuimos los primeros en pedir el regreso de nuestro rey'. Pero los hombres de Judá contestaron con palabras más duras."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Había allí un hombre malvado, llamado Sebá, hijo de Bicri, de la tribu de Benjamín. Tocó el cuerno y proclamó: 'Nada tenemos que ver con David, nada tenemos que esperar del hijo de Jesé. ¡Israel, regresa a tus tiendas!'"
,"2":"Todos los hombres de Israel abandonaron entonces a David y siguieron a Sebá, hijo de Bicri, mientras que los de Judá se quedaron con el rey y lo acompañaron desde el Jordán hasta Jerusalén."
,"3":"David entró nuevamente en su palacio de Jerusalén, ordenó que salieran las diez concubinas que había dejado para que cuidaran el palacio y las puso en una casa bajo vigilancia. Aseguró su manutención pero no se acercó más a ellas. Hasta el día de su muerte estuvieron allí encerradas llevando una vida de viudas."
,"4":"El rey dijo a Amasa: 'Tienes tres días para reunir a los hombres de Judá y presentarte ante mí'."
,"5":"Partió Amasa para reunir a Judá, pero tardó más del plazo que le había fijado el rey."
,"6":"Entonces el rey dijo a Abisaí: 'Sebá, hijo de Bicri, será pronto más peligroso para nosotros que Absalón. Sal al frente de la guardia de tu amo y persíguelo, porque si no podría apoderarse de alguna ciudad fortificada y escapársenos'."
,"7":"Joab, los quereteos, los peleteos y todos los valientes salieron de campaña. A las órdenes de Abisaí dejaron Jerusalén y se lanzaron en persecución de Seba, hijo de Bicri."
,"8":"Estaban cerca de la gran roca que se halla en Gabaón, cuando Amasa se presentó ante ellos. Joab llevaba encima de su ropa un cinturón del cual pendía una espada con su vaina; la espada se salió y cayó."
,"9":"Joab dijo a Amasa: 'Hermano mío, ¿estamos en paz?' Y con la mano derecha tomó la barba de Amasa como para abrazarlo."
,"10":"Amasa no desconfió de la espada que Joab tenía en la mano: Joab se la enterró en el vientre y las tripas se desparramaron por el suelo. No hubo necesidad de un segundo golpe pues Amasa había ya muerto. Entonces Joab y su hermano Abisaí se lanzaron en persecución de Sebá, hijo de Bicri."
,"11":"Le pidieron a uno de los compañeros de Joab que se quedara al lado del cuerpo de Amasa; él decía: '¡Los que están por David y aman a Joab, sigan a Joab!'"
,"12":"Porque Amasa estaba en un charco de sangre en medio del camino y todos los hombres del ejército que llegaban allí se detenían. Al ver eso, el muchacho sacó el cuerpo de Amasa fuera del camino y lo tapó con un manto."
,"13":"Apenas lo hubo retirado del camino, todos corrieron tras Joab y se lanzaron en persecución de Sebá, hijo de Bicri."
,"14":"Sebá recorrió todas las tribus de Israel hasta Abel-Bet-Maacá. Los hombres del clan de Bicri se habían reunido y se habían ido con él."
,"15":"Joab sitió a Sebá en Abel-Bet-Maacá, levantaron un terraplén para alcanzar la ciudad que llegaba hasta la muralla. Cuando todo el ejército de Joab cavaba para hacer caer la muralla,"
,"16":"una mujer criteriosa que estaba en la ciudad exclamó: '¡Oigan, oigan! Digan a Joab que se acerque hasta acá, porque quiero hablarle'."
,"17":"Joab se acercó y la mujer le dijo: '¿Eres tú Joab?' El respondió: 'Sí, yo soy'. Ella le dijo: 'Escucha lo que tengo que decirte'. Respondió: 'Escucho'."
,"18":"Ella le dijo: 'Antes era costumbre decir: En Abel y en Dan les enseñarán las antiguas costumbres de Israel;"
,"19":"¿y tú intentas destruir una ciudad que es madre de ciudades de Israel? ¿Por qué vas a destruir la herencia de Yavé?'"
,"20":"Joab respondió: 'De ninguna manera quiero yo destruir ni arruinar."
,"21":"Solamente buscamos a Sebá, hijo de Bicri, hombre de la montaña de Efraín, el que se ha rebelado contra el rey David. Entréguenmelo y me alejaré de la ciudad'. La mujer respondió a Joab: 'Muy bien, te tiraremos su cabeza por encima de la muralla'. "
,"22":"La mujer supo expresarse y convenció a los habitantes de la ciudad; le cortaron la cabeza a Sebá, hijo de Bicri, y se la tiraron a Joab. Este tocó inmediatamente el cuerno: se dispersaron y cada cual se volvió a su hogar. Joab por su parte regresó a Jerusalén donde el rey."
,"23":"Joab fue el comandante en jefe de todo el ejército de Israel, Benaías, hijo de Yoyada, mandaba los peleteos y quereteos."
,"24":"Adoram era supervisor de los trabajos impuestos; Josafat, hijo de Ajilud, era el archivero;"
,"25":"Siya era secretario; los sacerdotes eran Sadoc y Ebiatar;"
,"26":"Isá el Yairita, también era sacerdote de David."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Hubo bajo el reinado de David una hambruna que duró tres años. David consultó a Yavé y éste le respondió: 'Saúl y su familia tienen pendiente una deuda de sangre porque Saúl dio muerte a los gabaonitas'."
,"2":"Estos gabaonitas no eran israelitas, pues descendían de los antiguos amoreos, pero los israelitas se habían comprometido con ellos con juramento. A pesar de eso, Saúl había tratado de eliminarlos llevado por su celo por Israel y Judá. David convocó entonces a los gabaonitas, "
,"3":"y les dijo: '¿Qué tenemos que hacer como reparación para que ustedes bendigan la herencia de Yavé?'"
,"4":"Los gabaonitas le respondieron: 'No tenemos ningún problema de plata o de oro ni con Saúl ni con su familia, ni tampoco queremos que haya más víctimas en Israel'. David les dijo: 'Haré por ustedes lo que me digan'."
,"5":"Respondieron al rey: 'Un hombre nos masacró, quería destruirnos y eliminarnos del territorio de Israel."
,"6":"Entréguennos ahora a siete de sus hijos para que los ahorquemos delante de Yavé en Gabaón, en el cerro de Yavé'. El rey les dijo: 'Se los entregaré'."
,"7":"No tomó en cuenta sin embargo a Meribaal, el hijo de Jonatán, hijo de Saúl, debido al juramento que había hecho a Jonatán, hijo de Saúl, ante Yavé."
,"8":"Rispá, hija de Ayía, había dado dos hijos a Saúl, Armoní y Meribaal. Merab, hija de Saúl, había dado a Adriel, hijo de Barcilay de Mejola, cinco hijos."
,"9":"David los mandó apresar y se los entregó a los gabaonitas, quienes los ahorcaron en el cerro ante Yavé; los siete murieron juntos. Fueron ejecutados el primer día de la cosecha, al comienzo de la cosecha de la cebada. "
,"10":"Rispá, hija de Ayía, tomó un saco y lo extendió para ella sobre una roca del cerro, y desde el principio de la cosecha hasta la época de las primeras lluvias, impidió que se acercaran a ellos de día las aves del cielo y de noche las fieras salvajes."
,"11":"Comunicaron a David lo que Rispá, hija de Ayía y concubina de Saúl, estaba haciendo."
,"12":"David fue entonces a buscar los huesos de Saúl y de su hijo Jonatán que estaban en Yabés de Galaad. Pues los filisteos habían colgado sus cuerpos en la plaza de Bet-seán después de su victoria sobre Saúl en Guelboé, pero la gente de Yabés de Galaad se los había robado."
,"13":"David trajo pues los huesos de Saúl y de Jonatán, luego juntó los huesos de los que habían sido ahorcados,"
,"14":"y enterraron los huesos de Saúl en la tumba de su padre Quis, en Selá, en territorio de Benjamín. Allí también sepultaron los huesos de su hijo Jonatán y los de los ahorcados. Se hizo todo lo que el rey había ordenado, después de lo cual Dios tuvo compasión del país."
,"15":"Se reinició la guerra entre los filisteos e Israel. David bajó con su guardia para pelear con los filisteos."
,"16":"En un momento en que David estaba cansado, trató de matarlo un descendiente de Rafá, llamado Isbó-Benob. Llevaba una lanza de bronce que pesaba trescientos siclos (tres kilos y medio) y tenía además una espada nueva."
,"17":"Pero Abisaí, hijo de Seruya, fue a auxiliar a David, hirió al filisteo y lo mató. Los hombres de David le insistieron entonces: 'No vengas más a la guerra con nosotros, pues no debe apagarse la lámpara de Israel'."
,"18":"Después de eso hubo todavía otra batalla con los filisteos; en esa ocasión Sibecaí de Jusá dio muerte a un descendiente de Rafá, llamado Saf."
,"19":"Se reinició una vez más la guerra con los filisteos en Gob, y Eljanán, hijo de Yair, de Belén, mató a Goliat de Gat; el astil de su lanza era como un palo de un telar."
,"20":"Hubo además otro combate en Gat; allí se encontraba un hombre alto que tenía seis dedos en cada mano y seis dedos en cada pie, en total veinticuatro dedos. Este también era descendiente de Rafá."
,"21":"Como insultara a Israel, le dio muerte Jonatán, hijo de Simea, hermano de David."
,"22":"Los cuatro eran hombres de Gat descendientes de Rafá. Fueron muertos por las manos de David y de sus guardias."
}`)
	CurrentBook.AddChapter(22, `{
"1":"David dedicó a Yavé las palabras de este cántico, el día en que Yavé lo libró de las manos de todos sus enemigos y de las manos de Saúl."
,"2":"Yavé es mi roca, y mi fortaleza, mi salvador y mi Dios."
,"3":"El es mi roca, en él me refugio. Es mi escudo, mi salvación, mi ciudadela y mi refugio: mi salvador me salva de la violencia."
,"4":"Le oro a Yavé que es digno de confianza,y me veo libre de mis enemigos."
,"5":"Las olas de la muerte me envolvían, los torrentes devastadores me aterraban,"
,"6":"en las redes del mundo infernal estaba preso, veía delante de mí las trampas de la muerte:"
,"7":"y en mi angustia clamé a Yavé, le grité a mi Dios. Mi grito llegó hasta su presencia, desde su templo escuchó mi voz."
,"8":"Tembló entonces la tierra, se estremeció, bambolearon los cimientos del cielo, temblaban al sentir su cólera."
,"9":"Salía vapor de sus narices, y de su boca, un fuego devorador, un chorro de carbones encendidos."
,"10":"Inclinó los cielos y bajó, una nube oscura tenía bajo sus pies."
,"11":"Voló, montado en un querubín, transportado en alas del viento."
,"12":"A su alrededor una cortina de tinieblas, nubes aborregadas formaban su tienda."
,"13":"Un resplandor iba delante de él, brasas ardientes lo alumbraban."
,"14":"Tronó Yavé desde lo alto, hizo resonar su voz el Altísimo."
,"15":"Disparó sus flechas, dispersó a sus enemigos, el rayo los llenó de pavor."
,"16":"Apareció el fondo del mar, desnudas quedaron las bases de la tierra, ante la amenaza de Yavé, al estremecerlos el soplo de sus narices."
,"17":"De lo alto extendió la mano y me agarró, y me sacó de las aguas profundas."
,"18":"Me libró de mis terribles enemigos, de enemigos más fuertes que yo."
,"19":"Me asaltaron el día que me iba mal, pero Yavé fue mi protector."
,"20":"Me sacó del peligro, me salvó porque me ama."
,"21":"Yavé me trató según mis méritos, limpias son mis manos, y él me lo paga."
,"22":"He ido por los caminos de Yavé, y no hice el mal lejos de mi Dios."
,"23":"Ante mí estaban todas sus sentencias, jamás me apartaba de sus leyes."
,"24":"Estaba ante él sin ni un reproche, me cuidaba de cometer cualquier falta."
,"25":"Yavé me recompensa según mis méritos, ha visto mi pureza con sus ojos."
,"26":"Con el que es bueno tú eres bueno, con el que es perfecto, eres perfecto."
,"27":"Eres recto con el que es recto, pero pillas al hombre si es tramposo."
,"28":"Acudes a ayudar a un pueblo humilde, y humillas a los ojos altaneros."
,"29":"¡Oh Yavé, tú eres mi luz!,El, Yavé, ilumina mis tinieblas."
,"30":"Contigo me lanzo contra los asaltantes, con mi Dios yo salto la muralla."
,"31":"El camino de Dios es perfecto, la palabra de Dios es infalible. El es un escudo para los que en él se refugian."
,"32":"¿Quién es Dios fuera de Yavé?,¿Quién es la roca sino nuestro Dios?"
,"33":"Dios es mi asilo y mi fortaleza, me abre un camino real."
,"34":"Asemeja mis pies a los de la cierva, y me mantiene de pie en las alturas."
,"35":"Adiestra mis manos para el combate, y mis brazos tensan el arco de bronce."
,"36":"Tú me das tu escudo de salvación, y tus favores me agrandan."
,"37":"Me haces que alargue el paso,y mis tobillos no van a flaquear."
,"38":"Persigo a mis enemigos, los aplasto, no vuelvo sin haberlos derrotado."
,"39":"Rotos, aniquilados, no se levantan más, y caen bajo mis pies."
,"40":"Me llenas de fuerza para el combate, doblegas mis enemigos bajo mis pies."
,"41":"Haces que mis adversarios den la espalda, aniquilo a todos los que me odian."
,"42":"Aunque griten, nadie los salvará, Yavé ya no les responde."
,"43":"Los muelo como el polvo de la tierra, los pisoteo como el barro del camino."
,"44":"Me libras de las demandas de mi pueblo. Me pones a la cabeza de las naciones, pueblos que no conocía me obedecen."
,"45":"Los extranjeros buscan mi amistad, apenas oyen mi voz, me obedecen."
,"46":"Sin fuerzas están los extranjeros, tras sus fortalezas se atrincheran."
,"47":"¡Viva Yavé! ¡Bendita sea mi roca!,¡Alabado sea el Dios que me salva!"
,"48":"¡Oh Dios, me concedes el desquite, y colocas los pueblos a mis pies!"
,"49":"Tú me libras de todos mis enemigos, del agresor me haces el amo, tú me liberas de los violentos."
,"50":"Por eso te alabo entre las naciones,y quiero cantar a tu Nombre."
,"51":"Le da a su rey victoria tras victoria, y sigue con sus favores a su ungido, a David y a su raza para siempre'."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Estas fueron las últimas palabras de David: 'Oráculo de David, hijo de Jesé, oráculo del que fue puesto en lo más alto, del hombre que consagró el Dios de Jacob, del que cantaba los salmos de Israel."
,"2":"Por mí habló el espíritu de Yavé, y en mi boca reside su palabra."
,"3":"Habló el Dios de Israel, dijo la roca de Israel: Un justo que es conductor de hombres, que los guía con el temor de Dios,"
,"4":"es luz de la mañana al caer el sol, es como una mañana sin nubes,en que brilla tras la lluvia el césped de la tierra."
,"5":"¿No es eso mismo mi casa para Dios, para el que me reservó una alianza eterna,bien ordenada y bien garantizada?,¿No hará que germine mi salvación, todo lo que yo he deseado?"
,"6":"La gente sin fe ni ley es sólo espinas, que se tiran, no se toman con la mano."
,"7":"El que quiere atreverse con ellas, se arma de un fierro o de un astil de lanza, se queman, se consumen con el fuego'."
,"8":"Estos son los nombres de los valientes que estuvieron al servicio de David: Isbaal el jacmonita, el jefe de los 'Tres', quien con su lanza ultimó de una vez a ochocientos hombres."
,"9":"Después de él, Eleazar hijo de Dodó el Ajojita, quien era uno de los tres valientes; estuvo con David en Pasdamín cuando los filisteos se concentraron para pelear. Los israelitas se retiraban,"
,"10":"pero él les hizo frente; peleó con los filisteos hasta quedar con la mano tan cansada que se le crispó en la espada. Ese día Yavé otorgó una gran victoria. El ejército volvió inmediatamente, pero no tuvo más que despojar a los enemigos."
,"11":"Después de él, Samma hijo de Ela, el jararita. Los filisteos se habían reunido en Leji; había allí un campo de lentejas y el ejército dio la espalda ante los filisteos."
,"12":"Entonces él se puso en medio del campo, se abrió paso y derrotó a los filisteos. Yavé concedió una gran victoria."
,"13":"Entre los 'Treinta' hubo tres que bajaron a reunirse con David en tiempo de la cosecha, en la gruta de Adulam, cuando una compañía de filisteos acampaba en el valle de los Refaim;"
,"14":"David estaba en el refugio y había un destacamento de filisteos en Belén."
,"15":"David tuvo un deseo y dijo: '¿Quién pudiera traerme agua para tomar del pozo que está a la entrada de Belén?'"
,"16":"Los tres valientes se abrieron paso a través del campamento de los filisteos, sacaron agua del pozo que está a la entrada de Belén, la llevaron y se la pasaron a David. Pero éste no quiso tomarla y la derramó como ofrenda ante Yavé."
,"17":"Declaró: 'Líbreme Dios de tomar esta agua que es la sangre de esos hombres que arriesgaron su vida'. No quiso pues tomarla. Eso fue lo que hicieron esos tres valientes."
,"18":"El jefe de los 'Treinta' era Abisaí, hermano de Joab e hijo de Seruya. Se hizo famoso entre los 'Treinta' cuando, blandiendo su lanza, dio muerte a trescientos."
,"19":"Fue el más célebre de los 'Treinta' y llegó a ser su jefe, (pero no alcanzó el nivel de los 'Tres')."
,"20":"Benaías, hijo de Yoyada, era un valiente, autor de numerosas hazañas, venía de Cabuel. El fue quien derrotó a los dos héroes de Moab; un día de nieve bajó a un pozo para matar allí a un león."
,"21":"También derrotó a un egipcio muy alto; el egipcio tenía en su mano una lanza, Benaías avanzó contra él con un garrote. Le quitó la lanza de la mano al egipcio y lo mató con su propia lanza."
,"22":"Esas fueron las hazañas de Benaías, hijo de Yoyada. Se hizo famoso entre los treinta valientes"
,"23":"y fue aún más célebre que los 'Treinta', (pero no se lo contó entre los 'Tres'). David lo hizo entrar en su guardia personal."
,"24":"Azael, hermano de Joab, formaba parte de los 'Treinta'."
,"25":"Lo mismo Eljanán, hijo de Dodó, de Belén."
,"26":"Jelés de Bet-Pelé, Ira, hijo de Iqués de Tecoa,"
,"27":"Abiecer de Anatot, Sibecai de Jusá,"
,"28":"Salmón de Ajoj, Majrai de Netofa,"
,"29":"Jeled, hijo de Baana, de Netofa, Itaí, hijo de Ribaí, de Guibea de Benjamín,"
,"30":"Benaías de Pireatón, Jiddaí de los Torrentes de Gaas,"
,"31":"Abibaal de Betaaraba, Azmavet de Bajurim,"
,"32":"Eliajba de Saalbón, Yasén de Guimzo, Jonatán,"
,"33":"hijo de Samma, de Jarar, Ajiam, hijo de Sarar de Jarar,"
,"34":"Elifelet, hijo de Ajasbaí, de Betmaacá, Eliam, hijo de Ajitofel, de Guiló,"
,"35":"Jesraí de Carmelo, Paraí de Arab,"
,"36":"Yiguel, hijo de Natán de Soba, Barú de Gad,"
,"37":"Selec, el amonita, Najrai de Beerot, quien era escudero de Joab, hijo de Seruya,"
,"38":"Ira de Yattir, Gareb de Yattir,"
,"39":"Urías el hitita. En total treinta y siete."
}`)
	CurrentBook.AddChapter(24, `{
"1":"De nuevo se encendió contra Israel la cólera de Yavé, quien impulsó a David a causar su desgracia. 'Anda, le dijo, y haz el censo de Israel y Judá'."
,"2":"El rey dijo a Joab, el jefe del ejército, que estaba con él: 'Recorre todas las tribus de Israel desde Dan hasta Bersebá. Cuenta al pueblo, así sabré cuántos son."
,"3":"Joab dijo al rey: 'Que Yavé tu Dios multiplique cien veces al pueblo, y que lo vean los ojos de mi señor el rey. ¿Pero por qué el rey mi señor quiere tal cosa?'"
,"4":"Pero como la palabra del rey era una orden para Joab y los jefes del ejército, salió de la casa del rey junto con los jefes del ejército para ir a hacer el censo de la población de Israel."
,"5":"Atravesaron el Jordán y acamparon al sur de Aroer; la ciudad está en medio del Torrente de Gad. Continuaron luego hacia Yazer,"
,"6":"después llegaron a Galaad, al territorio de los hititas, a Cadés y de allí a Dan. Recorrieron los alrededores en dirección a Sidón,"
,"7":"llegaron a la fortaleza de Tiro y atravesaron las ciudades de los hivitas y de los cananeos. Luego salieron hacia Bersebá, en el Neguev de Judá."
,"8":"Recorrieron pues todo el país y regresaron a Jerusalén al cabo de nueve meses y veinte días."
,"9":"Joab le entregó al rey el número exacto de la población: Israel contaba con ochocientos mil hombres de armas capaces de manejar la espada, y Judá, con quinientos mil."
,"10":"Pero en seguida el corazón de David se puso a palpitar; ¡había censado al pueblo! Le dijo a Yavé: 'Cometí un grandísimo pecado. Perdona, Yavé, ahora, el pecado de tu servidor: actué como un tonto'."
,"11":"Al día siguiente, mientras David se levantaba, la palabra de Yavé fue dirigida al profeta Gad, el vidente de David:"
,"12":"Ve a transmitir a David esta palabra de Yavé: Te propongo tres cosas, elige una y la llevaré a cabo'."
,"13":"Gad se presentó ante David y le dijo: '¿Qué elegirías: tres años de hambruna en todo el país, tres meses huyendo de un enemigo que te persigue, o tres días de peste en el país? Piénsalo, tú me dirás qué respuesta debo llevar al que me envió'."
,"14":"David dijo a Gad: 'Estoy en un gran aprieto, pero es mejor para nosotros caer en las manos de Yavé, porque él es rico en misericordia, antes que caer en manos de los hombres'."
,"15":"Y David escogió la peste. Era el tiempo de la cosecha del trigo, y Yavé envió la peste a Israel desde esa mañana hasta el plazo fijado. El flagelo golpeó al pueblo y murieron setenta mil hombres desde Dan hasta Bersebá."
,"16":"El ángel exterminador extendió su mano hacia Jerusalén, pero Yavé se arrepintió del mal y dijo al ángel exterminador: '¡Detente! ¡Retira tu mano!' El ángel de Yavé estaba en ese momento cerca de la era de Arauna el jebuseo."
,"17":"Cuando David vio al ángel que castigaba a la población, se volvió hacia Yavé y le dijo: 'Yo pequé, yo cometí esa gran falta, pero ¿qué hizo el rebaño? Que tu mano se abata sólo sobre mí y la casa de mi padre'."
,"18":"Ese día el profeta Gad fue a ver a David y le dijo: 'Sube y levanta un altar a Yavé en la era de Arauna el jebuseo'."
,"19":"David subió entonces, de acuerdo a la palabra de Gad, tal como Yavé lo había ordenado."
,"20":"Ahora bien Arauna estaba mirando, vio al rey y a sus servidores que venían donde él. Arauna salió y se postró con el rostro en tierra delante del rey,"
,"21":"luego le preguntó: '¿Por qué el rey mi señor viene a la casa de su sirviente?' David le respondió: 'Vengo a comprarte la era para levantar allí un altar a Yavé, pues así cesará el flagelo que se abate sobre el pueblo'."
,"22":"Arauna dijo entonces a David: 'Que el rey mi señor tome y ofrezca todo lo que estime conveniente. Aquí están los bueyes para el holocausto, la rastra y los yugos de los bueyes proporcionarán la leña."
,"23":"Todo eso, señor, se lo da Arauna al rey'. Arauna le dijo además: 'Que Yavé tu Dios acepte tu sacrificio'. Pero el rey respondió a Arauna: "
,"24":"'No, quiero pagarte su justo precio, no quiero ofrecer a Yavé mi Dios holocaustos que nada me cuestan'. David compró entonces la era y los bueyes por cincuenta siclos de plata."
,"25":"David levantó allí un altar a Yavé y ofreció en él holocaustos y sacrificios de comunión. Entonces Yavé tuvo piedad de Israel y se apartó la peste de Israel."
}`)

}
func ES_LBL_LoadVHEDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"El primer año de Ciro, rey de Persia, se cumplió la palabra de Yavé proclamada por Jeremías: Yavé despertó el espíritu de Ciro, rey de Persia. Ciro mandó proclamar, tanto de viva voz como por escrito, en su reino, lo siguiente:"
,"2":"'Así habla Ciro, rey de Persia: Yavé, el Dios de los Cielos, me ha dado todos los reinos de la tierra; y ahora me encarga que reconstruya su templo en Jerusalén de Judá."
,"3":"Dios esté con los que pertenecen a su pueblo y que subirán a Jerusalén de Judá para reconstruir el Templo de Yavé Dios de Israel, el Dios que está en Jerusalén."
,"4":"En todo lugar donde se encuentren estos sobrevivientes, que la gente del lugar les proporcione plata, oro, bienes, ganado y también ofrendas voluntarias para el Templo de Dios, que está en Jerusalén.'"
,"5":"Entonces se pusieron en camino los jefes de familia de Judá y de Benjamín, los sacerdotes y los levitas, y todos aquellos a los que Dios había abierto el espíritu para ir a reconstruir el Templo de Yavé en Jerusalén."
,"6":"Todos los que los rodeaban les entregaron su ayuda de diversas formas: dándoles plata, oro, bienes, ganado, gran cantidad de objetos preciosos, además de las ofrendas voluntarias."
,"7":"El rey Ciro tomó los objetos del Templo de Yavé que Nabucodonosor había traído de Jerusalén y que había puesto en el Templo de su dios."
,"8":"Ciro rey de Persia los mandó retirar por intermedio del tesorero Mitrídates, quien los contó delante de Sesbasar, príncipe de Judá."
,"9":"Esta es la lista: 30 bandejas de oro, 1.000 bandejas de plata, 29 cuchillos,"
,"10":"30 copas de oro, 410 copas de plata de mediana calidad, y 1.000 otros objetos."
,"11":"En total había 5.400 objetos de oro y plata; Sesbasar se llevó todo eso cuando volvieron los desterrados desde Babilonia a Jerusalén."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Estas son las personas de la provincia de Judá que regresaron del cautiverio; había sido deportados a Babilonia por Nabucodonosor, rey de Babilonia. Regresaron a Jerusalén y a Judá cada cual a su ciudad."
,"2":"Llegaron junto con Zorobabel, Josué, Nehemías, Seraías, Relaías, Mardoqueo, Bilsán, Mispar, Bigvay, Rejum y Baana. Lista de los hombres del pueblo de Israel: "
,"3":"los hijos de Pareós: 2.172;"
,"4":"los hijos de Sefataías: 372; los hijos de Ará: 775;"
,"6":"los hijos de Pajat-Moab (hijos de Josué y Joab): 2.812;"
,"7":"los hijos de Elam: 1.254; los hijos de Zatú: 945;"
,"9":"los hijos de Zacay: 760;"
,"10":"los hijos de Bani: 642;"
,"11":"los hijos de Belay: 623;"
,"12":"los hijos de Azgad: 1.222; los hijos de Adonicam: 666; los hijos de Bigvay: 2.056;"
,"15":"los hijos de Adín: 454;"
,"16":"los hijos de Ater (Jejizquía): 98;"
,"17":"los hijos de Besay: 323;"
,"18":"los hijos de Yora: 112;"
,"19":"los hijos de Yasum: 223;"
,"20":"los hijos de Gibar: 95;"
,"21":"los hijos de Belén: 123;"
,"22":"los hombres de Netofa: 56;"
,"23":"los hombres de Anatot: 128;"
,"24":"los hijos de Azmavet: 42;"
,"25":"los hijos de Quiriat-Yearim, Quefira y Beerot: 743;"
,"26":"los hijos de Ramá y Gueba: 621;"
,"27":"los hombres de Micmas: 122;"
,"28":"los hombres de Betel y de Ay: 223;"
,"29":"los hijos de Nebo: 52;"
,"30":"los hijos de Magbis: 156;"
,"31":"los hijos de otro Elam: 1.254;"
,"32":"los hijos de Yarim: 320;"
,"33":"los hijos de Lod, Yadid y Ono: 725;"
,"34":"los hijos de Jericó: 345;"
,"35":"los hijos de Senar: 3.630."
,"36":"Los sacerdotes: los hijos de Jedaías (la casa de Josué): 973;"
,"37":"los hijos de Imer: 1.052;"
,"38":"los hijos de Pasejar: 1.247;"
,"39":"los hijos de Yarim: 1.017."
,"40":"Los levitas: los hijos de Josué (Cadmiel, hijos de Hodavía): 74."
,"41":"Los cantores: los hijos de Asaf: 128."
,"42":"Los hijos de los porteros: los hijos de Salum, los hijos de Ater, los hijos de Talmán, los hijos de Acub, los hijos de Atita, los hijos de Sobay: en total 139."
,"43":"Los sirvientes: los hijos de Sijá, los hijos de Asufa, los hijos de Tabaot,"
,"44":"los hijos de Querós, los hijos de Sía, los hijos de Padón,"
,"45":"los hijos de Lebana, los hijos de Agaba, los hijos de Acub,"
,"46":"los hijos de Agab, los hijos de Samlay, los hijos de Janán,"
,"47":"los hijos de Guidel, los hijos de Resin, los hijos de Necoda, los hijos de Gazam,"
,"49":"los hijos de Uza, los hijos de Pasea, los hijos de Besay,"
,"50":"los hijos de Asna, los hijos de los Meunitas, los hijos de los Nefasitas,"
,"51":"los hijos de Babuc, los hijos de Jacufa, los hijos de Jarur,"
,"52":"los hijos de Baslut, los hijos de Mejida, los hijos de Jarsa,"
,"53":"los hijos de Barcos, los hijos de Sisra, los hijos de Tema,"
,"54":"los hijos de Nesia, los hijos de Jatifa."
,"55":"Los hijos de los esclavos de Salomón: los hijos de Sotay, los hijos de Ha-Soferet, los hijos de Peruda,"
,"56":"los hijos de Yaaba, los hijos de Darcón, los hijos de Guidel,"
,"57":"los hijos de Sefatías, los hijos de Jatil, los hijos de Poqueret-Ja-Sabayim, los hijos de Amí."
,"58":"El total de sirvientes e hijos de esclavos de Salomón: 392."
,"59":"Los sobrevivientes que venían de Tel-Mela, de Tel-Jarsa, de Querub, de Addán y de Immner no pudieron decir si sus familias y sus clanes eran de Israel:"
,"60":"; los hijos de Delaías, los hijos de Tobías, los hijos de Nacoda: 652."
,"61":"Entre los hijos de los sacerdotes, los hijos de Yobaías, los hijos de Jacós, los hijos de Barcilay -ese hombre había adoptado el nombre de Barcilay de Galaad con una de cuyas hijas se había casado-"
,"62":"Todos esos buscaron sus listas genealógicas, pero como no las encontraron, fueron descartados del sacerdocio como impuros."
,"63":"El gobernador les prohibió que comieran alimentos sagrados hasta que un sacerdote solucionara el problema por el Urim y el Tumim."
,"64":"Toda la asamblea era de 42.360 personas,"
,"65":"sin contar a los esclavos y a los sirvientes en número de 7.357; también había 200 cantores entre hombres y mujeres, 736 caballos, 245 mulas,"
,"67":"435 camellos y 6.720 burros."
,"68":"Algunos jefes de familia al llegar al Templo de Yavé en Jerusalén hicieron ofrendas voluntarias para el Templo de Yavé, para que se lo reconstruyera en el mismo lugar."
,"69":"Para esa obra depositaron en el tesoro, según los medios de cada cual, 61.000 piezas de oro; 5.000 piezas de plata y 100 túnicas para los sacerdotes."
,"70":"Los sacerdotes, los levitas y una parte del pueblo se quedaron a vivir en Jerusalén; los cantores, los porteros, los sirvientes y todos los demás israelitas se fueron a vivir a su ciudad."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Los israelitas ya estaban en sus ciudades, cuando, al llegar el séptimo mes, el pueblo se reunió como un solo hombre en Jerusalén."
,"2":"Josué hijo de Yosadac y sus hermanos sacerdotes, Zorobabel hijo de Sealtiel y sus hermanos, se juntaron para reconstruir el altar del Dios de Israel y ofrecer en él holocaustos tal como está escrito en la ley de Moisés, el hombre de Dios."
,"3":"A pesar del miedo a los paganos, se reconstruyó el altar en el mismo lugar y se ofrecieron en él holocaustos en honor de Yavé: el holocausto de la mañana y el de la tarde."
,"4":"Se celebró la fiesta de los Tabernáculos tal como está escrito, con el número de holocaustos determinados para cada día."
,"5":"Luego, además del holocausto perpetuo, se ofrecieron los que estaban previstos para los sábados, las lunas nuevas y todas las fiestas en honor de Yavé; se ofrecieron también los holocaustos que cada uno con toda libertad quería ofrecer a Yavé."
,"6":"Se comenzó a ofrecer holocaustos a Yavé el primer día del séptimo mes, cuando aún no se habían puesto los cimientos del santuario de Yavé."
,"7":"Dieron dinero a los que trabajaban la piedra y a los carpinteros; víveres, bebidas y aceite a la gente de Sidón y de Tiro para que trajesen madera de cedro. Debían transportarla por mar desde el Líbano hasta Yafo, según la autorización dada por Ciro, rey de Persia."
,"8":"Al segundo año de su llegada al Templo de Dios en Jerusalén, el segundo mes, Zorobabel hijo de Sealtiel y Josué hijo de Yosadac, sus demás hermanos, los sacerdotes, los levitas y todos los que habían regresado del cautiverio a Jerusalén, comenzaron la obra. Encargaron a los levitas de veinte años para arriba que dirigieran la obra del Templo de Yavé."
,"9":"Josué, sus hijos y sus hermanos, Cadmiel y sus hijos, los hijos de Yodabías, se hicieron todos cargo de la dirección de los que trabajaban en el Templo de Dios."
,"10":"Cuando los obreros pusieron los cimientos del Templo de Yavé, se presentaron los sacerdotes revestidos de túnicas con sus trompetas, los levitas hijos de Azaf con sus címbalos, para celebrar a Yavé tal como lo había ordenado David, rey de Israel."
,"11":"Entonaron este canto para alabar y celebrar a Yavé: '¡Porque es bueno, porque eterno es su amor para con Israel!' Todo el pueblo lanzaba grandes aclamaciones, y daba gracias a Yavé porque se habían puesto los cimientos del Templo de Yavé."
,"12":"Muchas personas de edad, sacerdotes y levitas, jefes de familia que habían conocido el primer templo, lloraban abundantemente mientras se ponían ante su vista los cimientos, pero muchos otros dejaban escapar sus alegres exclamaciones."
,"13":"No se podía distinguir entre el ruido de las aclamaciones alegres y el del llanto del pueblo; eran tales las aclamaciones que se podían oír desde lejos."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Los adversarios de Judá y de Benjamín supieron que los que habían vuelto del cautiverio estaban construyendo un templo a Yavé Dios de Israel."
,"2":"Fueron pues a ver a Zorobabel y a los jefes de familia y les dijeron: 'Vamos a construirlo junto con ustedes pues, al igual que ustedes, invocamos a su Dios y le ofrecemos sacrificios desde la época de Asarjadón, rey de Asiria, quien nos desterró para acá'."
,"3":"Zorobabel, Josué y los demás jefes de familia de Israel les respondieron: '¡No tenemos que construir junto con ustedes un Templo para nuestro Dios. Nosotros solos construiremos para Yavé Dios de Israel, tal como nos lo ordenó Ciro, rey de Persia!'"
,"4":"La gente del país trató entonces de desanimar al pueblo de Judá y de amenazarlo para impedirle que construyera."
,"5":"Y mientras estuvo Ciro, rey de Persia, y hasta el reinado de Darío rey de Persia, pagaron a unos consejeros para que hicieran fracasar el proyecto del pueblo de Judá."
,"6":"Al comienzo del reinado de Jerjes, mandaron cartas para acusar a los habitantes de Judá y de Jerusalén."
,"7":"En tiempos de Artajerjes, Bislam, Mitrídates, Tabeel y sus demás colegas, le escribieron a Artajerjes rey de Persia para acusarlos de nuevo; el texto del documento estaba escrito en arameo, pero lo habían traducido."
,"8":"Luego el gobernador Rejum y el secretario Simsay escribieron una carta en contra de Jerusalén destinada al rey Artajerjes:"
,"9":"'El gobernador Rejum, el secretario Simsay, y todos sus demás colegas, los jueces y los embajadores, los funcionarios de Persia, la gente de Uruc, de Babilonia y de Susa (es decir, los Elamitas)"
,"10":"y los demás pueblos que el gran y célebre Asurbanipal desterró e instaló en las ciudades de Samaría y en las de la provincia que está más allá del Eufrates, escriben esto'."
,"11":"Esta es la copia de la carta que mandaron: 'Al rey Artajerjes, tus servidores, los hombres que están más allá del Río:"
,"12":"Debe saber el rey que los judíos que se vinieron de tu lado hasta nosotros llegaron a Jerusalén. Reconstruyeron esa ciudad rebelde y malvada, están levantando de nuevo las murallas y reparando sus cimientos."
,"13":"Pero ha de saber el rey que si llegan a reconstruir la ciudad y levantan nuevamente sus murallas, no pagarán más tributos, impuestos ni peajes, y por último los reyes saldrán perdiendo."
,"14":"Como nosotros comemos la sal del palacio real, no podemos aguantar viendo el daño que se le hará al rey; es por eso que enviamos esta información al rey."
,"15":"Que se averiguë en los libros en que están guardadas las memorias de tus padres. Allí, en el libro de las memorias, descubrirás y te enterarás que esa ciudad es rebelde y que ha provocado perjuicio a los reyes y a las provincias, y que en los tiempos antiguos nacieron allí muchas revueltas; a eso se debe que haya sido destruida."
,"16":"Le hacemos saber al rey que si esa ciudad es reconstruida, si son levantadas de nuevo sus murallas, ya no tendrá más territorios a este lado del Río'."
,"17":"El rey les mandó esta respuesta: '¡Al gobernador Rejum, al secretario Simsay, y a los otros colegas suyos que viven en Samaría y en la región más allá del Río, salud!"
,"18":"La carta que me enviaron ha sido leída delante de mí punto por punto."
,"19":"Se han hecho averiguaciones por orden mía y se ha comprobado que desde tiempos antiguos esa ciudad se ha alzado contra los reyes; se han visto allí rebeliones y revueltas."
,"20":"Poderosos reyes reinaron en Jerusalén en la provincia más allá del Río, a los que se les pagaba tributo, impuestos y peaje."
,"21":"Por eso, ordenen que se detenga el trabajo de esa gente; esa ciudad no debe ser reconstruida hasta una nueva orden de mi parte."
,"22":"No descuiden nada en este asunto, no sea que el mal siga en aumento con perjuicio para los reyes'."
,"23":"Se leyó la copia de la carta del rey Artajerjes delante de Rejum, del secretario Simsay y de sus colegas. Apenas se terminó la lectura, salieron para Jerusalén y obligaron a los judíos, por medio de la fuerza y de la violencia, a parar los trabajos."
,"24":"Así fue como se suspendieron los trabajos del Templo de Dios en Jerusalén y así se siguió hasta el segundo año del reinado de Darío, rey de Persia."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Los profetas Ageo y Zacarías hijo de Iddo, profetizaron para los judíos de Judá y de Jerusalén en nombre del Dios de Israel que estaba con ellos."
,"2":"Entonces Zorobabel hijo de Sealtiel y Josué hijo de Yosadac se decidieron a reiniciar la construcción del Templo de Dios en Jerusalén; los profetas de Dios estaban con ellos y los apoyaban."
,"3":"Fueron a verlos entonces Tatenay, gobernador de la provincia al otro lado del Río, Setar- Boznay y sus colegas. Les preguntaron: '¿Quién les dio permiso para reconstruir ese templo y poner esos tijerales?"
,"4":"Dennos los nombres de los que trabajan en esta obra'."
,"5":"Pero Dios cuidaba a los ancianos de Judá; pues mientras se enviaba un informe a Darío y se aguardaba su respuesta no se los obligó a suspender el trabajo."
,"6":"Esta es la copia de la carta que escribieron al rey Darío Tatenay, gobernador de la provincia más allá del Río, Setar-Boznay, sus colegas y los responsables de la Provincia:"
,"7":"'¡Salud, rey Darío!"
,"8":"Ha de saber el rey que fuimos a la provincia de Judá, al Templo del Gran Dios. Se lo construye con piedras talladas y con una armazón de madera puesta sobre el muro. La obra se hace cuidadosamente y va avanzando bien, merced a su trabajo."
,"9":"Interrogamos a los ancianos y les planteamos esta pregunta: ¿Quién los autorizó a reedificar ese Templo y a restaurar ese Santuario?"
,"10":"Les pedimos también su nombre y anotamos por escrito los nombres de los responsables para comunicártelos."
,"11":"Esta fue la respuesta que nos dieron: Nosotros somos los servidores del Dios del cielo y de la tierra, y reconstruimos el Templo que fue edificado hace muchos años; un gran rey de Israel lo edificó y terminó."
,"12":"Pero, como nuestros padres provocaron la cólera del Dios del Cielo, éste los dejó caer en manos de Nabucodonosor, rey de Babilonia, el caldeo. Demolió este Templo y se llevó al pueblo desterrado a Babilonia."
,"13":"Sin embargo, en el primer año del reinado de Ciro, rey de Babilonia, éste dio su autorización para reconstruir este Templo de Dios."
,"14":"El rey Ciro mandó buscar los objetos de oro y plata del Templo de Dios que Nabucodonosor había traído de Jerusalén y depositado en el templo de Babilonia. Se los pasó a Sesbasar, a quien nombró gobernador, diciéndole: Toma esos objetos y devuélvelos al Templo de Jerusalén, y reconstruye el Templo de Dios en el mismo lugar que tenía antes."
,"16":"Sesbasar vino entonces, puso los cimientos del Templo de Dios en Jerusalén y, desde ese día hasta ahora, la construcción prosigue sin que se la haya terminado todavía."
,"17":"Por eso, si el rey está de acuerdo, ordene buscar en la Casa de los tesoros del rey, allá abajo en Babilonia, si es que hubo una autorización del rey Ciro para reconstruir ese Templo de Dios en Jerusalén. Y el rey nos dirá cuál es su dictamen al respecto'."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Entonces el rey Darío ordenó que se hicieran las averiguaciones en la Sala de los tesoros donde se conservaban los archivos de Babilonia."
,"2":"En la ciudad fortificada de Ecbatana, en la provincia de los Medos, se descubrió un rollo en el que estaba escrito esto:"
,"3":"'El primer año del rey Ciro, el rey Ciro dio esta orden con respecto al Templo de Dios en Jerusalén: El Templo será reconstruido y será un lugar para ofrecer sacrificios. Se pondrán sus cimientos, su altura será de treinta metros y su ancho de treinta metros. Habrá tres bases de piedra por una de madera. Los gastos serán costeados por el palacio real."
,"5":"Los objetos de oro y de plata del Templo de Dios que fueron arrebatados por Nabucodonosor y traídos a Babilonia serán devueltos; serán depositados en la Casa de Dios y cada uno de ellos recuperará su lugar en el Templo de Jerusalén'."
,"6":"'Tú, Tatenay, gobernador de la provincia que está más allá del Eufrates, como también Setar-Boznay y los demás, sus colegas, y los jefes de la provincia, retírense de allí."
,"7":"El gobernador de Judá y los ancianos de los judíos reconstruirán el Templo de Dios en el mismo lugar; ¡déjenlos trabajar!"
,"8":"Estas son mis órdenes para esa reconstrucción del Templo de Dios que hacen los ancianos de los judíos: Ustedes cubrirán los gastos de esos hombres escrupulosa y regularmente con la parte de los impuestos de la provincia que deben al tesoro real."
,"9":"Proporcionarán cada día sin falta, según lo indiquen los sacerdotes de Jerusalén, todo lo que sea necesario para los holocaustos que se ofrecen al Dios del cielo: novillos, carneros y corderos, trigo, sal, vino y aceite."
,"10":"Ellos ofrecerán sacrificios de agradable olor al Dios del cielo y orarán por la vida del rey y de sus hijos."
,"11":"Además ordeno esto: Si alguien desobedece esta orden, arrancarán una viga de su casa, lo amarrarán a esa viga y su casa será transformada en un montón de escombros."
,"12":"Que el Dios cuyo Nombre habita en el Templo de Jerusalén arrase con cualquier rey o cualquier pueblo que quiera destruir esa Casa menospreciando este decreto. Yo Darío he dado esta orden, la que será ejecutada al pie de la letra'."
,"13":"Tatenay, gobernador de la provincia de más allá del Eufrates, Setar-Boznay y sus colegas hicieron exactamente lo que el rey Darío había ordenado."
,"14":"Los ancianos de los judíos prosiguieron la reconstrucción y la obra avanzó rápidamente gracias al profeta Ageo y a Zacarías hijo de Iddó; lo edificaron y lo terminaron conforme a las órdenes del Dios de Israel y a las de Ciro y Darío."
,"15":"El Templo de Dios fue terminado el tercer día del mes de Adar, en el sexto año del reinado de Darío."
,"16":"Los israelitas, los sacerdotes, los levitas y los demás desterrados hicieron una gran fiesta para la consagración de ese Templo de Dios."
,"17":"Trajeron para la consagración del Templo cien toros, doscientos carneros y cuatrocientos corderos; ofrecieron doce chivos como sacrificio por el pecado, en nombre de todo el pueblo, según el número de las tribus de Israel."
,"18":"Dispusieron a los sacerdotes según sus grupos y a los levitas según sus clases para asegurar el servicio de Dios en Jerusalén, tal como está escrito en el libro de Moisés."
,"19":"Los que habían sido desterrados celebraron la Pascua el día catorce del primer mes."
,"20":"Todos los levitas se habían purificado; estaban puros e inmolaron la Pascua para todos los desterrados, para sus hermanos sacerdotes y para ellos mismos."
,"21":"Los israelitas que habían vuelto del destierro comieron la Pascua, y junto con ellos, todos lo que habían renunciado a las prácticas impuras de los paganos del país para buscar a Yavé Dios de Israel."
,"22":"Celebraron con alegría durante siete días la fiesta de los panes sin levadura, porque Yavé los había colmado de alegría, pues había tornado favorable para ellos el corazón del rey de Asiria, quien había venido en su ayuda para reconstruir el Templo de Dios, del Dios de Israel."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Después de todo eso, bajo el reinado de Artajerjes, rey de Persia, arribó procedente de Babilonia Esdras hijo de Seraías, hijo de Azarías, hijo de Hilquías,"
,"2":"hijo de Salum, hijo de Sadoc, hijo de Ajitub,"
,"3":"hijo de Amarías, hijo de Azarías, hijo de Merayot,"
,"4":"hijo de Zeraquías, hijo de Uzi, hijo de Buqui,"
,"5":"hijo de Abizúa, hijo de Pinjas, hijo de Eleazar, hijo del sumo sacerdote Aarón."
,"6":"Era un escriba muy instruido en la Ley que Yavé Dios de Israel había ordenado por medio de Moisés. Como Yavé su Dios estaba con él, el rey le concedió todo lo que le pedía."
,"7":"Llegaron a Jerusalén, el séptimo año del rey Artajerjes, israelitas, sacerdotes, levitas, cantores, porteros y sirvientes."
,"8":"Esdras llegó a Jerusalén el quinto mes del séptimo año del rey."
,"9":"Había iniciado su salida de Babilonia el día primero del primer mes, y llegó a Jerusalén el día primero del quinto mes con la ayuda de Dios."
,"10":"Pues efectivamente se había dedicado con todo su corazón al estudio de la Ley de Yavé, a ponerla en práctica y a enseñarle a Israel las leyes y las costumbres."
,"11":"Esta es una copia de la carta que el rey Artajerjes dio a Esdras, el sacerdote escriba (un escriba instruido en las palabras y en las leyes que Yavé había dado a Israel):"
,"12":"'Artajerjes, el rey de reyes, a Esdras, el sacerdote, escriba de la Ley del Dios del Cielo."
,"13":"Esta es la orden que doy: todos los hombres, sacerdotes y levitas del pueblo de Israel, que viven en mi reino y que quieran volver a Jerusalén, pueden partir contigo."
,"14":"El rey y sus siete consejeros te envían para que inspecciones Judá y Jerusalén conforme a la Ley de tu Dios que llevas en tus manos."
,"15":"Tú llevarás el oro y la plata que el rey y sus consejeros ofrecen con mucho agrado al Dios de Israel que mora en Jerusalén."
,"16":"Tú llevarás todo el oro y la plata que recolectes en la provincia de Babilonia y las ofrendas que el pueblo y los sacerdotes ofrezcan generosamente para el Templo de su Dios en Jerusalén."
,"17":"Te encargarás de comprar con ese dinero toros, carneros, corderos, ofrendas y libaciones; las ofrecerás en el altar del Templo del Dios de ustedes en Jerusalén."
,"18":"Con lo que sobre de plata y oro, tú y tus hermanos harán lo que le parezca mejor, según la voluntad de su Dios."
,"19":"Depositarás ante el Dios de Jerusalén, para el servicio de su casa, los objetos que te han sido confiados."
,"20":"Si tienes que proporcionar otra cosa aún para la Casa de tu Dios, la tomarás del tesoro real."
,"21":"Yo, el rey Artajerjes, ordeno esto a todos los tesoreros de la provincia de más allá del Eufrates: ejecutarán al pie de la letra todo lo que les pida el sacerdote Esdras, escriba de la Ley del Dios del Cielo."
,"22":"Podrán gastar en todo eso hasta cien talentos de plata, cien medidas de trigo, cien medidas de vino y cien medidas de aceite; en cuanto a la sal, no repararán en gastos."
,"23":"Se ejecutará escrupulosamente cualquier orden del Dios del Cielo con respecto a su Casa, para que no se desate su cólera contra el reino del rey y de sus hijos."
,"24":"Además les comunicamos esto: No cobrarán tasa, ni impuesto ni peaje a los sacerdotes, a los levitas, a los cantores, a los porteros y a los sirvientes, en una palabra, a todos los que aseguran el servicio de ese Templo de Dios."
,"25":"Por lo que a ti toca, Esdras, con esa sabiduría que te viene de tu Dios, instalarás jueces y magistrados para que administren justicia a todo el pueblo de la provincia al otro lado del Jordán, a todos los que conocen la ley de tu Dios, y tú se la darás a conocer al que no la conoce aún."
,"26":"Si alguien no cumple la ley de tu Dios y la ley del rey, será acusado ante la justicia y condenado a multa, a prisión, a exilio o a la muerte'."
,"27":"Bendito sea Yavé el Dios de nuestros padres, quien puso en el corazón del rey esa decisión de glorificar el Templo de Yavé que está en Jerusalén."
,"28":"El hizo que el rey, sus consejeros y todos los altos funcionarios del rey estuvieran a favor de mis proyectos. Luego, lleno de entusiasmo, porque Yavé mi Dios estaba conmigo, reuní a los jefes de Israel para que partieran conmigo."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Estos son los jefes de familia, con su respectiva genealogía, que partieron conmigo de Babilonia bajo el reinado del rey Artajerjes:"
,"2":"De los hijos de Pinjas: Gersón; de los hijos de Itamar: Daniel; de los hijos de David: Jatús,"
,"3":"hijo de Secanías; de los hijos de Pareos: Zecarías, y junto con él fueron registrados ciento cincuenta hombres;"
,"4":"de los hijos de Pajat- Moab: Eliyoenay hijo de Zerajías, y con él doscientos hombres;"
,"5":"de los hijos de Zatú: Secarías hijo de Yacaziel, y con él trecientos hombres;"
,"6":"de los hijos de Adía: Ebed hijo de Yonatán y con él, cincuenta hombres;"
,"7":"de los hijos de Elam: Jesaías hijo de Atalías, y con él setenta hombres;"
,"8":"de los hijos de Sefatías: Zebadías hijo de Micael, y con él ochenta hombres;"
,"9":"de los hijos de Joab: Obadías hijo de Jejiel, y con él doscientos dieciocho hombres;"
,"10":"de los hijos de Baní: Selomit hijo de Yosifías, y con él ciento sesenta hombres;"
,"11":"de los hijos de Bebay: Zecarías hijo de Bebai, y con él veintiocho hombres;"
,"12":"de los hijos de Azgad: Yojanán hijo de Yacatán, y con él ciento diez hombres;"
,"13":"de los hijos de Adonicam: los últimos cuyos nombres son: Elifelet, Jeiel y Semaías, y con ellos sesenta hombres;"
,"14":"de los hijos de Bigvay: Utai hijo de Zabud, y con él setenta hombres."
,"15":"Los reuní cerca del río que corre hacia Ahava y acampamos allí tres días. Vi que había laicos y sacerdotes, pero no, levitas."
,"16":"Llamé entonces a los jefes Eliezer, Ariel, Semaías, Yarib, Elnatán y Natán y a los instructores Zecarías y Mesulam."
,"17":"Y los envié donde Ido, el gobernador de Casifía, para que nos mandara servidores para el Templo de nuestro Dios."
,"18":"Como Dios en su bondad lo dispone todo para nuestro bien, nos trajeron a Serebías, un hombre inteligente del clan de Majli hijo de Leví hijo de Israel. Llegó con sus hijos y sus hermanos; eran dieciocho."
,"19":"Llegaron también Yasabías y su hermano Jesaías, del clan de Merari, con sus hijos, en total veinte personas."
,"20":"De los sirvientes que David y los jefes habían designado para servirl a los levitas, llegaron también doscientos veinte; los empadronamos a todos uno por uno."
,"21":"Allí, a orillas del río Ahava, proclamé un día de ayuno para hacer penitencia delante de nuestro Dios, para suplicarle que nos concediera un viaje feliz junto con nuestros hijos y todo lo que llevábamos."
,"22":"Me habría dado vergüenza haberle pedido al rey un destacamento o una tropa de caballería para que nos protegieran de los salteadores en el camino. Pues habíamos dicho al rey: ' La fuerza de nuestro Dios acompaña a todos los que lo buscan para el bien de ellos; pero su fuerza y su cólera recaen sobre todos los que lo abandonan'."
,"23":"Ayunamos pues y suplicamos a Dios por esa intención, y él nos escuchó."
,"24":"Entonces elegí a doce de entre los jefes de los sacerdotes además de Serebías, Asabías y diez de sus hermanos."
,"25":"Pesé la plata, el oro y los objetos que habían dado para el Templo de nuestro Dios el rey, sus consejeros, sus jefes y todos los israelitas presentes."
,"26":"Pesé todo eso y se lo entregué en sus manos: 650 talentos de plata, 100 objetos de plata, cada uno de los cuales valía dos talentos de plata, cien talentos de oro,"
,"27":"20 copas de oro que valían 1.000 piezas persas y dos hermosos vasos de bronce dorado tan precioso como el oro."
,"28":"Les dije: 'Ustedes están consagrados al servicio de Yavé; estos objetos son sagrados; esta plata y este oro fueron dados para Yavé el Dios de sus padres."
,"29":"Tengan mucho cuidado y guárdenlos hasta el día en que puedan pesarlos delante de los jefes de los sacerdotes y levitas y delante de los jefes de familia de Israel en las salas del Templo de Yavé en Jerusalén'."
,"30":"Entonces los sacerdotes y los levitas se hicieron cargo de esa plata, de ese oro y de todos esos objetos que habían pesado para llevarlos al Templo de nuestro Dios, en Jerusalén."
,"31":"Dejamos el río Ahava para dirigirnos a Jerusalén, el doce del primer mes; la mano de nuestro Dios estaba con nosotros y nos protegió a lo largo del camino de los ataques de los enemigos y salteadores."
,"32":"Cuando llegamos a Jerusalén, tomamos tres días de descanso."
,"33":"Al cuarto día, se pesó el oro, la plata y los objetos en el Templo de nuestro Dios; lo pusimos todo en las manos del sacerdote Meremot hijo de Uría. Estaban allí Eleazar hijo de Pinjas y también los levitas Yozabal hijo de Josué, y Noadías hijo de Binui."
,"34":"Todo se encontraba en la misma cantidad y peso, y se anotó el peso total."
,"35":"Los que volvieron del cautiverio después del destierro ofrecieron holocaustos al Dios de Israel: doce toros por todo Israel, noventa y seis carneros, setenta y dos corderos y doce chivos por el pecado; todo eso se ofreció en holocausto a Yavé."
,"36":"Se despacharon las ordenanzas del rey a los gobernadores y a los jefes de la provincia al otro lado del Eufrates, quienes entregaron su ayuda para el pueblo y para el Templo de Dios."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Después de eso, se me acercaron los jefes, diciéndome: 'El pueblo de Israel, los sacerdotes y los levitas no se han separado de todos esos pueblos cananeos, hititas, pereceos, jebuseos, amonitas, moabitas, egipcios o amorreos, cuyas prácticas son abominables."
,"2":"Han tomado a sus hijas para ellos y para sus hijos, y la raza santa se ha mezclado con los pueblos del país. Los jefes y los responsables han sido los primeros en pecar de ese modo'."
,"3":"Al oír eso rasgué mi túnica y mi manto, me arranqué los cabellos y la barba y muy conmovido me fui a sentar."
,"4":"Entonces todos los que temían la palabra del Dios de Israel con respecto a ese pecado de los desterrados, se juntaron a mi alrededor y yo seguí allí muy conmovido hasta la ofrenda de la tarde."
,"5":"En el momento de la ofrenda de la tarde, salí de mi abatimiento y con la túnica y el manto rasgados me puse de rodillas. Extendí las manos hacia Yavé mi Dios"
,"6":"y le dije: 'Estoy tan avergonzado y confundido que no me atrevo a levantar mi cara hacia ti, Dios mío. Nuestras faltas se han acumulado de tal forma que han sobrepasado nuestras cabezas, y nuestro pecado ha subido hasta el Cielo. "
,"7":"Desde los tiempos de nuestros padres hasta ahora no hemos dejado de pecar delante de ti, y por culpa de nuestras faltas, nosotros, nuestros reyes y nuestros sacerdotes fuimos entregados a los reyes de las naciones paganas, condenados a la espada, al cautiverio y al pillaje, y aún hoy llevamos la vergüenza en nuestro rostro."
,"8":"Desde hace un tiempo Yavé nuestro Dios nos ha manifestado su bondad: nos dejó un pequeño resto de sobrevivientes y nos permitió poner un pie en su Lugar Santo. Nuestro Dios quiso darles un poco de luz a nuestros ojos y darnos vida en nuestra esclavitud."
,"9":"Seguimos como esclavos, pero nuestro Dios no nos ha abandonado en esta esclavitud, pues nos cubrió con su misericordia frente a los reyes de Persia. Nos ha dado un respiro, la Casa de nuestro Dios ha resurgido de sus ruinas, nos ha devuelto las murallas de Judá y de Jerusalén."
,"10":"Por eso, ahora, Dios nuestro, ¿qué más podemos decir? Pues no hicimos caso de tus mandamientos"
,"11":"ni de las advertencias que nos hacías por boca de tus servidores los profetas: El país donde van a entrar y que será su herencia es un país manchado por la impureza de los pueblos paganos. De un extremo al otro lo han llenado de impurezas con sus prácticas vergonzosas."
,"12":"No den pues sus hijas en matrimonio a los hijos de ellos ni tomen sus hijas para los hijos de ustedes. No hagan nada por su felicidad y prosperidad. Si actúan según mi Ley, ustedes serán poderosos, comerán los productos del país y lo dejarán como herencia a sus hijos para siempre."
,"13":"Nos han ocurrido muchas desgracias debido a nuestras prácticas malvadas y a nuestro gran pecado; tú, sin embargo, Dios nuestro, no te has fijado más que en un poco de nuestras faltas y nos has dejado a los sobrevivientes que están aquí."
,"14":"¿Vamos una vez más a violar tus mandamientos y a unirnos en matrimonio con esos abominables? Ciertamente que tú te enojarás con nosotros y nos destruirás de tal forma que no quede ni un resto ni sobrevivientes."
,"15":"Yavé, Dios de Israel, es un hecho que eres justo, pues nos has dejado un resto, unos sobrevivientes. Aquí estamos pues ante ti con nuestro pecado; pero, ¿cómo permanecer así en tu presencia?'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Esdras hacía esta oración y esta confesión, entre sollozos y postrado delante del Templo de Dios, mientras una gran multitud de israelitas, hombres, mujeres y niños se congregaban alrededor de él; el pueblo también sollozaba a gritos."
,"2":"Secanías hijo de Jequiel, uno de los hijos de Elam, tomó la palabra y dijo a Esdras: 'Si bien traicionamos a nuestro Dios tomando mujeres extranjeras de entre los pueblos del país, todavía hay esperanza para Israel."
,"3":"Vamos a comprometernos solemnemente ante nuestro Dios a mandar de vuelta a todas nuestras mujeres extranjeras y a los hijos que nacieron de ellas. De esa manera obedeceremos los consejos de mi señor y de los que temen el mandamiento de nuestro Dios. ¡Sí, vamos a actuar según la ley!"
,"4":"Levántate, ya que es asunto tuyo. Nosotros estamos contigo. Ten valor y pon manos a la obra'."
,"5":"Esdras entonces se levantó y pidió a los jefes de los sacerdotes y de los levitas y a todo Israel que juraran que iban a hacer lo que se había dicho, y ellos juraron."
,"6":"Esdras salió del Templo de Dios y se fue a la pieza de Yojanán, hijo de Eliasib, donde pasó toda la noche sin comer pan ni beber agua porque estaba sumido en la tristeza debido a la infidelidad de los exiliados."
,"7":"Se publicó un bando en Judá y en Jerusalén para todos los que habían sido desterrados, que debían reunirse en Jerusalén."
,"8":"Si alguien -decía el bando de los jefes y de los ancianos- no comparecía dentro de tres días, todos sus bienes serían condenados al anatema y hasta él mismo sería rechazado de la comunidad de los desterrados."
,"9":"Al tercer día se reunieron en Jerusalén todos los hombres de Judá y de Benjamín; era el veinte del noveno mes. Todo el pueblo estaba en la plaza delante del Templo de Dios. La gente temblaba tanto a causa de los acontecimientso como porque estaba lloviendo."
,"10":"Entonces se levantó el sacerdote Esdras y les dijo: 'Ustedes han sido infieles, se han casado con mujeres extranjeras y han aumentado así la culpa de Israel."
,"11":"Pero ahora, reconozcan su falta delante de Yavé, el Dios de sus padres y hagan lo que se les manda: sepárense de la gente del país y de las mujeres extranjeras'."
,"12":"Toda la asamblea respondió a una sola voz:'Tú has hablado muy bien; ahora no nos queda más que actuar."
,"13":"Pero, como el pueblo es numeroso y estamos en la estación de las lluvias, no podemos quedarnos a la intemperie, además que el problema no se solucionará en un día ni dos. Muchos de nosotros cometimos ese pecado."
,"14":"Por lo tanto, que nuestros jefes se queden aquí durante toda la asamblea, y todos los que en nuestras ciudades se hayan casado con mujeres extranjeras vendrán en la fecha que se les indique y con ellos vendrán también los ancianos de cada ciudad y los jueces, hasta que se haya apartado de nosotros la cólera de nuestro Dios por este motivo'."
,"15":"Sólo se opusieron a esto Yonatán hijo de Asajel y Yajzía hijo de Ticúa; los apoyaban Mesulam y el levita Sabtay."
,"16":"Pero los exiliados hicieron lo que se les había propuesto; el sacerdote Esdras eligió para cada casa jefes de familia designados personalmente. Comenzaron a sesionar el primer día del décimo mes para atender todos los casos,"
,"17":"y el primer día del primer mes habían terminado de solucionar el problema de los que se habían casado con mujeres extranjeras."
,"18":"Esta es la lista de los que se habían casado con mujeres extranjeras: de entre los sacerdotes, entre los hijos de Josué hijo de Yosadac, y entre sus hermanos: Maaseías, Eliezer, Yarib y Geldaía."
,"19":"Juraron despachar a sus mujeres y ofrecer un carnero como sacrificio de reparación por su pecado;"
,"20":"entre los hombres de Immer: Janani y Zebadía;"
,"21":"entre los hijos de Jarim: Maaseías, Elías, Semarías, Jejiel y Uzía;"
,"22":"entre los hijos de Pasejur: Elionay, Maaseías, Ismael, Nataneel, Yozabad y Eleasa;"
,"23":"entre los levitas: Yozabad, Simei, Quelaía -o lo mismo que Quelita- Petaías, Jejuda y Eliezer;"
,"24":"entre los cantores: Eliasib y Zacur; entre los porteros: Salum, Telem y Uri;"
,"25":"y entre los israelitas: de los hijos de Pareos: Ramías, Jicías, Malquías, Mijamín, Eleazar, Malquía y Benaía; de los hijos de Elam: Matanías, Zecarías, Jejiel, Abdi, Jeremot y Elía;"
,"27":"de los hijos de Zatú: Elioenay, Eliasib, Matanías, Jeremot, Zabad y Aziza;"
,"28":"de los hijos de Bebay: Yojanán, Yanaías, Zabaj, Atlay;"
,"29":"de los hijos de Bigvay: Mesulam, Maluc, Jedaías, Yasub, Jisal, Jeremot;"
,"30":"de los hijos de Pajat-Moab: Adna, Quelal, Benaías, Maaseías, Matanías, Besaleel, Binuy y Menasé;"
,"31":"de los hijos de Jarim: Eliezer, Jisiías, Malquías, Semaías, Simeón,"
,"32":"Benjamín, Maluc, Semaría;"
,"33":"de los hijos de Yasum: Matenay, Matatías, Zabad, Elifelet, Jeremay, Menasé, Simey;"
,"34":"de los hijos de Bani: Maaday, Amram, Yoel,"
,"35":"Benaías, Bedías, Quelaías,"
,"36":"Vamías, Meremot, Eliasib,"
,"37":"Matanías, Matenay y Yaasay;"
,"38":"de los hijos de Mirmi: Simei,"
,"39":"Selemías, Natán y Adaía;"
,"40":"de los hijos de Zacay: Sasay, Saray,"
,"41":"Azaieel, Selemías, Semarías,"
,"42":"Salum, Amarías, Yosef;"
,"43":"de los hijos de Nebo: Jeiel, Matitías, Zabad, Zebina, Yadaí, Yoel, Benaía."
,"44":"Todos estos se habían casado con mujeres extranjeras y las mandaron de vuelta junto con sus hijos."
}`)

}
func ES_LBL_LoadVHETChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Era en tiempos del rey Asuero; su imperio se extendía de la India a Etiopía y se dividía en ciento veintisiete provincias;"
,"2":"su trono real estaba por ese entonces en la fortaleza de Susa."
,"3":"El tercer año de su reinado, dio un gran banquete para sus altos funcionarios y sus servidores jefes del ejército de los Persas y de los Medos, para los gobernadores y los jefes de las provincias. El mismo presidió el banquete."
,"4":"Quería mostrarles durante muchos días (ciento ochenta días) la riqueza de su reino y su propia gloria, su riqueza y su éxito."
,"5":"Cuando transcurrió ese tiempo, el rey organizó en el patio de su palacio un gran banquete que duraría siete días y al que estaba invitado todo el pueblo de la fortaleza de Susa, desde el más grande hasta el más chico."
,"6":"Guirnaldas blancas y moradas atadas por cordones de lino y púrpura pendían de anillos de plata fijos en columnas de mármol. Sobre el pavimento de piedras seleccionadas, de mármol, de nácar y de mosaicos se habían dispuesto divanes de oro y de plata."
,"7":"Las bebidas se servían en vasos de oro de diferentes formas y, según la orden del rey, el vino corría a destajo."
,"8":"Sin embargo nadie era obligado a beber, porque el rey había ordenado a todos sus sirvientes que respetaran la voluntad de cada uno."
,"9":"La reina Vasti, por su parte, había organizado una comida para las mujeres en el palacio de Asuero."
,"10":"Al séptimo día, como el vino lo había puesto de buen humor, el rey ordenó a Mejuna, a Biceta, a Jarbona, a Bigta, a Abgtar, a Cetar y a Carcas, los siete eunucos que estaban para su servicio personal,"
,"11":"que le trajeran a la reina Vasti con la corona real en la cabeza. Quería jactarse de la belleza de la reina ante el pueblo y ante sus oficiales, pues en verdad era muy bella."
,"12":"Pero la reina Vasti se negó a aceptar la orden del rey transmitida por sus eunucos; el rey se sintió muy molesto y se enojó mucho."
,"13":"Se dirigió entonces a los sabios, a los especialistas en leyes (pues todos los asuntos del rey eran tratados en presencia de los que tenían conocimientos de la ley y del derecho)."
,"14":"Mandó que comparecieran ante él Carsena, Setar, Admata, Tarsis, Meres, Marsena y Memucán, los siete altos funcionarios persas y medos que podían ser admitidos a su presencia y que ocupaban los primeros puestos del reino."
,"15":"Les dijo: «¿Qué se debe hacer según la ley con la reina Vasti que no obedeció la orden que el rey Asuero le transmitió por medio de los eunucos?»"
,"16":"Memucán respondió en presencia del rey y de los altos funcionarios: «La reina Vasti no sólo ha ofendido al rey sino también a todos los altos funcionarios y a los diferentes pueblos diseminados por las diversas provincias del reino de Asuero."
,"17":"Todas las mujeres sabrán lo que hizo la reina y eso las animará a no respetar más la autoridad de su marido. Dirán: ¡El rey Asuero le ordenó personalmente a la reina que viniera, pero ésta se negó!"
,"18":"Este mismo día las princesas de Persia y de Media se van a enterar de la negativa de la reina. ¿Cómo irán a responder a todos los altos funcionarios del rey? En todas partes no habrá más que desprecio y cólera."
,"19":"Si el rey lo estima conveniente, hay que publicar ahora una ordenanza real de su puño y letra e inscribirla en las leyes de los Persas y Medos, de tal manera que nadie pueda oponérsele. Esa ordenanza le prohibirá a la reina Vasti volver a presentarse ante el rey Asuero, y el rey dará su título de reina a otra mejor que ella."
,"20":"La ordenanza que mande publicar el rey se dará a conocer a todos en su reino, para que todas las mujeres respeten a sus maridos, desde el más grande hasta el más pequeño»."
,"21":"Al rey y a sus funcionarios les pareció buena esa proposición, y el rey siguió el consejo de Memucán."
,"22":"Despachó cartas a todas las provincias, a cada provincia en su escritura, a cada pueblo en su idioma, para que todo marido fuese el señor de su casa."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Se le pasó el enojo al rey Asuero y no pensó ya más en Vasti, ni en lo que le había hecho ni en lo que había decidido al respecto."
,"2":"Los cortesanos del rey le dijeron entonces: «Busquemos para el rey algunas jovencitas que sean a la vez vírgenes y hermosas."
,"3":"El rey debe nombrar inspectores en todas las provincias de su reino, los que juntarán en la ciudadela de Susa a todas las jovencitas que sean vírgenes y bellas a la vez. Se alojarán en la casa de las mujeres bajo la vigilancia de Hegué, el eunuco del rey, que es el guardián de sus mujeres. Les proporcionará a todas productos de belleza,"
,"4":"y la joven que guste al rey será la reina en vez de Vasti». Al rey le pareció eso excelente y así se ejecutó."
,"5":"Vivía en la fortaleza de Susa un judío, llamado Mardoqueo; era hijo de Jaír, hijo de Simei, hijo de Kich, de la tribu de Benjamín."
,"6":"Era uno de los desterrados que Nabucodonosor, rey de Babilonia, había traído de Jerusalén junto con Jeconías, rey de Judá."
,"7":"Ese judío había criado a su sobrina Hadasá -es decir Ester- que había perdido a su padre y a su madre; la joven era elegante y maravillosa. Cuando murieron su padre y su madre, Mardoqueo la había adoptado como hija."
,"8":"Apenas se supo el edicto del rey y su decisión de reunir a numerosas jovencitas en la fortaleza de Susa bajo la vigilancia de Hegué, Ester fue llevada al palacio del rey y puesta bajo el cuidado del guardián de las mujeres."
,"9":"Como la joven le cayó en gracia a Hegué, éste le otorgó un trato especial: se esmeró en proporcionarle todo lo que necesitaba para su belleza personal y para su manutención. Puso a su disposición a siete mucamas seleccionadas en el palacio real y la instaló junto con sus camareras en el mejor departamento de la casa de las mujeres."
,"10":"Ester no había dicho a nadie cuál era su pueblo, quiénes eran sus padres, porque Mardoqueo se lo había prohibido."
,"11":"Pero diariamente Mardoqueo iba a dar su vuelta por delante del patio de la casa de las mujeres para tener noticias de Ester y de su salud."
,"12":"Las jóvenes se preparaban durante doce meses: los primeros seis meses se acicalaban con óleo de mirra, y los otros seis con perfumes y productos de belleza propios de las mujeres. Después de ese tiempo dedicado al cuidado de su belleza, cada joven debía comparecer por turno ante el rey."
,"13":"Cuando le tocaba ir donde el rey, cada joven podía pedir todo lo que estimara necesario para pasar de la casa de las mujeres al palacio real."
,"14":"Llegaba allí de tarde y al día siguiente pasaba a otra casa de las mujeres confiada a Saasgaz, el eunuco del rey encargado de cuidar a las concubinas. Ya no volvía más a ver al rey, salvo que el rey se hubiese enamorado de ella; en ese caso, la mandaba llamar personalmente."
,"15":"Llegó el día en que Ester, hija de Abijail, el tío de Mardoqueo, su padre adoptivo, debía presentarse ante el rey. Ella no exigió nada fuera de lo que le había proporcionado Hegué, el eunuco del rey encargado de la custodia de las mujeres. Pues bien, todos los que la veían, encontraron a Ester deslumbrante."
,"16":"La llevaron donde el rey Asuero, en el palacio real, el décimo mes, esto es Tebet, del séptimo año de su reinado."
,"17":"El rey la prefirió a todas las demás; se ganó su afecto y su cariño más que cualquier otra joven. Puso en su cabeza la corona real y la escogió como reina en vez de Vasti."
,"18":"Después de eso, el rey dio un gran banquete en honor de Ester a todos los altos funcionarios y a sus cortesanos; otorgó un día feriado en todas las provincias y distribuyó regalos con una real generosidad."
,"19":"Ester, igual que las otras jóvenes, pasó a la segunda casa de las mujeres."
,"20":"Obediente a las órdenes de Mardoqueo, tal como él se lo había inculcado, Ester no contó a nadie cuales eran sus orígenes."
,"21":"Mientras estaba sentado Mardoqueo en la puerta real, dos eunucos del rey Bigtán y Terés, que custodiaban las puertas, decidieron asesinar al rey Asuero, porque estaban descontentos con él."
,"22":"Lo supo Mardoqueo y se lo comunicó a la reina Ester; esta, a su vez, habló al rey de parte de Mardoqueo."
,"23":"Se hizo la investigación respectiva, se descubrió que eso era exacto y los dos hombres fueron ahorcados; luego, a la vista del rey, se escribió el relato de ese hecho en el Libro de las Crónicas."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Un tiempo después, el rey Asuero honró a Amán, hijo de Hamdata, de la raza de Agag, de un modo muy especial; lo puso al frente de todos los altos funcionarios, sus colegas."
,"2":"Por orden del rey, todos sus subordinados, responsables del servicio de la Puerta, tenían que arrodillarse y agacharse ante él. Pero Mardoqueo se negó a arrodillarse y a agacharse."
,"3":"Los demás empleados del rey que trabajaban en la Puerta dijeron a Mardoqueo: '¿Por qué desobedeces la orden del rey?»"
,"4":"Todos los días le repetían lo mismo, pero él no les hacía caso. Al final les dijo Mardoqueo que era judío. Lo denunciaron ante Amán para ver si seguía en su actitud."
,"5":"Cuando Amán vio que Mardoqueo no se arrodillaba ni se agachaba ante él, se puso furioso."
,"6":"Habría podido castigar únicamente a Mardoqueo, pero al enterarse del pueblo al que pertenecía Mardoqueo, Amán trató de exterminar al pueblo de Mardoqueo, es decir, a todos los judíos que había en el reino de Asuero."
,"7":"El primer mes (es decir el mes de Nisán) del duodécimo año del rey Asuero, se tiró el Pur (es decir el sorteo) en presencia de Amán para saber en qué momento se exterminaría a los judíos; salió sorteado el duodécimo mes, es decir, el mes de Adar."
,"8":"Entonces Amán dijo al rey Asuero : 'En todas las provincias de tu reino vive un pueblo extraño y que está disperso en medio de los demás pueblos. Sus leyes no se parecen a las de ningún otro y no observan las leyes del rey. Por ningún motivo debes dejarlos tranquilos."
,"9":"Si el rey lo estima conveniente, demos la orden de exterminarlos y yo daré a los funcionarios diez mil talentos de plata para que los depositen en el tesoro real»."
,"10":"El rey se sacó el anillo con el que sellaba sus cartas y se lo pasó a Amán, hijo de Hamdata, de la raza de Agag, el enemigo de los judíos."
,"11":"El rey añadió: 'Guarda tu dinero y haz lo que quieras con ese pueblo»."
,"12":"El día trece del primer mes, fueron convocados los secretarios del rey; escribieron según las órdenes de Amán a los gobernadores del rey, a los jefes de cada provincia y de cada pueblo, a cada provincia en su escritura, a cada pueblo en su lengua. Las cartas iban a nombre del rey Asuero y estaban selladas con el anillo real."
,"13":"Mensajeros llevaron esas cartas a todas las provincias del reino; en ellas se ordenaba hacer desaparecer, matar, exterminar en un mismo día, el día trece del duodécimo mes (es decir el mes de Adar) a todos los judíos, tanto jóvenes como viejos. Además se les expropiarían todos sus bienes."
,"14":"Debía enviarse una copia de esta carta a cada provincia para que tuviera fuerza de ley y dársela a conocer a todos los pueblos para que estuvieran listos ese día."
,"15":"Por orden del rey los mensajeros partieron inmediatamente; la ley fue publicada primero en la fortaleza de Susa. La ciudad de Susa quedó consternada, mientras que el rey y Amán no hacían más que tomar y pasarlo bien."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Al enterarse Mardoqueo de esas determinaciones rasgó su ropa, se puso un saco y se cubrió de ceniza, luego salió a recorrer la ciudad lanzando gritos desgarradores."
,"2":"Así llegó hasta la puerta real, la que nadie vestido de saco podía franquear."
,"3":"En las provincias, a medida que fueron llegando la orden y el decreto, sólo se vio entre los judíos duelo, ayuno, lágrimas y lamentaciones; muchos se acostaron en la ceniza cubiertos de saco."
,"4":"Cuando Ester se enteró de todo eso por medio de sus damas y de sus eunucos, quedó horrorizada. Mandó ropa a Mardoqueo para que se la pusiera en vez del saco, pero éste se negó."
,"5":"Llamó entonces a Hatac, uno de los eunucos que había puesto el rey a su servicio, y lo mandó donde Mardoqueo para que la informara de lo que pasaba y por qué actuaba así."
,"6":"Fue, pues, Hatac a encontrarse con Mardoqueo en la plaza de la ciudad, frente a la Puerta."
,"7":"Mardoqueo le contó todo lo que acababa de suceder y le habló de la suma de dinero que Amán quería ofrecer al tesoro real a cambio de la vida de los judíos."
,"8":"Le dio una copia del decreto de exterminación publicado en Susa para que se lo mostrara a Ester y la pusiera al corriente de todo. Le ordenaba a Ester que fuera a ver al rey para implorarle su bondad y suplicarle en favor de su pueblo. Mardoqueo le mandó decir: '¡Acuérdate de esa época en que estabas en la miseria y yo te alimentaba de mi mano. Ya que ahora Amán, el segundo personaje del reino, ha pedido al rey nuestra muerte, suplica al Señor, habla por nosotros al rey, líbranos de la muerte!» "
,"9":"Hatac transmitió a Ester las palabras de Mardoqueo."
,"10":"Ester mandó de vuelta a Hatac con esta respuesta:"
,"11":"'Los servidores del rey saben muy bien, igual como el pueblo de las provincias del rey, que cualquiera, hombre o mujer, que entre en los aposentos privados del rey sin haber sido llamado, es reo de muerte. La ley no hace excepciones al respecto, únicamente aquel a quien el rey tienda su cetro de oro puede salvar su vida. Y lo que es yo, hace treinta días que no he sido llamada por el rey»."
,"12":"Hatac transmitió a Mardoqueo las palabras de Ester."
,"13":"Pero Mardoqueo le mandó de nuevo a decir a Ester: 'No creas que tú serás la única entre los judíos en escapar de la muerte, porque estás en el palacio real."
,"14":"Si ahora te callas, la salvación y la liberación llegarán a los judíos de otra parte, pero tú y la casa de tu padre morirán. ¿Quién sabe si no fue para un día como éste que tu llegaste a ser reina?»"
,"15":"Ester mandó esta respuesta a Mardoqueo:"
,"16":"'Reúne a todos los judíos que hay en Susa y que ayunen por mí. No coman ni beban durante tres días y tres noches, y yo, por mi parte, también ayunaré con mis damas; ya que iré a ver al rey en contra de la ley, si tengo que morir, moriré»."
,"17":"Se fue Mardoqueo e hizo todo lo que Ester le había pedido."
}`)
	CurrentBook.AddChapter(5, `{
"3":"'¿Qué tienes, reina Ester?» le preguntó el rey. 'Pídeme lo que quieras; aunque sea la mitad de mi reino, te la daré»."
,"4":"Ester respondió: '¿Aceptaría el rey venir hoy, junto con Amán, al banquete que le tengo preparado?»"
,"5":"El rey dijo al momento: 'Vayan rápido a buscar a Amán y hagamos lo que Ester nos pide». Fue pues el rey con Amán al banquete que había preparado Ester. "
,"6":"Cuando le servían el vino, el rey dijo a Ester: '¿Qué pides? Lo que sea se te concederá. Dime lo que deseas, aunque sea la mitad de mi reino, se te dará»."
,"7":"Ester respondió: '¿Preguntas por mi solicitud y mi deseo?"
,"8":"Si el rey me quiere conceder un favor, si el rey estima conveniente satisfacer mi pedido y mi deseo, que venga el rey una vez más con Amán a la comida que le prepararé mañana. Entonces daré mi respuesta al rey»."
,"9":"Ese día salió Amán feliz y contento. Pero al ver en la puerta del rey a Mardoqueo que no se paró ni se cuadró ante él, se llenó nuevamente de rabia contra Mardoqueo."
,"10":"Sin embargo se dominó y regresó a su casa; mandó llamar entonces a sus amigos y a su mujer Zerés."
,"11":"Amán les contó en detalle su increíble riqueza, el gran número de sus hijos y todo lo que el rey había hecho para elevarlo y ponerlo por encima de todos los funcionarios y de todos los servidores del rey."
,"12":"Y Amán añadió: 'La reina Ester no ha invitado a nadie más que a mí al banquete que preparó para el rey, y mañana también he sido invitado por ella junto con el rey."
,"13":"Pero todo eso es nada para mí mientras vea a Mardoqueo, a ese judío, sentado en la puerta del rey.»"
,"14":"Su mujer Zerés y sus amigos le dijeron: 'Manda instalar una horca de veinticinco metros de alto y mañana pide al rey que ahorquen ahí a Mardoqueo. Así estarás de buen humor para ir al banquete con el rey». Amán aceptó su consejo y mandó levantar la horca."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Pero esa noche el rey no pudo conciliar el sueño. Pidió que le trajeran el Libro de las Memorias, las Crónicas, y lo leyeron ante el rey."
,"2":"Llegaron al pasaje donde se narraba cómo Mardoqueo había denunciado a los dos eunucos del rey, Bigtán y Terés, los guardianes de la Puerta que habían querido asesinar al rey Asuero."
,"3":"El rey preguntó entonces: '¿Se ha hecho algo especial con Mardoqueo? ¿Se le ha dado alguna recompensa?» Los servidores del rey respondieron: 'No se ha hecho nada con él»."
,"4":"Entonces dijo el rey: '¿Quién anda en el patio?» Precisamente en ese momento Amán atravesaba el patio exterior del palacio real para ir a pedir al rey que mandara ahorcar a Mardoqueo de la horca que había preparado para éste."
,"5":"Los servidores del rey respondieron: 'Es Amán quien anda en el patio». El rey dijo: 'Díganle que entre»."
,"6":"Amán entró y el rey le preguntó: '¿Qué se puede hacer con un hombre al que quiere el rey honrar?» Amán se dijo a sí mismo: '¡A quién más que a mí podría honrar el rey!»"
,"7":"Y respondió al rey: '¿Quiere el rey honrar a alguien?"
,"8":"Mande traer el rey un manto real que ya se haya puesto, un caballo en el que haya montado y en cuya cabeza se haya puesto una corona real. Entreguen el manto y el caballo a uno de los principales ministros del rey,"
,"9":"pónganle el manto al hombre que el rey quiere honrar, háganlo subir al caballo y sáquenlo a pasear por toda la ciudad. Vaya alguien delante de él pregonando: Así se hace con el hombre al que el rey quiere honrar»."
,"10":"El rey dijo entonces a Amán: 'Apresúrate, toma ese manto y el caballo como has dicho, y haz todo eso con Mardoqueo, el judío, que se sienta en la puerta del rey. No olvides nada de lo que has dicho»."
,"11":"Amán tomó el manto y el caballo, se lo hizo poner a Mardoqueo y lo paseó a caballo por la ciudad, e iba delante de él pregonando: '¡Esto es lo que se hace con un hombre a quien el rey quiere honrar!»"
,"12":"Luego Mardoqueo regresó a la puerta del rey, mientras que Amán se volvía precipitadamente a su casa, avergonzado y tapándose la cara."
,"13":"Amán contó detalladamente a su mujer Zerés y a todos sus amigos lo que acababa de pasarle. Esos hombres sabios y también su mujer Zerés le dijeron: 'Si Mardoqueo es de raza judía y si tú has comenzado a decaer, no podrás nada contra él. Tendrás que ceder ante él»."
,"14":"Todavía estaban conversando cuando llegaron los eunucos a buscar a Amán para llevarlo al banquete que había preparado Ester."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Vino pues el rey, lo mismo que Amán, al banquete de la reina Ester."
,"2":"Ese segundo día, el rey dijo de nuevo a Ester en el momento en que le servían el vino: '¿Qué pides, reina Ester? ¡Lo que pidas se te concederá! ¿Cuál es tu deseo? Aunque fuera la mitad de mi reino, te la daré»."
,"3":"La reina Ester respondió al rey: 'Si me quiere hacer un favor y si el rey lo estimare conveniente, pido que se me conceda la vida, deseo que se la conceda a mi pueblo."
,"4":"Porque hemos sido vendidos, yo y mi pueblo, para ser masacrados, asesinados y exterminados. Si sólo hubiéramos sido vendidos como esclavos, no diría nada, pero ¿de qué manera podrá el enemigo compensar el daño que ha hecho al rey?»"
,"5":"El rey Asuero tomó la palabra y dijo a la reina Ester: 'Pero, ¿quién es? ¿Dónde está ese hombre que alimenta tales propósitos?»"
,"6":"Ester respondió: '¡El adversario, el enemigo está aquí! ¡Es Amán, ese hombre malvado!» Amán quedó helado de espanto ante el rey y la reina."
,"7":"El rey se paró de la mesa muy enojado y salió al jardín del palacio. Amán, por su parte, se quedó para implorar su salvación a la reina Ester, porque veía bien que el rey había decidido su muerte."
,"8":"Cuando el rey volvió del jardín del palacio a la sala del banquete, Amán se había dejado caer sobre el diván donde estaba recostada Ester. El rey exclamó: '¿Así que ahora vas a violentar a la reina, en mi casa, en mi palacio?» Inmediatamente, el rey dio una orden y le echaron un velo a la cara de Amán."
,"9":"Arbona, uno de los eunucos, dijo al rey: 'Hay una horca que preparó Amán para Mardoqueo, el que había sido honrado por el rey. Está levantada frente a la casa de Amán y tiene una altura de veinticinco metros». Entonces dijo el rey: 'Cuelguen allí a Amán»."
,"10":"Colgaron a Amán en la horca que había preparado para Mardoqueo, y así se apaciguó la cólera del rey."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Ese mismo día, el rey Asuero dio a la reina Ester la casa de Amán, el enemigo de los judíos, y Mardoqueo fue a presentarse ante el rey, porque Ester había revelado al rey lo que aquél era para ella."
,"2":"El rey se sacó el anillo que había quitado a Amán y se lo pasó a Mardoqueo. Por su parte Ester encomendó a Mardoqueo la dirección de la casa de Amán."
,"3":"Una vez más, Ester habló con el rey, cayó de rodillas a sus pies y le suplicó que dejara sin efecto la malvada idea de Amán, descendiente de Agag, y los proyectos que había tramado contra los judíos."
,"4":"El rey tendió a Ester su cetro de oro; Ester se levantó y se quedó de pie ante el rey."
,"5":"Le dijo: 'Si el rey lo estima conveniente y si quiere hacerme un favor, si le parece justo al rey y si me dispensa su amistad, dé una orden por escrito para anular las cartas escritas por Amán, hijo de Hamdata, descendiente de Agag. Porque él escribió que se diera muerte a todos los judíos que se encuentran en las provincias del reino."
,"6":"¿Cómo podría yo presenciar la desgracia que va a caer sobre mi pueblo? ¿Cómo podría presenciar la destrucción de mi raza?»"
,"7":"El rey Asuero respondió a la reina Ester y al judío Mardoqueo: 'Di a Ester la casa de Amán y a éste lo colgué por haber inculpado a los judíos."
,"8":"Escriban pues respecto a los judíos, en nombre del rey, como lo estimen conveniente, y pongan el sello del anillo real, porque no puede ser anulada una carta en nombre del rey y sellada con el anillo real»."
,"9":"El vigésimo tercer día del tercer mes (el mes de Siván) reunieron pues a los secretarios del rey y escribieron lo que dictó Mardoqueo a los judíos, a los gobernadores, a los funcionarios, a los responsables de las provincias, desde la India a Etiopía. Escribieron a las ciento veintisiete provincias, a cada provincia en su escritura, a cada pueblo en su lengua."
,"10":"Se escribió en nombre del rey Asuero, se selló con el anillo real, y se entregaron las cartas a jinetes que montaban caballos de las caballerizas reales."
,"11":"En esas cartas el rey autorizaba a los judíos, en cada ciudad, a juntarse y a defender sus vidas. Podían aplastar, matar y exterminar junto con sus mujeres e hijos a todos los que los atacasen con armas, en la provincia que fuera; y también podían apoderarse de sus bienes."
,"12":"Eso sería el mismo día en todas las provincias del reino de Asuero, el día trece del duodécimo mes (es decir el mes de Adar)."
}`)
	CurrentBook.AddChapter(9, `{
"1":"El día trece del duodécimo mes (el mes de Adar), se dio vuelta la situación: el mismo día en que se debía ejecutar la orden del rey y su decreto, ese día en que los enemigos de los judíos habían pensado exterminarlos, los judíos derrotaron a los que los odiaban."
,"2":"En todas las provincias del reino de Asuero, se reunieron los judíos en sus ciudades para castigar a los que les habían deseado el mal; nadie pudo oponerles resistencia porque todos los pueblos tenían miedo de los judíos."
,"3":"Todos los gobernadores de provincia, los jefes, los responsables y los funcionarios del rey, ayudaron a los judíos por temor a Mardoqueo."
,"4":"Porque Mardoqueo era un personaje importante en el palacio real; su fama se había extendido por todas las provincias y ese hombre Mardoqueo se volvía cada vez más poderoso."
,"5":"Los judíos pasaron a espada a todos sus enemigos; ¡fue una matanza, una carnicería! Hicieron lo que quisieron con todos los que los odiaban."
,"6":"En la fortaleza de Susa los judíos mataron y masacraron a quinientos hombres."
,"7":"Parsandata, Dalfón, Aspata,"
,"8":"Porata, Adalia, Aridata,"
,"9":"Parmasta, Arisai, Aridai y Yezada,"
,"10":"los diez hijos de Amán, hijo de Hamdata, el enemigo de los judíos, fueron asesinados; sin embargo los judíos no se dedicaron al pillaje."
,"11":"Ese día supo el rey el número de los que habían sido muertos en la fortaleza de Susa."
,"12":"El rey dijo entonces a la reina Ester: 'Si únicamente en la fortaleza de Susa los judíos han dado muerte y masacrado a quinientos hombres y a los hijos de Amán, ¿qué no habrán hecho en las demás provincias? Pero dime lo que quieras, pues se te concederá. ¿Tienes alguna solicitud? Lo que pidas se hará."
,"13":"Ester le dijo: 'Si el rey lo quiere, permítales a los judíos de Susa proseguir mañana con lo que han hecho hoy día, tal como lo ha decretado el rey, y que cuelguen de la horca a los diez hijos de Amán'."
,"14":"El rey decidió que se hiciera así. Se publicó en Susa un decreto, y colgaron a los diez hijos de Amán."
,"15":"Los judíos de Susa se juntaron el día catorce del mes de Adar y mataron en Susa a trescientos hombres más, pero no se apoderaron de sus bienes."
,"16":"Los demás judíos que estaban en las provincias del reino, se reunieron también para defender sus vidas; hicieron lo necesario para no tener problemas con los que los odiaban y mataron a setenta y cinco mil enemigos; pero no se apoderaron de sus bienes."
,"17":"Todo eso lo hicieron el día trece del mes de Adar y dedicaron el día catorce a un día de descanso, de banquetes y de fiesta."
,"18":"Los judíos que vivían en Susa se reunieron los días trece y catorce del mes, y dedicaron el día quince del mes a un día de descanso, de banquetes y de fiesta."
,"19":"A eso se debe que los judíos que viven en el campo o en ciudades no fortificadas, dediquen el día catorce del mes de Adar a un día de esparcimiento, de banquetes y de fiesta; cada cual envía regalos a su vecino, para esa ocasión."
,"20":"Mardoqueo puso todo eso por escrito y despachó cartas a todos los judíos de las diferentes provincias de Asuero, tanto a los que estaban más cerca como a los que estaban más lejos."
,"21":"Les ordenaba que celebraran cada año los días catorce y quince del mes de Adar."
,"22":"Porque en esos días los judíos se habían librado, por fin, de sus enemigos; en ese mes las lágrimas habían dejado el lugar a la alegría, y el pesar a la fiesta. En esos días debían organizar banquetes y entretenimientos, mandarse regalos unos a otros y hacer ofrendas para los pobres."
,"23":"Los judíos transformaron en costumbre lo que habían hecho esos días, tal como Mardoqueo se lo había ordenado."
,"24":"Amán, hijo de Hamdata, de la raza de Agag, el enemigo de los judíos, había tramado un plan para exterminarlos; había tirado el Pur, es decir el sorteo, para destruirlos y aplastarlos,"
,"25":"pero cuando el rey lo supo, ordenó mediante un decreto que recayera sobre la cabeza del culpable su malvado proyecto contra los judíos, y que lo colgaran de la horca junto con sus hijos."
,"26":"Debido a la palabra Pur, esos días son llamados los Purim. Como consecuencia de la carta del rey, de lo que habían visto y de lo que les había sucedido,"
,"27":"los judíos establecieron esta regla para ellos, para sus descendientes y para todos los que se les juntaran, que celebrarían cada año, para la fecha indicada, sin faltar nunca, esos dos días, según la norma prescrita."
,"28":"Cada generación, cada clan, cada provincia, cada ciudad debía conmemorar y celebrar esos dos días, para que los judíos no lo olvidaran jamás, para que su recuerdo nunca se borrara."
,"29":"La reina Ester, hija de Abijail, y el judío Mardoqueo dieron el apoyo de su autoridad a esa segunda carta que se refería a los Purim."
,"30":"Se despacharon cartas a todos los judíos de las ciento veintisiete provincias del reino de Asuero, con palabras de paz y de amistad,"
,"31":"para instituir esos días de los Purim, para recordarles la fecha determinada por Mardoqueo el judío y por la reina Ester, y las normas establecidas para ellos y sus descendientes, como también todo lo relacionado con los ayunos y las lamentaciones."
,"32":"El decreto de Ester que establecía la institución de los Purim fue anotado en un libro."
}`)
	CurrentBook.AddChapter(10, `{
"1":"El rey Asuero estableció un impuesto en los países continentales y en las islas del mar."
,"2":"Todo lo que hizo durante su reinado, su valentía, los detalles concernientes a los honores otorgados por el rey a Mardoqueo, ¿no se encuentra todo eso escrito en el Libro de las Crónicas de los reyes de Media y Persia?"
,"3":"Mardoqueo, el judío, era el segundo del reino después de Asuero; era respetado por los judíos, amado por la multitud de sus hermanos, porque buscaba el bien de su pueblo y la paz de toda su raza."
,"4":"Mardoqueo dijo: 'Todo esto ha venido de Dios."
,"5":"Cuando me acuerdo del sueño que tuve al respecto, no hay un solo detalle que no se haya cumplido:"
,"6":"ni el pequeño manantial que se transforma en un río, ni la luz ni el sol ni el caudal desbordante. El río es Ester,"
,"7":"con la que el rey se casó y a quien hizo reina;"
,"8":"los dos dragones éramos Amán y yo, las naciones son las que se confabularon para borrar el nombre de los judíos;"
,"9":"mi pueblo son los hijos de Israel que clamaron a Dios y fueron librados. El Señor ha salvado a su pueblo, el Señor nos ha librado de todas esas desgracias, realizando grandes milagros y grandes prodigios, como nunca antes los había hecho entre los paganos."
,"10":"Es evidente que Dios sorteó dos destinos, uno para el pueblo de Dios y otro para todas las naciones paganas."
,"11":"La hora, el momento y el día del juicio son dos destinos que están presentes ante Dios y presentes en medio de las naciones."
,"12":"Dios se acordó de su pueblo y les hizo justicia a los suyos."
,"13":"Por eso, de generación en generación y por siempre, el pueblo de Israel pasará esos dos días, el catorce y el quince del mes de Adar, en asambleas jubilosas y en esparcimiento ante Dios'. El año cuarto del reinado de Tolomeo y de Cleopatra, Dositeo se presentó como sacerdote y Levita junto con su hijo Tolomeo; hizo entrega de la presente carta relativa a los Purim. Sostuvo que era auténtica y que había sido traducida por Lisímaco, hijo de Tolomeo, un hombre de la comunidad de Jerusalén."
}`)
	CurrentBook.AddChapter(11, `{
"1":"El segundo año del reinado del gran rey Asuero,"
,"2":"tuvo un sueño Mardoqueo, hijo de Jair, hijo de Simer, hijo de Kich, de la tribu de Benjamín."
,"3":"Ese judío, que vivía en Susa, era un personaje muy conocido en la corte del rey;"
,"4":"formaba parte de los desterrados que Nabucodonosor, rey de Babilonia, había traído cautivos junto con Jeconías, rey de Judá."
,"5":"Este fue el sueño de Mardoqueo. De repente se sienten gritos y ruidos espantosos, retumba el trueno, tiembla la tierra; todo se conmueve."
,"6":"Entonces se aproximan dos enormes dragones listos para enfrentarse. Lanzan un rugido,"
,"7":"e inmediatamente todas las naciones se preparan para atacar al pueblo de los justos."
,"8":"¡Es un día de tinieblas y oscuridad, día de prueba y de angustia, de violencia y de terror, en toda la tierra!"
,"9":"Todo el pueblo de los justos está espantado, temen la desgracia y se preparan para morir. Pero claman a Dios,"
,"10":"y su clamor hace surgir un pequeño manantial que se transforma en un gran río de un caudal desbordante."
,"11":"Luego vuelve la luz y se levanta el sol, triunfan los humildes y devoran a los orgullosos."
,"12":"En ese momento se despertó Mardoqueo. No dejaba de pensar que debía haber algún proyecto de Dios en el sueño que había tenido. Hasta el anochecer trató por todos los medios de comprender su sentido."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Como Mardoqueo se alojaba en uno de los patios del palacio junto con dos eunucos, Bigtán y Terés, que custodiaban las puertas, los oyó conversar."
,"2":"Trató de entender su conversación y descubrió que se preparaban para asesinar al rey Asuero; inmediatamente los fue a denunciar al rey."
,"3":"El rey mandó interrogar a los dos eunucos; y como éstos confesaran, los condenó a muerte."
,"4":"Después el rey mandó anotar en sus Memorias el relato de ese acontecimiento, y Mardoqueo por su parte hizo otro tanto."
,"5":"Para recompensar a Mardoqueo, el rey le confirió un cargo en su palacio y le dio numerosos regalos."
,"6":"Pero ese asunto de los dos eunucos del rey atrajo a Mardoqueo la enemistad de Amán, hijo de Hamdata, descendiente de Agag, quien era el favorito del rey."
}`)
	CurrentBook.AddChapter(13, `{
"1":"'¡El gran rey Asuero a los gobernadores de las ciento veintisiete provincias que van desde la India a Etiopía, y a los jefes de región que son sus súbditos!"
,"2":"Aunque estoy a la cabeza de innumerables pueblos y aunque soy dueño de toda la tierra, me he hecho un deber no dejarme embriagar por el orgullo del poder, gobernar siempre con sabiduría y benevolencia, garantizar continuamente a mis súbditos una vida en paz. Quiero extender hasta los límites de mi reino la civilización y la libre circulación, de tal manera que reine la paz que todos desean."
,"3":"Mis consejeros me están informando cuáles son los medios para alcanzar este objetivo. Pues bien, un hombre cuya sabiduría es eminente, cuya entrega no tiene falla, cuya fidelidad es a toda prueba, y que ocupa el segundo puesto en el reino -me refiero a Amán-"
,"4":"ese hombre ha denunciado ante nosotros a un pueblo lleno de malas intenciones, que está entremezclado con todos los pueblos del mundo. Sus leyes lo ponen en conflicto con todas las naciones; esa gente ignora sistemáticamente las órdenes de los reyes, hasta el punto de arruinar los esfuerzos de un gobierno que dirigimos de manera irreprochable."
,"5":"Hemos constatado que ese pueblo, único en su género, se opone constantemente al resto de la humanidad, mantiene malos sentimientos hacia nuestro gobierno, y está dispuesto a cometer los peores crímenes para impedir que el reino viva en paz."
,"6":"En vista de eso, hemos ordenado lo siguiente: Todos los que sean designados en las cartas de Amán, quien es responsable del gobierno y es para nosotros como un segundo padre, serán exterminados radicalmente junto con sus mujeres e hijos el día catorce del duodécimo mes (el mes de Adar) del presente año. Serán ejecutados por la espada de sus enemigos sin ninguna piedad ni miramiento."
,"7":"De esta manera los opositores de ayer y de hoy serán enviados, en un solo día, al lugar de los muertos, y los asuntos públicos recuperarán la paz y la tranquilidad para el porvenir»."
,"8":"Mardoqueo oró al Señor, recordándole todas sus maravillas, y le dijo:"
,"9":"'Señor, Señor, Rey todopoderoso, todo está en tus manos, y nadie puede oponérsete si tú has decidido salvar a Israel."
,"10":"Tú hiciste el cielo, la tierra y todas las maravillas que están bajo el cielo."
,"11":"Tú eres el Señor de todas las cosas y nadie puede resistirte, porque tú eres el Señor."
,"12":"Tú lo sabes todo, Señor; tú sabes que no fue por insolencia ni por orgullo ni por vanidad que me negué a hincarme ante ese orgulloso de Amán;"
,"13":"sin embargo estaría dispuesto a besar la planta de sus pies con tal de salvar a Israel."
,"14":"Pero he actuado así para no poner la gloria de un hombre por encima de la gloria de Dios. No quiero adorar a nadie más que a ti, mi Señor, y no lo hago por orgullo."
,"15":"Ahora Señor, Dios y Rey, Dios de Abrahán, salva a tu pueblo, ahora que tienen fijos sus ojos en nosotros para destruirnos y para hacer desaparecer el pueblo que te pertenece desde el principio."
,"16":"No abandones a tu pueblo, al que libraste de Egipto."
,"17":"Atiende a mi oración, mira favorablemente a tu pueblo, transforma nuestro pesar en alegría. Haz que vivamos y entonaremos cánticos en honor de tu nombre, Señor. No permitas que desaparezcan los que cantan tus alabanzas»."
,"18":"Y todo Israel clamaba con todas sus fuerzas porque se veían enfrentados a la muerte."
}`)
	CurrentBook.AddChapter(14, `{
"1":"La reina Ester se refugió junto al Señor, presa de una angustia mortal."
,"2":"Se había quitado sus vestidos de reina y se había puesto vestidos pobres y de luto. En vez de ricos perfumes se había cubierto la cabeza de cenizas y de basura."
,"3":"Humillaba severamente su cuerpo: en vez de adornarlo con joyas lo cubría con sus cabellos sueltos y así suplicaba al Señor, el Dios de Israel:"
,"4":"'¡Oh Señor mío, nuestro rey, tú eres el Unico! Ven en mi socorro, porque estoy sola y no tengo más ayuda que tú, y debo arriesgar mi vida."
,"5":"Desde mi nacimiento aprendí de mis padres que tú elegiste a Israel entre todos los pueblos, y a nuestros padres entre todos sus antepasados. Tú los nombraste tus herederos y tú cumpliste con ellos tus promesas."
,"6":"Pero luego pecamos contra ti y nos entregaste en manos de nuestros enemigos"
,"7":"porque habíamos servido a sus dioses. ¡Tú eres justo, Señor!"
,"8":"Pero no les bastó con ver nuestra triste esclavitud, sino que apelaron a sus ídolos para arruinar el decreto que había salido de tu boca,"
,"9":"para hacer desaparecer a tus herederos, para cerrar la boca de los que te cantan, extinguir la gloria de tu altar y de tu Templo."
,"10":"Mira cómo los paganos se aprestan a cantar la victoria de sus ídolos, a extasiarse sin cesar ante un rey que no es más que un hombre."
,"11":"¡Señor, no entregues tu realeza a los que son nada! ¡Que nadie pueda reírse de nuestra desgracia! Que sus proyectos se vuelvan en su contra y que lo que hagas con el que los trama en contra de nosotros sirva de escarmiento."
,"12":"Acuérdate Señor, muéstrate en el día de nuestra prueba, y dame a mí valor, Rey de los dioses y Señor de toda autoridad."
,"13":"Cuando esté ante el león, pon en mis labios las palabras que le seduzcan, transforma su corazón para que odie a nuestro enemigo, para que lo haga perecer junto con todos los que se le parecen."
,"14":"En cuanto a nosotros, que tu mano nos salve. Ven a socorrerme, porque estoy sola y no tengo a nadie más que a ti, Señor."
,"15":"Tú lo sabes todo, tú sabes que detesto la gloria de los impíos y que me horroriza la cama de los paganos y de cualquier extraño,"
,"16":"pero sabes que estoy obligada a ello. La corona que debo llevar puesta los días de fiesta, como señal de mi grandeza, me disgusta tanto como la toallita sucia con la menstruación de una mujer; por eso, cuando estoy en mi casa no la llevo puesta."
,"17":"Tu esclava no ha comido en la mesa de Amán, ni le gustan los banquetes de los reyes, ni tampoco prueba su vino."
,"18":"Tu esclava no ha conocido otra alegría más que tú, Señor, Dios de Abrahán, desde el día de su coronación hasta ahora."
,"19":"¡Oh Dios, tú que superas a todos, atiende los ruegos de los desesperados, líbranos de la mano de los malvados, y líbrame de mi miedo!»"
}`)
	CurrentBook.AddChapter(15, `{
"4":"Al tercer día, cuando hubo terminado su oración, se quitó sus vestidos de penitencia y se puso su traje de gala."
,"5":"Deslumbrante de belleza, invocó al Dios que todo lo ve y que salva, luego tomó a dos de sus damas:"
,"6":"se apoyaba en una de ellas,"
,"7":"mientras que la otra la acompañaba, sosteniendo la cola de su traje."
,"8":"Estaba en la cumbre de su belleza, estaba sonrojada y su rostro irradiaba confianza; sin embargo el miedo hacía estremecer su corazón."
,"9":"Después de haber atravesado todas las puertas, se presentó ante el rey. Este estaba sentado en su trono real, revestido de todos los ornamentos para las fiestas solemnes: el brillo del oro y de las piedras preciosas lo hacían aparecer terrible."
,"10":"Resplandeciente de gloria levantó la vista y lanzó una mirada furiosa. La reina se desmayó, se puso pálida e inclinó la cabeza sobre la dama que la acompañaba."
,"11":"Dios entonces transformó el corazón del rey y lo dispuso a la ternura. Muy preocupado, el rey se levantó de su trono y la tomó en sus brazos hasta que volviera en sí. La reconfortaba con palabras llenas de delicadeza:"
,"12":"'¿Qué te pasa Ester? ¡Soy tu hermano!"
,"13":"Tranquilízate, no morirás. Nuestro decreto se refiere a la gente común, acércate»."
,"14":"Levantó luego su cetro de oro y lo puso en el cuello de Ester, la abrazó y le dijo: 'Háblame». 'Señor, respondió ella, te vi como si fueras un ángel de Dios."
,"15":"Tu gloria inspira terror y mi corazón se estremeció. Porque tú eres admirable, señor, y tu rostro es encantador»."
,"16":"Mientras hablaba, se desmayó nuevamente; el rey estaba muy preocupado y sus cortesanos trataban de reanimarla."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Este fue el texto de la carta: 'El gran rey Asuero saluda a los gobernadores de las ciento veintisiete provincias que se extienden desde la India a Etiopía, a los funcionarios de las provincias y a todos los fieles súbditos."
,"2":"Muchas personas se hinchan de orgullo por haber sido demasiado colmadas de honores debido a la extrema bondad de sus bienhechores;"
,"3":"no contentos con perjudicar a nuestros súbditos, han llegado en su insolencia desenfrenada a complotar contra sus propios bienhechores."
,"4":"Con ellos el reconocimiento ha desaparecido del corazón humano; cegados por la locura propia de los que no tienen ningún sentido del bien, piensan escapar a la justicia del Dios que lo observa todo y que combate el mal."
,"5":"Así es como, a menudo, aquellos que han sido puestos en el poder, han debido soportar el peso de sangre inocente y verse involucrados en sucesos lamentables, por haber confiado a amigos deshonestos la administración de sus asuntos."
,"6":"Y esos amigos abusaron con discursos pérfidos de la confiada generosidad de sus soberanos."
,"7":"No es necesario remontarse a la historia antigua, basta con observar lo que hoy sucede para ver los crímenes cometidos por la maldad de gente indigna del poder."
,"8":"En adelante estaremos muy atentos en procurar a todos los habitantes de nuestro reino la tranquilidad y la paz."
,"9":"Haremos los ajustes necesarios y juzgaremos con indulgencia y benevolencia todo lo que llegue hasta nosotros."
,"10":"Así fue como Amán, hijo de Hamdata, un macedonio, un hombre totalmente extraño a la raza de los persas, y más extraño aún a nuestra bondad, recibió en medio de nosotros la hospitalidad."
,"11":"Recibió de parte nuestra la acogida que brindamos a cada pueblo, hasta el punto que lo llamamos nuestro padre. Llegó a ser el segundo personaje del reino y todos se postraban ante él."
,"12":"Pero siendo incapaz de refrenar su orgullo, hizo todo lo posible por quitarnos el poder y la vida."
,"13":"Mediante toda clase de mentiras y falsedades nos exigió la muerte de Mardoqueo, de aquel que nos había salvado la vida y que no dejaba de hacernos el bien, como también la muerte de Ester, la compañera irreprochable de nuestra realeza, y la muerte de todo su pueblo."
,"14":"De esa manera pensaba privarnos de su apoyo y entregar a los macedonios el imperio de los persas."
,"15":"Mientras ese triple criminal quería exterminar a los judíos, comprobamos por nuestra parte que éstos no son malhechores sino gente que vive según leyes muy justas."
,"16":"Son los hijos del Dios vivo, altísimo y grandísimo,"
,"17":"quien ha hecho que prospere el reino, tanto para nosotros como para nuestros antepasados."
,"18":"Ustedes deberán, pues, no tomar en cuenta las cartas despachadas por Amán, hijo de Hamdata, porque su autor fue ahorcado junto con toda su familia a las puertas de Susa. El Dios todopoderoso le infligió sin demora el castigo que merecía."
,"19":"Expongan en todos los lugares públicos la copia de esta carta, y dejen que los judíos practiquen sus costumbres."
,"20":"El día trece del duodécimo mes, el mes de Adar, los ayudarán a humillar a los que los inculparon durante la opresión."
,"21":"Dios, en efecto, Dueño de todo, ha hecho de ese día previsto para exterminar a la raza elegida, un día de fiesta para ellos."
,"22":"Por eso también ustedes, entre sus fiestas oficiales, celebren este día excepcional con toda clase de regocijos, pidiendo que desde ahora y para siempre llegue el bienestar para nosotros y para todos los que aman a los persas."
,"23":"Pero para los que buscan nuestro mal, sea ese día el recuerdo de su desgracia."
,"24":"La ciudad o provincia que no siga estas instrucciones será brutalmente devastada a sangre y fuego. No podrá ser más habitada por hombres y hasta las fieras salvajes y las aves huirán de allí'."
,"13":"Debía enviarse una copia de esa carta a cada provincia y darse a conocer a todos los pueblos; en el día señalado los judíos deberían estar listos para vengarse de sus enemigos."
,"14":"Los mensajeros, montados en caballos del estado, partieron inmediatamente para ejecutar sin tardanza la orden del rey. La ley fue publicada de igual modo en la fortaleza de Susa."
,"15":"Mardoqueo salió de la casa del rey con un traje real violeta y blanco, una gran corona de oro y un manto de lino y de púrpura, y en la ciudad de Susa hubo fiesta y alegría."
,"16":"Para los judíos todo era alegría desbordante, felicidad, fiesta y gloria."
,"17":"A medida que iban llegando a cada provincia y a cada ciudad la orden del rey y su decreto, para los judíos todo era alegría, fiesta, banquetes y celebraciones de todo tipo. Mucha gente del pueblo, en los distintos países, se hizo judía por temor a los judíos."
}`)

}
func ES_LBL_LoadVHIDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Josué había muerto. Los israelitas consultaron a Yavé: '¿Quién de nosotros, dijeron, subirá primero a atacar a los cananeos?'"
,"2":"Yavé respondió: 'Judá será quien subirá, pues he puesto el país en sus manos'."
,"3":"Los de Judá dijeron a sus hermanos de Simeón: 'Vengan a ayudarnos contra los cananeos en la parte que nos corresponde, y nosotros los ayudaremos en la de ustedes'. Y los de Simeón fueron a ayudarlos."
,"4":"Subió pues Judá y Yavé puso en sus manos a los cananeos y a los fereceos en Besec: derrotaron a diez mil hombres."
,"5":"En Besec se encontraron con Adoni-Besec; se trabaron en combate y derrotaron a los cananeos y a los fereceos."
,"6":"Adoni-Besec emprendió la fuga y lo persiguieron. Lo apresaron y le cortaron los pulgares de las manos y de los pies."
,"7":"Adoni-Besec dijo entonces: 'Setenta reyes, con los pulgares de las manos y de los pies cortados, recogían las migas debajo de mi mesa, hoy Dios me devuelve lo que hice'. Lo llevaron a Jerusalén y allí murió."
,"8":"La gente de Judá atacó Jerusalén. Se apoderaron de ella, la pasaron a cuchillo e incendiaron la ciudad."
,"9":"Después de esto, bajaron para atacar a los cananeos que vivían en la Montaña, en el Negueb y en la Tierra Baja."
,"10":"Judá atacó después a los cananeos que vivían en Hebrón (Hebrón se llamaba antes Quiriat-Arba); derrotaron a Sesai, Ajimán y Talmai."
,"11":"De allí se dirigieron para pelear con los habitantes de Debir (Debir se llamaba antes Quiriat-Sefer)."
,"12":"Caleb dijo entonces: 'Daré como esposa a mi hija Acsa a quien ataque a Quiriat-Sefer y se apodere de ella'."
,"13":"Otoniel, hijo de Quenaz, hermano menor de Caleb, se apoderó de ella y Caleb le dio su hija Acsa."
,"14":"En cuanto ella llegó, la impulsó a que pidiera a su padre un campo. Al verla que bajaba de su burro, Caleb dijo: '¿Qué quieres?'"
,"15":"Respondió: 'Hazme un favor; ya que me enviaste a esta zona del Negueb, dame al menos manantiales'. Caleb le dio pues las Fuentes de Arriba y las Fuentes de Abajo."
,"16":"Los hijos de Hobab el quenita, cuñado de Moisés, subieron con los hijos de Judá, desde la Ciudad de las Palmeras hasta el desierto de Judá, al sur de Arad. Allí se establecieron en medio del pueblo de Israel."
,"17":"Los de Judá salieron después con sus hermanos de Simeón. Derrotaron a los cananeos que vivían en Sefat y los condenaron al anatema, por eso la ciudad se llama Jormá."
,"18":"Judá no se apoderó de Gaza y su territorio ni de Asquelón y su territorio ni de Ecrón y su territorio."
,"19":"Judá se adueñó de la montaña con ayuda de Yavé, pero no pudo expulsar a los habitantes de la llanura, porque tenían carros de hierro."
,"20":"Tal como lo había ordenado Moisés, dieron Hebrón a Caleb; expulsó a los tres hijos de Anac."
,"21":"En cuanto a los jebuseos que vivían en Jerusalén, los hijos de Benjamín no los expulsaron, y por eso hasta hoy día los jebuseos viven en Jerusalén junto con los hijos de Benjamín."
,"22":"La gente de la casa de José emprendió una expedición contra Betel y Yavé estuvo con ellos."
,"23":"Instalaron su campamento frente a Betel (la ciudad se llamaba antes Luz)."
,"24":"Los espías vieron a un hombre que salía de la ciudad y le dijeron: 'Muéstranos por donde se puede entrar a la ciudad y te perdonaremos la vida'."
,"25":"Les mostró entonces cómo entrar en la ciudad. La pasaron a cuchillo, pero dejaron libre a ese hombre con toda su familia."
,"26":"El hombre se fue al territorio de los hititas y allí construyó una ciudad que se llamó Luz (y ese es el nombre que tiene todavía hoy)."
,"27":"Manasés no pudo apoderarse de la ciudad de Bet-Seán ni de sus dependencias, ni tampoco de Tanac, de Dor, de Jibleam y de Meguido; los cananeos se mantuvieron firmes en ese territorio."
,"28":"Pero cuando Israel fue más fuerte, redujo a servidumbre a los cananeos, sin empero eliminarlos."
,"29":"Efraín tampoco expulsó a los cananeos que vivían en Guezer; los cananeos siguieron pues viviendo allí con él."
,"30":"Zabulón no expulsó a los habitantes de Quitrón ni a los de Nahalol; así fue como los cananeos continuaron en medio de Zabulón pero fueron reducidos a servidumbre."
,"31":"Aser no expulsó a los habitantes de Acco ni a los de Sidón, de Majaleb, de Aczib, de Jelba, de Afec y de Rejov."
,"32":"La gente de Aser siguió pues viviendo en medio de los cananeos que poblaban la región, pues no los habían expulsado."
,"33":"Neftalí no echó a los habitantes de Bet-Seán ni a los de Bet-Anat: vivió pues en medio de los cananeos que habitan en la región, pero impuso trabajos forzados a los habitantes de Bet-Semés y de Bet-Anat."
,"34":"Los amoreos hicieron retroceder hasta la montaña a los hijos de Dan y les impidieron que bajaran a la llanura."
,"35":"Los amoreos se quedaron en Har-Jerés, en Ayalón y Saalbim, pero cuando la casa de José adquirió fuerza, fueron también reducidos a servidumbre."
,"36":"(El territorio de los edomitas se extiende de la Subida de los Escorpiones hasta la Roca y continúa luego subiendo)."
}`)
	CurrentBook.AddChapter(2, `{
"1":"El ángel de Yavé subió de Guilgal a Boquim. 'Los he hecho subir de Egipto, dijo, y los he traído a este país que prometí con juramento a sus padres. Yo había dicho: No romperé nunca mi alianza con ustedes,"
,"2":"y por su parte ustedes no harán alianza con los habitantes de este país sino que derribarán sus altares. Pero ustedes no me han hecho caso. ¿Qué es lo que han hecho?"
,"3":"Pues bien, esto he decidido yo: ¡No expulsaré a esa gente delante de ustedes! Estarán continuamente a su lado y sus dioses serán para ustedes una trampa'."
,"4":"Cuando el ángel de Yavé hubo hablado así a todo Israel, el pueblo lanzó alaridos y se puso a llorar."
,"5":"Por eso llamaron a aquel lugar Boquim y ofrecieron allí sacrificios a Yavé."
,"6":"Cuando Josué había despedido al pueblo, los israelitas habían vuelto cada uno a su parte de herencia, procurando conquistar el país."
,"7":"El pueblo sirvió a Yavé durante toda la vida de Josué y durante toda la vida de los ancianos que le sucedieron, pues habían visto los prodigios que había realizado Yavé en favor de Israel."
,"8":"Al morir Josué hijo de Nun, servidor de Yavé, a la edad de ciento diez años,"
,"9":"lo enterraron en el territorio que había recibido como herencia en Timnat-Herés, en la montaña de Efraín, al norte del monte Gaas."
,"10":"Cuando esa generación a su vez fue a reunirse con sus padres, le siguió otra generación que no conocía a Yavé ni sabía lo que éste había hecho por Israel."
,"11":"Los israelitas hicieron lo que es malo a los ojos de Yavé y sirvieron a los Baales."
,"12":"Abandonaron a Yavé, al Dios de sus padres que los había sacado del país de Egipto y siguieron a otros dioses. Se postraron ante los dioses de los pueblos que los rodeaban, y atrajeron sobre ellos la cólera de Yavé."
,"13":"En cuanto abandonaron a Yavé para servir a los Baales y a las Astartés, estalló la cólera de Yavé contra Israel."
,"14":"Los entregó en manos de salteadores que los despojaron, los vendió a sus enemigos de todo el contorno: ya no oponían más resistencia a sus enemigos."
,"15":"Cada vez que iban a la guerra, la mano de Yavé se alzaba en su contra para su desgracia, tal como Yavé se lo había dicho y jurado: estaban en una situación desastrosa."
,"16":"Entonces Yavé les dio jueces que los salvaron de las manos de los que los asaltaban."
,"17":"Pero tampoco escucharon a sus jueces. Se prostituyeron siguiendo a otros dioses y se postraron ante ellos. Bien pronto se apartaron del camino por donde habían andado sus padres cuando éstos hacían caso a los mandamientos de Yavé. Ellos, en cambio, hicieron todo lo contrario."
,"18":"Cuando Yavé les envió jueces, Yavé estaba con el juez, y durante toda la vida del juez los libraba de las manos de sus enemigos. Pues Yavé tenía piedad de ellos cuando escuchaba sus lamentos bajo la opresión y la persecución."
,"19":"Pero apenas moría el juez, volvían a hacer el mal, peor que sus padres. Seguían tras otros dioses, los servían y se postraban ante ellos. No querían renunciar a sus malas acciones y se empecinaban en su camino."
,"20":"Estalló pues la cólera de Yavé contra Israel y declaró: 'Ya que esta nación violó mi alianza que había hecho con sus padres y ya que no me escuchan,"
,"21":"yo tampoco expulsaré delante de ellos ni al más insignificante de los pueblos que Josué dejó al morir."
,"22":"De este modo probaré a Israel: tal vez así quieran seguir los caminos de Yavé, tal como lo hicieron sus padres'."
,"23":"Yavé dejó pues en paz a esas naciones que no había puesto en manos de Josué y no se apresuró en expulsarlas."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Estas fueron las naciones que Yavé dejó en paz para probar a Israel, es decir, a los israelitas que no habían conocido las guerras de Canaán."
,"2":"Quería que la juventud de Israel aprendiera a pelear, pues aquéllos no habían conocido la guerra."
,"3":"Así fue como quedaron los cinco príncipes de los filisteos, todos los cananeos y los sidonios, y también los jeveos que viven en la montaña del Líbano, desde la montaña de Baal-Hermón hasta la Entrada de Hamat."
,"4":"Yavé quiso pues poner a prueba a Israel y ver si obedecería sus mandamientos, los que Moisés había dado a sus padres."
,"5":"Los israelitas vivieron en medio de los cananeos, de los hititas, de los amoreos, de los fereceos, de los jeveos y de los jebuseos."
,"6":"Se casaron con sus hijas, dieron sus propias hijas a los hijos de aquellos, y sirvieron a sus dioses."
,"7":"Los israelitas hicieron lo que es malo a los ojos de Yavé. Se olvidaron de Yavé su Dios y sirvieron a los Baales y a los Aserás."
,"8":"Entonces estalló contra Israel la cólera de Yavé. Los dejó caer en las manos de Cusán-Riseataim, rey de Edom, y los israelitas estuvieron sometidos a Cusán-Riseataim por ocho años."
,"9":"Los israelitas clamaron a Yavé y Yavé hizo que surgiera para ellos un salvador que los libró: fue Otoniel, hijo de Quenaz, hermano menor de Caleb."
,"10":"El espíritu de Yavé se posó sobre él y se desempeñó como juez en Israel. Salió a guerrear y Yavé puso entre sus manos a Cusán-Riseataim, rey de Edom: derrotó a Cusán-Riseataim."
,"11":"El país estuvo en paz durante cuarenta años; luego Otoniel, hijo de Quenaz, murió."
,"12":"Una vez más los israelitas hicieron lo que es malo a los ojos de Yavé, y él volvió a Eglón rey de Moab mucho más fuerte que Israel, sencillamente porque hacían lo que desagrada a Yavé."
,"13":"Los moabitas se aliaron con los amonitas y con los amalecitas para luchar contra Israel, y se apoderaron de la Ciudad de las Palmeras."
,"14":"Los israelitas estuvieron sometidos a Eglón, rey de Moab, durante dieciocho años."
,"15":"Los israelitas clamaron entonces a Yavé, y Yavé hizo que les surgiera un salvador, Ehud, hijo de Guera, un hombre de Benjamín que era zurdo. Los israelitas le encargaron que llevara el tributo a Eglón, rey de Moab."
,"16":"Ehud se hizo un puñal de doble filo, y de hoja corta, que se puso bajo su ropa pegado a su muslo derecho."
,"17":"Luego fue a ofrecer el tributo a Eglón, rey de Moab, (Eglón era un hombre muy gordo)."
,"18":"De regreso, cuando estaban en los Idolos de Guilgal, Ehud ordenó que se fuera a la gente que había venido con él para presentar el tributo."
,"19":"El hizo el camino de vuelta y dijo: '¡Oh rey! Tengo para ti un mensaje secreto'. El rey respondió: '¡Silencio!' Y todos los que estaban a su alrededor se retiraron."
,"20":"Entonces Ehud se acercó a él, mientras estaba sentado en la pieza alta, tomando el fresco en sus departamentos privados. Ehud dijo: 'Es un mensaje de Dios que tengo para ti'. Entonces el rey se levantó de su silla."
,"21":"Ehud extendió su mano izquierda, agarró el puñal que tenía sobre su muslo derecho y se lo hundió en el vientre."
,"22":"El puño entró junto con la hoja y la grasa se cerró por encima de la hoja, pues no se la sacó del vientre, y salieron los excrementos."
,"23":"Ehud escapó por detrás, cerró tras él las puertas de la pieza superior y le echó el cerrojo."
,"24":"Después que salió, llegaron los sirvientes, y al ver con cerrojo la puerta de la pieza superior, se dijeron: 'Sin duda que está haciendo sus necesidades en sus departamentos privados'."
,"25":"Esperaron tanto que tuvieron vergüenza, pero las puertas de la pieza superior no se abrían. Entonces tomaron la llave y abrieron: ¡su patrón yacía por tierra, muerto!"
,"26":"Mientras ellos aguardaban, Ehud se había puesto a resguardo. Pasó por los Idolos y se puso a salvo en Ha-Seira."
,"27":"Apenas llegó, tocó el cuerno en la montaña de Efraín y los israelitas bajaron de la montaña siguiéndole."
,"28":"Les dijo: 'Síganme porque Yavé ha puesto a sus enemigos, los moabitas, en nuestras manos'. Todos bajaron tras él, cortaron los vados del Jordán en dirección a Moab y no dejaron escapar a ningún hombre."
,"29":"En aquella ocasión derrotaron a diez mil hombres de Moab, todos robustos y entrenados: no escapó ni uno solo."
,"30":"Aquel día Moab quedó sometido a Israel y el país quedó en paz por ochenta años."
,"31":"Después de él surgió Samgar, hijo de Anat. Venció a seiscientos hombres de los filisteos con una picana de bueyes; él también fue un libertador de Israel."
}`)
	CurrentBook.AddChapter(4, `{
"1":"De nuevo, después de la muerte de Ehud, los israelitas hicieron lo que es malo a los ojos de Yavé,"
,"2":"y Yavé los puso bajo las manos de Yabín, rey de Canaán, que reinaba en Hasor. Sísera era el jefe de su ejército y vivía en Haroset-ha-Goyim."
,"3":"Los israelitas clamaron a Yavé, porque Yabín tenía novecientos carros de hierro y oprimía duramente a los israelitas hacía veinte años."
,"4":"En aquel tiempo, la profetisa Débora, mujer de Lapidot, juzgaba a Israel."
,"5":"Se sentaba bajo la Palmera de Débora, entre Rama y Betel, en la montaña de Efraín, y los israelitas subían donde ella para obtener justicia."
,"6":"Mandó a buscar a Barac, hijo de Abinoam, de Cadés en Neftalí. Le mandó a decir: 'Esta es la orden de Yavé, el Dios de Israel: Dirígete al monte Tabor y recluta a diez mil hombres entre los hijos de Neftalí y los hijos de Zabulón."
,"7":"Yo atraeré hacia ti en el torrente de Quisón a Sísera, jefe del ejército de Yabín, junto con sus carros y todos sus hombres, y lo pondré en tus manos'."
,"8":"Barac le respondió: 'Si vienes conmigo iré, pero si no vienes no iré'."
,"9":"Ella le dijo: 'Muy bien, iré contigo, pero estás empezando mal, y la gloria de esta expedición no será para ti; Yavé pondrá a Sísera en manos de una mujer'. Se levantó pues Débora y Barac partió con ella rumbo a Cadés."
,"10":"En Cadés Barac reunió a Zabulón y a Neftalí, y lo siguieron diez mil hombres. Débora iba con él."
,"12":"Le avisaron a Sísera que Barac, hijo de Abinoam, se había dirigido al monte Tabor."
,"13":"Sísera reunió entonces a todos sus carros de hierro que llegaban a novecientos, como también a sus tropas, y vinieron de Haroset-ha-Goyim hasta el torrente de Quisón."
,"14":"Débora dijo entonces a Barac: 'Ha llegado el momento, hoy mismo Yavé pondrá a Sísera en tus manos. ¿No marcha Yavé delante de ti?',Barac bajó del monte Tabor seguido de sus diez mil hombres, "
,"15":"y Yavé hizo que derrotara a Sísera, a todos sus carros y todo su ejército; el mismo Sísera se bajó de su carro y huyó a pie."
,"16":"Barac salió en persecución de los carros y del ejército hasta Haroset-ha-Goyim, y todo el ejército de Sísera cayó bajo el filo de la espada; nadie escapó."
,"17":"Sísera había huido a pie hasta la tienda de Yael, mujer de Jeber el quenita, porque reinaba la paz entre Yabin, rey de Hasor, y Jeber el quenita."
,"11":"Este Jeber acampaba cerca de la Encina de Saananim, al lado de Cadés, después de separarse de los otros quenitas descendientes de Jobab, cuñado de Moisés."
,"18":"Yael salió al encuentro de Sísera y le dijo: '¡Ven para acá, señor. Ven para acá, no tengas miedo!' Fue donde ella, entró en su tienda y ella lo tapó con una manta."
,"19":"El le dijo: 'Dame un poco de agua para beber porque tengo sed'. Ella tomó un tiesto con leche y le dio de beber, luego lo volvió a tapar."
,"20":"El le dijo: 'Quédate a la entrada de la tienda, y si alguien te pregunta si hay aquí alguna persona, respóndele que nadie'."
,"21":"Pero Yael, mujer de Jeber, tomó una de las estacas de la tienda junto con un martillo, y acercándose suavemente por detrás de él le enterró la estaca en la sien con tal fuerza que se clavó en la tierra. El dormía profundamente porque estaba muy cansado, y así fue como murió."
,"22":"Cuando llegó Barac persiguiendo a Sísera, Yael salió a su encuentro y le dijo: 'Entra que te voy a mostrar al hombre que buscas'. Entró y vio a Sísera muerto, tendido en el suelo con la estaca en la sien."
,"23":"Ese día Dios humilló a Yabín, rey de Canaán, ante los israelitas."
,"24":"La mano de los israelitas se volvió cada vez más pesada para Yabín, rey de Canaán, hasta que lograron deshacerse de él."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Aquel día, Débora y Barac, hijo de Abinoam, entonaron este cántico:"
,"2":"En Israel los guerreros dejaron sus cabellos sueltos, del pueblo salieron voluntarios. ¡Bendigan a Yavé!"
,"3":"¡Escuchen reyes, soberanos presten atención, a Yavé le quiero cantar! ¡Cantaré para Yavé, para el Dios de Israel!"
,"4":"¡Oh Yavé! Cuando saliste de Seir, atravesando los campos de Edom, tembló la tierra, los cielos se deshicieron, las nubes se convirtieron en agua."
,"5":"Los montes se estremecieron al paso de Yavé, al paso de Yavé, el Dios de Israel."
,"6":"En tiempos de Samgar, hijo de Anat, en tiempos de Yael, las caravanas no viajaban, los viajeros tomaban caminos apartados."
,"7":"Las aldeas estaban desiertas, estaban desiertas en Israel hasta el día en que yo, Débora, me levanté, yo que fui una madre para Israel."
,"8":"Seguían a dioses nuevos, que antes no se veneraban, y los cuarenta mil hombres de Israel no tenían escudo ni lanza."
,"9":"Mi corazón se vuelve a los jefes de Israel, a los voluntarios del pueblo: ¡bendigan a Yavé!"
,"10":"¡Ustedes que van montados en blancas burras, que se sientan en sus alfombras, ustedes que van por los caminos, canten!"
,"11":"Cerca de los abrevaderos el pastor canta las liberaciones de Yavé, sus liberaciones y su bondad para con Israel. El pueblo de Yavé ha bajado a la frontera,"
,"12":"¡despiértate, despiértate, Débora!,¡Despiértate y despierta a tu pueblo!,¡Levántate, Barac, y somete a los que te sometían, hijo de Abinoam!"
,"13":"Que los que no cuentan venzan a los poderosos, el pueblo de Yavé se mostró valiente y venció."
,"14":"Los jefes de Efraín bajaron al valle. Benjamín va tras de ti entre tus tropas. Han bajado jefes desde Maquir, y de Zabulón los que llevan el cetro."
,"15":"Los jefes de Isacar están con Débora, Isacar está al lado de Barac, y en la llanura marcha tras sus huellas. Pero junto a los arroyos de Rubén no hay más que palabrería."
,"16":"¿Por qué te quedaste en tus potreros, oyendo la flauta de tus pastores? Junto a los arroyos de Rubén se contentan con palabrería."
,"17":"Galaad se quedó a la otra orilla del Jordán, Dan estaba en sus barcos, y Aser a la orilla del mar, tranquilo en sus puertos."
,"18":"Pero Zabulón es un pueblo que arriesga su vida, igual que Neftalí, en los campos de batalla."
,"19":"Llegaron los reyes y combatieron. En Tanac, cerca de las aguas de Meguido, combatieron los reyes de Canaán, pero no recogieron botín."
,"20":"De lo alto de los cielos combatieron las estrellas, desde sus caminos pelearon con Sísera."
,"21":"El torrente de Quisón los arrastró, el torrente de los tiempos antiguos, el torrente de Quisón. ¡Oh alma mía, avanza sin miedo!"
,"22":"¡Qué martilleo de cascos de caballos, de caballos a todo galope!"
,"23":"Maldigan a Meroz, dijo el ángel de Yavé, maldigan, maldigan a sus habitantes que no estuvieron allí para ayudar a Yavé, para ayudar a Yavé con los valientes."
,"24":"¡Bendita sea Yael, la mujer de Jeber el quenita, bendita sea entre las mujeres! Bendita sea entre las mujeres que viven en tiendas."
,"25":"El pidió agua, ella le dio leche; le ofreció leche cremosa en su mejor copa."
,"26":"Con una mano toma la estaca, y con su derecha el martillo del obrero. Golpea a Sísera y le rompe la cabeza, le rompe y traspasa su sien."
,"27":"Se desploma a sus pies, cae, está allí tendido. Cayó a sus pies, allí donde se desplomó está muerto."
,"28":"La madre de Sísera se asoma a la ventana, observa a través de la celosía: '¿Por qué, dice, tarda tanto en volver su carro? ¡Qué lentos son sus carros para volver!'"
,"29":"La más viva de sus mujeres le responde y ella misma se lo repite:"
,"30":"'Se están repartiendo el botín: una cautiva, dos cautivas para cada guerrero, paños de color para Sísera, bordados para su cuello'."
,"31":"¡Oh Yavé, que así perezcan tus enemigos! Y da a los que te aman el resplandor del sol. El país estuvo después tranquilo por cuarenta años."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Los israelitas hicieron lo que es malo a los ojos de Yavé, y Yavé los entregó por siete años en manos de Madián."
,"2":"La opresión de Madián fue dura para Israel, y debido a Madián los israelitas habitaron las hendiduras de las montañas, las grutas y los refugios."
,"3":"Cuando Israel sembraba, Madián hacía una incursión junto con Amalec y los hijos de Oriente."
,"4":"Se instalaban en su tierra y devastaban todos los campos hasta los alrededores de Gaza; nada le quedaba a Israel para comer, ni corderos ni bueyes ni burros."
,"5":"Sus rebaños y sus tiendas eran tan numerosos como las langostas; no se los podía contar ni a ellos ni a sus camellos cuando llegaban al país para arrasar con todo."
,"6":"Israel estaba en la miseria por culpa de Madián, y los israelitas clamaron a Yavé."
,"8":"Entonces Yavé mandó un profeta que les dijo: 'Esto dice Yavé, el Dios de Israel: Yo fui quien los hizo subir de Egipto, quien los hizo salir de la casa de la esclavitud."
,"9":"Así como los libré de la mano de los egipcios, así los he librado de todos aquellos que los oprimían. Los expulsé ante ustedes y les di a ustedes su país."
,"10":"Entonces les dije: Yo soy Yavé su Dios, no tomen en cuenta a los dioses de los amoreos en cuyo país viven. Pero ustedes no me hicieron caso'."
,"11":"El ángel de Yavé se fue a sentar bajo el terebinto que está en Ofra y que pertenecía a Joas, del clan de Abiezer. Gedeón, su hijo, estaba trillando el trigo en el lagar para esconderlo de los madianitas."
,"12":"El ángel de Yavé se le apareció y le dijo: '¡Yavé está contigo, valiente guerrero!'."
,"13":"Gedeón respondió: 'Perdona, señor, pero si Yavé está con nosotros, ¿por qué nos pasa todo esto? ¿Dónde están todos esos prodigios que nos contaron nuestros padres, cuando nos decían: Yavé nos hizo subir de Egipto? Lo que es ahora, Yavé nos ha dejado caer y nos ha entregado en las manos de Madián'."
,"14":"Entonces Yavé se volvió hacia él y le dijo: '¡Anda! Tú eres capaz de librar a Israel de la mano de Madián: yo soy quien te envía!'"
,"15":"Pero él respondió: 'Disculpa, señor, pero ¿cómo salvaré a Israel? Pues mi clan es el más pequeño de la tribu de Manasés y yo soy el más chico en la familia de mi padre'."
,"16":"Yavé le dijo: 'Yo estaré contigo y tú derrotarás a Madián como un solo hombre'."
,"17":"Respondió: 'Si realmente te he caído en gracia, hazme ver una señal y así sabré que eres tú quien me habla."
,"18":"No te alejes de aquí hasta que vuelva con una ofrenda que depositaré ante ti'. Yavé respondió: 'Me quedaré aquí hasta que vuelvas'."
,"19":"Se fue pues Gedeón; preparó un cabrito y con una medida de harina hizo panes sin levadura. Puso la carne en una canasta y el caldo en un una olla y lo llevó todo para ofrecérselo bajo el terebinto."
,"20":"El ángel de Dios le dijo entonces: 'Toma la carne y los panes sin levadura, deposítalos en esa roca y derrama el caldo'. Y así lo hizo."
,"21":"Entonces el ángel de Yavé extendió su bastón y con la punta tocó la carne y los panes sin levadura: salió fuego de la roca y consumió la carne y los panes sin levadura; el ángel de Yavé mientras tanto había desaparecido de su vista."
,"22":"Gedeón comprendió que era el ángel de Yavé y dijo: '¡Ay de mí, señor Yavé, porque realmente vi al Angel de Yavé cara a cara!'"
,"23":"Pero Yavé le dijo: 'No tengas miedo, porque no morirás'."
,"24":"Gedeón construyó en ese lugar un altar para Yavé, al que llamó: Yavé-Paz. Aún existe actualmente en Ofra, en las tierras de Abiezer."
,"25":"Esa misma noche le dijo Yavé: 'Toma el novillo de tu padre. Demolerás el altar de Baal que pertenece a tu padre y derribarás el poste sagrado que está al lado."
,"26":"Luego construirás un altar a Yavé tu Dios, en la cumbre de esta colina fortificada, y me sacrificarás el novillo, quemándolo con la leña del poste sagrado'."
,"27":"Gedeón tomó a diez de sus sirvientes e hizo lo que Yavé le había ordenado. Pero no lo hizo de día porque temía a la familia de su padre y a los hombres de la ciudad; por eso lo hizo de noche."
,"28":"Cuando los hombres de la ciudad se levantaron a la mañana siguiente, vieron que el altar de Baal había sido derribado, que el poste sagrado que estaba al lado había sido cortado, y que un novillo había sido ofrecido en holocausto en el nuevo altar."
,"29":"Se preguntaban unos a otros quién habría hecho eso. Se pusieron a investigar, a preguntar y se les dijo: 'Gedeón, hijo de Joás, fue quien lo hizo'."
,"30":"Los hombres de la ciudad dijeron a Joás: '¡Entréganos a tu hijo para que muera! Pues él fue quien demolió el altar de Baal y derribó el poste que estaba al lado'."
,"31":"Pero Joás respondió a la gente que lo amenazaba: '¿Así que ahora defienden a Baal? ¿Así que quieren salvarlo? Si Baal es Dios que se defienda por sí solo, ya que le han demolido su altar'."
,"32":"Ese día pusieron a Gedeón el sobrenombre de Jerubaal, porque decían: 'Que Baal se defienda de él ya que le destruyó su altar'."
,"33":"Se reunieron todos los madianitas, los amalecitas y los hijos de Oriente; atravesaron el Jordán y acamparon en la llanura de Jezrael."
,"34":"Entonces se apoderó de Gedeón el espíritu de Yavé. Tocó el cuerno y se puso tras él todo el clan de Abiezer."
,"35":"Mandó mensajeros a todo el territorio de Manasés, quien también se juntó tras él. Mandó también mensajeros a Aser, Zabulón y Neftalí, y vinieron a su encuentro."
,"36":"Gedeón dijo a Dios: 'Si realmente quieres salvar a Israel por mi mano, como lo has dicho, concédeme esta señal:"
,"37":"Pondré un vellón de lana en la era. Si solamente el vellón está con rocío, siendo que todo el suelo del derredor está seco, sabré que tú quieres librar a Israel por mi mano, como lo has dicho'."
,"38":"Y así sucedió. Cuando se levantó muy de mañana, tomó el vellón, lo estrujó y con el rocío llenó una copa."
,"39":"Gedeón dijo entonces a Dios: 'No te enojes conmigo si vuelvo a hablar: dame otra prueba con el vellón y que sólo quede seco el vellón mientras todo el suelo del derredor queda cubierto de rocío'."
,"40":"Así hizo Yavé que fuera esa noche, y el vellón quedó seco mientras que el rocío cubrió el suelo."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Jerubaal (es decir Gedeón) se levantó de madrugada y se fue a acampar con todo el pueblo que lo acompañaba encima de En-Jarod. El campamento de Madián estaba al norte del de Gedeón, en la llanura, al pie del monte Moré."
,"2":"Yavé dijo a Gedeón: 'El pueblo que te acompaña es demasiado. Si entregara a Madián en tus manos, Israel podría vanagloriarse a costa mía. Diría: Yo mismo me he librado."
,"3":"Vas pues a proclamar esto ante todo el pueblo: Cualquiera que tenga miedo o esté temblando, que se retire'. Y Gedeón se lo planteó. Se retiraron veintidós mil hombres del pueblo y quedaron diez mil."
,"4":"Yavé dijo a Gedeón: 'Todavía el pueblo es demasiado numeroso. Haz que bajen al agua y allí haré la selección. Si te digo por alguien: Que vaya contigo; irá contigo. Pero si te digo por otro: Que no vaya contigo; no irá contigo'."
,"5":"Se dispuso pues que el pueblo bajara al agua, y Yavé dijo a Gedeón: 'A los que laman el agua como lo hace el perro los separarás de los que se arrodillen para beber'."
,"6":"Los que lamieron el agua con su mano llevándosela a la boca, fueron trescientos, porque todo el resto del pueblo se arrodilló para beber."
,"7":"Yavé dijo entonces a Gedeón: 'Los salvaré y pondré a Madián en las manos de ustedes con esos trescientos hombres que lamieron el agua. Que todo el resto del pueblo se vuelva a su casa'."
,"8":"Se juntaron los víveres del pueblo y sus cuernos, después de lo cual Gedeón los despidió para su casa y se quedó con los trescientos hombres. El campamento de los madianitas estaba debajo de él, en la llanura."
,"9":"Esa noche Yavé dijo a Gedeón: 'Baja al campamento de los madianitas, nada tienes que temer de ellos."
,"10":"Si te da miedo bajar allá, baja con tu sirviente Purá."
,"11":"Escucharás lo que digan y eso te dará valor para ir a atacar su campamento'. Bajó pues con su sirviente Purá hasta los primeros puestos de los madianitas."
,"12":"Estos se habían instalado en toda la llanura junto con Amalec y todos los hijos de Oriente. Hormigueaban como las langostas y sus camellos eran tan numerosos como la arena de la orilla del mar."
,"13":"Gedeón, pues, bajó al campamento. Un hombre estaba contando un sueño a su compañero: 'Tuve un sueño: un pan de cebada saltaba por el campamento de Madián, hasta que llegó a la Tienda, chocó con ella y ésta se derrumbó'."
,"14":"Su compañero le respondió: 'Eso no puede ser otra cosa que la espada de Gedeón, hijo de Joás, el israelita. Ciertamente Dios puso todo el campamento de Madián en sus manos'."
,"15":"Cuando Gedeón oyó el relato del sueño y su interpretación, se postró. Regresó al campamento de Israel y dijo: '¡Levántense! Yavé ha puesto el campamento de Madián en nuestras manos'."
,"16":"Dividió a los trescientos hombres en tres grupos. A todos les pasó cuernos y cántaros vacíos con antorchas dentro."
,"17":"Luego les dijo: 'Fíjense bien y hagan lo mismo que yo. Apenas llegue cerca del campamento de los madianitas, harán como yo."
,"18":"Cuando yo, junto con los que estén conmigo, toquemos el cuerno, ustedes también tocarán el cuerno alrededor de todo el campamento y gritarán: '¡Por Yavé y por Gedeón!'"
,"19":"Gedeón y los cien hombres que lo acompañaban llegaron cerca del campamento de Madián al filo de la medianoche, cuando se acababa de hacer el relevo de los centinelas. Tocaron el cuerno y rompieron los cántaros que llevaban en la mano."
,"20":"Inmediatamente los tres grupos tocaron el cuerno y rompieron los cántaros. Tomaron las antorchas con la mano izquierda sin dejar de tocar el cuerno que sostenían en la mano derecha, y gritaban: '¡Espada para Yavé y Gedeón!'"
,"21":"Pero cada uno permaneció en su sitio alrededor del campamento. En el campamento todos se pusieron a correr, a gritar y a huir."
,"22":"Mientras seguían tocando el cuerno, Yavé hizo que en el campamento cada uno dirigiera su espada contra su hermano. Huyeron todos hasta Bet-ha-sita, para el lado de Sartán, y hasta la orilla de Abel Mejola frente a Tabat."
,"23":"Los hombres de Israel que habían venido de Neftalí, de Aser y de todo Manasés, se reagruparon y persiguieron a los madianitas."
,"24":"Gedeón mandó entonces mensajeros por toda la montaña de Efraín: 'Bajen al encuentro de los madianitas, y antes que lleguen ocupen los vados hasta Bet-Bará a lo largo del Jordán'."
,"25":"Hicieron prisioneros a los dos jefes de Madián, Oreb y Zeeb, mataron a Oreb en la Roca de Oreb y a Zeeb en el Lagar de Zeeb. De vuelta de la persecución a los madianitas, entregaron a Gedeón, al otro lado del Jordán, las cabezas de Oreb y de Zeeb."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Los hombres de Efraín dijeron a Gedeón: '¿Qué nos hiciste? ¡Ni siquiera nos convocaste cuando saliste a pelear con los madianitas!' Y estaban muy enojados con él."
,"2":"Pero Gedeón les respondió: 'Toda la vendimia de Abiezer no vale lo que Efraín rebuscó detrás de él."
,"3":"¿No puso Yavé en las manos de ustedes a los jefes de Madián Oreb y Zeeb? Lo que hice es nada en comparación con eso'. Cuando les hubo hablado así, se apaciguó su cólera."
,"4":"Cuando llegaron al Jordán, Gedeón lo atravesó con los trescientos hombres que lo acompañaban, pero estaban agotados por la persecución."
,"5":"Por eso dijeron a la gente de Sucot: 'Den, por favor, raciones de pan a la tropa que me acompaña porque mi gente está rendida. Estamos persiguiendo a Zebaj y a Salmuna, los reyes de Madián'."
,"6":"Pero los ancianos de Sucot le respondieron: '¿Ya les has atado las manos a Zebaj y a Salmuna? ¿Cómo quieres que demos pan a tus hombres?'"
,"7":"Gedeón les respondió: '¡Muy bien! Apenas Yavé ponga en mis manos a Zebaj y a Salmuna, les arrancaré a ustedes la piel con las espinas y cardos del desierto'."
,"8":"De allí partió para Penuel y dirigió las mismas palabras a la gente de Penuel. Estos respondieron tal como lo habían hecho los de Sucot."
,"9":"Les replicó a la gente de Penuel: 'Cuando vuelva como vencedor, derribaré esa torre'."
,"10":"Zebaj y Salmuna estaban en Carcor con un ejército de alrededor de quince mil hombres (eran los sobrevivientes del gran ejército de los hijos de Oriente, pues ya habían caído ciento veinte mil)."
,"11":"Gedeón subió por el camino de los Nómades, al este de Nobaj y de Yogboha, y arrasó con ese ejército que se sentía seguro."
,"12":"Zebaj y Salmuna huyeron, pero los persiguió, y apresó a los dos reyes de Madián, Zebaj y Salmuna, en tanto que su ejército era completamente derrotado."
,"13":"Después de la batalla, Gedeón, hijo de Joás, regresó por la subida de Jarés."
,"14":"Allí detuvo a un joven de Sucot y lo interrogó. Este le dio por escrito los nombres de los jefes de Sucot y de los ancianos; en total llegaban a setenta y siete."
,"15":"Gedeón fue a ver a la gente de Sucot y les dijo: 'Aquí están Zebaj y Salmuna por cuya causa ustedes se rieron de mí. Ustedes dijeron: 'Cuando Zebaj y Salmuna caigan en tus manos, daremos pan a tus hombres fatigados'."
,"16":"Entonces juntó a los ancianos de la ciudad, y mandó buscar espinas y cardos del desierto, con los que desgarró a la gente de Sucot."
,"17":"Gedeón derribó la torre de Penuel y masacró a los habitantes de la ciudad."
,"18":"Luego dijo a Zebaj y Salmuna: '¿Cómo eran esos hombres a los que ustedes mataron en el Tabor?' Respondieron: 'Se parecían a ti, cada uno tenía el aspecto de un hijo de rey'."
,"19":"Gedeón respondió: '¡Eran mis hermanos, los hijos de mi madre! Tan cierto como que Yavé vive que si ustedes los hubieran dejado con vida, yo no los mataría'."
,"20":"Entonces ordenó a Jeter, su hijo mayor: '¡Anda y mátalos!' Pero el joven no sacó su espada porque tenía miedo, pues era muy joven."
,"21":"Entonces Zebaj y Salmuna le dijeron: '¡Ven tu mismo y mátanos! A ver si eres hombre y te atreves'. Gedeón mató a Zebaj y Salmuna y tomó los adornos en forma de media luna que tenían sus camellos en el cogote."
,"22":"Los israelitas dijeron a Gedeón: 'Ya que nos libraste de la mano de los madianitas, tú serás nuestro rey, y después de ti, tu hijo y tu nieto'."
,"23":"Gedeón les respondió: 'Ni yo ni mi hijo reinaremos sobre ustedes: Yavé será su rey'."
,"24":"Gedeón añadió: 'Lo único que les pido es que cada uno de ustedes me dé un anillo de su botín (los vencidos eran Ismaelitas y tenían anillos de oro)'."
,"25":"Le dijeron: 'Por supuesto que te lo daremos'. Extendieron un manto en el suelo y cada uno echó allí un anillo de su botín."
,"26":"El peso de los anillos de oro fue de mil setecientos siclos, sin contar los prendedores, los aros y los trajes de púrpura que llevaban los reyes de Madián; y sin contar tampoco los collares que pendían del cogote de sus camellos."
,"27":"Con todo eso Gedeón se hizo un efod que puso en su ciudad en Ofra. Todos los israelitas iban allí a venderse; eso fue una trampa para Gedeón y su familia."
,"28":"En cuanto a los madianitas, quedaron en adelante sometidos a los israelitas y no volvieron a levantar cabeza. El país estuvo en paz cuarenta años, el tiempo que vivió Gedeón."
,"29":"Jerubaal, hijo de Joás, regresó a su casa y residió en ella."
,"30":"Gedeón tuvo setenta hijos, todos engendrados por él pues tuvo muchas mujeres."
,"31":"En Siquem tenía una concubina que también le dio un hijo, al que llamó Abimelec."
,"32":"Gedeón, hijo de Joás, murió en una feliz ancianidad. Lo enterraron en la tumba de su padre Joás, en Ofra, en el territorio de Abiezer."
,"33":"Después de la muerte de Gedeón, los israelitas volvieron a prostituirse siguiendo a los Baales: se dieron como dios a Baal-Berit."
,"34":"Así fue como los israelitas se olvidaron de Yavé su Dios, el que los había librado de todos sus enemigos vecinos."
,"35":"Ya no reconocieron más a la familia de Jerubaal-Gedeón todo lo bueno que había hecho por Israel."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Abimelec, hijo de Jerubaal, fue a ver a los hermanos de su madre en Siquem. Y les dijo, como también a toda la familia de su abuelo materno:"
,"2":"'Hagan esta pregunta a los señores de Siquem: '¿Prefieren ser gobernados por setenta hombres, todos hijos de Jerubaal, o tener un solo patrón? Acuérdense que yo soy de su sangre'."
,"3":"Los hermanos de su madre transmitieron todas estas palabras a los señores de Siquem, quienes se decidieron en favor de Abimelec, pues se decían: 'Es nuestro hermano'."
,"4":"Le entregaron setenta siclos de plata que tomaron del templo de Baal-Berit, y con este dinero Abimelec contrató a granujas y aventureros que se pusieron a su servicio."
,"5":"Se dirigió luego a Ofra, a la casa de su padre, y masacró a sus hermanos, los hijos de Jerubaal: los setenta fueron ejecutados en la misma roca. El menor de los hijos de Jerubaal, Yotam, se había escondido y escapó."
,"6":"Entonces todos los notables de Siquem y de Bet-Milló se reunieron y proclamaron rey a Abimelec, cerca de la Encina de la Estela, que está en Siquem."
,"7":"Le comunicaron la noticia a Yotam. Este subió a la cima del monte Garizim y desde allí gritó con todas sus fuerzas: '¡Escúchenme, notables de Siquem y Dios los escuche!"
,"8":"Un día salieron los árboles en busca de un rey. Dijeron al olivo: ¡Sé tú nuestro rey!"
,"9":"Pero el olivo les respondió: ¿Tendré que dejar mi aceite, tan apreciada por los dioses y los hombres, para ir a balancearme por encima de los demás árboles?"
,"10":"Los árboles se dirigieron entonces a la higuera: ¡Ven, tú serás nuestro rey!"
,"11":"La higuera les respondió: ¿Tendré que renunciar al dulzor de mi fruta tan apreciada para ir a balancearme por encima de los demás árboles?"
,"12":"Luego los árboles fueron donde la vid: ¡Ven, tú serás nuestro rey!"
,"13":"Pero la vid les respondió: ¿Tendré que renunciar a mi uva, que tanto alegra a los dioses y a los hombres, para ir a balancearme por encima de los árboles?"
,"14":"Entonces los árboles fueron a buscar a la zarza espinosa: ¡Ven, tú serás nuestro rey!"
,"15":"Y la zarza espinosa respondió a los árboles: 'Si realmente quieren hacerme rey y que los mande, vengan y quédense bajo mi sombra. Si no, saldrá fuego de la zarza espinosa y devorará hasta el cedro del Líbano."
,"16":"Pues bien, ¿han actuado ustedes con lealtad y honradez al hacer rey a Abimelec? ¿Se han portado bien con Jerubaal y su familia? ¿La han tratado como corresponde?"
,"17":"¿No combatió mi padre por ustedes? ¿No arriesgó su vida por ustedes? ¿No los libró acaso de manos de los madianitas?"
,"18":"Sin embargo, ustedes se han alzado ahora contra la familia de mi padre, han dado muerte a sus hijos, a los setenta en una misma roca. Y han convertido a Abimelec, el hijo de una esclava, en rey de los señores de Siquem, porque es de su sangre."
,"19":"Pues bien, si ustedes se han mostrado ahora fieles y leales a Jerubaal y a su casa, les deseo que Abimelec sea su dicha y ustedes la de él."
,"20":"Pero si no, que salga un fuego de Abimelec y devore a la gente de Siquem y de Bet-Milló, y que salga un fuego de la gente de Siquem y de Bet-Milló y devore a Abimelec'."
,"21":"En seguida Yotam se dio a la fuga y se refugió en Beer; allí se quedó porque tenía miedo de su hermano Abimelec."
,"22":"Abimelec gobernó a Israel tres años."
,"23":"Pero Dios envió un espíritu de discordia entre Abimelec y los habitantes de Siquem, y éstos traicionaron a Abimelec."
,"24":"Así fue como iba a ser vengado el crimen cometido con los setenta hijos de Jerubaal; su sangre recayó sobre Abimelec, su hermano, que los había asesinado y sobre la gente de Siquem que lo había ayudado a matar a sus hermanos."
,"25":"Para perjudicarlo, la gente de Siquem preparaba emboscadas en los desfiladeros de la montaña, de hombres que asaltaban a todos los que pasaban por allí cerca; se lo contaron a Abimelec."
,"26":"Llegó entonces Gaal, hijo de Obed, con sus hermanos. Se establecieron en Siquem y se ganaron la confianza de la gente de Siquem."
,"27":"Fueron al campo a hacer la vendimia de sus viñas, pisaron las uvas y prepararon una fiesta. Luego entraron en el templo de sus dioses, comieron y tomaron, y maldijeron a Abimelec."
,"28":"Gaal, hijo de Obed, dijo entonces: '¿Quién es ese Abimelec y qué es Siquem para que estemos a su servicio? Este hijo de Jerubaal y su segundón Zebul servían a los hombres de Hamor, padre de Siquem, ¿y nosotros ahora le serviríamos?"
,"29":"¡Ojalá fuera yo el jefe de este pueblo! Echaría a Abimelec y le diría: '¡Abimelec, ven para acá con todo tu ejército!'"
,"30":"Las palabras de Gaal, hijo de Obed, irritaron a Zebul, gobernador de la ciudad."
,"31":"Envió secretamente mensajeros a Abimelec para decirle: 'Gaal, hijo de Obed, acaba de llegar a Siquem con sus hermanos y han sublevado la ciudad en contra tuya."
,"32":"Levántate pues de noche junto con el pueblo que te acompaña y escóndete en el campo."
,"33":"Mañana, cuando salga el sol, levántate y ataca la ciudad. Y cuando Gaal y los que están con él salgan a enfrentarte, actúa como lo permitan las circunstancias'."
,"34":"Pues bien, Abimelec y todos los que estaban con él se levantaron de noche, y se pusieron al acecho alrededor de Siquem, repartidos en cuatro grupos."
,"35":"Cuando Gaal, hijo de Obed, vino a apostarse a la entrada de la ciudad, Abimelec y todos los que estaban con él salieron de su escondite."
,"36":"Al ver esa tropa, Gaal dijo a Zebul: 'Veo gente que baja de lo alto de la montaña'. Zebul le respondió: 'Tomas por hombres una sombra de la montaña'."
,"37":"De nuevo tomó la palabra Gaal y le dijo: 'Distingo a una tropa que baja de tierra adentro. Y otro grupo viene por el camino de la Encina de los Astrólogos'."
,"38":"Entonces Zebul le replicó: '¿Se te perdió ya esa lengua con la que decías: ¿quién es Abimelec para que le sirvamos? Allí está esa gente que menospreciaste. ¡Sal ahora y pelea con él!'"
,"39":"Salió pues Gaal a la cabeza de la gente de Siquem y se puso a combatir con Abimelec."
,"40":"Pero Abimelec lo persiguió y Gaal huyó delante de él: muchos perecieron antes de llegar a la puerta."
,"41":"Abimelec se quedó entonces en Aruma. Zebul por su parte expulsó a Gaal y a sus hermanos y les prohibió volver a Siquem."
,"42":"Al día siguiente, el pueblo salió al campo. Se lo comunicaron a Abimelec."
,"43":"Reunió a sus hombres y los repartió en tres grupos, luego tendieron una emboscada en el campo. Apenas vio que la gente salía de la ciudad, se lanzó sobre ellos."
,"44":"Abimelec con sus hombres corrieron para ubicarse a la entrada de la ciudad. Los otros dos destacamentos mientras tanto se lanzaban contra todos los que estaban en el campo y los mataban."
,"45":"Abimelec llevó a cabo el asalto de la ciudad durante todo ese día, se apoderó de ella y masacró a todos sus habitantes. Luego arrasó la ciudad y desparramó sal."
,"46":"Al saber eso, toda la gente de la Torre de Siquem se refugiaron en la cripta del templo de El-Berit."
,"47":"Cuando avisaron a Abimelec que toda la gente de la Torre de Siquem se había congregado allí,"
,"48":"tomó un hacha de doble filo con la que cortó un árbol, lo levantó y se lo puso al hombro. Luego dijo a los que lo acompañaban: 'Vieron lo que hice, apresúrense en hacer lo mismo que yo'."
,"49":"Cada uno de sus hombres cortó entonces una rama. Salieron caminando tras Abimelec y pusieron las ramas sobre la cripta, luego le prendieron fuego y quemaron la cripta. Así murió toda esa gente de la Torre de Siquem: cerca de mil hombres y mujeres."
,"50":"Abimelec se dirigió a Tebés; la sitió y se apoderó de ella."
,"51":"Pero había dentro de la ciudad una torre fortificada en la que se refugiaron hombres y mujeres, toda la gente noble de la ciudad. Cerraron la puerta tras ellos y se subieron a la terraza de la torre."
,"52":"Abimelec se acercó al pie de la torre para atacarla y avanzó hasta la puerta de la torre para prenderle fuego."
,"53":"Pero una mujer dejó caer sobre su cabeza una piedra de molino, que le partió el cráneo."
,"54":"Inmediatamente llamó a su escudero y le dijo: '¡Saca tu espada y mátame! No quiero que digan de mí: Lo mató una mujer'. Su escudero entonces lo traspasó y murió."
,"55":"Al ver los israelitas que había muerto Abimelec, se volvieron cada cual a su casa."
,"56":"Así fue como Dios devolvió a Abimelec el mal que éste había hecho a su padre asesinando a sus setenta hermanos,"
,"57":"y Dios hizo que recayera sobre los hombres de Siquem toda su maldad. Así se cumplió en ellos la maldición de Yotam, hijo de Jerubaal."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Después de Abimelec surgió Tola, hijo de Puá, hijo de Dodó, para librar a Israel. Era de la tribu de Isacar y vivía en Samir, en la montaña de Efraín."
,"2":"Fue juez de Israel durante veinte años, después murió y lo enterraron en Samir."
,"3":"Después de él surgió Yaír de Galaad. Fue juez de Israel veintidós años."
,"4":"Tenía treinta hijos que andaban en treinta burros, y poseía treinta ciudades que todavía se llaman las aldeas de Yaír, en el territorio de Galaad."
,"5":"Cuando Yaír murió, lo enterraron en Camón."
,"6":"De nuevo hicieron los israelitas lo que es malo a los ojos de Yavé. Sirvieron a los Baales y a las Astartés como también a los dioses de Aram, de Sidón, de Moab, de los amonitas y de los filisteos. Abandonaron a Yavé y no le sirvieron más."
,"7":"Por eso estalló contra Israel la cólera de Yavé, quien lo entregó en manos de los filisteos y de los amonitas."
,"8":"A partir de ese año aplastaron y maltrataron a todos los israelitas que vivían al otro lado del Jordán, en territorio amoreo, en Galaad, y esto duró dieciocho años."
,"9":"Los amonitas atravesaron incluso el Jordán para atacar a Judá, Benjamín y la casa de Efraín: Israel se hallaba en una situación muy grave."
,"10":"Los israelitas clamaron entonces a Yavé: 'Hemos pecado contra ti, le dijeron, hemos abandonado a nuestro Dios y servido a los Baales'."
,"11":"Yavé les respondió: 'Cuando ustedes eran oprimidos por los egipcios, los amoreos, los amonitas, los filisteos,"
,"12":"los sidonios, los amalecitas o los madianitas y me clamaban, ¿no los libré de sus manos?"
,"13":"Pero ustedes me han abandonado y han servido a otros dioses, por eso ya no los salvaré más."
,"14":"Vayan ahora a gritar a los dioses que se eligieron, ¡que ellos los libren ahora que las cosas se dan mal para ustedes!'"
,"15":"Los israelitas dijeron a Yavé: 'Hemos pecado, trátanos como mejor te parezca, pero por lo menos sálvanos ahora'."
,"16":"Hicieron desaparecer de sus casas los dioses extranjeros y sirvieron a Yavé. Entonces Yavé no aguantó más el sufrimiento de Israel."
,"17":"Los amonitas se reunieron e instalaron su campamento en Galaad. Los israelitas también se reunieron e instalaron su campamento en Mispá."
,"18":"El pueblo y los jefes de Galaad se decían unos a otros: '¿Quién será nuestro jefe para atacar a los amonitas? A ese lo pondremos a la cabeza de todos los habitantes de Galaad.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Jefté de Galaad era un valiente guerrero. Era hijo de una prostituta, pero su padre era Galaad."
,"2":"La mujer de Galaad le había dado hijos, y cuando éstos fueron grandes echaron a Jefté. Le dijeron: 'Tú no heredarás nada de la casa de nuestro padre, pues no eres más que el hijo de una extranjera'."
,"3":"Jefté se alejó entonces de sus hermanos y se instaló en el territorio de Tob. Se le juntaron aventureros que hacían incursiones con él."
,"4":"Fue en ese momento cuando los amonitas atacaron a Israel."
,"5":"Los ancianos de Galaad fueron a buscar a Jefté en el país de Tob"
,"6":"y le dijeron: '¡Ven! Tú serás nuestro jefe y nosotros lucharemos con los amonitas'."
,"7":"Pero Jefté respondió a los ancianos de Galaad: '¿No fueron ustedes los que me despreciaron y me echaron de la casa de mi padre? ¡Y vienen ahora a buscarme porque están en peligro!'"
,"8":"Los ancianos de Galaad dijeron a Jefté: 'Precisamente por eso nos hemos dirigido a ti ahora, para que marches al frente de nosotros y combatas a los amonitas; queremos hacerte jefe de todos los habitantes de Galaad'."
,"9":"Jefté respondió a los ancianos de Galaad: 'Si me hacen volver para combatir a los amonitas y si Yavé los pone en mis manos, seré el jefe de ustedes'."
,"10":"Los ancianos de Galaad dijeron a Jefté: 'Que Yavé sea testigo en contra nuestra si no actuamos como acabas de decir'."
,"11":"Jefté partió con los ancianos de Galaad, y el pueblo lo puso al frente de ellos como su jefe y general. Luego en Mispá, en presencia de Yavé, Jefté repitió todas sus condiciones."
,"12":"Jefté envió unos hombres al rey de los amonitas con este mensaje: '¿Por qué vienes a meterte en mis asuntos y a hacerme la guerra en mi país?'"
,"13":"El rey de los amonitas respondió a los mensajeros de Jefté: 'Bien sabes que los israelitas se apoderaron de mi territorio desde el Arnón hasta el Yaboc y el Jordán cuando llegaron de Egipto. Ahora, devuélvemelo por las buenas'."
,"14":"Jefté despachó otra vez mensajeros al rey de los amonitas."
,"15":"Le mandó a decir: 'Israel no se apoderó del territorio de Moab ni del de los amonitas."
,"16":"Cuando los israelitas subieron de Egipto, caminaron por el desierto hasta el Mar de los Juncos y llegaron a Cadés."
,"17":"Entonces Israel envió mensajeros al rey de Edom para que le dijeran: Déjame atravesar tu país. Pero el rey de Edom no quiso. Mandó asimismo mensajeros al rey de Moab quien también se negó. Entonces Israel se quedó en Cadés."
,"18":"Después avanzó por el desierto, rodeó el territorio de Edom y el de Moab y llegó por el este del territorio de Moab. No entró en el territorio de Moab sino que instaló su campamento al otro lado del Arnón, ya que el Arnón era la frontera de Moab."
,"19":"Luego Israel mandó mensajeros a Sijón, rey de los amoreos, que reinaba en Jesbón. Israel le dijo: Déjame atravesar tu territorio hasta el lugar adonde voy."
,"20":"Pero Sijón no quiso que Israel atravesara su territorio. Más todavía, Sijón reunió a toda su gente, llevaron su campamento a Yahas y atacaron a Israel."
,"21":"Yavé, el Dios de Israel, puso a Sijón y a todo su ejército en manos de Israel quien los aniquiló. Y así se apoderó Israel de todo el territorio de los amoreos que vivían en esa región."
,"22":"Después conquistó todo el territorio de los amoreos desde el Arnón hasta el Yaboc, y desde el desierto al Jordán."
,"23":"¿Y ahora que Yavé, el Dios de Israel, desposeyó a los amoreos para favorecer a su pueblo, quieres tú a tu vez desposeer a Israel?"
,"24":"Si consideras tuyo lo que Quemós, tu dios, te dio, ¿por qué quieres arrebatarnos lo que Yavé nuestro Dios nos ha dado?"
,"25":"¿Te crees más poderoso que Balac, hijo de Sipor, rey de Moab? ¿Pudo él oponer resistencia a Israel? ¿Pudo vencerlo?"
,"26":"Hace ya más de trescientos años que Israel vive en Jesbón y en sus dependencias, en Aroer y en sus dependencias, y en todas las ciudades que están a orillas del Arnón. ¿Por qué no las liberaron durante todo ese tiempo?"
,"27":"Yo no te he perjudicado, así que actúas mal conmigo haciéndome la guerra. Que Yavé, el Juez, juzgue ahora entre los israelitas y los amonitas'."
,"28":"Pero el rey de los amonitas no hizo caso de las palabras que le dirigió Jefté."
,"29":"El espíritu de Yavé se apoderó de Jefté. Atravesó Galaad y Manasés, luego pasó por Mispá de Galaad y de Mispá de Galaad se fue donde los amonitas."
,"30":"Hizo esta promesa a Yavé: 'Si entregas en mis manos a los amonitas,"
,"31":"el primero que atraviese la puerta de mi casa para salir a saludarme después de mi victoria sobre los amonitas, será para Yavé y lo sacrificaré por el fuego'."
,"32":"Jefté pasó entonces al territorio de los amonitas para atacarlos, y Yavé los puso en sus manos."
,"33":"Los persiguió desde Aroer hasta los alrededores de Minit, apoderándose de veinte pueblos, y hasta Abel-Queramim. Los amonitas sufrieron una derrota muy grande y en adelante quedaron sometidos a los israelitas."
,"34":"Ahora bien, cuando Jefté regresaba a su casa en Mispá, salió a saludarlo su hija con tamboriles y coros. Era su única hija; fuera de ella no tenía hijos ni hijas."
,"35":"Cuando la vio, rasgó su ropa y dijo: '¡Ay, hija mía, me has destrozado! ¡Tú llegas para traerme la desgracia! Pues hice una promesa a Yavé, y ahora no puedo echarme atrás'."
,"36":"Ella le respondió: 'Padre mío, ya que Yavé hizo que te desquitaras de tus enemigos, los amonitas, aunque te hayas comprometido con Yavé a la ligera, debes actuar conmigo de acuerdo a la palabra que salió de tu boca'."
,"37":"Y dijo a su padre: 'Concédeme sólo esto: Dame un plazo de dos meses para que vaya por los montes junto con mis compañeras y pueda llorar esa muerte siendo todavía virgen'."
,"38":"El le respondió: '¡Anda!' y le permitió que se fuera por dos meses. Ella se fue pues con sus compañeras para llorar por los montes esa muerte siendo virgen todavía."
,"39":"Al cabo de dos meses volvió donde su padre y cumplió con ella la promesa que había hecho. No había conocido varón. Desde entonces es costumbre en Israel"
,"40":"que cada año las jóvenes de Israel salgan a lamentarse por la hija de Jefté de Galaad."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Los hombres de Efraín se juntaron y atravesaron el Jordán a la altura de Safón. Le dijeron a Jefté: '¿Por qué te fuiste a pelear con los amonitas y no nos invitaste para que fuéramos contigo? Vamos a quemarte junto con tu casa'."
,"2":"Pero Jefté respondió: 'Yo y mi pueblo teníamos un conflicto pendiente con los amonitas. Los llamé a ustedes, pero no me libraron de las manos de aquellos."
,"3":"Cuando vi que no venían a librarme, arriesgué mi vida. Tuve una batalla con los amonitas y Yavé los puso en mis manos. ¿Es eso un motivo para que vengan a atacarme?"
,"4":"Jefté reunió a todos los hombres de Galaad y se trabó en combate con Efraín. Los hombres de Galaad aplastaron a los de Efraín que decían: 'Ustedes, gente de Galaad, no son más que desertores de Efraín, ustedes se pasaron de Efraín a Manasés'."
,"5":"Galaad se apoderó de los vados del Jordán por donde se pasa a Efraín, y cuando los fugitivos de Efraín decían: 'Quiero atravesar', los hombres de Galaad le decían: '¿Eres de Efraín?' Si respondían: 'No',"
,"6":"entonces le decían: '¡Di Chibolet!' y si pronunciaba 'Sibolet' (porque no podían pronunciar correctamente) lo tomaban y lo degollaban en el vado del Jordán. Cuarenta y dos mil hombres de Efraín fueron muertos ese día."
,"7":"Jefté juzgó a Israel seis años. Luego Jefté de Galaad murió y fue enterrado en su ciudad, en Galaad."
,"8":"Después de él juzgó a Israel Ibsán de Belén."
,"9":"Tuvo treinta hijos y treinta hijas, casó a sus hijas con gente de fuera e hizo venir de fuera muchachas para sus hijos. Juzgó a Israel siete años."
,"10":"Ibsán murió y lo enterraron en Belén."
,"11":"Después de él juzgó a Israel Elón de Zabulón. Juzgó a Israel diez años."
,"12":"Luego murió Elón de Zabulón y lo enterraron en Ayalón, en el territorio de Zabulón."
,"13":"Después de él fue Abdón, hijo de Hillel, de Pireatón quien juzgó a Israel."
,"14":"Tuvo cuarenta hijos y treinta nietos que andaban en setenta burros. Juzgó a Israel ocho años."
,"15":"Cuando murió Abdón, hijo de Hillel, de Pireatón, lo enterraron en Pireatón en territorio de Efraín, en la montaña del Amalecita."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Los israelitas volvieron a hacer lo que es malo a los ojos de Yavé, quien los entregó en manos de los filisteos durante cuarenta años."
,"2":"Había un hombre de Sorea, de la tribu de Dan, que se llamaba Manoa. Su mujer era estéril y no había tenido hijos."
,"3":"El ángel de Yavé se apareció a la mujer y le dijo: 'Hasta ahora has sido estéril y no has tenido hijos, pero vas a concebir y darás a luz un hijo."
,"4":"Ahora fíjate bien en no beber vino ni bebida alcohólica y en no comer nada impuro debido a ese hijo que vas a concebir y dar a luz."
,"5":"Porque desde el vientre de su madre el muchacho estará consagrado a Dios: no pasará por su cabeza la navaja, pues él será quien comenzará a librar a Israel de manos de los filisteos'."
,"6":"Al volver a su casa, la mujer conversó con su marido y le dijo: 'Un hombre de Dios vino a verme. Era tan majestuoso como un ángel de Dios, pero no le pregunté de dónde venía y no me dijo su nombre."
,"7":"Pero me dijo esto: Vas a concebir y dar a luz un hijo. Por eso, desde ahora no bebas vino ni bebida alcohólica y no comas nada impuro, porque el niño estará consagrado a Dios desde el vientre de su madre y hasta el día de su muerte'."
,"8":"Entonces Manoa le suplicó a Yavé: '¡Por favor, Señor! Que el hombre de Dios que enviaste venga de nuevo a vernos para decirnos cómo hay que actuar con el niño que va a nacer'."
,"9":"Dios oyó la voz de Manoa y el ángel de Dios vino otra vez donde la mujer, cuando estaba sentada en el campo. Pero su marido Manoa no estaba con ella."
,"10":"La mujer corrió inmediatamente a avisar a su marido: 'Acabo de ver al hombre que vino a visitarme el otro día'."
,"11":"Manoa se levantó y siguió a su mujer. Llegó donde estaba el hombre y le preguntó: '¿Eres tú el hombre que habló con esta mujer?' El respondió: 'Sí, yo soy'."
,"12":"Manoa le dijo: 'Si lo que has dicho sucede, ¿qué norma seguiremos con este niño, qué tendrá que hacer él?'"
,"13":"El ángel de Yavé respondió a Manoa: 'La mujer deberá abstenerse de todo lo que he dicho."
,"14":"No probará ningún producto de la vid, no beberá vino ni bebida alcohólica, no comerá nada impuro: tendrá que cumplir con todo lo que le he mandado'."
,"15":"Manoa dijo al ángel de Yavé: 'Permítenos que te retengamos un poco mientras preparamos un cabrito'."
,"16":"Pero el ángel de Yavé le respondió: 'Aunque me quede, no comeré de tu pan. Sin embargo, si quieres ofrecer un holocausto a Yavé, ofréceselo'. En realidad Manoa no sabía que era el ángel de Yavé."
,"17":"Entonces Manoa dijo al ángel de Yavé: '¿Cuál es tu nombre? Quisiéramos poder agradecerte cuando se cumplan tus palabras'."
,"18":"El ángel de Yavé le dijo: '¿Por qué me preguntas el nombre? Es misterioso'."
,"19":"Manoa tomó el cabrito y una ofrenda y los puso en una roca en honor de Yavé y de ese personaje misterioso al que podían ver Manoa y su mujer."
,"20":"Ahora bien, en cuanto se levantó a los cielos la llama del altar, sucedió que el ángel se elevó junto con la llama del altar. Al ver eso, Manoa y su mujer cayeron con el rostro en tierra."
,"21":"El ángel, mientras tanto, desapareció de la vista de Manoa y de su mujer. Entonces comprendió Manoa que era el ángel de Yavé."
,"22":"Manoa dijo a su mujer: 'Vamos a morir porque vimos a Dios'."
,"23":"Pero su mujer le respondió: 'Si Yavé hubiera querido que muriéramos, no habría aceptado nuestro holocausto y nuestra ofrenda. ¿Nos habría mostrado todo eso y más aún prometido lo que acabamos de escuchar?'"
,"24":"Así fue como la mujer dio a luz un hijo al que puso por nombre Sansón. El niño creció y Yavé lo bendijo;"
,"25":"el espíritu de Yavé comenzó a apoderarse de él en el Campamento de Dan, entre Sorea y Estaol."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Sansón bajó a Timná y allí se encontró una mujer entre las niñas filisteas."
,"2":"Subió para comunicárselo a su padre y a su madre: 'He visto a una mujer en Timná, les dijo, una niña filistea. ¡Consíganmela como esposa!'"
,"3":"Su padre y su madre le dijeron: '¿Acaso no hay suficientes jóvenes en nuestro clan y en todo nuestro pueblo para que vayas a buscarte una entre los incircuncisos, entre los filisteos?',Pero Sansón respondió a su padre 'Consíguemela porque me gusta'."
,"4":"Su padre y su madre no sabían que eso venía de Yavé, quien quería crear problemas con los filisteos (en ese tiempo Israel estaba sometido a los filisteos)."
,"5":"Bajó pues Sansón a Timná con su padre y su madre. Cuando venía por las viñas de Timná, le salió al paso un león joven."
,"6":"En ese momento se apoderó de él el espíritu de Yavé, desgarró al leoncito como se desgarra a un cabrito, siendo que nada tenía en las manos. No contó nada de esa hazaña ni a su padre ni a su madre."
,"7":"En seguida bajó y habló con la mujer que le gustaba."
,"8":"Al cabo de un tiempo volvió a Timná para llevársela. Dio un rodeo para ver el cadáver del león: en el cuerpo del león había un enjambre de abejas con miel."
,"9":"Lo tomó en sus manos y se fue chupándolo por el camino. Cuando llegó a su casa, le convidó miel a su padre y a su madre, quienes comieron, pero no les dijo que había encontrado esa miel en el cadáver de un león."
,"10":"Cuando el padre de Sansón bajó a la casa de la mujer, Sansón ofreció un gran banquete según la costumbre de los jóvenes."
,"11":"Como le tenían miedo, le habían buscado treinta jóvenes para que lo acompañaran."
,"12":"Sansón les dijo: 'Les voy a proponer una adivinanza. Les doy los siete días del banquete para que la resuelvan, y si la adivinan les daré treinta túnicas y treinta trajes para cambiarse."
,"13":"Pero si no adivinan, me darán treinta túnicas y treinta mudas'. Le respondieron: 'Dinos la adivinanza, te escuchamos'."
,"14":"Sansón les dijo: 'Del que come salió lo que se come, y del más fuerte salió lo dulce'. Durante tres días no pudieron resolver la adivinanza."
,"15":"Entonces, al cuarto día, dijeron a la mujer de Sansón: 'Hazle arrumacos a tu marido para que te explique la adivinanza, o si no te quemaremos a ti y a la familia de tu padre; ¿o es que nos invitaste para robarnos?'"
,"16":"La mujer de Sansón se puso a llorar a su lado: 'Tú sólo me odias, le decía, tú no me quieres. Ni siquiera me has explicado esa adivinanza que propusiste a los jóvenes de mi pueblo'. Le respondió: 'Ni siquiera se la he explicado a mi padre y a mi madre, ¿y quieres que te la explique?'"
,"17":"Ella siguió así llorando los siete días que duró el banquete, y al séptimo día, como él estaba cansado con eso, le dio la solución. Ella, inmediatamente, se la dio a los de su pueblo, "
,"18":"y al séptimo día antes de la puesta del sol, la gente de la ciudad dijo a Sansón: '¿Qué más dulce que la miel y qué más fuerte que un león?' Les respondió : 'Si no hubiesen arado con mi vaquilla, no habrían acertado con mi adivinanza'."
,"19":"El espíritu de Yavé se apoderó de él y bajó a Ascalón. Allí dio muerte a treinta hombres, les quitó la ropa y se la dio a los que habían explicado la adivinanza. Luego, muy enojado, se volvió a la casa de su padre."
,"20":"En vista de eso dieron la mujer de Sansón a uno de los jóvenes que lo habían acompañado."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Algún tiempo después, en la época de la cosecha del trigo, Sansón fue a ver a su mujer llevándole un cabrito. Dijo: 'Quisiera estar con mi mujer en su pieza'. Pero su suegro le impidió pasar. Le dijo:"
,"2":"'Como pensé que tú ya no la querías, se la di a tu compañero. Su hermana menor es más hermosa, ésta será tu esposa en vez de aquélla'."
,"3":"Entonces Sansón les dijo a todos: 'Esta vez, si hago algún perjuicio a los filisteos, no les deberé nada'."
,"4":"Se fue Sansón y atrapó trescientos zorros. Tomó unas antorchas y ató a los zorros de a dos por la cola poniendo una antorcha entremedio."
,"5":"Luego encendió las antorchas y soltó a los zorros en los campos de los filisteos. Así quemó todo: los atados, el trigo en pie y hasta las viñas y los olivares."
,"6":"Los filisteos preguntaron: '¿Quién hizo eso?' Les respondieron: 'Sansón, el yerno del hombre de Timná, porque este último le quitó a su mujer y se la dio a su camarada'. Subieron entonces los filisteos y quemaron la mujer junto con su padre."
,"7":"Sansón les dijo: 'Ya que ustedes actuaron así, no me detendré hasta que no me haya vengado de ustedes'."
,"8":"Les dio una tremenda paliza y después bajó a vivir en una cueva de los Roqueríos de Etam."
,"9":"Los filisteos hicieron una incursión. Acamparon en el territorio de Judá y se infiltraron por el lado de Lehi."
,"10":"Los hombres de Judá les dijeron: '¿Por qué han subido hasta acá?' Les respondieron: 'Subimos para apresar a Sansón y tratarlo como nos trató'."
,"11":"Tres mil hombres de Judá bajaron a la caverna de los Roqueríos de Etam para decir a Sansón: '¿No sabes que los filisteos son nuestros amos? ¿Qué hiciste?' Les respondió: 'Los traté como me trataron'."
,"12":"Los hombres de Judá le dijeron: 'Hemos bajado para apresarte y entregarte a los filisteos'. Sansón les dijo: '¡Júrenme que no me matarán!'"
,"13":"Ellos respondieron: 'No, sólo vamos a apresarte y a entregarte a ellos; pero no te mataremos'. Lo amarraron entonces con dos cuerdas nuevas y lo sacaron de los Roqueríos de Etam."
,"14":"Cuando estaba ya cerca de Lehi, salieron a su encuentro los filisteos lanzando gritos de alegría. Entonces se apoderó de él el espíritu de Yavé. Las cuerdas que amarraban sus brazos se volvieron para él como hilos de lino quemado, y se deshicieron las ataduras de sus manos."
,"15":"Encontró una quijada de burro todavía fresca, la tomó y mató a golpes a mil filisteos."
,"16":"Luego Sansón exclamó: 'Con una quijada de burro los desparramé; con una quijada de burro maté a golpes a mil'."
,"17":"Cuando terminó de hablar tiró la quijada y llamó a aquel lugar Ramat-Lehi."
,"18":"Como tuviese mucha sed, invocó a Yavé y le dijo: 'Concediste a tu servidor una gran victoria, pero ves que me muero de sed y que voy a caer en manos de los incircuncisos'."
,"19":"Entonces Dios partió la caverna que hay en Lehi; salió de allí agua y bebió. Se reanimó y recuperó sus fuerzas. Por eso pusieron a ese manantial el nombre de En-Ha-Coré; todavía se lo ve en Lehi."
,"20":"Juzgó a Israel veinte años, en la época de los filisteos."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Sansón bajó a Gaza. Allí se encontró con una prostituta y entró en su casa."
,"2":"Le dijeron a la gente de Gaza: '¡Sansón vino para acá!' Organizaron rondas y se quedaron de guardia toda la noche a la puerta de la ciudad. No se movieron en toda la noche porque decían: 'Esperémoslo hasta la mañana y entonces lo mataremos'."
,"3":"Sansón estuvo acostado hasta la medianoche. Se levantó a medianoche, tomó las puertas de la ciudad con su marco y las arrancó junto con su tranca. Se las echó a la espalda y se las llevó a la cumbre de la montaña que está frente a Hebrón."
,"4":"Después de eso se juntó con una mujer del valle de Sorec que se llamaba Dalila."
,"5":"Los jefes de los filisteos fueron a verla y le dijeron: 'Sedúcelo con tus encantos y trata de averiguar de dónde le viene esa fuerza tan grande y cómo podríamos dominarlo, amarrarlo y domarlo. Cada uno de nosotros te dará mil cien siclos de plata'."
,"6":"Dalila preguntó a Sansón: 'Dime, te lo ruego, de dónde proviene tu fuerza extraordinaria. ¿Cómo se podría amarrarte y domarte?'"
,"7":"Sansón le dijo: 'Si me ataran con siete cuerdas nuevas que todavía no estén secas, perdería mi fuerza y sería como un hombre cualquiera'."
,"8":"Los jefes de los filisteos le entregaron siete cuerdas nuevas que no se habían secado todavía y ella lo amarró;"
,"9":"había escondido a unos hombres en su pieza. Le gritó: '¡Sansón, los filisteos te atacan!' Rompió de un golpe las cuerdas como se rompe la mecha de estopa cuando se la quema: no descubrieron el secreto de su fuerza."
,"10":"Dalila dijo a Sansón: 'Te burlaste de mí y me contaste mentiras. Dime con qué hay que amarrarte'."
,"11":"Le dijo: 'Si me atan con cuerdas nuevas que nunca hayan sido usadas, perderé mi fuerza y seré como un hombre cualquiera'."
,"12":"Dalila lo amarró con cuerdas nuevas; luego dijo: '¡Sansón, los filisteos te atacan!' Le habían preparado una emboscada en su pieza, pero él rompió las cuerdas como si fueran hilo."
,"13":"Dalila dijo a Sansón: '¿Cuántas veces más me contarás mentiras? Dime con qué habría que atarte'. Respondió: 'Si tú entretejieras las siete trenzas de mi cabellera en la urdimbre de un telar, si las apretaras con un peine de tejedor, perdería mi fuerza y sería como un hombre cualquiera'."
,"14":"Ella lo durmió, entretejió las siete trenzas de su cabellera con la urdimbre de un telar, las apretó con un peine de tejedor y le dijo: '¡Sansón, los filisteos te atacan!' Se despertó de su sueño y arrancó el peine, la lanzadera y la urdimbre."
,"15":"Entonces ella le dijo: '¿Cómo puedes decirme que me amas? Tu corazón no está conmigo, ya que tres veces te has burlado de mí y no me has dicho de dónde proviene tu enorme fuerza'."
,"16":"Como siguiera molestándolo y acosándolo todos los días con la misma pregunta, creyó que se iba a morir."
,"17":"Entonces le abrió su corazón. Le dijo: 'Estoy consagrado a Dios desde el vientre de mi madre y nunca ha pasado la navaja por mi cabeza. Si me raparan, se me iría la fuerza y quedaría tan débil como cualquiera'."
,"18":"Dalila vio que esta vez le había revelado su secreto. Mandó a buscar a los jefes de los filisteos y les dijo: 'Vengan ahora porque me ha revelado lo más secreto de su corazón'. Los jefes de los filisteos fueron a su casa llevando el dinero en la mano."
,"19":"Después de haber hecho dormir a Sansón en sus rodillas, llamó a un hombre para que le cortara las siete trenzas de su cabellera y comenzó a perder sus fuerzas: su fuerza se le había ido."
,"20":"Entonces ella dijo: '¡Sansón, los filisteos te atacan!' El se despertó de su sueño y pensó: 'Me desataré como las otras veces y me libraré'. Pero no sabía que Yavé se había retirado lejos de él."
,"21":"Los filisteos lo apresaron y le sacaron los ojos. Lo hicieron bajar a Gaza, lo ataron con una cadena doble de bronce y lo pusieron a dar vueltas a la piedra de un molino en la prisión."
,"22":"Sin embargo, después que le cortaron el pelo, su cabellera volvió a crecer."
,"23":"Los jefes de los filisteos se juntaron para ofrecer un gran sacrificio a Dagón su dios, e hicieron una fiesta. Decían: 'Nuestro dios puso en nuestras manos a nuestro enemigo Sansón'."
,"24":"La gente del pueblo lo vio y alababan a su dios diciendo: 'Nuestro dios puso en nuestras manos a nuestro enemigo, que desolaba el país y dejaba tantos muertos entre nosotros'."
,"25":"Cuando todos se sintieron bien contentos, dijeron: '¡Llamen a Sansón para que nos entretenga!' Fueron a buscar a Sansón a la prisión y él dio varias vueltas a la vista de todos, luego lo pusieron entre las columnas."
,"26":"Sansón dijo entonces al joven que lo llevaba de la mano: 'Tú guíame, ayúdame a tocar las columnas que sustentan el templo para que pueda apoyarme en ellas'."
,"27":"El templo estaba lleno de hombres y mujeres. Allí estaban todos los jefes de los filisteos, y en la terraza había como tres mil hombres y mujeres que se divertían mirando a Sansón."
,"28":"Entonces Sansón invocó a Yavé y le dijo: '¡Por favor, Señor Yavé! Acuérdate de mí y dame fuerza por última vez. ¡Quisiera hacerles pagar a los filisteos mis dos ojos de un solo golpe!'"
,"29":"Sansón tocó las dos columnas centrales en las que se sostenía el templo y se apoyó en ellas: su brazo derecho en una y su brazo izquierdo en otra."
,"30":"Luego Sansón exclamó: '¡Que muera yo con todos los filisteos!' Se estiró con todas sus fuerzas y se derrumbó el templo encima de los jefes y de todo el pueblo que estaba allí. Los que arrastró consigo a la muerte fueron más numerosos que aquellos a los que había dado muerte durante toda su vida."
,"31":"Los hermanos y toda la familia de su padre bajaron y se lo llevaron. Subieron y lo enterraron entre Sorea y Estaol en la tumba de Manoa su padre. Había sido juez de Israel veinte años."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Vivía en la montaña de Efraín un hombre que se llamaba Micá."
,"2":"Dijo a su madre: 'Las mil cien monedas de plata que te habían robado y a propósito de las cuales habías pronunciado una maldición, maldición que oí con mis propios oídos, pues bien, esa plata la tengo yo: yo la había tomado'. Su madre dijo inmediatamente: '¡Yavé bendiga a mi hijo!'"
,"3":"El le devolvió las mil cien monedas de plata. Pero su madre dijo: 'Yo misma había dedicado este dinero a Yavé por mi hijo, para que hiciera un ídolo y una estatua de bronce; te puedes quedar con él'."
,"4":"El, sin embargo, entregó el dinero a su madre. Ella sacó doscientas monedas y se las dio a un orfebre. Con ellas hizo un ídolo y una estatua de bronce que quedaron en la casa de Micá."
,"5":"Ese hombre, Micá, se hizo un pequeño santuario doméstico. Tenía un efod, terafim, y luego consagró a uno de sus hijos para que fuera su sacerdote."
,"6":"En ese tiempo no había rey en Israel y cada uno hacía lo que le parecía bueno."
,"7":"Había entonces en Belén de Judá un joven levita que vivía como huésped en ese clan de Judá."
,"8":"Un día dejó Belén de Judá esperando que alguien lo adoptara donde fuera. Caminando llegó a la casa de Micá en la montaña de Efraín."
,"9":"Micá le dijo: '¿De dónde vienes?' Respondió: 'Soy un levita de Belén de Judá y busco quedarme como huésped donde encuentre'."
,"10":"Micá le dijo: 'Quédate conmigo, serás para mí un padre y un sacerdote'. Te daré diez monedas de plata al año y además alojamiento y comida'."
,"11":"El levita aceptó quedarse en la casa de ese hombre y ser para él como uno de sus hijos."
,"12":"Micá consagró al levita y el joven pasó a ser su sacerdote, y prestaba servicios en la casa de Micá."
,"13":"Entonces Micá pensó: 'Ahora sé que Yavé me favorecerá porque tengo como sacerdote a un levita'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"En ese tiempo no había rey en Israel. Fue entonces cuando la tribu de Dan buscó un territorio donde instalarse porque hasta ese día no había recibido su parte en medio de las tribus de Israel."
,"2":"La gente de Dan envió a cinco hombres de los suyos para que recorrieran el país y lo exploraran. Les dijeron: 'Vayan a inspeccionar el país'. Estos llegaron pues a los montes de Efraín, cerca de la casa de Micá, y allí pasaron la noche."
,"3":"Como estaban muy cerca de la casa de Micá oyeron la voz del joven levita y salieron a dar una vuelta. Le preguntaron: '¿Quién te trajo para acá? ¿Qué haces en este lugar? ¿Por qué te quedaste aquí?'"
,"4":"Les respondió: 'Micá hizo esto y eso por mí, me paga y yo le sirvo como sacerdote'."
,"5":"Le dijeron: 'Consulta a Yavé para que sepamos si resultará este viaje que estamos haciendo'."
,"6":"El sacerdote les dijo: '¡Vayan en paz! Su viaje está bajo la protección de Dios'."
,"7":"Partieron después los cinco hombres y llegaron a Lais. Vieron que sus habitantes vivían sin temor, según la costumbre de los sidonios, que la ciudad era tranquila y confiada, sin rey que la gobernara, que estaban lejos de los sidonios y que no tenían vinculación con nadie."
,"8":"Cuando regresaron donde sus hermanos en Sorea y Estaol, estos les preguntaron: '¡A ver, dígannos! ¿Qué noticias traen?'"
,"9":"Respondieron: '¡De pie! ¡Vamos! ¡Vimos una tierra magnífica! Pero, ¿por qué se quedan ahí parados? ¡Vamos, tenemos que apoderarnos de esa región!"
,"10":"Hallarán allí un pueblo sin desconfianza. Su territorio es largo y ancho, Dios lo ha puesto en nuestras manos. Allí nada falta de lo que puede hallarse en la tierra'."
,"11":"Salieron pues los danitas de Sorea y Estaol, completando un número de seiscientos hombres equipados para la guerra."
,"12":"Subieron a Quiriat-Yearim en Judá, donde acamparon. Por eso ese lugar se llamó Campamento de Dan hasta el día de hoy: está al oeste de Quiriat-Yearim."
,"13":"De allí se dirigieron a la montaña de Efraín y llegaron cerca de la casa de Micá."
,"14":"Entonces los cinco hombres que habían recorrido el territorio hasta Lais tomaron la palabra y dijeron a sus hermanos: '¿Saben que en una de esas casas hay un efod y terafim, un ídolo y una estatua de bronce? Piensen un poco lo que deberían hacer'."
,"15":"Dieron una vuelta y entraron en la casa de Micá. Allí estaba el joven levita a quien saludaron."
,"16":"Mientras tanto los seiscientos danitas armados estaban parados frente a la puerta."
,"17":"Los cinco hombres que habían ido a explorar el territorio subieron, entraron en la casa, tomaron el ídolo, el efod, los terafim y la estatua de bronce. El sacerdote estaba en la puerta de la casa con los seiscientos hombres armados."
,"18":"Al ver a los cinco hombres que entraban en la casa de Micá, y que tomaban el ídolo, el efod, los terafim y la estatua de bronce, el sacerdote les dijo: '¿Qué hacen?'"
,"19":"Le respondieron: '¡Cállate! Ponte la mano en tu boca y ven con nosotros: serás para nosotros un padre y un sacerdote. ¿Qué es mejor para ti, ser el sacerdote de un solo hombre en su casa, o ser el sacerdote de toda una tribu, de todo un clan de Israel?'"
,"20":"El sacerdote se sintió muy feliz. Tomó el efod, los terafim, el ídolo y la estatua de bronce y se fue con todos esos hombres."
,"21":"Al reiniciar la marcha, pusieron en la vanguardia a los niños, el ganado y el equipaje."
,"22":"Cuando ya estaban lejos de la casa, los vecinos de Micá se juntaron y se lanzaron en persecución de los danitas,"
,"23":"gritando detrás de ellos. Los danitas se dieron vuelta y dijeron a Micá: '¿Qué significa ese tropel?' "
,"24":"Les respondió: '¡Ustedes me quitaron los dioses que me había hecho, tomaron a mi sacerdote y se fueron! ¡No me queda nada! Y todavía me preguntan ¿qué pasa?'"
,"25":"Los danitas le dijeron: '¡Déjate de gritarnos, pues algunos de nuestros hombres podrían enojarse y abalanzarse sobre ustedes; y tú y tu familia podrían dejar aquí su pellejo!'"
,"26":"Los danitas prosiguieron su camino y Micá, al ver que ellos tenían más fuerza, dio media vuelta y regresó a su casa."
,"27":"Los danitas se llevaron todo lo que se había hecho Micá junto con el sacerdote que estaba en su casa, y se dejaron caer en Lais sobre una población tranquila y confiada. Pasaron a cuchillo a todo el mundo y quemaron la ciudad."
,"28":"No hubo nadie que la socorriera pues Sidón quedaba lejos y no tenían relación con nadie. La ciudad efectivamente se encuentra en la llanura en dirección a Bet-Rejob. La reconstruyeron y se instalaron allí."
,"29":"Pusieron a la ciudad el nombre de Dan, en memoria de su padre Dan, hijo de Israel; pero antes la ciudad se llamaba Lais."
,"30":"Los danitas instalaron allí al ídolo por su cuenta, y Yonatán, hijo de Guersón, hijo de Moisés, y sus hijos, fueron sacerdotes para la tribu de Dan hasta el día de la deportación."
,"31":"Instalaron en medio de ellos al ídolo que Micá había hecho y esto duró tanto como la casa de Dios en Silo."
}`)
	CurrentBook.AddChapter(19, `{
"1":"En ese tiempo no había rey en Israel. Un levita que vivía en el extremo de la montaña de Efraín tomó como concubina a una mujer de Belén de Judá."
,"2":"Su concubina le fue infiel y lo abandonó volviéndose a la casa de su padre, en Belén de Judá, donde permaneció más o menos cuatro meses."
,"3":"Su marido se puso en camino para ir a buscarla, hablarle al corazón y traerla de vuelta; con él iban su sirviente y dos burros. Ella lo hizo entrar en la casa de su padre, y apenas el padre de la joven lo vio, salió feliz a encontrarlo."
,"4":"Su suegro, padre de la joven, lo retuvo y se quedó tres días con él. Comieron, bebieron y pasaron la noche en ese lugar."
,"5":"Al cuarto día se levantaron de madrugada y el levita se dispuso a partir. Pero el padre de la joven dijo a su yerno: 'Repón tus fuerzas, cómete un pedazo de pan; luego te irás'."
,"6":"Se sentaron, comieron y bebieron los dos. Entonces el padre de la joven dijo a su marido: '¡Quédate todavía una noche, disfruta un poco más!'"
,"7":"El hombre estaba listo para partir, pero su suegro le insistió tanto que cedió y pasó la noche en ese lugar."
,"8":"Al quinto día, como se levantara muy temprano para irse, el padre de la joven le dijo: 'Repón tus fuerzas, espera la caída de la tarde'. Comieron los dos juntos."
,"9":"Cuando el marido se disponía a partir junto con su concubina y su sirviente, su suegro, el padre de la joven le dijo: '¡Mira! Ya es tarde, no tardará en anochecer, quédense aquí esta noche. Disfruta un poco más; mañana levántense temprano y partan para tu tienda'."
,"10":"Pero el marido no quiso quedarse una noche más. Partió con sus dos burros cargados y su concubina rumbo a Jebus (es decir Jerusalén)."
,"11":"Cuando estuvieron cerca de Jebus, como ya atardecía, el sirviente dijo a su patrón: 'Tú debieras dejar el camino y entrar en esa ciudad de los jebuseos, nosotros pasaremos aquí la noche'."
,"12":"Pero su patrón le respondió: 'No entraremos en una ciudad extranjera: esa gente no es israelita. Sigamos mejor hasta Guibea'."
,"13":"Y añadió: 'Apresurémonos en alcanzar una de esas ciudades, Guibea o Ramá, para pasar allí la noche'."
,"14":"Pasaron de largo, siguieron caminando y llegaron cerca de Guibea de Benjamín cuando el sol ya se ponía."
,"15":"Saliendo del camino, entraron en Guibea para pasar allí la noche. El levita fue a sentarse a la plaza, pero nadie lo invitó a alojarse en su casa."
,"16":"Un anciano volvía al final de la jornada de su trabajo en el campo. Ese hombre era de la montaña de Efraín, pero vivía en Guibea cuyos habitantes pertenecían a la tribu de Benjamín."
,"17":"Al levantar la vista, divisó al hombre de paso que estaba sentado en la plaza de la ciudad. El anciano dijo al levita: '¿A dónde vas y de dónde vienes?' "
,"18":"Este respondió: 'Venimos de Belén de Judá y vamos a los confines de la montaña de Efraín, porque yo soy de allá. Fui hasta Belén de Judá y me vuelvo a mi casa, pero nadie me ha recibido en la suya."
,"19":"Tengo sin embargo paja y forraje para nuestros burros, pan y vino para mí, para mi mujer y para mi sirviente. No nos falta nada'."
,"20":"El anciano le dijo entonces: 'No te preocupes, yo te daré lo que necesites, pero no pases la noche en la plaza."
,"21":"Lo invitó a su casa y dio forraje a los burros mientras los viajeros se lavaban los pies. Comieron y bebieron."
,"22":"Todo parecía ir muy bien hasta que los hombres de la ciudad, verdaderos depravados, rodearon la casa y golpearon la puerta. Le dijeron al anciano, dueño de la casa: 'Di a ese hombre que está en tu casa que salga para que abusemos de él'."
,"23":"Salió el dueño de la casa a hablarles y les dijo: '¡No, mis hermanos, por favor! No se comporten mal. Ustedes ven que este hombre está ahora bajo mi techo, no cometan una cosa así."
,"24":"Tengo una hija que es todavía virgen y él tiene también su concubina. Se las entregaré, pueden violarlas y tratarlas como quieran, pero no cometan una cosa tan fea con ese hombre'."
,"25":"Los otros no quisieron hacerle caso. Entonces el levita tomó a su concubina y la sacó para afuera. La violaron y abusaron de ella toda la noche hasta el amanecer; al alba la dejaron irse."
,"26":"La mujer regresó al amanecer y se derrumbó delante de la puerta de la casa donde se alojaba su marido. Allí permaneció hasta que fue de día."
,"27":"Se levantó entonces su marido, abrió la puerta de la casa y salió para continuar su viaje. Su concubina estaba tirada frente a la puerta de la casa con las manos en el escalón."
,"28":"Le dijo: 'Párate para que nos vayamos'. Pero no hubo respuesta. El hombre la cargó sobre su burro y retomó el camino para regresar a su casa."
,"29":"Al llegar a su casa, tomó un cuchillo, agarró el cuerpo de su concubina y lo despedazó, hueso por hueso, en doce trozos que despachó a través de todo el territorio de Israel. A los hombres que había enviado les había dado esta orden: 'Pregunten en todo Israel: ¿Se ha visto algo semejante desde que los israelitas salieron de Egipto hasta hoy día? Reflexionen, deliberen y den su opinión'."
,"30":"Todos los que veían eso decían: 'Nunca se ha visto algo semejante desde que los hijos de Israel salieron de Egipto hasta este día'."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Salieron de sus casas todos los israelitas, desde Dan hasta Berseba, y la comunidad se reunió como un solo hombre junto a Yavé en Mispá. Hasta la gente de Galaad se hizo presente."
,"2":"Participaron en esta asamblea del pueblo de Dios los jefes del pueblo y todas las tribus de Israel: eran como cuatrocientos mil hombres que sabían manejar la espada."
,"3":"Los hijos de Benjamín supieron que los israelitas habían subido a Mispá. Los israelitas dijeron: '¡Cuéntennos cómo se cometió ese crimen!' "
,"4":"Entonces el levita, el marido de la mujer asesinada, tomó la palabra y dijo: 'Había yo entrado en Guibea de Benjamín junto con mi concubina para pasar allí la noche,"
,"5":"y los vecinos de Guibea decidieron hacerme daño. Durante toda la noche rodearon la casa donde yo estaba con la intención de matarme; violaron a mi concubina de tal manera que ella murió."
,"6":"Entonces tomé a mi concubina, la corté en pedazos y los mandé por todos los territorios que pertenecen a Israel, porque cometieron una infamia en Israel."
,"7":"Ya que han venido aquí todos ustedes, todo Israel, estudien el asunto y decidan aquí mismo'."
,"8":"Todo el pueblo se levantó como un solo hombre y dijo: '¡Que ninguno de nosotros se retire a su tienda, que nadie regrese a su casa!"
,"9":"Vamos a actuar con Guibea de esta manera: Vamos a sortear"
,"10":"diez hombres de cien en todas las tribus de Israel, o cien de mil, o mil de diez mil. Irán a buscar víveres para los que partirán a Guibea de Benjamín a fin de tratarla como se lo merece después del crimen que cometió en Israel."
,"11":"Así fue como se reunieron los israelitas como un solo hombre frente a la ciudad."
,"12":"Las tribus de Israel mandaron hombres por todo el territorio de Benjamín para decirles: '¿Qué crimen es ese que se cometió entre ustedes?"
,"13":"Entréguennos a esos criminales de Guibea para que los matemos, porque hay que eliminar el mal de Israel'. Pero la gente de Benjamín no quiso oír la voz de sus hermanos israelitas."
,"14":"Los benjaminitas llegaron de sus ciudades y se reunieron en Guibea para pelear con los israelitas."
,"15":"Ese día se hizo el censo de los benjaminitas que habían venido de sus ciudades: veintiséis mil hombres de guerra. Se los censó sin contar a los habitantes de Guibea."
,"16":"Había en ese ejército setecientos hombres de élite, zurdos que podían con su honda dar en el blanco con una piedra sin errar un cabello."
,"17":"También se hizo el censo de los israelitas sin la gente de Benjamín: cuatrocientos mil hombres que sabían manejar la espada, todos hombres de guerra."
,"18":"Se levantaron y subieron a Betel para consultar a Dios. Los israelitas preguntaron: '¿Quién de nosotros subirá primero para atacar a la gente de Benjamín?' Yavé dijo: 'Judá será el primero'."
,"19":"Los israelitas se levantaron muy temprano e instalaron su campamento frente a Guibea."
,"20":"Los de Israel tomaron la iniciativa y se pusieron en fila para atacar a los de Benjamín que estaban en Guibea."
,"21":"Salió entonces de Guibea la gente de Benjamín y masacró ese día a veintidós mil hombres de Israel."
,"23":"Los israelitas subieron después a Betel y se lamentaron delante de Yavé hasta el atardecer. Luego consultaron a Yavé en estos términos: '¿Debemos atacar de nuevo a nuestros hermanos de Benjamín?' Yavé dijo: '¡Atáquenlos!'"
,"22":"El ejército de Israel se reanimó y de nuevo se puso en fila en el mismo lugar que el primer día."
,"24":"Los israelitas atacaron a los benjaminitas,"
,"25":"pero esa segunda vez salieron de Guibea los de Benjamín para enfrentarlos y mataron entre los israelitas a dieciocho mil hombres que sabían manejar la espada."
,"26":"Todos los israelitas y todo el pueblo subieron de nuevo a Betel. Allí, sentados delante de Yavé, lloraron y ayunaron todo el día hasta el atardecer, luego ofrecieron a Yavé holocaustos y sacrificios de comunión."
,"27":"Los israelitas consultaron a Yavé ese día, pues el Arca de la Alianza de Dios estaba en ese lugar,"
,"28":"y Finjás, hijo de Eleazar, hijo de Aarón la tenía a su cargo. Los israelitas preguntaron: '¿Debemos atacar una vez más a nuestros hermanos de Benjamín o tenemos que renunciar a ello?' Yavé respondió: 'Suban, porque mañana los pondré en sus manos'."
,"29":"Israel puso gente emboscada alrededor de Guibea."
,"30":"Cuando los israelitas subieron para atacar por tercera vez a los de Benjamín, se pusieron en fila delante de Guibea como las otras veces."
,"31":"Los benjaminitas hicieron entonces una salida para enfrentar al ejército y se alejaron de la ciudad. Igual que las veces anteriores comenzaron a masacrar a los hombres del ejército de Israel (mataron alrededor de treinta en los caminos que van a Betel y a Guibea por el campo)."
,"32":"Los benjaminitas pensaban: 'Se sienten derrotados ante nosotros igual que las otras veces'. Pero los israelitas se habían dicho: 'Emprenderemos la fuga para atraerlos a los caminos que están lejos de la ciudad'."
,"33":"Todos los israelitas se reagruparon y se les enfrentaron en Baal-Tamar, en el mismo momento en que los de la emboscada salían del lugar donde se habían ocultado al oeste de Guibea."
,"34":"Eran diez mil hombres de élite del ejército de Israel que avanzaron contra Guibea. La batalla fue tremenda y los benjaminitas no sabían que les iba a tocar la desgracia."
,"35":"Porque Yavé había decidido la derrota de Benjamín ante Israel y, ese día, los israelitas iban a matar veinticinco mil cien hombres de Benjamín, todos hábiles en el manejo de la espada."
,"36":"Los benjaminitas se dieron cuenta que estaban vencidos. Los israelitas les habían cedido el terreno sólo porque contaban con los emboscados que habían puesto para atacar a Guibea."
,"37":"La gente de la emboscada en efecto se lanzó contra Guibea, la tomaron y pasaron a cuchillo a toda la ciudad."
,"38":"Los israelitas habían convenido en una señal con los de la emboscada: estos últimos harían que subiera de la ciudad una nube de humo."
,"39":"Cuando los benjaminitas habían dado muerte a una treintena de hombres se decían: 'Ya están derrotados como la última vez', pero, en ese mismo momento los israelitas se volvieron contra ellos."
,"40":"De la ciudad se elevaba la señal de humo, y Benjamín, dándose vuelta, divisó la hoguera que subía a los cielos: toda la ciudad ardía en llamas."
,"41":"Los hombres de Israel atacaron y cundió el pánico entre los benjaminitas; comprendieron que les había caído encima la desgracia."
,"42":"Al intentar huir ante los israelitas por los caminos del desierto, la batalla se les echó encima y los que bajaban de la ciudad los masacraron."
,"43":"Benjamín fue cercado, hostigado, aplastado hasta el oriente de Guibea."
,"44":"Cayeron dieciocho mil hombres de Benjamín, todos valientes guerreros."
,"45":"Los que pudieron escapar llegaron hasta el desierto hacia la cuesta de Rimón. Fueron cinco mil los que cayeron en los caminos, y dos mil más perecieron cuando los perseguían hasta Guideón."
,"46":"El total de la gente de Benjamín que cayó ese día fue de veinticinco mil hombres que sabían manejar la espada, todos valientes guerreros."
,"47":"Sólo seiscientos hombres escaparon, huyendo al desierto hacia la Cuesta de Rimón; permanecieron allí cuatro meses."
,"48":"Mientras tanto los israelitas destruyeron todos los pueblos de Benjamín con los hombres, el ganado y todo lo que allí había. Luego prendieron fuego a todos los pueblos que encontraron."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Los israelitas habían hecho este juramento en Mispá: 'Ninguno de nosotros dará su hija en matrimonio a alguien de Benjamín'."
,"2":"Se reunieron en Betel y permanecieron ante Yavé hasta la tarde con gritos y grandes lamentaciones. Decían:"
,"3":"'¡Yavé, Dios nuestro, mira lo que ha pasado en Israel! ¡Ahora falta una tribu!"
,"4":"Al día siguiente, se levantó el pueblo muy temprano; construyeron un altar y ofrecieron holocaustos y sacrificios de comunión."
,"5":"Luego dijeron los israelitas: '¿No hay ninguna entre todas las tribus de Israel que no haya venido a la asamblea en presencia de Yavé?' Porque habían hecho un juramento solemne: Si alguien no sube a Mispá para comparecer ante Yavé, será condenado a muerte."
,"6":"Los israelitas estaban muy afligidos a causa de Benjamín su hermano; se decían: 'Hoy una tribu de Israel ha sido tronchada."
,"7":"¿Qué podemos hacer para que los que quedan de ellos tengan mujeres, ya que juramos ante Yavé que no les daríamos nuestras hijas en matrimonio?'"
,"8":"Por esto preguntaron: '¿Hay alguien entre todas las tribus de Israel que no haya subido hasta Yavé en Mispá?',Vieron que nadie de Yabés en Galaad había ido a la asamblea."
,"9":"Efectivamente, se había hecho el censo de toda la población y no había nadie de Yabés en Galaad."
,"10":"La comunidad mandó allá abajo a doce mil hombres, todos fuertes guerreros, con esta orden: '¡Vayan y pasen a cuchillo a los habitantes de Yabés en Galaad como también a las mujeres y a los niños:"
,"11":"todo varón y toda mujer que haya tenido relaciones con un hombre serán condenados al anatema, pero dejarán con vida a las que son vírgenes'. Así lo hicieron."
,"12":"Encontraron en la población de Yabés en Galaad cuatrocientas muchachas que no habían tenido relaciones con hombre, y las llevaron al campamento instalado en Silo, en el país de Canaán."
,"13":"Entonces la comunidad mandó a avisar a la gente de Benjamín que estaba en la Cuesta de Rimón e hicieron la paz."
,"14":"Volvieron pues los benjaminitas y les dieron las mujeres de Yabés de Galaad que habían dejado con vida. Pero no había para todos."
,"15":"De nuevo el pueblo se compadeció de Benjamín, porque Yavé había dejado una brecha entre las tribus de Israel."
,"16":"Los ancianos de la comunidad dijeron: '¿Qué podemos hacer por aquellos a los que todavía les falta una mujer, ya que las mujeres de Benjamín fueron masacradas?'"
,"17":"Decidieron esto: 'Los sobrevivientes conservarán toda la tierra que pertenece a Benjamín para que así ninguna tribu sea tronchada de Israel."
,"18":"Sin embargo no podemos darles nuestras hijas en matrimonio ya que los israelitas hicieron este juramento: 'Sea maldito el que dé su hija a Benjamín'."
,"19":"Entonces pensaron: 'Pronto es la fiesta de Yavé, que tiene lugar cada año en Silo, (Silo está al norte de Betel, al este del camino que va desde Betel a Siquem y al sur de Lebona)'."
,"20":"Y propusieron lo siguiente a los benjaminitas: 'Vayan a esconderse entre las parras."
,"21":"Cuando vean a las jóvenes de Silo que salgan para bailar en coro, ustedes saldrán de entre las parras, tomará cada uno a una joven de Silo y se irán al territorio de Benjamín."
,"22":"Si sus padres o sus hermanos vinieran a quejarse ante nosotros, les diremos: 'Déjenlos tranquilos, ustedes ven que no pudimos tomar una mujer para cada uno de ellos durante la guerra. No fueron ustedes los que se las dieron, de manera que no fueron infieles a su juramento'."
,"23":"Los benjaminitas hicieron como se les había dicho para tomar el número de mujeres que correspondía al de ellos. Las tomaron de entre las que habían salido a bailar. Luego se fueron y regresaron a sus tierras. Allí reconstruyeron las ciudades y se instalaron en ellas."
,"24":"Entonces, los israelitas dejaron esos lugares y se volvieron cada uno a su tribu y a su propio clan, en sus propias tierras."
,"25":"En ese tiempo no había rey en Israel y cada uno hacía lo que se le antojaba."
}`)

}
func ES_LBL_LoadVHIEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Después de la muerte de Moisés, Yavé habló a Josué, hijo de Nun, el ayudante de Moisés. Le dijo:"
,"2":"'Moisés, mi servidor, ha muerto. Tú, ahora, atraviesa junto con todo el pueblo el Jordán y pasa a la tierra que daré a los israelitas."
,"3":"Como se lo dije a Moisés, les daré cualquier lugar que pise tu pie,"
,"4":"esto es, desde ese desierto hasta el Gran Río, el río Eufrates. Todo el territorio desde los hititas al Gran Mar hacia el lado del sol poniente será su tierra."
,"5":"Mientras vivas, nadie podrá resistirte. Estaré contigo así como estuve con Moisés, no te olvidaré ni te abandonaré jamás."
,"6":"¡Sé valiente y ten ánimo! Tú harás que este pueblo tome posesión del país que juré darles a sus padres."
,"7":"¡Sé valiente y ten ánimo! Trata de observar en todos sus puntos la ley que te dio mi servidor Moisés. No te apartes ni a la derecha ni a la izquierda, y tendrás éxito por donde vayas."
,"8":"Releerás constantemente este libro de la Ley. Lo meditarás día y noche para que actúes en todo según lo que allí está escrito: de ese modo llevarás a cabo tus proyectos y tendrás éxito."
,"9":"Esta es mi orden: Sé valiente y ten ánimo; no tiembles ni tengas miedo; Yavé tu Dios está contigo adonde quiera que tú vayas'."
,"10":"Josué dio esta orden a los escribas del pueblo:"
,"11":"'Recorran el campamento y den al pueblo estas instrucciones: Preparen sus provisiones, porque en tres días más van a atravesar el Jordán para ir a conquistar el país que les dará Yavé su Dios'."
,"12":"Josué se dirigió luego a la tribu de Rubén, a la de Gad y a la media tribu de Manasés:"
,"13":"'Acuérdense de lo que Moisés, el servidor de Yavé, les mandó: Yavé su Dios, dijo, les ha dado este territorio para que sea el descanso de ustedes."
,"14":"Pero van a dejar a sus mujeres, a sus niños, y a sus rebaños en este territorio que Moisés les dio a este lado del Jordán, y pasarán armados delante de sus hermanos. Todos ustedes, que son guerreros valientes, los ayudarán"
,"15":"hasta que Yavé haya dado a sus hermanos el descanso así como lo hizo con ustedes, y hasta que tomen posesión también del territorio que Yavé les asignó. Entonces volverán ustedes a las tierras que les tocaron, es decir, al territorio que les dio Moisés, a este lado del Jordán, hacia el lado del sol naciente'."
,"16":"Le respondieron a Josué: 'Haremos todo lo que nos mandes e iremos adonde quieras enviarnos."
,"17":"Te obedeceremos en todo igual como obedecimos a Moisés. Y ojalá Yavé tu Dios esté contigo así como estuvo con Moisés."
,"18":"Aquel que no te obedezca ni haga caso de lo que tú mandes será reo de muerte; en cuanto a ti, sé valiente y manténte firme."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Josué hijo de Nun despachó desde Sitim secretamente a dos espías. Les dijo: '¡Vayan! Observen bien el terreno y la ciudad de Jericó'. Después de recorrer su camino, entraron en casa de una prostituta que se llamaba Rahab; allí pasaron la noche."
,"2":"Le avisaron al rey de Jericó: 'Unos hombres israelitas llegaron aquí, han venido para observar el terreno'."
,"3":"Entonces el rey de Jericó mandó a decir a Rahab: 'Haz que salgan esos hombres que se han alojado en tu casa, pues han venido para informarse de nuestro territorio'."
,"4":"Pero la mujer escondió a los hombres y respondió: 'Esos hombres que llegaron a mi casa"
,"5":"se fueron al caer la noche, cuando se cierra la puerta de la ciudad, y no sé para dónde partieron. Si ustedes salen inmediatamente en su persecución, tal vez los atrapen'."
,"6":"En realidad, los había hecho subir a su terraza y los había escondido bajo unos atados de lino que tenía allí."
,"7":"La gente se lanzó en su persecución en dirección al Jordán, hacia el lado de los vados, y apenas salieron, se cerró la puerta de la ciudad."
,"8":"Todavía no se habían acostado los dos hombres, cuando ella los fue a ver en la terraza."
,"9":"Les dijo: 'Sé que Yavé les ha entregado este país; han sembrado el pánico en medio de nosotros y toda la gente de este país está atemorizada con ustedes."
,"10":"Nos han dicho de qué manera Yavé secó ante ustedes el mar de los Juncos cuando salían de Egipto, y lo que ustedes hicieron a los dos reyes de los amoreos al otro lado del Jordán, a Sijón y a Og, a los que condenaron al anatema."
,"11":"Cuando lo supimos se nos paró el corazón y al verlos acercarse todo el mundo está ahora lleno de miedo, porque Yavé su Dios es Dios tanto arriba en los cielos como abajo en la tierra."
,"12":"Pero ya que les he hecho un favor, júrenme por Yavé que también ustedes harán un favor a la casa de mi padre,"
,"13":"y dejen que vivan mi padre, mi madre, mis hermanos, mis hermanas y todo lo que les pertenece. Líbrennos de la muerte'."
,"14":"Los hombres respondieron: 'Te lo juramos por nuestras propias cabezas; con tal que tú no reveles nuestra conversación, te trataremos con bondad y fidelidad cuando Yavé nos entregue este país'."
,"15":"Los ayudó a bajar por la ventana, porque su casa estaba construida junto a la muralla."
,"16":"Les dijo: 'Huyan a los cerros para que no los encuentren los que los persiguen. Quédense allí escondidos tres días, hasta que regresen los que los persiguen, luego sigan su camino'."
,"17":"Los hombres le dijeron: 'Respetaremos el juramento que te hemos hecho."
,"18":"Cuando entremos en este territorio, amarrarás este cordón de hilo rojo a la ventana por donde nos hiciste bajar. Reunirás junto a ti en tu casa a tu padre, tu madre, tus hermanos y a toda la familia de tu padre."
,"19":"Si alguno de entre ellos abre la puerta y sale de la casa, será responsable de su muerte y nosotros quedaremos libres, pero si los nuestros ponen la mano encima de cualquiera que esté contigo en tu casa, nosotros seremos responsables."
,"20":"Pero no cuentes a nadie nuestro acuerdo, porque si no quedaremos libres del juramento que acabamos de hacer'."
,"21":"Les dijo: 'Que sea como acaban de decírmelo'. Los despidió y se fueron; luego amarró el cordón rojo a su ventana."
,"22":"Los hombres al salir se dirigieron a los cerros. Allí estuvieron tres días mientras los que los perseguían buscaban a lo largo del camino sin encontrar nada."
,"23":"Los dos hombres entonces bajaron de los cerros y atravesaron el Jordán. Se presentaron luego a Josué hijo de Nun y le contaron toda su aventura."
,"24":"Y añadieron: 'Yavé ha puesto todo ese país en nuestras manos; todos los habitantes de ese país están asustados con nosotros'."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Josué se levantó muy de madrugada. Partieron de Sitim y llegaron a orillas del Jordán; allí pasaron la noche esperando atravesarlo."
,"2":"Al cabo de tres días, los escribas recorrieron el campamento,"
,"3":"-"
,"4":"y dieron al pueblo estas instrucciones: 'Apenas vean el Arca de la Alianza de Yavé su Dios y a los sacerdotes levitas que la transportan, dejarán el lugar donde están y la seguirán, para que les enseñe el camino, ya que es un camino por donde nunca han pasado '."
,"5":"Josué dijo al pueblo: 'Santifíquense porque mañana Yavé hará cosas prodigiosas en medio de ustedes'."
,"6":"Y a los sacerdotes les dijo: 'Tomen el Arca de la Alianza y colóquense a la cabeza del pueblo'. Levantaron pues el Arca de la Alianza y se pusieron al frente del pueblo."
,"7":"Yavé dijo a Josué: 'Hoy día te voy a engrandecer en presencia de todo Israel y sabrán que estoy contigo así como estuve con Moisés."
,"8":"Y tú darás esta orden a los sacerdotes que transportan el Arca de la Alianza: Apenas lleguen a orillas del caudal del Jordán, se detendrán en el Jordán."
,"9":"Josué se dirigió a los israelitas: '¡Acérquense y escuchen las palabras de Yavé su Dios!"
,"10":"Ustedes van a tener aquí la prueba de que el Dios vivo está en medio de ustedes y que por ustedes despojará a los cananeos, a los hititas, los jeveos, los fereceos, los guirgaceos, los amoreos y los jebuseos."
,"11":"El Arca de la Alianza del Señor de toda la tierra va ahora a atravesar delante de ustedes el Jordán. ("
,"12":"Escojan doce hombres, uno para cada una de las tribus de Israel)."
,"13":"Y apenas la planta de los pies de los sacerdotes que transportan el Arca de Yavé, el Señor de toda la tierra, haya tocado las aguas del Jordán, las aguas del Jordán que vienen de río arriba se detendrán'."
,"14":"Cuando el pueblo levantó sus tiendas para atravesar el Jordán, los sacerdotes que llevaban el Arca de la Alianza se pusieron a la cabeza del pueblo."
,"15":"Era el tiempo de la cosecha y el Jordán desbordaba por todas sus orillas. Pues bien, apenas llegaron al Jordán los que llevaban el Arca, y apenas tocaron el agua los pies de los sacerdotes que transportaban el Arca,"
,"16":"el caudal que bajaba de arriba se detuvo y se amontonó a una gran distancia, a la altura de Adán, el pueblo vecino de Sartán. Durante ese tiempo las aguas que bajaban al mar de la Araba, el Mar Salado, se derramaron porque habían sido cortadas, de tal manera que el pueblo atravesó frente a Jericó."
,"17":"Los sacerdotes que transportaban el Arca de la Alianza de Yavé se mantuvieron inmóviles en seco, en medio del Jordán, hasta que la nación terminó de atravesarlo. Israel pasó por un camino seco."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Cuando toda la nación terminó de atravesar, Yavé dijo a Josué:"
,"2":"'Elijan entre ustedes a doce hombres, uno por tribu."
,"3":"Les dirán que tomen doce piedras de en medio del Jordán y las lleven al lugar donde pasarán la noche; allí las depositarán'."
,"4":"Josué reunió a los doce hombres que habían escogido entre los israelitas, uno por cada tribu,"
,"5":"y les dijo: 'Vayan al medio del Jordán y échese cada uno una piedra sobre su hombro según el número de las tribus de Israel."
,"6":"Serán para ustedes una señal, cuando mañana sus hijos les pregunten: ¿Qué significan para ustedes esas piedras?"
,"7":"Entonces les responderán: Las aguas del Jordán se separaron ante el Arca de la Alianza de Yavé cuando ésta atravesó el Jordán. Esas piedras serán para siempre un recuerdo para los israelitas'."
,"8":"Los israelitas hicieron pues como Josué les había ordenado. Tomaron doce piedras del cauce del Jordán, como Yavé se lo había dicho a Josué, según el número de las tribus de Israel y las transportaron para depositarlas en el lugar donde se detendrían."
,"9":"Josué hizo que se erigieran doce piedras en el lecho del Jordán, en el lugar donde se detuvieron los pies de los sacerdotes que llevaban el Arca de la Alianza, y están allí todavía."
,"10":"Los sacerdotes que llevaban el Arca, estuvieron detenidos en medio del Jordán hasta que hubo dicho al pueblo todo lo que Yavé había ordenado. Luego, todo el pueblo se apresuró en atravesar."
,"11":"Cuando todo el pueblo hubo atravesado, el Arca de Yavé pasó y los sacerdotes se colocaron de nuevo a la cabeza del pueblo."
,"12":"Conforme a lo que Moisés había mandado, la tribu de Rubén, la de Gad y la media tribu de Manasés se pusieron armados al frente de los israelitas."
,"13":"Eran más o menos cuarenta mil hombres que formaban la vanguardia de Yavé y que avanzaban hacia las llanuras de Jericó."
,"14":"Ese día Yavé engrandeció a Josué a los ojos de todo Israel y se le temió como se había temido a Moisés durante toda su vida."
,"15":"Yavé dijo a Josué:"
,"16":"'Ordena a los sacerdotes que llevan el Arca del Testimonio que salgan del Jordán'."
,"17":"Josué ordenó pues a los sacerdotes: '¡Salgan del Jordán!'"
,"18":"Pues bien, cuando los sacerdotes que llevaban el Arca de la Alianza de Yavé salieron del Jordán y cuando tocaron sus pies tierra firme, las aguas del Jordán volvieron a su lugar y desbordaron por ambas orillas como en los días anteriores."
,"19":"Era el diez del primer mes; el pueblo subió del Jordán e instaló su campamento en Guilgal, al oriente de Jericó."
,"20":"Josué ordenó que se erigieran en Guilgal las doce piedras que se habían tomado en el Jordán."
,"21":"Luego dijo a los israelitas: 'Cuando mañana sus hijos les pregunten qué hacen estas piedras aquí,"
,"22":"ustedes les responderán: Esto es porque Israel atravesó el Jordán en seco."
,"21":"Yavé dejó en seco el lecho del Jordán ante nosotros cuando lo atravesamos, lo mismo que dejó en seco el mar de los Juncos para que lo atravesemos."
,"24":"¡Sepan, pues, todos los pueblos de la tierra cuán poderosa es la mano de Yavé, y teman siempre a Yavé nuestro Dios!'"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Todos los amoreos que se encontraban al oeste del Jordán, así como los cananeos que estaban cerca del mar se enteraron que Yavé había dejado en seco el lecho del Jordán ante los israelitas, hasta que hubiéramos pasado. Perdieron entonces la valentía y les entró el pánico al acercarse los israelitas."
,"2":"En ese tiempo, Yavé dijo a Josué: 'Hazte unos cuchillos de silex para circuncidar de nuevo a los israelitas'."
,"3":"Josué hizo unos cuchillos de silex y circuncidó a los israelitas en la Colina de los Prepucios."
,"4":"Josué ordenó esta circuncisión porque todo el pueblo que había salido de Egipto, todos los hombres adultos, habían muerto en el desierto a lo largo del camino, después de su salida de Egipto."
,"5":"Todo el pueblo de la salida había sido circuncidado pero todos los nacidos en el desierto durante el trayecto, después de la salida de Egipto, no estaban circuncidados."
,"6":"Los israelitas habían caminado cuarenta años por el desierto hasta que desaparecieron los adultos que habían salido de Egipto, toda esa generación que no había escuchado la voz de Yavé. Yavé se lo había jurado: 'Ustedes no verán el territorio que prometí darles a sus padres, tierra donde destila la leche y la miel'."
,"7":"Pero en su lugar habían nacido sus hijos y éstos estaban sin circuncidarse, porque no se les había circuncidado durante el trayecto. Josué los circuncidó."
,"8":"Cuando se terminó la circuncisión de todo el pueblo, se quedaron acampados en ese lugar hasta la curación."
,"9":"Yavé dijo entonces a Josué: 'Hoy he lanzado lejos de ustedes la vergüenza de Egipto'. Por eso dieron a ese lugar el nombre que tiene todavía: Guilgal."
,"10":"Los israelitas acamparon en Guilgal y la tarde del décimo cuarto día del mes celebraron la Pascua en las llanuras de Jericó."
,"11":"Al día siguiente de la Pascua, comieron de los frutos del país, panes sin levadura y grano tostado."
,"12":"El maná dejó de caer el día antes, en vista de que ya se alimentaban de los frutos del país. Los israelitas no tuvieron más maná; a partir de ese año se alimentaron de los frutos del país de Canaán."
,"13":"Estando Josué cerca de Jericó, levantó la vista y vio a un hombre de pie delante de él, con una espada desenvainada en la mano. Josué fue donde él y le dijo: '¿Estás en favor nuestro o de nuestros enemigos?'"
,"14":"Respondió: 'Soy el jefe del ejército de Yavé, y acabo de llegar'. Entonces Josué cayó con el rostro en tierra y se postró. Luego le dijo: '¿Qué dice mi Señor a su servidor?'"
,"15":"El jefe del ejército de Yavé respondió a Josué: 'Quítate la sandalia de tu pie, porque el lugar donde estás es un lugar santo'. Así lo hizo Josué."
}`)
	CurrentBook.AddChapter(6, `{
"1":"La ciudad de Jericó estaba cerrada por miedo a los israelitas; la habían cerrado y nadie salía ni entraba."
,"2":"Yavé dijo a Josué: '¡Mira! Pongo a Jericó en tus manos con su rey y sus mejores soldados."
,"3":"Ustedes los hombres de guerra van a dar una vuelta completa a la ciudad y harán lo mismo cada día durante seis días."
,"4":"Siete sacerdotes llevarán las siete trompetas de los jubileos delante del Arca. El séptimo día darán siete vueltas a la ciudad, luego los sacerdotes tocarán la trompeta."
,"5":"Cuando el sonido del cuerno de carnero se prolongue, todo el mundo lanzará el grito de guerra. Entonces se derrumbará la muralla de la ciudad y todo el pueblo se lanzará al asalto, cada uno por el lugar que tenga al frente'."
,"6":"Josué, hijo de Nun, reunió pues a los sacerdotes y les dijo: 'Llevarán el Arca de la Alianza, y siete sacerdotes llevarán las siete trompetas de los jubileos delante del Arca de Yavé'."
,"7":"Luego volviéndose al pueblo, le dijo: 'Pasen y den una vuelta completa a la ciudad; los hombres armados irán delante de Yavé'."
,"8":"Cuando Josué hubo hablado al pueblo, los siete sacerdotes que llevaban las siete trompetas de los jubileos delante de Yavé, pasaron e hicieron sonar cada uno su trompeta; el Arca de la Alianza de Yavé iba detrás de ellos."
,"9":"Los hombres armados iban delante de los sacerdotes que tocaban la trompeta, y la retaguardia caminaba detrás del Arca. Se avanzaba al son de trompetas."
,"10":"Josué había dado al pueblo esta orden: '¡No lancen el grito de guerra! Que no se les oiga hasta cuando les diga: ¡Griten! Entonces lanzarán el grito de guerra'."
,"11":"El Arca de la Alianza caminó alrededor de la ciudad. Dio una vuelta completa alrededor de ella y luego regresaron al campamento donde pasaron la noche."
,"12":"Josué se levantó muy temprano y los sacerdotes tomaron el Arca de Yavé."
,"13":"Los siete sacerdotes que llevaban las siete trompetas delante del Arca de Yavé se pusieron en camino y tocaron la trompeta. Los hombres armados iban delante de ellos y la retaguardia seguía al Arca de Yavé. Se avanzaba al son de trompetas."
,"14":"El segundo día se dio de nuevo una vuelta entera a la ciudad y luego regresaron al campamento y así se hizo durante seis días."
,"15":"El séptimo día, cuando despuntaba el alba, se dieron siete vueltas alrededor de la ciudad."
,"16":"A la séptima vez, cuando los sacerdotes tocaban la trompeta, Josué dijo al pueblo: '¡Lancen el grito de guerra! ¡Yavé les entrega la ciudad!"
,"17":"La ciudad con todo lo que hay en ella será condenada al anatema, en honor de Yavé. Sólo se salvará Rahab la prostituta con todos los que estén con ella en su casa."
,"18":"En cuanto a ustedes, cuídense de tomar lo que ha sido condenado al anatema, no sea que ustedes mismos se vuelvan anatema y atraigan la desgracia sobre el campamento de Israel."
,"19":"Toda la plata y todo el oro, todos los objetos de bronce y de hierro serán consagrados a Yavé e ingresarán al tesoro de Yavé'."
,"20":"El pueblo lanzó entonces el grito de guerra y resonó la trompeta. Apenas oyó el pueblo el sonido de la trompeta, lanzó el gran grito de guerra y la muralla se derrumbó. El pueblo entró en la ciudad, cada uno por el lugar que tenía al frente y se apoderaron de la ciudad."
,"21":"Siguiendo el anatema, se masacró a todo lo que vivía en la ciudad: hombres y mujeres, niños y viejos, incluso a los bueyes, corderos y burros."
,"22":"Josué dijo a los dos hombres que habían espiado el país: 'Entren en la casa de la prostituta y saquen a esa mujer con todo lo que le pertenece, como se lo juraron'."
,"23":"Los jóvenes que habían sido enviado en reconocimiento entraron y sacaron a Rahab, a su padre, su madre y sus hermanos, con todas sus pertenencias. Instalaron a toda la familia fuera del campamento de Israel."
,"24":"Luego prendieron fuego a la ciudad y a todo lo que había en ella. Pero depositaron en el tesoro de la Casa de Yavé la plata, el oro como también los objetos de bronce o de hierro."
,"25":"Josué dejó con vida a Rahab la prostituta y a la familia de su padre con todo lo que le pertenecía. Esta ha vivido en Israel hasta el día de hoy, porque ocultó a los espías que Josué había enviado para que exploraran Jericó."
,"26":"En ese momento Josué hizo este juramente: 'Maldiga Yavé al que quiera reconstruir esta ciudad. Pondrá sus cimientos a costa de su hijo mayor, instalará las puertas a costa de su hijo menor'."
,"27":"Yavé estaba con Josué y su fama se extendió por todo el país."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Los israelitas cometieron una grave infidelidad a propósito del anatema. Acán, hijo de Carmí, hijo de Zabdi, hijo de Zerá, de la tribu de Judá, tomó cosas prohibidas por el anatema, y estalló la cólera de Yavé contra los israelitas."
,"2":"Desde Jericó, Josué envió hombres a Aí, que está al lado de Betaven, al este de Betel. 'Suban y exploren el terreno', les dijo. Esos hombres fueron a reconocer la ciudad de Aí."
,"3":"A su regreso dijeron a Josué: 'No vale la pena movilizar a todo el pueblo, basta que suban hasta Aí dos o tres mil hombres para conquistarla, pero no fatigues a todo el pueblo, porque sus habitantes son muy pocos."
,"4":"Subieron más o menos tres mil hombres del pueblo, pero los habitantes de Aí los rechazaron."
,"5":"La gente de Aí les mataron como treinta y seis hombres y luego los persiguieron desde la puerta de la ciudad hasta Sebarim. En la bajada los masacraron. Presa del miedo, el pueblo se desanimó."
,"6":"Entonces Josué rasgó su ropa y estuvo postrado con el rostro en tierra ante el Arca de Yavé hasta la tarde. El y los ancianos de Israel se echaron polvo en sus cabezas."
,"7":"Josué dijo entonces: '¡Ay! ¡Señor Yavé! ¿Para qué hiciste que este pueblo atravesara el Jordán? ¿Fue acaso para entregarnos en manos de los amoreos y hacernos morir? ¿Por qué no nos quedamos mejor al otro lado del Jordán?"
,"8":"Señor, Israel ha vuelto la espalda frente a sus enemigos: ¿qué puedo decir ahora?"
,"9":"Los cananeos y todos los habitantes de este país lo van a saber, nos cercarán y borrarán nuestro nombre de este país. ¿Qué vas a hacer por el honor de tu gran nombre?'"
,"10":"Yavé respondió a Josué: '¡Levántate! ¿Por qué estás ahí tirado con el rostro en tierra?"
,"11":"Israel pecó, fue infiel a la Alianza que le prescribí. Tomaron objetos prohibidos por el anatema, los robaron, mintieron y los escondieron en el equipaje."
,"12":"Los israelitas no opondrán más resistencia a sus enemigos, darán vuelta la espalda frente a sus adversarios, porque se volvieron anatemas. Ya no estaré más con ellos mientras no quiten el anatema de entre ustedes."
,"13":"Pues bien, vas a santificar a los israelitas. Les dirás: Santifíquense para mañana, porque esto dice Yavé, el Dios de Israel: El anatema está entre medio de ustedes, israelitas, y ustedes no opondrán resistencia a sus enemigos hasta que no hayan quitado de entre ustedes el anatema. Por eso comparecerán mañana por tribus."
,"14":"La tribu que retenga Yavé comparecerá por familias, la familia que retenga Yavé comparecerá por casas, y la casa que retenga Yavé comparecerá por cabezas."
,"15":"El que haya sido designado será quemado en la hoguera con todo lo que le pertenezca, porque fue infiel a la Alianza de Yavé y cometió un crimen en Israel'."
,"16":"Al día siguiente, Josué se levantó muy de madrugada e hizo que compareciera Israel. Fue retenida la tribu de Judá."
,"17":"Hizo comparecer las familias de Judá y fue retenida la familia de Zerá. Hizo que compareciera la familia de Zerá por casas y fue retenida la casa de Zabdi."
,"18":"Hizo que compareciera la casa de Zabdi por cabezas y fue retenido Acán hijo de Carmí, hijo de Zabdi, hijo de Zerá de la tribu de Judá."
,"19":"Entonces Josué dijo a Acán: '¡Di la verdad delante de Yavé, el Dios de Israel, hijo mío! ¡Ríndele homenaje! Dime lo que hiciste y no me ocultes nada'."
,"20":"Acán respondió a Josué: 'Es cierto, pequé contra Yavé, el Dios de Israel, y esto fue lo que hice:"
,"21":"En medio de los despojos vi un hermoso manto de Chinear, doscientas piezas de plata y un lingote de oro que pesaba cincuenta siclos. Cedí a la tentación y los tomé. Están ocultos en el suelo en el centro de mi tienda y la plata está debajo'."
,"22":"Josué mandó a dos hombres. Corrieron a la tienda: todo estaba en la tienda bien escondido y la plata estaba debajo."
,"23":"Lo sacaron entonces de la tienda y lo llevaron a donde estaba Josué con todo Israel. Y lo depositaron todo delante de Yavé."
,"24":"Josué y todo Israel tomaron a Acán hijo de Zerá, con la plata, el manto, el lingote de oro, los hijos y las hijas de Acán junto con sus bueyes, sus burros, sus ovejas, su tienda y todo lo que le pertenecía, y los llevaron al valle de Acor."
,"25":"Entonces Josué le dijo: '¿Por qué atrajiste la desgracia sobre nosotros? Que Yavé, hoy día, te traspase a ti la desgracia'. Y todo Israel lo apedreó. Los quemaron en la hoguera y los apedrearon."
,"26":"Encima de Acán se levantó un gran montón de piedras que está allí todavía, y Yavé se apaciguó del ardor de su cólera. Por eso, hasta el día de hoy llaman a ese lugar: el valle de Acor."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Yavé dijo a Josué: '¡No temas ni tengas miedo! Reúnete con todos los hombres de guerra y vayan a atacar a Aí. Pues has de saber que puse en tus manos al rey de Aí y a su pueblo, su ciudad y su territorio."
,"2":"Tratarás a Aí y a su rey igual como trataste a Jericó y a su rey, pero podrán tomar el botín: sus despojos y el ganado. Prepara pues ahora una emboscada detrás de la ciudad'."
,"3":"Josué se levantó con todos los hombres de guerra para atacar a Aí; Josué eligió treinta mil hombres, valientes guerreros, y los envió de noche."
,"4":"Les dio esta orden: 'Pónganse en emboscada muy cerca de la ciudad, detrás de ella."
,"5":"Yo y todo el pueblo que está conmigo nos aproximaremos a la ciudad y cuando salgan a nuestro encuentro como la otra vez, emprenderemos la fuga."
,"6":"Saldrán detrás de nosotros y los atraeremos lejos de la ciudad. Porque pensarán que huimos de ellos como la vez anterior."
,"7":"En ese momento saldrán ustedes de su emboscada y ocuparán la ciudad, ya que Yavé su Dios la puso en manos de ustedes."
,"8":"Cuando se hayan apoderado de la ciudad, le prenderán fuego. ¡Estas son mis órdenes!'"
,"9":"Luego Josué los despachó y se fueron a la emboscada entre Betel y Aí, al oeste de Aí."
,"10":"Josué se levantó muy temprano y pasó revista al pueblo. Luego, junto con los ancianos de Israel, avanzó hacia Aí, a la cabeza del pueblo."
,"11":"Todos los hombres de guerra que estaban con él subieron, se acercaron y llegaron frente a Aí. Acamparon al norte de la ciudad, dejando de por medio el valle entre ellos y Aí."
,"12":"Josué tomó entonces cinco mil hombres y los puso en emboscada entre Betel y Aí, al oeste de la ciudad."
,"13":"El pueblo había instalado su campamento al oeste de Aí. Josué pasó la noche con el pueblo."
,"14":"Al ver esto, el rey de Aí se levantó muy temprano y salió con todo su pueblo al encuentro de Israel para atacarlo en la bajada que lleva a la Araba. No sabían que se había preparado contra ellos una emboscada detrás de la ciudad."
,"15":"Josué y todo Israel se dejaron vencer por ellos y se batieron en retirada por la ruta del desierto."
,"16":"Entonces toda la gente que estaba en la ciudad se juntó para perseguirlos; persiguieron a Josué y se dejaron llevar lejos de la ciudad."
,"17":"Por último no quedó nadie más en Aí; todo el mundo perseguía a Israel. Incluso habían dejado abierta la ciudad cuando se lanzaron en persecución de Israel."
,"18":"Yavé dijo entonces a Josué: 'Esgrime la lanza que tienes en tu mano hacia Aí, que te la voy a entregar en tus manos'. Josué tendió la lanza que tenía en la mano hacia la ciudad,"
,"19":"y apenas hubo hecho el gesto, los que estaban emboscados salieron del lugar donde se encontraban. Corrieron, entraron en la ciudad y se la tomaron, luego prendieron fuego a la ciudad."
,"20":"Al darse vuelta, los hombres de Aí vieron el humo que subía desde la ciudad al cielo. No sabían por dónde escapar, porque el pueblo que hasta ese momento huía al desierto, se volvía ahora contra ellos y los perseguía."
,"21":"Josué y todo Israel habían visto que los que estaban emboscados se habían apoderado de la ciudad, porque el humo subía de la ciudad. Regresaron pues y aplastaron a los hombres de Aí."
,"22":"Estos se toparon con los israelitas por los dos lados, porque los de la emboscada salían ahora de la ciudad a su encuentro. Los masacraron sin dejarles ni un sobreviviente ni un escapado."
,"23":"Los israelitas capturaron vivo al rey de Aí y se lo llevaron a Josué."
,"24":"Israel acabó de masacrar a todos los habitantes de Aí, a los que perseguía en el campo o en el desierto: todos murieron a espada, hasta el último. Luego Israel se volvió contra Aí y pasó a cuchillo la ciudad."
,"25":"El total de los que cayeron ese día, hombres y mujeres, fue de doce mil, todos habitantes de Aí."
,"26":"Josué no bajó su mano que blandía la lanza hasta que todos los habitantes de Aí fueron condenados al anatema."
,"27":"Entonces los israelitas tomaron posesión del ganado y del botín de la ciudad como Yavé se lo había ordenado a Josué."
,"28":"Josué quemó Aí y la convirtió en un montón de ruinas para siempre, como se la ve todavía hoy."
,"29":"Hizo colgar de un árbol al rey de Aí y allí lo dejó hasta la tarde. A la caída del sol Josué mandó que bajaran el cadáver del árbol; lo pusieron a la entrada de la ciudad y echaron encima un gran montón de piedras que se ven todavía hoy."
,"30":"Josué levantó entonces en el monte Ebal un altar en honor a Yavé, el Dios de Israel."
,"31":"Era un altar de piedras naturales que no habían sido talladas por el hierro, como Moisés el servidor de Yavé lo había ordenado a los israelitas, y como está escrito en el Libro de la Ley de Moisés. Se dispusieron holocaustos en el altar en honor de Yavé y se ofrecieron sacrificios de comunión."
,"32":"Josué escribió allí en unas piedras una copia de la Ley que Moisés había escrito en presencia de los israelitas."
,"33":"Todo Israel, con sus ancianos, sus escribas y sus jueces, estaba allí formado a los dos lados del Arca, mirando a los sacerdotes levitas que llevaban el Arca de la Alianza de Yavé. El extranjero se mezclaba allí con el hombre de ese país. La mitad estaba al lado del monte Garizim y la otra mitad al lado del monte Ebal, según la orden que Moisés, el servidor de Yavé, había dado antes para la bendición del pueblo de Israel."
,"34":"Josué leyó todas las palabras de la Ley, la bendición y la maldición, como está escrito en el Libro de la Ley."
,"35":"Josué leyó las instrucciones de Moisés, sin exceptuar nada, en presencia de la comunidad de Israel, en presencia de las mujeres, de los niños y de los extranjeros que vivían con ellos."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Los reyes de la región más allá del Jordán supieron todo eso. Inmediatamente, tanto en la montaña como en el llano, en la costa del Gran Mar como en los alrededores del Líbano, los hititas, amoreos, cananeos, fereceos, jeveos y jebuseos"
,"2":"se reunieron para atacar juntos a Josué y a Israel."
,"3":"Los habitantes de Gabaón sabían cómo Josué había tratado a Jericó y a Aí,"
,"4":"y decidieron recurrir a una astucia. Tomaron provisiones para el viaje, pero pusieron en sus burros sacos gastados, pellejos de vino raídos, reventados y parchados."
,"5":"Se pusieron en los pies sandalias rotas y remendadas, se vistieron con ropas viejas, y el pan que llevaban en sus alforjas estaba duro y se desmenuzaba."
,"16":"Se presentaron ante Josué en el campamento de Guilgal y esto fue lo que le contaron a él y a los hombres de Israel: 'Venimos de un país lejano, hagan pues alianza con nosotros'. Los hombres de Israel respondieron a esos jeveos: '¿Y si ustedes viven cerca de nosotros? ¿Cómo podríamos en ese caso hacer una alianza con ustedes?'"
,"8":"Pero respondieron a Josué: '¡Somos tus servidores!' Josué agregó: '¿Quiénes son ustedes y de dónde vienen?'"
,"9":"Respondieron: 'La fama de Yavé, tu Dios, nos movió a venir de un país muy lejano. Oímos hablar de todo lo que hizo en Egipto,"
,"10":"de todo lo que hizo a los dos reyes de los amoreos al otro lado del Jordán, a Sijón, rey de Jesbón y a Og, rey de Basán que estaban en Astarot."
,"11":"Entonces nuestros ancianos y todos los habitantes de nuestro país nos dijeron: Junten provisiones para el viaje y vayan a verlos y díganles: Somos sus servidores, hagan pues alianza con nosotros."
,"12":"Miren, nuestro pan estaba caliente todavía cuando lo tomamos en nuestras casas el día en que emprendimos el viaje para venir a verlos, y ahora está seco y se deshace."
,"13":"Estos pellejos de vino eran nuevos cuando los llenamos, y ahora están rasgados. Nuestra ropa y nuestras sandalias están gastadas porque el viaje fue largo'."
,"14":"Los hombres de Israel compartieron con ellos sus provisiones sin consultar al oráculo de Yavé."
,"15":"Josué les dio la paz y firmó con ellos una alianza que les garantizaba la vida; después de eso los jefes de la comunidad les hicieron un juramento."
,"16":"Pero tres días después de haber firmado esa alianza, supieron que esa gente era vecina suya y que vivía cerca de ellos."
,"17":"Los israelitas se pusieron en camino llegaron a sus ciudades. Eran Gabaón, Carifá, Beerot y Quiriat-Yearim."
,"18":"Los israelitas no los mataron porque los jefes de la comunidad les habían hecho un juramento en nombre de Yavé, el Dios de Israel, pero toda la comunidad murmuró contra los jefes."
,"19":"Los jefes respondieron a la comunidad: 'Les hicimos un juramento en nombre de Yavé, el Dios de Israel: ahora no podemos ponerles la mano encima."
,"20":"Actuemos, pues, con ellos de esta manera: los dejaremos con vida para no atraer sobre nosotros una desgracia, debido al juramento que les hicimos,"
,"21":"pero serán los siervos de toda la comunidad, partirán la leña e irán a buscar el agua'. Eso decidieron los jefes."
,"22":"Josué los reunió y les dijo: '¿Por qué nos mintieron? Dijeron que venían de muy lejos, cuando en realidad viven cerca de nosotros."
,"23":"Ustedes son ahora malditos, serán esclavos para siempre, partirán leña y traerán agua para la Casa de mi Dios'."
,"24":"Le respondieron: 'Nos habían dado a conocer las instrucciones de Yavé tu Dios a Moisés su servidor: Yavé les dará todo el país pero ustedes exterminarán a todos sus habitantes. Temimos mucho por nuestras vidas y por eso actuamos de esa manera."
,"25":"Ahora estamos en tus manos, trátanos como te parezca bueno y justo'."
,"26":"Josué no los entregó a los israelitas para que fueran masacrados,"
,"27":"pero desde ese día debieron partir la leña e ir a buscar el agua para la comunidad, para el altar de Yavé, en el lugar que éste debía designar. Y todavía lo hacen."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Adoni-Sedec, rey de Jerusalén, supo que Josué se había apoderado de Aí y que la había condenado al anatema: había tratado a Aí y a su rey como lo había hecho con Jericó y su rey. Supo también que los habitantes de Gabaón, que vivían en medio de los israelitas, habían hecho la paz con ellos,"
,"2":"y le entró mucho miedo. Porque Gabaón era una gran ciudad como una capital real; era más grande que Aí y todos sus hombres estaban entrenados."
,"3":"Por eso Adoni-Sedec, rey de Jerusalén, mandó a decir a Oham, rey de Hebrón, a Piream, rey de Jarmut, a Jafia, rey de Laquis, y a Debir, rey de Eglón:"
,"4":"Suban hasta mi casa y ayúdenme a castigar a Gabaón porque hizo la paz con Josué y los israelitas'."
,"5":"Se reunieron pues los cinco reyes de los amoreos y salieron de campaña con todo su ejército: el rey de Jerusalén, el rey de Hebrón, el rey de Jarmut, el rey de Laquis y el rey de Eglón. Acamparon frente a Gabaón para atacar la ciudad."
,"6":"La gente de Gabaón mandó a avisar a Josué en el campamento de Guilgal: 'No niegues tu auxilio a tus servidores, apresúrate en subir hasta nosotros, porque todos los reyes de los amoreos que viven en la montaña se aliaron en contra nuestra. Ven pues a librarnos y salvarnos'."
,"7":"Subió pues Josué desde Guilgal, y junto con él todos los hombres de guerra, todos los valientes guerreros."
,"8":"Yavé dijo a Josué: 'No temas, los he puesto en tus manos, y nadie podrá resistirte'."
,"9":"Josué los atacó por sorpresa, porque había subido desde Guilgal durante la noche."
,"10":"Yavé les provocó el desastre ante Israel y les infligió una gran derrota en Gabaón. Josué los persiguió por el camino que sube a Bet-Horón y los acosó hasta Azecá y Maquedá."
,"11":"Mientras huían ante Israel, Yavé lanzó de lo alto del cielo como grandes piedras cuando alcanzaban la bajada de Bet-Horón, hasta Azecá. Murieron golpeados. Los que murieron por las piedras de hielo fueron más numerosos que los que cayeron bajo la espada de los israelitas."
,"12":"Ese día en que Yavé puso al Amorreo en las manos de los israelitas, Josué se volvió hacia Yavé y exclamó delante de todo Israel: '¡Detente, sol, sobre Gabaón!,¡Y tu luna, sobre el valle de Ayalón!'"
,"13":"Y el sol se detuvo y la luna se quedó inmóvil hasta que el pueblo se hubo vengado de sus enemigos. ¿No está eso escrito en el Libro del Justo? El sol se detuvo en medio del cielo y se demoró en ponerse durante casi todo un día."
,"14":"No ha habido otro día como ése, ni antes ni después, en que Yavé haya escuchado la voz de un hombre. Ese día Yavé combatió por Israel."
,"15":"Después Josué y todo Israel regresaron al campamento, en Guilgal."
,"16":"Ahora bien, los cinco reyes que habían huido se escondieron en la cueva de Maquedá."
,"17":"Se lo comunicaron a Josué: '¡Hallaron a los cinco reyes! Están escondidos en la cueva de Maquedá'."
,"18":"Josué dijo: 'Hagan rodar grandes piedras hasta la entrada de la cueva y pongan al lado de ella hombres de guardia."
,"19":"Pero ustedes no se detengan, persigan a sus enemigos, córtenles la retirada; impídanles que lleguen a su ciudad, porque Yavé el Dios de ustedes los puso en sus manos'."
,"20":"Josué y los israelitas terminaron de masacrarlos y de exterminarlos; sólo algunos escapados lograron llegar a las ciudades fortificadas."
,"21":"Entonces todo el pueblo regresó sin peligro donde Josué, en Maquedá; nadie más en adelante se atrevió a levantar siquiera un dedo contra los israelitas."
,"22":"Josué dijo: 'Abran la entrada de la cueva y tráiganme a esos cinco reyes; sáquenlos de la cueva'."
,"23":"Sacaron pues de la cueva a los cinco reyes: al rey de Jerusalén, al rey de Hebrón, al rey de Jarmut, al rey de Laquis y al rey de Eglón."
,"24":"Cuando los hubieron sacado, Josué dijo a los jefes de guerra que habían combatido con él: 'Acérquense y pongan su pie en la nuca de esos reyes'. Se aproximaron y pusieron su pie en la nuca de ellos."
,"25":"Josué les dijo: 'No teman ni tengan miedo, sean valientes y tengan ánimo porque así tratará Yavé a todos los enemigos con los que tengan que pelear'."
,"26":"Después de eso, Josué les dio muerte. Los colgaron en cinco árboles y allí quedaron colgados hasta la tarde."
,"27":"Al ponerse el sol, Josué ordenó que los bajaran de los árboles. Los echaron en la cueva donde se habían escondido y cerraron la entrada de la cueva con grandes piedras que se encuentran allí hasta el día de hoy."
,"28":"Ese mismo día Josué se apoderó de Maquedá y pasó a cuchillo a toda la ciudad. Lanzó el anatema sobre la ciudad y todos sus habitantes y no dejó escapar a nadie. Trató al rey de Maquedá como había tratado al rey de Jericó."
,"29":"En seguida, Josué y todo Israel con él pasaron de Maquedá a Libna a la que atacó."
,"30":"Yavé puso la ciudad y a su rey en manos de Israel. La pasó a cuchillo como también a todos sus habitantes, sin dejar escapar a nadie, y trató a su rey como había tratado al rey de Jericó."
,"31":"Josué y todo Israel con él pasaron de Libna a Laquis. Instaló su campamento frente a la ciudad y la atacó."
,"32":"Yavé puso a Laquis en manos de Israel. Se apoderó de ella al segundo día y la pasó a cuchillo como también a todos sus habitantes, igual como lo había hecho con Libna."
,"33":"Entonces Horam, rey de Gazer, llegó para socorrer a Laquis, pero Josué venció al rey y a su pueblo y no dejó ningún sobreviviente."
,"34":"Josué, a la cabeza de todo Israel, pasó de Laquis a Eglón. Instalaron su campamento frente a la ciudad y la atacaron."
,"35":"Se apoderaron de ella ese mismo día y la pasaron a cuchillo. Ese día Josué lanzó el anatema sobre todos los habitantes como había hecho con Laquis."
,"36":"Josué, a la cabeza de todo Israel, subió de Eglón a Hebrón y la atacó."
,"37":"Se apoderaron de ella; pasaron a cuchillo la ciudad, su rey, todas las ciudades que dependían de él y a todos sus habitantes, como lo habían hecho con Eglón, sin dejar un solo sobreviviente. Josué condenó al anatema la ciudad y sus habitantes."
,"38":"Josué, a la cabeza de todo Israel, se dirigió hacia Debir para atacarla."
,"39":"Se apoderó de la ciudad, de su rey y de todas las ciudades que dependían de él. Las pasó a cuchillo y lanzó el anatema sobre todos los habitantes sin dejar un solo sobreviviente. Trató a Debir y a su rey como había tratado a Hebrón y como había tratado a Libna y a su rey."
,"40":"De ese modo castigó Josué a toda la región y a sus reyes: la montaña, el Negueb, las llanuras y las lomas. No dejó sobrevivientes, sino que lanzó el anatema sobre todo ser viviente como lo había ordenado Yavé, el Dios de Israel."
,"41":"Josué los derrotó desde Cadés-Barné hasta Gaza y desde el territorio de Goser hasta Gabaón."
,"42":"Josué se adueñó de un solo golpe de todos esos reyes y de sus territorios, porque Yavé, el Dios de Israel, combatía por Israel."
,"43":"Entonces Josué y todo Israel con él, regresaron al campamento de Guilgal."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Cuando Jabín, rey de Hasor supo todo eso, mandó mensaje a Jobab, rey de Merom, al rey de Simrón, al rey de Acsaf"
,"2":"y a los reyes que viven en la montañas del norte, en la planicie de Quinerot al sur, en la planicie y en las lomas de Dor al oeste."
,"3":"Los cananeos estaban al este y al oeste: los amoreos, los hititas, los fereceos y los jebuseos, en la montaña; los jeveos al pie del Hermón, en el territorio de Mispá."
,"4":"Salieron de campaña con todos sus ejércitos, era un pueblo tan numeroso como la arena de la orilla del mar, con una multitud de caballos y carros."
,"5":"Todos esos reyes se reunieron y acamparon cerca de las aguas de Merom para atacar a Israel."
,"6":"Pero Yavé dijo a Josué: 'No le temas, porque mañana a esta hora los entregaré heridos de muerte a Israel. Cortarás los jarretes de sus caballos y echarás al fuego sus carros'."
,"7":"Josué y todos sus hombres de guerra los atacaron por sorpresa en las aguas de Merom; se abalanzaron sobre ellos."
,"8":"Yavé los puso en las manos de Israel quien los aplastó y los persiguió hasta Sidón la Grande y hasta las aguas de Misrefot y el valle de Mispá, al este. Los derrotaron de tal manera que no hubo un solo sobreviviente."
,"9":"Josué los trató como se lo había dicho Yavé: les cortó los jarretes a los caballos y echó al fuego los carros."
,"10":"En ese tiempo, Josué se devolvió y se apoderó de Hasor, pues Hasor era entonces la capital de todos esos reinos. Josué acuchilló a su rey."
,"11":"Condenaron al anatema y pasaron a filo de espada a todos los seres vivientes que allí estaban; no se dejó a nadie con vida en Hasor, a la que se incendió."
,"12":"Josué se adueñó de todas esas ciudades y de todos sus reyes. Lanzó sobre ellos el anatema y los pasó a cuchillo como Moisés, el servidor de Yavé, lo había ordenado."
,"13":"Pero Israel no quemó ninguna de las ciudades edificadas en las colinas, excepto Hasor a la que Josué incendió."
,"14":"Los israelitas se apoderaron de todo el botín, pero pasaron a cuchillo a toda la población hasta exterminarla completamente: no quedó nadie."
,"15":"Josué llevó a cabo todo lo que Yavé había ordenado a Moisés su servidor, y que Moisés había transmitido a Josué. No se olvidó de nada de todo lo que Yavé había ordenado a Moisés."
,"16":"De ese modo se apoderó Josué de todo el país: de la montaña, de todo el Negueb, de la región de Gosén, de la planicie, de la Arabá, de la montaña de Israel y de sus llanuras,"
,"17":"desde el cerro pelado que se ve al lado de Seir hasta Baal Gad en el valle del Líbano al pie del Hermón. Capturó a todos los reyes, y les dio muerte."
,"18":"Durante largos días Josué luchó contra todos esos reyes:"
,"19":"ninguna de esas ciudades hizo la paz con los israelitas."
,"20":"Yavé les dio ánimo a todos para que hicieran la guerra a Israel, con el fin de que fueran consagrados en anatema y destruidos sin misericordia como Yavé se lo había ordenado a Moisés."
,"21":"En ese tiempo, Josué se devolvió para exterminar a los anaquim de la montaña, de Hebrón, de Debir, de Anab, en una palabra de toda la montaña de Judá y de toda la montaña de Israel: los condenó al anatema junto con sus ciudades."
,"22":"No quedó un solo anaquim en el territorio de los israelitas, excepto en Gaza, en Gat y en Azoto."
,"23":"Josué se apoderó de todo el país, tal como Yavé se lo había dicho a Moisés, y lo distribuyó entre las tribus de Israel para que fuera su herencia. Entonces el país descansó de la guerra."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Estos son los reyes a los que vencieron los israelitas al otro lado del Jordán al este, desde el torrente de Arnón hasta el monte Hermón, con toda la Arabá al este (Israel se había apoderado de sus territorios)."
,"2":"Sijón, rey de los amoreos, que vivía en Jesbón. Su reino comenzaba en Aroer, a orillas del Arnón; comprendía el fondo del valle, la mitad de Galaad hasta el torrente de Yaboc que marca la frontera con los Amonitas,"
,"3":"la Arabá hasta el mar de Quinerot al este y el mar de la Arabá o el Mar Salado al este, en dirección a Bet-ha-Jesimot, y al sur las primeras cuestas del Pisga."
,"4":"Og, rey de Basán, uno de los últimos refaím, residía en Astarot y en Edrei."
,"5":"Su reino comenzaba en el monte Hermón en Salca; comprendía todo el Basán hasta la frontera con los Guesuritas y los Maacatitas, y la mitad de Galaad hasta la frontera con Sijón, rey de Hesbón."
,"6":"Moisés, el servidor de Yavé, y los israelitas los habían vencido y Moisés había dado la posesión de ese territorio a la tribu de Rubén, a la de Gad y a la media tribu de Manasés."
,"7":"Esta es la lista de los reyes del país a los que Josué y los israelitas derrotaron a este lado del Jordán, al oeste, desde Baal Gad en el valle del Líbano hasta el monte Pelé que se levantaba al lado de Seir. Josué distribuyó sus tierras y se las dio en herencia a las tribus de Israel,"
,"8":"ya fuera en la montaña o en las tierra bajas, en la Arabá o en los lomajes regados, en el desierto o en el Negueb, entre los hititas, los amoreos, los cananeos, los fereceos, los jeveos y los jebuseos:"
,"9":"Al rey de Jericó, al rey de Aí, al lado de Betel;"
,"10":"al rey de Jerusalén, al rey de Hebrón;"
,"11":"al rey de Jarmut, al rey de Laquis;"
,"12":"al rey de Eglón, al rey de Guezer;"
,"13":"al rey de Debir, al rey de Gueder;"
,"14":"al rey de Jorma, al rey de Arad;"
,"15":"al rey de Libna, al rey de Adulam;"
,"16":"al rey de Maquedá, al rey de Betel;"
,"17":"al rey de Tapúa, al rey de Jefer;"
,"18":"al rey de Afec, al rey de Sarón;"
,"19":"al rey de Merom, al rey de Jasor;"
,"20":"al rey de Simerón-Merón, al rey de Acsaf;"
,"21":"al rey de Tanac, al rey de Megido;"
,"22":"al rey de Cadés, al rey de Jocneam, al pie del Carmelo;"
,"23":"al rey de Dor, en los lomajes de Dor, al rey de las naciones en Galilea;"
,"24":"al rey de Tirsa. En total treintaiún reyes."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Josué había vivido ya muchos días y tenía mucha edad cuando Yavé le dijo: 'Te has vuelto viejo, tienes ya mucha edad y todavía queda un vasto territorio por conquistar."
,"2":"Esto es lo que falta: todos los territorios de los filisteos, todo el territorio de los guesuritas,"
,"3":"desde el Sijor frente a Egipto hasta la frontera de Ecrón al norte, al que se lo considera como el territorio de los cananeos. (Los cinco pequeños reinos filisteos son: Gaza, Asdod, Asquelón, Gat y Ecrón y los avitas están"
,"4":"al sur). Luego todo el país de los cananeos desde Meará que pertenece a Sidón hasta Afeca y hasta el territorio de los amoreos; el territorio de los guiblitas con todo el Líbano al este, desde Baal-Gad al pie del monte Hermón hasta la entrada a Jarmut."
,"6":"A todos los habitantes de la montaña, desde el Líbano hasta las aguas de Misrefot y a todos los sidonios los expulsaré ante los israelitas y tú no tendrás más que repartir el país como herencia entre los israelitas, tal como te lo ordené."
,"7":"Ahora pues reparte este país para que sea la herencia de las nueve tribus y de la media tribu de Manasés. Tú se lo darás desde el Jordán hasta el Gran Mar al oeste: el Gran Mar será su frontera'."
,"8":"Moisés había dado ya su herencia al otro lado del Jordán, al este, a la otra media tribu de Manasés, a la tribu de Rubén y a la de Gad. Esto fue lo que Moisés servidor de Yavé les había dado entonces como territorio:"
,"9":"desde Aroer en el curso del Arnón, la ciudad que está en el fondo del valle, toda la meseta desde Medba hasta Dibón;"
,"10":"todas las ciudades de Sijón hasta la frontera con los amoreos; Galaad y el territorio de los Guesuritas y de los Maacatitas, toda la cadena montañosa del Hermón, todo el Basán hasta Salca;"
,"12":"y en el Basán, todo el territorio de Og que reinaba en Astarot y en Edrei y que fue el último sobreviviente de los refaim. Moisés había vencido y aniquilado a estos reyes."
,"13":"Sin embargo los israelitas no arrasaron ni a los guesuritas ni a los maacatitas, por eso Guesu y Maaca existen hasta el día de hoy en medio de Israel."
,"14":"A la única tribu a la que no se le dio su parte de herencia fue la tribu de Leví, porque Yavé Dios de Israel es su herencia como él se lo dijo."
,"15":"Moisés había hecho el reparto entre los clanes de la tribu de Rubén."
,"16":"Este es el territorio que recibieron: desde Aroer en el curso del Arnón, la ciudad que está en el fondo del valle, toda la meseta hasta Medba; Hesbón con todas las ciudades que están en la meseta: Dibón, Bamot-Baal, Bet-Baal-Meón,"
,"18":"Yahas, Cedemot, Mefaat,"
,"19":"Quiriatayim, Sibma y Seretasahar en la montaña de la Arabá;"
,"20":"Bet Peor, las pendientes regadas del Pisga, Betajesimot,"
,"21":"todas las ciudades de la meseta y todo el reino de Sijón, rey de los amoreos.(Había sido derrotado por Moisés junto con los príncipes de Madián: Evi, Requem, Sur, Hur y Reba que eran súbditos de Sijón y que vivían en esas tierras."
,"22":"El adivino Balaam, hijo de Peor, formaba parte de los que habían sido pasados a cuchillo)."
,"23":"La frontera de Rubén era pues el Jordán y todo su territorio. Esa era la herencia de los clanes de Rubén con sus ciudades y sus aldeas."
,"24":"Moisés había hecho el reparto entre los clanes de la tribu de Gad."
,"25":"Este es el territorio que recibieron: Yazer y todas las ciudades de Galaad, la mitad del territorio de los amoreos hasta Aroer que está frente a Raba,"
,"26":"desde Hesbón hasta Ramat-ha-Mispé y Betonim, a partir de Majanayim hasta el territorio de Lo-Debar, en el valle: Betaram, Betnimra, Sucot, Safón (todo eso era la segunda mitad del reino de Sijón, rey de Hesbón), el Jordán y el territorio que se extiende hasta el mar de Quineret en la ribera este del Jordán."
,"28":"Esa era la herencia de los clanes de Gad con sus ciudades y sus aldeas."
,"29":"Moisés había hecho el reparto entre los clanes de la media tribu de Manasés."
,"30":"Este es el territorio que recibieron: a partir de Majanaim, todo el Basán, todo el reino de Og rey de Basán, todas las tiendas de campaña de Yaír en Basán, en total sesenta ciudades."
,"31":"Los hijos de Maquir, hijo de Manasés, recibieron la mitad de Galaad con Astarot y Edrei, las capitales de Og de Basán. Tal fue el territorio de los clanes de Maquir."
,"32":"Esa era la herencia que había repartido Moisés en las estepas de Moab, al otro lado del Jordán, al este de Jericó."
,"33":"Pero Moisés no le dio su parte de herencia a la tribu de Leví, porque Yavé el Dios de Israel es su herencia como él se lo dijo."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Esta es la herencia de los israelitas en el territorio de Canaán. Esto fue lo que les dieron en herencia el sacerdote Eleazar, Josué hijo de Nun y los jefes de los clanes y de las tribus de Israel."
,"2":"El reparto se hizo por sorteo, como Yavé lo había ordenado por boca de Moisés, entre nueve tribus y media,"
,"3":"pues Moisés ya había dado su herencia a dos tribus y media al otro lado del Jordán. No había incluido en el reparto a los levitas, pero en cambio los hijos de José formaban dos tribus: Manasés y Efraín. Los levitas no recibieron más que las ciudades donde vivían, con las tierras que las rodeaban, para sus ganados y sus cultivos."
,"5":"Los israelitas se repartieron el país ateniéndose a la orden que Yavé había dado a Moisés."
,"6":"Los hijos de Judá fueron a ver a Josué en Guilgal y Caleb hijo de Jefoné, el quenisita, le dijo: 'Tú sabes lo que Yavé dijo a Moisés, el hombre de Dios, respecto a mí y a ti cuando estábamos en Cadés-Barne."
,"7":"Tenía entonces cuarenta años cuando Moisés, el servidor de Yavé, me mandó desde Cadés-Barne a explorar el territorio y yo le di mi informe con toda sinceridad."
,"8":"Mientras mis hermanos que habían subido conmigo desalentaban al pueblo, yo permanecí fiel a Yavé mi Dios."
,"9":"Por eso, Moisés hizo ese día este juramento: La tierra que ha pisado tu pie será tu herencia y la de tus descendientes para siempre, porque seguiste fielmente a Yavé mi Dios."
,"10":"Hace cuarenta y cinco años que Yavé dirigió esta palabra a Moisés cuando Israel caminaba por el desierto, y Yavé me conservó con vida como lo había prometido. Ahora tengo ochenta y cinco años,"
,"11":"pero todavía estoy tan firme como el día en que Moisés me envió. Me siento ahora con tanta fuerza como antes, ya sea para pelear como para ir y venir."
,"12":"Dame pues esa montaña de la que habló Yavé ese día. Tú mismo lo escuchaste entonces: allí están los anaquim en sus ciudades grandes y fortificadas, pero ¡ojalá que Yavé esté conmigo! Y los expulsaré como Yavé lo dijo."
,"13":"Josué bendijo a Caleb hijo de Jefoné y le dio como herencia Hebrón."
,"14":"Por eso Hebrón ha formado parte hasta el día de hoy de la herencia de Caleb, hijo de Jefoné el quenisita, porque había seguido fielmente a Yavé, el Dios de Israel."
,"15":"Hebrón se llamaba antes Quiriat-Arba (esa Arba era el hombre famoso de los anaquim); y con esto el país descansó de las guerras."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Los clanes de la tribu de Judá recibieron por sorteo un territorio que llegaba hasta la frontera de Edom y que se extendía desde el desierto de Sin hasta Cadés por el sur."
,"2":"La frontera meridional partía de la extremidad del Mar Salado, de la lengua de tierra que mira al sur,"
,"3":"se prolongaba por el sur de la subida de los Escorpiones, atravesaba Sin, subía al sur de Cadés-Barne; pasaba luego por Jesrón, subía hasta Addar y volvía entonces hacia Carca."
,"4":"Luego la frontera pasaba por Asmón, llegaba al torrente de Egipto y terminaba en el Mar. Esa era la frontera meridional."
,"5":"El Mar Salado hasta la desembocadura del Jordán constituía la frontera oriental. Por el norte, partía la frontera desde el golfete en la desembocadura del Jordán."
,"6":"La frontera subía luego a Bet-Hogla, pasaba por el norte de Bet-ha-Arabá y se prolongaba hasta la Roca de Bohán (Bohán era hijo de Rubén)."
,"7":"La frontera seguía luego a Debir, por el valle de Acor y subía por el norte a Guilgal frente a la subida de Adumim al sur del Torrente. La frontera pasaba después por las fuentes de En-Chemech y de En-Roguel;"
,"8":"subía luego por el barranco de Ben- Hinom, pasando por el sur del territorio de los jebuseos (es decir Jerusalén), luego proseguía por la cumbre de la montaña que está frente al barranco de Hinom al oeste, en el extremo de la llanura de los refaim por el norte."
,"9":"Entonces la frontera descendía de la cumbre de la montaña al manantial de Neftoa, luego se dirigía a las ciudades que están en el cerro Efrón y se volvía en dirección a Baala (es decir Quiriat-Yearim)."
,"10":"De Baala, la frontera continuaba al oeste hasta el monte Seir, se prolongaba por la pendiente del monte Yearim en dirección al norte (es decir Quesalón), pasaba por Bet-Chemech, atravesaba Timna,"
,"11":"y llegaba por la falda norte de Ecrón. Allí se volvía hacia Chicarón, pasaba por la montaña de Baal, y luego por Yabuel. La frontera terminaba en el mar."
,"12":"El Gran Mar constituía la frontera occidental. Esa era la frontera de los clanes de Judá."
,"13":"A Caleb, hijo de Jefoné se le entregó su parte en medio de la tribu de Judá, de acuerdo a la orden de Yavé a Josué: Quiriat-Arbá, la ciudad del padre de Anac (que ahora es Hebrón)."
,"14":"Caleb expulsó de allí a los tres hijos de Anac."
,"15":"Desde allí llevó a cabo una campaña contra los habitantes de Debir (antes Debir se llamaba Quiriat-Sefer)."
,"16":"Entonces Caleb exclamó: '¡Al que ataque Quiriat-Safer y se apodere de ella, le daré a mi hija Acsa como esposa!'"
,"17":"Otoniel, hijo de Quenaz, hermano de Caleb, se tomó la ciudad, y Caleb le dio a su hija Acsa como esposa."
,"18":"Cuando ésta llegó donde su marido, éste le aconsejó que pidiera a su padre un campo. Saltó pues de su burro y Caleb le preguntó: '¿Qué quieres?'"
,"19":"Respondió: '¡Hazme un favor, ya que me has mandado al Negueb, dame al menos un manantial!' Y le dio las Fuentes de Arriba y las Fuentes de Abajo."
,"20":"Esa fue la posesión de los clanes de Judá."
,"21":"Estas eran las ciudades al sur del territorio de Judá; al lado de la frontera con Edom, en el Negueb: Cabsel, Arad, Jagur,"
,"22":"Quina, Dimón, Aroer,"
,"23":"Cadés, Jasor-Jituán,"
,"24":"Zif, Telem, Balot,"
,"25":"Jasor-Jadata, Queriot-Hesrón (es decir Jasor),"
,"26":"Amam, Sema, Meclada,"
,"27":"Jasar-Gada, Hesmón, Bet-Pelet,"
,"28":"Jasar-Sual, Bersabé y sus pastizales,"
,"29":"Baala, Ijim, Esen,"
,"30":"Eltolad, Quesil, Jormá,"
,"31":"Siquelag, Madmana, Sansana,"
,"32":"Lebaot, Siljim, Ajín y Rimmón: en total, veintinueve ciudades y sus aldeas."
,"33":"En las tierras bajas: Estaol, Sorea, Ajna,"
,"34":"Zanúa, Enganim, Tapúa, Enam,"
,"35":"Jarmot, Adulam, Soco, Azeca,"
,"36":"Saarim, Aditaim, Ja-Guedera y Guederotarim: catorce ciudades y sus aldeas."
,"37":"Senán, Adasa, Migdalgat,"
,"38":"Dileán, Jamispé, Yoctel,"
,"39":"Laquis, Boscat, Eglón,"
,"40":"Cabón, Lajmas, Quitlis,"
,"41":"Guederot, Bet-dagón, Naama y Maqueda: dieciséis ciudades y sus aldeas."
,"42":"Libna, Eter, Asán,"
,"43":"Jifta, Asna, Nesib,"
,"44":"Queila, Aczib y Maresa: nueve ciudades y sus aldeas."
,"45":"Ecrón con sus pastizales y sus aldeas,"
,"46":"todo lo que está en la región de Asdod, con sus aldeas, desde Ecrón hasta el mar."
,"47":"Asdod con sus pastizales y sus aldeas, Gaza con sus pastizales y sus aldeas, desde el Gran Mar hasta el Torrente de Egipto."
,"48":"En la montaña: Samir, Yatir, Soco,"
,"49":"Dana, Quiriat-Sefer (actualmente Debir),"
,"50":"Anab, Estemoa, Anim,"
,"51":"Gosen, Jolón y Quilo: once ciudades y sus aldeas."
,"52":"Arab, Duma, Eseán,"
,"53":"Janum, Bet-tapúa, Afeca,"
,"54":"Umta, Quiriat-Arba (actualmente Hebrón) y Sior: nueve ciudades y sus aldeas."
,"55":"Maón, Carmel, Zif, Juta,"
,"56":"Jizreel, Yorqueam, Zanúa,"
,"57":"Jacayim, Guibea y Timna: diez ciudades y sus aldeas."
,"58":"Halul, Betsar, Guedor,"
,"59":"Maarat, Betamot y Eltecón: seis ciudades y sus aldeas. Tecoa, Efratá (actualmente es Belén), Peor, Etam, Culón, Tatam, Sorés, Carem, Galim, Beter y Mana: once ciudades y sus aldeas."
,"60":"Quiriat-Baal (es decir Quiriat-Yearim) y Jaraba: dos ciudades y sus aldeas."
,"61":"En el desierto: Betaraba, Midin, Secaca,"
,"62":"Nibsán, la ciudad de la sal y Engadi: seis ciudades y sus aldeas."
,"63":"Los hijos de Judá no pudieron echar a los jebuseos que vivían en Jerusalén, por eso los jebuseos viven hasta el día de hoy en Jerusalén al lado de los hijos de Judá."
}`)
	CurrentBook.AddChapter(16, `{
"1":"La parte de los hijos de José comenzaba por el este al lado del Jordán, en Jericó (en los manantiales de Jericó). Incluía el desierto que se extiende desde Jericó a Betel en la montaña."
,"2":"Se extendía desde Betel hasta Luz y llegaba hasta la frontera de los arquitas en Atarot."
,"3":"Se prolongaba por el oeste en dirección a la frontera de los jafleteos hasta la frontera de Bethorón de abajo y hasta Guezer terminando en el mar. Esa era la parte que correspondió a Manasés y a Efraín, hijos de José."
,"5":"Para el territorio de los clanes de Efraín, la frontera de su posesión pasaba por Atro-arac, por Bethorón de arriba,"
,"6":"y terminaba en el mar. Al norte quedaba el Micmetat. La frontera se volvía luego al este hacia Taanat-Silo y atravesaba por el este en dirección a Janoa."
,"7":"Descendía de Janoa hasta Atarot y Naara, pasaba por Jericó para terminar en el Jordán."
,"8":"De Tapúa, la frontera continuaba al oeste hasta el torrente de Cana y terminaba en el mar. Esa era la parte que les tocó a los clanes de la tribu de Efraín,"
,"9":"además de las ciudades (ciudades y aldeas) que fueron reservadas para los hijos de Efraín dentro de la parte de la tribu de Manasés."
,"10":"No pudieron sin embargo expulsar a los cananeos que vivían en Guezer; éstos se quedaron en medio de Efraín hasta el día de hoy pero fueron sometidos a tributo."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Maquir era el hijo mayor de Manasés, quien a su vez era el hijo mayor de José. Era un hombre guerrero y recibió como herencia Galaad y Basán."
,"2":"Esto es lo que respecta a los otros hijos de Manasés y a sus clanes: los hijos de Abiezer, los hijos de Helec, los hijos de Asnel, los hijos de Sequem, los hijos de Jefer y los hijos de Semida (eran los hijos varones de Manasés, hijo de José, según sus clanes)."
,"3":"Selofejad, hijo de Jefer, hijo de Galaad, hijo de Maquir, hijo de Manasés, no tenía hijos sino sólo hijas. Se llamaban: Majla, Noa, Hogla, Milca y Tirsa."
,"4":"Fueron pues a ver al sacerdote Eleazar y a Josué hijo de Nun y a todos los jefes. Les dijeron: 'Yavé ordenó a Moisés que nos diesen una parte en herencia en medio de nuestros hermanos'. Les dieron pues una posesión en medio de los hermanos de su padre, según la orden de Yavé."
,"5":"Manasés recibió pues diez partes de más en el territorio de Galaad y Basán,"
,"6":"ya que las hijas de Manasés recibieron una posesión en medio de sus hijos. Galaad pertenecía a los otros hijos de Manasés."
,"7":"Para el lado de Aser, constituía la frontera el Micmetat que está frente a Siquem. Esta descendía por el sur hacia Yasib que es la fuente de Tapúa."
,"8":"Manasés poseía en efecto la región de Tapúa, pero Tapúa en la frontera de Manasés pertenecía a Efraín."
,"9":"La frontera proseguía por el torrente de Cana; al sur de ese torrente estaban las ciudades de Efraín, fuera de las que poseía Efraín en medio de las ciudades de Manasés. La frontera de Manasés pasaba por el norte del torrente y terminaba en el mar."
,"10":"El sur pertenecía a Efraín y el norte a Manasés, y el mar era su límite. Tocaba a Aser por el norte y a Isacar por el este."
,"11":"En el territorio de Isacar y en el de Aser, Manasés poseía Bet-Seán y las ciudades que de ella dependen, Jiblean y las ciudades que dependen de ella, los habitantes de Dor y las ciudades que de ella dependen, los habitantes de Tanac y de Megido y las ciudades que dependen de ella (esas tres ciudades están situadas en alturas)."
,"12":"Como los hijos de Manasés no pudieron apoderarse de esas ciudades, los cananeos permanecieron en el país."
,"13":"Sin embargo, cuando se hicieron lo suficientemente fuertes, los israelitas hicieron tributarios suyos a los cananeos, pero no los exterminaron."
,"14":"Los hijos de José dijeron a Josué: '¿Por qué nos diste como herencia un único territorio y una sola porción siendo que somos un pueblo numeroso, pues Yavé nos ha bendecido hasta el día de hoy?'."
,"15":"Josué les respondió: 'Si son un pueblo tan numeroso, suban a los bosques de los fereceos y de los refaim. Tálenlos por su cuenta, si es que la montaña de Efraín es tan pequeña para ustedes'."
,"16":"Los hijos de José le dijeron: 'La montaña no nos basta, pero todos los cananeos que viven en la llanura tienen carros de hierro como también los que viven en Bet-seán y en sus aldeas y los que viven en el llano de Jizreel'."
,"17":"Entonces Josué respondió a la gente de José: 'Ustedes son un pueblo numeroso y son muy fuertes. No habrá para ustedes más que una sola porción."
,"18":"La montaña les pertenece: corten los árboles ya que es un bosque y será de ustedes en toda su extensión. Aunque el cananeo sea fuerte y tenga carros de hierro, ustedes tomarán posesión de ella'."
}`)
	CurrentBook.AddChapter(18, `{
"1":"La comunidad entera de los israelitas se reunió en Silo y allí levantaron la Tienda de las Declaraciones divinas. El país les estaba sometido."
,"2":"Siete tribus entre los israelitas no habían recibido todavía su herencia."
,"3":"Josué dijo entonces a los israelitas: '¿Cuánto tiempo van a esperar todavía para conquistar el territorio que Yavé, el Dios de sus padres, les dio?"
,"4":"Designen tres hombres por tribu: los enviaré a recorrer todo el país, harán un catastro de él para hacer después la repartición, luego vendrán a verme."
,"5":"Lo dividirán en siete partes porque Judá se quedará al sur dentro de sus fronteras y la casa de José al norte dentro de sus fronteras."
,"6":"Cuando hayan determinado las siete partes en que se dividirá el país, me las traerán y yo haré el sorteo para cada uno de ustedes delante de Yavé nuestro Dios."
,"7":"No habrá ninguna parte para los levitas en medio de ustedes, porque el servicio de Yavé es su herencia. En cuanto a Gad, Rubén y la media tribu de Manasés, ya recibieron su parte al otro lado del Jordán, al este: Moisés, el servidor de Yavé, se la dio.'"
,"8":"Se levantaron pues y se pusieron en camino. Josué les había dado sus instrucciones en el momento de la partida para que hicieran un catastro del país: '¡Vayan! Recorran el país, tomen nota de él y vuelvan a verme. Entonces yo haré el sorteo entre ustedes, aquí en Silo, delante de Yavé'."
,"9":"Se fueron los hombres y recorrieron el país. Hicieron por escrito la descripción del país y de sus ciudades: todo el conjunto estaba dividido en siete partes. Luego volvieron donde Josué en el campamento de Silo."
,"10":"Allí en Silo, Josué efectuó el sorteo entre ellos, en presencia de Yavé."
,"11":"La primera parte fue para los clanes de Benjamín y recibieron en suerte un territorio situado entre el de Judá y el de José."
,"12":"Por el norte, su frontera partía desde el Jordán; subía por la pendiente de Jericó y proseguía por la montaña occidental para terminar en el desierto de Betaven."
,"13":"De allí salía la frontera hacia Luz en la pendiente meridional (actualmente es Betel); descendía hasta Atrot-arac por medio de la montaña que está al sur de Bethorón de abajo."
,"14":"La frontera avanzaba después al oeste, luego se volvía al sur, desde la montaña que está frente a Bethorón por el sur, para terminar en los alrededores de Quiriat-baal (actualmente Quiriat- Yearim, una ciudad de la tribu de Judá). Esto era por el lado oeste."
,"15":"Por el sur, partiendo de Quiriat-Yearim, la frontera se dirigía a Gasín, pasaba cerca del manantial de Neftoa,"
,"16":"luego descendía hasta el final de la montaña, frente al valle de Ber-Hinnón, en la parte norte de la llanura de los Refaim. Luego bajaba por el valle de Hinnón, pasaba por la pendiente sur de los Jebuseos para llegar a En-Roguel."
,"17":"Entonces proseguía hacia el norte, pasaba por En-Semés y el Guilgal que está frente a la subida de Adumim, luego bajaba hasta la Roca de Bohán (Bohán era hijo de Rubén)."
,"18":"Pasaba en seguida por Quetef en la pendiente norte de Bet-ha-arama y bajaba hasta la Arabá."
,"19":"La frontera pasaba por la pendiente norte de Bet-hogla y terminaba en la parte norte del Mar de la la Sal, cerca de la desembocadura del Jordán. Esa era la frontera sur."
,"20":"Por el este, el Jordán servía de frontera. Esa era la posesión de los clanes de Benjamín con sus fronteras."
,"21":"Estas eran las ciudades de los clanes de Benjamín: Jericó, Bet-hogla, Emec-Quesis,"
,"22":"Bet-ha-arabá, Semaraim, Betel,"
,"23":"Avim, Pará, Ofra,"
,"24":"Quefur-ha-amoni, Ofni, Gaba: doce ciudades y sus aldeas."
,"25":"Gabaón, Rama, Beerot,"
,"26":"Mispé, Quefira, Mosa,"
,"27":"Requem, Jirpeel, Tareala,"
,"28":"Sela-ha-Elef, el Jebuseo (esto es Jerusalén), Guibea y Quiriat: catorce ciudades y sus aldeas. Esa era la parte de la herencia de los clanes de Benjamín."
}`)
	CurrentBook.AddChapter(19, `{
"1":"El sorteo asignó la segunda parte a Simeón, a los clanes de la tribu de Simeón: su parte se situaba en medio de la de Judá."
,"2":"Recibieron como herencia Bersabé, Sema, Molada,"
,"3":"Asar-Sual, Bala, Esem,"
,"4":"Eltobal, Betul, Jormá,"
,"5":"Siquelag, Bet-ha-Marcabot, Asar, Susa,"
,"6":"Bet-Lebaot y Sarujén: trece ciudades y sus aldeas."
,"7":"Ajin, Rimón, Eter y Asán: cuatro ciudades y sus aldeas,"
,"8":"y además todas las aldeas que la rodeaban hasta Baalat-Ber y Rama del Negueb; esa era la parte de la herencia de los clanes de la tribu de Simeón."
,"9":"Se sacó la herencia de Simeón de lo que correspondía a Judá porque la parte de Judá era demasiado grande para él. La tribu de Simeón recibió pues su herencia en medio de la herencia de Judá."
,"10":"El sorteo asignó la tercera parte a los clanes de Zabulón. El territorio que recibieron como herencia se extendía hasta Sadad."
,"11":"Su frontera subía por el oeste hasta Maraaba, pasaba al lado de Tabeset y del Torrente que está frente a Yocneam."
,"12":"A partir de Sadad la frontera se volvía al este para el lado del sol naciente. Alcanzaba hasta Quislot-Tabor, pasaba cerca de Daberat y subía a Yafia."
,"13":"Desde allí se extendía al este por el levante, hacia Gat-Jefer e Itacasín. Tocaba luego Rimón y llegaba a los alrededores de Nea."
,"14":"Luego la frontera daba una vuelta al norte en dirección a Hanatón y llegaba al valle de Jifta-el. Allí se incluían Catat, Najalal, Simrón, Jireala y Belén: doce ciudades y sus aldeas;"
,"16":"esa era la herencia de los clanes de Zabulón, con sus ciudades y sus aldeas."
,"17":"El sorteo asignó la cuarta parte a Isacar, a los clanes de la tribu de Isacar."
,"18":"Su territorio se extendía hasta Jizreel, incluía Quesulot, Sunem,"
,"19":"Hafaraim, Sión, Anajarat,"
,"20":"Daberat, Quisión, Ebes,"
,"21":"Remet, En-Garim, Enjada y Bet-Pasés."
,"22":"Tocando Tabor, Sajasima y Betsemes, la frontera llegaba al Jordán: dieciséis ciudades y sus aldeas."
,"23":"Esa era la herencia de los clanes de la tribu de Isacar con sus ciudades y sus aldeas."
,"24":"El sorteo asignó la quinta parte a los clanes de la tribu de Aser."
,"25":"Su territorio incluía Jelcat, Halí, Betén, Acsaf,"
,"26":"Alamelec, Amead y Miseal. Al oeste tocaba el Carmelo y el lecho del Libnat."
,"27":"Por el lado del sol naciente iba hasta Bet-Dagón; tocaba Zabulón, el valle de Jifta-el, Bet-ha-Emec y Neiel, al norte de Cabul."
,"28":"Comprendía Abdón, Rejob, Hamón y Caná, hasta Sidón la Grande. La frontera iba hasta Rama y hasta la ciudad fortificada de Tiro."
,"29":"En seguida llegaba hasta Hosa y terminaba en el mar, a la altura de Majaleb y Aczib,"
,"30":"con Acco, Afec y Rejob: veintidós ciudades y sus aldeas."
,"31":"Esa era la herencia de los clanes de la tribu de Aser, con sus ciudades y sus aldeas."
,"32":"El sorteo asignó la sexta parte a Neftalí, a los clanes de la tribu de Neftalí."
,"33":"Partiendo de Helef y de la Encina de Saananim, su frontera pasaba por Adami-ha-Nequeb y Yabneel, Lacum y llegaba al Jordán."
,"34":"La frontera pasaba al oeste por Aznot- Tabor, por Hucoc y tocaba Zabulón por el sur y Aser por el oeste, siendo el Jordán la frontera oriental."
,"35":"Las ciudades eran Sidim, Ser, Hamat, Racat, Quinerat,"
,"36":"Adama, Rama, Jasor,"
,"37":"Cadés, Edrei, En Jasora,"
,"38":"Jireón, Migdad-El, Jorem, Betanat y Betsemes: diecinueve ciudades y sus aldeas."
,"39":"Esa era la herencia de los clanes de la tribu de Neftalí, con sus ciudades y sus aldeas."
,"40":"El sorteo asignó la séptima parte a los clanes de Dan."
,"41":"El territorio que recibieron comprendía Sorea, Estaol, Ir-Semes,"
,"42":"Saalbin, Ayalón, Silata,"
,"43":"Elón, Timna, Ecrón,"
,"44":"Eltequé, Guibetón, Baalat,"
,"45":"Azor, Bené-Perac y Gatrimón;"
,"46":"hacia el mar Jeracón con el territorio que está frente a Jope."
,"47":"Pero la tribu de Dan no pudo apoderarse de su territorio. Por eso esos clanes subieron a atacar Lesem; se apoderaron de ella y la pasaron a cuchillo. Luego de la toma de Lesem, se instalaron allí y le dieron el nombre de Dan, él de su antepasado."
,"48":"Esa era la herencia de los clanes de la tribu de Dan, con sus ciudades y sus aldeas."
,"49":"Se había terminado el reparto del país con sus respectivas fronteras. Entonces los israelitas dieron a Josué, hijo de Nun, un territorio en medio de ellos."
,"50":"Según la orden de Yavé le dieron la ciudad que aquél había pedido: Timnat-Sera en la montaña de Efraín. Reconstruyó la ciudad y se instaló allí."
,"51":"Esas son las partes de la herencia que el sacerdote Eleazar, Josué hijo de Nun y los jefes de los clanes repartieron por sorteo entre las tribus de Israel. Eso fue en Silo, en presencia de Yavé a la entrada de la Tienda de las Declaraciones divinas. De ese modo se acabó con el reparto del país."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Yavé pidió a Josué que repitiera a los israelitas"
,"2":"lo que había hecho decir a Moisés: 'Dispongan entre ustedes ciudades de refugio donde pueda refugiarse el que haya dado muerte a otro por error o sin querer. Le servirán de refugio contra el vengador de la sangre."
,"4":"El que quiera refugiarse en una de esas ciudades se presentará a la entrada de la puerta de la ciudad. Allí expondrá su caso a los ancianos de la ciudad, y éstos lo acogerán entre ellos en la ciudad y le darán una casa para que viva con ellos."
,"5":"Si el vengador de la sangre lo persiguiere, no podrán en sus manos al que haya matado, porque mató a su prójimo sin querer: no sentía odio por él con anterioridad."
,"6":"El que mató se quedará en la ciudad hasta que comparezca ante la comunidad para ser juzgado y hasta que haya muerto el Sumo Sacerdote que se encuentre en funciones esos días. Entonces el que haya matado podrá regresar a su casa en la ciudad de donde huyó'."
,"7":"Se consagró pues a Cadés de Galilea en la montaña de Neftalí, Siquem en la montaña de Efraín y Quiriat-Arba, es decir Hebrón, en la montaña de Judá."
,"8":"Al otro lado del Jordán, al este de Jericó se había designado a Beser en el desierto, en la meseta, en el territorio de Rubén; Ramot-en-Galaad, en el territorio de Gad y Golán de Basán en el territorio de Manasés."
,"9":"Estas son las ciudades de refugio para los israelitas y para los extranjeros que viven con ellos. Allí se refugiará cualquiera que haya dado muerte a otro involuntariamente para escapar de la mano del vengador de la sangre hasta el momento en que comparezca ante la comunidad."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Los jefes de familia de los levitas se acercaron al sacerdote Eleazar, a Josué hijo de Nun y a los jefes de los clanes de las tribus de Israel"
,"2":"en Silo, en el territorio de Canaán y les dijeron: 'Yavé ordenó por boca de Moisés que nos dieran ciudades para vivir en ellas y pastizales para nuestro ganado'."
,"3":"Los israelitas dieron pues a los levitas, conforme a la orden de Yavé, las siguientes ciudades con sus pastizales, tomándolas de su propia parte."
,"4":"Hicieron el sorteo para los clanes de los cahatitas. Estos hijos del sacerdote Aarón establecidos en las tribus de Judá, de Simeón y de Benjamín recibieron trece ciudades"
,"5":"Los otros hijos de Cahat recibieron según sus clanes diez ciudades en las tribus de Efraín, de Dan y en la media tribu de Manasés."
,"6":"Los hijos de Guersón recibieron según sus clanes trece ciudades en las tribus de Isacar, de Aser, de Neftalí y en la media tribu de Manasés instalada en Basán."
,"7":"Los hijos de Marari recibieron según sus clanes doce ciudades en las tribus de Rubén, de Gad y de Zabulón."
,"8":"Los israelitas asignaron pues por sorteo esas ciudades y sus pastizales a los levitas tal como Yavé lo había ordenado por boca de Moisés."
,"9":"Estos son los nombres de las ciudades que les dieron en la tribu de Judá y en la tribu de Simeón."
,"10":"La primera parte fue para los hijos de Aarón que pertenecían al clan de los cahatitas, de la tribu de Leví."
,"11":"En la montaña de Judá les dieron Quiriat- Arba con sus pastizales, era la ciudad del padre de Anac (actualmente Hebrón)."
,"12":"Pero a Caleb, hijo de Jefoné, le dieron en propiedad el campo de esa ciudad y sus aldeas."
,"13":"Dieron a los hijos del sacerdote Aarón Hebrón y sus pastizales (Hebrón era una ciudad de refugio para los que habían dado muerte a alguien), Libna y sus pastizales,"
,"14":"Yatir y sus pastizales, Estemoa y sus pastizales,"
,"15":"Jolón y sus pastizales, Debir y sus pastizales,"
,"16":"Asán y sus pastizales, Yuta y sus pastizales y Betsemés y sus pastizales: nueve ciudades en estas tribus."
,"17":"En la tribu de Benjamín: Gabaón y sus pastizales, Gueba y sus pastizales,"
,"18":"Anatot y sus pastizales y Almón y sus pastizales: cuatro ciudades."
,"19":"El total de ciudades para los sacerdotes, hijos de Aarón fue de trece ciudades con sus pastizales."
,"20":"Para los otros clanes de los hijos de Cahat, para los demás levitas hijos de Cahat, se tomaron ciudades de la tribu de Efraín."
,"21":"Les dieron Siquem y sus pastizales, en la montaña de Efraín (era una ciudad de refugio para los que habían dado muerte a alguien), Guezer y sus pastizales,"
,"22":"Cibsaim y sus pastizales y Bet-Horón y sus pastizales: cuatro ciudades."
,"23":"En la tribu de Dan: Eltequé y sus pastizales, Guibetón y sus pastizales,"
,"24":"Ayalón y sus pastizales y Get-rimón y sus pastizales: cuatro ciudades."
,"25":"En la media tribu de Manasés: Tanac y sus pastizales y Jiblean y sus pastizales: dos ciudades."
,"26":"El total fue de diez ciudades con sus pastizales, para los clanes que faltaban de los hijos de Cahat."
,"27":"A los hijos de Guersón que pertenecían al clan de Leví, les dieron Golán en Basán (era una ciudad de refugio para los que habían dado muerte a alguien), y Astarot con sus pastizales, en la media tribu de Manasés: dos ciudades."
,"28":"En la tribu de Isacar: Quisión y sus pastizales, Daberat y sus pastizales,"
,"29":"Yarmut y sus pastizales y Enganim y sus pastizales: cuatro ciudades."
,"30":"En la tribu de Aser: Miseal y sus pastizales, Abdón y sus pastizales,"
,"31":"Helcat y sus pastizales y Rejob y sus pastizales: cuatro ciudades."
,"32":"En la tribu de Neftalí: Cadés de Galilea (era una ciudad de refugio para los que habían dado muerte a alguien) y sus pastizales, Hamot-Dor y sus pastizales y Cartán y sus pastizales: tres ciudades."
,"33":"El total de ciudades para los clanes de Guersón fue de trece ciudades y sus pastizales."
,"34":"Al clan de los hijos de Merarí, es decir a todo el resto de los levitas, les asignaron, en la tribu de Zabulón Yoqneam y sus pastizales, Carta y sus pastizales,"
,"35":"Rimón y sus pastizales y Nahalal y sus pastizales: cuatro ciudades."
,"36":"Al otro lado del Jordán, frente a Jericó, en la tribu de Rubén: Beser en el desierto, en la meseta (era una ciudad de refugio para los que habían dado muerte a alguien) y sus pastizales, Yahas y sus pastizales,"
,"37":"Quedemot y sus pastizales y Mefaat y sus pastizales: cuatro ciudades."
,"38":"En la tribu de Gad: Ramot de Galaad (era una ciudad de refugio para los que habían dado muerte a alguien) y sus pastizales, Mahanaim y sus pastizales,"
,"39":"Jesbón y sus pastizales y Yaser y sus pastizales: cuatro ciudades."
,"40":"El total de las ciudades que fueron asignadas al clan de los hijos de Merarí, lo que faltaba de los clanes de Leví, fue de doce ciudades."
,"41":"El total de las ciudades asignadas a los levitas en medio de los territorios de los israelitas fue de cuarenta y ocho."
,"42":"La ciudad se entendía de la ciudad y de sus pastizales que la rodeaban, y así era para todas las ciudades."
,"43":"De ese modo Yavé dio a los israelitas todo el país que había jurado a sus padres que les daría, se adueñaron de él y se instalaron allí."
,"44":"Yavé les concedió la paz en todas sus fronteras, tal como lo había jurado a sus padres, y ninguno de sus enemigos pudo hacerles frente. Yavé puso en sus manos a todos sus enemigos."
,"45":"Ninguna de las promesas que Yavé había hecho a la casa de Israel quedó en el olvido: todo se realizó."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Josué convocó a la gente de Rubén, de Gad y de la media tribu de Manasés,"
,"2":"y les dijo: 'Ustedes han obedecido todo lo que Moisés, servidor de Yavé, les ordenó y me han obedecido en todo lo que les mandé."
,"3":"Ha pasado mucho tiempo, pero ustedes no han abandonado a sus hermanos hasta el día de hoy, y han observado fielmente el mandamiento de Yavé su Dios."
,"4":"Ahora que Yavé su Dios concedió el descanso a sus hermanos, como se lo había dicho, vuelvan y ocupen nuevamente sus tiendas, en el territorio que les pertenece y que Moisés, servidor de Yavé, les dio al otro lado del Jordán."
,"5":"Tan solo acuérdense de poner en práctica los mandamientos y las leyes que Moisés, el servidor de Yavé, les prescribió. Amen a Yavé su Dios, sigan todos sus caminos, guarden sus mandamientos, apéguense a él y sírvanlo con todo su corazón y con toda su alma'."
,"6":"Josué los bendijo, luego los despidió y retornaron a sus hogares."
,"7":"Moisés había dado Basán a una mitad de la tribu de Manasés; a la otra mitad de la tribu Josué le dio una herencia entre sus hermanos, al oeste del Jordán. Al enviarlos de vuelta a sus tiendas, Josué los bendijo."
,"8":"Les dijo: 'Vuelvan a sus tiendas cargados de riquezas: ¡Cuánto ganado, oro, plata, bronce, hierro y ropa! Repartan los despojos de sus enemigos entre sus hermanos'."
,"9":"La gente de Rubén, Gad y de la media tribu de Manasés dejaron a los israelitas en Silo, en el territorio de Canaán. Regresaron al territorio de Galaad, pues esa era la herencia que habían recibido tal como Yavé lo había ordenado por medio de Moisés."
,"10":"Cuando llegaron a los alrededores del Jordán que forma parte del territorio de Galaad, la gente de Rubén, de Gad y de la media tribu de Manasés construyeron un altar en la ribera del Jordán. Era un altar de una altura impresionante."
,"11":"La noticia llegó a los israelitas: '¡Fíjense que la gente de Rubén, de Gad y de la media tribu de Manasés construyeron un altar frente al territorio de Canaán, en los alrededores de Guilgal del Jordán, junto a la frontera de los israelitas'."
,"12":"Entonces toda la comunidad de Israel se reunió en Silo para subir contra ellos y hacerles la guerra."
,"13":"Los israelitas mandaron donde la gente de Rubén, de Gad y de la media tribu de Manasés, en el territorio de Galaad, a Finjas, hijo del sacerdote Eleazar,"
,"14":"y a diez jefes con él: un jefe de clan por cada una de las tribus de Israel."
,"15":"Cuando llegaron donde la gente de Rubén, de Gad y de la media tribu de Manasés, en el territorio de Galaad, les dijeron:"
,"16":"'Esto es lo que dice la comunidad de Yavé: ¡Ustedes han cometido una infidelidad con el Dios de Israel! ¿Así que quieren apartarse de Yavé? ¡Al construir un altar se han rebelado contra Yavé!"
,"17":"¿No les bastó con el crimen de Peor? Todavía no nos hemos recuperado de la peste que asoló a toda la comunidad de Yavé."
,"18":"Si hoy día se han rebelado contra Yavé, mañana él se enojará con toda la comunidad de Israel."
,"19":"Si el territorio que poseen les parece impuro, vénganse al territorio que es la herencia de Yavé, allí donde él ha establecido su morada, y les darán una porción en medio de nosotros. Pero no se rebelen contra Yavé y contra nosotros, construyendo un altar distinto al de Yavé nuestro Dios."
,"20":"Acuérdense de la infidelidad de Acán, hijo de Zerá, a propósito del anatema: la cólera de Yavé castigó a toda la comunidad de Israel, y no murió solamente él por culpa de su crimen'."
,"21":"La gente de Rubén, de Gad y de la media tribu de Manasés respondieron a los jefes de los clanes de Israel:"
,"22":"'El Dios de los dioses, Yavé, el Dios de los dioses, sabe la verdad e Israel debe saberla. Si nos hubiéramos rebelado contra Yavé, si le hubiésemos sido infieles, entonces que Yavé no nos perdone."
,"23":"Si edificamos este altar para apartarnos de Yavé, para ofrecerle holocaustos y oblaciones, para presentarle sacrificios de comunión, que el mismo Yavé nos pida cuenta de ello."
,"24":"Pero actuamos así por temor a lo que pudiera ocurrir después; a lo mejor un día sus hijos dirán a los nuestros: '¿Qué tienen ustedes que ver con Yavé, Dios de Israel?"
,"25":"Yavé puso el Jordán como frontera entre nosotros y ustedes, ustedes no tienen pues parte alguna con Yavé. Y de ese modo, debido a sus hijos, nuestros hijos dejarán de temer a Yavé."
,"26":"Entonces nos dijimos: Construyamos un altar, no para ofrecer en él holocaustos o sacrificios,"
,"27":"sino para que sea un testimonio entre nosotros y ustedes, y entre nuestros descendientes. Será una prueba de que practicamos el culto a Yavé, en presencia de él, por nuestros holocaustos, nuestra ofrendas y nuestros sacrificios de comunión. De ese modo sus hijos no podrán decir a los nuestros: Ustedes no tienen nada que ver con Yavé."
,"28":"Nos dijimos: Si mañana nos hablan de esa manera a nosotros o a nuestros descendientes, les diremos: Miren la forma del altar de Yavé que nuestros padres construyeron, no para los holocaustos o para los sacrificios sino para que sea una prueba entre nosotros y ustedes."
,"29":"No queremos rebelarnos contra Yavé ni dejar de servirle. No construimos este altar para el holocausto, para la ofrenda o para el sacrificio de comunión, ni tampoco en menosprecio del altar de Yavé que está delante de su Morada'."
,"30":"Esas palabras que pronunciaron los hijos de Rubén, de Gad y de Manasés les gustaron al sacerdote Finjas, a los jefes de la comunidad y los jefes de los clanes de Israel que estaban con él."
,"31":"El sacerdote Finjas dijo a los hijos de Rubén, de Gad y de Manasés: 'Ahora sabemos que Yavé está en medio de nosotros ya que ustedes no cometieron infidelidad contra Yavé. Ustedes han ahorrado a Israel los azotes de Yavé'."
,"32":"Entonces, dejando a los hijos de Rubén y de Gad en el territorio de Galaad, el sacerdote Finjas y los jefes regresaron al país de Canaán, donde los israelitas. Les dieron cuenta de todo,"
,"33":"y los israelitas lo aprobaron. Bendijeron a Dios y se desistieron de marchar en son de guerra para arrasar el territorio donde vivían los hijos de Rubén y de Gad."
,"34":"Por su parte los hijos de Rubén y los hijos de Gad llamaron a ese altar 'Testigo', porque dijeron: 'Es testigo entre nosotros de que Yavé es Dios'."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Hacía ya mucho tiempo que Yavé había librado a Israel de todos sus enemigos de los alrededores y le había dado la tranquilidad. En cuanto a Josué, ya estaba viejo y de edad avanzada."
,"2":"Josué entonces reunió a todo Israel junto con sus ancianos, sus jefes, sus jueces y sus escribas y les dijo: 'Estoy ahora viejo y de edad avanzada."
,"3":"Ustedes vieron todo lo que Yavé, el Dios de ustedes, hizo a esas naciones con las que se enfrentaron: Yavé su Dios combatió al lado de ustedes."
,"4":"¡Miren! Les repartí por sorteo el dominio de esas naciones que permanecían entre ustedes y que eliminé. Esta será la herencia de sus tribus desde el Jordán hasta el Gran Mar hacia el lado del sol poniente."
,"5":"Yavé su Dios los expulsará ante ustedes y les quitará la tierra para que sea de ustedes, como Yavé su Dios se lo dijo."
,"6":"¡Tengan pues ánimo! Observen y pongan en práctica todo lo que está escrito en el libro de la Ley de Moisés. No se aparten ni a la derecha ni a la izquierda,"
,"7":"no se mezclen con los pueblos que quedaron entre ustedes. No invoquen el nombre de sus dioses y no juren por ellos; no les sirvan ni se postren ante ellos. A Yavé su Dios, y sólo a él seguirán, como lo han hecho hasta hoy."
,"9":"Yavé expulsó ante ustedes a naciones grandes y poderosas y nadie pudo oponerles resistencia hasta hoy."
,"10":"Uno solo de ustedes perseguía a mil, porque Yavé su Dios combatía para ustedes, como él se lo había dicho."
,"11":"Amen a Yavé su Dios, es vital para ustedes."
,"12":"Si se apartan de él, si se juntan con los otros pueblos que quedaron entre ustedes, si se mezclan con ellos casándose y se visitan mutuamente,"
,"13":"sépanlo bien: Yavé su Dios no continuará despojándolos ante ustedes. Pero ellos serán para ustedes como un lazo y como una trampa, como un látigo en su espalda y espinas en sus ojos, hasta que ustedes hayan desaparecido de esta buena tierra que Yavé su Dios les dio."
,"14":"En el momento en que me estoy yendo por el camino de toda criatura, reconozcan desde el fondo de su corazón y de su espíritu que Yavé su Dios realizó todo lo que había prometido. Todas sus palabras se han cumplido, ni una sola quedó sin efecto."
,"15":"Por eso, así como se realizaron todas las promesas de Yavé su Dios respecto a ustedes, de igual forma Yavé realizará en contra de ustedes todas sus amenazas hasta exterminarlos de esta buena tierra que les dio."
,"16":"Si ustedes son infieles a la Alianza que Yavé su Dios les propuso, si sirven a otros dioses y se prosternan delante de ellos, entonces se encenderá contra ustedes la cólera de Yavé y desaparecerán rápidamente de esta buena tierra que él les dio'."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Josué reunió pues en Siquem a todas las tribus de Israel. Convocó a los ancianos de Israel, a los jefes, a los jueces y a los escribas, y éstos se presentaron ante Dios."
,"2":"Josué dijo entonces a todo el pueblo: 'Esto es lo que Yavé, el Dios de Israel, les manda decir: Sus padres vivían más allá del Río, y servían a otros dioses: acuérdense de Teraj, padre de Abrahán y padre de Najor,"
,"3":"Pero yo tomé a su padre Abrahán más allá del Río y le hice recorrer todo el territorio de Canaán, multipliqué su raza y le di a Isaac."
,"4":"A Isaac le di a Jacob y Esaú. Le di el monte Seir a Esaú como su propiedad; pero Jacob y sus hijos bajaron a Egipto."
,"5":"Luego envié a Moisés y a Aarón y tuvieron lugar las plagas de Egipto y todo lo que yo hice allí; en seguida los hice salir."
,"6":"Cuando llegaron ustedes al mar y los egipcios persiguieron a sus padres con sus carros y sus jinetes hasta el Mar de los Juncos, clamaron a Yavé y Yavé interpuso una niebla entre ustedes y los egipcios, hizo retroceder el mar sobre ellos y los cubrió. Ustedes vieron con sus ojos lo que hice en Egipto, después de lo cual permanecieron por largos días en el desierto."
,"8":"Después los hice entrar en el país de los amoreos que viven al otro lado del Jordán. Pelearon con ustedes y yo los puse en sus manos. Conquistaron ustedes su país y los exterminé ante ustedes."
,"9":"Fue entonces cuando Balac, hijo de Sipor, rey de Moab, salió en son de guerra contra Israel, y mandó a buscar a Balaam, hijo de Beor para que los maldijera."
,"10":"Pero no quise escuchar a Balaam y tuvo que bendecirlos: así fue como los libré de sus manos."
,"11":"Luego ustedes atravesaron el Jordán y llegaron a Jericó. Los jefes de Jericó, los amoreos, los fereceos, los cananeos, los hititas, los guirgaseos, los jeveos y los jebuseos los atacaron, pero los entregué en manos de ustedes."
,"12":"Expulsé delante de ustedes a los dos reyes amoreos, no por la espada o el arco, sino por medio de las avispas que mandé delante de ustedes."
,"13":"Les di una tierra donde no han trabajado, ciudades que no construyeron pero que han habitado, viñas y olivares que no plantaron, pero cuya fruta han comido."
,"14":"¡Ahora, pues, teman a Yavé! ¡Sírvanle con sinceridad y fidelidad! ¡Eliminen los dioses a los que sus padres sirvieron tanto más allá del Río como en Egipto, y sirvan a Yavé!"
,"15":"Pero si no quieren servir a Yavé, elijan ahora a quién servirán: o bien a los dioses a los que sus padres sirvieron más allá del Río, o bien a los dioses de los amoreos en el país donde viven. Lo que es yo y mi familia serviremos a Yavé'."
,"16":"El pueblo respondió: 'Por ningún motivo abandonaremos a Yavé para servir a otros dioses,"
,"17":"porque Yavé nuestro Dios fue quien nos hizo subir con nuestros padres desde Egipto, y nos protegió a lo largo del camino por donde íbamos, y en medio de todos los pueblos por donde pasábamos."
,"18":"Yavé fue quien expulsó delante de nosotros a todos esos pueblos como también a los amoreos que vivían en este país. Serviremos pues a Yavé, él es nuestro Dios'."
,"19":"Entonces Josué dijo al pueblo: '¿Podrán ustedes servir a Yavé? porque es un Dios santo, un Dios celoso; El no perdonaría las infidelidades y los pecados de ustedes."
,"20":"Si abandonan a Yavé para servir a dioses extranjeros, él también cambiará: les hará el mal y los exterminará después de haberles hecho el bien'."
,"21":"El pueblo dijo a Josué: '¡De ninguna manera! ¡Serviremos a Yavé!'"
,"22":"Entonces Josué les dijo: 'Ustedes mismos son testigos que han escogido a Yavé y quieren servirlo'. Le respondieron: 'Somos testigos'."
,"23":"'Pues bien, dijo José, boten ahora los dioses extranjeros que tienen entre ustedes y vuelvan su corazón hacia Yavé, el Dios de Israel'."
,"24":"El pueblo dijo a Josué: 'Nosotros serviremos a Yavé y haremos caso a su palabra'."
,"25":"Ese día estableció Josué una alianza con el pueblo, le impuso un estatuto y una regla en Siquem."
,"26":"Escribió todas esas palabras en el libro de la Ley de Dios. Tomó una gran piedra y la puso debajo de la Encina que estaba en el santuario de Yavé."
,"27":"Josué dijo entonces al pueblo: 'Esta piedra atestiguará en contra de ustedes, porque escuchó todas las palabras que Yavé pronunció delante de nosotros. Servirá como testigo en contra de ustedes, para impedirles que renieguen de su Dios'."
,"28":"Después Josué mandó de vuelta al pueblo, a cada uno a su posesión."
,"29":"Josué, hijo de Nun, servidor de Yavé, murió después de eso, a la edad de ciento diez años."
,"30":"Lo sepultaron en el territorio que había recibido en el reparto, en Timnat-Sera, en la montaña de Efraín, al norte del monte Gaas."
,"31":"Israel sirvió a Yavé durante toda la vida de Josué y durante toda la vida de los ancianos que sucedieron a Josué, pues habían visto todo lo que Yavé había realizado en favor de Israel."
,"32":"En Siquem sepultaron los huesos de José que los israelitas habían traído de Egipto. Los depositaron en una parcela que Jacob había comprado a los hijos de Hamor, padre de Siquem, por cien piezas de plata; ella pasó a formar parte de la herencia de los hijos de José."
,"33":"Eleazar, hijo de Aarón, murió también y lo enterraron en la montaña de Efraín en Guibea, ciudad que había sido otorgada a su hijo Finjas."
}`)

}
func ES_LBL_LoadVHIHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Hacía doce años que Nabucodonosor, rey de Asiria, reinaba en la gran ciudad de Nínive. Arfaxad, que en aquel tiempo reinaba sobre los medos, en Ecbátana,"
,"2":"rodeó esta ciudad con una muralla de piedras talladas de metro y medio de ancho y tres de largo. La muralla tenía treinta y cinco metros de alto y veinticinco de ancho."
,"3":"Junto a las puertas levantó torres de cincuenta metros de alto y veinte de ancho en los cimientos."
,"4":"Las puertas, de treinta y cinco metros de alto y veinte de ancho, permitían la salida de sus fuerzas y el desfile de la infantería."
,"5":"En aquellos días, el rey Nabucodonosor declaró la guerra al rey Arfaxad en la gran llanura que está en Ragau."
,"6":"Se unieron a él todos los habitantes de la montaña, los del Eufrates, del Tigris, del Hidaspes y de la llanura de Arioj, rey de Elam. Fueron muchos los pueblos que se reunieron para combatir a los hijos de Jeleud."
,"7":"Además, Nabucodonosor, rey de Asiria, mandó mensajeros a los habitantes de Persia y a todos los habitantes de Occidente: a los de Cilicia, Damasco, el Líbano y el Antilíbano, a todos los del litoral,"
,"8":"a las poblaciones del Carmelo, Galaad, alta Galilea, la gran llanura de Esdrelón,"
,"9":"a los habitantes de Samaria y sus ciudades, a los de más allá del Jordán, hasta Jerusalén, Batanea, Jelús, Cadés, el río de Egipto, Tafnes, Rameses y toda la tierra de Gosén,"
,"10":"hasta más allá de Tanis y Menfis, a todos los habitantes de Egipto, hasta las fronteras de Etiopía."
,"11":"Pero los habitantes de todas estas regiones despreciaron el mensaje de Nabucodonosor y no quisieron ir con él a la guerra, ya que no lo temían, sino que lo consideraban como un hombre cualquiera. Por tanto, despidieron a los mensajeros con las manos vacías y avergonzados."
,"12":"Nabucodonosor, indignado con todas aquellas naciones, juró por su trono y por su reino vengarse de todas ellas."
,"13":"El año diecisiete, junto con su ejército, declaró la guerra a Arfaxad; lo derrotó en el combate, desconcertó todo su ejército, su caballería y sus carros;"
,"14":"se apoderó de sus ciudades, llegó hasta Ecbátana, ocupó sus torres, destruyó las plazas y las arruinó."
,"15":"Persiguió a Arfaxad hasta las montañas de Ragau y lo atravesó con sus lanzas, acabando con él."
,"16":"Luego, Nabucodonosor volvió a Nínive con sus soldados y con una inmensa multitud de gente armada que lo había seguido. Durante ciento veinte días descansaron allí y vivieron cómodamente."
}`)
	CurrentBook.AddChapter(2, `{
"1":"El veintidós de enero del año dieciocho, se trató en el palacio de Nabucodonosor, rey de Asiria, sobre la manera de vengarse de las otras naciones, tal como lo había anunciado."
,"2":"Convocó a sus ministros y a sus grandes y tuvo con ellos un consejo secreto. El mismo expuso todos los planes"
,"3":"y todos decidieron destruir a los que habían despreciado el llamado del rey."
,"4":"Apenas terminó el consejo, Nabucodonosor llamó a Holofernes, jefe supremo del ejército, que le seguía en el mando, y le dijo:"
,"5":"«Así habla el rey grande, señor de toda la tierra: Toma contigo unos ciento veinte mil infantes valientes y una gran cantidad de caballos, con doce mil jinetes,"
,"6":"y anda contra todo el occidente, ya que se opusieron a mis planes."
,"7":"Diles que se sometan, no sea que yo vaya furioso contra ellos. Cubriré la tierra con los pies de mis soldados, a los que entregaré el país como botín."
,"8":"Los heridos llenarán los valles, y los cadáveres harán desbordar los ríos."
,"9":"Los desterraré hasta los confines de la tierra."
,"10":"Anda, pues, y apodérate de su territorio. Si se entregan a ti, guárdamelos para el día del castigo."
,"11":"Pero si se rebelan, no los perdones; entrégalos a la muerte y al pillaje en toda la tierra."
,"12":"Porque juro por mi vida y por el poder de mi reino que cumpliré todo lo que he dicho."
,"13":"Tú no desobedezcas las órdenes de tu señor, sino realízalas pronto como te lo he mandado.»"
,"14":"Holofernes salió para convocar a los generales, jefes y capitanes del ejército asirio."
,"15":"Contó unos ciento veinte mil hombres escogidos para la guerra, y doce mil arqueros a caballo, a los que formó en orden de batalla."
,"16":"Tomó gran número de camellos, burros y mulas para el equipaje"
,"17":"y ovejas, bueyes y cabras para alimentarse."
,"18":"Además, cada hombre recibió provisiones y gran cantidad de oro y plata de la casa real."
,"19":"Salió, pues, Holofernes con su ejército delante del rey Nabucodonosor para cubrir toda la tierra de occidente con sus carros, sus caballos y sus infantes."
,"20":"Le seguía una multitud numerosa como la langosta y como la arena de la tierra. Eran tantos que no se podían contar."
,"21":"Durante la primera etapa de tres días llegaron desde Nínive a la llanura de Bektilez, cerca del monte que está al norte de Cilicia."
,"22":"Desde allí partió con su ejército, infantería, caballos y carros hacia la región montañosa."
,"23":"Arruinó Put y Lidia, a los hijos de Rassis y a los de Ismael, que están en el desierto, al sur de Jeleón."
,"24":"Atravesó el Eufrates, recorrió Mesopotamia, destruyó todas las ciudades altas que dominan el torrente Abrona y llegó hasta el mar."
,"25":"Se apoderó de Cilicia, derrotando a cuantos se le oponían; llegó a la frontera de Jafet por el sur, frente a Arabia;"
,"26":"rodeó a la gente de Madián, incendió sus tierras y tomó sus ganados;"
,"27":"en el tiempo de la siega del trigo bajó a la llanura de Damasco, incendió sus campos, dispersó sus ovejas y bueyes y mató a cuchillo a todos los jóvenes."
,"28":"Los habitantes de Sidón y Tiro, los de Sur y Okina, los de Jamnia, Azoto y Ascalón tenían miedo y temblaban ante él."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Todos éstos enviaron a Holofernes mensajeros para decirle en son de paz:"
,"2":"«Nosotros nos consideramos siervos del gran rey Nabucodonosor y nos entregamos a ti. Trátanos como quieras."
,"3":"Nuestras granjas, nuestro territorio, nuestros campos de trigo, nuestras ovejas, bueyes y sus apriscos, están a tu disposición. Haz con ello lo que quieras."
,"4":"También son tuyas nuestras ciudades, y sus habitantes son tus siervos. Dirígete a ellos como quieras.»"
,"5":"Aquellos hombres se presentaron ante Holofernes y le transmitieron estas palabras."
,"6":"Holofernes, entonces, bajó con su ejército al litoral, dejando guarniciones en las ciudades fortificadas, de donde tomó los mejores hombres en calidad de tropas auxiliares."
,"7":"Los habitantes de las ciudades y de los pueblos de los alrededores lo recibieron con coronas y danzando al compás del tamboril."
,"8":"Pero él destruyó sus templos, cortó los árboles de sus bosques sagrados y destruyó todas las divinidades para que los hombres de todas las lenguas y todas las tribus adoraran solamente a Nabucodonosor y lo proclamaran dios."
,"9":"Después llegó frente a Esdrelón, cerca de Dotán, que está ubicado frente a la sierra montañosa de Judea."
,"10":"Acampó entre Gueba y Escitópolis, y allí permaneció un mes para reorganizar el aprovisionamiento de su ejército."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Cuando los israelitas del territorio de Judá supieron que Holofernes, jefe supremo del ejército de Nabucodonosor, rey de Asiria, había despojado a los pueblos vecinos y destruido sus santuarios,"
,"2":"tuvieron miedo y temblaban pensando en la suerte de Jerusalén y su Templo,"
,"3":"ya que hacía poco que habían vuelto del destierro; el pueblo de Judea acababa de reunirse y de consagrar de nuevo el Templo con su altar y su mobiliario después de ser profanado."
,"4":"Entonces avisaron a toda la región de Samaria, a Komá, Bet-Jorán, Belmain, Jericó, Joba, Esorá y el valle de Salem."
,"5":"Ocuparon las alturas de las montañas, fortificaron los pueblos e hicieron provisiones para sostener la guerra, ya que habían terminado de segar sus campos."
,"6":"El jefe de los sacerdotes, Joaquín, que estaba entonces en Jerusalén, escribió a los habitantes de Betulia y Betomestain, que está frente a Esdrelón, a la entrada de la llanura de Dotán,"
,"7":"diciéndoles que cuidaran las subidas de la montaña que dan acceso a Judea, pues era fácil detener allí el avance de los atacantes, ya que era tan estrecho el paso que sólo permitía pasar de dos en dos."
,"8":"Los israelitas cumplieron las órdenes de Joaquín, jefe de los sacerdotes, y del consejo de los Ancianos de todo Israel, que se encontraba en Jerusalén."
,"9":"Todos los israelitas se dirigieron humilde y fervorosamente a Dios."
,"10":"Los hombres, sus esposas, sus hijos, sus ganados, los forasteros, los jornaleros y los esclavos se pusieron saco sobre sus cuerpos."
,"11":"Los habitantes de Jerusalén, con sus esposas y sus niños, se arrodillaron ante el Templo, cubrieron de ceniza sus cabezas y extendieron las manos para rezar ante el Señor."
,"12":"Cubrieron el altar de saco, y todos a una voz pidieron al Dios de Israel que no permitiera arrebatar a sus hijos y esposas, destruir sus ciudades y profanar su Templo."
,"13":"El Señor oyó su voz y comprendió su angustia. El pueblo ayunó muchos días en Judá y Jerusalén ante el Templo del Señor Omnipotente. "
,"14":"Joaquín, jefe de los sacerdotes, los sacerdotes y ministros del Señor, vestidos de saco, ofrecían el sacrificio perpetuo,"
,"15":"y, con sus gorros cubiertos de ceniza, clamaban al Señor con todas sus fuerzas para que velara por todo Israel."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Holofernes, jefe supremo del ejército asirio, supo que los israelitas se preparaban para la guerra, que habían cerrado los pasos de las montañas, fortificando las cimas de los montes y obstaculizando las llanuras."
,"2":"Se enojó muchísimo y llamó a los jefes de Moab, a los generales de Ammón y a todos los gobernadores del litoral"
,"3":"y les dijo: «Hijos de Canaán, díganme qué pueblo es éste que se estableció en la montaña, qué ciudades habita, cuál es la importancia de su ejército, en qué consiste su fuerza y su poder, qué rey guía su ejército"
,"4":"y por qué no se ha dirigido a mí como los otros países occidentales.»"
,"5":"Ajior, general de todos los amonitas, le respondió: «Escucha, señor, que te diré la verdad sobre ese pueblo que habita esta montaña junto a la que te encuentras."
,"6":"Este pueblo desciende de los caldeos."
,"7":"Habitaron primero Mesopotamia, pero no quisieron seguir a los dioses de sus padres, que vivían en Caldea."
,"8":"Se apartaron del culto de sus padres y adoraron al Dios del cielo, al Dios que habían reconocido. Por esto, sus padres los despidieron de la presencia de sus dioses y se refugiaron en Mesopotamia, donde permanecieron largo tiempo."
,"9":"Pero su Dios les aconsejó salir de su casa y marchar a la tierra de Canaán; se establecieron en ella y adquirieron oro, plata y gran cantidad de ganado."
,"10":"Después bajaron a Egipto porque el hambre se extendió en Canaán, y permanecieron allí mientras tuvieron alimentos. Allí el pueblo aumentó mucho, de modo que ya no podía contarse."
,"11":"El rey de Egipto los obligó a trabajar haciendo ladrillos, los oprimió y los redujo a la condición de esclavos."
,"12":"Clamaron a su Dios, que castigó la tierra de Egipto con plagas incurables. Entonces los egipcios los mandaron lejos de ellos."
,"13":"Dios secó el mar Rojo para que pasaran,"
,"14":"y los condujo hasta el Sinaí y Cadés-Barne. Echaron a todos los habitantes del desierto,"
,"15":"luego habitaron el país de los amorreos y acabaron por la fuerza con todos los jebonitas. Pasaron el Jordán, ocuparon toda la montaña"
,"16":"y despidieron al cananeo, al fereceo, al jebuseo, a los siquemitas, a todos los guirgaseos, y permanecieron allí mucho tiempo."
,"17":"Mientras no ofendieron a su Dios vivieron felices, porque estaba con ellos un Dios que odia el mal."
,"18":"Pero cuando se apartaron del camino que les había trazado, fueron exterminados en numerosos desastres y desterrados a otros países; el Templo de su Dios fue arrasado y sus ciudades tomadas por los enemigos."
,"19":"Pero ahora, cuando volvieron a su Dios, regresaron de los diversos lugares en que se encontraban, se posesionaron de Jerusalén, donde está su santuario, y habitaron la región montañosa que había quedado desierta."
,"20":"Así, pues, poderoso señor, informémonos para saber si este pueblo se ha portado mal y si han pecado contra su Dios; si la cosa es así, subamos y ataquémoslos."
,"21":"Pero si no hay maldad en esa gente, déjalos y vuélvete, no sea que su Dios los proteja con su escudo y toda la tierra sea testigo de nuestra derrota.»"
,"22":"Cuando Ajior terminó de hablar, el pueblo reunido en torno a la tienda comenzó a criticar. Los magnates de Holofernes y los habitantes de la costa de Moab hablaron de apalearlo."
,"23":"«¡No tememos a los hijos de Israel! Es un pueblo sin fuerza que no está preparado para una lucha dura."
,"24":"Subamos, señor Holofernes, que serán un botín para tu ejército.»"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Calmado el alboroto de la asamblea, Holofernes, jefe supremo del ejército de Asiria, dijo a Ajior delante de los moabitas y de los pueblos extranjeros:"
,"2":"«¿Quién eres tú, Ajior, y quiénes ustedes, que se dejaron sobornar por Efraín y que hoy se permiten profetizar contra nosotros? ¿Por qué nos aconsejan que no luchemos contra Israel, diciendo que Dios los protegerá con su escudo? ¿Qué otros dioses hay fuera de Nabucodonosor? El nos dará fuerza y los exterminará de la faz de la tierra, sin que su Dios pueda librarlos."
,"3":"Nosotros, sus siervos, venceremos a los israelitas de una vez, y no resistirán el empuje de nuestra caballería."
,"4":"Los quemaremos sin distinción. Su sangre chorreará por sus montañas y sus llanuras se convertirán en cementerios. No se mantendrán en pie ante nosotros, pues serán totalmente destruidos, dice el rey Nabucodonosor, señor de toda la tierra. El lo dijo y todas sus palabras se cumplirán."
,"5":"En cuanto a ti, Ajior, mercenario de Ammón, que pronunciaste estas palabras para tu desgracia, desde ahora no verás mi rostro hasta el día en que me vengue de esta raza venida de Egipto."
,"6":"Entonces, la espada de mis soldados y la lanza de la multitud de mis servidores traspasará tu cuerpo; cuando yo vuelva del combate tú estarás reunido con los muertos de Israel."
,"7":"Ahora mis servidores te van a llevar a la montaña y te dejarán en una de las ciudades de la subida"
,"8":"para que compartas la suerte de ellos."
,"9":"No pongas esa cara, si crees que son invencibles y que no se cumplirán mis palabras.»"
,"10":"Holofernes mandó a los hombres de su tienda que tomaran a Ajior, lo llevaran a Betulia y lo entregaran a los israelitas."
,"11":"Sus servidores lo tomaron y lo sacaron fuera del campamento, a la llanura; de allí pasaron a la montaña y llegaron a las fuentes que están al pie de Betulia."
,"12":"Cuando los hombres de la ciudad los divisaron, tomaron sus armas y salieron hacia la cumbre del monte, mientras que los honderos impedían su subida, disparándoles piedras."
,"13":"Los asirios llegaron a la base del cerro, ataron a Ajior, dejándolo tendido al pie del cerro, y volvieron donde su señor."
,"14":"Los israelitas bajaron, se acercaron a él, lo desataron y lo llevaron a Betulia, presentándolo a los jefes de la ciudad,"
,"15":"que en aquel tiempo eran Ozías, hijo de Miqueas, de la tribu de Simeón; Jabri, hijo de Gotoniel, y Jarmí, hijo de Melquiel."
,"16":"Convocaron a todos los dirigentes de la ciudad, también se unieron a la asamblea los jóvenes y las mujeres; pusieron a Ajior en medio del pueblo y Ozías lo interrogó sobre lo que había pasado."
,"17":"Ajior les dio a conocer lo de la asamblea de Holofernes, lo que dijo delante de todos los jefes de los asirios, y las amenazas de Holofernes contra Israel."
,"18":"Entonces el pueblo se arrodilló y adoró a Dios, clamando:"
,"19":"«Señor, Dios del cielo, mira su soberbia y ten piedad de tu humilde pueblo; vuelve hoy tu rostro a los que te están consagrados.»"
,"20":"Animaron a Ajior y lo felicitaron calurosamente."
,"21":"Después de la reunión, Ozías lo invitó a su casa y ofreció un banquete a los dirigentes. Durante toda la noche pidieron la ayuda del Dios de Israel."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Al día siguiente, Holofernes ordenó a su ejército y a todos los pueblos que se le habían unido para la guerra, poner su campamento cerca de Betulia, ocupar las pendientes de la montaña y pelear contra los israelitas."
,"2":"Ese mismo día su ejército se puso en marcha. El número de guerreros era de ciento veinte mil de infantería y doce mil jinetes, sin contar los encargados del equipaje y la gran cantidad de hombres que iba a pie con ellos."
,"3":"Acamparon en el valle que está cerca de Betulia, junto a la fuente, y se extendieron a lo ancho desde Dotán hasta Belmain y a lo largo, desde Betulia hasta Kiamón, que está frente a Esdrelón."
,"4":"Cuando los israelitas vieron aquella multitud, se asustaron y se dijeron unos a otros: «Sin duda, éstos devorarán todo el país y ni los montes más altos, ni los barrancos ni las colinas detendrán su marcha.»"
,"5":"Sin embargo, cada cual tomó su equipo de guerra, encendieron hogueras en las torres y permanecieron atentos toda la noche."
,"6":"El segundo día, Holofernes exhibió toda su caballería ante los israelitas que había en Betulia,"
,"7":"examinó las subidas de la ciudad y ocupó los manantiales, dejando soldados en ellos, y él volvió a su ejército."
,"8":"Los príncipes de Esaú, los jefes de Moab y los generales del litoral se acercaron a él y le dijeron:"
,"9":"«Escucha, señor, una palabra y no habrá ni un solo herido en tu ejército."
,"10":"Este pueblo de los hijos de Israel confía más en las alturas de las montañas que habitan, y donde no es tan fácil subir, que en sus lanzas."
,"11":"Por eso, señor, si quieres ahorrar la vida de tus hombres, no pelees contra ellos."
,"12":"Quédate en tu campamento y conserva a tu ejército. Basta que tus siervos ocupen las fuentes que brotan de la falda de la montaña."
,"13":"Como los de Betulia se abastecen de agua de esas fuentes, la sed los destruirá y entregarán la ciudad. Nosotros y nuestro pueblo subiremos a lo alto de la montaña para vigilar que nadie salga de la ciudad."
,"14":"Hombres, mujeres y niños, desfallecidos por el hambre, caerán en las plazas antes de que intervengas con la espada."
,"15":"Así los habrás castigado duramente por su rebeldía y por no haber salido a tu encuentro pacíficamente.»"
,"16":"Estos consejos agradaron a Holofernes y a sus oficiales, y Holofernes ordenó actuar conforme a ellos."
,"17":"El ejército de los moabitas salió reforzado por cinco mil asirios, llegaron al valle y se apoderaron de los depósitos de agua y de las fuentes de los israelitas."
,"18":"Por su parte, los edomitas y amonitas acamparon en la montaña frente a Dotán, y mandaron a algunos al sur y al este frente a Egrebel, que está al lado de Jus, sobre el torrente Mojmur. El resto del ejército asirio quedó en la llanura y cubría todo el país. Sus carpas y equipajes formaban un campamento inmenso porque era una enorme muchedumbre."
,"19":"Desanimados, clamaron los israelitas al Señor, su Dios, al ver que los rodeaban sus enemigos sin que pudieran escapar."
,"20":"Treinta y cuatro días estuvieron cercados por el ejército asirio: infantes, carros y jinetes. A los habitantes de Betulia se les acabaron las reservas de agua;"
,"21":"los pozos se agotaron y tuvieron que racionarla."
,"22":"Los niños, las mujeres y los adolescentes desfallecían de sed y caían en las calles de la ciudad."
,"23":"Entonces todos, hombres, mujeres, jóvenes y niños, acudieron en tropel a Ozías, y dijeron a una voz:"
,"24":"«Que Dios sea juez entre ti y nosotros, porque tú eres el causante de estas desgracias, al no querer tratar de paz con los asirios."
,"25":"No hay quien nos pueda socorrer ahora. Dios nos ha abandonado en manos de los asirios para morir de sed y de miseria."
,"26":"Convoca, pues, ahora, a todos los que están en la ciudad, y entreguémonos voluntariamente al ejército de Holofernes;"
,"27":"porque es preferible vivir cautivos y bendecir al Señor, que ver expirar ante nuestros ojos a nuestras esposas y niños."
,"28":"Te exigimos por el cielo y la tierra, por nuestro Señor y Dios de nuestros padres, el que nos castiga por nuestros pecados y los de ellos, que tomes esta resolución hoy mismo.»"
,"29":"Toda la asamblea se conmovió profundamente y clamó a Yavé, su Dios, a grandes voces."
,"30":"Ozías se levantó y dijo: «Tengan confianza, hermanos míos, y esperemos durante cinco días la misericordia del Señor. Quizá se apiade de nosotros y no nos abandone hasta el fin."
,"31":"Pero, si pasado ese plazo no llega ningún socorro, haremos lo que pidieron.»"
,"32":"Luego despidió al pueblo, y cada uno se fue a su lugar. Fueron a las murallas y torres de la ciudad y mandaron a las mujeres y a los niños a sus casas. Pero en la ciudad había un gran abatimiento."
}`)
	CurrentBook.AddChapter(8, `{
"1":"En Betulia vivía Judit, hija de Merarí, hijo de Idox, hijo de José, hijo de Oziel, hijo de Elcías, hijo de Ananías, hijo de Gedeón, hijo de Rafaín, hijo de Ajitob, hijo de Elías, hijo de Jilquías, hijo de Eliab, hijo de Natanías, hijo de Salatiel, hijo de Simeón."
,"2":"Manasés, su esposo, de su misma tribu y familia, había muerto durante la cosecha de la cebada."
,"3":"Mientras vigilaba a los segadores que ataban las gavillas, le dio una insolación, cayó en cama y murió en Betulia, su ciudad. Fue sepultado junto a sus padres en el campo que hay entre Dotán y Balamón."
,"4":"Hacía tres años y medio que Judit era viuda de Manasés."
,"5":"En la terraza de su casa se había hecho una habitación donde vivía. Se vestía de penitencia"
,"6":"y ayunaba todos los días, menos los sábados y otras festividades de Israel."
,"7":"Era extremadamente hermosa. Su marido le había dejado muchas riquezas, familia numerosa y posesiones llenas de rebaños de vacas y de ovejas, quedando ella como dueña."
,"8":"No había nadie que hablara la más mínima palabra en su contra, ya que procuraba agradar a Dios en todo."
,"9":"Judit, pues, oyó las amargas palabras que el pueblo había dicho contra el jefe de la ciudad, pues habían perdido el ánimo ante la escasez de agua. También supo que Ozías había prometido que al cabo de cinco días entregaría la ciudad."
,"10":"Entonces envió a llamar a los dirigentes Jabrí y Jarmí."
,"11":"Cuando llegaron a su casa les dijo: «Escúchenme, jefes de Betulia. No están bien las palabras que han pronunciado delante del pueblo, cuando incluso han jurado ante Dios que entregarían la ciudad a nuestros enemigos si en el plazo convenido el Señor no les enviaba socorro. "
,"12":"¿Quiénes son ustedes para poner a Dios a prueba?"
,"13":"Ese no es el medio para atraer su misericordia; más bien sirve para provocar su ira."
,"14":"Ustedes nunca llegarán a conocer todo lo que siente una persona, no podrán apoderarse de sus pensamientos. Entonces, ¿cómo van a comprender a Dios que hizo todas las cosas? No, hermanos, no provoquen la cólera del Señor, Dios nuestro."
,"15":"Si no quiere socorrernos en el plazo de cinco días, tiene poder para salvarnos en cualquier otro momento, como lo tiene para destruirnos en presencia de nuestros enemigos."
,"16":"Pero ustedes no exijan garantías a los designios del Señor, nuestro Dios, porque Dios no se somete a las amenazas como un hombre, ni se le impone decisión alguna, como a hijos de hombres."
,"17":"Más bien pidámosle que nos socorra mientras esperamos confiadamente que nos salve, y él escuchará nuestras súplicas, si le agrada hacerlo."
,"18":"Es verdad que no se encontraría en nuestros días tribu, familia, pueblo o ciudad de las nuestras que se postre ante dioses hechos por mano del hombre, como sucedió en otros tiempos,"
,"19":"por lo cual, en castigo, nuestros padres fueron entregados a la espada y al saqueo, y murieron en forma desastrosa ante sus enemigos."
,"20":"En cambio, nosotros no reconocemos a otro Dios fuera de él, y en esto radica nuestra esperanza de que no nos mirará con indiferencia, ni a nosotros, ni a ninguno de nuestra raza."
,"21":"Porque si de hecho se apoderan de nosotros, caerá toda Judea, y nuestro Santuario será saqueado."
,"22":"Tendremos que responder de esta profanación con nuestra propia sangre. Dios nos pedirá cuentas por la muerte de nuestros hermanos, la esclavitud de nuestro pueblo y la ruina de nuestra herencia."
,"23":"El castigo nos alcanzará en medio de las naciones en que estemos como esclavos, y seremos maltratados por nuestros patrones. No habrá esperanza de que nuestra esclavitud se cambie en una suerte más feliz, sino que el Señor, nuestro Dios, la convertirá en deshonra."
,"24":"Ahora, pues, mostremos a nuestros hermanos que nos sentimos solidarios con ellos y que sabemos luchar por nuestra religión, nuestro Templo y su altar."
,"25":"Por todos estos motivos debemos dar gracias al Señor, nuestro Dios, que ha querido probarnos como a nuestros padres."
,"26":"Recuerden lo que hizo con Abraham, las pruebas por las que hizo pasar a Isaac, lo que le sucedió a Jacob en Mesopotamia de Siria cuando pastoreaba el rebaño de Labán, hermano de su madre."
,"27":"Cómo los colocó en el crisol para probar sus corazones! El Señor nos hiere a los que nos acercamos a él, no para castigarnos, sino para instruirnos.»"
,"28":"Ozías respondió: «En todo lo que has dicho, has hablado con criterio, y nadie podrá oponerse a tus razones,"
,"29":"ya que no es hoy cuando has comenzado a dar muestras de tu sabiduría, sino que desde hace mucho tiempo todo el pueblo conoce tu inteligencia y la generosidad natural de tu corazón."
,"30":"Pero el pueblo padecía mucha sed y nos obligaron a cumplir nuestra palabra, y a comprometernos con un juramento que no podemos romper."
,"31":"Ahora, pues, tú que eres piadosa, pide por nosotros al Señor que envíe lluvia para llenar nuestros pozos, y así no nos veamos desfallecidos.»"
,"32":"Judit respondió: «Escúchenme. Voy a hacer algo cuyo recuerdo se prolongará entre los hijos de nuestra raza de generación en generación."
,"33":"Esta noche estén en la puerta de la ciudad. Yo saldré con mi sirvienta y, antes del plazo que se han fijado para entregar la ciudad a nuestros enemigos, el Señor, por mi medio, visitará a Israel."
,"34":"No intenten averiguar lo que quiero hacer, pues no lo diré hasta no haberlo cumplido.»"
,"35":"Entonces Ozías y los jefes le dijeron: «Vete en paz, y que el Señor Dios vaya delante de ti para tomar venganza de nuestros enemigos.»"
,"36":"Y dejando la habitación de Judit, regresaron a sus puestos."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Judit se arrodilló con el rostro inclinado, puso ceniza sobre su cabeza y dejó ver el saco que tenía puesto. Era precisamente a la misma hora en que se ofrecía en la Casa de Dios de Jerusalén el incienso de la tarde. Y dirigió su voz al Señor, diciendo:"
,"2":"«Señor, Dios de mi padre Simeón, a él le diste una espada para castigar a aquellos extranjeros que violaron a una virgen ultrajándola, que desnudaron su cuerpo para su propia vergüenza y que profanaron su seno para su propia deshonra. Ellos hicieron eso, aunque tú dijiste:"
,"3":"Esto no se hace. Pero entregaste a sus jefes a la muerte, y su lecho, rojo de vergüenza, lo dejaste rojo de sangre por su engaño."
,"4":"Castigaste a los esclavos junto a los príncipes; y a los príncipes con los siervos. Entregaste sus mujeres al rapto, sus hijas a la esclavitud y sus posesiones para que fueran repartidas entre tus hijos queridos, que habían hecho suyos tus deseos, que tuvieron horror a la profanación hecha a su sangre y pidieron tu ayuda."
,"5":"¡Dios mío, escúchame! Tú hiciste las cosas pasadas, las presentes y las venideras, tú has pensado el presente y el futuro, y sólo se realiza lo que tú dispones, ya que los acontecimientos que tú quieres se presentan y te dicen: ¡Aquí estamos!"
,"6":"Pues preparas tus intervenciones y tus decisiones están previstas de antemano."
,"7":"Mira la muchedumbre de los asirios; están orgullosos de sus caballos y jinetes, alaban la fortaleza de sus infantes, confían en sus escudos y en sus lanzas, en sus arcos y en sus hondas, pero no reconocen que tú eres el Señor, el que decide las guerras."
,"8":"Señor es tu nombre. ¡Quebranta su fuerza con tu poder! ¡Derriba su dominio con tu ira!, pues pretenden profanar tu Santuario, manchar la Tienda donde se encuentra la gloria de tu Nombre y destruir con hierro los cuernos de tu altar."
,"9":"Mira su orgullo y deja caer tu ira sobre sus cabezas, y da a mi mano de mujer la fuerza necesaria para lo que he dispuesto."
,"10":"Castiga con la astucia de mis palabras al esclavo y al señor, al jefe y sus servidores; acaba con su soberbia por medio de mi mano de mujer."
,"11":"Pues tu fuerza no está en la multitud, ni tu poder en los valientes, sino que eres el Dios de los humildes, defensor de los pequeños, apoyo de los débiles, protector de los abandonados, salvador de los desesperados."
,"12":"Sí, Dios de mi padre y Dios de Israel, Señor de cielos y tierra, Creador de las aguas, Rey de toda la creación, ¡escucha mi plegaria!"
,"13":"Dame palabras seductoras para herir y matar a los que vienen como enemigos de tu alianza, de tu santa Casa, del monte Sión y la Casa que pertenece a tus hijos."
,"14":"Haz que toda nación y toda tribu reconozca que eres Dios, todopoderoso y fuerte, y que fuera de ti no hay otro protector para el pueblo de Israel.»"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Acabada su plegaria al Dios de Israel,"
,"2":"Judit se levantó del suelo, llamó a su sierva y bajó a la habitación donde pasaba los sábados y días de fiesta."
,"3":"Se quitó el saco que vestía y, después de bañada, cambió sus vestidos de viuda por los de fiesta, que usaba cuando vivía su esposo Manasés; se echó perfumes, se peinó y se adornó la cabeza con una cinta;"
,"4":"se calzó las sandalias, se puso collares, brazaletes, anillos, aros y todas sus joyas. Se arregló lo mejor que pudo con el fin de atraer las miradas de todos los que la vieran."
,"5":"Llenó una bolsa con harina de cebada, tortas de higos y panes puros, lo envolvió todo y se lo entregó a su sierva, junto con un cuero lleno de vino y un cántaro de aceite."
,"6":"Luego se dirigieron a la puerta de Betulia y allí se encontraron con Ozías y con Jabrí y Jarmí, dirigentes de la ciudad,"
,"7":"quienes al ver a Judit transformada quedaron maravillados de su belleza y le dijeron:"
,"8":"«¡Que el Dios de nuestros padres te conceda gracia y dé éxito a tus planes para gloria de Israel y de Jerusalén!»"
,"9":"Judit adoró a Dios y les dijo: «Manden abrir la puerta de la ciudad para que yo salga a realizar lo que me acaban de decir.» Ellos mandaron a los jóvenes que abrieran la puerta, como ella lo había pedido."
,"10":"Cumplida la orden, Judit salió con su sierva. Los hombres de la ciudad la siguieron con la mirada mientras bajaba por la montaña hasta que llegó al valle, y allí la perdieron de vista."
,"11":"Ambas caminaban rápidamente por el valle, cuando les salieron al encuentro centinelas asirios,"
,"12":"quienes detuvieron a Judit y le preguntaron: «¿Quién eres? ¿De dónde vienes y a dónde vas?» Ella respondió: «Soy hija de hebreos y huyo de ellos porque están a punto de ser devorados por ustedes."
,"13":"Voy a presentarme a Holofernes, jefe del ejército de ustedes, para hablarle con sinceridad y mostrarle el camino para apoderarse de toda la montaña sin que ninguno de sus hombres sufra daño o pierda su vida.»"
,"14":"Aquellos hombres, al oírla hablar y ver su extraordinaria belleza, le dijeron:"
,"15":"«Has salvado tu vida con tu decisión de presentarte a nuestro señor. Anda a su tienda; algunos de los nuestros te acompañarán hasta que llegues a él."
,"16":"Cuando estés en su presencia, no tengas miedo, cuéntale tus propósitos y te tratará bien.»"
,"17":"Y eligieron entre ellos a cien hombres que la acompañaron y guiaron hasta la carpa de Holofernes."
,"18":"La noticia de su llegada se corrió de tienda en tienda. La gente de todo el campamento acudía en torno a ella, mientras esperaba fuera de la tienda de Holofernes que le anunciaran su llegada."
,"19":"Quedaban prendidos de su belleza y, al verla, admiraban a los hijos de Israel y decían: «¿Quién puede despreciar a un pueblo que tiene mujeres tan bellas? Sería un error dejar con vida a uno solo de ellos, porque los que queden podrían engañar a todo el mundo.»"
,"20":"Los guardias personales de Holofernes y todos sus oficiales salieron para introducirla en la tienda."
,"21":"Holofernes descansaba en su cama bajo colgaduras de oro y púrpura, adornada de esmeraldas y piedras preciosas."
,"22":"Le anunciaron la llegada de Judit y salió a la entrada de su tienda precedido de lámparas de plata."
,"23":"Cuando apareció Judit ante Holofernes y sus ayudantes, quedaron maravillados de la belleza de su rostro. Ella se puso de rodillas, pero los ayudantes de Holofernes la levantaron."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Holofernes le dijo: «Ten confianza, mujer, no tengas miedo, porque nunca he maltratado a los que se deciden a servir a Nabucodonosor, rey de toda la tierra."
,"2":"Tampoco habría levantado mi espada contra tu pueblo de montañeses si no me hubieran despreciado;"
,"3":"pero ellos lo han querido así. Ahora dime por qué huyes de ellos y te refugias entre nosotros ¿Lo haces para salvarte? Ten confianza, salvarás tu vida esta noche y en adelante."
,"4":"Nadie te hará daño; te tratarán bien como a los siervos de mi señor, el rey Nabucodonosor.»"
,"5":"Judit respondió: «Escucha mis palabras para que pueda hablar con libertad ante tu presencia. Esta noche diré sólo la verdad a mi señor."
,"6":"Si sigues los consejos de tu sierva, todo se cumplirá por la mano de Dios y mi señor no fracasará en sus proyectos."
,"7":"¡Viva Nabucodonosor, rey de toda la tierra, y viva su poder que te ha enviado para poner en el recto camino a todo viviente! Gracias a tu poder, no sólo los hombres le sirven, sino que hasta las bestias salvajes, los ganados y las aves del cielo viven para Nabucodonosor y toda su casa."
,"8":"Nosotros hemos oído hablar de tu sabiduría y de la prudencia de tu espíritu y toda la tierra sabe que tú eres el más hábil de todo el reino, de profundos conocimientos y muy entendido para la guerra."
,"9":"También conocemos el discurso que Ajior pronunció en tu consejo y oímos sus propuestas, pues los hombres de Betulia lo acogieron y él les contó todo lo que dijo en tu presencia."
,"10":"Ahora, poderoso señor, no desprecies sus palabras; tenlas bien presentes, que son verdaderas. Nuestro pueblo no será vencido, ni la espada podrá contra ellos si no han pecado contra su Dios."
,"11":"Pero, para que no quedes decepcionado y fracasado, la muerte caerá sobre ellos. Han caído en un pecado que hace enojarse a Dios cada vez que lo cometen"
,"12":"En vista de que les faltan alimentos y escasea el agua, han decidido consumir todo lo que Dios con sus leyes les tiene prohibido comer."
,"13":"Incluso las primicias del trigo y las décimas del vino y del aceite, cosas sagradas y reservadas a los sacerdotes de Jerusalén y que ningún laico puede tocar ni siquiera con las manos."
,"14":"Han enviado mensajeros a Jerusalén (donde el pueblo hace lo mismo), para conseguir autorización de los Ancianos."
,"15":"Y en cuanto les sea concedido y lo realicen, entonces Dios te los entregará para su destrucción."
,"16":"Cuando supe todo esto, huí de ellos, y Dios me envió para realizar contigo hazañas tales que, cuando la tierra lo sepa, todos queden desconcertados."
,"17":"Soy piadosa y sirvo al Dios del cielo noche y día. Ahora quiero quedarme a tu lado. Cada noche saldré al valle a rezar a Dios y él me avisará en cuanto hayan caído en el pecado."
,"18":"Entonces, yo te avisaré para que salgas con tu ejército y ninguno de ellos podrá oponerse."
,"19":"Te guiaré por toda Judea hasta llegar al corazón de Jerusalén. Tú los llevarás como ovejas sin pastor, y ni siquiera un perro ladrará contra ti. Todo esto me ha sido revelado para que te lo comunique.»"
,"20":"Estas palabras agradaron a Holofernes y a todos sus oficiales, que, admirados de su sabiduría, dijeron:"
,"21":"«De un extremo a otro del mundo no hay mujer tan hermosa como ésta y tan sensata en sus palabras.»"
,"22":"Holofernes le dijo: «Bien ha hecho Dios en mandarte delante de tu pueblo, para demostrarle que el poder está en mis manos y la ruina en manos de los que desprecian a mi señor."
,"23":"Eres tan hermosa como prudente para hablar. Si haces lo que has dicho, tu Dios será mi Dios, vivirás en el palacio de Nabucodonosor y serás famosa en toda la tierra.»"
}`)
	CurrentBook.AddChapter(12, `{
"1":"La invitó a pasar donde tenía sus cubiertos de plata y mandó que le sirvieran de sus manjares y su vino. Pero Judit le dijo:"
,"2":"«No debo comer esto para no caer en falta; basta con lo que traje.» Holofernes replicó:"
,"3":"«Cuando se te acaben las cosas que tienes, ¿de dónde sacaremos otras iguales, si entre nosotros no hay nadie de los tuyos?»"
,"4":"Judit respondió «No te preocupes, porque antes que consuma lo que traje, el Señor cumplirá, por mi mano, sus designios.»"
,"5":"Los ayudantes la llevaron a su tienda, donde durmió hasta medianoche."
,"6":"Luego se levantó para salir a orar,"
,"7":"pues había pedido a Holofernes que ordenara a sus guardias que la dejaran salir. Judit permaneció tres días en el campamento, y cada noche iba al valle de Betulia y se lavaba en la fuente donde estaban los guardias. "
,"8":"A su regreso, rogaba al Dios de Israel que encaminara sus pasos para alegría de todo su pueblo."
,"9":"Ya purificada, volvía a su tienda para la comida."
,"10":"Al cuarto día, Holofernes dio un banquete al que invitó solamente a sus oficiales, excluyendo a los que estaban de servicio."
,"11":"Dijo a Bagoas, su mayordomo: «Convence a esa mujer hebrea que está en tu casa que venga a comer y beber en nuestra compañía."
,"12":"Sería una vergüenza para nosotros dejar que se fuera una mujer así sin haber tenido relaciones con ella. Si no logramos convencerla, se reirá harto de nosotros.»"
,"13":"Bagoas salió, pues, de la carpa de Holofernes y entró en la de Judit. Le dijo: «No te niegues, bella joven, a venir donde mi señor para que te honre y bebas con nosotros alegremente. Hoy mismo llegarás a ser como una de las asirias que viven en el palacio de Nabucodonosor.»"
,"14":"Respondió Judit: «¿Quién soy yo para oponerme a mi señor? Todo lo que agrade a sus ojos lo haré con gusto, y eso será para mí motivo de alegría hasta el día de mi muerte.»"
,"15":"Se levantó, se adornó con sus vestidos y todos sus adornos de mujer. Su sirvienta se le adelantó y extendió en el suelo, delante de Holofernes, la piel que Bagoas había dado a Judit para su uso diario y donde pudiera reclinarse para comer."
,"16":"Entró Judit y se instaló. El corazón de Holofernes quedó cautivado y su espíritu perturbado. Era presa de un deseo intenso de poseerla, porque desde el día en que la vio atisbaba el momento favorable para seducirla."
,"17":"Le dijo, pues: «Bebe y participa de nuestra alegría.»"
,"18":"Judit respondió: «Bebo gustosa, señor, porque desde que nací jamás me sentí tan feliz como hoy.» Tomó lo que su sirvienta le había preparado"
,"19":"y comió y bebió ante él. Holofernes estaba bajo su encanto,"
,"20":"por eso bebió tal cantidad de vino como jamás en su vida había tomado."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Cuando se hizo tarde, sus oficiales se apuraron en irse. Bagoas cerró la carpa por fuera, después de haber despedido del lado de su amo a los que permanecían todavía. Todos fueron a acostarse, fatigados por el exceso en la bebida."
,"2":"Judit fue dejada sola en la tienda con Holofernes, hundido en su cama y ahogado en vino."
,"3":"Entonces Judit dijo a su sirvienta que permaneciera fuera, cerca del dormitorio, y que esperara su salida, como ella lo hacía diariamente. Además había tenido la precaución de decir que saldría para hacer su oración, y había hablado en el mismo sentido con Bagoas."
,"4":"Todos se habían ido de la carpa de Holofernes, y nadie, grande o pequeño, se había quedado en el dormitorio. Judit, de pie al lado de la cama, dijo interiormente: «Señor, Dios de toda fortaleza, favorece en esta hora lo que voy a hacer para gloria de Jerusalén."
,"5":"Este es el momento para que salves a tu pueblo. Da éxito a mis planes para aplastar a los enemigos que se han levantado en contra nuestra.»"
,"6":"Avanzó entonces hacia la cabecera de la cama, de donde colgaba la espada de Holofernes, la desenvainó"
,"7":"y después, acercándose al lecho, tomó al hombre por la cabellera y dijo: «Señor, Dios de Israel, dame fuerzas en este momento.»"
,"8":"Lo golpeó dos veces en el cuello, con todas sus fuerzas, y le cortó la cabeza."
,"9":"Después hizo rodar el cuerpo lejos del lecho y arrancó las cortinas de las columnas. En seguida salió y entregó la cabeza de Holofernes a su sirvienta,"
,"10":"que la puso en la bolsa en que guardaba sus alimentos, y las dos salieron del campamento como tenían costumbre para ir a rezar. Una vez que atravesaron el campamento, rodearon la quebrada, subieron la pendiente de Betulia y llegaron a sus puertas. "
,"11":"De lejos, Judit gritó a los guardias de las puertas: «Abran, abran la puerta. El Señor, nuestro Dios, está con nosotros para hacer maravillas en Israel y desplegar su fuerza contra nuestros enemigos, como lo ha hecho hoy.»"
,"12":"Los hombres de la ciudad, al oír su voz, se apuraron en bajar hasta la puerta de la ciudad y llamaron a los ancianos."
,"13":"Del más pequeño hasta el más grande, todos acudieron, porque ya no esperaban su regreso. Abrieron las puertas, acogieron a las dos mujeres, encendieron luces para verlas y las rodearon."
,"14":"Con fuerte voz, Judit les dijo: «¡Alaben a Dios! ¡Alábenlo! ¡Alábenlo, porque no ha apartado su bondad del pueblo de Israel! ¡Esta noche, por mi mano, ha aplastado a nuestros enemigos!»"
,"15":"Entonces sacó de la bolsa la cabeza de Holofernes y la mostró: «Aquí tienen la cabeza de Holofernes, general en jefe del ejército asirio, y éstas son las cortinas de su cama. El Señor lo mató por la mano de una mujer."
,"16":"¡Viva el Señor, que me protegió en mi empresa! Mi cara no encantó a ese hombre sino para perderlo, ya que no pecó conmigo; no me manchó ni me deshonró.»"
,"17":"Presa de un indecible entusiasmo, todo el pueblo se postró para adorar a Dios y gritó a una sola voz: «Bendito seas, Dios nuestro, tú que en este día aniquilaste a los enemigos de tu pueblo.»"
,"18":"Ozías, por su parte, dijo a Judit: «Hija mía, que Dios Altísimo te bendiga más que a todas las mujeres de la tierra. ¡Y bendito sea el Señor Dios, Creador del cielo y de la tierra, que te condujo para que cortaras la cabeza del jefe de nuestros enemigos!"
,"19":"Jamás los hombres olvidarán la confianza que has demostrado, y siempre recordarán las hazañas de Dios."
,"20":"Haga Dios que siempre te celebren, y que nunca te falten sus dones, porque no vacilaste en exponer tu vida por tu pueblo oprimido, y, para salvarnos del desastre, tomaste ante Dios la decisión más eficaz.»,Todo el pueblo respondió: «Amén. Amén.»"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Judit les dijo: «Escuchen, hermanos; tomen esta cabeza y cuélguenla en las murallas."
,"2":"Al amanecer, los más valientes con un jefe a la cabeza, tomen sus armas y salgan de la ciudad como si intentaran bajar a la llanura contra los asirios,"
,"3":"pero no bajen. Ellos tomarán sus armas e irán a despertar a los jefes de su ejército. Se presentarán a la tienda de Holofernes, y al no encontrarlo, quedarán aterrorizados y huirán ante ustedes."
,"4":"Entonces ustedes y todos los habitantes de Israel los perseguirán para matarlos."
,"5":"Pero antes llamen a Ajior, el amonita, para que vea y reconozca al que despreciaba a Israel, al que lo envió a nosotros para morir.»"
,"6":"Llegó Ajior, que estaba en casa de Ozías, y al ver la cabeza de Holofernes en manos de un hombre del pueblo, se desmayó."
,"7":"Una vez recuperado, se arrodilló a los pies de Judit y le dijo: ¡Bendita seas en toda Judá y en todas las naciones, que, al oír tu nombre, quedarán asombradas! "
,"8":"Ahora cuéntame lo que has hecho estos días.»,Judit, en medio del pueblo, narró todo lo que había hecho, desde que salió hasta ese momento. "
,"9":"Al terminar, todo el pueblo dio gritos de alegría, que se escucharon en toda la ciudad."
,"10":"Por su parte Ajior, al ver lo que había hecho el Dios de Israel, creyó en él, se circuncidó y quedó unido para siempre al pueblo de Israel."
,"11":"Apenas amaneció, colgaron la cabeza de Holofernes en la muralla, tomaron sus armas y salieron a los accesos del cerro."
,"12":"Los asirios que los vieron, avisaron a sus oficiales y éstos a su vez a los generales, capitanes y a todos los jefes,"
,"13":"hasta llegar a la tienda de Holofernes. Allí dijeron a su encargado general: «Despierta a nuestro jefe, que los esclavos quieren bajar a luchar con nosotros.»"
,"14":"Bagoas descorrió la cortina, pues creía que Holofernes dormía con Judit."
,"15":"Como nadie contestó, entró en el dormitorio y lo encontró en el suelo, muerto y sin cabeza."
,"16":"Gritó muy fuerte y rasgó sus ropas."
,"17":"Luego entró en la tienda de Judit y, al no encontrarla, corrió a las tropas y gritó:"
,"18":"«¡Los esclavos nos han traicionado! Una sola mujer hebrea ha llenado de vergüenza a la gente de Nabucodonosor. Holofernes está muerto en el suelo y sin cabeza.»"
,"19":"Los jefes del ejército asirio, desanimados por estas palabras, rasgaron sus vestiduras y dieron grandes gritos en el campo."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Cuando lo supieron los que estaban en el campamento, se conmovieron,"
,"2":"ya no respetaron ninguna disciplina, sino que llenos de miedo huyeron por todos los caminos de la montaña y la llanura."
,"3":"Los que estaban en torno a los judíos, también huyeron; entonces los guerreros de Israel se dejaron caer sobre ellos."
,"4":"Ozías mandó mensajeros a Betomestaim, a Jobá, a Coba y por todo Israel, para informarles de lo que había pasado, invitándolos a perseguir y destruir a los enemigos."
,"5":"Cuando los israelitas supieron esto, se lanzaron sobre ellos, y los persiguieron hasta Coba. También acudieron los de Jerusalén y los de la montaña, pues ya sabían lo que había pasado en el campamento de sus enemigos. Los de Galaad y Galilea los persiguieron hasta más allá de Damasco."
,"6":"En cuanto a los demás habitantes de Betulia, bajaron al campamento asirio, lo saquearon y recogieron grandes riquezas."
,"7":"Los israelitas que volvían de la matanza se adueñaron del resto; también los hombres de las aldeas y granjas de las llanuras y montañas recogieron gran botín de todo lo que los enemigos habían abandonado."
,"8":"El sumo sacerdote, Joaquín, y todo el Consejo de Ancianos de los habitantes de Jerusalén vinieron a enterarse de los beneficios con que el Señor había colmado a Israel, y para ver a Judit y saludarla."
,"9":"Al entrar a su casa, todos la felicitaban con estas palabras: «¡Tú eres la gloria de Jerusalén, el orgullo supremo de Israel, el honor mayor de nuestra raza!"
,"10":"¡Qué obra más grande ha sido la de tus manos, y qué beneficiosa resultó para Israel! Dios ha mirado con buenos ojos todo lo que hiciste. ¡Que el Señor Todopoderoso te bendiga a través de las edades!»,Y todos respondieron: ¡Amén!"
,"11":"El saqueo del campamento asirio duró un mes. A Judit le dieron la tienda de campaña de Holofernes con los objetos de plata, las camas, los cojines y todos los muebles. Ella lo tomó, trajo su mula y cargó todo en unos carros."
,"12":"Todas las mujeres de Israel se reunieron para verla y aclamarla, y organizaron danzas para festejarla. Ella tomó palmas y las distribuyó entre las mujeres que la acompañaban."
,"13":"Judit iba encabezando al pueblo y guiando la danza de las mujeres. Todos los hombres de Israel la seguían armados, llevando en la frente coronas y cantando himnos."
,"14":"Judit entonó este canto de acción de gracias, y todo Israel le respondía:"
}`)
	CurrentBook.AddChapter(16, `{
"1":"¡Alaben a mi Dios con tamboriles, canten al Señor con platillos,ofrézcanle un salmo de alabanza, ensalcen e invoquen su nombre!"
,"2":"Dios es el Señor que acaba la guerra, que acampa en medio de su pueblo, para librarme de mis perseguidores."
,"3":"Los asirios venían de las montañas del norte, su innumerable ejército cerraba los valles,y sus caballos cubrían los montes."
,"4":"Querían incendiar mis tierras, acabar con mis jóvenes y lactantes, y raptar a las vírgenes."
,"5":"El Señor todopoderoso los rechazó,por mano de una mujer."
,"6":"Su jefe no fue derribado,por jóvenes guerreros, ni herido por hijos de titanes, ni atacado por gigantes. ¡Fue Judit, hija de Merarí, que con la hermosura de su rostro lo desarmó!"
,"7":"Se sacó sus vestidos de viuda,para reanimar a los afligidos de Israel; adornó su rostro,"
,"8":"puso una cinta en sus cabellos,y se vistió de lino para seducirlo,"
,"9":"sus sandalias atrajeron su mirada,y su belleza encadenó su alma. ¡El sable atravesó su cuello!"
,"10":"Los persas se estremecieron de su audacia, los medos se sorprendieron de su temeridad."
,"11":"Entonces mis humildes clamaron,y aquéllos temieron; mis débiles gritaron,y aquéllos abandonaron el campo."
,"12":"Hijos de madres jóvenes los atacaron; como a hijos de desertores los hirieron. Murieron en la batalla contra mi Señor."
,"13":"Cantaré a mi Dios un canto nuevo: «Tú eres grande, Señor, eres glorioso, admirable e insuperable en poder."
,"14":"Que te sirvan todas las criaturas, pues tú hablaste y fueron hechas, enviaste tu espíritu y las hizo, nadie puede resistir tu voz."
,"15":"Los montes y las aguas se conmoverán, las rocas se derretirán como cera; pero tú siempre te mostrarás bueno,con aquellos que te temen."
,"16":"Todo sacrificio es de poco valor para ti. ¡Ni se nombre la grasa de los holocaustos!,Pero el que teme al Señor será grande para siempre."
,"17":"¡Ay de las naciones que atacan mi raza!,El Omnipotente las castigará el día del juicio; pondrá fuego y gusanos en su carne, y llorarán de dolor eternamente."
,"18":"Cuando llegaron a Jerusalén, adoraron a Dios y, después de que se purificó el pueblo, le ofrecieron sacrificios, ofrendas y regalos."
,"19":"Judit ofreció para el Templo todo el mobiliario de Holofernes, que el pueblo le había entregado, así como las cortinas de su dormitorio que ella misma se había llevado."
,"20":"Durante tres meses el pueblo permaneció en Jerusalén celebrando fiestas delante del Santuario. Judit estaba con ellos."
,"21":"Pasados aquellos días, cada uno volvió a su casa. Judit regresó a Betulia y se dedicó a su hacienda. Fue famosa en todo el país hasta el día de su muerte."
,"22":"Muchos le ofrecieron matrimonio, pero no aceptó a nadie desde que murió su esposo Manasés, y fue a reunirse con su pueblo."
,"23":"Su vejez la pasó en casa de su marido. A su sierva le dio la libertad. Murió en Betulia a la edad de ciento cinco años y fue sepultada en el sepulcro de Manasés."
,"24":"En esta ocasión el pueblo estuvo de duelo siete días. Antes de morir distribuyó su hacienda entre los parientes de su esposo y los suyos."
,"25":"Mientras vivió Judit, nadie amenazó a Israel, y ni siquiera mucho tiempo después de su muerte."
}`)

}
func ES_LBL_LoadVHNHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palabras de Nehemías, hijo de Hacalía. El año veinte del reinado de Artajerjes, en el mes de Quisleu, estaba yo en la fortaleza de Susa."
,"2":"Uno de mis hermanos, Jananí, acababa de llegar de Judá con algunos hombres; les pregunté sobre los judíos, sobre los sobrevivientes que habían regresado del cautiverio, y sobre Jerusalén."
,"3":"Me respondieron: 'Allá abajo, en la provincia, los que volvieron del cautiverio, los sobrevivientes, viven en la miseria y en medio de humillaciones; la muralla de Jerusalén está llena de hoyos y sus puertas, quemadas'."
,"4":"Al oír eso, me senté y me puse a llorar. Y durante muchos días permanecí sumido en la tristeza: ayunaba y oraba ante el Dios del Cielo,"
,"5":"y le decía: '¡Ay, Yavé, Dios del Cielo, Dios grande y terrible, que mantienes tu Alianza y tu fidelidad con los que te aman y cumplen tus mandamientos!"
,"6":"¡Escucha con atención, abre los ojos, atiende la plegaria de tu servidor! Porque como tú lo ves, yo oro día y noche por los hijos de Israel, tus servidores y confieso los pecados de los hijos de Israel. ¡Sí, hemos pecado contra ti, hemos pecado tanto yo como la casa de mi padre! Nos hemos portado muy mal contigo, no hemos respetado los mandatos, las ordenanzas y los decretos que nos diste por medio de Moisés, tu servidor. "
,"8":"Sin embargo, acuérdate de la palabra que empeñaste con Moisés, tu servidor, cuando le dijiste: 'Si ustedes son infieles, los dispersaré en medio de las naciones,"
,"9":"pero si se vuelven a mí, si respetan mis mandatos y los ponen en práctica, aunque sus desterrados se hallen en el extremo del cielo, los reuniré y los haré volver al lugar que elegí para que en él habitara mi Nombre'."
,"10":"Estos son pues tus servidores y tu pueblo que tú libraste con mucha fuerza y con tu poderosa mano."
,"11":"¡Oh Señor, escucha atentamente la oración de tu servidor, la oración de tus servidores que encuentran su alegría en temer tu Nombre, haz que hoy le vaya bien a tu servidor y que pueda conquistar el corazón del rey'. Por ese entonces yo estaba cerca del rey, pues le preparaba sus bebidas."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Ahora bien, el año veinte del rey Artajerjes, en el mes de Nisán, como yo estaba encargado de servir el vino, lo tomé y se lo pasé al rey. Nunca hasta entonces me había presentado triste delante de él."
,"2":"El rey me preguntó: '¿Por qué estás triste? No estás enfermo, sin embargo hay algo que te preocupa'. Después de un instante de temor,"
,"3":"le dije al rey: '¡Viva el rey para siempre! ¿Cómo no voy a estar triste si la ciudad donde están las tumbas de mis antepasados está en ruinas y sus puertas, quemadas por el fuego?'"
,"4":"El rey entonces me respondió: '¿Qué quieres?' Supliqué al Dios del Cielo"
,"5":"y le dije al rey: 'Si es que el rey quiere y si es que tu servidor cuenta con tu favor, envíame a Judá a la ciudad donde están las tumbas de mis antepasados para reconstruirla'."
,"6":"Como se encontraba la reina sentada al lado del rey, ambos me preguntaron: '¿Cuánto tiempo va a durar tu viaje y cuándo vas a volver?' Fijé entonces un plazo y el rey consintió en que me fuera."
,"7":"Dije también al rey: 'Si el rey así lo quiere, despache conmigo cartas a los gobernadores de la provincia que está más allá del Eufrates para que me dejen pasar hasta que llegue a Judá."
,"8":"Deme también una carta para Asaf, el gobernador del parque real, para que me entregue la madera para las puertas de la fortaleza del Templo, para la muralla de la ciudad y para la casa donde viviré'. Como la mano benevolente de Dios estaba conmigo, el rey me lo concedió todo."
,"9":"Cuando llegué donde los gobernadores de la provincia que está más allá del Eufrates, les entregué las cartas del rey; el rey había ordenado que me acompañaran oficiales y gente de a caballo."
,"10":"Pero cuando Sambalat el horonita, y Tobías, el funcionario amonita se enteraron de mi misión, se sintieron muy molestos: ¡cómo era posible que viniera alguien a preocuparse de los problemas de los israelitas!"
,"11":"Cuando llegué a Jerusalén, esperé tres días,"
,"12":"luego salí de noche con algunos hombres, sin decir a nadie lo que mi Dios me había inspirado que hiciera por Jerusalén, y no tenía ningún otro animal más que aquel en que iba montado."
,"13":"Salí pues de noche por la Puerta del Valle y me dirigí a la fuente del Dragón y a la Puerta del Basural. Observé atentamente la muralla de Jerusalén: había hoyos y las puertas habían sido devoradas por las llamas."
,"14":"Seguí hasta la Puerta de la Fuente y hasta la Piscina del rey, pero el animal que montaba ya no tenía por donde pasar."
,"15":"Entonces me devolví subiendo de noche a lo largo de la quebrada; examinaba a cada rato la muralla y después di media vuelta y me devolví pasando por la Puerta del Valle."
,"16":"Los consejeros no sabían a dónde había ido ni lo que había hecho. Pues hasta entonces no había dicho nada ni a los judíos, ni a los sacerdotes, ni a los responsables, ni a los consejeros ni a ningún otro funcionario."
,"17":"Pero entonces les dije: 'Fíjense en la miseria en que estamos, Jerusalén está en ruinas y sus puertas están quemadas. Vamos, tenemos que reconstruir la muralla de Jerusalén para que dejen de burlarse de nosotros'."
,"18":"Les conté además como la mano de Dios, esa mano llena de bondad, había estado conmigo, y les transmití las palabras del rey. '¡De pie! exclamaron, ¡construyamos!' Y se pusieron a trabajar con entusiasmo en esta hermosa obra."
,"19":"Cuando Sambalat el horonita, Tobías, el funcionario amonita, y Guesén el árabe supieron eso se burlaban de nosotros. Nos miraban con desprecio: '¿Qué están haciendo, nos decían, acaso quieren rebelarse contra el rey?'"
,"20":"Pero yo les respondí con seriedad: 'El Dios del Cielo hará que tengamos éxito, pues somos sus servidores, por eso vamos a empezar el trabajo. Ustedes en cambio no tienen ni derecho ni herencia ni ningún recuerdo en Jerusalén'."
}`)
	CurrentBook.AddChapter(3, `{
"1":"El sumo sacerdote Eliasib se puso a trabajar junto con sus hermanos y reconstruyeron la Puerta de las Ovejas. Instalaron el marco, pusieron las dos puertas y siguieron hasta la Torre de los Cien y hasta la Torre de Jananeel."
,"2":"Después de ellos trabajaba la gente de Jericó, y luego Zacur hijo de Imri."
,"3":"Los hijos de Ja-Sená construyeron la Puerta de los Pescados, instalaron el marco y pusieron ambas puertas junto con los candados y trancas."
,"4":"Después se puso a trabajar Meremot, hijo de Urías, hijo de Jacós, seguido por Mesulam hijo de Berequías, hijo de Mesezabeel, y al último Sadoc hijo de Baana."
,"5":"La gente de Tecoa se puso a trabajar pero sus jefes no se dignaron trabajar para su Señor."
,"6":"Yoyada hijo de Paseaj y Mesulam hijo de Besodías repararon la Puerta del Barrio Nuevo, instalaron el marco y pusieron ambas puertas junto con los candados y trancas."
,"7":"Melatías de Gabaón y Jadón de Meronot trabajaron a continuación junto con la gente de Gabaón y de Mispá, que dependían del gobernador de la provincia a este lado del Eufrates."
,"8":"Después de ellos fortificaron Jerusalén hasta la Muralla Grande, Uziel, de la corporación de los orfebres, y Jananías, de la corporación de los perfumistas."
,"9":"Después de ellos trabajaba Refaías hijo de Hur, jefe de medio sector de Jerusalén."
,"10":"Luego Yedaías hijo de Hammaf, en frente de su casa, y en seguida Jatús hijo de Jasabneías."
,"11":"Malaquías hijo de Jarim, y Jasub hijo de Pajaj-Moab, repararon el siguiente sector hasta la torre de los Hornos."
,"12":"Después seguía Salum hijo de Jalojés, jefe del otro medio sector de Jerusalén, quien trabajó con sus hijas."
,"13":"Janún y los habitantes de Zanoaj repararon la Puerta del Valle, la reconstruyeron y pusieron las puertas junto con los candados y las trancas; construyeron quinientos metros de muralla hasta la puerta del Basural."
,"14":"Malquías hijo de Recab, jefe del sector de Bet-ha-Querem, reparó la puerta del Basural junto con sus hijos, puso ambas hojas, los candados y las trancas."
,"15":"Salum hijo de Col José, jefe del sector de Mispá, reparó la puerta del Manantial, la reconstruyó, le puso techo y además ambas puertas con sus candados y trancas; levantó nuevamente el muro de la Cisterna de Siloé hasta los escalones que bajan de la Ciudad de David (la Cisterna se sitúa al lado del Jardín del Rey)."
,"16":"Nehemías hijo de Betsur continuó con los trabajos hasta las sepulturas de David, hasta la Cisterna y hasta la Casa de la guardia real."
,"17":"Después de él trabajaban los levitas: Rejum hijo de Bani, Asabías jefe de medio sector de Quela;"
,"18":"luego sus hermanos, Binui hijo de Yenadad, jefe del otro medio sector de Quela,"
,"19":"Ezer hijo de Yesúa, jefe de Mispá trabajó en el ángulo de la muralla cerca de la Casa de Armas;"
,"20":"después de ellos venía Baruc hijo de Zabay, desde el ángulo de la muralla hasta la puerta de la casa del Sumo sacerdote Eliasib;"
,"21":"después de él, en la siguiente sección, trabajó Meremot hijo de Urías, hijo de Jacós, desde la entrada de la casa de Eliasib hasta el término."
,"22":"Los sacerdotes que vivían en los demás sectores trabajaron también en las reparaciones."
,"23":"Dinyamín y Jasub frente a su propia casa, Azarías hijo de Maaseías hijo de Jananías cerca de su casa;"
,"24":"en el sector siguiente trabajó Binuí hijo de Jenadab, desde la casa de Azarías hasta el ángulo de la muralla;"
,"25":"luego trabajó Palal hijo de Uzay, cerca del ángulo de la muralla y de la torre que protege el palacio real al lado del patio de la prisión. Pedaías hijo de Pareas"
,"26":"trabajó hasta frente a la Puerta de las Aguas, hacia el este, y hasta la torre del Angulo;"
,"27":"después de él trabajaron la gente de Tecoa frente a la gran torre del ángulo y hasta el muro de Ofel."
,"28":"Los sacerdotes trabajaron en las reparaciones, cada uno frente a su casa, partiendo de la puerta de los Caballos:"
,"29":"Sadoc hijo de Immer frente a su propia casa; Semaías hijo de Secanías, custodiaba la puerta del Este."
,"30":"Jananías hijo de Selemías, y Janun, el sexto hijo de Salaf, trabajaron el siguiente sector. Mesulam hijo de Berequías, frente a su propia casa;"
,"31":"Malquías, de la corporación de los orfebres, trabajó hasta la casa de los sirvientes y de los comerciantes, que estaba frente a la puerta de la Vigilancia, cerca de la Sala alta del ángulo de las fortificaciones."
,"32":"Los orfebres y los comerciantes hicieron el trabajo entre esas dos salas y la Puerta de las Ovejas."
,"33":"Cuando Sambalat supo que estábamos reconstruyendo la muralla, se molestó mucho y montó en cólera. Burlándose de los judíos"
,"34":"declaró frente a sus hermanos y a las tropas de Samaría: '¿Qué hacen esos pobres judíos? ¡Piensan tal vez que van a hacer revivir esas piedras que sacaron de las ruinas y que están todas quemadas!'"
,"35":"Y Tobías el amonita que estaba a su lado agregó: '¡ Que construyan no más, pues cualquier zorro echará abajo su muralla!'"
,"36":"¡Escucha, Dios mío, cómo hemos sido humiliados! ¡Haz que sus insultos recaigan sobre sus cabezas y que sean despreciados en un país donde estén desterrados!"
,"37":"No perdones su falta ni borres su pecado porque insultaron a los que construían."
,"38":"Así fue como volvimos a levantar la muralla y la dejamos terminada hasta la mitad de su altura, porque el pueblo trabajaba con entusiasmo."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Cuando Sambalat, Tobías, los árabes, los amonitas y los habitantes de Asdod supieron que avanzaba la reconstrucción de la muralla de Jerusalén, ya que casi todos los hoyos habían sido tapados, se enojaron mucho"
,"2":"y se juntaron para atacar Jerusalén y sembrar allí el pánico."
,"3":"Nosotros en tanto orábamos a nuestro Dios y habíamos puesto una guardia de día y de noche para protegernos de ellos."
,"4":"Por ese entonces decían los judíos: 'Hay demasiados escombros y los portadores ya no dan más, jamás podremos recontruir la muralla'."
,"5":"Y nuestros adversarios decían: 'Nos dejaremos caer sobre ellos sin que lo sepan, antes de que nos vean. Los mataremos e interrumpiremos la obra'."
,"6":"Algunos judíos que vivían cerca de ellos nos vinieron a decir unas diez veces: '¡Van a venir a atacarlos de todas partes!'"
,"7":"Ubiqué pues a todo el pueblo por familias en los huecos de la parte baja de la muralla, con sus espadas, lanzas y arcos."
,"8":"Como viera que tenían miedo, fui a decir a los jefes, a los funcionarios y a todo el pueblo: '¡No tengan miedo! Piensen que el Señor que es grande y terrible, y luchen por sus hermanos, sus hijos, sus hijas, sus mujeres y sus casas'."
,"9":"Cuando nuestros enemigos supieron que estábamos prevenidos y que Dios había hecho fracasar su plan, volvimos todos a la muralla, cada cual a su trabajo."
,"10":"Pero desde ese día, la mitad de mis hombres trabajaba y la otra, armada con lanzas, escudos, arcos y corazas, se mantenía detrás de los judíos que trabajaban en la muralla. Los portadores iban armados, con una mano trabajaban y con la otra sostenían la lanza."
,"12":"Los que construían llevaban su espada al cinto mientras trabajaban. Un encargado de tocar la trompeta estaba a mi lado,"
,"13":"pues yo había dicho a los funcionarios y a todo el pueblo: 'La obra es muy exigente y muy extensa y estamos dispersos en la muralla, alejados unos de otros."
,"14":"Por eso, apenas oigan el toque de la trompeta, vengan a juntarse con nosotros desde el lugar en donde estén y que nuestro Dios combata por nosotros'."
,"15":"Así trabajabamos desde que comenzaba el día hasta la aparición de las primeras estrellas, y la mitad sostenía sus lanzas."
,"16":"Por ese entonces dije también al pueblo: 'Cada cual junto con su sirviente pasará la noche en Jerusalén. De noche harán guardia y de día estarán en la obra'."
,"17":"Ni yo ni mis hermanos ni mis hombres ni los que hacían guardia nos cambiábamos de ropa, y teníamos constantemente las armas en la mano."
}`)
	CurrentBook.AddChapter(5, `{
"1":"La gente del pueblo y sus mujeres se quejaron de sus hermanos judíos: 'Tenemos que empeñar a nuestros hijos y a nuestras hijas a cambio de trigo si queremos comer y vivir'."
,"3":"Otros decían: 'Tenemos que empeñar nuestros campos, nuestras viñas y nuestras casas a cambio de trigo debido a esta hambruna'."
,"4":"Otros decían además: 'Para poder pagar el impuesto al rey tuvimos que pedir plata prestada hipotecando nuestros campos y nuestras viñas."
,"5":"Sin embargo somos de la misma sangre que nuestros hermanos y nuestros hijos valen tanto como los de ellos; incluso tenemos que dejar en prenda a nuestros hijos y a nuestras hijas, y a menudo se aprovechan de ellas. ¿Qué más podemos hacer si nuestros campos y nuestras viñas ya pertenecen a otros?'"
,"6":"Al oír esa queja y esas palabras me enojé mucho."
,"7":"Después de haber reflexionado, llamé severamente la atención a los nobles y a los funcionarios: '¡Ustedes imponen una pesada carga a sus hermanos!',Entonces convoqué a una gran asamblea, "
,"8":"y les dije: 'En la medida de nuestras posibilidades hemos rescatado a nuestros hermanos judíos que habían sido vendidos en medio de las naciones, pero ahora ustedes venden a sus hermanos o los compran'. Todos estaban callados, nadie replicaba."
,"9":"Y añadí: 'Lo que han hecho no está bien. ¿No quieren obedecer a nuestro Dios? ¿Quieren seguir las practicas vergonzosas de nuestros enemigos paganos?"
,"10":"Yo mismo, mis hermanos y mis hombres les hemos prestado dinero y trigo, ¡pues bien condonémosles su deuda!"
,"11":"Devuélvanles inmediatamente sus campos, sus viñas, sus olivares y sus casas; condónenles la deuda de dinero, de trigo, de vino o de aceite que tienen con ustedes'."
,"12":"Todos respondieron: 'Devolveremos lo que recibimos en prenda, no exigiremos nada y haremos lo que tú dices'. Entonces llamé a los sacerdotes e hice que todo el mundo jurara que iba a poner en práctica esa promesa. "
,"13":"Luego, sacudí las dobleces de mi túnica y dije: '¡Así eche Dios fuera de su casa y de sus bienes a cualquier hombre que no cumpla esta palabra! ¡Sea así sacudido y que quede vacío!' Y toda la asamblea respondió: '¡Amén!' y alabaron a Yavé. El pueblo en tanto respetó su compromiso."
,"14":"Desde el día en que fui nombrado gobernador del territorio de Judá, en el año veinte de Artajerjes, hasta el año treinta y dos de su reinado, es decir, durante doce años, ni yo ni mis hermanos hemos cobrado 'el pan del gobernador'."
,"15":"Los anteriores gobernadores habían esquilmado al pueblo: le cobraban cuatro cientas piezas de plata en pan y vino por día, y sus hombres abusaban del pueblo. Yo no hice algo parecido porque temía a Dios."
,"16":"Además estuve tan absorbido por el trabajo de las fortificaciones que no compré campos, y todos mis hombres estaban allí trabajando."
,"17":"Se sentaban a mi mesa unos ciento cincuenta nobles y funcionarios, sin contar los que llegaban de las naciones extranjeras."
,"18":"Cada día habia que preparar un buey, seis corderos escogidos y aves, y todo eso era a mis expensas; todos los días se traían muchos cueros de vino. Pero a pesar de eso, nunca reclamé 'el pan del gobernador' porque veía que esa obra era muy pesada para el pueblo."
,"19":"Acuérdate de mi pues, Dios mío, no te olvides de lo que he hecho por este pueblo."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Sambalat, Tobías, el árabe, Guesén y los demás enemigos supieron que yo había reconstruido la muralla y que no quedaba ni un solo hoyo; sin embargo no había puesto todavía las hojas de las puertas."
,"2":"Entonces Sambalat y Guesén me mandaron este mensaje: 'Ven a vernos a Ha-Quefirim en el valle de Ono'. Pues tenían pensado hacerme algo malo."
,"3":"Les mandé unos mensajeros con esta respuesta: 'Estoy tan ocupado en un importante trabajo que no puedo ir. Ni voy a dejar todo tirado de repente para ir a verlos'."
,"4":"Me mandaron a decir lo mismo cuatro veces, y cada vez les di la misma respuesta."
,"5":"Pues bien, a la quinta vez, Sambalat me envió a su sirviente con una carta"
,"6":"que decía: 'Corre el rumor entre los extranjeros, y así me lo dijo Gasmú, que tú y los judíos se están preparando para una rebelión; es por eso que reconstruiste la muralla, porque quieres ser rey."
,"7":"Incluso te has conseguido profetas para que te apoyen y proclamen en Jerusalén: 'Judá tiene ahora un rey'. Como seguramente el rey se va a enterar de todo eso, mejor ven para que lo discutamos'."
,"8":"Le mandé de vuelta esta respuesta: 'Nada es cierto de todo lo que dices, tú has inventado todo eso'."
,"9":"Pues todos, queriendo meternos miedo, decían: 'Se van a cansar de trabajar y la obra no se hará'. Yo, en cambio, me empeñaba más todavía."
,"10":"Por ese entonces fui a la casa de Semaías, hijo de Delaías, hijo de Meytabeel, porque no podía venir. Me dijo: 'Reunámonos en el Templo de Dios, dentro del Santuario, y cerremos las puertas del Santuario, pues aquí están los que te van a matar y te van a matar de noche'."
,"11":"Le respondí: '¿Un hombre de mi clase va a huir? Uno cualquiera, como yo, no puede entrar en el Santuario y seguir con vida. No iré'."
,"12":"Me había dado cuenta de que no era Dios quien lo enviaba para advertirme, sino que Tobías lo había sobornado."
,"13":"Era para que tuviera miedo y cometiera un pecado haciendo lo que me decía. Esto habría dado motivo para perder mi reputación y avergonzarme."
,"14":"¡Oh Dios mío! Acuérdate de Tobías y de lo que hizo. Acuérdate también de la profetisa Noadías y de los demás profetas que querían meterme miedo."
,"15":"Se terminó la muralla el veinticinco del mes de Elul; se la había reconstruido en cincuenta y dos días."
,"16":"Cuando nuestros enemigos supieron eso, todas las naciones que están alrededor de nosotros tuvieron miedo y se acobardaron. Tuvieron que reconocer en eso la obra de Dios."
,"17":"Por ese mismo tiempo se multiplicó la correspondencia entre los nobles de Judá y Tobías."
,"18":"Pues mucha gente de Judá estaba ligada a Tobías por el juramento que le habían hecho; éste era yerno de Secanías, hijo de Ará, y su hijo Yohanán se había casado con la hija de Mesulam, hijo de Berequías."
,"19":"Incluso llegqron a hablar bien de Tobías delante de mí, al mismo tiempo que le contaban todas mis palabras. Y era éste, Tobías, quien me mandaba cartas para asustarme."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Cuando hube terminado la muralla, instalé ambas puertas y coloque allí porteros."
,"2":"Le encargué entonces a mi hermano Janani la administración de Jerusalén y entregué el mando de la fortaleza a Jananías, porque era un hombre de confianza que temía a Dios mucho más que los demás."
,"3":"Les dije: 'Las puertas de Jerusalén serán abiertas sólo cuando el sol comience a calentar, y aun cuando este esté todavía en lo alto del cielo, se deberán cerrar las puertas y ponerles candado. Se dispondrán turnos de guardia entre los habitantes de Jerusalén; unos permanecerán en sus puertas y otros delante de su casa."
,"4":"La ciudad era grande y extensa, pero la población era poco numerosa y las casas no habían sido reconstruidas aún. Por eso mi Dios me inspiró que reuniera a los nobles, a los funcionarios y al pueblo para hacer un censo por familia. Tomé en mi mano el libro donde estaban inscritos por familia los que habían vuelto primero y allí leí lo siguiente:"
,"6":"Lista de la gente de la provincia que retornaron del cautiverio, de los deportados que Nabucodonosor rey de Babel había desterrado y que regresaron a Jerusalén y a Judá, cada cual a su ciudad."
,"7":"Estos son los que volvieron con Zorobabel, Josué, Nehemías, Azarías, Raamías, Najamaní, Mardoqueo, Bilsán, Misperet, Bigvay, Nejum y Baana. Cantidad de hombres del pueblo de Israel: "
,"8":"hijos de Pareós: 2.172;"
,"9":"los de Safatías: 372;"
,"10":"los de Ara: 652;"
,"11":"los de Pajat-Moab (es decir los hijos de Josué y de Joab): 2.818;"
,"12":"los de Elam: 1.254; los de Zatú: 845;"
,"14":"hijos de Zacay: 760;"
,"15":"hijos de Binuí: 648; hijos de Bebay: 628; hijos de Azgad: 2.322; hijos de Adonicam: 667; hijos de Bigvay: 2.067;"
,"20":"hijos de Adín: 655;"
,"21":"hijos de Ater (es decir Hizquías): 98;"
,"22":"hijos de Jasum: 328;"
,"23":"hijos de Besay: 324;"
,"24":"hijos de Jarif: 112; "
,"25":"hijos de Gabaón: 95;"
,"26":"hombres de Belén y de Netofa: 188;"
,"27":"hombres de Anatot: 128;"
,"28":"hombres de Bet-Azmavet: 42;"
,"29":"hombres de Quiriat-Yearim, Quefira y Beerot: 743;"
,"30":"hombres de Ramá y Gueba: 621;"
,"31":"hombres de Micmas: 122; hombres de Betel y de Ay: 123;"
,"33":"hombres del otro Nebo: 52;"
,"34":"los hijos del otro Elam: 1.254;"
,"35":"los hijos de Yarim: 320;"
,"36":"los hijos de Jericó: 345;"
,"37":"los hijos de Lod, Jadid y Ono: 721;"
,"38":"los hijos de Senaa: 3.930."
,"39":"Sacerdotes: hijos de Yedaías (es decir la casa de Josué): 973;"
,"40":"hijos de Immer: 1.052;"
,"41":"hijos de Pasejur: 1.247;"
,"42":"hijos de Yarim: 1.017;"
,"43":"levitas: hijos de Josué (es decir Cadmiel), hijos de Jodías: 74;"
,"44":"cantores: hijos de Asaf 148;"
,"45":"porteros: hijos de Salum, hijos de Ater, hijos de Talmón, hijos de Acub, hijos de Hatita, hijos de Sobay: 138;"
,"46":"sirvientes: hijos de Sija, hijos de Jasufa, hijos de Tabaot,"
,"47":"hijos de Querós, hijos de Sía, hijos de Padón,"
,"48":"hijos de Lebana, hijos de Hagaba, hijos de Salmay,"
,"49":"hijos de Janán, hijos de Gidel, hijos de Gahar,"
,"50":"hijos de Reaías, hijos de Resín, hijos de Necoda,"
,"51":"hijos de Gazam, hijos de Uza, hijos de Pasea,"
,"52":"hijos de Besay, hijos de los Meunitas, hijos de los Nefusitas,"
,"53":"hijos de Bacbuc, hijos de Jacufa, hijos de Harjur,"
,"54":"hijos de Baslit, los de Mejida, los de Harsa,"
,"56":"los de Barcos, los de Sisra, los de Tema,"
,"56":"los de Nesia, los de Jatifa;"
,"57":"hijos de los esclavos de Salomón: hijos de Sotay, hijos de Soferet, hijos de Perida,"
,"58":"hijos de Jaala, hijos de Darcón, hijos de Gidel,"
,"59":"hijos de Safatías, hijos de Jatil, hijos de Poqueret-ha-Sebayim, hijos de Amón.."
,"60":"Total de sirvientes y esclavos de Salomón 392."
,"61":"Los sobrevivientes que provenían de Tel-Melá, de Tel- Jarsá, de Querub, de Adán y de Immer no pudieron decir si sus familias y sus clanes eran de Israel:"
,"62":"hijos de Delaías, hijos de Tobías, hijos de Necoda 642."
,"63":"Entre los hijos de sacerdotes, los hijos de Hobaías, los de Jacós y los de Barsilay (ese hombre había adoptado el nombre de Barsilay de Galaad con una de cuyas hijas se había casado),"
,"64":"todos esos buscaron sus listas genealógicas pero no las hallaron; por eso fueron descartados del sacerdocio como impuros."
,"65":"El gobernador les prohibió que comieran alimentos sagrados hasta que un sacerdote solucionara la cuestión por el Urim y el Tumim."
,"66":"Toda la asamblea sumaba 42.360 personas,"
,"67":"sin contar los esclavos y los sirvientes que llegaban a 7.337; también había 245 cantores entre hombres y mujeres."
,"68":"Se contaron 435 camellos y 6.720 burros."
,"69":"Algunos jefes de familia hicieron donaciones para los trabajos. El gobernador dio para el fondo común 1.000 piezas de oro,50 copas y 30 túnicas para los sacerdotes."
,"70":"Para los trabajos algunos jefes de familia entregaron al fondo común 20.000 piezas de oro y 2.200 minas de plata."
,"71":"Las demás donaciones hechas por el resto del pueblo ascendieron a 20.000 piezas de oro, 2.000 minas de plata y 67 túnicas para los sacerdotes."
,"72":"Los sacerdotes, los levitas y una parte del pueblo se quedaron a vivir en Jerusalén; los cantores, los porteros, los sirvientes y todos los demás israelitas se fueron a vivir en sus ciudades. Cuando llegó el séptimo mes los israelitas ya estaban en sus ciudades."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Todo el pueblo se juntó como un solo hombre en la plaza frente a la puerta de las Aguas. Pidieron entonces al escriba Esdras que trajera el libro de la Ley de Moisés que Yavé había ordenado a Israel."
,"2":"El sacerdote Esdras presentó la Ley ante la asamblea que estaba compuesta por hombres, mujeres, todos aquellos que estaban en edad de la razón. Era el primer día del séptimo mes."
,"3":"Estuvo leyendo el libro desde la mañana hasta el mediodía, frente a los hombres, mujeres y niños en edad de comprender que estaban reunidos en la plaza delante de la puerta de las Aguas. Todo el pueblo prestaba mucha atención al libro de la Ley."
,"4":"El escriba Esdras estaba en una tarima de madera construida para esa ocasión. Matitías, Sema, Anaías, Urías, Hilquías y Maaseías estaban cerca de él a su derecha. Pedaías, Micael, Malquías, Jasum, Jasbadana, Zecarías y Mesulam estaban a su izquierda."
,"5":"Esdras dominaba a todo el mundo; abrió el libro ante todo el pueblo y cuando lo abrió todos se pusieron de pie."
,"6":"Entonces Esdras bendijo a Yavé, el Gran Dios, y todo el pueblo respondió con las manos en alto: '¡Amén! ¡Amén!' Luego se inclinaron y se postraron delante de Yavé con el rostro en tierra."
,"7":"Josué, Bani, Serebías, Yamín, Acub, Sabtay, Hodías, Maaseías, Quelita, Azarías, Yozabad, Janán y Pelaías, que eran levitas, explicaban la Ley al pueblo, mientras éste permanecía de pie."
,"8":"Esdras leyó el libro de la Ley de Dios, e iba traduciendo y explicando el sentido para que comprendieran la lectura."
,"9":"En esa ocasión, su excelencia Nehemías y el sacerdote escriba Esdras, junto con los levitas que instruían al pueblo, le dijeron a éste: '¡Este es un día santo para Yavé nuestro Dios! ¡No estén tristes! ¡No lloren!' Pues todo el pueblo estaba llorando mientras oía las palabras de la ley."
,"10":"Le dijeron además: '¡Vayan y coman buena carne y tomen bebida agradable, pero guarden una parte para el que nada tiene preparado y llévensela, porque hoy es un día santo para nuestro Señor!'"
,"11":"Los levitas consolaban al pueblo diciéndole: '¡Que no se oigan estos lamentos! ¡Este es un día santo, no lloren más!'"
,"12":"Y todo el pueblo se dispersó para comer, beber, compartir y dar rienda suelta a su alegría, porque habían entendido las palabras que se les había enseñado."
,"13":"Al segundo día, los jefes de familia del pueblo, los sacerdotes y los levitas se reunieron junto al escriba Esdras para estudiar las palabras de la Ley."
,"14":"En la Ley que Yavé había ordenado por boca de Moisés encontraron esto escrito: 'Los hijos de Israel vivirán en chozas durante la fiesta del séptimo mes'."
,"15":"Inmediatamente hicieron publicar esta proclama en todas las ciudades y en Jerusalén: 'Vayan al cerro y traigan ramas de olivo, de pinos, de sicomoros, de palmeras y de otros árboles para que hagan chozas tal como está escrito'."
,"16":"Salió pues el pueblo y trajo ramas e hicieron chozas en las terrazas, en los patios, en los patios del Templo de Dios, en la plaza frente a la puerta de las Aguas y en la plaza al lado de la puerta de Efraín."
,"17":"Toda la asamblea, todos los que habían vuelto del destierro hicieron chozas y vivieron en ellas. Desde la época de Josué, hijo de Nun, hasta ese entonces, no habían hecho nada igual los hijos de Israel, era una fiesta extraordinaria."
,"18":"Día tras día se fue leyendo el libro de la Ley de dios, desde el primero al último día. La fiesta duró siete días, y al octavo día hubo según la Ley una asamblea solemne."
}`)
	CurrentBook.AddChapter(9, `{
"1":"El día veinticuatro de ese mes, se reunieron los israelitas para un ayuno; venían vestidos de saco y cubiertos de polvo."
,"2":"La raza de Israel se apartó de todos los extranjeros, se presentaron y confesaron sus pecados y las culpas de sus padres."
,"3":"Se pusieron de pie en la plaza y se dio lectura al libro de la Ley de Yavé durante un cuarto de la jornada. Durante otro cuarto, confesaron sus pecados y se postraron ante Yavé su Dios."
,"4":"Josué, Binuí, Cadmiel, Sebanías, Buni, Serebías, Bani, Quenani, se instalaron en el estrado de los levitas y con fuerte voz clamaron a Yavé su Dios."
,"5":"Los levitas Josué, Cadmiel, Bani, Jasbadleías, Serebías, Odías, Sebanías, Betajías dijeron: '¡Levántense y bendigan a Yavé nuestro Dios! ¡Bendito seas tú, Yavé Dios nuestro, por los siglos de los siglos! ¡Bendigan tu Nombre glorioso que sobrepasa todabendición y alabanza!"
,"6":"¡Tú, Yavé, eres el Unico! Tú hiciste los cielos, los cielos de los cielos y todo cuanto contienen, la tierra y todo lo que tiene, los mares y cuanto hay en ellos; tú das la vida a todos, y ante ti se postra el ejército de los cielos."
,"7":"Tú, Yavé, eres Dios; tú elegiste a Abram, lo sacaste de Ur de Caldea y le diste el nombre de Abrahán."
,"8":"Lo hallaste fiel e hiciste una alianza con él. Le diste el territorio del cananeo, del hitita y del amorreo, del pereceo, el jebuseo y el girgaseo. Mantuviste tus promesas porque eres justo."
,"9":"Viste la angustia de nuestros padres en Egipto, escuchaste sus gritos a orillas del mar de los juncos,"
,"10":"realizaste signos y prodigios contra el faraón, contra todos sus servidores y contra todo el pueblo de ese país cuyo orgullo tú conocías, y te hiciste una fama que perdura hasta hoy."
,"11":"Tú abriste el mar ante ellos, pasaron por medio del mar por suelo seco, y arrojaste al fondo de las aguas a los que los perseguían, como una piedra en aguas torrentosas."
,"12":"Tú los guiaste de día por medio de una columna de nubes y de noche por una columna de fuego, para alumbrar el camino por donde iban caminando."
,"13":"Tú bajaste al monte Sinaí y les hablaste de lo alto del cielo; les diste mandatos, leyes verdaderas, preceptos y decisiones excelentes."
,"14":"Les diste a conocer tu sábado santo y les ordenaste mandamientos, preceptos y leyes por boca de Moisés tu servidor."
,"15":"De lo alto del cielo les diste el pan para saciar su hambre, e hiciste brotar agua de la roca para su sed. Les dijiste que fueran a conquistar el territorio que habías jurado darles;"
,"16":"pero nuestros padres se negaron, se pusieron testarudos y no obedecieron tus órdenes."
,"17":"Se negaron a obedecer; se olvidaron de las maravillas que tú habías realizado para ellos y se les antojó volver a Egipto a su esclavitud. Pero tú, eres un Dios de perdón, lleno de piedad y de ternura, que tardas en enojarte y rico en bondad, y por eso no los abandonaste."
,"18":"Se hicieron un ternero de metal fundido diciendo: ¡Ese es el dios que te hizo subir de Egipto! Y pronunciaron toda clase de blasfemias."
,"19":"Pero tú, en tu inmensa ternura, no los abandonaste en medio del desierto; la columna de nubes no los dejó, sino que los guiaba de día por el camino, y de noche la columna de fuego alumbraba ante ellos el camino por donde iban."
,"20":"Les diste tu buen espíritu para hacerlos sabios, no les negaste el maná y les diste agua para su sed."
,"21":"Durante cuarenta años cuidaste de ellos en el desierto, no les faltó nada, su ropa no se gastó y sus pies no se hincharon."
,"22":"Les entregaste reinos y pueblos y les diste esos territorios como una provincia fronteriza. Se apoderaron del territorio de Sijón rey de Jesbón y del de Og rey de Basán."
,"23":"Multiplicaste sus hijos tanto como las estrellas del cielo e hiciste que entraran en el país del cual habías hablado a sus padres, para que entraran en él y tomaran posesión."
,"24":"Sus hijos entraron allí, conquistaron ese país; abatiste ante ellos a los cananeos habitantes del país, pusiste en sus manos reyes y pueblos para que los trataran como quisieran."
,"25":"Se apoderaron de ciudades fortificadas y de buena tierra, heredaron casas donde nada faltaba, pozos ya cavados, viñas, olivares, árboles frutales en cantidad; comieron cuanto quisieron, disfrutaron de tus incontables beneficios."
,"26":"Pero, se rebelaron y se alzaron contra ti, y se echaron tu Ley a la espalda. Mataron a los profetas que los invitaban a volverse hacia ti y cometieron grandes crímenes."
,"27":"Entonces los dejaste caer en manos de sus enemigos que los oprimieron. Clamaron a ti durante su opresión, y los escuchaste desde lo alto del cielo. En tu inmensa ternura les diste libertadores para que los libraran de manos de sus enemigos."
,"28":"Pero en cuanto recuperaron la paz, volvieron a hacer el mal delante de ti. De nuevo los abandonaste en manos de sus opresores y de nuevo clamaron a ti, y tú los escuchaste de lo alto del cielo. ¡Cuántas veces no los has librado así en tu ternura! "
,"29":"Les advertiste que volvieran a tu Ley, pero en su orgullo no cumplieron tus órdenes; pecaron contra esos mandatos que dan vida a cualquiera que los pone en práctica. No te ofrecieron más que una espalda rebelde y una nuca terca, no te obedecieron."
,"30":"Sin embargo, tú has sido paciente con ellos durante años, les advertiste por tu espíritu, por boca de tus profetas, pero no te hicieron caso. Entonces los entregaste en manos de las naciones paganas;"
,"31":"pero en tu inmensa ternura, no los hiciste desaparecer, no los abandonaste, porque eres un Dios lleno de piedad y de ternura."
,"32":"Ahora, oh Dios nuestro, tú, el Dios grande, poderoso y terrible, que siempre mantienes tu alianza y tu bondad, no seas insensible ante todas esas pruebas que han caído sobre nosotros, nuestros reyes, nuestros jefes, nuestros sacerdotes, nuestros profetas y todo nuestro pueblo desde los días de los reyes de Asiria hasta ahora."
,"33":"Tú has sido justo en todo lo que nos ha ocurrido, porque has actuado según la verdad y porque nosotros nos portamos mal."
,"34":"Nuestros reyes, nuestros jefes, nuestros sacerdotes y nuestros padres no han seguido tu Ley, se olvidaron de tus mandamientos y de las ordenanzas que les habías dado."
,"35":"Mientras estuvieron en su reino gozando de todos los beneficios que les proporcionabas, en este país grande y fértil que habías peusto a su disposición, no te sirvieron ni se apartaron de sus malas acciones."
,"36":"Por eso aquí estamos como esclavos, somos esclavos en este país que tú diste a nuestros padres y cuyos frutos y bienes deberían ser también nuestros."
,"37":"Pues esos productos están ahora en manos de reyes que tú nos impusiste debido a nuestros pecados y que disponen a su antojo de nuestras personas y de nuestros rebaños. Y mientras tanto nuestra angustia sigue siendo grande.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"'Por todo lo anterior, contraemos un compromiso solemne y lo ponemos por escrito.',En ese documento oficial figuraban los nombres de nuestros jefes, de nuestros levitas y de nuestros sacerdotes. "
,"2":"En el documento aparecían las firmas de: Nehemías hijo de Hacalía, el gobernador, y Sidquía,"
,"3":"Seraías, Azarías, Yirmeías,"
,"4":"Pasejur, Amarías, Malquías,"
,"5":"Jatús, Sebanías, Maluc,"
,"6":"Yarim, Meremot, Obadías,"
,"7":"Daniel, Guinetón, Baruc,"
,"8":"Mesulam, Abías, Miyamin,"
,"9":"Maazías, Bilgay, Semaías: éstos son los sacerdotes."
,"10":"Luego venían los levitas: Josué hijo de Azarías, Binuí, de los hijos de Yenadad, Cadmiel,"
,"11":"y sus hermanos Secanías, Hodavías, Quelita, Pelaías, Janán,"
,"12":"Mica, Rejov, Hasabías,"
,"13":"Zacur, Serebías, Sebanías,"
,"14":"Jodías, Bani, Quenani."
,"15":"Los jefes del pueblo: Pareoj, Pajat-Moab, Elam, Zatú, Bani,"
,"16":"Buni, Azgad, Bebay,"
,"17":"Adonías, Bigvay, Adín,"
,"18":"Ater, Yizquías, Azur,"
,"19":"Jodías, Jasum, Besay,"
,"20":"Jarif, Anatot, Nobay,"
,"21":"Magpías, Mesulam, Yezir,"
,"22":"Mesezabal, Sadoc, Yadua,"
,"23":"Pelatías, Janán, Anaías,"
,"24":"Josea, Jananías, Jacsub,"
,"25":"Jalojés, Pilja, Sobec,"
,"26":"Rejum, Yasabna, Maaseías,"
,"27":"Ajías, Janán, Anán,"
,"28":"Maluc, Jarim, Baana."
,"29":"Y el resto del pueblo: sacerdotes, levitas, porteros, cantores, servidores, en una palabra todos los que se separaron de la gente extranjera para obedecer a la Ley de Dios junto con sus mujeres, sus hijos y sus hijas que estaban en edad de comprender."
,"30":"Todos junto a sus hermanos, los jefes, se comprometen solemnemente y mediante juramento a caminar según la Ley que Dios dio por boca de Moisés, el servidor de Dios; a guardar y a cumplir los mandamientos de Yavé nuestro Dios, sus costumbres y sus leyes."
,"31":"No daremos más nuestras hijas a la gente del país ni tampoco tomaremos más sus hijas para nuestros hijos."
,"32":"Si un día de sábado la gente del país trae para vender mercadería u otros productos, no se los compraremos en un día sábado o en otro día sagrado. El séptimo año, renunciaremos a los productos de la tierra y a cualquier dinero que se nos deba."
,"33":"Nos obligamos a entregar un tercio de moneda de plata al año para el culto del Templo de nuestro Dios:"
,"34":"para el pan de la oblación, para la ofrenda y el holocausto perpetuos, para los sacrificios del sábado, de las Lunas Nuevas, de las fiestas, para las comidas sagradas, para los sacrificios ofrecidos para la expiación de los pecados de Israel; en una palabra, para todo el servicio del Templo de nuestro Dios."
,"35":"Todos nosotros, sacerdotes, levitas y pueblo, sorteamos para cada familia la fecha en que, una vez al año, tendrán que ofrecer la leña para el Templo de nuestro Dios, para quemarla en el altar de Yavé nuestro Dios, según lo que está escrito en la Ley."
,"36":"Cada año llevaremos al Templo de Yavé los primeros productos de nuestros campos y las primeras frutas de todos los árboles,"
,"37":"como también los primogénitos de nuestros hijos y de nuestro rebaño, según lo que está escrito en la Ley. Las primeras crías de nuestro ganado mayor y menor serán llevadas al Templo de nuestro Dios y destinadas a los sacerdotes que estén de turno en el Templo de nuestro Dios."
,"38":"Entregaremos a los sacerdotes, en las bodegas del Templo de nuestro Dios, lo mejor de nuestras harinas, de los productos de nuestros árboles, del vino recién cosechado y del aceite; y el diezmo de nuestros campos será para los levitas. Ellos mismos cobrarán ese diezmo en las regiones agrícolas."
,"39":"Un sacerdote, hijo de Aarón, acompañará a los levitas cuando vayan a cobrar el diezmo; los levitas llevarán luego ese diezmo a las dependencias de la casa del tesoro, en el Templo de nuestro Dios."
,"40":"A esas bodegas llevarán los israelitas y los levitas las contribuciones en trigo, vino y aceite; allí se guardará el material del Santuario, allí donde están los sacerdotes de turno, los porteros y los cantores. Y en adelante, no descuidaremos más el Templo de nuestro Dios."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Los jefes del pueblo se instalaron en Jerusalén y el resto del pueblo sorteó a uno de cada diez hombres para que fuera a vivir en Jerusalén, la ciudad santa; los demás podían quedarse en las ciudades de la provincia."
,"2":"El pueblo bendijo a todos aquellos que aceptaron vivir en Jerusalén:"
,"3":"a continuación viene la lista de los jefes de la provincia que se instalaron en Jerusalén. En las ciudades de Judá cada cual habitó en su ciudad y en su propiedad: israelitas, sacerdotes, levitas, sirvientes o hijos de esclavos de Salomón."
,"4":"De los hijos de Judá y de los hijos de Benjamín vivían en Jerusalén: Entre los hijos de Judá: Ataías, hijo de Uzías, hijo de Zecarías, hijo de Amarías, hijo de Sefatías, hijo de Majalaleel, de los descendientes de Perés; "
,"5":"Maaseías, hijo de Baruc, hijo de Col-José, hijo de Jazaías, hijo de Adaías, hijo de Yoyarib, hijo de Zecarías, descendiente de Sela."
,"6":"El total de los descendientes de Perés instalados en Jerusalén era de 468 hombres aptos para la guerra."
,"7":"Estos son los hijos de Benjamín: Salú, hijo de Mesulam, hijo de Yoed, hijo de Pedaías, hijo de Colaías, hijo de Maaseías, hijo de Itiel, hijo de Yesaías,"
,"8":"y sus hermanos Gabay y Salay: 928 en total. Los mandaba Yoel hijo de Zicri, y Judá hijo de Hasenua era el segundo en el mando de la ciudad."
,"10":"Entre los sacerdotes: Yedaías hijo de Joyaquim, hijo de"
,"11":"Seraías, hijo de Yilquías, hijo de Mesulam, hijo de Sadoc, hijo de Merayot, hijo de Ajitub, jefe del Templo de Dios,"
,"12":"y sus hermanos que estaban al servicio del Templo: en total 822; Adaías hijo de Yerojam, hijo de Pelalías, hijo de Amsi, hijo de Malquías,"
,"13":"y sus hermanos jefes de familia: en total 242; y Amasay hijo de Azareel, hijo de Asay, hijo de Mesilemot, hijo de Immer,"
,"14":"y sus hermanos, hombres valientes: en total 128. Los mandaba Zabdiel hijo de Hagadol."
,"15":"Entre los levitas, Semaías hijo de Jacsub, hijo de Azricam, hijo de Jasabías, hijo de Buni."
,"16":"Sabtay y Yozabad, jefes levitas responsables de los asuntos exteriores del Templo de Dios;"
,"17":"Matanías hijo de Mica, hijo de Zabdi, hijo de Asaf, que dirigía los himnos y entonaba la acción de gracias durante la oración; Baqbuquías, el segundo de sus hermanos; Obadías hijo de Samúa, hijo de Galal, hijo de Yedutún."
,"18":"El total de levitas en la ciudad santa era de 284."
,"19":"Los porteros: Acub, Talmón y sus hermanos que hacían la guardia en las puertas, en total 172."
,"20":"El resto de los israelitas, de los sacerdotes y de los levitas, vivían en las ciudades de Judá, cada uno en su propiedad o en las aldeas alrededor de sus campos."
,"21":"Los sirvientes vivían en Ofel; los jefes de los sirvientes eran Sijá y Gispá."
,"22":"Uzi hijo de Bani, hijo de Jasabías, hijo de Matanías, hijo de Micá, era el jefe de los levitas de Jerusalén; pertenecía a los hijos de Asaf, los cantores encargados del servicio del Templo de Dios."
,"23":"Una instrucción real y un reglamento determinaban lo que debían hacer los cantores día a día."
,"24":"Petaías hijo de Mesezabel, que pertenecía a los hijos de Zeraj, hijo de Judá, era el representante del rey para todo lo que concernía al pueblo."
,"25":"Los hombres de Judá vivían en Quiriat-Ha-Arbá y en sus alrededores, en Dibón y en sus alrededores, en Yecadseel y en sus alrededores,"
,"26":"en Yesua, en Molada, en Bet-Pelet,"
,"27":"en Jasar-Sual, en Berseba y en sus alrededores,"
,"28":"en Siclag, en Necona y en sus alrededores,"
,"29":"en En-Rimón, en Sorea, en Yarmut,"
,"30":"en Zanoaj, en Adulam y en las aldeas circunvecinas, en Laquis y en su comarca, en Azeca y en sus alrededores. Se instalaron pues desde Berseba hasta el valle de Hinnón."
,"31":"Los hijos de Benjamín vivían en Gueba, en Micmás, en Aya y en Betel y en sus alrededores,"
,"32":"en Anatot, en Nob, en Ananías,"
,"33":"en Jasor, en Ramá, en Guitayim,"
,"34":"en Jadid, en Seboyim, en Nedalat,"
,"35":"en Lod y en Ono como también en el valle de los artesanos."
,"36":"Los levitas vivían tanto en Judá como en Benjamín."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Estos son los sacerdotes y los levitas que volvieron con Zorobabel, hijo de Sealtiel, y Josué: Seraías, Yirmeías, Esdras,"
,"2":"Amarías, Maluc, Jatús,"
,"3":"Secanías, Rejum, Meremot,"
,"4":"Ido, Guinetón, Abías,"
,"5":"Miyamín, Maadías, Bilga,"
,"6":"Semaías; además Yoyarib, Yedaías,"
,"7":"Salú, Amoc, Yilquías, Yedaía. Eran los jefes de los sacerdotes y de sus hermanos, en tiempos de Josué."
,"8":"Levitas: Josué, Binui, Cadmiel, Serebías, Judá, Matanías, que dirigían el canto de acción de gracias."
,"9":"Bacbuquías, Uni y sus hermanos formaban el segundo coro, según sus clases."
,"10":"Josué engendró a Yoyaquim, Yoyaquim engendró a Eliasib, Eliasib a Yoyada,"
,"11":"Yoyada engendró a Yojanán y Yojanán engendró a Yadúa. Estos eran los jefes de familia de sacerdotes en tiempos de Yoyaquim: de la familia de Seraías, Meraías; de la familia de Yirmeías, Jananías; "
,"13":"de la familia de Esdras, Mesulam, de la familia de Amarías, Yojanán; de la familia de Maluc, Yonatán; de la familia de Sebanías, Yosef;"
,"15":"de la familia de Jarim, Adna; de la familia de Merayot, Jelcay;"
,"16":"de la familia de Ido, Zecarías; de la familia de Guinetón, Mesulam;"
,"17":"de la familia de Abías, Zicri; de la familia de Minyamin, y de Moadías, Felti;"
,"18":"de la familia de Bilga, Samúa; de la familia de Semaías, Yonatán;"
,"19":"además, de la familia de Yoyarib, Matenay; de la familia de Yedaías, Uzi;"
,"20":"de la familia de Salay, Calay; de la familia de Amoc, Eber,"
,"21":"de la familia de Yilquías, Jasabías; de la familia de Yedaías, Netaneel."
,"22":"Los jefes de familia y los sacerdotes fueron empadronados hasta el reinado de Darío el Persa, en tiempos de Eliasib, de Yoyada, de Yojanán y de Yadúa."
,"23":"Los hijos de Levi, jefes de familia, fueron inscritos en el Libro de las Crónicas solamente hasta el tiempo de Yojanán, nieto de Eliasib."
,"24":"Estos eran los jefes de los levitas: Jasabías, Serebías, Josué, Binui y Cadmiel; se paraban frente a sus hermanos Matanías, Bacbuquías y Obadías, y ambos grupos, frente a frente, ejecutaban los himnos de alabanza y de acción de gracias según la norma establecida por David, el hombre de Dios."
,"25":"Mesulam, Talmón y Acub eran porteros, hacían la guardia frente a los almacenes situados cerca de las puertas."
,"26":"Estos vivían en tiempos de Yoyaquim hijo de Josué, hijo de Yosadac, y en tiempos del gobernador Nehemías y del sacerdote-maestro de la Ley Esdras."
,"27":"Cuando se inauguró la muralla de Jerusalén, se buscó por todos los lugares a los levitas para traerlos a Jerusalén, con el fin de celebrar la inauguración con alegría, con cantos de acción de gracias, al son de címbalos, harpas y cítaras."
,"28":"Se congregaron pues los levitas de toda la región que rodeaba a Jerusalén, de las aldeas de Netofa,"
,"29":"de Bet-Ha-Gilgal, de los campos de Gueba y de Azmavet. Pues los cantores se habían construido poblados en los alrededores de Jerusalén."
,"30":"Los sacerdotes y los levitas se purificaron y luego purificaron al pueblo, las puertas y las murallas."
,"31":"Luego les pedí a los jefes de Judá que subieran a la muralla y los distribuí en dos grupos. El primero caminó por lo alto de la muralla hacia la derecha, en dirección a la puerta del Basural."
,"32":"En ese grupo iban Hosaías y la mitad de los jefes de Judá,"
,"33":"junto con Azarías, Esdras, Mesulam,"
,"34":"Judá hijo de Miyamín, Senaías y Yirmeía."
,"35":"Se los había seleccionado de entre los sacerdotes y se les había pasado unas trompetas. Luego seguía Zecarías hijo de Yonatán, hijo de Semaías, hijo de Matanías, hijo de Micá, hijo de Zacur, hijo de Asaf."
,"36":"El y sus hermanos Semaías, Azareel, Gilalay, Maay, Netaneel, Judá y Janani llevaban los instrumentos musicales de David, el hombre de Dios. Y Esdras, el maestro de la Ley, iba al frente de ellos."
,"37":"Al llegar a la puerta del Manantial, subieron, al lado de los escalones de la ciudad de David, a lo alto de la muralla y siguieron por la rampa del palacio de David, hasta la puerta de las Aguas, al este."
,"38":"El segundo grupo se fue por la izquierda; iba en él con la mitad de los jefes del pueblo caminando por lo alto de la muralla, hacia el lado de la torre de los Hornos y hasta la muralla ancha."
,"39":"Luego pasamos por la puerta de Efraín, la puerta de los Pescados, la torre de Jananeel y la torre de los Cien hasta la puerta de las Ovejas, y nos detuvimos en la puerta de la Guardia."
,"40":"Los dos grupos tomaron luego ubicación en el Templo de Dios; estaban conmigo la mitad de los funcionarios,"
,"41":"y además los sacerdotes Eliaquim, Maaseías, Minyamín, Micá, Elioenay, Zecarías, Ananías con sus trompetas,"
,"42":"y Maaseías, Semaías, Eleazar, Uzi, Yojanán, Malquías, Elam y Ezer. Los cantores eran dirigidos por Izraquía."
,"43":"Ese día ofrecieron muchos sacrificios y el pueblo estalló de alegría porque Dios le había dado un gran motivo para ello; las mujeres y los niños participaban de la fiesta, y la alegría de Jerusalén se oía a lo lejos."
,"44":"Por esos días se hizo entrega de las bodegas que se habían dispuesto para las provisiones, las tasas, las primicias y los diezmos a los que debían guardar en ellas la parte que la Ley dispone para los sacerdotes y levitas; allí llegaban de todas las ciudades del país, porque el pueblo de Judá estaba contento con los sacerdotes y levitas que cumplían el servicio."
,"45":"Estos aseguraban el servicio de su Dios y el servicio de las purificaciones; los cantores y los porteros cumplían los reglamentos de David y de su hijo Salomón."
,"46":"Pues ya en la época de David, Asaf era el jefe de los cantores, y había canticos de alabanza y de acción de gracias a Dios."
,"47":"Y desde la época de Zorobabel Israel entregaba la parte que les correspondía a los cantores y a los porteros, día a día; se les entregaban las ofrendas a los levitas, y éstos las remitían a los hijos de Aarón."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Por ese entonces se leyó el libro de Moisés ante el pueblo, pues allí estaba escrito: 'El amonita y el moabita quedarán para siempre excluidos de la asamblea de Dios,"
,"2":"porque no recibieron con pan y agua a los israelitas, sino que pagaron a Balaam para que los maldijera, pero nuestro Dios cambió la maldición en bendición'."
,"3":"Después de haber escuchado la Ley, echaron de Israel a todos los extranjeros."
,"4":"Pero antes de eso, estaba encargado de las bodegas de la Casa de nuestro Dios el sacerdote Eliyasib. Como era de la familia de Tobías,"
,"5":"le había pasado a éste una gran bodega donde antes se guardaban las ofrendas, el incienso, los objetos sagrados, el diezmo del trigo, del vino y del aceite, en una palabra, la parte de los levitas, de los cantores y de los porteros y lo que correspondía a los sacerdotes."
,"6":"Por ese entonces estaba yo ausente de Jerusalén, pues el año treinta y dos del reinado de Artajerjes, rey de Babilonia, yo había vuelto donde el rey. Pero al cabo de un tiempo pedí permiso al rey para regresar a Jerusalén; fue entonces cuando me informé de la mala acción que había hecho Elyasib para complacer a Tobías; le había arreglado una bodega en el patio de la Casa de Dios."
,"8":"Eso me molestó mucho; tiré al patio, fuera de la bodega, todos los muebles de Tobías,"
,"9":"y ordené que se purificaran las bodegas. Luego deposité allí los objetos de la Casa de Dios, las ofrendas y el incienso."
,"10":"Supe también que ya no se recaudaban las partes de los levitas y que éstos y los cantores encargados del servicio se habían vuelto cada cual a su campo."
,"11":"Por eso reté severamente a los funcionarios, diciéndoles: '¿Por qué está en el abandono la Casa de Dios?' Reuní de nuevo a los levitas y los repuse en sus funciones."
,"12":"Entonces todo el pueblo de Judá entregó de nuevo en los almacenes el diezmo del trigo, del vino y del aceite."
,"13":"Encargué los almacenes al sacerdote Selemías, al escriba Sadoc, y al levita Pedaías y les di como ayudante a Janán hijo de Zacur, hijo de Matanías, porque tenían fama de ser honrados. Les encargué la repartición a sus hermanos."
,"14":"Acuérdate, Dios mío, de lo que hice entonces, no te olvides de las buenas obras que realicé por la casa de mi Dios y para mantener sus ritos."
,"15":"También por ese entonces vi, un día sábado, a unos hombres que pisaban la uva en el lagar, y a otros que llevaban gavillas de trigo y las cargaban en sus burros junto con vino, uva, higos y toda clase de carga, y los llevaban a Jerusalén el día sábado. Les advertí que no vendieran sus productos."
,"16":"E incluso en Jerusalén había gente de Tiro que traía pescado y productos de todo tipo para vendérselos a los judíos el día sábado."
,"17":"Reté ásperamente a los nobles de Judá, diciéndoles: '¡Lo que ustedes hacen es vergonzoso!"
,"18":"Los padres de ustedes hicieron lo mismo y Dios nos mandó todas esas desgracias a nosotros y a esta ciudad. ¡Y ustedes siguen aumentando la cólera de Dios contra Israel al profanar el sábado!'"
,"19":"Por eso ordené que se cerraran las puertas de Jerusalén en cuanto comenzara a caer la tarde en el comienzo del sábado, y que se esperara hasta el término del sábado para abrirlas de nuevo. Puse en las puertas a algunos de mis hombres para vigilar que ninguna carga entrara en la ciudad el día sábado."
,"20":"Una o dos veces, mercaderes y comerciantes de todo tipo se quedaron de noche fuera de Jerusalén,"
,"21":"pero yo les advertí: '¿Por qué se quedan de noche cerca de la muralla? ¡Si vuelven a hacerlo, los arrestaré!' Con eso no volvieron más en día sábado."
,"22":"También ordené a los levitas que se purificaran y que custodiaran las puertas para que se respetara el día sábado. ¡Por todo eso acuérdate tambiém de mí, Dios mío. Ten piedad de mí según tu gran misericordia!"
,"23":"Por esos mismos días también vi a unos judíos que se habían casado con mujeres de Asdod, amonitas y moabitas."
,"24":"La mitad de sus hijos hablaban la lengua de Asdod o de tal o cual pueblo y no sabían el judío."
,"25":"Los reprendí y los maldije; incluso les pegué a algunos, les tiré el pelo y en nombre de Dios les dije severamente: 'No den más sus hijas a los hijos de ellos ni tomen más las hijas de ellos para sus hijos o para ustedes."
,"26":"Así fue como pecó Salomón, rey de Israel. No había otro rey como él en ninguna parte, era amado de su Dios que lo había puesto como rey de todo Israel, y sin embargo las mujeres extranjeras lo hicieron pecar."
,"27":"¿Quieren que se diga de ustedes que cometieron el mismo pecado y que fueron infieles a nuestro Dios casándose con mujeres extranjeras?'"
,"28":"Uno de los hijos de Yoyada, hijo del sumo sacerdote Elyasib era yerno de Sambalat el horonita; lo eché lejos de mí."
,"29":"No te olvides, Dios mío, hasta qué punto habían desacreditado el sacerdocio y tu alianza con los sacerdotes y los levitas."
,"30":"Los he purificado de cualquier extranjero; he establecido reglas para los sacerdotes y los levitas, para cada uno en su respectivo trabajo,"
,"31":"como asimismo reglas para la ofrenda de la leña a su debido tiempo y para los primeros frutos. ¡Acuérdate de mí, Dios mío, y bendíceme!"
}`)

}
func ES_LBL_LoadVHRTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"En los tiempos en que gobernaban los Jueces en Israel, hubo una gran hambruna en el país. Debido a eso, un hombre de Belén de Judá se trasladó a los campos de Moab con su mujer y sus dos hijos."
,"2":"El hombre se llamaba Elimelec; su esposa Noemí, y sus hijos, Majalón y Guilyón."
,"3":"Al poco tiempo falleció Elimelec, y Noemí quedó sola con sus dos hijos."
,"4":"Ambos tomaron por esposas a mujeres moabitas: una se llamaba Orfa y la otra Rut."
,"5":"Al cabo de diez años murieron también los dos hombres y Noemí quedó desamparada, sin esposo y sin hijos."
,"6":"Entonces decidió salir de Moab en compañía de sus nueras,"
,"7":"pues había oído decir que Yavé se había acordado de su pueblo y les había dado qué comer."
,"8":"Cuando estaban en camino de regreso a Judá, Noemí dijo a sus nueras: 'Creo que es mejor que ustedes se vayan a sus casas."
,"9":"Que el Señor les recompense todo lo bueno que han hecho con mis hijos y conmigo y les permita que encuentren cada una un esposo con quien puedan vivir en paz.'"
,"10":"Y en seguida les dio un abrazo. Pero ellas, llorando, le respondieron: 'No nos iremos, sino que seguiremos contigo.'"
,"11":"'Vuelvan a sus casas, insistió Noemí, pues ¿qué sacan con venir conmigo? Ya no puedo tener hijos para que sean sus maridos."
,"12":"Les repito, regresen a sus hogares, pues yo soy ya vieja para casarme de nuevo. Y aunque tuviera la remota esperanza de casarme esta misma noche y de tener hijos,"
,"13":"¿serían ustedes capaces de esperar a que se hicieran mayores? ¿Dejarían por eso de casarse? No, hijitas, bastante me ha castigado ya Dios como para añadir esta preocupación por ustedes.'"
,"14":"Ellas seguían llorando, hasta que al fin Orfa, dándole un beso, se fue a su casa. Rut, en cambio, se quedó con ella."
,"15":"Noemí le dijo entonces: '¿Por qué no te vas también tú con tu cuñada, y así regresas a tu casa y a tus dioses?'"
,"16":"Rut le replicó: 'No me obligues a dejarte yéndome lejos de ti, pues a donde tú vayas, iré yo; y donde tú vivas, viviré yo; tu pueblo será mi pueblo y tu Dios será mi Dios."
,"17":"Donde tú mueras, allí también quiero morir y ser enterrada yo. Que el Señor me castigue como es debido si no es la muerte la que nos separe.'"
,"18":"Viendo Noemí que Rut se mantenía firme en su decisión, no quiso insistirle más."
,"19":"Y continuando el camino llegaron las dos a Belén. Todo la gente se impresionó al verlas llegar."
,"20":"Y como Noemí se diera cuenta de que las mujeres comentaban: '¿Pero no es ésta Noemí?',"
,"21":"les dijo: 'No me llamen por mi nombre, sino díganme Amarga, porque el Todopoderoso me ha llenado de amargura. Partí con todo, y el Señor me hace volver con las manos vacías. ¿Para qué, pues, me llaman Noemí, cuando Yavé me ha condenado a ser una desgraciada?'"
,"22":"Así, fue como Noemí, acompañada de Rut, su nuera moabita, regresó de Moab. Y justo cuando llegaron a Belén estaba comenzando la cosecha de la cebada."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Noemí tenía, por parte de su marido, un pariente muy rico llamado Booz."
,"2":"Rut le pidió permiso a Noemí para ir a recoger espigas donde pudiera hacerlo sin problemas."
,"3":"Como ella se lo diera, Rut salió al campo y se puso a espigar detrás de los segadores. Dio la coincidencia de que el campo adonde ella había llegado pertenecía a Booz, pariente de Elimelec, que precisamente llegó ese día de Belén."
,"4":"Luego de saludar a los segadores con un: 'El Señor esté con ustedes', y de recibir por respuesta: '¡El Señor te bendiga!',"
,"5":"Booz preguntó al capataz de la cuadrilla de segadores: '¿De quién es esa joven?' Y el empleado le contestó:"
,"6":"'Es la moabita que acaba de regresar de Moab con Noemí."
,"7":"La autoricé para que recogiera las espigas que dejan los segadores, y es lo que ha hecho toda la mañana sin parar.'"
,"8":"Booz, dirigiéndose entonces a Rut, le dijo: 'Oye, hijita, no vayas a recoger espigas a otra parte."
,"9":"Quédate aquí y no te separes de los trabajadores. Síguelos a cualquier potrero donde vayan a segar. Yo les daré órdenes de que no te molesten. Y si tienes sed, no tienes más que acercarte a los cántaros donde tienen agua.'"
,"10":"Al oír esto, Rut se inclinó profundamente hasta el suelo y le dijo: '¿Qué de bueno has visto en mí, una extranjera, para que me trates con tanta bondad?'"
,"11":"'Me han contado, le respondió Booz, lo bien que te has portado con tu suegra después de que murió tu marido, hasta el punto de dejar tu patria y tus padres para venirte a un país totalmente desconocido para ti."
,"12":"Que Yavé te recompense tus buenas obras y que el Dios de Israel, bajo cuyas alas te has cobijado, te dé el premio que mereces.'"
,"13":"Ella replicó: '¡Ojalá me haga merecedora de tanta bondad como la que me has demostrado con tus palabras amables y tranquilizadoras, en circunstancias en que yo no me equiparo ni a la última de tus esclavas!'"
,"14":"A la hora del almuerzo, Booz la invitó a acercarse y a que comiera un pedazo de pan empapándolo en salsa."
,"15":"Cuando ella estaba sentada en medio de los segadores, él le ofreció también un puñado de granos tostados. Ella comió hasta quedar satisfecha y se guardó las sobras."
,"16":"En seguida se levantó para proseguir su trabajo, y entonces Booz dijo a sus trabajadores: 'Déjenla que incluso arranque espigas de las gavillas y no le llamen por eso la atención. Más aún, de vez en cuando vayan dejando caer de propósito algunas espigas para que ella pueda irlas recogiendo, sin decirle nada.'"
,"17":"Rut estuvo todo el día espigando y, luego de desgranarlas, vio que había juntado más o menos un quintal de cebada."
,"18":"Regresó a la ciudad con la cebada a cuestas y, cuando llegó a su casa, mostró a su suegra lo que había recogido y le entregó lo que había guardado para ella del almuerzo."
,"19":"Su suegra le preguntó: '¿Por dónde anduviste recogiendo espigas, ya que te fue tan bien?' Como ella le contase dónde había estado trabajando, su suegra prosiguió:"
,"20":"'¡Pero si el dueño de esos campos es Booz! ¡Bendito sea Yavé, que siempre se muestra tan bueno con los vivos y los muertos! Ese hombre es pariente nuestro; a él, entre otros, le corresponde rescatarnos.'"
,"21":"Rut, entonces, agregó: 'Fíjate que todavía me dijo que me quedara con sus trabajadores hasta que terminen de cosechar.'"
,"22":"Noemí le respondió: 'Muy bien, hija mía, quédate con sus trabajadores, pues así no tendrás que pasar malos ratos si vas a otra parte.'"
,"23":"Rut continuó, pues, recogiendo espigas al lado de los trabajadores de Booz hasta que terminó la siega de la cebada y del trigo. Por lo demás, no se separó de su suegra."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Noemí dijo a su nuera: 'Hija mía, ¿no es mi obligación asegurarte un porvenir tranquilo?"
,"2":"Pues bien, Booz, nuestro pariente, con cuya gente has estado trabajando, va a trillar la cebada esta tarde. Tú debes, por lo tanto, hacer lo siguiente:"
,"3":"Lávate, perfúmate, vístete lo mejor que puedas y vete a su era, pero no te dejes ver hasta que haya terminado de comer y beber."
,"4":"Fíjate bien dónde se va a acostar, y cuando ya esté durmiendo, acércate, levanta las mantas que tenga a sus pies y acuéstate allí. El te dirá entonces lo que debas hacer.'"
,"5":"Rut le contestó: 'Haré todo lo que me has dicho.'"
,"6":"Bajó, pues, a la era e hizo todo lo que su suegra le había indicado."
,"7":"Booz, después de una cena bien regada, se fue a acostar muy alegre junto a la parva. Ella, por su parte, caminando despacito, destapó sus pies y se acostó."
,"8":"Como a la medianoche se despertó el hombre y miró con asombro que tenía a sus pies a una mujer."
,"9":"Como le preguntara quién era, ella le respondió: 'Soy Rut, tu sirvienta. Tápame con tu manta, pues tú debes rescatarme.'"
,"10":"'¡Que Yavé te bendiga, hija mía, replicó él, pues este acto tuyo de piedad es mayor que el primero, ya que no has elegido a hombres jóvenes, ricos o pobres!"
,"11":"Quédate tranquila, hija, pues haré todo lo que me pidas, ya que todo el pueblo sabe que tú eres una mujer extraordinaria."
,"12":"Es cierto que a mí me corresponde rescatarte, pero hay otro pariente tuyo más cercano que tiene más obligación."
,"13":"Quédate aquí por esta noche, y mañana veremos si él quiere rescatarte o no. Pues, si él se niega, te lo prometo por Yavé, lo haré yo."
,"14":"Por ahora, sigue durmiendo hasta mañana.',Antes de que amaneciera, cuando todavía no se puede distinguir bien a las personas, se levantó Booz, pues pensaba: 'Nadie debe saber que esta mujer estuvo aquí durmiendo.' "
,"15":"Luego, le pidió a Rut que extendiera su chal y se lo llenó de cebada. Ella se lo echó al hombro y se volvió a la ciudad."
,"16":"Cuando llegó a casa de su suegra, le preguntó: '¿Cómo te ha ido, hija?'"
,"17":"Ella, entonces, le contó todo lo que el hombre había hecho por ella y cómo le había dado toda aquella cebada para que no volviera a su casa con las manos vacías."
,"18":"Noemí replicó: 'Quédate tranquila hasta que veas en qué termina esto, pues estoy segura de que él agotará todos los medios para llevarlo a buen fin hoy mismo.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Booz se sentó al lado de la puerta de la ciudad a esperar que pasara el pariente que debía rescatar a Rut."
,"2":"Cuando pasó lo detuvo y lo invitó a sentarse. Llamó entonces a diez ancianos de la ciudad para que se sentaran también a su alrededor."
,"3":"Cuando todo estuvo listo, le dijo al pariente: 'Noemí, la viuda de nuestro pariente Elimelec, que ha regresado de Moab, quiere vender la propiedad que pertenecía a su marido."
,"4":"Yo he creído conveniente avisarte de esto para que tú la compres en presencia de todos estos testigos. Si tú quieres cumplir con tu obligación de rescatarla, hazlo; si no, dímelo, porque después de ti me toca a mí cumplirlo.' El otro contestó: 'Muy bien, la voy a rescatar.'"
,"5":"Pero Booz prosiguió: 'Hay algo más todavía, pues si adquieres el campo de manos de Noemí, también debes adquirir a Rut, la moabita, que era mujer del difunto, y sus hijos heredarán la parcela del difunto.'"
,"6":"El otro, entonces, respondió: 'Si es así la cosa, no podré hacerlo por temor a perjudicar a mis herederos. Te cedo el derecho, cumple tú con la obligación.'"
,"7":"Era entonces costumbre en Israel que para confirmar cualquier negocio, como rescate o cambio, una de las partes se sacara su sandalia y se la diera al otro. Y este gesto servía como prueba del contrato."
,"8":"Por eso, el pariente que debía comprar la propiedad se sacó la sandalia, diciendo a Booz: 'Cómpratela.'"
,"9":"Al ver esto, Booz dijo a todos los que estaban presentes: 'Ustedes son testigos de que hoy día Noemí me ha vendido todo lo que pertenecía a su marido Elimelec y a sus hijos,"
,"10":"y de que también he adquirido a Rut, la moabita, viuda de Majalón, para conservar el apellido junto con la propiedad del difunto y para que su nombre esté siempre presente entre sus hermanos, cuando se reúnan a la entrada de la ciudad.'"
,"11":"Todos los que se encontraban allí dijeron: 'En efecto, nosotros somos testigos.' Los ancianos, por su parte, agregaron: '¡Que Yavé te conceda que tu mujer sea como Raquel y Lía, las dos que dieron origen a la familia de Israel! ¡Que seas poderoso en Efrata y famoso en Belén!"
,"12":"¡Que, gracias a la descendencia que Yavé te concederá de esta joven, tu casa sea tan célebre como la de Peres, el hijo que Judá tuvo de Tamar!'"
,"13":"Booz se casó, pues, con Rut y se la llevó a su casa. Tuvo relaciones con ella y Yavé permitió que quedara embarazada y que diera luego a luz un niño."
,"14":"Al saberlo, las mujeres felicitaban a Noemí diciéndole: 'Bendito sea Yavé, que no ha permitido que un pariente cercano de un difunto faltase a su deber con éste, sin conservar su apellido en Israel."
,"15":"Este niño será para ti un consuelo y tu sustento en tus últimos años, pues tiene por madre a tu nuera, que te quiere y vale para ti más que siete hijos.'"
,"16":"Noemí se llevó al niño, lo recostó en su falda y se encargó de criarlo."
,"17":"Las vecinas decían: 'A Noemí le ha nacido un hijo.' Y lo llamaron Obed. Obed fue el padre de Jesé y éste padre de David."
,"18":"Estos son los descendientes de Peres. Peres fue padre de Jesrón,"
,"19":"Jesrón de Ram, Ram de Aminadab,"
,"20":"Aminadab de Najsón y Najsón fue padre de Salomón."
,"21":"Salomón fue padre de Booz y éste de Obed."
,"22":"Obed fue padre de Jesé y Jesé fue padre de David."
}`)

}
func ES_LBL_LoadVHTBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Historia de Tobit, hijo de Tobiel, hijo de Ananiel, hijo de Aduel, hijo de Gabael, del clan de Asiel, de la tribu de Neftalí."
,"2":"En tiempos de Salmanasar, rey de Asiria, Tobit fue desterrado de Tisbé, al sur de Cadés-Neftalí (esto está en la Alta Galilea, encima de Jasor, al oeste, hacia el lado del sol poniente y al norte de Sefat)."
,"3":"Yo, Tobit, he andado siempre por los caminos de la verdad. He hecho el bien todos los días de mi vida. He dado muchas limosnas a mis hermanos y a aquellos de mi pueblo que fueron llevados junto conmigo a Nínive, en el país de los Asirios."
,"4":"Cuando yo era todavía joven en mi país, en la tierra de Israel, toda la tribu de Neftalí, mi antepasado, se había separado de la casa de David, mi padre, y de Jerusalén, la ciudad elegida entre todas las tribus de Israel; allí debían ofrecer sus sacrificios todas las tribus. Allí había sido construido y consagrado, para todas las generaciones futuras, el templo donde mora Dios."
,"5":"Pero todos mis hermanos y la casa de Neftalí ofrecían sacrificios al ternero que Jeroboam, rey de Israel, había instalado en Dan; también ofrecían sacrificios en todas las montañas de Galilea."
,"6":"Muchas veces fui solo a Jerusalén para las fiestas, de acuerdo al mandamiento perpetuo que fue redactado para todo Israel. Iba a Jerusalén con las primicias de nuestros frutos y de nuestros animales, el diezmo del ganado y la primera esquila de las ovejas."
,"7":"Allí se las entregaba a los sacerdotes, hijos de Aarón, para el servicio del altar. Daba el diezmo del vino, del trigo, de las aceitunas, de las granadas y de las demás frutas a los Levitas que estaban de servicio en Jerusalén. Durante seis años seguidos reunía en especies un segundo diezmo y cada año iba a distribuirlo en Jerusalén."
,"8":"Daba un tercer diezmo a los huérfanos, a las viudas, a los extranjeros que viven en medio de Israel, y cada tres años les hacía regalos. Con respecto a las comidas, obedecíamos los mandamientos de la Ley de Moisés y las órdenes que nos había dado Débora, la madre de Ananiel, nuestro padre, porque mi padre había muerto y me había dejado huérfano. "
,"9":"Cuando fui hombre, me casé con una mujer de mi familia, y tuve un hijo de ella, al que puse el nombre de Tobías."
,"10":"Cuando se produjo el destierro a Asiria, fui llevado a Nínive. Todos mis hermanos y los de mi pueblo se servían la comida de los paganos,"
,"11":"pero yo me guardé muy bien de comer el alimento de los paganos."
,"12":"Por eso, como yo era fiel a mi Dios desde el fondo de mi corazón,"
,"13":"el Altísimo me concedió que le simpatizara a Salmanasar, quien me hizo su hombre de negocios."
,"14":"Así fue como me trasladé a Media, donde administré sus negocios hasta su muerte. En esa ocasión, deposité en casa de Gabael, hermano de Gabri, en Ragués de Media, varias bolsas que contenían diez talentos de plata."
,"15":"Al morir Salmanasar, le sucedió en el trono su hijo Senaquerib. Se interrumpieron entonces las comunicaciones con Media y no pude volver más allá."
,"16":"En tiempo de Salmanasar, daba con frecuencia limosnas a mis hermanos de raza:"
,"17":"daba mi pan a los que tenían hambre y ropa a los que andaban desnudos. Cuando veía que los cadáveres de mis compatriotas eran lanzados por encima de las murallas de Nínive, yo los enterraba."
,"18":"También enterré a los que mandó matar Senaquerib. Pues éste, después del castigo que le infligió el rey del Cielo por sus blasfemias, salió huyendo de Judea, y a su regreso mandó matar a un gran número de israelitas. Escondía sus cuerpos para sepultarlos, de tal modo que aunque Senaquerib los buscara, no los hallaba."
,"19":"Un habitante de Nínive le informó al rey que era yo quien los enterraba, y por eso debí ocultarme. Pero cuando supe que el rey estaba bien informado de lo que yo hacía, cuando vi que me buscaba para matarme, tuve miedo y huí."
,"20":"Todos mis bienes fueron confiscados por el tesoro real; lo único que me quedó fue mi mujer Ana y mi hijo Tobías."
,"21":"Pero, no habían transcurridos todavía cuarenta días, cuando los dos hijos del rey lo asesinaron y luego salieron huyendo hacia los montes de Ararat. Le sucedió en el trono su hijo Asarjadón, quien encargó a Ajicar, hijo de mi hermano Anael, que llevara la contabilidad del reino y la dirección general de los negocios."
,"22":"Pues Ajicar había sido el copero mayor bajo el reinado de Senaquerib, rey de Asiria, además era el guardián del sello real, administrador y responsable de la contabilidad. Asarjadón lo mantuvo en sus funciones. Como era de mi familia, ya que era mi sobrino, Ajicar intercedió por mí y pude regresar a Nínive."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Bajo el reinado de Asarjadón, volví pues a mi casa y me reuní con mi mujer Ana y con mi hijo Tobías. Para la fiesta de Pentecostés, la fiesta de las Semanas, se hace una gran cena. Me recosté para comer, me acercaron la mesa con muchos platos."
,"2":"Dije entonces a mi hijo Tobías: «¡Hijo mío, anda a ver si encuentras entre nuestros hermanos exiliados en Nínive a algún pobre que se acuerde de Dios con todo su corazón, y tráemelo para que comparta conmigo esta comida. Te esperaré, hijo, hasta que regreses!'"
,"3":"Salió Tobías en busca de un pobre entre nuestros hermanos, y al regresar dijo: «Papá, acaban de asesinar a uno de nuestra raza. Lo estrangularon, lo dejaron tendido en la plaza del mercado y allí está todavía»."
,"4":"Dejé mi comida sin tocarla siquiera; de un salto saqué al hombre de la plaza y lo dejé en una pieza esperando la puesta del sol para enterrarlo."
,"5":"Luego regresé, me lavé y comí mi pan en medio de lágrimas."
,"6":"Me acordé de las palabras del profeta Amós, con respecto a Betel: «Sus fiestas se transformarán en luto y todos sus cantos en lamentaciones»."
,"7":"Lloré y cuando se entró el sol, fui a hacer un hoyo y lo enterré."
,"8":"Mis vecinos decían burlándose: «¿Y todavía no tiene miedo? ¡Ya tuvo que huir una vez, y de nuevo entierra a los muertos!»"
,"9":"Esa noche me di un baño. Salí al patio y me recosté junto a la muralla del patio; como hacía calor, tenía la cara destapada."
,"10":"No sabía que encima de mí, en la muralla, había pájaros; los excrementos calientes cayeron sobre mis ojos y me produjeron unas manchas blancas. Fui a consultar a los médicos, pero mientras más medicinas me aplicaban más crecían las manchas. Estuve cuatro años sin ver; todos mis hermanos estaban afligidos. Pero durante los dos años antes de la partida de Ajicar a Elimaida, él se preocupó de mí."
,"11":"Por ese entonces, mi mujer encontró trabajo: hilaba la lana y recibía madejas para tejer."
,"12":"Cuando entregaba el encargo recibía su paga. Pues bien, el siete del mes de Ditros, terminó una pieza y se la entregó a los clientes; estos le pagaron lo que le debían y le dieron además un cabrito para que se lo comiera."
,"13":"Cuando regresó a casa, el cabrito se puso a balar; entonces llamé a mi mujer y le pregunté: '¿De dónde salió ese cabrito? ¿No ha sido tal vez robado?»"
,"14":"Ella me respondió: 'Es un regalo que me han hecho fuera de mi paga». No quise creerle y le dije que se lo devolviera a sus dueños, porque me avergonzaba de ella. Entonces me respondió: '¿Dónde están ahora tus limosnas y tus buenas obras? ¡Todos saben lo que has ganado con eso!»"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Ese asunto me dio mucha pena. Suspiré y lloré. Oré y me lamenté:"
,"2":"'Señor, tú eres justo y todas tus obras son justas. Tus caminos son misericordia y verdad, tú eres el juez del mundo."
,"3":"¡Ahora, Señor, acuérdate de mí y mírame! No me castigues por mis pecados y mis faltas, ni por los que cometieron mis padres contra ti."
,"4":"Debido a que ellos no obedecieron tus mandamientos, tú nos condenaste al pillaje, al destierro y a la muerte. Somos el blanco de los insultos de todos los paganos entre los que nos has dispersado."
,"5":"Justa es tu sentencia cuando me tratas según mis pecados y según los pecados de mis padres, porque no obedecimos tus mandamientos y no nos portamos correctamente ante ti."
,"6":"Ahora trátame como quieras. Toma mi vida: me gustaría que me sacaras de este mundo y me volvieras al polvo, porque para mí la muerte vale más que la vida. He soportado insultos sin motivo y estoy sumido en una profunda tristeza. Líbrame, pues, Señor, de esta prueba; déjame partir para la morada eterna. No apartes de mí tu mirada, Señor. Es mejor para mí morir que seguir viviendo con un mal incurable»."
,"7":"Ahora bien, ese mismo día Sara, hija de Ragüel, que vivía en Ecbatana de Media, fue insultada por una sirvienta de su padre."
,"8":"Siete veces Sara había sido dada en matrimonio, pero Asmodeo, un demonio malvado, había dado muerte a sus maridos uno tras otro antes que hubiesen podido unirse como buenos esposos. Por eso esa sirvienta le había dicho: '¡Sí, tú eres la que mata a tus maridos! Te han dado ya siete y no te queda ninguno. "
,"9":"Si tus maridos han muerto, no es ese un motivo para que me pegues. ¡Anda mejor a buscarlos y que nunca tengas ni hijo ni hija!»"
,"10":"Ella se entristeció mucho ese día; se puso a llorar y se dirigió a la pieza de su padre con la intención de ahorcarse. Pero luego reflexionó y se dijo: 'Seguramente criticarán a mi padre, diciéndole: No tenías más que una hija regalona y se ahorcó de pena. ¡No! No quiero enlutar de ese modo los últimos días de mi padre. En vez de ahorcarme, debiera suplicarle al Señor que me haga morir antes que vivir siendo insultada a cada momento»."
,"11":"Inmediatamente extendió los brazos hacia la ventana y se puso a orar: '¡Tú eres bendito, Dios lleno de misericordia, que tu nombre sea bendito por los siglos y que todas tus obras te bendigan eternamente!"
,"12":"Mira como levanto mi rostro y dirijo mis ojos hacia ti."
,"13":"Manda que deje esta tierra para que no sea más insultada."
,"14":"Señor, tú lo sabes, yo soy pura y ningún hombre me ha tocado."
,"15":"No he deshonrado mi nombre ni el de mi padre en esta tierra de exilio. Soy la hija única de mi padre, no tiene hijos que lo hereden, ni tampoco un hermano cerca de él, o algún pariente para quien yo pudiera guardarme. ¿Para qué seguir viviendo cuando ya he perdido siete maridos? Si no quieres mandarme la muerte, mírame con piedad para que no vuelvan a insultarme»."
,"16":"Las oraciones de uno y otra llegaron al mismo tiempo al Dios de la Gloria,"
,"17":"y Rafael fue enviado para sanar a los dos. Debía quitar las manchas blancas de los ojos de Tobit, para que viera con sus ojos la luz de Dios, y debía lograr que Sara, hija de Ragüel, se casara con Tobías, hijo de Tobit y se viera libre de Asmodeo, el malvado demonio. (Conviene precisar que antes que a cualquier otro pretendiente ella correspondía por derecho a Tobías). En ese preciso momento, Tobit dejaba el patio para entrar en la casa y Sara, hija de Ragüel, bajaba de su pieza."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ese día Tobit se acordó del dinero que había dejado en casa de Gabael, en Ragués de Media."
,"2":"Se dijo: 'Si en realidad he pedido que me muera, debería llamar a mi hijo Tobías y hablarle de esa suma antes de morir»."
,"3":"Llamó pues a su hijo Tobías y le dijo: 'Cuando haya muerto, hazme un entierro conveniente. Honra a tu madre y no la abandones un solo día de tu vida. Haz lo que te mande y no le des ningún motivo para que se entristezca."
,"4":"Acuérdate, hijo mío, de los peligros que corrió por ti cuando todavía estabas en su seno, y cuando haya muerto, entiérrala a mi lado en la misma tumba."
,"5":"Hijo mío, sé fiel al Señor todos los días; no peques ni desobedezcas sus leyes. Haz el bien todos los días de tu vida y no andes por los caminos de la injusticia."
,"6":"Si actúas con rectitud, te irá bien en todo lo que hagas, como a todos los que practican la justicia."
,"7":"Separa una parte de tus bienes para dar limosna, no des vuelta la cara frente a un pobre y Dios tampoco te dará vuelta su cara."
,"8":"Da generosamente. Si tienes mucho, da más, si tienes poco, da menos; pero no vaciles en dar limosna."
,"9":"Así te prepararás un buen tesoro para cuando tengas necesidad."
,"10":"Porque la limosna libra de la muerte e impide que uno caiga en las tinieblas."
,"11":"La limosna es una ofrenda de gran valor para todos los que la hacen bajo la mirada del Altísimo."
,"12":"Abstente, hijo mío, de cualquier mal comportamiento. Elige una esposa en la familia de tus padres, no tomes como esposa a una mujer extranjera, porque somos hijos de profetas. Acuérdate de Noé, Abrahán, Isaac y Jacob que fueron nuestros padres desde nuestros comienzos. Todos eligieron una esposa entre su parentela y fueron bendecidos en sus hijos; su raza recibió como herencia la tierra."
,"13":"Por eso tú también, hijo mío, prefiere a tus hermanos; no menosprecies a tus hermanos, a los hijos y a las hijas de tu pueblo, y elige entre ellos a tu esposa. Así como el orgullo acarrea la ruina, de igual modo la pereza trae consigo la miseria, ya que la pereza es la madre del hambre."
,"14":"No dejes para el día siguiente el pago de tus obreros, sino que dáselo inmediatamente. Si sirves a Dios, serás recompensado. Sé responsable, hijo mío, de todo lo que hagas y actúa siempre con corrección."
,"15":"No hagas a los demás lo que no te gustaría para ti. No tomes vino hasta embriagarte ni hagas de las juergas la compañera de tu vida."
,"16":"Comparte tu pan con los que tienen hambre y tu ropa con los que andan desnudos. Da generosamente de todo lo que tengas en abundancia y que no te pese dar limosnas."
,"17":"Reparte generosamente el pan y el vino en los funerales de los justos, pero no des al pecador."
,"18":"Haz caso a los consejos de las personas mayores y no desprecies nunca un buen consejo."
,"19":"Bendice al Señor Dios a cada momento, pídele que guíe tus pasos y que resulten tus obras y tus proyectos. La sabiduría del mundo no llega muy lejos, el Señor es quien da la prosperidad; si él lo quiere eleva a alguien o lo rebaja hasta la morada de los muertos. Recuerda ahora, hijo mío, estos mandamientos y no dejes que se borren de tu corazón."
,"20":"Has de saber, hijo mío, que dejé depositados diez talentos de plata en casa de Gabael, hijo de Gabri, en Ragués de Media."
,"21":"Pero no te preocupes, hijo mío, porque nos hemos vuelto pobres: tú poseerás una gran riqueza si temes a Dios, si evitas cualquier pecado y si haces lo que agrada al Señor tu Dios»."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Entonces Tobías le respondió a su padre Tobit: 'Papá, haré todo lo que me ordenas."
,"2":"Pero, ¿cómo voy a recuperar ese depósito? Gabael no me conoce ni yo tampoco a él. ¿Qué prueba le daré para que me crea y me entregue ese dinero? Además, tampoco conozco el camino para ir a Media»."
,"3":"Tobit le respondió: 'Los dos pusimos nuestra firma en un recibo y yo lo partí en dos para que cada uno guardara una mitad. Me quedé con una y dejé la otra con el dinero cuando hice el depósito hace veinte años. Ahora, hijo mío, búscate a un hombre serio como compañero de tu viaje: nosotros le pagaremos hasta su vuelta. Y después anda a buscar ese dinero donde Gabael»."
,"4":"Salió pues Tobías a buscar a un buen guía que pudiera acompañarlo a Media. Se encontró afuera con el ángel Rafael que venía hacia él, pero no sabía que era un ángel de Dios."
,"5":"Le dijo: '¿De dónde eres, amigo?» El ángel le respondió: 'Soy uno de tus hermanos israelitas y he llegado hasta acá en busca de trabajo». Tobías le dijo: '¿Conoces el camino para ir a Media?»"
,"6":"El ángel le respondió: '¡Por supuesto! He ido allá varias veces, conozco perfectamente todos los caminos. He estado con frecuencia en Media, me he alojado en casa de Gabael, uno de nuestros hermanos que vive en Ragués de Media. Hay que caminar dos días de Ecbatana a Ragués. Ragués está en la montaña y Ecbatana en la planicie."
,"7":"Tobías le dijo: 'Espérame un momento, que voy a avisarle a mi padre. Tú vas a venir conmigo y yo te pagaré tu jornal»."
,"8":"El otro respondió: '¡Muy bien, te esperaré, pero no te demores!»"
,"9":"Fue Tobías a decirle a su padre que había encontrado a alguien entre sus hermanos de Israel. Su padre le dijo: 'Preséntamelo para que yo sepa cuál es su familia y su tribu. Hay que ver si podemos confiar en él para que te acompañe, hijo mío». Salió pues Tobías a hablarle: '¡Eh, amigo, mi padre te necesita!»"
,"10":"Entró el ángel en la casa, Tobit saludó primero y el otro le respondió deseándole felicidad. Tobit le dijo: '¿Disfrutaré de nuevo de la felicidad? Soy ciego. Ya no veo la luz del cielo, y vivo sumergido en la noche como los muertos que no ven más la luz. Soy un muerto en vida, oigo la voz de las personas sin verlas». El ángel le dijo: 'Ten confianza. Dios te va a sanar pronto. Ten confianza». Tobit le dijo: 'Mi hijo Tobías quiere ir a Media. ¿Aceptarías servirle de guía? Yo te pagaré, hermano. Respondió: 'Por supuesto que quiero acompañarlo, conozco todos los caminos. He ido con frecuencia a Media, he atravesado las llanuras y los montes y conozco todos los senderos»."
,"11":"Tobit le dijo: 'Hermano mío, ¿de qué familia y de qué tribu eres tú? ¡Me quieres decir, hermano!»"
,"12":"El otro le preguntó: '¿Por qué te interesa mi tribu?» Tobit insistió: 'Porque quiero saber de quién eres hijo y cuál es tu nombre»."
,"13":"El otro respondió: 'Yo soy Azarías, hijo de Ananías el Grande, uno de tus hermanos»."
,"14":"Entonces Tobit le dijo: 'Bienvenido seas, hermano mío, no te enojes porque quise conocer tu familia. Resulta que eres mi pariente de buena y linda descendencia. Conocí a Ananías y a Natán, hijos de Semeías el Grande. Iban conmigo a Jerusalén, allí adorábamos juntos y nunca dejaron el buen camino. Tus hermanos son hombres de bien, tú eres de una buena familia; bienvenido»."
,"15":"Agregó: 'Te contrato por un dracma al día y para mantenerte dispondrás de lo que le dé a mi hijo. Acompaña a mi hijo,"
,"16":"y hasta te pagaré más de lo pactado». El ángel respondió: 'Haré el viaje con él, no temas: iremos y volveremos sanos y salvos. Además, el camino es seguro»."
,"17":"Tobit le dijo: '¡Bendito seas, hermano mío!» Luego se dirigió a su hijo: 'Hijo mío, le dijo, prepara lo que vas a necesitar para el viaje, y luego márchate con tu compañero. ¡Que el Dios que está en los cielos los guarde a ustedes allá abajo y los traiga de vuelta hasta mí con buena salud. Que su ángel les acompañe con su protección, hijo mío!»,Cuando llegó el momento de dejar la casa para emprender el viaje, Tobías abrazó a su padre y a su madre. Tobit le dijo: '¡Que tengan buen viaje!» "
,"18":"pero su madre se puso a llorar; le dijo a Tobit: '¿Por qué has consentido que se vaya mi hijo, siendo que él es el bastón de nuestra vejez y el que se preocupa en todo de nosotros?"
,"19":"¿Para qué tener dinero? El dinero es nada en comparación con nuestro hijo."
,"20":"¡Teníamos bastante con lo que Dios nos daba para vivir!"
,"21":"Entonces Tobit le dijo: '¡Tú te imaginas cosas! Nuestro hijo se va con buena salud y volverá del mismo modo a casa."
,"22":"Lo acompañará un buen ángel, hará un buen viaje y volverá sano y salvo.»"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Ella dejó de llorar."
,"2":"El joven se fue con el ángel y detrás lo seguía su perro. Caminaron juntos y al cabo del primer día acamparon a orillas del Tigris."
,"3":"El joven bajó al río para lavarse los pies, pero un gran pez salió del agua y casi le devora el pie. El joven se puso a gritar,"
,"4":"pero el ángel le dijo: '¡Péscalo, no lo dejes escapar!» El joven agarró al pez y lo lanzó a la orilla."
,"5":"El ángel le dijo: 'Abrelo, sácale la hiel, el corazón y el hígado y ponlos aparte antes de tirar las tripas. Pues, en realidad, son remedios muy útiles»."
,"6":"El joven abrió el pescado y le sacó la hiel, el corazón y el hígado. Coció un trozo de pescado para comérselo y guardó el resto para salarlo. Luego continuaron juntos su camino hasta Media."
,"7":"Entonces el joven preguntó al ángel: 'Hermano Azarías, ¿para qué sirven como remedio el corazón, la hiel y el hígado del pescado?»"
,"8":"Respondió: 'El corazón y el hígado del pescado se queman delante de un hombre o de una mujer atormentados por un demonio o un mal espíritu, y cualquier mal desaparece completamente sin dejar huella."
,"9":"La hiel sirve para curar los ojos cuando hay manchas en ellos. Basta con soplarla sobre las manchas para que desaparezcan."
,"10":"Ya habían entrado a Media y se aproximaban a Ecbatana,"
,"11":"cuando Rafael dijo al joven: '¡Hermano Tobías!» Este respondió: '¿Qué quieres?» El ángel le dijo: 'Esta noche vamos a alojarnos en casa de tu pariente Ragüel; es de tu familia y tiene una hija llamada Sara."
,"12":"Fuera de Sara no tiene hijo ni hija, y tú eres su pariente más cercano. Ella te corresponde a ti por derecho propio y tú además tienes derecho a la herencia de su padre. Es una buena hija, valiente, muy linda y su padre la quiere mucho»."
,"13":"El ángel continuó: 'Tú tienes que casarte con ella. ¡Escúchame, hermano! Esta noche hablaré de ella a su padre, para que sea inmediatamente tu novia, y cuando volvamos de Ragués, haremos el casamiento. Te aseguro que Ragüel no tiene ningún derecho a negártela o a dársela a otro. Si así fuere, de acuerdo a la ley de Moisés, merecería la muerte apenas supiera que tú tienes la prioridad sobre cualquiera en la familia para casarte con su hija. Haz, pues, hermano lo que te digo."
,"14":"Tobías respondió a Rafael: 'Hermano Azarías, me han dicho que ella se casó siete veces y que sus maridos murieron uno tras otro la misna noche de bodas, cuando se acercaban a ella. Y oí decir que era un demonio quien les daba muerte."
,"15":"¡Tengo miedo! A ella el demonio no le hace nada porque la quiere, pero al que intenta acercarse a ella le da muerte. Ahora bien, yo soy el hijo único de mi padre, ¿quieres que muera y que mi padre y mi madre arrastren esa pena hasta su tumba? No tendrán otro hijo que los entierre»."
,"16":"El ángel respondió: '¿Te olvidas de las recomendaciones de tu padre? El te recomendó que te buscaras una esposa entre la familia de tu padre. Pues bien, escúchame, hermano, no te preocupes por ese demonio, y cásate con ella; te prometo que esta misma noche será tu esposa."
,"17":"Pero cuando entres en la pieza, toma el hígado y el corazón del pescado y ponlos en las brasas del pebetero. El olor se extenderá,"
,"18":"y apenas lo sienta el demonio, saldrá huyendo. No lo volverán a ver nunca más cerca de la joven. Luego, cuando llegue el momento de consumir el matrimonio, pónganse, primero, los dos a orar: pídanle al Señor del Cielo que les dé su gracia y su protección. No temas, pues ha estado reservada para ti desde siempre y tú eres quien la va a salvar. Ella te seguirá y te dará hijos que serán como hermanos para ti.»"
,"19":"Al oír las palabras de Rafael, Tobías entendió que Sara era su hermana, una pariente de la familia de su padre y se enamoró de tal manera de ella que no dejaba de pensar en ella."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Al llegar a Ecbatana, Tobías dijo a Azarías: 'Llévame inmediatamente a casa de nuestro hermano Ragüel. Lo llevó a la casa de Ragüel, quien estaba sentado cerca de la puerta del patio. Lo saludaron y él respondió: 'Buenas tardes, hermanos, bienvenidos a mi casa». Y los hizo pasar a la casa. "
,"2":"Dijo a su mujer Edna: '¡Que se parece este joven a mi hermano Tobit!»"
,"3":"Edna les preguntó: '¿De dónde son ustedes, hermanos?» Respondieron: 'Somos hijos de Neftalí, desterrados a Nínive»."
,"4":"Ella les dijo: '¿Conocen a nuestro hermano Tobit?» 'Por supuesto», dijeron ellos."
,"5":"Entonces ella añadió: '¿Cómo está?» 'Está bien, respondieron, y Tobías agregó: 'Es mi padre»."
,"6":"Ragüel se levantó inmediatamente, lo abrazó y se puso a llorar."
,"7":"Luego le dijo: 'Bendito seas, hijo mío, tu padre es un hombre bueno y excelente. ¡Qué pena que un hombre tan bueno y tan generoso haya quedado ciego!» Se echó al cuello de Tobías y seguía llorando; su mujer Edna y su hija Sara lloraban también."
,"8":"En seguida mandó matar un cordero de su rebaño y preparó una buena cena."
,"9":"Entonces Tobías dijo a Rafael: 'Hermano Azarías, ¿y si le pido ahora a Ragüel que me dé a mi hermana Sara?»"
,"10":"Al oír esas palabras, Ragüel dijo al joven: 'Come y bebe. No eches a perder esta velada, nadie más que tú tiene derecho a casarse con mi hija Sara, hermano mío. Yo no soy libre de dársela a otro ya que tú eres nuestro pariente más cercano. Ahora, hijo mío, te hablaré francamente."
,"11":"Se la di sucesivamente a siete de nuestros hermanos, y todos murieron la primera noche cuando se acercaron a ella. Por ahora, hijo mío, come y bebe. El Señor te concederá su gracia y su paz»."
,"12":"Pero Tobías exclamó: '¡No comeré ni beberé mientras no hayas arreglado este asunto!» Ragüel respondió: '¡Muy bien! Ya que según la ley de Moisés te pertenece, el Cielo ha decidido dártela; recibe pues a tu hermana. En adelante tú serás su hermano y ella, tu hermana, te la doy ahora para siempre. El Señor del Cielo vendrá a ayudarlos esta noche, hijo mío, y les dará su gracia y su paz»."
,"13":"Ragüel llamó a su hija Sara; le tomó la mano y la puso en la de Tobías, diciendo: 'Recíbela según la Ley y los decretos escritos en el libro de Moisés, quien te la da como esposa. Tómala, que llegue felizmente contigo a la casa de tu padre. Que el Dios del Cielo les conceda que tengan un buen viaje sin incidentes»."
,"14":"Se dirigió luego a la madre y le pidió que fuera a buscar una hoja de papiro para escribir. Redactó luego el contrato de matrimonio y lo firmaron. Después de eso, se pusieron a la mesa, comieron y bebieron. "
,"15":"Ragüel llamó a su mujer Edna y le dijo: 'Hermana, prepara la segunda pieza a donde la llevarás»."
,"16":"Ella se fue a hacer la cama del dormitorio, como se lo había pedido, y llevó allá a su hija. Luego se puso a llorar sobre ella y enjugándose las lágrimas, decía:"
,"17":"'¡Ten confianza, hija mía! ¡Que el Señor del Cielo cambie tu pena en alegría! ¡Ten confianza, hija mía!» Y se retiró."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Cuando se hubo terminado la cena, hablaron de ir a acostarse. Llevaron al joven desde el comedor al dormitorio."
,"2":"Tobías se acordó de los consejos de Rafael; tomó su bolso, sacó de él el corazón y el hígado del pescado y los puso sobre las brasas del pebetero."
,"3":"El demonio salió huyendo intoxicado a través del aire hasta arribar a las mesetas de Egipto. Rafael lo persiguió, lo capturó y en seguida lo amarró."
,"4":"Los padres, sin embargo, habían salido y cerrado la puerta. Tobías se levantó de la cama y dijo a Sara: 'Levántate, hermana mía. Oremos los dos, supliquémosle a nuestro Señor para obtener su gracia y su protección». "
,"5":"Ella se levantó y juntos se pusieron a orar por su salvación: 'Bendito eres, Dios de nuestros padres y bendito sea tu Nombre por los siglos de los siglos. ¡Los cielos y todas las criaturas te bendigan de siglo en siglo! "
,"6":"Tú creaste a Adán, tú creaste a Eva, su mujer, para que fuera su compañera y su ayuda, y de ambos nació toda la raza humana. Tu dijiste: No es bueno que el hombre esté solo, hagámosle una compañera semejante a él."
,"7":"Ahora no he buscado el placer al casarme con esta hermana, lo hago con un corazón sincero. Ten piedad de ella y de mí y llévanos juntos hasta la vejez»."
,"8":"Terminaron diciendo juntos: '¡Amén, Amén!»"
,"9":"Luego se acostaron para pasar la noche. Ragüel estaba en pie. Había llamado a sus sirvientes y había salido con ellos a cavar una tumba. "
,"10":"Se decía: 'Si por casualidad muere, no es necesario que nos veamos cubiertos de confusión y vergüenza»."
,"11":"Luego Ragüel volvió a casa y llamó a su mujer."
,"12":"Le dijo: 'Manda una sirvienta a la pieza para ver si Tobías está vivo. Si ha muerto, lo enterraremos sin que nadie lo sepa»."
,"13":"Mandaron a la sirvienta, la que encendió una lámpara y abrió la puerta. Entró y halló a los dos acostados y durmiendo."
,"14":"Salió y les hizo una seña de que estaba vivo."
,"15":"Entonces Ragüel bendijo al Dios del Cielo: '¡Oh Dios, tú mereces todas las santas bendiciones! ¡Que todos los siglos te bendigan!"
,"16":"Bendito seas porque me has llenado de alegría. Lo que yo temía no ocurrió, tú actuaste con nosotros con una inmensa bondad."
,"17":"Bendito seas tú, que tuviste piedad de estos dos hijos únicos. Señor, dales tu gracia y tu salvación. ¡Que toda su vida transcurra en la felicidad y en tu gracia!"
,"18":"Antes que despuntara el día, Ragüel había ordenado a sus sirvientes que rellenaran la tumba."
,"19":"Después dijo a su mujer que hiciera una hornada de pan y él fue al establo, laceó a dos bueyes y a cuatro corderos y pidió a la gente de la cocina que los mataran y los prepararan."
,"20":"Luego mandó llamar a Tobías y le dijo: 'No te vayas de aquí antes de dos semanas, comerás y beberás en mi casa. Mi hija ha tenido demasiadas pruebas, tú puedes muy bien darle un poco de felicidad."
,"21":"Después te llevarás de aquí la mitad de mis bienes y regresaras sin problemas a casa de tu padre. Cuando yo y mi mujer hayamos muerto, la otra mitad será para ustedes. ¡Confianza, hijo mío! Ahora yo soy tu padre, y Edna, tu madre. En adelante estaremos a tu lado como lo estamos con tu hermana. ¡Confianza, hijo mío!»"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Entonces Tobías dijo a Rafael:"
,"2":"'Hermano Azarías, toma a cuatro sirvientes y dos camellos y anda a Ragués."
,"3":"Irás a casa de Gabael, le darás el recibo y recogerás el dinero; luego lo traerás a él contigo al casamiento."
,"4":"Tú sabes que mi padre está contando los días y que cada día de demora aumenta su preocupación."
,"5":"Tú ves como Ragüel ha insistido: no me puedo librar de su juramento». Salió Rafael para Ragués de Media junto con los cuatro sirvientes y los dos camellos, y se alojaron en la casa de Gabael. Rafael le presentó el recibo. También le comunicó que Tobías, hijo de Tobit, se casaba y que lo invitaba a su casamiento. Gabael contó los sacos que todavía estaban con su sello; los cargaron en los camellos "
,"6":"y partieron juntos para el casamiento. Al llegar a casa de Ragüel, encontraron a Tobías que estaba a la mesa. Se levantó y lo saludó. Gabael lloró y lo bendijo: 'Tú eres el hijo excelente de un padre bueno, justo y generoso. Que el Señor te bendiga de lo alto del Cielo, tanto a ti y a tu mujer como al padre y a la madre de tu esposa. ¡Bendito sea Dios! Acaba de permitirme que vea el vivo retrato de mi primo Tobit»."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Durante ese tiempo, Tobit llevaba la cuenta de los días. Calculaba el tiempo que se necesitaba para ir y volver, y cuando pasó el tiempo sin que su hijo volviera,"
,"2":"pensó: '¡Ojalá no lo hayan retenido allá abajo! ¡Ojalá que Gabael no haya muerto! A lo mejor no había nadie que le entregara el dinero."
,"3":"Comenzó a preocuparse."
,"4":"Su mujer Ana decía: '¡Perdí a mi hijo! ¡Ya no está más entre los vivos!» Y se ponía a llorar y a lamentarse por su hijo:"
,"5":"'¡Qué desgracia! ¿Por qué permití que te fueras, hijo mío? Tú eras la luz de mis ojos»."
,"6":"Tobit le respondía: '¡Cálmate, hermana! ¡No te metas esas malas ideas en la cabeza! Seguramente está bien, pero se habrán retardado allá abajo. Su compañero es una persona de confianza, es un hermano. No te preocupes, hermana mía, va a volver de un momento a otro»."
,"7":"Pero ella respondía: '¡Déjame! ¡No me cuentes historias, mi hijo está muerto!» Y todos los días salía a mirar el camino por donde se había ido su hijo; ya no tenía confianza en nadie. Y cuando se ponía el sol, se volvía a su casa, y lloraba y se lamentaba toda la noche sin poder dormir. Al cabo de los catorce días de bodas que Ragüel había jurado hacerle a su hija, Tobías le dijo: 'Déjame partir, mi padre y mi madre deben estarse preguntando si me volverán a ver. Por favor, padre, déjame volver a casa de mi padre; ya te he dicho en qué estado lo dejé'. "
,"8":"Ragüel dijo a Tobías: 'Quédate todavía un poco más conmigo, hijo mío. Mandaré mensajeros a tu padre Tobías para darle tus buenas noticias'."
,"9":"Pero Tobías insistió: 'No, te pido que me dejes regresar a casa de mi padre'."
,"10":"En vista de eso Ragüel le entregó a su esposa Sara, y le pasó a Tobías la mitad de sus bienes en sirvientes y sirvientas, en bueyes, ovejas, burros y camellos, en ropas, en dinero y en toda clase de artículos."
,"11":"Hizo que se fueran en las mejores condiciones, dirigiendo a Tobías estas palabras de adiós: 'Ten buena salud, hijo mío, y buen viaje. ¡Que el Señor del Cielo esté contigo y con tu mujer Sara! Espero ver a los hijos de ustedes antes de morir!'"
,"12":"Y a su hija le dijo: 'Anda a la casa de tu suegro, ya que en adelante serán tus padres igual como los que te dieron a luz. Anda en paz, hija mía. Estoy seguro que sólo oiré hablar bien de ti mientras viva'. Se despidió de ellos y dejó que se fueran. Por su parte Edna dijo a Tobías: 'Hijo y hermano muy querido, que el Señor te acompañe. Quiero ver a los hijos de ustedes, a ti y a mi hija Sara, antes de morir. Ante el Señor te confío a mi hija. No le causes pena mientras viva. Anda en paz, hijo mío. En adelante yo seré tu madre y Sara, tu hermana. Que la vida de todos nosotros se desenvuelva sin problemas hasta el fin'. Los abrazó y dejó que se fueran acompañados de sus deseos de felicidad."
,"13":"Tobías se fue de la casa de Ragüel feliz y contento. Bendecía al Señor del cielo y de la tierra, al rey del universo por el buen éxito de su viaje. También bendijo a Ragüel y a su mujer Edna: '¡Señor, cuídalos todos los días de su vida!'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Cuando llegaron a Caserim, frente a Nínive,"
,"2":"Rafael dijo: 'Sabes muy bien el estado en que dejamos a tu padre."
,"3":"Adelantémonos a tu mujer, y vayamos a preparar la casa para cuando ellos lleguen'."
,"4":"Los dos se fueron adelante; le había recomendado mucho que llevara la hiel, y el perro los seguía."
,"5":"Ana estaba sentada, miraba el camino por donde debía venir su hijo."
,"6":"De repente tuvo un presentimiento y le dijo al padre: '¡Mira, ahí viene tu hijo con su compañero!'"
,"7":"Rafael había dicho a Tobías antes que se reuniera con su padre: 'Te prometo que los ojos de tu padre se abrirán."
,"8":"Le aplicarás en los ojos la hiel del pescado. El remedio le hará efecto y tú le retirarás de los ojos como una telita blanca. Entonces tu padre recuperará la vista y verá la luz'."
,"9":"La madre fue a echarse al cuello de su hijo: 'Ahora, decía ella, puedo morir porque te he recuperado'. Y lloraba."
,"10":"Tobit se levantó y caminando a tropezones logró llegar a la puerta del patio. Tobías corrió donde él;"
,"11":"llevaba en la mano la hiel del pescado y le dijo: '¡Ten confianza, papá!' Luego le aplicó el remedio y lo dejó un tiempo."
,"12":"En seguida, con cada mano, le quitó una débil tela del extremo de los ojos."
,"13":"Entonces su padre se echó a su cuello,"
,"14":"llorando y exclamando: '¡Te veo, hijo mío! ¡Tú eres la luz de mis ojos!' Y añadió: '¡Bendito sea Dios!,¡Bendito sea su santo Nombre!,¡Benditos sean todos sus santos ángeles!,¡Bendito sea su Gran Nombre, por los siglos de los siglos!"
,"15":"Porque me había castigado, pero tuvo piedad de mí, y hoy día veo a mi hijo Tobías'. Tobías entró en la casa. Muy feliz bendecía a Dios en alta voz; luego contó su viaje a su padre: le traía el dinero, se había casado con Sara, hija de Ragüel, que venía detrás de él y que ya no estaba lejos de las puertas de Nínive."
,"16":"Tobit se dirigió a las puertas de Nínive para encontrarse con su nuera, y en su alegría alababa a Dios. Cuando los habitantes de Nínive lo vieron caminando sin que nadie lo llevara de la mano, y avanzando a paso firme como antes, se quedaron maravillados."
,"17":"Entonces, ante ellos, Tobit proclamó que Dios había tenido piedad de él y que le había abierto los ojos. Luego Tobit se acercó a Sara, la mujer de su hijo Tobías, y la bendijo: '¡Bienvenida, hija mía! ¡Bendito sea Dios que te hizo venir a nuestra casa, hija mía! ¡Bendito sea tu padre, bendito sea mi hijo Tobías, bendita seas tu, hija mía; que el arribo a tu casa traiga la alegría y bendición. Entra hija mía'. Ese día se hizo una fiesta para todos los judíos de Nínive,"
,"18":"y los primos de Tobías, Ajicar y Nadab fueron a compartir su alegría."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Al final del banquete de bodas, Tobit llamó a su hijo Tobías y le dijo: 'Hijo mío, tenemos que arreglar cuentas con tu compañero. Aumentarás el precio convenido'."
,"2":"Tobías preguntó: 'Papá, ¿cómo podría pagarle por sus servicios? Aunque le diera la mitad de los bienes que trajo conmigo, no sería suficiente."
,"3":"Me devuelve sano y salvo, sanó a mi mujer, trae conmigo el dinero, y por último te sanó'. ¿Cómo hablar de un sueldo después de todo eso?'"
,"4":"Tobit respondió: 'Sería justo que se quedara con la mitad de lo que trajo'."
,"5":"Tobías llamó pues a su compañero y le dijo: 'Quédate con la mitad de lo que has traído, ese será el pago de tus servicios, y luego te irás en paz'."
,"6":"Entonces Rafael llevó a los dos aparte y les dijo: '¡Bendigan a Dios! ¡Celébrenlo en medio de todos los seres vivientes por los favores que les hizo! ¡Bendigan y canten su nombre! ¡Procuren que todos conozcan las obras de Dios como se lo merecen, y no dejen de darle gracias!"
,"7":"Es bueno guardar el secreto del rey, pero es muy recomendable revelar y publicar las maravillas de Dios. Agradézcanle como corresponde. Hagan el bien y no conocerán la desgracia. "
,"8":"Más vale la oración y el ayuno, la limosna y la justicia que la riqueza con injusticia; más vale tener poco y ser justo que tener mucho siendo pecador."
,"9":"La limosna libra de la muerte, purifica de cualquier pecado; los que dan limosna tendrán larga vida,"
,"10":"los que cometen el pecado y la maldad, atentan contra su vida."
,"11":"Les voy a decir toda la verdad y no les ocultaré nada. Ya les dije que es bueno guardar el secreto del rey y que es recomendable revelar las maravillas de Dios."
,"12":"Sepan, pues, que cuando ustedes, tú y Sara, estaban orando, yo fui quien presentó su oración delante de la Gloria del Señor. Y cuando tú enterrabas a los muertos, yo también estaba contigo."
,"13":"Después no dudaste en levantarte de la mesa para ir a enterrar a un muerto y fue entonces que me enviaron para probar tu fe."
,"14":"Y de nuevo me envió Dios para sanarte y para sanar al mismo tiempo a tu nuera Sara."
,"15":"Yo soy Rafael, uno de los siete ángeles servidores del Señor que en cualquier momento tienen acceso a su Gloria'."
,"16":"Entonces, llenos de temor, se postraron en el suelo."
,"17":"Pero él les dijo: '¡No tengan miedo. La paz sea con ustedes, bendigan siempre a Dios!"
,"18":"Yo no les he hecho ningún favor, fue por voluntad de Dios que los acompañé. A él pues deben bendecir todos los días de su vida, a él deben cantarle."
,"19":"Ustedes me veían comer, pero eran sólo apariencias."
,"20":"Bendigan pues al Señor, ustedes que están en la tierra, y denle gracias a Dios mientras subo a donde el que me envió. Pongan por escrito todo lo que ha pasado'. Entonces Rafael se elevó."
,"21":"Cuando se pararon, ya no lo vieron. Alabaron a Dios con cánticos, agradeciéndole de que hubiera realizado tales maravillas: ¡Sí, se les había aparecido un ángel de Dios!"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Tobías dijo: Bendito sea Dios que vive para siempre. Su reinado permanece por los siglos."
,"2":"Una vez corrige y otra, perdona. Hace bajar a la morada de los muertos,y hace subir de allí, nadie puede escaparse de su mano."
,"3":"Hijos de Israel, celébrenlo,en medio de las naciones donde los dispersó,"
,"4":"y muéstrenles todo su poder. ¡Canten su grandeza ante todos los vivos!,¡El es nuestro Señor y nuestro Dios, nuestro padre por los siglos de los siglos!"
,"5":"Si nos corrige por nuestros pecados, tendrá también compasión de nosotros. Nos reunirá de entre todas las naciones,entre las cuales nos había dispersado."
,"6":"Vuelvan a él de todo corazón, y actúen con plena verdad delante de él; entonces se volverá a ustedes,y no les ocultará más su cara."
,"7":"Vean lo que ha hecho por ustedes,y en alta voz denle gracias. ¡Bendigan al Señor porque es justo!,¡Cántenle al Rey de los siglos!"
,"8":"Quiero celebrarlo en esta tierra de exilio, contar al pueblo pecador su fuerza y su grandeza. Arrepiéntanse pecadores, hagan el bien delante de él: a lo mejor los mirará con bondad."
,"9":"Canto a Dios, y exulta mi alma pensando en el Rey del Cielo. ¡Todos en Jerusalén canten su grandeza!"
,"10":"Jerusalén, Ciudad Santa, Dios castigará los crímenes de tus hijos, pero luego tendrá piedad de los hijos de los justos."
,"11":"¡Da gracias, da gracias al Señor!,¡Bendice al Rey de los siglos!,¡Levántese nuevamente en ti su tienda con alegría!"
,"12":"Haga de ti la alegría de los desterrados, y ame por medio de ti a todos los desgraciados, por generaciones y generaciones."
,"13":"Numerosos pueblos vendrán de lejos, llegarán de todos los rincones del mundo, con las manos cargadas de presentes para el Rey del Cielo. Tú serás la alegría para todas las generaciones."
,"14":"¡Malditos sean los que te odian, pero sean benditos para siempre los que te aman!"
,"15":"Conocerás la alegría y la dicha,cuando en torno a ti se reúnan los hijos de los justos,para bendecir allí al Señor de los justos."
,"16":"Dichosos los que te aman,porque se alegrarán al verte prosperar. Felices los que lloraban cuando eras castigada,porque se alegrarán al contemplar tu gloria. ¡Alma mía, bendice al Señor, al Gran Rey"
,"17":"porque Jerusalén es reconstruida,con zafiros y esmeraldas!,Todas sus murallas serán de piedras preciosas, sus torres y sus baluartes de oro macizo. ¡Jerusalén! Caminarán por tus calles,por sobre un pavimento de rubíes, de piedras de Ofir. ¡Jerusalén! Tus puertas resonarán,con cánticos de alegría!"
,"18":"En todas tus callejuelas se oirá el Aleluya, cantarán: ¡Bendito sea el Dios de Israel!,¡En ti bendecirán el santo Nombre, por los siglos de los siglos!'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Tobit murió en paz a la edad de ciento doce años y lo enterraron solemnemente en Nínive."
,"2":"Tenía ya sesenta y dos años cuando quedó ciego; después de su curación vivió en la abundancia, dando limosnas. No dejaba de bendecir a Dios y de celebrar su grandeza."
,"3":"Cuando estaba a punto de morir, pidió que se acercara su hijo Tobías y le dio sus recomendaciones: 'Hijo mío, saca de aquí a tus hijos,"
,"4":"que busquen refugio en Media porque creo en la palabra de Dios que pronunció Nahum sobre Nínive. Se cumplirá con respecto a Asiria y a Nínive. Todas las palabras de los profetas de Israel se cumplirán, porque es Dios quien los mandó. Todas las palabras se cumplirán sin excepción. En ese tiempo se estará más seguro en Media que en Asiria o en Babilonia. Todos nuestros hermanos que viven en tierras de Israel serán dispersados y desterrados lejos de su bello país. Toda la tierra de Israel será devastada; Samaría y Jerusalén serán devastadas y el Templo de Dios quedará por un tiempo destruido y quemado. "
,"5":"Pero Dios tendrá de nuevo compasión, los traerá de vuelta a la tierra de Israel. Reconstruirán el Templo, menos hermoso que el anterior, aguardando la venida de los tiempos nuevos. Entonces, todos los sobrevivientes de la cautividad reconstruirán Jerusalén en toda su grandeza y el Templo de Dios será reconstruido, tal como lo anunciaron los profetas de Israel."
,"6":"Todos los pueblos de la tierra se convertirán y temerán verdaderamente a Dios. Todos arrojarán lejos a sus falsos dioses que los indujeron al error."
,"7":"Y con sinceridad bendecirán al Dios de los siglos. Todos los Israelitas, que se hayan salvado esos días, se acordarán de Dios con todo su corazón. Volverán a Jerusalén donde vivirán sin que nadie los moleste, en la tierra de Abrahán, la que les será devuelta. Los que aman sinceramente a Dios se regocijarán, pero todos los que hacen el mal y practican la injusticia, desaparecerán de la Tierra."
,"8":"Ahora, hijos míos, oigan lo que les recomiendo: Sirvan a Dios con fidelidad y hagan lo que le agrada. Pidan a sus hijos que practiquen la justicia y la limosna, que se acuerden de Dios y en todo momento y con todas sus fuerzas bendigan su nombre con fidelidad."
,"9":"Pues bien, hijo mío, sal de Nínive, no te quedes aquí."
,"10":"El mismo día en que hayas enterrado a tu madre a mi lado, ándate, no te demores más en esta región. Veo que aquí hay mucha injusticia, mucha falsedad, y nadie se avergüenza de eso. Mira, hijo mío, todo lo que le hizo Nadab a Ajicar que lo crió. Lo encerró vivo en un subterráneo, pero Dios lo declaró culpable ante su víctima. Ajicar volvió a la luz mientras que Nadab se hundía en las tinieblas eternas: ¿no había acaso querido que Ajicar muriera? Pero Ajicar daba limosnas, por eso escapó a la trampa mortal que le había tendido Nadab, y Nadab, en cambio, encontró en ella la muerte."
,"11":"Vean, pues, hijos míos, a dónde lleva la limosna y a dónde, la injusticia; ésta lleva a la muerte. Pero... siento que no puedo respirar'. Lo acostaron en su cama y murió; lo enterraron solemnemente."
,"12":"Cuando murió la madre de Tobías, éste la enterró al lado de su padre, y luego se fue a Media con su mujer y sus hijos. Vivió en Ecbatana, en casa de su suegro Ragüel."
,"13":"Trató con respeto y con delicadeza a sus suegros ya ancianos, y luego los enterró en Media, en Ecbatana. Tobías heredó tanto lo de Ragüel como lo de su padre Tobit."
,"14":"Era respetado y vivió hasta los ciento diecisiete años."
,"15":"Antes de morir le llegaron los ecos de la destrucción de Nínive, vio incluso a los habitantes de Nínive, prisioneros de Ciazares, rey de Media, que fueron deportados a Media. Antes de su muerte, pudo alegrarse por la suerte de Nínive y bendecir al Señor Dios, por los siglos de los siglos. ¡Amén!"
}`)

}
func ES_LBL_LoadVMBRChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Estas son las palabras del libro de Baruc, hijo de Nerías, descendiente de Maasías, de Sedecías, de Sedeí, de Helcías."
,"2":"Lo escribió en Babilonia el año quinto, el día siete del mes, desde que los caldeos se apoderaron de Jerusalén y la incendiaron."
,"3":"Baruc leyó las palabras de este libro en presencia de Jeconías, hijo de Joaquim, rey de Judá, y delante de todo el pueblo que acudía a oírlas."
,"4":"Estaban todos los personajes de la familia real, los ancianos y el pueblo, desde el más pequeño hasta el más grande, cuantos habitaban en Babilonia junto al río Sud."
,"5":"Entonces lloraron, ayunaron y rezaron"
,"6":"e hicieron una colecta de dinero, de acuerdo a las posibilidades de cada uno."
,"7":"Enviaron a Baruc a Jerusalén, hacia Joaquim, hijo de Helcías, hijo de Salón, sacerdote, a los sacerdotes y a todo el pueblo que se hallaba con él en Jerusalén."
,"8":"Antes de partir, el día diez del mes de Siván, había tomado los vasos del Templo del Señor que habían sido robados, para devolverlos a la tierra de Judá. Eran los vasos de plata que había hecho Sedecías, hijo de Josías, rey de Judá,"
,"9":"cuando Nabucodonosor, rey de Babilonia, aprisionó a Jeconías y a los príncipes, a todos los ricos y al pueblo y los llevó de Jerusalén a Babilonia."
,"10":"Y les dijeron: 'Les mandamos dinero para que compren holocaustos y ofrendas por el pecado e incienso, y para que ofrezcan sacrificios en el altar del Señor nuestro Dios,"
,"11":"rueguen por la vida de Nabucodonosor, rey de Babilonia, y por la vida de Baltasar, su hijo, para que en todo tengan éxito. Así el Señor nos concederá a nosotros fortaleza y salud,"
,"12":"viviremos bajo la protección de Nabucodonosor, rey de Babilonia, y de su hijo Baltasar, los serviremos por largo tiempo y nos tratarán bien."
,"13":"Rueguen también por nosotros al Señor, nuestro Dios, porque lo hemos ofendido y hasta el día de hoy el enojo y la cólera del Señor no se han apartado de nosotros."
,"14":"Finalmente, lean este libro que les mandamos para que sea leído en el Templo del Señor en día de fiesta y en los días que conviene."
,"15":"Dirán: Que todos reconozcan la justicia del Señor, nuestro Dios. En cambio, a nosotros nos corresponde la vergüenza y también a los habitantes de Judá y de Jerusalén,"
,"16":"a nuestros reyes y nuestros príncipes, a nuestros sacerdotes, nuestros profetas y nuestros padres,"
,"17":"porque hemos pecado delante del Señor."
,"18":"Le hemos desobedecido, no hemos escuchado su voz ni hemos caminado de acuerdo con las órdenes que el Señor nos puso delante."
,"19":"Desde el día en que el Señor sacó a nuestros padres de Egipto hasta hoy, hemos sido desobedientes con él y nos hemos rebelado en vez de escuchar su voz."
,"20":"Por eso, nos sobrevinieron calamidades y la maldición que el Señor dijo a su siervo Moisés el día en que sacó a nuestros padres de Egipto para darnos una tierra que destila leche y miel. Vivimos entre desgracias hasta el día de hoy."
,"21":"No escuchamos la voz del Señor, según lo que decían los profetas que nos envió;"
,"22":"y todos nos fuimos, según las inclinaciones de nuestro perverso corazón, a servir a otros dioses y a hacer lo que desagrada al Señor."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Por eso, el Señor cumplió la palabra que había pronunciado en contra nuestra, contra nuestros gobernantes que gobernaron a Israel, contra nuestros reyes y nuestros jefes, tanto en Israel como en Judá."
,"2":"Bajo la inmensidad del cielo jamás se produjo nada semejante a lo que él hizo en Jerusalén, de acuerdo a lo que está escrito en la Ley de Moisés:"
,"3":"llegamos a comer la carne de nuestros hijos e hijas."
,"4":"Además, nos sometió al poder de todas las naciones que nos rodean, para que fuéramos maldecidos y humillados entre los pueblos de los alrededores en que el Señor nos dispersó."
,"5":"Fuimos sometidos en vez de dominar, porque habíamos ofendido al Señor, al no escuchar su voz."
,"6":"Que todos reconozcan la justicia del Señor, pero nosotros hoy y nuestros padres no merecemos sino vergüenza. Todas estas calamidades que nos han sobrevenido,"
,"7":"el Señor las había pronunciado en contra nuestra."
,"8":"No hemos suplicado al Señor para que nos hiciera volver de nuestros perversos pensamientos."
,"9":"Entonces el Señor mandó estas calamidades sobre nosotros, porque es justo en todo lo que nos manda hacer,"
,"10":"y nosotros no escuchamos su voz, que nos mandaba caminar según sus órdenes."
,"11":"Y ahora, Señor, Dios de Israel, tú que sacaste a tu pueblo de Egipto con firme mano, con señales y milagros, con gran poderío y brazo fuerte, haciendo así famoso tu Nombre hasta el día de hoy,"
,"12":"hemos pecado, hemos sido impios e injustos, Señor, descuidando todos tus mandamientos."
,"13":"Que tu cólera se aparte de nosotros, puesto que quedamos poquísimos entre las naciones en que nos dispersaste."
,"14":"Señor, escucha nuestra oración y nuestra súplica, líbranos por tu honor y concédenos el favor de los que nos desterraron."
,"15":"Que la tierra entera sepa que tú eres el Señor, Dios nuestro, ya que Israel y su raza lleva tu Nombre."
,"16":"Señor, mira desde tu santa Morada y piensa en nosotros, inclina tu oído y escucha."
,"17":"Señor, abre los ojos y considera: no son los muertos que yacen en el sepulcro, los que celebrarán tu justicia y tu gloria después que se les arrebató el aliento del pecho;"
,"18":"más bien te celebrará el alma llena de aflicción del que camina inclinado y sin fuerzas, con los ojos desfallecidos y el alma hambrienta. Esos reconocerán tu gloria y justicia, Señor."
,"19":"Nosotros no nos apoyamos en los méritos de nuestros padres y de nuestros reyes para depositar nuestra súplica en tu presencia, Señor Dios."
,"20":"Porque tú mandaste sobre nosotros tu cólera y tu furor, como lo habías declarado por el ministerio de tus servidores los profetas, en estos términos:"
,"21":"Así habla el Señor: 'Sométanse y sirvan al rey de Babilonia; entonces permanecerán en el país que di a sus padres."
,"22":"Pero si ustedes no escuchan la invitación del Señor de servir al rey de Babilonia,"
,"23":"haré cesar en las ciudades de Judá y en Jerusalén el canto de gozo y de alegría, el canto del esposo y de la esposa, y todo el país llegará a ser una desolación, sin habitantes.'"
,"24":"Pero nosotros no escuchamos tu invitación de servir al rey de Babilonia; entonces tú cumpliste las palabras que habías pronunciado por ministerio de tus siervos los profetas: los huesos de nuestros reyes y los de nuestros padres serían sacados de su lugar."
,"25":"Y fueron expuestos al calor del día y al frío de la noche, después que murieron en medio de terribles miserias: hambre, espada y peste."
,"26":"Y de esta casa que lleva tu Nombre tú hiciste lo que hoy vemos, a causa de la maldad de la gente de Israel y de la gente de Judá."
,"27":"Sin embargo, Señor, has obrado con nosotros según toda tu indulgencia y tu inmensa ternura,"
,"28":"como lo habías declarado por ministerio de tu servidor Moisés el día en que tú le mandaste que escribiera la Ley en presencia de los hijos de Israel, en estos términos:"
,"29":"'Si no escuchan mi voz, con toda seguridad esta inmensa y ruidosa muchedumbre será reducida a un pequeño número entre las naciones donde los dispersaré,"
,"30":"porque sé que no me escucharán; es un pueblo de cabeza dura. Pero en el país de su destierro entrarán en sí mismos "
,"31":"y conocerán que yo soy el Señor su Dios. Les daré un corazón y unos oídos que escuchen"
,"32":"y me alabarán en el país de su destierro y se acordarán de mi nombre;"
,"33":"se arrepentirán de su cabeza dura y de sus malas acciones, recordando la suerte de sus padres, que pecaron delante del Señor."
,"34":"Entonces los devolveré al país que con juramento prometí a sus padres, Abraham, Isaac y Jacob, y lo poseerán; ahí los multiplicaré y ya no serán disminuidos;"
,"35":"con ellos estableceré una alianza eterna, seré su Dios y ellos serán mi pueblo. Yo no arrojaré más a mi pueblo Israel del país que les di.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Señor todopoderoso, Dios de Israel, un alma angustiada, un espíritu turbado es quien te clama."
,"2":"Señor, escucha y apiádate, porque hemos pecado contra ti."
,"3":"Tú reinas para siempre, y nosotros perecemos para siempre, Señor todopoderoso."
,"4":"Dios de Israel, escucha, pues, la súplica de los muertos de Israel. Somos los hijos de los que pecaron en contra de ti y no escucharon la voz del Señor, su Dios; de ahí las calamidades que se nos han apegado."
,"5":"No te acuerdes de las injusticias de nuestros padres, sino acuérdate en esta hora de tu poder y de tu Nombre."
,"6":"Sí, tú eres el Señor, nuestro Dios, y nosotros queremos alabarte, Señor."
,"7":"Por eso, pusiste en nuestros corazones tu temor para que invoquemos tu Nombre. Queremos alabarte en nuestro destierro, ya que hemos alejado de nuestro corazón toda la malicia de nuestros padres que pecaron delante de ti."
,"8":"Aquí estamos, todavía hoy, en este destierro en que nos dispersaste para ser despreciados, maldecidos y condenados, después de todas las faltas de nuestros padres que se alejaron del Señor Dios nuestro.'"
,"9":"Escucha, Israel, los mandatos de la vida, pon atención para que puedas discernir."
,"10":"Israel, ¿por qué moras en tierra de enemigos?,y envejeces en un país extraño"
,"11":"donde te manchas con hombres impuros, y te cuentan entre los que van al abismo?"
,"12":"Es que dejaste la fuente de la sabiduría."
,"13":"Si hubieras seguido el camino de Dios, sería la paz tu morada para siempre."
,"14":"Aprende dónde está la prudencia, la fuerza y la inteligencia, para saber dónde están vida y largos días, tiempos alegres y paz."
,"15":"¿Quién ubicará la sabiduría,y entrará a la bodega de sus tesoros?"
,"16":"¿Dónde están ahora los soberanos,que dominaban hasta las bestias del campo"
,"17":"y jugaban con las aves del cielo,"
,"18":"los que acumulaban plata y oro, y la gente les tenía respeto,Nunca se cansaban de acumular la plata,y sabían el arte de aprovecharla: ¿quién podrá contar todas sus obras?"
,"19":"Desaparecieron, bajaron al lugar de los muertos,y otros tomaron sus puestos."
,"20":"Una nueva generación goza la luz,y ocupa la tierra, que tampoco sabe los caminos de la sabiduría."
,"21":"No han encontrado sus senderos,ni han dado con ella, y sus hijos se han extraviado."
,"22":"De ella no se oyó en Canaán,ni fue vista en Temán."
,"23":"No la encontraron los árabes inquietos, los mercaderes de Madián y Temán, los autores de fábulas ni los filósofos; no conocieron el camino de la sabiduría,ni descubrieron sus senderos."
,"24":"¡Oh Israel, qué grande es la casa de Dios,y el lugar de su dominio!"
,"25":"Alto y ancho, no tiene límites ni medidas."
,"26":"Allí nacieron los antiguos y famosos gigantes, fuertes y entendidos en el arte de la guerra,"
,"27":"pero Dios no los eligió,ni les enseñó el camino de la sabiduría."
,"28":"Murieron por carecer de prudencia, perecieron por su locura."
,"29":"¿Quién fue al cielo y la trajo?,¿Quién la bajó desde las nubes?"
,"30":"¿Quién atravesó el mar y la encontró?,¿Quién la comprará a precio de oro?"
,"31":"No hay quién conozca su camino, nadie imagina sus senderos."
,"32":"La conoce el que todo lo sabe, la descubrió con su inteligencia,el que arregló la tierra para siempre, y la llenó de animales."
,"33":"El que envía la luz, y la luz llega, el que la llama y vuelve temblorosa:"
,"34":"por él se enciendan los astros, llenos de gozo, y cada uno en su puesto vela sobre la noche."
,"35":"Los llama él y responden: ¡Aquí estamos!,Y brillan alegres a su Creador."
,"36":"Este es nuestro Dios, ningún otro se puede comparar a él."
,"37":"Recorrió todos los caminos de la ciencia, y se la dio a su servidor Jacob, a los hijos de Israel, sus predilectos."
,"38":"Después apareció la sabiduría en la tierra,y vino a convivir con los hombres."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ella misma es el libro de los mandamientos, y la Ley de Dios que permanece para siempre. Todos los que la conservan alcanzarán la vida; pero los que la abandonan, morirán."
,"2":"Vuelve, Jacob, y abrázala, camina hacia la gloria a la claridad de su luz."
,"3":"No cambies por la de otro pueblo,la sabiduría que sólo tú tienes."
,"4":"¡Felices somos, Israel, pues sabemos nosotros lo que gusta al Señor!,Consuelo para Jerusalén"
,"5":"Valor, pueblo mío, tú que conservas el nombre de Israel."
,"6":"Fuiste vendido a las naciones, pero no para tu destrucción. Por haber provocado la cólera de Dios fuiste entregado a tus enemigos."
,"7":"porque irritaste a tu Creador ofreciendo sacrificios a los demonios y no a Dios."
,"8":"olvidaste al Dios eterno que te crió, llenaste de tristeza también a Jerusalén, tu nodriza."
,"9":"La ciudad santa vio caer la cólera de Dios sobre ustedes, y dijo: Ciudades vecinas de Sión, escuchen, Dios me ha mandado un gran dolor."
,"10":"He visto el cautiverio de mis hijos y de mis hijas, a que los llevó el Eterno."
,"11":"Yo los había criado con gozo; con llanto y tristeza los vi partir."
,"12":"Que nadie goce en verme viuda y abandonada por tantos; sufrí la soledad por los pecados de mis hijos, porque se apartaron de la Ley de Dios."
,"13":"Desconocieron sus preceptos, no caminaron por los caminos de sus mandamientos, ni han seguido los senderos de disciplina de su verdad."
,"14":"Vengan las ciudades vecinas de Sión y recuerden el cautiverio de mis hijos e hijas a que el Eterno los llevó."
,"15":"Porque él hizo venir contra ellos una nación lejana, prepotente, de lengua desconocida."
,"16":"No respetaron al anciano ni tuvieron piedad de los niños; se llevaron al hijo único de la viuda, le quitaron sus hijas y la dejaron sola."
,"17":"Y ahora, hijos míos, ¿cómo puedo ayudarlos?"
,"18":"El que les mandó estas calamidades los arrancará de manos de sus enemigos."
,"19":"Vamos, hijos míos, sigan su camino. Yo me quedo abandonada y solitaria."
,"20":"Me saqué el manto de paz y me vestí del saco de penitencia; quiero clamar hacia el Eterno mientras viva."
,"21":"Valor, hijos míos, clamé hacia Dios; él los librará de la violencia de sus enemigos."
,"22":"Sí, yo esperaba que el Eterno les vendría a salvar y el Santo me ha consolado; me alegro por la misericordia que pronto les mostrará."
,"23":"Porque con lágrimas y duelo los vi partir, pero Dios me los devolverá, tendré gozo y alegría para siempre."
,"24":"Y así como sus vecinos los han visto cautivos, así pronto verán la salvación que llega de parte de Dios cuando se manifieste la gloria inmensa y el esplendor del Eterno."
,"25":"Hijos míos, soporten con paciencia el castigo que Dios les ha mandado. Tu enemigo te ha perseguido, pero pronto verás su ruina y pondrás tu pie sobre su cuello."
,"26":"Mis hijos predilectos caminaron por difíciles senderos, arrebatados como un rebaño robado por el enemigo."
,"27":"Valor, hijos míos, clamen a Dios; él, que los desterró, se acordará de ustedes."
,"28":"Así como ustedes se alejaron de Dios, vuelvan ahora a él y búsquenlo con redoblado amor."
,"29":"Pues él, que les envió estas calamidades, les traerá la salvación y la dicha perpetuas."
,"30":"Jerusalén, ten valor. El que te dio tu nombre te consolará."
,"31":"¡Malditos sean los que te maltrataron y se alegraron de tu caída!"
,"32":"¡Malditas sean las ciudades en que tus hijos fueron esclavos! Maldición a la ciudad que los cautivó"
,"33":"y se alegró de tu caída y estuvo feliz con tu ruina, porque se verá afligida a su vez y destruida."
,"34":"Yo le quitaré su alegría de ciudad muy populosa, su orgullo se cambiará en duelo."
,"35":"Por largos días caerá fuego sobre ella de parte del Eterno, será por mucho tiempo morada de demonios."
,"36":"Jerusalén, mira al oriente y contempla la alegría que te viene de Dios."
,"37":"Vuelven, están aquí los hijos que viste partir; vuelven reunidos de oriente y occidente a la voz del Santo, gozosos de la gloria de Dios."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Jerusalén, quítate tu vestido de duelo y desdicha y vístete para siempre con el esplendor de la gloria de Dios."
,"2":"Reviste cual un manto la justicia de Dios, ponte como corona la gloria del Eterno;"
,"3":"porque Dios mostrará tu grandeza a todo lo que hay bajo el cielo."
,"4":"Dios te llamará para siempre: 'Paz en la justicia y gloria en el temor de Dios.'"
,"5":"Levántante, Jerusalén, ponte en lo alto, mira al oriente y ve a tus hijos reunidos del oriente al poniente por la voz del Santo, felices porque Dios se acordó de ellos."
,"6":"Salieron a pie escoltados por los enemigos, pero Dios te los devuelve, traídos con gloria, como hijos de rey."
,"7":"Porque Dios ha ordenado que todo cerro elevado y toda cuesta interminable sean rebajados, y rellenados los valles hasta aplanar la tierra, para que Israel camine seguro bajo la gloria de Dios."
,"8":"Hasta los bosques y todo árbol oloroso les darán sombra por orden de Dios."
,"9":"Porque él guiará a Israel en la alegría y a la luz de su gloria, escoltándolos con su misericordia y justicia."
}`)
	CurrentBook.AddChapter(6, `{
"0":"Copia de una carta que dirigió Jeremías a los prisioneros que iban a ser deportados a Babilonia, para darles a conocer el mensaje que Dios le había encargado."
,"1":"'Por los pecados que han cometido en la presencia de Dios, serán llevados cautivos a Babilonia por Nabucodonosor, rey de los babilonios."
,"2":"Llegados, pues, a Babilonia, estarán allí muchísimos años y por muy largo tiempo, hasta siete generaciones, después los sacaré de allí en paz."
,"3":"Ahora bien, ustedes verán en Babilonia dioses de oro, de plata, de piedra y de madera, llevados a hombros, que causan un temor respetuoso a las gentes."
,"4":"Guárdense, pues, ustedes de imitar lo que hacen los extranjeros, de modo que vengan a temerlos."
,"5":"Cuando vean, pues, detrás y delante de ellos la turba que los adora, digan allá en su corazón: ¡Oh Señor, sólo a ti se debe adorar!"
,"6":"Porque mi Angel está con ustedes y yo mismo tendré cuidado de sus almas."
,"7":"Puesto que la lengua de los ídolos fue pulida por el artífice, son un mero engaño, e incapaces de poder hablar aunque estén dorados y plateados."
,"8":"Y al modo que se hace un adorno para una muchacha que gusta engalanarse, así, echando mano del oro, los adornan con esmero."
,"9":"A la verdad, los dioses de ellos tienen puestas en la cabeza coronas de oro; oro que, después, juntamente con la plata, les arrebatan los sacerdotes a fin de gastarlo para sí mismos"
,"10":"y aun lo hacen servir para engalanar a los prostitutas de su casa. Visten a estos dioses como a hombres, aunque son de oro, plata y madera,"
,"11":"pero estos dioses no saben librarse del orín ni de la polilla."
,"12":"Y después que los han revestido de púrpura, les limpian el rostro con motivo del muchísimo polvo que hay en sus templos."
,"13":"Tiene también el ídolo un cetro en la mano, como lo tiene el que gobierna el país; mas él no puede quitar la vida al que lo ofende."
,"14":"Tiene igualmente en la mano la espada y el hacha; pero no se puede librar a sí mismo de la guerra ni de los ladrones; por todo lo cual pueden ver que no son dioses."
,"15":"Por eso, no tienen que temerlos; porque los tales dioses son como una vasija hecha pedazos, que para nada sirve."
,"16":"Una vez colocados en un templo, sus ojos se cubren luego del polvo que levantan los pies de los que entran."
,"17":"Y al modo que encierran detrás de muchas puertas al que ofendió al rey, como se practica con un muerto que se lleva al sepulcro, así los sacerdotes aseguran las puertas con cerraduras y cerrojos para que los ladrones no despojen a sus dioses."
,"18":"Encienden también delante de ellos lámparas, incluso más numerosas que para sí mismos, pero no pueden ver ninguna de ellas;"
,"19":"estos dioses son como las vigas de una casa que están roídas por dentro; la polilla se los come a ellos y sus vestiduras sin que ellos se den cuenta."
,"20":"Negras se vuelven sus caras con el humo que hay en su casa."
,"21":"Sobre su cuerpo y sobre su cabeza vuelan las lechuzas, las golondrinas y otras aves, y también los gatos andan sobre ellos."
,"22":"Por donde pueden conocer que no son dioses; y, por lo mismo, no los teman."
,"23":"Además de esto, si el oro que tienen como adorno no lo limpia alguno del orín, ya no relucirá. Ni aun cuando los estaban fundiendo sintieron nada."
,"24":"Y a pesar de que no hay en ellos espíritu alguno, fueron comprados a gran precio."
,"25":"Son llevados a hombros, ya que no tienen pies, demostrando así a los hombres su vergonzosa impotencia. Avergonzados sean también los que los adoran."
,"26":"Por eso, si caen a tierra no se levantan por sí mismos; ni por sí mismos se echarán a andar si alguno los pone de pie; y les tienen que poner delante las ofrendas como a los muertos."
,"27":"Estas ofrendas las venden y aprovechan sus sacerdotes, también sus mujeres las salan y no dan nada de eso al enfermo ni al mendigo."
,"28":"Las mujeres embarazadas y las que están impuras por sus reglas comen los sacrificios de ellos. Conociendo, pues, por todas estas cosas que no son dioses, no tienen que temerlos."
,"29":"Mas ¿por qué los llaman dioses? Las mujeres presentan dones a esos dioses de plata, de oro y de madera;"
,"30":"los sacerdotes están sentados en los templos de ellos, llevando rasgadas sus túnicas y rapado el cabello y la barba, y con la cabeza descubierta,"
,"31":"y rugen dando gritos en la presencia de sus dioses, como se practica en un banquete fúnebre."
,"32":"Con los vestidos que quitan a sus ídolos visten a sus mujeres y a sus hijos. Y aunque a los ídolos se les haga algún bien, no pueden premiar o castigar en ningún caso. No pueden poner a un rey ni quitarlo. "
,"33":"Y tampoco pueden dar riquezas,"
,"34":"ni siquiera una monedita. Si alguno les hace un voto y no lo cumple, ni de esto se quejan."
,"35":"No pueden librar a un hombre de la muerte ni amparar al débil contra el poderoso."
,"36":"No restituyen la vista a ningún ciego ni sacarán de la miseria a nadie."
,"37":"No se compadecerán de la viuda ni serán bienhechores de los huérfanos."
,"38":"Son semejantes a las piedras del monte esos dioses de madera, de piedra, de oro, de plata. Los que los adoran serán confundidos."
,"39":"¿Cómo, pues, puede pensarse o decirse que son dioses?"
,"40":"Incluso los mismos caldeos los desprecian. Cuando ven que uno no puede hablar, porque es mudo, lo presentan a Bel, rogándole que lo haga hablar; como si fuera capaz de entender."
,"41":"Ellos, que piensan, no son capaces de rechazar a dioses que no tienen entendimiento."
,"42":"Las mujeres, ceñidas de cordones, se sientan en los caminos quemando afrechillo, como si fuera incienso."
,"43":"Y si alguna de ellas, atraída por algún pasajero, ha dormido con él, reprocha a su compañera por no haber sido escogida como ella y porque no ha sido roto su cinto."
,"44":"Todo lo que se hace en honor de estos dioses es engaño. ¿Cómo, pues, podrá nunca juzgarse o decirse que ésos sean dioses?"
,"45":"Han sido fabricados por carpinteros y por plateros, y no son otra cosa que lo que quisieron sus artífices."
,"46":"Los artífices mismos de los ídolos duran poco tiempo; ¿podrán, pues, ser dioses las cosas que ellos mismos se fabrican?"
,"47":"No dejan a sus descendientes sino mentira y oprobio."
,"48":"Porque, si sobreviene alguna guerra o desastre, los sacerdotes andan discurriendo dónde refugiarse con sus dioses."
,"49":"¿Cómo no entienden entonces que no son dioses los que no pueden librarse de la guerra ni sustraerse de las calamidades?"
,"50":"Porque siendo, como son, cosa de madera, dorados y plateados, conocerán finalmente todas las naciones y reyes que son un engaño; reconocerán que no son dioses, sino obra de las manos de los hombres, y que nada hacen en prueba de que son dioses."
,"51":"Pero, ¿y cómo se conoce que no son dioses, sino obra de las manos de los hombres, y que no hacen nada que sea propio de dioses?"
,"52":"Ellos no pueden nombrar a rey alguno en ningún país ni pueden dar la lluvia a los hombres."
,"53":"No decidirán, ciertamente, los pleitos ni librarán de la opresión al que sufre injusticias, porque nada pueden;"
,"54":"son como las golondrinas que se quedan entre cielo y tierra. Porque si se incendia el templo de esos dioses de madera, de plata y de oro, seguramente que sus sacerdotes huirán y se pondrán a salvo; pero ellos se quemarán dentro, lo mismo que las vigas."
,"55":"No opondrán resistencia a un rey o a un ejército."
,"56":"¿Cómo, pues, puede creerse o admitirse que sean dioses?"
,"57":"No se librarán de ladrones ni de salteadores esos dioses de madera y de piedra, dorados y plateados; seguramente aquéllos pueden más que ellos, y les quitarán el oro, la plata y el vestido de que están cubiertos, y se marcharán sin que los ídolos puedan defenderse a sí mismos."
,"58":"De manera que vale más un rey que muestra su poder, o cualquier mueble útil en una casa, del cual se precia el dueño, o la puerta de la casa, que guarda lo que hay dentro de ella, que los falsos dioses."
,"59":"Ciertamente que el sol, la luna y las estrellas, que están puestas para alumbrarnos y sernos provechosos, obedecen a Dios."
,"60":"Asimismo, el relámpago se deja ver cuando aparece, y el viento que sopla por todas las regiones."
,"61":"Igualmente, las nubes, cuando Dios las manda recorrer todo el mundo, ejecutan lo que se les ha mandado."
,"62":"El fuego, también enviado de arriba para abrasar los cerros y los bosques, cumple lo que se le ha ordenado. Mas estos ídolos no se parecen a ninguna de esas cosas ni en la belleza ni en la fuerza."
,"63":"Y, así, no debe pensarse ni decirse que sean dioses, ya que no pueden ni hacer justicia ni proporcionar bien alguno a los hombres."
,"64":"Sabiendo, pues, que ellos no son dioses, no tienen que temerlos."
,"65":"No envían maldición ni bendición a los reyes;"
,"66":"no muestran tampoco a los pueblos señales en el cielo, ni lucen como el sol, ni alumbran como la luna."
,"67":"Más que ellos valen las bestias, que pueden huir o refugiarse bajo cubierto y valerse a sí mismas."
,"68":"De ninguna manera son dioses, como es evidente; por lo tanto, no tienen que temerlos."
,"69":"Porque así como no es buen guardián de un melonar un espantapájaros, así son sus dioses de madera, de plata y de oro."
,"70":"Son como la zarza de un huerto, sobre la cual viene a posarse toda clase de pájaros. También estos dioses de madera, dorados y plateados, se asemejan a un cadáver que yace en la oscuridad."
,"71":"Al ver que la púrpura y escarlata se apolillan sobre ellos, conocerán claramente que no son dioses. Ellos mismos son devorados al fin por la polilla, y pasan a ser la vergüenza de su país."
,"72":"Más vale el varón justo que no tiene ídolos, porque nadie le quitará su fama."
}`)

}
func ES_LBL_LoadVMDNChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"En el tercer año del reinado de Joaquín, rey de Judá, Nabucodonosor, rey de Babilonia, llegó hasta Jerusalén y la sitió."
,"2":"El Señor puso en sus manos a Joaquín, rey de Judá y una parte de los objetos del Templo de Dios; aquél los llevó a la tierra de Senaar y depositó esos objetos en el tesoro de sus dioses."
,"3":"El rey pidió a Asfernes, jefe de los eunucos, que eligiera de entre los Israelitas a algunos niños de raza real o de familia noble."
,"4":"Esos jóvenes no debían tener defecto alguno, debían tener una buena presencia, poseer un buen juicio, ser instruidos y bien educados, en una palabra, ser capaces de mantener su rango en el palacio del rey y de aprender allí la escritura y la lengua de los Caldeos."
,"5":"Cada día el rey les distribuía una parte de los alimentos que él comía y del vino que bebía; así se les debía educar durante tres años, después de lo cual servirían en presencia del rey."
,"6":"Entre ellos estaban estos jóvenes judíos: Daniel, Ananías, Misael y Azarías."
,"7":"El jefe de los eunucos les puso un nombre nuevo: Daniel se llamaría Baltasar; Ananías, Sidrac; Misael, Misac; y Azarías, Abdénago."
,"8":"Daniel decidió no mancharse comiendo de lo que se servía el rey o bebiendo de su vino. Le pidió pues al jefe de los eunucos que no lo obligara a comer esa comida impura."
,"9":"Dios concedió a Daniel que se atrajera la simpatía del jefe de los eunucos."
,"10":"Sin embargo éste respondió: 'Temo a mi señor el rey. Fue él quien determinó lo que ustedes tenían que comer y beber; si ve que están más flacos que los jóvenes de su misma edad, me hará a mí responsable'."
,"11":"Entonces Daniel dijo al guardia que el jefe de los eunucos había elegido para que vigilara a Daniel, Ananías, Misael y Azarías:"
,"12":"'Por favor, ponnos a prueba durante diez días, danos solamente legumbres para comer y agua como bebida."
,"13":"Compararás nuestra apariencia con la de los muchachos que comen de lo que se sirve el rey, y luego actuarás con nosotros según lo que hayas visto'."
,"14":"Les hizo caso y los puso a prueba por diez días."
,"15":"Ahora bien, al cabo de diez días era evidente que tenían mejor aspecto que todos los muchachos que se alimentaban de lo que comía el rey."
,"16":"Desde entonces el guardia les quitó la comida y el vino que debían servirse y sólo les dio legumbres."
,"17":"Dios les concedió a esos cuatro jóvenes la sabiduría y la inteligencia, tanto en literatura como en filosofía; Daniel era hábil para explicar las visiones y los sueños."
,"18":"Al cabo del tiempo fijado por el rey, el jefe de los eunucos los llevó ante Nabucodonosor."
,"19":"El rey les habló y, entre todos ellos, no encontró a ninguno como Daniel, Ananías, Misael y Azarías. Se quedaron pues para servir al rey."
,"20":"Y cualquiera que fuese el tema de filosofía o de reflexión sobre el cual los interrogara, los hallaba diez veces superiores a todos los magos y adivinos de su reino."
,"21":"Daniel se quedó allí hasta el primer año del rey Ciro."
}`)
	CurrentBook.AddChapter(2, `{
"1":"El año décimo de su reinado, Nabucodonosor tuvo un sueño que lo perturbó hasta el punto de no dejarlo dormir."
,"2":"El rey ordenó convocar a los magos, adivinos, brujos y astrólogos para que le explicaran el sueño que había tenido; vinieron y se presentaron ante el rey."
,"3":"El rey les dijo: 'He tenido un sueño y no me quedaré tranquilo hasta que sepa lo que ese sueño significa'."
,"4":"Los astrólogos dijeron al rey: '¡Que viva el rey eternamente! Cuéntales a tus servidores el sueño y te daremos su interpretación'."
,"5":"Pero el rey respondió a sus magos: 'Esto es lo que he decidido: Si ustedes no me dan a conocer el sueño y su explicación, serán hecho pedazos y sus casas serán destruidas."
,"6":"Pero si me dan a conocer el sueño y su explicación, recibirán de mí obsequios, regalos y grandes honores. Pues bien, cuéntenme el sueño y denme su explicación'."
,"7":"Tomaron nuevamente la palabra y dijeron: 'El rey tiene que contar el sueño a sus servidores para que en seguida se lo expliquemos'."
,"8":"Pero el rey les dijo: 'Bien veo que ustedes sólo buscan ganar tiempo porque ya saben que mi decisión está tomada."
,"9":"Si no me dan a conocer el sueño, todos ustedes serán ejecutados. De lo contrario, ustedes se pondrán de acuerdo para decirme cosas inventadas y engañosas mientras el tiempo pasa; cuéntenme pues el sueño y así sabré si son capaces de interpretarlo'."
,"10":"Los astrólogos respondieron al rey: 'No hay nadie en la tierra que pueda hacer lo que el rey pide. Ningún rey, por grande y poderoso que haya sido, le ha pedido semejante cosa a alguno de sus magos, adivinos o astrólogos."
,"11":"El rey pide demasiado; sólo los dioses pueden satisfacer esa exigencia del rey, pero ellos no se encuentran en el mundo de los mortales'."
,"12":"Entonces el rey se enojó de tal manera, y fue tanto su furor que ordenó ejecutar a todos los sabios de Babilonia."
,"13":"Se publicó la orden de ejecución de los sabios y fueron a buscar a Daniel y a sus compañeros para llevarlos al patíbulo."
,"14":"Entonces Daniel habló con sabiduría y astucia a Aryok, el jefe de los verdugos del rey que había salido para ejecutar a los sabios de Babilonia,"
,"15":"y le preguntó: '¿Por qué el rey dio esta orden con tanta prisa?' Aryok explicó a Daniel lo que pasaba."
,"16":"Daniel fue entonces a decirle al rey: 'Concédeme un plazo y te daré la explicación del sueño'."
,"17":"Daniel volvió a su casa y comunicó el asunto a sus compañeros Ananías, Misael y Azarías."
,"18":"Les pidió que imploraran la misericordia del Dios del cielo para que les esclareciera ese misterio; pues de lo contrario, harían morir a Daniel y a sus compañeros junto con los demás sabios de Babilonia."
,"19":"Y he aquí que se le reveló el misterio a Daniel en una visión durante la noche. Daniel bendijo al Dios del cielo,"
,"20":"le dijo: '¡Bendito sea Dios por los siglos de los siglos!,a él pertenecen la sabiduría y la fuerza."
,"21":"El es el dueño de los tiempos y de los momentos, destrona a los reyes igual como los entroniza, da la sabiduría a los sabios, la inteligencia a los que toman decisiones."
,"22":"Revela los misterios y los secretos, conoce lo que está oculto en las tinieblas; donde él está, todo es luz."
,"23":"Dios de mis padres, te alabo y te glorifico porque me has dado la sabiduría y la fuerza, y porque acabas de darme a conocer lo que te habíamos pedido: nos has revelado el secreto del rey'."
,"24":"Volvió entonces Daniel a casa de Aryok, al que el rey había encargado que ejecutara a los sabios de Babilonia. Le dijo: 'No mates a los sabios de Babilonia, sino que condúceme donde el rey y le daré la explicación'."
,"25":"Aryok llevó inmediatamente a Daniel ante el rey y le dijo: 'Entre los desterrados de Judá encontré a un hombre que dará al rey el significado de su sueño'."
,"26":"El rey tomó la palabra y dijo a Daniel cuyo nombre era Baltasar: '¿Puedes acaso contarme el sueño que tuve y darme su explicación?'"
,"27":"Daniel tomó la palabra en presencia del rey y dijo: 'El misterio que el rey quiere saber, no hay sabios, adivinos, magos ni astrólogos que se lo puedan revelar,"
,"28":"pues es Dios, en el cielo, quien revela los misterios. El dio a conocer al rey Nabucodonosor lo que va a suceder con el correr de los días. Estos son el sueño y las visiones que has tenido en tu lecho:"
,"29":"Los pensamientos que vinieron a tu espíritu durante la noche se refieren al porvenir. Aquel que revela los misterios te ha dado a conocer lo que acontecerá."
,"30":"A mí se me ha revelado este secreto, no porque tenga una sabiduría superior a la de los mortales, sino con el fin de que todos conozcan la interpretación de tu sueño."
,"31":"Viste una estatua muy grande y de un resplandor extraordinario; estaba de pie delante de ti y su aspecto era terrible."
,"32":"Esa estatua tenía una cabeza de oro fino, el pecho y los brazos eran de plata, el vientre y las caderas de bronce,"
,"33":"las piernas de hierro, y los pies de hierro mezclado con arcilla."
,"34":"Tú estabas mirándola cuando se desprendió una roca sin que nadie la moviera; pegó a la estatua a la altura de los pies de hierro y de arcilla y los rompió."
,"35":"Y en aquel mismo instante se hicieron trizas el hierro, la arcilla, el bronce, la plata y el oro; el viento se los llevó sin dejar huella como se lleva la paja del trigo en la era durante el verano. Y la piedra que había golpeado a la estatua se convirtió en una gran montaña que abarcó toda la tierra."
,"36":"Ese fue el sueño: Ahora daremos al rey su explicación."
,"37":"Tú eres el rey de reyes, el Dios del Cielo te dio la realeza, el poder, la fuerza y la gloria."
,"38":"El puso en tus manos los hombres, los animales del campo y los pájaros del cielo, te hizo su dueño doquiera ellos vivan. La cabeza de oro eres tú."
,"39":"Después de ti seguirá un reino inferior al tuyo, luego un tercero que será de bronce y que dominará toda la tierra."
,"40":"Después vendrá un cuarto reino que será fuerte como el hierro. Así como el hierro rompe y lo reduce todo a polvo, así romperá y lo arrasará todo."
,"41":"Como bien lo viste, los pies y los dedos son una mezcla de hierro y de arcilla de alfarero; ese será un reino dividido. Tendrá la solidez del hierro, pues viste al hierro mezclado con arcilla barrosa."
,"42":"Pero los dedos de los pies son mitad hierro y mitad arcilla; el reino será fuerte sólo a medias pues también será frágil."
,"43":"Así como viste el hierro mezclado con arcilla barrosa, así estos reinos se mezclarán debido a un matrimonio, pero no estarán unidos el uno al otro, igual como el hierro no puede unirse con la arcilla."
,"44":"En tiempo de esos reinos, el Dios del Cielo suscitará un reino que nunca será destruido; su poder no pasará a pueblo alguno. Derrotará y destruirá a todos los reinos y los reemplazará para siempre."
,"45":"Viste como se desprendió una roca de la montaña sin que mano alguna la tocara, y como pulverizó el hierro, el bronce, la arcilla, la plata y el oro: eso mismo va a acontecer. El Dios grande ha dado a conocer al rey lo que algún día va a pasar; como el sueño fue así, su interpretación también es exacta'."
,"46":"Al oír esto, el rey Nabucodonosor se echó de bruces al suelo y se postró ante Daniel, luego dio orden que le presentaran ofrendas y perfumes de olor agradable."
,"47":"El rey se dirigió entonces a Daniel y le dijo: 'En verdad el Dios de ustedes es el Dios de los dioses, el Señor de los reyes; es él quien da a conocer los misterios ya que tú pudiste revelárnoslos.'"
,"48":"El rey ensalzó a Daniel y le otorgó numerosos y ricos obsequios; lo hizo gobernador de la provincia de Babilonia y el jefe máximo de todos los sabios de Babilonia."
,"49":"Inmediatamente Daniel pidió al rey que pusiera al frente de la administración de la provincia de Babilonia a Sidrac, Misac y Abdénago; quedando Daniel a disposición del rey."
}`)
	CurrentBook.AddChapter(3, `{
"1":"El rey Nabucodonosor hizo una estatua de oro de treinta metros de alto por tres metros de ancho y la colocó en la llanura de Dura, en la provincia de Babilonia."
,"2":"El rey Nabucodonosor llamó a los funcionarios, prefectos, gobernadores, consejeros, tesoreros, procuradores, jueces y a todos los jefes de provincia para que se reunieran y asistieran a la inauguración de la estatua."
,"3":"Así fue, pues, como los funcionarios, prefectos, gobernadores, consejeros, tesoreros, procuradores, jueces y todos los jefes de provincia se reunieron para la inauguración de la estatua que había hecho levantar el rey Nabucodonosor."
,"4":"Un mensajero anunció con toda su voz: '¡Escuchen hombres de todas las razas, naciones y lenguas!"
,"5":"Cuando oigan el sonido de la trompeta, el cuerno, la cítara, la flauta, el trombón, la gaita y de cualquier otro instrumento, se postrarán en tierra y adorarán la estatua de oro que ordenó levantar el rey Nabucodonosor."
,"6":"Aquel que no se postre en tierra ni la adore, será echado inmediatamente a un horno ardiente'."
,"7":"Por eso, cuando todos los pueblos oyeron el sonido de la trompeta, el cuerno, la cítara, la flauta, el trombón, la gaita y de cualquier otro instrumento, los hombres de todos los pueblos, naciones y lenguas se postraron en tierra y adoraron la estatua de oro erigida por el rey Nabucodonosor."
,"8":"En esos momentos, unos hombres de Caldea fueron a acusar a los judíos."
,"9":"Pidieron la palabra y dijeron al rey Nabucodonosor: '¡Viva el rey para siempre!"
,"10":"Tú, oh rey, diste esta orden: Cualquier hombre al oír el sonido de la trompeta, del cuerno, la cítara, la flauta, el trombón, la gaita y de cualquier clase de instrumento, tendrá que postrarse en tierra y adorar la estatua de oro."
,"11":"También dijiste que cualquiera que no se postrara en tierra ni la adorara, sería echado a un horno ardiente."
,"12":"Pues bien, hay unos judíos, Sidrac, Misac y Abdénago, a quienes pusiste al frente de la administración de la provincia de Babilonia, que no han hecho caso de la orden del rey. No sirven a tus dioses ni adoran la estatua de oro que levantaste'."
,"13":"Rojo de ira, Nabucodonosor pidió que le trajeran a Sidrac, Misac y Abdénago; trajeron a esos hombres ante el rey."
,"14":"Nabucodonosor tomó la palabra y dijo: ' Sidrac, Misac y Abdénago, ¿es cierto que no honran a mis dioses ni adoran la estatua de oro que erigí?"
,"15":"Pues bien, si ahora mismo están dispuestos a postrarse en tierra cuando oigan el sonido de la trompeta, del cuerno, la cítara, la flauta, el trombón, la gaita y de toda clase de instrumentos, y adoran la estatua de oro, todo estará bien. Pero si no lo hacen serán inmediatamente echados a un horno ardiente. Y ¿qué dios los salvará de mi mano?'"
,"16":"Sidrac, Misac y Abdénago respondieron al rey Nabucodonosor: No necesitamos darte una respuesta sobre eso."
,"17":"Si nuestro Dios, al que servimos, quiere salvarnos del horno ardiente y de tu mano, nos salvará."
,"18":"Pero si no lo quiere, has de saber que no serviremos a tus dioses ni adoraremos la estatua de oro que erigiste'."
,"19":"Loco de rabia, Nabucodonosor cambió de actitud con respecto a Sidrac, Misac y Abdénago; ordenó que se calentara el horno siete veces más de lo que era necesario."
,"20":"Luego dio orden a los hombres más forzudos de su ejército que ataran a Sidrac, Misac y Abdénago para echarlos al horno ardiente."
,"21":"Ataron pues a esos hombres y los echaron al horno ardiente con sus mantos, túnicas, turbantes y toda su demás ropa."
,"22":"Como la orden del rey era irrevocable, se había calentado el horno al máximo; así fue como la llamarada mató a los hombres que habían llevado a Sidrac, Misac y Abdénago."
,"23":"Esos tres hombres, Sidrac, Misac y Abdénago cayeron en el horno ardiente amarrados."
,"24":"¡Pues bien, caminaban en medio de las llamas alabando a Dios y bendiciendo al Señor!"
,"25":"De pie, en medio del fuego, Azarías abrió la boca y oró de esta manera:"
,"26":"'¡Bendito seas tú, Señor, Dios de nuestros padres, que tu nombre sea alabado y glorificado eternamente!"
,"27":"Porque eres justo en todo lo que haces, todos tus caminos son rectos, tus obras son verdaderas,y todos tus juicios son irreprochables."
,"28":"Has llevado a efecto una justa sentencia al permitir todo lo que nos pasó a nosotros y a Jerusalén, la ciudad santa de nuestros padres. Sí, nos trataste con lealtad y justicia cuando dejaste caer sobre nosotros todo eso por culpa de nuestros pecados."
,"29":"Porque pecamos y cometimos la injusticia, alejándonos de ti; hemos pecado en todo eso gravemente; no hemos obedecido tus mandamientos."
,"30":"No los hemos cumplido, no hemos hecho lo que tú nos mandaste para que tu bendición viniera sobre nosotros."
,"31":"En todo lo que has permitido que nos pasara, en todo lo que has hecho, has actuado según una justa decisión."
,"32":"Nos entregaste en manos de enemigos paganos, los más detestables de los infieles, nos entregaste a un rey injusto, el más perverso de toda la tierra."
,"33":"Actualmente ya no nos atrevemos a abrir la boca, tus servidores y los que te adoran están cubiertos de vergüenza y de confusión."
,"34":"En honor a tu nombre no nos abandones para siempre ni te olvides de tu alianza."
,"35":"En recuerdo de Abrahán tu amigo, de Isaac tu servidor y de Israel tu santo no alejes de nosotros tu misericordia,"
,"36":"tú que prometiste multiplicar su descendencia como las estrellas del cielo y como la arena que está a orillas del mar."
,"37":"Sí, Señor, entre todas las naciones de la tierra somos los más pobres, y hemos sido humillados ante toda la tierra por culpa de nuestros pecados."
,"38":"No hemos tenido en todo este tiempo ni príncipe, ni profeta, ni jefe, ni holocausto, ni sacrificio ni ofrenda, ni incienso, ni siquiera un lugar para presentártelos y ser acogidos con benevolencia."
,"39":"Recibe sin embargo nuestro corazón destrozado y nuestro espíritu humillado como si fueran holocaustos de carneros y de toros, o sacrificios de miles de gordos corderos."
,"40":"Que así sea ahora nuestro sacrificio ante ti, concédenos seguirte fielmente, porque los que en ti ponen su confianza no quedarán decepcionados."
,"41":"Ahora te seguimos con todo nuestro corazón, te tenemos y buscamos tu rostro. No nos cubras de vergüenza,"
,"42":"sino que trátanos según tu benevolencia y según tu gran misericordia."
,"43":"Líbranos con tu poder y haz que veamos la gloria de tu Nombre, Señor."
,"44":"Que todos los que maltratan a tus servidores se vean confundidos y cubiertos de vergüenza, que sean privados de todo poder y de toda autoridad y que sus fuerzas sean aniquiladas."
,"45":"Que reconozcan que tú eres el Señor, el único Dios glorioso en toda la tierra'."
,"46":"Sin embargo, los servidores del rey que los habían echado al horno seguían calentándolo con alquitrán, pez, aceite y leña."
,"47":"Las llamas se elevaron veinticinco metros por encima del horno"
,"48":"y quemaron a los caldeos que se encontraban cerca del horno."
,"49":"Pero el ángel del Señor había descendido al horno donde estaban Azarías y sus compañeros y había apartado la llama del horno."
,"50":"Hizo que soplara como una suave brisa en el horno lo suficiente para que el fuego no los tocara ni les causara dolor ni sufrimiento."
,"51":"Entonces los tres, como un solo corazón, se pusieron a cantar, a glorificar y a bendecir a Dios desde el fondo del horno, diciendo:"
,"52":"'¡Bendito seas Señor, Dios de nuestros padres, alabado y ensalzado eternamente!,¡Bendito sea tu nombre santo y glorioso, cantado y ensalzado eternamente!"
,"53":"¡Bendito seas en el Templo de tu santa gloria, cantado y alabado eternamente!"
,"54":"¡Bendito seas en el trono de tu reino, cantado y glorificado eternamente!"
,"55":"¡Bendito seas tú que sondeas los abismos y que te sientas sobre los Querubines, alabado y cantado eternamente!"
,"56":"¡Bendito seas en la bóveda del cielo, cantado y glorificado eternamente!"
,"57":"¡Todas las obras del Señor, bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"58":"¡Angeles del cielo, bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"59":"¡Bendigan los cielos al Señor, cántenle y glorifíquenlo eternamente!"
,"60":"¡Todas las aguas del cielo, bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"61":"¡Todos los poderes del Señor, bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"62":"¡Sol y luna bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"63":"¡Estrellas del cielo bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"64":"¡ Lluvias y rocíos bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"65":"¡Todos los vientos bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"66":"¡Fuego y calor bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"67":"¡Frío y ardor bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"68":"¡Rocíos y escarchas bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"69":"¡Hielo y frío bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"70":"¡Hielos y nieves bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"71":"¡Noches y días bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"72":"¡Luces y tinieblas bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"73":"¡Rayos y nubes bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"74":"¡Bendiga la tierra al Señor, cántele y glorifíquelo eternamente!"
,"75":"¡Montañas y colinas bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"76":"¡Todas las semillas que germinan en la tierra bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"77":"¡Fuentes bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"78":"¡Mares y ríos bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"79":"¡Monstruos marinos y todo lo que se mueve en las aguas bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"80":"¡Aves todas del cielo bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"81":"¡Que todos los animales domésticos y las fieras salvajes bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"82":"¡Ustedes, todos los hijos de los hombres, bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"83":"¡Israel bendice al Señor, cántale y glorifícalo eternamente!"
,"84":"¡Sacerdotes bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"85":"Todos ustedes servidores del Señor, bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"86":"¡Espíritus y almas de los justos bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"87":"¡Todos los santos y los humildes de corazón, bendigan al Señor, cántenle y glorifíquenlo eternamente!"
,"88":"¡Ananías, Azarías y Misael, bendigan al Señor, cántenle y glorifíquenlo eternamente!,Porque nos libró del infierno y nos salvó de la muerte; nos arrancó del horno ardiente y nos sacó de en medio de las llamas."
,"89":"¡Den gracias al Señor porque es bueno, porque su amor es eterno!"
,"90":"Todos ustedes que temen al Señor, bendíganlo, bendigan al Dios de los dioses, cántenle y denle gracias porque su amor es eterno."
,"91":"El rey Nabucodonosor se quedó sin resuello, se levantó rápidamente y preguntó a sus consejeros: '¿No echamos a esos tres hombres amarrados al fuego?' Respondieron: 'Ciertamente'."
,"92":"El rey añadió: 'Pues bien, veo a cuatro hombres que caminan con toda libertad en medio del fuego sin que sufran nada; el cuarto se parece a un hijo de los dioses'."
,"93":"Nabucodonosor se acercó a la puerta del horno ardiente y exclamó: '¡Sidrac, Misac y Abdénago, servidores del Dios Altísimo, salgan y vengan para acá!'. Entonces Sidrac, Misac y Abdénago salieron de en medio del fuego."
,"94":"Los funcionarios, prefectos, gobernadores y consejeros del rey se juntaron para ver a esos hombres. El fuego no les había hecho nada: ni su cuerpo ni sus cabellos estaban quemados, sus ropas no habían sido tocadas y ningún olor a quemado despedían sus personas."
,"95":"Nabucodonosor dijo entonces: 'Bendito sea el Dios de Sidrac, Misac y Abdénago que envió a su ángel para librar a sus servidores; confiaron en él, desobedecieron la orden del rey y prefirieron entregar su cuerpo al fuego antes que servir o adorar a cualquier otro dios que no fuera su Dios."
,"96":"Esto es lo que ordeno a todos los pueblos, naciones y lenguas: Todos los que entre ustedes hablen sin respeto del Dios de Sidrac, Misac y Abdénago serán hecho pedazos y sus casas serán destruidas porque no hay otro Dios que pueda salvar de esa manera'."
,"97":"Luego el rey ordenó que se diera un puesto todavía más importante en la provincia de Babilonia a Sidrac, Misac y Abdénago."
,"98":"El rey Nabucodonosor a todos los pueblos, naciones y lenguas que habitan en toda la tierra : ¡La abundancia y la paz sean con ustedes!"
,"99":"Me ha parecido bueno dar a conocer las señales y maravillas que el Dios Altísimo ha hecho conmigo."
,"100":"¡Qué grandes son sus prodigios, qué poderosos, sus milagros!,Su imperio se extiende de generación en generación."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Yo, Nabucodonosor, estaba tranquilo en mi casa y vivía feliz en mi palacio,"
,"2":"cuando tuve un sueño que me espantó; los pensamientos y las visiones que tuve esa noche me aterrorizaron."
,"3":"Ordené entonces que vinieran a verme todos los sabios de Babilonia para que me dieran a conocer el significado del sueño."
,"4":"Llegaron los magos, los adivinos, los brujos y los astrólogos, y les conté el sueño, pero nadie me dio la interpretación de él."
,"5":"Al fin se presentó Daniel (llamado Baltasar según el nombre de mi Dios), quien tiene en sí el espíritu de los dioses santos. Le conté el sueño y le dije:"
,"6":"'Baltasar, jefe de los magos, sé que en ti está el espíritu de los dioses santos y que no hay misterios para ti. Este es el sueño que tuve, explícamelo."
,"7":"Estaba acostado y tuve esta visión: había en el centro de la tierra un árbol que tenía gran altura."
,"8":"Creció el árbol y llegó a ser tan importante que su copa tocaba el cielo; se lo veía desde los extremos de la tierra."
,"9":"Su follaje era hermoso y sus frutos abundantes. Alimentaba a todos, las fieras salvajes se cobijaban a su sombra, los pájaros del cielo anidaban entre sus ramas, le daba su alimento a todo ser viviente."
,"10":"Contemplaba esta visión en mi cama, cuando un ángel, un Santo, bajó del cielo."
,"11":"Se puso a gritar con toda su voz: Derriben el árbol y corten sus ramas, arranquen sus hojas y boten sus frutos. Huyan de su sombra las fieras salvajes, y los pájaros del cielo, de sus ramas."
,"12":"Pero dejen en la tierra en medio de la hierba del campo su tronco y sus raíces atados con cadenas de hierro y de bronce. Que lo moje el rocío del cielo y que comparta el pasto de la tierra con los animales salvajes."
,"13":"¡Que le sea quitado su corazón de hombre y se le dé un corazón de animal, que pasen siete años sobre él!"
,"14":"Tal es el juicio pronunciado por los ángeles, tal es la decisión de los Santos; así sabrá todo ser viviente que el Altísimo es el dueño de las realezas humanas. El exalta si quiere al más humilde de los hombres."
,"15":"Este es el sueño que tuve yo, el rey Nabucodonosor; tú, Belsasar, debes explicármelo porque todos los sabios de mi reino han sido incapaces de hacerlo. Pero tú sí lo puedes hacer porque en ti está el espíritu de los dioses santos."
,"16":"Entonces Daniel, llamado Baltasar, permaneció callado por unos momentos; estaba espantado por lo que se le venía al espíritu. El rey se dirigió a él: ''¡Baltasar, no temas decirme el significado del sueño!' Belsasar tomó la palabra y le dijo: '¡Señor, ojalá que el sueño fuera para los que te odian y su significado para tus enemigos!"
,"17":"Viste un árbol que crecía y que se hacía tan importante que su copa tocaba los cielos y que se lo veía desde toda la tierra."
,"18":"Su follaje era hermoso y su fruto abundante. Alimentaba a todo el mundo, las fieras salvajes dormían bajo su sombra y entre sus ramas anidaban las aves del cielo."
,"19":"Ese árbol, oh rey, eres tú. Has crecido hasta tal punto que tu poder se eleva hasta los cielos y tu autoridad se extiende hasta los extremos de la tierra."
,"20":"Pero viste, oh rey, que bajaba del cielo un ángel, un Santo, y decía: Corten el árbol, destrúyanlo, pero dejen en la tierra el tronco y las raíces atadas con cadenas de hierro y de bronce en medio de la hierba del campo, que sea mojado por el rocío del cielo y que comparta su alimento con los animales salvajes hasta que pasen siete años sobre él."
,"21":"Esto es lo que significa, oh rey. Es una decisión del Altísimo con respecto a mi señor el rey"
," 22":"Te expulsarán de entre los hombres y vivirás con los animales salvajes, comerás pasto como el buey y te mojará el rocío del cielo. Pasarán siete años sobre ti hasta que reconozcas que el Altísimo es dueño de las realezas humanas y da el poder a quien quiere."
,"23":"Se decía que dejaran el tronco y las raíces del árbol; de igual modo te será devuelto tu reino cuando hayas comprendido que los Cielos son dueños de todo."
,"24":"Por eso, oh rey, escucha mi consejo. Redime tus pecados practicando la justicia, y tus injusticias siendo bueno con los desgraciados; entonces te irá bien en todo."
,"25":"Al rey Nabucodonosor le ocurrió todo eso."
,"26":"Doce meses después, mientras se paseaba por la terraza del palacio real de Babilonia,"
,"27":"el rey comentaba: '¿No es esta la gran Babilonia que construí con mi poder y mi fuerza, la que he convertido en mi residencia real y que será la gloria de mi reino?'"
,"28":"Todavía estaban esas palabras en la boca del rey, cuando se oyó una voz del cielo: 'A ti te hablo, rey Nabucodonosor: Se te ha quitado la realeza."
,"29":"Te expulsarán de entre los hombres, vivirás con los animales salvajes, comerás pasto como el buey, y pasarán siete años sobre ti hasta que reconozcas que el Altísimo es dueño de las realezas humanas y que da el poder a quien quiera'."
,"30":"Esas palabras se cumplieron inmediatamente. Nabucodonosor fue expulsado de entre los hombres; comía pasto como el buey y el rocío del cielo mojaba su cuerpo; sus cabellos crecieron como las plumas del águila y sus uñas como las de los pájaros."
,"31":"Al término del tiempo fijado, yo, Nabucodonosor, levanté mis ojos al cielo, y me volvió la inteligencia. Bendije al Altísimo, alabé y glorifiqué al que vive eternamente. Su poder es un poder eterno y su realeza se extiende de generación en generación."
,"32":"Para él todos los habitantes de la tierra son como la nada, hace lo que quiere con los ejércitos de los cielos y con los habitantes de la tierra; nadie puede oponerse a su poder ni decirle: ¿Qué haces?"
,"33":"En ese mismo momento, me volvió la inteligencia, recuperé mi majestad y mi esplendor y pude reanudar un reinado glorioso. Mis consejeros y mis ministros me fueron a buscar, fui restablecido en mi trono e incluso gané en poder."
,"34":"Ahora yo, Nabucodonosor, alabo, celebro y glorifico al Rey de los cielos; todos sus caminos son justos y sus obras son verdad. Sabe humillar a los que se comportan con orgullo."
}`)
	CurrentBook.AddChapter(5, `{
"1":"El rey Belsasar dio un gran banquete para miles de sus altos funcionarios, y ante esos miles de invitados, se puso a tomar vino."
,"2":"Después de haber probado el vino, Belsasar ordenó que trajeran los vasos de oro y de plata que su padre Nabucodonosor había sacado del Templo de Jerusalén. Tanto el rey como sus altos funcionarios, sus mujeres y sus concubinas querían beber en ellos."
,"3":"Trajeron pues los vasos de oro que habían sido robados del Templo de Dios en Jerusalén."
,"4":"El rey y sus altos funcionarios, sus mujeres y sus concubinas los tomaron para beber en ellos: tomaron vino a la salud de sus dioses de oro, de plata, de bronce, de hierro, de madera y de piedra."
,"5":"Pues bien, de repente aparecieron frente al candelero los dedos de una mano, que escribían sobre el estuco del muro del palacio real. El rey vio esa mano que escribía"
,"6":"e inmediatamente cambió de color: estaba espantado, todo su cuerpo y todos sus miembros temblaban."
,"7":"Gritó con fuerte voz para que llamaran a los magos, los brujos y los astrólogos, y ante los sabios de Babilonia el rey tomó la palabra: 'El hombre que lea lo que ahí está escrito y que me dé a conocer su significado será revestido de púrpura, se le pondrá un collar de oro al cuello y ocupará el tercer puesto en mi reino'."
,"8":"Pero ninguno de los sabios que había venido era capaz de descifrar la inscripción y de entregar su sentido."
,"9":"El rey Belsasar se espantó más aún, estaba ya sin colores y sus altos funcionarios estaban muy asustados."
,"10":"Al enterarse de las palabras del rey y de sus altos funcionarios, la reina entró en el salón del festín, pidió la palabra y dijo: '¡Viva el rey eternamente! No te perturben tus pensamientos ni cambie así de color tu rostro."
,"11":"Hay un hombre en tu reino que tiene en sí el espíritu de los dioses santos. Durante el reinado de tu padre pudieron darse cuenta de que había en él una luz, un juicio y una sabiduría digna de los dioses. Por eso el rey tu padre lo puso como jefe de los adivinos, de los magos, de los brujos y de los astrólogos."
,"12":"Se notaba en él un espíritu superior, una inteligencia, un juicio, el arte de explicar los sueños, de interpretar los misterios y de resolver los problemas, hablo de Daniel a quien el rey había puesto el nombre de Baltasar. Llamemos por tanto a Daniel y él nos dirá lo que significa todo esto."
,"13":"Trajeron pues a Daniel a la presencia del rey. El rey tomó la palabra y le dijo: '¿Eres tú Daniel, uno de los desterrados que mi padre trasladó desde Judea?"
,"14":"Me han dicho que en ti reside el espíritu de los dioses y que han notado en ti una luz, un juicio y una sabiduría extraordinarias."
,"15":"Pues bien, acaban de traerme a los sabios y a los magos para que leyeran esa escritura y me dieran su significado, pero han sido incapaces de hacerlo."
,"16":"Después me dijeron que tú puedes interpretar y resolver los problemas. Si puedes leer lo que allí está escrito y darme a conocer su significado, serás revestido de púrpura, llevarás un collar de oro al cuello y serás la tercera persona del reino'."
,"17":"Entonces Daniel tomó la palabra y delante del rey dijo: '¡Guarda tus regalos o dáselos a otros! Voy a descifrar para el rey lo que está allí escrito y le daré a conocer el significado."
,"18":"Oh rey, el Dios Altísimo dio a tu padre Nabucodonosor la realeza, el poder, la gloria y la majestad."
,"19":"Debido a ese poder que había recibido, los hombres de todos los pueblos, naciones y lenguas estaban llenos de terror y temblaban ante él. Mataba o dejaba vivir a su arbitrio, elevaba o bajaba a quien quería."
,"20":"Pero cuando su corazón se infló de orgullo y se endureció su espíritu, fue echado de su trono real y se le quitó la gloria."
,"21":"Fue expulsado de entre los hombres porque su espíritu se transformó en el de un animal; vivía con los burros salvajes, se alimentaba de pasto como el buey, y su cuerpo era mojado por el rocío del cielo. Eso duró hasta el día en que reconoció que el Dios Altísimo es el dueño de las realezas humanas y que llama a quien quiera."
,"22":"Pero tú Belsasar, su hijo, no te has humillado siendo que sabías todo eso."
,"23":"Al contrario, te alzaste en contra del Señor de los cielos, dispusiste que te trajeran los vasos de su Templo y han tomado vino en ellos tú, tus altos funcionarios, tus mujeres y tus concubinas. Y han bebido a la salud de sus dioses de plata y de oro, de bronce, de hierro, de madera y de piedra, que nada ven, nada entienden y nada saben. Pero tú no has glorificado al Dios que tiene tu vida en su mano y a quien pertenece todo tu destino."
,"24":"Por eso fue enviada de su parte esa mano para que trazara ese escrito,"
,"25":"y ese escrito dice: 'Mené, Mené', 'Téquel' y 'Parsin'."
,"26":"Ahora viene la explicación de esas palabras: 'Mené': Dios ha medido tu reino y le ha puesto fin."
,"27":"'Téquel': has sido pesado en la balanza y tu peso ha resultado muy liviano."
,"28":"'Parsin': tu reino ha sido dividido y dado a los Medos y a los Persas'."
,"29":"Entonces Belsasar ordenó que se revistiera de púrpura a Daniel, que le pusieran al cuello un collar de oro y que se proclamara que de ahora en adelante era el tercer personaje de su reino."
,"30":"Pero esa misma noche el rey caldeo Belsasar fue asesinado."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Y recibió su reinado Darío el medo, que tenía ya sesenta y dos años."
,"2":"Darío dio un decreto para su reino: puso a ciento veinte gobernadores al frente de cada una de las provincias de su reino."
,"3":"Para preservar los intereses del rey, debían rendir cuentas a tres altos funcionarios que estaban sobre ellos (uno de los cuales era Daniel)."
,"4":"Pero Daniel se distinguió pronto entre los altos funcionarios y gobernadores porque había en él un espíritu realmente superior tanto que el rey pensaba ponerlo a la cabeza de todo su reino."
,"5":"Por eso fue que los altos funcionarios y gobernadores buscaron entre los asuntos del estado un pretexto para acusar a Daniel, pero no encontraban ningún reproche que hacerle porque era fiel y no podían reprocharle ni negligencia ni falta."
,"6":"Esos hombres se pusieron entonces a decir: 'Ya que no se le puede reprochar nada a ese Daniel, busquemos algún pretexto en la religión de su Dios'."
,"7":"Los altos funcionarios y los gobernadores se precipitaron donde el rey y le dijeron: '¡Viva para siempre el rey Darío!"
,"8":"Todos los altos funcionarios del reino, los prefectos, gobernadores, consejeros y hombres de leyes, piensan que sería bueno que se proclamara una prohibición por decreto real: Cualquiera que, durante treinta días dirija una plegaria a otro dios o a otra persona fuera de ti, oh rey, sea arrojado al foso de los leones."
,"9":"Ahora, oh rey, toma esa decisión, haz que se ponga por escrito para que no sea modificada y así, según la ley de los Medos y de los Persas, nadie pueda anularla'."
,"10":"El rey Darío firmó pues esa decisión."
,"11":"Cuando Daniel supo que había sido firmado ese decreto, entró en su casa; su pieza estaba en el segundo piso y las ventanas daban a Jerusalén. Tres veces al día Daniel se ponía de rodillas, oraba y alababa a Dios como lo había hecho siempre."
,"12":"Pues bien esos hombres entraron en tropel y encontraron a Daniel que estaba suplicando e implorando a su Dios."
,"13":"Corrieron donde el rey y le recordaron la prohibición real: '¿No firmaste un decreto según el cual cualquier hombre que en estos treinta días dirija una oración a otro dios o a otra persona fuera de ti, sería arrojado al foso de los leones?' El rey respondió: 'Así se ha establecido firmemente, según la ley de los medos y de los persas: nadie puede ir en contra'."
,"14":"Entonces dijeron al rey: 'Daniel, ese hombre que forma parte de los desterrados de Judá, no tiene respeto alguno por ti ni por la prohibición que tú firmaste. Hace su oración tres veces al día'."
,"15":"Al oír esas palabras, el rey se molestó mucho; quería salvar a Daniel y hasta la puesta del sol, buscó en vano una solución."
,"16":"Pero esos hombres lo presionaban, diciéndole: '¡Sabes muy bien, oh rey, que según la ley de los Medos y de los Persas ninguna prohibición o decreto firmado por el rey puede ser anulado!'."
,"17":"Entonces el rey ordenó que detuvieran a Daniel y que lo arrojaran al foso de los leones. El rey dijo a Daniel: '¡Ojalá te salve tu Dios, al que sirves con tanta fidelidad!'."
,"18":"Empujaron una gran piedra para cerrar la boca del foso; el rey y los altos funcionarios pusieron en ella sus sellos para que nada pudiera cambiar la suerte de Daniel."
,"19":"El rey entró en su palacio, ayunó toda la noche y no quiso acostarse con sus concubinas; no pudo dormir."
,"20":"Aun antes de que saliera el sol, el rey se levantó y se dirigió a toda prisa al foso de los leones."
,"21":"Se acercó al foso y gritó a Daniel con voz angustiada: '¿Daniel, servidor del Dios vivo, ese Dios al que sirves con tanta fidelidad ha sido capaz de librarte de los leones?'"
,"22":"Daniel respondió al rey: '¡Viva el rey para siempre!"
,"23":"Mi Dios me envió a su ángel, quien cerró las fauces de los leones, los que ni siquiera me han tocado porque fui hallado inocente ante él, y ante ti, oh rey, también soy inocente'."
,"24":"El rey experimentó una gran alegría y dio orden de que sacaran a Daniel del foso. Sacaron pues a Daniel del foso de los leones y lo encontraron en perfecto estado porque había puesto su confianza en su Dios."
,"25":"Entonces el rey mandó que vinieran los hombres que habían calumniado a Daniel, los arrojó al foso de los leones junto con sus hijos y sus mujeres, y aun antes que tocaran el suelo del foso, los leones se abalanzaron sobre ellos y trituraron sus huesos."
,"26":"El rey Darío escribió a todos los pueblos, naciones y lenguas que viven en toda la tierra: '¡La abundancia y la paz sean con ustedes!"
,"27":"Este es el decreto que promulgo: En toda la extensión de mi reino, la gente temerá y respetará al Dios de Daniel. El es el Dios vivo, que permanece para siempre: su reino no será destruido y su imperio no tendrá fin."
,"28":"El salva y libra, realiza señales y prodigios en los cielos y en la tierra: él salvó a Daniel de las garras y de los dientes de los leones'."
,"29":"Durante el reino de Darío y él de Ciro el Persa, Daniel fue cada vez más considerado."
}`)
	CurrentBook.AddChapter(7, `{
"1":"El primer año de Belsasar, rey de Babilonia, una noche Daniel tuvo un sueño y visiones que puso por escrito. Este es el relato."
,"2":"Daniel tomó la palabra y dijo: 'Tuve visiones durante la noche: cuatro vientos del cielo sacudían el mar,"
,"3":"y cuatro animales enormes salían del mar; los cuatro eran diferentes."
,"4":"El primero se parecía a un león con alas de águila; mientras lo estaba mirando, le arrancaron sus alas, fue levantado de la tierra y se paró sobre sus patas como un hombre; le fue dado un corazón de hombre."
,"5":"El segundo se parecía a un oso, estaba echado de lado y tenía entre sus dientes tres costillas. Entonces se le dijo: 'Levántate y come mucha carne'."
,"6":"Miré y vi a otro animal parecido a un leopardo, con cuatro alas en el lomo; tenía cuatro cabezas, y le fue dado el poder."
,"7":"Mientras contemplaba mis visiones nocturnas, percibí a un cuarto animal terrible, espantoso, con increíble poder; tenía grandes dientes de hierro, comía, trituraba, y lo sobrante lo aplastaba con sus patas. Era distinto a todos los animales que lo habían precedido, tenía diez cuernos."
,"8":"Estaba mirando los cuernos cuando surgió de entre ellos un cuerno pequeño, y fueron arrancados tres cuernos para dejarle lugar. Entonces vi en ese cuerno ojos parecidos a los ojos humanos y una boca que pronunciaba palabras insolentes."
,"9":"Seguía mirando, pusieron unos tronos y un anciano se sentó; su ropa era blanca como la nieve, los cabellos de su cabeza eran como la lana blanca, su trono era de llamas de fuego con ruedas de fuego ardiente."
,"10":"Un río de fuego brotaba y corría de delante de él; miles y millares le servían, millones y millones permanecían de pie en su presencia. Se constituyó el tribunal y abrieron los libros."
,"11":"Las palabras insolentes que habían sido pronunciadas por el cuerno habían sembrado un gran desorden. Mientras estaba mirando, mataron al animal, su cadáver fue destruido y arrojado al fuego ardiente."
,"12":"Se les quitó el poder a los otros animales, pero se les prolongó la vida por el momento hasta la fecha fijada."
,"13":"Mientras seguía contemplando esas visiones nocturnas, vi algo como un hijo de hombre que venía sobre las nubes del cielo; se dirigió hacia el anciano y lo llevaron a su presencia."
,"14":"Se le dio el poder, la gloria y la realeza, y todos los pueblos, naciones y lenguas lo sirvieron. Su poder es el poder eterno que nunca pasará; su reino no será destruido."
,"15":"Yo Daniel seguía allí. Mi espíritu estaba perturbado por todo eso, pues esas visiones me habían aterrorizado."
,"16":"Me acerqué entonces a uno de los que estaban de pie y le pedí que me dijera qué era realmente todo lo que había visto. Me habló y dio el significado de todas esas cosas."
,"17":"Esos cuatro animales enormes son cuatro reyes que aparecerán en la tierra,"
,"18":"después de lo cual los santos del Altísimo recibirán la realeza y la poseerán por los siglos de los siglos."
,"19":"Quería además saber la verdad respecto al cuarto animal, tan diferente a los demás y tan horrible con sus dientes de hierro y sus garras de bronce, que devoraba, trituraba y luego pisoteaba todo lo que quedaba."
,"20":"Quería saber qué eran esos diez cuernos que tenía en su cabeza, y el otro cuerno que había brotado y ante el cual habían caído tres de los primeros. Quería saber qué era ese cuerno con ojos y una boca que pronunciaba palabras insolentes y que parecía ser más importante que los demás."
,"21":"Seguía mirando ese cuerno, que combatía a los santos y que los vencía,"
,"22":"hasta que llegó el anciano, quien dictó sentencia en favor de los santos del Altísimo, y en ese momento los santos tomaron posesión del reino."
,"23":"Entonces aquel a quien había preguntado me dijo: 'El cuarto animal es un cuarto reino que habrá en la tierra y que será distinto a todos los demás; devorará a toda la tierra, la aplastará y la pisoteará. "
,"24":"Esos diez cuernos son diez reyes que se levantarán en ese reino, luego surgirá otro después de ellos, diferente a los anteriores, y que derrotará a tres reyes."
,"25":"Insultará al Altísimo, perseguirá a los santos del Altísimo, tratará de cambiar el calendario y la Ley; los santos quedarán sometidos a su poder por un tiempo, dos tiempos y la mitad de un tiempo."
,"26":"Pero se constituirá el Tribunal, se le quitará el poder, y será destruido y exterminado para siempre."
,"27":"Entonces la realeza, la autoridad y la grandeza de todos los reinos que están bajo los cielos serán dadas al pueblo de los santos del Altísimo; su reinado es un reinado eterno y todos los poderes le servirán y le obedecerán'."
,"28":"Aquí se acaba el relato. Esas visiones me habían aterrorizado a mí, Daniel, y mi rostro había mudado de color, pero conservaba todo eso en mi corazón."
}`)
	CurrentBook.AddChapter(8, `{
"1":"El tercer año del reinado de Belsasar, yo Daniel, recibí una nueva visión como continuación de las anteriores."
,"2":"Durante esa visión vi la ciudadela de Suza, en la provincia de Elam; en esa visión me encontraba a orillas del río Ulay, y miraba desde allí."
,"3":"Al levantar los ojos vi a un carnero con dos cuernos que estaba de pie frente al torrente. Los dos cuernos eran grandes pero uno sobrepasaba al otro, y el más grande fue el último en despuntar."
,"4":"Vi al carnero que daba cornadas al oeste, al norte y al sur; ningún animal podía resistirle ni nada podía escapársele. Hacía lo que quería y se volvió poderoso."
,"5":"Cuando trataba de entender eso, divisé a un chivato que venía del occidente después de haber recorrido toda la tierra, pero sin tocar el suelo; ese chivo tenía un enorme cuerno entre los ojos."
,"6":"Se acercó al carnero de dos cuernos que había visto en la orilla y se abalanzó contra él con todas sus fuerzas."
,"7":"Vi como embestía al carnero: lo golpeó furiosamente y le quebró ambos cuernos sin que el carnero opusiera resistencia. Lo tiró al suelo, lo pisoteó y nadie pudo librar al carnero de sus manos."
,"8":"El chivo se hizo muy poderoso, pero, en el colmo de su poder, el gran cuerno se rompió y brotaron en vez de él cuatro cuernos, vueltos a los cuatro vientos del Cielo."
,"9":"De uno de ellos salió un cuerno más pequeño, pero que se extendió mucho en dirección del sur, del este y de la tierra de Belleza."
,"10":"Alcanzó el ejército de los cielos e hizo caer a la tierra una parte de él como estrellas a las que pisoteó."
,"11":"Se alzó incluso contra el jefe de ese ejército: le quitó el sacrificio perpetuo y sacudió los cimientos de su santuario"
,"12":"junto con su ejército. En el mismo lugar en que se presentaba el sacrificio, erigió la Abominación, pisoteó la verdad y tuvo éxito en todo lo que hizo."
,"13":"Oí entonces a un Santo que hablaba y a otro Santo que le hizo esta pregunta: '¿Hasta cuándo durará lo que anuncia esta visión: el sacrificio perpetuo suprimido, la Abominación erigida y el lugar santo y el ejército pisoteados?'"
,"14":"Le respondió: 'Hasta dos mil trescientas tardes y mañanas; entonces será restablecido el lugar santo como corresponde'."
,"15":"Ahora bien, mientras yo Daniel contemplaba la visión y trataba de comprenderla, creí ver a un hombre delante de mí"
,"16":"y escuché una voz a orillas del Ulay que le gritaba: 'Gabriel, dale a entender la visión'."
,"17":"Se dirigió entonces al sitio donde me encontraba, pero al acercárseme me asusté y caí con el rostro en tierra. Me dijo: 'Hijo de hombre, entiende que esta visión se refiere al tiempo del fin'."
,"18":"Mientras estaba postrado en tierra y me hablaba, perdí el conocimiento; me tocó y me levantó."
,"19":"Luego me dijo: 'Ahora te voy a dar a conocer lo que sucederá al fin del tiempo de la cólera, porque el fin está ya decidido."
,"20":"El carnero que viste con sus dos cuernos son los reyes de los Medos y de los Persas."
,"21":"El chivo velludo es el rey de Yaván, el gran cuerno entre sus ojos es el primero de sus reyes."
,"22":"El cuerno roto y los cuatro cuernos que brotaron en su lugar son cuatro reinos surgidos de esa nación, pero que no alcanzarán su poder."
,"23":"Al término de su reinado, cuando el pecado haya llegado al máximo, verán cómo se levanta un rey con el rostro fiero que desafiará las dificultades."
,"24":"Su poder aumentará sin cesar, llevará a cabo cosas increíbles y tendrá éxito en sus empresas. Destruirá a los poderosos y al pueblo de los santos."
,"25":"Debido a su astucia sus estratagemas tendrán éxito; se inflará de orgullo y destruirá a mucha gente por sorpresa. Se alzará contra el Rey de reyes, pero sin que intervenga la mano del hombre será derrotado."
,"26":"Esta visión de las tardes y de las mañanas que acabas de ver se cumplirá, pero guárdala para ti solo pues se refiere a un porvenir lejano'."
,"27":"Yo Daniel me desmayé; estuve enfermo muchos días, luego me levanté para ocuparme de los asuntos del rey. Pero seguía consternado por esa visión que no entendía."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Era el primer año de Darío, hijo de Artajerjes, el Medo, que reinó en el reino de los Caldeos."
,"2":"Ese primer año de su reinado, yo Daniel estudiaba las Escrituras y sacaba la cuenta de esos setenta años que debían pasar sobre Jerusalén en ruinas como le fue revelado al profeta Jeremías."
,"3":"Volví mi mirada hacia el Señor Dios para invocarlo en la oración y suplicarle por medio del ayuno, la penitencia y la ceniza."
,"4":"Le supliqué a Yavé, mi Dios y le hice esta confesión: '¡Ah, mi Señor, Dios grande y temible que conservas la alianza y tu misericordia con los que te aman y observan tus mandamientos!"
,"5":"Pecamos, cometimos injusticias, fuimos infieles, nos rebelamos; nos apartamos de tus mandamientos y de tus leyes."
,"6":"No hicimos caso a tus servidores los profetas que hablaban en tu nombre a nuestros reyes, a nuestros jefes y a nuestros padres como también a toda la nación."
,"7":"Tú, Señor, has sido justo y nosotros sólo tenemos derecho a la vergüenza como en ese día, nosotros la gente de Judá, los habitantes de Jerusalén y todo Israel, estemos cerca o lejos en todos los países donde nos dispersaste por culpa de las infidelidades que cometimos contra ti."
,"8":"Oh Yavé, la vergüenza sea para nosotros, para nuestros reyes, nuestros jefes y nuestros padres, porque pecamos contra ti."
,"9":"Que el Señor nuestro Dios tenga misericordia y nos perdone porque nos rebelamos contra él."
,"10":"No obedecimos a Yavé nuestro Dios, no caminamos según sus leyes que puso delante de nosotros por medio de sus servidores los profetas."
,"11":"Todo Israel desobedeció a tu Ley y se apartó de tu palabra; por eso cayeron sobre nosotros la maldición y las amenazas que están escritas en la Ley de Moisés, servidor de Dios, porque habíamos pecado contra ti."
,"12":"Yavé cumplió las palabras que había pronunciado contra nosotros y contra los jefes que nos gobernaban. Hizo que cayera sobre nosotros una terrible desgracia; nunca se había visto bajo el cielo lo que pasó en Jerusalén."
,"13":"Cayó sobre nosotros la desgracia como está escrito en la Ley de Moisés, pero no apaciguamos a Yavé nuestro Dios, renunciando a nuestra mala conducta y prestando atención a su verdad."
,"14":"Yavé fue quien previó esa desgracia y la dejó caer sobre nosotros, porque Yavé es justo en todo lo que hace: no habíamos escuchado su voz."
,"15":"Señor nuestro Dios, cuya fama es eterna, tú que con mano poderosa hiciste salir a tu pueblo del país de Egipto, contra ti pecamos y nos rebelamos."
,"16":"Señor, en tu gran bondad, aparta tu cólera y tu furor de Jerusalén, tu ciudad, y de tu montaña santa, pues por culpa de nuestros pecados y de los pecados de nuestros padres Jerusalén y tu pueblo son motivo de burla de parte de todos los que nos rodean."
,"17":"Escucha pues, tú, nuestro Dios, la oración de tu servidor y su súplica. Por tu honor, Señor, haz que brille tu rostro sobre tu santuario en ruinas."
,"18":"Pon atención, oh Dios mío, escucha, abre tus ojos, mira nuestra ruina y la ciudad sobre la cual ha sido pronunciado tu Nombre. Te lo suplicamos; no esperamos nada de nuestros méritos, sino que confiamos en tu gran misericordia."
,"19":"Escucha, Señor, perdona, Señor, mira, Señor. Actúa oh mi Dios, no tardes por amor de ti mismo, porque tu ciudad y tu pueblo son llamados por tu nombre."
,"20":"A la hora de la ofrenda de la tarde estaba todavía hablando y orando, confesando mi pecado y el de mi pueblo Israel, suplicando a Yavé mi Dios por su santa montaña."
,"21":"En esto llegó volando hasta mí Gabriel, al que había visto en la visión al comienzo."
,"22":"Llegó hasta donde yo estaba y me dijo: 'Daniel, he venido ahora para que puedas comprender."
,"23":"Al principio de tu oración salió una palabra y he venido para dártela a conocer porque eres amado de Dios. Aplica tu espíritu a esa palabra y comprende la visión."
,"24":"Para tu pueblo y tu ciudad santa se han fijado setenta semanas, para que se termine el pecado, para expiar la ofensa, para que venga la justicia eterna, para que se cumpla la visión y la profecía, para ungir al Santo de los Santos."
,"25":"Entiende bien esto: Desde que se haya dado la orden de reconstruir Jerusalén hasta un jefe consagrado, son siete semanas; luego pasarán sesenta y dos semanas para reconstruir plazas y muros. Luego llegará el fin de los tiempos. "
,"26":"Después de las sesenta y dos semanas, será eliminado un hombre consagrado, sin que se encuentre culpa en él. Llegará un pueblo cuyo jefe destruirá la ciudad y el Templo: todo quedará sumergido y habrá guerras y desastres hasta el fin."
,"27":"Durante una semana consolidará su alianza con muchos, durante media semana interrumpirá el sacrificio y la ofrenda. Junto al Templo erigirá la Abominación de la Devastación hasta el tiempo fijado para la ruina del devastador."
}`)
	CurrentBook.AddChapter(10, `{
"1":"El tercer año de Ciro, rey de Persia, una palabra fue revelada a Daniel, de sobrenombre Baltasar. Este mensaje fidedigno se refería a una prueba grande. Daniel comprendió la palabra y recibió la explicación de la visión."
,"2":"En ese tiempo, yo Daniel, guardaba luto por tres semanas."
,"3":"Durante esas tres semanas no probé comidas exquisitas, me privé de carne y de vino y renuncié a cualquier perfume."
,"4":"El día vigésimo cuarto del primer mes estaba a orillas del gran río Tigris."
,"5":"Al levantar los ojos, vi a un hombre vestido de lino que llevaba un cinturón de oro brillante."
,"6":"Su cuerpo parecía de piedras preciosas, su rostro tenía el aspecto del rayo; sus ojos eran como lámparas encendidas, sus brazos y sus piernas brillaban como el bronce bruñido y sus palabras resonaban como el estruendo de una muchedumbre."
,"7":"Sólo yo Daniel contemplé esa visión; los hombres que me acompañaban no vieron nada, pero se apoderó de ellos un gran susto y corrieron a esconderse."
,"8":"Seguí contemplando solo esa gran visión. Estaba sin fuerzas, mi rostro había cambiado de color y perdí el control de todos mis sentidos."
,"9":"Oí lo que se decía y, al oírlo, caí desvanecido con el rostro en tierra."
,"10":"Entonces me tocó una mano que me hizo temblar en todos mis miembros."
,"11":"El hombre me dijo: 'Daniel, toma en serio las palabras que te digo y manténte de pie, he sido enviado hasta ti porque tú eres amado de Dios'. Cuando me hubo hablado así, pude ponerme de pie aunque seguía temblando."
,"12":"Luego añadió: 'No tengas miedo, Daniel, porque desde el primer día en que trataste de comprender y de humillarte ante la mirada de tu Dios, tus palabras fueron escuchadas y por eso vine yo en persona'."
,"13":"El príncipe del reino de los Persas me resistió durante veintiún días, pero vino en mi ayuda Miguel, uno de los principales príncipes. Lo dejé luchando con el rey de Persia"
,"14":"y vine a explicarte lo que ocurrirá a tu pueblo al fin de los tiempos. Porque esta visión también se refiere a esos días."
,"15":"Ante esas palabras incliné hacia el suelo la cabeza y me quedé sin palabras."
,"16":"Pero me tocó los labios un personaje de aspecto humano. Abrí la boca para hablar y dije al que estaba delante de mí: 'Señor mío, esa visión me ha llenado de angustia y me ha descontrolado."
,"17":"Soy sólo el servidor de mi señor, ¿cómo podré hablar a mi señor si estoy sin fuerzas y me falta el aliento?'"
,"18":"El personaje que parecía un hombre me tocó de nuevo y me reconfortó."
,"19":"Me dijo: '¡No temas, tú que eres amado de Dios, la paz sea contigo! ¡Animo, ánimo!' Y mientras me hablaba, sentí que me volvían las fuerzas. Le dije: 'Hable mi señor, porque me siento mejor'."
,"20":"-"
,"21":"Añadió: '¿Sabes por qué he venido donde ti? Te anunciaré lo que está escrito en el libro de la verdad. Y luego regresaré a luchar con el príncipe de Persia. También está por llegar el príncipe de Yaván; nadie me ayuda contra ellos, excepto Miguel, el príncipe de ustedes."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Has de saber que el primer año de Darío, el Medo, estaba yo cerca de él ayudándolo y animándole. Y ahora te revelaré la verdad: "
,"2":"en Persia surgirán todavía tres reyes y el cuarto será mucho más rico que los demás. Su riqueza lo volverá poderoso y hará todo lo posible para oponerse al reino de Yaván."
,"3":"Pero allí surgirá un rey valiente que se volverá poderoso y hará lo que quiera."
,"4":"En medio de sus éxitos, será rota su realeza y su reino repartido a los cuatro vientos del cielo, pero no entre sus descendientes pues le será arrebatado el reino y entregado a otros."
,"5":"El rey del sur se hará poderoso, pero uno de sus príncipes lo vencerá y se forjará un imperio más grande que el suyo."
,"6":"Al cabo de algunos años establecerá una alianza: la hija del rey del sur irá en busca del rey del norte para establecer un acuerdo, pero perderá su poder y no dejará descendencia: será luego asesinada junto con su corte, su hijo y su marido. En ese momento"
,"7":"se levantará en su lugar un retoño de su raza, llegará a sitiar la fortaleza del rey del norte, se apoderará de ella y la tratará como vencedor."
,"8":"E incluso llevará a Egipto como botín sus dioses, sus estatuas y sus vasos preciosos de plata y oro. Y durante algunos años mantendrá a raya al rey del norte."
,"9":"Este último hará una expedición al reino del sur, pero regresará rápidamente a su casa."
,"10":"Se levantarán sus hijos y reunirán fuerzas numerosas y poderosas. Uno de ellos descollará, desbordará como un río, invadirá el reino del sur y atacará la fortaleza de su rey."
,"11":"Furioso éste, se pondrá en campaña en contra del rey del norte con un poderoso ejército, y las numerosas tropas del rey del norte caerán en sus manos."
,"12":"La destrucción de ese ejército acrecentará su orgullo; masacrará a una gran cantidad de gente, pero sin resultado."
,"13":"El rey del norte volverá después de haber reunido tropas más numerosas que las primeras, y después de algunos años avanzará con un ejército poderoso y muy bien equipado."
,"14":"En ese momento se rebelarán contra el rey del sur mucha gente, y entre ellos, hombres violentos de tu pueblo; se alzarán porque la visión tiene que cumplirse, pero será para su perdición."
,"15":"El rey del norte avanzará, cavará trincheras y se apoderará de una ciudad fortificada; el ejército del sur no podrá resistir ante su empuje y los más valientes de sus hombres huirán."
,"16":"Entonces el atacante hará todo lo que quiera, nadie quedará en pie ante él, ocupará el país de Belleza y lo saqueará."
,"17":"Queriendo dominar todo el reino del sur, hará un pacto con él y le dará como esposa a una de sus hijas con el fin de destruirlo, pero eso no resultará ni se realizará."
,"18":"Se volverá entonces contra las islas y se apoderará de muchas de ellas, pero un jefe lo detendrá y lo humillará sin que pueda tomarse la revancha."
,"19":"Atacará después las ciudades fortificadas de su país, pero fracasará, será derrotado y desaparecerá para siempre."
,"20":"En su lugar aparecerá otro que enviará al lugar más glorioso del reino a un recaudador de impuestos, pero en unos pocos días éste será vencido sin armas ni lucha."
,"21":"En su lugar surgirá un hombre despreciable a quien no darán el honor de la realeza; llegará en son de paz y se apoderará del reino mediante traiciones."
,"22":"Ante él huirán y serán derrotados poderosos ejércitos; el Príncipe de la Alianza también será vencido."
,"23":"Utilizando la corrupción y la traición adquirirá importancia y se hará fuerte, aunque sólo tenga con él poca gente."
,"24":"Invadirá sin riesgo ricas provincias y hará lo que ni sus padres ni los padres de sus padres hicieron: distribuirá entre sus hombres botín, despojos y riqueza, y por un tiempo tratará de apoderarse de fortalezas."
,"25":"Dirigirá sus fuerzas y su ardor contra el rey del sur, apoyado en un gran ejército; el otro también saldrá a guerrear con un ejército grande y poderoso, pero será vencido como consecuencia de conspiraciones en su contra."
,"26":"Los que coman en su mesa lo debilitarán, su ejército será aplastado y perderá a mucha gente."
,"27":"Los dos reyes no pensarán más que en hacerse el mal mutuamente, y aunque estén sentados a la misma mesa se mentirán el uno al otro. Esto no cambiará nada: el fin llegará en el tiempo determinado."
,"28":"El rey del norte regresará a su país con grandes riquezas y con perversos proyectos en contra de la Alianza Santa; luchará contra ella y luego volverá a su país."
,"29":"Cuando llegue el momento, volverá a lanzarse contra el reino del sur, pero esta vez las cosas acabarán mal."
,"30":"Al ver que se acercan los barcos de Quitim perderá su seguridad, dará media vuelta y desencadenará su cólera en contra de la Alianza Santa. Nuevamente colmará de honores a los que abandonen esta alianza. "
,"31":"Sus tropas vendrán para profanar la fortaleza del templo, interrumpirán el sacrificio perpetuo y levantarán la Abominación de la Desolación."
,"32":"Seducirá y corromperá a hombres infieles a la alianza, pero el pueblo de los que conocen a su Dios se mantendrá firme en su comportamiento."
,"33":"Aquellos del pueblo que tengan el conocimiento instruirán a muchos, pero serán perseguidos: durante muchos días les tocará en suerte la espada, el fuego, el cautiverio y el pillaje."
,"34":"Durante su persecución, algunos les prestarán apoyo, pero muchos lo harán por hipocresía."
,"35":"La caída de algunos de los que saben servirá para purificar, lavar y blanquear a muchos de los demás hasta el tiempo del fin, el cual ya ha sido fijado, pero que todavía es futuro."
,"36":"En su orgullo, el rey hará todo lo que quiera, se pondrá por encima de todos los dioses; hasta pronunciará palabras insolentes contra el Dios de los dioses, y todo le resultará hasta que la Cólera llegue al colmo, porque lo que está decidido se cumplirá."
,"37":"No tendrá miramiento alguno ni por los dioses de sus padres ni por el dios preferido de las mujeres ni por cualquier otro dios, sino que se pondrá por encima de todo."
,"38":"En vez de esos dioses honrará al dios de las fortalezas, un dios que no conocieron sus padres, le ofrecerá oro, plata, piedras preciosas y objetos de gran valor."
,"39":"Pondrá sitio a las ciudades fortificadas con ayuda de un dios extranjero; al que reconozca a ese dios le concederá honores, poder, y tierras en recompensa."
,"40":"En los tiempos del fin, el rey del sur lo atacará; el rey del norte se lanzará contra él con sus carros, sus caballeros y numerosos barcos. Entrará por todos sus territorios, los invadirá y los atravesará."
,"41":"Atravesará el país de Belleza y masacrará a mucha gente, mientras que Edom, Moab y los mejores de los hijos de Amón escaparán de sus manos."
,"42":"Extenderá su mano por todos los países y Egipto no se escapará."
,"43":"Se apoderará de los tesoros de oro y plata y de todos los objetos de valor de Egipto. Someterá a los libios y a los cuchitas."
,"44":"Pero noticias provenientes del oriente y del norte le preocuparán; regresará muy enojado para destruir y masacrar a mucha gente."
,"45":"Plantará las tiendas de campaña de su ejército entre el mar y las montañas del país de Belleza. Después de eso le tocará su fin y nadie lo socorrerá."
}`)
	CurrentBook.AddChapter(12, `{
"1":"En aquel tiempo se levantará Miguel, el gran príncipe, que defiende a los hijos de tu pueblo; porque será un tiempo de calamidades como no lo hubo desde que existen pueblos hasta hoy en día. En ese tiempo se salvará tu pueblo, todos los que estén inscritos en el Libro."
,"2":"Muchos de los que duermen en el lugar del polvo despertarán, unos para la vida eterna, otros para vergüenza y horror eternos."
,"3":"Los que tengan el conocimiento brillarán como un cielo resplandeciente, los que hayan guiado a los demás por la justicia brillarán como las estrellas por los siglos de los siglos."
,"4":"Tú, Daniel, guarda en secreto estas palabras, que sean como un libro sellado hasta el momento del fin; muchos buscarán por aquí y por allá y la maldad irá en aumento.'"
,"5":"Al levantar la vista, yo Daniel, vi a otros dos hombres que estaban en una y otra orilla del río."
,"6":"Uno de ellos dijo al hombre vestido de lino que estaba por encima de las aguas del río: '¿Cuándo se cumplirán esas cosas prodigiosas?'"
,"7":"El hombre vestido de lino que estaba por encima de las aguas del río levantó entonces sus dos manos al cielo y le oí que hacía este juramento por el que vive eternamente: 'Todo se realizará en un tiempo, dos tiempos y un medio tiempo. Todas estas cosas se cumplirán cuando el pueblo santo esté completamente aplastado y sin fuerzas.'"
,"8":"Oía pero no entendía. Hice entonces esta pregunta: '¿Señor mío, cómo será el fin de las cosas?'"
,"9":"Me respondió: 'Anda, Daniel, estas cosas permanecerán en secreto y ocultas hasta el momento del fin."
,"10":"Muchos serán purificados, blanqueados y puestos a prueba; los malos harán el mal y no comprenderán, mas los que tienen el conocimiento comprenderán."
,"11":"Desde el día en que se suprima el sacrificio perpetuo y en que se erija la Abominación de la Desolación pasarán mil doscientos noventa días."
,"12":"Feliz el que se mantenga en pie y llegue a mil trescientos treinta y cinco días."
,"13":"En cuanto a ti, Daniel, sigue hasta el fin de tu camino; irás a tu descanso y luego te levantarás al fin de los días para recibir tu recompensa'."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Había en Babilonia un hombre llamado Joaquín."
,"2":"Se había casado con una mujer llamada Susana, hija de Helquías, que era muy bella y temía a Dios"
,"3":"pues sus padres eran excelentes y habían educado a su hija según la ley de Moisés."
,"4":"Joaquín era muy rico, tenía un jardín al lado de su casa; muchos judíos venían a su casa porque era el más respetado de todos."
,"5":"Ese año habían elegido como jueces a dos ancianos del pueblo, de los cuales ha dicho el Señor: 'La injusticia se manifestó en Babilonia por medio de los ancianos, de jueces que querían hacerse pasar por jefes de mi pueblo'."
,"6":"Esos hombres frecuentaban la casa de Joaquín y todos los que tenían un litigio venían a verles."
,"7":"Cuando el pueblo se retiraba al mediodía, Susana iba al jardín de su marido para pasearse en él."
,"8":"Los dos ancianos que la veían diariamente entrar y pasearse, comenzaron a desearla;"
,"9":"perdieron por ella la cabeza, dejaron de mirar al Cielo y se olvidaron de sus justas sentencias."
,"10":"Ambos estaban devorados por la misma pasión, pero se la ocultaban el uno al otro;"
,"11":"sentían vergüenza de confesar el deseo que se los comía de acostarse con ella,"
,"12":"pero cada día hacían todo lo posible para verla."
,"13":"Un día se dijeron el uno al otro: 'Vámonos a la casa que es hora de almorzar'."
,"14":"Salieron y se separaron, pero luego se devolvieron y se encontraron en el mismo lugar. Al preguntarse mutuamente sobre cuál era el motivo de ese regreso, terminaron por confesarse su deseo. Entonces comenzaron a buscar juntos una ocasión para hallarla sola."
,"15":"Mientras estaban al acecho de una ocasión favorable, entró Susana en el jardín como lo había hecho siempre acompañada solamente por dos sirvientas. Hacía calor y quería bañarse."
,"16":"No había nadie más en el jardín fuera de los dos ancianos que se habían escondido y que la observaban."
,"17":"Susana dijo a las muchachas: 'Tráiganme óleo y perfumes y cierren la puerta del jardín para que pueda bañarme'."
,"18":"Hicieron lo que Susana les había dicho; cerraron la puerta del jardín y salieron por la puerta trasera para traerle lo que les había pedido; no sabía ella que los ancianos estaban escondidos allí."
,"19":"Apenas salieron las sirvientas, los ancianos se levantaron y corrieron donde Susana."
,"20":"Le dijeron: 'Las puertas del jardín están ahora cerradas, nadie nos ve y estamos locos de ganas por ti, acepta pues entregarte a nosotros."
,"21":"Si no, atestiguaremos en tu contra, diremos que estaba contigo un joven y que por eso despachaste a las muchachas'."
,"22":"Susana suspiró y dijo: 'La angustia me cerca por todas partes; preferiría la muerte antes de hacer tal cosa, y de no hacerla, no me escaparé de las manos de ustedes."
,"23":"Pero es mejor para mí caer inocentemente en las manos de ustedes que pecar en presencia del Señor'."
,"24":"Entonces Susana lanzó un fuerte grito, pero los dos ancianos gritaron también en contra de ella,"
,"25":"y uno de ellos corrió a abrir las puertas del jardín."
,"26":"Al oír los gritos del jardín, los sirvientes de la casa llegaron corriendo por la puerta de atrás para ver lo que estaba pasando."
,"27":"Los ancianos se pusieron a dar explicaciones, y los sirvientes quedaron muy confundidos porque nunca habían oído decir semejante cosa con respecto a Susana."
,"28":"Al día siguiente, cuando se reunió el pueblo en casa de Joaquín, marido de Susana, llegaron los dos ancianos con el corazón repleto de intenciones criminales contra Susana; estaban decididos a condenarla a muerte."
,"29":"Delante de todo el pueblo dijeron: 'Vayan a buscar a Susana, hija de Helquías, la mujer de Joaquín'. Fueron a buscarla inmediatamente."
,"30":"Llegó junto con sus padres, sus hijos y su familia."
,"31":"Susana tenía una cara muy linda: era muy hermosa."
,"32":"Como venía con el velo puesto, esos miserables ordenaron que se quitara el velo para saciarse una vez más con su belleza."
,"33":"Todos sus parientes lloraban, como también todos los que la veían."
,"34":"Entonces los dos viejos se levantaron en medio de la asamblea y pusieron sus manos en la cabeza de ella."
,"35":"Susana lloraba volviendo su rostro al cielo, ponía su confianza en Dios."
,"36":"Los viejos pidieron la palabra: 'Mientras nosotros paseábamos solos por el jardín, esta mujer entró con dos sirvientas. Cerró las puertas del jardín y dijo a las muchachas que se fueran."
,"37":"Entonces un joven que estaba escondido se acercó a ella y pecó con ella."
,"38":"Nosotros estábamos en un extremo del jardín y cuando vimos ese escándalo, corrimos donde ellos y los vimos acostados juntos."
,"39":"Pero no pudimos agarrar al joven porque tenía más fuerza que nosotros. Después que abrió las puertas, salió huyendo."
,"40":"Pero a ésta la detuvimos y le preguntamos quién era ese joven,"
,"41":"pero no quiso decírnoslo. Somos testigos de todo eso'. Como eran ancianos y jueces del pueblo, la asamblea creyó en sus palabras y la condenaron a muerte. "
,"42":"Entonces Susana gritó con fuerza: '¡Dios eterno, tú que conoces los secretos y que conoces todo antes de que suceda,"
,"43":"tú sabes que han levantado contra mí un falso testimonio y que ahora muero inocente de todo lo que esos miserables han imaginado contra mí!'"
,"44":"El Señor oyó la voz de Susana."
,"45":"Mientras la llevaban al lugar de la ejecución, Dios despertó el espíritu santo en un joven llamado Daniel,"
,"46":"quien gritó fuerte: '¡Soy inocente de la sangre de esta mujer!'"
,"47":"Todo el mundo se volvió hacia él y le dijeron: '¿Qué es lo que nos dices?'"
,"48":"Y él, parándose en medio de todos, les dijo: '¿Por qué son tan estúpidos, hijos de Israel? ¡Ustedes han condenado a una hija de Israel sin haberla juzgado y sin conocer la verdad!"
,"49":"Vuelvan al tribunal porque han presentado un falso testimonio en su contra'."
,"50":"Todos se apresuraron en volver al juzgado y los ancianos dijeron a Daniel: '¡Ven, siéntate con nosotros y dinos lo que piensas porque Dios te ha dado la sabiduría de los ancianos!'"
,"51":"Daniel les dijo: 'Separen a los dos, y yo los voy a juzgar'."
,"52":"Cuando estuvieron separados el uno del otro, Daniel llamó al primero y le dijo: 'Has envejecido en el mal, y ahora los pecados de tu vida pasada recaen sobre ti."
,"53":"Tu dictabas injustas sentencias, condenabas a los inocentes y dejabas libres a los culpables, siendo que el Señor dijo: No condenarás a muerte al inocente ni al justo."
,"54":"Pues bien, ya que tú la viste, dinos bajo qué árbol los viste acostados juntos'. Respondió: 'Bajo una acacia'."
,"55":"Daniel le dijo: 'Tu mentira recae sobre tu propia cabeza y ya ha ordenado Dios a su ángel que te parta por el medio'."
,"56":"Lo despachó y ordenó que pasara el segundo, le dijo: '¡Raza de Canaán en vez de Judá! la belleza te hizo perder la cabeza y el deseo pervirtió tu corazón."
,"57":"Así es como se portaban ustedes con las hijas de Israel y ellas por temor se entregaban a ustedes, pero una hija de Judá no soportó la miserable conducta de ustedes."
,"58":"Pues bien, dime bajo qué árbol los sorprendiste acostándose juntos'. Respondió: 'Bajo una encina'."
,"59":"Daniel le dijo: 'También tu mentira recae sobre tu cabeza; allí está el ángel del Señor esperándote con la espada en la mano para cortarte por el medio y hacerte perecer'."
,"60":"Entonces toda la asamblea gritó a una sola voz: ¡bendigan al Señor porque salva a los que esperan en él!"
,"61":"Después se volvieron donde los dos ancianos a los que Daniel había convencido de falso testimonio con sus propias palabras; les aplicaron el mismo castigo que en su maldad habían planeado contra su prójimo."
,"62":"Se aplicó la ley de Moisés: fueron condenados a muerte y ese día se salvó la sangre inocente."
,"63":"Helquías y su mujer alabaron a Dios por su hija Susana, y lo mismo hizo Joaquín su marido y toda su familia, porque no se le había encontrado nada de que reprocharla."
,"64":"Desde ese día en adelante, el pueblo respetó a Daniel."
}`)
	CurrentBook.AddChapter(14, `{
"1":"El rey Astiages murió y Ciro el Persa heredó el reino."
,"2":"Daniel comía en la mesa del rey y era mucho más honrado que los demás Amigos del rey."
,"3":"Había en Babilonia un ídolo llamado Bel; cada día se gastaban en él doce medidas de flor de harina, cuarenta ovejas y seis pequeños toneles de vino."
,"4":"El rey también lo adoraba y cada día iba a venerarlo. Pero Daniel adoraba a su Dios."
,"5":"El rey le dijo: '¿Por qué no adoras a Bel?' Daniel respondió: 'Porque no venero a los ídolos hechos por mano de hombre, sino sólo al Dios vivo que ha hecho el cielo y la tierra y que tiene poder sobre todo ser viviente'."
,"6":"El rey le dijo: '¿Así que Bel no es un dios vivo? ¿No ves todo lo que come y bebe cada día?'"
,"7":"Daniel le respondió riendo: 'No se haga ilusiones el rey, ese dios es de arcilla por dentro y de bronce por fuera, nunca ha comido ni bebido nada'."
,"8":"Muy enojado, el rey llamó a sus sacerdotes y les dijo: 'Si no me dicen quién es el que se come esa ofrenda que tanto me cuesta, ustedes morirán, pero si me demuestran que es Bel quien se la come, será Daniel quien morirá por haber blasfemado contra Bel'."
,"9":"Daniel dijo al rey: 'Hagámoslo como tú dices'. Pues bien había setenta sacerdotes de Bel sin contar a sus mujeres ni a sus hijos. "
,"10":"El rey fue con Daniel al templo de Bel."
,"11":"Los sacerdotes de Bel le dijeron: 'Ahora nosotros vamos a salir, y tú señor, pondrás la comida y dejarás el vino luego de haberlo mezclado; en seguida cerrarás la puerta y pondrás tu sello para que nadie pueda abrirla. Mañana temprano vendrás y si Bel no se lo ha comido todo, moriremos; en caso contrario, será Daniel el que mintió en contra de nosotros'."
,"12":"Estaban tranquilos porque tenían bajo la mesa una entrada secreta por donde entraban regularmente para comerse las ofrendas."
,"13":"Se fueron pues y el rey mandó poner los alimentos delante de Bel,"
,"14":"pero Daniel ordenó a sus sirvientes que trajeran ceniza y que la esparcieran por todo el templo ante la presencia solamente del rey. Luego salieron, cerraron la puerta, pusieron el sello del rey y se fueron todos."
,"15":"Durante la noche vinieron los sacerdotes, como estaban acostumbrados a hacerlo, junto con sus mujeres e hijos, y se comieron y bebieron todo lo que había."
,"16":"A la mañana siguiente, el rey y Daniel fueron a ver lo que había pasado."
,"17":"El rey dijo a Daniel: '¿Están intactos los sellos?' Respondió: 'Absolutamente, señor'."
,"18":"Apenas se abrieron las puertas, al ver la mesa el rey exclamó con fuerza: '¡Oh Bel, qué grande eres, en ti no hay mentira alguna!'"
,"19":"Daniel se puso a reír, y reteniendo al rey para que no fuera más lejos, le dijo: 'Mira el pavimento y fíjate en esas huellas'."
,"20":"El rey dijo: 'Veo huellas, de pisadas de hombres, de mujeres y de niños'."
,"21":"Entonces, furioso, el rey mandó detener a los sacerdotes, a sus mujeres y a sus hijos, quienes le mostraron las puertas secretas por donde entraban para comer lo que estaba en la mesa."
,"22":"El rey los mandó ejecutar y puso a Bel a disposición de Daniel quien destruyó el ídolo y su templo."
,"23":"Había también un inmenso dragón al que veneraban los Babilonios."
,"24":"El rey dijo a Daniel: '¿No me vas a decir que éste no es un dios vivo? ¡adóralo pues!'"
,"25":"Daniel le respondió: 'Yo sólo adoro al Señor mi Dios, porque solamente él es un Dios vivo, pero tú, oh rey, dame permiso y mataré al dragón sin espada ni palo'."
,"26":"El rey le dio permiso."
,"27":"Entonces Daniel tomó resina, grasa y pelos, los hizo cocer todos juntos e hizo con ellos unas bolas que echó al hocico del dragón; el dragón se las comió y reventó. Daniel dijo entonces: '¡Vean ahora lo que veneraban!'"
,"28":"Los Babilonios al saber eso se escandalizaron. Se rebelaron contra el rey y decían: '¡El rey se ha hecho judío! Destruyó a Bel, mató al dragón y masacró a los sacerdotes'."
,"29":"Luego fueron donde el rey y le dijeron: '¡Entréganos a Daniel; si no te mataremos junto con toda tu familia!'"
,"30":". Al ver su violencia, el rey cedió y les entregó a Daniel."
,"31":"Lo echaron al foso de los leones donde permaneció seis días."
,"32":"En el foso había siete leones; diariamente les daban dos cuerpos y dos ovejas, pero para que devoraran a Daniel no les dieron nada."
,"33":"Estaba entonces en Judea el profeta Habacuc; acababa de cocer un guiso y de picar pan en una batea, y se iba al campo para llevar esa comida a los segadores."
,"34":"El ángel del Señor dijo a Habacuc: 'Lleva esa comida que tienes en las manos a Babilonia, donde Daniel que está en el foso de los leones'."
,"35":"Habacuc respondió: Señor, nunca he visto Babilonia ni tampoco conozco el foso de los leones'."
,"36":"Entonces el ángel lo tomó por la mollera y levantándolo de los cabellos, lo trasladó a Babilonia encima del foso con la rapidez de un espíritu."
,"37":"Habacuc gritó: '¡Daniel, Daniel, toma esta comida que Dios te envía!'"
,"38":"Daniel respondió: '¡Oh Dios, te acordaste de mí y no abandonaste a los que te aman!'"
,"39":"Daniel se levantó y comió, y el ángel del Señor volvió a dejar a Habacuc en el lugar donde lo había tomado."
,"40":"Al séptimo día, llegó el rey para llorar a Daniel, se acercó al foso y miró: ¡Daniel estaba sentado!"
,"41":"Entonces el rey exclamó con fuerza: '¡Qué grande eres, Señor, Dios de Daniel! No hay otro Dios fuera de ti'."
,"42":"El rey ordenó que sacaran a Daniel del foso y mandó que arrojaran allí a todos los que habían buscado su perdición; inmediatamente fueron devorados en su presencia."
}`)

}
func ES_LBL_LoadVMEZChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"El año treinta, el día quinto del cuarto mes, encontrándome entre los desterrados, a orillas del río Quebar, se abrió el cielo y contemplé visiones divinas."
,"2":"El día quinto del mes, el año quinto de la deportación del rey Joaquim,"
,"3":"la palabra de Yavé fue dirigida al sacerdote Ezequiel, hijo de Buzi, en el país de los caldeos, a orillas del río Quebar. Yavé puso su mano sobre mí. "
,"4":"Yo miré: un viento huracanado venía del norte. Vi una gran nube: En medio de ella un fuego ardiente irradiaba luz, y el centro era como de metal incandescente."
,"5":"En medio del fuego había cuatro seres vivos. Tenían la misma forma:"
,"6":"cada uno tenía cuatro caras y cuatro alas."
,"7":"Sus piernas eran rectas, con pezuñas como las de buey; brillaban como bronce pulido."
,"8":"Bajo sus alas (en los cuatro costados) tenían manos de hombre. Las alas de los cuatro"
,"9":"se tocaban unas con otras. Al andar no se volvían a ningún lado: iban derecho siguiendo una de sus caras."
,"10":"Vistos de frente, los cuatro seres tenían aspecto humano, pero la cara derecha de su cuerpo era cara de león, y su cara izquierda, cara de toro. Los cuatro tenían también una cara de águila."
,"11":"Sus alas estaban desplegadas hacia arriba; cada uno tenía dos alas que se juntaban con las de sus compañeros, y dos alas que le cubrían el cuerpo."
,"12":"Cada uno de ellos iba derecho siguiendo una de sus caras, iban hacia donde el espíritu los empujaba y al caminar no se daban vuelta."
,"13":"Entre los seres había como carbones ardientes: se diría que había un baile de antorchas entre esos seres; el fuego iluminaba, y del fuego surgían relámpagos."
,"14":"Esos seres iban y venían como el relámpago."
,"15":"Al mirar bien a esos seres, vi que, en el suelo, había una rueda al lado de cada uno de ellos."
,"16":"Esas ruedas centelleaban como piedras preciosas, y las cuatro tenían la misma forma. Cada rueda era doble: parecía como dos ruedas entrecruzadas."
,"17":"De ese modo podían avanzar en las cuatro direcciones, sin tener que dar vuelta."
,"18":"Tenían una llanta muy grande y de aspecto aterrador, porque las cuatro tenían ojos por todo el derredor."
,"19":"Cuando los seres avanzaban, las ruedas avanzaban al lado de ellos; cuando los seres se elevaban desde la tierra, las ruedas también se elevaban."
,"20":"Los seres iban adonde el Espíritu quería, y las ruedas también iban allá porque el espíritu que estaba en los seres estaba también en las ruedas."
,"21":"Cuando ellos avanzaban, éstas avanzaban; cuando se detenían, se detenían éstas; cuando se elevaban desde la tierra, las ruedas igual se elevaban, porque el espíritu del ser estaba también en cada una de las ruedas."
,"22":"Por encima de los seres se veía una como plataforma de cristal resplandeciente;"
,"23":"bajo la plataforma sus alas se erguían paralelas unas a otras."
,"24":"Oí entonces el ruido de sus alas, como el ruido de aguas caudalosas, como la voz del Dios Todopoderoso. Cuando caminaban se sentía un ruido como de tempestad, como el estruendo de una multitud; cuando se detenían replegaban sus alas."
,"25":"Un ruido se oía desde la plataforma que estaba encima de sus cabezas."
,"26":"Sobre ésta se veía como una piedra de zafiro en forma de trono y, en esta forma de trono, a un ser que tenía una apariencia humana en su parte superior."
,"27":"Lo vi como rodeado de metal incandescente, de la cintura para arriba, y de la cintura para abajo, era un fuego que proyectaba luz."
,"28":"La luz que lo rodeaba tenía el aspecto del arco iris que se ve en las nubes en los días de lluvia. Esa visión era una imagen de la Gloria de Yavé, cuando lo vi me tiré de bruces al suelo; oí entonces una voz que me habló."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Me dijo: 'Hijo de hombre, ponte de pie, te voy a hablar.'"
,"2":"En el mismo momento en que me habla, entra en mí un espíritu y me hace ponerme de pie;"
,"3":"entonces oigo que me dice: 'Hijo de hombre, te envío donde los Israelitas, a un pueblo de rebeldes que se han rebelado contra mí; ellos y sus padres me han sido infieles hasta el día de hoy."
,"4":"Te envío donde esa raza de cabezas duras y de corazones obstinados para que les digas: ¡Esta es la palabra de Yavé...!"
,"5":"Te escucharán o no te escucharán porque son una raza de rebeldes- pero sabrán que hay un profeta en medio de ellos."
,"6":"Y tú, hijo de hombre, no les temas, no temas a sus amenazas; serán para ti como zarzas u ortigas, como un escorpión donde te hayas sentado. No tengas miedo de sus palabras, no temas ante ellos: ¡no son más que una raza de rebeldes!"
,"7":"Les transmitirás mis palabras, te escuchen o no, porque son una raza de rebeldes."
,"8":"Ahora, hijo de hombre, escucha lo que te voy a decir, no te rebeles como esa raza de rebeldes, sino que abre la boca y come lo que te doy.'"
,"9":"Miré: hacia mí se tendió una mano que sostenía el rollo del libro."
,"10":"Lo desenrolló ante mí; estaba escrito al revés y al derecho, y sólo eran cantos fúnebres, lamentaciones y gemidos."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Me dijo: 'Hijo de hombre, come lo que te presento, cómelo y luego anda a hablarle a la casa de Israel.'"
,"2":"Abrí la boca para que me hiciera comer ese rollo,"
,"3":"y me dijo: 'Hijo de hombre, come ahora y llena tu estómago con este rollo que te doy.' Lo comí pues, y en mi boca era dulce como la miel."
,"4":"Me dijo: 'Hijo de hombre, anda a la casa de Israel y diles mis palabras."
,"5":"No te envío a un pueblo extranjero cuya lengua te sería difícil, sino a la casa de Israel."
,"6":"Si te enviara donde muchedumbres extranjeras, cuyo hablar es oscuro y cuya lengua es difícil, la cual no comprenderías, podrían tal vez escucharte."
,"7":"Pero la casa de Israel no querrá escucharte, porque no quiere escucharme; todos tienen la cabeza dura y el corazón obstinado."
,"8":"Por eso, he vuelto tu cara tan dura como la de ellos, y tu frente tan dura como la de ellos."
,"9":"Haré de tu frente un diamante, más duro que la roca; no les temerás, no tendrás miedo de ellos, porque son sólo una raza de rebeldes.'"
,"10":"Me dijo: 'Hijo de hombre, recibe en tu corazón, escucha con tus oídos todas las palabras que te voy a decir;"
,"11":"luego, anda, vuélvete donde los desterrados, donde la gente de tu pueblo. Les hablarás y les dirás: ¡Así habla Yavé...! te escuchen o no.'"
,"12":"Entonces el espíritu me levantó mientras oía detrás de mí una formidable aclamación: '¡Bendita sea la Gloria de Yavé en todo lugar!'"
,"13":"Oí el batir de las alas de los seres unas contra otras, oí también el ruido de las ruedas: todo era un enorme estruendo."
,"14":"El espíritu me había levantado, me había arrebatado. Quedé lleno de amargura, con el espíritu afiebrado, porque la mano de Yavé pesaba fuertemente sobre mí."
,"15":"Cuando llegué a Tel Aviv, donde estaban los desterrados a orillas del río Quebar, permanecí siete días como atontado en medio de ellos."
,"16":"Al cabo de esos siete días se me dirigió la palabra de Yavé:"
,"17":"'Hijo de hombre, te he puesto como un vigía para la casa de Israel: si oyes una palabra que salga de mi boca, inmediatamente se lo advertirás de mi parte."
,"18":"Si le digo al malvado: ¡Vas a morir! y si tú no se lo adviertes, si no hablas de tal manera que ese malvado deje su mala conducta y así salve su vida, ese malvado morirá debido a su falta, pero a ti te pediré cuenta de su sangre."
,"19":"En cambio, si se lo adviertes al malvado y él no quiera renunciar a su maldad y a su mala conducta, morirá debido a su falta, pero tú habrás salvado tu vida."
,"20":"Si el justo deja de hacer el bien y comete la injusticia, pondré una piedra delante de él para que se caiga y morirá. Si tú no se lo has advertido, morirá a causa de su pecado, se olvidarán de las buenas acciones que haya hecho, pero a ti te pediré cuenta de su sangre."
,"21":"Pero, si tu adviertes al justo para que no peque y siga sin pecar, vivirá gracias a tu advertencia, y tú habrás salvado tu vida."
,"22":"La mano de Yavé se puso sobre mí y me dijo: 'Levántate, dirígete al valle, allí te hablaré.'"
,"23":"Me levanto entonces y me dirijo al valle. Veo allí la Gloria de Yavé: estaba allí tal como había visto la Gloria a orillas del río Quebar. Inmediatamente me echo de bruces al suelo."
,"24":"El Espíritu entra en mí y me hace ponerme de pie sobre mis piernas; y me habla y me dice: 'Anda, enciérrate en tu casa."
,"25":"Mira, hijo de hombre, como te ponen cuerdas y te atan; ya no podrás salir para conversar con ellos:"
,"26":"Hago que tu lengua se pegue a tu paladar: estás mudo y dejas de reprocharlos porque son una raza de rebeldes."
,"27":"Pero más tarde te hablaré, te abriré la boca y les dirás: ¡Esto dice Yavé! que escuche el que quiere escuchar, y el que no quiere, que no escuche, puesto que es una raza de rebeldes."
}`)
	CurrentBook.AddChapter(4, `{
"1":"'Toma pues un ladrillo, hijo de hombre, y ponlo delante de ti; dibujarás en él una ciudad: Jerusalén."
,"2":"Luego le pondrás sitio, construirás una torre de asalto, harás terraplenes, establecerás en su derredor campamentos y por todo su alrededor dispondrás máquinas para el sitio."
,"3":"Después tomarás una sartén de hierro que pondrás cual muralla de hierro entre ti y la ciudad, y te quedarás vigilándolas; tú le pondrás sitio y quedará sitiada. Esta será una señal para la casa de Israel."
,"4":"Acuéstate sobre el lado izquierdo y pon sobre ti el pecado de la casa de Israel; soportarás su pecado tantos días cuantos estés así acostado."
,"5":"Te he sacado la cuenta de los días, la que corresponde a los años de sus pecados; soportarás el pecado de la casa de Israel durante ciento noventa días."
,"6":"Cuando estos días se hayan cumplido, te acostarás sobre el lado derecho y esta vez soportarás el pecado de la casa de Judá, serán cuarenta días; te he sacado la cuenta a un día por año."
,"7":"Volverás tu mirada y tu brazo desnudo hacia Jerusalén sitiada y profetizarás contra ella."
,"8":"Mira que te he atado con cuerdas para que no puedas darte vuelta ni a un lado ni al otro mientras duren los días de tu asedio."
,"9":"Toma trigo, cebada, habas, lentejas, mijo y centeno, y colócalos en un tiesto; con ellos te harás pan teniendo en cuenta el número de días que estarás acostado de ese lado. Lo comerás durante ciento noventa días."
,"10":"Para tu ración diaria pesarás doscientos gramos; lo comerás varias veces."
,"11":"De igual manera beberás racionada tu agua, una sexta parte de medida varias veces."
,"12":"Lo prepararás como se preparan las galletas de cebada y lo cocerás a la vista de ellos en un fuego de excrementos humanos secos."
,"13":"Porque de la misma manera, me dijo, los hijos de Israel comerán un pan impuro en medio de las naciones donde los dispersaré.'"
,"14":"Entonces dije: '¡Ay, Señor Yavé, mira, nunca me he manchado. Jamás he comido animales muertos o desgarrados desde mi juventud hasta el presente, ninguna carne impura ha entrado en mi boca.'"
,"15":"Entonces me dijo: 'Te concedo que para el fuego en que cuezas tu pan uses excrementos secos de animales en vez de los excrementos humanos.'"
,"16":"Luego me dijo: 'Mira, hijo de hombre, cómo dejo sin pan a Jerusalén. En su angustia comerán pan que les será contado, y en su temor beberán agua que les será racionada."
,"17":"Se debilitarán por falta de pan y de agua, y así perecerán a causa de sus pecados.'"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Toma después una lámina cortante, hijo de hombre, afílala como navaja de barbero y pásatela por la cabeza y por la barba. En seguida, toma una balanza y reparte los pelos que te hayas cortado."
,"2":"Quemarás un tercio en medio de la ciudad sitiada. Tomarás otro tercio que irás golpeando con la espada alrededor de la ciudad, y tirarás al viento el último tercio; yo accionaré la espada detrás de ellos."
,"3":"Apartarás algunos que esconderás en los pliegues de tu manto;"
,"4":"también tomarás unos cuantos de éstos para echarlos al fuego y quemarlos. Entonces dirás a toda la casa de Israel: "
,"5":"'Esto dice Yavé: Ustedes tienen allá a Jerusalén. La puse en medio de las naciones, quedando los países extranjeros en las orillas."
,"6":"Pero en su maldad, rechazó mis mandamientos más que las otras naciones, y mis leyes más que los países que la rodean: esa gente rechazó mis mandamientos y no caminó según mis leyes."
,"7":"Por eso, esto dice el Señor: Ustedes han sido más rebeldes que las naciones que los rodean, y no han caminado según mis leyes; no han observado mis mandamientos sino que han actuado como las naciones que los rodean."
,"8":"Por eso Yavé les dice: Yo, a mi vez, me vuelvo contra ti; cumpliré dentro de ti, viéndolo las naciones, lo que he decidido."
,"9":"Debido a tus crímenes haré lo que nunca hice y que no volveré a hacer."
,"10":"Se verán en ti a padres que se coman a sus hijos y a hijos que devoren a su padre. Cumpliré lo que decidí contra ti y dispersaré a los cuatro vientos lo que quede de ti."
,"11":"Lo juro por mi vida, dice Yavé, puesto que tú ensuciaste mi Santuario con todas tus inmundicias y horrores, yo, por mi parte, te arrasaré, no te miraré con piedad, seré sin misericordia."
,"12":"Un tercio de tus habitantes morirá de peste o será consumido por el hambre dentro de tus muros; un tercio será muerto a espada en todo tu alrededor, dispersaré a los demás a los cuatro vientos y accionaré la espada tras ellos."
,"13":"Mi cólera se desatará con furor, y cuando se desate mi cólera, experimentarán la indignación que me movía a hablar, a mí, Yavé."
,"14":"Te convertiré en ruinas en medio de las naciones que te rodean y en motivo de risa para todos los que pasen."
,"15":"Serás objeto de burla y de risa para las naciones que te rodean, cuando te corrija sin piedad y haga contigo lo que te dije. Yo, Yavé, hablé."
,"16":"Enviaré en contra de ustedes las flechas terribles del hambre para exterminarlos, los dejaré sin pan."
,"17":"Enviaré en tu contra hambre y animales feroces para privarte de tus hijos; sabrás lo que es la peste y la sangre derramada, porque mandaré contra ti la espada. Yo, Yavé, hablé.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Yavé me dirigió su palabra:"
,"2":"'Hijo de hombre, vuelve tu mirada hacia las montañas de Israel y profetiza contra ellas."
,"3":"Dirás: Montañas de Israel, escuchen la palabra de Yavé. Esto dice Yavé a las montañas y a las colinas, a las quebradas y a los valles: Enviaré en su contra la espada, voy a destruir sus Altos Lugares. "
,"4":"Sus altares serán derribados, sus altares para el perfume serán rotos. Haré que sus habitantes sean masacrados delante de sus ídolos."
,"5":"Dispersaré sus huesos alrededor de sus altares."
,"6":"Doquiera ustedes habiten, serán devastadas las ciudades y derribados los Altos Lugares, sus altares serán abandonados, sus ídolos rotos, sus altares para el perfume destruidos."
,"7":"Sus habitantes serán masacrados en medio de ustedes y sabrán que yo soy Yavé."
,"8":"Algunos, sin embargo, escaparán a la espada, dejaré un resto en medio de las naciones cuando los haya dispersado entre ellas."
,"9":"Los sobrevivientes se acordarán de mí en medio de las naciones en las que yo quiero que sean prisioneros; romperé su corazón adúltero que se alejó de mí, y sus ojos adúlteros que miraban a los ídolos, tendrán vergüenza de sí mismos por todo el mal que hicieron y por los horrores que cometieron."
,"10":"Entonces sabrán que yo soy Yavé."
,"11":"Esto es lo que dice Yavé: Aplaude, patalea y di: ¡Bien hecho! Cuando veas que la casa de Israel cae por la espada, el hambre y la peste, te acordarás de todas sus inmundas porquerías."
,"12":"El que esté lejos morirá de peste, el que esté cerca caerá por la espada, el sobreviviente morirá de hambre: mi cólera se descargará hasta el final."
,"13":"Sabrán que yo soy Yavé cuando los muertos se amontonen al lado de los ídolos, cerca de sus altares, en todas las colinas elevadas, bajo cualquier árbol verde y bajo cualquier frondosa encina, doquiera hayan ofrecido a sus porquerías el buen olor del incienso."
,"14":"Los abatiré completamente, convertiré su país en una soledad, en una ruina doquiera habiten, desde el desierto hasta Ribla. Entonces sabrán que yo soy Yavé.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Yavé me dirigió su palabra:"
,"2":"'Hijo de hombre, así habla Yavé a la tierra de Israel: ¡Es el fin! ¡Llegó el final a los cuatro rincones del país! "
,"3":"Ahora es el fin para ti. Voy a desatar mi cólera contra ti, te juzgaré de acuerdo a tu comportamiento y haré recaer sobre ti todos tus crímenes."
,"4":"Mi ojo no te perdonará, seré inclemente. Haré recaer sobre ti tu conducta, y te recordaré todos tus crímenes; entonces sabrán que yo soy Yavé."
,"5":"Esto dice Yavé: Ya llega la desgracia, una desgracia única."
,"6":"Es el fin, se acerca el fin, se muestra aquí y acullá."
,"7":"Es tu turno, habitante del país, llegó el momento, se acerca el día; no faltará, no tardará."
,"8":"Voy a hacer que mi cólera se derrame sobre ti; se descargará mi cólera sobre ti y te juzgaré según tu conducta. Haré que pagues todos tus crímenes."
,"9":"Mi ojo no te perdonará, seré inclemente, haré que pagues tu conducta y me recordaré de tus crímenes; entonces sabrán que yo, Yavé, soy quien castiga."
,"10":"¡Este es el día! ¡La insolencia floreció, el orgullo se expandió,"
,"11":"la violencia reina, castiga perversamente."
,"12":"¡Llegó el momento, llegó el día! Que el comprador no se alegre, que el vendedor no se queje,"
,"13":"porque el vendedor, aunque quede con vida, no recuperará su mercadería. Cada uno vive en su injusticia, ¿dónde, pues, hallarán fuerzas?"
,"14":"Sonará la trompeta, harán los preparativos, pero nadie partirá al combate."
,"15":"La espada aguarda al que sale afuera. El que está en el campo morirá a espada, el que está en la ciudad será presa del hambre y de la peste."
,"16":"Los que escapen vagarán por la montaña como palomas asustadas; todos morirán, a causa de su pecado."
,"17":"Todos los brazos serán abatidos y las rodillas quebrantadas."
,"18":"Se cubrirán de sacos, pero el terror los envolverá; la vergüenza cubrirá su rostro y todas las cabezas serán rapadas."
,"19":"Tirarán por las calles su plata y arrojarán su oro a la basura. Esto no calmará su hambre ni llenará su estómago, ya que todo eso solamente los conducirá al mal."
,"20":"En su 'Joya', que constituía su orgullo, pondrán sus miserables ídolos, y por ello yo se la convertiré en algo horroroso."
,"21":"La entregaré en manos de extranjeros, y como botín a la gente malvada del país, que la profanarán."
,"22":"Apartaré mi vista de ellos, mi tesoro será profanado; entrarán los ladrones y lo profanarán."
,"23":"Harán allí una masacre,porque el país está cubierto de sangre,y la ciudad repleta de violencia."
,"24":"Humillaré la soberbia de los violentos,y sus santuarios serán profanados."
,"25":"Reinará la angustia, buscarán la paz, pero ésta no llegará."
,"26":"Desgracia tras desgracia, una mala noticia tras otra; los profetas no tendrán más visiones, los sacerdotes, nada más que decir, los ancianos no sabrán más qué aconsejar."
,"27":"El rey estará de duelo, colmado de espanto, a los nobles les temblarán las manos; los trataré de acuerdo a su comportamiento, tendrán la sentencia que se merecen,y sabrán que yo soy Yavé.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"El año sexto, el día quinto del sexto mes, estaba sentado en mi casa y los ancianos de Judá estaban sentados frente a mí. Entonces la mano de Yavé se posó sobre mí."
,"2":"Miré, era una forma humana; por debajo de la cintura no era más que fuego, y de la cintura para arriba era como un metal incandescente."
,"3":"Extendió lo que podía ser una mano y me agarró por los cabellos: inmediatamente el Espíritu me levantó entre el cielo y la tierra. Me llevó a Jerusalén en una visión divina hasta la entrada de la puerta que mira al norte, allí donde está el ídolo que provoca los celos del Señor."
,"4":"Allí estaba la Gloria del Dios de Israel, tal como la había yo visto en una visión en el valle."
,"5":"Me dijo: 'Hijo de hombre, mira hacia el norte.' Miré al norte y ese ídolo que provoca sus celos estaba allí al norte de la entrada al altar."
,"6":"Me dijo: '¿Hijo de hombre, has visto todos los horrores que comete aquí la casa de Israel para echarme de mi Santuario? Pero todavía verás algo peor aún.'"
,"7":"Me llevó entonces a la puerta del patio y"
,"8":"me dijo: 'Hijo de hombre, traspasa ese muro.' Traspaso el muro y hago en él una puerta."
,"9":"Me dijo: 'Entra y mira las cosas escandalosas que se hacen allí.'"
,"10":"Entro, observo y veo toda clase de reptiles y animales impuros que estaban grabados a lo largo del muro: todos los inmundos ídolos de la casa de Israel."
,"11":"Había allí setenta hombres, cada uno con su incensario en la mano, y el humo del incienso se elevaba. Eran los ancianos de Israel y entre ellos reconocí a Jeconías, hijo de Safán."
,"12":"Me dijo: '¿Hijo de hombre, has visto lo que hacen los ancianos de Israel, cada uno en su cuarto? Dicen para sí: 'Yavé ya no ve, Yavé ya no se preocupa de esta tierra'."
,"13":"Luego me dijo: 'Verás todavía otras cosas escandalosas que se cometen'."
,"14":"Me llevó entonces a la entrada de la puerta del Templo de Yavé que está al lado norte y vi allí mujeres que estaban sentadas llorándole a Tamuz."
,"15":"Me dijo: '¿Viste, hijo de hombre? Vas a ver cosas aún más escandalosas que éstas'."
,"16":"Me llevó al patio interior del Templo de Yavé, y a la entrada del Templo de Yavé, entre el vestíbulo y el altar, veo alrededor de veinticinco hombres que daban la espalda al Templo de Yavé. Estaban allí mirando hacia el este y se prosternaban delante del sol."
,"17":"Entonces me dijo: 'Viste, hijo de hombre, ¿no les basta a la casa de Judá con hacer aquí tantas cosas escandalosas? ¿Van a seguir enojándome? Pero esta vez se les pasó la medida,"
,"18":"voy a actuar con furor, no los perdonaré y mi ojo será inclemente.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Gritó con todas sus fuerzas en mis oídos: '¡Castigos de la ciudad, acérquense! ¡Que cada uno lleve en la mano su instrumento de muerte!'"
,"2":"Aparecen entonces seis hombres desde el lado de la Puerta Alta, que mira al norte: cada cual lleva en la mano un instrumento de muerte, y en medio de ellos veo a un hombre con un traje de lino, que tiene en la cintura una tablilla de escriba. Vienen a ponerse al lado del altar de bronce,"
,"3":"e inmediatamente la Gloria del Dios de Israel, que hasta entonces descansaba sobre los querubines, se eleva en dirección a la puerta del Templo. Llama al hombre con traje de lino, que lleva en su cintura una tablilla de escriba,"
,"4":"y le dice: 'Recorre Jerusalén, marca con una cruz en la frente a los hombres que se lamentan y que gimen por todas esas prácticas escandalosas que se realizan en esta ciudad.'"
,"5":"Luego, dice a los otros, de manera que yo lo entienda: 'Recorran la ciudad detrás de él y maten. No perdonen a nadie, que su ojo no tenga piedad."
,"6":"Viejos, jóvenes, muchachas, niños y mujeres, mátenlos hasta acabar con ellos. Pero no tocarán a los que tienen la cruz. Comenzarán por mi Santuario.',Comienzan pues con la gente que se encontraba delante del Templo. "
,"7":"Porque les había dicho: 'Llenen los patios de cadáveres, el Templo quedará manchado con ellos; luego salgan y maten en la ciudad.'"
,"8":"Mientras mataban de esa manera, me postré con el rostro en tierra, gritando y diciéndole. '¡Ay, Yavé, ¿vas a esparcir tu furor por Jerusalén y destruir lo que queda de Israel?'"
,"9":"Me respondió: 'El pecado de la casa de Israel y de Judá es tan grande que supera toda medida; el país está repleto de sangre y la ciudad, llena de injusticia. Dicen para sí: Yavé ya no se preocupa del país, Yavé ya no ve nada."
,"10":"Por eso, yo tampoco los perdonaré, mi ojo no tendrá piedad. Haré que su comportamiento recaiga sobre su cabeza.'"
,"11":"En ese momento, el hombre que llevaba un traje de lino y que tenía una tablilla en la cintura, llegó para dar cuenta; declaró: 'Hice todo lo que me ordenaste.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"En ese momento vi que en la plataforma, por encima de los querubines, había una piedra de zafiro en forma de trono."
,"2":"Desde allí dijo al hombre vestido de lino: 'Pasa por debajo de las ruedas y toma entre tus manos carbones que dispersarás por la ciudad.' El hombre fue allá, y yo lo observaba;"
,"3":"mientras se deslizaba, los querubines estaban de pie al lado sur y la nube cubría el patio interior."
,"4":"La Gloria de Yavé se elevó por encima del querubín, en dirección a la puerta del Templo; la nube cubría la Casa y todo el patio quedó inundado del resplandor de la Gloria de Yavé."
,"5":"El ruido de las alas de los querubines se oía hasta en el patio exterior, pues era tan fuerte que parecía la voz del Dios Todopoderoso cuando habla."
,"6":"Dio esta orden al hombre vestido de lino: 'Saca fuego de entre medio de las ruedas y de los querubines.' El hombre se aproximó y se puso al lado de la rueda."
,"7":"El querubín extendió la mano hasta el fuego, sacó unas brasas y las depositó en la mano del hombre con traje de lino; éste las recibió y salió."
,"8":"Vi entonces una especie de mano de hombre bajo las alas de los querubines."
,"9":"Vi cuatro ruedas colocadas al lado de los querubines (había una rueda al lado de cada querubín), y las ruedas resplandecían como piedras preciosas."
,"10":"Las cuatro ruedas tenían la misma forma: se podría decir que cada rueda estaba hecha de dos ruedas entrecruzadas."
,"11":"Podían pues ir sin volverse a los cuatro puntos cardinales, iban sin darse vuelta en la misma dirección hacia donde miraba la cara del querubín."
,"12":"Las llantas de las cuatro ruedas estaban llenas de ojos por todo el derredor."
,"13":"Oí entonces que a esas ruedas les daban el nombre de 'torbellino.' (14-15)."
,"16":"Cuando los querubines avanzaban, las ruedas avanzaban con ellos; cuando los querubines desplegaban sus alas para elevarse desde la tierra, las ruedas no dejaban de acompañarlos."
,"17":"Cuando los querubines se detenían, las ruedas se detenían junto con ellos, porque el espíritu de estos seres estaba en ellas."
,"18":"La Gloria de Yavé salió de la Casa y se detuvo encima de los querubines."
,"19":"Ante mi vista, los querubines abrieron sus alas para elevarse desde la tierra, y salieron acompañados por las ruedas; se detuvieron a la entrada de la puerta oriental del Templo de Yavé, con la Gloria del Dios de Israel que descansaba sobre ellos."
,"20":"Eran los mismos seres que había visto debajo del Dios de Israel junto al río Quebar, y reconocí que eran querubines."
,"21":"Cada uno tenía cuatro caras y cuatro alas, y se veían como manos debajo de sus alas."
,"22":"Sus caras, eran tales como las había visto junto al río Quebar. Y se desplazaban según la dirección de sus caras."
}`)
	CurrentBook.AddChapter(11, `{
"1":"En seguida el Espíritu me llevó a la puerta de la Casa de Yavé que mira al este. A la entrada de la puerta había veinticinco hombres entre los cuales divisé a Jezanías, hijo de Azur y a Peltía, hijo de Banaías, jefes del pueblo."
,"2":"Yavé me dijo: 'Hijo de hombre, estos son hombres que meditan el mal y que dan malos consejos a la ciudad."
,"3":"Dicen: Nuestras casas no están próximas a caer, nosotros somos la carne y la ciudad es la olla que la conserva."
,"4":"¡Por eso, profetiza contra ellos esta profecía, hijo de hombre!'"
,"5":"En ese momento cayó sobre mí el espíritu de Yavé. Me dijo: 'Transmíteles esta palabra de Yavé: Sé lo que tienen en su cabeza, casa de Israel, sé lo que dicen."
,"6":"Pero como han llenado esta ciudad de víctimas y las calles de cadáveres,"
,"7":"Yavé les dice: Las víctimas que dejaron en la ciudad son la carne, y la ciudad, la olla. Pero a ustedes los haré salir."
,"8":"Ya que ustedes temen a la espada, enviaré sobre ustedes la espada, palabra de Yavé."
,"9":"Los haré salir de la ciudad y los entregaré a los extranjeros; así es como haré justicia con ustedes."
,"10":"Los matarán a espada en las fronteras de Israel; allí los castigaré y sabrán que yo soy Yavé."
,"12":"Porque ustedes no han obedecido mis mandamientos, no han seguido mis reglas, sino que se han conducido como esos paganos que los rodean.'"
,"13":"Mientras estaba profetizando, murió Peltía hijo de Banaías: caí entonces con el rostro en tierra y me puse a gritar con fuerte voz: '¡Ay, Yavé! ¿Quieres destruir todo lo que queda de Israel?'"
,"14":"Yavé me dirigió, entonces, estas palabras:"
,"15":"'Hijo de hombre, bien sabes lo que los habitantes de Jerusalén dicen de tus hermanos, de tus vecinos, de todos los desterrados: Que se queden allá lejos de Yavé, pues nosotros hemos heredado esta tierra."
,"16":"Por eso, les vas a decir esta palabra de parte de Yavé: Sí, los envié lejos entre las naciones, los dispersé en esos países, pero yo soy para ellos un santuario en esos países adonde se fueron."
,"17":"Y a los desterrados les dices: Los juntaré de entre esos pueblos; los reuniré de esos países adonde han sido dispersados y les devolveré la tierra de Israel."
,"18":"Entrarán allí nuevamente y arrancarán todos los horrores, todos los ídolos."
,"19":"Les daré un corazón nuevo y pondré en su interior un espíritu nuevo. Quitaré de su carne su corazón de piedra y les daré un corazón de carne."
,"20":"Así caminarán según mis mandamientos, observarán mis leyes y las pondrán en práctica; entonces serán mi pueblo y yo seré su Dios."
,"21":"Pero a los que tienen su corazón apegado a sus inmundicias y a sus horrores, les costará cara su conducta, palabra de Yavé.'"
,"22":"En ese momento, los querubines desplegaron sus alas y las ruedas se fueron con ellos; la Gloria del Dios de Israel descansaba sobre ellos."
,"23":"La Gloria de Yavé se levantó desde el centro de la ciudad; se elevó y se detuvo en la montaña que está al oriente de la ciudad."
,"24":"Entonces el Espíritu me tomó y me llevó de vuelta a Caldea junto a los cautivos; todo esto se desarrolló en una visión; esto venía del Espíritu de Dios. Y luego esa visión se alejó de mí"
,"25":"y pude contarles a los exiliados todo lo que me había mostrado Yavé."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Me fue dirigida esta palabra de Yavé:"
,"2":"'Hijo de hombre, tú vives en medio de rebeldes, que tienen ojos para ver pero no ven, oídos para oír y no oyen. Realmente son una banda de rebeldes."
,"3":"Prepara, pues, hijo de hombre, tu equipaje de exiliado en pleno día y ante ellos; a lo mejor así reconocen que son una banda de rebeldes."
,"4":"De día y a su vista arreglarás tus asuntos, como lo hace un exiliado, y saldrás al atardecer como parten los exiliados."
,"5":"Harás en presencia de ellos un hoyo en la muralla, por donde saldrás."
,"6":"Te echarás tu bulto a la espalda y saldrás en presencia de ellos en la oscuridad. Además, te taparás la cara para que no veas la tierra. Todo esto que te mando hacer será una señal para la casa de Israel.'"
,"7":"Ejecuté pues la orden que había recibido. Arreglé durante el día mi equipaje de exiliado, y al atardecer hice con mi mano un hoyo en la muralla, luego salí de noche en presencia de ellos, después de haberme echado mi fardo al hombro."
,"8":"A la mañana siguiente me fue dirigida otra palabra de Yavé:"
,"9":"'Hijo de hombre, ¿esa gente de Israel, esa banda de rebeldes, no te preguntaron por lo que hacías?"
,"10":"Pues bien, así les dirás de parte de Yavé: Esto es una profecía, que se refiere a Jerusalén y a todos los israelitas que allí moran."
,"11":"Yo soy para ustedes una señal; a ustedes les pasará lo que he hecho. ¡Irán deportados al exilio!"
,"12":"El príncipe que está entre ustedes se echará su bulto a la espalda en la oscuridad y saldrá por el boquete que habrán hecho para que salga; llevará la cara tapada y no verá."
,"13":"Pero extenderé mi red a su paso y caerá en ella; lo llevaré a Babilonia, al país de los caldeos, pero no verá esa tierra, y allí morirá."
,"14":"Dispersaré a los cuatro vientos a los que lo rodean, a toda su tropa, y los perseguiré a espada."
,"15":"Cuando los haya desparramado por entre las naciones, o dispersado en medio de los países, sabrán que yo soy Yavé."
,"16":"Perdonaré sin embargo a algunos de ellos, los que escaparán a la espada, al hambre y a la peste; entonces podrán confesar en medio de las naciones adonde vayan todos los horrores que cometieron; y así sabrán que yo soy Yavé.'"
,"17":"Yavé me dirigió nuevamente la palabra:"
,"18":"'Hijo de hombre, vas a comer tu pan como si estuvieras temblando, y a beber tu agua como si estuvieras angustiado y anonadado."
,"19":"Y luego dirás a propósito de los señores de Jerusalén: Esta palabra de Yavé está destinada a los habitantes de Jerusalén, a todos los que están todavía en la tierra de Israel: Comerán su pan en medio de la angustia, beberán su agua en medio de su tristeza, porque su país será desolado, privado de sus riquezas a causa de la violencia de sus habitantes."
,"20":"Las ciudades habitadas quedarán reducidas a escombros y el país se convertirá en un desierto; entonces sabrán que yo soy Yavé.'"
,"21":"Se me dirigió esta palabra de Dios:"
,"22":"'Hijo de hombre, ¿qué se oye repetir entre ustedes en tierra de Israel?: 'Se alarga el plazo, la visión no vale.'"
,"23":"Pues bien, tú les dirás esta palabra de Yavé: Haré que lo que dicen quede en falso y que no lo repitan más en Israel. Y tú añadirás: Han llegado los días en que se cumplirá toda visión."
,"24":"De hoy en adelante no habrá más visiones mentirosas o adivinaciones engañosas entre ustedes."
,"25":"Porque yo, Yavé, digo lo que tengo que decir y mis palabras se cumplirán. Ya no habrá más plazo, porque lo que voy a hablar y a hacer se refiere a sus días, banda de rebeldes, palabra de Yavé."
,"26":"Me fue dirigida esta palabra de Yavé:"
,"27":"'Hijo de hombre, la gente de Israel comenta: Las visiones de Ezequiel se refieren a tiempos futuros, profetiza para un porvenir lejano."
,"28":"Pero tú les dirás esta palabra de Yavé: Ninguna de mis palabras tardará en cumplirse; lo que digo se hará, palabra de Yavé'."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Se me dirigió esta palabra de Yavé:"
,"2":"'Hijo de hombre, profetiza contra los falsos profetas de Israel, profetiza y diles: Escuchen esta palabra de Yavé.'"
,"3":"Sí, esto dice Yavé: ¡Ay de estos profetas irresponsables que siguen su imaginación y no han tenido visiones!"
,"4":"Tus profetas, Israel, son como zorros en medio de ruinas."
,"5":"No han hecho frente ni han construido fortificaciones alrededor de Israel, para que resista el ataque en el día de Yavé."
,"6":"Dicen: Palabra de Yavé, pero son sólo visiones falsas, predicciones mentirosas. Yavé no los envió, ¿y esperan que él cumpla lo que han dicho?"
,"7":"Cuando dicen: Palabra de Yavé, siendo que yo nada he dicho, ¿no es eso una visión falsa, una profecía mentirosa?"
,"8":"Pero Yavé dice: Me declaro en contra de ustedes debido a sus palabras huecas y a sus visiones de mentira, palabra de Yavé."
,"9":"Castigaré a los profetas de visiones falsas, de promesas mentirosas; ya no serán admitidos en el consejo de mi pueblo, ni serán más inscritos en la libreta de familia de Israel, ni entrarán en la tierra de Israel: así sabrán que yo soy Yavé."
,"10":"Esos profetas engañan a mi pueblo; dicen 'paz' cuando no hay paz; mi pueblo se construye un muro y ellos ponen el estuco."
,"11":"Díganles a los que ponen el estuco: ¡Vendrán la lluvia torrencial, la caída del granizo y el viento de tormenta,"
,"12":"y el muro se caerá! Entonces les dirán: ¿Dónde está el estuco que pusieron en ese muro?"
,"13":"Esto dice Yavé: Mi cólera desencadena un viento tempestuoso, mi furor envía la lluvia torrencial, mi rabia lanza los granizos de la destrucción."
,"14":"Derribo el muro que habían recubierto de estuco, lo dejo a ras del suelo y quedan al descubierto sus cimientos; cae sobre ustedes y los aplasta. Entonces sabrán que yo soy Yavé."
,"15":"Cuando mi cólera se desate contra el muro y los que lo estucaron, les preguntarán: ¿Dónde está el muro, dónde los que lo estucaron?"
,"16":"¿Dónde están esos profetas de Israel que profetizaban sobre Jerusalén, y que veían para ella visiones de paz cuando no había paz?, palabra de Yavé."
,"17":"Vuélvete, hijo de hombre, hacia las hijas de tu pueblo que profetizan por su cuenta; sí, profetiza contra ellas."
,"18":"Les dirás estas palabras de Yavé: ¡Ay de ustedes que cosen cintas mágicas para todos los puños y tejen velos para las cabezas de cualquier talla! Con eso hacen caer en la trampa a las almas. Ustedes que así atrapan a las almas de mi pueblo, ¿creen que salvarán sus propias vidas?"
,"19":"Por un puñado de cebada o un mendrugo de pan me desacreditan frente a mi pueblo, hacen que mueran los que no deben morir y dejan con vida a los que no deben vivir, engañan a mi pueblo y mi pueblo hace caso a la mentira."
,"20":"Pues bien, esto dice Yavé: Aborrezco esas cintas con las que cautivan a las almas; las romperé en sus brazos y libraré las almas que ustedes querían atrapar."
,"21":"Desgarraré sus velos y arrancaré a mi pueblo de las manos de ustedes para que no sea más una presa en manos de ustedes; así sabrán que yo soy Yavé."
,"22":"Porque desanimaron con mentiras al hombre bueno, siendo que yo no quería que se desanimara. Y le dieron seguridad al malvado, quien no renunció a su mal comportamiento para recuperar la vida."
,"23":"Por eso, ya no tendrán falsas visiones, sino que libraré a mi pueblo de las manos de ustedes y sabrán que yo soy Yavé.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Algunos ancianos de Israel vinieron a mi casa y se sentaron a mi lado."
,"2":"Entonces Yavé me dirigió su palabra:"
,"3":"'Hijo de hombre, esos hombres tienen a sus ídolos arraigados en su corazón; están apegados a lo que los hace pecar. ¿Permitiré que me consulten?"
,"4":"Les dirás pues esta palabra de Yavé: Si alguien en Israel lleva consigo sus ídolos y se apega a lo que lo hace pecar, que vaya no más a ver al profeta, yo Yavé le daré una respuesta apropiada a sus sucios ídolos."
,"5":"Porque quiero recuperar el corazón de la casa de Israel, que se alejó de mi junto con todas sus inmundicias."
,"6":"Dirás pues esta palabra de Yavé a la casa de Israel: Regresen a mí, apártense de sus ídolos y renuncien a sus crímenes."
,"7":"Yo, Yavé, responderé personalmente a cualquier israelita y a cualquier extranjero que vive en Israel, que vive alejado de mí, que sólo piensa en sus ídolos que lo inducen a pecar, y que después vaya al profeta para que me consulte."
,"8":"Lo castigaré para ejemplo de los demás y será un ejemplo que no se olvidará. Lo suprimiré de mi pueblo, y sabrán que yo soy Yavé."
,"9":"Si el profeta se deja convencer por esa persona y le da una respuesta de mi parte, es porque yo, Yavé, busqué su perdición. Castigaré a ese profeta y lo eliminaré de en medio de mi pueblo."
,"10":"Ambos soportarán el peso de su culpa, el que consulta y el profeta que sea consultado."
,"11":"Así la casa de Israel no se apartará más de mí. Dejarán de ensuciarse con sus faltas, serán mi pueblo y yo seré su Dios, palabra de Yavé.'"
,"12":"Se me dirigió esta palabra de Yavé:"
,"13":"'Hijo de hombre, imagínate un país que peca contra mí: es infiel y yo lo castigo; lo dejo sin pan, le envío el hambre para acabar con los animales y la gente."
,"14":"Imagínate que en ese país se encuentren estos tres hombres: Noé, Daniel y Job. Pues bien, lo digo yo, esos tres hombres salvarían su vida debido a su justicia, palabra de Yavé."
,"15":"Imagínate que en ese país suelto animales feroces para que quede sin hijos y se convierta en un desierto, el que nadie podrá atravesar por miedo a esas fieras salvajes."
,"16":"Por mi vida, dice Yavé, si esos tres hombres vivieran en este país, no podrían salvar ni a su hijo ni a su hija, pero ellos, sólo ellos, se salvarían mientras el país se convertiría en un desierto."
,"17":"Imagínate que hago venir la espada en contra de ese país y que yo diga: ¡Arrase la espada con este país y mate a hombres y animales!"
,"18":"Por mi vida, dice Yavé, si estos tres hombres estuvieran en ese país, no podrían salvar ni al hijo ni a la hija pero ellos salvarían su vida debido a su justicia."
,"19":"Imagínate, asimismo, que me dejo arrebatar por un furor destructor y que envío la peste a ese país acabando con animales y hombres."
,"20":"Si Noé, Daniel y Job estuvieran en ese país, por mi vida, dice Yavé, no salvarían ni hijos ni hijas, pero salvarían su vida a causa de su justicia."
,"21":"Esto dice el Señor: He enviado en contra de Jerusalén a mis cuatro terribles castigos: la espada, el hambre, las fieras feroces y la peste, porque quiero acabar con hombres y animales."
,"22":"Quedan, sin embargo, supervivientes, los cuales están saliendo y serán traídos hasta aquí, hombres y mujeres. Cuando sepan de su conducta y de sus obras,"
,"23":"se consolarán y comprenderán que no sin razón actué así con Jerusalén, palabra de Yavé.'"
}`)
	CurrentBook.AddChapter(15, `{
"1":"Me fue dirigida esta palabra de Yavé:"
,"2":"'Hijo de hombre, ¿acaso la madera de parra vale más que las otras maderas o que las ramas de los árboles del bosque?"
,"3":"¿Se usa la madera de parra para fabricar algún objeto? ¿Se hace con ella una clavija para encajarla en cualquier cosa?"
,"4":"Peor aun si fue echada al fuego: éste devoró sus dos puntas, y el medio está quemado, ¿se puede trabajar todavía?"
,"5":"Si cuando estaba entera, no se podía hacer nada con ella, ¿cuánto menos ahora que ha sido devorada y quemada por el fuego?"
,"6":"Por eso, así habla Yavé: Los habitantes de Jerusalén son como la madera de parra que se echa al fuego junto con los árboles silvestres."
,"7":"Volveré mi rostro contra ellos: escaparon al fuego pero el fuego los devorará, y sabrán que yo soy Yavé cuando vuelva mi rostro contra ellos."
,"8":"Convertiré al país en un desierto porque fueron infieles, palabra de Yavé.'"
}`)
	CurrentBook.AddChapter(16, `{
"1":"Me fue dirigida esta palabra de Yavé:"
,"2":"'Hijo de hombre, hazle ver a Jerusalén todas sus horribles acciones."
,"3":"Dile de mi parte: Naciste en Canaán y de allí saliste; tu padre era el amorreo y tu madre una hitita."
,"4":"Cuando naciste, el día en que viniste al mundo, no habían cortado tu cordón, ni te habían bañado en agua, ni frotado con sal, ni te habían envuelto en pañales."
,"5":"Nadie tuvo compasión de ti, nadie te cuidó, ni siquiera por piedad; el día en que viniste al mundo, a nadie interesabas y te dejaron en el suelo en medio del campo."
,"6":"Yo pasé entonces cerca de ti, te vi debatiéndote en medio de tu sangre y te dije: ¡Vive tú que pierdes tu sangre,"
,"7":"y crece como una hierba del campo! Entonces comenzaste a crecer, te desarrollaste, te convertiste en una jovencita, tu pecho se afirmó y tu cabellera creció; pero estabas desnuda, no tenías nada."
,"8":"Entonces pasé cerca de ti y te vi; era el tiempo de los amores, eché sobre ti mi manto, cubrí tu desnudez y te hice un juramento. Hice una alianza contigo, palabra de Yavé, y tu pasaste a ser mía."
,"9":"Te bañé con agua, lavé tu sangre y te perfumé con aceite."
,"10":"Te vestí con ropajes bordados, con calzado de cuero fino, puse en tu cabeza un velo de lino y de seda,"
,"11":"te adorné con joyas, puse brazaletes en tus muñecas, un collar en tu cuello,"
,"12":"un anillo en tu nariz, aros en tus orejas, y para tu cabeza una espléndida diadema."
,"13":"Tus joyas eran de oro y plata, tus vestidos de lino fino, hechos con telas preciosas todas bordadas. Te alimentabas de harina fina, de miel y de aceite, y quedaste magnífica: un día fuiste la reina."
,"14":"Tu belleza se hizo célebre entre las naciones: era una belleza perfecta gracias a mi esplendor que derramaba sobre ti, palabra de Yavé."
,"15":"Pero luego pusiste tu confianza en tu belleza, tu fama te permitió prostituirte; prodigaste tus encantos a cualquiera que pasaba y te fuiste con él."
,"16":"Tomaste tus vestidos para decorar los altos lugares en los que te prostituías."
,"17":"Tomaste tus joyas de oro y plata que te había dado, hiciste con ellas estatuas de machos con los que te prostituiste."
,"18":"Las cubriste con tus vestidos bordados y depositaste ante ellas mi aceite y mi incienso."
,"19":"Les presentaste como ofrenda de agradable olor el pan que te había dado, la harina flor, el aceite, la miel con que te alimentaba, palabra de Yavé."
,"20":"Más aún, tomaste a tus hijos y a tus hijas que tú me habías dado, y se los ofreciste para que los devoraran: ¿y no te bastaba eso que te corrompías?"
,"21":"No, pues degollaste a mis hijos y los entregaste para el sacrificio, para que esto fuera mejor que prostituirte, y te olvidaste de los días de tu juventud, cuando andabas desnuda y sin ropa y te debatías en tu propia sangre."
,"23":"Después de todas tus maldades, dice Yavé,"
,"24":"te construiste además estrados en todas tus plazas;"
,"25":"en todas las entradas de camino levantaste un montículo. Profanaste tu belleza, ofreciste tu cuerpo a cuantos pasaban y te revolcaste en la perdición."
,"26":"Te prostituiste con los egipcios tus vecinos bien constituidos, multiplicaste tus liviandades por el puro gusto de molestarme."
,"27":"Por eso, levanté mi mano contra ti, reduje tu ración y te abandoné al capricho de tus enemigos, las ciudades filisteas, que se avergonzaban de tu descarada conducta."
,"28":"No satisfecha todavía, te envileciste con los asirios, pero no quedaste satisfecha."
,"29":"Multiplicaste tus desórdenes en un país de mercaderes, en Caldea, y allí tampoco te sentiste satisfecha."
,"30":"¡Cuál no será mi furor, dice Yavé, al ver tu mala conducta de prostituta insolente!"
,"31":"Cuando levantabas tu estrado en todas las entradas de camino o en las plazas, no pedías tu paga como lo hace la prostituta,"
,"32":"sino que eras la mujer adúltera que busca extraños en vez de su marido."
,"33":"A las prostitutas les dan un regalo, pero tú, en cambio, dabas regalos a tus amantes; les pagabas para que vinieran de todas partes a envilecerse contigo."
,"34":"Te prostituías, pero era al revés de las otras mujeres: nadie corría detrás de ti, sino que tú pagabas y nadie te pagaba. Realmente no eras como las demás."
,"35":"Por eso, prostituta, escucha esta palabra de Yavé:"
,"36":"Ya que mostraste tu desnudez en tus prostituciones con tus amantes, con todos tus ídolos abominables, ya que derramaste la sangre de tus hijos,"
,"37":"yo, a mi vez, reuniré a todos tus amantes con los que te calentaste, a los que querías y a los que aborrecías; los reuniré en contra tuya de todas partes y ante ellos descubriré tu desnudez: te verán privada de todo."
,"38":"Te aplicaré la sentencia de las mujeres adúlteras y criminales; te entregaré a la cólera y a la indignación."
,"39":"Te entregaré en sus manos, derribarán y destruirán tus altos lugares, te quitarán tus vestidos, tomarán tus joyas y te dejarán desnuda, sin nada."
,"40":"Convocarán a la asamblea contra ti, te apedrearán y te atravesarán con sus espadas."
,"41":"Condenarán tus hijas -tus ciudades- a la hoguera en presencia de todas las demás mujeres; así haré que no puedas más prostituirte ni pagarte amantes."
,"42":"Cuando haya descargado mi furor, se acabará mi indignación, me calmaré y no me enojaré más."
,"43":"Pero ya que no te acordaste de los días de tu juventud, sino que me provocaste de mil maneras, yo haré que recaiga sobre tu cabeza tu conducta, palabra de Yavé. ¿No siguieron a tus acciones vergonzosas los crímenes?"
,"44":"Los que gustan de los refranes te dirán: 'De tal madre, tal hija.'"
,"45":"Tú eres hija de la madre que aborreció a su marido y a sus hijos, tú eres hermana de tus hermanas que abandonaron a sus maridos y a sus hijos, tu madre era hitita y tu padre, amorreo."
,"46":"Tu hermana mayor es Samaría que vive con sus hijas al lado norte tuyo, tu hermana menor es Sodoma que vive con sus hijas hacia el sur."
,"47":"Tú no seguiste a medias sus caminos para cometer el crimen, sino que te mostraste más desvergonzada que ellas en todo tu mal proceder."
,"48":"Por mi vida, dice Yavé, que tu hermana Sodoma y sus hijas no actuaron como tú y tus hijas."
,"49":"¿Cuál fue el pecado de tu hermana Sodoma? Era orgullosa, comía bien y vivía sin preocupaciones, ella y sus hijas no hicieron nada por el pobre y el desgraciado."
,"50":"Se volvieron arrogantes, hicieron lo que me desagrada, por eso las hice desaparecer como tú lo has visto."
,"51":"En cuanto a Samaria, no cometió ni siquiera la mitad de tus pecados; pero tú has cometido tantas abominaciones que tus hermanas parecen justas a tu lado."
,"52":"Por eso, ahora soporta tu afrenta ya que tus pecados más horribles que los de ellas las hacen aparecer como inocentes. Deberías estar roja de vergüenza por haber justificado así a tus hermanas."
,"53":"Las restableceré, restableceré a Sodoma y a sus hijas, restableceré a Samaria y a sus hijas, y luego te restableceré a ti en medio de ellas."
,"54":"Así, para consuelo de ellas, soportarás tu humillación y te avergonzarás de cuanto has hecho."
,"55":"Tus hermanas, Sodoma y sus hijas, Samaría y sus hijas serán restablecidas como eran antes; tú y tus hijas también serán restablecidas como antes."
,"56":"¿No te burlabas de Sodoma y la ponías de ejemplo en el tiempo de tu orgullo,"
,"57":"antes que se descubrieran tus maldades? Pues ahora tú eres la burla de Edom y de sus alrededores, y de los filisteos, que te desprecian por todas partes."
,"58":"Paga ahora tus pecados y tus crímenes, palabra de Yavé."
,"59":"Esto dice Yavé: Me portaré contigo como tu lo hiciste conmigo: rompiste la alianza sin pensar más en tu juramento."
,"60":"Sin embargo me acordaré de mi alianza contigo cuando eras joven y estableceré contigo una alianza eterna."
,"61":"Te acordarás entonces de tu conducta y te avergonzarás de ella cuando recibas a tus hermanas, tanto a las mayores como a las menores, cuando te las entregue como hijas, sin renegar en nada de mi alianza contigo."
,"62":"Porque mantendré mi alianza contigo y sabrás que yo soy Yavé."
,"63":"Entonces te acordarás, te sentirás llena de vergüenza y no te atreverás a abrir la boca cuando te perdone todo lo que has hecho, palabra de Yavé.'"
}`)
	CurrentBook.AddChapter(17, `{
"1":"Me fue dirigida esta palabra de Yavé:"
,"2":"'Hijo de hombre, inventa una comparación para la gente de Israel y diles que la adivinen."
,"3":"Les dirás: Esta es una palabra de Yavé: El gran águila de amplias alas, de largo plumaje, con sus plumas multicolores, llegó al Líbano: se subió a la copa del cedro. "
,"4":"Cogió la rama más alta, y la llevó al país de los negocios, a una ciudad de comerciantes."
,"5":"Luego, tomó una plantita del lugar, la puso en un campo como si fuera un sauce, donde no faltara el agua."
,"6":"La planta creció, llegó a ser una parra, de poca altura pero fértil, que extendía sus ramas hacia el águila mientras sus raíces se hundían. La parra brotó y se convirtió en una vid grande, dio guías y sarmientos."
,"7":"Pero llegó otra águila, grande, de anchas alas, de tupido plumaje, y la parra dirigió sus raíces y sus ramas hacia ella, esperando encontrar más agua que la que tenía en su tierra."
,"8":"Había sido sin embargo plantada en buena tierra, donde no faltaba el agua, podía extender sus ramas, dar frutos y ser una parra magnífica."
,"9":"Y ahora pregunta Yavé: ¿Prosperará? ¿No arrancará el otro sus raíces, cortará sus racimos y dejará que se sequen sus brotes? No necesitará de mucho esfuerzo ni de mucha mano de obra para arrancarla de raíz."
,"10":"Está plantada, pero ¿prosperará? Basta que se levante el viento del este para que se seque: se secará en la tierra donde floreció.'"
,"11":"Me llegó entonces una palabra de Yavé:"
,"12":"'Dirás a esos rebeldes: ¿No saben lo que eso significa? Pues bien, esto: el rey de Babilonia llegó a Jerusalén, tomó a su rey y a sus ministros y se los llevó a Babilonia."
,"13":"Luego, tomó un retoño de raza real, pactó con él una alianza y le impuso un juramento. Incluso se llevó a los responsables del país"
,"14":"para que el reino fuera pequeño, no pudiera rebelarse y así este último guardara y respetara su alianza."
,"15":"Pero ese príncipe se rebeló contra el rey de Babilonia, envió mensajeros a Egipto para que le dieran caballos y un numeroso ejército. ¿Podrá tener éxito? ¿Podrá escaparse después de haber roto la alianza?"
,"16":"Por mi vida, palabra de Yavé, él morirá en el país del rey que lo puso en el trono, en la tierra de ese rey cuyo juramento despreció y cuya alianza rompió. Morirá en Babilonia."
,"17":"Faraón no le enviará un gran contingente, con mucha gente, cuando se levanten terraplenes y torres para aplastar a los defensores."
,"18":"Menospreció el juramento, rompió la alianza siendo que había empeñado su palabra; y después de eso ¿podrá salvarse?"
,"19":"Por eso, esto dice Yavé: Tan cierto como que yo estoy vivo, haré que recaiga sobre su cabeza mi juramento que despreció y mi alianza que rompió."
,"20":"Tenderé mi red a su paso y quedará atrapado en sus mallas."
,"21":"Sus guardias caerán por la espada y los sobrevivientes serán dispersados a los cuatro vientos: entonces sabrán que yo Yavé fui quien habló."
,"22":"Esto dice Yavé: Yo mismo sacaré del cedro una patilla y la plantaré en una montaña alta y segura."
,"23":"La plantaré en una alta montaña de Israel, se desarrollará, dará frutos y se convertirá en un cedro magnífico; bajo él descansarán aves de todas las especies, se cobijarán a la sombra de sus ramas."
,"24":"Todos los árboles del campo sabrán entonces que yo soy Yavé: yo rebajo al árbol que se eleva y levanto al árbol humillado; seco al árbol verde y hago florecer al árbol seco; yo Yavé lo dije y lo haré.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Me fue dirigida esta palabra de Yavé:"
,"2":"'¿Por qué al hablar de Israel repiten este proverbio: Los padres comieron uvas verdes y los hijos tienen dentera?"
,"3":"Yo juro, dice Yavé, que ese proverbio no tendrá más valor en Israel."
,"4":"Porque todas las vidas me pertenecen, tanto la vida del hijo como la del padre, y el que peca, ése morirá."
,"5":"Sea un hombre justo que practica el derecho y la justicia;"
,"6":"no come la carne no desangrada, no vuelve sus ojos hacia los sucios ídolos de la casa de Israel,"
,"7":"no ensucia a la mujer de su prójimo ni se acerca a una mujer durante su regla; no oprime a nadie,"
,"8":"devuelve la garantía al que le debía, no comete robos, da su pan al que tiene hambre y le pone ropa al que está desnudo; no presta su dinero con interés, no cobra comisiones, aparta su mano de la injusticia, juzga conforme a la verdad cualquier problema entre un hombre y su prójimo;"
,"9":"sigue mis mandamientos, observa mis leyes y actúa en todo con fidelidad. Ese hombre es justo y vivirá, palabra de Yavé."
,"10":"Pero ocurre que ese hombre tiene un hijo violento, que derrama sangre y comete esas faltas"
,"11":"que su padre no cometió. Come la carne sin desangrar, ensucia a la mujer de su prójimo, trata violentamente al pobre y al indigente,"
,"12":"roba, no devuelve la garantía que se le pasó, vuelve su mirada hacia los sucios ídolos y comete el crimen,"
,"13":"presta su dinero con interés y cobra comisiones. ¿Después de todo eso, vivirá? Ciertamente que no. Si cometió todos esos crímenes, debe morir: él será responsable de su muerte."
,"14":"Pero ese hombre, a su vez, tiene un hijo; éste vio todos los pecados que cometía su padre, los vio pero no lo imitó."
,"15":"No come la carne sin desangrar, no vuelve su mirada hacia los sucios ídolos de la casa de Israel, no ensucia a la mujer de su prójimo,"
,"16":"a nadie trata con violencia, no se guarda la garantía, no roba, da su pan al que tiene hambre y le pone ropa al que está desnudo,"
,"17":"no trata al pobre con violencia, no cobra interés o comisión, observa mis leyes y sigue mis mandamientos. Ese no morirá por el pecado de su padre, sino que al contrario vivirá."
,"18":"Quien morirá por su pecado es el padre, el que multiplicó sus violencias, robó a su prójimo e hizo lo que es malo en medio de mi pueblo."
,"19":"Ustedes me preguntan: '¿Por qué el hijo no carga con el pecado de su padre?' ¡Pero si el hijo se comportó conforme al derecho y a la justicia, observó todos mis mandamientos y los puso en práctica! Debe pues vivir."
,"20":"Quien debe morir es el que peca; el hijo no carga con el pecado del padre, y el padre no cargará con el pecado del hijo. El mérito del justo le corresponderá sólo a él, y la maldad del malo, sólo a él."
,"21":"Si el malvado se aparta de todos los pecados cometidos, se dedica a observar todos mis mandamientos y se comporta de acuerdo al derecho y a la justicia, vivirá y no morirá;"
,"22":"se echarán al olvido todos los crímenes que cometió y, debido a la justicia que haya practicado, vivirá."
,"23":"¿Creen ustedes que me gusta la muerte del malvado? dice Yavé. Lo que me agrada es que renuncie a su mal comportamiento y así viva."
,"24":"En cambio, si el justo se aparta de su justicia y se dedica a hacer el mal, si comete las mismas fechorías que cometía el malo, serán dadas al olvido todas las obras de justicia que practicó. Morirá a causa de la infidelidad de la que se hizo culpable y del pecado que cometió."
,"25":"Ustedes dicen: La manera de ver las cosas que tiene Yavé no es la correcta. Oigan, pues, gente de Israel: ¿así que mi manera de ver las cosas no es correcta? ¿No lo será más bien la de ustedes?"
,"26":"Cuando el justo se aparta de la justicia y comete el mal y por eso muere, muere por culpa de la injusticia que cometió."
,"27":"Del mismo modo, si el malvado se aparta de la mala vida que llevaba y actúa según el derecho y la justicia, vivirá."
,"28":"Si se aparta de todas las infidelidades que cometía, debe vivir, pero no morir."
,"29":"La gente de Israel dice: La manera de ver las cosas que tiene el Señor no es justa. ¿Así que mi manera de ver las cosas no es justa, gente de Israel, no será más bien la de ustedes?"
,"30":"Juzgaré a cada uno de ustedes de acuerdo a su comportamiento, gente de Israel, dice Yavé. Corríjanse y renuncien a todas sus infidelidades, a no ser que quieran pagar el precio de sus injusticias."
,"31":"Lancen lejos de ustedes todas las infidelidades que cometieron, háganse un corazón nuevo y un espíritu nuevo; ¿o es que quieren morir, gente de Israel?"
,"32":"A mí no me gusta la muerte de nadie, palabra de Yavé; conviértanse y vivirán.'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"Vas a pronunciar una lamentación respecto a los príncipes de Israel."
,"2":"Dirás: '¡Qué leona era tu madre en medio de los leones! Se acostaba junto a sus cachorros y los amamantaba. "
,"3":"Educó a uno de sus cachorros que se convirtió en un joven león, aprendió a desgarrar la presa y a devorar a los hombres."
,"4":"Pero como las naciones oyeron hablar de él, fue capturado en una fosa y llevado encadenado a Egipto."
,"5":"La leona se decepcionó, sus esperanzas se vieron frustradas; tomó a otro de sus cachorros al que convirtió en un joven león."
,"6":"Como joven león, salía con los leones, aprendió a desgarrar la presa y a devorar hombres."
,"7":"Destruyó sus palacios, arrasó sus ciudades, sus rugidos aterrorizaban al país y a sus habitantes."
,"8":"Llegaron extranjeros de todas las provincias a atacarlo; le echaron encima sus redes y cayó en una fosa."
,"9":"Lo pusieron encadenado en una jaula y se lo llevaron a Babilonia, donde lo dejaron en cautiverio: ¡ya no se oirá más su voz por las montañas de Israel!"
,"10":"Tu madre era como una parra plantada a orilla del agua, una parra fértil y verde porque no le faltaba el agua."
,"11":"Produjo una rama tan grande como para hacer de ella un cetro de rey. Creció hasta las nubes (se admiraban de su altura y de su tupido follaje.)"
,"12":"Pero la arrancaron con rabia y la echaron al suelo, el viento del este secó sus racimos que se cayeron. (La rama vigorosa se secó, el fuego la devoró.)"
,"13":"Ahora está plantada en una tierra árida, en el desierto."
,"14":"(Un fuego que salió de su tronco devoró sus sarmientos y sus racimos.) ¿Qué le pasó? No más rama vigorosa, no más cetro real. Es una lamentación, y ¡cuánto no se lamentarán!'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"El diez del quinto mes del séptimo año, algunos ancianos de Israel habían venido a consultar a Yavé y se hallaban sentados frente a mí."
,"2":"Me fue dirigida entonces esta palabra de Yavé:"
,"3":"'Hijo de hombre, les dirás a los ancianos de Israel esta palabra de Yavé: ¿Así que ustedes vinieron a consultarme? Pues bien, tan cierto como que yo estoy vivo que no dejaré que me consulten, palabra de Yavé."
,"4":"Júzgalos, hijo de hombre, ¿no los vas a juzgar? Hazles ver las horribles acciones de sus padres."
,"5":"Les dirás esta palabra de Yavé: Hice un juramento a la raza de Jacob, el mismo día en que elegí a Israel, me di a conocer a ellos en Egipto y les hice este juramento: Yo, Yavé, seré su Dios."
,"6":"Ese día, mano en alto, juré que los haría salir de Egipto a un país que había seleccionado para ellos, un país que mana leche y miel, el más bello de todos los países."
,"7":"Les había dicho: Lancen lejos de ustedes esas cosas que los seducen, no se ensucien con los ídolos de Egipto: yo soy Yavé su Dios."
,"8":"Pero se rebelaron contra mí y no quisieron escucharme. No arrojaron lejos de sí a esos ídolos que los seducían, no abandonaron a los ídolos de Egipto. Pensé desatar mi cólera en su contra, hacerles sentir mi furor en el país de Egipto."
,"9":"Pero no quise que mi nombre fuera profanado en presencia de las naciones en las cuales vivían: al contrario me di a conocer a esas naciones haciéndolos salir del país de Egipto."
,"10":"Una vez que salieron de Egipto, los conduje al desierto."
,"11":"Allí les di mis mandamientos y les di a conocer mis leyes, las que debe el hombre practicar para vivir."
,"12":"Les di mis sábados para que sean una señal entre yo y ellos, para que sepan que yo soy Yavé, quien los hace santos."
,"13":"Pero el pueblo de Israel se rebeló contra mí en el desierto. No siguieron mis mandamientos, menospreciaron mis leyes, las que debe el hombre practicar para vivir, no tuvieron respeto alguno por mis sábados. Entonces pensé descargar mi cólera contra ellos y hacerlos desaparecer en el desierto."
,"14":"Pero no quise profanar mi nombre ante las naciones que habían visto cómo los había hecho salir."
,"15":"Una vez en el desierto, sin embargo, juré que no los llevaría al país que les había prometido, a ese país que mana leche y miel, el más bello de todos los países."
,"16":"porque habían rechazado mis mandamientos, no habían seguido mis leyes, habían profanado mis sábados y habían vuelto a sus ídolos."
,"17":"Pero tuve para con ellos una mirada compasiva, no los destruí ni los exterminé en el desierto."
,"18":"Dije a sus hijos en el desierto: No sigan las huellas de sus padres, ni imiten su conducta, no se vuelvan impuros sirviendo a sus ídolos."
,"19":"Yo soy Yavé, su Dios, sigan mis mandamientos, observen mis leyes y pónganlas en práctica."
,"20":"Respeten mis sábados, que sean una señal entre yo y ustedes para que así sepan que yo soy Yavé su Dios."
,"21":"Pero los hijos se rebelaron contra mí, no siguieron mis mandamientos, no observaron mis leyes (esas leyes que el hombre debe poner en práctica para vivir) y no tuvieron respeto alguno por mis sábados. Pensé desencadenar mi cólera contra ellos, derramar mi furor sobre ellos en el desierto,"
,"22":"pero no quise que mi nombre fuera profanado ante las naciones bajo cuya mirada los había hecho salir."
,"23":"Sin embargo, aún en el desierto, juré echarlos a las naciones y dispersarlos entre los países extranjeros."
,"24":"Porque no habían puesto en práctica mis leyes, habían despreciado mis mandamientos, no habían respetado mis sábados sino que sus ojos se habían vuelto hacia los sucios ídolos de sus padres."
,"25":"Llegué hasta a darles mandamientos malos y leyes incapaces de hacerlos vivir:"
,"26":"los volví impuros mediante sus ofrendas cuando hacían pasar por el fuego a sus primogénitos."
,"27":"Pues bien, hijo de hombre, esto le dirás al pueblo de Israel. Le dirás esta palabra de Yavé: ¡Vean esta infidelidad de sus padres y cómo me ofendieron!"
,"28":"Los hice entrar en el país que les había prometido con juramento, pero inmediatamente, en cualquier alta colina, bajo cualquier árbol verde, se pusieron a ofrecer sacrificios, a depositar perfumes de incienso y a hacer libaciones."
,"29":"Yo les dije: ¿Qué están haciendo? Y les pusieron a esos lugares el nombre de 'Bama' (¿Qué?) hasta el día de hoy."
,"30":"Y ahora dirás a la gente de Israel de parte de Yavé: ¿No se han vuelto impuros como sus padres y no se han prostituido con sus sucios ídolos?"
,"31":"Aún ahora se vuelven impuros con todos sus sucios ídolos, les presentan sus ofrendas y ¿tendré que dejar que me consulten, gente de Israel? Tan cierto como que soy vivo, palabra de Yavé, que no dejaré que me consulten."
,"32":"Ustedes sueñan con ser como los paganos, vivir como se acostumbra en los países extranjeros en los que se adoran los palos y las piedras; pero eso no sucederá."
,"33":"Tan cierto como que vivo que reinaré sobre ustedes a la fuerza, castigándolos duramente, y haré que experimenten el peso de mi cólera."
,"34":"Haré que salgan de todos los pueblos y los reuniré de todos esos países en donde, en mi cólera, los había dispersado a la fuerza, castigándolos duramente."
,"35":"Los llevaré al desierto y allí los juzgaré cara a cara."
,"36":"Los juzgaré, dice Yavé, como juzgué a sus padres en el desierto de Egipto."
,"37":"Los haré pasar bajo mi varilla y los contaré uno a uno."
,"38":"Expulsaré de entre ustedes a los rebeldes, a los que se rebelaron contra mí; los echaré del país donde se encuentran, pero no entrarán en la tierra de Israel; entonces sabrán que yo soy Yavé."
,"39":"Gente de Israel, Yavé les dice: Sigan no más sirviendo a sus sucios ídolos, pues al final me escucharán y no profanarán más mi Santo Nombre con esas ofrendas y esos ídolos."
,"40":"Sí, en mi montaña santa, en una alta montaña de Israel, dice Yavé, toda la casa de Israel vendrá a rendirme homenaje. Allí recibiré y aguardaré sus ofrendas, las primicias de todo lo que me presenten, de todo lo que me consagren."
,"41":"Cuando salgan de en medio de los pueblos y los junte de todos los países en donde fueron dispersos, serán para mí como un perfume de agradable olor. Entonces, por medio de ustedes haré que las naciones vean mi santidad."
,"42":"Ese día, cuando los traiga de vuelta a la tierra de Israel, al país que juré que les daría a sus padres, sabrán ustedes que yo soy Yavé."
,"43":"Entonces se acordarán de su conducta y de todo lo que los volvió impuros, se avergonzarán de ustedes mismos y de todas sus malas acciones."
,"44":"Actuaré con ustedes conforme al honor de mi Nombre y no a como lo merecen su conducta y sus malas acciones, dice Yavé, entonces sabrán que yo soy Yavé.'"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Se me dirigió esta palabra de Yavé:"
,"2":"'Hijo de hombre, vuélvete a tu derecha, profetiza hacia el sur, profetiza en contra del Bosque del sur."
,"3":"Le dirás al bosque del sur: Escucha la palabra de Yavé... Esto dice Yavé: Encenderé en ti un fuego que consumirá todos los árboles: verdes o secos. Ese fuego violento no se apagará y en él arderán todas las personas desde el sur al norte. "
,"4":"Entonces todo mortal entenderá que yo Yavé fui quien lo prendió, porque no se extinguirá.'"
,"5":"Respondí: '¡Ay, Yavé, dicen que hablo siempre de manera misteriosa!'"
,"6":"Entonces se me dirigió esta palabra de Yavé:"
,"7":"'Hijo de hombre, vuélvete hacia Jerusalén, profetiza en contra del Templo, profetiza en contra de la tierra de Israel."
,"8":"A la tierra de Israel le dirás esta palabra de Yavé: Me lanzo contra ti. Sacaré mi espada de la vaina y acabaré con el justo y con el malo."
,"9":"Sí, quiero que desaparezcan de ti tanto el justo como el malvado; para eso sale mi espada de su vaina, para castigar a todo mortal, desde el sur al norte."
,"10":"Y todo mortal sabrá que yo Yavé fui quien sacó la espada de la vaina, y no la guardaré más."
,"11":"¡Ponte a gemir, hijo de hombre! Lanza gemidos ante ellos como si tuvieras roto el corazón, lleno de tristeza."
,"12":"Y si te dicen ¿Por qué te lamentas tanto? les responderás: Es por una noticia que acaba de llegar, todos se van a desmoralizar, se les caerán las manos, sus espíritus se perturbarán y sus rodillas temblarán. He aquí que viene, ya está aquí, dice Yavé.'"
,"13":"Me fue dirigida una palabra de Yavé:"
,"14":"'Hijo de hombre, profetiza. Les dirás esta palabra de Yavé: ¡Brilla la espada, la afilada!"
,"15":"Le han sacado punta para la masacre, brilla y lanza destellos."
,"16":"Yavé la dio para que la hagan relucir y para que la tomen con toda la mano; esa espada afilada y que brilla se la entregarán al verdugo."
,"17":"Grita, hijo de hombre, lanza alaridos, porque está destinada a mi pueblo, a todos los jefes de Israel. Serán pasados a espada junto con el pueblo, ¡golpéate de desesperación!"
,"18":"El castigo está decidido, palabra de Yavé."
,"19":"Y tú, hijo de hombre, profetiza y aplaude con fuerza. Que la espada pase tres veces, la espada que traspasa a sus víctimas, la gran espada que masacra y que pasa por enmedio de ellos."
,"20":"Todos se asustarán y muchos morirán, porque en todas las puertas he puesto la espada para la masacre; lanza destellos, reluce para la masacre."
,"21":"¡Mata a diestra y siniestra, mata en todas partes!"
,"22":"Y yo aplaudiré con fuerza, porque mi cólera habrá quedado satisfecha: yo, Yavé, hablé.'"
,"23":"Se me dirigió esta palabra de Yavé:"
,"24":"'Hijo de hombre, traza dos caminos para la espada del rey de Babilonia. Los dos salen del mismo punto,"
,"25":"pero tú pon allí un letrero para que la espada pueda elegir entre los dos caminos, cada uno de los cuales lleva a una ciudad: o Rabba de los amonitas o Judá, con Jerusalén en el centro."
,"26":"El rey de Babilonia se detuvo en el cruce de caminos, se ve la suerte, sacude las flechas, interroga a los ídolos, examina el hígado de los animales."
,"27":"La suerte hace que salga Jerusalén en su mano derecha. Inmediatamente lanza un grito de guerra: '¡Emplacen las maquinarias junto a las puertas, levanten terraplenes, caven trincheras!'"
,"28":"Los habitantes de Jerusalén no lo pueden creer, pero el rey de Babilonia no se ha olvidado de su infidelidad y se lo hará pagar."
,"29":"Esto dice Yavé: Ustedes han hecho justamente lo que se necesita para que se acuerden de sus deudas, para que quede al desnudo el pecado en todas sus malas acciones. Me he acordado de ustedes y serán tomados a la fuerza."
,"30":"Ha llegado para ti el tiempo del castigo definitivo, príncipe de Israel, criminal infame."
,"31":"Esto dice Yavé: Te arrancarán el turbante, te quitarán la corona y se invertirá la situación: lo que está abajo será levantado y lo que está arriba será rebajado."
,"32":"En ruinas, ruinas y más ruinas lo convertiré todo hasta que venga aquel a quien le pertenece el derecho, a ése lo restableceré."
,"33":"Profetiza, hijo de hombre, con respecto a los amonitas en respuesta a sus insultos. Les dirás esta palabra de Yavé: Han sacado la espada para la masacre, la espada reluce y devora, lanza destellos."
,"34":"Te apoyas en falsas visiones, en señales mentirosas; serás condenado a la espada y echado junto con los malvados masacrados: llegó la hora, la injusticia llegó a su fin."
,"35":"Regresa a tu casa, deja esas tierras, quiero juzgarte ahí mismo donde fuiste creado, en la tierra donde naciste."
,"36":"Desencadenaré mi cólera contra ti, el fuego de mi furor te alcanzará; te entregaré en manos de hombres bárbaros que lo único que saben es destruir."
,"37":"Te condenaré a las llamas, tu sangre se derramará por tus tierras, y no se acordarán más de ti, porque yo Yavé, hablé.'"
}`)
	CurrentBook.AddChapter(22, `{
"1":"Se me dirigió esta palabra de Yavé:"
,"2":"'Hijo de hombre, ¿no juzgarás a la ciudad sanguinaria?"
,"3":"Dale a conocer todos sus crímenes. Le comunicarás esta palabra de Yavé: Ay de esta ciudad, pues adelantó su hora con la sangre derramada en medio de ella, se volvió impura con los ídolos que se hizo. "
,"4":"La sangre derramada te ha convertido en culpable, te hiciste ídolos y con ello te has ensuciado. Adelantaste tu hora y el término de tus años: te convertiré en la vergüenza de las naciones, en motivo de risa para todos los pueblos."
,"5":"Estén cerca o lejos, se burlarán de ti por haber ensuciado tu nombre y multiplicado tus crímenes."
,"6":"Los jefes de Israel no han hecho más que derramar sangre, cada uno por su cuenta."
,"7":"Dentro de ti se desprecia al padre y a la madre, se maltrata al extranjero, se trata con violencia al huérfano y a la viuda."
,"8":"Se desprecia lo que me está consagrado, no se respetan mis sábados."
,"9":"Dentro de ti, la gente calumnia y derrama sangre, se come la carne sin desangrar, se cometen mil fechorías."
,"10":"Dentro de ti una tiene relaciones con su padre, otro se acuesta con una mujer que tiene sus reglas;"
,"11":"otro comete el adulterio, otro violenta a su nuera, otro viola a su propia hermana, a la hija de su padre."
,"12":"Dentro de ti, se condena a muerte por dinero, prestan a interés y cobran comisiones. Despojas brutalmente a tu prójimo, y me has olvidado, palabra de Yavé."
,"13":"Pero ahora aplaudo por toda esta corrupción y por la sangre que hay en ti."
,"14":"¿Conservarás tu tranquilidad, serás tan atrevida el día en que me lance contra ti? Yo Yavé hablé y lo haré."
,"15":"Te dispersaré entre las naciones, te arrojaré en medio de los pueblos, haré que desaparezca de ti tu impureza."
,"16":"Te dejaré deshonrada en presencia de las naciones y sabrás que yo soy Yavé.'"
,"17":"Se me dirigió esta palabra de Yavé:"
,"18":"'Hijo de hombre, la gente de Israel se ha convertido para mí en un metal impuro. Son como el cobre, el estaño, el hierro o el plomo, a los que hay que pasar por el fuego porque son metales impuros."
,"19":"Por eso, esto dice Yavé: Los reuniré en Jerusalén como se hace con el metal impuro."
,"20":"Así, como se junta la plata, el cobre, el hierro, el plomo y el estaño en un horno para fundirlos a fuerza de calor, así los juntaré en mi cólera para que se fundan:"
,"21":"los fundiré en el fuego de mi cólera."
,"22":"Así como se funde la plata en el horno, así serán fundidos en medio de la ciudad y sabrán que yo Yavé fui quien desencadenó mi cólera contra ustedes.'"
,"23":"Se me dirigió esta palabra de Yavé:"
,"24":"'Hijo de hombre, dile a Jerusalén: Eres como una tierra que no ha recibido ni lluvias ni aguaceros en tiempo de siembra."
,"25":"Los que en ti mandan son como un león rugiente que desgarra su presa: devoran a la gente, les quitan sus bienes y sus joyas, y por su culpa las viudas son cada vez más numerosas."
,"26":"Tus sacerdotes han menospreciado mi Ley y profanado lo que me está consagrado, no han distinguido entre lo que es santo y lo que es profano. No han mostrado la diferencia entre lo impuro y lo puro; han ignorado mis sábados y entre ellos me he sentido deshonrado."
,"27":"Tus jefes se comportan en el país como lobos que desgarran una presa, que derraman sangre y condenan a muerte a la gente para sacar algún provecho."
,"28":"Durante este tiempo tus profetas tranquilizan a la gente con visiones engañosas y predicciones mentirosas. Dicen: '¡Palabra de Yavé!' siendo que Yavé nada ha dicho."
,"29":"Los propietarios se dedican a la violencia, cometen robos, maltratan al pobre y al indigente y le niegan sus derechos al forastero."
,"30":"He buscado entre ellos a un hombre que construyera una muralla y se enfrentara conmigo sobre la almena para impedirme que destruya al país, pero no lo he hallado."
,"31":"Entonces he desencadenado mi cólera contra ellos, los he exterminado con el fuego de mi furor y he hecho que recaiga sobre su cabeza su mal comportamiento, palabra de Yavé.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Se me dirigió esta palabra de Yavé:"
,"2":"'Hijo de hombre, había dos mujeres, hijas de una misma madre."
,"3":"Desde su juventud en Egipto empezaron a prostituirse, metían mano en sus senos y acariciaban su pecho de muchachas."
,"4":"La mayor se llamaba Ohola y su hermana Oholiba; eran mías y me dieron hijos e hijas. Ohola es Samaria y Oholiba, Jerusalén."
,"5":"Ohola me engañó: ardía de pasión por sus amantes. Eran sus vecinos asirios,"
,"6":"gobernadores y funcionarios vestidos de púrpura, jóvenes y bien apuestos en sus caballos."
,"7":"Con ellos me engañó, con esos asirios de clase alta. Ardía de amor por ellos, y al mismo tiempo se ensuciaba con sus ídolos."
,"8":"Pero no se había olvidado de sus prostituciones con los Egipcios sino que seguían acostándose con ella, manoseaban sus senos y abusaban de ella."
,"9":"Por eso, la entregué en manos de sus amantes, en manos de los asirios por quienes ardía en amor."
,"10":"La desnudaron, tomaron a sus hijos e hijas y los mataron a espada; se hizo famosa entre las mujeres debido al castigo que se le infligió."
,"11":"Su hermana Oholiba fue testigo de todo eso, pero sus desvaríos y prostituciones superaron a los de su hermana."
,"12":"También ella ardía de pasión por sus vecinos asirios, esos gobernadores y jefes que andaban ricamente vestidos, jóvenes y bien apuestos en sus caballos."
,"13":"Vi cómo se ensuciaba, cómo ambas seguían el mismo camino."
,"14":"Lo hizo peor aún en su prostitución cuando vio esas imágenes de caldeos pintadas de color rojo, de esos hombres que se veían pintados en los muros,"
,"15":"con sus fajas en la cintura y grandes turbantes en sus cabezas, esos hombres de aspecto marcial cuyo país natal es Caldea."
,"16":"Apenas los vio, se encendió en ella el deseo por ellos: envió mensajeros adonde ellos en Caldea."
,"17":"Los hijos de Babilonia vinieron para ensuciarla con sus prostituciones, y la dejaron tan mancillada que su corazón se apartó de ellos."
,"18":"Pero como ella se había prostituido y entregado, mi corazón también se apartó de ella como se había ya apartado de su hermana."
,"19":"Sí, ella multiplicaba sus prostituciones, revivía su juventud cuando se prostituía en Egipto."
,"20":"Ardía en deseo por unos desvergonzados que se calentaban como burros y cuyo sexo era como el de los caballos."
,"21":"Sí, Jerusalén, volviste a la degradación de tu juventud, cuando los Egipcios acariciaban tu pecho y pasaban sus manos por tus senos."
,"22":"Por eso, Oholiba, esto dice Yavé: Voy a azuzar en contra tuya a tus amantes de los cuales se apartó tu corazón; los reuniré en tu contra de todas partes."
,"23":"babilonios y caldeos, los de Pegod, de Soa y de Coa, y con ellos a todos los asirios, jóvenes y hermosos, gobernadores y funcionarios, oficiales famosos y diestros caballeros."
,"24":"Una coalición de pueblos vendrán del norte para asaltarte con sus carros y carretas. Se lanzarán contra ti de todas partes con sus escudos, armas y cascos, les encargaré que te juzguen y te juzgarán según sus leyes."
,"25":"Daré libre curso a mis celos contigo: te tratarán cruelmente, te cortarán la nariz y las orejas, y lo que quede de tus hijos caerá por la espada. Tomarán a tus hijos y a tus hijas, y los sobrevivientes serán devorados por las llamas."
,"26":"Te despojarán de tus vestidos y te quitarán tus joyas;"
,"27":"así pondré fin a tu mala conducta y a tus prostituciones iniciadas en Egipto. Ya no los mirarás más ni pensarás más en Egipto."
,"28":"Esto dice Yavé: Te entregaré en manos de los que tú odias, en manos de aquellos a los que tu corazón ya no quiere."
,"29":"En tu odio te maltratarán, se apoderarán de todo el fruto de tu trabajo y te dejarán desnuda y sin nada; no te quedará más que la vergüenza por tus prostituciones, desvaríos y mala conducta."
,"30":"Todo eso te pasará porque te prostituiste con las naciones y con sus sucios ídolos."
,"31":"Ya que seguiste el camino de tu hermana, pondré también en tu mano su copa."
,"32":"Esto dice Yavé: Beberás la copa de tu hermana, una copa ancha y honda, de gran capacidad."
,"33":"Quedarás saturada de embriaguez y de angustia porque la copa de tu hermana sólo contiene desolaciones."
,"34":"La tomarás hasta la última gota, te tragarás hasta los vidrios; yo lo he dicho, palabra de Yavé."
,"35":"Y esta es una palabra de Yavé: 'Ya que tú me olvidaste y te apartaste de mí, cargarás con el peso de tu vergüenza y de tus prostituciones'."
,"36":"Yavé me dijo de nuevo: Hijo de hombre, ¿no quieres juzgar a Ohola y a Oholiba y echarles en cara sus crímenes?"
,"37":"Han sido adúlteras, sus manos están llenas de sangre, cometieron adulterio con sus innumerables ídolos, hicieron pasar por el fuego a los hijos que me habían dado a luz."
,"38":"Al mismo tiempo que se comportaban así, se dedicaban a manchar mi Templo y profanaban mis sábados,"
,"39":"inmolaban sus hijos a los ídolos y venían a profanar mi Templo. Eso hicieron en mi casa."
,"40":"Mandaste venir hombres de tierras lejanas, les enviaste mensajeros y éstos vinieron. Para ellos te bañaste, te maquillaste los ojos y te pusiste tus joyas."
,"41":"Luego te reclinaste sobre una cama lujosa; delante de ella pusieron una mesa y allí depositaste mi incienso y mi aceite."
,"42":"Se oía el ruido como de una muchedumbre enfiestada a la que se habían juntado hombres venidos del desierto; éstos colocaban brazaletes en las manos de las mujeres y espléndidas coronas en sus cabezas."
,"43":"Entonces dije de esa ciudad carcomida por el vicio: '¡Qué prostituta!"
,"44":"Van a su casa como quien va a un prostíbulo.' Y así en efecto iban a casa de Ohola y de Oholiba para hacer el mal."
,"45":"Actuaron con justicia los que les aplicaron la sentencia que conviene a las mujeres adúlteras, la condenación reservada a las que derraman sangre. ¡Porque realmente son adúlteras y tienen sangre en sus manos!"
,"46":"Sí, esto dice Yavé: Convoquen la asamblea, condénenlas al terror y al pillaje."
,"47":"La asamblea las lapidará y las herirán con la espada, matarán a sus hijos y a sus hijas y quemarán sus casas."
,"48":"Así, pondré término a la degradación en el país; eso servirá de lección a todas las mujeres, para que no cometan las mismas faltas."
,"49":"Haré que tu perdición recaiga sobre ti y cargarás con el peso de los pecados cometidos con tus ídolos: entonces sabrás que yo soy Yavé.'"
}`)
	CurrentBook.AddChapter(24, `{
"1":"El año noveno, el día décimo del décimo mes, se me dirigió esta palabra de Yavé."
,"2":"'Hijo de hombre, toma nota por escrito de esta fecha, porque hoy el rey de Babilonia ha puesto sitio a Jerusalén."
,"3":"Habla, pues, en figuras para esa banda de rebeldes. Dirás de parte de Yavé: Pon la olla en el fuego y échale agua."
,"4":"Llénala con trozos de carne, con las mejores presas: perniles y lomos. Llénala con los mejores huesos."
,"5":"Anda y toma lo mejor del rebaño, pon leña bajo la olla y hazla hervir un buen rato hasta que se hayan cocido los huesos.'"
,"6":"Y ahora, esto dice Yavé: '¡Ay de la ciudad sanguinaria! Es una olla oxidada y el óxido no sale, vacíala pieza por pieza sin elegir."
,"7":"Porque en medio de ella hay sangre. Si hasta la derramó en las rocas y no lo hizo en el suelo ni la recubrió con tierra."
,"8":"Yo mismo quise esa sangre aún en las rocas, al descubierto, para que así se excitara mi cólera y se precipitara la venganza."
,"9":"Por eso, esto dice Yavé: ¡Ay de la ciudad sanguinaria! Yo también preparo una gran hoguera,"
,"10":"junto la leña, prendo el fuego y coceré tan bien la carne que desaparecerá hasta el jugo."
,"11":"Pondré luego la olla vacía sobre carbones, se calentará, el bronce se pondrá rojo, desaparecerán sus impurezas y se le irá el óxido."
,"12":"¡Pero no! El óxido está tan metido que no sale con el fuego."
,"13":"Tus pecados te han manchado de tal manera que ya no podrás volver a quedar pura si no doy libre curso a mi cólera en contra de ti."
,"14":"Yo Yavé lo dije, y lo haré; no retrocederé, no tendré piedad ni misericordia, se te juzgará según tu conducta y según tus obras, palabra de Yavé.'"
,"15":"Me llegó una palabra de Yavé:"
,"16":"' Hijo de hombre, te retiraré de un golpe la alegría de tus ojos, pero tú no harás lamentaciones ni llorarás."
,"17":"Suspira en silencio y no guardes luto como se hace por los muertos; quédate con tu turbante en la cabeza y con tus sandalias en los pies, no tapes tu barba ni comas el pan que te traigan tus vecinos.'"
,"18":"Por la mañana hablaba al pueblo, y por la tarde mi mujer había muerto. Al día siguiente hice como se me había ordenado;"
,"19":"entonces el pueblo me dijo: '¿Quieres explicarnos por qué actúas así?'"
,"20":"Les respondí: 'Esta es la palabra de Yavé que se me comunicó:"
,"21":"Dirás de mi parte a la casa de Israel: Me preparo para profanar mi santuario, del cual están ustedes tan orgullosos y que es la alegría de sus ojos; también serán muertos sus hijos y sus hijas a los que dejaron y en los cuales piensan continuamente."
,"22":"Pero harán como lo hago yo, no se taparán la barba, no comerán el pan que les lleven los vecinos,"
,"23":"seguirán con sus turbantes en la cabeza y sus sandalias en los pies, no gemirán ni llorarán. Se sentirán débiles a causa de sus maldades y se lamentarán entre ustedes."
,"24":"Ezequiel será para ustedes una señal: todo lo que él hizo, lo harán también ustedes, y cuando esto suceda, sabrán que yo soy Yavé."
,"25":"Acuérdate de esta advertencia, hijo de hombre: el día en que se les quite su 'refugio', esa joya que es la alegría de sus ojos, así como también a sus hijos y a sus hijas en los que piensan continuamente,"
,"26":"ese día llegará un escapado para darte la noticia."
,"27":"Entonces se abrirá tu boca para hablarle al escapado, ya no estarás más mudo. Serás para ellos una señal y sabrán que yo soy Yavé.'"
}`)
	CurrentBook.AddChapter(25, `{
"1":"Se me comunicó esta palabra de Yavé:"
,"2":"'Hijo de hombre, vuélvete hacia los amonitas y profetiza contra ellos."
,"3":"Dirás esto a los hijos de Amón de parte de Yavé: Te reías mucho cuando mi Templo fue profanado, cuando la tierra de Israel fue devastada y el pueblo de Judá partió a la cautividad."
,"4":"Pues bien, por eso, te voy a entregar en manos de los hijos de Oriente; vendrán a acampar en tu tierra, en ella instalarán sus tiendas, comerán tus frutos y tomarán tu leche."
,"5":"Convertiré a Rabba en un potrero para los camellos, y a la tierra de Amón en un corral para las ovejas; entonces sabrán que yo soy Yavé."
,"6":"Porque esto dice Yavé: Aplaudiste con ganas y zapateaste, te reíste con sarcasmo de la tierra de Israel."
,"7":"Pues bien, por eso, levanto mi mano en contra tuya; te convertirás en pasto de las naciones, haré que desaparezcas de entre los pueblos y ya no serás más un país. Entonces sabrás que yo soy Yavé."
,"8":"Esta es otra palabra de Yavé: Moab dijo que la casa de Judá era como todas las demás naciones."
,"9":"Por eso mismo abriré el flanco de Moab y arrasaré de una frontera a otra con esas ciudades que son el ornato del país: Bet-Jerimot, Baal-Meón y Cariataim."
,"10":"Igual que a los amonitas los entregaré a los hijos de Oriente y no se acordarán más de ellos entre las naciones."
,"11":"Cuando castigue a Moab, sabrán que yo soy Yavé."
,"12":"Esto dice Yavé: Edom se vengó de la gente de Judá pero esa venganza le va a costar caro."
,"13":"Esto dice Yavé: Levantaré mi mano en contra de Edom y acabaré con hombres y animales; lo convertiré en un desierto: Desde Temán a Dedán caerán por la espada."
,"14":"Le encomendaré a mi pueblo de Israel mi venganza contra Edom; tratará a Edom según mi cólera y mi furor; y reconocerán mi venganza, palabra de Yavé."
,"15":"Esto dice Yavé: Los filisteos se vengaron, se vengaron con desprecio y con odio, destruyeron con un odio sin límites."
,"16":"Pues bien, esto dice Yavé: Me preparo para levantar mi mano en contra de los filisteos. Eliminaré a los quereteos y destruiré lo que queda de los habitantes de la costa."
,"17":"Me vengaré de manera terrible: entonces sabrán que yo soy Yavé.'"
}`)
	CurrentBook.AddChapter(26, `{
"1":"El año undécimo, el primero del mes, se me comunicó una palabra de Yavé:"
,"2":"'Hijo de hombre, Tiro se rió mucho de Jerusalén, pues dijo: ¡Miren como está rota la puerta de los pueblos! Está arruinada, todo el comercio terminará ahora en mí."
,"3":"Pues bien, esto dice Yavé: Me lanzaré contra ti, Tiro, y haré que suban contra ti naciones tan numerosas como las olas del mar."
,"4":"Destruirán las fortificaciones de Tiro y demolerán sus torres; barreré de ti hasta el polvo y te convertiré en una roca desnuda."
,"5":"No será más que un secadero marino para tender las redes. Yo Yavé lo he dicho: será sometida al pillaje por las naciones."
,"6":"Sus ciudades que están en tierra firme serán condenadas a la espada, y sabrán que yo soy Yavé."
,"7":"Porque esto dice Yavé: Haré venir del norte contra Tiro a Nabucodonosor, rey de Babilonia, el rey de reyes. Llegará con caballos, carros y caballeros, con una coalición de pueblos, y un enorme ejército."
,"8":"Pasará a espada a las ciudades que están en tierra firme, cavará en su derredor trincheras, construirá terraplenes y levantará un muro de defensa, echará abajo tus fortificaciones a"
,"9":"fuerza de arietes y demolerá tus torres con sus máquinas de asalto."
,"10":"Entrará por las puertas en la ciudad tomada por asalto, las patas de sus caballos te cubrirán de polvo, el estruendo de los animales de tiro, de las carretas y de los carros hará temblar tus fortificaciones,"
,"11":"los cascos de sus caballos resonarán en sus baldosas. Matarán a tu pueblo a filo de espada y tus columnas de piedra serán echadas al suelo."
,"12":"Se apoderarán de tus riquezas, saquearán los frutos de tu trabajo, tus fortificaciones serán derribadas y tus hermosas mansiones, demolidas: arrojarán al mar las piedras junto con la madera y los escombros."
,"13":"Silenciaré el sonido de tus canciones, nadie más escuchará el son de tus arpas."
,"14":"Te convertiré en una roca desnuda, en un secadero donde se tienden las redes, y no serás reconstruida: yo lo he dicho, palabra de Yavé."
,"15":"Esto dice Yavé con respecto a Tiro: Tu caída provocará mucho ruido. Se escucharán los gritos de los heridos mientras la masacre haga estragos en medio de ti: las islas quedarán espantadas."
,"16":"Entonces descenderán de sus tronos todos los príncipes, se quitarán su manto y dejarán su traje de fiesta. Se pondrán ropa de luto y se sentarán en el suelo. Se sentirán impactados por el estupor al pensar en ti y se quedarán temblando."
,"17":"Entonces cantarán por ti este canto fúnebre: ¿Dónde está la ciudad famosa a la que sus habitantes daban tanto prestigio?"
,"18":"Porque has caído, las islas tiemblan."
,"19":"Sí, Yavé lo dijo: Te convertiré en una ciudad desierta, como las ciudades abandonadas. El océano te arrasará, sus olas pasarán por encima de ti."
,"20":"Haré que desciendas junto con los que van a la tumba, y te reunirás con el pueblo de los muertos, con todos los que han ido a parar a la fosa; no revivirás, no serás reedificada en la tierra de los vivos."
,"21":"¡Te convertiré en un ejemplo y no existirás nunca más, palabra de Yavé.'"
}`)
	CurrentBook.AddChapter(27, `{
"1":"Me llegó una palabra de Yavé:"
,"2":"'Hijo de hombre, pronuncia una lamentación referente a Tiro:"
,"3":"Le dirás a Tiro, la ciudad instalada a la salida de los mares, el gran mercado de los pueblos y de las innumerables islas, palabra de Yavé..!,¿No decías tú, Tiro: Soy perfectamente bella? "
,"4":"Tus fronteras estaban en alta mar y tus fundadores quisieron que fueras muy hermosa."
,"5":"De los cipreses de Senir sacaron las planchas de tu casco, de un cedro del Líbano, tu mástil, y de las"
,"6":"encinas de Basán, tus remos; tu puente era de cedro de las islas de Quitim, con incrustaciones de marfil."
,"7":"Tus velas eran de lino de Egipto, y de lo mismo tu pabellón. Tus tinturas de púrpura y de escarlata venían de las islas de Elisha."
,"8":"Los habitantes de Sidón y de Arvad eran tus remeros, pero los pilotos eran tus peritos;"
,"9":"los ancianos de Guebal reparaban tus averías."
,"10":"Gente de Persia, de Lud y de Put, llevando casco y escudo, formaban tus tropas y eran tu orgullo."
,"11":"Los hijos de Arvad a tu servicio custodiaban tus fortificaciones; los guemadianos hacían guardia en tus torres, sus escudos colgando de tus muros te daban color."
,"12":"Tarsis te surtía de todo: a cambio de plata, hierro, estaño y plomo recibía tus mercaderías."
,"13":"Yaván, Tubal y Mesac adquirían tus mercaderías a cambio de esclavos y objetos de bronce."
,"14":"De Bet-Togorma venían los caballos para los carros y la caballería, y también las mulas."
,"15":"Los hijos de Dan comerciaban contigo; las islas populosas estaban bajo tu control y te pagaban con colmillos de marfil y madera de ébano."
,"16":"Edom pagaba tus numerosos productos con joyas, púrpura, telas finas, piedras preciosas, coral y rubíes."
,"17":"Judá y la tierra de Israel te proporcionaban trigo de Minita, cera, aceite, perfume a cambio de tus mercaderías."
,"18":"Damasco se aprovisionaba en ti, porque tenías de todo; te proveía de vino de Helbón y lana de Sadad."
,"19":"La gente de Uzal llevaba a tus mercados hierro forjado, canela y caña."
,"20":"Dedán te vendía cobertores para los camellos."
,"21":"Hasta Arabia y los príncipes de Cedar se proveían en ti; te pagaban con corderos, carneros y chivos."
,"22":"Los mercaderes de Cheba y de Rama te traían bálsamos finos, piedras preciosas y oro."
,"23":"Harán, Cane y Edén, los mercaderes de Cheba y los asirios, como también los de Media,"
,"24":"venían a comerciar contigo: ricas vestimentas, mantos de púrpura, telas bordadas y tapices de colores, cuerdas bien trenzadas."
,"25":"Los barcos de Tarsis aseguraban tu comercio.',Partiste para ultramar, repleta, cargada hasta el tope; "
,"26":"tus remeros te llevaron a alta mar, y luego, en medio del mar, el viento del este te hizo volcar."
,"27":"Y se hunden, en lo profundo del mar, tus riquezas, tus mercaderías y todo lo que transportas: marinos y marineros, carpinteros de a bordo, comerciantes, hombres de guerra y pasajeros: ¡es un naufragio!"
,"28":"Los gritos de tus marineros han llegado hasta la costa."
,"29":"Todos los remeros se bajan de sus embarcaciones y los marinos se quedan en tierra."
,"30":"No conversan más que de ti y lanzan gritos, se echan tierra en sus cabezas y se revuelcan en la ceniza."
,"31":"Por ti se rapan la cabeza y se visten de sacos; muy afligidos, dejarán oír sus lamentos, una amarga lamentación."
,"32":"Para ti han compuesto un canto fúnebre, y se lamentan: '¿Quién era igual a Tiro en medio de los mares?'"
,"33":"Desembarcabas tus mercaderías y todos los pueblos se surtían. Tú y tus mercaderías hacían ricos a los reyes de la tierra."
,"34":"Pero el mar te dio vuelta, te fuiste al fondo del mar; tu carga y todo tu mundo desaparecieron contigo."
,"35":"Los habitantes de todas las islas están muy consternados, los reyes tiritan, su rostro se descompone."
,"36":"Por doquier en el mundo entero, los mercaderes silban cuando hablan de ti, te has convertido en un ejemplo, no te verán más.'"
}`)
	CurrentBook.AddChapter(28, `{
"1":"Me llegó una palabra de Yavé:"
,"2":"'Hijo de hombre, háblale al príncipe de Tiro; le dirás esta palabra de Yavé: ¡Eres muy engreído, te consideras un dios en su residencia divina, en medio de los mares! ¿Te vas a hacer pasar por Dios, tú que eres hombre y no Dios?"
,"3":"Tú eres seguramente más sabio que Daniel, y ningún misterio te quedó grande."
,"4":"Tienes inteligencia, has sabido actuar y te ha llegado la riqueza: el oro y la plata han repletado tus cofres."
,"5":"Gracias a tu inteligencia, gracias a tus negocios, ha aumentado tu riqueza y te ha crecido el orgullo en la misma medida que tu riqueza."
,"6":"Por eso, esto dice Yavé al que se hace pasar por Dios:"
,"7":"Enviaré contra ti a extranjeros, los sepultureros de los pueblos; su espada se medirá con tu bella cultura, pisotearán tu gloria."
,"8":"Te harán bajar a la tumba y morirás allí, en el corazón de los mares."
,"9":"¿Acaso dirás: 'Yo soy Dios' cuando vengan a matarte? En manos del matador serás hombre y no Dios."
,"10":"Sufrirás la muerte de los paganos, y por manos de extranjeros, yo lo digo, palabra de Yavé.'"
,"11":"Se me comunicó otra palabra de Yavé:"
,"12":"'Hijo de hombre, entona esta lamentación por el rey de Tiro. Le dirás esta palabra de Yavé: Tú eras la obra maestra, lleno de sabiduría, y de una belleza perfecta."
,"13":"Vivías en el Edén, en el jardín de Dios, sobre ti sólo había piedras preciosas: cornalina, topacio y diamante, crisólito, ónix y jaspe, zafiro, malaquita, esmeralda, con aros, pendientes labrados en oro, desde el día en que fuiste creado."
,"14":"Te puse de guardia, como un Querub, en la montaña santa de Dios: permanecías allí,yendo y viniendo entre las piedras de fuego."
,"15":"Desde el día en que fuiste creado, tu conducta había sido perfecta, hasta el día en que el mal se anidó en ti."
,"16":"(De tanto comerciar,te llenaste de violencia y pecaste); entonces te barrí de la montaña de Dios: liquidé al Querub, que vigilaba entre piedras de fuego."
,"17":"Estabas muy orgulloso de tu belleza: tu belleza te hizo perder la sabiduría; por eso te tiré al suelo, para que fueras un espectáculo para los reyes de la tierra."
,"18":"De tantas riquezas y ganancias deshonestas, profanaste el lugar sagrado; hice brotar fuego de ti que te devoró; no dejé de ti más que cenizas por el suelo, en presencia de los que te miraban."
,"19":"A todos los que te conocían en el extranjero,se les cortó la respiración; tú no inspiras más que terror: ya no te verán más.'"
,"20":"Me llegó esta palabra de Yavé:"
,"21":"'Hijo de hombre, dirígete ahora a Sidón y profetiza en contra de ella."
,"22":"Le dirás esta palabra de Yavé: Me lanzaré contra ti, Sidón, y me cubriré de gloria a costa tuya. Sabrán que yo soy Yavé cuando ejecute mis decisiones: entonces conocerán mi santidad."
,"23":"La espada atacará de todas partes, los muertos se amontonarán en la ciudad: entonces sabrán que yo soy Yavé."
,"24":"La casa de Israel no tendrá más, entre sus vecinos que la desprecian, ni espinas que la hieran ni zarzas que la desgarren: entonces sabrán que yo soy Yavé."
,"25":"Esto dice Yavé: Reuniré a Israel de en medio de los pueblos donde lo dispersé: de ese modo haré que las naciones vean mi santidad: Israel vivirá en la tierra que di a mi servidor Jacob."
,"26":"Vivirán con seguridad, construirán casas y plantarán viñas. Vivirán seguros porque castigaré a todos sus vecinos que los desprecian. Entonces sabrán que yo soy Yavé, su Dios.'"
}`)
	CurrentBook.AddChapter(29, `{
"1":"El décimo mes, el doce de ese mes, se me comunicó esta palabra de Yavé:"
,"2":"'Hijo de hombre, habla para el Faraón, el rey de Egipto y profetiza en contra de él y de todo Egipto."
,"3":"Le dirás de parte de Yavé: Me dirijo contra ti, Faraón, gran Dragón. Te pavoneas en medio de tus canales diciendo: '¡Mis canales me pertenecen porque yo los mandé cavar!' "
,"4":"Pero te colocaré un garfio en tu mandíbula y te sacaré de tus canales a ti y a los peces de tus canales."
,"5":"Te arrojaré al suelo seco junto con los peces de tus canales, quedarás tirado en el suelo sin que nadie te levante o recoja. Te entregaré como carroña a las fieras de la tierra y a los pájaros del cielo."
,"6":"Entonces los habitantes de Egipto sabrán que yo soy Yavé, pues no fueron más que caña cuando Israel buscó un apoyo."
,"7":"cuando mi pueblo se te acercó, te quebraste en sus manos y lo heriste hasta en la espalda; cuando se apoyaron en ti, te doblaste e hiciste que perdieran el equilibrio."
,"8":"Por eso, esto dice Yavé: Enviaré contra ti la espada y acabaré dentro de ti con hombres y animales."
,"9":"El país de Egipto se convertirá en un desierto, en una ruina, y sabrán que yo soy Yavé. Tú dices: 'El Nilo es mío, porque yo lo hice'. "
,"10":"Debido a esto me lanzo contra ti y tus canales; haré de Egipto un desierto, una desolación, desde Migdol hasta Siene y la frontera con Etiopía."
,"11":"Hombres y animales no pasarán más por allí, quedará despoblada durante cuarenta años."
,"12":"Sí, haré que Egipto sea el más devastado de los países: sus ciudades, durante cuarenta años, serán las más saqueadas. Dispersaré a los egipcios en medio de las naciones, los diseminaré por todos los países."
,"13":"Pero esto dice Yavé: Después de cuarenta años reuniré a los egipcios de entre los pueblos donde los había dispersado."
,"14":"Haré cambiar su suerte y los devolveré a Patros, su país de origen, allí formarán un reino,"
,"15":"el más modesto de todos: ya no dominará más a las naciones; lo humillaré para que no se imponga más a las naciones."
,"16":"La gente de Israel no confiará más en él, sino que se acordarán del pecado que cometieron volviéndose a Egipto; entonces sabrán que yo soy Yavé.'"
,"17":"El año veinte, el primero del primer mes, me llegó esta palabra de Yavé:"
,"18":"'Hijo de hombre, el sitio de Tiro ha sido una difícil empresa para Nabucodonosor, rey de Babilonia, y para su ejército; sus hombres han perdido allí sus cabellos y sus espaldas se han desollado; pero ese sitio de Tiro no ha aportado ningún beneficio ni para él ni para su ejército."
,"19":"Por eso, esto dice Yavé: Entregaré Egipto en manos de Nabucodonosor, rey de Babilonia: cautivará a su pueblo, lo saqueará y repartirá los despojos, con eso sus tropas quedarán recompensadas"
,"20":"por el servicio que me prestaron contra Tiro. Le he dado el país de Egipto porque ha trabajado para mí, dice Yavé."
,"21":"En ese día yo levantaré la nación de Israel. Yo te concederé hablar libremente en medio de ellos y conocerán que yo soy Yavé.'"
}`)
	CurrentBook.AddChapter(30, `{
"1":"Yavé me dirigió de nuevo su palabra, diciéndome:"
,"2":"'Hijo de hombre, habla de parte mía, y di: Esto dice el Señor Yavé: ¡Ay de ese día!"
,"3":"Se acerca ese día, la hora de Yavé, el juicio de las naciones."
,"4":"Ha llegado la espada a Egipto, Kuch está temblando; caen las víctimas en Egipto y se conmueven sus cimientos."
,"5":"Kuch, Put y Lud, Arabia, Kub y los de la coalición caerán todos a espada."
,"6":"Los aliados de Egipto sucumbirán, y desde Migdol a Siene se hundirá su orgulloso poder: morirán a espada, palabra de Yavé."
,"7":"Será el más calamitoso de los países, sus ciudades serán las más saqueadas."
,"8":"Sabrán que yo soy Yavé cuando prenda fuego a Egipto y sean derrotados todos sus aliados."
,"9":"Irán mensajeros hasta Kuch, allá se pondrán todos a temblar al saber de su caída: ese día ya viene."
,"10":"Esto dice Yavé: Aniquilaré al ejército de Egipto por medio de Nabucodonosor, rey de Babilonia."
,"11":"Traeré a él y a su mundo, al sepulturero de los pueblos, para que arrase el país. Asolarán a Egipto a espada y el país quedará cubierto de víctimas."
,"12":"Dejaré secos sus canales y entregaré a los extranjeros el país y todo lo que contiene, palabra de Yavé."
,"13":"Esto dice todavía Yavé: Ya no habrá señores en Nof ni príncipes en Egipto ("
,"14":"). Devastaré a Patros, quemaré Soan y castigaré a No."
,"15":"Desataré mi cólera en contra de Sin, la fortaleza de Egipto, y haré que desaparezca la muchedumbre de No."
,"16":"Le prenderé fuego a Egipto, Sin será presa de convulsiones, en No se abrirá una brecha y las aguas se escurrirán."
,"17":"Los jóvenes de On y de Pi-Beset morirán a espada: la ciudad se irá al cautiverio."
,"18":"En Tahpanés el día se convertirá en tinieblas cuando rompa el cetro de Egipto y ponga fin a su poder insolente; no saldrá de la neblina y sus ciudades sabrán lo que es la deportación."
,"19":"Haré que Egipto rinda cuenta y sabrán que yo soy Yavé.'"
,"20":"El año once, el siete del primer mes, me llegó esta palabra de Yavé:"
,"21":"'Hijo de hombre, rompí el brazo de Faraón, rey de Egipto, y nadie vino a cuidarlo o a aplicarle un remedio para que tuviera fuerza para empuñar la espada."
,"22":"Por eso, esto dice Yavé: Me dirigiré en contra de Faraón, rey de Egipto, le romperé el brazo y haré que se le caiga la espada de la mano."
,"23":"Dispersaré a los egipcios en medio de las naciones, los desparramaré entre los países."
,"24":"Fortaleceré los brazos del rey de Babilonia y pondré en su mano la espada; asolará a Egipto y se marchará con el botín."
,"25":"Fortaleceré los brazos del rey de Babilonia, mientras que Faraón tendrá que bajar los suyos. Sabrán que yo soy Yavé cuando ponga mi espada en la mano del rey de Babilonia y la alce contra Egipto."
,"26":"Dispersaré a los egipcios entre las naciones, los desparramaré entre los pueblos y sabrán que yo soy Yavé.'"
}`)
	CurrentBook.AddChapter(31, `{
"1":"El año once, el primer día del tercer mes, me llegó esta palabra de Yavé:"
,"2":"'Hijo de hombre, esto dirás a Faraón y a toda su corte: ¿Cómo expresar tu grandeza?"
,"3":"Tú eras un cedro del Líbano de magníficas ramas y de abundante follaje, de altura tan grande que alcanzabas las nubes."
,"4":"Las aguas lo habían hecho crecer, las aguas subterráneas le habían dado su prestancia, y de donde él estaba regaba a todos los árboles del campo por medio de canales."
,"5":"Era el más alto de los árboles del campo, sus ramas se habían multiplicado, su ramaje cubría todo su derredor gracias a la abundancia de las aguas."
,"6":"En sus ramas anidaban todos los pájaros del cielo, y numerosos pueblos se cobijaban bajo su sombra. ("
,"7":"Su altura, sus largas ramas constituían su belleza, sus raíces estaban orientadas hacia abundantes aguas.)"
,"8":"Ningún cedro le igualaba en el jardín de Dios: ni los cipreses tenían tales ramas, ni los plátanos, tal follaje."
,"9":"Su follaje era tan espeso que todo el jardín de Dios estaba envidioso de él."
,"10":"Pero esto es lo que dice Yavé: Subió demasiado alto, su copa se elevó hasta las nubes y su corazón se hinchó de orgullo."
,"11":"Por eso, lo entregué en manos del príncipe de las naciones para que lo trate como merece su falta."
,"12":"Extranjeros, los sepultureros de los pueblos, lo cortaron: lo echaron abajo en la montaña y sus ramas cayeron en todos los valles. Se quebraron en el fondo de los barrancos; todos los pueblos de la tierra se retiraron de su sombra y lo abandonaron."
,"13":"Los pájaros del cielo se posan sobre sus restos y las fieras salvajes se instalan en medio de sus ramas."
,"14":"Que no se vea más en adelante a un árbol bien regado que se enorgullezca de su grandeza, o que quiera alcanzar con sus ramas hasta las nubes. Ningún árbol cuyas raíces alcanzan las aguas profundas pondrá su confianza en sí mismo, porque todos están condenados a muerte, todos irán a parar a la morada de los muertos igual que los humanos que descienden a la tumba."
,"15":"Esto dice Yavé: Dispuse un gran duelo para el día en que el cedro bajó a la morada de los muertos; cerré el abismo encima de él, detuve los ríos y sus aguas se secaron. Por él vestí de negro al Líbano, y se secaron todos los árboles del campo."
,"16":"Las naciones se conmovieron de espanto ante el estruendo de su caída, cuando lo hice descender a la morada de los muertos con los que bajan a la tumba. Pero en el país subterráneo, se consolaron todos los árboles del Edén, los más bellos del Líbano y los mejor regados."
,"17":"Los que vivían bajo su sombra en todas las naciones bajaron con él a la morada de los muertos, y se juntaron con las víctimas de la espada."
,"18":"¿Con quién podría compararte? Te precipité en lo más profundo de la tierra, igual que a los árboles del Edén: allí estás acostado junto con los incircuncisos, con las víctimas de la espada. Allí están Faraón y su pueblo, dice Yavé.'"
}`)
	CurrentBook.AddChapter(32, `{
"1":"El año doce, el primero del duodécimo mes, me llegó esta palabra de Yavé:"
,"2":"'Hijo de hombre, entona un canto fúnebre sobre Faraón, rey de Egipto. Dirás esto: ¡Cómo! ¿Desapareció el león de las naciones? Tú eras como el dragón de los mares; hacías hervir las aguas, las removías con tus patas y producías las olas. "
,"3":"Esto dice Yavé: Te echaré mi red y te arrastraré a la orilla con mis cuerdas."
,"4":"Te dejaré botado en el suelo, te esparciré por los campos, haré que sobre ti bajen los pájaros del cielo, las fieras de la tierra te devorarán."
,"5":"Expondré tus carnes en las montañas, llenaré los valles con tus restos"
,"6":"y con tu sangre regaré el país"
,"7":"el día de tu muerte. Cubriré los cielos y oscureceré las estrellas, cubriré el sol con nubes y la luna no alumbrará más. "
,"8":"Por culpa tuya apagaré todas las estrellas del cielo y extenderé sobre tu país las tinieblas, palabra de Yavé."
,"9":"Muchos pueblos se estremecerán cuando anuncie tu ruina a las naciones, a países que no conocías."
,"10":"Numerosos pueblos quedarán espantados al ver tu suerte, sus reyes se pondrán a tiritar cuando haga pasar mi espada delante de ellos, cada uno temerá por su vida en el día de tu ruina."
,"11":"Esto dice Yavé: La espada del rey de Babilonia llega a tu tierra."
,"12":"Haré que caigan multitudes por la espada de sus guerreros, los sepultureros de los pueblos; acabarán con el orgullo de Egipto y todo su pueblo será exterminado."
,"13":"Haré perecer todos sus rebaños a orillas de las grandes aguas; ya no las removerán ni el pie del hombre ni las pezuñas del ganado."
,"14":"Entonces se calmarán las aguas de Egipto, y sus ríos se deslizarán como el aceite, palabra de Yavé."
,"15":"Arrasaré a Egipto; mataré a sus habitantes y quedará completamente vacío: entonces sabrán que yo soy Yavé."
,"16":"Las hijas de las naciones entonarán este canto fúnebre; lo cantarán refiriéndose a Egipto y a su pueblo, cantarán este canto fúnebre, palabra de Yavé.'"
,"17":"El duodécimo año, el quince del primer mes, se me comunicó esta palabra de Yavé:"
,"18":"'Hijo de hombre, laméntate por la gloria de Egipto."
,"19":"Porque yo los voy a lanzar ahí donde están los que bajan al sepulcro"
,"20":"y serán reunidos con todos los demás que fueron pasados a cuchillo. Egipto ha sido entregada y la llevan con todos sus habitantes."
,"21":"En el reino de los muertos los héroes más valientes junto con los auxiliares de Faraón le dirán: ¿Por qué van a ser tratados mejor que los demás? Baja y quédate entre los incircuncisos, que perecieron al filo de la espada."
,"22":"Ahí están Asur y todo su ejército masacrado."
,"23":"Pusieron sus tumbas en el fondo de la morada de los muertos y todo ese ejército rodea la tumba de Asur. Los que sembraban el terror por la tierra de los vivos fueron todos masacrados a espada."
,"24":"Ahí están Elam y todo su pueblo agrupado alrededor de su tumba. También ellos sembraron el terror por la tierra de los vivos, pero fueron masacrados a espada; estos incircuncisos bajaron a la morada de los muertos, arrastrando su vergüenza hasta donde los que bajan a la tumba."
,"25":"Los pusieron entre medio de sus víctimas."
,"26":"Ahí están Masoc, Tubal y todo su pueblo en las tumbas que lo rodean; todos esos incircuncisos sembraron el terror en la tierra de los vivos y luego cayeron a espada."
,"27":"Están todos acostados con los héroes antiguos, porque estos hombres bajaron a la morada de los muertos con las armas en la mano. Pusieron sus espadas sobre sus cabezas y sus escudos sobre sus huesos, porque su valentía los hacía temibles en la tierra de los vivos."
,"28":"Tú también te acostarás entre medio de los incircuncisos, junto con las víctimas de la espada."
,"29":"Ahí están Edom, sus reyes y sus jefes; a pesar de su valor, cayeron a espada, igual que los demás. Están acostados con los circuncidados, junto con los que bajan a la tumba."
,"30":"Ahí están todos los príncipes del norte, y los hombres de Sidón: bajaron con todo su prestigio a pesar de su valentía. Estos incircuncisos están acostados entre las víctimas de la espada, arrastraron su vergüenza hasta donde los que bajan a la tumba."
,"31":"Al verlos Faraón se consolará por su ejército que cayó bajo la espada, palabra de Yavé."
,"32":"Al que difundía el terror por la tierra de los vivos, lo acostarán entre los incircuncisos, entre las víctimas de la espada, y junto con él a todo su ejército, palabra de Yavé.'"
}`)
	CurrentBook.AddChapter(33, `{
"1":"Se me dirigió esta palabra de Yavé:"
,"2":"'Hijo de hombre, dirás esto a los hijos de mi pueblo, les dirás: cuando hago que caiga la espada sobre un país, la gente de ese país eligen a alguien de entre ellos y lo ponen para que vigile."
,"3":"Si ve que la espada amenaza al lugar, toca el cuerno y le avisa al pueblo."
,"4":"Si alguien oye el sonido del cuerno y no toma en cuenta el aviso, y llega la espada y lo corta, él es responsable de su muerte."
,"5":"Si oyó el sonido del cuerno y no tomó en cuenta el aviso, él es responsable y el centinela que dio el aviso no tiene nada que temer."
,"6":"Pero si el vigía ve que amenaza la espada y no toca el cuerno, si el pueblo no es avisado y llega a matar la espada a alguien del pueblo, ése será segado debido a su pecado, pero le pediré al centinela cuenta de su sangre."
,"7":"A ti, hijo de hombre, te he puesto como centinela para la casa de Israel, apenas oigas que una palabra sale de mi boca, tendrás que advertírselo de mi parte."
,"8":"Cuando diga al malo: '¡Malo, vas a morir!', si no le hablas, si no haces que se preocupe por su mala conducta, el malo morirá debido a su pecado, pero a ti te pediré cuenta de su sangre."
,"9":"Al contrario, si le has llamado la atención al malo por su mala conducta y no se aparta de ella, si no deja su mala conducta, morirá debido a su pecado y tú nada tendrás que temer."
,"10":"Hijo de hombre, le dirás a la casa de Israel: Se oye decir: 'Estamos bajo el peso de nuestros pecados y nos desesperamos sin esperanza de salir de ellos.'"
,"11":"Les responderás: 'Tan cierto como que soy vivo, palabra de Yavé, que no deseo la muerte del malvado sino que renuncie a su mala conducta y viva. Dejen, dejen el camino que han tomado: ¿para qué morir, casa de Israel?'"
,"12":"Les dirás a los hijos de tu pueblo: La justicia del justo no lo salvará si después se pone a pecar, y la maldad del malo no lo hará caer después que se haya apartado de su maldad; por la misma razón que el justo, vivirá."
,"13":"Aunque yo le haya dicho al justo: ¡Vivirás!, si se queda en sus méritos y se dedica a cometer injusticias, quedará en el olvido su justicia y morirá debido a la injusticia que haya cometido."
,"14":"De igual modo, aunque yo haya dicho al malo: ¡Morirás! , si se aparta de su pecado y se dedica a hacer lo que es correcto y justo,"
,"15":"si devuelve lo que se le ha prestado o que haya robado, si camina según mis mandamientos y no comete más injusticias, en verdad vivirá y no morirá."
,"16":"No se tendrán en cuenta todos los pecados que haya cometido; ya que actuó de acuerdo al derecho y a la justicia, vivirá."
,"17":"Los hijos de tu pueblo dicen: 'La manera de ver que tiene Yavé no es la correcta', pero, más bien la de ellos es la incorrecta."
,"18":"Desde el momento en que el justo se aparta de la injusticia y comete algo injusto, eso mismo lo hace morir."
,"19":"Y cuando el malo se aparta de su maldad y se dedica a hacer lo que es correcto y justo, eso mismo le da vida."
,"20":"Aunque ustedes digan: 'La manera de Yavé no es la correcta', juzgaré a cada uno de ustedes según su conducta, casa de Israel."
,"21":"El año duodécimo de nuestro destierro, el cinco del décimo mes, llegó a mi casa un fugitivo de Jerusalén, me dijo: 'La ciudad cayó.'"
,"22":"Ahora bien, la mano de Yavé había estado sobre mí desde la tarde antes que llegara el fugitivo, y a la mañana siguiente, cuando llegó a mi casa el hombre, Yavé me abrió la boca: ¡ya no estaba mudo!"
,"23":"Entonces se me comunicó esta palabra de Yavé:"
,"24":"'Hijo de hombre, los que se quedaron entre las ruinas en tierra de Israel dicen esto: Abrahán era él solo y recibió el país en propiedad. Nosotros somos todavía muchos y el país nos pertenece.'"
,"25":"Les dirás esta palabra de Yavé: 'Ustedes comen carne sin desangrar, vuelven sus miradas a sus sucios ídolos, derraman sangre, y ¿quieren así poseer ese país?"
,"26":"Moran en medio de ruinas y siguen viviendo de manera escandalosa, ensuciando cada cual a la mujer de su prójimo, y ¿quieren así poseer ese país?'"
,"27":"Añadirás: Esto dice Yavé: 'Tan cierto como que vivo que los que viven entre ruinas caerán a espada, los que viven en el campo serán devorados por las fieras salvajes y los que viven en guaridas y en cavernas morirán de peste."
,"28":"Convertiré a ese país en una ruina, echaré por tierra su fuerza y su orgullo, y las montañas quedarán abandonadas, sin habitantes."
,"29":"El día en que transforme al país en una ruina y en un desierto, debido a todos los crímenes que cometieron, sabrán que yo soy Yavé.'"
,"30":"Sabes muy bien, hijo de hombre, que los hijos de tu pueblo hablan de ti a lo largo de los muros y en las puertas de las casas, se dicen unos a otros: 'Vamos a escuchar lo que viene de Yavé.'"
,"31":"Entonces vienen a verte como si fueran a cualquier parte, se sientan a tu lado para oír tus palabras, pero no las ponen en práctica. La mentira está en su boca y sólo buscan su interés."
,"32":"Tú eres para ellos como una canción que les gusta: ¡la voz es hermosa y canta bien! Escuchan tus palabras pero no hacen nada."
,"33":"Pero cuando eso ocurra -y eso va a ocurrir- sabrán que tenían un profeta en medio de ellos.'"
}`)
	CurrentBook.AddChapter(34, `{
"1":"Se me comunicó esta palabra de Yavé:"
,"2":"'Hijo de hombre, habla de parte mía contra los pastores de Israel, ¡profetiza! Les dirás a los pastores, Esta es una palabra de Yavé: ¡Ay de ustedes, pastores de Israel: pastores que sólo se preocupan de ustedes mismos! ¿Acaso el pastor no tiene que preocuparse del rebaño?"
,"3":"Se alimentan de leche, se visten con lana, sacrifican los animales gordos, pero no se preocupan de sus ovejas."
,"4":"No han reanimado a la oveja agotada, no se han preocupado de la que estaba enferma, ni curado a la que estaba herida, ni han traído de vuelta a la que estaba extraviada ni buscado a la que estaba perdida. Y a las que eran fuertes, las han conducido en base al terror."
,"5":"Sin pastores, mis ovejas se han dispersado: siendo así presa fácil de las fieras salvajes."
,"6":"Mi rebaño se dispersó por las montañas y colinas; el resto está disperso por todo el país, y nadie se preocupa o sale en su búsqueda."
,"7":"Por eso, pastores, escuchen la palabra de Yavé:"
,"8":"Tan cierto como que yo vivo, dice Yavé, que si mis ovejas quedaron expuestas a los ladrones, si se convirtieron en presa de las fieras salvajes, la culpa es de los pastores. Mis pastores no se preocuparon de mis ovejas, se preocuparon de sí mismos pero no del rebaño."
,"9":"Por eso, pastores,"
,"10":"Yavé habló: Me dirijo directamente a los pastores para quitarles mi rebaño. Ya no serán más los pastores de mi rebaño, pastores que sólo se preocupan de sí mismos. Arrancaré mis ovejas de su boca y ya no serán más su presa."
,"11":"Porque esto dice Yavé: ¡Aquí estoy, soy yo! Vengo en busca de las ovejas, yo me ocuparé de ellas"
,"12":"como el pastor que se ocupa de su rebaño el día en que se encuentre en medio de sus ovejas en libertad. Yo también me ocuparé de mis ovejas y las sacaré de todos los lugares por donde se dispersaron ese día de negras nubes y tinieblas."
,"13":"Haré que salgan de los otros pueblos, las reuniré de diferentes países y las conduciré a su propia tierra. Haré que ramoneen por las montañas de Israel, en los valles y en todas las praderas del país."
,"14":"Sí, haré que ramoneen en un buen potrero, en las altas montañas de Israel, descansarán en un buen corral y se alimentarán en fértiles praderas de las montañas de Israel;"
,"15":"yo mismo me preocuparé de mis ovejas, yo las llevaré a descansar, palabra de Yavé."
,"16":"Buscaré a la que esté perdida, volveré a traer a la que esté extraviada, curaré a la que esté herida, reanimaré a la que esté enferma, velaré por la que esté sana; las cuidaré con justicia."
,"17":"Y a ustedes, mis ovejas, esto dice Yavé: Juzgaré entre ovejas y ovejas, entre chivos y carneros."
,"18":"¿Así que no les basta con pastar en un buen potrero? ¿Por qué han pisoteado el resto del pasto? Si toman un agua clara, ¿por qué han enturbiado el resto con sus pies?"
,"19":"¿Acaso mis ovejas tienen que ramonear lo que ustedes pisotearon y tomar lo que enturbiaron los pies de ustedes?"
,"20":"Por eso, esto dice Yavé: Juzgaré tanto a las ovejas gordas como a las flacas."
,"21":"Ustedes les han pegado a costillas y lomos, han corneado a todas las más débiles, hasta echarlas afuera."
,"22":"Por eso, salvaré a mis ovejas, las pondré a resguardo de los ladrones y juzgaré entre unas ovejas y otras."
,"23":"Pondré a la cabeza de ellas a un pastor único para que se preocupe de ellas, a mi servidor David. El será su pastor."
,"24":"Yo, Yavé, seré su Dios, y mi servidor David, su príncipe."
,"25":"Firmaré con ellas una alianza de paz, haré que desaparezcan del país las fieras salvajes; mis ovejas podrán quedarse en el desierto y dormir en los bosques."
,"26":"Las instalaré alrededor de mi colina y haré que caiga la lluvia a su tiempo, será una lluvia de bendición."
,"27":"El árbol de los campos dará su fruto y la tierra, su cosecha; mi pueblo vivirá seguro en su tierra, porque habré roto su yugo y los habré librado de manos de los opresores. Entonces sabrán que yo soy Yavé."
,"28":"Ya no serán más presa de las naciones, ni los devorarán más las fieras salvajes, sino que vivirán en paz y nadie vendrá a molestarlos."
,"29":"Haré que la tierra produzca en abundancia. Ya no experimentarán más hambre, ni pasarán más esa humillación ante los demás pueblos."
,"30":"Porque yo soy Yavé, su Dios, y ellos son Israel, mi pueblo, palabra de Yavé."
,"31":"Ustedes son mi rebaño, las ovejas de mi potrero y yo soy su Dios, palabra de Yavé.'"
}`)
	CurrentBook.AddChapter(35, `{
"1":"Se me comunicó esta palabra de Yavé:"
,"2":"'Vuelve tu mirada hacia la montaña de Seír y profetiza contra ella. Así le dirás"
,"3":"de parte de Yavé: Aquí estoy para extender mi mano sobre ti, montaña de Seír, te convertiré en ruinas y en desierto."
,"4":"Tus ciudades serán arrasadas, te transformarás en un desierto y sabrás que yo soy Yavé."
,"5":"Con tu odio de siempre, condenaste a los israelitas a la espada en el tiempo de la prueba, cuando puse término a sus pecados."
,"6":"Por eso, tan cierto como que vivo, dice Yavé, puesto que has hecho derramar sangre, la sangre te perseguirá."
,"7":"Convertiré a la montaña de Seír en ruinas y en desierto, y eliminaré de ella toda presencia humana."
,"8":"Tus montañas se cubrirán de cadáveres; habrá víctimas de la espada en tus colinas, en los valles y en todos los barrancos."
,"9":"Te arruinaré para siempre y tus ciudades nunca más serán habitadas; entonces sabrás que yo soy Yavé."
,"10":"¿Cómo pudiste decir: 'Las dos naciones son mías, su tierra ahora me pertenece'? ¡Siendo que allí está Yavé!"
,"11":"Tan cierto como que yo vivo, dice Yavé, que mi cólera y mi celo serán tan grandes como el odio que tuviste hacia ellos; me daré a conocer a ti el día en que te juzgue."
,"12":"Sabrás que yo, Yavé, escuchaba todos tus insultos. Pues decías: '¡Están totalmente arruinadas, todo será para nosotros!'"
,"13":"Tuviste conmigo palabras muy despreciativas y yo lo entendí."
,"14":"Así habla Yavé: a ti te convertiré en una ruina, mientras el resto del mundo disfrutará de alegría."
,"15":"Serán arrasados no sólo la montaña de Seír sino todo Edom. Y sabrán que yo soy Yavé.'"
}`)
	CurrentBook.AddChapter(36, `{
"1":"Hijo de hombre, profetiza para las montañas de Israel. Diles: Montañas de Israel, escuchen una palabra de Yavé."
,"2":"Esto dice Yavé: ¡ El enemigo se burló de ustedes: '¡Oh sí, las montañas eternas pasaron a ser de nuestra propiedad!'"
,"3":"Por eso, profetizarás. Diles de mi parte: Ustedes fueron devastados, pisoteados de todas partes, pasaron a ser propiedad de otras naciones, a costa de ustedes contaron cualquier cosa, los insultaron."
,"4":"Pues bien, montañas de Israel, escuchen la palabra de Yavé. Esto dice a las montañas y a las colinas, a los barrancos y a los valles, a las ruinas devastadas y a las ciudades abandonadas que se transformaron en presa y entretención para lo que quedaba de sus vecinos."
,"5":"En el ardor de mi indignación me volveré en contra de Edom y de las demás naciones que invadieron mi tierra con gusto y mucho desprecio, para apropiársela o para saquearla."
,"6":"Por eso, profetiza respecto de la tierra de Israel. Esta palabra de Yavé transmitirás a las montañas y a las colinas, a los barrancos y a los valles: Esto fue lo que decidí en mi indignación y cólera. Ya que fueron humillados por las naciones,"
,"7":"yo a mi vez levanto mi mano para jurar que las naciones que los rodean serán humilladas."
,"8":"Pero ustedes, montañas de Israel, producirán cosechas y frutos para mi pueblo de Israel que está próximo a volver."
,"9":"Regresaré donde ustedes y me volveré hacia ustedes; ustedes serán trabajadas y sembradas."
,"10":"Multiplicaré en ustedes a los hombres, a toda la casa de Israel; las ciudades serán nuevamente habitadas y las ruinas reedificadas."
,"11":"Multiplicaré en ustedes a hombres y animales. Serán pobladas como antes y las trataré mejor que en los comienzos; entonces sabrán que yo soy Yavé."
,"12":"Por ustedes pasarán gente de mi pueblo de Israel, y éste será dueño y heredero de ustedes. Tierra de Israel, tú no permanecerás más sin hijos."
,"13":"Esto dice Yavé: Dicen de ti que eres una tierra que come a sus habitantes y que deja a la nación sin hijos."
,"14":"Pues bien, ya no te comerás más a tus habitantes ni dejarás más sin hijos a la nación, palabra de Yavé."
,"15":"No permitiré más que te insulten las naciones, palabra de Yavé."
,"16":"Se me comunicó esta palabra de Yavé:"
,"17":"'Hijo de hombre, cuando Israel vivía en su tierra, la volvió impura con su conducta y sus acciones; su conducta era a mis ojos como la impureza de la mujer."
,"18":"Entonces decidí desatar contra ellos mi cólera,"
,"19":"los dispersé por entre las naciones, los desparramé entre los países; los juzgué de acuerdo a su conducta y a sus acciones."
,"20":"Y así llegaron a las naciones. Pero allí también fue profanado mi nombre. En efecto se decía: 'Este es el pueblo de Yavé que tuvo que salir de su país.' "
,"21":"Entonces salí en defensa de mi Nombre, porque éste había sido profanado en las naciones donde se encontraba Israel y por culpa de éste.'"
,"22":"Por eso le dirás esta palabra de Yavé a la casa de Israel: 'no es por ustedes que hago esto, casa de Israel, sino por mi santo Nombre que por culpa de ustedes fue profanado en las naciones donde estaban."
,"23":"Santificaré mi nombre que fue profanado en las naciones -y ustedes fueron los que lo hicieron despreciable-. Las naciones sabrán que yo soy Yavé cuando, por medio de ustedes, aparezca ante sus ojos mi santidad."
,"24":"Los sacaré de las naciones, los reuniré de entre los pueblos y los traeré de vuelta a su tierra."
,"25":"Los rociaré con un agua pura y quedarán purificados; los purificaré de todas sus impurezas y de todos sus inmundos ídolos."
,"26":"Les daré un corazón nuevo y pondré dentro de ustedes un espíritu nuevo. Quitaré de su carne ese corazón de piedra y les daré un corazón de carne."
,"27":"Pondré dentro de ustedes mi Espíritu y haré que caminen según mis mandamientos, que observen mis leyes y que las pongan en práctica."
,"28":"Vivirán en el país que di a sus padres, ustedes serán mi pueblo y yo seré su Dios."
,"29":"Los libraré de todas sus impurezas. Llamaré al trigo y brotará en abundancia; no les enviaré más hambrunas."
,"30":"Multiplicaré los frutos de los árboles y los productos del campo; ya no serán más humillados por el hambre en presencia de las demás naciones."
,"31":"Entonces se acordarán de su conducta y de sus malas acciones, se avergonzarán de ustedes mismos debido a sus culpas y a sus crímenes."
,"32":"Sépanlo bien, dice Yavé, que no es por ustedes que hago esto. Tengan vergüenza y sonrójense por su conducta, casa de Israel."
,"33":"Esto dice Yavé: El día en que los purifique de sus pecados, haré que se repueblen las ciudades y sean reconstruidas las ruinas."
,"34":"La tierra arrasada será nuevamente cultivada después que todos los que hayan pasado la hayan visto abandonada."
,"35":"Incluso dirán: 'Esa tierra que estaba abandonada se ha vuelto el jardín del Edén, las ciudades en ruina, abandonadas, destruidas tienen ahora muros y están pobladas.'"
,"36":"Entonces las naciones que hayan subsistido alrededor de ustedes sabrán que yo, Yavé, reconstruí lo que estaba demolido, volví a plantar lo que había sido arrasado. Yo Yavé lo digo y lo haré."
,"37":"Esto dice Yavé: Le concederé además esto a las oraciones de la casa de Israel: multiplicaré entre ellos a los hombres tanto como a los animales."
,"38":"En las ciudades otrora en ruinas, los hombres serán tan numerosos como las ovejas, como el rebaño de animales consagrados, como las ovejas en Jerusalén con ocasión de las grandes asambleas; entonces sabrán que yo soy Yavé.'"
}`)
	CurrentBook.AddChapter(37, `{
"1":"La mano de Yavé se posó sobre mí. Yavé me hizo salir por medio de su espíritu. Me depositó en medio de un valle, que estaba lleno de huesos humanos."
,"2":"Me hizo recorrer el valle en todos los sentidos; los huesos esparcidos por el suelo eran muy numerosos, y estaban completamente secos."
,"3":"Entonces me dijo: '¿Hijo de hombre, podrán revivir estos huesos?' Respondí: 'Yavé, tú lo sabes.'"
,"4":"Me dijo: 'Profetiza con respecto a estos huesos, les dirás: ¡Huesos secos, escuchen la palabra de Yavé!"
,"5":"Esto dice Yavé a estos huesos: Haré que entre en ustedes un espíritu, y vivirán."
,"6":"Pondré en ustedes nervios, haré que brote en ustedes la carne, extenderé en ustedes la piel, colocaré en ustedes un espíritu y vivirán: y sabrán que yo soy Yavé.'"
,"7":"Hice según lo que se me había ordenado y, mientras profetizaba, se produjo una gran agitación: los huesos se acercaron unos a otros."
,"8":"Miré: vi cómo se cubrían de nervios, brotaba la carne y se extendía sobre ellos la piel. Pero no había en ellos espíritu."
,"9":"Entonces me dijo: '¡Profetiza, hijo de hombre, llama al Espíritu! Dirás al Espíritu: Esto dice Yavé: ¡Espíritu, ven desde los cuatro vientos, sopla sobre estos muertos para que vivan!'"
,"10":"Profeticé según la orden que había recibido y el espíritu entró en ellos; recuperaron la vida se levantaron sobre sus pies: era una multitud grande, inmensa."
,"11":"Yavé me dijo entonces: Hijo de hombre, estos huesos son toda la casa de Israel. Ahora dicen: 'Nuestros huesos se han secado, nuestras esperanzas han muerto, hemos sido rechazados.'"
,"12":"Por eso, profetiza. Les dirás esta palabra de Yavé: 'Voy a abrir las tumbas de ustedes, oh pueblo mío, haré que se levanten de sus tumbas y los traeré de vuelta a la tierra de Israel."
,"13":"Entonces, cuando haya abierto sus tumbas y los haya hecho levantarse, sabrán que yo soy Yavé."
,"14":"Pondré en ustedes mi Espíritu y vivirán; los estableceré en su tierra y sabrán que yo, Yavé, lo dije y lo hice, palabra de Yavé.'"
,"15":"Se me comunicó esta palabra de Yavé:"
,"16":"'Hijo de hombre, toma un trozo de madera y escribe en él: 'A Judá y a los hijos de Israel que se han reunido con él.' Tomarás después otro trozo de madera y escribirás encima: 'A José.' Esa será la madera (de Efraín y) de toda la casa de Israel que se ha reunido con él."
,"17":"Luego, juntarás los dos para que formen en tu mano una sola pieza."
,"18":"Cuando los hijos de tu pueblo te digan: '¿Nos vas a explicar lo que eso significa?' les"
,"19":"responderás: 'Esto dice Yavé: Me dispongo a tomar la madera de José junto con las tribus de Israel que se le han unido; los juntaré con la madera de Judá y formarán una sola cosa en mi mano.'"
,"20":"Tendrás en tu mano ante sus ojos los trozos de madera en los que hayas escrito"
,"21":"y les dirás de parte de Yavé: Sacaré a los hijos de Israel de las naciones adonde partieron, los reuniré de todas partes y los juntaré en su tierra."
,"22":"Haré de ellos una sola nación en mi país en las montañas de Israel; un único rey reinará sobre todos ellos, ya no serán más dos naciones, ni estarán más separados en dos reinos."
,"23":"No se ensuciarán más con sus inmundos ídolos, porque los libraré de sus pecados y de todas sus rebeldías y los purificaré; serán mi pueblo y yo seré su Dios."
,"24":"Sobre ellos reinará mi servidor David, y tendrán todos un solo pastor. Entonces caminarán según mis mandamientos, observarán mis leyes y las pondrán en práctica."
,"25":"Vivirán en esa tierra que di a mi servidor Jacob, esa tierra en que han vivido. Vivirán en ella para siempre, ellos y sus hijos y los hijos de sus hijos; y mi servidor David será su príncipe para siempre."
,"26":"Firmaré con ellos una alianza de paz, una alianza conmigo para siempre; pondré en medio de ellos mi santuario para siempre."
,"27":"Mi morada permanecerá por encima de ellos, yo seré su Dios y ellos serán mi pueblo."
,"28":"Cuando mi santuario esté en medio de ellos para siempre, las naciones sabrán que yo soy Yavé quien santifica a Israel.'"
}`)
	CurrentBook.AddChapter(38, `{
"1":"Se me comunicó esta palabra de Yavé:"
,"2":"'Hijo de hombre, vuelve tu mirada hacia Gog, del país de Magog, el gran jefe de Mecheq y de Tubal; profetizarás contra él."
,"3":"Dirás: esto dice Yavé: Vengo a buscarte, Gog, gran jefe de Mecheq y de Tubal. "
,"4":"Haré que te pongas en marcha con todo tu ejército, tus caballos y tus caballeros, todos vestidos magníficamente, tus numerosas tropas armadas con espadas, lanzas y escudos."
,"5":"Allí están los persas, los cuchitas y la gente de Put con sus armas y sus cascos,"
,"6":"como también Gomer con todas sus tropas y Bet-Togorma, que vino de los lejanos países nórdicos con todas sus tropas. ¡Cuántos pueblos contigo!"
,"7":"Prepárate y estáte listo, tú y todo el ejército que reuniste a tu alrededor, ponte a mi disposición."
,"8":"Después de siglos vas a recibir órdenes, después de muchos años te vas a poner en camino al país cuyos habitantes escaparon a la espada; fueron reunidos de numerosos pueblos en las montañas de Israel, las que estuvieron mucho tiempo abandonadas. Después que se separaron de los demás pueblos, viven todos en paz."
,"9":"Tú llegarás pues como el huracán, cubrirás el país como lo hacen las nubes, tú y tu ejército junto con los numerosos pueblos que te acompañan."
,"10":"Esto dice Yavé: Ese día, te vendrán ideas al espíritu y tendrás en la cabeza malas intenciones."
,"11":"Te dirás: Voy a subir contra un país sin defensa, atacaré a gente tranquila que vive en paz en ciudades sin fortificaciones, puertas ni cerrojos."
,"12":"Me apoderaré de sus despojos y reuniré un botín, extenderé mi mano sobre esas ruinas que se repoblaron, sobre ese pueblo que regresó de las naciones, que vive del pastoreo y del comercio y que vive en el ombligo de la tierra."
,"13":"Entonces Cheba, Dedán, los comerciantes de Tarsis y todos los demás te dirán: '¿Así que reuniste tu ejército para hacerte de un botín y recoger los despojos? ¿No quieres oro y plata a cambio de los numerosos rebaños y tesoros que has capturado?'"
,"14":"Por eso, hijo de hombre, profetiza y dile a Gog de mi parte: Cuando mi pueblo de Israel viva seguro, entonces será cuando caigas sobre él."
,"15":"Vendrás de tu país, de muy al norte, con pueblos numerosos, todos montados a caballo, conformando un ejército grande e inmenso."
,"16":"Te lanzarás sobre mi pueblo Israel como las nubes que vienen a cubrir al país; eso sucederá en el transcurrir del tiempo. Quiero que ataques a mi país, Gog, para que las naciones me conozcan, pues por tu intermedio manifestaré ante todos mi santidad."
,"17":"Esto dice Yavé: ¿No eres tú aquel de quien hablaba en los tiempos antiguos por boca de mis servidores, los profetas de Israel? Desde esos días y a lo largo de los años han profetizado que te haría venir en contra de ellos."
,"18":"Pues bien, ese día en que Gog invada la tierra de Israel, dice Yavé, la cólera se me subirá hasta la nariz."
,"19":"En mi celo y en el ardor de mi cólera, lo digo: Sí, ese día será un terremoto para Israel."
,"20":"Ante mí temblarán los peces del mar, las aves del cielo, los animales del campo, todos los reptiles que se arrastran por el suelo y todos los hombres que están en la tierra. Las montañas se hundirán, los acantilados se derrumbarán y todas las fortificaciones caerán."
,"21":"Entonces, dice Yavé, haré que cunda el pánico entre la gente de Gog: se atacarán con sus espadas unos a otros."
,"22":"Lo castigaré por la peste y la sangre, haré que caiga sobre él, su pueblo y los numerosos pueblos que lo acompañan, una lluvia torrencial, granizos, de fuego y azufre."
,"23":"Así demostraré mi grandeza y mi santidad, y me daré a conocer ante numerosas naciones: sabrán que yo soy Yavé.'"
}`)
	CurrentBook.AddChapter(39, `{
"1":"Hijo de hombre, profetiza pues contra Gog. Dirás: Esto dice Yavé: 'Me dirijo hacia ti, Gog, gran jefe de Mecheq y de Tubal."
,"2":"Te traeré, te conduciré, te haré venir de las extremidades del norte y haré que subas a las montañas de Israel."
,"3":"Romperé en tu mano izquierda tu arco y haré que caigan las flechas de tu mano derecha."
,"4":"Te dejarás caer sobre las montañas de Israel con todo tu ejército y todos los pueblos que vienen contigo. Ya te he destinado como comida de las aves de rapiña, de toda clase de pájaros y de las fieras salvajes."
,"5":"Rodarás por el suelo en plena campaña, yo lo digo, palabra de Yavé."
,"6":"Provocaré un incendio en Magog y entre los habitantes de las islas que viven seguros, y sabrán que yo soy Yavé."
,"7":"Daré a conocer mi Santo Nombre en medio de mi pueblo de Israel; no permitiré que se lo profane más, y sabrán las naciones que yo soy Yavé, el Santo de Israel."
,"8":"La cosa ya llega, dice Yavé, ya se va a hacer; ya llega el día del que hablé."
,"9":"Entonces los habitantes de las ciudades de Israel saldrán, encenderán dos fogatas y quemarán las armas, los escudos grandes y chicos, el arco y las flechas, el dardo y la lanza, los quemarán por siete años."
,"10":"No se los verá trayendo leña recogida en el campo, ni irán a buscarla a los bosques, porque harán fuego con las armas; despojarán a los que los despojaron y saquearán a los que los saquearon, palabra de Yavé."
,"11":"Ese día le daré como sepultura a Gog un lugar célebre en Israel: el valle de los Abarim, un valle que está al este del mar y cierra el paso a los viajeros. Allí serán enterrados Gog y todo su ejército y lo llamarán: valle de Hamón-Gog."
,"12":"Habrá entonces que purificar al país: el pueblo de Israel los enterrará durante siete meses."
,"13":"Toda la gente del país trabajará en el entierro y se sentirán orgullosos de eso, el día en que manifieste mi gloria, palabra de Yavé."
,"14":"Pasados los siete meses, se designarán a algunos hombres para que recorran el país y entierren a los que quedaron insepultos, para purificar así la tierra."
,"15":"Recorrerán el país, y el que vea huesos humanos, levantará al lado una pila de piedras: luego, los enterradores los sepultarán en el valle de Hamón-Gog."
,"16":"Y, así, el país quedará purificado."
,"17":"Hijo de hombre, dile a toda clase de aves y a las fieras salvajes: Júntense, vengan de todas partes y reúnanse para el sacrificio, palabra de Yavé, un gran sacrificio que he preparado en las montañas de Israel; habrá carne para comer y sangre para beber."
,"18":"Comerán la carne de los guerreros, beberán la sangre de los jefes de la tierra: ¡hay muchos carneros, corderos, chivos y toros gordos de Basán!"
,"19":"En ese sacrificio que les he preparado, se les dará grasa sin medida, y beberán sangre hasta embriagarse."
,"20":"Esto dice Yavé: En mi mesa se hartarán de caballos y de animales de tiro, de hombres selectos y de soldados."
,"21":"Así mostraré mi gloria a las naciones. Quiero que sepan lo que es mi justicia y cómo supe dejar caer mi mano sobre ellas."
,"22":"Entonces y para siempre la casa de Israel sabrá que yo soy Yavé, su Dios."
,"23":"Las naciones comprenderán que si el pueblo de Israel estuvo en el exilio, fue porque pecó contra mí; le oculté mi rostro porque me fue infiel; lo entregué en manos de sus enemigos, y todos murieron a espada."
,"24":"Los traté como lo merecían por sus pecados y sus infidelidades, y les oculté mi rostro."
,"25":"Por eso, esto dice Yavé: Voy a traer de vuelta a los desterrados de Jacob, tendré piedad de todo Israel y defenderé celosamente mi Santo Nombre."
,"26":"Cuando vivan en paz en su país y ya nadie los moleste, se olvidarán de su tristeza pasada y de todas las infidelidades que cometieron contra mí."
,"27":"Los reuniré de entre los pueblos y los traeré de vuelta del país de sus enemigos. Por su intermedio manifestaré mi santidad ante numerosas naciones."
,"28":"Sabrán que yo soy Yavé cuando me manifieste a las naciones paganas."
,"29":"Ya no les ocultaré mi rostro, sino que difundiré mi Espíritu en mi pueblo de Israel, palabra de Yavé.'"
}`)
	CurrentBook.AddChapter(40, `{
"1":"Era el comienzo del año vigésimo quinto de nuestro exilio; el diez del mes, catorce años después de la caída de la ciudad; ese día la mano de Yavé se posó sobre mí y me llevó."
,"2":"Mediante visiones divinas, me condujo al país de Israel y me depositó en una montaña muy alta. En la ladera me pareció ver las construcciones de una ciudad."
,"3":"Me llevó para allá y vi a la entrada a un hombre que parecía de bronce; en su mano tenía un cordel de lino y una vara para medir."
,"4":"Ese hombre me dijo: 'Hijo de hombre, mira bien, escucha con todos tus oídos y pon mucha atención a todo lo que te voy a mostrar, pues para eso te he traído hasta acá; todo lo que veas se lo comunicarás a la casa de Israel."
,"5":"Un muro, alrededor de toda la Casa, la separaba del exterior. El hombre tenía en la mano una vara para medir que llegaba a los seis codos de largo. Midió esa construcción: una vara de espesor y otra de alto."
,"6":"El hombre se acercó luego al pórtico que mira al oriente, subió los peldaños y midió el umbral del pórtico; medía una vara de profundidad."
,"7":"Cada una de las piezas medía una vara de largo y otra de ancho, los pilares que separaban a las piezas tenían cinco codos de espesor."
,"8":"El umbral del pórtico que miraba al oriente, al lado del vestíbulo, tenía una vara de profundidad."
,"9":"El hombre midió entonces el vestíbulo del pórtico, que daba al interior: ocho codos; su pilar medía dos."
,"10":"En ese pórtico del este había tres piezas a cada lado, todas de la misma dimensión; también los pilares eran de igual dimensión."
,"11":"Midió el ancho de la entrada del pórtico: diez codos; el pórtico como tal medía trece codos de largo."
,"12":"Las piezas medían seis codos a cada lado y frente a cada una había una balaustrada de un codo."
,"13":"El hombre midió el pórtico de una entrada a la otra: veinticinco codos."
,"14":"Midió el vestíbulo, que llegaba a veinte codos, el atrio se extendía alrededor del pórtico."
,"15":"Desde la fachada del pórtico hasta el fondo del vestíbulo interior, había cincuenta codos."
,"16":"Las piezas y los pilares estaban provistos de ventanas con rejillas que daban al interior del pórtico; también las había alrededor del vestíbulo. Los pilares estaba decorados con palmas."
,"17":"Me hizo entrar al patio interior; allí se habían dispuesto treinta salas y un embaldosado daba la vuelta al patio."
,"18":"Ese embaldosado se ajustaba a la profundidad de los pórticos; era el embaldosado interior."
,"19":"Desde la fachada de la puerta interior hasta el exterior había cien codos. Esto era para el este. Al norte, "
,"20":"midió el largo y ancho del pórtico que daba al patio exterior."
,"21":"Las seis piezas repartidas a ambos lados, los pilares y el vestíbulo tenían las mismas dimensiones que en el primer pórtico; su largo era de cincuenta codos y su profundidad, de veinticinco."
,"22":"Las ventanas, el vestíbulo y las palmas tenían la misma dirección que las del pórtico del este; se llegaba a ellas por siete escalones y el vestíbulo daba al interior."
,"23":"El patio interior tenía una puerta hacia el pórtico del norte, semejante a la que miraba al este; el hombre midió de una puerta a la otra y registró cien codos."
,"24":"Me condujo entonces al sur, y en el sur había un pórtico; midió sus pilares y vestíbulo: tenían las mismas dimensiones."
,"25":"El pórtico, el vestíbulo y las ventanas en derredor eran semejantes, el ancho del pórtico era de cincuenta codos y su profundidad, de veinticinco."
,"26":"Se llegaba al vestíbulo por siete peldaños, palmas decoraban los pilares de un extremo al otro."
,"27":"El patio interior tenía una puerta que daba al pórtico del sur; medía cien codos de una puerta a otra."
,"28":"Me llevó al patio interior por el pórtico sur y midió ese pórtico; tenía las mismas dimensiones que los otros."
,"29":"Sus piezas, sus pilares y su vestíbulo tenían las mismas dimensiones; el pórtico y su vestíbulo tenían ventanas a su alrededor, el largo del pórtico era de cincuenta codos y su ancho de veinticinco."
,"30":"Lo rodeaban vestíbulos de veinte codos de largo y cinco de ancho."
,"31":"Su vestíbulo daba al patio exterior, palmas adornaban sus pilares y se llegaba a él por ocho escalones."
,"32":"Me llevó al patio interior por el este, y midió el pórtico; tenía las mismas dimensiones que los otros."
,"33":"Sus piezas, sus pilares y su vestíbulo tenían las mismas dimensiones, el pórtico y su vestíbulo tenían ventanas en su derredor. Su ancho era de cincuenta codos y su profundidad de veinticinco."
,"34":"Su vestíbulo daba al patio exterior, palmas adornaban sus pilares de un extremo al otro y se llegaba a él por ocho escalones."
,"35":"Me hizo volver por la entrada norte, y encontró las mismas medidas;"
,"36":"La entrada tenía sus piezas, sus pilares, su vestíbulo con ventanas en derredor, su largo era de cincuenta codos y su ancho de veinticinco."
,"37":"Su vestíbulo daba al patio exterior, palmas adornaban sus pilares de un extremo al otro y se llegaba a él por ocho peldaños."
,"38":"Una sala desembocaba en el vestíbulo de la puerta; allí se lavaban las víctimas para el holocausto."
,"39":"En el vestíbulo de la puerta había dos mesas a un lado y dos al otro para degollar las víctimas para el holocausto, las víctimas por el pecado o como reparación."
,"40":"En el exterior, saliendo del norte, había dos meses a un lado y dos al otro."
,"41":"De ese modo había cuatro mesas en el interior y cuatro en el exterior de la puerta, o sea ocho mesas sobre las cuales se degollaban las víctimas."
,"42":"Las cuatro mesas para el holocausto eran de piedra tallada de un codo y medio de largo, de uno y medio de ancho y uno de alto. En las mesas se colocaban los instrumentos con los que se degollaban las víctimas para los holocaustos y los diversos sacrificios;"
,"43":"esas mesas en las que se ponía la carne de los sacrificios tenía un borde sobresaliente de una palma de ancho en todo el derredor."
,"44":"Me hizo entrar en el patio interior. Había allí dos salas, una en dirección a la fachada sur del pórtico norte, y otra hacia la fachada norte del pórtico sur."
,"45":"El hombre me dijo: 'La sala que mira al sur está destinada a los sacerdotes que prestan servicios en la Casa."
,"46":"La sala que mira al norte está reservada a los sacerdotes que prestan servicios en el altar. Entre los levitas, los hijos de Sadoc tienen el privilegio de acercarse a Yavé y de servirlo.'"
,"47":"Midió el patio, era cuadrado, de cien codos de largo y cien de ancho. El altar estaba frente a la Casa."
,"48":"Me hizo entrar en el vestíbulo de la Casa y midió sus pilares, cinco codos tanto a un lado como al otro. El ancho de la puerta era de catorce codos, y sus lados, de tres codos."
,"49":"El vestíbulo tenía veinte codos de ancho y doce de profundidad; se llegaba a él por diez peldaños. Cerca de los pilares había dos columnas, una a cada lado."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Me hizo entrar en la parte del antesantuario y midió los pilares de cada lado: medían seis codos de ancho."
,"2":"Su entrada medía diez codos de ancho y sus columnitas, cinco; midió su profundidad, que era de cuarenta codos y su ancho, de veinte."
,"3":"Luego entró en el santuario y midió el pilar de la entrada, medía dos codos de ancho. La entrada medía seis, y el muro de cada lado, siete."
,"4":"Midió veinte codos para el ancho y veinte para el largo de esa sala, luego añadió: 'Ese es el Santo de los Santos.'"
,"5":"Midió en seguida el muro de la Casa; tenía seis codos de alto; el ancho del corredor que rodeaba a la Casa era de cuatro codos."
,"6":"Las piezas laterales estaban dispuestas en tres pisos, treinta por cada uno. Había salientes en la pared de la Casa por los lados, alrededor, a fin de que las sostuvieran, sin que sus vigas penetraran en la pared interior de la Casa."
,"7":"El ancho de las piezas iba aumentando en todo a medida que se subían; porque el corredor del edificio aumentaba gradualmente en todo el rededor, de modo que el interior era más ancho en lo más alto, y así desde el pavimento se subía al piso del medio, y de éste al más alto."
,"8":"El tabique de esas piececitas tenía una vara de ancho alrededor de toda la Casa."
,"9":"Por su lado exterior el tabique de las piezas, junto con el pasadizo que las comunicaba, medía cinco codos."
,"10":"Las piezas alrededor de la Casa añadían a sus dimensiones veinte codos más."
,"11":"El pasadizo que comunicaba las piezas tenía una entrada al norte y una entrada al sur; el ancho de ese pasadizo era de cinco codos."
,"12":"El edificio estaba al oeste del patio, de frente al mismo. Tenía setenta codos de ancho y noventa de largo; el muro del edificio tenía cinco codos de espesor en toda su extensión."
,"13":"El hombre midió la Casa, tenía cien codos de largo: en profundidad, el patio, la edificación y sus muros medían cien codos."
,"14":"La fachada de la Casa, que daba al patio hacia el este, tenía también cien codos de ancho."
,"15":"Midió la longitud de la edificación por el lado del patio trasero con sus corredores de un extremo al otro; medía cien codos. El antesantuario y el vestíbulo del atrio, "
,"16":"las ventanas con rejillas y las entradas con sus tres piezas estaban todas revestidas de madera preciosa, desde el suelo hasta las ventanas."
,"17":"La decoración se extendía desde la entrada hasta dentro de la Casa, tanto en el exterior como el interior."
,"18":"Estaba formada por querubines y palmas, había una palma entre dos querubines; los querubines tenían dos caras:"
,"19":"una cara de hombre se enfrentaba a una palma de un lado, y otra cara de león enfrentaba a otra palma del otro lado. Así se había hecho en todo el derredor de la Casa."
,"20":"En el muro se habían representado querubines y palmas desde el suelo hasta encima de la entrada."
,"21":"Los pilares del antesantuario eran cuadrados; delante del santuario propiamente tal"
,"22":"había un altar de madera de tres codos de alto; su largo y su ancho eran de dos codos. Tenía piezas angulares y sus adornos eran de madera. El hombre me dijo: 'Esta es la mesa que está ante Yavé.'"
,"23":"El antesantuario tenía una puerta con dos batientes, y lo mismo el Santuario;"
,"24":"cada batiente era doble."
,"25":"Encima de las batientes del antesantuario, había representado en los muros querubines y palmas; un tejado de madera protegía la fachada y la puerta exterior."
,"26":"Ventanas con rejillas y palmas decoraban los pilares del vestíbulo, las piezas que rodeaban a la Casa y los tejados."
}`)
	CurrentBook.AddChapter(42, `{
"1":"El hombre me hizo salir en dirección norte, al patio interior; me condujo a las salas que daban al patio al norte del edificio."
,"2":"Al lado norte, las salas tenían cien codos de largo y cincuenta de ancho."
,"3":"Las puertas del patio interior se abrían hacia una galería de tres pisos que daban al empedrado del patio exterior."
,"4":"Frente a las salas había un corredor de cien codos de largo y diez de ancho; las entradas estaban por el norte."
,"5":"Las salas superiores eran más pequeñas que las salas inferiores o que las intermedias porque las galerías les quitaban espacio."
,"6":"En efecto, esas galerías tenían tres pisos y no tenían columnas como las de los patios; por eso, había un estrechamiento con respecto a las salas inferiores o a las del medio."
,"7":"El muro de las salas que daba al exterior, en dirección al patio exterior, tenía cincuenta codos de largo."
,"8":"El largo de las salas que miraba al patio exterior tenía cincuenta codos mientras que las que estaban de frente al Templo tenían cien."
,"9":"Viniendo desde el patio exterior había encima de esas salas una entrada que daba al este."
,"10":"En medio del muro del patio, en dirección sur, había salas que estaban frente al patio y a las edificaciones."
,"11":"Al lado de ellas pasaba un corredor, esas salas tenían el mismo aspecto que las piezas que se encontraban al norte: la misma longitud, el mismo ancho, la misma puerta, la misma disposición, la misma entrada."
,"12":"Encima de las salas que miraban al sur, había una entrada al comienzo de cada ala."
,"13":"El hombre me dijo entonces: 'Las salas del norte y las del sur que miran al patio son las salas santas donde los sacerdotes que se acercan a Yavé comen las carnes consagradas; allí depositan las cosas muy santas que han sido ofrecidas por la oblación, el sacrificio por el pecado y el sacrificio de reparación. Es un lugar santo."
,"14":"Cuando los sacerdotes salgan del santuario al patio exterior, dejarán allí las vestimentas con que oficiaron, porque esas vestimentas son santas. Se pondrán otras y entonces irán al patio reservado al pueblo.'"
,"15":"Cuando el hombre hubo acabado de medir las construcciones interiores, me hizo salir por la puerta oriental para tomar las medidas del exterior."
,"16":"Midió el lado este con su vara de medir y comprobó que tenía quinientas varas de largo."
,"17":"Midió el lado norte con su vara y vio que tenía quinientas varas."
,"18":"Midió otra vez el lado sur con la vara y de nuevo le dio quinientas varas."
,"19":"Midió, por último, el lado oeste con su vara y encontró que tenía quinientas varas."
,"20":"Así midió los cuatro lados; un muro de quinientas varas a lo largo y a lo ancho separaba lo sagrado de lo profano."
}`)
	CurrentBook.AddChapter(43, `{
"1":"El hombre me condujo a la puerta del es te,"
,"2":"y de repente llegó del Oriente la Gloria del Dios de Israel con un ruido semejante a los grandes torrentes; la tierra se iluminó con su Gloria."
,"3":"Esa visión era semejante a la que había tenido cuando Yavé llegó para destruir la ciudad; también era parecida a la visión que había tenido a orillas del río Quebar; me tiré de bruces al suelo."
,"4":"La Gloria de Yavé entró en el Templo por la puerta este."
,"5":"El Espíritu me levantó y me hizo entrar en el patio interior, y la Gloria de Yavé llenó la Casa."
,"6":"Oí entonces a alguien que me hablaba desde el interior del Templo, mientras el hombre seguía siempre a mi lado."
,"7":"Me dijo: 'Hijo de hombre, has visto el lugar de mi trono, el sitio para la planta de mis pies; allí habitaré para siempre en medio de los Israelitas. El pueblo de Israel junto con sus reyes no ensuciará más mi Santo Nombre con sus prostituciones o con los cadáveres de sus reyes cuando éstos mueran."
,"8":"Habían puesto su puerta al lado de mi puerta, sus montantes de puerta al lado de los montantes de la mía: sólo un muro había entre ellos y yo. Los horrores que cometieron mancharon mi Santo Nombre, y los exterminé en mi cólera."
,"9":"Por eso, ahora arrojen de mí sus prostituciones y los cadáveres de sus reyes, de tal manera que pueda habitar en medio de ustedes para siempre."
,"10":"Tú, hijo de hombre, descríbele ahora al pueblo de Israel la Casa, para que sientan vergüenza de sus culpas y les tomen el peso."
,"11":"Si se avergüenzan de todo lo que han hecho, dibujarás la Casa y sus dependencias, sus entradas y sus salidas y todas sus decoraciones. Se las darás a conocer y pondrás por escrito ante sus ojos todos los reglamentos y todas las leyes de la Casa, para que las observen y las pongan en práctica."
,"12":"Esta es la ley de la Casa: todo su territorio, en toda su extensión en la cumbre de la montaña, es un lugar santísimo.'"
,"13":"Estas son las dimensiones del Altar en codos del Templo. Este codo vale un codo ordinario y un palmo. El basamento completo es de un codo de alto y uno de ancho, con un borde exterior de un palmo. El altar se levanta de este modo:"
,"14":"el zócalo inferior tiene dos codos por encima del basamento, dejando un codo de ancho, y la altura es de cuatro codos desde el pequeño zócalo hasta el gran zócalo, dejando también un codo de ancho."
,"15":"El fogón está cuatro codos más alto, con sus cuatro cuernos hacia arriba."
,"16":"El fogón es cuadrado, con doce codos de largo por doce de ancho."
,"17":"El gran zócalo tiene catorce codos de largo por catorce de ancho (el pequeño zócalo tiene seis codos de largo y seis de ancho) sobre su basamento de un codo, más el borde en derredor. Los peldaños quedan al lado este."
,"18":"Y me dijo: 'Hijo de hombre, esto dice Yavé: Estas son las reglas para el altar, el día en que se lo inaugure. Se subirá a él el holocausto y se derramará allí la sangre."
,"19":"Entonces darás a los sacerdotes levitas que son descendientes de Sadoc y que se acercan a mí para servirme, palabra de Yavé, un novillo para la expiación."
,"20":"Untarás en su sangre y con ella tocarás los cuatro cuernos, los ángulos del zócalo y el borde; así harás la expiación del altar."
,"21":"Luego tomarás al toro y lo quemarás en una dependencia de la Casa, fuera del Templo."
,"22":"El segundo día ofrecerás un chivo sin defecto como expiación, y se hará la expiación por el altar como se hizo con el novillo."
,"23":"Luego, cuando hayas terminado la expiación, ofrecerás un novillo sin defecto y un carnero sin defecto sacado del rebaño."
,"24":"Los ofrecerás ante Yavé, los sacerdotes les echarán sal y los ofrecerán como holocausto a Yavé."
,"25":"Durante siete días ofrecerás diariamente un chivo como expiación; se sacrificará igualmente un novillo y un carnero sacado del rebaño."
,"26":"Durante siete días se harán súplicas por el altar, lo purificarán y lo inaugurarán."
,"27":"A partir del octavo día, los sacerdotes podrán ofrecer en el altar los holocaustos y sacrificios pacíficos de ustedes y yo los aceptaré, palabra de Yavé.'"
}`)
	CurrentBook.AddChapter(44, `{
"1":"El hombre me hizo regresar a la puerta este del Templo; estaba cerrada."
,"2":"Me dijo: 'Esta puerta permanecerá cerrada; no la abrirán nunca y nadie entrará por ella, porque Yavé Dios de Israel pasó por esa puerta; permanecerá cerrada."
,"3":"Pero el príncipe, debido a que es príncipe, podrá sentarse allí para comer el pan ante Yavé; llegará por el vestíbulo de la puerta y se retirará por el mismo camino.'"
,"4":"Luego me condujo al Templo por la puerta norte, miré y vi que la Gloria de Yavé llenaba la Casa. Entonces me eché de bruces al suelo."
,"5":"Me dijo: 'Hijo de hombre, pon mucha atención, mira con tus ojos y oye con tus oídos todo lo que voy a decir con respecto a las reglas de la Casa de Yavé y de sus leyes. Escucha bien todo lo relativo a la entrada y salida del Templo.'"
,"6":"Dirás a la gente de Israel, a esa banda de revoltosos: Esto dice Yavé: 'Estoy harto, pueblo de Israel, de todos los horrores"
,"7":"que cometían cuando hacían entrar a extranjeros incircuncisos de corazón y de carne. Entraban en mi santuario y lo profanaban cuando ustedes me ofrecían mi comida de grasa y de sangre."
,"8":"Ustedes rompieron mi alianza con todos esos horrores, al encargarles el servicio de mi santuario. Y ahora,"
,"9":"esto dice Yavé: Ningún extranjero de corazón o de carne volverá a entrar a mi santuario, ninguno de los extranjeros que viven en medio de los israelitas."
,"10":"En cuanto a los levitas que se alejaron de mí cuando Israel me dejó para seguir a sus ídolos, cargarán con el peso de su pecado."
,"11":"En mi santuario serán los encargados de la vigilancia de las puertas del Templo y mantendrán el servicio de la Casa. Degollarán los animales para el holocausto y el sacrificio por el pueblo, estarán a disposición del pueblo para el culto."
,"12":"Pero ya que tomaron para sí el servicio a los ídolos y fueron para la gente de Israel una ocasión de pecado, levanto mi mano para condenarlos, palabra de Yavé: cargarán con el peso de su pecado."
,"13":"No serán más contados entre los sacerdotes que se acercan a mí y tocan las cosas santas o santísimas; quedarán descalificados debido a los horrores cometidos."
,"14":"Haré de ellos los guardianes del orden de la Casa, del culto y de todo lo que debe hacerse."
,"15":"Pero quienes se acerquen a mí para servirme y estén ante mí para presentarme la grasa y la sangre serán los sacerdotes levitas descendientes de Sadoc, palabra de Yavé, porque mantuvieron las leyes de mi santuario cuando los Israelitas se apartaban lejos de mí."
,"16":"Entrarán a mi santuario y se aproximarán a mi mesa para servirme; tendrán a su cargo mi culto."
,"17":"Cuando franqueen las puertas del patio interior, se revestirán de ropas de lino; no se pondrán nada de lana cuando cumplan con su servicio en el patio interior."
,"18":"Tendrán turbantes de lino en la cabeza y calzoncillos de lino en las entrepiernas, no se pondrán nada que los haga traspirar."
,"19":"Cuando salgan donde está el pueblo en el patio exterior, se sacarán las vestimentas con que celebraron el culto; las dejarán en las salas santas y se pondrán otra ropa para que el pueblo no entre en contacto con sus vestimentas sagradas."
,"20":"No se raparán la cabeza, no tendrán el cabello largo, sino que se lo cortarán como corresponde."
,"21":"Ningún sacerdote tomará vino antes de entrar al patio interior."
,"22":"Los sacerdotes no se casarán con viudas (salvo una viuda de sacerdote) ni con mujeres repudiadas, sino sólo con vírgenes de la raza de Israel."
,"23":"Le enseñarán a mi pueblo la diferencia entre lo sagrado y lo profano, entre lo puro y lo impuro."
,"24":"Tendrán autoridad para juzgar en los procesos, juzgarán según mis reglas, observarán mis leyes y mis mandamientos en todo lo concerniente a las fiestas, y santificarán mis sábados."
,"25":"No se acercarán a un muerto para no quedar impuros. Sin embargo, si se trata de su padre, de su madre, de un hijo o de una hija, de un hermano o de una hermana todavía virgen, podrán quedar impuros."
,"26":"Cuando uno de ellos tenga que purificarse, se contarán siete días,"
,"27":"y el día en que entre nuevamente en el patio interior para su servicio en el lugar santo, presentará su sacrificio por el pecado, palabra de Yavé."
,"28":"Esta será su herencia. Yo soy su herencia, y ustedes no les darán posesión alguna en Israel porque yo soy su posesión."
,"29":"Las víctimas que se ofrecen por el pecado o como reparación, y todo lo que es considerado anatema en Israel será para ellos."
,"30":"Los sacerdotes recibirán las primicias de todos los primores y todo lo que sea descontado de lo que ustedes hayan descontado; las primicias de sus harinas serán para el sacerdote y gracias a eso vendrá la bendición sobre la casa de Israel."
,"31":"Los sacerdotes no comerán ningún animal reventado o desgarrado, sea ave o cuadrúpedo."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Cuando se repartan por sorteo el país, dejarán una parte para Yavé, un territorio sagrado que hayan elegido dentro del país; tendrá veinticinco mil codos de largo por veinte mil de ancho; será sagrado en toda su extensión."
,"2":"Allí se reservará un espacio cuadrado de quinientos codos por lado para el lugar santo, con una orilla de circunvalación de cincuenta codos."
,"3":"En la primera superficie mencionada se medirá una parte de veinticinco mil codos de largo por diez mil de ancho donde estará el santuario; será un lugar santísimo."
,"4":"Esa porción de terreno será para los sacerdotes que se preocupan del servicio del santuario y que se acercan a Yavé para servirle; será para sus casas y para su ganado."
,"5":"Y a los levitas que se preocupan del servicio de la Casa les darán un territorio de veinticinco mil codos por diez mil: allí estarán las ciudades en donde vivirán."
,"6":"Reservarán un terreno de cinco mil codos por veinticinco mil, junto al dominio del Templo: será propiedad de la ciudad y será de toda la casa de Israel."
,"7":"El príncipe recibirá un territorio tanto al lado del dominio reservado al Templo como al lado de la propiedad de la ciudad: al este hasta la frontera oriental, y al oeste hasta el mar. Tendrá pues la misma longitud que las partes reservadas a cada tribu."
,"8":"Esa será su propiedad en Israel; así, mis príncipes no oprimirán más a mi pueblo y dejarán la tierra de Israel a sus tribus."
,"9":"Esto dice Yavé: ¡Se han pasado de la raya, príncipes de Israel! Detengan la opresión y la violencia, practiquen el derecho y la justicia. Pongan fin a sus abusos con mi pueblo, palabra de Yavé."
,"10":"Tengan balanzas justas, una medida y pesa justas."
,"11":"Las medidas para los granos y las medidas para los líquidos deben contener lo mismo; así el bat igual que el efá contendrán la décima parte de un jomer. Determinarán pues su contenido en base al jomer."
,"12":"El siclo equivaldrá a veinte gueras y quince siclos, a una mina."
,"13":"Esto es lo que reservarán: un sexto de efá por jomer de trigo y un sexto de efá por jomer de cebada."
,"14":"Esta es la regla para el aceite: darán un sexto de bat por kor, ya que diez bats forman un kor."
,"15":"De un rebaño de doscientas cabezas que se halle en los pastizales de Israel, sacarán una oveja para la ofrenda, el holocausto y el sacrificio de comunión: eso será para hacer la expiación por ustedes, palabra de Yavé."
,"16":"Todo el pueblo del país estará obligado a esta contribución que irá al príncipe de Israel."
,"17":"El príncipe se encargará de los holocaustos, de las ofrendas y de la libación con ocasión de las fiestas, de las lunas nuevas, de los sábados y de todas las asambleas del pueblo de Israel; él se preocupará del sacrificio por el pecado, de la ofrenda, el holocausto y los sacrificios de comunión por el pueblo de Israel."
,"18":"Esto dice Yavé: El primer día del primer mes tomarás un novillo sin defecto para borrar el pecado del Santuario."
,"19":"El sacerdote untará en la sangre de la víctima por el pecado y rociará los montantes de la puerta de la Casa, los cuatro ángulos del zócalo del altar y los montantes de las puertas del patio interior."
,"20":"Se hará lo mismo el siete del mes en favor de los que hayan pecado involuntariamente o sin pensarlo; así harán la expiación por la Casa."
,"21":"El día catorce del primer mes será para ustedes la fiesta de Pascua; durante siete días comerán pan sin levadura."
,"22":"Ese día el príncipe ofrecerá un toro como sacrificio por el pecado, por él y por todo el pueblo."
,"23":"Durante los siete días de la fiesta se ofrecerán cada día a Yavé siete toros y siete carneros en holocausto, y cada día un chivo como sacrificio por el pecado."
,"24":"Presentarán como ofrenda una medida de harina por cada toro y otra por cada carnero, con un sexto de medida de aceite."
,"25":"Para la fiesta de las Tiendas, el quince del séptimo mes, se hará lo mismo durante siete días; ofrecerán sacrificios por el pecado, holocausto, ofrendas y aceite."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Esto dice Yavé: La puerta del patio interior que da al oriente permanecerá cerrada durante los seis días laborables; se la abrirá el día sábado y también el día de la luna nueva."
,"2":"El príncipe llegará hasta allí desde el exterior por el vestíbulo de la puerta y se quedará cerca del montante de la puerta; los sacerdotes ofrecerán entonces su holocausto y su sacrificio pacífico. Luego, se postrará en el dintel de la puerta y se retirará; la puerta no se volverá a cerrar hasta la tarde."
,"3":"Con ocasión de los sábados y de las lunas nuevas, el pueblo se postrará ante Yavé a la entrada de la puerta."
,"4":"El día sábado, el príncipe presentará en holocausto a Yavé seis corderos y un carnero sin defecto."
,"5":"Presentará como ofrenda una medida de harina por el carnero y lo que quiera por los corderos; añadirá un sexto de medida de aceite."
,"6":"El día de la luna nueva ofrecerá un novillo, seis corderos y un carnero sin defecto."
,"7":"Junto con el novillo ofrecerá harina, una medida por el carnero y lo que quiera por los corderos; añadirá un sexto de medida de aceite."
,"8":"Cuando el príncipe entre, pasará por el vestíbulo de la puerta y se devolverá por el mismo camino."
,"9":"Cuando el pueblo del país comparezca ante Yavé con ocasión de las fiestas, el que venga por la puerta norte para postrarse saldrá por la puerta sur; el que venga por la puerta sur saldrá por la puerta norte. No se volverá por la puerta por donde se entró, sino que se saldrá por el lado contrario."
,"10":"El príncipe entrará con sus súbditos y saldrá cuando estos salgan."
,"11":"Con ocasión de las fiestas y de las solemnidades, el príncipe ofrecerá por el novillo una medida de harina, otra por el carnero y lo que quiera por los corderos."
,"12":"Cuando el príncipe presente a Yavé su ofrenda voluntaria, el holocausto o el sacrificio pacífico, se le abrirá la puerta del este. Presentará su holocausto y su sacrificio pacífico como lo hace el día sábado, luego se retirará y se cerrará la puerta apenas salga."
,"13":"Cada día ofrecerás en holocausto a Yavé un cordero de un año, sin defecto, lo presentarás cada mañana."
,"14":"Cada mañana igualmente presentarás a Yavé una ofrenda: un sexto de medida de harina y un duodécimo de medida de aceite para amasar la harina; es una regla perpetua."
,"15":"Cada mañana se presentará el holocausto perpetuo: un cordero, junto con la harina y el aceite."
,"16":"Esto dice Yavé: Si el príncipe hace un regalo a uno de sus hijos, ese regalo será parte de la herencia de sus hijos, será su propiedad de generación en generación."
,"17":"Pero si regala algo de la herencia a uno de sus servidores, ese regalo pertenecerá a su servidor hasta el año de la liberación, después de lo cual volverá al príncipe; sólo los hijos conservarán la herencia."
,"18":"Con esto, el príncipe no tomará nada de la herencia del pueblo; no le quitará lo que le pertenece, sino que de sus propios bienes dará una herencia a sus hijos; así mi pueblo no será despojado de su herencia.'"
,"19":"El hombre me llevó por la entrada ubicada al lado del pórtico a las piezas santas reservadas a los sacerdotes, las que están al norte. Allí, en el extremo oeste, había un espacio."
,"20":"Me dijo: 'En este lugar los sacerdotes cocerán las víctimas de los sacrificios por el pecado y de los sacrificios de reparación. Allí también cocerán las ofrendas de harina; no tendrán que llevarlas al patio exterior para que las cosas santas no entren así en contacto con el pueblo.'"
,"21":"Me llevó en seguida al patio exterior e hizo que pasara cerca de las cuatro esquinas del patio. En cada esquina había un pequeño patio,"
,"22":"o sea cuatro patios pequeños de cuarenta codos de largo por treinta de ancho; los cuatro tenían las mismas dimensiones."
,"23":"Estaban rodeados de un muro y al pie de ese muro se habían construido fogones."
,"24":"Me dijo: 'En estos fogones los servidores de la Casa quemarán la carne de los sacrificios por el pueblo.'"
}`)
	CurrentBook.AddChapter(47, `{
"1":"El me llevó a la entrada del Templo y vi que brotaba agua de debajo del dintel de la Casa: corría hacia el oriente igual como la Casa que daba al oriente. El agua brotaba del lado sur del altar."
,"2":"Me hizo salir por el pórtico norte y que diera la vuelta por el exterior hasta el pórtico este: el agua corría ahora a mi derecha."
,"3":"El hombre se alejó al oriente. Midió mil codos con la vara que sostenía en la mano, luego me dijo que atravesara el arroyuelo: el agua me llegaba apenas a los tobillos."
,"4":"Midió luego mil codos y me dijo que atravesara el arroyo; el agua me llegaba a las rodillas. Midió otra vez mil codos y me dijo que atravesara el estero: el agua me llegaba a la cintura."
,"5":"Midió todavía mil codos: esa vez no pude atravesar el torrente; las aguas habían subido, se habían convertido en un río que no se podía atravesar a pie sino a nado."
,"6":"Me dijo entonces: '¿Has visto, hijo de hombre?' Después de eso me hizo pasear por la orilla."
,"7":"Cuando regreso al torrente, veo que hay en la orilla muchos árboles, a ambos lados del torrente."
,"8":"Me dijo: 'Esa agua corre hacia la región este, desciende hacia la Arabá y desemboca en el Mar Muerto para que sus aguas queden sanas."
,"9":"Todo ser viviente, todo lo que se mueva por donde pase el torrente se llenará de vida; la pesca será allí muy abundante. Bastará con que lleguen sus aguas para que haya salud y vida por donde ellas pasen."
,"10":"Los pescadores se instalarán en sus orillas desde En-Guedi hasta En-Elayim: allí echarán sus redes. Los pescados serán muy numerosos, de las mismas especies que hay en el Gran Mar."
,"11":"Los pantanos y lagunas, en cambio, serán insalubres; quedarán como salinas."
,"12":"En las márgenes del torrente, desde principio a fin, crecerán toda clase de árboles frutales; su follaje no se secará, tendrán frutas en cualquier estación: Producirán todos los meses gracias a esa agua que viene del santuario. La gente se alimentará con sus frutas y sus hojas les servirán de remedio."
,"13":"Así habla Yavé: Este es el territorio que se repartirán entre las doce tribus de Israel (darán dos porciones a José)."
,"14":"Todos tendrán su parte porque juré a sus padres, con la mano en alto, que les daría este país: su herencia."
,"15":"Por el norte, la frontera del país partirá del gran mar por el camino de Hetlón en el Sedad a la entrada de Jamat,"
,"16":"luego seguirá en dirección a Haurán: Berota, Sibrayim, entre los territorios de Damasco y de Jamat, Hases-ha-ticón."
,"17":"La frontera irá pues desde el mar hasta Hasar-Enán, dejando al norte el territorio de Damasco y el de Jamat: esto es por el norte."
,"18":"Por el este pasará entre Haurán y Damasco, entre Galaad y el territorio de Israel, y el Jordán servirá de frontera hasta el Mar Muerto al lado de Tamar. Esa es la frontera este."
,"19":"Por el sur se dirigirá desde Tamar a las aguas de Meribá en Cadés, luego seguirá hacia el torrente hasta el Gran Mar; esa será la frontera meridional."
,"20":"Por el oeste el Gran Mar servirá de frontera hasta la entrada a Jamat, esa será la frontera oeste."
,"21":"Se repartirán esa tierra entre las tribus de Israel."
,"22":"Cada uno sacará por sorteo la propiedad que le corresponda y también la de los extranjeros que viven entre ustedes junto con sus hijos nacidos en el país. Los tratarán como a los israelitas del país, e igual que ustedes recibirán una propiedad en medio de las tribus de Israel."
,"23":"El extranjero tendrá su propiedad en la tribu donde viva, palabra de Yavé."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Esta es la repartición de las tribus. Dan tiene su territorio bien al norte, en dirección a Hetlón, a la entrada de Jamat y de Hasar-Enán; se extiende desde la frontera este a la occidental, dejando más al norte el territorio de Damasco que bordea Jamat."
,"2":"El territorio de Aser se extiende desde la frontera este a la frontera occidental, justo al lado de Dan."
,"3":"El territorio de Neftalí se extiende desde la frontera este a la frontera occidental, al lado de Aser."
,"4":"El territorio de Manasés se extiende desde la frontera este a la frontera occidentdal, al lado de Neftalí."
,"5":"El territorio de Efraím se extiende desde la frontera este a la frontera occidental, al lado de Manasés."
,"6":"El territorio de Rubén se extiende desde la frontera este a la frontera occidental, al lado de Efraím."
,"7":"El territorio de Judá se extiende desde la frontera este a la frontera occidental, al lado de Rubén."
,"8":"Después de Judá, desde la frontera este a la frontera occidental, reservarán un territorio de veinticinco mil codos de ancho y tan largo como cada una de las porciones; en medio de ese territorio estará el santuario."
,"9":"La parte que separen para Yavé tendrá veinticinco mil codos de largo por diez mil de ancho."
,"10":"El lote sagrado destinado a los sacerdotes tendrá veinticinco mil codos al norte, diez mil codos de ancho al oeste y al este, y veinticinco mil codos al sur. El Santuario de Yavé estará en el medio."
,"11":"Ese territorio será para los sacerdotes consagrados, esos descendientes de Sadoc que aseguraron mi servicio y no siguieron a los israelitas en su desvarío como lo hicieron los levitas."
,"12":"Aquéllos pues tendrán un lote tomado de la parte más santa del país, al lado del territorio de los levitas."
,"13":"Tanto el territorio de los levitas como el de los sacerdotes tendrá veinticinco mil codos de largo por diez mil de ancho."
,"14":"No podrán vender ni cambiar esta tierra, ni podrán cedérsela a otro, porque está consagrada a Yavé."
,"15":"La superficie que resta, de cinco mil codos de ancho por veinticinco mil de largo, será un territorio profano para la ciudad, para viviendas y para que pasten los animales; la ciudad quedará en el medio."
,"16":"Estas son sus dimensiones: cuatro mil quinientos codos al norte, al sur, al este y al oeste."
,"17":"Al norte, los campos para pastar de la ciudad se extenderán doscientos cincuenta codos al este y doscientos cincuenta al oeste."
,"18":"A lo largo de la parte consagrada se ubicará una franja de terreno de diez mil codos de largo al este y diez mil al oeste; los ingresos de ese terreno servirán para alimentar a los trabajadores de la ciudad."
,"19":"Los trabajadores de la ciudad serán elegidos de entre todas las tribus de Israel y cultivarán ese terreno."
,"20":"En total, el lote que se saque de la herencia de Israel será de veinticinco mil codos por veinticinco mil. En su centro se reservará un espacio para construir la ciudad."
,"21":"El príncipe recibirá lo que queda al este y al oeste, tanto de la parte consagrada como de la propiedad de la ciudad, en esa franja de veinticinco mil codos de largo que va desde la frontera este a la frontera oeste; la porción del príncipe será paralela a los demás lotes, y en el medio estará el dominio sagrado con el santuario de la Casa."
,"22":"Así pues, el príncipe recibirá su terreno a continuación del de los levitas y del de la ciudad, entre el territorio de Judá y él de Benjamín."
,"23":"Estas son las porciones para las demás tribus: Benjamín tendrá su parte desde la frontera este hasta la frontera oeste."
,"24":"Justo al lado de Benjamín tendrá su parte Simeón, desde la frontera este hasta la frontera oeste."
,"25":"Justo al lado de Simeón tendrá su parte Isacar, desde la frontera este hasta la frontera oeste."
,"26":"Justo al lado de Isacar tendrá su parte Zabulón, desde la frontera este hasta la frontera oeste."
,"27":"Justo al lado de Zabulón tendrá su parte Gad desde la frontera este hasta la frontera oeste."
,"28":"La frontera meridional de Gad irá desde Tamar hacia las aguas de Meribá de Cadés, y hasta el Gran Mar siguiendo el torrente de Egipto."
,"29":"Ese será el país que se repartirán como herencia entre las tribus de Israel, y ésa es la parte de cada uno, palabra de Yavé."
,"30":"Estas son las salidas de la ciudad: El lado norte tendrá cuatro mil quinientos codos."
,"31":"Habrá tres puertas al norte: la puerta de Rubén, la de Judá y la de Leví (pues las puertas de la ciudad recibirán los nombres de las tribus de Israel)."
,"32":"El lado este tendrá cuatro mil quinientos codos, y habrá tres puertas: las puertas de José, Benjamín y Dan."
,"33":"El lado sur medirá cuatro mil quinientos codos, y tendrá tres puertas: las puertas de Simeón, Isacar y Zabulón."
,"34":"En el lado oeste se medirán cuatro mil quinientos codos y habrá tres puertas: las puertas de Gad, Aser y Neftalí."
,"35":"La ciudad tendrá pues un perímetro de dieciocho mil codos. En cuanto a su nombre, a partir de ese día, será: 'Yavé está allí.'"
}`)

}
func ES_LBL_LoadVMIEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Estas son las palabras de Jeremías, hijo de Helcías, de una familia de sacerdotes que vivían en Anatot, en la tierra de Benjamín."
,"2":"La palabra de Yavé le fue dirigida en tiempos de Josías, hijo de Amón y rey de Judá, en el año trece de su reinado,"
,"3":"y después en tiempos de Joaquim, hijo de Josías y rey de Judá, hasta cumplirse el año undécimo de Sedecías, hijo de Josías y rey de Judá, o sea, hasta el destierro del pueblo de Jerusalén, que aconteció en el mismo mes."
,"4":"Me llegó una palabra de Yavé:"
,"5":"'Antes de formarte en el seno de tu madre, ya te conocía; antes de que tú nacieras, yo te consagré, y te destiné a ser profeta de las naciones.'"
,"6":"Yo exclamé: 'Ay, Señor, Yavé, ¡cómo podría hablar yo, que soy un muchacho!'"
,"7":"Y Yavé me contestó: 'No me digas que eres un muchacho. Irás adondequiera que te envíe, y proclamarás todo lo que yo te mande."
,"8":"No les tengas miedo, porque estaré contigo para protegerte, palabra de Yavé.'"
,"9":"Entonces Yavé extendió su mano y me tocó la boca, diciéndome: 'En este momento pongo mis palabras en tu boca."
,"10":"En este día te encargo los pueblos y las naciones: Arrancarás y derribarás, perderás y destruirás, edificarás y plantarás.'"
,"11":"Me llegó una palabra de Yavé: '¿Reconoces esta visión?'"
,"12":"Yo dije: 'La rama es del árbol que llaman alerta.' Yavé respondió: 'No te equivocas, pues yo estoy así alerta a mi palabra, para cumplirla.'"
,"13":"Luego me llegó una palabra de Yavé: '¿Qué estás viendo?' Y contesté: 'Veo una olla echando espumas, y la cosa viene del norte.'"
,"14":"Yavé me dijo: 'Del norte se viene derramando el desastre, y alcanzará a todos los habitantes de este país."
,"15":"Pues estoy llamando a todos los reinos del norte, palabra de Yavé. Aquí vienen y cada uno de ellos establece sus cuarteles frente a una de las entradas de Jerusalén, frente a sus murallas y frente a las ciudades de Judá."
,"16":"Voy a hacer justicia con este pueblo que me ha dejado para hacer el mal; ha quemado incienso a dioses extranjeros, y se ha puesto a servir a dioses que ellos mismos se fabricaron."
,"17":"Tú, ahora, muévete y anda a decirles todo lo que yo te mande. No temas enfrentarlos, porque yo también podría asustarte delante de ellos."
,"18":"Este día hago de ti una fortaleza, un pilar de hierro y una muralla de bronce frente a la nación entera: frente a los reyes de Judá y a sus ministros, frente a los sacerdotes y a los propietarios."
,"19":"Ellos te declararán la guerra, pero no podrán vencerte, pues yo estoy contigo para ampararte, palabra de Yavé.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Se me comunicó una palabra de Yavé: 'Anda y grita a los oídos de Jerusalén':"
,"2":"Así dice Yavé: 'Aún me acuerdo de la pasión de tu juventud, de tu cariño como de novia, cuando me seguías por el desierto, por la tierra sin cultivar.'"
,"3":"Israel era la cosa sagrada de Yavé, la parte mejor de su cosecha. Quien comiera de sus frutos tenía que pagar y pronto le venía la desgracia, palabra de Yavé."
,"4":"Gente de Israel, con todas sus familias, escuchen lo que dice Yavé:"
,"5":"¿Acaso sus padres me hallaron desleal, para que se alejaran de mí? Pues se fueron a cosas despreciables y, con esto, se hicieron despreciables."
,"6":"Ya no preguntan: ¿Dónde está Yavé, que nos hizo salir de Egipto y nos llevó a través del desierto, tierra de estepas y barrancas, tierra árida y tenebrosa, tierra sin habitantes y por donde no transita nadie?"
,"7":"Yo soy quien los condujo al jardín de la tierra para que gozaran sus bienes y comieran los mejores frutos. Pero apenas llegaron a mi país, lo profanaron, y mancharon mi herencia."
,"8":"Los sacerdotes ya no se preguntan: ¿Dónde está Yavé? ¡Los dueños de mi enseñanza no me conocen! Los pastores de mi pueblo se rebelaron contra mí, y los profetas consultaron a dioses inútiles, dando respuestas en nombre de Baal."
,"9":"Por eso, les he metido pleito a esa gente, palabra de Yavé, y aún lo seguiré con los hijos de sus hijos."
,"10":"Vayan, pues, a las islas y miren, manden al país de Quedar y pregunten para saber dónde pasó algo igual que aquí."
,"11":"¿Qué nación cambió sus dioses? -aunque en verdad no son dioses-. Y mi pueblo cambia a su Dios glorioso por algo que no sirve."
,"12":"Que los cielos se asombren y tiemblen espantados por eso, palabra de Yavé;"
,"13":"doble falta ha cometido mi pueblo: me ha abandonado a mí, que soy manantial de aguas vivas, y se han cavado pozos, pozos agrietados que no retendrán el agua."
,"14":"¿Acaso yo te había hecho esclavo, o te había sometido a algún dueño? ¿Por qué, pues, ahora saquean a Israel?"
,"15":"Contra ti han rugido leones, tu tierra ha sido desolada, tus ciudades, incendiadas y despobladas."
,"16":"Hasta los egipcios de Nof y de Tajfanjes te han humillado."
,"17":"¿Acaso no sucedió esto porque has abandonado a Yavé, tu Dios, que te indicaba el camino?"
,"18":"¿Para qué llamas a Egipto?, ¿acaso te sanarán las aguas del Nilo? ¿Y para qué llamas a Asur?, ¿apagarán acaso tu sed las aguas del río?"
,"19":"Tus mismas faltas te castigan y tus infidelidades te condenan. Reconoce y comprueba cuán malo y amargo resulta abandonar a Yavé, tu Dios, y dejar de temerme a mí, palabra de Yavé Sabaot."
,"20":"Hace tiempo que has quebrado el yugo, soltándote de sus lazos. Tú dijiste: 'Yo no quiero servir.' Y sobre cualquier loma, bajo cualquier árbol frondoso, te tendías como una prostituta."
,"21":"Yo te había plantado como una parra fina. ¿Cómo has pasado a ser para mí viña degenerada?"
,"22":"Aunque te laves, te limpies y te restriegues, ante mí no desaparecerá la mancha de tus faltas, palabra de Yavé."
,"23":"Todavía te atreves a decir: 'No estoy manchada, no he ido tras los baales.' Mira en el valle las huellas de tus pasos, y reconoce lo que has hecho, camella fácil, que va coqueteando por los caminos;"
,"24":"burra salvaje suelta en el desierto, que en el ardor de su pasión olfatea el viento. ¿Quién calmará su celo? "
,"25":"El que la busca sabe dónde encontrarla. Pero tú dices: '¡No, déjame!, a mí me gustan los extranjeros y tras ellos quiero ir.'"
,"26":"Así como se avergüenza un ladrón cuando lo pillan, así se avergonzarán los hombres de Israel, ellos, sus reyes y sus jefes, sus sacerdotes y sus profetas,"
,"27":"que dicen a un palo: 'Tú eres mi padre', y a una piedra: 'Tú me diste la vida.',Ellos me dan la espalda, en vez de mostrarme su cara. Pero cuando les pase una desgracia, gritarán diciéndome: '¡Levántate, sálvanos!'"
,"28":"Pues, ¿dónde están tus dioses que tú mismo hiciste?,¡A ver si te salvan en el tiempo de tu desgracia!,Porque tus dioses, pueblo de Judá, son tan numerosos como tus ciudades."
,"29":"¿Por qué quieren ustedes meterme en pleito, cuando todos ustedes me han traicionado?, dice Yavé."
,"30":"Inútilmente he corregido a sus hijos, ya que nadie me ha hecho caso. La espada, más feroz que un león, ha devorado a sus profetas, pero no entendieron."
,"31":"¿He sido yo para Israel un desierto,o una tierra cubierta de espinos?,¿Por qué, entonces, dice mi pueblo: 'Nos apartamos de ti, no queremos verte más?'"
,"32":"¿Puede una joven olvidarse de sus adornos,o una novia de su cinturón?,Y, sin embargo, mi pueblo me ha olvidado, hace ya mucho tiempo."
,"33":"Qué bien andaban tus pies en busca de amor. Conoces todos los caminos, aun los del crimen."
,"34":"Mira tus manos manchadas con sangre, no de bandidos sorprendidos en el crimen,sino que de inocentes."
,"35":"Sin embargo, dices: 'Soy inocente,¿por qué no se aparta de mí la ira de Yavé?',Pues bien, aquí te voy a rebatir: Sí, tú pecaste."
,"36":"¿Hasta dónde no correrás? Pero será en vano: como te engañó Asur también te engañará Egipto."
,"37":"También de ahí saldrás con las manos en la cabeza, porque a Yavé no le gustan aquellos en que confías, y no te irá bien con ellos."
}`)
	CurrentBook.AddChapter(3, `{
"1":"'Si un hombre despide a su esposa y ella, alejándose de él, pasa a ser esposa de otro, ¿podrá volver a él de nuevo? ¿No sería un escándalo para todo el país? Pues bien, tú has andado con muchos amantes ¿y pretendes volver a mí?"
,"2":"Alza los ojos hacia los cerros y mira: no hay lugar en que no te hayas prostituido. Junto al camino te sentabas para esperar, como la mujer árabe en el desierto, y manchaste tu país con tus prostituciones y tus crímenes."
,"3":"Por eso, los aguaceros cesaron y no hubo más lluvia para ti en la primavera, pero tu rostro de mujer perdida ni siquiera ha enrojecido."
,"4":"Mas aún me llamabas: 'Padre mío, tú, el amigo de mi juventud, ¿tendrás rencor para siempre? ¿Durará eternamente tu cólera?'"
,"5":"Así hablabas, y proseguías feliz cometiendo tus maldades."
,"6":"Yavé me dijo, cuando era rey Josías: '¿Has visto lo que ha hecho la infiel de Israel? Se ha entregado en cualquier cerro alto y bajo cualquier árbol verde."
,"7":"Y yo me decía: Después de todo lo hecho, volverá a mí; pero no volvió."
,"8":"Todo esto lo vio Judá, su perversa hermana; vio cómo yo me separaba de la infiel Israel, dándole el certificado de divorcio por todas sus traiciones; pero ni siquiera se ha asustado, y ha salido también a ejercer la prostitución."
,"9":"Su conducta descarada ha sido una deshonra para todo el país, pues ella también pecó con dioses de piedra y de madera."
,"10":"Y después de todo eso, Judá la pérfida, no ha vuelto a mí sinceramente, sino con engaños.'"
,"11":"Y Yavé continuó: 'Por eso, la rebelde Israel es mucho mejor que esta pérfida Judá.'"
,"12":"Sal a gritar estas palabras, al norte: 'Vuelve, Israel infiel, dice Yavé. No me enojaré con ustedes, porque soy bueno, ni les guardaré rencor."
,"13":"Unicamente reconoce que eres culpable, que has traicionado a Yavé, tu Dios; has vendido tu amor a los extranjeros y no has escuchado mi voz.'"
,"14":"Vuelvan, hijos rebeldes, dice Yavé, porque yo soy su Dueño. Elegiré de ustedes a uno de esa ciudad y dos de aquella familia y los introduciré en Sión."
,"15":"Les pondré pastores según mi corazón, que los alimenten con inteligencia y prudencia."
,"16":"Y cuando ustedes sean muchos y prosperen en el país, ya no se hablará más del Arca de la Alianza de Yavé, ni pensarán más en ella, ni la recordarán más, ni la echarán de menos, ni la harán de nuevo."
,"17":"Entonces llamarán a Jerusalén 'el trono de Yavé' y a su alrededor se juntarán todas las naciones, sin seguir más la dureza de sus malos corazones."
,"18":"Por ese mismo tiempo los hijos de Judá y los de Israel harán el camino juntos desde las tierras del norte a la tierra que di en herencia a sus padres."
,"19":"Y yo pensaba: '¡Cómo quisiera contarte entre mis hijos, darte como herencia un país maravilloso, que sobresalga entre todas las naciones!' Y añadí: 'Me llamarás 'Padre mío' y nunca más te apartarás de mí."
,"20":"Sin embargo, así como una mujer traiciona a su amante, así me ha engañado la gente de Israel.'"
,"21":"Sobre las lomas peladas se oyen unos gritos, son las súplicas llenas de lágrimas de los hijos de Israel porque perdieron el camino, olvidándose de Yavé, su Dios."
,"22":"'¡Vuelvan, hijos rebeldes, que los voy a sanar de su rebelión!','Aquí estamos de vuelta junto a ti, porque tú eres Yavé, nuestro Dios. "
,"23":"Realmente de nada sirven los templos en las lomas y las fiestas en los montes. Sólo Yavé, nuestro Dios, es quien salva a Israel."
,"24":"El dios infame se comió el fruto del trabajo de nuestros padres desde nuestra juventud, sus ovejas y sus vacas, sus hijos e hijas."
,"25":"¡Acostémonos en nuestra vergüenza y que nos cubra nuestra propia confusión! Porque nuestros padres, y nosotros desde nuestra juventud, hemos pecado contra Yavé, nuestro Dios, y no hemos escuchado su voz.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Si tú quieres volver, oh Israel, dice Yavé, si quieres convertirte a mí, si alejas de mi vista tus sucios ídolos, ya no tendrás más que esconderte de mí."
,"2":"Si juras por la vida de Yavé, con verdad, con derecho y con justicia, entonces tú serás para las naciones una bendición, y serás su gloria."
,"3":"Porque así habla Yavé a los hombres de Judá y de Jerusalén: 'Aren profundamente sus campos para que no siembren en la maleza."
,"4":"¡Oh habitantes de Judá y de Jerusalén, circuncídense por Yavé y purifiquen sus corazones, no sea que mi ira se propague como el fuego y arda, sin que nadie pueda apagarla, a causa de sus malas acciones!'"
,"5":"Publíquenlo en Judá,y que se oiga en Jerusalén. Toquen la trompeta en todo el país; griten a voz en cuello y digan: 'Juntémonos y entremos en las ciudades fortificadas."
,"6":"Icen banderas como señales hacia el lado de Sión. ¡Huyan, no se paren!',Pues yo traigo del norte la desgracia,y una catástrofe inmensa."
,"7":"El león, que devora las naciones, se ha levantado de su madriguera,y se ha puesto en marcha, abandonando su morada, para dejar tu tierra como un desierto, tus ciudades destruidas y sin habitantes."
,"8":"Por eso, vístanse con sacos, lloren y aúllen, porque Yavé no aparta de nosotros,su ardiente cólera."
,"9":"Ese día, dice Yavé, desfallecerá el corazón del rey y de los jefes; los sacerdotes temblarán de miedo, y los profetas, de espanto."
,"10":"Y dirán: '¡Ah, Señor Yavé! ¡Mira cómo nos has engañado, cuando afirmabas: Ustedes vivirán en paz; mientras que ahora estamos con la espada al cuello!'"
,"11":"En ese tiempo dirán a este pueblo y a Jerusalén: 'Un viento que quema y que no sirve para separar la paja del grano, sopla desde el desierto hacia la hija de mi pueblo.'"
,"12":"'Es un viento amenazante que les mando. Pues bien, ahora soy yo el que va a hablar y pronunciar sentencia contra ellos'."
,"13":"'Miren cómo el destructor se levanta como las nubes, sus carros parecen un huracán,y sus caballos son más rápidos que las águilas. ¡Pobres de nosotros, estamos perdidos!'"
,"14":"'Limpia tu corazón del mal, Jerusalén, para que puedas salvarte. ¿O acaso piensas seguir con tus perversos pensamientos?'"
,"15":"Lanzan la voz de alarma desde Dan y anuncian la mala noticia desde los cerros de Efraím:"
,"16":"'Que todos sepan, en Judá y en Jerusalén, que los enemigos ya están aquí.' Vienen de un lejano país y gritan contra las ciudades de Judá,"
,"17":"rodean a Jerusalén como los que cuidan una propiedad, porque se rebeló contra mí, dice Yavé."
,"18":"Todo esto te mereces por tu mala conducta y por tus fechorías. Que se te parta el corazón de pena porque te rebelaste contra mí."
,"19":"'¡Ay, qué dolores en todo mi interior, me duele el corazón! Me palpita tan fuerte que no puedo callarme. ¿No oyes, alma mía, el toque del clarín y el estruendo de la guerra?"
,"20":"Las derrotas se suceden una tras otra, el país va quedando desierto. En un abrir y cerrar de ojos, fueron arrebatados mis pabellones y mis carpas."
,"21":"¿Hasta cuándo tendré que ver estandartes guerreros, y soportar el sonido del clarín?'"
,"22":"Esto te pasa porque eres un pueblo estúpido que no me conoce. Ustedes son hijos tontos y sin inteligencia que saben hacer el mal pero no el bien.'"
,"23":"Miré a la tierra, pero estaba vacía y llena de confusión. Miré a los cielos, y eran sólo tinieblas."
,"24":"Miré a los montes, y temblaban; a los cerros, y se sacudían."
,"25":"Miré y me di cuenta que no había un alma, y que todos los pájaros del cielo se habían ido."
,"26":"Miré los campos floridos, pero estaban secos, y todas las ciudades habían sido destruidas por Yavé y por el ardor de su cólera."
,"27":"Pues bien, así habla Yavé: 'Todo el país será destruido, pero no les daré el golpe de gracia."
,"28":"Por eso, la tierra se viste de luto y los cielos se oscurecen, porque yo lo he dicho y no me arrepentiré; lo he resuelto y no me volveré atrás.'"
,"29":"Al ruido de la caballería y de los arqueros,todo el mundo ha huido, escondiéndose en los bosques,o trepando por las rocas. Los habitantes dejan sus ciudades, sin que nadie quede en ellas."
,"30":"'Y tú, la devastada, ¿qué vas a hacer?,Aunque te pongas vestidos de púrpura, te adornes con joyas de oro,y te pintes con lápiz los ojos, en vano te estás haciendo bonita, pues no les interesa a tus amantes,y sólo buscan quitarte la vida.'"
,"31":"Oigo gritos como los de una mujer que da a luz por primera vez; la hija de Sión está gimiendo y extiende sus manos: '¡Ay de mí, que voy a sucumbir bajo los golpes de los asesinos!'"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Recorran las calles de Jerusalén, miren bien e infórmense. Busquen por las plazas, a ver si encuentran a un hombre, uno siquiera, que practique la justicia y busque la verdad, y perdonaré a esta ciudad. '¿Tus ojos, Yavé, no buscan acaso la verdad? "
,"2":"Sin embargo, cuando dicen 'Por la vida de Yavé', están, en realidad, jurando en falso."
,"3":"Les has herido, pero no han sentido; los has aplastado, pero no han querido aprender la lección. Han endurecido su frente como una roca y se han negado a convertirse."
,"4":"Yo me decía: 'Sólo la gente ordinaria es irresponsable, porque no conocen el camino de Yavé ni el derecho de su Dios."
,"5":"Iré ver a los jefes y les hablaré, pues éstos conocen el camino de Yavé y el derecho de su Dios.' Pues bien, todos juntos habían quebrado el yugo y roto las correas."
,"6":"Por esto, el león de la selva los ataca, el lobo de las estepas los destroza y la pantera está acechando a la puerta de sus ciudades, lista para despedazar al que salga, porque son muchos sus pecados y numerosas sus rebeldías."
,"7":"¿Cómo te voy a perdonar? Tus hijos me han abandonado tomando por Dios a los que no lo son. Cuando cuidaba que nada les faltara, ellos se entregaron al adulterio. Juntos acudían a la casa de las prostitutas."
,"8":"Son potros satisfechos y lozanos que relinchan por la mujer de su prójimo."
,"9":"¿Y no voy a castigar tales acciones? ¿No he de vengarme de una nación como ésta? Así, dice Yavé:"
,"10":"Vengan, naciones, y escalen las murallas de mi pueblo, destruyan, pero no terminen con mi viña, córtenle esos sarmientos, ya que no son los que plantó Yavé."
,"11":"Realmente, harto me han traicionado, tanto la gente de Judá,como la de Israel, palabra de Yavé."
,"12":"Renegaron de Yavé, diciendo: '¡No existe! Nada malo nos sucederá, no veremos ni espada ni escasez."
,"13":"¿Los profetas? Que se los lleve el viento, nadie los envía o les encarga un mensaje, que sus amenazas se vuelvan contra ellos.'"
,"14":"Pero así me habla Yavé: 'Puesto que esa gente se expresa así,yo pongo en tu boca palabras de fuego, y esta gente será leña que el fuego devorará.'"
,"15":"Gente de Israel, Yavé les habla: Estoy trayendo de muy lejos una nación contra ustedes. Es una nación invencible y muy antigua, cuyo idioma desconoces."
,"16":"Son arqueros certeros, todos ellos valientes,"
,"17":"ellos comerán tu cosecha y tu pan, devorarán a tus hijos y a tus hijas, se comerán tus carneros y tus vacas, tus viñas y tus higos, destruirán tus plazas fuertes,en las que tanto confías."
,"18":"Sin embargo, dice Yavé, ni siquiera en aquellos días los voy a destruir completamente,"
,"19":"y cuando pregunten: '¿Por qué Yavé, nuestro Dios, ha hecho todo esto con nosotros?', les dirás: 'Así como me dejaron para adorar, en el país de ustedes, a dioses extraños, de la misma manera tendrán que servir a extranjeros en una tierra que no es la de ustedes.'"
,"20":"Comuniquen esto a la familia de Jacob,y que lo escuche la gente de Judá:"
,"21":"'Oye pueblo estúpido y tonto, que tienes ojos y no ves, orejas y no oyes.'"
,"22":"¿A mí no me temen, dice Yavé, ni tiemblan delante de mí?,De mí, que puse la arena para atajar el mar, como una cerca eterna que no puede saltar. Aunque se agite bramando, no podrá pasarla con sus olas."
,"23":"Pero este pueblo, cuyo corazón es traidor y rebelde, me ha vuelto la espalda y se ha marchado,"
,"24":"sin que se les ocurriera decir: 'Temamos a Yavé, nuestro Dios, que nos manda lluvia, en otoño y en primavera, y nos concede el tiempo justo para cosechar.'"
,"25":"Sus crímenes y pecados han creado el desorden, privándoles a ustedes de esos bienes."
,"26":"En mi pueblo, hay malhechores,que colocan trampas como para pillar pájaros, pero cazan hombres."
,"27":"Sus casas están repletas con el botín de sus saqueos, como una jaula llena de pájaros, y se han hecho importantes y ricos,"
,"28":"Se ven gordos y macizos,y ya no saben distinguir el mal. Nada tiene de justo su justicia, no respetan el derecho de los huérfanos,ni defienden la causa de los pobres."
,"29":"¿Y yo no pediría cuentas?, dice Yavé, ¿No me vengaría de una nación como ésta?"
,"30":"Algo espantoso y horrible está pasando en este país:"
,"31":"Los profetas anuncian mentiras, los sacerdotes buscan el dinero,y todo esto le gusta a mi pueblo. ¿Qué harán ustedes, cuando llegue el fin?"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Salgan de Jerusalén, a refugiarse, hijos de Benjamín. Que resuene la trompeta en Tecoa; coloquen una señal en Betqueren, pues por el Norte se asoma una desgracia,como una inmensa catástrofe."
,"2":"No te comparabas con una deliciosa pradera, hija de Sión;"
,"3":"pues bien, hasta ti han llegado unos pastores con sus rebaños. Han instalado sus carpas a tu alrededor y cada uno da, allí, pasto a sus ovejas."
,"4":"Declárenle la guerra: ¡Ea, ataquemos al mediodía!,Qué mala suerte la nuestra, pues el día ya se acaba,y la tarde extiende sus sombras."
,"5":"No importa, volvamos a atacar de noche,y destruyamos sus fuertes."
,"6":"Pues así habla Yavé, el Dios de los Ejércitos: 'Corten árboles y construyan un terraplén frente a Jerusalén, porque es una ciudad mentirosa y en ella no hay más que opresión."
,"7":"Como se saca agua de un pozo, así brota de ella la maldad. Allí sólo se oye hablar de violencia e injusticia, y mis ojos están siempre viendo los golpes y el mal trato.'"
,"8":"Hazme caso, Jerusalén, si no quieres que me aleje de ti y te conviertas en un desierto, en una tierra deshabitada."
,"9":"Así dice Yavé: 'Busquen y rebusquen como en una viña lo que queda de Israel; vuelvan a pasar su mano, como lo hace el vendimiador, por los sarmientos.'"
,"10":"¿A quién hablaré y tomaré como testigo para que escuchen? A sus oídos les hace falta una circuncisión, y no pueden entender. La palabra de Yavé les causa risa y no les gusta."
,"11":"'¡Pero yo estoy lleno de la ira de Yavé y no la aguanto más!','Derrámala entonces sobre los niños de la calle y sobre los grupos de muchachos. Les va a llegar a todos, al marido y a la mujer, al anciano y al hombre lleno de vida. "
,"12":"Sus casas pasarán a otros, junto con sus campos y sus mujeres, cuando yo extienda mi mano sobre los habitantes de esta tierra, dice Yavé."
,"13":"Pues desde el más chico al más grande, todos andan buscando su propio provecho, y desde el sacerdote hasta el profeta son todos unos embusteros."
,"14":"Calman sólo a medias la aflicción de mi pueblo, diciendo: 'Paz, paz', siendo que no hay paz."
,"15":"Deberían avergonzarse de sus abominables acciones, pero han perdido la vergüenza y ni siquiera se ponen colorados. Por eso, caerán junto con los demás y se irán al suelo cuando los visite, declara Yavé."
,"16":"Así dice Yavé: 'Vuelvan al punto de partida y pregunten por los viejos senderos: ¿Cuál era el camino del bien? Síganlo y encontrarán la tranquilidad.',Pero respondieron: '¡No queremos ir por ahí!'"
,"17":"Les puse entonces centinelas: '¡Estén atentos cuando toquen la trompeta!' Y también contestaron: 'No queremos atender.'"
,"18":"Pues bien, que todas las naciones oigan y sepan lo que voy a hacer con ellos:"
,"19":"Escucha, tierra, mira el castigo que voy a dar a este pueblo como fruto de su rebelión, pues no quisieron hacerme caso cuando les hablaba, y despreciaron mi Ley."
,"20":"¿Qué me importa a mí el incienso importado de Saba y la canela fina que viene de un país lejano? Ya no me gustan los holocaustos que ustedes hacen, y sus sacrificios me caen mal."
,"21":"Por eso, así habla Yavé: 'Voy a poner, por donde pase este pueblo, piedras, para que todos se caigan: padres e hijos, vecinos y amigos, perecerán juntos.'"
,"22":"Así habla Yavé: 'Un pueblo viene del norte, una gran nación se ha puesto en marcha desde lo más lejano de la tierra."
,"23":"Llevan arcos y espadas, son crueles e inhumanos; avanzan como las olas del mar rugiente, montados a caballo, ordenados como un solo hombre para atacarte, hija de Sión.'"
,"24":"Hemos oído la noticia y se nos caen los brazos; la angustia y un dolor como de mujer que da a luz, nos asalta:"
,"25":"'No salgan al campo, ni anden por los caminos, porque allí está la espada del enemigo: ¡terror por todos los lados!'"
,"26":"Hija de mi pueblo, vístete con sacos, revuélcate en la ceniza, colócate luto como por un hijo único, llora amargamente, porque de repente cae sobre nosotros el que nos va a destruir."
,"27":"Yo quiero que pases mi pueblo al crisol, que veas y examines su conducta."
,"28":"Pues son todos unos rebeldes y calumniadores; todo lo echan a perder."
,"29":"El fundidor dio tan fuerte con el fuelle que el plomo se consumió, pero inútilmente trabajó, pues la escoria no se desprendió."
,"30":"Serán llamados, en consecuencia, 'plata de desecho', porque Yavé los arrojó."
}`)
	CurrentBook.AddChapter(7, `{
"1":"A Jeremías le llegó esta palabra de Yavé:"
,"2":"'Párate en la puerta de la Casa de Yavé y publica allí esta palabra: Escuchen, hombres de Judá, que entran por esta puerta a adorar a Yavé."
,"3":"Así habla Yavé, Dios de Israel: Mejoren su proceder y sus obras, y yo me quedaré con ustedes en este lugar. "
,"4":"No confíen en palabras mentirosas como éstas: ¡Miren el Templo de Yavé!, ¡aquí está el Templo de Yavé!, ¡éste es el Templo de Yavé!"
,"5":"Más bien mejoren su proceder y sus obras y hagan justicia a todos."
,"6":"Dejen de oprimir al extranjero, al huérfano y a la viuda. No manchen este lugar con sangre de gente asesinada. No vayan en pos de otros dioses, para desgracia de ustedes."
,"7":"Yo, entonces, los mantendré en este lugar, en el país que di a sus padres desde hace tiempo y para siempre."
,"8":"Pero ustedes se fían de palabras engañosas e inútiles."
,"9":"Ustedes roban, matan, toman la esposa del prójimo, juran en falso u ofrecen sacrificios a otros dioses, que no son de ustedes..."
,"10":"Y luego vienen a presentarse ante mí, en este Templo que lleva mi Nombre, y dicen: '¡Aquí estaremos seguros después de cometer tantas maldades!'"
,"11":"¿Será un refugio de ladrones esta casa mía sobre la cual descansa mi Nombre?"
,"12":"Es así como la ven ustedes, pero yo también he visto. Vayan, pues, al santuario de Silo, donde quise que descansara mi Nombre en tiempos pasados, y miren cómo lo traté por los crímenes de mi pueblo Israel."
,"13":"Ustedes siguen cometiendo todas estas maldades que acabo de decir, y por más que se lo advertí no me han escuchado; hablé y no me hicieron caso."
,"14":"Ahora, pues, lo que hice en Silo, también lo haré con esta Casa que lleva mi Nombre y por la que se sienten seguros. Lo mismo haré con este lugar que yo di a sus padres,"
,"15":"y los arrojaré lejos de mi presencia, como arrojé a sus hermanos del norte, a toda la gente de Efraím."
,"16":"Y tú no pidas por este pueblo ni eleves por ellos súplicas ni oraciones, ni me insistas más, porque no te escucharé."
,"17":"¿Es que no ves lo que ellos hacen en las ciudades de Judá y en las calles de Jerusalén?"
,"18":"Los hijos amontonan la leña, los padres encienden el fuego y las mujeres amasan para hacer tortas a la reina del cielo. Y luego derraman vino en honor de dioses extranjeros, para así ofenderme."
,"19":"Pero, ¿es a mí, acaso, a quien rebajan con eso, dice Yavé? ¿No es más bien a ellos mismos, para su propia deshonra?"
,"20":"Por eso, así habla Yavé: 'Mi cólera y mi furor se van a desencadenar sobre este lugar, sobre los hombres y los animales, sobre los árboles del campo y los frutos de la tierra, y arderá sin apagarse.'"
,"21":"Así habla Yavé de los Ejércitos, el Dios de Israel: '¡Añadan ustedes, no más, los holocaustos a los sacrificios y coman después la carne!"
,"22":"Que cuando yo saqué a sus padres de Egipto, no les hablé ni les ordené nada referente a sacrificios y holocaustos."
,"23":"Lo que les mandé, más bien, fue esto: 'Escuchen mi voz, y yo seré su Dios y ustedes serán mi pueblo. Caminen por el camino que les indiqué para que siempre les vaya bien.'"
,"24":"Pero ellos no me escucharon ni me hicieron caso, sino que siguieron la inclinación de su corazón malvado, me dieron la espalda y me volvieron la cara."
,"25":"Desde el día en que saqué a sus padres de Egipto hasta el día de hoy les he mandado continuamente a mis servidores, los profetas."
,"26":"Pero tampoco ustedes me oyeron ni me hicieron caso, y, endureciendo su cabeza, se portaron peor que ellos."
,"27":"Puedes decirles todo esto, pero se harán los sordos. Puedes llamarlos, pero no te responderán."
,"28":"Diles, entonces, esto: Esta es la nación que no ha escuchado la voz de Yavé, su Dios, ni ha querido aprender. La fidelidad ha muerto, ha desaparecido de su boca."
,"29":"Córtate tus cabellos largos y tíralos. Entona sobre los cerros pelados una lamentación. Porque Yavé ha despreciado y rechazado a esta generación a la que aborrece.'"
,"30":"'Sí, los hijos de Judá han hecho lo que a mí no me gusta, dice Yavé. Han instalado sus ídolos en el templo, que lleva mi Nombre, para profanarlo;"
,"31":"han construido los santuarios de Lomas de Tofet, en el valle de Ben-Hinón, para quemar en el fuego a sus hijos y a sus hijas, cosa que yo no les ordené ni se me ocurrió jamás.'"
,"32":"'Por eso, se acerca el tiempo, dice Yavé, en que no se hablará más de Tofet ni del valle de Ben-Hinón, sino del Valle de la Matanza. Y se enterrará a la gente en Tofet, porque no habrá otro lugar,"
,"33":"y sus cadáveres servirán de comida a las aves de rapiña y a las fieras salvajes, sin que nadie las espante."
,"34":"Suspenderé en las ciudades de Judá y en las calles de Jerusalén toda manifestación de gozo y de alegría, los cantos del novio y de la novia, porque el país sólo será un desierto.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"En ese tiempo, dice Yavé, sacarán de sus tumbas los huesos de los reyes de Judá; los de los príncipes, los de los sacerdotes, los de los profetas y los de los habitantes de Jerusalén."
,"2":"Los expondrán al sol, a la luna y a todo el ejército del cielo, a quienes amaron y sirvieron, a quienes siguieron, consultaron y adoraron. No serán recogidos para ser enterrados de nuevo, sino que quedarán como abono por el suelo."
,"3":"La muerte valdrá más que la vida para los sobrevivientes de esta raza perversa en cualquier parte donde los haya echado, dice Yavé de los Ejércitos."
,"4":"'Les dirás: Así dice Yavé: ¿Acaso el que cae no se levanta, y el que se ha perdido de camino, no vuelve atrás?"
,"5":"Pues, ¿por qué este pueblo sigue en su rebeldía, sin querer ceder? Se aferran fuertemente a la mentira y se niegan a convertirse."
,"6":"Ven y oyen, pero hablan otro lenguaje y nadie llora su maldad, diciendo: '¿Qué es lo que he hecho?' Todos prosiguen su loca carrera como un caballo que se lanza a la carga."
,"7":"Hasta la cigüeña, en el cielo, conoce su estación; la tórtola, la golondrina y la grulla saben la época de sus migraciones. ¡Pero mi pueblo ignora el derecho de Yavé!'"
,"8":"¿Cómo pueden ustedes decir: 'Somos sabios y poseemos la Ley de Yavé?' Cuando es bien cierto que la ha cambiado en mentira la pluma falaz de los escribientes."
,"9":"Los sabios pasarán vergüenza, serán confundidos y caerán en la trampa. Como despreciaron la palabra de Yavé, ¿qué les queda ahora como sabiduría?"
,"10":"Así, que yo daré sus mujeres a otros, sus campos a nuevos propietarios. Pues desde el más chico hasta el más grande, andan todos buscando su provecho; y desde el profeta hasta el sacerdote todos se dedican a engañar."
,"11":"Curan sólo por encima la herida de la hija de mi pueblo, diciendo: '¡Paz, paz!' siendo que no hay paz."
,"12":"Deberían avergonzarse de sus actos abominables, pero ya no conocen la vergüenza ni se ponen rojos. Por eso, caerán junto con los demás y tropezarán cuando los visite, dice Yavé."
,"13":"Yo me llevaré a todos, dice Yavé: no quedarán racimos en la parra, ni higos en la higuera, y aun las hojas estarán secas."
,"14":"'¿Por qué nos quedamos parados? Juntémonos, entremos en nuestras ciudades fortificadas para morir allí, pues Yavé, nuestro Dios, nos entrega a la muerte y nos da para tomar agua envenenada, porque hemos pecado contra él."
,"15":"Esperábamos la paz, y ninguna cosa buena ha llegado; el tiempo de la curación, y se presenta el miedo."
,"16":"Desde Dan se siente el resuello de sus caballos; al relincho sonoro de sus corceles, toda la tierra tiembla. Vienen a comerse el país y sus bienes, la ciudad y sus habitantes.'"
,"17":"Voy a mandarles a ustedes serpientes venenosas, contra las que no exista encantamiento; que los morderán sin remedio, dice Yavé."
,"18":"El dolor se apodera de mí, el corazón me está fallando."
,"19":"El grito de angustia de la hija de mi pueblo se siente a lo largo de todo el país: '¿Ya no está Yavé en Sión?, ¿su Rey ya no está allí?','¿Por qué me han irritado con sus ídolos, con esas cosas extranjeras, que nada son?'"
,"20":"Pasó la siega y se acabó el verano, pero nosotros no hemos sido salvados."
,"21":"La herida de la hija de mi pueblo ha pasado a ser la mía, me siento abatido y espantado."
,"22":"¿No hay, acaso, bálsamo en Galaad ni queda allí ningún médico? ¿Cómo es, pues, que no mejora la salud de la hija de mi pueblo?"
,"23":"¡Quién pudiera cambiar mi cabeza en una vertiente y que de mis ojos brotara un arroyo de lágrimas, para así llorar, día y noche, los muertos de la hija de mi pueblo!"
}`)
	CurrentBook.AddChapter(9, `{
"1":"¿Quién me diera, en el desierto, una posada de viajeros, para dejar a mi pueblo e irme lejos de ellos?,Porque son todos unos adúlteros, una pandilla de traidores."
,"2":"Estiran su lengua como un arco; es la mentira y no la verdad,lo que prevalece en este país. Sí, van de crimen en crimen. ¡Y a Yavé no lo conocen!"
,"3":"Que cada uno desconfíe de su amigo,y que no tenga confianza ni en su hermano, porque el hermano sólo piensa en suplantar al otro,y el amigo anda levantando calumnias."
,"4":"Se engañan unos a otros, nunca dicen la verdad, su lengua está acostumbrada a mentir, y no pueden convertirse."
,"5":"Viven en la mentira,y la mentira les impide conocerme."
,"6":"Por eso, así habla Yavé de los Ejércitos: 'Voy a probarlos en el fuego del crisol, ¿qué otra cosa puedo hacer con la hija de mi pueblo?"
,"7":"Su lengua es una flecha que mata, diciendo mentiras; le desean al prójimo la paz, pero, en su corazón, le preparan una trampa."
,"8":"¿Y no he de castigarles yo por estas cosas?, dice Yavé. ¿De gente como ésta, no me vengaré?'"
,"9":"Lancen por los montes gemidos y lamentos, y un canto fúnebre por el pasto del desierto, porque ha sido quemado, y nadie pasa por allí, ni se oyen los mugidos del ganado. Desde los pájaros del cielo hasta las bestias, todas han huido, han desaparecido."
,"10":"'Voy a hacer de Jerusalén un montón de piedras, una guarida de chacales, y de las ciudades de Judá, un desierto donde nadie viva.'"
,"11":"¿Quién es bastante sabio para comprender estos acontecimientos? ¿A quién se lo ha dicho la boca de Yavé para que lo publique? ¿Por qué el país está perdido, incendiado como el desierto, por donde nadie pasa?"
,"12":"Yavé lo ha dicho: Es que han abandonado mi Ley, que les había dado; no han oído mi voz ni la han seguido,"
,"13":"sino que, yendo tras la inclinación de su duro corazón se han marchado con los baales, que sus padres les enseñaron."
,"14":"Por eso, así dice Yavé de los Ejércitos, Dios de Israel: 'Yo daré de comer ajenjo a este pueblo y les voy a dar de beber agua envenenada."
,"15":"Los desparramaré entre las naciones que no conocieron ni ellos ni sus padres, y detrás de ellos enviaré la espada hasta acabar con todos.'"
,"16":"¡Oigan! ¡Llamen a las lloronas, que vengan!,¡Busquen a las más peritas y que vengan!"
,"17":"Que se apresuren en entonarnos una canción fúnebre. Dejen que lloren nuestros ojos,y que derramen llanto nuestros párpados."
,"18":"Sí, una queja llega desde Sión: '¡Ah, qué arruinados,y avergonzados estamos!,Tener que abandonar la patria,y ver nuestras casas destruidas.'"
,"19":"Ustedes, mujeres, escuchen la palabra de Yavé, reciban sus oídos la palabra de su boca, enseñen a sus hijas este canto fúnebre, y, unas a otras, esta lamentación:"
,"20":"'La muerte ha trepado por nuestras ventanas,y ha entrado en nuestros palacios; ha segado al niño en la calle, a los jóvenes en la plaza."
,"21":"Los cadáveres humanos yacen,como guano por el campo, como gavillas tras el segador, sin que haya nadie que los recoja.'"
,"22":"Así dice Yavé: 'Que no se alabe el sabio por su sabiduría, ni el valiente por su valentía, ni el rico por su riqueza."
,"23":"Quien quiera alabarse, que busque su alabanza en esto: en tener inteligencia y conocerme. Yo soy Yavé, y mi obrar en la tierra no es más que bondad, rectitud y justicia. Estas son las cosas que me gustan, palabra de Yavé."
,"24":"Se acerca el tiempo, dice Yavé, en que castigaré a los circuncidados junto con los que no lo son:"
,"25":"a Egipto, Judá, Edom, los hijos de Ammón, Moab, y a todos los árabes que se afeitan las sienes y que viven en el desierto. Pues todos estos pueblos no son circuncidados, y la gente de Israel no ha circuncidado su corazón."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Escucha lo que dice Yavé, pueblo de Israel."
,"2":"Así habla Yavé: 'No se acostumbren al proceder de los paganos ni teman las señales del cielo, aunque a ellos les asusten. "
,"3":"Porque el Dios Terrible de los pueblos es pura nada. Es un palo cortado en un bosque, labrado con azuela por las manos del maestro"
,"4":"y luego adornado con plata y oro,"
,"9":"con láminas de plata importada de Tarsis y con oro de Ofir; hechura del escultor y de las manos del platero, todos ellos son únicamente obras de artistas. Los visten de púrpura violeta y roja y los sujetan con clavos, a golpes de martillo, para que no se muevan."
,"5":"Sus ídolos son como un espantapájaros en un sandial, que no hablan; y tienen que ser transportados, pues no pueden andar. No les tengan miedo, que no pueden hacer ni el mal ni el bien."
,"6":"¡No hay como tú, Yavé; tú eres grande, y grande es tu Nombre poderoso!"
,"7":"¿Quién no te temerá, Rey de las naciones? Sí, a ti se te debe temer, porque entre todos los sabios de las naciones y entre todos sus reinos no hay nadie como tú."
,"8":"Todos ellos son bestias y estúpidos, pues sus ídolos demuestran su necedad."
,"10":"Pero Yavé es el verdadero Dios, el Dios viviente, el Rey eterno. Cuando se enoja, tiembla la tierra, y las naciones no pueden aguantar su cólera."
,"11":"Así hablarán ustedes de ellos: 'Los dioses que no hicieron ni el cielo ni la tierra, desaparecerán de la tierra y de debajo del cielo.'"
,"12":"El hizo la tierra con su poder, estableció el mundo con su sabiduría y con su inteligencia extendió los cielos."
,"13":"Cuando él levanta su voz, se amontonan las aguas en los cielos; llama las nubes desde los extremos de la tierra, hace brillar relámpagos en el aguacero y saca de sus depósitos el viento."
,"14":"Así queda descalificada la sabiduría de los mortales. El platero debería avergonzarse de su ídolo, porque sus estatuas no son más que mentira, que nunca respiran."
,"15":"Son tonterías, obras ridículas, que serán juzgadas y desaparecerán."
,"16":"No es así Aquel que es la herencia de Jacob, pues él ha formado el universo, e Israel es su tribu heredera, su nombre es Yavé de los Ejércitos."
,"17":"Prepara tus maletas y sal del país, tú que estás rodeada de sitiadores."
,"18":"Pues así habla Yavé: 'Voy a lanzar muy lejos a los habitantes del país y los haré perseguir de manera que los alcancen.'"
,"19":"¡Pobre de mí! ¡Qué herida! Mi llaga es incurable. Y yo que decía: 'Es un sufrimiento que se puede aguantar."
,"20":"Pero ahora mi carpa está destruida y todos sus cordeles cortados. Mis hijos me han abandonado, no queda ninguno. Ya no hay nadie que pueda levantar mi carpa o extender mis toldos.'"
,"21":"Es que los pastores han sido estúpidos, no han buscado a Yavé, por esto les fue mal y todo su rebaño fue dispersado."
,"22":"Oigan esta noticia. ¡Atiendan! El ruido de una gran muchedumbre se acerca desde el norte, vienen a reducir las ciudades de Judá en un desierto, guarida de chacales."
,"23":"Tú sabes, Yavé, que el hombre no es dueño de su camino, y mientras camina no está seguro de sus pasos."
,"24":"Corrígenos, Yavé, pero con prudencia, sin enojarte, no sea que desaparezcamos."
,"25":"Derrama tu enojo sobre las naciones que no te conocen, sobre los pueblos que no han invocado tu Nombre. Mira cómo están devorando a Jacob y se lo comen hasta terminarlo. Ya le han arruinado su casa."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Palabras que dirigió Yavé a Jeremías:"
,"2":"'Habla a los hombres de Jerusalén"
,"3":"y diles: Así habla Yavé, Dios de Israel: Maldito el hombre que no escuche las palabras de esta alianza,"
,"4":"que yo impuse a los padres de ustedes el día en que los saqué de ese horno purificador que es Egipto. Les dije entonces: Oigan mi voz y actúen conforme a todo lo que les mando; y así serán mi pueblo y yo seré su Dios"
,"5":"y cumpliré el juramento que hice a sus padres de darles una tierra que mana leche y miel (como es el caso ahora).',Yo respondí: 'Sí, Yavé.'"
,"6":"Y Yavé me dijo: 'Publica este aviso en las ciudades de Judá y en las calles de Jerusalén: 'Escuchen las palabras de esta alianza y cúmplanlas."
,"7":"Pues constantemente les advertí a sus padres, y sin cesar se lo he repetido, desde que los hice subir de Egipto hasta el día de hoy: 'Escúchenme.'"
,"8":"Pero no me escucharon ni me hicieron caso, sino que cada uno siguió la inclinación de su corazón perverso. Entonces yo cumplí contra ellos todas las palabras de esta alianza que les había ordenado observar y no observaron.'"
,"9":"Y añadió Yavé: 'Se han puesto de acuerdo los hombres de Judá y los habitantes de Jerusalén"
,"10":"para volver a las maldades de sus mayores, que no quisieron escuchar mis palabras. También éstos se han ido tras dioses extranjeros para servirles. La casa de Israel y la de Judá han roto mi alianza que yo había pactado con sus padres."
,"11":"Por eso, así habla Yavé: Les voy a mandar una catástrofe de la cual nadie podrá escapar. Y aunque me pidan auxilio, no los ayudaré."
,"12":"¡Que vayan, entonces, las ciudades de Judá y los habitantes de Jerusalén a clamar a los dioses a los que quemaban incienso! Estos dioses no les darán ningún socorro cuando les pase la desgracia."
,"13":"¡Porque tan numerosos como tus ciudades son tus dioses, Judá! E igual al número de las calles de Jerusalén es la cantidad de altares que ustedes han levantado para ofrecer incienso a Baal."
,"14":"En cuanto a ti, no ruegues por este pueblo, ni eleves por él súplicas ni oraciones; porque no los voy a oír cuando me llamen en el momento de la desgracia.'"
,"15":"¿Qué viene a hacer mi amada en mi Casa? ¡Su manera de actuar es pura viveza! ¿Crees que los votos y las carnes consagradas te limpiarán de tu maldad o que te podré purificar por todo eso?"
,"16":"Olivo verde, hermoso por su fruto magnífico, éste era el nombre que te había puesto Yavé. Pero con gran estrépito, le prendió fuego a su follaje y se han quemado sus ramas."
,"17":"Y Yavé de los cielos, que te había plantado, te ha condenado a la desgracia, a causa del mal que se hizo a sí misma la gente de Israel y la de Judá por haber quemado incienso a Baal, haciendo que me enojara por esto."
,"18":"Yavé me dio un aviso que pude comprobar. Tú, Yavé, me abriste los ojos para que viera sus maniobras."
,"19":"¡Y yo que no tenía más sospecha que el cordero al que llevan tranquilo para matarlo! No sabía lo que estaban tramando para perderme: 'Hagámosle tragar unas buenas pruebas, hasta que desaparezca de entre los vivos, y nadie se acordará más de su nombre.'"
,"20":"Pero tú, Yavé de los Ejércitos, que pronuncias sentencias justas, conoces el corazón y las intenciones de los hombres; a ti he entregado mi causa y estaré presente cuando tú hagas justicia.'"
,"21":"Esta es la sentencia que ha pronunciado Yavé en contra de los hombres de Anatot, que me amenazaron de muerte y me dijeron: 'Deja de hacerte el profeta de Yavé, y te perdonaremos la vida.'"
,"22":"Yavé dice: 'Por eso, les pediré cuentas. Sus jóvenes serán muertos a espada; sus hijos y sus hijas perecerán de hambre."
,"23":"No podrán salvarse los hombres de Anatot el año que les pida cuentas y les mande la desgracia.'"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Yavé, tú tienes siempre la razón cuando yo hablo contigo, y, sin embargo, hay un punto que quiero discutir: ¿Por qué tienen suerte los malos y son felices los traidores?"
,"2":"Los plantas en esta tierra y en seguida echan raíces, crecen y dan frutos, a pesar de que te honran con puras palabras y estás lejos de sus corazones."
,"3":"En cambio, a mí me conoces, Yavé; me has visto y has comprobado que mi corazón está contigo. Llévatelos como ovejas al matadero y señálalos para el día de la matanza."
,"4":"¿Hasta cuándo estará de luto el país? ¿Permanecerá seco el pasto de los campos? Aves y bestias ya han perecido por causa de la maldad de los hombres, pues ellos dicen: 'Dios no ve nuestra conducta.'"
,"5":"'Si te cansa correr con los de a pie, ¿cómo competirás con los de a caballo? Si en país tranquilo no te sientes seguro, ¿qué harás en los bosques del Jordán?'"
,"6":"'Cuídate, me dijiste, pues hasta tus hermanos y tus familiares te traicionan y te critican abiertamente por detrás de ti. No confíes en sus buenas palabras.'"
,"7":"Abandoné mi casa, dejé mi propiedad, he entregado lo que más quería,en manos de mis enemigos."
,"8":"Los míos se han portado conmigo,como un león de la selva, que ha lanzado contra mí sus rugidos; por eso, les tengo rencor."
,"9":"¿Será acaso mi pueblo un buitre de plumaje feo, para que todos los demás se lancen contra él?,¡Ea, júntense ustedes, fieras salvajes, vayan a devorar!"
,"10":"Muchos pastores han saqueado mi viña, han pisoteado mi propiedad,y han convertido mi campo, que tanto quería, en un potrero sin pasto. Lo han dejado hecho una lástima, sin nada de vegetación."
,"11":"¡El país está totalmente destruido,y nadie se conmueve por eso!"
,"12":"Los saqueadores han subido,a todas las alturas peladas del desierto, pues Yavé tiene una espada que devora,de un extremo al otro del país,y nadie se salvará."
,"13":"Sembraron trigo, y cosecharon espinas: se han cansado inútilmente. Les da vergüenza lo poco que han cosechado, por la mucha ira de Yavé."
,"14":"Así ha dicho Yavé: 'A todos mis malvados vecinos, que han invadido la propiedad que yo le había regalado a mi pueblo Israel, los voy a arrancar de su suelo. Y a la casa de Judá la arrancaré de en medio de ellos."
,"15":"Pero después de haberlos arrancado, de nuevo me compadeceré de ellos y los haré volver a cada uno a su propiedad, a cada uno a su país."
,"16":"Y si aprenden con cuidado los preceptos de mi pueblo, de tal modo que lleguen a jurar en nombre mío: 'Por vida de Yavé', así como enseñaron a mi pueblo a jurar por Baal, entonces serán establecidos en medio de mi pueblo."
,"17":"Pero si se niegan a obedecerme, arrancaré a aquella gente y la haré desaparecer, dice Yavé.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Yavé me dijo así: 'Anda a comprarte un cinturón de lino y póntelo a la cintura, pero no lo metas al agua.'"
,"2":"Compré el cinturón, según la orden de Yavé, y me lo puse a la cintura."
,"3":"Por segunda vez me llegó una palabra de Yavé: 'Toma el cinturón que compraste y que llevas a la cintura, baja al torrente Para y escóndelo en la grieta de una roca.'"
,"4":"Y fui a esconderlo, conforme a la orden de Yavé."
,"5":"Después de muchos días, Yavé me dijo:"
,"6":"'Anda al torrente y busca el cinturón que te mandé esconder.'"
,"7":"Fui al torrente Para, recogí el cinturón del sitio donde lo había escondido, pero estaba podrido y no servía para nada."
,"8":"Entonces Yavé me dijo:"
,"9":"'De este modo destruiré el orgullo de Judá y la fama de Jerusalén."
,"10":"Este pueblo malvado que no quiere escuchar mi palabra y se deja llevar por su corazón endurecido y va tras otros dioses para servirlos y adorarlos, quedará como el cinturón que ya no vale nada."
,"11":"De la misma manera que un hombre se ciñe un cinturón a la cintura, así quise tener junto a mí a la gente de Judá para que fueran mi pueblo, mi honra, mi gloria y mi adorno, pero ellos no han escuchado.'"
,"12":"Tú les dirás también estas palabras: 'Todo cántaro se llenará de vino.' Y si te responden: '¿Es ésta una novedad, que un cántaro se llene de vino?'"
,"13":"tú les dirás: 'Ustedes son los cántaros, y a todos los llenará Yavé hasta que queden borrachos. Y se estrellarán los habitantes de este país, el uno contra el otro, y los padres contra sus hijos, tanto los reyes, sucesores de David, como los sacerdotes y los profetas, junto con los habitantes de Jerusalén.'"
,"14":"Así dice Yavé: 'No tendré piedad ni misericordia, y sin perdón los destruiré.'"
,"15":"¡Oigan, pongan atención, no sean tan creídos, pues es Yavé el que habla!"
,"16":"Reconozcan a Yavé, su Dios, antes que llegue la noche y sus pies tropiecen en las oscuras montañas. Ustedes esperaban la luz, pero él la cambia en sombra de muerte y, luego, en total oscuridad."
,"17":"Si ustedes no hacen caso a este aviso, lloraré en silencio por ese su orgullo, y mis ojos verterán lágrimas cuando el rebaño de Yavé sea llevado cautivo."
,"18":"Di al Rey y a la Reina Madre: Siéntense en el suelo, porque ha caído de sus cabezas su corona gloriosa."
,"19":"¡Las ciudades del Negueb han sido cerradas y nadie viene a abrirlas! Todo Judá es deportado, deportado en masa."
,"20":"Levanta tus ojos, Jerusalén, y mira a los que vienen del norte. ¿Dónde está el rebaño que estaba a tu cargo, las ovejas que eran tu orgullo?"
,"21":"¿Qué dirás cuando aquéllos te visiten como vencedores, siendo que tú los habías acostumbrado a tus intimidades? ¿No se apoderarán de ti dolores como de una mujer que da a luz?"
,"22":"Tú te preguntarás, tal vez: '¿Por qué me suceden todas estas desgracias?' A causa de tu gran perversidad te han arrancado los vestidos y te han pegado en los talones."
,"23":"¿Puede un negro etíope cambiar su piel o una pantera, su pelaje? Y ¿pueden ustedes actuar correctamente, ustedes que están acostumbrados al mal?"
,"24":"Los dispersaré, pues, como paja liviana arrebatada por el viento del desierto;"
,"25":"ése es tu premio, el salario de tu rebelión, que yo te había reservado, dice Yavé, porque a mí me echaste al olvido y te entregaste a la Mentira."
,"26":"Yo mismo levantaré tus vestidos, hasta tu cara, para que se vea tu vergüenza."
,"27":"¡Ah!, tus adulterios y tus gritos de placer, tu descarada prostitución, en los cerros y en los campos, todas tus monstruosidades, yo las he visto. Desgraciada Jerusalén, ¿hasta cuándo, todavía, estarás impura?"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Estas son palabras dirigidas a Jeremías a propósito de la gran sequía:"
,"2":"Judá está de duelo, y sus ciudades van a la ruina; están en el suelo, y de Jerusalén suben lamentos."
,"3":"Los ricos mandaron a los pobres a buscar agua;"
,"4":"fueron a los pozos y no encontraron, y volvieron con sus cántaros vacíos. Ya no produce la tierra por falta de lluvia y los campesinos andan apenados, cubierta la cabeza en señal de luto."
,"5":"Hasta los animales del campo abandonan sus crías porque no hallan pasto."
,"6":"Los burros se paran sobre los cerros pelados, aspiran el aire como suelen hacer los chacales, y desfallecen porque no hay ni un cardo."
,"7":"Aunque nuestras faltas nos acusen, tú, Yavé, haz algo para gloria de tu nombre. En verdad, muchas son nuestras rebeldías, y grande nuestro pecado contra ti."
,"8":"Oh Yavé, esperanza de Israel, que nos salvas en tiempo de angustia, ¿por qué te portas como extranjero en este país, o como huésped por una sola noche?"
,"9":"¿Por qué has de ser como un hombre aturdido, como un guerrero que no salva a los suyos? Pues tú estás entre nosotros, Yavé, y sobre nosotros fue invocado tu Nombre: no nos desampares."
,"10":"Esto dice Yavé respecto de este pueblo: ¡Cómo les gusta correr de acá para allá, si no paran un momento! Yavé no los quiere, pues se acuerda ahora de sus crímenes y del castigo que merecen."
,"11":"Y añadió Yavé: No ruegues por la felicidad de este pueblo."
,"12":"Aunque ayunen, no escucharé su súplica; aunque me presenten holocaustos y ofrendas, no los aceptaré. Al contrario, me preparo para acabar con ellos por la espada, el hambre y la peste."
,"13":"Yo exclamé: ¡Señor Yavé! Mira cómo los profetas andan diciendo: 'Ustedes no verán la espada, ni sufrirán de hambre, sino que les voy a dar una paz que dure, en este lugar.'"
,"14":"Yavé me respondió: Estos profetas andan anunciando mentiras en mi nombre; yo no los mandé, ni les di órdenes, ni les hablé. Falsas visiones, adivinaciones sin cometido, sueños de su imaginación, eso es lo que profetizan."
,"15":"Por consiguiente, así habla Yavé: Estos profetas, que profetizan en mi nombre, siendo que yo no los he mandado, y que declaran que en este país no habrá ni espada ni hambre; estos profetas morirán, justamente, por espada y por hambre."
,"16":"En cuanto a la gente a quien profetizaban, quedará tirada por las calles de Jerusalén, víctima del hambre y de la espada; pues no habrá nadie para enterrarla, ni a sus mujeres, ni a sus hijos e hijas. Haré recaer sobre ella misma su maldad."
,"17":"Les dirigirás estas palabras: De mis ojos están brotando lágrimas día y noche, sin parar, porque un gran mal aqueja a la hija de mi pueblo, una herida muy grave. "
,"18":"Si salgo al campo, veo personas atravesadas por la espada; si me vuelvo a la ciudad, encuentro a la gente torturada por el hambre. Y por más que se muevan los profetas y los sacerdotes, no encuentran la razón de esto."
,"19":"¿Has rechazado para siempre a Judá, o tu alma está aburrida con Sión?,¿Por qué nos has herido sin esperanza de mejorar?,Esperábamos la paz, y ninguna cosa buena llegó, la hora de nuestra mejoría, y se presentó el susto."
,"20":"Reconocemos, Yavé, nuestra maldad, la deuda de nuestros padres,y que hemos pecado contra ti."
,"21":"No nos desprecies más, por el honor de tu Nombre; no profanes más el trono de tu Gloria y no olvides tu alianza con nosotros."
,"22":"¿Hay acaso, entre los ídolos de los paganos, quién haga llover, o son los cielos los que dan los chubascos?,¿No eres tú únicamente, Yavé?,¡Oh Dios nuestro, sólo en ti esperamos, y tú eres quien ha hecho todas estas cosas!"
}`)
	CurrentBook.AddChapter(15, `{
"1":"Y me dijo Yavé: Aunque Moisés y Samuel vinieran en persona a rogar por este pueblo, mi corazón no se compadecería de él. ¡Echalos de mi presencia, que se vayan lejos!"
,"2":"Y si te preguntan: ¿Dónde? Diles: Así habla Yavé: Quien está condenado a la peste, a la peste; quien a la espada, a la espada; quien al hambre, al hambre; y quien al cautiverio, al cautiverio."
,"3":"Los someteré a cuatro tiranos, dice Yavé: la espada para matarlos, los perros para despedazarlos, las aves de rapiña y las fieras salvajes para devorarlos y aniquilarlos. ("
,"4":"Haré que su suerte infunda terror a todos los reinos de la tierra, por culpa de Manasés, hijo de Ezequías, rey de Judá, por sus crímenes cometidos en Jerusalén.)"
,"5":"¿Quién tendrá compasión de ti, Jerusalén?,¿Quién te consolará?,¿Quién se detendrá para preguntar por tu salud? "
,"6":"Tú me has dejado, dice Yavé, tú me has vuelto la espalda. Por eso, ahora extiendo mi mano para destruirte, pues ya me cansé de perdonarte."
,"7":"Los he pasado por el harnero en las ciudades del país. He dejado sin hijos a mi pueblo para que desaparezca, porque no ha querido dejar el mal camino."
,"8":"Sus viudas son más numerosas que las arenas del mar. He dejado caer al salteador, en pleno día, sobre las madres de los jóvenes guerreros; de repente, se han apoderado de ellas el miedo y el terror."
,"9":"La madre que tuvo siete hijos está avergonzada y desalentada y se le acaba el resuello porque se puso el sol de su vida aun en pleno día. Y a los que queden todavía los haré morir a espada, en presencia de sus enemigos, dice Yavé."
,"12":"¿Serás capaz de romper el hierro, el hierro que viene del norte, y el bronce?"
,"13":"Tu riqueza y tus tesoros voy a entregarlos al saqueo en pago por todos tus pecados cometidos dentro de tus fronteras."
,"14":"Te haré esclavo de tus enemigos en un país que no conoces, porque mi cólera ha pasado a ser un fuego que los va a quemar."
,"10":"Ay de mí, ¡madre mía!, ¿por qué me diste a luz? Soy hombre que trae líos y contiendas a todo el país. No les debo dinero, ni me deben; ¡pero todos me maldicen!"
,"11":"Di, Yavé, si no te he servido bien: ¿no intercedí ante ti, por mis enemigos, en el tiempo de la desgracia y de la angustia? Tú lo sabes."
,"15":"Yavé, acuérdate de mí y defiéndeme y véngame de mis perseguidores. No detengas más tu ira. Piensa que por tu causa soporto tantas humillaciones."
,"16":"Cuando me llegaban tus palabras, yo las devoraba. Tus palabras eran para mí gozo y alegría, porque entonces hacías descansar tu Nombre sobre mí, ¡oh, Yavé Sabaot!"
,"17":"Yo no me sentaba con otros para bromear, sino que, apenas tu mano me tomaba, yo me sentaba aparte, pues me habías llenado de tu propio enojo."
,"18":"¿Por qué mi dolor no tiene fin y no hay remedio para mi herida? ¿Por qué tú, mi manantial, me dejas de repente sin agua?"
,"19":"Entonces Yavé me dijo: 'Si vuelves a mí, yo te haré volver a mi servicio. Separa el oro de la escoria si quieres ser mi propia boca. Tendrán que volver a ti, pero tú no volverás a ellos."
,"20":"Haré que tú seas como una fortaleza y una pared de bronce frente a ellos; y si te declaran la guerra, no te vencerán, pues yo estoy contigo para librarte y salvarte."
,"21":"Te protegeré contra los malvados y te arrancaré de las manos de los violentos.'"
}`)
	CurrentBook.AddChapter(16, `{
"1":"Me llegó una palabra de Yavé:"
,"2":"'No te busques esposa, ni tengas hijos e hijas en este lugar,"
,"3":"porque ésta es la sentencia de Yavé respecto a los hijos y a las hijas nacidas en este lugar, respecto a sus padres y también a sus madres que los dieron a luz en este país:"
,"4":"Todos morirán miserablemente, sin que ni siquiera los lloren ni los sepulten. Sus cadáveres se pudrirán sobre la tierra y servirán de comida para las aves de rapiña y para las fieras.'"
,"5":"Y Yavé insistió: 'No entres en la casa donde celebran un duelo. No llores con ellos ni te lamentes en voz alta. Porque, en adelante, no daré más mi paz a este pueblo, ni le haré misericordia, ni le tendré compasión."
,"6":"En ese país morirán grandes y chicos, sin que los sepulten ni los lloren. En este país ya no se harán cortes en el cuerpo, ni se cortarán el pelo en homenaje a los muertos. "
,"7":"Tampoco se repartirá pan en los velorios, ni se ofrecerá vino para consolar a los deudos. Nadie servirá a los hijos la copa del consuelo el día de la muerte de sus padres."
,"8":"No entres en la casa donde celebran una fiesta, para sentarte con ellos y comer y beber."
,"9":"Pues Yavé de los Ejércitos, Dios de Israel, dice: Haré desaparecer de este lugar, y ante tus propios ojos, todo grito de alegría y de gozo, y también los cantos de los novios.'"
,"10":"Cuando tú anuncies a este pueblo todas estas cosas, te preguntarán: '¿Por qué nos amenaza Yavé con estas enormes desgracias? ¿Qué crimen o qué pecado hemos cometido contra Yavé, nuestro Dios?'"
,"11":"Entonces tú les contestarás: 'Porque sus padres me dejaron, dice Yavé, y se fueron con otros dioses sirviéndoles e hincándose ante ellos; y a mí me despreciaron y no observaron mis mandamientos."
,"12":"Y ustedes, sí, ustedes, han actuado peor que sus padres; pues cada uno de ustedes hace lo que le aconseja su corazón duro y perverso en vez de escucharme."
,"13":"Los voy a echar de este país a otro que ni ustedes ni sus padres conocen; ¡allí podrán ustedes servir a esos dioses, día y noche, que yo ya no les haré más caso!'"
,"14":"Sin embargo, se acerca el tiempo -dice Yavé-, en que no dirán: 'Viva Yavé porque sacó a los hijos de Israel del país de Egipto',"
,"15":"sino 'Viva Yavé que trajo a los hijos de Israel del país del norte y de todos los países adonde los había echado'. ¡Yo los devolveré a la tierra que había dado a sus padres!"
,"16":"Yo enviaré primero a muchos pescadores, dice Yavé, que los pescarán; después, a numerosos cazadores, que los perseguirán por montes y cerros, y hasta en las cavernas de las montañas."
,"17":"Porque estoy mirando todos sus caminos, sin que ninguno se me oculte y sin que su culpa escape a mi vista."
,"18":"Les haré pagar el doble por su crimen y sus pecados, ya que profanaron mi tierra con los cadáveres de sus ídolos y llenaron mi propiedad con sus abominaciones."
,"19":"¡Oh Yavé, mi fuerza y mi fortaleza, mi refugio en el día de la desgracia!,A ti vendrán a verte las naciones,desde los últimos límites de la tierra, y dirán: Era sólo mentira lo que se transmitían nuestros padres, y vanidad y falta de poder."
,"20":"¿Puede un hombre fabricarse sus dioses?,¡Qué va, ésos no son dioses!"
,"21":"Y se lo voy a mostrar, pues esta vez les demostraré, cómo son mi mano y mi poder, y así sabrán que mi nombre es Yavé."
}`)
	CurrentBook.AddChapter(17, `{
"1":"El pecado de Judá está escrito con un punzón de acero, con una punta de diamante; está grabado sobre la tabla de su corazón y sobre los cuernos de sus altares."
,"2":"Sus altares y sus postes sagrados lo recuerdan debajo de los árboles verdes, en las lomas altas"
,"3":"y los cerros del llano. Tu riqueza y todos tus tesoros los entregaré al saqueo, en pago por todos tus pecados cometidos en tus santuarios altos por todo tu territorio."
,"4":"Tendrás que desprenderte de la propiedad que te había regalado, y te haré esclavo de tus enemigos en una tierra desconocida, porque has encendido el fuego de mi ira, que quemará eternamente."
,"5":"Así habla Yavé: ¡Maldito el hombre que confía en otro hombre, que busca su apoyo en un mortal, y que aparta su corazón de Yavé!"
,"6":"Es como mata de cardo en la estepa; no sentirá cuando llegue la lluvia, pues echó sus raíces,en lugares ardientes del desierto, en un solar despoblado."
,"7":"¡Bendito el que confía en Yavé, y que en él pone su esperanza!"
,"8":"Se asemeja a un árbol plantado,a la orilla del agua, y que alarga sus raíces hacia la corriente: no tiene miedo de que llegue el calor, su follaje se mantendrá verde; en año de sequía no se inquieta, ni deja de producir sus frutos."
,"9":"El corazón es lo más complejo, y es perverso: ¿quién puede conocerlo?"
,"10":"Yo, Yavé, yo escudriño el corazón,y sondeo las entrañas; yo doy a cada cual según su conducta,y según el fruto de sus obras."
,"11":"El que amontona riquezas injustamente,es como la perdiz que se echa sobre huevos ajenos; tendrá que dejarlas, en la mitad de su vida, y al final no será más que un insensato."
,"12":"Un trono glorioso y excelso, es nuestro Santuario:"
,"13":"esperanza de Israel, Yavé, los que te traicionan serán confundidos. Los que se rebelan serán borrados del país, porque abandonaron el manantial de agua viva."
,"14":"¡Devuélveme la salud, Yavé, y quedaré sano! ¡Sálvame y estaré a salvo! Pues mi esperanza eres tú."
,"15":"Mira cómo me dicen: ¿Una palabra más de Yavé? ¡Que se cumpla, pues!"
,"16":"A pesar de esto yo no te he obligado a lo peor, no he anhelado que llegue el día fatal, tú lo sabes bien; todo lo que ha salido de mis labios está claro para ti."
,"17":"No me hagas caer en el susto, tú, que eres mi refugio en el tiempo malo."
,"18":"¡Que sean humillados mis perseguidores y no yo; que ellos tiemblen de miedo, no yo! Desata sobre ellos todas las calamidades, aplástalos bien aplastados."
,"19":"Me llegó una palabra de Yavé: 'Anda a la puerta que llaman 'Puerta del Pueblo', por donde entran los reyes de Judá. Irás también a las demás puertas de Jerusalén"
,"20":"y dirás: Escuchen la palabra de Yavé, ustedes reyes de Judá, y también ustedes que habitan en Jerusalén y pasan por estas puertas:"
,"21":"Si ustedes quieren salvar la vida, cuiden de no llevar carga el día sábado, y de no hacer entrar en Jerusalén sus productos en ese día."
,"22":"No salgan cargados ese día, ni hagan trabajo alguno, sino que santifiquen el día sábado como se lo mandé a sus padres."
,"23":"Ellos no me obedecieron ni escucharon mi mandato. Se pusieron duros de cabeza, para no oír ni aceptar mis advertencias."
,"24":"Pero si ustedes me hacen caso, palabra de Yavé, y santifican el día sábado, sin realizar en él trabajo alguno, y no entran cargados por las puertas de Jerusalén, entonces habrá reyes que se sientan en el trono de David."
,"25":"Entrarán por estas puertas con sus carros y sus caballos, ellos y sus cortesanos, y también la gente de Judá y de Jerusalén, y esta ciudad será habitada siempre."
,"26":"Aquí subirán los habitantes de las ciudades de Judá, de los alrededores de Jerusalén, de la tierra de Benjamín, de la Tierra Baja, de los cerros y del sur, trayendo víctimas y sacrificios, incienso y ofrendas, en acción de gracias al Templo de Yavé."
,"27":"Pero si no me escuchan, y no santifican este día, trabajando y llevando sus cargas por las puertas de Jerusalén, prenderé fuego a esas puertas, y devorará los edificios de Jerusalén. Y nadie lo apagará.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Aquí viene una palabra que Yavé dirigió a Jeremías:"
,"2":"'Levántate y baja a la casa del que trabaja la greda; allí te haré oír mis palabras.'"
,"3":"Bajé, pues, donde el alfarero que estaba haciendo un trabajo al torno."
,"4":"Pero el cántaro que estaba haciendo le salió mal, mientras amoldaba la greda. Lo volvió entonces a empezar, transformándolo en otro cántaro a su gusto."
,"5":"Yavé, entonces, me dirigió esta palabra:"
,"6":"'Yo puedo hacer lo mismo contigo, pueblo de Israel; como el barro en la mano del alfarero, así eres tú en mi mano."
,"7":"A veces yo hablo respecto de algún reino o de alguna nación, amenazando con destruir y arrancar."
,"8":"Mas ellos cambian su proceder, dejando la maldad que yo denunciaba. Entonces, yo también cambio mis proyectos y ya no les quiero causar ningún mal."
,"9":"Otras veces, yo hablo respecto de alguna nación, o de algún reino, prometiendo edificar y plantar."
,"10":"Mas ellos hacen lo que me desagrada y dejan de escuchar mi voz. Entonces yo también me arrepiento y ya no quiero hacerles el bien que prometía."
,"11":"Pues bien, oigan lo que dice Yavé a la gente de Judá y a los habitantes de Jerusalén: Sepan que yo estoy preparando contra ustedes una desgracia. Arrepiéntanse cada uno de su mal proceder, y mejoren su conducta y sus obras.'"
,"12":"Pero ellos respondieron: '¡Basta! Nosotros haremos según nos parezca.' Y cada uno sigue sus propias ideas, por malas que sean."
,"13":"Debido a todo esto, así habla Yavé: Averigüen entre las naciones y vean si alguien oyó cosa semejante: una cosa horrible ha hecho la virgen de Israel."
,"14":"¿Han visto ustedes que haya desaparecido de las altas cumbres la nieve del Líbano, o que se hayan secado las aguas poderosas, frescas y corrientes?"
,"15":"¡Y bien, mi pueblo me ha olvidado y quema incienso a cosas que no valen nada! Lo han desviado de sus caminos, de sus viejos senderos, para tomar caminos horrorosos, rutas intransitables."
,"16":"Lograrán que su país se vuelva un desierto, un objeto de risa eterna: todo el que pase quedará sorprendido de eso y meneará la cabeza."
,"17":"Como si fuera el viento de oriente, los desparramaré frente al enemigo. La espada y no la cara les mostraré, en el día de su calamidad."
,"18":"Ellos decían: 'Vengan, tramemos un atentado contra Jeremías, porque no por eso van a faltar sacerdotes que nos digan la Ley, ni sabios que den consejos, ni profetas que transmitan palabras de Yavé. Vengan, debemos contradecirle y no hacer más caso a todas sus palabras.'"
,"19":"Atiéndeme, Yavé, mira lo que dicen mis adversarios."
,"20":"¿Acaso se paga mal por bien?,¿Y cómo es que ellos están haciendo un hoyo para mí?,Recuérdate cómo me presenté a ti,para hablarte en su favor,y para apartar de ellos tu ira."
,"21":"¡Entrega, pues, sus hijos al hambre, déjalos a merced de la espada!,Que sus mujeres se queden sin hijos ni maridos. ¡Que sus esposos sean muertos por la peste,y sus jóvenes atravesados por la espada en la guerra!"
,"22":"Que se oigan salir gritos de sus casas,cuando tú envíes, de repente, contra ellos, bandas de salteadores, ya que han cavado una fosa para cazarme,y han escondido trampas por donde yo paso."
,"23":"Tú, Yavé, conoces en detalle,sus planes asesinos contra mí. No perdones su crimen,ni se te olvide su pecado. ¡No pierdas de vista su destrucción, cuando se desate tu cólera, actúa, no más, contra ellos!"
}`)
	CurrentBook.AddChapter(19, `{
"1":"Esta fue la palabra de Yavé: 'Anda a comprarte un jarro de greda. Que te acompañen algunos ancianos del pueblo y algunos sacerdotes."
,"2":"Parte después en dirección del valle de Ben-Hinón, a la entrada de la Puerta de los Alfareros, y pronuncia allí este discurso, que yo te dictaré."
,"3":"Comenzarás así: Escuchen la palabra de Yavé, reyes de Judá y habitantes de Jerusalén. Así dice Yavé de los Ejércitos, el Dios de Israel. Voy a mandar una calamidad tal sobre este lugar, que le zumbarán los oídos a quien la oiga, "
,"4":"por haberme abandonado, profanando este lugar, y ofrecido incienso a dioses extranjeros que ni ellos, ni sus padres, ni los reyes de Judá conocían. Han llenado este lugar de sangre inocente"
,"5":"y han construido santuarios altos a Baal para quemar a sus hijos; siendo que yo jamás lo había prescrito u ordenado, ni se me había pasado por la mente."
,"6":"Por esto, se está acercando el día en que este lugar ya no se llamará Tofet ni valle de Ben-Hinón, sino Valle de la Muerte."
,"7":"Reduciré a nada las esperanzas de Judá y Jerusalén en este lugar; los haré caer bajo la espada de sus enemigos, a manos de los que buscan su muerte; daré sus cadáveres por comida a las aves de rapiña y a las fieras salvajes."
,"8":"Transformaré este lugar en un desierto, en un objeto de risa, de manera que cualquiera que pase quedará admirado y silbará al ver tantas heridas."
,"9":"Les haré comer la carne de sus hijos e hijas, y se devorarán entre ellos, en medio del angustioso asedio y de la miseria a que los reducirán sus enemigos, que quieren quitarles la vida."
,"10":"Después de decirles todo esto, harás pedazos este jarro en presencia de los que te hayan acompañado,"
,"11":"y les dirás: Así habla Yavé de los Ejércitos: Voy a despedazar a este pueblo y esta ciudad, como se hace añicos un vaso de greda, sin que pueda componerse. Y se harán los entierros en Tofet por no haber lugar en otra parte."
,"12":"Así haré con este lugar, dice Yavé, hasta convertir esta ciudad en un Tofet."
,"13":"Las casas de los reyes de Judá y las de Jerusalén serán impuras como el lugar de Tofet; ¡todas aquellas casas, en cuyas terrazas quemaron incienso al ejército del cielo y derramaron vino a los dioses extranjeros!'"
,"14":"Al volver Jeremías de Tofet, lugar donde Yavé lo había enviado a profetizar, se paró a la entrada de la Casa de Yavé. Allí dijo ante toda la gente:"
,"15":"Escuchen esta palabra del Dios de Israel, Yavé: 'Mando a esta ciudad y a los pueblos de su alrededor todas las calamidades con las que los he amenazado, porque se rebelaron contra mí, y se negaron a escucharme.'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"El sacerdote Pasjur, hijo de Immer, que era primer encargado de la Casa de Yavé,"
,"2":"al oír a Jeremías, mandó apalearlo, y lo hizo sujetar con cadenas en el calabozo de la puerta alta de Benjamín, que está en la Casa de Yavé."
,"3":"Al día siguiente, sacó Pasjur a Jeremías del calabozo. Entonces Jeremías le dijo: 'Para Yavé, ahora, no eres más Pasjur, sino que te ha llamado: Terror para todos.'"
,"4":"Porque así dice Yavé: 'Yo te entregaré al terror, junto con tus amigos, los cuales serán muertos por sus enemigos ante tus propios ojos."
,"5":"Entregaré a toda la gente de Judá en manos del rey de Babilonia para que sean llevados a esa ciudad o muertos a espada. Entregaré a los enemigos las riquezas de Jerusalén, tanto sus reservas como sus cosas preciosas, y los tesoros de los reyes de Judá. Los enemigos saquearán y tomarán todo, llevándoselo a Babilonia."
,"6":"A ti también, Pasjur, te llevarán a Babilonia, junto con todos los que viven en tu casa. Allí morirás y serás sepultado, igual que tus amigos, a quienes engañas con profecías falsas.'"
,"7":"Me has seducido, Yavé, y me dejé seducir por ti. Me tomaste a la fuerza y saliste ganando. Todo el día soy el blanco de sus burlas, toda la gente se ríe de mí."
,"8":"Pues me pongo a hablar, y son amenazas, no les anuncio más que violencias y saqueos. La palabra de Yavé me acarrea cada día humillaciones e insultos."
,"9":"Por eso, decidí no recordar más a Yavé, ni hablar más en su nombre, pero sentía en mí algo así como un fuego ardiente aprisionado en mis huesos, y aunque yo trataba de apagarlo, no podía."
,"10":"Yo oía a mis adversarios que decían contra mí: '¿Cuándo, por fin, lo denunciarán?' Ahora me observan los que antes me saludaban, esperando que yo tropiece para desquitarse de mí."
,"11":"Pero Yavé está conmigo, él, mi poderoso defensor; los que me persiguen no me vencerán. Caerán ellos y tendrán la vergüenza de su fracaso, y su humillación no se olvidará jamás."
,"12":"Yavé, Señor, tus ojos están pendientes del hombre justo. Tú conoces las conciencias y los corazones, haz que vea cuando te desquites de ellos, porque a ti he confiado mi defensa."
,"13":"¡Canten y alaben a Yavé, que salvó al desamparado de las manos de los malvados!"
,"14":"¡Maldito sea el día en que nací,en que mi madre me dio a luz: ¡No sea bendito!"
,"15":"Maldito sea el que avisó a mi padre,y le colmó con esa alegría: 'Te ha nacido un hijo varón.'"
,"16":"Que ese hombre sea como aquellas ciudades,que Yavé ha destruido sin compasión; que sienta el grito de alarma en la mañana,y el clamor de guerra al mediodía,"
,"17":"porque no me hizo morir en el seno materno. ¡Mi madre habría sido mi tumba,y yo me habría quedado siempre en su seno!"
,"18":"¿Para qué, pues, salí de sus entrañas?,¿Para vivir angustia y tormento,y acabar mis días en la humillación?"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Estas fueron las palabras que dirigió Yavé a Jeremías, cuando el rey Sedecías le mandó a Pasjur, hijo de Malaquías y al sacerdote Sofonías, hijo de Mahasías, para que le dijeran:"
,"2":"'Consulta, en nombre de nosotros, a Yavé, pues Nabucodonosor, rey de Babilonia, nos está atacando; a lo mejor Yavé vuelve a hacer para nosotros algunos de sus milagros, y el enemigo se retira de nuestra presencia.'"
,"3":"Jeremías les contestó: 'Lleven a Sedecías esta respuesta: Esto dice Yavé, Dios de Israel:"
,"4":"Yo haré retroceder las armas que ustedes llevan en sus manos y con las que combaten en las murallas de la ciudad, al rey de Babilonia y a los caldeos que los están sitiando, y las amontonaré en medio de la ciudad."
,"5":"Y yo mismo pelearé contra ustedes a mano limpia y con la camisa arremangada, con rabia, con ira y con gran indignación."
,"6":"Enviaré sobre los habitantes de esta ciudad, hombres y bestias, una terrible peste, para que mueran."
,"7":"Después de eso, dice Yavé, a Sedecías, rey de Judá, a sus sirvientes y a la gente de esta ciudad que haya escapado de la peste, de la espada y del hambre, los entregaré en manos de Nabucodonosor, rey de Babilonia, en manos de sus enemigos que quieren quitarles la vida. Los matarán con la espada, sin tener con ustedes consideración, ni piedad, ni compasión.'"
,"8":"Y hablarás a este pueblo: 'Esto dice Yavé: Les presento a ustedes dos caminos, el de la vida y el de la muerte."
,"9":"El que se quede en esta ciudad morirá a espada, de hambre y de peste; en cambio, el que salga y se rinda a los caldeos, sus sitiadores, vivirá: salvará su vida por lo menos."
,"10":"Pues yo le he vuelto la cara a esta ciudad para su mal, no para su bien, dice Yavé. Caerá en manos del rey de Babilonia, que le prenderá fuego.'"
,"11":"A los magistrados del rey de Judá le dirás: Servidores de la dinastía de David, oigan lo que les dice Yavé;"
,"12":"éstas son sus palabras: Hagan justicia correctamente, cada día, libren al oprimido de las manos de su opresor; de lo contrario mi cólera va a estallar como un incendio y no va a haber nadie para apagarlo."
,"13":"¡Aquí me tienes, tú que dominas el valle, como peñón en la llanura! dice Yavé. Tú decías: '¿Quién nos asaltará y penetrará en nuestros refugios?'"
,"14":"Vengo a pedirles cuentas, dice Yavé. ¡Prenderé fuego al bosque y quemará todos sus alrededores!"
}`)
	CurrentBook.AddChapter(22, `{
"1":"Yavé me dijo: 'Baja al palacio del rey de Judá, y allí entregarás esta palabra:"
,"2":"Escucha la palabra de Yavé, rey de Judá que reinas sentado en el trono de David. Así te dice Yavé a ti y a tus servidores y a todo tu pueblo que entra por estas puertas:"
,"3":"Practiquen la justicia y hagan el bien, libren de la mano del opresor al que fue despojado; no maltraten al forastero ni al huérfano ni a la viuda; no les hagan violencia, ni derramen sangre inocente en este lugar."
,"4":"Si cumplen esto, entonces los reyes sucesores de David seguirán entrando por estas puertas, pasarán con sus carros y sus caballos, con su gente y con su pueblo."
,"5":"Pero si no escuchan estas palabras, les juro por mí mismo, Yavé es quien habla, este palacio será destruido.'"
,"6":"Pues así se expresa Yavé respecto a este palacio de Judá: Me gustaría verte ensalzado como el país de Galaad, como una cumbre del Líbano, mas te voy a dejar hecho un desierto o una ciudad sin habitantes. "
,"7":"Estoy preparando a los que te van a asaltar con hacha en mano, echarán abajo tus cedros más hermosos para tirarlos al fuego."
,"8":"Y cuando la gente de cualquiera nación pase frente a esta ciudad se preguntarán unos a otros: '¿Por qué Yavé habrá tratado así a esta gran ciudad?',"
,"9":"les contestarán: 'Es porque faltaron a su palabra con Yavé, su Dios, y se arrodillaron delante de otros dioses para servirlos.'"
,"10":"No lloren al que murió ni estén apenados por él. Lloren, más bien, por el que se va, pues no volverá más ni jamás verá su país natal."
,"11":"Esto es lo que ha decidido Yavé sobre Salum, hijo de Josías, rey de Judá, que sucedió en el trono a su padre, y que ha salido de aquí:"
,"12":"Nunca más volverá, sino que morirá en el lugar adonde lo llevaron prisionero, y jamás verá este país."
,"13":"¡Pobre de aquel que edifica su casa con abusos, y levanta sus pisos sobre la injusticia! ¡Pobre de aquel que se aprovecha de su prójimo y lo hace trabajar sin pagarle su salario!"
,"14":"Tú piensas: 'Me voy a construir un palacio suntuoso, con pisos espaciosos; luego abriré ventanas y las cubriré con madera de cedro, toda pintada de rojo.'"
,"15":"¿Acaso hace falta el cedro para que seas rey? ¿Le faltó acaso a tu padre comida o bebida? Sin embargo, se preocupaba de la justicia y todo le salía bien."
,"16":"Juzgaba la causa del desamparado y del pobre. Yavé te pregunta: '¿Conocerme no es actuar en esa forma?'"
,"17":"Pero nada ves o conoces sino tu propio interés; y esto, derramando sangre, y manteniendo la opresión y la violencia."
,"18":"Esta es la suerte que, por orden de Yavé, correrá Joaquim, hijo de Josías, rey de Judá. Nadie dirá sollozando por él: '¡Ay de mi hermano, ay de mi hermana!' Nadie dirá sollozando por él: '¡Ay, Señor! ¡Ay, su Majestad!'"
,"19":"Será enterrado como un burro, lo arrastrarán y lo tirarán fuera de las puertas de Jerusalén."
,"20":"Sube a los cerros del Líbano y grita; levanta tu voz desde los cerros de Basán y de lo alto del Abarim, porque todos tus amantes han sido aplastados."
,"21":"Te hablé cuando te sonreía la fortuna y dijiste: 'No tengo ganas de oír.' Te has acostumbrado desde tu juventud a no escuchar mi voz."
,"22":"El viento dispersará a todos tus pastores, y tus amantes partirán al destierro. Entonces quedarás avergonzada y decepcionada de todos esos amantes."
,"23":"Tú, que hiciste tu casa en el Líbano, que anidabas entre los cedros, ¡cómo te irás a quejar cuando sientas dolores y angustias como de una mujer que da a luz!"
,"24":"¡Por mi vida, dice Yavé, aunque Jeconías, hijo de Joaquim, rey de Judá, fuese un anillo en mi mano derecha, lo arrancaría de allí!"
,"25":"Te entregaré a los caldeos, que te buscan y que te atemorizan ,"
,"26":"y te echaré a ti y a tu madre, que te engendró, a otro país donde ustedes no nacieron, pero donde van a morir."
,"27":"Y a esta tierra, a la que tanto desean volver, no volverán jamás."
,"28":"Este tal Jeconías, ¿es, acaso, un trasto viejo e inservible que ya nadie quiere? ¿Por qué han sido expulsados él y su familia y echados a un país que no conocían?"
,"29":"¡Tierra, tierra, tierra!, escucha esta palabra de Yavé:"
,"30":"Inscriban en el registro a este hombre así: 'Sin hijos, un fracasado en su vida.' Pues nadie de su sangre logrará restablecerse sobre el trono de David para reinar en Judá."
}`)
	CurrentBook.AddChapter(23, `{
"1":"'¡Ay de esos pastores que pierden y dispersan las ovejas de mis praderas!'"
,"2":"Así habla Yavé, el Dios de Israel, contra los pastores que pastorean a mi pueblo: 'Ustedes han dispersado mis ovejas y las han echado en vez de preocuparse de ellas. Pero ahora me voy a preocupar de ustedes por todo el mal que cometieron, palabra de Yavé."
,"3":"Voy a reunir el resto de mis ovejas, llamándolas de todos los países adonde las haya dispersado. Las haré volver a sus pastos, donde se criarán y se multiplicarán."
,"4":"Yo pondré al frente de ellas pastores que las cuiden, y nunca más temerán o serán asustadas. Ya ninguna se perderá.'"
,"5":"Así dice Yavé: 'Llega el día en que yo haré surgir un hijo de David que se portará como rey justo y prudente."
,"6":"El gobernará este país según la justicia y el derecho. En aquel tiempo Judá gozará de paz, e Israel permanecerá seguro. Y éste es el nombre que le darán: Yavé-nuestra-justicia."
,"7":"Llegará también el tiempo, dice Yavé, en que ya no se dirá más: 'Viva Yavé, que ha sacado a los hijos de Israel de la tierra de Egipto',"
,"8":"sino: 'Viva Yavé, que sacó y trajo a la raza de Israel del país del norte y de todos los países donde los había desparramado, para que habiten de nuevo en su propia tierra.'"
,"9":"Para los profetas. Se me parte el corazón en mi pecho, tiemblo de pies a cabeza; quedo como un borracho,que ha volteado el vino, al ver a Yavé y oír sus santas palabras:"
,"10":"'El país está repleto de adúlteros; y porque los he maldecido, el país está de duelo y se han secado los oasis del desierto. Corren para hacer el mal y se empeñan en actuar injustamente."
,"11":"Hasta el profeta y el sacerdote se han vuelto impíos, y en mi propia Casa me he topado con su maldad, dice Yavé."
,"12":"Por eso, su camino se les hará resbaladizo en la oscuridad; caerán y se irán al suelo cuando llegue el año del castigo y les envíe la desgracia.'"
,"13":"No he encontrado más que estupidez en los profetas de Samaria: profetizaron en nombre de Baal y extraviaron a mi pueblo Israel."
,"14":"Luego vi cosas horrorosas en los profetas de Jerusalén: adulterio, apego a la mentira. Apoyan a los perversos de tal manera, que nadie se arrepiente de su maldad. Para mí son todos ellos como Sodoma, y los habitantes son como los de Gomorra."
,"15":"Esta es, por tanto, la sentencia de Yavé de los Ejércitos sobre estos profetas: Les daré como comida ajenjo, y como bebida agua envenenada, porque a partir de los profetas de Jerusalén la corrupción ha cundido por todo el país."
,"16":"Esto dice Yavé: No escuchen las palabras de estos profetas que profetizan para ustedes, porque los engañan contándoles las visiones de su propia imaginación y no lo que sale de la boca de Yavé."
,"17":"A aquellos que desprecian la palabra de Yavé les aseguran 'que tendrán paz', y a todos los que siguen los caprichos de su corazón, 'que ninguna desgracia les va a suceder'."
,"18":"Pero, ¿quién de ellos ha asistido a una reunión con Yavé? ¿Quién ha visto y oído su palabra? ¿Quién se ha fijado en sus palabras para transmitirlas?"
,"19":"El temporal de Yavé estalla, una tempestad se desencadena y se precipita sobre las cabezas de los impíos."
,"20":"Es la cólera de Yavé que no se calmará hasta que no haya cumplido y realizado el propósito de su corazón. Después entenderán ustedes todo esto claramente."
,"21":"Yo no mandé a estos profetas ¡y vinieron corriendo! Tampoco les hablé y se pusieron a profetizar."
,"22":"¿Acaso asistieron a alguna reunión conmigo? ¡Entonces, que transmitan mis palabras a mi pueblo, que lo hagan volverse de su mal camino y de sus obras perversas!"
,"23":"¿Soy yo un Dios sólo de cerca?, dice Yavé, ¿no soy Dios también de lejos?"
,"24":"¿O puede un hombre ocultarse en un escondite sin que yo lo vea?, dice Yavé. El cielo y la tierra, ¿no los lleno yo?, dice Yavé."
,"25":"Me he puesto a escuchar lo que dicen los profetas que profetizan en mi nombre falsamente; sus palabras son: '¡He tenido un sueño, he tenido un sueño!'"
,"26":"¿Hasta cuándo habrá, entre los profetas, profetas de mentira que profetizan falsamente y que cuentan lo que han inventado?"
,"27":"Pretenden, con los sueños que unos a otros se cuentan, hacer olvidar mi Nombre a mi pueblo, como sus padres se olvidaron de mi Nombre por seguir a Baal."
,"28":"El profeta que ha tenido un sueño cuenta su sueño, pero el que ha recibido mi palabra transmite mi palabra de verdad. ¿Qué tiene que ver la paja con el trigo?, dice Yavé. "
,"29":"¿No es mi palabra como fuego que quema o como martillo que rompe la roca?"
,"30":"Pues bien, dice Yavé, voy a castigar los profetas, dice Yavé, que se roban mis palabras unos a otros;"
,"31":"que no tienen más que abrir su boca para pronunciar oráculos."
,"32":"Voy a castigar los profetas de sueños mentirosos que son buenos para contarlos y que desorientan a mi pueblo con sus embustes y extravagancias. Yo no los he enviado ni les mandado órdenes, y no sirven para nada a este pueblo, dice Yavé."
,"33":"Y cuando esa gente te pregunte: '¿Cuál es la carga de Yavé?', les contestarás: 'Ustedes son esa carga, y a ustedes los voy a tirar para afuera,"
,"34":"dice Yavé.' Y al profeta, sacerdote u hombre cualquiera que diga: 'Carga de Yavé', lo castigaré a él y a su familia."
,"35":"Esto es lo que unos a otros deben decirse ustedes: '¿Qué ha respondido Yavé? o ¿qué ha dicho Yavé?'"
,"36":"Pero no usen más la expresión 'Carga de Yavé', porque se volverá muy pesada para quien la emplee."
,"37":"Así hay que hablarle a un profeta: '¿Qué te ha contestado Yavé o qué te ha dicho?';"
,"38":"y si alguno llega a exclamar 'Carga de Yavé', entonces miren lo que les anuncia Yavé: Puesto que ustedes repiten esa expresión, siendo que les advertí que no la usaran,"
,"39":"los levantaré como un fardo y los dejaré caer lejos de mi presencia, junto con la ciudad que regalé a ustedes y a sus padres."
,"40":"Y echaré encima de ustedes una vergüenza eterna, una mancha que nunca se borrará."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Yavé me mostró dos canastos con higos, que estaban delante de su templo. Esto pasó después de que Nabucodonosor, rey de Babilonia, desterró a Jeconías, hijo de Joaquim, rey de Judá, y a los príncipes de Judá junto con los herreros y los cerrajeros, y los llevó a Babilonia, lejos de Jerusalén."
,"2":"Un canasto tenía higos muy buenos, como son los primeros que maduran; el otro tenía higos podridos, tan malos que no se podían comer."
,"3":"Y me preguntó Yavé: '¿Qué ves, Jeremías?' Le contesté: 'Higos. Los buenos son muy buenos; los malos están tan podridos que no se pueden comer.'"
,"4":"Entonces me llegó una palabra de Yavé: Esto dice Yavé, Dios de Israel:"
,"5":"Así como se mira con gusto estos higos buenos, así me voy a interesar por el bien de los desterrados de Judá, que eché de este lugar al país de los caldeos."
,"6":"Me fijaré que les vaya bien, los haré regresar a su tierra, los reconstruiré en vez de demolerlos, los plantaré en vez de arrancarlos."
,"7":"Les daré un corazón que sea capaz de conocerme a mí, Yavé. Serán mi pueblo y yo seré su Dios, pues volverán a mí con todo su corazón."
,"8":"Pero así como se trata a los higos malos, tan podridos que no se pueden comer, así trataré a Sedecías, rey de Judá, a sus príncipes y al resto de los habitantes de Jerusalén, tanto a los que quedaron en este país como a los que viven en Egipto."
,"9":"Serán motivo de espanto y de vergüenza para todos los reinos de la tierra; se reirán y se burlarán de ellos, serán como un ejemplo de maldición en todos los países adonde los echaré."
,"10":"Enviaré contra ellos la espada, el hambre, la peste, hasta que hayan desaparecido de la tierra que les había dado a ellos y a sus padres."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Aquí viene la palabra que fue dirigida a Jeremías acerca de todo el pueblo de Judá, el año cuarto del reinado de Joaquim, hijo de Josías, y rey de Judá."
,"2":"Jeremías, el profeta, la transmitió a todo el pueblo de Judá y a todos los habitantes de Jerusalén:"
,"3":"'Hace ya veintitrés años, desde el año trece del reinado de Josías, hijo de Amón y rey de Judá, hasta la fecha, que me habla Yavé. Sin descanso (les predico a ustedes, pero sin que ustedes escuchen."
,"4":"Además, Yavé, sin cesar), les ha mandado a sus servidores los profetas, pero ustedes ni los oyeron ni les hicieron caso."
,"5":"Sus palabras han sido: 'Dejen su mala conducta y sus malas acciones, sólo así podrán ustedes permanecer en el territorio que Yavé concedió a ustedes y a sus padres, siempre y por siempre."
,"6":"Y no corran tras otros dioses para servirlos y para arrodillarse ante ellos; no me molesten con las obras que hacen sus manos y yo tampoco les haré mal alguno."
,"7":"Pero ustedes se negaron a oírme, dice Yavé; más aún, me han hecho enojar con esas obras, para su propia desgracia.'"
,"8":"Por esto, así se expresa Yavé de los Ejércitos: 'Ya que ustedes no quisieron oírme cuando les hablaba,"
,"9":"voy a mandar a buscar a una nación del norte, dice Yavé, y la echaré contra este país y sus habitantes; los maldeciré y los convertiré para siempre en motivo de espanto, de burla y de vergüenza."
,"10":"Suprimiré de su casa las manifestaciones de alegría y de contento, los cantos del novio y de la novia, el ruido de la piedra de molino y la luz de la lámpara."
,"11":"Todo este país será saqueado y quedará reducido a un desierto, y estas naciones servirán al rey de Babilonia durante setenta años."
,"12":"Pero, cuando se cumpla este tiempo, castigaré al rey de Babilonia y a su nación por sus crímenes; castigaré al país de los caldeos, dejándolo abandonado para siempre."
,"13":"Haré que se ejecute con este país todo cuanto he pronunciado en su contra, todo lo que está escrito en este libro."
,"14":"Pues también caerán bajo el dominio de naciones más poderosas y de grandes reyes, y les pagaré según sus actos y según la obra que hicieron sus manos. Lo que profetizó Jeremías contra todas las naciones."
,"15":"Yavé, Dios de Israel, me habló de esta manera: 'Toma esta copa de vino y pásasela a todas las naciones a las que te voy a enviar,"
,"16":"para que beban y se mareen.'"
,"17":"Recibí la copa que me entregaba Yavé, y se la di a beber a todas las naciones a las que me envió:"
,"18":"(A Jerusalén y a las ciudades de Judá, sus reyes y sus príncipes, para que queden hechos una ruina, un espanto, una payasada, una maldición, como les está ocurriendo ahora.)"
,"19":"A Faraón, rey de Egipto, con sus ministros, sus príncipes y su pueblo,"
,"20":"y a todos los países del occidente, a todos los reyes de Us; a todos los reyes de los filisteos, a Ascalón, Gaza, Ecrón, y a lo que queda de Azoto;"
,"21":"a Edom, a Moab, a los hijos de Ammón;"
,"22":"a todos los reyes de Tiro, a todos los reyes de Sidón, a los reyes de las islas que están al otro lado del mar;"
,"23":"a Dedán, a Tema, a Buz y a todos los hombres de cabezas rapadas"
,"24":"que viven en el desierto,"
,"25":"a todos los reyes de Zimri, a todos los reyes de Elam y a todos los reyes de Media;"
,"26":"a todos los reyes del norte, los que están cerca y los que están lejos, uno detrás de otro; y a todos los reinos que existen sobre la tierra."
,"27":"Y les dirás: 'Esta es la orden de Yavé de los Ejércitos, el Dios de Israel: Tomen, emborráchense, vomiten; caigan al suelo sin poder levantarse bajo la espada que dirigiré contra ustedes.'"
,"28":"Y si se niegan a tomar de la copa que tú les presentes, les dirás: 'Esto les dice Yavé: Ustedes tienen que beber,"
,"29":"porque la ciudad que lleva mi nombre es la primera que empiezo a castigar, ¿y ustedes quedarían sin castigo? No, porque yo mismo dejaré caer la espada contra todos los habitantes de la tierra', dice Yavé de los Ejércitos."
,"30":"Y tú les comunicarás todas estas cosas y les dirás: Ruge Yavé desde lo alto, y grita desde su santa morada. Ruge con fuerza contra su corral y lanza gritos como los que pisan la uva en el lagar. A todos los habitantes de la tierra, hasta el fin del mundo, ha llegado el eco de su voz. "
,"31":"Pues Yavé abre el proceso de todas las naciones, pone pleito a todo mortal, y a los impíos los condena a la espada, dice Yavé."
,"32":"Y añade Yavé: La catástrofe se extiende de nación en nación, y una tempestad inmensa estalla desde los confines de la tierra."
,"33":"Y las víctimas de Yavé se extenderán de uno al otro extremo de la tierra; no las recogerán ni las enterrarán, sino que quedarán tiradas por el suelo como guano."
,"34":"Pastores, lancen alaridos y griten, revuélquense en la tierra, dueños del rebaño, porque a ustedes les toca ir al matadero,y ser ejecutados como carneros escogidos."
,"35":"No habrá salvación para los pastores,ni escapatoria para los dueños."
,"36":"Escuchen los gritos de los pastores,y los alaridos de los dueños del rebaño, porque Yavé ha destruido el pasto,"
,"37":"ya no hay vida en los potreros verdes,por el ardor de la cólera de Yavé."
,"38":"El león ha dejado su guarida, y la tierra se ha convertido en un desierto, bajo los golpes de la espada destructora."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Al comienzo del reinado de Joaquim, hijo de Josías, rey de Judá,"
,"2":"Yavé me dijo: 'Párate en el patio de la Casa de Yavé para decir mis advertencias a todas las ciudades del país de Judá que vienen aquí a postrarse ante mí. Tú les dirás cuanto yo te mande, sin suprimir nada."
,"3":"Puede ser que al escucharte se conviertan del mal que están haciendo. En tal caso, yo también renunciaré al castigo que pensaba darles por sus malas obras."
,"4":"Les dirás: Escuchen esta palabra de Yavé: Ustedes no me hacen caso ni andan según mi Ley, tal como se la enseñé. "
,"5":"Hasta ahora no han escuchado las palabras de los profetas que yo les mandé con insistencia. Si ustedes persisten en no escucharlos,"
,"6":"trataré a este templo como traté al santuario de Silo, y pondré a Jerusalén como ejemplo; todas las naciones de la tierra reconocerán que yo la maldije.'"
,"7":"Los sacerdotes, los profetas y todo el pueblo oyeron a Jeremías pronunciar estas palabras en la Casa de Yavé."
,"8":"En cuanto terminó de decir todo lo que Yavé le había ordenado, lo agarraron, diciendo: 'Vas a morir"
,"9":"por lo que has dicho en nombre de Yavé, que a este templo le pasará lo que a Silo y esta ciudad será arrasada y quedará sin habitantes.' Y se juntó todo el pueblo en torno a Jeremías en la Casa de Yavé."
,"10":"Al enterarse de esto, los jefes de Judá subieron desde el palacio del rey a la Casa de Yavé, donde se sentaron para juzgar el asunto a la entrada de la Puerta Nueva."
,"11":"Los sacerdotes y los profetas dijeron a los jefes y a todo el pueblo: 'Este hombre merece la muerte porque ha hablado de parte de Yavé contra esta ciudad, como ustedes mismos lo han escuchado.'"
,"12":"Respondió Jeremías: 'Yavé me ha enviado a decirles todas las palabras que han escuchado respecto de su templo y de esta ciudad."
,"13":"Ahora bien, corrijan su conducta y mejoren sus obras, escuchen la voz de Yavé, y él no ejecutará el mal con que los amenaza."
,"14":"En cuanto a mí, estoy en sus manos, hagan conmigo lo que les parezca bueno y justo."
,"15":"Pero sepan que yo soy inocente y, si me matan, cargarán con un crimen, tanto ustedes como la ciudad de Jerusalén y todos sus habitantes, porque es verdad que Yavé me ha enviado para decirles en forma directa todas estas palabras.'"
,"16":"Entonces los jefes, apoyados por todo el pueblo, dijeron a los sacerdotes y profetas: 'Este hombre no merece la muerte, realmente nos ha hablado en nombre de Yavé, nuestro Dios.'"
,"17":"Incluso se levantaron algunos de los ancianos del país y dijeron ante la gente reunida:"
,"18":"'Miqueas de Morasti, que profetizaba en tiempos de Ezequías, rey de Judá, dijo también públicamente: 'Sión llegará a ser un campo arado, Jerusalén se convertirá en un montón de ruinas, el cerro de la Casa de Yavé no será más que una colina abandonada.'"
,"19":"¿Acaso lo hicieron morir por eso Ezequías, rey de Judá, y su pueblo? Más bien temieron a Yavé e imploraron su perdón, hasta lograr que retirara el mal con que los había amenazado. Y nosotros, ¿cómo podríamos actuar de otra manera y cargar con un crimen?'"
,"20":"Hubo también otro hombre que profetizó en nombre de Yavé: Urías, hijo de Semaya, de Cariatiarim; él profetizó contra esta ciudad y contra este país exactamente lo mismo que Jeremías."
,"21":"El rey Joaquim, con todos sus oficiales y magistrados, al oír sus palabras, trató de darle muerte. Al tener noticia de eso, Urías, aterrorizado, huyó a Egipto."
,"22":"Pero el rey Joaquim envió a Egipto a algunos hombres a las órdenes de Elnatán, hijo de Acbor, que sacaron a Urías de Egipto"
,"23":"y lo condujeron al rey Joaquim, quien lo mandó matar al filo de la espada y arrojar su cadáver a la fosa común."
,"24":"En cuanto a Jeremías, gozaba del favor de Ajigam, hijo de Safán; por eso, no cayó en manos del pueblo que quería matarlo."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Al principio del reinado de Sedecías, hijo de Josías, rey de Judá,"
,"2":"le llegó a Jeremías una palabra de Yavé: 'Búscate unos cordeles y un yugo, y colócatelo al cuello,"
,"3":"pues tienes que entregar un mensaje al rey de Edom, al rey de Moab, al rey de los amonitas, al rey de Tiro y al rey de Sidón, por medio de sus embajadores que acaban de llegar a Jerusalén para entrevistarse con Sedecías, rey de Judá."
,"4":"Les darás estas instrucciones para sus señores: Aquí tienen una palabra de Yavé de los Ejércitos, Dios de Israel, comuníquensela a sus señores:"
,"5":"Yo hice, con mi gran poder y con mis intervenciones, la tierra, el hombre y los animales que existen sobre ella, y los doy a quien se me antoje."
,"6":"Ahora bien, acabo de entregar todos estos países a mi mayordomo Nabucodonosor, rey de Babilonia, y le he entregado hasta las bestias del campo para que le sirvan."
,"7":"Y todas las naciones dependerán de él, de su hijo y de su nieto, hasta que le llegue también el turno a su país; entonces los subyugarán poderosas naciones y grandes reyes."
,"8":"A la nación o reino que no se someta a Nabucodonosor, rey de Babilonia, ni agache su cabeza bajo el yugo del rey de Babilonia, los castigaré, dice Yavé, con espada, hambre y peste, hasta que los ponga en sus manos."
,"9":"No hagan, pues, caso ustedes a sus profetas, adivinos, soñadores, augures y hechiceros, que les dicen: 'Ustedes no serán súbditos del rey de Babilonia',"
,"10":"pues es falso lo que les profetizan; el resultado será que los barrerán a ustedes de su suelo, que yo los expulsaré y que ustedes perecerán."
,"11":"Pero a la nación que doble su cuello bajo el yugo del rey de Babilonia y le obedezca, la dejaré tranquila en su suelo, dice Yavé, y lo cultivará y vivirá en él.'"
,"12":"A Sedecías, rey de Judá, le hablé en los mismos términos, diciéndole: 'Pongan sus cuellos bajo el yugo del rey de Babilonia, sométanse a él y a su pueblo y vivirán."
,"13":"¿Acaso quieres morir tú y tu pueblo por la espada, el hambre y la peste, como Yavé lo ha amenazado a la nación que no quiera obedecer al rey de Babilonia?"
,"14":"No crean a los profetas que les dicen: 'Ustedes no serán súbditos del rey de Babilonia', pues es falso lo que les profetizan."
,"15":"Yo no los mandé, dice Yavé, y lo que anuncian en mi nombre no es cierto. Escúchame, no sea que yo los expulse, y mueran ustedes junto con los profetas que les anuncian eso.'"
,"16":"Y a los sacerdotes y a todo el pueblo me dirigí en estos términos: Así habla Yavé: 'No hagan caso de lo que les dicen sus profetas, cuando les aseguran que 'pronto volverán de Babilonia los utensilios de la Casa de Yavé', porque no es verdad lo que les profetizan."
,"17":"No les presten atención, sino que obedezcan al rey de Babilonia y vivirán; pues, ¿quieren que esta ciudad se convierta en un montón de ruinas?"
,"18":"Si fuesen profetas, si tuvieran la palabra de Yavé, rogarían a Yavé de los Ejércitos por los utensilios que todavía quedan"
,"20":"y de los cuales no se apoderó Nabucodonosor, rey de Babilonia, cuando se llevó cautivo a Jeconías y a todos los nobles de Judá y Jerusalén."
,"21":"Sí, esto es lo que dice Yavé de los Ejércitos, Dios de Israel, sobre los objetos que quedaron en la Casa de Yavé, en el palacio real y en Jerusalén:"
,"22":"También ellos serán llevados a Babilonia.'"
}`)
	CurrentBook.AddChapter(28, `{
"1":"Era el principio del reinado de Sedecías, rey de Judá. El mes quinto del cuarto año, el profeta Ananías, que era de Gabaón, se dirigió a mí delante de los sacerdotes y de toda la gente, mientras estaba en la Casa de Yavé. Me dijo:"
,"2":"'Así habla Yavé Sebaot, el Dios de Israel: He quebrado el yugo que les impuso el rey de Babilonia."
,"3":"Dentro de dos años haré devolver a este lugar todos los objetos de la Casa de Yavé;"
,"4":"haré también regresar a Jeconías, rey de Judá, y a todos los cautivos de Judá que fueron desterrados a Babilonia. Pues yo quebraré el yugo del rey de Babilonia, palabra de Yavé.'"
,"5":"Entonces Jeremías respondió a Ananías delante de los sacerdotes y de todo el pueblo: '¡Amén!"
,"6":"Haga Yavé que se cumplan tus palabras y que devuelvan todos los objetos de la Casa de Yavé y a todos los cautivos."
,"7":"Pero fíjate bien en lo que te voy a decir delante de todos."
,"8":"Los profetas que nos han precedido desde hace mucho tiempo, predijeron a muchos países y a grandes naciones guerra, hambre y peste."
,"9":"Por eso, un profeta que anuncia la paz no será reconocido como verdadero profeta, mandado por Yavé, mientras no se realice lo que él anunció.'"
,"10":"Entonces el profeta Ananías tomó el yugo que el profeta Jeremías llevaba sobre el cuello y lo rompió;"
,"11":"luego dijo a la gente: 'Esto les dice Yavé: Dentro de dos años romperé el yugo que Nabucodonosor impuso a todos los países.' Y el profeta Jeremías se marchó."
,"12":"Pero después Yavé dirigió a Jeremías su palabra:"
,"13":"'Anda a decir a Ananías: Has roto yugos de madera; en vez de ellos habrá yugos de hierro.'"
,"14":"Porque así habla Yavé: 'Yo pongo un yugo de hierro al cuello de todas estas naciones para someterlas a Nabucodonosor, rey de Babilonia, para que lo sirvan; a todos los he entregado a Nabucodonosor, hasta los animales del campo.'"
,"15":"Después Jeremías dijo a Ananías: 'Escúchame tú: Yavé no te ha enviado y tú has engañado a este pueblo dándole una falsa seguridad."
,"16":"Por eso así habla Yavé: Yo te echo de la superficie de la tierra y en el presente año vas a morir, por haber incitado a la rebelión contra Yavé.'"
,"17":"Y a los dos meses, aquel mismo año, murió Ananías."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Esta es la carta que el profeta Jeremías escribió desde Jerusalén a los ancianos que no habían muerto, sino que estaban cautivos, a los sacerdotes, profetas y al pueblo en general que Nabucodonosor había desterrado de Jerusalén a Babilonia."
,"2":"La escribió, después de salir de Jerusalén Jeconías, con la reina madre, sus sirvientes, los príncipes de Judá y de Jerusalén, los herreros y los cerrajeros."
,"3":"La llevaron a Elasa, hijo de Safán, y Gamarías, hijo de Elcías, a quienes Sedecías, rey de Judá, había enviado a Babilonia, para que se presentaran al rey Nabucodonosor. La carta decía así:"
,"4":"Así habla Yavé, Dios de Israel, a todos los judíos que ha desterrado de Jerusalén a Babilonia:"
,"5":"'Edifiquen casas y habítenlas; planten árboles y coman sus frutos; cásense y tengan hijos e hijas."
,"6":"Casen a sus hijos y a sus hijas para que se multipliquen y no disminuyan."
,"7":"Preocúpense por la prosperidad del país donde los he desterrado y rueguen por él a Yavé; porque la prosperidad de este país será la de ustedes.',Pues así habla Yavé: "
,"10":"'Cuando se cumplan los setenta años en Babilonia, los visitaré y cumpliré mi promesa de hacerlos volver a su país."
,"11":"Porque yo sé muy bien lo que haré por ustedes; les quiero dar paz y no desgracia y un porvenir lleno de esperanza, palabra de Yavé."
,"12":"Cuando me invoquen y vengan a suplicarme, yo los escucharé;"
,"13":"y cuando me busquen me encontrarán, siempre que me imploren con todo su corazón."
,"14":"Entonces haré que me encuentren; volverán sus desterrados, que yo reuniré de todos los países y de todos los lugares adonde los expulsé. Y luego los haré volver de donde fueron desterrados, palabra de Yavé."
,"15":"En cuanto a eso de que ustedes hablan: 'Yavé nos ha dado también aquí, en Babilonia, profetas',"
,"16":"así dice Yavé de los Ejércitos, Dios de Israel:"
,"8":"No se dejen engañar por los profetas, ni por los adivinos que hay entre ustedes, ni crean en sus sueños, fruto de su imaginación."
,"9":"Porque sin que yo los haya mandado se aprovechan de mi nombre para profetizar mentiras, dice Yavé. Respecto al que ocupa el trono de David y a toda la población de esta ciudad, hermanos de ustedes, que no los acompañaron en el destierro, "
,"17":"esto es lo que ha decidido Yavé de los Ejércitos: Voy a mandar contra ellos la espada, el hambre y la peste, y van a quedar como higos podridos, que de malos no se pueden comer."
,"18":"Los perseguiré con la espada, el hambre y la peste. Producirán terror a todos los reinos de la tierra, y serán motivo de maldición, de admiración, de burla y de risa para todas las naciones adonde los arroje."
,"19":"Pues no quisieron hacerme caso, dice Yavé, cuando les hablaba por medio de mis servidores los profetas, los que les estuve mandando sin parar. Se negaron a oírme."
,"20":"¡Pero ustedes, los desterrados que envié de Jerusalén a Babilonia, pongan atención a lo que les dice Yavé!"
,"21":"'Sobre Ajab, hijo de Colaya, y Sedecías, hijo de Masaya, que abusaron de mi nombre para anunciar mentiras, esto es lo que dice Yavé de los Ejércitos, Dios de Israel: Los entregaré a Nabucodonosor, rey de Babilonia, que les dará muerte en presencia de ustedes mismos."
,"22":"Y su caso dará pie para esta maldición, que usarán corrientemente todos los desterrados judíos que están en Babilonia: 'Que Yavé te trate como a Sedecías y a Ajab, que fueron asados al fuego por el rey de Babilonia.'"
,"23":"Porque hicieron algo que es una infamia en Israel, a saber, cometieron adulterio con las mujeres de sus compañeros y anduvieron diciendo en mi nombre cosas que yo no les había mandado, dice Yavé.' Yo, sin embargo, lo sé y soy testigo, palabra de Yavé."
,"24":"Semaías, de Nejelam,"
,"25":"despachó en su propio nombre cartas al sacerdote Sofonías, hijo de Masaya, que decían:"
,"26":"'Yavé te ha puesto como sacerdote en lugar de Joyada, para que detengas en la Casa de Yavé a cualquier fanático que quiera pasar por profeta, y le amarres las manos y lo metas en el calabozo."
,"27":"Entonces, ¿por qué no has prohibido actuar a Jeremías de Anatot, que se las da de profeta entre ustedes?"
,"28":"Ya que nos ha enviado a Babilonia este mensaje: 'Su permanencia por allá será larga. Construyan casas y habítenlas; planten árboles frutales y aprovechen sus frutos.'"
,"29":"Habiendo leído el sacerdote Sofonías esta carta a Jeremías,"
,"30":"Yavé le dirigió la palabra al profeta: Manda este recado a los desterrados:"
,"31":"'Esto es lo que piensa hacer Yavé con Semaías de Nejelam por haber profetizado sin autorización haciéndoles creer en mentiras:"
,"32":"Yo castigaré a Semaías de Nejelam y a su familia. Ninguno de los suyos habitará en medio de este pueblo ni verá el bien que voy a hacer a mi pueblo, dice Yavé, porque ha empujado a mi pueblo a la desobediencia contra Yavé.'"
}`)
	CurrentBook.AddChapter(30, `{
"1":"Palabra de Yavé a Jeremías."
,"2":"Estas son las palabras de Yavé, Dios de Israel: Escribe todo lo que te he comunicado en un libro,"
,"3":"pues se acerca el tiempo, dice Yavé, en que cambiaré la suerte de mi pueblo, Israel y Judá, haciéndoles retornar a la tierra que di a sus padres en propiedad."
,"4":"Así se ha expresado Yavé, de Israel y de Judá:"
,"5":"Esto dice Yavé: He oído un grito de terror, de pánico, no de paz."
,"6":"Pregunten y miren: ¿han visto que un hombre esté esperando un hijo?,Pues entonces, ¿por qué veo a los hombres,con las manos en las caderas,como mujer que da a luz,y sus caras se han puesto amarillas?"
,"7":"¡Ay! ¡Porque es grande este día,y como él no habrá otro igual!,Es una época de catástrofe para Jacob, de la que, sin embargo, se salvará."
,"8":"Cuando llegue aquel día, dice Yavé de los Ejércitos, quebraré el yugo que pesa sobre su cuello y romperé sus ataduras. Ya no estarán más sometidos a extranjeros,"
,"9":"sino que servirán a Yavé, su Dios, y a David, el rey que yo les pondré."
,"10":"No temas, pues, servidor mío, Jacob, dice Yavé, ni te asustes, Israel, porque yo acudo, desde lejos, para sacarte a ti y a tus hijos del país en que están cautivos. Jacob volverá y encontrará la paz y vivirá tranquilo, sin que nadie lo moleste."
,"11":"Yo estoy contigo para salvarte. Reduciré a la nada a todas las naciones por donde te disperse; pero a ti no te aniquilaré, sino que te corregiré como es debido, ya que no te dejaré sin castigo."
,"12":"Así continúa Yavé: Tu herida es incurable, es una llaga dolorosa."
,"13":"No hay nadie para hacerte justicia,ni hay remedio que te sane."
,"14":"¡Todos tus amantes te olvidaron, ya no se interesan por ti!,Sí, yo te he herido como hiere el enemigo, con un golpe seco, por tu enorme culpa y por tus numerosos pecados."
,"15":"¿Por qué te quejas de tus heridas, y por qué tu dolor no se puede calmar?,Por tu enorme culpa, por tus numerosos pecados te he hecho esto."
,"16":"Sin embargo, todos los que te devoran serán devorados, todos tus opresores irán al destierro, todos tus saqueadores serán saqueados, y los que te desprecian pasarán a ser despreciados."
,"17":"Ya que a ti te llamaban La Abandonada, nuestra presa, de quien nadie se preocupa, yo voy a devolver el vigor a tu cuerpo y voy a sanar tus llagas, dice Yavé."
,"18":"Yavé lo asegura: Volverán los cautivos a las carpas de Jacob, pues me compadeceré de estas moradas; la ciudad será reedificada sobre sus ruinas, y el fuerte se levantará en su antiguo lugar."
,"19":"Y allí resonarán los cantos de acción de gracias y los gritos de alegría. Los multiplicaré en vez de disminuirlos, los honraré en lugar de humillarlos. "
,"20":"Sus hijos serán como antes, su asamblea permanecerá delante de mí y castigaré a todos sus opresores."
,"21":"Su soberano será uno de ellos, pues saldrá de su mismo seno. Le daré audiencia y se acercará a mí; pues, ¿quién es el que se halla capaz de arriesgar su vida para acercarse a mí?, dice Yavé."
,"22":"Y ustedes serán mi pueblo y yo seré su Dios."
,"23":"Miren cómo estalla la tempestad de Yavé y cómo se desencadena su temporal y se descarga sobre la cabeza de los impíos;"
,"24":"la cólera de Yavé no se apaciguará hasta que no haya él cumplido y realizado el propósito de su corazón. En el futuro ustedes entenderán bien todas estas cosas."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Entonces, dice Yavé, yo seré el Dios de todas las familias de Israel, y ellos serán mi pueblo."
,"2":"Esto dice Yavé: El pueblo que se salvó de la espada enfrenta la calor del desierto, Israel se está dirigiendo al lugar de su reposo."
,"3":"De lejos Yavé se le apareció: 'Con amor eterno te he amado, por eso prolongaré mi cariño hacia ti."
,"4":"Volveré a edificarte y serás reedificada, virgen de Israel."
,"5":"De nuevo lucirás tu belleza bailando, alegremente, con tus panderetas. De nuevo plantarás viñas en los cerros de Samaria, como antes las plantaban los viñadores y las cosechaban."
,"6":"Vendrá un día en que los centinelas gritarán desde los cerros de Efraím: '¡Levántense, subamos a Sión, adonde está Yavé nuestro Dios!'"
,"7":"Y añade Yavé: ¡Vitoreen con alegría a Jacob, aclamen a la primera de las naciones! Háganse escuchar, celébrenlo y publíquenlo: '¡Yavé ha salvado a su pueblo, al resto de Israel!'"
,"8":"Miren cómo los traigo del país del norte, y cómo los junto de los extremos del mundo. Están todos, ciegos y cojos, mujeres encinta y con hijos, y forman una multitud que vuelve para acá."
,"9":"Partieron en medio de lágrimas, pero los hago regresar contentos; los voy a llevar a los arroyos por un camino plano para que nadie se caiga. Pues he llegado a ser un padre para Israel y Efraím es mi primogénito."
,"10":"Que todas las naciones escuchen la palabra de Yavé; proclámenla en las islas lejanas: 'El que dispersó a Israel, lo reunirá y lo cuidará como un pastor a su rebaño.'"
,"11":"Porque Yavé ha rescatado a Jacob y lo ha librado de las manos del poderoso."
,"12":"Vendrán, cantando de alegría, al cerro de Sión, y acudirán para gozar de los regalos de Yavé, del trigo, vino y aceite, de las ovejas y bueyes. Su alma será como un huerto bien regado, y no volverán más a estar desganados."
,"13":"Entonces la muchacha bailará de alegría, jóvenes y viejos vivirán felices; cambiaré su tristeza en alegría, los consolaré, los haré reír después de sus penas."
,"14":"Daré a los sacerdotes harta manteca y mi pueblo quedará satisfecho con mis regalos, dice Yavé."
,"15":"Esto dice Yavé: En Ramá se han oído unos quejidos y un amargo lamento: es Raquel que llora a sus hijos y no quiere que la consuelen, pues ya no están."
,"16":"Así dice Yavé: Deja de lamentarte, y seca el llanto de tus ojos, ya que tu prueba tendrá su recompensa: tus hijos volverán del país enemigo."
,"17":"Ten esperanza para el futuro, pues tu descendencia regresará a su tierra."
,"18":"Escucho, escucho quejarse a Efraím: 'Me has pegado, y he sido castigado muy duro, como un novillo no domado; haz que yo vuelva y volveré, ya que tú eres Yavé, mi Dios."
,"19":"Si bien me he descarriado, ahora me arrepiento, me doy cuenta y me golpeo el pecho. Estoy avergonzado y confundido, pues pesa sobre mí mi infame juventud.'"
,"20":"¿No es Efraím para mí un hijo predilecto, o un niño mimado, para que después de cada amenaza deba siempre pensar en él, y por él se conmuevan mis entrañas y se desborde mi ternura?, palabra de Yavé."
,"21":"Coloca señales, pon en su lugar las marcas; fíjate bien en la ruta, en el camino por el que te has ido. Vuelve, Virgen de Israel, vuelve a estas ciudades, que son tuyas."
,"22":"¿Hasta cuándo andarás de aquí para allá, hija rebelde?,Porque Yavé ha presentado,una cosa nueva en la tierra: la mujer es la que busca a su marido."
,"23":"Estas son las palabras de Yavé de los Ejércitos, Dios de Israel: 'Usarán nuevamente esta expresión en Judá y en sus ciudades, cuando yo haya mejorado su suerte: ¡Que Yavé te bendiga, oh morada de Justicia, monte santo!"
,"24":"Allí se restablecerá Judá con todas sus ciudades; cultivarán la tierra y cuidarán sus rebaños."
,"25":"Yo daré de beber al alma agotada y saciaré a la que se desmaya.'"
,"26":"Entonces fue cuando me desperté, y vi que mi sueño había sido muy bueno."
,"27":"Se aproximan días, dice Yavé, en que sembraré en la casa de Israel y en la de Judá semilla de hombres y semilla de animales."
,"28":"Y del mismo modo que me preocupé por arrancarlos, destruirlos, demolerlos, acabarlos y perjudicarlos, así también estaré atento para edificarlos y plantarlos, dice Yavé."
,"29":"Entonces no andarán diciendo más: 'Los padres comieron uvas agrias y los hijos sufren dentera',"
,"30":"sino que cada uno morirá por su propio pecado. El que coma uvas agrias sufrirá dentera."
,"31":"Ya llega el día, dice Yavé, en que yo pactaré con el pueblo de Israel (y con el de Judá) una nueva alianza."
,"32":"No será como esa alianza que pacté con sus padres, cuando los tomé de la mano, sacándolos de Egipto. Pues ellos quebraron la alianza, siendo que yo era su Señor."
,"33":"Esta es la alianza que yo pactaré con Israel en los días que están por llegar, dice Yavé: pondré mi ley en su interior, la escribiré en sus corazones, y yo seré su Dios y ellos serán mi pueblo."
,"34":"Ya no tendrán que enseñarle a su compañero, o a su hermano, diciéndoles: 'Conozcan a Yavé.' Pues me conocerán todos, del más grande al más chico, dice Yavé; yo entonces habré perdonado su culpa, y no me acordaré más de su pecado."
,"35":"Así se expresa Yavé, que ha puesto el sol para alumbrar el día, la luna y las estrellas para iluminar la noche, que agita el mar y hace bramar sus olas, y que se llama Yavé de los Ejércitos:"
,"36":"Si llegara a fallar este orden ante mí, dice Yavé, entonces la raza de Israel dejaría también de ser la nación que me sirve para siempre."
,"37":"Si pudieran medirse los cielos por arriba y sondear por abajo los cimientos de la tierra, entonces yo también rechazaría a toda la raza de Israel por todo lo que ha hecho, dice Yavé."
,"38":"Se acerca el tiempo, dice Yavé, en que la ciudad de Yavé será reconstruida desde la torre de Jananeel hasta la puerta del Angulo."
,"39":"Y el cordel para medir será tirado en línea recta hasta la colina de Gareb, dando la vuelta después hacia Goat."
,"40":"Y todo el valle de los muertos y de la ceniza, y los campos que limitan con el torrente de Cedrón hasta la esquina de la Puerta de los Caballos, al este, serán consagrados a Yavé. ¡Ya no volverán a ser destruidos ni declarados malditos!"
}`)
	CurrentBook.AddChapter(32, `{
"1":"Esta es la palabra de Yavé que fue dirigida a Jeremías el año décimo del reinado de Sedecías, rey de Judá, o sea el año dieciocho de Nabucodonosor."
,"2":"En ese entonces, el ejército del rey de Babilonia sitiaba a Jerusalén y el profeta Jeremías se hallaba detenido en el patio de la guardia del palacio real de Judá,"
,"3":"donde lo había mandado encerrar el rey Sedecías, con esta acusación: '¿Por qué andas diciendo en nombre de Yavé: Yo pondré esta ciudad en manos del rey de Babilonia, quien la tomará;"
,"4":"y Sedecías, rey de Judá, no escapará de manos de los caldeos, sino que será entregado, sin remedio, al rey de Babilonia, a quien podrá hablarle frente a frente y verlo cara a cara,"
,"5":"Sedecías será conducido a Babilonia y allí estará hasta que lo visite, dice Yavé. Y aunque ustedes peleen con los caldeos, no ganarán.'"
,"6":"En ese tiempo dijo Jeremías: Una palabra de Yavé me ha llegado, esto me dice:"
,"7":"'Hanamel, hijo de tu tío Selum, va a venir a verte para decirte: Cómprate mi campo, que tengo en Anatot, porque a ti te toca comprarlo por derecho de rescate.'"
,"8":"En efecto, de acuerdo a las palabras de Yavé, Hanamel, mi primo, vino a verme al patio de la guardia y me dijo: 'Compra mi campo de Anatot, pues tú tienes el derecho de propiedad y el rescate te interesa; cómpralo.',Comprendí, entonces, que era una orden de Yavé; "
,"9":"compré ese campo a mi primo Hanamel de Anatot y le pagué como precio diecisiete siclos de plata."
,"10":"Después hice la escritura de compra y la sellé, busqué unos testigos y pesé la plata en una balanza."
,"11":"En seguida, tomé la escritura de compra, su ejemplar sellado y la copia abierta,"
,"12":"según las prescripciones de la Ley, y se la entregué a Baruc, hijo de Nerías, hijo de Masías, en presencia de mi primo Hanamel, de los testigos que habían firmado la escritura de compra, y de todos los judíos que se encontraban en el patio de la guardia."
,"13":"Delante de ellos di esta orden a Baruc:"
,"14":"Toma estos documentos, esta escritura de compra, el ejemplar sellado junto con la copia abierta, y colócalos en un cántaro de greda, a fin de que puedan conservarse mucho tiempo;"
,"15":"porque esto es lo que asegura Yavé de los Ejércitos, Dios de Israel: 'Todavía se comprarán casas, campos y viñas en este país.'"
,"16":"Después de haber entregado a Baruc, hijo de Nerías, la escritura de compra, dirigí a Yavé esta oración:"
,"17":"'Ah, Señor Yavé, tú has hecho los cielos y la tierra con tu inmenso poder y con la fuerza de tu brazo. ¡Para ti nada es imposible!"
,"18":"Tú mantienes tu bondad por mil generaciones, pero castigas la falta de los padres en sus hijos. ¡Oh Dios grande y poderoso, que te llamas Yavé de los Ejércitos,"
,"19":"grande en tus proyectos y poderoso en tus realizaciones; tú tienes los ojos fijos en la conducta de los humanos para pagar a cada uno según su conducta y según el fruto de sus obras!"
,"20":"Tú que realizaste maravillas y prodigios, primero en Egipto y luego en Israel y en la humanidad entera hasta hoy, te has hecho famoso con todo eso, como se puede ver actualmente."
,"21":"Tú sacaste a tu pueblo Israel de Egipto, en medio de milagros y prodigios, actuando con mano firme y dando grandes golpes, provocando un gran terror."
,"22":"Después tú le diste esta tierra, que habías prometido con juramento a sus padres, tierra de donde brota leche y miel."
,"23":"Llegaron a ella y se adueñaron de ella, pero no escucharon tu voz ni se portaron de acuerdo a tus mandamientos. Y como no hicieron nada de lo que tú les habías ordenado, tú mandaste contra ellos todas estas calamidades."
,"24":"Pues bien ahora los terraplenes que se han construido para asaltar la ciudad ya están llegando a ella, y la ciudad va a caer en manos de los caldeos, que la atacan a espada, hambre y peste. Todo lo que tú anunciaste se está cumpliendo, como tú lo ves."
,"25":"¡Y a pesar de todo, tú, oh Señor Yavé, me dices: 'Cómprate este campo con plata, y toma testigos', justamente cuando la ciudad está a punto de ser conquistada por los caldeos!'"
,"26":"Entonces Yavé me respondió en estos términos:"
,"27":"'Mira, yo soy Yavé, el Dios de todos los mortales; para mí nada es imposible."
,"28":"Pues bien, afirma Yavé, voy a entregar esta ciudad en manos de los caldeos y de Nabucodonosor, rey de Babilonia, que se apoderará de ella;"
,"29":"los caldeos, que están atacando a esta ciudad, entrarán y le prenderán fuego; arderán todas las casas en cuyas terrazas se quemó incienso a Baal y se derramó vino en honor de otros dioses, para provocarme."
,"30":"Pues los hijos de Israel y los de Judá no han hecho otra cosa, desde su juventud, más que disgustarme; sí, los hijos de Israel no han hecho más que molestarme con las obras de sus manos, dice Yavé."
,"31":"Esta ciudad ha sido el blanco de mi rabia y furor desde el día en que la edificaron hasta el día de hoy, y tendré que venir a hacerla desaparecer de mi vista,"
,"32":"debido a todas las maldades que han cometido para hacerme enojar los hijos de Israel y de Judá, ellos, sus reyes, sus príncipes, sus sacerdotes, sus profetas, los hombres de Judá y los habitantes de Jerusalén."
,"33":"Me han dado la espalda en vez de la cara, y mientras yo trataba de instruirlos continuamente, nadie me puso atención para aprender la lección."
,"34":"Han instalado sus ídolos hasta en la Casa sobre la cual descansa mi Nombre, para ensuciarla."
,"35":"Han construido, además, altares a Baal, en el valle de Ben-Hinón, para quemar en el fuego a sus hijos e hijas en honor a Moloc, cosa que yo jamás les ordené, ni tampoco se me pasó por la mente que practicarían tales infamias para hacer pecar a Judá.'"
,"36":"Así habla Yavé respecto de Jerusalén, en el momento en que ustedes la ven entregada al rey de Babilonia por la espada, por el hambre y por la peste. Yavé dice:"
,"37":"'Yo los reuniré de todos los países adonde los empujé cuando estaba tan enojado, indignado y encolerizado. Los haré regresar a este lugar y haré que vivan seguros en él."
,"38":"Ellos serán mi pueblo y yo seré su Dios."
,"39":"Y les daré un solo corazón y una sola manera de vivir, para que guarden siempre mi temor, para bien de ellos y de sus hijos después de ellos."
,"40":"Pactaré con ellos una alianza eterna y no dejaré de acompañarlos para hacerles favores. Infundiré mi temor en su corazón para que no se aparten de mí."
,"41":"Me alegrará hacerles bien, y los plantaré sólidamente en esta tierra, con todo el empeño de mi corazón.'"
,"42":"Así dice Yavé: 'Así como mandé sobre este pueblo tanta desgracia, así traeré sobre ellos todo el bien que ahora les prometo."
,"43":"En aquel tiempo comprarán campos en este país que ustedes consideran como un desierto, al quedar sin hombres ni animales, a merced de los caldeos."
,"44":"De nuevo se comprarán campos y se firmarán contratos con sellos y con testigos, tanto en las tierras de Benjamín y en los alrededores de Jerusalén como en las ciudades de Judá, de la llanura, de los cerros y del sur. Pues yo haré volver a sus cautivos, palabra de Yavé.'"
}`)
	CurrentBook.AddChapter(33, `{
"1":"Estando Jeremías todavía preso en el patio de la guardia, la palabra de Yavé le llegó por segunda vez, de esta manera:"
,"2":"Esto dice Yavé, que hizo la tierra, dándole forma y firmeza, y cuyo nombre es Yavé."
,"3":"Llámame y te responderé; te mostraré cosas grandes y secretas que tú ignoras."
,"4":"Pues, respecto de las casas de esta ciudad y de los palacios reales, que van a ser demolidos, para servir de trincheras y de muros de defensa contra los caldeos,"
,"5":"Yavé, Dios de Israel, dice que esto no conducirá a otra cosa que a llenar la ciudad de cadáveres; allí estarán aquellos a quienes haya yo derribado con rabia y furor, y cuya maldad fue causa de que yo no quisiera mirar más a esta ciudad."
,"6":"Yo, sin embargo, me apresuraré a que se restablezcan y mejoren; les devolveré la salud y les haré gozar de mucha paz y seguridad."
,"7":"Cambiaré la suerte de Judá y la de Jerusalén y los volveré a construir como antes."
,"8":"Los limpiaré de todos esos pecados con que me ofendieron y se rebelaron contra mí."
,"9":"Y Jerusalén será para mí motivo de alegría, de honor y de gloria ante todas las naciones de la tierra. El mundo entero, al oír todo el bien que voy a hacer a los míos, se asustará y temblará de tanta felicidad y paz que les concederé."
,"10":"Ustedes dicen que este lugar está abandonado, sin habitantes ni ganados. Pero así dice Yavé: En todas las ciudades de Judá y en las calles desoladas de Jerusalén, ahora sin habitantes ni ganados, aún se oirán"
,"11":"gritos de gozo y de alegría, canción del novio y de la novia, voz de los que traigan sacrificios de alabanza a la Casa de Yavé. Y dirán éstos: 'Alaben a Yavé porque es bueno, porque es eterno su amor.' Pues haré volver a los que fueron desterrados, y estarán como antes."
,"12":"Así dice Yavé Sabaot: En este lugar sin habitantes ni ganados, y en todas las ciudades, habrá pastos y pastores que hagan acostarse a las ovejas"
,"13":"en las ciudades de la Montaña y en las de la Tierra Baja, en las del Negueb y en la tierra de Benjamín. En los alrededores de Jerusalén y en las ciudades de Judá volverán a pasar las ovejas bajo la mano del que las cuente, dice Yavé."
,"14":"Se acerca ya el momento, dice Yavé, en que cumpliré la promesa que hice a la gente de Israel y a la de Judá:"
,"15":"En esos días, haré nacer un nuevo brote de David que ejercerá la justicia y el derecho en el país."
,"16":"Entonces Judá estará a salvo, Jerusalén vivirá segura y llevará el nombre de 'Yavé es nuestra justicia'."
,"17":"Pues lo afirma Yavé: Nunca le faltará a David un descendiente para que se siente en el trono de Israel,"
,"18":"ni tampoco les faltará a los sacerdotes y levitas un hombre que, en presencia mía, ofrezca holocaustos, queme incienso de oblación y celebre el sacrificio cada día."
,"19":"En seguida Yavé se dirigió a Jeremías con estas palabras:"
,"20":"Si ustedes pudieran alterar el orden acordado por mí entre el día y la noche, de tal manera que no sea de día o de noche cuando corresponda,"
,"21":"entonces podría romper también mi alianza con David, mi siervo, para que no haya ningún hijo suyo que pueda ocupar el trono del rey, y con los sacerdotes y levitas que me sirven."
,"22":"Multiplicaré la descendencia de David, mi servidor, y de los levitas, para que continúen en mi servicio, como el ejército de los cielos que no se puede contar, o como la arena del mar que no se puede calcular."
,"23":"Una palabra de Yavé llegó a Jeremías:"
,"24":"¿No te has fijado en lo que esta gente comenta? Que Yavé ha dejado a un lado a las dos familias que había escogido, y, por eso, desprecian a mi pueblo, que para ellos ya no es una nación."
,"25":"Mas Yavé sostiene: Si no es cierto que yo hice el día y la noche, ni establecí leyes para el cielo y la tierra,"
,"26":"en ese caso ¡tampoco me preocuparé de la familia de Jacob y de David, mi servidor, ni tomaré más de entre sus descendientes a quienes gobiernen la posteridad de Abraham, de Isaac y de Jacob!; pues quiero que vuelvan de su cautiverio y demostrarles así compasión."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Estas fueron las palabras que Yavé dirigió a Jeremías, mientras el rey de Babilonia, Nabucodonosor, con todo su ejército, con todos los reinos de la tierra sometidos a su poder y todos los pueblos, atacaban a Jerusalén y a todas las ciudades de Judá."
,"2":"Esta fue la palabra de Yavé, Dios de Israel: Anda a decirle a Sedecías, rey de Judá, lo que piensa Yavé. Muy pronto dejaré que esta ciudad caiga en manos del rey de Babilonia, quien la incendiará."
,"3":"Y tú no creas que te vas a escapar de él, sino que caerás prisionero y serás entregado en sus manos. Verás al rey de Babilonia cara a cara y le hablarás frente a frente. Luego partirás a Babilonia."
,"4":"Sin embargo, atiende esta palabra de Yavé, oh Sedecías, rey de Judá: Tú no morirás a espada, sino en paz."
,"5":"Y así como se quemaron perfumes para tus antepasados, los reyes que gobernaron antes que tú, así también se quemarán en tu honor y se recitará por ti la lamentación '¡Ay, Señor!', pues soy yo quien lo afirma, dice Yavé."
,"6":"El profeta Jeremías refirió todo esto a Sedecías, rey de Judá, en Jerusalén,"
,"7":"mientras el ejército del rey de Babilonia atacaba a Jerusalén y a las ciudades de Judá que aún quedaban, a saber Laquis y Azecá, que eran las únicas que todavía resistían de todas las ciudades de Judá, pues eran ciudades fortificadas."
,"8":"Palabras que Yavé dirigió a Jeremías con respecto a la liberación de los esclavos. El rey Sedecías de acuerdo con el pueblo de Jerusalén, había proclamado solemnemente una liberación, "
,"9":"y cada uno debía dejar libres a sus esclavos de raza hebrea, hombres o mujeres. Nadie debía mantener en esclavitud a uno de sus hermanos judíos."
,"10":"Todas las autoridades y el pueblo habían entendido el compromiso que tomaban y despidieron a sus esclavos."
,"11":"Pero pronto cambiaron de parecer y los mandaron a buscar, reduciéndolos otra vez a la esclavitud."
,"12":"Entonces Jeremías recibió esta palabra de Yavé:"
,"13":"'Yo hice una alianza con sus padres el día que los saqué de Egipto, de la casa de la esclavitud, y les dije:"
,"14":"Al cabo de siete años cada uno de ustedes dejará libre a su hermano. La persona de raza hebrea que se haya vendido a ti estará a tu servicio seis años y luego la despedirás libre. Pero sus padres no me escucharon ni se fijaron en esto."
,"15":"Ustedes, sin embargo, se convirtieron hace poco e hicieron según mi deseo, proclamando la libertad de sus hermanos. Ese compromiso se tomó en mi presencia, en la casa que mi Nombre ha santificado."
,"16":"Pero ustedes se arrepintieron después y profanaron mi Nombre, pues cada uno fue a buscar a su esclavo o a su sirvienta para hacerlos esclavos de nuevo.'"
,"17":"Por lo tanto, así dice Yavé: 'Ustedes no me han escuchado al no conceder la libertad a su prójimo. Pues bien, voy a dejar libres contra ustedes a la espada, a la peste y al hambre, y llegarán a ser un ejemplo espantoso para todas las naciones de la tierra."
,"18":"Esos hombres que firmaron el acuerdo y que después violaron el acuerdo que se tomó en mi presencia, todos esos tendrán una suerte parecida a la del ternero que partieron para luego pasar entre sus pedazos."
,"19":"Hablo de los jefes de Judá y de Jerusalén, de los oficiales y de los sacerdotes, y de todos los propietarios que pasaron entre las mitades del ternero."
,"20":"Los entregaré a sus enemigos, y sus cadáveres serán pasto de las aves y de las fieras."
,"21":"Entregaré también a Sedecías, rey de Judá, y a sus oficiales en manos de sus adversarios, o sea, al ejército del rey de Babilonia que acaba de retirarse."
,"22":"Pues ahora les doy una orden para que vuelvan. Atacarán esta ciudad y la tomarán para pegarle fuego. Y de las ciudades de Judá no quedarán más que ruinas solitarias.'"
}`)
	CurrentBook.AddChapter(35, `{
"1":"Esta es la palabra de Yavé que llegó a Jeremías cuando reinaba en Judá Joaquim, hijo de Josías:"
,"2":"Anda a ver a los recabitas, conversa con ellos, llévalos a la Casa de Yavé y, en uno de sus departamentos, sírveles vino."
,"3":"Fui, pues, a ver a Jezonías, hijo de Jeremías y nieto de Habsanías, a sus hermanos, a todos sus hijos, en una palabra, a toda la familia de los recabitas,"
,"4":"y los llevé a la Casa de Yavé, al departamento de Ben Yojanán, hijo de Jegdelías, hombre de Dios; ése está al lado del departamento de los jefes y encima del que tiene Masías, hijo de Selum, guardián de la puerta."
,"5":"Coloqué delante de los miembros de la comunidad recabita jarros y copas llenas de vino y les dije: 'Sírvanse vino.'"
,"6":"Pero contestaron: 'No podemos tomar vino porque Jonadab, hijo de Recab, nuestro antepasado, nos prohibió hacerlo, diciéndonos: 'Ninguno de ustedes ni de sus hijos probará jamás el vino,"
,"7":"ni construirá casas, ni hará siembras, ni plantará viñas, ni tendrá propiedades, sino que durante toda su vida vivirán en carpas para que vivan largos años en la tierra, en que son ustedes extranjeros.'"
,"8":"Nosotros hemos cumplido fielmente lo que nos ordenó nuestro padre Jonadab, hijo de Recab, y así ninguno de nosotros, ni nuestras mujeres ni nuestros hijos ni nuestras hijas,"
,"9":"tomamos nunca vino, ni edificamos casas para vivir, ni tenemos viñas ni campos sembrados,"
,"10":"sino que habitamos en carpas. Hemos obedecido siempre todas las órdenes que nos dio nuestro antepasado Jonadab."
,"11":"Sólo que cuando Nabucodonosor, rey de Babilonia, invadió nuestro país, nos dijimos: 'Vamos a Jerusalén para escapar del ejército de los caldeos y del de Siria.' Y nos hemos establecido en Jerusalén.'"
,"12":"Entonces Yavé habló a Jeremías de nuevo:"
,"13":"Esto dice Yavé de los Ejércitos, el Dios de Israel: Anda a decirles a los hombres de Judá y a los habitantes de Jerusalén: ¡Ojalá que esto les sirva de lección de cómo se obedecen mis palabras!, dice Yavé."
,"14":"Se han cumplido las órdenes de Jonadab, hijo de Recab, que prohibió a sus hijos tomar vino y no han bebido hasta la fecha por obedecer a la orden de su padre. En cambio, yo les he hablado a ustedes sin parar, insistentemente, y ustedes no me han escuchado."
,"15":"Les he mandado, repetidas veces, a todos mis servidores los profetas, con este aviso: Dejen el mal camino que llevan, mejoren de conducta, no anden tras otros dioses para adorarlos, y sólo entonces podrán quedarse en la tierra que les di a ustedes y a sus padres. Pero ustedes no me han oído ni me han hecho caso. "
,"16":"¡Mientras que los hijos de Jonadab, hijo de Recab, cumplieron la orden que les dejó su padre, este pueblo, en cambio, ni siquiera se ha parado a escucharme!"
,"17":"Pues bien, esto es lo que afirma ahora Yavé de los Ejércitos, el Dios de Israel: Yo voy a mandar sobre Judá y sobre los habitantes de Jerusalén toda suerte de calamidades con que los había amenazado, porque las avisé y no lo tomaron en cuenta, los llamé y no me respondieron."
,"18":"Y a la comunidad de los recabitas les dijo Jeremías: 'Esto declara Yavé de los Ejércitos, el Dios de Israel sobre ustedes: Ya que ustedes han obedecido a la orden de su antepasado Jonadab cumpliendo todo lo que les mandó y actuando como él quería,"
,"19":"por eso, lo dice Yavé de los Ejércitos, Dios de Israel: Jonadab, hijo de Recab, siempre tendrá descendientes para servirme.'"
}`)
	CurrentBook.AddChapter(36, `{
"1":"El año cuarto del reinado de Joaquim, hijo de Josías, rey de Judá, Jeremías recibió esta palabra de Yavé:"
,"2":"Toma un papel enrollado y apunta en él todo lo que te he comunicado sobre Jerusalén, Judá y todas las naciones, desde la fecha en que comencé a hablarte, en tiempos de Josías, hasta el día de hoy."
,"3":"A ver si, escuchando el pueblo de Judá el mal que he pensado hacerles, se aparta de su mal camino y puedo yo, entonces, perdonarles su culpa y sus pecados."
,"4":"Jeremías mandó llamar a Baruc, hijo de Nerías, a quien dictó, para que anotara en el papel enrollado todo cuanto Yavé le había comunicado al profeta."
,"5":"Jeremías mandó decirle a Baruc: 'Estoy detenido y no puedo ir a la Casa de Yavé,"
,"6":"así que tú mismo irás a leer este rollo en la Casa de Yavé. Cuando corresponda un día de ayuno lo leerás en voz alta a los judíos que vienen de sus ciudades."
,"7":"Tal vez supliquen a Yavé y se aparten de su mal camino, porque grandes son la indignación de Yavé y el castigo con que ha amenazado a este pueblo."
,"8":"Y Baruc, hijo de Nerías, hizo lo que le ordenó Jeremías, o sea, leer este libro en la Casa de Yavé."
,"9":"En el año quinto de Joaquim, rey de Judá, en el mes noveno, convocaron para un ayuno a toda la gente de Jerusalén y de las ciudades de Judá, y éstos vinieron a Jerusalén."
,"10":"Entonces Baruc leyó a todo el pueblo las palabras de Yavé contenidas en el libro, a la entrada de la Puerta Nueva de la Casa de Yavé, en la habitación de Guemarías, hijo de Safán."
,"11":"En cuanto Miqueas, hijo de Guemarías, oyó las palabras de Yavé escritas en el rollo,"
,"12":"bajó al palacio real, donde estaban reunidos todos los ministros. Ahí estaban el secretario Elisama, Dalaías, Gamarías, Elnatán, Sedecías, hijo de Hananías, y los demás ministros."
,"13":"Y Miqueas les refirió todo lo que había oído de la lectura pública de Baruc."
,"14":"Entonces los ministros enviaron a Judí, hijo de Natanías, a decir a Baruc: 'Toma el rollo que has leído y ven.' Baruc tomó el libro y fue donde ellos."
,"15":"Y le dijeron: 'Siéntate y léenoslo ahora a nosotros.'"
,"16":"Cuando oyeron todos estos discursos, se miraron uno al otro muy asustados y dijeron a Baruc: 'Tenemos que dar a conocer al rey todo esto.' "
,"17":"Y le preguntaron a Baruc: 'Explícanos de dónde has sacado todo lo que está escrito.'"
,"18":"Baruc les respondió: 'Jeremías me dictaba las palabras y yo las escribía con tinta en el libro.'"
,"19":"Los ministros dijeron a Baruc: 'Escóndanse, tú y Jeremías, sin que nadie sepa dónde están.'"
,"20":"Después fueron al patio donde estaba el rey, dejando el libro en la oficina del secretario Elisama, y contaron al rey todo lo que pasaba."
,"21":"El, entonces, mandó a Judí a buscar el libro. Este lo trajo y lo leyó al rey y a los ministros que estaban a su lado."
,"22":"El rey estaba ante un brasero, pues era invierno,"
,"23":"y cada vez que Judí acababa de leer tres o cuatro columnas, él recortaba las hojas con su cortaplumas y las arrojaba al fuego del brasero, hasta que todo el rollo se quemó."
,"24":"Ni el rey, ni ninguno de sus servidores se asustaron o se rasgaron las vestiduras al escuchar estas palabras."
,"25":"Por más que Elnatán, Dalaías y Gamarías suplicaran al rey que no quemara el rollo, no les hizo caso."
,"26":"En seguida, el rey ordenó a Jeramiel, a Seraías y a Selemías que tomaran preso al secretario Baruc y al profeta Jeremías, pero Yavé los ocultó."
,"27":"Después que el rey hubo quemado el rollo que contenía todo lo que había anotado Baruc y que le había dictado Jeremías, Yavé habló de nuevo a éste:"
,"28":"'Toma otro papel enrollado y vuelve a escribir en él todo lo que contenía el primero, y que fue quemado por Joaquim, rey de Judá."
,"29":"Y sobre este último pronuncia esta sentencia. Esto dice Yavé: Tú quemaste este rollo, diciendo: '¿Por qué has escrito en él: Vendrá sin falta el rey de Babilonia, destruirá esta tierra y hará desaparecer de ella hombres y animales?' "
,"30":"Pues bien, así dice Yavé a propósito de Joaquim, rey de Judá: No tendrá quien le suceda en el trono de David, y su propio cadáver quedará tirado, expuesto al calor del día y al frío de la noche."
,"31":"Le castigaré a él, a su familia y a su servidumbre por todas sus maldades, enviando sobre ellos, sobre los habitantes de Jerusalén y sobre los hombres de Judá todas las calamidades que les anuncié sin que me hicieran caso.'"
,"32":"Tomó, pues, Jeremías otro papel enrollado y se lo entregó a Baruc hijo de Nerías, el secretario, y le dictó para que anotara todas las cosas que contenía el libro quemado por Joaquim, rey de Judá. Y añadió, además, muchas otras cosas del mismo estilo."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Sedecías, hijo de Josías, sucedió en el trono a Konías, hijo de Joaquim. Nabucodonosor, rey de Babilonia, lo puso por rey del país de Judá."
,"2":"Pero ni él ni sus ministros ni la gente del país hicieron caso de las palabras que Yavé les había dirigido por medio del profeta Jeremías."
,"3":"El rey Sedecías ordenó a Jucal, hijo de Selemías, y al sacerdote Sofonías, hijo de Maseías, que fueran donde el profeta Jeremías con este recado: 'Ruega por nosotros a Yavé, nuestro Dios.'"
,"4":"Jeremías andaba, entonces, libremente en medio del pueblo, pues todavía no lo habían encarcelado."
,"5":"Por otra parte, los caldeos que estaban sitiando a Jerusalén, habiendo tenido noticia que el ejército de Faraón había salido de Egipto, se retiraron de la ciudad."
,"6":"En esa ocasión, Yavé habló a Jeremías en estos términos:"
,"7":"Así dice Yavé, Dios de Israel: Esta es la respuesta que entregarán ustedes al rey de Judá que los envió a consultarme: El ejército de Faraón que había salido de Egipto para ayudarlos, se volverá a su país,"
,"8":"y los caldeos volverán a atacar esta ciudad, se apoderarán de ella y la quemarán."
,"9":"Yavé les recomienda, pues, a ustedes, que no se engañen pensando que los caldeos se van a ir para siempre de aquí, pues ¡no se van a ir!"
,"10":"Aunque ustedes destrozaran todo el ejército de los caldeos y no les quedasen más que algunos heridos, se levantaría cada uno de ellos de su carpa e incendiaría la ciudad."
,"11":"Cuando los caldeos estaban sitiando a Jerusalén, les llegó la noticia de que un ejército de Faraón se acercaba, y se retiraron."
,"12":"Entonces, Jeremías salió de Jerusalén y se dirigió a su pueblo, en las tierras de Benjamín, para compartir con los suyos una herencia."
,"13":"Pero al pasar la puerta de la ciudad que lleva a Benjamín, el vigilante Jerías, hijo de Selemías, detuvo al profeta diciendo: 'Tú te pasas a los caldeos.'"
,"14":"Jeremías le respondió: 'Es falso, yo no me paso a los caldeos.' Pero el guardia no le hizo caso y lo llevó a los jefes."
,"15":"Estos, furiosos contra Jeremías, lo golpearon y lo encerraron en casa del secretario Jonatán, que habían convertido en cárcel."
,"16":"Así, pues, Jeremías fue puesto en un subterráneo y allí permaneció largo tiempo."
,"17":"El rey Sedecías mandó a buscarlo y lo interrogó en secreto, en su palacio: '¿Acaso tienes una palabra de Yavé?' 'Sí', respondió Jeremías, y agregó: 'Serás entregado en manos del rey de Babilonia.'"
,"18":"Entonces Jeremías preguntó: '¿Qué mal he cometido contra ti o tus servidores o contra este pueblo, para que me hayas encarcelado?"
,"19":"¿Dónde están los profetas que te decían: No vendrá el rey de Babilonia contra ustedes; no entrará en nuestro país?"
,"20":"Ahora bien, escucha por favor, mi señor; acoge mi súplica y no me vuelvas a enviar a la casa del secretario Jonatán, pues tengo miedo de morir allí.'"
,"21":"Entonces Sedecías ordenó que trasladaran a Jeremías al patio de la guardia y cada día se le daba un pan de los que hacían en la calle de los panaderos, hasta que hubo pan en la ciudad. Así, quedó Jeremías en el patio de la guardia."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Sefatías, Guedalías, Jucal y Pasjur habían oído a Jeremías decir en público lo siguiente:"
,"2":"'Dice Yavé: Quien se quede en esta ciudad morirá a espada, o de hambre o de peste; en cambio, el que se entregue a los caldeos, vivirá; aunque pierda todo, salvará la vida. Y también esto es palabra de Yavé:"
,"3":"He decidido entregar a Jerusalén en manos del rey de Babel.'"
,"4":"Y aquellos jefes dijeron al rey: 'Este hombre debe morir, porque sus discursos desalientan a los combatientes que quedan en esta ciudad y aun a todo el pueblo. Es evidente que este hombre no busca nuestro bien, sino que trata de perdernos.'"
,"5":"Sedecías respondió: 'Ahí lo tienen, pues el rey nada puede contra ustedes.'"
,"6":"Entonces se apoderaron de Jeremías y lo echaron al pozo de Melquías, hijo del rey, situado en el patio de la guardia, bajándolo con cuerdas. En el pozo no había agua, sino puro fango, y Jeremías se hundió en el fango."
,"7":"Pero un oficial del palacio, el etíope Abdemalec, oyó decir que habían echado a Jeremías en el pozo."
,"8":"Salió del palacio y fue al encuentro del rey, que estaba sentado a la Puerta de Benjamín y le habló en estos términos:"
,"9":"'¡Oh, mi señor!, esos hombres han procedido muy mal con el profeta Jeremías. Lo han echado en el pozo, donde va a morir.'"
,"10":"Entonces el rey ordenó al etíope: 'Toma tres hombres y saca a Jeremías del pozo antes de que muera.'"
,"11":"Abdemalec consiguió los hombres, volviendo con ellos al palacio del rey. Ahí, del ropero de la sala del tesoro, tomó trapos y ropas gastadas, y por medio de sogas los pasó a Jeremías, diciéndole:"
,"12":"'Ponte estos trapos en los sobacos y pasa las cuerdas por debajo.' Jeremías lo hizo,"
,"13":"y así lo subieron y lo dejaron en el patio de la guardia."
,"14":"Entonces, Sedecías mandó a buscar a Jeremías y lo hizo venir donde él estaba, a la tercera entrada de la Casa de Yavé. Y le dijo: 'No me ocultes nada de lo que te voy a preguntar.'"
,"15":"Respondió Jeremías: 'Si soy sincero, me matarás; y si te doy un consejo, no me escucharás.'"
,"16":"Entonces el rey juró en secreto a Jeremías: 'Por Yavé y por la vida que nos ha dado, que no te mataré, ni te entregaré a los jefes que buscan tu muerte.'"
,"17":"Y Jeremías transmitió al rey esta palabra de Yavé: 'Si te entregas a los generales del rey de Babel, salvarás tu vida y esta ciudad no será quemada; vivirás tú y los tuyos."
,"18":"Pero si no lo haces, esta ciudad caerá en manos de los caldeos, que la incendiarán, y tú no escaparás de ellos.'"
,"19":"Sedecías dijo a Jeremías: 'Les tengo miedo a los judíos que se han pasado a los caldeos; pues si me entregan a ellos, se vengarán de mi persona.'"
,"20":"Replicó Jeremías: 'Los caldeos no te entregarán a ellos. Haz lo que Yavé te dice por mi boca; te resultará bien, y con vida quedarás."
,"21":"En cambio, si te niegas a rendirte, escucha lo que me ha revelado Yavé:"
,"22":"Todas tus mujeres que han quedado en el palacio del rey de Judá son llevadas a los generales del rey de Babilonia, y se burlan de ti con esta canción: 'Te han engañado tus buenos amigos; al hundirse tus pies en el fango, ellos te abandonaron.'"
,"23":"Llevarán a todas tus mujeres y tus hijos a los caldeos, y tú no escaparás de ellos, sino que caerás en manos del rey de Babilonia, el cual incendiará esta ciudad.'"
,"24":"Entonces dijo Sedecías a Jeremías: 'Que nadie se entere de estas palabras, de lo contrario morirás."
,"25":"Si los jefes saben que he hablado contigo y te preguntan qué hemos conversado, aunque te amenacen de muerte,"
,"26":"les dirás: Sólo he suplicado al rey que no me haga volver a la casa de Jonatán, porque tengo miedo de morir allí.'"
,"27":"Vinieron, en efecto, todos los jefes donde Jeremías y lo interrogaron. Y él les respondió conforme a lo que había dicho el rey. Ellos no pudieron insistirle, pues nadie había presenciado su entrevista con el rey."
,"28":"Así, pues, Jeremías quedó en el patio de la guardia hasta el día en que fue tomada Jerusalén."
}`)
	CurrentBook.AddChapter(39, `{
"1":"El año nueve del reinado de Sedecías, rey de Judá, y en el décimo mes del año, Nabucodonosor, rey de Babilonia, volvió con todo su ejército contra Jerusalén y la sitiaron de nuevo."
,"2":"Dos años después, el día nueve del cuarto mes, abrieron una brecha en la muralla de la ciudad"
,"3":"y entraron por allí todos los oficiales del rey de Babilonia y establecieron su campamento en la puerta del medio: Nergal-Sareser, príncipe de Sin-Maguir, oficial mayor, Nebusasban, alto jefe y todos los demás oficiales del rey de Babilonia."
,"4":"Cuando Sedecías, rey de Judá, y todos sus soldados los vieron allí, huyeron de noche, saliendo de la ciudad por el camino del parque real, que pasa por la puerta que está entre las dos murallas, y se dirigieron hacia el valle del Jordán."
,"5":"Pero las tropas de los caldeos salieron en su persecución y alcanzaron a Sedecías en los llanos de Jericó, lo tomaron preso y lo llevaron a la presencia de Nabucodonosor, que estaba en Ribla, en tierra de Jamat, el cual lo sometió a juicio."
,"6":"En Ribla, el rey de Babilonia mandó degollar a los hijos de Sedecías ante sus propios ojos, y lo mismo hizo con todos los nobles de Judá."
,"7":"A Sedecías le sacó los ojos y lo envió encadenado a Babilonia."
,"8":"Los caldeos incendiaron el palacio real y las casas del pueblo, y demolieron las murallas de Jerusalén."
,"9":"Nebuzardán, comandante de la guardia, desterró a Babilonia al resto de la población que había quedado en la ciudad, a los desertores que se habían rendido a él y a los pocos artesanos que aún había."
,"10":"En cuanto a los pobres, que no poseían ninguna cosa, los dejó en la tierra de Judá, dándoles, al mismo tiempo, viñas y campos."
,"11":"Respecto a Jeremías, Nabucodonosor, rey de Babilonia, había dado esta orden a Nebuzardán, comandante de la guardia:"
,"12":"'Tómalo y cuídalo, no le hagas ningún daño, sino que has de tratarlo como él te pida.'"
,"13":"Entonces Nebuzardán, comandante de la guardia, Nebusasbán, alto jefe, Nergal-Sareser, oficial mayor y los otros oficiales del rey de Babilonia,"
,"14":"mandaron sacar a Jeremías del patio de la guardia y lo entregaron a Godolías, hijo de Ajigam, para que lo condujera a su casa. Y así se quedó en medio del pueblo."
,"15":"Estando Jeremías detenido en el patio de la guardia, la palabra de Yavé le había sido dirigida de esta manera:"
,"16":"'Anda a decir a Abdemelec, el etíope: Así habla Yavé de los Ejércitos, el Dios de Israel: Ahora se van a cumplir mis palabras que anunciaban a esta ciudad, no felicidades sino calamidades, y tú mismo lo verás."
,"17":"Perro yo te salvaré, dice Yavé, y no caerás en manos de los hombres a los que tú tienes miedo."
,"18":"Sí, ten la seguridad de que entonces yo te pondré a salvo y no morirás a espada; y salvarás por lo menos tu vida, porque confiaste en mí', dice Yavé."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Ahora viene lo que Yavé le habló a Jeremías, después que Nebuzardán, comandante de la guardia, lo dejó en libertad, cuando, en Ramá, lo sacó de en medio de los cautivos de Jerusalén y de Judá que iban desterrados a Babilonia, entre los cuales se encontraba encadenado."
,"2":"En efecto, el comandante de la guardia tomó aparte a Jeremías y le dijo: 'Yavé, tu Dios, había predicho esta catástrofe para este país y lo ha cumplido. Yavé ha actuado de acuerdo a sus amenazas."
,"3":"Y toda esta serie de desgracias les han ocurrido a ustedes porque pecaron contra Yavé, no haciendo caso de su palabra."
,"4":"Ahora mismo te quito las cadenas que tienes en tus manos. Si quieres acompañarme a Babilonia, ven conmigo, que yo te protegeré; si no te gusta, quédate. Mira, tienes todo el país a tu disposición; puedes ir a donde quieras o a donde te convenga."
,"5":"O bien dirigirte a casa de Godolías, hijo de Ajigam y nieto de Safán, a quien el rey de Babilonia ha nombrado gobernador de las ciudades de Judá y quedarte a vivir con él, entre esta gente. En fin, anda a donde más te convenga.' En seguida, el comandante de la guardia le dio víveres y un regalo y lo despidió."
,"6":"Y Jeremías se fue a Mispá, donde estaba Godolías, hijo de Ajigam, y se quedó a vivir en su casa, junto con la gente que había quedado en el país."
,"7":"Todos los jefes de las guerrillas, que se mantenían con sus hombres en pie de guerra, se enteraron de que el rey de Babilonia había dejado a Godolías, hijo de Ajigam, como gobernador del país y que le había encomendado hombres, mujeres y niños, así como la gente común del país que no había sido desterrada a Babilonia."
,"8":"Fueron, pues, a presentarse a Godolías, en Mispá. Ellos eran: Ismael, hijo de Natanías, Joanán, hijo de Carea, Serayas, hijo de Tánjumet, los hijos de Efai, netofita, y Jezonías, hijo de Makati, junto con sus hombres."
,"9":"Godolías, hijo de Ajigam, nieto de Safán, les hizo este juramento a ellos y a su gente: 'No teman a los jefes de los caldeos, quédense en el país, obedezcan al rey de Babilonia y en todo les irá bien."
,"10":"Por mi parte, aquí me tienen establecido en Mispá, como representante del país ante los caldeos que se van a establecer en este lugar. Ustedes, pues, hagan la vendimia, recojan la fruta, cosechen el aceite y guárdenlo en sus tinajas; y vivan en los pueblos que ustedes van a ocupar.'"
,"11":"Igualmente, los judíos que estaban en Moab, entre los amonitas, en Edom y en todos los otros países, supieron que el rey de Babilonia había dejado una parte de la población de Judá y que había puesto al frente de ellos a Godolías, hijo de Ajigam, nieto de Safán."
,"12":"Todos ellos regresaron de los distintos lugares donde se habían refugiado y, luego de haber llegado a la tierra de Judá, junto a Godolías, en Mispá, hicieron una gran cosecha de vino y fruta."
,"13":"Joanán, hijo de Carea, y todos los jefes guerrilleros se presentaron a Godolías en Mispá,"
,"14":"y le dijeron: '¿No sabes que Baalis, rey de los amonitas, ha enviado a Ismael, hijo de Netanías, para asesinarte?' Pero Godolías no les creyó."
,"15":"Entonces Joanán dijo secretamente a Godolías: 'Yo voy a ir a matar a Ismael, hijo de Netanías, sin que nadie lo sepa. ¿Con qué derecho va a quitarte la vida? Esto produciría el desbande de todos los judíos reunidos a tu alrededor y sería el fin de la poca población de Judá.'"
,"16":"Mas Godolías, hijo de Ajigam, le contestó a Joanán, hijo de Carea: 'No hagas eso, porque no es cierto lo que dices de Ismael.'"
}`)
	CurrentBook.AddChapter(41, `{
"1":"Pues bien, en el séptimo mes, Ismael, hijo de Netanías, nieto de Elisama y que tenía sangre real, vino con diez hombres a visitar a Godolías, en Mispá. Y mientras estaban comiendo con él,"
,"2":"se levantaron Ismael y sus diez hombres y acuchillaron a Godolías, matando así al que el rey de Babilonia había puesto al frente del país."
,"3":"Ismael asesinó también a todos los judíos que estaban comiendo con Godolías y a los soldados caldeos que estaban allí."
,"4":"Dos días después del asesinato de Godolías, del cual nadie estaba enterado todavía,"
,"5":"llegaron de Siquem, de Silo y de Samaria, ochenta hombres con la barba cortada, la ropa hecha tiras y el cuerpo cubierto de cortaduras, que traían ofrendas e incienso que querían presentar en el Templo de Yavé."
,"6":"Ismael, hijo de Netanías, salió de Mispá a su encuentro. Ellos iban llorando mientras caminaban. Al encontrarse con ellos, les dijo: 'Vamos a saludar a Godolías, hijo de Ajigam.'"
,"7":"Pero apenas llegaron al centro de la ciudad, Ismael, ayudado por sus hombres, los degolló y los echó al fondo de un estanque."
,"8":"Sin embargo, entre esos hombres hubo diez que le dijeron a Ismael: 'Consérvanos la vida, pues tenemos escondidas, en el campo, provisiones de trigo, cebada, aceite y miel.' Entonces los perdonó y no los hizo morir como a sus hermanos."
,"9":"El estanque donde Israel tiró los cadáveres de toda la gente que había asesinado era el Gran Estanque, que había mandado cavar el rey Asa para defenderse de Basa, rey de israel, hijo de Netanías, y lo llenó de cadáveres."
,"10":"Después se llevó prisioneros a toda la pequeña población que había en Mispá, y a las princesas reales que Nebuzardán, comandante de la guardía, había entregado al cuidado de Godolías, hijo de Ajigam. Y, de madrugada, se puso en marcha hacia el país de los amonitas."
,"11":"Cuando Joanán, hijo de Carea, y todos los oficiales que le acompañaban se informaron de todos los crímenes de Ismael,"
,"12":"reunieron a todos sus hombres y partieron a luchar contra Ismael. Lo alcanzaron cerca de la gran laguna de Gabaón."
,"13":"Toda la gente que Ismael llevaba prisionera desde Mispá y que iba con él, se alegraron mucho apenas vieron a Joanán y sus oficiales,"
,"14":"y dando media vuelta, regresaron al lado de Joanán."
,"15":"Mientras tanto, Ismael logró escapar de Joanán y con ocho hombres se pasó a los amonitas."
,"16":"Joanán, hijo de Carea, y sus oficiales juntaron a toda la gente que Ismael se había llevado prisionera desde Mispá, después de asesinar a Godolías, y que se había vuelto gracias a ellos desde Gabaón: hombres, mujeres, niños y eunucos."
,"17":"Se pusieron en camino e hicieron un alto en Caman, cerca de Belén. Su proyecto era irse a Egipto, lejos de los caldeos, a quienes temían, después que Ismael había asesinado a Godolías, puesto por el rey de Babilonia para gobernar el país."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Entonces todos los oficiales, especialmente Joanán, hijo de Carea, y Azarías, hijo de Hosías, y todo el pueblo, chicos y grandes, fueron a ver al profeta Jeremías"
,"2":"para decirle:"
,"3":"'¡Atiende, por favor, nuestra solicitud! Ruega a Yavé, tu Dios, por este grupito -pues de tantos que éramos, hemos quedado reducidos a unos pocos, como tú mismo lo puedes comprobar-, para que Yavé, tu Dios, nos indique el camino que debemos seguir o lo que tenemos que hacer.'"
,"4":"El profeta Jeremías les contestó: 'De acuerdo, ahora mismo me pondré a rogar a Yavé, su Dios, por lo que ustedes me piden. Y cualquiera que sea la respuesta de Yavé, su Dios, yo se la comunicaré a ustedes sin ocultarles nada.'"
,"5":"Ellos, a su vez, dijeron a Jeremías: 'Que Yavé sea un testigo fiel y sincero, que declare contra nosotros si no hacemos exactamente todo lo que Yavé, tu Dios, nos mande a decir por medio de ti."
,"6":"Sea como sea, bueno o malo, seguiremos la voz de Yavé, nuestro Dios, con el cual te mandamos a conversar. Así, seremos felices por haber obedecido lo que nos mandaba Yavé, nuestro Dios.'"
,"7":"Al cabo de diez días, una palabra de Yavé le llegó a Jeremías."
,"8":"Este llamó a Joanán, hijo de Carea, a todos los oficiales de su escolta y a todo el pueblo, chicos y grandes;"
,"9":"y les dijo: 'Así, habla Yavé, el Dios de Israel, al que ustedes me enviaron para exponerle sus deseos: "
,"10":"Si ustedes quieren vivir tranquilamente en esta tierra, yo los edificaré y no los destruiré; los plantaré y no los arrancaré más, pues estoy arrepentido del mal que les he hecho."
,"11":"No teman al rey de Babilonia, que tanto susto les causa; no lo teman, dice Yavé, pues estoy con ustedes para salvarlos y para librarlos de sus manos."
,"12":"Yo pondré en su corazón sentimientos de piedad hacia ustedes, y él se compadecerá de ustedes, permitiéndoles que vuelvan a su patria."
,"13":"Pero si ustedes dicen: 'No queremos quedarnos más en este país', desobedeciendo así la voz de Yavé, su Dios,"
,"14":"y sostienen, por el contrario: 'No, que es a Egipto adonde queremos ir, pues allí no veremos más la guerra, ni oiremos el toque del clarín, ni sufriremos de falta de paz; es allí donde queremos morar',"
,"15":"pues bien, entonces, pequeño grupo de Judá, escucha la palabra de Yavé: Esto dice Yavé de los Ejércitos, el Dios de Israel: Si ustedes resuelven irse a Egipto y entran en esa tierra para habitar allí,"
,"16":"la espada, que les da miedo, los alcanzará también por allá, y el hambre, que les preocupa, les irá pisando los talones; y allí, en Egipto, ustedes morirán."
,"17":"Y todos los que han decidido irse a Egipto para residir allí, morirán a espada, de hambre y de peste; y nadie escapará con vida de esa catástrofe que les voy a mandar."
,"18":"Sí, lo asegura Yavé de los Ejércitos, el Dios de Israel: Como cayeron mi cólera y mi furor sobre los habitantes de Jerusalén, así también se desatarán sobre ustedes si se van a Egipto. Y ustedes serán objeto de mucho desprecio, de asombro, de maldición y de burla, y no volverán a ver más estos lugares."
,"19":"Este es el mensaje de Yavé al resto de Judá: No vayan a Egipto. Fíjense bien que yo se lo he advertido hoy, claramente."
,"20":"Ustedes ponían en juego su propia vida, cuando me encargaron: 'Ruega por nosotros a Yavé, nuestro Dios, y todo lo que ordene Yavé, nuestro Dios, nos lo comunicas para que lo ejecutemos.'"
,"21":"Y ahora que se lo comunico, ustedes no quieren aceptar nada del mensaje de Yavé, su Dios, que yo les transmito."
,"22":"Tengan, pues, ustedes muy bien en cuenta que perecerán por la espada, de hambre y de peste, en el territorio a donde quieren ir a instalarse.'"
}`)
	CurrentBook.AddChapter(43, `{
"1":"Pero apenas Jeremías hubo terminado de transmitir al pueblo todo el mensaje que Yavé, su Dios, le había entregado para ellos (y que fue mencionado arriba),"
,"2":"Azarías, hijo de Masías, y Joanán, hijo de Carea, y todos esos hombres, insolentes y porfiados, le contestaron a Jeremías: 'No es cierto lo que cuentas. No es Yavé quien te ha encargado decirnos: 'No se vayan a vivir a Egipto',"
,"3":"sino que es Baruc, hijo de Nerías, quien te azuza contra nosotros para que así caigamos en manos de los caldeos, que nos matarán o nos desterrarán a Babilonia.'"
,"4":"Ni Joanán, ni sus oficiales, ni nadie del pueblo hizo caso de Yavé, que les mandaba quedarse en el país de Judá. Antes bien,"
,"5":"Joanán, hijo de Carea, y los jefes del ejército se llevaron al resto de la población de Judá, a los que habían estado desparramados por todas partes y que habían regresado a Judá para vivir allí."
,"6":"Entre ellos había hombres, mujeres y niños; estaban las princesas reales y todas las personas que Nebuzardán, comandante de la guardia, había dejado con Godolías, hijo de Ajigam, y nieto de Safán, y, especialmente, al profeta Jeremías y a Baruc, hijo de Nerías."
,"7":"Partieron para Egipto, desobedeciendo la orden de Yavé, y llegaron hasta Tafnes."
,"8":"Una palabra de Yavé llegó a Jeremías en Tafnes:"
,"9":"'Toma unas piedras grandes y, a la vista de los judíos, mételas en el cemento de la plaza cuadrada que hay a la entrada del palacio de Faraón, en Tafnes."
,"10":"Después dirás a esta gente: Esto es lo que afirma Yavé de los Ejércitos, el Dios de Israel: Miren, yo voy a mandar a buscar a Nabucodonosor, rey de Babilonia, mi servidor, el cual instalará su trono sobre estas piedras que he enterrado aquí, y detrás pondrá un adorno de colgaduras."
,"11":"Vendrá y castigará a Egipto: Quien esté destinado a la peste, a la peste, quien al cautiverio, al cautiverio, quien a la espada, a la espada."
,"12":"Y prenderá fuego a los templos de los dioses de Egipto, quemará o se llevará sus dioses, despiojará a Egipto como despioja un pastor su manta, y después se irá sin que nadie lo moleste."
,"13":"Hará pedazos los obeliscos del templo del Sol, que se encuentra en On, e incendiará los templos de los dioses egipcios.'"
}`)
	CurrentBook.AddChapter(44, `{
"1":"Palabra que le llegó a Jeremías respecto de todos los judíos que estaban en Egipto y que vivían en Migdol, Tafnes, Nof y en el territorio de Patrós."
,"2":"Así dice Yavé de los Ejércitos, el Dios de Israel. Ustedes han presenciado todas las desgracias que sufrieron Jerusalén y todas las ciudades de Judá, que hoy no son más que un montón de ruinas abandonadas."
,"3":"Esto les pasó por culpa de los crímenes que cometieron para molestarme, yendo a incensar y adorar a dioses extranjeros, que no conocían ni ellos, ni ustedes ni sus padres."
,"4":"Yo les he estado mandando a ustedes sin parar, a todos mis sirvientes los profetas, con este mensaje: 'No hagan esas cosas horribles que yo detesto.'"
,"5":"Pero no han querido escuchar ni hacer caso para abandonar su maldad o dejar de incensar a dioses extranjeros."
,"6":"Entonces mi furor y mi cólera estallaron y quemaron las ciudades de Judá y los barrios de Jerusalén reduciéndolos a un montón de ruinas abandonadas, como lo están hoy en día."
,"7":"Y ahora, Yavé, Dios de los Ejércitos, Dios de Israel, les pregunta: '¿Por qué se hacen tanto mal ustedes mismos? Ustedes van a hacer que se acaben los hombres, las mujeres y los niños de la raza de Judá, hasta que no quede nadie,"
,"8":"al provocarme con las cosas que hacen sus manos o quemando incienso a dioses extranjeros en este suelo de Egipto a donde se han venido a instalar. Así cooperan ustedes mismos a su propia ruina y hacen que todo el mundo los maldiga y se ría de ustedes."
,"9":"¿Acaso se han olvidado ustedes de los crímenes cometidos por sus padres, por los reyes de Judá y sus mujeres, por ustedes y sus mujeres, en Judá y en las calles de Jerusalén?"
,"10":"Hasta ahora no han sentido ningún arrepentimiento ni miedo, ni se han portado según la Ley y los mandamientos, que yo había publicado delante de ustedes y de sus padres."
,"11":"Por esto, así les dice Yavé de los Ejércitos, el Dios de Israel: Me voy a fijar en ustedes para desgracia suya y acabaré con todo Judá."
,"12":"Tomaré al resto de la población de Judá que resolvió venirse a vivir a Egipto y los haré perecer a todos en la tierra de Egipto; caerán al filo de la espada o morirán de hambre; grandes y chicos, todos morirán por la espada y de hambre. Los aborrecerán, se asombrarán de ellos, los maldecirán y se reirán de ellos."
,"13":"Así, como castigué a Jerusalén con la espada, el hambre y la peste, también castigaré a los que viven en Egipto."
,"14":"De este grupito de Judá que se vino a vivir a Egipto nadie escapará con vida para volver a su patria, adonde tanto anhelan volver a vivir. Nadie regresará, sino algunos pocos fugitivos.'"
,"15":"Entonces todos aquellos hombres que sabían que sus mujeres quemaban incienso a dioses extranjeros, todas las mujeres que estaban presentes y todo el pueblo establecido en Egipto, en Patrós -en total una gran muchedumbre-, respondieron a Jeremías:"
,"16":"'No queremos saber nada con todo lo que nos has dicho en nombre de Yavé,"
,"17":"pues nosotros continuaremos haciendo lo que hemos decidido: ofreceremos incienso a la reina del cielo y derramaremos vino en su honor como lo hacíamos nosotros, nuestros padres, nuestros reyes y príncipes en las ciudades de Judá y en los barrios de Jerusalén. Entonces teníamos harto pan, éramos felices y en todo nos iba bien."
,"18":"Pero desde que dejamos de ofrecer incienso a la reina del cielo y de derramar vino en su honor, nos ha faltado de todo y hemos perecido por la espada y de hambre.'"
,"19":"Y las mujeres añadieron: 'Cuando nosotras ofrecíamos incienso y derramábamos vino en honor de la reina del cielo, ¿acaso era sin permiso de nuestros maridos?'"
,"20":"Pero Jeremías les contestó a todo el pueblo, a los hombres y mujeres que le habían dicho eso:"
,"21":"'¿No ha sido, justamente, ese incienso que ustedes han ofrecido en las ciudades de Judá y en los barrios de Jerusalén, junto con sus padres, reyes y príncipes, lo que ha recordado Yavé y lo que le ha hecho palpitar el corazón?"
,"22":"Yavé no ha podido contenerse más al ver la mala conducta de ustedes y las cosas horribles que ustedes han hecho. Por eso, su país es ahora un desierto espantoso, maldito y abandonado."
,"23":"Todas las calamidades que están ustedes padeciendo ahora, han sido porque ustedes ofrecieron incienso y pecaron así contra Yavé, no haciendo caso a su palabra y no portándose de acuerdo a su Ley, a sus mandamientos y órdenes.'"
,"24":"En seguida Jeremías se dirigió a todo el pueblo, especialmente a las mujeres: 'Escuchen el mensaje de Yavé: Esto les dice Yavé de los Ejércitos, el Dios de Israel:"
,"25":"Ustedes, mujeres, piensan que tienen la obligación de cumplir los votos que han hecho, y dicen: 'Tenemos que cumplir fielmente la promesa que hemos hecho de ofrecer incienso a la reina del cielo y derramar vino en su honor.' ¡Muy bien! ¡Cumplan sus mandas, derramen su vino!"
,"26":"Sin embargo, oigan lo que les dice Yavé a todos ustedes, los judíos que viven en Egipto: Juro por mi Nombre poderoso, dice Yavé, que en todo Egipto no habrá en adelante un solo judío que pronuncie mi nombre; no quedará nadie para decir: 'Por vida del Señor, Yavé.'"
,"27":"Sí, voy a poner mis ojos sobre ellos, no para su bien sino para su mal. Todos los hombres de Judá que están ahora en Egipto, perecerán a espada y de hambre hasta que se terminen todos."
,"28":"Sólo unos pocos, que hayan logrado escapar de la espada, regresarán de Egipto a la tierra de Judá. Entonces todo el resto de la población de Judá, que entró en Egipto como refugiado, verá qué palabra se ha cumplido, si la mía o la suya."
,"29":"Esta es para ustedes la prueba de que los voy a castigar en este lugar, dice Yavé, para que así reconozcan que mis palabras llenas de amenazas contra ustedes se cumplirán."
,"30":"Yavé lo asegura: Voy a entregar a Faraón Hofrá, rey de Egipto, en manos de sus enemigos que quieren quitarle la vida, igual que entregué a Sedecías, rey de Judá, en manos de Nabucodonosor, rey de Babilonia, su enemigo, que quería matarlo.'"
}`)
	CurrentBook.AddChapter(45, `{
"1":"Estas fueron las palabras que el profeta Jeremías le dirigió a Baruc, hijo de Nerías, cuando éste copiaba en un libro todo lo que le iba dictando Jeremías, el año cuarto del reinado de Joaquim, hijo de Josías, rey de Judá."
,"2":"'Este recado te manda, a ti, Baruc, Yavé, el Dios de Israel."
,"3":"Ya que tú has dicho: 'Pobre de mí, porque Yavé añade más penas a mis sufrimientos, estoy cansado de tanto llorar sin encontrar consuelo.'"
,"4":"Así dice Yavé: Lo que había construido, lo destruyo; lo que había plantado, lo arranco, y esto, en todo el país."
,"5":"¿Y tú reclamas para ti cosas extraordinarias? No reclames tanto, pues voy a descargar calamidades sobre todos los mortales, dice Yavé, pero a ti te concederé la vida. La guardarás como un premio por dondequiera que vayas.'"
}`)
	CurrentBook.AddChapter(46, `{
"1":"Estas son palabras de Yavé que le llegaron al profeta Jeremías sobre el destino de las naciones."
,"2":"Para Egipto y el ejército de Faraón Necao, rey de Egipto, que estaba cerca del río Eufrates, en Carquemis, y al que derrotó Nabucodonosor, rey de Babilonia, el año cuarto del reinado de Joaquim, rey de Judá."
,"3":"Preparen escudos grandes y chicos, marchen al combate, ensillen los caballos;"
,"4":"¡monten, jinetes!,Formen filas con los cascos puestos, saquen brillo a las lanzas, ¡pónganse las corazas...!"
,"5":"Pero, ¿qué es lo que veo?,Ellos se acobardan y retroceden. Los más valientes son derrotados, huyen sin volver la cabeza, ¡Terror por todas partes!, dice Yavé."
,"6":"Ni el más ágil podrá escapar, ni el más valiente, salvarse, Al norte, a orillas del río Eufrates, tropezaron y cayeron."
,"7":"¿Quién era aquel que subía como el Nilo,o como río de torrentosas aguas?"
,"8":"Egipto era el que subía como el Nilo, como torrente de revueltas aguas. El decía: 'Subiré e inundaré la tierra, destruiré las ciudades con sus habitantes"
,"9":"¡A la carga, la caballería!,¡Al asalto, los carros!,Adelante, soldados de Etiopía, y de Libia, que manejan escudos, y ustedes los de Libia, que tiran flechas con el arco.'"
,"10":"Ese día será para el Señor Yavé un día de venganza, para vengarse de sus enemigos: Su espada los va a devorar hasta quedar satisfecha, y se embriagará con su sangre. Sí, el Señor, Yavé de los Ejércitos, celebra un sacrificio de centenares de víctimas, en el norte, a orillas del río Eufrates."
,"11":"¡Sube a Galaad a buscar bálsamos, virgen, hija de Egipto!,¡Pero es inútil que multipliques tus remedios, pues nada podrá sanarte!"
,"12":"Las naciones se han enterado de tu derrota, la tierra está llena con tus gritos; pues un soldado ha tropezado con otro,y ambos han caído al mismo tiempo."
,"13":"Estas fueron las palabras que Yavé dirigió al profeta Jeremías, cuando Nabucodonosor, rey de Babilonia, emprendió el ataque a Egipto:"
,"14":"Publíquenlo en Migdol,y repítanlo en Nof. Digan: Levántate y prepárate, porque la espada anda devorando a tu alrededor."
,"15":"¡Cómo! ¿Apis ha huido?,¿Tu Toro ha sido derrotado?,Sí, Yavé lo ha derribado,"
,"16":"ha caminado a tropezones,y se ha venido a tierra. Entonces unos a otros se han dicho: '¡Arriba! Volvámonos a nuestro pueblo,y a nuestra patria, lejos de la espada que destruye.'"
,"17":"Pongan este nombre a Faraón: '¡Ruido a destiempo!'"
,"18":"Por vida mía, dice el Rey, cuyo nombre es Yavé de los Ejércitos, alguien va a venir, que es como el Tabor entre los montes, o como el Carmelo que domina el mar."
,"19":"Prepara tu equipaje de desterrada, hija de Egipto, que vives tan cómodamente. Nof será reducida a un desierto, a un montón de ruinas abandonadas."
,"20":"Egipto era una linda vaquilla: un tábano del norte se ha posado sobre ella."
,"21":"Los mercenarios que se veían en ella, eran como novillos de engorde, pero ellos también vuelven la espalda y huyen todos juntos, sin oponer resistencia. Pues éste es para ellos el día de su desgracia, la hora de su castigo."
,"22":"Escúchenla que silba como una serpiente que huye, pues avanzan en masa contra ella, se echan sobre ella con sus hachas, como hace el leñador,"
,"23":"¡y cortan el bosque!, dice Yavé. Sí, han venido como una nube de langostas, tan numerosos que no se pueden contar."
,"24":"La hija de Egipto se ve derrotada, ha caído en manos del pueblo del norte."
,"25":"Yavé de los Ejércitos, el Dios de Israel, ha declarado: Voy a castigar a Amón de No, el Faraón, y a los que ponen en él su confianza."
,"26":"Los entregaré en manos de los que quieren quitarles la vida, en manos de Nabucodonosor, rey de Babilonia, y de sus súbditos. Pero en el futuro Egipto será nuevamente poblado como antiguamente, dice Yavé."
,"27":"No tengas miedo, Jacob, mi servidor; no te asustes, Israel. Pues yo estoy aquí para sacarte de tierras lejanas y a tus hijos del país donde están cautivos. Jacob recobrará la calma y vivirá tranquilo, sin que nadie lo moleste."
,"28":"No temas, servidor mío, Jacob, dice Yavé, pues yo estoy a tu lado. Destruiré a todas las naciones adonde te arrojé, pero a ti no te exterminaré; te castigaré como lo mereces, pero no será una venganza."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Esta es la palabra de Yavé que llegó al profeta Jeremías referente a los filisteos, antes que Faraón se apoderase de Gaza."
,"2":"Así dijo Yavé: Desde el norte llegan aguas desbordadas: es un río caudaloso, que inunda el país y cuanto él contiene, las ciudades y sus habitantes. Por todas partes se escuchan gritos, y los habitantes del país se lamentan."
,"3":"Se oye el martilleo de las herraduras de sus caballos, el ruido de sus carros,y el estrépito de sus ruedas. Los padres ya no miran por sus hijos, sus manos están sin fuerza."
,"4":"Porque ha llegado el día,en que serán aniquilados todos los filisteos, y en que Tiro y Sidón verán derrotados,hasta sus últimos aliados. Sí, Yavé exterminará a los filisteos, a los restos de la isla de Caftor."
,"5":"Gaza ha sido rapada, Ascalón está callada; Asdod, resto de los anaquitas, ¿hasta cuándo te vas a hacer cortaduras en tu cuerpo?"
,"6":"¡Ay, espada de Yavé!,¿Hasta cuándo estarás sin descansar?,Métete en tu vaina. ¡Párate, tranquilízate!"
,"7":"¿Cómo va a tomar descanso,si Yavé le ha dado órdenes?,Ascalón y la costa del mar, ésos son sus blancos."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Contra Moab. Así habla Yavé de los Ejércitos, el Dios de Israel: Pobre de Nebo, que ha sido saqueada, Quiriatayim ha sido tomada, la confusión y el miedo reinan en la ciudadela:"
,"2":"ya no es más ella la gloria de Moab. En Jesebón han planeado su ruina: 'Vamos y borrémosla de entre las naciones.',También tú, Madmén, vas a caer, ya la espada te está cercando."
,"3":"Escuchen los gritos que se sienten desde Abarim: '¡Calamidad! ¡Desastre total!,¡Moab ha sido arrasada!'"
,"4":"Lo anuncian a voz en cuello hasta Soar. ¡Ay!, la cuesta de Luit,la suben llorando."
,"5":"¡Ay!, por la bajada de Joronayim,se oyen gritos desgarradores:"
,"6":"'Huyan, sálvese quien pueda, hagan como los burros salvajes del desierto.'"
,"7":"Tú confiabas en tus fortalezas y tus riquezas, pero también a ti te pillarán. Camos partirá al destierro,con sus sacerdotes y príncipes."
,"8":"El destructor va a invadir a todas las ciudades, sin que se libre una sola. El valle será arrasado, la Meseta saqueada: lo asegura Yavé."
,"9":"Entierren a Moab, porque ha sido totalmente destruido; sus ciudades quedarán hechas un desierto, y no habrá quien habite en ellas."
,"10":"Maldito el que ejecuta con flojera el trabajo que Yavé le ha encomendado. ¡Maldito el que tiene su espada limpia de sangre!"
,"11":"Tranquilo ha vivido Moab desde su juventud, reposaba como un vino,que nunca ha sido cambiado de tonel. Nunca había marchado al exilio, por eso había conservado su gusto,y su sabor no se había picado."
,"12":"Pero se acerca el momento, dice Yavé, en que le mandaré gente que lo cambie de tonel; ellos dejarán sus barriles vacíos y quebrarán sus tinajas."
,"13":"Entonces Moab se avergonzará de Camos como la Casa de Israel se avergonzó de Betel, en el que había puesto su esperanza."
,"14":"¿Cómo pueden decir ustedes: 'Somos valientes y buenos para la pelea'?"
,"15":"El destructor de Moab se ha lanzado contra él, lo mejor de su juventud va a parar al matadero."
,"16":"El fin de Moab se acerca, su desgracia está ya encima."
,"17":"Lloren por él todos ustedes, sus vecinos, ustedes, que conocían su fama. Digan: '¿Cómo ha sido roto este bastón tan firme, esta vara tan preciosa?'"
,"18":"Baja de tu trono de gloria,y siéntate en el suelo, hija de Dibón, que vives con tanta comodidad; el devastador de Moab te ha atacado,y ha destruido tus fortalezas."
,"19":"Párate a mirar en el camino, tú que habitas en Aroer. Pregúntales al fugitivo y al escapado: '¿Qué pasa?'"
,"20":"'Moab está avergonzada porque ha sido derrotada. ¡Giman y griten!,Cuenten en Arnón que Moab ha sido destruida.'"
,"21":"Se ha dictado la sentencia condenando a la región de la Meseta, a Jolón, Jasa y Mefat,"
,"22":"a Dibón, Nebo, Betdeblataim,"
,"23":"Quiriatayim, Betgamul, Bet Maón,"
,"24":"Cariot y Bosra, y a todas las ciudades de Moab, tanto las que están lejos como las de cerca."
,"25":"El poder de Moab se ha venido abajo, ha sido herido su brazo."
,"26":"Emborráchenlo, pues se alzó contra Yavé. ¡Que Moab se revuelque en sus vómitos y quede en ridículo!"
,"27":"Pues, ¿tú no te reíste también de Israel? ¿Lo pillaste, acaso, en compañía de ladrones, para que siempre que hables de él, menees burlonamente la cabeza?"
,"28":"Salgan de las ciudades,y váyanse a los cerros, habitantes de Moab. Imiten a las palomas, que hacen sus nidos al borde del precipicio."
,"29":"Nos han llegado noticias del orgullo de Moab, es un orgullo muy grande."
,"30":"Conocemos su soberbia, su arrogancia, su insolencia,y la altanería de su corazón. ¡Conozco bien su arrogancia!, dice Yavé, sus amenazas son puras palabras, sus obras no sirven para nada."
,"31":"Por eso, quiero también llorar por Moab, gritar por todo Moab, gemir por la gente de Quir-Jerés."
,"32":"Más que por Yazer, lloro por ti, ¡oh viña de Sibma!,Tus sarmientos se alargaban más allá del mar,y alcanzaban hasta Jazer. Sobre tu cosecha y tu vendimia, ha caído el destructor."
,"33":"El gozo y la alegría han desaparecido del país de Moab. No hay vino en las cubas, pues los hombres ya no pisan el lagar,ni resuenan más sus cantos de alegría."
,"34":"Los aullidos de Jesbón y de Elealí se escuchan hasta en Jasa; se grita desde Segor hasta Joronaím y Eglatselisa, pues las aguas de Nimri han sido devastadas."
,"35":"Haré que en Moab no haya más quien haga ofrendas en los lugares altos, o queme incienso a su dios, dice Yavé."
,"36":"Mi corazón gime por Moab como una flauta; mi corazón gime por la gente de Quir-Jerés como una flauta, porque todas las riquezas que habían acumulado se han perdido."
,"37":"Sí, todas las cabezas están rapadas; todas las barbas, cortadas; todas las manos están llenas de cortaduras, y todos se han vestido con sacos."
,"38":"En las terrazas de Moab y en sus calles, todo el mundo se lamenta, porque he hecho pedazos a Moab como un cántaro que no sirve, dice Yavé."
,"39":"¿Cómo es posible que Moab haya sido destruido y que, humillado, haya tenido que volver la espalda? ¿Por qué Moab se ha convertido en objeto de burla y de espanto para todos sus vecinos?"
,"40":"Porque así habla Yavé: miren cómo vuela cual un águila,y extiende sus alas sobre Moab."
,"41":"Las ciudades son conquistadas,y las fortalezas ocupadas; el corazón de los soldados de Moab ha pasado a ser,como el corazón de una mujer que da a luz."
,"42":"Moab ha sido destruido y queda sin habitantes, porque se alzó contra Yavé."
,"43":"¡El terror, la fosa y la trampa,son para ti, habitante de Moab!, dice Yavé."
,"44":"El que escape del terror, caerá en la fosa, y el que salga de la fosa, quedará preso en la trampa. Sí, todas estas calamidades enviaré sobre Moab,el año de su castigo, dice Yavé."
,"45":"A la sombra de Jesbón se pararon, sin fuerzas, los fugitivos. Pero ha salido un fuego de Jesbón, una llama del palacio de Sijón, que ha devorado las sienes de Moab,y el cráneo de esta gente revoltosa."
,"46":"¡Ay de ti, Moab!,¡Estás perdido, pueblo de Camos!,Pues tus hijos han sido llevados al destierro,y tus hijas al cautiverio."
,"47":"Pero yo cambiaré la suerte de Moab, en el futuro, dice Yavé. Hasta aquí la sentencia contra Moab."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Sobre los hijos de Ammón. Esto dice Yavé: ¿Israel no tiene, acaso, hijos o herederos? ¿Cómo, entonces, Melcom ha heredado el país de Gad y su pueblo se ha establecido en sus ciudades?"
,"2":"Por eso, se acerca ya el tiempo, dice Yavé, en que haré resonar, en Rabbá de los amonitas, el grito de guerra. Quedará convertida en un montón de escombros abandonados, y sus aldeas serán incendiadas. Entonces Israel despojará a los que lo habían despojado, afirma Yavé."
,"3":"¡Quéjate, Jesbón, porque Ar ha sido destruida. Griten, hijas de Rabbá! ¡Vístanse con sacos, lloren, anden llenas de cortaduras en el cuerpo! Pues Melcom parte al destierro, junto con sus sacerdotes y príncipes."
,"4":"Eres bien orgullosa de tus valles, muchacha insolente; confiada en tus riquezas, dices: '¿Quién se atreverá a atacarme?'"
,"5":"Pues bien, yo trataré de que el terror se abalance contra ti por todas partes: todos huirán, cada uno por su lado, y no habrá nadie para reunir a los fugitivos."
,"6":"Pero, en el futuro, mejoraré la suerte de los hijos de Ammón, dice Yavé."
,"7":"Para Edom. Esto dice Yavé de los Ejércitos. ¿Ya se acabó la sabiduría en Temán?,¿Perdieron su prudencia los inteligentes, o se corrompió su sabiduría?"
,"8":"¡Den media vuelta y huyan, escóndanse bien, habitantes de Dedán,Porque voy a dejar caer la ruina sobre Esaú, en el momento de su castigo!"
,"9":"Si llegan vendimiadores a tu casa, no van a dejar un solo pampanito; si son ladrones nocturnos, saquearán todo lo que encuentren."
,"10":"Pues yo soy el que asalto a Esaú, y descubro sus escondites, para que ya no pueda esconderlos. ¡Su raza ha sido destruida, ya no existe!,No hay nadie de entre sus vecinos que diga:"
,"11":"'Pásame tus huérfanos, yo los cuidaré, y que tus viudas se acerquen a mí con confianza.'"
,"12":"Porque así habla Yavé: Los que no debían haber tomado de esa copa fueron obligados a beber, y tú, ¿quieres que no te castiguen? ¡No quedarás sin castigo, sino que tendrás también que tomar!"
,"13":"Pues yo lo juré por mí mismo, dice Yavé: Bosra quedará convertida en un desierto espantoso, infame y maldito, y todas sus ciudades no serán, en adelante, más que un montón de ruinas."
,"14":"Acaba de llegar un mensaje de Yavé, un mensajero ha sido enviado a todas las naciones: 'Júntense y marchen contra este pueblo. Prepárense para la guerra.'"
,"15":"Pues mira cómo te he hecho un pequeño pueblo, despreciado por los hombres."
,"16":"El miedo que metías y la soberbia de tu corazón te han engañado a ti que vives en el hueco de la roca, y te cuelgas de la cumbre más alta. Aunque hagas tu nido tan alto como un águila, desde allí te tiraré abajo, dice Yavé."
,"17":"Edom quedará hecho una calamidad: todos los que pasen cerca silbarán horrorizados, al ver todas sus heridas."
,"18":"Será semejante a Sodoma, Gomorra y las ciudades vecinas después de la catástrofe: nadie volverá a vivir allí, ni nunca más un ser humano se radicará en este lugar."
,"19":"Como un león que sale de la espesura del Jordán y se dirige a un potrero siempre verde, así, en un abrir y cerrar de ojos, estaré en sus praderas y los haré huir. Pues ¿quién es como yo? ¿Quién podrá resistirme, y dónde está el pastor capaz de hacerme frente?"
,"20":"Así, pues, escuchen la decisión que Yavé ha tomado contra Edom y sus proyectos contra los habitantes de Temán: Sí, hasta las ovejas más flacas serán llevadas a la rastra, y, al verlo, el rebaño se estremecerá de espanto."
,"21":"Con el estruendo de su caída temblará la tierra, y el eco se oirá hasta en el mar Rojo."
,"22":"Miren al águila que se eleva y que da sus vueltas: ¡ha extendido sus alas sobre Bosra! Aquel día, el corazón de los valientes de Edom será como el corazón de una mujer que da a luz."
,"23":"Sobre Damasco. Jamat y Arfad están preocupadas porque recibieron una mala noticia. Se les para el corazón de espanto y no pueden tranquilizarse."
,"24":"Damasco, acobardado, se dispone a huir, el terror la invade."
,"25":"¿Cómo es que está abandonada la ciudad famosa, la ciudad alegre?"
,"26":"Sí, es cierto, sus jóvenes caerán en sus plazas y todos sus soldados perecerán aquel día, dice Yavé de los Ejércitos."
,"27":"Yo prenderé fuego a las murallas de Damasco, que quemará también a los palacios de Benadad."
,"28":"Esto dice Yavé respecto de Quedar y los reinos de Jasor derrotados por Nabucodonosor: ¡Levántense y suban a Quedar,y dejen en la ruina a los hijos de Oriente!"
,"29":"Les quitarán sus carpas y sus rebaños, sus toldos y todo su bagaje, y les arrebatarán sus camellos. Gritarán encima de ellos: 'Susto por todas partes.'"
,"30":"Huyan, salgan rápido, escóndanse bien, moradores de Jasor, dice Yavé; pues Nabucodonosor ha trazado un proyecto,y ha organizado un plan contra ustedes."
,"31":"'De pie, ataquemos a la nación tranquila, que vive confiada, que no tiene puertas ni candados,y que habita en despoblado."
,"32":"Sus camellos serán nuestro botín,y sus incontables rebaños, nuestra presa.',Voy a desparramar a los cuatro vientos,a los que se afeitan la cabeza, y de todas partes les sobrevendrá la desgracia, dice Yavé."
,"33":"Jasor será, en adelante, una guarida de chacales, un eterno desierto. Allí nadie vivirá, ni ningún ser humano se radicará."
,"34":"Palabra de Yavé al profeta Jeremías acerca de Elam, al comienzo del reinado de Sedecías, rey de Judá."
,"35":"Así dice Yavé de los Ejércitos: Voy a romper el arco de Elam, que es la base de su poder."
,"36":"Haré que soplen sobre Elam los cuatro vientos desde los cuatro puntos cardinales del cielo; ¡y mandaré a los elamitas a todos estos vientos, y no habrá nación adonde no lleguen fugitivos de Elam!"
,"37":"Haré que los elamitas tiemblen al ver a sus enemigos, que quieren quitarles la vida. Sobre ellos arrojaré la desgracia, mi ardiente cólera. Enviaré la espada en su persecución, para que los mate a todos."
,"38":"Pondré mi trono en Elam y haré desaparecer de allí rey y príncipe, dice Yavé."
,"39":"Pero, en el futuro, cambiaré la suerte de Elam, dice Yavé."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Palabra de Yavé, que dijo contra Babilonia:"
,"2":"'Díganlo entre las naciones,para que lo sepan todos; no lo callen, digan: Babilonia ha caído. Babilonia ha sido tomada. Su dios Bel ha sido humillado, Marduk ha sido derribado, avergonzadas están sus imágenes, espantados sus ídolos."
,"3":"Un pueblo del norte la ha atacado,ya ha hecho de su tierra un desierto. Nadie en adelante, hombre o animal, vivirá en ella."
,"4":"En aquellos días, en esa época,volverán los hijos de Israel; y caminarán llorando,en busca de Yavé, su Dios."
,"5":"Preguntarán por el camino hacia Sión, y mirando a ella, dirán: 'Vengan, unámonos a Yavé,con pacto eterno e inolvidable.'"
,"6":"Los de mi pueblo eran ovejas perdidas; sus pastores las habían descarriado,y las hacían vagar por los cerros: ya no conocían su corral."
,"7":"Todo el que los encontraba los devoraba, y sus enemigos decían: No corremos riesgos, pues pecaron contra Yavé, morada segura en el que confiaban sus padres.'"
,"8":"Huyan de Babilonia,y del país de los caldeos. Salgan como salen los machos cabríos a la cabeza del rebaño."
,"9":"Porque voy a azuzar contra Babilonia,grandes naciones venidas del norte. Contra ella, juntas pelearán, y la conquistarán los arqueros certeros, cuyas flechas no caen en el vacío."
,"10":"Caldea será entregada al saqueo,y los saqueadores quedarán repletos."
,"11":"¡Ustedes se alegraban y triunfaban, saqueadores de mi propiedad, y relinchaban como potros!"
,"12":"Pero ahora ven a su madre humillada, la que los dio a luz ha sido humillada; ha pasado a ser la última de las naciones, un desierto seco y triste."
,"13":"La cólera de Yavé la ha devastado, nadie ya habitará en ella. El que pase cerca de Babilonia se detendrá asombrado, y silbará al ver tantas heridas."
,"14":"Ordénense frente a Babilonia, rodéenla, ¡ustedes que manejan el arco!,¡Tírenle flechas, sin ahorrar ninguna!"
,"15":"De todas partes han lanzado contra ella gritos de guerra y se ha rendido. Han caído sus torres de defensa, se han derrumbado sus murallas. Ustedes que son los instrumentos de la cólera de Yavé, ¡hagan con ella lo mismo que hizo con ustedes!"
,"16":"Saquen de Babilonia al sembrador y al segador que maneja la echona. Ante la espada destructora, que cada uno se vuelva a su pueblo y huya a su tierra."
,"17":"Israel era una oveja perdida, perseguida por leones. Primero, el rey de Asur la devoró, y luego, Nabucodonosor, rey de Babilonia, se comió sus huesos."
,"18":"Por eso, así habla Yavé de los Ejércitos, el Dios de Israel: Estoy listo para castigar al rey de Babilonia y a su país, como ya castigué al rey de Asur."
,"19":"Yo haré volver a Israel a su corral y comerá el pasto en el Carmelo y en el Basán y en los cerros de Efraím y Galaad tendrá para saciarse."
,"20":"En aquellos días, entonces, se buscará la culpa de Israel, pero no existirá; los pecados de Judá, pero no se hallará ninguno, porque al que salvo, yo le perdono."
,"21":"Contra el país de Meratayim. 'Sube al país de Meratim, y atácalo; a los habitantes de Pecod persíguelos, toma la espada y mátalos, dice Yavé. Ejecuta mis órdenes fielmente.'"
,"22":"Ruido de batalla en el país, ¡gran desastre!"
,"23":"¿Cómo se ha partido en mil pedazos el martillo de toda la tierra? ¿Cómo es posible que Babilonia se haya convertido en una cosa que produce horror a todas las naciones?"
,"24":"Te coloqué una trampa y caíste en ella, sin darte cuenta. Fuiste capturada y dominada porque te sublevaste contra Yavé."
,"25":"Yavé ha abierto su arsenal,y ha sacado las armas de su ira, porque hay trabajo para el Señor Yavé,en la tierra de los caldeos:"
,"26":"'Vengan de todas partes, abran sus graneros, amontónenlo todo y préndanle fuego, para que no quede nada."
,"27":"Degüellen todos sus novillos, que marchen al matadero. ¡Ay de ellos, porque ha llegado su día, la hora de su castigo!'"
,"28":"¡Escuchen! Son los fugitivos y los que escaparon del país de Babilonia que vienen a contar en Sión la venganza de Yavé nuestro Dios."
,"29":"Llamen a los arqueros para que ataquen a Babilonia. Ustedes que manejan el arco, pongan sus campamentos alrededor de ella, para que nadie pueda escapar. Páguenle a ella según sus obras; todo lo que ella hizo, hagan con ella, porque se portó insolente con Yavé, con el Santo de Israel."
,"30":"Por eso, sus jóvenes caerán en sus plazas y sus soldados perecerán aquel día, dice Yavé."
,"31":"Contra ti me dirijo, Insolencia, dice el Señor Yavé de los Ejércitos; ha llegado tu día, la hora de tu castigo."
,"32":"tropezará y caerá al suelo, sin tener quién la levante. Prenderé fuego a tus ciudades y arderán todos tus alrededores."
,"33":"Así habla Yavé de los Ejércitos: Los hijos de Israel están oprimidos, todos los que los han hecho cautivos los retienen y no quieren soltarlos."
,"34":"Pero su Redentor es poderoso, su nombre es Yavé de los Ejércitos. El ha tomado la defensa de su causa; dará paz al mundo, pero hará temblar a los habitantes de Babilonia."
,"35":"Espada para los caldeos, para los babilonios, sus jefes y sus sabios."
,"36":"¡Espada para sus adivinos, para que se vuelvan tontos!,¡Espada para sus soldados, para que se acobarden!"
,"37":"¡Espada para toda la mezcolanza,de tropas aliadas que hay dentro de ella, para que se porten como mujeres!,¡Espada a sus tesoros, para que sean saqueados!"
,"38":"¡Espada a sus aguas, para que se sequen!,Porque es un país de ídolos y están locos por sus horribles imágenes."
,"39":"Por eso, los linces harán allá sus guaridas con los chacales, y los avestruces vivirán allí; nunca más será habitada y quedará despoblada para siempre."
,"40":"Como después que Dios destruyó a Sodoma, Gomorra y las ciudades vecinas, dice Yavé, allí nadie vivirá, y ningún ser humano allí se radicará."
,"41":"Miren ese pueblo que viene del norte, es una gran nación, sus reyes poderosos se levantan,desde los confines del mundo."
,"42":"Empuñan el arco y la lanza, son bárbaros y crueles; su griterío es como el rugido del mar; andan a caballo; cada hombre está equipado para la batalla,para atacarte a ti, hija de Babilonia."
,"43":"Apenas el rey de Babilonia tuvo noticias de todo esto, comenzaron a temblarle las manos, y le asaltó la angustia,y un dolor como de una mujer que da a luz."
,"44":"Alguien sale como un león,de la espesura del Jordán, y se dirige a un potrero siempre verde; así, en un abrir y cerrar de ojos,los echaré de allí,y colocaré a mi elegido. ¿Quién es, en efecto, como yo?,¿Quién podrá demandarme ante la justicia?,¿Dónde está el pastor capaz de hacerme frente?"
,"45":"Así, pues, escuchen lo que ha decidido hacer Yavé con Babilonia y lo que piensa realizar en el país de los caldeos: sí, hasta las ovejas más pequeñas serán llevadas a la rastra, y, al verlo, el rebaño temblará de miedo."
,"46":"Con el estruendo de la caída de Babilonia se estremece la tierra, y el eco retumba en todos los pueblos."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Así habla Yavé: Voy a levantar contra los habitantes de Babilonia un viento impetuoso."
,"2":"Enviaré a Babilonia gente que limpia el grano en la era para que la aventen y limpien su territorio, pues la van a atacar por todas partes en el día de su desgracia."
,"3":"Que ninguno de sus arqueros pueda estirar su arco y que nadie se pueda enderezar en su coraza. No tengan piedad con sus jóvenes, destruyan totalmente su ejército."
,"4":"Los caldeos caerán heridos en su tierra y acuchillados en las calles de Babilonia;"
,"5":"porque Israel no es viuda de su Dios, Yavé de los Ejércitos, aunque su país estaba lleno de pecados contra el Santo de Israel."
,"6":"Salgan de en medio de Babilonia y que cada cual salve su vida; para que no perezca cuando llegue su castigo, pues éste es el momento de la venganza de Yavé en que él le dará su merecido."
,"7":"Babilonia era una copa de oro en manos de Yavé que embriagó al mundo entero, ya que todas las naciones tomaron vino en ella y perdieron la razón."
,"8":"De repente ha caído Babilonia y se ha hecho pedazos; ¡lloren por ella! Vayan a buscar pomada para su mal, a lo mejor se cura."
,"9":"'Atendimos a Babilonia, pero no se recuperó. Dejémosla ahí y partamos cada uno para nuestra tierra; porque el juicio en su contra llega hasta el cielo y se eleva hasta las nubes.'"
,"10":"Yavé ha hecho brillar nuestros derechos. Vengan y contemos en Sión las obras de Yavé, nuestro Dios."
,"11":"Afilen las flechas, llenen con ellas las cajas. Yavé ha movido la voluntad del rey de los medos, para que éste marche contra Babilonia y la destruya: ésta será la venganza de Yavé, la venganza por su Templo."
,"12":"Frente a las murallas de Babilonia levanten banderas, refuercen la guardia, coloquen centinelas, preparen emboscadas, porque Yavé mismo pensó el plan, y ahora cumplirá lo que dijo contra los habitantes de Babilonia."
,"13":"Tú que resides cerca de grandes ríos, tú, rica en tesoros ha llegado tu fin, el término de tus rapiñas."
,"14":"Yavé de los Ejércitos lo ha jurado por sí mismo: Te llenaré de hombres tan numerosos como langostas, que lanzarán gritos de guerra contra ti."
,"15":"El hizo la tierra con su poder, afirmó el mundo con su sabiduría y con su inteligencia extendió los cielos."
,"16":"A su voz se acumulan las aguas en el cielo, hace subir las nubes desde el extremo de la tierra, produce relámpagos en medio del aguacero y saca el viento de sus depósitos."
,"17":"Todo hombre entonces se siente estúpido, imbécil, y el platero se avergüenza de su ídolo, pues sus estatuas no son más que mentiras, que nunca respiran."
,"18":"Son cosas inútiles, puras tonterías que desaparecerán cuando llegue su castigo."
,"19":"No es así, en cambio, el Dios de Jacob, pues él ha formado el universo e Israel es su tribu heredera. Su nombre es Yavé de los Ejércitos."
,"20":"Yo te usé como un martillo, como una maza para el combate."
,"21":"Contigo aplasté naciones, contigo destruí reinos, contigo derribé al caballo y al jinete, al carro de guerra y al que lo monta."
,"22":"Contigo golpeé a hombres y mujeres, al viejo y al muchacho, al joven y a la doncella."
,"23":"Contigo aplasté al pastor y su rebaño, al labrador y su yunta, a gobernantes y funcionarios."
,"24":"Pero le devolveré a Babel,y a todos los caldeos,en presencia de ustedes, dice Yavé, todo el mal que hicieron a Sión. Ya vengo a ti, cerro destructor, que arruinabas la faz de la tierra."
,"25":"Apenas extienda mi mano contra ti,te haré rodar de lo alto de las rocas,y te convertiré en un cerro quemado. Jamás sacarán de ti una piedra de cimientos,"
,"26":"ni tampoco buscarán piedras,para volver a edificarte. Serás un montón de ruinas para siempre, porque así lo ha dicho Yavé."
,"27":"¡Agiten banderas por el mundo entero y toquen el clarín en todas las naciones! Preparen los países para atacarla, citen a los reinos de Ararat, Minni y Askenaz para que marchen contra ella; que entre en acción el oficial de reclutamiento. Lancen a la carga la caballería como una nube de langostas rabiosas."
,"28":"Alisten las naciones para el ataque, el rey de Media, sus gobernadores, todos sus jefes y todos los países que están bajo su imperio."
,"29":"La tierra tembló y se estremeció porque se cumplió lo que Yavé había decretado contra Babilonia: reducir el territorio de Babilonia a un desierto despoblado."
,"30":"Los valientes de Babilonia han abandonado la batalla y se han sentado en las ciudadelas; se les acabaron las fuerzas y parecen unas mujeres."
,"31":"Han prendido fuego a sus aposentos y han hecho pedazos sus trancas. Carteros y mensajeros salen unos después de otros para comunicar al rey de Babilonia que su ciudad ha sido totalmente tomada, "
,"32":"los vados del río ocupados, las fortificaciones incendiadas y los soldados se ha han acobardado."
,"33":"Pues así habla Yavé de los Ejércitos, el Dios de Israel: La hija de Babilonia se parece a una era al tiempo de la trilla; para ella dentro de poco vendrá el tiempo de la siega."
,"34":"El pueblo de Sión dice: 'Me comió y me chupó el rey de Babilonia; me dejó como un plato vacío, me tragó igual que un dragón, se llenó su estómago con mis mejores presas."
,"35":"¡Caigan sobre Babilonia mi humillación y mis sufrimientos, y mi sangre sobre los habitantes de Caldea!, dice Jerusalén."
,"36":"Por lo tanto, así habla Yavé: Aquí estoy para tomar la defensa de tu casa y para asegurarte tu venganza. Voy a secar su río y a agotar sus vertientes."
,"37":"Babilonia se convertirá en un montón de piedras, ven una guarida de chacales que cause horror y desprecio, sin un solo habitante."
,"38":"Todos rugen como leones y andan gruñendo como leoncitos."
,"39":"¿Tienen calor? Ya les tengo listo un refresco, se lo daré para que tomen hasta perder los sentidos y caigan en un sueño eterno y nunca más puedan levantarse, afirma Yavé."
,"40":"Los empujaré como corderos al matadero, como carneros y chivatos."
,"41":"¡Cómo! ¿Ha caído, ha sido conquistada la más famosa del mundo entero? ¡Cómo! ¿Babilonia ahora es la más miserable de las naciones?"
,"42":"El mar se salió en Babilonia y la sumergió bajo el tropel de sus olas."
,"43":"Sus ciudades se han convertido en un desierto seco y triste, donde nadie vive y por donde nadie pasa más."
,"44":"Haré una visita a Bel en Babilonia y le quitaré de su boca lo que ha comido. Ya no vendrán más a él las naciones. ¡Los muros de Babilonia se vinieron abajo, "
,"45":"salgan de allí, pueblo mío! ¡Que cada uno de ustedes salve su vida ante el fuego de la cólera de Yavé!"
,"46":"Pero que no desfallezca su corazón ni se asuste por las noticias que circularán por el país, pues un año correrá un rumor, al año siguiente, otro; la violencia se impondrá en el país y un tirano derrocará a otro."
,"47":"Pues bien, ya se acercaron los días en que voy a castigar a los ídolos de Babilonia; se avergonzará todo su territorio, todos sus muertos quedarán tirados en el centro de la ciudad."
,"48":"Entonces el cielo y la tierra y todo lo que hay en ellos, aplaudirán contra Babilonia, cuando del norte vengan a atacarla los destructores, dice Yavé."
,"49":"Cuando le toque su turno, Babilonia debe caer por todos los muertos de Israel, así como por Babilonia murió tanta gente en el mundo entero."
,"50":"¡Ustedes, que se libraron de la espada, partan, no se queden allí! Acuérdense de Yavé en esta tierra lejana, y que Jerusalén les venga a la memoria:"
,"51":"'Estábamos indignados al oír tantos insultos y nos tapábamos la cara de vergüenza al saber que extranjeros habían entrado en los lugares santos de la Casa de Yavé.'"
,"52":"No importa, ya viene el día, dice Yavé, en que castigaré a sus ídolos, y en toda su tierra se quejarán los heridos."
,"53":"Aunque Babilonia se levante hasta el cielo y alce su poder a donde nadie puede llegar, llegarán, sin embargo, hasta allí los saqueadores que yo mandé, asegura Yavé."
,"54":"Escuchen el griterío que sale de Babilonia y el crujido inmenso del país de los caldeos."
,"55":"Es Yavé que destruye a Babilonia y hace callar su gran ruido, sus olas pueden rugir como las del mar y sentirse el resonar de su voz."
,"56":"Es que viene sobre Babilonia el que la va a destruir; sus soldados son hechos prisioneros, y sus arcos, rotos. Sí, Yavé es el Dios de las represalias que paga estrictamente."
,"57":"Haré emborracharse a sus jefes y a sus sabios, a sus gobernantes, funcionarios y soldados, que caerán en un sueño eterno para no despertar más. ¡Así lo declara el Rey, que se llama Yavé de los Ejércitos!"
,"58":"Esto dice Yavé de los Ejércitos: La ancha muralla de Babilonia será totalmente demolida y sus altas puertas serán quemadas, pues los pueblos trabajan para que todo quede en nada, y las naciones se esfuerzan para que todo lo consuma el fuego."
,"59":"Viene a continuación la orden que dio Jeremías a Seraías, hijo de Nerías, al partir éste junto a Sedecías, rey de Judá, a Babilonia, el cuarto año de su reinado (Seraías era el mayordomo de viaje)."
,"60":"Entonces Jeremías había reunido en un libro todas las profecías que había escrito respecto de Babilonia para anunciar todo el mal que caería sobre ella."
,"61":"Y Jeremías dio esta orden a Seraías: 'Cuando llegues a Babilonia, cuida de leer en voz alta todo esto, y agrega:"
,"62":"'Yavé, tú has declarado respecto a este lugar que será destruido de manera que nadie lo vuelva a habitar y que quede arruinado para siempre.'"
,"63":"Terminado de leer el libro, lo atarás a una piedra y lo tirarás al Eufrates,"
,"64":"diciendo: 'Así se hundirá Babilonia y nunca se levantará de la ruina que yo traigo sobre ella.',Hasta aquí, nada más, las palabras de Jeremías."
}`)
	CurrentBook.AddChapter(52, `{
"1":"Veintiún años tenía Sedecías cuando comenzó a reinar, y reinó once años en Jerusalén. Su madre se llamaba Jamital y era hija de Jeremías, de Libna."
,"2":"Se portó mal a los ojos de Yavé, tal como se había portado Joaquim."
,"3":"Todo lo que le pasó a Jerusalén y a Judá fue porque Yavé se había enojado tanto con ellos que acabó por echarlos de su presencia."
,"4":"Sedecías se rebeló contra el rey de Babilonia. El año nueve del reinado de Sedecías, el día diez del décimo mes del año, Nabucodonosor, rey de Babilonia, llegó con todo su ejército a atacar a Jerusalén, instaló su campamento frente a la ciudad y la rodeó de trincheras."
,"5":"La ciudad estuvo sitiada hasta el año undécimo del reinado de Sedecías."
,"6":"El día nueve del cuarto mes, cuando el hambre reinaba en la ciudad y la población no tenía ya nada más que comer,"
,"7":"se abrió un hoyo en el muro de la ciudad; el rey y todos los combatientes salieron de noche y escaparon de la ciudad por el camino de la puerta que está entre las dos murallas y que está cerca del parque del rey -los caldeos rodeaban la ciudad-, y tomaron el camino del valle del Jordán."
,"8":"Pero las tropas caldeas persiguieron al rey y alcanzaron a Sedecías en los llanos de Jericó, donde todos sus soldados, dejándolo solo, huyeron."
,"9":"Tomaron preso al rey y lo llevaron a la presencia del rey de Babilonia, que estaba en Ribla, en tierra de Jamat, el cual lo sometió a juicio."
,"10":"En Ribla mandó degollar a los hijos de Sedecías ante sus propios ojos, y lo mismo hizo con todos los jefes de Judá."
,"11":"Luego, le sacó los ojos a Sedecías y lo amarró con cadenas de bronce. Después el rey de Babilonia se lo llevó a Babilonia, donde lo tuvo prisionero hasta el día de su muerte."
,"12":"El día diez del quinto mes, era el año diecinueve de Nabucodonosor, rey de Babilonia, Nebuzardán, comandante de la guardia y uno de los acompañantes más cercanos del rey de Babilonia, hizo su entrada en Jerusalén."
,"13":"Incendió el Templo de Yavé, el palacio real y todas las casas de Jerusalén."
,"14":"Las tropas caldeas, que mandaba el comandante de la guardia, demolieron todas las murallas que rodeaban a Jerusalén."
,"15":"Nebuzardán, comandante de la guardia, desterró el resto de la población que había quedado en la ciudad, a los desertores que se habían pasado al rey de Babilonia y a los pocos artesanos que aún había. Pero Nebuzardán, comandante de la guardia,"
,"16":"dejó una parte de la gente pobre del país como vinateros y labradores."
,"17":"Los caldeos hicieron pedazos las columnas de bronce de la Casa de Yavé, las basas redondas y el Mar de Bronce que había en la Casa de Yavé, y se llevaron todo el bronce a Babilonia."
,"18":"Tomaron también los ceniceros, las palas, los cuchillos, las copas para rociar, las cucharas; en una palabra, todos los objetos de bronce que se utilizaban en el templo."
,"19":"El comandante de la guardia tomó además las vasijas, los braseros, los jarros, los ceniceros, los candelabros, los tazones y los platos para los sacrificios, todo de oro y de plata."
,"20":"En cuanto a las dos columnas, al Mar, a los doce bueyes de bronce que estaban debajo del Mar, y a las basas redondas que el rey Salomón había mandado fabricar para la Casa de Yavé, no se pudo calcular lo que pesaba el bronce de todos estos objetos."
,"21":"Cada una de las dos columnas tenía dieciocho codos de alto, doce de circunferencia y cuatro dedos de grosor, y eran huecas por dentro."
,"22":"Encima tenían un capitel de bronce de cinco codos de altura, rodeado totalmente por un trenzado con granadas, todo de bronce. Ambas columnas eran iguales."
,"23":"Había noventa y seis granadas de relieve en torno a ellas. Y había cien granadas alrededor del trenzado."
,"24":"El comandante de la guardia tomó prisionero al sumo sacerdote Seraya, a su vicario Sofonías y a los tres guardianes del Templo."
,"25":"Entre los ciudadanos hizo apresar a un oficial del palacio que mandaba a los soldados, a siete familiares del rey que fueron encontrados en la ciudad, al secretario del jefe del ejército, encargado del reclutamiento, y a sesenta personas de condición que se hallaban en la ciudad."
,"26":"Nebuzardán, comandante de la guardia, los mantuvo detenidos y los llevó al rey de Babilonia, que estaba en Ribla,"
,"27":"quien los mandó matar en Ribla, en la región de Jamat. Entonces fue desterrado Judá lejos de su tierra."
,"28":"Este es el número de las personas que desterró Nabucodonosor: en el año séptimo: 3.023 judíos;"
,"29":"en el año dieciocho de Nabucodonosor fueron sacadas de Jerusalén 832 personas; "
,"30":"en el año veintitrés de Nabucodonosor, Nebuzardán, comandante de la guardia, mandó al destierro 745 judíos. Lo que da un total de 4.600 personas."
,"31":"Pero en el año treinta y siete del destierro de Joaquín, rey de Judá, el día veinticinco del duodécimo mes, Evilmerodac, rey de Babilonia, durante el primer año de reinado, indultó a Joaquim, rey de Judá, y lo sacó de la cárcel."
,"32":"Le habló amigablemente y le concedió un trato superior al de los otros reyes que estaban con él en Babilonia."
,"33":"Joaquim dejó sus ropas de prisionero y, en adelante, se sentó a comer en la mesa del rey."
,"34":"Su mantenimiento fue siempre asegurado por el rey de Babilonia, día a día, hasta su muerte, mientras vivió."
}`)

}
func ES_LBL_LoadVMISChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"En los tiempos de Ozías, Jotam, Ajaz y Ezequías, reyes de Judá, Isaías, hijo de Amós, tuvo esta visión acerca de Judá y Jerusalén."
,"2":"¡Cielos y tierra, oigan!,Escuchen la queja de Yavé: 'Crié hijos hasta hacerlos hombres, pero se rebelaron contra mí."
,"3":"El buey conoce a su dueño,y el burro el pesebre de su señor; pero Israel no me conoce, mi pueblo no comprende.'"
,"4":"¡Ay, gente pecadora, pueblo cargado de crímenes, raza de malvados, hijos perversos!,Han abandonado a Yavé, han despreciado al Santo de Israel."
,"5":"¿Dónde quieren que les pegue ahora, ya que siguen rebeldes?,Tienen toda la cabeza dolorida, el corazón entero apenado,"
,"6":"desde la planta de los pies hasta la cabeza,no les queda nada sano; sólo heridas, golpes, llagas vivas,que no han sido envueltas ni vendadas,ni aliviadas con aceite."
,"7":"Su país es una soledad,con ciudades hechas cenizas; ustedes vieron las cosechas, y el enemigo se las comió; esta ruina no es menos que la de Sodoma."
,"8":"Aquí está la Hija de Sión,como cabaña de viña, como choza de melonar, como ciudad que ha sufrido un largo sitio."
,"9":"¡Menos mal que Yavé de los Ejércitos,no ha dejado un resto!,Pues por poco nos parecemos a Sodoma,y somos igual que Gomorra."
,"10":"Escuchen, jefes de Sodoma,que esto es palabra de Yavé; presten atención, pueblo de Gomorra, a las advertencias de nuestro Dios:"
,"11":"'¿Por qué tantos sacrificios en mi honor?,-dice Yavé. Ya estoy saciado de sus animales, de la grasa de sus terneros. No me agrada la sangre de sus novillos, de sus corderos y chivos."
,"12":"Si suben hacia mí en peregrinación, y se agolpan en los patios de mi Templo, ¿quién se lo ha pedido?"
,"13":"Déjense de traerme ofrendas inútiles; ¡el incienso me causa horror!,Lunas nuevas, sábados, reuniones, ¡ya no soporto más sacrificios ni fiestas!"
,"14":"Odio sus lunas nuevas y sus ceremonias, se me han vuelto un peso,y estoy cansado de tolerarlas."
,"15":"Cuando rezan con las manos extendidas, aparto mis ojos para no verlos; aunque multipliquen sus plegarias, no las escucharé, porque veo la sangre en sus manos."
,"16":"¡Lávense, purifíquense!,no me hagan el testigo de sus malas acciones,"
,"17":"dejen de hacer el mal y aprendan a hacer el bien. Busquen la justicia, den sus derechos al oprimido, hagan justicia al huérfano y defiendan a la viuda.'"
,"18":"Ahora Yavé les dice: 'Vengan, para que arreglemos cuentas. Aunque sus pecados sean colorados, quedarán blancos como la nieve; aunque sean rojos como púrpura, se volverán como lana blanca."
,"19":"Si ustedes quieren obedecerme, comerán lo mejor de la tierra;"
,"20":"pero si ustedes insisten en desobedecerme, será la espada la que los devore; porque ésta es palabra de Yavé.'"
,"21":"¿Cómo es posible, se ha prostituido,Sión, la ciudad fiel, el reino de la justicia,en que moraba la rectitud,que te conformabas a mis leyes?, pero ahora sólo es un barrio de asesinos."
,"22":"Tu plata se ha convertido en basura, tu vino está mezclado con agua."
,"23":"Tus jefes son unos rebeldes, cómplices de ladrones. Todos esperan recompensa,y van detrás de los regalos. No hacen justicia al huérfano,ni atienden la causa de la viuda."
,"24":"Por eso, dice el Señor Yavé Sabaot, el Fuerte de Israel: 'Me desquitaré con mis adversarios,me vengaré de mis enemigos."
,"25":"Volveré mi mano contra ti,y quemaré tus impurezas con la cal, hasta quitarte todo lo sucio que tengas."
,"26":"Haré a tus gobernantes como eran antes, y a tus consejeros como en otros tiempos. Entonces te llamarán,Ciudad Fiel, Lugar de la Justicia."
,"27":"Sión será librada, pero no sin un Juicio, y son los justos los que se salvarán;"
,"28":"rebeldes y pecadores serán destrozados,y aquellos que se alejen de Yavé, perecerán."
,"29":"Ustedes se avergonzarán,de los árboles sagrados que tanto les gustan, y se pondrán colorados,al ver los jardines que tanto les encantan."
,"30":"Pues ustedes serán como una encina a la que se le caen las hojas, y como un jardín al que le falta agua."
,"31":"El hombre importante quedará como un trapo,y su trabajo como una chispa; se quemarán los dos juntos, y no habrá nadie para apagar el fuego."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Isaías, hijo de Amós, tuvo esta visión acerca de Judá y de Jerusalén."
,"2":"Al fin de los tiempos, el cerro de la Casa de Yavé,será puesto sobre los altos montes,y dominará los lugares más elevados."
,"3":"Irán a verlo todas las naciones,y subirán hacia él muchos pueblos, diciendo: 'Vengan, subamos al cerro de Yavé, a la Casa del Dios de Jacob, para que nos enseñe sus caminos,y caminemos por sus sendas. Porque la enseñanza irradia de Sión, de Jerusalén sale la palabra de Yavé.'"
,"4":"Hará de árbitro entre las naciones,y a los pueblos dará lecciones. Harán arados de sus espadas y sacarán hoces de sus lanzas. Una nación no levantará la espada contra otra,y no se adiestrarán para la guerra."
,"5":"Pueblo de Jacob, ven: ¡caminemos a la luz de Yavé!"
,"6":"Yavé, has rechazado a tu pueblo, a los hijos de Jacob, porque su país está lleno de adivinos y de magos, como los hay entre los paganos, y se ven numerosos extranjeros."
,"7":"Su país está lleno de oro y plata,y sus tesoros son innumerables."
,"8":"Su país está lleno de caballos,y sus carros de guerra son numerosos. Su país está lleno de ídolos, pues se inclinan ante la obra de sus manos, ante la figura que modelaron sus dedos."
,"9":"El hombre será humillado, el mortal abatido: ¡No se lo perdones!"
,"10":"Métete entre las rocas, escóndete en el polvo, para no ver la cara de Yavé, que da miedo o que brilla majestuosa, cuando él aparezca para hacer temblar la tierra."
,"11":"El hombre bajará sus ojos orgullosos,y su soberbia se irá al suelo; sólo Yavé será exaltado aquel día."
,"12":"Pues Yavé Sabaot tendrá su día,contra todo orgullo e insolencia,y contra todo el que se cree: ¡será rebajado!"
,"13":"Pedirá cuentas a los cedros del Líbano,elevados y altaneros, y a las encinas de Basán,"
,"14":"a los cerros altos y las lomas orgullosas,"
,"15":"a las torres altas y las murallas fortificadas,"
,"16":"a los barcos de ultramar y las naves lujosas. El orgullo del hombre será doblegado,y las glorias humanas, humilladas."
,"17":"Sólo Yavé será exaltado cuando venga aquel día,"
,"18":"y de los ídolos no quedará nada."
,"19":"Irán a meterse entre las rocas, y en los huecos de la tierra, para no ver la cara de Yavé, que da miedo o que brilla majestuosa, cuando él aparezca para hacer temblar la tierra."
,"20":"Ese día, el hombre tirará a los topos y a los murciélagos,los ídolos de oro y de plata,que se había hecho para adorarlos,"
,"21":"y se esconderá en las rocas,o detrás de las piedras, para no ver la cara de Yavé, que da miedo o que brilla majestuosa, cuando él aparezca para hacer temblar la tierra."
,"22":"No confíen más en el hombre, pues no dura más que el soplo de sus narices: ¿para qué estimarlo tanto?"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Esta es la hora del Señor Yavé, en que quita de Jerusalén y de Judá,todas las provisiones y recursos: las provisiones de pan y las reservas de agua."
,"2":"Las deja sin oficiales ni soldados, sin juez ni profeta; sin adivino ni anciano,"
,"3":"sin capitán ni noble, sin consejero, ni sabio, ni artesano o mago."
,"4":"'Les pondré como jefes a unos chiquillos,y a unos petulantes para que los manden.'"
,"5":"Entre la gente del pueblo pelearán unos con otros, o unos vecinos con otros; el joven le reprenderá al viejo,y el hombre sin apellido al noble,"
,"6":"pues cada cual querrá obligar al otro,o a su mismo hermano, diciéndole: 'Tú tienes una manta, ¿por qué no aceptas ser nuestro jefe,y nos sacas así de esta ruina?'"
,"7":"Aquel día cada cual se excusará: Yo no soy ningún médico, ni tengo en mi casa pan ni manta, no me pongan como jefe del pueblo.'"
,"8":"Sí, Jerusalén se viene abajo, y se hunde Judá, a causa de sus palabras y hechos, pues a la vista de Yavé han desafiado su gloria."
,"9":"Su rostro descarado los denuncia,y, como Sodoma, muestran sus pecados en vez de esconderlos. ¡Ay de ellos que han preparado su propia ruina!"
,"10":"Digan: 'Feliz el justo, pues comerá el fruto de sus obras'; pero: 'Pobre del malo, porque le irá mal, y será tratado según las obras de sus manos.'"
,"11":"¡Oh, pueblo mío!, chiquillos lo oprimen y mujeres lo gobiernan."
,"12":"¡Oh, pueblo mío!, los que debían guiar tus pasos,te hacen desviarte y echan a perder el camino que sigues."
,"13":"Yavé se instala en su tribunal, y se pone de pie para juzgar a su pueblo."
,"14":"Yavé demanda a los ancianos y a los jefes de su pueblo: 'Ustedes han devorado los frutos de la viña, en sus casas están los despojos del pobre."
,"15":"¿Con qué derecho vejan a mi pueblo o pisotean a los pobres?', dice el Señor Yavé de los Ejércitos."
,"16":"Dice Yavé: 'Muy orgullosas andan las damas de Sión, con el cuello estirado y la mirada provocativa, y caminan a pasitos cortos haciendo sonar las pulseras de sus pies.'"
,"17":"Por eso, el Señor llenará de sarna la cabeza de las damas de Sión, y quedarán peladas."
,"18":"Aquel día, el Señor arrancará los adornos, pulseras para los tobillos, cintas y lunetas,"
,"19":"pendientes, brazaletes,"
,"20":"velos, sombreros, cadenillas de pie, cinturones, frascos de perfume y amuletos,"
,"21":"sortijas, aros de nariz,"
,"22":"vestidos preciosos, mantos, chales y bolsos,"
,"23":"espejos, lienzos finos, turbantes y mantillas."
,"24":"Aquel día, en lugar de perfumes habrá podredumbre; en lugar de cinturón, una cuerda; en lugar de cabello trenzado, cabeza rapada; en lugar de vestidos lujosos, un saco; en vez de un diestro maquillaje, una marca con un hierro al rojo."
,"25":"Tus hombres caerán bajo la espada, y tu ejército quedará tendido en tierra. En tus puertas habrá lamentos y duelo, y tú te sentarás sola, en el suelo."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Siete mujeres se pelearán,por un solo hombre en ese día, y le suplicarán: 'Nos alimentaremos por nuestra cuenta, y lo mismo nos vestiremos nosotras, permítenos solamente llevar tu apellido, para salvar así nuestra honra.'"
,"2":"Aquel día, el Brote de Yavé será ornamento y gloria de los salvados de Israel; el Fruto de la tierra será su orgullo y esplendor."
,"3":"A los que queden de Sión y al resto de Jerusalén se los llamará santos, pues sus nombres fueron escritos para que tengan vida en Jerusalén. El Señor viene para "
,"4":"lavar de sus inmundicias a las hijas de Sión, y para limpiar a Jerusalén de la sangre que ha sido derramada en ella, con el soplo de su justicia que es un soplo de fuego."
,"5":"Entonces habrá sobre el cerro Sión y sobre su Asamblea santa, una nube de día y como resplandor de fuego llameante por la noche. La Gloria de Yavé se extenderá por encima como un toldo"
,"6":"o una tienda, para dar sombra contra el calor del día, refugio y amparo contra el temporal."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Déjenme cantar, en nombre de mi amigo, la canción de mi amigo por su viña. Una viña tenía mi amigo en una loma fértil."
,"2":"La cavó quitando las piedras,y plantó cepas escogidas. En medio de ella construyó una torre,y también cavó un lagar. El esperaba que produjera uvas, pero sólo le dio racimos amargos."
,"3":"Acérquense, habitantes de Jerusalén, y hombres de Judá: juzguen ahora entre mi viña y yo."
,"4":"¿Qué otra cosa pude hacer a mi viña,que no se lo hice?,¿Por qué, esperando que diera uvas, sólo ha dado racimos amargos?"
,"5":"Déjenme que les diga,lo que voy a hacer con mi viña: le quitaré la cerca, para que la puedan saquear; se convertirá en maleza para el fuego;"
,"6":"derribaré el muro, y será pisoteada. Ya no la cuidaré en adelante, no se podará ni se limpiará más, sino que crecerán en ella la zarza y el espino, y les mandaré a las nubes,que no dejen caer más lluvia sobre ella."
,"7":"La viña de Yavé Sabaot es el pueblo de Israel, y los hombres de Judá, su cepa escogida. El esperaba rectitud, y va creciendo el mal; esperaba justicia, y sólo se oye el grito de los oprimidos."
,"8":"¡Pobres de ustedes que compran todas las casas,y van juntando campo a campo!,¿Así, que no quedará más lugar,y sólo quedarán ustedes en este país?"
,"9":"En mis oídos ha resonado la palabra de Yavé de los Ejércitos: 'Han de quedar en ruinas muchas casas grandes y hermosas, y no habrá quien las habite. "
,"10":"Diez cuadras de viña apenas darán un barril de vino, y un quintal de semilla sólo dará un puñado.'"
,"11":"¡Pobres de aquellos que se levantan muy temprano,en busca de aguardiente,y hasta muy entrada la noche continúan su borrachera!"
,"12":"Hay cítaras, panderetas, arpas, flautas y vino en su banquete, pero no ven la obra de Yavé,ni entienden lo que él está preparando."
,"13":"A mi pueblo le falta inteligencia, por eso será desterrado. Sus nobles morirán de hambre, y su pueblo perecerá de sed."
,"14":"Por esto la Muerte ensancha su garganta,y abre su enorme hocico, allí baja el esplendor de Sión: con toda la bulla de su gente alegre."
,"15":"El mortal será doblegado, y cada cual humillado."
,"16":"Yavé Sabaot será grande en el Juicio, el Dios Santo al juzgar, mostrará su santidad."
,"17":"Los corderos pastarán en sus campos desolados,y las manadas vivirán en medio de los escombros."
,"18":"Desgraciados de aquellos que arrastran su maldad,con la cuerda de sus engaños, y arrastran el pecado,como los tiros de un carro."
,"19":"De aquellos que dicen: 'Rápido!,Que Yavé haga sus cosas y que las veamos. ¡Que se cumpla el proyecto del Santo de Israel, que venga para que lo conozcamos!'"
,"20":"¡Ay de aquellos que llaman bien al mal y mal al bien, que cambian las tinieblas en luz,y la luz en tinieblas, que dan lo amargo por dulce,y lo dulce por amargo!"
,"21":"¡Ay de los que se creen sabios,y se consideran inteligentes!"
,"22":"¡Pobres de los que son valientes para beber vino, y campeones para mezclar bebidas fuertes,"
,"23":"pero que perdonan al culpable por dinero, y privan al justo de sus derechos!"
,"24":"Así como las llamas queman el rastrojo,y como el pasto seco se consume en el fuego, así se pudrirá su raíz,y el viento se llevará su flor junto con el polvo. Pues han rechazado la ley de Yavé Sabaot,y han despreciado la palabra del Santo de Israel."
,"25":"Por esto Yavé se enojó con su pueblo,y levantó su mano para pegarle; los cerros se estremecieron,y los cadáveres quedaron tirados,esparcidos como la basura en las calles. Pero no se le pasó el enojo, pues siguió con su mano levantada."
,"26":"Le hace señas a una nación lejana,y le pega un silbido desde el fin del mundo; ella ligerito llega con rapidez."
,"27":"Nadie de los suyos se debilita o se cansa, ni se queda dormido o se pone a cabecear, ninguno se suelta los cordones de su zapato."
,"28":"Sus flechas son muy puntiagudas, todos sus arcos estirados, los cascos de sus caballos son como de piedra, las ruedas de sus carros igual que el huracán."
,"29":"Tiene un rugido como de leona, ruge como un cachorro de león, gruñe y atrapa su presa, se la lleva y nadie se la quita."
,"30":"Rugirá contra él, en ese día, como el bramido del mar. Al mirar el país sólo se verán tinieblas, angustia, y luz que desaparece entre las sombras."
}`)
	CurrentBook.AddChapter(6, `{
"1":"El año en que murió el rey Ozías, vi al Señor sentado en un trono elevado y alto, y el ruedo de su manto llenaba el Templo."
,"2":"Por encima de él había serafines. Cada uno de ellos tenía seis alas: con dos se cubrían el rostro, con dos los pies y con las otras volaban."
,"3":"Y gritaban, respondiéndose el uno al otro: 'Santo, Santo, Santo es Yavé de los Ejércitos, su Gloria llena la tierra toda.'"
,"4":"Los postes de piedra de la entrada temblaban a la voz del que gritaba y la Casa se llenaba de humo. Yo exclamé: "
,"5":"'¡Ay de mí, estoy perdido, porque soy un hombre de labios impuros y vivo entre un pueblo de labios impuros, y mis ojos han visto al rey, Yavé de los Ejércitos!'"
,"6":"Entonces voló hacia mí uno de los serafines. Tenía un carbón encendido que había tomado del altar con unas tenazas,"
,"7":"tocó con él mi boca y dijo: 'Mira, esto ha tocado tus labios, tu falta ha sido perdonada y tu pecado, borrado.'"
,"8":"Y oí la voz del Señor que decía: '¿A quién enviaré, y quién irá por nosotros?' Y respondí: 'Aquí me tienes, mándame a mí.'"
,"9":"El me dijo: 'Ve y dile a este pueblo: Por más que ustedes escuchen, no entenderán; por más que ustedes miren, nunca ven.'"
,"10":"¡Puedes ir! Se pondrá más pesado el corazón de este pueblo, se volverán sordos sus oídos y se les pegarán sus ojos. ¿Acaso se atreverían a ver con sus ojos, y a oír sus oídos, para que comprenda su corazón, y se conviertan y recuperen la salud.'"
,"11":"Yo dije: '¿Hasta cuándo, Señor?' Y él me respondió:"
,"12":"'Hasta que las ciudades queden destruidas y sin habitantes, las casas desocupadas y la tierra abandonada; hasta que Yavé haya expulsado a los hombres y la soledad en el país sea grande."
,"13":"Y si quedara solamente la décima parte, también habría de ser entregada al fuego, como hacen con la raíz de la encina y del roble. De la raíz, sin embargo, brotará una raza santa.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Esto sucedió en tiempos de Ajaz, hijo de Jotam y nieto de Ozías, rey de Judá. Rasín, rey de Aram y Pecaj, hijo de Romelía, rey de Israel, subieron a Jerusalén para apoderarse de ella, pero no lo consiguieron."
,"2":"Cuando llevaron esta noticia al palacio de David: 'Los de Aram están acampados en el territorio de Efraím', el corazón del rey y de la gente se puso a palpitar como se estremecen los árboles del bosque movidos por el viento."
,"3":"Entonces Yavé dijo a Isaías: 'Sal con tu hijo Un-resto-volverá, y ve al encuentro de Ajaz: está en el camino del campo del batanero, donde termina el canal de la piscina superior. Le dirás:"
,"4":"Quédate tranquilo, no tengas miedo, y que tu corazón no te falle al ver ese par de tizones humeantes."
,"5":"Rasín, rey de Aram, y el hijo de Romelía se han enfurecido, ¿y qué? Es cierto que Aram, Efraím y el hijo de Romelía han resuelto acabar contigo, y han dicho:"
,"6":"Subamos contra Judá, metámosle miedo, apoderémonos de ella y pongamos allí por rey al hijo de Tabel."
,"7":"Pero así habla el Señor Yavé: Esto no se cumplirá ni pasará jamás. "
,"8":"Rasín es sólo jefe de Damasco, y Damasco es solamente la capital de Aram."
,"9":"Samaria es la capital de Efraím, y el hijo de Romelía es sólo jefe de Samaria. Pero si ustedes no creen, no permanecerán."
,"10":"Yavé se dirigió otra vez a Ajaz, por medio de Isaías, que le dijo:"
,"11":"'Pide a Yavé, tu Dios, una señal, aunque sea en las profundidades del lugar oscuro o en las alturas del cielo.'"
,"12":"Respondió Ajaz: 'No la pediré, porque no quiero poner a prueba a Yavé.'"
,"13":"Entonces Isaías dijo: '¡Oigan, herederos de David! ¿No les basta molestar a todos, que también quieren cansar a mi Dios?"
,"14":"El Señor, pues, les dará esta señal: La joven está embarazada y da a luz un varón a quien le pone el nombre de Emmanuel, es decir: Dios-con-nosotros."
,"15":"El niño se alimentará de leche cuajada y miel hasta que sepa rechazar lo malo y elegir lo bueno."
,"16":"Porque antes de que sepa rechazar lo malo y elegir lo bueno, los territorios de los dos reyes que ahora te amenazan, serán destruidos"
,"17":"y Yavé te enviará a ti, a tu pueblo y familia, días tan malos como nunca los hubo desde que Efraím se separó de Judá."
,"18":"Aquel día Yavé llamará con un silbido: de los ríos de Egipto vendrán los tábanos,y del país de Asiria las avispas."
,"19":"Vendrán y se posarán en masa,en las quebradas, en las hendiduras de las rocas, en todos los matorrales,y en todas las praderas."
,"20":"En ese día, el Señor, con una navaja alquilada al otro lado del río, rapará la cabeza, el cuerpo y la barba."
,"21":"Aquel día cada cual criará una vaca y dos ovejas."
,"22":"Darán leche en abundancia,y cuantos queden en el país,se alimentarán de leche cuajada y miel."
,"23":"Aquel día todo lugar donde había mil parras, valoradas en mil monedas de plata, se cubrirá de zarzas y espinas."
,"24":"Se entrará en él con flechas y arcos, porque todo el país no será más que zarzas y espinas."
,"25":"Y por miedo a las espinas y a las zarzas, no entrará más en los cerros que antes se cultivaban, porque no serán más que terrenos baldíos. Allí soltarán los bueyes, y los dejarán para las ovejas."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Yavé me dijo: 'Toma una tablilla grande y escribe encima con un punzón: 'Pronto-Saqueo-Rápido-Botín'."
,"2":"Lo harás en presencia de dos testigos fidedignos, el sacerdote Urías y Zacarías, hijo de Iberequías.'"
,"3":"Luego me acerqué a la profetisa, que dio a luz un hijo, y Yavé me dijo: 'Ponle el nombre de 'Pronto-Saqueo-Rápido-Botín',"
,"4":"porque antes de que el niño sepa decir 'papá y mamá', la riqueza de Damasco y el botín de Samaria serán llevados ante el rey de Asiria.'"
,"5":"Yavé me habló nuevamente y me dijo:"
,"6":"'Este pueblo se ha asustado ante los reyes de Damasco y Samaria, y no hizo más caso de las aguas de Siloé que corren mansamente."
,"7":"Pues bien, el Señor hará subir contra ellos las aguas embravecidas y profundas del río Eufrates (que es el rey de Asiria con todo su poder). ¡Ya está saliendo de su lecho y corre por todas sus riberas! "
,"8":"¡Llega hasta Judá inundándolo todo, sus aguas le llegan hasta el cuello! Aquí está y sus alas abiertas cubren todo lo ancho de tu país, ¡oh Emmanuel!"
,"9":"Véanlo, pueblos, y sean destrozados; atrévanse, naciones lejanas. ¡Arriba! Serán destrozados."
,"10":"Tracen un plan: fracasará; digan una palabra: no se cumplirá; porque Dios está con nosotros."
,"11":"Esta es la advertencia que me dirigió Yavé en el momento en que me tomó de su mano y me mandó que no siguiera el camino de este pueblo. Estas fueron sus palabras:"
,"12":"'No digan ustedes: '¡Conspiración!' cada vez que la gente dice: '¡Conspiración!'. No teman lo que ellos temen, ni tengan miedo."
,"13":"Yavé de los Ejércitos es el único a quien ustedes deben tener por Santo, a quien deben temer y al que tendrán miedo."
,"14":"El es un Santuario para los dos reinos de Israel, pero también es piedra donde se tropieza y roca que hace caer. Y será como una red y una trampa para la gente de Jerusalén."
,"15":"Es ahí donde muchos tropezarán, caerán y se quebrarán, quedarán atrapados y presos.'"
,"16":"Y añadió Yavé: 'Que mis discípulos guarden esta declaración cual revelación sellada.'"
,"17":"Ahora, pues, esperaré en Yavé, que esconde su rostro al pueblo de Jacob; en él confío."
,"18":"Yo y los hijos que Yavé me ha dado, somos para Israel como señales y anuncios que puso Yavé de los Ejércitos, que habita en el monte de Sión."
,"19":"Y si les dicen a ustedes: 'Consulten a los espíritus y a los adivinos que cuchichean y murmuran', respondan: '¡Por supuesto, todo pueblo debe consultar a sus dioses! ¡A ver si los muertos podrán aconsejar a los que viven!'"
,"20":"Ojalá dijeran: 'Vuelvan a la Ley y las declaraciones de Dios', y estén de acuerdo con esta palabra en que no hay tinieblas."
,"21":"Andarán vagando por el país, amargados y hambrientos, y se pondrán furiosos por el hambre, y maldecirán a su rey y a su Dios: levantarán sus ojos al cielo,"
,"22":"luego mirarán al suelo,y sólo encontrarán miseria y tinieblas, oscuridad angustiosa, y no verán más que noche."
,"23":"Pero allí donde se encontraba la angustia, desaparecerá la noche. En el pasado casi aniquiló al país de Zabulón y al país de Neftalí, pero en el futuro se llenará de gloria la carretera del mar, más allá del Jordán, en la región de los paganos."
}`)
	CurrentBook.AddChapter(9, `{
"1":"El pueblo que caminaba en la noche,divisó una luz grande; habitaban el oscuro país de la muerte, pero fueron iluminados."
,"2":"Tú los has bendecido y multiplicado, los has colmado de alegría. Es una fiesta ante ti como en un día de siega, es la alegría de los que reparten el botín."
,"3":"Pues el yugo que soportaban,y la vara sobre sus espaldas, el látigo de su capataz, tú los quiebras como en el día de Madián."
,"4":"Los zapatos que hacían retumbar la tierra,y los mantos manchados de sangre,van a ser quemados: el fuego los devorará."
,"5":"Porque un niño nos ha nacido, un hijo se nos ha dado; le ponen en el hombro el distintivo del rey,y proclaman su nombre: 'Consejero admirable, Dios fuerte, Padre que no muere, príncipe de la Paz.'"
,"6":"El imperio crece con él,y la prosperidad no tiene límites, para el trono de David y para su reino: El lo establece y lo afianza,por el derecho y la justicia, desde ahora y para siempre. Sí, así será, por el amor celoso de Yavé Sabaot."
,"7":"El Señor ha lanzado una sentencia contra Jacob, y ha caído en Israel."
,"8":"Todo ese pueblo ha sido testigo, la gente de Efraím y los habitantes de Samaria. Pero se hicieron fuertes y dijeron con soberbia:"
,"9":"'Si se han venido abajo los ladrillos, edificaremos con piedras labradas; si han cortado los sicómoros, los reemplazaremos con cedros.'"
,"10":"Pero Yavé lanza contra este pueblo a sus enemigos, azuza a sus adversarios:"
,"11":"Aram por el este y los filisteos por el oeste, que devoran a Israel a dentelladas. Ni con esto se le ha pasado el enojo, y su mano sigue amenazando."
,"12":"Mas el pueblo no se ha vuelto hacia el que le pegaba, no se ha preocupado de Yavé de los ejércitos."
,"13":"Por eso Yavé ha cortado a Israel cabeza y cola, palmera y junco, en un mismo día."
,"14":"La cabeza son el anciano y el noble; la cola es el profeta de mentira."
,"15":"Los guías de este pueblo lo han extraviado y sus dirigidos se han perdido."
,"16":"Por eso, el Señor no tendrá compasión de sus jóvenes, y tratará sin piedad a sus huérfanos y viudas. Todo este pueblo es hipócrita y perverso, y no tienen en la boca más que estupideces. Ni con eso se le ha pasado el enojo, y su mano sigue amenazante."
,"17":"Pues su maldad arde como fuego, devora zarzas y espinas, y después quema la espesura del bosque, y todos ellos se disipan como se disipa el humo."
,"18":"El enojo de Yavé de los Ejércitos ha sacudido el país y el pueblo ha sido pasto de las llamas. Nadie se compadece de su hermano, cada uno se come la carne de su vecino."
,"19":"Muerden a derecha, y todavía siguen con hambre; comen a izquierda, y no quedan satisfechos."
,"20":"Manasés se come a Efraím, Efraím a Manasés, y ambos se lanzan contra Judá. Ni con eso se le ha pasado el enojo, y su mano sigue amenazante."
}`)
	CurrentBook.AddChapter(10, `{
"1":"¡Pobres de aquellos que dictan leyes injustas,y ponen por escrito los decretos de la maldad."
,"2":"Dejan sin protección a los pobres de mi país; roban a los pequeños de sus derechos, dejan sin nada a la viuda,y despojan al huérfano!"
,"3":"¿Qué harán el día en que se arreglen las cuentas?,¿A dónde huirán, y quién los ayudará,cuando, desde lejos, venga el desastre?,¿Dónde encerrarán sus riquezas?"
,"4":"No quedará más que doblegarse bajo las cadenas,o caer con los muertos. Pero a Yavé no se le ha pasado el enojo, aún sigue con la mano amenazante."
,"5":"¡Ay de Asur, que es el bastón de mi ira, el garrote que usa mi furor!"
,"6":"Yo lo he enviado,contra una nación impía, contra un pueblo que me molesta, para que lo saquee,y le quite todo lo que tiene,y lo pisotee como el polvo de las calles."
,"7":"El, sin embargo, no entiende mi proyecto, ni lo cree así su corazón, pues su intención es destruir,y desmenuzar a no pocas naciones."
,"8":"Dice: '¿Mis príncipes no son reyes acaso?"
,"9":"No sucedió a Calmo como a Carquemis, a Jamat igual que a Arpad y a Samaria como a Damasco?"
,"10":"Mi mano supo alcanzar los reinos de los ídolos, en que las estatuas eran más numerosas que las de Jerusalén y Samaria;"
,"11":"pues bien, como he tratado a Samaria y a sus ídolos, ¿no seré capaz de hacer lo mismo con Jerusalén y sus objetos sagrados?'"
,"12":"Pero esto ha de suceder: cuando el Señor haya terminado su obra en la montaña de Sión y en Jerusalén, castigará la soberbia del corazón del rey de Asiria y la mirada despreciativa de sus ojos. Porque dijo:"
,"13":"'Esto lo conseguí con la fuerza de mi brazo,y con mi capacidad, pues soy inteligente; he hecho retroceder las fronteras de los pueblos,y me he apoderado de sus tesoros. Yo como soberano hice bajar de su trono a sus reyes."
,"14":"Mi mano ha tomado, como se toma un nido, las riquezas de los pueblos. Como se recogen huevos botados, así me he apoderado de toda la tierra,y no hubo quién aleteara,ni abriera el pico ni piara.'"
,"15":"¿Acaso el hacha se cree más que el leñador, o la sierra, más que el aserrador?,¡Como si el bastón mandara a quien lo usa,o el palo moviera al que no es de madera!"
,"16":"Por eso, Yavé de los ejércitos enviará,a sus hombres forzudos la debilidad,y prenderá fuego a su lujo,como se enciende la leña."
,"17":"La luz de Israel se hará fuego,y su Santo será como una llama,"
,"18":"que quemará y consumirá,todos sus matorrales en un solo día. El esplendor de sus bosques y de sus árboles frutales,se desvanece, se deshace, y se le va la vida."
,"19":"Lo que quede de sus árboles será tan poco, que un niño los podrá contar."
,"20":"Aquel día el resto de Israel y los sobrevivientes de la familia de Jacob ya no le pedirán ayuda al que les pega, sino que le pedirán ayuda a Yavé, el Santo de Israel, y serán sinceros con él."
,"21":"'Un resto volverá', un resto de Jacob se volverá hacia el Dios fuerte."
,"22":"Porque aunque fuera tu pueblo, oh Israel, como la arena del mar, sólo un resto volverá. Su destrucción está decidida, para que quede bien en claro la justicia;"
,"23":"pues el Señor Yavé de los Ejércitos llevará a cabo, en todo el país, exterminio y limpieza."
,"24":"Por tanto, así se expresa Yavé de los Ejércitos: Oh pueblo mío, que vives en Sión, no le tengas miedo a Asur, que te da de palos, o que te pega con su bastón, como hacía Egipto. "
,"25":"Porque dentro de muy poco tiempo desaparecerá mi enojo, y mi cólera se tornará contra él."
,"26":"Yavé de los Ejércitos hará zumbar la huasca sobre él, igual como cuando se las dio a Madián, en el cerro Horeb, y levantará su bastón sobre el mar, como lo hizo en Egipto."
,"27":"Entonces, la carga se caerá de tu espalda, su yugo dejará de pesar en tu cuello, y la abundancia reemplazará la opresión."
,"28":"Se acerca por el lado de Rimón, avanza sobre Ayot, atraviesa Migrón, deja su bagaje en Micmas."
,"29":"Atraviesan el desfiladero, pasan la noche en Gueba. Rama se asusta, Guibea de Saúl huye."
,"30":"Grita, hija de Galim; escúchala, Lais; respóndele, Anatot."
,"31":"Madmena se dispersa, los habitantes de Gabim buscan refugio."
,"32":"Hoy mismo hará un alto en Nob, y extenderá su brazo sobre el cerro de la hija de Sión, la colina de Jerusalén..."
,"33":"Pero vean cómo el Señor Yavé de los Ejércitos desgaja con fuerza las copas de los árboles; los más altos son cortados y los más orgullosos, rebajados. Su hacha termina con los matorrales del bosque,"
,"34":"y el Líbano tan nombrado se viene abajo."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Una rama saldrá del tronco de Jesé, un brote surgirá de sus raíces."
,"2":"Sobre él reposará el Espíritu de Yavé, espíritu de sabiduría e inteligencia,espíritu de prudencia y valentía, espíritu para conocer a Yavé y para respetarlo, y para gobernar según sus preceptos."
,"3":"No juzgará por las apariencias,ni se decidirá por lo que se dice,"
,"4":"sino que hará justicia a los débiles,y defenderá el derecho de los pobres del país. Su palabra derribará al opresor, el soplo de sus labios matará al malvado."
,"5":"Tendrá como cinturón la justicia, y la lealtad será el ceñidor de sus caderas."
,"6":"El lobo habitará con el cordero, el puma se acostará junto al cabrito, el ternero comerá al lado del león,y un niño chiquito los cuidará."
,"7":"La vaca y el oso pastarán en compañía,y sus crías reposarán juntas, pues el león también comerá pasto, igual que el buey."
,"8":"El niño de pecho jugará sobre el nido de la víbora, y en la cueva de la culebra el pequeñuelo meterá su mano."
,"9":"No cometerán el mal, ni dañarán a su prójimo,en todo mi Cerro santo, pues, como llenan las aguas el mar, se llenará la tierra del conocimiento de Yavé."
,"10":"Aquel día la raíz de Jesé se levantará como una bandera para las naciones, los pueblos irán en su busca y su casa se hará famosa."
,"11":"Al mismo tiempo, el Señor volverá a tender su mano para rescatar al resto de su pueblo, a los que todavía queden en Asur y Egipto, en Patros, Etiopía y Elam, en Senar, Jamat y las islas del mar."
,"12":"Levantará una bandera que se verá desde el extranjero, para juntar a los desterrados de Israel, y reunirá a los dispersos de Judá desde los cuatro puntos cardinales."
,"13":"Entonces se acabará la envidia de Efraím y los enemigos de Judá serán aplastados; Efraím ya no tendrá envidia de Judá y Judá no será más enemigo de Efraím."
,"14":"Se dejarán caer sobre las costas de los filisteos al oeste, y juntos asaltarán a los hijos del este; extenderán su imperio sobre Edom y Moab y someterán a los amonitas."
,"15":"Y Yavé secará el golfo del mar de Egipto y levantará su mano contra el río Eufrates; con un fuerte soplido lo dividirá en siete brazos que se podrán cruzar sin sacarse los zapatos."
,"16":"Así tendrá un camino el resto de su pueblo que haya sobrevivido en el destierro de Asiria, del mismo modo que lo tuvo Israel cuando salió de Egipto."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Y dirás aquel día: 'Te doy gracias, Yavé, porque estabas enojado conmigo, pero se te pasó el enojo y me levantaste."
,"2":"¡Vean cómo es él, el Dios que me salva!,En él confío y no tengo más miedo, pues Yavé es mi fuerza y mi canción, él ha sido mi salvación."
,"3":"Y ustedes sacarán agua con alegría,de las vertientes de la salvación."
,"4":"Ustedes dirán ese día: ¡Denle las gracias a Yavé, vitoreen su Nombre!,Publiquen entre los pueblos sus hazañas, celébrenlo, pues su Nombre es sublime."
,"5":"¡Canten a Yavé, pues hizo maravillas,que ahora son famosas en toda la tierra!"
,"6":"¡Grita de contento y de alegría, oh Sión, porque grande es, en medio de ti, el Santo de Israel!'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Esta es la sentencia contra Babilonia que fue revelada a Isaías, hijo de Amós, contra Babilonia."
,"2":"En lo alto de un cerro pelado coloquen una bandera, lancen gritos de guerra, háganles señas con la mano para que entren por las puertas de los príncipes."
,"3":"'Yo he dado órdenes a mis Santos, a mis guerreros alegres y gloriosos, instrumentos de mi venganza.'"
,"4":"Escuchen ese rugido que viene de las montañas como de una inmensa muchedumbre. Escuchen el ruido de los reinos o de las naciones reunidas. Es Yavé de los Ejércitos, que pasa revista al ejército dispuesto para la guerra."
,"5":"Yavé y los defensores de su causa llegan de lejanas tierras, más allá del horizonte, para arrasar toda la tierra."
,"6":"Griten, pues se acerca el día de Yavé; es como la tormenta del Dios Todopoderoso."
,"7":"Por eso, todos los brazos caen sin fuerza... A todos los hombres se les para el corazón."
,"8":"De puro susto comienzan a temblar y a sentir dolores y se retuercen como mujeres que dan a luz. Se miran unos a otros, el miedo se dibuja en sus rostros ardientes."
,"9":"Ya llega el día cruel de Yavé, con furia y rabia inmensa, para dejar la tierra hecha un desierto,y acabar con todos los pecadores."
,"10":"Las estrellas del cielo y sus constelaciones han dejado de alumbrar, el sol ha salido negro y la luna no envía más su luz."
,"11":"'Voy a castigar a todo el mundo por su maldad y a los impíos por sus crímenes; acabaré con el orgullo de la clase alta y humillaré la soberbia de los dictadores."
,"12":"Haré que los hombres sean más escasos que el oro fino y más difíciles de hallar que el oro de Ofir.'"
,"13":"Por eso, tiemblan los cielos y la tierra se mueve de su sitio, al ver el furor de Yavé de los Ejércitos, cuando estalla su cólera."
,"14":"Entonces, como una cabrita asustada, como ovejas que andan sin pastor, cada uno se vuelve a su pueblo o huye a su patria."
,"15":"A todos los que encuentran los traspasan, y a todos los que apresan los acuchillan."
,"16":"Sus hijos son aplastados ante sus mismos ojos, sus casas saqueadas y sus mujeres violadas."
,"17":"'Miren cómo yo empujo contra ellos a los medos, que no se interesan por la plata y que desprecian al oro."
,"18":"Sus arcos tiran al suelo a los jóvenes, ni siquiera se compadecen del fruto de las entrañas y miran sin lástima a los niños."
,"19":"Babilonia, la perla de los reinos, la joya y orgullo de los caldeos, será como Sodoma y Gomorra, arrasada por Dios."
,"20":"Nunca más, en adelante, será poblada o habitada. Ni el árabe acampará allí ni los pastores descansarán allí con sus rebaños."
,"21":"Por allí vagarán las fieras del desierto,y las lechuzas se meterán en sus casas. Allí bailarán los avestruces,y danzarán los machos cabríos."
,"22":"Las hienas aullarán en sus castillos,y los chacales en sus lujosos palacios. Ya se acerca su hora, no tardarán en llegar esos días."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Sí, Yavé se compadecerá de Jacob, dará su preferencia a Israel y volverá a instalarlo en su patria. El extranjero seguirá también sus pasos y se juntará a los de la familia de Jacob."
,"2":"Los pueblos los recogerán y los devolverán a su tierra, y la familia de Israel, a su vez, se apoderará de ellos y los hará sus esclavos y sirvientes en la tierra de Yavé. Israel hará prisioneros a los que lo llevaron cautivo y dominará a sus opresores."
,"3":"Cuando Yavé te libere de tus padecimientos, de tus inquietudes y de la dura esclavitud a la que estabas sometido,"
,"4":"te burlarás así del rey de Babilonia:"
,"5":"¡Cómo ha terminado el tirano y acabado su arrogancia! Yavé ha roto el palo de los malvados, el bastón de los opresores,"
,"6":"que les pegaba a los pueblos con rabia, golpeándolos sin cesar, y oprimía con furia a las naciones, persiguiéndolas sin descanso."
,"7":"La tierra está ahora tranquila y quieta y retumban las aclamaciones."
,"8":"Aun los cipreses y los cedros del Líbano se alegran, diciendo: 'Desde que estás en la tumba, ya no tenemos que temer al leñador.'"
,"9":"Bajo la tierra, el reino de los muertos se agita por ti, para darte la bienvenida; despierta a las sombras de todos los grandes de la tierra y se levantan de sus tronos los reyes de los pueblos."
,"10":"Todos se dirigen a ti y te dicen: '¡Tú también has sido tirado al suelo y ahora eres igual a nosotros!"
,"11":"Tu esplendor junto al sonido de tus arpas ha sido lanzado al lugar adonde van los muertos, tienes gusanos como tu cama y, para cubrirte, lombrices.'"
,"12":"¿Cómo caíste desde el cielo, estrella brillante, hijo de la Aurora? ¿Cómo tú, el vencedor de las naciones, has sido derribado por tierra?"
,"13":"En tu corazón decías: 'Subiré hasta el cielo y levantaré mi trono encima de las estrellas de Dios, me sentaré en la montaña donde se reúnen los dioses, allá donde el norte se termina;"
,"14":"subiré a la cumbre de las nubes, seré igual al Altísimo.'"
,"15":"Mas, ¡ay!, has caído en las honduras del abismo, en el lugar adonde van los muertos."
,"16":"Los que te ven se fijan en ti y dicen al verte: 'Este es el hombre que espantaba a la tierra, que hacía temblar a los reinos, "
,"17":"que convertía al mundo en un desierto, que destruía las ciudades y nunca abría la cárcel a sus presos.'"
,"18":"Todos los reyes de las naciones reposan con honor, cada uno en su tumba,"
,"19":"pero tú has sido echado a la fosa común, como una basura que molesta, como un cadáver pisoteado, cubierto de gente masacrada, de degollados por la espada."
,"20":"No tendrás la sepultura de los reyes, porque has desolado tu tierra y asesinado a tu pueblo: nadie, en adelante, se acordará de la descendencia de los malhechores."
,"21":"Prepárense para matar a los hijos por los crímenes de sus padres; ¡ya no saldrán a conquistar la tierra ni cubrirán, con sus ciudades, la faz del mundo!"
,"22":"Me levantaré contra ellos -dice Yavé de los Ejércitos- y acabaré en Babilonia con su nombre y su descendencia, con sus hijos y sus bastardos, dice Yavé."
,"23":"Yo se la doy a los erizos, pues no será más que un pantano. Le pasaré la escoba, y barreré con todo, dice Yavé."
,"24":"Yavé de los Ejércitos lo ha jurado, diciendo: Tal como lo he pensado, pasará, y como lo he querido, se cumplirá."
,"25":"Destrozaré a Asur en mi propio país,y lo aplastaré en mis cerros; así ustedes se librarán de su yugo,y de su carga, que pesa sobre los hombros."
,"26":"Esta es la sentencia decretada contra toda la tierra; así su mano está extendida sobre las naciones."
,"27":"Si Yavé de los Ejércitos forja un plan, ¿quién lo arruinará? Si extiende su mano, ¿quién lo hará cambiar?"
,"28":"El año en que murió Ajaz, Isaías pronunció esta sentencia:"
,"29":"'No te alegres tanto, Filistea, porque se quebró el bastón que te pegaba; pues del huevo de la culebra saldrá una víbora, que, a su vez, tendrá una serpiente voladora."
,"30":"Entonces mis pobres se alimentarán de mis campos,y los que nada tienen dormirán tranquilos, mientras que a tus hijos los haré morir de hambre,y mataré a los sobrevivientes.'"
,"31":"¡Que den aullidos en la alcaldía, que grite la ciudad!,Filistea entera se queda sin ánimo. Porque por el norte se levanta una humareda, ¡y nadie de sus soldados abandona las filas!"
,"32":"¿Qué responderán, entonces, a los embajadores de esa nación?,'Que Yavé ha fundado a Sión,y en ella se refugiarán los pobres de su pueblo.'"
}`)
	CurrentBook.AddChapter(15, `{
"1":"Profecía sobre Moab. Bastó con una noche: Ar-Moab quedó toda en silencio. Bastó con una noche: Quir-Moab fue destruida,"
,"2":"Sube la gente de Dibón, para llorar en los santuarios altos; en el Nebo y en el Madaba gime Moab. Llevan el pelo cortado al rape,y la cara afeitada."
,"3":"En las calles y las azoteas, se ven cubiertos de saco; en las plazas, todos están de duelo, no se oye más que lamentaciones."
,"4":"Jesebón y Elealé gritan, hasta Jahas se oye su voz. Por eso, se conmueven los valientes de Moab,y tiembla su alma."
,"5":"Mi corazón está de duelo por Moab, por sus fugitivos que llegan hasta Soar. Por la cuesta de Luhit,suben llorando, por el camino de Joronaim,lanzan gritos desgarradores."
,"6":"Las vegas de Nimrín,son ahora un terreno abandonado, pues se secó la hierba, desapareció el pasto,y se acabó el verdor."
,"7":"Por eso, llevan sus provisiones, lo que les queda, al otro lado del arroyo de los Sauces."
,"8":"Los alaridos han despertado toda la tierra de Moab; el griterío se siente hasta en Eglaim,y su eco hasta en Beer-Elim. Las lagunas de Dimón están rojas de sangre,"
,"9":"pues mando un nuevo castigo sobre Dimón: envío un león contra los sobrevivientes de Moab,y contra aquellos que queden en el país."
}`)
	CurrentBook.AddChapter(16, `{
"1":"'Desde Sela que está en el desierto, lleven corderos al monte de la hija de Sión,al soberano del país.'"
,"2":"Y como pichones asustados,que han echado de su nido, andan las hijas de Moab,por los vados del río Arnón."
,"3":"'Llamen a consejo, tomen una decisión, extiende tu sombra como la noche,contra el ardor del sol; esconde a los perseguidos, no entregues al que huye."
,"4":"Dales hospedaje a los fugitivos de Moab, ofréceles un asilo frente al saqueador.',y se hayan alejado los que aplastan al país."
,"5":"el trono será restablecido, estable gracias a la bondad, y en él se sentará bajo la carpa de David, un gobernante leal, amante del derecho, y dispuesto a hacer justicia.)"
,"6":"Tenemos noticias del orgullo de Moab, de ese orgullo enorme, de su vanidad, soberbia y petulancia, de sus palabrerías que no llevan a ninguna parte."
,"7":"Dejemos que los moabitas lloren por Moab,y se lamentan todos juntos. Todos suspiran apenados,por las tortas de uva de Quir-Jerés."
,"8":"Pues se han marchitado los campos de Jesebón,y la viña de Sibma, cuyos racimos arrancaron los amos de las naciones. Ella llegaba hasta Yazer,y se perdía en el desierto; sus sarmientos se extendían,hasta más allá del mar."
,"9":"También lloro, como llora Yazer, por la viña de Sibma, los regaré con mis lágrimas, Jesebón y Elealé. Porque sobre tu cosecha y tu vendimia,ya no se escuchan las canciones;"
,"10":"alegría y el contento se han ido de sus huertos. Ya no cantan ni aplauden en las viñas, ya no se pisa la uva en el lagar, y se han terminado los cantos."
,"11":"Por eso, mis entrañas se conmueven,por Moab, como una cítara, y mi corazón por Quir-Jerés."
,"12":"Por más que Moab se canse,subiendo a los santuarios, o entre a su templo a rezar, nada conseguirá con eso."
,"13":"Esta es la sentencia que, hace tiempo, pronunció Yavé contra Moab. Y ahora Yavé declara: 'Dentro de tres años, los mismos que dura el contrato de un soldado, el famoso poder de Moab, con su gran población, se vendrá abajo y sólo quedará una minoría sin importancia.'"
}`)
	CurrentBook.AddChapter(17, `{
"1":"Oráculo contra Damasco. Damasco ya no será más una ciudad, sino un montón de escombros."
,"2":"Las ciudades de Aror, abandonadas, han sido tomadas por los rebaños, que allí se tienden sin que nadie los espante."
,"3":"Va a desaparecer el reino de Damasco, que era una protección para Efraím; pues lo que quede de Aram y de su gloria,no valdrá más que los israelitas,- dice Yavé de los Ejércitos."
,"4":"La fama de Jacob perderá su brillo,y enflaquecerá su cuerpo. Como el segador toma un manojo de trigo,y corta con su mano las espigas;"
,"5":"como se recogen las espigas en el valle de Refaím,y sólo quedan rastrojos,"
,"6":"o como cuando se apalean los olivos,y sólo quedan dos o tres aceitunas en la copa,o cuatro o cinco en las ramas del árbol, así será -palabra de Yavé, Dios de Israel."
,"7":"Por ese entonces, el hombre mirará a su Creador y volverá sus ojos al Santo de Israel."
,"8":"Ya no se fijará más en lo que construyeron sus manos, ni contemplará lo que trabajaron sus dedos: los postes sagrados y los altares para el incienso."
,"9":"En ese día tus ciudades fortificadas serán abandonadas como lo fueron las de los amorreos y de los jeveos ante el ataque de los hijos de Israel: quedarán despobladas."
,"10":"Porque olvidaste a Dios que te salva, y no te acordaste de la Roca que te protege. Pues bien, si plantas plantas tempraneras,y cultivas patillas traídas del extranjero,"
,"11":"las ves brotar el mismo día que las plantas, y a la mañana el brote florece. Pero se marchita y la cosecha se te va,- entonces tú podrás llorar."
,"12":"¡Ay! un bramar de pueblos inmensos, como el rugido del mar enfurecido; estruendo de naciones que resuenan,como retumban las aguas torrentosas."
,"13":"Pero El las amenaza, y de muy lejos huyen, como polvillo de los cerros movido por el viento, o como un remolino, por el huracán."
,"14":"Espanto, al caer la tarde, pero antes de amanecer ya no queda nadie. Esa será la suerte de nuestros opresores, el destino de los que nos saquean."
}`)
	CurrentBook.AddChapter(18, `{
"1":"¡Ay de la tierra de las langostas,aladas, más allá de los ríos de Etiopía, del país que envía embajadores por mar,en livianas canoas de juncos!"
,"2":"Vayan, rápidos mensajeros, al país de gente alta y morena, cuyo pueblo ha sido siempre temible; a la nación vigorosa y conquistadora,cuya tierra está surcada por ríos."
,"3":"Ustedes, habitantes del universo,y pobladores de la tierra, miren esta bandera en lo alto de los cerros, y escuchen el sonido del clarín."
,"4":"Porque así me ha hablado Yavé: Me quedo mirando y sin moverme ahí donde estoy, así como pesa el calor cuando hay mucho sol, o como se detiene una nube blanca en un día de siega."
,"5":"Pues antes de la vendimia, después que haya florecido la viña, y cuando comiencen a aparecer los granitos, podaré los sarmientos con las tijeras,y arrancaré o cortaré los racimos."
,"6":"Y quedarán a merced del ave de rapiña de los cerros,o de las fieras salvajes. Los buitres estarán sobre ellos en el verano,y las fieras salvajes, en el invierno."
,"7":"En ese tiempo, el pueblo de gente alta y morena, ese pueblo siempre respetado, la nación vigorosa cuyo territorio está surcado por ríos, le llevará regalos a Yavé de los Ejércitos al lugar de su Nombre, al cerro de Sión."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Yavé se ha montado en una rápida nube, y llega a Egipto. Los ídolos de Egipto tiemblan al verle,y a los egipcios les falla el corazón."
,"2":"'Azuzaré a los egipcios unos contra otros,y se pelearán los hermanos entre sí, un amigo con otro, una ciudad con otra, un reino con otro reino."
,"3":"Egipto no sabrá qué hacer, echaré a perder su prudencia. Irán a consultar a los ídolos, a los adivinos, a los magos y a los brujos."
,"4":"Entregaré a Egipto a un amo sin corazón; un rey cruel los gobernará, dice el Señor Yavé de los Ejércitos.'"
,"5":"Desaparecerá el agua del mar, su río no correrá y quedará seco;"
,"6":"los arroyos quedarán infectados, el agua de sus canales disminuirá y se secará."
,"7":"Las plantas que están a orillas del Nilo,como los juncos y las cañas se marchitarán, todos los sembrados regados por el Nilo,se pondrán amarillos, se secarán y no quedará nada."
,"8":"Los pescadores se quejarán, todos los que tiran el anzuelo en el Nilo,andarán tristes, los que extienden la red en el agua se lamentarán."
,"9":"Estarán de muerte los que trabajan el lino, y los que lo limpian y lo hilan, también."
,"10":"Los tejedores quedarán apenados,y todos los obreros, desanimados."
,"11":"¡Son unos estúpidos los príncipes de Zoan!,Los sabios de Faraón forman un ministerio de imbéciles, y todavía dicen al Faraón: 'Yo soy un alumno de sabios, un alumno de antiguos reyes.'"
,"12":"¿Dónde están tus sabios?,Que te digan si lo saben, y que adivinen,lo que ha decidido hacer con Egipto,Yavé de los Ejércitos."
,"13":"Están locos los príncipes de Zoan, y se engañan los príncipes de Nof, pues hacen desviarse a Egipto,ellos, que son los jefes de sus tribus. Yavé les suministró una droga,para que pierdan los sentidos."
,"14":"Por eso, Egipto lo hace todo al revés, como un borracho atontado que vomita."
,"15":"Y ya de nada le aprovecha a Egipto,lo que pueden hacer la cabeza o la cola, la palmera o el junco."
,"16":"Ese día, los egipcios comenzarán a temblar de susto y terror como las mujeres, cuando vean que Yavé agita su mano."
,"17":"Egipto le tendrá miedo al país de Judá; cada vez que alguien se acuerde de los judíos se pondrá pálido de susto, porque recordará las amenazas de Yavé de los Ejércitos."
,"18":"Entonces habrá en Egipto cinco ciudades que hablarán la lengua de Canaán, y que jurarán por Yavé de los Ejércitos. Y de ellas una se llamará Ciudad del Sol."
,"19":"Aquel día, se levantará un altar a Yavé en medio del país de Egipto y cerca de la frontera se colocará un monumento de piedra a Yavé."
,"20":"Este será para Yavé de los Ejércitos una señal y un testimonio en el país de Egipto. Y cuando se vean oprimidos y pidan socorro a Yavé, éste les mandará un salvador que los defenderá y libertará. "
,"21":"Así, Yavé se dará a conocer a los egipcios y éstos, al conocerlo, le honrarán con sacrificios y ofrendas. Harán votos a Yavé y los cumplirán."
,"22":"Pues bien, si Yavé ha castigado estrictamente a los egipcios, también los sanará. Se volverán a Yavé, que los atenderá y los consolará."
,"23":"Y habrá entonces un camino que vaya de Egipto a Asiria. Los asirios irán a Egipto y los egipcios a Asiria; Egipto y Asiria servirán a Yavé."
,"24":"Por último, Israel se juntará con Egipto y Asiria, y esto será una bendición para el mundo entero."
,"25":"Yavé de los Ejércitos lo bendecirá con estas palabras: 'Benditos sean mi pueblo de Egipto y Asur, la obra de mis manos, e Israel, mi herencia.'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"Aquel año el generalísimo de Sargón, rey de Asiria, fue mandado a Azoto; la atacó y se apoderó de esta ciudad."
,"2":"Entonces Yavé habló por medio de Isaías, hijo de Amós. Le había dicho: 'Te colgarás este saco de la cintura y te sacarás las sandalias de tus pies.' Isaías lo hizo así y andaba sin ropa y descalzo."
,"3":"Luego dijo Yavé: 'Mi siervo Isaías anduvo sin ropa y descalzo durante tres años, y esto fue una señal y anuncio para Egipto y Etiopía."
,"4":"De la misma manera conducirá el rey de Asur a los cautivos de Egipto y a los desterrados de Etiopía. Jóvenes o viejos, los llevará desnudos, sin zapatos y con las nalgas al aire.'"
,"5":"Entonces habrá susto y vergüenza para quienes confiaban en Etiopía y se sentían seguros por Egipto."
,"6":"Los habitantes de estas costas temblarán y dirán: '¡Miren lo que le ha ocurrido a aquel en quien confiábamos, y a quien acudíamos en busca de protección, para vernos seguros y libres del rey de Asiria! Y ahora, ¿cómo nos vamos a salvar nosotros?'"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Profecía sobre el desierto que está junto al mar. Esto viene del desierto, del país espantoso, es como una tempestad que pasa por el Negueb."
,"2":"Una visión siniestra se presenta a mis ojos: El traidor traiciona, y el salteador saquea: '¡Arriba, elamitas! ¡ataquen, medos!',- 'Hice callar los últimos gemidos.'"
,"3":"Por eso, mis entrañas se estremecen de espanto,y el dolor se apodera de mí,como de una mujer que da a luz; estoy muy asustado para oír, muy aterrado para ver."
,"4":"Ando perdido, cosas horribles me llenan de terror; el atardecer, que tanto esperaba, ahora me causa pánico."
,"5":"Se pone la mesa, se extiende el mantel, se come, se bebe... ¡Arriba, capitanes, preparen sus escudos!"
,"6":"Pues así me ha hablado el Señor: 'Anda, coloca un centinela,para que comunique lo que vea."
,"7":"Si ve tropas de caballería,y a los jinetes formados de dos en dos, unos montados en burros, otros en camellos, que ponga atención, mucha atención.'"
,"8":"El vigía exclamó: 'En lo alto de la torre, mi señor, estoy de pie todo el día, y en mi puesto de guardia,permanezco alerta toda la noche."
,"9":"Pues bien, veo acercarse la caballería,y a los jinetes, formados de dos en dos.',Entonces me han hablado y me han dicho: 'Cayó, cayó Babilonia,y todas las estatuas de sus dioses,han rodado por el suelo hechas pedazos.'"
,"10":"Oh pueblo mío, que has sido pisoteado,y trillado en la era, lo que he oído de Yavé de los Ejércitos, Dios de Israel, yo te lo anuncio."
,"11":"Profecía sobre Edom. Alguien me grita desde Seír: 'Centinela, ¿qué hora es de la noche?,Centinela, ¿qué hora es de la noche?'"
,"12":"El centinela responde: 'Llega la mañana, pero también la noche; si ustedes quieren preguntar, pregunten, pero vuelvan otra vez.'"
,"13":"Profecía sobre Arabia: Entre las matas de la estepa pasan la noche,las caravanas de los dedanitas."
,"14":"Salgan al encuentro del sediento, habitantes del país de Tema, llevándole agua; acojan al fugitivo y denle pan."
,"15":"Pues ellos vienen huyendo de las espadas, de las espadas afiladas, del arco listo para disparar, de la violencia de la guerra."
,"16":"Sí, así me ha dicho el Señor: 'Dentro de un año, lo mismo que dura el contrato de un soldado, toda la riqueza de Quedar se habrá terminado"
,"17":"y no quedará casi nada de los arqueros valientes de Quedar -esto es palabra de Yavé, el Dios de Israel.'"
}`)
	CurrentBook.AddChapter(22, `{
"1":"Profecía contra el valle de la Visión. ¿Qué te pasa, que has subido a las terrazas,"
,"2":"ciudad llena de bulla, ciudad ruidosa y de vida alegre?,Si tu gente está muerta, no murieron a espada,ni cayeron en el combate."
,"3":"Todos tus jefes huyeron juntos,y se rindieron bajo la amenaza de los arcos; tus valientes se dieron a la fuga, pero fueron apresados."
,"4":"Por eso digo: 'Apártense de mí,para que pueda llorar amargamente. No traten de consolarme,por el desastre de la hija de mi pueblo.'"
,"5":"Pues es un día de derrota, aplastante y desastrosa, que envía el Señor Yavé de los Ejércitos. En el valle de la Visión se echan abajo las murallas, y los gritos de socorro llegan hasta las montañas."
,"6":"Elam toma su caja de flechas, Aram monta a caballo,y Quir saca su escudo."
,"7":"Tus más hermosos valles están llenos de carros, y la caballería toma posiciones frente a las puertas."
,"8":"Así cayeron las defensas de Judá. Aquel día miraron al arsenal de la Casa del Bosque. "
,"9":"Ustedes se fijaron en que las murallas de la ciudad de David estaban mal, muy mal,"
,"10":"por lo que examinaron las casas de Jerusalén, una por una, y derribaron casas para fortificar la muralla."
,"11":"También hicieron un estanque entre los dos muros para recoger las aguas del estanque inferior, en sustitución de la piscina antigua. Pero no repararon en el que manda estos acontecimientos, ni vieron a aquel que los ha decidido desde hace tiempo."
,"12":"El Señor Yavé de los Ejércitos los invitaba aquel día a llorar y lamentar sus pecados, a cortarse el pelo y a vestirse con un saco."
,"13":"Pero prefirieron reír y divertirse. Mataron bueyes y degollaron ovejas, comieron carne y bebieron vino: 'Comamos y bebamos, que mañana moriremos.'"
,"14":"Ahora bien, Yavé de los Ejércitos me ha comunicado esto: 'Esta falta sólo será pagada por su muerte.'"
,"15":"Así habla el Señor Yavé de los Ejércitos: Anda a ver a ese funcionario, llamado Sobna, que es administrador del palacio "
,"16":"y que se está haciendo un sepulcro en el cerro, una bóveda tallada en roca viva: ¿Qué tienes tú aquí o quién eres tú aquí,para que te mandes hacer un sepulcro así?"
,"17":"Pues bien, Yavé te va a arrojar, hombre, te agarrará y te apretará,"
,"18":"te enrollará como una pelotazo,y te hará rodar hacia una tierra lejana. Allí morirás y allí pararán tus carrozas famosas, tú que deshonras la casa de tu amo,"
,"19":"'Te destituiré de tu puesto,y te quitaré tu cargo; Aquel día llamaré a mi servidor,"
,"20":"a Eliaquim, hijo de Helcías. Le pasaré tu traje,"
,"21":"le colocaré tu cinturón, y le confiaré tu cargo, y será un padre para los habitantes de Jerusalén,y para la familia de Judá."
,"22":"Pondré en sus manos,la llave de la Casa de David; cuando él abra, nadie podrá cerrar, y cuando cierre, nadie podrá abrir."
,"23":"Lo meteré como un clavo,en un muro resistente,y su puesto le dará fama,a la familia de su padre.'"
,"24":"(Colgarán allí todo lo de valor de la familia de su padre -sus hijos y nietos-, todos los utensilios pequeños, desde las copas hasta los jarros."
,"25":"Pero, dice Yavé de los Ejércitos, cederá el clavo que había sido colocado en un muro resistente. Se soltará y caerá. Y todo el peso que sostenía, se hará añicos, pues así lo ha querido Yavé.)"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Profecía contra Tiro. Lloren, navíos de Tarsis, porque ha sido destruido su puerto. Al volver del país de Quitim,supieron la noticia."
,"2":"¡Ustedes se han quedado sin voz, gente de la costa, comerciantes de Sidón!,Ustedes atravesaban el mar"
,"3":"y vivían del tráfico transmarino. El grano del valle del Nilo era su riqueza, que vendían al mundo entero."
,"4":"¡Qué vergüenza, Sidón!,Tú preguntas: '¿Acaso no he tenido hijos,y sufrido los dolores de parto, educado a jóvenes y niñas?'"
,"5":"Cuando se enteren en Egipto, la suerte de Tiro los hará temblar."
,"6":"Vuelvan, pues, a Tarsis, y dejen que se lamenten los habitantes de la costa, habitantes de la costa."
,"7":"¿Dónde está ahora la ciudad orgullosa, que tenía tantos años de antigüedad,y que llegó muy lejos en sus andanzas,para establecerse allá sus sucursales?"
,"8":"¿Quién es, pues, el que ha tramado esto,en contra de Tiro, la reina, cuyos comerciantes eran príncipes,y sus negociantes, los grandes de la tierra?"
,"9":"Esto lo ha tramado Yavé de los Ejércitos, para echar abajo todo su prestigio,y para humillar a los más grandes del mundo."
,"10":"¡Ara el campo, ahora, hija de Tarsis, no hay más puerto!"
,"11":"Yavé extendió su mano sobre el mar,para derribar a grandes potencias; El dio una orden referente a Canaán: Sus fortalezas serán destruidas."
,"12":"El dijo: '¡Ya no triunfarás más, Hija de Sidón, muchacha que has sido violada!,Levántate y márchate a Quitim, que allí tampoco tendrás tranquilidad.'"
,"13":"Pues mira cómo está la tierra de Caldea, este pueblo ya no existe, Asiria lo ha entregado a las fieras del desierto. Levantaron torres de asalto, demolieron sus castillos, y sólo quedan escombros."
,"14":"¡Lloren, navíos de Tarsis, porque ha sido destruido su puerto!"
,"15":"Entonces Tiro será olvidada durante setenta años, esto es la duración de un reinado. Pero al cabo de los setenta años, a Tiro le pasará lo mismo que a la prostituta de la canción:"
,"16":"Toma la guitarra y recorre la ciudad, prostituta olvidada, toca lo mejor que puedas. Puede ser que con tus canciones se vuelvan a acordar de ti."
,"17":"Después de los setenta años, Yavé se interesará de nuevo por Tiro, quien volverá a cobrar su salario de prostituta y se entregará a todos los reyes del mundo."
,"18":"Pero sus ganancias y ahorros no serán, esta vez, guardados ni se acumularán, sino que serán consagrados a Yavé. Esos fondos se usarán para aquellos que ofician en su presencia, y con esto tendrán buena comida y se vestirán como príncipes."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Miren cómo Yavé limpia la tierra, la arrasa, trastorna su superficie, dispersa a sus habitantes:"
,"2":"al sacerdote y al laico, al amo y al esclavo, a la señora y su empleada, al vendedor y al comprador, al prestamista y al que pide prestado, al acreedor y al deudor."
,"3":"La tierra será totalmente arrasada,y completamente saqueada, porque Yavé ha hablado."
,"4":"La tierra está de duelo y se seca, el mundo está agotado y decae, el cielo y la tierra se debilitan."
,"5":"La tierra ha sido profanada,por los pies de sus habitantes, que pasaron por alto las leyes, violaron los mandamientos,y no cumplieron el contrato eterno."
,"6":"Por eso, una maldición ha devorado la tierra,por culpa de sus habitantes; por eso, se han ido muriendo,y sólo quedan unos pocos."
,"7":"El vino se ha terminado, la viña se ha secado, todos los que tenían el corazón alegre andan ahora tristes."
,"8":"Ya no tocan los tambores, ni resuenan las guitarras, ha cesado el bullicio de la fiesta."
,"9":"Ya no se toma vino ni se canta, y los que toman, sienten amargos los licores."
,"10":"La ciudad del libertinaje está en ruinas,y las puertas de las casas, cerradas."
,"11":"La gente se queja en las calles porque no hay vino, la alegría ya no se ve,y las fiestas han desaparecido del país."
,"12":"La ciudad es ahora sólo ruinas,y la plaza se ha quedado sin vida, desierta.)"
,"13":"Estos quedan en la tierra, allí donde estaban los pueblos, como las aceitunas después de apalear al olivo,o como los pampanitos después de la vendimia."
,"14":"Ellos levantan la voz, gritan de alegría; avivan el nombre de Yavé desde la orilla del mar."
,"15":"También alaban a Yavé las islas del mar; ¡Islas del mar, aviven el Nombre de Yavé, Dios de Israel!"
,"16":"Desde el fin del mundo se escuchan cantos: 'Gloria al Justo.',Y pensar que yo decía: ¡Pobre de mí!, ¡pobre de mí!, no hay más que traidores y traición."
,"17":"Pánico, fosa y trampa te esperan, habitante de la tierra:"
,"18":"el que logre salvarse del pánico,caerá en la fosa; y el que se libre de la fosa,quedará atrapado en la trampa. Las compuertas de lo alto se han abierto,y los cimientos de la tierra se han estremecido."
,"19":"La tierra estalla en pedazos, la tierra cruje y se agrieta, la tierra tiembla y se sacude,"
,"20":"la tierra se bambolea como un borracho, se balancea como una hamaca; es tanto el peso de sus faltas con las que debe cargar, que cae al suelo sin poder levantarse."
,"21":"Ese día Yavé pedirá cuentas,al ejército de los cielos, allá en lo alto, y aquí abajo, a los reyes de la tierra;"
,"22":"los juntará a todos y los meterá en un calabozo, y serán encerrados en la cárcel, y después de años, recibirán su sentencia."
,"23":"La luna se pondrá colorada, el sol no sabrá dónde esconderse, avergonzado, cuando Yavé de los Ejércitos sea rey,sobre el cerro de Sión, en Jerusalén, y aparezca su Gloria ante sus Ancianos."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Yavé, tú eres mi Dios, yo te saludo y celebro tu Nombre, pues hiciste maravillas, obras que venían desde mucho antes, que no podían faltar."
,"2":"Has hecho de la ciudad un montón de escombros, y de la fortaleza una ruina; el bastión de los extranjeros ya no es una ciudad, y nadie la reconstruirá."
,"3":"Por eso, te proclama un pueblo poderoso, y la ciudad respetada por las naciones te teme."
,"4":"Tú has sido un refugio para el despreciado, una ayuda para el pobre en su miseria; te hiciste abrigo contra la lluvia, y sombra para el calor. El aliento de los tiranos es como la lluvia helada"
,"5":"o como el ardor del sol en el desierto; pero tú rebajas la arrogancia de los extranjeros como el calor del sol, y haces callar el canto de los tiranos."
,"6":"Yavé de los Ejércitos está preparando para todos los pueblos, en este cerro, una comida con jugosos asados y buenos vinos, un banquete de carne y vinos escogidos."
,"7":"En este cerro quitará el velo de luto que cubría a todos los pueblos y la mortaja que envolvía a todas las naciones."
,"8":"Y destruirá para siempre a la Muerte. El Señor Yavé enjugará las lágrimas de todos los rostros; devolverá la honra a su pueblo, y a toda la tierra, pues así lo ha dicho Yavé. "
,"9":"Entonces dirán: 'Este es, en verdad, nuestro Dios, de quien esperábamos que nos salvara; éste es Yavé, en quien confiábamos. Ahora estamos contentos y nos alegramos porque nos ha salvado;"
,"10":"pues la mano de Yavé se nota en este cerro.',Moab, en cambio, será pisoteado como se pisotea la paja en un montón de guano, "
,"11":"y desde allí levantará sus brazos como los extiende el nadador para nadar. Pero Yavé aplastará su soberbia a pesar de sus esfuerzos."
,"12":"Tus seguras y elevadas torres, las destruirá, las demolerá y las echará abajo."
}`)
	CurrentBook.AddChapter(26, `{
"1":"En ese día cantarán de esta manera en el país de Judá: Tenemos ahora una ciudad amurallada; El ha construido para defendernos,no una, sino dos murallas."
,"2":"Abran las puertas para que entre la gente buena, que cumple fielmente "
,"3":"y se queda firme. Tú la guardas en paz porque confía en ti."
,"4":"No duden nunca de Yavé, pues Yavé es la Roca para siempre."
,"5":"El doblegó a los que vivían en las alturas, en la ciudadela de la cual nadie podía apoderarse; la derribó, la demolió y la redujo a escombros."
,"6":"Ahora es pisoteada, pasan sobre ella los pies de los humildes y de los pobres."
,"7":"El camino del justo es siempre derecho, tú le allanas el camino recto."
,"8":"¡Ah, Yavé!, tú sabes que sólo buscamos el camino de tus preceptos. Tu nombre y tu memoria son el anhelo del alma. "
,"9":"Mi alma te desea por la noche y mi espíritu se despierta en mí desde la mañana. Cuando a la tierra le llegan tus juicios, los habitantes del mundo aprenden a ser justos. "
,"10":"Pues si se perdona al malvado, no aprende la justicia y sigue haciendo el mal en la tierra del derecho, pues no teme la majestad de Yavé."
,"11":"¿Hasta cuándo los estarás amenazando sin que comprendan? Haz que vean, para vergüenza suya, que cuidas de tu pueblo; ¡que tu furor, cual fuego, devore a tus enemigos!"
,"12":"Yavé, dígnate darnos la paz, pues, sólo tú llevas a feliz término lo que hacemos nosotros."
,"13":"Oh Yavé, nuestro Dios, otros señores, fuera de ti, nos han dominado, mas no recordaremos otro nombre que el tuyo, a ti solo conocemos."
,"14":"Los muertos no volverán, y sus sombras no se levantarán, pues los has juzgado y los hiciste morir; has borrado hasta el recuerdo de su nombre."
,"15":"Yavé, has hecho crecer tu nación, ensanchaste nuestro país y, mientras más crecía, te hacías más famoso."
,"16":"Yavé, en la angustia te buscábamos; vivíamos bajo la opresión y tu castigo nos apretaba."
,"17":"Como la mujer sufre al dar a luz, se retuerce y grita en sus dolores, así estuvimos ante ti, Yavé."
,"18":"Hemos concebido, tuvimos dolores como si diéramos a luz, pero ¡puro aire!; no hemos traído al país la salvación, y no se ven los pioneros de un mundo nuevo."
,"19":"¡Tus muertos revivirán, y sus cadáveres resucitarán! Despierten y den gritos de júbilo todos ustedes, que yacen en el polvo. Que baje tu rocío, Señor, rocío de luz, y la tierra nos devolverá a los muertos."
,"20":"Entra, pueblo mío, en tus habitaciones y cierra las puertas tras de ti; escóndete un momento hasta que pase la cólera."
,"21":"Porque Yavé está saliendo de su morada para castigar la maldad de los habitantes de la tierra. La tierra dejará ver la sangre derramada y no esconderá más a los que fueron degollados."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Aquel día Yavé castigará con su espada firme, grande y pesada a la serpiente Leviatán, que siempre sale huyendo, a Leviatán, que es una serpiente astuta, y matará al dragón del mar."
,"2":"Entonces dirá: 'Cántenle a esta excelente viña."
,"3":"Yo, Yavé, soy su cuidador; la riego todas las mañanas para que no caiga su follaje, y me preocupo por ella noche y día.'"
,"4":"- 'Yo me quedo sin cerca, ¿y de dónde me vienen esas malezas?',- 'Yo mismo les haré la guerra y a todos les prenderé fuego; "
,"5":"a no ser que me pidan protección o hagan la paz conmigo; sí, conmigo.'"
,"6":"En los días que vienen le saldrán brotes a Jacob, Israel dará brotes y florecerá, y sus frutos llenarán el mundo entero."
,"7":"¿Acaso Yavé le ha pegado como les pegó a los que lo maltrataban? ¿O lo ha exterminado como hizo con los que lo masacraban?"
,"8":"Lo castigó, echándolo de su casa o desterrándolo, y lo despidió de un soplido tan fuerte como viento del este."
,"9":"Ahora bien, así es como será pagada la falta de Jacob, como será expiado su pecado: tendrá que hacer pedazos sus altares y moler sus piedras como se hace polvo la piedra de cal, y no levantar más postes sagrados o monumentos de piedra en honor al sol."
,"10":"La ciudad fortificada está ahora solitaria, permanece abandonada y triste como un desierto. Allí van a pastar los animales, allí crecen y se extienden los matorrales."
,"11":"Cuando se secan las ramas, las quiebran y luego las mujeres les prenden fuego. Eso se debe a que este pueblo no quiere entender, por eso su Hacedor no se compadece de ellos, ni los perdonará el que los ha creado."
,"12":"Pero llegará el día Yavé hará la trilla desde el río Eufrates hasta el Nilo de Egipto, y ustedes, hijos de Israel, serán juntados uno a uno."
,"13":"Aquel día, al sentir el fuerte sonido de la trompeta, acudirán los que andaban perdidos por el país de Asur y los que estaban desparramados por la tierra de Egipto, y adorarán a Yavé en el cerro santo de Jerusalén."
}`)
	CurrentBook.AddChapter(28, `{
"1":"¡Ay de esa ciudad, pretenciosa corona de los borrachos de Efraím, espléndido adorno de flores marchitas,en lo alto del valle fértil!,¡Todos quedan tendidos por el vino!"
,"2":"He aquí que uno, robusto y macizo, mandado por el Señor, los tirará al suelo de un empujón, como si fuese una fuerte granizada, un viento huracanado,o una inundación de lluvias torrenciales."
,"3":"Será pisoteada,la pretenciosa corona de los borrachos de Efraím."
,"4":"Su espléndido adorno de flores marchitas,en lo alto del valle fértil,será como la primera breva que madura, que, en cuanto uno la ve, la toma con la mano y se las come."
,"5":"Ese día, Yavé de los Ejércitos,será para los que quedan de su pueblo,espléndido adorno y joya magnífica."
,"6":"Pues se hará espíritu de justicia,para el juez en el tribunal, le ayudará a hacer justicia, y al que impide que los asaltantes pasen la puerta,le dará valentía."
,"7":"También éstos se tambalean,bajo los efectos del vino, sacerdotes y profetas andan dando tumbos,por haber tomado tanto. El vino los hace titubear,y los licores fuertes les hacen perder los sentidos: divagan en sus visiones,y tartamudean al dar sus sentencias."
,"8":"Sí, todas las mesas están cubiertas de vómitos, sin que haya un lugar limpio."
,"9":"- ¿A quién le está enseñando la lección, o quién quiere que le atienda sus explicaciones?,¡Los niños que recién dejaron el biberón, los niñitos que acabaron de tomar pecho!"
,"10":"Pues no dice más que: '¡Si entiendes, bueno, si no sabes, no importa!'"
,"11":"- Sí, en realidad, con palabras que hacen reír,y en un idioma extranjero, le va a hablar a este pueblo."
,"12":"él, que les había dicho: 'Este es el lugar para descansar, dejen descansar al que está cansado. es el momento de parar.',Pero no quisieron hacerle caso."
,"13":"Por eso, Yavé les habla en estos términos: '¡Si entiendes, bueno, si no sabes, no importa!', para que al caminar se caigan de espaldas,y se quiebren un hueso, y caigan en la trampa y queden atrapados."
,"14":"Por eso, escuchen esta palabra de Yavé, ustedes que son buenos para reírse, y que mandan a este pueblo de Jerusalén."
,"15":"Ustedes dicen: 'Hemos hecho un contrato con la Muerte, y con el lugar de los muertos hemos firmado un acuerdo. El vendaval destructor pasará y no nos llevará, pues nos refugiaremos en ilusiones,y nos esconderemos tras mamparas.'"
,"16":"En vista de todo esto, el Señor Yavé les dice: Yo mismo voy a colocar una piedra en Sión, una piedra escogida, una piedra angular, de gran valor y firme: 'El que se apoye en ella, no se moverá.'"
,"17":"Pondré el derecho como regla,y la justicia como nivel. El granizo aplastará su refugio ilusorio,y las aguas se llevarán su mampara;"
,"18":"será roto su contrato con la Muerte,y su pacto con el Lugar de los Muertos quedará sin efecto. Pasará el vendaval destructor, y a ustedes se los llevará."
,"19":"Cada vez que pase los agarrará, pues pasará todas las mañanas, de día y de noche, y si entendieran este mensaje, sería puro susto."
,"20":"La cama será demasiado corta para poder estirarse,y la frazada muy chica para taparse."
,"21":"Sí, como en el monte Perasim, Yavé se levantará, o como en el valle de Gabaón, se despertará,para realizar su obra, obra rara, para hacer su trabajo, trabajo misterioso."
,"22":"Así, pues, dejen de burlarse, no sea que se les aprieten las ataduras; pues, sépanlo: 'Destrucción total y para todo el país', esto es lo que he oído de Yavé de los Ejércitos."
,"23":"Paren la oreja y escuchen lo que les digo, pongan atención y oigan bien mis palabras."
,"24":"¿Acaso el labrador emplea todo su tiempo en arar,"
,"25":"partir los terrones y pasarle el rastrillo a su tierra?,¿No es cierto que después de haberla aplanado, siembra mostaza y esparce el comino y luego tira el trigo y la cebada y la avena en los surcos?"
,"26":"Su Dios es el que le enseñó a hacerlo así y el que lo instruyó."
,"27":"Pues el yuyo no se trilla ni se pasa el rodillo sobre el comino, sino que al yuyo, lo mismo que al comino, se les golpea con un palo."
,"28":"¿Se muele el grano de trigo? No, pues no se trilla indefinidamente, sino que después de pasarle el rodillo, se le limpia, pasando las ruedas, pero sin partirlo."
,"29":"Todo esto lo ha aprendido de Yavé de los Ejércitos, que es muy bueno para dar consejos,y que hace cosas extraordinarias"
}`)
	CurrentBook.AddChapter(29, `{
"1":"¡Ay de Ariel, Ariel, ciudad donde acampó David!,Añadan un año a otro año, que las fiestas den vuelta al año;"
,"2":"entonces le pondré sitio a Ariel,y habrá quejas y lamentaciones. Tú serás para mí como un Ariel."
,"3":"Instalaré mi campamento frente a ti como David, te rodearé de empalizadas,y cavaré trincheras a tu alrededor."
,"4":"Desde la fosa, donde estés tendida, hablarás, pero tu voz será como la de un fantasma,y tus palabras desde el fondo de la fosa,serán sofocadas por el polvo."
,"5":"Y, en un momento, de repente, la multitud de los atacantes será como paja al viento, y las huestes de tus enemigos como polvo fino."
,"6":"Yavé de los Ejércitos intervendrá, con truenos, terremotos y gran estruendo, y el huracán, la tempestad, y la llama de un fuego devorador."
,"7":"Como un sueño que se tiene de noche, así será para la multitud de naciones, que iban a pelear contra Ariel, para sus ejércitos que la rodeaban, para sus trincheras y sus empalizadas."
,"8":"Les sucederá como al hambriento que come en sueños,y que se despierta con el estómago vacío; o como al sediento que sueña que bebe, pero se despierta con la garganta seca. Así les pasará a todas las naciones, a los que hayan venido para atacar a Sión."
,"9":"Embrutézcanse y pónganse tontos, anden ciegos, sin vista, quédense ebrios, pero no por el vino, maréense, pero no por el licor."
,"10":"Es un espíritu que adormece, el que Yavé les ha enviado; les ha cerrado los ojos a ustedes los profetas, y a ustedes los videntes, les ha vendado los ojos."
,"11":"Todas las visiones han pasado a ser para ustedes como las palabras de un libro que está sellado. Si se lo pasa a uno que no sabe leer, diciéndole: 'Lee esto', él contestará: 'No puedo, pues el libro está sellado.'"
,"12":"O bien si se lo entregan a otro que no sabe leer, diciéndole lo mismo, él responderá: 'No sé leer.'"
,"13":"El Señor ha dicho: 'Este pueblo me ofrece tan sólo palabras, y me honra con los labios, pero su corazón sigue lejos de mí. Su religión no vale, pues no son más que enseñanzas y obligaciones humanas."
,"14":"Por eso, yo seguiré desconcertando a este pueblo, y serán sorpresas y más sorpresas; la sabiduría de sus sabios fracasará, y se perderá la inteligencia de sus entendidos.'"
,"15":"¡Ay de los que disimulan sus planes,y creen que se esconden de Yavé!,Traman sus proyectos en la oscuridad, y luego dicen: '¿Quién nos ve, quién lo sabe?'"
,"16":"¡Qué maldad la de ustedes!,¿Es acaso la greda igual que el alfarero?,¿Podrá decir al que la hizo: 'Yo no soy tu obra'; o dirá un cántaro al alfarero: 'No sabes nada'?"
,"17":"Falta muy poco tiempo para que el Líbano se convierta en un jardín y que el jardín, en cambio, pase a ser un zarzal."
,"18":"Aquel día, los sordos oirán las palabras de un libro, y libres de la sombra y de las tinieblas, los ojos de los ciegos volverán a ver."
,"19":"Los humildes aún se alegrarán con Yavé y los más pobres quedarán felices con el Santo de Israel,"
,"20":"pues ya no habrá más opresor. Habrá desaparecido el que se reía de todos y habrán sido eliminados todos los malvados,"
,"21":"los que hacen condenar a otro porque saben hablar,y les meten trampas a los jueces al tribunal, y niegan, por una coma, el derecho del bueno."
,"22":"Por todo esto, así lo declara Yavé, Dios de la familia de Jacob, El, que rescató a Abraham: 'En adelante, Jacob ya no será defraudado,ni tendrá por qué verse pálido,"
,"23":"pues, al ver a sus hijos de vuelta a su casa,-gracias a mí-, se pondrá a alabar mi Nombre.',Festejarán al Santo de Jacob,y temerán al Dios de Israel."
,"24":"Los descarriados entrarán en razón,y los rebeldes se dejarán instruir."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Ay de estos hijos rebeldes, dice Yavé, que traman unos proyectos que no son los míos y que se comprometen con pactos ajenos a mi espíritu, de modo que acumulan así pecados y más pecados."
,"2":"Están saliendo para Egipto, sin haberme consultado, para pedirle asilo a Faraón y refugiarse bajo la sombra de Egipto."
,"3":"Ustedes esperan la protección de Faraón, pero serán defraudados; la sombra de Egipto no será más que decepción para ustedes."
,"4":"Sus ministros han ido a Zoan y sus embajadores han llegado hasta Hanes."
,"5":"Pero todos se sentirán defraudados de un pueblo incapaz de socorrerlos; en vez de ayuda o socorro sólo hallarán en ellos decepción y confusión."
,"6":"Oráculo sobre los animales del Negueb: A través de una tierra pobre y triste, poblada por leones,y por víboras y serpientes voladoras, llevan sus tesoros, a lomo de burro, y sus riquezas sobre la joroba de camellos, a un pueblo que no les prestará ninguna ayuda."
,"7":"¿Egipto? Su auxilio es ineficaz y vano; por eso, le he puesto el sobrenombre,de 'El espantapájaros incapaz'."
,"8":"Anda, ahora, y escribe esto,en una pizarra o en un libro, para que sea, en el futuro, algo que siempre los esté acusando."
,"9":"Es un pueblo que nunca está conforme, son hijos hipócritas, que se niegan a escuchar los consejos de Yavé."
,"10":"Han dicho a los videntes: 'No tengan más visiones', y a los profetas: 'No nos comuniquen la verdad, más bien, cuéntennos cosas interesantes,de mundos maravillosos."
,"11":"Desvíense del camino, no sigan esa ruta, quiten de nuestros ojos,al Santo de Israel.'"
,"12":"En vista de eso, así habla el Santo de Israel: 'Ya que ustedes no han hecho caso a estas advertencias y han recurrido más bien a las tasas impuestas y a la mentiras,"
,"13":"este pecado será para ustedes como una grieta que aparece en una alta muralla. Se agranda y amenaza, hasta que, de repente, de un golpe, se derrumbe la muralla."
,"14":"Se ha quebrado como un cántaro de greda, roto sin contemplación, y no queda, siquiera, un solo pedazo bueno para tomar las brasas del fuego o para sacar agua de una charca. Así habla el Señor Yavé, el Santo de Israel:"
,"15":"'En la conversión y en la calma estaba su salvación, y su seguridad, en una perfecta confianza."
,"16":"Pero ustedes no lo han aceptado y han dicho: '¡Mejor huiremos a caballo!',¡Pues bien, huyan no más!,Y han añadido: 'En rápidos carros.' ¡Muy bien, sus perseguidores serán todavía más rápidos! "
,"17":"Mil huirán ante la amenaza de uno solo, y ante el ataque de cinco todos ustedes huirán; y sólo sobrevivirá de ustedes un resto, como un poste en la cumbre de un cerro o como un palo de bandera en una colina."
,"18":"Yavé está esperando el momento para perdonarlos; se levantará y tendrá piedad de ustedes, pues Yavé es un Dios justo y ¡felices los que en él esperan!"
,"19":"Sí, pueblo de Sión, que vives en Jerusalén, ya no llorarás más. El se compadecerá de ti al sentir tus lamentos, lo llamarás y te atenderá."
,"20":"Después que el Señor les haya dado el pan del sufrimiento y el agua de la aflicción, él, que es su educador, ya no se ocultará más y ustedes verán al que les educa."
,"21":"Cuando tengan que tomar el camino ya sea a la derecha o a la izquierda, tus oídos oirán sus palabras resonar detrás de ti: 'Este es el camino que deben seguir.'"
,"22":"Encontrarás que son impuros la cubierta de plata de tus ídolos y el revestimiento de oro de tus estatuas. Los tirarás como unas inmundicias y les dirás: 'Váyanse de aquí.'"
,"23":"El Señor te dará la lluvia para las semillas que hayas sembrado en el campo, y el pan que te producirá la tierra será sustancioso y nutritivo. Tu ganado pastará entonces en grandes potreros."
,"24":"Los bueyes y los burros que trabajan en el campo, comerán buen pasto aventado a pala y horqueta."
,"25":"Sobre cualquier cerro alto y sobre cualquier colina elevada habrá arroyuelos y vertientes cuando llegue el día de la gran matanza y se vengan abajo los castillos."
,"26":"Entonces la luna alumbrará como el sol, y la luz del sol será siete veces más fuerte el día en que Yavé vende la herida de su pueblo y le haga una curación a las magulladuras de sus golpes."
,"27":"¡Miren cómo viene de lejos el Nombre de Yavé! Su ira es una llama, su presencia es aplastante. En sus labios se nota su furor y su lengua es como un fuego que devora."
,"28":"Su respiración es como un torrente que se desborda y que le llega a uno hasta el cuello. El viene para colar a las naciones con un colador muy fino y a poner sus riendas con freno en el hocico de los pueblos."
,"29":"Ustedes cantarán, entonces, como en una noche de fiesta, en que todos los corazones están contentos, como el que parte, al son de la flauta, para subir el cerro de Yavé, cerca de la roca de Israel, mientras se tocan tambores y guitarras y se baila..."
,"30":"Yavé hará oír su voz majestuosa y descargará su ardiente cólera, en medio de relámpagos que queman y de una tempestad de lluvia y granizo."
,"31":"Pues, por orden de Yavé, Asur será maltratado a palos y castigado."
,"32":"Una y otra vez recibirá los bastonazos que le pegará Yavé."
,"33":"Porque de antemano está preparada la hoguera, que será también para su rey; una fosa profunda y ancha, llena de leña y paja. El soplo de Yavé, que es como un río de azufre, le prenderá fuego."
}`)
	CurrentBook.AddChapter(31, `{
"1":"¡Pobres de aquellos que bajan a Egipto, por si acaso consiguen ayuda!,Pues confían en la caballería, en los carros de guerra, que son numerosos, y en los jinetes, porque son valientes. ¿Por qué no hicieron caso del Santo de Israel y no consultaron a Yavé?"
,"2":"Porque él también es hábil en proporcionar desgracias, y no cambia su palabra. Se opondrá a la banda de los malvados y al socorro que esperaban los malos."
,"3":"El egipcio es un hombre y no es Dios y sus caballos son carne, y no espíritu. Al primer golpe que Yavé les pegue, vacilará el protector y caerá quien buscaba protección; juntos perecerán."
,"4":"Así me ha dicho Yavé: 'Cuando un león o su cachorro ruge sobre su presa y la defiende, por más que se junten los pastores y den voces, no les tiene miedo a sus gritos y su número no lo asusta. Así sucederá cuando Yavé de los Ejércitos baje a pelear sobre el cerro de Sión. "
,"5":"Yavé de los Ejércitos, como pájaro que vuela, protegerá a Jerusalén y la salvará, guardándola ilesa y liberándola.'"
,"6":"Hijos de Israel, vuelvan a aquel a quien tanto han traicionado."
,"7":"En ese día cada uno de ellos tirará sus ídolos de plata o de oro, todos los ídolos que ustedes se han hecho."
,"8":"Asur caerá sin intervención de hombre, una espada no de hombre lo devorará. El huirá ante esa espada, y sus jóvenes serán hechos prisioneros"
,"9":"Les entrará tanto miedo que huirán sin que nadie los detenga, y sus jefes, espantados, dejarán tirado el estandarte. Esta es palabra de Yavé, cuyo fuego arde en Sión y su horno está en Jerusalén."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Un rey hará reinar la justicia y sus ministros gobernarán según el derecho."
,"2":"Cada uno de ellos será como un cortaviento, o como un refugio para guarecerse del temporal. Serán como un río que corre por el desierto o como la sombra de un cerro en medio de una llanura calurosa."
,"3":"Entonces los que pueden ver ya no se quedarán ciegos, y los oídos de los que oyen estarán atentos,"
,"4":"los indisciplinados tratarán de aprender y los tartamudos hablarán correctamente;"
,"5":"no se le tratará de 'señor' al hombre sin conciencia, y el sinvergüenza no será considerado como una persona de importancia."
,"6":"Pues el hombre sin conciencia dice cosas que chocan la conciencia y trama el mal; es un hipócrita que blasfema contra Yavé, que deja sin comida al hambriento o le niega un vaso de agua al sediento."
,"7":"En cuanto al sinvergüenza, sus inventos son perversos, pues trata de perjudicar a los pobres con sus mentiras, aunque sean justos los reclamos de estos humildes."
,"8":"En cambio, el caballero sólo piensa lo correcto y actúa siempre con decencia."
,"9":"Mujeres despreocupadas, levántense, oigan lo que les digo; hijas demasiado confiadas, escuchen mis palabras."
,"10":"Dentro de un año, más o menos, ustedes que están tan confiadas temblarán al ver que en el tiempo de la vendimia no hay nada que cosechar."
,"11":"¡Tiriten, despreocupadas, y asústense, ustedes que andan tan confiadas! Quítense la ropa y vístanse de saco."
,"12":"Péguense en los senos por lo que les pasó a esos hermosos campos y a esas fértiles viñas;"
,"13":"ahora espinas y zarzamoras cubren los terrenos de mi pueblo y las casas de vida alegre de la ciudad feliz."
,"14":"El palacio está abandonado, la ciudad bulliciosa está solitaria; el ofel y la torre de guardia han sido convertidos en ruinas para siempre; serán, en adelante, unos lugares donde gocen los burros salvajes o donde pasten los rebaños."
,"15":"Pero sobre nosotros se derramará el espíritu desde arriba. Entonces el desierto se transformará en vergel, y lo que ahora es llamado vergel será tenido por terreno baldío."
,"16":"En el desierto acampará el Derecho; en el jardín descansará la Justicia."
,"17":"La obra de la Justicia será la Paz y los frutos de la Justicia serán tranquilidad y seguridad para siempre."
,"18":"Mi pueblo vivirá en habitaciones buenas, en barrios seguros, en lugares tranquilos."
,"19":"La selva será cortada, y la ciudad humillada."
,"20":"Felices ustedes, que sembrarán entonces a orillas de todos los esteros o soltarán sin problemas su buey o su burro."
}`)
	CurrentBook.AddChapter(33, `{
"1":"¡Ay de ti, salteador que no has sido saqueado, traidor que no has sido traicionado!,Cuando hayas terminado tus asaltos, te saltearán, y cuando hayas acabado con tus robos, te pillarán."
,"2":"¡Yavé, ten compasión, pues en ti esperamos!,Sé tú nuestro apoyo, por la mañana, y nuestra salvación en el tiempo de la angustia."
,"3":"Al sentir tus amenazas huyen los pueblos, tú te paras, y las naciones se dispersan:"
,"4":"¡recojan su botín como lo hace la langosta, tírense encima como nube de langostas!"
,"5":"Grande es Yavé, pues mora en las alturas, El llena a Sión de justicia y de derecho."
,"6":"El asegura, en todo tiempo, tu existencia; las riquezas que salvan son la sabiduría y la ciencia, el temor de Yavé será tu tesoro."
,"7":"Miren cómo Ariel se queja por la calle,y cómo lloran amargamente,los embajadores que venían en son de paz."
,"8":"Los caminos están desiertos, ya nadie pasa por allí. No respetaron el contrato, han faltado a su palabra, no han sido siquiera correctos."
,"9":"La tierra está de luto y se muere, el Líbano ha sido humillado y queda árido, el Sarón parece un desierto, y un peladero, el Basán y el Carmelo."
,"10":"'Ahora me levanto, dice Yavé, y me pongo de pie con toda mi estatura."
,"11":"Ustedes sembraron heno y cosecharán sólo paja, mi respiración los quemará como una llama."
,"12":"Los pueblos quedarán reducidos a cenizas, como zarzamora cortada a la que le prenden fuego."
,"13":"Ustedes que están lejos, miren lo que he hecho, y los que están cerca, conozcan cuál es mi fuerza.'"
,"14":"En Sión, los pecadores se han espantado,y los impíos han sido presa del pánico: '¿Quién de nosotros podrá resistir ese fuego devorador, quién convivirá con llamas que nunca se apagan?'"
,"15":"El que actúa siempre con honradez, el que dice la verdad,y que se niega a conseguir algo con trampa; el que retira su mano para no aceptar la coima, que no quiere oír sugerencias criminales,y no quiere ver procederes malos."
,"16":"Este tendrá su casa en las alturas, vivirá seguro como en un castillo,edificado sobre un peñasco,y nunca le faltarán pan ni agua."
,"17":"Tus ojos contemplarán a un rey en su esplendor y verán un país ampliado."
,"18":"Entonces tu corazón recordará sus espantos, y dirás: '¿Dónde está el opresor que pesaba y contaba los impuestos y se llevaba a nuestros hijos?'"
,"19":"No verás más al pueblo insolente cuyo lenguaje no se puede entender, cuyas palabras te hacen reír y te suenan raras."
,"20":"Contempla a Sión, la ciudad de nuestras fiestas, y que vean tus ojos a Jerusalén, la morada segura, la tienda que nunca se moverá. Sus estacas no cederán y no se romperá ninguna de sus cuerdas."
,"21":"Aquí está Yavé, el que hace cosas grandes con nosotros más potente que los amplios canales. Aquí no cruzan los barcos de remo ni las naves poderosas,"
,"22":"sino que Yavé es el que nos gobierna, Yavé nos pone leyes, Yavé es nuestro rey, El nos salvará."
,"23":"Tus cordeles se soltaron y ya no sostienen el mástil; no se izó la bandera. Entonces hubo que repartir un botín inmenso, hasta los cojos se echaron sobre los despojos;"
,"24":"y no hubo aquel día quién dijera: 'Estoy enfermo'. Al pueblo que allí vive, se le ha perdonado su deuda."
}`)
	CurrentBook.AddChapter(34, `{
"1":"¡Naciones, vengan a presenciar, pueblos, pongan atención; tierra y todo lo que encierras, con tus continentes y sus habitantes, escucha!"
,"2":"Yavé está enojado con todas las naciones,y está enfurecido contra sus ejércitos. Los ha condenado a la destrucción, los ha entregado a la matanza."
,"3":"Los muertos están tirados por las calles, y se siente la fetidez de sus cadáveres. Los montes chorrean sangre,"
,"4":"y el ejército de los cielos se descompone. Los cielos se enrollan como papel,y todo su ejército se marchita,como se secan los racimos nuevos,o como se ponen lacias las hojas de la higuera."
,"5":"Mi espada en los cielos estaba esperando,y ahora cae sobre Edom, sobre este pueblo que yo quiero que sea castigado."
,"6":"La espada de Yavé está cubierta de sangre,y está bañada en grasa, con sangre de corderos y de chivos, con la grasa de los riñones de los carneros. Porque Yavé ha hecho un sacrificio en Bosra, y una gran matanza en tierra de Edom."
,"7":"Hoy caen los toros de este pueblo, sus bueyes y sus terneros cebados. La tierra se empapa de sangre,y el polvo se impregna de grasa,"
,"8":"porque es el día de la venganza de Yavé, día del desquite en las luchas de Sión."
,"9":"Sus ríos son ahora de petróleo, su tierra es de azufre, y todo su país arde como asfalto."
,"10":"No se apagará ni de día ni de noche, y el humo subirá continuamente. Quedará desolado para siempre, y por ahí nadie pasará."
,"11":"Servirá de refugio a los pelícanos y erizos, y allí vivirán las lechuzas y los cuervos; Yavé tirará el cordel para aplanarlo,y su nivel no dejará sino el vacío."
,"12":"Allí tendrán su casa los chivos; y ya no habrá nobles para elegir a un rey, pues todos sus príncipes habrán desaparecido."
,"13":"En sus palacios crecerán las zarzamoras,y en sus castillos, las ortigas y los cardos. Serán una guarida de lobos,y un escondite para los avestruces."
,"14":"Allí se juntarán los gatos salvajes con los pumas, y se darán cita los chivos; allí también se echará a descansar,el monstruo llamado Lilit."
,"15":"Allí tendrá su cueva la serpiente, pondrá sus huevos y se echará encima,hasta que se abran; también allí se reunirán los buitres,"
,"16":"se encontrarán unos con otros. Abran el libro de Yavé y lean, ¡ven que no falta ninguno!,Así es, pues su misma boca lo ha ordenado,y su soplo los ha juntado."
,"17":"El ha sorteado la parte que le tocaba a cada uno,y con sus mismas manos tomó la lienza,para repartirles el país. Serán sus dueños para siempre,y allí vivirán ellos y sus descendientes."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Que se alegren el desierto y la tierra seca, que con flores se alegre la pradera."
,"2":"Que se llene de flores como junquillos, que salte y cante de contenta, pues le han regalado el esplendor del Líbano,y el brillo del Carmelo y del Sarón. Ellos a su vez verán el esplendor de Yavé, todo el brillo de nuestro Dios."
,"3":"Robustezcan las manos débiles,y afirmen las rodillas que se doblan."
,"4":"Díganles a los que están asustados: 'Calma, no tengan miedo, porque ya viene su Dios a vengarse, a darles a ellos su merecido; El mismo viene a salvarlos a ustedes.'"
,"5":"Entonces los ojos de los ciegos se despegarán, y los oídos de los sordos se abrirán,"
,"6":"los cojos saltarán como cabritos,y la lengua de los mudos gritará de alegría. Porque en el desierto brotarán chorros de agua, que correrán como ríos por la superficie."
,"7":"La tierra ardiente se convertirá en una laguna, y el suelo sediento se llenará de vertientes. Las cuevas donde dormían los lobos,se taparán con cañas y juncos..."
,"8":"Por allí pasará una buena carretera, que se llamará el camino santo; por él no transitará ningún impuro, y el sinvergüenza no se atreverá a pisarlo;"
,"9":"no habrá allí ningún león, y la fiera salvaje no se acercará a él. Por este camino marcharán los rescatados"
,"10":"y por ahí regresarán los libertados por Yavé; llegarán a Sión dando gritos de alegría, y con una dicha eterna reflejada en sus rostros; la alegría y la felicidad los acompañarán,y ya no tendrán más pena ni tristeza."
}`)
	CurrentBook.AddChapter(36, `{
"1":"En el año catorce del rey Ezequías, Senaquerib, rey de Asiria, subió contra todas las ciudades fortificadas de Judá y se apoderó de ellas."
,"2":"El rey de Asiria, desde Laquis, envió donde el rey Ezequías a uno de sus generales con una numerosa tropa. El general se colocó cerca del canal del estanque superior, junto al camino del campo del batanero."
,"3":"A su encuentro salieron el mayordomo del palacio Eliaquim, el secretario Sobná y el canciller Joás, hijo de Asaf."
,"4":"El general les dijo: 'Transmitan este recado a Ezequías. Así habla el rey de Asur: ¿En qué pones tu confianza? ¿Acaso crees que para hacer la guerra algunas declaraciones reemplazan a la sabiduría y a la fuerza?"
,"5":"¿En quién te apoyas para rebelarte contra mí?'"
,"6":"Ya sé, tú cuentas con la ayuda de esa caña rota que es Egipto, que rompe y traspasa la mano del que se apoya en ella. Así se porta Faraón con todos los que confían en él. Ustedes, tal vez, me dirán:"
,"7":"'No es cierto, porque nosotros solamente hemos confiado en Yavé'; pero, ¿no son justamente sus altares y sus lugares altos los que ha suprimido Ezequías, diciéndole a la gente de Judá y Jerusalén: 'Ustedes deben agacharse únicamente delante de este altar'?"
,"8":"Pues bien, haz una apuesta con el señor rey de Asur: Yo te doy dos mil caballos si puedes encontrar el mismo número de jinetes para montarlos."
,"9":"¡Pero ni siquiera eres capaz de hacer retroceder al más insignificante de los generales de mi patrón! Mientras confiabas en Egipto, pensando que te daría carros y caballerías,"
,"10":"a mí Yavé me traía a este país para arruinarlo. Pues Yavé fue el que me lo ordenó: 'Sube contra este país y destrúyelo.'"
,"11":"Eliaquim, Sobná y Joás respondieron al general: 'Por favor, habla a tus servidores en arameo, porque nosotros lo entendemos, pero no nos hables en judío frente a esta gente que está encima de las murallas.'"
,"12":"Pero el general les contestó: '¿Ustedes se figuran que mi patrón me mandó a decirles estas cosas nada más que a su patrón y a ustedes y no a la gente que está sentada encima de las murallas y que junto con ustedes está condenada a comer sus excrementos y a tomar su orina?'"
,"13":"Entonces el general se puso de pie y hablando en alta voz pronunció, en judío, estas palabras: 'Oigan el mensaje del gran rey de Asiria."
,"14":"Así habla el rey: No se dejen engañar por Ezequías, porque no los podrá salvar;"
,"15":"ni lo crean cuando trata de que ustedes confíen en Yavé. Que no les diga a ustedes que Yavé los librará sin duda alguna y no permitirá que esta ciudad caiga en manos del rey de Asur."
,"16":"No le hagan caso a Ezequías sino, más bien, al rey de Asur, quien les promete lo siguiente: Si hacen las paces conmigo y se rinden a mí, cada uno de ustedes comerá los frutos de su viña y de su higuera y tomará del agua de su pozo,"
,"17":"hasta que venga y los lleve a una tierra como la de ustedes, tierra de trigo y de viñas, tierra de pan y de vino."
,"18":"Ezequías los está engañando al decirles: 'Yavé nos salvará.' ¿Pudieron, acaso, los dioses de las naciones salvar cada uno a su país de las manos del rey de Asur?"
,"19":"¿Dónde están los dioses de Jamat y de Arpad? ¿Dónde los dioses de Sefarvaim? ¿Dónde los de Samaria? ¿Fueron capaces de libertar a Samaria de mis manos?"
,"20":"¿Cuál de todos los dioses de esos países ha salvado a su país de mis manos? ¿Cómo, pues, Yavé podría salvar de mis manos a Jerusalén?'"
,"21":"Todo el mundo guardó silencio y nadie le respondió, pues ésa era la orden del rey: 'No le respondan a nada.'"
,"22":"El superintendente del palacio, Eliaquim, hijo de Helcías, el secretario Sobná y el canciller Joás, hijo de Asaf, volvieron a casa de Ezequías con la ropa rasgada y le contaron todo lo que les había dicho el general."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Cuando terminaron de hablar, el rey Ezequías rasgó también su ropa, se puso un saco y se fue a la Casa de Yavé."
,"2":"En seguida mandó al superintendente del palacio, Eliaquim, al secretario Sobná y a los sacerdotes ancianos, vestidos de sacos, a ver al profeta Isaías, hijo de Amós,"
,"3":"con este recado: 'Esto manda decir Ezequías: Este es un día de angustia, de castigo y de vergüenza; los niños están a punto de nacer, pero falta la fuerza para darlos a luz."
,"4":"¡Ojalá Yavé, tu Dios, haya escuchado las palabras del general al que el rey de Asur mandó para que insultara al Dios vivo, y pueda Yavé tu Dios castigar esas palabras! ¡Ruega a Dios por los pocos que todavía quedamos!'"
,"5":"Cuando los ministros del rey Ezequías le entregaron ese recado a Isaías,"
,"6":"éste les contestó: 'Díganle a su patrón que ésta es la respuesta de Yavé: No te asustes por las palabras que escuchaste, con las que me injuriaron los mozos del rey de Asur."
,"7":"Lo voy a impresionar por una noticia que recibirá, de manera que vuelva a su país, y en su país será asesinado.'"
,"8":"Se fue el general y encontró al rey de Asur, que estaba atacando a Libna. El general se había informado, en efecto, de que el rey se había retirado de Laquis,"
,"9":"al comunicársele la siguiente noticia: 'Taraca, rey de Etiopía, ha salido a atacarte.',De nuevo, Senaquerib envió embajadores a Ezequías "
,"10":"con esta advertencia para el rey de Judá: 'Tú has puesto tu confianza en tu Dios y dices que Jerusalén no caerá en manos del rey de Asur, pero es cierto que te va a defraudar."
,"11":"Pues sabes muy bien lo que los reyes de Asur han hecho con todos los países, esto es, los han destruido totalmente;"
,"12":"y ¿tú piensas que te vas a librar? ¿De qué les sirvieron sus dioses a las naciones que mis padres conquistaron, a Gozán, Jarán, Résef, y a los arameos de Tel-basar?"
,"13":"¿Dónde están ahora el rey de Jamat, el rey de Arpad, el rey de Sefarvaim, de Hena y de Iva?'"
,"14":"Ezequías tomó la carta que traían los embajadores y la leyó. En seguida subió al Templo de Yavé y la desenrolló delante de Yavé."
,"15":"Y dirigió esta súplica a Yavé:"
,"16":"'Yavé de los Ejércitos, Dios de Israel,"
,"17":"que estás sentado sobre los querubines, tú eres el único Dios de todos los reinos de la tierra; tú eres el creador del cielo y de la tierra. Atiéndeme, Yavé, y escucha. Abre, Yavé, tus ojos y mira. Mira las palabras de Senaquerib,con que manda insultar al Dios viviente."
,"18":"Es cierto, Yavé, que los reyes de Asur han aniquilado a todas las naciones con sus habitantes."
,"19":"Y han echado al fuego a sus dioses, aunque no son dioses sino hechura de mano de hombre, de madera o de piedra, y por eso han sido destruidos."
,"20":"Sin embargo, ahora, Yavé, Dios nuestro, líbranos de caer en sus manos, te lo suplico, para que todos los reinos de la tierra sepan que tú eres el único Dios, ¡Yavé!'"
,"21":"Entonces Isaías mandó a decir a Ezequías: 'Esto es lo que dice Yavé, Dios de Israel: He escuchado la oración que tú me has dirigido a propósito de Senaquerib, rey de Asiria,"
,"22":"y ésta es la palabra que Yavé ha pronunciado contra él: La Virgen de Sión te desprecia y se ríe de ti, la hija de Jerusalén te hace burlas por la espalda."
,"23":"¿A quién has insultado con tus blasfemias?,¿A quién le has levantado la voz,y lo has mirado con orgullo?,Al Santo de Israel."
,"24":"Por boca de tus mensajeros has insultado a Yavé; 'Con mis innumerables carros dijiste-, he subido a las más altas montañas, en las faldas del Líbano. He cortado sus altos bosques de cedros,y sus cipreses más hermosos. He llegado hasta su más remotos escondites, hasta sus frondosas selvas."
,"25":"He cavado pozos en tierra extranjera, he bebido sus aguas, y dejé secos, al pasar, todos los ríos de Egipto.'"
,"26":"Hace mucho tiempo que tengo eso preparado, -¿no te lo habían dicho?,Hace años que decidí esto que ahora voy a realizar."
,"27":"Tú debías convertir en ruinas ciudades fortificadas; sus habitantes quedaban sin fuerza, estaban espantados y confundidos. Fueron como la hierba del campo, como el musgo en el techo, o como el trigo verde quemado por la peste."
,"28":"Pero yo sé cuándo tú te sientas, cuándo entras y cuándo sales."
,"29":"Te has levantado contra mí,y tus palabras insolentes han llegado a mis oídos; por eso, voy a poner un anillo en tus narices,y un freno en tus labios, y te haré volver por el camino por donde has venido.'"
,"30":"Isaías dijo a Ezequías: 'Esto te servirá de señal: Este año se comerá del trigo sembrado, y el año siguiente lo que brote sin sembrar. Pero al tercer año podrán comer y cosechar, plantar viñas y comer su fruto."
,"31":"El resto que sobrevivirá del pueblo de Judá, volverá a echar raíces y a dar fruto."
,"32":"Pues de Jerusalén saldrá un resto, del monte de Sión un grupo de salvados."
,"33":"Todo esto lo hará el amor celoso de Yavé de los Ejércitos.'"
,"34":"Ahora bien, Yavé dice sobre el rey de Asur: 'No entrará en esta ciudad, no le tirará ninguna flecha, no la atacará con torres rodantes ni construirá terraplenes contra ella, sino que se volverá por el camino por donde vino.'"
,"35":"No entrará en esta ciudad, pues lo asegura Yavé: 'Yo defenderé esta ciudad y la salvaré en atención a mí y a mi servidor David.'"
,"36":"Esa misma noche el Angel de Yavé hirió de muerte a ciento ochenta y cinco mil hombres del campamento asirio. A la hora de levantarse, en la mañana, no había más que cadáveres."
,"37":"Senaquerib levantó su campamento y se fue. Y de regreso se quedó en Nínive. Un día, mientras estaba adorando, dentro del templo, a Nisroc, su dios, sus hijos Adramelec y Sareser lo asesinaron a puñaladas y se pusieron a salvo en el país de Ararat. Le sucedió en el trono su hijo Asaradón."
}`)
	CurrentBook.AddChapter(38, `{
"1":"En aquellos días Ezequías cayó enfermo de muerte. El profeta Isaías, hijo de Amós, vino a decirle de parte de Yavé: 'Esto te dice Yavé: Pon en orden las cosas de tu familia, porque vas a morir y no sanarás.'"
,"2":"Entonces Ezequías volvió su rostro a la pared y oró así a Yavé:"
,"3":"'Acuérdate, por favor, que te he servido fielmente con corazón honrado y haciendo lo que te agradaba.' Y se largó a llorar."
,"4":"Entonces le llegó a Isaías una palabra de Yavé:"
,"5":"'Esto has de decir a Ezequías de parte de Yavé, el Dios de su padre David: He escuchado tu oración, he visto tus lágrimas; y ahora te voy a dar quince años más de vida. "
,"6":"Te libraré a ti y esta ciudad del rey de Asiria. Yo mismo protegeré la ciudad.'"
,"22":"Ezequías dijo: '¿Cuál será la señal de que subiré a la Casa de Yavé?'"
,"7":"Isaías respondió: 'Yavé te va a indicar con esta señal que él cumplirá lo que yo te he dicho:"
,"8":"La sombra que proyecta el sol sobre las escaleras del palacio de Ajaz va a retroceder diez grados de los ya recorridos.' Y la sombra retrocedió diez grados de los que ya había recorrido."
,"21":"Después Isaías dijo: 'Tomen una torta de higos, aplíquenla a la llaga y el rey sanará.'"
,"9":"Poema dedicado a Ezequías, rey de Judá, que cayó enfermo y luego sanó de su enfermedad."
,"10":"Yo decía: En la mitad de mis días ya me marcho; seré encerrado para el resto de mis años,en el lugar adonde van los muertos."
,"11":"Yo decía: No veré más al Señor,en la tierra de los vivos, ya no veré a los habitantes de este mundo."
,"12":"Mi carpa es arrancada y enrollada,tirada lejos de mí, como una carpa de pastores. Como un tejedor tú enrollabas mi vida, y ahora me separas del telar. De repente cae la noche, y acabas conmigo,"
,"13":"grité hasta el amanecer. Como un león ha molido todos mis huesos."
,"14":"Pío como la golondrina, gimo como la paloma; mis ojos han mirado hacia arriba: Señor, ten piedad de mí, responde tú por mí."
,"15":"¿Qué diré, y de qué le hablaré, cuando El mismo lo ha hecho?,¡Ojalá pudiera alabarlo con ocasión de mi mal,todos los años de mi vida,"
,"16":"y que mi corazón viva para ti, y mi espíritu, Señor, porque me habrás sanado, haciéndome revivir!"
,"17":"Miren que mi enfermedad se cambió en salud; tú has sacado mi alma de la fosa fatal,echándote a la espalda todos mis pecados."
,"18":"Pues los muertos no te alaban, ¿podría acaso celebrarte la Muerte, o los que caen en el hoyo proclamar tu fidelidad?"
,"19":"El que está vivo, ése sí que te bendice, como yo lo hago hoy día: de padres a hijos recordarán tu fidelidad."
,"20":"Oh Señor, ven a salvarme, y tocaremos para ti las cuerdas del arpa,en la casa del Señor todos los días de nuestra vida."
}`)
	CurrentBook.AddChapter(39, `{
"1":"En aquel tiempo, Merodac-Baladán, hijo de Baladán, rey de Babilonia, mandó cartas y un regalo a Ezequías al enterarse de su enfermedad y de su curación."
,"2":"Ezequías estuvo tan contento que enseñó a los mensajeros la sala del tesoro, con la plata, el oro, los perfumes, los aceites aromáticos, como también su arsenal y todo lo que había en sus bodegas. Nada quedó de su palacio y de sus dependencias que no se lo mostrase Ezequías."
,"3":"Entonces Isaías vino a ver a Ezequías y le preguntó: '¿Qué han dicho esos hombres? ¿De dónde venían?' Y Ezequías respondió: 'Han venido de un país lejano, de Babilonia.'"
,"4":"Isaías le preguntó: '¿Qué han visto en tu palacio?' Ezequías respondió: 'Han visto todo lo que hay en mi palacio. No ha quedado nada en mis almacenes que no les haya mostrado.'"
,"5":"Entonces Isaías dijo a Ezequías: 'Escucha la palabra de Yavé de los Ejércitos:"
,"6":"Vendrán días en que todo lo que hay en tu palacio y todo lo que han atesorado tus padres hasta el día de hoy será llevado a Babilonia y no quedará nada."
,"7":"E incluso tus hijos, que tú has engendrado, servirán como eunucos en el palacio del rey de Babilonia.'"
,"8":"Ezequías dijo a Isaías: 'Es buena la palabra de Yavé que has anunciado.' Pues pensaba: 'En mi vida, por lo menos, habrá paz y seguridad.'"
}`)
	CurrentBook.AddChapter(40, `{
"1":"Consuelen, dice Yavé, tu Dios, consuelen a mi pueblo."
,"2":"Hablen a Jerusalén, hablen a su corazón, y díganle que su jornada ha terminado, que ha sido pagada su culpa, pues ha recibido de manos de Yavé,doble castigo por todos sus pecados."
,"3":"Una voz clama: 'Abran el camino a Yavé en el desierto; en la estepa tracen una senda para Dios;"
,"4":"que todas las quebradas sean rellenadas,y todos los cerros y lomas sean rebajados; que se aplanen las cuestas,y queden las colinas como un llano.'"
,"5":"Porque aparecerá la gloria de Yavé,y todos los mortales a una verán,que Yavé fue el que habló."
,"6":"Una voz dice: 'Grita.',Y yo respondo: '¿Qué he de gritar?',La voz dice: 'Toda carne es hierba, y toda su delicadeza como flor del campo."
,"7":"La hierba se seca y la flor se marchita,cuando sobre ella pasa el soplo de Yavé.'"
,"8":"La hierba se seca y la flor se marchita, mas la palabra de nuestro Dios,permanece para siempre."
,"9":"Sube a un alto cerro,tú que le llevas a Sión una buena nueva. ¡Haz resonar tu voz, grita sin miedo, tú que llevas a Jerusalén la noticia!,Diles a las ciudades de Judá: '¡Aquí está su Dios!'"
,"10":"Sí, aquí viene el Señor Yavé, el fuerte, el que pega duro y se impone. Trae todo lo que ganó con sus victorias, delante de él van sus trofeos."
,"11":"Como pastor, lleva a pastar a su rebaño, y su brazo lo reúne,toma en brazos a los corderos, y conduce a las paridas."
,"12":"¿Quién cerró su mano sobre el agua del mar, o tomó las dimensiones del cielo?,¿Quién recogió todas las arenas del globo, o pesó las montañas en una romana,y los cerros en una balanza?"
,"13":"¿Y quién sondeó el espíritu de Yavé, o fue su consejero para guiarlo?"
,"14":"¿A quién habrá consultado para entender mejor, para saber cómo se administra justicia,o para estar al día en los métodos más prácticos?"
,"15":"Las naciones son como una gota en el borde del vaso, como un polvillo que se deja en la balanza. ¿Las tierras de ultramar ? Son sólo un granito de arena."
,"16":"El Líbano no sirve para encender su hoguera, y sus animales no alcanzan para quemarlos en su templo."
,"17":"Todos los países son como nada delante de él, valen un cero, no se toman en cuenta."
,"18":"¿Con quién podrán comparar a Dios,y qué representación darán de él?"
,"19":"¿Acaso la estatua que fundió el artista, y que el joyero revistió de oro con cadenas de plata?"
,"20":"Un hábil escultor busca una palmera escogida,y de allí saca madera que no se pudre,para levantar una estatua bien firme."
,"21":"¿No lo sabían, o no habían oído hablar de eso?,¿No se lo enseñaron desde el comienzo,para que entendieran cómo se fundó la tierra?"
,"22":"El vive más allá del techo de la tierra, desde allí sus habitantes parecen hormigas. Ha estirado los cielos como una tela, los ha extendido como una carpa para vivir."
,"23":"Reduce a la nada a los grandes,y hace desaparecer a los gobernantes de la tierra."
,"24":"Apenas han sido plantados o sembrados, apenas su tallo ha echado raíces en el suelo, sopla sobre ellos y se secan, y un viento fuerte se los lleva como paja."
,"25":"'¿Con quién podrán ustedes compararme, o quién será igual a mí?', dice el Santo."
,"26":"Pongan la cara hacia arriba y miren: ¿Quién ha creado todos esos astros?,El, él mismo, que hace salir en orden su ejército, y que llama a cada estrella por su nombre. Su fuerza es tan grande y su poder tan inmenso, que ninguna se hace la desentendida."
,"27":"¿Por qué dices tú, Jacob, y lo repites tú, Israel: 'Yavé no me mira, mi Dios no se preocupa por mis derechos'?"
,"28":"¿Acaso no lo sabes, o no lo has oído?,Yavé es un Dios eterno,que ha creado hasta los extremos del mundo. No se cansa ni se fatiga,y su inteligencia no tiene límites."
,"29":"El da la fuerza al que está cansado,y robustece al que está débil."
,"30":"Mientras los jóvenes se cansan y se fatigan,y hasta pueden llegar a caerse,"
,"31":"los que en El confían recuperan fuerzas, y les crecen alas como de águilas. Correrán sin fatigarse,y andarán sin cansarse. Ciro, libertador de Israel"
}`)
	CurrentBook.AddChapter(41, `{
"1":"Islas, guarden silencio y atiéndanme, y que los pueblos se acerquen a mí. Adelántense para hablar, pues tenemos que litigar juntos."
,"2":"¿Quién ha mandado desde el Oriente,a aquel que se topa con la victoria a cada paso?,¿Quién le entrega las naciones,y le somete los reyes?,Su espada los convierte en polvo,y las flechas de su arco los dispersan como paja."
,"3":"El los persigue y avanza sin que lo molesten, sus pies apenas tocan el camino."
,"4":"¿Quién está detrás de esto realizándolo?,Aquel que desde el principio,trae a su tiempo los acontecimientos. Yo, Yavé, que soy el primero,y que estaré también con los últimos."
,"5":"Las islas lo han visto y sienten miedo, y se han asustado hasta los extremos del mundo."
,"6":"(Se ayudan unos a otros y mutuamente se dan ánimo."
,"7":"El fundidor anima al joyero y el pulidor al herrero, mientras conversan sobre el enchapado: 'Está bueno.' Y lo afianzan con clavos para que no se mueva.)"
,"8":"Pero tú, Israel, eres mi siervo. Tú eres mi elegido, pueblo de Jacob, raza de Abraham, mi amigo,"
,"9":"yo te traje de los confines de la tierra. Te llamé de una región lejana, diciéndote: 'Tú eres mi servidor, yo me fijé en ti y te elegí.'"
,"10":"No temas, pues yo estoy contigo; no mires con desconfianza, pues yo soy tu Dios; yo te he dado fuerzas, he sido tu auxilio, y con mi diestra victoriosa te he sostenido."
,"11":"Todos los que se lanzan contra ti serán avergonzados y humillados; tus adversarios serán reducidos a la nada y perecerán."
,"12":"Buscarás a tus contrarios, pero no los hallarás; serán totalmente derrotados, reducidos a la nada los que te hacían la guerra."
,"13":"Yo, Yavé, soy tu Dios; te tomo de la mano y te digo: No temas, que yo vengo a ayudarte."
,"14":"No temas, raza de Jacob, más indefensa que un gusano. Yo soy tu socorro, dice Yavé, el Santo de Israel es el que te rescata."
,"15":"Mira que te convierto en un rastrillo nuevo y con doble hilera de dientes: molerás los cerros y los harás polvo, y dejarás las lomas como paja."
,"16":"Las echarás al viento, que se las llevará, el temporal las dispersará; pero tú te alegrarás en Yavé, y te sentirás orgulloso con el Santo de Israel."
,"17":"Los pobres y los humildes buscan agua pero no la encuentran, y se les seca la lengua de sed. Pero yo, Yavé, los escucho; yo, Dios de Israel, no los abandonaré."
,"18":"Haré brotar ríos en los cerros pelados y vertientes en medio de los valles. Convertiré el desierto en lagunas y la tierra seca en manantiales."
,"19":"Plantaré en el desierto cedros, acacias, arrayanes y olivares. En la estepa plantaré cipreses, olmos y alerces"
,"20":"para que todos vean y sepan, miren y comprendan que esto lo ha hecho la mano de Yavé y lo ha creado el Dios Santo de Israel."
,"21":"Presenten sus argumentos, dice Yavé, hablen por su defensa, dice el rey de Jacob."
,"22":"Preséntense para decirnos qué es lo que pasará. ¿Qué nos anunciaron en el pasado, para que lo estudiemos,y sepamos lo que vendrá después?,O sencillamente digan lo que sucederá,"
,"23":"indiquen lo que pasará en el futuro, para que sepamos si ustedes son dioses. Hagan algo al menos, bueno o malo, para que lo veamos y los respetemos."
,"24":"Pero no, ustedes son nada, y sus obras no valen nada. Es una locura seguirlos a ustedes."
,"25":"Lo he despertado en el norte, y ha venido, desde el oriente ha sido llamado por su nombre. Ha pisoteado a los jefes como al barro, como el alfarero pisa la arcilla."
,"26":"¿Quién lo había dicho con anterioridad,para que lo supiéramos?,Había que decirlo antes, y podríamos decir: 'Era exacto.',Pero nadie lo anunció o lo dio a saber,"
,"27":"yo fui el primero que dije a Sión: 'Aquí están',y mandé la Buena Nueva a Jerusalén."
,"28":"Miré y no había nadie que diera una opinión, a quien yo preguntara y que me respondiera."
,"29":"Pues todos ellos no valen nada, nada son sus obras,y sus ídolos, puro aire y vacío."
}`)
	CurrentBook.AddChapter(42, `{
"1":"He aquí a mi siervo a quien yo sostengo, mi elegido, al que escogí con gusto. He puesto mi Espíritu sobre él, y hará que la justicia llegue a las naciones."
,"2":"No clama, no grita, no se escuchan proclamaciones en las plazas."
,"3":"No rompe la caña doblada,ni aplasta la mecha que está por apagarse, sino que hace florecer la justicia en la verdad."
,"4":"No se dejará quebrar ni aplastar, hasta que establezca el derecho en la tierra. Las tierras de ultramar esperan su ley."
,"5":"Así habla Yavé, que creó los cielos y los estiró, que moldeó la tierra y todo lo que sale de ella, que dio aliento a sus habitantes,y espíritu, a los que se mueven en ella."
,"6":"Yo, Yavé, te he llamado para cumplir mi justicia, te he formado y tomado de la mano, te he destinado para que unas a mi pueblo,y seas luz para todas las naciones."
,"7":"Para abrir los ojos a los ciegos, para sacar a los presos de la cárcel, y del calabozo a los que yacen en la oscuridad."
,"8":"¡Yo soy Yavé! ¡Ese es mi Nombre!, no daré mi gloria a otros ni mi honor a los ídolos."
,"9":"Las primeras cosas se han realizado; ahora, pues, anuncio cosas nuevas, antes que aparezcan se las doy a conocer."
,"10":"¡Cántenle a Yavé un nuevo canto, que lo alaben hasta los extremos del mundo!,¡Que lo celebre la gente del mar y cuanto él contiene, las islas con sus habitantes!"
,"11":"¡Que levanten la voz el desierto y sus ciudades, los campos donde vive Cedar!,¡Que los habitantes de Petra lancen gritos,y sus aclamaciones resuenen hasta las cumbres!"
,"12":"¡Que aviven a Yavé,y que los vivas se oigan hasta en las islas!"
,"13":"Yavé avanza como un héroe, y se enardece como un guerrero. Pronuncia su arenga y lanza su grito de combate, y luego cae sobre los enemigos."
,"14":"'Hacía mucho tiempo que estaba en silencio, me callaba y aguantaba. Como mujer que da a luz me quejaba, me ahogaba y respiraba entrecortado."
,"15":"Ahora voy a talar los montes y los cerros, a secar toda la vegetación; convertiré los ríos en pantanos,y secaré las lagunas."
,"16":"Haré andar a los ciegos por el camino desconocido,y los guiaré por los senderos. Cambiaré ante ellos las tinieblas en luz,y los caminos de piedras en pistas pavimentadas. Todo esto es lo que que voy a hacer, y lo haré sin falta.'"
,"17":"Se retirarán humillados,todos los que confían en los ídolos, los que dicen a las estatuas fundidas: 'Ustedes son nuestros dioses.'"
,"18":"¡Sordos, oigan! ¡Ciegos, abran sus ojos y vean!"
,"19":"¿Quién está ciego sino mi servidor, y quién es más sordo que el mensajero que yo mando? ¿Quién es ciego como el que trato de levantar, y quién es sordo como el servidor de Yavé?"
,"20":"Tú has visto muchas cosas, pero no te has fijado en nada. ¡Tienes los oídos abiertos, pero no oyes!"
,"21":"Yavé quiso, movido por su justicia, dar fama a su ley;"
,"22":"pero su pueblo es gente robada y saqueada, presa en cavernas o encerrada en calabozos. Los asaltaban y nadie los defendía, o les robaban y nadie reclamaba que les devolvieran."
,"23":"¿Quién de ustedes escuchará todo esto, y pondrá atención para recordarlo después?"
,"24":"¿Quién permitió que asaltaran a Jacob, o le robaran a Israel? ¿No fue Yavé, contra quien pecamos? Pues no quisieron seguir sus caminos y despreciaron sus mandamientos."
,"25":"Por eso les hizo sufrir el ardor de su enojo y los horrores de la guerra. Todo fue presa del fuego, pero ellos no entendieron; todo ha sido consumido, pero no prestaron atención."
}`)
	CurrentBook.AddChapter(43, `{
"1":"Y ahora, así te habla Yavé, que te ha creado, Jacob, o que te ha formado, Israel. No temas, porque yo te he rescatado; te he llamado por tu nombre, tú eres mío."
,"2":"Si atraviesas el río, yo estaré contigo,y no te arrastrará la corriente. Si pasas por medio de las llamas, no te quemarás, ni siquiera te chamuscarás."
,"3":"Pues yo soy Yavé, tu Dios, el Santo de Israel, tu Salvador. Para rescatarte, entregaría a Egipto,Etiopía y Saba, en lugar tuyo."
,"4":"Porque tú vales mucho a mis ojos, yo doy a cambio tuyo vidas humanas; por ti entregaría pueblos, porque te amo y eres importante para mí."
,"5":"No temas, pues, ya que yo estoy contigo. Del este haré venir a tu descendencia,y del oeste te reuniré."
,"6":"Le diré al norte: 'Entrégamelos', y al sur: 'No los retengas más. Devuelve a mis hijos y a mis hijas,desde el lejano fin del mundo,"
,"7":"a todos aquellos que llevan mi apellido,y que yo he creado y formado en honor mío.'"
,"8":"Dejen salir al pueblo ciego, pero que tiene ojos, sordo y que sin embargo tiene oídos."
,"9":"Que se reúnan todas las naciones,y se junten los pueblos. ¿Quién de ustedes dijo lo que pasaría,y anunció lo que ya ocurrió?,Que presenten testigos a favor suyo, para que al escuchar digamos: '¡Es cierto!'"
,"10":"Ustedes son mis testigos, dice Yavé, y son mi servidor, que he elegido; sépanlo, pues, y crean en mí, y comprendan que Yo Soy. Ningún Dios fue formado antes de mí, y ningún otro existirá después."
,"11":"Yo, yo soy Yavé, y nadie salva fuera de mí."
,"12":"Yo soy el que lo ha dicho, y ha acertado; soy yo el que lo había dado a conocer, y no un Dios extraño. Ustedes son mis testigos, y yo soy Dios, dice Yavé. "
,"13":"Siempre lo he sido, y nadie me puede hacer apartar la mano; si yo ejecuto algo, ¿quién me hará retroceder?"
,"14":"Así habla Yavé, su Salvador, el Santo de Israel: Por ustedes he mandado gente a Babel,hice que rompieran todas sus trancas: ¡Lloren en sus barcos, caldeos!"
,"15":"¡Yo soy Yavé, su Santo, el Creador de Israel, su Rey!"
,"16":"Esto dice Yavé, que abrió un camino a través del mar,como una calle en medio de las olas;"
,"17":"que empujó al combate carros y caballería, un ejército con toda su gente: y quedaron tendidos, para no levantarse más, se apagaron como mecha que se consume."
,"18":"Pero no se acuerden más de otros tiempos, ni sueñen ya más en las cosas del pasado."
,"19":"Pues yo voy a realizar una cosa nueva, que ya aparece. ¿No la notan?,Sí, trazaré una ruta en las soledades,y pondré praderas en el desierto."
,"20":"Los animales salvajes me felicitarán, ya sean lobos o búhos, porque le daré agua al desierto, y los ríos correrán en las tierras áridas,para dar de beber a mi pueblo elegido."
,"21":"Entonces el pueblo que yo me he formado,me cantará alabanzas."
,"22":"Tú, Jacob, no me has invocado, más bien, te habías cansado de mí."
,"23":"No me has traído tus ovejas para víctimas, ni me has honrado con sacrificios."
,"24":"Yo no te he abrumado pidiéndote ofrendas, ni te he cansado reclamando incienso. No tuviste que gastar en aromas, ni me diste la grasa de tus sacrificios, sino que me has atormentado con tus pecados,y me has cansado con tu maldad."
,"25":"Soy yo quien tenía que borrar tus faltas,y no acordarme más de tus pecados."
,"26":"Recuerda bien, para que discutamos, saca tú mismo las cuentas para que puedas ganar."
,"27":"Ya pecó tu primer padre, y después se han rebelado tus portavoces;"
,"28":"por eso, dejé botados a los jefes de mi santuario, exterminé a los hijos de Jacob,y quise que mi pueblo fuera despreciado."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Pero ahora, escucha, Jacob, siervo mío, hijos de Israel, a quienes yo elegí:"
,"2":"Así habla Yavé, el que te hizo, tu socorro, el que te formó desde el seno materno: No teman, hijos de Jacob, mi servidor, Israel a quien yo elegí."
,"3":"Derramaré agua sobre el suelo sediento,y los riachuelos correrán en la tierra seca. Derramaré mi espíritu sobre tu raza,y mi bendición cubrirá tus descendientes."
,"4":"Crecerán como hierba regada, como sauces a orillas de los ríos."
,"5":"Uno dirá: Yo soy de Yavé, otro llevará el nombre de Jacob, un tercero escribirá en su mano: 'De Yavé', y tendrá como apellido el nombre de Israel."
,"6":"Así habla el rey de Israel y su redentor, Yavé de los Ejércitos: 'Yo soy el primero y el último; no hay otro Dios fuera de mí."
,"7":"¿Quién es igual a mí? Que se pare y lo diga, que me cuente y me demuestre,que anunció lo que debía pasar,y nos dijo con anticipación las cosas futuras."
,"8":"No se asusten ni tengan miedo: ¿no es cierto que se lo había anunciado desde hace tiempo?,Ustedes ahora son mis testigos: ¿hay acaso otro Dios fuera de mí?,¡No! no existe otra Roca que yo sepa.'"
,"9":"Los que se dedican a tallar estatuas de dioses no son nada por muchos que sean, y esas obras a las que quieren no sirven para nada. Sus partidarios no ven ni entienden nada, pero al fin se decepcionarán."
,"10":"¿Cómo se les ocurre fabricar un dios o fundir una estatua que de nada sirve?"
,"11":"Todos sus cómplices llevarán un chasco, y esos artesanos se pondrán colorados. Que se reúnan todos y se presenten. Verán cómo sentirán, al mismo tiempo, miedo y vergüenza."
,"12":"El herrero trabaja con la fragua y a martillazos da forma a su obra; la trabaja con la fuerza de sus brazos. Siente hambre y se cansa y se agota."
,"13":"El escultor mide la madera, dibuja a lápiz la figura, la trabaja con el cincel y le aplica el compás. Lo hace siguiendo las medidas del cuerpo humano, y con cara de hombre, para ponerlo en un templo."
,"14":"Para esto tuvo que escoger un cedro o un roble entre los árboles del bosque, o bien plantó un laurel que la lluvia hizo crecer."
,"15":"El hombre ya tiene para hacer fuego, para calentarse y para cocer el pan. Pero también fabrica con esa madera un dios para agacharse delante de él; se hace un ídolo para adorarlo."
,"16":"Echa la mitad al fuego, pone a asar la carne sobre las brasas, y cuando está listo, se come el asado hasta quedar satisfecho. Al mismo tiempo, se calienta y dice: 'Me caliento mientras miro las llamas.'"
,"17":"Y con lo que sobre se fabrica su dios, su ídolo, ante el cual se agacha, se tira al suelo, y le reza diciéndole: 'Sálvame, pues tú eres mi dios.'"
,"18":"No saben ni entienden. Sus ojos están tapados y no ven; su inteligencia no se da a la razón."
,"19":"No reflexionan ni son capaces de pensar o entender y decirse: 'He echado la mitad al fuego, he puesto a cocer el pan sobre las brasas, he asado la carne que me comí, ¿y con lo que sobra voy a hacer esta tontería? ¿Y me voy a agachar ante un trozo de madera?'"
,"20":"Ese es un hombre que se alimenta de cenizas; tiene su corazón engañado y se perderá. ¿No será capaz de recapacitar y de preguntarse: '¿Qué tengo en las manos sino puras mentiras?'"
,"21":"Jacob, acuérdate de estas cosas,pues tú eres mi servidor, Israel. Yo hice de ti mi servidor, Israel ¡no me olvides!"
,"22":"He disuelto tus pecados como una neblina, y tus faltas como se deshace una nube. Vuélvete a mí, pues yo te he rescatado."
,"23":"Cielos, griten de alegría, porque Yavé lo ha hecho, y retumben, profundidades de la tierra; cerros y bosques con sus árboles, salten de contento, pues Yavé ha rescatado a Jacob y ha demostrado su poder en Israel."
,"24":"Así habla Yavé, tu redentor, el que te formó desde el seno materno: Yo, Yavé, he hecho todas las cosas, yo solo estiré los cielos, yo afirmé la tierra, ¿y quién estuvo conmigo?"
,"25":"Hago fracasar las predicciones de los magos, y divagar a los adivinos; hago que los sabios se retiren y que su ciencia no acierte."
,"26":"Yo confirmo las palabras de mi servidor y hago que resulten los planes de mis mensajeros. Yo digo a Jerusalén: 'Volverás a ser habitada.' Y a las ciudades de Judá: 'Serán reconstruidas, pues las levantaré de entre sus ruinas.'"
,"27":"Yo digo al océano: '¡Sécate!', y sus fuentes se cierran."
,"28":"Yo digo de Ciro: 'Aquí está mi pastor', y sale para cumplir mis deseos. El dirá por Jerusalén: '¡Que la levanten!', y por el Templo: '¡Que sea reconstruido!'"
}`)
	CurrentBook.AddChapter(45, `{
"1":"Así habla Yavé a Ciro, su ungido: 'Yo te he llevado de la mano,para doblegar a las naciones,y desarmar a los reyes. Hice que las puertas se abrieran ante ti,y no volvieran a cerrarse."
,"2":"Yo iré delante de ti,y aplanaré las pendientes, destrozaré las puertas de bronce,y romperé las trancas de hierro."
,"3":"Te daré los tesoros secretos,y las riquezas escondidas, para que sepas que Yo soy Yavé, el Dios de Israel que te llamó por tu nombre."
,"4":"Por amor a mi servidor Jacob, a Israel, mi elegido, te he llamado por tu nombre,y te he lanzado sin que tú me conocieras."
,"5":"Yo soy Yavé, y no hay otro igual, fuera de mí no hay ningún otro Dios. Sin que me conocieras estuve contigo,"
,"6":"para que todos sepan, del oriente al poniente, que nada existe fuera de mí."
,"7":"Yo soy Yavé, y no hay otro más; yo enciendo la luz y creo las tinieblas, yo hago la felicidad y provoco la desgracia, yo, Yavé, soy el que hace todo esto."
,"8":"Que los cielos manden de lo alto, como lluvia, y las nubes descarguen la Justicia. Que se abra la tierra y produzca su fruto, que es la salvación, y al mismo tiempo florezca la justicia, porque soy yo, Yavé, quien lo envió."
,"9":"¿Acaso discutirá con su fabricante el que es el último de los tiestos? Vaso de arcilla, ¿vas a decir al artesano: qué hiciste? Si eres una cosa fabricada y no tienes manos."
,"10":"Pobre del que se atreve a gritarle a su padre: '¿Qué clase de hijo tienes?' O a su madre: '¿Qué es lo que has dado a luz?'"
,"11":"Así habla Yavé, el Santo, aquel que formó a Israel: '¿Me van a criticar acerca de mis hijos, me van a dar órdenes sobre lo que deba hacer?"
,"12":"Pues bien, yo he hecho la tierra y he creado a los hombres para que en ella vivan. Yo, con mis manos, he estirado los cielos y mando a todo su ejército."
,"13":"Yo lo he llevado a la victoria,y le he despejado el camino. El reconstruirá mi ciudad, traerá a su patria a mis desterrados, sin exigir rescate ni recompensa', dice Yavé de los Ejércitos."
,"14":"Así habla Yavé: 'El trabajo de Egipto y las ganancias de Etiopía, junto con los sebaítas, de alta estatura, pasarán a poder tuyo y te pertenecerán. Irán detrás de ti encadenados, se agacharán delante de ti y volviendo su cara hacia ti suplicarán: 'Sólo en ti está Dios, y no hay otro. "
,"15":"Tú eres un Dios al que le gusta esconderse, Dios de Israel, el Salvador.'"
,"16":"Quedarán confundidos y humillados los fabricantes de ídolos, y se irán avergonzados."
,"17":"Israel en cambio será salvado para siempre, y sus hijos no sufrirán más vergüenza ni deshonra, nunca jamás."
,"18":"Sí, así habla Yavé, Creador de los cielos, - pues El es Dios, que ha formado y hecho la tierra, - pues El le puso cimientos: No dejé la confusión, sino que la hice habitable, - pues yo soy Yavé y no hay otro;"
,"19":"asimismo no he hablado en secreto, - en algún rincón oscuro; y no he dicho a la raza de Jacob: 'Búsquenme, pero todo será confusión', - pues yo, Yavé, digo lo que es justo y hablo sin rodeos.'"
,"20":"Reúnanse y vengan, acérquense y traten de entender, ustedes que sobreviven entre las naciones: Son tontos los que le creen a una estatua, a una cosa de madera, y rezan a un dios incapaz de salvar."
,"21":"O si no hablen, presenten sus pruebas; si es necesario, consúltense unos a otros: ¿Quién había anunciado estas cosas,y las había publicado desde hace tiempo?,¿No he sido yo, Yavé?,No hay otro Dios fuera de mí. Dios justo y Salvador no hay fuera de mí."
,"22":"Vuélvanse a mí para que se salven, desde cualquier parte del mundo, pues ¡yo soy Dios y no tengo otro igual!"
,"23":"Lo juro por mi Nombre, pues de mi boca sólo sale la verdad,y si hablo, la palabra no se echa atrás: 'Ante mí se doblará toda rodilla,y toda lengua jurará por mí, diciendo:"
,"24":"Justicia y fuerza están sólo en Yavé.',Vendrán a verlo muy humilditos,los mismos que se enfurecían con él, "
,"25":"y toda la raza de Israel conseguirá con Yavé,el triunfo y la gloria."
}`)
	CurrentBook.AddChapter(46, `{
"1":"¡Bel se desploma y Nebo se derrumba! Sus ídolos son puestos sobre bestias de carga, sus objetos sagrados son un peso para las bestias cansadas."
,"2":"Se desploman y se caen junto con éstas, incapaces de salvar a las que los transportan. Ellos también van al cautiverio."
,"3":"'Escúchenme, gente de Jacob, todos los que sobreviven de Israel: a los que crié desde su nacimiento,y de los que me hice cargo desde el seno materno."
,"4":"Hasta su vejez yo seré el mismo, y los apoyaré hasta que sus cabellos se pongan blancos. He cargado con ustedes, y seguiré haciéndolo, los sostendré y los libertaré."
,"5":"¿Con quién podrán compararme o equipararme?,¿Encontrarán uno igual o semejante a mí?"
,"6":"Pero la gente saca el oro de su cartera,y lo pesan, con la plata, en la balanza. Le pagan a un joyero para que les haga un dios,al que adoran y delante del cual se tiran al suelo."
,"7":"Se lo echan al hombro y lo llevan, después lo colocan donde va a quedar, y allí está sin que se mueva de su sitio. Por más que le hablan, no responde,y a nadie salva de la ruina."
,"8":"Recuerden esto y tengan vergüenza, reflexionen en su corazón, pecadores."
,"9":"Recuerden las cosas que pasaron antiguamente. Yo soy Dios y no hay otro igual, soy Dios y no hay nada divino fuera de mí."
,"10":"Yo anuncio desde el principio lo que va a venir, y de antemano, lo que no se ha cumplido todavía. Yo digo, y mis planes se cumplen, y todo lo que quiero se realizará."
,"11":"Llamo desde el este a un ave de rapiña, llamo de una tierra lejana, al hombre que está en mis proyectos. Tal como lo he pensado, así lo haré; como lo he planeado, así lo ejecutaré."
,"12":"Oiganme, ustedes, que no piensan en nada,y que están tan ajenos a mi salvación."
,"13":"Mi victoria ya se aproxima, ya llega, y mi salvación no se demorará más. Instalaré mi salvación en Sión, y daré a Israel la grandeza.'"
}`)
	CurrentBook.AddChapter(47, `{
"1":"¡Baja y siéntate en el suelo, virgen hija de Babel!,No más trono: Siéntate en la tierra, hija de los caldeos. Ya no te llamarán más delicada y tierna."
,"2":"Toma el molino y muele la harina, quítate el velo que te protege la cara, levanta tu falda para atravesar el río,y que se vean tus piernas."
,"3":"Pondrán al descubierto tu desnudez, y se verán tus vergüenzas."
,"4":"Me voy a desquitar y nadie intervendrá. - dice Yavé de los Ejércitos, nuestro libertador, cuyo nombre es el Santo de Israel."
,"5":"Siéntate en silencio, colócate en la sombra, hija de los caldeos. Ya nunca más te llamarán soberana de los reinos."
,"6":"Me había enojado con mi pueblo,y había rechazado a los míos. Los había entregado a tus manos, pero tú no tuviste compasión,y, sobre el anciano, hiciste caer tu yugo aplastante."
,"7":"Tú decías: 'Para siempre dominaré.',Y no te fijabas en lo que sucedía, ni pensabas cuál sería el fin."
,"8":"Ahora, escucha esto, delicada, tú que te sientes tan segura y dices: 'Yo, y nadie más; no quedaré viuda, ni perderé mis hijos.'"
,"9":"Estas dos desgracias te sucederán,de un golpe, en el mismo día: quedarás viuda y sin hijos. Esta será tu suerte, a pesar de tus muchos encantamientos,y del poder de tus brujerías."
,"10":"Te sentías segura en tu maldad, y decías: 'Nadie me ve.',Tu sabiduría y tu ciencia se te subieron a la cabeza. hasta tal punto que pensabas: 'Yo y nadie más.'"
,"11":"Pero te va a ocurrir una desgracia,que no podrás evitar, una calamidad caerá sobre ti, y no podrás hacerle el quite. De repente te va a pasar algo,muy grave, en lo que no pensabas."
,"12":"Quédate, pues, con tus encantamientos,y con tus numerosas brujerías, a las que te has dedicado desde tu juventud. ¡A ver si te ayudan en algo, o si puedes con ellos atemorizar a la desgracia!"
,"13":"Te cansas con tantos consejos. Que se presenten y que te salven,los que describen los cielos y observan las estrellas, y te dan a conocer, cada mes, lo que te sucederá."
,"14":"Serán todos como paja que devora el fuego, ninguno de ellos podrá salvarse de las llamas, -y no serán brasas para el pan, o brasero para calentarse-."
,"15":"En esto vendrán a parar tus magos, por los cuales tanto te has preocupado desde tu juventud; se irán corriendo uno tras otro y no podrán salvarte."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Escuchen esto, familia de Jacob, ustedes que llevan el nombre de Israel,y que son hijos de su padre Judá. Ustedes que juran por el nombre de Yavé,e invocan al Dios de Israel, pero con mala fe y sin sinceridad."
,"2":"Ustedes llevan el nombre de la Ciudad Santa,y confían en el Dios de su Padre Israel, cuyo nombre es Yavé de los Ejércitos."
,"3":"Yo les había anunciado los acontecimientos mucho tiempo antes. Salieron de mi boca cuando los di a conocer, de pronto actué y se cumplieron."
,"4":"Yo sabía que eres porfiado, que tu cuello es como una barra de hierro y que tienes la frente como de bronce."
,"5":"Por eso, te había anunciado los acontecimientos y te los di a conocer antes que sucedieran. Si no, habrías dicho: '¡Mi ídolo fue el que los hizo, mi estatua tallada o fundida fue quien los mandó!'"
,"6":"Esto lo has visto, lo has oído. ¿No tienes que confesarlo? Ahora te revelo cosas nuevas y secretas que tú no conocías."
,"7":"No son cosas de tiempos pasados, pues recién acabo de decidirlas, y hasta el día de hoy no habías oído de ellas, así que no podrás decir: 'Ya lo sabía.'"
,"8":"Tú nada de ellas habías escuchado o sabido, ni habían llegado con anticipación a tus oídos; porque yo sabía lo infiel que eres, que desde el seno de tu madre te llaman 'el rebelde'."
,"9":"Pero por amor de mi Nombre contuve mi enojo y por mi honor me reprimí y no te hice pedazos."
,"10":"Esto sí, te he puesto en el fuego, igual que la plata, y te he probado en el horno de la desgracia."
,"11":"Por mí, sí, sólo por mí voy a actuar, pues ¿cómo dejaría que me desprecien? ¿Y cómo cedería mi gloria a otro?"
,"12":"Escúchame, Jacob, pues a ti te he llamado, Israel: soy Yo; Yo que soy el primero y también el último."
,"13":"Mi mano puso los cimientos de la tierra y mi derecha estiró los cielos. Los llamo y se presentan todos juntos."
,"14":"Reúnanse todos y escuchen: quién de toda esa gente les ha hecho este anuncio: 'Yavé quiere a ese hombre (a Ciro); éste es el que cumplirá sus deseos contra Babilonia y contra el pueblo de los caldeos.'"
,"15":"Yo, sí, yo he hablado, porque era yo quien lo llamaba y daba éxito a sus empresas."
,"16":"Acérquense a mí y oigan: desde el principio nunca hablé en secreto y desde que sucedieron estas cosas me tenían aquí. Sepan entonces que el Señor Yavé me ha enviado junto con su Espíritu."
,"17":"Así dice Yavé, el que te rescata, el Santo de Israel: 'Yo soy tu Dios y te enseño lo que te es provechoso, indicándote el camino que debes seguir."
,"18":"Si hubieras estado atento a mis leyes, la dicha te habría inundado como un río. Habrías sido fuerte como las olas del mar,"
,"19":"y tus hijos, numerosos como los granos de arena, y tu nombre no sería nunca arrancado o borrado de mi vista.'"
,"20":"'¡Salgan de Babilonia! ¡Huyan del país de los caldeos!' Griten esto alegremente, anúncienlo y transmítanlo hasta el último rincón del mundo. Digan: 'Yavé ha salvado a su servidor Jacob."
,"21":"No pasaron sed en los desiertos por los que los guió; para ellos sacó agua de la roca.'"
,"22":"Pero no hay paz para los malvados, dice Yavé."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Escúchenme, islas lejanas, pongan atención, pueblos. Yavé me llamó desde el vientre de mi madre, conoció mi nombre desde antes que naciera."
,"2":"Hizo de mi boca una espada cortante,y me guardó debajo de su mano. Hizo de mí una flecha puntiaguda,que tenía escondida entre las otras."
,"3":"El me dijo: 'Tú eres mi servidor, Israel, y por ti me daré a conocer.'"
,"4":"Mientras que yo pensaba: 'He trabajado en balde, en vano he gastado mis fuerzas, para nada.',Yavé, sin embargo, protegía mis derechos, mi Dios guardaba mi salario, pues soy importante para Yavé, y mi Dios se hizo mi fuerza."
,"5":"Y ahora ha hablado Yavé, que me formó desde el seno materno,para que fuera su servidor, para que le traiga a Jacob y le junte a Israel:"
,"6":"'No vale la pena que seas mi servidor,únicamente para restablecer a las tribus de Jacob, o traer sus sobrevivientes a su patria. Tú serás, además, una luz para las naciones, para que mi salvación llegue,hasta el último extremo de la tierra.'"
,"7":"Esto dice Yavé, el redentor y el Santo de Israel, al esclavo de los tiranos, al que es despreciado de todos y al que las naciones aborrecen: 'Los reyes, al ver lo que suceda, se levantarán, y los príncipes se inclinarán; porque el Santo de Israel, que te eligió, Yavé, ha cumplido su palabra.'"
,"8":"Yavé te asegura: En el momento oportuno te atendí, al día de la salvación, te socorrí. Quise que fueras la alianza del pueblo, que reconstruyeras el país, y entregaras a sus dueños las propiedades destruidas,"
,"9":"Dirás a los prisioneros: '¡Salgan!', a los que están en la oscuridad: 'Salgan a la luz.',A lo largo del camino pastarán y no les faltará el pasto ni en los cerros pelados. "
,"10":"No padecerán hambre ni sed, y no estarán expuestos al viento quemante ni al sol; pues el que se compadece de ellos los guiará y los llevará hasta donde están las vertientes de agua."
,"11":"Haré caminos a través de las montañas y pavimentaré los senderos.."
,"12":"Y ahora vuelven del país lejano, otros del norte y del oeste, aquéllos del sur de Egipto."
,"13":"¡Cielos, griten de alegría!,¡Tierra, alégrate!,Cerros, salten y canten de gozo,porque Yavé ha consolado a su pueblo,y se ha compadecido de los afligidos."
,"14":"Y Sión decía: 'Yavé me ha abandonado,y el Señor se ha olvidado de mí.'"
,"15":"Pero, ¿puede una mujer olvidarse del niño que cría, o dejar de querer al hijo de sus entrañas?,Pues bien, aunque alguna lo olvidase, yo nunca me olvidaría de ti."
,"16":"Mira cómo te tengo grabada,en la palma de mis manos. y nunca dejé de pensar en tus murallas:"
,"17":"ya llegan tus reconstructores, mientras que tus demoledores,y los que te arruinaron se van."
,"18":"Levanta tus ojos y mira en tu derredor: todos se juntan y vuelven a ti. Por mi vida, dice Yavé, que todos ellos serán como tu traje de gala,y los lucirás como una novia."
,"19":"Pues tus lugares abandonados, tus ciudades destruidas,y tu país arruinado,se harán estrechos para tantos habitantes, mientras que tus destructores se habrán ido."
,"20":"De nuevo te dirán al oído tus hijos, a los que nunca pensabas recuperar: 'Ese sitio se ha hecho chico para mí, dame otro donde pueda levantar mi casa.',Tú entonces te preguntarás:"
,"21":"'¿Quién me habrá dado a luz a toda esta gente?,Pues yo estaba sin hijos,y no los podía tener, estaba abandonada, en el exilio, ¿quién me los habrá criado?,Porque yo había quedado sola. Y éstos, ¿de dónde vienen ahora?'"
,"22":"El Señor Yavé te responde de esta manera: Hago señas con la mano a las naciones,y levanto mi bandera para que la vean los pueblos. Te traerán a tus hijos en brazos,y a tus hijas sobre los hombros."
,"23":"Los reyes serán tus padres adoptivos,y sus princesas tus niñeras. Se agacharán delante de ti hasta tocar el suelo,y besarán el polvo de tus pies. Entonces tú sabrás que Yo soy Yavé; y que nunca defraudo a los que esperan en mí."
,"24":"¿Se le puede quitar su parte a un soldado,o escapársele su prisionero al vencedor?"
,"25":"Sí, afirma Yavé: Le arrebatarán su prisionero al vencedor,y dejarán sin su parte al soldado. Al que contienda contigo, con él yo pelearé, y yo mismo salvaré a tus hijos."
,"26":"A tus opresores los haré comer su propia carne. y se emborracharán con su sangre como si fuese vino. Y todo mortal sabrá que yo, Yavé, soy tu Salvador,y que tu Redentor es el Campeón de Jacob."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Así habla Yavé: ¿Acaso despedí a su madre? ¡Muéstrenme el certificado de divorcio!"
,"2":"O bien, ¿a quién debo yo dinero, y a quién los he vendido? Por culpa de sus pecados fueron vendidos y por sus infidelidades me divorcié de su madre. ¿Por qué, cuando llegué, no encontré a nadie, y cuando llamé, nadie me respondió? ¿Se me habrá acortado el brazo, que no alcanza a salvar, o será que ya no tengo fuerzas? Con un solo gesto dejo seco el mar y cambio los ríos en desiertos. Sus peces, sin agua, quedan en seco y mueren de sed. "
,"3":"Pinto a los cielos de negro y los visto de luto."
,"4":"El Señor Yavé me ha concedido,el poder hablar como su discípulo. Y ha puesto en mi boca las palabras,para fortalecer al que está aburrido. A la mañana él despierta mi mente,y lo escucho como lo hacen los discípulos."
,"5":"El Señor Yavé me ha abierto los oídos,y yo no me resistí ni me eché atrás."
,"6":"He ofrecido mi espalda a los que me golpeaban, mis mejillas a quienes me tiraban la barba, y no oculté mi rostro ante las injurias y los escupos."
,"7":"El Señor Yavé está de mi parte, y por eso no me molestan las ofensas; por eso, puse mi cara dura como piedra. y yo sé que no quedaré frustrado,"
,"8":"Aquí viene mi juez, ¿quieren meterme pleito?,Presentémonos juntos, y si hay algún demandante, ¡que se acerque!"
,"9":"Si el Señor Yavé está de mi parte, ¿quién podrá condenarme?,Todos se harán tiras como un vestido gastado, y la polilla se los comerá."
,"10":"Quien de ustedes respeta a Yavé, escuche la voz de su servidor. El que camina a oscuras, sin luz para alumbrarse, que confíe en el Nombre de Yavé, y que se apoye en su Dios."
,"11":"Pero todos ustedes que encienden un fuego,y que forman un círculo con antorchas, ¡vayan a las llamas de su hoguera,y que sus antorchas los quemen!,Ustedes se revolverán en sus tormentos,y esto será la obra de mis manos."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Escúchenme ustedes, que anhelan la justicia,y que buscan a Yavé."
,"2":"Vuelvan a su origen, miren la roca, la cantera de donde fueron sacados; miren a Abraham, su padre, y a Sara, que los dio a luz. Era uno solo cuando lo llamé, pero lo bendije y se multiplicó."
,"3":"Pues bien, Yavé se ha compadecido de Sión,y ahora quiere dar vida a sus ruinas, transformar su soledad en un Paraíso,y su sequedad en un jardín de Yavé. Entonces se lo agradecerán, tocando música,y lanzando vivas de entusiasmo y de alegría."
,"4":"Pueblos, pónganme atención, y escúchenme, naciones, porque de mí saldrá la Ley,y mis sentencias que serán la luz de los pueblos."
,"5":"Mi justicia está por llegar; ya he mandado mi salvación,y aquí vengo yo para gobernar a los pueblos. Las islas también esperan en mí,y cuentan con mi intervención."
,"6":"Levanten los ojos al cielo,y miren después al suelo. Miren que los cielos se derriten y se hacen humo,y la tierra se deshace como la ropa,mientras sus habitantes mueren como moscas. Pero mi salvación durará para siempre,y mi justicia nunca se acabará."
,"7":"Atiéndanme, ustedes que andan derecho, pueblo mío que tienes mi ley en tu corazón. No teman las injurias de los hombres,ni se desmoralicen por sus insultos."
,"8":"Porque la polilla los roerá como ropa, y sus larvas se los comerán como lana. Pero mi justicia durará para siempre,y mi salvación seguirá de siglos en siglos."
,"9":"¡Despiértate, despiértate con toda tu fuerza, brazo de Yavé! Despiértate como pasó antes, en los tiempos antiguos. ¿No eres tú quien destrozó a Rahab y traspasó al dragón?"
,"10":"¿No eres tú el que secó el mar y las aguas profundas, e hiciste del fondo del mar un camino para que pasaran los que rescatabas?"
,"11":"Así volverán los que ha salvado Yavé. Entrarán a Sión entre gritos de alegría, una dicha imperecedera hará brillar sus rostros. ¡Alegría y felicidad los acompañarán, y lejos quedarán las penas y los suspiros!"
,"12":"Yo, yo soy el que te consuela. ¿Por qué tienes miedo a los hombres que mueren, a un hijo de hombre que desaparecerá como el pasto?"
,"13":"¿Acaso te has olvidado de Yavé, que te creó, que extendió los cielos y que fundó la tierra? Pues te lo pasas siempre asustado al ver la rabia del tirano, que trata, por todos los medios, de destruirte. Pero, ¿dónde está ahora su rabia? "
,"14":"Muy pronto saldrá en libertad el prisionero; no morirá en el calabozo, ni le faltará más el pan."
,"15":"Yo soy Yavé, tu Dios, que muevo el mar y hago rugir sus olas, mi nombre es Yavé de los Ejércitos."
,"16":"Cuando estaba estirando los cielos y echando los cimientos de la tierra, coloqué mis palabras en tu boca y te escondí bajo mi mano. Y dije a Sión: 'Tú eres mi pueblo.'"
,"17":"¡Despierta, despierta, levántate, Jerusalén! Tú que te serviste de la misma mano de Yavé la copa que contenía su enojo y que hace perder los sentidos, te la tomaste hasta dejarla vacía."
,"18":"Ella, que tuvo tantos hijos, no tiene ni uno para que la lleve; y, de todos los hijos que crió, no queda nadie para que la sostenga."
,"19":"¿Quién te dará el pésame por estas dos desgracias que te han ocurrido: saqueo y ruina, hambre y espada?"
,"20":"Has visto a tus hijos tirados, sin fuerzas, en las esquinas de las calles, como un antílope en una trampa, desmayados por el enojo de Yavé, por las amenazas de tu Dios."
,"21":"Por esto, óyeme, infeliz, que te has embriagado con algo que no es vino."
,"22":"Así te habla tu Señor, Yavé, tu Dios, defensor de tu pueblo: Yo quito de tu mano la copa que hace perder los sentidos, la copa de mi enojo; tú ya no volverás a tomarla."
,"23":"Yo se la pasaré a tus opresores que decían: Agáchate, para que pasemos por encima. Y tu espalda quedó como un camino por donde pasaba la gente."
}`)
	CurrentBook.AddChapter(52, `{
"1":"¡Despierta, despierta, levántate, Sión! Vístete de fiesta, Jerusalén, Ciudad Santa. Ya no volverá a entrar en ti ni el incircunciso ni el impuro."
,"2":"¡Sacude el polvo! ¡Levántate, Jerusalén, tú que estabas cautiva, y desata las ligaduras de tu cuello, Hija de Sión!"
,"3":"Sí, así se expresa Yavé: Así, como ustedes fueron gratuitamente vendidos, así serán comprados sin plata."
,"4":"Sí, lo asegura Yavé, mi pueblo bajó, primero, a Egipto para instalarse allí, y después cayó bajo la violenta opresión de Asur."
,"5":"Y ahora, ¿qué hago yo aquí?, se pregunta Yavé, mientras mi pueblo ha sido hecho esclavo gratuitamente, sus opresores lanzan gritos de triunfo, y continuamente, a lo largo del día, mi nombre es despreciado."
,"6":"Pues bien, mi pueblo conocerá mi Nombre, y sabrá entonces quién dijo: '¡Aquí estoy!'"
,"7":"Qué bien venidos, por los montes, los pasos del que trae buenas noticias, que anuncia la paz, que trae la felicidad, que anuncia la salvación, y que dice a Sión: '¡Ya reina tu Dios!'"
,"8":"Escucha, tus centinelas alzan la voz,y juntos gritan jubilosos, por lo que han visto con sus propios ojos: ¡Yavé regresando a Sión!"
,"9":"Griten de alegría, ruinas de Jerusalén, porque Yavé se ha compadecido de su pueblo,y ha rescatado a Jerusalén."
,"10":"Yavé, el Santo, se ha arremangado su brazo a la vista de las naciones, y han visto, hasta los extremos del mundo, la salvación de nuestro Dios."
,"11":"¡Apártense!, ¡apártense! salgan de aquí, y déjense de tocar cosas impuras. Salgan de Babilonia y purifíquense,ustedes que llevan los vasos sagrados de Yavé."
,"12":"No saldrán a la carrera, ni partirán como que vienen huyendo, pues al frente de ustedes irá Yavé, y el Dios de Israel les protegerá las espaldas."
,"13":"Ahora llega para mi servidor la hora del éxito; será exaltado, y puesto en lo más alto."
,"14":"Así como muchos quedaron espantados al verlo, pues estaba tan desfigurado, que ya no parecía un ser humano"
,"15":"así también todas las naciones se asombrarán, y los reyes quedarán sin palabras al ver lo sucedido, pues verán lo que no se les había contado,y descubrirán cosas que nunca se habían oído."
}`)
	CurrentBook.AddChapter(53, `{
"1":"¿Quién podrá creer la noticia que recibimos?,Y la obra mayor de Yavé, ¿a quién se la reveló?"
,"2":"Este ha crecido ante Dios como un retoño, como raíz en tierra seca. No tenía brillo ni belleza para que nos fijáramos en él, y su apariencia no era como para cautivarnos."
,"3":"Despreciado por los hombres y marginado, hombre de dolores y familiarizado con el sufrimiento, semejante a aquellos a los que se les vuelve la cara, no contaba para nada y no hemos hecho caso de él."
,"4":"Sin embargo, eran nuestras dolencias las que él llevaba, eran nuestros dolores los que le pesaban. Nosotros lo creíamos azotado por Dios, castigado y humillado,"
,"5":"y eran nuestras faltas por las que era destruido,nuestros pecados, por los que era aplastado. El soportó el castigo que nos trae la paz,y por sus llagas hemos sido sanados."
,"6":"Todos andábamos como ovejas errantes, cada cual seguía su propio camino, y Yavé descargó sobre él la culpa de todos nosotros."
,"7":"Fue maltratado y él se humilló y no dijo nada, fue llevado cual cordero al matadero, como una oveja que permanece muda cuando la esquilan."
,"8":"Fue detenido, enjuiciado y eliminado,¿y quién ha pensado en su suerte?,Pues ha sido arrancado del mundo de los vivos,y herido de muerte por los crímenes de su pueblo."
,"9":"Fue sepultado junto a los malhechores,y su tumba quedó junto a los ricos, a pesar de que nunca cometió una violencia,ni nunca salió una mentira de su boca."
,"10":"Quiso Yavé destrozarlo con padecimientos, y él ofreció su vida como sacrificio por el pecado. Por esto verá a sus descendientes y tendrá larga vida, y el proyecto de Dios prosperará en sus manos."
,"11":"Después de las amarguras que haya padecido su alma, gozará del pleno conocimiento. El Justo, mi servidor, hará una multitud de justos, después de cargar con sus deudas."
,"12":"Por eso, le daré en herencia muchedumbres,y lo contaré entre los grandes, porque se ha negado a sí mismo hasta la muerte,y ha sido contado entre los pecadores, cuando llevaba sobre sí los pecados de muchos,e intercedía por los pecadores."
}`)
	CurrentBook.AddChapter(54, `{
"1":"¡Grita de júbilo, oh tú, que estabas estéril,y que no dabas a luz; grita de júbilo y alegría, tú que no esperabas!,Pues mira a los hijos de la abandonada, más numerosos que los de la casada, dice Yavé."
,"2":"Ensancha el espacio de tu tienda, sin demora despliega tus toldos, alarga tus cuerdas y refuerza tus estacas;"
,"3":"porque te extenderás a derecha y a izquierda. Tu descendencia conquistará las naciones,y repoblará las ciudades desiertas."
,"4":"No temas, pues no vas a ser defraudada, no tengas vergüenza, pues no tendrás de qué ponerte colorada. Te olvidarás de las vergüenzas de tu juventud,y de los desprecios que te hicieron cuando viuda."
,"5":"Pues ahora te desposa tu creador, Yavé de los Ejércitos es su nombre. El que te rescata es el Santo de Israel, quien se llama Dios de toda la tierra."
,"6":"Sí, Yavé te llama como a la esposa abandonada, que se encuentra afligida. ¿Se puede rechazar la esposa que uno toma siendo joven?, dice tu Dios."
,"7":"Te había abandonado un momento, pero con inmensa piedad yo te vengo a reunir."
,"8":"En unos momentos de ira te oculté mi rostro, pero con amor que no tiene fin me apiado de ti -dice Yavé, que te viene a rescatar."
,"9":"Voy a hacer como en el diluvio de Noé, cuando juré que las aguas no pasarían más sobre la tierra. Así, juro yo no enojarme más contigo ni amenazarte nunca más."
,"10":"Los cerros podrán correrse,y bambolearse las lomas; mas yo no retiraré mi amor, y mi alianza de paz contigo no se bamboleará,-dice Yavé, que se compadece de ti."
,"11":"¡Pobrecilla, azotada por la tempestad y sin consuelo!,Yo asentaré tus muros sobre piedras preciosas, y serán tus cimientos de zafiro."
,"12":"Haré tus murallas de rubíes, tus puertas de cristal, y todo tu contorno de piedras preciosas."
,"13":"Todos tus hijos serán instruidos por Yavé, y grande será la felicidad de tus hijos."
,"14":"Te mantendrás firme por la justicia,y no tendrás que temer la opresión; el terror no se te acercará."
,"15":"Si alguien te ataca, no será de parte mía; el que se lance contra ti, ante ti caerá."
,"16":"Mira, yo he creado al herrero que mantiene el fuego de la fragua con el fuelle, y saca de allí las armas que debe forjar. Pero también he sido yo quien ha creado al destructor que las va a romper."
,"17":"Ningún arma que hayan forjado contra ti resultará, y harás callar a cualquiera que te acuse. Este es el premio para los servidores de Yavé y la victoria que les garantizo, dice Yavé."
}`)
	CurrentBook.AddChapter(55, `{
"1":"A ver ustedes que andan con sed, ¡vengan a las aguas!,No importa que estén sin plata, vengan; pidan trigo sin dinero, y coman, pidan vino y leche, sin pagar."
,"2":"¿Para qué van a gastar en lo que no es pan,y dar su salario por cosas que no alimentan?,Si ustedes me hacen caso, comerán cosas ricas,y su paladar se deleitará con comidas exquisitas."
,"3":"Atiéndanme y acérquense a mí, escúchenme y su alma vivirá. Voy a hacer con ustedes una alianza para siempre, para darles los bienes que tengo prometidos a David."
,"4":"Mira, lo había puesto como un testigo para varios pueblos, como un jefe para mandar a las naciones."
,"5":"Así, tú ahora vas a llamar a una nación que no conocías, una nación que no te conocía correrá por verte. Esto será nada más que por Yavé, tu Dios, por el Santo de Israel, que te ha puesto arriba."
,"6":"Busquen a Yavé ahora que lo pueden encontrar, llámenlo ahora que está cerca."
,"7":"Que el malvado deje sus caminos, y el criminal sus proyectos; vuélvanse a Yavé, que tendrá piedad de ellos, a nuestro Dios, que está siempre dispuesto a perdonar."
,"8":"Pues sus proyectos no son los míos, y mis caminos no son los mismos de ustedes, dice Yavé."
,"9":"Así, como el cielo está muy alto por encima de la tierra, así también mis caminos se elevan por encima de sus caminos,y mis proyectos son muy superiores a los de ustedes."
,"10":"Como baja la lluvia y la nieve de los cielos,y no vuelven allá sin haber empapado la tierra, sin haberla fecundado y haberla hecho germinar, para que dé la simiente para sembrar y el pan para comer,"
,"11":"así será la palabra que salga de mi boca. No volverá a mí con las manos vacías,sino después de haber hecho lo que yo quería, y haber llevado a cabo lo que le encargué."
,"12":"Sí, ustedes partirán con alegría, y serán traídos con toda seguridad. Cerros y lomas, a sus pasos, gritarán de alegría, y todos los árboles batirán las palmas."
,"13":"En lugar del espino crecerá el ciprés, y el mirto, en vez de las ortigas. Y esto le dará fama a Yavé, pues será una señal que nunca se borrará."
}`)
	CurrentBook.AddChapter(56, `{
"1":"Así dice Yavé: Actúen correctamente y hagan siempre lo debido, pues mi salvación se viene acercando y mi justicia está a punto de aparecer."
,"2":"Feliz el hombre que siempre se comporta así, sin desmayar, que se fija en no profanar el sábado y trata de no hacer algo malo."
,"3":"Que el extranjero, que se ha puesto al lado de Yavé, no diga: 'Con toda certeza Yavé me dejará afuera de su pueblo.' Ni tampoco afirme el castrado: 'Yo no soy más que un árbol seco.'"
,"4":"Pues esto dice Yavé a los castrados que observan sus sábados, que hacen lo que le gusta y que no faltan a su compromiso con él:"
,"5":"'Les daré dentro de los muros de mi Casa un lugar y una consideración que tendrán más valor que hijos e hijas; les daré una fama que nunca se olvidará.'"
,"6":"Y a los extranjeros que se han puesto de parte de Yavé, para obedecerle, amar su Nombre y ser sus servidores, que tratan de no profanar el sábado y que cumplen fielmente su compromiso conmigo,"
,"7":"los llevaré a mi cerro santo y haré que se sientan felices en mi Casa de oración. Serán aceptados los holocaustos y los sacrificios que hagan sobre mi altar, ya que mi casa será llamada Casa de oración para todos los pueblos."
,"8":"Esto dice el Señor Yavé, que reúne a todos los israelitas que estaban dispersos: Agregaré todavía más gente a todos los que ya se habían juntado."
,"9":"Animales del campo,y de la selva, acérquense a devorar."
,"10":"¡Esos cuidadores están todos ciegos, no saben nada! Son todos como perros mudos, que no pueden ladrar. Tendidos en sus lechos, no hacen más que dormir y soñar."
,"11":"A pesar de que hacen de pastores, son perros hambrientos que no se llenan con nada. Son gente incapaz de comprender. Cada uno sigue su propio camino, o busca su propio interés: "
,"12":"'¡Vengan!, voy a ir a buscar vino; o mejor, emborrachémonos con licor, pues mañana será como hoy o tal vez habrá mucho más!'"
}`)
	CurrentBook.AddChapter(57, `{
"1":"El hombre honrado es asesinado y nadie toma la cosa en serio. Los hombres fieles son eliminados, y nadie entiende que si desaparecen, es para que no vean las desgracias: "
,"2":"descansan en paz."
,"3":"Y ustedes, vengan para acá, hijos de bruja, familia de adúltera y de prostituta."
,"4":"¿De quién se están riendo?,¿A quién le hacen morisquetas y le sacan la lengua?,¿No son ustedes hijos del pecado y descendientes de la mentira,"
,"5":"ustedes que se calientan a la sombra de los arrayanes,o bajo cualquier árbol frondoso; que sacrifican niños en las quebradas, en el hueco de alguna roca?"
,"6":"Ustedes escogen piedras parejas en el torrente, las que pasan a ser sus dioses. Sobre ellas derraman vino,y presentan sus ofrendas. ¿Acaso me sentiré bien con esas cosas?"
,"7":"En un lugar elevado instalaste tu cama; y hasta allí subiste para ofrecer sacrificios."
,"8":"Detrás de la puerta y a la entrada,colocaste tu ídolo. Sí, lejos de mí preparaste tu cama, te subiste a ella para tu lujuria. Tú has gozado de esa gente,con que te gusta acostarte,y cuyos ídolos seducen tus ojos."
,"9":"Tú acudiste al Moloc con aceites,y le ofreciste perfumes; por él mandaste mensajeros muy lejos: esos niños que has enviado a donde los muertos."
,"10":"Te has cansado de tanto caminar, pero no dijiste: 'No sigo más', pues renovabas tus energías, y no te agotaste."
,"11":"¿Quién te asustó y a quién tuviste miedo, para traicionarme así ?,No te acordabas, ni hacías caso de mí. Yo, ¿no fue así?, me hice el desentendido, como que no había visto nada, por eso tú no me tuviste miedo."
,"12":"Mas, ahora, voy a denunciar tu buena conducta y tus acciones que no te sirvieron para nada."
,"13":"Cuando pidas auxilio, ¡que te salven tus ídolos despreciables! El viento se los llevará a todos, desaparecerán de un soplo. Pero aquel que confía en mí poseerá el país y será dueño de mi Cerro Santo."
,"14":"Entonces dirán: ¡Abran, abran, despejen la ruta! ¡Quiten todos los obstáculos del camino, por donde va mi pueblo!"
,"15":"Pues así habla el Altísimo, que vive en su morada eterna, y cuyo Nombre es santo: 'Yo vivo en lo alto y me quedo en mi santidad, pero también estoy con el hombre arrepentido y humillado, para reanimar el espíritu de los humildes y a los de corazón quebrantado."
,"16":"No voy a reclamar sin fin ni seguiré más enojado; pues a causa de mí se desmayarían el espíritu y las almas que yo he creado."
,"17":"Corría tras las ganancias injustas; me enojé por un momento, le pegué y en mi enojo le escondí mi cara. Pues él, rebelde, no hacía más que seguir las indicaciones de su corazón,"
,"18":"y yo vi su conducta. Pero yo le devolveré la salud, lo alentaré y lo ayudaré a recuperarse. Y a los que están de duelo "
,"19":"haré que les brote la risa de sus labios: ¡Paz, paz al que está lejos y al que está cerca!, dice Yavé. Sí, yo te voy a sanar.'"
,"20":"Pero los malvados son como un mar con tormentas, que no puede calmarse, y cuyas aguas revuelven el fango y el barro."
,"21":"'No hay paz para los malvados', dice mi Dios."
}`)
	CurrentBook.AddChapter(58, `{
"1":"Grita con fuerza y sin miedo. Levanta tu voz como trompeta y denuncia a mi pueblo sus maldades, y sus pecados a la familia de Jacob."
,"2":"Según dicen, me andan buscando día a día y se esfuerzan por conocer mis caminos, como una nación que practica la justicia y no descuida las órdenes de su Dios. Vienen a preguntarme cuáles son sus obligaciones y desean la amistad de Dios."
,"3":"Y se quejan: '¿Por qué ayunamos y tú no lo ves, nos humillamos y tú no lo tomas en cuenta?',Porque en los días de ayuno ustedes se dedican a sus negocios y obligan a trabajar a sus obreros. "
,"4":"Ustedes ayunan entre peleas y contiendas, y golpean con maldad. No es con esta clase de ayunos que lograrán que se escuchen sus voces allá arriba."
,"5":"¿Cómo debe ser el ayuno que me gusta, o el día en que el hombre se humilla? ¿Acaso se trata nada más que de doblar la cabeza como un junco o de acostarse sobre sacos y ceniza? ¿A eso llamas ayuno y día agradable a Yavé?"
,"6":"¿No saben cuál es el ayuno que me agrada? Romper las cadenas injustas, desatar las amarras del yugo, dejar libres a los oprimidos y romper toda clase de yugo."
,"7":"Compartirás tu pan con el hambriento, los pobres sin techo entrarán a tu casa, vestirás al que veas desnudo y no volverás la espalda a tu hermano."
,"8":"Entonces tu luz surgirá como la aurora y tus heridas sanarán rápidamente. Tu recto obrar marchará delante de ti y la Gloria de Yavé te seguirá por detrás."
,"9":"Entonces, si llamas a Yavé, responderá. Cuando lo llames, dirá: 'Aquí estoy.',Si en tu casa no hay más gente explotada, si apartas el gesto amenazante y las palabras perversas; "
,"10":"si das al hambriento lo que deseas para ti y sacias al hombre oprimido, brillará tu luz en las tinieblas, y tu oscuridad se volverá como la claridad del mediodía."
,"11":"Yavé te confortará en cada momento, en los lugares desérticos te saciará. El rejuvenecerá tus huesos y serás como huerto regado, cual manantial de agua inagotable."
,"12":"Volverás a edificar sobre las ruinas antiguas y reconstruirás sobre los cimientos del pasado; y todos te llamarán: El que repara sus muros, el que arregla las casas en ruinas."
,"13":"Si te preocupas de no caminar en día sábado ni de tratar tus negocios en el día santo; si tú llamas al sábado 'Delicioso', y 'Venerable' al día consagrado a Yavé; si tú lo veneras, evitando los viajes, no haciendo tus negocios ni arreglando, ese día, tus asuntos,"
,"14":"entonces, te sentirás feliz con Yavé. Yo te llevaré por las cumbres de la tierra, y te mantendré con la propiedad de tu padre Jacob; la boca de Yavé te lo asegura."
}`)
	CurrentBook.AddChapter(59, `{
"1":"No, no es que el brazo de Yavé no alcance a salvar, ni que su oído esté demasiado sordo para oír."
,"2":"Sino que sus maldades de ustedes,han cavado un abismo entre ustedes y su Dios. Sus pecados han hecho que él vuelva su cara para no atenderlos."
,"3":"Pues las manos de ustedes están manchadas de sangre, y sus dedos, de crímenes. Sus labios pronuncian la mentira,y su lengua murmura la falsedad."
,"4":"Nadie acusa con justa razón, ni reclama con sinceridad. Toman pie de un pretexto, y andan con mentiras, conciben un mal proyecto y dan a luz la maldad."
,"5":"Se echan sobre huevos de víboras,y tejen telarañas; el que come sus huevos, muere, y si los aplastan, salen culebritas."
,"6":"Uno no se puede vestir con sus telas, y no se vestirán con sus obras. Pues lo que hacen son obras criminales, y es sólo violencia lo que sale de sus manos."
,"7":"Con sus pies corren al mal,y se apresuran en derramar la sangre inocente. Sus proyectos son proyectos asesinos, por donde pasan, sólo dejan ruina y calamidades."
,"8":"No conocen el camino de la paz,y la justicia no se encuentra en sus empresas. Todo es chueco en sus caminos, y el que allí se mete no anda tranquilo."
,"9":"Por eso, la justicia no se acerca a nosotros,y no nos llega la salvación. Esperábamos la luz y sólo hay tinieblas; la claridad, y andamos a oscuras."
,"10":"Palpamos las paredes como ciegos,y caminamos con miedo, como los que no ven. Tropezamos al mediodía como si fuera de noche, y en la fuerza de la edad, ya somos como muertos."
,"11":"Todos nosotros gruñimos como osos,y gemimos como palomas. Esperábamos que nos hicieran justicia, pero nada, o que llegara nuestra salvación, pero permanece lejos de nosotros."
,"12":"Pues a menudo te hemos sido infieles, y nuestras propias faltas nos acusan. En efecto, tenemos siempre presentes nuestros pecados,y reconocemos nuestros yerros:"
,"13":"la rebelión e hipocresía para con Yavé, y la infidelidad a nuestro Dios, nuestras traiciones y revueltas,y nuestros pensamientos y juicios injustos."
,"14":"Se ha expulsado al derecho, así que la justicia no pudo acercarse; la verdad ha sido maltratada en el tribunal,y la rectitud ya no tuvo allí acceso."
,"15":"La verdad ya no existe, y el que se aparta del mal es despojado. Lo vio Yavé y no le gustó que no hubiera justicia. "
,"16":"Vio que no había nadie y se sorprendió de que nadie interviniera. Entonces intervino personalmente y con la fuerza de su justicia,"
,"17":"Se puso la justicia como coraza y se colocó en su cabeza su casco que es la salvación. Se vistió con la venganza como si fuese túnica y se arropó con el celo como un chal."
,"18":"A cada uno le va a dar su merecido: enojo para sus adversarios y castigo para sus enemigos."
,"19":"Los del occidente han conocido su Nombre, y los del oriente, su Gloria, pues llega como un torrente encajonado, empujado por un soplo de Yavé."
,"20":"Para Sión, en cambio, y para todos los habitantes de Jacob que hayan vuelto de sus pecados, vendrá como Redentor."
,"21":"Por lo que a mí me toca, dice Yavé, ésta será la alianza que hago con ellos: Mi espíritu, que ha venido sobre ti, y mis palabras que he puesto en tu boca, no se alejarán de tu boca ni de la boca de tus hijos o de tus nietos, desde ahora en adelante y para siempre, afirma Yavé."
}`)
	CurrentBook.AddChapter(60, `{
"1":"Levántate y brilla, que ha llegado tu luz,y la Gloria de Yavé amaneció sobre ti."
,"2":"Mientras las tinieblas cubrían la tierra,y los pueblos estaban en la noche, sobre ti se levantó Yavé, y sobre ti apareció su Gloria."
,"3":"Los pueblos se dirigen hacia tu luz,y los reyes, al resplandor de tu aurora."
,"4":"Levanta los ojos a tu alrededor y contempla: todos se reúnen y vienen a ti; tus hijos llegan de lejos y tus hijas son traídas en brazos."
,"5":"Tú entonces, al verlo, te pondrás radiante, palpitará tu corazón muy emocionado; traerán a ti tesoros del otro lado del mar,y llegarán a ti las riquezas de las naciones."
,"6":"Te inundará una multitud de camellos: llegarán los de Madián y Efá. Los de Sabá vendrán todos,trayendo oro e incienso, y proclamando las alabanzas de Yavé."
,"7":"Todos los rebaños de Cedar se reunirán junto a ti, y los carneros de Nebayot serán tuyos,para ser ofrecidos en mi altar, pues quiero dar esplendor al templo de mi Gloria."
,"8":"Oh, ¿quiénes son ésos, una nube de palomas que vuelan a su palomar?"
,"9":"¡Pero si las islas ahora creen en mí!,mira cómo los barcos de Tarsis acuden, trayendo de lejos a tus hijos, con su plata y su oro, a causa del Nombre de Yavé, tu Dios, del Santo de Israel que te ha glorificado."
,"10":"Los extranjeros reedificarán tus muros,y sus reyes te pagarán los gastos. Pues si bien cuando estuve enojado te pegué, llevado por mi buen corazón, me compadecí de ti."
,"11":"Tus puertas estarán siempre abiertas, no se cerrarán ni de día ni de noche, para recibir las riquezas de las naciones que te traerán sus mismos reyes."
,"12":"El país o el reino que no quiera obedecerte, perecerá, y las naciones serán destruidas totalmente."
,"13":"A ti llegará lo mejor del Líbano, con el ciprés, el olmo y el alerce, para adornar mi Lugar Santo y honrar la Casa donde yo resido."
,"14":"Vendrán a verte y se inclinarán ante ti los hijos de los que te humillaban, y se echarán a tus pies los que te despreciaban. Te llamarán: 'Ciudad de Yavé', 'Sión del Santo de Israel'."
,"15":"Ya que tú fuiste la abandonada, la odiada y desamparada, en adelante yo haré que te sientas orgullosa, y te daré alegría para siempre."
,"16":"Te alimentarás con la leche de las naciones y serás amamantada con la riqueza de los reyes. Y conocerás, entonces, que yo, Yavé, soy tu Redentor, y que el Campeón de Jacob es tu Salvador."
,"17":"En vez de bronce, traeré oro; en vez de hierro, plata; en vez de madera, bronce, y en vez de piedra, hierro. Como gobernantes te pondré la paz, y en vez de opresión, la justicia."
,"18":"Ya no se hablará de violencia en tu país ni de saqueo o calamidades dentro de tus fronteras. A tus murallas les pondrás por nombre 'Salvación', y a tus puertas, 'Alabanza'."
,"19":"Ya no tendrás necesidad del sol para que alumbre tu día, ni de la luna para la noche. Porque Yavé será tu luz eterna, y tu Dios, tu esplendor."
,"20":"Tu sol no se pondrá jamás, y tu luna no desaparecerá más, porque Yavé será tu luz perpetua y se habrán acabado tus días de luto."
,"21":"No habrá sino buenos en tu pueblo y siempre poseerán mi tierra. Serán el brote nuevo que Yavé hizo crecer y la obra que mis manos hicieron en honor mío."
,"22":"El más chico de tus habitantes se multiplicará en mil y el más insignificante se convertirá en una gran nación. Yo, Yavé, lo haré en un momento, cuando sea la hora."
}`)
	CurrentBook.AddChapter(61, `{
"1":"¡El Espíritu del Señor Yavé está sobre mí!,sepan que Yavé me ha ungido. Me ha enviado con un buen mensaje para los humildes, para sanar los corazones heridos, para anunciar a los desterrados su liberación, y a los presos su vuelta a la luz."
,"2":"Para publicar un año feliz lleno de los favores de Yavé, y el día del desquite de nuestro Dios. Me envió para consolar a los que lloran"
,"3":"y darles (a todos los afligidos de Sión),una corona en vez de ceniza, el aceite de los días alegres, en lugar de ropa de luto, cantos de felicidad, en vez de pesimismo. Les pondrán el sobrenombre de 'Encinas de Justicia', 'los que Yavé plantó para su gloria'. "
,"4":"Reconstruirán las viejas ruinas, levantarán de nuevo los edificios caídos del pasado, restaurarán las ciudades en ruinas, las construcciones que permanecen por siglos destruidas."
,"5":"Vendrán extranjeros a cuidar de sus rebaños y a trabajar en sus campos y en sus viñas."
,"6":"Y ustedes serán llamados 'sacerdotes de Yavé' y los nombrarán 'ministros de nuestro Dios'. Ustedes vivirán a expensas de las naciones y se aprovecharán de su lujo."
,"7":"Por haber sido tan grande su humillación y no haberles tocado más que insultos, su suerte se restablecerá. Recibirán en el país de ellos el doble de todo y nunca se terminará su felicidad."
,"8":"Pues como yo, Yavé, amo la justicia y odio el robo y el crimen, les entregaré sin falta su recompensa y haré con ellos un contrato que durará siempre."
,"9":"Sus hijos se harán famosos entre las naciones y sus nietos, en medio de los pueblos. Todos los que los vean reconocerán que son una raza bendecida de Yavé."
,"10":"Salto de alegría delante de Yavé, y mi alma se alegra en mi Dios, pues él me puso ropas de salvación,y me abrigó con el chal de la justicia, como el novio se coloca su corona, o como la esposa se arregla con sus joyas."
,"11":"Pues así como brotan de la tierra las semillas o como aparecen las plantitas en el jardín, así el Señor Yavé hará brotar la justicia y la alabanza a la vista de todas las naciones."
}`)
	CurrentBook.AddChapter(62, `{
"1":"Por amor a Sión no me callaré, por Jerusalén no quedaré tranquilo hasta que su justicia se haga claridad y su salvación brille como antorcha."
,"2":"Verán tu justicia las naciones, y los reyes contemplarán tu gloria y te llamarán con tu nombre nuevo, el que Yavé te habrá dado."
,"3":"Y serás una corona preciosa en manos de Yavé, un anillo real en el dedo de tu Dios."
,"4":"No te llamarán más 'Abandonada', ni a tu tierra 'Desolada', sino que te llamarán 'Mi preferida' y a tu tierra 'Desposada'. Porque Yavé se complacerá en ti y tu tierra tendrá un esposo."
,"5":"Como un joven se casa con una muchacha virgen, así el que te reconstruyó se casará contigo, y como el esposo goza con su esposa, así harás las delicias de tu Dios."
,"6":"Sobre tus murallas, Jerusalén, he puesto centinelas,para que estén alerta día y noche. Ustedes, que deben recordárselo a Yavé, no se queden allí parados,"
,"7":"ni lo dejen tranquilo, hasta que restaure a Jerusalén,y la ponga en un trono de honor en medio de la tierra."
,"8":"Yavé lo ha jurado por su mano derecha,y por su forzudo brazo: 'Ya no entregaré más tu trigo, y tus enemigos no se lo comerán; los extranjeros no tomarán más tu vino, que tanto te costó producir,"
,"9":"sino que los mismos que cosechen el trigo, lo comerán y alabarán a Yavé. Y los que vendimien se tomarán el vino, en los corredores de mi santuario.'"
,"10":"¡Pasen, pasen por las puertas!,¡Abranle camino al pueblo!,¡Arreglen, arreglen la carretera!,¡Déjenla limpiecita, sin una piedra!,Pongan en lo alto la bandera,para que todos los pueblos la vean."
,"11":"Pues Yavé lanza una proclamación, que la oigan hasta en el último rincón de la tierra: 'Díganle a la hija de Sión: Mira cómo ya llega tu Salvador. Anda trayendo el premio por su victoria,y delante de él van sus trofeos."
,"12":"Entonces los llamarán a ustedes 'Pueblo Santo', 'Rescatados por Yavé', y a ti te dirán 'La deseada', 'Ciudad no Abandonada'."
}`)
	CurrentBook.AddChapter(63, `{
"1":"¿Quién es ese que viene de Edom, que llega de Bosrá, vestido de rojo?,¿Quién es ése del vestido esplendoroso, y de andar majestuoso?,'Soy yo que hablo de justicia,y soy poderoso para salvar.'"
,"2":"¿Por qué es rojo tu vestido, y tu ropa manchada como la del que pisa en el lagar?"
,"3":"En el lagar he pisado yo solo, y nadie de mi pueblo estaba conmigo. Sí, los he pisado con rabia,y los he pisoteado con furor, su jugo salpicó mis vestidos,y he manchado toda mi ropa."
,"4":"Porque había preparado el día de mi desquite,y el año de mi venganza había llegado."
,"5":"Miré a mi alrededor y me asombré: no había quién me ayudara. Así, es que no conté más que con mi brazo,y mi enojo me dio fuerzas."
,"6":"Aplasté con rabia a los pueblos, los quebré con furia, e hice correr su jugo por la tierra."
,"7":"Yo quiero felicitar a Yavé por sus favores,y cantar sus alabanzas, por todo lo que ha hecho por nosotros, por la gran bondad que demostró a Israel, que nos demostró al compadecerse de nosotros,y darnos tantos beneficios."
,"8":"Dijo: 'En realidad son mi pueblo, hijos que no me harán traición.',Y se hizo su salvador "
,"9":"en todas sus pruebas. No era un delegado ni un ángel, sino él mismo, quien los salvaba. Lleno de amor y de piedad, él mismo los rescataba; se encargó de ellos,y los guió durante todo el tiempo pasado."
,"10":"Pero ellos lo desobedecieron, y como causaban pena a su Espíritu Santo, se convirtió en su enemigo,y él mismo les hizo la guerra."
,"11":"Entonces se acordaron de los tiempos pasados, de los días de Moisés: ¿Dónde está aquel que salvó de la mar al pastor de su rebaño,y que puso dentro de ellos su Espíritu Santo,"
,"12":"que dio golpes formidables, a la derecha de Moisés, que partió las aguas del mar delante de ellos,y se hizo famoso para siempre,"
,"13":"que los hizo caminar por el fondo del mar,como un caballo por la pradera, y sin que se tropezaran,"
,"14":"como un buey que baja a la llanura?,El Espíritu de Yavé los llevaba a descansar. Así fuiste guiando a tu pueblo, y con esto te hiciste famoso."
,"15":"Mira desde los cielos, y ve desde tu santo y lujoso aposento: ¿Dónde están tu preocupación y tu poder?,¿Por qué ya no se conmueven tus entrañas?,Ah, no sigas sin sentir pena por nosotros,"
,"16":"pues tú eres nuestro Padre. Abraham ya no sabe de nosotros,e Israel tampoco se acordará. Mas tú, Yavé, eres nuestro Padre, nuestro Redentor; éste ha sido siempre tu Nombre."
,"17":"¿Por qué, Yavé, permitiste,que nos perdiéramos de tus caminos, que nuestros corazones se pusieran tercos y ya no te temieran?,¡Vuelve, por amor de tus servidores,y de tus tribus herederas!"
,"18":"¿Por qué los impíos han invadido tu Santuario?,¿por qué ha sido pisoteado por nuestros enemigos?"
,"19":"Desde hace tiempo somos un pueblo que tú no gobiernas,y que tu Nombre ya no protege. ¡Ah, si tú rasgaras los cielos y bajaras!,Los cerros se derretirían al verte."
}`)
	CurrentBook.AddChapter(64, `{
"1":"Si dieras a conocer tu Nombre a tus contrarios, sería como llama que prende en las ramas secas,o como el agua que borbotea en el fuego, y las naciones temblarían en tu presencia"
,"2":"al verte realizar prodigios inesperados."
,"3":"Nunca se escuchó, ningún oído oyó, ni ojo alguno ha visto que un Dios, fuera de ti, hiciera tanto en favor de quienes confían en él."
,"4":"Tú has desconcertado a los que vivían como justos, y que te recordaban, siguiendo tus caminos. Te enojaste, pues a lo mejor pecamos; hemos actuado mal, pero tendremos salvación."
,"5":"Todos nosotros éramos como impuros, y nuestros méritos no valían más que un paño sucio. Somos como las hojas caídas, y nuestros pecados nos arrastran como el viento."
,"6":"Nadie ya invoca tu Nombre,ni se despierta para buscarte, sino que tú nos has dado vuelta la cara,y nos has dejado a merced de nuestras culpas."
,"7":"Y, sin embargo, Yavé, tú eres nuestro Padre, somos la greda que tus manos plasmaron, todos nosotros fuimos hechos por tus manos."
,"8":"¡No te enojes tanto, pues, Yavé, ni estés recordando, a cada momento, nuestros pecados!,Míranos, pues todos nosotros formamos tu pueblo."
,"9":"Tus ciudades santas han quedado abandonadas; Sión está desierta, Jerusalén hecha una ruina."
,"10":"Nuestro templo, santo y magnífico, en que te rezaban nuestros abuelos, ha sido consumido por el fuego; todo lo que nos hacía felices está ahora en ruinas."
,"11":"¿Y puedes tú, Yavé, no conmoverte al ver estas cosas?,¿Durará tu silencio y será mayor nuestra humillación?"
}`)
	CurrentBook.AddChapter(65, `{
"1":"Me he dejado hallar por los que no preguntaban por mí y me he dejado encontrar por los que no me buscaban. Dije: 'Aquí me tienen' a una nación que no invocaba mi nombre."
,"2":"Le he tendido la mano todos los días a un pueblo desobediente, que seguía un camino que no era bueno, tras sus propios caprichos."
,"3":"Este pueblo me provoca continuamente en mi propia cara, haciendo sacrificios en los jardines, quemando perfumes sobre ladrillos,"
,"4":"viviendo en los sepulcros, pasando la noche en rincones secretos, comiendo carne de cerdo y sirviendo en sus platos comidas prohibidas."
,"5":"Dicen: 'Párate, no te acerques, que puedo pegarte la santidad.' Todo esto me molesta las narices como el humo de un incendio que no se apaga."
,"6":"Pero esto es lo que tengo escrito delante de mí: No me quedaré callado hasta no haber arreglado de una vez cuentas con ustedes"
,"7":"por sus pecados y los de sus padres, dice Yavé, que quemaron incienso en los cerros y me desafiaron en las colinas. Les daré bien su merecido, sin quitarles nada."
,"8":"Esto es lo que declara Yavé: Así como dice uno, cuando encuentra un racimo jugoso: 'No lo cortes, porque es una bendición', así me portaré yo por amor a mis servidores, y no lo destruiré todo."
,"9":"Haré nacer de Jacob una descendencia y de Judá herederos para mis montañas. Les corresponderán en herencia a mis elegidos y mis servidores harán allí sus casas."
,"10":"Mi pueblo, que me habrá buscado, tendrá el Sarón para que pasten las ovejas y el valle de Acor como potrero para los bueyes."
,"11":"Pero a ustedes, que abandonan a Yavé, que se olvidan de su Cerro Santo, que le preparan una mesa a Gad y que llenan la copa de Meni,"
,"12":"yo los condeno a morir por la espada, y todos doblarán la rodilla para ser degollados. Porque llamé y nadie respondió, les hablé y nadie me hizo caso. Hicieron lo que yo considero como malo,y eligieron lo que a mí no me gusta."
,"13":"En vista de esto, el Señor Yavé les dice: ¡Muy bien! Mis servidores comerán, mientras que ustedes estarán con hambre. Ellos tendrán de beber, mientras que ustedes sentirán sed. Se alegrarán, mientras que ustedes se verán humillados."
,"14":"Mis servidores cantarán con el corazón lleno de felicidad, mientras que ustedes se quejarán, con el corazón apenado, y gritarán, con el ánimo aplastado."
,"15":"El nombre de ustedes no se recordará más que cuando mis elegidos pronuncien una maldición: '¡Así te haga morir el Señor Yavé!' En cambio, a mis servidores les daré un nombre nuevo."
,"16":"Todo el que quiera recibir una bendición en el país, la recibirá en el nombre del Dios de la verdad; y cualquiera que preste un juramento en el país, jurará por el Dios que cumple sus promesas, pues todos los males del pasado quedarán en el olvido y ocultos a mis ojos."
,"17":"Pues Yo voy a crear un cielo nuevo y una tierra nueva y el pasado no se volverá a recordar más ni vendrá más a la memoria."
,"18":"Que se alegren y que estén contentos para siempre por lo que voy a crear. Pues Yo voy a hacer de Jerusalén un Contento y de su pueblo una Alegría."
,"19":"Yo quedaré contento con Jerusalén y estaré feliz con mi pueblo. Ya no se oirán, en adelante, sollozos ni gritos de angustia,"
,"20":"ni habrá más, allí, recién nacidos que vivan apenas algunos días, o viejos que no vivan largos años, pues morir a los cien años será morir joven, y no llegar a los cien será tenido como una maldición."
,"21":"Harán casas y vivirán en ellas, plantarán viñas y comerán sus frutos."
,"22":"Ya no edificarán para que otro vaya a vivir, ni plantarán para alimentar a otro. Los de mi pueblo tendrán vida tan larga como la de los árboles y mis elegidos gozarán de los frutos de su trabajo."
,"23":"No trabajarán inútilmente ni tendrán hijos para perderlos, pues ellos y sus descendientes serán una raza bendita de Yavé."
,"24":"Antes que me llamen les responderé, y antes que terminen de hablar habrán sido atendidos."
,"25":"El lobo pastará junto con el cordero; el león comerá paja como el buey,y la culebra se alimentará de tierra. No harán más daño ni perjuicio,en todo mi santo cerro, dice Yavé."
}`)
	CurrentBook.AddChapter(66, `{
"1":"Así se expresa Yavé: ¡El cielo es mi trono y la tierra la tarima para mis pies! ¿Qué casa podrían ustedes edificarme, o en qué parte fijarían mi lugar de reposo,"
,"2":"si todo esto lo ha hecho mi mano y todo esto es mío?, dice Yavé. Pero en quien fijo realmente mis ojos es en el pobre y en el corazón arrepentido, que se estremece por mi palabra."
,"3":"Ahora bien se sacrifica a un buey y al mismo tiempo se mata a un hombre; se degüella un cordero pero también se desnuca un perro. Se presenta como ofrenda sangre de cerdo y, si queman incienso, lo queman ante los ídolos. Así como se deleitan en seguir sus caminos, y sus almas quedan felices con sus sucios ídolos, "
,"4":"así también yo me deleitaré maltratándolos y mandaré sobre ellos cosas de que se espantan. Pues yo llamé y nadie contestó, hablé y nadie se dignó escucharme. Han hecho lo que yo considero como malo y han elegido lo que no me gusta."
,"5":"¡Oigan lo que les dice Yavé a ustedes que se estremecen por su palabra! Sus hermanos, que los odian y que no se juntan con ustedes por causa de mi Nombre, dicen: 'Que Yavé demuestre su poder, para que podamos ver la alegría de ustedes.' Pero son ellos los que serán humillados."
,"6":"Oigo ruidos como un griterío que viene de la ciudad, o como voces que salen del Templo: es la voz de Yavé que da su merecido a sus enemigos."
,"7":"Antes de que llegara el parto, dio a luz; antes de sentir los dolores, tuvo un niño varón."
,"8":"¿Quién ha oído jamás cosa igual, o ha visto algo semejante, que se pueda dar a luz, en un solo día, a un país entero? ¿Puede una nación nacer toda de una vez? ¡Pues bien, apenas sintió los dolores, Sión dio a luz a todos sus hijos!"
,"9":"Yavé dice: Si yo abro el seno materno, ¿podrá ser que no dé a luz? Pues yo soy el que abro el seno y también el que lo cierro."
,"10":"Alégrense con Jerusalén, y que se feliciten por ella todos los que la aman. Siéntanse, ahora, muy contentos con ella todos los que por ella anduvieron de luto,"
,"11":"porque tomarán la leche hasta quedar satisfechos de su seno acogedor, y podrán saborear y gustar sus pechos famosos."
,"12":"Pues Yavé lo asegura: Yo voy a hacer correr hacia ella, como un río, la paz, y como un torrente que lo inunda todo, la gloria de las naciones. Ustedes serán como niños de pecho llevados en brazos y acariciados sobre las rodillas."
,"13":"Como un hijo a quien consuela su madre, así yo los consolaré a ustedes."
,"14":"Cuando ustedes vean todo esto, les saltará de gozo el corazón y su cuerpo rejuvenecerá como la hierba. La mano de Yavé se dará a conocer a sus servidores y hará que sus enemigos vean su enojo."
,"15":"Pues he aquí que Yavé se presenta en medio del fuego, montado en los carros de la tempestad. Da rienda suelta a su ardiente cólera, sus amenazas son carbones encendidos."
,"16":"Porque Yavé va a venir a juzgar, por medio del fuego y a probar a todo mortal. Entonces serán muchas las víctimas de Yavé:"
,"17":"los que van a los jardines para purificarse y hacerse santos, y se ponen detrás de uno que está en el centro, que comen carne de cerdo, de culebras o de ratones. Sus obras y artimañas cesarán al mismo tiempo, dice Yavé."
,"18":"Ahora vengo a reunir a los paganos de todos los pueblos y de todos los idiomas. Y cuando vengan, serán testigos de mi gloria."
,"19":"Yo haré un prodigio en medio de ellos y, luego, mandaré los sobrevivientes hacia todas las naciones: hacia Tarsis, Lud y Put, Meshek, Tubal y Javan, en una palabra, hacia las tierras lejanas de ultramar que no saben de mi fama ni han visto mi gloria. Ellos darán a conocer mi gloria entre las naciones a lo lejos, "
,"20":"y de todos los pueblos traerán a todos tus hermanos dispersos como una ofrenda a Yavé, a caballo, en carro, en carretas, a lomo de mula o de camello. Me los traerán a mi cerro santo en Jerusalén, igual que los hijos de Israel me traen sus regalos para el templo de Yavé en vasos puros."
,"21":"Y Yavé lo afirma: 'De entre ellos también tomaré sacerdotes y levitas para mí.'"
,"22":"Así como los nuevos cielos y la nueva tierra que voy a crear durarán para siempre, así también tu nombre y tu raza permanecerán siempre."
,"23":"Cada luna nueva y cada sábado, todo hombre vendrá a postrarse ante mí, dice Yavé,"
,"24":"y, al salir, verán los cadáveres de los hombres que se rebelaron contra mí. El gusano que los devora no morirá, y el fuego que los quema no se apagará, y todos se sentirán horrorizados al verlos."
}`)

}
func ES_LBL_LoadVMLMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Ay, qué solitaria quedó Jerusalén, la ciudad tan poblada. Como una viuda quedó,la grande entre las naciones. La ciudad que dominaba las provincias,tiene ahora que pagar impuestos."
,"2":"Llora durante las noches, las lágrimas corren por sus mejillas. Entre todos sus amantes,nadie hay que la consuele. La traicionaron todos sus amigos, ¡y se convirtieron en sus enemigos!"
,"3":"El pueblo de Judá ha sido desterrado; sufre atropellos y dura servidumbre. Vive en medio de pueblos extranjeros,y no encuentra descanso; sus enemigos lo persiguieron,y le dieron alcance."
,"4":"Los caminos de Sión están de luto, pues nadie va a sus fiestas. Todas sus puertas están destruidas, gimen sus sacerdotes, sus doncellas están llenas de tristeza, ¡Jerusalén está llena de amargura!"
,"5":"Sus adversarios la vencieron,y ahora se sienten felices, pues Yavé la castigó,por sus muchos pecados; sus niños marcharon al destierro,empujados por el enemigo."
,"6":"Ha perdido la hija de Sión toda su gloria, sus jefes parecían carneros,que no encuentran pasto, iban caminando sin fuerzas,delante del que los arreaba."
,"7":"En sus días de miseria y destierro,Jerusalén recuerda,cuando caía en manos del enemigo,sin que ninguno la socorriera; sus enemigos la miraban,y se burlaban de su ruina."
,"8":"Gravemente pecó Jerusalén,y se hizo impura. Los que la alababan, la desprecian, porque la vieron desnuda. Y ella gime,y esconde el rostro."
,"9":"Su impureza manchaba su vestido, pero no pensaba que tendría este fin. ¡Se hundió profundamente!,¡Nadie la consuela!,¡Mira, oh Yavé, mi dolor, ¡cómo se pone orgulloso el enemigo!"
,"10":"El invasor tomó,todos sus tesoros; ella vio entrar,a los paganos en su santuario; a quienes tú habías prohibido,entraron en tus asambleas."
,"11":"Todo su pueblo gime,y busca pan. Entregan sus joyas a cambio de comida, para conservar la vida. 'Mira, ¡oh Yavé!, y observa,a qué humillación he llegado.'"
,"12":"Todos ustedes que pasan por el camino, miren y observen,si hay dolor semejante,al que me atormenta, con el que Yavé me ha herido,en el día de su ardiente cólera."
,"13":"El fuego que lanzó de lo alto,bajó hasta mis huesos; tendió una red a mis pies,y me hizo caer de espaldas. Me dejó abandonada,y siempre doliente."
,"14":"Vigiló mis crímenes, los juntó y los ató; están en su mano. Su yugo pesa sobre mi cuello,ha hecho flaquear mi fuerza; Yavé me ha entregado,en manos que no puedo resistir."
,"15":"Derribó Yavé a los valientes,que cuidaban mis ciudades. Reunió un consejo contra mí,para sacrificar a mis jóvenes. El Señor ha pisado en el lagar,a la virgen, Hija de Judá."
,"16":"Por eso, lloro yo, mis ojos se deshacen en lágrimas,porque está lejos el consolador,que reanime mi alma. Mis hijos están desolados,porque sus enemigos triunfan."
,"17":"Sión tiende sus manos, y no hay quién la consuele. Yavé mandó contra Jacob,adversarios de todas partes; Jerusalén se ha hecho,ejemplo de horror para ellos."
,"18":"Es justo Yavé, porque fui rebelde a sus órdenes. Escuchen, pues, pueblos todos, y miren mi dolor. Mis vírgenes y mis jóvenes,han ido al cautiverio."
,"19":"Llamé a mis amigos, pero me traicionaron. Mis sacerdotes y mis ancianos,han muerto en la ciudad, mientras se buscaban alimento,para reanimarse."
,"20":"Mira, Yavé, que estoy en angustias, me hierven las entrañas. Dentro se me retuerce el corazón, porque he sido muy rebelde. Afuera la espada acaba con los hijos, y dentro de la ciudad, la muerte."
,"21":"Oye cómo gimo, y no hay quién me consuele. Mis enemigos conocieron mi desgracia,y se alegran de lo que me has hecho. ¡Que venga el día que tienes anunciado!,¡Que ellos estén como yo estoy!"
,"22":"¡Que toda su maldad llegue ante ti, y trátalos como me trataste a mí,por todas mis rebeldías!, porque mis gemidos son muchos,y languidece mi corazón."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Ay, ¡cómo ha oscurecido, en su,cólera, el Señor a la Hija de Sión!,Ha derribado del cielo a la tierra,la gloria de Israel; en su enojo no se acordó de su Templo, en que descansaron sus pies."
,"2":"El Señor ha destruido sin piedad,todas las moradas de Jacob; ha destruido, en su furor, las fortalezas de la Hija de Judá; ha echado por tierra, ha profanado,al reino y a sus príncipes."
,"3":"En el ardor de su cólera ha quebrado,toda la fuerza de Israel, ha retirado la protección de su brazo frente al enemigo, ha prendido en Jacob como fuego llameante,que devora por todas partes."
,"4":"Como un enemigo, ha preparado su arco, ha afirmado su derecha, como un adversario ha matado,todo lo que encanta los ojos; en la casa de la Hija de Sión,ha vertido su furor como fuego."
,"5":"El Señor se ha portado como enemigo; ha destruido a Israel: ha destruido todos sus palacios, y derribado sus fortalezas, no le dejó a la Hija de Judá,sino llantos y lamentos."
,"6":"Ha forzado sus murallas como un huerto, ha destruido su lugar de reunión. Yavé ha hecho olvidar en Sión,solemnidades y sábados; en el ardor de su cólera,ha desechado al rey y al sacerdote."
,"7":"El Señor ha rechazado su altar, ha despreciado su santuario; ha dejado a merced del enemigo,los muros de sus palacios; en la Casa de Yavé se oyeron gritos,como en día de fiesta."
,"8":"Yavé resolvió destruir,la muralla de la Hija de Sión. Decidió la destrucción,y no retiró su mano,antes que se cumpliera; quiso acabar con el antemural y la muralla, que juntos se desmoronaron."
,"9":"Sus puertas se han hundido en tierra, él ha roto sus cerrojos; su rey y sus príncipes están entre extranjeros; ya no hay Ley y tampoco sus profetas,consiguen visiones de Yavé."
,"10":"Los ancianos de la Hija de Sión, en silencio, están sentados en tierra; se echaron ceniza en la cabeza, se vistieron de saco. Las jóvenes de Jerusalén,inclinan hasta el suelo la cabeza."
,"11":"Mis ojos se agotan de llorar,y arden mis entrañas, mi hígado se derrama por tierra,por el desastre de la Hija de mi pueblo, mientras desfallecen niños y lactantes,en las plazas de la ciudad."
,"12":"Ellos decían a sus madres: ¿Dónde hay pan?, mientras caían desfallecidos,en las plazas de la ciudad,y derramaban su alma,en el regazo de sus madres."
,"13":"¿A quién te compararé y asemejaré, Hija de Jerusalén?,¿A quién podrás mirar para tu consuelo, oh virgen, Hija de Sión?,Tu quebranto es inmenso como el mar. ¿Quién te sanará?"
,"14":"Tus profetas anunciaron para ti,falsedad y tonterías. No te descubrieron tu culpa,para ahorrarte el cautiverio. Tuvieron para ti presagios,de falsedad y de ilusión."
,"15":"Baten palmas sobre ti,todos los que pasan; silban y menean la cabeza,sobre la Hija de Jerusalén. ¿Esa era el modelo de hermosura, la alegría de toda la tierra?"
,"16":"Abren su boca contra ti todos tus enemigos; silban y crujen los dientes, dicen: La devoramos. Este es el día que esperábamos, ya lo alcanzamos, ya lo vimos."
,"17":"Yavé cumplió lo que tenía resuelto, cumplió su palabra, lo que había decretado desde antiguo; destruyó sin compasión; hizo alegrarse por tu destino al enemigo, fortaleció el poder de tus adversarios."
,"18":"Hija de Sión, gime, clama al Señor; deja correr a torrentes tus lágrimas,día y noche, no te des descanso, no cesen las fuentes de tus ojos."
,"19":"En pie, clama en la noche, cuando comienza la ronda; derrama como agua tu corazón,ante el rostro del Señor, alza tus manos hacia él por la vida de tus hijitos,que desfallecen de hambre,en la esquina de todas las calles."
,"20":"Mira, Yavé, y piensa: ¿a quién has tratado así?,Las madres tuvieron que comer a sus hijos, a sus niños de pecho. Fueron asesinados en el santuario de Yavé,sacerdote y profeta."
,"21":"Por tierra yacen en las calles,niños y ancianos; mis vírgenes y mis jóvenes,cayeron a cuchillo; mataste en el día de tu cólera, mataste sin compasión."
,"22":"Como para una fiesta invitaste,a todos los terrores juntos; en el día de tu enojo,no hubo quién se salvara o sobreviviera. Los que yo crié y mantuve, mi enemigo los exterminó."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Yo soy el hombre que ha visto la miseria,bajo el látigo del furor de Dios."
,"2":"El me llevó y me obligó a caminar,en tinieblas y oscuridad."
,"3":"Vuelve y revuelve todo el día,su mano contra mí solo."
,"4":"Consumió mi carne y mi piel,y quebró mis huesos."
,"5":"Edificó contra mí un muro, me cercó de veneno y de dolor."
,"6":"Me mandó vivir en las tinieblas, como los muertos de antaño."
,"7":"Me encarceló y no puedo salir, me puso pesadas cadenas."
,"8":"Por más que grito y pido auxilio,él sofoca mi súplica."
,"9":"Cercó mi camino con piedras enormes, confundió mis senderos."
,"10":"Ha sido para mí como oso en acecho,y león en escondite."
,"11":"Complicando mis caminos me destrozó, me dejó hecho un horror."
,"12":"Preparó su arco, y me puso,como blanco de sus flechas."
,"13":"Clavó en mi espalda,sus dardos sacados de la caja."
,"14":"Me hizo burla de todo mi pueblo, la cantinela todo el día."
,"15":"Me colmó de amargura, me dio a beber ajenjo."
,"16":"Quebró mis dientes con una piedra, me revolcó en la ceniza."
,"17":"Mi alma está alejada de la paz,y ha olvidado la dicha."
,"18":"Dije: Mi esperanza se perdió,igual que mi confianza en Yavé."
,"19":"Acuérdate de mi miseria y mi vida errante, de mi ajenjo y amargor."
,"20":"Mi alma recuerda, sí, y se me hunde."
,"21":"Esto reflexiono en mi corazón, y por ello esperaré."
,"22":"El amor de Yavé no se ha acabado, ni se han agotado sus misericordias;"
,"23":"se renuevan cada mañana. Sí, tu fidelidad es grande."
,"24":"Dice mi alma: 'Yavé es mi parte, por eso en él esperaré.'"
,"25":"Bueno es Yavé para los que esperan en él, para el alma que lo busca."
,"26":"Bueno es esperar en silencio,la salvación de Yavé."
,"27":"Bueno es para el hombre,soportar el yugo desde su juventud."
,"28":"Que se siente solitario y silencioso,cuando Dios se lo impone;"
,"29":"que ponga su boca en el polvo; quizá tenga esperanza,"
,"30":"que tienda la mejilla al que lo hiere, que se llene de humillaciones."
,"31":"Porque el Señor no desecha,al hombre para siempre."
,"32":"Si llega a afligir, luego se compadece, según su inmenso amor;"
,"33":"él no se alegra en humillar,y afligir a los hombres."
,"34":"Cuando se aplasta con el pie,a todos los cautivos de un país,"
,"35":"cuando se niega el derecho de un hombre,ante la cara de Dios,"
,"36":"cuando se falsea la justicia, ¿no lo ve el Señor?"
,"37":"¿Quién habló y realizó?,¿No es el Señor el que decidió?"
,"38":"¿No salen de la boca del Altísimo,los males y los bienes?"
,"39":"Pues, ¿de qué se queja el hombre, el hombre que vive a pesar de sus pecados?"
,"40":"Examinemos nuestros caminos, estudiémoslos,y convirtámonos a Yavé."
,"41":"Alcemos nuestro corazón y nuestras manos,al Dios que está en los cielos."
,"42":"Nosotros hemos sido rebeldes y traidores,y tú no has perdonado."
,"43":"Te has vestido de cólera,y nos has perseguido."
,"44":"Has matado sin piedad; te encerraste en tu nube,para que no pasara la oración;"
,"45":"nos hiciste basura y vileza,en medio de los pueblos."
,"46":"Abren su boca contra nosotros,todos nuestros enemigos."
,"47":"Nuestro destino es el terror, sepulcro, desolación y ruina."
,"48":"Torrentes de agua derraman mis ojos,por la ruina de la Hija de mi pueblo."
,"49":"Mis ojos lloran sin cesar, ya que no hay alivio,"
,"50":"hasta que Yavé desde los cielos mire y vea."
,"51":"Me duelen los ojos,al ver a las hijas de mi ciudad."
,"52":"Me cazaron como a un pájaro,mis enemigos sin motivo."
,"53":"Ahogaron mi vida en un sepulcro,y echaron piedras sobre mí."
,"54":"Cubrieron las aguas mi cabeza, dije: Estoy perdido."
,"55":"Invoqué tu nombre, Yavé, desde lo profundo del sepulcro."
,"56":"Oye mi grito: no cierres tu oído a mi oración."
,"57":"Te acercaste el día que te invocaba,y dijiste: 'No temas.'"
,"58":"Señor, tú defendiste mi causa, rescataste mi vida."
,"59":"Yavé, viste la injusticia que me hacían. ¡Defiende tú mi juicio!"
,"60":"Tú ves cómo se vengan de mí,todos los que intrigaron contra mí."
,"61":"Yavé, oíste sus insultos, todas sus maniobras contra mí."
,"62":"Sus palabras y sus pensamientos,todo el día se dirigen contra mí."
,"63":"Estén sentados o en pie, mira: yo soy risa para ellos."
,"64":"Yavé, tú les pagarás, según la obra de sus manos."
,"65":"Haz que se obcequen en su maldad, que ésta sea su maldición."
,"66":"Tú entonces los perseguirás y barrerás,debajo de los cielos."
}`)
	CurrentBook.AddChapter(4, `{
"1":"¿Cómo se ha empañado y deteriorado el oro más puro?,¿Por qué están desparramadas las piedras sagradas,por las esquinas de todas las calles?"
,"2":"Los hijos de Sión, valiosos,y preciados como el oro fino, ¡ay!, son considerados como vasos de arcilla, obra del alfarero."
,"3":"Hasta los chacales descubren el pezón,y dan de mamar a sus cachorros; la Hija de mi pueblo se ha vuelto tan cruel,como los avestruces del desierto."
,"4":"La lengua del niño de pecho se pega de sed al paladar; los niños piden pan, pero no hay quién lo reparta."
,"5":"Los que comían manjares deliciosos,desfallecen por las calles; los que se criaban entre sedas,se quedan en basurales."
,"6":"La culpa de la Hija de mi pueblo,supera el pecado de Sodoma, que fue aniquilada en un momento,sin que manos humanas,se volvieran contra ella."
,"7":"Sus nazireos eran más puros que la nieve, más blancos que la leche, de cuerpo más rojo que corales; su cara, un zafiro."
,"8":"Su semblante ahora es más oscuro que carbón, ya no se los reconoce por las calles. Su piel está pegada a sus huesos, seca como madera."
,"9":"Más dichosos fueron los muertos a cuchillo,que los muertos de hambre, que mueren extenuados,por falta de los frutos de los campos."
,"10":"Las mismas manos de tiernas mujeres,cocieron a sus hijos, los sirvieron como comida,en la ruina de la Hija de mi pueblo."
,"11":"Yavé descargó su furor, derramó el ardor de su cólera; encendió fuego en Sión, que devoró sus cimientos."
,"12":"Nunca creyeron los reyes de la tierra, ni cuantos viven en el mundo, que adversarios y enemigos entrarían,por las puertas de Jerusalén."
,"13":"Fue por los pecados de sus profetas, por las culpas de sus sacerdotes, que en medio de ellos derramaron sangre de justos."
,"14":"Vagaban ellos como ciegos por las calles, manchados estaban de sangre; por lo que nadie podía tocar sus vestiduras."
,"15":"Les gritaban: ¡Apártense, un impuro!,¡Apártense, no lo toquen!,Y cuando huían y vagaban, se decía entre las naciones: ¡Aquí no seguirán como huéspedes!"
,"16":"El rostro de Yavé los dispersó, ya no vuelve a mirarlos. No respetaron a los sacerdotes,ni tuvieron piedad de los profetas."
,"17":"Y todavía nos cansábamos,esperando el socorro. ¡Ilusión!,Desde nuestros cerros no vimos llegar a Egipto, incapaz de salvarnos."
,"18":"Vigilaban nuestros pasos,para que no anduviéramos por nuestras plazas."
,"19":"Nuestro fin estaba cercano,y, cumplidos nuestros días, ha llegado."
,"20":"Nuestros perseguidores eran veloces, más que las águilas del cielo, nos perseguían por los montes, en el desierto nos armaban trampas. Nuestro rey, el ungido de Yavé, del que estábamos pendientes, quedó preso en sus redes; aquél de quien decíamos: A su sombra viviremos entre las naciones."
,"21":"¡Regocíjate, alégrate, Hija de Edom, que habitas en el país de Us!,También a ti te llegará la copa: te embriagarás y te desnudarás."
,"22":"¡Hija de Sión, se ha borrado tu culpa, él no volverá a desterrarte!,En cambio, Hija de Edom, Yavé castigará tu culpa,y pondrá al desnudo tus pecados."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Yavé, acuérdate de lo que nos ha pasado, mira y ve nuestra humillación."
,"2":"Nuestra herencia pasó a extranjeros, nuestras casas a extraños."
,"3":"Somos huérfanos, sin padre; nuestras madres, viudas."
,"4":"A precio de plata bebemos nuestra agua, nuestra leña nos llega por dinero."
,"5":"Con el yugo al cuello andamos acosados; estamos agotados, no nos dan respiro."
,"6":"Tendimos a Egipto nuestra mano, y a Asur, para calmar el hambre."
,"7":"Nuestros padres, que pecaron, ya no existen, y nosotros cargamos con sus culpas."
,"8":"Esclavos nos dominan y no hay quien nos libre de su poder."
,"9":"Con riesgo de la vida trajimos nuestro pan, enfrentando los peligros del desierto."
,"10":"Nuestra piel abrasa como un horno, por el ardor del hambre."
,"11":"Violaron a las mujeres en Sión; a las jóvenes en las ciudades de Judá."
,"12":"Colgaron a los príncipes y no respetaron al resto de los ancianos."
,"13":"Los muchachos arrastraron la piedra de moler, bajo la carga de leña se han encorvado las niñas."
,"14":"Los ancianos dejaron de acudir a la puerta, los muchachos dejaron de cantar."
,"15":"Cesó nuestra alegría, se cambió en duelo nuestro baile."
,"16":"Cayó la corona de nuestra cabeza. ¡Pobres de nosotros, que pecamos!"
,"17":"Por eso, está podrido nuestro corazón y se nos nublan los ojos"
,"18":"pensando en tu cerro desolado, donde merodean las fieras."
,"19":"Pero tú, Yavé, reinas para siempre, tu trono permanece firme de generación en generación."
,"20":"¿Por qué te olvidas siempre de nosotros?, ¿por qué nos abandonas?"
,"21":"Haz que volvamos a ti, Yavé, y volveremos; haz que seamos de nuevo lo que fuimos antes."
,"22":"¿Nos has desechado totalmente? ¿Estás irritado sin medida con nosotros?"
}`)

}
func ES_LBL_LoadVNABChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Visión de Abdías. Palabra del Señor Yavé sobre Edom: Acabamos de oír un llamado de Yavé, un mensaje que manda a las naciones: '¡En pie de guerra, levántense y ataquemos a Edom!'"
,"2":"Desde ahora serás pequeño entre las naciones, el menos considerado de todos."
,"3":"La soberbia de tu corazón te ha engañado a ti que habitas en las quebradas de Petra, que te cuelgas de la muralla rocosa y que dices en tu corazón: '¿Quién me hará bajar a tierra?'"
,"4":"Aunque te eleves como el águila y coloques tu nido entre las estrellas, te haré descender de allí, palabra de Yavé."
,"5":"Si vienen a ti los ladrones, los salteadores nocturnos, ¿cómo no te robarán lo que quieran? Si vienen a ti los vendimiadores, ¿te dejarán acaso más que algunos racimos?"
,"6":"¡Cómo han rebuscado en Esaú y escudriñado sus escondrijos!"
,"7":"Hasta la frontera te han rechazado tus amigos; tus aliados han sido más fuertes que tú, y han puesto un lazo bajo tus pies."
,"8":"Aquel día, dice Yavé, haré desaparecer a los sabios de Edom y a la astucia de los montes de Esaú."
,"9":"Tus valientes se estremecen, pueblo de Temán, pues se está acuchillando a los hombres de los cerros de Esaú."
,"10":"A causa de tu violencia contra tu hermano Jacob quedarás cubierto de vergüenza y desaparecerás para siempre."
,"11":"Tú te quedabas esperando cuando los extranjeros hacían cautivo a su ejército; cuando los enemigos entraban por sus puertas y sobre Jerusalén echaban suertes, tú también, eras como uno de ellos."
,"12":"No te alegres de la ruina de tu hermano en el día de su desgracia. No hagas burla de los hijos de Judá en el día de su angustia, no te rías de su miseria."
,"13":"No vengas a mirar a la puerta el día en que le va mal a mi pueblo: ¿será bueno que veas sus sufrimientos el día de su desgracia? No eches mano de sus riquezas en el día de la desventura."
,"14":"No te pongas en la cruzada para matar a los que huyen, ni entregues a los sobrevivientes en el día de su angustia."
,"15":"Ya viene, para todas las naciones, el día de Yavé: como tú has hecho, así se te hará; sobre tu cabeza recaerá tu merecido."
,"16":"Así como ustedes bebieron sobre mi monte santo, así van a beber, naciones que me rodean; beberán hasta que pierdan los sentidos, y serán luego como si no hubieran sido."
,"17":"Pero en el monte de Sión habrá supervivientes, que será un lugar santo, y el pueblo de Jacob recobrará su heredad."
,"18":"El pueblo de Jacob será un fuego, el de José una llama, mientras la gente de Esaú será la paja; la quemarán y la devorarán y no quedarán restos de la raza de Esaú, porque Yavé lo ha dicho."
,"19":"Los habitantes del Negueb heredarán los cerros de Esaú; los de la tierra baja, el país de los filisteos; heredarán del territorio de Efraím y los campos de Samaria, y los de Benjamín heredarán Galaad."
,"20":"Los desterrados de Israel dominarán lo que pertenecía a los cananeos hasta Sarepta, y los desterrados de Jerusalén que están en Sefarad heredarán las ciudades del Negueb;"
,"21":"subirán victoriosos al monte Sión para gobernar de allí a los cerros de Esaú. Entonces Yavé reinará."
}`)

}
func ES_LBL_LoadVNAGChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"En el segundo año del reinado de Darío, el primer día del sexto mes, la palabra de Yavé fue dirigida por medio del profeta Ageo a Zorobabel, hijo de Sealtiel, gobernador de Judá, y a Josué, hijo de Josadac, sumo sacerdote, para que les dijera:"
,"2":"'Aquí tienen una respuesta de Yavé a lo que dice este pueblo, que todavía no ha llegado el momento de reconstruir la Casa de Yavé.'"
,"3":"Así es cómo Yavé habló por medio del profeta Ageo, y les dijo:"
,"4":"'¿Cómo es posible que ustedes se queden en sus casas bien construidas, mientras esta Casa es un montón de escombros?'"
,"5":"Pues bien, Yavé de los Ejércitos les dice: 'Examinen cómo van sus asuntos:"
,"6":"ustedes han sembrado mucho, pero han cosechado poco; han comido, pero se han quedado con hambre; han bebido, pero han seguido con sed; se han vestido, pero no estaban bien abrigados. Y el obrero pone el dinero que ha ganado en un bolsillo roto."
,"7":"Piensen en lo que hacen:"
,"8":"Vayan al monte a buscar madera y reconstruyan la Casa. Con eso, yo seré feliz y me sentiré muy honrado a la vez, dice Yavé."
,"9":"Ustedes esperaban mucho y lo que amontonaron es muy poco, pues yo lo he soplado. ¿'Por qué? -pregunta Yavé-. Porque mi Casa está en ruinas, mientras cada uno de ustedes corre para arreglar la suya. "
,"10":"Por esto, los cielos han retenido la lluvia y la tierra no ha dado sus frutos."
,"11":"Yo mandé la sequía a la tierra y a las montañas, al trigo y a las viñas, al aceite y a cuanto produce el suelo, a los hombres y a los animales y a todo lo que se logra con el trabajo humano.'"
,"12":"Ahora bien, Zorobabel, hijo de Sealtiel, Josué, hijo de Josadac, sumo sacerdote, y todo el pueblo, escucharon estas palabras de Yavé su Dios que les hablaba por medio del profeta Ageo, pues hablaba por encargo de Yavé, su Dios. Y el pueblo se llenó de respeto a Dios."
,"13":"En seguida Ageo, actuando como mensajero de Yavé y conforme a su misión, transmitió al pueblo esta palabra de Yavé: 'Yo estoy con ustedes.'"
,"14":"Entonces Yavé tocó el corazón de Zorobabel, de Josué y de todo el pueblo, quienes empezaron la reconstrucción de la Casa de Yavé de los Ejércitos, su Dios."
,"15":"El veinticuatro del sexto mes..."
}`)
	CurrentBook.AddChapter(2, `{
"1":"El día veintiuno del séptimo mes del segundo año de Darío, Yavé le encargó al profeta Ageo"
,"2":"que transmitiera el siguiente recado a Zorobabel, gobernador de Judá, y a Josué, sumo sacerdote, y a todo el pueblo en general:"
,"3":"'¿Vive todavía entre ustedes alguien que haya visto esta Casa con el esplendor que tenía? ¿Qué es lo que ven ahora? ¿No les parece una cosa insignificante?"
,"4":"Sin embargo, a ustedes les digo, Zorobabel, Josué y todos ustedes que son el pueblo del país, que no se desanimen. Pónganse a trabajar y yo estaré con ustedes, palabra de Yavé de los Ejércitos."
,"5":"No tengan miedo, porque mi espíritu está entre ustedes."
,"6":"Esto dice Yavé: 'Dentro de muy poco tiempo sacudiré los cielos y la tierra, los mares y los continentes."
,"7":"Sacudiré a todas las naciones, y todos sus objetos preciosos vendrán a parar aquí, dice Yavé."
,"8":"¡A mi el oro! ¡A mí la plata!, dice Yavé de los ejércitos."
,"9":"La fama de este templo será mucho mayor que la del anterior, y en este lugar yo entregaré la paz, dice Yavé de los Ejércitos.'"
,"10":"El día veinticuatro del mes noveno, Yavé se dirigió nuevamente al profeta Ageo,"
,"11":"para que, en su nombre, les pidiera a los sacerdotes la solución del siguiente caso, de acuerdo a la ley."
,"12":"'Si un hombre lleva carne consagrada envuelta en un traje y con éste roza pan, comida, vino, aceite o cualquier otro alimento, ¿quedará también todo esto consagrado?' Ellos respondieron: 'No.'"
,"13":"Ageo prosiguió: 'Si uno, en cambio, queda impuro por haber tocado un cadáver y roza luego algunas de estas cosas, ¿quedarán todas impuras?' Los sacerdotes dijeron esta vez: 'Sí.'"
,"14":"Entonces les dijo Ageo: 'Así les sucedía a este pueblo, y así es esta nación delante de mí, palabra de Yavé. Todas sus acciones son impuras y entonces todo lo que aquí ofrecen es impuro."
,"15":"Pero miren lo que sucederá a partir de hoy. Antes de que empezaran a poner piedra sobre piedra para la Casa de Yavé,"
,"16":"¿qué les pasaba? Venían a un montón de veinte sacos de trigo, pero sólo quedaban diez. Venían a un tanque de cincuenta arrobas de vino y se encontraban sólo veinte."
,"17":"Yo eché a perder todo el trabajo de ustedes con el tizón, el pulgón y el granizo. Pero ninguno de ustedes se volvía a mí, dice Yavé."
,"18":"Pongan, pues, atención desde hoy en adelante, desde este día veinticuatro del noveno mes en que se ha puesto la primera piedra del Santuario de Yavé."
,"19":"Miren si todavía falta el trigo en el granero. Miren si la vid, la higuera, el granado y el olivo no dan frutos. Pues en adelante los voy a bendecir.'"
,"20":"Una palabra de Yavé le llegó nuevamente a Ageo ese día veinticuatro:"
,"21":"Dile a Zorobabel, gobernador de Judá: 'Voy a remecer los cielos y la tierra."
,"22":"Derribaré los tronos de los reyes y destruiré el poderío de las naciones. Volcaré al carro con su conductor; rodarán por el suelo los caballos y sus jinetes. Se matarán unos a otros."
,"23":"En aquel día, lo asegura Yavé de los Ejércitos, te tomaré a ti, Zorobabel, hijo de Sealtiel, mi servidor, y serás para mí como un anillo con mis iniciales en mi dedo. Pues a ti te he elegido, dice Yavé de los Ejércitos.'"
}`)

}
func ES_LBL_LoadVNAMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palabras de Amós, uno de los intendentes de los pastores de Tecoa. Estas son las revelaciones que tuvo acerca de Israel, en tiempo de Ozías, rey de Judá; y en tiempos de Jeroboam, hijo de Joás, rey de Israel, dos años antes del terremoto."
,"2":"Dijo: 'Ruge Yavé desde Sión, desde Jerusalén hace oír su voz; se marchitan los pastos de los pastores,y se secan las cumbres del Carmelo.'"
,"3":"Así dice Yavé: 'Mi sentencia en contra de Damasco por sus muchos crímenes será sin apelación. Porque machacaron a los israelitas de Galaad como se trilla el trigo,"
,"4":"yo prenderé fuego a la casa de Jazael y se incendiarán los palacios de Ben-Hadad."
,"5":"Romperé la fortaleza de Damasco, arrancaré de Bicat-Aven a todos sus pobladores y de Bet-Edén al que empuña el cetro, y el pueblo de Aram irá cautivo a Quir, dice Yavé.'"
,"6":"Así dice Yavé: 'Mi sentencia en contra de Gaza por sus muchos crímenes, será sin apelación. Porque llevaron poblaciones enteras para venderlas a Edom como esclavos,"
,"7":"yo prenderé fuego a la muralla de Gaza y se incendiarán sus palacios;"
,"8":"extirparé de Asdod a todos sus pobladores y de Ascalón al que empuña el cetro; volveré luego mi brazo contra Ecrón y perecerán los que quedan de los filisteos, dice el Señor Yavé.'"
,"9":"Así, dice Yavé: 'Mi sentencia en contra de Tiro por sus muchos crímenes será sin apelación. Porque vendieron como esclavos poblaciones enteras a Edom, sin acordarse de su alianza con sus hermanos,"
,"10":"yo lanzaré fuego sobre las murallas de Tiro y todos sus palacios quedarán arrasados por las llamas.'"
,"11":"Así dice Yavé: 'Mi sentencia en contra de Edom por sus muchos crímenes será sin apelación. Porque ha perseguido con espada a su hermano Israel ahogando todo sentimiento de piedad, porque le tiene un odio siempre vivo y le guarda un rencor que nunca pasa,"
,"12":"yo prenderé fuego a Temán y se quemarán los palacios de Bosrá.'"
,"13":"Así dice Yavé: 'Mi sentencia en contra de Ammón por sus muchos crímenes será sin apelación. Porque ellos al extender sus dominios abrieron el vientre de las mujeres embarazadas de Galaad,"
,"14":"por eso yo prenderé fuego a los muros de Rabbá, incendiándose sus palacios; habrá entonces alaridos de combate y soplará el vendaval de la tormenta."
,"15":"Y su rey, rodeado de su corte, partirá al destierro, dice Yavé.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Así dice Yavé: 'Mi sentencia en contra de Moab por sus muchos crímenes será sin apelación. Por haber quemado los huesos del rey de Edom hasta reducirlos a cenizas,"
,"2":"yo prenderé fuego contra Moab, que devorará los palacios de Cariot. Moab caerá estrepitosamente en medio de los gritos de los combatientes y del toque de las trompetas."
,"3":"Arrasaré a todos sus gobernantes y aniquilaré, con él, a todos sus príncipes, dice Yavé.'"
,"4":"Así, dice Yavé: 'Mi sentencia en contra de Judá por sus muchos crímenes será sin apelación. Porque han despreciado la Ley de Yavé y no han guardado sus preceptos, sino que se dejaron llevar por sus falsos dioses, detrás de los cuales corrían ya sus padres."
,"5":"Prenderé fuego a Judá y se quemarán los palacios de Jerusalén.'"
,"6":"Así dice Yavé: 'Mi sentencia en contra de Israel por sus muchos crímenes será sin apelación. Porque venden al inocente por dinero y al necesitado por un par de sandalias,"
,"7":"pisotean a los pobres en el suelo y les impiden a los humildes conseguir lo que desean. Padre e hijo, faltándole al respeto a mi Santo Nombre, tienen relaciones con la misma mujer; "
,"8":"tomando las ropas empeñadas, se acuestan cerca de cualquier altar, y con el vino de las multas se emborrachan en la Casa de su Dios."
,"9":"Yo, sin embargo, en atención a ustedes, destruí a los amorreos, tan altos como cedros y tan forzudos como encinas, cortándoles sus ramas y arrancándoles sus raíces."
,"10":"Yo, también, los saqué a ustedes de Egipto y los conduje por el desierto durante cuarenta años, para que tomaran posesión del territorio amorreo."
,"11":"Yo, de entre tus hijos hice surgir profetas y me consagraba tus jóvenes como nazireos. ¿No es así, hijos de Israel?"
,"12":"Pero ustedes hicieron tomar vino a los nazireos, y a los profetas les prohibieron predicar."
,"13":"Pues bien, por todo lo que han hecho, yo los voy a aplastar contra el suelo, como aplasta la tierra la pala que muele la paja."
,"14":"No se podrá escapar el hombre rápido, ni demostrar su fuerza el forzudo, ni salvar su vida el valiente."
,"15":"El que dispara el arco no lo podrá estirar, el rápido corredor no logrará huir, el caballero no saldrá con vida,"
,"16":"y el primero entre los valientes huirá desnudo aquel día. Así lo asegura el Señor.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Escuchen, israelitas, esta palabra de Yavé que se refiere a ustedes y a todos los suyos, a quienes hizo salir de Egipto:"
,"2":"'No me di a conocer más que a ustedes entre todas las naciones de la tierra, y por esta razón los castigaré de un modo especial por todas sus maldades."
,"3":"¿Emprenden, acaso, dos hombres juntos el camino sin haberse puesto antes de acuerdo?"
,"4":"¿No ruge el león en la selva porque ha cazado una presa? ¿No resuena en su guarida el rugido del cachorro porque tiene algo que comer?"
,"5":"¿No cae un pajarito en la trampa porque alguien la ha armado antes?"
,"6":"¿Se levanta del suelo una trampa antes de que haya caído algo? ¿Resuena la trompeta en una ciudad sin que se alarme toda la población? ¿Sucede alguna desgracia en un pueblo sin que venga del Señor?"
,"7":"En realidad, el Señor Yavé no hace nada sin comunicárselo antes a sus servidores, los profetas."
,"8":"Así, como nadie queda impertérrito al oír el rugido del león, así tampoco se negará nadie a profetizar cuando escucha lo que le habla el Señor."
,"9":"Llamen a los que viven en los palacios asirios o en los palacios egipcios y díganles: Júntense en las montañas de Samaria, para que vean los desórdenes que hay en esa ciudad o los crímenes que en ella se cometen."
,"10":"Ya no saben actuar con honradez, dice Yavé, pues amontonan la rapiña y el fruto de sus asaltos en sus palacios."
,"11":"Por eso, lo afirma Yavé, el enemigo invadirá tu territorio, tu poder se irá al suelo y tus palacios serán saqueados."
,"12":"Y agrega todavía Yavé: Como las dos patas o la punta de una oreja que el pastor salva de la boca del león, así será el resto de los hijos de Israel que en Samaria se sientan en la espuma de un sofá, sobre cojines de Damasco."
,"13":"Oigan y transmitan a la casa de Jacob esta palabra de Yavé."
,"14":"Cuando yo llegue a tomar cuentas de sus crímenes a Israel, ese día yo iré derecho a los altares de Betel: quebraré los cuernos del altar y los tiraré al suelo."
,"15":"Daré combos a las mansiones para el invierno o para el verano; terminaré con los palacios de marfil y serán demolidas las casas de piedras.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Escuchen esta palabra, vacas de Basán, damas de los cerros de Samaria: Ustedes oprimen a los débiles, aplastan a los menesterosos, y luego dicen a sus maridos: 'Sírvannos vino para tomar.'"
,"2":"El Señor jura por su santidad: Está para llegar el día en que las levantarán a ustedes con arpones, y con un aguijón, para empujar por detrás."
,"3":"Cada una de ustedes saldrá como pueda por las aberturas de la muralla, y serán deportadas hacia el Hermón."
,"4":"Vayan al santuario de Betel para pecar. Vayan al de Guilgal y pequen más todavía. Presenten sus sacrificios cada mañana y también los diezmos a los tres días."
,"5":"Quemen, para dar gracias, panes sin levadura, y anuncien a los cuatro vientos sus ofrendas voluntarias, pues eso les gusta a ustedes, hijos de Israel, dice el Señor Yavé."
,"6":"Yo dejé sus dientes limpios por no tener qué masticar e hice que faltara el pan en todas sus ciudades, pero ustedes no se han vuelto a mí, palabra de Yavé."
,"7":"No les mandé la lluvia cuando faltaban tres meses para la cosecha, o bien hice llover sobre una ciudad mientras en otra no llovía; unos campos se regaron con la lluvia, pero otros, faltos de agua, se secaron."
,"8":"La gente de dos o tres ciudades corría a otra ciudad en busca de agua, sin poder con ello calmar su sed. Y ustedes, sin embargo, no volvieron a mí, palabra de Yavé."
,"9":"Yo les mandé la tiña y la polilla a todos sus jardines y viñedos; y devoró la langosta sus higueras y olivos. Con todo, ustedes no volvieron a mí, palabra de Yavé."
,"10":"Desencadené sobre ustedes una peste parecida a la de Egipto; masacré por la espada a sus jóvenes y se llevaron a todos sus caballos; hice que subiera hasta sus narices la hediondez de sus muertos en combate. Y ustedes, sin embargo, no volvieron a mí, palabra de Yavé."
,"11":"Los he estremecido como estremecí a Sodoma y Gomorra, y quedaron ustedes como un tizón sacado del fuego. Y ustedes, sin embargo, no volvieron a mí, palabra de Yavé."
,"12":"Por eso, ahora vengo a pedirte cuentas, Israel: prepárate a enfrentarte con tu Dios."
,"13":"Porque ahí viene el que forma los montes y crea el viento, el que enseña al hombre la manera de reflexionar, el que tramó el mal contra esa gente, una desgracia tan grande que no podrán hacerle el quite ni caminar con la frente en alto."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Escuchen estas palabras que yo pronuncio contra ustedes, una lamentación por ti, Israel:"
,"2":"Ha caído la virgen de Israel, y no volverá ya a levantarse, postrada está en el suelo, y no hay quién la levante."
,"3":"Porque así dice Yavé a la gente de Israel: La ciudad de la cual salían mil hombres quedará sólo con cien, y de la que salían cien quedará sólo con diez."
,"4":"Así dice Yavé a la Casa de Israel: Búsquenme a mí y vivirán,"
,"5":"pero no me busquen en Betel,ni vayan a Guilgal, ni pasen a Bersebá; porque Guilgal será enviada al destierro, Betel será reducida a la nada."
,"6":"Busquen a Yavé y vivirán, no sea que él mande fuego,sobre la casa de José y la consuma, sin que haya nadie para apagarlo."
,"7":"El formó la Pléyade y Orión, él cambia las tinieblas en aurora,y el día claro en noche oscura."
,"8":"El llama a las aguas del mar,y las derrama por la superficie de la tierra; pues su Nombre es Yavé."
,"9":"El trae la ruina sobre los potentes, y entrega al saqueo el recinto fortificado."
,"10":"¡Ay de ustedes, que transforman las leyes en algo tan amargo como el ajenjo y tiran por el suelo la justicia!"
,"10":"Ustedes odian al que defiende lo justo en el tribunal y aborrecen a todo el que dice la verdad."
,"11":"Pues bien, ya que ustedes han pisoteado al pobre, exigiéndole una parte de su cosecha, esas casas de piedras canteadas que edifican no las van a ocupar, y de esas cepas escogidas que ahora plantan no probarán el vino."
,"12":"Pues yo sé que son muchos sus crímenes y enormes sus pecados, opresores de la gente buena, que exigen dinero anticipado y hacen perder su juicio al pobre en los tribunales."
,"13":"Por esto, el hombre prudente tiene que callarse, pues estamos pasando días infelices."
,"14":"Busquen el bien y no el mal si quieren vivir, para que así Yavé esté con ustedes, como de continuo repiten."
,"15":"Aborrezcan el mal y amen el bien, impongan la justicia en sus tribunales, y quizá Yavé Sabaot se apiade del resto de José."
,"16":"Por eso, así habla Yavé, el Dios de los Ejércitos, el Señor: Habrá lamentaciones en las plazas y en todas las calles se escucharán los '¡Ayes!'. Invitarán a los campesinos para celebrar el duelo y contratarán lloronas como para un velorio."
,"17":"Pues habrá llantos en todas las viñas cuando yo pase en medio de ti, dice Yavé."
,"18":"¡Qué decepción para aquellos que suspiran por el día en que vendrá Yavé! ¿Cómo será ese día para ustedes? Será un día de tinieblas, no de luz."
,"19":"Será como un hombre que huye del león y se topa con un oso, o como el que al entrar en casa apoya su mano en la pared y lo muerde una culebra."
,"20":"El día de Yavé será tinieblas y no luz, será un día sombrío, sin el menor destello."
,"21":"Yo odio y aborrezco sus fiestas y no me agradan sus celebraciones."
,"22":"Por más que me ofrezcan víctimas consumidas por el fuego, no me gustan sus ofrendas ni me llaman la atención sus sacrificios."
,"23":"Váyanse lejos con el barullo de sus cantos, que ya no quiero escuchar la música de sus arpas."
,"24":"Quiero que la justicia sea tan corriente como el agua, y que la honradez crezca como un torrente inagotable."
,"25":"¿Acaso me ofrecieron ustedes sacrificios y ofrendas en el desierto durante esos cuarenta años?"
,"26":"Quédense, pues, con los ídolos que se han fabricado, con Sicut, su rey, y la estela de Queván, su dios,"
,"27":"y yo los desterraré a ustedes a un lugar más allá de Damasco, dice Yavé cuyo nombre es: Dios de los Ejércitos."
}`)
	CurrentBook.AddChapter(6, `{
"1":"¡Ay de ustedes, los primeros de la primera de las naciones, a quienes acude todo el mundo en Israel! Ustedes descansan en su orgullo y se sienten seguros en el cerro de Samaria,"
,"2":"pero pasen a la ciudad de Calne y vean. Vayan de allí a Jamat la grande y bajen después a Gat de los filisteos. ¿Valen ustedes más que esos reinos, o es su territorio más grande que lo era el de ellos?"
,"3":"Ustedes piensan alejar el día de su desgracia, pero, en realidad, apresuran la venida del opresor."
,"4":"Tendidos en camas de marfil o arrellanados sobre sus sofás, comen corderitos del rebaño y terneros sacados del establo,"
,"5":"canturrean al son del arpa y, como David, improvisan canciones."
,"6":"Beben vino en grandes copas, con aceite exquisito se perfuman, pero no se afligen por el desastre de mi pueblo."
,"7":"Por eso ustedes serán, ahora, los primeros en partir al destierro, y así se terminará con ese montón de ociosos."
,"8":"Juro por mí mismo, dice el Señor Yavé, el Dios de los Ejércitos: Yo aborrezco el lujo insolente de Jacob y detesto sus palacios; por eso, entregaré en manos del enemigo la ciudad con todos sus habitantes."
,"9":"Y si solamente queda una casa, con diez hombres adentro, también ellos morirán."
,"10":"y cuando se presenten los deudos para sacar sus huesos, si a uno, que está al fondo le preguntan: 'Oye, ¿queda alguien por allá?',"
,"11":"éste dirá: 'No hay nadie', y el que le preguntó le dirá: 'Cállate, pues no queda nadie para invocar el Nombre del Señor.'"
,"11":"Pues ahora Yavé es el que manda: él reducirá a escombros la gran mansión y a un montón de ruinas, la pequeña."
,"12":"¿Galopan por las rocas los caballos o se ara el mar con bueyes, para que ustedes cambien en veneno el derecho o en ajenjo las sentencias del tribunal?"
,"13":"Y luego se sienten orgullosos por cosas de nada y andan diciendo: 'Ahora somos fuertes, nos hemos hecho imbatibles.'"
,"14":"Pues bien, yo voy a lanzar contra ustedes, israelitas, una nación que los oprimirá desde la entrada de Jamat hasta el torrente de la Arabá. Palabra de Yavé, Dios Sabaot."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Esto fue lo que me mostró el Señor Yavé: Cuando estaba brotando de nuevo el pasto, después del corte para el rey, él estaba fabricando langostas."
,"2":"Al ver cómo pelaban los campos, intervine y dije: 'Por favor, Señor Yavé, perdona. Pues, ¿qué será de Jacob, que es tan pequeño?'"
,"3":"Yavé se arrepintió y me dijo: 'Esto no va a pasar.'"
,"4":"En seguida, el Señor me mostró otra cosa: El Señor llamaba al fuego para que secara los manantiales y marchitara los campos."
,"5":"Entonces exclamé: 'Por favor, detente, Señor Yavé. Pues, ¿cómo se salvará Jacob, que es tan pequeño?'"
,"6":"Yavé se arrepintió, manifestando que no pasaría nada."
,"7":"Por tercera vez, el Señor me mostró otro espectáculo: Un hombre estaba de pie al lado de un muro con un nivel de plomo en la mano."
,"8":"Y como Yavé me preguntara qué veía yo, le respondí que un nivel de plomo. Entonces el Señor prosiguió: 'Voy a ver si está desplomado o no Israel, pues ya no lo apuntalaré más;"
,"9":"los altos lugares sagrados de Isaac serán demolidos; los santuarios de Israel, destruidos, y yo me lanzaré, espada en mano, contra la familia de Jeroboam.'"
,"10":"Entonces Amasías, sacerdote de Betel, le mandó este recado a Jeroboam, rey de Israel: 'Amós está conspirando contra ti en pleno centro de Israel. No hay que permitirle que siga hablando,"
,"11":"pues dice que a ti te matarán a espada y que Israel será llevado al destierro, lejos de su patria.'"
,"12":"Luego, Amasías fue a decirle a Amós: 'Sal de aquí, visionario; vete a Judá, gánate allá la vida dándotelas de profeta,"
,"13":"pero no profetices más aquí en Betel, que es un santuario real, un templo nacional.'"
,"14":"Amós le replicó: 'Yo no soy profeta ni uno de los hermanos profetas; soy cuidador de rebaños y trato los sicómoros."
,"15":"Yavé es quien me sacó de detrás de las ovejas y me dijo: 'Ve y habla de parte mía a Israel, mi pueblo'."
,"16":"Pues bien, escucha, tú que dices: ¡Basta de profecías contra Israel; deja de insultar a la raza de Isaac!"
,"17":"Escucha esta palabra de Yavé: 'Un día, tu esposa se prostituirá en plena calle, tus hijos e hijas morirán en la guerra. Los vencedores se repartirán tus bienes, tú mismo morirás en tierra extranjera e Israel será llevado lejos de su país.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"El Señor puso ante mis ojos un canasto con frutas maduras,"
,"2":"y me dijo: '¡Qué ves, Amos?' Yo respondí: 'Una canasta de frutas maduras.' Yavé me dijo: 'También está maduro mi pueblo de Israel, el fin ha llegado; ya no le perdonaré más."
,"3":"Ese día sólo habrá en el palacio lamentos en vez de alegres cantos. Serán tantos los muertos, que quedarán tendidos en cualquier parte.'"
,"4":"A ustedes me dirijo, explotadores del pobre, que quisieran hacer desaparecer a los humildes."
,"5":"Ahí están sus palabras: '¿Cuándo pasará la fiesta de la luna nueva, para que podamos vender nuestro trigo? Que pase el sábado, para que abramos nuestras bodegas, pues nos irá tan bien que venderemos hasta el desecho. Vamos a reducir la medida, aumentar los precios y falsear las balanzas.'"
,"6":"Ustedes juegan con la vida del pobre y del miserable tan sólo por algún dinero o por un par de sandalias."
,"7":"Pero no, pues Yavé jura, por su Tierra Santa, que jamás ha de olvidar lo que ustedes hacen."
,"8":"Por eso, la tierra ha temblado y están de duelo sus habitantes, el suelo sube y baja como aumentan y bajan las aguas del Nilo."
,"9":"En ese día, dice Yavé, yo mandaré ponerse el sol en pleno mediodía y las tinieblas se extenderán sobre la tierra en día claro."
,"10":"Cambiaré sus fiestas en velorio y sus cantos en lamentos. Haré que todo el mundo se vista de saco y que todos se rapen la cabeza. Ese día habrá tanto pesar como en los funerales de un hijo único; y el porvenir no será menos amargo."
,"11":"Llegará el día, dice Yavé, en que mandaré al país el hambre, mas no hambre de pan ni sed de agua, sino de oír la palabra de Yavé."
,"12":"Entonces atravesarán mares y recorrerán la tierra desde el norte hasta oriente buscando la palabra de Yavé, pero no la encontrarán."
,"13":"Aquel día desfallecerán de sed las jóvenes hermosas y los jóvenes valientes, los que juraban por el Idolo de Samaria,"
,"14":"los que decían: '¡Viva el Dios de Dan!' y '¡Viva el Dios Querido de Bersebá!' Esos caerán para no levantarse más."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Vi al Señor, de pie junto al altar, que decía: 'Rompe las columnas para que se hunda el techo y les parta a todos la cabeza; y si alguno llega a salvarse, lo mataré a espada; pues ninguno de ellos podrá huir, no escapará nadie con vida."
,"2":"Aunque bajen hasta el infierno, de allí los sacará mi mano; si suben a los cielos, de allí los haré bajar."
,"3":"Si se esconden en la cumbre del Carmelo, allí los buscaré y los agarraré; si se ocultan de mi vista en el fondo del mar, allí mismo mandaré a la serpiente para que los muerda;"
,"4":"cuando vayan cautivos, arreados por sus enemigos, daré orden a la espada para que los degüelle. Tendré mis ojos puestos en ellos, no para ayudarlos sino para castigarlos."
,"5":"Yavé Sabaot es el Señor, si él toca la tierra, ésta se estremece, y se desmayan todos sus habitantes; se levanta entera, como el Nilo y, vuelve a encogerse como el río de Egipto."
,"6":"El ha edificado su morada en los cielos y ha puesto su bóveda sobre la tierra; él junta las aguas del mar para derramarlas por la superficie terrestre; Yavé Sabaot es su nombre."
,"7":"Hijos de Israel, ¿no son ustedes para mí iguales que los etíopes?, dice el Señor. ¿No hice subir a Israel del país de Egipto, como a los filisteos de Caftor y a los arameos de Quis?"
,"8":"Pues bien me estoy fijando en ese reino pecador de Israel, decidido a exterminarlo de la tierra. Sin embargo, no exterminaré totalmente la casa de Jacob, dice Yavé. "
,"9":"Pues ahora estoy dando órdenes para que se sacuda a Israel entre todas las naciones como se limpia el trigo en el harnero, sin que se pierda un solo grano."
,"10":"En cambio, a espada morirán todos los pecadores de mi pueblo, que andan diciendo: 'No depende de ti que se acerque la desgracia y caiga sobre nosotros.'"
,"11":"Aquel día repararé la choza de David medio caída, taparé sus grietas y levantaré sus ruinas; la volveré a edificar tal como estaba antiguamente."
,"12":"Entonces serán dueños de lo que queda de Edom, y de todas las naciones vecinas sobre las cuales era invocado mi Nombre. Yavé es quien lo dice y quien lo hará."
,"13":"Ya se acerca el momento, dice Yavé, en que el que ara alcanzará al segador, y el que vendimia alcanzará al sembrador. El jugo de las uvas correrá sobre los cerros, y habrá abundante mosto en todas las colinas."
,"14":"Entonces traeré de vuelta a los exiliados de mi pueblo Israel: volverán a construir sus ciudades en ruinas y morarán en ellas; plantarán sus viñas y beberán su vino; cultivarán sus huertos y podrán comer sus frutas."
,"15":"Yo los plantaré en su tierra para que nunca más sean extirpados y arrancados del suelo que otrora yo les di, dice Yavé, tu Dios.'"
}`)

}
func ES_LBL_LoadVNHAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Este fue el encargo que recibió en una visión el profeta Habacuq:"
,"2":"¿Hasta cuándo, Yavé, te pediré socorro sin que tú me hagas caso, y te recordaré la opresión sin que tú salves?"
,"3":"¿Por qué me obligas a ver la injusticia? ¿Acaso tus ojos soportan la opresión? Sólo observo robos y atropello y no hay más que querellas y altercados."
,"4":"Por eso, la Ley está sin fuerza y no se hace justicia. Como los malvados mandan a los buenos, no se ve más que derecho torcido."
,"5":"Miren, traidores y contemplen, asómbrense y quédense alelados, porque voy a realizar en su época algo que no creerían si se lo hubieran contado."
,"6":"Pues ahora empujo a los caldeos, pueblo terrible y arrollador, que recorre enormes distancias para apoderarse de países ajenos."
,"7":"Es terrible y temible, y se hace su propio derecho."
,"8":"Sus caballos son más rápidos que las panteras, más tenaces que los lobos de la estepa;"
,"9":"sus jinetes galopan y vienen desde lejos, vuelan como el águila que se precipita sobre su presa. Se lanzan juntos al asalto, sin mirar más que a su presa, y amontonan los cautivos como arena."
,"10":"Este pueblo se burla de los reyes, se ríe de los soberanos; no le importan las ciudades fortificadas, pues levanta terraplenes y se apodera de ellas."
,"11":"¡Y así pasa y se va como el viento...! ¡Su fuerza es su dios!"
,"12":"Mi Dios, mi Santo ¿no eres tú el Yavé de antes que no puede morir? ¿Has hecho de este pueblo, oh Yavé, el instrumento de tu justicia? ¿Acaso lo has escogido, Roca mía, para corregirnos?"
,"13":"Tus ojos son puros y no soportas el mal y ni puedes ver la opresión. ¿Por qué, entonces, miras a los traidores y observas en silencio cómo el malvado se traga a otro más bueno que él?"
,"14":"Tú tratas a los hombres como a los peces del mar, como a los reptiles que no pertenecen a nadie."
,"15":"Ese pueblo los pesca a todos con su anzuelo, los saca con su red y los va amontonando en su malla."
,"16":"Feliz y contento por su pesca, le ofrece sacrificios a su red, quema incienso a sus mallas, pues a ellas les debe que haya pescado tanto y tenga que comer en abundancia."
,"17":"¿Seguirá, pues, tirando constantemente la espada, masacrando sin piedad a las naciones?"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Me ubicaré en mi torre de vigía y me pondré de pie sobre mi almena para ver si diviso su respuesta, lo que él va a contestar a mi pregunta."
,"2":"Entonces Yavé me respondió, diciendo: 'Escribe la visión, anótala en tablillas, para que pueda leerse de corrido."
,"3":"Esta visión espera su debido tiempo, pero se cumplirá al fin y no fallará; si se demora en llegar, espérala, pues vendrá ciertamente y sin retraso."
,"4":"Aquí la tienes: El que vacila nunca contará con mi favor, el justo sí vivirá por su fidelidad.'"
,"5":"¡Ciertamente es traidora la riqueza! El hombre es un tonto, y no gana nada el que ensancha su codicia y se pone insaciable igual que la muerte, que se apodera de todas las naciones y acapara para él todos los pueblos."
,"6":"Un día lo darán en ejemplo y todos se burlarán de él. Y le dedicarán estos versos: ¡Ay de aquel que amontona sin parar cosas que son de otros! Pues está acumulando las deudas. "
,"7":"Vendrán, de pronto tus acreedores, y se despertarán quienes te quiten todas tus cosas."
,"8":"Así como has despojado a muchas naciones, lo que queda de los pueblos te despojará a ti."
,"9":"¡Ay del que levanta a los suyos con ganancias injustas y coloca su nido tan arriba que así piensa escapar de la desgracia!"
,"10":"Es la vergüenza la que has traído sobre tu casa, pues al destruir a tantos pueblos, atentabas contra tu propia vida."
,"11":"Contra ti gritan las piedras de tu muro y las vigas desde el techo le responden."
,"12":"¡Ay del que construye una ciudad a base de sangre y funda un pueblo con medios injustos!"
,"13":"Así lo ha dispuesto Yavé de los Ejércitos, que los pueblos trabajen para el fuego y la gente se canse para nada (14)."
,"15":"Ay del que da de beber a sus vecinos y les pone un narcótico para que se emborrachen, y así se puedan ver sus desnudeces."
,"16":"Esto te acarreará más vergüenza que fama. Toma tú también y emborráchate. En la mano de Yavé la copa se da vuelta, y sobre tu gloria derrama la vergüenza."
,"17":"Sobre ti recaerán la violencia que le hiciste al Líbano, con sus animales masacrados, y sobre ti vendrá el terror, porque has derramado sangre humana, le hiciste violencia a la tierra, a la ciudad y a todos sus habitantes."
,"18":"¿De qué sirve una estatua, para qué se esculpen imágenes? Imagen de metal fundido: cosa engañosa. ¿Cómo su autor puede poner en ella su confianza? Pues no es más que un ídolo mudo."
,"19":"Ay del que dice a un palo: '¡Despierta!', y a una piedra muda: '¡Levántate!' ¿Puede dar alguna respuesta? Por más que esté cubierta de oro y plata, no abriga ningún espíritu."
,"20":"Pero Yavé reside en su Templo santo: ¡calle ante su presencia la tierra entera!"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Oración del profeta Habacuq, en forma de lamentaciones."
,"2":"Después de lo que acabo de oír, me llena de terror lo que vas a hacer, oh Yavé, y que realizarás a los muchos años, que darás a conocer en aquellos días. ¡No olvides tu misericordia,en el tiempo de tu enojo!"
,"3":"Viene Dios de Temán, el Santo, desde el monte Parán. Su majestad envuelve los cielos,y su Gloria repleta la tierra."
,"4":"Se asemeja a la luz su resplandor, un par de rayos brotan de sus manos."
,"5":"Abriéndole camino va la peste, y viene detrás de él la fiebre ardiente."
,"6":"Se detiene, y la tierra se estremece, mira, y se sobresaltan las naciones; las montañas eternas se desploman, las colinas antiguas se derriten,¡Yavé sale como en tiempos pasados!"
,"7":"Vi que cundía el miedo en las tiendas de Cusán; que temblaban de espanto las carpas de Madián."
,"8":"¿Contra quién, oh Yavé, se enciende tu ira?,¿Es tu cólera en contra de los ríos,o estás enfurecido con el mar, para que andes montado en tus caballos, de pie sobre tus carros victoriosos?"
,"9":"Preparas tu arco para disparar,y sacas tus flechas de la aljaba, se abre la tierra y saltan torrentes;"
,"10":"las montañas te ven y se estremecen; caen lluvias de diluvio,mientras truena la voz del abismo."
,"11":"El sol detiene su luz,y la luna se para de repente,al ver el relámpago de tus flechas, el rayo fulgurante de tu lanza."
,"12":"Caminas muy molesto por la tierra, y con ira pisoteas las naciones."
,"13":"Pues llegas en socorro de tu pueblo, para salvar a tu ungido. Al opresor le rompes la cabeza,y lo arrasas hasta sus cimiento."
,"14":"Traspasas con tus flechas la cabeza de sus jefes, que se lanzaban gozosos para aplastarnos, para devorar callando al desdichado."
,"15":"Tus caballos han atravesado la mar, las olas que se agitan con violencia."
,"16":"Al oírlo, mi corazón palpita, al sentirlo, mis labios se estremecen, se corrompe la médula en mis huesos, y temblequean mis piernas. Espero, sin embargo, el día amargo,que sobrevendrá al pueblo opresor."
,"17":"Pues aunque no florezca la higuera,ni den las viñas uva en adelante; aunque falte el producto del olivo,y se niegue la tierra a darnos pan; aunque no tenga ovejas el corral,y se queden sin bueyes los establos;"
,"18":"yo seguiré alegrándome en Yavé, lleno de gozo en Dios, mi Salvador."
,"19":"Yavé, que es mi Señor, es mi fuerza,el da a mis pies la agilidad de un ciervo,y me hace caminar por las alturas. Salmo para el maestro del coro, con instrumentos de cuerdas."
}`)

}
func ES_LBL_LoadVNILChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palabra de Yavé que fue dirigida a Joel, hijo de Petuel."
,"2":"¡Oigan esto, ancianos!, escuchen todos los habitantes del país: ¿Ha sucedido algo semejante en sus tiempos, en tiempos de sus padres?"
,"3":"Cuéntenselo a sus hijos y a sus nietos y a las generaciones venideras."
,"4":"Lo que dejó el gusano, lo devoró la langosta; lo que dejó la langosta, lo devoró el pulgón; lo que dejó el pulgón, lo devoró el grillo."
,"5":"Despierten, borrachos, y lloren; giman todos los bebedores de vino porque se nos quitó de la boca el vino nuevo."
,"6":"Una nación poderosa e innumerable ha invadido mi país; sus dientes son como dientes de león, y tienen colmillos de leona."
,"7":"En ruinas ha dejado mi viña y ha destrozado mis higueras, les sacó toda la corteza, las dejó peladas y con las ramas blancas.."
,"8":"¡Laméntate como la joven que, recién casada, llora por su esposo!"
,"9":"No hay fruto que ofrecer en la Casa de Yavé, de duelo están los sacerdotes al servicio de Yavé."
,"10":"El campo ha sido desolado, de duelo está la tierra porque la cosecha del trigo está perdida; nos falta el vino y el aceite se nos ha terminado."
,"11":"Avergüéncense, labradores; giman, viñadores, por el trigo y la cebada, porque la cosecha de los campos está perdida."
,"12":"La viña se ha secado y la higuera languidece; el granado, la palmera y el manzano, todos los árboles del campo están secos, y se nos fue la alegría como avergonzada."
,"13":"Pónganse su cinturón, sacerdotes, y laméntense. Lloren, ministros del Señor. Vengan a pasar la noche cubiertos de saco, ministros de mi Dios. Ya no se ven ofrendas ni vino en la casa de su Dios."
,"14":"Proclamen un ayuno y una asamblea santa, congreguen a los ancianos y a toda la gente del campo en la Casa de Yavé, su Dios, y clamen a él."
,"15":"¡Ay, qué día! Se acerca el día de Yavé! Es como una devastación mandada por el Todopoderoso."
,"16":"Ya no vemos con qué mantenernos y toda alegría ha huido de la casa de nuestro Dios."
,"17":"La semilla se secó debajo de los terrones, los graneros están vacíos y las granjas arruinadas porque no hay grano. ¡Cómo mugen los animales!"
,"18":"Las manadas de bueyes andan locas porque no tienen pasto, y perecen los rebaños."
,"19":"Oh Yavé, a ti clamo, porque el fuego ha consumido los árboles del campo."
,"20":"Hasta las bestias del campo se vuelven a ti ávidas porque se han secado los arroyos y el fuego ha devorado los prados del llano."
}`)
	CurrentBook.AddChapter(2, `{
"1":"¡Toquen la trompeta en Sión! Den la alarma en mi monte santo. ¡Tiemblen todos los habitantes del país, porque está cerca el día de Yavé: ¡Ahí viene!"
,"2":"¡Día de tinieblas y de oscuridad, día de nubes y de espesa niebla! Ahí viene un pueblo numeroso y fuerte, como jamás hubo otro ni lo habrá después de él, avanza y se extiende como una sombra sobre los cerros."
,"3":"El fuego devora delante de él, detrás de él la llama abrasa. Delante de él, un jardín de delicias; detrás de él queda un desierto. No hay nada que se pueda salvar."
,"4":"Son semejantes a poderosos caballos y se lanzan como caballerías, saltando por los cerros."
,"5":"Es como el estruendo de carros, como el sonido de la llama de fuego que devora la paja seca. Son como un ejército poderoso en orden de batalla."
,"6":"Ante él se estremecen los pueblos, todos los rostros palidecen."
,"7":"Corren como valientes, como asaltantes suben las murallas; cada uno va delante sin equivocarse de camino."
,"8":"Nadie tropieza con su vecino, cada cual va por su camino. Atacan en medio de las flechas, sin romper las filas."
,"9":"Se arrojan sobre la ciudad, corren sobre la muralla, suben hasta las casas, y por las ventanas entran como ladrones."
,"10":"¡Al verlos tiembla la tierra, se estremecen los cielos, el sol y la luna se oscurecen y las estrellas pierden su brillo!"
,"11":"Yavé hace oír su trueno, al frente de su ejército: numerosos son sus soldados, poderosos los que cumplen sus órdenes. Porque grande y temible es el día de Yavé. ¿Quién podrá soportarlo?"
,"12":"Dice Yavé: 'Vuelvan a mí con todo corazón, con ayuno, con llantos y con lamentos.'"
,"13":"Rasguen su corazón, y no sus vestidos, y vuelvan a Yavé su Dios, porque él es bondadoso y compasivo; le cuesta enojarse, y grande es su misericordia; envía la desgracia, pero luego perdona."
,"14":"¡Quién sabe si volverá atrás y nos perdonará y hará producir de nuevo a nuestros campos, de los cuales sacaremos las ofrendas para Yavé!"
,"15":"Toquen la trompeta en Sión, promulguen un ayuno sagrado y llamen a concejo."
,"16":"Congreguen al pueblo, reúnan a los ancianos y que todos se purifiquen. Traigan también a los pequeños y a los niños de pecho, y que los recién casados dejen su cama."
,"17":"En el patio del santuario lloren los sacerdotes ministros de Yavé y digan: '¡Yavé, perdona a tu pueblo, y no lo entregues al desprecio y a la burla de las naciones! ¿Acaso permitirás que los paganos digan: dónde está su Dios?'"
,"18":"Yavé se mostró lleno de celo por su tierra y tuvo piedad de su pueblo."
,"19":"Entonces Yavé respondió y dijo a su pueblo: 'Miren que les envío trigo, vino y aceite, de suerte que puedan saciarse, y no los expondré más a los insultos de las naciones."
,"20":"Al que viene del norte se lo quitaré de encima y lo arrojaré a una tierra árida y desierta, su vanguardia hacia el mar oriental, su retaguardia hacia el mar occidental, y subirá su pestilencia y hediondez, porque yo obro maravillas.'"
,"21":"No temas, tierra; alégrate y regocíjate, porque Yavé obra grandes cosas."
,"22":"No teman, animales del campo, porque los prados del desierto han reverdecido, los árboles han dado su fruto, la higuera y la vid, sus riquezas."
,"23":"Y ustedes, hijos de Sión, alégrense en Yavé, su Dios, porque él les da la lluvia de otoño para la fertilidad y hace caer agua en otoño y primavera como antes."
,"24":"Las eras se llenarán de trigo puro, los lagares desbordarán de vino y aceite virgen."
,"25":"Yo los compensaré por los años que les devoró la langosta y el pulgón, el grillo y la oruga, mi gran ejército, que contra ustedes había mandado."
,"26":"Comerán y se saciarán, alabarán el Nombre de su Dios, que ha obrado con ustedes de modo maravilloso, mi pueblo no será ya jamás confundido,"
,"27":"y sabrán ustedes que yo estoy en medio de Israel, yo Yavé, su Dios, y no hay otro. Mi pueblo no será ya jamás confundido."
}`)
	CurrentBook.AddChapter(3, `{
"1":"'Esto es lo que ha de suceder después: Yo derramaré mi Espíritu sobre cualquier mortal. Tus hijos y tus hijas profetizarán, los ancianos tendrán sueños,y los jóvenes verán visiones."
,"2":"Hasta sobre los siervos y las sirvientas,derramaré mi Espíritu en aquellos días."
,"3":"Daré a ver señales en el cielo, y en la tierra habrá sangre, fuego y nubes de humo."
,"4":"El sol se cambiará en tinieblas,y la luna en sangre,cuando se acerque el día de Yavé, día grande y terrible."
,"5":"Entonces serán salvados,todos aquellos que invoquen el Nombre de Yavé. Pues unos se salvarán en el cerro Sión, habrá sobrevivientes en Jerusalén, como lo ha dicho Yavé; allí estarán los que llame Yavé."
}`)
	CurrentBook.AddChapter(4, `{
"1":"En aquellos días cambiaré la suerte de Judá y de Jerusalén."
,"2":"Reuniré todas las naciones y las haré descender al valle de Josafat. Allí discutiré con ellas la causa de mi pueblo y de mi heredad, Israel, a quien ellas han dispersado entre las naciones, mientras se repartían mi tierra."
,"3":"Se jugaron a los dados a mi pueblo; cambiaron al niño por la prostituta y a la niña la vendieron por vino para emborracharse."
,"4":"Y ustedes, ¿qué son ustedes para mí, Tiro y Sidón y todos los distritos de Filistea? ¿Tomarán acaso represalias contra mí? Si las quieren tomar, bien pronto volveré estas represalias sobre su propia cabeza."
,"5":"Ustedes que robaron mi plata y mi oro y se llevaron mis más hermosas joyas a sus templos"
,"6":"y vendieron los hijos de Judá y los hijos de Israel a los griegos, alejándolos de su tierra,"
,"7":"sepan que yo los voy a despertar del lugar donde ustedes los vendieron y haré caer las represalias de ustedes sobre sus cabezas."
,"8":"Venderé a los hijos e hijas de ustedes por medio de los hijos de Judá, que los venderán a los sabeos, nación lejana. Yavé lo ha dicho."
,"9":"Publiquen esto entre las naciones, proclamen una guerra santa, despierten a los valientes, avancen y suban todos los hombres de guerra."
,"10":"Conviertan sus azadones en espadas y sus hoces en lanzas, que el débil diga: 'Soy un valiente.'"
,"11":"Dense prisa y lleguen pronto, todas las naciones de alrededor, reúnanse allí. ¡Haz bajar, Yavé, a tus valientes!"
,"12":"Que despierten y suban las naciones al valle de Josafat, porque allí me sentaré para juzgar a todas las naciones de alrededor."
,"13":"Metan la hoz, pues los sembrados están maduros, vengan y pisen, porque el lagar está lleno y las cubas desbordan, ¡tan grande es su maldad!"
,"14":"Multitudes y multitudes en el Valle de la Decisión, porque está cerca el día de Yavé en el Valle de la Decisión."
,"15":"El sol y la luna se oscurecieron y las estrellas retiraron su resplandor."
,"16":"Yavé ruge desde Sión y desde Jerusalén hace oír su voz. Los cielos y la tierra se han conmovido. Porque Yavé es un refugio para su pueblo y un asilo para los hijos de Israel."
,"17":"Y sabrán que yo soy Yavé, su Dios, que habito en Sión, mi monte santo, y Jerusalén será un lugar santo por el que no pasará extranjero."
,"18":"En aquellos días los montes destilarán vino, y de las colinas manará leche; en todos los torrentes de Judá correrá el agua y una fuente saldrá de la Casa de Yavé para regar el valle de las acacias."
,"19":"Egipto quedará todo en ruinas y Edom en un desierto desolado, por la violencia que cometieron contra los hijos de Judá, porque derramaron sangre inocente en su tierra."
,"20":"Pero Judá será habitado para siempre, y Jerusalén, de generación en generación. No me quedaré indiferente sino que vengaré la sangre, pues sepan que Yavé habita en Sión."
}`)

}
func ES_LBL_LoadVNINChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"La palabra de Yavé fue dirigida a Jonás, hijo de Amittay, en estos términos:"
,"2":"'Levántate, vete a Nínive, la ciudad grande, y predica contra ellos, porque su maldad ha subido hasta mí.'"
,"3":"Se levantó Jonás, pero fue para huir a Tarsis, lejos de la presencia de Yavé. Descendió a Jafa, donde encontró un barco que salía para Tarsis, pagó su pasaje y se embarcó para irse con ellos a Tarsis, lejos del rostro de Yavé."
,"4":"Pero Yavé envió un fuerte viento sobre el mar, causando una tempestad tan grande que el barco amenazaba hundirse."
,"5":"Los marineros tuvieron miedo y cada uno invocaba a su Dios. Después echaron la carga del barco al mar para sacarle peso. Jonás, mientras tanto, había bajado al fondo del barco para tomar descanso, y dormía profundamente."
,"6":"El capitán se acercó a él y le dijo: '¿Cómo estás durmiendo? Levántate, invoca a tu Dios, quizá se acuerde de nosotros y no pereceremos.'"
,"7":"Después se dijeron unos a otros: 'Echemos suertes para saber quién nos trajo ese mal.' Echaron suertes y la suerte cayó en Jonás."
,"8":"Entonces le dijeron: 'Tiene que haber un causante de nuestra desgracia; enséñanos, pues, cuál es tu oficio y de dónde vienes. ¿Cuál es tu país y de qué pueblo eres?'"
,"9":"Entonces empezó a decirles: 'Soy hebreo y temo a Yavé, Dios del Cielo, que hizo el mar y los continentes...'"
,"10":"Aquellos hombres tuvieron gran miedo y le dijeron: '¿Qué es lo que has hecho?' Pues ahora esos hombres sabían que huía de la presencia de Yavé."
,"11":"Le dijeron: '¿Qué haremos contigo para que se calme el mar?' Pues el mar se embravecía."
,"12":"Jonás les contestó: 'Llévenme y arrójenme al mar, y éste se calmará, porque sé que por culpa mía les ha sobrevenido esta tempestad.'"
,"13":"Pues, por más que los marineros se esforzaban remando por alcanzar tierra, no podían, y el mar cada vez se ponía más agitado."
,"14":"Entonces invocaron a Yavé y le dijeron: 'Oh Yavé, no nos hagas perecer a todos por causa de este hombre, ni nos consideres culpables de su muerte, ya que tú, Yavé, has obrado todo según deseabas.'"
,"15":"Luego, llevando a Jonás, lo tiraron al mar, y el mar calmó su furia."
,"16":"Aquellos hombres temieron a Yavé y con gran respeto le ofrecieron un sacrificio y le hicieron votos."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Yavé ordenó a un gran pez que tragara a Jonás, y Jonás estuvo tres días y tres noches en el vientre del pez."
,"2":"Entonces Jonás dirigió esta oración a Yavé, su Dios, desde el vientre del pez:"
,"3":"'En mi angustia llamé a Yavé,y me respondió, grité desde el lugar de los muertos,y tú oíste mi voz."
,"4":"Me habías arrojado en el corazón del mar, y la corriente me cercaba, tus olas y tus remolinos pasaban sobre mí."
,"5":"Y dije: He sido arrojado de tu presencia, nunca más veré tu santo templo."
,"6":"Me subían las aguas hasta el cuello, el abismo me rodeaba, las algas se enredaban en mi cabeza."
,"7":"A las raíces de los montes descendí, al país cuyos cerrojos se cierran para siempre, pero me hiciste subir de la fosa, ¡oh Yavé, mi Dios!"
,"8":"Cuando en mí se me desfallecía el alma, me acordé de Yavé, y mi oración llegó a ti, a tu santo templo."
,"9":"Los que sirven los ídolos vanos,sacrifican sus esperanzas;"
,"10":"pero yo en acción de gracias,te ofreceré un sacrificio y cumpliré mis votos: de Yavé viene la salvación.'"
,"11":"Entonces Yavé dio orden al pez y éste vomitó a Jonás sobre la tierra."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Por segunda vez la palabra de Yavé llegó a Jonás y le dijo:"
,"2":"'Levántate, vete a Nínive, la gran ciudad, y anuncia lo que yo te diga.'"
,"3":"Se levantó Jonás y fue a Nínive, como se lo había ordenado Yavé. Nínive era una ciudad muy grande. Se necesitaban tres días para atravesarla. "
,"4":"Jonás entró en la ciudad e hizo un día de camino pregonando: 'Dentro de cuarenta días Nínive será destruida.'"
,"5":"Los ninivitas creyeron en la advertencia de Dios y ordenaron un ayuno, y se vistieron de saco desde el mayor al menor."
,"6":"La noticia llegó hasta el rey de Nínive, que se levantó de su trono, se quitó el manto, se vistió de saco y se sentó sobre cenizas."
,"7":"Luego hizo publicar esta orden en Nínive: 'Hombres y bestias no comerán ni beberán nada."
,"8":"Que se vistan de saco y clamen a Dios insistentemente. Que cada uno se corrija de su mala conducta y de sus malas obras."
,"9":"¿Quién sabe si Dios se arrepentirá y cesará su enojo, de manera que no nos haga morir?'"
,"10":"Al ver Dios lo que hacían y cómo se habían arrepentido de su mala conducta, se arrepintió él también y no los castigó como los había amenazado."
}`)
	CurrentBook.AddChapter(4, `{
"1":"A Jonás esto no le gustó nada, y se enojó."
,"2":"Se dirigió a Yavé y le dijo: 'Ah, Yavé, es exactamente lo que yo preveía cuando estaba todavía en mi tierra, y por esto traté de huir a Tarsis. Yo sabía que tú eres un Dios clemente y misericordioso, paciente y lleno de bondad, siempre dispuesto a perdonar."
,"3":"Oh Yavé, te ruego que tomes mi vida, pues ahora es mejor para mí morir que vivir.'"
,"4":"Yavé le contestó: 'Jonás, ¿crees tú que tienes razón para enojarte así?'"
,"5":"Pero Jonás salió de Nínive y se hizo una cabaña al este de la ciudad, para ver lo que sucedería a la ciudad."
,"6":"Entonces Yavé Dios hizo brotar una planta de ricino que creció por encima de Jonás para dar sombra a su cabeza y así calmarlo de su enojo. Jonás se alegró mucho por la planta."
,"7":"Pero al día siguiente, al amanecer, Yavé mandó un gusano que malogró la planta y la secó."
,"8":"Al salir el sol, Yavé hizo soplar viento caliente desde el este. El sol acaloró tanto a Jonás que éste se desmayó. Se deseó la muerte y dijo: 'Mejor es morir que vivir.' "
,"9":"Entonces Yavé le preguntó: '¿Te parece bien enojarte por este ricino?' Jonás respondió: 'Sí, tengo razón para estar enojado hasta el punto de querer morir.'"
,"10":"Yavé le replicó: 'Te afliges por un ricino que no te ha costado trabajo alguno y que no has hecho crecer, que en una noche ha nacido y en una noche ha muerto."
,"11":"¿Cómo, pues, yo no voy a tener lástima de Nínive, la gran ciudad, donde hay más de ciento veinte mil personas que no saben distinguir el bien y el mal, y gran cantidad de animales?'"
}`)

}
func ES_LBL_LoadVNMIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Estas fueron las palabras de Yavé a Miqueas de Moreset en tiempos de Jotam, Ajaz y Ezequías, reyes de Judá; y éstas, sus visiones sobre Samaria y Jerusalén."
,"2":"Que escuchen todos los pueblos; que ponga atención la tierra y todo lo que contiene, pues Yavé sale de su palacio santo para declarar en contra de ustedes."
,"3":"Miren cómo sale de su santa morada, bajando y caminando por las cumbres de la tierra."
,"4":"A su paso se desmoronan las montañas y los valles se hunden como cera ante el fuego o como el agua que se escurre por la pendiente."
,"5":"Jacob es el culpable de todo esto, y los hijos de Israel con sus pecados. ¿Cuál es el delito de Jacob? ¿No es Samaria? ¿Cuál es el pecado de Judá? ¿No es Jerusalén?"
,"6":"Convertiré a Samaria en un campo cubierto de escombros, que no sirve más que para viñas. Echaré a rodar sus piedras por el valle y así quedarán a la vista sus cimientos."
,"7":"Todas sus estatuas serán hechas pedazos y sus ídolos serán tirados al fuego, porque las compraron con el salario de sus prostitutas y pasarán a ser salario de prostitutas."
,"8":"Por todo esto lloraré y gemiré, caminaré desnudo y sin zapatos, lloraré como aúllan los chacales y gemiré como lo hacen los avestruces,"
,"9":"porque las llagas de Samaria son incurables y han llegado hasta Judá, alcanzando la capital de mi pueblo, la misma Jerusalén."
,"10":"No lo anuncien en Gat ni lloren por ello en Aco. Los de Betlefrá, revuélquense en el polvo."
,"11":"Habitante de Safi, toca el clarín. Que no salgan de su ciudad los que viven en Sanán. Betaesel es arrancada de sus cimientos, en los que se apoyaba."
,"12":"¿Cómo podría ser feliz la que habita en Marot, cuando la desgracia que viene de Yavé golpea la puerta de Jerusalén?"
,"13":"Prepara el carro con sus caballos, tú que vives en Laquis, pues por tu culpa empezó a pecar la hija de Sión, ya que tú le enseñaste el mal que se cometía en Israel."
,"14":"Por eso, tú deberás pagar una fianza por Moreset-Gat. Betaksib será una trampa para los reyes de Israel."
,"15":"Volverá de nuevo el invasor, habitante de Maresa, y los que eran la gloria de Yavé se irán para siempre."
,"16":"Córtate el pelo al rape por tus hijos tan queridos, quédate pelada como el buitre, pues han sido llevados lejos de ti."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Pobres de ustedes que meditan la injusticia, que toda la noche traman el mal, y al amanecer lo ejecutan cuando está a su alcance."
,"2":"Si les gustan unos campos, se los roban; si unas casas, se las toman. Se apoderan de la casa y de su dueño, de un hombre y de su propiedad."
,"3":"Por eso, dice Yavé, yo también tramo el mal contra esa gente, una desgracia tan grande que no podrán hacerle el quite ni caminar con la frente en alto."
,"4":"Cuando llegue aquel día, otros se burlarán de ustedes y les cantarán la canción: 'Hemos sido saqueados; han repartido nuestras tierras. ¿Quién echará al opresor que se adueñó de mis campos?'"
,"5":"Cuando se reúna la asamblea de Yavé, no habrá nadie para reservarles una parcela."
,"6":"'No gastes tu saliva, dicen ellos, en anunciar todas estas cosas, pues nada malo nos pasará."
,"7":"¿Va a ser maldita la raza de Jacob? ¿Acaso Yavé se pondría nervioso? ¿Es así cómo procede? ¿No tiene más bien palabras de bondad para su pueblo, Israel?'"
,"8":"Pero son ustedes los enemigos de mi pueblo, pues le quitan su manta al hombre bueno y hacen la guerra al que vive tranquilo."
,"9":"Arrancan de sus hogares tan queridos a las mujeres de mi pueblo y les quitan a sus hijos la libertad que yo les había dado."
,"10":"Ustedes son de los que dicen: 'Levántense y caminen, pues aquí no se descansa.' Debido a sus pecados irán amarrados al cautiverio."
,"11":"Si un falso profeta fuera capaz de decir: 'Yavé te va a dar vino y aguardiente', éste sería el profeta de ese pueblo."
,"12":"Quiero reunir a Jacob entero, y recoger el resto de Israel. Los pondré como un rebaño en el corral, como rebaño en medio del pastizal, como una multitud alegre."
,"13":"El que abre camino saldrá delante de ellos, y ellos alargarán el paso; les hará pasar la puerta y por ella saldrán; sí, su rey marchará delante de ellos, Yavé los encabezará."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Yo les diré: Escuchen, jefes de Jacob, señores de las tribus de Israel. ¿No deberían conocer lo que es justo? ¿Por qué, pues, odian el bien y aman el mal?"
,"2":"Ustedes descueran vivos a los de mi pueblo y les arrancan la carne de sus huesos."
,"3":"Ustedes pueden comerse la carne de mi pueblo, partir sus huesos y echarlos a la olla,"
,"4":"pero cuando me llamen no les haré caso, sino que les ocultaré mi cara por sus malas acciones."
,"5":"Esto dice Yavé en contra de los profetas que engañan a mi pueblo: Si pueden masticar a dos canillas, anuncian la paz; pero si alguien no les llena la boca, le declaran la guerra."
,"6":"Por eso, les dice: 'Noche para ustedes, y no más visiones; tinieblas en vez de revelaciones; el sol se pone para los profetas y su día se cambia en tinieblas.'"
,"7":"Los videntes se llenarán de vergüenza, y los adivinos, de confusión; unos y otros se taparán la cara porque Dios no les responde."
,"8":"Yo, al contrario, estoy lleno del espíritu de Yavé. El me da celo por la justicia, me llena de fuerza y de ánimo para denunciar a Jacob su pecado, para descubrir las faltas de Israel."
,"9":"Escuchen esto, gobernantes del pueblo de Jacob, ustedes que son los señores de Israel, ustedes que desprecian la justicia y que tuercen mañosamente la ley:"
,"10":"Sión se está edificando sobre sangre, y Jerusalén, en base a crímenes."
,"11":"Sus gobernantes se dejan comprar para dar una sentencia; sus sacerdotes cobran por una decisión; sus profetas sólo vaticinan si se les paga. Y todos se sienten tan seguros de Yavé que dicen: Si el Señor está con nosotros, ¿qué desgracia nos puede pasar?"
,"12":"Pero precisamente por sus maldades Sión va a quedar como un potrero arado, Jerusalén será reducida a escombros y el cerro del Templo será cubierto por el bosque."
}`)
	CurrentBook.AddChapter(4, `{
"1":"En el futuro, el cerro de la Casa de Yavé será puesto sobre los altos montes y dominará los lugares más elevados. Irán a verlo todas las naciones "
,"2":"y subirán hacia él muchos pueblos, diciendo: 'Vengan, subamos al cerro de Yavé, a la Casa del Dios de Jacob, para que nos enseñe sus caminos y caminemos por sus sendas. Porque la enseñanza irradia de Sión, de Jerusalén sale la palabra de Yavé.'"
,"3":"El Señor gobernará las naciones y enderezará a la humanidad. Harán arados de sus espadas y sacarán hoces de sus lanzas. Una nación no levantará la espada contra otra y no se adiestrarán para la guerra."
,"4":"Cada uno podrá permanecer sentado bajo su parrón o su higuera sin que nadie lo moleste; pues así lo dice el Señor."
,"5":"Mientras todos los pueblos caminan cada uno en nombre de sus dioses, nosotros caminamos en el Nombre de Yavé, nuestro Dios, por siempre jamás."
,"6":"Ese día, dice Yavé, recogeré a la oveja coja y llevaré al corral a la perdida, y a la que había maltratado."
,"7":"De las cojas salvaré un resto, y haré de las extraviadas una nación poderosa. Reinaré sobre ellas en el monte Sión, desde ahora y para siempre."
,"8":"Y tú, Sión, torre de donde se vigila el rebaño, recuperarás la antigua soberanía, la autoridad real sobre todo Israel."
,"9":"¿Por qué ahora gritas de esa manera? ¿Te quedaste sin rey o desaparecieron tus ministros para que te quejes de dolor como mujer que da a luz?"
,"10":"Retuércete de dolor y grita, hija de Sión, como mujer que da a luz, porque ahora saldrás de la ciudad para vivir en despoblado. Llegarás hasta Babilonia, pero allí serás liberada, pues Yavé te libertará del poder de tus enemigos."
,"11":"Naciones numerosas se reúnen ahora para atacarte, diciendo: 'Sometámoslo al saqueos y gocemos mirando su derrota.'"
,"12":"Pero ellos no saben lo que piensa Yavé y no comprenden sus designios, pues él los ha juntado como a las gavillas en la era."
,"13":"¡Levántate, pues, y aplástalos con tus pies, hija de Sión, porque te pondré cuernos de hierro, y pezuñas de bronce para que tritures a muchos pueblos! Entonces consagrarás sus despojos a Yavé, y sus riquezas serán para el Señor del mundo entero."
,"14":"Ahora ¡ánimo!, fortaleza, pues nos rodean con trincheras y le dan un varillazo en la cara al que gobierna a Israel."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Pero tú, Belén Efrata, aunque eres la más pequeña entre todos los pueblos de Judá, tú me darás a aquel que debe gobernar a Israel: su origen se pierde en el pasado, en épocas antiguas."
,"2":"Por eso, si Yavé los abandona es sólo por un tiempo, hasta que aquella que debe dar a luz tenga su hijo. Entonces el resto de sus hermanos volverá a Israel."
,"3":"El se mantendrá a pie firme y guiará su rebaño con la autoridad de Yavé, para gloria del Nombre de su Dios; vivirán seguros, pues su poder llegará hasta los confines de la tierra."
,"4":"El mismo será su paz. Cuando Asiria invada nuestra tierra y pise nuestro suelo, le opondremos siete pastores, ocho de nuestros jefes."
,"5":"Con su espada dominará a Asiria, sus armas someterán la tierra de Nemrod. Así, nos librará de los asirios cuando invadan nuestro territorio y traspasen nuestras fronteras."
,"6":"Entonces el resto de Jacob será en medio de numerosos pueblos como rocío enviado por Yavé, como gotas de lluvia sobre el pasto, pues ya no esperarán más en los hombres ni pondrán en los mortales su confianza."
,"7":"Entonces el resto de Jacob será en medio de numerosos pueblos como león entre los animales de la selva, como cachorro entre los rebaños de corderos, que aplasta cuanto encuentra a su paso, y nadie puede arrebatarle su presa."
,"8":"Yavé, ¡que tu mano quiebre a tus adversarios, y perezcan todos tus enemigos!"
,"9":"Aquel día, dice Yavé, te sacaré tus caballos y destruiré tus carros,"
,"10":"borraré de tu suelo las ciudades y demoleré todas tus fortalezas,"
,"11":"arrancaré de tus manos tus supercherías, y ya no tendrás más a tus adivinos."
,"12":"Sacaré de en medio de ti tus estatuas y tus ídolos; y así no podrás más postrarte delante de algo hecho por tus manos."
,"13":"Arrancaré también tus postes sagrados y no dejaré en pie ídolo alguno."
,"14":"Luego me haré justicia, con indignación y furor, de las naciones que no me obedecieron."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Escuchen ahora lo que me dice Yavé: 'Presenta tu querella delante de las montañas y que oigan tu acusación las colinas.'"
,"2":"Escuchen, pues, montañas, la demanda de Yavé y sirvan de testigos los inconmovibles fundamentos de la tierra, pues Yavé tiene un pleito con su pueblo, se ha querellado con Israel:"
,"3":"'Pueblo mío, ¿qué te he hecho yo y en qué te he molestado? Respóndeme."
,"4":"Yo te saqué de Egipto y te rescaté de la casa de los esclavos; yo puse para que te guiaran a Moisés, Aarón y Miriam."
,"5":"Acuérdate, pueblo mío, de lo que pensaba hacer contigo Balac, rey de Moab, y de lo que le respondió Balaam, hijo de Beor. Te hizo pasar desde Sitim hasta Guilgal, para que así conozcas a Yavé.'"
,"6":"'¿Con qué me presentaré delante de Yavé? ¿Cómo iré a arrodillarme delante del Dios Altísimo? ¿Acaso le traeré holocaustos o terneros de un año?"
,"7":"¿O le gustarán miles de carneros y torrentes de aceite? ¿O será necesario que sacrifique a mi hijo mayor para pagar mi culpa, al fruto de mis entrañas por mi pecado?'"
,"8":"Ya se te ha dicho, hombre, lo que es bueno y lo que el Señor te exige: tan sólo que practiques la justicia, que seas amigo de la bondad y te portes humildemente con tu Dios."
,"9":"Resuena la voz de Yavé en la ciudad: Escuchen, tribus, óyeme asamblea de la ciudad."
,"10":"¿Voy a soportar una medida falsa, un galón disminuido?"
,"11":"¿Voy a aceptar que usen balanzas inexactas con pesas falsificadas?"
,"12":"En esta ciudad los ricos se enriquecen en base a crímenes, y los habitantes se han acostumbrado a mentir."
,"13":"Por eso, yo mismo he empezado a maltratarte, a arruinarte debido a tus pecados."
,"14":"Comerás, pero quedarás con hambre; reservarás cosas, pero no podrás guardar nada; y si logras salvar algo, yo lo entregaré a la espada."
,"15":"Sembrarás, pero no podrás cosechar; molerás las aceitunas pero no aprovecharás el aceite; exprimirás la uva, pero no beberás el vino."
,"16":"Tú observas los decretos de Omri y todas las normas de la familia de Ajab, pero si tú sigues sus ejemplos, yo te pondré de ejemplo terrible, para que se burlen de tus habitantes y para que seas despreciada por todo el mundo."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Pobre de mí, pues me parezco a los que recogen espigas después de la siega o a los que rebuscan racimos después de la vendimia, pero no hay ni un racimito para probarlo ni una de esas primeras brevas que me gustan."
,"2":"Los creyentes han desaparecido del país, y entre sus habitantes no se encuentra ni siquiera un hombre justo."
,"3":"Sus manos son buenas para hacer el mal: el príncipe es exigente; el juez se deja comprar; el poderoso decide lo que le conviene."
,"4":"Su bondad es la del cardo, su honradez peor que una hilera de espinos. ¡Pobres de ellos! Ahora viene el juicio, el día de su castigo, y ahora no saben qué hacer."
,"5":"No crean en su compañero, ni confíen en su amigo; cuídate de la que se acuesta contigo."
,"6":"Porque ahora el hijo insulta a su padre, la hija se rebela contra su madre, la nuera contra su suegra, y cada cual tiene por enemigos a las personas de su familia."
,"7":"Pero yo miraré al Señor, esperaré en el Dios que me salva; mi Dios me atenderá."
,"8":"No te alegres de mi desgracia, oh enemiga mía, pues si he caído, me levantaré; si ahora estoy a oscuras, Yavé será mi luz."
,"9":"Por ahora debo soportar la cólera de Yavé, pues me rebelé contra él, mientras examina mi causa y me hace justicia; entonces me hará salir a la luz y yo veré su fidelidad."
,"10":"Mi enemiga, al verlo se sentirá avergonzada, pues decía: ¿Dónde se metió tu Dios? Mis ojos se recrearán viendo cómo es pisoteada, igual que el barro de las calles."
,"11":"Ya llega el día en que se reedificarán tus fortificaciones, el día en que se ampliarán tus fronteras,"
,"12":"el día en que vendrán a ti desde Asiria hasta Egipto, desde Tiro hasta el Eufrates, de uno a otro mar, de una a otra cordillera."
,"13":"El país se convertirá en un desierto por culpa de sus habitantes: esto será el fruto de sus maldades."
,"14":"Apacienta con tu vara a tu pueblo, al pequeño rebaño que te pertenece y que todavía permanece extraviado en los matorrales, en una zona de excelentes pastizales. Concédele que pueda ir a pastar en Basán y en Galaad, como lo hacía antiguamente."
,"15":"Haz que presenciemos tus prodigios como en los días de la salida de Egipto."
,"16":"Al verlo las naciones se sentirán derrotadas a pesar de todo su poderío; se taparán la boca con la mano y quedarán atontadas."
,"17":"Morderán el polvo como la serpiente, como los reptiles que se arrastran por el suelo. Saldrán temblando de sus refugios, y en tu presencia se sentirán despavoridos y asustados."
,"18":"¿Qué Dios hay como tú, que borra la falta y que perdona el crimen; que no se encierra para siempre en su enojo, sino que le gusta perdonar?"
,"19":"Una vez más te compadecerás de nosotros, pisotearás nuestras faltas. Tira, pues, al fondo del mar todos nuestros pecados."
,"20":"Concede a Jacob tu fidelidad, a Abraham tu misericordia, como lo juraste a nuestros padres desde los días antiguos."
}`)

}
func ES_LBL_LoadVNMLChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Esta advertencia es la palabra que dirigió Yavé a Israel por medio de Malaquías. Yo los he amado, dice Yavé. "
,"2":"Pero ustedes dicen: '¿En qué has demostrado ese cariño?' Por eso, les pregunta Yavé: ¿No era Esaú hermano de Jacob?"
,"3":"Pues bien, yo le tuve cariño a Jacob, pero le tomé odio a Esaú; si no, miren cómo dejé sus montañas desoladas y abandoné sus tierras a los chacales del desierto."
,"4":"Si Edom afirma que empezará a reconstruir sus ruinas, a pesar de haber sido destruidas, Yavé de los Ejércitos les advierte: '¿Qué sacan con reconstruir, si yo se lo demoleré? A ustedes los llamarán 'país maldito' y 'nación con la que Yavé se ha disgustado para siempre'.'"
,"5":"Con sus propios ojos podrán ustedes comprobar esto; entonces exclamarán: 'El poder de Yavé traspasa las fronteras de Israel.'"
,"6":"El hijo honra a su padre; el servidor respeta a su patrón. Pero si yo soy padre, ¿dónde está la honra que se me debe? O si yo soy su patrón, ¿dónde el respeto a mi persona? Esto es lo que Yavé de los Ejércitos quiere saber de ustedes, sacerdotes que desprecian su Nombre. Ustedes dirán: '¿En qué hemos menospreciado tu Nombre?'"
,"7":"Miren, ustedes presentan sobre mi altar alimentos impuros. Ustedes seguramente replicarán: '¿En qué te hemos profanado?' Lo han hecho cuando han pensado que la mesa de Yavé no merece respeto. "
,"8":"Cuando ustedes traen para sacrificarla una bestia ciega, o cuando presentan una coja o enferma, ¿creen que actúan bien? Llévasela al gobernador a ver si queda contento o si te recibe bien, dice Yavé de los ejércitos."
,"9":"Así es como ustedes piden a Dios sus favores. Pero, ¿creen ustedes que los atenderá?"
,"10":"¿Quién de ustedes cerrará las puertas del templo para que no vengan más ustedes a encender mi altar inútilmente? Pues ustedes ahora sólo me molestan, les dice Yavé de los Ejércitos, y me desagradan totalmente sus ofrendas."
,"11":"Desde donde sale el sol hasta el ocaso, en cambio, todas las naciones me respetan y en todo el mundo se ofrece a mi Nombre tanto el humo del incienso como una ofrenda pura. Porque mi Nombre es grande en las mismas naciones paganas, dice Yavé de los ejércitos."
,"12":"Ustedes, mientras tanto, profanan mi Nombre cuando dicen: 'La mesa del Señor está sucia y su comida no es muy rica.'"
,"13":"Y me desprecian cada vez que dicen: '¡Qué lata!', palabra de Yavé. Ustedes toman para ofrecérmelo en sacrificio un animal robado, cojo o apestado. ¿Y creen que les voy a aceptar eso?"
,"14":"Maldito sea el tramposo que, teniendo en su rebaño un toro, luego de prometérmelo, me sacrifica una bestia raquítica. Porque el Rey grande soy yo, y mi Nombre será respetado en todas las naciones, dice Yavé de los Ejércitos."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Para ustedes, sacerdotes, es también esta advertencia. Si no la escuchan ni se preocupan de glorificar mi nombre, dice Yavé de los Ejércitos, les lanzaré la maldición y maldeciré también sus bendiciones."
,"2":"Ya las he maldecido, porque ninguno de ustedes toma su oficio en serio."
,"3":"Voy a quebrarles el brazo; les tiraré a la cara lo que recogeré detrás de los animales que me sacrifican, y los barreré junto con ello."
,"4":"Y comprobarán que yo he sido quien les hizo esta advertencia para restaurar mi alianza con Leví, declara Yavé de los Ejércitos."
,"5":"En mi alianza con él se hablaba de vida y de paz, y se las concedí; se hablaba también de respeto y él me respetó y reverenció mi Nombre."
,"6":"El levita enseñaba la verdadera doctrina y nada perverso salía de sus labios; me servía, traía paz y justicia y apartaba a muchos del mal."
,"7":"Porque los labios del sacerdote guardan el conocimiento y en su boca se debe encontrar la ley, pues es el mensajero de Yavé de los ejércitos."
,"8":"Pero ustedes se han desviado del camino, dice Yavé de los ejércitos, y han hecho que muchos tropiecen en cosas de la Ley."
,"9":"Por eso, yo permití que todo el pueblo los despreciara y los considerara indignos, debido a que ustedes se separaron de mí y dieron fallos para cada cual según a ustedes les convenía."
,"10":"¿No tenemos todos un mismo padre? ¿No nos ha creado a todos un mismo Dios? ¿Por qué, entonces, cada uno se aprovecha de su hermano, profanando la alianza de nuestros padres?"
,"11":"Judá ha cometido una traición, una cosa vergonzosa se ha hecho en Jerusalén: Judá ha profanado el santuario preferido de Yavé, casándose con la hija de un dios extranjero."
,"12":"¡Que Yavé arranque de las tiendas de Jacob al que haga esto, que no haya nadie que lo defienda en los tribunales ni nadie que presente por él una ofrenda a Yavé!"
,"13":"Ustedes cometen otra falta: como Yavé se niega a mirar sus ofrendas y no quiere recibírselas, ustedes se ponen a llorar y a gemir cubriendo con lágrimas el altar."
,"14":"Y luego se preguntan: '¿Por qué será?',Porque Yavé ha visto cómo tú traicionas a la esposa que tomaste cuando joven. Ella ha sido tu compañera y con esta mujer te habías comprometido. "
,"15":"¿No ha hecho Dios, de ambos, un solo ser que tiene carne y respira? Y este ser único, ¿qué busca sino una familia dada por Dios? No traiciones, pues, a la mujer de tu juventud."
,"16":"Odio el divorcio, dice Yavé, Dios de Israel, y al que hace el mal sin manifestar vergüenza. Tengan, pues, mucho cuidado y no cometan tal traición."
,"17":"Ustedes aburren a Yavé con sus discursos y todavía dicen: '¿En qué le hemos molestado?' Ustedes lo molestan cuando afirman que Yavé mira complacido a cuantos actúan mal, ya que les va bien en todo, o cuando se preguntan: '¿Dónde estará el Dios que hace justicia?'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Estoy para enviar a mi mensajero, al que despejará el camino delante de mí; pues pronto entrará en su santuario el Señor que ustedes piden. Fíjense que ya llega el mensajero de la alianza que ustedes tanto desean, dice Yavé de los ejércitos."
,"2":"¿Quién podrá mantenerse en pie cuando aparezca? Pues él es como el fuego de una fundición y como la lejía que se usa para blanquear."
,"3":"Purificará a los hijos de Leví y los refinará como se hace con la plata. Como el oro y la plata, volverán a ser auténticos y dignos de ofrecer a Yavé la ofrenda como es debido."
,"4":"Entonces Yavé aceptará con gusto la ofrenda de Judá y de Jerusalén, como ocurría antiguamente, en épocas pasadas."
,"5":"Cuando venga a ustedes para hacer justicia, exigiré un castigo inmediato para los hechiceros y los adúlteros, para los que hacen falsos juramentos, para los que abusan del asalariado, de la viuda y del huérfano, para los que no respetan los derechos del extranjero."
,"6":"Porque yo, Yavé, en nada he cambiado; igual que ustedes, hijos de Jacob que todavía no terminan..."
,"7":"En efecto, desde los tiempos de sus antepasados, ustedes se han apartado de mis ordenanzas y no las han practicado. Vuelvan a mí y yo volveré a ustedes, dice Yavé de los ejércitos. Pero ustedes preguntan: '¿Por qué tenemos que volver?'"
,"8":"¿Puede acaso un hombre engañar a Dios? Pero ustedes me están engañando. Ustedes dirán: '¿En qué cosa te hemos engañado?' Pues, con los diezmos y tributos sagrados."
,"9":"Por eso los maldigo, a todos ustedes israelitas, que son unos tramposos."
,"10":"Entreguen, pues, la décima parte de todo lo que tienen al tesoro del templo, para que haya alimentos en mi casa. Traten después de probarme, dice Yavé de los ejércitos, para ver si les abro las compuertas del cielo o si derramo para ustedes la lluvia bendita hasta la última gota."
,"11":"Yo espantaré a la langosta para que no devore sus campos ni se seque la viña de su propiedad, dice Yavé de los ejércitos."
,"12":"Entonces vendrán a felicitarlos todas las naciones, porque su país será un paraíso."
,"13":"Ustedes se expresan de mí muy duramente, dice Yavé, a pesar de que tratan de excusarse de que nada malo han dicho de mí."
,"14":"Pues ustedes dicen que es tontería servir a Dios y que nada se gana con observar sus mandamientos o con llevar una vida austera en su presencia."
,"15":"Por eso, ahora, ustedes llaman felices a los que no tienen religión, pues los que actúan mal tienen éxito en todo, e incluso si provocan a Dios, no les pasa nada.'"
,"16":"Así hablaban entre sí los que respetan a Yavé. Yavé, que estaba escuchando, lo supo, y mandó en seguida que en un libro se anotaran los nombres de aquellos que lo respetaban y reverenciaban su Nombre."
,"17":"Ellos serán mis preferidos, dice Yavé de los ejércitos, el día en que yo actúe. Y los premiaré como hace un padre con su hijo obediente."
,"18":"Entonces ustedes verán cómo se trata al bueno y al malo, al que sirve a Dios y al que no lo sirve."
,"19":"Porque ya llega el día, ardiente como un horno. Todos los orgullosos y los que hacen el mal serán quemados como paja por el fuego de ese día. No quedarán de ellos ni ramas ni raíces."
,"20":"Pero, en cambio, para ustedes que respetan mi Nombre, brillará el sol de justicia, que traerá en sus rayos la salud; ustedes saldrán saltando como terneros cebados."
,"21":"En el día que estoy preparando, pisotearán a los malvados, que serán como ceniza esparcida en el camino de ustedes, dice Yavé."
,"22":"'Acuérdense de la ley de Moisés, mi servidor, a quien entregué en el Cerro Horeb leyes y ordenanzas para todo Israel."
,"23":"Les voy a enviar al profeta Elías antes que llegue el día de Yavé, que será grande y temible."
,"24":"El reconciliará a los padres con los hijos y a éstos con sus padres, para que, cuando yo llegue, no tenga que maldecir a este país.'"
}`)

}
func ES_LBL_LoadVNNHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palabras contra Nínive. Este es el libro de la visión que tuvo Nahúm de Elcós."
,"2":"Yavé es un Dios celoso y vengador. Se venga contra sus adversarios,y su ira es terrible."
,"3":"Yavé es lento a la cólera,pero tremendo en su poder,y no deja pasar nada. Camina entre tempestades y huracanes, y las nubes son el polvo de sus pies."
,"4":"Amenaza a los mares y los seca, los ríos se quedan sin agua. El Basán y el Carmelo desfallecen,y se marchita el verdor del Líbano,"
,"5":"los cerros tiemblan ante él, y las lomas se estremecen. Ante él se derrumban la tierra, el universo y todos los que en él viven."
,"6":"¿Quién podrá resistir ante su enojo?,¿Quién podrá soportar el ardor de su cólera?,Su furor se extiende como el fuego, y las rocas se quiebran ante él."
,"7":"Yavé es bueno; para los que en él confían, es un refugio en el día de la angustia. Conoce a los que en él confían, y los salva de las aguas embravecidas."
,"8":"Mas extermina a los que se alzan contra él, a sus enemigos los persigue hasta en la oscuridad."
,"9":"¿Qué traman contra Yavé?, El va a llevar a cabo la destrucción y la ruina, y la maldad no volverá a triunfar."
,"10":"Porque ellos, espinos enredados, serán consumidos enteramente,como se consume la paja seca,"
,"11":"Yavé sacará de Judá a su enemigo, al que medita el mal."
,"12":"Así, dice Yavé: 'Por más potentes y poderosos que sean, serán cortados y desaparecerán. Si te he humillado, no volveré a humillarte más."
,"13":"Voy a quebrar el yugo que pesa sobre ti y a romper tus cadenas."
,"14":"Pero Yavé ha ordenado respecto a ti: No habrá más descendencia de tu nombre; de la casa de tu Dios extirparé ídolos y estatuas fundidas y haré de tu sepulcro un lugar maldito."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Ya corren por los montes los pies del mensajero, del que anuncia la paz. ¡Celebra tus fiestas, oh Judá, cumple tus votos! Porque no volverá a pasar por ti el bandido: ha sido extirpado totalmente."
,"2":"Yavé ha restablecido la gloria de Jacob, la gloria de Israel. Los devastadores han sido devastados y destruidos sus sarmientos."
,"3":"Monta guardia en el muro. Vigila el camino y prepárate para el asalto, porque viene contra ti el destructor."
,"4":"Sus valientes llevan el escudo rojo, sus guerreros están vestidos de púrpura. Los carros alistados brillan como antorchas,y sus hombres llevan el casco."
,"5":"Se lanzan a las calles y corren por las plazas, como antorchas encendidas, como relámpagos."
,"6":"Se les oponen los más valientes, pero en vano. Corren hacia la muralla,y se coloca la pared de defensa."
,"7":"Las puertas son forzadas, se rompen,y en el palacio es la derrota."
,"8":"La diosa es sacada afuera y va al exilio, y sus siervas lloran,y gimen como palomas, y se dan golpes en el pecho."
,"9":"Nínive parece un estanque de aguas; pero de aguas que se van, todos huyen. Nadie vuelve,cuando se le grita: 'Detente.'"
,"10":"'Roben la plata y saqueen el oro', pues son innumerables los tesoros, verdaderos montones de objetos preciosos."
,"11":"¡Destrozo, saqueo, devastación!,Los corazones desfallecen, tiemblan las rodillas, los más valientes se desconciertan, y palidecen los rostros."
,"12":"¿Dónde está la cueva de los leones, guarida de sus cachorros, donde iban a llevar sus crías,sin que nadie los molestara?"
,"13":"El león desgarraba para sus cachorros; mataba para sus leonas,y llenaba sus guaridas de presas,y de carne despedazada."
,"14":"Pero aquí estoy yo contra ti, dice Yavé Sabaot: yo convertiré en cenizas tus carros, y la espada acabará con tus cachorros. La tierra no verá más tus cazas, y no se oirá más el grito de tus mensajeros."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Pobre de la ciudad de sangre, toda llena de mentira, de rapiña, de incesantes robos."
,"2":"Chasquido de látigo, estrépito de ruedas, caballos que galopan, carros que saltan,"
,"3":"caballerías que avanzan, llamear de espadas, centellear de lanzas, multitud de heridos, montones de muertos, cadáveres sin fin; se tropieza en los cadáveres."
,"4":"Así paga sus muchas prostituciones la prostituta de encantadores atractivos, maestra en sortilegios, que engañaba a los pueblos con sus prostituciones y a las naciones con sus sortilegios."
,"5":"Aquí estoy contra ti, palabra de Yavé Sabaot, voy a alzar tus faldas hasta tu cara; mostraré a las naciones tu desnudez, y verán los reinos tus vergüenzas."
,"6":"Arrojaré inmundicias sobre ti, te deshonraré y te pondré como espectáculo"
,"7":"y todo el que te vea, huirá de ti. Dirán: 'Asolada está Nínive, ¿quién tendrá piedad de ella?,¿Dónde buscar quién la consuele?'"
,"8":"¿Eres acaso tú mejor que No-Amón, la ciudad situada entre los ríos, rodeada de aguas, que tenía el mar por antemuro?"
,"9":"Etiopía y Egipto la defendían; su fuerza no tenía límites; Put y los libios venían en su ayuda."
,"10":"También ella fue al destierro, partió al cautiverio; sus niños fueron estrellados en los cruces de las calles. Se echaron suertes sobre sus notables,y todos sus grandes fueron cargados de cadenas."
,"11":"También tú quedarás ebria. También tú buscarás un refugio contra el enemigo."
,"12":"Tus fortalezas son como higueras cargadas de brevas: si se las sacude, caen en la boca de quien va a comerlas."
,"13":"Mira a tus habitantes: son ahora como mujeres; las puertas de tu país están abiertas, y tus enemigos pueden entrar, el fuego ha devorado tus trancas."
,"14":"Sácate agua para el asedio, refuerza tus fortalezas, métete en la arcilla, pisa el mortero, toma el molde para hacer ladrillos."
,"15":"Aunque fueras numeroso como el pulgón, incontable como la langosta,el fuego te consumirá, te exterminará la espada,"
,"16":"Habías multiplicado tus mercaderes,más que las estrellas del cielo,"
,"17":"tus guardias, como langosta, y tus funcionarios como enjambres de insectos,que se posan en los cercos en un día de frío. Sale el sol y se van, se despliegan los pulgones, se vuelan y nadie sabe dónde."
,"18":"Dormidos están tus pastores, ¡oh rey de Asur!,Duermen también tus capitanes, tu pueblo está disperso por los montes, y no hay quién lo reúna."
,"19":"¡No hay remedio para tu herida, tu llaga es incurable!,Todos los que oyen aplauden por tu ruina; pues, ¿sobre quién no pesó,constantemente tu crueldad?"
}`)

}
func ES_LBL_LoadVNOSChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Esta es la palabra de Yavé que fue dirigida a Oseas, hijo de Beeri, en el tiempo que reinaron Ozías, Jotam, Ajaz y Ezequías en Judá, y Jeroboam, hijo de Joás, en Israel"
,"2":"Cuando Yavé comenzó a hablar por medio de Oseas, le dijo al profeta: 'Vete y cásate con una de esas mujeres que se entregan a la prostitución sagrada y ten hijos de esa prostituta. Porque el país se está prostituyendo al apartarse de Yavé.'"
,"3":"Fue, pues, y tomó a Gomer, hija de Diblayim. Ella quedó esperando y le dio luego un hijo."
,"4":"Yavé entonces le dijo: 'Ponle el nombre de Jezrael, porque dentro de poco haré pagar a los reyes de la familia de Jehú la sangre que derramó en Jezrael y no habrá más reyes en Israel."
,"5":"Aquel día yo haré que Israel sea derrotado en el valle de Jezrael.'"
,"6":"Nuevamente Gomer quedó embarazada y dio a luz una niña. Y Yavé dijo a Oseas: 'Ponle el nombre de No Amada, porque yo no seguiré teniendo más compasión de Israel para seguir perdonándolo.'"
,"7":"Pero tendré compasión de la casa de Judá y los salvaré por Yavé su Dios; los salvaré sin usar el arco ni la espada, ni la guerra ni los carros ni los caballos."
,"8":"Cuando la niña ya estaba grandecita, Gomer quedó embarazada otra vez y dio a luz otro hijo."
,"9":"Y dijo Yavé: 'Ponle el nombre de No mi Pueblo, porque ustedes no son mi pueblo y tampoco Yo Soy para ustedes.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Y los hijos de Israel serán tan numerosos como la arena del mar, que no pueden contarse ni medirse. Entonces, en vez de decirles: 'Ustedes no son mi pueblo', les dirán:"
,"2":"'Ustedes son los hijos del Dios vivo.' Se reunirán los hijos de Judá y los de Israel bajo un solo jefe, y desbordarán los límites del país; porque el día de Jezrael será un gran día."
,"3":"Ustedes llamarán a sus hermanos Mi pueblo, y a sus hermanas, Amadas."
,"4":"¡Acusen a su madre, acúsenla, porque ella ya no es mi esposa ni yo soy su marido!,Que se limpie de la infidelidad grabada en su rostro,y tire afuera la impureza que se apegó a sus pechos."
,"5":"Porque si no, la desvestiré y la dejaré desnuda, y sin nada, como cuando nació; será entonces igual que un desierto, como tierra sin agua, y morirá de sed."
,"6":"Ya no querré más a sus hijos, porque son frutos de la prostitución."
,"7":"Sí, puesto que su madre se ha entregado,y ha perdido su decencia. Ella decía: 'Déjenme partir con mis amantes, que me dan mi pan y mi agua, mi lana y mi lino, mi aceite y mis bebidas.'"
,"10":"Ella no veía que era yo el que le daba,el trigo, el vino y el aceite,y quien le proporcionaba en abundancia,la plata y el oro que empleó para fabricar el Baal."
,"11":"Por eso, vendré a recuperar mi trigo en la cosecha,y mi vino nuevo en la vendimia; y le quitaré mi lana y mi lino, y todo lo que cubría su desnudez."
,"12":"Dejaré desnuda su vergüenza en presencia de sus amantes, y nadie la salvará de mis manos."
,"13":"Yo pondré fin a sus diversiones, a sus fiestas, lunas nuevas y sábados, a todas sus solemnidades."
,"14":"Echaré a perder su viña y sus higueras, pues ella decía : 'Son mi salario, me las han dado mis amantes.',Las dejaré como terreno baldío, y se las comerán los animales."
,"15":"Yo le tomaré cuentas por los años de los baales,en que les ofrecía incienso,y en que se ponía sus aros y collares,para correr detrás de sus amantes; y se olvidaba de mí, la ingrata."
,"8":"Por eso, voy a impedir su paso con espinos, y a cercarla con una cerca,para que no encuentre ya caminos."
,"9":"Perseguirá a sus amantes y no los alcanzará, tratará de encontrarlos, pero en vano. Entonces se dirá: 'Voy a levantarme, y volveré donde mi primer marido, pues con él me iba mejor que ahora.'"
,"16":"Por eso, ahora la voy a conquistar, la llevaré al desierto y allí le hablaré a su corazón."
,"17":"Le devolveré sus viñas, convertiré el valle de la Mala Suerte,en un lugar de esperanzas. Y allí ella me responderá como cuando era joven, como en los días en que subió de Egipto."
,"18":"Aquel día, dice Yavé, ya no me llamarás más 'Señor mío', sino que me dirás 'Marido mío'."
,"19":"Sacaré de su lengua los nombres de los baales, para que ya no se acuerde de esos nombres."
,"20":"Ese día haré un pacto con las fieras salvajes, con las aves de rapiña y las serpientes de la tierra, para que no le hagan daño. Romperé el arco y la espada, alejaré de su tierra la guerra, y haré que la gente duerma segura ahí."
,"21":"Yo te desposaré para siempre. Justicia y rectitud nos unirán, junto con el amor y la ternura,"
,"22":"Yo te desposaré con mutua fidelidad, y conocerás quién es Yavé."
,"23":"En ese día, palabra de Yavé, responderé a los cielos,y ellos responderán a la tierra."
,"24":"La tierra responderá al trigo, al vino nuevo y al aceite, y éstos harán honor al nombre de Jezrael."
,"25":"Yo sembraré para mí en el país, tendré compasión de No Amada,y diré a No mi Pueblo: 'Tú eres mi pueblo'; y él me contestará: 'Tú eres mi Dios.'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Yavé me dijo: 'Vuelve a querer de nuevo a una mujer adúltera que hace el amor con otros, así como Yavé ama a los hijos de Israel a pesar de que lo han dejado por otros dioses y les ofrecen tortas de pasas.'"
,"2":"Recuperé, pues, a mi esposa, pagando por ella quince monedas de plata y una carga y media de cebada."
,"3":"Y le dije: 'Te quedarás aquí conmigo mucho tiempo, sin ofrecerte a nadie y sin traicionarme con ningún hombre, y yo tampoco tendré relaciones contigo.'"
,"4":"Porque también por muchos días los hijos de Israel quedarán sin rey, sin jefe, sin sacrificios, sin piedras sagradas, sin consultas a Yavé y sin ídolos para proteger la casa."
,"5":"Después volverán los hijos de Israel, buscarán a Yavé, su Dios, y a David, su rey. Cuando llegue el momento acudirán llenos de respeto a Yavé para recibir sus beneficios."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Escuchen lo que dice Yavé, hijos de Israel. Yavé tiene un pleito pendiente con la gente de esta tierra, porque no encuentra en su país ni sinceridad, ni amor, ni conocimiento de Dios."
,"2":"Sólo hay juramentos en falso y mentiras, asesinato y robo, adulterio y violencia, crímenes y más crímenes."
,"3":"Por eso, todo el país está de duelo y están deprimidos sus habitantes. Y desaparecen hasta los animales salvajes, las aves del cielo y los peces del mar."
,"4":"Pero que nadie acuse o se defienda, pues contra ti, sacerdote, es mi demanda."
,"5":"Tropezarás en pleno día y contigo tropezará el profeta en la noche, pues haré callar sus oráculos."
,"6":"Mi pueblo languidece por falta de conocimiento, y como tú has dejado que se perdiera el conocimiento, yo también haré que pierdas mi sacerdocio. Te has olvidado de mi Ley, y también yo me olvidaré de tus hijos."
,"7":"Todos por igual me han ofendido, pues me han dejado a mí, su Gloria, por ir a unas vergüenzas."
,"8":"Y como comen de los animales que mi pueblo ofrece por el pecado, les conviene que mi pueblo siga pecando."
,"9":"Trataré al sacerdote como al pueblo y le pediré cuentas por su conducta; a cada cual retribuiré según sus obras."
,"10":"Comerán, pero sin quedar satisfechos; se prostituirán, pero no ganarán nada, porque han traicionado a Yavé."
,"11":"Prostitución, vino y aguardiente se han hecho dueños de su mente."
,"12":"Mi pueblo consulta a un palo y espera la respuesta de un bastón, pues un espíritu de infidelidad lo arrastra a engañar a su Dios con otros dioses."
,"13":"En lo alto de los cerros ofrecen sacrificios y sobre las lomas queman incienso bajo cualquier encina, álamo o espino cuya sombra sea agradable. Por esto, si sus hijas se hacen prostitutas o si sus nueras engañan a sus maridos, "
,"14":"no castigaré ni a sus hijas ni a sus nueras porque sean prostitutas o infieles, pues ustedes mismos se encierran con las prostitutas y sacrifican con los consagrados a la prostitución. De este modo, un pueblo que no entiende acaba por perderse."
,"15":"Si Israel es infiel, tú al menos, Judá, no cometas la misma falta. No vayan a Guilgal ni suban a Betaven, ni juren allá por la vida de Yavé.)"
,"16":"Si Israel se muestra rebelde como una vaquilla salvaje, ¿cómo podrá Yavé llevarlo a pastar como un cordero a pleno campo?"
,"17":"Efraím se ha aliado con los ídolos; ¡que su Dios lo deje, pues! Se despiertan de su borrachera para salir con prostitutas y prefieren su vergonzoso ídolo a mi Gloria."
,"18":"Se lo llevará el viento en sus alas, y no habrán ganado nada con sus sacrificios."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Escuchen esto, sacerdotes; estén atentos, jefes de Israel; presten atención los de la casa del rey, pues esta sentencia es para ustedes: Han sido como un lazo de cazador en Mispá y como una red tendida en el Tabor. Yo los voy a castigar a todos porque se han hundido hasta el cuello en la corrupción. "
,"2":"Sé quién es Efraím y no me es desconocido Israel."
,"3":"Tú, Efraím, te has entregado; tú, Israel, te has ensuciado."
,"4":"Sus faltas les impiden volver a su Dios, un espíritu de prostitución se ha hecho dueño de ellos y ya no conocen a Yavé."
,"5":"El orgullo de Israel lo condena. Israel y Efraím están en crisis a causa de su pecado."
,"6":"Con sus ovejas y sus bueyes irán en busca de Yavé, pero no lo encontrarán porque se ha alejado de ellos."
,"7":"Han traicionado a Yavé y sus hijos son ilegítimos: ¡que el destructor los devore junto con sus campos!"
,"8":"Toquen el cuerno en Gueba, la trompeta en Rama. Den la alarma en Betaven, la voz de alerta en Benjamín. Ténganlo por seguro, tribus de Israel,"
,"9":"que cuando llegue su hora, Efraím será destruido."
,"10":"Como los reyes de Judá han tratado de ensanchar sus dominios, mi furor los va a llevar como un torrente."
,"11":"Efraím es un opresor y dicta sentencias injustas, pues se deja llevar por las apariencias."
,"12":"Pues bien, yo seré como polilla para Efraím y como carcoma para la gente de Judá. Efraím sabe que está enfermo,"
,"13":"y Judá, que tiene úlceras. Por eso, Efraím ha ido a Asiria y ha mandado mensajeros al gran rey, pero éste no podrá sanarlos ni curarles sus llagas."
,"14":"Yo seré como un león para Efraím, y como un cachorro para la gente de Judá. Yo, sí, yo mismo lanzaré un zarpazo y huiré, me llevaré mi presa y nadie me la podrá quitar."
,"15":"Volveré a mi casa hasta que se reconozcan culpables y vengan a verme."
}`)
	CurrentBook.AddChapter(6, `{
"1":"'Vengan, volvamos a Yavé; pues si él nos lesionó, él nos sanará; si él nos hirió, él vendará nuestras heridas."
,"2":"Dentro de poco nos dará la vida, al tercer día nos levantará y viviremos en su presencia."
,"3":"Empeñémonos en conocer a Yavé. Su venida es tan cierta como la de la aurora, y su intervención, tan repentina como la llegada del día. Llegará como la lluvia, como el aguacero que riega la tierra."
,"4":"'¿Qué he de hacer contigo, Efraím? ¿Cómo he de tratarte, Judá? El cariño que me tienen es como una nube matinal, como el rocío que sólo dura algunas horas."
,"5":"Por eso, les envié profetas para desarraigarlos, y de mi propia boca salió su sentencia de muerte."
,"6":"Porque me gusta más el amor que los sacrificios, y el conocimiento de Dios, más que víctimas consumidas por el fuego.'"
,"7":"Pero ellos no cumplieron mi alianza en Adam, pues allí me traicionaron."
,"8":"Galaad, ciudad de malhechores, está llena de huellas de sangre."
,"9":"Como una banda de salteadores, los sacerdotes se juntan para asaltar a los que pasan por el camino de Siquem: lo que hacen es una vergüenza."
,"10":"He visto una cosa horrible en Betel; pues allá Efraím se prostituye, Israel se deshonra."
,"11":"(A ti, Judá, te espera una buena cosecha cuando traiga de vuelta a los desterrados de mi pueblo y sane a Israel)."
}`)
	CurrentBook.AddChapter(7, `{
"1":"El pecado de Efraím y la malicia de Samaria han quedado de manifiesto, pues no actuaron con sinceridad. En la casa entra el ladrón, en los caminos asalta la pandilla."
,"2":"Ellos no se fijan que tengo presente su maldad. Ahora mismo sus obras están delante de mí acusándolos."
,"3":"Entusiasman al rey con su astucia, y a los cortesanos, con sus mentiras."
,"4":"Todos están ardiendo de pasión, calientes como un horno que ha dejado encendido el panadero mientras amasa y espera que la masa se levante."
,"5":"El día del rey los jefes se calientan y se embriagan, y él tiende su mano a los que se ríen"
,"6":"cuando se acercan. Pero sus corazones se van enardeciendo en su conspiración como un horno; toda la noche está en calma, pero a la mañana arde como una llama de fuego."
,"7":"Todos se enardecen como un horno y devoran a sus gobernantes. Así han perecido todos sus reyes sin que ninguno de ellos me pidiera auxilios."
,"8":"Efraím irá a ablandarse en tierra extranjera. Efraím es una tortilla que se ha quemado por un solo lado."
,"9":"Los extranjeros consumen sus energías sin que se dé cuenta. Su cabeza está sembrada de canas y él no lo nota."
,"10":"Su misma arrogancia condena a Israel, pero no se han vuelto a Yavé, su Dios, ni tratan, a pesar de todo, de buscarlo."
,"11":"Efraím es como una paloma tonta y sin juicio, pues o bien llaman a Egipto, o bien parten a Asiria."
,"12":"Pero adondequiera que vayan yo les pondré una trampa; los haré caer como a las aves del cielo, como una red los atraparé para su desgracia."
,"13":"¡Ay de ellos que se han alejado de mí! ¡Que la desgracia se los lleve, porque me han traicionado! ¿Acaso debo liberarlos, después que me han sido infieles?"
,"14":"Se lamentan en sus lechos, pero no se acuerdan de invocarme sinceramente; se asustan porque les va a faltar el trigo o el vino, pero continúan alejados de mí."
,"15":"Cuando les daba la fuerza, maquinaban contra mí."
,"16":"Prefieren lo que es malo y son como un arco que no apunta. Sus jefes morirán acuchillados por haber proferido tantas injurias, y en Egipto se reirán de ellos."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Prepárate a tocar la corneta pues aquí viene la desgracia y se deja caer como un águila sobre los de la Casa de Yavé. No han respetado mi alianza y han rechazado mi Ley."
,"2":"Ellos me aclaman: 'Dios mío, nosotros los de Israel te conocemos.'"
,"3":"Pero Israel ha rechazado el bien y por eso el enemigo lo perseguirá."
,"4":"Se han elegido reyes sin que esto viniera de mí; se han dado jefes que yo no conocía. Con su oro y su plata se han fabricado ídolos, y yo se los quitaré."
,"5":"Le tengo asco a tu ternero, Samaria, y estalla mi cólera contra él. ¿Cuánto tiempo más esperarán para limpiarse,"
,"6":"hijos de Israel? No es un Dios, pues ha sido hecho por un escultor; por eso, el ternero de Samaria se hará cenizas."
,"7":"Como siembran vientos, cosecharán tempestades. Su trigo no echará espigas, la espiga no dará harina; y si llega a dar algo, se la comerán los extranjeros."
,"8":"Israel vivía aparte como el asno salvaje, pero ha sido devorado y está en tierra de paganos. Efraím ya no sirve para nada."
,"9":"subía a Asiria llevando regalos;"
,"10":"pero si él mismo ha sido entregado a los paganos, tendré que rescatarlo yo. Pues en unos momentos se ha quedado sin profetas, sin reyes y sin jefes."
,"11":"Efraím multiplicó los altares, pero éstos sólo le han servido para pecar."
,"12":"Aunque escribiera mil preceptos para él, los consideraría como cosa sin importancia."
,"13":"¿Acaso quieren ofrecer sacrificios? ¡Que los ofrezcan, pues, y que se coman la carne! Pero Yavé no se siente agradecido por ellos, pues se está acordando de su falta; va a castigar sus pecados y los va a mandar nuevamente a Egipto."
,"14":"Israel se ha olvidado de su creador y construye palacios; Judá, por su parte, multiplica las ciudades fortificadas; pero yo prenderé fuego a sus ciudades e incendiaré sus castillos."
}`)
	CurrentBook.AddChapter(9, `{
"1":"No te alegres, Israel, no te regocijes como las naciones paganas, porque tú has traicionado a tu Dios y, con tal de que te dieran algo, te entregabas en cualquiera era donde se trillara."
,"2":"Pero ni la era ni el lagar les proporcionarán el sustento necesario, y hasta el vino les faltará."
,"3":"No vivirán más en la tierra de Yavé, Efraím volverá a Egipto y en su destierro de Asiria comerán alimentos impuros."
,"4":"Ya no derramarán más vino en homenaje a Yavé, ni le ofrecerán más sacrificios. Su pan será como el pan que se sirve en un velorio, que deja impuros a todos los que lo comen. Su pan será sólo para ellos, pues no podrán llevarlo a la Casa de Yavé."
,"5":"¿Qué harán ustedes el día de la peregrinación para la fiesta de Yavé?"
,"6":"Ustedes saldrán, pero huyendo después de la derrota. Egipto los recogerá, y en Menfis serán sepultados. Las ortigas guardarán sus tesoros de plata y las zarzas crecerán en sus casas."
,"7":"Ha llegado la hora de rendir cuentas; ha llegado la hora del desquite: ¡que todo Israel lo sepa! Los profetas serán como locos y los inspirados ya no sabrán qué decir, pues, así como fue grande tu pecado, enorme será tu desastre."
,"8":"Efraím monta guardia ante mi Dios y el profeta trata de impedir que el enemigo llegue de sorpresa, anunciando el ataque contra el templo de sus ídolos."
,"9":"Se han corrompido profundamente como aquel día en Guibea, pero Yavé se acordará de su culpa y castigará sus pecados."
,"10":"Israel fue para mí como uva silvestre encontrada en el desierto, y sus padres me parecieron como si fueran las primeras brevas; pero no bien habían llegado a Baal-Peor, se vendieron al ídolo y se hicieron tan aborrecibles como el ídolo que amaban."
,"11":"La gloria de Efraím se volará como un pájaro: no más hijos, no más embarazos, no más concepción."
,"12":"Por más que críen hijos, se los quitaré antes que lleguen a hombres. ¡Ay de ellos cuando me aparte de ellos!"
,"13":"Ya ha visto a Efraím entregando sus hijos al cazador; Efraím tendrá que llevar sus hijos al matadero."
,"14":"Dales, Yavé... ¿Qué les darás? ¡Haz que sus entrañas sean estériles y que se sequen sus pechos!"
,"15":"En Guilgal salió a relucir toda su maldad. Allí fue donde les tomé odio. Los echaré de mi Casa por todos sus crímenes; no les tendré más cariño, pues todos sus jefes son unos rebeldes."
,"16":"Efraím se está muriendo, sus raíces se están secando y ya no habrá más frutos. Y aunque tengan hijos, yo haré morir el apreciado fruto de su seno."
,"17":"Como no le hicieron caso, mi Dios los echará de su presencia y andarán como vagabundos por la tierra."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Israel era una viña excelente que daba uva en abundancia. Cuanto más eran los frutos, más multiplicaba sus altares; mientras mejor le iba al país, más embellecía sus pilares sagrados."
,"2":"Su cariño está repartido, pero me lo van a pagar. Yavé mismo derribará sus altares y demolerá sus monumentos sagrados."
,"3":"Ahora andan diciendo: 'Nos quedamos sin rey por no haber respetado a Yavé. Pero, ¿qué podría haber hecho el rey en favor nuestro?'"
,"4":"Dejen que hablen, y que juren en falso, y que celebren convenios, pues su sentencia está lista para florecer, como hace la hierba mala entre los surcos de los sembrados."
,"5":"Los habitantes de Samaria se lamentan por su ternero de Betavén; su pueblo hace duelo por el ternero, y los sacerdotes lloran a su glorioso ídolo;"
,"6":"pues él también es llevado a Asiria, como regalo para el gran rey. Para Efraím será una afrenta, ¡qué vergüenza para Israel!"
,"7":"Su rey será sacado de Samaria como se limpia la espuma de la superficie de un estanque."
,"8":"Los santuarios altos de Aven, donde pecaba Israel, serán destruidos; zarzas y cardos cubrirán sus altares. Entonces dirán a las montañas: 'Escóndannos', y a los cerros: 'Caigan sobre nosotros.'"
,"9":"Desde aquel día en Guibea estás pecando, Israel; no has cambiado nada. ¿No serán castigados como lo fueron los malvados en Guibea?"
,"10":"Yo los castigaré y las naciones se juntarán contra ellos por su doble crimen."
,"11":"Efraím es una vaquilla bien domesticada, a la que le gusta trillar; pero yo voy a poner un yugo sobre su hermosa cabeza:"
,"12":"Israel tirará del arado, Jacob rastrillará. Siembren, pues, según la justicia, y cosechen la bondad. Roturen para ustedes tierras sin cultivar, pues es tiempo de buscar a Yavé hasta que venga a traerles la justicia."
,"13":"Pero ustedes han sembrado el mal, han cosechado la injusticia y se han comido el fruto de la mentira. Ya que tú te sientes orgulloso de tus carros y de tu ejército numeroso,"
,"14":"reinará la confusión en tus ciudades y serán demolidas tus fortalezas, como pasó cuando Salmán atacó y destruyó a Betabel, y todo fue aplastado, la madre con sus hijos."
,"15":"Así te voy a tratar, Israel, por todo el mal de tus acciones malas. El rey de Israel desaparecerá en la tormenta."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Cuando Israel era niño, yo lo amé, y de Egipto llamé a mi hijo."
,"2":"Pero mientras los llamaba, más se alejaban de mí. Ofrecieron sacrificios a los baales y quemaron incienso ante los ídolos."
,"3":"Yo, sin embargo, le enseñaba a andar a Efraím, sujetándolo de los brazos, pero ellos no entendieron que yo cuidaba de ellos."
,"4":"Yo los trataba con gestos de ternura, como si fueran personas. Era para ellos como quien les saca el bozal del hocico y les ofrece en la mano el alimento."
,"5":"Pero ¡volverán a Egipto! Ya que no han querido volver a mí, tendrán por rey a Asiria."
,"6":"La espada arrasará sus ciudades, exterminará a sus hijos y se saciará con sus fortalezas."
,"7":"Mi pueblo está pagando ahora su infidelidad. Llamen si quieren a Baal, pero nadie lo levantará."
,"8":"¿Cómo voy a dejarte abandonado, Efraím? ¿Cómo no te voy a rescatar, Israel? ¿Será posible que te abandone como a Adma o que te trate igual que a Seboím? Mi corazón se conmueve y se remueven mis entrañas."
,"9":"No puedo dejarme llevar por mi indignación y destruir a Efraím, pues soy Dios y no hombre. Yo soy el Santo que está en medio de ti, y no me gusta destruir."
,"10":"Ustedes seguirán a Yavé, que rugirá como león. Sí, rugirá y sus hijos vendrán temblorosos desde el occidente."
,"11":"De Egipto acudirán como pájaros, del país de Asur como palomas, y haré que vuelvan a habitar sus casas, palabra de Yavé."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Efraím me ha rodeado de mentira; la gente de Israel, de falsedad; sigue todavía a su Baal y se apega a sus divinidades."
,"2":"Efraím vive de ilusiones y corre todo el día tras el viento de oriente. Multiplica las mentiras y las violencias, hace alianza con Asiria mientras se pone bien con Egipto."
,"3":"Por eso, Yavé tiene una querella contra Israel; va a pedir cuentas a Jacob y darle su merecido por lo que ha hecho."
,"4":"Ya en el seno materno suplantó a su hermano y, cuando era hombre, peleó con Dios. Luchó con el ángel, lo venció."
,"5":"Le suplicó llorando que le diera la bendición. Lo encontró en Betel y allí le habló ("
,"6":"Yavé Dios de los Ejércitos, Yavé es su nombre)."
,"7":"Por eso, tú regresa donde tu Dios, actúa con amor y justicia, y confía siempre en él."
,"8":"Eres un verdadero cananeo, tú acostumbrabas a meter trampas con balanzas mal ajustadas."
,"9":"Efraím dice: 'Yo me he enriquecido y me he juntado una fortuna'; pero no guardará nada de todo lo que ha juntado, pues estaba actuando mal."
,"10":"Yo, Yavé, que soy tu Dios desde Egipto, te haré vivir de nuevo en tiendas de campaña, como en aquellos días del Encuentro."
,"11":"Hablaré a los profetas, multiplicaré las visiones y dictaré sentencias por medio de los profetas."
,"12":"Si Galaad no es más que pecado, ellos no son más que mentira; en Guilgal ofrecen sus sacrificios a los terneros; por eso, sus altares no serán más que piedras esparcidas en el campo."
,"13":"Huyó Jacob a las llanuras de Aram, sirvió Israel por una mujer, y por una mujer guardó rebaños."
,"14":"Por medio de un profeta hizo subir Yavé a Israel de Egipto y por medio de un profeta lo guardó,"
,"15":"pero Efraím lo ha colmado con sus provocaciones; por eso, hará que recaiga sobre él la sangre que ha derramado, y su Señor le devolverá las ofensas que le ha hecho."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Cuando Efraím hablaba, todos temblaban de espanto, pues era poderoso en Israel; pero decayó apenas se puso a pecar con el Baal."
,"2":"Y todavía siguen pecando, pues se han fabricado con su plata un ídolo de metal fundido, diseñado a su gusto. Esto no es más que obra de artesanos, pero ellos dicen: 'Ofrézcanles sacrificios', y hombres como ellos besan a un ternero."
,"3":"Por eso, serán como neblina matinal, como el rocío que pronto se seca, como paja barrida por el viento, como el humo que escapa por la ventana."
,"4":"Sin embargo, yo soy Yavé, tu Dios, desde la tierra de Egipto; no conoces otro Dios fuera de mí, ni tienes más Salvador que yo."
,"5":"Yo te conocí en el desierto, en esa tierra seca."
,"6":"Yo les di de comer; pero cuando estuvieron satisfechos, se llenó de orgullo su corazón y se olvidaron de mí."
,"7":"Pues bien, yo fui para ellos como un leopardo; me pongo al acecho en su camino como una pantera;"
,"8":"me lanzo sobre ellos como un oso al que le han quitado sus crías, y desgarro la funda de su corazón. Como leona, allí mismo los devoro y los destrozo como fiera salvaje."
,"9":"Ya estás destruido, Israel, ¿quién vendrá en tu ayuda?"
,"10":"¿Dónde está tu rey para que te salve?, ¿y tus jefes para que te protejan? ¿No decías: 'Dame un rey y unos jefes'?"
,"11":"Te di un rey para que no me molestaras más, y ahora te lo quito porque ya me aburriste."
,"12":"La falta de Efraím es mantenida en reserva y se guarda en un lugar seguro su pecado."
,"13":"Le llegan los dolores de parto y el niño está listo para nacer; mas no sale, pues es un hijo tarado."
,"14":"¿Yo los libraré del poder del sepulcro? ¿Yo los salvaré de la Muerte? ¡No! ¿Dónde están, oh Muerte, tus plagas? ¿Dónde están, oh Sepulcro, tus azotes? No quiero tenerles más compasión."
,"15":"Efraím creció más que sus hermanos, pero sobre él pasará el viento del este, el soplo de Yavé subirá del desierto; se secarán sus vertientes y se agotará su manantial; consumirá su tierra y todas sus riquezas."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Samaria recibirá su castigo por haberse rebelado contra Yavé: sus habitantes serán acuchillados, sus niños serán pisoteados y les abrirán el vientre a sus mujeres embarazadas."
,"2":"Vuelve, Israel, junto a Yavé, tu Dios, pues tus faltas te hicieron tropezar."
,"3":"Preparen sus palabras,y vuelvan a Yavé para decirle: '¡Quita el pecado y acepta lo bueno, que esta confesión nuestra reemplace cualquier ofrenda!"
,"4":"Asiria no nos salvará, ni confiaremos más en los caballos, ni a la estatua que hicieron nuestras manos,volveremos a decirle Dios nuestro; en ti sólo encuentra compasión el huérfano.'"
,"5":"Yo sanaré su infidelidad, los amaré con todo el corazón,pues ya no estoy enojado con ellos."
,"6":"Yo seré para Israel como el rocío; florecerá como una azucena,y extenderá sus raíces como el árbol del Líbano."
,"7":"Sus retoños brotarán por todas partes, tendrá como el olivo mucha prestancia,y será su perfume como el del Líbano."
,"8":"Volverán a sentarse bajo mi sombra; serán vigorosos como el trigo, y les brotarán flores como a la vid; serán tan renombrados como los vinos del Líbano."
,"9":"Efraím, ¿qué tienes ya que ver con los ídolos?,Yo te miro y aguardo tu respuesta, yo que soy como un ciprés siempre verde: si tienes frutos, esto te viene de mí."
,"10":"Si alguien es sabio, que comprenda estas palabras, y si es inteligente, que las entienda. Pues los caminos del Señor son derechos,y por ellos caminan los buenos, mientras que los malos en ellos tropiezan."
}`)

}
func ES_LBL_LoadVNSOChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palabra de Yavé que fue dirigida a Sofonías, hijo de Cusi, hijo de Godolías, hijo de Amarías, hijo de Ezequías cuando reinaba en Juda Josías, hijo de Amón."
,"2":"Doy mi palabra, dice Yavé, que borraré cuanto existe en la faz de la tierra."
,"3":"Acabaré con los hombres y los animales, con las aves del cielo y los peces del mar; arrancaré al hombre de la superficie de la tierra."
,"4":"Levantaré mi mano para castigar a Judá y a todos los habitantes de Jerusalén; sacaré todo lo que queda de Baal y hasta el nombre de sus sacerdotes."
,"5":"Echaré fuera además a los que se arrodillan en las terrazas para adorar las estrellas; a los que si bien adoran a Yavé, juran al mismo tiempo por Yavé y por Moloc;"
,"6":"a los que se separan de Yavé y dejan de seguirlo y no lo consultan."
,"7":"¡Reine el silencio delante del Señor Yavé, pues se acerca su día! Yavé ha preparado un sacrificio y ya ha consagrado a sus invitados."
,"8":"He aquí lo que pasará el día del sacrificio de Yavé: 'Yo pediré cuentas a los ministros, a los hijos del rey y a todos los que se visten a la moda extranjera."
,"9":"También pediré cuentas a todos los que saltan por encima del umbral del Templo de su Señor sin pisarlo, y a los que lo llenan de violencia y de robos.'"
,"10":"Ese día, lo asegura Yavé, un tremendo clamor saldrá de la Puerta del Pescado; aullidos de la ciudad nueva, y un ruido espantoso de los cerros vecinos."
,"11":"Griten, habitantes del barrio hundido, pues ha desaparecido toda esa gentuza de comerciantes, han sido eliminados todos los que contaban la plata."
,"12":"Ese día andaré con antorchas, registrando Jerusalén para castigar a esos hombres que se quedan sentados en sus basuras y piensan: '¡Total, Yavé no hace ni bien ni mal!'"
,"13":"Pues bien, sus riquezas serán saqueadas; sus casas, demolidas"
,"14":"Se aproxima el gran día de Yavé, ya está cerca, ya llega corrriendo. El día de Yavé: su solo estruendo es una cosa amarga, y hasta el valiente grita de pavor."
,"15":"Es un día de cólera aquel día, de angustia y de congoja; día de destrucción y de ruinas, de sombras y tinieblas; día de nubarrones y neblina,"
,"16":"día en que suena el clarín en lo alto de la muralla y da la alarma en todas las fortalezas."
,"17":"Les mandaré a los hombres la congoja, y andarán como ciegos. Su sangre será esparcida como el polvo y sus restos yacerán como basura."
,"18":"Ni su oro ni su plata los lograrán salvar cuando estalle la cólera de Dios y consuma en el fuego de su celo al país de Judá y destruya sin dejar rastro siquiera a todos los que habitan esa tierra."
}`)
	CurrentBook.AddChapter(2, `{
"1":"¡Júntense y amontónense, oh gente sin vergüenza,"
,"2":"para que puedan ser desparramados como un montón de paja por el viento cuando se precipite sobre ustedes el furor de Yavé, cuando llegue sobre ustedes el día de su enojo!"
,"3":"Busquen a Yavé todos ustedes, los humildes del país, que cumplen sus mandatos, practiquen la justicia y sean humildes y así, tal vez, encontrarán refugio el día del furor de Yavé."
,"4":"Pues Gaza va a quedar convertida en un desierto, Ascalón va a ser totalmente abandonada; Asdod será despoblada en pleno mediodía, y Acarón será destruida hasta sus cimientos."
,"5":"Ay de la nación de los quereteos que viven a orillas del mar, pues Yavé ha hablado para condenarlos: 'Te haré desaparecer, Canaán, y tú, tierra de los filisteos, quedarás sin población.'"
,"6":"La región costera será en adelante pastizales; estos campos serán para los pastores, ahí no habrá más que corrales."
,"7":"Esta región pertenecerá al resto de la tribu de Judá; allí llevarán a pastar sus rebaños y dormirán de noche en las casas de Ascalón. Pues Yavé, su Dios, se acordará de ellos y traerá de vuelta a sus cautivos."
,"8":"He oído las injurias de Moab y las burlas de los amonitas, que insultaron a mi pueblo y se agrandaron a costa de mi territorio."
,"9":"Por esto, lo juro por mi vida, dice Yavé de los Ejércitos, Dios de Israel, Moab quedará igual que Sodoma, y Amón, como Gomorra. La tierra será abandona a las ortigas, con canteras de sal, y será un desierto para siempre. Los que queden de mi pueblo se apoderarán de ellos; los sobrevivientes de mi nación los recibirán en herencia."
,"10":"Esa será su suerte, en pago de su orgullo, pues insultaron al pueblo de Dios de los Ejércitos y se agrandaron a costa suya."
,"11":"Yavé será su terror cuando venga a destronar a todos los dioses de la tierra y lo adoren, cada uno en su propio país, los que viven en las islas de los paganos."
,"12":"'También sobre ustedes, etíopes, pende la amenaza de mi espada...'"
,"13":"Levantará su mano contra el norte y a Asur lo reducirá a escombros; dejará a Nínive totalmente despoblada, seca como un desierto."
,"14":"En ella harán su refugio los rebaños y toda clase de animales y aun el pelícano y la garza pasarán la noche entre sus ruinas; la lechuza lanzará graznidos desde la ventana y el cuervo desde el umbral; los paneles de cedro habrán sido arrancados."
,"15":"Ese será el fin de la ciudad alegre, que se sentía segura y que decía en su interior: 'Yo y nadie más que yo.' ¿Y por qué, ahora no es más que un montón de ruinas donde se guarecen los animales? Todos los que pasan por allí silban, haciendo señas con la mano."
}`)
	CurrentBook.AddChapter(3, `{
"1":"¡Ay de la rebelde, de la manchada, de la ciudad opresora!"
,"2":"No ha escuchado el llamado, no ha aceptado la corrección, no ha puesto su confianza en Yavé ni se ha acercado a su Dios."
,"3":"Sus reyes en medio de ella son como leones que rugen; sus gobernantes son como lobos nocturnos que no guardan ni un hueso para el día siguiente."
,"4":"Sus profetas son unos charlatanes dispuestos para cualquier mentira; sus sacerdotes profanan las cosas santas y no respetan la Ley."
,"5":"Sin embargo, en su interior está Yavé, el Justo, el que cada mañana dicta sus sentencias. El es fiel como la salida del sol, y nunca comete injusticia. Pero el injusto ni siquiera se siente avergonzado."
,"6":"He borrado del mapa a las naciones, he demolido sus torres de defensa, he dejado sus calles solitarias, nadie pasa por ellas, sus ciudades han sido arrasadas y no se ve ni un hombre, ni un habitante siquiera."
,"7":"Yo pensaba: '¡Si al menos tú me temieras y tomaras en cuenta mi reprensión, y no te olvidaras de todas las veces que te corregí.' Pero ellos, al contrario, se han apresurado a comportarse mucho peor aún."
,"8":"Por esto, espérenme, les dice Yavé, para el día en que yo venga a acusarlos. Pues ya salió la sentencia: reuniré a las naciones y juntaré a los imperios para descargar sobre ustedes mi enojo, todo el ardor de mi ira, y todo el país será consumido por el fuego de mis celos."
,"9":"Sí, yo daré a los pueblos labios puros para que todos puedan invocar el Nombre de Yavé y servirlo también con un mismo celo."
,"10":"De más allá de los ríos de Etiopía mis fieles me traerán ofrendas."
,"11":"Ese día ya no tendrás que avergonzarte de todas esas faltas que cometes contra mí, pues de en medio de ti yo arrancaré a aquellos que se jactan de su orgullo y tú no seguirás vanagloriándote de mi montaña santa."
,"12":"Dejaré dentro de ti a un pueblo humilde y pobre, que buscará refugio sólo en el Nombre de Yavé."
,"13":"Aquellos que queden de Israel no cometerán injusticias; no hablarán para engañar, ni se hallará falsedad en su boca. Entonces serán como el rebaño que pasta y que descansa, y no habrá quién los perturbe."
,"14":"¡Grita de gozo, oh hija de Sión, y que se oigan tus aclamaciones, oh gente de Israel!,¡Regocíjate y que tu corazón esté de fiesta, hija de Jerusalén!"
,"15":"Pues Yavé ha cambiado su suerte, ha alejado de ti a tus enemigos. No tendrás que temer desgracia alguna, pues en medio de ti está Yavé, rey de Israel."
,"16":"Ese día le dirán a Jerusalén: '¡No tengas ningún miedo, ni te tiemblen las manos!"
,"17":"¡Yavé, tu Dios, está en medio de ti,el héroe que te salva!,El saltará de gozo al verte a ti,y te renovará su amor. Por ti danzará y lanzará gritos de alegría,como lo haces tú en el día de la Fiesta.'"
,"18":"Apartaré de ti ese mal con el que te amenacé, y ya no serás humillada."
,"19":"Entonces eliminaré a todos tus opresores. Ese día salvaré a la oveja coja y llevaré al corral a la perdida, a ustedes les daré fama y honores en todos los países donde la humillación era su parte."
,"20":"Ese día los traeré a este lugar y los reuniré para hacerlos famosos y respetados entre todos los pueblos de la tierra, cuando traiga de vuelta a los cautivos a la vista de ustedes, dice Yavé."
}`)

}
func ES_LBL_LoadVNZAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"En el octavo mes del segundo año del reinado de Darío, una palabra de Yavé llegó al profeta Zacarías, hijo de Ido:"
,"2":"'Yavé estuvo muy enojado con los padres de ustedes; pero éste es el recado de Yavé de los Ejércitos:"
,"3":"Vuelvan a mí y yo me volveré a ustedes."
,"4":"No se porten como sus antepasados, a quienes los antiguos profetas les gritaban: 'Déjense de andar por malos caminos y no sigan haciendo maldades.' Pero ellos no quisieron escucharlos, ni les hicieron caso."
,"5":"¿Dónde están ahora sus padres?, ¿qué se hizo de los profetas?"
,"6":"Pero mis palabras y mis órdenes que yo había dado a mis servidores, los profetas, se cumplieron en sus padres de tal manera que volvieron a mí y reconocieron: Yavé de los Ejércitos nos ha tratado como lo había resuelto, conforme a nuestra conducta y manera de proceder.'"
,"7":"El día veinticuatro del undécimo mes del año tercero, Yavé dirigió nuevamente una palabra al profeta Zacarías. Aquí la tienen."
,"8":"'He tenido una visión esta noche: Había un hombre montado en un caballo rojo que estaba en medio de los arrayanes, de raíces muy profundas. Lo seguían caballos rojos, alazanes, negros y blancos.' Yo entonces pregunté '¿Qué son éstos, Señor?'"
,"9":"Y el ángel que hablaba conmigo respondió: 'Ya te diré quiénes son.'"
,"10":"Pero el hombre que estaba parado en medio de los arrayanes nos interrumpió: 'Estos son los que Yavé envió para que recorrieran la tierra.'"
,"11":"Ellos, entonces, dirigiéndose al ángel de Yavé que estaba entre los arrayanes, le dijeron: 'Acabamos de recorrer la tierra y hemos comprobado que se encuentra tranquila.'"
,"12":"El ángel de Yavé hizo, por su parte, esta pregunta: 'Yavé de los Ejércitos, ¿hasta cuándo estarás sin compadecerte de Jerusalén y de las ciudades de Judá, a las que has castigado durante setenta años?'"
,"13":"Yavé dio, entonces, al ángel que conversaba conmigo una respuesta muy esperanzadora."
,"14":"Al oírla el ángel me ordenó: 'Anúncialo a viva voz: Esto es lo que dice Yavé de los Ejércitos: Mi amor por Jerusalén y por Sión es tan grande que llega a ser celoso;"
,"15":"por eso, estoy muy enojado con las naciones orgullosas; pues si bien yo estaba disgustado con Jerusalén, no era para que ellas llegaran a tanto."
,"16":"Por esto, continúa Yavé, estoy volviendo a Jerusalén muy bien dispuesto; mi Templo será reconstruido, y de nuevo se usará la lienza para medir en Jerusalén, palabra de Yavé. Todavía te queda algo que anunciar:"
,"17":"En mis ciudades habrá abundancia de todo. Yavé tendrá una vez más piedad de Sión y volverá a hacer de Jerusalén su predilecta.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Tuve otra visión: yo veía cuatro cuernos."
,"2":"Pregunté al Angel que me acompañaba qué significaban estos cuernos y él me respondió: 'Estas son las naciones enemigas de Judá y Jerusalén.'"
,"3":"En seguida me mostró Yavé a cuatro herreros."
,"4":"Yo dije: '¿Qué vienen a hacer aquellos hombres?', y él me explicó: 'Esos cuernos son las naciones que han dispersado a Judá, sin que nadie pudiera resistirles. Pero éstos han venido para aterrorizarlos, para acabar con el poderío de las naciones que han lanzado sus fuerzas contra el país de Judá para dispersar a su gente.'"
,"5":"Tuve la siguiente visión: Veía a un hombre que llevaba en su mano una lienza para medir."
,"6":"Le pregunté a dónde iba y me contestó: 'Voy a medir a Jerusalén, para saber cuánto mide de largo y de ancho.'"
,"7":"El ángel que conmigo conversaba se quedó parado mientras que otro ángel le salía al encuentro."
,"8":"El que estaba de pie le dijo: 'Corre a decir a este joven que Jerusalén será una ciudad abierta, pues será inmenso el número de habitantes y de animales que habrá en su interior."
,"9":"Pero yo seré para ella como una muralla de fuego que la rodee totalmente, y habitaré en ella para ser su gloria.'"
,"10":"'¡Ea!, salgan del país del norte, dice Yavé, pues yo los he dispersado a los cuatro puntos cardinales.'"
,"11":"Sálvense, habitantes de Sión que viven en Babilonia."
,"12":"Porque esto es lo que dice Yavé, que me ha enviado con su poder, respecto de las naciones que los han asaltado a ustedes: 'El que a ustedes los toca me pega en la pupila del ojo."
,"13":"Por eso, levanto mi mano para que las saqueen aquellos que fueron sus esclavos.' Así sabrán que Yavé de los Ejércitos me ha enviado."
,"14":"Canta, gozosa, oh hija de Sión, pues mira que yo vengo,para quedarme contigo, dice Yavé."
,"15":"En aquel día numerosas naciones,vendrán a Yavé y pasarán a ser su pueblo, pero yo me quedaré contigo."
,"16":"Yavé tendrá en propiedad,a Judá en la tierra santa,y será Jerusalén nuevamente su elegida."
,"17":"Que todo ser se calle ante Yavé, pues se levanta y sale de su Morada Santa."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Yavé presentó ante mis ojos a Josué, el gran sacerdote. Estaba éste frente al ángel de Yavé, y tenía a su derecha a Satán, que lo estaba acusando."
,"2":"El ángel de Yavé dijo a Satán: 'Que Yavé te contenga, Satán, que él te haga callar, pues Jerusalén es su preferida. ¿No aparece éste como un tizón sacado del fuego?"
,"3":"Ahora bien, Josué estaba vestido con ropas sucias, mientras permanecía en presencia del ángel de Yavé."
,"4":"Tomó éste la palabra y les ordenó a sus asistantes:"
,"5":"'Quítenle sus ropas sucias y pónganle un traje de gala. Coloquen además en su cabeza una corona reluciente.' Lo vistieron con el traje de fiesta y pusieron en su cabeza la corona reluciente."
,"6":"Luego el ángel de Yavé dijo a Josué: 'Ahora te he dejado libre de tu falta.',En seguida, el ángel hizo a Josué esta advertencia: "
,"7":"'Esto te manda decir Yavé: Si andas por mis caminos y respetas mis disposiciones, tú mismo gobernarás mi Casa y cuidarás de sus patios. Yo dejaré que formes parte de los que están aquí presentes."
,"9a":"Pues pongo ahora delante de Josué una piedra que reluce como si tuviera siete ojos y yo mismo escribo en ella la inscripción.'"
,"8":"Escucha, pues, Josué, sumo sacerdote, tú y tus compañeros que se sientan en tu presencia, pues todos ustedes son personas importantes."
,"9b":"Voy a traer acá a mi servidor, el Brote, y cancelo la deuda del país en un solo día."
,"10":"Ese día, prosigue Yavé, se invitarán unos a otros a pasar un rato debajo de la parra o de la higuera.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"El ángel que hablaba conmigo volvió y me sacudió como se despierta a un hombre que está durmiendo."
,"2":"Me preguntó qué veía yo, y le dije: 'Veo un candelabro de oro macizo con su estanque de aceite arriba, y siete lámparas."
,"3":"También hay cerca del candelabro dos olivos, uno a la derecha y otro a la izquierda.'"
,"4":"Pregunté al ángel que estaba conmigo qué querían decir esas cosas."
,"5":"Y me respondió: '¿Cómo, no lo sabes?' 'No, señor', insistí yo."
,"6":"Entonces continuó: 'Estas siete lámparas son los ojos de Yavé que miran por toda la tierra.'"
,"11":"Le volví a preguntar:"
,"12":"'¿Qué representan esos dos olivos puestos a la derecha y a la izquierda del candelabro?'"
,"13":"Me volvió a decir: '¿Cómo, tampoco sabes lo que quieren decir?' 'No, señor', le repliqué."
,"14":"El me explicó: 'Son los dos Ungidos con aceite fresco que están ante el Señor del mundo entero.'"
,"7":"Esta es una palabra de Yavé para Zorobabel: 'Ni con el valor ni con la fuerza, sino sólo con mi espíritu."
,"8":"Miren esa montaña tan inmensa; pues bien, será completamente allanada delante de Zorobabel. Y de ella extraerá hasta la última piedra que corone el Templo, en medio de aclamaciones de gracias.' Una palabra de Yavé me fue dirigida:"
,"9":"'Las manos de Zorobabel pondrán los cimientos de este Templo y ellas mismas lo terminarán.'"
,"10":"El día en que se puso la primera piedra, les pareció ser una cosa sin importancia, pero ahora es una alegría para todos ustedes ver la piedra que corona el edificio en manos de Zorobabel."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Tuve otra visión: un libro iba volando."
,"2":"Cuando el ángel me preguntó qué veía yo, le respondí: 'Veo un libro que va volando; mide como diez metros de largo por cinco de ancho.'"
,"3":"Entonces me dijo:"
,"4":"'Allí va escrita la Maldición que se extenderá por toda esta región. Según ella todos los ladrones serán echados fuera de aquí y lo mismo les ocurrirá a todos los que juran en falso. Por ahora, dice Yavé, la dejo salir de mi boca para que entre en la casa del ladrón y en la del que jura, se instale en esa casa y la demuela con sus paredes y techo.'"
,"5":"El ángel que andaba conmigo se me adelantó, diciéndome: 'Fíjate bien en lo que vas a ver aparecer.'"
,"6":"'¿Qué es eso?', le pregunté. 'Es un cajón para pesar grano, me contestó. Representa el pecado que todos cometen en el país.'"
,"7":"Se levantó la tapa de plomo y apareció una mujer sentada dentro del cajón."
,"8":"El ángel dijo: 'Esa es la maldad.' Y empujándola hacia el fondo, tapó el cajón con la cubierta de plomo."
,"9":"Vi inmediatamente que aparecían dos mujeres. El viento levantaba sus alas, pues llevaban alas parecidas a las de la cigüeña. Se llevaron volando el cajón."
,"10":"Cuando pregunté al ángel que me hablaba a dónde lo llevaban, me dijo:"
,"11":"'Van a edificarle un templo en el país de Senaar y a prepararle un pedestal para ponerla allí.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Tuve otra visión: cuatro carros salían de entre dos cerros y los cerros eran de bronce."
,"2":"El primer carro iba tirado por caballos rojos,"
,"3":"el segundo por caballos negros, el tercero por caballos blancos, y el cuarto por caballos overos."
,"4":"Pregunté al ángel qué quería decir eso"
,"5":"y su respuesta fue: 'Estos marchan en dirección de los cuatro puntos cardinales después de haberse presentado al Señor del mundo entero. Los caballos rojos se dirigen al oriente,"
,"6":"los negros hacia el norte, los blancos hacia el occidente, y los overos hacia el sur.'"
,"7":"Se movían refrenando su vigor, impacientes por recorrer la tierra. Cuando él les dijo: 'Vayan a recorrer la tierra', salieron a recorrer la tierra."
,"8":"Luego, me llamó para decirme: 'Mira a los que se dirigen al norte; ellos harán que mi espíritu descanse en el país del norte.'"
,"9":"Una palabra de Yavé me fue dirigida:"
,"10":"'Recoge de manos de Helday, de Tobías y de Jedaya las ofrendas de los que han vuelto del destierro, y dirígete hoy mismo a casa de Josías, hijo de Sefanías, que ha regresado de Babilonia."
,"11":"Con el oro y plata recolectados harás una corona que pondrás en la cabeza de Josué, hijo de Josadac, sumo sacerdote."
,"12":"Le hablarás así de parte de Yavé de los Ejércitos: Viene un hombre cuyo nombre es Brote, y sepan que algo brotará de él."
,"13":"El construirá el Templo de Yavé y recibirá el poder. Se sentará en un trono para gobernar, y también un sacerdote se sentará en un trono, con armonía perfecta entre ambos."
,"14":"La corona quedará en el Templo como un memorial de lo hecho por Helday, Tobías y Josías, el hijo de Sofonías."
,"15":"Los que están lejos vendrán y trabajarán en la construcción del Templo de Yavé. Pero es preciso que ustedes obedezcan la palabra de Yavé, su Dios."
}`)
	CurrentBook.AddChapter(7, `{
"1":"El día cuatro del noveno mes del cuarto año de reinado del rey Darío, Yavé volvió a hablar a Zacarías."
,"2":"La ciudad de Betel había enviado una delegación presidida por Saresa y Reguem-Melec para que presentaran a Yavé sus súplicas"
,"3":"e hicieran a los sacerdotes de su Templo y a los profetas esta consulta: '¿Debemos continuar con ayunos y penitencias en el mes de julio, como hasta ahora lo hemos hecho?'"
,"4":"Entonces me llegó una palabra de Yavé de los Ejércitos:"
,"5":"'Esto es lo que dirás a todos residentes del país y a los sacerdotes: Cuando ustedes han ayunado y llorado en julio y en septiembre, durante setenta años, ¿acaso fui yo el que les pedí ayunar? "
,"6":"Si ustedes quieren comer y beber, que lo decidan ustedes mismos."
,"7":"¿Acaso ya se olvidaron de lo que decía Yavé por medio de los antiguos profetas cuando la gente vivía tranquila en Jerusalén y sus pueblos vecinos y los desiertos de Negueb y la Sefela estaban poblados? (8)"
,"9":"Pues bien, esto es lo que Yavé decía por sus profetas: 'Tomen decisiones justas, actúen con sinceridad, sean compasivos con sus hermanos."
,"10":"No opriman a la viuda ni al huérfano, al extranjero ni al pobre; no anden pensando cómo hacerle el mal a otro."
,"11":"Pero ellos no quisieron que les hablara, me volvieron la espalda y se tapaban los oídos para no escucharme;"
,"12":"endurecieron el corazón como el diamante. Rechazaron la Ley y los mensajes que Yavé de los Ejércitos les mandaba por medio de los antiguos profetas, a los cuales inspiraba. Yavé se enojó mucho con esto,"
,"13":"y se les dijo: Si ustedes no le hacen caso cuando él los llama, también ustedes gritarán sin que él los atienda."
,"14":"Por esta razón los dispersé entre naciones desconocidas para ellos y a sus espaldas dejaron un país desolado y sin alma viviente. Por culpa de ellos un país fértil se convirtió en un desierto.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Una palabra de Yavé de los Ejércitos me fue dirigida:"
,"2":"'He querido a Sión hasta los celos y por ella he llegado hasta enojarme con sus enemigos."
,"3":"He vuelto a Sión, pues quiero residir en Jerusalén. Esta será llamada Ciudad fiel, y el cerro de Yavé de los Ejércitos, Cerro Santo.'"
,"4":"Así habla Yavé de los Ejércitos: 'Los ancianos y las viejas volverán a sentarse en las plazas de Jerusalén, apoyándose en su bastón por el peso de los años."
,"5":"Las calles de la ciudad se llenarán de niños y niñas, que andarán corriendo por ellas.'"
,"6":"Y pregunta Yavé: 'Si esto ahora les parece imposible a los que han quedado de este pueblo, ¿tendré yo también que pensar que no es posible?"
,"7":"Pues bien, dice Yavé, yo voy a salvar a mi pueblo que se encuentra tanto al oriente como al poniente. Los voy a juntar para que vivan en Jerusalén."
,"8":"Ellos serán mi pueblo y yo seré su Dios, guardándonos mutuamente fidelidad y respeto."
,"9":"No bajen sus manos desalentados, les dice Yavé de los Ejércitos. Recuerden lo que les fue dicho por los profetas en aquel día en que se puso la primera piedra para reconstruir el Santuario del Señor."
,"10":"Pues antes ni los hombres recibían su salario ni los animales su alimento; nadie podía viajar de un lado a otro con tranquilidad, debido al enemigo, pues yo dejaba que cada uno se lanzara contra su prójimo."
,"11":"Pero ahora, voy a tratar a los sobrevivientes de este pueblo en forma distinta al pasado, dice Yavé."
,"12":"Pues yo sembraré la paz; la viña dará uva; la tierra, sus productos; el cielo entregará su rocío. Todo esto se lo daré a lo que queda de este pueblo."
,"13":"Así como antes ustedes, gente de Judá y de Israel, eran una raza maldita para todo el mundo, así también ahora yo los salvaré para que sean felicitados por todos. ¡No se desalienten, pues, y tengan confianza!"
,"14":"Esto es lo que dice Yavé: Así como yo estaba resuelto a castigarlos cuando sus padres me disgustaron, sin que diera muestras de ceder,"
,"15":"así también ahora, cambiando de parecer, he decidido tratar bien a Jerusalén y a la gente de Judá. No teman, pues."
,"16":"Esto es lo que deben hacer: Díganse la verdad unos a otros, y cuando juzguen, pronuncien sentencias justas;"
,"17":"no anden pensando cómo perjudicar a otro; no sean amigos de jurar en falso. Porque éstas son las cosas que aborrezco, dice Yavé.'"
,"18":"Una palabra de Yavé de los Ejércitos me llegó nuevamente:"
,"19":"'Los días de ayuno de junio, julio, septiembre y diciembre serán en adelante para la gente de Judá días feriados y de regocijo, con ceremonias bonitas, palabra de Yavé, pero sean sinceros y vivan en paz.'"
,"20":"Así habla Yavé de los Ejércitos: 'Llegarán a Jerusalén gente de diversos países, habitantes de grandes ciudades."
,"21":"De una ciudad a otra se enviarán invitaciones diciendo: 'Vengan con nosotros a orar ante Yavé, vayamos a buscar a Yavé; pues ya estamos listos para partir.'"
,"22":"Y así es como pueblos numerosos y naciones poderosas llegarán a Jerusalén, para adorar a Yavé de los ejércitos y pedirle favores,"
,"23":"Así habla Yavé de los Ejércitos: 'En esos días diez hombres, de distinta nacionalidad cada uno, agarrarán por el manto a un judío, suplicándole: Queremos ir con ustedes, pues hemos oído decir que Dios está con ustedes.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Yavé se ha establecido en Hadrak y reside en Damasco, pues las ciudades de Aram le pertenecen tanto como todas las tribus de Israel."
,"2":"Igualmente son suyas Jamat, que está al lado, y Tiro y Sidón que llevan tan bien sus negocios."
,"3":"Tiro se ha construido una fortaleza, y ha amontonado la plata como el polvo y el oro como la tierra de las calles."
,"4":"Pero ahora Yavé se va a apoderar de ella; destruirá su frente marítimo y el fuego destruirá sus ciudades."
,"5":"Al ver esto, Ascalón tamblará de miedo y Gaza se pondrá a tiritar. Ecrón lo mismo, al ver perdida su esperanza. El rey se irá de Gaza, Ascalón quedará sin habitantes."
,"6":"Una población mestiza vivirá en Asdod. Así aplastaré la soberbia de los filisteos."
,"7":"Sacaré de su boca la carne con sangre, y de sus dientes los alimentos prohibidos. Pero nuestro Dios se dejará para él a algunos filisteos, que formarán como una familia en Judá. Ecrón será tratado como el jebuseo."
,"8":"Yo montaré guardia para proteger a mi país de cualquier asaltante; ya nadie se atreverá a oprimirlos, pues ahora he visto cómo están oprimidos."
,"9":"Salta, llena de gozo, oh hija de Sión, lanza gritos de alegría, hija de Jerusalén. Pues tu rey viene hacia ti; él es santo y victorioso, humilde, y va montado sobre un burro, sobre el hijo pequeño de una burra."
,"10":"Destruirá los carros de Efraím,y los caballos de Jerusalén. Entonces se podrá romper el arco con flechas, pues él dictará la paz a las naciones. Extenderá su dominio de un mar al otro mar, y desde el Eufrates hasta el fin del mundo."
,"11":"En cuanto a ti, por consideración a tu alianza celebrada con sangre, sacaré a los presos de la cisterna seca en que los guardaban."
,"12":"Hacia ti volverán, oh Sión, los prisioneros que estaban aguardando. Ahora te doy doble bendición para compensar tus días de destierro."
,"13":"Yo estiraré a Judá como un arco y le pondré como flecha a Efraím; lanzaré tus hijos, oh Sión, contra los griegos, y tú serás como la espada de un héroe."
,"14":"Entonces Yavé aparecerá por encima de ellos y lanzará sus flechas como relámpagos. El Señor hará resonar la trompeta y marchará en medio de la tormenta del sur."
,"15":"Yavé de los Ejércitos será su escudo. Pisotearán, triunfantes, a los malvados, beberán sangre como si fuera vino y quedarán repletos como la copa del sacrificio o como los cuernos del altar."
,"16":"Yavé, su Dios, los pondrá a salvo; salvará a este pueblo que es su rebaño."
,"17":"¡Ya se verán fuertes, ya serán hermosos! El trigo dará vigor a los jóvenes y el vino dulce, a las muchachas."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Pidan a Yavé las lluvias de primavera, pues él es quien manda los relámpagos; él les dará lluvia abundante para que cada uno tenga pasto en su campo."
,"2":"Porque consultados los idolitos, sólo responden tonterías, los adivinos tienen falsas visiones. Con esto ilusionan a la gente y la consuelan con engaños. Por eso, mi pueblo se ha dispersado y ha sido maltratado, como ovejas a las que falta un pastor."
,"3":"(Me he indignado con los pastores y voy a castigar a los chivatos.),Pero Yavé de los Ejércitos visitará a su rebaño, la tribu de Judá, ellos serán su caballo de batalla. "
,"4":"El es el que dará el ejército, la lanza y el arco de guerra; El es el que dará todos los jefes."
,"5":"Ellos serán en la batalla como valientes que pisan el polvo del camino; serán victoriosos, pues Yavé estará de su parte, y derrotarán a los que montan a caballo."
,"6":"Reanimaré al pueblo de Judá y liberaré a la gente de José. Los restableceré, pues les he tenido lástima, y serán como si nunca los hubiera rechazado (porque yo, Yavé, su Dios, los he escuchado)."
,"7":"Los de Efraím serán como unos héroes, se sentirán alegres como quien toma vino. Sus hijos se alegrarán al verlos y alabarán con júbilo al Señor."
,"8":"Les daré un silbido para juntarlos, pues yo los he rescatado, y serán tan numerosos como antes."
,"9":"Los que yo disperse por el mundo se acordarán de mí hasta en el lugar más lejano, y allí seguirán instruyendo a sus hijos, los que volverán."
,"10":"Los haré regresar de la tierra de Egipto, los traeré juntos desde Asiria; les daré nuevamente la región de Galaad y la del Líbano, pero éste se les hará chico."
,"11":"Cruzarán el Mar Rojo, quedará seco el cauce del Nilo. Será aplastado el orgullo de Asur y no habrá más rey en Egipto."
,"12":"Yavé los hará poderosos y avanzarán confiados en su Nombre."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Abre, oh Líbano, tus puertas, y que el fuego devore tus cedros."
,"2":"Gime, ciprés, porque se ha venido abajo el cedro, porque han sido derribados los gigantes. Giman también, encinas de Basán, porque ha sido talada la selva impenetrable."
,"3":"Resuenan los lamentos de los pastores al ver arruinado lo que era su gloria. Hacen eco los rugidos de los leones porque ha sido devastada la gloria del Jordán."
,"4":"Así me habló Yavé, mi Dios: 'Encárgate de esas ovejas que van al matadero."
,"5":"Sus compradores las matan sin ser castigados, y los que las venden dicen: '¡Gracias a Yavé, ahora soy rico!' Y sus pastores no se preocupan de ellas."
,"6":"(Yo tampoco me voy a preocupar más de los habitantes de este país, dice Yavé. Los dejaré en manos de su pastor y de su rey, que los exploten; pero no intervendré.)'"
,"7":"Entonces me hice pastor de las ovejas a las que mataban los comerciantes de ganado. Me conseguí un par de bastones de ganado: a uno le puse el nombre de Bondad y al otro de Unión. Y desde entonces me hice cargo de las ovejas."
,"8":"En un mes despedí a los tres pastores. Pero me aburrieron las ovejas, y ellas también se disgustaron conmigo."
,"9":"Entonces exclamé: 'Ya no las cuido más. La que quiera morirse, que se muera; la que quiera perderse, que se pierda; y las que queden, que se desgarren la carne unas a otras.'"
,"10":"En seguida tomé el bastón llamado Bondad y lo rompí; y fue rota la alianza que Dios había hecho con los pueblos vecinos."
,"11":"Cuando los comerciantes de ganado vieron que lo había roto, comprendieron que eso era una señal de Yavé."
,"12":"Yo les dije: 'Si ustedes quieren, páguenme mi salario; si no, quédense con él.',Y me dieron treinta monedas de plata. "
,"13":"Pero Yavé me ordenó: 'Echa en los cofres del Templo ese precio tan alto en que ellos me han valorado.' Tomé las monedas y las deposité en la alcancía del Templo de Yavé."
,"14":"A continuación, rompí mi otro bastón llamado Unión; y quedó rota la fraternidad entre Judá e Israel."
,"15":"Después Yavé me dijo: 'Vístete como un pastor poco serio,"
,"16":"pues yo voy a dar a este país un pastor que no se preocupará de las ovejas que desaparecen, ni buscará a la oveja perdida, ni cuidará a la herida, ni sostendrá a la que apenas puede caminar. Al contrario, se comerá la carne de las más gordas y les arrancará las pezuñas.'"
,"17":"¡Ay del pastor que no sirve para nada, que deja abandonado su rebaño! ¡La espada le cortará su brazo y le alcanzará el ojo derecho! ¡Que se seque su brazo y que su ojo derecho no vea más!"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Esta es sentencia de Yavé que estiró los cielos, que puso los cimientos de la tierra y que formó el espíritu del hombre en su interior; y se refiere al futuro de Israel."
,"2":"Vienen los días en que yo haré que Jerusalén sea para todos los pueblos una copa de vino que hace perder los sentidos."
,"3":"Jerusalén, en ese entonces, será como una piedra que tratarán de levantar todos los pueblos; pero cuantos lo hagan quedarán desgarrados."
,"4":"Ese día, dice Yavé, sembraré la confusión entre los caballos y volveré locos a sus jinetes. Dejaré ciegos a todos los pueblos y cuidaré de la casa de Judá."
,"5":"Entonces los jefes de Judá dirán en su interior: 'La fuerza de Jerusalén le viene de Yavé, su Dios.'"
,"6":"Aquel día haré que los pueblitos de Judá sean como un fósforo encendido en un montón de leña, como una antorcha lanzada entre las gavillas; devorarán a izquierda y derecha a todos los pueblos de los alrededores. A Jerusalén, empero, no le pasará nada."
,"7":"Yavé salvará, en primer lugar, a las ciudades de Judá, para que la familia de David y los habitantes de Jerusalén no se crean más importantes que el resto de Judá."
,"8":"Ese día, también, Yavé protegerá de tal forma a los habitantes de Jerusalén que el más débil de entre ellos será como David, y la familia de David, que los encabezará, será como Dios, como el ángel de Yavé."
,"9":"Ese día, destruiré sin piedad a todas las naciones que hayan atacado a Jerusalén."
,"10":"Dispondré el ánimo de los descendientes de David y de los habitantes de Jerusalén para que vuelvan a mí con amor y confianza. Llorarán por aquel que ha sido traspasado, como se siente la muerte de un hijo único, y lo echarán de menos como se lamenta el fallecimiento del primer hijo."
,"11":"La lamentación que habrá en ese día, en Jerusalén, será tan grande como la que se celebra para Hadad Rimón en la llanura de Meguido."
,"12":"Cada familia en el país, por separado, guardará luto y pesar: así, por ejemplo, la familia de David sola, y lo mismo sus mujeres."
,"13":"La familia de Natán, por su cuenta, y lo mismo sus mujeres; la familia de Leví, en su casa, y lo mismo sus mujeres; la familia de Semeí aparte y lo mismo sus mujeres."
,"14":"Y de la misma manera, en todas las demás familias, ya sean hombres o mujeres."
}`)
	CurrentBook.AddChapter(13, `{
"1":"En aquel día habrá una fuente siempre corriendo para que los descendientes de David y los habitantes de Jerusalén se puedan lavar de sus pecados e impurezas."
,"2":"En esos días, dice Yavé, arrancaré del país hasta el nombre de los ídolos para que nunca más se los mencione; echaré además a los profetas con sus espíritus impuros."
,"3":"Y si alguno intenta hacerse de profeta, su padre y su madre que lo engendraron le dirán: 'Mereces la muerte, porque no dices más que mentiras en nombre de Yavé.' Y sus mismos padres lo traspasarán mientras profetice."
,"4":"Entonces los profetas se avergonzarán de las visiones que contaban y no se pondrán más el manto de pieles que les daba autoridad para mentir."
,"5":"Y se disculparán: 'Yo no soy profeta; soy un campesino que trabaja la tierra desde joven.'"
,"6":"Y si alguno le llega a preguntar: '¿Por qué tienes entonces esas cicatrices en tu cuerpo?', él se defenderá diciendo: 'Son heridas que me hicieron mis amigos.'"
,"7":"Levántate, espada, contra mi pastor y contra el hombre de mi parentela, exclama Yavé de los Ejércitos."
,"8":"Hiere al pastor para que se dispersen las ovejas, que yo me encargaré de matar a los corderitos. Y en todo el país, amenaza Yavé, dos tercios serán exterminados, y sólo se salvará un tercio."
,"9":"Echaré ese tercio al fuego; lo purificaré como se hace con la plata, lo pondré a prueba como se prueba el oro. El invocará mi Nombre y yo lo escucharé. Entonces yo diré: '¡Este es mi pueblo!', y él, a su vez, dirá: '¡Yavé es mi Dios!'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Aquí viene el día de Yavé, en que se repartirán tus despojos dentro de tus muros."
,"2":"Haré que se junten todas las naciones para atacar a Jerusalén. Se apoderarán de la ciudad, saquearán sus casas y violarán a sus mujeres. La mitad de la población será llevada cautiva; pero a los demás habitantes de la ciudad no los eliminarán."
,"3":"Entonces saldrá Yavé a combatir; peleará con esas naciones como lo hace en los días de batalla."
,"4":"Ese día pondrá su pie sobre el Cerro de los Olivos, que queda al oriente de Jerusalén. Y el Cerro de los Olivos se partirá en dos de este a oeste, dejando en medio un profundo valle; una parte del cerro quedará al norte y la otra mitad al sur."
,"5":"Y huirán ustedes por ese valle, por entre los dos cerros hacia Yasol. Huirán igual que huyeron cuando hubo ese terremoto en tiempos de Ozías, rey de Judá. Entonces vendrá Yavé, tu Dios, acompañado de todos los santos."
,"6":"En aquel día no habrá más frío ni hielo."
,"7":"Será éste un día extraordinario, solamente conocido por Yavé; no habrá más cambio del día a la noche, pues de noche será como de día claro."
,"8":"Ese día brotará en Jerusalén un manantial que nunca se secará ni en verano ni en invierno y que estará siempre corriendo, tanto hacia el mar oriental como hacia el mar occidental."
,"9":"Y Yavé reinará sobre toda la tierra. El será el Unico, y único será su Nombre."
,"10":"El país entero se transformará en una planicie, desde Gueba, en el norte, hasta Rimón, en el Negueb. Jerusalén, en cambio, será alzada en su mismo lugar desde la puerta de Benjamín hasta el lugar de la antigua puerta; es decir, hasta la puerta del Angulo, y desde la torre de Jananeel hasta los lagares del rey."
,"11":"Ya no habrá peligro ni maldición para Jerusalén; sus habitantes vivirán tranquilos en adelante."
,"12":"En cambio, éste es el castigo que Yavé dará a todos los pueblos que hayan atacado a Jerusalén: se les pudrirá su carne mientras aún se mantienen de pie; sus ojos se descompondrán dentro de sus órbitas y su lengua se echará a perder en su misma boca."
,"15":"Una peste parecida atacará a los caballos, a las mulas, a los camellos, a los burros; en fin, a todos los animales que estén en sus campamentos."
,"13":"Aquel día Yavé les infundirá un miedo horrible: se volverán el uno contra el otro y se pondrán a pelear entre ellos mismos."
,"14":"Los hombres de Juda participarán en el combate de Jerusalén, y luego recogerán los despojos de todas las naciones vecinas: oro, plata, trajes en grandes cantidades."
,"16":"Después de esto, los sobrevivientes de todos los países que le declararon la guerra a Jerusalén vendrán anualmente a adorar al Rey, Yavé de los Ejércitos, y a celebrar la fiesta de los Tabernáculos."
,"17":"Si algún pueblo de la tierra no sube a Jerusalén para reverenciar al Rey, Yavé de los Ejércitos, será castigado con la sequía."
,"18":"Y si son los egipcios quienes se niegan a hacerlo, Yavé los castigará como lo merecen las naciones que no vengan a celebrar esa dicha fiesta."
,"19":"Así, pues, pagarán su pecado Egipto y las naciones que no vengan para esta fiesta."
,"20":"En ese día, hasta los cascabeles de los caballos llevarán escrito: 'Consagrado a Yavé.' Las ollas del Templo de Yavé serán tan sagradas como las copas que se usan para esparcir la sangre ante el altar."
,"21":"Y en Jerusalén y Judá cualquier utensilio de cocina será propiedad santa de Yavé de los Ejércitos; de tal modo que podrán usarlos para cocer la carne de los animales sacrificados. Desde ese día no habrá más mercaderes en la Casa de Yavé."
}`)

}
func ES_LBL_LoadVPDTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Estas son las palabras que dijo Moisés a todo Israel, al otro lado del Jordán, en el desierto. Estaba en la Arabá frente a Suf, entre Parán y Tofel, entre Labam, Haserot y Dishab."
,"2":"Desde el Horeb hasta Cadés Barné, habían corrido once días de camino por los montes de Seír."
,"3":"El año 40 después de la salida de Egipto, el día primero del undécimo mes, Moisés comunicó a los hijos de Israel todo cuanto Yavé le había ordenado respecto a ellos."
,"4":"Esto sucedió después de derrotar a Sijón, rey de los amorreos, que habitaba en Jesbón, y a Og, rey de Basán, que reinaba en Astarot y en Edreí,"
,"5":"pues estaban en el país de Moab, al otro lado del Jordán, cuando Moisés comenzó a exponer esta ley. Y les dijo:"
,"6":"'Yavé, nuestro Dios, nos habló así en el monte Horeb: 'Ustedes han demorado bastante tiempo en esta montaña."
,"7":"En marcha, partan. Ustedes entrarán en el territorio de los amorreos y en los territorios vecinos: la Arabá, la Montaña, la Tierra Baja, el Negueb y la costa del mar, es decir todo el país de Canaán y el Líbano, hasta el gran río Eufrates."
,"8":"Miren: ésta es la tierra que les he reservado; vayan y tomen posesión de la tierra que Yavé juró dar a sus padres, Abrahán, Isaac y Jacob y a todos sus descendientes.'"
,"9":"Fue entonces cuando les dije: 'No puedo hacerme cargo yo solo de todos ustedes."
,"10":"Yavé, el Dios de ustedes, los ha multiplicado y son ahora tan numerosos como las estrellas del cielo."
,"11":"¡Yavé, Dios de sus padres, los haga crecer mil veces más y los bendiga como se lo prometió!"
,"12":"Pero ¿cómo los atenderé yo solo y me haré cargo de sus pleitos?"
,"13":"Busquen, pues, entre ustedes hombres sabios, perspicaces y experimentados de cada una de sus tribus, y yo los pondré al frente del pueblo."
,"14":"Ustedes me respondieron: 'Está bien lo que tú nos propones hacer'."
,"15":"Tomé entonces de entre los jefes de sus tribus hombres sabios y experimentados y los puse al frente de ustedes como jefes de millar, de cien, de cincuenta y de diez, así como también secretarios para cada una de las tribus."
,"16":"Entonces di a los jueces las siguientes instrucciones: 'Ustedes atenderán las quejas de sus hermanos, y decidirán, sea que el pleito oponga un israelita a su hermano, o bien un israelita a uno de los extranjeros que viven en medio de nosotros."
,"17":"Cuando juzguen, no se dejarán influenciar por persona alguna, sino que escucharán lo mismo al pobre que al rico, al poderoso que al débil, y no tendrán miedo de nadie, pues el juicio es cosa de Dios. Si un problema les resulta demasiado difícil, me lo pasarán a mí, y yo lo veré."
,"18":"Así, pues, en aquel entonces les ordené a ustedes todo lo que tenían que hacer'."
,"19":"Al fin, habiendo partido del Horeb, enfrentamos aquel enorme y temible desierto que vieron, camino de la montaña del amorreo, como Yavé nos lo mandaba, y llegamos a Cadés Barné."
,"20":"Entonces les dije: 'Hemos llegado a esta montaña del amorreo, que Yavé, nuestro Dios, nos da."
,"21":"Mira, Israel, Yavé pone a tu disposición todo este territorio; sube, pues, y toma posesión de él como Yavé, el Dios de tus padres te ha dicho. No tengas miedo ni te desanimes.'"
,"22":"Entonces todos ustedes se acercaron a mí y me dijeron: 'Manda mejor algunos hombres delante de nosotros para que exploren el país y nos enseñen los caminos que llevan a las ciudades que podremos asaltar'."
,"23":"Me pareció bien esa propuesta y tomé de entre ustedes doce hombres, uno por tribu,"
,"24":"los cuales partieron, subieron a los cerros y llegaron hasta el Valle del Racimo, que recorrieron a pie."
,"25":"Allí tomaron de las frutas del valle y, al volver, nos contaron cómo les había ido. Nos dijeron: 'Buena es la tierra que Yavé nos da.'"
,"26":"Ustedes, sin embargo, no quisieron subir, sino que se rebelaron contra las órdenes de Yavé."
,"27":"Y empezaron a murmurar en sus tiendas: 'Yavé no nos quiere; nos hizo salir de Egipto para entregarnos a los amorreos, que acabarán con todos nosotros."
,"28":"¿A dónde nos están llevando? Los mensajeros dicen que la gente de allá es más fuerte y más numerosa que nosotros; las ciudades son grandes y con murallas que llegan al cielo; incluso se han visto allí gigantes. Con esto se nos ha ido abajo el ánimo.'"
,"29":"Entonces yo les dije:"
,"30":"'No teman ni tengan miedo de ellos. Yavé, nuestro Dios, que los conduce a ustedes, peleará por ustedes como ya lo hizo en Egipto"
,"31":"y en el desierto. Han visto cómo los llevó durante todo el camino, como un padre lleva a su hijo, hasta que llegamos a este lugar.'"
,"32":"Pero ni aun así creyeron a Yavé, nuestro Dios."
,"33":"El, sin embargo, era quien había ido delante de ustedes durante todo el viaje, enseñándoles los sitios donde debían levantar su campamento, señalándoles el camino, de noche con la columna de fuego y de día con la nube."
,"34":"Al escuchar Yavé sus quejas, se indignó y juró:"
,"35":"'Ningún hombre de esta generación perversa verá la espléndida tierra que yo juré dar a sus padres,"
,"36":"excepto Caleb, hijo de Jefoné; él la verá y yo le daré a él y a sus hijos la tierra que ha pisado, porque ha seguido fielmente a Yavé'."
,"37":"Por culpa de ustedes Yavé se enojó también conmigo y me dijo: 'Tampoco tú entrarás allí;"
,"38":"será tu ayudante Josué, hijo de Nun, el que entrará. Dale autoridad, pues él ha de entregar a Israel su herencia."
,"39":"Allí entrarán los pequeños de ustedes, de los que dijeron que iban a ser presa de sus enemigos; ellos sí entrarán, pues no conocen todavía el bien y el mal. A ellos se la daré, y ellos la poseerán."
,"40":"Pero ustedes vuelvan atrás y partan hacia el desierto del Mar Rojo.'"
,"41":"Ustedes me respondieron: 'Hemos pecado contra Yavé, nuestro Dios. Iremos y combatiremos como él nos ha ordenado.' Y tomaron cada uno sus armas y les pareció fácil escalar los cerros."
,"42":"Pero Yavé me dijo: 'Adviérteles que no vayan a pelear, pues yo no estoy con ellos, no sea que sean derrotados por el enemigo.'"
,"43":"Yo se lo dije, pero ustedes no escucharon; desobedecieron la orden de Yavé y subieron a los cerros."
,"44":"Entonces los amorreos, habitantes de aquellos cerros, les salieron al encuentro, los persiguieron como hacen las abejas y los acuchillaron desde Seír hasta Jormá."
,"45":"Ustedes al volver lloraron en presencia de Yavé, pero él no quiso escucharlos ni atender sus ruegos."
,"46":"Ustedes entonces se establecieron por largos años en Cadés; ustedes saben cuánto tiempo estuvimos allá."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Luego volvimos al desierto por el camino del Mar Rojo, como Yavé me había ordenado, y anduvimos largo tiempo rodeando los cerros de Seír."
,"2":"Entonces Yavé me habló:"
,"3":"'Ustedes llevan mucho tiempo rodeando estos cerros; vayan hacia el norte."
,"4":"Pero tú darás esta orden al pueblo: 'Van a pasar por el territorio de sus hermanos, los hijos de Esaú, que habitan en Seír. Ellos los temen a ustedes, pero, mucho cuidado,"
,"5":"no los ataquen, porque yo no les daré nada de su tierra, ni siquiera donde poner el pie. Sepan que los cerros de Seír se los he dado en posesión a Esaú,"
,"6":"y ustedes les comprarán con plata los alimentos que coman, e incluso el agua."
,"7":"Piensen que Yavé nos ha bendecido en todas nuestras obras; él había previsto nuestro camino por el desierto y hace ya cuarenta años que Yavé está con ustedes, sin que nada les haya faltado.'"
,"8":"Pasamos, pues, por el lado de nuestros hermanos, los hijos de Esaú que habitan en Seír. Dejamos el camino que lleva a la Arabá desde Elat y Asión Gaber y avanzamos por el camino del desierto de Moab."
,"9":"Yavé me dijo entonces: 'No ataques a Moab ni lo provoques al combate, pues yo no te daré nada de su país. Quise que la ciudad de Ar perteneciera a los hijos de Lot.'"
,"10":"(Antiguamente habitaban allí los emíos, pueblo grande, numeroso y de alta estatura, como los enaceos."
,"11":"Tanto a ellos como a los enaceos se los tenía por gigantes, pero los moabitas los llamaban emíos."
,"12":"Asimismo en Seír habitaron antiguamente los horeos, pero los hijos de Esaú los echaron, los exterminaron y se establecieron en su lugar, como lo hizo Israel en la tierra que Yavé le dio como posesión suya.)"
,"13":"'Y ahora ¡pasen el torrente de Zared!'"
,"14":"Pasamos, pues, el torrente de Zared. El tiempo que estuvimos caminando desde Cadés Barné hasta el paso del torrente fue de treinta y ocho años, hasta que hubo desaparecido del pueblo toda la generación de los hombres aptos para la guerra, como les había dicho Yavé."
,"15":"La mano de Yavé hizo lo necesario para eliminarlos del campamento hasta que desaparecieran todos."
,"16":"Muertos, finalmente, todos aquellos guerreros,"
,"17":"Yavé me dijo:"
,"18":"'Tú vas a pasar hoy por las fronteras de Moab, frente a la ciudad de Ar,"
,"19":"y te encontrarás con los amonitas. No los ataques ni los provoques, pues yo no te daré nada de la tierra de los amonitas: sepan que se la di a los hijos de Lot.'"
,"20":"(Esta tierra también fue considerada como país de gigantes, pues en ella habitaban antiguamente unos refaítas, o gigantes, que los amonitas llaman zamzumitas,"
,"21":"pueblo grande, numeroso y de altura descomunal, a semejanza de los enaceos. Yavé los exterminó por mano de los amonitas e hizo que éstos poblaran la tierra en su lugar."
,"22":"Lo mismo había hecho con los horitas que fueron exterminados en Seír por los hijos de Esaú. Y los amonitas habitaron la tierra de los refaítas hasta el día de hoy."
,"23":"En aquel tiempo los avitas también vivían en campamentos extendiéndose hacia Gaza, pero fueron exterminados por los caftoreos que habían salidos de Caftor, los cuales ocuparon su lugar.)"
,"24":"'Marchen, pues, y pasen el torrente de Arnón. Miren, yo pongo en manos de ustedes a Sijón, rey de Jesbón, el amorreo, y todo su país. Empieza, pues, desde ahora, a ocupar su tierra y a hacerle la guerra,"
,"25":"y yo, por mi parte, comienzo a infundir terror y miedo de ti entre todos los pueblos que hay debajo del cielo. Al oír tu nombre temblarán y se desmayarán ante ti.'"
,"26":"Del desierto de Quedemot envié mensajeros a Sijón, rey de Jesbón, con estas palabras de paz:"
,"27":"'Quiero pasar por tu país, pero seguiré el camino sin desviarme ni a la derecha ni a la izquierda."
,"28":"Véndenos los alimentos que consumamos, lo mismo que el agua que bebamos,"
,"29":"y déjanos pasar tan sólo como lo hicieron los hijos de Esaú que habitan en Seír y los moabitas que moran en Ar, hasta que lleguemos al Jordán y entremos en la tierra que nos da Yavé, nuestro Dios.'"
,"30":"Pero Sijón, rey de Jesbón, no quiso dejarnos pasar por allí, pues aquel día Yavé, nuestro Dios, quiso que se pusiera duro y cerrado, para que así cayera en nuestras manos."
,"31":"Entonces Yavé me habló: 'Ya ves que he comenzado a entregarte Sijón y su tierra; ustedes empezarán la conquista conquistando su tierra.'"
,"32":"Salió, pues, Sijón con toda su gente a presentarnos batalla en Yahas"
,"33":"y Yavé, nuestro Dios, nos lo entregó y lo derrotamos junto con sus hijos y toda su gente."
,"34":"En ese tiempo tomamos todas sus ciudades y las consagramos en anatema, matando a sus habitantes, hombres, mujeres y niños, sin perdonar vida alguna,"
,"35":"salvo la de los animales, que fueron parte del botín como los despojos de las ciudades que ocupamos."
,"36":"Desde Aroer, ciudad situada sobre la pendiente del torrente Arnón, y la ciudad que está abajo, hasta Galaad, no hubo aldea ni ciudad que no tomáramos: Yavé, nuestro Dios, nos las entregó todas."
,"37":"Pero, como Yavé, nuestro Dios nos había prohibido la tierra de los amonitas, no tocamos las ciudades de la pendiente del Yaboc ni las ciudades de los cerros."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Dando una larga vuelta, tomamos el camino de Basán. Og, rey de Basán vino a nuestro encuentro con todo su pueblo y nos presentó batalla en Edreí."
,"2":"Yavé me dijo: 'No le tengas miedo porque yo lo he entregado en tus manos con toda su gente y con su misma tierra, para que hagas con él lo mismo que hiciste con Sijón, el rey amorreo que habitaba en Jesbón.'"
,"3":"Y Yavé entregó en nuestras manos a Og, rey de Basán, con todo su pueblo; los derrotamos en tal forma que no quedó nadie con vida."
,"4":"Nos adueñamos de todas sus ciudades, no hubo población que se nos escapara; nos apoderamos de sesenta ciudades: toda la comarca de Argob, del reino de Og, en Basán."
,"5":"Todas eran ciudades fortificadas con muros altos, con puertas y trancas, sin contar los pueblos del campo, que eran innumerables."
,"6":"Los consagramos en anatema, exterminando a aquella gente, como lo habíamos hecho con Sijón, rey de Jesbón: acabamos con todas las ciudades, hombres, mujeres y niños."
,"7":"Solamente guardamos los despojos de las ciudades y todo el ganado."
,"8":"Nos hicimos, pues, dueños de la tierra de los dos reyes amorreos, el país de Trasjordania, desde el torrente de Arnón hasta el monte Hermón"
,"9":"(los sidonios llaman Siryón al Hermón y los amorreos lo llaman Senir)."
,"10":"Y tomamos todas las ciudades de la meseta y toda la tierra de Galaad y de Basán hasta Selca y Edreí, ciudades del reino de Og, en Basán."
,"11":"Og, rey de Basán, era el último superviviente de la raza de los gigantes. En Rabba, ciudad de los amonitas, se muestra su cama de hierro, la cual tiene cuatro metros cincuenta de largo y dos de ancho."
,"12":"Nos adueñamos, pues, en aquel tiempo de ese país. Yo di a las tribus de Rubén y de Gad la mitad de los cerros de Galaad con sus ciudades, desde Aroer, situada a la orilla del torrente de Arnón."
,"13":"Y entregué a la media tribu de Manasés la otra mitad de Galaad y el Basán, el reino de Og, o sea toda la comarca de Argob y el Basán. Era llamado tierra de los refaítas."
,"14":"Yahír, hijo de Manasés, se adueñó de toda la comarca de Argob hasta los términos de los gesuritas y de los macatitas. Dio su nombre a estos pueblos que todavía hoy se llaman aldeas de Yahír."
,"15":"Lo que es a Maquir, le di parte de Galaad."
,"16":"A las tribus de Rubén y de Gad les di parte de Galaad hasta el torrente de Arnón. Sus fronteras pasaban por el medio del torrente y, por el lado de los amonitas, el torrente de Yabok servía de frontera."
,"17":"También les di la Arabá, siendo el Jordán su frontera desde Kineret hasta el mar de la Arabá, llamado Mar Salado, al pie del monte Pisga, al oriente."
,"18":"Entonces yo les di estas órdenes: 'Yavé, nuestro Dios, les ha dado esta tierra en propiedad. Y mientras los guerreros, todos los hombres valientes, irán armados al frente de sus hermanos israelitas,"
,"19":"sus mujeres, sus hijos y sus rebaños, sus numerosos rebaños, se quedarán en los pueblos que yo les he dado."
,"20":"En cuanto Yavé haya dado a sus hermanos un lugar de descanso, como ya hizo para ustedes, y se hayan adueñado de la tierra que les daré al otro lado del Jordán, entonces cada uno de ustedes volverá aquí a la heredad que les he dado."
,"21":"En aquel tiempo di también instrucciones a Josué. Le dije: 'Con tus propios ojos has visto lo que Yavé ha hecho con estos dos reyes: así lo harás con todos los reinos donde has de pasar;"
,"22":"no los teman, porque Yavé combate por ustedes.'"
,"23":"Entonces supliqué así a Yavé:"
,"24":"'Yavé, mi señor, tú has comenzado a manifestar tu grandeza y tu mano fuerte; pues ¿qué Dios hay en los cielos o en la tierra que pueda hacer obras y hazañas como las tuyas?"
,"25":"Déjame, por favor, pasar y ver esta espléndida tierra del otro lado del Jordán, aquellos espléndidos cerros y también el Líbano.'"
,"26":"Pero Yavé se había enojado conmigo por culpa de ustedes y no me escuchó, antes bien me dijo: 'Basta ya, no me hables más de eso,"
,"27":"pero sube a la cumbre del Pisga y desde allí mira al oeste y al norte, al sur y al oriente. Tú verás la tierra, pero no pasarás ese Jordán."
,"28":"Da tus órdenes a Josué, dale autoridad y dale ánimo, pues él es quien ha de encabezar a ese pueblo y le distribuirá la tierra que vas a ver.'"
,"29":"Nos quedamos, pues, en el valle frente a Bet-Peor."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Y ahora, Israel, escucha las normas y los mandamientos que yo te enseño, para que los pongas en práctica. Así vivirás, y entrarás al país que te da Yavé, Dios de tus padres, y tomarás posesión de él."
,"2":"No añadirás nada a lo que yo te mando, y no le quitarás nada, sino que guardarás los mandamientos de Yavé, tu Dios, tal como yo se lo ordeno."
,"3":"Has visto con tus propios ojos lo que hizo Yavé en Baal-Peor, pues acabó con todos aquellos que se fueron tras el baal."
,"4":"En cambio ustedes, que fueron fieles a Yavé, su Dios, están hoy todos vivos."
,"5":"Mira: como Yavé, mi Dios, me ha ordenado, te he enseñado normas y leyes para que las pongas en práctica en la tierra en que vas a entrar y que pasará a ser tuya."
,"6":"Si las guardan y las practican, pasarán por sabios e inteligentes a los ojos de los pueblos que tengan conocimiento de todas estas leyes; y dirán: '¡Qué pueblo tan grande! Sólo él tiene sabiduría e inteligencia.'"
,"7":"En verdad, ¿qué nación hay tan grande, cuyos dioses se acerquen a ella como lo hace para nosotros, siempre que lo invocamos, Yavé, nuestro Dios?"
,"8":"¿Y qué nación hay tan grande que tenga normas y mandamientos tan justos como esta ley que yo te entrego hoy?"
,"9":"Pero ¡fíjate bien! Ten mucho cuidado de no olvidarte de estas cosas que tus ojos han visto. Guárdalas en tu interior todos los días de tu vida, y repíteselas a tus hijos y a tus nietos."
,"10":"Me refiero al día en que ustedes estuvieron en presencia de Yavé en el monte Horeb y él me dijo: 'Reúneme al pueblo para que oiga mis palabras. Así me temerán mientras vivan en esa tierra y enseñarán estas palabras a sus hijos.'"
,"11":"Entonces ustedes se acercaron y permanecieron al pie del monte. Este ardió en llamas hasta el mismo cielo entre tinieblas de nube y espesa niebla."
,"12":"Yavé les habló entonces en medio del fuego. Ustedes oyeron el rumor de las palabras, pero no vieron figura alguna, sólo oían una voz."
,"13":"Y Yavé les dio a conocer su Alianza, en la que les ordenó observar sus diez mandamientos, y los escribió en las dos tablas de piedra."
,"14":"En aquel día a mí me ordenó enseñarles las normas y los mandamientos que ustedes pondrán en práctica en la tierra donde van a entrar y que pasará a ser suya."
,"15":"Mediten bien lo que van a hacer. Ustedes no vieron figura alguna el día en que Yavé les habló en el monte Horeb en medio del fuego."
,"16":"Por tanto no vayan a corromperse: no se hagan un ídolo, o sea, cualquier cosa esculpida con forma de hombre o de mujer;"
,"17":"ni con forma de algún animal de los que viven en la tierra, o de algún ave que vuela en el cielo;"
,"18":"ni de algún reptil de los que se arrastran sobre la tierra, ni de algún pez de los que viven en el agua debajo de la tierra."
,"19":"Cuando mires al cielo y veas el sol, la luna, las estrellas y todos los astros del firmamento, no te dejes arrastrar a adorarlos como dioses y a servirlos, pues Yavé, tu Dios, dejó que fueran la parte de los demás pueblos,"
,"20":"pero a ustedes los tomó y los sacó del horno que es Egipto, para que fueran su propio pueblo como lo son ahora."
,"21":"Por culpa de ustedes Yavé se enojó contra mí y juró que yo no pasaría el Jordán ni entraría en la espléndida tierra que él les da en herencia."
,"22":"Pero aunque yo muera en este país y no pase el Jordán, ustedes lo pasarán y poseerán esa espléndida tierra."
,"23":"Guárdate, pues, de olvidar la Alianza que Yavé ha pactado contigo y no te hagas ídolos, o sea imágenes de todo lo que Yavé tu Dios te ha prohibido."
,"24":"Sepas que Yavé, tu Dios, es un fuego devorador, un Dios celoso."
,"25":"Cuando tengas hijos y nietos y hayan envejecido en el país, no vayan a corromperse teniendo ídolos y haciendo lo que desagrada a Yavé."
,"26":"Pues si lo irritan, desaparecerán de la tierra que va a ser de ustedes, al pasar el Jordán; el cielo y la tierra son testigos de mis advertencias: ustedes serán reducidos a nada."
,"27":"Yavé los dispersará entre los pueblos y sólo quedará de ustedes un pequeño número, repartidos entre las naciones a las que Yavé los llevará."
,"28":"Allí tendrán que servir a dioses fabricados, que no son más que madera y piedra, que ni ven, ni oyen, ni comen, ni sienten."
,"29":"Allí buscarás a Yavé, tu Dios, y lo encontrarás si lo buscas con todo tu corazón y toda tu alma."
,"30":"Cuando estas desgracias te hayan venido encima, volverás por fin a Yavé en medio de tu angustia y harás caso a sus palabras."
,"31":"Pues Yavé, tu Dios, es un Dios misericordioso, que no te rechaza ni te destruye del todo, ni olvida la Alianza que juró a tus padres."
,"32":"Pregunta a los tiempos pasados. Investiga desde el día en que Dios creó al hombre sobre la tierra. Pregunta desde un extremo a otro del mundo: ¿Hubo jamás una cosa tan extraordinaria como ésta? ¿Se ha oído cosa semejante?"
,"33":"¿Ha quedado con vida algún pueblo después de haber oído como tú a Dios vivo hablando en medio del fuego?"
,"34":"¿Acaso algún dios ha intentado tomarse un pueblo y sacarlo de en medio de otro pueblo a fuerza de pruebas y de señales, de milagros y de combates, actuando con mano firme y dando grandes golpes, realizando esas cosas grandes que Yavé hizo por ustedes en Egipto y que tú viste con tus propios ojos?"
,"35":"Y porque lo has visto, ahora sabes que Yavé es Dios y que no hay otro fuera de él."
,"36":"Desde el cielo te hizo oír su voz, para que lo temas, y sobre la tierra viste su gran fuego: desde en medio del fuego oíste sus palabras,"
,"37":"y quedaste con vida. Porque amaba a tus padres, eligió a su descendencia después de ellos; él mismo vino a sacarte de Egipto con mucho poder."
,"38":"Expulsó delante de ti pueblos más numerosos y más fuertes que tú, y te hizo entrar en su tierra: hoy te la dio en herencia."
,"39":"Por tanto, reconoce ahora y trata de convencerte de que Yavé es el único Dios del cielo y de la tierra, y que no hay otro."
,"40":"Guarda sus leyes y sus mandamientos que yo te ordeno hoy, y te irá bien a ti y a tus hijos después de ti. Así vivirás largos años en la tierra que Yavé, tu Dios, te da.'"
,"41":"Moisés designó tres ciudades al otro lado del Jordán, hacia el oriente,"
,"42":"para que allí se refugiara el que involuntariamente diera muerte a su prójimo, siempre que no hubiese sido antes su enemigo. Con refugiarse en una de esas ciudades estaría a salvo."
,"43":"Estas fueron las ciudades: Basar, en la meseta del desierto, para la tribu de Rubén; Ramot, en Galaad, para la tribu de Gad, y Golán, en Basán, para la tribu de Manasés."
,"44":"Esta es la Ley que Moisés dio a los hijos de Israel."
,"45":"Estos son los preceptos, decretos y leyes que Moisés dictó a los hijos de Israel a su salida de Egipto,"
,"46":"al otro lado del Jordán, en el valle fronterizo a Bet-Peor, en el país de Sijón, rey de los amorreos. A este Sijón, que vivía en Jesbón, Moisés y los hijos de Israel lo habían derrotado a su salida de Egipto"
,"47":"y se habían apoderado de su país, así como del de Og, rey de Basán. Los territorios de estos reyes amorreos estaban al oriente del Jordán."
,"48":"Se extendían desde Aroer, situada en la orilla del torrente Arnón, hasta el monte Sirión, llamado también Hermón,"
,"49":"y abarcaban toda la llanura al oriente del Jordán hasta el Mar Muerto, al pie del monte Pisga."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Moisés convocó a todo Israel y le dijo: 'Escucha, Israel, las normas y los mandamientos que te enseño en este día; ustedes los aprenderán y cuidarán de ponerlos en práctica."
,"2":"Nuestra es la alianza que nos dio Yavé, nuestro Dios, en el Horeb."
,"3":"Pues su alianza, no la tiene pactada con nuestros padres, sino más bien con nosotros que hoy estamos aquí todos vivos."
,"4":"Yavé nos habló cara a cara en el monte, desde en medio del fuego."
,"5":"Entonces yo estaba entre Yavé y ustedes y los tuve informados, pues aquel fuego los mantenía a distancia, y ustedes no subieron al monte. Estas fueron sus palabras:"
,"6":"'Yo soy Yavé, tu Dios, que te saqué de la tierra de Egipto, de la casa de la esclavitud."
,"7":"No tendrás otro dios delante de mí."
,"8":"No te harás ídolos, no te harás figura alguna de las cosas que hay arriba en el cielo o aquí debajo en la tierra, ni de lo que hay en las aguas debajo de la tierra."
,"9":"Ante ellas no te hincarás ni les rendirás culto; porque yo, Yavé, tu Dios, soy un Dios celoso, que castigo la maldad de los padres en los hijos hasta la tercera y cuarta generación de los que me odian."
,"10":"Pero mantengo mi favor por mil generaciones a los que me aman y guardan mis mandamientos."
,"11":"No harás mal uso del nombre de Yavé, tu Dios, porque Yavé no dejará sin castigo a quien se aproveche de su nombre."
,"12":"Cuida de santificar el día sábado, como Yavé, tu Dios, te lo manda."
,"13":"Seis días tienes para trabajar y hacer tus quehaceres."
,"14":"Pero el día séptimo es el Descanso en honor de Yavé, tu Dios. No harás ningún trabajo, ni tú, ni tu hijo, ni tu hija, ni tu servidor, ni tu sirvienta, ni tu buey, ni tu burro u otro de tus animales. Tampoco trabajará el extranjero que está en tu país. Tu servidor y tu sirvienta descansarán así como tú,"
,"15":"pues no olvides que fuiste esclavo en la tierra de Egipto, de la que Yavé, tu Dios, te sacó actuando con mano firme y dando grandes golpes; por eso Yavé, tu Dios, te manda guardar el día sábado."
,"16":"Honra a tu padre y a tu madre, como Yavé, Dios tuyo, te lo tiene mandado, y tus días se prolongarán por mucho tiempo y te irá bien en la tierra que Yavé, tu Dios, te da."
,"17":"No matarás."
,"18":"No cometerás adulterio."
,"19":"No robarás."
,"20":"No darás falso testimonio contra tu prójimo."
,"21":"No desearás la mujer de tu prójimo. No codiciarás la casa de tu prójimo, ni su campo, ni su servidor, ni su sirvienta, ni su buey, ni su burro, ni cosa alguna suya.'"
,"22":"Estas son las palabras que dijo Yavé a toda la asamblea que estaba en el monte, desde en medio del fuego y la espesa nube. Dichas palabras resonaron con estruendo y no se les añadió nada. Y luego Yavé las escribió en dos tablas de piedra que me entregó."
,"23":"Cuando oyeron aquella voz en medio de las tinieblas, mientras que el monte ardía, se acercaron a mí todos los jefes de sus tribus y los ancianos."
,"24":"Y dijeron: 'Yavé, Dios nuestro, acaba de mostrarnos su gloria y su grandeza y hemos oído su voz en medio del fuego. Hoy hemos visto a Dios hablando al hombre sin que éste muriera;"
,"25":"pero nosotros vamos a morir si nos quedamos escuchando la voz de Yavé, nuestro Dios, pues nos va a consumir este fuego terrible"
,"26":"¿Qué hombre quedará con vida después de escuchar la voz de Dios vivo hablando de en medio del fuego, como lo hace ahora con nosotros?"
,"27":"Mejor acércate tú para oír todo lo que diga Yavé, nuestro Dios, y luego tú nos las dices para que las pongamos en práctica.'"
,"28":"Yavé oyó estas palabras mientras ustedes me hablaban, y me dijo: 'He oído lo que dice este pueblo; en todo han hablado bien."
,"29":"¡Ojalá que siempre tengan el mismo espíritu, me teman y guarden todos mis preceptos!, pues entonces les iría bien a ellos y a sus hijos eternamente."
,"30":"Ahora les vas a decir que vuelvan a sus tiendas de campaña."
,"31":"Pero tú te quedarás conmigo, para que yo te diga todos los mandamientos, preceptos y leyes que habrás de enseñarles y así los pongan en práctica en la tierra que yo quiero que sea suya.'"
,"32":"Ustedes guardarán y cumplirán lo que Yavé les tiene ordenado. No se desvíen ni a la derecha ni a la izquierda,"
,"33":"sino que sigan en todo el camino que Yavé les ha marcado; así vivirán y tendrán éxito, y sus días se prolongarán en la tierra que pasará a ser suya."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Estos son los preceptos, las normas y los mandamientos que Yavé, Dios de ustedes, me mandó, para que yo se los enseñe y ustedes los cumplan en la tierra que va a ser de ustedes."
,"2":"Temerás a Yavé, tu Dios, y guardarás todos los días de tu vida sus mandamientos y sus normas que te enseño hoy. Que los guarden tus hijos y los hijos de tus hijos, para que vivan largos años."
,"3":"Escucha, pues, Israel, y cuida de poner en práctica lo que ha de traerte felicidad y prosperidad en esta tierra que mana leche y miel, como lo prometió Yavé, Dios de tus padres."
,"4":"Escucha, Israel: Yavé, nuestro Dios, es Yavé-único."
,"5":"Y tú amarás a Yavé, tu Dios, con todo tu corazón, con toda tu alma y con todas tus fuerzas."
,"6":"Graba en tu corazón los mandamientos que yo te entrego hoy,"
,"7":"repíteselos a tus hijos, habla de ellos tanto en casa como cuando estés de viaje, cuando te acuestes y cuando te levantes."
,"8":"Grábalos en tu mano como una señal y póntelos en la frente como tu distintivo;"
,"9":"escríbelos en los postes de tu puerta y a la entrada de tus ciudades."
,"10":"Y cuando Yavé te haya llevado a la tierra que juró darte -pues se lo dijo a tus padres, Abrahán, Isaac y Jacob-, con ciudades grandes y prósperas que tú no edificaste,"
,"11":"con casas abastecidas de todo lo que tú no llenaste, con pozos que tú no cavaste, viñas y olivares que tú no plantaste; cuando hayas comido y te hayas saciado,"
,"12":"no te olvides de Yavé que te sacó de Egipto, donde eras esclavo."
,"13":"Temerás a Yavé, tu Dios; a él servirás, e invocarás su nombre si debes hacer algún juramento."
,"14":"No vayas tras dioses extraños, tras los dioses de los pueblos que te rodean,"
,"15":"porque Yavé, tu Dios, que está en medio de ti, es un Dios celoso. No sea que estalle el furor de Yavé tu Dios, y te haga desaparecer de la superficie de la tierra."
,"16":"Ustedes no pondrán a prueba a Yavé, su Dios, como lo hicieron en Masá."
,"17":"Más bien hagan empeño en guardar los preceptos, los mandamientos y las normas que les he mandado."
,"18":"Haz lo que es recto y bueno a los ojos de Yavé, para que seas feliz y llegues a tomar posesión de la espléndida tierra que prometió con juramento a tus padres,"
,"19":"pues él destruirá delante de ti a todos tus enemigos."
,"20":"Tal vez un día tu hijo te pregunte: '¿Qué son estos preceptos, mandamientos y normas que Yavé, nuestro Dios, les ha ordenado?'"
,"21":"Tú responderás a tu hijo: 'Nosotros éramos esclavos de Faraón en Egipto, y Yavé nos hizo salir de Egipto con mano firme."
,"22":"Y lo vimos hacer milagros grandes, y terribles prodigios contra Faraón y toda su gente,"
,"23":"y a nosotros nos sacó de allí para conducirnos a la tierra que prometió a nuestros padres."
,"24":"Entonces fue cuando Yavé nos ordenó poner en práctica todos estos preceptos y temerle a él, nuestro Dios, pues por ese camino nos iría bien y él nos daría vida, como hoy es el caso."
,"25":"El camino recto para nosotros consiste en guardar y practicar estos mandamientos como él lo ha ordenado.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Yavé, tu Dios, te introducirá en la tierra adonde vas y que pasará a ser tuya; arrojará delante de ti a muchos pueblos, al heteo y al guergaseo, al amorreo y al cananeo, al fereceo, al jeveo y al jebuseo, siete naciones mucho más numerosas y poderosas que tú."
,"2":"Cuando las entregue en tus manos y tú las derrotes, los exterminarás según la ley del anatema. No harás alianza con ellas ni les tendrás compasión."
,"3":"No te emparentarás con ellas, dando tus hijas a sus hijos, ni tomando sus hijas para tus hijos,"
,"4":"porque seducirían a tus hijos para que me abandonen y adoren a dioses extranjeros, con lo que la ira de Yavé se encendería contra ustedes y luego los eliminaría."
,"5":"Por el contrario, esto es lo que deben hacer: derriben sus altares y hagan pedazos las imágenes, arrasen sus bosques sagrados y quemen sus ídolos."
,"6":"Eres un pueblo consagrado a Yavé, tu Dios. Yavé te ha elegido de entre todos los pueblos que hay sobre la faz de la tierra, para que seas su propio pueblo."
,"7":"Yavé se ha ligado a ti, y te ha elegido, no por ser el más numeroso de todos los pueblos (al contrario, eres el menos numeroso)."
,"8":"Más bien te ha elegido por el amor que te tiene y para cumplir el juramento hecho a tus padres. Por eso Yavé, con mano firme, te sacó de la esclavitud y del poder de Faraón, rey de Egipto."
,"9":"Reconoce, pues, que Yavé, tu Dios, es 'el' Dios. Es el Dios fiel, que guarda su Alianza y su misericordia hasta mil generaciones a los que lo aman y cumplen sus mandamientos,"
,"10":"pero castiga en su propia persona a quien lo odia, y lo sanciona sin demora."
,"11":"Guarda, pues, los mandamientos, normas y ordenanzas que yo te mando hoy poner en práctica."
,"12":"Si te fijas en estas normas, las guardas y las practicas, Yavé te mantendrá la alianza y la benevolencia que prometió a tus padres."
,"13":"Te amará, te bendecirá y te multiplicará. Te concederá numerosos hijos y cosechas abundantes: trigo, vino y aceite; multiplicará las crías de tus vacas y de tus ovejas en la tierra que prometió a tus padres para ti."
,"14":"Serás favorecido más que todos los pueblos; no habrá macho o hembra estéril entre tu gente ni en tu ganado,"
,"15":"Yavé alejará de ti toda enfermedad, no dejará caer sobre ti ninguna de las plagas de Egipto que tú conoces. En cambio, las hará caer sobre aquellos que te odien."
,"16":"Así, pues, extermina todos los pueblos que Yavé, tu Dios, pondrá en tus manos. No tengas piedad de ellos, ni sirvas a sus dioses: éstos serían una trampa para ti."
,"17":"Tal vez dirás en tu corazón: Estos pueblos son más numerosos que yo, ¿cómo los voy a desalojar?"
,"18":"Mas no temas, acuérdate de lo que hizo Yavé, tu Dios, con Faraón y con todos los egipcios;"
,"19":"de aquellas terribles pruebas que vieron tus ojos, y de los prodigios y señales, de la mano fuerte y de los grandes golpes con que te libertó Yavé, tu Dios."
,"20":"Lo mismo hará con todos los pueblos a quienes temes. Incluso enviará Yavé avispas para destruir a los que hayan quedado y se hayan escondido para escapar de ti."
,"21":"No les tengas miedo, porque Yavé, tu Dios, Dios grande y terrible, está en medio de ti."
,"22":"El mismo irá achicando a tu vista estas naciones poco a poco y por partes, pues no te conviene acabar con ellas de una sola vez, no sea que se multipliquen contra ti las fieras salvajes."
,"23":"Pero Yavé, tu Dios, los pondrá en tus manos y los llenará de espanto hasta que desaparezcan del todo."
,"24":"Entregará sus reyes en tus manos para que borres sus nombres de debajo del cielo; nadie podrá resistir ante ti hasta que los hayas destruido."
,"25":"Ustedes quemarán las imágenes de sus dioses y no codiciarán el oro ni la plata que los recubre. No lo tomes para ti, no sea que te quedes atrapado: debes saber que Yavé lo odia. Nada de esto entrará en tu casa, no sea que te vuelvas maldición, como ello es maldición."
,"26":"Los tendrás por cosa abominable, porque, de hecho, son 'anatema', o sea, maldición."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Cuiden de cumplir con todos los mandamientos que hoy les ordeno. Si lo hacen, vivirán y se multiplicarán y serán dueños de la tierra que prometió Yavé con juramento a sus padres."
,"2":"Acuérdate del camino que Yavé, tu Dios, te hizo recorrer en el desierto por espacio de cuarenta años. Te hizo pasar necesidad para probarte y conocer lo que había en tu corazón, si ibas o no a guardar sus mandamientos."
,"3":"Te hizo pasar necesidad, te hizo pasar hambre, y luego te dio a comer maná que ni tú ni tus padres habían conocido. Quería enseñarte que no sólo de pan vive el hombre, sino que todo lo que sale de la boca de Dios es vida para el hombre."
,"4":"Ni tu vestido se ha gastado, ni tu pie se ha lastimado a lo largo de estos cuarenta años."
,"5":"Comprende, pues, que del mismo modo que un padre educa a su hijo, así Yavé te ha educado a ti."
,"6":"Guardarás los mandamientos de Yavé, tu Dios y seguirás sus caminos; a él habrás de respetar."
,"7":"Pues Yavé, tu Dios, es el que te introduce a esa tierra buena, tierra de arroyos y de vertientes, de aguas subterráneas que brotan en los valles y en las montañas,"
,"8":"tierra de trigo y de cebada, de viñas e higueras, de granados y olivos, tierra de aceite y miel;"
,"9":"tierra donde el pan que comas no será racionado y donde nada te faltará; tierra donde las piedras tienen hierro y de cuyas montañas extraerás el cobre."
,"10":"Comerás hasta satisfacerte y bendecirás a Yavé por el buen país que te dio."
,"11":"Por eso, guárdate de olvidar a Yavé, tu Dios, descuidando los mandamientos, los preceptos y las normas que yo te prescribo hoy."
,"12":"No sea que cuando comas y quedes satisfecho, cuando hayas construido casas cómodas y vivas en ellas,"
,"13":"cuando se multipliquen tus ganados, cuando tengas plata y oro en abundancia y se acrecienten tus bienes de toda clase,"
,"14":"tu corazón se ponga orgulloso. No olvides a Yavé, tu Dios, que te sacó del país de Egipto, de la Casa de la esclavitud, "
,"15":"y que te ha conducido a través de este desierto grande y terrible, lleno de serpientes-abrasadoras y escorpiones, tierra árida donde no hay agua. Pero para ti la hizo brotar de una roca dura,"
,"16":"y te alimentó en el desierto con el maná, que no conocían tus padres. Así que te hizo pasar necesidad y te puso a prueba, para colmarte mejor después."
,"17":"¿No podría ser que digas: 'Con mi propio esfuerzo me conseguí esta buena situación'?"
,"18":"Más bien acuérdate de Yavé, tu Dios, que te dio fuerzas para conseguir este bienestar, cumpliendo así la alianza que bajo juramento prometió a tus padres, como en este día sucede."
,"19":"Pero, si olvidas a Yavé y sigues a otros dioses, si les das culto y te postras ante ellos, te advierto desde ahora que perecerás sin remedio."
,"20":"Del mismo modo que Yavé destruyó las naciones que les cerraban el camino, así también perecerán ustedes si desobedecen a Yavé, su Dios."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Escucha, Israel: Hoy vas a pasar el Jordán para desalojar naciones más grandes y más fuertes que tú, con ciudades grandes cuyas murallas llegan hasta el cielo."
,"2":"Es un pueblo grande, de alta estatura, los enaceos, que tú mismo has visto y de quienes se dice que nadie puede vencerlos."
,"3":"Pero debes saber que Yavé, tu Dios, pasará el Jordán delante de ti; él los exterminará y te los someterá para que les quites la tierra y los hagas desaparecer rápidamente, como él te lo dijo."
,"4":"Cuando Yavé, tu Dios, los haya deshecho en tu presencia, no pienses así: 'Yo merecía que Yavé me lleve a esta tierra y me la dé.' Más bien desalojó Yavé a esas naciones a causa de su maldad."
,"5":"No por tus méritos ni porque seas bueno conquistarás su tierra, sino que Yavé se la quita porque ellos han obrado mal, y también para cumplir lo que prometió con juramento a tus padres, Abrahán, Isaac y Jacob."
,"6":"Sepas, pues, que no por tus méritos te ha dado Yavé tu herencia, esta tierra excelente, ya que tú eres un pueblo rebelde."
,"7":"Acuérdate y no olvides que por tu culpa se enojó Yavé en el desierto. Has sido rebelde a Yavé desde el día en que saliste de Egipto hasta que llegaste aquí."
,"8":"Ya en el Horeb despertaron su enojo, y él los quiso destruir."
,"9":"Yo había subido al monte para recibir las tablas de piedra, las tablas de la Alianza que Yavé había pactado con ustedes, permaneciendo en el monte cuarenta días y cuarenta noches, sin comer ni beber."
,"10":"Entonces me dio Yavé las dos tablas de piedra escritas por el dedo de Dios. Todas sus palabras estaban ahí escritas, todas las palabras que les dijo en el monte, desde en medio del fuego, en el día de la asamblea."
,"11":"Y Yavé me dio las dos tablas de piedra, las tablas de la Alianza, al terminarse los cuarenta días y las cuarenta noches."
,"12":"Pero luego me dijo: 'Vete, baja a toda prisa porque tu pueblo que tú sacaste de Egipto se ha corrompido; han abandonado bien pronto el camino que yo les enseñé y se han hecho un ídolo de metal.'"
,"13":"Y Yavé me dijo: 'Ya veo que éste es un pueblo rebelde."
,"14":"Déjame que lo destruya y borre su nombre de debajo del cielo. De ti, en cambio, haré nacer otra nación más numerosa y más grande que ésta.'"
,"15":"Bajé, pues, de la cumbre ardiente, teniendo en mis manos las dos tablas de la Alianza,"
,"16":"y vi que habían pecado contra Yavé, su Dios, y que se habían hecho un ternero de metal. Muy rápido se habían desviado del camino que Yavé les había enseñado."
,"17":"Arrojé, entonces, con ambas manos las tablas que llevaba y las hice pedazos a la vista de todos."
,"18":"Luego me postré ante Yavé y, como la otra vez, estuve cuarenta días y cuarenta noches sin comer pan ni beber agua, por el pecado que habían cometido; pues habían hecho lo que es malo a los ojos de Yavé hasta irritarlo."
,"19":"Yo estaba espantado a causa de la cólera y furor de Yavé contra ustedes, ya que quería destruirlos. Pero una vez más Yavé me escuchó."
,"20":"Yavé estaba también muy enojado con Aarón y quería hacerlo perecer. Del mismo modo intercedí por Aarón."
,"21":"En cuanto al pecado, ese ternero que ustedes se habían hecho, lo eché al fuego, lo hice pedazos y lo molí hasta reducirlo a polvo. Luego tiré el polvo al arroyo que baja de la montaña."
,"22":"Del mismo modo despertaron la ira de Yavé en Taberá, en Masá, y en Quibrot-hatavá."
,"23":"Y cuando Yavé les mandó que salieran de Cadés-Barné, diciendo: 'Suban a tomar posesión de la tierra que les di', ustedes se rebelaron otra vez contra las órdenes de Yavé, su Dios; no creyeron a Yavé ni le hicieron caso."
,"24":"Han sido rebeldes a Yavé desde el día en que yo los conozco."
,"25":"Me postré, pues, delante de Yavé. Lo hice mil veces en esos cuarenta días y cuarenta noches porque hablaba de acabar con ustedes."
,"26":"Supliqué a Yavé y le dije: 'Ah, Señor Dios, no destruyas a ese pueblo que es tu propio pueblo, y que te ganaste con tu poderío, a los que sacaste de Egipto con mano firme."
,"27":"Acuérdate de tus siervos Abrahán, Isaac y Jacob y olvida que este pueblo es pesado, malo y pecador."
,"28":"De otra manera dirían en el país de donde los sacaste: 'Yavé no fue capaz de llevarlos a la tierra que les había prometido; le dieron tanto asco que, después de sacarlos de Egipto, los hizo morir en el desierto.'"
,"29":"Ellos son tu pueblo y tu pertenencia, a los que sacaste de Egipto con mano firme y a fuerza de golpes.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"En ese tiempo Yavé me dijo: 'Labra dos tablas de piedra semejantes a las primeras y sube hacia mí en el monte; harás también un Arca de madera."
,"2":"Yo escribiré en las tablas las palabras que había en las primeras que rompiste y las pondrás en el Arca.'"
,"3":"Hice, pues, un arca de madera de acacia, labré dos tablas de piedra como las primeras y subí al cerro llevándolas."
,"4":"Yavé escribió en las tablas eso mismo que había en las primeras, las diez palabras que les dijo en el monte desde en medio del fuego, en el día de la Asamblea, y me las dio."
,"5":"A la vuelta, bajando del monte, puse las tablas en el Arca que había hecho , y quedaron allí como me lo mandó Yavé."
,"6":"(Los hijos de Israel partieron de los pozos de Jacán, caminando hacia Mosera. Allí murió Aarón y fue sepultado, y su hijo Eleazar lo sucedió."
,"7":"De allí pasaron a Gudgoda, y de Gudgoda a Yotbata, tierra de aguas y arroyos."
,"8":"Fue entonces cuando Yavé puso aparte la tribu de Leví para que llevaran el Arca de la Alianza, para que fueran sus servidores y sus adoradores, y para que bendijeran invocando su nombre, como lo hacen hasta el día de hoy."
,"9":"Por eso Leví no ha compartido la herencia con sus hermanos; Yavé es su heredad, como Yavé, tu Dios, se lo dijo.)"
,"10":"Yo, pues, estuve en el monte cuarenta días y cuarenta noches, como la primera vez, y también esa vez escuchó Yavé mi súplica y renunció a destruirte."
,"11":"Luego Yavé me dijo: 'Levántate y ponte al frente de este pueblo para que vayan a tomar posesión de la tierra que juré dar a sus padres.'"
,"12":"Ahora, pues, Israel, ¿qué es lo que pide Yavé, tu Dios, sino que temas a Yavé, tu Dios, que sigas todos sus caminos y que lo ames y lo sirvas con todo tu corazón y con toda tu alma?"
,"13":"Guarda los mandamientos de Yavé y sus leyes que hoy te ordeno para tu bien."
,"14":"Mira: a Yavé, tu Dios, pertenecen los cielos visibles e invisibles, la tierra y cuanto hay en ella."
,"15":"Pero sólo con tus padres estableció Yavé lazos de amor, y después de ellos eligió a su descendencia, a ustedes mismos, con preferencia a todos los pueblos, como hoy puedes ver."
,"16":"Ustedes, pues, necesitan otra circuncisión, que es la del corazón, para que ya no le presenten una frente desafiante."
,"17":"Porque Yavé es el Dios de los dioses y el Señor de los señores, el Dios grande, el Dios fuerte y terrible, el que da un trato igual a todos y no se deja comprar con regalos."
,"18":"Hace justicia al huérfano y a la viuda, y ama al forastero dándole pan y vestido."
,"19":"Ama, pues, al forastero, porque forastero fuiste tú mismo en el país de Egipto."
,"20":"A Yavé, tu Dios, temerás, a él servirás, a él seguirás e invocarás su nombre si debes hacer algún juramento."
,"21":"A él irán tus alabanzas, pues El es tu Dios, que ha hecho por ti las cosas asombrosas que has visto."
,"22":"Cuando bajaron a Egipto, tus antepasados no eran más de setenta personas, y ahora Yavé, tu Dios, te ha hecho un pueblo numeroso como las estrellas del cielo."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Amarás, pues, a Yavé, tu Dios, y cumplirás todos los días cuanto te tiene ordenado: sus ordenanzas, sus mandamientos y sus preceptos."
,"2":"Ustedes a quienes me dirijo me entienden; tal vez sea más difícil para sus hijos que no habrán conocido ni visto las lecciones que dio Yavé con su mano firme y sus grandes golpes,"
,"3":"ni sus milagros e intervenciones en Egipto contra Faraón y contra todo el país."
,"4":"Recuerden lo que hizo con el ejército egipcio, con sus caballos y sus carros, cuando los sepultó bajo las aguas del Mar Rojo, destruyéndolos cuando nos perseguían."
,"5":"Acuérdate también de cuanto ha hecho Yavé por ustedes en el desierto, hasta que llegaron a este lugar,"
,"6":"lo que hizo con Datán y Abirón, hijos de Eliab, de la tribu de Rubén, cuando la tierra abrió su boca y los tragó en medio de todo Israel, con toda su familia, sus tiendas y sus seguidores."
,"7":"Ustedes han visto con sus propios ojos todas estas grandes intervenciones de Yavé."
,"8":"Por eso, guardarán todos estos mandamientos que yo les doy, para que sean fuertes y tomen posesión de la tierra a donde van a pasar para apoderarse de ella."
,"9":"Y prolongarán sus días en el país que Yavé juró dar a sus padres y a su descendencia, tierra que mana leche y miel."
,"10":"Porque la tierra que van a poseer no es como el país de Egipto de donde salieron, en el cual después de haber sembrado había que regar a fuerza de brazos, como en las huertas,"
,"11":"sino que es tierra de montes y valles, que bebe el agua de la lluvia del cielo."
,"12":"De esta tierra cuida Yavé, tu Dios, y sus ojos están constantemente puestos en ella, desde que comienza el año hasta que termina."
,"13":"Si obedeces puntualmente los mandamientos que te entrego hoy, si amas a Yavé, tu Dios, y me sirves con todo tu corazón y toda tu alma,"
,"14":"yo daré a tus tierras la lluvia a su tiempo, en otoño y en primavera, y podrás cosechar tu trigo, tus uvas y tu aceite fresco."
,"15":"Tu campo te dará hierba para tu ganado y comerás hasta saciarte."
,"16":"Pero no te dejes seducir. No sea que ustedes sirvan a dioses extraños y se postren ante ellos, pues la ira de Yavé se encendería contra ustedes."
,"17":"Cerraría los cielos y no habría más lluvia; la tierra no daría sus frutos y pronto desaparecerías en esta espléndida tierra que Yavé te da."
,"18":"Pon estas palabras mías en tu corazón y en tu alma, que sean para ti como una señal ligada a tu mano, un signo puesto en medio de tu frente."
,"19":"Enséñaselas a tus hijos. Habla de ellas, sea que estés sentado en tu casa o que vayas de viaje, cuando te acuestas o cuando te levantas;"
,"20":"las grabarás en tus puertas y a la entrada de tus ciudades."
,"21":"Entonces tus días y los de tus hijos se prolongarán en la tierra que Yavé juró dar a tus padres, y permanecerás en ella mientras permanezca el cielo sobre la tierra."
,"22":"Si ustedes guardan estos mandamientos que yo les mando practicar, si aman a Yavé y siguen sus caminos, abrazándose a él,"
,"23":"Yavé echará fuera a todas esas naciones delante de ustedes y, por más que sean grandes y poderosas, ustedes les quitarán la tierra."
,"24":"Todo lugar donde pongan el pie será de ustedes, desde el desierto hasta el Líbano y desde el río Eufrates hasta el mar occidental: éstas serán sus fronteras."
,"25":"Nadie podrá resistirles; en toda la extensión de la tierra que han de pisar, Yavé hará que, al oír hablar de ustedes, los pueblos teman y tengan miedo, como él les ha dicho."
,"26":"Miren que en este día yo pongo delante de ustedes la bendición y la maldición."
,"27":"Bendición, si obedecen los mandamientos de Yavé que yo les prescribo hoy;"
,"28":"maldición, si desobedecen dichos mandamientos y se desvían del camino que yo ahora les muestro, para seguir a dioses extraños que no son suyos."
,"29":"Cuando Yavé, Dios de ustedes, los haya introducido en la tierra que van a conquistar, pondrán la bendición sobre el monte Garizim, y la maldición sobre el monte Ebal."
,"30":"(Estos montes están al otro lado del Jordán, detrás del camino del oeste, en el país de los cananeos que habitan en la Arabá, frente a Guilgal, cerca de la encina de Moré.)"
,"31":"Ustedes ahora van a pasar el Jordán para tomar posesión de la tierra que Yavé les da; ustedes la tomarán y se establecerán en ella."
,"32":"Pero cuiden de cumplir todas las leyes y preceptos que les propongo ahora."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Estos son los preceptos, y los mandamientos que procurarás poner en práctica todos los días de tu vida en la tierra que te da Yavé, Dios de tus padres."
,"2":"Ustedes destruirán totalmente todos los sitios en donde los pueblos que van a desalojar han dado culto a sus dioses."
,"3":"Ustedes lo harán tanto en los altos cerros como en las lomas y bajo los árboles frondosos. Demuelan, pues, sus altares, rompan sus pedestales, quemen sus troncos sagrados y hagan pedazos las esculturas de sus dioses. Procuren borrar, en dichos lugares, hasta el nombre de sus dioses."
,"4":"Yavé no les pide nada semejante."
,"5":"Ustedes irán a buscar a Yavé al lugar que él escoja entre todas las tribus para poner allí su Nombre y habitar en él."
,"6":"Allí llevarán sus víctimas consumidas por el fuego y sus sacrificios, los diezmos y las ofrendas. Allí presentarán lo que prometieron a Dios, lo que ofrecen voluntariamente y los primeros nacidos de sus vacas y de sus ovejas."
,"7":"Allí comerán en presencia de Yavé y se alegrarán junto con sus familias, disfrutando de todo lo que hayan cosechado por la bendición de Yavé."
,"8":"No actuarán cada cual según le dé la gana; así lo hacemos hoy nosotros en este lugar,"
,"9":"porque todavía no hemos llegado al lugar del descanso, al país que Yavé nos da."
,"10":"Cuando pasen el Jordán y habiten en la tierra que Yavé les da en herencia, cuando él haya asegurado todas sus fronteras y vivan con tranquilidad,"
,"11":"entonces llevarán al lugar elegido por Yavé para morada de su Nombre, todo lo que yo les prescribo: las víctimas consumidas por el fuego, los sacrificios, los diezmos y las primicias del trabajo de sus manos, y lo que hayan prometido por voto a Yavé, pues querrás ofrecerle lo mejor."
,"12":"Allí estarán de fiesta delante de Yavé con sus hijos e hijas, sus servidores y sus sirvientas, sin olvidar a los levitas que viven entre ustedes, ya que ellos no tienen propiedad ni herencia como la tienen ustedes."
,"13":"Tengan cuidado de no ofrecer holocausto en cualquier lugar;"
,"14":"sólo en el lugar elegido por Yavé en una de tus tribus podrás ofrecer tus holocaustos y sólo allí harás todo lo que ordeno."
,"15":"No obstante, podrás sacrificar y comer carne en todas tus ciudades, siempre que lo desees y que no te falte por el favor de Yavé; pero ésta será carne de la que todos podrán comer, estén puros o impuros, como si se tratara de gacela o de ciervo."
,"16":"Cuiden tan sólo de no comer la sangre sino que la derramarán en la tierra como se derrama el agua."
,"17":"No podrás comer en tus ciudades el diezmo de tu trigo, vino y aceite, ni los primeros nacidos de tu ganado, ya sean vacas u ovejas, ni tampoco de todas aquellas cosas que por voto y espontáneamente hayas ofrecido a Yavé."
,"18":"Solamente lo comerás delante de Yavé, en el lugar que Yavé haya elegido, y contigo tus hijos, tus siervos y siervas; estarás de fiesta delante de Yavé, tu Dios, comiendo el fruto de tu trabajo."
,"19":"Cuando estés en tu tierra, cuidarás de no abandonar al levita mientras vivas."
,"20":"Cuando Yavé haya ensanchado tus fronteras, como te tiene prometido, y quieras comer carne, podrás hacerlo siempre que quieras."
,"21":"Si el lugar elegido por Yavé para su morada está muy lejos, podrás matar del ganado mayor o menor que Yavé te ha concedido del modo que yo te prescribo; lo podrás comer en tus ciudades a la medida de tus deseos,"
,"22":"pero lo comerás como se come la gacela o el ciervo: de él comerán igualmente el que se encuentre puro y el que no."
,"23":"Cuidarás tan sólo de no comer la sangre, porque la sangre es la vida y no debes comer la vida con la carne."
,"24":"No la comerás, sino que la verterás como agua sobre la tierra;"
,"25":"así harás lo que es correcto a los ojos de Yavé, y te irá bien a ti y a tus hijos después de ti."
,"26":"En cambio, las cosas que hayas consagrado y ofrecido por voto a Yavé, las tomarás contigo y vendrás al lugar que haya elegido Yavé."
,"27":"Allí sacrificarás tus holocaustos, tanto la carne como la sangre, sobre el altar de Yavé, tu Dios. La sangre de tus sacrificios se derramará también sobre este altar, y luego comerás la carne."
,"28":"Escucha y observa todas las cosas que te mando, y siempre te irá bien a ti y a tus hijos después de ti, por hacer lo que es bueno y correcto a los ojos de Yavé."
,"29":"Cuando Yavé, tu Dios, haya exterminado las naciones del país en que vas a entrar y las hayas desalojado, te establecerás en su tierra."
,"30":"Pero ten cuidado, no sea que esa gente siga siendo para ti una trampa después que la hayas destruido. No mires a sus dioses ni preguntes por ellos; no digas: '¿Cómo servía esta gente a sus dioses? ¿No debo yo hacer lo mismo?'"
,"31":"No puedes honrar a Yavé, tu Dios, con las mismas prácticas que esas naciones, ya que hicieron para sus dioses todo lo que Yavé aborrece, e incluso quemaron a sus hijos e hijas en honor de ellos."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Tú observarás todo lo que yo te prescribo, sin quitar ni añadir nada."
,"2":"Tal vez se presente en tu pueblo algún profeta o soñador profesional y pronostique alguna señal o prodigio."
,"3":"Si ocurre esta señal o este prodigio, y él te dice: Vamos, sigamos a otros dioses, dioses que no son de nosotros, y sirvámosles,"
,"4":"no hagas caso a las palabras de aquel profeta o soñador; porque Yavé, tu Dios, te prueba para saber si realmente lo amas con todo tu corazón y con toda tu alma."
,"5":"A Yavé, tu Dios, seguirás y a él temerás, guardarás sus mandamientos y escucharás su voz, a él servirás y a él te abrazarás."
,"6":"Ese profeta o soñador debe morir porque habló de traicionar a Yavé, tu Dios, que te sacó del país de Egipto y te rescató de la casa de la esclavitud. Debe morir porque quiso desviarte del camino que Yavé te ha ordenado seguir. Así harás desaparecer el mal de en medio de ti."
,"7":"Si tu hermano, hijo de tu padre, si tu hijo o tu hija, o la mujer que descansa en tu regazo o el amigo a quien amas tanto como a ti mismo, trata de seducirte en secreto, diciéndote: 'Vamos a servir a otros dioses', dioses que no conociste ni tú ni tus padres,"
,"8":"dioses de los pueblos próximos o lejanos que te rodean de un extremo a otro de la tierra,"
,"9":"no le harás caso ni lo escucharás. No tendrás piedad de él, no lo perdonarás ni lo encubrirás,"
,"10":"sino que lo matarás. Tu mano será la primera en caer sobre él, y después lo hará todo el pueblo."
,"11":"Lo apedrearán hasta que muera, porque trató de apartarte de Yavé, tu Dios, el que te sacó del país de Egipto, de la casa de la esclavitud."
,"12":"Al oír esto todos temerán en Israel, y ya no se atreverán a hacer semejante cosa."
,"13":"Si te dicen respecto de alguna de las ciudades que Yavé te dará para habitar:"
,"14":"'Allí se han manifestado unos desgraciados, y han pervertido a sus conciudadanos, invitándolos a servir a dioses extranjeros que no son nada para ustedes',"
,"15":"infórmate con cuidado, averigua bien la verdad del hecho. Si es cierto el asunto y se comprueba que esta abominación se ha cometido,"
,"16":"pasarás a cuchillo a todos los habitantes de aquella ciudad. Echarás la maldición sobre la ciudad y todo lo que hay en ella; pasarás a cuchillo a todos los animales y,"
,"17":"luego, amontonarás los despojos en medio de la plaza y prenderás fuego a la ciudad con todos sus despojos para cumplir la maldición de Yavé. Esta ciudad quedará convertida en un montón de ruinas para siempre, y jamás volverá a ser edificada."
,"18":"No guardarás en tu poder ni la cosa más pequeña de esta ciudad, para que Yavé aplaque su cólera y sea misericordioso contigo y te bendiga como tiene jurado a tus padres que lo hará,"
,"19":"a condición de que escuches la voz de Yavé, guardando todos sus mandamientos que yo te prescribo hoy, y haciendo lo que es correcto a los ojos de Yavé, tu Dios."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Yavé, Dios de ustedes, los tiene por sus hijos. No se hagan incisiones ni se corten el pelo en la frente por un difunto. "
,"2":"Pues tú eres un pueblo santo y consagrado a Yavé, tu Dios. Yavé te ha elegido de entre todos los pueblos que hay sobre la faz de la tierra, para que seas su propio pueblo."
,"3":"No comerán nada que sea impuro. Estos son los animales que podrán comer:"
,"4":"el buey, la oveja y la cabra,"
,"5":"el ciervo, la gacela y el gamo, la cabra montés, el antílope, el búfalo y la gamuza."
,"6":"O sea, que pueden comer cualquier animal rumiante de pezuña partida en dos mitades."
,"7":"Pero no comerán de los que solamente rumian, o que solamente tienen la pezuña partida: el camello, la liebre y el conejo que, si bien rumian, no tienen la pezuña partida; los tendrán por impuros."
,"8":"Tampoco comerán carne de cerdo, que tiene la pezuña partida, pero no rumia. Ustedes lo tendrán por impuro: no comerán su carne ni tocarán su cadáver."
,"9":"De todos los animales que viven en el agua, comerán todo lo que tiene aletas y escamas."
,"10":"Pero no los que no tienen aletas y escamas: a éstos los considerarán impuros."
,"11":"Pueden comer toda ave pura."
,"12":"No coman las siguientes: el águila, el quebrantahuesos,"
,"13":"el águila marina, el buitre, las diferentes especies de halcón"
,"14":"todas las especies de cuervos,"
,"15":"el avestruz, la lechuza, la gaviota y las diferentes especies de gavilanes,"
,"16":"el búho, el ibis, el cisne,"
,"17":"el pelícano, el calamón, el somormujo, la cigüeña,"
,"18":"las diferentes especies de garza real, la abubilla y el murciélago."
,"19":"Todo insecto que tiene alas será impuro para ustedes: no lo coman."
,"20":"En cambio comerán toda ave pura."
,"21":"No comerán de ningún animal hallado muerto. Se lo darás al forastero que reside en tu ciudad o bien lo venderás a un extranjero, sabiendo que tú eres un pueblo consagrado a Yavé, tu Dios. No cocerás el cabrito en la leche de su madre."
,"22":"Cada año separarás el diezmo de todo lo que hayas sembrado y que haya crecido en tus tierras."
,"23":"Comerás en presencia de Yavé, en el lugar que El haya escogido para morada de su Nombre, el diezmo de tu trigo, de tu aceite y de tu vino, así como los primeros nacidos de tu ganado mayor y menor. Con eso aprenderás a honrar a Yavé, tu Dios, todos los días de tu vida."
,"24":"Pero, cuando Yavé los haya multiplicado, podría ser que el camino sea demasiado largo y, por eso, no puedas llevar ese diezmo al lugar que Yavé ha elegido para morada de su Nombre."
,"25":"En ese caso, cambiarás todo por dinero, e irás al lugar elegido por Yavé llevando el dinero."
,"26":"Allí comprarás todo lo que desees, sean vacas u ovejas, así como también vino o bebida fermentada, todo lo que gustes y lo comerás allí en presencia de Yavé. Estarás de fiesta, tú y los de tu casa,"
,"27":"sin olvidar al levita que habita en tus ciudades, ya que él no tiene propiedades ni herencia como tú tienes."
,"28":"Cada tres años separarás el diezmo de todas las cosechas del año, pero lo guardarás en tu ciudad."
,"29":"Vendrá entonces a comer el levita, que no tiene herencia propia entre ustedes, y el extranjero, el huérfano y la viuda, que habitan tus ciudades, y comerán hasta saciarse. Así Yavé bendecirá todas las obras de tus manos, todo lo que hayas emprendido."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Cada siete años ustedes perdonarán las deudas."
,"2":"Esta remisión se hará de la siguiente manera: Aquel a quien su prójimo o su hermano deba algo perdonará a éste, y dejará de exigírselo en cuanto se proclame la remisión de Yavé."
,"3":"Del extranjero podrás exigir que te pague sus deudas; en cambio perdonarás la deuda de tu hermano,"
,"4":"pues no debe haber pobres en medio de ti mientras Yavé te dé prosperidad en la tierra que es tu herencia y que ha pasado a ser tuya."
,"5":"Si escuchas la voz de Yavé, tu Dios, y observas todas las cosas que yo te recuerdo ahora,"
,"6":"él te bendecirá como te tiene prometido; prestarás a muchas naciones y de nadie pedirás prestado, dominarás sobre muchas naciones y ninguna tendrá dominio sobre ti."
,"7":"Si se encuentra algún pobre entre tus hermanos, que viven en tus ciudades, en la tierra que Yavé te ha de dar, no endurezcas el corazón ni le cierres tu mano,"
,"8":"sino ábrela y préstale todo lo que necesita."
,"9":"No te dejes llevar por consideraciones indignas como de ser ésta: 'Ya pronto llega el año séptimo, el año de la remisión', y mires entonces con malos ojos a tu hermano pobre y no le prestes nada. No sea que llame contra ti a Yavé y cargues tú con un pecado."
,"10":"Debes darle, y de buena gana, porque por esto te bendecirá Yavé, tu Dios, en todas tus obras y empresas."
,"11":"Nunca faltarán pobres en este país, por esto te doy yo este mandato: debes abrir tu mano a tu hermano, a aquel de los tuyos que es indigente y pobre en tu tierra."
,"12":"Si tu hermano hebreo, varón o mujer, se vende a ti, te servirá durante seis años y al séptimo lo dejarás libre."
,"13":"Al dejarlo libre, no lo despedirás con las manos vacías,"
,"14":"sino que le darás algo de tus rebaños, de tu trigo y de tu bodega, algo de los bienes con que Yavé te ha bendecido."
,"15":"Acuérdate de que tú también fuiste esclavo en la tierra de Egipto y que Yavé, tu Dios, te dio la libertad: por esto hoy te doy este mandato."
,"16":"Tal vez tu esclavo te diga: 'No quiero irme', porque te ama a ti y tu casa y reconoce que le va bien contigo."
,"17":"En ese caso tomarás un punzón y le horadarás la oreja en uno de los postes de tu puerta, y él te servirá para siempre. Lo mismo harás con tu esclava."
,"18":"No se te haga demasiado duro el darle la libertad, porque durante seis años ganaste con él dos veces más que con un asalariado."
,"19":"Todo primer nacido, ya sea de tus vacas u ovejas, si es macho, lo consagrarás a Yavé. No harás trabajar al primerizo de la vaca, ni esquilarás los primerizos de las ovejas."
,"20":"Todos los años los comerás en presencia de Yavé con toda tu familia, en el lugar que haya elegido Yavé."
,"21":"Si tiene algún defecto, si es cojo o ciego, no lo sacrificarás a Yavé,"
,"22":"sino que lo comerás en tu casa y tanto el hombre puro como el impuro podrán comer de él, como si se tratara de una gacela o de un ciervo."
,"23":"Solamente te cuidarás de no comer la sangre, que derramarás en el suelo, como el agua."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Nota el mes de Abib para celebrar en él la Pascua en honor de Yavé, ya que en ese mes te sacó de Egipto, durante la noche."
,"2":"En la Pascua sacrificarás a Yavé bueyes y ovejas en el lugar que El haya elegido para morada de su nombre."
,"3":"En la cena de Pascua no comerás pan con levadura, sino que, durante siete días, comerás pan ázimo, pan de miseria; porque la salida de Egipto se hizo en forma precipitada. Así te acordarás todos los días de tu vida del día en que saliste de Egipto."
,"4":"Por siete días no se verá la levadura en todo tu territorio; y de la carne que hayas sacrificado la tarde del primer día no quedará nada para el día siguiente."
,"5":"No podrás sacrificar la Pascua en ninguna de las ciudades que Yavé te dará,"
,"6":"sino sólo en el lugar elegido por él para morada de su Nombre."
,"7":"Sacrificarás la víctima de la Pascua por la tarde, a la puesta del sol, a la hora que saliste de Egipto. La asarás y la comerás en el lugar elegido por Yavé, tu Dios, y luego, por la mañana te volverás a tu casa."
,"8":"Comerás panes ázimos durante seis días; el día séptimo celebrarás una reunión solemne en honor a Yavé y no trabajarás."
,"9":"Luego contarás siete semanas; las contarás desde el día en que comiences a cortar el trigo."
,"10":"Entonces celebrarás la fiesta de las Siete Semanas a Yavé, tu Dios, haciéndole ofrendas voluntarias según lo que hayas cosechado por la gracia de Yavé, tu Dios."
,"11":"En el lugar que Yavé haya elegido para morada de su Nombre, estarás de fiesta, y contigo tu hijo y tu hija, tu siervo y tu sierva, el levita que vive en tus ciudades, el forastero, el huérfano y la viuda que viven entre ustedes."
,"12":"Te acordarás de que fuiste esclavo en Egipto y cuidarás de poner en práctica estos preceptos."
,"13":"Celebrarás también la fiesta de las Tiendas durante siete días, después de recoger el producto de tu era y de tu lagar."
,"14":"Durante esta fiesta te alegrarás, tú, tu hijo y tu hija, tu siervo y tu sierva, el levita, el forastero, el huérfano y la viuda que viven en tu ciudad."
,"15":"Siete días durará esta fiesta en honor a Yavé, en el lugar elegido por él; pues Yavé te bendecirá en todas tus cosechas y en toda obra de tus manos, así que te darás todo a la alegría."
,"16":"Tres veces al año se presentarán todos tus varones ante Yavé, tu Dios, en el lugar elegido por él: en la fiesta de los Azimos, en la fiesta de las Semanas y en la fiesta de los Tabernáculos. Y no se presentarán con las manos vacías,"
,"17":"sino que cada uno ofrecerá en proporción a lo que tenga, según la bendición que Yavé le haya otorgado."
,"18":"Establecerás jueces y magistrados para tus tribus en cada una de las ciudades que Yavé te dé, para que juzguen al pueblo según la justicia."
,"19":"No torcerás el derecho ni te fijarás en la condición de las personas. No aceptarás regalos, porque los regalos ciegan los ojos de los sabios y se hacen en perjuicio de los justos. ¡Justicia!"
,"20":"Busca la justicia si quieres vivir y conservar la tierra que te da Yavé, tu Dios."
,"21":"No plantarás tronco sagrado ni árbol alguno cerca del altar que levantes para tu Dios."
,"22":"Tampoco levantarás piedras, porque Yavé aborrece estas cosas."
}`)
	CurrentBook.AddChapter(17, `{
"1":"No sacrificarás a Yavé, tu Dios, buey u oveja que tenga alguna tara o defecto, porque Yavé aborrece esto."
,"2":"Si, en medio de ti, en alguna de las ciudades que Yavé te dará, un hombre o una mujer hacen lo que desagrada a Yavé, hasta quebrantar su alianza,"
,"3":"si van a servir a otros dioses y se postran ante ellos, sean el sol, o la luna, o las estrellas del cielo, respecto a los cuales no te di ningún mandato,"
,"4":"en cuanto te lo denuncien o en cuanto lo sepas, empezarás por investigar bien todo. Si compruebas que esta abominación se ha cometido en Israel,"
,"5":"sacarás a las puertas de la ciudad al hombre o a la mujer que cometieron esta fechoría, y los apedrearás hasta que mueran."
,"6":"Exigirás las declaraciones de dos o tres testigos para condenarlos a muerte. Nadie será condenado a muerte por la acusación de un solo testigo."
,"7":"La mano de los testigos será la primera en tirar piedras para matarlo. Después, todo el pueblo lo apedreará. Así harás desaparecer el mal de en medio de ti."
,"8":"Si se te presenta un caso demasiado difícil, ya sea un asunto de sangre, un litigio o una querella por heridas, o una disensión entre las autoridades de la ciudad, subirás al lugar elegido por Yavé, tu Dios,"
,"9":"irás a los sacerdotes levitas y al juez que entonces esté en funciones. Los consultarás y ellos te indicarán el fallo de la causa."
,"10":"Te ajustarás al fallo que te hayan indicado en este lugar elegido por Yavé, y procurarás actuar conforme a lo que te hayan enseñado."
,"11":"Seguirás las instrucciones que te hayan dado y la sentencia que te dicten, sin desviarte ni a la derecha ni a la izquierda del fallo que te señalen."
,"12":"El hombre que se atreva a actuar en otra forma y no escuche al sacerdote que se encuentra allí al servicio de Yavé, ni al juez, morirá. Harás desaparecer el mal de Israel."
,"13":"Así todo el pueblo, al saberlo, temerá y ya no propasará el derecho."
,"14":"Cuando llegues a la tierra que Yavé, tu Dios, te da, cuando la conquistes y habites en ella, tal vez digas: 'Quiero tener un rey como todas las naciones vecinas.'"
,"15":"En todo caso pondrás a tu cabeza un rey elegido por Yavé de entre tus hermanos. No pondrás a tu cabeza un rey extranjero que no sea hermano tuyo."
,"16":"Que tu rey no tenga muchos caballos, no sea que traiga de vuelta a Egipto a su pueblo con el fin de tener más caballos. Pues Yavé te ordenó que no volvieras jamás por aquel camino."
,"17":"Tampoco se buscará muchas mujeres, no sea que se pervierta su corazón. Y que tampoco se haga rico en oro y plata."
,"18":"Cuando suba al trono, deberá copiar para su uso esta ley, del libro de los sacerdotes levitas."
,"19":"La llevará consigo, la leerá todos los días de su vida, para que aprenda a temer a Yavé, guardando todas las palabras de la Ley y poniendo en práctica sus preceptos."
,"20":"Así no mirará en menos a sus hermanos, y no se apartará de estos mandamientos ni a la derecha ni a la izquierda, y él y sus hijos prolongarán los días de su reinado en medio de Israel."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Los sacerdotes levitas, toda la tribu de Leví, no compartirán con los demás la herencia de Israel, sino que se alimentarán con las víctimas consumidas por el fuego en honor de Yavé, y las cosas que le fueron consagradas."
,"2":"El levita no tendrá parte en la herencia que reciben sus hermanos, porque Yavé es su herencia, como él se lo tiene dicho."
,"3":"Este será el derecho de los sacerdotes respecto del pueblo. Cuando se ofrezca ya sea buey u oveja, se le dará al sacerdote la espaldilla, las quijadas y el vientre."
,"4":"Le darás también las primicias de tu trigo, de tus vinos y de tu aceite, así como las primicias de la esquila de tus ovejas."
,"5":"Porque a él lo eligió Yavé de entre todas las tribus para oficiar en su nombre, él y sus hijos para siempre."
,"6":"Si un levita llega de otra parte, sea cual fuere la ciudad de Israel donde reside, porque tiene un deseo sincero de estar en el Lugar elegido por Yavé,"
,"7":"podrá oficiar en el nombre de Yavé, su Dios, como todos sus hermanos levitas que están allí al servicio de Yavé;"
,"8":"comerá una porción igual a la de los demás, aparte de lo que saque de sus bienes patrimoniales."
,"9":"Cuando hayas entrado en la tierra que Yavé, tu Dios, te da, no imites las costumbres perversas de aquellos pueblos."
,"10":"Que no haya en medio de ti nadie que haga pasar a su hijo o a su hija por el fuego; que nadie practique encantamientos o consulte a los astros; que no haya brujos ni hechiceros;"
,"11":"que no se halle a nadie que se dedique a supersticiones o consulte los espíritus; que no se halle ningún adivino o quien pregunte a los muertos."
,"12":"Porque Yavé aborrece a los que se dedican a todo esto, y los expulsa delante de ti a causa de estas abominaciones."
,"13":"Tú, en cambio, te portarás bien en todo con Yavé, tu Dios."
,"14":"Esos pueblos que vas a desalojar escuchan a hechiceros y adivinos, pero a ti, Yavé, tu Dios, te dio algo diferente."
,"15":"Yavé hará que se levante para ti, de en medio de tus hermanos, un profeta como yo: a él habrán de escuchar."
,"16":"Acuérdate de lo que pediste a Yavé, tu Dios, en el Horeb, el día de la Asamblea; tú dijiste: 'No puedo seguir más oyendo la voz de Yavé, ni soportar este gran fuego, y si me quedo mirando, voy a morir.'"
,"17":"Entonces Yavé me dijo: 'Dicen bien."
,"18":"Yo haré que se levante de en medio de sus hermanos un profeta, lo mismo que hice contigo. Yo pondré mis palabras en su boca y él les dirá todo lo que yo mande."
,"19":"Si alguno no escucha mis palabras, cuando habla el profeta de parte mía, yo mismo le pediré cuentas."
,"20":"Pero si un profeta pretende hablar en mi nombre sin que lo haya mandado, o si habla en nombre de otros dioses, morirá.'"
,"21":"Acaso preguntas: '¿Cómo vamos a saber que una palabra no viene de Yavé?'"
,"22":"Si algún profeta habla en nombre de Yavé y lo que dice no sucede, tú sabrás que esta palabra no viene de Yavé. El profeta habrá hablado para jactarse y no le harás caso."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Cuando Yavé, tu Dios, haya exterminado a las naciones cuyo país te va a dar, cuando las hayas desalojado y vivas en sus ciudades, ocupando sus casas,"
,"2":"reservarás tres ciudades del país que Yavé, tu Dios, te da."
,"3":"Tendrás libre y franco el camino de acceso a ellas y dividirás en tres partes el territorio que Yavé, tu Dios, te da en posesión: esto para que todo el que haya dado muerte a un hombre pueda refugiarse en esas ciudades."
,"4":"Mira en qué caso el que dio muerte a un hombre podrá refugiarse allí para salvarse: si hirió involuntariamente a su hermano al que no tenía odio."
,"5":"Por ejemplo, si alguno va al bosque con un compañero a cortar leña y mientras maneja el hacha para cortar el árbol, se sale el hierro del mango y va a herir mortalmente a su compañero; éste puede huir a una de estas ciudades y así salvarse."
,"6":"No sea que el vengador de la sangre se deje llevar por la cólera, persiga al que causó la muerte, lo alcance si es muy largo el camino, y lo mate, cuando en realidad éste no es reo de muerte, ya que no odiaba anteriormente a su compañero."
,"7":"Por esto, te mando yo que separes estas tres ciudades."
,"8":"Pero si Yavé ensancha tus fronteras, como lo tiene jurado a tus padres, y te da todo el país que te prometió,"
,"9":"con la condición de que guardes sus mandamientos y hagas lo que hoy te digo, esto es, que ames a Yavé, tu Dios, y sigas sus caminos en todo tiempo, entonces añadirás otras tres ciudades a las antedichas, duplicando así el número de ciudades de refugio."
,"10":"Así, no se derramará sangre inocente en medio de la tierra que Yavé, tu Dios, te da en herencia; y no serás culpable de este derramamiento."
,"11":"Pero si un hombre, por odio a su prójimo, le tiende una emboscada, se lanza sobre él y lo hiere de muerte, si luego el agresor huye a una de estas ciudades,"
,"12":"los jefes de su ciudad mandarán prenderlo allí, al lugar de asilo, y lo entregarán en manos del pariente del muerto para que le quiten la vida."
,"13":"No tendrás piedad de él, sino que harás desaparecer de en medio de Israel el derramamiento de sangre inocente y así tendrás prosperidad."
,"14":"No moverás los deslindes de tu vecino del lugar en que los pusieron tus padres para delimitar la herencia familiar, en el país que Yavé, tu Dios, te dará."
,"15":"Un solo testigo no es suficiente para condenar a un hombre, sea cual fuere el delito o falta de que se le acusa; sólo por el testimonio de dos o tres testigos se decidirá la causa."
,"16":"Si un solo testigo se levanta contra un hombre y lo acusa de algún delito,"
,"17":"los dos hombres cuyo pleito se trata comparecerán ante Yavé, en presencia de los sacerdotes y jueces que haya en aquel tiempo."
,"18":"Los jueces examinarán minuciosamente, y si resulta que el testigo ha dicho una mentira, acusando falsamente a su hermano,"
,"19":"le impondrán a él la pena que pretendía imponer a su hermano. Así arrancarás el mal de en medio de ti,"
,"20":"porque los demás al saberlo temerán y no cometerán cosas semejantes."
,"21":"No te compadecerás de él, sino que le harás pagar vida por vida, ojo por ojo, diente por diente, mano por mano, pie por pie."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Cuando vayas a la guerra contra tus enemigos y veas caballos, carros y un ejército más numeroso que el tuyo, no les tengas miedo, porque está contigo Yavé, tu Dios, aquel que te sacó de Egipto."
,"2":"Cuando se acerque la hora del combate, se adelantará el sacerdote y dirigirá estas palabras al pueblo:"
,"3":"'Escucha, Israel, estás para enfrentar a tus enemigos; que no desmaye tu corazón, no tengas miedo ni te turbes, ni tiembles delante de ellos,"
,"4":"porque Yavé, tu Dios, está contigo. El peleará en favor tuyo contra tus enemigos y te salvará.'"
,"5":"Entonces los oficiales dirán al pueblo: '¿Hay alguno de ustedes que tenga su casa nueva recién terminada y no la haya estrenado todavía? Vaya y regrese a su casa; no sea que muera en la batalla y otro la estrene."
,"6":"¿Hay alguien entre ustedes que haya plantado una viña nueva y que todavía no ha podido disfrutar de ella? Vaya y regrese a su casa, no sea que muera en la guerra y otro pase a ser dueño de ella."
,"7":"¿Hay alguno que esté prometido en matrimonio y que todavía no se haya casado? Regrese en seguida a su casa, no sea que muera en el combate y otro se case con su prometida.'"
,"8":"Dicho esto, añadirán todavía: '¿Hay aquí algún hombre que tenga miedo o al que falte el ánimo? Regrese inmediatamente a su casa para que no contagie con su miedo a sus hermanos.'"
,"9":"Cuando hayan terminado de hablar, los oficiales se pondrán al frente del pueblo."
,"10":"Cuando te acerques a una ciudad para sitiarla, le propondrás la paz."
,"11":"Si ella te la acepta y te abre las puertas, toda la gente que en ella se encuentre salvará su vida. Te pagarán impuestos y te servirán."
,"12":"Si no acepta la paz que tú le propones y te declara la guerra, la sitiarás."
,"13":"Y cuando Yavé, tu Dios, la entregue en tus manos pasarás a cuchillo a todos los varones,"
,"14":"pero las mujeres y niños, el ganado y las demás cosas que en ella encuentres, serán tu botín y comerás de los despojos de tus enemigos que Yavé te haya entregado."
,"15":"Así harás con todas las ciudades que estén muy distantes de ti, y que no sean de aquellas de las cuales has de tomar posesión."
,"16":"En cambio, no dejarás a nadie con vida en las ciudades que Yavé te da en herencia,"
,"17":"sino que las destruirás conforme a la ley del anatema, ya sean heteos, amorreos, cananeos, fereceos, jeveos y jebuseos. Así te lo tiene mandado Yavé, tu Dios,"
,"18":"para que no te enseñen a imitar todas esas cosas malas que ellos hacían en honor de sus dioses, con lo cual tú pecarías contra Yavé, tu Dios."
,"19":"Si, al atacar una ciudad, tienes que sitiarla por mucho tiempo para tomarla, no destruirás los árboles frutales que estén alrededor ni les meterás el hacha, ya que deben ser tu alimento. No los cortarás, pues, ¿son acaso hombres los árboles del campo para que los trates como a sitiados?"
,"20":"Si hay árboles que no son frutales, córtalos y haz con ellos escaleras e instrumentos que te sirvan para tomar la ciudad que te opone resistencia."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Cuando encuentres en el campo, en el país que Yavé, tu Dios, te da, el cadáver de una persona asesinada, sin que se sepa quién la mató,"
,"2":"tus jueces y tus jefes irán a medir la distancia entre la víctima y los pueblos vecinos."
,"3":"Entonces los jefes del pueblo más cercano traerán una ternera que no haya trabajado ni llevado yugo,"
,"4":"la bajarán a un arroyo que corre todo el año, donde no se haya arado ni se siembre, y allí le romperán la nuca."
,"5":"Estarán presentes los sacerdotes, hijos de Leví, pues fueron elegidos por Yavé para que le sirvan y den la bendición en su nombre, y son ellos los que deciden todo litigio o asunto criminal."
,"6":"Entonces todos los ancianos del pueblo más próximo al crimen se lavarán las manos en el arroyo sobre la ternera desnucada,"
,"7":"y pronunciarán estas palabras: 'Nuestras manos no han derramado esa sangre y nuestros ojos no han visto nada."
,"8":"Perdona, oh Yavé, a tu pueblo de Israel al que rescataste, y no le imputes la sangre inocente derramada en medio de él.'"
,"9":"Así se les perdonará esta sangre; así quitarás de en medio de ti la sangre inocente y obrarás rectamente a los ojos de Yavé."
,"10":"Cuando vayas a la guerra contra tus enemigos, y Yavé, tu Dios, te los entregue,"
,"11":"verás tal vez entre las cautivas a una mujer hermosa, te enamoras de ella y querrás hacerla tu esposa."
,"12":"Entonces la llevarás a tu casa, donde se rapará la cabeza y se cortará las uñas."
,"13":"Dejará el vestido que llevaba cuando fue tomada, y quedará en tu casa durante un mes, haciendo duelo por su padre y su madre. Después te juntarás con ella y tú serás su marido y ella tu esposa."
,"14":"Si con el tiempo ya no te agrada, la despedirás; pero no podrás venderla por dinero, ni hacerla tu esclava, ya que la tomaste."
,"15":"Cuando un hombre tiene dos mujeres, de las cuales a una quiere y a la otra, no, puede ser que las dos le den hijos y que el primogénito sea hijo de la mujer menos amada."
,"16":"El día que reparta la herencia entre sus hijos, no podrá dar los derechos de primogenitura al hijo de la mujer a la que quiere, en perjuicio del primogénito que le dio la mujer no amada."
,"17":"Al contrario, deberá reconocer como primogénito al hijo de la mujer menos amada y darle una parte doble de toda su herencia. Al que engendró primero, a éste le corresponden los derechos de primogénito."
,"18":"Si un hombre tiene un hijo rebelde y desvergonzado, que no atiende lo que mandan su padre o su madre, ni los escucha cuando lo corrigen,"
,"19":"sus padres lo agarrarán y llevarán ante los jefes de la ciudad, a la puerta donde se juzga,"
,"20":"y les dirán: 'Este hijo nuestro es rebelde y desvergonzado, no nos hace caso, es un vicioso y un borracho.'"
,"21":"Entonces todo el pueblo le tirará piedras hasta que muera. Así harás desaparecer el mal de en medio de ti, y todo Israel, al saberlo, temerá."
,"22":"Si un hombre, culpable de algún delito que merece la muerte, ha sido ajusticiado y colgado de un árbol,"
,"23":"su cuerpo no pasará la noche colgado, sino que lo enterrarás el mismo día, porque un colgado es maldición de Dios. Así no harás impura la tierra que Yavé, tu Dios, te da por herencia."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Si encuentras extraviado el buey o la oveja de tu hermano, no te harás el desentendido, sino que se lo llevarás a tu hermano."
,"2":"Si este hermano no es vecino tuyo y no sabes a quién pertenece el animal, lo guardarás en tu casa hasta que su dueño vaya a buscarlo. Entonces se lo devolverás."
,"3":"Lo mismo harás con su burro, y lo mismo con su vestido, y lo mismo con cualquier objeto que se le extravió a tu hermano, el día que lo encuentres. No puedes hacer como si no supieras."
,"4":"Si ves el burro de tu hermano o su buey que caen en el camino, no puedes desentenderte, sino que ayudarás a levantarlo."
,"5":"La mujer no llevará vestido de hombre, ni el hombre vestido de mujer, porque Yavé aborrece al que hace tal cosa."
,"6":"Si encuentras en tu camino un nido de pájaros en un árbol o en el suelo, y la madre está echada sobre los polluelos o sobre los huevos, no te llevarás a la madre con las crías,"
,"7":"sino que dejarás que ella se vaya y tomarás para ti sólo las crías. Así tendrás prosperidad y larga vida."
,"8":"Cuando construyas una casa nueva, harás alrededor de la azotea un pequeño muro, no sea que alguien se caiga desde arriba y tu casa quede manchada con sangre."
,"9":"No sembrarás en tu viña ninguna otra semilla, porque de hacerlo, tanto los productos de esta siembra como las uvas de tu viña quedarían prohibidos."
,"10":"No ararás con un buey y un burro juntos."
,"11":"No te vestirás con un paño tejido mitad de lana y mitad de lino."
,"12":"Te harás una borla en las cuatro puntas del manto con que te cubras."
,"13":"Aquí viene el caso de un hombre que se ha casado con una mujer y después deja de quererla."
,"14":"Este hombre empieza a reprocharla por su conducta y a difamarla, y se le ocurre decir: 'Me casé con esta mujer, y al acostarme con ella, no le encontré las señas de su virginidad.'"
,"15":"En ese caso el padre y la madre de la joven tomarán el paño en que están las señas de su virginidad y lo mostrarán a los jueces de la ciudad."
,"16":"El padre de la joven dirá a los jueces: 'He dado a mi hija por esposa a este hombre, pero ya no la quiere, y ahora pretende que no la tomó virgen."
,"17":"Vean, pues, ahí las pruebas de la virginidad de mi hija.' Y extenderán el paño delante de los jueces de la ciudad."
,"18":"Si el hombre es culpable, los jueces lo tomarán preso y lo azotarán."
,"19":"Lo multarán además en cien monedas de plata, que entregarán al padre de la joven, por haber difamado a una virgen de Israel. El marido tendrá que tomarla como esposa y no podrá repudiarla en toda su vida."
,"20":"Pero si es verdad lo que el hombre dice, y no aparecen las pruebas de su virginidad,"
,"21":"entonces la sacarás a la puerta de la casa de su padre y morirá apedreada por el pueblo, por haber cometido una infamia en Israel, prostituyéndose mientras todavía estaba en la casa de su padre. Así harás desaparecer el mal de en medio de ti."
,"22":"Si se sorprende a un hombre acostado con una mujer casada, morirán los dos, el adúltero y la adúltera. Así harás desaparecer el mal de Israel."
,"23":"Si una joven está prometida en matrimonio a un hombre, y otro hombre la encuentra en la ciudad y se acuesta con ella,"
,"24":"los llevarán a los dos y los apedrearán hasta que mueran: la joven porque no gritó y no pidió ayuda, estando en la ciudad, y el hombre, porque deshonró a la mujer de su prójimo. Así harás desaparecer el mal de en medio de ti."
,"25":"Pero si el hombre encuentra en el campo a una joven prometida en matrimonio, y a la fuerza la viola, sólo el hombre que la violó morirá."
,"26":"No harás nada a la joven; ella no merece la muerte, porque así como un salteador se arroja sobre un hombre y lo asesina, de la misma manera fue asaltada la joven."
,"27":"Estaba sola en el campo, gritó y nadie le prestó ayuda."
,"28":"Si un hombre encuentra a una joven virgen, no prometida en matrimonio a otro hombre, y a la fuerza la viola y luego son sorprendidos,"
,"29":"el hombre que se acostó con ella dará al padre de la joven cincuenta monedas de plata, y la tomará por esposa. Y no podrá repudiarla en toda su vida, ya que la deshonró."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Ninguno tomará por esposa a la de su padre; que no se atreva a deshonrar a su padre."
,"2":"El hombre que tenga los testículos aplastados o el pene mutilado no será admitido en la asamblea de Yavé."
,"3":"Tampoco el mestizo será admitido en la asamblea de Yavé, ni aun en la décima generación."
,"4":"El amonita y el moabita no se admitirán jamás en la asamblea de Yavé, ni aun después de la décima generación."
,"5":"Porque, cuando ustedes venían de Egipto, no les salieron al encuentro con pan y agua sino que trajeron a Balaam, hijo de Beor de la ciudad de Petar en Mesopotamia, para que los maldijera."
,"6":"Pero Yavé, tu Dios, no escuchó a Balaam y cambió la maldición por bendición, porque Yavé te ama."
,"7":"A estos pueblos nunca les proporcionarás prosperidad ni bienestar."
,"8":"Pero no aborrecerás al edomita, pues es hermano tuyo. No aborrecerás al egipcio, porque fuiste peregrino en su tierra."
,"9":"A la tercera generación, sus descendientes podrán ser admitidos en la asamblea de Yavé."
,"10":"Cuando salgas de campaña contra tus enemigos, te guardarás de toda acción mala."
,"11":"Si hay entre los tuyos un hombre que no esté puro por causa de una polución nocturna, saldrá fuera del campamento y no volverá a entrar."
,"12":"Al llegar la tarde se lavará y a la puesta del sol podrá entrar de nuevo al campamento."
,"13":"Habrá un lugar afuera del campamento para satisfacer las necesidades naturales."
,"14":"Llevarás una estaquita al cinturón, con la cual harás un hoyo antes de ponerte en cuclillas, y luego taparás el excremento con la tierra sacada."
,"15":"Porque Yavé, tu Dios, recorre el campamento para protegerte y entregar en tus manos al enemigo. Por eso tu campamento debe ser cosa limpia y sagrada, en que Yavé no vea nada indecente; de lo contrario se apartaría de ti."
,"16":"No entregarás a su amo al esclavo que huyó de su casa y se acogió a ti."
,"17":"Se quedará contigo entre los tuyos, en el lugar que él elija en una de tus ciudades, donde mejor le parezca; no lo molestarás."
,"18":"No habrá entre las hijas de Israel prostituta sagrada, ni prostituto sagrado entre los hijos de Israel."
,"19":"Sea cual fuere el voto que hayas hecho, no llevarás a la casa de Yavé, tu Dios, regalo de prostitutas, ni salario de perro, o sea, prostituto, porque ambas cosas son abominables a los ojos de Yavé."
,"20":"No prestarás con interés a tus hermanos, ni dinero, ni alimentos, ni cualquier otra cosa por la que se cobran intereses."
,"21":"Al extranjero podrás prestarle con interés, pero a tu hermano, no. Con esto conseguirás que Yavé, tu Dios, te bendiga en todas tus empresas, en la tierra que vas a poseer."
,"22":"Si haces algún voto a Yavé, no tardes en cumplirlo, porque sin duda Yavé te lo reclamará y tú cargarías con un pecado."
,"23":"Pero si no haces votos, no cometes pecado alguno."
,"24":"Cumplirás tus promesas y, si haces algún voto, ofrecerás según hayas prometido a Yavé."
,"25":"Si entras en la viña de tu prójimo, podrás comer las uvas que quieras, pero no podrás llevarte ninguna."
,"26":"Si pasas por los sembrados de tu prójimo, podrás arrancar espigas con tu mano, pero no meterás la hoz en las mieses de tu prójimo."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Si un hombre toma una mujer y se casa con ella, puede ser que le encuentre algún defecto y ya no la quiera. En ese caso, escribirá un certificado de divorcio que le entregará antes de despedirla de su casa."
,"2":"Habiendo salido de su casa, puede ser la mujer de otro."
,"3":"Pero si éste también ya no la quiere y la despide con un certificado de divorcio, o bien si llega a morir este otro hombre que la tomó como mujer suya,"
,"4":"el primer marido que la repudió no podrá volver a tomarla por esposa, ya que pasó a ser para él como impura. Sería una abominación a los ojos de Yavé que la volviera a tener. No manches la tierra que Yavé te dará en herencia."
,"5":"Si un hombre está recién casado, no irá a la guerra ni se le molestará con otro servicio. Que esté exento de todo durante un año para así quedar en su casa y hacer feliz a su esposa."
,"6":"No se tomará en prenda el molino, ni la muela de piedra del molino, porque ello sería tomar en prenda la vida misma."
,"7":"Si se descubre a un hombre que haya raptado a un israelita, es decir, a uno de sus hermanos, y lo haya vendido como esclavo, el raptor debe morir. Así cortarás el mal entre tu gente."
,"8":"Cuídate de las lepras contagiosas. Observa y pon en práctica lo que te enseñen los sacerdotes levitas; cumple lo que yo les mandé."
,"9":"Acuérdate de lo que Yavé, tu Dios, hizo con Miriam, cuando el pueblo estaba en camino, al salir de Egipto."
,"10":"Si prestas algo a tu prójimo, no entrarás en su casa para tomar alguna prenda."
,"11":"Esperarás afuera, y el deudor saldrá de la casa para entregarte la prenda."
,"12":"Si has tomado como prenda el manto de un pobre, no te acostarás guardándolo,"
,"13":"sino que se lo devolverás a la puesta del sol y así él se acostará en su manto. El pobre te bendecirá y tú tendrás méritos a los ojos de Yavé, tu Dios."
,"14":"No explotarás al jornalero humilde y pobre, ya sea uno de tus hermanos o un forastero que se encuentre en tu tierra, en algunas de tus ciudades."
,"15":"Le pagarás cada día, antes de la puesta del sol, porque es pobre y está pendiente de su salario. No sea que clame a Yavé contra ti, pues tú cargarías con un pecado."
,"16":"No se matará a los padres por la culpa de sus hijos, ni a los hijos por la de sus padres. Cada cual pagará por su propio pecado."
,"17":"No violarás el derecho del forastero, ni del huérfano, ni tomarás en prenda las ropas de la viuda."
,"18":"Recuerda que fuiste esclavo en Egipto y que Yavé, tu Dios, te rescató. Por eso te mando hacer esto."
,"19":"Cuando cortes el trigo en tu campo, si se te cae alguna gavilla, no volverás a recogerla, sino que quedará para el forastero, el huérfano y la viuda. Así Yavé te bendecirá en todos tus trabajos."
,"20":"Cuando coseches tus olivos, no pasarás otra vez para sacudirlos: el resto será para el forastero, el huérfano y la viuda."
,"21":"Cuando vendimies tu viña, no volverás a buscar lo que haya quedado. Esto será la parte del forastero, del huérfano y de la viuda."
,"22":"Acuérdate de que fuiste esclavo en Egipto. Por eso te mando hacer esto."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Cuando haya pleito o contienda entre dos hombres, se recurrirá a los jueces para que juzguen. Se declarará justo al que lo es y se condenará al culpable."
,"2":"Si éste merece azotes, el juez le hará echarse al suelo en su presencia y hará que lo azoten con un número de golpes proporcionado a su culpa."
,"3":"Podrán darle cuarenta azotes, no más, no sea que al golpearlo más, sea mucho el castigo y tu hermano quede deshonrado a tus ojos."
,"4":"No pondrás bozal al buey que trilla."
,"5":"Si dos hermanos viven juntos y uno de ellos muere sin tener hijos, la mujer del difunto no irá a casa de un extraño, sino que la tomará su cuñado para cumplir el 'deber del cuñado.'"
,"6":"El primer hijo que de ella tenga retomará el lugar y el nombre del muerto, y así su nombre no se borrará de Israel."
,"7":"En el caso de que el hombre se niegue a cumplir su deber de cuñado, ella se presentará a la puerta de la ciudad y dirá a los ancianos: 'Mi cuñado se niega a perpetuar el nombre de su hermano en Israel, no quiere ejercer en mi favor su deber de cuñado.'"
,"8":"Entonces los ancianos lo llamarán y le hablarán. Si él porfía en decir: 'No quiero tomarla por mujer',"
,"9":"su cuñada se acercará a él y en presencia de los jueces le sacará la sandalia de su pie, le escupirá a la cara y le dirá estas palabras: 'Así se trata al hombre que no hace revivir el nombre de su hermano.'"
,"10":"Su casa será llamada en Israel 'la casa del descalzo.'"
,"11":"Si dos hombres pelean entre sí y la mujer de uno de ellos se acerca para librar a su marido de los golpes del otro, alarga la mano y agarra a éste por las vergüenzas,"
,"12":"harás cortar la mano de la mujer sin piedad."
,"13":"No tendrás en tu bolsa diferentes pesas, unas mayores y otras menores,"
,"14":"ni habrá en tu casa una medida grande y otra menor."
,"15":"Tendrás un peso justo y exacto, e igualmente una medida justa y exacta, para que se prolonguen tus días en la tierra que Yavé, tu Dios, te da."
,"16":"Porque Yavé aborrece al que hace tales cosas y a toda injusticia."
,"17":"Acuérdate de lo que hizo Amalec con ustedes cuando estaban en camino, al salir de Egipto."
,"18":"Vino a tu encuentro en el camino y atacó por la espalda a todos los que iban agotados en la retaguardia, cuando tú estabas cansado y extenuado; no tuvo temor a Dios."
,"19":"Por eso, cuando Yavé, tu Dios, después de someter a todos tus enemigos alrededor, te dé descanso en la tierra que él te da, borrarás el recuerdo de Amalec de debajo de los cielos. No lo olvides."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Cuando llegues a la tierra que Yavé, tu Dios, te da en herencia, cuando haya pasado a ser tuya y habites en ella,"
,"2":"tomarás los primeros productos de la tierra que Yavé, tu Dios, te da, los pondrás en un canasto y los llevarás al lugar elegido por Yavé, tu Dios, para morada de su Nombre."
,"3":"Te presentarás al sacerdote que esté en funciones en aquellos días y le dirás: 'En este día yo reconozco que Yavé, mi Dios, me hizo entrar a la tierra que prometió a nuestros padres que nos daría.'"
,"4":"Y el sacerdote tomará de tus manos el canasto y lo depositará ante el altar de Yavé, tu Dios."
,"5":"Entonces tú dirás estas palabras ante Yavé:"
,"6":"'Mi padre era un arameo errante, que bajó a Egipto y fue a refugiarse allí, siendo pocos aún; pero en ese país se hizo una nación grande y poderosa. Los egipcios nos maltrataron, nos oprimieron y nos impusieron dura servidumbre."
,"7":"Llamamos pues a Yavé, Dios de nuestros padres, y Yavé nos escuchó, vio nuestra humillación, nuestros duros trabajos y nuestra opresión."
,"8":"Yavé nos sacó de Egipto con mano firme, demostrando su poder con señales y milagros que sembraron el terror."
,"9":"Y nos trajo aquí para darnos esta tierra que mana leche y miel."
,"10":"Y ahora vengo a ofrecer los primeros productos de la tierra que tú, Yavé, me has dado.',Los depositarás ante Yavé, te postrarás y adorarás a Yavé, tu Dios. "
,"11":"Después comerás y celebrarás una fiesta, tú y tu familia, con todos los bienes que Yavé te ha dado. También comerán y estarán de fiesta contigo, tanto el levita como el forastero que viven junto a ti."
,"12":"El tercer año, año del diezmo, cuando hayas acabado de separar el diezmo de todas tus cosechas y se lo hayas dado al levita, al forastero, a la viuda y al huérfano, para que lo coman en tu misma ciudad hasta saciarse,"
,"13":"dirás en presencia de Yavé: 'He sacado de mi casa lo que pertenece a Yavé: se lo he dado al levita, al forastero, al huérfano y a la viuda, según los mandamientos que me has dado. No he traspasado ninguno de ellos ni los he olvidado. "
,"14":"De lo que quedaba no he comido nada durante mi duelo, nada hay impuro en él, nada he ofrecido a los ídolos, sino que he obedecido la voz de Yavé, mi Dios, y he obrado en todo como me lo habías mandado."
,"15":"Desde tu Santuario, desde lo alto de los cielos, mira a tu pueblo Israel y bendícelo, así como a la tierra que nos has dado según lo tenías dicho a nuestros padres, esta tierra que mana leche y miel.'"
,"16":"Has de saber que ese mismo día Yavé, tu Dios, te manda cumplir sus normas y sus mandamientos. Tú los guardarás y los pondrás en práctica con todo tu corazón y toda tu alma."
,"17":"Pues acabas de decir a Yavé que él será tu Dios y tú seguirás sus caminos, observarás sus normas, sus mandamientos y sus leyes y escucharás su voz."
,"18":"Yavé, a su vez, te manda decir hoy que serás el pueblo que le pertenece, como él te lo tiene dicho, y tú guardarás todos sus mandamientos."
,"19":"El, por su parte, te dará honor, renombre y gloria y te pondrá por encima de todas las naciones que hizo, mientras tú pasas a ser un pueblo consagrado a Yavé, tu Dios, como él te ha dicho.'"
}`)
	CurrentBook.AddChapter(27, `{
"1":"Moisés y los ancianos de Israel dieron al pueblo esta orden: 'Guarden todos los mandamientos que yo les prescribo hoy."
,"2":"Cuando pasen el Jordán para ir a la tierra que Yavé, tu Dios, te da, erigirás grandes piedras y las blanquearás con cal."
,"3":"Y al pasar escribirás en ellas todas las palabras de esta Ley, con el fin de asegurar tu entrada a la tierra que Yavé, tu Dios, te da como lo tiene dicho a tus padres, tierra que mana leche y miel."
,"4":"Cuando hayas pasado el Jordán, levantarás estas piedras en el monte Ebal, como hoy te mando, y las blanquearás con cal."
,"5":"Levantarás allí en honor de Yavé un altar de piedras, sin labrarlas con hierro."
,"6":"Con piedras sin labrar harás el altar de Yavé y sobre este altar ofrecerás holocaustos a Yavé, tu Dios."
,"7":"Allí también inmolarás sacrificios de comunión, los comerás y te alegrarás en presencia de Yavé, tu Dios."
,"8":"Escribirás en estas piedras todas las palabras de esta Ley. Déjalas bien grabadas.'"
,"9":"Después, Moisés y los sacerdotes de la tribu de Leví hablaron así al pueblo de Israel: 'Atiende y escucha, Israel. Hoy has pasado a ser el pueblo de Yavé, tu Dios;"
,"10":"escucharás, pues, su voz y pondrás en práctica los mandamientos y normas que yo hoy te prescribo.'"
,"11":"Aquel día Moisés dio esta orden al pueblo:"
,"12":"'Cuando hayan pasado el río Jordán, las tribus de Simeón, Leví, Judá, Isacar, José y Benjamín se pondrán en el monte Garizim para repetir las bendiciones sobre el pueblo,"
,"13":"mientras que las de Rubén, Gad, Aser, Zabulón, Dan y Neftalí estarán en el monte Ebal para repetir las maldiciones."
,"14":"Entonces los levitas tomarán la palabra y dirán en voz alta para que lo oigan todos los israelitas:"
,"15":"Maldito sea el que hace un ídolo de metal, cosa odiosa a Yavé, obra de manos de artífice, y lo coloca en un lugar oculto. Todo el pueblo responderá: ¡Amén!"
,"16":"Maldito aquel que desprecia a su padre o a su madre. Y responderá todo el pueblo: ¡Amén!"
,"17":"Maldito el que corre los límites de la heredad de su prójimo. Todo el pueblo responderá: ¡Amén!"
,"18":"Maldito el que desvía a un ciego en el camino. Todo el pueblo responderá: ¡Amén!"
,"19":"Maldito el que no respeta el derecho del forastero, del huérfano y de la viuda. Todo el pueblo responderá: ¡Amén!"
,"20":"Maldito el que se acueste con la mujer de su padre y deshonre así su cama. Todo el pueblo responderá: ¡Amén!"
,"21":"Maldito el que peca con cualquier animal que sea. Responderá el pueblo: ¡Amén!"
,"22":"Maldito el que se acuesta con su hermana, hija de su padre o de su madre. Todo el pueblo responderá: ¡Amén!"
,"23":"Maldito el que se acuesta con su suegra. Todo el pueblo dirá: ¡Amén!"
,"24":"Maldito aquel que mata a traición a su prójimo. Todo el pueblo dirá: ¡Amén!"
,"25":"Maldito el que acepta soborno para matar a un inocente. Todo el pueblo dirá: ¡Amén!"
,"26":"Maldito el que no sigue fiel a las palabras de esta ley poniéndolas en práctica, y todo el pueblo dirá: ¡Amén!"
}`)
	CurrentBook.AddChapter(28, `{
"1":"Ahora bien, si tú obedeces de verdad a la voz de Yavé, tu Dios, practicando y guardando todos los mandamientos que te prescribo hoy, Yavé, tu Dios, te levantará por encima de todas las naciones de la tierra."
,"2":"Entonces vendrán sobre ti y te alcanzarán todas las bendiciones siguientes, por haber obedecido a la voz de Yavé, tu Dios:"
,"3":"Bendito serás en la ciudad y en el campo."
,"4":"Bendito será el fruto de tus entrañas y el fruto de tu tierra, las crías de tus burras, el parto de tus vacas y ovejas."
,"5":"Benditos tu canasta de frutos y tu reserva de pan."
,"6":"Bendito serás cuando salgas y bendito también cuando vuelvas."
,"7":"Yavé hará huir ante ti a los enemigos que te ataquen; por un camino saldrán a tu encuentro y por siete huirán de ti."
,"8":"Yavé ordenará a la bendición que esté contigo en tus graneros y en tus empresas para que seas bendecido en la tierra que Yavé, tu Dios, te da."
,"9":"Yavé hará de ti su pueblo santo, como te ha jurado si tú guardas sus mandamientos y sigues sus caminos."
,"10":"Todos los pueblos de la tierra verán que te protege el Nombre de Yavé, y te respetarán."
,"11":"Yavé te colmará de toda clase de bienes, multiplicando el fruto de tu vientre, el fruto de tus ganados y el fruto de tu tierra, la cual prometió Yavé con juramento a tus padres que te la daría."
,"12":"Yavé abrirá para ti los cielos, su rico tesoro, para dar a su tiempo la lluvia que necesiten tus campos, y para mandar la bendición sobre todo cuanto emprendas. Tú prestarás a naciones numerosas y no pedirás prestado a ninguna."
,"13":"Yavé te pondrá a la cabeza de los pueblos y no a la cola; siempre estarás encima y nunca debajo si cumples los mandamientos de Yavé, tu Dios, que yo hoy te prescribo, guardándolos y poniéndolos en práctica,"
,"14":"sin apartarte ni a la derecha ni a la izquierda, para seguir y adorar a otros dioses."
,"15":"Pero si no obedeces la voz de Yavé, tu Dios, y no pones en práctica todos sus mandamientos y normas que hoy te prescribo, vendrán sobre ti todas estas maldiciones:"
,"16":"Maldito serás en la ciudad y en el campo."
,"17":"Maldita será tu canasta de frutos y tu reserva de pan."
,"18":"Maldito el fruto de tus entrañas y el fruto de tus tierras, los partos de tus vacas y las crías de tus ovejas."
,"19":"Maldito serás cuando salgas y maldito también cuando vuelvas."
,"20":"Yavé mandará la desgracia, la derrota y el susto sobre todo lo que tus manos toquen, hasta que seas exterminado, y perecerás en poco tiempo por las malas acciones que cometiste, traicionando a Yavé."
,"21":"El hará que se te pegue la peste hasta que desaparezcas de este país que, hoy, pasa a ser tuyo."
,"22":"Yavé te castigará con tuberculosis, fiebre, inflamación, quemaduras, tizón y roya del trigo, que te perseguirán hasta que mueras."
,"23":"El cielo que te cubre se volverá de bronce, y la tierra que pisas, de hierro."
,"24":"En vez de lluvia, Yavé te mandará cenizas y polvo, que caerán del cielo hasta que te hayan barrido."
,"25":"Yavé hará que seas derrotado por tus enemigos. Por un camino irás a pelear en su contra y por siete caminos huirás de ellos. Al verte se horrorizarán todos los pueblos de la tierra."
,"26":"Tu cadáver servirá de comida a todas las aves del cielo y a todas las bestias de la tierra, sin que nadie las corra."
,"27":"Te herirá Yavé con las úlceras y plagas de Egipto, con tumores, sarna y tiña, de las que no podrás sanar."
,"28":"Te castigará Yavé con la locura, la ceguera y la pérdida de los sentidos."
,"29":"Andarás a tientas en pleno mediodía, como anda el ciego en la oscuridad, y fracasarás en tus empresas. Siempre serás un hombre oprimido y despojado, sin que nadie salga en tu defensa."
,"30":"Tendrás una prometida y otro hombre la hará suya. Edificarás una casa y no la podrás habitar. Plantarás una viña y no comerás sus uvas."
,"31":"Tu buey será sacrificado delante de ti y no comerás de él. Ante tus ojos te robarán tu burro y no te lo devolverán, tus ovejas serán entregadas a tus enemigos y nadie te defenderá."
,"32":"Tus hijos y tus hijas serán entregados a pueblos extranjeros y enfermerás con tanto mirar hacia ellos, pero no podrás hacer nada."
,"33":"El fruto de tus campos, todos tus esfuerzos, los comerá un pueblo que no conoces y tú no serás más que un explotado y oprimido toda la vida."
,"34":"Te volverás loco por lo que veas."
,"35":"Yavé te herirá con úlceras malignísimas en las rodillas y en las piernas, de las que no podrás sanar, desde la planta de los pies hasta la coronilla de tu cabeza."
,"36":"Yavé te llevará a ti y al rey que tú hayas elegido a una nación que ni tú ni tus padres conocían, y allí servirás a otros dioses de piedra y de madera."
,"37":"Andarás perdido, siendo el juguete y la burla de todos los pueblos donde Yavé te llevará."
,"38":"Echarás en tus campos mucha semilla y será muy poco lo que coseches, porque la langosta lo devorará."
,"39":"Plantarás una viña y la cultivarás, pero no beberás vino ni comerás uvas, porque los gusanos la roerán."
,"40":"Tendrás olivos por todo tu territorio, pero no te darán ni siquiera aceite con que ungirte, porque se caerán las aceitunas y se pudrirán."
,"41":"Tendrás hijos e hijas, pero no serán para ti, porque se los llevarán cautivos."
,"42":"Todos los árboles y frutos de tu tierra serán atacados por los insectos."
,"43":"El forastero que vive contigo se hará cada día más rico, y tú cada día serás más pobre."
,"44":"El te prestará y tú tendrás que pedir prestado; él estará a la cabeza y tú a la cola."
,"45":"Todas estas maldiciones caerán sobre ti, te perseguirán y oprimirán hasta que hayas sido eliminado, porque no escuchaste la voz de Yavé, tu Dios, ni guardaste sus mandamientos ni las normas que te ordenó."
,"46":"Se apegarán a ti y a tus descendientes para siempre y serán una señal asombrosa a la vista de todos."
,"47":"Por no haber servido con gozo y alegría de corazón a Yavé, tu Dios, cuando nada te faltaba,"
,"48":"servirás con hambre, sed, falta de ropa y toda clase de miseria a los enemigos que Yavé enviará contra ti. Ellos pondrán sobre tu cuello un yugo de hierro hasta que te destruyan del todo."
,"49":"Yavé hará venir contra ti de un país remoto, como un vuelo de águila, a un pueblo cuya lengua no entenderás."
,"50":"Ese pueblo cruel no tendrá respeto por el anciano ni compasión del niño."
,"51":"Devorará las crías de tus ganados y los frutos de tus cosechas, para que así perezcas, pues no te dejará trigo, ni vino, ni aceite, ni las crías de tus vacas y de tus ovejas, hasta acabar contigo."
,"52":"Te asediarán en todas tus ciudades, hasta que caigan en todo tu país las murallas más altas y fortificadas en las que tú ponías tu confianza. Quedarás sitiado dentro de tus ciudades en todo el país que te da Yavé, tu Dios."
,"53":"Te comerás el fruto de tus entrañas, la carne de tus hijas e hijos que te haya dado Yavé, en el asedio y angustia a que te reducirá tu enemigo."
,"54":"El hombre más refinado de tu pueblo se esconderá de su hermano e incluso de su esposa y de los hijos que le queden,"
,"55":"negándose a compartir con ellos la carne de los hijos que se estará comiendo, porque nada le quedará durante el asedio y la angustia a que tu enemigo te reducirá en todas tus ciudades."
,"56":"La mujer más tierna y delicada de tu pueblo, tan delicada y tierna que hacía ademanes para posar en tierra la planta de su pie, se esconderá del hombre que se acuesta con ella, e incluso de su hijo o de su hija,"
,"57":"mientras come la placenta salida de su seno y a los hijos que dio a luz, por falta de todo otro alimento, cuando tu enemigo te sitie en tus ciudades y te reduzca a la más extrema miseria."
,"58":"Si no guardas ni pones en práctica las palabras de esta Ley tales como están escritas en este libro, y no temes a ese Nombre glorioso y terrible, a Yavé, tu Dios,"
,"59":"él te castigará, a ti y a tus descendientes, con plagas asombrosas, plagas grandes y duraderas, enfermedades malignas e incurables."
,"60":"Hará caer sobre ti todas las plagas de Egipto, a las que tanto miedo tenías; y se apegarán a ti."
,"61":"Más todavía, todas las enfermedades y plagas que no se mencionan en este libro de la Ley, te las mandará Yavé hasta aniquilarte."
,"62":"Por no haber obedecido a la voz de Yavé, tu Dios, no quedarán más que unos pocos de ustedes, que eran tan numerosos como las estrellas del cielo."
,"63":"Sucederá, pues, que de la misma manera que Yavé se complacía en hacerles el bien y en multiplicarlos, así se complacerá en perseguirlos y destruirlos. Serán arrancados de la tierra en la que entran para conquistarla."
,"64":"Yavé te dispersará entre todos los pueblos, de un extremo a otro de la tierra, y allí servirás a otros dioses, de madera y de piedra, que ni tú ni tus padres han conocido."
,"65":"En aquellas naciones no encontrarás paz ni estabilidad. Yavé te dará allí un corazón cobarde, atemorizado e inquieto de día y de noche."
,"66":"Tu vida estará ante ti como pendiente de un hilo y andarás asustado de noche y de día."
,"67":"Por la mañana dirás: '¡Ojalá fuera ya de noche!', y por la noche dirás: '¡Ojalá estuviéramos ya a la mañana!', a causa del miedo que estremecerá tu corazón, al contemplar lo que verán tus ojos."
,"68":"Yavé te volverá a llevar a Egipto por tierra y por mar, a pesar de que te dijo: 'No volverás a verlos.' Allí ustedes querrán venderse a sus enemigos como esclavo y como sirvientas, pero no habrá comprador."
,"69":"Estas son las palabras de la Alianza que Yavé mandó a Moisés ratificar con los hijos de Israel en el país de Moab, además de la que hizo con ellos en el Horeb.'"
}`)
	CurrentBook.AddChapter(29, `{
"1":"Moisés convocó a todo el pueblo de Israel. Les dijo: 'Han visto todo lo que Yavé hizo ante sus propios ojos con Faraón, con sus ministros y con todo su país,"
,"2":"aquellas grandes plagas que ustedes mismos presenciaron, aquellos prodigios y señales."
,"3":"Pero hasta el día de hoy Yavé no les ha dado corazón para entender, ojos para ver ni oídos para oír."
,"4":"Durante cuarenta años, Yavé los ha hecho caminar por el desierto, sin que se les hayan gastado los vestidos, ni se haya roto de puro viejo el calzado de sus pies."
,"5":"No tenían pan que comer, ni vino o licor fermentado que beber, y así fue como descubrieron que yo, Yavé, soy el Dios de ustedes."
,"6":"Llegamos luego a este lugar, donde nos salieron al encuentro Sijón, rey de Jesbón, y Og, rey de Basán, para pelear contra nosotros,"
,"7":"pero los derrotamos a todos y nos apoderamos de sus tierras, que dimos a Rubén, a Gad y a la media tribu de Manasés."
,"8":"Guarden, pues, las condiciones de esta Alianza y pónganlas en práctica, para que tengan éxito en todas sus empresas."
,"9":"Aquí están todos hoy, en presencia de Yavé, su Dios: sus jefes, sus tribus, sus ancianos, sus oficiales, todos los hombres de Israel,"
,"10":"con sus hijos, hijas y esposas. También el forastero que vive en tu campo para cortar la leña o para acarrear agua."
,"11":"Ha llegado la hora de entrar en la Alianza de Yavé, tu Dios, mediante el juramento."
,"12":"El quiere hacer de ti su pueblo y ser, él, tu Dios, como te lo dijo y como lo juró a tus padres, Abrahán, Isaac y Jacob."
,"13":"Y no sólo con ustedes hago yo hoy esta alianza y este juramento,"
,"14":"sino que lo hago también con los que están aquí junto a nosotros en presencia de Yavé y con los ausentes."
,"15":"Bien saben ustedes de qué manera hemos vivido en el país de Egipto y cómo hemos atravesado por medio de otras naciones."
,"16":"Ustedes han visto las abominaciones y los sucios ídolos que guardan ellas: piedra, madera, oro y plata."
,"17":"Ojalá no haya, pues, entre ustedes hombre o mujer, familia o tribu, cuyo corazón se aparte hoy de Yavé para ir a servir a los dioses de esas naciones. Ojalá no broten entre ustedes plantas venenosas y amargas."
,"18":"Si alguien cree que estas maldiciones no lo alcanzarán y se dice a sí mismo: 'Haré lo que quiera y no tendré problemas: justos y pecadores perecen juntos.'"
,"19":"Yavé no lo perdonará. Su furor y sus celos se encenderán contra este hombre, al que acecharán todas las maldiciones escritas en este libro. Yavé borrará su nombre de debajo de los cielos"
,"20":"y lo separará de todas las tribus de Israel para su desgracia, conforme a todas las maldiciones de la Alianza expresadas en este libro de la Ley."
,"21":"Las generaciones futuras, los que nacerán después de ustedes, el extranjero llegado de un país lejano, verán las plagas de esta tierra y las enfermedades con que Yavé la castigará,"
,"22":"y dirán: 'Azufre, salitre, tierra quemada, eso es su tierra entera; no volverá a ser sembrada, ni germinará más, ninguna hierba volverá a crecer en ella, como en la catástrofe de Sodoma y Gomorra, Adama y Seboyim, que Yavé asoló en su cólera y en su furor.'"
,"23":"Todas las naciones preguntarán: ¿Por qué Yavé ha tratado así a este país? ¿Cuál es la causa de tanto enojo?"
,"24":"Y contestarán: Esto sucedió porque abandonaron la Alianza que Yavé, Dios de sus padres, pactó con ellos al sacarlos de Egipto;"
,"25":"porque se han ido a servir a otros dioses y los han adorado, dioses que no eran suyos y a quienes Yavé no había encargado."
,"26":"Por eso se ha encendido la ira de Yavé contra ese país hasta traer sobre él toda la maldición escrita en este libro."
,"27":"Yavé los arrancó de su suelo con cólera, furor y gran indignación, y los arrojó a otro país, como hoy se puede ver."
,"28":"Las cosas secretas pertenecen a Yavé, nuestro Dios, pero las que nos dio a conocer nos comprometen, a nosotros y nuestros hijos para siempre, y tenemos que poner en práctica todas las disposiciones de esta Ley."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Cuando te sucedan todas estas cosas acerca de la bendición o maldición que te he propuesto, te acordarás de ellas en medio de las naciones donde Yavé, tu Dios, te haya arrojado."
,"2":"Volverás a él, tú y tus hijos; escucharás su voz con todo tu corazón y con toda tu alma, obedeciendo todo lo que hoy te mando."
,"3":"Entonces Yavé, tu Dios, hará que vuelvan los cautivos de tu pueblo, tendrá piedad de ti y te reunirá de nuevo de en medio de todos los pueblos donde Yavé te haya dispersado."
,"4":"Aunque tus desterrados estén en el otro extremo de la tierra, de allí te sacará Yavé,"
,"5":"y te llevará de nuevo a la tierra que era de tus padres, para que también sea tuya; te hará feliz y te multiplicará más que a tus padres."
,"6":"Yavé, tu Dios, circuncidará tu corazón y el corazón de tus descendientes para que ames a Yavé con todo tu corazón y con toda tu alma y para que vivas."
,"7":"Entonces Yavé, tu Dios, hará caer todas estas maldiciones sobre tus enemigos, contra los que te hayan perseguido porque te odian."
,"8":"Tú volverás a escuchar a Yavé y pondrás en práctica todos sus mandamientos, que yo te prescribo hoy."
,"9":"Yavé, tu Dios, te dará abundante prosperidad en todo lo que hagas, multiplicará a tus hijos y las crías de tus ganados; tu tierra será fecunda y tendrás de todo en abundancia. De nuevo se complacerá Yavé en tratarte bien, como hizo con tus padres,"
,"10":"porque tú habrás vuelto a Yavé, tu Dios, con todo tu corazón y con toda tu alma, y guardarás sus mandamientos y sus normas, en una palabra, lo que está escrito en el libro de esta Ley."
,"11":"Este mandamiento que yo te doy no es superior a tus fuerzas ni está fuera de tu alcance."
,"12":"No está en el cielo, para que puedas decir: '¿Quién subirá al cielo y nos lo traerá? Entonces escucharemos y lo pondremos en práctica.'"
,"13":"Tampoco está al otro lado del mar, para que tengas que decir: '¿Quién pasará hasta el otro lado y nos lo traerá? Entonces escucharemos y lo pondremos en práctica.'"
,"14":"Todo lo contrario, mi palabra ha llegado bien cerca de ti; ya la tienes en la boca y la sabes de memoria, y sólo hace falta ponerla en práctica."
,"15":"Mira que te he ofrecido en este día el bien y la vida, por una parte, y por la otra, el mal y la muerte. Lo que hoy te mando es que tú ames a Yavé, tu Dios, y sigas sus caminos."
,"16":"Observa sus preceptos, sus normas y sus mandamientos, y vivirás y te multiplicarás, y Yavé te dará su bendición en la tierra que vas a poseer."
,"17":"Pero, si tu corazón se desvía y no escuchas, sino que te dejas arrastrar y te postras ante otros dioses para servirlos,"
,"18":"yo declaro hoy que perecerás sin remedio. No durarás largo tiempo en el país que vas a ocupar al otro lado del Jordán."
,"19":"Que los cielos y la tierra escuchen y recuerden lo que acabo de decir; te puse delante la vida o la muerte, la bendición o la maldición. Escoge, pues, la vida para que vivas tú y tu descendencia."
,"20":"Ama a Yavé, escucha su voz, uniéndote a él, para que vivas y se prolonguen tus días, mientras habites en la tierra que Yavé juró dar a tus padres, Abrahán, Isaac y Jacob.'"
}`)
	CurrentBook.AddChapter(31, `{
"1":"Moisés fue a decir estas palabras a todo Israel. Luego les dijo:"
,"2":"'Tengo ya ciento veinte años. Ya se me van las fuerzas y Yavé me advirtió que no pasaría el río Jordán."
,"3":"Pero ahora Yavé, tu Dios, irá delante de ti; él destruirá a tu vista estas naciones y tú las desalojarás. Es Josué quien estará al frente de ustedes, como ya lo tiene dicho Yavé."
,"4":"Yavé tratará a estas ciudades tal como trató a Sijón y a Og, los reyes amorreos, y a su país, a los cuales destruyó."
,"5":"Así, pues, cuando les haya entregado estas naciones ustedes harán lo mismo, según les tengo mandado."
,"6":"Sean valientes y firmes, no teman ni se asusten ante ellos, porque Yavé, tu Dios, está contigo; no te dejará ni te abandonará.'"
,"7":"Después de esto, Moisés llamó a Josué y le dijo en presencia de todo Israel: 'Sé valiente y firme, tú entrarás con este pueblo en la tierra que Yavé, hablando a sus padres, juró darles; y sortearás la parte que le corresponderá a cada uno."
,"8":"Yavé irá delante de ti. El estará contigo; no te dejará ni te abandonará. No temas, pues, ni te desanimes.'"
,"9":"Moisés puso esta Ley por escrito y se la entregó a los sacerdotes, hijos de Leví, que llevaban el Arca de la Alianza de Yavé, así como también a todos los jefes de Israel,"
,"10":"dándoles esta orden: 'Cada siete años, en el año de la Remisión, en el tiempo fijado que es la fiesta de las Tiendas,"
,"11":"cuando todo Israel se junte para presentarse ante Yavé en el lugar elegido por él, ustedes leerán esta Ley en presencia de todo Israel."
,"12":"Reúne al pueblo, hombres, mujeres y niños, y al forastero que vive en tus ciudades, para que escuchen, aprendan a temer a Yavé y cuiden de poner en práctica todas las palabras de esta Ley."
,"13":"Tus hijos, que todavía no la conocen, la oirán y aprenderán a temer a Yavé, tu Dios, todos los días que vivan en el país que vas a conquistar después de pasar el Jordán."
,"14":"Yavé dijo a Moisés: 'Ya se acerca el día en que vas a juntarte con tus padres. Llama a Josué y preséntense los dos en la Tienda de las Citas, para que yo le dé mis órdenes.' Moisés fue con Josué y se presentaron en la Tienda de las Citas."
,"15":"Yavé se les apareció en la Tienda, en la columna de nube; la columna estaba a la entrada de la Tienda. Y Yavé dijo a Moisés:"
,"16":"'Apenas hayas ido a descansar con tus padres, este pueblo empezará a rebelarse y se prostituirá siguiendo a dioses extraños. Me abandonarán y romperán la Alianza que tengo pactada con ellos."
,"17":"Aquel día me enojaré contra ellos, los abandonaré y les ocultaré mi rostro; entonces no les quedará más que ser devorados, y los alcanzarán muchos males y adversidades. Aquel día dirán: ¿No me habrán llegado estos males porque mi Dios ya no está en medio de nosotros?"
,"18":"Pero yo ocultaré mi rostro aquel día a causa de todo el mal que habrán hecho yéndose detrás de otros dioses."
,"19":"Escribe, pues, este libro y enséñaselo a los hijos de Israel para que lo recen de memoria. Este cántico me servirá de testimonio contra los hijos de Israel."
,"20":"Pues los estoy llevando a la tierra que bajo mi juramento prometí a sus padres, tierra que mana leche y miel, y ellos, después de comer hasta saciarse y engordar bien, se volverán hacia otros dioses, les darán culto y a mí me despreciarán y romperán mi Alianza."
,"21":"Y cuando les sucedan males y calamidades sinnúmero, este cántico dará testimonio contra ellos, ya que sus descendientes no lo olvidarán. Pues conozco esa gente y no se me escapan sus malas disposiciones cuando todavía no han entrado en la tierra que les tengo prometida.'"
,"22":"Moisés, pues, escribió aquel día este cántico y se lo enseñó a los hijos de Israel."
,"23":"Luego dio orden a Josué, hijo de Nun: 'Sé valiente y firme, porque tú llevarás a los hijos de Israel a la tierra que les tengo prometida, y yo estaré contigo.'"
,"24":"Cuando terminó de escribir en un libro las palabras de esta Ley,"
,"25":"Moisés dio esta orden a los levitas que llevaban el Arca de la Alianza de Yavé:"
,"26":"'Tomen el libro de esta Ley y pónganlo al lado del Arca de la Alianza de Yavé, nuestro Dios. Allí quedará como testimonio contra ustedes."
,"27":"Porque yo conozco su espíritu rebelde y su cabeza dura. Si hoy, que vivo yo entre ustedes, son rebeldes a Yavé, ¿cuánto más lo serán después de mi muerte?"
,"28":"Reúnan junto a mí a todos los ancianos y los oficiales de todas las tribus, que voy a pronunciar en sus oídos estas palabras, y pediré al cielo y la tierra que sean testigos contra ellos."
,"29":"Porque sé que después de mi muerte obrarán perversamente y se apartarán del camino que les he señalado, y la desgracia vendrá sobre ustedes en el futuro por haber hecho lo que es malo a los ojos de Yavé, enojándolo con sus obras.'"
,"30":"Luego, ante toda la asamblea de Israel, Moisés recitó este cántico hasta el fin:"
}`)
	CurrentBook.AddChapter(32, `{
"1":"'Cielos, presten oídos, que voy a hablar, y la tierra toda escuche las palabras de mi boca."
,"2":"Como lluvia se derrame mi doctrina, caiga como rocío mi palabra, como suave lluvia sobre la verde hierba, como aguacero sobre el césped."
,"3":"Voy a proclamar el nombre de Yavé: ¡alaben a nuestro Dios!"
,"4":"El es la Roca, cuya obra es perfecta, y todos sus caminos son justicia. Es Dios leal, enemigo del mal, es recto y justo."
,"5":"Se portaron mal con él, ¡hijos indignos!,generación perversa y depravada."
,"6":"¿Así pagas a Yavé, pueblo tonto y estúpido?,¿No es él tu Padre, el que te creó, el que te hizo y te estableció?"
,"7":"Acuérdate de los días pasados, recuerda las generaciones anteriores. Interroga a tu padre, que te cuente, a tus ancianos, que te expliquen."
,"8":"Cuando el Altísimo dio a cada pueblo su tierra, cuando repartió a los hijos de Adán, fijó las fronteras de los pueblos,según el número de los Hijos de Dios."
,"9":"Pero la parte de Yavé fue su pueblo, Jacob fue su propio dominio."
,"10":"Lo encontró en el desierto, en la soledad rugiente, y lo cubrió, lo alimentó, lo cuidó como a la niña de sus ojos."
,"11":"Como un águila cubre a sus polluelos, y revolotea sobre ellos, así él extendió sus alas y lo tomó,y lo llevó sobre sus plumas."
,"12":"Sólo Yavé lo guiaba, no estaba con él ningún dios ajeno."
,"13":"Lo estableció en las tierras altas, lo alimentó de los frutos del campo, le dio a gustar la miel de una peña,que sale como aceite del hueco de la roca,"
,"14":"la crema de la vaca y la leche de las ovejas, la grasa de los corderos, y la flor de los granos de trigo; tuvo por bebida el jugo de la uva."
,"15":"Comió el Regalón y se sació, engordó Israel y dio coces, rechazó a Dios, que lo formó, despreció a su Roca, que lo salvó."
,"16":"Despertaron sus celos con dioses ajenos, lo irritaron con sus ídolos."
,"17":"Sacrificaron, no a Dios, sino a demonios. a dioses que no eran suyos, dioses nuevos, recién llegados, a los que nunca veneraron sus padres."
,"18":"¿Cómo? Olvidas a la Roca que te creó, ignoras al Dios que te engendró?"
,"19":"Yavé lo ha visto, y desprecia,a sus hijos e hijas que lo han ofendido."
,"20":"Les voy a esconder mi rostro, a ver qué será de ellos. Estos son una generación perversa, hijos de los que uno no se puede fiar."
,"21":"Me pusieron celoso con lo que no es Dios, me molestaron con cosas que no sirven. Por eso yo los pondré celosos,de una gente que no es pueblo, y los molestará una nación que no sirve."
,"22":"¡Miren que saltó fuego de mi cólera,y la llama consume hasta el mundo de abajo, devora la tierra y sus frutos, abrasa los cimientos de los cerros!"
,"23":"Descargaré mis plagas sobre ellos,y agotaré en ellos mis dardos."
,"24":"Los consumirán el hambre, la peste,y las fiebres mortales. Dientes de fiera mandaré contra ellos, y el veneno de los reptiles."
,"25":"Por fuera la espada hará estragos,y dentro reinará el espanto. Caerán sobre el joven y la doncella, el niño de pecho y el viejo encanecido."
,"26":"¿Acaso diré: A polvo los reduciré, borraré su recuerdo de en medio de los hombres?"
,"27":"Temo que se jacten sus enemigos, ya que no entenderían,y dirían: 'Les ganamos nosotros, no es Yavé quien lo hizo.'"
,"28":"Israel no sabe conducirse,y no hay en ellos sensatez."
,"29":"Si fueran inteligentes, lo entenderían, y sabrían en qué van a parar:"
,"30":"Un solo enemigo persigue a mil de ellos,y dos ponen en fuga a diez mil, ¿no será porque su Roca los ha vendido, porque Yavé los ha entregado?"
,"31":"El enemigo, su roca no es como nuestra Roca, no hay sabiduría en nuestros adversarios."
,"32":"Porque su viña es viña de Sodoma,y de las plantaciones de Gomorra,uvas venenosas son sus uvas, racimos amargos sus racimos."
,"33":"Su vino es veneno de serpiente, mortal ponzoña de áspid."
,"34":"¿Qué suerte les tengo reservada, sellada y guardada junto a mí?"
,"35":"¡A mí la venganza y la sanción,en el momento que su pie vacile!,Pues se acerca el día de su ruina, y pronto llega su fin."
,"36":"Porque Yavé hará justicia a su pueblo,y se apiadará de sus siervos, cuando vea que su fuerza se agota, que no queda ya ni hombre libre ni esclavo."
,"37":"Y les dirá: ¿Dónde están sus dioses, la roca en la que buscaban su refugio,"
,"38":"los que comían la grasa de sus sacrificios,y bebían el vino de sus ofrendas?,¡Que se levanten y los salven a ustedes!, ¡sean ellos su amparo y refugio!"
,"39":"Vean ahora que Yo, sólo Yo soy, y que no hay más Dios que yo. Yo doy la muerte y la vida, yo hiero, y soy yo mismo el que sano, y no hay quién se libre de mi mano."
,"40":"Sí, yo alzo al cielo mi mano y digo: 'Tan cierto como vivo yo para siempre,"
,"41":"afilaré la punta de mi espada, y mi mano empuñará el Juicio; me vengaré de mis adversarios, y daré el pago a quienes me aborrecen."
,"42":"Embriagaré de sangre mis saetas, y mi espada se hartará de carne: sangre de muertos y cautivos, cabezas de caudillos enemigos."
,"43":"¡Que los cielos festejen a su pueblo!,¡Hijos de Dios, póstrense ante él!,Porque él venga la sangre de sus siervos,y devuelve la venganza a sus adversarios, mientras purifica la tierra de su pueblo.'"
,"44":"Moisés pronunció las palabras de este cántico ante el pueblo que lo escuchaba, y Josué, hijo de Nun, estaba con él."
,"45":"Cuando Moisés acabó de pronunciar estas palabras a todo Israel, les dijo:"
,"46":"'Estén bien atentos a todas estas palabras que contienen mi declaración contra ustedes, y digan a sus hijos que cuiden de ponerlas todas en práctica."
,"47":"Porque no es cosa de poca importancia: esta palabra es su vida y, por ella, ustedes prolongarán sus días en el país que van a conquistar después de pasar el Jordán.'"
,"48":"Yavé habló a Moisés en aquel mismo día y le dijo:"
,"49":"'Sube a los cerros de los Abarim, en el país de Moab, frente a Jericó, y contempla la tierra de Canaán que yo doy a los hijos de Israel. Morirás en el cerro al que vas a subir,"
,"50":"y te reunirás con tus padres, igual que tu hermano Aarón, que murió en el cerro de Hor y fue a reunirse con los suyos."
,"51":"Bien sabes que han desconfiado de mí en las aguas de Meribá, en el desierto de Zin, cuando no me proclamaron frente al pueblo."
,"52":"Por eso no entrarás en la Tierra; sólo la contemplarás de lejos.'"
}`)
	CurrentBook.AddChapter(33, `{
"1":"Estas son las bendiciones que Moisés dio a los hijos de Israel antes de morir. Dijo:"
,"2":"'Yavé ha salido del Sinaí; para ellos se ha levantado sobre el horizonte de Seír; resplandeció desde el monte Parán; para ellos llegó a Meriba de Cadés acompañado de sus ángeles."
,"3":"Yavé ama a todos los pueblos, pero en su mano está el pueblo de sus santos. Ahí están, postrados a sus pies, esperando sus instrucciones."
,"4":"Moisés nos dio la Ley que es la herencia de la asamblea de Jacob;"
,"5":"Israel tenía un rey cuando estaban reunidos los jefes y las tribus de Israel eran unidas."
,"6":"Viva Rubén y no muera, a pesar de que sus hijos son tan escasos."
,"7":"Aquí está lo que dijo para Judá: Escucha, Yavé, la voz de Judá y haz que se junte a su pueblo. Sus manos lucharán y tú lo ayudarás contra sus adversarios."
,"8":"Dijo para Leví: Tus Tumim y tus Urim, oh Yavé, están en manos del que te es fiel, a quien probaste en Masa y al que reprochaste en Meribá."
,"9":"El que fue capaz de decir a sus padres: 'A ustedes no los conozco'; y no les hizo caso a sus hermanos e hijos. Están a cargo de tus palabras y cuidan de tu Alianza."
,"10":"Ellos enseñan a Jacob tus decisiones, a Israel tu Ley. Hacen subir hacia ti el olor del incienso y ponen las ofrendas en tu altar."
,"11":"Bendice, ¡oh, Yavé!, su valentía y acepta su servicio. Hiere en el dorso a los que contra él se alcen y que sus enemigos no se levanten jamás."
,"12":"Dijo para Benjamín: Amado de Yavé, descansa confiado en el que lo protege desde las lomas en que tiene su santuario."
,"13":"Dijo para José: ¡Que Yavé bendiga su tierra con el rocío del cielo y las aguas que surgen del abismo,"
,"14":"los frutos que madura el sol y lo que hace germinar la luna,"
,"15":"lo mejor de los viejos montes y de las antiguas lomas,"
,"16":"la tierra generosa y las cosechas abundantes! ¡Descienda sobre la cabeza de José la bendición del que se apareció en la zarza, pues es el elegido entre sus hermanos!"
,"17":"José es su toro primogénito: ¡gloria a él! Son sus cuernos, cuernos de búfalo, con los que hiere a todos los pueblos hasta los confines de la tierra. ¡Miren las muchedumbres de Efraím y los millares de Manasés!"
,"18":"Dijo para Zabulón: Sé feliz, Zabulón, cuando viajes, y tú, Isacar, en tus tiendas."
,"19":"Ellos llamarán a los pueblos a la montaña sagrada, ahí ofrecerán sacrificios justos, pues gozan de las riquezas del mar y los tesoros escondidos en la arena."
,"20":"Dijo para Gad: ¡Bendito el que ensanche a Gad. Como leona se halla tumbado y desgarra el brazo y la cabeza!"
,"21":"El escogió la parte mejor, la parte que fue reservada para el jefe. Encabeza el pueblo, pues ha cumplido la justicia de Yavé y sus decisiones respecto a Israel."
,"22":"Dijo para Dan: Dan es un cachorro de león que salta de Basán."
,"23":"Dijo para Neftalí: Neftalí es colmado de favores, lleno de la bendición de Yavé. ¡Extiéndete hacia el sur y hacia el mar!"
,"24":"Dijo para Aser: Bendito sea Aser entre los hijos."
,"25":"Sea él preferido entre sus hermanos y meta sus pies en el aceite. Sean de hierro y bronce tus cerrojos. Seas fuerte mientras vivas."
,"26":"Nadie hay como Dios ¡oh, Israel!, el que atraviesa los cielos para socorrerte, cabalgando majestuoso sobre las nubes."
,"27":"El Dios eterno es tu refugio, te protegen sus brazos para siempre. Arroja ante ti al enemigo y te dice: Acaba con él."
,"28":"Israel habita seguro. La fuente de Jacob corre aparte en una tierra de trigo y de vino, y le llega rocío del cielo."
,"29":"Feliz eres, ¡oh, Israel! ¿Quién semejante a ti, pueblo salvado por Yavé? El es el escudo que te ampara, la espada que te da la victoria. Tus enemigos quisieran apaciguarte, pero tú, al fin, les pisas el cuello.'"
}`)
	CurrentBook.AddChapter(34, `{
"1":"Moisés subió del llano estéril de Moab al cerro de Nebo, a la cumbre de Pisga, frente a Jericó, y Yavé le mostró toda la Tierra: de Galaad hasta Dan,"
,"2":"todo Neftalí, la tierra de Efraím y de Manasés, toda la tierra de Judá, hasta el mar occidental,"
,"3":"el Negueb, la llanura, el valle de Jericó, ciudad de las Palmeras, hasta Soar."
,"4":"Y le dijo Yavé: 'Esta es la tierra que prometí a Abrahán, a Isaac y a Jacob, y juré que se la daría a su descendencia. Dejo que la veas con tus propios ojos, pero no entrarás en ella.'"
,"5":"Allí murió Moisés, siervo de Yavé, en el país de Moab, conforme Yavé lo había dispuesto."
,"6":"Lo sepultaron en el valle, en el país de Moab frente a Baal Peor, pero nadie hasta hoy ha conocido su tumba."
,"7":"Tenía Moisés ciento veinte años cuando murió. No había perdido su vigor y sus ojos veían aún claramente."
,"8":"Los hijos de Israel hicieron duelo por él en los campos de Moab; durante treinta días estuvieron en duelo."
,"9":"Pero tenían a Josué, hijo de Nun, el cual quedó lleno del espíritu de sabiduría porque Moisés había puesto sus manos sobre él. Los hijos de Israel le obedecieron y actuaron en todo según Yavé había ordenado a Moisés."
,"10":"No ha vuelto a surgir en Israel profeta semejante a Moisés. Con él, Yavé había tratado cara a cara."
,"11":"¡Cuántos milagros y maravillas hizo en Egipto contra Faraón, contra su gente y todo su país!"
,"12":"¡Qué mano tan poderosa y qué autoridad para obrar estos prodigios a los ojos de todo Israel!"
}`)

}
func ES_LBL_LoadVPEXChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Estos son los nombres de los hijos de Israel que llegaron con Jacob a Egipto, cada uno con su familia:"
,"2":"Rubén, Simeón, Leví, Judá,"
,"3":"Isacar, Zabulón, Benjamín,"
,"4":"Dan, Neftalí, Gad y Aser."
,"5":"El número de estos descendientes de Jacob era de setenta personas. Además José, que estaba ya en Egipto."
,"6":"Murió José, y también sus hermanos y toda aquella generación,"
,"7":"mientras los hijos de Israel seguían siendo muy fecundos. Se multiplicaron y crecieron, llegando a ser tan numerosos que los había en todo el país."
,"8":"Entró a gobernar en Egipto un nuevo rey, que no sabía nada de José, y dijo a su pueblo:"
,"9":"'Miren que los hijos de Israel forman un pueblo más numeroso y fuerte que nosotros."
,"10":"Tomemos precauciones contra él para que no siga multiplicándose, no vaya a suceder, que si estalla una guerra, se una a nuestros enemigos para luchar contra nosotros y escapar del país.'"
,"11":"Les pusieron entonces capataces a los israelitas, para sobrecargarlos con duros trabajos. Edificaron así para Faraón las ciudades de almacenamiento: Pitom y Ramsés."
,"12":"Pero cuanto más los oprimían, tanto más crecían y se multiplicaban, de tal modo que la gente ya no soportaba a los israelitas."
,"13":"Los egipcios trataron con brutalidad a los Israelitas y los redujeron a esclavitud."
,"14":"Les amargaron la vida con duros trabajos de arcilla y ladrillos, con toda clase de labores campesinas y toda clase de servidumbres que les imponían por la fuerza."
,"15":"Luego el rey de Egipto se dirigió a las parteras de las hebreas, una de las cuales se llamaba Sifrá y la otra Púa; les dijo:"
,"16":"'Cuando asistan a las hebreas, y ellas se pongan de cuclillas sobre las dos piedras, fíjense bien: si es niño, háganlo morir; y si es niña, déjenla con vida.'"
,"17":"Pero las parteras temían a Dios, y no hicieron lo que les había mandado el rey de Egipto, sino que dejaron con vida a los niños."
,"18":"Entonces el rey llamó a las parteras y les dijo: '¿Por qué han actuado así, dejando con vida a los niños?'"
,"19":"Las parteras respondieron: 'Es que las mujeres hebreas no son como las egipcias. Son más robustas y dan a luz antes de que llegue la partera.'"
,"20":"Dios estaba con las parteras, así que el pueblo creció y llegó a ser muy fuerte;"
,"21":"y a las parteras, por haber temido a Dios, les concedió numerosa descendencia."
,"22":"Entonces Faraón dio esta orden a todo el pueblo: 'Echen al río a todo niño nacido de los hebreos, pero a las niñas déjenlas con vida.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Un hombre de la tribu de Leví se casó con una niña de su misma tribu."
,"2":"La mujer quedó esperando y dio a luz un hijo, y viendo que era hermoso, lo tuvo escondido durante tres meses."
,"3":"Como no podía ocultarlo por más tiempo, tomó un canasto de papiro, lo recubrió con alquitrán y brea, metió en él al niño y lo puso entre los juncos, a la orilla del río Nilo."
,"4":"La hermana del niño se quedó a cierta distancia para ver lo que le pasaba."
,"5":"En eso bajó la hija de Faraón al Nilo, y se bañó mientras sus sirvientas se paseaban por la orilla del río. Al divisar el canasto entre los juncos, envió a una criada a buscarlo."
,"6":"Lo abrió y vio que era un niño que lloraba. Se compadeció de él y exclamó: '¡Es un niño de los hebreos!'"
,"7":"Entonces la hermana dijo a la hija de Faraón: 'Si quieres, yo buscaré entre las hebreas, y me pondré al habla con una nodriza para que te críe este niño.'"
,"8":"'¡Ve!', le contestó la hija de Faraón."
,"9":"Así que la joven fue y llamó a la madre del niño. La hija de Faraón le dijo: 'Toma este niño y críamelo, que yo te pagaré.' Y la mujer tomó al niñito para criarlo."
,"10":"Habiendo crecido el niño, ella lo llevó a la hija de Faraón, y pasó a ser para ella como su hijo propio. Ella lo llamó Moisés, pues, dijo, 'lo he sacado de las aguas.'"
,"11":"Tiempo después, siendo Moisés ya mayor, se preocupó por sus hermanos y entonces fue cuando comprobó sus penosos trabajos. Le tocó ver cómo un egipcio golpeaba a un hebreo, a uno de sus hermanos."
,"12":"Miró a uno y otro lado, y como no viera a nadie, mató al egipcio y lo escondió en la arena."
,"13":"Al día siguiente salió de nuevo, y esta vez dos hebreos estaban peleando. Moisés dijo al culpable: '¿Por qué le pegas a tu compañero?'"
,"14":"Y él le contestó: '¿Quién te ha puesto de jefe y juez sobre nosotros? ¿Y por qué no me matas como mataste al egipcio?' Moisés tuvo miedo, pues pensó: 'Este asunto ya se sabe.'"
,"15":"De hecho, le llegó la noticia a Faraón y buscó a Moisés para matarlo, pero Moisés huyó de la presencia de Faraón y se fue a vivir al país de Madián. Allí se sentó junto a un pozo."
,"16":"Vinieron una niñas para sacar agua, eran las siete hijas de un sacerdote de Madián. Como llenaran las piletas para dar de beber a las ovejas de su padre,"
,"17":"llegaron unos pastores y las echaron. Entonces Moisés salió en su defensa, y dio de beber al rebaño."
,"18":"Al volver ellas donde su padre Ragüel, éste les dijo: '¿Cómo es que hoy han venido tan pronto?'"
,"19":"Ellas contestaron: 'Un egipcio nos ha defendido de los pastores y además nos sacó agua y dio de beber al rebaño.'"
,"20":"Ragüel preguntó: '¿Y dónde está? ¿Por qué no han traído aquí a ese hombre? Díganle que venga a comer.'"
,"21":"Moisés aceptó quedarse con aquel hombre, quien le dio por esposa a su hija Séfora."
,"22":"Y como diera a luz un hijo, Moisés lo llamó Guersón, pues dijo: Soy forastero en tierra extraña."
,"23":"Durante este largo período murió el rey de Egipto. El pueblo de Israel sufría bajo la esclavitud. Gritaban, y su grito subía desde los lugares de trabajo hasta Dios."
,"24":"Oyó Dios sus lamentos, y se acordó de su alianza con Abraham, Isaac y Jacob."
,"25":"Y miró Dios con bondad a los hijos de Israel, y los atendió."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Moisés cuidaba las ovejas de Jetró, su suegro, sacerdote de Madián. Una vez llevó las ovejas muy lejos en el desierto y llegó al cerro de Horeb, esto es, el Cerro de Dios."
,"2":"Entonces fue cuando el Angel de Yavé se presentó a él, como una llama ardiente en medio de una zarza. Moisés estuvo observando: la zarza ardía, pero no se consumía."
,"3":"Y se dijo: 'Voy a dar una vuelta para mirar esta cosa tan extraordinaria: ¿ por qué la zarza no se consume?'"
,"4":"Yavé vio que Moisés se acercaba para mirar; Dios lo llamó de en medio de la zarza: '¡Moisés, Moisés!', y él respondió: 'Aquí estoy.'"
,"5":"Yavé le dijo: 'No te acerques más. Sácate tus sandalias porque el lugar que pisas es tierra sagrada.'"
,"6":"Luego le dijo: 'Yo soy el Dios de tus padres, el Dios de Abrahán, el Dios de Isaac y el Dios de Jacob.' Al instante Moisés se tapó la cara, porque tuvo miedo de que su mirada se fijara sobre Dios."
,"7":"Yavé dijo: 'He visto la humillación de mi pueblo en Egipto, y he escuchado sus gritos cuando lo maltrataban sus mayordomos. Yo conozco sus sufrimientos,"
,"8":"y por esta razón estoy bajando, para librarlo del poder de los egipcios y para hacerlo subir de aquí a un país grande y fértil, a una tierra que mana leche y miel, al territorio de los cananeos, de los heteos, de los amorreos, los fereceos, los jeveos y los jebuseos."
,"9":"El clamor de los hijos de Israel ha llegado hasta mí y he visto cómo los egipcios los oprimen."
,"10":"Ve, pues, yo te envío a Faraón para que saques de Egipto a mi pueblo, los hijos de Israel.'"
,"11":"Moisés dijo a Dios: '¿Quién soy yo para ir donde Faraón y sacar de Egipto a los israelitas?'"
,"12":"Dios respondió: 'Yo estoy contigo, y ésta será para ti la señal de que yo te he enviado: Cuando hayas sacado al pueblo de Egipto, ustedes vendrán a este cerro y me darán culto aquí.'"
,"13":"Moisés contestó a Dios: 'Si voy a los hijos de Israel y les digo que el Dios de sus padres me envía a ellos, si me preguntan: ¿Cuál es su nombre?, yo ¿qué les voy a responder?'"
,"14":"Dios dijo a Moisés: 'Yo soy: YO-SOY.' 'Así hablarás al pueblo de Israel: YO-SOY me ha enviado a ustedes."
,"15":"Y también les dirás: YAVE, el Dios de sus padres, el Dios de Abrahán, el Dios de Isaac y el Dios de Jacob, me ha enviado. Este será mi nombre para siempre, y con este nombre me invocarán de generación en generación.'"
,"16":"Ve y reúne a los jefes de Israel, y les dirás: 'Yavé, el Dios de sus padres, se me apareció; el Dios de Abrahán, de Isaac y de Jacob me ha dicho: Ahora voy a pedir cuentas por todo lo que a ustedes les está pasando en Egipto."
,"17":"He decidido sacarlos de esta opresión en Egipto y trasladarlos a una tierra que mana leche y miel, al país de los cananeos, de los heteos, de los amorreos, los fereceos, los jeveos y los jebuseos."
,"18":"Los jefes de Israel te harán caso y, con ellos te presentarás al rey de Egipto. Tú le dirás: El Dios de los hebreos, Yavé, nos salió al encuentro: deja que caminemos tres días por el desierto, para ofrecer sacrificios a Yavé, nuestro Dios."
,"19":"Yo ya sé que el rey de los egipcios no los dejará ir, si no es obligado por la fuerza."
,"20":"Por esto yo extenderé mi mano y azotaré a Egipto con toda clase de males extraordinarios, de manera que él mismo los echará fuera."
,"21":"Yo moveré a los egipcios para que traten bien a mi gente, y al salir no se irán con las manos vacías."
,"22":"Cada mujer pida a su vecina o a la persona que comparte su casa objetos de plata y oro y también vestidos; sus hijos e hijas se los pondrán, y así dejarán sin nada a los egipcios.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Moisés respondió a Yavé: 'No me van a creer, ni querrán escucharme, sino que dirán: ¡Cómo que se te ha aparecido Yavé!'"
,"2":"Entonces Yavé le dijo: '¿Qué es lo que tienes en la mano?' 'Un bastón', le respondió él."
,"3":"Dijo Yavé: 'Tíralo al suelo.' Lo tiró al suelo, y se convirtió en una serpiente: Moisés dio un salto atrás."
,"4":"Yavé entonces le dijo: '¡Tómala por la cola con tu mano!' Moisés la agarró, y volvió a ser un bastón en su mano."
,"5":"'Con esto -le dijo Yavé- podrán creer que se te ha aparecido el Dios de sus padres, el Dios de Abrahán, el Dios de Isaac y de Jacob.'"
,"6":"Otra vez Yavé le dijo: 'Mete la mano en tu pecho.' Lo hizo, y la sacó cubierta de lepra, blanca como la nieve."
,"7":"'Vuelve a meter tu mano en el pecho.' Lo hizo y, al sacarla, su mano estaba tan sana como el resto de su cuerpo."
,"8":"'Si no te creen -le dijo Yavé- y no los convence el primer prodigio, te creerán con el segundo."
,"9":"Y si no creen todavía con los dos prodigios y no te hacen caso, toma agua del río y derrámala; en cuanto toque el suelo, el agua del río se convertirá en sangre.'"
,"10":"Moisés dijo a Yavé: 'Mira, Señor, que yo nunca he tenido facilidad para hablar, y no me ha ido mejor desde que hablas a tu servidor: mi boca y mi lengua no me obedecen.'"
,"11":"Le respondió Yavé: '¿Quién ha dado la boca al hombre? ¿Quién hace que uno hable y otro no?"
,"12":"¿Quién hace que uno vea y que el otro sea ciego o sordo? ¿No soy yo, Yavé?"
,"13":"Anda ya, que yo estaré en tu boca y te enseñaré lo que has de hablar.'"
,"14":"Pero él insistió: 'Por favor, Señor, ¿por qué no mandas a otro?' Esta vez Yavé se enojó con Moisés y le dijo: '¿No tienes a tu hermano Aarón, el levita? Bien sé yo que a él no le faltan las palabras."
,"15":"Y precisamente ha salido de viaje en busca tuya y, al verte, se alegrará mucho. Tú le hablarás y se lo enseñarás de memoria,"
,"16":"y yo les enseñaré todo lo que han de hacer, pues estaré en tu boca cuando tú le hables, y en la suya cuando él lo transmita."
,"17":"Aarón hablará por ti igual que un profeta habla por su Dios, y tú, con este bastón en la mano, harás milagros.'"
,"18":"Yavé dijo a Moisés, en el país de Madián: 'Regresa a Egipto, pues ya murieron los que querían tu muerte.'"
,"19":"Moisés, pues, volvió a casa de su suegro Jetró y le dijo: 'Yo quisiera irme donde mis hermanos, en Egipto, para saber si están vivos todavía.' Jetró le respondió: 'Que te vaya bien.'"
,"20":"Tomó Moisés a su esposa y a sus hijos. Los hizo montar en un burro y partió para Egipto, llevando en la mano el bastón divino."
,"21":"Yavé le dijo, asimismo: 'Cuando regreses a Egipto, harás delante de Faraón todos los prodigios para los cuales te he dado poder. Pero yo haré que se ponga porfiado y no dejará partir a mi pueblo."
,"22":"Tú entonces le dirás: Esto dice Yavé: Israel es mi hijo primogénito."
,"23":"Ya te dije: Deja partir a mi hijo, para que me rinda culto. Pero tú no lo has dejado que salga, y yo voy a quitar la vida a tu hijo primogénito.'"
,"24":"Cuando Moisés iba de camino, el Angel de Yavé se le presentó en el lugar donde pasaba la noche, con intención de quitarle la vida."
,"25":"Tomó entonces Séfora un cuchillo de piedra y, cortando el prepucio de su hijo, tocó él los pies de Moisés. Luego dijo: 'Tú eres para mí un esposo de sangre.'"
,"26":"El Angel lo dejó. Ella había dicho estas palabras, 'esposo de sangre', a causa de la circuncisión."
,"27":"Mientras tanto, Yavé había dicho a Aarón: 'Sal al encuentro de Moisés, en el desierto.' Así que partió Aarón, lo encontró en el Monte de Dios y lo besó."
,"28":"Moisés contó a Aarón todas las palabras que Yavé le había dirigido y los prodigios que le había enseñado."
,"29":"Moisés y Aarón, pues, partieron juntos a Egipto, donde reunieron a todos los jefes de los hijos de Israel."
,"30":"Aarón les comunicó todo lo que Yavé había dicho a su hermano Moisés; y éste hizo los prodigios delante de todo el pueblo."
,"31":"El pueblo creyó; comprendieron que Yavé había visto sus humillaciones y venía a visitar a los hijos de Israel. Postrados en tierra, adoraron."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Después de eso Moisés y Aarón fueron a decir a Faraón: 'Así dice Yavé, el Dios de Israel: Deja que mi pueblo salga al desierto para celebrar mi fiesta.'"
,"2":"Respondió Faraón: '¿Quién es Yavé para que yo le haga caso y deje salir a Israel? No conozco a Yavé y no dejaré salir a Israel.'"
,"3":"Ellos dijeron: 'El Dios de los hebreos nos ha salido al encuentro. Permite que vayamos al desierto a tres días de camino. Allá ofreceremos sacrificios a Yavé, nuestro Dios, no sea que nos castigue con peste o espada.'"
,"4":"El rey de Egipto les dijo: 'Ustedes, Moisés y Aarón, ¿por qué ponen trabas a los que trabajan? Vuelvan a sus tareas.'"
,"5":"Faraón añadió: 'Este pueblo ahora es más numeroso que la gente del país y ¿ustedes quieren que interrumpa sus trabajos?'"
,"6":"Aquel mismo día Faraón dio la siguiente orden a los capataces del pueblo y a sus secretarios israelitas:"
,"7":"'Ya no darán paja al pueblo para hacer ladrillos, como lo hacían antes. Que vayan ellos mismos a recoger la paja."
,"8":"Pero les exigirán la misma cantidad de ladrillos que hacían antes, sin disminuir ni uno solo. Son unos flojos, y por eso vienen aquí con sus gritos: ¡Déjanos salir! ¡Tenemos que sacrificar a nuestro Dios!"
,"9":"Denles más trabajo y que no flojeen, y ya no se prestaran para estas tonterías.'"
,"10":"Los capataces, pues, junto con sus secretarios israelitas, empezaron a apurar al pueblo: 'Así dice Faraón: No les daremos más paja."
,"11":"Vayan ustedes mismos a buscarla donde la encuentren. Pero la producción tendrá que ser la misma de antes.'"
,"12":"El pueblo recorría todo el país de Egipto en busca de paja para machacar."
,"13":"Tenían encima a sus capataces que les decían: 'Cumplan su tarea, la misma cantidad diaria que cuando se les daba paja.'"
,"14":"Los secretarios israelitas que se habían colocado al frente del pueblo fueron castigados, pues se les dijo: '¿Por qué ni ayer ni hoy han respetado las normas sobre la cantidad de ladrillos? Debía ser la misma de antes.'"
,"15":"Los secretarios israelitas fueron a quejarse a Faraón y le dijeron: '¿Por qué tratas así a tus siervos?"
,"16":"No nos dan paja y nos piden ladrillos. Los tuyos no tienen por qué azotarnos.'"
,"17":"El respondió: '¡Flojos y más que flojos! Por esa razón me piden ir a sacrificar a Yavé."
,"18":"Vuelvan a sus trabajos. No se les dará paja, y tendrán que entregar la cantidad de ladrillos.'"
,"19":"Los secretarios israelitas, pues, tuvieron que enfrentarse con el pueblo y decirle: No se les quitará nada de la cantidad diaria."
,"20":"Al salir de la casa de Faraón se encontraron con Moisés y Aarón, que los esperaban,"
,"21":"y les dijeron: 'Que Yavé examine y juzgue. Por culpa de ustedes Faraón y sus capataces nos han tomado odio. Ustedes han puesto la espada en sus manos para matarnos.'"
,"22":"Se volvió entonces Moisés hacia Yavé y dijo: 'Señor mío, ¿por qué maltratas a tu pueblo?, ¿por qué me has enviado?"
,"23":"Pues desde que fui donde Faraón y le hablé en tu nombre, está maltratando a tu pueblo, y Tú no haces nada para librarlo.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Yavé respondió a Moisés: 'Ahora verás lo que voy a hacer con Faraón. Yo seré más fuerte que él, y no sólo los dejará partir, sino que él mismo los echará de su tierra.'"
,"2":"Dios habló a Moisés, le dijo: '¡Yo soy Yavé!"
,"3":"Me di a conocer a Abrahán, a Isaac y a Jacob como Dios de las Alturas, pues no quise revelarles este nombre mío: Yavé."
,"4":"También pacté mi alianza con ellos para darles la tierra de Canaán, la tierra en donde estuvieron como peregrinos."
,"5":"Ahora me acuerdo de mi alianza al oír los gemidos de los hijos de Israel oprimidos por los egipcios."
,"6":"Por lo tanto, diles de mi parte: Yo soy Yavé, que quitaré de sus espaldas los duros trabajos de Egipto y los liberaré de la esclavitud. Yo les devolveré la libertad con golpes tremendos de mi mano y con intervenciones manifiestas."
,"7":"A ustedes los tomaré para pueblo mío, y seré Dios para ustedes. Y, en adelante, conocerán que yo soy Yavé, Dios de ustedes, que quité de sus espaldas el yugo de Egipto."
,"8":"Yo los introduciré en la tierra que con juramento prometí darles a Abrahán, a Isaac y a Jacob; y se la daré como herencia, pues yo soy Yavé.'"
,"9":"Así habló Moisés a los hijos de Israel, pero no le hicieron caso, porque estaban desanimados y agobiados por sus duras labores."
,"10":"Yavé habló a Moisés: 'Ve a hablar a Faraón, rey de Egipto,"
,"11":"y dile que deje salir de su país a los hijos de Israel.'"
,"12":"Pero Moisés contestó: 'Si los hijos de Israel no me hacen caso, ¿cómo me escuchará Faraón? Y eso que me cuesta expresarme.'"
,"13":"Eso no obstante, Yavé habló con Moisés y Aarón y los mandó donde los hijos de Israel, y también donde Faraón, para sacar a su pueblo del país de Egipto."
,"14":"Estos son los jefes de las tribus: Hijos de Rubén, primogénito de Israel: Janoc y Falu, Jesrón y Carmi. Estas son las familias descendientes de Rubén."
,"15":"Hijos de Simeón: Jamuel, Jasmín, Ahod y Jaguen, Sojar y Saúl, hijo de una cananea. Estas son las familias de Simeón."
,"16":"Estos son los hijos de Leví: Guersón, Quehat y Merari. Leví vivió ciento treinta y siete años."
,"17":"Hijos de Guersón: Lobni y Semeí con sus descendientes."
,"18":"Hijos de Quehat: Amram y Jishar, Hebrón y Oziel. Quehat vivió ciento treinta y tres años."
,"19":"Hijos de Merari: Majli y Musi. Estos son los descendientes de Leví según sus familias."
,"20":"Amram se casó con su tía Jocabed, la cual le dio dos hijos: Aarón y Moisés. Amram vivió ciento treinta y siete años."
,"21":"Los hijos de Jishar fueron: Coré, Nefeg y Zicrí."
,"22":"Los de Oziel: Misael, Elisafán y Sitri."
,"23":"Aarón se casó con Elisabet, hija de Aminadab, hermana de Najasón, de la que tuvo cuatro hijos: Nadab, Abihú, Eleazar e Itamar."
,"24":"Los hijos de Coré: Aser, Elcana y Abiasat. Estas son las familias de los coreítas."
,"25":"Eleazar, hijo de Aarón, se casó con una de las hijas de Futiel, con quien tuvo un hijo: Finjas. Estos son los jefes de las familias levitas, según sus familias."
,"26":"Estos son Aarón y Moisés, a los que se dirigió Yavé para sacar a los hijos de Israel de Egipto, ordenados como un ejército."
,"27":"Estos son los que hablaron a Faraón, rey de Egipto, para sacar de Egipto a los hijos de Israel. Estos son Moisés y Aarón."
,"28":"El día que Yavé habló a Moisés en el país de Egipto,"
,"29":"le dijo: 'Yo soy Yavé; dile a Faraón todas las cosas que yo te mande.'"
,"30":"A lo cual respondió Moisés: '¿Cómo me escuchará Faraón, siendo yo tan malo para hablar?'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Yavé dijo a Moisés: 'Mira lo que hago: vas a ser como un dios para Faraón, y Aarón, tu hermano, será tu profeta."
,"2":"Tú le dirás todo lo que yo te mande y Aarón, tu hermano, hablará a Faraón para que deje salir de su país a los hijos de Israel."
,"3":"Sin embargo, haré que se mantenga en su negativa y, por más que yo multiplique mis prodigios y milagros a costa de Egipto,"
,"4":"él no te hará caso. Yo, entonces, sacaré a mi pueblo del país de Egipto, a fuerza de golpes y de grandes intervenciones."
,"5":"Así entenderán los egipcios que yo soy Yavé, cuando vean los golpes que les daré para sacar de su país a los hijos de Israel.'"
,"6":"Moisés y Aarón hicieron tal cual Yavé les había mandado."
,"7":"Moisés tenía ochenta años y Aarón ochenta y tres cuando hablaron con Faraón."
,"8":"Yavé advirtió a Moisés y a Aarón: 'Si Faraón les pide algún signo o milagro,"
,"9":"tú dirás a Aarón que tome su bastón y lo lance delante de Faraón, y se cambiará en serpiente.'"
,"10":"Se presentaron Moisés y Aarón a Faraón, hicieron lo que Yavé les había ordenado, y, al echar el bastón delante de Faraón y de sus ministros, éste se convirtió en serpiente."
,"11":"Faraón entonces llamó a sus sabios y brujos, los cuales hicieron algo semejante con sus fórmulas secretas;"
,"12":"arrojando todos ellos sus bastones, también se convirtieron en serpientes; pero el bastón de Aarón devoró a los de ellos."
,"13":"Eso no obstante, Faraón se puso más duro y no escuchó a Moisés y a Aarón, como Yavé le había predicho."
,"14":"Yavé dijo a Moisés: 'Faraón porfía en negarse a que salga el pueblo."
,"15":"Ve a encontrarlo en la mañana, a la hora en que vaya a bañarse. Lo esperarás a la orilla del río, llevando en tu mano el bastón que se convirtió en serpiente."
,"16":"Le dirás esto: 'Yavé, el Dios de los hebreos, me ha mandado decirte que dejes salir a su pueblo, para que le rinda culto en el desierto. Pero hasta ahora no has escuchado."
,"17":"Ahora, pues, Yavé dice: En esto conocerás que yo soy Yavé: voy a golpear el Nilo con mi bastón y las aguas se convertirán en sangre."
,"18":"Los peces morirán, el río apestará y los egipcios tendrán asco de beber sus aguas.'"
,"19":"Yavé dijo a Moisés: 'Di a Aarón: toma tu bastón y extiende tu mano sobre las aguas de los egipcios, sobre su río, sus canales, sus estanques, y sobre todos sus depósitos de aguas, y éstas se convertirán en sangre. Habrá sangre en toda la tierra de Egipto, hasta en las vasijas, tanto de madera como de piedra.'"
,"20":"Moisés y Aarón hicieron lo que Yavé les había mandado. Aarón levantó su bastón y golpeó las aguas en presencia de Faraón y de su gente, y todas las aguas del Nilo se convirtieron en sangre. "
,"21":"Los peces del río murieron y el río quedó contaminado, de tal manera que los egipcios no pudieron beber más agua del Nilo. Y hubo sangre en todo el país de Egipto. "
,"22":"Los brujos egipcios hicieron cosas semejantes con sus fórmulas secretas y Faraón se puso más porfiado todavía. Como Yavé lo había dicho, se negó a escuchar a Moisés y Aarón."
,"23":"Faraón volvió a su casa como si no hubiera ocurrido nada importante."
,"24":"Pero, mientras tanto, los egipcios tuvieron que cavar pozos en los alrededores del río en busca de agua potable, porque no podían beber del río."
,"25":"Cuando ya habían transcurrido siete días después de que Yavé golpeó el río,"
,"26":"Yavé dijo a Moisés: 'Preséntate a Faraón y dile de parte de Yavé: Deja salir a mi pueblo para que me rinda culto."
,"27":"Si te niegas a dejarlos salir, castigaré a tu país con plaga de ranas."
,"28":"El río pululará de ranas, que subirán y penetrarán en tu casa, en tu dormitorio, en tu cama, en la casa de tus servidores y de tu pueblo, en tus hornos y en tus provisiones."
,"29":"Las ranas subirán contra ti, contra tu pueblo y contra todos tus servidores.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Yavé dijo a Moisés: 'Dile a Aarón que extienda el bastón que tiene en su mano hacia los ríos, los esteros y las lagunas de Egipto, para que salgan ranas por todo el país de Egipto.'"
,"2":"Así lo hizo Aarón, y salieron tantas ranas que cubrieron todo el país de Egipto."
,"3":"Los brujos de Egipto hicieron lo mismo, y también hicieron salir ranas por todo Egipto."
,"4":"Entonces llamó Faraón a Moisés y a Aarón y les dijo: 'Pidan a Yavé que aleje de mí y de mi país estas ranas, y yo dejaré que su pueblo salga para ofrecer sacrificios a Yavé.'"
,"5":"Moisés le contestó: 'Indícame, por favor, cuándo tendré que rogar por ti, por tus servidores y tu pueblo, para que se alejen las ranas y que solamente haya en el Nilo.'"
,"6":"Faraón respondió: 'Mañana.' 'Bien dijo Moisés-, lo haré como tú pides, para que sepas que no hay nadie como Yavé, nuestro Dios."
,"7":"Se alejarán las ranas de ti, de tus casas, de tu gente y de tu pueblo, y sólo quedarán en el río.'"
,"8":"Dicho esto, se fueron Moisés y Aarón. Moisés llamó a Yavé por el asunto de las ranas, ya que se había comprometido con Faraón,"
,"9":"y Yavé cumplió la promesa de Moisés: todas las ranas salieron de las casas, de las granjas y de los campos, y murieron."
,"10":"Las juntaron en inmensos montones, quedando el país apestado de mal olor."
,"11":"Faraón, sin embargo, al ver que se le daba alivio, se puso más porfiado; no quiso escuchar a Moisés y a Aarón, tal como Yavé les había dicho."
,"12":"Nuevamente habló Yavé a Moisés: 'Di a Aarón que golpee con su bastón el polvo de la tierra, y saldrán mosquitos por todo el país.'"
,"13":"Así lo hizo Aarón; golpeó el polvo de la tierra, que se volvió mosquitos, persiguiendo a hombres y animales. Todo el polvo de la tierra se volvió mosquitos por todo el país de Egipto."
,"14":"Los brujos de Egipto intervinieron también esta vez, y trataron de echar fuera a los mosquitos por medio de sus fórmulas secretas, pero no lo pudieron, de manera que los mosquitos siguieron persiguiendo a hombres y animales."
,"15":"Entonces los brujos dijeron a Faraón: 'Aquí está el dedo de Dios.' Pero Faraón se puso más porfiado y no quiso hacerles caso, tal como Yavé lo había dicho anteriormente."
,"16":"De nuevo Yavé dijo a Moisés: 'Levántate temprano, preséntate a Faraón cuando vaya al río, y dile: Esto dice Yavé: Deja salir a mi pueblo para que me ofrezca sacrificios."
,"17":"Si tú no lo envías, enviaré yo tábanos contra ti, tus servidores y tu pueblo; e invadirán las habitaciones de los egipcios y todos los lugares donde viven."
,"18":"Pondré a salvo, sin embargo, la región de Gosén, porque mi pueblo vive en ella; allí no habrá tábanos, a fin de que entiendas que yo, Yavé, estoy en aquella tierra."
,"19":"Yo haré distinción entre mi pueblo y el tuyo, y esto sucederá mañana.'"
,"20":"Y así lo hizo Yavé. Densas nubes de tábanos invadieron la casa de Faraón y las de toda su gente en toda la tierra de Egipto. El país quedó infestado de ellos."
,"21":"Entonces Faraón mandó llamar a Moisés y a Aarón para decirles: 'Vayan a ofrecer sacrificios a Yavé, pero háganlo en este país.'"
,"22":"Moisés le contestó: 'Esto no se puede, porque los egipcios no toleran estos sacrificios que ofrecemos a Yavé, nuestro Dios. Si le sacrificamos estos animales delante de ellos, nos tirarán piedras."
,"23":"Así que caminaremos tres días por el desierto y, allí, ofreceremos el sacrificio a nuestro Dios, de la manera que él nos ordene.'"
,"24":"Faraón respondió: 'Yo los dejaré ir a ofrecer sacrificios a su Dios en el desierto con la condición de que no vayan muy lejos. Pero ustedes rueguen por mí.'"
,"25":"Moisés le dijo: 'En cuanto salga, rogaré a Yavé por ti y, mañana, los tábanos se alejarán de ti, de tus servidores y de tu pueblo, pero no nos vayas a engañar después y te niegues a que salgamos al desierto.'"
,"26":"Apenas salió Moisés de la casa de Faraón, rogó a Yavé,"
,"27":"y Yavé cumplió la promesa de Moisés: liberó de los tábanos a Faraón, a sus servidores y su pueblo, sin que quedara uno solo."
,"28":"Pero Faraón se puso porfiado una vez más y se negó a que Israel saliera de su país."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Yavé dijo a Moisés: 'Anda donde Faraón y dile: Esto dice Yavé, el Dios de los hebreos: Deja salir a mi pueblo para que me rinda culto."
,"2":"Si te niegas otra vez y te pones duro con ellos,"
,"3":"volveré mi mano contra los animales de tus campos, de manera que habrá una mortandad tremenda de los caballos, de los burros, de los camellos, de las vacas y ovejas."
,"4":"También haré distinción entre el ganado de los egipcios y el de mi pueblo, de manera que no se perderá nada de lo que pertenece a los hijos de Israel.'"
,"5":"Yavé fijó el plazo, dijo: 'Esto lo hará Yavé mañana por todo el país.'"
,"6":"Y Yavé lo hizo al día siguiente: murieron todos los animales pertenecientes a los egipcios, mientras que no murió ni uno siquiera de los que pertenecían a los israelitas."
,"7":"Faraón se informó al respecto: ¡ninguno había muerto de los que pertenecían a Israel! Pero siguió en su ceguera y no dejó salir al pueblo."
,"8":"Entonces Yavé dijo a Moisés y a Aarón:"
,"9":"'Tomen unos puñados de cenizas, que Moisés tirará hacia el cielo en presencia de Faraón. El polvo se esparcirá por todo el territorio de Egipto, provocando úlceras y tumores en hombres y animales por todo el país de Egipto.'"
,"10":"Tomaron, pues, cenizas de un horno, se presentaron a Faraón, y Moisés las lanzó hacia el cielo. Luego aparecieron úlceras y tumores infecciosos en hombres y animales."
,"11":"Esta vez los brujos no pudieron presentarse delante de Faraón, pues tenían úlceras, como todos los demás egipcios."
,"12":"Pero Yavé mantuvo a Faraón en su ceguera, y éste no quiso escuchar a Moisés y a Aarón, tal como él lo había advertido."
,"13":"De nuevo Yavé dijo a Moisés: 'Levántate temprano, preséntate a Faraón y dile: Esto dice Yavé, Dios de los hebreos: Deja salir a mi pueblo para que me rinda culto."
,"14":"Porque esta vez enviaré todas mis plagas sobre ti, tus servidores y tu pueblo, para que entiendas de una vez que no hay nadie como yo en toda la tierra."
,"15":"Yo podría haber vuelto mi mano contra ti y tu pueblo, y habrían perdido la vida con semejante peste."
,"16":"Pero no, preferí mantenerte de pie, para que veas mi fuerza y para que se celebre mi Nombre por toda la tierra."
,"17":"¿Y todavía te opones a que salga mi pueblo?"
,"18":"Pues bien, mañana a esta misma hora, haré llover una granizada tan fuerte como no ha habido otra en Egipto desde el día en que fue fundado hasta hoy."
,"19":"Desde ahora, pues, manda recoger tu ganado y todo lo que tengas en el campo, porque el granizo caerá sobre todos los hombres y animales que se hallen fuera, y cuantos pille al descubierto perecerán.'"
,"20":"Aquellos servidores de Faraón que creyeron en la palabra de Yavé pusieron bajo techo a su gente y su ganado,"
,"21":"pero aquellos que no hicieron caso a la palabra de Yavé los dejaron en el campo."
,"22":"Yavé, pues, dijo a Moisés: 'Extiende tu mano hacia el cielo, para que caiga el granizo en toda la tierra de Egipto sobre hombres, ganados y sembrados.'"
,"23":"Así lo hizo Moisés. Extendió su bastón hacia el cielo, y Yavé mandó truenos y granizos, e hizo caer fuego sobre la tierra. Yavé hizo llover granizos sobre el país de Egipto."
,"24":"Caía el granizo y, junto a él, caía fuego; cayó tan fuerte como jamás se había visto desde que se fundó aquel país."
,"25":"El granizo dañó todo cuanto había en el campo, en todo el país de Egipto, desde los hombres hasta los animales; el granizo echó a perder todas las verduras del campo y aun quebró todos los árboles del campo."
,"26":"Pero no hubo granizada en la tierra de Gosén donde habitaban los israelitas."
,"27":"Por fin, Faraón mandó llamar a Moisés y a Aarón y les dijo: '¡Ahora sí que tengo la culpa! Yavé es el justo; yo y mi pueblo somos los culpables."
,"28":"Pidan a Yavé que cesen esos truenos tremendos y esa granizada, y ya no los detendré sino que los dejaré que se vayan.'"
,"29":"Moisés le respondió: 'En cuanto salga de tu presencia extenderé mis manos hacia Yavé, y cesarán los truenos y no caerá más granizo; con eso comprenderás que Yavé es dueño de la tierra."
,"30":"Pero yo sé que ni tú ni tus ministros querrán todavía obedecer a Dios.'"
,"31":"El lino y la cebada se perdieron: la cebada estaba espigada y el lino granaba;"
,"32":"pero el trigo y la escanda no fueron destruidos, por ser tardíos."
,"33":"En cuanto Moisés entró en la ciudad, volviendo de la casa de Faraón, alzó sus brazos hacia Yavé; y cesaron los truenos y el granizo y no cayó más lluvia sobre la tierra."
,"34":"Pero, al ver Faraón que habían cesado la lluvia y el granizo, volvió a pecar,"
,"35":"pues siguió negándose a que salieran los hijos de Israel, tal como Yavé lo había dicho."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Yavé dijo a Moisés: 'Ve donde Faraón, porque he endurecido su corazón y el de sus ministros con el fin de realizar mis prodigios en medio de ellos."
,"2":"Así podrás contar a tus hijos y a tus nietos cuántas veces he destrozado a los egipcios y cuántos prodigios he obrado contra ellos; así conocerán ustedes que yo soy Yavé.'"
,"3":"Moisés y Aarón fueron al palacio de Faraón, al que le dijeron: 'Esto dice Yavé, Dios de los hebreos: ¿Hasta cuándo te negarás a humillarte ante mí? Deja que mi pueblo salga para ofrecerme sacrificios."
,"4":"En caso contrario, si te niegas a que salgan, mañana mandaré langostas a tu país."
,"5":"Cubrirán toda la superficie del país, de suerte que ya no se vea la tierra, y devorarán todo lo que a ustedes les queda, todo lo que no destrozó el granizo; y además roerán todos los árboles que tienen en el campo."
,"6":"Llenarán tu casa, las de tus ministros y las de todo tu pueblo, en tal cantidad como no vieron tus padres ni los padres de tus padres, desde los más antiguos hasta el día de hoy.' Dicho esto, volvió las espaldas y dejó a Faraón."
,"7":"Los servidores de Faraón le dijeron: '¿Hasta cuándo va a ser nuestra ruina este hombre? Deja salir a esa gente para que ofrezca sacrificios a su Dios. ¿No te das cuenta cómo está arruinado el país?'"
,"8":"Así que llamaron a Moisés y a Aarón ante Faraón, el cual les dijo: 'Vayan y ofrezcan sacrificios a Yavé, el Dios de ustedes. Mas ¿quiénes van a ir?'"
,"9":"Respondió Moisés: 'Saldremos con nuestros niños y ancianos, hijos e hijas, con nuestras ovejas y nuestros vacunos, porque para nosotros es la fiesta de Yavé.'"
,"10":"Faraón replicó: '¡Que Yavé los ayude! ¡Espérense que los voy a dejar partir con sus niños! ¡Se ve cuáles son sus malas intenciones!"
,"11":"De ninguna manera. Son los hombres los que irán para rendir culto a Yavé, si eso es lo que buscan.',En seguida fueron echados de la presencia de Faraón."
,"12":"Yavé, entonces, dijo a Moisés: 'Extiende tu mano sobre la tierra de Egipto para que venga la langosta y devore toda la hierba del campo, todo lo que quedó después del granizo.'"
,"13":"Al extender Moisés su bastón sobre el país de Egipto, Yavé hizo que un viento del oriente soplara todo aquel día y aquella noche. Al amanecer, el viento del oriente había traído la langosta."
,"14":"Invadieron Egipto y se desparramaron por todas las tierras en tal cantidad que nunca se habían visto tantas, ni jamás volverán a verse. Ocultaron la luz del sol y cubrieron todas las tierras;"
,"15":"devoraron toda la hierba del campo, y todos los frutos de los árboles que el granizo había dejado fueron devorados; no quedó nada verde en todo Egipto, ni de los árboles, ni de la hierba del campo."
,"16":"Inmediatamente Faraón llamó a Moisés y a Aarón. Les dijo: 'He pecado contra Yavé, el Dios de ustedes, y contra ustedes."
,"17":"Ahora perdónenme mi pecado esta última vez, e intercedan por mí ante Dios para que aparte de nosotros esta plaga.'"
,"18":"En vista de esto, apenas salió Moisés de la presencia de Faraón, rogó a Yavé,"
,"19":"el cual hizo soplar un viento muy fuerte del mar, que arrastró todas las langostas hasta el mar Rojo. Ni una sola quedó en todo el territorio de Egipto."
,"20":"Pero Yavé hizo que Faraón continuara en su porfía y no dejara salir a Israel."
,"21":"Yavé dijo a Moisés: 'Extiende tu mano hacia el cielo y cubrirán las tinieblas el país de Egipto, tan densas que la gente caminará a tientas.'"
,"22":"Así lo hizo Moisés, y al instante densas tinieblas cubrieron Egipto por espacio de tres días."
,"23":"No podían verse unos a otros, ni nadie pudo moverse durante los tres días; pero había luz para los hijos de Israel en todos sus poblados."
,"24":"Faraón llamó a Moisés y le dijo: 'Salgan ustedes a rendir culto a Yavé, pero que se queden sus ovejas y sus vacunos. Ustedes llevarán a sus niños.'"
,"25":"Moisés le respondió: '¿Y tú mismo nos proporcionarás animales para los sacrificios y holocaustos?"
,"26":"También nuestros animales estarán con nosotros, hasta la última uña, pues sacamos de entre ellos lo que sacrificamos a Yavé, nuestro Dios,"
,"27":"y ni siquiera sabemos cuáles animales hemos de ofrecer hasta que lleguemos al lugar.'"
,"28":"Faraón dijo a Moisés: 'Retírate de mi presencia y ya no vuelvas; si te presentas otra vez, será para morir.'"
,"29":"Y Moisés respondió: 'Así será como tú dices: ya no me presentaré delante de ti.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Yavé dijo a Moisés: 'No mandaré más que esta última plaga sobre Faraón y sobre su pueblo. Después dejará que salgan, o más bien él mismo los echará fuera a todos ustedes."
,"2":"No olvides de decir a todo mi pueblo que cada uno pida a su amigo, y cada mujer a su vecina, objetos de oro y plata.'"
,"3":"Yavé hizo que los egipcios acogieran esta petición; además, Moisés era un personaje en todo Egipto, y lo consideraban tanto los ministros como la gente del pueblo."
,"4":"Moisés dijo: 'Esto dice Yavé: A media noche saldré a recorrer Egipto"
,"5":"y en Egipto morirán todos los primogénitos, desde el primogénito de Faraón que se sienta en el trono, hasta el de la esclava que mueve la piedra del molino, y todos los primeros nacidos de los animales."
,"6":"Y se escuchará un clamor tan grande en todo Egipto como nunca lo hubo ni lo habrá jamás."
,"7":"Pero entre los hijos de Israel, ni siquiera un perro llorará por la muerte de un hombre o por la muerte de animales, y ustedes sabrán que Yavé hace distinción entre egipcios e israelitas."
,"8":"Todos tus ministros vendrán a mí, se postrarán delante de mí y me pedirán por favor que nos vayamos, yo y todo el pueblo de Israel. Después de esto, nos iremos.',Moisés volvió muy enojado de la presencia de Faraón."
,"9":"Yavé dijo a Moisés: 'A ustedes no los escuchará Faraón, y gracias a esto serán todavía mayores mis prodigios en la tierra de Egipto.'"
,"10":"Pues, mientras Moisés y Aarón obraban todos estos prodigios delante de Faraón, Yavé lo mantenía en su negativa, y seguía negándose a que Israel saliera de su país."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Yavé dijo a Moisés y a Aarón, en el país de Egipto:"
,"2":"'Este mes será para ustedes el comienzo de los meses, el primero de los meses del año."
,"3":"Hablen a la comunidad de Israel y díganle: El día décimo de este mes tome cada uno un cordero por familia, un cordero por casa."
,"4":"Pero, si la familia es demasiado pequeña para consumir el cordero, se pondrá de acuerdo con el vecino más cercano, según el número de personas y conforme a lo que cada cual pueda comer."
,"5":"Ustedes escogerán un corderito sin defecto, macho, nacido en el año. En lugar de un cordero podrán tomar también un cabrito."
,"6":"Ustedes lo reservarán hasta el día catorce de este mes. Entonces toda la comunidad de Israel lo sacrificará al anochecer."
,"7":"En cada casa en que lo coman ustedes tomarán de su sangre para untar los postes y la parte superior de la puerta."
,"8":"Esa misma noche comerán la carne asada al fuego; la comerán con panes sin levadura y con verduras amargas."
,"9":"No comerán nada de él crudo o hervido sino que lo comerán todo asado con su cabeza, sus patas y sus entrañas."
,"10":"Ustedes no guardarán nada para el día siguiente. Lo que sobre al amanecer, quémenlo en el fuego."
,"11":"Y comerán así: con el traje puesto, las sandalias en los pies y el bastón en la mano. Ustedes no se demorarán en comerlo: es una pascua en honor de Yavé."
,"12":"Durante esa noche, yo recorreré el país de Egipto y daré muerte a todos los primogénitos de Egipto, tanto de los egipcios como de sus animales; y demostraré a todos los dioses de Egipto quién soy yo, Yavé."
,"13":"En las casas donde están ustedes la sangre tendrá valor de señal: al ver esta sangre, yo pasaré de largo, y la plaga no los alcanzará mientras golpeo a Egipto."
,"14":"Ustedes harán recuerdo de este día año tras año, y lo celebrarán con una fiesta en honor a Yavé. Este rito es para siempre: los descendientes de ustedes no dejarán de celebrar este día."
,"15":"Durante siete días comerán pan sin levadura. Desde el primer día no habrá fermento en las casas, pues cualquiera que coma pan fermentado desde el primer día hasta el séptimo será borrado de la comunidad de Israel."
,"16":"El primer día tendrán una reunión sagrada, así como el séptimo. Ningún trabajo se hará estos días, salvo lo que se prepara para la comida de cada cual."
,"17":"Ustedes celebrarán la fiesta de los Azimos, pues éste es el día en que los hice salir de Egipto. Ustedes celebrarán ese día de generación en generación: este rito es para siempre."
,"18":"Desde la tarde del día catorce del primer mes hasta la tarde del veintiuno del mismo mes ustedes comerán pan sin levadura."
,"19":"Durante siete días no habrá levadura en las casas de ustedes. El que coma cosa fermentada será borrado de la comunidad de Israel, sea extranjero o nativo."
,"20":"No comerán nada fermentado, sino que, en todas sus casas, comerán panes ázimos.'"
,"21":"Moisés, pues, llamó a los jefes de Israel y les dijo: 'No demoren en buscar una res para cada una de sus familias e inmolen la Pascua."
,"22":"Tomen un manojo de hisopo mojado con la sangre y marquen los dos postes y la parte superior de la puerta. Y luego ninguno de ustedes saldrá de su casa hasta la mañana."
,"23":"Pues Yavé, con su plaga, va a recorrer todo Egipto y, al ver la sangre en la entrada, pasará de largo y no permitirá que el Exterminador entre en sus casas y los mate."
,"24":"Ustedes observarán este rito, y también lo observarán sus hijos para siempre."
,"25":"Estas mismas ceremonias las harán cuando entren en la tierra que Yavé les dará, como les tiene prometido."
,"26":"Y cuando sus hijos les pregunten qué significa este rito,"
,"27":"les responderán: Este es el sacrificio de la Pascua para Yavé, que pasó de largo por las casas de los hijos de Israel en Egipto, cuando mató a los egipcios, dejando a salvo nuestras casas.' Al oír esto, todo el pueblo se postró y adoró."
,"28":"Los israelitas se fueron e hicieron lo que Yavé había mandado a Moisés y Aarón."
,"29":"Sucedió que, a media noche, Yavé hirió de muerte a todo primogénito del país de Egipto, desde el primogénito de Faraón que está sentado en el trono, hasta el del preso que está en la cárcel, y a todos los primeros nacidos de los animales."
,"30":"Faraón se levantó de noche, y con él toda su gente y todos los egipcios. Se oyó un clamor grande por todo Egipto, pues no había casa donde no hubiera algún muerto."
,"31":"Aquella misma noche Faraón llamó a Moisés y Aarón y les dijo: 'Levántense y salgan de este pueblo, ustedes y los hijos de Israel. Vayan para servir a Yavé, como ustedes dicen."
,"32":"Llévense sus rebaños de ovejas y vacunos, como ustedes piden. ¡Salgan, pero denme la bendición!'"
,"33":"Los egipcios los presionaban para que se fueran inmediatamente, pues decían: 'Si no se van ésos, moriremos todos.'"
,"34":"Así que los israelitas llevaron la masa antes de ponerle levadura; la envolvieron en sus mantas y se la cargaron al hombro."
,"35":"Los israelitas hicieron lo que les había dicho Moisés: pidieron a los egipcios objetos de oro y plata y muchos vestidos,"
,"36":"y los egipcios se lo dieron prestado, porque Yavé hizo que estuvieran dispuestos para escucharlos. Así fue cómo despojaron a los egipcios."
,"37":"Los hijos de Israel partieron de Ramsés a Sucot en número de unos seiscientos mil hombres, sin contar a los niños."
,"38":"También salió con ellos un montón de gente, con grandes rebaños de ovejas y vacas."
,"39":"Comieron panes sin levadura, tomando de la masa que habían sacado de Egipto. Pues habían salido con tanta prisa que no les alcanzó el tiempo para echarle levadura y hacer panes."
,"40":"La estadía de los israelitas en Egipto fue de 43 0,años. "
,"41":"Cuando se cumplieron estos 430 años, ese mismo día, todos los ejércitos de Yavé salieron de Egipto."
,"42":"Esta es la noche y la vigilia en honor de Yavé que sacó a Israel del país de Egipto. Esta noche es para Yavé, y los hijos de Israel la pasarán velando, año tras año, perpetuamente."
,"43":"Yavé dijo a Moisés y a Aarón: 'Estos son los ritos para la celebración de la Pascua. Ningún extranjero comerá de ella,"
,"44":"excepto el esclavo, comprado con dinero, con tal de que haya sido circuncidado."
,"45":"El extranjero que reside en Israel o que trabaja a tu servicio no la comerá."
,"46":"El cordero se comerá dentro de la casa; no se sacará afuera ni un solo pedazo, ni le quebrarán ningún hueso."
,"47":"Toda la comunidad de Israel observará este rito."
,"48":"Si algún extranjero residente quiere celebrarla, tienen que circuncidarse los varones de su casa; entonces podrá participar como cualquier persona del país. El que no esté circuncidado no puede comerla:"
,"49":"esta ley vale para ustedes y para los extranjeros que vivan entre ustedes.'"
,"50":"Los hijos de Israel hicieron tal como Yavé lo había mandado a Moisés y a Aarón,"
,"51":"y aquel mismo día Yavé los hizo salir de Egipto, bien ordenados como un ejército."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Yavé dijo a Moisés: 'Conságrame todo primogénito."
,"2":"Todos los primogénitos de los hijos de Israel son míos, tanto de hombre como de animales.'"
,"3":"Moisés dijo al pueblo: 'Ustedes celebrarán este día en que salieron de Egipto, de la casa de la esclavitud, al sacarlos Yavé de ese lugar con mano fuerte. Este día no comerán pan fermentado."
,"4":"El día en que ustedes salieron está en el mes de Aviv, mes de la primavera.'"
,"5":"Cuando Yavé te haya introducido en la tierra del cananeo, del heteo, del amorreo, del jeveo y del jebuseo, la que prometió con juramento a tus padres que te daría a ti, tierra que mana leche y miel, tú celebrarás este rito sagrado en este mes."
,"6":"Durante siete días comerás pan sin levadura, y el día séptimo será también una fiesta de Yavé."
,"7":"En estos días comerás pan sin levadura; no se verá pan fermentado en todo tu territorio."
,"8":"En aquel día dirás a tus hijos: Esto lo hacemos recordando lo que hizo Yavé conmigo cuando salí de Egipto."
,"9":"Será como una señal en tu mano, y como un recuerdo delante de tus ojos, a fin de que la enseñanza de Yavé esté siempre en tu boca; porque con mano fuerte te sacó Yavé de Egipto."
,"10":"Este precepto lo guardarás todos los años, a su debido tiempo."
,"11":"Cuando Yavé te haya introducido en la tierra del cananeo y te la haya dado en posesión,"
,"12":"consagrarás a Yavé todos los primogénitos. Todo primer nacido de tus ganados, si es macho, pertenece a Yavé."
,"13":"Todo primer nacido de burro ha de ser cambiado por un cordero; si no, lo matarás. Tratándose de personas, todo hijo primogénito será rescatado."
,"14":"Y cuando tu hijo te pregunte el día de mañana: ¿Qué significa esto? Le dirás: Yavé nos ha sacado de Egipto, de la casa de la esclavitud, con mano fuerte;"
,"15":"y como Faraón porfiaba en no dejarnos salir, Yavé mató a todos los primogénitos de Egipto, tanto de hombres como de animales. Por esta razón sacrifico a Yavé todo primogénito macho, y rescato al primer nacido de mis hijos."
,"16":"Estas normas serán como una señal impresa en tu mano, y como un recuerdo pendiente ante tus ojos, que te recuerde cómo Yavé nos sacó de Egipto con mano fuerte."
,"17":"Cuando Faraón despidió al pueblo, Dios no lo llevó por el camino del país de los filisteos, que era más corto. Pues Dios pensaba: 'Si hay que combatir, tal vez el pueblo se asuste y vuelva a Egipto.'"
,"18":"Por eso los llevó rodeando por el camino del desierto hacia el Mar Rojo. Todo el pueblo salió de Egipto bien ordenado."
,"19":"Moisés llevó consigo también los huesos de José, conforme éste había hecho prometer con juramento a los hijos de Israel; pues les dijo: 'Con toda seguridad Dios los visitará; entonces se llevarán con ustedes mis huesos.'"
,"20":"Partieron de Sucot y acamparon en Etam, que está en la proximidad del desierto."
,"21":"Yavé iba delante de ellos señalándoles el camino: de día iba en una columna de nube; de noche, en una columna de fuego, iluminándolos para que anduvieran de noche como de día."
,"22":"La columna de nube no se apartaba de ellos durante el día, ni la columna de fuego de noche."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Yavé dijo a Moisés:"
,"2":"'Ordena a los hijos de Israel que cambien de rumbo y acampen frente a Pi-Hajirot, que está entre Migdal y el mar, delante de Baal-Sefón. Al llegar a este lugar levantarán el campamento junto al mar."
,"3":"Así, pues, Faraón pensará que los hijos de Israel andan errantes en el país y que no pueden atravesar el desierto."
,"4":"Yo, entonces, haré que se ponga duro y los persiga a ustedes; y luego, me haré famoso a costa de Faraón y de todo su ejército, y sabrá Egipto que yo soy Yavé.' Ellos lo hicieron así."
,"5":"Anunciaron al rey de Egipto que el pueblo de Israel se había marchado. De repente, Faraón y su gente cambiaron de parecer respecto al pueblo. Dijeron: '¿Qué hemos hecho? Dejamos que se fueran los israelitas, y ya no estarán para servirnos.'"
,"6":"Faraón hizo preparar su carro y llevó consigo su gente."
,"7":"Tomó seiscientos carros escogidos, ¡todos los carros de Egipto!, cada uno con sus guerreros."
,"8":"Yavé había endurecido el corazón del rey y, mientras los israelitas se marchaban seguros, él los persiguió."
,"9":"Los egipcios, es decir, todos los carros, los caballos, los jinetes y el ejército de Faraón, se lanzaron en su persecución y les dieron alcance mientras acampaban junto al mar, cerca de Pi-Hajirot, frente a Baal-Sefón."
,"10":"Al aproximarse Faraón, los israelitas pudieron ver que los egipios los estaban persiguiendo. Sintieron mucho miedo y clamaron a Yavé;"
,"11":"dijeron a Moisés: '¿Acaso no había tumbas en Egipto para que nos hayas traído a morir al desierto?, ¿qué has ganado con sacarnos de Egipto?"
,"12":"Te dijimos claramente en Egipto: Déjanos en paz, y mejor servimos a los egipcios, porque más no conviene servir a los egipcios que morir en el desierto.'"
,"13":"Moisés contestó al pueblo: '¡No se asusten, permanezcan firmes! Vean la obra de Yavé y cómo él los salva hoy. Miren a esos egipcios a los que nunca más volverán a ver."
,"14":"Yavé peleará por ustedes, y ustedes solamente mirarán.'"
,"15":"Yavé dijo a Moisés: '¿Por qué clamas a mí? Di a los hijos de Israel que se pongan en marcha."
,"16":"Luego levanta tu bastón, extiende tu mano sobre el mar y divídelo, para que los hijos de Israel pasen en seco por medio del mar."
,"17":"Yo, mientras tanto, endureceré el corazón de los egipcios para que salgan en persecución de ustedes, y me haré famoso a costa de Faraón y de todo su ejército, de sus carros y de su caballería."
,"18":"Entonces Egipto conocerá que yo soy Yavé.'"
,"19":"El Angel de Dios que iba delante de los israelitas pasó detrás de ellos; también la nube en forma de columna vino a colocarse detrás,"
,"20":"poniéndose entre el campo de los israelitas y el de los egipcios. Esta nube era para unos tinieblas y para otros iluminaba la noche; y no se acercaron los unos a los otros durante la noche."
,"21":"Moisés extendió su mano sobre el mar y Yavé hizo soplar durante toda la noche un fuerte viento del oriente que secó el mar. Se dividieron las aguas. "
,"22":"Los israelitas pasaron en seco, por medio del mar; las aguas les hacían de murallas a izquierda y a derecha."
,"23":"Los egipcios se lanzaron a perseguirlos, y todo el ejército de Faraón entró en medio del mar con sus carros y caballos."
,"24":"Llegada la madrugada, Yavé miró a los egipcios desde el fuego y la nube, y provocó el desorden en el ejército de Faraón."
,"25":"Atascó las ruedas de sus carros, que no podían avanzar sino con gran dificultad. Entonces los egipcios dijeron: 'Huyamos de Israel, porque Yavé pelea con ellos contra nosotros.'"
,"26":"Pero Yavé dijo a Moisés: 'Extiende tu mano sobre el mar, y las aguas volverán sobre los egipcios, sus carros y sus caballos.'"
,"27":"Moisés extendió su mano sobre el mar. Al amanecer, el mar volvió a su lugar. Mientras los egipcios trataban de huir, Yavé arrojó a los egipcios en el mar."
,"28":"Las aguas al volver cubrieron los carros, los caballos y su gente, o sea, todo el ejército de Faraón que había entrado en el mar persiguiéndolos: no se escapó ni uno solo."
,"29":"Los israelitas, en cambio, habían pasado en medio del mar; las aguas les hacían de murallas a derecha e izquierda."
,"30":"Aquel día, Yavé liberó a Israel del poder de los egipcios; e Israel vio a los egipcios muertos en la orilla del mar."
,"31":"Israel vio los prodigios que Yavé había obrado contra Egipto, y el pueblo temió a Yavé. Creyó en Yavé y en Moisés, su siervo."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Entonces Moisés y los hijos de Israel cantaron este cántico a Yavé: 'Cantaré a Yavé, que se hizo famoso; arrojó en el mar al caballo y su jinete."
,"2":"¡Yavé, mi fortaleza!, a él le cantaré, él fue mi salvación, él es mi Dios y lo alabaré, el Dios de mi padre, lo ensalzaré."
,"3":"Yavé es un guerrero, Yavé es su nombre."
,"4":"Los carros de Faraón y su ejército: ¡los precipitó en el mar!,Los mejores de sus oficiales, ¡hundidos en el Mar Rojo!"
,"5":"Las aguas profundas los han sepultado, hasta el fondo cayeron como piedra."
,"6":"Tu diestra, Yavé, de tremendo poder, tu diestra, Yavé, aplasta al enemigo."
,"7":"Tu Gloria derriba a tus adversarios, despachas tu furor y los devora como paja."
,"8":"Al soplo de tus narices retroceden las aguas, las olas se paran como murallas; los torbellinos cuajan en medio del mar."
,"9":"Dijo el enemigo: 'Los perseguiré y los alcanzaré, los tendré a merced, llevaré sus despojos; sacaré mi espada y mi mano los matará.'"
,"10":"Mandaste tu soplo y el mar los cubrió, y se hundieron como plomo en las aguas majestuosas."
,"11":"¿Quién como Tú, Yavé, entre los dioses?,¿Quién como Tú, glorioso y santo, terrible en tus hazañas, autor de maravillas?"
,"12":"¡Extiendes tu mano y se los traga la tierra!"
,"13":"Guiaste con amor al pueblo que rescataste, lo llevaste con poder a tu santa morada."
,"14":"Lo oyeron los pueblos y se turbaron, se asustaron los filisteos;"
,"15":"los jefes de Edom vacilan,y los generales de Moab se asustan, se angustian los pobladores de Canaán:"
,"16":"¡pavor y espanto cayó sobre ellos!,Diste golpes, y quedan mudos como piedra,hasta que pase tu pueblo, Yavé, hasta que pase el pueblo que compraste."
,"17":"Tú lo llevarás y lo plantarás en el monte que es tuyo, el lugar en que habitas, oh Yavé; el Santuario del Señor, obra de sus manos."
,"18":"¡Que Yavé reine eternamente!'"
,"19":"Como Faraón entrara en el mar, con sus carros y sus caballos, Yavé hizo volver sobre ellos las aguas del mar, mientras los israelitas pasaban en seco por medio del mar."
,"20":"Entonces Miriam, la profetisa, hermana de Aarón, tomó en sus manos un instrumento, un pandero, y todas las mujeres la seguían con tímpanos, danzando en coro."
,"21":"Y Miriam les entonaba estas palabras: 'Cantemos a Yavé, que se hizo famoso; arrojó en el mar al caballo y su jinete.'"
,"22":"Moisés hizo partir a los israelitas del Mar Rojo y fueron al desierto de Sur. Allí anduvieron tres días por el desierto sin encontrar agua."
,"23":"Llegaron a Mará, pero no pudieron beber de sus aguas porque eran amargas. Por esto se llamó aquel lugar Mará, esto es, Amargura."
,"24":"El pueblo murmuró contra Moisés, diciendo: '¿Qué beberemos?'"
,"25":"Y como Moisés invocara a Yavé, le enseñó cierto madero; Moisés lo echó en las aguas, y se endulzaron. Fue allí donde Yavé dio al pueblo sus decisiones y sus decretos. Allí lo puso a prueba, "
,"26":"y le dijo: 'Si de veras escuchas a Yavé, tu Dios, y haces lo que es justo a sus ojos, dando oídos a sus mandatos y practicando sus normas, no descargaré sobre ti ninguna plaga de las que he descargado sobre los egipcios; porque yo soy Yavé, que te doy la salud.'"
,"27":"De allí pasaron a Elim, donde había doce manantiales de agua y setenta palmeras. Allí acamparon junto a las aguas."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Los israelitas se marcharon de Elim y llegaron al desierto de Sin, entre Elim y el Sinaí, el día quince del segundo mes después de la salida de Egipto."
,"2":"Toda la comunidad de los israelitas empezó a murmurar contra Moisés y Aarón en el desierto."
,"3":"Les decían: '¡Ojalá Yavé nos hubiera hecho morir en Egipto! Allí nos sentábamos junto a las ollas de carne y comíamos pan en abundancia. Ustedes, en cambio, nos han traído a este desierto en que todo ese gentío morirá de hambre.'"
,"4":"Pero Yavé dijo a Moisés: 'Ahora les hago llover pan del cielo; salga el pueblo y recoja lo que necesita para cada día. Y yo voy a probar si se ajusta o no a mi enseñanza..."
,"5":"El día sexto prepararán lo que les envíe, y será el doble de la ración diaria.'"
,"6":"Entonces Moisés y Aarón dijeron a toda la gente de Israel: 'Esta tarde ustedes reconocerán que Yavé es el que los ha sacado de Egipto,"
,"7":"y por la mañana sus ojos verán la Gloria de Yavé. Yavé ha escuchado cuando ustedes murmuraron contra él. Pues sus quejas no se dirigían a nosotros, ¿qué somos nosotros?"
,"8":"Esta tarde, Yavé les dará carne para que coman, y por la mañana, pan a saciedad. Esa es la manera como les contestará porque le han criticado a él y no a nosotros. Pues nosotros, ¿qué somos?'"
,"9":"Moisés dijo a Aarón: 'Di a todos los hijos de Israel: Vengan, preséntense a Yavé, porque ha oído las quejas de ustedes.'"
,"10":"Y mientras Aarón hablaba al pueblo, miraron hacia el desierto: la Gloria de Yavé se apareció en medio de la nube."
,"11":"Yavé habló a Moisés diciendo:"
,"12":"'He oído las quejas de mi pueblo. Diles: por la tarde comerán carne y por la mañana se saciarán de pan; así sabrán que yo soy Yavé, el Dios de ustedes.'"
,"13":"Aquella misma tarde llegaron codornices, que cubrieron el campamento. Y, por la mañana, en torno al campamento, había una capa de rocío. "
,"14":"Al evaporarse el rocío, apareció sobre el suelo del desierto una cosa menuda, como granos, parecida a la escarcha."
,"15":"Cuando los israelitas vieron esto, se dijeron unos a otros: 'Manha', o sea: '¿Qué es esto?' Pues no sabían lo que era. Y Moisés les dijo: 'Este es el pan que Yavé les da para comer."
,"16":"Yavé manda que cada uno recoja cuanto necesite para comer, alrededor de unos cinco litros por persona; y cada uno recogerá lo necesario para la gente de su tienda de campaña.'"
,"17":"Así lo hicieron los israelitas. Unos recogieron mucho y otros menos."
,"18":"Pero cuando lo midieron con el medio decalitro, ni los que recogieron mucho tenían más, ni los que recogieron poco tenían menos: cada uno tenía su ración."
,"19":"Moisés les dijo: 'Que nadie guarde nada para mañana.'"
,"20":"Algunos no le hicieron caso, sino que guardaron para el día siguiente. Pero se llenó de gusanos y se pudrió. Moisés se enojó con ellos."
,"21":"Cada cual recogía día tras día lo que necesitaba para el día, y luego, al calentar el sol se derretía lo que quedaba."
,"22":"El día sexto, cada uno recogió doble ración: dos medio-decalitros por persona. Todos los jefes de la comunidad fueron a decírselo a Moisés."
,"23":"El les dijo: 'Esto es lo que tiene ordenado Yavé: Mañana es día sábado, un descanso sagrado que le es dedicado. Hagan hoy todo lo que tengan que hacer, cuezcan lo que haya que cocer, hiervan lo que han de hervir y guarden lo que sobre para el día siguiente.'"
,"24":"Ellos guardaron el maná tal como Moisés lo había mandado y el maná no se pudrió. Entonces Moisés les dijo:"
,"25":"'Esta será la comida para hoy. Hoy es el día de descanso para Yavé y no encontrarán maná en el campo."
,"26":"Durante seis días saldrán a buscarlo, pero el séptimo día, que es el descanso, no habrá.'"
,"27":"Cuando llegó el séptimo día, algunos salieron a buscar maná, pero no hallaron nada. Por lo cual Yavé dijo a Moisés:"
,"28":"'¿Hasta cuándo se negarán a observar mis mandamientos y mi Ley?"
,"29":"Acuérdense de que Yavé les ha dado el sábado, y por esto el día sexto les ha doblado la ración. Quédense cada uno en su casa y que nadie se mueva el día séptimo.'"
,"30":"El pueblo, entonces, observó el descanso el día séptimo."
,"31":"La gente de Israel llamó a este alimento: maná. Era como la semilla del cilantro, blanco, y su gusto se parecía al de una torta de miel."
,"32":"Moisés dijo: 'Yavé ha dado esta orden: Guarden una medida de maná para sus descendientes, para que vean el alimento que les di de comer en el desierto cuando los hice salir de Egipto.'"
,"33":"Moisés dijo a Aarón: 'Toma un tiesto y échale una medida de maná; la depositarás ante la presencia de Yavé y la conservarás para los descendientes de ustedes.'"
,"34":"Aarón, pues, llevó el vaso conforme Moisés se lo había dicho, y lo depositó delante de las tablas de las Declaraciones divinas."
,"35":"Los hijos de Israel comieron maná durante cuarenta años, hasta que llegaron a una tierra poblada;"
,"36":"comieron el maná hasta que llegaron a la tierra de Canaán."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Al salir la comunidad de Israel del desierto de Sin, dispusieron sus etapas según Yavé les ordenaba. Acamparon en Refidim donde el pueblo, sediento, no encontró agua."
,"2":"Le reclamaron a Moisés, diciendo: 'Danos agua para beber.' Moisés les contestó: '¿Por qué me reclaman ustedes a mí?, ¿por qué tientan a Yavé?'"
,"3":"Allí el pueblo, atormentado por la sed, murmuró contra Moisés: '¿Por qué nos has hecho salir de Egipto? ¿Para que ahora muramos de sed con nuestros hijos y nuestros animales?'"
,"4":"Entonces Moisés llamó a Yavé y le dijo: '¿Qué puedo hacer con este pueblo?; por poco me apedrean.'"
,"5":"Yavé respondió a Moisés: 'Preséntate al pueblo, lleva contigo algunos jefes de Israel, lleva también en tu mano el bastón con que golpeaste el río Nilo."
,"6":"Yo estaré allá delante de ti, sobre la roca. Golpearás la roca y de ella saldrá agua, y el pueblo tendrá para beber.' Moisés lo hizo así, en presencia de los jefes de Israel."
,"7":"Aquel lugar se llamó Masá (o sea, tentación) y Meribá (o sea, quejas), a causa de las quejas de los israelitas que allí tentaron a Yavé, diciendo: '¿Está Yavé en medio de nosotros, o no?'"
,"8":"En Refidim los amalecitas vinieron a atacar a Israel."
,"9":"Moisés dijo a Josué: 'Elígete algunos hombres y marcha a pelear contra los amalecitas. Yo, por mi parte, estaré mañana en lo alto de la loma, con el bastón de Dios en mi mano.'"
,"10":"Josué hizo como se lo ordenaba Moisés, y salió a pelear contra los amalecitas. Mientras tanto, Moisés, Aarón y Jur subieron a la cumbre de la loma."
,"11":"Y sucedió que mientras Moisés tenía las manos arriba, se imponía Israel, pero cuando las bajaba, se imponían los amalecitas."
,"12":"Se le cansaron los brazos a Moisés; entonces tomaron una piedra y sentaron a Moisés sobre ella, mientras Aarón y Jur le sostenían los brazos, uno a cada lado. Así, Moisés mantuvo sus brazos alzados hasta la puesta del sol"
,"13":"y Josué hizo una enorme matanza entre la gente de Amalec."
,"14":"Entonces Yavé dijo a Moisés: 'Escribe todo esto en un libro para que sirva de recuerdo, y dile a Josué que yo no dejaré ni el recuerdo de Amalec debajo de los cielos.'"
,"15":"Luego Moisés edificó allí un altar a Yavé, al que puso por nombre: Yavé es mi triunfo. Y declaró:"
,"16":"'La bandera de Yavé en la mano: Yavé está en guerra con Amalec de generación en generación.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Jetró, sacerdote de Madián y suegro de Moisés, se enteró de todo lo que Dios había hecho en favor de Moisés y de Israel, su pueblo, y cómo lo había sacado de Egipto."
,"2":"Jetró, el suegro de Moisés, había acogido a Séfora, esposa de Moisés, después de que Moisés la había despedido,"
,"3":"y con ella sus dos hijos. Uno de esos hijos se llamaba Guersón (pues su padre dijo: He estado peregrino en tierra extraña);"
,"4":"y el otro se llamaba Eliezer (porque dijo: El Dios de mi padre vino en mi ayuda y me libró de la espada de Faraón)."
,"5":"Jetró, pues, el suegro de Moisés, le trajo sus hijos y su esposa mientras acampaba en el desierto, junto al monte de Dios."
,"6":"Mandó decir a Moisés: 'Yo, Jetró, suegro tuyo, vengo a ti con tu esposa y tus dos hijos.'"
,"7":"Moisés salió al encuentro de su suegro, le hizo una profunda reverencia y lo besó. Se preguntaron el uno al otro acerca de su salud y entraron en la tienda."
,"8":"Moisés le contó a su suegro todo lo que Yavé había hecho a Faraón y a los egipcios para bien de Israel, todas las dificultades que encontraron en el camino y cómo Yavé los había librado."
,"9":"Jetró se alegró mucho al oír todos los beneficios que Yavé había hecho a Israel cuando lo sacó del poder de los egipcios."
,"10":"Y dijo: '¡Bendito sea Yavé, que los ha liberado a ustedes de los egipcios y de Faraón!"
,"11":"Ahora reconozco que Yavé es el más grande de los Dioses; lo demostró en el momento en que oprimían a su pueblo.'"
,"12":"Jetró, suegro de Moisés, ofreció un sacrificio y presentó a Dios ofrendas. Vinieron entonces Aarón y todos los jefes de Israel para compartir una comida con el suegro de Moisés en la presencia de Dios."
,"13":"Al día siguiente, Moisés se sentó para hacer de juez y hubo gente en torno a él desde la mañana hasta la tarde."
,"14":"El suegro de Moisés vio el trabajo que su yerno se imponía por el pueblo y le dijo: '¡Cómo te sacrificas por el pueblo! ¿Por qué estás ahí tú solo y todo este pueblo queda de pie a tu lado desde la mañana hasta la tarde?'"
,"15":"Moisés contestó a su suegro: 'El pueblo viene a mí para consultar a Dios."
,"16":"Cuando tienen un pleito vienen a mí, yo juzgo entre unos y otros, y les doy a conocer las decisiones de Dios y sus normas.'"
,"17":"Entonces su suegro le dijo: 'No es lo mejor como tú lo estás haciendo."
,"18":"Acabarás por agotarte tú y este pueblo que está contigo; pues la carga es demasiado pesada para ti y no puedes llevarla tú solo."
,"19":"Ahora escúchame, te voy a dar un consejo, y Dios estará contigo. Tú serás para el pueblo el representante de Dios, y le llevarás sus problemas. "
,"20":"Les explicarás las normas y las instrucciones de Dios, les darás a conocer el camino que deben seguir y las obras que tienen que realizar."
,"21":"Pero elige entre los hombres del pueblo algunos que sean valiosos y que teman a Dios, hombres íntegros y que no se dejen sobornar, y los pondrás al frente del pueblo como jefes de mil, de cien, de cincuenta o de diez."
,"22":"Ellos harán de jueces para tu pueblo a cualquier hora; te presentarán los asuntos más graves, pero decidirán ellos mismos en los asuntos de menos importancia. Así se aliviará tu carga pues ellos la llevarán contigo."
,"23":"Si procedes como te digo, Dios te comunicará sus decisiones y tú podrás hacerles frente, y toda esa gente llegará felizmente a su tierra.'"
,"24":"Moisés escuchó a su suegro e hizo todo lo que le había dicho."
,"25":"Eligió hombres capaces de todo Israel y los puso al frente del pueblo como jefes de mil, de cien, de cincuenta y de diez."
,"26":"Ellos atendían al pueblo a toda hora para arreglar los problemas de menor importancia, y llevaban a Moisés los asuntos más delicados."
,"27":"Luego Moisés despidió a su suegro y lo encaminó hacia su tierra."
}`)
	CurrentBook.AddChapter(19, `{
"1":"El mismo día en que empezaba el tercer mes después de la salida de Egipto, los israelitas llegaron al desierto de Sinaí."
,"2":"Habían salido de Refidim, y llegaban al desierto de Sinaí donde acamparon. Los israelitas establecieron su campamento frente al monte, "
,"3":"y Moisés subió hacia Dios. Yavé lo llamó del cerro y le dijo: 'Esto es lo que dirás a los hijos de Jacob, lo que explicarás a los hijos de Israel:"
,"4":"Ustedes han visto cómo he tratado a los egipcios y que a ustedes los he llevado sobre las alas del águila para traerlos hacia mí."
,"5":"Ahora, pues, si ustedes me escuchan atentamente y respetan mi alianza, los tendré por mi propio pueblo entre todos los pueblos. Pues el mundo es todo mío,"
,"6":"pero los tendré a ustedes como un reino de sacerdotes, y una nación que me es consagrada.'"
,"7":"Entonces Moisés bajó del cerro y llamó a los jefes del pueblo, y les expuso todas estas instrucciones que Yavé le había dado."
,"8":"Todo el pueblo a una voz contestó: 'Haremos todo lo que Yavé ha mandado.' Luego Moisés llevó a Yavé la respuesta del pueblo."
,"9":"Yavé dijo a Moisés: 'Yo vendré a ti en medio de una espesa nube para que el pueblo oiga cuando yo hable contigo y tenga fe en ti también para siempre.'"
,"10":"Yavé dijo a Moisés: 'Vuelve donde el pueblo y mándales que se purifiquen hoy y mañana; que laven sus ropas"
,"11":"y estén listos para pasado mañana, porque pasado mañana Yavé bajará a vista de todos sobre el monte Sinaí."
,"12":"Señala al pueblo un límite alrededor del monte, y diles que no traten de subir al monte o de alcanzarlo. Todo aquel que traspase el límite deberá morir."
,"13":"Que nadie ponga las manos sobre el culpable, sino que sea apedreado o flechado; sea hombre o animal, no debe vivir más. Solamente cuando se oiga el toque de cuerno algunos podrán subir.'"
,"14":"Moisés bajó del monte y lo consagró; lavaron sus ropas,"
,"15":"y Moisés dijo: 'No tengan relaciones sexuales y estén listos para pasado mañana.'"
,"16":"Al tercer día, al amanecer, hubo sobre el monte truenos, relámpagos y una espesa nube; se oía un sonido muy fuerte de cuerno. En el campamento todo el pueblo se puso a temblar."
,"17":"Entonces Moisés los hizo salir del campamento para ir al encuentro de Dios, y se detuvieron al pie del monte."
,"18":"El monte Sinaí entero humeaba, porque Yavé había bajado en medio del fuego. Subía aquel humo como de un horno, y todo el monte temblaba muy fuerte."
,"19":"El sonido del cuerno iba creciendo: Moisés hablaba y Dios le contestaba con el trueno."
,"20":"Yavé bajó a la cumbre del monte Sinaí y, desde allí, llamó a Moisés. Y Moisés subió."
,"21":"Yavé dijo a Moisés: 'Baja del monte para advertir al pueblo que no traspase los límites para acercarse a Yavé y para ver algo, no sea que perezcan muchos."
,"22":"Que también los sacerdotes que se acercan a Yavé se santifiquen, no sea que Yavé los deje tendidos en el suelo.'"
,"23":"Moisés contestó: 'El pueblo no puede subir al monte, pues se lo prohibiste y me dijiste: Pon un cerco al pie del monte y tenlo por lugar sagrado.'"
,"24":"Y Yavé prosiguió: 'Anda, baja del cerro y sube luego con Aarón; pero que los sacerdotes y el pueblo no intenten traspasar el límite para subir hacia Yavé, no sea que él los deje tendidos en el suelo.'"
,"25":"Moisés, pues, bajó hasta el pueblo y les dijo..."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Entonces Dios dijo todas estas palabras:"
,"2":"'Yo soy Yavé, tu Dios, el que te sacó de Egipto, país de la esclavitud."
,"3":"No tendrás otros dioses fuera de mí."
,"4":"No te harás estatua ni imagen alguna de lo que hay arriba, en el cielo, abajo, en la tierra, y en las aguas debajo de la tierra."
,"5":"No te postres ante esos dioses, ni les sirvas, porque yo, Yavé, tu Dios, soy un Dios celoso. Yo pido cuentas a hijos, nietos y biznietos por la maldad de sus padres que no me quisieron."
,"6":"Pero me muestro favorable hasta mil generaciones con los que me aman y observan mis mandamientos."
,"7":"No tomes en vano el nombre de Yavé, tu Dios, porque Yavé no dejará sin castigo a aquel que toma su nombre en vano."
,"8":"Acuérdate del día del Sábado, para santificarlo."
,"9":"Trabaja seis días, y en ellos haz todas tus faenas."
,"10":"Pero el día séptimo es día de descanso, consagrado a Yavé, tu Dios. Que nadie trabaje: ni tú, ni tus hijos, ni tus hijas, ni tus siervos, ni tus siervas, ni tus animales, ni los forasteros que viven en tu país."
,"11":"Pues en seis días Yavé hizo el cielo y la tierra, el mar y cuanto hay en ellos, y el séptimo día descansó. Por eso bendijo el Sábado y lo hizo sagrado."
,"12":"Respeta a tu padre y a tu madre, para que se prolongue tu vida sobre la tierra que Yavé, tu Dios, te da."
,"13":"No mates."
,"14":"No cometas adulterio."
,"15":"No robes."
,"16":"No atestigües en falso contra tu prójimo."
,"17":"No codicies la casa de tu prójimo. No codicies su mujer, ni sus servidores, su buey o su burro. No codicies nada de lo que le pertenece.'"
,"18":"Mientras tanto, todo el pueblo estaba mirando: todo era truenos, relámpagos y sonido de trompeta en el cerro que humeaba. Al verlo el pueblo temblaba de miedo, y se mantenían a distancia."
,"19":"Entonces dijeron a Moisés: 'Habla tú con nosotros, que te escucharemos; pero que no hable Dios, no sea que muramos.'"
,"20":"Moisés les respondió: 'No teman, pues Dios ha venido para probarlos; él quiere que su temor permanezca en ustedes y así no pequen.'"
,"21":"El pueblo, pues, se mantuvo a distancia mientras Moisés se acercaba a la densa nube donde estaba Dios."
,"22":"Yavé habló a Moisés: 'Esto dirás a los hijos de Israel: ya han visto cómo yo les he hablado desde el cielo."
,"23":"No pondrán junto a mí dioses de plata ni de oro."
,"24":"A mí me harás un altar de tierra y sobre él ofrecerás tus sacrificios de comunión, tus ovejas y vacas; vendré a ti y te bendeciré en todo lugar en que yo haya revelado mi Nombre."
,"25":"Si me haces un altar de piedra, no serán piedras labradas, porque al trabajarlas con el hierro quedarían profanadas."
,"26":"Tampoco subirás por gradas a mi altar, para que no se descubra tu desnudez."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Les dictarás estas leyes:"
,"2":"Si compras un esclavo hebreo, te servirá seis años: el séptimo saldrá libre sin pagar rescate."
,"3":"Si entró solo, saldrá solo. Si tenía esposa, ella también quedará libre lo mismo que él."
,"4":"Si su patrón le dio la mujer de la que tiene hijos, éstos y la madre serán del patrón y él saldrá solo."
,"5":"Si el esclavo dice: 'Estoy feliz con mi patrón, con mi esposa y mis hijos, no quiero salir libre solo',"
,"6":"el dueño lo llevará ante Dios y acercándolo a los postes de la puerta de su casa le horadará la oreja con su punzón y este hombre quedará a su servicio para siempre."
,"7":"Si un hombre vende a su hija como esclava, ésta no recuperará su libertad como hace cualquier esclavo."
,"8":"Si la joven no agrada a su dueño que debía tomarla por esposa, el dueño aceptará que otro la rescate; pero no la puede vender a un extranjero, en vista de que la ha traicionado."
,"9":"Si la casa con su hijo, le dará el trato de una joven libre."
,"10":"Si se casa con ella y, después, con otra, no le disminuirá a la primera ni el vestido ni los derechos conyugales."
,"11":"Fuera de estos tres casos, la joven saldrá libre, sin pagar nada."
,"12":"El que hiera a otro y lo mate, morirá."
,"13":"Si causó la muerte del otro sin intención de matarlo, solamente porque Yavé dispuso así el accidente, tendrá que refugiarse en el lugar que yo te señalaré."
,"14":"Pero si alguien ataca a su prójimo y lo mata por traición, hasta de mi altar lo arrancarás para matarlo."
,"15":"El que le pegue a su padre o a su madre, muera sin remedio."
,"16":"El que rapte a una persona, la haya vendido o esté en su posesión, muera sin remedio."
,"17":"El que maldiga o trate sin respeto a su padre o su madre morirá."
,"18":"Si dos hombres se pelean y uno hiere al otro con una piedra o con el puño, pero no muere, sino que, después de guardar cama,"
,"19":"puede levantarse y andar por la calle apoyado en un bastón, el que le hirió no será culpado, pero pagará sus jornales perdidos hasta que su recuperación sea completa."
,"20":"Si un hombre golpea a su esclavo o esclava con un palo, si mueren en sus manos, será reo de crimen."
,"21":"Mas si sobreviven uno o dos días no se le culpará, porque le pertenecían."
,"22":"Si unos hombres, en el curso de una pelea, dan un golpe a una mujer embarazada provocándole un aborto, sin que muera la mujer, serán multados conforme a lo que imponga el marido ante los jueces."
,"23":"Pero si la mujer muere, pagarán vida por vida,"
,"24":"ojo por ojo, diente por diente, mano por mano, pie por pie,"
,"25":"quemadura por quemadura, herida por herida, golpe por golpe."
,"26":"Si un hombre ha herido el ojo de su esclavo o esclava, dejándolo tuerto, le dará la libertad a cambio del ojo que le sacó."
,"27":"Si le hace saltar un diente, lo dejará libre también a cambio de su diente."
,"28":"Si un buey cornea a un hombre o a una mujer y los mata, será muerto a pedradas. Su carne no podrá comerse, pero el dueño del buey quedará libre."
,"29":"Mas si el buey corneaba de tiempo atrás, y su dueño aun advertido no lo vigiló, y ese buey mata a un hombre o a una mujer, será muerto a pedradas, y su dueño también morirá."
,"30":"Si los jueces le imponen solamente una multa, dará a cambio de su vida todo cuanto le impongan."
,"31":"Si cornea a un muchacho o a una muchacha, se seguirá la misma norma."
,"32":"Si lo hace a un esclavo o a una esclava, se pagarán treinta siclos de plata al dueño de ellos, y el buey morirá apedreado."
,"33":"Si uno deja abierto un pozo, o si no tapa el pozo que está cavando, y luego cae en él un buey o un burro,"
,"34":"el propietario del pozo pagará al dueño de los animales el precio en dinero, pero el animal muerto será suyo."
,"35":"Si el buey de uno cornea al buey de otro, causándole la muerte, venderán el vivo, repartiéndose el precio; del mismo modo se repartirán el buey muerto."
,"36":"Mas si era notorio que el buey corneaba desde tiempo atrás, y su dueño no lo vigiló, pagará buey por buey, y el muerto será suyo."
,"37":"Si uno roba un buey o una oveja y los mata o vende, pagará cinco bueyes por un buey y cuatro ovejas por una."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Si un ladrón, sorprendido de noche forzando una casa, es herido mortalmente, el que lo mató no será culpado."
,"2":"Mas si lo hace ya salido el sol, se le culpará."
,"3":"Si alguien no tiene para devolver lo que robó será vendido él mismo para pagar. Si lo robado se encuentra vivo en su poder, sea buey, burro u oveja, debe restituir el doble."
,"4":"Si uno deja suelto su ganado para que paste en su chacra o en su viña, y el ganado pasta en campo ajeno, devolverá con lo mejor de su propio campo o de su propia viña."
,"5":"Si se prende fuego a los matorrales y éste pasa a los árboles frutales o a los sembrados que están en el campo, el que prendió el fuego pagará el daño."
,"6":"Cuando uno dé a otro dinero o joyas en depósito, para que se los guarde, y son robados de la casa de éste, el ladrón, si es hallado, restituirá el doble."
,"7":"Si no es hallado el ladrón, el dueño de la casa será presentado ante los jueces y jurará no haber echado mano de las cosas de su prójimo ni haber tenido parte en el robo."
,"8":"Cualquier pleito en que se sospeche que uno de los dos estafó al otro, ya se haya perdido buey, burro, cordero o manta, será llevado ante Dios, y al que Dios declare culpable restituirá el doble a su prójimo."
,"9":"Si alguien pasa a su prójimo, para que se lo guarde, un burro, buey u oveja, o cualquier otro animal, y éste muere, sufre algún daño o es robado sin que nadie lo vea,"
,"10":"el asunto se decidirá por un juramento. El que lo guardaba jurará que no tomó nada de lo de su prójimo. El dueño se dará por satisfecho y el otro no tendrá que devolver."
,"11":"Si el animal fue robado por descuido del depositario, éste pagará el daño."
,"12":"Si el animal ha sido destrozado por una fiera, que el depositario traiga como prueba los restos, y no habrá restitución."
,"13":"Si uno pide a otro que le preste un animal, y éste sufre un daño o muere en ausencia de su dueño, pagará restitución."
,"14":"Si el dueño estuvo presente, no hay restitución. Si el animal es alquilado, el dueño recibirá el alquiler."
,"15":"El que seduce a una joven no casada y se acuesta con ella, la dotará y se casará con ella."
,"16":"Si el padre de la niña no se la quiere dar, el otro pagará en dinero la dote que suelen recibir las esposas."
,"17":"A los hechiceros no los dejarán con vida."
,"18":"El que tenga relación sexual con una bestia morirá."
,"19":"El que ofrezca sacrificios a otros dioses, fuera de Yavé, será muerto."
,"20":"No maltratarás, ni oprimirás a los extranjeros, ya que también ustedes fueron extranjeros en tierra de Egipto."
,"21":"No harán daño a la viuda ni al huérfano."
,"22":"Si ustedes lo hacen, ellos clamarán a mí, y yo escucharé su clamor,"
,"23":"se despertará mi enojo y a ustedes los mataré a espada; viudas quedarán sus esposas y huérfanos sus hijos."
,"24":"Si prestas dinero a uno de mi pueblo, al pobre, que tú conoces, no serás como el usurero, no le exigirás interés."
,"25":"Si tomas en prenda el manto de tu prójimo, se lo devolverás al ponerse el sol,"
,"26":"pues este manto cubre el cuerpo de tu prójimo y protege su piel; si no, ¿cómo podrá dormir? Si no se lo devuelves, él clamará a mí, y yo lo escucharé porque soy compasivo."
,"27":"No blasfemarás el Nombre de Dios ni maldecirás al que es jefe en tu pueblo."
,"28":"No tardarás en ofrecerme mi parte de tus frutos y de tu cosecha. Me darás el primogénito de tus hijos."
,"29":"Lo mismo harás con los primeros nacidos de tus vacas y ovejas; siete días estarán con su madre, y al octavo me los ofrecerás."
,"30":"Sean para mí como personas consagradas: ustedes no comerán de la carne que haya sido destrozada por animales en el campo, sino que se la darán a los perros."
}`)
	CurrentBook.AddChapter(23, `{
"1":"No atestigües en falso ni ayudes al malvado dando un testimonio injusto."
,"2":"No sigas a la mayoría para obrar mal; no desviarás de la justicia para decir lo que todos dicen."
,"3":"Tratándose de justicia, no favorecerás ni siquiera al pobre."
,"4":"Cuando encuentres perdido el buey o el burro de tu enemigo, se lo llevarás."
,"5":"Si ves caído con la carga al burro del que te quiere mal, no pases de largo, sino ayúdalo a levantarlo."
,"6":"No tuerzas el derecho del pobre en su pleito."
,"7":"Aléjate de la mentira. No harás morir al inocente ni al justo, porque yo no perdonaré al culpable."
,"8":"No recibas regalos, porque los regalos deslumbran a los prudentes y perjudican los derechos de los justos."
,"9":"No opriman a los extranjeros, pues ustedes saben lo que es ser extranjero. Lo fueron ustedes en la tierra de Egipto."
,"10":"Seis años sembrarás tus campos y sacarás sus frutos;"
,"11":"al séptimo no los cultivarás y los dejarás descansar. Los pobres de tu pueblo comerán lo que encuentren allí, y si sobra algo, lo comerán los animales del campo. Harás lo mismo con tu viña y tu olivar."
,"12":"Seis días trabajarás, y al séptimo descansarás; tu buey y tu burro reposarán, y el hijo de tu esclava podrá respirar, tal como el extranjero."
,"13":"Cumplan todas estas cosas que les he dicho. No invoquen a dioses extranjeros, ni siquiera los nombren."
,"14":"Tres veces al año me celebrarán con una fiesta:"
,"15":"La celebración de la fiesta de los Azimos será de siete días. Comerás panes sin levadura, como te tengo mandado, en el mes de Aviv (de la primavera), el mes en que saliste de Egipto. Ustedes no se presentarán delante de mí con las manos vacías."
,"16":"Luego la fiesta de la siega de los primeros frutos de tus trabajos, de todo aquello que hayas sembrado en el campo. Luego la fiesta de la recolección a fin de año, cuando recoges todos los frutos del campo."
,"17":"Con eso, todos tus varones se presentarán tres veces al año delante de Yavé, tu Señor."
,"18":"No ofrecerás con pan fermentado la sangre de mis víctimas, ni guardarás hasta el día siguiente su grasa."
,"19":"Llevarás a la casa de Yavé los primeros y mejores frutos de tus tierras. No cocerás el cordero en la leche de su madre."
,"20":"Ya estoy enviando a mi Angel delante de ti para que te proteja en el viaje, hasta introducirte en el lugar que te he preparado."
,"21":"Anda derecho en su presencia y hazle caso: no le seas rebelde. Sepas que no perdonará tus faltas, pues en él está mi Nombre."
,"22":"Si le escuchas y haces todo lo que yo te diga, seré enemigo de tus enemigos y adversario de tus adversarios."
,"23":"Mi Angel irá delante de ti y te introducirá en el país del amorreo, del heteo, del fereceo, del cananeo, del jeveo y del jebuseo, a los cuales yo exterminaré."
,"24":"No adorarás a sus dioses; no los servirás ni harás lo que allá se hace; antes bien destruirás sus dioses y harás pedazos sus estatuas."
,"25":"Ustedes sólo servirán a Yavé, y yo bendeciré tu pan y tu agua, y apartaré de ti todas las enfermedades."
,"26":"No habrá en tu país mujer que aborte o sea estéril; y prolongaré los días de tu vida."
,"27":"Sembraré el terror delante de ti y exterminaré todos los pueblos del país en que tú entrarás; haré que todos tus enemigos huyan ante ti."
,"28":"Enviaré avispas delante de ti que harán huir de tu presencia al jeveo, al cananeo y al heteo."
,"29":"No te los quitaré de tu paso en un solo año, no sea que la tierra quede desierta y se multipliquen las fieras en perjuicio de ustedes."
,"30":"Los expulsaré poco a poco, mientras te hagas fuerte y te apoderes de la tierra."
,"31":"Fijaré tus fronteras desde el Mar Rojo hasta el mar de los filisteos (Mediterráneo) y desde el desierto hasta el río Eufrates. Pondré en tus manos a los que ocupan el país y tú los echarás fuera."
,"32":"No hagas pacto alguno ni con ellos ni con sus dioses."
,"33":"No habitarán en tu tierra, no sea que te lleven a servir sus dioses y a pecar contra mí: eso sería tu ruina."
}`)
	CurrentBook.AddChapter(24, `{
"1":"A Moisés, entonces, Dios le dijo: 'Sube donde Yavé, tú, Aarón, Nadab y Abihú, con setenta de los ancianos de Israel. Ellos adorarán desde lejos,"
,"2":"y Moisés se acercará solo a Yavé; ellos no se acercarán, y tampoco el pueblo subirá con ellos.'"
,"3":"Moisés bajó del monte y contó al pueblo todas estas palabras de Yavé y todas sus leyes. Contestaron de una sola voz: 'Nosotros cumpliremos con todo lo que Yavé ha dicho.'"
,"4":"Y Moisés escribió todas las palabras de Yavé. Al despuntar el día, Moisés levantó un altar al pie del monte y, al lado del altar, doce piedras por las doce tribus de Israel. "
,"5":"Luego mandó algunos jóvenes para que ofrecieran víctimas consumidas por el fuego y sacrificaran novillos como sacrificios de comunión."
,"6":"Moisés tomó la mitad de la sangre y la echó en vasijas; con la otra mitad roció el altar."
,"7":"Después tomó el libro de la Alianza y lo leyó en presencia del pueblo. Respondieron: 'Obedeceremos a Yavé y haremos todo lo que él pide.'"
,"8":"Entonces Moisés tomó la sangre con la que roció el pueblo, diciendo: 'Esta es la sangre de la Alianza que Yavé ha hecho con ustedes, conforme a todos estos compromisos.'"
,"9":"Moisés subió con Aarón, Nadab y Abihú, y setenta de los ancianos de Israel."
,"10":"Contemplaron al Dios de Israel. Debajo de sus pies había algo parecido a un pavimento de zafiro transparente y tan esplendoroso como el mismo cielo."
,"11":"Dios no dejó que su poder aplastara a los que había elegido, sino que vieron a Dios; luego comieron y bebieron."
,"12":"Yavé dijo a Moisés: 'Sube a lo más alto del cerro y detente allí. Yo te daré unas tablas de piedra con la enseñanza y los mandamientos que tengo escritos en ellas, a fin de que los enseñes al pueblo.'"
,"13":"Partió, pues, Moisés con Josué, su ayudante, y ascendió el monte de Dios."
,"14":"Había dicho a los ancianos: 'Aguarden aquí hasta que regresemos. Ahí quedan con ustedes Aarón y Jur, de manera que si se presenta alguna dificultad recurran a ellos.'"
,"15":"Moisés, pues, subió al monte, al que cubrió en seguida una nube."
,"16":"La Gloria de Yavé estaba bajando sobre el Sinaí, y la nube lo envolvió durante seis días. Al séptimo día, El llamó a Moisés de en medio de la nube."
,"17":"La Gloria de Yavé estaba en la cumbre del monte y los hijos de Israel la veían semejante a un fuego ardiente;"
,"18":"Moisés entró en la nube mientras subía al monte. Moisés permaneció en el monte cuarenta días y cuarenta noches."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Yavé habló a Moisés para decirle:"
,"2":"'Pide a los israelitas que me ofrezcan una contribución. Tú recibirás todas sus ofrendas voluntarias."
,"3":"Estas son las cosas que aceptarás como contribución: oro, plata y cobre;"
,"4":"ropas de color jacinto, morado y rojo; lino fino y pelos de cabra;"
,"5":"pieles de carnero teñidas de rojo y pieles moradas; madera de acacia"
,"6":"y aceite para mantener las lámparas; aromas para componer el óleo de la unción y perfumes de buen olor;"
,"7":"piedras de ónice y piedras de engaste para adornar el Efod y el Pectoral."
,"8":"Me van a hacer un santuario para que yo habite en medio de ellos,"
,"9":"y lo harán, como también todas las cosas necesarias para mi culto, según el modelo que yo te enseñaré."
,"10":"Harás un Arca de madera de acacia, de dos codos y medio de largo, codo y medio de ancho y otro codo y medio de alto."
,"11":"La revestirás de oro fino por dentro y por fuera y labrarás una cornisa de oro alrededor."
,"12":"Le pondrás cuatro anillos, uno en cada ángulo del Arca, dos a un lado y dos al otro."
,"13":"Harás también unas varas de madera de acacia y las cubrirás igualmente con oro."
,"14":"Las pasarás por los anillos que están a los lados del Arca para llevarla."
,"15":"Estas varas estarán siempre metidas en los anillos y no se sacarán de ellos."
,"16":"En el Arca pondrás el Testimonio que yo te daré."
,"17":"Le harás una cubierta, el 'Lugar del Perdón', de oro puro, de dos codos y medio de largo y codo y medio de ancho."
,"18":"Asimismo, harás dos querubines de oro macizo, y los pondrás en las extremidades de la cubierta."
,"19":"Pondrás un querubín a una extremidad, y el otro en la otra; formarán un solo cuerpo con la cubierta, a sus dos lados."
,"20":"Los querubines extenderán sus alas hacia arriba y sus alas cubrirán el Lugar del Perdón. Estarán de frente el uno al otro y sus caras mirarán hacia el Lugar del Perdón. Lo pondrás sobre el Arca,"
,"21":"y pondrás dentro de ella el Testimonio que yo te daré."
,"22":"Allí me encontraré contigo para darte mis órdenes referentes a los hijos de Israel. Te hablaré de encima del Lugar del Perdón, de en medio de los dos querubines puestos sobre el Arca del Testimonio."
,"23":"Harás también una mesa de madera de acacia, de dos codos de largo, uno de ancho y uno y medio de alto."
,"24":"La cubrirás de oro puro y le pondrás alrededor una moldura de oro."
,"25":"Le harás un borde de cuatro dedos de alto con una moldura de oro."
,"26":"Formarás, también, cuatro anillos de oro y los pondrás en las cuatro esquinas de la mesa, uno para cada pata."
,"27":"Los anillos estarán debajo de la cornisa y en ellos se colocarán las varas para el transporte de la mesa."
,"28":"Harás estas varas de madera de acacia cubierta de oro y servirán para transportar la mesa."
,"29":"Harás también de oro las fuentes, los vasos, los jarros y las tazas para las ofrendas líquidas."
,"30":"Y sobre la mesa tendrás siempre puestos ante mi presencia los panes de la ofrenda."
,"31":"Labrarás igualmente un candelabro de oro puro. Su pie y su tallo serán de oro macizo; sus capullos y flores formarán cuerpo con él."
,"32":"Saldrán seis brazos de sus lados: tres de uno y tres del otro."
,"33":"Cada brazo tendrá tres cálices en forma de almendro, con capullo y flor."
,"34":"En el mismo candelabro habrá cuatro cálices en forma de flor de almendro con capullos y flores;"
,"35":"un capullo debajo de los dos primeros brazos que forman cuerpo con el candelabro; otro, debajo de los siguientes, y un tercero debajo de los dos últimos brazos: seis brazos saldrán del candelabro."
,"36":"Los capullos y los brazos formarán un cuerpo con el candelabro: todo ello será de oro puro macizo."
,"37":"Harás siete lámparas que colocarás encima, de manera que den luz al frente."
,"38":"Sus despabiladeras y ceniceros serán de oro puro."
,"39":"Se empleará un talento de oro para hacer el candelabro con todos estos utensilios."
,"40":"Cuida, pues, de hacerlo todo conforme al modelo que te he enseñado en el monte."
}`)
	CurrentBook.AddChapter(26, `{
"1":"La Morada tendrá que ser hecha de diez cortinas de lino fino de color jacinto morado y rojo, adornadas con querubines."
,"2":"Cada cortina tendrá catorce metros de largo y dos de ancho. Todas serán de una misma medida."
,"3":"Cinco cortinas se unirán entre sí, y lo mismo las otras cinco."
,"4":"Pondrás lazos de color morado en los lados y extremos de cada conjunto, para que puedan unirse uno con otro."
,"5":"Cada conjunto tendrá por ambas partes cincuenta lazos, dispuestos de tal modo que uno corresponda a otro y se puedan ajustar entre sí."
,"6":"Harás asimismo cincuenta broches de oro, con los que se han de trabar los dos conjuntos, de manera que formen una sola tienda."
,"7":"También harás una cubierta de pelo de cabra para cubrir la Morada. Habrá once piezas,"
,"8":"cada una de ellas tendrá quince metros de largo y dos de ancho. Todas serán de la misma medida."
,"9":"Reunirás las cinco primeras, y lo mismo las otras seis, de modo que la sexta se doble por delante de la entrada."
,"10":"Harás también en la orilla de cada pieza de la cubierta cincuenta presillas, para que se pueda unir con la anterior, y cincuenta presillas en la otra orilla para unirla a la siguiente."
,"11":"Harás asimismo cincuenta hebillas de bronce, mediante las cuales se traben las presillas para que se forme un solo toldo."
,"12":"Sobrará la mitad de una de las cubiertas que sirven para toldo: dejarás caer esta mitad sobre la parte posterior y anterior de la Morada."
,"13":"El medio metro que sobre en el largo de estas piezas caerá sobre los lados de la Morada para protegerla."
,"14":"Harás también otra cubierta de pieles de carnero teñidas de rojo para cubrir la Morada, y sobre ésta pondrás otra cubierta de cuero fino."
,"15":"Harás asimismo tablones de madera de acacia para la Morada, cada uno de los cuales estará derecho;"
,"16":"tendrá cinco metros de largo y setenta y cinco centímetros de ancho."
,"17":"En un lado de cada tablón se harán dos muescas para encajar un tablón con otro, y de este modo se dispondrán todos los tablones."
,"18":"Veinte de éstos se pondrán en el lado meridional,"
,"19":"para los cuales harás cuarenta basas de plata, de suerte que dos basas sustenten los dos ángulos de cada tablón."
,"20":"En la misma forma se pondrán veinte tablones al otro lado de la Morada que mira al norte,"
,"21":"los cuales tendrán cuarenta basas de plata: dos basas debajo de cada tablón."
,"22":"Harás seis tablones para la parte occidental de la Morada."
,"23":"Harás otros dos que se fijarán en las esquinas, a la espalda de la Morada,"
,"24":"donde estarán trabados de abajo arriba a la altura de la primera argolla; esto se hará para las dos esquinas."
,"25":"Así serán en total ocho tablones con sus basas de plata, o sea dieciséis basas de plata, dos basas por cada tablón."
,"26":"También harás travesaños de madera de acacia, cinco travesaños para los tablones del primer lado de la Morada,"
,"27":"y otros cinco para los tablones del otro lado; y además, cinco travesaños para los tablones de la parte atrás de la Morada, al occidente."
,"28":"El travesaño atravesará los tablones de un extremo a otro."
,"29":"Cubrirás de oro los tablones y los travesaños y harás para ellos argollas de oro, por las cuales pasarán los travesaños."
,"30":"Así construirás la Morada, conforme al modelo que se te ha mostrado en el monte."
,"31":"Para el velo necesitarás lino fino retorcido color jacinto, púrpura, y de grana dos veces teñida, decorada en hermosa tapicería de querubines."
,"32":"Lo colgarás ante cuatro columnas de madera de acacia, que estarán cubiertas de oro y tendrán ganchos de oro. Las columnas serán puestas sobre pedestales de plata. El velo quedará pendiente por medio de sortijas, y detrás de él pondrás el Arca del Testimonio."
,"33":"El velo servirá para separar el Lugar Santo del Lugar Santísimo."
,"34":"Pondrás también el 'Lugar del Perdón' sobre el Arca del Testimonio en el Lugar Santísimo."
,"35":"Fuera del velo pondrás la mesa de los panes, y enfrente de la mesa, el candelabro. Estará en el lado meridional de la Morada, mientras que la mesa estará en la parte septentrional."
,"36":"Harás una cortina para la entrada de la Morada. Será de lino fino color jacinto, y púrpura, de grana dos veces teñida, con labores de tapicería."
,"37":"Luego harás cinco columnas de madera de acacia, de las que cuelgue esta cortina. Serán cubiertas con láminas de oro y puestas sobre basas de bronce."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Harás también un altar de madera de acacia, que tendrá dos metros y medio de largo y otros tantos de ancho, esto es, cuadrado, y metro y medio de altura."
,"2":"De sus cuatro esquinas saldrán cuatro cuernos que harán un cuerpo con él, y los cubrirás con láminas de bronce."
,"3":"Para el servicio del altar fabricarás unas calderas donde recoger las cenizas, tenazas, tridentes y braseros. Todos estos utensilios serán de bronce."
,"4":"Harás también un enrejado de bronce en forma de red en cuyos cuatro ángulos habrá cuatro anillos de bronce,"
,"5":"y lo pondrás debajo del plano o fogón del altar: este enrejado llegará hasta el medio del altar."
,"6":"Harás también dos varas de madera de acacia cubiertas con láminas de bronce para transportar el altar:"
,"7":"las meterás por los anillos a los lados del altar cuando haya que transportarlo."
,"8":"Harás el altar con paneles huecos de madera como te lo he mostrado en el monte."
,"9":"Dispondrás un atrio en torno a la Morada. Por el lado sur será cerrado por cortinas de lino fino de un largo de cincuenta metros."
,"10":"Colgarán de veinte columnas con otras tantas basas de bronce, cuyos ganchos y varillas serán de plata."
,"11":"Harás lo mismo para el lado del norte. Las cortinas tendrán cincuenta metros de largo; las veinte columnas con sus veinte basas serán de bronce, pero los ganchos y las varillas serán de plata."
,"12":"Por el lado del mar, esto es al oeste, lo ancho, unas cortinas de veinticinco metros marcarán su anchura; habrá diez columnas con otras tantas basas."
,"13":"La anchura del atrio será también de veinticinco metros al oriente."
,"14":"A un lado de la entrada se pondrán cortinas de siete metros y medio, con tres columnas y otras tantas basas."
,"15":"Lo mismo al otro lado de la entrada."
,"16":"Ante la entrada del atrio se pondrá una cortina de diez metros hecha de lino fino retorcido y bordado de color jacinto, púrpura y de grana dos veces teñida. Se sostendrá en cuatro columnas con otras tantas basas."
,"17":"Todas las columnas que cercan el atrio llevarán varillas de plata, con ganchos de plata y basas de bronce."
,"18":"El atrio tendrá una extensión de cincuenta metros de largo por veinticinco de ancho. La altura de las cortinas será de dos metros y medio; se harán de lino fino retorcido y tendrán basas de bronce."
,"19":"Todos los utensilios de la Morada, para cualquier uso, serán de bronce, y lo mismo las estacas, tanto de la misma Morada como del atrio."
,"20":"Da orden a los hijos de Israel que te traigan aceite de oliva puro y exprimido en mortero para las lámparas, de tal manera que nunca se apague la luz."
,"21":"Aarón y sus hijos dispondrán esta lámpara en la Tienda del Testimonio, fuera del velo que está pendiente delante del Testimonio,"
,"22":"y estará ardiendo en presencia de Yavé desde la mañana hasta la tarde. Será esto un rito perpetuo para los hijos de Israel."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Pide a tu hermano Aarón que se acerque a ti con sus hijos Nadab y Abihú, Eleazar e Itamar; sepáralos de los otros hijos de Israel para que sean mis sacerdotes."
,"2":"Harás a tu hermano Aarón vestiduras sagradas para que no le falte gloria ni belleza."
,"3":"Propondrás este trabajo a todos esos hombres expertos a los cuales he llenado yo del espíritu de inteligencia. Harán las vestiduras de Aarón para que sea consagrado como sacerdote mío."
,"4":"Estas son las vestiduras que han de hacerse: el Pectoral, el Efod, el manto, la túnica de malla, la tiara y el cinturón. Estas serán las vestiduras sagradas que harán a tu hermano Aarón y a sus hijos para que ejerzan delante de mí las funciones del sacerdocio."
,"5":"Para eso se emplearán oro, jacinto, púrpura, y grana dos veces teñida y lino fino."
,"6":"Harán el Efod de oro, de jacinto, de púrpura, de grana dos veces teñida, y de lino fino retorcido, obra tejida artísticamente."
,"7":"El Efod tendrá dos hombreras para reunir sus dos partes."
,"8":"El cinturón que llevará encima para sujetarlo será del mismo estilo y hará un cuerpo con él, de oro, de jacinto, de púrpura y grana dos veces teñida, y de lino fino retorcido."
,"9":"Tomarás también dos piedras de ónix y grabarás en ellas los nombres de los hijos de Israel;"
,"10":"seis nombres en cada piedra, según el orden de su nacimiento."
,"11":"Esculpirás en ellas los nombres de los hijos de Israel de la misma manera que se graba un sello; las engastarás y las guarnecerás de oro."
,"12":"Luego las pondrás sobre las hombreras del Efod, para representar a los hijos de Israel. Aarón llevará sus nombres delante de Yavé sobre sus dos hombros para recordárselos."
,"13":"Harás asimismo unos engastes de oro,"
,"14":"y dos cadenillas de oro puro labradas como cordeles trenzados, y las sujetarás de los engastes."
,"15":"Un artista realizará el Pectoral de las Sentencias bajo tu dirección. Lo harás como el Efod de hilos de oro, de jacinto o azul celeste, de púrpura y de grana dos veces teñida, y de lino fino retorcido."
,"16":"Será cuadrado y doble; tendrá de medida treinta centímetros, tanto a lo largo como a lo ancho."
,"17":"Colocarás en él cuatro filas de piedras preciosas. En la primera estarán la piedra sárdica, el topacio y la esmeralda."
,"18":"En la segunda estarán el carbucio, el zafiro y el jaspe;"
,"19":"en la tercera, el rubí, el ágata y la amatista;"
,"20":"en la cuarta, el crisólito, el ónix y el berilo. Estarán engastadas en oro."
,"21":"Estas piedras llevarán los nombres de los hijos de Israel; doce nombres estarán grabados en ellas, según las doce tribus: en cada piedra, un nombre."
,"22":"Harás para el pectoral dos cadenitas de oro puro, trenzadas a manera de un cordón"
,"23":"y dos sortijas o anillos de oro que pondrás en las dos puntas."
,"24":"Fijarás las cadenas de oro en los anillos que están en dichas puntas"
,"25":"y la otra extremidad de las cadenas se fijará en la parte delantera del Efod."
,"26":"Harás también dos anillos de oro, que pondrás en las puntas del Pectoral, a las orillas, frente del Efod, por la parte de dentro."
,"27":"Igualmente otros dos anillos de oro, para las dos hombreras del Efod, debajo de la parte que se ve, cerca de la juntura del cinturón que pasa sobre el Efod."
,"28":"Un cordón de jacinto unirá los anillos del Pectoral y los del Efod, de manera que el Pectoral se quede por encima del cinturón del Efod y no se pueda separar de él."
,"29":"Y así Aarón, siempre que entre en el Santuario, llevará sobre su pecho, en el Pectoral del Juicio, los nombres de los doce hijos de Israel, para recordarlos siempre en presencia de Yavé."
,"30":"En el mismo Pectoral de las Sentencias pondrás el Urim y el Tumin para que estén sobre el corazón de Aarón cuando se presente delante de Yavé, y sobre su corazón llevará el Pectoral de las Sentencias de los hijos de Israel en la presencia de Yavé."
,"31":"Harás también el manto del Efod, todo de color jacinto,"
,"32":"en medio del cual, por arriba, habrá una abertura para la cabeza. Esta abertura tendrá una orla de tejido como se suele hacer en la abertura de los corseletes para que no se rompan."
,"33":"En los lados habrá en todo el derredor unas granadas de jacinto, de púrpura y de grana dos veces teñida, y, entre las granadas, unas campanillas de oro."
,"34":"El manto tendrá granadas y campanillas de oro en todo el derredor."
,"35":"Aarón vestirá dicho manto cuando desempeñe su ministerio, y se oirá el sonido de las campanillas cuando entre al santuario para presentarse delante de Yavé, y también cuando salga del santuario; de lo contrario moriría."
,"36":"Harás también una lámina de oro fino, en la cual mandarás grabar como se graba en los sellos: 'Consagrado a Yavé.'"
,"37":"Y la sujetarás a la tiara por delante con un cordón de color jacinto, de modo que esté encima."
,"38":"Estará sobre la frente de Aarón siempre que deba cargar con los pecados cometidos por los hijos de Israel en todas sus oblaciones y sacrificios. Tendrá siempre esta lámina en su frente para atraerles la benevolencia de Yavé."
,"39":"Tejerás la túnica de lino fino; y de lino también harás el turbante y el cinturón, artísticamente recamados."
,"40":"Las túnicas y los cinturones de los hijos de Aarón se harán en la misma forma. Con esto les darás majestad y belleza."
,"41":"Vestirás a tu hermano Aarón y a sus hijos, los consagrarás con la unción santa, los harás sacerdotes y los consagrarás a mi servicio."
,"42":"Les harás calzoncillos de lino, con los que cubrirán la desnudez de su carne desde la cintura hasta las rodillas."
,"43":"Aarón y sus hijos los usarán siempre que entren en la Tienda de las Citas divinas o se acerquen al altar para cumplir con su ministerio en el Lugar Santo. De lo contrario incurrirían en falta y morirían. Es éste un precepto perpetuo para Aarón y su posteridad."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Esta es la manera como consagrarás a los sacerdotes. Tomarás un novillo y dos carneros sin defecto alguno,"
,"2":"panes ázimos y una torta sin levadura, amasada con aceite, como también buñuelos ázimos, untados con aceite; todo lo harás con la flor de la harina de trigo."
,"3":"Puesto en un canastillo lo ofrecerás junto con el novillo y los dos carneros."
,"4":"Luego pedirás a Aarón y sus hijos que se acerquen a la entrada de la Tienda de las Citas y los lavarás con agua."
,"5":"Luego revestirás a Aarón de sus ornamentos, esto es, de la túnica de lino, el manto del Efod, el Efod y el Pectoral, que ceñirás con el cinturón del Efod."
,"6":"Pondrás sobre su cabeza el turbante, y sobre éste, la lámina sagrada."
,"7":"Entonces tomarás el óleo de la unción, lo derramarás sobre su cabeza y así quedará consagrado."
,"8":"También pedirás a sus hijos que se acerquen, y los revestirás con las túnicas de lino;"
,"9":"ceñirás a Aarón y a sus hijos las fajas y les pondrás las mitras. Así es como consagrarás a Aarón y sus hijos como sacerdotes míos: éste será un rito perpetuo."
,"10":"Entonces traerás el novillo delante de la Tienda de las Citas; allí Aarón y sus hijos le pondrán las manos sobre la cabeza"
,"11":"y lo degollarás en presencia de Yavé, junto a la entrada de la Tienda de las Citas."
,"12":"Tomando de la sangre del novillo con tu dedo, la pondrás sobre los cuernos del altar; el resto lo derramarás al pie del altar."
,"13":"Sacarás todo el sebo que cubre las entrañas, el que queda junto al hígado y los dos riñones con el sebo que los envuelve, para quemarlo en el altar."
,"14":"Quemarás fuera del campamento la carne del novillo, con su piel y excrementos, por cuanto es sacrificio por el pecado."
,"15":"Tomarás después el primero de los carneros. Aarón y sus hijos pondrán las manos sobre la cabeza del carnero."
,"16":"Lo sacrificarás, tomarás su sangre y la derramarás sobre el altar, por todos lados."
,"17":"Luego despedazarás el carnero en trozos; lavarás sus intestinos y sus patas, los pondrás sobre su cabeza"
,"18":"y lo quemarás todo en el altar. Es el holocausto, esto es el sacrificio de calmante olor para Yavé."
,"19":"Tomarás asimismo el otro carnero, sobre cuya cabeza Aarón y sus hijos pondrán las manos."
,"20":"Lo degollarás, tomarás de su sangre y teñirás con ella la extremidad de la oreja derecha de Aarón y de sus hijos, y los pulgares de su mano y pie derechos, derramando la sangre sobre el altar por todos lados."
,"21":"Y tomando de la sangre vertida sobre el altar y del óleo de la consagración, rociarás a Aarón y sus ropas, y con él, a sus hijos y las ropas de ellos. Así será consagrado con sus ropas, y lo mismo sus hijos y las ropas de sus hijos."
,"22":"Tomarás la grasa y la cola del carnero, el sebo que cubre los intestinos, la telilla del hígado, los dos riñones y la enjundia de encima, y la espaldilla derecha, porque es un cordero para consagración de sacerdotes."
,"23":"Además, una torta de pan y otra de masa amasada con aceite y una torta del canasto de los ázimos presentados a Yavé,"
,"24":"y después de poner todas estas cosas sobre las manos de Aarón y de sus hijos, las mecerás en la presencia de Yavé."
,"25":"Después recibirás de sus manos todo lo dicho y lo quemarás sobre el altar encima de la víctima quemada. Será un sacrificio por el fuego de calmante olor para Yavé."
,"26":"Luego tomarás el pecho del carnero sacrificado para la consagración de Aarón y lo ofrecerás llevándolo ante Yavé: ésta será tu parte."
,"27":"Consagrarás el pecho que ha sido mecido y la espaldilla que ha sido puesta aparte -todo lo que ha sido mecido o separado del carnero para la consagración de Aarón y de sus hijos."
,"28":"Con esto Aarón y sus hijos recibirán para siempre el derecho a cobrar este tributo de los hijos de Israel. Es el tributo que les presentarán los hijos de Israel en todos los sacrificios de comunión que presenten a Yavé."
,"29":"Las ropas santas de Aarón pasarán a sus hijos después de su muerte: pasarán a ser suyas el día que sean ungidos y consagrados."
,"30":"El sacerdote que se tome de los hijos de Aarón para sucederle las vestirá durante siete días cuando lo consagren para entrar en la Tienda de las Citas y para oficiar en el Santuario."
,"31":"Cocerás en un lugar sagrado la carne del carnero ofrecido para esta consagración,"
,"32":"y la comerán Aarón y sus hijos, junto con el pan del canastillo, a la entrada de la Tienda de las Citas."
,"33":"La comerán, ya que fue santificada para hacer expiación por ellos y consagrarlos. Ningún extraño comerá de estas cosas, porque son sagradas."
,"34":"Si algo de la carne o del pan sobra hasta el día siguiente, no lo comerán sino que lo quemarás, porque es cosa sagrada."
,"35":"Harás, pues, con Aarón y sus hijos todo lo que te mando. La consagración durará siete días."
,"36":"Cuando se haga la expiación para la purificación del altar, se ofrecerá cada día un novillo para la expiación, un sacrificio por el pecado, y luego ungirás el altar para consagrarlo."
,"37":"La expiación por el altar, y luego su consagración durará siete días. En adelante el altar será cosa muy sagrada y todo cuanto toque el altar quedará consagrado."
,"38":"Cada día, y para siempre, prepararás sobre el altar dos corderos nacidos durante el año,"
,"39":"un cordero por la mañana y otro por la tarde."
,"40":"Con el primer cordero ofrecerás una décima de medida de flor de harina amasada con un cuarto de sextario de aceite de oliva, y como libación, un cuarto de sextario de vino."
,"41":"Ofrecerás el otro cordero por la tarde con los mismos ritos de la mañana; será un sacrificio por el fuego de calmante olor."
,"42":"Este es el holocausto perpetuo que se ofrecerá a Yavé de generación en generación a la entrada de la Tienda de las Citas, allí mismo donde me encuentro contigo para hablarte."
,"43":"Allí me encontraré con los hijos de Israel; mi propia Gloria santificará este lugar."
,"44":"Así santificaré la Tienda de las Citas con el altar; así santificaré a Aarón y a sus hijos para que sean sacerdotes míos."
,"45":"Habitaré entre los hijos de Israel y seré su Dios,"
,"46":"y sabrán que yo soy Yavé, su Dios, que los saqué de la tierra de Egipto para morar entre ellos. Yo, Yavé, seré su Dios."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Harás también un altar para quemar el incienso. Lo harás de madera de acacia"
,"2":"y tendrá medio metro de largo y de ancho; es decir, que será cuadrado. Tendrá un metro de altura, y de sus cuatro ángulos saldrán sus cuernos, haciendo un cuerpo con él."
,"3":"Lo revestirás de oro puro, tanto su parte superior como sus costados, así como sus cuernos. Pondrás en su derredor una moldura de oro,"
,"4":"y debajo de la moldura, a los costados, harás dos anillos de oro. Los harás a ambos lados para meter por ellos las varas con que transportarlo."
,"5":"Estas serán de madera de acacia y las revestirás de oro."
,"6":"Colocarás el altar delante de la cortina que abriga el Arca del Testimonio y ante el Lugar del Perdón que cubre el Testimonio, allí mismo donde yo te hablo."
,"7":"Aarón quemará cada mañana sobre él incienso aromático, al preparar las lámparas,"
,"8":"y hará lo mismo al atardecer cuando alimente las lámparas. Este será el Incienso ante Yavé, de generación en generación."
,"9":"No se ofrecerá sobre este altar incienso profano, ni holocausto, ni víctima, ni se derramará sobre él vino alguno."
,"10":"Una vez al año Aarón hará la expiación sobre los cuernos del altar. Hará la expiación sobre el altar una vez al año con la sangre del sacrificio por el pecado, y esto, de generación en generación. Será, pues, un lugar muy sagrado para Yavé.'"
,"11":"Yavé habló a Moisés:"
,"12":"'Cuando hagas el censo de los hijos de Israel, cada uno hará una ofrenda a Yavé, para que ninguna plaga los alcance con motivo del empadronamiento; cada uno pagará a Yavé por sí mismo."
,"13":"Cada uno de los que sean empadronados pagará medio siclo, según el peso del templo (es decir, un siclo de veinte óbolos). Este medio siclo será la ofrenda para Yavé."
,"14":"Todos los comprendidos en el censo, de veinte años para adelante, pagarán este rescate."
,"15":"El rico no dará más de medio siclo ni el pobre dará menos, pues es una contribución para Yavé, para rescate de su vida."
,"16":"Recibirás el dinero de esta expiación de mano de los hijos de Israel y lo destinarás para el servicio de la Tienda de las Citas. Con este medio los israelitas harán que Yavé se acuerde de ellos y rescatarán sus vidas.'"
,"17":"Yavé se dirigió a Moisés y le dijo:"
,"18":"'Harás una pila de bronce con un pie de bronce para el lavatorio. La colocarás entre la Tienda de las Citas y el altar y se echará agua en ella"
,"19":"para que Aarón y sus hijos se laven las manos y los pies. Que se laven con esta agua cuando entren a la Tienda de las Citas, no sea que mueran."
,"20":"Lo mismo cuando se presenten al altar para cumplir su ministerio y ofrecer un sacrificio por el fuego a Yavé,"
,"21":"que se laven las manos y los pies, no sea que mueran; éste será un rito perpetuo para Aarón y su descendencia de generación en generación.'"
,"22":"Yavé dijo a Moisés: 'Toma aromas escogidos: de mirra pura, quinientos siclos;"
,"23":"de cinamomo, doscientos cincuenta; de caña aromática, doscientos cincuenta;"
,"24":"de canela, quinientos, en siclos del santuario, y un sextario de aceite de oliva."
,"25":"Prepararás con ello el óleo para la unción sagrada, perfume aromático como lo prepara el perfumista."
,"26":"Con él ungirás la Tienda de las Citas y el Arca del Testimonio,"
,"27":"la mesa con todos sus vasos, el candelabro con todos sus utensilios, el altar del incienso,"
,"28":"el altar de los holocaustos con todos sus utensilios y la pila con su base."
,"29":"Así los consagrarás y serán cosas muy santas. Todo lo que las toque quedará santificado."
,"30":"Ungirás también a Aarón y a sus hijos y los consagrarás para que sean mis sacerdotes."
,"31":"Luego dirás a los hijos de Israel:"
,"32":"Este será para ustedes el óleo de la unción sagrada de generación en generación. Nadie se ungirá con él, ni tampoco harán otro óleo de semejante composición. Es santo y lo tendrán por cosa sagrada."
,"33":"Cualquier hombre que prepare otro semejante o derrame de él sobre un extraño será exterminado de entre los suyos.'"
,"34":"Yavé dijo a Moisés: 'Procúrate en cantidades iguales los siguientes aromas: resina, espinos y gálbano, especias aromáticas e incienso puro."
,"35":"Prepara con ellos según el arte del perfumista un incienso perfumado, sazonado con sal, puro y santo;"
,"36":"molerás una parte, que pondrás delante del Testimonio, en la Tienda de las Citas, donde yo me reúno contigo. Será para ustedes cosa sacratísima."
,"37":"No harán perfume de semejante composición para uso personal; lo tendrán por cosa reservada a Yavé."
,"38":"Cualquiera que haga otro igual para recrearse con su fragancia será exterminado de entre los suyos.'"
}`)
	CurrentBook.AddChapter(31, `{
"1":"Yavé dijo a Moisés:"
,"2":"'Acabo de llamar por su nombre a Bezaleel, hijo de Urí, hijo de Jur, de la tribu de Judá,"
,"3":"y lo he llenado del espíritu de Dios, de saber, de inteligencia, de ciencia y de capacidad en toda clase de trabajo,"
,"4":"para crear obras de arte. Este hombre sabe trabajar el oro, plata y bronce,"
,"5":"y tallar tanto las piedras preciosas como la madera: es entendido en toda clase de trabajos."
,"6":"También le doy por ayudante a Oholiab, hijo de Ajisamac, de la tribu de Dan; y además, he puesto sabiduría en el corazón de todos los hombres hábiles que deberán hacer todo lo que he mandado:"
,"7":"la Tienda de las Citas, el Arca del Testimonio, el Lugar del Perdón que la cubre, y todos los utensilios de la Tienda;"
,"8":"la mesa y sus vasos, el candelabro de oro macizo con todos sus utensilios, el altar de los perfumes"
,"9":"y el de los holocaustos con todos sus utensilios, la pila con su base;"
,"10":"las vestiduras sagradas y las que han de servir para la consagración del sacerdote Aarón y las de sus hijos cuando ejerzan sus funciones sacerdotales;"
,"11":"el óleo de la unción y el incienso aromático para el santuario. Ellos lo harán conforme a todo lo que he ordenado.'"
,"12":"Yavé dijo a Moisés: 'Habla a los hijos de Israel y diles: No dejen de guardar mis sábados;"
,"13":"porque son una señal entre ustedes y yo de generación en generación, para que sepan que yo, Yavé, soy el que los santifica."
,"14":"Guarden el sábado porque es sagrado para ustedes. El que lo profane morirá; el que trabaje en ese día será borrado de en medio de su pueblo."
,"15":"Seis días se trabajará, pero el día séptimo será un día de descanso completo consagrado a Yavé. El que trabaje el día sábado morirá."
,"16":"Los hijos de Israel observarán el sábado de generación en generación y lo celebrarán: éste ha de ser un compromiso perpetuo conmigo."
,"17":"El sábado será entre yo y los hijos de Israel una señal perpetua, pues Yavé hizo los cielos y la tierra en seis días, y el séptimo descansó y respiró."
,"18":"Cuando Dios terminó de hablar con Moisés en el monte Sinaí, le dio las dos tablas del Testimonio, escritas por el dedo de Dios."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Moisés no bajaba del cerro y le pareció al pueblo un tiempo largo. Se reunieron en torno a Aarón, al que dijeron: 'Fabrícanos un Dios que nos lleve adelante, ya que no sabemos qué ha sido de Moisés, que nos sacó de Egipto.'"
,"2":"Aarón les contestó: 'Saquen los aros de oro que sus mujeres, y sus hijos e hijas llevan en sus orejas, y tráiganmelos.'"
,"3":"Todos se los sacaron y los entregaron a Aarón."
,"4":"El los recibió y fabricó un ternero de metal batido. Entonces exclamaron: 'Israel, aquí están tus dioses que te han sacado de Egipto.' "
,"5":"Se lo mostraron a Aarón, el que edificó un altar delante de la imagen y luego anunció: 'Mañana habrá fiesta en honor de Yavé.'"
,"6":"Al día siguiente, se levantaron temprano, ofrecieron víctimas consumidas por el fuego, y también presentaron sacrificios de comunión. El pueblo se sentó para comer y beber; luego se levantaron para divertirse."
,"7":"Entonces Yavé dijo a Moisés en el cerro: 'Vuelve y baja, porque tu pueblo ha pecado."
,"8":"Bien pronto se han apartado del camino que yo les había indicado. Se han hecho un ternero de metal fundido y se han postrado ante él. Le han ofrecido sacrificios y han dicho: Israel, aquí están tus dioses que te han sacado de Egipto.'"
,"9":"Yavé dijo también: 'Ya veo que ese pueblo es un pueblo rebelde."
,"10":"Ahora, pues, deja que estalle mi furor contra ellos. Voy a exterminarlos, mientras que de ti yo haré nacer un gran pueblo.'"
,"11":"Moisés suplicó a Yavé, su Dios, con estas palabras: 'Oh Yavé, ¿cómo podrías enojarte con tu pueblo, después de todos los prodigios que hiciste para sacarlo de Egipto?"
,"12":"¿O quieres que los egipcios digan: 'Yavé los ha sacado con mala intención, para matarlos en los cerros y suprimirlos de la tierra'? Aplaca tu ira y renuncia a castigar a tu pueblo."
,"13":"Acuérdate de tus servidores Abrahán, Isaac y Jacob, y de las promesas que les hiciste. Pues juraste por tu propio Nombre: 'Multiplicaré tu descendencia como las estrellas del cielo, y daré a tu raza la tierra que te prometí, para que sea de ellos para siempre.'"
,"14":"Así, pues, Yavé renunció a destruir a su pueblo, como lo había anunciado."
,"15":"Al bajar de vuelta del cerro, Moisés traía las dos tablas de las Declaraciones divinas en que las leyes estaban escritas y grabadas por ambos lados."
,"16":"Las tablas eran obra de Dios, como también la escritura era la escritura de Dios, grabada sobre ellas."
,"17":"Josué estaba con Moisés, y al oír el griterío del pueblo dijo: '¡Hay gritos de guerra en el campamento!'"
,"18":"Moisés le contestó: 'No son gritos de victoria, ni lamentos de derrota; lo que oigo son cantos a coros.'"
,"19":"Al acercarse Moisés al campamento, vio el ternero y las danzas. Se llenó de furor y arrojó las tablas, que se hicieron pedazos al pie del cerro."
,"20":"Después tomó el ternero que habían fabricado, lo quemó y lo machacó hasta reducirlo a polvo. Y dio de beber al pueblo agua con este polvo mezclado."
,"21":"Moisés dijo a Aarón: '¿Qué te hizo ese pueblo para que lo hayas arrastrado a un pecado tan grave?'"
,"22":"Aarón le contestó: '¡No te enojes conmigo, mi señor! Tú mismo sabes que este pueblo es inclinado al mal."
,"23":"Ellos me dijeron: No sabemos lo que ha pasado con Moisés, el que nos ha sacado de Egipto, así que fabrícanos dioses que nos lleven adelante."
,"24":"Yo les dije: ¿Quiénes son los de ustedes que tienen oro? Ellos se lo sacaron al instante de sus orejas y me lo dieron; yo lo fundí y salió este ternero.'"
,"25":"Moisés vio que el pueblo estaba sin freno, porque Aarón se lo había quitado, y que sus enemigos habrían tenido toda la razón al despreciarlo."
,"26":"Se colocó, pues, a la entrada del campamento y llamó en voz alta: '¡Vengan a mí los que estén por Yavé!' Todos los de la tribu de Leví se juntaron en torno a él."
,"27":"El les dijo: 'Esta es orden de Yavé, el Dios de Israel: Colóquense cada uno su espada al costado y pasen y repasen por el campamento, de una entrada a la otra; y no vacilen en matar a sus hermanos, compañeros y familiares.'"
,"28":"Los de la tribu de Leví cumplieron la orden de Moisés, y perecieron, aquel día, unos tres mil hombres del pueblo."
,"29":"Entonces Moisés dijo a los levitas: 'Ustedes hoy acaban de ser consagrados a Yavé con sangre, tal vez con la sangre de un hijo o de un hermano. Por eso hoy él les da la bendición.'"
,"30":"Al día siguiente Moisés dijo al pueblo: 'Ustedes han cometido un gran pecado, pero voy a subir donde Yavé. Ojalá pueda obtener por ustedes el perdón de este pecado.'"
,"31":"Al volver Moisés donde Yavé le dijo: 'Este pueblo ha cometido un gran pecado con estos dioses de oro que se hicieron."
,"32":"Con todo, dígnate perdonar su pecado...  pero si no, bórrame del libro que has escrito.'"
,"33":"Yavé respondió a Moisés: 'Al que peca contra mí, a éste borraré yo de mi libro."
,"34":"Pero tú, sigue, y conduce al pueblo al lugar que te indiqué. Mi Angel irá delante de ti, pero algún día los visitaré y les pediré cuentas de su pecado.'"
,"35":"Y, en efecto, Yavé castigó al pueblo por el ternero que se fabricaron, el ternero que les hizo Aarón."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Yavé dijo a Moisés: 'Márchate de ese lugar tú y tu pueblo que saqué de Egipto; sube a la tierra que yo prometí con juramento a Abraham, a Isaac y a Jacob cuando les dije: Se la daré a tu descendencia."
,"2":"Enviaré delante de ti un ángel para que eche del país al cananeo, al amorreo, al heteo, al fereceo, al jeveo y al jebuseo."
,"3":"Pero no subiré con ustedes a esa tierra que mana leche y miel, no sea que los destruya en el camino, por ser un pueblo rebelde.'"
,"4":"El pueblo escuchó esta advertencia; ninguno se puso su traje de fiesta; más bien hicieron duelo."
,"5":"Yavé dijo a Moisés: 'Di a los hijos de Israel: Ustedes son un pueblo rebelde; si estuviera en medio de ustedes, aunque fuera por un momento, los exterminaría. Ahora, quítense sus ropas de fiesta, y veré lo que puedo hacer con ustedes.'"
,"6":"Y los hijos de Israel se quitaron sus trajes de fiesta al pie del monte Horeb."
,"7":"Entonces Moisés tomó la Tienda de campaña y la plantó a cierta distancia, fuera del campamento. La llamó Tienda de las Citas divinas, y todo el que quería consultar a Yavé tenía que ir a la Tienda de la Citas, fuera del campamento."
,"8":"Cada vez que Moisés iba a la Tienda de las Citas, todo el pueblo se ponía de pie a la entrada de sus carpas, y los ojos de todos lo seguían, hasta que entraba en ella."
,"9":"Y al entrar Moisés en la Tienda, la nube en forma de columna bajaba y se detenía a la entrada de la Tienda, mientras Yavé hablaba a Moisés."
,"10":"Cuando el pueblo veía la nube parada junto a la entrada de la Tienda, todos se ponían de pie y luego se postraban cada uno ante su carpa."
,"11":"Yavé hablaba con Moisés, cara a cara, como habla un hombre con su prójimo. Después Moisés volvía al campamento, pero su ayudante, el joven Josué, hijo de Nun, no se alejaba de la Tienda."
,"12":"Moisés dijo a Yavé: 'Tú me mandas que encabece a este pueblo, y no me das a conocer a quién enviarás conmigo. Sin embargo, me has dicho: Te conozco por tu nombre, y te he mirado con buenos ojos."
,"13":"Ahora, si realmente me miras con buenos ojos, dame a conocer caminos para que te conozca, y me sigas mirando bien: no olvides que esa gente es tu pueblo.'"
,"14":"Yavé respondió: 'Ve y haz lo que te diga, que yo te llevaré al descanso.'"
,"15":"Moisés contestó: 'Si tu Rostro no nos acompaña, no nos hagas salir de aquí."
,"16":"¿Cómo podrá verse que nos das tu preferencia a mí y a tu pueblo? ¿No será, acaso, en que tú nos acompañarás? Esto nos distinguirá, yo y tu pueblo, de todos los pueblos de la tierra.'"
,"17":"Yavé contestó a Moisés: 'También esto que me acabas de pedir, lo haré, pues te di mi preferencia y te conozco por tu nombre.'"
,"18":"Moisés dijo a Yavé: 'Por favor, déjame ver tu Gloria.'"
,"19":"Y El le contestó: 'Toda mi bondad va a pasar delante de ti, y yo mismo pronunciaré ante ti el Nombre de Yavé. Pues tengo piedad de quien quiero, y doy mi preferencia a quien la quiero dar.'"
,"20":"Y agregó Yavé: 'Pero mi cara no la podrás ver, porque no puede verme el hombre y seguir viviendo."
,"21":"Mira este lugar junto a mí. Te vas a quedar de pie sobre la roca y,"
,"22":"al pasar mi Gloria, te pondré en el hueco de la roca y te cubriré con mi mano hasta que yo haya pasado."
,"23":"Después sacaré mi mano y tú entonces verás mis espaldas; pero mi cara no se puede ver.'"
}`)
	CurrentBook.AddChapter(34, `{
"1":"Yavé dijo a Moisés: 'Labra dos tablas de piedra parecidas a las primeras y yo escribiré las palabras que había en las primeras que tú rompiste."
,"2":"Prepárate para subir mañana temprano al monte Sinaí, ahí esperarás en la cumbre."
,"3":"Pero que ninguno suba contigo, ni aparezca nadie en todo el monte: ni siquiera oveja ni buey paste en los alrededores.'"
,"4":"Moisés labró dos tablas de piedra semejantes a las anteriores, como lo había ordenado Yavé, y de madrugada subió al monte Sinaí llevando en sus manos las dos tablas de piedra."
,"5":"Yavé bajó en una nube y se quedó allí junto a él. Moisés entonces invocó el Nombre de Yavé, "
,"6":"y El pasó delante de Moisés diciendo con voz fuerte: 'Yavé, Yavé es un Dios misericordioso y clemente, tardo a la cólera y rico en amor y en fidelidad."
,"7":"El mantiene su benevolencia por mil generaciones y soporta la falta, la rebeldía y el pecado, pero nunca los deja sin castigo; pues por la falta de los padres pide cuentas a sus hijos y nietos hasta la tercera y la cuarta generación.'"
,"8":"Al momento Moisés cayó al suelo de rodillas, adorando a Dios,"
,"9":"y dijo: 'Señor, si realmente me miras con buenos ojos, ven y camina en medio de nosotros; aunque sea un pueblo rebelde, perdona nuestras faltas y pecados, y recíbenos por herencia tuya.'"
,"10":"Yavé dijo: Ahora mismo quiero firmar una alianza: voy a realizar, delante de todo este pueblo, prodigios como no los hubo jamás en ningún país y para ningún pueblo. Y todo este pueblo que te rodea verá las obras de Yavé, pues serán cosas asombrosas las que haré contigo."
,"11":"Observa lo que te ordeno en este día, y yo, por mi parte, arrojaré delante de ti al amorreo, al cananeo, al heteo, al fereceo, al jeveo y al jebuseo. - "
,"12":"No hagas ningún pacto con el habitante del país en que vas a entrar, no sea que se transforme en una trampa para ti."
,"13":"Más bien destruye sus altares, quiebra sus piedras levantadas y corta sus troncos sagrados. - "
,"14":"No te arrodillarás ante otro dios, pues Yavé lleva por nombre Celoso: él es un Dios celoso. No sea que te comprometas con la gente de aquellos países, que se prostituyen tras sus dioses y les ofrecen sacrificios."
,"15":"Pues te convidarán a comer de sus cosas sacrificadas,"
,"16":"y luego casarás a tus hijos con las hijas de ellos y, puesto que se prostituyen ellas por sus dioses, arrastrarán a tus hijos a prostituirse también a sus dioses. - "
,"17":"No te harás dioses de metal fundido. - "
,"18":"Respetarás la fiesta de los ázimos. Comerás pan sin levadura durante siete días, como te lo he ordenado, en el mes de la primavera, porque fue en ese mes de Aviv cuando saliste de Egipto. - "
,"19":"Todo primogénito es mío: todo primer nacido de tus ovejas y de tus vacas que sea macho."
,"20":"El burro primerizo lo rescatarás con un corderito; en caso de no ser rescatado, será muerto. Rescatarás el primero de tus hijos. No te presentarás ante mí con las manos vacías. - "
,"21":"Trabajarás seis días y al séptimo día descansarás, incluso en tiempo de aradura y de siega. - "
,"22":"Celebrarás la fiesta de las Semanas con las primeras siegas de tu trigo, y otra fiesta a fin de año al recoger todos los frutos."
,"23":"Se presentarán tres veces al año todos tus varones ante Yavé, el Señor y Dios de Israel."
,"24":"Pues yo arrojaré de tu presencia a los pueblos y agrandaré tus fronteras y nadie codiciará tu país, mientras tú subas tres veces al año a presentarte ante Yavé, tu Dios. - "
,"25":"No ofrecerás con pan fermentado la sangre de mis víctimas y no quedará hasta el otro día la víctima de la fiesta de Pascua. - "
,"26":"Llevarás los primeros frutos de tu tierra a la Casa de Yavé, tu Dios. -No cocerás el cabrito con la leche de su madre.'"
,"27":"Yavé terminó diciendo a Moisés: 'Pon por escrito estas palabras, pues éste es el compromiso de la Alianza que he pactado contigo y con los hijos de Israel.'"
,"28":"Estuvo allí con Yavé por espacio de cuarenta días y cuarenta noches, sin comer ni tomar agua. Y escribió en las tablas las palabras de la Alianza, los diez mandamientos."
,"29":"Cuando Moisés bajó del monte Sinaí, tenía en las manos las dos tablas de las Declaraciones divinas donde estaban escritas las leyes de la Alianza, y no sabía que la piel de su cara se había vuelto radiante, por haber hablado con Yavé."
,"30":"Aarón y los hijos de Israel vieron con sorpresa ese resplandor de la cara de Moisés, y sintieron miedo de acercarse a él."
,"31":"Pero Moisés los llamó y volvieron Aarón y los jefes de la comunidad; y Moisés les habló."
,"32":"El pueblo a su vez se acercó, y Moisés les comunicó todo lo que Yavé le había mandado en el monte Sinaí."
,"33":"Cuando Moisés terminó de hablar con ellos, se cubrió la cara con un velo."
,"34":"Cada vez que Moisés volvía donde Yavé para hablar con él, se quitaba el velo hasta que salía. Una vez fuera, comunicaba al pueblo lo que Yavé le había ordenado."
,"35":"Al ver los israelitas la cara de Moisés, notaban que su piel era radiante; pero Moisés volvía a ponerse el velo, hasta que entraba a hablar con Yavé."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Moisés reunió a toda la comunidad de los hijos de Israel y les dijo: 'Esto es lo que Yavé ha mandado hacer:"
,"2":"Trabajarás durante seis días, pero el día séptimo será sagrado para ustedes, día de descanso completo en honor a Yavé. Cualquiera que trabaje en ese día morirá."
,"3":"En ninguna de sus casas encenderán fuego el día sábado.'"
,"4":"Moisés dijo a toda la comunidad de Israel:"
,"5":"'Esta es la orden de Yavé: Que cada uno ofrezca algo de lo suyo a Yavé. Que todos los de corazón generoso le ofrezcan oro, plata y cobre,"
,"6":"púrpura violeta y escarlata, lino fino, pelo de cabra,"
,"7":"pieles de carnero teñidas de rojo, cueros finos y madera de acacia,"
,"8":"aceite para el alumbrado, aromas para el óleo de la unción y para el incienso aromático,"
,"9":"piedras de ónice y piedras de engaste para el Efod y el Pectoral."
,"10":"Que se presenten los artífices más hábiles de entre ustedes para hacer lo que Yavé ha ordenado:"
,"11":"la Morada, su Tienda y su cubierta, sus broches y tablones, sus travesaños, sus postes y sus basas;"
,"12":"el Arca y sus varas, el Lugar del Perdón y el velo que lo cubre;"
,"13":"la mesa y sus varas y todos los utensilios necesarios, el pan de la ofrenda,"
,"14":"el candelabro para el alumbrado con sus utensilios y sus lámparas y el aceite para la luz;"
,"15":"el altar del incienso con sus varas; el óleo de la unción, el incienso aromático, la cortina para la entrada de la Morada,"
,"16":"el altar de los holocaustos con su rejilla de bronce, sus varas y todos sus utensilios; la pila con su base;"
,"17":"los cortinajes del atrio con sus postes y sus basas; la cortina de la entrada del atrio;"
,"18":"todos los clavos necesarios para la Morada y para el atrio como también las cuerdas;"
,"19":"los ornamentos de ceremonia para oficiar en el Santuario; las vestiduras de la consagración del sacerdote Aarón y las vestiduras de sus hijos para las funciones sacerdotales.'"
,"20":"Entonces todo el pueblo de Israel se retiró de la presencia de Moisés;"
,"21":"todos aquellos a quienes su corazón movía, hombres de corazón generoso, vinieron a dejar su ofrenda para Yavé, para la construcción de la Tienda de las Citas, para todo su servicio y para las vestiduras sagradas."
,"22":"Venían hombres y mujeres: todos los de corazón generoso traían joyas, aros, anillos, collares y toda clase de objetos de oro, el oro que cada uno presentaba como ofrenda a Yavé."
,"23":"Los que tenían púrpura violeta y escarlata y carmesí, lino fino, pelo de cabra, pieles de carnero teñidas de rojo y cueros finos, lo traían también."
,"24":"Quienes pudieron reservar una ofrenda de plata y bronce la llevaron también como ofrenda para Yavé. Lo mismo hicieron los que poseían madera de acacia para los trabajos de la obra."
,"25":"Todas las mujeres hábiles en el oficio hilaron con sus manos la púrpura violeta, escarlata y carmesí y el lino fino, y después lo ofrecieron a Yavé."
,"26":"Las que sabían hilar el pelo de cabra lo hicieron."
,"27":"Los jefes trajeron piedras ágatas y engaste para el Efod y el Pectoral,"
,"28":"aromas y aceite para el alumbrado, para el óleo de la unción y para el incienso aromático."
,"29":"Todos los hijos de Israel, hombres y mujeres, a quienes su generosidad había impulsado a llevar algo para cualquiera de los trabajos que Yavé, por medio de Moisés, les había encomendado, trajeron sus ofrendas voluntarias a Yavé."
,"30":"Moisés dijo entonces a los hijos de Israel: 'Miren, Yavé ha designado a Bezaleel, hijo de Urí, hijo de Jur, de la tribu de Judá,"
,"31":"y lo ha llenado del espíritu de Dios, y de saber, de inteligencia, de ciencia y de capacidad en toda clase de trabajo"
,"32":"para crear obras de arte. Este hombre sabe trabajar oro, plata y bronce"
,"33":"y tallar tanto las piedras preciosas como la madera. Es entendido en toda clase de trabajos."
,"34":"A él y a Oholiab, hijo de Ajisamac, de la tribu de Dan, Yavé les ha infundido el don de enseñar."
,"35":"Les ha llenado de habilidad para toda clase de labores de artesanos o artistas, para bordar la púrpura violeta y escarlata, el carmesí y el lino fino, y para todo tipo de tejido. Son muy capaces para ejecutar toda clase de trabajos y obras de arte."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Así, pues, Bezaleel, Oholiab y todos los hombres peritos a los que Yavé ha dado habilidad y pericia para saber realizar todos los trabajos en servicio del Santuario, ejecutarán todo conforme lo ha mandado Yavé.'"
,"2":"Moisés llamó a Bezaleel y a Oholiab y a todos los hombres hábiles a los que Yavé había dado pericia, y a todas las personas deseosas de trabajar para el Santuario,"
,"3":"y les entregó todas las ofrendas que los hijos de Israel habían reservado para la ejecución de las obras del Santuario. Mientras tanto, los hijos de Israel seguían entregando a Moisés, cada mañana, ofrendas voluntarias."
,"4":"Por eso, todos los artesanos que trabajaban en la construcción del Santuario, además de su propio trabajo,"
,"5":"fueron a decir a Moisés: 'El pueblo entrega más de lo que se necesita para la construcción de las obras que Yavé ha mandado hacer.'"
,"6":"Entonces Moisés mandó correr la voz por todo el pueblo: 'Ni hombre ni mujer reserve ya más ofrendas para el Santuario.'"
,"7":"El pueblo, pues, dejó de traer ofrendas, pues había material de sobra para construir toda la obra."
,"8":"Entonces los artesanos más expertos de entre los que ejecutaban el trabajo hicieron la Morada. Hicieron diez cortinas de lino fino retorcido de color jacinto, morado y rojo, adornadas con querubines."
,"9":"Cada cortina tenía catorce metros de largo y dos de ancho. Todas eran de una misma medida."
,"10":"Reunieron las primeras cinco cortinas y lo mismo las otras cinco."
,"11":"Pusieron cordones de color morado en los bordes de la cortina que terminaba el primer conjunto, e hicieron lo mismo con los bordes de la cortina que terminaba el segundo conjunto."
,"12":"Cada conjunto tenía por ambas partes cincuenta cordones, dispuestos de tal modo que el uno correspondía al otro, y se podían ajustar entre sí."
,"13":"Hicieron asimismo cincuenta broches de oro, con los que se reunieron las cortinas. Así la tienda fue una sola."
,"14":"También hicieron una cubierta de pelo de cabra para el techo de la Morada. Había once piezas."
,"15":"Cada una de ellas tenía quince metros de largo y dos de ancho."
,"16":"Todas eran de la misma medida. Juntaron las cinco primeras y lo mismo las otras seis."
,"17":"Hicieron también en la orilla de cada cubierta cincuenta presillas, para que se pudiera unir con la otra, y cincuenta presillas en la orilla de ésta para unirla a la contigua."
,"18":"Hicieron asimismo cincuenta hebillas de bronce, mediante las cuales se formó un solo toldo."
,"19":"Hicieron también a la Morada otra cubierta de pieles de carnero, teñidas de rojo, y sobre ésta otra cubierta de cueros finos."
,"20":"Hicieron asimismo tablones de madera de acacia derechos,"
,"21":"cada uno de los cuales tenía cinco metros de largo por setenta y cinco centímetros de ancho."
,"22":"En los lados de cada tablón se hicieron dos muescas para encajar un tablón con otro, y de este modo se dispusieron todos los tablones. Veinte de éstos se pusieron en el lado meridional,"
,"23":"para los cuales se fundieron cuarenta basas de plata, de suerte que dos basas sostenían los dos ángulos de cada tablón."
,"24":"En la misma forma se pusieron veinte tablones al otro lado de la Morada que mira al norte,"
,"25":"los cuales tenían cuarenta basas de plata:"
,"26":"dos basas debajo de cada tablón."
,"27":"En la parte occidental de la Morada se pusieron seis tablones"
,"28":"además de otros dos que hubo que fijar a la espalda del Tabernáculo en las esquinas,"
,"29":"y estuvieron trabados de arriba abajo y asegurados todos con un mismo encaje. El mismo trabajo se hizo para los dos tablones que se hubo de colocar en las esquinas."
,"30":"Así fueron en total ocho tablones los que había en el fondo con dieciséis basas de plata, dando a cada tablón dos basas."
,"31":"También hizo cinco travesaños de madera de acacia en un lado de la Morada, que afianzaron los tablones,"
,"32":"y otros cinco al otro lado, y al occidente otros tantos,"
,"33":"los cuales atravesaban los tablones de un extremo a otro."
,"34":"Cubrió asimismo con planchas de oro los tablones, y para ello hizo argollas de oro, por las cuales pasaban los travesaños y los cubrió con láminas de oro."
,"35":"Además de esto hizo un velo de lino fino retorcido de color morado, púrpura, y de grana dos veces teñida, bordado de querubines, obra de artista;"
,"36":"el cual colgó ante cuatro columnas de madera de acacia, que estaban también cubiertas de oro, y tenían ganchos de oro, estando puestas sobre basas de plata."
,"37":"Hizo para la entrada de la Morada una cortina de lino fino color morado, púrpura y de grana dos veces teñida, con labores de tapicería."
,"38":"Hizo las cinco columnas con sus ganchos. Cubrió de oro los capiteles y las varillas. Las basas eran de bronce."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Bezaleel hizo el Arca de madera de acacia, con una longitud de dos codos y medio, codo y medio de anchura y otro codo y medio de altura."
,"2":"La revistió por dentro y por fuera con láminas de oro; hizo además una moldura de oro alrededor."
,"3":"Le pusieron cuatro anillos de oro, uno en cada ángulo del Arca, dos en un lado y dos en otro."
,"4":"Hicieron también las varas de madera de acacia y las cubrió con láminas de oro."
,"5":"Las pasaron por los anillos que estaban a los lados del Arca y sirvieron para llevarla."
,"6":"Hizo el Lugar del Perdón de oro puro, de dos codos y medio de largo y codo y medio de ancho."
,"7":"Asimismo hizo dos querubines de oro macizo y los puso en las extremidades del Lugar del Perdón,"
,"8":"uno a cada lado, haciendo un cuerpo con el Lugar del Perdón."
,"9":"Los dos querubines tenían las alas extendidas y cubrían con sus alas el Lugar del Perdón. Estaban uno frente al otro y sus caras miraban al Lugar del Perdón."
,"10":"Hizo también una mesa de madera de acacia, de dos codos de largo, uno de ancho y uno y medio de alto."
,"11":"La cubrió con láminas de oro puro y le puso alrededor una moldura de oro,"
,"12":"le hizo un borde de cuatro dedos de alto y encima de éste puso una moldura de oro."
,"13":"Formó asimismo cuatro anillos de oro y los puso en las cuatro esquinas de la mesa, uno para cada pata."
,"14":"Los anillos estaban debajo de la cornisa para meter las varas por ellos a fin de que pudiera transportarse la mesa."
,"15":"Hizo también de madera de acacia estas varas y las cubrió con planchas de oro, pues sirvieron para transportar la mesa."
,"16":"Hizo también los utensilios que están en la mesa; las fuentes, los vasos, los jarros y las tazas para las libaciones; todo era de oro."
,"17":"Labró igualmente de oro puro el candelabro. Era de oro macizo su pie y su tallo. Sus cálices y nudos y flores formaban un cuerpo con él."
,"18":"Salían seis brazos de sus lados: tres de uno y tres de otro."
,"19":"Cada brazo tenía tres cálices en forma de flor de almendro, con capullos y flores."
,"20":"En el mismo candelabro había cuatro cálices en forma de flor de almendro con capullos y flores;"
,"21":"un capullo debajo de los dos primeros brazos que formaban cuerpo con el candelabro; otro, debajo de los siguientes y un tercero debajo de los dos últimos brazos; se hizo lo mismo para los seis brazos que salían del candelabro."
,"22":"Los capullos y los brazos formaban un cuerpo con el candelabro. Todo ello era de oro puro macizo."
,"23":"Hizo sus siete lámparas; sus despabiladeras y ceniceros eran de oro puro."
,"24":"Se empleó un talento de oro para hacer el candelabro con todos estos utensilios."
,"25":"Hizo también el Altar del Incienso. Lo hizo de madera de acacia. Tenía medio metro de largo y de ancho: era cuadrado. Tenía un metro de altura. Sus cuernos formaban un cuerpo con él."
,"26":"Cubrió de oro la mesa, los costados y los cuernos; también hizo una moldura de oro alrededor."
,"27":"Debajo de dicha moldura hizo dos anillos de oro a ambos lados para meter en ellos las varas con que lo transportarían."
,"28":"Hizo las varas de madera de acacia y las cubrió de oro."
,"29":"Hizo el óleo de la consagración y el incienso aromático, obra de perfumista."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Hizo también el Altar de los Holocaustos de madera de acacia. Tenía dos metros y medio de largo y otros tantos de ancho, esto es, cuadrado, y metro y medio de altura."
,"2":"De sus cuatro esquinas salían cuatro cuernos que formaban un cuerpo con él. Los cubrió con láminas de bronce."
,"3":"Para el servicio del altar fabricó las calderas, tenazas, tridentes y braseros. Todos estos instrumentos los hizo de bronce."
,"4":"Además un enrejado de bronce en forma de red, que se ponía debajo del plano del altar y llegaba a media altura."
,"5":"En los cuatro ángulos le hizo anillos de bronce para sus varas."
,"6":"Hizo también dos varas de madera de acacia, cubiertas con láminas de bronce,"
,"7":"y las pasó por los anillos: estaban a los dos lados del altar para transportarlo. Hizo el altar hueco, de paneles."
,"8":"Hizo también la pileta y la basa de bronce, con los espejos de bronce pulido de las mujeres que servían a la entrada de la Tienda de las Citas."
,"9":"Hizo asimismo el atrio de la Morada, en cuya parte meridional había cortinas de lino fino retorcido de cincuenta metros de largo,"
,"10":"con veinte columnas puestas en otras tantas basas de bronce, cuyos ganchos y varillas eran de plata."
,"11":"Igualmente en el lado septentrional había a lo largo cortinas de cincuenta metros con veinte columnas y otras tantas basas de bronce, y sus ganchos y varillas de plata."
,"12":"Además, en lo ancho del atrio que mira al oeste había cortinas por espacio de veinticinco metros, con diez columnas y otras tantas basas de bronce."
,"13":"Del mismo modo, en lo ancho del atrio que cae al oriente se contaron veinticinco metros;"
,"14":"se pusieron cortinas de siete metros y medio por cada lado,"
,"15":"con tres columnas y otras tantas basas por cada lado."
,"16":"Todas las cortinas del atrio alrededor eran de fino lino retorcido."
,"17":"Las basas de las columnas eran de bronce. Los ganchos y las varillas eran de plata; los capiteles estaban cubiertos de plata."
,"18":"Pero a la entrada del atrio se puso una cortina de diez metros de lino fino retorcido color morado, púrpura y de grana dos veces teñida: una obra de bordador. Tenía diez metros de largo y dos y medio de altura, como las cortinas del atrio."
,"19":"Sus cuatro columnas y basas eran de bronce, sus ganchos y varillas de plata. Sus capiteles estaban cubiertos de plata."
,"20":"Las estacas y clavos, tanto de la Morada como del atrio, eran de bronce."
,"21":"Este era el inventario de la Morada de la Alianza, realizado por orden de Moisés y hecho por los levitas bajo la dirección de Itamar, hijo del sacerdote Aarón."
,"22":"Bezaleel, hijo de Urí, hijo de Jur, de la tribu de Judá, hizo todo cuanto Yavé había mandado a Moisés,"
,"23":"juntamente con Oholiab, hijo de Ajisamac, de la tribu de Dan, que era artesano, bordador en púrpura, violeta y escarlata, en carmesí y lino fino."
,"24":"El total de oro empleado en el trabajo, en todo el trabajo del Santuario, el oro que ofreció el pueblo, fue de veintinueve talentos y setecientos treinta siclos, en siclos del Santuario;"
,"25":"la plata entregada por los hombres incluidos en el censo de la comunidad fue de cien talentos y mil setecientos sesenta y cinco siclos, según el peso del Santuario."
,"26":"Pues se contaba medio siclo, en siclos del Santuario, por cabeza."
,"27":"Los cien talentos de plata se emplearon en fundir las basas del Santuario y las basas de las columnas que sostenían el velo; cien basas correspondientes a los cien talentos, un talento por basa."
,"28":"De los mil setecientos setenta y cinco siclos hizo ganchos para los postes, revistió sus capiteles y los unió con varillas."
,"29":"El bronce que ofrecieron fue de setenta talentos y dos mil cuatrocientos siclos."
,"30":"Con él hizo las basas para la entrada de la Tienda de las Citas, el altar de bronce con su rejilla de bronce también y todos los utensilios del altar,"
,"31":"las basas del recinto del atrio y las basas de la entrada del atrio, todos los clavos que se ocuparon en la Morada y en el atrio que la rodeaba."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Hicieron para el servicio del Santuario vestiduras de ceremonia de púrpura violeta y escarlata, de carmesí y lino fino. Hicieron asimismo las vestiduras sagradas de Aarón, como Yavé había mandado a Moisés."
,"2":"Hicieron el Efod de oro, de púrpura violeta y escarlata, de carmesí y lino fino retorcido."
,"3":"Batieron oro en láminas y las cortaron en hilos para bordar junto con la púrpura violeta y escarlata, con el carmesí y el lino fino."
,"4":"El Efod tenía dos hombreras que se juntaban y estaban unidas por sus extremos."
,"5":"El cinturón con que se ciñe el Efod era de la misma hechura y de los mismos materiales y formaba con él una sola pieza, tal como Yavé se lo había mandado a Moisés."
,"6":"Prepararon igualmente las piedras ónices engastadas en oro y grabadas, como se graban los sellos, con los nombres de los hijos de Israel;"
,"7":"las colocaron sobre las hombreras del Efod, como piedras que sirvieran para recordar a los hijos de Israel, según había ordenado a Moisés."
,"8":"Bordaron también el Pectoral, del mismo estilo que el Efod, de oro, púrpura violeta y escarlata, carmesí y lino fino retorcido."
,"9":"Era cuadrado y doble: tenía un palmo de largo por uno de ancho."
,"10":"Llevaba cuatro filas de piedras; en la primera fila había un sardio, un topacio y una esmeralda;"
,"11":"en la segunda fila, un rubí, un zafiro y un diamante;"
,"12":"en la tercera, un ópalo, un ágata y una amatista;"
,"13":"y en la cuarta, un crisolito, un ónice y un jaspe. Todas ellas engastadas en oro."
,"14":"Las piedras eran doce, correspondientes a los nombres de los hijos de Israel, y grabada cada piedra con el nombre de cada uno de ellos conforme a las doce tribus."
,"15":"Hicieron para el Pectoral cadenillas de oro puro, trenzadas a manera de cordones."
,"16":"Hicieron dos engastes de oro y dos anillos de oro y fijaron los dos anillos en los dos extremos."
,"17":"Pasaron después las dos cadenillas de oro por los dos anillos de los extremos del Pectoral."
,"18":"Unieron los dos extremos de las dos cadenillas a los dos engastes que fijaron en la parte inferior de los hombros del Efod."
,"19":"Se hicieron otros dos anillos de oro, que se pusieron en los extremos inferiores del Pectoral, en la parte baja del Efod por fuera."
,"20":"Se hicieron otros dos anillos de oro, que se pusieron en las dos hombreras del Efod abajo, en la parte delantera, cerca de la juntura por encima del cinturón del Efod,"
,"21":"y fijaron el Pectoral uniéndolo por sus anillos a los anillos del Efod para sostenerlo encima del cinturón del Efod, con un cordón de púrpura violeta, para que quedara el Pectoral sobre el cinturón del Efod y no se desprendiera, como Yavé había mandado a Moisés."
,"22":"Tejieron el manto del Efod todo de púrpura violeta."
,"23":"Había una abertura en el centro del manto, semejante al cuello de un corselete, con una orla alrededor de la abertura, para que no se rompiera."
,"24":"En el ruedo inferior del manto hicieron granadas de púrpura violeta y escarlata, de carmesí y lino fino retorcido."
,"25":"Hicieron campanillas de oro puro, que resonaran cuando oficiara el sacerdote, colocadas entre las granadas, en todo el ruedo,"
,"26":"alternando una campanilla y una granada en la parte inferior del manto, como Yavé había ordenado a Moisés."
,"27":"Tejieron también las túnicas de lino fino para Aarón y sus hijos; la tiara de lino fino, los adornos de las mitras de lino fino"
,"28":"y también los calzoncillos de lino fino retorcido,"
,"29":"lo mismo que las fajas de lino fino retorcido, de púrpura violeta y escarlata y de carmesí, tal como Yavé había ordenado a Moisés."
,"30":"E hicieron de oro puro una lámina, la diadema sagrada, en la que grabaron, como se graban los sellos: 'Consagrado a Yavé'."
,"31":"La fijaron con un cordón de púrpura violeta para sujetarla en la parte superior de la tiara, como Yavé había mandado a Moisés."
,"32":"Así fue terminada toda la obra de la Morada, es decir, de la Tienda de las Citas; los hijos de Israel hicieron toda la obra conforme a lo que Yavé había mandado a Moisés."
,"33":"Entonces presentaron a Moisés la Morada, es decir, la Tienda y todos sus utensilios; los broches, los tablones, los travesaños, los postes y las basas;"
,"34":"el toldo de pieles de carnero teñidas de rojo, el toldo de cueros finos y el velo protector;"
,"35":"el Arca de la Alianza con sus varas y el Lugar del Perdón;"
,"36":"la mesa con todos sus utensilios y el pan de la ofrenda,"
,"37":"el candelabro de oro puro con sus lámparas, todos los utensilios y el aceite del alumbrado;"
,"38":"el altar de oro, el óleo de la unción, el incienso aromático y la cortina para la entrada de la tienda;"
,"39":"el altar de bronce con su enrejado, sus varas y sus utensilios, la pileta con su base;"
,"40":"el cortinaje del atrio, los postes con sus basas, la cortina para la entrada del atrio, sus cuerdas, clavos y todos los demás utensilios del servicio de la Morada, la Tienda de las Citas;"
,"41":"las vestiduras de ceremonia para el servicio en el Santuario; los ornamentos sagrados para el sacerdote Aarón y las vestiduras de sus hijos para ejercer el sacerdocio."
,"42":"Los hijos de Israel hicieron toda la obra conforme a cuanto Yavé había ordenado a Moisés."
,"43":"Moisés vio todo el trabajo y comprobó que lo habían hecho conforme a lo que había mandado Yavé. Entonces Moisés los bendijo."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Yavé habló así a Moisés:"
,"2":"'El día primero del primer mes alzarás la Morada, la Tienda de las Citas."
,"3":"Allí pondrás el Arca de la Alianza y cubrirás el Arca con la cortina."
,"4":"Llevarás la mesa y la dispondrás. Llevarás también el candelabro y prepararás las lámparas."
,"5":"Colocarás el altar de oro para el incienso delante del Arca de la Alianza y colgarás la cortina a la entrada de la Morada."
,"6":"Colocarás el altar de los holocaustos ante la entrada de la Tienda de las Citas. Pondrás la pila entre la Tienda de las Citas y el Altar y echarás agua en ella."
,"7":"En derredor levantarás el atrio y tenderás la cortina a la entrada del atrio."
,"8":"Entonces tomarás el óleo de la unción y ungirás la Morada y todo lo que hay en ella."
,"9":"La consagrarás con todo su mobiliario y será cosa sagrada."
,"10":"Ungirás además el altar de los holocaustos con todos sus utensilios. Consagrarás el altar y en adelante será cosa sacratísima."
,"11":"Asimismo ungirás la pila y su base y la consagrarás."
,"12":"Después mandarás que Aarón y sus hijos se acerquen a la entrada de la Tienda de las Citas y los lavarás con agua."
,"13":"Vestirás a Aarón con las vestiduras sagradas, lo ungirás y lo consagrarás para que sea mi sacerdote."
,"14":"Mandarás también que se acerquen sus hijos, los vestirás con túnicas,"
,"15":"los ungirás como ungiste a su padre, para que sean mis sacerdotes. Así por su unción serán sacerdotes míos para siempre, de generación en generación.'"
,"16":"Moisés hizo todo según lo que Yavé le había mandado. Así lo hizo."
,"17":"En el primer mes del año segundo, el día primero del mes, alzaron la Morada."
,"18":"Moisés alzó la Morada, asentó las basas, colocó sus tablones, puso los travesaños y erigió sus columnas."
,"19":"Después desplegó la Tienda por encima de la Morada y puso además por encima el toldo de la Tienda, como Yavé había mandado a Moisés."
,"20":"Luego tomó el Testimonio y lo puso en el Arca, puso al Arca las varas y sobre ella colocó el Lugar del Perdón en la parte superior."
,"21":"Llevó entonces el Arca a la Morada, colgó la cortina y cubrió así el Arca de la Alianza, como Yavé había mandado a Moisés."
,"22":"Colocó también la mesa en la Tienda de las Citas, al lado septentrional de la Morada, fuera del velo."
,"23":"Dispuso sobre ella las filas de los panes de la Presencia delante de Yavé, como él había ordenado a Moisés."
,"24":"Luego instaló el candelabro en la Tienda de las Citas, frente a la mesa, en el lado meridional de la Morada,"
,"25":"y colocó encima las lámparas delante de Yavé, como él había ordenado a Moisés."
,"26":"Asimismo puso el altar de oro en la Tienda de las Citas, delante del velo,"
,"27":"y quemó sobre él incienso aromático, como Yavé había mandado a Moisés."
,"28":"A la entrada de la Morada colocó la cortina, y en la misma entrada de la Morada colocó también el altar de los holocaustos,"
,"29":"sobre el cual ofreció el holocausto y la ofrenda, como Yavé le había mandado."
,"30":"Puso la pileta entre la Tienda de las Citas y el altar y echó agua en ella para las abluciones;"
,"31":"Aarón y sus hijos se lavaron en ella las manos y los pies."
,"32":"Siempre que entraban en la Tienda de las Citas y siempre que se acercaban al altar se lavaban, como Yavé había mandado a Moisés."
,"33":"Por fin, dispuso el atrio que rodeaba el Santuario y el altar y colgó la cortina a la entrada del atrio. Así Moisés terminó todas las obras."
,"34":"Entonces la Nube vino a cubrir la Tienda de las Citas y la Gloria de Yavé llenó la Morada."
,"35":"Moisés ya no podía entrar en la Tienda de las Citas, pues la Nube descansaba sobre ella y la Gloria de Yavé llenaba la Morada."
,"36":"A lo largo de su trayecto, los hijos de Israel se ponían en marcha en cuanto la Nube se elevaba de encima de la Morada."
,"37":"Pero mientras la Nube no se elevaba, ellos no se movían y esperaban el día en que de nuevo se elevara."
,"38":"Porque la Nube de Yavé descansaba sobre la Morada durante el día a la vista de todo el pueblo de Israel, y durante la noche había fuego. Así sucedió a lo largo de su trayecto."
}`)

}
func ES_LBL_LoadVPGNChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"En el principio, cuando Dios creó los cielos y la tierra,"
,"2":"todo era confusión y no había nada en la tierra. Las tinieblas cubrían los abismos mientras el Espíritu de Dios aleteaba sobre la superficie de las Aguas."
,"3":"Dijo Dios: 'Haya luz', y hubo luz."
,"4":"Dios vio que la luz era buena, y separó la luz de las tinieblas."
,"5":"Dios llamó a la luz 'Día' y a las tinieblas 'Noche'. Atardeció y amaneció: fue el día Primero."
,"6":"Dijo Dios: 'Haya una bóveda en medio de las aguas, para que separe unas aguas de las otras.'"
,"7":"Hizo Dios entonces como una bóveda y separó unas aguas de las otras: las que estaban por encima del firmamento, de las que estaban por debajo de él. Y así sucedió."
,"8":"Dios llamó a esta bóveda 'Cielo'. Y atardeció y amaneció: fue el día Segundo."
,"9":"Dijo Dios: 'Júntense las aguas de debajo de los cielos en un solo depósito, y aparezca el suelo seco.' Y así fue."
,"10":"Dios llamó al suelo seco 'Tierra' y al depósito de las Aguas 'Mares'. Y vio Dios que esto era bueno."
,"11":"Dijo Dios: 'Produzca la tierra hortalizas, plantas que den semilla, y árboles frutales que por toda la tierra den fruto con su semilla dentro, cada uno según su especie.' Y así fue."
,"12":"La tierra produjo hortalizas, plantas que dan semillas y árboles frutales que dan fruto con su semilla dentro, cada uno según su especie. Dios vio que esto era bueno."
,"13":"Y atardeció y amaneció: fue el día Tercero."
,"14":"Dijo Dios: 'Haya lámparas en el cielo que separen el día de la noche, que sirvan para señalar las fiestas, los días y los años,"
,"15":"y que brillen en el firmamento para iluminar la tierra.' Y así sucedió."
,"16":"Hizo, pues, Dios dos grandes lámparas: la más grande para presidir el día y la más chica para presidir la noche, e hizo también las estrellas."
,"17":"Dios las colocó en lo alto de los cielos para iluminar la tierra,"
,"18":"para presidir el día y la noche y separar la luz de las tinieblas; y vio Dios que esto era bueno."
,"19":"Y atardeció y amaneció: fue el día Cuarto."
,"20":"Dijo Dios: 'Llénense las aguas de seres vivientes y revoloteen aves sobre la tierra y bajo el firmamento.'"
,"21":"Dios creó entonces los grandes monstruos marinos y todos los seres que viven en el agua según su especie, y todas las aves, según su especie. Y vio Dios que todo ello era bueno."
,"22":"Los bendijo Dios, diciendo: 'Crezcan, multiplíquense y llenen las aguas del mar, y multiplíquense asimismo las aves sobre la tierra.'"
,"23":"Y atardeció y amaneció: fue el día Quinto."
,"24":"Dijo Dios: 'Produzca la tierra animales vivientes de diferentes especies, animales del campo, reptiles y animales salvajes.' Y así fue."
,"25":"Dios hizo las distintas clases de animales salvajes según su especie, los animales del campo según su especie, y todos los reptiles de la tierra según su especie. Y vio Dios que todo esto era bueno."
,"26":"Dijo Dios: 'Hagamos al hombre a nuestra imagen y semejanza. Que tenga autoridad sobre los peces del mar y sobre las aves del cielo, sobre los animales del campo, las fieras salvajes y los reptiles que se arrastran por el suelo.'"
,"27":"Y creó Dios al hombre a su imagen. A imagen de Dios lo creó. Macho y hembra los creó."
,"28":"Dios los bendijo, diciéndoles: 'Sean fecundos y multiplíquense. Llenen la tierra y sométanla. Tengan autoridad sobre los peces del mar, sobre las aves del cielo y sobre todo ser viviente que se mueve sobre la tierra.'"
,"29":"Dijo Dios: 'Hoy les entrego para que se alimenten toda clase de plantas con semillas que hay sobre la tierra, y toda clase de árboles frutales."
,"30":"A los animales salvajes, a las aves del cielo y a todos los seres vivientes que se mueven sobre la tierra, les doy pasto verde para que coman.' Y así fue."
,"31":"Dios vio que todo cuanto había hecho era muy bueno. Y atardeció y amaneció: fue el día Sexto."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Así estuvieron terminados el cielo, la tierra y todo lo que hay en ellos."
,"2":"El Séptimo día Dios tuvo terminado su trabajo, y descansó en ese día de todo lo que había hecho."
,"3":"Bendijo Dios el Séptimo día y lo hizo santo, porque ese día descansó de sus trabajos después de toda esta creación que había hecho."
,"4":"Este es el origen del cielo y de la tierra cuando fueron creados. El día en que Yavé Dios hizo la tierra y los cielos, "
,"5":"no había sobre la tierra arbusto alguno, ni había brotado aún ninguna planta silvestre, pues Yavé Dios no había hecho llover todavía sobre la tierra, y tampoco había hombre que cultivara el suelo"
,"6":"e hiciera subir el agua para regar toda la superficie del suelo."
,"7":"Entonces Yavé Dios formó al hombre con polvo de la tierra; luego sopló en sus narices un aliento de vida, y existió el hombre con aliento y vida."
,"8":"Yavé Dios plantó un jardín en un lugar del Oriente llamado Edén, y colocó allí al hombre que había formado."
,"9":"Yavé Dios hizo brotar del suelo toda clase de árboles, agradables a la vista y buenos para comer. El árbol de la Vida estaba en el jardín, como también el árbol de la Ciencia del bien y del mal."
,"10":"Del Edén salía un río que regaba el jardín y se dividía en cuatro brazos."
,"11":"El primero se llama Pisón, y corre rodeando toda la tierra de Evila donde hay oro,"
,"12":"oro muy fino. Allí se encuentran también aromas y piedras preciosas."
,"13":"El segundo río se llamaba Guijón y rodea la tierra de Cus."
,"14":"El tercer río se llama Tigris, y fluye al oriente de Asiria. Y el cuarto río es el Eufrates."
,"15":"Yavé Dios tomó al hombre y lo puso en el jardín del Edén para que lo cultivara y lo cuidara."
,"16":"Y Yavé Dios le dio al hombre un mandamiento; le dijo: 'Puedes comer todo lo que quieras de los árboles del jardín,"
,"17":"pero no comerás del árbol de la Ciencia del bien y del mal. El día que comas de él, ten la seguridad de que morirás.'"
,"18":"Dijo Yavé Dios: 'No es bueno que el hombre esté solo. Le daré, pues, un ser semejante a él para que lo ayude.'"
,"19":"Entonces Yavé Dios formó de la tierra a todos los animales del campo y a todas las aves del cielo, y los llevó ante el hombre para que les pusiera nombre. Y el nombre de todo ser viviente había de ser el que el hombre le había dado."
,"20":"El hombre puso nombre a todos los animales, a las aves del cielo y a las fieras salvajes. Pero no se encontró a ninguno que fuera a su altura y lo ayudara."
,"21":"Entonces Yavé hizo caer en un profundo sueño al hombre y éste se durmió. Le sacó una de sus costillas y rellenó el hueco con carne."
,"22":"De la costilla que Yavé había sacado al hombre, formó una mujer y la llevó ante el hombre. Entonces el hombre exclamó:"
,"23":"'Esta sí es hueso de mis huesos y carne de mi carne. Esta será llamada varona porque del varón ha sido tomada.'"
,"24":"Por eso el hombre deja a su padre y a su madre para unirse a su mujer, y pasan a ser una sola carne."
,"25":"Los dos estaban desnudos, hombre y mujer, pero no sentían vergüenza."
}`)
	CurrentBook.AddChapter(3, `{
"1":"La serpiente era el más astuto de todos los animales del campo que Yavé Dios había hecho. Dijo a la mujer: '¿Es cierto que Dios les ha dicho: No coman de ninguno de los árboles del jardín?'"
,"2":"La mujer respondió a la serpiente: 'Podemos comer de los frutos de los árboles del jardín,"
,"3":"pero no de ese árbol que está en medio del jardín, pues Dios nos ha dicho: No coman de él ni lo prueban siquiera, porque si lo hacen morirán.'"
,"4":"La serpiente dijo a la mujer: 'No es cierto que morirán."
,"5":"Es que Dios sabe muy bien que el día en que coman de él, se les abrirán a ustedes los ojos; entonces ustedes serán como dioses y conocerán lo que es bueno y lo que no lo es.'"
,"6":"A la mujer le gustó ese árbol que atraía la vista y que era tan excelente para alcanzar el conocimiento. Tomó de su fruto y se lo comió y le dio también a su marido que andaba con ella, quien también lo comió."
,"7":"Entonces se les abrieron los ojos y ambos se dieron cuenta de que estaban desnudos. Cosieron, pues, unas hojas de higuera, y se hicieron unos taparrabos."
,"8":"Oyeron después la voz de Yavé Dios que se paseaba por el jardín, a la hora de la brisa de la tarde. El hombre y su mujer se escondieron entre los árboles del jardín para que Yavé Dios no los viera."
,"9":"Yavé Dios llamó al hombre y le dijo: '¿Dónde estás?'"
,"10":"Este contestó: 'He oído tu voz en el jardín, y tuve miedo porque estoy desnudo; por eso me escondí.',Yavé Dios replicó: "
,"11":"'¿Quién te ha hecho ver que estabas desnudo? ¿Has comido acaso del árbol que te prohibí?'"
,"12":"El hombre respondió: 'La mujer que pusiste a mi lado me dio del árbol y comí.'"
,"13":"Yavé dijo a la mujer: '¿Qué has hecho?' La mujer respondió: 'La serpiente me engañó y he comido.'"
,"14":"Entonces Yavé Dios dijo a la serpiente: 'Por haber hecho esto, maldita seas entre todas las bestias y entre todos los animales del campo. Te arrastrarás sobre tu vientre y comerás tierra por todos los días de tu vida."
,"15":"Haré que haya enemistad entre ti y la mujer, entre tu descendencia y la suya. Ella te pisará la cabeza mientras tú herirás su talón.'"
,"16":"A la mujer le dijo: 'Multiplicaré tus sufrimientos en los embarazos y darás a luz a tus hijos con dolor. Siempre te hará falta un hombre, y él te dominará.'"
,"17":"Al hombre le dijo: 'Por haber escuchado a tu mujer y haber comido del árbol del que Yo te había prohibido comer, maldita sea la tierra por tu causa. Con fatiga sacarás de ella el alimento por todos los días de tu vida."
,"18":"Espinas y cardos te dará, mientras le pides las hortalizas que comes."
,"19":"Con el sudor de tu frente comerás tu pan hasta que vuelvas a la tierra, pues de ella fuiste sacado. Sepas que eres polvo y al polvo volverás.'"
,"20":"El hombre dio a su mujer el nombre de 'Eva', por ser la madre de todo viviente."
,"21":"En seguida Yavé Dios hizo para el hombre y su mujer unos vestidos de piel y con ellos los vistió."
,"22":"Entonces Yavé Dios dijo: 'Ahora el hombre es como uno de nosotros, pues se ha hecho juez de lo bueno y de lo malo. Que no vaya también a extender su mano y tomar del Arbol de la Vida, pues viviría para siempre.'"
,"23":"Y así fue como Dios lo expulsó del jardín del Edén para que trabajara la tierra de la que había sido formado."
,"24":"Habiendo expulsado al hombre, puso querubines al oriente del jardín del Edén, y también un remolino que disparaba rayos, para guardar el camino hacia el Arbol de la Vida."
}`)
	CurrentBook.AddChapter(4, `{
"1":"El Adán se unió a Eva, su mujer, la cual quedó embarazada y dio a luz a Caín. En esta oportunidad dijo: 'Gracias a Yavé me conseguí un hijo.'"
,"2":"Después dio a luz a Abel, el hermano de Caín. Abel fue pastor de ovejas, mientras que Caín labraba la tierra."
,"3":"Pasado algún tiempo, Caín presentó a Yavé una ofrenda de los frutos de la tierra."
,"4":"También Abel le hizo una ofrenda, sacrificando los primeros nacidos de sus rebaños y quemando su grasa."
,"5":"A Yavé le agradó Abel y su ofrenda, mientras que le desagradó Caín y la suya. Ante esto Caín se enojó mucho y su rostro se descompuso."
,"6":"Yavé le dijo: '¿Por qué andas enojado y con la cabeza baja? Si obras bien, podrás levantar tu vista."
,"7":"Pero tú no obras bien y el pecado está agazapado a las puertas de tu casa. El te acecha como fiera, pero tú debes dominarlo.'"
,"8":"Caín dijo después a su hermano Abel: 'Vamos al campo.' Y como estaban en el campo, Caín se lanzó contra su hermano Abel y lo mató."
,"9":"Yavé preguntó a Caín: '¿Dónde está tu hermano?' Respondió: 'No lo sé. ¿Soy acaso el guardián de mi hermano?'"
,"10":"Entonces Yavé le dijo: '¿Qué has hecho? Clama la sangre de tu hermano y su grito me llega desde la tierra."
,"11":"En adelante serás maldito, y vivirás lejos de este suelo fértil que se ha abierto para recibir la sangre de tu hermano, que tu mano ha derramado."
,"12":"Cuando cultives la tierra, no te dará frutos; andarás errante y fugitivo sobre la tierra.'"
,"13":"Caín dijo a Yavé: 'Mi castigo es más grande de lo que puedo soportar."
,"14":"Tú me arrojas hoy de esta tierra, y me dejas privado de tu presencia. Si he de ser un errante y de andar vagando sobre la tierra, cualquiera que me encuentre me matará.'"
,"15":"Yavé le dijo: 'No será así: me vengaré siete veces de quien mate a Caín.' Y Yavé puso una marca a Caín para que no lo matara el que lo encontrara."
,"16":"Caín se fue de la presencia de Yavé y habitó en el país de Nod, al oriente del Edén."
,"17":"Caín tuvo relaciones con su mujer, la cual dio a luz un hijo, al que llamó Henoc. Construyó una ciudad y la llamó Henoc, con el mismo nombre de su hijo."
,"18":"Con el tiempo Henoc tuvo un hijo, que llamó Irad. Irad fue padre de Mavael, Mavael padre de Matusael y éste de Lamec."
,"19":"Lamec tuvo dos mujeres: Ada y Sella."
,"20":"Ada dio a luz a Jabel, que fue el padre de los que habitan en cabañas y cuidan rebaños."
,"21":"Tuvo un hermano llamado Jubal, que fue el padre de los que tocan la cítara y la flauta."
,"22":"Sella, por su parte, dio a luz a Tubal-Caín; ése es el que forja toda clase de herramientas en cobre y hierro. La hermana de Tubal-Caín se llamaba Nohema."
,"23":"Dijo Lamec a sus mujeres: 'Escúchenme ustedes, Ada y Sella; oigan mis palabras, mujeres de Lamec: yo he matado a un hombre por herirme y a un muchacho porque me golpeó."
,"24":"Si Caín ha de ser vengado siete veces, Lamec ha de serlo setenta y siete veces.'"
,"25":"Adán tuvo de nuevo relaciones con su mujer, que dio a luz otro hijo, a quien llamó Set, pues dijo: 'Dios me ha concedido otro hijo en lugar de Abel que fue matado por Caín.'"
,"26":"A Set también le nació un hijo, y le puso el nombre de Enós; él fue el primero que invocó el nombre de Yavé."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Esta es la descendencia de Adán. El día que Dios creó a Adán, lo creó a semejanza de Dios."
,"2":"Macho y hembra los creó, y luego los bendijo. El día que los creó les puso el nombre de Adán."
,"3":"Tenía Adán ciento treinta años de edad, cuando tuvo un hijo a su imagen y semejanza, a quien llamó Set."
,"4":"Después que nació Set, Adán vivió aún ochocientos años y tuvo otros hijos e hijas."
,"5":"Adán al morir tenía novecientos treinta años."
,"6":"Set tenía ciento cinco años cuando fue padre de Enós."
,"7":"Después que nació Enós, Set vivió aún ochocientos siete años y tuvo otros hijos e hijas."
,"8":"Set al morir tenía novecientos doce años."
,"9":"Tenía Enós noventa años cuando fue padre de Cainán."
,"10":"Después que nació Cainán vivió ochocientos años y tuvo otros hijos e hijas."
,"11":"Enós al morir tenía novecientos cinco años."
,"12":"A los setenta años de edad, Cainán fue padre de Malael, y después de que nació Malael,"
,"13":"vivió Cainán ochocientos cuarenta años y tuvo más hijos e hijas."
,"14":"Cainán al morir tenía novecientos diez años."
,"15":"Malael fue padre de Jared a la edad de setenta y cinco años."
,"16":"Vivió aún ochocientos treinta años después del nacimiento de Jared, y tuvo otros hijos e hijas."
,"17":"Malael al morir tenía ochocientos noventa y cinco años."
,"18":"Tenía Jared ciento sesenta y dos años cuando fue padre de Henoc."
,"19":"Y vivió Jared después del nacimiento de Henoc ochocientos años y tuvo más hijos e hijas."
,"20":"Jared al morir tenía novecientos sesenta y dos años."
,"21":"Tenía Enoc sesenta y cinco años de edad cuando fue padre de Matusalén."
,"22":"Enoc anduvo con Dios y vivió después del nacimiento de Matusalén trescientos años y tuvo más hijos e hijas."
,"23":"En total, Enoc vivió trescientos sesenta y cinco años."
,"24":"Enoc anduvo con Dios hasta que Dios se lo llevó: sencillamente desapareció."
,"25":"Matusalén tenía ciento ochenta y dos años cuando fue padre de Lamec."
,"26":"Y después que nació Lamec, Matusalén vivió setecientos ochenta y dos años y fue padre de otros hijos e hijas."
,"27":"Matusalén al morir tenía novecientos sesenta y nueve años."
,"28":"A la edad de ciento ochenta y dos años, Lamec fue padre de un hijo,"
,"29":"y le puso por nombre Noé, pues pensó: 'Este nos servirá de consuelo en medio de nuestro trabajo y del cansancio de nuestras manos, debido a la tierra que maldijo Yavé.'"
,"30":"Vivió Lamec, después que le nació Noé, quinientos noventa y cinco años, y fue padre de más hijos e hijas."
,"31":"Lamec al morir tenía setecientos setenta y siete años."
,"32":"Noé tenía quinientos años cuando fue padre de Sem, Cam y Jafet."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Cuando los hombres empezaron a multiplicarse sobre la tierra y les nacieron hijas,"
,"2":"los hijos de Dios se dieron cuenta de que las hijas de los hombres eran hermosas, y tomaron por esposas aquellas que les gustaron."
,"3":"Entonces dijo Yavé: 'No permanecerá para siempre mi espíritu en el hombre, porque no es más que carne. Que su vida no pase los ciento veinte años.'"
,"4":"En ese entonces había gigantes sobre la tierra, y también los hubo después, cuando los hijos de Dios se unieron a las hijas de los hombres y tuvieron hijos de ellas. Estos fueron los héroes de la antigüedad, hombres famosos."
,"5":"Yavé vio que la maldad del hombre en la tierra era grande y que todos sus pensamientos tendían siempre al mal."
,"6":"Se arrepintió, pues, de haber creado al hombre, y se afligió su corazón."
,"7":"Dijo: 'Borraré de la superficie de la tierra a esta humanidad que he creado, y lo mismo haré con los animales, los reptiles y las aves, pues me pesa haberlos creado.'"
,"8":"Noé, sin embargo, se había ganado el cariño de Yavé."
,"9":"Esta es la historia de Noé. Noé fue en su tiempo un hombre justo y que se portó bien en todo; Noé caminaba con Dios."
,"10":"Noé tuvo tres hijos: Sem, Cam y Jafet."
,"11":"El mundo se corrompió a los ojos de Dios y se llenó de violencia."
,"12":"Miró Dios a la tierra, y vio que estaba corrompida, pues todos los mortales en la tierra seguían los caminos del mal."
,"13":"Y dijo Dios a Noé: 'He decidido acabar con todos los seres vivos, pues la tierra está llena de violencia por culpa de ellos, y los voy a suprimir de la tierra."
,"14":"En cuanto a ti, construye un arca de madera de ciprés; en el arca dispondrás celditas, y la recubrirás con brea por dentro y por fuera."
,"15":"La construirás de la siguiente manera: tendrá ciento cincuenta metros de largo, veinticinco metros de ancho y quince metros de alto."
,"16":"Le pondrás un techo, dejando medio metro entre la parte superior de los costados y el techo. Pondrás la puerta del arca en un costado y harás un primer piso, un segundo y un tercero."
,"17":"Por mi parte, voy a mandar el diluvio, o sea, las aguas sobre la tierra, para acabar con todo ser que tiene aliento y vida bajo el cielo; todo cuanto existe en la tierra perecerá."
,"18":"Pero contigo voy a firmar mi pacto, y entrarás en el arca tú y tu esposa, tus hijos y las esposas de tus hijos contigo."
,"19":"Meterás en el arca una pareja de todo ser viviente, o sea de todos los animales para que puedan sobrevivir contigo; tomarás macho y hembra."
,"20":"De cada especie de pájaros, de animales, de cada especie de los que se arrastran por el suelo, entrarán contigo dos para que puedan salvar su vida."
,"21":"Procúrate también toda clase de alimentos y almacénalos, pues te servirán de comida a ti y a ellos.'"
,"22":"Y Noé hizo todo lo que lo que Dios le había mandado."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Yavé dijo a Noé: 'Entra en el Arca, tú y tu familia, pues tú eres el único justo que he encontrado en esta generación."
,"2":"De todos los animales puros, tomarás contigo siete parejas de cada especie, cada macho con su hembra. De los animales impuros, tomarás un macho con su hembra."
,"3":"Del mismo modo, de las aves del cielo tomarás siete parejas, cada macho con su hembra, con el fin de que se conserven las especies sobre la tierra."
,"4":"Porque dentro de siete días, haré llover sobre la tierra durante cuarenta días y cuarenta noches, y exterminaré a todos los seres que creé.'"
,"5":"Noé hizo todo lo que Yavé le había ordenado."
,"6":"Noé tenía seiscientos años de edad cuando se produjo el diluvio que inundó la tierra."
,"7":"Noé, pues, entró en el arca junto con su esposa, sus hijos y las esposas de sus hijos, para salvarse de las aguas del diluvio."
,"8":"Animales puros e impuros, aves del cielo y reptiles de la tierra, entraron con Noé en el Arca."
,"9":"Entraron de dos en dos, macho y hembra, como Dios lo había ordenado."
,"10":"Y luego, a los siete días, comenzaron a caer sobre la tierra las aguas del diluvio."
,"11":"Cuando Noé contaba seiscientos años de vida, el día diecisiete del segundo mes del año, brotaron todos los manantiales del fondo del mar, mientras se abrían las compuertas del cielo."
,"12":"Estuvo lloviendo sobre la tierra por cuarenta días y cuarenta noches."
,"13":"Ese mismo día Noé entró en el arca con sus hijos Cam, Sem y Jafet, su esposa y sus nueras."
,"14":"También entraron con ellos en el arca las diversas especies de animales salvajes y de los otros animales, de los reptiles que se arrastran por el suelo y de las aves."
,"15":"De todo ser que respira y vive entraron con Noé en el arca en fila de a dos."
,"16":"Y los que entraban eran un macho y una hembra de cada especie, que iban llegando según la orden de Dios. Y Yavé cerró la puerta del arca detrás de Noé."
,"17":"El diluvio cayó durante cuarenta días sobre la tierra. Crecieron, pues, las aguas y elevaron el arca muy alto sobre la tierra."
,"18":"Las aguas subieron y crecieron enormemente sobre la tierra, y el arca flotaba sobre las aguas."
,"19":"Subió el nivel de las aguas, y crecieron más y más sobre la tierra, y quedaron cubiertos los montes más altos que hay bajo el cielo."
,"20":"Las aguas subieron todavía quince metros después de cubiertos los montes más altos."
,"21":"Todo ser mortal que se mueve sobre la tierra pereció: aves, bestias, animales, todo lo que tiene vida y se mueve sobre la tierra y toda la humanidad."
,"22":"Todo ser vivo que existía sobre la tierra murió."
,"23":"Así perecieron todos los vivientes que había sobre la tierra, desde el hombre hasta los animales, los reptiles y las aves del cielo. Todos fueron borrados de la superficie de la tierra. Sólo sobrevivieron Noé y los que estaban con él en el arca."
,"24":"Las aguas inundaron la tierra durante ciento cincuenta días."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Y Dios se acordó de Noé y de todas las fieras salvajes y de los otros animales que estaban con él en el arca. Dios hizo soplar un viento sobre la tierra, y las aguas descendieron."
,"2":"Entonces se cerraron los manantiales que brotaban del abismo, como también las compuertas del cielo, y la lluvia cesó de caer sobre la tierra."
,"3":"Las aguas iban bajando sobre la tierra, con flujo y reflujo; empezaron a descender después de los ciento cincuenta días."
,"4":"El día diecisiete del séptimo mes, el arca descansó sobre los montes de Ararat."
,"5":"Y las aguas siguieron bajando hasta el mes décimo, hasta que el día primero de ese mes aparecieron las cumbres de los montes."
,"6":"Después de cuarenta días, Noé abrió la ventana que había hecho en el arca"
,"7":"y soltó al cuervo, el cual revoloteaba sobre las aguas, yendo y viniendo, hasta que se evaporaron las aguas de la tierra."
,"8":"Entonces Noé soltó a la paloma, para ver si las aguas se habían retirado de la superficie de la tierra."
,"9":"Pero la paloma no encontró dónde posarse, y volvió al arca, pues todavía las aguas cubrían toda la superficie de la tierra. Noé extendió su brazo, tomó a la paloma y la introdujo en el arca."
,"10":"Esperó siete días más y de nuevo soltó a la paloma fuera del arca."
,"11":"La paloma regresó al atardecer, trayendo en su pico una rama verde de olivo. Entonces Noé se dio cuenta que las aguas se habían retirado de la superficie de la tierra."
,"12":"Todavía esperó otros siete días más y soltó a la paloma, que ya no regresó más al arca."
,"13":"El año seiscientos uno de la vida de Noé, en el primer día del primer mes, las aguas desaparecieron de la tierra. Noé quitó la cubierta del arca y miró fuera, y vio que la superficie de la tierra estaba seca."
,"14":"El día ventisiete del segundo mes, la tierra estaba ya seca."
,"15":"Entonces Dios habló de esta manera a Noé:"
,"16":"'Sal del arca, tú y tu esposa, tus hijos y tus nueras."
,"17":"Saca también contigo a todos los seres vivientes que tienes dentro de todas las especies: aves, animales, bestias y reptiles que se arrastran por el suelo. Que pululen, llenen la tierra y se multipliquen.'"
,"18":"Salió, pues, Noé y con él sus hijos, su esposa y sus nueras."
,"19":"Todos los animales salvajes y domésticos, todas las aves y todos los reptiles que se arrastran sobre la tierra, salieron por familias del arca."
,"20":"Noé construyó un altar a Yavé, y tomando de todos los animales puros y de todas las aves puras, los ofreció en sacrificio sobre el altar."
,"21":"Al aspirar el agradable aroma, Yavé decidió: 'Nunca más maldeciré la tierra por causa del hombre, pues veo que sus pensamientos están inclinados al mal ya desde la infancia. Nunca más volveré a castigar a todo ser viviente como acabo de hacerlo."
,"22":"Mientras dure la tierra, habrá siembra y cosecha, pues nunca cesarán,ni el frío ni el calor, ni el verano ni el invierno,ni los días ni las noches.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Bendijo Dios a Noé y a sus hijos y les dijo: 'Crezcan, multiplíquense y pueblen la tierra."
,"2":"Teman y tiemblen ante ustedes todos los animales de la tierra y todas las aves del cielo. Pongo a su disposición cuanto se mueve sobre la tierra y todos los peces del mar."
,"3":"Todo lo que tiene movimiento y vida les servirá de alimento; se lo entrego lo mismo que hice con las legumbres y las hierbas."
,"4":"Lo único que no deben comer es la carne con su alma, es decir, con su sangre."
,"5":"Pero también reclamaré la sangre de ustedes como si fuera su alma. Pediré cuenta de ella a cualquier animal. Y también el hombre deberá responder de la sangre de cualquier hombre, hermano suyo."
,"6":"Quien derrame sangre del hombre, su sangre será también derramada por el hombre, porque Dios creó al hombre a imagen suya."
,"7":"En cuanto a ustedes, tengan hijos y multiplíquense, dispérsense sobre la tierra y domínenla.'"
,"8":"Dios dijo a Noé y a sus hijos:"
,"9":"'Miren, voy a hacer una alianza con ustedes y con sus descendientes después de ustedes;"
,"10":"y también con todos los seres vivientes que están con ustedes: aves, animales domésticos, y fieras salvajes, en una palabra, con todas las bestias de la tierra que han salido del arca."
,"11":"El compromiso que contraigo con ustedes es que, en adelante, ningún ser viviente morirá por las aguas de un diluvio, ni habrá nunca más diluvio que destruya la tierra.'"
,"12":"Y Dios dijo: 'Esta es la señal de la alianza que establezco entre ustedes y yo, y con todo animal viviente que esté con ustedes, por todas las generaciones que han de venir:"
,"13":"Pongo mi arco en las nubes para que sea una señal de mi alianza con toda la tierra."
,"14":"Cuando yo cubra de nubes la tierra y aparezca el arco en las nubes,"
,"15":"me acordaré de mi alianza con ustedes y con toda criatura que tiene vida, y nunca más habrá aguas diluviales para acabar con toda carne."
,"16":"Pues el arco estará en las nubes; yo al verlo me acordaré de la alianza perpetua entre Dios y todo ser terrestre, con todo ser animado que vive en una carne.'"
,"17":"Y dijo Dios a Noé: 'Esta es la señal de la alianza que yo he establecido entre mí y todo ser terrestre.'"
,"18":"Los hijos de Noé que salieron del arca fueron Sem, Cam y Jafet. Cam es el padre de Canaán."
,"19":"Esos tres son los hijos de Noé, y de éstos se pobló toda la tierra."
,"20":"Noé, que era labrador, comenzó a trabajar la tierra y plantó una viña."
,"21":"Bebió el vino, se embriagó y quedó tendido sin ropas en medio de su tienda."
,"22":"Cam, padre de Canaán, vio que su padre estaba desnudo y fue a decírselo a sus dos hermanos que estaban fuera."
,"23":"Pero Sem y Jafet tomaron un manto, se lo echaron al hombro, y caminando de espaldas, entraron a tapar a su padre. Como habían entrado de espaldas, mirando hacia afuera, no vieron a su padre desnudo."
,"24":"Cuando despertó Noé de su embriaguez, supo lo que había hecho con él su hijo menor, y dijo:"
,"25":"'¡Maldito sea Canaán! ¡Será esclavo de los esclavos de sus hermanos!"
,"26":"¡Bendito sea Yavé, Dios de Sem, y sea Canaán esclavo suyo!"
,"27":"Que Dios agrande a Jafet y habite en las tiendas de Sem, y sea Canaán esclavo de ellos.'"
,"28":"Noé vivió aún trescientos cincuenta años después del diluvio. Al morir Noé tenía novecientos cincuenta años."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Estos son los descendientes de Sem, Cam y Jafet, hijos de Noé, y éstos son los hijos que les nacieron después del diluvio:"
,"2":"Hijos de Jafet: Gomer, Magog, Maday, Javán, Tubal, Mesec y Tirás."
,"3":"Hijos de Gomer: Ascenez, Rifat y Togarma."
,"4":"Hijos de Javán: Elisa, Tarsis, Quittim y Dodanim."
,"5":"Estos se dispersaron y poblaron las islas de las naciones y sus diversas regiones, cada cual según su propia lengua, familia y nación."
,"6":"Hijos de Cam: Cus, Misraim, Put y Canaán."
,"7":"Hijos de Cus: Sebá, Hevila, Sabata, Regmá y Sabateca. Hijos de Raamá: Sabá y Dadán."
,"8":"Cus es el padre de Nemrod, quien fue el primero en ejercer el poder sobre la tierra."
,"9":"Fue un valiente cazador a los ojos de Yavé y por eso se dice: 'Valiente cazador como Nimrod ante Yavé.'"
,"10":"El comienzo de su reino fue Babilonia, y Arac, Acad y Calne, ciudades todas del país de Sinear."
,"11":"De este país salió para Asur, donde edificó Nínive, Rejobot-Ir, Calaj"
,"12":"y Rese, entre Nínive y Calaj (ésta es la Gran ciudad)."
,"13":"Misraim fue padre de los luditas, anamitas, lehabitas, naftujitas,"
,"14":"y también de los que habitan Patros, Kasluj y Caftor, de donde procedieron los filisteos."
,"15":"Canaán tuvo hijos: Sidón su primogénito, el Heteo,"
,"16":"el Jebuseo, el Amorreo, el Gergeseo,"
,"17":"el Jeveo, el Araceo, el Sineo,"
,"18":"el Aradio, el Samareo y el Amateo. Luego se dispersaron las familias de los cananeos,"
,"19":"cuyos límites iban desde Sidón, en dirección de Guerar, hasta Gaza; y en dirección de Sodoma, Gomorra, Adman y Seboyim, hasta Lesa."
,"20":"Estos son los hijos de Cam, según sus familias y lenguas, por sus territorios y naciones respectivos."
,"21":"También le nacieron hijos a Sem, que es el antepasado de todos los hijos de Eber, y hermano mayor de Jafet."
,"22":"Los hijos de Sem son: Elam, Asur, Arfaxad, Lud y Aram."
,"23":"Y los hijos de Aram: Us, Jul, Guéter y Más."
,"24":"Arfaxad fue padre de Selaj y éste de Eber."
,"25":"Eber fue padre de dos hijos: uno se llamó Peleg, porque en su tiempo fue dividida la tierra, y su hermano se llamó Joctán."
,"26":"Joctán fue padre de Elmodad, Salef, Asarmot, Jaré,"
,"27":"Aduram, Uzal, Decla,"
,"28":"Obal, Abimael, Saba,"
,"29":"Ofir, Hevila y Jobab. Todos estos son hijos de Joctán."
,"30":"Estos ocuparon la región comprendida entre Mesa, en dirección a Sefar, y la montaña que está al oriente."
,"31":"Estos son los hijos de Sem, según sus familias, lenguas, y según sus países y naciones."
,"32":"Estas son las familias de los hijos de Noé según sus genealogías y naciones. A partir de éstos se esparcieron las naciones por la tierra después del diluvio."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Todo el mundo tenía un mismo idioma y usaba las mismas expresiones."
,"2":"Pero al emigrar los hombres desde Oriente, encontraron una llanura en la región de Sinear, y se establecieron allí."
,"3":"Entonces se dijeron unos a otros: 'Vamos a hacer ladrillos y cocerlos al fuego.' El ladrillo reemplazó la piedra y el alquitrán les sirvió de mezcla."
,"4":"Después dijeron: 'Construyamos una ciudad con una torre que llegue hasta el cielo. Así nos haremos famosos, y no nos dispersaremos por todo el mundo.'"
,"5":"Yavé bajó para ver la ciudad y la torre que los hombres estaban levantando,"
,"6":"y dijo Yavé: 'Veo que todos forman un solo pueblo y tienen una misma lengua. Si esto va adelante, nada les impedirá desde ahora que consigan todo lo que se propongan."
,"7":"Pues bien, bajemos y confundamos ahí mismo su lengua, de modo que no se entiendan los unos a los otros.'"
,"8":"Así Yavé los dispersó sobre la superficie de la tierra, y dejaron de construir la ciudad."
,"9":"Por eso se la llamó Babel, porque allí Yavé confundió el lenguaje de todos los habitantes de la tierra, y desde allí los dispersó Yavé por toda la tierra."
,"10":"Estos son los descendientes de Sem: A los cien años años de edad, Sem fue padre de Arfaxad, dos años después del diluvio."
,"11":"Después del nacimiento de Arfaxad vivió todavía cuatrocientos años, y tuvo más hijos e hijas."
,"12":"Arfaxad fue padre de Shela cuando contaba con treinta y cinco años,"
,"13":"y después del nacimiento de Shela, Arfaxad vivió cuatrocientos tres años más, y tuvo otros hijos e hijas."
,"14":"Shela fue padre de Eber al cumplir los treinta años."
,"15":"Después del nacimiento de éste, Shela vivió aún cuatrocientos tres años, y tuvo más hijos e hijas."
,"16":"Cuando Eber tenía treinta y cuatro años fue padre de Peleg."
,"17":"Después del nacimiento de Peleg, Eber vivió cuatrocientos treinta años, y tuvo más hijos e hijas."
,"18":"Peleg fue padre de Reu a los treinta años,"
,"19":"y después del nacimiento de Reu, Peleg vivió doscientos nueve años, y tuvo más hijos e hijas."
,"20":"Cuando Reu contaba treinta y dos años, fue padre de Serug."
,"21":"Y después del nacimiento de éste, Reu vivió doscientos siete años, y tuvo más hijos e hijas."
,"22":"Cuando Serug cumplió treinta años fue padre de Najor."
,"23":"Después del nacimiento de Najor, Serug vivió doscientos años, y tuvo otros hijos e hijas."
,"24":"Cuando Najor tenía veintinueve años, fue padre de Terá."
,"25":"Después del nacimiento de Terá, Najor vivió ciento diecinueve años, y tuvo más hijos e hijas."
,"26":"Terá a los setenta años fue padre de Abram, de Najor y de Harán."
,"27":"Esta es la descendencia de Terá: Terá fue padre de Abram, de Najor y de Harán."
,"28":"Harán fue padre de Lot. Harán murió en Ur de Caldea, su tierra natal, antes que su padre Terá."
,"29":"Abram y Najor se casaron. La esposa de Abram se llamaba Saray, y la de Najor Milcá, hija de Harán, que era padre de Milcá y de Jisca."
,"30":"Saray era estéril y no tenía hijos."
,"31":"Terá tomó consigo a su hijo Abram, a su nieto Lot, hijo de Harán, y a su nuera Saray, esposa de Abram, y los sacó de Ur de Caldea para llevarlos al país de Canaán. Pero al llegar a Jarán se establecieron allí."
,"32":"Terá vivió doscientos cinco años, y murió en Jarán."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Yavé dijo a Abram: 'Deja tu país, a los de tu raza y a la familia de tu padre, y anda a la tierra que yo te mostraré."
,"2":"Haré de ti una gran nación y te bendeciré; voy a engrandecer tu nombre, y tú serás una bendición."
,"3":"Bendeciré a quienes te bendigan y maldeciré a quienes te maldigan. En ti serán bendecidas todas las razas de la tierra.'"
,"4":"Partió Abram, tal como se lo había dicho Yavé, y Lot se fue también con él. Abram tenía setenta y cinco años de edad cuando salió de Jarán."
,"5":"Abram tomó a su esposa Saray y a Lot, hijo de su hermano, con toda la fortuna que había acumulado y el personal que había adquirido en Jarán, y se pusieron en marcha hacia la tierra de Canaán."
,"6":"Entraron en Canaán, y Abram atravesó el país hasta llegar al lugar sagrado de Siquem, al árbol de Moré. En aquel tiempo los cananeos ocupaban el país."
,"7":"Yavé se apareció a Abram y le dijo: 'Le daré esta tierra a tu descendencia.' A consecuencia de esto, Abram edificó un altar a Yavé que se le había aparecido."
,"8":"Desde allí pasó a la montaña, al oriente de Betel, y plantó su tienda de campaña, teniendo Betel al oeste y Aí al oriente. También aquí edificó un altar a Yavé e invocó su Nombre."
,"9":"Luego Abram avanzó por etapas hacia el país de Negueb."
,"10":"En el país hubo hambre, y Abram bajó a Egipto a pasar allí un tiempo, pues el hambre abrumaba el país."
,"11":"Estando ya para entrar en Egipto, dijo a Saray, su esposa: 'Estoy pensando que eres una mujer hermosa."
,"12":"Los egipcios al verte dirán: 'Es su mujer', y me matarán para llevarte."
,"13":"Di, pues, que eres mi hermana; esto será mucho mejor para mí, y me respetarán en consideración a ti.'"
,"14":"Efectivamente, cuando Abram entró en Egipto, los egipcios notaron que la mujer era muy hermosa."
,"15":"Después que la vieron los oficiales de Faraón, le hablaron a éste muy bien de ella; por eso Saray fue conducida al palacio de Faraón,"
,"16":"y en atención a ella, Faraón trató bien a Abram, quien recibió ovejas, vacas, burros, siervos y camellos."
,"17":"Pero Yavé afligió con grandes plagas a Faraón y su gente a causa de Saray."
,"18":"Entonces Faraón llamó a Abram y le dijo: '¡Mira lo que me has hecho! ¿Por qué no me dijiste que era tu esposa?"
,"19":"Y yo la hice mi mujer porque me dijiste que era tu hermana. ¡Ahí tienes a tu esposa! ¡Tómala y márchate!'"
,"20":"Y Faraón ordenó a sus hombres que lo devolvieran a la frontera con su mujer y todo lo suyo."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Abram, pues, salió de Egipto con su mujer y todo lo suyo, subiendo al Negueb; también Lot estaba con él."
,"2":"Abram era muy rico, pues tenía animales, plata y oro."
,"3":"Viajando por etapas, caminó desde el Negueb hasta Betel, llegando al lugar donde anteriormente había levantado su tienda, entre Betel y Aí."
,"4":"En aquel sitio había invocado el Nombre de Yavé y construido un altar."
,"5":"También Lot, que iba con Abram, tenía rebaños, vacas y tiendas."
,"6":"La tierra ya no les permitía vivir en un mismo lugar, pues sus rebaños eran demasiado grandes como para que estuvieran juntos."
,"7":"Hubo una pelea entre los pastores del rebaño de Abram y los de Lot. (Los cananeos y los ferezeos habitaban en el país en aquel tiempo)."
,"8":"Así pues, Abram le dijo a Lot: 'Mira, es mejor que no haya peleas entre nosotros, ni entre mis pastores y los tuyos, ya que somos hermanos."
,"9":"¿No tienes todo el país ante ti? Pues bien, separémonos. Si tú te vas por la izquierda, yo me iré por la derecha. Y si tú te vas por la derecha, yo tomaré la izquierda.'"
,"10":"Lot miró y vio toda la llanura del Jordán, que era toda ella de regadío. Pues antes de que Yavé destruyera Sodoma y Gomorra, era como un jardín de Yavé, como el país de Egipto viniendo de Soar."
,"11":"Lot eligió para sí todo el valle del Jordán, y se trasladó al oriente. Así se separaron el uno del otro."
,"12":"Abram se estableció en Canaán, y Lot en las ciudades del valle, llevando sus tiendas desde allí hasta Sodoma."
,"13":"Los habitantes de Sodoma eran malos y pecadores ante Yavé."
,"14":"Yavé dijo a Abram, después que Lot se separó de él: 'Levanta tus ojos y mira desde el lugar en que estás hacia el norte, el sur, el oriente y el poniente."
,"15":"Pues bien, toda la tierra que ves, te la voy a dar a ti y a tu descendencia para siempre."
,"16":"Multiplicaré tu descendencia como el polvo de la tierra, de tal manera, que si se pudiera contar el polvo de la tierra, también se podría contar tu descendencia."
,"17":"Levántate, recorre el país a lo largo y a lo ancho, pues te lo voy a dar a ti.'"
,"18":"Abram entonces levantó sus tiendas y fue a establecerse junto a los árboles de Mambré, en Hebrón. Allí edificó un altar a Yavé."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Y sucedió por aquel tiempo que Amrafel, rey de Senaar, Arioc, rey del Ponto, Codorlamor, rey de los elamitas, y Tadal, rey de los Goyim,"
,"2":"declararon la guerra a Bera, rey de Sodoma, Bersa, rey de Gomorra, Sineab, rey de Adama, Semeber, rey de Seboim, y al rey de Bela, (es decir, Soar)."
,"3":"Todos estos se reunieron en el valle de Sidim, que es ahora el Mar Salado."
,"4":"Durante doce años habían estado bajo el dominio de Codorlamor, y el año decimotercero decidieron rebelarse."
,"5":"El año decimocuarto vino Codorlamor con los reyes que estaban de su parte, y derrotaron a los refaítas en Astarotcarnaim, a los zuzíes en Ham, a los emeos en Save-Cariataim"
,"6":"y a los horitas en los cerros de Seir, hasta los Campos de Parán, que están cerca del desierto."
,"7":"Luego se volvieron y llegaron hasta la fuente de Misfat, o sea Cadés, y arrasaron todo el país de los amalecitas y de los amorreos que vivían en Asasontamar."
,"8":"Salieron entonces los reyes de Sodoma, Gomorra, Adama, Seboim y también el rey de Bala (o Soar), y se dispusieron en orden de batalla en el valle de Sidim,"
,"9":"contra Codorlamor, rey de los elamitas, Tadal, rey de Goyim, Amrafel, rey de Senaar, y Arioc, rey del Ponto. Eran, pues, cuatro reyes contra cinco."
,"10":"El valle de Sidim estaba lleno de pozos de asfalto, y los reyes de Sodoma y Gomorra, mientras huían, unos cayeron en los pozos y los demás huyeron a los montes."
,"11":"Los vencedores se adueñaron de las riquezas y las reservas de alimentos de Sodoma y Gomorra y se marcharon."
,"12":"Se llevaron también con ellos a Lot, hijo del hermano de Abram, con todo lo que tenía, pues vivía en Sodoma."
,"13":"Uno de los que escaparon vino a avisar a Abram el hebreo, que vivía en el valle de Mambré el amorreo, hermano de Escol y de Aner, que eran aliados de Abram."
,"14":"En cuanto oyó Abram que los cuatro jefes habían llevado prisionero a su hermano Lot, escogió trescientos dieciocho de sus hombres que se habían criado en su casa y los persiguió hasta la ciudad de Dan."
,"15":"Con sus hombres cayó de noche sobre ellos, los derrotó y persiguió hasta Jobá, al norte de Damasco."
,"16":"Recuperó el botín, y también a su sobrino Lot con sus pertenencias, a las mujeres y al resto de la gente."
,"17":"Cuando Abram venía de vuelta, después de derrotar a Codorlamor y sus aliados, le salió al encuentro el rey de Sodoma en el valle de Save (es decir, el valle del Rey)."
,"18":"Entonces Melquisedec, rey de Salem, trajo pan y vino, pues era sacerdote del 'Dios Altísimo'."
,"19":"Melquisedec bendijo a Abram, diciendo: 'Abram, bendito seas del Dios Altísimo, Creador del cielo y de la tierra."
,"20":"Y bendito sea el Dios Altísimo, porque entregó a tus enemigos en tus manos.' Y Abram le dio la décima parte de todo lo que llevaba."
,"21":"Luego el rey de Sodoma dijo a Abram: 'Devuélveme las personas que has liberado, y quédate con sus pertenencias.'"
,"22":"Abram le respondió: 'Levanto mi mano hacia Yavé, creador del cielo y de la tierra, el Dios Altísimo,"
,"23":"para jurar que no tomaré una hebra de hilo, ni el cordón de un zapato, ni cosa alguna que te pertenezca. Así tú no podrás decir: 'Abram se hizo rico a costa mía.'"
,"24":"No quiero nada para mí, sino tan sólo lo que han comido mis hombres. En cuanto a mis aliados Aner, Escol y Mambré, que ellos mismos tomen su parte.'"
}`)
	CurrentBook.AddChapter(15, `{
"1":"Después de estos sucesos, Yavé dirigió su palabra a Abram en una visión, y le dijo: 'No temas, Abram, yo soy tu protector. Tu recompensa será muy grande.'"
,"2":"Abram respondió: 'Señor Yavé, ¿qué me quieres dar? Soy un hombre sin hijos, y todo lo que poseo pasará a Eliezer de Damasco."
,"3":"Ya que no me diste descendencia, tendré por heredero a uno de mis sirvientes.'"
,"4":"Entonces le llegó una palabra de Yavé: 'Tu heredero no será Eliezer, sino un hijo tuyo, nacido de tu propia carne y sangre.'"
,"5":"Yavé lo sacó afuera y le dijo: 'Mira al cielo y cuenta las estrellas, si puedes. Así será tu descendencia.'"
,"6":"Y creyó Abram a Yavé, el que lo tuvo en adelante por un hombre justo."
,"7":"Yavé le dijo: 'Yo soy Yavé, que te sacó de Ur de los Caldeos, para entregarte esta tierra en propiedad.'"
,"8":"Abram le preguntó: 'Señor, ¿en qué conoceré yo que será mía?'"
,"9":"Le contestó: 'Tráeme una ternera, una cabra y un carnero, todos ellos de tres años, y también una paloma y un pichón.'"
,"10":"Abram trajo todos estos animales, los partió por mitad, y puso una mitad frente a la otra; las aves no las partió."
,"11":"Las aves rapaces se lanzaban sobre la carne, pero Abram las ahuyentaba."
,"12":"Cuando el sol estaba a punto de ponerse, Abram cayó en un profundo sueño y se apoderó de él un terror y una gran oscuridad."
,"13":"Entonces Yavé le dijo: 'Debes saber desde ahora que tus descendientes serán forasteros en una tierra que no es suya. Los esclavizarán y los explotarán durante cuatrocientos años."
,"14":"Pero yo vendré a juzgar a la nación que los ha oprimido, y después saldrán cargados de riquezas."
,"15":"En cuanto a ti, irás a reunirte con tus padres en paz, y serás sepultado después de una ancianidad dichosa."
,"16":"Tus descendientes de la cuarta generación volverán a esta tierra que no te puedo entregar ahora, pues la maldad de los amorreos todavía no ha merecido que yo se la quite.'"
,"17":"Cuando el sol ya se había puesto y estaba todo oscuro, algo como un calentador humeante y una antorcha encendida pasaron por medio de aquellos animales partidos."
,"18":"Aquel día Yavé pactó una alianza con Abram diciendo: 'A tu descendencia daré esta tierra desde el torrente de Egipto hasta el gran río Eufrates."
,"19":"El país de los quenitas, de los ceniceos, y de los cadmoneos,"
,"20":"de los hititas, de los fereceos y los refaítas,"
,"21":"de los amorreos, de los cananeos, de los jergeseos y los jebuseos.'"
}`)
	CurrentBook.AddChapter(16, `{
"1":"Saray, esposa de Abram, no le había dado hijos, pero tenía una esclava egipcia que se llamaba Agar."
,"2":"Y dijo Saray a Abram: 'Ya que Yavé me ha hecho estéril, toma a mi esclava y únete a ella, a ver si yo tendré algún hijo por medio de ella.' Abram hizo caso a las palabras de su esposa."
,"3":"Abram llevaba diez años viviendo en Canaán, cuando su esposa Saray tomó a su esclava Agar y se la dio a su esposo Abram por mujer."
,"4":"Abram, pues, se unió a Agar, y quedó embarazada. Al notarse Agar en ese estado, comenzó a despreciar a su señora,"
,"5":"quien dijo a Abram: 'Que esta ofensa recaiga sobre ti. Yo te entregué a mi esclava por mujer, y cuando se ve embarazada, ya no cuento nada para ella. Juzgue Yavé entre tú y yo.'"
,"6":"Abram le contestó: 'Ahí tienes a tu esclava, haz con ella como mejor te parezca.' Y como Saray la maltratara, ella huyó."
,"7":"La encontró el Angel de Yavé junto a una fuente de agua en el desierto (la fuente que hay en el camino de Sur),"
,"8":"y le dijo: 'Agar, esclava de Saray, ¿de dónde vienes y a dónde vas?'"
,"9":"Ella contestó: 'Estoy huyendo de Saray, mi señora.' Le replicó el Angel del Señor: 'Regresa donde tu señora y ponte a sus órdenes con humildad.'"
,"10":"El Angel de Yavé añadió: 'Multiplicaré de tal manera tu descendencia, que no se podrá contar'."
,"11":"Y el Angel le dijo: 'Mira que estás embarazada y darás a luz a un hijo, al que pondrás por nombre Ismael, porque Yavé ha considerado tu miseria."
,"12":"El será un hombre feroz, que se levantará contra todos y todos se levantarán contra él, y plantará su tienda desafiante frente a la de sus hermanos.'"
,"13":"Agar invocó a Yavé que le hablaba, dándole este nombre: 'Tú eres El-Roí.' Porque pensó: 'No hay duda que he visto a Aquel que me ve.'"
,"14":"Por eso se llamó aquel pozo 'el pozo de Lajay-Roi' y está entre Cadés y Bered."
,"15":"Agar dio a luz un hijo, y Abram le puso el nombre de Ismael al hijo que Agar le había dado."
,"16":"Abram tenía ochenta y seis años cuando Agar le dio su hijo Ismael."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Tenía Abram noventa y nueve años, cuando se le apareció Yavé y le dijo: 'Yo soy el Dios de las Alturas. Camina en mi presencia y sé perfecto."
,"2":"Yo estableceré mi alianza entre Yo y tú, y te multiplicaré más y más.'"
,"3":"Abram cayó rostro en tierra, y Dios le habló así:"
,"4":"'Esta es mi alianza que voy a pactar contigo: tú serás el padre de una multitud de naciones."
,"5":"No te llamarás más Abram, sino Abrahán, pues te tengo destinado a ser padre de una multitud de naciones."
,"6":"Yo te haré crecer sin límites, de ti saldrán naciones y reyes, de generación en generación."
,"7":"Pacto mi alianza contigo y con tu descendencia después de ti: ésta es una alianza eterna. Yo seré tu Dios y, después de ti, de tu descendencia."
,"8":"Yo te daré a ti, y después de ti a tu posteridad, la tierra en que vives como peregrino, es decir, toda la tierra de Canaán, en posesión perpetua, y seré el Dios de los tuyos.'"
,"9":"Dijo Dios a Abrahán: 'Guarda mi alianza, tú y tus descendientes después de ti, de generación en generación."
,"10":"Esta es mi alianza contigo y con tu raza después de ti, que ustedes deberán guardar: todo varón entre ustedes será circuncidado."
,"11":"Ustedes cortarán el prepucio y ésta será la señal de la alianza entre yo y ustedes."
,"12":"En adelante y para siempre, todo varón entre ustedes deberá ser circuncidado a los ocho días después de su nacimiento, tanto el nacido en tu casa, como el extranjero que haya sido comprado como esclavo."
,"13":"Sea que hayan nacido en tu casa, o hayan sido comprados como esclavos, deberán ser circuncidados. Esta alianza mía grabada en la carne de ustedes es una alianza perpetua."
,"14":"Todo varón no circuncidado, al que no se le haya cortado el prepucio, será eliminado de su pueblo, por haber roto mi Alianza.'"
,"15":"Dijo Dios a Abrahán: 'A Saray, tu esposa, ya no la llamarás Saray, sino Sara. Yo la bendeciré y te daré de ella un hijo."
,"16":"La bendeciré de tal manera, que pueblos y reyes saldrán de ella.'"
,"17":"Entonces Abrahán, agachándose hasta tocar la tierra con su cara, se puso a reír, pues pensaba: '¿Acaso le va a nacer un hijo a un hombre de cien años? ¿Y puede Sara, a sus noventa años, dar a luz?'"
,"18":"Y dijo a Dios: 'Si al menos aceptaras a Ismael para servir tus designios.'"
,"19":"Pero Dios le respondió: 'De ninguna manera, pues va a ser Sara, tu esposa, la que te dará un hijo y le pondrás por nombre Isaac. Estableceré mi alianza con él, y con su descendencia después de él para siempre."
,"20":"En cuanto a Ismael, también te he escuchado. Yo lo bendeciré y le daré una descendencia muy grande y muy numerosa. Será el padre de doce príncipes y haré de él una gran nación."
,"21":"Pero mi alianza la estableceré con Isaac, que Sara te dará a luz por este tiempo, el año que viene.'"
,"22":"Así terminó Dios de hablar con Abrahán y se alejó."
,"23":"Tomó entonces Abrahán a su hijo Ismael, a todos los nacidos en su casa y a todos los que había comprado, en una palabra, a todos los varones que había en la familia y los circuncidó ese mismo día, tal como Dios le había mandado."
,"24":"Abrahán tenía noventa y nueve años cuando se circuncidó,"
,"25":"y su hijo Ismael tenía trece años cuando fue circuncidado."
,"26":"En aquel mismo día fueron circuncidados Abrahán y su hijo Ismael."
,"27":"También todos los varones de su casa, tanto los nacidos en ella como los esclavos comprados a algún extranjero, fueron igualmente circuncidados con él."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Yavé se presentó a Abrahán junto a los árboles de Mambré mientras estaba sentado a la entrada de su tienda, a la hora más calurosa del día."
,"2":"Al levantar sus ojos, Abrahán vio a tres hombres que estaban parados a poca distancia. En cuanto los vio, corrió hacia ellos y se postró en tierra,"
,"3":"diciendo: 'Señor mío, si me haces el favor, te ruego que no pases al lado de tu servidor sin detenerte."
,"4":"Les haré traer un poco de agua para que se laven los pies y descansen bajo estos árboles."
,"5":"Les haré traer un poco de pan para que recuperen sus fuerzas, antes de proseguir su viaje, pues creo que para esto pasaron ustedes por mi casa.' Ellos respondieron: 'Haz como has dicho.'"
,"6":"Abrahán fue rápidamente a la tienda, donde estaba Sara, y le dijo: '¡De prisa, tres medidas de harina! amásala y haz unas tortas.'"
,"7":"Luego él mismo corrió al potrero, tomó un ternero tierno y bueno y se lo entregó a un muchacho para que lo preparara inmediatamente."
,"8":"Después tomó mantequilla, leche y el ternero ya cocinado y se lo presentó a ellos. El se quedó de pie a su lado, bajo el árbol, mientras comían."
,"9":"Entonces le preguntaron: '¿Dónde está Sara, tu esposa?' El les respondió: 'Está dentro, en la tienda.'"
,"10":"El otro le dijo: 'Dentro de un año volveré por aquí, y para entonces Sara, tu mujer, tendrá un hijo.',Sara estaba escuchando a la entrada de la tienda, a la espalda del que hablaba."
,"11":"Abrahán y Sara eran ancianos, bien entrados en años, y ella no tenía ya lo que le pasa ordinariamente a las mujeres."
,"12":"Sara se rió, mientras pensaba: 'Ahora que soy anciana, ¿haré el amor con mi marido que es tan viejo?'"
,"13":"Pero Yavé dijo a Abrahán: '¿Por qué se ha reído Sara? ¿Por qué ha dicho: Cómo voy a tener un hijo ahora que soy vieja?"
,"14":"¿Hay acaso algo imposible para Yavé? Pues bien, volveré a visitarte dentro de un año, y para entonces Sara tendrá un hijo.'"
,"15":"Sara trató de defenderse, pues tuvo miedo, y dijo: 'Yo no me he reído.' Pero él contestó: 'Cierto que te has reído.'"
,"16":"Los hombres se levantaron y marcharon en dirección de Sodoma, mientras Abrahán los acompañaba para indicarles el camino."
,"17":"Y Yavé se preguntó: '¿Ocultaré a Abrahán lo que voy a hacer,"
,"18":"cuando justamente quiero que salga de él una nación grande y poderosa, y que a través de él sean bendecidas todas las naciones de la tierra?"
,"19":"Pues lo he escogido para que ordene a sus hijos y a los de su raza después de él, que guarden el camino de Yavé y vivan según la justicia y haciendo el bien, para que Yavé cumpla con Abrahán todo lo que le ha prometido.'"
,"20":"Dijo entonces Yavé: 'Las quejas contra Sodoma y Gomorra son enormes, y su pecado es en verdad muy grande."
,"21":"Voy a visitarlos, y comprobaré si han actuado según esas quejas que han llegado hasta mí. Si no es así, lo sabré.'"
,"22":"Los hombres partieron y se dirigieron a Sodoma, mientras Yavé se quedaba de pie delante de Abrahán."
,"23":"Se acercó entonces Abrahán y le dijo: '¿Es cierto que vas a exterminar al justo junto con el malvado?"
,"24":"Tal vez haya cincuenta justos dentro de la ciudad: ¿es cierto que vas a acabar con todos y no perdonar el lugar en atención a esos cincuenta justos?"
,"25":"¡Tú no vas a hacer algo semejante, permitir que el bueno sea tratado igual que el malvado! ¿O es que el juez de toda la tierra no aceptará lo que es justo?'"
,"26":"Yavé le dijo: 'Si encuentro en Sodoma cincuenta justos dentro de la ciudad, perdonaré a todo el lugar en atención a ellos.'"
,"27":"Abrahán volvió a hablar: 'Sé que a lo mejor es un atrevimiento hablar a mi Señor, yo que soy polvo y ceniza,"
,"28":"pero si faltan cinco justos para llegar a los cincuenta, ¿destruirás la ciudad por esos cinco que faltan?' Yavé respondió: 'No habrá destrucción si encuentro allí cuarenta y cinco hombres justos.'"
,"29":"Abrahán insistió: 'Pero a lo mejor se encuentran allí sólo cuarenta justos.' Yavé contestó: 'En atención a esos cuarenta, no lo haré.'"
,"30":"Abrahán continuó todavía: 'No se enoje mi Señor si sigo hablando, pero tal vez no se encuentren más que treinta justos.' Yavé contestó: 'No lo haré si encuentro allí treinta justos.'"
,"31":"Abrahán insistió: 'Sé que es una osadía por mi parte hablar así a mi Señor; pero, ¿y si se encuentran allí solamente veinte justos?' Yavé contestó: 'No destruiré el lugar, en atención a esos veinte.'"
,"32":"Abrahán dijo: 'Vaya, no se enoje mi Señor, y hablaré por última vez. Puede ser que se encuentren allí sólo diez.' Yavé dijo: 'En atención a esos diez, no destruiré la ciudad.'"
,"33":"Cuando Yavé terminó de hablar con Abrahán se fue, mientras Abrahán volvió a su casa."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Los dos ángeles llegaron a Sodoma al atardecer. Lot estaba sentado a la entrada del pueblo. Apenas los vio, salió a su encuentro, se arrodilló inclinándose profundamente,"
,"2":"y les dijo: 'Señores míos, les ruego que vengan a la casa de este siervo suyo a pasar la noche. Se lavarán los pies, descansarán y mañana, al amanecer, podrán seguir su camino.' Ellos le respondieron: 'No, pasaremos la noche en la plaza.' Pero él insistió tanto, que lo siguieron a su casa, y les preparó comida."
,"3":"Hizo panes sin levadura y comieron."
,"4":"No estaban acostados todavía cuando los vecinos, es decir los hombres de Sodoma, jóvenes y ancianos, rodearon la casa: ¡estaba el pueblo entero!"
,"5":"Llamaron a Lot y le dijeron: '¿Dónde están esos hombres que llegaron a tu casa esta noche? Mándanoslos afuera, para que abusemos de ellos.'"
,"6":"Lot salió de la casa y se dirigió hacia ellos, cerrando la puerta detrás de sí,"
,"7":"y les dijo: 'Les ruego, hermanos míos, que no cometan semejante maldad."
,"8":"Miren, tengo dos hijas que todavía son vírgenes. Se las voy a traer para que ustedes hagan con ellas lo que quieran, pero dejen tranquilos a estos hombres que han confiado en mi hospitalidad.'"
,"9":"Pero ellos le respondieron: '¡Quítate del medio! ¡Eres un forastero y ya quieres actuar como juez! Ahora te trataremos a ti peor que a ellos.' Lo empujaron violentamente y se disponían a romper la puerta."
,"10":"Pero los dos hombres desde adentro extendieron sus brazos, tomaron a Lot, lo introdujeron en la casa y cerraron la puerta."
,"11":"Hirieron de ceguera a los hombres que estaban fuera, desde el más joven hasta el más viejo, de modo que no fueron ya capaces de encontrar la puerta."
,"12":"Los dos hombres dijeron a Lot: '¿A quién más de los tuyos tienes aquí? ¿Tus yernos? Tienes que llevar de este lugar a tus hijos e hijas y todo lo que tienes en la ciudad."
,"13":"Vamos a destruir esta ciudad, pues son enormes las quejas en su contra que han llegado hasta Yavé, y él nos ha enviado a destruirla.'"
,"14":"Salió entonces Lot y dijo a sus yernos, a los que iban a casarse con sus hijas: 'Levántense y salgan de aquí, pues Yavé va a destruir la ciudad.' Pero ellos creían que Lot estaba bromeando."
,"15":"Al amanecer los ángeles apuraron a Lot diciéndole: 'Date prisa, toma a tu esposa y a tus dos hijas y márchate, no sea que te alcance el castigo de esta ciudad.'"
,"16":"Y como él aún vacilase, lo tomaron de la mano, junto a su mujer y a sus dos hijas, porque Yavé había tenido compasión de ellos, y lo llevaron fuera de la ciudad."
,"17":"Una vez fuera, le dijeron: 'Ponte a salvo. Por tu vida, no mires hacia atrás ni te detengas en parte alguna de esta llanura, sino que huye a la montaña para que no perezcas.'"
,"18":"Pero Lot replicó: '¡Oh, no, Señor mío!"
,"19":"Veo que me has hecho un gran favor y que has sido muy bueno conmigo conservándome la vida. Pero yo no puedo llegar hasta la montaña sin que me alcance el desastre y la muerte."
,"20":"Mira este pueblito que está más cerca y en el que podría refugiarme. Es tan pequeño, y para mí es cosa de vida o muerte, ¿no podría estar a salvo allí?'"
,"21":"El otro respondió: 'También este favor te lo concedo, y no destruiré ese pueblo del que has hablado."
,"22":"Pero huye rápidamente, ya que no puedo hacer nada hasta que tú no hayas llegado allá. (Por esto, aquel pueblo fue llamado Soar, o sea, Pequeño.)"
,"23":"El sol ya había salido cuando Lot entró en Soar."
,"24":"Entonces Yavé hizo llover del cielo sobre Sodoma y Gomorra azufre ardiendo que venía de Yavé,"
,"25":"y que destruyó completamente estas ciudades y toda la llanura con todos sus habitantes y la vegetación."
,"26":"La mujer de Lot miró hacia atrás, y quedó convertida en una estatua de sal."
,"27":"Abrahán se levantó muy de madrugada y fue al lugar donde antes había estado con Yavé."
,"28":"Miró hacia Sodoma y Gomorra y hacia toda la comarca del valle y vio una gran humareda que subía de la tierra, semejante a la humareda de un horno."
,"29":"Cuando Dios destruyó las ciudades de la llanura, se acordó de Abrahán y libró a Lot de la catástrofe, mientras arrasaba las ciudades donde Lot había vivido."
,"30":"Después Lot salió de Soar con sus dos hijas, pues no se sentía seguro allí, y se fue a vivir al monte, en una cueva."
,"31":"Entonces dijo la hija mayor a la menor: 'Nuestro padre está viejo y no ha quedado ni un hombre siquiera en esta región que pueda unirse a nosotras como se hace en todo el mundo."
,"32":"Ven y embriaguémoslo con vino y acostémonos con él. Así sobrevivirá la familia de nuestro padre.'"
,"33":"Y así lo hicieron aquella misma noche, y la mayor se acostó con su padre, quien no se dio cuenta de nada, ni cuando ella se acostó ni cuando se levantó."
,"34":"Al día siguiente dijo la mayor a la menor: 'Ya sabes que me acosté anoche con mi padre. Hagámosle beber vino otra vez esta noche y te acuestas tú también con él, para que la raza de nuestro padre no desaparezca.'"
,"35":"Le hicieron beber y lo embriagaron de nuevo aquella noche, y la hija menor se acostó con él. El padre no se dio cuenta de nada, ni cuando ella se acostó ni cuando se levantó."
,"36":"Y así las dos hijas de Lot quedaron embarazadas de su padre."
,"37":"La mayor dio a luz un hijo y lo llamó Moab: éste fue el padre de los moabitas, que todavía existen hoy."
,"38":"La menor también dio a luz un hijo y lo llamó Ben-Ammí, y es el padre de los actuales amonitas."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Abrahán se trasladó de allí al territorio del Negueb y se instaló entre Cadés y Sur; después fue a vivir un tiempo a Guerar."
,"2":"Abrahán decía de su esposa Sara: 'Es mi hermana.' Oyendo esto, el rey de Guerar, llamado Abimelec, mandó a buscarla para él."
,"3":"Pero en la noche Dios habló a Abimelec en sueños y le dijo: 'Date por muerto a causa de esa mujer que has tomado, porque es casada.'"
,"4":"Abimelec no la había tocado aún y dijo: 'Pero, Señor mío, ¿vas a dar muerte a un pagano que es inocente?"
,"5":"El me dijo que era su hermana, y ella también me dijo: 'Es mi hermano'. Yo he actuado con corazón sencillo y con manos limpias.'"
,"6":"Dios le dijo: 'Yo sé que lo hiciste con corazón sencillo y por eso te he librado de pecar contra mí, y no he permitido que la tocases."
,"7":"Ahora devuelve su mujer a ese hombre, porque es un profeta. El rogará por ti y vivirás. Pero si no se la devuelves, debes saber que morirás sin remedio, tú y todos los tuyos.'"
,"8":"Abimelec se levantó muy de mañana, y llamando a todos sus oficiales, les contó privadamente todo esto. Ellos, al oírlo, quedaron muy asustados."
,"9":"Llamó entonces Abimelec a Abrahán y le dijo: '¡En qué lío nos metiste! ¿En qué te he ofendido, para que traigas sobre mí y mi país un pecado tan grande? Te has portado como no debe hacerse.'"
,"10":"Y Abimelec le preguntó: '¿Por qué has hecho eso?'"
,"11":"Respondió Abrahán: 'Pensé que si no había temor de Dios en este lugar, podrían matarme por causa de mi esposa."
,"12":"Pero es verdad que es mi hermana, pues es hija de mi padre, aunque no de mi madre, y ha pasado a ser mi esposa."
,"13":"Desde que los dioses me han hecho caminar de un lado para otro, lejos de mi patria, le dije: 'Tú me harás el favor de decir, en cualquier lugar donde lleguemos, que soy tu hermano.'"
,"14":"Abimelec mandó traer ovejas y bueyes, esclavos y esclavas y se los dio a Abrahán, al mismo tiempo que le devolvía su esposa Sara."
,"15":"Después Abimelec agregó: 'Ahí tienes a mi tierra, puedes vivir donde quieras.'"
,"16":"Y a Sara le dijo: 'Le he dado a tu hermano mil monedas de plata, que serán para ti como un velo que tiendas ante los ojos de todos los que están contigo, y así nadie pensará mal de ti.'"
,"17":"Entonces Abrahán oró por Abimelec, y Dios curó a Abimelec, a su esposa y a sus esclavos, a fin de que pudieran tener hijos."
,"18":"Porque Dios había vuelto estériles a todas las mujeres en la casa de Abimelec, a causa de Sara, esposa de Abrahán."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Yavé visitó a Sara tal como lo había dicho; Yavé hizo con Sara aquello mismo que había prometido."
,"2":"Sara quedó embarazada, dio a luz un hijo de Abrahán siendo ya anciana, y en la misma fecha que Dios había señalado."
,"3":"Abrahán le puso por nombre Isaac al hijo que le nació, el hijo que Sara dio a luz."
,"4":"Lo circuncidó a los ocho días, conforme a lo que Dios le había ordenado."
,"5":"Abrahán tenía cien años de edad cuando le nació Isaac."
,"6":"Sara dijo: 'Dios me ha hecho reír, y todos los que se enteren se reirán también.'"
,"7":"Y añadió: '¡Quién hubiera dicho a Abrahán que yo amamantaría hijos! Y sin embargo, le he dado a luz un hijo en su vejez.'"
,"8":"Creció el niño, y el día en que dejó de ser amamantado, Abrahán celebró un gran banquete."
,"9":"Sara vio que el hijo que la egipcia Agar había dado a Abrahán, se burlaba de su hijo Isaac,"
,"10":"y dijo a Abrahán: 'Despide a esa esclava y a su hijo, pues el hijo de esa esclava no debe compartir la herencia con mi hijo, con Isaac.'"
,"11":"Esto desagradó mucho a Abrahán, por ser Ismael su hijo."
,"12":"Pero Dios le dijo: 'No te preocupes por el muchacho ni por tu sirvienta. Haz todo lo que te pide Sara, porque de Isaac saldrá la descendencia que lleve tu nombre."
,"13":"Pero también del hijo de la sierva yo haré una gran nación, por ser descendiente tuyo.'"
,"14":"Abrahán se levantó por la mañana muy temprano, tomó pan y un recipiente de cuero lleno de agua y se los dio a Agar. Le puso su hijo sobre el hombro y la despidió. Agar se marchó y anduvo errante por el desierto de Bersebá."
,"15":"Cuando no quedó nada de agua en el recipiente de cuero, dejó tirado al niño bajo un matorral"
,"16":"y fue a sentarse a la distancia de un tiro de arco, pues pensó: 'Al menos no veré morir a mi hijo.',Como se alejara para sentarse, el niño se puso a llorar a gritos."
,"17":"Dios oyó los gritos del niño, y el Angel de Dios llamó desde el cielo a Agar y le dijo: '¿Qué te pasa, Agar? No temas, porque Dios ha oído al niño gritando de donde está."
,"18":"Anda a buscar al niño, y llévalo bien agarrado, porque de él haré yo un gran pueblo.'"
,"19":"Entonces Dios le abrió los ojos y vio un pozo de agua. Llenó el recipiente de cuero y dio de beber al niño."
,"20":"Dios asistió al niño, que creció y vivió en el desierto, llegando a ser un experto tirador de arco."
,"21":"Vivió en el desierto de Parán, donde su madre lo casó con una mujer egipcia."
,"22":"Por aquel tiempo, Abimelec fue con Ficol, general de sus tropas, a hablar a Abrahán, y le dijo: 'Dios está contigo en todo cuanto emprendes."
,"23":"Por eso júrame ahora mismo ante Dios que no me harás daño, ni a mí, ni a mis hijos, ni a mis descendientes, sino que usarás conmigo y con esta tierra en la que habitas, la misma bondad que yo he usado contigo.'"
,"24":"Abrahán le respondió: 'Lo juro.'"
,"25":"Y de inmediato Abrahán se quejó ante Abimelec de que algunos servidores de éste se habían apoderado por la fuerza de un pozo que le pertenecía."
,"26":"Abimelec le contestó: 'No sé quién haya hecho tal cosa, pero tú no me has dicho nada, y yo me entero de eso sólo ahora.'"
,"27":"Abrahán tomó unas ovejas y vacas y se las dio a Abimelec, e hicieron los dos un pacto."
,"28":"Abrahán puso aparte siete ovejas de su rebaño,"
,"29":"y Abimelec le preguntó: '¿Qué significan estas siete ovejas que has separado?'"
,"30":"Le respondió Abrahán: 'Acepta estas siete ovejas de mi mano, como prueba de que ese pozo lo he excavado yo.'"
,"31":"Por eso aquel lugar fue llamado Bersebá (o sea, pozo del juramento), porque allí juraron ambos."
,"32":"Después de haber hecho el pacto en Bersebá, Abimelec y Ficol, general de sus tropas, volvieron al país de los filisteos."
,"33":"Abrahán plantó un árbol de tamarindo en Bersebá y allí invocó el nombre de Yavé, Dios Eterno."
,"34":"Abrahán estuvo todavía mucho tiempo viviendo en el país de los filisteos."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Tiempo después, Dios quiso probar a Abrahán y lo llamó: 'Abrahán.' Respondió él: 'Aquí estoy.'"
,"2":"Y Dios le dijo: 'Toma a tu hijo, al único que tienes y al que amas, Isaac, y vete a la región de Moriah. Allí me lo ofrecerás en holocausto, en un cerro que yo te indicaré.'"
,"3":"Se levantó Abrahán de madrugada, ensilló su burro, llamó a dos muchachos para que lo acompañaran, y tomó consigo a su hijo Isaac. Partió leña para el sacrificio y se puso en marcha hacia el lugar que Dios le había indicado."
,"4":"Al tercer día levantó los ojos y divisó desde lejos el lugar."
,"5":"Entonces dijo a los muchachos: 'Quédense aquí con el burro. El niño y yo nos vamos allá arriba a adorar, y luego volveremos donde ustedes.'"
,"6":"Abrahán tomó la leña para el sacrificio y la cargó sobre su hijo Isaac. Tomó luego en su mano el brasero y el cuchillo y en seguida partieron los dos."
,"7":"Entonces Isaac dijo a Abrahán: 'Padre mío.' Le respondió: '¿Qué hay, hijito?' Prosiguió Isaac: 'Llevamos el fuego y la leña, pero, ¿dónde está el cordero para el sacrificio?'"
,"8":"Abrahán le respondió: 'Dios mismo proveerá el cordero, hijo mío.' Y continuaron juntos el camino."
,"9":"Al llegar al lugar que Dios le había indicado, Abrahán levantó un altar y puso la leña sobre él. Luego ató a su hijo Isaac y lo colocó sobre la leña."
,"10":"Extendió después su mano y tomó el cuchillo para degollar a su hijo,"
,"11":"pero el Angel de Dios lo llamó desde el cielo y le dijo: 'Abrahán, Abrahán.' Contestó él: 'Aquí estoy.'"
,"12":"'No toques al niño, ni le hagas nada, pues ahora veo que temes a Dios, ya que no me has negado a tu hijo, el único que tienes.'"
,"13":"Abrahán miró a su alrededor, y vio cerca de él a un carnero que tenía los cuernos enredados en un zarzal. Fue a buscarlo y lo ofreció en sacrificio en lugar de su hijo."
,"14":"Abrahán llamó a aquel lugar 'Yavé provee'. Y todavía hoy la gente dice: 'En ese monte Yavé provee.'"
,"15":"Volvió a llamar el Angel de Dios a Abrahán desde el cielo,"
,"16":"y le dijo: 'Juro por mí mismo -palabra de Yavé- que, ya que has hecho esto y no me has negado a tu hijo, el único que tienes,"
,"17":"te colmaré de bendiciones y multiplicaré tanto tus descendientes, que serán tan numerosos como las estrellas del cielo o como la arena que hay a orillas del mar. Tus descendientes se impondrán a sus enemigos."
,"18":"Y porque has obedecido a mi voz, todos los pueblos de la tierra serán bendecidos a través de tu descendencia.'"
,"19":"Abrahán regresó a donde estaban sus muchachos, y juntos emprendieron la marcha hacia Bersebá, donde Abrahán fijó su residencia."
,"20":"Algún tiempo después, llegaron noticias a Abrahán de que también Melcá le había dado hijos a Najor, su hermano:"
,"21":"Us, el primogénito, Buz su hermano, Camuel, que fue padre de los sirios,"
,"22":"Cased, Azau, Feldas, Jedlaf y Batuel,"
,"23":"(que fue el padre de Rebeca.) Estos fueron los ocho hijos que Melcá dio a Najor, el hermano de Abrahán."
,"24":"Najor tenía una concubina, llamada Roma, que también dio a luz a Tebaj, Gajam, Tajas y Maaca."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Sara murió a la edad de ciento veintisiete años"
,"2":"en la ciudad de Kiriat-Arbe -o sea, Hebrón-, en el país de Canaán. Abrahán hizo duelo por ella y la lloró."
,"3":"Dejando el lugar donde estaba el cuerpo, Abrahán dijo a los hititas:"
,"4":"'Yo no soy más que un forastero en medio de ustedes. Denme una tierra en medio de ustedes, para que sea mía y pueda enterrar a mi difunta.'"
,"5":"Los hititas le respondieron:"
,"6":"'Escúchanos, señor: entre nosotros tú eres un príncipe de Dios. Sepulta a tu difunta en la mejor de nuestras sepulturas, pues ninguno de nosotros te negará una tumba para tu difunta.'"
,"7":"Se levantó Abrahán, e inclinándose ante los hititas,"
,"8":"les dijo: 'Si están de acuerdo en que yo entierre a mi difunta, escúchenme e intercedan por mí ante Efrón, hijo de Seor,"
,"9":"para que me ceda la cueva de Macpelá, que es suya y está al borde de su finca. Que me la dé por su precio justo, y que sea en adelante propiedad mía en medio de ustedes.'"
,"10":"Entonces Efrón, que estaba sentado entre los hititas presentes, le respondió de manera que todos lo oyeran:"
,"11":"'No, señor mío, escúchame: yo te regalo el campo y también la cueva que hay en él. En presencia de los hijos de mi pueblo te la doy. Sepulta allí a tu difunta.'"
,"12":"Abrahán se inclinó de nuevo profundamente ante los hititas, y se dirigió a Efrón, de modo que los propietarios presentes lo oyeran, y le dijo:"
,"13":"'A ver si nos entendemos: yo te pago el precio de la finca. Acéptamelo y enterraré en ella a mi difunta.'"
,"14":"Contestó Efrón a Abrahán: 'Señor mío, escúchame:"
,"15":"cuatrocientas monedas de plata por un terreno, ¿no sería lo justo para ambos? Pues bien, sepulta a tu difunta.'"
,"16":"Abrahán estuvo de acuerdo y pesó para Efrón, en presencia de los hititas, la plata que habían acordado: cuatrocientas piezas de plata, en monedas de mercader."
,"17":"Fue así como la finca de Efrón, que está en Macpelá, frente a Mambré, con la cueva que hay en ella y todos los árboles, tanto los que tiene el campo como los que hay en su alrededor,"
,"18":"pasaron a ser propiedad de Abrahán, a la vista de todos los hititas registrados en esta ciudad."
,"19":"Después Abrahán sepultó a Sara, su mujer, en la cueva que está en el campo de Macpelá, frente a Mambré, en Canaán."
,"20":"De este modo el campo, con la cueva que en él se encuentra, fueron vendidos a Abrahán por los hititas, para que sirviera de sepultura."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Abrahán era ya un anciano muy avanzado en edad, y Yavé le había favorecido en todo."
,"2":"Abrahán dijo a su servidor más antiguo, que era su mayordomo: 'Pon tu mano bajo mi muslo,"
,"3":"y júrame por Yavé, Dios del cielo y de la tierra, que no tomarás para mi hijo una mujer de raza cananea, pues vivo en medio de éstos,"
,"4":"sino que irás a mi país, a buscar entre mi parentela una mujer para mi hijo Isaac.'"
,"5":"El servidor le respondió: 'Y si la mujer no quiere venir conmigo a esta tierra, ¿tendré que llevar a tu hijo a la tierra de donde saliste?'"
,"6":"Abrahán le contestó: 'Por ningún motivo llevarás allá a mi hijo."
,"7":"Pues Yavé, Dios del cielo y de la tierra, que me sacó de la familia de mi padre y del país donde nací, me prometió con juramento que entregaría este país a mis descendientes. Y enviará a su Angel delante de ti, para que traigas de allá una mujer para mi hijo."
,"8":"Si la mujer no quiere seguirte, quedarás libre de este juramento. Pero en ningún caso llevarás para allá a mi hijo.'"
,"9":"El mayordomo colocó su mano debajo del muslo de su patrón Abrahán, y le juró que cumpliría este encargo."
,"10":"Luego el servidor escogió diez camellos entre los de su patrón y se puso en marcha, llevando todo lo mejor que poseía Abrahán. Y caminó hasta alcanzar la ciudad de Najor, en el país de Aram."
,"11":"Era ya tarde, la hora en que las mujeres salen a buscar agua al pozo; hizo arrodillar a los camellos junto al pozo, en las afueras de la ciudad."
,"12":"Entonces el mayordomo oró así: 'Yavé, Dios de mi patrón Abrahán, haz que me vaya bien hoy y muestra tu benevolencia para con mi patrón Abrahán."
,"13":"Voy a quedarme junto a la fuente, mientras las muchachas de la ciudad vienen a buscar agua,"
,"14":"y a una de ellas le voy a decir: 'Por favor, inclina tu cántaro para que yo pueda tomar agua.' Si ella me responde: 'Toma y daré también de beber a tus camellos', haz que sea ella la que tú has destinado para tu servidor Isaac. Esta será para mí la señal de que has escuchado a mi patrón.'"
,"15":"No había terminado de orar, cuando salió Rebeca con su cántaro al hombro. Era la hija de Batuel, el hijo de Milcá, esposa de Najor, hermano de Abrahán."
,"16":"La joven era muy bella y aún virgen, pues no había tenido contacto con ningún hombre. Bajó a la fuente, llenó el cántaro y subió."
,"17":"Entonces el hombre corrió a su encuentro y le dijo: 'Por favor, dame un poco de agua de tu cántaro.'"
,"18":"Ella respondió: 'Bebe, mi señor.' Y bajando inmediatamente el cántaro sobre su mano le dio de beber."
,"19":"Cuando hubo acabado de darle agua, le dijo: 'También sacaré agua para tus camellos hasta que se sacien.'"
,"20":"Vació rápidamente su cántaro en la pila, corrió de nuevo al pozo a sacar agua y trajo para todos sus camellos."
,"21":"Entretanto el hombre la contemplaba en silencio, preguntándose si Yavé habría hecho que su viaje tuviera éxito o no."
,"22":"Cuando acabaron de beber los camellos, él sacó un anillo de oro de seis gramos y se lo puso a la joven en las narices. Luego tomó para sus brazos dos brazaletes de oro de unos sesenta gramos."
,"23":"Y le dijo: 'Dime, por favor, ¿de quién eres hija? ¿Habrá lugar en la casa de tus padres para pasar la noche?'"
,"24":"Ella le respondió: 'Soy hija de Batuel, el hijo que Milcá le dio a Najor.'"
,"25":"Y prosiguió: 'Tenemos paja y forraje en abundancia, y también hay lugar para pasar la noche.'"
,"26":"Entonces el hombre cayó de rodillas y adoró a Yavé,"
,"27":"diciendo: 'Bendito sea Yavé, Dios de mi señor Abrahán, pues ha mostrado una vez más su bondad y fidelidad para con mi patrón, y me ha conducido a la casa del hermano de mi amo.'"
,"28":"Mientras tanto la joven corrió y contó a la casa de su madre todo lo sucedido."
,"29":"Rebeca tenía un hermano llamado Labán."
,"30":"Cuando vio el anillo y los brazaletes que llevaba su hermana, y oyó decir a Rebeca: 'Esto me ha dicho ese hombre...', corrió a buscar al hombre que estaba de pie junto a los camellos, al lado del pozo."
,"31":"Y le dijo: '¡Oh bendito de Yavé! ¿Por qué te quedas afuera? Ven. He despejado un sitio en la casa y hay cabida para tus camellos.'"
,"32":"Entonces el hombre entró en la casa y desensilló los camellos. Dieron paja y forraje a los camellos, y a él y sus acompañantes les trajeron agua para que se lavaran los pies."
,"33":"Después les ofrecieron comida. Pero él dijo: 'No comeré hasta que no diga lo que tengo que decir.' Labán le dijo: 'Habla.'"
,"34":"Entonces empezó a decir: 'Yo soy servidor de Abrahán."
,"35":"Yavé ha bendecido y enriquecido a mi amo. Le ha dado ganado, ovejas, plata y oro, servidores y sirvientas, camellos y burros."
,"36":"Ahora bien, siendo ya muy anciano, su esposa Sara le ha dado un hijo al que ha dejado todo lo que posee."
,"37":"Mi patrón me hizo jurar y me ordenó: 'No buscarás esposa para mi hijo de entre las mujeres cananeas, en cuyo país vivo,"
,"38":"sino que irás a la tierra de mi padre y buscarás en mi familia una esposa para mi hijo.'"
,"39":"Yo le pregunté: '¿Y si ella no quiere seguirme?'"
,"40":"El me contestó: 'Yavé, al que he servido siempre, mandará a su Angel para que te acompañe, y resulte tu viaje. Tomarás una mujer para mi hijo de entre mi parentela y de la casa de mi padre."
,"41":"Quedarás libre de tu juramento con tan sólo llegar donde mi parentela: si ellos no te la quieren dar, quedarás libre.'"
,"42":"Así, pues, al llegar hoy a la fuente hice esta súplica: 'Yavé, Dios de mi señor Abrahán, si quieres que el viaje que he emprendido tenga éxito, concédeme lo siguiente:"
,"43":"Me voy a quedar parado al lado de la fuente, y cuando llegue alguna joven a sacar agua, le diré: 'Dame un poco de agua de tu cántaro'."
,"44":"Y si me responde: 'Toma, y luego sacaré más agua para tus camellos', que ésa sea la mujer que Yavé tiene destinada para el hijo de mi patrón."
,"45":"Ni siquiera había terminado de decir estas palabras en mi interior, cuando apareció Rebeca, con su cántaro al hombro, y bajó a la fuente para sacar agua."
,"46":"Yo le dije: 'Por favor, dame de beber.' Al momento bajó el cántaro de su hombro y dijo: 'Toma, y también voy a dar agua a tus camellos.' Bebí, pues, y después ella dio también agua a mis camellos."
,"47":"En seguida le pregunté: '¿De quién eres hija?' Me respondió: 'Soy hija de Batuel, el hijo de Najor y de Milcá.' Entonces le puse el anillo en su nariz y los brazaletes en sus brazos,"
,"48":"e hincándome de rodillas, adoré a Yavé, bendiciendo al Dios de mi patrón Abrahán, que me había conducido por el buen camino para conseguir para su hijo a la hija del hermano de mi patrón."
,"49":"Ahora, si ustedes tienen una respuesta buena y sincera para mi patrón, háganmelo saber; y si no, díganmelo también para que pueda tomar una decisión.'"
,"50":"Labán y Batuel respondieron: 'En todo esto está la mano de Yavé, y no tenemos nada que añadir."
,"51":"Ahí tienes a Rebeca: tómala y llévala contigo. Que sea la esposa del hijo de tu patrón, como Yavé lo ha dispuesto.'"
,"52":"Al oír esto el servidor de Abrahán, se echó por tierra adorando a Yavé."
,"53":"Luego sacó joyas de oro y plata, y también vestidos, y se los dio a Rebeca. Hizo también valiosos regalos a su hermano y a su madre."
,"54":"Luego él y sus acompañantes comieron y bebieron. Pasaron allí la noche, y a la mañana siguiente, apenas se levantaron, él dijo: 'Permítanme volver donde mi señor.' "
,"55":"Entonces el hermano y la madre de Rebeca contestaron: 'Que la joven se quede todavía algunos días más con nosotros y después se irá.'"
,"56":"Pero él insistió: 'Si Yavé hizo que mi viaje tuviera éxito, ustedes ahora no me demoren, y déjenme volver a la casa de mi patrón.'"
,"57":"Ellos le dijeron: 'Llamemos entonces a la joven y pidámosle su parecer.'"
,"58":"Llamaron pues a Rebeca y le preguntaron: '¿Quieres irte con este hombre?' Contestó: 'Sí, me voy.'"
,"59":"Entonces dejaron partir a su hermana Rebeca y a su nodriza con el servidor de Abrahán y sus hombres."
,"60":"Y bendijeron a Rebeca, diciendo: 'Hermana nuestra, ojalá des vida a multitudes, y que tus descendientes se impongan a sus enemigos.'"
,"61":"Entonces se levantó Rebeca con sus criadas, montaron en los camellos y siguieron a los hombres. Fue así como el servidor de Abrahán se llevó a Rebeca."
,"62":"Isaac acababa de volver del pozo de Lajay-Roi, pues estaba viviendo en el Negueb."
,"63":"Al atardecer, como salía a dar un paseo por el campo, vio que se acercaban unos camellos."
,"64":"También Rebeca divisó a Isaac, y al verlo se bajó del camello."
,"65":"Y preguntó al mayordomo: '¿Quién es aquel hombre que viene por el campo a nuestro encuentro?' Le respondió: 'Es mi patrón.' Ella entonces tomó su velo y se cubrió el rostro."
,"66":"El mayordomo contó a Isaac, todo lo que había hecho."
,"67":"Isaac llevó a Rebeca a la tienda que había sido de su madre Sara. La hizo suya y fue su esposa. La amó y así se consoló por la muerte de su madre."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Abrahán tomó a otra mujer llamada Queturá,"
,"2":"de la que tuvo los siguientes hijos: Zamram, Jecsán, Madián, Jesboc y Suraj."
,"3":"Jecsán fue padre de Saba y Dedán. Los hijos de Dedán fueron los asuritas, los latusíes y los leumíes."
,"4":"De Madián nacieron: Efá, Efer, Enoc, Abidá y Eldaa. Todos estos fueron descendientes de Queturá."
,"5":"Abrahán dio todo lo suyo a Isaac."
,"6":"A los hijos de las concubinas que tenía Abrahán, en cambio, les hizo regalos, y estando él vivo todavía, los envió más al este, a los países del oriente, lejos de Isaac."
,"7":"Abrahán vivió ciento setenta y cinco años."
,"8":"Abrahán murió luego de una feliz ancianidad, cargado de años, y fue a reunirse con sus antepasados."
,"9":"Sus dos hijos, Isaac e Ismael, lo sepultaron en la cueva de Macpelá, que está en el campo de Efrón, hijo de Seor el hitita enfrente de Mambré."
,"10":"Esta era la finca que Abrahán había comprado a los hititas, allí fueron sepultados Abrahán y su esposa Sara."
,"11":"Después de la muerte de Abrahán, Dios bendijo a su hijo Isaac, que se fue a vivir cerca del pozo de Lajay-Roi."
,"12":"Estos son los descendientes de Ismael, hijo de Abrahán y de Agar la egipcia, esclava de Sara."
,"13":"Y éstos son los nombres de los hijos de Ismael, y son los nombres de sus descendientes: El primogénito es Nebaiot; después vienen Cedar, Adbeel, Mibsam,"
,"14":"Masma, Duma, Massa,"
,"15":"Hadar, Tema, Jetur, Nafis y Cedma."
,"16":"Estos son los hijos de Ismael y éstos son los nombres de sus pueblos y campamentos. Fueron doce, caudillos de sus respectivas tribus."
,"17":"Ismael vivió ciento treinta y siete años. Luego murió y fue a juntarse con sus antepasados."
,"18":"Sus descendientes permanecieron en la región que se extiende desde Hevilá hasta Sur, frente a Egipto, en dirección a Asur. Se mantienen a distancia de todos sus hermanos."
,"19":"Estas son las memorias de Isaac, hijo de Abrahán."
,"20":"Abrahán fue padre de Isaac. Cuando Isaac tenía cuarenta años, tomó por esposa a Rebeca, hija de Betuel, el arameo de Paddán Aram, y hermana de Labán el arameo."
,"21":"Isaac suplicó a Yavé en favor de su esposa, pues era estéril. Yavé escuchó su oración y Rebeca, su esposa, quedó encinta."
,"22":"Pero como los hijos chocasen entre sí en su seno, ella dijo: 'Si esto debe seguir, yo me muero.' Y fue a consultar a Yavé."
,"23":"Yavé le dijo: 'Dos naciones hay en tu seno; dos pueblos se separarán desde tus entrañas. Uno será más fuerte que el otro, y el mayor servirá al menor.'"
,"24":"Llegó el día del nacimiento, y se comprobó que había mellizos en su vientre."
,"25":"El primero que nació era rojizo y tan peludo que parecía un abrigo de pieles, por lo que lo llamaron Esaú."
,"26":"Después salió su hermano, que agarraba con su mano el talón de Esaú, y lo llamaron Jacob. Isaac tenía sesenta años cuando nacieron."
,"27":"Los dos muchachos crecieron. Esaú llegó a ser un experto cazador y un hombre de campo abierto, mientras Jacob era un hombre tranquilo a quien le gustaba estar en la tienda."
,"28":"Isaac quería a Esaú porque le gustaba la caza, pero Rebeca prefería a Jacob."
,"29":"En cierta ocasión estaba Jacob cocinando un guiso, cuando llegó Esaú del campo, muy agotado."
,"30":"Dijo Esaú a Jacob: 'Por favor, dame un poco de ese guiso rojizo, pues estoy hambriento' (por eso fue llamado Edom, o sea, rojizo)."
,"31":"Jacob le dijo: 'Me vendes, pues, ahora mismo tus derechos de primogénito.'"
,"32":"Esaú le respondió: 'Estoy que me muero, ¿qué me importan mis derechos de primogénito?'"
,"33":"Jacob insistió: 'Júramelo ahora mismo.' Y lo juró, vendiéndole sus derechos."
,"34":"Jacob entonces dio a su hermano pan y el guiso de lentejas. Esaú comió y bebió, y después se marchó. No hizo mayor caso de sus derechos de primogénito."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Hubo hambre en el país -ésta no se debe confundir con la primera hambruna que hubo en tiempos de Abrahán-, y fue Isaac a Guerar, hacia Abimelec, rey de los filisteos."
,"2":"Se le apareció Yavé y le dijo: 'No bajes a Egipto, quédate en la tierra que yo te diga."
,"3":"Serás forastero en esa tierra, pero yo estaré contigo y te bendeciré. Pues quiero darte a ti y a tus descendientes todas estas tierras, cumpliendo así el juramento que hice a tu padre Abrahán."
,"4":"Multiplicaré tu descendencia como las estrellas del cielo y le daré todas esas tierras. Y por tu descendencia serán bendecidas todas las naciones de la tierra,"
,"5":"como premio a la obediencia de Abrahán, que guardó mis leyes y cumplió mis mandamientos y preceptos.'"
,"6":"Isaac, pues, se estableció en Guerar."
,"7":"Cuando la gente de aquel país le preguntaba quién era la mujer que iba con él, les decía: 'Es mi hermana.' Porque tenía miedo a decir que era su esposa, para que no lo fueran a matar por causa de Rebeca, que era muy bonita."
,"8":"Llevaba ya bastante tiempo allí, cuando Abimelec, rey de los filisteos, mirando por una ventana, sorprendió a Isaac acariciando a Rebeca."
,"9":"Entonces Abimelec mandó llamar a Isaac y le dijo: '¡No puedes negar que es tu mujer! ¿Por qué has declarado que es tu hermana?' Isaac le contestó: 'Es que pensé que por causa de ella me podrían matar.'"
,"10":"Abimelec replicó: '¡En qué lío nos metiste! Por poco uno de aquí se acostaba con tu esposa y tú nos cargabas con un delito.'"
,"11":"Entonces Abimelec dio la siguiente orden a toda su gente: 'El que toque a este hombre o a su esposa, morirá.'"
,"12":"Isaac sembró en aquella tierra y cosechó aquel año el ciento por uno. Yavé lo bendijo"
,"13":"de manera que se fue enriqueciendo día a día hasta que el hombre llegó a ser muy rico."
,"14":"Tenía rebaños de ovejas, rebaños de vacas y numerosos criados, por lo que los filisteos empezaron a mirarlo con envidia."
,"15":"Los filisteos taparon todos los pozos que habían cavado los servidores de su padre, en tiempos de Abrahán, y los llenaron de tierra."
,"16":"Entonces Abimelec dijo a Isaac: 'Márchate de aquí, pues ahora eres más poderoso que nosotros.'"
,"17":"Isaac partió de allí y acampó en el valle de Guerar, en donde se quedó."
,"18":"Isaac volvió a abrir los pozos que habían sido cavados en tiempos de su padre Abrahán, y que habían tapado los filisteos después de la muerte de Abrahán, y les puso los mismos nombres que les había puesto su padre."
,"19":"Después los hombres de Isaac hicieron excavaciones en el valle y dieron con una capa de agua."
,"20":"Pero los pastores de Guerar riñeron con los pastores de Isaac diciendo que el agua era de ellos. Por eso, Isaac llamó a ese pozo Esec, ya que se habían peleado por él."
,"21":"Excavaron otro pozo, pero también hubo peleas, por lo que lo llamó Sitna."
,"22":"Se fue de allí a otra parte y mandó cavar otro pozo, y como esta vez nadie se peleó por él, le puso el nombre de Rejobot, pues dijo: 'Por fin Yavé nos pone a nuestras anchas. Ahora sí que podremos prosperar en esta tierra.'"
,"23":"De allí subió a Bersebá."
,"24":"Yavé se le apareció aquella misma noche y le dijo: 'Yo soy el Dios de tu padre Abrahán. No temas, porque yo estoy contigo. Te bendeciré, y multiplicaré tu descendencia por amor de Abrahán, mi servidor.'"
,"25":"Levantó allí un altar e invocó el nombre de Yavé. Luego plantó allí mismo su tienda, y sus hombres cavaron un pozo."
,"26":"Abimelec vino desde Guerar a verlo, acompañado de su amigo Ajuzat, y de Ficol, jefe de su ejército."
,"27":"Isaac les dijo: '¿Por qué vienen a visitarme, si ustedes me odian y me han hecho marchar?'"
,"28":"Le contestaron: 'Hemos visto claramente que Yavé está contigo, y hemos dicho: Prometamos con juramento, nosotros y tú, que viviremos en paz."
,"29":"Y hagamos un pacto: tú no nos harás ningún mal, ya que nosotros no te hemos tocado nada sino que, al contrario, sólo te hicimos bien y te dejamos partir tranquilamente. Tú eres el protegido de Yavé.'"
,"30":"Isaac les dio un banquete, y comieron y bebieron."
,"31":"Se levantaron muy temprano y se hicieron juramento unos a otros. Luego Isaac los despidió y se fueron en paz por su camino."
,"32":"Ese mismo día llegaron unos servidores de Isaac a comunicarle que habían abierto un pozo y que habían encontrado agua."
,"33":"El lo llamó Sebá, y de aquí viene que la ciudad se llame Bersebá hasta el día de hoy."
,"34":"Cuando Esaú tenía cuarenta años, tomó por esposa a Judit, hija de Berí el heteo, y a Basemat, hija de Elón, heteo también."
,"35":"Pero ellas amargaron la vida a Isaac y a Rebeca."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Siendo Isaac ya anciano, y con sus ojos tan debilitados que no veía nada, llamó a su hijo mayor Esaú. Como le dijera: '¡Hijo mío!', Esaú respondió: 'Aquí estoy.'"
,"2":"Prosiguió Isaac: 'Mira que ya estoy viejo e ignoro el día de mi muerte."
,"3":"Así, pues, toma tus armas, tu arco y la caja de las flechas, sal al campo y caza alguna pieza para mí."
,"4":"Luego me preparas un guiso como a mí me gusta y me lo sirves, y yo te daré la bendición antes de que muera.'"
,"5":"Rebeca estaba escuchando la conversación de Isaac con Esaú. Cuando éste se fue al campo en busca de caza para su padre,"
,"6":"Rebeca dijo a su hijo Jacob: 'Acabo de oír a tu padre que hablaba con tu hermano Esaú y le dijo:"
,"7":"'Vete a cazar y prepárame un guiso, para que yo lo coma y te pueda bendecir ante Yavé, antes de morirme'."
,"8":"Ahora, pues, hijo, escúchame y haz cuanto te diga."
,"9":"Anda al corral y tráeme dos cabritos de los mejores que haya; con ellos haré un guiso como le gusta a tu padre."
,"10":"Después tú se lo presentas a tu padre para que lo coma y te bendiga antes de su muerte.'"
,"11":"Jacob dijo a su madre Rebeca: 'Pero mi padre sabe que yo soy lampiño y mi hermano muy velludo."
,"12":"Si me toca se dará cuenta del engaño y recibiré una maldición en lugar de una bendición.'"
,"13":"Su madre le replicó: 'Tomo para mí la maldición. Pero tú, hijo mío, hazme caso, y ve a buscar lo que te pedí.'"
,"14":"Fue, pues, a buscarlo y se lo llevó a su madre, que preparó para su padre uno de sus platos preferidos."
,"15":"Después, tomando las mejores ropas del hijo mayor Esaú, que tenía en casa, vistió con ellas a Jacob, su hijo menor."
,"16":"Con las pieles de los cabritos le cubrió las manos y la parte lampiña del cuello,"
,"17":"y luego puso en las manos de Jacob el guiso y el pan que había preparado."
,"18":"Jacob entró donde estaba su padre y le dijo: '¡Padre!' El le preguntó: 'Sí, hijo mío. ¿Quién eres?'"
,"19":"Y Jacob dijo a su padre: 'Soy Esaú, tu primogénito. Ya hice lo que me mandaste. Levántate, siéntate y come la caza que te he traído. Después me bendecirás.'"
,"20":"Dijo Isaac: '¡Qué pronto lo has encontrado, hijo!' Contestó Jacob: 'Es que Yavé, tu Dios, me ha dado buena suerte.'"
,"21":"Isaac le dijo: 'Acércate, pues quiero tocarte y comprobar si eres o no mi hijo Esaú.',Jacob se acercó a su padre Isaac, "
,"22":"quien lo palpó y dijo: 'La voz es la de Jacob, pero las manos son las de Esaú.'"
,"23":"Y no lo reconoció, pues sus manos eran velludas como las de su hermano Esaú, y lo bendijo."
,"24":"Volvió a preguntarle: '¿Eres de verdad mi hijo Esaú?' Contestó Jacob: 'Sí, yo soy.'"
,"25":"Isaac continuó: 'Acércame la caza que me has preparado, hijo mío, para que la coma y te dé mi bendición.' Jacob le sirvió y comió. También le ofreció vino, y bebió."
,"26":"Entonces Isaac le dijo: 'Acércate y bésame, hijo mío.'"
,"27":"Jacob se acercó y le besó. Al sentir Isaac el perfume de su ropa, lo bendijo con estas palabras: '¡Oh!, el olor de mi hijo,es el de un campo al que Yavé bendijo."
,"28":"Que Dios te dé el rocío del cielo,y la fertilidad de la tierra, y abundancia de trigos y mostos."
,"29":"Que te sirvan los pueblos,y las naciones se inclinen ante ti. Sé señor de tus hermanos, que los hijos de tu madre se inclinen ante ti. Sea maldito quien te maldiga, y bendito quien te bendiga.'"
,"30":"Apenas Isaac había terminado de bendecirle, y Jacob había salido de la pieza de su padre, cuando llegó Esaú, su hermano, con el producto de su caza."
,"31":"Preparó también el guiso y se lo llevó a su padre, diciendo: 'Levántate, padre, y come la caza que tu hijo te ha preparado, de manera que me puedas dar tu bendición.'"
,"32":"Pero Isaac le dijo: '¿Y quién eres tú?' Respondió: 'Soy Esaú, tu primogénito.'"
,"33":"Isaac comenzó a temblar violentamente y dijo: 'Pues entonces, ¿quién es el que cazó y me sirvió su caza? Yo comí de todo antes de que tú llegaras y le di mi bendición: ¡sí, él tiene la bendición!'"
,"34":"Al oír Esaú las palabras de su padre, se puso a gritar muy amargamente, y dijo a su padre: 'Bendíceme también a mí, padre.'"
,"35":"Isaac respondió: 'Tu hermano ha venido, me ha engañado y se ha tomado tu bendición.'"
,"36":"Esaú declaró: 'Con razón le dieron el nombre de Jacob, pues me ha suplantado por segunda vez. Primero me quitó los derechos de primogénito, y ahora me ha quitado la bendición.',Esaú preguntó: '¿Y no me has reservado alguna bendición?' "
,"37":"Respondió Isaac: 'Lo he hecho tu señor y señor de todos tus hermanos. Lo he abastecido de trigo y vino. Después de esto, ¿qué quieres que haga por ti, hijo mío?'"
,"38":"Esaú insistió: '¿Acaso no tienes más bendición que ésta? Padre, bendíceme a mí también.' Y Esaú se puso a llorar."
,"39":"Entonces Isaac le respondió: 'Mira, vivirás lejos de las tierras fértiles y lejos del rocío del cielo."
,"40":"De tu espada vivirás y a tu hermano servirás; pero cuando así lo quieras, quitarás su yugo de tu cuello.'"
,"41":"Esaú le tomó odio a Jacob, a causa de la bendición que le había dado su padre, y se decía: 'Se acercan ya los días de luto por mi padre, y entonces mataré a mi hermano Jacob.'"
,"42":"Contaron a Rebeca las palabras de Esaú, su hijo mayor, y mandó a llamar a Jacob, su hijo menor, al que dijo: 'Tu hermano Esaú quiere vengarse de ti y matarte."
,"43":"Por lo tanto, hijo mío, hazme caso y huye ahora mismo a Jarán, a la casa de mi hermano Labán."
,"44":"Te quedarás con él por algún tiempo hasta que se calme el furor de tu hermano."
,"45":"Cuando ya no esté enojado y haya olvidado lo que le has hecho, yo enviaré a buscarte y volverás. Pero no quiero perderlos a ustedes dos en un mismo día.'"
,"46":"Rebeca dijo a Isaac: 'Estas mujeres hititas me tienen tan aburrida que ya no quiero vivir. Si también Jacob se casa con una mujer de esta tierra, yo me muero.'"
}`)
	CurrentBook.AddChapter(28, `{
"1":"Entonces Isaac llamó a su hijo Jacob, lo bendijo y le dio esta orden: 'No te cases con ninguna mujer cananea."
,"2":"Ponte en camino y vete a Padán-Aram, a la casa de Batuel, el padre de tu madre, y elige allí una mujer para ti de entre las hijas de Labán, hermano de tu madre."
,"3":"Que el Dios de las Alturas te bendiga, te multiplique y de ti salgan muchas naciones."
,"4":"Que Dios te conceda la bendición de Abrahán, a ti y a tu descendencia, para que te hagas dueño de la tierra en que ahora vives, y que Dios dio a Abrahán.'"
,"5":"Isaac despidió a Jacob, que se dirigió a Padán-Aram, a la casa de Labán, hijo de Betuel el arameo, hermano de Rebeca."
,"6":"Esaú vio que su padre había bendecido a Jacob y lo enviaba a Padán-Aram para que allí se buscara una mujer. Escuchó también que, después de haberlo bendecido, le había ordenado: 'No te cases con ninguna mujer cananea',"
,"7":"y que Jacob, obedeciendo a su padre y a su madre, se había ido a Padán-Aram."
,"8":"Comprendió, pues, que las mujeres cananeas no agradaban a su padre Isaac."
,"9":"Se dirigió a Ismael y tomó por esposa, además de las que tenía, a Majalat, hija de Ismael, hijo de Abrahán, y hermana de Nebayot."
,"10":"Jacob dejó Bersebá y se dirigió hacia Jarán."
,"11":"Al llegar a un cierto lugar, se dispuso a pasar allí la noche pues el sol se había ya puesto. Escogió una de las piedras del lugar, la usó de cabecera, y se acostó en ese lugar."
,"12":"Mientras dormía, tuvo un sueño. Vio una escalera que estaba apoyada en la tierra, y que tocaba el cielo con la otra punta, y por ella subían y bajaban ángeles de Dios."
,"13":"Yavé estaba allí a su lado, de pie, y le dijo: 'Yo soy Yavé, el Dios de tu padre Abrahán y de Isaac. Te daré a ti y a tus descendientes la tierra en que descansas."
,"14":"Tus descendientes serán tan numerosos como el polvo de la tierra y te extenderás por oriente y occidente, por el norte y por el sur. A través de ti y de tus descendientes serán bendecidas todas las naciones de la tierra."
,"15":"Yo estoy contigo; te protegeré a dondequiera que vayas y te haré volver a esta tierra, pues no te abandonaré hasta que no haya cumplido todo lo que te he dicho.'"
,"16":"Se despertó Jacob de su sueño y dijo: 'Verdaderamente Yavé estaba en este lugar y yo no me di cuenta.'"
,"17":"Sintió miedo y dijo: '¡Cuán digno de todo respeto es este lugar! ¡Es nada menos que una Casa de Dios! ¡Esta es la Puerta del Cielo!'"
,"18":"Se levantó Jacob muy temprano, tomó la piedra que había usado de cabecera, la puso de pie y derramó aceite sobre ella."
,"19":"Jacob llamó a ese lugar Betel, pues antes aquella ciudad era llamada Luz."
,"20":"Entonces Jacob hizo una promesa: 'Si Dios me acompaña y me protege durante este viaje que estoy haciendo, si me da pan para comer y ropa para vestirme,"
,"21":"y si logro volver sano y salvo a la casa de mi padre, Yavé será mi Dios."
,"22":"Esta piedra que he puesto de pie como un pilar será Casa de Dios y, de todo lo que me des, yo te devolveré la décima parte.'"
}`)
	CurrentBook.AddChapter(29, `{
"1":"Jacob, siguiendo su viaje, llegó a la tierra de oriente."
,"2":"En el camino vio un pozo, y cerca de él descansaban tres rebaños de ovejas, pues era en este pozo donde tomaban agua los rebaños. Una gran piedra cubría la boca del pozo."
,"3":"Allí se juntaban todos los pastores, removían la piedra, sacaban agua para los rebaños y volvían a colocar la piedra sobre la boca del pozo."
,"4":"Jacob dijo a los pastores: 'Hermanos, ¿de dónde son ustedes?' Contestaron: 'Somos de Jarán.'"
,"5":"Les preguntó Jacob: '¿Conocen a Labán, el hijo de Najor.' Contestaron: 'Sí, lo conocemos.'"
,"6":"'¿Está bien?', preguntó aún. Contestaron: 'Sí, muy bien. Mira, justamente allí viene su hija Raquel con las ovejas.'"
,"7":"Jacob les dijo: 'Veo que el sol está todavía alto y que aún no es hora para guardar el ganado, ¿por qué no dan agua a sus ovejas y las llevan a pastar.'"
,"8":"Los pastores respondieron: 'No podemos hacer eso hasta que no se junten todos los rebaños y se haya sacado la piedra de la boca del pozo. Entonces damos de beber a las ovejas.'"
,"9":"Todavía estaba Jacob hablando con ellos, cuando llegó Raquel con las ovejas de su padre, pues era pastora."
,"10":"Apenas Jacob vio a Raquel, hija de Labán, hermano de su madre, se acercó al pozo, movió la piedra de la boca del pozo y dio agua a las ovejas de Labán."
,"11":"Jacob besó a Raquel y estalló en fuerte llanto."
,"12":"Jacob hizo saber a Raquel que era hermano de su padre e hijo de Rebeca, y ella fue corriendo a decírselo a su padre."
,"13":"Apenas supo Labán que Jacob era el hijo de su hermana, corrió a su encuentro, lo abrazó, lo besó, y lo llevó a su casa."
,"14":"Jacob contó a Labán todo lo ocurrido, y Labán le dijo: 'En verdad tú eres carne y hueso míos.' Y Jacob se quedó allí con él durante un mes."
,"15":"Entonces Labán le dijo: '¿Acaso porque eres hermano mío vas a trabajar para mí de balde? Dime cuál va a ser tu salario.'"
,"16":"Labán tenía dos hijas: la mayor se llamaba Lía, y la menor Raquel."
,"17":"Lía no tenía brillo en sus ojos, mientras Raquel tenía buena presencia y era linda."
,"18":"Jacob se había enamorado de Raquel, así que le contestó: 'Te serviré siete años por Raquel, tu hija menor.'"
,"19":"Labán dijo: 'Mejor te la doy a ti y no a cualquier otro hombre. Quédate, pues, conmigo.'"
,"20":"Jacob trabajó siete años por Raquel, pero la amaba tanto, que los años le parecieron días."
,"21":"Entonces Jacob dijo a Labán: 'Dame a mi esposa, pues se ha cumplido el plazo y ahora quiero vivir con ella.'"
,"22":"Labán invitó a todos los del lugar y dio un banquete,"
,"23":"y por la tarde, tomó a su hija Lía y se la llevó a Jacob, que se acostó con ella."
,"24":"Labán dió a Lía su propia esclava Zilpá, para que fuera sirvienta de ella."
,"25":"A la mañana siguiente: ¡Caramba! ¡Lía! Jacob dijo a Labán: '¿Qué me has hecho? Yo te he servido por Raquel."
,"26":"¿Por qué me has engañado?' Labán le respondió: 'No se acostumbra por aquí dar la menor antes que la mayor."
,"27":"Deja que se termine la semana de bodas, y te daré también a mi hija menor, pero tendrás que prestarme servicios por otros siete años más.'"
,"28":"Jacob lo aceptó, y al terminar la semana de bodas con Lía, Labán le entregó a su hija Raquel."
,"29":"Labán le dio a Raquel a su esclava Bilá como sierva."
,"30":"Jacob se unió también a Raquel, y amó a Raquel más que a Lía. Y se quedó con Labán al que prestó servicios siete años más."
,"31":"Al ver Yavé que Lía no era querida, le concedió ser fecunda, mientras que Raquel era estéril."
,"32":"Lía quedó embarazada y dio a luz un hijo, al que llamó Rubén, porque decía: 'En verdad Yavé ha visto mi aflicción; ahora mi esposo me amará.'"
,"33":"De nuevo quedó embarazada, y dio a luz un hijo; entonces dijo: 'Yavé ha oído que yo era despreciada y me ha dado todavía otro hijo.' Por eso le puso por nombre Simeón."
,"34":"Volvió a quedar esperando y tuvo otro hijo; y esta vez dijo: 'Ahora sí que me querrá mi marido, pues le he dado ya tres hijos.' Por eso lo llamó Leví."
,"35":"Concibió todavía otra vez y dio a luz un hijo. Y exclamó: 'Esta vez alabaré a Yavé.' Por eso le puso por nombre Judá, y ya dejó de tener hijos."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Raquel, viendo que no daba hijos a Jacob, se puso envidiosa de su hermana y dijo a Jacob: 'Dame hijos, porque si no, me muero.'"
,"2":"Entonces Jacob se enojó con Raquel y le dijo: 'Si Dios te ha negado los hijos, ¿qué puedo hacer yo?'"
,"3":"Ella le contestó: 'Aquí tienes a mi esclava Bilá. Únete a ella y que dé a luz sobre mis rodillas. Así tendré yo también un hijo por medio de ella.'"
,"4":"Le dio, pues, a su esclava Bilá, y Jacob se unió a ella."
,"5":"Bilá quedó embarazada, y dio a Jacob un hijo."
,"6":"Entonces Raquel dijo: 'Dios me ha hecho justicia, pues ha oído mi voz y me ha dado un hijo.' Por eso le puso por nombre Dan."
,"7":"Otra vez concibió Bilá, la esclava de Raquel, y dio a Jacob un segundo hijo."
,"8":"Y Raquel dijo: 'Tuve una lucha tremenda con mi hermana y he vencido.' Por eso lo llamó Neftalí."
,"9":"Viendo Lía que había dejado de tener hijos, tomó a su sierva Zelfa y se la dio por mujer a Jacob."
,"10":"Y Zelfa, esclava de Lía, dio un hijo a Jacob."
,"11":"Lía exclamó: '¡Qué suerte!', y le puso por nombre Gad."
,"12":"Zelfa, la sierva de Lía, dio un segundo hijo a Jacob,"
,"13":"y dijo Lía: '¡Felicidad! Las mujeres me felicitarán.' Y le llamó Aser."
,"14":"En el tiempo de la siega del trigo, salió Rubén y encontró unas manzanas silvestres en el campo; y se las llevó a su madre Lía. Las vio Raquel y dijo a Lía: 'Por favor, dame alguna de esas manzanas silvestres que ha traído tu hijo.'"
,"15":"Le respondió Lía: '¿No te basta con haberme quitado el marido, que ahora quieres llevarte también las manzanas de mi hijo?' Raquel le dijo: 'Muy bien, que duerma contigo esta noche, a cambio de las manzanas de tu hijo.'"
,"16":"Cuando por la tarde llegaba Jacob del campo, Lía salió a su encuentro y le dijo: 'Esta noche dormirás conmigo, pues te he alquilado por unas manzanas de mi hijo.'"
,"17":"Aquella noche, pues, durmió Jacob con ella. Dios escuchó las oraciones de Lía, la que concibió y le dio a Jacob el quinto hijo."
,"18":"Dijo Lía: 'Dios me ha premiado por haber entregado mi sierva a mi marido.' Le puso por nombre Isacar."
,"19":"De nuevo Lía quedó embarazada, y dio a Jacob el sexto hijo."
,"20":"Y dijo: 'Me ha hecho Dios un buen regalo. Ahora mi marido cohabitará conmigo, porque le he dado seis hijos.' Y le llamó Zabulón."
,"21":"Después dio a luz a una niña, y le puso el nombre de Dina."
,"22":"Entonces Dios se acordó de Raquel, oyó sus ruegos y le concedió ser fecunda."
,"23":"Concibió y dio a luz un hijo, y exclamó: 'Dios me ha quitado de encima la vergüenza.'"
,"24":"Y le puso por nombre José, pues decía: '¡Ojalá Yavé me dé otro hijo!'"
,"25":"Después de que Raquel hubo dado a luz a José, Jacob dijo a Labán: 'Déjame regresar a mi patria y mi tierra."
,"26":"Dame mis esposas y mis hijos, por quienes te he servido, y déjame partir, pues bien sabes con qué fidelidad te he servido.'"
,"27":"Labán le contestó: 'Hazme un favor. El cielo me hizo ver que Yavé me bendecía gracias a ti.'"
,"28":"Y agregó: 'Dime cuánto te debo y te lo pagaré.'"
,"29":"Jacob respondió: 'Tú sabes cómo te he servido, y cómo le fue a tu rebaño conmigo."
,"30":"Poco era lo que tenías antes de que yo llegara aquí; pero después creció enormemente y Yavé te ha bendecido. ¿Cuándo, pues, podré trabajar para mi propia casa?'"
,"31":"Dijo Labán: '¿Qué te puedo dar?',Jacob respondió: 'No me des nada, pero si haces por mí lo que voy a pedirte, seguiré cuidando tus rebaños."
,"32":"Hoy voy a revisar tus rebaños y pondré aparte todos los corderos negros, y también todos los cabritos manchados y rayados, y éste será mi salario."
,"33":"Comprobarás mi honradez el día de mañana cuando quieras verificar personalmente lo que me llevo. Todo lo que no sea manchado o rayado entre las cabras, ni negro entre los corderos, será considerado como un robo de mi parte.'"
,"34":"Dijo Labán: 'Está bien, sea como tú dices.'"
,"35":"Ese mismo día Labán puso aparte todos los cabritos rayados o con manchas, y a cuanto cordero había con color negro, y se los dio a sus hijos,"
,"36":"y los mandó lejos de Jacob, a una distancia de tres días. Y Jacob se quedó cuidando el resto del rebaño de Labán."
,"37":"Jacob se buscó entonces unas ramas verdes de chopo, almendro y plátano. Peló la corteza de las ramas haciendo franjas que dejaban al descubierto el blanco de la madera."
,"38":"Después las colocó ante las pilas y abrevaderos, justo delante de esas que al beber entraban en celo."
,"39":"Y las que se apareaban frente a las varas parían después crías rayadas, moteadas y manchadas."
,"40":"Entonces Jacob separaba los corderos. En una palabra, hacía que las ovejas del rebaño de Labán miraran todo lo que tenía rayas o era negro. Así se formó rebaños que le pertenecían y que apartaba de los de Labán."
,"41":"Cada vez que entraban en celo las ovejas más robustas, Jacob volvía a poner en las pilas y abrevaderos las varas, a la vista de las ovejas, para que se aparearan ante ellas."
,"42":"Pero si las ovejas eran débiles, no ponía las varas. Así las débiles quedaban para Labán, y las robustas eran para Jacob."
,"43":"Y el hombre se hizo muy rico, pues tenía grandes rebaños, muchos servidores y sirvientas, camellos y burros."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Supo Jacob lo que los hijos de Labán andaban diciendo: 'Jacob se ha apoderado de todo lo de nuestro padre, y con lo de nuestro padre ha hecho toda esa fortuna.'"
,"2":"Y se dio cuenta Jacob de que Labán no lo miraba en la misma forma que antes."
,"3":"Entonces Yavé dijo a Jacob: 'Regresa a tu patria, a la tierra de tus padres, pues yo estaré contigo.'"
,"4":"Jacob mandó a llamar a sus esposas Lía y Raquel, las que vinieron al campo, donde estaba el rebaño"
,"5":"y les dijo: 'Veo que el padre de ustedes no me mira con buenos ojos como antes, pero el Dios de mi padre ha estado conmigo."
,"6":"Ustedes saben muy bien que he servido a su padre con todas mis fuerzas,"
,"7":"y que él se ha burlado de mí, cambiándome diez veces mi salario. Pero Dios no le ha permitido que me perjudicara."
,"8":"Cuando él decía: 'Las crías manchadas serán para ti', todas las ovejas parían corderitos manchados. Y si decía: 'Las rayadas serán tu sueldo', todo el rebaño tenía corderitos rayados."
,"9":"De esta manera ha ido Dios quitándole el rebaño a su padre para dármelo a mí."
,"10":"Pues me ocurrió una vez, cuando era el tiempo en que entraban en celo las ovejas, que alcé los ojos y vi entre sueños que los machos que cubrían a las hembras eran rayados, manchados y de varios colores."
,"11":"Y el Angel de Dios me dijo en sueños: '¡Jacob!' Yo respondí: 'Aquí estoy.'"
,"12":"Y añadió: 'Fíjate bien cómo los machos que cubren a las hembras son rayados, manchados y moteados. Esto es así porque he visto todas las cosas que Labán ha hecho contigo."
,"13":"Yo soy el Dios de Betel, en donde derramaste aceite sobre una piedra y me hiciste un juramento. Ahora, levántate y vuélvete a la tierra en que naciste.'"
,"14":"Respondieron Raquel y Lía: '¿Acaso tenemos que ver algo todavía con la casa de nuestro padre, o somos aún sus herederas?"
,"15":"¿No hemos sido tratadas como extrañas después que nos vendió y se comió nuestra plata?"
,"16":"Pero Dios ha tomado las riquezas de nuestro padre y nos las ha dado a nosotras y a nuestros hijos. Haz, pues, todo lo que Dios te ha dicho.'"
,"17":"Se levantó Jacob e hizo montar en camellos a sus mujeres e hijos."
,"18":"Y se llevó todos sus rebaños y todos los bienes que había adquirido en Padán-Aram, volviendo donde su padre Isaac, a Canaán."
,"19":"Aprovechando que Labán había salido a esquilar su rebaño, Raquel robó los ídolos familiares que su padre tenía en casa."
,"20":"Jacob actuó a escondidas de Labán, y no le avisó nada sobre su partida."
,"21":"Tomó, pues, todo lo que poseía, y emprendió la huida. Atravesó el río Eufrates y se dirigió a las montañas de Galaad."
,"22":"Al tercer día avisaron a Labán de que Jacob había huido."
,"23":"Se hizo acompañar por los de su tribu y, durante siete días, lo persiguió, hasta que lo alcanzó en la montaña de Galaad."
,"24":"Pero Dios se acercó a Labán el arameo en un sueño, y le dijo: 'Cuídate de no discutir con Jacob, bien sea con amenazas o sin violencia.'"
,"25":"Labán alcanzó a Jacob. Como éste ya había levantado sus tiendas en el cerro de Mispa, Labán instaló las suyas en el de Galaad."
,"26":"Labán dijo a Jacob: '¿Qué me has hecho? Me has engañado, y te has llevado a mis hijas como si fueran prisioneras de guerra."
,"27":"¿Por qué has huido en secreto engañándome? ¿Por qué no me avisaste? Yo habría hecho una fiesta para despedirte, con canciones, tambores y guitarra."
,"28":"Ni siquiera me has dejado besar a mis hijos y a mis hijas. Te has portado como un tonto."
,"29":"Yo podría hacerte mal, pero el Dios de tu padre me dijo anoche: 'Cuídate de no discutir con Jacob, bien sea con amenazas o sin violencia.'"
,"30":"Pero si te has ido porque echabas de menos a la casa de tu padre, ¿por qué me has robado mis dioses?'"
,"31":"Respondió Jacob a Labán: 'Yo tuve miedo a que me quitaras tus hijas."
,"32":"Pero eso sí, al que descubras que tiene en su poder tus dioses, ése morirá. En presencia de nuestros hermanos, revisa todo lo que yo tengo, y si reconoces algo tuyo, llévatelo.' Pero Jacob ignoraba que Raquel había robado los ídolos."
,"33":"Entró Labán en la tienda de Jacob, después en la de Lía y en las de las dos criadas, pero no encontró nada. A continuación, entró en la tienda de Raquel,"
,"34":"pero Raquel había tomado los ídolos familiares y colocándolos debajo de la montura del camello se sentó encima mientras Labán registraba toda su tienda y no encontraba nada."
,"35":"Entonces ella, dirigiéndose a su padre le dijo: 'Perdone, mi señor, si no me pongo de pie ante su presencia, pero me sucede lo que le pasa a las mujeres.' Registró, pues, y no encontró los ídolos."
,"36":"Entonces Jacob se enojó y reprochó a Labán: '¿Cuál es mi delito? ¿Cuál ha sido mi pecado, para que así me persigas?"
,"37":"Después de revisar todas mis cosas, ¿qué objeto de tu casa has encontrado? Colócalo aquí, a la vista de tu familia y de la mía, y que ellos sean jueces entre nosotros dos."
,"38":"En veinte años que llevo contigo, tus ovejas y tus cabras no han malparido, y nunca he comido ni un cordero de tus rebaños."
,"39":"Los animales destrozados por las fieras, no te los traía, sino que yo mismo los reemplazaba, y tú me exigías lo que había sido robado de noche o de día."
,"40":"Pero tenía que soportar el calor durante el día y el frío durante la noche, a veces sin poder dormir una pestañada."
,"41":"Ya llevo veinte años en tu casa. Catorce te serví por tus dos hijas y seis por tus rebaños, y tú has cambiado mi salario diez veces."
,"42":"Si el Dios de mi padre, el Dios de Abrahán y Dios Terrible de Isaac, no me hubiera asistido, con toda seguridad que tú me habrías despedido con las manos vacías. Pero Dios ha visto mis pruebas y el trabajo de mis manos y por eso anoche pronunció su sentencia.'"
,"43":"Respondió Labán a Jacob: 'Estas hijas son mis hijas y estos hijos son mis hijos, el ganado también es mío y todo cuanto ves es mío. ¿Cómo podría yo querer mal a mis hijas y a sus hijos?"
,"44":"Ven, hagamos un pacto entre los dos, y que quede una prueba de ello.'"
,"45":"Jacob tomó una piedra y la puso de pie. Y dijo a los de su familia: 'Recojan piedras.'"
,"46":"Todos se pusieron a juntar piedras, hicieron con ellas un montón, y luego comieron sobre él."
,"47":"Labán lo llamó Yegar-Saaduta, pero Jacob lo llamó Galed."
,"48":"Labán dijo: 'Este montón de piedras va a quedar aquí como una prueba del acuerdo entre tú y yo.'"
,"49":"Por esto se llamó Galed, y también Mispá, porque dijo: 'Que Yavé se fije en nosotros cuando nos hayamos separado."
,"50":"Si tratas mal a mis hijas o si tomas otras mujeres fuera de ellas, no serán los hombres los que te juzguen, sino Dios que es testigo de nuestro pacto.'"
,"51":"Labán añadió dirigiéndose a Jacob: 'Mira este montón y esta piedra que he levantado entre nosotros dos:"
,"52":"ellos serán testigos de que yo no pasaré más allá hacia ti para hacerte daño, ni tú pasarás más acá hacia mí para causarme mal."
,"53":"El Dios de Abrahán, y el Dios de Najor sea juez entre nosotros.'"
,"54":"Entonces Jacob juró por el Dios Terrible de su padre Isaac. Jacob ofreció un sacrificio en el monte y convidó a comer a todos sus hermanos. Comieron y pasaron la noche en el monte."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Labán se levantó muy temprano, besó a sus hijos y a sus hijas, los bendijo y se fue. Así volvió Labán a su lugar."
,"2":"Jacob, por su parte, siguió su camino y le salieron al encuentro Angeles de Dios."
,"3":"Al verlos dijo Jacob: 'Este es un campamento de Dios', y por eso llamó a aquel lugar Majanaim."
,"4":"Jacob mandó a avisar de su llegada a su hermano Esaú, en Seír, en los campos de Edom;"
,"5":"los mensajeros recibieron las instrucciones siguientes: 'Digan a mi señor, a Esaú, de parte de su servidor Jacob: He vivido con Labán y con él he permanecido hasta hoy."
,"6":"He adquirido bueyes, burros, rebaños, mozos y sirvientas. Y ahora quiero avisarte, esperando que me recibirás bien.'"
,"7":"Volvieron los mensajeros y dijeron a Jacob: 'Hemos estado con tu hermano Esaú, y él mismo viene ahora a tu encuentro con cuatrocientos hombres.'"
,"8":"Jacob se llenó de miedo y se desesperó. Dividió en dos campamentos a la gente que estaba con él, y lo mismo hizo con el ganado, las ovejas y los camellos,"
,"9":"pues pensaba: 'Si Esaú ataca a un campamento, el otro podrá salvarse.'"
,"10":"Luego oró así: 'Yavé, Dios de mi padre Abrahán y Dios de mi padre Isaac, tú me dijiste: Vuelve a tu patria, a la tierra de tus padres que yo seré bueno contigo."
,"11":"Yo no soy digno de todos los favores que me has hecho, ni de la gran bondad que has tenido conmigo. Porque al partir, cuando atravesé el Jordán, no tenía más que mi bastón. Pero ahora, al volver, tengo suficiente como para hacer dos campamentos."
,"12":"Líbrame de las manos de mi hermano, de las manos de Esaú; no sea que que venga y mate a todos, a la madre con sus hijos."
,"13":"Pero eres tú quien me dijo: Te colmaré de bienes y tu descendencia será como la arena del mar, que nadie puede contar.'"
,"14":"Y pasó allí aquella noche. Echó mano a lo que traía consigo para enviar un regalo a su hermano Esaú: "
,"15":"doscientas cabras y veinte machos cabríos, doscientas ovejas y veinte carneros,"
,"16":"treinta camellas paridas con sus crías, cuarenta vacas y diez toros, veinte mulas y diez burros."
,"17":"Luego los dividió en varios grupos y confió cada uno de ellos a un servidor, con esta orden: 'Vayan delante de mí, y mantengan cierta distancia entre un grupo y otro.'"
,"18":"Al del primer grupo le recomendó: 'Cuando te encuentre mi hermano Esaú y te pregunte quién eres, a dónde vas, y de quién es el rebaño que vas guiando,"
,"19":"le contestarás: 'Todo pertenece a tu siervo Jacob, y todo es un regalo que él envía a mi señor Esaú. El mismo viene detrás de nosotros.'"
,"20":"Jacob dio las mismas instrucciones al segundo, al tercero y a todos los demás que guiaban los rebaños. Y les dijo:"
,"21":"'Así han de hablar a Esaú cuando lo encuentren.' Y también le dirán: 'Tu siervo Jacob ya viene detrás de nosotros.',Pues Jacob pensaba: 'Lo aplacaré con los regalos que le envío delante, y cuando después me encuentre frente a él, quizá me reciba sin enojo.' "
,"22":"Envió, pues, los regalos por delante, y él se quedó aquella noche en el campamento."
,"23":"Aquella misma noche Jacob se levantó, tomó a sus dos esposas, a sus dos sirvientas y a sus once hijos, y los hizo cruzar el vado de Yaboc."
,"24":"A todos los hizo pasar al otro lado del torrente, y también hizo pasar todo lo que traía con él."
,"25":"Y Jacob se quedó solo. Entonces alguien luchó con él hasta el amanecer."
,"26":"Este, viendo que no lo podía vencer, tocó a Jacob en la ingle, y se dislocó la cadera de Jacob mientras luchaba con él."
,"27":"El otro le dijo: 'Déjame ir, pues ya está amaneciendo.' Y él le contestó: 'No te dejaré marchar hasta que no me des tu bendición.'"
,"28":"El otro, pues, le preguntó: '¿Cómo te llamas?' El respondió: 'Jacob.'"
,"29":"Y el otro le dijo: 'En adelante ya no te llamarás Jacob, sino Israel, o sea Fuerza de Dios, porque has luchado con Dios y con los hombres y has salido vencedor.'"
,"30":"Entonces Jacob le hizo la pregunta: 'Dame a conocer tu nombre' Él le contestó: '¿Mi nombre? ¿Para qué esta pregunta?' Y allí mismo lo bendijo."
,"31":"Jacob llamó a aquel lugar Panuel, o sea Cara de Dios, pues dijo: 'He visto a Dios cara a cara y aún estoy vivo.'"
,"32":"El sol empezaba a dar fuerte cuando cruzó Penuel, y él iba cojeando a causa de su cadera."
,"33":"Por esta razón los hijos de Israel no comen, hasta el día de hoy, el nervio del muslo, porque tocó a Jacob en la ingle, sobre el nervio del muslo."
}`)
	CurrentBook.AddChapter(33, `{
"1":"En cierto momento, Jacob vio algo: era Esaú que se acercaba con los cuatrocientos hombres. Distribuyó entonces a los hijos entre Lía, Raquel y las dos siervas."
,"2":"Situó a las dos siervas con sus hijos por delante; detrás colocó a Lía con sus hijos, después a Raquel y a José."
,"3":"El mismo pasó delante de todos, y se inclinó siete veces hasta el suelo antes de alcanzar a su hermano."
,"4":"Esaú corrió al encuentro de su hermano y lo abrazó; echándose sobre su cuello lo besó, y los dos rompieron a llorar."
,"5":"Levantó después la vista, y al ver a las mujeres y a sus hijos preguntó: '¿Qué tienen que ver todos estos contigo?' Jacob le respondió: 'Son los hijos que Dios ha dado a tu siervo.'"
,"6":"Entonces se acercaron las siervas de Jacob con sus hijos, e hicieron profunda reverencia;"
,"7":"se acercó también Lía con sus hijos, y se postraron; por último se acercaron José y Raquel y se postraron."
,"8":"Le preguntó Esaú: '¿Qué significan todos aquellos grupos con los que me he encontrado?' Respondió Jacob: 'Esos eran para ganarme tu favor.'"
,"9":"Le dijo Esaú: 'Hermano, yo tengo de todo, guarda lo que es tuyo.'"
,"10":"Pero Jacob contestó: 'No, por favor. Si realmente me quieres, acepta el regalo que te ofrezco, pues me he presentado ante ti como ante Dios, y tú me has acogido."
,"11":"Acepta, pues, el regalo que te he traído, ya que Dios me ha favorecido, y tengo de todo.' Jacob insistió tanto, que Esaú aceptó."
,"12":"'Vamos -dijo después Esaú-, pongámonos en marcha, que yo iré delante de ti.'"
,"13":"Jacob le dijo: 'Mi señor sabe bien que los niños son delicados, y tengo ovejas y vacas paridas, que si las hago andar muy apuradas, en un solo día todo el ganado menor morirá."
,"14":"Vaya mi señor delante de su siervo, y yo caminaré con calma al paso del ganado que viene detrás de mí y al paso de los niños, hasta que nos encontremos en Seír.'"
,"15":"Respondió Esaú: 'Por lo menos acepta que se queden contigo algunos de los hombres que me acompañan.'. Jacob replicó: 'No es necesario si tengo paz contigo.'"
,"16":"Aquel mismo día regresó Esaú a Seír,"
,"17":"y Jacob se dirigió a Sucot, donde se construyó una casa e hizo chozas para sus rebaños; a esto se debió que aquel lugar fuese llamado Sucot (o sea, chozas)."
,"18":"Regresando de Padán-Aram, Jacob llegó sano y salvo a la ciudad de Siquem, en el país de Canaán, y acampó frente a la ciudad."
,"19":"Compró por cien monedas de plata a los hijos de Hamor, que era padre de Siquem, el pedazo de tierra en que había instalado sus tiendas."
,"20":"Allí construyó un altar, llamando a este lugar: 'El, el Dios de Israel.'"
}`)
	CurrentBook.AddChapter(34, `{
"1":"Dina, la hija que Lía dio a Jacob, salió un día a visitar a las mujeres de aquel país."
,"2":"La vio Siquem, hijo de Hamor el jeveo, príncipe de aquella tierra, y la tomó; se acostó con ella y la violó."
,"3":"Pero se quedó prendado de Dina, hija de Jacob, se enamoró de la joven y le habló de amor."
,"4":"Entonces Siquem dijo a su padre Hamor: 'Toma para mí a esa joven.'"
,"5":"Jacob se enteró de que su hija Dina había sido deshonrada, pero como sus hijos estaban en el campo con su rebaño, no dijo nada hasta que regresaron."
,"6":"Hamor, padre de Siquem, vino a hablar con Jacob."
,"7":"Cuando los hijos de Jacob volvieron del campo, se enteraron de lo que había pasado. Estos hombres se enojaron muchísimo porque se había cometido una infamia en Israel; alguien había abusado de la hija de Jacob, cosa que no debe hacerse."
,"8":"Hamor habló con ellos y les dijo: 'Siquem, mi hijo, está enamorado de la hermana de ustedes. Les ruego que se la den por esposa."
,"9":"Sean nuestros parientes, dennos sus hijas, y tomen las nuestras."
,"10":"Quédense a vivir con nosotros, pues todo el territorio está a disposición de ustedes; habiten en él, muévanse libremente y adquieran propiedades en él.'"
,"11":"Siquem dijo al padre y a los hermanos de Dina: 'Les ruego que me perdonen. Yo les daré todo lo que ustedes me pidan."
,"12":"Impónganme un precio y regalos de valor, y yo les pagaré lo que quieran, pero denme a la muchacha por esposa.'"
,"13":"Los hijos de Jacob respondieron a Siquem y a su padre Hamor. Les hablaron con engaño, porque Siquem había deshonrado a Dina, su hermana, y les dijeron:"
,"14":"'No podemos dar nuestra hermana a un hombre incircunciso, pues entre nosotros eso es una vergüenza."
,"15":"Daremos nuestro consentimiento con una sola condición: que se hagan iguales a nosotros, y circunciden a todos los varones que hay entre ustedes."
,"16":"Entonces daremos a nuestras hijas y tomaremos las de ustedes, viviremos con ustedes y con ustedes formaremos un solo pueblo."
,"17":"Pero si no nos hacen caso y no se circuncidan, tomaremos a nuestra hermana y nos iremos.'"
,"18":"Estas palabras agradaron a Hamor y Siquem, su hijo."
,"19":"El joven no tardó en hacer lo que se le pedía, porque estaba enamorado de la hija de Jacob; además, Siquem era el de más prestigio e influencia en la familia de su padre."
,"20":"Hamor y su hijo Siquem fueron a la puerta de su ciudad y hablaron a sus conciudadanos, reunidos allí."
,"21":"Les dijeron: 'Estos hombres son gente pacífica. Dejemos que se establezcan aquí y se muevan libremente por nuestra tierra. Nuestro país es extenso, y hay mucho lugar para ellos. Nosotros nos casaremos con sus hijas y les daremos las nuestras como esposas a ellos,"
,"22":"pero ellos ponen una condición para quedarse con nosotros y formar un solo pueblo, y es que todos los varones nos hagamos circuncidar, tal como lo hacen ellos."
,"23":"Si aceptamos, sus rebaños, sus posesiones, sus animales y todo lo que tienen, será de nosotros. Hagamos, pues, lo que nos piden y que vivan entre nosotros.'"
,"24":"Todos los que salían por la puerta de la ciudad se dejaron convencer por Hamor y su hijo Siquem, y todos los varones de la ciudad se hicieron circuncidar."
,"25":"Al tercer día, cuando estaban más doloridos, dos hijos de Jacob, Simeón y Leví, hermanos de Dina, agarraron sus espadas, entraron en la ciudad sin peligro y mataron a todos los varones."
,"26":"Mataron a Hamor y a su hijo Siquem, y tomando a Dina de la casa de Siquem, se fueron."
,"27":"Los demás hijos de Jacob pasaron sobre los muertos y saquearon la ciudad."
,"28":"Se apoderaron de sus vacas, ovejas, burros y de todo lo que había en la ciudad o en el campo."
,"29":"Se llevaron como botín todas las riquezas, a las mujeres y a los niños, y saquearon todo lo que encontraron dentro de las casas."
,"30":"Dijo entonces Jacob a Simeón y a Leví: 'Me han dejado en mala situación, y por culpa de ustedes me odiarán los cananeos y los fereceos que ocupan el país. Yo sólo tengo unos pocos hombres, y si ellos se unen para atacarme, me exterminarán junto con toda mi gente.'"
,"31":"Pero ellos respondieron: '¿Ibamos a dejar que nuestra hermana fuera tratada como una prostituta?'"
}`)
	CurrentBook.AddChapter(35, `{
"1":"Dios dijo a Jacob: 'Ponte en camino, sube a Betel. Allí te establecerás y levantarás un altar al Dios que se te apareció cuando ibas huyendo de tu hermano Esaú.'"
,"2":"Llamó Jacob a toda su familia y a los que estaban con él y les ordenó: 'Arrojen lejos a los dioses extranjeros que tienen con ustedes. Purifíquense y cámbiense la ropa."
,"3":"Después subiremos a Betel. Allí edificaré un altar al Dios que me oyó el día de mi angustia y que me acompañó durante mi viaje.'"
,"4":"Entregaron a Jacob todos los dioses extraños que tenían consigo, así como los aros de las orejas, y Jacob los enterró bajo una encina que hay junto a Siquem;"
,"5":"luego levantaron el campamento. Un miedo sobrenatural se apoderó de los habitantes de las ciudades vecinas, de tal manera que nadie se atrevió a perseguirlos."
,"6":"Jacob llegó con toda su gente a Luz, que está en territorio cananeo y que ahora se llama Betel;"
,"7":"levantó allí un altar y llamó al lugar 'El-Betel', porque allí fue donde se le había aparecido Dios, cuando iba huyendo de su hermano."
,"8":"Por ese mismo entonces murió Débora, la nodriza de Rebeca, y fue sepultada cerca de Betel, bajo la encina que después se llamó Bacut (o sea, Llanto)."
,"9":"Dios se apareció de nuevo a Jacob cuando regresaba de Padán-Aram y lo bendijo,"
,"10":"diciendo: 'Tu nombre es Jacob, pero desde ahora no te llamarás más Jacob, sino que tu nombre será Israel.' Así, pues, le puso por nombre Israel."
,"11":"Y agregó: 'Yo soy el Dios de las Alturas; sé fecundo y multiplícate. Una nación, o mejor, un grupo de naciones nacerá de ti, y reyes saldrán de tu linaje."
,"12":"Te daré la tierra que di a Abraham e Isaac, y la daré a tus descendientes después de ti.'"
,"13":"Después Dios se alejó."
,"14":"Jacob puso de pie una piedra como monumento, en el lugar en que había hablado con Dios, y derramó sobre ella vino y aceite."
,"15":"Jacob llamó Betel al lugar en que había hablado con Dios."
,"16":"Partieron de Betel, y faltando ya poco para llegar a Efratá, Raquel dio a luz. Tuvo un parto muy difícil,"
,"17":"y cuando sus dolores eran más intensos, la partera le dijo: 'Animo, que éste es también un hijo.'"
,"18":"Y dando el último suspiro, pues se estaba muriendo, lo llamó Ben-Oní (o sea, hijo de mi dolor), pero su padre le dio el nombre de Benjamín."
,"19":"Así es como murió Raquel y fue sepultada en el camino de Efratá (que es Belén)."
,"20":"Jacob puso una piedra de pie sobre su tumba, es la Piedra de la Tumba de Raquel que se ve hoy todavía."
,"21":"Partió después Israel y levantó sus tiendas más allá de Migdal-Eder."
,"22":"Mientras Israel moraba en aquella tierra, ocurrió que Rubén se acostó con Bilá, concubina de su padre, e Israel llegó a saberlo. Jacob tuvo doce hijos:"
,"23":"Hijos de Lía: Rubén, el primogénito de Jacob, Simeón, Leví, Judá, Isacar y Zabulón."
,"24":"Hijos de Raquel: José y Benjamín."
,"25":"Hijos de Bilá, la sirvienta de Raquel: Dan y Neftalí."
,"26":"Hijos de Zelfa, la sirvienta de Lía: Gad y Aser. Estos fueron los hijos de Jacob, que nacieron en Padán-Aram."
,"27":"Volvió Jacob a la casa de su padre Isaac, a Mambré, junto a Quiryat-Arbe (es decir, Hebrón), donde Abraham e Isaac habían vivido como forasteros."
,"28":"Isaac vivió ciento ochenta años;"
,"29":"murió muy anciano y fue a reunirse con sus antepasados. Lo sepultaron sus hijos Esaú y Jacob."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Estos fueron los descendientes de Esaú, o sea Edom. Esaú tomó por esposas a mujeres cananeas:"
,"2":"a Ada, hija de Helón el hitita, a Olibama, hija de Aná, hijo de Sebeón el jorita,"
,"3":"y a Basemat, hija de Ismael y hermana de Nébayot."
,"4":"Ada le dio a luz a Elifaz, Basemat fue madre de Rahuel,"
,"5":"y Olibama tuvo a Jehús, a Ihelón y a Coré. Estos son los hijos que le nacieron a Esaú en Canaán."
,"6":"Tomó después Esaú a sus esposas, a sus hijos e hijas, a todos los miembros de su familia, los rebaños, todos los animales y todos los bienes que había logrado en la tierra de Canaán, y se fue a la tierra de Seír, lejos de su hermano Jacob,"
,"7":"porque los dos eran muy ricos y no podían vivir juntos, ya que no cabían sus rebaños en la tierra que habitaban."
,"8":"Fue así que Esaú se ubicó en los montes de Seír. Esaú es Edom."
,"9":"Estos son los descendientes de Esaú, padre de los edomitas, que viven en la región montañosa de Seír. Y éstos son los nombres de los hijos de Esaú:"
,"10":"Elifaz, hijo de Ada, esposa de Esaú, y Rahuel, hijo de Basemat, mujer también de Esaú."
,"11":"Los hijos de Elifaz fueron: Timna, Omar, Sefo, Gatam y Cenez."
,"12":"Elifaz, hijo de Esaú, tenía también a Timna como concubina, y le dio a luz a Amalec. Estos son los descendientes de Ada, esposa de Esaú."
,"13":"Estos son los hijos de Rahuel: Najat, Zaraj, Samma y Meza. Estos son los descendientes de Basemat, esposa de Esaú."
,"14":"Y los hijos de Olibama, esposa de Esaú, hija de Aná, hijo de Sebeón, fueron éstos: Jehús, Ihelón y Coré."
,"15":"Estos son los jefes de los hijos de Esaú. De los hijos de Elifaz, primogénito de Esaú: el jefe Temán, el jefe Omar, el jefe Sefo, el jefe Cenez, "
,"16":"el jefe Coré, el jefe Gatam, el jefe Amalec. Estos son los jefes de Elifaz en la tierra de Edom. Estos son descendientes de Ada."
,"17":"Y éstos son los hijos de Rahuel, hijo de Esaú: Mahat, Zara, Samma, Meza. Estos son los jefes de Rahuel en la tierra de Edom, y son los descendientes de Basemat, esposa de Esaú."
,"18":"Los hijos de Olibama, esposa de Esaú, son: Jehús, Ihelón, Coré. Estos son los jefes de Olibama, hija de Aná, esposa de Esaú."
,"19":"Estos son los hijos de Esaú y éstos sus jefes. Esaú es Edom."
,"20":"Estos son los hijos de Seír, el jorita, que habitaban en aquella tierra: Lotán, Sebal, Sebeón, Aná,"
,"21":"Disón, Eser y Disán. Estos son los jefes de los joritas, hijos de Seír, en el país de Edom."
,"22":"Los hijos de Lotán fueron: Hori y Hemán. Tamna era hermana de este mismo Lotán."
,"23":"Los hijos de Sebal fueron: Alván y Manahat, Ebal, Sefe y Onam."
,"24":"Y los hijos de Sebeón: Aia y Aná. Este Aná es el que descubrió las aguas termales en el desierto, mientras andaba pastoreando los burros de su padre Sebeón."
,"25":"Estos son los hijos de Aná: Disón y Olibama, hija de Aná."
,"26":"Estos son los hijos de Disón: Hamdam, Esebán, Jetrán y Caram."
,"27":"Los hijos de Eser fueron: Balaán, Zaván y Acán."
,"28":"Y los hijos de Disán: Hus y Aram."
,"29":"Estos son los jefes joritas: el jefe Lotán, el jefe Sebal, el jefe Sibón, el jefe Aná, el jefe Disón, el jefe Eser, el jefe Disán."
,"30":"Estos son los jefes joritas, y éstas son sus tribus, en el país de Seír."
,"31":"Estos son los reyes que reinaron en Edom, antes de que hubiera reyes en Israel."
,"32":"En Edom reinó Bela, hijo de Beor, y el nombre de su ciudad era Dinaba."
,"33":"A la muerte de Bela reinó en su lugar Jobab, hijo de Zara, natural de Bosra."
,"34":"Jobab murió y reinó en su lugar Husam, de la tierra de los temanitas."
,"35":"Murió Husam y reinó en su lugar Hadad, hijo de Badad, el cual derrotó a Madián en los campos de Moab. El nombre de su ciudad era Avit."
,"36":"Murió Hadad y le sucedió en el reino Semla de Masreca."
,"37":"Murió Semla y reinó en su lugar Saúl, de Rejobot del río."
,"38":"A la muerte de Saúl subió al trono Balanán, hijo de Acober."
,"39":"Murió Balanán y ocupó el reino Adar, cuya ciudad se llamaba Fau, y su mujer, Metable, hija de Matred, hija de Mezaab."
,"40":"Estos son los nombres de los jefes de Esaú, y son los nombres de sus familias y territorios: el jefe Timna, el jefe Alva, el jefe Jefet,"
,"41":"el jefe Olibama, el jefe Eta, el jefe Finón,"
,"42":"el jefe Cenez, el jefe Temán, el jefe Mabaar,"
,"43":"el jefe Magdiel, el jefe Iram. Estos son los jefes de Edom, y éstos son los nombres de sus clanes y de las tierras que ocupan. Esaú es el padre de los edomitas."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Jacob, por su parte, se estableció en Canaán, país donde había vivido su padre."
,"2":"Esta es la historia de la familia de Jacob. A los diecisiete años, José se dedicaba a cuidar ovejas. Siendo todavía un adolescente, ayudaba a los hijos de Bilá y de Zelfa, mujeres de su padre y por lo tanto, informaba a su padre sobre la mala reputación que sus hermanos tenían."
,"3":"Israel quería a José más que a sus otros hijos, pues le había nacido en su ancianidad; incluso le había hecho una túnica con mangas."
,"4":"Sus hermanos, viendo que su padre le prefería a sus otros hijos, comenzaron a odiarlo hasta tal punto que no podían conversar con él."
,"5":"José tuvo un sueño y lo contó a sus hermanos."
,"6":"'Miren, les dijo, el sueño que he tenido."
,"7":"Estábamos nosotros atando gavillas en medio del campo, cuando sucedió que mi gavilla se levantaba y permanecía derecha. Entonces las gavillas de ustedes la rodearon y se postraron ante la mía.'"
,"8":"Sus hermanos le dijeron: '¿Eso quiere decir acaso que tú vas a reinar sobre nosotros, o que vas a mandarnos?' Y lo aborrrecieron más aún, a causa de sus sueños y de sus interpretaciones."
,"9":"Tuvo José todavía otro sueño, y también se lo contó a sus hermanos: 'Tuve otro sueño; esta vez el sol, la luna y once estrellas se inclinaban ante mí.'"
,"10":"Su padre, que también lo escuchaba, lo reprendió y le dijo: '¿Qué sueño es ese que has tenido? ¿Acaso yo, tu madre y tus hermanos tendremos que inclinarnos ante ti?'"
,"11":"Sus hermanos se pusieron envidiosos con él, mientras que su padre conservaba esto en la memoria."
,"12":"Sus hermanos habían ido a apacentar el rebaño de su padre a Siquem,"
,"13":"e Israel dijo a José: 'Tus hermanos están cuidando las ovejas en los pastos de Siquem; ven, que quiero mandarte donde ellos.' Contestó José: 'Aquí estoy.'"
,"14":"Su padre le dijo: 'Anda a ver cómo está el rebaño y cómo se encuentran tus hermanos, y ven después a contármelo.' Lo envió, pues, desde el valle de Hebrón, y José fue a Siquem."
,"15":"Un hombre lo vio que andaba perdido por los campos y le preguntó: '¿Qué buscas?'"
,"16":"Le respondió: 'Estoy buscando a mis hermanos. Dime, por favor, dónde están con sus rebaños.'"
,"17":"El hombre le contestó: 'Se han ido de aquí, pues les oí decir: Vámonos a Dotán.' Y José salió en busca de sus hermanos y los encontró en Dotán."
,"18":"Al verlo desde lejos, y antes de que llegara, se pusieron de acuerdo para matarlo."
,"19":"Se dijeron: 'Allí viene el soñador."
,"20":"Este es el momento: matémoslo y echémoslo en un pozo cualquiera, y diremos que algún animal feroz lo devoró. ¡Ahí vamos a ver en qué quedan sus sueños!'"
,"21":"Al oír esto, Rubén quiso salvarlo de sus manos y les dijo: 'No lo maten.'"
,"22":"'No derramen sangre, les dijo Rubén, échenlo más bien en aquella cisterna allá en el desierto, pero no pongan las manos sobre él.' Esto dijo para sacarlo de sus manos y devolverlo después a su padre."
,"23":"Fue así que cuando José llegó junto a ellos, le sacaron la túnica con mangas que llevaba puesta,"
,"24":"lo tomaron y lo arrojaron a una cisterna que estaba seca, sin agua."
,"25":"Se sentaron para comer, cuando alzando los ojos, vieron una caravana de ismaelitas que venía de Galaad, con sus camellos cargados de bálsamo, mirra y otras especias que llevaban a Egipto."
,"26":"Entonces Judá dijo a sus hermanos: '¿Qué ganamos con matar a nuestro hermano y tapar su sangre?"
,"27":"Mejor vendámoslo a esos ismaelitas y no pongamos nuestras manos sobre él, pues es nuestro hermano y carne nuestra.' Sus hermanos le hicieron caso,"
,"28":"y al pasar unos madianitas, que eran mercaderes, sacaron a José del pozo. Lo vendieron a los madianitas por veinte monedas de plata, y éstos llevaron a José a Egipto."
,"29":"Al regresar Rubén al pozo, ya no encontró a José. Rasgó sus vestidos"
,"30":"y volviendo donde estaban sus hermanos, les dijo: 'El muchacho ya no está. ¿Y qué hago ahora?'"
,"31":"Entonces tomaron la túnica de José y, degollando un cabrito, la tiñeron con su sangre."
,"32":"Enviaron la túnica de manga larga a su padre con este mensaje: 'Esto hemos encontrado. Mira a ver si es la túnica de tu hijo.'"
,"33":"Jacob la reconoció y exclamó: '¡Es la túnica de mi hijo. Algún animal feroz lo ha devorado! ¡José ha sido despedazado!'"
,"34":"Jacob desgarró sus vestidos, se vistió con un sayal, e hizo duelo por su hijo durante muchos días."
,"35":"Todos sus hijos e hijas acudieron a consolarlo, pero él no quería ser consolado, y decía: 'Estaré todavía de duelo cuando descienda donde mi hijo al lugar de las Sombras.' Y su padre lo lloró."
,"36":"Entretanto los madianitas llegaron a Egipto y vendieron a José a Putifar, funcionario del palacio de Faraón y capitán de la guardia."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Por aquel tiempo Judá se separó de sus hermanos y bajó donde un tal Jirá, que era de Adulam."
,"2":"Allí conoció a la hija de un cananeo llamado Sué, a la que tomó por esposa."
,"3":"Esta quedó embarazada y dio a luz un hijo al que llamó Er."
,"4":"Tuvo un segundo hijo, al que llamó Onán,"
,"5":"y, estando en Quézib dio a luz un tercer hijo al que puso el nombre de Sela."
,"6":"Judá tomó como esposa para su primogénito Er, a una mujer llamada Tamar."
,"7":"Er, primogénito de Judá, fue malo a los ojos de Yavé, y él le quitó la vida."
,"8":"Entonces Judá dijo a Onán: 'Cumple con tu deber de cuñado, y toma a la esposa de tu hermano para darle descendencia a tu hermano.'"
,"9":"Onán sabía que aquella descendencia no sería suya, y así, cuando tenía relaciones con su cuñada, derramaba en tierra el semen, para no darle un hijo a su hermano."
,"10":"Esto no le gustó a Yavé, y le quitó también la vida."
,"11":"Entonces Judá dijo a su nuera Tamar: 'Vuelve como viuda a la casa de tu padre, hasta que mi hijo Sela se haga mayor.' Porque Judá tenía miedo de que Sela muriera también, al igual que sus hermanos. Tamar se fue y se quedó en la casa de su padre."
,"12":"Bastante tiempo después, murió la esposa de Judá. Terminado el luto, Judá subió con su amigo Jirá de Adulam a Timna, donde estaban esquilando sus ovejas."
,"13":"Alguien informó a Tamar de que su suegro iba camino de Timna, para la esquila de su rebaño."
,"14":"Ella entonces se sacó sus ropas de viuda, se cubrió con un velo, y con el velo puesto fue a sentarse a la entrada de Enaín, que está en el camino a Timna, pues veía que Sela era ya mayor, y todavía no la había hecho su mujer."
,"15":"Al pasar Judá por dicho lugar, pensó que era una prostituta, pues tenía la cara tapada."
,"16":"Se acercó a ella y le dijo: 'Déjame que me acueste contigo'; pues no sabía que era su nuera. Ella le dijo: '¿Y qué me vas a dar para esto?'"
,"17":"El le dijo: 'Te enviaré un cabrito de mi rebaño.' Mas ella respondió: 'Bien, pero me vas a dejar algo en prenda hasta que lo envíes.'"
,"18":"Judá preguntó: '¿Qué prenda quieres que te dé?' Ella contestó: 'El sello que llevas colgado de tu cuello, con su cordón, y el bastón que llevas en la mano.' El se los dio y se acostó con ella, y la dejó embarazada."
,"19":"Ella después se marchó a su casa y, quitándose el velo, se puso sus ropas de viuda."
,"20":"Judá envió el cabrito por intermedio de su amigo de Adulam, con el fin de recobrar lo que había dejado a la mujer, pero no la encontró."
,"21":"Entonces preguntó a la gente del lugar: '¿Dónde está la prostituta que se sienta en Enaín, al borde del camino?' Le respondieron: 'Nunca ha habido prostituta alguna por allí.'"
,"22":"Volvió, pues, el hombre donde Judá y le dijo: 'No la he encontrado, e incluso las personas del lugar dicen que jamás ha habido prostituta por esos lados.'"
,"23":"Judá respondió: 'Que se quede no más con la prenda, con tal que la gente no se ría de nosotros. Después de todo, yo le mandé el cabrito y si tú no la has encontrado, yo no tengo la culpa.'"
,"24":"Como tres meses después, le contaron a Judá: 'Tu nuera Tamar se ha prostituido, y ahora está esperando un hijo.' Entonces dijo Judá: 'Llévenla afuera y que sea quemada viva.'"
,"25":"Pero cuando ya la llevaban, ella mandó a decir a su suegro: 'Me ha dejado embarazada el hombre a quien pertenecen estas cosas. Averigua, pues, quién es el dueño de este anillo, este cordón y este bastón.'"
,"26":"Judá reconoció que eran suyos y dijo: 'Soy yo el culpable, y no Tamar, porque no le he dado a mi hijo Sela.' Y no tuvo más relaciones con ella."
,"27":"Cuando le llegó el tiempo de dar a luz, resultó que tenía dos gemelos en su seno."
,"28":"Al dar a luz, uno de ellos sacó una mano y la partera la agarró y ató a ella un hilo rojo, diciendo: 'Este ha sido el primero en salir.'"
,"29":"Pero el niño retiró la mano y salió su hermano. '¡Cómo te has abierto brecha!', dijo la partera, y lo llamó Peres."
,"30":"Detrás salió el que tenía el hilo atado a la mano, y lo llamó Zeraj."
}`)
	CurrentBook.AddChapter(39, `{
"1":"José, pues, fue conducido a Egipto, y Putifar, funcionario del palacio de Faraón y capitán de la guardia, lo compró a los ismaelitas que lo habían traído."
,"2":"Yavé estuvo con José, y le fue bien en todo; y se quedó en casa del egipcio, su amo."
,"3":"El egipcio vio que Yavé estaba con José y hacía prosperar todo cuanto emprendía;"
,"4":"José le cayó en gracia a su amo, quien lo retuvo junto a él, lo hizo mayordomo de su casa y le confió todo cuanto tenía."
,"5":"Desde ese momento, Yavé bendijo la casa del egipcio, en consideración a José. Dio prosperidad tanto a la casa como al campo."
,"6":"En vista de esto, el egipcio dejó que José administrara todo cuanto poseía, y ya no se preocupó más que de su propia comida."
,"7":"José era muy varonil y de buena presencia. Algún tiempo después, la esposa de su amo puso sus ojos en él, y le dijo: 'Acuéstate conmigo.'"
,"8":"Pero José se negó y le dijo: 'Mi señor confía tanto en mí que no se preocupa para nada de lo que pasa en la casa, y ha puesto en mis manos todo lo que tiene."
,"9":"Aquí tengo tanto poder como él. Nada me ha prohibido, excepto a ti, porque eres su esposa. ¿Cómo, pues, voy a cometer un mal tan grande, y pecar contra Dios?'"
,"10":"Y aunque ella insistía día tras día, José se negó a acostarse a su lado y estar con ella."
,"11":"Cierto día, José entró en la casa para cumplir su oficio, y ninguno del personal de la casa estaba en ella."
,"12":"La mujer lo agarró de la ropa diciendo: 'Vamos, acuéstate conmigo.' Pero él, dejándole su ropa en la mano, salió afuera corriendo."
,"13":"Ella vio que José había huído, pero que ella tenía en manos su ropa;"
,"14":"llamó, pues, a sus sirvientes y les dijo: 'Miren, han traído aquí a un hebreo para que se burle de nosotros. Ha querido aprovecharse de mí, pero yo me he puesto a gritar,"
,"15":"y al sentir que yo levantaba la voz y gritaba, salió huyendo y dejó su ropa en mis manos.'"
,"16":"La mujer depositó la ropa a su lado, hasta que el patrón de José llegó a casa,"
,"17":"y le repitió las mismas palabras: 'Ese esclavo hebreo que tú nos has traído, se me acercó para abusar de mí."
,"18":"Cuando grité pidiendo auxilio, él salió huyendo y dejó su ropa en mis manos.'"
,"19":"Cuando el patrón oyó lo que le decía su esposa: 'Mira lo que me ha hecho tu esclavo', se puso furioso."
,"20":"Tomó preso a José y lo metió en la cárcel donde estaban encarcelados los prisioneros del rey. Y José quedó encarcelado."
,"21":"Pero Yavé lo asistió y fue muy bueno con él; hizo que cayera en gracia al jefe de la prisión."
,"22":"Este le confió el cuidado de todos los que estaban en la prisión, y todo lo que se hacía en la prisión, José lo dirigía."
,"23":"El jefe de la cárcel no controlaba absolutamente nada de cuanto administraba José, pues decía: 'Yavé está con él y hace que le vaya bien en todo.'"
}`)
	CurrentBook.AddChapter(40, `{
"1":"Sucedió tiempo después, que dos funcionarios, el que preparaba las bebidas para el rey de Egipto, y el panadero principal, cometieron algunas faltas contra su señor el rey de Egipto."
,"2":"Faraón se enojó contra el que le preparaba las bebidas y contra su panadero,"
,"3":"y los entregó en custodia al capitán de la guardia en la misma cárcel en que estaba José."
,"4":"El capitán de la guardia encargó a José que los atendiera y quedaron algún tiempo arrestados."
,"5":"Una noche, tanto el que preparaba las bebidas, como el panadero principal del rey de Egipto, tuvieron ambos un sueño en la prisión, y cada sueño requería una interpretación."
,"6":"Cuando José los vino a ver por la mañana, se dio cuenta de que estaban muy preocupados."
,"7":"Preguntó entonces a esos oficiales de Faraón que estaban con él en la prisión: '¿Por qué amanecieron con tan mala cara?'"
,"8":"Y le contestaron: 'Los dos hemos tenido un sueño y nos falta quien lo interprete.' José les dijo: '¿No es Dios quien da el interpretar los sueños? Vamos, cuéntenme lo que soñaron.'"
,"9":"El que preparaba la bebida del rey contó primero su sueño a José así: 'En mi sueño había frente a mí una parra,"
,"10":"y en la parra tres sarmientos. Apenas brotó, apareció la flor y maduraron los granos en los racimos."
,"11":"Yo tenía en la mano la copa de Faraón, y tomando aquellas uvas las exprimía en la copa de Faraón, y ponía la copa en sus manos.'"
,"12":"José le dijo: 'Esto es lo que quiere decir tu sueño. Los tres sarmientos significan tres días."
,"13":"Dentro de tres días Faraón te pondrá la cabeza en alto, pues te restablecerá en tu oficio, y volverás a colocar la copa en manos de Faraón, como lo hacías antes, cuando eras jefe de los que preparaban su bebida."
,"14":"Acuérdate, pues, de mí cuando recuperes tu puesto, y habla en mi favor a Faraón, para que me mande sacar de esta cárcel."
,"15":"Pues contra mi voluntad fui raptado del país de los hebreos, y tampoco aquí he hecho nada por lo que merezca estar en prisión.'"
,"16":"Al ver el jefe de los panaderos que José había dado una interpretación favorable, le dijo: 'Voy a contar ahora mi sueño: Había tres canastos de pan blanco sobre mi cabeza."
,"17":"En el canasto de arriba había toda clase de pasteles de los que come Faraón, pero los pájaros se lo comían del canasto que estaba sobre mi cabeza.'"
,"18":"Respondió José: 'Este es el significado. Los tres canastos son tres días."
,"19":"Pasados tres días, Faraón te pondrá la cabeza en alto, pues te colgará de un árbol y las aves vendrán a comer tu carne.'"
,"20":"Al tercer día era el cumpleaños de Faraón, y dio un banquete a todos sus servidores. Y cuando estuvo con ellos, se acordó del jefe de los que preparaban las bebidas y del jefe de los panaderos."
,"21":"Repuso en su puesto al que preparaba las bebidas, quien de nuevo puso la copa en las manos de Faraón,"
,"22":"mientras al jefe de los panaderos lo hizo colgar, tal como José lo había interpretado."
,"23":"El que preparaba las bebidas no se volvió a acordar de José: sencillamente lo había olvidado."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Dos años después Faraón tuvo este sueño: Estaba él a orillas del Nilo,"
,"2":"cuando vio que salían del río siete vacas hermosas y muy gordas, que se pusieron a pastar entre los juncos."
,"3":"Detrás de ellas salieron otras siete vacas feas y flacas que se pusieron al lado de las primeras a la orilla del río."
,"4":"Pero las siete vacas feas y flacas se comieron a las siete vacas gordas y hermosas. Entonces Faraón se despertó."
,"5":"Se quedó de nuevo dormido, y tuvo otro sueño: Vio siete espigas granadas y buenas que salían de un mismo tallo."
,"6":"Después de éstas brotaron otras siete espigas pequeñas y quemadas por el viento,"
,"7":"y estas espigas pequeñas y quemadas por el viento se tragaron a las siete granadas y repletas. Se despertó Faraón, y se dio cuenta que era un sueño."
,"8":"Aquella mañana Faraón se levantó muy preocupado, y mandó llamar a todos los adivinos y sabios de Egipto. Les contó sus sueños, pero ninguno fue capaz de interpretarlos."
,"9":"Entonces el jefe de los que preparan las bebidas pidió la palabra y dijo a Faraón: 'Me estoy acordando de una falta mía."
,"10":"Faraón se había enojado contra sus siervos, y me dejó detenido en la casa del capitán de la guardia, junto con el panadero del palacio."
,"11":"El y yo tuvimos sendos sueños en la misma noche, y que requerían una interpretación."
,"12":"Con nosotros estaba un joven hebreo, un servidor del capitán de la guardia. Le contamos nuestros sueños y él los interpretó, a cada uno le dio la interpretación."
,"13":"Y todo sucedió tal como él lo había dicho: yo fui repuesto en mi cargo y el jefe de los panaderos ahorcado.'"
,"14":"Faraón entonces mandó traer a José. Fue sacado rápidamente de la cárcel, lo afeitaron y cambiaron de ropa, y lo presentaron a Faraón."
,"15":"Dijo Faraón a José: 'He tenido un sueño, y nadie ha sido capaz de explicarlo, pero he oído decir que a ti te basta con que te cuenten un sueño para que tú lo interpretes.'"
,"16":"José respondió: 'No soy yo, sino Dios quien te dará una respuesta favorable.'"
,"17":"Y Faraón contó su sueño a José: 'Estaba yo parado a la orilla del río, "
,"18":"cuando de pronto subieron del río siete vacas hermosas y muy gordas que se pusieron a pastar entre los juncos."
,"19":"Pero detrás de ellas subieron otras siete vacas tan flacas y feas como no había visto nunca en todo Egipto."
,"20":"Y las siete vacas flacas y feas se comieron a las siete vacas gordas."
,"21":"Pero una vez que las tuvieron en su vientre, no se notaba en absoluto, pues seguían tan flacas y feas como antes. Entonces me desperté."
,"22":"Vi también en mi sueño siete espigas llenas y granadas que salían de un solo tallo."
,"23":"Pero brotaron detrás de ellas siete espigas pequeñas, vacías y quemadas por el viento."
,"24":"Las espigas vacías se tragaron a las espigas hermosas. Se lo he contado a los adivinos, pero ninguno de ellos me lo ha podido explicar.'"
,"25":"José dijo a Faraón: 'El sueño de Faraón es uno solo: Dios ha anunciado a Faraón lo que El va a hacer."
,"26":"Las siete vacas hermosas, al igual que las siete espigas granadas, son siete años de abundancia."
,"27":"Las siete vacas feas y raquíticas que salieron detrás, al igual que las siete espigas vacías y quemadas por el viento del este, son siete años de hambre."
,"28":"Como dije a Faraón, Dios le está manifestando lo que está para suceder."
,"29":"Vendrán siete años de gran abundancia en todo Egipto,"
,"30":"pero en seguida vendrán siete años de escasez que harán olvidar toda la abundancia anterior, y el país quedará extenuado por el hambre."
,"31":"Tan terrible será la escasez que sobrevendrá, que ya nadie volverá a recordar los tiempos de abundancia."
,"32":"Si el sueño se te presentó dos veces, esto quiere decir que Dios está muy decidido a realizar estas cosas y que pronto las realizará."
,"33":"Ahora, pues, aconsejo a Faraón que busque un hombre inteligente y sabio para ponerlo al frente de Egipto."
,"34":"Que Faraón nombre, además, intendentes en todo el país, para que recauden la quinta parte de la cosecha durante estos siete años de abundancia."
,"35":"Recogerán todos los víveres de estos siete años de abundancia, y almacenarán el grano en las ciudades, donde los guardarán bajo la autoridad de Faraón."
,"36":"De esta manera habrá reservas en el país para los siete años de escasez que van a afectar a Egipto, y el pueblo no morirá de hambre.'"
,"37":"La propuesta de José agradó a Faraón y a sus servidores, y dijo Faraón a sus oficiales:"
,"38":"'¿Se podrá encontrar otro hombre como éste, que tenga el espíritu de Dios?'"
,"39":"Y dijo a José: 'Puesto que Dios te ha hecho saber todo esto, no hay hombre más inteligente ni sabio que tú."
,"40":"Tú estarás al frente de toda mi casa, y todo mi pueblo obedecerá tus órdenes. Solamente yo estaré por encima de ti.'"
,"41":"Faraón dijo a José: 'Mira, te he puesto al frente de todo el país de Egipto.'"
,"42":"Y quitándose el anillo de su dedo, lo puso en el dedo de José; lo hizo vestir con ropas de lino fino y le puso un collar de oro en el cuello."
,"43":"Luego lo hizo subir a la segunda carroza del palacio e iban gritando delante de él: '¡Abran camino!' Así quedó José al frente de todo el país de Egipto."
,"44":"Dijo Faraón a José: '¡Yo soy Faraón! Sin tu consentimiento, nadie moverá mano o pie en Egipto.'"
,"45":"Faraón llamó a José Safnat-Paneaj y le dio por esposa a Asenat, hija de Poti Fera, sacerdote del dios On. Después de esto José salió a recorrer todo el país de Egipto."
,"46":"José tenía treinta años cuando se presentó ante Faraón, rey de Egipto. Se retiró de su presencia y empezó a recorrer todo el país de Egipto."
,"47":"Durante los siete años de abundancia hubo grandes cosechas."
,"48":"José juntó todos los víveres producidos en estos años de abundancia e hizo reservas en las ciudades; en cada ciudad almacenó los productos del campo de sus alrededores."
,"49":"Y así José juntó una cantidad de trigo tan enorme como la arena del mar, hasta tal punto que perdieron la cuenta, pues sobrepasaba todo cálculo."
,"50":"Antes de que llegaran los años de hambre, José tuvo dos hijos de su esposa Asenat, hija de Poti Fera, sacerdote del dios On."
,"51":"Al primero lo llamó Manasés (que significa: 'He olvidado'), pues se dijo: 'Dios me ha hecho olvidar mi pena y a la familia de mi padre.'"
,"52":"Al segundo lo llamó Efraím (que significa: 'He fructificado'), pues se dijo: 'Dios me ha hecho fecundo en el país de mi aflicción.'"
,"53":"Pasados los siete años de abundancia en Egipto,"
,"54":"llegaron los siete años de escasez, tal como José había anunciado. Hubo hambre en todos los países, pero en todo Egipto había pan."
,"55":"Cuando en Egipto se sintió el hambre, el pueblo pidió pan a gritos, y Faraón decía a todos los egipcios: 'Vayan a José y hagan lo que él les diga.'"
,"56":"Había escasez por todo el país, pero José abrió los almacenes y vendió trigo a los egipcios. Una gran hambruna asolaba todo el mundo."
,"57":"Como el hambre se hacía sentir más y más en todos los países, de todas partes venían a Egipto a comprar trigo a José."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Al saber Jacob que había trigo en Egipto, dijo a sus hijos: '¿Por qué se están ahí mirando el uno al otro?"
,"2":"He oído que se vende trigo en Egipto. Vayan también ustedes allá y compren trigo para nosotros, 'pues es cosa de vida o de muerte'.'"
,"3":"Los hermanos de José -diez de ellos-, bajaron entonces a Egipto para comprar trigo;"
,"4":"Jacob no dejó ir con ellos a Benjamín, hermano de José, pues pensaba: 'No sea que le vaya a pasar algo.'"
,"5":"Se fueron los hijos de Israel a comprar trigo junto con la otra gente, pues arreciaba el hambre en Canaán."
,"6":"Siendo José el gobernador del país, vendía el trigo a toda la gente. Al llegar sus hermanos, se postraron ante él hasta tocar el suelo con la cara."
,"7":"José reconoció a sus hermanos, pero no se lo dio a entender, sino que más bien los trató duramente. Les preguntó: '¿De dónde vienen ustedes?' Respondieron ellos: 'Venimos de la tierra de Canaán a comprar grano para comer.'"
,"8":"José, pues, había reconocido a sus hermanos, pero no ellos a él."
,"9":"Y se acordó José de los sueños que había tenido con respecto a ellos."
,"10":"Les dijo: 'Ustedes son espías y vienen a descubrir los secretos del país.' Respondieron ellos: 'No, señor, tus siervos han venido a comprar alimentos."
,"11":"Somos todos hijos de un mismo padre y somos honrados. Tus servidores no son espías.'"
,"12":"Pero él les dijo: 'No, ustedes han venido a descubrir los puntos débiles del país.'"
,"13":"Ellos se defendieron diciéndole: 'Eramos doce hermanos, hijos de un mismo padre, que vive en Canaán. El menor se quedó con nuestro padre, y el otro ya no vive.'"
,"14":"José insistió todavía: '¡Lo que he dicho: ustedes son espías!"
,"15":"Y ahora mismo los pondré a prueba. Por la vida de Faraón, que ustedes no dejarán este país hasta que no llegue aquí su hermano menor."
,"16":"Manden a uno de ustedes a buscar a su hermano, y los demás quedarán presos. Así sabré si es cierto lo que me acaban de decir. Y si me han mentido, ¡por la vida de Faraón!, que quedará así comprobado que son espías.'"
,"17":"Y los metió a todos en la cárcel por tres días."
,"18":"Al tercer día José les dijo: 'Les doy un medio para que se salven, pues yo también tengo temor de Dios."
,"19":"Si han dicho la verdad, que se quede sólo uno de ustedes como prisionero en la casa de la guardia donde ahora están, y los demás llevarán el trigo que tanta falta hace en sus casas."
,"20":"Pero habrán de traerme a su hermano menor para que yo compruebe que es cierto lo que ustedes me han dicho; y así podrán salvar su vida.',Así se hizo, "
,"21":"y ellos comentaban entre sí: 'Verdaderamente estamos pagando lo que hicimos con nuestro hermano, pues a pesar de ver su aflicción y de oír sus súplicas, no le hicimos caso. Por eso ahora ha venido sobre nosotros esta desgracia.'"
,"22":"Rubén dijo a los demás: '¿No les decía yo que no le hicieran mal al muchacho? Pero ustedes no me escucharon y ahora estamos pagando por su muerte.'"
,"23":"Ellos no sabían que José les entendía, pues entre él y ellos había un intérprete."
,"24":"Al oír esto, José se retiró y lloró. Después volvió, habló a sus hermanos, tomó a Simeón, lo hizo amarrar en su presencia."
,"25":"José mandó llenar de trigo sus bolsas, devolverle a cada uno dentro de su bolsa su dinero, y también que se les dieran provisiones para el camino. Y así se hizo."
,"26":"Cargaron, pues, el trigo sobre sus burros y se fueron."
,"27":"Cuando acamparon para pasar la noche, uno de ellos abrió su bolsa para dar forraje a su burro, y vio su plata: ¡Estaba en la boca de la bolsa!"
,"28":"Les dijo a sus hermanos: 'Me han devuelto el dinero: está aquí en mi bolsa.' Se quedaron sin aliento y se miraban asustados mientras decían: '¿Qué es esto que Dios nos ha hecho?'"
,"29":"Al llegar donde su padre Jacob, en la tierrra de Canaán, le contaron todo lo que les había sucedido:"
,"30":"'El hombre que gobierna ese país nos habló con aspereza y nos tomó por espías,"
,"31":"pero nosotros le dijimos: 'Nosotros somos gente honrada y no espías."
,"32":"Eramos doce hermanos, hijos del mismo padre, pero uno de nosotros ya no vive, y el hermano más pequeño se quedó con nuestro padre en el país de Canaán.'"
,"33":"Entonces el señor del país, nos dijo: 'Para que yo pueda comprobar si ustedes dicen la verdad, se va a quedar conmigo uno de ustedes; mientras tanto tomen lo que hace falta en sus casas y márchense."
,"34":"Pero tráiganme a su hermano menor, y así conoceré que ustedes son personas honradas y no espías. Sólo entonces les devolveré a su hermano y podrán moverse libremente por este país.'"
,"35":"Ahora bien, cuando vaciaron sus bolsas, cada uno de ellos encontró su dinero en la boca de la misma. Este descubrimiento les produjo temor a ellos y a su padre."
,"36":"Jacob, su padre, les dijo: 'Ustedes me van a dejar sin hijos: falta José, falta Simeón, ¡y ahora quieren llevarse a Benjamín! ¡Todas estas cosas recaen sobre mí!'"
,"37":"Pero Rubén dijo a su padre: 'Quita la vida a mis dos hijos si no te lo devuelvo. Confíamelo a mí, y yo te lo traigo de vuelta.'"
,"38":"Jacob respondió: 'No bajará mi hijo con ustedes. Su hermano ha muerto y sólo me queda él. Si le ocurre cualquier desgracia en el viaje, me moriré de pena en mi ancianidad, y será por culpa de ustedes.'"
}`)
	CurrentBook.AddChapter(43, `{
"1":"La escasez de alimentos seguía muy grande en el país,"
,"2":"y cuando se acabó el trigo que habían traído de Egipto, su padre les dijo: 'Vuelvan a comprarnos un poco de comida.'"
,"3":"Judá le contestó: 'Aquel hombre nos dijo bien claro que no nos admitiría en su presencia si no iba con nosotros nuestro hermano."
,"4":"Si mandas a Benjamín con nosotros, entonces iremos a buscar provisiones,"
,"5":"pero si no lo mandas, no bajaremos, porque aquel hombre nos dijo: 'No verán mi cara si no está con ustedes su hermano el más pequeño.'"
,"6":"Dijo entonces Israel: '¿Por qué, para desgracia mía, le dijeron a ese hombre que tenían otro hermano?'"
,"7":"Ellos contestaron: 'Aquel hombre nos interrogó con tanta insistencia sobre nosotros y nuestra familia: ¿Vive todavía el padre de ustedes? ¿Tienen algún otro hermano? Y nosotros contestamos a esas preguntas. ¿Cómo ibamos a imaginar que nos diría: Tráiganme a su hermano?'"
,"8":"Entonces Judá dijo a su padre Israel: 'Deja que el muchacho venga conmigo, para que podamos partir. Sólo así podremos seguir viviendo nosotros y nuestros hijos, en vez de morir."
,"9":"Yo respondo por él, pídeme cuenta de él. Si no te lo traigo de vuelta y no te lo muestro de nuevo, no me perdones jamás esta falta."
,"10":"Si no nos hubiéramos demorado tanto, a estas horas ya hubiéramos vuelto dos veces.'"
,"11":"Israel, su padre, les dijo: 'Ya que no queda más remedio, hagan lo siguiente. Echen en sus bolsas algo de los productos del país: tragacanto, miel, goma, láudano, pistacho y almendras, y llévenselo como regalo a ese hombre."
,"12":"Tomen doble cantidad de plata y devuelvan el dinero que apareció en la boca de sus bolsas, tal vez se deba a una equivocación."
,"13":"Y tomen a su hermano menor para volver donde aquel hombre."
,"14":"Que el Dios de las Alturas les haga hallar misericordia ante ese hombre para que les devuelva a su otro hermano, y a Benjamín. En cuanto a mí, si pierdo a mis hijos, es que tenía que perderlos.'"
,"15":"Tomaron entonces los regalos y doble cantidad de dinero, y también a Benjamín, y bajaron a Egipto. Se presentaron ante José."
,"16":"Cuando José vio que Benjamín estaba con ellos, dijo a su mayordomo: 'Lleva a casa a estos hombres, haz matar algún animal y que se prepare un banquete, porque estos hombres comerán conmigo a mediodía.'"
,"17":"El mayordomo hizo como José le ordenó, y llevó estos hombres a la casa de José."
,"18":"Ellos se asustaron porque los llevaban a la casa de José, y comentaban entre sí: 'Seguramente nos traen aquí a causa del dinero que nos fue devuelto la primera vez. Nos están preparando una trampa y nos van a asaltar; nos tomarán como esclavos y se apoderarán de nuestros burros.'"
,"19":"Por eso, estando ya para pasar la puerta, se acercaron al mayordomo de José y le dijeron:"
,"20":"'Perdón, mi señor, pero ya vinimos una vez a comprar grano,"
,"21":"y cuando en la posada abrimos nuestras bolsas, el dinero de cada uno estaba en la boca de las bolsas. Contamos bien la plata y ahora la traemos aquí para devolverla."
,"22":"Y traemos además plata para comprar más comida. No sabemos quién puso el dinero en nuestras bolsas.'"
,"23":"El mayordomo les dijo: 'Quédense tranquilos y no tengan miedo. El Dios de ustedes y el Dios de su padre les ha puesto ese tesoro en sus bolsas, pues yo recibí toda su plata.' Y en seguida les devolvió a Simeón."
,"24":"El hombre los hizo entrar en la casa de José y les dio agua para que se lavaran los pies, y mandó dar forraje a sus burros."
,"25":"Ellos prepararon el regalo y esperaron a que José llegara al mediodía, porque habían oído decir que comería allí."
,"26":"Al entrar José en la casa, le ofrecieron el regalo y lo saludaron inclinándose hasta el suelo."
,"27":"El les preguntó cómo estaban; les dijo: '¿Está bien el padre de ustedes, aquel anciano de quien me hablaron? ¿Vive todavía?'"
,"28":"Ellos respondieron: 'Tu siervo, nuestro padre, está bien y vive todavía.' Y se arrodillaron, inclinándose hasta el suelo."
,"29":"Entonces José, levantando la vista vio a su hermano Benjamín, hijo de su misma madre, y dijo: '¿Es éste el hermano menor del cual me hablaron?' Y le dijo: '¡Dios te bendiga, hijo mío!'"
,"30":"José tuvo que salir rápidamente, porque se sintió muy conmovido por la presencia de su hermano y le vinieron ganas de llorar. Apenas entró en su habitación se puso a llorar."
,"31":"Después se lavó la cara y volvió. Tratando de dominarse, ordenó: 'Sirvan la comida.'"
,"32":"Se la sirvieron por separado: a él aparte, también aparte a ellos, y a los egipcios que comían con él también les sirvieron aparte. Es que los egipcios no pueden comer con los hebreos: de hacerlo, Egipto se tendría por deshonrado."
,"33":"Se sentaron, pues, frente a él, el mayor en el primer asiento y el menor en el último, mirándose el uno al otro con asombro."
,"34":"Después separó para ellos partes de lo que se le ponía en su mesa, y la porción de Benjamín era cinco veces más grande que la de los demás. Bebieron con él y se sintieron muy alegres."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Entonces José ordenó a su mayordomo: 'Llena de alimentos las bolsas de estos hombres, todo lo que puedan llevar, y coloca el dinero de cada uno en la boca de su bolsa."
,"2":"En la bolsa del menor pondrás, junto con el dinero de su trigo, también mi copa, mi copa de plata.' El mayordomo hizo tal como José le había ordenado."
,"3":"Al amanecer fueron despedidos los hombres con sus burros."
,"4":"Habían salido ya de la ciudad y se encontraban aún a poca distancia, cuando José dijo a su mayordomo: 'Corre detrás de esos hombres, y cuando los alcances, les dirás: ¿Por qué han devuelto mal por bien?"
,"5":"¿No es ésta la copa de plata en que bebe mi señor y con la que también practica la adivinación? Han obrado muy mal al hacer eso.'"
,"6":"El los alcanzó y les habló en esa forma."
,"7":"Ellos le respondieron: '¿Por qué habla así mi señor? Jamás haríamos cosa semejante."
,"8":"Si te trajimos desde Canaán la plata que encontramos en nuestras bolsas, ¿cómo íbamos ahora a robar oro y plata de la casa de tu señor?"
,"9":"Si a alguno de nosotros, tus siervos, se le encuentra el objeto, que muera, y también nosotros seremos esclavos de mi señor.'"
,"10":"'Muy bien -dijo él-, sea como ustedes han dicho. Aquel a quien se le encuentre el objeto será mi esclavo, pero ustedes quedarán libres.'"
,"11":"Rápidamente bajó cada uno su bolsa y cada uno la abrió."
,"12":"El mayordomo los registró empezando por el mayor y terminando por el más joven y la copa se encontró en la bolsa de Benjamín."
,"13":"Entonces rasgaron sus ropas, y cargando cada uno su burro, volvieron a la ciudad."
,"14":"Judá y sus hermanos volvieron a la casa de José, que todavía estaba allí, y se postraron con el rostro por tierra delante de él."
,"15":"José les dijo: '¿Qué han hecho? ¿No sabían que un hombre como yo iba a adivinarlo?'"
,"16":"Contestó Judá: '¿Qué podemos decir a mi señor, y cómo podemos justificarnos? Dios ha descubierto alguna falta en tus servidores. En adelante seremos esclavos de mi señor, junto con aquél en cuyo poder se encontró la copa.'"
,"17":"Pero José respondió: 'Jamás haría tal cosa. El hombre a quien se le halló la copa será mi esclavo, pero ustedes pueden volver en paz donde su padre.'"
,"18":"Entonces se adelantó Judá y le dijo: 'Permite, señor mío, que pueda tu siervo decirte algunas palabras sin que te enojes contra mí, aunque tú eres como Faraón."
,"19":"Tú, mi señor, preguntaste a tus siervos la otra vez: '¿Tienen todavía padre o hermano?'"
,"20":"y nosotros contestamos: 'Tenemos todavía nuestro padre muy anciano, con un muchachito que le nació en su vejez. Este tenía otro hermano, hijo de la misma madre, pero murió y le queda sólo ese hijo de ella. Por esto su padre lo quiere mucho.'"
,"21":"Después nos dijiste: 'Que baje aquí con ustedes, y que yo mismo lo vea.'"
,"22":"Y nosotros te respondimos: 'El muchacho no puede dejar a su padre, porque si lo abandona, éste se morirá.'"
,"23":"Y tú nos dijiste: 'Si su hermano menor no baja con ustedes, no los admitiré en mi presencia.'"
,"24":"Subimos entonces a casa de nuestro padre y le dijimos tus palabras."
,"25":"Y cuando nos pidió: 'Vuelvan a comprar algo de comida',"
,"26":"nosotros respondimos: 'No podemos ir, a menos que vaya con nosotros nuestro hermano menor, porque no nos recibirá aquel hombre si nuestro hermano menor no está con nosotros.'"
,"27":"Entonces nuestro padre nos dijo: 'Ustedes saben que mi esposa me dio dos hijos."
,"28":"Uno se me fue, al que no he vuelto a ver, y creo que habrá sido despedazado por las fieras."
,"29":"Si ahora llevan de mi lado también a éste y le sucede alguna desgracia, me moriré de pena en mi ancianidad, y será por culpa de ustedes.'"
,"30":"Ahora yo no puedo volver donde mi padre sin el muchacho, pues no vive sino por él, y al ver que el muchacho no está morirá."
,"31":"Y por culpa nuestra nuestro padre morirá de pena en su ancianidad."
,"32":"Yo, tu servidor, me hice responsable por el joven ante mi padre y le dije: 'Si no te lo traigo de vuelta, seré culpable ante mi padre para siempre.'"
,"33":"Te ruego, pues, que yo quede en lugar del joven como esclavo de mi señor, para que así el muchacho suba con sus hermanos."
,"34":"Yo no podría regresar a la casa de mi padre sin el joven; no quiero ver la aflicción de mi padre.'"
}`)
	CurrentBook.AddChapter(45, `{
"1":"A este punto José no pudo ya contenerse más delante de toda aquella gente que estaba con él, y gritó: '¡Salgan todos de aquí!' No quedaba ninguno cuando José se dio a conocer a sus hermanos,"
,"2":"pero rompió a llorar tan fuerte que lo oyeron los egipcios y los servidores de Faraón."
,"3":"José dijo a sus hermanos: 'Yo soy José. ¿Vive aún mi padre?' Ellos quedaban tan aterrados de verlo que no podían responderle."
,"4":"El les dijo: 'Acérquense', y se acercaron. 'Yo soy José, su hermano, el que ustedes vendieron a los egipcios."
,"5":"Pero no se apenen ni les pese por haberme vendido, porque Dios me ha enviado aquí delante de ustedes para salvarles la vida."
,"6":"Ya van dos años de hambre en la tierra, y aún quedan cinco en que no se podrá arar ni cosechar."
,"7":"Dios, pues, me ha enviado por delante de ustedes, para que nuestra raza sobreviva en este país: ustedes vivirán aquí hasta que suceda una gran liberación."
,"8":"No han sido ustedes, sino Dios quien me envió aquí; El me ha hecho familiar de Faraón, administrador de su palacio, y gobernador de todo el país de Egipto."
,"9":"Vuelvan pronto donde mi padre y díganle: 'Esto te manda a decir tu hijo José: Dios me ha hecho dueño de todo Egipto."
,"10":"Ven a mí sin demora. Vivirás en la región de Gosén y estarás cerca de mí, tú, tus hijos y tus nietos, con tus rebaños, tus animales y todo cuanto posees."
,"11":"Aquí yo cuidaré de ti, y nada te faltará a ti, a tu familia, ni a cuantos dependen de ti, durante estos cinco años de hambre que aún quedan."
,"12":"Ahora ustedes ven, y su hermano Benjamín lo ve, que soy yo quien les está hablando."
,"13":"Cuenten a mi padre la gloria que tengo en Egipto, y todo lo que han visto, y luego dense prisa de traer aquí a mi padre.'"
,"14":"Dicho esto, José abrazó llorando a Benjamín, quien también lloró."
,"15":"Después, entre lágrimas, abrazó y besó a cada unos de sus hermanos, que se pusieron a conversar con él."
,"16":"La noticia de que habían llegado los hermanos de José llegó hasta la casa de Faraón. Se decía: 'Han venido los hermanos de José.' Esta noticia agradó a Faraón y también a sus oficiales."
,"17":"Faraón dijo a José: 'Diles esto a tus hermanos: 'Carguen sus burros y regresen a Canaán."
,"18":"Tomen a su padre y a sus familias y vengan aquí. Yo les daré lo mejor del país de Egipto y comerán lo mejor de esta tierra."
,"19":"Lleven del país de Egipto carretas para sus niños y mujeres, y traigan a su padre."
,"20":"No se preocupen por las cosas que dejan allá, pues lo mejor de Egipto será para ustedes.'"
,"21":"Así lo hicieron los hijos de Israel. José les consiguió carretas según la orden de Faraón, y los proveyó de víveres para el camino."
,"22":"A cada uno le regaló un vestido, pero a Benjamín le regaló trescientas monedas de plata y cinco vestidos."
,"23":"Y puso además diez burros cargados con los mejores productos de Egipto, y diez burras cargadas de trigo, pan y víveres para el viaje de su padre."
,"24":"Después despidió a sus hermanos, que se fueron, pero antes les recomendó que no pelearan por el camino."
,"25":"Subieron de Egipto y llegaron a Canaán, donde estaba Jacob, su padre."
,"26":"Le dieron la buena noticia: 'José vive todavía y es el que manda en todo el país de Egipto.' Pero Jacob no se conmovió, pues no les creyó."
,"27":"Ellos repitieron todas las palabras que José les había dicho y le mostraron las carretas que José le había mandado para que se trasladara. Entonces revivió el espíritu de Jacob,"
,"28":"y exclamó: '¡Me basta con saber que mi hijo José vive todavía! Iré donde él y lo veré antes de morir.'"
}`)
	CurrentBook.AddChapter(46, `{
"1":"Israel partió con todo lo que tenía, y al llegar a Bersebá, ofreció allí sacrificios al Dios de su padre Isaac."
,"2":"Dios habló a Israel durante la noche en una visión y le dijo: 'Jacob, Jacob.'"
,"3":"'Aquí estoy', contestó él. Y Dios prosiguió: 'Yo soy Dios, el Dios de tu padre. No temas bajar a Egipto, porque allí te convertiré en una gran nación."
,"4":"Yo te acompañaré a Egipto, y también te haré volver aquí. José te cerrará los ojos.'"
,"5":"Jacob dejó Bersebá y los hijos de Israel llevaron a su padre junto con sus hijos pequeños y sus mujeres en las carretas que Faraón había mandado para transportarlos."
,"6":"También tomaron sus rebaños y todo lo que habían adquirido en Canaán, y así entraron en Egipto Jacob y toda su descendencia,"
,"7":"sus hijos y los hijos de sus hijos, sus hijas y los hijos de sus hijas; en una palabra, hizo que entrara con toda su familia en Egipto."
,"8":"Estos son los nombres de los descendientes de Israel que entraron en Egipto: Jacob y sus hijos. Rubén, el primogénito de Jacob, "
,"9":"y sus hijos Henoc, Falú, Hesrón y Carmí."
,"10":"Los hijos de Simeón: Jamuel y Jamín, Ahod, Juaquín, Sohar y Saúl, cuya madre era cananea."
,"11":"Los hijos de Leví: Guersón, Quehat y Merarí."
,"12":"Los hijos de Judá: Er, Onán, Sela, Farés, Zaraj (pero Er y Onán habían muerto en la tierra de Canaán). Los hijos de Farés: Hesrón y Hamul."
,"13":"Los hijos de Isacar: Tola, Fua, Job y Sumrón."
,"14":"Los hijos de Zabulón: Sared, Elón y Jahelel."
,"15":"Estos son los hijos que Lía había dado a Jacob en Padán-Aram, además de su hija Dina. El total entre hijos e hijas era de treinta y tres personas."
,"16":"Los hijos de Gad: Sefión, Haggi, Suni, Esebón, Heri, Arodi y Arelí."
,"17":"Los hijos de Aser: Jamne, Jesua, Jesui, Beria y su hermana Seraj. Los hijos de Beria: Hebel y Melquiel."
,"18":"Estos son los hijos de Zelfa, la esclava que Labán dio a su hija Lía. Zelfa fue la madre y Jacob el padre, en total, dieciséis personas."
,"19":"Los hijos de Raquel, esposa de Jacob: José y Benjamín."
,"20":"A José le nacieron en Egipto Manasés y Efraím, cuya madre era Asenat, hija de Potifera, sacerdote de On."
,"21":"Los hijos de Benjamín: Bela, Beker, Asbel, Gera, Naamán, Equi, Ros, Mofín, Ofín y Ared."
,"22":"Estos son los hijos que Raquel dio a Jacob, en total catorce personas."
,"23":"Los hijos de Dan: Husim."
,"24":"Los hijos de Neftalí: Jasiel, Guni, Jese y Sallem."
,"25":"Estos son los hijos de Bilá, la que Labán dio a su hija Raquel. Bilá fue la madre y Jacob el padre. En total, siete personas."
,"26":"El total de personas que entraron con Jacob en Egipto, todos descendientes suyos, era de sesenta y seis personas, sin contar las mujeres de sus hijos."
,"27":"Los hijos de José que nacieron en Egipto, fueron dos. Total de personas de la familia de Jacob que entraron en Egipto. setenta."
,"28":"Antes de que entraran en Gosén. Jacob mandó delante a Judá para avisar a José de que estaba para llegar a la tierra de Gosén."
,"29":"José enganchó su carro y fue al encuentro de su padre a Gosén. Al verlo lo abrazó y lloró largamente sobre su cuello."
,"30":"Y dijo Israel a José: 'Ahora ya puedo morir, porque he visto tu rostro y porque vives todavía.'"
,"31":"Después dijo José a sus hermanos y a toda la familia de su padre: 'Voy ahora mismo a anunciar a Faraón que mis hermanos y la familia de mi padre, que vivían en tierra de Canaán, acaban de llegar."
,"32":"Le diré también que ustedes son pastores de ovejas, que se dedican a la crianza de animales y que han traído rebaños, vacas, y todas sus pertenencias."
,"33":"Así pues, cuando Faraón les llame y les pregunte: '¿Cuál es su oficio?',"
,"34":"ustedes contestarán: 'Tus servidores hemos sido pastores desde nuestra niñez hasta el día de hoy, como lo fueron también nuestros padres.' Así se podrán quedar ustedes en esta tierra de Gosén, ya que los egipcios aborrecen a todos los pastores de ovejas.'"
}`)
	CurrentBook.AddChapter(47, `{
"1":"Llegó, pues, José donde estaba el Faraón con la noticia de que su padre y sus hermanos habían llegado de Canaán con sus rebaños, vacas y demás pertenencias, y que se encontraban en la tierra de Gosén."
,"2":"Después escogió a cinco de sus hermanos y los presentó a Faraón."
,"3":"Este les preguntó: '¿A qué se dedican?' Ellos contestaron: 'Nosotros, tus servidores, somos pastores de ovejas, como lo fueron nuestros padres."
,"4":"Hemos venido a vivir en este país porque ya no quedaban pastos para nuestros rebaños, debido a la gran sequía que asola el país de Canaán. Por eso te rogamos que nos permitas vivir en la tierra de Gosén.'"
,"5":"Entonces Faraón dijo a José:"
,"6b":"'Que vivan en el país de Gosén, y si sabes que entre ellos hay hombres capacitados, ponlos como pastores principales de mis ganados.'"
,"5b":"Faraón, rey de Egipto supo que Jacob y sus hijos se habían presentado a José en Egipto. Entonces dijo a José: 'Tu padre y tus hermanos han venido a ti."
,"6":"Todo el país de Egipto está a tu disposición. Que tu padre y tus hermanos se establezcan en la mejor parte del país.'"
,"7":"José trajo después a su padre Jacob y se lo presentó a Faraón. Después que Jacob lo saludó,"
,"8":"Faraón le preguntó: '¿Cuántos años tienes?'"
,"9":"Jacob respondió: 'Los años de mi peregrinación son ciento treinta. Pocos y malos han sido los días de mi vida, y no han llegado a igualar los años de vida de mis padres durante su peregrinación.'"
,"10":"Después Jacob volvió a bendecir a Faraón y se retiró de su presencia."
,"11":"José instaló a su padre y a sus hermanos, y les dio una propiedad en la tierra de Egipto, en el mejor lugar de la comarca de Ramsés, tal como Faraón había ordenado."
,"12":"Y José proveyó de lo necesario para vivir a su padre, a sus hermanos y a toda la familia de su padre, teniendo en cuenta el número de sus dependientes."
,"13":"La escasez se hizo más fuerte y no se encontraban alimentos en toda la tierra; Egipto y Canaán estaban agotados por el hambre."
,"14":"Entonces José acaparó toda la plata que había en la tierra de Egipto y de Canaán, a cambio del trigo que compraban, y llevó toda esa plata al palacio de Faraón."
,"15":"Cuando se acabó la plata de Egipto y de Canaán, todos los egipcios comenzaron a llegar donde José para decirle: 'Danos pan, ¿acaso nos vas a dejar morir porque se nos terminó el dinero?'"
,"16":"José les respondió: 'Si no tienen más dinero, denme sus ganados y yo en cambio les daré pan.'"
,"17":"Trajeron su ganado a José, y José les dio pan a cambio de sus caballos, ovejas, vacas y burros. De esta manera los abasteció de pan durante ese año a cambio de todos sus ganados."
,"18":"Al año siguiente volvieron donde él diciendo: 'No podemos ocultar a nuestro señor que se nos ha terminado el dinero, y que los ganados ya son todos suyos. Tan sólo nos quedan nuestros cuerpos y nuestras tierras."
,"19":"Tú no puedes vernos morir a nosotros y nuestras tierras; compranos, pues, a nosotros y nuestras tierras, a cambio de pan, y seremos nosotros y nuestras tierras propiedad de Faraón. Danos trigo para que no muramos; así viviremos y nuestra tierra no quedará desolada.'"
,"20":"De este modo José adquirió para Faraón toda la tierra de Egipto, pues los egipcios tuvieron que vender sus campos, ya que el hambre los apretaba, y la tierra pasó a ser toda de Faraón."
,"21":"En cuanto al pueblo, lo redujo a la servidumbre desde un extremo al otro de Egipto."
,"22":"La única tierra que no compró fue la de los sacerdotes, pues había un decreto de Faraón en favor de ellos, y él debía procurarles el alimento. Por eso no vendieron sus tierras."
,"23":"Entonces José dijo al pueblo: 'Ya ven que los he comprado a ustedes y sus tierras para Faraón. Aquí tienen semillas: siembren la tierra."
,"24":"Cuando llegue el tiempo de la cosecha, darán la quinta parte a Faraón y las otras cuatro partes restantes serán para ustedes, como semillas de siembra, y como alimento para ustedes, su familia y los que estén en su casa.'"
,"25":"Ellos respondieron: 'Puesto que nos has salvado la vida, sírvete aceptarnos como esclavos de Faraón.'"
,"26":"Así José impuso como ley, que la quinta parte de los productos de la tierra de Egipto debe ser entregada a Faraón, y esa norma perdura hasta el día de hoy. Sólo las tierras de los sacerdotes no pasaron a poder de Faraón."
,"27":"Los israelitas vivieron en el país de Egipto, en la tierra de Gosén. Tomaron posesión de ella, tuvieron muchos hijos y se multiplicaron en número."
,"28":"Jacob vivió en Egipto diecisiete años de los ciento cuarenta y siete que duró su vida."
,"29":"Y cuando los días de su vida se acercaron a su fin, llamó a su hijo José y le dijo: 'Si me aprecias de veras, te ruego que coloques tu mano bajo mi muslo, y me prometas que no me sepultarás en Egipto; en esto reconoceré tu amor y fidelidad."
,"30":"Cuando me haya ido a descansar con mis padres, sácame de Egipto y entiérrame en la tumba de ellos.' José respondió: 'Lo haré tal como lo pides.' Insistió Jacob: '¡Júramelo!' Y José se lo juró."
,"31":"Entonces Israel se inclinó sobre la cabecera de su cama."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Algún tiempo después, avisaron a José de que su padre estaba enfermo. Tomó entonces con él a sus dos hijos, Manasés y Efraím,"
,"2":"e hizo anunciar a su padre: 'Mira, tu hijo José ha venido a verte.' Israel, haciendo un esfuerzo, se sentó en la cama."
,"3":"Dijo Jacob a José: 'El Dios de las Alturas se me apareció en Luz, en el país de Canaán, y me bendijo diciendo:"
,"4":"'Mira, yo haré que seas fecundo y que te multipliques. Haré de ti una asamblea de naciones y te daré a ti y a tus descendientes después de ti este país, como una propiedad eterna.'"
,"5":"Desde ahora, pues, los dos hijos que te han nacido en Egipto antes de llegar yo a este país, serán míos. Efraím y Manasés serán hijos míos, al igual que Rubén y Simeón son hijos míos,"
,"6":"pero los hijos que has engendrado después serán tuyos, tanto ellos como su patrimonio serán registrados con los nombres de Efraím y Manasés."
,"7":"También debes saber que cuando yo regresaba de Padán, tu madre Raquel se me murió en el camino, en el país de Canaán, poco antes de llegar a Efratá, y la enterré allí (en el camino de Efratá, que es Belén).'"
,"8":"Al ver Israel a los dos hijos de José, le preguntó: '¿Quiénes son éstos?'"
,"9":"José le respondió: 'Estos son mis hijos, los que Dios me ha dado aquí.' Y le dijo: 'Acércalos, por favor, y los bendeciré.'"
,"10":"Israel tenía los ojos debilitados por la vejez y no podía ver. Cuando José se los acercó, él los abrazó y los besó."
,"11":"Israel dijo a José: ' Nunca pensé que volvería a verte, y ahora Dios me concede ver incluso a tus descendientes.'"
,"12":"José retiró a los hijos de entre las rodillas de su padre y se postró delante de su padre hasta tocar el suelo con la cara."
,"13":"Colocó José a Efraím a su derecha, quedando a la izquierda de Israel, y a Manasés a su izquierda, quedando a la derecha de su padre, y los acercó a él."
,"14":"Israel extendió su mano derecha y la puso sobre la cabeza de Efraím, que era el menor, y así, cruzando las manos, puso su izquierda sobre la cabeza de Manasés a pesar de que era el primogénito."
,"15":"Luego bendijo a José diciendo: 'Que el Dios ante el cual caminaron mis padres Abraham e Isaac, el Dios que ha sido mi pastor desde el día en que nací hasta hoy,"
,"16":"el Angel que me ha librado de todo mal, bendiga a estos muchachos. Que en ellos se perpetúe mi nombre y el nombre de mis padres Abraham e Isaac. Que lleguen a ser muy numerosos en esta tierra.'"
,"17":"José vio que su padre tenía puesta su mano derecha sobre la cabeza de Efraím, lo que le disgustó. Tomó, pues, la mano de su padre para cambiarla de la cabeza de Efraím a la de Manasés"
,"18":"y le dijo: 'Así no, padre mío, porque éste es mi hijo mayor. Coloca tu mano derecha sobre su cabeza.'"
,"19":"Israel se negó y le dijo: 'Lo sé, hijo mío, lo sé. El también se hará pueblo, también él llegará a ser grande, pero su hermano menor será más grande que él y su descendencia formará una familia de pueblos.'"
,"20":"Y los bendijo aquel día con estas palabras: 'A ustedes los tomarán como ejemplo cuando quieran bendecir a alguno en Israel, y dirán: 'Que Dios te haga semejante a Efraím y Manasés.',Así puso a Efraím por delante de Manasés."
,"21":"Después dijo Israel a José: 'Yo estoy para morir, pero Dios estará con ustedes y los hará volver a la tierra de sus padres."
,"22":"A ti te dejo algo más que a tus hermanos, me refiero a Siquem que conquisté al amorreo con mi espada y con mi arco.'"
}`)
	CurrentBook.AddChapter(49, `{
"1":"Jacob llamó a sus hijos y les dijo: 'Reúnanse, que les voy a anunciar lo que sucederá en el futuro."
,"2":"Júntense hijos de Jacob, oigan y escuchen a Israel, su padre."
,"3":"Rubén, tú eres mi primogénito, mi vigor y el primer fruto de mi virilidad, pero rebosante de orgullo y de ímpetu."
,"4":"Eres como las aguas espumantes: no te encumbrarás, tú que subiste al lecho de tu padre y deshonraste mi cama."
,"5":"Simeón y Leví son hermanos, sus cuchillos fueron instrumentos de violencia."
,"6":"Que nunca mi alma participe en sus intrigas, y que mi corazón esté lejos de su compañía, porque en su enojo mataron hombres, y en su furor desjarretaron toros."
,"7":"Sea maldita su cólera porque es violenta, y su furor, porque fue cruel. Los dividiré en Jacob, y los dipersaré en Israel."
,"8":"A ti, Judá, te alabarán tus hermanos, tu mano agarrará del cuello a tus enemigos, y tus hermanos se inclinarán ante ti."
,"9":"¡Judá es cachorro de león! Vuelves, hijo mío, de la caza. Se agazapa o se abalanza cual león, o cual leona, ¿quién lo hará levantar?"
,"10":"El cetro no será arrebatado de Judá ni el bastón de mando de entre sus piernas hasta que venga aquel a quien le pertenece y a quien obedecerán los pueblos."
,"11":"Amarra en la vid a su burrito, y a la cepa el hijito de su burra. Lava en el vino su túnica y en la sangre de los racimos su manto."
,"12":"Sus ojos están encandilados de vino y sus dientes más blancos que la leche."
,"13":"Zabulón habita a orillas del mar, es tripulante de barcos y se extiende hasta Sidón."
,"14":"Isacar es un burro corpulento, echado entre dos establos."
,"15":"Encontró un buen lugar de descanso, y como vio que el país era agradable, inclinó su espalda a la carga: pasará a ser esclavo."
,"16":"Dan juzgará a su pueblo como una más de las tribus de Israel."
,"17":"Será como serpiente en el camino, como víbora en el sendero, que muerde los talones del caballo, y hace caer de espaldas al jinete."
,"18":"¡Oh Yavé, espero en tu salvación!"
,"19":"A Gad le asaltan salteadores, pero él atraca a su retaguardia."
,"20":"Aser tiene ricos manjares, y prepara comidas de rey."
,"21":"Neftalí es una cierva suelta que tiene cervatillos hermosos."
,"22":"José es el retoño de una vid frondosa, de una parra frondosa junto a la fuente: los sarmientos trepan sobre la muralla."
,"23":"Lo han provocado lanzándole flechas, lo han perseguido los arqueros,"
,"24":"pero su arco se ha mantenido firme y sus brazos no han aflojado, por la mano del Fuerte de Jacob, por el Pastor y la Roca de Israel,"
,"25":"por el Dios de tu padre, el que te ayuda, por el Dios Todopoderoso que te bendice: ¡bendiciones de los altos cielos! ¡Bendiciones del abismo que yace abajo! ¡Bendiciones de los pechos y los senos! ¡Bendiciónes de tu campo y de tu establo!"
,"26":"Las bendiciones de tu padre han sobrepasado a las bendiciones de los montes seculares, y a las venturas de las lomas eternas. Todas ellas descansen sobre la cabeza de José sobre la frente del que ha sido consagrado en medio de sus hermanos."
,"27":"Benjamín es un lobo sanguinario. Por la mañana devora su presa y por la tarde reparte los despojos."
,"28":"Estas son las tribus de Israel, doce en total, y esto fue lo que les dijo su padre cuando los bendijo, dando a cada uno la bendición que le correspondía."
,"29":"Después les dio estas instrucciones: 'Yo voy a reunirme con mi pueblo. Entiérrenme junto a mis padres, en la cueva que hay en el campo de Efrón el hitita,"
,"30":"o sea, en la cueva que está en el campo de Macpelá, frente a Mambré, en el país de Canaán, el campo que Abraham compró a Efrón el hitita como lugar de su propiedad para sepulturas."
,"31":"Allí fue sepultado Abraham y su esposa Sara. Allí también fue sepultado Isaac y su esposa Rebeca, y allí sepulté yo a Lía."
,"32":"Dicho campo y la cueva que hay en él fueron comprados a los hititas.'"
,"33":"Cuando Jacob hubo terminado de dar estas instrucciones a sus hijos, recogió sus pies en la cama y expiró, y fue a reunirse con sus antepasados."
}`)
	CurrentBook.AddChapter(50, `{
"1":"José se acercó a la cama de su padre, lo abrazó llorando y lo besó."
,"2":"Mandó después a los médicos que estaban a su servicio que embalsamaran a su padre y ellos lo embalsamaron."
,"3":"Emplearon en ello cuarenta días, ya que éste es el tiempo necesario para el embalsamamiento. Los egipcios lo lloraron durante setenta días."
,"4":"Transcurrido el tiempo de duelo, José habló a los principales de la casa de Faraón de esta manera: 'Si ustedes realmente me aprecian, les ruego hagan llegar a oídos de Faraón lo siguiente:"
,"5":"Antes de morir, mi padre me hizo prometerle bajo juramento que yo lo habría de sepultar en el sepulcro que él mismo se había preparado en el país de Canaán. Así pues, permíteme ahora subir a enterrar a mi padre, y luego volveré.'"
,"6":"Faraón le mandó a decir: 'Sube y entierra a tu padre, tal como te hizo jurar.'"
,"7":"Subió José a sepultar a su padre y subieron también con él todos los oficiales de Faraón, los principales de su familia y todos los jefes de Egipto,"
,"8":"así como toda la familia de José, sus hermanos y la familia de su padre. Tan sólo dejaron en el país de Gosén a sus niños, sus rebaños y demás animales."
,"9":"Lo acompañaban además carros y soldados a caballo, lo que hacía que fuese una caravana muy considerable."
,"10":"Al llegar a Gorén-Atad, que está al otro lado del Jordán, celebraron unos funerales muy grandes y solemnes; estos funerales que José celebró por su padre duraron siete días."
,"11":"Los cananeos que vivían allí, al ver los funerales que se hacían en Gorén-Atad, se dijeron: 'Estos son unos funerales muy solemnes de los egipcios.' Por eso aquel lugar se llamó Abel-Misraim (o sea, duelo de los egipcios) y está al otro lado del Jordán."
,"12":"Los hijos de Jacob cumplieron a su respecto todo lo que él les había ordenado."
,"13":"Lo trasladaron al país de Canaán y lo sepultaron en la cueva que hay en el campo de Macpelá, frente a Mambré, campo que Abraham había comprado a Efrón el hitita, como su propiedad para sepulturas."
,"14":"Después de sepultar a su padre, José volvió a Egipto con sus hermanos y con todos los que lo habían ido a acompañar en el funeral de su padre."
,"15":"Al ver que había muerto su padre, los hermanos de José se dijeron: 'Tal vez José nos guarde aún rencor, y ahora nos devuelva todo el mal que le hicimos.'"
,"16":"Por eso le mandaron a decir: 'Tu padre antes de morir nos encargó que te dijéramos:"
,"17":"'Por favor, perdona el crimen de tus hermanos y el pecado que cometieron cuando te trataron mal. Ahora debes perdonar su crimen a los servidores del Dios de tu padre.' José, al oír este mensaje, se puso a llorar."
,"18":"Sus hermanos vinieron y se echaron a sus pies, diciendo: 'Aquí nos tienes, somos tus esclavos.'"
,"19":"José les respondió: 'No teman. ¿Acaso podría ponerme yo en lugar de Dios?"
,"20":"Ustedes quisieron hacerme daño, pero Dios quiso convertirlo en bien para que se realizara lo que hoy ven: conservar la vida de un pueblo numeroso."
,"21":"Nada teman, pues. Yo los mantendré a ustedes y a sus hijos.' Luego los consoló, hablándoles con palabras cariñosas."
,"22":"José permaneció en Egipto junto con toda la familia de su padre. Murió a la edad de ciento diez años."
,"23":"Alcanzó a ver a los hijos de Efraím hasta la tercera generación. También los hijos de Maquir, hijo de Manasés, nacieron sobre las rodillas de José."
,"24":"José dijo a sus hermanos: 'Yo voy a morir, pero tengan la plena seguridad de que Dios los visitará y los hará subir de este país a la tierra que juró dar a Abraham, Isaac y Jacob.'"
,"25":"Y José hizo jurar a los hijos de Israel, pidiéndoles este favor: 'Cuando Dios los visite, lleven mis huesos de aquí junto con ustedes.'"
,"26":"José murió en Egipto, a la edad de ciento diez años. Embalsamaron su cuerpo y lo colocaron en un ataúd en Egipto."
}`)

}
func ES_LBL_LoadVPLVChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Yavé llamó a Moisés y le habló así, desde la Tienda de las Citas divinas: 'Esto tienes que decir a los hijos de Israel:"
,"2":"Cuando alguno de ustedes presente a Yavé una ofrenda de animales, esta ofrenda podrá ser de ganado mayor o menor."
,"3":"Si quiere ofrecer un holocausto, es decir una víctima totalmente quemada, presentará a la entrada de la Tienda de las Citas el macho sin defecto que haya escogido, y así su sacrificio será agradable a Yavé."
,"4":"Pondrá su mano sobre la cabeza de la víctima, para que Yavé se la reciba para perdón de sus pecados."
,"5":"Sacrificará el novillo delante de Yavé y los sacerdotes, hijos de Aarón, ofrecerán la sangre derramándola sobre el altar que está a la entrada de la Tienda de las Citas, y todo en derredor."
,"6":"Entonces desollarán la víctima y la despedazarán;"
,"7":"luego los hijos del sacerdote Aarón pondrán fuego en el altar y colocarán leña sobre el fuego;"
,"8":"acomodarán los trozos con la cabeza y las grasas encima de la leña colocada sobre el fuego del altar."
,"9":"Lavarán con agua las entrañas y las patas, y el sacerdote lo quemará todo en el altar. Así es el holocausto, y es un sacrificio por el fuego cuyo suave olor apacigua a Yavé."
,"10":"Si alguien ofrece ganado menor, corderos o cabras, también ofrecerá un macho sin defecto."
,"11":"Lo sacrificarán ante Yavé, al lado norte del altar; los sacerdotes derramarán la sangre en el altar y en todo su derredor."
,"12":"Luego lo despedazarán en porciones y el sacerdote lo dispondrá con la cabeza y el sebo encima de la leña colocada sobre el fuego del altar."
,"13":"Lavarán con agua las entrañas y las patas y el sacerdote lo ofrecerá y lo quemará en el altar. Así es el holocausto, y es un sacrificio por el fuego cuyo suave olor apacigua a Yavé."
,"14":"Si se ofrece a Yavé un holocausto de aves, presentarán tórtolas o pichones."
,"15":"El sacerdote presentará la víctima en el altar, le retorcerá la cabeza y la quemará sobre el altar; la sangre la exprimirá sobre la pared del altar."
,"16":"Le quitará el buche y las plumas y los arrojará a las cenizas, al lado oriental del altar."
,"17":"Se abrirá el ave entre las alas, sin partirla. El sacerdote la quemará en el altar encima de la leña colocada sobre el fuego. Así es el holocausto, y es un sacrificio por el fuego cuyo suave olor apacigua a Yavé.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"'Cuando alguien ofrezca a Yavé una ofrenda, ésta consistirá en flor de harina, sobre la que derramará aceite y pondrá incienso."
,"2":"La llevará a los hijos de Aarón, a los sacerdotes; el sacerdote tomará un puñado de harina con aceite y todo el incienso; luego lo quemará en el altar para que Dios se acuerde de aquel que ofrece. Es un sacrificio por el fuego de calmante aroma para Yavé."
,"3":"El resto de la ofrenda quedará para Aarón y sus hijos; es cosa muy sagrada porque proviene del sacrificio por el fuego para Yavé."
,"4":"Cuando quieras ofrecer alguna masa cocida al horno, será de flor de harina en panes sin levadura amasados con aceite, o en tortas sin levadura untadas de aceite."
,"5":"Si ofreces alguna masa preparada en la parrilla, ésta deberá ser de flor de harina amasada con aceite, sin levadura."
,"6":"La partirás en trozos y le echarás aceite, pues es una ofrenda."
,"7":"Si presentas una ofrenda preparada en sartén, ésta será de flor de harina con aceite."
,"8":"Presentarás al sacerdote dichas ofrendas que llevas a Yavé, para que las presente al altar."
,"9":"El sacerdote reservará parte de la ofrenda para que Dios se acuerde de aquel que ofrece, y la quemará en el altar: es un sacrificio por el fuego de calmante olor para Yavé."
,"10":"El resto de la ofrenda quedará para Aarón y sus hijos, como porción muy sagrada del sacrificio por el fuego para Yavé."
,"11":"No se presentará a Yavé ninguna ofrenda de masa fermentada. No habrá ni levadura ni miel en los sacrificios por el fuego que ofrezcan a Yavé."
,"12":"Se podrán ofrecer a Yavé como primicias, pero no se pondrán en el altar como sacrificios de calmante aroma. En toda ofrenda que presentes, pondrás sal, "
,"13":"pues así como la alianza con tu Dios es alianza de sal, también estará la sal en tus ofrendas: todas serán saladas."
,"14":"Si ofreces a Yavé las primicias de tus sembrados, presentarás las espigas tostadas al fuego, o granos nuevos partidos. Así será tu ofrenda de primicias."
,"15":"Echarás por encima aceite e incienso, por ser una ofrenda."
,"16":"El sacerdote quemará en tu nombre parte del grano molido y del aceite, con todo el incienso. Es un sacrificio por el fuego para Yavé."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Cuando alguien ofrezca vacuno como sacrificio de comunión, ya sea macho o hembra, ofrecerá un animal sin defecto."
,"2":"Pondrá su mano sobre la cabeza de la víctima y la degollará a la entrada de la Tienda de las Citas; y los hijos de Aarón, los sacerdotes, derramarán la sangre en el altar y en su derredor."
,"3":"Se tomará una parte del sacrificio de comunión y se ofrecerá por el fuego para Yavé: el sebo que cubre las entrañas y todo lo que hay sobre ellas;"
,"4":"los dos riñones y el sebo adherido a ellos y a los lomos, y la telilla del hígado que se separará de los riñones."
,"5":"Los hijos de Aarón quemarán todo esto en el altar encima del holocausto que está sobre la leña puesta al fuego. Será un sacrificio por el fuego de calmante olor para Yavé."
,"6":"Si lo que se ofrece como sacrificio de comunión ante Yavé es de ganado menor, se ofrecerá un animal sin defecto, macho o hembra."
,"7":"Si alguien ofrece un cordero, lo presentará ante Yavé,"
,"8":"pondrá su mano sobre la cabeza de su víctima, y luego la degollará a la entrada de la Tienda de las Citas. Los hijos de Aarón derramarán su sangre en el altar y en su derredor."
,"9":"Parte de este sacrificio de comunión será quemada para Yavé: la gordura y la cola entera"
,"10":"con los riñones y el sebo adherido a ellos y a los lomos, junto con la telilla del hígado que se separará de los riñones."
,"11":"El sacerdote quemará todo esto sobre el altar como sacrificio para Yavé."
,"12":"Si su ofrenda es una cabra, la presentará ante Yavé,"
,"13":"impondrá la mano sobre su cabeza y la sacrificará ante la Tienda de las Citas; los hijos de Aarón derramarán su sangre en el altar y alrededor."
,"14":"Presentará parte de ella como sacrificio por el fuego para Yavé:"
,"15":"el sebo que cubre las entrañas y el que está encima, con el sebo adherido a ellos y a los lomos, junto con la telilla del hígado."
,"16":"El sacerdote quemará todo esto en el altar, como alimento pasado por el fuego, de calmante olor para Yavé."
,"17":"Toda la grasa pertenece a Yavé. Este es un decreto perpetuo de generación en generación, dondequiera que vivan. No comerán grasa ni sangre."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Yavé habló así a Moisés:"
,"2":"'Dirás a los hijos de Israel: Estas son las normas para las personas que pecan por ignorancia contra uno de los mandamientos de Yavé, haciendo algo que no debe hacerse."
,"3":"Si el que peca es el sumo sacerdote, el ungido, su pecado mancha al pueblo. Ofrecerá a Yavé, por el pecado que cometió, un novillo sin defecto."
,"4":"Lo traerá a la Tienda de las Citas a la presencia de Yavé; pondrá la mano sobre la cabeza del novillo, y luego lo sacrificará delante de Yavé."
,"5":"Entonces el sacerdote ungido tomará parte de su sangre, que llevará a la Tienda de las Citas,"
,"6":"y habiendo mojado el dedo en la sangre rociará con ella siete veces hacia el velo del santuario."
,"7":"El sacerdote teñirá con la sangre los cuernos del altar del incienso aromático para Yavé que está en la Tienda de las Citas, y vaciará el resto de la sangre al pie del altar de los holocaustos, a la entrada de la Tienda de las Citas."
,"8":"Después quitará la grasa del novillo sacrificado por el pecado, tanto la que cubre las entrañas, como la que está encima,"
,"9":"los riñones y el sebo adherido a éstos y a los lomos, junto con la telilla del hígado."
,"10":"Hará como se hace en los sacrificios de comunión: lo quemará sobre el altar de los holocaustos."
,"11":"Todo lo restante del animal, la piel, toda la carne, la cabeza, patas e intestinos y el excremento,"
,"12":"lo llevará fuera del campamento, a un lugar limpio donde se suelen echar las cenizas de las víctimas. Allí lo quemarán sobre un montón de leña."
,"13":"Si toda la comunidad de Israel ha pecado por ignorancia, sin darse cuenta de que hizo alguna cosa prohibida por Yavé,"
,"14":"en cuanto la comunidad se dé cuenta del pecado, ofrecerá un novillo como sacrificio por el pecado. Lo llevarán a la entrada de la Tienda de las Citas,"
,"15":"y los ancianos del pueblo pondrán las manos sobre la cabeza del ternero, en la presencia de Yavé. Allí sacrificarán el novillo."
,"16":"El sacerdote ungido llevará parte de la sangre a la Tienda de las Citas;"
,"17":"allí mojará su dedo en sangre y hará siete aspersiones hacia el velo."
,"18":"Teñirá también con sangre los cuernos del altar que está ante Yavé en la Tienda de las Citas, y derramará la sangre restante al pie del altar de los sacrificios que está a la entrada de la Tienda de las Citas."
,"19":"Luego quitará toda la grasa y la quemará sobre el altar,"
,"20":"haciendo en todo con este novillo lo mismo que se hace al ofrecer el sacrificio por el pecado del sacerdote. Así hará la expiación por ellos y serán perdonados."
,"21":"Sacarán el ternero fuera del campamento y lo quemarán también como el primero, por ser sacrificio por el pecado de toda la asamblea."
,"22":"Si un jefe ha pecado, haciendo sin darse cuenta alguna de las muchas cosas que prohíbe la ley de Yavé, se encuentra con un delito."
,"23":"En cuanto se dé cuenta de su pecado, traerá como ofrenda un macho cabrío sin defecto,"
,"24":"le pondrá su mano sobre la cabeza y lo degollará en el lugar donde se sacrifica el holocausto en presencia de Yavé."
,"25":"Es un sacrificio por el pecado. El sacerdote mojará su dedo en la sangre de la víctima y derramará la sangre al pie de este altar."
,"26":"El sebo lo quemará encima, como se hace en los sacrificios de comunión. De esta forma el sacerdote hará la expiación por la persona y por su pecado, y será perdonada."
,"27":"Si uno del pueblo ha pecado por inadvertencia, haciendo algo prohibido por Yavé, se encuentra con un delito."
,"28":"En cuanto se dé cuenta del pecado cometido, presentará como ofrenda una cabra sin defecto,"
,"29":"pondrá la mano sobre la cabeza de la víctima y la degollará en el lugar de los holocaustos."
,"30":"El sacerdote mojará su dedo en la sangre, teñirá con ella los cuernos del altar de los holocaustos, y derramará el resto junto a su base."
,"31":"Quitará toda la grasa como suele quitarse de los sacrificios de comunión, la quemará sobre el altar como calmante olor para Yavé. Así hará la expiación por la persona y por su pecado, y será perdonada."
,"32":"Si ofrece por el pecado una ovejita, tomará una oveja sin defecto,"
,"33":"pondrá la mano sobre la cabeza de la víctima y la degollará en el lugar donde se degüellan las víctimas de los holocaustos."
,"34":"El sacerdote mojará su dedo en la sangre y teñirá con ella los cuernos del altar de los holocaustos, luego derramará el resto de la sangre al pie del altar."
,"35":"También quitará toda la grasa, así como se quita del ternero sacrificado en sacrificio de comunión, la quemará sobre el altar encima de los sacrificios haciendo la expiación por el que ofrece y por su pecado, y le será perdonado."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Lo que sigue vale para la persona que se encuentra culpable porque podía testificar respecto de algún crimen del que fue testigo ocular o del que supo y, sin embargo, al oír las palabras de la maldición contra quien no denunciara no quiso denunciar al culpable."
,"2":"Vale también para la persona que toca por inadvertencia cosas impuras, ya sea el cuerpo de una bestia impura, o de un animal impuro, o bien de algún reptil impuro, pero después se da cuenta y entonces se encuentra con un delito."
,"3":"Lo mismo para quien toca por inadvertencia cualquiera de las inmundicias humanas con que puede contaminarse, y después se da cuenta y entonces se encuentra con un delito."
,"4":"O bien la persona que por inadvertencia jura y pronuncia un juramento insensato de cualquier clase, pero después se da cuenta y así se encuentra con un delito."
,"5":"En todos estos casos el que cometió el delito confesará primero su pecado."
,"6":"Luego, como sacrificio de reparación por el pecado cometido, llevará a Yavé una hembra, oveja o cabra, y el sacerdote hará la expiación por dicho pecado y persona."
,"7":"Si a dicha persona no le alcanza para una res, ofrecerá a Yavé dos tórtolas o dos pichones, uno por el pecado y otro en holocausto."
,"8":"Los entregará al sacerdote, el cual, ofreciendo uno por el pecado, le retorcerá la cabeza hacia las alitas, de manera que quede pegada al cuello y no enteramente separada."
,"9":"Rociará con su sangre la pared del altar y derramará el resto de la sangre al pie del altar: es un sacrificio por el pecado."
,"10":"El otro pájaro lo quemará en sacrificio de holocausto, como se acostumbra hacer. Así es como el sacerdote hará la expiación por esta persona, por su pecado, y será perdonada."
,"11":"Si a esta persona tampoco le alcanza para ofrecer dos tórtolas o dos pichones, ofrecerá por su pecado, para que se le perdone, una décima parte de flor de harina. No le pondrá aceite, ni pondrá encima incienso, pues es ofrenda por el pecado."
,"12":"La entregará al sacerdote, el cual, tomando un puñado entero de harina, la quemará sobre el altar encima de los holocaustos para Yavé, para que se acuerde del que ofrece."
,"13":"Así el sacerdote hará la expiación por esta persona y por su pecado, y le será perdonado. El resto de la ofrenda será para el sacerdote.'"
,"14":"Yavé habló a Moisés para decirle:"
,"15":"'Si alguno ha pecado por error, al no dar todo lo que debía consagrar a Yavé, ofrecerá por su pecado un carnero sin defecto, una res de ganado menor que tú apreciarás según lo que vale en siclos de plata, según el peso del santuario."
,"16":"Este hombre devolverá lo que no dio para el santuario y lo dará al sacerdote, agregando una quinta parte. El sacerdote hará la expiación por él, ofreciendo el carnero por el pecado, y quedará perdonado."
,"17":"Si alguno ha pecado, haciendo alguna cosa de las prohibidas por la ley de Dios, ha cometido un delito aunque no se dé cuenta, y carga con un pecado."
,"18":"Si lo juzgas conveniente, traerá al sacerdote un carnero sin defecto, una res de ganado menor. El sacerdote hará la expiación por él, pues lo hizo sin advertencia, y quedará perdonado."
,"19":"Pues no hay duda de que cometió un delito a los ojos de Yavé.'"
,"20":"Yavé habló a Moisés para decirle:"
,"21":"'Aquí viene el caso del que cometió un pecado de infidelidad a Yavé en la forma siguiente: Defraudó a su prójimo respecto a algún depósito que éste le había confiado, o le quitó una cosa por la fuerza, o lo explotó,"
,"22":"o mintió respecto de una cosa perdida que encontró, o hizo falso juramento en cualquier asunto en que los hombres suelen pecar."
,"23":"El que pecó y que cometió un delito, tendrá que devolver lo que robó o quitó a la fuerza o lo que guardó del depósito o de la cosa perdida que encontró"
,"24":"y por la que hizo falso juramento. Añadirá además la quinta parte."
,"25":"Si lo juzgas conveniente, traerá a Yavé su sacrificio por el pecado: un carnero sin defecto, una res de ganado menor, y lo dará al sacerdote."
,"26":"El sacerdote hará la expiación por esta persona en presencia de Yavé, y le será perdonado el pecado que haya cometido.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Yavé habló a Moisés para decirle:"
,"2":"'Da esta orden a Aarón y a sus hijos: Esta será la ley del holocausto, es decir de la víctima totalmente quemada. La dejarán en el altar durante todo la noche hasta el amanecer; el fuego del altar no se apagará."
,"3":"A la mañana después de ponerse su túnica de lino y sus calzoncillos de lino, el sacerdote recogerá las cenizas que el fuego dejó al quemar la víctima, y las pondrá junto al altar."
,"4":"Luego cambiará sus vestiduras por otras antes de llevar las cenizas fuera del campamento, y las echará en un lugar puro."
,"5":"El fuego del altar habrá de ser alimentado de manera que nunca se apague; el sacerdote echará leña cada día por la mañana, y pondrá encima las víctimas de holocausto así como la grasa de las víctimas de comunión."
,"6":"El fuego arderá perpetuamente en el altar: no debe apagarse."
,"7":"Este es la ley de las ofrendas. Los hijos de Aarón las ofrecerán en presencia de Yavé frente al altar."
,"8":"El sacerdote tomará de la ofrenda un puñado de flor de harina mezclada con aceite y todo el incienso que haya puesto encima, y lo quemará en el altar para Yavé en nombre del que la ofreció."
,"9":"Lo que quede será para Aarón y sus hijos: lo comerán sin ponerle levadura en un lugar santo dentro de la Morada."
,"10":"No le pondrán levadura, pues ésta es la parte que les doy en mis sacrificios por el fuego, y será cosa muy sagrada, lo mismo que la víctima por el pecado o por algún delito."
,"11":"Todo varón de la descendencia de Aarón podrá comerla. Esta será para sus descendientes una ley perpetua: todo lo que toque esas cosas sacrificadas por el fuego para Yavé pasará a ser santo también.'"
,"12":"Yavé habló a Moisés para decirle:"
,"13":"'Esta es la ofrenda que Aarón y sus hijos ofrecerán a Yavé en el día de su consagración: una décima de flor de harina lo mismo como para la ofrenda perpetua la mitad por la mañana y la otra por la tarde."
,"14":"La freirán en aceite, en una sartén, y la ofrecerás caliente; presentarás los pedacitos fritos como ofrenda de calmante olor para Yavé."
,"15":"Uno de los hijos del sacerdote que ha sido ungido podrá ofrecerla en su lugar. Esta ofrenda será quemada entera en el altar: esto será un rito perpetuo."
,"16":"Toda ofrenda que presente uno de los sacerdotes será consumida totalmente; no se comerá nada de ella.'"
,"17":"Yavé habló a Moisés para decirle:"
,"18":"'Dile a Aarón y a sus hijos: Esta es la ley de la víctima ofrecida por el pecado. Será sacrificada ante Yavé en el mismo lugar donde se ofrece el sa crificio del holocausto. Es una cosa muy sagrada."
,"19":"El sacerdote que la ofrece la comerá en un lugar santo, a la entrada de la Tienda de las Citas."
,"20":"Cualquier cosa que toque las carnes sacrificadas será santificada; si cae una gota de su sangre sobre algún vestido, se lavará en lugar santo;"
,"21":"la vasija de barro en que fue cocida, será quebrada; la de cobre, en cambio, se fregará y lavará con agua."
,"22":"Todo varón de entre los sacerdotes podrá comer la carne de esta víctima, la cual es cosa muy sagrada."
,"23":"En cambio, siempre que la sangre de la víctima por el pecado haya sido introducida en la Tienda de las Citas para hacer la expiación, no se comerá, sino que se echará al fuego."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Esta es la ley de la víctima ofrecida por un el delito: esta víctima es cosa muy santa."
,"2":"La víctima por el delito se sacrificará en el mismo lugar donde se sacrifica la víctima del holocausto y su sangre será derramada en el altar y en su derredor."
,"3":"Ofrecerán la cola y la grasa que cubre las entrañas,"
,"4":"los dos riñones junto con el sebo adherido a ellos y a los lomos, y la telilla del hígado que se separará de los riñones."
,"5":"El sacerdote quemará todo esto sobre el altar como sacrificio por el fuego para Yavé. Este es el sacrificio por el delito."
,"6":"Todo varón de entre los sacerdotes podrá comerlo; se comerá en lugar sagrado, pues es cosa muy santa."
,"7":"El ritual será el mismo para la víctima por el pecado y para la víctima por el delito. La víctima pertenece al sacerdote que hace la expiación."
,"8":"El sacerdote que ofrece un holocausto se queda con la piel de la víctima."
,"9":"Toda ofrenda de flor de harina que fue cocida en horno o tostada en sartén será del sacerdote que la presentó;"
,"10":"en cambio, toda ofrenda amasada en aceite o seca, se dará a todos los hijos de Aarón, en proporciones iguales."
,"11":"Esta es la ley del sacrificio de comunión que se ofrece a Yavé."
,"12":"Si se ofrece en acción de gracias, lo acompañan panes sin levadura amasados con aceite, tortas sin levadura untadas con aceite, y flor de harina amasada y sobada con aceite."
,"13":"Esta ofrenda se añadirá a los buñuelos de masa fermentada y a lo que se ofrece como sacrificio de comunión para dar gracias."
,"14":"De cada una de esas ofrendas se apartará la porción de Yavé, y será del sacerdote que derrama la sangre de las víctimas de comunión."
,"15":"La carne de la víctima de comunión se comerá el mismo día: no quedará nada hasta la mañana."
,"16":"La víctima ofrecida en cumplimiento de un voto, o como ofrenda voluntaria, se comerá el mismo día, pero lo que sobre podrá comerse al otro día."
,"17":"Si al tercer día queda algo de la carne de la víctima, se quemará."
,"18":"El que al tercer día comiere carne del sacrificio de comunión, su sacrificio no sería recibido por Dios, y no sería de ningún provecho para el que lo ofreció; sería una cosa fea y el que la comiere cargaría con un pecado."
,"19":"No se comerá la carne que ha tocado alguna cosa impura, sino que la quemarán. En cuanto a la carne del sacrificio de comunión, cualquier persona que esté pura la podrá comer,"
,"20":"pero si alguien come carne del sacrificio de comunión presentado a Yavé, a pesar de que esté en estado de impureza, ése será borrado de entre los suyos."
,"21":"El que haya tocado cualquier cosa impura, sea de hombre o de animal, o cualquier otra abominación impura, y a pesar de eso coma de la carne del sacrificio de comunión ofrecida a Yavé, será borrado de entre los suyos.'"
,"22":"Yavé habló a Moisés para decirle:"
,"23":"'Habla a los hijos de Israel y diles: No comerán sebo de buey, ni de cordero ni de cabra."
,"24":"La grasa de animal muerto o destrozado podrá servir para cualquier uso, pero no la comerán."
,"25":"El que coma grasa de algún animal que suele ofrecerse en sacrificio por el fuego para Yavé, será borrado de entre los suyos."
,"26":"Cualquiera fuere el lugar donde vivan, no comerán sangre, bien sea de animal, o de ave."
,"27":"Cualquier persona que coma sangre será borrada de entre los suyos.'"
,"28":"Yavé dijo a Moisés:"
,"29":"'Habla a los hijos de Israel y diles: El que presente a Yavé un sacrificio de comunión le regalará una porción del sacrificio."
,"30":"Con sus propias manos llevará lo sacrificado por el fuego para Yavé, o sea, la grasa junto con el pecho, y el pecho será mecido ante Yavé."
,"31":"El sacerdote quemará la grasa sobre el altar; el pecho será para Aarón y sus hijos."
,"32":"Ustedes darán también al sacerdote el pernil derecho de la víctima de comunión."
,"33":"El pernil derecho será de aquel hijo de Aarón que haya ofrecido la sangre y la grasa del sacrificio de comunión."
,"34":"Yo quito a los hijos de Israel, de sus sacrificios de comunión, el pecho que fue mecido y el pernil que fue puesto aparte, para dárselos al sacerdote Aarón y a sus hijos. Este será para siempre derecho suyo entre los hijos de Israel."
,"35":"Esta es la porción de Aarón y de sus hijos en los sacrificios por el fuego para Yavé, desde el día en que sean consagrados como sacerdotes de Yavé."
,"36":"Esto es lo que mandó Yavé que les dieran los hijos de Israel, el día en que fueron consagrados: es un decreto perpetuo de generación en generación."
,"37":"Este es el ritual del holocausto, de la ofrenda, del sacrificio por el pecado y por el delito, y del sacrificio de comunión."
,"38":"Esto es lo que Yavé ordenó a Moisés en el monte, el día en que mandó a los hijos de Israel que presentaran sus ofrendas a Yavé en el desierto de Sinaí.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Yavé habló a Moisés para decirle:"
,"2":"'Toma contigo a Aarón y a sus hijos, y también sus vestiduras, el óleo de la unción, el novillo para el sacrificio por el pecado, los dos carneros y el canastillo de los panes sin levadura."
,"3":"Luego reúne a toda la comunidad a la entrada de la Tienda de las Citas.'"
,"4":"Moisés hizo lo que Yavé le había mandado, y la comunidad se reunió a la entrada de la Tienda de las Citas."
,"5":"Y Moisés dijo a la comunidad: 'Esto es lo que Yavé ha mandado hacer.'"
,"6":"Moisés, entonces, pidió que Aarón y sus hijos se acercaran, y los lavó con agua."
,"7":"Puso sobre Aarón la túnica y se la ajustó con el cinturón, luego lo vistió con el manto; le puso encima el 'Efod' y se lo ajustó con el cinturón del Efod."
,"8":"Luego le puso el escapulario llamado Pectoral, en el que despositó el Urim y el Tumin (o sea, dados para consultar a Yavé)."
,"9":"Le colocó también el turbante en la cabeza, y puso en su parte delantera la lámina de oro: ésta era la corona de santidad que Yavé había mandado a Moisés."
,"10":"Después Moisés tomó el óleo de la unción y ungió la morada de Yavé y la consagró con cuanto había dentro de ella."
,"11":"Roció con el óleo siete veces el altar y lo ungió con todos los utensilios, así como también la pila y su base, para que quedaran consagrados."
,"12":"Moisés derramó oleo sobre la cabeza de Aarón y lo ungió para consagrarlo."
,"13":"Luego mandó que se acercaran los hijos de Aarón, los vistió con las túnicas y se las ajustó con el cinturón; les puso las mitras como Yavé se lo había mandado."
,"14":"Después hizo traer el novillo para el sacrificio por el pecado, y Aarón y sus hijos pusieron las manos sobre la cabeza del novillo."
,"15":"Moisés lo sacrificó. Mojando sus dedos en la sangre, untó con ella las esquinas del altar, para consagrarlo. Después derramó el resto de la sangre al pie del altar; de esta manera lo consagró, haciendo por él la expiación."
,"16":"Moisés tomó luego toda la grasa que cubre las entrañas, el hígado y los dos riñones con su grasa y la quemó sobre el altar."
,"17":"En cuanto al novillo con su piel, carne y excrementos, los quemó fuera del campamento, como Yavé lo había ordenado."
,"18":"Hizo que acercaran el carnero del holocausto, y Aarón y sus hijos le pusieron las manos sobre la cabeza."
,"19":"Moisés lo sacrificó y roció con la sangre el altar y sus alrededores."
,"20":"El carnero fue partido en trozos y Moisés quemó la cabeza, los trozos y las entrañas."
,"21":"Después de lavar en agua las entrañas y las patas, y Moisés quemó todo el carnero en el altar, como holocausto de calmante olor, sacrificio por el fuego para Yavé, como Yavé había mandado a Moisés."
,"22":"Hizo luego traer el segundo carnero, el carnero para la consagración, y Aarón y sus hijos impusieron las manos sobre su cabeza."
,"23":"Moisés lo sacrificó y, tomando su sangre, mojó el lóbulo de la oreja derecha de Aarón, el pulgar de su mano derecha y el pie derecho."
,"24":"Después pidió que se acercaran los hijos de Aarón, les untó con la sangre el lóbulo de la oreja derecha, el pulgar de su mano derecha y el pie derecho. Y derramó la sangre en el altar y en su derredor."
,"25":"Luego tomó la grasa, el rabo, la grasa que cubre las entrañas, la que queda junto al hígado, los dos riñones con su grasa y el pernil derecho."
,"26":"Sacó del canastillo de los panes sin levadura que estaba ante Yavé un pan ázimo, una torta de pan amasada en aceite y otra torta, y las puso sobre la grasa y el pernil derecho."
,"27":"Entregó todo esto en manos de Aarón y en manos de sus hijos, haciéndolas mecer como ofrenda mecida ante Yavé."
,"28":"Moisés la recibió luego de sus manos y la quemó en el altar por encima del holocausto. Este fue el sacrificio de consagración de calmante olor, sacrificio por el fuego para Yavé."
,"29":"Moisés tomó entonces el pecho y lo meció como ofrenda mecida ante Yavé; esta porción del carnero de la consagración fue la parte de Moisés, como Yavé se lo había mandado."
,"30":"Después Moisés tomó el óleo de la unción y sangre de la que había encima del altar y roció a Aarón y sus vestiduras, como también a sus hijos y sus vestiduras. Así, pues, los consagró."
,"31":"Entonces, Moisés dijo a Aarón y a sus hijos: 'Asen la carne en la puerta de la Tienda de las Citas y cómanla allí mismo. Coman también el pan consagrado que está en su canasto tal como lo he mandado, diciendo: Aarón y sus hijos lo comerán;"
,"32":"las sobras de la carne y del pan las quemarán."
,"33":"Ustedes no se apartarán de la entrada de la Tienda de las Citas durante siete días, pues hasta el séptimo día sus manos quedarán consagradas."
,"34":"Moisés añadió: Acabamos de hacer lo que Yavé ordenó: hicimos la expiación por ustedes."
,"35":"Ustedes quedarán día y noche a la entrada de la Tienda de las Citas durante siete días. Ustedes deberán observar estas normas no sea que mueran, pues él mismo lo ordenó así.'"
,"36":"Aarón y sus hijos hicieron todo como Yavé ordenó por boca de Moisés."
}`)
	CurrentBook.AddChapter(9, `{
"1":"El día octavo, Moisés llamó a Aarón y a sus hijos, y a los ancianos de Israel. Entonces dijo a Aarón:"
,"2":"'Trae un ternero para el sacrificio por el pecado y un carnero para el holocausto, ambos sin defecto, para ofrecerlos ante Yavé."
,"3":"Luego hablarás a los hijos de Israel para decirles: Tomen un macho cabrío para el sacrificio por el pecado y un ternero y un cordero, ambos de un año y sin defecto, para el holocausto;"
,"4":"para el sacrificio de comunión, un ternero y un carnero que se sacrificarán ante Yavé; y además una ofrenda amasada con aceite, pues hoy Yavé se manifestará delante de ustedes.'"
,"5":"Trajeron ante la Tienda lo que Moisés había mandado, y toda la comunidad se acercó, quedándose de pie delante de Yavé. Entonces Moisés dijo:"
,"6":"'Esto es lo que Yavé les manda hacer para que se les aparezca la Gloria de Yavé.'"
,"7":"Y Moisés dijo a Aarón: 'Acércate al altar y ofrece tu sacrificio por el pecado y tu holocausto, haciendo así la expiación por ti mismo y por los tuyos. También presenta la ofrenda del pueblo y haz la expiación por ellos, como Yavé lo ha ordenado.'"
,"8":"Acercándose Aarón al altar sacrificó el ternero por su propio pecado."
,"9":"Los hijos de Aarón le presentaron la sangre, y él, mojando su dedo en la sangre, untó con ella los cuernos del altar y derramó el resto de la sangre al pie del altar."
,"10":"Quemó luego la grasa sobre el altar junto con los riñones y la telilla del hígado de la víctima por el pecado, como Yavé había mandado a Moisés,"
,"11":"pero quemó la carne y la piel fuera del campamento."
,"12":"Después sacrificó la víctima del holocausto y los hijos de Aarón le presentaron la sangre, que derramó en el altar y alrededor."
,"13":"Le presentaron la víctima del holocausto en trozos, juntamente con la cabeza, y lo quemó todo sobre el altar."
,"14":"Lavó las entrañas y las patas y las quemó encima del holocausto sobre el altar."
,"15":"Después presentó la ofrenda del pueblo. Tomó el macho cabrío por la expiación por el pueblo. Lo sacrificó como el primero e hizo la expiación."
,"16":"Ofreció el holocausto como ordena el ritual."
,"17":"Además presentó la oblación: tomando un puñado de ella, la quemó en el altar, encima del holocausto de la mañana."
,"18":"Sacrificó asimismo el ternero y el carnero como sacrificios de comunión por el pueblo. Los hijos de Aarón le entregaron la sangre, que él derramó en el altar y en su derredor."
,"19":"En cuanto a las grasas del ternero y del carnero, el rabo, la grasa que cubre las entrañas, los riñones y la telilla del hígado,"
,"20":"las pusieron sobre el pecho de las víctimas, y él las quemó sobre el altar."
,"21":"Aarón meció los pechos y el pernil derecho como ofrenda mecida ante Yavé, conforme Moisés había ordenado."
,"22":"Aarón, levantando las manos hacia el pueblo, lo bendijo, y luego descendió, pues terminaba de ofrecer el sacrificio por el pecado, el holocausto y el sacrificio de comunión."
,"23":"Entonces Moisés y Aarón entraron en la Tienda de las Citas y, cuando salieron, bendijeron al pueblo. En ese instante la Gloria de Yavé se apareció a todo el pueblo:"
,"24":"salió fuego de la presencia de Yavé, que consumió el holocausto y las grasas puestas sobre el altar. Todo el pueblo, al verlo, dio gritos de júbilo y cayó rostro en tierra."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Nadab y Abiohú, hijos de Aarón, tomaron cada uno su incensario, pusieron fuego en ellos y, sobre este fuego, incienso que ofrecieron a Yavé. Pero este fuego no correspondía a sus órdenes."
,"2":"Y en eso, un fuego salió de la presencia de Yavé que los devoró, y murieron allí delante de Yavé."
,"3":"Entonces Moisés dijo a Aarón: 'Esto es lo que Yavé había declarado: Daré a conocer mi santidad a través de los que se allegan a mí, y a vista de todo el pueblo seré glorificado.' Aarón no agregó palabra."
,"4":"Moisés llamó a Misael y Elisafam, hijos de Oziel, tío paterno de Aarón, y les dijo: 'Acérquense y no dejen a sus hermanos delante del santuario, sino que llévenselos fuera del campamento.'"
,"5":"Ellos fueron al momento y llevándolos vestidos como estaban con las túnicas de lino, los sacaron fuera, conforme Moisés les mandó."
,"6":"Entonces Moisés dijo a Aarón y a sus hijos Eleazar e Itamar: 'No lleven la cabeza cubierta ni rasguen sus vestiduras en señal de duelo, no sea que mueran ustedes y el castigo se extienda a toda la comunidad. Más bien son sus hermanos, toda la gente de Israel, quienes harán duelo por el fuego de Yavé."
,"7":"Ustedes no saldrán de la Tienda de las Citas si no quieren morir, pues está sobre ustedes el óleo de la unción de Yavé.' Ellos actuaron en todo conforme al precepto de Moisés."
,"8":"Yavé dijo a Aarón:"
,"9":"'Ni tú ni tus hijos tomen vino ni bebida alcohólica cuando entren a la Tienda de las Citas, no sea que mueran. Esto será un decreto perpetuo para sus descendientes."
,"10":"Así serán capaces de distinguir entre lo santo y lo profano, entre lo impuro y lo puro,"
,"11":"y enseñar a los hijos de Israel todas los ritos que Yavé les ha dado por medio de Moisés.'"
,"12":"Moisés dijo a Aarón, y también a Eleazar e Itamar, los dos hijos que le quedaban: 'Tomen lo que queda de la ofrenda del sacrificio de Yavé y cómanla sin levadura junto al altar por ser cosa muy santa."
,"13":"Ustedes lo comerán en lugar santo, ya que es la parte que te corresponde a ti y tus hijos en los sacrificios por el fuego para Yavé, según se me ha ordenado."
,"14":"Tú, y contigo tus hijos e hijas, comerán también en lugar puro el pecho que ha sido mecido y el pernil que ha sido separado, pues son la parte que te corresponde a ti y tus hijos en los sacrificios de comunión que los hijos de Israel me presentan."
,"15":"Los hijos de Israel traerán además de las grasas que van a ser quemadas, el pernil que fue separado y el pecho que fue mecido. Los mecerán ante Yavé, y luego serán para ti y tus hijos para siempre, según lo ha ordenado Yavé.'"
,"16":"Entretanto Moisés quiso cerciorarse acerca del macho cabrío del sacrificio por el pecado; pero vio que había sido quemado. Se enojó con Eleazar e Itamar, los hijos que le habían quedado a Aarón,"
,"17":"y dijo: '¿Por qué no comieron en lugar sagrado la víctima del sacrificio de expiación? Pues era cosa muy santa que se les daba a ustedes para quitar la falta de la comunidad y para conseguir de Yavé su perdón."
,"18":"Debían haberla comido en lugar sagrado, según les había ordenado, puesto que su sangre no había sido llevada al interior del santuario.'"
,"19":"Aarón respondió a Moisés: 'Es cierto que han presentado hoy delante de Yavé su sacrificio por el pecado y su holocausto; pero después de lo que me ha sucedido, si yo hubiera comido hoy de la víctima por el pecado,"
,"20":"¿acaso hubiera sido esto grato a Yavé?' Al escuchar esto Moisés se dio por satisfecho."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Yavé habló a Moisés y a Aarón, diciéndoles:"
,"2":"'Hablen a los hijos de Israel y díganles: Estos son los animales terrestres que pueden comer."
,"3":"Ustedes comerán el animal de pezuña partida, hendida en dos uñas y que rumia."
,"4":"Pero no comerán el camello que rumia y no tiene dividida la pezuña, sino que será para ustedes impuro."
,"5":"El conejo que rumia, pero no tiene dividida la pezuña, será impuro para ustedes."
,"6":"Lo mismo la liebre."
,"7":"El cerdo, que tiene la pezuña partida, hendida en dos uñas, pero no rumia, será impuro para ustedes."
,"8":"Ustedes no comerán su carne y tampoco tocarán su cadáver: serán impuros para ustedes."
,"9":"Estos son los que hay en el agua y que pueden comer. Ustedes comerán los que tienen aletas y escamas bien vivan en el mar o en los ríos."
,"10":"Pero ustedes tendrán asco a los bichos y los animales que viven en el mar o en los ríos, y que no tienen aletas ni escamas."
,"11":"Ustedes les tendrán asco, no comerán de su carne y tendrán sus cadáveres por inmundos."
,"12":"Ustedes tendrán asco a todos los seres que viven en las aguas y no tienen aletas y escamas."
,"13":"Estas son las aves que tendrán por impuras y que no comerán por ser inmundas:"
,"14":"el águila, el quebrantahuesos en todas sus especies,"
,"15":"toda clase de cuervos,"
,"16":"el avestruz, la lechuza, la gaviota, el gavilán en todas sus especies,"
,"17":"el búho, el somormujo, el ibis,"
,"18":"el cisne, el pelícano, el buitre,"
,"19":"la cigüeña, la garza en todas sus especies, la abubilla y el murciélago."
,"20":"Ustedes tendrán por inmundo a todo insecto alado que anda sobre cuatro patas."
,"21":"Pero, tratándose de los insectos alados que andan sobre cuatro patas, podrán comer aquellos que, además de sus cuatro patas, tienen piernas para saltar sobre el suelo."
,"22":"De ellos podrán comer: la langosta en sus diversas especies y toda clase de solam, de jargol y de jagab."
,"23":"Cualquier otro insecto alado de cuatro patas será para ustedes impuro."
,"24":"Con sólo tocar estos animales, ustedes contraerán impureza. El que toque su cadáver quedará impuro hasta la tarde."
,"25":"El que levante alguno de sus cadáveres tendrá que lavar sus vestidos y quedará impuro hasta la tarde."
,"26":"Ustedes tendrán por impuros a todos los animales que tienen pezuña no partida en dos uñas y no rumian; todo aquel que los toque quedará impuro."
,"27":"Ustedes tendrán por impuros a todos los cuadrúpedos que andan sobre las plantas de sus patas."
,"28":"El que toque sus cadáveres quedará impuro hasta la tarde. El que levante el cadáver de uno de ellos tendrá que lavar sus vestidos, y quedará impuro hasta la tarde. Estos animales son impuros para ustedes."
,"29":"Estos son los reptiles que andan arrastrándose por el suelo y que serán impuros para ustedes: la comadreja, el ratón, el lagarto en sus diversas especies,"
,"30":"la musaraña, el camaleón, la salamandra, la lagartija y el topo."
,"31":"Ustedes tendrán por impuros a todos esos reptiles. El que toque sus cadáveres quedará impuro hasta la tarde."
,"32":"Quedará impuro cualquier objeto sobre el que caiga uno de sus cadáveres, ya sea un artefacto de madera, o un vestido, una piel, un saco o cualquier utensilio. Será metido en agua y quedará impuro hasta la tarde; después quedará puro."
,"33":"Si cae uno de estos cadáveres en una vasija de barro, cuanto haya dentro de ella quedará impuro y habrá que romper la vasija."
,"34":"Toda cosa comestible preparada con dicha agua será impura y toda bebida que se tome en una de esas vasijas será impura."
,"35":"Cualquier objeto sobre el que caiga alguno de esos cadáveres quedará impuro: el horno y el doble fogón serán derribados; son impuros y los tendrán por impuros"
,"36":"(solamente las fuentes y pozos donde se recogen las aguas permanecerán puras), pero el que toque sus cadáveres quedará impuro."
,"37":"Si alguno de esos cadáveres cae sobre semillas que han de sembrarse, quedarán puras;"
,"38":"pero si cae sobre semilla mojada, la tendrán por impura."
,"39":"Cuando muera uno de esos animales de los que puedan comer, el que toque sus cadáveres quedará impuro hasta la tarde."
,"40":"El que coma de su cadáver deberá lavar sus vestidos y quedará impuro hasta la tarde; el que levante un cadáver habrá de lavar sus vestidos y quedará impuro hasta la tarde."
,"41":"Tendrán por inmundo todo reptil que anda arrastrándose sobre la tierra; es cosa inmunda; no se podrá comer."
,"42":"No comerán aquellos que caminan sobre su vientre o que se arrastran por el suelo sobre cuatro patas o sobre muchas patas; ustedes los tendrán por inmundos."
,"43":"No se hagan inmundos con ninguno de estos reptiles que se arrastran: no se hagan impuros con ellos ni dejen que a ustedes los hagan impuros."
,"44":"Porque yo soy Yavé, Dios de ustedes; santifíquense y sean santos, pues yo soy Santo. No se hagan impuros con ninguno de esos reptiles que se arrastran por el suelo,"
,"45":"pues yo soy Yavé, el que los ha sacado del país de Egipto para ser su Dios. Sean, pues, santos porque yo soy Santo."
,"46":"Esta es la ley acerca de los animales, de las aves, y de todos los seres vivientes que se mueven en el agua, y de todos los que andan arrastrándose sobre la tierra."
,"47":"Sepan distinguir entre lo impuro y lo puro, entre el animal que puede comerse y el que no.'"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Yavé habló a Moisés para decirle:"
,"2":"'Habla a los hijos de Israel y diles: Cuando una mujer conciba y tenga un hijo varón, quedará impura durante siete días, igual que en el tiempo de sus reglas."
,"3":"El niño será circuncidado en su carne al octavo día,"
,"4":"pero ella esperará treinta y tres días para ser purificada de su sangre. No tocará ninguna cosa santa, ni entrará en el santuario, hasta que se cumplan los días de su purificación."
,"5":"Si dio a luz una niña, estará impura dos semanas, y lo mismo será doble el tiempo de su purificación: esperará sesenta y seis días la purificación de su sangre."
,"6":"Al cumplirse los días de su purificación, sea por niño o niña, presentará al sacerdote, a la entrada de la Tienda de las Citas, un cordero de un año como holocausto, y un pichón o una tórtola como sacrificio por el pecado."
,"7":"El sacerdote lo ofrecerá ante Yavé haciendo expiación por ella, y quedará purificada del flujo de su sangre. Esta es la ley referente a la mujer que da a luz a un niño o una niña."
,"8":"Si la mujer no puede ofrecer una res menor, ofrecerá dos tórtolas o dos pichones, uno como holocausto y otro como sacrificio por el pecado; el sacerdote hará expiación por ella y quedará pura.'"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Yavé habló a Moisés y a Aarón, diciendo:"
,"2":"'Cuando uno tenga en su piel tumor, erupción o mancha blanca y se forme en su piel como una llaga de lepra, será llevado al sacerdote Aarón o a uno de sus hijos, los sacerdotes."
,"3":"El sacerdote examinará la llaga; si el pelo en la llaga se ha vuelto blanco, y la llaga parece hundida en la piel, es llaga de lepra; cuando el sacerdote lo haya comprobado, lo declarará impuro."
,"4":"Pero si hay en la piel una mancha blanca que no parezca hundida en la piel, y si el pelo no se ha vuelto blanco, el sacerdote recluirá durante siete días al afectado."
,"5":"Al séptimo día lo examinará y, si comprueba que la llaga subsiste pero no se ha extendido por la piel, el sacerdote lo recluirá otros siete días."
,"6":"Pasados estos días lo volverá a examinar; si ve que la llaga ha perdido su color y no se ha extendido en la piel, el sacerdote lo declarará puro; no se trata más que de una erupción. El afectado lavará sus vestidos y será puro."
,"7":"Pero si sigue la erupción y se extiende por la piel, el sacerdote lo examinará de nuevo."
,"8":"El sacerdote, al comprobar que la erupción se extiende por la piel, lo declarará impuro. Es un caso de lepra."
,"9":"En cuanto una persona tenga una llaga de lepra, la llevarán al sacerdote."
,"10":"El la examinará y, si observa un tumor blanco en la piel, si el pelo se ha vuelto blanco y se nota una úlcera en la hinchazón,"
,"11":"se trata de lepra arraigada en su piel; el sacerdote lo declarará impuro sin esperar más, porque es impuro."
,"12":"Si la lepra se ha desarrollado sobre la piel hasta cubrirla de la cabeza hasta los pies, por cuanto el sacerdote alcance a verlo,"
,"13":"éste lo examinará. A pesar de que esa lepra cubra todo el cuerpo, declarará pura la persona. Con tal de que todo sea blanco, la persona es pura."
,"14":"Pero en cuanto se vea una llaga, será impura."
,"15":"Si el sacerdote ve una llaga la declarará impura. La llaga significa impureza y lepra."
,"16":"Pero si la llaga cambia, volviéndose blanca, el afectado ha de presentarse al sacerdote."
,"17":"Este lo examinará y, si la llaga se ha vuelto blanca, lo declarará puro: porque es puro."
,"18":"Cuando alguien lleva en la carne o en la piel una úlcera, puede ser que sane la úlcera;"
,"19":"pero si en su lugar aparece un tumor blanco, o una mancha blanca y rojiza, entonces la persona tendrá que presentarse al sacerdote."
,"20":"Este la examinará y, si la mancha parece hundida en la piel y su pelo se ha vuelto blanco, el sacerdote la declarará impura: una llaga de lepra se ha desarrollado en la úlcera."
,"21":"Pero, si el sacerdote ve que no hay pelo blanco en la mancha ni está hundida en la piel, y que se ha secado, recluirá la persona por siete días."
,"22":"Si entonces la mancha se extiende por la piel, el sacerdote declarará la persona impura; es un caso de lepra."
,"23":"Si, en cambio, la mancha no se ha extendido, es la cicatriz de la úlcera; el sacerdote declarará la persona pura."
,"24":"Cuando alguien haya tenido una quemadura de la piel, y ésta se haya curado formándose una mancha de color blanco o rojizo,"
,"25":"el sacerdote la examinará; si el pelo se ha vuelto blanco, y la mancha parece hundida en la piel, es que se ha producido lepra en la quemadura. El sacerdote declarará la persona impura: es un caso de lepra."
,"26":"Si, en cambio, ve que no aparece pelo blanco en la mancha, que no está hundida la piel, recluirá la persona siete días."
,"27":"Al séptimo día la examinará, y, si se ha extendido por la piel, la declarará impura; es lepra."
,"28":"Pero, si la mancha no se ha extendido y ha perdido color, se trata de la costra de la quemadura; el sacerdote declarará la persona pura, pues es la cicatriz de la quemadura."
,"29":"Cuando un hombre o una mujer tengan una llaga en la cabeza o en la barbilla,"
,"30":"el sacerdote examinará la llaga, y si ésta parece hundida en la piel, y si hay en ella pelo amarillento y más ralo, el sacerdote lo declarará impuro; es tiña, o sea, lepra de la cabeza o de la barbilla."
,"31":"Pero, si el sacerdote ve que la llaga no parece hundida en la piel y no hay en ella pelo amarillo, recluirá la persona por siete días."
,"32":"Al séptimo día el sacerdote examinará el mal, y, si no se ha extendido la tiña y no hay pelo amarillento, ni la llaga parece más hundida que la piel,"
,"33":"aquella persona se afeitará menos en el lugar de la tiña, y el sacerdote la recluirá otra vez por siete días."
,"34":"Al séptimo día la examinará y, si no se ha extendido la llaga por la piel, ni aparece más hundida que la piel, la declarará pura."
,"35":"Si esa tiña, después de esta declaración, se va extendiendo por la piel,"
,"36":"el sacerdote, al comprobar que la tiña se ha extendido, ya no tendrá que buscar pelo amarillento; aquella persona es impura."
,"37":"Pero, si le parece que la tiña no se ha extendido y ha brotado en ella pelo negro, esa persona ha sanado de la tiña: es pura, y así lo declarará el sacerdote."
,"38":"Cuando un hombre o una mujer tengan en su piel manchas brillantes blancas,"
,"39":"el sacerdote las examinará; si comprueba que las manchas de la piel son de color blanco, se trata de una eczema que ha brotado en la piel; esta persona es pura."
,"40":"Si a alguno se le cae el pelo de la cabeza y queda calvo, es puro."
,"41":"Si se le cae el pelo por la parte delantera de la cabeza, es un calvo por delante; queda puro."
,"42":"Pero si en la calva, por detrás o por delante, aparece una llaga de color blanco rojizo, es lepra que se ha producido en la calva, sea por detrás o por delante."
,"43":"El sacerdote lo examinará y, si la hinchazón de la llaga en la parte calva es de color blanco rojizo, con aspecto de lepra en la piel,"
,"44":"se trata de un leproso, es impuro. El sacerdote lo declarará impuro: tiene lepra en la cabeza."
,"45":"El leproso que tiene llaga de lepra llevará los vestidos rasgados e irá despeinado; se cubrirá hasta el bigote y tendrá que gritar: '¡Impuro, impuro!'"
,"46":"Todo el tiempo que dure la llaga, quedará impuro y, siendo impuro, vivirá solo; se quedará fuera del campamento."
,"47":"Cuando aparezca una llaga de lepra en un vestido de lana o de lino,"
,"48":"sea en la urdimbre o en la trama del lino o lana, o en una piel o en cualquier objeto de cuero,"
,"49":"si la mancha en el vestido o en la piel, en la urdimbre o en la trama, o en cualquier objeto hecho de cuero tiene color verdoso o rojizo, es llaga de lepra y debe ser mostrada al sacerdote."
,"50":"El sacerdote examinará la mancha y encerrará el objeto manchado durante siete días."
,"51":"Al séptimo, el sacerdote examinará la mancha y, si se ha extendido por el vestido, sea en la urdimbre o en la trama, por la piel o por un objeto de cuero, es un caso de lepra maligna;"
,"52":"será quemado."
,"53":"Si el sacerdote ve que la mancha no se ha extendido por el vestido, en la urdimbre o en la trama o por el objeto de cuero,"
,"54":"hará lavar el objeto manchado y lo encerrará otros siete días."
,"55":"Si el sacerdote ve que la mancha, después de haber sido lavada, no ha cambiado de aspecto, el objeto es impuro, aun en caso de que la mancha no se haya extendido. Lo entregarás al fuego: es una corrosión por la cara o por detrás."
,"56":"En cambio, si el sacerdote ve que la parte manchada, después de lavada, ha perdido color, la rasgará del vestido, del cuero, de la urdimbre o de la trama."
,"57":"Pero si vuelve a aparecer en el vestido, en la urdimbre o en la trama, en el objeto de cuero, ha vuelto la lepra, por lo que quemarás el objeto que está afectado."
,"58":"El vestido, la urdimbre o la trama o el objeto de cuero que después de ser lavados pierdan la mancha, serán lavados por segunda vez y quedarán puros."
,"59":"Esta es la ley para la mancha de lepra que se halla en los vestidos de lana o de lino, en la urdimbre o en la trama o en cualquier objeto hecho de cuero, para declararlos puros e impuros.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Yavé habló a Moisés y le dijo:"
,"2":"'Esta es la ley para el día de la purificación del leproso, cuando lo lleven al sacerdote."
,"3":"El sacerdote saldrá fuera del campamento para examinarlo y comprobar que la llaga de la lepra ha sido sanada."
,"4":"El sacerdote mandará traer para el que ha de ser purificado dos pájaros vivos y puros, madera de cedro, escarlata e hisopo."
,"5":"Después mandará sacrificar uno de los pájaros sobre una vasija de barro con agua fresca."
,"6":"Tomará luego el pájaro vivo, la madera de cedro, la escarlata y el hisopo, y los mojará, incluso el pájaro vivo, en la sangre del pájaro inmolado sobre el agua fresca."
,"7":"Rociará siete veces al que ha de ser purificado de la lepra, y tras declararlo puro, soltará en el campo el pájaro vivo."
,"8":"El que ha sido purificado lavará sus vestidos, se afeitará todo su pelo, se bañará en agua y quedará puro, y luego volverá al campamento. Pero tiene que quedarse primero siete días fuera de su tienda,"
,"9":"y es al día séptimo cuando se afeitará todo el pelo, la cabellera, la barba y las cejas, es decir, se afeitará todo su pelo; lavará también sus vestidos, bañará su cuerpo en agua y quedará limpio."
,"10":"El día octavo tomará dos corderos sin defecto y una oveja de un año sin defecto; y como oblación tres décimas de flor de harina amasada con aceite y un cuartillo de aceite."
,"11":"El sacerdote que hace la purificación presentará a la persona que se purifica, junto con todas esas cosas, a la entrada de la Tienda de las Citas, delante de Yavé."
,"12":"El sacerdote tomará uno de los corderos para ofrecerlo como sacrificio por el delito, además del cuartillo de aceite, y lo mecerá como ofrenda ante Yavé."
,"13":"Luego sacrificará el cordero en el lugar donde se sacrifica el sacrificio por el pecado y el holocausto, en lugar puro; porque la víctima por el pecado, tanto como la víctima por el delito, pertenece al sacerdote: es una cosa muy santa."
,"14":"Después el sacerdote tomará sangre de la víctima de reparación y mojará el lóbulo de la oreja derecha del que se está purificando, el pulgar de su mano derecha y el de su pie derecho."
,"15":"Y, tomando el cuartillo de aceite, el sacerdote echará parte del aceite en la palma de su mano izquierda."
,"16":"Después untará el dedo de su mano derecha en el aceite que tiene en su mano izquierda, y con su dedo hará siete aspersiones de aceite delante de Yavé."
,"17":"Con el aceite restante que tiene en su mano, el sacerdote untará el lóbulo de la oreja derecha del que se purifica, el pulgar de su mano derecha y el de su pie derecho, sobre la sangre de la víctima de reparación."
,"18":"Y el aceite que quede en la mano del sacerdote, lo echará sobre la cabeza del que se purifica haciendo en esta forma la expiación por él ante Yavé."
,"19":"El sacerdote ofrecerá el sacrificio por el pecado y hará su reparación por el que se purifica de su impureza; después inmolará el holocausto,"
,"20":"y ofrecerá sobre el altar el holocausto y la oblación. De esta manera el sacerdote hará la súplica por él y quedará limpio."
,"21":"Si el leproso es demasiado pobre para pagar todo eso, tomará un solo cordero como sacrificio de reparación, como ofrenda mecida para hacer reparación por él, y además como oblación una décima de flor de harina amasada con aceite, un cuartillo de aceite"
,"22":"y dos tórtolas o dos pichones, según sus recursos, uno como sacrificio por el pecado y otro como holocausto."
,"23":"Al octavo día, los llevará al sacerdote, a la entrada de la Tienda de las Citas, para su purificación delante de Yavé."
,"24":"El sacerdote tomará el cordero del sacrificio por el delito y el cuartillo de aceite, y los mecerá como ofrenda ante Yavé."
,"25":"Después de haber sacrificado el cordero del sacrificio por el delito, el sacerdote tomará sangre de la víctima de reparación y mojará el lóbulo de la oreja derecha del que se purifica y el pulgar de su mano derecha y el de su pie derecho."
,"26":"Luego derramará parte del aceite sobre la palma de su mano izquierda;"
,"27":"con un dedo de su mano derecha hará ante Yavé siete aspersiones con el aceite que tiene en la palma de la mano izquierda;"
,"28":"untará con el aceite que tiene en su mano el lóbulo de la oreja derecha del que se purifica, el pulgar de su mano derecha y el del pie derecho, en el lugar donde puso la sangre de la víctima por el delito."
,"29":"Derramará el resto del aceite que le quede en la mano sobre la cabeza del que se purifica, haciendo reparación por él ante Yavé."
,"30":"Luego sacrificará una de las tórtolas o pichones,"
,"31":"según los recursos del que ofrece, uno como sacrificio del pecado y otro como holocausto, además de la oblación. De este modo el sacerdote hará la expiación ante Yavé por aquel que se purifica."
,"32":"Esta es la ley de purificación para el leproso de escasos recursos.'"
,"33":"Yavé habló a Moisés y a Aarón y les dijo:"
,"34":"'Cuando hayan entrado en la tierra de Canaán que yo les daré en posesión, si yo castigo con la lepra alguna de las casas de la tierra que van a poseer,"
,"35":"el propietario de la casa irá a avisarle al sacerdote diciendo: 'He visto en mi casa algo que parece lepra.'"
,"36":"Antes de ir para examinar esa plaga, el sacerdote ordenará que desocupen la casa, no sea que lo que hay en ella pase a ser impuro. Después irá a examinar la casa."
,"37":"Si ve que la llaga está en las paredes de la casa en forma de cavidades verdosas y rojizas que parecen hundidas en la pared,"
,"38":"el sacerdote saldrá a la puerta de la casa y la cerrará durante siete días."
,"39":"Volverá al día séptimo y si comprueba que la mancha se ha extendido por las paredes,"
,"40":"mandará arrancar las piedras manchadas y arrojarlas fuera de la ciudad en un lugar impuro."
,"41":"Hará raspar todo el interior de la casa, y echará fuera de la ciudad, en un lugar impuro, el polvo que hayan quitado."
,"42":"Luego tomarán piedras y las colocarán en el lugar de las primeras, y también mezcla nueva para revocar la casa."
,"43":"Si la mancha vuelve a extenderse por la casa después de haber arrancado las piedras y de haberlas raspado y revocado,"
,"44":"el sacerdote entrará de nuevo; y si comprueba que la mancha se ha extendido por la casa, hay un caso de lepra maligna en la casa y está impura."
,"45":"En este caso se derribará la casa. Sus piedras, sus maderas y todo el material de la casa serán sacados fuera de la ciudad a un lugar impuro."
,"46":"Quien entre en esa casa durante el tiempo que esté clausurada quedará impuro hasta la tarde."
,"47":"El que duerma en ella habrá de lavar sus vestidos, como también el que coma en ella."
,"48":"Pero si el sacerdote comprueba al entrar que, después de revocada la casa, la mancha no se ha extendido por ella, la declarará pura, pues ha sanado del mal."
,"49":"Entonces ofrecerá por la casa un sacrificio por el pecado; tomará dos pájaros, madera de cedro, escarlata e hisopo;"
,"50":"sacrificará uno de los pájaros sobre una vasija de barro con agua fresca,"
,"51":"y tomando la madera de cedro, el hisopo y escarlata, con el pájaro vivo, los mojará en la sangre del pájaro sacrificado y en el agua fresca; luego rociará la casa siete veces."
,"52":"Así hará la expiación por la casa con la sangre del pájaro, el agua fresca, el pájaro vivo, la madera de cedro, el hisopo y la escarlata."
,"53":"Luego soltará el pájaro vivo fuera de la ciudad, en el campo. De este modo hará reparación por la casa, la cual quedará pura."
,"54":"Esta es la ley para todo tipo de lepra o tiña,"
,"55":"para la lepra del vestido y de la casa,"
,"56":"para los tumores, erupciones y manchas."
,"57":"Con esto se sabrá cuándo uno es puro o impuro. Esta es la ley de la lepra.'"
}`)
	CurrentBook.AddChapter(15, `{
"1":"Yavé habló a Moisés y a Aarón para decirles:"
,"2":"'Hablen a los hijos de Israel y díganles: Cualquier persona que padezca un derrame es impura por este derrame."
,"3":"Y ésta es la ley de la impureza por algún derrame: sea que su cuerpo deje destilar el derrame o lo retenga, es impuro."
,"4":"Toda cama en que duerma el que padece derrame será impura."
,"5":"Quien toque esta cama deberá lavar sus vestidos y luego bañarse, y quedará impuro hasta la tarde."
,"6":"Quien se siente en un mueble donde se haya sentado cualquiera que padezca derrame, deberá lavar sus vestidos y luego bañarse en agua, y será impuro hasta la tarde."
,"7":"Quien toque el cuerpo del que padece derrame lavará sus vestidos, se bañará y será impuro hasta la tarde."
,"8":"Si el que tiene derrame escupe sobre un hombre puro, éste deberá lavar sus vestidos y luego bañarse, y quedará impuro hasta la tarde."
,"9":"Todo aparejo sobre el que haya montado el que padece derrame será impuro."
,"10":"Si otra persona toca un objeto que ha estado debajo de él, quedará impura hasta la tarde; si lleva este objeto, tendrá que lavar sus vestidos y luego bañarse y será impura hasta la tarde."
,"11":"Todo aquel a quien toque el que padece derrame, si no se lava las manos, deberá lavar sus vestidos y luego bañarse, y quedará impuro hasta la tarde."
,"12":"Toda vasija de barro tocada por el que padece derrame será rota y todo utensilio de madera será lavado en agua."
,"13":"Para ser purificada de su derrame, esta persona deberá contar siete días; después lavará sus vestidos, se bañará en agua fresca y quedará pura."
,"14":"Al octavo día tomará dos tórtolas o dos pichones y se presentará ante Yavé a la entrada de la Tienda de las Citas para entregarlos al sacerdote."
,"15":"Este los ofrecerá, uno como sacrificio por el pecado, el otro como holocausto; así el sacerdote hará la expiación ante Yavé por esa persona y por su derrame."
,"16":"El hombre que tenga derrame seminal lavará con agua todo su cuerpo y quedará impuro hasta la tarde."
,"17":"Toda ropa y todo cuerpo sobre los cuales se haya derramado el semen serán lavados con agua y quedarán impuros hasta la tarde."
,"18":"Cuando una mujer ha tenido relaciones sexuales con un hombre, ambos deben lavarse con agua y quedan impuros hasta la tarde."
,"19":"La mujer que ha tenido sus reglas será impura por espacio de siete días, por ser un derrame de sangre de su cuerpo. Quien la toque será impuro hasta la tarde."
,"20":"Todo aquello en que se acueste durante su impureza quedará impuro, lo mismo que todo aquello sobre lo que se siente."
,"21":"Quien toque su cama deberá lavar sus vestidos y luego bañarse, y permanecerá impuro hasta la tarde."
,"22":"Quien toque un asiento sobre el que se ha sentado deberá lavar sus vestidos y luego bañarse, y quedará impuro hasta la tarde."
,"23":"Quien toque algo que se puso sobre el lecho o sobre el mueble donde ella se ha sentado quedará impuro hasta la tarde."
,"24":"Si un hombre se acuesta con ella a pesar de su impureza, comparte su impureza y queda impuro siete días; toda cama en que él se acueste será impura."
,"25":"Si una mujer tiene derrame de sangre durante muchos días, fuera del tiempo de sus reglas, o si éstas se prolongan, quedará impura durante todo este tiempo, como en los días del derrame menstrual."
,"26":"Toda cama en que se acueste mientras dure su derrame será impura, como la cama en la que estuvo en tiempo de sus reglas, y cualquier mueble sobre el que se siente quedará impuro igual."
,"27":"Quien los toque quedará impuro; deberá lavar sus vestidos y bañarse, y quedará impuro hasta la tarde."
,"28":"Una vez que sane de su derrame, contará siete días, quedando después pura."
,"29":"Al octavo día tomará para sí dos tórtolas o dos pichones y los presentará al sacerdote a la entrada de la Tienda de las Citas."
,"30":"Este los ofrecerá, uno como sacrificio por el pecado y el otro como holocausto, y hará la expiación por ella ante Yavé, por el derrame que la hacía impura."
,"31":"Ustedes pondrán sobre aviso a los hijos de Israel respecto de sus impurezas, no sea que mueran debido a ellas, en el caso de que contaminen mi Morada, que está en medio de ellos."
,"32":"Esta es la ley referente al hombre que padece derrame o que es impuro debido a un derrame seminal,"
,"33":"a la mujer que ha tenido su derrame menstrual, a aquel que padece de derrame, sea varón o mujer, y a aquel que se acueste con una mujer en período de impureza.'"
}`)
	CurrentBook.AddChapter(16, `{
"1":"Yavé habló a Moisés después de la muerte de los dos hijos de Aarón, los que murieron al acercarse a Yavé."
,"2":"Le dijo: 'Di a tu hermano Aarón que no entre en cualquier tiempo en el Santuario que está detrás del velo, ni se presente ante el lugar del Perdón que está encima del Arca, no sea que muera, pues es allí donde yo me manifiesto en medio de la nube, encima del Lugar del Perdón."
,"3":"Para que pueda entrar en el Santuario, Aarón deberá procurarse un novillo para el sacrificio por el pecado y un carnero para el holocausto."
,"4":"Se vestirá con la túnica sagrada de lino, se pondrá los calzoncillos de lino, se ceñirá la faja de lino y se cubrirá con el turbante de lino. Estas son las vestiduras sagradas que vestirá después de haberse lavado con agua."
,"5":"Recibirá de la comunidad de los hijos de Israel dos machos cabríos para el sacrificio por el pecado y un carnero para el holocausto."
,"6":"Al ofrecer su novillo por el pecado, hará la expiación por sí mismo y por los de su familia."
,"7":"Luego tomará los dos machos cabríos y los presentará ante Yavé a la entrada de la Tienda de las Citas."
,"8":"Aarón echará suertes sobre los dos machos cabríos, uno para Yavé y otro para Azazel."
,"9":"Presentará el macho cabrío sobre el cual haya caído la suerte para Yavé y lo ofrecerá como sacrificio por el pecado."
,"10":"El macho cabrío sobre el cual haya caído la suerte para Azazel, será llevado vivo delante de Yavé, harán sobre él el rito de expiación y lo echarán al desierto, hacia Azazel."
,"11":"Aarón presentará el novillo que trajo para el sacrificio por el pecado, haciendo la expiación por sí mismo y por los de su casa. Luego lo sacrificará."
,"12":"Tomará del altar que está ante Yavé un incensario lleno de brasas y dos puñados de incienso aromático en polvo"
,"13":"y lo llevará todo detrás del velo. Pondrá el incienso sobre el fuego delante de Yavé de manera que la nube del incienso envuelva el Lugar del Perdón que está encima del Arca, no sea que muera."
,"14":"Luego, tomando la sangre del novillo, rociará con su dedo la parte delantera del Lugar del Perdón. Hará siete aspersiones de sangre con su dedo delante del lugar del Perdón."
,"15":"Después sacrificará el macho cabrío que fue reservado para el sacrificio por el pecado del pueblo, y llevará su sangre detrás del velo. Haciendo con su sangre lo mismo que hizo con la sangre del novillo, rociará el Lugar del Perdón en su parte anterior."
,"16":"Así hará la expiación por el Santuario, debido a las impurezas de los hijos de Israel, a sus faltas y a todos sus pecados. Así hará por la Tienda de las Citas, que mora con ellos en medio de sus impurezas."
,"17":"No habrá nadie en la Tienda de las Citas cuando Aarón entre en el Santuario para hacer la expiación, hasta que salga. Después de hacer la expiación por sí, por los de su familia y por toda la comunidad de Israel,"
,"18":"saldrá hacia el altar que está ante Yavé y hará sobre él la expiación. Tomará sangre del novillo y del macho cabrío que esparcirá en su derredor después de untar los cuernos del altar."
,"19":"Hará con su dedo siete aspersiones de sangre sobre el altar, y así lo purificará de las impurezas de los hijos de Israel y lo santificará."
,"20":"Acabada la expiación del Santuario, de la Tienda de las Citas y del altar, Aarón presentará el macho cabrío vivo."
,"21":"Imponiendo ambas manos sobre la cabeza del macho cabrío vivo, hará confesión sobre él de todos los pecados de los hijos de Israel, tanto de sus maldades como de sus faltas. Y después de cargarlas sobre la cabeza del macho cabrío, lo enviará al desierto por medio de un ayudante."
,"22":"Así el macho cabrío llevará sobre sí todas las maldades de ellos hacia un lugar árido, y el que lo lleve lo soltará en el desierto."
,"23":"Luego entrará Aarón en la Tienda de las Citas y, despojándose de las vestiduras de lino con que se había vestido al entrar en el Santuario, las dejará allí."
,"24":"Entonces lavará su cuerpo con agua en un lugar sagrado y se pondrá sus vestiduras. Y saldrá para ofrecer su holocausto y el holocausto del pueblo; luego hará la expiación por sí mismo y por el pueblo"
,"25":"y quemará sobre el altar el sebo de la víctima por el pecado."
,"26":"El hombre encargado de soltar el macho cabrío para Azazel se bañará y lavará sus vestidos en agua; después volverá al campamento."
,"27":"En cuanto al novillo del sacrificio por el pecado y el macho cabrío inmolado por el pecado, cuya sangre fue introducida en el Santuario para hacer la expiación, serán sacados fuera del campamento y quemarán con fuego sus pieles, su carne y sus excrementos."
,"28":"El que los queme deberá lavar sus vestidos y bañarse; entonces volverá al campamento."
,"29":"Este será para ustedes un rito perpetuo. En el mes séptimo, el día décimo, ustedes ayunarán y no harán trabajo alguno, tanto el israelita como el forastero que viva con ustedes."
,"30":"En este día se hará expiación por ustedes; así serán purificados y quedarán limpios de todos sus pecados ante Yavé."
,"31":"Será para ustedes un sábado muy solemne en el que ayunarán. Esta es una ley perpetua."
,"32":"El sacerdote al que hayan ungido y consagrado para ser sacerdote en lugar de su padre, hará la expiación. Se vestirá con las vestiduras de lino, las vestiduras sagradas, y hará el rito de expiación por el Santuario Sagrado, por la Tienda de las Citas y el altar."
,"33":"Lo hará también por los sacerdotes y por toda la comunidad del pueblo."
,"34":"Esta será para ustedes una ley perpetua. Una vez al año harán el rito de expiación por todos los pecados de los Israelitas.',Y lo hicieron como Yavé había mandado a Moisés."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Yavé dijo a Moisés:"
,"2":"'Habla a Aarón y a sus hijos y a todos los hijos de Israel y diles: Esta es la orden que ha dado Yavé:"
,"3":"Cualquier hombre del pueblo de Israel que sacrifique un ternero, una oveja o una cabra dentro del campamento o fuera del mismo,"
,"4":"y no lo lleve a la entrada de la Tienda de las Citas para presentarlo como ofrenda a Yavé ante su Morada, será considerado como reo de sangre. Y por haber derramado sangre, será borrado de su pueblo."
,"5":"Los hijos de Israel no sacrificarán más sus víctimas en el campo, sino que las traerán al sacerdote, a la entrada de la Tienda de las Citas. Allí las ofrecerán a Yavé como sacrificios de comunión."
,"6":"El sacerdote derramará la sangre sobre el altar de Yavé a la entrada de la Tienda de las Citas y quemará las grasas como calmante olor para Yavé."
,"7":"De este modo ellos ya no seguirán ofreciendo sacrificios a esos chivos a los que servían y tras los cuales se prostituían. Este será un decreto perpetuo para ellos, de generación en generación."
,"8":"Y les dirás también: Si un israelita o uno de los forasteros que viven en medio de ustedes ofrece un holocausto u otro sacrificio,"
,"9":"y no lo lleva a la entrada de la Tienda de las Citas para ofrecerlo a Yavé, ése será borrado de entre los suyos."
,"10":"Si un hombre de Israel o de los forasteros que viven en medio de ustedes come cualquier clase de sangre, aborreceré a esta persona que come sangre y la exterminaré."
,"11":"Porque el alma de todo ser viviente está en su sangre, y yo les di la sangre para que la lleven al altar para el rescate de sus almas, pues esta sangre paga la deuda del alma."
,"12":"Por eso he dicho a los hijos de Israel: 'Ninguno de ustedes comerá sangre, ni tampoco el forastero que viva entre ustedes.'"
,"13":"Si un hombre de Israel, o alguno de los extranjeros que viven en medio de ustedes, caza un animal o ave que está permitido comer, derramará su sangre y la cubrirá con tierra."
,"14":"Porque la sangre de todo ser viviente es su misma alma. Por eso mandé a los hijos de Israel: 'No comerán la sangre de ningún animal, pues la sangre es su alma misma.' El que la coma será eliminado."
,"15":"Toda persona nacida en el país, o todo forastero que haya comido carne de animal muerto o destrozado deberá lavar sus vestidos y bañarse en agua, y quedará impuro hasta la tarde; después será puro."
,"16":"Si no los lava ni se baña, cargará con su falta.'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Yavé dijo a Moisés:"
,"2":"'Habla a los hijos de Israel; les dirás: Yo soy Yavé, tu Dios."
,"3":"No hagan lo que se hace en la tierra de Egipto, donde ustedes han vivido, ni hagan lo que se hace en la tierra de Canaán, hacia donde los llevo. Ustedes no seguirán sus tradiciones."
,"4":"Son mis decisiones las que seguirán, y mis tradiciones las que guardarán, viviendo de acuerdo a ellas, pues Yo soy Yavé."
,"5":"Guarden mis tradiciones y mis decisiones, pues el que las cumpla vivirá gracias a ellas: ¡Yo soy Yavé!"
,"6":"Ninguno de ustedes se acercará a una pariente directa para tener relaciones con ella: ¡Yo soy Yavé!"
,"7":"No tendrás relaciones con tu padre ni con tu madre. ¡Piensa que es tu madre!: no tendrás relaciones con ella."
,"8":"No tendrás relaciones con la mujer de tu padre. ¡Respeta a tu padre! No tengas relaciones con ella."
,"9":"No tendrás relaciones con tu hermana, hija de tu padre o de tu madre, nacida en casa o fuera de ella."
,"10":"No tendrás relaciones con las hijas de tu hijo o de tu hija, pues son de tu misma sangre."
,"11":"No tendrás relaciones con tu hermana, hija de tu padre aunque de otra madre. Respeta a tu hermana: no tendrás relaciones con ella."
,"12":"No tendrás relaciones con la hermana de tu padre: respeta en ella a tu padre."
,"13":"No tendrás relaciones con la hermana de tu madre: respeta en ella a tu madre."
,"14":"Respeta al hermano de tu padre, y no tengas relaciones con su mujer, pues es tu tía."
,"15":"No tendrás relaciones con la mujer de tu hijo. Respeta a tu propio hijo y no tengas relaciones con ella."
,"16":"No tendrás relaciones con la mujer de tu hermano: respeta a tu hermano."
,"17":"No tendrás relaciones con una mujer y su hija, y tampoco tomarás a su nieta, pues te respetarás a ti mismo."
,"18":"Teniendo ya mujer, no tomarás a su hermana para ponerla celosa, teniendo relaciones con su hermana mientras viva ella."
,"19":"No tendrás relaciones con una mujer durante el período de sus reglas."
,"20":"No te acostarás con la mujer de tu prójimo, pues es una maldad."
,"21":"No entregarás a tu hijo, quemándolo según el rito de Moloc, pues sería deshonrar el nombre de tu Dios. ¡Yo soy Yavé!"
,"22":"No te acostarás con un hombre como se hace con una mujer: esto es una cosa abominable."
,"23":"No te acostarás con un animal: la mancha te quedaría. Tampoco la mujer se dejará cubrir por un animal: esto es una cosa abominable."
,"24":"No se manchen haciendo estas cosas, pues así es como se han manchado las naciones que yo desalojé ante ustedes."
,"25":"El país estaba manchado, por lo que yo intervine; y la tierra echó fuera a sus habitantes."
,"26":"Ustedes guarden mis leyes y mis normas y no cometan ninguna de estas abominaciones ni tampoco los forasteros que vivan entre ustedes."
,"27":"No cometan estos mismos pecados para que la tierra no los arroje fuera,"
,"28":"del mismo modo que vomitó a las naciones anteriores a ustedes que cometieron todos estos pecados."
,"29":"Cualquiera que cometa estas abominaciones, todas esas personas serán eliminadas de su pueblo."
,"30":"Observen, pues, mis normas, y no practiquen ninguna de las costumbres horribles que se practicaron antes de ustedes; no se manchen con ellas, pues Yo soy Yavé, Dios de ustedes.'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"Yavé dijo a Moisés:"
,"2":"'Habla a toda la comunidad de los hijos de Israel y diles: Sean santos, porque yo, Yavé, Dios de ustedes, soy Santo."
,"3":"Todos ustedes respetarán a su padre y a su madre y guardarán mis sábados. ¡Yo soy Yavé, su Dios!"
,"4":"No se vuelvan hacia los ídolos ni se hagan dioses de metal fundido. ¡Yo soy Yavé, Dios de ustedes!"
,"5":"Cuando sacrifiquen a Yavé un sacrificio de comunión, háganlo de manera que le sea grato."
,"6":"Ustedes comerán de la víctima el mismo día en que la inmolen y al día siguiente, y lo que sobre hasta el tercer día será quemado."
,"7":"Es una cosa muy fea comerla el día tercero: la víctima deja de ser grata."
,"8":"El que la coma cargará con su pecado por haber profanado la santidad de Yavé. Esta persona será borrada de entre los suyos.'"
,"9":"'Cuando sea tiempo de cosechar, no siegues hasta la misma orilla del campo, ni recojas las espigas caídas."
,"10":"Tampoco rebusques en tus viñas, ni recojas de tus huertos las frutas caídas. Las dejarás al pobre y al forastero: ¡Yo soy Yavé, tu Dios!"
,"11":"No hurtarán, no mentirán, ni se engañarán mutuamente."
,"12":"No jurarán en falso por mi Nombre porque esto sería deshonrar el nombre de tu Dios. ¡Yo soy Yavé!"
,"13":"No oprimirás ni despojarás a tu prójimo. No retendrás el salario del jornalero hasta el día siguiente."
,"14":"No gritarás maldiciones al sordo, ni pondrás obstáculos al ciego, sino que temerás a tu Dios. ¡Yo soy Yavé!"
,"15":"No dictarás sentencias injustas. No harás favores al pobre, no te inclinarás ante el rico, sino que juzgarás con justicia a tu prójimo."
,"16":"No calumniarás a tu prójimo ni buscarás medios legales para hacerlo desaparecer."
,"17":"No odies en tu corazón a tu hermano; pero corrígelo, no sea que te hagas cómplice de sus faltas."
,"18":"No te vengarás ni guardarás rencor contra tus paisanos, sino que más bien amarás a tu prójimo como a ti mismo, pues Yo soy Yavé."
,"19":"Guarden mis tradiciones. No aparearás en tu ganado dos bestias de diferente especie; no sembrarás tu campo con dos clases distintas de grano; no usarás ropa tejida con hilos de dos clases."
,"20":"Si un hombre tiene relaciones con una esclava ya entregada a otro, sin que haya sido rescatada ni liberada, serán castigados los dos, pero no con pena de muerte, pues ella no era mujer libre."
,"21":"El ofrecerá su sacrificio de reparación para Yavé a la entrada de la Tienda de las Citas; será un carnero de reparación."
,"22":"Con este carnero el sacerdote hará reparación por él ante Yavé, por el pecado que cometió, y se le perdonará el pecado."
,"23":"Cuando entren en el país y planten toda clase de árboles frutales, consideren impuros sus frutos por tres años; durante este período no se podrán comer."
,"24":"Al cuarto año todos sus frutos serán consagrados a Yavé."
,"25":"El quinto año podrán comer y almacenar los frutos para guardarlos. ¡Yo soy Yavé, Dios de ustedes!"
,"26":"No coman nada encima de la sangre. No practiquen la hechicería ni la astrología."
,"27":"No rapen en redondo su cabeza ni corten los bordes de su barba."
,"28":"No se hagan cortes en su cuerpo por los muertos; no lleven inscripciones o tatuajes en su cuerpo: ¡Yo soy Yavé!"
,"29":"No profanarás a tu hija, prostituyéndola; no sea que tu país se vuelva una tierra de prostitutas, un nido de víboras."
,"30":"Guarden mis sábados y respeten mi Santuario: ¡Yo soy Yavé!"
,"31":"No se dirijan a los brujos ni a los que llaman a los espíritus; no los consulten no sea que con ellos se manchen: ¡Yo soy Yavé!"
,"32":"Ponte en pie ante un anciano y honra a las personas mayores; esto es temer a tu Dios: ¡Yo soy Yavé!"
,"33":"Cuando un forastero viva junto a ti, en tu tierra, no lo molestes."
,"34":"Al forastero que viva con ustedes lo mirarán como a uno de ustedes y lo amarás como a ti mismo, pues ustedes también fueron forasteros en Egipto: ¡Yo soy Yavé, tu Dios!"
,"35":"No cometan injusticia en los juicios, ni en medidas de longitud, de peso o capacidad;"
,"36":"usen balanzas justas, peso, medida y sextuario justos: ¡Yo soy Yavé, el Dios de ustedes, que los saqué del país de Egipto!"
,"37":"Guarden todas mis normas y mis mandamientos. Ustedes los pondrán en práctica: ¡Yo soy Yavé!'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"Yavé habló a Moisés para decirle:"
,"2":"'Di a los hijos de Israel: Si un israelita o uno de los extranjeros que habitan en Israel sacrifica a alguno de sus hijos según el rito de Moloc morirá: la gente del pueblo lo apedreará."
,"3":"Yo mismo volveré mi rostro contra ese hombre y lo eliminaré de su pueblo. Pues al sacrificar su descendencia para Moloc, contaminó mi Santuario y profanó mi santo Nombre."
,"4":"Si la gente del pueblo cierra sus ojos respecto de ese hombre cuando entrega su descendencia para Moloc y no lo hace morir,"
,"5":"volveré yo mi rostro contra ese hombre y contra toda su familia y borraré de en medio de su pueblo a él y a todos los que se venden como él a Moloc."
,"6":"Si alguno se dirige a los que consultan a los espíritus, o a los brujos para prostituirse con ellos, volveré mi rostro contra él y lo eliminaré de su pueblo."
,"7":"Santifíquense, pues, y sean santos, porque yo soy Yavé, el Dios de ustedes."
,"8":"Guarden mis preceptos y practíquenlos: ¡Yo soy Yavé, y a ustedes les hago santos!"
,"9":"Cualquiera que maldiga a su padre o a su madre morirá. El que maldice a su padre o a su madre, quiere su propia muerte."
,"10":"Si alguno comete adulterio con una mujer casada, con la mujer de su prójimo, morirán los dos, el adúltero y la mujer adúltera."
,"11":"El hombre que se acueste con la mujer de su padre ha descubierto la desnudez de su padre; los dos morirán, y serán responsables de su propia muerte."
,"12":"Si un hombre se acuesta con su nuera, los dos morirán: han cometido una infamia y son responsables de su propia muerte."
,"13":"Si un hombre se acuesta con un varón, como se acuesta con una mujer, ambos han cometido una infamia; los dos morirán y serán responsables de su muerte."
,"14":"El hombre que tome a una mujer y a su madre comete una infamia. Se les quemará a él y a ellas para que no haya infamia entre ustedes."
,"15":"Si un hombre tiene relación sexual con un animal, morirán él y el animal."
,"16":"Y si una mujer la tiene con un animal, los dos morirán también. Son responsables de su propia muerte."
,"17":"El hombre que tiene relaciones con su hermana, hija de su padre o de su madre y ve su desnudez y ella la de él, es una ignominia; serán exterminados en presencia de los hijos de su pueblo. Ha descubierto la desnudez de su hermana: cargará con su maldad."
,"18":"Si un hombre se acuesta con una mujer durante su derrame menstrual y descubre su desnudez, ha descubierto, y ella también, la fuente de su sangre; ambos serán borrados de en medio de su pueblo."
,"19":"No tendrás relaciones sexuales con la hermana de tu madre, ni con la de tu padre, porque son tu propia carne; de hacerlo, cargarás con tu maldad."
,"20":"Si un hombre se acuesta con su tía, descubre la desnudez de su tío; de hacerlo, cargará con su pecado y morirá sin hijos."
,"21":"Si un hombre toma la mujer de su hermano, comete una maldad: ha descubierto la desnudez de su hermano. Estos no tendrán hijos."
,"22":"Guarden, pues, todas mis tradiciones y mandamientos y pónganlos en práctica. Así no los vomitará esa tierra a donde los estoy llevando para que vivan en ella."
,"23":"No seguirán las costumbres de la gente que voy a arrojar delante de ustedes, pues a causa de esas mismas prácticas les tomé odio."
,"24":"Por esto les he dicho a ustedes: Poseerán su tierra; y soy quien se la doy, de manera que sea de ustedes esa tierra que mana leche y miel: Yo soy Yavé, el Dios de ustedes, que los ha separado de entre los pueblos."
,"25":"Distingan bien, pues, entre el animal puro y el impuro y entre ave pura e impura, y no se contaminen comiendo algún animal, o ave, o cualquier ser que se mueva en la tierra, que yo haya separado como impuro."
,"26":"Sean santos para mí, porque yo soy Santo, yo Yavé, que los he separado de los demás pueblos para que sean míos."
,"27":"Todo hombre o mujer que llame a los espíritus o practique hechicerías morirá. Los apedrearán y su sangre caerá sobre ellos.'"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Yavé dijo a Moisés: 'Habla a los sacerdotes, hijos de Aarón, y diles: Que ninguno de ustedes se haga impuro por un muerto"
,"2":"excepto por sus parientes más próximos, por su madre, su padre, sus hijos, sus hijas o sus hermanos."
,"3":"También podrá contraer impureza por el duelo de una hermana que vivía con él y no tenía marido."
,"4":"Siendo señor en medio de su pueblo, toda mancha suya profana su pueblo."
,"5":"No raparán su cabeza ni rasurarán los lados de su barba, ni se harán cortes en su cuerpo."
,"6":"Serán santos para su Dios y no profanarán su Nombre porque son ellos los que ofrecen los sacrificios por el fuego, alimento de su Dios; por esto han de ser santos."
,"7":"No tomarán una mujer prostituta o deshonrada, ni tampoco una mujer despedida por su marido, porque el sacerdote está consagrado a Dios."
,"8":"Al sacerdote lo tendrás por santo, pues él ofrece el pan de tu Dios; será santo para ti porque yo soy Santo, yo Yavé, que les santifico a ustedes."
,"9":"Si se prostituye la hija de un sacerdote, se profana a sí misma y a su padre: será quemada viva."
,"10":"El sacerdote que ha sido puesto más alto que sus hermanos, sobre cuya cabeza se ha derramado el óleo de unción, y que ha sido consagrado para revestir las vestiduras, en ningún caso tendrá su cabellera suelta ni rasgará sus vestidos."
,"11":"No se hará impuro por haberse acercado a un muerto, aun por un padre o una madre."
,"12":"No puede salir del Lugar Santo sin profanar el orden del Lugar Santo, porque el óleo que lo consagró a su Dios permanece sobre él como una diadema sobre su cabeza: ¡Yo soy Yavé!"
,"13":"El sumo sacerdote tomará mujer virgen. No tomará una viuda o una mujer despedida, o deshonrada o prostituta."
,"14":"Solamente tomará una mujer virgen de su pueblo."
,"15":"No profanará a su posteridad en medio de su pueblo, porque yo soy Yavé, que a él lo hago santo.'"
,"16":"Yavé dijo a Moisés:"
,"17":"'Habla a Aarón y dile: Ninguno de tu descendencia, ahora o en el futuro, que tenga una deformidad ofrecerá el alimento de su Dios."
,"18":"Ningún varón que tenga un defecto presentará las ofrendas: ya sea ciego o cojo, desfigurado o desproporcionado,"
,"19":"o un hombre que tenga fracturado un pie o una mano,"
,"20":"o que sea jorobado, enano o bisojo, sarnoso y tiñoso, o con los testículos aplastados."
,"21":"Ningún descendiente del sacerdote Aarón que tenga un defecto, se acercará para ofrecer a Yavé los sacrificios por el fuego. El que tiene alguna deformidad no ofrecerá el alimento de su Dios; "
,"22":"eso sí, lo podrá comer y se alimentará de las cosas santas."
,"23":"Pero, debido a su defecto corporal, no irá hasta el velo ni se acercará al altar; así no profanará mi santuario, porque yo soy Yavé, que a ellos los santifico.'"
,"24":"Y Moisés repitió todo esto a Aarón y a sus hijos y a todos los hijos de Israel."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Yavé dijo a Moisés:"
,"2":"'Enseña a Aarón y a sus hijos cuándo se deben abstener de las cosas santas que los hijos de Israel me consagren, para que no profanen mi santo Nombre: ¡Yo soy Yavé!"
,"3":"Diles: Cualquier descendiente de ustedes en las generaciones venideras que, estando impuro, se acerque a las cosas sagradas que los hijos de Israel consagran a Yavé, ése será exterminado de mi presencia: ¡Yo soy Yavé!"
,"4":"Todo descendiente de Aarón que sea leproso, o padezca derrame, no comerá de las cosas sagradas hasta que se purifique. Si tocó un cadáver o si ha tenido un derrame seminal;"
,"5":"si tocó un reptil cualquiera o a un hombre que lo contamine, haciéndolo impuro,"
,"6":"en ese caso será impuro hasta la tarde y no comerá de las cosas santas hasta después de haber bañado su cuerpo en agua."
,"7":"Pero, cuando se haya puesto el sol, será puro y podrá comer de las cosas santas porque son su alimento."
,"8":"No comerán animal muerto o destrozado, pues con él se harían impuros: ¡Yo soy Yavé!"
,"9":"Ustedes guardarán estos preceptos míos, no sea que carguen con un pecado y mueran a consecuencia de esta profanación: ¡Yo soy Yavé, y a ustedes los hago santos!"
,"10":"Ningún extraño comerá de las cosas sagradas; el que viva en casa del sacerdote o que trabaje a su servicio, no comerá de las cosas sagradas."
,"11":"Pero si un sacerdote adquiere un esclavo comprándolo, éste podrá comer de las cosas sagradas y también los que han nacido en su casa comerán de su alimento."
,"12":"La hija de un sacerdote, si está casada con un extraño, no podrá comer de las cosas sagradas."
,"13":"Pero, si queda viuda o es despedida por su esposo sin tener hijos y vuelve a la casa de su padre, podrá comer el pan de su padre, como cuando era joven. Pero ningún extraño comerá de él."
,"14":"Quien sin darse cuenta coma algo sagrado, lo restituirá al sacerdote, añadiendo un quinto de más."
,"15":"No profanen, pues, las cosas sagradas de los hijos de Israel, reservadas para Yavé,"
,"16":"porque al comerlas cargarían con un pecado: ¡Yo soy Yavé, que los santifica a ustedes!'"
,"17":"Yavé habló a Moisés y le dijo:"
,"18":"'Habla a Aarón y a sus hijos y a todos los hijos de Israel y diles: Cuando un israelita, o un forastero en Israel, presente una ofrenda en cumplimiento de un voto o como ofrenda voluntaria a Yavé,"
,"19":"la víctima sólo será aceptada si es macho, sin defecto, buey, oveja o cabra."
,"20":"No ofrezcan nada defectuoso, pues no será aceptado."
,"21":"Si alguien ofrece a Yavé ganado mayor o menor como sacrificio de comunión, sea en cumplimiento de un voto o como ofrenda voluntaria, el animal será aceptado si es sin mancha ni defecto."
,"22":"Nunca ofrezcan a Yavé ni pongan en el altar como sacrificio por el fuego para Yavé, un animal ciego, quebrado, mutilado, con llagas o sarna."
,"23":"Si es buey u oveja desproporcionado o enano, podrán presentarlo como ofrenda voluntaria, pero no será aceptado en cumplimiento de voto."
,"24":"No ofrezcan a Yavé animal alguno que tenga los testículos aplastados, hundidos, cortados o arrancados. No harán esto en el país de ustedes,"
,"25":"ni tampoco recibirán de mano de extranjeros alguna de estas víctimas para ofrecerla como alimento del Dios de ustedes, porque dicha mutilación es un defecto, y con esto no será aceptada.'"
,"26":"Yavé dijo a Moisés:"
,"27":"'Cuando nazca un ternero, cordero o cabrito, quedará con su madre siete días; desde el día octavo será aceptado como ofrenda por el fuego para Yavé."
,"28":"No degüellen en el mismo día una vaca o una oveja con su cría."
,"29":"Cuando ofrezcan un sacrificio de acción de gracias a Yavé, háganlo de manera que le agrade."
,"30":"Comerán la víctima en el mismo día y no dejarán nada para el día siguiente: ¡Yo soy Yavé!"
,"31":"Guarden mis mandamientos y pónganlos en práctica: ¡Yo soy Yavé!"
,"32":"No profanen mi santo Nombre, para que yo sea reconocido santo en medio de los hijos de Israel."
,"33":"Yo soy Yavé, que los santifico a ustedes y que los hice salir de Egipto para ser su Dios, Yo, Yavé.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Yavé dijo a Moisés:"
,"2":"'Habla a los hijos de Israel y diles: Estas son las fiestas de Yavé para las cuales se convocará una asamblea santa:"
,"3":"Habrá seis días trabajados, y el séptimo día será sábado de descanso con una asamblea santa: no se hará ningún trabajo. El sábado será para Yavé en todos los lugares donde vivan."
,"4":"Luego están las fiestas de Yavé celebradas con una asamblea santa, que ustedes convocarán a su debido tiempo."
,"5":"El día catorce del mes primero, al anochecer, es la Pascua de Yavé."
,"6":"El quince del mismo mes es la fiesta de los ázimos en honor a Yavé: durante siete días comerán panes sin levadura."
,"7":"El día primero convocarán una asamblea santa; no harán trabajo de trabajador."
,"8":"Durante siete días seguidos ofrecerán a Yavé un sacrificio por el fuego; el séptimo día convocarán una asamblea santa, y no harán ningún trabajo de trabajador.'"
,"9":"Yavé dijo a Moisés:"
,"10":"'Di a los israelitas: Cuando hayan entrado en la tierra que yo les doy, y ya hagan cosechas, llevarán al sacerdote la primera gavilla, o sea, las primicias de su cosecha;"
,"11":"y el sacerdote la mecerá ante Yavé para que a ustedes los bendiga. El gesto de mecerla se hará el día después del sábado."
,"12":"El mismo día en que ofrezcan la gavilla, ustedes sacrificarán en honor de Yavé un cordero de un año, sin defecto, como víctima quemada para Yavé."
,"13":"Junto con esto, ofrecerán dos décimas de flor de harina amasada con aceite, y como sacrificio de suave aroma para Yavé. Al mismo tiempo ofrecerán vino, unas dos botellas."
,"14":"Ustedes no comerán pan ni granos, tostados o tiernos, hasta el día en que presenten la ofrenda a su Dios. Este será un rito perpetuo, de generación en generación dondequiera que vivan."
,"15":"A partir del día que sigue al sábado en que habrán traído la gavilla para ser mecida ante Yavé, ustedes contarán siete semanas completas."
,"16":"Al día siguiente del séptimo sábado serán cincuenta días y entonces ofrecerán una nueva ofrenda a Yavé."
,"17":"Traerán de sus casas, para ofrecerlos, dos panes de dos décimas de flor de harina cocidos con levadura: éstas serán sus primicias para Yavé."
,"18":"Junto con estos panes, ustedes ofrecerán siete corderos de un año, sin defecto, un novillo y dos carneros como víctimas quemadas para Yavé; añadirán la ofrenda y la libación correspondientes y será un sacrificio por el fuego de suave aroma para Yavé."
,"19":"Sacrificarán también un macho cabrío en sacrificio por el pecado y dos corderos de un año en sacrificio de comunión."
,"20":"El sacerdote los ofrecerá como ofrenda mecida ante Yavé junto con el pan de las primicias y los dos corderos; serán cosa consagrada a Yavé y pertenecerán al sacerdote."
,"21":"Este mismo día convocarán una asamblea santa; no harán ningún trabajo de trabajador. Es ley perpetua para sus descendientes, dondequiera que habiten."
,"22":"Cuando cosechen los productos de sus campos, no segarán hasta el límite de los campos ni recogerán las espigas perdidas, sino que las dejarán para el pobre y para el forastero: ¡Yo soy Yavé, el Dios de ustedes.'"
,"23":"Yavé habló a Moisés y le dijo:"
,"24":"'Habla a los hijos de Israel y diles: El día primero del séptimo mes será para ustedes el Gran Sábado, proclamado con sonar de trompeta, con una reunión sagrada."
,"25":"No harán ningún trabajo de trabajador y ofrecerán a Yavé un sacrificio por el fuego.'"
,"26":"Yavé dijo a Moisés:"
,"27":"'El día décimo de este séptimo mes es el día del Perdón. Este día ustedes tendrán una reunión sagrada; ayunarán y ofrecerán a Yavé un sacrificio por el fuego."
,"28":"No harán ningún trabajo porque ése es el día del Perdón, en que se hace la expiación por ustedes delante de Yavé."
,"29":"Cualquier persona que no ayune este día será exterminada de en medio de los suyos."
,"30":"Al que haga algún trabajo, yo lo exterminaré de en medio de su pueblo."
,"31":"No harán, pues, trabajo alguno, es un decreto perpetuo, de generación en generación, dondequiera que habiten."
,"32":"Este será para ustedes el más grande de los sábados, en el que harán penitencia. El día nueve del mes por la tarde y hasta la tarde del día siguiente observarán el sábado.'"
,"33":"Yavé habló a Moisés y le dijo:"
,"34":"'Habla a los hijos de Israel y diles: El día quince del séptimo mes ustedes celebrarán durante siete días la fiesta de las Chozas en honor de Yavé."
,"35":"El día primero habrá reunión sagrada y no harán ningún trabajo de trabajador."
,"36":"Durante siete días ustedes ofrecerán cada día a Yavé sacrificios por el fuego. El día octavo tendrán reunión sagrada y ofrecerán a Yavé sacrificios por el fuego. Ustedes tendrán una asamblea solemne y no harán ningún trabajo."
,"37":"Estas son las solemnidades de Yavé en que ustedes convocarán a una reunión sagrada para ofrecer a Yavé sacrificios por el fuego, holocaustos y ofrendas, víctimas y libaciones, cada cosa en su día. Además están los sábados de Yavé;"
,"38":"además también todo lo que le regalan: lo prometido por voto y las oblaciones voluntarias."
,"39":"El día quince del séptimo mes, cuando cosechen los productos de la tierra, ustedes celebrarán la Fiesta en honor a Yavé durante siete días. El primer día será un sábado solemne igual que el octavo."
,"40":"El primer día tomarán frutos del árbol hermoso, ramos de palmera, de árboles frondosos y de sauces de río, y durante siete días se alegrarán en presencia de Yavé, el Dios de ustedes."
,"41":"Esta es una ley para siempre, de generación en generación: en el séptimo mes ustedes lo celebrarán."
,"42":"Durante siete días ustedes vivirán en chozas; todos los hijos de Israel vivirán en chozas,"
,"43":"para que los descendientes de ustedes sepan que yo hice vivir en chozas a los hijos de Israel cuando los saqué de la tierra de Egipto: ¡Yo soy Yavé, su Dios!'"
,"44":"Estas fueron las palabras de Moisés a los hijos de Israel respecto de las fiestas de Yavé."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Yavé habló a Moisés diciendo:"
,"2":"'Manda a los hijos de Israel que te traigan aceite puro de oliva molida, para el candelero, para mantener continuamente la luz encendida."
,"3":"Aarón mantendrá la lámpara de la mañana hasta la tarde en presencia de Yavé, fuera de la cortina que está delante del Testimonio en la Tienda de las Citas: es una ley perpetua de generación en generación."
,"4":"El colocará las lámparas sobre el candelabro puro que permanece ante Yavé."
,"5":"Tomarás flor de harina y cocerás con ella doce tortas, dos décimas de harina para cada una."
,"6":"Las colocarás en dos filas, seis en cada fila, sobre la mesa pura en presencia de Yavé."
,"7":"Pondrás sobre cada fila incienso puro para que el pan sea un memorial, un sacrificio por el fuego para Yavé."
,"8":"Cada sábado, de generación en generación, dispondrán esos panes ante Yavé de parte de los hijos de Israel, como signo de alianza perpetua."
,"9":"Estos panes serán para Aarón y sus hijos, que los comerán en lugar sagrado. Y los tendrán por cosa muy santa entre todos los sacrificios por el fuego para Yavé. Es una ley para siempre."
,"10":"Un día, en el campamento, hubo un altercado entre un hombre de madre israelita y de padre egipcio, y un israelita."
,"11":"El hijo de la israelita (ella se llamaba Selomit, hija de Dibrí, de la tribu de Gad) blasfemó y maldijo el nombre de Yavé, por lo que lo llevaron ante Moisés."
,"12":"Y lo tuvieron preso hasta que Yavé dispusiera lo que había que hacer con él."
,"13":"Y Yavé dijo a Moisés: 'Saca fuera del campamento al que blasfemó."
,"14":"Todos los que lo oyeron pondrán las manos sobre su cabeza, y luego toda la comunidad lo apedreará."
,"15":"Entonces dirás a los hijos de Israel: Cualquier persona que maldiga a su Dios cargará con su pecado;"
,"16":"el que blasfeme el nombre de Yavé será castigado de muerte: toda la comunidad lo apedreará. Sea israelita o extranjero, si blasfema el nombre de Yavé, morirá."
,"17":"El que hiera de muerte a cualquier persona morirá."
,"18":"El que hiera de muerte a un animal pagará con otro; vida por vida."
,"19":"El que cause alguna lesión a su prójimo, como él hizo, así se le hará:"
,"20":"fractura por fractura, ojo por ojo, diente por diente; se hará la misma lesión que él ha causado al otro."
,"21":"El que mate a un animal, dará otro por él, pero el que mate a una persona humana, morirá."
,"22":"La ley será la misma para el forastero y para el nativo, porque yo soy Yavé, su Dios.'"
,"23":"Moisés, pues, habló a los hijos de Israel, que sacaron al blasfemo fuera del campamento y lo apedrearon. Lo hicieron tal como Yavé lo había mandado a Moisés."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Yavé dijo a Moisés en el monte Sinaí:"
,"2":"'Di a los hijos de Israel: Cuando hayan entrado en el país que les voy a dar, la tierra tendrá su descanso el año séptimo en honor a Yavé."
,"3":"Durante seis años sembrarás tu campo, podarás tu viña y cosecharás sus frutos,"
,"4":"pero el séptimo año será un sábado, un descanso solemne para la tierra, un sábado en honor de Yavé. No sembrarás tu campo ni podarás tu viña;"
,"5":"tampoco segarás los rebrotes de la última cosecha, ni vendimiarás los racimos de tu viña sin cultivar: será un año de descanso completo para la tierra."
,"6":"Lo que produzca naturalmente la tierra durante su descanso, servirá de comida a ti, a tu siervo y a tu sierva, a tu jornalero y al extranjero que vive junto a ti."
,"7":"También tus animales comerán lo que produce naturalmente la tierra, igual que las bestias del campo."
,"8":"Después de pasadas siete semanas de años, es decir, cuarenta y nueve años,"
,"9":"al llegar el día diez del séptimo mes, harás resonar el cuerno. Será entonces el día del Perdón, y harás resonar el cuerno en todo el país."
,"10":"El año cincuenta será para ustedes un año santo, un año en que proclamarán una amnistía para todos los habitantes del país. Será para ustedes el jubileo. Los que habían tenido que empeñar su propiedad, la recobrarán. Los esclavos regresarán a su familia."
,"11":"Este año cincuenta será para ustedes el jubileo. No sembrarán ni segarán los rebrotes, ni vendimiarán la viña sin cultivar,"
,"12":"pues es año jubilar. Será para ustedes un año santo en que comerán de lo que el campo produce por sí solo."
,"13":"Este año jubilar, cada uno volverá a su propiedad."
,"14":"Por eso, si venden o compran algo a su prójimo, no lo engañen:"
,"15":"Pagarás a tu prójimo de acuerdo al número de años transcurridos después del jubileo y, según el número de años de cosecha, él te fijará el precio de venta:"
,"16":"cuantos más años quedan, mayor será el precio; cuantos menos años queden, tanto menor será, porque lo que él vende es el número de cosechas."
,"17":"Ninguno de ustedes dañe a su prójimo; antes bien, teme a tu Dios, pues yo soy Yavé tu Dios."
,"18":"Si ponen mis leyes en práctica y observan mis mandamientos, vivirán seguros en esta tierra."
,"19":"La tierra dará su fruto para que coman hasta saciarse; y vivirán seguros en ella."
,"20":"Tal vez preguntes: '¿Qué comeremos el séptimo año, ya que no podremos sembrar ni cosechar?'"
,"21":"Piensa que yo les mandaré mi bendición en el sexto año, de modo que éste produzca para tres años."
,"22":"Y cuando siembren en el año octavo, seguirán comiendo de la cosecha pasada, y la seguirán comiendo hasta que venga la cosecha del año noveno."
,"23":"Las tierras no se venderán para siempre, porque la tierra es mía y ustedes están en mi tierra como forasteros y huéspedes."
,"24":"Por tanto, en todo el territorio que ustedes ocupan, las tierras conservarán el derecho de rescate."
,"25":"Si tu hermano pasa necesidad y se ve obligado a venderte su propiedad, su pariente más cercano podrá rescatar lo vendido por su pariente."
,"26":"Si alguno no tiene quién le rescate su propiedad, pero tiene por sí solo recursos suficientes para rescatarla,"
,"27":"ustedes contarán los años pasados desde la venta y se dará al comprador la cantidad correspondiente al tiempo que falta; y volverá a su propiedad."
,"28":"Si no halla lo suficiente para recuperarla, lo vendido quedará en poder del comprador hasta el año del jubileo; entonces la tierra quedará libre y volverá al que la vendió."
,"29":"En cambio, el que venda una casa ubicada en una ciudad con murallas, tendrá un año para rescatarla a partir de su venta; su derecho de rescate no vale más que un tiempo."
,"30":"De no ser rescatada dentro del año, una casa ubicada en una ciudad con murallas quedará para siempre para el comprador y sus descendientes: no se la quitarán en el jubileo."
,"31":"Pero las casas de las aldeas sin murallas serán tratadas como los campos; hay derecho de rescate para ellas y en el año del jubileo volverán al vendedor."
,"32":"En cuanto a las ciudades de los levitas, éstos tendrán siempre derecho de rescate sobre las casas que posean en estas ciudades."
,"33":"Aun cuando no se rescate una casa ubicada en una ciudad de los levitas, lo vendido quedará libre en el jubileo; porque las casas de las ciudades de los levitas son su propiedad en medio de los hijos de Israel."
,"34":"Tampoco pueden venderse los campos que rodean sus ciudades, pues son su propiedad para siempre."
,"35":"Si tu hermano pasa necesidad y ves que no puede salir del apuro, ayúdalo, aunque sea forastero o huésped, para que pueda vivir junto a ti."
,"36":"No tomarás de él interés ni usura; antes bien, teme a tu Dios y haz que tu hermano pueda vivir junto a ti."
,"37":"No le prestarás dinero a interés; no le facilitarás víveres para después aprovecharte de él,"
,"38":"pues yo soy Yavé, el Dios de ustedes, que los saqué de la tierra de Egipto para darles la tierra de Canaán y ser su Dios."
,"39":"Si tu prójimo se hace tu deudor y se vende a ti, no le impondrás trabajo de esclavo;"
,"40":"estará contigo como jornalero o como huésped y trabajará junto a ti hasta el año del jubileo."
,"41":"Entonces saldrá de tu casa con sus hijos y volverá a su familia recobrando la propiedad de sus padres."
,"42":"Porque todos son mis siervos, que yo saqué de la tierra de Egipto, y no deben ser vendidos como se vende un esclavo."
,"43":"Así que no te pondrás duro con tu hermano, sino que temerás a tu Dios."
,"44":"Si quieres adquirir esclavos y esclavas, los tomarás de las naciones vecinas: de allí comprarás esclavos y esclavas."
,"45":"También podrán comprarlos entre los extranjeros que viven con ustedes y de sus familias que están entre ustedes, es decir, de los que hayan nacido entre ustedes. Esos pueden ser propiedad de ustedes,"
,"46":"y los dejarán en herencia a sus hijos después de ustedes como propiedad para siempre. Pero tratándose de tus hermanos israelitas, no actuarás en forma tiránica, sino que los tratarás como a tus hermanos."
,"47":"Si el extranjero o el forastero que vive contigo adquiere bienes, y en cambio tu hermano se empobrece al lado de él y se vende al extranjero o al forastero, o al descendiente de la familia del extranjero,"
,"48":"después de haberse vendido le quedará el derecho de rescate; uno de sus hermanos podrá rescatarlo."
,"49":"Lo rescatará su tío paterno, o el hijo de su tío, o algún otro pariente cercano suyo dentro de su familia, o, si le alcanzan sus recursos, él mismo podrá rescatarse."
,"50":"Contará con su comprador los años desde que se vendió hasta el año del jubileo, y el precio se calculará en proporción de los años, valorando sus días de trabajo como los de un jornalero."
,"51":"Si faltan todavía muchos, devolverá en proporción a ellos, tomando como base el precio de venta."
,"52":"Si faltan pocos años para el jubileo, se le calculará en proporción a ellos."
,"53":"Estará en casa de su patrón, año tras año, como quien trabaja a jornal. No permitas que se le trate con dureza ante tus ojos."
,"54":"Si nadie lo rescata, quedará libre el año del jubileo, y también sus hijos con él."
,"55":"Porque es a mí a quien sirven los hijos de Israel, siervos míos son a quienes yo he sacado del país de Egipto. Yo soy Yavé, el Dios de ustedes."
}`)
	CurrentBook.AddChapter(26, `{
"1":"No se hagan ídolos, ni levanten estatuas o monumentos, ni coloquen en su tierra piedras grabadas para postrarse ante ellas, porque yo soy Yavé, el Dios de ustedes."
,"2":"Ustedes guardarán mis sábados y respetarán mi santuario: ¡Yo soy Yavé!"
,"3":"Si caminan según mis tradiciones y guardan mis normas poniéndolas en práctica,"
,"4":"les enviaré las lluvias a su tiempo para que la tierra dé sus productos y los árboles del campo sus frutos."
,"5":"El tiempo de trilla alcanzará hasta la vendimia y la vendimia durará hasta la siembra; comerán su pan hasta saciarse y vivirán seguros en su tierra."
,"6":"Yo estableceré la paz en su país y dormirán sin que nadie los moleste; haré desaparecer del país los animales feroces, y la espada no pasará por su tierra."
,"7":"Perseguirán a sus enemigos, que caerán ante ustedes a filo de espada."
,"8":"Cinco de ustedes perseguirán a cien de ellos, y cien de ustedes a diez mil de ellos: los enemigos caerán ante ustedes a filo de espada."
,"9":"Yo me inclinaré hacia ustedes y mi alianza con ustedes cobrará pleno vigor; tendrán familias numerosas y llegarán a ser un gran pueblo;"
,"10":"todavía no habrán terminado de comer la cosecha añeja cuando tendrán que tirarla para dar cabida a la nueva."
,"11":"Tendré mi Morada entre ustedes y ya no los miraré mal."
,"12":"Me pasearé en medio de ustedes y seré Dios de ustedes mientras ustedes serán mi pueblo."
,"13":"Pues yo soy Yavé, Dios de ustedes, que los saqué del país de Egipto para que no fueran más esclavos de ellos, y rompí el bastón de sus vigilantes para que salieran ustedes con la cabeza alta."
,"14":"Pero si no me escuchan, si no cumplen todo eso;"
,"15":"si desprecian mis normas y rechazan mis leyes; si no hacen caso de todos mis mandamientos y rompen mi alianza,"
,"16":"entonces miren lo que haré yo con ustedes. Mandaré sobre ustedes el terror, la peste y la fiebre; sus ojos se debilitarán y su salud irá en desmedro. Ustedes sembrarán en vano la semilla, pues se la comerán los enemigos."
,"17":"Me volveré contra ustedes y serán derrotados ante el enemigo; ustedes no resistirán a sus adversarios y huirán sin que nadie los persiga."
,"18":"Si ni aun así me obedecen, les devolveré siete veces más por sus pecados."
,"19":"Quebrantaré su orgullosa fuerza; haré que el cielo sea de hierro para ustedes y la tierra de bronce."
,"20":"Sus esfuerzos se perderán, su tierra no dará sus productos ni los árboles darán sus frutos."
,"21":"Y si siguen enfrentándose conmigo en vez de escucharme, les devolveré siete veces más por sus pecados."
,"22":"Soltaré contra ustedes la fiera salvaje, que les devorará sus hijos, exterminará los ganados y los reducirá a unos pocos, de modo que nadie ya ande por los caminos de su país."
,"23":"Si aun con esto no cambian su actitud respecto a mí y siguen desafiándome,"
,"24":"también yo me enfrentaré con ustedes y les devolveré yo mismo siete veces más por sus pecados;"
,"25":"traeré sobre ustedes la espada vengadora de mi alianza. Se refugiarán entonces en sus ciudades, pero yo enviaré la peste en medio de ustedes y serán entregados en manos del enemigo."
,"26":"Yo les quitaré el pan, hasta el punto que diez mujeres cocerán todo su pan en un solo horno, y se lo darán tan medido que no se podrán saciar."
,"27":"Si con esto no me obedecen y siguen haciéndome la contra,"
,"28":"yo me enfrentaré con ustedes con ira y les devolveré siete veces más por sus pecados:"
,"29":"¡ustedes llegarán a comer la carne de sus hijos e hijas!"
,"30":"Destruiré sus santuarios altos, demoleré sus monumentos, amontonaré sus cadáveres sobre los cadáveres de sus sucios ídolos y les tendré asco."
,"31":"Reduciré a escombros sus ciudades y devastaré sus santuarios, no me agradará más el perfume de sus sacrificios."
,"32":"Yo devastaré la tierra de tal modo que sus mismos enemigos quedarán admirados y asombrados cuando vengan a ocuparla."
,"33":"A ustedes los desparramaré entre las ciudades y naciones; y los perseguiré con la espada. Sus tierras serán arruinadas y quedarán desiertas sus ciudades."
,"34":"Entonces la tierra gozará de sus descansos sabáticos durante todo el tiempo que sea arruinada, mientras estén ustedes en tierra de enemigos. La tierra descansará y gozará sus sábados;"
,"35":"y mientras esté abandonada, descansará por lo que no pudo descansar en sus sábados, cuando ustedes habitaban en ella."
,"36":"A los que queden de ustedes les infundiré pánico en sus corazones en el país de sus enemigos; el ruido de una hoja que cae los hará huir como quien huye de la espada y caerán sin que nadie los persiga."
,"37":"Se atropellarán unos a otros como delante de la espada, aunque nadie los persiga. No se podrán tener en pie ante el enemigo."
,"38":"Perecerán en tierra de paganos y desaparecerán en el país de sus enemigos."
,"39":"Los que de ustedes sobrevivan se pudrirán en país enemigo por causa de su maldad y por las maldades de sus padres unidas que se les pegaron."
,"40":"Entonces confesarán su maldad y la de sus padres; reconocerán que me han traicionado y se han enfrentado conmigo,"
,"41":"y que yo también me enfrenté con ellos y los desterré al país de sus enemigos. ¡Ojalá que se humillen los corazones incircuncisos y acepten el castigo de su maldad!"
,"42":"Yo, entonces, me acordaré de mi alianza con Jacob y de mi alianza con Isaac y de mi alianza con Abraham."
,"42":"Yo me acordaré y recordaré su país."
,"43":"Así, pues, la tierra será abandonada por ellos para que goce sus descansos sabáticos mientras quede desolada y ellos estén lejos; ellos también pagarán su maldad, porque desecharon mis mandamientos y se cansaron de mis preceptos."
,"44":"A pesar de todo, no los despreciaré cuando estén en tierra enemiga; no los aborreceré hasta su total exterminio ni anularé mi alianza con ellos, porque yo soy Yavé, su Dios."
,"45":"Me acordaré en su favor de la alianza hecha con sus padres a quienes saqué de la tierra de Egipto ante los ojos de las naciones, para ser su Dios: ¡Yo soy Yavé!'"
,"46":"Estas son las normas, leyes e instrucciones que Yavé estableció entre El y los hijos de Israel en el monte Sinaí, por medio de Moisés."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Yavé dijo a Moisés:"
,"2":"'Habla a los hijos de Israel y diles: Esta es la manera de valorar las personas que han sido consagradas a Yavé por voto."
,"3":"Para un hombre de veinte a sesenta años, el valor será de cincuenta siclos de plata, según el siclo del santuario."
,"4":"El valor de una mujer será de treinta siclos."
,"5":"De los cinco a los veinte años, el valor será: para el varón veinte siclos, para la mujer diez siclos."
,"6":"De un mes hasta los cinco años: para un niño cinco siclos de plata, para una niña tres siclos."
,"7":"De los sesenta años en adelante, el valor será: para un hombre quince siclos; para una mujer diez siclos."
,"8":"Si uno es tan pobre que no puede pagar este precio, lo presentarán al sacerdote, el cual le pondrá precio; el sacerdote lo evaluará según los recursos del que hizo el voto."
,"9":"Si has ofrecido un animal a Yavé, le ha sido regalado y es cosa consagrada:"
,"10":"no se le cambiará. No se reemplazará bueno por malo o malo por bueno. Si se reemplaza uno por otro, uno y otro serán cosa sagrada."
,"11":"Si el animal es impuro y no se puede hacer ofrenda de él a Yavé, se presentará el animal al sacerdote."
,"12":"El sacerdote le pondrá precio según a él le parece bueno o malo, y según lo que el sacerdote diga, así se hará."
,"13":"Y si lo quieren rescatar, añadirán un quinto de la valoración."
,"14":"Si uno consagra su casa como cosa santa a Yavé, el sacerdote le pondrá precio. Según lo que él diga, así será."
,"15":"Si el que la ha consagrado la quiere rescatar, añadirá una quinta parte del precio fijado y será suya."
,"16":"Si uno consagra a Yavé un campo de su propiedad, su valor se medirá según la cantidad de semilla que se le echa, a razón de cincuenta siclos de plata por cada carga de cebada de sembrado."
,"17":"Si uno ha consagrado el campo durante el año de jubileo, se mantendrá íntegra la valoración."
,"18":"Pero, si consagra su campo después del jubileo, el sacerdote calculará su precio a razón de los años que quedan hasta el jubileo, y la estimación será inferior."
,"19":"Si el que consagró el campo lo quiere rescatar, añadirá la quinta parte al precio fijado y será suyo."
,"20":"Si no rescata el campo y lo vende a otro, este campo no podrá ser rescatado en adelante,"
,"21":"y, cuando quede libre en el jubileo, será consagrado a Yavé tal como si fuera consagrado por maldición y será propiedad del sacerdote."
,"22":"Si alguien consagra a Yavé un campo que compró y que no forma parte de su propiedad,"
,"23":"el sacerdote calculará el precio hasta el año del jubileo, y el otro pagará ese mismo día el valor indicado: este dinero es cosa consagrada a Yavé."
,"24":"El año del jubileo, el campo volverá al que lo había vendido y al patrimonio del que era parte."
,"25":"Toda tasación se hará con siclos del santuario: veinte óbolos por un siclo."
,"26":"Nadie podrá consagrar los primogénitos de su ganado, porque éstos ya pertenecen a Yavé. Sean de ganado mayor o menor, pertenecen a Yavé."
,"27":"Si se trata de un animal impuro, lo rescatarán según el precio que tú fijes y añadirán la quinta parte del precio: si no es rescatado será vendido según el precio."
,"28":"En cambio, lo que uno consagre a Yavé por anatema, cualquier cosa que le pertenece, hombre, animal o campo de su herencia, no podrá venderse o rescatarse. Todo anatema es cosa muy sagrada para Yavé."
,"29":"Por esto ningún ser humano consagrado como anatema será rescatado: será muerto."
,"30":"El diezmo entero de la tierra, tanto de las semillas como de los frutos de los árboles, es de Yavé, es cosa sagrada para él;"
,"31":"si alguien quiere rescatar parte de su diezmo, añadirá la quinta parte de su valor."
,"32":"El diezmo del ganado mayor o menor, de todo lo que pasa bajo el cayado, será consagrado a Yavé como diezmo."
,"33":"No se distinguirá entre bueno o malo, ni se cambiará uno por otro, y si se hace un reemplazo, el animal sustituido y el que lo sustituye serán cosa sagrada y no podrán ser rescatados.'"
,"34":"Estos son los mandatos que Yavé dio a Moisés para los hijos de Israel en el monte Sinaí."
}`)

}
func ES_LBL_LoadVPNMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Yavé habló a Moisés en el desierto del Sinaí, en la Tienda de las Citas divinas, el primer día del mes segundo, el segundo año después de la salida de Egipto."
,"2":"Le dijo: 'Registren a toda la comunidad de los hijos de Israel por casas paternas."
,"3":"Tú y Aarón alistarán a todos los de más de veinte años, útiles para la guerra."
,"4":"Tendrán con ustedes, para que les ayuden, un hombre de cada tribu, jefe de familia."
,"5":"Estos son sus nombres: De la tribu de Rubén: Elisur, hijo de Sedeur. "
,"6":"De la de Simeón, Selumiel, hijo de Suridday."
,"7":"De la de Judá, Najasón, hijo de Aminadab."
,"8":"De la de Isacar, Nataneel, hijo de Suar."
,"9":"De la de Zabulón, Eliab, hijo de Elón."
,"10":"De los hijos de José, por Efraím: Elisana, hijo de Amiud; por Manasés: Gamliel, hijo de Padasur."
,"11":"De la de Benjamín: Abidam, hijo de Guedeoní."
,"12":"De la de Dan: Abiezer, hijo de Ammisadday."
,"13":"De la de Aser: Paguiel, hijo de Ocrón."
,"14":"De la de Gad: Elisaf, hijo de Duel."
,"15":"De la de Neftalí, Ajira, hijo de Enán."
,"16":"Estos son los que fueron escogidos en la asamblea; eran jefes en la tribu de su padre y eran los jefes de los clanes de Israel."
,"17":"Moisés y Aarón tomaron como ayudantes a esos hombres que habían sido designados por sus nombres"
,"18":"y convocaron a toda la asamblea el día primero del segundo mes, haciendo su alistamiento por familias y linajes, tomando el nombre de cada uno de los hombres de veinte años para arriba,"
,"19":"como Yavé había mandado a Moisés. Así se hizo el censo en el desierto de Sinaí."
,"20":"De la tribu de Rubén, primogénito de Israel, contando los nombres de todos los varones de veinte años para arriba, según sus familias y linajes,"
,"21":"fueron alistados cuarenta y seis mil quinientos hombres aptos para la guerra."
,"22":"De la tribu de Simeón, contando los nombres de todos los varones de veinte años para arriba, según sus linajes y familias;"
,"23":"fueron alistados cincuenta y nueve mil trescientos hombres aptos para la guerra."
,"24":"De la tribu de Gad, contando los nombres de todos los varones de veinte años para arriba, según sus familias y linajes,"
,"25":"fueron alistados cuarenta y cinco mil seiscientos cincuenta hombres aptos para la guerra."
,"26":"De la tribu de Judá, contando los nombres de todos los varones de veinte años para arriba, según sus linajes y familias,"
,"27":"fueron alistados setenta y cuatro mil seiscientos hombres aptos para la guerra."
,"28":"De la tribu de Isacar, contando los nombres de todos los varones de veinte años para arriba, según sus linajes y familias,"
,"29":"fueron alistados cincuenta y cuatro mil cuatrocientos hombres aptos para la guerra."
,"30":"De la tribu de Zabulón, contando los nombres de todos los varones de veinte años para arriba, según sus linajes y familias,"
,"31":"fueron alistados cincuenta y siete mil cuatrocientos hombres aptos para la guerra."
,"32":"De los descendientes de José, por la línea de Efraím, contando los nombres de todos los varones de veinte años para arriba, según sus linajes y familias,"
,"33":"fueron alistados cuarenta mil quinientos hombres aptos para la guerra."
,"34":"Por la línea de Manasés, según sus linajes y familias,"
,"35":"se alistaron treinta y dos mil doscientos hombres aptos para la guerra."
,"36":"De la tribu de Benjamín, contando los nombres de todos los varones de veinte años para arriba, según sus linajes y familias,"
,"37":"se alistaron treinta y cinco mil cuatrocientos hombres aptos para la guerra."
,"38":"De la tribu de Dan, contando los nombres de todos los varones de veinte años para arriba, según sus familias y linajes,"
,"39":"fueron alistados sesenta y dos mil setecientos hombres aptos para la guerra."
,"40":"De la tribu de Aser, contando los nombres de todos los varones de veinte años para arriba, según sus familias y linajes,"
,"41":"fueron alistados cuarenta y un mil quinientos hombres aptos para la guerra."
,"42":"De la tribu de Neftalí, contando los nombres de todos los varones de veinte años para arriba, según sus familias y linajes,"
,"43":"fueron alistados cincuenta y tres mil cuatrocientos hombres aptos para la guerra."
,"44":"Estos son los hijos de Israel aptos para la guerra contados por Moisés y Aarón, ayudados por los doce jefes de Israel, uno de cada tribu."
,"45":"Fueron contados según sus linajes y familias"
,"46":"y resultaron en total seiscientos tres mil quinientos cincuenta."
,"47":"Los levitas no fueron contados ni alistados,"
,"48":"pues Yavé habló a Moisés y le dijo:"
,"49":"'No contarás a los de la tribu de Leví junto con los hijos de Israel,"
,"50":"sino que tú pondrás a los levitas al servicio y cuidado de la Morada del Testimonio, de todos sus utensilios y de todo cuanto le pertenece. Ellos llevarán la Morada y todos sus utensilios, servirán en ella y acamparán en torno a ella."
,"51":"Cuando la Morada haya de trasladarse, los levitas la desarmarán; cuando tenga que pararse, ellos la montarán. Cualquier extraño que se acerque, será castigado de muerte."
,"52":"Los hijos de Israel acamparán cada uno en su campamento y bajo su bandera, por cuerpos de ejército,"
,"53":"mientras que los levitas acamparán alrededor de la Morada del Testimonio, y cuidarán de ella, para que así no venga la cólera contra la comunidad de los hijos de Israel.'"
,"54":"Los hijos de Israel lo hicieron tal como se lo había mandado Yavé a Moisés."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Yavé dijo a Moisés y a Aarón:"
,"2":"'Los hijos de Israel acamparán cada uno bajo su bandera, bajo las enseñas de sus familias, en torno a la Tienda de las Citas divinas, y frente a ella."
,"3":"La tribu de Judá acampará hacia el oriente, por donde sale el sol, con su bandera y los diversos cuerpos de su ejército. Najasón, hijo de Aminadab, será el jefe de los hijos de Judá."
,"4":"Su ejército es, según el censo, de setenta y cuatro mil seiscientos hombres."
,"5":"Junto a él acampará la tribu de Isacar: Natanel, hijo de Suar, será el jefe de los hijos de Isacar."
,"6":"Su ejército es, según el censo, de cincuenta y cuatro mil cuatrocientos hombres."
,"7":"Luego estará la tribu de Zabulón: Eliab, hijo de Jelón, será el jefe de los hijos de Zabulón."
,"8":"Su ejército es, según el censo, de cincuenta y siete mil cuatrocientos hombres."
,"9":"El total del campamento de Judá es, según el censo, de ciento ochenta y seis mil cuatrocientos hombres; éstos marcharán a la vanguardia."
,"10":"Al sur acampará la tribu de Rubén, con sus cuerpos de ejército. El jefe será Elisur, hijo de Sedeur."
,"11":"Su ejército es, según el censo, de cuarenta y seis mil quinientos hombres."
,"12":"Junto a él acampará la tribu de Simeón; Selumiel, hijo de Surisadday, será el jefe de los hijos de Simeón."
,"13":"Su ejército es, según el censo, de cincuenta y nueve mil trescientos hombres."
,"14":"Luego estará la tribu de Gad, cuyo jefe será Elysaf, hijo de Duel."
,"15":"Su ejército es, según el censo, de cuarenta y cinco mil seiscientos cincuenta hombres."
,"16":"El total del campamento de Rubén es, según el censo, de ciento cincuenta y cuatro mil cuatrocientos cincuenta hombres; éstos marcharán en segundo lugar."
,"17":"Partirá entonces la Tienda de las Citas, y el campamento de los levitas estará en medio de los demás campamentos. En el mismo orden que llegaron partirán, cada uno por el lado que le corresponda y bajo su propia bandera."
,"18":"Al occidente acampará la tribu de Efraím, por cuerpos de ejército. Elisama, hijo de Ammiud, será el jefe de los hijos de Efraím."
,"19":"Su ejército es, según el censo, de cuarenta mil quinientos hombres."
,"20":"Junto a él estará la tribu de Manasés, su jefe será Gamaliel, hijo de Pedasur."
,"21":"Su ejército es, según el censo, de treinta y dos mil doscientos hombres."
,"22":"Luego estará la tribu de Benjamín, cuyo jefe es Abidam, hijo de Guedeoní."
,"23":"Su ejército es, según el censo, de treinta y cinco mil cuatrocientos hombres"
,"24":"El total del campamento de Efraím es, según el censo, de ciento ocho mil cien hombres; éstos marcharán en tercer lugar."
,"25":"Al norte, la tribu de Dan bajo su bandera y con sus diversos cuerpos de ejército. El jefe será Abiezer, hijo de Ammisadday."
,"26":"Su ejército es, según el censo, de sesenta y dos mil setecientos hombres."
,"27":"Junto a él acampará la tribu de Aser, cuyo jefe será Paguiel, hijo de Ocrón."
,"28":"Su ejército es, según el censo, de cuarenta y un mil quinientos hombres."
,"29":"Luego estará la tribu de Neftalí; Ajira, hijo de Enan, será el jefe."
,"30":"Su ejército es, según el censo, de cincuenta y tres mil cuatrocientos hombres."
,"31":"El total del campamento de Dan es, según el censo, de ciento cincuenta y siete mil seiscientos hombres. Estos marcharán en retaguardia, cada uno bajo su bandera."
,"32":"Estos fueron los hijos de Israel contados según sus familias paternas. El total de los hombres alistados para la guerra en los diversos campamentos y repartidos en diferentes cuerpos de ejército era de seiscientos tres mil quinientos cincuenta."
,"33":"Pero los de la tribu de Leví no fueron alistados como los demás, pues así se lo había mandado Yavé a Moisés."
,"34":"Los hijos de Israel hicieron todo, tal como Yavé lo había ordenado a Moisés: así acampaban y así emprendían la marcha, cada uno con su tribu, bajo su bandera y con los de su familia."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Estos son los descendientes de Aarón y de Moisés en el tiempo que Yavé habló a Moisés en el monte Sinaí."
,"2":"Estos son los nombres de los hijos de Aarón: Nadab, el primogénito; Abihú, Eleazar e Itamar."
,"3":"Estos son los nombres de los hijos de Aarón que fueron ungidos sacerdotes y que fueron consagrados para ejercer el sacerdocio."
,"4":"Nadab y Abihú murieron delante de Yavé cuando ofrecieron a Yavé un fuego profano, en el desierto del Sinaí, y como no tenían hijos, Eleazar e Itamar fueron los que ejercieron el sacerdocio junto con su padre Aarón."
,"5":"Yavé dijo a Moisés:"
,"6":"'Manda que se acerquen los de la tribu de Leví. Estarán al servicio de Aarón, el sacerdote,"
,"7":"y compartirán la responsabilidad de Aarón y de toda la comunidad en todo lo referente a la Tienda de las Citas; estarán a cargo del servicio de la Morada."
,"8":"Los Levitas cuidarán de todos los utensilios de la Tienda de las Citas, de todo lo que ha sido encargado a los hijos de Israel: estarán a cargo del servicio de la Morada."
,"9":"Darás los levitas a Aarón y a sus hijos en concepto de 'donados': son tomados de entre los hijos de Israel y le son donados."
,"10":"Pero reservarás a Aarón y sus hijos las funciones sacerdotales. El que no sea levita y se acerque, morirá.'"
,"11":"Yavé dijo a Moisés:"
,"12":"'He elegido a los levitas de entre los demás hijos de Israel, en lugar de todos los primogénitos de Israel, de los que abren el seno materno: los Levitas serán, pues, para mí."
,"13":"Porque todo primogénito me pertenece desde el día en que hice morir a todos los primogénitos de Egipto; entonces consagré para mí a todos los primogénitos de Israel; tanto de hombre como de ganado son para mí: ¡Yo soy Yavé!'"
,"14":"Yavé dijo a Moisés en el desierto de Sinaí:"
,"15":"'Alista a los hijos de Leví por familias y por clanes: alistarás a todo varón de un mes para arriba.'"
,"16":"Moisés los alistó según la orden de Yavé, tal como se lo había mandado."
,"17":"Los nombres de los hijos de Leví son: Guersón, Quehat y Merarí."
,"18":"Estos son los nombres de los hijos de Guersón, por familias: Libní y Semeí."
,"19":"Los hijos de Quehat, por familias: Amram, Yishar, Hebrón y Uziel."
,"20":"Los hijos de Merarí, por clanes: Majlí y Musí. Estos son los clanes de Leví y sus familias paternas."
,"21":"De Guersón procedían la familia libnita y la familia semeíta: ésas son las familias guersonitas."
,"22":"Los varones de un mes para arriba, eran siete mil quinientos."
,"23":"Las familias de los guersonitas acampaban detrás de la Morada, al poniente."
,"24":"El jefe de la casa de Guersón era Eliasaf, hijo de Sael."
,"25":"Los hijos de Guersón estaban encargados de la tienda, de su toldo y de la cortina de entrada a la Tienda de las Citas,"
,"26":"del cortinaje del atrio y de la cortina de entrada al atrio que rodea la Morada, del altar y de las cuerdas necesarias para todo su servicio."
,"27":"De Quehat procedían la familia amramita, la yisharita, la hebronita y la uzielita: ésas son las familias quehatitas."
,"28":"Contando todos los varones de un mes para arriba, eran ocho mil seiscientos al servicio del santuario."
,"29":"Las familias quehatitas acampaban al lado meridional de la Morada."
,"30":"El jefe de la familia quehatita era Elisafán, hijo de Uziel."
,"31":"A su cargo estaban el Arca, la mesa, el candelabro, los altares, los objetos sagrados que se usan en el culto, el velo y todo su servicio."
,"32":"El jefe de los levitas era Eleazar, hijo del sacerdote Aarón. Ejercía la supervisión de todos los que guardaban el Santuario."
,"33":"De Merarí procedían la familia majlita y la musita: ésas eran las familias meraritas."
,"34":"Contando todos los varones de un mes para arriba, eran seis mil doscientos."
,"35":"El jefe de la familia merarita era Suriel, hijo de Abijayil. Acampaban al lado septentrional de la Morada."
,"36":"A los hijos de Merarí les estaba encomendado el cuidado de los tablones de la Morada,"
,"37":"de sus travesaños, columnas y bases, de todos sus utensilios; y de las columnas que rodeaban el atrio con sus basas, clavos y cuerdas."
,"38":"Al este, frente a la Morada, delante de la Tienda de las Citas hacia oriente, acampaban Moisés y Aarón con sus hijos, que estaban encargados del Santuario en nombre de los hijos de Israel. Cualquier laico que se acercara, sería muerto."
,"39":"El total de los levitas, de todos los varones de un mes para arriba era de veintidós mil; Moisés y Aarón los habían registrado por familias, siguiendo la orden de Yavé."
,"40":"Entonces Yavé dijo a Moisés: 'Registra a todos los primogénitos varones de los hijos de Israel, de un mes para arriba, y anota su número."
,"41":"Luego, toma a los levitas para mí, Yavé, en lugar de todos los primogénitos de los israelitas; y toma el ganado de los levitas en lugar de todos los primogénitos del ganado de los hijos de Israel.'"
,"42":"Moisés registró, según le había ordenado Yavé, a todos los primogénitos de los hijos de Israel,"
,"43":"y el total de los primogénitos varones, contando los hombres desde la edad de un mes para arriba, según el censo, resultó ser veintidós mil doscientos setenta y tres."
,"44":"Entonces Yavé dijo a Moisés:"
,"45":"'Toma a los levitas en lugar de todos los primogénitos de los hijos de Israel, y el ganado de los levitas en lugar de su ganado; así los levitas serán míos: ¡Yo soy Yavé!"
,"46":"Pero has de rescatar los doscientos setenta y tres primogénitos que exceden del número de los levitas;"
,"47":"toma, pues, cinco siclos por cabeza, en siclos del santuario, a razón de veinte granos por siclo."
,"48":"La plata se la entregarás a Aarón y a sus hijos como rescate de los que sobrepasan el número.'"
,"49":"Moisés tomó la plata del rescate de los que sobraban después de rescatar a los otros con los levitas."
,"50":"Esta plata que pidió a los primogénitos de Israel era de mil trescientos sesenta y cinco siclos, en siclos del Santuario;"
,"51":"Moisés la entregó a Aarón y a sus hijos según Yavé le había ordenado."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Yavé dijo a Moisés y a Aarón:"
,"2":"'Dentro de los levitas, haz el censo de los hijos de Quehat, por clanes y familias,"
,"3":"de todos los de más de treinta años hasta los cincuenta, aptos para entrar al servicio de la Tienda de las Citas."
,"4":"Este será el servicio de los hijos de Quehat en la Tienda de las Citas, y es un servicio muy santo."
,"5":"Cuando se levante el campamento, Aarón y sus hijos descolgarán la cortina y cubrirán con ella el Arca del Testimonio."
,"6":"Pondrán sobre ella una cubierta de cuero fino y extenderán encima un paño todo de púrpura; luego le pondrán las varas."
,"7":"Sobre la mesa de los panes ofrecidos extenderán un paño de púrpura y pondrán sobre ella las fuentes, copas, vasos y jarros de libación, y el pan que está siempre encima."
,"8":"Extenderán sobre ella un paño carmesí, que cubrirán con una cubierta de cuero fino, y después le pondrán las varas."
,"9":"Tomarán entonces un paño de púrpura y cubrirán el candelabro del alumbrado con sus lámparas, despabiladeras y ceniceros, y todos los vasos de aceite que se utilizan en el servicio del candelabro."
,"10":"Lo pondrán con todos sus utensilios en una cubierta de cuero fino y lo colocarán sobre las angarillas."
,"11":"Sobre el altar de oro extenderán un paño de púrpura. Lo cubrirán con una cubierta de cuero fino, y le pondrán las varas."
,"12":"Tomarán luego todos los vasos que se empleen en el servicio del Santuario, los pondrán en un paño de púrpura, los cubrirán con una cubierta de cuero fino y los colocarán sobre las angarillas."
,"13":"Quitarán las cenizas del altar y extenderán sobre él un paño escarlata."
,"14":"Pondrán encima todos los utensilios para su servicio: los braseros, tenedores, palas y platos; extenderán sobre él una cubierta de cuero fino y le pondrán las varas."
,"15":"Después que Aarón y sus hijos hayan terminado de envolver las cosas sagradas con todos los utensilios y puesto en marcha el campamento, los hijos de Quehat se acercarán para transportarlas; pero que no toquen lo que es sagrado, no sea que mueran. Este es el papel de los hijos de Quehat en la Tienda de las Citas."
,"16":"Eleazar, hijo del sacerdote Aarón, estará al cuidado del aceite del alumbrado, del incienso aromático, de los panes de ofrenda perpetua y del óleo de unción; cuidará de toda la Morada y de cuanto hay en ella, sean cosas sagradas o sus utensilios.'"
,"17":"Yavé dijo a Moisés y a Aarón:"
,"18":"'No dejen que los quehatitas mueran y desaparezca su familia de entre los demás hijos de Leví."
,"19":"Hagan con ellos de esta manera, para que vivan y no mueran cuando se acercan a las cosas muy sagradas. Aarón y sus hijos se adelantarán para poner a cada uno en su servicio y darle su carga,"
,"20":"pero no entrarán, ni por un instante, a ver las cosas sagradas; de lo contrario, morirán.'"
,"21":"Yavé dijo a Moisés:"
,"22":"'Haz también el censo de los hijos de Guersón por familias y clanes."
,"23":"Alistarás a los de treinta años para arriba hasta cincuenta, aptos para prestar servicio en la Tienda de las Citas."
,"24":"Estas serán las obligaciones de su servicio:"
,"25":"llevarán las cortinas de la Morada y de la Tienda de las Citas, el toldo y la capa de cuero fino que la cubre por encima y la cortina de la entrada de la Tienda de las Citas,"
,"26":"los cortinajes del atrio y la cortina de la entrada de la puerta anterior al atrio que rodea la Morada y el altar. También las cuerdas y todos los utensilios que usan en su servicio. Todo lo que se necesita para su trabajo."
,"27":"Los hijos de Guersón prestarán su servicio y desempeñarán sus funciones y obligaciones a las órdenes de Aarón y de sus hijos."
,"28":"Este será el servicio de las familias guersonitas en la Tienda de las Citas, bajo las órdenes de Itamar, hijo del sacerdote Aarón."
,"29":"Harás el censo de los hijos de Merarí, por clanes y familias,"
,"30":"de todos los de treinta años hasta los cincuenta, aptos para prestar servicio en la Tienda de las Citas."
,"31":"Esto es lo que han de transportar y éste es el servicio que ellos prestarán en la Tienda de las Citas: los tablones de la Morada, sus travesaños, columnas y basas;"
,"32":"las columnas que rodean el atrio con sus basas, clavos y cuerdas: todos sus utensilios y todo lo necesario para su servicio. Señalarán con nombre cada uno de los objetos que han de transportar."
,"33":"Este es el servicio de los clanes meraritas. En todo lo referente al servicio de la Tienda de las Citas, estarán a las órdenes de Itamar, hijo de Aarón.'"
,"34":"Moisés, Aarón y los jefes de la comunidad hicieron el censo de los hijos de Quehat, por clanes y familias,"
,"35":"de todos los de más de treinta años hasta los cincuenta, aptos para prestar servicio en la Tienda de las Citas."
,"36":"Fueron registrados por clanes: eran dos mil setecientos treinta."
,"37":"Así fueron registrados en las familias quehatitas todos los que tenían que servir en la Tienda de las Citas. Los alistaron Moisés y Aarón, según lo ordenado por Yavé."
,"38":"Se hizo el censo de los hijos de Guersón, por clanes y familias,"
,"39":"de todos los de treinta años hasta los cincuenta, aptos para el servicio en la Tienda de las Citas."
,"40":"Fueron registrados por clanes y familias: eran dos mil seiscientos treinta."
,"41":"Así fueron registrados los hijos de Guersón que habían de servir en la Tienda de las Citas. Los alistaron Moisés y Aarón según la orden de Yavé."
,"42":"Se hizo el censo de los clanes de los hijos de Merarí, por clanes y familias,"
,"43":"de todos los de treinta años para arriba hasta los cincuenta, aptos para servir en la Tienda de las Citas."
,"44":"Fueron registrados por clanes: eran tres mil doscientos."
,"45":"Los alistaron Moisés y Aarón, según lo había ordenado Yavé a Moisés."
,"46":"El total de los levitas que Moisés, Aarón y los jefes de Israel registraron por clanes y familias,"
,"47":"de todos los de treinta años hasta los cincuenta aptos para servir y transportar las cosas de la Tienda de las Citas"
,"48":"fue, según el censo, de ocho mil quinientos ochenta."
,"49":"Por orden de Yavé cada uno fue registrado señalándole su servicio y lo que debía transportar. El censo se hizo tal y como Yavé había mandado a Moisés."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Yavé dijo a Moisés:"
,"2":"'Manda a los hijos de Israel que echen del campamento a todos los leprosos, a los que están impuros por flujo seminal y a todos los que están impuros por haber tocado algún muerto."
,"3":"Ya sean hombres o mujeres, los echarán fuera del campamento para que no lo hagan impuro, pues yo habito en medio de ustedes.'"
,"4":"Así lo hicieron los hijos de Israel: los echaron fuera del campamento, tal como Yavé lo había mandado a Moisés."
,"5":"Yavé dijo a Moisés:"
,"6":"'Di a los hijos de Israel: El hombre o la mujer que cometa algún pecado en perjuicio de otro, ofendiendo a Yavé, será reo de delito."
,"7":"Confesará el pecado que ha cometido y restituirá exactamente el objeto del delito, añadirá una quinta parte más y se la devolverá al que fue perjudicado."
,"8":"Y si no hay personas a quien devolver la cosa, se la darán a Yavé. El culpable se la dará al sacerdote, además del carnero de reparación que se ofrece por él."
,"9":"Asimismo, la mejor parte de todas las primicias que ofrecen los hijos de Israel pertenece al sacerdote."
,"10":"Los sacrificios que cada cual ofrece le pertenecen, a excepción de lo que entrega en manos del sacerdote.'"
,"11":"Yavé dijo a Moisés:"
,"12":"'Habla a los hijos de Israel respecto del caso siguiente. Un hombre tiene una mujer que se porta mal y lo engaña;"
,"13":"otro hombre ha tenido relaciones con ellas en secreto y ella supo disimular este acto impuro de tal manera que nadie lo ha visto y no hay testigos."
,"14":"Puede ser que un espíritu de celos entre en el marido y que tiene sospechas porque, de hecho, se hizo impura. Pero también puede ser que un espíritu de celos le haya entrado y tenga sospechas, siendo que ella le ha sido fiel."
,"15":"En estos casos, el hombre llevará a su mujer ante el sacerdote y presentará por ella la ofrenda correspondiente: una décima de medida de harina de cebada. No derramará aceite sobre la ofrenda, ni le pondrá incienso, pues es ofrenda de Celos, o sea, ofrenda para recordar y descubrir una culpa."
,"16":"El sacerdote hará que se acerque la mujer ante Yavé,"
,"17":"tomará luego agua santa en un vaso de barro y, recogiendo polvo del suelo de la Morada, lo esparcirá en el agua."
,"18":"Así, puesta la mujer delante de Yavé, el sacerdote le descubrirá la cabeza y pondrá en sus manos la ofrenda para recordar la culpa, mientras que él mismo tendrá en sus manos el agua de amargura que trae la maldición."
,"19":"Entonces el sacerdote pedirá a la mujer que repita esta maldición: 'Si nadie más que tu marido se ha acostado contigo y no te has descarriado con otro hombre, esta agua amarga que trae la maldición manifestará tu inocencia."
,"20":"Pero si te has ido con otro que no es tu marido, y te has manchado teniendo relaciones con otro hombre..."
,"21":"Y el sacerdote proseguirá con la fórmula de maldición: Que Yavé te convierta en maldición y abominación en medio de tu pueblo; que se marchiten tus senos y que se te hinche el vientre."
,"22":"Entren en tus entrañas las aguas que traen la maldición, haciendo que se pudran tus muslos y reviente tu vientre.' Y la mujer responderá: ¡Así sea, así sea!"
,"23":"Después, el sacerdote escribirá en una hoja estas imprecaciones y las lavará en el agua amarga."
,"24":"Y dará a beber a la mujer estas aguas que traen la maldición."
,"25":"El sacerdote tomará de manos de la mujer la ofrenda por los celos, la llevará a la presencia de Yavé y la pondrá sobre el altar."
,"26":"Luego tomará un puñado de la harina ofrecida en sacrificio y la quemará sobre el altar; finalmente, dará a beber el agua amarga a la mujer."
,"27":"Si la mujer fue infiel a su marido y se hizo impura, el agua que bebió se volverá amarga en ella, se le hinchará el vientre y se le marchitarán los senos y será mujer maldita en medio de su pueblo."
,"28":"Pero si la mujer no se hizo impura, sino que ha sido fiel, no sufrirá y podrá tener hijos."
,"29":"Este es el rito de los celos, para cuando una mujer peca con otro hombre y se hace impura;"
,"30":"o para cuando a un hombre le entren celos y se ponga celoso de su esposa. Entonces llevará a su esposa en presencia de Yavé y el sacerdote cumplirá todos estos ritos."
,"31":"Con esto el marido estará exento de culpa y ella pagará la pena de su pecado.'"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Yavé dijo a Moisés:"
,"2":"'Di a los hijos de Israel: Si un hombre o una mujer se consagra a Yavé mediante el voto de nazireato,"
,"3":"no beberá ni vino ni bebida alguna que pueda embriagar, ni vinagre hecho de vino o de otra bebida embriagante cualquiera, ni tampoco jugo alguno exprimido de uvas; no comerá uvas frescas ni pasas."
,"4":"Todo el tiempo que sea nazireo, no comerá fruto alguno de la vid, desde los granos hasta el hollejo."
,"5":"Todo el tiempo de su consagración como nazireo, no se pasará la navaja por su cabeza; hasta que pasen los días de su consagración, será persona consagrada y se dejará crecer la cabellera."
,"6":"Durante el tiempo de su consagración no se acercará a ningún cadáver,"
,"7":"aunque sea de su padre o madre, de su hermano o hermana; en pocas palabras, si a ésos les toca morir, no se hará impuro por cuanto tiene en su cabeza la consagración a su Dios."
,"8":"Todo el tiempo de su voto está consagrado a Yavé."
,"9":"Si alguien muere de repente junto a él, y con esto su cabeza consagrada ha quedado impura, se rapará la cabeza el día que se purifique, y se la rapará otra vez al séptimo día."
,"10":"El octavo día ofrecerá dos tórtolas o dos pichones al sacerdote a la entrada de la Tienda de las Citas."
,"11":"El sacerdote ofrecerá uno en sacrificio por el pecado y el otro en holocausto; así expiará por aquel hombre la impureza contraída a causa del muerto. Consagrará de nuevo su cabeza el mismo día:"
,"12":"se consagrará a Yavé por toda la duración de su voto de nazireo y ofrecerá un cordero de un año como sacrificio por el delito. Los días anteriores son nulos, pues su voto de nazireo ha sido interrumpido."
,"13":"Esta es la ley referente a los nazireos. Cuando se cumpla el plazo de su consagración, el nazireo será conducido a la entrada de la Tienda de las Citas"
,"14":"y presentará su ofrenda a Yavé: un cordero de un año sin defecto en holocausto; una oveja de un año sin defecto en sacrificio por el pecado; un carnero sin defecto como sacrificio de comunión;"
,"15":"un canastillo de panes ázimos de flor de harina amasada con aceite, y tortas sin levadura untadas en aceite con sus correspondientes oblaciones y libaciones."
,"16":"El sacerdote presentará todo esto a Yavé y ofrecerá el sacrificio por el pecado y el holocausto."
,"17":"Ofrecerá a Yavé el carnero del sacrificio de comunión junto con el canastillo de panes sin levadura y, luego, hará la ofrenda y la libación."
,"18":"Entonces el nazireo se rapará su cabellera a la entrada de la Tienda de las Citas; tomará su cabellera de nazireo y la echará al fuego que arde debajo del sacrificio de comunión."
,"19":"En cuanto la espaldilla del carnero esté cocida, el sacerdote la tomará; tomará también un pan y una torta sin levadura, y lo pondrá todo en manos del nazireo que acaba de rapar su cabeza."
,"20":"El sacerdote lo mecerá todo delante de Yavé como se hace con las ofrendas. Son cosas consagradas y pertenecen al sacerdote, lo mismo que el pecho que fue mecido y el pernil que fue ofrecido. Hecho esto, el nazireo ya podrá beber vino."
,"21":"Esta es la ley referente al nazireo que viene a presentar su ofrenda a Yavé con ocasión de su voto, aparte de lo que sus posibilidades le permitan. Si prometió algo más al hacer su voto, lo cumplirá después de cumplido lo previsto por la ley del nazireato.'"
,"22":"Yavé dijo también a Moisés:"
,"23":"'Di a Aarón y a sus hijos: Así bendecirán a los hijos de Israel. Dirán:"
,"24":"'¡Yavé te bendiga y te guarde!"
,"25":"¡Yavé haga resplandecer su rostro sobre ti y te mire con buenos ojos!"
,"26":"¡Yavé vuelva hacia ti su rostro y te dé la paz.'"
,"27":"Es así como ellos pondrán mi Nombre sobre los hijos de Israel, y yo los bendeciré.'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"El día en que Moisés terminó la Morada, la ungió y la santificó con todo su mobiliario. Después de la consagración del altar y de todos sus utensilios,"
,"2":"los jefes de Israel, jefes de los clanes y de las tribus que habían presidido el censo, hicieron una ofrenda."
,"3":"Ofrecieron a Yavé seis carretas cubiertas y doce bueyes: una carreta por cada dos jefes y un buey por cada uno, y los presentaron delante de la Morada."
,"4":"Entonces Yavé habló a Moisés y le dijo:"
,"5":"'Recibe todo esto de su mano para el servicio de la Tienda de las Citas. Dáselo a los levitas, a cada uno según su servicio.'"
,"6":"Moisés recibió las carretas y los bueyes y se los dio a los levitas:"
,"7":"dos carretas y cuatro bueyes a los hijos de Guersón, para su trabajo;"
,"8":"cuatro carretas y ocho bueyes a los hijos de Merarí, para el trabajo que cumplían a las órdenes de Itamar, hijo del sacerdote Aarón."
,"9":"Pero no dio ni buey ni carreta a los hijos de Quehat, porque estaban a cargo del servicio del santuario y llevaban su carga al hombro."
,"10":"Los jefes hicieron su ofrenda en ese día de la dedicación del altar, y presentaron su ofrenda delante del altar que acababa de ser consagrado."
,"11":"Y Yavé dijo a Moisés: 'Cada día uno de los jefes vendrá para hacer su ofrenda por la dedicación del altar.'"
,"12":"Najasón, hijo de Aminadab, de la tribu de Judá, hizo su ofrenda el primer día."
,"13":"Ofreció una fuente de plata de ciento treinta siclos de peso, un platillo de plata de setenta siclos, en siclos del Santuario, ambos llenos de flor de harina amasada con aceite, para la oblación;"
,"14":"una naveta de oro de diez siclos, llena de incienso;"
,"15":"un novillo, un carnero, un cordero de un año, para el holocausto;"
,"16":"un chivo para el sacrificio por el pecado;"
,"17":"y para el sacrificio de comunión, dos bueyes, cinco carneros, cinco machos cabríos y cinco corderos de un año. Esa fue la ofrenda de Najasón, hijo de Aminadab."
,"18":"El segundo día, Natanael, hijo de Suar, de la tribu de Isacar, hizo su ofrenda."
,"19":"Ofreció en una fuente de plata de ciento treinta siclos de peso, un platillo de plata de setenta siclos en siclos del Santuario, ambos llenos de flor de harina amasada con aceite, para la oblación;"
,"20":"una naveta de oro de diez siclos llena de incienso;"
,"21":"un novillo, un carnero, un cordero de un año para el holocausto;"
,"22":"un chivo para el sacrificio por el pecado;"
,"23":"y para el sacrificio de comunión, dos bueyes, cinco carneros, cinco machos cabríos y cinco corderos de un año. Esa fue la ofrenda de Natanael, hijo de Suar."
,"24":"El tercer día, Eliab, hijo de Helón, de la tribu de Zabulón, hizo su ofrenda."
,"25":"Ofreció una fuente de plata de ciento treinta siclos de peso, un platillo de plata de setenta siclos, en siclos del Santuario, ambos llenos de flor de harina amasada con aceite para la oblación,"
,"26":"una naveta de oro de diez siclos llena de incienso;"
,"27":"un novillo, un carnero, un cordero de un año para el holocausto;"
,"28":"un chivo para el sacrificio por el pecado;"
,"29":"y para el sacrificio de comunión, dos bueyes, cinco carneros, cinco machos cabríos y cinco corderos de un año. Esa fue la ofrenda de Eliab, hijo de Helón."
,"30":"El cuarto día, Elisur, hijo de Sedeur, de la tribu de Rubén, hizo su ofrenda."
,"31":"Ofreció una fuente de plata de ciento treinta siclos de peso, un platillo de plata de setenta siclos de peso, en siclos del Santuario, ambos llenos de flor de harina amasada con aceite para la oblación;"
,"32":"una naveta de diez siclos de oro llena de incienso;"
,"33":"un novillo, un carnero, un cordero de un año, para el holocausto;"
,"34":"un chivo para el sacrificio por el pecado;"
,"35":"y para el sacrificio de comunión, dos bueyes, cinco carneros, cinco machos cabríos y cinco corderos de un año. Esa fue la ofrenda de Elisur, hijo de Sedeur."
,"36":"El quinto día, Selumiel, hijo de Surisadday, de la tribu de Simeón, hizo su ofrenda."
,"37":"Ofreció una fuente de plata de ciento treinta siclos de peso, un platillo de plata de setenta siclos, en siclos del Santuario, ambos llenos con flor de harina amasada con aceite, para la oblación;"
,"38":"una naveta de oro de diez siclos llena de incienso;"
,"39":"un novillo, un carnero y un cordero de un año para el holocausto;"
,"40":"un chivo para el sacrificio por el pecado;"
,"41":"y para el sacrificio de comunión, dos bueyes, cinco carneros, cinco machos cabríos y cinco corderos de un año. Esa fue la ofrenda de Selumiel, hijo de Surisadday."
,"42":"El día sexto, Elyasaf, hijo de Duel, de la tribu de Gad, hizo su ofrenda."
,"43":"Ofreció una fuente de plata de ciento treinta siclos, un platillo de plata de setenta siclos, en siclos del Santuario, ambos llenos con flor de harina amasada con aceite para la oblación;"
,"44":"una naveta de oro de diez siclos llena de incienso;"
,"45":"un novillo, un carnero y un cordero de un año, para el holocausto;"
,"46":"un chivo para el sacrificio por el pecado;"
,"47":"y para el sacrificio de comunión, dos bueyes, cinco carneros, cinco machos cabríos y cinco corderos de un año. Esa fue la ofrenda de Elyasaf, hijo de Duel."
,"48":"El día séptimo, Elisama, hijo de Ammihud, de la tribu de Efraím, hizo su ofrenda."
,"49":"Ofreció una fuente de plata de ciento treinta siclos, un platillo de setenta siclos de peso, en siclos del Santuario, ambos llenos de flor de harina amasada con aceite para la oblación;"
,"50":"una naveta de oro de diez siclos de peso, llena de incienso;"
,"51":"un novillo, un carnero y un cordero de un año para el holocausto;"
,"52":"un chivo para el sacrificio por el pecado,"
,"53":"y para el sacrificio de comunión, dos bueyes, cinco carneros cinco machos cabríos y cinco corderos de un año. Esa fue la ofrenda de Elisama, hijo de Ammihud."
,"54":"El día octavo, Gamaliel, hijo de Pedasur, de la tribu de Manasés, hizo su ofrenda."
,"55":"Ofreció una fuente de plata de ciento treinta siclos de peso, un platillo de plata de setenta siclos, en siclos del Santuario, ambos llenos de flor de harina amasada con aceite para la oblación;"
,"56":"una naveta de oro de diez siclos de peso, llena de incienso;"
,"57":"un novillo, un carnero y un cordero de un año para el holocausto;"
,"58":"un chivo para el sacrificio por el pecado;"
,"59":"y para el sacrificio de comunión, dos bueyes, cinco carneros, cinco machos cabríos y cinco corderos de un año. Esa fue la ofrenda de Gamaliel, hijo de Pedasur."
,"60":"El día nono, Abidam, hijo de Guedeoní, de la tribu de Benjamín, hizo su ofrenda."
,"61":"Ofreció una fuente de plata de ciento treinta siclos de peso, un platillo de plata de setenta siclos, en siclos del Santuario, ambos llenos de flor de harina amasada con aceite para la oblación;"
,"62":"una naveta de oro de diez siclos, llena de incienso,"
,"63":"un novillo, un carnero, un cordero de un año para el holocausto;"
,"64":"un chivo para el sacrificio por el pecado;"
,"65":"y para el sacrificio de comunión, dos bueyes, cinco carneros, cinco machos cabríos y cinco corderos de un año. Esa fue la ofrenda de Abidam, hijo de Guedeoní."
,"66":"El décimo día, Abiezer, hijo de Ammisadday, de la tribu de Dan, hizo su ofrenda."
,"67":"Ofreció una fuente de plata de ciento treinta siclos de peso, un platillo de plata de setenta siclos de peso, en siclos del Santuario, ambos llenos de flor de harina amasada con aceite para la oblación;"
,"68":"una naveta de oro de diez siclos, llena de incienso;"
,"69":"un novillo, un carnero, un cordero de un año para el holocausto;"
,"70":"un chivo para el sacrificio por el pecado;"
,"71":"y para el sacrificio de comunión, dos bueyes, cinco carneros, cinco machos cabríos y cinco corderos de un año. Esto fue lo que ofreció Abiezer, hijo de Ammisadday."
,"72":"El día undécimo, Pagiel, hijo de Ocrón, de la tribu de Aser, hizo su ofrenda."
,"73":"Ofreció una fuente de plata de ciento treinta siclos de peso, un platillo de plata de setenta siclos de peso, en siclos del Santuario, ambos llenos de flor de harina amasada con aceite, para la oblación;"
,"74":"una naveta de oro de diez siclos llena de incienso;"
,"75":"un novillo, un carnero y un cordero de un año para el holocausto;"
,"76":"un chivo para el sacrificio por el pecado;"
,"77":"y para el sacrificio de comunión, dos bueyes, cinco carneros, cinco machos cabríos y cinco corderos de un año. Esa fue la ofrenda de Pagiel, hijo de Ocrón."
,"78":"El día duodécimo, Ajirá, hijo de Enan, de la tribu de Neftalí, hizo su ofrenda."
,"79":"Ofreció una fuente de plata de ciento treinta siclos de peso, un platillo de plata de setenta siclos de peso, en siclos del Santuario, los dos llenos de flor de harina amasada en aceite para la oblación;"
,"80":"una naveta de oro de diez siclos de peso, llena de incienso;"
,"81":"un novillo, un carnero y un cordero de un año para el holocausto;"
,"82":"un chivo para el sacrificio por el pecado; y para el sacrificio de comunión,"
,"83":"dos bueyes, cinco carneros, cinco machos cabríos y cinco corderos de un año. Esa fue la ofrenda de Ajirá, hijo de Enan."
,"84":"Esa fue la ofrenda de los jefes de Israel en la dedicación del altar, el día en que fue consagrado: doce fuentes de plata, doce platillos de plata y doce navetas de oro."
,"85":"Cada fuente era de ciento treinta siclos, y cada platillo de setenta siclos. Los siclos de plata de todos estos objetos eran en total dos mil cuatrocientos, en siclos del Santuario."
,"86":"Las navetas de oro eran doce, llenas de incienso. Cada naveta era de diez siclos, en siclos del santuario. Los siclos de oro de las navetas sumaban en total ciento veinte."
,"87":"El total del ganado: para el holocausto, doce novillos, doce carneros, doce corderos de un año, con sus oblaciones correspondientes; para el sacrificio por el pecado, doce chivos."
,"88":"El total del ganado para los sacrificios de comunión: veinticuatro novillos, sesenta carneros, sesenta machos cabríos y sesenta corderos de un año. Estas fueron las ofrendas de la dedicación del altar una vez que fue consagrado."
,"89":"Cuando Moisés entraba en la Tienda de las Citas para hablar con El, oía la voz que le hablaba de lo alto del Lugar del Perdón que está sobre el Arca del Testimonio, de entre los dos querubines. Entonces Moisés hablaba con El."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Yavé dijo a Moisés:"
,"2":"'Di a Aarón: Cuando dispongas las lámparas, las colocarás de manera que las siete lámparas alumbren hacia la parte delantera del candelabro.'"
,"3":"Así lo hizo Aarón: colocó las lámparas en la parte delantera del candelabro, tal como Yavé lo había mandado a Moisés."
,"4":"Este candelabro era de oro macizo; desde el pie hasta las flores eran de oro macizo. Hicieron el candelabro según el modelo que Yavé había mostrado a Moisés."
,"5":"Yavé dijo a Moisés:"
,"6":"'Aparta a los levitas de entre los demás hijos de Israel y purifícalos."
,"7":"Lo harás de la siguiente manera: los rociarás con agua bendita; se rasurarán todo el cuerpo, se pondrán ropa limpia y así quedarán purificados."
,"8":"Tomarán luego un novillo, con su correspondiente oblación de flor de harina amasada con aceite, y tú tomarás otro novillo como sacrificio por el pecado."
,"9":"Mandarás que se acerquen los levitas a la Tienda de las Citas y convocarás a toda la comunidad de los hijos de Israel."
,"10":"Harás que los levitas se acerquen a Yavé, y los hijos de Israel les impondrán las manos."
,"11":"Entonces Aarón ofrecerá a los levitas, como se presenta una ofrenda mecida, pues son ellos los que estarán a cargo del servicio de Yavé."
,"12":"Los levitas impondrán sus manos sobre la cabeza de los novillos, y tú sacrificarás el primero como sacrificio por el pecado, y el otro en holocausto a Yavé: así harás la expiación por los levitas."
,"13":"Pondrás luego a los levitas delante de Aarón y de sus hijos y los presentarás como se presenta una ofrenda mecida."
,"14":"De este modo los separarás de los hijos de Israel, para que sean míos."
,"15":"Desde ese momento cuidarán del servicio en la Tienda de las Citas. Los purificarás y los presentarás como se presenta una ofrenda mecida, "
,"16":"porque me son consagrados: ellos son la parte de Israel que me ha sido dada, y yo los he recibido a cambio de todos los primogénitos, es decir de los que salen primeros del seno materno en Israel."
,"17":"Porque míos son todos los primogénitos de los hijos de Israel, tanto de hombres como de ganado: los consagré a mí el día que di muerte a todos los primogénitos en la tierra de Egipto."
,"18":"Pero ahora he escogido a los levitas en lugar de todos los primogénitos de Israel."
,"19":"Los he tomado de entre los israelitas y se los he dado a Aarón y a sus hijos, para que sirvan en la Tienda de las Citas y atraigan la misericordia sobre los hijos de Israel. Si éstos se acercaran personalmente al Santuario morirían.'"
,"20":"Moisés y Aarón y toda la comunidad de los hijos de Israel hicieron con los levitas conforme Yavé había mandado a Moisés."
,"21":"Los levitas fueron purificados y se pusieron ropa limpia, y Aarón los presentó ante Yavé como se presenta una ofrenda, y luego hizo la expiación por ellos para que fueran purificados."
,"22":"A partir de este momento los levitas se hicieron cargo del servicio en la Tienda de las Citas, a las órdenes de Aarón y sus hijos. Como Yavé lo había mandado a Moisés, así se hizo con los levitas."
,"23":"Yavé dijo a Moisés:"
,"24":"'Esta ley también se refiere a los levitas. Los de veinticinco años para arriba servirán en la Tienda de las Citas."
,"25":"Pero, cumplidos los cincuenta años, dejarán de servir."
,"26":"En adelante podrán ayudar a sus hermanos en la Tienda de las Citas, pero ya no tendrán funciones. Así harás con los levitas en lo que se refiere a sus funciones.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"En el mes primero del segundo año de la salida de Egipto, Yavé habló a Moisés, en el desierto de Sinaí, y le dijo:"
,"2":"'Que los hijos de Israel celebren la Pascua a su tiempo."
,"3":"La celebrarán por la noche del día catorce de este mes, con todos sus ritos y ceremonias.'"
,"4":"Moisés, pues, dijo a los hijos de Israel que celebraran la Pascua"
,"5":"y ellos la celebraron el día catorce del mes, al atardecer, en el desierto del Sinaí, tal como Yavé lo había ordenado a Moisés."
,"6":"Pero sucedió que algunos hombres estaban impuros por haber tocado un cadáver humano y no pudieron celebrar la Pascua aquel día. Se presentaron a Moisés y Aarón el mismo día,"
,"7":"y les dijeron: 'Estamos impuros por haber tocado un cadáver humano, ¡qué lástima que no podamos presentar la ofrenda a Yavé cuando los hijos de Israel la están celebrando!'"
,"8":"Moisés les contestó: 'Esperen que yo escuche lo que manda Yavé respecto a ustedes.'"
,"9":"Yavé dijo a Moisés:"
,"10":"'Di a los hijos de Israel: Si uno de ustedes o de los descendientes de ustedes está impuro por haber tocado un cadáver, o está de viaje en tierra lejana, esto no le impedirá que celebre la Pascua de Yavé."
,"11":"La celebrará el día catorce del segundo mes al atardecer. Comerán el cordero con panes ázimos y hierbas amargas,"
,"12":"y no dejarán nada de él para el otro día ni le quebrarán hueso alguno. Observarán todas las ceremonias de la Pascua."
,"13":"En cambio el que, encontrándose puro y no estando de viaje deje de celebrar la Pascua, será eliminado de entre los suyos por no haber ofrecido a su tiempo la ofrenda de Yavé. Así pagará la pena de su pecado."
,"14":"Si un extranjero que vive entre ustedes quiere celebrar la Pascua de Yavé, la celebrará según los preceptos y costumbres de la Pascua. El rito será el mismo para todos, tanto para el extranjero como para ustedes."
,"15":"El día que se erigió la Morada, o sea, la Tienda de las Declaraciones divinas, la nube la cubrió."
,"16":"Y desde la tarde hasta la mañana, se vio sobre la Morada algo como un resplandor de fuego. Y fue siempre así: de día la cubría la nube y, de noche, como un resplandor de fuego."
,"17":"Cuando la nube se levantaba por encima de la Tienda, los hijos de Israel levantaban el campamento, y en el lugar donde se detenía la nube, allí acampaban de nuevo."
,"18":"Los hijos de Israel partían a la orden de Yavé, y acampaban a la orden de Yavé; y quedaban acampados todo el tiempo que la nube se detenía sobre la Tienda."
,"19":"Si la nube se detenía mucho tiempo, los hijos de Israel respetaban la orden de Yavé y no partían."
,"20":"Lo mismo si la nube se detenía sólo algunos días sobre la Morada: a la orden de Yavé levantaban el campamento, y a la orden de Yavé acampaban."
,"21":"Si la Nube estaba sobre la Tienda sólo desde el anochecer hasta la mañana siguiente y por la mañana se alzaba, ellos partían. Si estaba un día y una noche y luego se elevaba, partían."
,"22":"Si, en cambio, se detenía sobre la Tienda dos días, o un mes o un año, reposando sobre ella, los hijos de Israel se quedaban en el campamento y no partían; pero, en cuanto se elevaba la nube, ellos partían."
,"23":"A la orden de Yavé partían y a su orden acampaban, observando la decisión de Yavé, tal como la daba a Moisés."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Yavé dijo a Moisés:"
,"2":"'Hazte dos trompetas de plata: las harás de plata batida. Te servirán para convocar a la comunidad y para dar la señal de levantar el campamento."
,"3":"Cuando suenen las dos, se reunirá junto a ti toda la comunidad, a la entrada de la Tienda de las Citas."
,"4":"En cambio, si se toca una sola, será para que los responsables, los jefes de mil, se reúnan contigo."
,"5":"Cuando se toque con estrépito, partirán los que acampan al oriente."
,"6":"Cuando se toque con estrépito por segunda vez, partirán los que acampan al mediodía. Se tocará con estrépito para dar la señal de partir;"
,"7":"en cambio cuando quieras congregar al pueblo, el sonido de las trompetas será sencillo y sin redoble."
,"8":"Los sacerdotes, hijos de Aarón, tocarán las trompetas: ésta es una ley para ustedes y para sus descendientes."
,"9":"Cuando ya estén en su tierra y salgan a combatir al enemigo que les trae la guerra, ustedes tocarán las trompetas con estrépito; así se acordará Yavé, Dios de ustedes, y los librará de sus enemigos."
,"10":"En los días de alegría, en las fiestas y en las lunas nuevas, ustedes tocarán las trompetas durante el ofrecimiento de los holocaustos y sacrificios de comunión. Así harán que su Dios se acuerde de ustedes. Yo soy Yavé, Dios de ustedes.'"
,"11":"El día veinte del segundo mes del año segundo se levantó la Nube de encima de la Morada del Testimonio,"
,"12":"y los hijos de Israel partieron del desierto de Sinaí caminando por etapas. La Nube se detuvo en el desierto de Parán."
,"13":"Partieron entonces por primera vez según la orden de Yavé transmitida por Moisés."
,"14":"La bandera del campamento de la tribu de Judá partió en primer lugar, por cuerpos de ejército."
,"15":"Al frente de la tropa de Judá iba Najasón, hijo de Aminadab; al frente de la tribu de los hijos de Isacar (en formación) Natanael, hijo de Suar;"
,"16":"al frente de la tribu de los hijos de Zabulón (en formación) Eliab, hijo de Helón."
,"17":"Entonces fue desmontada la Morada y partieron los hijos de Guersón y los de Merarí, llevándola."
,"18":"Partió luego la bandera del campamento de Rubén, por cuerpos de ejército. Al frente de la tropa de Rubén iba Elisur, hijo de Sedeur;"
,"19":"al frente de la tribu de los hijos de Simeón (en formación) Selemiel, hijo de Surisadday;"
,"20":"al frente de la tribu de los hijos de Gad (en formación) Elyasaf, hijo de Duel."
,"21":"Tras éstos caminaron los quehatitas, llevando en hombros las cosas santas; así se armaba la Morada antes de que ellos llegaran."
,"22":"Partió luego la bandera del campamento de la tribu de Efraím por cuerpos de ejército; al frente de la tropa de Efraím iba Elisama, hijo de Ammiud."
,"23":"Al frente de los hijos de Manasés (en formación) Gamaliel, hijo de Pedasur;"
,"24":"al frente de la tribu de los hijos de Benjamín (en formación) Abidán, hijo de Guedeoní."
,"25":"Luego, cerrando la marcha de todos los campamentos, partió la bandera del campamento de los hijos de Dan, por cuerpos de ejército. Al frente de la tropa de Dan iba Abiezer, hijo de Amisadday;"
,"26":"al frente de la tribu de los hijos de Aser (en formación) Pagiel, hijo de Ocrón;"
,"27":"al frente de la tribu de los hijos de Neftalí (en formación) Ajirá, hijo de Enan."
,"28":"Este fue el orden de marcha de los hijos de Israel repartidos en cuerpos de ejército. Y así partieron."
,"29":"Moisés dijo a Jobab, hijo de Raguel el madianita, su suegro: 'Nosotros partimos para el lugar que Yavé nos prometió que nos daría: ¡ven pues con nosotros! Te trataremos bien porque Yavé prometió que le haría el bien a Israel.'"
,"30":"Jobab le respondió: 'No iré con ustedes sino que volveré a mi país donde mi familia.'"
,"31":"Moisés le replicó: '¡Por favor, no nos dejes. Tú conoces los lugares donde tendremos que acampar en el desierto, tú serás nuestro ojo!"
,"32":"Si vienes con nosotros, tendrás tu parte en todos los favores que Dios nos haga.'"
,"33":"Saliendo de la montaña de Yavé, caminaron tres días, y durante esos tres días de marcha, el Arca de la Alianza iba delante de ellos para ubicarles un lugar donde descansar."
,"34":"La Nube de Yavé estaba encima de ellos durante el día, cuando levantaban el campamento."
,"35":"Cuando el Arca partía, Moisés decía: '¡Levántate, Yavé! ¡Que se dispersen tus enemigos, que huyan ante ti los que te odian!'"
,"36":"Y cuando se detenía, decía: '¡Vuélvete Yavé a las miríadas de Israel!'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"El pueblo murmuró malvadamente a los oídos de Yavé. Yavé lo oyó y se enojó: se encendió el fuego de Yavé contra el pueblo y devoró las primeras tiendas del campamento."
,"2":"Entonces el pueblo le suplicó a Moisés. Moisés intercedió ante Yavé y el fuego se apagó."
,"3":"A ese lugar se le dio el nombre de Tabera porque se había encendido contra ellos el fuego de Yavé."
,"4":"El montón de gente extraña que se encontraba en medio de los Israelitas sólo pensaba en comer, y hasta los mismos israelitas se pusieron a quejarse. Decían: '¿Quién nos dará carne para comer?'"
,"5":"¡Cómo echamos de menos el pescado que gratuitamente comíamos en Egipto, los pepinos, melones, puerros, cebollas y ajos."
,"6":"Ahora tenemos la garganta seca, y no hay nada, absolutamente nada más que ese maná en el horizonte!"
,"7":"El maná era como la semilla del cilantro, se parecía a un manojo de malvavisco."
,"8":"La gente del pueblo se dispersaba para recogerlo, luego lo molían entre dos piedras o lo machacaban en un mortero. Después lo cocían en una olla y hacían con él tortillas. Su sabor era parecido al de una tortilla con aceite."
,"9":"Por la noche, apenas caía el rocío sobre el campamento, caía también el maná."
,"10":"Moisés oyó que el pueblo lloraba, cada familia a la entrada de su tienda, mientras ardía la cólera de Yavé. Moisés se afectó mucho por eso."
,"11":"Le dijo a Yavé: '¿Por qué tratas tan mal a tu servidor? ¡No me has hecho ningún favor al imponerme la carga de todo este pueblo!"
,"12":"¿Soy yo acaso quien lo dio a luz para que me digas: Llévalo en tu seno, como la nodriza lleva a su bebé, al país que prometiste bajo juramento a nuestros padres?"
,"13":"Todo el pueblo viene a mí para decirme: ¡Danos carne, queremos comerla! Pero, ¿de dónde voy a sacar carne para dársela?"
,"14":"¡No puedo conducir solo a todo este pueblo, es demasiado peso para mí!"
,"15":"Si así es como me quieres tratar, mejor mátame, te lo ruego; con eso me harías un favor y me vería libre de esta desgracia!'"
,"16":"Yavé le respondió a Moisés: 'Júntame setenta ancianos de Israel, hombres de los que sabes que son ancianos y escribas de su pueblo, y llévalos a la Tienda de las Citas. Que se paren a tu lado."
,"17":"Bajaré y hablaré contigo; luego tomaré de mi espíritu que está en ti y se lo pondré a ellos. Llevarán contigo la carga del pueblo y ya no tendrás que llevarla solo."
,"18":"Dirás al pueblo: Santifíquense para mañana, comerán carne ya que vinieron a llorar a los oídos de Yavé. Pues ustedes dijeron: ¿Quién nos dará carne para comer? ¡Estábamos tan bien en Egipto! Yavé les dará carne y la comerán."
,"19":"La comerán no sólo uno o dos, o siquiera cinco, diez o veinte días,"
,"20":"sino todo un mes, hasta que les salga por las narices y sientan asco de ella. Porque menospreciaron a Yavé que está en medio de ustedes cuando vinieron a llorar ante él, diciéndole: ¿Por qué salimos de Egipto?'"
,"21":"Moisés dijo: 'El pueblo al que pertenezco consta de seiscientos mil hombres de a pie, y tú dices: ¿¡Les voy a dar carne y la comerán todo un mes!?"
,"22":"Si se mataran para ellos rebaños de ovejas y de bueyes, ¿tendrían bastante? Si se recogieran para ellos todos los pescados del mar, ¿sería suficiente?'"
,"23":"Yavé le dijo a Moisés: '¡Así que la mano de Yavé es muy corta! Ahora verás si mi palabra se cumple o no.'"
,"24":"Moisés salió y transmitió al pueblo las palabras de Yavé: Reunió a setenta hombres de entre los ancianos del pueblo, que se pusieron de pie alrededor de la Tienda."
,"25":"Entonces Yavé bajó en la nube y habló, luego tomó del espíritu que estaba en Moisés y lo puso en los setenta hombres ancianos. Cuando el espíritu se posó sobre ellos, se pusieron a profetizar, pero después no lo hicieron más."
,"26":"Dos hombres se habían quedado en el campamento, el primero se llamaba Eldad y el otro, Medad; el espíritu se posó sobre ellos. Pertenecían a los inscritos, pero no habían ido a la Tienda, y profetizaron en el campamento."
,"27":"Un muchacho corrió para anunciárselo a Moisés: 'Eldad y Medad están profetizando en el campamento'."
,"28":"Josué, hijo de Nun, servidor de Moisés desde su juventud, tomó la palabra: '¡Mi señor Moisés, prohíbeselo!'"
,"29":"Pero Moisés le respondió: '¿Así que te pones celoso por mí? ¡Ojalá que todo el pueblo de Yavé fuera profeta, que Yavé les diera a todos su espíritu!'"
,"30":"Después de eso, Moisés regresó al campamento junto con los ancianos de Israel."
,"31":"Empezó a soplar un viento: venía de Yavé. El viento venía del mar y arrastraba codornices, las que dispersó por el campamento y sus alrededores hasta un día de camino. Las había por todo el derredor del campamento formando una capa de dos codos."
,"32":"El pueblo se levantó, y toda esa noche y todo el día siguiente se dedicó a recoger codornices. El que menos tenía había juntado diez grandes medidas. Las pusieron a secar alrededor del campamento."
,"33":"Pero aún tenían la carne entre los dientes, y todavía no terminaban de masticarla, cuando la cólera de Yavé se encendió contra el pueblo. Yavé le asestó al pueblo un golpe tremendo."
,"34":"A ese lugar se le dio el nombre de Quibrot-ha-taava, porque allí fueron enterrados los que se habían lanzado como hambrientos sobre la comida."
,"35":"De Quibrot-ha-taava partió el pueblo para Jaserot."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Miriam y Aarón murmuraban contra Moisés porque había tomado como mujer a una cuchita (del territorio de Cuch)."
,"2":"'¿Acaso Yavé, decían, sólo hablará por medio de Moisés? ¿No habló también por nuestro intermedio? Y Yavé lo oyó."
,"3":"Ahora bien, Moisés era un hombre muy humilde. No había nadie más humilde que él en la faz de la tierra."
,"4":"De repente Yavé les dijo a Moisés, Aarón y Miriam: '¡Salgan los tres del campamento y vayan a la Tienda de las Citas!' Salieron pues los tres."
,"5":"Entonces Yavé bajó en la columna de nube y se puso a la entrada de la Tienda. Llamó a Aarón y a Miriam, quienes se acercaron."
,"6":"Yavé les dijo entonces: 'Oigan bien mis palabras: Si hay en medio de ustedes un profeta,me manifiesto a él por medio de visiones,y sólo le hablo en sueños."
,"7":"Pero no ocurre lo mismo con mi servidor Moisés; le he confiado toda mi Casa"
,"8":"y le hablo cara a cara. Es una visión clara, no son enigmas; él contempla la imagen de Yavé. ¿Cómo, pues, no tienen miedo de hablar en contra de mi servidor, en contra de Moisés?'"
,"9":"La cólera de Yavé se encendió contra ellos, y se retiró."
,"10":"Cuando se disipó la nube que estaba encima de la Tienda, Miriam había contraído la lepra: su piel estaba blanca como la nieve. ¡Aarón se volvió hacia ella y se dio cuenta de que estaba leprosa!"
,"11":"Aarón le dijo entonces a Moisés: 'Te lo suplico, Señor, no nos hagas pagar este pecado, esta locura de la que estábamos poseídos."
,"12":"Que no sea como el aborto cuyo cuerpo ya está medio destrozado cuando sale del vientre de su madre'."
,"13":"Entonces Moisés suplicó a Yavé: '¡Por favor, detente! ¡Sánala!'"
,"14":"Pero Yavé le respondió a Moisés: 'Si su padre la hubiera escupido en la cara, habría tenido que esconderse de vergüenza durante siete días. Que sea pues excluida del campamento por siete días, después de lo cual se reintegrará.'"
,"15":"Miriam quedó pues fuera del campamento por siete días, y mientras ella no regresara el pueblo no se movió."
,"16":"Entonces el pueblo partió de Jaserot y acampó en el desierto de Parán."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Yavé dijo a Moisés:"
,"2":"'Envía hombres adelante para que exploren esa tierra de Canaán que voy a darles a los israelitas. Cada tribu elija como representante a uno de sus jefes.'"
,"3":"Moisés los envió pues desde el desierto de Parán según la orden de Yavé. Todos esos hombres eran jefes de Israel."
,"4":"Estos eran sus nombres: Por la tribu de Rubén, Chamma, hijo de Zacur;"
,"5":"por la tribu de Simeón, Chafat, hijo de Huri;"
,"6":"por la tribu de Judá, Caleb, hijo de Jefoné;"
,"7":"por la tribu de Isacar, Igal, hijo de José;"
,"8":"por la tribu de Efraím, Oseas, hijo de Nun;"
,"9":"por la tribu de Benjamín, Palti, hijo de Rafu;"
,"10":"por la tribu de Zabulón, Gadiel, hijo de Sodi;"
,"11":"por la tribu de José, por la estirpe de Manasés, Gadi, hijo de Susi;"
,"12":"por la tribu de Dan, Ammiel, hijo de Gemali;"
,"13":"por la tribu de Aser, Setur, hijo de Micael;"
,"14":"por la tribu de Neftalí, Nahalí, hijo de Vafsi;"
,"15":"por la tribu de Gad, Geuel, hijo de Maqui."
,"16":"Estos son los nombres de los hombres que Moisés mandó para que exploraran la tierra de Canaán (a Osea, Moisés le dio el nombre de Josué)."
,"17":"Moisés los mandó pues a explorar la tierra de Canaán. Les dijo: 'Suban por el Negueb, luego pasen a la montaña."
,"18":"Miren bien cómo es esa tierra y qué tipo de gente vive allí; si es fuerte o débil, escasa o numerosa."
,"19":"Observen cómo es ese país donde viven, si es bueno o malo. Cómo son las ciudades donde viven: ¿son campamentos o ciudades fortificadas?"
,"20":"Fíjense en cómo es la tierra, si es rica o pobre, si hay o no árboles. Y no tengan miedo en traernos algunos productos del país'. Porque era la estación de las primeras uvas."
,"21":"Partieron pues a explorar ese país desde el desierto de Sin hasta Rehob, a la entrada de Emat."
,"22":"Subieron por el Negueb y llegaron a Hebrón, donde se encontraban Ahimán, Chechai y Talmai, de la raza de los anaquim. Hebrón había sido fundada siete años antes que la ciudad de Tanis, en Egipto."
,"23":"Llegaron al valle de Escol, donde cortaron un sarmiento con un racimo de uva que transportaron en un palo entre dos, junto con granadas e higos."
,"24":"Ese lugar se llamó el valle del Racimo, por el racimo que habían cortado allí los israelitas."
,"25":"Al cabo de cuarenta días volvieron de su inspección a ese país."
,"26":"A su regreso se presentaron a Moisés, Aarón y a toda la comunidad de los israelitas, en Cadés, en el desierto de Parán. Dieron cuenta de su recorrido ante toda la comunidad y les mostraron los productos del país."
,"27":"Esto fue lo que contaron: 'Entramos al país a donde nos enviaron. ¡Realmente es una tierra que mana leche y miel: ¡aquí están sus productos!"
,"28":"Pero el pueblo que vive en ese país es muy poderoso. Las ciudades son muy grandes y fortificadas, hemos visto incluso a los descendientes de Enac."
,"29":"Los amalecitas viven en el Negueb; los hititas, jebuseos y amorreos viven en la montaña; los cananeos están instalados en la costa del mar y en las riberas del Jordán'."
,"30":"Caleb calmó al pueblo que murmuraba contra Moisés. 'Subamos, les dijo, y conquistemos ese país, que somos capaces de más.'"
,"31":"Pero los hombres que habían subido junto con él le replicaron: 'No podemos atacar a ese pueblo porque es demasiado poderoso para nosotros.'"
,"32":"Y se pusieron a desacreditar la tierra que habían visitado. Les decían a los Israelitas: 'La tierra que hemos explorado es una tierra que devora a sus habitantes. Los hombres que allí viven son muy altos."
,"33":"Si hasta vimos gigantes. A su lado teníamos la impresión de que éramos langostas y así nos veían ellos.'"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Toda la comunidad se puso a lanzar gritos lastimeros, y el pueblo pasó toda la noche llorando."
,"2":"Los israelitas se enojaron con Moisés y Aarón y toda la comunidad les dijo: '¿Por qué no morimos mejor en Egipto? ¿Por qué no morimos mejor en el desierto?"
,"3":"¿Por qué Yavé nos lleva a esa tierra? ¿Para que allí nos maten a espada y para que nuestras mujeres y nuestros niños sean esclavos? ¿No sería mejor para nosotros volver a Egipto?'"
,"4":"Y se decían unos a otros: 'Elijámonos un jefe y volvamos a Egipto.'"
,"5":"Moisés y Aarón se echaron de bruces al suelo en presencia de toda la comunidad de los israelitas."
,"6":"Josué, hijo de Nun, y Caleb, hijo de Jefoné, que habían formado parte de los espías, rasgaron sus ropas."
,"7":"Luego se dirigieron a toda la comunidad de los israelitas: '¡El país por donde hemos pasado y que exploramos es bueno! ¡Es una tierra excelente!"
,"8":"Si Yavé nos favorece, nos llevará a ese país y nos dará esa tierra que mana leche y miel."
,"9":"Pero no se rebelen contra Yavé! No teman a la población de esa tierra, porque nos la serviremos en bandeja. No tienen esperanza porque Yavé está con nosotros. No les tengan miedo.'"
,"10":"La comunidad entera hablaba de tirarles piedras, pero apareció la Gloria de Yavé en la Tienda de las Citas, ante los israelitas."
,"11":"Yavé dijo a Moisés: '¿Hasta cuándo me va a seguir menospreciando este pueblo? ¿Hasta cuándo va a tener poca confianza en mí después de todos los prodigios que he hecho en medio de él?"
,"12":"Quiero mandarles la peste y exterminarlos; luego haré salir de ti una nación más grande y más poderosa que él.'"
,"13":"Moisés le dijo a Yavé: 'Los egipcios saben muy bien con qué fuerza hiciste salir a este pueblo de en medio de ellos."
,"14":"Se lo han contado a los habitantes de este país. Esta gente sabe que tú estás en medio de tu pueblo, tú Yavé que se le apareciste cara a cara, tú Yavé que estás en medio de ellos en la nube, que caminas delante de ellos en una columna de nube de día y en una columna de fuego de noche."
,"15":"¿Y ahora quieres que muera este pueblo como un solo hombre?,Pero entonces las naciones que oyeron hablar de ti van a decir: "
,"16":"Yavé no fue capaz de llevar a ese pueblo a la tierra que había jurado darles, por eso es que los mató en el desierto."
,"17":"¡Demuestra más bien tu fuerza, mi Señor! Tú has dicho muy bien:"
,"18":"Yavé es paciente y rico en misericordia. Soportas la falta y el pecado, pero no dejas pasar la falta, porque el pecado de los padres lo castigas en los hijos, en los nietos y en los bisnietos."
,"19":"Perdona pues el pecado de este pueblo con esa gran misericordia y esa paciencia que has tenido para con él, desde su salida de Egipto hasta el día de hoy.'"
,"20":"Yavé respondió: 'Ya que tú me lo pides, lo voy a perdonar."
,"21":"Pero tan cierto como que yo vivo y que la Gloria de Yavé llena la tierra"
,"22":"que la desgracia caerá sobre esa gente. Porque vieron mi Gloria y mis maravillas, vieron lo que hice en Egipto y en el desierto, y a pesar de eso me tentaron más de diez veces y no me escucharon."
,"23":"Por eso no verán la tierra que prometí a sus padres con juramento; ninguno de los que me menospreciaron la verá."
,"24":"Pero a mi servidor Caleb lo haré entrar a esa tierra a la que ya entró, y se la daré a su posteridad, porque tuvo un espíritu distinto y me siguió sin vacilar."
,"25":"Ahora, como los amalecitas y los cananeos ocupan el valle, den mañana media vuelta y partan para el desierto, camino del mar de los Juncos.'"
,"26":"Yavé dijo a Moisés y a Aarón:"
,"27":"'¿Hasta cuándo esta comunidad malvada y esta gente van a seguir murmurando contra mí? Porque he oído las murmuraciones, las quejas de los israelitas en mi contra."
,"28":"Diles: Tan cierto como que Yavé es vivo que les voy a tomar la palabra, y así como ustedes acaban de decirlo a mis oídos,"
,"29":"sus cadáveres caerán en este desierto. Ustedes se lo han ido toda la vida murmurando contra mí: pues bien, todos los que fueron censados de los veinte años para arriba,"
,"30":"no entrarán en la tierra que juré darles. Sólo habrá una excepción para Caleb, hijo de Jefoné y para Josué, hijo de Nun."
,"31":"Quienes entrarán serán sus nietos, de los que decían que serían reducidos a la esclavitud; ellos conocerán la tierra que ustedes menospreciaron."
,"32":"Los cadáveres de ustedes caerán en el desierto,"
,"33":"y sus hijos serán nómadas en el desierto durante cuarenta años. Cargarán con el peso de la infidelidad de ustedes hasta que el desierto haya acogido a la totalidad de sus cadáveres."
,"34":"Ustedes emplearon cuarenta días en recorrer el país; pues bien, cada día equivaldrá a un año. Cargarán con el peso de su pecado durante cuarenta años y sabrán lo que es mi cólera."
,"35":"Así es como trataré a esta comunidad malvada que se ha confabulado contra mí. Yo Yavé lo digo: en el desierto desaparecerán, allí morirán.'"
,"36":"Esos hombres a los que Moisés había enviado para que exploraran la tierra y que, a su regreso, habían alzado a toda la comunidad en contra de él hablando mal del país,"
,"37":"esos hombres que habían criticado a ese país con un mal espíritu, murieron de un golpe en presencia de Yavé."
,"38":"Josué, hijo de Nun, y Caleb, hijo de Jefoné, fueron los únicos que sobrevivieron de todos los que habían ido a explorar el país."
,"39":"Cuando Moisés transmitió a los Israelitas todo eso, el pueblo quedó consternado."
,"40":"Muy temprano decidieron subir la montaña, pues decían: '¡Hemos pecado! Tenemos que subir a ese lugar que Yavé nos prometió.'"
,"41":"Pero Moisés les dijo: '¿Quieren desobedecer de nuevo las órdenes de Yavé?"
,"42":"No tendrán éxito, porque Yavé no está con ustedes; no se expongan pues a los golpes de los enemigos."
,"43":"Los amalecitas y los cananeos están frente a ustedes y perecerán a espada porque se han apartado de Yavé, y Yavé nos los acompañará.'"
,"44":"Pero ellos insistieron en subir a la cumbre de la montaña, si bien el Arca de la Alianza y Moisés permanecieron en el campamento."
,"45":"Pero los amalecitas y los cananeos bajaron de sus montañas, los derrotaron y los persiguieron hasta Jorma."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Yavé dijo a Moisés"
,"2":"para que se lo repitiera a los Israelitas: Esto será para cuando hayan llegado al país donde van a vivir, el país que les daré."
,"3":"Entonces le ofrecerán a Yavé sacrificios por el fuego, holocaustos o sacrificios de comunión, le ofrecerán sacrificios de agradable olor, de ganado mayor o menor, con ocasión de un voto o de una fiesta, o como ofrendas voluntarias."
,"4":"El que ofrezca un sacrificio a Yavé presentará una ofrenda de un décimo de flor de harina amasada con un cuarto de medida de aceite,"
,"5":"y un cuarto de medida de vino para la libación; añadirás esto al holocausto o al sacrificio de cada cordero."
,"6":"Si es un chivo, la ofrenda será de dos décimos de flor de harina amasada con un tercio de medida de aceite,"
,"7":"y un tercio de medida de vino para la libación. Ese será un sacrificio de agradable olor para Yavé."
,"8":"Cuando ofrezcas en sacrificio un novillo, ya sea como holocausto, ya sea como sacrificio de comunión o para cumplir un voto o como ofrenda pacífica a Yavé,"
,"9":"presentarás, además del novillo, una ofrenda de tres medidas de flor de harina amasada con media medida de aceite,"
,"10":"y ofrecerás media medida de vino para la libación. Ese será un sacrificio por el fuego de agradable olor para Yavé."
,"11":"Tendrán que seguir esta norma por cada toro, por cada chivo, por cada cordero o por cada cabrito."
,"12":"Esto será para cada una de las víctimas, no importando su número."
,"13":"Toda persona nacida en el país observará esta norma cuando ofrezca a Yavé un sacrificio por el fuego de agradable olor."
,"14":"Lo mismo vale para el extranjero y para cualquier persona que viva con ustedes: seguirá esta norma igual que ustedes cuando ofrezca a Yavé un sacrificio por el fuego de agradable olor, y esto será de generación en generación."
,"15":"La norma será la misma para toda la comunidad, tanto para ustedes como para el extranjero que vive con ustedes: será una ley perpetua para sus descendientes. Yavé no hará diferencias entre el extranjero y ustedes."
,"16":"Habrá sólo una ley y una norma tanto para ustedes como para el extranjero que vive con ustedes."
,"17":"Yavé dijo a Moisés:"
,"18":"'Diles esto a los israelitas: Cuando hayan llegado al país a donde los llevo,"
,"19":"y estén ya comiendo del pan de esa tierra, separarán una parte para Yavé."
,"20":"Reservarán una torta que pondrán aparte, como primicia por la masa, igual como lo hacen cuando dejan aparte una porción de la cosecha en la era."
,"21":"Le darán una parte a Yavé de generación en generación; serán las primicias de la masa de ustedes."
,"22":"Supongan que alguien haya pecado por error no obedeciendo a todas las órdenes que Yavé le dio a Moisés;"
,"23":"(a todas esas órdenes que Yavé dio para que se observaran en el transcurso del tiempo, y que entregó por boca de Moisés)."
,"24":"Si alguien hizo algo por inadvertencia y la comunidad no se dio cuenta de ello, entonces toda la comunidad presentará a Yavé como sacrificio un novillo, para un holocausto de agradable olor, con una oblación y una libación como lo prevé la norma. En seguida presentará un chivo para la expiación."
,"25":"El sacerdote hará entonces la expiación por toda la comunidad de los israelitas y quedará perdonada. Pues habían actuado sin darse cuenta, y por su falta presentaron una ofrenda, un sacrificio por el fuego en honor de Yavé, así como también un sacrificio expiatorio delante de Yavé."
,"26":"De esta manera quedará perdonada tanto la comunidad de los israelitas como el extranjero que vive en medio de ellos, ya que el pueblo pecó por inadvertencia."
,"27":"Si una persona peca sin darse cuenta, ofrecerá como reparación una cabrita de un año."
,"28":"El sacerdote hará la expiación ante Yavé por esa persona, y gracias a esa expiación, quedará perdonada."
,"29":"Ya sea que se trate de un israelita o de un extranjero que viva con ustedes, la ley será la misma por el pecado por inadvertencia."
,"30":"Pero si alguien, israelita o extranjero, peca conscientemente, como con eso insulta a Yavé, será eliminado de su pueblo."
,"31":"Si desprecia la palabra de Yavé y viola su mandamiento, tendrá que ser eliminado, llevando consigo el peso de su pecado.'"
,"32":"Cuando los israelitas estaban en el desierto, vieron a un hombre recogiendo leña un día sábado."
,"33":"Los que lo encontraron recogiendo leña lo llevaron a Moisés, a Aarón y a toda la comunidad."
,"34":"Lo dejaron preso mientras tanto, porque no se sabía lo que se haría con él."
,"35":"Entonces Yavé dijo a Moisés: 'A ese hombre hay que darle muerte. Toda la comunidad le lanzará piedras fuera del campamento.'"
,"36":"Toda la comunidad lo llevó fuera del campamento y le dieron muerte lanzándole piedras. Murió tal como Yavé se lo había ordenado a Moisés."
,"37":"Yavé dijo a Moisés:"
,"38":"'Dirás esto a los israelitas: Háganse flecos en los bordes de sus vestidos, y esto de generación en generación. Pongan en los flecos un hilo de púrpura violeta."
,"39":"Así será sus flecos y cuando los vean, se acordarán de todos los mandamientos de Yavé. De esta manera los pondrán en práctica y no seguirán las malas inclinaciones de su corazón o de sus ojos que los arrastran a la infidelidad."
,"40":"De ese modo se acordarán de todos mis mandamientos, los pondrán en práctica y serán santos delante de su Dios:"
,"41":"Yo soy Yavé su Dios, yo los hice salir de Egipto para ser su Dios. ¡Yo soy Yavé su Dios!'"
}`)
	CurrentBook.AddChapter(16, `{
"1":"Coré, hijo de Isar, hijo de Quehat, hijo de Leví y también Datán y Abirón, hijos de Eliab, y On, hijo de Pelet, de la tribu de Rubén,"
,"2":"se rebelaron contra Moisés. Les siguieron doscientos cincuenta israelitas, todos jefes de la comunidad, miembros del consejo y personajes conocidos."
,"3":"Se amotinaron contra Moisés y Aarón y dijeron: 'Basta ya, ¿acaso no están consagrados todos los miembros de la comunidad? ¿Y no está Yavé en medio de nosotros? ¿ Por qué entonces se creen ustedes superiores a la comunidad de Yavé?'"
,"4":"Al oír eso, Moisés se echó de bruces al suelo."
,"5":"Luego, dirigiéndose a Coré y a toda su banda, les dijo: 'Mañana temprano Yavé dará a conocer quién es suyo y quién le está consagrado y puede acercarse a él. El mismo hará que se aproxime el que eligió."
,"6":"Así que mañana tomen sus incensarios, tú Coré y toda tu banda; y al llegar ante Yavé"
,"7":"les pondrán fuego y luego les echarán incienso. Aquel a quien Yavé designe, ése será el consagrado. ¡Se han pasado, hijos de Leví!'"
,"8":"Moisés le dijo a Coré: '¡Oigan bien, hijos de Leví!"
,"9":"¿Les parece poco que el Dios de Israel los haya separado de la comunidad de los israelitas, y que los haya hecho acercarse a El para que sirvan en la Morada de Yavé y así aseguren el culto en nombre de la comunidad?"
,"10":"Les permitió que se le acercaran a ti y a tus hermanos, los hijos de Leví, y ¿todavía reclaman el sacerdocio?"
,"11":"Esto es el colmo, pues tú y tu banda se han amotinado contra Yavé. Y Aarón, ¿qué tienen en su contra para que murmuren de él?'"
,"12":"Moisés mandó buscar a Datán y Abirón, hijos de Eliab. Pero ellos respondieron: '¡No iremos!"
,"13":"¿Te parece poco habernos sacado de una tierra que manaba leche y miel para hacernos morir en este desierto? ¿Y tú quieres hacer de jefe?"
,"14":"¿Piensas que nos trajiste a una tierra que mana leche y miel? ¡Si ni siquiera nos has dado campos ni viñas! ¿Crees que toda esa gente está ciega? ¡No iremos, pues!'"
,"15":"Moisés se enojó mucho y dijo a Yavé: 'No mires su ofrenda, no les he quitado nada, ni siquiera un burro, ni les he hecho daño a ninguno de ellos.'"
,"16":"Moisés dijo a Coré: 'Tú y toda tu banda preséntense mañana ante Yavé, junto con Aarón."
,"17":"Que cada uno tome su incensario y le ponga incienso, luego cada uno hará sus incensaciones en presencia de Yavé (¡doscientos cincuenta incensarios!). Tú y Aarón tendrán cada uno su incensario.'"
,"18":"Tomó pues cada uno su incensario, le puso fuego e incienso y se presentó a la entrada de la Tienda de las Citas, junto con Moisés y Aarón."
,"19":"Como Coré sublevara a toda la comunidad contra ellos a la entrada de la Tienda de las Citas, se manifestó la Gloria de Yavé a toda la comunidad."
,"20":"Entonces dijo Yavé a Moisés y Aarón:"
,"21":"'Apártense de esta comunidad porque la voy a exterminar en todo el campamento.'"
,"22":"Ellos se pusieron con el rostro en tierra y dijeron: '¡Oh Dios, Dios de los espíritus de todos los hombres! Si un solo hombre ha pecado, ¿vas a enojarte con toda la comunidad?'"
,"23":"Yavé le respondió a Moisés:"
,"24":"'Díganle a la comunidad que se aleje de las tiendas de Coré, Datán y Abirón.'"
,"25":"Moisés fue entonces donde Datán y Abirón; los ancianos de Israel lo siguieron."
,"26":"Se dirigió a la comunidad: '¡Apártense de las tiendas de esos hombres perversos! No toquen nada de lo que les pertenece, porque si no van a morir debido a sus pecados.'"
,"27":"Se apartaron entonces (de las tiendas de Coré, Datán y Abirón;) mientras tanto Datán y Abirón habían salido a la entrada de su tienda junto con sus mujeres, sus hijos y sus pequeñuelos."
,"28":"Moisés dijo: 'Ahora sabrán que Yavé me envió para que realice todos esos prodigios y que eso no viene de mí."
,"29":"Si esos hombres mueren de muerte natural y corren la misma suerte que cualquiera, es señal de que Yavé no me envió."
,"30":"Pero si Yavé hace un milagro, si la tierra se abre en un gran tramo para tragárselos junto con todo lo que tienen, si descienden vivos al Lugar de los muertos, entonces sabrán que esos hombres despreciaron a Yavé.'"
,"31":"Aún no terminaba de hablar, cuando la tierra se abrió a sus pies."
,"32":"Se abrió una garganta y se los tragó con toda su familia (a todos los hombres de la banda de Coré) junto con todo lo que les pertenecía."
,"33":"Bajaron vivos al Lugar de los muertos, junto con todos los que estaban con ellos. La tierra los tapó y desaparecieron de la vista de la comunidad."
,"34":"Todos los israelitas que estaban en los alrededores salieron huyendo y decían: '¡No vaya a tragarnos también la tierra!'"
,"35":"Entonces brotó un fuego de Dios que devoró a los doscientos cincuenta hombres que ofrecían el incienso."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Yavé dijo a Moisés:"
,"2":"'Comunícale esto al sacerdote Eleazar, hijo de Aarón: Saca los incensarios de entre las cenizas y arroja lejos el fuego que había en ellos, porque están consagrados."
,"3":"Los incensarios de esos hombres que pecaron y que murieron te servirán para hacer las placas para revestir el altar. Esos incensarios son santos porque estuvieron en contacto con Yavé. Serán una señal para los israelitas.'"
,"4":"El sacerdote Eleazar tomó entonces los incensarios de cobre que pertenecieron a los que habían sido quemados e hizo con ellos placas para revestir el altar."
,"5":"Allí están para recordarles a los israelitas que cualquiera que no pertenezca a la raza de Aarón no puede acercarse para hacer incensaciones a Yavé. De lo contrario, correrá la misma suerte que Coré y su banda a los que Yavé se lo había advertido por medio de Moisés."
,"6":"Al día siguiente, toda la comunidad de los israelitas se puso a murmurar contra Moisés y Aarón: '¡Ustedes, decían, son los que han dado muerte al pueblo de Yavé!'"
,"7":"Mientras la comunidad se amotinaba contra Moisés y Aarón, estos se dirigieron a la Tienda de las Citas: la nube la había cubierto y apareció la Gloria de Yavé."
,"8":"Entonces Moisés y Aarón se acercaron a la Tienda"
,"9":"y Yavé le dijo a Moisés:"
,"10":"'¡Retírate de en medio de esta comunidad, porque la voy a exterminar en el campamento!' Ellos cayeron con el rostro en tierra."
,"11":"Moisés le dijo entonces a Aarón: 'Toma tu incensario, pon en él fuego del altar, échale luego incienso y corre hacia la comunidad con tu incensario. Harás la expiación por ellos, porque se ha desencadenado la cólera de Yavé y ha comenzado el castigo.'"
,"12":"Aarón hizo como Moisés se lo había dicho, y corrió hacia la comunidad. El flagelo ya estaba azotando al pueblo. Aarón puso el incienso e hizo la expiación por el pueblo;"
,"13":"se paró en medio de los muertos y de los vivos, y el flagelo se detuvo."
,"14":"Los que murieron víctimas del castigo llegaron a la cifra de catorce mil setecientos, sin contar a los que habían muerto por culpa de Coré."
,"15":"Cuando Aarón volvió donde Moisés, a la entrada de la Tienda de las Citas, el flagelo había cesado."
,"16":"Yavé dijo a Moisés:"
,"17":"'Diles a los israelitas que te traigan una varilla por tribu, una varilla por cada uno de los jefes de tribu. Serán pues doce varillas; y tú escribirás en la varilla respectiva el nombre de cada uno."
,"18":"En la varilla de Leví escribirás el nombre de Aarón, porque sólo habrá una varilla por tribu."
,"19":"Las depositarás en la Tienda delante del Testimonio, allí donde los cito a ustedes,"
,"20":"y aquel cuya varilla florezca, ese será el que he elegido. Así acabaré con todas esas quejas de los israelitas contra mí me refiero a las quejas contra ustedes.'"
,"21":"Moisés transmitió esas palabras a los israelitas y cada uno de los jefes le dio una varilla. Cada tribu tenía su varilla, que era llevada por su jefe, o sea, en total doce varillas. La varilla de Aarón estaba junto con las demás."
,"22":"Moisés depositó esas varillas delante de Yavé en la Tienda del Testimonio."
,"23":"Al día siguiente, cuando Moisés entró en la Tienda del Testimonio, la varilla de la tribu de Leví presentada por Aarón había florecido: le habían aparecido yemas, había botones de flores y las almendras habían madurado."
,"24":"Moisés retiró entonces todas las demás varillas de la presencia de Yavé y se las mostró a los israelitas. Estos las vieron y cada uno recogió la suya."
,"25":"Yavé dijo entonces a Moisés: 'Vuelve a poner la varilla de Aarón delante del Testimonio; allí permanecerá como una advertencia para los rebeldes. Así alejarás de mí sus murmuraciones y no morirán.'"
,"26":"Moisés hizo como Yavé se lo había ordenado."
,"27":"Los israelitas le dijeron a Moisés: '¡Nos morimos, estamos perdidos. Nos estamos muriendo todos!"
,"28":"Porque cualquiera que se acerque a la Morada de Yave muere. ¿Vamos pues a perecer todos así?'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Yavé dijo a Aarón: 'Tú, tus hijos y tu tribu contigo, serán responsables del Santuario. Tú y tus hijos contigo, tendrán la responsabilidad del sacerdocio."
,"2":"También harás que participen en el culto los levitas: son tus hermanos, de la tribu de tu padre. Te ayudarán y te asistirán cuando tú y tus hijos tengan que servir en la Tienda del Testimonio."
,"3":"Serán socios de ustedes en todo el servicio de la Tienda, pero no se aproximarán a los objetos sagrados, ni al altar, pues de lo contrario será la muerte para ellos y ustedes."
,"4":"Los acompañarán a ustedes en el servicio de la Tienda de las Citas, en todo lo que concierne al servicio de la Tienda, pero ningún profano se unirá a ustedes."
,"5":"Ustedes asegurarán el servicio del Santuario y el del altar. De ese modo no se desencadenará sobre los israelitas la cólera de Dios."
,"6":"Yo mismo escogí a sus hermanos los Levitas de en medio de los israelitas para dárselos. Son donados de Dios para servir en la Tienda de las Citas."
,"7":"Tú, y tus hijos contigo, desempeñarán su ministerio en todo lo que se refiere al altar y a lo que pasa detrás de la cortina. Ustedes asegurarán su servicio y ese sacerdocio es un don que les hago; el extraño que quisiere meterse en eso, morirá.'"
,"8":"Yavé dijo a Aarón: 'Te doy la parte que se reserva para mí de todas las ofrendas de los israelitas. Te la doy debido a la consagración que recibieron tú y tus hijos: es una ley perpetua."
,"9":"Esto es lo que te corresponderá de todo lo que se ofrece o se consagra: todas las ofrendas, es decir, todas las oblaciones, todos los sacrificios por el pecado y todos los sacrificios de reparación que se ofrezcan, todo eso será cosa santísima y será para ti y para tus hijos."
,"10":"Lo comerás en un lugar santísimo. Cualquier varón lo podrá comer; la considerarás como una cosa santa."
,"11":"Tuyo será también lo que se reserva de las ofrendas de los israelitas, de cualquier ofrenda mecida; te lo doy a ti, a tus hijos y a tus hijas como ley perpetua. Cualquiera que esté puro en tu casa, lo podrá comer."
,"12":"Te doy además las primicias que los israelitas presentan a Yavé, lo mejor del aceite, del vino nuevo y del trigo."
,"13":"Te doy los primeros productos de la tierra que ellos lleven a Yavé. Cualquiera que esté puro en tu casa los podrá comer."
,"14":"Todo lo que esté consagrado por anatema en Israel será para ti."
,"15":"Te pertenecerá el primogénito de cualquier ser viviente, sea de hombre o de animal, ofrecido a Yavé. Tú harás solamente el rescate del primogénito de hombre, así como del primerizo de un animal impuro."
,"16":"El rescate se hará a partir de un mes de edad, lo estimarás en cinco siclos de plata calculados según el siclo del Santuario, es decir veinte gueras."
,"17":"Pero no harás el rescate del primerizo de vaca, de oveja ni de cabra, porque están consagrados. Derramarás más bien su sangre sobre el altar, y harás quemar su grasa como sacrificio por el fuego de agradable aroma para Yavé."
,"18":"Para ti será su carne como asimismo el pecho que se haya mecido y la espaldilla derecha."
,"19":"Todo lo que se haya reservado de las ofrendas que hagan los israelitas a Yavé será considerado como partes santas; te las doy a ti, a tus hijos y a tus hijas: es una ley perpetua. Es una alianza eterna por la sal ante Yavé para ti y para toda tu descendencia contigo.'"
,"20":"Yavé dijo además a Aarón: 'Tú no tendrás territorio alguno en el país ni habrá parte alguna para ti en medio de tu pueblo. Porque yo mismo soy tu parte y tu heredad en medio de los israelitas."
,"21":"A los hijos de Leví les doy como herencia todos los diezmos de Israel, a cambio del servicio que presten, es decir, del servicio de la Tienda de las Citas."
,"22":"Los israelitas no se acercarán a la Tienda so pena de cometer una falta grave."
,"23":"Los levitas son quienes asegurarán el servicio de la Tienda de las Citas y cargarán con la falta si existiese: es una regla perpetua de generación en generación. Por eso no tendrán heredad entre los israelitas."
,"24":"El diezmo que los israelitas separan en honor de Yavé, se lo doy a los levitas como parte de su herencia. Por eso les he dicho que no tendrán heredad entre los israelitas.'"
,"25":"Yavé dijo a Moisés:"
,"26":"'Transmitirás esto a los levitas: Cuando perciban de los israelitas el diezmo que les otorgo en herencia, reservarán una parte para Yavé: será el diezmo del diezmo."
,"27":"Esa parte que ustedes reservarán, les será contada como se cuenta el trigo en la era o el vino en la cuba."
,"28":"Así pues reservarán una ofrenda para Yavé de todos los diezmos que reciban de los israelitas y entregarán esa parte al sacerdote Aarón."
,"29":"De todos los dones que reciban reservarán una parte para Yavé, que será lo mejor de todo lo consagrado."
,"30":"Les dirás además: Cuando ustedes aparten lo mejor, el resto del diezmo será para los levitas como el trigo en la era o como el vino en la cuba."
,"31":"Pondrán comérselo en cualquier parte, ustedes y su familias: es su salario por el servicio que prestarán en la Tienda de las Citas."
,"32":"Si han apartado lo mejor, no cometerán por ello ningún pecado. Cuiden pues de no profanar las ofrendas santas de los israelitas y no morirán.'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"Yavé dijo a Moisés y a Aarón:"
,"2":"'Esta es una disposición de la Ley que les ordena Yavé. Diles a los israelitas que te traigan una vaca colorada sin defecto y sin mancha, y a la cual no se la haya enyugado."
,"3":"Se la pasarán al sacerdote Eleazar, quien la sacará fuera del campamento y la inmolará frente a éste."
,"4":"El sacerdote Eleazar untará su dedo en la sangre y rociará siete veces volviéndose hacia la entrada de la Tienda de las Citas."
,"5":"Luego se quemará la vaca a la vista de todos. Quemará su piel, su carne, su sangre y sus excrementos."
,"6":"Después el sacerdote tomará leña de cedro, de hisopo y de granado y la echará a la hoguera donde se queme la vaca."
,"7":"En seguida el sacerdote lavará sus ropas, se bañará en agua, y regresará al campamento; el sacerdote quedará impuro hasta la tarde."
,"8":"El que haya quemado la vaca lavará sus ropas en el agua y se bañará, quedará impuro hasta la tarde."
,"9":"Un hombre puro recogerá las cenizas de la vaca y las pondrá fuera del campamento en un lugar puro. Allí se las conservará para hacer el agua de purificación que usará la comunidad de los israelitas para hacer la expiación."
,"10":"El que haya recogido las cenizas de la vaca lavará sus ropas y quedará impuro hasta la tarde: es una ley perpetua tanto para los israelitas como para el extranjero que vive con ustedes."
,"11":"El que toque a un muerto, a cualquier cadáver humano, quedará impuro durante siete días."
,"12":"Se purificará con esa agua el tercero y séptimo día, después de lo cual quedará puro. Pero si no se purifica al tercero y séptimo día, seguirá impuro."
,"13":"Si alguien toca a un muerto, al cadáver de un hombre que haya muerto, y no se purifica, vuelve impura a la Morada de Yavé. Ese hombre debe ser eliminado de Israel. Mientras no se haya derramado sobre él el agua de purificación está impuro y su impureza sigue sobre él."
,"14":"Esta es la ley cuando un hombre muera en una tienda: Quienquiera que entre en la tienda quedará impuro durante siete días igual que todo lo que hay en la tienda."
,"15":"Cualquier tiesto abierto que no tenga una tapa amarrada, quedará impuro."
,"16":"El que en el campo toque a alguien que haya muerto, o huesos humanos o una tumba, quedará impuro durante siete días."
,"17":"Para la purificación de esa persona, se tomará un poco de ceniza de la hoguera donde se hizo el sacrificio de expiación y se la vaciará en un vaso de agua."
,"18":"Luego un hombre puro tomará una ramita de hisopo, la sumergerá en el agua y rociará la tienda y a todos los objetos y personas que haya en ella; se hará lo mismo con el que tocó los huesos, al muerto o la tumba."
,"19":"El hombre puro rociará al que está impuro al tercero y séptimo día; el séptimo día este último hará la expiación. Lavará sus ropas y se bañará en agua, y a la tarde quedará puro."
,"20":"Pero, el hombre que está impuro y que no hace el rito de expiación, será eliminado de la comunidad por haber vuelto impuro el Santuario de Yavé. Si no se derrama sobre él el agua que purifica, es un impuro."
,"21":"Este será un rito perpetuo. El que rocíe con el agua de purificación tendrá que lavar sus ropas, y el que haya sido tocado por esa agua quedará impuro hasta la tarde."
,"22":"Todo lo que toque el impuro quedará impuro, y el que toque eso quedará impuro hasta la tarde.'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"Toda la comunidad de Israel llegó el primer mes al desierto de Sin. El pueblo se instaló en Cadés, allí murió y fue enterrada Miriam."
,"2":"No había agua para la comunidad y los israelitas le echaron la culpa a Moisés y a Aarón."
,"3":"Se encararon con Moisés y le dijeron: '¿Por qué no morimos mejor en presencia de Yavé como nuestros hermanos?"
,"4":"¿Por qué han traído a la comunidad de Yavé a este desierto para que muramos junto con nuestros animales?"
,"5":"¡Nos sacaron de Egipto para traernos a este lugar horrible! ¡No hay dónde sembrar, ni tampoco hay higueras, viñas ni granados y menos agua potable!'"
,"6":"Moisés y Aarón se escaparon de en medio de la comunidad y se presentaron a la entrada de la Tienda de las Citas. Allí se pusieron con el rostro en tierra y se les apareció la Gloria de Yavé."
,"7":"Yavé le dijo a Moisés:"
,"8":"'Toma tu varilla y junto con tu hermano Aarón reúne a toda la comunidad. Y a la vista de todos le dirás a la roca que dé agua. Harás que brote para ellos agua de la roca y se la darás a beber a la comunidad y a su ganado'."
,"9":"Moisés sacó la varilla que estaba ante Yavé tal como se le había ordenado."
,"10":"Luego Moisés y Aarón reunieron a la comunidad frente a la roca y Moisés dijo: '¡Oigan, pues, rebeldes! ¿Así que nosotros vamos a hacer brotar para ustedes agua de esta roca?'"
,"11":"Moisés levantó su mano y golpeó dos veces la roca con su varilla. Entonces brotó agua en abundancia y tuvieron para beber la comunidad y su ganado."
,"12":"Pero Yavé dijo a Moisés y Aarón: '¡Ustedes no han tenido confianza en mí! Ya que no me glorificaron ante los israelitas, no harán entrar a esta comunidad en la tierra que les daré.'"
,"13":"Esto pasó en las agua de Meriba; los israelitas protestaron contra Yavé y él les manifestó su santidad."
,"14":"Desde Cadés, Moisés mandó a decirle al rey de Edom: 'Así habla tu hermano Israel. Tu sabes de todas las dificultades con que nos hemos topado."
,"15":"Nuestros padres bajaron a Egipto y allí permanecieron por mucho tiempo, pero los egipcios nos maltrataron a nosotros y a nuestros padres."
,"16":"Entonces clamamos a Yavé y él escuchó nuestro clamor: envió a un ángel que nos sacó de Egipto. Ahora estamos en Cadés, el oasis que conlinda con tu país. "
,"17":"Déjanos atravesar tu territorio; no atravesaremos por tus campos ni por tus viñas, ni beberemos el agua de tus pozos. Iremos por el camino real sin apartarnos ni a la derecha ni a la izquierda, hasta el día en que hayamos atravesado tu país.'"
,"18":"Edom respondió: 'No pasarás por mi territorio, si lo haces saldré a tu encuentro con la espada en la mano.'"
,"19":"Los israelitas le dijeron: 'Iremos por el camino y si bebemos de tu agua, nosotros y nuestros rebaños, te la pagaremos. Sólo dejaremos la huella de nuestros pies.'"
,"20":"Edom respondió: '¡No pasarás!' Y avanzó contra Israel con mucha gente y un gran ejército."
,"21":"Como Edom le impidió a Israel que atravesara por su territorio, Israel tuvo que dar un rodeo."
,"22":"Partió de Cadés toda la comunidad de los israelitas y llegaron al monte Hor."
,"23":"Yavé le dijo a Moisés y Aarón cuando estaban en el monte Hor, en la frontera con Edom:"
,"24":"'Aarón tiene que ir a reunirse con sus padres, no entrará en el país que les daré a los israelitas, porque ustedes no siguieron mis órdenes en el oasis de Meriba."
,"25":"Llévate contigo a Aarón y a su hijo Eleazar, y sube al monte Hor."
,"26":"Allí le quitarás a Aarón sus vestiduras y se las pondrás a su hijo Eleazar, puesto que Aarón irá a reunirse con sus padres, allí morirá.'"
,"27":"Moisés hizo lo que Yavé le había ordenado. Subieron el monte Hor a la vista de toda la comunidad."
,"28":"Moisés le quitó sus vestiduras a Aarón y se las puso a Eleazar. Luego murió Aarón en la cumbre del monte y Moisés bajó del monte con Eleazar."
,"29":"Toda la comunidad se informó que Aarón había muerto; todo el pueblo de Israel lloró a Aarón por treinta días."
}`)
	CurrentBook.AddChapter(21, `{
"1":"El rey de Arad, un cananeo que vivía en el Negueb, supo que Israel venía por el camino de Atarim. Atacó a Israel y tomó algunos prisioneros."
,"2":"Entonces Israel hizo un voto a Yavé: 'Si me entregas a ese pueblo, condenaré sus ciudades al anatema.'"
,"3":"Yavé escuchó a Israel y le entregó a los cananeos. Los condenaron a ellos y a sus ciudades al anatema y le dieron a ese lugar el nombre de Jormá."
,"4":"Dejaron el monte Hor por el camino del mar de Suf para rodear el territorio de Edom. En el camino el pueblo perdió la paciencia"
,"5":"y murmuró contra Dios y Moisés: '¿Por qué nos hicieron subir de Egipto para que muramos en el desierto sin pan y sin agua? ¡Ya estamos aburridos de esta comida sin gracia!'"
,"6":"Entonces Dios mandó contra el pueblo serpientes-ardientes. Muchos de los israelitas murieron por sus mordeduras."
,"7":"El pueblo fue a ver a Moisés y le dijo: 'Hemos pecado, hemos murmurado contra Yavé y contra ti. Ruega a Yavé por nosotros, para que aleje de nosotros las serpientes.' Moisés oró por el pueblo,"
,"8":"y Yavé le dijo a Moisés: 'Hazte una serpiente-ardiente y colócala en un poste. El que haya sido mordido, al verla, sanará.'"
,"9":"Moisés hizo una serpiente de bronce y la puso en un poste. Cuando alguien era mordido por una serpiente, miraba la serpiente de bronce y se sanaba."
,"10":"Los israelitas partieron y acamparon en Obot."
,"11":"Partieron de allí y acamparon en las Ruinas de los Abarim, en el desierto, al este de Moab, hacia el lado del sol naciente."
,"12":"Salieron de allí y acamparon a orillas del torrente de Zered."
,"13":"Subieron de allí y acamparon más allá del Arnón. Ese torrente en el desierto era el límite del territorio de los amoritas, pues el Arnón es la frontera de Moab, entre los moabitas y los amoritas."
,"14":"Por eso se dice en el Libro de las Guerras de Yavé: '... Vaheb cerca de Sufá y el torrente de Arnón,"
,"15":"y la pendiente de la quebrada que baja hacia Ar, pegada a la frontera de Moab.'"
,"16":"De allí partieron para Beer. A propósito de ese pozo Yavé le dijo a Moisés: 'Reúne al pueblo y le daré agua.'"
,"17":"Entonces Israel entonó este cántico: '¡Oh pozo! ¡Levántate y canta!"
,"18":"¡Pozo que cavaron los jefes, pozo que perforaron los príncipes del pueblo con su cetro y su bastón!',Del desierto subieron a Matana, "
,"19":"de Matana a Nahaliel, de Nahaliel a Bamot,"
,"20":"y de Bamot al arroyo que está en la campiña de Moab, hacia el monte Pisgá, frente al desierto."
,"21":"Israel le mandó decir a Sijón, rey de los amoritas."
,"22":"'Déjame pasar por tu territorio. No atravesaremos por tus campos ni por tus viñas, ni beberemos el agua de tus pozos. Iremos por el camino real, hasta que hayamos atravesado tu país.'"
,"23":"Pero Sijón no dejó a Israel que atravesara por su territorio, reunió a todo su pueblo y salió al encuentro de Israel en el desierto. Cuando llegó a Yahas, atacó a Israel."
,"24":"Israel lo derrotó a espada y conquistó su territorio desde el Arnón hasta el Yaboc, hasta la frontera de Amón, pues la frontera de Amón estaba bien defendida."
,"25":"Israel se apoderó de todas sus ciudades, los israelitas se instalaron en todas las ciudades de los amoritas, en Jesbón y en sus alrededores."
,"26":"Jesbón era la ciudad de Sijón, rey de los amoritas. Este había vencido al anterior rey de Moab y se había apoderado de su tierra hasta el Arnón."
,"27":"De ahí que dicen los poetas: ' Vengan a Jesbón, que sea reconstruida y fortificada, la ciudad de Sijón."
,"28":"Porque ha salido un fuego de Jesbón, una llama de la ciudad de Sijón. ¡Devoró Ar Moab,y los Baales de los lugares altos del Arnón!"
,"29":"¡Ay de ti, Moab!,¡Estás perdido, pueblo de Camón!,Hizo huir a tus hijos,y tus hijas fueron llevadas cautivas,por Sijón, rey de los amoritas."
,"30":"Jesbón sembró la ruina, sus flechas llegaron hasta Dibón; hemos incendiado,de Nofa a Medba.'"
,"31":"Cuando Israel se instaló en el territorio de los amoritas,"
,"32":"Moisés envió espías a Yazer. Los israelitas se apoderaron de esa ciudad y de sus aldeas y expulsaron a los amoritas que estaban allí."
,"33":"Dando un rodeo, tomaron el camino de Basán. Og, rey de Basán, se lanzó en su contra junto con todo su pueblo y les presentó batalla en Edrei."
,"34":"Yavé le dijo a Moisés: 'No temas: Lo he puesto en tus manos junto con todo su pueblo y todo su territorio. Lo tratarás como a Sijón, rey de los amoritas, que vivía en Jesbón.'"
,"35":"Efectivamente los israelitas lo masacraron junto con sus hijos y todo su pueblo, a tal punto que nadie quedó con vida, y se instalaron en su territorio."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Los israelitas salieron de allí y acamparon en las estepas de Moab, al otro lado del Jordán a la altura de Jericó."
,"2":"Balac, hijo de Sipor, se enteró de todo lo que Israel les había hecho a los amoritas."
,"3":"Se apoderó de los moabitas un gran terror al ver cuán numeroso era ese pueblo: cundió el pavor en Moab por temor a Israel."
,"4":"Los moabitas dijeron entonces a los ancianos de Madián: '¡Esa muchedumbre va a devorar toda la región, como el buey se come la hierba del campo!',En ese entonces era rey de Moab Balac, hijo de Sipor. "
,"5":"Mandó buscar a Balaam, hijo de Ber, a Petor junto al río, en el territorio de los amonitas. Lo invitó a venir diciéndole: 'Un pueblo que salió de Egipto acaba de extenderse por toda la región y se estableció frente a mí."
,"6":"Ven pues, por favor, y maldice a ese pueblo porque es más poderoso que yo. A lo mejor así puedo vencerlo y expulsarlo del país, porque sé que lo que tú bendices queda bendito y lo que maldices, maldito está.'"
,"7":"Los ancianos de Moab partieron pues junto con los de Madián, con las manos llenas de regalos para el adivino, y llegaron a la casa de Balaam. Cuando le transmitieron las palabras de Balac,"
,"8":"Balaam les dijo: 'Alójense en mi casa por esta noche, y les responderé según lo que me diga Yavé.' Los jefes de Moab se quedaron pues en casa de Balaam."
,"9":"Dios visitó a Balaam y le dijo: '¿Quiénes son esos hombres que están en tu casa?'"
,"10":"Balaam le respondió a Dios: 'Balac, hijo de Sipor, rey de Moab, me manda este recado:"
,"11":"Ese pueblo que salió de Egipto cubre toda la región. Ven pues y maldícelo, a lo mejor así puedo oponerle resistencia y expulsarlo.'"
,"12":"Pero Dios dijo a Balaam: 'No irás con ellos ni maldecirás a ese pueblo, porque está bendito.'"
,"13":"Balaam se levantó muy de madrugada y les dijo a los jefes enviados por Balac: 'Regresen a su país, porque Yavé no quiso que fuera con ustedes.'"
,"14":"Se levantaron entonces los jefes de Moab y retornaron donde Balac: 'Balaam, dijeron, se niega a venir con nosotros.'"
,"15":"Balac envió de nuevo a otros jefes más numerosos y más ilustres que los primeros."
,"16":"Llegaron donde Balaam y le dijeron: 'Esto dice Balac, hijo de Sipor: ¡Por favor, no te niegues a venir a mi casa,"
,"17":"te trataré como rey y haré todo lo que me digas; ven pues y maldice a ese pueblo!'"
,"18":"Balaam respondió a los servidores de Balac: 'Aunque Balac me diera su casa llena de plata y de oro, no desobedecería la orden de Yavé, mi Dios, no importa que fuera para una cosa pequeña o grande."
,"19":"Sin embargo, alojen aquí esta noche, por favor, para que sepa lo que Yavé me quiere aún decir.'"
,"20":"Esa noche se apareció Dios a Balaam y le dijo: '¿Así que esos hombres vinieron a invitarte? ¡Muy bien, parte con ellos, pero sólo harás lo que te diga!'"
,"21":"Balaam se levantó muy de mañana, ensilló su burra y se fue con los jefes de Moab."
,"22":"Estalló la cólera de Dios contra Balaam cuando todavía estaba en camino. El ángel de Yavé se paró en medio del camino para cerrarle el paso, mientras venía en su burra acompañado de dos sirvientes."
,"23":"La burra vio al ángel de Yavé que le impedía el paso, con su espada desenvainada en la mano derecha. La burra dio un rodeo por el campo y Balaam le pegó a la burra para hacerla volver al camino."
,"24":"Luego el ángel de Yavé se fue a parar en un sendero abierto en medio de las parras: había un cerco a cada lado."
,"25":"La burra vio al ángel de Yavé; pasó a rozar el muro, aplastando el pie de Balaam contra la cerca, y Balaam le pegó de nuevo."
,"26":"El ángel de Yavé se fue a poner más adelante y se paró en un lugar tan estrecho que no se podía esquivarlo ni a derecha ni a izquierda."
,"27":"Cuando la burra vio al ángel de Yavé, se echó con Balaam a cuestas. Balaam furioso, le pegó con su palo."
,"28":"Esta vez Yavé abrió el hocico de la burra, la que le dijo a Balaam: '¿Qué te he hecho para que me pegues tres veces?'"
,"29":"Balaam le respondió a su burra: '¿Y hasta te burlas de mí? Ojalá hubiera tenido una espada a mano porque te habría dado muerte inmediatamente.'"
,"30":"La burra le dijo a Balaam: '¿No soy acaso tu burra en la que montas desde que viniste al mundo hasta el día de hoy? ¿Tengo costumbre de actuar contigo de esta manera?' 'Evidentemente que no', respondió él."
,"31":"Entonces Yavé abrió los ojos de Balaam: vio al ángel de Yavé de pie en medio del camino, con su espada desenvainada en la mano. Se arrodilló y se postró con su nariz en tierra."
,"32":"El ángel de Yavé le dijo: '¿Por qué le pegaste tres veces a tu burra? Yo vine para impedirte el paso, porque este viaje no me gusta."
,"33":"La burra me vio y trató de esquivarme tres veces. Si no me hubiera esquivado, te habría dado muerte al instante y a ella la habría dejado con vida.'"
,"34":"Balaam le dijo al ángel de Yavé: 'A lo mejor pequé, pero no sabía que tú estabas impidiéndome el paso. Si esto no te gusta, me vuelvo a mi casa.'"
,"35":"El ángel de Yavé le dijo entonces a Balaam: 'Anda con esos señores, pero sólo dirás las palabras que yo te trasmita.' Balaam siguió pues su camino junto con los jefes enviados por Balac."
,"36":"Cuando Balac supo que venía Balaam, salió a su encuentro en Ar-Moab, en la frontera del Arnón en los límites de su territorio."
,"37":"Balac dijo a Balaam: '¿No te había mandado gente para invitarte? ¿Por qué no viniste? ¿Pensabas acaso que no te iba a pagar como es debido?'"
,"38":"Balaam respondió a Balac: 'Tú ves bien que he llegado, pero ¿qué puedo decir ahora? ¡Sólo las palabras que Dios pondrá en mi boca!'"
,"39":"Balaam se fue luego con Balac y llegaron a Quiriat-Jusot."
,"40":"Balac sacrificó bueyes y ovejas y envió parte del sacrificio a Balaam y a los jefes que habían venido con éste."
,"41":"De mañana Balac vino a buscar a Balaam e hizo que subiera a Bamot-Baal, porque desde allí podía ver una parte del pueblo."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Balaam le dijo a Balac: '¡Levanta aquí siete altares y prepárame siete novillos y siete chivos!'"
,"2":"Balac hizo lo que Balaam le había dicho, y Balac y Balaam sacrificaron un novillo y un chivo en cada altar."
,"3":"Balaam le dijo a Balac: 'Quédate aquí cerca de tu holocausto mientras voy a dar una vuelta. A lo mejor Yavé viene a visitarme para que yo te revele entonces lo que me dé a conocer.' Y Balaam se fue a una cumbre."
,"4":"Dios se presentó a Balaam y éste le dijo: '¡Preparé siete altares y en cada altar sacrifiqué un novillo y un chivo!'"
,"5":"Entonces Yavé puso una palabra en la boca de Balaam y le dijo: 'Regresa donde Balac y transmítele esta palabra.'"
,"6":"Volvió pues donde Balac que seguía de pie junto a su holocausto con todos los jefes de Moab."
,"7":"Y Balaam proclamó su poema: 'De Aram me dice que venga Balac, de los montes del oriente,me llama el rey de Moab: '¡Ven y maldice a Jacob!,¡Ven y amenaza a Israel!'"
,"8":"¿Cómo maldecir si Dios no maldice, cómo amenazar si Dios no amenaza?"
,"9":"¡Lo veo de lo alto de los riscos,y lo contemplo de lo alto de las colinas: ese pueblo vive aparte,no se lo puede contar entre las naciones!"
,"10":"¿Quién podrá calcular el polvo de Jacob,y contar aunque sea una cuarta parte de Israel?,¡Que muera yo con la muerte de los justos,y que mi fin sea como él de ellos!'"
,"11":"Balac le dijo a Balaam: '¿Qué me hiciste? ¡Te traje para que maldijeras a mis enemigos y tú los bendices!'"
,"12":"Respondió: '¿No debo acaso decir lo que Yavé puso en mi boca?'"
,"13":"Entonces Balac le dijo: 'Ven pues conmigo a otro lugar. Desde allí verás al pueblo, aunque no todo, y tú me lo maldecirás.'"
,"14":"Lo llevó pues al Campo de los Centinelas en la cumbre del Pisga. Allí hizo siete altares y puso en cada altar un novillo y un chivo."
,"15":"Balaam le dijo entonces a Balac: 'Quédate aquí junto a tu holocausto, que yo iré un poco más lejos.'"
,"16":"Yavé se presentó a Balaam y puso una palabra en su boca, luego le dijo: 'Regresa donde está Balac y transmítele esta palabra.'"
,"17":"Balaam volvió entonces donde aquél, que seguía de pie al lado de su holocausto con los jefes de Moab. Balac le preguntó a Balaam: '¿Qué dijo Yavé?'"
,"18":"Y Balaam proclamó su poema: '¡Levántate Balac, escucha!,¡Pon atención, hijo de Sipor!"
,"19":"Dios no es un hombre para que mienta, ni es un hijo de hombre para volver atrás. ¿Dice él algo sin que lo haga?,¿O habla sin que actúe?"
,"20":"¡Mira! Me trajo para bendecir; si él bendice, ¿cómo voy a decir otra cosa?"
,"21":"El no vio culpa alguna en Jacob,ni percibió mal alguno en Israel. Yavé su Dios está con él, en su campamento se oye,que aclaman a su rey."
,"22":"¡Dios lo hizo salir de Egipto, y le dio cuernos de búfalo!"
,"23":"No necesitan magia en Jacob,ni brujerías en Israel, porque a su debido tiempo,se le predecirá a Jacob, a Israel, lo que Dios prepara."
,"24":"Ese pueblo se alza como una leona, se yergue como un león. No volverá sin que haya devorado su presa, sin que haya bebido la sangre de sus víctimas."
,"25":"Balac le dijo a Balaam: '¡Si no maldices, por lo menos no lo bendigas!'"
,"26":"Pero Balaam le respondió a Balac: 'Te lo advertí muy bien: lo que diga Yavé, eso haré'."
,"27":"Balac le dijo a Balaam: 'Ven, te llevaré a otra parte, y a lo mejor allí tu Dios estará de acuerdo en que me lo maldigas!'"
,"28":"Balaam condujo entonces a Balaam a la cima del monte Fogor, frente al desierto."
,"29":"Balaam le dijo a Balac: 'Haz siete altares en este lugar, y prepara siete novillos y siete chivos'."
,"30":"Balac hizo como Balaam le había dicho y sacrificó un novillo y un chivo en cada altar."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Balaam vio que a Dios le gustaba bendecir a Israel, de manera que no fue como las otras veces en busca de señales, sino que se volvió de cara al desierto."
,"2":"Cuando Balaam levantó la vista, vio a Israel agrupado por tribus; entonces el espíritu de Dios se apoderó de él."
,"3":"Y proclamó así su poema: 'Palabra de Balaam, hijo de Beor, palabra del hombre que traspasa el misterio,"
,"4":"oráculo del que escucha las palabras de Dios, que ve lo que el Dios de la Estepa le da a ver, que se postra, y Dios le abre los ojos."
,"5":"¡Qué hermosas son tus tiendas, oh Jacob, tus moradas, oh Israel!"
,"6":"Se estiran como valles, como jardines a orillas de un río, como áloes que ha plantado Yavé, como cedros a orillas de un curso de agua."
,"7":"¡Se rebalsa el agua de sus dos baldes, su simiente está bien regada, su rey es más poderoso que Agag, y su reino crece todavía!"
,"8":"¡Dios lo hace salir de Egipto, y le da cuernos de búfalo!,Devora a las naciones enemigas, les quiebra los huesos, las atraviesa con sus flechas."
,"9":"Se agacha, se acuesta como un león, como una leona: ¿quién lo hará levantarse?,Benditos sean los que te bendicen, malditos sean los que te maldicen.'"
,"10":"Se enojó Balac con Balaam; golpeó las manos, y le dijo: '¡Te hice venir para que maldijeras a mis enemigos, y tú, en cambio, los has bendecido tres veces!"
,"11":"Ahora lárgate a tu tierra. Yo había prometido colmarte de honores, pero Yavé te dejó sin nada.'"
,"12":"Balaam respondió a Balac: 'Dije algo a los hombres que tú me mandaste; les dije:"
,"13":"Aunque Balac me dé su casa llena de plata y de oro, no desobedeceré la orden de Yavé. Bien o mal, no haré nada por mi mismo, sino que diré lo que diga Yavé."
,"14":"Ahora me regreso a mi tierra. Pero déjame decirte lo que ese pueblo hará a tu pueblo en los días venideros.'"
,"15":"Entonces proclamó su poema: 'Palabra de Balaam, hijo de Beor, palabra del hombre que atraviesa el misterio,"
,"16":"oráculo del que escucha las palabras de Dios,y que posee la ciencia del Altísimo, que ve lo que el Dios de la Estepa le deja ver, que se postra, y Dios le abre los ojos."
,"17":"Lo veo; pero no por ahora, lo contemplo, pero no de cerca: un astro se levanta desde Jacob, un cetro se yergue en Israel. Le pega a Moab en las sienes, y en el cráneo a todos los hijos de Set."
,"18":"Edom se convierte en su conquista, le quita Seír a sus enemigos, Israel hace grandes cosas,"
,"19":"Jacob impone su fuerza,y hace que perezcan los sobrevivientes de Ar.'"
,"20":"Balaam vio a Amalec y dijo su poema: '¡Amalec, la primera de las naciones, tu posteridad desaparecerá!'"
,"21":"Al ver a los cenitas, dijo su poema: '¡Sólida es tu morada, tu nido está instalado en una roca!"
,"22":"Sin embargo, el fuego devorará a Kayin, y al final el asirio lo llevará cautivo.'"
,"23":"Y proclamó además este poema: '¡Ay! ¿quién estará allí cuando Dios lo decida?"
,"24":"Vienen naves desde Quitim, someten al asirio, someten al hebreo, pero ellos también correrán a la ruina'."
,"25":"Balaam se puso en camino para volver a su casa, y Balac se fue también por su camino."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Israel se instaló en Sitim y el pueblo se entregó a la prostitución con las hijas de Moab."
,"2":"Ellas invitaron al pueblo a sacrificar a sus dioses: el pueblo comió y se postró ante los dioses de ellas."
,"3":"Israel se apegó al Baal de Fogor y se encendió la cólera de Yavé contra Israel."
,"4":"Yavé dijo entonces a Moisés: 'Apresa a todos los cabecillas del pueblo y empálalos de cara al sol, ante Yavé; de ese modo se apartará de Israel la cólera de Yavé.'"
,"5":"Moisés dijo a los jefes de Israel: 'Que cada uno mate a aquellos de sus hombres que se prostituyeron con el Baal de Fogor'."
,"6":"Justo a ese momento, un israelita introducía en su tienda a una moabita, a la vista de Moisés y de toda la comunidad que lloraba a la entrada de la Tienda de las Citas."
,"7":"Al ver eso, Finjas, hijo de Eleazar, hijo del sacerdote Aarón, tomó una lanza,"
,"8":"siguió al israelita al interior de su tienda y los traspasó a los dos, al hombre y a la mujer, en pleno vientre. Inmediatamente cesó la plaga que se cernía sobre Israel:"
,"9":"porque ya habían muerto por esa plaga veinticuatro mil de ellos."
,"10":"Yavé dijo a Moisés:"
,"11":"'Finjas, hijo de Eleazar, hijo del sacerdote Aarón, alejó mi cólera de los israelitas cuando se mostró lleno de celo por mí en medio de ellos."
,"12":"Por eso le dirás que me comprometo a recompensarlo."
,"13":"Me comprometo a darle el sacerdocio para siempre, a él y a su descendencia, porque se mostró lleno de celo por su Dios y lo reparó en nombre de los Israelitas.'"
,"14":"El israelita que fue muerto, al ser herido junto con la madianita, se llamaba Zimiri, hijo de Salú; era uno de los jefes de la tribu de Simeón."
,"15":"El nombre de la madianita que fue muerta era Cozbi, hija de Sur, jefe de una familia de Madián."
,"16":"Yavé le dijo entonces a Moisés. '"
,"17":"Ataca a los madianitas y acaba con ellos,"
,"18":"porque los atacaron a ustedes con su idolatría. Los engañaron a ustedes en el asunto de Fogor y en el de Cozbi, su hermana, hija de un príncipe de Madián, la que fue muerta en el día de la plaga, cuando fue el asunto de Fogor.'"
}`)
	CurrentBook.AddChapter(26, `{
"1":"Yavé dijo a Moisés y a Eleazar, hijo del sacerdote Aarón:"
,"2":"'Registren a toda la comunidad de los hijos de Israel por casas paternas, y hagan el recuento de todos los de más de veinte años, útiles para la guerra.'"
,"3":"Moisés y el sacerdote Eleazar les hablaron en las estepas de Moab, cerca del Jordán, a la altura de Jericó,"
,"4":"y les dieron esta precisión: 'A los que tenían más de veinte años.',Los hijos de Israel salidos de Egipto eran:"
,"5":"Rubén, primogénito de Israel. Hijos de Rubén: Henoc y el clan henoquita; Palú y el clan paluita;"
,"6":"Jersón y el clan jersonita; Karmí y el clan karmita."
,"7":"Esos eran los clanes rubenitas. Según el censo, eran cuarenta y tres mil setecientos treinta."
,"8":"Hijos de Palú: Eliab. Hijos de Eliab: Nemuel, Datán y Abirón."
,"9":"Estos Datán y Abirón fueron convocados por la comunidad y se rebelaron contra Moisés y Aarón con los partidarios de Coré, cuando éste se rebeló contra Yavé."
,"10":"La tierra abrió su boca y los tragó a ellos (y a Coré, cuando pereció su grupo) cuando el fuego devoró a doscientos cincuenta hombres: sirvió de escarmiento."
,"11":"Pero los hijos de Coré no murieron."
,"12":"Hijos de Simeón; por clanes: Nemuel y el clan nemuelita; Yamín y el clan yaminita; Yakín y el clan yakinita;"
,"13":"Socar y el clan socarita; Saúl y el clan saulita."
,"14":"Estos eran los clanes simeonitas. Según el censo, eran veintidós mil doscientos."
,"15":"Hijos de Gad; por clanes: Sefón y el clan sefonita; Jagguí y el clan jaguita; Suní y el clan sunita;"
,"16":"Ozní y el clan oznita; Erí y el clan erita; Arod y el clan arodita;"
,"17":"Arelí y el clan arelita."
,"18":"Esos eran los clanes de los hijos de Gad. Según el censo eran cuarenta mil quinientos."
,"19":"Hijos de Judá: Er y Onán, que murieron en la tierra de Canaán."
,"20":"Después, los hijos de Judá, por clanes, fueron: Selá y el clan selanita; Peres y el clan peresita; Zeraj y el clan zerajita."
,"21":"Hijos de Peres fueron: Jesrón y el clan jesronita; Jamul y el clan jamulita."
,"22":"Estos eran los clanes de Judá. Según el censo eran setenta y seis mil quinientos."
,"23":"Hijos de Isacar, por clanes: Tolá y el clan tolaíta; Puvá y el clan puvita;"
,"24":"Yasub y el clan yasubita; Simrón y el clan simronita."
,"25":"Esos eran los clanes de Isacar. Según el censo eran sesenta y cuatro mil tres cientos."
,"26":"Hijos de Zabulón, por clanes: Sared y el clan saredita; Elón y el clan elonita; Yajleel y el clan yajleelita."
,"27":"Esos eran los clanes de Zabulón. Según el censo, eran sesenta mil quinientos."
,"28":"Hijos de José, por clanes: Manasés y Efraím."
,"29":"Hijos de Manasés: Makir y el clan makirita. Makir engendró a Galaad. De Galaad, el clan galaadita."
,"30":"Los hijos de Galaad eran: Yezer y el clan yezerita: Yéleq y el clan yelequita;"
,"31":"Asriel y el clan asrielita; Sekem y el clan sekemita;"
,"32":"Semidá y el clan semidaíta; Jéfer y el clan jeferita; Selofjad, hijo de Jéfer. Selofjad no tuvo hijos, solamente hijas."
,"33":"Se llamaban las hijas de Selofjad: Mojlá, Noaá, Joglá, Milcá y Tirsá."
,"34":"Esos eran los clanes de Manasés, según el censo, eran cincuenta y dos mil setecientos."
,"35":"Estos eran los hijos de Efraím, por clanes: Sutelaj y el clan sutelajita; Beker y el clan bekerita; Taján y el clan tajanita."
,"36":"Estos son los hijos de Sutelaj: Erán y el clan eranita."
,"37":"Esos eran los clanes de los hijos de Efraím. Según el censo eran treinta y dos mil quinientos. Esos eran los hijos de José por clanes."
,"38":"Hijos de Benjamín, por clanes: Belá y el clan belaíta; Asbel y el clan asbelita; Ajiram y el clan ajiramita;"
,"39":"Sefufam y el clan sefufamita; Jufan y el clan jufanita."
,"40":"Los hijos de Belá fueron Ard y Naamán: de Ard, el clan ardita; de Naamán, el clan naamanita."
,"41":"Esos eran los hijos de Benjamín, por clanes. Según el censo eran cuarenta y cinco mil seiscientos."
,"42":"Estos eran los hijos de Dan, por clanes: Sujam y el clan sujamita. Estos eran los clanes de Dan, por clanes."
,"43":"Todos los clanes sujamitas. Según el censo, eran sesenta y cuatro mil cuatrocientos."
,"44":"Hijos de Aser, por clanes: Yimná y el clan yimnita; Yisví y el clan yisvita; Bería y el clan berita."
,"45":"De los hijos de Bería: Jéber y el clan jeberita; Malkiel y el clan malkielita. La hija de Aser se llamaba Sáraja."
,"46":"Esos eran los clanes de los hijos de Aser."
,"47":"Según el censo eran cincuenta y tres mil cuatrocientos."
,"48":"Hijos de Neftalí, por clanes: Yajseel y el clan yajseelita; Guní y el clan gunita; Yéser y el clan yeserita;"
,"49":"Sil-Lem y el clan silemita."
,"50":"Esos eran los clanes de Neftalí. Según el censo eran cuarenta y cinco mil quinientos."
,"51":"Así que pasaron revista a seiscientos un mil setecientos treinta israelitas."
,"52":"Yavé dijo a Moisés:"
,"53":"'Tú les repartirás la tierra en herencia, conforme al número de alistados;"
,"54":"darás mayor herencia a los que son más numerosos, y menor a los que son menos."
,"55":"Pero el reparto se hará a la suerte; según los nombres de cada tribu paterna recibirán la herencia."
,"56":"La suerte decidirá la repartición, haciendo distinción entre los grandes y los pequeños.'"
,"57":"Estos son los levitas, alistados según sus clanes: Guersón y el clan guersonita; Quehat y el clan quehatita; Merarí y el clan merarita."
,"58":"Estos son los clanes de Leví: Lobní, Hebroní, Mahalí, Musí, Coré. Quehat fue padre de Amram,"
,"59":"el cual tuvo por esposa a Jocabed, descendiente de Leví, que nació en Egipto. Amram tuvo de ella a Aarón, Moisés y María, su hermana."
,"60":"Aarón fue padre de Nadab y Abihú, Eleazar e Itamar,"
,"61":"pero Nadab y Abihú murieron al ofrecer fuego profano delante de Yavé."
,"62":"Se contaron en total en la tribu de Leví veintitrés mil varones de un mes para arriba. No fueron alistados con los demás hijos de Israel, pues no debían compartir con ellos la herencia."
,"63":"Estos fueron alistados por Moisés y el sacerdote Eleazar, cuando alistaron a los hijos de Israel en las estepas de Moab, cerca del Jordán, a la altura de Jericó."
,"64":"Entre ellos no había nadie de los que habían sido alistados por Moisés y por el sacerdote Aarón, cuando hicieron el censo de los hijos de Israel en el desierto de Sinaí."
,"65":"Es que Yavé había dicho que morirían en el desierto y no quedó ninguno de ellos, excepto Caleb, hijo de Jefoné, y Josué, hijo de Nun."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Entonces se acercaron las hijas de Selofjad, hijo de Jefer, hijo de Galaad, hijo de Maquir, hijo de Manasés, que fue hijo de José. Sus nombres eran: Majlá, Noá, Joglá, Milcá y Tirsá."
,"2":"Se presentaron a Moisés y al sacerdote Eleazar, a los jefes y a toda la comunidad a la entrada de la Tienda de las Citas, y dijeron:"
,"3":"'Nuestro padre murió en el desierto. No tuvo parte en la amotinación contra Yavé, con los partidarios de Coré, sino que murió como todos por su pecado, y no dejó hijos varones."
,"4":"¿Será posible que su nombre sea borrado de entre los de su familia? Puesto que no tuvo hijos, dennos a nosotros una herencia entre los hermanos de nuestro padre.'"
,"5":"Moisés fue a consultar a Yavé por este caso,"
,"6":"y Yavé dijo a Moisés: 'La petición de las hijas de Selofjad es justa;"
,"7":"dales, pues, la herencia de su padre, y que tengan una herencia entre los hermanos de su padre."
,"8":"Y dirás a los hijos de Israel: Si un hombre muere sin tener hijos, su herencia se traspasará a su hija."
,"9":"Si tampoco tiene hijas, darán su herencia a sus hermanos."
,"10":"Si tampoco los hay, darán la herencia al hermano de su padre."
,"11":"Y si su padre no tenía hermanos, darán la herencia al pariente más próximo de su familia, el cual tomará posesión de ella. Esta será norma de derecho para los hijos de Israel, pues así lo mandó Yavé a Moisés.'"
,"12":"Yavé dijo a Moisés: 'Sube a esa montaña de los montes de Abarim, y contempla desde allí la tierra que yo daré a los hijos de Israel."
,"13":"Cuando la hayas visto, irás a reunirte tú también a tu pueblo, como tu hermano Aarón."
,"14":"Recuerda que ustedes se rebelaron contra mis órdenes en el desierto de Zin, cuando la comunidad murmuró por el asunto del agua, y a ustedes les mandé que manifestaran mi santidad delante de ellos.' (Estas son las aguas de Meribá en Cadés en el desierto de Zin.)"
,"15":"Moisés, pues, dijo a Yavé:"
,"16":"'Que Yavé, Dios de los espíritus de todos los mortales, designe un hombre para estar al frente de esta comunidad,"
,"17":"para que salga y entre al frente de ellos. El los hará salir y entrar, y con esto el pueblo de Yavé no se parecerá a un rebaño sin pastor.'"
,"18":"Yavé respondió a Moisés: 'Llama a Josué, hijo de Nun, hombre en que está el Espíritu, y pon tu mano sobre él."
,"19":"Lo presentarás al sacerdote Eleazar y a toda la comunidad, y allí le darás instrucciones en presencia de ellos."
,"20":"Le transmitirás una parte de tu autoridad con el fin de que toda la comunidad de los hijos de Israel le obedezca."
,"21":"En adelante se presentará ante el sacerdote Eleazar y éste consultará a Yavé por medio del Urim para darle una respuesta. A sus órdenes saldrán y a sus órdenes entrarán todos los hijos de Israel, toda la comunidad.'"
,"22":"Moisés hizo como le había mandado Yavé; tomó a Josué y lo puso delante del sacerdote Eleazar y delante de todo el pueblo."
,"23":"Le impuso su mano y lo estableció como Yavé había dicho por intermedio de Moisés."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Yavé dijo a Moisés:"
,"2":"'Da esta orden a los hijos de Israel: Tendrán cuidado de traerme a su debido tiempo la ofrenda de alimentos que me corresponde en los sacrificios por el fuego de suave aroma."
,"3":"Les dirás: Este será el sacrificio por el fuego que ustedes ofrecerán a Yavé cada día:"
,"4":"dos corderos de un año sin defecto. Es el holocausto perpetuo. Ofrecerán uno de los corderos por la mañana, y el otro al atardecer,"
,"5":"con una décima de medida de flor de harina, amasada con un cuarto de sextario de aceite virgen, como oblación."
,"6":"Es el holocausto perpetuo que se ofreció en el monte Sinaí como calmante aroma, sacrificio por el fuego para Yavé."
,"7":"Harás la libación de vino puro, delante de Yavé en el lugar santo: un cuarto de sextario por cada cordero."
,"8":"El segundo cordero lo ofrecerás por la tarde: lo ofrecerás con la misma oblación y libación que el de la mañana, como sacrificio por el fuego de calmante aroma para Yavé."
,"9":"El día sábado, ofrecerás dos corderos de un año, sin tacha, y como oblación, dos décimas de flor de harina amasada con aceite, junto con su correspondiente libación."
,"10":"Es el holocausto del sábado que se añadirá cada sábado al holocausto perpetuo y a su libación."
,"11":"El primer día del mes, ustedes ofrecerán un holocausto a Yavé: dos novillos, un carnero y siete corderos de un año, sin defecto."
,"12":"Como oblación, tres décimas de flor de harina amasada con aceite por cada novillo; y dos décimas de flor de harina amasada con aceite por el carnero;"
,"13":"y una décima de flor de harina amasada con aceite por cada cordero: es un holocausto de calmante aroma, sacrificio por el fuego para Yavé."
,"14":"Las libaciones correspondientes serán: medio sextario de vino por novillo, un tercio de sextario por el carnero y un cuarto de sextario por cordero. Este será el holocausto mensual, todos los meses del año."
,"15":"Ofrecerás también a Yavé, como sacrificio por el pecado, un macho cabrío con su libación, además del holocausto perpetuo."
,"16":"El mes primero, el día catorce del mes, es la Pascua de Yavé,"
,"17":"y el día quince del mismo mes es día de fiesta. Durante siete días comerán panes sin levadura."
,"18":"El día primero habrá reunión sagrada, y no harán ningún trabajo de trabajador."
,"19":"Ofrecerán un sacrificio de holocausto a Yavé: dos novillos, un carnero, y siete corderos de un año, sin defecto."
,"20":"La oblación correspondiente de flor de harina amasada con aceite será de tres décimas por novillo, dos décimas por el carnero"
,"21":"y una décima por cada uno de los siete corderos."
,"22":"Ofrecerán además un macho cabrío como sacrificio por el pecado, para expiar por ustedes."
,"23":"Esto, además del holocausto de la mañana que ofrecerán como holocausto perpetuo."
,"24":"Así harán durante los siete días de la fiesta. Es un alimento, un sacrificio por el fuego de calmante aroma para Yavé; lo ofrecerán además del holocausto perpetuo y de su libación."
,"25":"El séptimo día, ustedes tendrán reunión sagrada y no harán ningún trabajo de trabajador."
,"26":"El día de las primicias, cuando ofrezcan a Yavé los frutos nuevos, en la fiesta de las Semanas, tendrán reunión sagrada, y no harán ningún trabajo de trabajador."
,"27":"Ofrecerán en holocausto de calmante aroma para Yavé dos novillos, un carnero y siete corderos de un año."
,"28":"La oblación correspondiente será de tres décimas de flor de harina amasada con aceite por novillo, dos décimas por carnero"
,"29":"y una décima por cada uno de los siete corderos."
,"30":"Ofrecerán además un macho cabrío para expiar por ustedes."
,"31":"Ustedes lo ofrecerán con sus libaciones además del holocausto perpetuo y su oblación. Ustedes escogerán animales sin defecto."
}`)
	CurrentBook.AddChapter(29, `{
"1":"El mes séptimo, el primero del mes, tendrán una reunión sagrada; no harán ningún trabajo de trabajador. Será para ustedes el día de las Aclamaciones."
,"2":"Ofrecerán un novillo, un carnero, y siete corderos de un año sin defecto, como holocausto de calmante aroma para Yavé."
,"3":"La oblación correspondiente de flor de harina amasada con aceite será de tres décimas por el novillo, dos décimas por el carnero"
,"4":"y una décima por cada uno de los siete corderos."
,"5":"Ustedes ofrecerán un macho cabrío como sacrificio por el pecado, para hacer la expiación por ustedes."
,"6":"Ustedes harán esto además del holocausto mensual y de su oblación, del holocausto perpetuo y de su oblación y sus libaciones, según la norma establecida; ésos son sacrificios por el fuego de calmante aroma para Yavé."
,"7":"El día décimo del mismo mes séptimo, ustedes tendrán una reunión sagrada: ayunarán y no harán ningún trabajo de trabajador."
,"8":"Ofrecerán un novillo, un carnero y siete corderos de un año sin defecto como holocausto de calmante aroma para Yavé."
,"9":"La oblación de flor de harina amasada con aceite será de tres décimas por el novillo, dos décimas por el carnero,"
,"10":"una décima por cada uno de los corderos."
,"11":"Ofrecerán también un macho cabrío como sacrificio por el pecado; todo esto además del sacrificio de la fiesta de la expiación y del holocausto perpetuo, de su oblación y sus libaciones."
,"12":"El día quince del mes séptimo tendrán una reunión sagrada; no harán ningún trabajo de trabajador y celebrarán durante siete días una fiesta en honor de Yavé."
,"13":"Ofrecerán trece novillos, dos carneros y catorce corderos sin defecto como holocausto de calmante aroma para Yavé."
,"14":"Ofrecerán además la oblación de flor de harina amasada con aceite; será de tres décimas por cada uno de los novillos, dos décimas por cada uno de los carneros"
,"15":"y una décima por cada uno de los corderos."
,"16":"Ofrecerán también un macho cabrío como sacrificio por el pecado; todo esto además del holocausto perpetuo, de su oblación y libación."
,"17":"El día segundo ofrecerán doce novillos, dos carneros, catorce corderos de un año sin defecto,"
,"18":"con las oblaciones y libaciones correspondientes al número y según las normas por los novillos, carneros y corderos."
,"19":"Ofrecerán un macho cabrío como sacrificio por el pecado; todo esto además del holocausto perpetuo, de su oblación y sus libaciones."
,"20":"El día tercero, ofrcerán once novillos, dos carneros, catorce corderos de un año sin defecto,"
,"21":"con las oblaciones y libaciones correspondientes al número y según las normas por los novillos, carneros y corderos."
,"22":"Ofrecerán un macho cabrío como sacrificio por el pecado; todo esto además del holocausto perpetuo, de su oblación y su libación."
,"23":"El cuarto día ofrecerán diez novillos, dos carneros y catorce corderos de un año sin defecto,"
,"24":"con las oblaciones y libaciones correspondientes al número y según las normas por los novillos, carneros y corderos."
,"25":"Ofrecerán un macho cabrío como sacrificio por el pecado; todo esto además del holocausto perpetuo, con su oblación y su libación."
,"26":"El quinto día ofrecerán nueve novillos, dos carneros y catorce corderos de un año sin defecto,"
,"27":"con las oblaciones y libaciones correspondientes al número y según las normas por los novillos, carneros y corderos."
,"28":"Ofrecerán un macho cabrío como sacrificio por el pecado; todo esto además del holocausto perpetuo, de su oblación y su libación."
,"29":"El día sexto ofrecerán ocho novillos, dos carneros y catorce corderos de un año sin defecto,"
,"30":"con las oblaciones y libaciones correspondientes al número y según las normas por los novillos, los carneros y los corderos."
,"31":"Ofrecerán un macho cabrío como sacrificio por el pecado; todo esto, además del holocausto perpetuo, de su oblación y su libación."
,"32":"El día séptimo ofrecerán siete novillos, dos carneros y catorce corderos de un año sin defecto,"
,"33":"con las oblaciones y libaciones correspondientes al número y según las normas por los novillos, los carneros y los corderos."
,"34":"Ofrecerán un macho cabrío como sacrificio por el pecado; todo esto, además del holocausto perpetuo, de su oblación y su libación."
,"35":"El día octavo será para ustedes de reunión solemne; no harán ningún trabajo de trabajador."
,"36":"Ofrecerán un novillo, un carnero y siete corderos de un año sin tacha, en holocausto, como sacrificio por el fuego de calmante aroma para Yavé,"
,"37":"con las oblaciones y libaciones conforme al número y según las normas por el novillo, el carnero y los corderos."
,"38":"Ofrecerán un macho cabrío como sacrificio por el pecado; todo esto además del holocausto perpetuo, de su oblación y libación."
,"39":"Estos son los sacrificios que ofrecerán a Yavé en las solemnidades. Se les añadirán sus ofrendas de votos y espontáneas, sus holocaustos, oblaciones, libaciones y sacrificios de comunión.'"
}`)
	CurrentBook.AddChapter(30, `{
"1":"Moisés habló a los hijos de Israel conforme a todo lo que Yavé le había ordenado."
,"2":"Moisés dijo a los jefes de las tribus de Israel:"
,"3":"'Esto es lo que ha ordenado Yavé: Si un hombre hace un voto a Yavé o se compromete con juramento, no faltará a su palabra, sino que cumplirá todo lo que ha prometido."
,"4":"Pero está el caso de una mujer que hace un voto a Yavé o toma un compromiso en su juventud, cuando está en casa de su padre."
,"5":"Si su padre, al enterarse de su voto o del compromiso que ha contraído, no le dice nada, serán válidos."
,"6":"Pero si su padre, el mismo día en que se entera de cualquiera de sus votos o de los compromisos que ha contraído, lo desaprueba, no serán válidos. Yavé no se lo tomará en cuenta, pues su padre lo ha desaprobado."
,"7":"Está también el caso de una mujer que se casa cuando todavía está ligada por un voto o por una promesa que ha hecho imprudentemente."
,"8":"Si su marido, al enterarse, no le dice nada, los votos y compromisos que ha contraído serán válidos."
,"9":"Pero si su marido, el mismo día en que se entera, desaprueba los votos o promesas que hizo y los anula, Yavé no se lo tomará en cuenta."
,"10":"El voto de una mujer viuda o despedida y todos los compromisos contraídos por ella serán válidos."
,"11":"Está también el caso de la mujer que ha hecho un voto estando en casa de su marido, o se ha comprometido con juramento."
,"12":"Si su marido al enterarse no le dice nada, ni lo desaprueba, serán válidos."
,"13":"Pero si su marido se lo anula el mismo día en que se entera, está desligada de su palabra o juramento, de su voto y de sus compromisos. Yavé no se lo tomará en cuenta, pues su marido lo ha desaprobado."
,"14":"Cualquier voto o compromiso con el que la mujer se quiere mortificar, lo ratifica y anula el marido."
,"15":"Si su marido no le dice nada hasta el día siguiente, es que confirma el voto o el compromiso de su esposa; lo confirma con no expresar su desaprobación en el momento en que ella se lo dio a conocer."
,"16":"Y si, más tarde, quiere anularlo, cargará con la falta de su esposa.'"
,"17":"Estos son los mandatos que Yavé dio a Moisés referente a la esposa y su marido, y al padre con su hija que, siendo joven todavía, está en la casa de su padre."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Yavé dijo a Moisés:"
,"2":"'Que los hijos de Israel tomen ahora desquite de los madianitas, y luego irás a reunirte con tu pueblo.'"
,"3":"Moisés, pues, dijo al pueblo: 'Que se armen algunos de ustedes para la guerra. Que vayan a pelear contra Madián y sean los instrumentos de la venganza de Yavé contra él."
,"4":"Enviarán a la guerra mil hombres de cada tribu de Israel.'"
,"5":"Reclutaron, pues, entre los israelitas, mil hombres por cada tribu, doce mil hombres armados para la guerra."
,"6":"Moisés mandó al combate mil por cada tribu, y con ellos a Finjas, hijo del sacerdote Eleazar, que llevaba los objetos sagrados, y las trompetas para los toques."
,"7":"Pelearon contra Madián, como Yavé había mandado a Moisés, y mataron a todos los varones."
,"8":"Mataron también a los reyes de Madián: Eví, Requem, Sur, Jur y Rebá; eran los cinco reyes madianitas. Mataron también a espada a Balaam, hijo de Beor."
,"9":"Los hijos de Israel trajeron cautivas a las mujeres de Madián y a sus niños y recogieron sus animales, sus rebaños y todas sus pertenencias."
,"10":"Prendieron fuego a todos los pueblos en que vivían y a todos sus campamentos."
,"11":"Habiendo reunido todo el botín y los despojos, hombres y bestias,"
,"12":"llevaron los cautivos y el botín ante Moisés, el sacerdote Eleazar y toda la comunidad de los hijos de Israel, en las estepas de Moab, que están cerca del Jordán, a la altura de Jericó."
,"13":"Moisés, el sacerdote Eleazar y todos los jefes de la comunidad salieron a su encuentro hasta fuera del campamento."
,"14":"Moisés se enojó contra los jefes de las tropas, jefes de mil y jefes de cien que volvían del combate."
,"15":"Moisés les dijo: '¿Así, pues, han dejado con vida a las mujeres?"
,"16":"Precisamente ellas fueron las que, siguiendo el consejo de Balaam, indujeron a los hijos de Israel a que desobedecieran a Yavé (en el asunto de Baal-Peor); y una plaga azotó a la comunidad de Yavé."
,"17":"Maten, pues, a todos los niños hombres, y a toda mujer que haya tenido relaciones con un hombre."
,"18":"Pero dejen con vida y tomen para ustedes todas las niñas que todavía no han tenido relaciones."
,"19":"Todos los de ustedes que derramaron sangre o que tocaron a algún muerto, quedarán fuera del campamento durante siete días, y se purificarán el tercer y el séptimo día. Ustedes harán lo mismo con las cautivas."
,"20":"Asimismo purificarán todos los vestidos, objetos de cuero, tejidos de pelo de cabra y objetos de madera.'"
,"21":"El sacerdote Eleazar dijo a los hombres que habían ido a la guerra: 'Esta es la Ley que Yavé ordenó a Moisés:"
,"22":"el oro, la plata, el cobre, el hierro, el estaño y el plomo, todo lo que puede pasar por el fuego, lo purificarán con el fuego y el agua de purificación."
,"23":"Y todo lo que no pueda pasar por el fuego lo pasarán por agua."
,"24":"Después de lavar sus vestidos el día séptimo, quedarán puros y podrán volver al campamento.'"
,"25":"Yavé dijo a Moisés:"
,"26":"'Saca la cuenta, tú, el sacerdote Eleazar y los jefes de las familias de la comunidad, de lo que fue traído como botín, hombres y ganado."
,"27":"Lo partirás en dos; la mitad, para los combatientes que fueron a la guerra, y la otra mitad, para toda la comunidad."
,"28":"Reserva como ofrenda para Yavé, de la parte de los combatientes que fueron a la guerra, uno por cada quinientos, sean hombres, bueyes, burros y ovejas."
,"29":"Lo tomarás de la mitad del botín que les corresponde y se lo darás al sacerdote Eleazar como contribución para Yavé."
,"30":"Y, de la mitad del botín correspondiente a los hijos de Israel, separarás uno por cada cincuenta, sean hombres, bueyes, burros y ovejas, cualquier clase de animales, y se lo darás a los levitas que están encargados del ministerio de la Morada de Yavé.'"
,"31":"Moisés y el sacerdote Eleazar hicieron como Yavé había mandado a Moisés."
,"32":"El botín, lo que quedaba de lo que la gente de guerra había saqueado, era de seiscientas setenta y cinco mil cabezas de ganado menor,"
,"33":"setenta y dos mil de vacuno"
,"34":"y sesenta y un mil burros."
,"35":"En cuanto a las personas, las mujeres que todavía no habían tenido relaciones eran en total treinta y dos mil."
,"36":"La mitad que correspondió a los que fueron al combate fue de trescientas treinta y siete mil quinientas cabezas de ganado menor,"
,"37":"siendo la parte de Yavé seiscientas sesenta y cinco cabezas;"
,"38":"además, treinta y seis mil cabezas de vacuno, siendo la parte de Yavé setenta y dos; además,"
,"39":"treinta mil quinientos burros, siendo la parte de Yavé sesenta y uno."
,"40":"Personas: dieciséis mil, siendo la parte de Yavé treinta y dos."
,"41":"Moisés dio al sacerdote Eleazar la ofrenda reservada para Yavé, como Yavé había ordenado a Moisés."
,"42":"La otra mitad del botín, perteneciente a los hijos de Israel,"
,"43":"era de trescientas treinta y siete mil cabezas de ganado menor,"
,"44":"treinta y seis mil de vacuno,"
,"45":"treinta mil quinientas de burros"
,"46":"y dieciséis mil personas."
,"47":"Moisés tomó de esta mitad perteneciente a los hijos de Israel a razón de uno por cincuenta hombres y animales y se los dio a los levitas que cuidan la Morada de Yavé, como Yavé había ordenado a Moisés."
,"48":"Los jefes de las tropas de Israel que habían ido a la guerra, jefes de mil y de cien, se acercaron a Moisés"
,"49":"y le dijeron: 'Hemos sacado la cuenta de los combatientes que teníamos a nuestras órdenes y no falta ni uno."
,"50":"Por eso venimos a ofrecer a Yavé lo que cada uno de nosotros ha encontrado, en objetos de oro, brazaletes, cadenitas, anillos y collares para hacer expiación por nosotros delante de Yavé.'"
,"51":"Moisés y el sacerdote Eleazar recibieron de ellos el oro y las joyas."
,"52":"El total de oro que los jefes de millar y cien presentaron a Yavé fue de dieciséis mil setecientos cincuenta siclos."
,"53":"Los combatientes habían saqueado cada uno por cuenta propia."
,"54":"Entonces Moisés y el sacerdote Eleazar recibieron el oro de los jefes de millar y de cien y lo llevaron a la Tienda de las Citas para que quedara ante Yavé y para que él se acordara de los hijos de Israel."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Los hijos de Rubén y los hijos de Gad, que tenían muy grandes rebaños, vieron que el país de Yazer y el de Galaad eran tierras buenas para la ganadería."
,"2":"Y fueron a decir a Moisés, al sacerdote Eleazar y a los jefes de la comunidad:"
,"3":"'Miren cómo son Atarot, Dibón, Yaser, Nimrá, Jesbón, Elalé, Seban, Nebo y Beón,"
,"4":"este país que Yavé entregó a la comunidad de Israel. Esta es tierra de ganado y nosotros tenemos ganado.' Y agregaron:"
,"5":"'Si quieres hacernos ese favor, que se nos dé esta tierra en propiedad, no nos hagas pasar el Jordán.'"
,"6":"Moisés contestó a los hijos de Gad y a los de Rubén: '¿Acaso nuestros hermanos van a ir al combate mientras ustedes se quedan aquí?"
,"7":"Están desalentando a los hijos de Israel, que ya no querrán pasar a la tierra que Yavé les ha dado."
,"8":"Así hicieron sus padres cuando los mandé de Cadés-Barné a explorar la tierra."
,"9":"Entraron hasta el valle de Escol y vieron la tierra, pero luego desanimaron a los israelitas, que ya no quisieron entrar en la tierra que Yavé les había dado."
,"10":"Por eso Yavé se enojó ese día e hizo este juramento:"
,"11":"'Los hombres que salieron de Egipto, los de veinte años para arriba, no verán la tierra que prometí a Abraham, a Isaac y a Jacob, porque no han sido fieles."
,"12":"Solamente lo harán Caleb, hijo de Jefoné, el queniceo, y Josué, hijo de Nun, que siguieron a Yavé sin fallarle.'"
,"13":"Yavé se enojó y durante cuarenta años los hizo andar por el desierto, hasta que se acabó toda aquella generación que había obrado mal a los ojos de Yavé."
,"14":"¡Raza de pecadores! Ustedes ahora imitan a nuestros padres y quieren que el furor de la ira de Yavé se encienda contra Israel."
,"15":"Si ustedes dejan de obedecerle, él prolongará la estadía en el desierto y por culpa de ustedes se perderá todo este pueblo.'"
,"16":"Entonces se acercaron a Moisés y le dijeron: 'Vamos a construir aquí corrales para nuestras ovejas y ciudades para nuestros niños."
,"17":"Pero nosotros tomaremos las armas y estaremos a la vanguardia de los hijos de Israel hasta que los introduzcamos en la parte que les corresponde, mientras que nuestros hijos se quedarán en las plazas fuertes, al abrigo de los habitantes del país."
,"18":"No volveremos a nuestras casas hasta que los hijos de Israel no hayan recibido cada uno su herencia."
,"19":"No pediremos que se nos dé parte de la herencia con ellos al otro lado del Jordán, ya que tendremos nuestra herencia por el lado oriental.'"
,"20":"Moisés les dijo: 'Hagan lo que acaban de decir, ármense para combatir delante de Yavé,"
,"21":"y pasen armados el Jordán delante de Yavé, hasta que arroje a sus enemigos ante él."
,"22":"Cuando el país esté sometido a Yavé, volverán a su tierra, y ni Yavé ni Israel los podrán reprochar: esta tierra será de ustedes a los ojos de Yavé."
,"23":"Pero, si no lo hacen, sepan que será un pecado contra Yavé y este pecado los seguirá."
,"24":"Construyan, pues, ciudades para sus hijos y corrales para sus rebaños, pero cumplan sus promesas.'"
,"25":"Los hijos de Gad y los hijos de Rubén contestaron: 'Tus siervos harán como mi señor manda;"
,"26":"nuestros hijos, nuestras mujeres, nuestros rebaños y todo nuestro ganado se quedarán aquí, en las ciudades de Galaad,"
,"27":"pero tus siervos, todos los que llevan armas, pasarán delante de Yavé para ir a la guerra, como dice mi señor.'"
,"28":"Moisés entonces dio orden al sacerdote Eleazar, a Josué, hijo de Nun, y a los jefes de las casas paternas de las tribus de los hijos de Israel respecto a ellos."
,"29":"Moisés dijo: 'Si los hijos de Gad y de Rubén pasan con ustedes el Jordán y van armados delante de Yavé, cuando ustedes hayan conquistado el país les darán esta tierra de Galaad en propiedad."
,"30":"Pero si no pasan armados con ustedes, tendrán su herencia entre ustedes en el país de Canaán.'"
,"31":"Los hijos de Gad y de Rubén contestaron: 'Lo que Yavé ha dicho a tus siervos lo haremos."
,"32":"Pasaremos armados delante de Yavé al país de Canaán, pero nuestra parte de la herencia será a este lado del Jordán.'"
,"33":"Moisés dio a los hijos de Gad, a los de Rubén y a la media tribu de Manasés, hijo de José, el reino de Sijón, rey de los amorreos, y el reino de Og, rey de Basán. Les dio el país con las ciudades comprendidas en sus fronteras y las ciudades vecinas."
,"34":"Los hijos de Gad construyeron las plazas fuertes de Dibón,"
,"35":"Atarot y Aaroer, Atrot-Sofán, Yazer, Yogbohá,"
,"36":"Bet-Ninrá, Bet-Harán, y rediles para los rebaños."
,"37":"Los hijos de Rubén construyeron Jesbón, Elalé, Quiryatayim,"
,"38":"Nebo, Baal-Meón, que cambiaron de nombre, y Sibmá. Y pusieron nombres a las ciudades que construyeron."
,"39":"Los hijos de Makir, hijo de Manasés, fueron a Galaad, lo conquistaron y expulsaron a los amorreos que vivían allí."
,"40":"Moisés dio Galaad a Makir, hijo de Manasés, que se estableció allí."
,"41":"Yaír, hijo de Manasés, se apoderó de las aldeas de ellos y las llamó Aldeas de Yaír."
,"42":"Nobaj se apoderó de Quenat y de sus aldeas y les puso su propio nombre de Nobaj."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Estas son las etapas de los hijos de Israel, cuando salieron de Egipto por cuerpos de ejército a las órdenes de Moisés y Aarón."
,"2":"Moisés anotó por escrito los puntos de partida de cada etapa, como Yavé se les ordenaba. Estos fueron los puntos de partida:"
,"3":"Partieron de Ramsés el mes primero, el día quince del mes primero. Al día siguiente de la Pascua, los hijos de Israel salieron con mucha seguridad a la vista de todos los egipcios, mientras éstos enterraban a sus muertos."
,"4":"Pues Yavé había dado muerte a sus primogénitos, haciendo justicia de sus dioses."
,"5":"Los hijos de Israel partieron de Ramsés y acamparon en Sucot."
,"6":"Partieron de Sucot y acamparon en Etam, que está en el extremo del desierto."
,"7":"Partieron de Etam, pero volvieron hacia Pi-hajirot y pasaron por medio del mar hacia el desierto."
,"8":"Anduvieron tres días de camino por el desierto de Etam y acamparon en Mará."
,"9":"Partieron de Mará y llegaron a Elim, donde había doce fuentes de agua y setenta palmeras."
,"10":"Partieron de Elim y acamparon cerca del Mar de las Cañas."
,"11":"Partieron del Mar de las Cañas y acamparon en el desierto de Sin."
,"12":"Partieron del desierto de Sin y acamparon en Dofcá."
,"13":"Partieron de Dofcá y acamparon en Alús."
,"14":"Partieron de Alús y acamparon en Refidim, pero allí la gente no encontró agua para beber."
,"15":"Partieron de Refidim y acamparon en el desierto del Sinaí."
,"16":"Partieron del desierto del Sinaí y acamparon en Quibrot-hat-Taavá."
,"17":"Partieron de Quibrot-hat-Taavá y acamparon en Jaserot."
,"18":"Partieron de Jaserot y acamparon en Ritmá."
,"19":"Partieron de Ritmá y acamparon en Rimmón-Perés."
,"20":"Partieron de Rimmón-Perés y acamparon en Libná."
,"21":"Partieron de Libná y acamparon en Rissá."
,"22":"Partieron de Rissá y acamparon en Quehalatá."
,"23":"Partieron de Quehalatá y acamparon en el monte Séfer."
,"24":"Partieron del monte Séfer y acamparon en Jaradá."
,"25":"Partieron de Jaradá y acamparon en Macelot."
,"26":"Partieron de Macelot y acamparon en Tajat."
,"27":"De Tajat partieron al campo de Taraj."
,"28":"De Taraj fueron a parar a Meteá."
,"29":"De Meteá pasaron a Hesmona."
,"30":"De Hesmona acamparon en Moserot."
,"31":"Partieron de Moserot y acamparon en Benejaacán."
,"32":"De Benejaacán se fueron al monte de Gadgad,"
,"33":"de donde partieron y fueron a Jotbata."
,"34":"De Jotbata pasaron a Hebrona."
,"35":"Dejando Hebrona acamparon en Asiongaber."
,"36":"Marchando de Asiongaber fueron a parar al desierto de Zin, es decir, en Cadés,"
,"37":"y habiendo salido de Cadés acamparon en la falda de Hor del Monte en los últimos confines del país de Edom."
,"38":"Allí subió el sumo sacerdote Aarón al Monte Hor por mandato de Yavé; y allí murió a los cuarenta años de la salida de los hijos de Israel de Egipto, el mes quinto, el primero del mes."
,"39":"Aarón tenía ciento veintitrés años cuando murió en la montaña de Hor."
,"40":"El rey cananeo de Arad, que vivía en el Negueb, en el país de Canaán, se enteró de que llegaban los hijos de Israel.)"
,"41":"Partieron de Hor del Monte y acamparon en Salmoná."
,"42":"Partieron de Salmoná y acamparon en Punón."
,"43":"Partieron de Punón y acamparon en Abot."
,"44":"De Abot pasaron a las ruinas de Abarim, que están en los confines de los moabitas."
,"45":"Partieron de las ruinas de Abarim y acamparon en Dibón de Gad."
,"46":"De allí partieron a Helmon-deblataim, donde acamparon."
,"47":"Partiendo de Helmon-deblataim vinieron a los montes de Abarim, enfrente del Nebo."
,"48":"Dejaron los montes de Abarim, pasaron a las estepas de Moab, a orillas del Jordán, enfrente de Jericó."
,"49":"Allí fijaron sus tiendas desde Betjesimot hasta Abel-hasitim, en las estepas de los moabitas."
,"50":"Yavé habló a Moisés en las estepas de Moab, cerca del Jordán, a la altura de Jericó, y le dijo:"
,"51":"'Habla a los hijos de Israel y diles: Cuando hayan pasado el Jordán y entren en el país de Canaán,"
,"52":"eliminarán delante de ustedes a todos los habitantes del país. Destruirán sus estatuas de metal fundido, y arrasarán todos los santuarios altos."
,"53":"Entonces serán los dueños del país, pues yo se lo he dado todo en posesión."
,"54":"Lo repartirán entre las familias, echando suertes. A los más numerosos darán una parte mayor de la herencia, y a los menos numerosos, una parte menor. Donde le caiga a cada uno la suerte, allí será su propiedad. Harán el reparto por tribus paternas."
,"55":"Pero si no expulsan delante de ustedes a los habitantes del país, los que queden serán para ustedes como espinas en los ojos y aguijones en los costados. A ustedes los hostigarán en el país en que van a vivir,"
,"56":"y yo los trataré a ustedes en la forma en que pensaba tratarlos a ellos."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Yavé habló a Moisés y le dijo:"
,"2":"'Da esta orden a los hijos de Israel: Cuando entren en el país de Canaán, éste será el territorio que les caerá en herencia: el país de Canaán, entre las fronteras siguientes:"
,"3":"Ustedes tendrán por frontera meridional el desierto de Zin junto a Edom. La frontera partirá del Mar Salado al este,"
,"4":"torcerá por el sur hacia la Subida de los Escorpiones, pasará por Zin, pasando al sur de Cadés-Barné. Luego irá hacia Jasar-Adar pasando por Asemona."
,"5":"Torcerá de Asemona hacia el Torrente de Egipto y terminará en el Mar Grande (o Mediterráneo)."
,"6":"El Mar Grande será su frontera occidental."
,"7":"La frontera norte partirá de este mar, yendo en línea derecha hasta Hor del Monte."
,"8":"Desde Hor del Monte irá en línea derecha hacia la entrada de Hamat, pasando por Sedad,"
,"9":"seguirá después hasta Zeprona y se terminará en la aldea de Enan. Estos serán los límites al norte."
,"10":"La frontera oriente partirá de la aldea de Enan, yendo hasta Sefama;"
,"11":"desde Sefama bajará a Ribla, al este de Ain; bajará nuevamente hasta la ribera oriente del Mar de Kineret."
,"12":"Seguirá el Jordán llegando al Mar Salado. Estas son las fronteras entre las cuales se extenderá su tierra.'"
,"13":"Moisés dio entonces esta orden a los hijos de Israel: 'Este es el país que han de repartirse a suerte, el que Yavé mandó dar a las nueve tribus y media,"
,"14":"pues los clanes de las tribus de Rubén y de Gad, y la media tribu de Manasés, han recibido ya su herencia."
,"15":"Estas dos tribus y media ya la tienen al otro lado del Jordán, al oriente.'"
,"16":"Yavé dijo a Moisés: 'Estos son los que les han de repartir la tierra:"
,"17":"el sacerdote Eleazar y Josué, hijo de Nun."
,"18":"Ustedes escogerán también un responsable de cada tribu, para esa repartición del país;"
,"19":"éstos serán: por la tribu de Judá, Caleb, hijo de Jefoné;"
,"20":"por la tribu de Simeón, Samuel, hijo de Ammiud;"
,"21":"por la tribu de Benjamín, Elidad, hijo de Caselón;"
,"22":"por la tribu de los hijos de Dan, el jefe Buqui, hijo de Jogal;"
,"23":"por los hijos de José, por la tribu de los hijos de Manasés, el jefe Hanniel, hijo de Efod;"
,"24":"y por la tribu de los hijos de Efraím, el jefe Camuel, hijode Seftán;"
,"25":"por la tribu de los hijos de Zabulón, Elisafán, hijo de Farnac;"
,"26":"por la tribu de los hijos de Isacar, el jefe Paltiel, hijo de Ozán;"
,"27":"por la tribu de los hijos de Aser, el jefe Ahiud, hijo de Salomi;"
,"28":"por la tribu de los hijos de Neftalí, el jefe Pedael, hijo de Ammiud.'"
,"29":"Estos son los que Yavé designó para que repartieran a los israelitas su herencia en el país de Canaán."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Habló Yavé a Moisés en las estepas de Moab, cerca del Jordán, a la altura de Jericó, y le dijo:"
,"2":"'Manda a los hijos de Israel que cedan a los levitas, algunas ciudades de la herencia que les pertenece, con lugares de pastoreo alrededor, para que puedan habitarlas."
,"3":"Los levitas vivirán en esas ciudades y sus pastos serán para todos sus animales y sus pertenencias."
,"4":"Los pastos se extenderán hasta quinientos metros alrededor de las ciudades que entreguen a los levitas, a contar desde las murallas."
,"5":"Estos pastos formarán un cuadrado de mil metros: mil metros al occidente, mil al sur, mil al oeste y mil metros al norte; la ciudad estará al centro. Estos serán los pastos propios de las ciudades de los levitas."
,"6":"Ustedes les darán cuarenta y dos ciudades además de las seis ciudades de asilo, en las que se podrá refugiar el que haya ocasionado la muerte de una persona."
,"7":"Las ciudades que darán a los levitas será cuarenta y ocho en total, todas ellas con sus lugares de pastoreo."
,"8":"Estas ciudades se tomarán de la herencia de los hijos de Israel, tomando más del que tiene más, y menos del que tiene menos; cada tribu dará ciudades a los levitas en proporción a la herencia que le haya tocado.'"
,"9":"Yavé dijo a Moisés:"
,"10":"'Di a los hijos deIsrael: Cuando pasen el Jordán hacia la tierra de Canaán,"
,"11":"elegirán ciudades de las que harán ciudades de refugio. En ellas se refugiará el que dio muerte a una persona sin intención."
,"12":"Esas ciudades le servirán de refugio contra el vengador de la sangre, para que no sea muerto antes de haber sido juzgado por la comunidad."
,"13":"Ustedes se reservarán seis ciudades de asilo:"
,"14":"tres al otro lado del Jordán y tres en el país de Canaán, que pasarán a ser ciudades de asilo"
,"15":"tanto para los hijos de Israel como para el forastero y para el que está en medio de ustedes, para que todo aquel que haya dado muerte involuntariamente a una persona se pueda refugiar en ellas."
,"16":"Si alguno ha herido a otro con un instrumento de hierro, y éste muere, es un asesino y debe morir."
,"17":"Si lo ha herido con un arma de piedra que tenía en la mano, y el otro muere, es un asesino y debe morir."
,"18":"Si lo hiere con un arma de madera, y el otro muere, es un asesino y debe morir."
,"19":"El mismo vengador de la sangre dará muerte al asesino en cuanto lo encuentre."
,"20":"Si alguien ha herido a su víctima por odio, o le ha lanzado algo con maldad, causándole la muerte,"
,"21":"o si, por maldad, lo ha golpeado con las manos causándole la muerte, es un asesino y debe morir. El vengador de la sangre dará muerte al asesino en cuanto lo encuentre."
,"22":"Pero si lo hirió por inadvertencia y sin enemistad, o si le lanzó cualquier objeto sin mala intención,"
,"23":"o si le tiró sin verlo una piedra, sin tenerle enemistad ni querer dañarlo, y el otro muere,"
,"24":"la comunidad juzgará entre el homicida y el vengador de la sangre según estas normas."
,"25":"Salvará a este hombre de la mano del vengador de la sangre y lo hará volver a la ciudad de asilo en la que se refugió. Allí vivirá hasta la muerte del sumo sacerdote ungido con el óleo santo."
,"26":"Pero si el hombre ha salido de los límites de la ciudad de asilo en la que se ha refugiado,"
,"27":"y el vengador de la sangre lo encuentra fuera del límite de su ciudad de asilo, podrá matar al homicida, sin que le pidan cuenta por esa sangre."
,"28":"Porque aquél debía permanecer en su ciudad de asilo hasta la muerte del sumo sacerdote. El homicida no volverá a su propiedad antes de que haya muerto el sumo sacerdote."
,"29":"Estas serán normas de derecho para ustedes y para sus descendientes, dondequiera que vivan."
,"30":"En cualquier caso de homicidio, se dará muerte al asesino, según declaración de los testigos, pero un solo testigo no bastará para condenar a muerte a una persona."
,"31":"No aceptarán rescate por un asesino, pues debe morir."
,"32":"Tampoco aceptarán rescate del que se ha refugiado en una ciudad de asilo y quiere volver a vivir en su tierra antes de que muera el sumo sacerdote."
,"33":"Cuídense de no profanar la tierra en que están; sepan que la sangre es lo que profana la tierra, y la tierra no queda expiada de la sangre derramada más que con la sangre del que la derramó."
,"34":"No hagan impura la tierra en que viven, y en medio de la cual moraré, pues yo, Yavé, tengo mi morada entre los hijos de Israel.'"
}`)
	CurrentBook.AddChapter(36, `{
"1":"Los jefes de familia del clan de Galaad, hijo de Maquir, hijo de Manasés, uno de los clanes de José, se acercaron y dijeron a Moisés ante los jefes de las familias israelitas."
,"2":"'Yavé te mandó que dieras la tierra en herencia por suertes a los hijos de Israel y recibiste orden de Yavé de dar la herencia de Selofjad, nuestro hermano, a sus hijas."
,"3":"Resulta que, si se casan con alguno de otra tribu de Israel, su parte se restará de la herencia de nuestras familias y se añadirá a la herencia de la tribu a la que van a pertenecer. Esta herencia se quitará de lo que nos tocó en suerte y,"
,"4":"cuando llegue el año del jubileo para los hijos de Israel, la herencia de ellas se añadirá a la de la tribu a la que van a pertenecer y se restará de la herencia de la tribu de nuestros padres.'"
,"5":"Moisés, según la orden de Yavé, mandó lo siguiente a los hijos de Israel: 'Los hijos de la tribu de José tienen la razón."
,"6":"Esta es la respuesta de Yavé referente a las hijas de Selofjad: Tomarán por esposos a los que bien les parezcan, con tal de que éstos pertenezcan a un clan de la tribu de su padre."
,"7":"Con eso la herencia de los israelitas no pasará de una tribu a otra, sino que cada uno estará vinculado a la herencia de la tribu de sus padres."
,"8":"Toda hija que tenga una herencia en una de las tribus de Israel se casará con uno de la tribu de su padre. Con eso cada uno de los israelitas conservará la herencia de sus padres;"
,"9":"la herencia no pasará de una tribu a otra, sino que cada una de las tribus de Israel quedará ligada a su heredad.'"
,"10":"Las hijas de Selofjad, pues, hicieron tal como Yavé había mandado a Moisés;"
,"11":"Majlá, Tirsá, Joglá, Milcá y Noá tomaron como esposos gente de su parentesco."
,"12":"Se casaron con los hijos de sus tíos paternos, de la familia de Manasés, hijo de José, y la posesión que se les había adjudicado se conservó en la tribu de su padre."
,"13":"Estas son las leyes y los mandatos que Yavé dio, por medio de Moisés, a los hijos de Israel en las estepas de Moab, en las orillas del Jordán, enfrente de Jericó."
}`)

}
func ES_LBL_LoadVSCCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"El Canto sublime, que es de Salomón."
,"2":"¡Que me bese,con los besos de su boca!"
,"3":"Tus amores son un vino exquisito, suave es el olor de tus perfumes, y tu nombre, ¡un bálsamo derramado!; por eso, se enamoran de ti las jovencitas. ¡Llévame! Corramos tras de ti."
,"4":"Llévame, oh Rey, a tu habitacion,para que nos alegremos y regocijamos, y celebremos, no el vino, sino tus caricias. ¿Cómo podrían no quererte?"
,"5":"Soy morena, pero bonita, hijas de Jerusalén, como las carpas de Quedar, como las carpas de Salomón."
,"6":"No se fijen en que estoy morena, el sol fue el que me tostó. Los hijos de mi madre, enojados contra mí, me pusieron a cuidar las viñas. Mi viña yo la había descuidado."
,"7":"Dime, Amado de mi alma, ¿a dónde llevas a pastar tu rebaño, dónde lo llevas a descansar a mediodía, para que yo no ande como vagabunda,detrás de los rebaños de tus compañeros?"
,"8":"¡Oh la más bella de las mujeres!, si no estás consciente de quién eres, sigue las huellas de las ovejas, y lleva tus cabritas a pastar,junto a las tiendas de los pastores."
,"9":"Como yegua uncida al carro de Faraón, así eres a mis ojos, amada mía."
,"10":"Tus mejillas se ven lindas con esos aros,y tu cuello entre los collares."
,"11":"Te haremos aros de oro,con cuentas de plata."
,"12":"Mientras el Rey estaba en su aposento,se sentía el olor de mi perfume."
,"13":"Mi amado es para mí bolsita de mirra,cuando reposa entre mis pechos."
,"14":"Mi amado es para mí racimo de glicina,en las viñas de Engadí."
,"15":"¡Oh mi amor, ¡qué bella eres, qué bella eres con esos ojos de paloma!"
,"16":"Amado mío, ¡qué hermoso eres, qué delicioso!,Nuestro lecho es sólo verdor."
,"17":"Las vigas de nuestra casa son de cedro, y su techo de ciprés."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Yo soy el narciso de Sarón,y el lirio de los valles."
,"2":"Como lirio entre los cardos, así es mi amada entre las jóvenes."
,"3":"Como manzano entre los arbustos, así es mi amado entre los jóvenes. Estoy sentada a su sombra deseada,y su fruto me es dulce al paladar."
,"4":"Me llevó a una bodega de vino: su divisa de amor estaba encima de mí."
,"5":"Pásenme pasteles de pasas. Reanímenme con manzanas, porque estoy enferma de amor."
,"6":"Su izquierda se desliza bajo mi cabeza, y su derecha me abraza."
,"7":"Hijas de Jerusalén, yo les ruego,por las gacelas y las cabras del campo,que no despierten ni molesten al Amor,hasta cuando ella quiera."
,"8":"¡La voz de mi amado!,Miren cómo viene saltando por los montes,"
,"9":"brincando por los cerros, mi amado, como una gacela o un cabrito. Ahora se detiene detrás de nuestra cerca, y se pone a mirar por las ventanas, a espiar por las rejas."
,"10":"Mi amado empieza a hablar,y me dice: Levántate, compañera mía, hermosa mía, y ven por acá, paloma mía."
,"11":"Acaba de pasar el invierno, y las lluvias ya han cesado y se han ido."
,"12":"Han aparecido las flores en la tierra, ha llegado el tiempo de las canciones, se oye el arrullo de la tórtola,en nuestra tierra."
,"13":"Las higueras echan sus brotes,y las viñas nuevas exhalan su olor. Levántate, amada mía, hermosa mía, y ven."
,"14":"Paloma mía, que te escondes,en las grietas de las rocas, en apartados riscos, muéstrame tu rostro, déjame oír tu voz, porque tu voz es dulce,y amoroso tu semblante."
,"15":"¡Que cacen a los zorros, esos dañinos zorritos que destrozan las viñas, pues las nuestras se encuentran en flor!"
,"16":"Mi amado es para mí, y yo para mi amado; lleva a su rebaño a pastar entre los lirios."
,"17":"Antes que sople la brisa del día,y huyan las sombras, amado mío, vuelve, como la gacela o el cabrito, por los montes de las balsameras."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Sobre mi lecho, por las noches, yo buscaba al amado de mi alma. Lo busqué y no lo hallé."
,"2":"Me levantaré, pues, y recorreré la ciudad. Por las calles y las plazas,buscaré al amado de mi alma. Lo busqué y no lo hallé."
,"3":"Me encontraron los centinelas, esos que andan de ronda por la ciudad."
,"4":"¿Han visto a mi amado?,Apenas los había dejado,cuando encontré al amado de mi alma. Lo abracé y no lo soltaré más,hasta que no lo haya hecho entrar,en la casa de mi madre, en la pieza de la que me dio a luz."
,"5":"Hijas de Jerusalén, yo les ruego, por las gacelas y las cabras del campo, que no despierten,y no se despierte el Amor,hasta cuando ella quiera."
,"6":"¿Quién es este que sube del desierto?,Parece ser una columna de humo,perfumado de mirra y de incienso,y de todos los aromas."
,"7":"Es la litera de Salomón. Sesenta guerreros la rodean, los más valientes de Israel,"
,"8":"todos muy buenos para la espada, hombres adiestrados para el combate. Cada uno lleva su espada a la cintura,para que nadie los sorprenda de noche."
,"9":"El rey Salomón se ha hecho una litera,de madera del Líbano."
,"10":"Le hizo columnas de plata, el enchapado de oro, el asiento de púrpura; el interior de ébano incrustado."
,"11":"Salgan, hijas de Jerusalén. y vean al rey Salomón con su corona, con la corona que le colocó su madre,el día de sus bodas, el día de su alegría."
}`)
	CurrentBook.AddChapter(4, `{
"1":"¡Qué bella eres, amada mía, qué bella eres!,Tus ojos son como palomas,detrás de tu velo."
,"2":"Tus cabellos, como un rebaño de cabras,que ondulan por las pendientes de Galaad. Tus dientes, ovejas esquiladas,que acaban de bañarse, cada una tiene su melliza,y ninguna la ha perdido."
,"3":"Tus labios son una cinta roja, y tu hablar es encantador. Tus mejillas son las mitades de,una granada a través de tu velo."
,"4":"Tu cuello es como la torre de David, levantada para dominar; de ella cuelgan mil escudos, todos escudos de valientes."
,"5":"Tus dos pechos, cervatillos coquetones, mellizos de gacela."
,"6":"Antes de que sople la brisa del día, y se vayan las sombras, me iré al monte de la mirra, al cerro del incienso."
,"7":"Eres toda hermosa, amada mía, en ti no hay ningún defecto."
,"8":"Ven del Líbano, novia mía, ven hasta acá del Líbano, deja lo alto del Amaná, las cumbres del Samir y del Hermón, moradas de leones, guaridas de leopardos."
,"9":"Me robaste el corazón, hermana mía, novia mía, me robaste el corazón,con una sola mirada tuya, con una sola de las perlas de tu collar."
,"10":"¡Qué amorosas son tus caricias, hermana mía, novia mía!,¡Más delicioso es tu amor que el vino!,Y el olor de tus perfumes,supera a cualquier otro."
,"11":"Los labios de mi novia,destilan pura miel; debajo de tu lengua,se encuentra leche y miel, y la fragancia de tus vestidos,es la de los bosques del Líbano."
,"12":"Un jardín cercado es mi hermana, mi novia, huerto cerrado,y manantial bien guardado."
,"13":"Tu tierra regada da un jardín,de granadas,con abundancia de frutos exquisitos,y de hierbas aromáticas."
,"14":"nardo y azafrán, clavo de olor y canela, con todos los árboles de incienso, mirra y áloe,con los mejores perfumes."
,"15":"Fuente de los jardines, manantial de aguas vivas, corrientes que bajan del Líbano."
,"16":"Soplen, vientos del norte,y del desierto, soplen en mi huerto,para que se expandan sus aromas, y así entre mi amado en su huerto,y coma de sus exquisitos frutos."
}`)
	CurrentBook.AddChapter(5, `{
"1":"He entrado en mi huerto, hermana mía, novia mía, he tomado mi mirra con mi perfume, he comido mi miel en su panal, he bebido mi vino y mi leche. Amigos, coman, beban, compañeros, embriáguense."
,"2":"Yo dormía, pero mi corazón estaba despierto. Oí la voz de mi amado que me llamaba: 'Abreme, hermana mía, compañera mía, paloma mía, preciosa mía; que mi cabeza está cubierta de rocío, y mis cabellos, de la humedad de la noche.'"
,"3":"Me quité la túnica, ¿tendré que ponérmela otra vez?,Me lavé los pies, ¿tendré que ensuciármelos de nuevo?"
,"4":"Mi amado metió la mano por la cerradura; ¡cómo se me estremeció el corazón!"
,"5":"Me levanté para abrir a mi amado, y mis manos destilaron mirra, corrió mirra de mis dedos,sobre el pestillo de la cerradura."
,"6":"Abrí a mi amado, pero mi amado ya se había ido. ¡Se me fue el alma tras de él!,Lo busqué y no lo hallé, lo llamé y no me respondió."
,"7":"Me encontraron los centinelas,los que andan de ronda por la ciudad, me golpearon y me hirieron. Me quitaron mi chal, los guardias de las murallas."
,"8":"Hijas de Jerusalén, yo les ruego,por si encuentran a mi amado... ¿Qué le dirán?,Que estoy enferma de amor."
,"9":"Oh tú, la más bella de las mujeres, ¿qué distingue a tu amado de los otros?,¿Qué distingue a tu amado de los otros,para que así nos mandes?"
,"10":"Mi amado es vigorozo y buen mozo, dintinguido entre mil."
,"11":"Su cabeza brilla como el oro puro; sus cabellos, como hojas de palma, son negros como el cuervo."
,"12":"Sus ojos, como palomas,junto a una fuente de agua, que se bañan en leche, posadas junto a un estanque;"
,"13":"sus mejillas, plantaciones de balsameras, cultivo de plantas olorosas. Sus labios son lirios,que destilan mirra pura."
,"14":"Sus manos son aros de oro,adornados con piedras de Tarsis. Su vientre, marfil pulido, cubierto de zafiros."
,"15":"Sus piernas, columnas de mármol, asentadas en basas de oro puro. Su aspecto es como el Líbano, majestuoso como los cedros."
,"16":"Su hablar es lo más suave que hay,y toda su persona es un encanto. Hijas de Jerusalén, así es mi amado, así es mi amigo."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Coro: ¿Adónde se fue tu amado, oh la más bella de las mujeres?,¿Adónde se dirigió tu amado, para que lo busquemos contigo?"
,"2":"Mi amado bajó a su huerto, donde se cultivan flores olorosas, pastorea su rebaño en los jardines,y va a recoger lirios."
,"3":"Yo soy para mi amado y él es para mí: él pastorea entre los lirios."
,"4":"Eres hermosa, amada mía, como Tirsá, encantadora como Jerusalén, imponente como tropas ordenadas."
,"5":"Aparta de mí tus ojos, porque me cautivan. Tus cabellos son como rebaño de cabras,que ondulan por las pendientes de Galaad."
,"6":"Tus dientes son como rebaño de ovejas,que acaban de bañarse, cada una tiene su melliza,y ninguna y ninguna la ha perdido."
,"7":"Tus mejillas, son las mitades de una granada,detrás de tu velo."
,"8":"Las reinas son sesenta, ochenta las concubinas, y las jóvenes son innumerables,"
,"9":"pero una sola es mi paloma, mi toda perfecta. Ella es la hija única de su madre, la preferida de la que la engendró. Las jóvenes que la ven la felicitan, reinas y concubinas la alaban."
,"10":"¿Quién es esta que surge,como la aurora, bella como la luna, brillante como el sol, temible como un ejército?"
,"11":"Había bajado a los nogales,para ver las flores del valle, por ver si la viña estaba brotando,y florecían los granados."
,"12":"No sé cómo, de repente se me oocurrió: encabecé los carros de guerra,de mi pueblo."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Coro: Vuelve, Sulamita, vuelve; vuelve, vuelve para contemplarte. ¿Por qué miran a la Sulamita, cuando entra con los coros en la danza?"
,"2":"Hija de príncipes, qué graciosos son tus pasos,con esas sandalias. La curva de tus caderas es un collar,hecho por manos de artistas."
,"3":"Tu ombligo es un cántaro,donde no falta el vino con especias. Tu vientre es como una pila de trigo,"
,"4":"tus dos pechos cervatillos coquetones,mellizos de gacela. Tu cuello, como torre de marfil."
,"5":"Tus ojos, las piscinas de Jesbón, junto a la puerta de Bat-Rabím. Tu nariz es la cumbre del Líbano, centinela que mira hacia Damasco."
,"6":"Tu cabeza se yergue: es el Carmelo, tu cabellera tiene reflejos de púrpura; un rey se halla preso en sus trenzas."
,"7":"¡Qué bella eres, qué encantadora, oh amor, en tus delicias!"
,"8":"Tu talle se parece a la palmera; tus pechos, a los racimos."
,"9":"Me dije: subiré a la palmera, míos son esos racimos de dátiles. ¡Sean tus pechos como racimos de uvas,y tu aliento como perfume de manzanas!"
,"10":"¡Tus palabras sean,como vino generoso!,Vaya derecho hacia el amado,fluyendo de mis labios."
,"11":"Yo soy para mi amado,y su deseo tiende hacia mí."
,"12":"Amado mío, ven, salgamos al campo, pasaremos la noche en los pueblos,"
,"13":"de mañana iremos a las viñas; veremos si las parras han brotado, si se abren las flores,y florecen los granados. Allí te entregaré todo mi amor."
,"14":"Las mandrágoras exhalan,su fragancia. Mira a nuestras puertas,esos frutos exquisitos, nuevos y añejos, que guardaba para ti, amado mío."
}`)
	CurrentBook.AddChapter(8, `{
"1":"¡Ah, si tú fueras hermano mío, alimentado con el pecho de mi madre!,Te podría besar al encontrarte afuera,sin que me despreciaran."
,"2":"Te llevaría a la casa de mi madre, a la habitación de la que me concibió. Te daría a beber vino fragante,y un licor hecho de granada."
,"3":"Su izquierda se desliza bajo mi cabeza,y su derecha me abraza."
,"4":"Hijas de Jerusalén, les ruego,que no despierten,ni se despierte el Amor,hasta que ella quiera."
,"5":"¿Quién es esa que sube del desierto,apoyada en su amado?,Debajo del manzano te desperté, allí mismo donde te concibió tu madre, donde te concibió la que te dio a luz."
,"6":"Guárdame en tu corazón,como tu sello o tu joya, siempre fija a tu muñeca. porque es fuerte el amor como la muerte, y la pasión, tenaz como el infierno; sus flechas son dardos de fuego, como llama de Yavé."
,"7":"¿Quién apagará el amor?,No lo podrán las aguas embravecidas, vengan los torrentes, ¡no lo ahogarán!,Si alguien quisiera comprar el amor,con todo lo que posee en su casa, sólo conseguiría desprecio."
,"8":"Tenemos una hermana pequeña, todavía no tiene sus senos formados. ¿Qué haremos con nuestra hermana,cuando se trate de casarla?"
,"9":"Si es una muralla, le construiremos defensas de plata; si es una puerta, la reforzaremos con barras de cedro."
,"10":"Yo soy una muralla, mis pechos son como torres. Soy a sus ojos como quien ha hallado la paz."
,"11":"Salomón tenía una viña en Baal-Amón, la confió a unos cuidadores, y cada uno le traía mil siclos de plata por sus frutos."
,"12":"Mi viña es sólo para mí y yo no más la cuido. Mil siclos para ti, Salomón, doscientos para los guardianes."
,"13":"¡Oh tú que habitas en los huertos!, tus compañeros prestan oído a tu voz, haz que yo también la pueda oír."
,"14":"Huye, amado mío, como gacela o como un cabrito,por los montes de las balsameras."
}`)

}
func ES_LBL_LoadVSEEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palabras de Qohelet, hijo de David, rey de Jerusalén."
,"2":"¡Esto no tiene sentido!, decía Qohelet, ¡esto no tiene sentido, nada a qué aferrarse!"
,"3":"¿Qué le queda al hombre de todas sus fatigas,cuando trabaja tanto bajo el sol?"
,"4":"Una generación se va y viene la otra; pero la tierra permanece siempre."
,"5":"El sol sale, el sol se pone, y no piensa más que en salir de nuevo."
,"6":"Va el viento hacia el sur, y luego gira al norte, y girando y girando, vuelve sobre sus giros."
,"7":"Todos los ríos van al mar,y el mar jamás se llena; por los mismos cauces que veían sus caudales,ha pasado de nuevo su curso."
,"8":"Hay mucho que decir, uno se cansaría de tanto hablar; El ojo no terminará de ver, el oído nunca terminará de oír,"
,"9":"pero lo que pasará es lo que ya pasó, y todo lo que se hará ha sido ya hecho. ¡No hay nada nuevo bajo el sol!"
,"10":"Si algo sucede y te dicen: '¡Mira, esto es nuevo!',no es así; las cosas que observan nuestros ojos,ya pasaron en los siglos anteriores."
,"11":"Nadie se acuerda de las cosas de antaño: será lo mismo con los asuntos actuales, y de todo lo que pueda ocurrir en el futuro,un día nadie más se acordará."
,"12":"Yo, Qohelet, he sido rey de Israel en Jerusalén,"
,"13":"y me dediqué a investigar y comprender todo lo que se hace bajo el sol. Pero es una tarea ingrata que Dios ha dado a los hombres: todo es para humillarlos."
,"14":"Miré de cerca todo lo que se hace bajo el sol: ¡no se tiene nada, se corre tras el viento!"
,"15":"No puede enderezarse lo que está torcido, no puede corregirse lo que falta."
,"16":"Debí convencerme: 'Estoy más adelantado en sabiduría que todos los que reinaron antes que mí en Jerusalén. Acumulé los conocimientos y el saber."
,"17":"Me dediqué a ver dónde están la sabiduría y la ciencia, la estupidez y la locura. Pero ahora veo que aun eso es correr tras el viento."
,"18":"Cuanto mayor la sabiduría, mayores son los problemas; mientras más se sabe, más se sufre.'"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Me dije: '¡Vamos, encontremos la alegría, y que yo pruebe la felicidad!' Pero eso también no es más que un viento."
,"2":"Acabé diciendo: '¿La risa? Una estupidez. ¿La alegría? ¿Para qué?'"
,"3":"Pues en mi búsqueda de la sabiduría me había entregado a los placeres del vino. Quería vivir la experiencia de la locura, para saber al fin lo que conviene a los hombres que hagan bajo el cielo, durante los contados días de su vida."
,"4":"Emprendí grandes obras. Me edifiqué casas, me planté viñas,"
,"5":"me arreglé jardines y huertos: planté allí todos los árboles frutales."
,"6":"Me hice cavar cisternas para regar mis plantaciones."
,"7":"Compré esclavos, hombres y mujeres, y otros me nacieron en mi casa. Tuve rebaños de ganado mayor y de ganado menor, mucho más que cualquiera antes de mí en Jerusalén."
,"8":"Amontoné el oro y la plata, todas las riquezas que me venían de los reyes y de las provincias. Tuve cantantes y coristas, y lo que más deleita al hombre: mujeres, muchas mujeres."
,"9":"Llegué a ser grande, superé a todos los que me habían precedido en Jerusalén, y mi sabiduría no me abandonaba."
,"10":"Todo lo que mis ojos deseaban, me lo concedí; no hubo placer del cual me haya privado, pues encontraba mi alegría en todo lo que hacía. Así, al menos recogía el fruto de mi trabajo."
,"11":"Luego, reflexioné en todas las obras que había emprendido y en todas las molestias que me había costado su realización. Pues bien, no se retiene nada, se corre tras el viento; ¡no hay nada que ganar bajo el sol!"
,"12":"Pues me planteé la pregunta de la sabiduría, de la estupidez y de la locura: ¿Cómo será el que me sucederá en el trono? (Se sabe lo que éste hizo.)"
,"13":"Vi que la sabiduría aventaja a la locura, tanto como la luz a la oscuridad:"
,"14":"'El sabio tiene los ojos abiertos, mientras que el tonto camina en la oscuridad.' Pero también sé: 'Para todos no hay más que una misma suerte.'"
,"15":"Me dije: 'Si la suerte del insensato es también la mía, ¿qué he ganado con mi sabiduría?' Y también en esto he visto que uno se afana por nada."
,"16":"Pues a la larga no se acuerdan más del sabio que del tonto, y si todo recuerdo ha de perderse en el futuro, ¿cómo hablar de sabiduría y de locura?"
,"17":"Y encontré la vida detestable: para mí todo lo que se hace bajo el sol es un mal negocio; todo se nos escapa, se corre tras el viento."
,"18":"Me puse a detestar todas las molestias que me había dado bajo el sol, puesto que debo dejarlo todo al que vendrá después de mí."
,"19":"¿Quién sabe si será sabio o insensato? Pero él será quien recogerá el fruto de mis trabajos bajo el sol, en los que empeñé a la vez mi sabiduría y mis preocupaciones: ¡así es como todo se nos escapa!"
,"20":"Comencé pues a arrepentirme de todo aquello por lo que me había afanado bajo el sol:"
,"21":"después de haber trabajado con inteligencia, sabiduría y habilidad, uno tiene que dejárselo todo a otro que nada ha hecho."
,"22":"¡Muy pésimo negocio es ése: todo se nos escapa! ¿Cómo gozará el hombre de todo aquello por lo cual ha trabajado bajo el sol, en medio de tantas fatigas y preocupaciones?"
,"23":"Pues todos sus días han sido penosos, a tal punto que perdía el sueño y aún de noche su corazón no descansaba. Eso es algo que no tiene sentido."
,"24":"Lo único que el hombre puede esperar es comer, beber y pasarlo bien. Pero he visto que también en eso está la mano de Dios."
,"25":"Pues ¿quién puede comer o beber si no es gracias a él?"
,"26":"Dios da a quien quiere la sabiduría, la ciencia y la alegría; el pecador tendrá la carga de amontonar y de enriquecerse para que todo pase a manos del que agrada a Dios. También allí habrá decepción: se habrá corrido tras el viento."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Hay bajo el sol un momento para todo, y un tiempo para hacer cada cosa:"
,"2":"Tiempo para nacer, y tiempo para morir; tiempo para plantar, y tiempo para arrancar lo plantado;"
,"3":"tiempo para matar y tiempo para curar; tiempo para demoler y tiempo para edificar;"
,"4":"tiempo para llorar y tiempo para reír; tiempo para gemir y tiempo para bailar;"
,"5":"tiempo para lanzar piedras y tiempo para recogerlas; tiempo para los abrazos y tiempo para abstenerse de ellos;"
,"6":"tiempo para buscar y tiempo para perder; tiempo para conservar y tiempo para tirar fuera;"
,"7":"tiempo para rasgar y tiempo para coser; tiempo para callarse y tiempo para hablar;"
,"8":"tiempo para amar y tiempo para odiar; tiempo para la guerra y tiempo para la paz."
,"9":"Al final ¿qué provecho saca uno de sus afanes?"
,"10":"Me puse a considerar la tarea que Dios impone a los hombres para humillarlos."
,"11":"Todo lo que él hace llega a su tiempo; pero ha puesto la eternidad en sus corazones, y el hombre no encuentra el sentido de la obra divina desde el principio al fin."
,"12":"Vi entonces que su verdadero bien es la alegría y hacer el bien durante su vida."
,"13":"Si uno puede comer y beber, si encuentra la felicidad en su trabajo, eso es un don de Dios."
,"14":"Vi que todo lo que hace Dios perdura para siempre; no hay nada que añadirle, nada que quitarle. Y Dios actúa de manera tal que se le respete."
,"15":"Lo que es ya existió; lo que será ya fue; Dios va a rebuscar en lo que ya pasó."
,"16":"Vi otras cosas bajo el sol: en vez de derecho se encuentra la injusticia; en la sede de la justicia se sienta el malvado."
,"17":"Y me dije a mí mismo: 'Dios juzgará al justo y al malo, pues hay tiempo para todo, y nada escapa a su juicio.'"
,"18":"Me dije a mí mismo, pensando en lo que es el hombre: Dios los pone a prueba, les demuestra que no son más que animales."
,"19":"Pues hombre y bestia tienen la misma suerte; la muerte es tanto para uno como para el otro. El aliento es el mismo y el hombre no tiene nada más que el animal. Esa es otra cosa que no tiene sentido,"
,"20":"que todo vaya al mismo lugar. Todo viene del polvo y todo vuelve al polvo. "
,"21":"¿Quién dirá si el aliento del hombre parte a las alturas, y el del animal baja a la tierra?"
,"22":"Y vi que lo único que el hombre puede esperar es gozar del fruto de sus obras; porque ésa es su condición. Pero, ¿quién le dará a conocer lo que pasará después?"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Pensé además en todos los abusos que se cometen bajo el sol. Vi las lágrimas de los oprimidos, y no hay nadie que los consuele; sufren la violencia de sus opresores, y no hay nadie que venga en su ayuda."
,"2":"Por eso, felicitaré al muerto porque es muerto más bien que al vivo porque todavía vive."
,"3":"Y más feliz que uno y otro es el que todavía no existe, pues no ha visto todo el mal que se comete bajo el sol."
,"4":"Si miro todo el trabajo que los hombres se dan, toda la carrera tras el éxito, eso no es más que envidia del uno para el otro. ¡Todo eso es insensato, se corre tras el viento!"
,"5":"El tonto que se cruza de brazos, devora su propia carne."
,"6":"Pero gozar del descanso cuando una mano está llena vale más que el tormento de llenar la otra mano."
,"7":"Pues vi bajo el sol otra cosa absurda: Un hombre solo, que no tiene a nadie, ni hijos ni hermanos, y"
,"8":"que no deja de extenuarse trabajando, nunca se siente lo bastante rico. Pero ¿para quién trabaja, para quién son esas privaciones? Ese es un mal negocio y que no tiene sentido."
,"9":"Más vale estar de a dos que solo: el trabajo rendirá más."
,"10":"Si uno cae, su compañero lo levantará. Pero, ay del que está solo si cae: nadie lo levantará."
,"11":"De igual modo, si se acuestan juntos se calentarán; pero nadie calentará al que está solo."
,"12":"Si uno está solo, lo pueden atacar; pero acompañado, podrá resistir, y si el hilo es triple, no se cortará fácilmente."
,"13":"Más vale un muchacho pobre y con buen criterio que un rey viejo y tonto, que no sabe pedir consejos."
,"14":"Y esto, aunque haya pasado de la prisión al poder, o aunque haya nacido como el último de todos en el reino."
,"15":"Vi que todos los que viven bajo el sol se ponían de lado del nuevo, del joven que asumía la sucesión."
,"16":"Interminable era la multitud de los que venían a rendirle homenaje. Un día, sin embargo, no estarán más contentos con él. Esas son pues cosas que no duran: se corre tras el viento."
,"17":"Mira dónde pisas cuando vayas a la Casa de Dios. Presenta la ofrenda como un hombre prevenido, no como los tontos que ofrecen el sacrificio y no ven que hacen el mal."
}`)
	CurrentBook.AddChapter(5, `{
"1":"No hables demasiado rápido, no te precipites en tu decisión cuando te comprometas delante de Dios, porque Dios está en el Cielo y tú, en la tierra: no te comprometas demasiado."
,"2":"Si estás muy preocupado, te pones a soñar; si prometes demasiado, dirás lo que no conviene."
,"3":"Si has hecho una promesa a Dios, no tardes en cumplirla, pues Dios no ama a los tontos: Si lo has prometido, hazlo."
,"4":"Más vale no prometerle algo que prometer sin cumplirlo:"
,"5":"no sea que por eso sufras un percance y deberás confesar ante su Angel: '¡No lo había pensado!' ¿Necesitas de una promesa que va a irritar a Dios y acarrearte sinsabores?"
,"6":"Los soñadores se comprometen a cada momento sin pensar. Pero tú, teme a Dios."
,"7":"Si ves en una provincia al pobre oprimido, el derecho y la justicia violados, no te sorprendas: por encima de una autoridad hay un escalón superior, y por encima de éste, otros más elevados."
,"8":"El país avanzará si el rey se pone al servicio de los campos."
,"9":"El que ama el dinero nunca tiene lo suficiente: ¿por qué, entonces, perseguir una satisfacción que nunca llegará? Esto no tiene sentido."
,"10":"Si se acrecienta la riqueza, se multiplican también los que se la comen: ¿y qué saca su dueño con tenerla? Sólo el gusto de verla."
,"11":"El sueño del trabajador será tranquilo, haya comido poco o mucho; pero la saciedad del rico no le permite dormir."
,"12":"Hay otra mala suerte que vi bajo el sol: la riqueza que uno guardó para su propia desgracia."
,"13":"Perdió esa riqueza en un mal negocio, tiene un hijo y no tiene qué dejarle."
,"14":"Desnudo sale el hombre del vientre de su madre, y desnudo volverá tal como vino. Nada podrá llevarse de todas las obras que realizaron sus manos."
,"15":"También esto es una mala suerte: irse en el mismo estado en que uno llegó. ¿Qué más ha hecho sino trabajar para el viento?"
,"16":"¡Cuántos días en que comió pan negro; cuántas decepciones, fatigas y disgustos!"
,"17":"Esto es lo que veo: todo lo que uno puede esperar es comer y beber, y gozar el bienestar mientras trabaja bajo el sol durante los contados días de su vida, tales como Dios se los concedió: ésa es su parte."
,"18":"Cuando un hombre ha recibido de Dios posesiones y riquezas; cuando puede comer, gozar y disfrutar de su trabajo, todo eso es un don de Dios."
,"19":"A lo menos no piensa en lo corto de la vida mientras Dios le llena el corazón de alegría."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Hay otro mal que he visto bajo el sol y que aplasta al hombre."
,"2":"Alguien recibió de Dios fortuna, riqueza y honores: nada faltó de todo lo que pudo desear. Pero Dios no le concede disfrutar de ello, y es otro el que lo aprovecha. Esta es otra cosa muy mala y que no se puede justificar."
,"3":"Supongamos que un hombre tuviera un centenar de hijos y viviera largos años, pero durante todo ese tiempo no encontrara la felicidad y no tuviera después sepultura -en ese caso digo que un recién nacido fallecido es más feliz que él-."
,"4":"Ese niño vino para nada, sólo para regresar a la negrura, y hasta su mismo nombre permanecerá en la oscuridad."
,"5":"No vio ni conoció el sol, pero descansó; en cambio el otro, no."
,"6":"Ese hombre pudo haber vivido dos mil años, pero ¿de qué le serviría si no conoció la felicidad? Bien se puede decir que todo va al mismo lugar."
,"7":"Todo el trabajo del hombre es por su boca, pero esto no basta para llenar su alma."
,"8":"¿En qué aventaja el sabio al tonto? ¿En qué sale ganando el pobre cuando sabe comportarse en la vida?"
,"9":"Más vale creer en lo que se ve que dejarse llevar por sus deseos: pues allí también no se retiene nada y se corre tras el viento."
,"10":"Todo lo que existe ya ha recibido su nombre, y se sabe lo que es un hombre: no puede discutir con Alguien más poderoso que él."
,"11":"¿Muchas palabras? Habrá mucho de vacío: ¿qué se habrá ganado?"
,"12":"¿Quién sabe cómo debería vivir el hombre durante sus días contados y frágiles que pasan como sombra? ¿Quién le revelará al hombre lo que pasará bajo el sol después de él?"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Una buena reputación vale más que un buen perfume: el día de la muerte pasa pues antes que el del nacimiento."
,"2":"Anda a la casa que está de duelo más que a la que está de fiesta: verás el fin de todo hombre, y al que vive le da para pensar."
,"3":"Más vale el pesar que la risa: la tristeza en el rostro promete un mejor corazón."
,"4":"La casa en duelo da para pensar a los sabios, los tontos no piensan más que en la casa alegre."
,"5":"Más vale escuchar la reprensión de un sabio que la canción de los tontos;"
,"6":"la risa del tonto es como el crepitar de zarzas que arden bajo la marmita. Esta es una cosa desconcertante:"
,"7":"la corrupción pervierte incluso al sabio; los regalos ahogan la conciencia."
,"8":"Terminar una obra vale más que comenzarla: lo que cuenta es la perseverancia, y no la pretensión."
,"9":"No dejes que tu espíritu ceda a la cólera: la cólera se siente a gusto en el tonto."
,"10":"No digas: '¿Cómo serían los tiempos antiguos? Ciertamente mejores que los de ahora.' Pues no es la sabiduría la que te hace formular esa pregunta."
,"11":"La sabiduría es útil para el que tiene tierras: ¡cuánto más para los que ven el sol!"
,"12":"La sabiduría es una protección como lo es el dinero; pero la ventaja del saber es que la sabiduría da la vida a los que la poseen."
,"13":"Contempla la obra de Dios: ¿quién podrá enderezar lo que él ha curvado?"
,"14":"En los días felices disfruta de la felicidad, y en el día de la desgracia, abre los ojos: Dios los ha dispuesto a ambos de tal manera que nadie pueda saber cuál será su fin."
,"15":"He visto de todo en esta vida tan decepcionante: hay justos que perecen a pesar de su justicia, y malos que prolongan sus días, a pesar de su maldad."
,"16":"No seas justo en exceso, ni te hagas el sabio más de lo necesario: podrías demolerte."
,"17":"No seas malvado en demasía ni te comportes como un insensato: podrías morir antes de tiempo."
,"18":"Es bueno tomar un partido sin descartar la posibilidad del otro: el que teme a Dios sacará provecho del uno y de lo otro."
,"19":"La sabiduría hace al sabio más poderoso que los diez jefes de su ciudad."
,"20":"No hay en la tierra ningún hombre lo bastante justo como para hacer el bien sin nunca pecar."
,"21":"No hagas pues caso a todo lo que se cuenta: así no oirás a tu servidor hablar mal de ti."
,"22":"Tú mismo lo sabes muy bien, has hablado con frecuencia mal de los otros."
,"23":"Todo eso lo he experimentado: es cuestión de sabiduría. Me había dicho: 'Quiero ser sabio.' ¡Pero estaba tan lejos de mí!"
,"24":"Está más allá de todo lo que existe."
,"25":"Cuando me dediqué a saber, a profundizar, a buscar la sabiduría y el por qué de las cosas, reconocí que la maldad es una tontería y una locura."
,"26":"Saqué esta conclusión: que la mujer es más amarga que la muerte; ella es para el hombre una trampa, su corazón es una red y sus brazos, cadenas. El que agrada a Dios se escapa de ella, pero el pecador se deja atrapar."
,"27":"Esto es lo que he encontrado -decía Qohelet- al reflexionar sobre todas las cosas, una tras otra, para comprender."
,"28":"Sin embargo, busco todavía: un hombre entre mil y lo encontré; pero una mujer entre todas, y no la he hallado."
,"29":"Y esto es lo que vi: Dios hizo sencillo al ser humano, pero ellos se han buscado mil problemas."
}`)
	CurrentBook.AddChapter(8, `{
"1":"¿Quién es sabio, quién es capaz de explicar las cosas? La sabiduría en un hombre ilumina su rostro y transforma lo que tenía de duro."
,"2":"Obedece la orden del rey, ya que le juraste fidelidad ante Dios."
,"3":"Si quieres alejarte de él, piénsalo dos veces, no te metas en un mal negocio: lo que el rey quiere, lo hará."
,"4":"El rey hablará, ¡y punto! Nadie le dirá: '¿Qué haces?'"
,"5":"El que guarda los mandamientos no se meterá en situaciones difíciles. El sabio sabe cuál es la hora y cuáles son los criterios."
,"6":"Pues hay para cosa un tiempo y un criterio."
,"7":"Pero el hombre tiene una falla muy grande: nadie sabe lo que le sobrevendrá: ¿quién le dirá lo que sucederá?"
,"8":"Ningún hombre es dueño del soplo de vida, nadie puede disponer del día de su muerte. Es un combate sin piedad y no hay maldad que nos pueda salvar."
,"9":"Todo eso lo vi mientras reflexionaba sobre todo lo que pasa bajo el sol, durante el tiempo en que los hombres tienen poder para hacerse el mal unos a otros."
,"10":"Así fue como vi que a los hombres malos se los acompañaba a su entierro desde el lugar santo, y que en la ciudad se olvidaban de todo el mal que habían hecho. Esta es otra cosa desconcertante: "
,"11":"como las acciones malas no son inmediatamente juzgadas y castigadas, los hombres encuentran en eso un incentivo para hacer el mal."
,"12":"Pues por más que el pecador haga cien veces lo que es malo, se le deja todo su tiempo. (Sé, sin embargo, que la felicidad es para los que temen a Dios y que lo respetan."
,"13":"La felicidad no es para el malo; no prolongará sus días, sino que pasará como una sombra porque no tiene el temor de Dios.)"
,"14":"Esto es desconcertante en esta tierra: hay justos a los que les pasa todo lo que les tocaría a los malos por todo lo que han hecho, y hay malos a los que les pasa lo que les correspondería a los justos: esto tampoco tiene sentido."
,"15":"¡Viva la alegría!, pues la única felicidad para el hombre bajo el sol es comer y beber y regocijarse: esto le toca por su trabajo a lo largo de los contados días que Dios le concedió vivir bajo el sol."
,"16":"Como me dedicara a conocer y observase la condición del hombre en la tierra, vi que el ojo humano no tiene descanso de día ni de noche."
,"17":"Observé la obra de Dios en su conjunto: el hombre no puede encontrarle un sentido a la obra que se hace bajo el sol. Por más que el hombre se fatigue y busque, nada encuentra; e incluso cuando el sabio pretende saber, no ha encontrado nada."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Reflexioné pues en todo eso y vi claramente que los justos, los sabios y sus obras están en las manos de Dios. ¿Lo quiere El o no? Los hombres no lo saben: les puede pasar cualquier cosa."
,"2":"Y no tiene sentido el que todos tengan la misma suerte: el justo y el malo, el hombre puro y el que no lo es, el que ofrece sacrificios y el que no los ofrece, el que se compromete con un voto y el que teme hacerlo."
,"3":"Ahí está lo malo en todo lo que se hace bajo el sol: que todos corren la misma suerte; es por eso que los hijos de Adán están llenos de ideas malvadas, y sus pensamientos se descarrilan a lo largo de toda su vida esperando acabar entre los muertos."
,"4":"Pues mientras uno se cuenta entre los vivos, se siente seguro: 'Perro vivo vale más que león muerto.'"
,"5":"Los vivos saben que morirán; los muertos, nada saben. No tienen nada que esperar: son sólo un recuerdo olvidado."
,"6":"Pudieron amar, odiar, tener ambiciones: todo se perdió y nunca más tomarán parte en todo lo que se hace bajo el sol."
,"7":"Anda, pues, come tu pan alegremente y bebe gustoso tu vino, porque Dios ha bendecido tus trabajos."
,"8":"Lleva siempre ropas blancas y que nunca falte el óleo para perfumar tu cabeza."
,"9":"Goza de la vida con la mujer que amas, todos los días de tu vida fugaz, pues ésa es tu parte durante todo el tiempo que te afanas bajo el sol."
,"10":"Haz todo lo que esté a tu alcance y que te sientas capaz de hacer; porque en la morada de los muertos a donde tú vas, no hay ni trabajos ni problemas, ni conocimiento ni sabiduría."
,"11":"Aún he visto esto bajo el sol, que la carrera no la ganan los más rápidos, ni la lucha los que tienen más fuerzas; no hay más pan para los sabios, ni más riquezas para los inteligentes, ni más favores para los entendidos. Pues para todos se da la ocasión y la mala suerte."
,"12":"Nadie sabe cuándo vendrá su hora: a los hijos de Adán los sorprende la desgracia como al pez que queda preso en la red o como el pájaro sobre el cual cae la trampa."
,"13":"Hablemos de sabiduría: esto vi bajo el sol y que no me pareció poca cosa."
,"14":"Había una pequeña ciudad, con pocos habitantes. Se presentó un rey y le puso sitio con parepetos y trincheras."
,"15":"En la ciudad, sin embargo, había un hombre muy vivo, un hombre muy ordinario, y gracias a su astucia la ciudad se salvó. Pero como era un hombre muy ordinario, nadie pensó más en él."
,"16":"Entonces dije: la sabiduría supera a las hazañas, pero cuando se trata de los pobres, se desprecia su sabiduría: pueden hablar, pero no los escuchan."
,"17":"Las palabras de los sabios, dichas con calma, producen efecto; no así los gritos de uno que es bueno para mandar a locos."
,"18":"La sabiduría tiene más poder que las armas: pero bastan los errores de una sola persona para destruir mucho bien."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Una mosca muerta echa a perder todo el frasco de perfume; algunas locuras reducen a nada mucha sabiduría."
,"2":"El corazón del sabio mantiene su derecha, el corazón del tonto toma la izquierda;"
,"3":"sigue su camino en contra, y a todos los que se cruzan con él les dice: '¡Ahí va otro tonto!'"
,"4":"Si el príncipe monta en cólera contra ti, no dejes tu puesto, la calma evitará muchas desgracias."
,"5":"Vi otro mal bajo el sol, y uno podría pensar que el error viene del Soberano:"
,"6":"los incapaces están en lo alto de la escala, y los que valen se quedan abajo."
,"7":"Vi servidores que andaban a caballo y nobles que iban a pie, como los servidores."
,"8":"El que cava un hoyo, se puede caer en él; el que derriba un muro, puede ser que lo muerda la serpiente;"
,"9":"el que extrae piedras, puede lastimarse con ellas; el que parte leña corre el peligro de herirse;"
,"10":"si el hierro está embotado, hay que golpear más fuerte: en todo esto se gana con la sabiduría."
,"11":"Pero tal vez la serpiente no se deja encantar y muerde: en ese caso el encantador no habrá ganado nada."
,"12":"Las palabras del sabio son una gracia, en cambio las del tonto son perjudiciales, en primer lugar para él."
,"13":"Su punto de partida es un error, y la conclusión es tan peligrosa como absurda."
,"14":"La estupidez es la que le inspiró tantas palabras."
,"15":"El tonto se agota pronto: no sabe ni siquiera el camino a la ciudad."
,"16":"¡Pobre de ti, país, cuyo rey es un muchacho y cuyos jefes están de parranda desde la mañana!"
,"17":"Feliz tú, país, cuyo rey es un príncipe bien nacido, y cuyos jefes comen a sus horas, para tomar fuerzas y no para embriagarse."
,"18":"Por falta de mantención se hunde la techumbre, y si las manos son flojas, llueve la casa;"
,"19":"hacen banquetes para divertirse; se dan sus pasatiempos con el vino: ¡ el dinero lo resolverá todo!"
,"20":"No maldigas al rey ni siquiera de pensamiento; ni maldigas al poderoso, ni siquiera en el secreto de tu pieza: un pajarito del cielo podría llevarle el rumor, un par de alas le daría a conocer el asunto."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Lanza tu pan a la superficie del agua; después de un tiempo volverá a ti."
,"2":"Compártelo con los asociados, ocho más bien que siete, pues no sabes qué desgracia puede azotar al país."
,"3":"Cuando las nubes están llenas, descargan la lluvia sobre la tierra. Así como el árbol cae, ya sea al norte o al sur, así queda tumbado."
,"4":"Observar al viento, no es sembrar; considerar las nubes, no es cosechar."
,"5":"Tú no sabes por dónde llegó el espíritu al niño en el vientre de la mujer embarazada: otro tanto ignoras la obra de Dios tomada en su conjunto."
,"6":"Siembra de mañana tu grano y que en la tarde tu mano todavía esté activa: no sabes cuál de las dos cosas será más útil, si una u otra."
,"7":"Suave es la luz y es bueno ver el sol."
,"8":"Aun cargado de años, que el hombre sepa tomarles el gusto a todos ellos; pero que tome en cuenta los días del anochecer, pues por muchos que sean, nada es seguro para el porvenir."
,"9":"Muchacho, conoce la felicidad, mientras seas joven, y toma temprano las buenas decisiones. Elige tu camino como mejor te parezca, sin olvidar que Dios te pedirá cuenta de todo."
,"10":"No dejes que la amargura se instale en ti, ni la enfermedad en tu cuerpo: ¡juventud y cabellos negros son traicioneros!"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Acuérdate de tu Creador en los días de tu juventud, antes que lleguen los días malos, y los años que se acercan, de los cuales dirás: 'No espero más de ellos',"
,"2":"antes de que se oscurezcan el sol, la luz,la luna y las estrellas, y que vuelvan las nubes apenas haya llovido."
,"3":"Cuando tiemblen los guardias de la casa, y se encorven los porteros, cuando lo que queda de muelas deje de moler, y se queden ciegos los que miran detrás de las ventanas."
,"4":"Entonces se cierra la puerta de la calle,y se detiene el ruido del molino; en que el trino del ave no despierta,y se mueren las canciones."
,"5":"Se temen las subidas,y los barrancos en el camino; el almendro está en flor, la langosta está repleta, la alcaparra da su fruto. Ahí va el hombre a su casa de eternidad, y ya están las lloronas en la esquina de la calle."
,"6":"El hilo de plata no llegará más lejos: dejaron de hilarlo; la lámpara de oro se rompió, se quebró el cántaro en la fuente, y cedió la polea del pozo."
,"7":"El polvo vuelve a la tierra de donde vino, y el espíritu sube a Dios que lo dio."
,"8":"¡Esto no tiene sentido! decía Qohelet, ¡nada a qué aferrarse!"
,"9":"Qohelet era un sabio, que enseñó el saber al pueblo; sopesó, examinó y corrigió muchos proverbios."
,"10":"Qohelet procuró pulir sus sentencias y expresar verdades en un estilo muy directo."
,"11":"Las palabras de los sabios son como aguijones; una colección de sentencias es como una cerca cuyas estacas han sido ensambladas por un mismo pastor."
,"12":"No le añadas nada, hijo mío: ¿para qué más y más libros? Esto no tiene fin, y el demasiado estudio agota al cuerpo."
,"13":"Conclusión del discurso: todo ha sido dicho. Teme a Dios y observa sus mandamientos: allí está todo para el hombre."
,"14":"Pues Dios juzgará todas las acciones, aun lo que está oculto, tanto el bien como el mal."
}`)

}
func ES_LBL_LoadVSEIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Toda sabiduría viene del Señor y con él permanece para siempre."
,"2":"¿Quién podrá contar los granos de arena a orilla de los mares, las gotas de lluvia, los días ya transcurridos?"
,"3":"¿Quién puede medir la altura del cielo, la extensión de la tierra, las profundidades del océano?"
,"4":"La sabiduría fue creada antes de cualquier cosa, la inteligencia que todo lo dispone viene de más lejos que el principio del tiempo."
,"6":"¿A quién ha sido revelada la fuente de la sabiduría? ¿Quién ha conocido sus secretas intenciones?"
,"8":"Sólo hay un sabio, muy digno del más alto respeto: ¡El que se sienta en su trono!"
,"9":"El Señor fue quien creó la sabiduría; la vio, le tomó las medidas, la difundió en todas sus obras,"
,"10":"en todos los seres vivos, según su generosidad. La distribuyó con largueza a todos los que lo aman."
,"11":"El temor del Señor es nuestra gloria y de ello podemos estar orgullosos; es la alegría y la corona de los vencedores."
,"12":"El temor del Señor regocija el corazón, da buen humor, alegría y larga vida."
,"13":"Todo acabará bien para el que teme al Señor; será bendito en el día de su muerte."
,"14":"El temor del Señor es el comienzo de la sabiduría; puso la sabiduría en el corazón de sus fieles desde antes de su nacimiento."
,"15":"Ella estaba en su puesto desde antes del tiempo; anidó en medio de los hombres, permanecerá fiel a su descendencia."
,"16":"El temor del Señor es la plenitud de la sabiduría; te sacia con sus frutos,"
,"17":"repletando tu casa con cosas muy especiales, y tus graneros, con sus riquezas."
,"18":"El temor del Señor es la corona de la sabiduría; hace que florezcan la paz y la buena salud."
,"19":"El Señor la vio y la midió; dejó caer una lluvia de saber y de inteligencia; los que tienen la sabiduría no pueden disimularla."
,"20":"El temor del Señor es la raíz de la sabiduría; su ramaje se llama larga vida."
,"22":"La violencia injusta no tiene excusa alguna; se destruye por sus propios excesos."
,"23":"El hombre paciente soportará todo el tiempo que sea necesario, al final se le concederá la alegría;"
,"24":"se retendrá de hablar hasta el momento preciso, todos entonces reconocerán su valor."
,"25":"La sabiduría guarda entre sus tesoros máximas de rico contenido; pero el pecador no se preocupa de las cosas de Dios."
,"26":"¿Deseas la sabiduría? Cumple los mandamientos y el Señor te la concederá generosamente."
,"27":"Pues el temor del Señor es sabiduría y doctrina; lo que le agrada es la fidelidad y la dulzura."
,"28":"No te apartes del temor del Señor, acércate a él con un corazón íntegro."
,"29":"No seas hipócrita ante la gente, más bien vigila tus palabras."
,"30":"No cantes tus propias alabanzas; podrías caer y atraerte la deshonra. Si no tienes el temor del Señor y vives en la mentira, él revelará tus secretos y te echará por tierra en público."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Si te has decidido a servir al Señor, prepárate para la prueba."
,"2":"Conserva recto tu corazón y sé decidido, no te pongas nervioso cuando vengan las dificultades."
,"3":"Apégate al Señor, no te apartes de él; si actúas así, arribarás a buen puerto al final de tus días."
,"4":"Acepta todo lo que te pase y sé paciente cuando te halles botado en el suelo."
,"5":"Porque así como el oro se purifica en el fuego, así también los que agradan a Dios pasan por el crisol de la humillación."
,"6":"Confía en él y te cuidará; sigue el camino recto y espera en él."
,"7":"Ustedes que temen al Señor, esperen su misericordia, no se aparten de él, pues podrían caer."
,"8":"Ustedes que temen al Señor, confíen en él: no perderán su recompensa."
,"9":"Ustedes que temen al Señor, esperen recibir todo lo que vale la pena: esperen misericordia y alegría eternas."
,"10":"Recuerden lo que les pasó a sus antepasados: ¿quién confió en el Señor y se arrepintió de haberlo hecho? ¿Quién perseveró en su temor y fue abandonado? ¿Quién lo llamó y no fue escuchado?"
,"11":"Pues el Señor es ternura y misericordia; perdona nuestros pecados y nos salva en los momentos de angustia."
,"12":"¡Ay de los flojos que dejan caer sus brazos, ay del pecador que se niega a elegir!"
,"13":"¡Ay de los flojos que no tienen confianza!; por eso, no serán protegidos."
,"14":"Ay de ustedes que no han perseverado: ¿qué harán cuando el Señor les pida cuentas?"
,"15":"Los que temen al Señor no desobedecen sus mandamientos; los que son fieles en amarle siguen sus caminos."
,"16":"Los que temen al Señor tratan de agradarle; los que lo aman se alimentan de su Ley."
,"17":"Los que temen al Señor tienen su corazón preparado; se humillan ante él y dicen:"
,"18":"'¡Pongámonos en las manos del Señor más bien que en las de los hombres, pues su misericordia no es menos que su poder!'"
}`)
	CurrentBook.AddChapter(3, `{
"1":"¡Hijos, óiganme, les habla su padre! Sigan mis consejos y se salvarán."
,"2":"Porque el Señor quiso que los hijos respetaran a su padre, estableció la autoridad de la madre sobre sus hijos."
,"3":"El que respeta a su padre obtiene el perdón de sus pecados;"
,"4":"el que honra a su madre se prepara un tesoro."
,"5":"Sus propios hijos serán la alegría del que respeta a su padre; el día en que le implore, el Señor lo atenderá."
,"6":"El que respeta a su padre tendrá larga vida; el que obedece al Señor será el consuelo de su madre."
,"7":"Servirá a los que le dieron la vida como si sirviera al Señor."
,"8":"Actúa así, honra a tu padre de palabra y de hecho, y su bendición se hará realidad para bien tuyo."
,"9":"Pues la bendición de un padre afirma la casa de sus hijos, pero la maldición de una madre la destruye hasta los cimientos."
,"10":"No te alegres de la deshonra de tu padre: su vergüenza nunca será motivo de gloria para ti."
,"11":"El honor de un hombre depende de la reputación de su padre; cuando una madre mereció el desprecio, salieron deshonrados sus hijos."
,"12":"Hijo mío, cuida de tu padre cuando llegue a viejo; mientras viva, no le causes tristeza."
,"13":"Si se debilita su espíritu, aguántalo; no lo desprecies porque tú te sientes en la plenitud de tus fuerzas."
,"14":"El bien que hayas hecho a tu padre no será olvidado; se te tomará en cuenta como una reparación de tus pecados."
,"15":"En el momento de la adversidad será un punto a tu favor, y tus pecados se derretirán como hielo al sol."
,"16":"Abandonar a su padre es como insultar al Señor; el Señor maldice al que ha sido la desgracia de su madre."
,"17":"Hijo mío, actúa con tacto en todo, y serás amado por los amigos de Dios."
,"18":"Mientras más grande seas, más debes humillarte; así obtendrás la benevolencia del Señor."
,"20":"Porque si hay alguien realmente poderoso, ése es el Señor, y los humildes son los que lo honran."
,"21":"No aspires a algo superior a tus fuerzas, ni te lances a investigar lo que sobrepasa tus capacidades."
,"22":"Profundiza lo que se te ha mandado, no tienes necesidad alguna de conocer los misterios ocultos."
,"23":"No te canses resolviendo problemas inútiles, el saber que te ha sido entregado desborda lo que una persona puede comprender."
,"24":"Piensa que muchos se han extraviado con sus teorías, su seguridad mal fundada les falseó el raciocinio."
,"26":"El obstinado acabará en el fracaso; el que ama el peligro dejará en él la vida."
,"27":"El obstinado se verá colmado de pruebas; es pecador y acumula pecados y más pecados."
,"28":"No hay remedio para la miseria del orgulloso: el mal ha echado raíces en él."
,"29":"El hombre sabio medita las máximas en su corazón; todo lo que el sabio desea es hallar a alguien que lo escuche."
,"30":"El agua apaga las llamas de la hoguera; la limosna borra los pecados."
,"31":"El que responde de manera generosa asegura su porvenir: cuando esté a punto de caer encontrará un apoyo."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Hijo mío, no niegues su pan al pobre; no hagas esperar al que te mira con ojos suplicantes."
,"2":"No apenes al que tiene hambre, ni hagas enojarse a un indigente."
,"3":"No discutas con el desesperado, ni dejes que el necesitado suspire por tu limosna."
,"4":"No eches al mendigo agobiado por su miseria, ni le des la espalda al pobre."
,"5":"No des la espalda al que está necesitado, ni des a alguien un motivo para que te maldiga."
,"6":"Pues si alguien te maldice movido por su amargura, El que lo ha creado escuchará su súplica."
,"7":"Haz que la comunidad hable bien de ti, inclínate ante el que dirige."
,"8":"Atiende al pobre, respóndele con serenidad, dile palabras amables."
,"9":"Libra al oprimido de manos del opresor, y no seas blando cuando hagas justicia."
,"10":"Sé como un padre para el huérfano y como un marido para su madre. Entonces serás como un Hijo del Altísimo, te amará más que tu propia madre."
,"11":"La sabiduría educa a sus hijos y cuida de los que la buscan."
,"12":"El que la ama ama la vida; los que parten de mañana en su búsqueda serán colmados de alegría."
,"13":"El que la posee alcanzará al fin la gloria; el Señor le dará su bendición."
,"14":"Los que la sirven se hacen los ministros del Santo, los que la aman son amados del Señor."
,"15":"El que la escucha tendrá un juicio acertado, el que le obedece estará seguro."
,"16":"El que confía en ella la heredará, y sus descendientes disfrutarán de ella."
,"17":"Al principio lo llevará por caminos ásperos, le provocará miedos y sustos; lo agotará con su disciplina hasta el momento en que pueda contar con él; multiplicará sus exigencias para ponerlo a prueba."
,"18":"Pero luego lo llevará por caminos planos, le procurará la alegría y le revelará sus secretos."
,"19":"Pero si se ha extraviado, lo abandonará y dejará que se pierda."
,"20":"En cualquier circunstancia pesa el pro y el contra y evita lo peor. Hay una especie de vergüenza mala que te engañaría."
,"21":"Porque hay una vergüenza que lleva al pecado y otra que merece elogios y respeto."
,"22":"No reniegues de lo mejor que hay en ti por consideración al qué dirán; esa clase de vergüenza no debe hacer que te rebajes."
,"23":"No te quedes callado cuando tengas que hablar; no escondas por un orgullo mal puesto, lo que te dicta tu sabiduría."
,"24":"La sabiduría se reconoce en la conversación; la instrucción se ve en el discurso."
,"25":"No contradigas lo que es verdad; más vale que confieses tu ignorancia."
,"26":"No te avergüences de confesar tus pecados: no nades contra la corriente."
,"27":"No te amilanes ante un tonto; ni te dejes influenciar por un poderoso."
,"28":"Lucha a muerte por la verdad, y el Señor combatirá por ti."
,"29":"No seas atrevido en palabras, y luego perezoso y descuidado en tus actos."
,"30":"No seas como un león en tu casa, maltratando a tus servidores, humillando a tus inferiores."
,"31":"No tengas la mano extendida para recibir, y cerrada cuando haya que dar."
}`)
	CurrentBook.AddChapter(5, `{
"1":"No te sientas seguro con tu riqueza ni pienses: '¡Me basto a mí mismo!'"
,"2":"No te dejes arrastrar por la violencia o el deseo de tener: harán de ti su esclavo."
,"3":"No digas: '¡Nadie me lo impedirá!' El Señor puede castigarte."
,"4":"No digas: '¡Pequé y no me pasó nada!' El Señor se toma todo su tiempo."
,"5":"No estés demasiado seguro del perdón cuando acumules pecados."
,"6":"No digas: '¡La misericordia del Señor es grande, perdonará mis pecados por numerosos que sean!' Porque en él se encuentran misericordia y reprobación; su cólera se deja caer sobre los pecadores."
,"7":"No tardes en volver al Señor, no lo postergues cada día más, no sea que llegue el día del ajuste de cuentas; se encenderá de repente la cólera del Señor y tú perecerás."
,"8":"No cuentes con las riquezas mal adquiridas, de nada te servirán el día de la desgracia."
,"9":"No te dejes llevar por la corriente, no estés en dos caminos a la vez; esto es propio del pecador que usa un doble lenguaje."
,"10":"Mantente firme en tus convicciones y sé un hombre de palabra."
,"11":"Aprende a escuchar y tómate tu tiempo para responder."
,"12":"Si sabes de qué hablas, respóndele a tu interlocutor; si no, guarda silencio."
,"13":"Tus palabras te pueden traer gloria o descrédito; la lengua de un hombre prepara su caída."
,"14":"¡No permitas que te consideren como un mendigo o como un tramposo! Un ladrón atrae sobre sí la vergüenza, pero el hipócrita también tendrá su condenación."
,"15":"Evita el pecado, ya sea de grandes o pequeñas cosas; no te conviertas en enemigo del que era tu amigo."
}`)
	CurrentBook.AddChapter(6, `{
"1":"El que abiertamente hace el mal se prepara la vergüenza y la confusión; lo mismo ocurrirá con el pecador hipócrita."
,"2":"No capitules delante de tus pasiones; se volverían contra ti como un toro y te harían pedazos."
,"3":"Comerían tus hojas y destruirían tus frutos, dejándote como un tronco seco."
,"4":"Una mala pasión pierde al que la tiene, lo convierte en el hazmerreír de sus enemigos."
,"5":"Las palabras amables te harán ganar muchos amigos, un lenguaje cortés atrae respuestas benevolentes."
,"6":"Ten muchos amigos, pero para aconsejarte escoge uno entre mil."
,"7":"Si has encontrado un nuevo amigo, comienza por ponerlo a prueba, no le otorgues demasiado pronto tu confianza."
,"8":"Hay amigos que sólo lo son cuando les conviene, pero que no lo serán en las dificultades."
,"9":"Hay amigos que se transforman en enemigos y que dan a conocer a todo el mundo su desavenencia contigo para avergonzarte."
,"10":"Hay amigos que lo son para compartir tu mesa, pero que no lo serán cuando vayan mal tus negocios."
,"11":"Mientras éstos marchen bien, serán como tu sombra, e incluso mandarán a la gente de tu casa."
,"12":"Pero si tienes reveses, se volverán contra ti y evitarán encontrar tu mirada."
,"13":"Mantente a distancia de tus enemigos y cuídate de tus amigos."
,"14":"Un amigo fiel es un refugio seguro; el que lo halla ha encontrado un tesoro."
,"15":"¿Qué no daría uno por un amigo fiel? ¡No tiene precio!"
,"16":"Un amigo fiel es como un remedio que te salva; los que temen al Señor lo hallarán."
,"17":"El que teme al Señor encontrará al amigo verdadero, pues así como es él, así será su amigo."
,"18":"Hijo mío, conságrate al estudio desde tu juventud, y hasta cuando tengas blancos tus cabellos progresarás en la sabiduría."
,"19":"Que sea como un verdadero trabajo, igual como el del labrador o sembrador; cultívala y aguarda sus frutos excelentes. El cultivarla te acarreará preocupaciones, pero pronto gozarás de sus frutos."
,"20":"La sabiduría les parece a los ignorantes una persona muy severa; el que nada piensa no persevera en ella."
,"21":"Es para él una carga pesada, una prueba difícil, y pronto la tirará."
,"22":"La sabiduría defiende su reputación y no quiere revelarse al primero que llega."
,"23":"Así pues, hijo mío, recibe mis advertencias y no rechaces este consejo:"
,"24":"pon tus pies en sus grillos y coloca tu cuello bajo su yugo;"
,"25":"toma su carga sobre tus hombros y soporta su yugo; no te impacientes por sus cadenas."
,"26":"Acércate a ella con toda tu alma, y pon todo tu empeño en seguir sus caminos."
,"27":"Lánzate tras sus huellas, búscala y se dará a conocer; cuando la tengas, no dejes que se vaya."
,"28":"Porque al fin encontrarás en ella tu descanso y será tu alegría."
,"29":"Sus grillos facilitarán tus pasos, su collar será tu vestido."
,"30":"Su yugo será un adorno de oro, y sus cadenas, preciosas guirnaldas de púrpura violeta."
,"31":"Será tu ornamento, tu túnica de gala; la llevarás en la frente como una diadema de fiesta."
,"32":"Si tú quieres, hijo mío, llegarás a ser instruido; si te aplicas, se abrirá tu espíritu."
,"33":"Si quieres escuchar, aprenderás; si pones atención, serás sabio."
,"34":"Frecuenta la asamblea de los ancianos; si ves ahí un hombre sabio, júntate con él."
,"35":"Escucha con gusto todo lo que se refiere a las cosas de Dios; no dejes pasar las sentencias de los sabios."
,"36":"Si ves a un hombre realmente sensato, anda a su casa desde el amanecer, y que tus pies desgasten el umbral de su puerta."
,"37":"Medita los preceptos del Señor, preocúpate continuamente de sus mandamientos; él te afirmará el corazón y tú recibirás esa sabiduría tan deseada."
}`)
	CurrentBook.AddChapter(7, `{
"1":"No hagas el mal y el mal no te sorprenderá."
,"2":"Apártate de la mala acción, y ella te dejará."
,"3":"Hijo mío, no siembres en los senderos del mal: podrías cosechar siete veces más."
,"4":"No pidas al Señor un puesto de dirigente, ni al rey un puesto de honor."
,"5":"No te hagas pasar por justo ante el Señor, ni por sabio ante el rey."
,"6":"No aspires a tener un puesto de responsabilidad si no eres lo bastante fuerte para arrancar de raíz la injusticia: te dejarás intimidar por un poderoso y perderás tu integridad."
,"7":"No ofendas a la asamblea de la ciudad ni pierdas la confianza de la población."
,"8":"No cometas dos veces el mismo pecado: basta con uno para que seas castigado."
,"9":"No digas: 'Dios tomará en cuenta mis numerosas ofrendas; se las presentaré al Altísimo y las aceptará.'"
,"10":"Más bien ora con fuerza y no dejes de dar limosna."
,"11":"No te burles del que ha sido humillado: hay alguien que humilla y que ensalza."
,"12":"No mientas a costa de tu hermano, ni mientas a costa de tu amigo."
,"13":"Aléjate de cualquier clase de mentira: nada de bueno saldrá de eso."
,"14":"No hables a tontas y a locas en la asamblea de los ancianos, ni multipliques las palabras en tu oración."
,"15":"No menosprecies las actividades penosas, ni el trabajo del campo instituido por el Altísimo."
,"16":"No te juntes con el grupo de los pecadores, acuérdate que la Cólera no tarda."
,"17":"No te creas más de lo que eres: el que vive sin Dios será castigado por el fuego y los gusanos."
,"18":"No cambies un amigo por la plata, ni un verdadero hermano por el oro fino."
,"19":"No te separes de una esposa sabia y buena; una esposa amable vale más que el oro."
,"20":"No maltrates al doméstico que trabaja como debe, ni al asalariado que no pierde su tiempo."
,"21":"Ama al esclavo inteligente como a ti mismo: le darás su libertad."
,"22":"¿Tienes rebaños? Cuídalos. Si te dan ganancias, no te deshagas de ellos."
,"23":"¿Tienes hijos? Edúcalos y enséñales a obedecer desde su niñez."
,"24":"¿Tienes hijas? Cuida su virginidad, no seas demasiado indulgente con ellas."
,"25":"Casa a tu hija y habrás arreglado un importante asunto, pero entrégasela a un hombre inteligente."
,"26":"¿Tienes una mujer según tu corazón? No te separes de ella. Pero no confíes en la que ves con malos ojos."
,"27":"Honra a tu padre con todo tu corazón; no olvides nunca que tu madre sufrió por ti."
,"28":"Acuérdate que por ellos tu naciste: ¿qué les darás por todo lo que te dieron?"
,"29":"Rinde homenaje al Señor con toda tu alma, y respeta a sus sacerdotes."
,"30":"Ama con todas tus fuerzas al que te ha creado, y no abandones a sus ministros."
,"31":"Teme al Señor y honra al sacerdote; dale su parte como se te ha mandado: las primeras cosechas de tu campo, el sacrificio por el pecado, el lomo de las víctimas, las ofrendas santas y las primicias de las cosas sagradas."
,"32":"Tiéndele al pobre una mano generosa, y recibirás del Señor una bendición."
,"33":"Que los vivos reciban tus buenas obras y no olvides a los muertos."
,"34":"No te apartes de los que lloran, sufre con los que tienen pena."
,"35":"No te olvides de visitar al enfermo: ese tipo de cosas hará que se te quiera."
,"36":"En todo lo que hagas acuérdate de tu fin y nunca pecarás."
}`)
	CurrentBook.AddChapter(8, `{
"1":"No discutas con un hombre poderoso: podrías caer en sus manos."
,"2":"No te querelles con un hombre rico: podría echar su peso en la balanza."
,"3":"No discutas con un hablador: sería echar leña al fuego."
,"4":"No bromees con el hombre grosero: acabaría insultando a tus antepasados."
,"5":"No hagas reproches al pecador arrepentido; acuérdate que todos somos culpables."
,"6":"No desprecies al hombre en su vejez; también seremos viejos un día."
,"7":"No te alegres de la muerte de alguien: acuérdate que todos moriremos."
,"8":"No desdeñes las palabras de los sabios, recuerda a menudo sus preceptos: aprenderás de ellos a vivir y servir a los grandes."
,"9":"No te apartes de la doctrina de los ancianos, pues ellos la aprendieron de sus padres; abrirán tu inteligencia y te harán capaz de responder oportunamente."
,"10":"No excites al pecador: podrías quemarte en sus llamas."
,"11":"No impacientes a un hombre de mal carácter: falsearía tus palabras y de allí sacaría pretexto."
,"12":"No prestes a uno que tiene más poder que tú: si le has prestado, dalo por perdido."
,"13":"No sirvas de aval de alguien más allá de tus medios: si lo has hecho, prepárate a pagar."
,"14":"No presentes demanda judicial contra un juez: en vista de su posición, fallarán en su favor."
,"15":"No salgas a caminar con un hombre temerario, no sea que te doble la mano. Como él actuará según su antojo, sus locuras los perderán a ambos."
,"16":"No discutas con un hombre violento, no te quedes con él en un lugar solitario. Porque no tendrá escrúpulos en derramar sangre, y viéndote indefenso, se te echará tal vez encima."
,"17":"No tomes tu decisión en presencia de un tonto: no guardará el secreto."
,"18":"No hagas lo que debe permanecer secreto en presencia de un desconocido: no sabes cómo reaccionará."
,"19":"No abras tu corazón a cualquiera: no cuentes con que sabrá agradecértelo."
}`)
	CurrentBook.AddChapter(9, `{
"1":"No seas celoso de la mujer que amas: podría nacer en ella la tentación de engañarte."
,"2":"No te entregues en las manos de una mujer hasta el punto que te domine."
,"3":"No te acerques a una mujer de mala reputación: podrías caer en sus redes."
,"4":"No te entretengas con una cantadora: haría que cayeras en su trampa."
,"5":"No fijes tu mirada en una jovencita: podrías condenarte con ella."
,"6":"No caigas en los brazos de una prostituta: podrías perder con ella todo lo que tienes."
,"7":"No mires para todas partes en las calles de la ciudad, ni te entretengas en rincones solitarios."
,"8":"Aparta tus ojos de una mujer hermosa; no te quedes mirando a una belleza desconocida. La belleza de una mujer ha hecho caer a muchos; ella basta para encender la pasión."
,"9":"No te sientes a la mesa con una mujer casada para tomar vino con ella, no sea que se despierte en ti el deseo y que la pasión te haga ceder y caer."
,"10":"No abandones a un viejo amigo: el nuevo no se le equiparará. Nuevo amigo, vino nuevo; déjalos que envejezcan y los tomarás con gusto."
,"11":"No envidies el éxito del pecador, no sabes cuál será su fin."
,"12":"No te alegres del éxito de los renegados: acuérdate que su castigo no esperará su muerte."
,"13":"Mantente alejado del que puede matar, y no tendrás miedo de morir. Si te acercas a él, trata de no molestarlo, pues podría quitarte la vida: Sabes muy bien que caminas en medio de trampas, que caminas por encima de un muro."
,"14":"Muéstrate sociable en cuanto puedas, y déjate aconsejar por los sabios."
,"15":"Prefiere conversar con las personas inteligentes; que todas tus conversaciones giren en torno a la Ley del Altísimo."
,"16":"Que los hombres buenos frecuenten tu mesa; que tu orgullo sea el temor del Señor."
,"17":"Se juzga a un artesano por su trabajo, y al jefe del pueblo por sus sabias intervenciones."
,"18":"El hombre que habla mucho es temido en la ciudad; se detesta al que habla puras estupideces."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Un sabio dirigente educa a su pueblo; el gobierno de un hombre sensato es bien ordenado."
,"2":"Así como es el jefe así serán los ministros; así como es el gobernador de una ciudad así serán sus habitantes."
,"3":"Un rey sin sabiduría es la ruina de su pueblo; una ciudad prospera gracias a la inteligencia de sus jefes."
,"4":"Las autoridades de un país están en las manos del Señor; él envía en el momento preciso el hombre que conviene."
,"5":"El éxito de quien sea está en las manos del Señor; él reviste a los jefes de su propia autoridad."
,"6":"No guardes rencor a tu prójimo sea cual fuere la ofrenda; no hagas algo bajo el efecto de la cólera."
,"7":"El orgullo es tan odioso al Señor como a los hombres; para él como para los demás la injusticia es abominable."
,"8":"Una nación pierde el poder y lo deja en manos de otra debido a la injusticia, la violencia y la riqueza."
,"9":"¿Cómo puede uno tener tanto orgullo cuando no es más que polvo y ceniza? ¡Ya cuando está con buena salud, el hombre tiene la pudrición en sus tripas!"
,"10":"Que se alargue la enfermedad, bromea el médico...  el rey de hoy estará muerto mañana."
,"11":"Una vez muerto, el hombre no tiene ante sí más que la podredumbre, las fieras y los gusanos."
,"12":"El comienzo de la soberbia en el hombre es apartarse del Señor y no tomar más en cuenta a su Creador."
,"13":"El pecado es el comienzo del orgullo; al perseverar en el pecado se abren de par en par las puertas a la soberbia impía. Por eso, el Señor envió a los pecadores siniestros castigos; al último, los aniquiló."
,"14":"El Señor ha derribado de sus tronos a príncipes, y los ha reemplazado por gente sencilla."
,"15":"El Señor ha arrancado de cuajo a los orgullosos y en su lugar plantó a los humildes."
,"16":"El Señor ha asolado tierras de paganos, las destruyó totalmente."
,"17":"Devastó a muchos, destruyó sus naciones, borrando su recuerdo de la tierra."
,"18":"No fue creado el orgullo para el hombre, ni los excesos de cólera para los que nacen de mujer."
,"19":"¿Cuál es la raza digna de honor? La raza humana. ¿Cuál es la raza digna de honor? Los que temen al Señor. ¿Qué raza es despreciable? La raza humana. ¿Qué raza es despreciable? Los que violan los mandamientos y la Ley."
,"20":"El jefe merece el respeto de sus hermanos;"
,"21":"pero él respeta a los que temen al Señor."
,"22":"Ricos, ilustres o pobres, su único orgullo debe ser el temer al Señor."
,"23":"No es justo despreciar a un pobre que observa la Ley, ni conviene glorificar a un pecador."
,"24":"El grande, el juez y el poderoso son dignos de honor, pero ninguno de ellos es tan grande como el que teme al Señor."
,"25":"Un servidor inteligente tendrá por servidores hombres libres, y las personas sensatas no tendrán nada que decir."
,"26":"No te jactes cuando no haces más que cumplir con tus obligaciones, ni te pongas soberbio cuando estés en apreturas."
,"27":"Más vale ser un trabajador y vivir con holgura que aparentar ser alguien y que te falte el pan."
,"28":"Hijo mío, estímate con modestia, apréciate en tu justo valor."
,"29":"¿Quién defenderá al que atenta contra su propia vida? ¿Quién respetará al que se desacredita a sí mismo?"
,"30":"A un pobre se lo estima por su sabiduría, y a un rico por sus riquezas."
,"31":"Si a uno lo honran siendo pobre, ¿cuánto más cuando sea rico? Si a uno lo desprecian siendo rico, ¿cuánto más cuando sea pobre?"
}`)
	CurrentBook.AddChapter(11, `{
"1":"El pobre, si es un sabio, lleva la frente en alto; se sienta entre los notables."
,"2":"No te dejes embaucar por el que tiene buena facha, ni mires mal a otro por su aspecto."
,"3":"Entre los seres alados la abeja es de los pequeños, pero es la principal por la dulzura de su miel."
,"4":"No te sientas orgulloso de la ropa que llevas, ni te creas el día en que te honran; ¿sabes lo que el Señor prepara sin que se lo note?"
,"5":"Muchos dictadores han sido destronados y la corona ha pasado al que nadie esperaba."
,"6":"Muchos que eran poderosos lo han perdido todo, personas famosas han caído en manos de un recién llegado."
,"7":"No reprendas antes de informarte; comienza por examinar y luego haz los reproches."
,"8":"No respondas antes de haber escuchado, ni interrumpas al que habla."
,"9":"No te metas en lo que no te incumbe, ni tomes partido en querellas de pecadores."
,"10":"Hijo mío, no emprendas muchas cosas a la vez; si son demasiadas, te perjudicarás; aunque corras, no las conseguirás y no podrás librarte más de ellas."
,"11":"Hay quiénes se fatigan en el trabajo, se agotan y se atormentan y se encuentran más pobres que antes."
,"12":"Otros son débiles y vulnerables, sin recursos y carentes de todo, pero el Señor los mira con ojos favorables."
,"13":"Los saca de su abatimiento y les hace levantar la cabeza, a tal punto que muchos se maravillan de ello."
,"14":"Prosperidad y mala suerte, vida y muerte, pobreza y riqueza, todo viene del Señor."
,"17":"Los que son fieles pueden contar con la generosidad del Señor, su benevolencia los guiará siempre."
,"18":"Piensa en la suerte de un hombre que se ha enriquecido a fuerza de cálculos y de economías."
,"19":"A lo mejor se dice a sí mismo: 'Tengo bien ganado el descanso, ya puedo vivir con lo que he adquirido.' Pero no sabe el tiempo que le queda, morirá y se lo dejará todo a otros."
,"20":"Sé fiel a tu trabajo, conságrale tu vida y continúa con tu labor hasta tus días de ancianidad."
,"21":"No te escandalices por el éxito de los pecadores; pon tu confianza en el Señor y persevera en tu labor. Es fácil para el Señor hacer rico al pobre en un instante."
,"22":"La bendición del Señor recompensará a sus fieles: de repente, sin hacerse anunciar, trae sus frutos."
,"23":"No digas: ¿Qué me falta, qué más podría tener o desear?"
,"24":"No digas: 'Tengo todo lo que necesito, ¿qué desgracia podría ocurrirme ahora?'"
,"25":"En los días buenos se olvida uno de los malos, en los días malos no se acuerda más de los buenos."
,"26":"Aun cuando esté cerca el fin, es fácil para el Señor darle a cada uno según cómo ha vivido."
,"27":"La hora de la prueba hace olvidar todos los placeres, al acabarse la vida de un hombre es cuando sus acciones se aprecian."
,"28":"No proclames feliz a nadie, mientras la persona no esté muerta: la conocerás sólo al final."
,"29":"No lleves a cualquiera a tu casa, porque los aprovechadores habilosos son muchos."
,"30":"El pensamiento del orgulloso es como la perdiz enjaulada para atraer la caza: te observa y descubre tus puntos débiles;"
,"31":"cambia el bien en mal, te tiende sus trampas, calumnia lo que hay de mejor."
,"32":"La chispa enciende los carbones, el pecador con sus acechanzas hará correr sangre."
,"33":"Desconfía del malo: no olvides que anda tramando el mal; podría destruir tu reputación para siempre."
,"34":"Lleva a tu casa a un extraño y te acarreará problemas; te enemistará con las personas de tu casa."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Si haces un favor, mira a quién lo haces, y te valdrá un reconocimiento."
,"2":"Haz el bien a un fiel y serás recompensado, si no es por él, por el Altísimo."
,"3":"No se hacen favores al que se obstina en hacer el mal, ni al que no tiene compasión."
,"4":"Da a un fiel, pero no ayudes a un pecador."
,"5":"Haz el bien al que es humilde, pero no des a un impío. Niégale el pan, no se lo des, pues llegaría a ser más poderoso que tú y te pagaría con el doble de mal tus buenas obras."
,"6":"Mira que el Altísimo aborrece a los pecadores y se venga de los impíos."
,"7":"Da al hombre bueno, pero no vayas en ayuda del pecador."
,"8":"Un amigo no se vuelve enemigo cuando todo va bien, un enemigo no se disimula más cuando llega la adversidad."
,"9":"Cuando a uno le va bien, sus enemigos se enojan; cuando tiene reveses, hasta su amigo lo abandona."
,"10":"No te fíes nunca de tu enemigo: su maldad permanece igual que el bronce bajo el óxido."
,"11":"Aunque se haga el humilde y se acerque agachado, mantente en guardia y desconfía de él; actúa con él como el artesano que pule un espejo de bronce y que sabe que el óxido no se resistirá hasta el fin."
,"12":"No lo pongas a tu lado: podría echarte y ocupar tu lugar. No lo invites a sentarse a tu derecha: podría ambicionar tu puesto; entonces comprenderías que yo tenía razón y te pesaría no haberme escuchado."
,"13":"¿Quién se compadecerá del encantador mordido por una serpiente, o de cualquier otro que se acerca a animales peligrosos?"
,"14":"Lo mismo vale para el que frecuenta al pecador y se asocia a sus malas acciones."
,"15":"El pecador se mantendrá tranquilo a tu lado durante una hora, pero apenas te distraigas, se sacará la máscara."
,"16":"El enemigo no es más que dulzura en sus palabras, pero sólo piensa en tirarte a la fosa. Sabe derramar lágrimas, pero si tiene la ocasión, se le hará poco tu sangre."
,"17":"Si te azota la desgracia, lo verás ante ti: hará como que te ayuda, pero será sólo para librarse de ti."
,"18":"Entonces te hará muecas y aplaudirá; hará bromas a costa tuya y mostrará su verdadera cara."
}`)
	CurrentBook.AddChapter(13, `{
"1":"El que toca el alquitrán se ensucia los dedos, el que se junta con un hombre soberbio se volverá como él."
,"2":"No cargues con un fardo muy pesado; no te hagas amigo de uno más fuerte y más rico que tú. Juntarías un cántaro de arcilla y una olla de fierro. Uno golpearía a la otra y se quebrarían."
,"3":"El rico actúa mal y hace como si nada; el pobre es insultado y presenta sus excusas."
,"4":"Mientras le seas útil, se sirve de ti; cuando ya no tengas nada, te dejará."
,"5":"Irá a tu casa mientras tengas algo; se aprovechará de ti sin el menor remordimiento."
,"6":"Si te necesita, te adulará y te sonreirá; te prometerá maravillas y te dirá buenas palabras: '¿Qué necesitas?'"
,"7":"Te dará gracias hasta molestarte, mientras te quita todo lo que tengas; después de eso se burlará de ti. Luego, cuando te vea se apartará de ti, y si se topa contigo meneará la cabeza."
,"8":"Cuídate, pues, de dejarte engañar, y de venirte abajo por pura estupidez."
,"9":"Si una persona importante te invita, discúlpate: te volverá a llamar."
,"10":"No te acerques demasiado, pues podrían echarte; ni te apartes demasiado, pues te olvidarían."
,"11":"No pienses hablarle de igual a igual, no te fíes de todas sus palabras; todas esas palabras son una manera de ponerte a prueba, quiere sopesarte mostrando interés por ti."
,"12":"Repetirá sin compasión tus palabras, no te escatimará golpes ni cadenas."
,"13":"Cuídate, pues, y pon mucha atención, pues junto a ti está caminando tu caída."
,"15":"Todo ser viviente ama a su semejante, todo hombre ama a su prójimo."
,"16":"Todo animal frecuenta a los de su especie, también el hombre busca a su semejante."
,"17":"¿Puede el lobo caminar con el cordero? Lo mismo pasa con el pecador y el hombre de bien."
,"18":"¿Qué paz puede haber entre la hiena y el perro? ¿Y qué paz entre el rico y el pobre?"
,"19":"Los burros salvajes son presa de los leones del desierto: de igual modo los pobres son presa del rico."
,"20":"El orgulloso aborrece la humildad, un pobre es para el rico un objeto de horror."
,"21":"Cuando el rico se tambalea, sus amigos le tienden una mano; cuando el pobre se cae, sus amigos lo abandonan."
,"22":"Cuando el rico tiene problemas, son muchos lo que vienen a ayudarlo; puede decir tonterías y le hallarán que tiene razón. Cuando el pobre comete un error, le llaman la atención, si dice cosas sensatas, nadie se las toma en cuenta."
,"23":"Cuando el rico habla todos se callan; elevan sus palabras hasta las nubes. Después que el pobre ha hablado preguntan: '¿Quién es ése?' Y si tropieza lo tiran al suelo."
,"24":"La riqueza es buena cuando es sin pecado. Pero, según el impío, la pobreza es el mal."
,"25":"El corazón del hombre se refleja en su rostro, para bien o para mal."
,"26":"¿Tiene el rostro radiante? Es porque le va bien en todo. ¿Encontró palabras de sabiduría? Es porque reflexionó en el sufrimiento."
}`)
	CurrentBook.AddChapter(14, `{
"1":"¡Feliz el hombre que no pecó con sus palabras y que no arrastra el pesar por sus faltas!"
,"2":"¡ Feliz aquel que no es condenado por su conciencia y que no renunció a su ideal!"
,"3":"A un hombre mezquino no le conviene la riqueza: ¿para qué le van a dar muchos bienes a un avaro?"
,"4":"El que junta privándose de todo, junta para otro: otros disfrutarán de sus bienes."
,"5":"Si alguien es malo consigo mismo, ¿para quién será bueno? Ni siquiera goza de lo que tiene."
,"6":"No hay nadie más malo que el que es malo consigo mismo: su maldad se vuelve contra él."
,"7":"Si hace el bien será por casualidad, pero al final reaparecerá su maldad."
,"8":"El hombre que siempre está ambicionando es un malo; no le interesan las personas, desprecia a los demás."
,"9":"El hombre insaciable no está nunca satisfecho, la codicia le seca el corazón."
,"10":"El envidioso codicia el alimento de su prójimo; miseria y hambre se sentarán a su mesa."
,"11":"Hijo mío, haz buen uso de todo lo que tengas, y preséntale al Señor ofrendas generosas."
,"12":"Acuérdate que la muerte no tardará, y que tu hora no te ha sido aún revelada."
,"13":"Antes de morir haz el bien a tu amigo, sé generoso según tus medios."
,"14":"Disfruta de la vida y no desdeñes un gusto legítimo si se te presenta en el camino."
,"15":"¿Dejarás a otro el fruto de tu trabajo? Se repartirán a la suerte el fruto de tus sacrificios."
,"16":"Da y recibe, satisface tus anhelos, porque no se puede buscar el placer en el sepulcro."
,"17":"Todo lo que vive envejece como un vestido; es la ley eterna: ¡tú morirás!"
,"18":"Mira el verdor de un árbol frondoso: unas hojas caen y otras aparecen; de igual manera las generaciones de carne y hueso, una muere y la otra nace."
,"19":"Las cosas finitas pasan y con ellas pasa el que las hizo."
,"20":"Feliz el que se dedica a la sabiduría y puede responder al que lo interroga;"
,"21":"que hace suyos los caminos de la sabiduría y profundiza sus secretos;"
,"22":"que sale a cazarla y acecha su paso;"
,"23":"que mira a través de sus ventanas y escucha a su puerta;"
,"24":"que instala su tienda al lado de su casa y clava las estacas en sus muros."
,"25":"Pone su tienda en manos de la sabiduría y se queda en esa feliz morada."
,"26":"Deja a sus hijos bajo su protección y se tiende al abrigo de sus ramas;"
,"27":"lo protege del calor y él se instala en su gloria."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Esta es la suerte del que teme al Señor; el que se da a la Ley obtendrá la sabiduría."
,"2":"Le saldrá al encuentro como una madre, y lo acogerá como una joven esposa."
,"3":"Lo alimentará con el pan de la inteligencia y le dará a beber el agua de la sabiduría."
,"4":"Puede contar con ella: no vacilará. Se apoyará en ella y no caerá."
,"5":"La sabiduría lo destacará entre los que lo rodean, y tomará la palabra en la asamblea."
,"6":"Será coronado de felicidad y de alegría, y su nombre será famoso para siempre."
,"7":"Los imbéciles jamás conseguirán la sabiduría, los pecadores nunca la verán."
,"8":"Se mantiene alejada de los orgullosos, y los mentirosos no la conocerán."
,"9":"De nada vale la alabanza en boca del pecador, pues ella no viene del Señor."
,"10":"Debe venir de un sabio, porque entonces es el Señor quien lo inspira."
,"11":"No digas: '¡Dios me hizo pecar!' porque él no hace lo que odia."
,"12":"No digas: '¡Me hizo cometer un error!' porque no necesita a un pecador."
,"13":"El Señor detesta el mal, y de igual modo lo detestan los que temen al Señor."
,"14":"Cuando al principio creó al hombre, lo dejó en manos de su propia conciencia:"
,"15":"Si tú quieres, puedes observar los mandamientos; está en tus manos el ser fiel."
,"16":"Ante ti puso el fuego y el agua: extiende la mano a lo que prefieras."
,"17":"Delante de los hombres están la vida y la muerte, a cada uno se le dará lo que ha elegido."
,"18":"¡Qué grande es la sabiduría del Señor, qué fuerte y poderoso es él! El todo lo ve."
,"19":"Su mirada se posa en los que le temen; conoce todas las acciones de los hombres."
,"20":"A nadie le ha pedido que sea impío, a nadie le ha dado permiso para que peque."
}`)
	CurrentBook.AddChapter(16, `{
"1":"No desees que tus hijos sean numerosos si van a ser inútiles; no pongas en ellos tu alegría si son impíos."
,"2":"Por numerosos que sean, no te alegres de ello si no tienen el temor de Dios."
,"3":"Poco importa si son numerosos y tienen larga vida, porque uno solo vale a veces más que mil, y más les vale morir que ser impíos."
,"4":"Basta con un hombre prudente para que prospere una ciudad; pero los malos por más que se multipliquen, serán aniquilados."
,"5":"Con mis propios ojos he visto muchos ejemplos, y me han contado algunos más impactantes todavía:"
,"6":"Un fuego cayó sobre una banda de pecadores, la cólera del Señor estalló contra una raza rebelde."
,"7":"No perdonó a los héroes antiguos cuando orgullosos de su fuerza se rebelaron."
,"8":"No perdonó a la ciudad donde vivía Lot: odiaba a esos orgullosos."
,"9":"No tuvo compasión de esa nación condenada a la destrucción: fueron aniquilados a causa de sus pecados."
,"10":"Hizo lo mismo con seiscientos mil hombres que con un corazón obstinado se negaban a obedecerle."
,"11":"Aunque hubiera habido un solo obstinado, habría sido sorprendente que quedara sin castigo. Porque en la mano del Señor están la misericordia y la cólera: él es poderoso tanto para perdonar como para castigar."
,"12":"Su justicia es tan grande como su misericordia, y juzga a los hombres según sus actos."
,"13":"No escapará el pecador con su botín, y la paciencia de los fieles no quedará sin recompensa."
,"14":"Dios recompensará cualquier gesto caritativo, y cada uno será tratado según sus acciones."
,"17":"No digas: '¡Me esconderé lejos del Señor! Allá arriba, ¿quién se acordará de mí? No me reconocerán en medio de la muchedumbre: ¿qué soy yo en la inmensidad de la creación?'"
,"18":"Mira: cuando él aparece, hasta el cielo se estremece, y también los cielos por encima de los cielos como asimismo la tierra y los mares."
,"19":"Las montañas y los fundamentos de la tierra se llenan de espanto ante su vista."
,"20":"Pero nadie reflexiona en esto: ¿quién pues se interesa en la manera de actuar de Dios?"
,"21":"La gente no advierte la tormenta, porque la mayor parte de sus intervenciones se prepara en secreto."
,"22":"'¿Quién nos habla de las intervenciones de Dios? ¿Quién las aguarda? La alianza ahora está lejos'."
,"23":"Eso es lo que piensa el que no reflexiona, el que no tiene juicio, el que está corrompido y vive de sus ilusiones."
,"24":"Escúchenme, hijos míos, aprendan y tomen en serio lo que les voy a decir:"
,"25":"Quiero exponer paso a paso la doctrina y transmitir cuidadosamente el saber."
,"26":"Desde el principio las criaturas han obedecido a un designio de Dios; apenas hechas, les ha asignado un lugar a cada una."
,"27":"Ordenó a sus obras por mientras dure el tiempo, fijándoles un punto de partida y un porvenir. Nunca tienen hambre, ni se cansan, ni se detienen en su trabajo."
,"28":"Los objetos celestes no chocan con sus vecinos, ni desobedecen jamás sus órdenes."
,"29":"Después de eso, el Señor miró hacia abajo, a la tierra, y la colmó de sus riquezas."
,"30":"Le dio un alma, una cubierta de seres vivos, y todos retornan a la tierra."
}`)
	CurrentBook.AddChapter(17, `{
"1":"El Señor sacó al hombre de la tierra, y allá lo hace volver."
,"2":"Para cada uno determinó el tiempo de su venida y el número de sus días; les dio poder sobre las cosas de la tierra."
,"3":"Los revistió de fuerza semejante a la suya, haciéndolos a su imagen."
,"4":"Hizo que todo ser animado los temiera, y que fueran amos de las fieras salvajes y de las aves."
,"6":"Les dio para que percibieran la realidad una conciencia, una lengua y ojos, oídos y entendimiento."
,"7":"Los llenó de saber y de inteligencia, y les enseñó el bien y el mal."
,"8":"Puso en ellos su ojo interior, haciéndolos así descubrir las grandes cosas que había hecho,"
,"10":"para que alabaran su Nombre Santísimo y proclamaran la grandeza de sus obras."
,"11":"Les reveló además un saber, y los dotó de una Ley de vida."
,"12":"Concluyó con ellos una alianza eterna y les enseñó sus decretos."
,"13":"Sus ojos contemplaron su gloria majestuosa, sus oídos oyeron su voz poderosa."
,"14":"Les dio mandamientos con respecto a su prójimo, diciéndoles: 'Eviten cualquier injusticia'."
,"15":"El comportamiento del hombre está siempre ante sus ojos, no pueden escapar a su mirada."
,"17":"Dio a cada nación un guía, pero Israel pertenece en propiedad al Señor."
,"19":"Todas sus obras están ante él como a pleno sol, no pierde de vista por dónde andan."
,"20":"No se le ocultan sus injusticias, todos sus pecados están delante del Señor."
,"22":"Guarda como objeto precioso la limosna que se hace, preserva las buenas obras de cada uno como a la niña de sus ojos."
,"23":"Se levantará un día, entregará las recompensas, depositando sobre sus cabezas lo que les corresponde."
,"24":"A los que se arrepienten les concede que vuelvan, anima a los que se descorazonaron."
,"25":"Conviértete al Señor y renuncia al pecado, rézale y disminuye tus ofensas."
,"26":"Vuélvete al Altísimo y apártate de la injusticia, ten horror de lo que es abominable."
,"27":"¿Quién alabará al Altísimo en la morada de los muertos? Son los vivos los que le dan la alabanza?"
,"28":"El muerto no puede alabar, es como si no existiera; es el vivo, el que está sano, el que alaba al Señor."
,"29":"¡Qué grande es la misericordia del Señor, y su perdón para los que se convierten a él!"
,"30":"El hombre no puede tenerlo todo: para comenzar el hijo del hombre no es inmortal."
,"31":"¿Qué es más luminoso que el sol? Y, sin embargo, va declinando. ¡Qué error más grande es la pretensión de un ser de carne y hueso!"
,"32":"El Señor controla los ejércitos celestiales, y los hombres, en cambio, no son más que tierra y ceniza."
}`)
	CurrentBook.AddChapter(18, `{
"1":"El que vive por los siglos lo ha creado todo maravillosamente."
,"2":"Unicamente el Señor será reconocido como justo."
,"4":"A nadie le ha dado la capacidad para proclamar todas sus obras: ¿quién podría entender todas de sus maravillas?"
,"5":"¿Quién medirá su poder esplendoroso, quién podrá contar todos sus gestos de misericordia?"
,"6":"No hay nada que quitarles ni nada que añadirles; las maravillas del Señor permanecen impenetrables."
,"7":"Cuando uno cree haber terminado, no hace más que empezar; cuando se detiene en ellas, se siente sobrepasado."
,"8":"¿Qué es el hombre? ¿Para qué sirve? ¿Qué le hace falta? ¿Qué es malo para él?"
,"9":"¿Cuánto dura su vida? A lo más cien años."
,"10":"Una gota de agua en el mar, un grano de arena: así es su vida frente a la eternidad."
,"11":"Por eso, el Señor tiene paciencia con los hombres y los cubre con su misericordia."
,"12":"El ve y sabe que su fin es miserable, por eso los perdona sin cuento."
,"13":"A cada uno le corresponde la misericordia con su prójimo, y al Señor, la misericordia para todo ser viviente; reprende, corrige, enseña, y como un pastor reúne a su rebaño."
,"14":"Es bueno con los que aceptan la corrección y cumplen con prontitud sus decisiones."
,"15":"Hijo mío, no reprendas cuando hagas un favor, no causes tristeza si haces un regalo."
,"16":"¿No refresca el rocío al viento caliente? De igual modo la palabra hace más bien que lo que se da."
,"17":"¿No ves que algunas palabras valen más que un regalo? Pero una persona generosa junta lo uno con lo otro."
,"18":"El insensato echa a perder una buena obra con sus críticas, el regalo de un hombre mezquino hace que se llenen de lágrimas los ojos."
,"19":"Antes de hablar, infórmate, y cuídate antes de estar enfermo."
,"20":"Examínate antes que Dios te juzgue, y obtendrás perdón el día en que te visite."
,"21":"Humíllate antes de caer enfermo y si has pecado muestra tu arrepentimiento."
,"22":"No dejes de cumplir un voto en el momento determinado, no esperes la muerte para ponerte en regla."
,"23":"Reflexiona bien antes de hacer un voto, no seas de esos que tientan al Señor."
,"24":"Piensa en el juicio de los últimos días, en los días del castigo en que Dios dará vuelta la cara."
,"25":"En los momentos de abundancia acuérdate de los instantes de miseria; en los días de riqueza piensa en la pobreza y en la carencia de todo."
,"26":"De la mañana a la noche ha transcurrido el tiempo: todo pasa rápido delante del Señor."
,"27":"El que es sabio está atento en cualquier momento; incluso cuando abunda el pecado, él evita la falta."
,"28":"Toda persona sensata reconoce la sabiduría, y felicita a los que la han hallado."
,"29":"Aquellos cuyas palabras están llenas de sensatez han sabido ser sabios; sus sentencias son una lluvia bienhechora."
,"30":"No te dejes llevar por tus ambiciones, refrena tus apetitos."
,"31":"Si te concedes lo que quieren tus pasiones, harán que de ti se rían tus enemigos."
,"32":"No te des a la buena vida, no pases a ser esclavo de sus exigencias."
,"33":"No te empobrezcas festejándote con dinero prestado cuando no tienes nada en tu bolsillo."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Un obrero bebedor nunca se hará rico; el que se descuida en las pequeñas cosas decaerá poco a poco."
,"2":"El vino y las mujeres corrompen a los mejores; el que frecuenta a las prostitutas perdió toda vergüenza."
,"3":"Allí ganará sólo podredumbre y gusanos: así acabará el que no tiene más vergüenza."
,"4":"El que confía inmediatamente es un cabeza hueca, el que cede al pecado se hace daño a sí mismo."
,"5":"El que se complace en los chismes será condenado,"
,"6":"el que odia la charlatanería escapa al mal."
,"7":"No cuentes nunca lo que te han dicho, y nunca tendrás que sufrir por ello."
,"8":"No cuentes nada a nadie, ni amigo ni enemigo; no lo digas a menos que tu silencio se haga culpable."
,"9":"Te escucharán seguramente, pero después desconfiarán de ti y por último te odiarán."
,"10":"¿Has oído algo? Entiérralo dentro de ti; ¡ánimo, que eso no te hará reventar!"
,"11":"Por una palabra que escuchó, el tonto está con dolores como una mujer que va a dar a luz."
,"12":"El secreto es insoportable para las entrañas del tonto: para él es como una flecha enterrada en el muslo."
,"13":"Conversa con tu prójimo, tal vez no ha hecho nada, y si lo ha hecho, no lo hará más."
,"14":"Conversa con tu prójimo, tal vez no ha dicho nada, y si lo ha dicho, no volverá a decirlo."
,"15":"Conversa con tu prójimo, porque a menudo no son más que calumnias: no creas todo lo que se cuenta."
,"16":"Sucede que uno resbala sin mala intención; ¿quién no ha pecado nunca con su lengua?"
,"17":"Conversa con tu prójimo antes de llegar a las amenazas: luego te atendrás a la Ley del Altísimo."
,"20":"El temor del Señor es lo sumo de la sabiduría; en toda sabiduría se da la práctica de la Ley."
,"22":"Saber hacer el mal no es sabiduría; ella está ausente de los designios de los pecadores."
,"23":"Hay una forma de habilidad que es odiosa: es locura, pues no tiene sabiduría."
,"24":"Más vale tener un espíritu limitado y temer al Señor que ser hábil en faltar a la Ley."
,"25":"Hay una habilidad que sólo lleva a la injusticia: desfigurar las cosas pretendiendo imponer el derecho."
,"26":"Se hace la víctima, camina doblado bajo el peso, pero en el fondo es pura comedia."
,"27":"Se tapa el rostro y se hace el sordo, pero, cuidado, pues a la primera distracción se aprovechará de ti."
,"28":"Otro no peca hasta que le faltan los medios; a la primera ocasión hará el mal."
,"29":"A un hombre se lo reconoce a simple vista, en la cara se reconoce a un hombre responsable."
,"30":"La manera como un hombre se vista, su manera de reírse y de caminar revelan lo que es."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Hay reprensiones inoportunas, puede ser sabio callarse."
,"2":"Más vale llamarle la atención a alguien que rumiar su cólera."
,"3":"El que confiesa sus errores evita sus consecuencias."
,"4":"Como un impotente que quisiera violar a una joven, así es el que quiere establecer la justicia por la violencia."
,"5":"Uno se calla y lo tienen por sabio, el otro no hace más que hablar y se hace odioso."
,"6":"Uno se calla porque no tiene qué responder, el otro se calla porque espera el momento."
,"7":"El hombre sabio se calla hasta el momento oportuno, el parlanchín y el torpe hablan a deshora."
,"8":"El que habla demasiado se torna odioso, el que pretende imponerse se hace odiar."
,"9":"Hay desgracias que se transforman en bien, hay gangas que se vuelven un mal."
,"10":"Hay generosidades que no producirán ningún provecho, hay otras que te producirán el doble."
,"11":"Uno es humillado porque recibió honores, otro levanta la cabeza después de haber sido humillado."
,"12":"Uno compra muchas cosas con poco dinero, otro paga por ellas siete veces más."
,"13":"El sabio se hace querer nada más que por sus palabras, mientras que los favores del tonto sólo le dejan pérdidas."
,"14":"El regalo del tonto de nada sirve porque espera sacar provecho."
,"15":"El da poco y pide mucho, y lo difunde por todas partes; presta hoy y te lo reclama mañana: ¡qué hombre más odioso!"
,"16":"El insensato dice: '¡No tengo amigos, nadie reconoce mis buenas obras."
,"17":"Esa gente come mi pan, y luego me calumnia!' ¡Cuántos se burlan de él! Y volverán a hacerlo."
,"18":"Más vale caerse al suelo por culpa de una piedra que por lo que uno ha dicho; la caída de los malvados no tardará en llegar."
,"19":"Una persona desagradable es como un cuento estúpido que personas mal educadas cuentan inoportunamente."
,"20":"De nada vale una palabra sabia en la boca del tonto, porque nunca la dice cuando conviene."
,"21":"Hay gente que no peca sólo por falta de medios: si se presenta la ocasión no tendrán empacho en hacerlo."
,"22":"Otro se pierde por falsa vergüenza, y se pierde para caerle bien a un hombre sin conciencia."
,"23":"Por falsa vergüenza sólo piensa en ganar su amistad: es en verdad un enemigo que se ganó inútilmente."
,"24":"Para cualquier persona la mentira es una mancha, pero la gente mal educada se acostumbra a ella."
,"25":"Más vale un ladrón que un mentiroso empedernido, pero uno y otro caminan a su perdición."
,"26":"La costumbre de mentir desacredita a cualquiera, es una vergüenza que no te dejará."
,"27":"El sabio se engrandece merced a sus palabras: el hombre de buen criterio agrada a los grandes."
,"28":"El que cultiva la tierra aumenta sus ganancias, el que complace a los grandes se hace olvidar las injusticias."
,"29":"Los agasajos y los regalos ciegan los ojos de los sabios. Es un bozal que impide que las críticas salgan de su boca."
,"30":"Sabiduría oculta y tesoro escondido, ¿para qué sirven?"
,"31":"Más vale ser tonto y ocultarlo, que ser sabio y ocultar su sabiduría."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Hijo mío, ¿pecaste? No vuelvas a hacerlo, y reza por tus culpas pasadas."
,"2":"Huye del pecado como lo harías de una serpiente: si te acercas, te muerde; tiene dientes de león y destruye vidas humanas."
,"3":"Toda maldad es una espada de doble filo, cuyas heridas son incurables."
,"4":"La arrogancia y el orgullo hacen caer al rico; la casa del orgulloso será destruida."
,"5":"La oración del pobre llega a oídos de Dios, éste no tardará en intervenir."
,"6":"El que detesta las amonestaciones toma el camino del pecado, el que teme al Señor se vuelve a él de todo corazón."
,"7":"Desde lejos reconocerás al charlatán, el hombre precavido le descubre pronto los puntos débiles."
,"8":"Edificar su casa con plata prestada es amontonar piedras para hacer su propia tumba."
,"9":"El partido de los pecadores no es más que un montón de leña seca: todos acabarán en llamas y fuego."
,"10":"El camino de los pecadores está despejado de piedras, pero va derecho al abismo de los muertos."
,"11":"El que cumple la Ley es dueño de sus pensamientos, el temor del Señor lo llevará a la sabiduría."
,"12":"Sin habilidad no se consigue nada, pero hay una habilidad que termina en amarguras."
,"13":"El conocimiento del sabio se expande como las aguas, sus consejos son una fuente de vida."
,"14":"La mente del tonto es como un cántaro trizado que no retiene nada de lo que aprende."
,"15":"Si un hombre instruido escucha una palabra sabia, la aprecia y le añade otra; si un bueno para nada la oye, le disgusta y se la echa a sus espaldas."
,"16":"La charlatanería del insensato pesa como un fardo; las palabras del sabio hacen bien."
,"17":"Los consejos del hombre sensato son solicitados por la asamblea, cada uno medita lo que dijo."
,"18":"La sabiduría para el insensato es una casa anticuada, pero el saber del ignorante no es más que palabras mal ajustadas."
,"19":"La instrucción molesta al imbécil como grillos en sus pies, como esposas en su mano derecha."
,"20":"El tonto ríe a carcajadas, mientras que el hombre hábil sonríe discretamente."
,"21":"El hombre sensato considera la instrucción como un adorno de oro, es un brazalete en su brazo derecho."
,"22":"El tonto entra sin más en una casa, el hombre que sabe actuar se presenta con discreción."
,"23":"El insensato se inclina desde la puerta para mirar adentro, el hombre bien educado se queda de pie afuera."
,"24":"Es falta de educación escuchar junto a las puertas, un hombre bien educado se avergüenza de hacerlo."
,"25":"Un cualquiera dirá cualquier cosa, el hombre sensato pesa sus palabras."
,"26":"El interior del tonto está todo en su boca; la boca del sabio es también parte de su interior."
,"27":"Cuando el impío maldice a su adversario, la maldición recae sobre él."
,"28":"El calumniador se ensucia a sí mismo, se hace odioso para los que lo rodean."
}`)
	CurrentBook.AddChapter(22, `{
"1":"El flojo se parece a una piedra embarrada, todo el mundo se ríe de su degradación."
,"2":"El flojo es como un montón de estiércol, el que lo tocó se sacude las manos."
,"3":"Un hijo mal educado es la vergüenza de su padre, si es una hija, será su humillación."
,"4":"Una hija juiciosa será un tesoro para su marido, la que se porta mal será el sufrimiento de su padre."
,"5":"Una hija que de nada se sonroja avergüenza tanto a su padre como a su marido, ambos la desprecian."
,"6":"Una palabra dicha en mal momento es como música en momentos de duelo, pero los azotes y las sabias reprensiones convienen en cualquier momento."
,"9":"Instruir a un tonto es como pegar de nuevo un cántaro roto o despertar a un hombre muerto de sueño."
,"10":"Hablar a un tonto es como hablar a un hombre adormecido; cuando hayas terminado preguntará: '¿De qué se trata?'"
,"11":"Llora por un muerto: perdió la luz; llora por un tonto: perdió el espíritu. Laméntate menos por un muerto, porque encontró el descanso, pero la vida de un tonto es peor que la muerte."
,"12":"Por un muerto son siete días de duelo, pero por el tonto y el impío, son todos los días de su vida."
,"13":"No alargues la conversación con un insensato, no viajes con un hombre estúpido. Ten cuidado con él para que no tengas problemas: sus excesos podrían salpicarte. Apártate de él, estarás en paz en vez de cansarte con sus estupideces."
,"14":"¿Hay algo más pesado que el plomo? ¿Cómo se llama? ¡Tonto!"
,"15":"La arena, la sal y una masa de hierro son más soportables que un hombre sin inteligencia."
,"16":"Una techumbre de madera bien ensamblada y clavada no se suelta con un temblor, el que se decidió después de madura reflexión no se conmoverá en la adversidad."
,"17":"Una decisión basada en la reflexión aguanta tanto como el estuco en un muro firme."
,"18":"Un cerco de madera en una altura no resiste al viento; lo mismo el insensato frente a sus propios terrores: cualquier miedo lo domina."
,"19":"Pégale a un ojo, brotarán lágrimas, golpea una conciencia, se le hará la luz."
,"20":"Quien tira piedras a los pájaros, los espanta; quien insulta a un amigo romperá la amistad."
,"21":"Si has desenvainado la espada contra tu amigo, no te desesperes: puedes volver."
,"22":"Si has hablado duramente, no temas: es posible la reconciliación. Pero si se trata de ultrajes, de desprecios, de un secreto traicionado o de un golpe traicionero, cualquier amigo se irá."
,"23":"Gánate la confianza de tu prójimo mientras sea pobre, y si llega a ser rico disfrutarás con él de sus bienes. Sé fiel a él en los días difíciles, y cuando le llegue una herencia, la compartirás con él."
,"24":"Humo y vapor se ven antes que las llamas: las injurias preceden a la sangre derramada."
,"25":"No tendré vergüenza de proteger a mi amigo, no me esconderé de él;"
,"26":"y si por culpa de él me sucede algo malo, todos los que lo sepan desconfiarán de él."
,"27":"¿Quién pondrá una cerradura en mi boca, un buen candado en mis labios para que no me hagan caer y no me condene mi lengua?"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Señor, Padre y dueño de mi vida, no me abandones al capricho de mis labios, no permitas que caiga por culpa de mis palabras."
,"2":"¿Quién domará con el látigo mis pensamientos, e impondrá a mi entendimiento la disciplina de la sabiduría, sin perdonar mis extravíos ni dejar pasar mis pecados?"
,"3":"Porque de otro modo repetiría mis errores, se reproducirían mis pecados y caería en manos de mis adversarios para alegría de mis enemigos."
,"4":"Señor, Padre y Dios de mi vida, no permitas que mi mirada sea altanera,"
,"5":"y presérvame de la codicia."
,"6":"Que no se apoderen de mí lo placeres ni el sexo; ¡no me entregues a mis pasiones impuras!"
,"7":"Hijos míos, aprendan a controlar su lengua; ¡el que está atento a ello no será tomado por sorpresa!"
,"8":"El pecador quedará atrapado en sus propias palabras, ¡el mendigo y el orgulloso caerán en sus redes!"
,"9":"No digas a cada rato: '¡Lo juro!', ni tomes continuamente al Altísimo por testigo."
,"10":"Porque así como el sirviente al que se lo vigila de cerca no se escapa de la paliza, así también el que jura e invoca continuamente su nombre no se hallará sin pecado."
,"11":"Quien multiplica los juramentos acumula las transgresiones: el castigo no se alejará de su casa. Si falta a ellos por negligencia, ya pecó; si lo hace conscientemente, es doble pecado. El que hizo un juramento falso no será perdonado: su casa se llenará de desgracias"
,"12":"Hay conversaciones que merecen la muerte: son inaceptables entre los descendientes de Jacob. Los verdaderos fieles se abstienen de ellas y no se revuelcan en el pecado."
,"13":"No acostumbres tu boca a las groserías: sería pecar con palabras."
,"14":"¡Acuérdate de tu padre y de tu madre cuando te sientes en medio de los grandes, no sea que te descuides en su presencia y te conduzcas como un tonto! Desearías entonces no haber nacido y maldecirías el día de tu nacimiento."
,"15":"El hombre que está acostumbrado a insultar no se corregirá en toda su vida."
,"16":"Dos clases de hombres multiplican los pecados, y una tercera provoca la cólera del Señor:"
,"17":"La pasión que quema como un fuego ardiente no se apagará antes de ser satisfecha. El hombre que comete la impureza en su cuerpo no se detendrá hasta que ese fuego lo devore. Para el hombre impúdico cualquier satisfacción es buena, no se calmará hasta que muera."
,"18":"El hombre que es infiel a su esposa se dice a sí mismo: '¿Quién me verá? Las sombras me rodean, los muros me ocultan, nadie me mira; ¿por qué inquietarme? El Altísimo no anotará mis pecados.'"
,"19":"¡Sólo teme la mirada de los hombres, olvidándose de los ojos del Señor que son mil veces más luminosos que el sol, que observan todas nuestras acciones y que penetran hasta en los lugares más secretos!"
,"20":"Tiene presente a todas las cosas antes de crearlas, y lo estarán aun cuando desaparezcan."
,"21":"Tal hombre será pillado donde menos se lo piense, y será castigado en la plaza."
,"22":"Lo mismo le ocurrirá a la mujer que engaña a su marido y le da un heredero concebido de un extraño."
,"23":"En primer lugar, desobedeció a la Ley del Altísimo, luego pecó contra su marido; y, en tercer lugar, se manchó con un adulterio, teniendo hijos de un extraño."
,"24":"Esa mujer será llevada ante la asamblea y se investigará el asunto."
,"25":"Sus hijos serán plantas sin raíces, sus ramas no producirán frutos."
,"26":"El nombre de su madre pasará a ser un insulto, y nunca se borrará su vergüenza."
,"27":"Así los demás sabrán que lo único que vale es el temor del Señor, y que nada es más dulce que cumplir sus mandamientos."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Mira cómo la sabiduría se alaba y se elogia a sí misma en medio de su pueblo,"
,"2":"cómo toma la palabra en la Asamblea del Altísimo y se glorifica delante del Todopoderoso:"
,"3":"Salí, dice, de la boca del Altísimo, y como una niebla cubrí la tierra."
,"4":"Mi morada está en lo más alto del cielo, mi trono en la columna de nube."
,"5":"Yo sola di la vuelta a la bóveda del cielo y recorrí el fondo de los océanos."
,"6":"Tomé posesión de las olas del mar; míos son la tierra, todos los pueblos y todas las naciones."
,"7":"Busqué entre todos ellos un lugar donde detenerme: ¿en qué casa, en qué propiedad instalaré mi refugio?"
,"8":"Entonces el Creador del universo me dio una orden, el que me creó me indicó dónde levantar mi tienda. Me dijo: '¡Instálala en Jacob, que Israel sea tu propiedad!'"
,"9":"Desde el principio el Señor me había creado, antes que existiera el tiempo, y no pasaré con el tiempo."
,"10":"Celebro en su presencia la liturgia de su Santa Morada, y es por eso que me establecí en Sión."
,"11":"Me hizo descansar en la ciudad amada, en Jerusalén ejerzo mi poder."
,"12":"Eché raíces en el pueblo glorificado por el Señor, en su dominio que es su herencia."
,"13":"Crecí como un cedro del Líbano, como el ciprés en las laderas del Hermón."
,"14":"Crecí como las palmeras de Engadí, como los adelfales de Jericó, como un magnífico olivo en la llanura."
,"15":"Exhalé mi perfume como el cinamomo, como las plantas olorosas; expandí mi buen olor como las savias aromáticas, como el bálsamo y la mirra exquisita, como el humo del incienso en el Santuario."
,"16":"Extendí mis ramas como el pino: ellas se llaman Gloria y Gracia."
,"17":"Florecí como una vid, con flores agradables a la vista que dieron frutos de gloria y riqueza."
,"19":"Vengan a mí los que me desean y sáciense con mis frutos."
,"20":"El recuerdo que tendrán de mí es más dulce que la miel, poseerme es más agradable que un panal."
,"21":"Los que me comen tendrán todavía hambre, y los que me beben tendrán aún sed."
,"22":"El que me escucha no se arrepentirá, los que me cultivan no pecarán."
,"23":"Todo esto no es más que el Libro de la Alianza del Dios Altísimo, es la Ley que nos mandó Moisés y que es el tesoro de las asambleas de Jacob."
,"25":"De esta Ley brotan los ríos de la sabiduría, semejantes al Pisón o al Tigris en la estación de las frutas."
,"26":"De ella desborda el saber cual crecida del Eufrates o del Jordán en época de cosecha;"
,"27":"de ella salen las aguas de la instrucción como las ondas del Nilo o como el Guijón en días de vendimia."
,"28":"El primero que la encontró no le verá el fin, el último que llegó no la agotará;"
,"29":"porque sus pensamientos son más vastos que el mar y sus proyectos abarcan más que el gran océano."
,"30":"Yo, por mi parte, no era más que un canalito del río, un arroyo que se pierde en un jardín."
,"31":"Pero pensé: 'Voy a regar mi jardín, voy a rociar mis flores' ¡Y he aquí que mi arroyo se convirtió en un río, y mi río, en un mar!"
,"32":"¡Brille mi doctrina como la aurora y extienda su luz a lo lejos!"
,"33":"Propáguense mis lecciones como palabras proféticas: porque quiero dejarlas a las futuras generaciones."
,"34":"Vean: no he trabajado sólo para mí, sino para todos los que buscan la sabiduría."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Hay tres cosas que hallo hermosas, y que son hermosas tanto para Dios como para los hombres: la unión entre hermanos, la amistad entre prójimos y la perfecta armonía entre marido y mujer."
,"2":"Hay tres clases de personas que aborrezco y cuya presencia no la soporto: un pobre orgulloso, un rico que miente y un viejo vicioso y tonto."
,"3":"Si no has juntado nada en tu juventud, ¿con qué te las arreglarás en tu vejez?"
,"4":"Es bonito ver a un anciano que tiene criterio, un anciano que sabe aconsejar."
,"5":"Es bonito ver a un anciano que es sabio, a un hombre estimado que comprende y sabe decidir."
,"6":"Una rica experiencia es la corona de los ancianos; pueden sentirse orgullosos si tienen el temor del Señor."
,"7":"Hay nueve cosas que considero hermosas, y a ésas añadiría una décima: el que se siente feliz con sus hijos; el que ve antes de morir la ruina de sus enemigos."
,"8":"Feliz también el hombre que vive con una mujer juiciosa; que no ara con un burro y un buey juntos; que no ha cometido errores al hablar; que no sirve a un patrón indigno de él."
,"9":"Feliz el que ha conseguido un buen criterio, y que sabe hacerse oír."
,"10":"¡Qué grande es el que encuentra la sabiduría! Pero no supera al que teme al Señor."
,"11":"El temor del Señor está por encima de todo: ¿con quién comparar al que lo posee?"
,"13":"¡Cualquier herida, menos la del corazón! ¡Cualquier maldad, pero que no provenga de una mujer!"
,"14":"¡Cualquier penuria pero no por culpa de un adversario! ¡Cualquier sentencia, pero no la dictada por una persona enemiga!"
,"15":"No hay cabeza más temible que la de una serpiente, ni peor furor que el de una persona enemiga."
,"16":"Estaría más contento con un león o un dragón que con una mujer malvada."
,"17":"La maldad de la mujer le desfigura el rostro, éste se torna más sombrío que él de un oso."
,"18":"Si su marido parte a reunirse con sus vecinos, no podrá dejar de suspirar."
,"19":"Cualquier maldad es poca cosa al lado de la maldad de una mujer: ¡ojalá que caiga sobre ella el castigo de los pecadores!"
,"20":"Como una cuesta arenosa para los pies de un anciano, así es la mujer habladora para un marido de buen carácter."
,"21":"¡No te dejes seducir por la belleza de una mujer, ni la desees!"
,"22":"Mal humor, impaciencia, reproches... es lo que sucede cuando la mujer manda al marido."
,"23":"Corazón apenado, cara triste y herida oculta: así sucede con la mujer malvada. Brazos caídos y rodillas vacilantes: ¡ella no hace feliz a su marido!"
,"24":"Por la mujer comenzó el pecado: por su culpa morimos todos."
,"25":"¡Detén inmediatamente la fuga de agua!; no dejes que una malvada mujer se imponga."
,"26":"Si no anda como le dices, ¡sepárate de ella!"
}`)
	CurrentBook.AddChapter(26, `{
"1":"Feliz el marido de una buena mujer: el número de sus días se duplicará."
,"2":"Una mujer valiente es la alegría de su marido, éste vivirá en paz todos los días de su vida."
,"3":"Una buena esposa es como el premio mayor de la lotería, le tocará en suerte al que teme al Señor."
,"4":"Rico o pobre tendrá contento el corazón; en todo momento se verá la felicidad en su rostro."
,"5":"Hay tres cosas que temo y una cuarta que me espanta: una calumnia que se expande por el vecindario, una muchedumbre amotinada y una acusación falsa; todo eso es peor que la muerte."
,"6":"Pero la mujer que tiene celos de otra es una angustia, un dolor íntimo, su lengua es un azote que no perdona a nadie."
,"7":"La mujer malvada es como un yugo suelto: poner la mano en él es tan arriesgado como agarrar un escorpión."
,"8":"Una mujer bebedora es un gran escándalo, no podrá remediar su deshonor."
,"9":"Una mujer sin pudor se reconoce en sus ojos, en su mirada descarada."
,"10":"Mantén a raya a una muchacha provocadora, no sea que se aproveche de tu complacencia."
,"11":"Ten cuidado con seguir a una mujer seductora; no te hagas ilusiones: sólo quiere ganarte."
,"12":"El viajero sediento abre la boca y toma cualquier agua que encuentre: ella también se coloca frente a cualquier palo y a cualquier flecha abre su aljaba."
,"13":"La gracia de una esposa regocija a su marido, pero su saber actuar lo reconforta hasta la médula de sus huesos."
,"14":"Una mujer que sabe callarse es un don del Señor, nada es comparable con la que es bien educada."
,"15":"Una mujer modesta es doblemente encantadora, la que es casta es un tesoro inestimable."
,"16":"Así como el sol se levanta sobre las montañas del Señor, así es el encanto de una buena esposa en una casa bien ordenada."
,"17":"Como la lámpara que brilla en un candelabro sagrado, así es un hermoso rostro en un cuerpo armonioso."
,"18":"Como columnas de oro en una base de plata, así son unas lindas piernas en unos talones bien plantados."
,"28":"Hay dos cosas por las que me aflijo y una tercera que me causa ira: un guerrero reducido a la miseria, personas criteriosas que son despreciadas, el que pasa de una vida correcta al pecado; el Señor lo destina a morir por la espada."
,"29":"Es difícil para un comerciante no estafar a los demás; un comerciante no estará libre de pecado."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Muchos han pecado por amor al dinero, el que trata de enriquecerse se hace el desentendido."
,"2":"Así como se introduce un palo entre dos piedras juntas, así se inserta el pecado entre la compra y la venta."
,"3":"El que no se apega firmemente al temor del Señor, verá pronto su casa por el suelo."
,"4":"Al sacudir el cedazo caen las mugres, y lo mismo los defectos del hombre cuando se pone a hablar."
,"5":"La prueba para los cántaros de arcilla es el horno; para un hombre es su manera de razonar."
,"6":"Los frutos de un árbol mostrarán si fue bien cultivado; de igual modo las palabras de un hombre dan a conocer su fondo."
,"7":"No elogies a una persona mientras no se exprese: ésa es la prueba para todo hombre."
,"8":"Si procuras la justicia, la lograrás; te revestirás de ella como de un manto de fiesta."
,"9":"Los pájaros hacen sus nidos junto a sus semejantes, la verdad retorna a los que la practican."
,"10":"El león espía a su presa, y lo mismo el pecado a los que hacen el mal."
,"11":"La conversación de un hombre de Dios tiene siempre su sabiduría; el insensato en cambio es cambiante como la luna."
,"12":"Sé avaro de tu tiempo con los que no entienden, dalo ampliamente a los que reflexionan."
,"13":"La conversación de los tontos fastidia, necesitan obscenidades para reírse."
,"14":"Un lenguaje lleno de imprecaciones pone los nervios de punta, ese género de discusiones hace que uno se tape los oídos."
,"15":"Una pelea entre orgullosos hace que la sangre llegue al río; sus injurias no se pueden oír."
,"16":"El que revela un secreto hace que no se le crea, no encontrará más amigos según su corazón."
,"17":"Ama a tu amigo y permanécele fiel; si revelaste sus secretos no vayas más en pos de él;"
,"18":"es como si hubieras perdido a uno de tus parientes: su amistad murió para ti."
,"19":"Dejaste que escapara el ave de tus manos: tu amigo se fue, es inútil salir en su búsqueda."
,"20":"No lo persigas: como la gacela que se libera de su trampa, puso distancia entre ambos."
,"21":"Se puede vendar una herida, reconciliarse después de las injurias, pero revelar secretos no tiene vuelta."
,"22":"El que guiña un ojo está tramando algo malo, y nadie lo apartará de eso."
,"23":"Delante de ti su boca es melosa, aplaude todo lo que tú dices, pero luego habla lo contrario y tergiversa tus palabras para perderte."
,"24":"Hay muchas cosas que detesto, pero nada tanto como a él: hasta el Señor lo aborrece."
,"25":"El que tira una piedra al cielo, le caerá en la cabeza, y el que da un golpe a traición se herirá de rebote."
,"26":"El que cava una fosa se caerá en ella, y el que tiende una emboscada, quedará atrapado en ella."
,"27":"El que comete malas acciones, éstas le repercutirán y de donde menos se lo piensa."
,"28":"Los soberbios son buenos para el insulto y la burla, pero la justicia los aguarda como león al acecho."
,"29":"Los que gozan haciendo caer a los fieles, quedarán atrapados en la red. El dolor se apoderará de ellos mucho antes de que mueran. No guardes rencor"
,"30":"Odio y cólera son dos cosas abominables en las que se destaca el pecador."
}`)
	CurrentBook.AddChapter(28, `{
"1":"El que se venga experimentará la venganza del Señor: él le tomará rigurosa cuenta de todos sus pecados."
,"2":"Perdona a tu prójimo el daño que te ha hecho, así cuando tú lo pidas, te serán perdonados tus pecados."
,"3":"¡Cómo! ¿Un hombre guarda rencor a otro hombre y le pide a Dios que lo sane?"
,"4":"No tiene misericordia con otro hombre, su semejante, y ¿suplica por sus propios pecados?"
,"5":"Si él, débil y pecador, guarda rencor, ¿quién le conseguirá el perdón?"
,"6":"Acuérdate de tu fin y déjate de odiar; piensa en la muerte, en la descomposición, y observa los mandamientos."
,"7":"Acuérdate de los mandamientos y no tengas rencor a tu prójimo; piensa en la alianza del Altísimo, y olvida la ofensa."
,"8":"Mantente alejado de las peleas y cometerás menos pecados, porque el hombre colérico enciende las peleas."
,"9":"El pecador siembra la perturbación entre los amigos, y hace cundir las desavenencias entre los que viven en paz."
,"10":"El calor del fuego depende del combustible, la pelea aumenta según las pasiones: mientras más poderoso es un hombre más se enoja; mientras más rico más monta en cólera."
,"11":"Una discusión imprevista enciende la mecha, una pelea repentina hace correr sangre."
,"12":"Sopla una llamita, y el fuego arde; escúpele y se apaga: ¡ambas dependen de tu boca!"
,"13":"Maldito el calumniador y su manera doble de hablar: ha contribuido a que perezcan muchas personas que vivían en paz."
,"14":"Las insinuaciones de terceras personas los demolieron hasta dispersarlos en una y otra nación; destruyeron además ciudades poderosas y derribaron grandes familias."
,"15":"La calumnia hizo que se repudiara a valientes mujeres y las privó del fruto de sus trabajos."
,"16":"El que le presta atención no tendrá más reposo, ni vivirá más en paz."
,"17":"Un latigazo deja una herida, una lengua suelta rompe los huesos."
,"18":"Muchos cayeron por la espada, pero más numerosos aún son las víctimas de la lengua."
,"19":"Feliz el hombre que ha permanecido fuera de su alcance y no conoció su furor, que no soportó su yugo ni arrastró sus cadenas;"
,"20":"porque su yugo es un yugo de hierro, y sus cadenas, cadenas de bronce."
,"21":"La lengua produce una muerte miserable; ¡más vale descender a la morada de abajo!"
,"22":"Pero ella no vencerá a los fieles; su llama no los quemará."
,"23":"A los que abandonan al Señor, a ésos sí que los atrapará. Arderá en ellos sin extinguirse jamás, se arrojará sobre ellos como un león, y los desgarrará como una pantera."
,"24":"Tú rodeas tu campo con una cerca de espinas, y pones bajo llave tu plata y tu oro;"
,"25":"para tus palabras necesitas una balanza y pesas. Colócale a tu boca puerta y candado,"
,"26":"no sea que te haga tropezar y caigas ante tu contrario."
}`)
	CurrentBook.AddChapter(29, `{
"1":"El que sabe de compasión presta a su prójimo, el que acude en su ayuda observa los mandamientos."
,"2":"Presta a tu prójimo si lo necesita; por tu parte, págale a tu prójimo en el plazo acordado."
,"3":"Mantén tu palabra, sé leal con tu prójimo, y en cualquier momento tendrás lo que necesitas."
,"4":"Muchos consideran el préstamo que se les hace como un regalo, así ponen en apuros a los que los ayudaron."
,"5":"Mientras no hayan recibido, besarán las manos del prójimo, se harán los humildes pensando en lo que él tiene; pero en el momento de la devolución le piden una prórroga, o le pagan con palabras hirientes, o se quejan de la mala situación."
,"6":"Aunque puedan reembolsarle, el acreedor tendrá suerte si recupera la mitad. En caso contrario, se habrán apoderado de su dinero y no habrá ganado más que un enemigo; éste le pagará con maldiciones e insultos, con desprecios en vez de agradecimientos."
,"7":"Mucha gente se niega a prestar, no por maldad sino por miedo a que los despojen sin motivo."
,"8":"Sé, sin embargo, generoso con el prójimo, no lo dejes esperando tu limosna."
,"9":"Conforme a lo que está mandado, cuida del pobre; fíjate qué es lo que necesita y no lo despaches con las manos vacías."
,"10":"Es mejor que pierdas tu dinero por un hermano o por un amigo que dejarlo que se oxide inútilmente bajo una piedra."
,"11":"Invierte tu tesoro siguiendo los mandamientos del Altísimo, esto te será más útil que el oro."
,"12":"Repleta tus graneros con tus generosidades, éstas te preservarán de la desgracia; combatirán por ti frente al enemigo,"
,"13":"mejor que un sólido escudo o una pesada lanza."
,"14":"El hombre de bien sirve de aval a su prójimo; tendría que haber perdido toda la vergüenza para abandonarlo."
,"15":"No te olvides del favor que te hizo tu aval; se arriesgó por ti."
,"16":"Pero el pecador malgasta los bienes de su fiador; es un ingrato que se olvida del que lo salvó."
,"17":"Una garantía arruinó a mucha gente acomodada; las sacudió como espuma del mar."
,"18":"Forzó a expatriarse a hombres poderosos, convirtiéndolos en vagabundos entre las naciones extranjeras."
,"19":"El pecador sirve de aval cuando cree que puede sacar provecho, pero lo que va a conseguir serán puros procesos."
,"20":"Acude en ayuda de tu prójimo en la medida de tus posibilidades, pero trata de no caerte."
,"21":"Lo indispensable para vivir es: el agua, el pan, la ropa y una casa donde vivir."
,"22":"Más vale vivir como pobre bajo cuatro tablas propias que comer como un príncipe en casa extraña."
,"23":"Conténtate con lo poco o mucho que tengas: eso vale más que oír las reprensiones de alguien que te da alojamiento."
,"24":"Es una triste vida ir de casa en casa; pues donde estés no te atreverás a abrir la boca."
,"25":"Aunque tú seas el que corre con los gastos de la comida y bebida, oirás las palabras amargas de un ingrato:"
,"26":"'¡Ven para acá, allegado, prepara la mesa; si tienes algo, dame de comer!'"
,"27":"O peor aún: '¡Sal de ahí, allegado, sucedió algo inesperado: Mi hermano acaba de llegar y necesito la casa!'"
,"28":"A una persona sensata se le hace duro que le saquen en cara la hospitalidad y que lo traten como un deudor."
}`)
	CurrentBook.AddChapter(30, `{
"1":"El que ama a su hijo no le escatima los azotes, más tarde ese hijo será su consuelo."
,"2":"El que educa bien a su hijo, tendrá sus satisfacciones; se sentirá orgulloso de él delante de sus parientes."
,"3":"El que instruye a su hijo será envidiado por su enemigo; y se alegrará de él delante de sus amigos."
,"4":"Cuando su padre desaparezca, será como si no hubiera muerto, porque dejará tras de sí a otro como él."
,"5":"Durante su vida, su felicidad era verlo, cuando llegue la muerte no sentirá pena."
,"6":"Porque deja a los suyos un defensor frente a sus enemigos, y quién devuelva los favores a sus amigos."
,"7":"El que mima a su hijo tendrá que curar sus heridas; tendrá que ceder al más leve de sus gritos."
,"8":"Un caballo chúcaro no se puede montar, un hijo dejado a sus caprichos se vuelve insolente."
,"9":"¿Quieres mimar a tu hijo?; un día te hará temblar; juguetea con él, te causará tristeza."
,"10":"No te rías con él si no quieres un día afligirte con él y tener al fin que rechinar los dientes."
,"11":"No le des rienda suelta en su juventud,"
,"12":"Pégale en las costillas cuando sea pequeño, no sea que se empecine y se te rebele."
,"13":"Educa bien a tu hijo, lábralo, o si no su mala conducta se volverá en tu contra."
,"14":"Más vale un pobre con buena salud y vigoroso que un rico que sufre en su cuerpo."
,"15":"La salud y una contextura firme valen más que todo el oro del mundo, y un cuerpo robusto más que una inmensa fortuna."
,"16":"No hay riqueza más grande que la salud del cuerpo, ni placer superior a la alegría de vivir."
,"17":"Más vale la muerte que una vida miserable, y el descanso eterno más que una enfermedad incurable."
,"18":"Dejar ofrendas de alimentos en las tumbas es presentar cosas buenas a una boca cerrada;"
,"19":"lo mismo pasa con la ofrenda a un ídolo: ¿para qué, si ni come ni siente? Eso le pasa a un hombre perseguido por el Señor:"
,"20":"ve la comida y suspira; es como un hombre castrado que abraza a una joven y gime."
,"21":"No te dejes llevar por la tristeza, ni dominar por tus preocupaciones."
,"22":"Un corazón alegre mantiene al hombre con vida; la alegría prolonga su existencia."
,"23":"¡Ea, vamos! Diviértete y alegra tu corazón; echa lejos de ti la tristeza, porque la tristeza perdió a muchos y no sirve para nada."
,"24":"La envidia y la ira acortan la vida, las preocupaciones hacen envejecer antes de tiempo."
,"25":"El que tiene un corazón alegre tiene buen apetito; lo que come lo aprovecha."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Las vigilias que exige la riqueza hacen perder peso, las preocupaciones que trae consigo espantan el sueño."
,"2":"Vigilias y preocupaciones impiden dormir, un grave problema quita el sueño."
,"3":"El rico se sacrifica para amasar una fortuna, cuando deja de hacerlo es para gozar de su lujo."
,"4":"El pobre se sacrifica para sobrevivir, si deja de hacerlo le sobreviene la indigencia."
,"5":"El que ama el oro no estará libre de pecados, el que busca la ganancia se dejará llevar por mal camino."
,"6":"Muchos fracasaron por culpa del oro, la ruina les salió al encuentro."
,"7":"El oro bota al suelo a los que lo hacen su dios; los que no piensan en eso se dejan conquistar por él."
,"8":"¡Feliz el rico que fue hallado sin falta, que no corrió tras el oro!"
,"9":"¿Conocen a uno? De él diremos: '¡Feliz es ese hombre, pues dio al pueblo un ejemplo admirable!'"
,"10":"¿Quién pasó por este examen y fue reconocido sin fallas? Puede sentirse orgulloso de eso. ¿Quién tuvo los medios para pecar y no cometió falta, quién podía hacer el mal y no lo hizo?"
,"11":"Su fortuna le durará, contarán en la asamblea sus obras generosas."
,"12":"Si estás sentado junto a una magnífica mesa, no te quedes con la boca abierta exclamando: '¡Qué abundancia!'"
,"13":"Acuérdate que la avidez es un mal. ¿Hay peor criatura que un ojo ávido? Por eso, todo lo que ve lo hace llorar."
,"14":"No extiendas la mano a todo lo que ves, no te precipites sobre la bandeja."
,"15":"Piensa que los demás están en la misma situación tuya, actúa en todo con reflexión."
,"16":"Come lo que se te presenta como un hombre educado y no como un glotón, lo que te haría odioso."
,"17":"Sé el primero en detenerte, es cuestión de educación; no seas tragón, pues molestarías."
,"18":"Si estás sentado con varias personas, no seas el primero en servirte."
,"19":"Un poco le basta a un hombre bien educado; una vez en su cama, no le costará respirar."
,"20":"Un estómago liviano produce un sueño sano; uno se levanta temprano y con la cabeza despejada. En cambio el insomnio, los vómitos y las diarreas esperan al hombre glotón."
,"21":"Si te has visto obligado a comer mucho, levántate, anda a vomitar al excusado y te sentirás aliviado."
,"22":"Hijo mío, óyeme, no te rías de mis consejos; al final, verás que te decía la verdad. Sé moderado en todo lo que hagas y no tendrás ninguna enfermedad."
,"23":"Cuando el anfitrión hace las cosas regiamente, lo felicitan y hablan con razón de su generosidad."
,"24":"Pero si es mezquino, todo el mundo lo critica y habla con lujo de detalles de su mezquindad."
,"25":"No juegues a ser fuerte con el vino, porque el vino ha perdido a muchos."
,"26":"El horno pone a prueba el temple del acero, el vino pone a prueba los corazones, empujando a los orgullosos a la pelea."
,"27":"Para el hombre el vino es la vida, siempre que lo tome con moderación. ¿Qué es una vida donde falta el vino? Fue creado para alegrar a los hombres."
,"28":"Alegría del corazón y bienestar para todo el ser, eso es el vino que se toma a sus horas y con moderación."
,"29":"Malestar para todo el ser, eso es el vino cuando se toma en exceso por vicio o por una bravuconada."
,"30":"La ebriedad excita a los insensatos, pero lo pagarán, pues les quita las fuerzas y atrae los golpes."
,"31":"En un banquete bien rociado, no molestes a tu vecino; no lo desprecies si está alegre."
,"32":"No es el momento para insultarlo ni para acosarlo con cuestiones de dinero."
}`)
	CurrentBook.AddChapter(32, `{
"1":"¿Te eligieron para que organices un banquete? No te des grandes ínfulas. Compórtate con los demás como uno de ellos; preocúpate de ellos y después anda a sentarte en tu lugar."
,"2":"Cuando hayas hecho todo lo necesario, volverás a tu asiento para alegrarte con ellos. Entonces recibirás la corona por tu buena organización."
,"3":"Habla, si eres anciano, eso te corresponde; pero di cosas que tengan sentido, y no impidas la música."
,"4":"Cuando la están escuchando, no es el momento para discursos, no pases por sabio en el momento inadecuado."
,"5":"Un concierto en medio de un banquete bien regado, es una piedra preciosa engastada en una joya de oro."
,"6":"El canto de los músicos le viene a la dulzura del vino como una esmeralda a un brazalete de oro."
,"7":"Habla, tú que eres joven, si te lo piden, pero no más de dos veces, y sólo para responder."
,"8":"Abrevia tu discurso, di mucho en pocas palabras. Demuestra que sabes, pero sobre todo que sabes callar."
,"9":"Si estás con personas importantes, no las trates de igual a igual; trata de no conversar mientras otro habla."
,"10":"El relámpago se siente antes que el trueno: lo mismo la disposición para escuchar al hombre modesto."
,"11":"Levántate de la mesa a tiempo, no te demores. Llega pronto a tu casa sin entretenerte por el camino."
,"12":"Allí intercambiarás ideas, harás lo que te guste, pero sin pecar con palabras indecentes."
,"13":"Por último bendecirás al que te hizo y te colma con sus bienes."
,"14":"El que teme al Señor acepta sus lecciones, los que lo buscan desde la aurora recibirán buena acogida."
,"15":"El que se dedica a la Ley, ésta lo llenará; el que sólo disimula, ésta lo hará caer."
,"16":"El Señor recibirá a los que le temen, sus buenas acciones brillarán como la luz."
,"17":"El pecador no acepta la reprensión, siempre justifica lo que le gusta."
,"18":"El hombre prudente no descuida la reflexión; en cambio el orgulloso indiferente no tiene miedo a nada."
,"19":"No hagas nada sin haber reflexionado, y no tendrás que arrepentirte de tus actos."
,"20":"No tomes el camino áspero y no te tropezarás con las piedras."
,"21":"No te fíes de un camino bien pavimentado:"
,"22":"ten cuidado aun con tus hijos."
,"23":"En todo lo que hagas, actúa según tu conciencia: así observarás los mandamientos."
,"24":"El que confía en la Ley pone atención en los mandamientos; el que obedece al Señor no sufrirá daño alguno."
}`)
	CurrentBook.AddChapter(33, `{
"1":"La desgracia no alcanza al que teme al Señor; si le toca una prueba se verá libre de ella."
,"2":"El hombre sabio no odia la Ley; el que la sigue sólo en apariencias es como un barco en medio de la tempestad."
,"3":"El hombre inteligente pone su confianza en la Ley; para él la Ley es digna de fe como una respuesta divina."
,"4":"Prepara tu discurso y serás escuchado; hazte una buena síntesis y luego habla."
,"5":"Los sentimientos del tonto son como rueda de carreta, sus razonamientos son como veleta."
,"6":"Un amigo burlón es como potro en celo, relincha con cualquier jinete."
,"7":"¿Por qué un día será más importante que otro cuando todos los días reciben la luz del sol?"
,"8":"Una decisión del Señor los ha hecho diferentes, El fue quien dispuso las fiestas y las estaciones."
,"9":"Eligió y santificó a algunos de ellos, a los demás los dejó para hacer número."
,"10":"También los hombres fueron sacados de la tierra, de ésta fue formado Adán."
,"11":"El Señor, sin embargo, en su sabiduría, los separó, poniéndolos en diferentes caminos."
,"12":"A algunos los bendijo y exaltó, los consagró y tomó a su servicio; a otros los maldijo y humilló, hizo que perdieran su lugar."
,"13":"Así como el barro está en manos del alfarero que lo moldea a su voluntad, así también están los hombres en las manos del que los ha hecho: trata a cada cual como mejor lo estima."
,"14":"De un lado, el mal, y del otro el bien; de un lado, la muerte, y del otro la vida: y de igual modo frente al fiel está el pecador."
,"15":"Miren por todas partes las obras del Altísimo; siempre van de a dos, una oponiéndose a la otra."
,"16":"En cuanto a mí, me afané después de todos los demás, semejante al que rebusca detrás de los vendimiadores."
,"17":"Pero por la bendición del Señor los alcancé y llené con mis racimos el lagar."
,"18":"Entiendan que mis esfuerzos no fueron sólo para mí, sino para todos los que buscan el saber."
,"19":"¡Oigan, pues, ustedes los grandes del pueblo; presten atención, ustedes que presiden la asamblea!"
,"20":"¡Ni a tu hijo, ni a tu mujer, ni a tu hermano ni a tu amigo: a nadie des poder sobre ti mientras vivas! No des tus bienes a otro; podrías arrepentirte y tener que reclamárselos."
,"21":"Mientras te quede un soplo de vida, no entregues a nadie tu libertad."
,"22":"Es mejor que tus hijos dependan de ti que tener tú que suplicarles."
,"23":"Asume la responsabilidad de todo lo que hagas, no permitas que otros manchen tu reputación."
,"24":"Cuando concluyan los días de tu vida, cuando llegue la hora de tu fin, entonces reparte la herencia."
,"25":"Para el burro: el forraje, el palo y la carga; para el sirviente: el pan, las correcciones y el trabajo."
,"26":"Da trabajo a tu esclavo y gozarás de paz; suéltale la rienda y querrá la libertad."
,"27":"El yugo y el cabestro hacen doblar el cogote; para el mal servidor, castigos y cadenas."
,"28":"Ponlo a trabajar, que no se quede ocioso, porque la ociosidad enseña la maldad."
,"29":"Hazlo trabajar según su capacidad, y si no obedece pon sus pies en los grillos."
,"30":"Pero no seas demasiado exigente con nadie, no hagas nada sin discernimiento."
,"31":"Si tienes un sirviente trátalo como a ti mismo, puesto que lo compraste con sangre."
,"32":"Si tienes un sirviente, trátalo como a un hermano, pues lo necesitas tanto como él a ti."
,"33":"Si lo maltratas y emprende la fuga, ¿a dónde irás a buscarlo?"
}`)
	CurrentBook.AddChapter(34, `{
"1":"Las esperanzas vanas y engañosas son para los imbéciles: los sueños dan alas a los insensatos."
,"2":"Contar con los sueños es como perseguir una sombra o correr tras el viento."
,"3":"Lo que se ve en sueños no es más que un reflejo: la persona ve su propia imagen."
,"4":"¿Puede uno purificarse con algo impuro? ¿Y encontrar la verdad en lo que es mentira?"
,"5":"Predicciones, visiones y sueños son tan vacíos como los fantasmas de una mujer en cinta."
,"6":"A menos que te sean enviados como una visita del Altísimo, no les prestes atención."
,"7":"Porque los sueños engañaron a mucha gente; los que confiaron en ellos fracasaron."
,"8":"La Ley en cambio se cumplirá sin falta: es sabia en lo que dice, fiel en lo que promete."
,"9":"El que ha viajado conoce muchas cosas, un hombre de experiencia no habla sin fundamento."
,"10":"El que no ha sido puesto a prueba sabe poco, el que ha recorrido el mundo ha adquirido muchos conocimientos."
,"11":"A lo largo de mis viajes he visto muchas cosas, y he conocido mucho más de lo que puedo decir."
,"12":"Me he visto varias veces en peligro de muerte y me he salvado gracias a mi experiencia."
,"13":"Los que temen al Señor salvarán su vida porque pusieron su esperanza en el que los puede salvar."
,"14":"El que teme al Señor no tendrá miedo, no se asustará por nada ya que El es su esperanza."
,"15":"El que teme al Señor conoce bien su felicidad: ¿en quién se apoya, quién es su fuerza?"
,"16":"La mirada del Señor está puesta sobre los que lo aman, es una poderosa protección, un apoyo resistente, un refugio contra el viento ardiente y el sol del mediodía, un sostén contra las caídas, una ayuda en el momento de caer."
,"17":"El Señor renueva el entusiasmo e ilumina los ojos, da la salud, vida y bendición."
,"18":"Dar a Dios una cosa mal adquirida es una ofrenda sucia; los dones de los malvados no pueden agradar a Dios."
,"19":"Al Altísimo no le agradan las ofrendas de los impíos; sus pecados no serán perdonados a fuerza de sacrificios."
,"20":"Ofrecer un sacrificio con lo que pertenecía a los indigentes es condenar a muerte a un hijo en honor de su padre."
,"21":"El pan que mendigan es la vida de los pobres; el que se lo quita es un asesino."
,"22":"Mata a su prójimo el que le quita los medios para sobrevivir; retener el salario de un trabajador es lo mismo que derramar su sangre."
,"23":"Uno construye, otro demuele; ¿qué han conseguido sino penas?"
,"24":"Uno ruega, el otro maldice, ¿la voz de quién escuchará el Amo?"
,"25":"Si uno se baña después de haber tocado a un muerto, y lo toca de nuevo, ¿de qué le sirve la purificación?"
,"26":"Es lo que pasa con el que ayuna por sus pecados y luego vuelve a cometerlos: ¿quién escuchará su oración? ¿De qué le sirvió su penitencia?"
}`)
	CurrentBook.AddChapter(35, `{
"1":"El que observa la Ley hace más que multiplicar las ofrendas; apegarse a los mandamientos es ofrecer un sacrificio de comunión."
,"2":"Un acto generoso es una ofrenda de harina pura, la limosna es un sacrificio de alabanza."
,"3":"Lo que agrada al Señor es que uno se aleje del mal; ¡no hay sacrificio de expiación más hermoso que huir de la injusticia!"
,"4":"Pero no debes presentarte ante el Señor con las manos vacías: todos esos sacrificios te han sido prescritos."
,"5":"Cuando el justo presenta su ofrenda, la grasa es para el altar, pero el buen olor sube hasta el Altísimo."
,"6":"El sacrificio del justo es bien acogido, el Señor no se olvidará de él."
,"7":"Glorifica al Señor con un corazón generoso, ofrece sin regatear los primeros frutos de tu trabajo."
,"8":"Cada vez que das, muestra una cara alegre, siéntete feliz de presentar tus diezmos."
,"9":"Da al Altísimo como te ha dado, de todo corazón y según tus medios;"
,"10":"porque el Señor devuelve la mano; te dará siete veces más."
,"11":"No trates de comprar sus favores, no lo aceptará; tu ofrenda de algo mal adquirido de nada te servirá."
,"12":"Porque el Señor es el juez, y no hace favoritismo."
,"13":"El nunca recibirá mal al pobre, escuchará la oración del oprimido."
,"14":"No menospreciará la súplica del huérfano ni los gemidos de la viuda."
,"15":"Cuando las lágrimas de la viuda corren por sus mejillas, ¿su llanto no está acusando acaso al que la hace llorar?"
,"16":"El que adora a Dios con todo su corazón encontrará buena acogida, su clamor llegará hasta el cielo."
,"17":"La oración del humilde atravesará las nubes, no se consolará hasta que no sea escuchado."
,"18":"No se desistirá, será necesario que el Altísimo se ocupe de él, que el Señor intervenga en favor de los justos."
,"19":"Pero el Señor no tardará; no hará demorar la espera."
,"20":"Les pegará en los riñones a los que no tienen piedad y se vengará de las naciones."
,"21":"Exterminará a la multitud de los violentos y destruirá el poder de los injustos."
,"22":"Al final, le dará a cada uno según lo que merece, conforme a sus actos y a sus intenciones."
,"23":"Hará justicia a su pueblo y su pueblo se alegrará de su misericordia."
,"24":"¡Su misericordia será tan bienvenida en momentos de angustia como lo son las nubes después de una sequía!"
}`)
	CurrentBook.AddChapter(36, `{
"1":"Ten piedad de nosotros, Señor, Dios de todas las cosas y míranos, y derrama tu temor en todas las naciones."
,"2":"¡Alza tu mano en contra de las naciones extranjeras y haz que vean tu poder!"
,"3":"Tú les mostraste tu santidad en todo lo que nos pasó, hazles ahora ver tu grandeza actuando en medio de ellas."
,"4":"¡Haz que te reconozcan como nosotros te reconocimos: porque no hay otro Dios sino tú, Señor!"
,"5":"Danos nuevos signos, renueva tus maravillas, manifiesta tu gloria actuando y castigando."
,"6":"Revive tu furor y derrama tu cólera; destruye al adversario y aplasta al enemigo."
,"7":"Apresura el día, acuérdate de tu juramento, y que podamos contar pronto tus hazañas."
,"8":"Que los sobrevivientes sean presa del fuego, que perezcan los opresores de tu pueblo."
,"9":"Parte la cabeza de tus enemigos, de sus jefes que dicen: '¡No hay más que nosotros!'"
,"10":"Reúne a todas las tribus de Jacob y entrégales como al comienzo su heredad."
,"11":"¡Ten piedad, Señor, de este pueblo que lleva tu nombre! ¡Piedad para Israel al que consideraste como tu primogénito!"
,"12":"Ten compasión de la ciudad santa, Jerusalén, del lugar de tu descanso."
,"13":"Repleta a Sión con el relato de tus maravillas, y a tu pueblo con tu gloria."
,"14":"Confirma las promesas que hiciste al principio, y haz que reaparezcan las profecías en tu nombre."
,"15":"Dales su recompensa a los que en ti esperaron, y demuestra que tus profetas decían la verdad."
,"16":"Escucha, Señor, la oración de tus servidores, escucha a tus sacerdotes cuando dan a tu pueblo la bendición de Aarón."
,"17":"¡Y que todos en la tierra reconozcan que tú eres el Señor, el Dios eterno!"
,"18":"El estómago absorbe todo tipo de alimentos, pero algunos alimentos son mejores que otros."
,"19":"Reconoces por el gusto de qué animal cazado se trata, del mismo modo el que tiene experiencia detecta las palabras mentirosas."
,"20":"Algunos son buenos para herir, pero el hombre de experiencia sabrá responderles."
,"21":"Una mujer acepta cualquier marido, pero hay unas mujeres mejores que otras."
,"22":"La belleza de una mujer ilumina su rostro y colma todos los deseos de un hombre."
,"23":"Si sus palabras están impregnadas de bondad y dulzura, su marido será el hombre más feliz."
,"24":"El que tomó una esposa comenzó a enriquecerse; tiene una ayuda semejante a él, una columna donde apoyarse."
,"25":"Una propiedad sin cerca atrae a los ladrones: allí donde falta la mujer, se gime y se va a la ventura."
,"26":"¿Quién confiará en un ladrón hábil que va de ciudad en ciudad?"
,"27":"Lo mismo ocurre con aquel que no tiene donde cobijarse y que se detiene donde lo sorprende la noche."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Todos tus amigos dirán: 'Yo también te amo', pero ten cuidado, pues el amigo sólo puede serlo de nombre."
,"2":"¿No es una tristeza mortal que un compañero o un amigo se vuelva enemigo?"
,"3":"¡Oh mal deseo!, ¿de dónde saliste para cubrir la tierra de tantos embustes?"
,"4":"Miren a ese camarada que se aprovecha de la buena fortuna de su amigo: apenas llega la desgracia, se vuelve en su contra."
,"5":"Miren a ese compañero que sufre por su amigo mientras se aprovecha para llenarse el estómago: apenas llega el peligro, sólo piensa en ponerse a salvo."
,"6":"Que tu corazón no se olvide de tu amigo, no lo dejes en la miseria si tú te haces rico."
,"7":"Todo consejero hace valer su consejo, pero más de alguno aconseja sólo por interés."
,"8":"Pon atención en el que te aconseja: pregúntate primero qué es lo que necesita, porque hablará según su interés. Tal vez trate de conquistarte."
,"9":"Tal vez te diga: 'Tu decisión es buena', y luego se quedará observando lo que te sucede."
,"10":"No consultes al que no confía en ti, oculta tus intenciones a los que te tienen envidia."
,"11":"No consultes jamás a una mujer sobre su rival; a un cobarde a propósito de la guerra; a un negociante sobre una tasa de interés; a un comprador si vendes algo; a un envidioso si se trata de un agradecimiento; a un flojo sobre algo que hay que hacer; a un jornalero por el fin de su trabajo; a un sirviente holgazán por un trabajo pesado."
,"12":"Busca más bien la compañía de un verdadero creyente, que tú sepas que es respetuoso de los mandamientos, cuya alma está cerca de la tuya y que compartirá tu sufrimiento si tú fracasas."
,"13":"Luego, mantente firme en la decisión que nacerá de ti, porque nadie merece más tu confianza."
,"14":"Nuestra propia intuición ve a veces más claro que los siete centinelas que vigilan en lo alto."
,"15":"Pero, sobre todo, invoca al Altísimo para que te guíe en la verdad."
,"16":"Antes de emprender algo hay que pensarlo; antes de cualquier acción hay un proyecto."
,"17":"Tus opciones orientan tus pasos según cuatro direcciones:"
,"18":"el bien o el mal, la vida o la muerte. La elección que hagas depende de tu propia decisión."
,"19":"Hay hombres que son buenos para instruir a los demás, pero que no sirven para ayudarse a sí mismos."
,"20":"El que es bueno para hablar se hace odiar: lo dejarán morir de hambre."
,"21":"El Señor no lo favorece en nada, porque está desprovisto de sabiduría."
,"22":"Otro es sabio a sus propios ojos; él mismo afirma que su sabiduría es provechosa."
,"23":"El hombre sabio instruye a su propio pueblo: uno puede fiarse de los frutos de su inteligencia."
,"24":"El hombre sabio está colmado de bendiciones, todos los que lo ven lo alaban."
,"25":"Los días del hombre son contados, pero los días de Israel sobrepasarán cualquier medida."
,"26":"El sabio gozará de la confianza de su pueblo; su nombre perdurará para siempre."
,"27":"Hijo mío, ve por ti mismo lo que te conviene: ve lo que es malo para ti y aprende a evitarlo."
,"28":"Porque no todo conviene a todos, y todos no se contentan con las mismas cosas."
,"29":"No abuses de todo lo que te gusta, no te abalances sobre la comida,"
,"30":"porque comer demasiado enferma, y la gula provoca indigestión."
,"31":"Mucha gente ha muerto por esos excesos, mientras que los que se moderan prolongan su vida."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Tenle al médico toda la estima que se merece, debido a sus servicios porque así lo quiso el Señor."
,"2":"La mejoría viene del Altísimo, y es el Rey quien concede el don de sanar."
,"3":"Los conocimientos del médico le permiten andar con la cabeza levantada, hasta los grandes lo admiran."
,"4":"El Señor creó las plantas medicinales que brotan de la tierra: un hombre inteligente no las menosprecia."
,"5":"Acuérdate de aquella madera que endulzó las aguas amargas, y con eso el Señor dio a conocer su poder."
,"6":"El da a los hombres el saber para que lo glorifiquen por los maravillosos remedios que creó."
,"7":"El médico los usa para curar y para quitar el dolor, el farmacéutico hace con ellos sus mezclas."
,"8":"De ese modo, las obras del Señor no se han terminado, y continúa difundiéndose el bienestar por la tierra."
,"9":"Hijo mío, cuando estés enfermo no te deprimas: ruégale al Señor para que te cure."
,"10":"Renuncia a tus malas acciones, guarda las manos limpias y purifica tu corazón de cualquier pecado."
,"11":"Ofrécele a Dios el incienso y la harina flor para que te tenga en su memoria, preséntale una ofrenda escogida entre tus bienes."
,"12":"Luego, haz que venga el médico, ya que el Señor lo creó; no lo desprecies porque lo necesitas."
,"13":"En algunos casos el restablecimiento pasa por las manos de ellos;"
,"14":"rogarán al Señor para que les ayude a encontrar los medios para aliviarte y salvarte la vida."
,"15":"El que peca en presencia de su Creador, ¡que caiga en las manos del médico!"
,"16":"Hijo mío, derrama lágrimas por un muerto y entona la lamentación que expresará tu dolor. Luego, entierra su cuerpo como se debe, no descuides nada referente a su sepultura."
,"17":"Gime amargamente, golpéate el pecho, haz el velorio como conviene por uno o dos días para marcar la separación, luego consuélate de tu tristeza."
,"18":"Porque la tristeza lleva a la muerte, y la pena interior consume las energías."
,"19":"Que la tristeza se acabe con los funerales: no puedes vivir siempre afligido."
,"20":"¡No abandones tu corazón a la tristeza, échala y piensa en tu propio fin!"
,"21":"No lo olvides: es sin vuelta. Tú te perjudicarías y no le harías ningún bien."
,"22":"Acuérdate de mi sentencia que un día podrás repetir: ¡ayer fui yo, hoy serás tú!"
,"23":"Desde el momento en que el muerto reposa, haz que también repose su recuerdo; consuélate desde el momento en que haya expirado."
,"24":"Hay que tener sosiego para adquirir el conocimiento de la Ley; el que no está esclavizado por su trabajo podrá llegar a ser sabio."
,"25":"¿Cómo llegará a ser sabio el que maneja el arado? todo su orgullo consiste en usar la picana; guía a sus bueyes y los hace trabajar, no habla más que de animales."
,"26":"Toda su atención está puesta en el surco que traza y hasta tarde en la noche les da forraje a sus terneras."
,"27":"Lo mismo pasa con cualquier obrero o artesano que trabaja día y noche, con los que graban los sellos y se esfuerzan por variar el diseño. Toda su atención está puesta en el trabajo que hacen, y pasan las noches en vela perfeccionando su obra."
,"28":"Otro tanto ocurre con el herrero sentado junto al yunque, ocupado totalmente en fierro que forja mientras literalmente se derrite por el ardor del fuego. Tiene que protegerse de la fragua y del ruido del martillo que le rompe los tímpanos. Toda su atención está centrada en hacer un trabajo perfecto y se queda hasta altas horas de la noche embelleciendo su obra."
,"29":"Lo mismo sucede con el alfarero que trabaja sentado frente al torno y hace andar la rueda con sus pies; está inmerso en su faena y trata de producir más."
,"30":"Con sus manos moldea la arcilla y la amasa con sus pies. Pondrá toda su atención en extender el barniz y se desvelará manteniendo encendido el horno."
,"31":"Todas esas personas cuentan con sus brazos y cada uno es hábil en su oficio."
,"32":"Sin ellos no se construiría la ciudad, ni se podría habitarla ni circular por ella."
,"33":"Sin embargo, no irán a buscarlos para el consejo del pueblo ni se fijarán en ellos en la asamblea. No se sentarán en el tribunal porque no están familiarizados con la Ley."
,"34":"Demostrarán muy poca instrucción, no son expertos en derecho, y no figuran entre los que interpretan las máximas. Por cierto, que valorizan todo lo que Dios creó en un comienzo, pero su oración no va más allá de las cosas de su oficio."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Pasa todo lo contrario con el que se aplica a meditar la Ley del Altísimo. Escudriña la sabiduría de los antiguos y las profecías de éstos le absorben todo el tiempo."
,"2":"Conserva en su memoria las palabras de los hombres célebres y penetra las riquezas de sus máximas;"
,"3":"busca el sentido oculto de los proverbios y se interesa en los enigmas de las parábolas."
,"4":"Se pone al servicio de los grandes y se le ve en medio de los jefes. Viaja por los países extranjeros y tiene la experiencia de lo que es bueno o malo para los hombres."
,"5":"Desde temprano se dedica a encontrar al Señor que lo creó, implora en presencia del Altísimo; abre su boca para orar y suplicar por sus pecados."
,"6":"Si el Señor sublime lo ha decidido así, lo llenará del espíritu de inteligencia. Entonces entregará, como una lluvia, palabras de sabiduría, y dará gracias al Señor en su oración."
,"7":"Penetrará en los planes de Dios y en el conocimiento: meditará los secretos del Señor."
,"8":"Comunicará las enseñanzas de su doctrina y se sentirá orgulloso de la Ley y de la Alianza del Señor."
,"9":"Mucha gente alabará su inteligencia, la que nunca pasará al olvido; su recuerdo no desaparecerá y su nombre se mantendrá a perpetuidad, de generación en generación."
,"10":"Se reconocerá su sabiduría en el extranjero, y hará el elogio de ella la asamblea del pueblo."
,"11":"Mientras viva, su nombre estará por encima de otros mil, y cuando descanse, le bastará con su renombre."
,"12":"Quiero además comunicarles mis reflexiones, de las que estoy repleto como la luna llena."
,"13":"Hijos míos santos, escúchenme y crecerán como el rosedal plantado junto al arroyo."
,"14":"Expandan un olor agradable como el incienso, que se abran sus flores como el lirio, den su perfume y entonen un canto. ¡Bendigan al Señor por todas sus obras!"
,"15":"Glorifiquen su nombre y publiquen sus alabanzas; canten, toquen el arpa, aclámenlo diciendo:"
,"16":"¡Qué hermosas son las obras del Señor! Todo lo que él decide ocurre en el momento preciso. No hay pues que decir: ¿Qué es eso? ¿Por qué aquello? porque todo será útil a su debido tiempo."
,"17":"A una palabra suya las aguas se detuvieron y se elevaron en un solo lugar; una palabra de su boca abrió el depósito de las aguas."
,"18":"Basta que hable para que todo lo que desea se realice, nadie puede detener su obra de salvación."
,"19":"Ante él están las obras de cada uno, y nada escapa a su mirada."
,"20":"Su mirada se extiende desde el comienzo al fin de los tiempos, y nada puede sorprenderle."
,"21":"No hay pues que decir: ¿Qué es esto? ¿Por qué eso? porque todo ha sido hecho para que sirva."
,"22":"La bendición del Señor es como un río que se desborda; inundó la tierra como un diluvio."
,"23":"Pero los paganos se harán acreedores a su cólera, como cuando convirtió una tierra de regadío en una superficie de sal."
,"24":"Sus caminos son rectos para sus fieles, pero para los sin Ley están llenos de obstáculos."
,"25":"Desde un principio creó las cosas buenas para los que son buenos, y las malas para los pecadores."
,"26":"Estas son las cosas más elementales para la vida humana: el agua, el fuego, el fierro, la sal, y también la harina de trigo, la leche y la miel, el zumo de la uva, el aceite y la ropa."
,"27":"Todas estas cosas son buenas para los buenos, pero se tornan dañinas para los pecadores."
,"28":"Algunos vientos fueron hechos para destruir; el Señor en su cólera los convierte en azotes. Llegado el momento de destruir, desencadenan su violencia y satisfacen la furia del que los hizo."
,"29":"Fuego, granizo, hambre y muerte: todo eso fue creado para servir de castigo."
,"30":"Como también los dientes de las fieras salvajes, los escorpiones, las víboras y la espada vengadora que castiga a los impíos."
,"31":"Todas esas cosas se alegran de ejecutar sus órdenes. Están listas para cuando sea necesario, y llegado el momento no desobedecerán sus órdenes."
,"32":"De todo eso estaba convencido desde un comienzo. Pero lo medité y por eso escribí:"
,"33":"'Todas las obras del Señor son buenas, el provee a todo cuando llega el momento."
,"34":"No hay pues que decir: ¡Esto es malo, eso es bueno! porque todo con el tiempo tiene su valor.'"
,"35":"Y ahora canten con toda su voz y con todo su corazón: ¡bendigan el nombre del Señor!"
}`)
	CurrentBook.AddChapter(40, `{
"1":"Una preocupación mayor ha sido impuesta a los seres humanos, una pesada carga agobia a los hijos de Adán desde el día en que salen del seno de su madre hasta aquel en que vuelven a la madre universal."
,"2":"Cuando piensan en el futuro, lo que preocupa a sus espíritus, lo que temen, es el día de su muerte."
,"3":"¡Desde el que se sienta como rey en su trono, hasta el que vive sumido en el barro y la ceniza,"
,"4":"desde el que lleva la corona y la púrpura, hasta el que se viste con una arpillera, sólo se ve en ellos pasión, envidia, perturbación, agitación, miedo a la muerte, rencor y discordia!"
,"5":"Y cuando nos acostamos de noche, el sueño hace surgir nuevas angustias."
,"6":"Apenas uno está descansando y durmiendo, los sueños vienen a perturbarnos como si fuera en pleno día: uno se ve como que escapa a una masacre."
,"7":"Se ve reducido a la situación más extrema y entonces se despierta: y se asombra al ver que tuvo miedo por nada."
,"8":"Esto le pasa a todos tanto hombres como animales, pero es siete veces peor para los pecadores:"
,"9":"muerte, sangre, discordia, espada, desgracias, hambre, destrucción y calamidades."
,"10":"Porque todo eso fue creado en contra de los sin Ley: por su culpa fue que vino el diluvio."
,"11":"Todo lo que proviene de la tierra vuelve a la tierra, y lo que proviene del agua vuelve al mar."
,"12":"El dinero para sobornar desaparecerá junto con la injusticia, pero la fidelidad permanecerá para siempre."
,"13":"La riqueza de los injustos se agotará como el torrente en el verano, como el estruendo del trueno en la tormenta."
,"14":"El que ha sido generoso tendrá de qué regocijarse, pero los pecadores se irán a la ruina."
,"15":"Los retoños de los malvados casi no tendrán ramas, sus raíces no encontrarán más que roca dura."
,"16":"Serán como las cañas que crecen en las cercanías de la ribera: se las arranca antes que las demás plantas."
,"17":"La generosidad, en cambio, es como un jardín de bendiciones, la misericordia permanece para siempre."
,"18":"Bastarse a sí mismo o ser un artesano produce una vida agradable; hallar un tesoro supera a uno y otro."
,"19":"Los hijos, la fundación de una ciudad harán que perdure tu nombre: la mujer irreprochable supera a uno y otro."
,"20":"El vino y la música alegran el corazón: el amor de la sabiduría supera a uno y otro."
,"21":"La flauta y el arpa producen una suave melodía: una voz persuasiva supera a uno y otro."
,"22":"El ojo busca la gracia y la belleza: el verdor de los campos supera a ambas."
,"23":"El amigo, el compañero son bienvenidos, pero más que ambos la esposa o el marido."
,"24":"¡Hermanos y protectores lo son para los momentos de prueba! Más que unos y otros un gesto caritativo te valdrá la salvación."
,"25":"El oro y la plata aseguran tus pasos, pero un buen consejo es más eficaz que ambos."
,"26":"La riqueza y la fuerza te dan ánimo, pero más que ambos el temor del Señor. Con el temor del Señor nada falta, no hay que buscar ayuda en otra parte."
,"27":"El temor del Señor es un jardín de bendiciones, protege mejor que todos los hombres."
,"28":"Hijo mío, trata de no vivir mendigando, ¡es mejor morir que mendigar!"
,"29":"Atisbar continuamente a la mesa de otro es existir sin vivir. La comida de otro sólo puede ensuciarte: un hombre educado e instruido no la acepta."
,"30":"La comida que se mendiga es dulce a la boca de un mal educado, pero le quemará las entrañas."
}`)
	CurrentBook.AddChapter(41, `{
"1":"¡Oh muerte, qué amargo es tu recuerdo para el que vive sin problemas, gozando de sus bienes, para el que va adelante y todo le resulta, para el que todavía tiene salud para comer!"
,"2":"¡Oh muerte, qué buena es tu sentencia para el que padece necesidad y al que abandonan sus fuerzas, para el anciano gastado que pierde la memoria, que se rebela y pierda la paciencia!"
,"3":"No temas la sentencia de la muerte, acuérdate de los que te precedieron y de los que te seguirán."
,"4":"El Señor la decretó para todo ser viviente: ¿rehusarás algo que le pareció bueno al Altísimo? Ya sea que hayas vivido diez, cien o mil años, a nadie le importarará eso en la Morada de abajo."
,"5":"Los hijos de los pecadores formarán una raza detestable, buena para llenar las casas de los malvados."
,"6":"Los hijos de los pecadores perderán su herencia, su raza arrastra una maldición."
,"7":"Un padre impío será reprochado por sus hijos, por culpa de él quedaron deshonrados."
,"8":"Ay de ustedes, hombres malvados, que abandonaron la ley del Altísimo."
,"9":"Ustedes nacieron sólo para que los maldigan, y a su muerte no recibirán más que una maldición."
,"10":"Todo lo que proviene de la tierra vuelve a la tierra, es por eso que los impíos pasarán de la maldición a la ruina."
,"11":"Debemos hacer duelo por nuestro cuerpo, pero en cuanto a los pecadores hasta su nombre desaparecerá, al no evocar nada bueno."
,"12":"Cuida el honor de tu nombre, porque permanecerá mucho más que mil depósitos de oro."
,"13":"Una vida, por buena que sea, dura sólo un tiempo, mientras que el buen nombre permanece para siempre."
,"14":"Hijos míos, guarden mis enseñanzas y háganlas prosperar: si la sabiduría permanece escondida y el tesoro enterrado, ¿para qué sirven?"
,"15":"Más vale ocultar su locura que esconder su sabiduría."
,"16":"Les voy a decir de qué hay que avergonzarse realmente, porque no debemos tener vergüenza de cualquier cosa, aun cuando otros tienen ideas falsas al respecto."
,"17":"Avergüéncense de su mal comportamiento ante su padre y su madre; de la mentira ante un príncipe o un poderoso;"
,"18":"de un crimen ante un juez o un magistrado, de sus faltas ante la asamblea del pueblo;"
,"19":"de una injusticia ante tu compañero o tu amigo; de un robo ante el vecindario."
,"20":"Debes tener vergüenza, pensando en la verdad de Dios y en la Alianza: de guardar los panes para ti solo,"
,"21":"de no saber dar y recibir, de no responder al saludo de otro,"
,"22":"de mirar con atención a una prostituta, de no mirar a tu legítima esposa,"
,"23":"de apropiarte de lo que se ha dado a otros, de mirar con insistencia a una mujer casada,"
,"24":"de tener un trato demasiado familiar con tu empleada: ¡no te acerques a su cama!"
,"25":"de haber insultado a un amigo, de echar en cara después de haber dado algo,"
,"26":"de contar lo que has oído, de revelar un secreto."
,"27":"Si tienes vergüenza de todas esas cosas, todos te apreciarán."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Pero debe ser todo lo contrario con lo que sigue, si no quieres pecar. No tengas vergüenza:"
,"2":"de la ley del Altísimo y de su Alianza, de reconocer la inocencia, aun la del malvado,"
,"3":"de mantener las cuentas claras con tus compañeros de viaje, de entregar a los extranjeros su parte de la herencia,"
,"4":"de usar una balanza y pesas exactas, de hacer obras de caridad grandes o pequeñas"
,"5":"de obtener ganancia en un negocio, de corregir a menudo a tus hijos, y de cascarle en el lomo a un mal servidor."
,"6":"¡Con una mala mujer usa el candado; allí donde se meten muchas manos, pon las cosas bajo llave!"
,"7":"Cuenta y pesa las cosas que entregas; anota por escrito lo que das y lo que recibes."
,"8":"No tengas vergüenza de reprender a un imbécil o a un tonto, y al anciano decrépito que ha vuelto a la infancia. Entonces demostrarás que verdaderamente eres educado, y todos te apreciarán."
,"9":"Una hija es para su padre una causa secreta de inquietud; el cuidado que le ocasiona le quita el sueño; si es joven, por el temor a que demore en casarse; si está casada, a que su marido le tome tirria."
,"10":"Mientras es virgen, podría dejarse seducir y quedar embarazada en la casa de su padre. Si tiene marido, tal vez podría serle infiel o bien no darle hijos."
,"11":"Si tu hija es una descarada, redobla la prudencia: cuida de que no haga de ti el hazmerreír de tus enemigos, el comentario de la ciudad, un tema para chismes. Podría deshonrarte ante todo el mundo."
,"12":"No detengas tu mirada en una belleza humana ni te pongas a conversar con mujeres."
,"13":"Así como la polilla sale de la ropa, así sale de la mujer su malicia."
,"14":"Más vale dureza de hombre que bondad de mujer: la mujer puede atraerte vergüenza y reproches."
,"15":"Voy ahora a recordar las obras del Señor, y a contar lo que he visto: las obras del Señor salieron de sus palabras, conforme a sus decisiones."
,"16":"Así como el sol ilumina todo lo que está a la vista, así la obra del Señor está llena de su gloria."
,"17":"Explicar este mundo de maravillas es una cosa que le queda grande aun a los santos del Señor. Porque el Señor, Dueño del Universo, le dio consistencia en su propia gloria."
,"18":"El sondea tanto los abismos del mar como los espíritus de los hombres; él ve claro en sus proyectos. El Altísimo conoce todo lo que se puede saber: conoce los signos de los tiempos. "
,"19":"Dice lo que ha sido y lo que será, descubre las huellas de las cosas pasadas."
,"20":"Ni un pensamiento se le escapa, ni una palabra se le oculta."
,"21":"Dispuso armoniosamente las obras maestras de su sabiduría, tales como han sido siempre y lo serán; no ha recurrido a ningún consejero; nada podría añadírseles o quitárseles."
,"22":"¡Qué hermosas son todas sus obras¡; qué encanto contemplar hasta la más pequeña chispa!"
,"23":"Todo eso vive y dura para siempre, todo obedece en todo momento."
,"24":"Todas las cosas van de a par, una enfrentando a la otra; el Señor no ha hecho nada imperfecto."
,"25":"Una destaca a la otra: ¿quién se cansará de contemplar su gloria?"
}`)
	CurrentBook.AddChapter(43, `{
"1":"El orgullo del mundo de arriba es el firmamento cristalino: el espectáculo del cielo es una visión de gloria."
,"2":"Desde que el sol aparece va proclamando: '¡Soy un objeto admirable, una obra del Altísimo!'"
,"3":"Al mediodía reseca el campo; ¿quién puede soportar su ardor? 'Aunque sea insoportable el calor de la fragua, el ardor del sol es tres veces más cuando quema las montañas, proyectando vapores ardientes, rayos que ciegan los ojos."
,"5":"¡Sí, grande es el Señor que lo hizo y cuyas palabras estimulan su curso!"
,"6":"Luego, viene la luna, siempre fiel a su cita; ella indica los meses y el calendario."
,"7":"El tiempo de la fiesta nos viene de la luna, cuando después de un plenilunio vuelve a su menguante."
,"8":"De la luna nueva toma su nombre el mes: ¡qué maravilla cuando llega a su creciente! Ella es el estandarte de los ejércitos celestiales, mientras ilumina la extensión del firmamento."
,"9":"El resplandor de las estrellas da al cielo su belleza, es el ornato resplandeciente de las alturas del Señor."
,"10":"Dóciles a la palabra del Santo, se mantienen en el puesto que les asignó y montan guardia sin cansarse jamás."
,"11":"Contempla al arco iris y bendice al que lo hizo; ¡qué hermoso es con todos sus colores!"
,"12":"Traza en el cielo un círculo de gloria, un arco que fue extendido por las manos del Altísimo."
,"13":"Si él quiere despacha la nieve y apresura a los relámpagos para que ejecuten sus sentencias."
,"14":"Si abre de nuevo las reservas del cielo, las nubes emprenden su vuelo como los pájaros."
,"15":"Con su poder congela las nubes para que lancen el granizo como piedras."
,"16":"Las montañas tiemblan si las mira, al sentir su trueno la tierra se estremece."
,"17":"El viento sur sopla si lo quiere, como asimismo los ciclones y el huracán del norte."
,"18":"Los copos de nieve descienden como pájaros; se posa como la langosta. Su blancura inmaculada maravilla a nuestros ojos, el pensamiento queda en suspenso al verla caer."
,"19":"Derrama como sal la escarcha por la tierra; el frío la transforma en espinas puntudas."
,"20":"Cuando sopla el frío viento del norte, se forma el hielo sobre el agua; cubre las extensiones líquidas y las reviste de una coraza."
,"21":"El otro viento consume las montañas y quema el desierto; como si fuera fuego devora todo verdor."
,"22":"Pero acude una nube y cura todos esos males: después de la canícula, el rocío devuelve la alegría."
,"23":"Según su designio domó al océano y plantó en él islas."
,"24":"Los que navegan por el mar nos cuentan sus peligros: ¡se oyen relatos escalofriantes!"
,"25":"¡Hay allí seres extraños y maravillosos, animales de todas las especies, y monstruos marinos!"
,"26":"Pero gracias a Dios, su enviado encuentra su camino, y todo se arregla según su palabra."
,"27":"Podríamos seguir, pero no terminaríamos: en una palabra, ¡El es Todo!"
,"28":"¿Dónde hallar la fuerza para glorificarlo? ¡Es grande, por encima de todo lo que ha hecho!"
,"29":"Es un Señor temible y altísimo, su poder es prodigioso."
,"30":"Ríndanle alabanza, exalten al Señor todo lo que puedan: ¡El merece mucho más! Exáltenlo con todas sus fuerzas, no se cansen, que nunca será suficiente."
,"31":"¿Quién lo vio y puede decirnos lo que vio? ¿Quién lo glorificará como se lo merece?"
,"32":"¡Cuántas maravillas ocultas, mucho más grandes todavía! Sólo hemos visto una pequeña parte de sus obras."
,"33":"Sí, el Señor hizo todas esas cosas, y a sus fieles otorga que las puedan comprender."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Hagamos ahora el elogio de los hombres ilustres, hagamos una reseña de nuestros antepasados."
,"2":"El Señor les dio una bella gloria, que es una parte de su gloria eterna."
,"3":"Unos fueron soberanos en su reino, hombres famosos por su energía; otros sobresalieron por sus sabias decisiones, hablaron como profetas."
,"4":"Otros guiaron al pueblo con sus consejos, le enseñaron con sus palabras llenas de sabiduría."
,"5":"Otros cultivaron la música, la poesía y la prosa."
,"6":"Otros fueron hombres ricos, personajes poderosos que vivieron en paz en sus dominios."
,"7":"Todos tuvieron fama en su vida y fueron un motivo de orgullo para sus contemporáneos."
,"8":"Si bien ellos dejaron un nombre, y todavía se repiten sus alabanzas,"
,"9":"otros cayeron en el olvido, desaparecieron como si no hubieran existido, y lo mismo ocurrió con sus descendientes."
,"10":"Pero hablemos de los hombres de bien cuyas buenas obras no se han olvidado."
,"11":"Sus descendientes han heredado ese hermoso legado,"
,"12":"su raza se mantiene fiel a la Alianza, sus hijos siguen su ejemplo."
,"13":"Su raza durará para siempre, su gloria no desaparecerá."
,"14":"Sus cuerpos fueron enterrados en la paz, pero su nombre está vivo por todas las generaciones."
,"15":"Los pueblos cuentan su sabiduría y la asamblea proclama su alabanza."
,"16":"Enoc agradó al Señor y fue trasladado: él ha dejado su testimonio para los hombres de todos los tiempos."
,"17":"Noé fue hallado justo, perfecto: fue el instrumento de la reconciliación en el momento de la Cólera; debido a él quedó un resto en la tierra cuando vino el diluvio."
,"18":"El Señor se comprometió con él para siempre: no destruirá más por medio de las aguas al conjunto de los vivientes."
,"19":"Abrahán es el padre ilustre de una multitud de naciones; nadie ha igualado nunca su gloria."
,"20":"Observó la ley del Altísimo, que lo hizo entrar en su alianza; esa alianza fue inscrita en su carne; permaneció fiel en el día de la prueba."
,"21":"Por eso Dios le hizo un juramento: todas las naciones serían bendecidas en su descendencia, la multiplicaría como el polvo de la tierra, elevaría su descendencia hasta las estrellas, su posteridad dominaría de uno al otro mar, desde el Eufrates hasta donde terminan las tierras en occidente."
,"22":"A Isaac le renovó esa promesa, debido a Abrahán su padre."
,"23":"Luego hizo reposar sobre la cabeza de Jacob la bendición para todos los hombres, lo mismo que la alianza; lo bendijo personalmente y le dio el país como herencia. Lo dividió en partes y las distribuyó entre las doce tribus."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Luego, Dios hizo que apareciera Moisés, un descendiente de Jacob, un hombre muy amado por Dios y por los hombres y cuya memoria será bendita para siempre."
,"2":"Lo hizo tan glorioso como los ángeles, lo volvió poderoso, terrible para sus enemigos;"
,"3":"por su sola palabra se multiplicaban los prodigios. El Señor lo glorificó en presencia de los reyes, le dio mandamientos para su pueblo y le dejó ver un reflejo de su gloria."
,"4":"Dejó que entrara en su misterio ese hombre fiel y amable, al que había escogido entre todos."
,"5":"Le permitió que oyera su voz y lo introdujo en la nube oscura. Le habló cara a cara y le dio los mandamientos, esa ley revelada, ley de vida, para que enseñara la alianza a Jacob, y sus decretos a Israel."
,"6":"Dios elevó y consagró igual que a él a su hermano Aarón, de la tribu de Leví."
,"7":"Concluyó con él una alianza perpetua, haciéndolo el sacerdote de su pueblo."
,"8":"Lo revistió con ornamentos espléndidos y le entregó las insignias de su poder: pantalones, túnica larga, efod."
,"9":"Del borde de su manto pendían granadas e innumerables campanillas de oro que tintineaban a cada uno de sus pasos; se las oía resonar en el templo y el pueblo permanecía atento a ellas."
,"10":"Lo revistió con un traje sagrado, bordado de oro, de púrpura y de escarlata; encima llevaba el pectoral con el urim y el tumim, bordado también con hilos escarlatas."
,"11":"Piedras preciosas destellaban, grabadas como sellos, engastadas por el joyero en una montura de oro. Allí se leían los nombres de las tribus de Israel: era para tenerlas siempre presentes en la memoria del Señor."
,"12":"Le puso una corona de oro por encima del turbante, con una inscripción en relieve: '¡Consagrado al Señor!' Era un adorno precioso, una obra espléndida que atraía las miradas de todos."
,"13":"Antes de él jamás se había visto algo tan hermoso; ningún profano se había revestido con tales ornamentos; están reservados a sus hijos y a sus descendientes en la continuación de los tiempos:"
,"14":"El fuego consume sus ofrendas dos veces al día, y para siempre."
,"15":"Moisés en persona lo consagró: Aarón recibió de él la unción con el aceite santo; así fue como recibió ese privilegio para siempre, no sólo él sino también sus descendientes, y esto mientras duren los cielos, llevarán a cabo el servicio litúrgico. Serán sacerdotes y darán al pueblo de Dios la bendición en su nombre."
,"16":"Fue elegido entre todos los seres vivientes para que presentara la ofrenda al Señor, junto con el incienso de agradable aroma, para que así el Señor se acordara de su pueblo y le perdonara sus pecados."
,"17":"El Señor le concedió el don de interpretar sus mandamientos y de pronunciarse cuando se trate de enseñar a Jacob sus decisiones, y de esclarecer a Israel con respecto a su Ley."
,"18":"Extranjeros conspiraron en contra de Aarón, estaban envidiosos de él en el desierto. Eran los hombres de Datán y de Abirón, era junto con Coré el partido de los violentos y furiosos."
,"19":"El Señor lo vio y eso no le gustó; fueron exterminados por el ardor de su cólera. Los castigó de manera extraordinaria: llamas ardientes los devoraron."
,"20":"Dios hizo mucho más aún por la gloria de Aarón; le dio a manera de herencia los primores de las cosechas, asegurándole así el pan en abundancia."
,"21":"Le dio, a él y a su raza, las ofrendas que se hacen al Señor: ése es su pan."
,"22":"En cambio, nada tienen de herencia en la tierra de su pueblo, no tienen su parte con el pueblo; porque el Señor dijo: 'Yo seré la parte que le toca en herencia.'"
,"23":"Finjas, hijo de Eleazar, es el tercero en gloria, porque temió al Señor y se mostró lleno de celo por él. Permaneció firme cuando el pueblo se rebeló: su voluntad no se doblegó, y así obtuvo el perdón para Israel."
,"24":"Por eso el Señor concluyó con él una alianza de paz: lo estableció como jefe del Santuario y del pueblo; le concedió a él y a su descendencia la dignidad de jefe de los sacerdotes, y esto por los siglos."
,"25":"Cuando Dios se comprometió con David, hijo de Jesé, de la tribu de Judá, uno solo de sus hijos heredaría su realeza; con Aarón, en cambio, su sacerdocio pasa a todos sus descendientes."
,"26":"¡Oh raza de Aarón, que el Señor ponga sabiduría en sus corazones para que gobiernen a su pueblo con rectitud, y así, de generación en generación, no se pierda ni su prosperidad ni su gloria!"
}`)
	CurrentBook.AddChapter(46, `{
"1":"¡Qué valiente en la guerra era ese Josué, hijo de Nun, que reemplazó a Moisés como profeta! Como lo dice su nombre, fue grandioso cuando se trataba de librar a los elegidos de Dios. Se vengó de los enemigos que lo atacaban e instaló a Israel en su territorio."
,"2":"¡Qué glorioso era cuando, levantando su brazo, hería a las ciudades con su espada!"
,"3":"¿Quién antes de él supo guerrear como él? Sabía llevar adelante los combates del Señor."
,"4":"¿No fue a una orden suya que el sol se detuvo y que un día duró tanto como dos?"
,"5":"Invocó al Altísimo, al Poderoso, cuando sus enemigos lo atacaban por todas partes, y el Amo supremo lo escuchó haciendo llover tremendos granizos."
,"6":"Josué embistió entonces a la nación enemiga, alcanzó a sus adversarios y los masacró en la bajada. Así fue como los paganos probaron sus armas y comprendieron que combatía para el Señor."
,"7":"Josué siguió siempre al Todopoderoso. En tiempos de Moisés, junto con Caleb, hijo de Jefuné, actuó bien oponiéndose a la multitud, trató de apartar al pueblo del pecado y de hacer callar las murmuraciones de los malvados."
,"8":"Por eso, fueron los dos únicos que sobrevivieron entre seicientos mil hombres de guerra: el Señor los introdujo en su heredad, en la tierra en que corren la leche y la miel."
,"9":"A Caleb el Señor le concedió la fuerza, la que lo acompañó hasta en su vejez. Se estableció en las alturas del país y sus descendientes conservaron esa herencia."
,"10":"Así sabrán todos los hijos de Israel que es bueno seguir al Señor."
,"11":"Luego, vinieron los Jueces: cada uno de ellos tiene su propia fama. Su corazón no se vendió a los falsos dioses, y no se apartaron del Señor. ¡Que sean benditos para siempre!"
,"12":"¡Que sus huesos reflorezcan en sus tumbas, que los hijos de esos hombres ilustres sean dignos del nombre de sus padres!"
,"13":"Samuel fue amado del Señor. Como profeta del Señor estableció la realeza y dio la unción santa a los jefes de su pueblo."
,"14":"Gobernó a la Asamblea según la ley del Señor, y el Señor se preocupó por Jacob."
,"15":"Reconocieron que era profeta y que no se equivocaba; cuando se cumplieron sus palabras, reconocieron que sus visiones eran verdaderas."
,"16":"Cuando el enemigo lo presionaba por todas partes, invocó al Señor poderoso y le sacrificó un corderito."
,"17":"Entonces el Señor hizo resonar su trueno en el cielo y dejó oír su voz con gran estruendo."
,"18":"Samuel exterminó a los jefes enemigos y a todos los príncipes de los Filisteos."
,"19":"Cuando llegó la hora de su sueño eterno, dio testimonio delante del Señor y de su Ungido: '¡Nada he tomado a nadie, ni dinero, ni siquiera un par de sandalias!' y nadie lo acusó."
,"20":"Incluso profetizó hasta después de su muerte: levantó su voz desde el seno de la tierra para anunciarle al rey que su fin estaba próximo y decirle que el Señor le haría pagar al pueblo su pecado."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Después apareció Natán que profetizó en tiempos de David."
,"2":"Así como en un sacrificio se reservan las grasas para el Señor, así fue puesto aparte David entre los hijos de Israel."
,"3":"David se entretenía con leones y con osos como si fueran cabritos o corderitos."
,"4":"¿No mató al gigante en su juventud? Con una piedra de su honda abatió al arrogante Goliat y así lavó la afrenta hecha a su pueblo."
,"5":"Había clamado al Señor, al Altísimo, y éste le dio a su brazo la fuerza para acabar con ese terrible combatiente; así le dio la victoria a su pueblo."
,"6":"Le atribuyeron el mérito de haber muerto a diez mil, cantaban sus alabanzas bendiciendo al Señor y le ofrecieron la corona."
,"7":"Porque aplastó al enemigo en todos los frentes, aniquiló a los filisteos que lo atacaban, y el poder de éstos se debilitó hasta nuestros días."
,"8":"Después de tantas hazañas, David rindió homenaje al Santo, al Altísimo, con cánticos de alanbanza; le entonó himnos con todo su corazón; se sentía contento por lo que le había hecho."
,"9":"David puso delante del altar a los cantores con arpas para que dejaran oír sus voces melodiosas."
,"10":"Dio esplendor a las fiestas y realzó el brillo de las solemnidades, haciendo que se alabara el nombre del Señor: desde la aurora se oía el canto sagrado."
,"11":"El Señor le perdonó sus pecados y quiso que su poder perdurara por los siglos: se comprometió con él en lo que respecta a los reyes futuros, y le prometió que haría gloriosa su dinastía en Israel."
,"12":"David tuvo por sucesor a un hijo lleno de sabiduría; gracias a su padre, vivió a sus anchas."
,"13":"Salomón reinó en un período de paz y Dios le ahorró cualquier preocupación en sus fronteras, porque tenía que levantar un Templo en honor de su Nombre y prepararle un Santuario por los siglos."
,"14":"¡Oh Salomón, qué sabio fuiste en tu juventud, igual que un río desbordabas inteligencia!"
,"15":"Tu genio cubrió la tierra; la llenaste con tus proverbios y enigmas."
,"16":"Tu fama llegó hasta las islas más lejanas: fuiste amado porque eras pacífico."
,"17":"Las naciones te admiraron por tus cantos, proverbios y parábolas: tenías el arte de aclararlo todo."
,"18":"En nombre del Señor Dios que se llama Dios de Israel, amontonaste el oro como si fuera estaño, y acumulaste la plata como el plomo."
,"19":"Pero estuviste pendiente de las mujeres que compartían tu cama, ellas fueron dueñas de tu cuerpo."
,"20":"Manchaste así tu gloria y deshonraste du descendencia; atrajiste la Cólera sobre tus hijos, y tu locura los hundió en la desgracia."
,"21":"Se dio la división del poder: una realeza rebelde surgió en Efraím."
,"22":"Pero Dios no renegó de su compasión ni retiró ninguna de sus promesas; no hizo perecer la descendencia de un elegido ni destruyó la vaza de quien lo amó. Por eso dió un resto a Jacob y a David un brote salido de él."
,"23":"Cuando Salomón fue a descansar con sus padres, dejó como sucesor al más loco del pueblo, a un hombre sin inteligencia: ese Roboam, con sus decisiones, fue el culpable de la revuelta del pueblo."
,"24":"Entonces fue cuando Jeroboam, hijo de Nabat, hizo pecar a Israel, enseñándole a Efraím los caminos del mal. Y sus pecados fueron aumentando hasta tal punto que se hicieron deportar de su país."
,"25":"Se entregaron a todo lo que es malo hasta que el castigo recayó sobre ellos."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Luego, apareció, como un fuego, el profeta Elías, cuyas palabras quemaban como un antorcha."
,"2":"Hizo que cayera sobre ellos el hambre, su amor lleno de celo los redujo casi a la nada."
,"3":"¡Una palabra del Señor, y el cielo retenía la lluvia! Tres veces además dejó caer el rayo."
,"4":"¡Oh Elías, tus milagros constituyeron tu gloria! ¿Quién podría vanagloriarse de ser como tú?"
,"5":"A una sola palabra del Altísimo, hiciste que un muerto se levantara, arrancándolo del mundo de los muertos, de la Morada de abajo."
,"6":"Por ti, reyes se fueron a la ruina, y hombres importantes no se levantaron más de su cama."
,"7":"Tu escuchaste en el monte Sinaí una sentencia, conociste en el Horeb el castigo decretado por Dios."
,"8":"Consagraste a reyes para que hicieran justicia, y a profetas para que continuaran tu misión."
,"9":"Después fuiste arrebatado en un torbellino de fuego, en un carro con caballos de fuego."
,"10":"Está escrito que volverás un día para apaciguar la cólera lista para estallar, para que los padres se reconcilien con los hijos y para restablecer las tribus de Jacob."
,"11":"¡Oh Elías, felices los que te vieron, y que luego se durmieron en el amor! - porque nosotros también ciertamente que viviremos."
,"12":"Cuando Elías fue llevado en un torbellino, Eliseo quedó lleno de su espíritu. Ningún príncipe pudo intimidarlo todo el tiempo que vivió, ni nadie pudo dominarlo."
,"13":"Nada fue imposible para él y hasta en el sueño de la muerte hizo obra de profeta."
,"14":"En vida hizo prodigios, y después de muerto, todavía obró milagros."
,"15":"A pesar de todo el pueblo no se convirtió. No renunciaron a sus pecados, de tal manera que fueron llevados lejos de su país y dispersados por toda la tierra."
,"16":"Sólo quedó un pueblo muy pequeño, con un soberano de la casa de David. De esos reyes, unos hicieron lo que le agrada al Señor, pero otros multiplicaron sus pecados."
,"17":"El rey Ezequías fortificó la ciudad y llevó el agua hasta dentro de sus murallas; cavó un túnel en la roca y construyó estanques para el agua."
,"18":"Durante su reinado, llegó Senaquerib para atacarlo; envió a Rabsaqués, quien se presentó en su nombre y organizó el asalto a Sión. Llegó para jactarse con arrogancia."
,"19":"Todos entonces se descorazonaron, y sus manos se pusieron a temblar; se sentían tan angustiados como una mujer que va a dar a luz."
,"20":"Pero invocaron al Señor, al Misericordioso, y tendieron sus manos hacia él; y el Santo, desde lo alto del cielo, los escuchó inmediatamente, y los salvó por la intervención de Isaías."
,"21":"El Señor castigó al campamento de los asirios, su ángel los exterminó."
,"22":"Porque Ezequías hacía lo que le gusta al Señor; se atuvo firmemente a los ejemplos de David, su padre. El profeta Isaías, que fue tan grande y cuyas visiones no engañaban a nadie, se encargaba de enseñárselos."
,"23":"Con él fue que el sol dio marcha atrás, cuando prolongó la vida del rey."
,"24":"Inspirado de manera extraordinaria, Isaías vio lo que iba a pasar y dejó un mensaje a los afligidos de Sión."
,"25":"Reveló lo que ocurrirá hasta el fin de los tiempos y mostró las cosas ocultas antes que sucedieran."
}`)
	CurrentBook.AddChapter(49, `{
"1":"El recuerdo de Josías es como un perfume de incienso preparado con todo el arte del perfumista, es como una miel suave al paladar, es como una música en medio de un festín y del vino."
,"2":"Porque tomó el camino recto y convirtió al pueblo: él suprimió los ídolos abominables que eran el origen del pecado."
,"3":"Había enderezado su corazón hacia el Señor y restauró la piedad en una época en que triunfaban los sin ley."
,"4":"Fuera de David, Ezequías y Josías, todos los demás no hicieron más que multiplicar sus pecados. Los reyes de Judá abandonaron la ley del Altísimo y por eso fueron abandonados."
,"5":"Debieron someterse a otros y ceder su patrimonio a una nación extranjera."
,"6":"La ciudad elegida, la ciudad santa fue incendiada, y los caminos que conducían a ella quedaron desiertos."
,"7":"Intervino Jeremías, al que habían maltratado. Fue consagrado como profeta desde el vientre de su madre: tenía que arrancar, destruir y dejar en ruinas, y luego construir y plantar."
,"8":"Luego fue Ezequiel el que contempló en una visión la gloria del Señor: la que le fue mostrada en el carro de querubines."
,"9":"Ezequiel hizo alusión a los rebeldes cogidos en el huracán, pero vino para ayudar a los que siguen el recto camino."
,"10":"En cuanto a los doce Profetas, que sus huesos reflorezcan donde cayeron. Porque consolaron a Jacob, lo salvaron reavivando sus esperanzas."
,"11":"¿Podremos elogiar dignamente a Zorobabel, quien fue como 'el anillo que se lleva en la mano derecha'?"
,"12":"¿Y hacer lo mismo con Josué, hijo de Josedec? Porque ellos reconstruyeron la Casa de Dios; reedificaron el santo templo del Señor, dejándolo listo para una gloria imperecedera."
,"13":"También Nehemías dejó un gran recuerdo: volvió a levantar nuestras murallas en ruinas, restauró nuestras puertas y sus cerrojos, reconstruyó nuestras casas."
,"14":"¡Nadie fue creado en esta tierra con el destino de Enoc, quien fue arrancado de este mundo!"
,"15":"¡Ningún hombre ha nacido igual a José, el jefe de sus hermanos y el apoyo de su pueblo, a quien se le prometió que lo trasladarían de su tumba!"
,"16":"Sem y Set han sido grandes para la humanidad, pero ¡Adán es superior a toda criatura viviente!"
}`)
	CurrentBook.AddChapter(50, `{
"1":"Hablemos también del sumo Sacerdote Simón, hijo de Onías. Durante su vida reparó la Casa del Señor, en su tiempo se reparó el Santuario."
,"2":"Puso los cimientos de la segunda muralla y rodeó el Santuario con una fortificación."
,"3":"También en su tiempo se cavó el depósito para el agua, un estanque tan grande como el mar."
,"4":"En previsión de nuevas desgracias para su pueblo, fortificó la ciudad contra un eventual asalto."
,"5":"¡Qué majestuoso se veía cuando salía de detrás del velo del Templo, rodeado de su pueblo!"
,"6":"Era como la estrella matutina en medio de las nubes, como la luna llena en toda su plenitud;"
,"7":"como el sol que ilumina el Templo del Altísimo, como el arco iris cuya luz transfigura las nubes;"
,"8":"como el rosal en flor en primavera, como el lirio junto a la fuente, como ramas de un árbol oloroso en verano,"
,"9":"como el fuego y el aroma del incensario, como un vaso de oro macizo adornado con toda clase de piedras preciosas,"
,"10":"como olivo cargado de frutos, como el ciprés que se alza hasta las nubes."
,"11":"Así era Simón cuando subía al santo altar de los sacrificios, revestido con su túnica de fiesta y con sus preciosos ornamentos; su gloria centelleaba en el recinto del Santuario."
,"12":"De pie junto al brasero del altar, recibía de manos de los sacerdotes las carnes sacrificadas: sus hermanos formaban una corona a su alrededor como el follaje de los cedros del Líbano, o hacían un círculo en torno a él como troncos de palmeras."
,"13":"Entonces todos los hijos de Aarón, revestidos de sus ornamentos, iban a ponerse frente a la asamblea de Israel, llevando en sus manos la ofrenda del Señor."
,"14":"Simón ejecutaba en el altar los ritos litúrgicos y presentaba con gran dignidad la ofrenda al Altísimo, al Todopoderoso."
,"15":"Tomando la copa de vino, dejaba que corriera suavemente el jugo de la uva al pie del altar, como perfume agradable para el Altísimo, el Rey del universo."
,"16":"Entonces los hijos de Aarón lanzaban gritos de aclamación, tocaban las trompetas de plata forjada y hacían oír su sonido poderoso, como para llamar la atención del Altísimo."
,"17":"El pueblo entero de un solo golpe se echaba de bruces en el suelo: adoraban al Señor, al Todopoderoso, al Dios Altísimo."
,"18":"Los cantores lo alababan a voz en cuello: era una inmensa y dulce armonía."
,"19":"El pueblo suplicaba al Señor Altísimo y se mantenía en oración delante del Misericordioso, hasta que se acababa el homenaje al Señor y se terminaba la liturgia."
,"20":"Entonces bajaba del altar y extendía sus manos sobre la asamblea de los hijos de Israel: bendecía con sus labios al Señor y pronunciaba con toda solemnidad su Nombre."
,"21":"Y el pueblo se prosternaba de nuevo para recibir la bendición del Altísimo."
,"22":"¡Y ahora bendigan al Dios del Universo que hace en todas partes grandes cosas! Desde que nacemos nos hace vivir, y nos trata siempre con misericordia."
,"23":"¡Que nos dé la alegría de corazón, que tengamos la paz en nuestros días, que Israel goce de ella hasta el fin de los tiempos!"
,"24":"¡Que el Señor mantenga su benevolencia con nosotros, y que nos libre a lo largo de nuestros días!"
,"25":"¡Hay dos naciones que me exasperan y una tercera que ni siquiera merece llamarse de tal."
,"26":"Son los que moran en la montaña de Seír, los filisteos, y también ese estúpido pueblo que vive en Siquem!"
,"27":"Jesús, hijo de Sirac, hijo de Eleazar de Jerusalén, fue quien puso en este libro tanta enseñanza y tanto saber; vertió en él toda la sabiduría que llevaba en su interior."
,"28":"¡Feliz el que lo lea continuamente! Si le presta atención, se hará sabio; si lo pone en práctica, se sentirá lo bastante fuerte en cualquier circunstancia, porque la luz del Señor iluminará su camino."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Quiero glorificarte, mi Señor y mi Rey, te bendeciré, oh Dios, mi Salvador, y daré gracias a tu nombre."
,"2":"Porque te has hecho mi protector, mi apoyo, y no has permitido que se pierda mi cuerpo, que fuera presa de las calumnias, de las argucias de los mentirosos. ¡Cuando estaba frente a mis acusadores, tú me acompañaste y me libraste!"
,"3":"¡Grande es tu misericordia, grande es tu Nombre!,me arrancaste de las fauces listas para devorarme, de las manos de los que querían quitarme la vida, me salvaste de múltiples pruebas,"
,"4":"de las llamas sofocantes que me rodeaban: y no me quemé en medio del fuego!"
,"5":"Me rescataste de la Morada de abajo,y también de la lengua impura y mentirosa,"
,"6":"cuando con sus calumnias me acusaban ante el Rey. Estaba yo al borde de la tumba, y mi vida oscilaba hacia la muerte."
,"7":"¡Me rodeaban, pero nadie me ayudaba!,¡Buscaba un socorro humano, pero en vano!"
,"8":"Me acordé, Señor, de tu misericordia, de tus intervenciones en el pasado, pues tú libras a los que en ti se apoyan,y los salvas de manos del adversario."
,"9":"Y elevé de la tierra mi súplica, llamé a Dios de las puertas de la muerte."
,"10":"Invoqué al Señor, Padre de mi Señor: 'No me abandones en estos días de angustia, cuando festejan el verme sin socorro.',Continuamente alabaré tu Nombre,y te agradeceré por medio de himnos."
,"11":"Mi oración fue escuchada: me salvaste de la ruina,y me libraste de esta hora fatal."
,"12":"Por eso, quiero darte gracias y cantarte, bendeciré el Nombre del Señor."
,"13":"Desde que era joven, antes de todos mis viajes, resueltamente he pedido en mi oración la sabiduría."
,"14":"Me quedaba frente al Santuario para pedirla, y hasta el final la buscaré."
,"15":"En ella hallé mi alegría: venía como flor de un racimo que madura. Avancé en mi camino sin desviarme, y seguí sus huellas desde mi juventud."
,"16":"Apenas empecé a ponerle atención, se me concedió, y encontré en ella toda una doctrina."
,"17":"¡Cuánto no progresé gracias a ella! Quiero rendirle gloria al que me la dio."
,"18":"Me había decidido a ponerla en práctica, busqué ardientemente el bien y no me he arrepentido de ello."
,"19":"Me hizo soportar duros combates, pues me esforcé por cumplir toda la Ley. Levantaba mis manos hacia el cielo, deplorando mis insuficiencias al respecto."
,"20":"Me volví a ella con toda mi alma, y la encontré a fuerza de purificación. Por lo demás, fue debido a ella que, desde el comienzo, fui amo de mi corazón: ahora no me abandonará jamás."
,"21":"El deseo de adquirirla me dominaba totalmente, y al final conseguí la parte mejor."
,"22":"El Señor me recompensó con el don de la palabra: así seré capaz de alabarle."
,"23":"¡Acérquense, ustedes que no saben, vengan a pasar un tiempo en la escuela de la sabiduría!"
,"24":"¿Por qué dicen que la sabiduría no es para ustedes, siendo que están sedientos de ella?"
,"25":"Les declaro con toda convicción: ¡Adquiéranla, y sin pagar nada!"
,"26":"¡Doblen su cuello para que reciban su yugo, y obtendrán la instrucción! Salgan a su encuentro, que ya está cerca."
,"27":"Abran los ojos y vean que he penado poco para llegar a un tal descanso."
,"28":"Para pagar su instrucción no sería suficiente un montón de plata; con ella, en cambio, tendrán oro en abundancia."
,"29":"Alégrense pues de la misericordia del Señor, no tengan vergüenza de alabarlo."
,"30":"Terminen el trabajo de ustedes antes que suene la hora, y cuando sea el tiempo, el Señor los recompensará."
}`)

}
func ES_LBL_LoadVSIBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Había en el país de Us un hombre llamado Job; era un varón perfecto que temía a Dios y se alejaba del mal."
,"2":"Tuvo siete hijos y tres hijas."
,"3":"Tenía muchos servidores y poseía siete mil ovejas, tres mil camellos, quinientas yuntas de bueyes y quinientas burras. Este hombre era el más famoso entre todos los hijos de oriente."
,"4":"Sus hijos acostumbraban a celebrar banquetes por turno, en casa de cada uno de ellos, e invitaban también a sus tres hermanas a comer y beber con ellos."
,"5":"Una vez terminados los días de esos banquetes, Job los mandaba a llamar para purificarlos; se levantaba muy temprano y ofrecía sacrificios por cada uno de ellos, pues decía: 'Puede que mis hijos hayan pecado y ofendido a Dios en su corazón.',Así hacía Job."
,"6":"Un día, cuando los hijos de Dios vinieron a presentarse ante Yavé, apareció también entre ellos Satán."
,"7":"Yavé dijo a Satán: '¿De dónde vienes?' Satán respondió: 'Vengo de la tierra, donde anduve dando mis vueltas.'"
,"8":"Yavé dijo a Satán: '¿No te has fijado en mi servidor Job? No hay nadie como él en la tierra. Es un hombre bueno y honrado, que teme a Dios y se aparta del mal.'"
,"9":"Satán respondió: '¿Acaso Job teme a Dios sin interés?"
,"10":"¿No lo has rodeado de un cerco de protección a él, a su familia y a todo cuanto tiene? Has bendecido el trabajo de sus manos y sus rebaños hormiguean por el país."
,"11":"Pero extiende tu mano y toca sus pertenencias. Verás si no te maldice en tu propia cara.'"
,"12":"Entonces dijo Yavé a Satán: 'Te doy poder sobre todo cuanto tiene, pero a él no lo toques.' Y Satán se retiró de la presencia de Yavé."
,"13":"Un día los hijos y las hijas de Job estaban comiendo y bebiendo en casa del hermano mayor."
,"14":"Vino un mensajero y le dijo a Job: 'Tus bueyes estaban arando y las burras pastando cerca de ellos."
,"15":"De repente aparecieron los sabeos y se los llevaron y a los servidores los pasaron a cuchillo. Sólo yo pude escapar para traerte la noticia.'"
,"16":"Todavía estaba hablando, cuando llegó otro que dijo: 'Cayó del cielo fuego de Dios y quemó completamente a las ovejas y sus pastores. Sólo escapé yo para anunciártelo.'"
,"17":"Aún no terminaba de hablar, cuando entró un tercero, diciendo: 'Los caldeos, divididos en tres grupos, se lanzaron sobre tus camellos, se los llevaron, dieron muerte a espada a tus mozos y sólo yo he escapado para anunciártelo.'"
,"18":"Estaba éste contando lo sucedido cuando un último lo interrumpió, diciendo: 'Tus hijos e hijas estaban comiendo y bebiendo vino en casa del mayor de ellos."
,"19":"De repente sopló un fuerte viento del desierto y sacudió las cuatro esquinas de la casa; ésta se derrumbó sobre los jóvenes y han muerto todos. Sólo yo pude escapar para traerte la noticia.'"
,"20":"Entonces Job se levantó y rasgó su manto. Luego, se cortó el pelo al rape, se tiró al suelo y, echado en tierra,"
,"21":"empezó a decir: 'Desnudo salí del seno de mi madre, desnudo allá volveré. Yavé me lo dio, Yavé me lo ha quitado, ¡que su nombre sea bendito!'"
,"22":"En todo esto no pecó Job ni dijo nada insensato en contra de Dios."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Otro día en que vinieron los hijos de Dios a presentarse ante Yavé, se presentó también con ellos Satán."
,"2":"Yavé dijo a Satán: '¿De dónde vienes?' Satán respondió: 'De recorrer la tierra y pasearme por ella.'"
,"3":"Yavé dijo a Satán: '¿Te has fijado en mi siervo Job? No hay nadie como él en la tierra; es un hombre bueno y honrado que teme a Dios y se aparta del mal. Aún sigue firme en su perfección y en vano me has incitado contra él para arruinarlo.'"
,"4":"Respondió Satán: 'Piel por piel. Todo lo que el hombre posee lo da por su vida."
,"5":"Pero extiende tu mano y toca sus huesos y su carne; verás si no te maldice en tu propia cara.'"
,"6":"Yavé dijo: 'Ahí lo tienes en tus manos, pero respeta su vida.'"
,"7":"Salió Satán de la presencia de Yavé e hirió a Job con una llaga incurable desde la punta de los pies hasta la coronilla de la cabeza."
,"8":"Job tomó entonces un pedazo de teja para rascarse y fue a sentarse en medio de las cenizas."
,"9":"Entonces su esposa le dijo: '¿Todavía perseveras en tu fe? ¡Maldice a Dios y muérete!'"
,"10":"Pero él le dijo: 'Hablas como una tonta cualquiera. Si aceptamos de Dios lo bueno, ¿por qué no aceptaremos también lo malo?',En todo esto no pecó Job con sus palabras."
,"11":"Tres amigos de Job: Elifaz de Temán, Bildad de Suaj y Sofar de Naamat se enteraron de todas las desgracias que le habían ocurrido y vinieron cada uno de su país. Acordaron juntos ir a visitarlo y consolarlo."
,"12":"Lo miraron de lejos y no lo reconocieron. Entonces se pusieron a llorar a gritos; rasgaron sus vestidos y se echaron polvo sobre la cabeza."
,"13":"Luego, permanecieron sentados en tierra junto a él siete días y siete noches. Y ninguno le dijo una palabra, porque veían que su dolor era muy grande."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Después de esto, Job tomó la palabra para maldecir el día de su nacimiento,"
,"2":"diciendo:"
,"3":"'¡Maldito el día en que nací,y la noche que dijo: Ha sido concebido un hombre!"
,"4":"Conviértase ese día en tinieblas, y Yavé allá arriba lo ignore para siempre; que ningún rayo de luz resplandezca sobre él."
,"5":"Lo cubran tinieblas y sombras, se extienda sobre él la oscuridad, y haya ese día un eclipse total."
,"6":"Que esa noche siga siempre en su oscuridad. Que no se añada a las otras del año, ni figure en la cuenta del mes."
,"7":"Que sea triste aquella noche, impenetrable a los gritos de alegría."
,"8":"Que la maldigan los que odian la luz del día, y que son capaces de llamar al Diablo."
,"9":"Que no se vean las estrellas de su aurora; que espere en vano la luz, y no vea el despertar de la mañana,"
,"10":"pues no me cerró la puerta del vientre de mi madre,para así ahorrarme a la salida la miseria."
,"11":"¿Por qué no morí en el seno,y no nací ya muerto?"
,"12":"¿Por qué hubo dos rodillas para acogerme,y dos pechos para darme de mamar?"
,"13":"¿O por qué no fui como un aborto que se esconde, como los pequeños que nunca vieron la luz?"
,"14":"Pues ahora estaría acostado tranquilamente,y dormiría mi sueño para descansar,"
,"15":"con los reyes y con los ministros del país,que se mandan hacer solitarios mausoleos,"
,"16":"o con los príncipes que amontonan el oro,y repletan de plata sus casas."
,"17":"Allí cesan de moverse los malvados,y descansan los que se encuentran agotados."
,"18":"Los prisioneros son excarcelados,y ya no se oyen los gritos del vigilante."
,"19":"Allí no se distingue el pequeño del grande, y el esclavo se ve libre de su amo."
,"20":"¿Para qué dar la luz a un desdichado, la vida a los que tendrán una vida amarga?"
,"21":"Desean la muerte que no llega,y la buscan más ávidamente que un tesoro;"
,"22":"saltan de júbilo ante el sepulcro,y se alegran cuando llegan a la tumba."
,"23":"¿Para qué dar la vida si el hombre ya no encuentra su camino, ya que Dios le ha cerrado todas las salidas?"
,"24":"Son los suspiros mi alimento, y se derraman como el agua mis lamentos;"
,"25":"si temía algo, eso me ocurre, lo que me atemoriza me ha venido encima."
,"26":"No hay para mí tranquilidad ni calma, mis tormentos no me dejan descansar.'"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Elifaz de Temán tomó la palabra y dijo:"
,"2":"'¿Te molesta si te hablamos?,Pero, ¿cómo guardar silencio?"
,"3":"Mira, tú dabas lección a mucha gente, les dabas fuerza a los que se sentían débiles."
,"4":"Con tu palabra sostenías a aquel que vacilaba, robustecías las piernas de los endebles;"
,"5":"¿y ahora que te llega a ti la hora, te impacientas; ahora que te toca a ti, estás tan conmovido?"
,"6":"¿No te da confianza tu respeto al derecho?,¿No te sientes seguro por tu buena conducta?'"
,"7":"Recuerda, pues, ¿cuándo ha perecido un inocente, dónde se ha visto que los buenos desaparezcan?"
,"8":"He observado a los que hacen el mal: los mismos que lo siembran lo cosechan."
,"9":"Dios los hace perecer con el aliento de su boca,y los aniquila con el soplo de su cólera."
,"10":"Ruge el león, aulle el leopardo, pero a la fiera se le rompen los dientes."
,"11":"El león se muere porque no encuentra presa, y los cachorros de la leona se dispersan."
,"12":"Una revelación me hicieron en secreto, y su eco furtivo captaron mis oídos."
,"13":"En el momento en que se tienen pesadillas, cuando una pesadez se apodera de los hombres,"
,"14":"sentí un escalofrío de terror,y mis huesos se pusieron a temblar."
,"15":"Un soplo se deslizó sobre mi cara,y se me pusieron de punta los pelos de la piel."
,"16":"Alguien está... no distingo su cara, pero veo una figura ante mis ojos. Hay silencio... luego escucho hablar en voz baja:"
,"17":"¿Hay algún hombre que se encuentre bueno delante de Dios?"
,"18":"¿Será puro algún mortal a los ojos de su Hacedor?,Ni siquiera en sus servidores Dios confía, El, que descubre fallas en sus mismos ángeles."
,"19":"¿Qué decir de los que viven en casas de barro, cuyos cimientos no son más que de polvo,"
,"20":"a los que se aplasta de un golpe como un insecto?,Son hechos trizas de la noche a la mañana, sin decir pío."
,"21":"Su tienda les ha sido desarmada,y murieron sin darse de ello cuenta."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Llama, pues, si quieres; ¿quién te responderá?,¿A cuál de los santos te dirigirás?"
,"2":"¿Rebelarte? Así perece el insensato. ¿Enojarte? De eso mueren los tontos."
,"3":"Yo he visto al insensato echar raíces, de pronto se derribó su casa: '¡Que a sus hijos nadie los socorra!"
,"4":"No encontraban sus hijos quién los ayudara,o defendiera de los ataques en un corte."
,"5":"Hambrientos les robaban sus cosechas, llevándolas a sus escondites.',Se les arrebatarán sus bienes,y los sedientos tomaban sus bienes."
,"6":"No, el desorden no nace de la tierra, ni desde el suelo brota la desgracia."
,"7":"El hombre engendra su propio castigo, así como en las nubes hace estallar el águila el rayo."
,"8":"Yo, en tu lugar, a Dios recurriría,y a él expondría mi causa."
,"9":"A él, que hace cosas grandes e insondables, maravillas innumerables."
,"10":"A él, que derrama la lluvia sobre la tierra,y envía las aguas a los campos."
,"11":"Ensalza a los humildes,y alivia a los afligidos,"
,"12":"desbarata los planes de los astutos, y aunque quieran no pueden reponerse."
,"13":"Atrapa a los sabios en su astucia, y las decisiones de los sagaces no aciertan."
,"14":"En pleno día los asaltan tinieblas, y van a tientas como si fuera de noche."
,"15":"Así salva Dios al arruinado cuando lo persiguen,y libra al pobre de las manos del poderoso."
,"16":"Así el débil renace a la esperanza, y la injusticia tiene que callar."
,"17":"¡Dichoso el hombre a quien Dios corrige!,No desprecies, pues, la lección del Omnipotente,"
,"18":"pues él es el que hiere y el que venda la herida, él lastima y después cura sus manos."
,"19":"Seis veces te librará de la angustia, y a la séptima el mal no te alcanzará."
,"20":"Durante el hambre, te salvará de la muerte; y en la guerra, del golpe de la espada."
,"21":"Estarás protegido de la lengua malvada, sin miedo a que llegue el salteador."
,"22":"Te reirás de la sequía y del hambre, y no temerás a los animales feroces."
,"23":"No más piedras en tus campos: la tierra te servirá, y las bestias salvajes no te atacarán."
,"24":"Sabrás que en tu tienda todo prospera, al visitar tus tierras no verás allí perjuicios."
,"25":"Verás multiplicarse tu descendencia, y tus renuevos como la hierba de la tierra."
,"26":"Llegarás a la tumba cargado de años,como se recogen a su tiempo las gavillas."
,"27":"Todo esto lo hemos comprobado y así es. Lo hemos visto, comprúebalo tú también."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Job tomó la palabra y dijo:"
,"2":"'Si se pudiese pesar mi aflicción,y poner mis males sobre una balanza,"
,"3":"pesarían más que la arena de los mares, y por eso hablo tan impetuosamente."
,"4":"Llevo en mí las flechas del Omnipotente,mi espíritu bebe su veneno, ¿qué diré a Dios cuando ellas me atormentan?"
,"5":"¿Rebuzna acaso un burro junto a la hierba verde?,¿Muge un buey junto al forraje?"
,"6":"¿Tiene gusto la comida sin sal?,¿Se encontrará sabor en la clara del huevo?"
,"7":"Pero ahora sólo tengo por pan,todo lo que no quería tocar."
,"8":"¡Ojalá se escuchara mi ruego,y Dios me concediera lo que espero,"
,"9":"que por fin se decida a aplastarme, que deje caer su mano y me suprima."
,"10":"Al menos tendría consuelo,y gozo en medio de mi terrible susto, porque no habría maldecido la decisión del Santo."
,"11":"¿Tendré aún fuerzas para esperar, y qué futuro puedo esperar aún?"
,"12":"¿Acaso resistiré como la roca?,¿Es mi carne de bronce?"
,"13":"Ya no encuentro en mí fuerza que me salve,y toda ayuda se ha ido lejos de mí."
,"14":"El que niega la compasión al prójimo,desecha el temor del Omnipotente."
,"15":"Mis hermanos me han fallado como un arroyo, como un torrente que dura sólo un tiempo:"
,"16":"Era el derretimiento de los hielos, las aguas brotaban por debajo de las nieves,"
,"17":"pero llega el verano y se evaporan, en cuanto hace calor queda seco su lecho."
,"18":"En busca de ellos las caravanas alargan su camino, se hunden en lo desconocido."
,"19":"Los viajeros de Temán se ubicaban con ellos, y se dirigían hacia ellos las caravanas de Sabá,"
,"20":"pero su esperanza ha sido en vano, al llegar no saben qué hacer."
,"21":"Así son ahora ustedes para mí. Han visto cosas horribles y les entra miedo."
,"22":"¿Les he dicho acaso: 'Denme algo, rescátenme con algo de su fortuna,"
,"23":"o líbrenme de una mano enemiga,y rescátenme de manos de algún opresor?"
,"24":"Aclárenme esto y callaré. Háganme ver en qué me he equivocado."
,"25":"¡Da gusto escuchar una sana corrección!,Pero, ¿qué pretenden con sus sermones?"
,"26":"¿Quieren sólo condenar mis palabras, o rectificar lo dicho por un hombre que sufre?"
,"27":"Mas ustedes disponen de mí como de un indefenso,y traicionan a su propio amigo."
,"28":"Se lo pido, mírenme, no les mentiré a la cara."
,"29":"¡Comiencen de nuevo, pero sin faltar a la justicia!,Retomemos el examen de mi causa."
,"30":"¿Hay acaso falsedad en mis discursos?,¿No sé todavía distinguir el mal del bien?'"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Un trabajo forzado es la vida del hombre sobre la tierra, y sus días son los de un jornalero."
,"2":"Se parece al esclavo que suspira por la sombra, o al jornalero que espera su salario."
,"3":"Así, a mí me han tocado meses de decepción, y fueron mi parte noches de dolor."
,"4":"Al acostarme digo: '¿Cuándo llegará el día?',Al levantarme: '¿Cuándo será de noche?',Y hasta el crepúsculo me abruman mis inquietudes."
,"5":"Mi carne está cubierta de gusanos y costras, mi piel se ha arrugado y se deshace,"
,"6":"mis días han corrido más rápidos que la lanzadera, y se pararon cuando ya no hubo hilo."
,"7":"Recuerda que mi vida es un soplo, y que mis ojos no verán más la felicidad."
,"8":"Los ojos que me miraban ya no me verán, y si me buscas ya no estaré."
,"9":"Así como la nube se disipa y pasa, así el que baja donde los muertos no sube más."
,"10":"No volverá a su casa,y los lugares en que estuvo no lo verán jamás."
,"11":"Por eso, no quiero callarme,sino que expresaré la angustia de mi espíritu,y haré que escuchen la pena de mi alma."
,"12":"¿Soy acaso el mar o el Monstruo marino, para que pongas guardia a mi alrededor?"
,"13":"Si digo: 'Mi cama me consolará, y mi jergón aliviará mi llanto',"
,"14":"entonces tú me asustas con sueños,y me aterrorizas con visiones."
,"15":"Preferiría ser sofocado: la muerte antes que estos dolores."
,"16":"Mira que desfallezco, no viviré para siempre. ¡Déjame! Ves que mis días son un soplo."
,"17":"¿Qué es el hombre,para que te fijes tanto en él,y pongas en él tu mirada,"
,"18":"para que lo vigiles cada mañana,y lo pongas a prueba a cada instante?"
,"19":"¿Cuándo apartarás de mí tus ojos,y me darás tiempo de tragar mi saliva?"
,"20":"Si he pecado, ¿qué te he hecho a ti, guardián de los hombres?,¿Por qué me has tomado como blanco de tus golpes?,¿En qué te molesto?"
,"21":"¿No puedes soportar mi falta,y hacer la vista gorda ante mi pecado?,Porque pronto me voy a acostar en el polvo, y cuando me busques, ya no existiré.'"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Entonces Bildad de Suaj dijo:"
,"2":"'¿Hasta cuándo hablarás así,y soltarás tus palabras como viento que no cesa?"
,"3":"¿Acaso Dios tuerce el derecho,y el Altísimo ha faltado a la justicia?"
,"4":"Si tus hijos pecaron contra él, él ya los entregó en manos de su maldad."
,"5":"Pero si recurres a Dios,e imploras al Omnipotente,"
,"6":"si eres puro y sincero, él cuidará de ti inmediatamente,para ponerte en el lugar que mereces por ser justo."
,"7":"Tu antiguo estado parecerá bien poco, tan feliz será el nuevo."
,"8":"Pregunta a la generación pasada,y medita en la experiencia de tus padres."
,"9":"Nosotros somos de ayer, no sabemos nada, pues en la tierra pasamos como una sombra."
,"10":"Pero ellos te enseñarán y te hablarán, expresarán para ti su pensamiento."
,"11":"¿Acaso crece el papiro fuera del pantano,y el junco donde no hay aguas?"
,"12":"Aún en su verdor, antes de que lo corten, se seca más pronto que cualquier hierba."
,"13":"Esta es la suerte de los que olvidan a Dios, así perecen las esperanzas del impío."
,"14":"Su confianza pende de un hilo,y su seguridad es una tela de araña."
,"15":"Si se apoya en ella, no lo aguanta, se agarra a ella, y no resiste."
,"16":"A la luz del sol crecía vigoroso,y con sus ramas cubría el jardín."
,"17":"Sus raíces serpenteaban por la pendiente, se adherían a las rocas."
,"18":"Pero lo han quitado de su lugar,y lo niega su propio sitio: 'Nunca te he visto.'"
,"19":"Véanlo cómo se pudre en el camino, mientras que en el suelo brotan otros."
,"20":"No, Dios no desprecia al hombre íntegro, ni tampoco toma de la mano a los malvados."
,"21":"Tu boca aún se llenará de risa, se verá en tus labios la alegría."
,"22":"Tus enemigos se avergonzarán,y la carpa de los malos desaparecerá.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Job tomó la palabra y dijo:"
,"2":"'En verdad, yo sé muy bien que es así. ¿Cómo puede un hombre justificarse ante Dios?"
,"3":"Si quisiere discutir con él, no podría responderle ni una entre mil veces."
,"4":"Su corazón es sabio y su fuerza es enorme. ¿Quién puede resistirle inpunemente?"
,"5":"El traslada los montes sin que se den cuenta,y los sacude en su furor."
,"6":"El remueve la tierra de su sitio,y sus columnas se bambolean."
,"7":"Si él no quiere, no aparece el sol, y si él las tapa, no lucen las estrellas."
,"8":"El solo desplegó la bóveda de las estrellas,y camina por encima de los mares."
,"9":"El ha dispuesto la Osa y Orión, las Pléyades y las Cámaras del sur,"
,"10":"hace cosas tan grandes que son insondables, y maravillas que no pueden contarse."
,"11":"Si pasa junto a mí, yo no lo veo, si me pasa a rozar, no me doy cuenta."
,"12":"Si se apodera de una presa, ¿quién se lo impedirá?,¿Quién podrá decirle: qué es lo que haces?"
,"13":"Dios no se vuelve atrás cuando se enoja; bajo él quedan postrados los monstruos de antaño"
,"14":"¿Quieren que yo vaya a replicarle,y me ponga a discutir con él,"
,"15":"o que le suplique a mi juez,que no me responde aun cuando tengo la razón?"
,"16":"Podría apelar a él, aguardando una respuesta, pero, ¿cómo creer que me atenderá?"
,"17":"El, que me aplasta sólo por un pelo,y que multiplica sin razón mis heridas,"
,"18":"que no me deja ni respirar,con tantas amarguras que me hace tragar."
,"19":"¿Recurriré a la fuerza? El es más forzudo, y si le meto pleito, ¿quién le hará la citación?"
,"20":"Si me doy la razón, mi boca puede condenarme, y si me encuentro inocente, ella me declarará culpable."
,"21":"Pero, ¿realmente soy bueno? ¡Ni yo mismo lo sé!,¡La vida no tiene sentido!"
,"22":"Pues todo es igual, y puedo decir: Le quita la vida tanto al bueno como al malo."
,"23":"Si una calamidad trae repentinamente la muerte, se ríe de la desesperación de los inocentes."
,"24":"En nación dominada por un tirano, él venda los ojos de los jueces, pues si no es él, ¿quién será entonces?"
,"25":"Mis días han sido más rápidos que un correo, se me fueron sin conocer la felicidad,"
,"26":"se han deslizado lo mismo que canoas de junco, como el águila que se lanza sobre la presa."
,"27":"A pesar de que digo: 'Voy a olvidar mis quejas, cambiaré de semblante y me pondré alegre',"
,"28":"mis pruebas me dejan angustiado,porque entiendo que tú me condenas."
,"29":"Y si debo ser culpable, ¿para qué cansarme en vano?"
,"30":"Aunque me lave con nieve,y limpie mis manos con jabón,"
,"31":"tú me hundirías en las inmundicias, y mis propias ropas tendrían horror de mí."
,"32":"El no es un hombre como yo, para decirle: Comparezcamos juntos en juicio."
,"33":"Entre nosotros se necesitaría un árbitro,que tomara por la espalda uno y otro"
,"34":"y apartaría su vara que me pega,y el espanto en que me sumen sus terrores."
,"35":"Puesto que es así, yo hablaré a solas conmigo sin tenerle miedo.'"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Mi alma está hastiada de la vida, por lo que daré libre curso a mi queja, hablaré de mi amargura."
,"2":"Quiero decirle a Dios: No me condenes; dime por qué me has demandado."
,"3":"¿Acaso te conviene mostrarte duro, despreciar la obra de tus manos,y justificar las teorías de los malvados?"
,"4":"¿Tienes tú ojos humanos?,¿Ves como un hombre?"
,"5":"¿Son tus días como los del hombre, o pasan tus años como los de un mortal,"
,"6":"para que andes rebuscando mi falta, indagando mi pecado?"
,"7":"Sabes muy bien que yo no soy culpable,y que nadie puede librarme de tu mano."
,"8":"Tus manos me han modelado, me han formado, y luego, enojado, ¿me quieres destruir?"
,"9":"Acuérdate que me amasaste como el barro,¿y ahora me harás volver al polvo?"
,"10":"¿No me derramaste como leche,y me hiciste cuajar como el queso?"
,"11":"De piel y de carne me cubriste,y de huesos y nervios me tejiste,"
,"12":"hiciste en mí una obra de vida y de gracia, tus atenciones han mantenido mi aliento."
,"13":"Pero veo que tenías secretas intenciones,y sé lo que pensabas:"
,"14":"querías ver si yo pecaría, si pecaba, no dejarme pasar nada."
,"15":"Si soy culpable, ¡desgraciado de mí!, y si soy inocente, no me animo a levantar la cabeza; estoy saciado de vergüenza, embriagado de aflicción."
,"16":"Estoy agotado, pero como un león me persigues, quieres demostrar tu superioridad;"
,"17":"redoblas tus asaltos y tu furor se reanima, y lanzas de nuevo tus ataques en mi contra."
,"18":"¿Por qué me sacaste del seno materno?,Habría muerto y ningún ojo me habría visto."
,"19":"Sería como si no hubiese existido nunca,y me habrían llevado del vientre materno al sepulcro."
,"20":"Puesto que son pocos los días que me quedan,apártate de mí, que goce un poco de alegría,"
,"21":"antes de que me vaya, para no volver más, a la región de tinieblas y de sombra,"
,"22":"tierra donde todo se confunde de noche, y la misma claridad está hecha de tinieblas.'"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Sofar de Naamat tomó la palabra y dijo:"
,"2":"'Al hablador, ¿no se le contestará?,Por hablar mucho, ¿tendrás tú la razón?"
,"3":"Tu palabrería, ¿hará guardar silencio a los demás?,¿Acaso te burlarás sin que nadie responda?"
,"4":"Tú has dicho: 'Es pura mi conducta,y soy irreprochable a los ojos de Dios."
,"5":"¡Ojalá hablara Dios, ojalá te viniera a contestar"
,"6":"y te revelara los secretos de la Sabiduría, que desconciertan a los más entendidos!; Comprenderías que él te pide cuenta de tu falta."
,"7":"¿Pretendes sondear lo profundo de Dios, elevarte hasta la perfección del Omnipotente?"
,"8":"Es más alta que los cielos, ¿qué harás?,Más profunda que el infierno, ¿cómo la conocerás?"
,"9":"Su amplitud es más extensa que la tierra, y más ancha que el mar."
,"10":"Si él quiere pasar, si cierra el paso, si toma algo, ¿quién se lo impedirá?"
,"11":"Porque él reconoció a los que son falsos, ¡vió el pecado, lo entendió!"
,"12":"Así, el insensato se hace cuerdo,como se amansa el pollino salvaje.'"
,"13":"'Pon la mano, pues, en tu corazón,y tiende tus manos hacia El,"
,"14":"aleja la maldad que hay en tus manos,y no dejes que la injusticia habite en tus tiendas,"
,"15":"entonces levantarás tu frente limpia, te sentirás firme y sin temor."
,"16":"Se te olvidarán tus penas,y su recuerdo será como de aguas que pasaron."
,"17":"La vida será para ti más resplendeciente que el medodía, en que los rincones mismos son todavía mañanas."
,"18":"Vivirás seguro, lleno de esperanza, serás protegido y te acostarás tranquilo."
,"19":"Cuando te acuestes, no te molestarán,y muchos te vendrán a adular."
,"20":"En cambio, se nublará la vista de los malvados, y no tendrán posibilidad alguna de escapar; su única esperanza es la muerte.'"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Job tomó la palabra y dijo:"
,"2":"'¡Todos deben pensar como ustedes,y con ustedes morirá la sabiduría!"
,"3":"Pero yo no tengo menos experiencia: ¿quién no sabe todo lo que han dicho?"
,"11":"Al oyente le corresponde criticar, igual que al paladar saborear lo que come."
,"12":"¿No se halla entre ancianos la sabiduría,y la inteligencia donde hay muchos años?"
,"4":"Pero he pasado a ser objeto de risa para mi amigo, yo que clamo a Dios y no me responde. ¡Motivo de risa es el hombre intachable!"
,"5":"'Desprecio al desdichado', así juzga el satisfecho; 'un golpe más a quien vacila'."
,"6":"Los salteadores viven tranquilos en sus casas, pueden provocar a Dios con toda seguridad, se lo han echado al bolsillo."
,"7":"¿Quieres preguntárselo a las bestias? te instruirán. Pregúntaselo a las aves del cielo, te lo dirán."
,"8":"Los que se arrastran por el suelo te lo enseñarán,y los peces del mar te darán los detalles."
,"9":"¿Quién no sabe entre las criaturas,que todo esto lo hizo la mano de Dios?"
,"10":"El, que tiene en su mano el soplo de todo viviente,y el espíritu de todo ser humano."
,"13":"En él están la sabiduría y el poder, a él pertenecen el consejo y la inteligencia."
,"14":"Si El destruye, nadie puede reconstruir; el prisionero que El tiene no será liberado. Si retiene las aguas, viene la sequía;"
,"15":"si las deja correr, inundan la tierra."
,"16":"Son suyas la fuerza y la prudencia, él sabe quién se equivoca y quién lo hace errar."
,"17":"A los ministros los hace andar descalzos, y vuelve locos a los gobernantes."
,"18":"El desabrocha el cinturón de los reyes, y pone en sus caderas el taparrabos del cautivo."
,"19":"Hace andar descalzos a los sacerdotes,y derriba a los poderosos."
,"20":"Deja callados a los consejeros probados,y priva del recto juicio a los ancianos."
,"21":"Extiende el desprecio sobre los nobles,y a los fuertes se les caen sus armas."
,"22":"Saca de la oscuridad lo que estaba oculto,y saca a la luz lo que estaba en la sombra."
,"23":"Engrandece a las naciones o las destruye, ensancha a los pueblos o los suprime,"
,"24":"desanima a los jefes del país, y los hace vagar por desiertos sin caminos;"
,"25":"caminan a tientas en tinieblas,y se tambalean como un ebrio."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Sí, todo esto lo han visto mis ojos, y mis oídos lo han escuchado y entendido."
,"2":"Todo lo que ustedes saben, yo también lo sé, en nada me aventajan ustedes."
,"3":"Pero yo quisiera hablarle al Todopoderoso,y echárselo en cara a Dios."
,"4":"Ustedes tal vez no son más que charlatanes, y me traen remedios ilusorios."
,"5":"¡Quién pudiera obligarlos a guardar silencio!, eso sería el único acto sabio de ustedes."
,"6":"Oigan, por favor, mis críticas,y fíjense en la defensa que pronuncian mis labios."
,"7":"¿Acaso quieren defender a Dios con argumentos falsos,y justificarlo con mentiras?"
,"8":"¿Así, van ustedes a ponerse de su parte,y a hacer su defensa?"
,"9":"¿No podría ocurrir que los examinase primero,y no les fuera tan bien? El no es un hombre;"
,"10":"los castigaría a ustedes severamente,si favorecieran a alguien en secreto."
,"11":"¿Ya no temen ustedes su Majestad,ni les asusta el terror que inspira?"
,"12":"Los refranes de ustedes no son más que polvo, las murallas de ustedes son muros de barro."
,"13":"¡Cállense, ahora voy a hablar yo, y que me pase cualquier cosa!"
,"14":"Voy a jugarme el todo por el todo,y pongo mi vida en la balanza."
,"15":"No importa que me quite la vida,quiero defender en su presencia mi punto de vista."
,"16":"A lo mejor esto me salva, pues ningún impío comparecería ante El."
,"17":"¡Oigan bien lo que les digo, pongan atención a mis explicaciones!"
,"18":"Voy a ordenar mis argumentos,porque estoy seguro que tengo la razón."
,"19":"Si alguien quiere contradecirme, no me queda más que callarme."
,"20":"Concédeme solamente dos cosas,y no me esconderé más al verte:"
,"21":"saca tu mano que tienes puesta sobre mí,y no me asustes más con tu terror."
,"22":"En seguida, exprésate y yo responderé, o mejor, yo hablaré y tú me rectificarás."
,"23":"¿Cuántas faltas y pecados tengo?,¿Cuál ha sido mi transgresión o mi ofensa?"
,"24":"¿Por qué me vuelves la cara,y me tratas como a un enemigo tuyo?"
,"25":"¿Quieres asustar a una hoja que arrastra el viento,o perseguir a una paja seca,"
,"26":"tú, que dictas contra mí amargas sentencias,y que me achacas los pecados de la juventud,"
,"27":"que colocas cadenas en mis pies,o que vigilas todos mis pasos,observando las huellas de mis pies?"
}`)
	CurrentBook.AddChapter(14, `{
"1":"El hombre nacido de mujer tiene corta vida y llena de problemas."
,"2":"Como la flor, brota y se marchita, y pasa como sombra, sin detenerse. Se deshace como leña carcomida,"
,"3":"como vestido que se come la polilla. ¿Y sobre un ser así pones tú los ojos,y lo citas a juicio frente a ti?"
,"4":"¿Quién podrá sacar lo puro de lo impuro?,¡Nadie!"
,"5":"Sabiendo que sus días están contados, que de ti depende el número de sus meses, y tú le has puesto un límite que no se puede pasar,"
,"6":"aparta de él tu mirada y déjalo,hasta que termine su trabajo diario como un jornalero."
,"7":"El árbol tiene una esperanza: pues, si es cortado, aún pueden salirle renuevos, que seguirán brotando."
,"8":"Aunque sus raíces se hayan envejecido en la tierra, y su tronco muera en el suelo,"
,"9":"al contacto del agua rebrota,y echa ramaje como una planta nueva."
,"10":"Pero el hombre que muere, queda inerte. Cuando un hombre expira, ¿dónde está?"
,"11":"Las aguas del mar podrán desaparecer,o los ríos podrán agotarse y secarse;"
,"12":"el hombre, en cambio, no se levantará. Se gastarán los cielos antes que despierte, nunca saldrán los hombres de su sueño."
,"14":"¡Si pudiera un hombre revivir,"
,"13":"quisiera que me escondieras en el lugar de los muertos,y me ocultaras allí hasta que cese tu ira, fijando una fecha en que vuelvas a acordarte de mí!"
,"14":"a allí, mientras dure mi servicio, esperaría la hora del relevo."
,"15":"Me llamarías y te respondería; reclamarías la obra de tus manos."
,"16":"Acabado el tiempo en que contabas mis pasos, no mirarías ya más mis pecados;"
,"17":"mi delito quedaría sellado en un saco,y mi pecado blanqueado."
,"18":"Pero no; cae el monte,y la roca se cambia de lugar,"
,"19":"las aguas desgastan las piedras,y las lluvias se llevan la tierra, asimismo le quitas al hombre su esperanza."
,"20":"Lo derribas, se acabó, se fue, lo desfiguras y lo mandas al diablo."
,"21":"Si son honrados sus hijos, él no lo sabe; si son despreciados, él no se da cuenta."
,"22":"Sólo puede afligirse por su propia carne,y lamentarse por su alma.'"
}`)
	CurrentBook.AddChapter(15, `{
"1":"Elifaz de Temán tomó la palabra y dijo:"
,"2":"'¿Es ésa la respuesta de un sabio, vanos razonamientos?"
,"3":"Y se hincha con puro viento,defendiéndose con palabras inútiles,y con discursos de que no se saca provecho."
,"4":"¡Tú, incluso, destruyes la piedad, y no quieres pensar más a la manera de Dios!"
,"5":"La maldad de tu interior te hace hablar, te entrega argumentos contradictorios."
,"6":"Tu propia boca te condena, no yo, tus propios labios te acusan."
,"7":"¿Eres tú el primer hombre que ha nacido?,¿Se te dio a luz antes que las colinas?"
,"8":"¿Sabes acaso los secretos de Dios?,¿Eres dueño de toda la sabiduría?"
,"9":"¿Qué sabes tú, que nosotros no sepamos?,¿Qué comprendes, que no comprendamos?"
,"10":"Con nosotros están los ancianos, y hasta nacidos antes que tu padre."
,"11":"¡Así que no te bastan los consuelos de Dios,y las palabras que se te dicen con cariño!"
,"12":"¿Por qué te arrebata tu furor,y por qué brillan tus ojos,"
,"13":"cuando te enojas contra Dios, con palabras que no salen del corazón?"
,"14":"¿Qué es el hombre y cómo podría ser puro?,¿Cómo puede ser justo un hombre nacido de mujer?"
,"15":"Si Dios no confía ni en sus santos, y hasta los cielos no son puros a sus ojos,"
,"16":"¡cuánto menos ese ser abominable y corrompido, el hombre, que bebe la maldad como el agua!"
,"17":"Te lo explicaré si me escuchas, te contaré lo que he visto,"
,"18":"lo que enseñan los sabios, toda la verdad que aprendieron de sus padres,"
,"19":"esos hombres a los que se entregó el país, antes que pasara ningún extranjero."
,"20":"Son un tormento la vida del malvado, los años a los que tiene derecho el violento."
,"21":"Gritos espantosos le resuenan en los oídos. En plena paz sueña con asesinos,"
,"22":"desespera salir de las tinieblas,y se ve cayendo bajo la espada,"
,"23":"tirado en el suelo como pasto de los buitres."
,"24":"Sabe que se acerca el día sin luz, ansiedad y angustia lo vienen a asaltar,su mal es peor que si un rey lo atacase."
,"25":"¡Es que alzaba su mano contra Dios,y se atrevía a retar al Omnipotente!"
,"26":"Corría contra él con la cabeza gacha, protegiéndose con escudo macizo,"
,"27":"pues tenía el rostro hundido en su gordura,y su cintura cubierta de grasa,"
,"28":"habitaba ciudades destruidas, en cuyas casas ya nadie vive,simpre en peligro de derrumbarse."
,"29":"Pero no se enriquecerá, su fortuna no durará; la sombra de su follaje no se extenderá sobre la tierra."
,"30":"El fuego quemará sus brotes,y el viento barrerá su flor."
,"31":"No te fijes en su talla, sabemos que eso es vanidad."
,"32":"Su renuevo se marchitará antes de tiempo, y su rama no reverdecerá;"
,"33":"como la viña dejará caer sus racimos malos, dejará caer como el olivo su flor."
,"34":"Porque la raza del impío es estéril, y el fuego quema la tienda del soborno."
,"35":"Quien concibe el mal da a luz la desgracia, en su propio vientre madura la decepción.'"
}`)
	CurrentBook.AddChapter(16, `{
"1":"Job respondió diciendo:"
,"2":"'¡He oído muchas cosas como éstas!, ¡pesados consoladores son todos ustedes!"
,"3":"¿No se acabarán tus palabras vanas?,¿Que necesidad tienes de discutir?"
,"4":"Yo también podría hablar como ustedes,si estuvieran en mi lugar y yo en el suyo. Podría llenarlos de discursos,y movería la cabeza por ustedes,"
,"5":"los reanimaría con discursos bonitos,hablando con toda libertad."
,"6":"Pero cuando hablo, no se suaviza mi dolor, y si callo, tampoco se aparta de mí."
,"7":"Pues ahora, el envidioso ha agotado mis fuerzas,y su bando se apodera de mí."
,"8":"Se levanta contra mí como acusador, mi calumniador me acusa a la cara."
,"9":"Su furor encontró a quién desgarrar y me persigue, rechinando contra mí sus dientes. Los ojos de mis enemigos me rodean como espadas"
,"10":"y abren contra mí su boca. Han golpeado mis mejillas, se burlan de mí, todos juntos me acosan."
,"11":"Dios me ha entregado a los injustos,y me ha arrojado en manos de los malvados."
,"12":"Yo vivía tranquilo cuando comenzó a sacudirme, me tomó del cuello y me hizo pedazos."
,"13":"Me convirtió en su blanco, por doquier me apuntan sus flechas; traspasa mis entrañas sin piedad,y derrama por el suelo mi hiel."
,"14":"Me llena de heridas,y se lanza contra mí como un guerrero."
,"15":"Me he puesto un saco como traje, y he hundido mi frente en el polvo."
,"16":"Mi cara está colorada por el llanto,y mis párpados, ojerosos."
,"17":"Y eso que en mis manos no hay violencia,y mi oración ha sido pura."
,"18":"¡Tierra, no tapes mi sangre,y que mi grito llegue a todas partes!"
,"19":"Pero tengo en los cielos un testigo, allá arriba tengo un defensor."
,"20":"Mi clamor ante Dios habla por mí, mientras mis lágrimas corren ante él."
,"21":"¡Ojalá pudiera el hombre discutir con Dios,lo mismo que lo hace con su prójimo!"
,"22":"Son pocos los años que me quedan, y pronto me iré por el camino sin regreso."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Mi respiración va disminuyendo, y mis días se van apagando,y ya no me queda más que el sepulcro."
,"2":"¿No soy acaso el blanco de las burlas,y mis noches envenenan sus insolencias?"
,"3":"Coloca tú mismo mi fianza al lado tuyo, ya que ningún amigo se compromete por mí."
,"4":"Les has oscurecido la razón, y ninguno se arriesga en mi favor."
,"5":"No se hacen regalos a los amigos, dicen, para dejar luego a sus hijos en la miseria."
,"6":"Ahora soy el comentario de todo el mundo, y soy como uno a quien le escupen la cara."
,"7":"Mis ojos se cierran de pena,no soy más que la sombra de mí mismo."
,"8":"Los hombres correctos se asombran al verme, los buenos ven en mí a un malvado y moralizan."
,"9":"¡Qué ejemplo para el justo! Se reanima, y la gnte honrada rejuvenece."
,"10":"Pero vuelvan ustedes y acérquense todos, y verán que no hay ni un sabio entre todos ustedes."
,"11":"Mis días han pasado, mis planes han fracasado; mi corazón ansía "
,"12":"la noche cuando es de día, y cuando está oscuro la salida del sol."
,"13":"Sólo puedo esperar mi casa entre los muertos, ya he colocado mi cama en las tinieblas."
,"14":"Al sepulcro le dije: 'Tú eres mi padre', y a los gusanos: 'Mi madre y mis hermanos.'"
,"15":"¿Dónde está mi esperanza?,¿Quién divisará para mí la felicidad?"
,"16":"¿Acaso bajarán conmigo al infierno,y nos encontraremos juntos en el polvo?'"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Bilbad de Suaj tomó la palabra y les,dijo:"
,"2":"'¿Cuándo terminarán sus palabras?,Sé razonable y déjanos hablar."
,"3":"¿Crees que somos bestias, o nos consideras unos brutos?"
,"4":"¿Por qué te destrozas en tu enojo?,¿Se desolará la tierra otro tanto,o las rocas cambiarán de lugar?"
,"5":"Sí, la luz del malvado se apaga,y no brilla la llama de su fuego."
,"6":"Se oscurece la luz en su tienda,y su lámpara encima de él se apaga."
,"7":"Sus pasos vigorosos se acortan, y sus propios designios lo hacen tropezar."
,"8":"Corría, cuando sus pies se prendieron en la red. Caminaba sobre mallas,"
,"9":"y por el talón lo apresa el lazo, el garrote le cae encima."
,"10":"Escondida en la tierra está la cuerda para atarlo. Una trampa lo espera en el camino."
,"11":"Por todas partes lo estremecen terrores,que lo persiguen paso a paso."
,"12":"Está hambriento en medio de sus riquezas, la desgracia está de pie a su lado,"
,"13":"la lepra devora su piel, una fiebre mortal consume sus miembros,"
,"14":"lo arrancan de su carpa en que se sentía seguro,y lo llevan al rey de los terrores;"
,"15":"su tienda ya no es suya y la puedes tomar, se esparce azufre sobre su lugar."
,"16":"Sus raíces abajo se secan,y sus ramas arriba se marchitan."
,"17":"Ya nadie se acuerda de él en el país,y su nombre ya no se pronuncia."
,"18":"Lo echan de la luz a las tinieblas, lo expulsan del mundo."
,"19":"Para él, ni descendencia ni posterioridad en su pueblo, ni sobrevivientes por donde pasó."
,"20":"Los de occidente y los de oriente,se espantan y se asombran de su destino:"
,"21":"Eso espera a las moradas de los malos,y al país que quiere ignorar a Dios.'"
}`)
	CurrentBook.AddChapter(19, `{
"1":"Job respondió:"
,"2":"'¿Hasta cuándo me cansarán,y me acorralarán con sus discursos?"
,"3":"Ya me han insultado diez veces, ¿y no se avergüenzan de maltratarme así?"
,"4":"¡Aunque de hecho hubiera errado, conmigo estaría mi error!"
,"5":"Si quieren triunfar de mí,y reprocharme por mi humillación,"
,"6":"sepan que es Dios quien me perjudicó,y me envolvió con su red."
,"7":"Si grito: ¡violencia!, nadie me responde; y por más que llamo, no me hacen justicia."
,"8":"Ha cortado mi camino para que no pase, ha puesto tinieblas sobre mis senderos,"
,"9":"me ha desvestido de mi gloria, me ha quitado de la cabeza mi corona."
,"10":"Corta mis amarras hasta que me vaya,arranca de raíz mis esperanzas."
,"11":"Descarga sobre mí su enojo,y me trata como su enemigo."
,"12":"Sus bandas llegan a la vez, se abren camino hasta mí,y acampan a mi alrededor."
,"13":"Ha apartado de mí mis hermanos, y todos mis conocidos tratan de alejarse."
,"14":"Ya no me ven parientes ni familiares, me olvidaron los allegados a mi casa."
,"15":"Mis sirvientas me tienen por extraño, me miran como un desconocido."
,"16":"Si llamo a mi criado, no me hace caso,aunque se lo suplique."
,"17":"Mi aliento le cae mal a mi mujer, mis propios hijos me encuentran hediondo."
,"18":"Hasta los niños me desprecian, y hacen burla de mí si me levanto."
,"19":"Todos mis íntimos tienen asco de mí, los que yo amaba se han vuelto contra mí."
,"20":"Bajo mi piel, mi carne se deshace, al desnudo quedan mis huesos como dientes."
,"21":"Apiádense de mí, ustedes mis amigos, que es la mano de Dios la que me hirió."
,"22":"¿Por qué me persiguen tan cruelmente como Dios,y no quedan satisfechos con mi carne?"
,"23":"¡Ojalá que mis palabras se escribieran,y se grabaran en el bronce,"
,"24":"y con un punzón de hierro o estilete,para siempre en la piedra se esculpieran!"
,"25":"Bien sé yo que mi Defensor vive,y que él hablará el último, de pie sobre la tierra."
,"26":"Yo me pondré de pie dentro de mi piel,y en mi propia carne veré a Dios."
,"27":"Yo lo contemplaré, yo mismo. El es a quien veré y no a otro: mi corazón desfallece esperándolo;"
,"28":"Ustedes que tratan de condenarme,y buscan pretextos contra mí,"
,"29":"teman que la espada los hiera a ustedes mismos,cuando la cólera de Dios castigue las culpas, y sabrán entonces que hay al fin justicia.'"
}`)
	CurrentBook.AddChapter(20, `{
"1":"Sofar de Naamat tomó la palabra y dijo:"
,"2":"'Mis reflexiones me llevan a contestar,a consecuencia de lo que siento."
,"3":"Al oír una lección que me ofende, mis pensamientos me inspiran una respuesta."
,"4":"¿No sabes tú que desde siempre, desde que fue puesto el hombre sobre la tierra,"
,"5":"el triunfo del malvado es breve,y el gozo del perverso no dura más que un instante?"
,"6":"Aunque se eleve hasta los cielos,y toque las nubes con la cabeza,"
,"7":"como un fantasma desaparece para siempre; los que lo veían dicen: '¿Dónde está?'"
,"8":"Se va como un sueño, se vuela y ya no lo hallan, huye como una visión nocturna."
,"9":"El que solía verlo, no lo ve, y tampoco lo divisa el lugar donde vivía."
,"11":"Sus huesos rebosaban de vigor juvenil, su vigor ahora está junto a él en el polvo."
,"12":"Si el mal era dulce a su boca, si lo ocultó bajo su lengua,"
,"13":"si allí lo conservó y lo retuvo,y lo guardó en medio del paladar,"
,"14":"su comida se corrompe en el estómago, y se vuelve veneno en su interior."
,"15":"Tiene que vomitar las riquezas que tragó, Dios las hace salir de su vientre."
,"16":"Chupaba veneno de áspides, una lengua de víbora lo mata."
,"17":"Ya no verá los arroyos de aceite fresco, los torrentes de miel y de mantequilla."
,"18":"Devuelve su ganancia sin tragarla, y no puede gozar el fruto de su negocio."
,"19":"Porque despojó por la fuerza a los pobres,y robó su casa en vez de construirla,"
,"10":"sus hijos pagarán a los pobres, y sus propias manos devolverán sus riquezas."
,"20":"Porque su vientre se mostró insaciable, nadie podía resistir a su apetito"
,"21":"ni escapar de su comida, por eso, no dura su bienestar."
,"22":"En plena riqueza sufre miseria,y cae sobre él la desgracia."
,"23":"Cuando está llenándose el vientre, Dios desencadena sobre él su ira,y hace llover sus flechas sobre él."
,"24":"Si logra huir del arma de hierro, lo traspasa el arco de bronce."
,"25":"Una flecha le sale por la espalda,la punta atravesó su hígado. Lo invade una angustia mortal,"
,"26":"las tinieblas están reservadas para él. Un fuego que no encendió el hombre lo devora,y consume cuanto queda en su tienda."
,"27":"Los cielos revelan su falta,y la tierra se levanta contra él."
,"28":"Aguas desbordadas se llevan su casa, empujadas por la cólera de Dios."
,"29":"Esta es la herencia que el malvado recibe de Dios, tal es la parte que le fijó.'"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Job tomó la palabra y dijo:"
,"2":"'Escuchen, escuchen mis razones, esto sería mejor que consolarme."
,"3":"Déjenme hablar, y cuando haya terminado, podrán burlarse."
,"4":"¿Acaso pleiteo contra un hombre?,Entonces, ¿cómo no me pondría nervioso?"
,"5":"Préstenme atención y quedarán espantados,y se pondrán la mano en la boca,"
,"6":"que yo mismo, al recordar estos hechos, me horrorizo y me dan escalofríos."
,"7":"¿Por qué siguen viviendo los malvados, prolongan sus días y se van haciendo fuertes?"
,"8":"Su familia a su lado va aumentando,y sus vástagos crecen ante su vista."
,"9":"Nada perturba la paz de sus hogares, la vara de Dios no cae sobre ellos."
,"10":"Sus toros cubren y fecundan,y sus vacas paren y no abortan."
,"11":"Dejan correr a sus niños como ovejas; sus hijos brincan de contento."
,"12":"Cantan al son del arpa y de la cítara, al son de la flauta se divierten."
,"13":"Acaban sus días tranquilamente,y descienden en paz al lugar de los muertos."
,"14":"Y éstos eran los que decían a Dios: '¡Apártate!,no queremos conocer tus caminos."
,"15":"¿Por qué habría que servir al Todopoderoso,y qué ganamos si le suplicamos?'"
,"16":"Y tienen a su alcance la felicidad, sin que Dios esté presente en sus proyectos."
,"17":"¿Será verdad que se apaga la lámpara de los malvados,y cae sobre ellos la desgracia,y que Dios, en su ira, los destruye?"
,"18":"¿Los vemos acaso como paja ante el viento, como pelusa que arrebata un torbellino?"
,"19":"No basta que Dios lo castigue en sus hijos. ¡Que lo castigue en su propia persona, para que aprenda!"
,"20":"Que vea su ruina con sus propios ojos, que beba la cólera del Todopoderoso."
,"21":"¿Qué le importa su familia después de él, cuando se haya cumplido el número de sus meses?"
,"22":"Pero, ¿a Dios le van a dar lecciones, a él, que juzga a los seres del cielo?"
,"23":"Hay quien muere en lo mejor de su vida, cuando vivía feliz y tranquilo,"
,"24":"con los costados bien regordetes,y los huesos repletos de sustancia."
,"25":"Y hay quien muere con amargura en el alma, sin haber gustado nunca la felicidad."
,"26":"Juntos, luego, se acuestan en el polvo,y los cubren los gusanos."
,"27":"Yo conozco sus razones,y sé lo que ustedes piensan de mí."
,"28":"Dicen: ¿dónde está la casa del poderoso,y dónde la tienda que habitaban los malvados?"
,"29":"Pero, ¿no han preguntado a los que viajan?,¿No saben lo que dejaron escrito?"
,"30":"Que de la desgracia el malo es preservado, y no lo alcanza el día de la cólera."
,"31":"¿Quién le echa en cara su conducta,y le da su merecido?"
,"32":"Cuando lo llevan al cementerio, su estatua mira sobre la tumba,"
,"33":"los terrones del valle le son suaves,la gente va desfilando ante él, y lo sigue un pueblo innumerable."
,"34":"¿Para qué, pues, me dan vanos consuelos?,¡Pura falsedad lo que me contestan!'"
}`)
	CurrentBook.AddChapter(22, `{
"1":"Elifaz de Temán tomó la palabra y dijo:"
,"2":"'¿Qué puede un hombre aportarle a Dios?,¡Sólo a sí mismo es útil el sabio!"
,"3":"¿Qué interés tiene el Omnipotente en que seas justo?,O, ¿qué gana él si tu conducta es perfecta?"
,"4":"¿Acaso te corrige por tu piedad,y por eso te meterá pleito?"
,"5":"¿No será más bien por tu gran maldad,y por tus faltas sinnúmero?"
,"6":"Seguramente cobrabas sin razón a tus hermanos, les exigías su ropa e iban desnudos,"
,"7":"no dabas agua al sediento, y negabas el pan al hambriento."
,"8":"Si llega un poderoso, se apodera de las tierras,y lo pone en manos de sus criaturas."
,"9":"Por cierto, despedías a las viudas con las manos vacías,y te aprovechabas de los huérfanos."
,"10":"Por eso, te rodean los lazos,y de improvisto te sorprende el terror."
,"11":"La luz se ha oscurecido y ya no ves, y te sumergen aguas desbordadas."
,"12":"¿No está Dios en lo alto de los cielos?,¡Mira cuán lejanas están las estrellas!"
,"13":"Por esto, te dijiste: '¿Qué sabe Dios?,¿Podrá juzgar a través de las nubes?"
,"14":"Las nubes hacen de cortina, así que no ve; sólo se pasea por el contorno de los cielos.'"
,"15":"¿Quieres seguir el antiguo camino,que anduvieron los hombres perversos?"
,"16":"Ellos fueron eliminados antes de tiempo, cuando un río inundó sus habitaciones."
,"17":"Los que decían a Dios: '¡Apártate de nosotros!"
,"18":"¿Qué puede hacernos el Omnipotente?',El hacía que nada faltara en sus casas, pero esos malos no lo tomaban en cuenta."
,"19":"Los justos lo ven y se alegran, y el inocente se burla de ellos."
,"20":"'¡Cómo ha quedado en nada su riqueza!,¡El fuego devoró cuanto tenían!'"
,"21":"Reconcíliate, pues, con Dios, haz las paces, y te resultará bien."
,"22":"Escucha de su boca sus preceptos,y guarda sus palabras en tu corazón."
,"23":"Si vuelves al Omnipotente con humildad, si alejas de tu tienda la injusticia,"
,"24":"si estimas el oro como polvo, y como guijarros los ríos dorados,"
,"25":"entonces el Omnipotente será tu oro, y para ti, será plata a montones."
,"26":"Hallarás en el Omnipotente tus delicias,y alzarás tu rostro hacia Dios."
,"27":"Lo invocarás y él te escuchará,para que puedas cumplir tus mandas."
,"28":"Lo que decidas te saldrá bien,y sobre tus caminos brillará la luz."
,"29":"Porque él rebaja lo que es alto,y salva al que baja los ojos;"
,"30":"él, que libera al inocente, a ti también te salvará,si tus manos son puras.'"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Job tomó la palabra y dijo:"
,"2":"'Hoy aún es rebelde mi queja, no puede mi mano acallarla en mi boca."
,"3":"¡Ah, si supiera dónde vive, iría hasta su casa!"
,"4":"Expondría ante él mi caso,y le diría todos mis argumentos."
,"5":"Por lo menos conocería su respuesta,y trataría de comprender lo que él dijera."
,"6":"¿Acaso necesitaría gran fuerza para disputar conmigo?,No, no tendría más que escucharme."
,"7":"Reconocería que su demandante es un hombre recto,y yo para siempre me libraría de mi juez."
,"8":"Pero si voy al oriente, no está allí; al occidente, tampoco lo descubro;"
,"9":"si lo busco al norte, no lo encuentro; si vuelvo al mediodía, no lo veo."
,"10":"Mas El me conoce, sea que ande o que me pare, y si me prueba en el crisol, saldré puro."
,"11":"Mis pies han pisado sus huellas, he seguido su camino sin desviarme;"
,"12":"no me aparté del precepto que declaró, sino que puse en mi corazón sus palabras."
,"13":"Pero él así decidió: ¿quién se lo impedirá?,Lo que le dio ganas lo hará,"
,"14":"pues siempre cumple su propio decreto; y tiene proyectadas muchas cosas parecidas."
,"15":"Por eso, estoy horrorizado ante él, y cuando reflexiono, le tengo miedo."
,"16":"Dios me ha hecho perder el valor,y el Omnipotente me ha espantado"
,"17":"porque no callaba al caer las tinieblas,y la oscuridad que envolvió mi rostro."
}`)
	CurrentBook.AddChapter(24, `{
"1":"¿Por qué el Todopoderoso no se entera de lo que sucede,y sus fieles no comprueban su justicia?"
,"2":"Los malvados cambian los linderos, llevan a pastar rebaños robados."
,"3":"Se roban el burro de los huérfanos, y confiscan el buey de la viuda."
,"9":"Se arranca al huérfano del pecho materno, se toma en prenda el hijo del pobre."
,"4":"Los mendigos tienen que apartarse del camino, todos los pobres del país han de esconderse."
,"5":"Como los burros salvajes en el desierto, salen desde la mañana a buscar su alimento, y a la noche no tienen pan para sus hijos."
,"6":"Salen de noche a segar el campo,y a vendimiar la viña del malvado."
,"7":"Pasan la noche desnudos, sin tener qué ponerse, sin un abrigo contra el frío."
,"8":"Están empapados por la lluvia de las montañas, sin tener donde guarecerse se sujetan a las rocas."
,"10":"Andan desnudos, sin ropa, y sienten hambre mientras llevan las gavillas."
,"11":"Mueven el molino para exprimir el aceite,y pisan la uva de los lagares, pero quedan con sed."
,"12":"En la ciudad gimen los moribundos, y los heridos piden socorro, pero Dios no atiende a sus súplicas."
,"13":"Todos son enemigos de la luz, que no conocieron sus caminos, y no volverán por sus senderos,"
,"14":"De madrugada se levanta el asesino,para matar al pobre indigente."
,"14a":"Y llegada la noche sale el ladrón."
,"15":"Luego el adúltero espera el anochecer, dice: 'Ahora nadie me verá', y pone un pañuelo sobre su rostro."
,"16":"Asaltan las casas que notaron en el día,y perforan sus muros en la oscuridad."
,"17":"La mañana es para ellos tinieblas,y al salir el sol los asusta."
,"18":"Huye veloz, se parece a la espuma de las aguas, y evita el camino de las cumbres."
,"19":"Un calor sofocante evapora sus aguas,y quema lo que queda de su trigo."
,"20":"El seno que lo formó se olvida de él, y su nombre no se recuerda más: la maldad ya no es más que un árbol cortado."
,"21":"Pues maltrataba a la mujer sin hijos,y no atendía a la viuda."
,"22":"Hay Uno que con su fuerza agarra a los poderosos, que si se levanta, nadie podrá escaparse."
,"23":"Dios permitió que progresara seguro, pero vigilaba sus caminos."
,"24":"Se encumbró por un instante, y ya no existe, se ha marchitado como espiga cortada."
,"25":"Si no es así, ¿quién me desmentirá,y rebatirá mis palabras?'"
}`)
	CurrentBook.AddChapter(25, `{
"1":"Bildad de Suaj tomó la palabra y dijo:"
,"2":"'El tiene con qué imponerse y hacer temblar, hace él reinar la paz en las alturas."
,"3":"¿Se pueden acaso contar sus tropas?,¿Sobre quién su luz no se levanta?"
,"4":"¿Cómo puede un hombre justificarse ante Dios?,¿Cómo será puro el que nació de mujer?"
,"5":"Si ni la luna es clara, ni las estrellas son puras a sus ojos,"
,"6":"¡cuánto menos el hombre, este gusano, el hijo del hombre, esta lombriz!"
}`)
	CurrentBook.AddChapter(26, `{
"1":"Job respondió con estas palabras:"
,"2":"'¡Qué bien sabes ayudar al débil,y socorrer al inválido!"
,"3":"¡Qué buenos consejos das al ignorante, qué profundo conocimiento has demostrado!"
,"4":"Pero ¿a quién van dirigidas tus palabras,y quién te las inspiró?'"
,"5":"Las sombras tiemblan debajo de la tierra, las aguas y sus habitantes se estremecen."
,"6":"El reino de la muerte no le está oculto, el lugar de los muertos está descubierto ante él."
,"7":"El extiende el norte sobre el vacío, suspende la tierra sobre la nada."
,"8":"Encierra la lluvia en los nubarrones,y la nube no se rasga con el peso."
,"9":"El cubre la cara de la luna llena,y le da por velo sus nubes,"
,"10":"encierra las aguas en el cerco del horizonte, que es el límite de la luz con las tinieblas."
,"11":"Las columnas del cielo se tambalean,y se llenan de miedo cuando amenaza."
,"12":"Con su poder dividió el mar,y con su inteligencia aplastó a Rahab."
,"13":"Su soplo ha despejado los cielos, su mano traspasó la Serpiente huidiza."
,"14":"Esto es sólo el exterior de sus obras, sus ecos tan sólo percibimos. ¿Quién podrá comprender su trueno poderoso?'"
}`)
	CurrentBook.AddChapter(27, `{
"1":"Job continuó su discurso y agregó:"
,"2":"'¡Por la vida de Dios que me niega justicia, por el Omnipotente que me llenó de amargura,"
,"3":"mientras esté mi espíritu en mí,y el aliento de Dios en mis narices,"
,"4":"no diré falsedad,ni saldrá mentira de mi boca!"
,"5":"Lejos de mí darles la razón: mantendré mi inocencia hasta la muerte."
,"6":"Mantendré que he actuado bien, pues mi conciencia no se avergüenzo de mi pasado."
,"7":"Sea reconocido culpable mi enemigo,y mi adversario tenga la suerte del malvado."
,"8":"Porque, ¿qué puede esperar el malvado,cuando suplica, cuando eleva su alma a Dios?"
,"9":"¿Escuchará Dios sus gritos,cuando le llegue la desgracia?"
,"10":"¿Acaso se complacerá el malo en el Omnipotente, o lo invoca en todo momento?"
,"11":"Miren que les enseño el proceder de Dios,y no les oculto sus pensamientos."
,"12":"Y si todos ustedes lo han visto, ¿para qué, pues, esos vanos discursos?"
,"13":"Esta es la suerte que le reserva Dios al malvado,el porvenir que el Poderoso reserva a los opresores:"
,"14":"por numerosos que sean sus hijos, los espera la espada; sus descendientes carecerán de pan."
,"15":"La peste arrasará con los sobrevivientes, y sus viudas no les llorarán."
,"16":"Aunque el malo junte plata como polvo, y amontone vestidos como el barro,"
,"17":"él los prepara, pero los vestirá el justo, un hombre sin maldad heredará su plata."
,"18":"La casa que edificó no vale más que un nido, es como cabaña que construye un guardia."
,"19":"Se acuesta rico, pero por última vez; pues al abrir los ojos no le queda nada."
,"20":"En pleno día lo asaltan los terrores,y por la noche lo arrebata el torbellino."
,"21":"El viento del oriente lo levanta y se lo lleva, ha sido soplado de donde estaba."
,"22":"le tiran piedras sin compasión,no puede huir de la mano que lo golpea."
,"23":"Baten palmas contra él,y lo silban allí donde lo encuentran."
}`)
	CurrentBook.AddChapter(28, `{
"1":"La plata tiene su mina,el oro un lugar donde se purifica."
,"2":"El hierro se extrae de la tierra, una piedra fundida se hace cobre."
,"3":"Se descubre el secreto de las tinieblas, se busca hasta el último extremo,en la piedra oscura y opaca."
,"4":"Un pueblo extranjero abre galerías,en lo recóndito donde nadie ha penetrado, y se suspenden y balancean lejos de los humanos."
,"5":"La tierra, de donde sale el pan, está envuelta en sus entrañas por el fuego,"
,"6":"allá donde las piedras son zafiros,y contienen polvo de oro."
,"7":"El ave de rapiña no conoce ese sendero,ni el ojo del buitre lo ha advertido;"
,"8":"las bestias feroces no han pisado por ese camino,ni el león jamás lo ha atravesado."
,"9":"El hombre aplica su mano al pedernal, y estremece los cimientos de las montañas."
,"10":"Abre canales en las rocas, su ojo busca todo lo que sea precioso."
,"11":"Explora las fuentes que brotan de la tierra,y saca a la luz lo que estaba escondido,"
,"12":"pero la sabiduría, ¿de dónde viene, dónde se hallará la inteligencia?"
,"13":"Ignora el hombre su camino, no lo encontrará en la tierra de los vivos."
,"14":"El abismo dijo: 'No está en mí.',Y respondió el mar: 'Tampoco la tengo.'"
,"15":"No se puede dar por ella oro fino, ni comprarla por plata;"
,"16":"no se valora con oro de Ofir, ni con el ágata preciosa ni el zafiro."
,"17":"No se comparan con ella ni el oro ni el cristal, ni se la cambia por un vaso de oro puro."
,"18":"Corales y cristales ni se nombren. Conseguir la sabiduría vale más que extraer perlas."
,"19":"No la puede igualar el topacio de Etiopía, ni con el oro más puro se valora."
,"20":"Entonces ¿la sabiduría de dónde sale?, ¿habrá un lugar de la inteligencia?"
,"21":"Ha estado oculta a los ojos de todo ser viviente,y aun a las aves del cielo."
,"22":"El infierno y la muerte confiesan: No la conocemos más que de oídas."
,"23":"Sólo Dios conoce su camino, sólo él sabe dónde está,"
,"24":"él que mira hasta los extremos de la tierra,y ve todo lo que existe debajo de los cielos."
,"25":"Cuando determinó la fuerza de los vientos,y fijó a las aguas su medida;"
,"26":"cuando impuso leyes a la lluvia,y un camino al fragor del trueno,"
,"27":"entonces la vio y le puso precio, la examinó y conoció sus secretos."
,"28":"Entonces dijo al hombre: 'Mira, el temor del Señor es la sabiduría; y huir del mal es la inteligencia.'"
}`)
	CurrentBook.AddChapter(29, `{
"1":"Job prosiguió su poema y dijo:"
,"2":"'¡Quién me hiciera volver a los meses de antaño, a los días en que Dios me protegía,"
,"3":"cuando hacía brillar su lámpara sobre mi cabeza, y su luz me guiaba en las tinieblas!"
,"4":"¡Ah, si pudiesen volver los días de mi otoño, cuando rodeaba Dios mi tienda,"
,"5":"cuando el Todopoderoso estaba aún conmigo,y me rodeaban mis hijos,"
,"6":"cuando mis pies se bañaban en leche,y corrían de la roca arroyos de aceite!"
,"7":"Si yo salía a la puerta que domina la ciudad,y me sentaba en la plaza,"
,"8":"los jóvenes al verme se retiraban,y los ancianos se ponían de pie,"
,"9":"los notables interrumpían su conversación,y ponían la mano en su boca."
,"10":"La voz de los jefes se apagaba, la lengua se les pegaba al paladar."
,"21":"Me escuchaban en silencio,y esperando mi parecer."
,"22":"Después que había hablado, nadie replicaba."
,"23":"Caía sobre ellos mi discurso gota a gota: era la lluvia que aguardaban, el aguacero primaveral que calmaría su sed."
,"24":"Si les sonreía, no se atrevían a creerlo, y recibían gratos cualquier señal de benevolencia."
,"25":"Les trazaba el camino e iba al frente de ellos,como un rey en medio de sus tropas, y yo a mi gusto los llevaba a todas partes."
,"11":"Todo el que me oía me llamaba dichoso,y quien me veía se declaraba en mi favor."
,"12":"Pues yo libraba al pobre que gemía,y al huérfano que no tenía apoyo,"
,"13":"la bendición del desgraciado caía sobre mí, y yo alegraba el corazón de la viuda."
,"14":"Me había puesto la justicia como un vestido,y llevaba mi rectitud como un manto y un turbante."
,"15":"Era yo los ojos para el ciego, y los pies para el cojo."
,"16":"Era el padre de los pobres, y me preocupaba por la causa del desconocido."
,"17":"Quebraba los colmillos del malvado, de entre sus dientes arrancaba su presa."
,"18":"Y me decía: 'Anciano moriré, mis días serán tantos como los granos de arena."
,"19":"Mi raíz se alarga hacia las aguas, el rocío cae de noche en mi ramaje."
,"20":"Mi gloria estará siempre flamante,y en mi mano mi arco será fuerte.'"
}`)
	CurrentBook.AddChapter(30, `{
"1":"Pero ahora se ríen de mí,unos más jóvenes que yo,y cuyos padres, para mí, no eran dignos,ni de mezclarse con los perros de mi ganado."
,"2":"¿Qué habría hecho con sus manos,si no tenían la más mínima fuerza, debilitados como estaban por el hambre y la miseria?"
,"3":"Roían las raíces de la estepa, hijos de una tierra desolada y árida."
,"4":"Recogían hierbas por los matorrales, su pan eran las raíces de retama."
,"5":"Los expulsaban de la sociedad, y se gritaba tras ellos como tras un ladrón,"
,"6":"por lo que moraban en lo abrupto de los torrentes, en huecos de la tierra y de las rocas."
,"7":"Rugían entre las zarzas, y se reunían bajo los espinos."
,"8":"Hijos de ruines, hijos de desconocidos, los arrojaban del país."
,"9":"Ahora, sin embargo, les sirvo de canción,y soy objeto de sus burlas."
,"10":"Se espantan al verme y se alejan,y sin miramientos escupen a mi paso."
,"11":"Desde el día que me quebró y me humilló, ya no se contuvieron en mi presencia."
,"12":"A mi derecha se levantan acusadores, mis pies están atrapados en la red, se están abriendo caminos hacia mí."
,"13":"Me cortaron la huida, me asaltan, y no hay quién los detenga;"
,"14":"se han abierto paso, ¡aquí están!,se inflitran bajo los escombros."
,"15":"Los terrores caen soobre mí, el viento se llevó mis esperanzas, mi bienestar se me fue como una nube."
,"16":"Y ahora se va deshaciendo mi vida, los días de aflicción se han apoderado de mí."
,"17":"De noche se me taladran los huesos,y no descansan mis llagas."
,"18":"Con gran fuerza agarra Dios mi manto, me aprieta el cuello de la túnica."
,"19":"Me ha tirado en el fango, ya no soy más que polvo y ceniza."
,"20":"Clamo a ti, y tú no me respondes; me presento, y no me haces caso."
,"21":"Te has vuelto cruel conmigo, me persigues con toda la fuerza de tus manos."
,"22":"Me llevas y me haces cabalgar sobre el viento, hasta que una tormenta me deshace en agua."
,"23":"Bien sé que me conduces a la muerte, al lugar de reunión de todos los vivientes."
,"24":"Sin embargo, contra el pobre no levantaba mi mano,cuando en su angustia clamaba a mí."
,"25":"¿No lloré con quien tuvo días duros?,¿No se entristeció mi corazón por el pobre?"
,"26":"Yo esperaba la dicha, y llegó la desgracia. Esperaba la luz, y vino la oscuridad."
,"27":"Mis entrañas se agitan sin descanso, porque me vinieron al encuentro días de aflicción."
,"28":"Tengo la piel quemada pero no por el sol. En la asamblea quise hablar, pero fue sólo un chillido."
,"29":"Me he hecho hermano de chacales, compañero de avestruces."
,"30":"Mi piel se ha ennegrecido sobre mí, mis huesos se van consumiendo por la fiebre."
,"31":"Tomé mi cítara para la lamentación,y mi flauta se puso a tono con las lloronas."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Yo había hecho ese pacto con mis ojos,de ni siquiera mirar a una doncella."
,"2":"Pues, ¿cuál es la parte que Dios nos envía desde arriba,y cómo devuelve el Omnipotente desde lo alto?"
,"3":"¿No es acaso la desgracia para el injusto,y la prueba para los que actúan con maldad?"
,"4":"El sabe cuál ha sido mi conducta,y conoce todos mis pasos."
,"5":"Nunca he andado con mentiras,ni me he afanado en engañar a los demás."
,"6":"Que me pese Dios en la balanza de la justicia, y se dará cuenta de mi honradez."
,"7":"Si mis pasos se apartaron del buen camino, si mi corazón corrió tras lo que veían mis ojos, si he manchado mis manos,"
,"8":"¡que otro coma lo que yo sembré, y sean arrancados mis retoños!"
,"9":"Si mi corazón se dejó seducir por mujer, si estuve acechando a la puerta de mi prójimo,"
,"10":"¡sea para otro mi mujer, y otros brazos la estrechen!"
,"11":"Pues hubiera sido una infamia, un crimen condenado por los jueces,"
,"12":"un fuego que devora hasta la perdición,y que habría consumido mis cosechas."
,"13":"Si he menospreciado el derecho de mi siervo, o de mi sierva, cuando se quejaron de mí,"
,"14":"¿qué podré hacer cuando Dios me juzgue?; y cuando me pida cuentas, ¿qué responderé?"
,"15":"Me formó a mí y a ellos en el seno materno, un mismo Dios nos formó en el vientre."
,"16":"No les negué a los pobres lo que deseaban, ni a la viuda dejé aguardando en vano."
,"17":"¿Acaso comí solo mi pedazo de pan, sin compartirlo con el huérfano?"
,"18":"Al contrario, desde la infancia lo traté como un padre, y desde joven he protegido a la viuda."
,"19":"No he visto a un necesitado sin vestido,ni algún pobre desnudo,"
,"20":"sin que en lo íntimo de su ser me bendijera, porque del vellón de mis corderos se había calentado."
,"21":"Si he alzado mi mano contra un huérfano,porque pensaba que podía contar con los jueces,"
,"22":"que mi espalda se desprenda del cuello,y que mi brazo se parta en el codo."
,"23":"Porque temo los castigos de Dios,y no podría resistir ante su majestad."
,"24":"No he puesto en el oro mi confianza, ni he exclamado: 'Tú eres mi apoyo.'"
,"25":"No me complací en la abundancia de mis bienes,ni de lo mucho que habían adquirido mis manos."
,"26":"¿Acaso, al ver el sol en su esplendor,y la luna que radiante caminaba,"
,"27":"mi corazón se dejó seducir en secreto, y le mandé con mi mano un beso de mi boca?"
,"28":"También esto habría sido una falta criminal, porque habría renegado del Dios que está en lo alto."
,"29":"¿Acaso me alegré de la mala suerte de mi enemigo,y me sentí feliz por la desgracia que lo afectaba?"
,"30":"No he permitido que mi lengua pecara,deseándole la muerte como una maldición."
,"31":"Decían las gentes de mi casa: ¿Hay alguien que no se haya saciado en su mesa?"
,"32":"Tenía abierta mi puerta al caminante,y el forastero pasaba la noche a la intemperie."
,"38":"Si la tierra clamó contra mí,y junto con ella lloraron sus surcos,"
,"39":"por haber yo comido sus frutos sin pagarlos,o porque hice exhalar el alma a su dueño,"
,"40a":"¡que en lugar de trigo broten espinas, y en vez de cebada, hierba maloliente!'"
,"33":"¿Acaso disimulé mis culpas como hace un cualquiera, ocultando el pecado en mi seno?"
,"34":"¿Acaso debí temer al rumor público,hasta quedarme callado y encerrado en mi casa?"
,"35":"¡Quién me diera que se me escuchara!,Ahí va mi firma: ¡que me responda el Omnipotente!"
,"36":"La acusación escrita por mi adversario, estoy listo para llevarla sobre mi espalda,y me la ceñiré como una corona."
,"37":"A él le daré cuenta del número de mis pasos,y me acercaré a él como un príncipe."
,"40b":"Aquí terminan las palabras de Job."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Y aquellos tres hombres dejaron de replicar a Job porque lo creían justo."
,"2":"Entonces Elihú, hijo de Barakel, busita de la familia de Ram, se enojó contra Job, porque creía tener razón frente a Dios;"
,"3":"y también contra sus tres amigos, porque no habían encontrado qué responder y así habían dejado mal a Dios."
,"4":"Elihú había esperado mientras hablaban con Job, porque ellos eran mayores que él."
,"5":"Pero cuando vio que los tres hombres ya no respondían, se enojó."
,"6":"Elihú tomó la palabra y dijo: 'Yo soy joven y ustedes ancianos, y por eso temía,y sentía miedo de manifestarles mi saber."
,"7":"Yo me decía: hablará la edad,y de los muchos años brotará la sabiduría."
,"8":"Pero no; ella es en el mortal fruto de una inspiración, un espíritu salido del Omnipotente da la inteligencia."
,"9":"Los sabios no son los ancianos, ni por ser viejos comprenden lo que es justo."
,"10":"Por eso, ahora les digo: 'Escúchenme,y yo también demostraré mi saber.'"
,"11":"Yo puse atención a sus discursos,y me fijé en sus razones,mientras ustedes buscaban palabras."
,"12":"Los escuché a ustedes atentamente, pero veo que nadie critica a Job, ninguno responde a sus razones."
,"13":"No digan, pues: 'Hemos alcanzado la sabiduría; es Dios quien nos enseña, no un hombre.'"
,"14":"No ordenaré palabras como ésas, ni les replicaré en los términos que usaron ustedes."
,"15":"Están vencidos, ya no saben qué responder,y les faltan las palabras."
,"16":"Yo esperé, pero ya no hablan, se callan a la vez sin haberlo rebatido."
,"17":"Por eso, responderé yo,y manifestaré también mi parecer."
,"18":"Porque me siento lleno de palabras,y me empuja un fuego interior."
,"19":"Dentro de mí hay como un vino que fermenta, y que revienta los odres nuevos."
,"20":"Hablaré para desahogarme, abriré mis labios y responderé."
,"21":"No tomaré partido por nadie, a nadie adularé,"
,"22":"porque no sé adular, y si lo hiciera, mi Creador me echaría al viento."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Escucha, Job, mis palabras, pon atención a mis discursos."
,"2":"Ya ves que he abierto mi boca, y he empezado a hablar."
,"3":"Mi corazón me dicta palabras de sabiduría,que pronunciaré con claridad."
,"4":"El espíritu de Dios me hizo, y el soplo del Omnipotente me dio vida."
,"5":"Si puedes, respóndeme, prepárate para replicarme."
,"6":"Mira, ante Dios soy igual que tú, también yo fui modelado de barro."
,"7":"Por eso, no tendrás que atemorizarte ante mí,ni temerás que te apremie mi mano."
,"8":"No dejas de repetir, pues he oído el son de tus palabras:"
,"9":"'Soy puro, no tengo pecado; estoy limpio y en mí no hay culpa."
,"10":"Dios es el que busca pretextos,y me tiene por su enemigo;"
,"11":"pone trabas a mis pies,y vigila mis pasos.'"
,"12":"Te respondo: Estas quejas no valen, pues, ¡cuánto supera Dios al hombre!"
,"13":"¿Por qué le haces este reproche,de que no contesta tus palabras?"
,"14":"Pero mira que Dios habla una vez,y no lo repite dos veces."
,"15":"En sueños, en visión nocturna, cuando desciende el sueño sobre los hombres, mientras los humanos duermen en su cama,"
,"16":"él les abre el entendimiento,y los espanta con apariciones,"
,"17":"para retraerlos del mal,y apartarlos del orgullo."
,"18":"Así le ahorra la tumba a su alma,y salva su vida de la muerte."
,"19":"Ve cómo Dios instruye al hombre en su cama, por medio del dolor y de la fiebre,"
,"20":"cuando está hastiado del pan,y rechaza los manjares apetitosos."
,"21":"Cuando su carne desaparece a la vista,y los huesos se transparentan,"
,"22":"cuando su alma se acerca al sepulcro,y su vida a la morada de los muertos."
,"23":"Si hay junto a él en ese momento,un ángel de Dios, un intercesor que le indique su deber,"
,"24":"que tenga piedad de él y diga: 'Líbralo, ¡oh Dios!, de bajar al sepulcro, aquí tengo lo que él debía pagar.'"
,"25":"Entonces, su carne rejuvenece,como en los días de su adolescencia."
,"26":"Se vuelve a Dios que le hace caso, lo va a visitar y estalla de alegría."
,"27":"Luego publica lo sucedido,y dice entre los hombres: 'Había yo pecado y torcido el derecho, pero Dios no me ha tratado según mi culpa,"
,"28":"libró mi alma del sepulcro,y vivo ahora gozando la luz.'"
,"29":"Esto es lo que hace Dios, dos y tres veces con el hombre,"
,"30":"para sacar su alma del sepulcro,e iluminarla con la luz de los vivos."
,"31":"Fíjate, Job, y escúchame, guarda silencio y yo hablaré."
,"32":"Si tienes algo que decir, respóndeme, habla, que yo quiero darte la razón."
,"33":"O si no, escúchame, cállate y yo te enseñaré la sabiduría.'"
}`)
	CurrentBook.AddChapter(34, `{
"1":"Elihú continuó hablando y dijo:"
,"2":"'Sabios y doctos, escuchen, presten atención a mis palabras."
,"3":"Porque el oído aprecia las palabras,como el paladar gusta los manjares."
,"4":"Examinemos, pues, entre nosotros lo que es justo, reconozcamos lo que es bueno."
,"5":"Job ha dicho: 'Yo soy justo, pero Dios niega mi derecho"
,"6":"y miente en contra mía, mi llaga es incurable, a pesar de que no tengo culpa.'"
,"7":"Pero, ¿acaso hay alguien como Job,que se burla tan fácilmente como bebe?"
,"8":"Ahora toma el partido de los malvados,y camina con los hombres impíos."
,"9":"Job ha dicho: 'El hombre no saca provecho,con estar en gracia de Dios.'"
,"10":"Por eso, ustedes que saben pensar, escúchenme: Lejos de Dios el mal, y del Omnipotente, la injusticia."
,"11":"Porque él retribuye la obra del hombre,y trata a cada uno según su conducta."
,"12":"Ciertamente, Dios no hace el mal,y el Omnipotente no tuerce el derecho."
,"13":"¿Quién le confió la tierra, y le encargó el mundo entero?"
,"14":"Si llamara de vuelta a su sabiduría,y recogiera su soplo y su espíritu,"
,"15":"en un instante moriría toda la tierra,y los hombres volverían al polvo."
,"16":"Si tienes inteligencia, escúchame,y presta atención a mis palabras:"
,"17":"¿Acaso puede gobernar el que odia el derecho?,¿Cómo vas a condenar al Justo Supremo?"
,"18":"El puede decir a un rey: ¡Infame!, y a los príncipes: ¡Malvados!"
,"19":"No toma el partido de los príncipes,ni distingue entre el rico y el pobre, porque todos son obra de sus manos."
,"20":"Mueren de noche en un instante: se amotina un pueblo,y derriba al tirano sin esfuerzo."
,"21":"Pues sus ojos vigilan los caminos del hombre, y observan todos sus pasos,"
,"22":"no hay tinieblas ni sombras,donde puedan esconderse los malvados."
,"23":"Al hombre no le fija fecha,para presentarse ante Dios:"
,"24":"derrota a los grandes sin averiguaciones,y pone a otros en su lugar."
,"25":"El, conocedor de sus obras, los derriba en una noche y quedan aplastados,"
,"26":"los abofetea como a malvados,allí donde todos puedan verlos,"
,"27":"porque se apartaron de él,y no tomaron en cuenta su voluntad"
,"28":"mientras hasta élsubía el grito de los débiles: él escuchaba el lamento de los pobres."
,"29":"Si Dios calla, ¿quién lo moverá?,Si esconde su rostro, ¿quién lo descubrirá?,Vela sobre las naciones y los individuos,"
,"30":"y le quita el poder al opresor del pueblo."
,"31":"Pero si éste dice a Dios: 'Me dejé llevar, no volveré a hacer mal;"
,"32":"enséñame hasta que yo sepa bien. He cometido crímenes, pero no volveré a hacerlo';"
,"33":"según tu parecer, ¿lo castigará Dios?,Dilo, pues, tú que criticas, tú debes responder, no yo; di, pues lo sabes."
,"34":"Los hombres sensatos me dirán, al igual que todo sabio que me escuche:"
,"35":"Job habla sin saber, y sus argumentos no valen."
,"36":"Más aún, Job debe ser examinado a fondo,por sus respuestas, propias de malvados."
,"37":"Job ahora peca con plena advertencia, ya que niega su falta entre nosotros,y no cesa de hablar contra Dios.'"
}`)
	CurrentBook.AddChapter(35, `{
"1":"Elihú volvió a tomar la palabra y dijo:"
,"2":"'¿Crees que has hablado con sensatez,y que te has justificado ante Dios"
,"3":"al decirle: Qué te importa?,No te alcanza mi pecado."
,"4":"Voy a responderte a ti, y contigo a tus amigos."
,"5":"Contempla los cielos y mira, observa cómo las nubes están más arriba que tú."
,"6":"Si pecas, ¿qué le haces?,Si se multiplican tus ofensas, ¿en qué lo perjudicas?"
,"7":"Y con ser justo, ¿qué le das,o qué recibe él de tu mano?"
,"8":"A un hombre como tú afecta tu maldad, tu justicia es a la medida de los hombres."
,"9":"Gritan bajo el peso de la opresión, y claman porque los poderosos los dominan,"
,"10":"pero no preguntan: '¿Dónde está Dios, que nos creó, que da en las noches cantares de júbilo,"
,"11":"que nos instruye por medio de las bestias,y nos da ejemplos en las aves del cielo?'"
,"12":"Por eso, él no responde cuando gritan, cuando los malos los maltratan."
,"13":"En vano claman: Dios no escucha, el Omnipotente no los atiende."
,"14":"Peor todavía si dices que no encuentras a Dios, y que después de preparar tu defensa lo esperas."
,"15":"Lo mismo si dices que su enojo no sabe castigar,y que no se entera de los abusos."
,"16":"Por tanto, Job habla para decir nada, y multiplica sus discursos por falta de conocimiento.'"
}`)
	CurrentBook.AddChapter(36, `{
"1":"Elihú prosiguió diciendo:"
,"2":"'Espera un poco y yo te instruiré, pues tengo más que decir en favor de Dios."
,"3":"Voy a llevar muy lejos mi saber,y daré la razón a mi Hacedor."
,"4":"En verdad, no hay mentiras en mis palabras, pues el que te enseña es hombre de mucha experiencia."
,"5":"Sabes que Dios es muy fuerte, pero no rechaza al hombre de limpio corazón."
,"6":"No deja vivir al malvado a sus anchas, sino que hace justicia a los desvalidos:"
,"7":"no aparta su mirada de los justos. Si pone en el trono a los reyes, es para que perdure su reinado; pero si se dejan dominar por la soberbia,"
,"8":"entonces se ven cargados de cadenas, amarrados con cuerdas de aflicción."
,"9":"Después les muestra cómo ha sido su conducta,y sus faltas nacidas de su orgullo."
,"10":"Les llama la atención al oído, y los manda apartarse del mal."
,"11":"Si escuchan y lo sirven, acabarán felices sus días, y sus años, con toda tranquilidad."
,"12":"Pero si no lo escuchan, les quitará la vida de un golpe,y morirán por no haber entendido."
,"13":"Son hombres desleales que se rebelan,en vez de suplicarle cuando los encadena,"
,"14":"mueren en plena juventud,y su vida acaba despreciada."
,"15":"Dios salva al miserable por su misma pobreza, y le enseña por medio del sufrimiento."
,"16":"También a ti te librará de la angustia. una abundancia sin límites la reemplazará, y tu mesa rebosará de sabrosos manjares."
,"17":"Entonces enjuiciarás al malvado,justicia y derecho estarán en tus manos."
,"18":"No te dejes, pues, llevar por la ira,ni te dejes comprar por los regalos."
,"19":"Pide cuentas tanto al rico como al que nada tiene, al débil como al poderoso."
,"20":"No aplastes a aquellos que te son extraños, para poner en su lugar a tus parientes;"
,"21":"guárdate de inclinarte hacia la injusticia, pues ésta fue la causa de tu prueba."
,"22":"Mira, Dios es sublime en su fuerza, ¿qué maestro puede comparársele?"
,"23":"¿Quién le pedirá cuentas por lo que hace?,¿Quién le dirá: 'Has actuado mal?'"
,"24":"Acuérdate, pues, de ensalzar su obra, después que tantos hombres la alabaron."
,"25":"Todo humano la contempla, todo mortal la mira desde lejos."
,"26":"Dios es grande y no sabemos cuánto, el número de sus años es incalculable."
,"27":"El atrae las gotas de agua, los vapores que se transformarán en lluvia."
,"28":"Las nubes la derramarán,y la repartirán en el mundo de los hombres."
,"31":"Con esto, alimenta a los pueblos,y les proporciona abundante comida."
,"29":"¿Quién puede comprender el despliegue de las nubes,y el trueno que en su morada retumba?"
,"30":"Vean cómo extiende sus vapores,y cubre las profundidades de los mares."
,"32":"En sus manos ha alzado el rayo,y le ordena dar en el blanco."
,"33":"Su trueno lo anuncia a los pastores, y los rebaños sienten la tempestad inminente."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Por esto, se me estremece el corazón y salta fuera de su lugar."
,"2":"Escuchen el estruendo de su voz, el rumor que sale de su voz,"
,"3":"por la inmensidad del cielo arroja su relámpago,que llega a los extremos de la tierra."
,"4":"Detrás de él una voz ruge; truena con su majestuosa voz,y no retendrá sus rayos,mientras su voz retumbe."
,"5":"Por su voz hace Dios cosas maravillosas, cosas grandes que no comprendemos."
,"6":"A la nieve ordena: Cae sobre la tierra, y a los aguaceros: Sean fuertes."
,"7":"Así mantiene encerrados a los hombres, para que reconozcan que ésa es su obra."
,"8":"Las fieras huyen a sus guaridas,y permanecen en sus refugios."
,"9":"Del sur viene el huracán y del norte, el frío."
,"10":"Por el soplo de Dios se forma el hielo,y se pone sólida la superficie de las aguas."
,"11":"O bien, las nubes arrojan su rayo,y el nublado difunde sus relámpagos."
,"12":"Los envía por todos lados,para que hagan el trabajo que él ordena,sobre toda la superficie de la tierra."
,"13":"Si es para castigo, harán su voluntad, si es para bendición, será recibida."
,"14":"Presta oídos a esto, Job: detente y observa las maravillas de Dios."
,"15":"¿Sabes tú cómo manda él a su creación,y cómo de la nube brilla el relámpago?"
,"16":"¿Sabes tú cómo flotan las nubes, obra maravillosa del Perfecto Sabio?"
,"17":"Tú que sientes quemar tus vestidos,cuando la tierra descansa bajo el viento del sur,"
,"18":"¿acaso extendiste con él el firmamento, sólido como espejo de metal fundido?"
,"19":"Enséñame qué debemos decirle... Quedémonos aquí que ya viene la oscuridad."
,"20":"Si yo hablo, ¿alguien se lo cuenta?, ¿le informa de lo que uno ha dicho?"
,"21":"Pero ya no se ve la luz, oscurecida por las nubes... y ahora pasa el viento que las despeja..."
,"22":"Del norte llega una luz dorada: es la gloria terrible en torno a Dios."
,"23":"¡Es el Poderoso, al que no podíamos alcanzar!,Su fuerza es soberana, sus juicios y su justicia no oprimen a nadie."
,"24":"Por eso, los hombres lo deben temer, todos los sabios juntos no son nada ante él.'"
}`)
	CurrentBook.AddChapter(38, `{
"1":"Yavé respondió a Job en medio de la tempestad, y le dijo:"
,"2":"'¿Quién es ese que oscurece mis designios,y habla de lo que no sabe?"
,"3":"Amárrate los pantalones como hombre; voy a preguntarte, y tú me enseñarás."
,"4":"¿Dónde estabas tú cuando yo fundaba la tierra?,¡Habla, si es que sabes tanto!"
,"5":"¿Sabes tú quién fijó sus dimensiones, o quién la midió con una cuerda?"
,"6":"¿Sobre qué están puestas sus bases,o quién puso su piedra angular,"
,"7":"mientras cantaban a coro las estrellas del alba,y aclamaban todos los hijos de Dios?"
,"8":"¿Quién encerró con doble puerta el mar,cuando salía borbotando del seno materno,"
,"9":"cuando le puse una nube por vestido,y espesos nublados por pañales;"
,"10":"cuando le fijé sus límites,y le puse puertas y cerrojos"
,"11":"diciendo: 'Hasta aquí no más llegarás, aquí se romperá el orgullo de tus olas'?"
,"12":"¿Has mandado una vez en tu vida a la mañana,o indicado a la aurora su lugar,"
,"13":"para que tome los bordes de la tierra,y eche fuera de ella a los malhechores?"
,"14":"El suelo entonces toma un color de arcilla,y se tiñe de rojo como un vestido."
,"15":"Les quita su luz a los malvados,y quiebra el brazo que iba a matar."
,"16":"¿Has llegado hasta donde nace el mar,y paseado por el fondo del abismo?"
,"17":"¿Se te han mostrado las puertas de la muerte?,¿Has visto los porteros del país de la sombra?"
,"18":"¿Has medido las llanuras inmensas?,¡Indícalo, si lo sabes!"
,"19":"¿Por dónde se va a la morada de la luz,y de dónde salen las tinieblas?"
,"20":"Si sabes ir hasta su casa, podrías encaminarlas hasta allá."
,"21":"Pero lo sabes, pues naciste antes que ellas,y grande es el número de tus días."
,"22":"¿Has llegado a los depósitos de nieve?,¿Has visto las reservas de granizo"
,"23":"que guardo yo para los días de angustia, para el día de la guerra y del combate?"
,"24":"¿De dónde sale y se difunde la luz, de dónde el viento de oriente que barre la tierra?"
,"25":"¿Quién abre un canal al aguacero,y una senda al estrépito de los truenos,"
,"26":"para que llueva sobre la tierra inhabitada, sobre el desierto donde no hay un ser humano,"
,"27":"para regar las soledades desoladas, y hacer germinar en tierra árida hierba verde?"
,"28":"¿Tiene padre la lluvia?,¿Quién engendra las gotas del rocío?"
,"29":"¿Qué seno dio a luz al hielo?,¿Quién engendra la escarcha del cielo"
,"30":"cuando las aguas se endurecen como piedras, y se congela la superficie del abismo?"
,"31":"¿Puedes tú anudar los lazos de las Cabrillas,o desatar las cuerdas del Orión?"
,"32":"¿Haces tú salir a su tiempo,el lucero del alba,y guías a la Osa con sus pequeños?"
,"33":"¿Conoces acaso las leyes de los cielos,y haces que sus decretos se cumplan en la tierra?"
,"34":"¿Llegará tu orden hasta las nubes, de manera que te responda un diluvio de aguas?"
,"35":"¿Serás tú quien arroje los relámpagos?,¿Acaso te dirán: 'Aquí estamos'?"
,"36":"¿Quién puso sabiduría en el ibis, y dio inteligencia al gallo?"
,"37":"¿Quién puede someter a las nubes, y vaciar los estanques del cielo,"
,"38":"para que el polvo se haga barro,y los terrones se peguen entre sí?"
,"39":"¿Acaso tú preparas la caza de la leona,y sacias el hambre de sus cachorros,"
,"40":"cuando están agazapados en sus guaridas,y se ponen al acecho en los matorrales?"
,"41":"¿Quién prepara al cuervo su alimento,cuando sus polluelos claman a Dios,y se agitan hambrientos?"
}`)
	CurrentBook.AddChapter(39, `{
"1":"¿Sabes cómo se multiplican las gamuzas,y has observado el parto de las ciervas?"
,"2":"¿Has contado los meses de su preñez, sabes la época de su parto?"
,"3":"Entonces se acurrucan y paren sus crías. En pleno desierto depositan su camada,"
,"4":"y cuando ya sus crías se hacen fuertes y grandes, se marchan y no vuelven más a ellas."
,"5":"¿Quién dejó en libertad al burro salvaje,y soltó sus amarras?"
,"6":"Yo le he dado el desierto por morada, y la tierra salitrosa por mansión."
,"7":"El se ríe del tumulto de la ciudad,y no escucha los gritos del arriero,"
,"8":"explora las montañas en busca de su pasto,y de todo lo que es verde."
,"9":"¿Querrá el búfalo trabajar para ti,o pasar la noche en tu pesebre?"
,"10":"¿Podrás amarrarle al cuello con un cordel, para que vaya detrás de ti tapando los surcos?"
,"11":"¿Podrías contar con él por su mucha fuerza,y encomendarle lo que a ti te cansa?"
,"12":"¿Estarás seguro que volverá,para acarrear las gavillas a tu era?"
,"13":"El avestruz tiene unas alas alegres,y unas plumas suaves como un plumón."
,"14":"Pero pone sus huevos en la tierra,y deja que el calor del suelo los empolle;"
,"15":"no se fija en que un pie puede aplastarlos,y los animales del campo pueden abrirlos."
,"16":"Ignora a sus pichones como si no fueran suyos, no le importa haberse sacrificado para nada."
,"17":"Porque Dios lo dejó sin razón,y no le dio nada de inteligencia;"
,"18":"pero, apenas puede mantenerse en pie, se burla del jinete y de su caballo."
,"19":"¿Tú das al caballo su fuerza,y cubres de crines su cuello?"
,"20":"¿Tú lo haces saltar como langosta?,Su fuerte relincho da miedo."
,"21":"Da patadas en el suelo de la pradera, y relinchando con fuerza, se lanza al frente del ejército."
,"22":"Se ríe del miedo y nada lo asusta,ni la espada lo hace retroceder."
,"23":"Sobre él resuenan las flechas, el brillo llameante de las lanzas y de los dardos."
,"24":"Temblando de impaciencia devora la distancia,y no se para hasta que resuena el clarín."
,"25":"Cuando siente la trompeta relincha, y olfatea de lejos el combate, las órdenes de los jefes y el grito de guerra."
,"26":"¿Diriges acaso el vuelo del halcón, cuando despliega sus alas hacia el sur?"
,"27":"¿Por orden tuya se eleva el águila,y coloca su nido en las alturas?"
,"28":"Hace de la roca su mansión nocturna,y de un picacho su fortaleza."
,"29":"Desde ahí espía su presa, y sus ojos de lejos la divisan."
,"30":"Alimenta con sangre a sus pichones, llega al instante donde cae un cuerpo.'"
}`)
	CurrentBook.AddChapter(40, `{
"1":"Yavé reprendió a Job, diciéndole:"
,"2":"'El acusador del Poderoso, ¿se da por vencido?,o va a replicar el censor de Dios?'"
,"3":"Y Job respondió a Yavé:"
,"4":"'Hablé con ligereza, ¿qué te contestaré?,Prefiero ponerme la mano ante la boca."
,"5":"Hablé una vez...  no volveré a hacerlo; dos veces...  no añadiré nada.',Sigue el discurso de Yavé"
,"6":"Yavé contestó a Job en medio de la tempestad, y dijo:"
,"7":"'Amárrate los pantalones como hombre, voy a interrogarte y tú me enseñarás:"
,"8":"¿serás tú quien firmará mi sentencia,y me condenará para afirmar tus derechos?"
,"9":"¿Tiene tu brazo la fuerza de Dios,y sabes tronar como él?"
,"10":"Vamos, adórnate con majestad y grandeza, cúbrete de esplendor y de gloria,"
,"11":"haz brillar el furor de tu cólera, con una mirada doblega al arrogante."
,"12":"Con una mirada derriba a todo ser soberbio, aplasta, donde se encuentren, a los impíos."
,"13":"Húndelos juntos en el polvo, enciérralos en el calabozo,"
,"14":"y yo mismo te felicitaré,por haber triunfado por tu propia fuerza."
,"15":"Yo que te hice, hice también a Behemot. Se alimenta de hierba como el buey,"
,"16":"pero, ¡mira qué fuerza en sus lomos,qué potencia en los músculos de su vientre!"
,"17":"Arrisca la cola como un cedro, los nervios de su muslo resaltan como cables."
,"18":"Sus huesos son barras de acero, duras sus costillas como hierro forjado."
,"19":"Es la primera de las obras de Dios, que lo hizo soberano de sus compañeros."
,"20":"Desde el monte en que las bestias se entretienen, todas le llevan su tributo."
,"21":"Fue a descansar bajo los lotos; escondido en los cañaverales del pantano,"
,"22":"las ramas del loto le dan sombra,y los sauces del torrente lo protegen."
,"23":"Si el río crece, no se asusta; el agua le llega hasta el hocico, y él se queda tranquilo."
,"24":"¿Quién se atreverá a herirle los ojos,y ponerle una argolla en las narices?"
,"25":"Y a Leviatán, ¿lo pescas tú con anzuelo, y con una cuerda lo sujetas de la lengua?"
,"26":"¿Le atraviesas las narices con una caña, o con un gancho lo sacarás de las quijadas?"
,"27":"¿Acaso te hará largas súplicas,y te hablará con timidez?"
,"28":"¿Se comprometerá contigo en un contrato,para servirte toda su vida?"
,"29":"¿Te entretendrá como un pajarillo, lo atarás para gozo de tus hijas?"
,"30":"¿Habrá gente para hacer dinero de su carne,y venderla a los comerciantes?"
,"31":"¿Acribillarás su piel con flechas, y clavarás un arpón en su cabeza?"
,"32":"Si colocas tu mano sobre él, ¡mira qué lucha!, no volverás a comenzar."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Ya pierden su confianza,y son derribados por su sola vista."
,"2":"Se vuelve tan feroz apenas lo despiertan, que no pueden hacerle frente."
,"3":"¿Quién lo ha desafiado y quedó con vida?,¡Nadie, bajo ningún cielo!"
,"4":"Te hablaré también de sus miembros, te explicaré su fuerza incomparable."
,"5":"¿Quién ha levantado la orla de su vestido, y pasó la mano bajo su coraza?"
,"6":"¿Quién ha abierto las mandíbulas de sus fauces?,¡Qué terror con sólo ver sus dientes!"
,"7":"Su lomo son escudos en hileras, unidos como piedras selladas."
,"8":"Están tan juntos, que no dejan pasar ni un soplo."
,"9":"Se unen unos a otros,formando una capa sin junturas."
,"10":"Si estornuda saltan chispas, de sus pupilas sale un rayo de luz."
,"11":"De su hocico salen llamaradas, se escapan chispas de fuego."
,"12":"Sus narices echan humo, como caldera hirviente al fuego."
,"13":"Su aliento encendería carbones, salen llamas de su boca."
,"14":"Su cogote está lleno de fuerza,y ante él brota el miedo."
,"15":"Su caparazón es un solo conjunto, resistente por doquier e inconmovible."
,"16":"Cuando se endereza, se asustan las aguas, y las olas del mar se alejan."
,"17":"Su corazón es duro como roca, resistente como piedra de molino."
,"18":"La espada que lo alcanza no lo clava, le rebotan la lanza y la jabalina."
,"19":"Para él, el hierro es paja, y el bronce, madera podrida."
,"20":"Las flechas del arco no lo hacen huir, recibe como paja las piedras de la honda."
,"21":"La maza le parece caña, se ríe del dardo que vibra."
,"22":"Por debajo tiene como tejas puntiagudas, y como un rastrillo pasa por el barro."
,"23":"Entran luego las aguas en ebullición, el agua borbotea como carbones de incienso."
,"24":"Deja tras sí un brillante surco, un mar de blanca espuma."
,"25":"En tierra no tiene semejante, fue hecho atrevido,"
,"26":"mira de frente a los más insolentes, es rey de todas las fieras.'"
}`)
	CurrentBook.AddChapter(42, `{
"1":"Y Job respondió a Yavé:"
,"2":"'Reconozco que lo puedes todo, y que eres capaz de realizar todos tus proyectos."
,"3":"Hablé sin inteligencia de cosas que no conocía, de cosas extraordinarias, superiores a mí."
,"5":"Yo te conocía sólo de oídas; pero ahora te han visto mis ojos."
,"6":"Por esto, retiro mis palabras,y hago penitencia sobre el polvo y la ceniza.'"
,"7":"Yavé, después de hablarle así a Job, se dirigió a Elifaz de Temán: 'Me siento muy enojado contra ti y contra tus dos amigos, porque no hablaron bien de mí, como lo hizo mi servidor Job. "
,"8":"Por lo tanto, consíganse siete becerros y siete carneros y vayan a ver a mi servidor Job. Ofrecerán un sacrificio de holocaustos, mientras que mi servidor Job rogará por ustedes. Ustedes no han hablado bien de mí, como hizo mi servidor Job, pero los perdonaré en consideración a él.'"
,"9":"Elifaz de Temán, Bildad de Suaj y Sofar de Naamat fueron a ejecutar la orden de Yavé. Y Yavé los perdonó por consideración a Job. Aquí termina la historia del santo Job"
,"10":"Yavé hizo que la nueva situación de Job superara la anterior, porque había intercedido por sus amigos y aun Yavé aumentó al doble todos los bienes de Job."
,"11":"Este vio volver a él a todos sus hermanos y hermanas, lo mismo que a los conocidos de antes. Comían con él en su casa lo compadecían y consolaban por todos los males que Yavé le había mandado. Cada uno de ellos le regaló una moneda de plata y un anillo de oro."
,"12":"Yavé hizo a Job más rico que antes. Tuvo catorce mil ovejas, seis mil camellos, mil yuntas de bueyes y mil burras."
,"13":"Tuvo siete hijos y tres hijas. A la primera la llamó 'Tórtola',"
,"14":"a la segunda, 'Canela' y a la tercera, 'Frasco de Perfumes'."
,"15":"No se hallaban en el país mujeres tan bellas como las hijas de Job. Y su padre les dio parte de la herencia junto con sus hermanos."
,"16":"Job vivió todavía ciento cuarenta años después de sus pruebas,"
,"17":"y vio a sus hijos y a sus nietos hasta la cuarta generación."
}`)

}
func ES_LBL_LoadVSPRChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Estos son Proverbios de Salomón, hijo de David, rey de Israel,"
,"2":"para que con ellos adquieran sabiduría y educación, y entiendan las palabras que abren la inteligencia,"
,"3":"para darles lecciones de buen juicio,y así lleguen a ser justos, honrados y leales."
,"4":"La gente sencilla aprenderá a juzgar bien, los jóvenes se instruirán, su espíritu se abrirá."
,"6":"Comprenderán los proverbios y refranes, las palabras de los sabios y sus enigmas."
,"5":"Que el sabio escuche, y ganará en saber; el hombre inteligente sabrá dirigir a los demás."
,"7":"El comienzo del saber es el temor de Yavé, únicamente los tontos desprecian la sabiduría y la disciplina."
,"8":"Escucha, hijo mío, los consejos de tu padre, no rechaces las advertencias de tu madre:"
,"9":"Son para ti una hermosa corona para tu cabeza, un collar para tu cuello."
,"10":"¡Hijo mío, si los pecadores quieren arrastrarte al mal, no los sigas! Tal vez te dirán:"
,"11":"'Ven con nosotros, aguardaremos el buen momento -¡y es para matar! Tenderemos una trampa - ¡una trampa al inocente que no la merece!"
,"12":"Haremos de él un buen bocado, como se hace en la Morada de los muertos, caeremos sobre él como la muerte."
,"13":"Pondremos las manos sobre montones de cosas de valor, llenaremos nuestras casas con el botín."
,"14":"Pero tú, también tendrás tu parte, porque todo lo pondremos en común.'"
,"15":"Hijo mío, no camines con ellos, no vayas por donde ellos andan."
,"16":"¡Mira cómo sus pies corren hacia el mal, cuán rápidamente han derramado sangre!"
,"17":"Los pájaros no caen en tu trampa si la has puesto a la vista,"
,"18":"pero ellos, ponen en juego su propia vida, ellos mismos se ponen trampas."
,"19":"Así acabará cualquier hombre que vive de rapiñas: un día cualquiera la rapiña le costará la vida."
,"20":"La sabiduría grita por las calles, levanta su voz en las plazas."
,"21":"Presenta su llamado en las encrucijadas, pronuncia su mensaje en las puertas de la ciudad:"
,"22":"¿Por cuánto tiempo más, gente insignificante, preferirán sus estupideces? ¿Hasta cuándo los burlones se entretendrán con sus mofas y la gente estúpida se negará a saber?"
,"23":"Oigan pues mis advertencias, en este momento en que abro mi corazón y les doy a conocer mis pensamientos."
,"24":"¿Se van a rehusar cuando los llamo, no van a poner atención cuando les tiendo la mano?"
,"25":"¿No quieren hacer caso de mis consejos y rechazan mis advertencias?"
,"26":"Yo también me reiré de su miseria, me burlaré cuando el miedo los domine,"
,"27":"cuando les llegue el hurracán del terror y se los lleve el torbellino de las desdichas, cuando queden bajo el peso de la miseria y de la angustia."
,"28":"Entonces me llamarán pero no responderé, me buscarán pero no me hallarán."
,"29":"Porque no quisieron el saber, no eligieron el temor de Yavé."
,"30":"Esa gente no buscó mis consejos, despreció todas mis advertencias."
,"31":"Por eso, comerán los frutos de sus errores, y de sus iniciativas, hasta que no puedan más."
,"32":"Porque a los tontos los perderá su porfía, y a los irresponsables su propia dejación."
,"33":"Pero el que me escucha dormirá en paz, no tendrá que temer la desgracia."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Acoge mis palabras, hijo mío, guarda mi enseñanza,"
,"2":"que tu oído se abra a la sabiduría, que tu corazón se doblegue a la verdad,"
,"3":"apela a la inteligencia y déjate guiar por la razón;"
,"4":"busca la sabiduría como el dinero, como un tesoro escondido:"
,"5":"entonces penetrarás en el temor de Yavé y hallarás el conocimiento de Dios."
,"6":"Porque Yavé da la sabiduría, de su boca salen el saber y la verdad."
,"7":"El viene en ayuda de los hombres rectos, es un escudo para los que siguen siendo honrados."
,"8":"Está alerta a lo largo del buen camino para proteger el caminar de sus fieles."
,"9":"Entonces comprenderás lo que es justo y honrado, lo que es recto y conduce a la felicidad."
,"10":"Entonces entrará la sabiduría en tu corazón y el saber será tu alegría."
,"11":"La prudencia velará por ti, la reflexión será tu salvaguardia;"
,"12":"te mantendrán aparte de los caminos del mal y de los hombres de palabras engañosas,"
,"13":"que abandonan los rectos senderos y se van por caminos oscuros;"
,"14":"que ponen su alegría en hacer el mal y se complacen en sus abominaciones,"
,"15":"que van por caminos chuecos, por senderos que se pierden."
,"16":"La sabiduría te protegerá de la mujer de otro, de la bella desconocida de palabras suaves,"
,"17":"que abandona al compañero de su juventud y olvida las alianzas de su Dios."
,"18":"De su casa se salta a la muerte, sus senderos llevan derecho a la tumba."
,"19":"Los que allá van no volverán, no reencontrarán el camino de la vida."
,"20":"Pero tú irás por el camino de la gente honrada, seguirás los senderos de los justos."
,"21":"Porque los hombres buenos vivirán en el país, las personas íntegras prolongarán en él sus días."
,"22":"Los malos en cambio serán echados del país, los traidores serán expulsados."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Hijo mío, no te olvides de mis advertencias, que tu corazón sepa guardar mis mandamientos."
,"2":"Ellos prolongarán tus días, te darán la prosperidad, años de vida."
,"3":"¡Que no te falten ni la bondad ni la fidelidad! Atalas a tu cuello, inscríbelas en las tablillas de tu corazón;"
,"4":"así conseguirás benevolencia y estima tanto de Dios como de los hombres."
,"5":"Confía en el Señor con todo el corazón, y no te fíes de tu propia sabiduría."
,"6":"En cualquiera cosa que hagas, tenlo presente: él aplanará tus caminos."
,"7":"No te creas el más sabio: ten el temor de Yavé y mantente alejado del mal."
,"8":"Eso será un remedio para tu cuerpo, y allí encontrarás el vigor."
,"9":"Haz tu ofrenda a Yavé, tomando de tus bienes los primeros frutos de tus cosechas;"
,"10":"entonces se llenarán de trigo tus graneros y tus cubas desbordarán de vino nuevo."
,"11":"Hijo mío, no desprecies las advertencias de Yavé, no te rebeles contra su reprimenda;"
,"12":"porque el Señor corrige al que ama, así como un padre reprende al hijo que quiere."
,"13":"¡Feliz el mortal que encontró la sabiduría, el hombre que obtuvo la inteligencia!"
,"14":"El estar provisto de sabiduría vale más que tener dinero en el banco; te da más utilidades que el oro."
,"15":"Es más preciosa que las perlas, nada de lo que te atrae se le puede igualar."
,"16":"Con su mano derecha te ofrece larga vida, y con la otra, riqueza y gloria."
,"17":"Te llevará por caminos agradables, todas sus sendas son seguras."
,"18":"Es un árbol de vida para el que se acerca a ella; ¡felices los que encontraron la sabiduría!"
,"19":"Yavé mediante la sabiduría puso la tierra en orden; por medio de la inteligencia estableció el firmamento."
,"20":"Debido a su ciencia brotaron las aguas de las profundidades y las nubes derramaron la lluvia."
,"21":"Actúa siempre, hijo mío, con prudencia y reflexión: es algo que no debes olvidar."
,"22":"De allí te llegará la vida: la sentirás en ti, irradiará en tu rostro."
,"23":"Avanzarás entonces con confianza, sin miedo a tropezarte."
,"24":"Irás a acostarte sin temor y durante la noche tu sueño será apacible."
,"25":"No temerás una catástrofe repentina o el ataque imprevisto de los malhechores."
,"26":"Porque Yavé estará a tu lado y tu pie no quedará metido en una trampa."
,"27":"No niegues un favor al que te lo pide, si tienes como hacerlo."
,"28":"Si puedes hacerlo inmediatamente, no digas a tu prójimo: 'Andate, vuelve mañana y te lo daré.'"
,"29":"No le juegues a tu prójimo una mala pasada, siendo que confió en ti."
,"30":"No pelees con otro sin motivo, siendo que nada malo te ha hecho."
,"31":"No tengas envidia de los violentos, no imites su comportamiento;"
,"32":"porque Yavé tiene horror de la gente sin conciencia, pues su amistad es para con los justos."
,"33":"Yavé maldice la casa del malvado, bendice la morada de los justos."
,"34":"Se burla de los burlones, concede su favor a los humildes."
,"35":"La gloria está reservada a los sabios, y los tontos sólo tendrán el desprecio."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Hijos míos, escuchen la enseñanza de un padre, estén atentos para conocer la verdad."
,"2":"Les doy un saber bueno, no rechacen mi enseñanza."
,"3":"Yo mismo fui un hijo dócil con mi padre, el hijo regalón de mi mamá;"
,"4":"él me instruía entonces en estos términos: '¡Recuerda bien mis palabras; sigue mis consejos y vivirás!"
,"5":"¡Busca la sabiduría! ¡Hazte inteligente! No olvides lo que te digo, no menosprecies mis palabras."
,"6":"Si no abandonas la sabiduría, ésta te protegerá; ámala y velará por ti."
,"7":"El principio de la sabiduría es correr tras ella; ¡busca la inteligencia a cambio de todo lo que tienes!"
,"8":"Elígela, te exaltará; apégate a ella, te honrará."
,"9":"Pondrá en tu cabeza una magnífica diadema, te regalará una corona de gloria'."
,"10":"Atiéndeme, pues, hijo mío, toma en serio mis palabras, y vivirás largos años."
,"11":"Cuando te haya enseñado los caminos de la sabiduría, cuando haya orientado tu ruta,"
,"12":"caminarás sin vacilar y podrás correr sin miedo a caerte."
,"13":"Conserva mi disciplina, no la dejes: guárdala y vivirás."
,"14":"¡Pero, no tomes el camino de los malvados, no vayas por el sendero de los malos!"
,"15":"Evítalos, apártate de ellos; ándate por otro camino y pasa lejos."
,"16":"Porque no pueden dormir si no hacen el mal; no descansan en tanto no le hayan hecho daño a alguien."
,"17":"El crimen se volvió su pan, y la violencia, el vino de que tienen sed."
,"18":"El camino de los justos es como la luz de la aurora: su resplandor va aumentando hasta el mediodía."
,"19":"Pero el camino de los malvados es sólo oscuridad; no ven lo que los hará caer."
,"20":"¡Hijo mío, pon atención a mis palabras, oye bien mis discursos!"
,"21":"Tenlas presentes en el espíritu, guárdalas en lo más profundo de tu corazón."
,"22":"Porque son vida para el que las acoge, son un remedio para el cuerpo."
,"23":"Primero que nada, vigila tu corazón, porque en él está la fuente de la vida."
,"24":"Rechaza cualquier lenguaje perverso, abstente de cualquier mentira."
,"25":"Que tus ojos miren de frente, que tu mirada sea franca."
,"26":"Tantea primero el suelo bajo tus pies, para que tu andar sea seguro."
,"27":"No te vuelvas a derecha ni a izquierda, sino que aléjate del mal."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Hijo mío, pon atención a mi sabiduría, oye bien mis palabras de advertencia."
,"2":"Recuerda mis consejos y habla siempre a sabiendas."
,"3":"Las lisonjas de la mujer infiel son dulces como la miel, sus palabras son más pegajosas que el aceite."
,"4":"Pero el fin será más amargo que el ajenjo; es una espada afilada de doble filo."
,"5":"Sus pies corren derechos a la muerte, sus pasos descienden a la tumba;"
,"6":"más que tomar el camino de la vida, ella sigue la senda que se desvía quién sabe a dónde."
,"7":"Y ahora, hijo mío, no te apartes de mis consejos."
,"8":"Que tu trayecto pase lejos de esa mujer, no te arriesgues a la entrada de su casa."
,"9":"Porque a lo mejor puedes perder tu honor con gente extraña, y años de tu vida pueden pasar a gente despiadada."
,"10":"¡No sea que extraños devoren tu fortuna, y tus economías acaben en la casa de otro!"
,"11":"Entonces te lamentarás, viendo cómo se agotaron tus fuerzas y tu salud,"
,"12":"y dirás: '¿Cómo pude rechazar las advertencias y despreciar tantos sabios consejos?"
,"13":"¿Por qué no escuché la voz de mis maestros y seguí los consejos de los que me instruían?"
,"14":"¡Ahora casi he llegado al nivel más bajo, en medio del pueblo y de la asamblea!'"
,"15":"¡Toma el agua de tu propia cisterna, bebe el agua que brota de tu fuente!"
,"16":"No permitas que tus aguas se pierdan fuera, que las vean correr por las calles."
,"17":"¡Que sean sólo para ti, y no para extraños junto contigo!"
,"18":"¡Bendita sea tu fuente, y sea tu alegría la mujer de tu juventud,"
,"19":"graciosa cierva, amable gacela! Encuentra el placer entre sus pechos en cualquier momento, y permanece siempre prendado de su amor!"
,"20":"¿Por qué, hijo mío, te dejarías llevar por la pasión por una desconocida, por qué apretar el vientre de una extraña?"
,"21":"Has de saber que Yavé observa el comportamiento de los hombres y vigila todos sus pasos."
,"22":"El que hace el mal quedará atrapado en el mal que hizo, se verá atado por sus propios pecados."
,"23":"Morirá porque falta de disciplina, se perderá cuando sus errores lleguen al colmo."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Hijo mío, si has servido de aval a un compañero, si te has comprometido con un desconocido,"
,"2":"estás amarrado por tus propias palabras, eres prisionero de tus compromisos."
,"3":"Pues bien, haz esto, hijo mío: ¡libérate lo más pronto! ¿No ves que estás a merced de otro? ¡Anda a verlo, ponte de rodillas, suplícale!"
,"4":"¡No concedas sueño a tus ojos ni descanso a tus párpados;"
,"5":"tienes que librarte, como el ciervo de la trampa, como el pájaro de la red!"
,"6":"Flojo, anda a ver a la hormiga, mira cómo se mueve y se hace sabia."
,"7":"En su casa no hay jefe, ni supervisor, ni mayordomo;"
,"8":"pero junta en verano provisiones, amontona su alimento en tiempo de cosecha."
,"9":"¿Flojo, hasta cuándo vas a seguir echado? ¿Cuándo vas a levantarte de tu cama?"
,"10":"Duermes un poco, después sueñas un momento, luego estiras los brazos cruzados... "
,"11":"y de pronto te sorprende la pobreza como un vagabundo, la miseria cae sobre ti como un ladrón."
,"12":"El pillo, el marrullero, anda con risitas;"
,"13":"guiña un ojo, arrastra los pies, hace sonar los dedos."
,"14":"Está siempre preparando alguna trampa, anda buscando peleas en todo momento."
,"15":"Pero también, sin que lo advierta, caerá sobre él la desgracia, será derribado de un golpe y no se repondrá."
,"16":"Hay seis cosas que detesta el Señor, y hasta siete que le causan horror:"
,"17":"la mirada despreciativa, la lengua mentirosa, las manos que derraman sangre inocente,"
,"18":"el corazón que medita intenciones culpables, los pies que corren impacientes a hacer el mal,"
,"19":"el testigo falso que habla para mentir y el hombre que provoca la discordia entre hermanos."
,"20":"Hijo mío, observa los consejos de tu padre, no rechaces la enseñanza de tu madre."
,"21":"Mantenlos bien amarrados en tu corazón, cuélgalos de tu cuello."
,"22":"Ellos guiarán tus pasos; en tu sueño velarán por ti y te aconsejarán apenas despiertes."
,"23":"El mandamiento es una lámpara, la Ley, una luz; las correcciones te enseñan el camino de la vida."
,"24":"Te protegerán de la mala mujer, de las palabras zalameras de la mujer de otro."
,"25":"No sueñes con su belleza, ni te dejes conquistar por sus miradas."
,"26":"La prostituta no busca más que un trozo de pan, pero la mujer adúltera lo que quiere es una vida preciosa."
,"27":"¿Se pueden llevar brasas en los bolsillos sin que se queme la ropa?"
,"28":"¿Se puede caminar por carbones encendidos sin que se quemen los pies?"
,"29":"Lo mismo pasa con el que va donde la mujer de su prójimo: el que la toca no quedará sin castigo."
,"30":"No se condena al ladrón hambriento que roba para llenar su estómago."
,"31":"Pero si es pillado, tendrá que pagar siete veces más: y en eso se le irá toda su casa."
,"32":"¡Cuánto más loco el que le levanta al prójimo su mujer! El que lo hace, se pierde a sí mismo."
,"33":"Cosechará golpes y deshonra, dejará en ello su reputación."
,"34":"Porque los celos pondrán furioso al marido; en la primera oportunidad se vengará sin compasión."
,"35":"No aceptará excusa alguna, tus regalos no lo conmoverán."
}`)
	CurrentBook.AddChapter(7, `{
"1":"¡Hijo mío, guarda mis palabras, conserva como cosa preciosa mis consejos."
,"2":"Observa mis órdenes y vivirás, guarda mi enseñanza como a la niña de tus ojos."
,"3":"Apriétalos firmemente entre tus dedos, inscríbelos en las tablillas de tu corazón!"
,"4":"Dile a la sabiduría: 'Sé mi hermana', y a la inteligencia: 'Se mi amiga'."
,"5":"Entonces sabrás protegerte de la mujer de otro, de la hermosa desconocida de suaves palabras."
,"6":"Miraba desde la ventana de mi casa a través de la rejilla,"
,"7":"y vi pasar a un muchacho, a uno de esos jóvenes que no piensan en nada."
,"8":"Se metía por la callejuela, cerca de la esquina donde vive esa mujer, para dirigirse a su casa."
,"9":"Atardecía, terminaba el día, ya estaba encima la noche y la oscuridad."
,"10":"De repente, sale ella a su encuentro, vestida como prostituta y tapada con un velo."
,"11":"Es la mujer descarada, que no tiene vergüenza ni puede quedarse tranquila en su casa."
,"12":"Ya sea en la calle, ya sea en las plazas, por todas partes anda buscando aventuras."
,"13":"Se echa sobre el joven y lo abraza; le dice con tono seguro:"
,"14":"'Tenía que ofrecer un sacrificio, hoy mismo tuve que pagar mi manda."
,"15":"Salí pues a buscarte para que estés en el banquete y te encontré."
,"16":"Adorné mi cama con un cobertor de fina tela de Egipto."
,"17":"Perfumé mi lecho con mirra, áloe y canela."
,"18":"¡Ven, entreguémonos al placer, embriaguémonos de amor hasta el amanecer!"
,"19":"Mi marido no está en casa, salió de viaje a un lugar lejos de aquí;"
,"20":"se llevó el dinero y no volverá a casa hasta la luna llena.'"
,"21":"Logra convencerlo con habilidad, lo seduce y se lo lleva."
,"22":"El la sigue como un buey que llevan al matadero, como un ciervo pillado en un lazo corredizo,"
,"23":"al que pronto una flecha atravesará el hígado: ¡Es como un pájaro que cae en la trampa, sin saber que eso le costará la vida!"
,"24":"Pues bien, hijos míos, pongan atención en lo que les digo."
,"25":"No te dejes seducir por una de esas mujeres, ni te dejes engañar por sus maniobras."
,"26":"Porque ella ya ha hecho muchas víctimas, y hasta los más fuertes han caído."
,"27":"De su casa se pasa al lugar de los muertos, es un camino que se hunde en el mundo de los muertos."
}`)
	CurrentBook.AddChapter(8, `{
"1":"¿Quién llama? ¿No es la sabiduría?,Esa voz, ¿no es la de la inteligencia?"
,"2":"Se detuvo en las alturas, al borde del camino, en el cruce de las carreteras."
,"3":"Miren cómo llama a las puertas de la ciudad, en las entradas más frecuentadas:"
,"4":"'¡A Ustedes, humanos, me dirijo, lanzo un llamado a los hijos de los hombres!"
,"5":"¡Aprendan a juzgar, ustedes que no saben; y sean más reflexivos, ustedes que no piensan!"
,"6":"Escúchenme, les diré lo esencial, nada sale de mis labios que no sea exacto."
,"7":"De mi boca brota la verdad, porque aborrezco los discursos hipócritas."
,"8":"Todas mis palabras son sinceras, ni una sola es dudosa o falsa."
,"9":"Todas son exactas: un espíritu abierto se da cuenta; son justas: eso se ve con un poco de saber."
,"10":"Aprópiense de mi disciplina antes que del dinero, elijan la ciencia y no el oro fino."
,"11":"La sabiduría es más útil que las perlas, ¿qué tesoro podría igualársele?"
,"12":"Yo, la Sabiduría, vivo junto con el arte de juzgar, la acción reflexiva me tiene entre sus amigas."
,"13":"(Aborrecer el mal es temer a Yavé.),Aborrezco el orgullo y la arrogancia, los caminos que conducen al mal y a la hipocresía."
,"14":"Mío es el buen sentido, y mío el saber práctico, mía la inteligencia y también el poder."
,"15":"Por mí reinan los reyes,y sus ministros deciden con justicia."
,"16":"Gracias a mí se mantienen los príncipes, los grandes, y los que gobiernan la tierra."
,"17":"Amo a los que me aman, los que me buscan me encuentran."
,"18":"Junto conmigo encuentran honor y riqueza, fortuna perdurable y prosperidad."
,"19":"Mis frutos son mejores que el oro fino, lo que yo aporto vale más que la plata."
,"20":"Voy por un camino de rectitud, de donde salen a todas partes senderos de justicia;"
,"21":"voy colmando de bienes a los que me aman, y dejando llenas sus bodegas."
,"22":"Yavé me creó -fue el inicio de su obra-,antes de todas las criaturas, desde siempre."
,"23":"Antes de los siglos fui formada, desde el comienzo, mucho antes que la tierra."
,"24":"Aún no existían los océanos cuando yo nací, no había fuente alguna de donde brotaran los mares."
,"25":"Las montañas no habían aparecido, ni tampoco había colinas cuando fui dada a luz."
,"26":"Yavé no había hecho ni la tierra ni el campo, ni siquiera el primitivo polvo del mundo."
,"27":"Yo ya estaba allí cuando puso los cielos en su lugar, cuando trazó en el océano el círculo de los continentes,"
,"28":"cuando formó las nubes en las alturas, y reguló en el fondo de los mares el caudal de sus aguas,"
,"29":"cuando le impuso sus fronteras al mar, un límite que no franquearían sus olas. Cuando ponía los cimientos de la tierra,"
,"30":"yo estaba a su lado poniendo la armonía. Día tras día encontraba en eso mis delicias,y continuamente jugaba en su presencia."
,"31":"Me entretengo con este mundo, con la tierra que ha hecho, y mi gusto más grande es estar con los humanos."
,"32":"Pues bien, hijos míos, oíganme. ¡Felices los que siguen mis caminos!"
,"33":"¡Acepten mi enseñanza y sean sabios, no la menosprecien!"
,"34":"Feliz el que me escucha, que aguarda cada día junto a mi puerta,y permanece a la espera, en el umbral."
,"35":"Porque el que me encuentra ha encontrado la vida, sobre él vendrán los favores de Yavé;"
,"36":"pero el que me ofende atenta contra su vida, todos los que me odian eligieron la muerte.'"
}`)
	CurrentBook.AddChapter(9, `{
"1":"La sabiduría construyó su casa, levantó sus siete columnas."
,"2":"Mató a sus animales y preparó sus vinos, ya había puesto su mesa."
,"3":"Ordenó pregonar por medio de sus sirvientes, desde las alturas de la ciudad alta:"
,"4":"¡Dense una vuelta por aquí, ustedes que no saben!',A los que no piensan en nada les dice:"
,"5":"'¡Vengan a comer mi pan,y a beber mi vino que he preparado!'"
,"6":"'¡Dejen a un lado su locura y vivirán, anden por los caminos de la verdad!'"
,"7":"El que le llama la atención a un burlón se atrae sus insultos; el que corrige a un malvado corre el riesgo de que lo humillen."
,"8":"No reprendas al burlón, te ganarías un enemigo más; corrige al sabio, y te amará."
,"9":"Dale al sabio y será más sabio; instruye a un hombre bueno y sabrá más."
,"10":"El temor de Yavé es el principio de la sabiduría; conocer Al, que es Santo, eso es inteligencia."
,"11":"Así es como prolongarás tus días y se te añadirán años de vida."
,"12":"Si eres sabio, la sabiduría trabajará para ti; si eres un burlón, sólo tú pagarás las consecuencias."
,"13":"La señora Locura es nerviosa, tonta e ignorante."
,"14":"Se sienta a la puerta de su casa, en un trono, en lo alto de la ciudad."
,"15":"Desde allí interpela a los viajeros que van por su camino:"
,"16":"'¡Dénse una vuelta por aquí, ustedes que nada saben!' A los que no piensan en nada les dice:"
,"17":"'¡El agua que se roba es más dulce, el pan que se come a escondidas es mucho más sabroso!'"
,"18":"Pero el auditor no sabe que por allí andan rondando los muertos, los que ella invita descienden a los infiernos."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Proverbios de Salomón. Un hijo sabio es la alegría de su padre; un hijo insensato es la amargura de su madre."
,"2":"Los tesoros mal adquiridos no se aprovechan; una vida honrada, en cambio, libra de la muerte."
,"3":"Yavé no quiere que el justo padezca de hambre, pero deja a los malvados insatisfechos."
,"4":"La mano perezosa atrae la pobreza; la mano diligente se enriquece."
,"5":"El hombre prevenido cosecha cuando es verano; pero es muy tonto el que duerme durante la cosecha."
,"6":"Las bendiciones descenderán sobre la cabeza del justo, pero los gritos de los malvados quedarán ahogados."
,"7":"La memoria del justo será bendecida, pero el nombre de los malvados se pudrirá."
,"8":"El hombre de corazón sabio acepta los consejos, mientras que el pretencioso corre a su perdición."
,"9":"El que camina con integridad va seguro, pero el que toma caminos equivocados pronto será desenmascarado."
,"10":"Un guiño de ojo te acarrea problemas, un reproche restablecerá la paz."
,"11":"La boca del hombre bueno es un manantial de vida, la de los malvados disimula la violencia."
,"12":"El odio suscita las peleas, el amor perdona cualquier falta."
,"13":"En los labios del hombre inteligente sólo hay sabiduría, la espalda del insensato merece palos."
,"14":"Los sabios atesoran el saber, la boca del tonto derrama la desgracia."
,"15":"La fortuna del rico le sirve de defensa, la pobreza del indigente provoca su desgracia."
,"16":"Los trabajos del hombre honrado son sustento para su vida; las ganancias del malvado serán su ruina."
,"17":"Respetar las advertencias es caminar a la vida, no hacer caso de la corrección es perder su camino."
,"18":"El que disimula su odio es un farsante, el que difunde la calumnia es un insensato."
,"19":"En el mucho hablar no faltará el pecado, el que refrena sus labios es prudente."
,"20":"El justo habla: es plata fina; los pensamientos del malvado: nada valen."
,"21":"Muchos se alimentan de las palabras del justo, mientras que los insensatos mueren por su propia estupidez."
,"22":"Lo que enriquece es la bendición de Yavé; tus esfuerzos no le añaden nada."
,"23":"Al insensato le gusta meditar el mal, y al hombre prudente, cultivar la sabiduría."
,"24":"Lo que el malvado temía le sucede; lo que el justo deseaba se le concede."
,"25":"Pasada la tormenta, el malo ha desaparecido, pero el justo permanece para siempre."
,"26":"Vinagre para los dientes, humo en los ojos, eso es el flojo para su patrón."
,"27":"El temor de Yavé te prolongará tus días; los años del malvado serán acortados."
,"28":"Después de haber esperado, el justo experimentará la alegría, pero la espera de los malvados será en vano."
,"29":"Yavé previó un refugio para el hombre íntegro, y la ruina para los que hacen el mal."
,"30":"El justo puede perturbarse pero no para siempre, los malos en cambio no ocuparán la tierra."
,"31":"La sabiduría sale de la boca de los justos; la lengua mentirosa será arrancada."
,"32":"La bondad se hospeda en los labios del justo, y la corrupción, en la boca de los malvados."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Yavé odia la balanza falsa, le agrada el peso justo."
,"2":"Hoy la arrogancia, mañana la vergüenza: la sabiduría vive con los modestos."
,"3":"La integridad guía a los hombres rectos; la perversidad lleva a los impíos a su perdición."
,"4":"En el día de la cólera, la riqueza no servirá de nada, pero la honradez librará de la muerte."
,"5":"La honradez les abre un camino recto a los hombres íntegros; los malvados se pierden en el de su maldad."
,"6":"Los hombres buenos se salvan debido a su justicia, pero los impíos son presa de su propia ambición."
,"7":"Cuando al malvado le llega la muerte, se acaba su esperanza; sus riquezas ya no lo amparan."
,"8":"El justo se verá libre del peligro, en su lugar caerá el malvado."
,"9":"Cuando el impío habla, trata de destruir a su prójimo; la sabiduría de los justos les permite liberarse de ello."
,"10":"Cuando les va bien a los justos la ciudad se alegra, cuando los malvados pierden, hay fiesta."
,"11":"La ciudad prosperará mientras los justos la bendigan; su ruina se deberá a las intrigas de los malvados."
,"12":"El hombre sin corazón denigra a su prójimo, el hombre prudente guarda silencio."
,"13":"El cuentista revela los secretos; el que merece confianza guarda el secreto."
,"14":"Cuando no hay dirección, el pueblo va a la deriva, la salvación depende del número de los consejeros."
,"15":"El que sirve de aval a un extranjero se arriesga mucho; el que se abstiene de eso estará seguro."
,"16":"Una mujer amable se forma una buena reputación, los hombres enérgicos consiguen una fortuna."
,"17":"El que es generoso se hace bien a sí mismo, el que es duro hiere su propia carne."
,"18":"El salario del malvado es engañoso; el que siembra el bien tiene su recompensa asegurada."
,"19":"La vida honrada lleva a la vida, el que eligió el mal camina a la muerte."
,"20":"Yavé aborrece al hombre corrompido, los que permanecen íntegros obtienen su favor."
,"21":"El malvado nunca quedará sin castigo, pero la descendencia de los justos será salvada."
,"22":"Una mujer bonita carente de buen criterio es como un anillo de oro en el hocico de un cerdo."
,"23":"Los justos no desean sino el bien, los malos también tienen sus esperanzas, pero van al fracaso."
,"24":"Uno reparte abundantemente y se enriquece, otro economiza y se empobrece."
,"25":"El que es generoso será saciado, el que riega será regado."
,"26":"El pueblo maldice al que acapara el trigo; bendice al que vende su grano."
,"27":"El que trata de hacer el bien será bendito, si alguien persigue el mal, el mal lo alcanzará."
,"28":"El que confía en sus riquezas caerá, mientras que los justos verán cómo crece su follage."
,"29":"El que no sabe ordenar su casa cosechará sólo el viento, el tonto terminará sirviendo al sabio."
,"30":"El fruto del justo es un árbol de vida, los malvados serán arrancados antes de tiempo."
,"31":"El justo recibe lo que merece en esta tierra, y más todavía el malvado y el pecador."
}`)
	CurrentBook.AddChapter(12, `{
"1":"El que acepta que lo corrijan ama el saber; el que aborrece la reprensión es un tonto."
,"2":"Yavé favorece al que es bueno, pero condena al hombre con dobles intenciones."
,"3":"El que hace el mal no está nunca seguro; el justo, en cambio, está bien arraigado."
,"4":"Una mujer valiente es el orgullo de su marido; la que no sabe tener vergüenza es un cáncer en los huesos."
,"5":"Los justos tratan de hacer el bien, los proyectos de los malos no son más que engaño."
,"6":"Son trampas las palabras de los malvados, pero los hombres rectos tienen la respuesta para escapar."
,"7":"Los malvados se tambalean, desaparecen, pero la casa de los justos permanece de pie."
,"8":"Se aprecia a cada cual según su buen criterio, el que habla con doblez será despreciado."
,"9":"Más vale no tener títulos pero tener un servidor, que dárselas de grande y que le falte el pan."
,"10":"El justo tiene atenciones hasta con sus animales; el malvado, en cambio, no tiene entrañas."
,"11":"El que cultiva su campo tendrá pan; carece de buen tino el que persigue ilusiones."
,"12":"Las ambiciones del malo le acarrean desgracias; el justo, en cambio, es un árbol que fructifica."
,"13":"El malvado queda atrapado en sus propias artimañas, el justo se libra de cualquier problema."
,"14":"Al que sabe hablar no le faltará el pan, el que trabaja con sus manos será recompensado."
,"15":"El tonto está seguro de sus decisiones, pero el sabio atiende a los consejos."
,"16":"El tonto manifiesta su disgusto al instante, el hombre juicioso no da muestras de la afrenta."
,"17":"El hombre honrado expondrá la verdad, el testigo falso lo embrollará todo."
,"18":"Las palabras desconsideradas hieren como una espada, la palabra de un sabio será el remedio."
,"19":"La palabra verdadera se instala para siempre, lo que es falso dura sólo un momento."
,"20":"El embuste se aloja en el corazón de los intrigantes, la alegría, en el del buen consejero."
,"21":"La desgracia no desanimará al justo, mientras que los malos serán colmados de males."
,"22":"Yavé detesta los labios mentirosos, pero favorece a los que pronuncian la verdad."
,"23":"El hombre prudente no dice todo lo que sabe, los tontos se dan prisa en manifestar sus estupideces."
,"24":"La mano que trabaja será quien tome las riendas, y los trabajos duros serán para el perezoso."
,"25":"Una pena profunda debilita las energías, una buena noticia devuelve la alegría."
,"26":"El justo sabrá guiar a su prójimo, mientras que los malvados se desviarán de su camino."
,"27":"Para el flojo no hay asado de caza; ser activo, es el secreto de la riqueza."
,"28":"La vida se halla en el camino recto, el camino tortuoso conduce a la muerte."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Un hijo sabio atiende los consejos de su padre, el burlón no toma en cuenta los reproches."
,"2":"Cada cual comerá del fruto de sus obras: la felicidad será para el justo, la violencia para el impío."
,"3":"El que vigila sus palabras tendrá larga vida, el que habla sin parar, se perjudicará."
,"4":"Si uno se queda en el deseo, no pasa nada: son los activos los que engordan."
,"5":"El hombre bueno siente horror por la mentira, el malvado tira mugre y calumnia."
,"6":"La rectitud protege al hombre recto, la maldad lleva al malvado a su perdición."
,"7":"Uno aparenta ser rico pero nada tiene; otro, ser pobre, y tiene grandes bienes."
,"8":"El rico paga el rescate que lo salva, pero el pobre no se siente amenazado."
,"9":"La luz de los justos brilla, mientras que la lámpara de los malos se apaga."
,"10":"La arrogancia sólo produce peleas, la sabiduría está en escuchar."
,"11":"La fortuna que se adquiere de repente no dura, el que la administra a su ritmo la aumenta."
,"12":"La esperanza diferida desanima, el deseo satisfecho es un árbol de vida."
,"13":"El que menosprecia las advertencias saldrá perdiendo, el que observa los mandamientos será recompensado."
,"14":"La enseñanza del sabio es fuente de vida, permite escapar de los lazos de la muerte."
,"15":"El que actúa con sensatez será apreciado, el camino de los traidores no lleva a ninguna parte."
,"16":"El hombre prudente actúa a sabiendas, el tonto demuestra al instante su locura."
,"17":"Un mensajero mentiroso prepara una desgracia, un mensajero fiel da la ayuda."
,"18":"Miseria y vergüenza para el que rechaza los consejos, el que hace caso a la reprensión será estimado."
,"19":"Es agradable tener lo que uno desea; los tontos no renunciarán al mal."
,"20":"El que anda con sabios se hace sabio, el que frecuenta a los insensatos se pervierte."
,"21":"La mala suerte persigue a los pecadores, la felicidad vendrá a recompensar a los justos."
,"22":"Los buenos dejan a sus hijos y nietos su herencia; la fortuna de los pecadores está reservada al justo."
,"23":"El campo que trabaja el pobre lo alimenta, mientras otros perecen por falta de justicia."
,"24":"No usar el chicote es no amar al hijo: el que lo ama no demora en corregirlo."
,"25":"El justo come y calma su apetito, el estómago de los malos grita de hambre."
}`)
	CurrentBook.AddChapter(14, `{
"1":"La sabiduría construye la casa, la estupidez la destruye con sus propias manos."
,"2":"El que teme a Yavé toma el recto camino, el que lo desprecia se aleja de él."
,"3":"Las palabras del insensato le traen la reprensión, lo que dice el sabio trabaja por él."
,"4":"Sin bueyes los graneros quedarán vacíos; los ingresos dependen de la fuerza de los animales."
,"5":"Un testigo digno de fe dice la verdad; un testigo falso miente tanto como respira."
,"6":"El burlón busca la sabiduría, pero en vano; el hombre reflexivo aprende rápido."
,"7":"Apártate del tonto; no recibirás de su boca la sabiduría."
,"8":"La sabiduría del hombre hábil consiste en saber a dónde va; la necedad de los tontos los extravía."
,"9":"Los tontos se burlan del pecado, pero Dios favorece a los hombres buenos."
,"10":"El corazón conoce su propia pena, y su alegría nadie podrá compartirla."
,"11":"La casa de los malvados será destruida, pero la tienda de los justos no se moverá."
,"12":"A algunos su camino les parece recto, pero al final del camino está la muerte."
,"13":"Aun en medio de la risa el corazón tiene sus penas, la alegría acaba en tristeza."
,"14":"El descarriado se saciará con el fruto de su conducta, y lo mismo el hombre de bien."
,"15":"El simple cree todo lo que se dice, pero el prudente mira dónde pone los pies."
,"16":"El sabio teme el mal y se aparte de él, el tonto sigue adelante sin preocuparse."
,"17":"El colérico comete disparates, el hombre reflexivo lo soporta todo."
,"18":"Los ingenuos sólo adquieren la estupidez, los hábiles podrán estar orgullosos de su saber."
,"19":"Los malos se inclinarán ante los buenos, los pecadores esperarán junto a la puerta del justo."
,"20":"El pobre le causa fastidio a su mismo vecino, mientras que el rico tiene muchos amigos."
,"21":"El que desprecia a su prójimo comete un pecado; feliz el que tiene piedad de los desgraciados."
,"22":"¿No han perdido su camino los que maquinan el mal? ¿Acaso no se topará con la bondad y la fidelidad el que busca el bien?"
,"23":"Todo trabajo tiene su recompensa, pero lo que se queda en palabras lleva a la miseria."
,"24":"La riqueza será la corona de los sabios, y el tonto se quedará con su estupidez."
,"25":"Un testigo veraz salva vidas, el marrullero profiere mentiras."
,"26":"El que teme a Yavé tiene un apoyo firme, sus hijos podrán confiar en él."
,"27":"El temor de Yavé es fuente de vida, a uno lo libra de los lazos de la muerte."
,"28":"Un pueblo numeroso es la gloria de su rey; cuando faltan los súbditos es la ruina del soberano."
,"29":"El que demora en enojarse da muestra de inteligencia, el que no se domina manifiesta su locura."
,"30":"La paz del corazón fomenta la salud, pero la envidia corroe los huesos."
,"31":"El que oprime al pobre insulta a su Creador, el que tiene piedad de los indigentes le rinde homenaje."
,"32":"Al malvado lo derriba su propia malicia; el justo está seguro hasta en la muerte."
,"33":"La sabiduría habita en los hombres de buen criterio, la estupidez se encuentra entre los insensatos."
,"34":"Una nación crece por la justicia; el pecado es la vergüenza de los pueblos."
,"35":"El servidor inteligente será apreciado por el rey, pero el incapaz se hace acreedor a su cólera."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Una respuesta amable calma la furia, una palabra hiriente hace que aumente la cólera."
,"2":"Las palabras de los sabios difunden el saber, mientras que la boca de los tontos desborda de locura."
,"3":"Los ojos de Yavé están en cualquier lugar, observan a los malos y a los buenos."
,"4":"Las palabras que apaciguan son un árbol de vida; la lengua perversa rompe las energías."
,"5":"El tonto menosprecia la corrección de su padre, el sensato toma en cuenta las advertencias."
,"6":"Hay muchas riquezas en la casa del justo, y muchos problemas con las ganancias del malo."
,"7":"Las palabras de los sabios propagan el saber, pero no está en el corazón de los tontos."
,"8":"Yavé aborrece el sacrificio de los malvados, pero acoge con alegría la oración de los justos."
,"9":"Yavé detesta a los que se portan mal, pero ama al que busca el bien."
,"10":"Un severo castigo aguarda al que se sale del camino; si no quiere corregirse, morirá."
,"11":"El mundo infernal y la muerte están a la vista de Yavé, ¡cuánto más el corazón de los hombres!"
,"12":"Al burlón no le gusta que lo reprendan, por eso evita la compañía de los sabios."
,"13":"Corazón contento, rostro radiante; corazón triste, espíritu abatido."
,"14":"El inteligente anda en busca del saber, la boca de los tontos repite sus necedades."
,"15":"Para el infeliz todos los días son malos, el que tiene alegre el corazón está siempre de fiesta."
,"16":"Más vale tener poco y temer a Yavé, que guardar tesoros y no tener paz."
,"17":"Es mejor un plato de legumbres con cariño que un buey gordo con discordia."
,"18":"El hombre arrebatado arma peleas, el que demora en enojarse trae la calma."
,"19":"El camino del flojo está jalonado de zarzas, el sendero de los trabajadores es como una carretera."
,"20":"Un hijo sabio será la alegría de su padre, el tonto será la vergüenza de su madre."
,"21":"El loco se entretiene en su tontería; el hombre inteligente sigue derecho su camino."
,"22":"Los proyectos carentes de reflexión fracasan; tendrán éxito si han sido bien madurados."
,"23":"¡Feliz el que tiene la respuesta acertada! Nada mejor que una respuesta oportuna."
,"24":"El camino que sube, el de la vida, es para el hombre sensato; éste evitará el que baja a la morada de los muertos."
,"25":"Yavé derriba la casa de los orgullosos, pero protege el cercado de la viuda."
,"26":"Yavé odia los proyectos perversos, la pureza que él espera son las palabras benevolentes."
,"27":"El que corre tras el dinero desarma su casa, el que no se deja comprar vivirá."
,"28":"El hombre recto reflexiona antes de responder, la maldad sale por sí sola de la boca de los malos."
,"29":"Yavé se mantiene alejado de los malos, pero atiende a la oración de los justos."
,"30":"Una mirada benevolente alegra el corazón, una buena noticia reanima las fuerzas."
,"31":"El que pone atención en los consejos saludables tendrá su lugar entre los sabios."
,"32":"El que desprecia la corrección se perjudica a sí mismo, el que escucha los consejos forma su conciencia."
,"33":"El temor de Yavé es la escuela de la sabiduría; antes de la gloria es necesaria la humildad."
}`)
	CurrentBook.AddChapter(16, `{
"1":"El hombre propone, pero Yavé dispone."
,"2":"Cada cual justifica sus decisiones, pero Yavé sopesa los espíritus."
,"3":"Encomienda tus obras a Yavé, y tus proyectos se realizarán."
,"4":"Yavé hizo todo con un propósito, y al mismo malvado, para el día del castigo."
,"5":"Yavé detesta el corazón altanero: no podrá quedar sin castigo."
,"6":"Con la bondad y la fidelidad uno repara sus faltas, pero con el temor de Yavé se aleja del mal."
,"7":"Si Yavé aprecia tu conducta, hará que tus mismos enemigos se reconcilien contigo."
,"8":"Más vale tener poco y ser honrado, que ganar mucho en forma indebida."
,"9":"Cada uno decide dentro de sí su camino, pero Yavé asegura sus pasos."
,"10":"El rey habló: ¡es un oráculo! No se equivoca cuando tiene que juzgar."
,"11":"Yavé pide balanza y platillos justos; a él se le rinden cuentas por el juego de pesas."
,"12":"Los reyes detestan hacer el mal: saben que su trono se basa en la justicia."
,"13":"El que manda con justicia es apreciado por el rey; él ama a los hombres rectos."
,"14":"¡El enojo del rey es peligro de muerte! Pero un hombre sabio puede apaciguarlo."
,"15":"¡Si se ilumina el rostro del rey es señal de vida! Su benevolencia es como lluvia de primavera."
,"16":"Adquiere la sabiduría más bien que el oro; prefiere el buen juicio al dinero."
,"17":"El camino de los hombres buenos los aleja del mal; el que mira por dónde va seguirá vivo."
,"18":"Antes de la ruina hubo orgullo; la arrogancia precede a la caída."
,"19":"Más vale permanecer humilde con los de abajo que repartirse los despojos con los orgullosos."
,"20":"El que reflexiona en los hechos tendrá éxito; ¡feliz el que confía en Yavé!"
,"21":"El que tiene la sabiduría es el verdadero inteligente: las palabras acertadas atraen la adhesión."
,"22":"El buen criterio es fuente de vida para el que lo posee, la estupidez de los tontos será su castigo."
,"23":"La sabiduría que tienes adentro le da sentido a tu discurso: tus palabras producirán un impacto."
,"24":"Las conversaciones benévolas son como un panal de miel: agradables al paladar, buenas para la salud."
,"25":"A veces nuestro camino nos parece recto, pero lleva inexorablemente a la muerte."
,"26":"La necesidad del trabajador trabaja para él, su boca tiene exigencias y lo presiona."
,"27":"El pillo trama el mal; lo que sale de su boca es un fuego devorador."
,"28":"El hombre perverso provoca las disputas, y el que anda con cuentos divide a los amigos."
,"29":"El que quiere abusar de su prójimo comienza por seducirlo, y lo lleva por un camino que no es bueno."
,"30":"El que mira de soslayo trama alguna picardía: frunce los labios, ya cometió el pecado."
,"31":"Los cabellos blancos son una corona respetable: está al fin del camino de la justicia."
,"32":"El que demora en encolerizarse vale más que un héroe; el que sabe dominarse es más que el conquistador de una ciudad."
,"33":"Se tira al cara o sello en la palma de la mano, ¡pero la decisión viene de Yavé!"
}`)
	CurrentBook.AddChapter(17, `{
"1":"Más vale un trozo de pan seco en paz que una casa bien abastecida donde hay peleas."
,"2":"Un servidor astuto le ganará al hijo indigno; compartirá la herencia junto con los hijos."
,"3":"Hay crisol para la plata, y horno para el oro; Yavé es el que sondea los corazones."
,"4":"El malvado escucha al mal consejero, el mentiroso le presta atención al que deforma."
,"5":"El que se burla de los pobres insulta a su Creador; el que se alegra de la desgracia ajena no quedará sin castigo."
,"6":"Los nietos son la corona de los ancianos, así como los padres son el orgullo de sus hijos."
,"7":"Un lenguaje noble no le cae bien a un tonto, y menos aún la mentira a un príncipe."
,"8":"La gratificación, varita mágica para el que la usa, da resultados dondequiera que uno vaya."
,"9":"Si se perdona una falta, se refuerza la amistad; si uno la da a conocer, perderá a su amigo."
,"10":"Una amonestación tiene más efecto sobre un hombre inteligente que cien bastonazos sobre un tonto."
,"11":"El malvado sólo piensa en rebelarse, pero se le mandará un ángel de infortunio."
,"12":"Es mejor toparse con una osa privada de sus crías que con un tonto en su delirio."
,"13":"Si uno devuelve mal por bien, la desgracia no se apartará de su casa."
,"14":"Entablar un juicio es como abrir una represa; desístete antes que se dé curso a la demanda."
,"15":"Absolver al culpable, condenar al inocente: ambas cosas son igualmente odiosas para Yavé."
,"16":"¿De qué sirve el dinero en manos de un tonto? Como es tonto no comprará la sabiduría."
,"17":"Un amigo te querrá en todo momento: te ha nacido un hermano en previsión de días malos."
,"18":"Hay que ser bien ingenuo para servir de aval a otro y comprometerse en vez del otro."
,"19":"Amar la discusión es buscar los golpes, el que toma un tono arrogante busca su propia desgracia."
,"20":"El que actúa con doblez no hallará la felicidad; las malas lenguas caerán en desgracia."
,"21":"El que echa un tonto al mundo le pesará; el padre del insensato no tendrá de qué alegrarse."
,"22":"El buen humor hace bien al organismo; si el espíritu está triste los nervios se deprimen."
,"23":"El malvado acepta regalos bajo cuerda para torcer la justicia."
,"24":"El hombre inteligente tiene los ojos fijos en la sabiduría, las miradas del tonto vagabundean por los cuatro rincones del mundo."
,"25":"Un hijo insensato es la amargura de su padre, y la tristeza de la que lo dio a luz."
,"26":"No es nada bueno castigar a un inocente; golpear a personas honorables no se puede justificar."
,"27":"El hombre con experiencia no habla demasiado, el inteligente se toma su tiempo antes de hablar."
,"28":"Hasta un tonto pasaría por sabio si supiese callarse; mientras cierre la boca es inteligente."
}`)
	CurrentBook.AddChapter(18, `{
"1":"El egoísta no busca sino lo suyo; se irrita ante cualquier consejo."
,"2":"Al tonto no le gusta reflexionar, sino dar a conocer sus opiniones."
,"3":"La maldad atrae el desprecio, un comportamiento vergonzoso atrae las críticas."
,"4":"La palabra humana es un agua profunda, un manantial surgente, una fuente de vida."
,"5":"No está bien eximir de culpa al malvado y condenar al que está en su derecho."
,"6":"Las reflexiones del tonto provocan las peleas; cuando habla, siembra la confusión."
,"7":"El tonto habla y se perjudica a sí mismo: se prepara una trampa."
,"8":"Las palabras del mendigo son como golosinas; se deslizan suavemente hasta el fondo de las entrañas."
,"9":"El que flojea en su trabajo es hermano del que demuele."
,"10":"El nombre de Yavé es una fortaleza; allí acude el justo y encuentra seguridad."
,"11":"La fortuna del rico es su ciudad fortificada; le parece una fortaleza inconquistable."
,"12":"La arrogancia del hombre viene antes que su ruina, la humildad precede a la gloria."
,"13":"El que responde antes de haber escuchado pasa por un estúpido y queda en ridículo."
,"14":"Lo que mantiene al hombre en su enfermedad es su espíritu; pero ¿cómo levantar a un espíritu deprimido?"
,"15":"Un espíritu abierto adquiere conocimientos; el oído del sabio está atento al saber."
,"16":"Un regalo abre las puertas; es la manera de introducirse ante los grandes."
,"17":"Se da razón al primero que habla; aparece su contrario y hay que revisarlo todo."
,"18":"Tirando al cara o sello podrían resolverse muchas querellas, y hasta zanjar pleitos entre los poderosos."
,"19":"Hermanos que se ayudan son como una fortaleza, y los amigos, como los cerrojos de una torre."
,"20":"De todo lo que has dicho te llenarás el estómago; comerás hasta saciarte de lo que ha salido de tus labios."
,"21":"La lengua puede dar vida y muerte; según como la uses, así serán sus frutos."
,"22":"El que encontró una esposa encontró la felicidad; Yavé es quien le otorgó ese favor."
,"23":"El mendigo habla en tono de súplica, y el rico le responde con dureza."
,"24":"Hay amigos que llevan a la ruina, pero otros que son más fieles que un hermano."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Más vale el pobre que vive honradamente que el sinvergüenza que ha sabido escalar posiciones."
,"2":"De nada vale el entusiasmo si no hay reflexión; el que precipita sus pasos se pierde."
,"3":"Uno se arruina por su propia estupidez, ¡y luego le echa la culpa a Yavé!"
,"4":"La fortuna multiplica los amigos, mientras que el desafortunado pierde los suyos."
,"5":"El testigo falso no quedará sin castigo, el que propaga calumnias no se escapará."
,"6":"Un noble tiene muchos aduladores, todos son amigos del que hace regalos."
,"7":"Al pobre lo rechazan todos sus hermanos, con mayor razón sus amigos. ¿Con quién hablar? Nadie se presenta."
,"8":"El que adquiere buen juicio se hace bien a sí mismo; el que actúa con inteligencia será feliz."
,"9":"El testigo falso no quedará sin castigo, el que miente cuando atestigua perecerá."
,"10":"No conviene que un tonto viva en el lujo, y menos aún que un esclavo mande a los príncipes."
,"11":"Un hombre inteligente domina su enojo; al no hacerle caso a la ofensa se agranda."
,"12":"El furor del rey es como el rugido del león, su benevolencia es como el rocío sobre la hierba."
,"13":"Un hijo sin juicio es la desdicha de su padre; chillidos de mujer son como una gotera que no termina."
,"14":"Casa y bienes son herencia paterna, pero Yavé es quien da una esposa juiciosa."
,"15":"La pereza produce sueño; el flojo tendrá hambre."
,"16":"El que guarda el mandamiento se guarda a sí mismo; el que desprecia la palabra morirá."
,"17":"El que tiene compasión del pobre le presta a Yavé: éste sabrá pagar su deuda."
,"18":"Corrige a tu hijo mientras haya esperanza; sino tú serás responsable de su muerte."
,"19":"El que se ha enojado debe pagar; si se le perdona, volverá a hacerlo."
,"20":"Atiende a los consejos, acepta la enseñanza, al final serás un sabio."
,"21":"El hombre forja muchos proyectos, pero se realizará lo que Yavé decidió."
,"22":"El hombre atrae por su bondad, se prefiere un pobre a un arrogante."
,"23":"El temor de Yavé te dará vida: dormirás tranquilo, inmune a la desgracia."
,"24":"El flojo mete la mano en el plato, y luego no la lleva a la boca."
,"25":"Castiga al burlón y el simple pondrá atención; reprende al hombre sensato y entenderá."
,"26":"El que deja sin nada a su padre y echa a su madre es un hijo infame y desnaturalizado."
,"27":"El hijo que no hace más caso de los que lo reprenden, sólo puede rumiar malos pensamientos."
,"28":"Un testigo perverso se burla de la justicia; la boca de los malvados se entretiene con la injusticia."
,"29":"El látigo es para los que se burlan, el palo fue hecho para la espalda de los tontos."
}`)
	CurrentBook.AddChapter(20, `{
"1":"El vino lo pone a uno sarcástico, el alcohol excita: el que se da a ellos no será un sabio."
,"2":"La cólera del rey es como el rugido del león; el que la provoca arriesga su vida."
,"3":"Poner fin a las querellas engrandece al hombre; el que no se domina es un tonto."
,"4":"El flojo no trabajó en el otoño; ¡cuando llegue el verano buscará, pero nada!"
,"5":"Aguas profundas son los proyectos del corazón; los inteligentes sacan de allí."
,"6":"De mucha gente se dice que son buenos, pero ¿quién hallará a un hombre fiel?"
,"7":"El justo que lleva una vida irreprochable; ¡felices sus hijos después de él!"
,"8":"En cuanto se sienta el rey en su tribunal, le salta a la vista todo lo malo."
,"9":"¿Quién puede decir: mi corazón es puro, estoy limpio de todo pecado?"
,"10":"¡Peso doble y medida doble: dos cosas que aborrece Yavé!"
,"11":"Por sus actos demuestra el muchacho si su vida será justa y honrada."
,"12":"Al oído que oye, al ojo que ve, a ambos los hizo Yavé."
,"13":"No te acostumbres a dormitar, vendría la pobreza; ten abiertos los ojos y tendrás pan."
,"14":"'¡Mal negocio, mal negocio!' dice el comprador, pero se va contento."
,"15":"Hay oro, hay muchas perlas, pero lo más precioso es el saber."
,"16":"¡Quítale su ropa ya que sirvió de aval a otro; ponlo en prisión en lugar de un extraño!"
,"17":"El pan prohibido es sabroso, pero te deja la boca llena de arena."
,"18":"Los proyectos toman cuerpo si ha habido reflexión; calcula bien cuando hagas la guerra."
,"19":"El que habla demasiado traiciona los secretos: ¡desconfía del charlatán!"
,"20":"¿Ha maldecido a su padre y a su madre? Su lámpara se apagará en el lugar más oscuro."
,"21":"Fortuna adquirida en pocos días no prosperará después."
,"22":"No digas: '¡Me vengaré!', confía en Yavé para resarcirte."
,"23":"Un peso para comprar, otro para vender: ¡Yavé los aborrece! No se debe falsear la balanza."
,"24":"Yavé dirige los pasos del hombre; ¿quién sabe a dónde lo conduce su camino?"
,"25":"Cuídate de prometer en forma apresurada: '¡Esto es para Yavé!' y de ponerte después a reflexionar."
,"26":"Un rey sabio pasa a los malos por el cedazo, les hace sentir el peso de su justicia."
,"27":"El espíritu en nosotros es la lámpara de Yavé: escudriña los rincones de nuestro interior."
,"28":"La fidelidad y la lealtad conservan al rey; la benevolencia afirma su poder."
,"29":"La fuerza es el orgullo de los jóvenes, los cabellos blancos son el honor de los ancianos."
,"30":"La herida que sangra evita la infección; los golpes curan el mal interior."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Los pensamientos del rey, igual que el agua, corren por donde Yavé los dirige."
,"2":"Cada uno considera buenos los caminos que ha tomado, pero Yavé pesa los corazones."
,"3":"Practicar la justicia y el derecho vale más ante Yavé que los sacrificios."
,"4":"Ojos despreciativos, corazón altanero: lo que en los malos reluce es sólo pecado."
,"5":"Los proyectos del empeñoso acaban en ganancias; para el que se agita sólo hay déficits."
,"6":"Amontonar con estafas un tesoro es la breve ilusión de los que van a la muerte."
,"7":"Su violencia arrebatará a los malvados, porque se niegan a practicar la justicia."
,"8":"El criminal sigue caminos torcidos; rectas son las acciones del hombre íntegro."
,"9":"Más vale vivir en un rincón del granero que compartir su casa con una mujer peleadora."
,"10":"El malvado sólo desea el mal, nadie le cae bien."
,"11":"Castiga al burlón y el simple se hará sabio, instruye al sabio, y le aprovechará la lección."
,"12":"El justo vigila la casa del malvado, precipita a los malos en la ruina."
,"13":"El que pone oídos sordos al grito del afligido, cuando llame no le responderán."
,"14":"Un regalo en secreto apacigua la ira, un presente distrae el furor violento."
,"15":"Cuando reina la justicia, el justo se alegra; pero es la ruina de los malhechores."
,"16":"El que se aparta del camino de la prudencia, pronto descansará entre los muertos."
,"17":"El que ama el placer terminará en la pobreza, nadie se enriquece corriendo tras el vino y los perfumes."
,"18":"El malo pagará por el justo; el traidor será castigado, no el hombre bueno."
,"19":"Más vale vivir en un rincón solitario que con una mujer peleadora y desagradable."
,"20":"El sabio tiene en su casa aceite y provisiones, el tonto sólo sabe gastarlas."
,"21":"El que procura la justicia y la bondad encontrará vida, bienestar y consideración."
,"22":"El sabio se apodera de una ciudad bien protegida, derribando las murallas que la aseguraban."
,"23":"El que pone un guardia a su boca y a su lengua, se libra de muchos tormentos."
,"24":"Es arrogante e insolente: '¡Me río de todo!' Sus actos son un desborde de su orgullo."
,"25":"Los deseos del flojo sólo pueden matarlo, porque sus manos se niegan a trabajar."
,"26":"El impío ambiciona todo el día, mientras que el justo da sin medida."
,"27":"Yavé siente horror por el sacrificio de los malvados, sobre todo si ofrecen con una mala intención."
,"28":"El testigo falso quedará en vergüenza; el hombre que sabe escuchar tendrá la última palabra."
,"29":"El malvado aparenta seguridad, el hombre honrado da pasos seguros."
,"30":"Ante Yavé no hay sabiduría, inteligencia o prudencia que valgan."
,"31":"Se equipa al caballo para el día del combate, pero la victoria depende de Yavé."
}`)
	CurrentBook.AddChapter(22, `{
"1":"¡Un nombre respetado es mejor que grandes riquezas; ser estimado es mejor que el oro y la plata!"
,"2":"El rico y el pobre tienen esto en común, que Yavé hizo a uno y a otro."
,"3":"El hombre prevenido ve que viene la desgracia y se pone a resguardo; los tontos siguen adelante y pagan las consecuencias."
,"4":"La recompensa de la humildad es el temor de Yavé, la riqueza, el honor y la vida."
,"5":"Hay espinas y trampas en el camino del perverso; el que se aleja de él se asegura."
,"6":"Muéstrale al niño el camino que debe seguir, y se mantendrá en él aun en la vejez."
,"7":"El rico domina al pobre, el deudor está a merced de su acreedor."
,"8":"Quien siembra injusticia cosechará la desgracia, el poder de los violentos se romperá."
,"9":"El hombre compasivo será bendito: supo compartir su pan con el pobre."
,"10":"Echa al burlón y se acabará la disputa; se calmarán las peleas y las injurias."
,"11":"Yavé ama a los corazones rectos; al que procura el bien, el rey lo tomará por amigo."
,"12":"Yavé protege al que sabe de verdad, pero desenmascara los discursos perversos."
,"13":"El flojo dice: '¡Hay un león afuera, si salgo me devorará!'"
,"14":"La boca de la adúltera es una fosa profunda; hay que estar abandonado por Yavé para caer en ella."
,"15":"La despreocupación está anclada en el corazón del niño; la disciplina y la corrección lo librarán de ella."
,"16":"Si oprimen a un pobre, lo hacen progresar, si dan a un rico, lo perjudican."
,"17":"Abre tus oídos, escucha mis palabras, pon atención a mis enseñanzas."
,"18":"Te gustará conservarlas en tu memoria y tenerlas listas en tus labios cada vez que tú quieras."
,"19":"Quiero que pongas tu confianza en Yavé:"
,"20":"por eso, te he escrito estas treinta máximas, para aconsejarte y advertirte,"
,"21":"para que conozcas la verdad, y puedas responder con seguridad a quien te pregunte."
,"22":"No le quites sus cosas al pobre porque es pobre, ni condenes a un desdichado."
,"23":"Porque Yavé se pondrá de su lado y se hará el opresor de sus opresores."
,"24":"No te juntes con un hombre colérico, ni frecuentes al rabioso:"
,"25":"podrías adquirir sus modales y arriesgarías así tu vida."
,"26":"No seas de los que se comprometen a la ligera y que se ofrecen como avales para un préstamo;"
,"27":"si no tienes con qué pagar, te quitarán tu cama dejándote en el suelo."
,"28":"Deja los límites que tus padres pusieron donde han estado siempre."
,"29":"¿Ves a un hombre que sabe desenvolverse? Este entrará al servicio de los reyes, no se quedará sirviendo a gente oscura."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Si estás a la mesa con un noble, mira bien lo que hay ante ti."
,"2":"¡No seas goloso, te pondrás el cuchillo a la garganta!"
,"3":"No te abalances sobre sus buenos platos: son alimentos engañosos."
,"4":"No te canses persiguiendo la riqueza, déjate de pensar en ella;"
,"5":"apenas se la ve ya desapareció. Se pone alas e igual que un águila se pierde entre las nubes."
,"6":"No comas el pan de un hombre interesado, no codicies sus manjares delicados,"
,"7":"porque toda su actitud es calculada: '¡Come y bebe!', te dice, pero su corazón no está contigo."
,"8":"Tendrás que vomitar el bocado que hayas comido, y habrás perdido tus buenas palabras."
,"9":"No aconsejes a un tonto, despreciará aun tus palabras más sensatas."
,"10":"No cambies un límite antiguo, no te apoderes del campo de los huérfanos."
,"11":"Tienen a un poderoso defensor, Yavé mismo, quien asumirá su causa en contra tuya."
,"12":"Pon todo tu celo en instruirte, abre tus oídos a las palabras sabias."
,"13":"No vaciles en corregir a un niño: el haberlo azotado no lo hará morir."
,"14":"Debes corregirlo: así lo salvarás de la morada de los muertos."
,"15":"Hijo mío, si llegas a ser un sabio, seré el primero en alegrarme;"
,"16":"estaré feliz cuando tú estés en la verdad."
,"17":"No envidies a los pecadores sino que sigue siempre en el temor de Yavé;"
,"18":"si lo conservas, verás sus resultados, y tu esperanza no será fallida."
,"19":"Hijo mío, oye y hazte sabio, anda por el camino recto."
,"20":"No te juntes con bebedores de vino y con los que se hartan de carne;"
,"21":"porque el borracho y el glotón se empobrecen, y el holgazán irá vestido de harapos."
,"22":"Escucha a tu padre que te dio la vida; no desprecies a tu madre cuando sea viejecita."
,"23":"Compra la verdad, no la revendas; adquiere la sabiduría, la instrucción y la inteligencia."
,"24":"El padre del justo tendrá de qué alegrarse; la que dio a luz a un sabio, éste será su felicidad."
,"25":"¡Que se regocijen pues tu padre y tu madre, que estalle la alegría de la que te dio a luz!"
,"26":"Atiéndeme, hijo mío, no pierdas de vista el camino que te indico."
,"27":"Has de saber que la prostituta es una fosa profunda, la mujer adúltera es un pozo estrecho."
,"28":"Está al acecho como un bandido; ¡cuántos hombres han traicionado por culpa de ella!"
,"29":"¿De quién son los 'ayes'? ¿De quién son los lamentos? ¿De quiénes las peleas y las quejas? ¿De quiénes los golpes sin motivos y los ojos que ven doble?"
,"30":"De los que se dedican a tomar y amontonar botellas y alcohol."
,"31":"No te dejes fascinar por el vino: ¡qué rojo más hermoso, transparente en la copa, y cómo baja!"
,"32":"Acabará mordiéndote como una serpiente, te picará como una víbora."
,"33":"Ya no sabrás lo que ves y te pondrás a decir estupideces."
,"34":"Serás como un hombre en alta mar, agarrado al mástil del navío:"
,"35":"'¡Me golpearon...  pero no me dolió! ¡Me pegaron...  pero no lo sentí!"
,"36":"¿Voy a despertarme? ¡Quiero pedir más!'"
}`)
	CurrentBook.AddChapter(24, `{
"1":"No envidies a los malvados, no busques su compañía,"
,"2":"porque sólo piensan en la violencia y no hablan más que de sus fechorías."
,"3":"Gracias a la sabiduría se construye una casa, merced a la experiencia se la consolida;"
,"4":"por medio del saber sus cuartos se llenan de muchas cosas preciosas y agradables."
,"5":"El hombre sabio supera al poderoso, el hombre de experiencia vale más que el forzudo;"
,"6":"calcula bien cuando hagas la guerra, porque la victoria depende de lo que muchos han sabido pensar."
,"7":"La sabiduría no está al alcance del tonto: ¡que se calle en la asamblea!"
,"8":"Al que trama la maldad, lo llaman hacedor de intrigas;"
,"9":"el tonto, por su parte, se dedica a cometer el pecado, y el burlón, a hacerse odiar por todos."
,"10":"Si te desanimas cuando algo anda mal, tu fuerza no es gran cosa."
,"11":"¡Libra a los sentenciados a muerte, salva a los que son arrastrados al suplicio!"
,"12":"Tu dirás después: '¡No lo sabíamos!' Pero el que pesa los corazones ve claro, el que te observa lo sabrá; y recompensará a cada uno según sus obras."
,"13":"Come miel, hijo mío, porque es bueno; la miel es suave al paladar."
,"14":"También la sabiduría te hará bien: si la adquieres, verás sus frutos, y tu esperanza no será defraudada."
,"15":"¡Malvado, déjate de tramar algo malo en contra de la casa del justo; no vayas a perturbar su descanso!"
,"16":"Si el justo cayó siete veces, se levantará otras tantas, mientras que los malvados caerán para seguir en su desgracia."
,"17":"No te regocijes porque cae tu enemigo, que tu corazón no se alegre porque tropezó;"
,"18":"Yavé podría molestarse y revertir su cólera sobre ti."
,"19":"No te preocupes por los que hacen el mal, no envidies a los impíos,"
,"20":"porque el mal no tiene porvenir y la lámpara de los impíos se apagará."
,"21":"¡Hijo mío, teme a Yavé y al rey, no frecuentes a los revoltosos!"
,"22":"Porque ambos pueden golpear de improviso y ¿quién sabe cómo castigarán?"
,"23":"Esto también viene de los sabios. No es bueno ser parcial en los juicios. "
,"24":"El que dice a un malvado: '¡Tienes razón!' será maldito por el pueblo, las naciones lo detestarán."
,"25":"Los que saben sancionar se encontrarán a gusto, serán colmados de bendiciones."
,"26":"Una respuesta justa vale todas las señales de afecto."
,"27":"Comienza por tu trabajo de afuera, preocúpate en primer lugar de tus campos; después de eso podrás agrandar tu casa."
,"28":"No atestigües a la ligera contra tu prójimo, ¿querrías pues mentir?"
,"29":"No digas: '¡Le haré lo que me hizo!'"
,"30":"Pasé al lado del campo del flojo, caminé alrededor de la viña de un tonto:"
,"31":"¡ortigas por todas partes, el suelo cubierto de zarzas, el muro de piedras caído!"
,"32":"Después de haberlo visto, reflexioné y saqué la lección:"
,"33":"se hace una corta siesta, se alarga el rato para cruzarse de brazos;"
,"34":"¡pero la pobreza se aproxima a ti como un merodeador, la miseria cae sobre ti como un hombre armado!"
}`)
	CurrentBook.AddChapter(25, `{
"1":"He aquí otros proverbios de Salomón que fueron transcritos por el personal de Ezequías, rey de Judá."
,"2":"Es gloria de Dios esconder las cosas, y gloria de los reyes, aclarar las cosas."
,"3":"Muy alto el cielo y muy profunda la tierra: insondable también el pensamiento de los reyes."
,"4":"Quita las escorias de la plata, el orfebre sacará de allí un vaso;"
,"5":"retira al malvado de la presencia del rey, y su trono se apoyará en la justicia."
,"6":"No te hagas el importante delante del rey, ni te ubiques en medio de los grandes;"
,"7":"más vale que te digan: '¡Sube para acá!' que verte rebajado en presencia del príncipe. Si has visto algo, "
,"8":"no acuses inmediatamente; ¿qué harás luego si tu adversario te contradice?"
,"9":"Defiende tu causa contra tu adversario, pero sin revelar los secretos de nadie,"
,"10":"cualquiera que lo supiera te lo reprocharía y tu deshonor no tendría remedio."
,"11":"Joya de oro engastada en plata, tal es la palabra que se dice oportunamente;"
,"12":"anillo de oro en un collar de zafiro, así es una sabia reprimenda para el que puede oírla."
,"13":"Frescura de nieve en un día de verano, así es el mensajero fiel para el que lo envía: ¡qué consuelo para su amo!"
,"14":"Viento y nube sin lluvia, así es el jactancioso con sus promesas ilusorias."
,"15":"Con perseverancia se puede convencer al juez; la lengua blanda rompe el hueso."
,"16":"Si has encontrado miel, cómela con moderación. No exageres, pues la vomitarás."
,"17":"No vayas demasiado a casa de tu prójimo: podría cansarse y tomarte antipatía."
,"18":"Una masa, una espada, una flecha puntiaguda, tal es el hombre que habla falsedades de su prójimo."
,"19":"Un diente cariado, un pie torcido, así es el apoyo de un hipócrita, cuando te vaya mal."
,"20":"¿Tomarías su manto en un día de invierno, derramarías vinagre en su herida? No entones una canción alegre delante de los que sufren."
,"21":"Si tu enemigo tiene hambre, dale de comer; si tiene sed, dale de beber."
,"22":"Así amontonarás brasas sobre su cabeza y Yavé te lo recompensará."
,"23":"El viento del norte produce la lluvia, y los subentendidos hipócritas, rostros enojados."
,"24":"Más vale quedarse en un rincón del granero que compartir su casa con una mujer peleadora."
,"25":"Como agua fresca para una garganta sedienta, así es una buena noticia que llega de lejos."
,"26":"Un manantial sucio, una fuente contaminada, tal es el hombre honrado que cede a la presión de un malvado."
,"27":"No conviene comer demasiada miel: ¡cuidado con los honores!"
,"28":"Una ciudad abierta, sin defensas, así es el hombre que no controla sus impulsos."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Ni nieve en verano, ni lluvia en la cosecha: tampoco convienen honores a un tonto."
,"2":"Se escapa un pajarillo, se vuela una golondrina: cuando se maldice sin motivo no pasa nada."
,"3":"¡La fusta para el caballo, las riendas para el burro, y el palo para la espalda de los imbéciles!"
,"4":"No respondas a las estupideces de un imbécil, te volverías como él."
,"5":"Responde a las estupideces de un imbécil, porque si no se va a creer un sabio."
,"6":"Es cortarse un pie, confiar sus mensajes a un imbécil: el trago será amargo."
,"7":"Como piernas inseguras de un cojo, así es la palabra sabia en boca de un tonto."
,"8":"Darle importancia a un tonto no es mejor que amarrar la piedra a la honda."
,"9":"Como una rama de espino en manos de un borracho, así es la palabra sabia en boca de un tonto."
,"10":"Si utilizas a un tonto, será como un arquero que hiere a cuantos pasan."
,"11":"El perro vuelve a su vómito, y el insensato recae en su locura."
,"12":"¿Ves a ese hombre que se tiene por sabio? Más se puede esperar de un tonto."
,"13":"El flojo dice: 'Hay un animal feroz en el camino! ¡Hay un león en la calle!'"
,"14":"La puerta da vuelta sobre sus goznes, y el flojo, sobre su lecho."
,"15":"El flojo mete la mano en el plato, pero le cansa llevarla a la boca."
,"16":"El flojo se cree más sabio que siete personas que responden bien."
,"17":"¿Meterse en las peleas de otro? ¡Es mejor agarrar por las orejas a un perro que pasa!"
,"18":"Como un loco que lanza brasas o flechas mortíferas,"
,"19":"así es el que miente a su prójimo antes de decirle: '¡Era una broma!'"
,"20":"Sin leña el fuego se apaga; sin chismoso la disputa se apacigua."
,"21":"El carbón y la leña activan el fuego, el hombre pendenciero atiza las disputas."
,"22":"Las palabras del chismoso son como golosinas; se deslizan suavemente hasta el fondo de las entrañas."
,"23":"Como un revestimiento de plata en un tiesto de barro, así son las buenas palabras de un corazón perverso."
,"24":"El que tiene odio disimula su lenguaje y esconde en él su maldad."
,"25":"Si expresa buenos sentimientos, no te fíes: siete maldades llenan su corazón."
,"26":"Aunque oculte su odio bajo modales educados, su malicia se manifestará en público."
,"27":"El que cava una fosa caerá en ella; el que hace rodar una piedra, ésta se volverá sobre él."
,"28":"El que miente odia al que ofende; lo echa abajo con palabras suaves."
}`)
	CurrentBook.AddChapter(27, `{
"1":"No te jactes del día de mañana: no sabes lo que te reserva ese día."
,"2":"Otro puede hacer tu elogio, pero no tú; otro hablará, no tú."
,"3":"La piedra es pesada y la arena cansadora para caminar; más pesados todavía son los rencores del insensato."
,"4":"La cólera es cruel, el furor tiene sus excesos, pero ¿quién puede hacer frente a la envidia?"
,"5":"Más vale una reprensión franca que rencores disimulados."
,"6":"El que te quiere te aporrea; el enemigo te abraza hipócritamente."
,"7":"La boca satisfecha rechaza la miel, a la hambrienta, lo amargo le parece dulce."
,"8":"Como un ave que vuela errante lejos de su nido, así es el hombre que anda lejos de su hogar."
,"9":"El aceite y los perfumes alegran el corazón, la dulzura de la amistad reconforta el alma."
,"10":"No renuncies a tu amigo ni al amigo de tu padre; un amigo cerca vale más que un hermano lejos."
,"11":"Hijo mío, hazte sabio y me darás alegría; así tendré que responder al que me insulta."
,"12":"El hombre cuidadoso advierte el peligro y se pone a salvo; los ingenuos siguen adelante y lo pagan."
,"13":"¡Quítale su manto porque sirvió de aval a otro, cóbrale la deuda de un extraño!"
,"14":"Si uno desea el bien a su vecino gritándole muy fuerte, a lo mejor le desea el mal."
,"15":"Gotera continua todo a lo largo de un día de lluvia, así es la mujer peleadora."
,"16":"¿Dominarla? sería como coger el viento, o tomar el aceite con la mano."
,"17":"El fierro aguza el fierro; uno se afina en contacto con el prójimo."
,"18":"El que cultiva a la higuera comerá de su fruto, el que cuida de su patrón recibirá un anticipo."
,"19":"Las caras no se parecen y mucho menos los corazones."
,"20":"La muerte y el mundo de abajo nunca están satisfechos: lo mismo el deseo humano."
,"21":"Se prueba la plata en el fuego, se coloca el oro en el crisol: cada uno debe probar a los que lo adulan."
,"22":"Podrías moler al tonto en un mortero, pero su estupidez no lo dejaría."
,"23":"Infórmate bien del estado de tu rebaño, cuida tu ganado,"
,"24":"porque la riqueza no es eterna y las reservas no duran generaciones."
,"25":"Cuando se ha cortado la hierba y aparecen los brotes, amontona el pasto en el monte;"
,"26":"tendrás corderos para vestirte, cabritos para pagar tu campo,"
,"27":"leche de cabra suficiente para que te alimentes tú y mantengas a tus sirvientas."
}`)
	CurrentBook.AddChapter(28, `{
"1":"El malhechor huye cuando nadie lo persigue, el justo en cambio se siente más seguro que el león."
,"2":"Los errores de un violento ponen al mundo en ebullición, con un hombre inteligente vuelve la calma."
,"3":"El hombre malo que explota a los pobres es como una lluvia devastadora que deja sin pan."
,"4":"Los que abandonaron la ley aplauden al malvado, los que observan la Ley se indignan contra él."
,"5":"Los malos no entienden nada de moral, los que buscan a Yavé lo comprenden todo."
,"6":"Más vale un pobre que vive honradamente, que un oportunista que se hizo rico."
,"7":"Un muchacho inteligente observa la Ley, el que frecuenta a los libertinos es la vergüenza de su padre."
,"8":"Préstamos y usura lo han hecho rico: amontonó para otro que tuvo piedad de los pobres."
,"9":"El que se niega a escuchar la Ley, hasta su oración indispone a Dios."
,"10":"El que enseña el mal camino a la gente buena, el mismo caerá en la zanja."
,"11":"El hombre rico piensa que es sabio, pero el pobre de buen criterio sabe lo que aquél vale."
,"12":"Cuando triunfan los justos es grande la alegría; cuando ganan los malos, cada uno se esconde."
,"13":"Ocultar sus faltas no conduce a nada, el que las reconoce y renuncia a ellas se hace perdonar."
,"14":"Feliz el que nunca pierde el temor: el que endurece su conciencia caerá en la desgracia."
,"15":"Como león rugiente, o un oso hambriento, así es el malvado que domina al pobre pueblo."
,"16":"Mientras menos inteligente es un jefe, más opresor será: el que aborrece los abusos durará largo tiempo."
,"17":"El violento que derramó sangre huirá hasta su muerte, ¡no lo detengan!"
,"18":"El que camina sin reproches se salvará, el que actúa con doblez se perderá."
,"19":"Cultiva tu campo, tendrás tu ración de pan; persigue ilusiones, te hartarás de privaciones."
,"20":"El que actúa en conciencia será bendecido en todo, el que corre trás el dinero no estará sin pecado."
,"21":"Uno debiera ser imparcial, pero hay algunos que se venden por un trozo de pan."
,"22":"El hombre interesado corre tras la riqueza, no sabe que la miseria lo está esperando."
,"23":"El que sabe reprochar será un día más apreciado que el que es bueno para adular."
,"24":"El que roba a su padre diciendo: '¡No es grave!' es un bandido más."
,"25":"El hombre ambicioso sólo consigue peleas, el que confía en Yavé tendrá éxito."
,"26":"El que sólo cree en su parecer es un imbécil, el que actúa con sabiduría saldrá adelante."
,"27":"Al que da al pobre nada le faltará, el que prefiere no verlo conseguirá maldiciones."
,"28":"Cuando ganan los malos todos se esconden; cuando son eliminados, los justos se multiplican."
}`)
	CurrentBook.AddChapter(29, `{
"1":"El hombre que se encapricha a pesar de las advertencias será derribado de un golpe y sin remedio."
,"2":"Cuando los justos están en el poder, el pueblo se alegra; cuando domina un malo, el pueblo gime."
,"3":"El que ama la sabiduría es la alegría de su padre, el que se entretiene con prostitutas dejará allí su fortuna."
,"4":"Por la justicia un rey hace prosperar al país; si sólo es un opresor, lo lleva a la ruina."
,"5":"Adular a su prójimo es tenderle una red bajo sus pies."
,"6":"El pecado del malvado le prepara una trampa, mientras que el justo corre y le va bien."
,"7":"El justo conoce los derechos del pobre, el malo no quiere saber de ellos."
,"8":"Los que sólo saben criticar alborotan la ciudad, pero los sabios apaciguan la cólera."
,"9":"Cuando un sabio discute con un loco, ya sea que se enoje o que bromee, no consigue nada."
,"10":"Los violentos aborrecen al hombre integro, los malvados tratan de perderle."
,"11":"El insensato da libre curso a su impulsividad, el sabio domina la suya y la calma."
,"12":"Cuando un jefe hace caso de las calumnias, todos sus servidores son malos."
,"13":"El pobre y el opresor tienen algo en común: Yavé les da a ambos la luz del día."
,"14":"El rey que imparte a los pobres una verdadera justicia tendrá estable su poder."
,"15":"Los azotes y las correcciones llevan a la sabiduría, el niño que lo dejan hacer todo será la vergüenza de su madre."
,"16":"Cuando los malos prosperan, abunda el pecado, pero los justos verán su caída."
,"17":"Corrige a tu hijo si quieres después descansar: entonces te dará grandes alegrías."
,"18":"Si no hay visiones el pueblo vive sin freno; ¡feliz el que observa la Ley!"
,"19":"No se corrige a un sirviente sólo con palabras, ¡comprende pero no obedece!"
,"20":"¿Ves a un hombre que se muere de ganas de hablar? Hay que esperar más de un tonto que de él."
,"21":"Si has regaloneado a tu sirviente desde su juventud, al fin se volverá intratable."
,"22":"El violento multiplica las peleas, el arrebatado comete una y otra falta."
,"23":"Tu orgullo hará que te humillen, el que es humilde alcanzará los honores."
,"24":"Busca su propia ruina y es cómplice del ladrón, el que nada dice cuando hacen jurar a los que saben."
,"25":"Es una trampa temblar ante los hombres: el que confía en Yavé está seguro."
,"26":"Muchos buscan los favores del poder, pero Yavé es el que fija la suerte de cada cual."
,"27":"Los hombres justos no aguantan al malo, así como los malvados no aguantan al que es honrado."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Estas son las palabras de Agur, hijo de Yaqué, originario de Massa. Estas son las sentencias de ese hombre: ¡Me cansé, oh Dios, me cansé y me agoté, oh Dios mío! "
,"2":"Soy más estúpido que cualquiera y me falló el sentido común:"
,"3":"¡sí, yo que no aprendí la sabiduría, pensé conocer la ciencia del Santo!"
,"4":"¿Quién subió al cielo y volvió? ¿Quién encerró al viento en su puño? ¿Quién juntó las aguas en su manto? ¿Quién les puso límites a las extremidades del mundo? ¿Me puedes decir su nombre y el de su hijo?"
,"5":"Las palabras de Dios pasan cualquier prueba, son un escudo para los que confían en él."
,"6":"No agregues nada a sus palabras: te reprendería y te demostraría que mientes."
,"7":"¡Dos cosas te pido, Dios mío, no me las niegues hasta el día de mi muerte:"
,"8":"aleja de mí la falsedad y la mentira, no me des ni pobreza ni riqueza. Dame sólo mi ración de pan."
,"9":"Porque con la abundancia podría dejarte y decir: '¿Pero, quién es Yavé?' Y en la miseria podría ponerme a robar: lo que sería deshonrar el nombre de mi Dios!"
,"10":"No acuses a un sirviente ante su patrón: si te maldijera, lo tendrías bien merecido."
,"11":"¡Hay personas que maldicen a su padre y no bendicen a su madre,"
,"12":"personas que se consideran puras, pero que no han lavado sus suciedades,"
,"13":"personas cuyos ojos son despreciativos y de mirada soberbia,"
,"14":"personas con dientes como espadas y colmillos como cuchillos, que devoran a los humildes del país y a los pobres del pueblo!"
,"15":"La sanguijuela tiene dos hijas, que se llaman '¡Dame! y ¡Dame!',Hay tres que nunca tienen bastante, y cuatro que nunca dicen: '¡Es suficiente!': "
,"16":"la morada de los muertos, la mujer estéril, la tierra que carece de agua, y el fuego que nunca dice: '¡Basta!'"
,"17":"A los ojos que desafían a su padre y se niegan a obedecer a su madre, los cuervos del torrente los arrancarán, los aguiluchos los devorarán."
,"18":"Hay tres cosas que me superan y cuatro que no puedo conocer:"
,"19":"¿por dónde pasó el aguila en el cielo, y la serpiente por la roca, y el barco en alta mar? ¿Y cómo pasó el hombre por la mujer?"
,"20":"Mira cómo actúa la mujer adúltera: comió y luego se limpió la boca: '¡No hice nada malo!'"
,"21":"Hay tres cosas que hacen temblar la tierra, cuatro que no puedo soportar:"
,"22":"el esclavo que llega a ser rey, el loco que come todo lo que le gusta,"
,"23":"la joven aborrecible que encuentra marido, la sirvienta que suplanta a su patrona."
,"24":"Hay cuatro seres minúsculos en la tierra, pero que superan a todos los demás en sabiduría:"
,"25":"las hormigas son un pueblo insignificante, pero juntan sus provisiones en el verano;"
,"26":"las marmotas son indefensas, pero hallan su refugio en medio de las rocas;"
,"27":"las langostas no tienen rey, pero saben avanzar en disciplinados escuadrones; y, por último,"
,"28":"el lagarto: uno lo toma con la mano, pero lo encuentras en el palacio de los reyes."
,"29":"Hay tres que tienen un hermoso aspecto, y cuatro cuyo caminar es bello:"
,"30":"el león, el más valiente de los animales, que no retrocede ante nada;"
,"31":"el gallo, que se yergue orgulloso, y también el chivo; y además el rey, al frente de su ejército."
,"32":"Si has sido bastante torpe como para enojarte, repréndete a ti mismo, y ponte la mano en la boca."
,"33":"Porque batiéndola a golpes la nata se vuelve mantequilla, un golpe en la nariz hace estallar la sangre, y un golpe de ira provoca las peleas."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Consejos a Lemuel, rey de Massa, que le entregó su madre."
,"2":"¡No, hijo mío! ¡No, niño mío! ¡Tú, mi primogénito, al que pedí con tanto anhelo!"
,"3":"No entregues tu vigor a las mujeres, líbrate de los abrazos de las que pierden a los reyes."
,"4":"A los reyes, no les conviene, Lemuel, que tomen vino, ni a los príncipes que abusen de licores fuertes,"
,"5":"porque podrían embriagarse, olvidarse de los decretos, y violar los derechos de los pobres."
,"6":"Dale bebidas fuertes al que va a morir, dale vino al que está en la tristeza;"
,"7":"que tome, que se olvide de su miseria, que no se acuerde más de su desgracia."
,"8":"Abre la boca en favor del mudo, sostén la causa de todos los desamparados."
,"9":"Abre la boca y juzga a los pobres y afligidos con verdadera justicia."
,"10":"Una mujer de carácter, ¿dónde hallarla?,Es mucho más preciosa que una perla."
,"11":"Sabe su esposo que de ella puede fiarse: con ella saldrá siempre ganando."
,"12":"Le reporta felicidad, sin altibajos, durante todos los días de su vida."
,"13":"Ella se ha conseguido lana y lino,porque trabaja con manos hacendosas."
,"14":"Como los barcos de los comerciantes, hace que su pan venga de lejos."
,"15":"Se levanta cuando aún es de noche,para dar de comer a los de su casa."
,"16":"¿Tiene idea de un campo? Ya lo compró: una viña que pagó con su trabajo."
,"17":"Se pone con ardor a trabajar,porque tiene en sus brazos el vigor."
,"18":"Vio que sus negocios iban bien, su lámpara no se apagó toda la noche:"
,"19":"sus manos se ocupaban en la rueca, al huso sus dedos daban vuelta."
,"20":"Le tendió la mano al pobre, la abrió para el indigente."
,"21":"No le hace temer la nieve por los suyos,porque todos tienen abrigos forrados."
,"22":"Para ella se hizo cobertores, y lleva un vestido de lino y de púrpura."
,"23":"Su marido es conocido entre los oficiales, porque se sienta entre los ancianos del país."
,"24":"Vende telas que ha teñido, hasta el comerciante le compra un cinturón."
,"25":"Va irradiando salud y dignidad, mira con optimismo el porvenir."
,"26":"Lo que dice es siempre muy juicioso, tiene el arte de transmitir la piedad."
,"27":"Atenta a las actividades de su mundo, no es de aquellas que comen sin trabajo."
,"28":"Sus hijos quisieron felicitarla, su marido es el primero en alabarla:"
,"29":"'¡Las mujeres valientes son incontables, pero tú a todas has superado!'"
,"30":"¡El encanto es engañoso, la belleza pasa pronto, lo admirable en una dama es la sabiduría!"
,"31":"Reconózcanle el trabajo de sus manos: un público homenaje merecen sus obras."
}`)

}
func ES_LBL_LoadVSPSChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Dichoso el hombre,que no va a reuniones de malvados, ni sigue el camino de los pecadores,ni se sienta en la junta de burlones,"
,"2":"mas le agrada la Ley del Señor,y medita su Ley de noche y día."
,"3":"Es como árbol plantado junto al río, que da fruto a su tiempo,y tiene su follaje siempre verde. Todo lo que él hace le resulta."
,"4":"No sucede así con los impíos: son como paja llevada por el viento."
,"5":"No se mantendrán en el juicio los malvados,ni en la junta de los justos los pecadores. Porque Dios cuida el camino de los justos,y acaba con el sendero de los malos."
}`)
	CurrentBook.AddChapter(2, `{
"1":"¿Para qué meten ruido las naciones,y los pueblos meditan vanos planes?"
,"2":"Se sublevan los reyes de la tierra, y sus fuerzas unen los soberanos,en contra del Señor y de su Ungido."
,"3":"'¡Vamos, dicen, rompamos sus cadenas,y su yugo quebremos!'"
,"4":"El que se sienta en los cielos se sonríe, el Señor se burla de ellos."
,"5":"Luego les habla con enojo,y su furor los amedrenta:"
,"6":"'Yo soy quien ha consagrado a mi rey,en Sión, mi monte santo.'"
,"7":"Voy a comunicar el decreto del Señor: El me ha dicho: 'Tú eres hijo mío, yo te he engendrado hoy."
,"8":"Pídeme y serán tu herencia las naciones, tu propiedad, los confines de la tierra."
,"9":"Las regirás con un cetro de hierro,y quebrarás como cántaro de arcilla.'"
,"10":"Pues bien, reyes, entiendan, recapaciten, jueces de la tierra."
,"11":"Sirvan con temor al Señor, besen, temblando, sus pies;"
,"12":"no sea que se enoje y perezcan, pues su cólera estalla en un momento. ¡Felices los que en él se refugian!"
}`)
	CurrentBook.AddChapter(3, `{
"2":"¡Señor, cuántos son mis adversarios, cuántos los que se alzan contra mí!"
,"3":"¡Cuántos los que me dicen: 'Ya no tienes en Dios salvación'!"
,"4":"Mas tú, Señor, eres mi escudo, mi gloria, el que levanta mi cabeza."
,"5":"Tan pronto como llamo al Señor, me responde desde su monte santo."
,"6":"Yo me acuesto y me duermo, y me levanto: el Señor me sostiene."
,"7":"No le temo al pueblo que me rodea, que por todas partes me amenaza."
,"8":"¡Levántate, Señor!,¡Sálvame, oh Dios mío!,Tú golpeas en la cara a mis enemigos,y a los malvados les rompes los dientes."
,"9":"La salvación viene del Señor, que tu bendición venga sobre tu pueblo."
}`)
	CurrentBook.AddChapter(4, `{
"2":"¡Cuando llamo, respóndeme, Dios mi defensor!,En la angustia tú me has dado sosiego: ten compasión de mí y escucha mi oración."
,"3":"¿Hasta cuándo, señores, no querrán entender?,¿Por qué aman la falsedad,y buscan la mentira?"
,"4":"Sepan que por mí maravillas hace el Señor, tan pronto como lo llamo, él me escucha."
,"5":"Si tienen rabia, no se arriesguen, guárdenlo para ustedes, en la cama, y quédense luego callados."
,"6":"Según la ley ofrezcan sacrificios,y pongan su confianza en el Señor."
,"7":"Muchos dicen: '¿Quién nos hará ver la dicha?,¡Muéstranos, Señor, tu rostro alegre!'"
,"8":"Que rebosen de trigo y vino, más alegría das tú a mi corazón."
,"9":"En paz me acuesto y en seguida me duermo, pues tú sólo, Señor, me das seguridad."
}`)
	CurrentBook.AddChapter(5, `{
"2":"Señor, escucha mis palabras, y a mi queja pon atención."
,"3":"Presta oído a mi clamor, ¡oh mi rey y mi Dios!,Pues a ti te imploro, Señor."
,"4":"Desde la mañana oyes mi voz. Desde la mañana te hago promesas y me quedo a la espera."
,"5":"Tú no eres un Dios al que le gusta la maldad, ni el malvado tiene en ti acogida."
,"6":"Los insensatos no aguantan tu mirada, detestas a los que obran la maldad."
,"7":"A los que hablan mentiras los destruyes: Odia el Señor a violentos y embusteros."
,"8":"Pero yo por tu inmensa bondad,puedo entrar en tu casa; frente a tu santo templo me prosterno con toda reverencia."
,"9":"Señor, tú que eres justo, guíame: Frente a los que me espían abre ante mí un camino llano."
,"10":"Pues nada de sincero hay en su boca y sólo crímenes hay en su interior. Para halagar tienen buena lengua, mas su garganta se abre para tragar."
,"11":"Castígalos, oh Dios, como culpables, haz que fracasen sus intrigas; échalos por sus crímenes sin cuento, ya que contra ti se han rebelado."
,"12":"Que se alegren cuantos a ti se acogen, que estén de fiesta los que tú proteges, y te celebren los que aman tu nombre."
,"13":"Pues tú, Señor, bendices al justo y como un escudo lo cubre tu favor."
}`)
	CurrentBook.AddChapter(6, `{
"2":"Señor, no me reprendas en tu ira, ni me castigues si estás enojado."
,"3":"Ten compasión de mí que estoy sin fuerzas; sáname pues no puedo sostenerme."
,"4":"Aquí estoy sumamente perturbado, y tú, Señor, ¿hasta cuándo?..."
,"5":"Vuélvete a mí, Señor, salva mi vida, y líbrame por tu gran compasión."
,"6":"Pues, ¿quién se acordará de ti entre los muertos? ¿Quién te alabará donde reina la muerte?"
,"7":"Extenuado estoy de tanto gemir, cada noche empapo mi cama y con mis lágrimas inundo mi lecho."
,"8":"Mis ojos se consumen de tristeza, he envejecido al ver tantos enemigos."
,"9":"Aléjense de mí, ustedes malvados, porque el Señor oyó la voz de mi llanto."
,"10":"El Señor atendió mi súplica, el Señor recogió mi oración."
,"11":"¡Que todos mis contrarios se confundan, y no puedan reponerse, que en un instante se aparten, llenos de vergüenza!"
}`)
	CurrentBook.AddChapter(7, `{
"2":"Señor, Dios mío, en ti yo me refugio, líbrame de mis perseguidores, sálvame."
,"3":"No sea que me atrapen como un león, y me arrastren sin que nadie me salve."
,"4":"Señor Dios mío, si he actuado mal, si ha manchado mis manos la maldad,"
,"5":"si he devuelto mal por bien, o despojado sin razón a mi contrario,"
,"6":"que mi enemigo me persiga y me alcance, que me aplaste contra el suelo y esparza por el polvo mis entrañas."
,"7":"Enójate, Señor, y ponte en pie, haz frente al furor de mis opresores. Despiértate, oh Dios, y ordena el juicio."
,"8":"Que la asamblea de las naciones te rodee, y presídela tú, desde lo alto."
,"9":"Tú que juzgas a las naciones, proclama, Señor, mi rectitud y reconoce mi inocencia."
,"10":"Pon fin a la maldad y a los malvados, y fortalece tú al justo, pues las mentes y los corazones tú sondeas, tú que eres un Dios justo."
,"11":"Dios es el escudo que me cubre, él, que salva a los de recto corazón."
,"12":"Dios es un juez justo, atento siempre para castigar. Arrepiéntanse, o tengan cuidado: "
,"13":"El Señor tiene su espada afilada, su arco tenso y la flecha apuntando."
,"14":"Tiene en su mano, siempre preparadas, armas mortíferas y flechas encendidas."
,"15":"Miren al hombre preñado de malicia: Concibe la desgracia y da a luz el fracaso."
,"16":"Cava una fosa y la hace profunda, pero en la trampa que ha hecho caerá."
,"17":"Su maldad le recae en la cabeza y le rebota en la cara su violencia."
,"18":"Yo alabaré al Señor por su justicia y cantaré al Nombre del Altísimo."
}`)
	CurrentBook.AddChapter(8, `{
"2":"¡Oh Señor, nuestro Dios, qué grande es tu nombre en toda la tierra!,Y tu gloria por encima de los cielos."
,"3":"Hasta bocas de niños y lactantes,recuerdan tu poder a tus contrarios,y confunden a enemigos y rebeldes."
,"4":"Al ver tu cielo, obra de tus dedos, la luna y las estrellas que has fijado,"
,"5":"¿qué es el hombre, para que te acuerdes de él?,¿qué es el hijo de Adán para que cuides de él?"
,"6":"Un poco inferior a un dios lo hiciste, lo coronaste de gloria y esplendor."
,"7":"Has hecho que domine las obras de tus manos, tú lo has puesto todo bajo sus pies:"
,"8":"ovejas y bueyes por doquier, y también los animales silvestres,"
,"9":"aves del cielo y peces del mar, y cuantos surcan las sendas del océano."
,"10":"¡Oh Señor, Dios nuestro, qué grande es tu Nombre en toda la tierra!"
}`)
	CurrentBook.AddChapter(9, `{
"2":"Que mi alma alabe al Señor y proclame todas sus maravillas..."
,"3":"En ti me alegraré y me regocijaré, y cantaré a tu Nombre, oh Altísimo."
,"4":"Porque mis enemigos retroceden, tropiezan y perecen ante ti."
,"5":"Te has sentado en tu trono cual juez justo y has reinvindicado mi causa y mis derechos."
,"6":"Has abatido a las naciones, has hecho perecer a los malvados y has borrado su nombre para siempre."
,"7":"Los enemigos fueron aniquilados, arruinados sin remedio; sus ciudades fueron devastadas, perdido su recuerdo."
,"8":"Pero el Señor reina para siempre y establece su trono para el juicio."
,"9":"Gobernará la tierra con justicia y juzgará con rectitud a las naciones."
,"10":"El Señor es un bastión para el oprimido, un refugio para los tiempos de angustia."
,"11":"Que en ti confíen los que veneran tu nombre, porque no abandonas, Señor, a los que te buscan."
,"12":"Canten al Señor, que mora en Sión, y publiquen entre los pueblos sus hazañas."
,"13":"Pues pide cuentas por la sangre vertida, se acuerda de los oprimidos y no olvida su clamor."
,"14":"Ten compasión de mí, Señor, mira cómo me afligen los que me odian. Sácame de las puertas de la muerte, "
,"15":"para que proclame tus maravillas, en las puertas de la hija de Sión, feliz y agradecido por tu salvación."
,"16":"En la fosa que cavaron se han hundido los paganos y su pie quedó atrapado en la trampa que escondieron."
,"17":"El Señor se ha manifestado, ha dictado su sentencia, y el pecador quedó atrapado en la obra de sus manos."
,"18":"Que vuelvan al abismo los malvados, todos los paganos que olvidan al Señor."
,"19":"Porque no será olvidado el pobre para siempre ni será en vano la esperanza del humilde."
,"20":"¡Levántate, Señor, que el hombre no triunfe, y sean en tu presencia juzgadas las naciones!"
,"21":"Infúndeles terror, oh Señor, que sepan los paganos que sólo son hombres."
}`)
	CurrentBook.AddChapter(10, `{
"1":"¿Por qué te quedas lejos, Señor, y te escondes en los momentos de angustia?"
,"2":"El malvado se impone y aplasta al humilde: que quede atrapado en las trampas que maquina."
,"3":"El malvado se jacta de la avidez de su alma, el aprovechador maldice y desprecia al Señor."
,"4":"Enrisca la nariz y no se preocupa: '¡No hay Dios', dice; eso es todo lo que piensa."
,"5":"En todas sus empresas le va bien, tus sentencias son muy altas para él, barre de un soplo a todos sus rivales."
,"6":"Dice en su corazón: 'Soy inquebrantable, la desgracia jamás me alcanzará'."
,"7":"Su boca está llena de perfidia, de fraude y amenazas; sus palabras inspiran injusticia y maldad."
,"8":"Se pone al acecho en el cañaveral, a escondidas mata al inocente;"
,"9":"sus ojos espían al indigente, acecha como león en la espesura, listo para atrapar al desdichado, lo atrapa y luego lo arrastra con su red."
,"10":"Se detiene, se encoge, y cae en su poder el indigente."
,"11":"Dice en su corazón: 'Dios lo ha olvidado, tiene su cara tapada, no ve nada'."
,"12":"¡Levántate, Señor, alza tu mano! ¡No te olvides de los desdichados!"
,"13":"¿Por qué el impío menosprecia a Dios y dice para sí: 'No me pedirá cuentas'?"
,"14":"Pero tú has visto la pena y el dolor, los miras y los recoges en tus manos. A ti el desamparado se encomienda, a ti que al huérfano socorres."
,"15":"Quiebra el poder del impío y del malvado, haz que de su maldad te rinda cuentas y que no se vea más."
,"16":"El Señor es rey ahora y para siempre, los paganos ya no se ven en su tierra."
,"17":"Tú escuchas, Señor, el ruego de los humildes, reconfortas su corazón y están atentos tus oídos"
,"18":"para defender al huérfano y al oprimido y así los hombres de barro no puedan oprimirlos."
}`)
	CurrentBook.AddChapter(11, `{
"1":"En el Señor he puesto mi refugio; ¿cómo dicen a mi alma: 'Huye, cual un pájaro, hacia el monte,"
,"2":"porque los impíos tensan su arco, y ajustan sus flechas a la cuerda,para herir en la sombra,a los de recto corazón?"
,"3":"Si han cedido los cimientos, ¿qué puede hacer el justo?'"
,"4":"El Señor está en su templo santo, el Señor tiene su trono en el cielo. Sus ojos están observando,y fija su mirada en los hijos de Adán."
,"5":"El Señor explora al justo y al impío, y su alma odia a quien ama la violencia."
,"6":"Hará llover sobre los malvados,carbones encendidos y azufre,y un viento abrasador les tocará en suerte."
,"7":"Porque el Señor es justo y ama la justicia, los que son rectos contemplarán su rostro."
}`)
	CurrentBook.AddChapter(12, `{
"2":"Interviene, Señor, porque ya no hay hombres buenos ni se encuentran ya hombres leales."
,"3":"Cada cual engaña a su prójimo, se dicen buenas palabras, pero con doblez."
,"4":"Que el Señor arranque los labios mentirosos y la lengua que dice grandes frases."
,"5":"Pues dicen: 'Con palabras todo lo conseguiremos; si sabemos hablar, ¿quién nos va a dominar?'"
,"6":"'Los pobres son despojados, gimen los humildes, ahora me levanto -dice el Señor- y prestaré socorro al que es despreciado.'"
," 7":"Las palabras del Señor son palabras seguras, son como plata pura siete veces purificada en el crisol."
,"8":"Tú, Señor, cuidarás de nosotros; protégenos por siempre de esta generación."
,"9":"Por doquier se andan paseando los malvados y cunde el vicio entre los hijos de Adán."
}`)
	CurrentBook.AddChapter(13, `{
"2":"¿Hasta cuándo, Señor, seguirás olvidándome? ¿Hasta cuándo me ocultarás tu rostro?"
,"3":"¿Hasta cuándo sentiré angustia en mi alma y tristeza en mi corazón, día tras día? ¿Hasta cuándo mi enemigo triunfará a costa mía?"
,"4":"¡Señor, Dios mío, mírame y respóndeme! Ilumina mis ojos para que no me duerma con los muertos,"
,"5":"y no diga mi enemigo que acabó conmigo, ni mis adversarios se alegren al verme vacilar."
,"6":"En cuanto a mí, confío en tu bondad; conoceré la alegría de tu salvación y cantaré al Señor que me ha tratado bien."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Dijo en su corazón el insensato: '¡Mentira, Dios no existe!',Son gente pervertida que hacen cosas infames; ya no hay quien haga el bien."
,"2":"Se inclina Dios desde el cielo, mira a los hijos de Adán, ¿habrá alguno que valga, siquiera uno que busque al Señor?"
,"3":"Todos están descarriados, y juntos se han corrompido. No queda ni un hombre honrado,ni uno de muestra siquiera."
,"4":"¿No comprenderán esos malhechores,que, cuando comen, se comen a mi pueblo,¡No le han pedido a Dios la bendición!"
,"5":"Pero mira cómo se asustan de repente: ¡Dios estaba entre los justos!"
,"6":"Ustedes frustraban la esperanza del pobre, pero es Dios su refugio."
,"7":"¿Quién traerá de Sión la salvación de Israel?,Cuando a su pueblo Dios traiga de vuelta, habrá alegría en Jacob, Israel será colmado."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Señor, ¿quién entrará bajo tu tienda,y habitará en tu montaña santa?"
,"2":"El que es irreprochable y actúa con justicia, el que dice la verdad de corazón,y no forja calumnias;"
,"3":"el que no daña a su hermano,ni al prójimo molesta con agravios;"
,"4":"el que menosprecia al criminal, pero honra a los que temen al Señor;"
,"5":"y si bien al jurar se perjudicó, no se retracta de lo que ha dicho; el que no presta dinero a interés,ni acepta sobornos,para perjudicar al inocente. Quien obra así jamás vacilará."
}`)
	CurrentBook.AddChapter(16, `{
"2":"Guárdame, oh Dios, pues me refugio en ti. Yo le he dicho: 'Tú eres mi Señor, no hay dicha para mí fuera de ti."
,"3":"Los dioses del país son sólo mugre, ¡malditos sean los que los escogen"
,"4":"y que corren tras ellos!,Tan sólo penas cosecharán. No les ofreceré libaciones de sangre,ni llevaré sus nombres a mis labios."
,"5":"El Señor es la herencia que me toca,y mi buena suerte: ¡guárdame mi parte!"
,"6":"El cordel repartidor me dejó lo mejor, ¡magnífica yo encuentro mi parcela!"
,"7":"Yo bendigo al Señor que me aconseja, hasta de noche me instruye mi conciencia."
,"8":"Ante mí tengo siempre al Señor, porque está a mi derecha jamás vacilaré."
,"9":"Por eso está alegre mi corazón, mis sentidos rebosan de júbilo,y aún mi carne descansa segura:"
,"10":"pues tú no darás mi alma a la muerte, ni dejarás que se pudra tu amigo."
,"11":"Me enseñarás la senda de la vida, gozos y plenitud en tu presencia, delicias para siempre a tu derecha."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Escuha mi grito, Señor, atiende a mis clamores, presta atención a mi plegaria pues no hay engaño en mis labios."
,"2":"Dicta tú mi sentencia, pues tus ojos ven lo que es recto."
,"3":"Puedes escudriñar mi corazón,o visitarme de noche, o probarme en el crisol, no hallarás crimen en mí:"
,"4":"No he pecado en palabras, como pecan los hombres; he guardado las palabras de tus labios, y seguido las sendas del Soberano."
,"5":"Afirma mis pasos en tus caminos para que no tropiecen mis pies."
,"6":"A ti te llamo, oh Dios, esperando tu respuesta; inclina a mí tu oído y escucha mi ruego."
,"7":"Renueva tus bondades, tú que salvas del agresor a los que se refugian bajo tu diestra."
,"8":"Guárdame como a la niña de tus ojos, escóndeme a la sombra de tus alas,"
,"9":"lejos de esos malvados que me acosan, de mis enemigos que quieren mi muerte."
,"10":"Tienen el corazón taponado de grasa, y con arrogancia habla su boca."
,"11":"Me vigilan y de un golpe me cercan; se fijan en mí para tirarme al suelo."
,"12":"Son como un león ávido de presa, como un cachorro agazapado en su guarida."
,"13":"Levántate, Señor, hazles frente, derríbalos, de un mandoble líbrame del violento."
,"14":"Señor, que perezcan por tu mano, acaba con ellos, no los dejes vivir. Llénales el vientre de lo que les reservas, que sus hijos también queden saciados y que dejen las sobras a sus nietos."
,"15":"Y yo, como justo, contemplaré tu rostro, y al despertar, me saciaré de tu semblante."
}`)
	CurrentBook.AddChapter(18, `{
"2":"Yo te amo, Señor, mi fuerza,"
,"3":"El Señor es mi roca y mi fortaleza; es mi libertador y es mi Dios, es la roca que me da seguridad; es mi escudo y me da la victoria."
,"4":"Invoco al Señor que es digno de alabanzas, y me veo libre de mis enemigos."
,"5":"Las aguas de la muerte me envolvían, los torrentes devastadores me aterraban;"
,"6":"las redes de la muerte me cercaban, ante mí estaban tendidas trampas mortales."
,"7":"En mi angustia yo invoqué al Señor, y clamé a mi Dios. Mi clamor llegó hasta sus oídos y desde su Templo oyó mi voz."
,"8":"Tembló la tierra y se estremeció, se sacudieron las bases de los montes, que temblaban con sólo ver su furor."
,"9":"Subía humo de sus narices y de su boca salía un fuego abrasador que arrojaba carbones encendidos."
,"10":"El inclinó los cielos y descendió, con una densa nube bajo sus pies."
,"11":"Montó en un querubín y emprendió vuelo; planeaba sobre las alas del viento."
,"12":"En torno a él, un manto de tinieblas, un oscuro aguacero era su toldo."
,"13":"Un resplandor lo iba precediendo con granizos y brasas encendidas."
,"14":"Tronó el Señor desde los cielos, el Altísimo hizo oír su voz."
,"15":"Tiró sus flechas y los dispersó, lanzó sus rayos y los derrotó."
,"16":"Entonces apareció el fondo del mar y las bases del mundo se descubrieron, al ver, Señor, tu enojo, al pasar el soplo de tus narices."
,"17":"Desde lo alto su mano me tomó, y me rescató de las aguas profundas."
,"18":"Me libró de enemigos poderosos, de enemigos más fuertes que yo."
,"19":"Me asaltaron el día en que me iba mal, pero el Señor vino en mi ayuda."
,"20":"Me sacó a un espacio abierto, me salvó porque me amaba."
,"21":"El Señor según mis méritos me trata, limpias son mis manos, y él me lo paga."
,"22":"Porque guardé los caminos del Señor y no hice el mal lejos de mi Dios."
,"23":"Me acuerdo siempre de sus decisiones, y nunca descarto sus mandamientos."
,"24":"Ante él soy irreprochable y me cuido de cometer pecado alguno."
,"25":"Por eso me retribuye según mis méritos, según mi pureza que sus ojos ven."
,"26":"Con el que es fiel, tú te muestras fiel; si alguien no falla, tampoco tú le fallas."
,"27":"Con el que es sin doblez tú eres leal, pero pillas al hombre si es tramposo."
,"28":"Tú salvarás a un pueblo humilde y humillarás los ojos altaneros."
,"29":"Tú haces, Señor, que brille mi lámpara, ¡mi Dios ilumina mis tinieblas!"
,"30":"Contigo acometo las huestes, con mi Dios escalo la muralla."
,"31":"Mi Dios, su proceder es perfecto, y su palabra es a toda prueba. El es un escudo para cualquiera que se acoja a él."
,"32":"Pues, ¿quién es Dios fuera del Señor? ¿Quién es la Roca, sino nuestro Dios?"
,"33":"Es un Dios que me reviste de fuerza, un Dios que allana mis caminos."
,"34":"Asemeja mis pies a los de la cierva, y me hace estar de pie en las alturas."
,"35":"Adiestra mis manos para el combate, y mis brazos para tensar el arco de bronce."
,"36":"Tú me das tu escudo de salvación; tu mano me sostiene, tus favores me agrandan."
,"37":"Puedo alargar el paso, y mis tobillos no van a flaquear."
,"38":"Persigo a mis enemigos y los alcanzo, no volveré hasta que estén exterminados."
,"39":"Doy un golpe, y no pueden rehacerse, caen y quedan tendidos a mis pies."
,"40":"Me revistes de fuerza en el combate, y doblegas ante mí a mis agresores."
,"41":"Haces que mis enemigos den la espalda, y a cuantos me odiaban aniquilo."
,"42":"Aunque griten, nadie los salvará, claman al Señor, pero no les responde."
,"43":"Los trituro como polvo que se lleva el viento, los pisoteo como el barro del camino."
,"44":"Me libras de las querellas de mi pueblo, y me pones al frente de las naciones. Un pueblo que no conocía me sirve."
,"45":"Los hijos de extranjeros me adulan, apenas oyen mi voz, me obedecen."
,"46":"Los extranjeros pierden el ánimo, y salen temblando de sus fortalezas."
,"47":"¡Viva el Señor! ¡Bendita sea mi Roca! ¡Ensalzado sea el Dios que me salva!"
,"48":"Oh Dios que me concedes el desquite y colocas los pueblos a mis pies,"
,"49":"que me libras de mis enemigos y me encumbras por encima de mis agresores, tú me salvas de la gente violenta."
,"50":"Por eso te ensalzaré, Señor, y en medio de los pueblos cantaré tu Nombre,"
,"51":"tú que a tu rey das victoria tras victoria, y sigues con tus favores a tu ungido, a David y a su descendencia para siempre."
}`)
	CurrentBook.AddChapter(19, `{
"2":"Los cielos cuentan la gloria del Señor, proclama el firmamento,la obra de sus manos."
,"3":"Un día al siguiente le pasa el mensaje,y una noche a la otra se lo hace saber."
,"4":"No hay discursos ni palabras,ni voces que se escuchen,"
,"5":"mas por todo el orbe se capta su ritmo, y el mensaje llega hasta el fin del mundo."
,"6":"Al sol le fijó una tienda en lontananza, de allí sale muy alegre, como un esposo que deja su alcoba, como atleta a correr su carrera."
,"7":"Sale de un extremo de los cielos,y en su vuelta, que alcanza al otro extremo, no hay nada que se escape a su calor."
,"8":"La ley del Señor es perfecta, es remedio para el alma, toda declaración del Señor es cierta,y da al sencillo la sabiduría."
,"9":"Las ordenanzas del Señor son rectas,y para el corazón son alegría. Los mandamientos del Señor son claros,y son luz para los ojos."
,"10":"El temor del Señor es un diamante, que dura para siempre; los juicios del Señor son verdad, y todos por igual se verifican."
,"11":"Son más preciosos que el oro, valen más que montones de oro fino; más que la miel es su dulzura, más que las gotas del panal."
,"12":"También son luz para tu siervo, guardarlos es para mí una riqueza."
,"13":"Pero, ¿quién repara en sus deslices?,Límpiame de los que se me escapan."
,"14":"Guarda a tu siervo también de la soberbia, que nunca me domine. Así seré perfecto,y limpio de pecados graves."
,"15":"¡Ojalá te gusten las palabras de mi boca, esta meditación a solas ante ti, oh Señor, mi Roca y Redentor!"
}`)
	CurrentBook.AddChapter(20, `{
"2":"Que el Señor te responda en el día aciago y te proteja el Nombre del Dios de Jacob."
,"3":"Que del Santuario te envíe socorro y desde Sión te venga su auxilio."
,"4":"Que se acuerde de todas tus ofrendas y reciba con agrado tu holocausto."
,"5":"Que te conceda según tus deseos y lleve a buen fin todos tus proyectos."
,"6":"Que podamos celebrar tu victoria y enarbolar el nombre de nuestro Dios. ¡Que el Señor atienda todas tus peticiones!"
,"7":"Ahora sé que el Señor salva a su ungido; le respondió desde su santo cielo y le dio la victoria: su diestra hace proezas."
,"8":"Unos en carros, otros a caballo, pero nosotros sólo recurrimos al nombre del Señor, nuestro Dios."
,"9":"Ellos tropiezan y caen, mientras nosotros nos levantamos y nos recuperamos."
,"10":"¡Oh Señor, salva al rey, atiéndenos, pues hoy a ti clamamos!"
}`)
	CurrentBook.AddChapter(21, `{
"2":"Señor, tu fuerza regocija al rey: ¡cómo se alegra si tú lo haces triunfar!"
,"3":"Le has cumplido sus más caros deseos, no le has negado lo que te pedía."
,"4":"Tú le presentas buenas bendiciones, con oro fino coronas su cabeza."
,"5":"La vida que te pidió, tú se la diste: largos días, muchos y muchos años."
,"6":"Debido a tu favor, será muy famoso, derramas sobre él honor y majestad."
,"7":"Has puesto sobre él bendiciones eternas, tú lo haces feliz con tu presencia."
,"8":"El rey confía en el Señor, el favor del Altísimo lo hace inquebrantable."
,"9":"Tu mano encontrará a tus adversarios, tu diestra encontrará a los que te odian;"
,"10":"los dejarás, en cuanto te presentes, como si estuvieran en un horno. El Señor, en su ira, se los engullirá y un fuego los devorará."
,"11":"Arrancarás de la tierra sus frutos y su semilla de entre los hombres."
,"12":"Si contra ti traman algún mal, o meditan un plan, no se la podrán."
,"13":"Pues tú harás que te den vuelta la espalda y contra ellos dispararás tus flechas."
,"14":"¡Señor, levántate, muestra tu poder y cantaremos con salmos tus proezas!"
}`)
	CurrentBook.AddChapter(22, `{
"2":"Dios mío, Dios mío, ¿por qué me abandonaste? ¡Las palabras que lanzo no me salvan!"
,"3":"Mi Dios, de día llamo y no me atiendes, de noche, mas no encuentro mi reposo."
,"4":"Tú, sin embargo, estás en el Santuario, de allí sube hasta ti la alabanza de Israel."
,"5":"En ti nuestros padres esperaron, esperaban y tú los liberabas."
,"6":"A ti clamaban y quedaban libres, su espera puesta en ti no fue fallida."
,"7":"Mas yo soy un gusano y ya no un hombre los hombres de mí tienen vergüenza y el pueblo me desprecia."
,"8":"Todos los que me ven, de mí se burlan, hacen muecas y mueven la cabeza:"
,"9":"'¡Confía en el Señor, pues que lo libre, que lo salve si le tiene aprecio!'"
,"10":"Me has sacado del vientre de mi madre, me has confiado a sus pechos maternales."
,"11":"Me entregaron a ti apenas nacido; tú eres mi Dios desde el seno materno."
,"12":"No te alejes de mí, que la angustia está cerca, y no hay nadie que pueda ayudarme."
,"13":"Me rodean novillos numerosos y me cercan los toros de Basán."
,"14":"Amenazándome abren sus hocicos como leones que desgarran y rugen."
,"15":"Yo soy como el arroyo que se escurre; todos mis huesos se han descoyuntado; mi corazón se ha vuelto como cera, dentro mis entrañas se derriten."
,"16":"Mi garganta está seca como teja, y al paladar mi lengua está pegada: ya están para echarme a la sepultura."
,"17":"Como perros de presa me rodean, me acorrala una banda de malvados. Han lastimado mis manos y mis pies."
,"18":"Con tanto mirarme y observarme pudieron contar todos mis huesos."
,"19":"Reparten entre sí mis vestiduras y mi túnica la tiran a la suerte."
,"20":"Pero tú, Señor, no te quedes lejos; ¡fuerza mía, corre a socorrerme!"
,"21":"Libra tú de la espada mi alma, de las garras del can salva mi vida."
,"22":"Sálvame de la boca del león, y de los cuernos del toro lo poco que soy."
,"23":"Yo hablaré de tu Nombre a mis hermanos, te alabaré también en la asamblea."
,"24":"Alaben al Señor sus servidores, todo el linaje de Jacob lo aclame, toda la raza de Israel lo tema;"
,"25":"porque no ha despreciado ni ha desdeñado al pobre en su miseria, no le ha vuelto la cara y a sus invocaciones le hizo caso."
,"26":"Para ti mi alabanza en la asamblea, mis votos cumpliré ante su vista."
,"27":"Los pobres comerán hasta saciarse, alabarán a Dios los que lo buscan: ¡vivan sus corazones para siempre!"
,"28":"De Dios se acordará toda la tierra y a él se volverá; todos los pueblos, razas y naciones ante él se postrarán."
,"29":"¡Rey es Dios, Señor de las naciones! Todo mortal honor le rendirá,"
,"30":"se agacharán al verlo los que al sepulcro van. Para Dios será sólo mi existencia."
,"31":"Lo servirán mis hijos, hablarán del Señor a los que vengan,"
,"32":"al pueblo futuro: Que es justo, les dirán. Tal es su obra."
}`)
	CurrentBook.AddChapter(23, `{
"1":"El Señor es mi pastor: nada me falta;"
,"2":"en verdes pastos él me hace reposar. A las aguas de descanso me conduce,"
,"3":"y reconforta mi alma. Por el camino del bueno me dirige, por amor de su nombre."
,"4":"Aunque pase por quebradas oscuras, no temo ningún mal, porque tú estás conmigo,con tu vara y tu bastón, y al verlas voy sin miedo."
,"5":"La mesa has preparado para mí,frente a mis adversarios, con aceites perfumas mi cabeza,y rellenas mi copa."
,"6":"Irán conmigo la dicha y tu favor,mientras dure mi vida, mi mansión será la casa del Señor,por largos, largos días."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Del Señor es la tierra y lo que contiene, el mundo y todos sus habitantes;"
,"2":"pues él la edifició sobre los mares, y la puso más arriba que las aguas."
,"3":"¿Quién subirá a la montaña del Señor?,¿Quién estará de pie en su santo recinto?"
,"4":"El de manos limpias y de puro corazón, el que no pone su alma en cosas vanas,ni jura con engaño."
,"5":"Ese obtendrá la bendición del Señor,y la aprobación de Dios, su salvador."
,"6":"Así es la raza de los que Le buscan, de los que buscan tu rostro, ¡Dios de Jacob!"
,"7":"¡Ea puertas, levanten sus dinteles, elévense, portones eternos, y que pase el Rey de la Gloria!"
,"8":"¿Quién es ese Rey de la gloria?,El Señor, el fuerte, el poderoso, el Señor, valiente en la batalla."
,"9":"¡Puertas, levanten sus dinteles, elévense, portones eternos,y que pase el Rey de la gloria!"
,"10":"¿Quién es ese Rey de la gloria?,Es Yahvé, Dios de los Ejércitos, él es el Rey de la Gloria."
}`)
	CurrentBook.AddChapter(25, `{
"1":"A ti, Señor, elevo mi alma,"
,"2":"a ti que eres mi Dios. En ti he confiado, que no quede avergonzado ni se rían de mí mis enemigos."
,"3":"Los que esperan en ti no serán confundidos, pero sí lo serán quienes te mienten."
,"4":"Haz, Señor, que conozca tus caminos, muéstrame tus senderos."
,"5":"En tu verdad guía mis pasos, instrúyeme, tú que eres mi Dios y mi Salvador. Te estuve esperando todo el día, sé bueno conmigo y acuérdate de mí."
,"6":"Acuérdate que has sido compasivo y generoso desde toda la eternidad."
,"7":"No recuerdes las faltas ni los extravíos de mi juventud; pero acuérdate de mí según tu amor."
,"8":"El Señor es bueno y recto; por eso muestra el camino a los que han pecado."
,"9":"Dirige los pasos de los humildes, y muestra a los sencillos el camino."
,"10":"Amor y lealtad son todos sus caminos, para el que guarda su alianza y sus mandatos."
,"11":"¡Rinde honor a tu nombre, Señor, y perdona mi deuda, que es muy grande!"
,"12":"En cuanto un hombre teme al Señor, él le enseña a escoger su camino."
,"13":"Su alma en la dicha morará, y sus hijos heredarán la tierra."
,"14":"El secreto del Señor es para quien lo teme, le da el conocimiento de su alianza."
,"15":"Mis ojos nunca se apartan del Señor, pues él saca mis pies de la trampa."
,"16":"Mírame y ten compasión de mí, que estoy solo y desvalido."
,"17":"Afloja lo que aprieta mi corazón y hazme salir de mis angustias."
,"18":"Contempla mi miseria y mi fatiga y quítame de encima todos mis pecados."
,"19":"Mira cuántos son mis enemigos y con qué odio violento me persiguen."
,"20":"Defiende mi vida, líbrame: no quede confundido por haber confiado en ti."
,"21":"Integridad y rectitud me guardarán; en ti, Señor, he puesto mi confianza."
,"22":"Oh Dios, redime a Israel de todas sus angustias."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Júzgame, Señor, y ve que seguí la senda de los perfectos. En el Señor me apoyaba y por eso no me desviaba."
,"2":"Revísame, Señor, y ponme a prueba; pon en el crisol mi conciencia, mi corazón."
,"3":"Tu amor lo tengo ante mis ojos y tomo en cuenta tu fidelidad."
,"4":"Con hombres tramposos no me siento ni me meto con los hipócritas."
,"5":"Aborrezco el partido de los malos y con los malvados no me siento."
,"6":"Lavo mis manos, que están limpias, y en torno a tu altar voy caminando,"
,"7":"mientras entono mi acción de gracias y recuerdo tus obras admirables."
,"8":"Señor, cuánto amo la casa en que moras, y el lugar donde reside tu gloria."
,"9":"No me confundas con las almas pecadoras; que no tenga mi vida el fin de los violentos,"
,"10":"cuyas manos están manchadas y cuyos bolsillos se llenan con sobornos."
,"11":"Y a mí, como busco ser perfecto, rescátame, Señor, ten piedad de mí."
,"12":"Mis pies pisan en terreno llano, bendeciré al Señor en las asambleas."
}`)
	CurrentBook.AddChapter(27, `{
"1":"El Señor es mi luz y mi salvación, ¿a quién he de temer?,Amparo de mi vida es el Señor, ¿ante quién temblaré?"
,"2":"Cuando los malvados se lanzan contra mí,para comer mi carne, ellos, mis enemigos y contrarios, tropiezan y perecen."
,"3":"Si me sitia un ejército contrario, mi corazón no teme; si una guerra estalla contra mí, aún tendré confianza."
,"4":"Una cosa al Señor sólo le pido, la cosa que yo busco,es habitar en la casa del Señor,mientras dure mi vida, para gozar de la dulzura del Señor,y cuidar de su santuario."
,"5":"Porque él me dará asilo en su cabaña,en tiempos de desdicha, me ocultará en el secreto de su tienda, y me alzará sobre la roca."
,"6":"Y ahora mi cabeza se levanta,sobre mis enemigos que me cercan. Jubiloso en su carpa ofreceré,sacrificios con aclamaciones. Quiero cantar, tocar para el Señor."
,"7":"Señor, oye la voz con que a ti clamo, escucha, por piedad."
,"8":"Mi corazón de ti me habla diciendo: 'Procura ver su faz'."
,"9":"Es tu rostro, Señor, lo que yo busco, no me escondas tu cara. Con enojo a tu siervo no rechaces; eres tú mi defensa, ¡no me abandones, no me dejes solo, mi Dios y Salvador!"
,"10":"Si me abandonaran mi padre y mi madre, me acogería el Señor."
,"11":"Enséñame, Señor, tus caminos, y guíame por sendero llano."
,"12":"Líbrame del afán de mis contrarios, pues contra mí se levantan falsos testigos,que lanzan amenazas."
,"13":"La bondad del Señor espero ver,en la tierra de los vivientes."
,"14":"Confía en el Señor, ¡ánimo, arriba!, espera en el Señor."
}`)
	CurrentBook.AddChapter(28, `{
"1":"A ti te llamo, Señor, Roca mía, no te hagas el sordo; no sea que, si guardas silencio, me ocurra como a los que bajan a la tumba."
,"2":"Escucha la voz de mi plegaria cuando a ti grito y elevo mis manos hacia tu Templo santo."
,"3":"Junto con los malvados no me arrastres ni con los que cometen iniquidad, que hablan de paz a sus hermanos, pero llevan dentro la maldad."
,"4":"Págales tú de acuerdo a sus obras y según la malicia de sus crímenes, dáles lo mismo que han hecho sus manos; págales como se lo merecen."
,"5":"Ya que no miran las obras del Señor ni entienden lo que hacen sus manos, él los destruirá y no los rehará."
,"6":"Bendito sea el Señor, que ha escuchado la voz de mi oración."
,"7":"El Señor es mi fuerza y mi escudo, mi corazón confiaba en él, y me socorrió; por eso mi corazón se alegra y le canto agradecido."
,"8":"El Señor es la fuerza de su pueblo, un refugio seguro para su ungido."
,"9":"¡Salva a tu pueblo y bendice a los tuyos; pastoréalos y llévalos por siempre!"
}`)
	CurrentBook.AddChapter(29, `{
"1":"¡Tributen a Yahvé, hijos de Dios, tributen a Yahvé gloria y poder!"
,"2":"Devuelvan al Señor la gloria de su Nombre, adoren al Señor en solemne liturgia."
,"3":"¡Voz del Señor sobre las aguas!,retumba el trueno del Dios de majestad: es el Señor, por encima del diluvio."
,"4":"Voz del Señor, llena de fuerza, voz del Señor, voz esplendorosa."
,"5":"Voz del Señor: ¡ha partido los cedros!,El Señor derriba los cedros del Líbano."
,"6":"Hace saltar como un novillo al Líbano, y al monte Sarón como búfalo joven."
,"7":"Voz del Señor: ¡se ha tallado relámpagos!"
,"8":"Voz del Señor que sacude el desierto; estremece el Señor el desierto de Cadés."
,"9":"Voz del Señor: ¡ha doblegado encinas,y ha arrancado la corteza de los bosques!,En su templo resuena una sola voz: ¡Gloria!"
,"10":"El Señor dominaba el diluvio, el Señor se ha sentado como rey y por siempre."
,"11":"El Señor dará fuerza a su pueblo, dará a su pueblo bendiciones de paz."
}`)
	CurrentBook.AddChapter(30, `{
"2":"Te alabaré, Señor, porque me has levantado y muy poco se han reído mis contrarios."
,"3":"Señor, Dios mío, clamé a ti y tu me sanaste."
,"4":"Señor, me has sacado de la tumba, me iba a la fosa y me has devuelto a la vida."
,"5":"Que sus fieles canten al Señor, y den gracias a su Nombre santo."
,"6":"Porque su enojo dura unos momentos, y su bondad toda una vida. Al caer la tarde nos visita el llanto, pero a la mañana es un grito de alegría."
,"7":"Cuando me iba bien, decía entre mí: 'Nada jamás me perturbará'."
,"8":"Por tu favor, Señor, yo me mantenía como plantado en montes poderosos; apenas escondiste tu rostro, vacilé."
,"9":"A ti clamé, Señor, a mi Dios supliqué."
,"10":"'¿Qué ganas si me muero y me bajan al hoyo? ¿Podrá cantar el polvo tu alabanza o pregonar tu fidelidad?"
,"11":"¡Escúchame, Señor, y ten piedad de mí; sé, Señor, mi socorro!"
,"12":"Tu has cambiado mi duelo en una danza, me quitaste el luto y me ceñiste de alegría."
,"13":"Así mi corazón te cantará sin callarse jamás ¡Señor, mi Dios, por siempre te alabaré!,Señor, busco refugio en ti.-"
}`)
	CurrentBook.AddChapter(31, `{
"2":"A ti, Señor, me acojo, no quede yo nunca defraudado: ¡tú que eres justo, ponme a salvo!"
,"3":"Inclina tu oído hacia mí, date prisa en liberarme. Sé para mí una roca de refugio, el recinto amurallado que me salve."
,"4":"Porque tú eres mi roca y mi fortaleza; por tu nombre me guías y diriges."
,"5":"Sácame de la red que me han tendido, porque eres tú mi refugio."
,"6":"En tus manos encomiendo mi espíritu, y tú, Señor, Dios fiel, me librarás."
,"7":"Aborreces a los que adoran ídolos vanos, pero yo confío en el Señor."
,"8":"Gozaré y me alegraré de tu bondad porque has mirado mi aflicción y comprendido la angustia de mi alma;"
,"9":"no me dejaste en manos del enemigo, me has hecho caminar a campo abierto."
,"10":"Ten piedad de mí, Señor, pues estoy angustiado; mis ojos languidecen de tristeza."
,"11":"Mi vida se consume en la aflicción y mis años entre gemidos; mi fuerza desfallece entre tanto dolor y mis huesos se deshacen."
,"12":"Mi enemigo se alegra, mis vecinos se horrorizan, y se espantan de mí mis conocidos: si me ven en la calle, se alejan de mí."
,"13":"Se olvidaron de mí, como de un muerto, soy como un objeto inservible."
,"14":"Oigo los cuchicheos de la gente, y se asoma el terror por todas partes. Se unieron todos en mi contra, tramaron arrebatarme la vida."
,"15":"Pero yo, Señor, confío en ti, yo dije: Tú eres mi Dios."
,"16":"Mi porvenir está en tus manos, líbrame de los enemigos que me persiguen."
,"17":"Que sobre tu servidor brille tu rostro, sálvame por tu amor."
,"18":"A ti clamé, Señor, no sea confundido; confundidos sean los impíos, lánzalos a la mansión del silencio."
,"19":"Enmudece los labios embusteros, que hablan insolencias contra el justo con orgullo y desprecio."
,"20":"Qué bondad tan grande, Señor, es la que reservas para los que te temen. Se la brindas a los que en ti esperan, a la vista de los hijos de los hombres."
,"21":"En secreto, junto a ti los escondes, lejos de las intrigas de los hombres; los mantienes ocultos en tu carpa, y los guardas de las querellas."
,"22":"Bendito sea el Señor, su gracia hizo maravillas para mí: Mi corazón es como una ciudad fuerte."
,"23":"Yo decía en mi desconcierto: 'Me ha arrojado de su presencia'. Pero tú oías la voz de mi plegaria cuando clamaba a ti."
,"24":"Amen al Señor todos sus fieles, pues él guarda a los que le son leales, pero les devolverá el doble a los soberbios."
,"25":"Fortalezcan su corazón, sean valientes, todos los que esperan en el Señor."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Dichoso el que es absuelto de pecado,y cuya culpa le ha sido borrada."
,"2":"Dichoso el hombre aquel,a quien Dios no le nota culpa alguna,y en cuyo espíritu no se halla engaño."
,"3":"Hasta que no lo confesaba, se consumían mis huesos, gimiendo todo el día."
,"4":"Tu mano día y noche pesaba sobre mí, mi corazón se transformó en rastrojo,en pleno calor del verano."
,"5":"Te confesé mi pecado, no te escondí mi culpa. Yo dije:' Ante el Señor confesaré mi falta'. Y tú, tu perdonaste mi pecado, condonaste mi deuda."
,"6":"Por eso el varón santo te suplica,en la hora de la angustia. Aunque las grandes aguas se desbordasen, no lo podrán alcanzar."
,"7":"Tú eres un refugio para mí, me guardas en la prueba, y me envuelves con tu salvación."
,"8":"'Yo te voy a instruir, te enseñaré el camino, te cuidaré, seré tu consejero."
,"9":"No sean como el caballo o como el burro,faltos de inteligencia, cuyo ímpetu dominas,con la rienda y el freno.'"
,"10":"Muchos son los dolores del impío, pero al que confía en el Señor,lo envolverá la gracia."
,"11":"Buenos, estén contentos en el Señor, y ríanse de gusto; todos los de recto corazón, canten alegres."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Buenos, festejen al Señor, pues los justos le deben alabar."
,"2":"Denle gracias, tocando la guitarra, y al son del arpa entónenle canciones."
,"3":"Entonen para él un canto nuevo, acompañen la ovación con bella música."
,"4":"Pues recta es la palabra del Señor, y verdad toda obra de sus manos."
,"5":"El ama la justicia y el derecho, y la tierra está llena de su gracia."
,"6":"Por su palabra surgieron los cielos, y por su aliento todas las estrellas."
,"7":"Junta el agua del mar como en un frasco, y almacena las aguas del océano."
,"8":"Tema al Señor la tierra entera, y tiemblen ante él sus habitantes,"
,"9":"pues él habló y todo fue creado, lo ordenó y las cosas existieron."
,"10":"Malogra los proyectos de los pueblos,y deshace los planes de las naciones."
,"11":"Pero el proyecto del Señor subsiste siempre, sus planes prosiguen a lo largo de los siglos."
,"12":"Es feliz la nación cuyo Dios es el Señor, el pueblo que él escoge como herencia."
,"13":"Mira el Señor de lo alto de los cielos, y contempla a los hijos de los hombres."
,"14":"Del lugar en que vive está observando,a todos los que habitan en la tierra;"
,"15":"él, que solo formó sus corazones, él, que escudriña todas sus acciones."
,"16":"No salva al rey lo inmenso de sus tropas, ni su gran fuerza libra al que combate."
,"17":"No es verdad que un caballo sirva para triunfar, no salvará al jinete ni con todo su brío."
,"18":"Está el ojo del Señor sobre los que le temen, y sobre los que esperan en su amor,"
,"19":"para arrancar sus vidas de la muerte,y darles vida en momentos de hambruna."
,"20":"En el Señor nosotros esperamos, él es nuestra defensa y nuestro escudo;"
,"21":"en él se alegra nuestro corazón, en su santo nombre tenemos confianza."
,"22":"Venga, Señor, tu amor sobre nosotros, como en ti pusimos nuestra confianza."
}`)
	CurrentBook.AddChapter(34, `{
"2":"Bendeciré al Señor en todo tiempo, no cesará mi boca de alabarlo."
,"3":"Mi alma se gloría en el Señor: que lo oigan los humildes y se alegren."
,"4":"Engrandezcan conmigo al Señor,y ensalcemos a una su nombre."
,"5":"Busqué al Señor y me dio una respuesta,y me libró de todos mis temores."
,"6":"Mírenlo a él y serán iluminados,y no tendrán más cara de frustrados."
,"7":"Este pobre gritó y el Señor lo escuchó, y lo salvó de todas sus angustias."
,"8":"El ángel del Señor hace sus rondas,junto a los que le temen y los guarda."
,"9":"Gusten y vean cuán bueno es el Señor,¡dichoso aquel que busca en él asilo!"
,"10":"Teme al Señor, pueblo de los santos, pues nada les falta a los que le temen."
,"11":"Los ricos se han quedado pobres y con hambre, pero a los que buscan al Señor nada les falta."
,"12":"Vengan, hijos, y pónganme atención, quiero enseñarles el temor del Señor."
,"13":"¿Cuál es el hombre que anhela vivir,y desea gozar días felices?"
,"14":"Guarda tu lengua del mal, tus labios de palabras mentirosas."
,"15":"Apártate del mal y haz el bien, busca la paz y ponte a perseguirla."
,"16":"Pero tiene puestos sus ojos en los justos,y sus oídos pendientes de sus clamores."
,"17":"El Señor aparta su cara de los malos,y borra de la tierra su recuerdo."
,"18":"En cuanto gritan, el Señor escucha, y los libra de todas sus angustias."
,"19":"El Señor está cerca del corazón deshecho,y salva a los de espíritu abatido."
,"20":"Aunque el justo padezca muchos males, de todos los librará el Señor."
,"21":"El cuida con afán todos sus huesos, no le será quebrado ni uno de ellos."
,"22":"El malo morirá por su maldad,y los que odian al justo, lo tendrán que pagar."
,"23":"Pero el Señor libra el alma de sus siervos, el que se ampara en él no tendrá que pagar."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Ataca, Señor, a los que me atacan, combate a los que me combaten."
,"2":"Ponte la armadura, toma el escudo, y te levantas para venir a socorrerme."
,"3":"Blandes la lanza y el hacha contra mis perseguidores, y a mí me dices: '¡Yo soy tu salvación!'"
,"4":"Que sean humillados y fracasen los que quieren mi vida, que retrocedan y sean confundidos los que rumian mi desgracia."
,"5":"Que sean como pelusa al viento, acosados por el ángel del Señor."
,"6":"Que su camino sea oscuro y resbaladizo, perseguidos por el ángel del Señor."
,"7":"Sin motivo me tendieron una trampa, y cavaron una fosa para mí."
,"8":"Que sin aviso venga sobre ellos la ruina, que queden atrapados en su trampa y caigan en su fosa."
,"9":"Y mi alma se alegrará en el Señor, muy contenta con su intervención."
,"10":"Todo mi ser exclamará: ' Señor, ¿quién hay como tú, que libras al débil de la mano del fuerte, y al pobre y al pequeño del que los despoja?'"
,"11":"Falsos testigos se levantan en mi contra, me interrogan por cosas que yo ignoro;"
,"12":"me devuelven mal por bien, y me miran cómo me debato."
,"13":"Pero yo, cuando se enfermaban, me vestía de saco, ayunaba, hacía penitencia, y no cesaba de rezar por ellos."
,"14":"Caminaba sin rumbo como por un amigo o un hermano, me curvaba de tristeza como quien llora a su madre."
,"15":"Pero en cuanto caí, se alegraron y se juntaron todos contra mí como extranjeros o desconocidos."
,"16":"Sin cesar me desgarran esos hipócritas, burlándose de mí continuamente y rechinando contra mí los dientes."
,"17":"Señor, ¿te quedarás mirando? Rescátame de los leones rugientes, pues no tengo sino una vida."
,"18":"Te daré gracias en la gran asamblea, te alabaré cuando esté todo el pueblo."
,"19":"Que no se rían los que me odian sin razón, ni se guiñen el ojo, pues no tienen excusas."
,"20":"Esa gente no quiere la paz para los pacíficos del país; siniestros planes han maquinado"
,"21":"y hablan abiertamente contra mí: '¡Sí, sí', dicen, 'nosotros lo hemos visto!'"
,"22":"Tú, Señor, que lo has visto, no te quedes callado, ¡no te apartes de mí, Señor!"
,"23":"Despiértate y levántate, que es tiempo de juzgar. Señor, Dios mío, toma mi defensa."
,"24":"Júzgame, Señor, tú que eres justo, y que no puedan reírse de mí,"
,"25":"ni digan: '¡Salió tal como queríamos, al fin lo hemos devorado!'"
,"26":"Queden avergonzados y humillados, todos los que se ríen de mi desgracia. Queden cubiertos de infamia y de desprecio los que se alzan contra mí."
,"27":"Ríanse y alégrense los que creen en mis derechos, y que puedan decir siempre: '¡Grande es el Señor, pues supo defender a su servidor!'"
,"28":"Yo les diré que tú eres justo, todo el día te alabaré."
}`)
	CurrentBook.AddChapter(36, `{
"2":"Sólo el pecado habla al impío en el fondo de su corazón; ¡ningún temor de Dios ante sus ojos!"
,"3":"Se mira con tan buen concepto, que se niega a admitir su culpa."
,"4":"Sus palabras son fraude y maldad; renunció a ser sensato, a obrar el bien."
,"5":"Hasta en su lecho rumia sus maldades; se obstina en el camino que no es bueno, no renuncia al mal."
,"6":"Señor, tu amor está sobre los cielos y tu fidelidad pasa las nubes."
,"7":"Como los altos montes es tu justicia, y tus decretos como los abismos; Señor, tú ayudas a hombres y animales:"
,"8":"¡qué valiosa es tu gracia!,A ti acuden los hijos de Adán, debajo de tus alas se refugian; "
,"9":"se sacian con lo mejor de tu casa, y le quitas la sed en tu río de delicias."
,"10":"En ti se halla la fuente de la vida, y es por tu luz que vemos la luz."
,"11":"Conserva tu amor a los que te conocen, tus premios a los de recto corazón."
,"12":"Que no me aplaste el pie del orgulloso, ni me atrape la mano del impío."
,"13":"¡Ahí están, cayeron los malhechores, fueron tumbados y no pueden levantarse!"
}`)
	CurrentBook.AddChapter(37, `{
"1":"No te acalores pensando en los malos ni envidies a los que cometen maldad."
,"2":"Muy pronto se marchitarán como la hierba, se secarán como el verdor de los prados."
,"3":"Confía en el Señor y haz el bien, habita en tu tierra y come tranquilo."
,"4":"Pon tu alegría en el Señor, él te dará lo que ansió tu corazón."
,"5":"Encomienda al Señor tus empresas, confía en él que lo hará bien."
,"6":"Hará brillar tus méritos como la luz y tus derechos como el sol del mediodía."
,"7":"Cállate ante el Señor y espéralo; no te indignes por el aprovechador, por el que atropella al pobre y al pequeño."
,"8":"Calma tu enojo, renuncia al rencor, no te exasperes, que te haría mal."
,"9":"Pues los malvados serán extirpados y tendrán la tierra los que esperan al Señor."
,"10":"Sólo un momento y ya no está el impío, si buscas dónde estaba ya no lo encontrarás."
,"11":"Los humildes heredarán la tierra y será grande su prosperidad."
,"12":"El malo conspira contra el justo, y rechina los dientes contra él."
,"13":"Pero el Señor se burla de él, porque ve que le llega su hora."
,"14":"Han desenvainado la espada los malvados y tensado su arco para matar al justo."
,"15":"Pero su espada les traspasa el corazón y sus arcos se rompen."
,"16":"Al que es justo le va mejor con poco que al malvado con toda su riqueza."
,"17":"Porque al malo le quebrarán los brazos, en cambio a los justos los apoya el Señor."
,"18":"El Señor cuida los días de los buenos, su herencia será eterna."
,"19":"Cuando haya escasez no tendrán problemas y tendrán qué comer cuando arrecie el hambre."
,"20":"Pero los impíos perecerán y sus hijos mendigarán el pan. Los que odian al Señor desaparecen como flores del prado, y se desvanecen como el humo."
,"21":"El impío pide fiado y no devuelve, pero el justo es compasivo y comparte."
,"22":"Los que él bendice poseerán la tierra, y los que él maldice serán eliminados."
,"23":"El Señor guía los pasos del hombre; lo afirma si le gusta su conducta."
,"24":"Si el bueno cae, no se queda en tierra, porque el Señor lo tiene de la mano."
,"25":"Fui joven y ahora soy viejo, pero nunca vi a un justo abandonado."
,"26":"No se ha cansado de dar y prestar: en sus hijos se notará la bendición."
,"27":"Apártate del mal y haz el bien, y tendrás una casa para siempre."
,"28":"Porque el Señor ama lo que es justo y no abandona jamás a sus amigos. Los pecadores perecerán para siempre y se acabará la raza de los malos."
,"29":"Los justos poseerán la tierra y habitarán en ella para siempre."
,"30":"Medita el justo los dichos de los sabios y si habla, expresa lo que es justo."
,"31":"Con la ley del Señor en su corazón, sus pasos no vacilan."
,"32":"El malvado anda espiando al justo y trata siempre de darle muerte."
,"33":"Pero el Señor no lo deja en sus manos ni permite que sus jueces lo condenen."
,"34":"Espera en el Señor y sigue su camino, él te librará de los impíos, y te mantendrá hasta que heredes la tierra; presenciarás la caída de los malos."
,"35":"He visto al impío, vuelto tirano, elevarse como un cedro del Líbano."
,"36":"Pasé de nuevo, pero ya no estaba; lo busqué, pero no lo encontré."
,"37":"Observa al perfecto, mira al hombre recto: toda una posteridad tendrá el hombre de paz."
,"38":"Los pecadores, en cambio, de una vez se irán, la raza de los malos será exterminada."
,"39":"La salvación de los justos viene del Señor, él es su refugio en tiempos de angustia."
,"40":"El Señor los ayuda y los libera, salva a cuantos confiaron en él."
}`)
	CurrentBook.AddChapter(38, `{
"2":"Señor, no me reprendas en tu enojo, ni me castigues si estás indignado."
,"3":"Pues tus flechas en mí se han clavado, y tu mano se ha cargado sobre mí."
,"4":"Nada quedó sano en mí por causa de tu ira, nada sano en mis huesos, después de mi pecado."
,"5":"Mis culpas llegan más arriba de mi cabeza, pesan sobre mí más que un fardo pesado."
,"6":"Mis llagas supuran y están fétidas, debido a mi locura."
,"7":"Ando agobiado y encorvado, camino afligido todo el día."
,"8":"Mi espalda arde de fiebre y en mi carne no queda nada sano."
,"9":"Estoy paralizado y hecho pedazos, quisiera que mis quejas fueran rugidos."
,"10":"Señor, ante ti están todos mis deseos, no se te ocultan mis gemidos."
,"11":"Mi corazón palpita, las fuerzas se me van, y hasta me falta la luz de mis ojos."
,"12":"Compañeros y amigos se apartan de mis llagas, mis familiares se quedan a distancia."
,"13":"Los que esperan mi muerte hacen planes, me amenazan los que me desean lo peor, y rumian sus traiciones todo el día."
,"14":"Pero yo, como si fuera sordo, no oigo; soy como un mudo que no abre la boca,"
,"15":"como un hombre que no entiende nada y que nada tiene que contestar."
,"16":"Pues en ti, Señor, espero; tú, Señor mi Dios, responderás."
,"17":"Yo dije: 'Que no se rían de mí, ni canten victoria si vacilan mis pasos'."
,"18":"Ahora estoy a punto de caer, y mi dolor no se aparta de mí."
,"19":"Sí, quiero confesar mi pecado, pues ando inquieto a causa de mi falta."
,"20":"Son poderosos mis enemigos sin causa, incontables los que me odian sin razón."
,"21":"Me devuelven mal por bien, y me condenan porque busco el bien."
,"22":"¡Señor, no me abandones, mi Dios, no te alejes de mí!"
,"23":"¡Ven pronto a socorrerme, oh Señor, mi salvador!"
}`)
	CurrentBook.AddChapter(39, `{
"2":"Había dicho: 'Andaré derecho, para que no peque por mi lengua, le pondré a mi lengua una mordaza mientras el malvado se yergue ante mí'."
,"3":"Callaba resignado, sin decir palabra, pero me atormentaba al ver su buena suerte;"
,"4":"me ardía por dentro el corazón, y el escándalo atizaba el fuego, hasta que al fin se me soltó la lengua."
,"5":"'Señor, haz que conozca mi fin y cuál es el largo de mis días, para que sepa lo frágil que soy."
,"6":"A mis días no les diste más de una cuarta y mi existencia es nada para ti. El hijo de Adán se pavonea, pero no es más que soplo."
,"7":"Pasa el hombre mortal como una sombra, no es más que un soplo, pero se afana y almacena sin saber quién lo tendrá."
,"8":"Si es así, ¿qué me queda, Señor? Pondré en ti mi esperanza."
,"9":"No consideres todos mis pecados, no me avergüences ante el insensato'."
,"10":"Me callo, no hablaré más, pues tú así lo dispusiste."
,"11":"Aleja de mí tus castigos, que me han destrozado los golpes de tu mano."
,"12":"Corriges al hombre cobrándole sus culpas, roes como polilla lo que más deseó. En verdad, el hombre es sólo un soplo."
,"13":"Señor, escucha mi plegaria, presta oído a mis clamores, no permanezcas sordo a mis lágrimas, pues en tu casa soy un forastero y, como mis padres, peregrino."
,"14":"Dame un descanso, que pueda respirar antes de que me vaya y ya no esté."
}`)
	CurrentBook.AddChapter(40, `{
"2":"Esperaba, esperaba al Señor, él se inclinó hacia mí y escuchó mi clamor,"
,"3":"me sacó de la fosa fatal del barro del pantano; puso mis pies sobre roca y aseguró mis pasos."
,"4":"Puso en mi boca un cántico nuevo, de alabanza a nuestro Dios. Muchos al verlo temerán y pondrán su confianza en el Señor."
,"5":"Feliz el hombre que cuenta con el Señor, que no escucha a los cínicos ni se pierde en sus mentiras."
,"6":"¡Cuántas maravillas has hecho, Señor, mi Dios, cuántos proyectos en favor nuestro! Nadie se te puede comparar. Yo quisiera publicarlas y contarlas, pero son demasiado para enumerarlas."
,"7":"No quisiste sacrificios ni ofrendas -lo dijiste y penetró en mis oídos- no pediste holocaustos ni víctimas."
,"8":"Entonces dije: 'Aquí estoy, de mi está escrito en el rollo del Libro."
,"9":"He elegido, mi Dios, hacer tu voluntad, y tu Ley está en el fondo de mi ser'."
,"10":"Publiqué tu camino en la gran asamblea, no me callé, Señor, tú bien lo sabes."
,"11":"No encerré tus decretos en el fondo de mi corazón: proclamé tu fidelidad y tu socorro. No oculté tu amor y tu verdad en la gran asamblea."
,"12":"¡Tú, Señor, no me niegues tu ternura, que tu amor y tu verdad me guarden siempre!"
,"13":"Me rodean desgracias incontables, mis culpas recaen sobre mí y no hay salida, son más que los cabellos de mi cabeza y me falla el corazón."
,"14":"Dígnate liberarme, Señor; Señor, ven pronto a socorrerme."
,"15":"¡Queden avergonzados y humillados todos los que atentan contra mi vida; que retrocedan confundidos los que se alegran con mi desgracia!"
,"16":"Que se escondan de vergüenza los que dicen: '¡Esta vez lo pillamos!'"
,"17":"Pero que en ti se alegren y regocijen todos los que te buscan, y que repitan siempre: '¡Dios es grande!' los que desean tu salvación."
,"18":"¡Piensa en mí, oh Dios, en mí que soy un pobre y desdichado! ¡No te demores, mi Dios, pues tú eres mi socorro y salvación!"
}`)
	CurrentBook.AddChapter(41, `{
"2":"Feliz el que se acuerda del pobre y del débil, en el día malo lo salvará el Señor;"
,"3":"el Señor lo guardará, lo mantendrá con vida,y feliz en esta tierra: -no lo dejarás en manos de sus enemigos-"
,"4":"El Señor lo acompaña en su lecho de dolor,y le arregla la cama mientras está enfermo."
,"5":"Yo dije: 'Señor, apiádate de mí, sáname porque he pecado contra ti'."
,"6":"Mis enemigos me desean lo peor: 'A ver si se muere y ya no se habla más de él'."
,"7":"Si alguien viene a verme, habla por hablar, pero se informa para dañarme; apenas está fuera, esparce sus rumores."
,"8":"Mis enemigos se juntan y cuchichean, mientras comentan mi mal:"
,"9":"'Este ataque no es cosa buena, cayó en la cama para no levantarse'."
,"10":"Hasta mi amigo seguro,en el que yo confiaba, que mi pan compartía, se ha vuelto en contra mía."
,"11":"Pero tú, Señor, ten piedad de mí, ponme en pie, que quiero pagarles con lo mismo."
,"12":"Que mis enemigos no canten victoria, y reconoceré que me valoras."
,"13":"Tú me asistirás, Señor, porque no hay falta en mí, y me mantendrás en tu presencia para siempre."
,"14":"¡Bendito sea el Señor, Dios de Israel, desde siempre y para siempre! ¡Así sea!"
}`)
	CurrentBook.AddChapter(42, `{
"2":"Como anhela la cierva estar junto al arroyo, así mi alma desea, Señor, estar contigo."
,"3":"Sediento estoy de Dios, del Dios de vida; ¿cuándo iré a contemplar el rostro del Señor?"
,"4":"Lágrimas son mi pan de noche y día, cuando oigo que me dicen sin cesar: '¿Dónde quedó su Dios?'"
,"5":"Es un desahogo para mi alma, acordarme de aquel tiempo, en que iba con los nobles,hasta la casa de Dios, entre vivas y cantos de la turba feliz."
,"6":"¿Qué te abate, alma mía, por qué gimes en mí?,Pon tu confianza en Dios,que aún le cantaré a mi Dios Salvador."
,"7":"Mi alma está deprimida, por eso te recuerdo desde el Jordán y el Hermón,a ti, humilde colina."
,"8":"El eco de tus cascadas,resuena en los abismos, tus torrentes y tus olas,han pasado sobre mí."
,"9":"Quiera Dios dar su gracia de día, y de noche a solas le cantaré, oraré al Dios de mi vida."
,"10":"A Dios, mi Roca, le hablo: ¿Por qué me has olvidado?,¿Por qué debo andar triste, bajo la opresión del enemigo?"
,"11":"Mis adversarios me insultan,y se me quiebran los huesos,al oír que a cada rato me dicen: '¿Dónde quedó tu Dios?'"
,"12":"¿Qué te abate, alma mía, por qué gimes en mí?,Pon tu confianza en Dios,que aún le cantaré a mi Dios salvador."
}`)
	CurrentBook.AddChapter(43, `{
"1":"Hazme justicia, oh Dios, y defiende mi causa,del hombre sin piedad; de la gente tramposa y depravada,líbrame, tú, Señor."
,"2":"Si tú eres el Dios de mi refugio: ¿por qué me desamparas?,¿por qué tengo que andar tan afligido,bajo la presión del enemigo?"
,"3":"Envíame tu luz y tu verdad: que ellas sean mi guía,y a tu santa montaña me conduzcan, al lugar donde habitas."
,"4":"Al altar de Dios me acercaré, al Dios de mi alegría; jubiloso con arpa cantaré,al Señor, mi Dios."
,"5":"¿Qué tienes alma mía, qué te abate, por qué gimes en mí?,Confía en Dios, que aún le cantaré,a mi Dios salvador."
}`)
	CurrentBook.AddChapter(44, `{
"2":"Lo escuchamos, oh Dios, con nuestros oídos y nos lo transmitieron nuestros padres: las hazañas que en su época tú hiciste, con tu propia mano, en otros tiempos."
,"3":"Para implantarlos, expulsaste a naciones y para extenderlos, maltrataste a pueblos."
,"4":"No conquistó al país su propia espada, ni su brazo los hizo vencedores, sino que fueron tu diestra y tu brazo y la luz de tu rostro, porque los amabas."
,"5":"Tú, mi rey y mi Dios es quien decide las victorias de Jacob."
,"6":"Por ti hundimos a nuestros adversarios y en tu nombre pisamos a nuestros agresores."
,"7":"No es mi arco en quien yo confío, ni es mi espada quien me da la victoria;"
,"8":"mas por ti vencemos a nuestros adversarios, tú dejas en vergüenza a los que nos odian."
,"9":"A Dios cada día celebramos y sin cesar alabamos tu nombre."
,"10":"Ahora, en cambio, nos rechazas y humillas y no sales al frente de nuestras tropas."
,"11":"Nos haces ceder ante el adversario y los que nos odian saquean a gusto."
,"12":"Nos entregas como ovejas a la matanza, y nos dispersas en medio de las naciones."
,"13":"Vendes a tu pueblo por un precio irrisorio y no ganas nada con tu negocio."
,"14":"Nos haces el escarnio de nuestros vecinos, todos en derredor se burlan y se ríen."
,"15":"Servimos de escarmiento a las naciones, y los pueblos menean la cabeza."
,"16":"Tengo siempre delante mi deshonra y enrojece mi rostro la vergüenza"
,"17":"al oír los insultos y blasfemias, al ver el odio y la venganza."
,"18":"Todo esto nos pasó sin que nosotros te olvidáramos o rompiéramos tu alianza."
,"19":"No se dio vuelta nuestro corazón ni dejaron tu senda nuestros pasos."
,"20":"Pero nos aplastaste en el desierto, y nos cubrió la sombra de la muerte."
,"21":"Si hubiéramos olvidado el nombre de nuestro Dios tendiendo las manos hacia un dios extranjero,"
,"22":"¿no es cierto que Dios lo hubiera visto, el que conoce los secretos del corazón?"
,"23":"Por tu causa nos matan a cada rato, y nos vemos como ovejas ante el cuchillo."
,"24":"Despiértate, ¿por qué duermes, Señor? ¡Levántate y ven a socorrernos!"
,"25":"¿Por qué escondes tu cara? ¿olvidas nuestra opresión, nuestra miseria?"
,"26":"Nos arrastramos por el polvo y a la tierra se pega nuestro vientre."
,"27":"¡Levántate, Señor, y socórrenos, acuérdate de tu bondad y líbranos!"
}`)
	CurrentBook.AddChapter(45, `{
"2":"Lleno me siento de palabras bellas, recitaré al rey, yo, mi poema: mi lengua es como un lápiz de escritor."
,"3":"Tú eres el más hermoso entre los hombres, en tus labios la gracia se derrama, así Dios te bendijo para siempre."
,"4":"Cíñete ya la espada, poderoso, con gloria y con honor"
,"5":"anda y cabalga por la causa,de la verdad, la piedad y el derecho. Haces proezas con armas en la mano:"
,"6":"tus flechas son agudas, los pueblos se te rinden; los enemigos del rey pierden coraje."
,"7":"Tu trono, oh Dios, es firme para siempre. Cetro de rectitud es el de tu reinado."
,"8":"Amas lo justo y odias lo que es malo; por eso Dios, tu Dios, te dio a ti solo,una unción con perfumes de alegría,como no se la dio a tus compañeros."
,"9":"Mirra y áloe impregnan tus vestidos, el son del arpa alegra tu casa de marfil."
,"10":"Hijas de reyes son tus muy amadas, una reina se sienta a tu derecha, oro de Ofir en sus vestiduras luce."
,"11":"Ahora tú, hija, atiéndeme y escucha: olvida a tu pueblo y la casa de tu padre,"
,"12":"y tu hermosura al rey conquistará. El es tu Señor:"
,"13":"los grandes de Tiro ante él se postrarán. Ahí vienen los ricos del país,a rendirte homenaje."
,"14":"La hija del rey, con oro engalanada, es introducida al interior,"
,"15":"vestida de brocados al rey es conducida. La siguen sus compañeras vírgenes,que te son presentadas."
,"16":"Escoltadas de alegría y júbilo, van entrando al palacio real."
,"17":"En lugar de tus padres tendrás hijos, que en todas partes príncipes serán."
,"18":"Gracias a mí yo quiero que tu nombre,viva de una a otra generación,y que los pueblos te aclamen para siempre."
}`)
	CurrentBook.AddChapter(46, `{
"2":"Dios es nuestro refugio y fortaleza, socorro siempre a mano en momentos de angustia."
,"3":"Por eso, si hay temblor no temeremos, o si al fondo del mar caen los montes;"
,"4":"aunque sus aguas rujan y se encrespen,y los montes a su ímpetu retiemblen: El Señor Sabaot está con nosotros, es nuestro baluarte el Dios de Jacob."
,"5":"Un río, sus brazos regocijan,a la ciudad de Dios, santifica las moradas del Altísimo."
,"6":"Dios está en ella, no puede ceder, Dios la socorre al despuntar la aurora."
,"7":"Los pueblos bramaban, los reinos en marcha se ponían... El eleva su voz y el mundo se hunde."
,"8":"El Señor Sabaot está con nosotros, es nuestro baluarte el Dios de Jacob."
,"9":"Vengan a ver las hazañas del Señor, y los estragos que causó a la tierra."
,"10":"Pone fin a la guerra en todo el país, rompe el arco y en dos parte la lanza,y consume los carros en el fuego."
,"11":"Paren y reconozcan que soy Dios, muy por encima de los pueblos,y muy alto sobre la tierra."
,"12":"El Señor Sabaot está con nosotros, es nuestro baluarte el Dios de Jacob."
}`)
	CurrentBook.AddChapter(47, `{
"2":"Aplaudan, pueblos todos, aclamen a Dios con voces de alegría"
,"3":"pues el Señor, el altísimo, es terrible, es un gran rey en toda la tierra."
,"4":"Bajo nuestro yugo pone a las naciones,y los pueblos a nuestros pies;"
,"5":"él eligió para nosotros nuestra herencia, orgullo de Jacob, su muy amado."
,"6":"Dios sube entre fanfarrias, para el Señor resuenan los cuernos;"
,"7":"canten, canten a Dios; entonen salmos a nuestro rey;"
,"8":"a Dios que es el rey de toda la tierra, cántenle un himno de alabanza."
,"9":"Dios reina sobre las naciones, Dios se sienta en su santo trono."
,"10":"Los jefes de los pueblos se han unido,con el pueblo del Dios de Abrahán; porque él es el señor de los grandes de la tierra, él es Dios y es muy excelso."
}`)
	CurrentBook.AddChapter(48, `{
"2":"Grande es el Señor y muy digno de alabanzas, en la ciudad de nuestro Dios, en su monte santo,"
,"3":"de hermosa altivez, alegría de toda la tierra. ¡Monte Sión, morada divina, ciudad del Gran Rey!"
,"4":"Dentro de sus torreones está Dios, se ha revelado como su baluarte."
,"5":"Los reyes se habían unido, y juntos avanzaban, hasta que la vieron... y quedaron pasmados; presos de pánico, se dieron a la fuga."
,"7":"Allí mismo los agarró un temblor, un escalofrío como de mujer en parto; "
,"8":"así es como el viento del oriente,estrella a los navíos de Tarsis."
,"9":"Tal como lo oímos, así lo vimos en la ciudad del Señor Sabaot, en la ciudad de nuestro Dios: él la ha asentado para siempre."
,"10":"Oh Dios, recordamos tus favores,en los patios de tu Templo; "
,"11":"que iguale, oh Dios, tu alabanza a tu nombre, y alcance los confines de la tierra."
,"12":"Impone tu diestra tu justicia; se alegra el monte Sión; los pueblos de Judá saltan de gozo al presenciar tus juicios."
,"13":"Recorran Sión y den la vuelta, cuenten sus torres "
,"14":"y contemplen sus defensas; recorran uno a uno sus palacios,y digan a las nuevas generaciones: "
,"15":"¡así es nuestro Dios!,Nuestro Dios por los siglos de los siglos, él nos conducirá."
}`)
	CurrentBook.AddChapter(49, `{
"2":"Oigan esto, pueblos todos, habitantes del mundo entero, escuchen:"
,"3":"gente del pueblo y gente de apellido, ricos y pobres, todos en conjunto."
,"4":"Mi boca va a decir sabiduría,y lo que pienso sobre cosas hondas;"
,"5":"dejen que me concentre en un refrán, lo explicaré luego al son del arpa."
,"6":"¿Por qué temer en días de desgracia, cuando me cercan el mal y la traición"
,"7":"de los que en su fortuna se confían,y hacen prevalecer su gran riqueza?"
,"8":"Mas comprada su vida nadie tiene, ni a Dios puede, con plata, sobornarlo,"
,"9":"pues es muy caro el precio de la vida."
,"10":"¿Vivir piensa por siempre, o cree que no irá a la fosa un día?"
,"11":"Pues bien, verá que los sabios se mueren, que igual perecen el necio y el estúpido, y dejan para otros su riqueza."
,"12":"Sus tumbas son sus casas para siempre, por siglos y siglos sus moradas, por más que su nombre a sus tierras hayan puesto."
,"13":"El hombre en los honores no comprende, es igual que el ganado que se mata."
,"14":"Hacia allá van los que en sí confían, ese será el fin de los que les gusta escucharse."
,"15":"Abajo cual rebaño la muerte los reúne, los pastorea y les impone su ley. Son como un espectro desvaído,que a la mañana vuelve su casa abajo."
,"16":"Pero a mí Dios me rescatará, y me sacará de las garras de la muerte."
,"17":"No temas cuando el hombre se enriquece, cuando aumenta la fama de su casa."
,"18":"Nada podrá llevar él a su muerte, ni su riqueza podrá bajar con él."
,"19":"Su alma, que siempre en vida bendecía: 'Te alaban, porque te has tratado bien',"
,"20":"irá a unirse con la raza de sus padres, que jamás volverán a ver la luz."
,"21":"El hombre en los honores no comprende, es igual que el ganado que se mata."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Yavé, el Dios de los dioses, ha hablado: desde donde sale el sol hasta el ocaso, ha convocado él a la tierra."
,"2":"Desde Sión, la muy hermosa, Dios refulge:"
,"3":"¡Ahí viene nuestro Dios, que no se calla!,Un fuego, delante de él, lo abrasa todo, y a su alrededor ruge la tormenta."
,"4":"De lo alto convoca a los cielos,y a la tierra para juzgar a su pueblo:"
,"5":"'Reúnan a mis fieles ante mí, que con un sacrificio sellaron mi alianza.'"
,"6":"Serán los cielos los que anuncien la sentencia, porque el juez es Dios mismo:"
,"7":"'Escucha, pueblo mío, que te hablo; Israel, declaro en contra tuya, yo, Dios, que soy tu Dios."
,"8":"No te reprendo por tus sacrificios, o por tus holocaustos, que están siempre ante mí."
,"9":"No tomaría un toro de tu establo,ni un chivo de tu corral,"
,"10":"pues mío es cuanto vive en la selva,y los miles de animales de los montes."
,"11":"Conozco todas las aves del cielo,y mío es cuanto se mueve en el campo."
,"12":"Si tuviera hambre, no te lo diría, pues mío es el orbe y lo que encierra."
,"13":"¿Acaso comeré carne de toros,o beberé la sangre de cabritos?"
,"14":"Pero dale gracias a Dios con sacrificios, y cumple tus mandas al Altísimo;"
,"15":"invócame en el día de la angustia, te libraré y tú me darás gloria."
,"16":"Pero al impío Dios le dice: '¿Por qué vas repitiendo mis preceptos, y andas siempre hablando de religión,"
,"17":"tú que odias mis reprensiones,y te echas mis palabras a la espalda?"
,"18":"Si ves un ladrón, corres con él, y entre los adúlteros tienes tu sitio."
,"19":"Das rienda suelta a tu boca para el mal,y tu lengua urde el engaño."
,"20":"Si te sientas, hablas mal de tu hermano, deshonras al hijo de tu madre."
,"21":"Si tú lo haces, ¿tendré yo que callarme?, ¿o piensas que yo soy como tú?,Te acusaré y te lo echaré en cara."
,"22":"¡Oigan bien los que se olvidan de Dios!,pues si doy un zarpazo no habrá quien los libre."
,"23":"Me honra el que da gracias con sacrificios, pero al que va por camino recto, le haré ver la salvación de Dios'."
}`)
	CurrentBook.AddChapter(51, `{
"3":"Ten piedad de mí, oh Dios, en tu bondad, por tu gran corazón, borra mi falta."
,"4":"Que mi alma quede limpia de malicia, purifícame de mi pecado."
,"5":"Pues mi falta yo bien la conozco,y mi pecado está siempre ante mí;"
,"6":"contra ti, contra ti sólo pequé, lo que es malo a tus ojos yo lo hice. Por eso en tu sentencia tú eres justo, no hay reproche en el juicio de tus labios."
,"7":"Tú ves que malo soy de nacimiento, pecador desde el seno de mi madre."
,"8":"Mas tú quieres rectitud de corazón, y me enseñas en secreto lo que es sabio."
,"9":"Rocíame con agua, y quedaré limpio; lávame y quedaré más blanco que la nieve."
,"10":"Haz que sienta otra vez júbilo y gozo,y que bailen los huesos que moliste."
,"11":"Aparta tu semblante de mis faltas, borra en mí todo rastro de malicia."
,"12":"Crea en mí, oh Dios, un corazón puro, renueva en mi interior un firme espíritu."
,"13":"No me rechaces lejos de tu rostro,ni me retires tu espíritu santo."
,"14":"Dame tu salvación que regocija, y que un espíritu noble me dé fuerza."
,"15":"Mostraré tu camino a los que pecan, a ti se volverán los descarriados."
,"16":"Líbrame, oh Dios, de la deuda de sangre, Dios de mi salvación, y aclamará mi lengua tu justicia."
,"17":"Señor, abre mis labios,y cantará mi boca tu alabanza."
,"18":"Un sacrificio no te gustaría, ni querrás si te ofrezco, un holocausto."
,"19":"Mi espíritu quebrantado a Dios ofreceré, pues no desdeñas a un corazón contrito."
,"20":"Favorece a Sión en tu bondad: reedifica las murallas de Jerusalén;"
,"21":"entonces te gustarán los sacrificios, ofrendas y holocaustos que se te deben; entonces ofrecerán novillos en tu altar."
}`)
	CurrentBook.AddChapter(52, `{
"3":"¿Por qué de tu maldad te jactas tanto, tú que te sientes fuerte en tu injusticia"
,"4":"y meditas en crímenes todo el día?,Una navaja afilada es tu lengua, hacedor de imposturas."
,"5":"Amas el mal más que el bien, prefieres la mentira a la verdad."
,"6":"Lengua embustera, que te gusta lanzar toda palabra que hace mal."
,"7":"Por eso Dios te aplastará, te va a tomar y echarte de tu tienda, te extirpará de la tierra de los vivos."
,"8":"Los buenos lo verán y temerán y dirán riéndose de él:"
,"9":"'Miren al hombre que no hizo de Dios su fortaleza, sino que confió en sus muchas riquezas y se encastilló en su crimen'."
,"10":"Pero yo quiero ser olivo vigoroso en la casa de Dios, en el amor de Dios yo me confío para siempre jamás."
,"11":"Te alabaré por todo lo que has hecho, tu Nombre será siempre mi esperanza, porque eres bueno, Señor, con los que te aman."
}`)
	CurrentBook.AddChapter(53, `{
"2":"Dijo en su corazón el insensato: '¡Mentira, Dios no existe!' Son gente pervertida, hacen cosas infames, ya no hay quien haga el bien."
,"3":"Se asoma Dios desde el cielo, mira a los hijos de Adán, para ver si hay alguno que valga, alguien que busque a Dios."
,"4":"Pero todos se han descarriado, y se han corrompido juntos,No queda ni un hombre honrado, ni uno de muestra siquiera."
,"5":"¿No comprenderán esos malhechores que comen a mi pueblo como se come el pan?,¡No le han pedido a Dios la bendición!"
,"6":"¡Mira cómo se asustan de repente! Les cae una desgracia inesperada. Dios dispersa los huesos del renegado; todos se ríen de ellos: '¡Cómo Dios los ha rechazado!'"
,"7":"¿Quién traerá de Sión la salvación de Israel?,Cuando a su pueblo Dios traiga de vuelta, habrá alegría en Jacob, Israel será colmado."
}`)
	CurrentBook.AddChapter(54, `{
"3":"Oh Dios, por tu Nombre sálvame; por tu poder hazme justicia."
,"4":"Oh Dios, escucha mi plegaria, escucha las palabras de mi boca,"
,"5":"pues se alzan contra mí los arrogantes y buscan mi muerte los violentos, hombres para los cuales Dios no cuenta."
,"6":"Pero a mí Dios me ayuda, entre los que me apoyan está el Señor."
,"7":"Que el mal recaiga sobre los que me espían; destrúyelos, Señor, pues tú eres fiel."
,"8":"Te ofreceré de buena gana un sacrificio y alabaré tu nombre, porque es bueno,"
,"9":"pues me has sacado de cualquier angustia y he visto humillado a mis enemigos."
}`)
	CurrentBook.AddChapter(55, `{
"2":"Oh Dios, pon atención a mi plegaria, no desatiendas mis súplicas."
,"3":"Atiéndeme y respóndeme: me agito lamentándome y gimiendo,"
,"4":"al oír la voz del enemigo,y las amenazas del impío."
,"5":"Con sus aullidos me ensordecen,y me persiguen con alevosía."
,"6":"Mi corazón se estremece en mi pecho, una angustia mortal me sobrecoge; me invaden el miedo y el terror,y el pavor me atenaza,Y yo dije:"
,"7":"Si tuviera alas de paloma,volaría a donde pudiera posarme."
,"8":"Huiría muy lejos, y pasaría la noche en el desierto."
,"9":"Buscaría un asilo a toda prisa,contra la tempestad y contra el viento."
,"10":"Dispérsalos, Señor, confúndeles las lenguas, pues violencia y discordia he visto en la ciudad;"
,"11":"rondan por sus murallas día y noche,y dentro están la injusticia y el crimen."
,"12":"El mal se aloja en ella; de su plaza no se alejan la astucia y el engaño."
,"13":"Si llegara a insultarme un enemigo, yo lo soportaría; si el que me odia se alzara en contra mía, me escondería de él;"
,"14":"mas fuiste tú, un hombre como yo, mi familiar, mi amigo,"
,"15":"a quien me unía una dulce amistad; juntos íbamos a la casa de Dios,en alegre convivencia."
,"16":"Que la muerte los sorprenda, que bajen vivos al lugar de los muertos, pues el mal se cobija en su interior."
,"17":"Pero yo clamo a Dios,y el Señor me salvará."
,"18":"De tarde, de mañana, al mediodía, me lamento y me aflijo,y escuchará mi voz."
,"19":"Me dará la paz, me sacará del combate, aunque muchos estén en contra mía."
,"20":"Dios atenderá y los humillará, el que reina desde siempre. ¿Podrán convertirse si no temen a Dios?"
,"21":"Alzan la mano contra sus amigos, no cumplen sus compromisos,"
,"22":"su boca es más untuosa que una crema,pero su corazón es agresivo; sus palabras, más suaves que el aceite, son espadas desenvainadas."
,"23":"Descarga en el Señor todo tu peso, porque él te sostendrá; no dejará que el justo se hunda para siempre."
,"24":"Tú, oh Dios, los echarás al pozo de la muerte; los hombres sanguinarios y embusteros, no llegarán a la mitad de su vida; pero yo confío en ti."
}`)
	CurrentBook.AddChapter(56, `{
"2":"Oh Dios, ten piedad de mí, que me hostigan; me acosan asaltantes todo el día,"
,"3":"me hostigan todo el día y miran cómo me debato. ¡Qué numerosos son mis adversarios!"
,"4":"En ti pondré, oh Altísimo, mi confianza el día que tenga miedo."
,"5":"Renuevo mi fe en las palabras de Dios, confío en Dios y no temo más: ¿qué me puede hacer un ser de carne?"
,"6":"Oigo todo el día palabras hirientes, no piensan más que en hacerme daño."
,"7":"Se agrupan, se ocultan, me siguen el rastro, se lanzan a la caza de mi vida."
,"8":"Después de tanta maldad, que no se escapen, que sobre ellos recaiga, oh Dios, la furia de los paganos."
,"9":"Tu contaste mis disgustos, recogiste mis lágrimas en tu odre."
,"10":"Retrocederán mis enemigos el día que te invoque. Sé muy bien que Dios está conmigo."
,"11":"Mi fe renuevo en las palabras de Dios, tengo fe en la palabra del Señor;"
,"12":"confío en Dios y no temo más, ¿qué puede hacerme un hombre?"
,"13":"No me olvido, oh Dios, de mis promesas, te ofreceré sacrificios para darte gracias,"
,"14":"porque me sacaste de la muerte; no dejaste que diera un paso en falso. En presencia de Dios seguiré caminando a la luz de los vivos."
}`)
	CurrentBook.AddChapter(57, `{
"2":"Piedad de mí, oh Dios, piedad de mí, pues en ti se refugia el alma mía; a la sombra de tus alas me cobijo hasta que haya pasado la tormenta."
,"3":"Yo clamo al Dios Altísimo, al Dios que de mí cuida."
,"4":"Que del cielo mande alguien a salvarme de las manos de aquellos que me acosan; envíe Dios su gracia y su verdad."
,"5":"Yo duermo rodeado de leones, que devoran a los hijos de los hombres; sus dientes son lanzas y flechas, su lengua es una espada acerada."
,"6":"Muéstrate, oh Dios, por encima de los cielos, y que brille tu luz en toda la tierra."
,"7":"Habían tendido un lazo en mi camino, allí querían que cayera; ante mí cavaron una trampa, pero ellos cayeron dentro."
,"8":"Oh Dios, mi corazón está dispuesto, mi corazón está atento, quiero cantar y tocar para ti."
,"9":"Despiértate, corazón mío, despiértense arpas y cítaras, que quiero a la aurora despertar."
,"10":"Te alabaré, Señor, entre los pueblos, te cantaré en todas las provincias,"
,"11":"pues tu amor está a la altura de los cielos y tu verdad se eleva hasta las nubes."
,"12":"Muéstrate, oh Dios, por encima de los cielos, y que brille tu gloria en toda la tierra."
}`)
	CurrentBook.AddChapter(58, `{
"2":"Dioses, ¿será verdad que hacen justicia y gobiernan como es justo a los hijos de los hombres?"
,"3":"Pero no, de adrede cometen injusticia y sus manos imponen al país la violencia."
,"4":"Desde el seno materno andan descarriados los impíos; desde el vientre de su madre se desvían los que dicen la mentira."
,"5":"Su veneno es veneno de serpiente, son sordos como el áspid que se tapa el oído"
,"6":"para no oír la voz del encantador, del que doma a las serpientes."
,"7":"Oh Dios, rompe los dientes de su boca; quiebra, Señor, sus colmillos de leones."
,"8":"Que se escurran como agua de un vaso roto, que se sequen como hierba pisoteada."
,"9":"Que sean cual babosa que se va deshaciendo, o como el aborto que no ha visto el sol,"
,"10":"como zarza quemada antes de que claven sus espinas: ¡que los arrebate un torbellino!"
,"11":"¡Qué alegría la del justo al ver la venganza! Lavará sus pies en la sangre del impío."
,"12":"Y dirán: '¡Sí, se gana con ser justo; sí, hay un Dios para juzgar al mundo!'"
}`)
	CurrentBook.AddChapter(59, `{
"2":"¡Dios mío, líbrame de mis enemigos, protégeme de mis agresores;"
,"3":"líbrame de los que hacen la maldad, sálvame de los hombres criminales!"
,"4":"Mira cómo acechan a mi vida, cuántos poderosos se juntan contra mí. Señor, en mí no hay crimen ni pecado, "
,"5":"pero sin falta mía acuden y se aprestan. Despiértate, ven a mi encuentro y mira."
,"6":"Señor, Dios Sabaot, Dios de Israel, despiértate, castiga a esos paganos, sé inclemente con todos esos renegados."
,"7":"Vuelven de tarde, ladran como perros, andan dando vueltas por la ciudad."
,"8":"A toda boca dicen barbaridades, de sus labios salen como espadas: '¡Escuche Dios, si puede!'"
,"9":"Pero tú, Señor, te burlas de ellos, te ríes de esos incrédulos."
,"10":"Oh tú, mi fuerza, hacia ti miro, pues Dios es mi ciudadela."
,"11":"Si mi Dios viene a mí en su bondad, me hará ver la pérdida de los que me espían."
,"12":"Oh Dios, ordena su masacre, pues tu pueblo no debe olvidarlo. Tú, tan valiente, persíguelos y mátalos, oh Señor, nuestro escudo."
,"13":"No hay palabra de sus labios que en su boca no sea pecado. Quedarán atrapados en su orgullo, en los insultos y mentiras que pronuncian."
,"14":"En tu furor aplástalos, destrúyelos y que ya no existan más. Entonces se sabrá que Dios reina en Jacob y hasta los confines de la tierra."
,"15":"Que a la tarde regresen, que ladren como perros, que anden dando vueltas por la ciudad"
,"16":"a la caza de algo que comer y que gruñan si no se repletan."
,"17":"Pero yo cantaré tu poder, y desde la mañana contaré tus bondades; porque tú has sido para mí una ciudadela y mi refugio en el día de la angustia."
,"18":"Oh fuerza mía, yo quiero cantarte; mi Bastión es un Dios siempre bueno conmigo."
}`)
	CurrentBook.AddChapter(60, `{
"3":"Oh Dios, nos rechazaste, nos hiciste pedazos, tú estabas enojado, pero vuelve a nosotros."
,"4":"Sacudiste la tierra, la partiste; repara sus grietas, pues se hunde."
,"5":"Impusiste a tu pueblo duras pruebas, nos diste a beber vino embriagante."
,"6":"Portabas la bandera de los que te temen, pero la pusiste detrás para que huyeran del arco."
,"7":"Libera ahora a los que tú amas, sálvanos con tu diestra y respóndenos."
,"8":"Dios ha hablado en su santuario: 'Salto de gozo, voy a repartir Siquem y a lotear el valle de Sucot."
,"9":"Míos serán Galaad y Manasés, Efraín será el casco de mi cabeza, Judá será mi bastón de mando."
,"10":"Moab será la vasija en que me lavo; a Edom le lanzo mi sandalia, y oyen mi grito de guerra los filisteos.'"
,"11":"¿Quién me guiará hasta la ciudad fuerte? ¿quién me conducirá hasta Edom?"
,"12":"¿Quién sino tú, oh Dios, que nos rechazaste y que no sales más con nuestras tropas?"
,"13":"Danos tu ayuda contra el enemigo, pues de nada sirve la ayuda del hombre."
,"14":"Junto con Dios haremos maravillas, él pisoteará a nuestros adversarios."
}`)
	CurrentBook.AddChapter(61, `{
"2":"Oh Dios, escucha mi clamor, atiende a mi plegaria."
,"3":"Desde el confín de la tierra yo te grito, mientras el corazón me desfallece."
,"4":"Llévame a la roca muy alta para mí, pues tú eres mi refugio, una torre poderosa ante el enemigo."
,"5":"Quiero compartir tu tienda para siempre, cobijarme en el repliegue de tus alas."
,"6":"Pues tú, oh Dios, escuchaste mis votos; cumples el deseo de los que temen tu nombre."
,"7":"Prolonga los días del rey, multiplícalos, que vea transcurrir generaciones."
,"8":"Que reine y sirva a Dios eternamente, que lo guarden tu gracia y fidelidad."
,"9":"Entonces cantaré por siempre a tu nombre y cumpliré mis promesas día tras día."
}`)
	CurrentBook.AddChapter(62, `{
"2":"En Dios sólo descansa el alma mía, de él espero mi salvación."
,"3":"Sólo él es mi roca y mi salvador, si es mi fortaleza, no he de vacilar."
,"4":"¿Hasta cuándo se lanzan todos contra uno, para juntos demolerlo,como se echa abajo un muro, como se derriba una cerca?"
,"5":"Todos sus proyectos son sólo engaños, su placer es mentir; con lo falso en la boca ellos bendicen, y en su interior maldicen."
,"6":"Sólo en Dios tendrás tu descanso, alma mía, pues de él me viene mi esperanza."
,"7":"Sólo él es mi roca y mi salvador, si es mi fortaleza, no he de vacilar."
,"8":"En Dios están mi salvación y mi gloria, él es mi roca y mi fuerza, en él me abrigo."
,"9":"Pueblo mío, confíen siempre en él, abran su corazón delante de él, Dios es nuestro refugio."
,"10":"El vulgo no es más que una pelusa, y de los de arriba no se puede fiar. Si en la balanza se pusieran todos, ni un soplo pesarían"
,"11":"No vayan a contar con la violencia,ni se hagan ilusiones con la rapiña; el corazón no apeguen,a las riquezas cuando se acrecientan."
,"12":"Una vez Dios habló, dos cosas yo entendí: Que de Dios es la fuerza, y tuya es, oh Señor, también la gracia. Que eres tú quien retribuye,a cada cual según sus obras."
}`)
	CurrentBook.AddChapter(63, `{
"2":"Oh Dios, tú eres mi Dios, a ti te busco, mi alma tiene sed de ti; en pos de ti mi carne languidece,cual tierra seca, sedienta, sin agua."
,"3":"Por eso vine a verte en el santuario,para admirar tu gloria y tu poder."
,"4":"Pues tu amor es mejor que la vida, mis labios tu gloria cantarán."
,"5":"Quiero bendecirte mientras viva,y con las manos en alto invocar tu Nombre."
,"6":"Mi alma está repleta, saciada y blanda, y te alaba mi boca con labios jubilosos."
,"7":"Cuando estoy en mi cama pienso en ti, y durante la noche en ti medito,"
,"8":"pues tú fuiste un refugio para mí,y salto de gozo a la sombra de tus alas."
,"9":"Mi alma se estrecha a ti con fuerte abrazo,y tu diestra me toma de la mano."
,"10":"Los que en vano quieren perderme,irán a parar debajo de tierra."
,"11":"Serán muertos al filo de la espada, servirán de festín a los chacales."
,"12":"El rey se sentirá feliz en Dios, y cuantos juran por él se gloriarán: 'Por fin se acalló a los mentirosos'."
}`)
	CurrentBook.AddChapter(64, `{
"2":"Escucha, oh Dios, mi voz cuando me quejo; me amenaza el enemigo, guarda mi vida;"
,"3":"escóndeme del complot de los malvados y de las maniobras de los criminales."
,"4":"Afilaron sus lenguas como espada, tienen sus flechas, palabras de amenaza,"
,"5":"que tiran a ocultas contra el inocente, las lanzan de improviso y sin miedo."
,"6":"Se animan entre sí para hacer el mal, estudian cómo disimular la trampa y dicen: '¿Quién verá"
,"7":"o quién descubrirá nuestros secretos?',Los sacará a la luz el que escudriña el fondo del hombre, lo profundo del ser."
,"8":"Pero Dios les lanza sus flechas, y se ven heridos de repente."
,"9":"Sus propias palabras los hicieron caer y los que los ven los miran sin piedad."
,"10":"Cada cual entonces empieza a temer, dice en voz alta que es obra de Dios, y comprende su acción."
,"11":"El justo se alegrará en el Señor y en él confiará; se congratularán todos los de recto corazón."
}`)
	CurrentBook.AddChapter(65, `{
"2":"En Sión, oh Dios, conviene alabarte,y en Jerusalén cumplir nuestras promesas,"
,"3":"pues tú has oído la súplica. Todo mortal viene a ti con sus culpas a cuestas; nuestros pecados nos abruman,pero tú los perdonas."
,"5":"Feliz tu invitado, tu elegido,para hospedarse en tus atrios. Sácianos con los bienes de tu casa, con las cosas sagradas de tu Templo."
,"6":"Tú nos responderás, como es debido, con maravillas, Dios Salvador nuestro, esperanza de las tierras lejanas,y de las islas de ultramar,"
,"7":"tú que fijas los montes con tu fuerza,y que te revistes de poder."
,"8":"Tú calmas el bramido de los mares,y el fragor de sus olas; tú calmas el tumulto de los pueblos."
,"9":"Tus prodigios espantan a los pueblos lejanos, pero alegran las puertas,por donde el sol nace y se pone."
,"10":"Tú visitas la tierra y le das agua, tú haces que dé sus riquezas. Los arroyos de Dios rebosan de agua,para preparar el trigo de los hombres. Preparas la tierra, "
,"11":"regando sus surcos, rompiendo sus terrones, las lluvias la ablandan, y bendices sus siembras."
,"12":"Coronas el año de tus bondades, por tus senderos corre la abundancia;"
,"13":"las praderas del desierto reverdecen, las colinas se revisten de alegría;"
,"14":"sus praderas se visten de rebaños,y los valles se cubren de trigales, ¡ellos aclaman, o mejor, ellos cantan!"
}`)
	CurrentBook.AddChapter(66, `{
"2":"Aclamen a Dios en toda la tierra, canten salmos a su glorioso nombre, hagan alarde de sus alabanzas."
,"3":"Digan a Dios: ¡Qué terribles son tus obras!,Tu fuerza es tal que tus enemigos,se convierten en tus aduladores."
,"4":"Toda la tierra ante ti se inclina, te canta y celebra tu Nombre."
,"5":"Vengan a ver las obras de Dios: sus milagros que a los hombres espantan."
,"6":"Transforma el mar en tierra firme, por el río pasaron caminando; ¡Que para él sean nuestros festejos, para el Valiente, siempre vencedor!"
,"7":"Con sus ojos vigila a las naciones,no sea que se alcen los rebeldes."
,"8":"Bendigan, pueblos, a nuestro Dios, que se escuchen sus voces, que lo alaban,"
,"9":"porque él nos ha devuelto a la vida,y no dejó que tropezaran nuestros pies."
,"10":"¿Oh Dios, por qué nos examinaste,y nos pusiste en el crisol como la plata?"
,"11":"Nos hiciste caer en la trampa,y la angustia nos apretó el estómago."
,"12":"Dejaste que un cualquiera,cabalgara sobre nuestras cabezas, por el fuego y por el agua hemos pasado,pero, al fin, nos has hecho respirar."
,"13":"Llegaré hasta tu Casa con holocaustos, y te cumpliré mis votos,"
,"14":"que en mi angustia mis labios pronunciaron,y ratificó mi boca."
,"15":"Te ofreceré animales bien cebados, hacia ti subirá el humo de los corderos, te inmolaré bueyes y chivos."
,"16":"Vengan a oírme los que temen a Dios, les contaré lo que hizo por mí."
,"17":"Mi boca le gritaba alabanzas,pues estaban debajo de mi lengua."
,"18":"Si hubiere visto maldad en mi corazón, el Señor no me habría escuchado."
,"19":"Pero Dios me escuchó,y atendió a la voz de mi plegaria."
,"20":"¡Bendito sea Dios, que no desvió mi súplica,ni apartó de mi su amor!"
}`)
	CurrentBook.AddChapter(67, `{
"2":"¡Que Dios tenga piedad y nos bendiga, nos ponga bajo la luz de su rostro!"
,"3":"Para que conozcan en la tierra tu camino, tu salvación en todas la naciones."
,"4":"Que los pueblos te den gracias, oh Dios, que todos los pueblos te den gracias."
,"5":"Que los poblados se alegren y te canten. Pues tú juzgas los pueblos con justicia, tú riges a los pueblos de la tierra."
,"6":"Que los pueblos te den gracias, oh Dios, que todos los pueblos te den gracias."
,"7":"Ha entregado la tierra su cosecha, Dios, nuestro Dios, nos dio su bendición;"
,"8":"que nos bendiga Dios, y sea temido,hasta los confines de la tierra."
}`)
	CurrentBook.AddChapter(68, `{
"2":"Que Dios se pare y sus enemigos se dispersen, que huyan ante él los que lo odian."
,"3":"Como humo al viento, así tú los disipas, como cera en el fuego se deshacen."
,"4":"En presencia de Dios los malos perecen, mientras que los justos se regocijan, y ante Dios saltan y gritan de alegría."
,"5":"Canten a Dios y toquen a su Nombre, abran camino al que cabalga en las nubes, alégrense en Dios y bailen ante él."
,"6":"Padre del huérfano, defensor de las viudas, ese es Dios en su santa morada."
,"7":"Al solitario le da el calor de hogar, deja libre al preso encadenado, a los rebeldes los deja en calabozos."
,"8":"Oh Dios, cuando saliste al frente de tu pueblo, para tomar el camino del desierto,"
,"9":"la tierra tembló y los cielos destilaron en presencia de Dios, el Dios de Israel."
,"10":"Esparciste una lluvia generosa para reanimar a los tuyos extenuados,"
,"11":"tu familia encontró una morada, la que en tu bondad destinabas a los pobres."
,"12":"El Señor ha mandado una palabra, y es buena noticia para el gran ejército:"
,"13":"¡Huyen, huyen los reyes con sus tropas! Una sirvienta reparte el botín:"
,"14":"alas de paloma cubiertas de plata, con sus plumas color de oro."
,"15":"Mientras el Omnipotente vencía a los reyes, caía nieve en el monte Salmón."
,"16":"Montes de Dios, montes de Basán, montes escarpados, montes de Basán:"
,"17":"¿por qué miran celosos, montes escarpados, al monte que Dios quiso habitar?,Sepan que el Señor lo habita para siempre."
,"18":"Los carros de Dios son miles y miles, en ellos vino del Sinaí al Santuario."
,"19":"Subiste a las alturas, tomaste cautivos, y recibiste hombres en tributo. Hasta los rebeldes se quedarán a tu lado."
,"20":"¡Bendito sea el Señor día tras día! El Dios que salva se encarga de nosotros."
,"21":"Se hizo para nosotros un Dios que libera, con Yahvé, el Señor, escapamos a la muerte."
,"22":"Dios aplasta la cabeza de sus enemigos, el cráneo de los habituados al crimen."
,"23":"El Señor lo dijo: 'Los traeré de Basán y de las profundidades del mar,"
,"24":"para que hundas los pies en su sangre y hasta la lengua de tus perros reciba su parte de los enemigos.'"
,"25":"He visto, oh Dios, tus procesiones, las procesiones de mi Dios, de mi rey, en el santuario."
,"26":"Los cantores van delante, los músicos detrás, en medio van las niñas tocando tamboriles."
,"27":"¡Bendigan a Dios con coros, bendigan al Señor en las fiestas de Israel!"
,"28":"Benjamín, el menor, abre el cortejo, los príncipes de Judá con ropas bordadas, los príncipes de Zabulón, los de Neftalí."
,"29":"Oh Dios, habla con fuerza, con la fuerza que manifestaste con nosotros."
,"30":"Desde tu templo que domina Jerusalén, donde los reyes te aportan sus ofrendas,"
,"31":"amenaza al monstruo de los cañaverales, al tropel de toros, a los dueños de los pueblos para que se sometan y te ofrezcan oro y plata. Dispersa a los pueblos que aman la guerra."
,"32":"Desde Egipto vendrán los más ricos, Etiopía tenderá a Dios sus manos."
,"33":"Reinos de la tierra, canten a Dios, toquen para el Señor,"
,"34":"que cabalga por los cielos seculares. ¡Oigan su voz, su voz que es poderosa!"
,"35":"Reconozcan el poder de Dios, él es grande en Israel, y en lo alto, poderoso."
,"36":"Dios es terrible desde su santuario, él, el Dios de Israel, él da a su pueblo fuerza y poder."
}`)
	CurrentBook.AddChapter(69, `{
"2":"Oh Dios, sálvame, que las aguas me llegan hasta el cuello."
,"3":"Me estoy hundiendo en un cieno profundo, y no hay dónde apoyarme. Me vi arrastrado a profundas aguas y las olas me cubren."
,"4":"Me agoto de gritar, me arde la garganta, y mis ojos se cansan de esperar a mi Dios."
,"5":"Más que los cabellos de mi cabeza son los que me odian sin motivo. Son más fuertes que yo los que con calumnias me persiguen. ¿Cómo devolveré lo que no he robado?"
,"6":"Tú sabes, oh Dios, si me he extraviado, pues no te están escondidos mis errores."
,"7":"No avergüences por mí a los que en ti esperan, Señor, Dios Sabaot, ni humilles por causa mía a los que te buscan, oh Dios de Israel."
,"8":"Por ti fue que soporté el insulto, y la vergüenza me cubrió la cara;"
,"9":"me volví como un extraño a mis hermanos, un desconocido para los hijos de mi madre."
,"10":"El celo por tu casa me devora, los insultos de los que te insultan recaen sobre mí."
,"11":"Si me aflijo con ayunos, eso me vale insultos;"
,"12":"si me visto de saco, ellos se burlan de mí."
,"13":"Se ríen de mí los que se sientan en la plaza, y a los bebedores doy un tema de canción."
,"14":"Pero a ti, oh Dios, sube mi oración, sea ése el día de tu favor. Según tu gran bondad, oh Dios, respóndeme, sálvame tú que eres fiel."
,"15":"Sácame del barro, que no me hunda; líbrame del vértigo del agua profunda."
,"16":"Que las olas no me sumerjan, ni me trague el torbellino ni el pozo cierre sobre mí su boca."
,"17":"Respóndeme, Señor, pues tu amor es bondad, vuélvete hacia mí por tu gran misericordia."
,"18":"No escondas a tu siervo tu rostro, me siento angustiado, respóndeme pronto."
,"19":"Ven, acércate a mí y rescátame, líbrame de tantos enemigos."
,"20":"Tú conoces mi humillación, mis adversarios están todos a tu vista."
,"21":"Tanta ofensa me ha partido el corazón, mi vergüenza y confusión son irremediables. Esperé compasión, pero fue en vano, alguien que me consolara, y no lo hallé."
,"22":"En mi comida me echaron veneno, y para la sed me dieron vinagre."
,"23":"Que un traidor los invite a cenar, y se vuelva una trampa su banquete."
,"24":"Que pierdan la vista y queden a ciegas, que siempre caminen encorvados."
,"25":"Arroja sobre ellos tu furor, que los alcance el fuego de tu ira."
,"26":"Que su propiedad quede devastada y sus carpas sin habitantes,"
,"27":"porque persiguieron al que tú heriste y aumentaron los dolores de tu víctima."
,"28":"Impútales falta tras falta y que de ellas nunca se libren;"
,"29":"sean borrados del libro de los vivos, no sean inscritos en la lista de los justos."
,"30":"¡Pero a mí, humillado y afligido, que me levante, oh Dios, tu ayuda!"
,"31":"Celebraré con un canto el nombre de Dios, proclamaré sus grandezas, le daré gracias."
,"32":"Esto le agradará al Señor más que una víctima, más que un ternero con cuernos y pezuñas."
,"33":"Vean esto, los humildes, y regocíjense. ¡Reanímense, los que buscan al Señor!"
,"34":"Pues el Señor escucha a los pobres, no desdeña a los suyos prisioneros."
,"35":"Que lo aclamen los cielos y la tierra, los mares y cuanto bulle en su interior."
,"36":"Pues Dios salvará a Sión y reconstruirá las ciudades de Judá: allí habrá de nuevo casas y propiedades."
,"37":"Los hijos de sus siervos serán los herederos, y allí morarán los que aman su Nombre."
}`)
	CurrentBook.AddChapter(70, `{
"2":"Dígnate, oh Dios, librarme; apresúrate, Señor, en socorrerme."
,"3":"Queden avergonzados y humillados los que buscan mi muerte. Que retrocedan, confundidos, los que se alegran con mi desgracia."
,"4":"Que se escondan de vergüenza los que dicen: '¡Esta vez lo pillamos!'"
,"5":"Pero que en ti se alegren y regocijen todos los que te buscan; y los que esperan tu salvación repetirán: '¡El Señor ha sido grande!'"
,"6":"Tú ves cuán pobre soy y desdichado, oh Dios, ven a salvarme. ¡Tú eres mi socorro, mi liberador, Señor, no tardes más!"
}`)
	CurrentBook.AddChapter(71, `{
"1":"En ti, Señor, confío, que no quede decepcionado."
,"2":"En tu justicia tú querrás defenderme, inclina a mí tu oído y sálvame."
,"3":"Sé para mí una roca de refugio, una ciudad fortificada en que me salve, pues tú eres mi roca, mi fortaleza."
,"4":"Líbrame, oh Dios, de la mano del impío, de las garras del malvado y del violento,"
,"5":"pues tú eres, Señor, mi esperanza, y en ti he confiado desde mi juventud."
,"6":"En ti me apoyé desde mis primeros pasos, tú me atrajiste desde el seno de mi madre, y para ti va siempre mi alabanza."
,"7":"Pero ahora para muchos soy un escándalo, y sólo me quedas tú, mi amparo seguro."
,"8":"Llena de tu alabanza está mi boca, de tu esplendor, el día entero."
,"9":"No me despidas ahora que soy viejo, no te alejes cuando mis fuerzas me abandonan."
,"10":"Pues mis enemigos hablan contra mí y los que esperan mi muerte hacen sus planes."
,"11":"Dicen: 'Dios lo ha abandonado; persíganlo y agárrenlo, nadie lo ayudará'."
,"12":"Oh Dios, no te alejes de mí, Dios mío, ven pronto a socorrerme."
,"13":"Que queden humillados, cubiertos de vergüenza, los que me ponen asechanzas. Que el insulto y la infamia envuelvan a los que quieren mi desgracia."
,"14":"Yo entonces, siempre en ti esperaré, y te alabaré como no se ha hecho nunca."
,"15":"Mi boca contará tus obras justas y tu salvación a lo largo del día, pues son más de lo que podría decir."
,"16":"Ahondaré las hazañas del Señor, recordaré tu justicia que es sólo tuya."
,"17":"Oh Dios, me has enseñado desde joven, y hasta ahora anuncié tus maravillas;"
,"18":"si ahora estoy viejo y decrépito, oh Dios, no me abandones. A esta generación anunciaré tu poder, y a los que vengan después, tu valentía "
,"19":"y tu justicia, oh Dios, que llega al cielo. Pues, ¿quién como tú, oh Dios, que has hecho grandes cosas?"
,"20":"Tú que me hiciste pasar tantas penas y miserias, volverás para hacerme revivir, y me harás subir de nuevo del abismo."
,"21":"Volverás a ponerme de pie y tendré de nuevo tu consuelo."
,"22":"Entonces te daré gracias al son del arpa por tu fidelidad, oh Dios. Con la cítara te entonaré salmos, oh Santo de Israel."
,"23":"Te aclamarán mis labios y mi alma que tú redimiste."
,"24":"Tarareará mi lengua todo el día: 'Es cierto que él es justo, pues están confundidos y humillados los que querían mi desgracia'."
}`)
	CurrentBook.AddChapter(72, `{
"1":"Oh Dios, comunica al rey tu juicio, y tu justicia a ese hijo de rey,"
,"2":"para que juzgue a tu pueblo con justicia,y a tus pobres en los juicios que reclaman."
,"3":"Que montes y colinas traigan al pueblo la paz y la justicia."
,"4":"Juzgará con justicia al bajo pueblo, salvará a los hijos de los pobres, pues al opresor aplastará."
,"5":"Durará tanto tiempo como el sol, como la luna a lo largo de los siglos."
,"6":"Bajará como la lluvia sobre el césped, como el chubasco que moja la tierra."
,"7":"Florecerá en sus días la justicia, y una gran paz hasta el fin de las lunas."
,"8":"Pues domina del uno al otro Mar, del Río hasta el confín de las tierras."
,"9":"Ante él se arrodillará su adversario, y el polvo morderán sus enemigos."
,"10":"Los reyes de Tarsis y de las islas,le pagarán tributo; los reyes de Arabia y de Etiopía,le harán llegar sus cuotas."
,"11":"Ante él se postrarán todos los reyes, y le servirán todas las naciones."
,"12":"Pues librará al mendigo que a él clama, al pequeño que de nadie tiene apoyo;"
,"13":"él se apiada del débil y del pobre, él salvará la vida de los pobres;"
,"14":"de la opresión violenta rescata su vida, y su sangre que es preciosa ante sus ojos."
,"15":"Que él viva, que le den oro de Arabia, y que sin tregua rueguen por él; lo bendecirán el día entero."
,"16":"¡Abundancia de trigo habrá en la tierra, que cubrirá la cima de los montes; que abunde en fruto como el Líbano, se multiplicarán como hierba de la tierra!"
,"17":"Que su nombre permanezca para siempre, y perdure por siempre bajo el sol. En él serán benditas,todas las razas de la tierra, le desearán felicidad todas las naciones."
,"18":"Bendito sea el Señor, Dios de Israel, pues sólo él hace maravillas."
,"19":"Bendito sea por siempre su nombre de gloria, que su gloria llene la tierra entera. ¡Amén, amén!"
,"20":"Aquí terminan las plegarias de David, hijo de Jesé."
}`)
	CurrentBook.AddChapter(73, `{
"1":"'Dios se porta muy bien con Israel,con los que tienen puro el corazón'."
,"2":"Pero yo, por poco mi pie no tropieza,y mis pasos casi se resbalan;"
,"3":"yo sentía envidia de los malos, viendo lo bien que le va a los impíos."
,"4":"Para ellos no existe el sufrimiento, su cuerpo está gordo y lleno de salud."
,"5":"No comparten las penurias de los hombres,ni les tocan pruebas como a los demás."
,"6":"Por eso como un collar lucen su orgullo, por ropa llevan puesta la violencia,"
,"7":"transpiran por sus poros la maldad, su corazón desborda de planes ambiciosos."
,"8":"Se burlan mientras traman sus maldades, con soberbia profieren amenazas;"
,"9":"hablan como dueños del cielo,y pretenden guiar a todo el país."
,"10":"Por eso mi pueblo va tras ellos, porque en ellos sólo brilla el éxito;"
,"11":"y dicen: '¿Dios lo verá?,¿Tendrá de esto idea el Altísimo?"
,"12":"Miren, pues, cómo son los impíos,y sin problemas amasan sus fortunas."
,"13":"¿De qué me sirve tener un corazón puro,y mantener mis manos inocentes,"
,"14":"cuando todos los días me apalean,y no hay mañana en que no me castiguen?'"
,"15":"Si hubiera dicho: 'Voy a hablar como ellos', habría traicionado la raza de tus hijos."
,"16":"Traté, pues, de poderlo comprender, pero era para mí cosa difícil."
,"17":"Pero un día penetré en los secretos de Dios, y me di cuenta de cuál será su fin."
,"18":"Pues los pones en un lugar resbaladizo,y luego los empujas al abismo."
,"19":"¿Cómo? ¿Están en la ruina en un momento?,Ya no están, trágico fue su fin."
,"20":"Señor, como de un sueño al despertar, te levantas y disipas su imagen."
,"21":"Cuando se exasperó mi corazón,y punzadas sentía en mis entrañas,"
,"22":"era estupidez, no cordura,y no comprendía más que las bestias."
,"23":"¿No he estado yo contigo todo el tiempo?,Me tomaste de mi mano derecha,"
,"24":"me guías conforme a tus designios,y me llevas de la mano tras de ti."
,"25":"¿A quién tengo en los cielos sino a ti?,y fuera de ti nada más quiero en la tierra."
,"26":"Mi carne y mi corazón se consumen por ti, mi Roca, mi Dios, que es mío para siempre."
,"27":"Los que se alejan de ti se pierden, tú aniquilas a los que te son infieles."
,"28":"Para mí lo mejor es estar junto a Dios, he puesto mi refugio en el Señor; proclamaré tus obras en las puertas de Sión."
}`)
	CurrentBook.AddChapter(74, `{
"1":"¿Por qué, oh Dios, esos continuos rechazos, y esa ira contra el rebaño de tu redil?"
,"2":"Acuérdate de tu comunidad, que antiguamente adquiriste y rescataste para que fuera tu tribu y heredad con el monte Sión donde tú moras."
,"3":"Dirige tus pasos a esas ruinas sin remedio; saqueó todo el enemigo en el santuario. Lanzaron alaridos en tu tienda, a la entrada pusieron la bandera extranjera."
,"5":"Lo derribaron todo con el hacha como leñadores en el bosque;"
,"6":"el enmaderado y sus esculturas los demolieron a machete y azuela."
,"7":"Prendieron fuego a tu santuario y profanaron la morada de tu Nombre."
,"8":"Dijeron: '¡Acabemos con ellos de una vez!' y en el país incendiaron todos los santuarios."
,"9":"Ya no vemos signos de ti, ya no hay profetas, y nadie entre nosotros que nos diga hasta cuando."
,"10":"¿Hasta cuándo, oh Dios, blasfemará el opresor y seguirá el enemigo ultrajando tu nombre?"
,"11":"¿Por qué retiras tu mano? ¿O la tienes tomada de la cintura?"
,"12":"¿No eres acaso desde siempre mi Dios, mi rey, tú, el autor de las liberaciones del país?"
,"13":"Tú con tu poder, dividiste el mar y aplastaste las cabezas de monstruos marinos."
,"14":"Rompiste las cabezas de Leviatán y lo diste por comida a las tortugas de mar."
,"15":"Tú hiciste brotar fuentes y torrentes, tú secaste ríos inagotables."
,"16":"Tuyo es el día y tuya es la noche, tú ajustas la luz y el sol."
,"17":"Pusiste todos los límites de la tierra, y formaste el invierno y el verano."
,"18":"No lo olvides: el enemigo insultó al Señor, un pueblo de locos ultrajó tu nombre."
,"19":"No entregues a las fieras el alma que te da gracias, no olvides para siempre la vida de tus pobres."
,"20":"Mira cómo han guardado tu alianza, en las cuevas del país, lugares de resistencia."
,"21":"Que el oprimido no vuelva avergonzado, que el pobre y el pequeño puedan alabar tu nombre."
,"22":"Levántate, oh Dios, y defiende tu causa, te insultan todo el día, no olvides a esos locos."
,"23":"No olvides el alboroto de tus adversarios y el clamor siempre creciente de tus agresores."
}`)
	CurrentBook.AddChapter(75, `{
"2":"Te damos gracias, oh Dios, te damos gracias, cuenten tus prodigios los que invocan tu nombre."
,"3":"'Déjenme fijar la fecha y yo haré el juicio, yo impondré la justicia.'"
,"4":"Se derrumba la tierra con sus habitantes, mas yo soy quien afianzó sus columnas."
,"5":"Digo a los arrogantes: '¡Ya basta de violencias!' y a los incrédulos: 'No alcen los cuernos,"
,"6":"no levanten tanto su cornamenta ni lancen desafíos contra la Roca'."
,"7":"Pues, he aquí que viene, no del oriente ni del occidente, ni del desierto ni de las montañas,"
,"8":"pero sí viene Dios, que es el juez, para humillar a unos y ensalzar a otros."
,"9":"En su mano el Señor tiene la copa de vino espumante y embriagador. La escancia y la vacian hasta la borra al beberla todos los malos de la tierra."
,"10":"Yo podría alargarme, no terminaría, cantaré salmos al Dios de Jacob:"
,"11":"aserruchará los cuernos de los malvados, y se alzarán los cuernos de los justos."
}`)
	CurrentBook.AddChapter(76, `{
"2":"En Judá Dios se ha dado a conocer, grande es su nombre en Israel,"
,"3":"pues en Salem está su tienda,y su morada en Sión."
,"4":"Allí rompió las flechas del arco, el escudo, la espada, las armas de la guerra."
,"5":"Allí estás radiante, majestuoso, triunfante sobre montañas de trofeos:"
,"6":"¡todo se les quitó!,Los valientes no despertaban de su sueño, el ejército entero, todos desfallecieron."
,"7":"Al oír tu amenaza, Dios de Jacob, carro y caballo quedaron petrificados."
,"8":"¡Qué terrible eres tú!,¿Quién te resistirá el día de tu ira?"
,"9":"Si en los cielos dictas la sentencia, la tierra se asusta y queda sin palabras."
,"10":"Dios entonces se levanta, hace justicia,y salva a todos los humildes de la tierra."
,"11":"El furor del hombre redundará en tu gloria, los que escapen de tu cólera te alabarán."
,"12":"¡Hagan votos al Señor, al Dios de ustedes, y vengan de todas partes a cumplirlos, traigan ofrendas para el Dios terrible!"
,"13":"El apaga el coraje de los príncipes,y es terrible para los reyes de la tierra."
}`)
	CurrentBook.AddChapter(77, `{
"2":"En voz alta clamo a Dios, en voz alta para que me escuche."
,"3":"Busqué al Señor en el momento de la prueba, de noche sin descanso hacia él tendí mi mano y mi alma se negó a ser consolada."
,"4":"No me acuerdo de Dios sin que no gima, si medito, una duda acosa mi espíritu."
,"5":"No me permite dormir, me perturbo y me faltan las palabras."
,"6":"Es que pienso en los días de otrora, en los tiempos antiguos."
,"7":"Y me acuerdo y por la noche mi corazón se atormenta, medito y mi espíritu se interroga:"
,"8":"¿Nos rechazará Dios para siempre y no reabrirá el tiempo de sus favores?"
,"9":"¿Ha clausurado su gracia para siempre y encerrado su palabra para el futuro?"
,"10":"¿Se ha olvidado Dios de su compasión o la cólera ha cerrado sus entrañas?"
,"11":"Y me dije: 'Lo que me traspasa es que ha cambiado la diestra del Altísimo'."
,"12":"Recuerdo las hazañas del Señor, recuerdo tus milagros de otros tiempos."
,"13":"En tus obras medito, una a una, y pienso en tus hazañas."
,"14":"¡Oh Dios, en tus obras todo es santo! ¿Qué dios es tan grande como nuestro Dios?"
,"15":"Tú eres el Dios que hace maravillas, tú demuestras tu fuerza entre los pueblos."
,"16":"Por tu brazo a tu pueblo rescataste, a los hijos de Jacob y de José."
,"17":"Oh Dios, las aguas te vieron, te vieron y se estremecieron, y hasta sus honduras enmudecieron."
,"18":"Las nubes descargaron aguaceros, las nubes hicieron oír su voz, mientras tus flechas se arremolinaban."
,"19":"Se oía de tu trueno el retumbar, tus relámpagos el mundo iluminaban, la tierra se asombraba y estremecía."
,"20":"Tu camino cruzaba por el mar, por aguas profundas corrían tus senderos, y nadie supo dar cuenta de tus huellas."
,"21":"Tú guiabas a tu pueblo, a tu rebaño, por la mano de Moisés y de Aarón."
}`)
	CurrentBook.AddChapter(78, `{
"1":"Atiende, pueblo mío, a mi enseñanza, toma en serio estas palabras de mi boca."
,"2":"En parábolas voy a abrir mi boca, evocaré los enigmas del pasado."
,"3":"Las cosas que escuchamos y sabemos, que nos fueron contando nuestros padres,"
,"4":"no deben ignorarlas nuestros hijos. A la futura generación le contaremos la fama del Señor y su poder, las maravillas que él ha realizado."
,"5":"En Jacob arraigó sus declaraciones, a Israel le dio una Ley. Luego ordenó a nuestros padres que se las enseñaran a sus hijos, "
,"6":"para que las conozcan sus sucesores, los hijos que nacerán después. Que éstos se encarguen de instruir a sus hijos "
,"7":"para que éstos confíen sólo en Dios, no olviden las hazañas de su Dios y observen sus mandatos."
,"8":"Para que no sean, a ejemplo de sus padres, una generación rebelde y obstinada, incapaz de mantener su decisión y cuyo espíritu no era fiel a Dios."
,"9":"Los hijos de Efraín, diestros arqueros, volvieron las espaldas el día del combate."
,"10":"Es que no respetaban la alianza de Dios, se habían negado a seguir su Ley."
,"11":"Habían olvidado sus hazañas, los prodigios que había hecho ante sus ojos."
,"12":"¡Qué milagros no hizo ante sus padres, en la tierra de Egipto, en los campos de Tanis!"
,"13":"Hendió el mar y los hizo pasar deteniendo las aguas como un dique."
,"14":"De día los guió con una nube y cada noche con una luz de fuego."
,"15":"Partió en medio las rocas del desierto y les dio de beber agua a torrentes."
,"16":"Hizo brotar arroyos de la piedra y las aguas corrieron como ríos."
,"17":"Mas de nuevo pecaron contra él, desafiaron al Altísimo en el desierto."
,"18":"Tentaron a Dios en sus corazones, pidiendo de comer para sobrevivir;"
,"19":"insultaron a Dios, diciendo: '¿Será Dios capaz de prepararnos la mesa en el desierto?"
,"20":"Es cierto que, cuando él golpeó la roca, corrió el agua y los torrentes desbordaron, pero, ¿será capaz de darnos pan, o de proporcionar carne a su pueblo?'"
,"21":"Al oírlo el Señor se encolerizó, un fuego se encendió contra Jacob y la cólera subió contra Israel,"
,"22":"porque no habían creído en Dios ni habían confiado en que los salvaría."
,"23":"Dio orden a las nubes en lo alto, abrió las compuertas de los cielos,"
,"24":"les envió como lluvia maná para comida, les dio trigo del cielo."
,"25":"Y el hombre comió el pan de los Fuertes, y El les envió de sobra provisiones."
,"26":"Hizo soplar en los cielos viento del este, y trajo con su poder el viento sur."
,"27":"Hizo llover sobre ellos la carne como polvo, aves innumerables como arena del mar."
,"28":"Hizo que cayeran dentro del campamento, en todo el derredor de sus carpas."
,"29":"Comieron hasta ya no poder más, él les sirvió de cuanto deseaban."
,"30":"Pero aún sus ansias no calmaban y todavía en su boca tenían su comida,"
,"31":"cuando estalló contra ellos la cólera de Dios: dio muerte a los más fuertes de los suyos, derribó a la flor y nata de Israel."
,"32":"A pesar de esto, pecaron nuevamente, no creían aún en sus maravillas."
,"33":"De un soplo, entonces, apagó sus días, trágicamente se acabaron sus años."
,"34":"Cuando él los masacraba, lo buscaban, se volvían y le hacían la corte;"
,"35":"se acordaban que Dios era su Roca y el Dios altísimo, su redentor."
,"36":"Pero todo se quedaba en palabras, y con su lengua sólo le mentían;"
,"37":"pues su corazón no se dio a fondo, ni tampoco tenían fe en su alianza."
,"38":"El, empero, siempre bueno y compasivo, perdonaba su culpa en vez de destruirlos, ¡cuántas veces no refrenó su cólera en vez de desatar toda su ira!"
,"39":"'Son seres de carne, se decía, soplo que se va y no volverá'."
,"40":"¡Cuántas veces lo desafiaron en el desierto y lo enervaron en esa soledad!"
,"41":"Nuevamente tentaron a su Dios y enojaron al Santo de Israel."
,"42":"No se acordaron más de su poder, del día en que los libró del adversario,"
,"43":"cuando hizo milagros en Egipto, prodigios en los campos de Tanis,"
,"44":"convirtió en sangre sus ríos, para que no bebieran de sus arroyos."
,"45":"Luego vinieron mosquitos que se los comían y ranas que les hicieron gran perjuicio."
,"46":"Entregó sus cosechas al pulgón y el fruto de su trabajo a las langostas."
,"47":"Echó a perder sus viñas con granizo y sus sicómoros con la helada."
,"48":"Dejó sus rebaños a merced del granizo y el rayo tumbó sus ganados."
,"49":"Lanzó sobre ellos el ardor de su cólera, ira, furor, angustia: ¡un buen envío de ángeles de desdichas!"
,"50":"Dio rienda suelta a su cólera, no preservó sus vidas de la muerte y los entregó a la peste."
,"51":"Mató a los primogénitos de Egipto, a todo hijo mayor en las carpas de Cam."
,"52":"Luego sacó a su pueblo como ovejas, los guió, como rebaño, en el desierto;"
,"53":"los condujo seguros, sin temor, mientras que el mar cubría a sus enemigos."
,"54":"Los introdujo en su santo territorio, la montaña que su diestra conquistó."
,"55":"Expulsó en su presencia a las naciones, les asignó a cordel una heredad y en carpas ajenas instaló a las tribus de Israel."
,"56":"Mas tentaron a Dios, el Altísimo, se rebelaron contra él, no hicieron caso de sus advertencias."
,"57":"Se corrían y traicionaban como sus padres, le fallaban como arco que no apunta."
,"58":"Lo irritaron con sus sitios de culto y con sus ídolos lo pusieron celoso."
,"59":"Dios los oía, y se indignó, y rechazó totalmente a Israel;"
,"60":"abandonó su morada de Silo, que era su tienda, plantada entre los hombres."
,"61":"Permitió que se llevaran cautivo su poder y en manos enemigas cayera su gloria."
,"62":"Tanto era su enojo con los suyos que entregó su pueblo a la espada;"
,"63":"el fuego devoró a su juventud y sus niñas solteras se quedaron;"
,"64":"sus sacerdotes cayeron por la espada y sus viudas no se lamentaron."
,"65":"Pero se despertó el Señor como de un sueño, como un valiente que ha dormido la mona,"
,"66":"hirió a sus enemigos por la espalda, los dejó humillados para siempre."
,"67":"Descartó luego a la tienda de José y no eligió a la tribu de Efraín,"
,"68":"mas escogió a la tribu de Judá, a ese monte Sión al que amaba."
,"69":"Construyó su santuario como las alturas, como la tierra, firme para siempre."
,"70":"Eligió a David, su servidor, lo sacó del redil de los corderos,"
,"71":"lo llamó cuando cuidaba a las ovejas para pastorear a Jacob, su pueblo."
,"72":"Fue su pastor con un corazón perfecto y con mano prudente los condujo."
}`)
	CurrentBook.AddChapter(79, `{
"1":"Oh Dios, los paganos han entrado en tu heredad, han profanado tu santuario, y a Jerusalén la han dejado en ruinas."
,"2":"Arrojaron los cuerpos de tus siervos como carroña a las aves de rapiña y la carne de tus fieles a las fieras."
,"3":"Derramaron la sangre como el agua en torno a Jerusalén y no había ningún sepulturero."
,"4":"Somos una vergüenza ante nuestros vecinos, objeto de risa y burla a nuestro derredor."
,"5":"¿Hasta cuándo, Señor, durará tu cólera? ¿Tus celos quemarán siempre como fuego?"
,"6":"Descarga tu furor sobre los paganos, sobre la gente que no te conoce, sobre los reinos que no invocan tu nombre."
,"7":"Pues devoraron a Jacob y asolaron tu dominio."
,"8":"No nos tengas rencor por faltas de nuestros padres, que tu misericordia corra a nuestro encuentro, pues ya no podemos más."
,"9":"Ayúdanos, oh Dios, salvador nuestro, en atención a la gloria de tu nombre; líbranos y perdona nuestros pecados en honor a tu nombre."
,"10":"¿Quieres que digan los paganos: '¿Dónde está su Dios?',Que bajo nuestros ojos conozcan los paganos cómo cobras venganza de la sangre derramada de tus siervos."
,"11":"Que hasta ti llegue la queja del prisionero; con tu potente brazo salva a los condenados a muerte."
,"12":"Paga a nuestros vecinos siete veces los insultos que te lanzaron, Señor."
,"13":"Y nosotros, tu pueblo, el rebaño de tu redil, te daremos gracias para siempre; de edad en edad diremos tu alabanza."
}`)
	CurrentBook.AddChapter(80, `{
"2":"Escucha, pastor de Israel, que guías a José como un rebaño, tú que te sientas en los querubines"
,"3":"resplandece delante de Efraín, Benjamín y Manasés. ¡Despierta tu valentía, ven y sálvanos!"
,"4":"¡Oh Dios, retómanos en tus manos, haz brillar tu faz y sálvanos!"
,"5":"¿Hasta cuándo, Señor, Dios de los ejércitos, vas a desconsiderar las oraciones de tu pueblo?"
,"6":"Le diste por comida un pan de lágrimas, han bebido sus lágrimas hasta saciarse."
,"7":"Somos la presa que se arrebatan nuestros vecinos, y nuestros enemigos se burlan de nosotros."
,"8":"¡Oh Dios de los ejércitos, restablécenos, haz brillar tu faz y sálvanos!"
,"9":"Tenías una viña que arrancaste de Egipto, para plantarla, expulsaste naciones."
,"10":"Delante de ella despejaste el terreno, echó raíces y repletó el país."
,"11":"De su sombra se cubrieron las montañas y de sus pámpanos, los cedros divinos."
,"12":"Extendía sus sarmientos hasta el mar y sus brotes llegaban hasta el río."
,"13":"¿Por qué has destrozado sus cercos?,Cualquier transeúnte saca racimos, "
,"14":"el jabalí de los bosques la devasta y los animales salvajes la devoran."
,"15":"¡Oh Dios Sabaot, es hora de que regreses; mira de lo alto del cielo y contempla, visita esa viña"
,"16":"y protégela, ya que tu derecha la plantó!"
,"17":"Los que le prendieron fuego como basura, que perezcan al reproche de tu mirada."
,"18":"Que tu mano apoye al hombre que hace tus obras, al hijo de hombre que has hecho fuerte para ti."
,"19":"Ya no nos apartaremos más de ti, nos harás revivir y tu nombre invocaremos."
,"20":"¡Señor, Dios Sabaot, restablécenos, haz brillar tu faz y sálvanos!"
}`)
	CurrentBook.AddChapter(81, `{
"2":"¡Aviven a Dios, nuestra fuerza, aclamen al Dios de Jacob."
,"3":"Entonen los salmos y toquen los tambores, la melodiosa cítara y la lira!"
,"4":"Que suene el cuerno para el primero del mes, para la luna llena, el día de nuestra fiesta."
,"5":"Pues es una ley en Israel, una ordenanza del Dios de Jacob;"
,"6":"un decreto que impuso a José, cuando salió de la tierra de Egipto. Oyó, entonces, una voz desconocida:"
,"7":"'Yo quité la carga de su espalda, sus manos han dejado la canasta'"
,"8":"En la angustia gritaste y te salvé, te respondí en el secreto de la nube, te puse a prueba en las aguas de Meribá:"
,"9":"'Escucha, pueblo mío, te lo advierto, ojalá me escucharas, Israel:"
,"10":"No tengas en tu casa un dios extraño, ni te prosternes ante un dios de afuera:"
,"11":"Yo soy Yavé, tu Dios, que te hice subir de la tierra de Egipto. Abre tu boca y te la llenaré'."
,"12":"Pero mi pueblo no me quiso oír, e Israel no me obedeció."
,"13":"Los dejé, pues, que siguieran sus caprichos,y caminaran según su parecer."
,"14":"'Ah, si mi pueblo me escuchara, si Israel fuera por mis caminos,"
,"15":"sometería en un instante a sus enemigos, volvería mi mano contra sus opresores."
,"16":"Los enemigos del Señor le adularían,y su espanto jamás terminaría."
,"17":"Pero a él, con flor de trigo lo alimentaría,y con miel de la roca lo saciaría'."
}`)
	CurrentBook.AddChapter(82, `{
"1":"Se ha puesto Dios de pie en la asamblea divina,para dictar sentencia en medio de los dioses:"
,"2":"'¿Hasta cuándo juzgarán inicuamente,y tendrán miramientos con los malos?"
,"3":"Denle el favor al débil y al huérfano, hagan justicia al que sufre y al pobre;"
,"4":"si los ven tan débiles e indigentes, sálvenlos de la mano de los impíos'."
,"5":"Esta gente no sabe ni comprende, no dan más que vueltas en sus tinieblas, y las bases de la tierra se conmueven."
,"6":"Había dicho: 'Ustedes serán dioses, serán todos hijos del Altísimo'."
,"7":"Pero ahora como hombres morirán,y como seres de carne caerán'."
,"8":"Oh Dios, ponte de pie, juzga la tierra, pues tú dominas todas las naciones."
}`)
	CurrentBook.AddChapter(83, `{
"2":"Oh Dios, no descanses, no te calles; oh Dios, no te quedes impasible"
,"3":"cuando tus enemigos hacen estruendo y los que te odian levantan la cabeza."
,"4":"Traman un complot contra tu pueblo, conspiran contra tus protegidos."
,"5":"'Vengan, dicen, no sean más nación, y que nadie recuerde el nombre de Israel'."
,"6":"Se pusieron todos de acuerdo, sellaron una alianza contra ti:"
,"7":"los clanes de Edom y de Ismael, los de Moab y los hijos de Agar,"
,"8":"los de Guebal, Amón y de Amalec, los filisteos y la gente de Tiro;"
,"9":"hasta los de Asur se unieron a ellos y prestaron su fuerza a los hijos de Lot."
,"10":"Haz que corran la suerte de Madián, de Sísera y Jabín en el valle de Cisón,"
,"11":"que fueron exterminados junto a Endor, y de abono sirvieron a la tierra."
,"12":"Trata a sus príncipes como a Oreb y a Zeeb, y como a Zebaj y Salmana a sus capitanes,"
,"13":"que habían dicho: 'Nosotros conquistaremos los dominios de Dios'."
,"14":"Dios mío, trátalos como un torbellino, como paja llevada por el viento;"
,"15":"como incendio que arrasa con el bosque, como fuego que corre por los montes;"
,"16":"así persíguelos con tu tormenta y llénalos de terror con tu huracán."
,"17":"Cúbreles la cara de vergüenza, tal vez así, Señor, busquen tu nombre."
,"18":"Que se confundan y espanten para siempre, que sean humillados y perezcan."
,"19":"Sepan que sólo tú te llamas Señor, y eres Altísimo en toda la tierra."
}`)
	CurrentBook.AddChapter(84, `{
"2":"¡Qué amables son tus moradas, Señor Sabaot!"
,"3":"Mi alma suspira y hasta languidece,por los atrios del Señor; mi corazón y mi carne,gritan de alegría al Dios que vive."
,"4":"Hasta el pajarillo encuentra casa, y la alondra un nido, donde dejar sus polluelos: cerca de tus altares, Señor Sabaot, ¡oh mi Rey y mi Dios!"
,"5":"Felices los que habitan en tu casa, se quedarán allí para alabarte."
,"6":"Dichosos los hombres cuya fuerza eres tú,y que gustan de subir hasta ti."
,"7":"Al pasar por el valle de los Sauces, beben allí de la fuente,ya bendecida por las primeras lluvias;"
,"8":"pasan por las murallas una a una, hasta presentarse a Dios en Sión."
,"9":"¡Oh Señor, Dios Sabaot, escucha mi plegaria, oye con atención, Dios de Jacob!"
,"10":"Mira, oh Dios, nuestro escudo, contempla la cara de tu ungido."
,"11":"Vale por mil un día en tus atrios, y prefiero quedarme en el umbral, delante de la casa de mi Dios,antes que compartir la casa del malvado."
,"12":"El Señor es un baluarte y un escudo, el Señor dará la gracia y la gloria,a los que marchan rectamente: ninguna bendición les negará."
,"13":"¡Oh Señor Sabaot, feliz el que confía en ti!"
}`)
	CurrentBook.AddChapter(85, `{
"2":"Señor, has sido bueno con tu tierra: hiciste volver a los cautivos de Jacob."
,"3":"Suprimiste la deuda de tu pueblo, perdonaste totalmente su pecado."
,"4":"Depusiste todo tu furor, y volviste del ardor de tu cólera."
,"5":"Restablécenos, Dios, salvador nuestro, pon fin a tu resentimiento con nosotros."
,"6":"¿Estarás siempre irritado con nosotros, de edad en edad proseguirá tu cólera?"
,"7":"¿No volverás, acaso, a darnos vida,para que tu pueblo en ti se regocije?"
,"8":"¡Haz, Señor, que veamos tu bondad,y danos tu salvación!"
,"9":"Quiero escuchar lo que dice el Señor, pues Dios habla de paz,a su pueblo y a sus servidores, con tal que en su locura no recaigan."
,"10":"'Cerca está su salvación de los que le temen,y habitará su Gloria en nuestra tierra."
,"11":"La Gracia y la Verdad se han encontrado, la Justicia y la Paz se han abrazado;"
,"12":"de la tierra está brotando la verdad, y del cielo se asoma la justicia."
,"13":"El Señor mismo dará la felicidad, y dará sus frutos nuestra tierra."
,"14":"La rectitud andará delante de él, la paz irá siguiendo sus pisadas'"
}`)
	CurrentBook.AddChapter(86, `{
"1":"Escúchame, Señor, y respóndeme, pues soy pobre y desamparado;"
,"2":"si soy tu fiel, vela por mi vida, salva a tu servidor que en ti confía."
,"3":"Tú eres mi Dios; piedad de mí, Señor, que a ti clamo todo el día."
,"4":"Regocija el alma de tu siervo, pues a ti, Señor, elevo mi alma."
,"5":"Tú eres, Señor, bueno e indulgente, lleno de amor con los que te invocan."
,"6":"Señor, escucha mi plegaria, pon atención a la voz de mis súplicas."
,"7":"A ti clamo en el día de mi angustia, y tú me responderás."
,"8":"Nadie hay como tú, Señor, entre los dioses y nada que a tus obras se asemeje."
,"9":"Todos los paganos vendrán para adorarte y darán, Señor, gloria a tu nombre."
,"10":"Porque eres grande y haces maravillas, tú solo eres Dios."
,"11":"Tus caminos enséñame, Señor, para que así ande en tu verdad; unifica mi corazón con el temor a tu nombre."
,"12":"Señor, mi Dios, de todo corazón te daré gracias y por siempre a tu nombre daré gloria,"
,"13":"por el favor tan grande que me has hecho: pues libraste mi vida del abismo."
,"14":"Oh Dios, me echan la culpa los soberbios, una banda de locos busca mi muerte, y son gente que no piensan en ti."
,"15":"Mas tú, Señor, Dios tierno y compasivo, lento para enojarte, lleno de amor y lealtad,"
,"16":"vuélvete a mí y ten piedad de mí, otórgale tu fuerza a tu servidor y salva al hijo de tu sierva,"
,"17":"y para mi bien haz un milagro. Humillados verán mis enemigos que tú, Señor, me has ayudado y consolado."
}`)
	CurrentBook.AddChapter(87, `{
"1":"La ciudad que fundó en los montes santos,"
,"2":"las puertas de Sión, ama el Señor,más que todas las moradas de Jacob."
,"3":"De ti se dicen cosas admirables, ciudad de Dios."
,"4":"Hablamos entre amigos de Egipto y Babilonia, luego, de Tiro, Filistea y Etiopía: tal y cual han nacido aquí o allá."
,"5":"Mas de Sión se dirá: 'Es la madre, porque en ella todos han nacido,y quien la fundó es el Altísimo'."
,"6":"El Señor inscribe a los pueblos en el registro: 'Este en ella nació, éste también'."
,"7":"Mientras tanto en ti todos se alegran,con cantos y con bailes."
}`)
	CurrentBook.AddChapter(88, `{
"2":"Señor, mi Dios, te clamo a ti de día, y de noche me quejo en tu presencia."
,"3":"Que hasta ti llegue mi oración, presta atención a mi clamor."
,"4":"Pues de pruebas mi alma está saturada y mi vida está al borde del abismo."
,"5":"Me cuentan entre los que bajan a la fosa, soy un hombre acabado,"
,"6":"que ya tiene su cama entre los muertos, parecido a los cuerpos tirados en la tumba, de los cuales ya no te acuerdas, y que se han sustraído de tu mano."
,"7":"Me arrojaste a las cavernas inferiores, a las tinieblas, a los abismos;"
,"8":"tu cólera ha pesado sobre mí y me han arrollado todas tus olas."
,"9":"Alejaste de mí a mis conocidos, hiciste que me miraran con horror. Estoy encerrado y no puedo salir, "
,"10":"el sufrimiento mis ojos ha gastado. Señor, a ti clamo todo el día, y mis manos extiendo hacia ti."
,"11":"¿Harás milagros para los difuntos, se levantarán sus sombras para alabarte?"
,"12":"¿Se hablará de tu bondad entre los muertos, de tu lealtad donde todo está perdido?"
,"13":"¿Admirarán tus maravillas en lo oscuro, y tu justicia en la tierra del olvido?"
,"14":"Yo, por mi parte, clamo a ti, Señor, y de mañana sube a ti mi oración."
,"15":"¿Por qué, Señor, entonces, me rechazas y me escondes tu cara?"
,"16":"Soy pobre y enfermizo desde niño, sufrí tus golpes y me quedo sin fuerzas;"
,"17":"tus cóleras han pasado sobre mí, tus espantos me han aniquilado."
,"18":"Como las aguas me arrollan todo el día, y me cercan todos a la vez."
,"19":"De mí alejaste amigos y compañeros, y son mi compañía las tinieblas."
}`)
	CurrentBook.AddChapter(89, `{
"2":"El amor del Señor por siempre cantaré, tu fidelidad proclamaré de siglo en siglo;"
,"3":"yo digo: tu favor es eterno, al hacer el cielo, pusiste en él tu fidelidad."
,"4":"Una alianza hiciste con tu preferido, le juraste a David, tu servidor:"
,"5":"'Establecí tu linaje para siempre, asenté tu trono de siglo en siglo'"
,"6":"Señor, los cielos celebran tus maravillas, y tu fidelidad, la asamblea de los santos."
,"7":"Pues, en las nubes, ¿quién es igual al Señor? ¿Quién se le parece entre los hijos de los dioses?"
,"8":"Dios terrible en la asamblea de los santos, grande y temible para toda su corte."
,"9":"Señor, Dios Sabaot, ¿quién como tú? ¡Poderoso Señor, tu fidelidad te envuelve!"
,"10":"Tú dominas el orgullo de la mar; si levanta sus olas, tú las calmas."
,"11":"Tú aplastaste al Monstruo, y quedó tendido; tu brazo dispersó a tus enemigos."
,"12":"Tuyos son los cielos, tuya es la tierra; el mundo y su contenido tú lo fundaste."
,"13":"El norte y el sur tú los creaste, el Tabor y el Hermón celebran tu nombre."
,"14":"Tuyo es el poder y tuyas las hazañas, potente es tu mano, rápida tu derecha."
,"15":"Justicia y derecho son la base de tu trono, Amor y Fidelidad van delante de ti."
,"16":"Dichoso el pueblo que sabe aclamarte, y que avanza a la luz de tu faz, Señor;"
,"17":"tu Nombre es su alegría todo el día y lo ensalza tu justicia."
,"18":"Tú eres el brillo de su poder, de tu bondad nos viene la victoria."
,"19":"Nuestro escudo está en la mano del Señor nuestro rey, en manos del Santo de Israel."
,"20":"En una visión tú hablaste en otro tiempo refiriéndote a tu amigo, tú dijiste: 'He prestado mi apoyo a un valiente, lo he sacado del pueblo y exaltado."
,"21":"Encontré a David mi servidor, y lo ungí con óleo santo,"
,"22":"lo sostendrá mi mano y mi brazo lo fortalecerá."
,"23":"El enemigo no podrá sorprenderlo ni podrá el malvado oprimirlo."
,"24":"Aplastaré delante de él a sus agresores, les pegaré a los que lo odian."
,"25":"Mi fidelidad y mi amor lo acompañarán, mi Nombre le asegurará la victoria."
,"26":"Extenderé su mano sobre el mar, y sobre los ríos su derecha."
,"27":"El me podrá invocar: '¡Tú eres mi Padre, mi Dios y la roca donde me refugio!'"
,"28":"Haré de él mi primogénito, el más famoso de los reyes de la tierra."
,"29":"Para siempre mi amor le mantendré, y seré fiel a mi alianza con él."
,"30":"Estableceré su descendencia para siempre, y haré que su trono dure como los cielos."
,"31":"Si sus hijos abandonan mi ley y no andan según mis decisiones,"
,"32":"si profanan mis preceptos y no guardan mis mandamientos,"
,"33":"castigaré a varillazos su pecado y con golpes su falta;"
,"34":"pero mi amor no se lo quitaré ni renegaré de mi fidelidad."
,"35":"No romperé mi alianza ni cambiaré lo que salió de mis labios."
,"36":"Lo juré una vez por mi santidad: ¡Yo no le mentiría a David!"
,"37":"Su descendencia durará para siempre, su trono como el sol se mantendrá ante mí."
,"38":"Está allí para siempre como la luna, ese testigo fiel más allá de las nubes'."
,"39":"Pero tú lo rechazaste y repudiaste, te enojaste con tu ungido."
,"40":"Renegaste de la alianza con tu siervo y arrojaste por tierra su corona."
,"41":"Hiciste huecos en todos sus cercos, arruinaste sus fortificaciones."
,"42":"Los que pasan por el camino la saquean, y sus vecinos le faltan al respeto."
,"43":"Levantaste la diestra de sus adversarios y alegraste a sus enemigos."
,"44":"Sus armas se volvieron atrás, y no lo sostuviste en el combate."
,"45":"Hiciste caer el cetro de su mano y por tierra su trono derribaste."
,"46":"Acortaste los días de su juventud, y lo cubriste de vergüenza."
,"47":"¿Hasta cuándo, Señor, vas a ocultarte?,¿Arderá siempre como fuego tu enojo?"
,"48":"Recuerda, Señor, lo que es nuestra existencia, y para qué nada hiciste a los humanos."
,"49":"¿Quién vivirá y no verá la muerte? ¿Quién salvará su vida de las garras del abismo?"
,"50":"¿Dónde están, Señor, tus favores de antes, tus juramentos a David, tu fidelidad?"
,"51":"Recuerda, Señor, las afrentas a tus siervos, (llevo en mi seno todos esos ultrajes)"
,"52":"¡Cuántos insultos de tus enemigos, Señor, cómo insultan las huellas de tu ungido!"
,"53":"¡Bendito sea el Señor eternamente, Amén, amén!"
}`)
	CurrentBook.AddChapter(90, `{
"1":"Señor, tú has sido para nosotros,un refugio a lo largo de los siglos."
,"2":"Antes que nacieran las montañas,y aparecieran la tierra y el mundo, tú ya eras Dios y lo eres para siempre,"
,"3":"tú que devuelves al polvo a los mortales, y les dices:'¡Váyanse, hijos de Adán!'."
,"4":"Mil años para ti son como un día, un ayer, un momento de la noche."
,"5":"Tú los siembras, cada cual a su turno, y al amanecer despunta la hierba;"
,"6":"en la mañana viene la flor y se abre,y en la tarde se marchita y se seca."
,"7":"Por tu cólera somos consumidos, tu furor nos deja anonadados."
,"8":"Pusiste nuestras culpas frente a ti, nuestros secretos bajo la luz de tu rostro."
,"9":"Hizo correr tu cólera nuestros días, y en un suspiro se fueron nuestros años."
,"10":"El tiempo de nuestros años es de setenta, y de ochenta si somos robustos. La mayoría son de pena y decepción, transcurren muy pronto y nos llevan volando."
,"11":"¿Quién conoce la fuerza de tu cólera,y quién ha sondeado el fondo de tu furor?"
,"12":"Enséñanos lo que valen nuestros días, para que adquiramos un corazón sensato."
,"13":"Vuélvete, Señor, ¿hasta cuándo?. Compadécete de tus servidores."
,"14":"Cólmanos de tus favores por la mañana, que tengamos siempre risa y alegría."
,"15":"Haz que nuestra alegría dure lo que la prueba,y los años en que vimos la desdicha."
,"16":"Muestra tu acción a tus servidores,y a sus hijos, tu esplendor."
,"17":"Que la dulzura del Señor nos cubra,y que él confirme la obra de nuestras manos."
}`)
	CurrentBook.AddChapter(91, `{
"1":"Tú que habitas al amparo del Altísimo,y resides a la sombra del Omnipotente,"
,"2":"dile al Señor: 'Mi amparo, mi refugio, mi Dios, en quien yo pongo mi confianza'."
,"3":"El te librará del lazo del cazador,y del azote de la desgracia;"
,"4":"te cubrirá con sus plumas,y hallarás bajo sus alas un refugio."
,"5":"No temerás los miedos de la noche,ni la flecha disparada de día,"
,"6":"ni la peste que avanza en las tinieblas, ni la plaga que azota a pleno sol."
,"7":"Aunque caigan mil hombres a tu lado,y diez mil, a tu derecha, tú estarás fuera de peligro: su lealtad será tu escudo y armadura."
,"8":"Basta que mires con tus ojos,y verás cómo se le paga al impío."
,"9":"Pero tú dices: 'Mi amparo es el Señor', tú has hecho del Altísimo tu asilo."
,"10":"La desgracia no te alcanzará,ni la plaga se acercará a tu tienda:"
,"11":"pues a los ángeles les ha ordenado,que te escolten en todos tus caminos."
,"12":"En sus manos te habrán de sostener,para que no tropiece tu pie en alguna piedra;"
,"13":"andarás sobre víboras y leones,y pisarás cachorros y dragones."
,"14":"'Pues a mí se acogió, lo libraré, lo protegeré, pues mi Nombre conoció."
,"15":"Si me invoca, yo le responderé, y en la angustia estaré junto a él, lo salvaré, le rendiré honores."
,"16":"Alargaré sus días como lo desea,y haré que pueda ver mi salvación'."
}`)
	CurrentBook.AddChapter(92, `{
"2":"Es bueno dar gracias al Señor,y celebrar tu nombre, Dios Altísimo,"
,"3":"proclamar tu amor por la mañana,y tu fidelidad durante la noche,"
,"4":"con liras de diez cuerdas y cítara,y un suave acompañamiento de arpa."
,"5":"Pues me alegras, Señor, con tus acciones; yo exclamo al ver las obras de tus manos:"
,"6":"'¡Cuán grandes son tus obras, oh Señor, y cuán profundos son tus pensamientos!'"
,"7":"El de corazón torpe de esto nada sabe,y el insensato nada de esto entiende."
,"8":"Si brotan como hierba los impíos,o florecen aquellos que obran mal, es para que sean por siempre destruidos."
,"9":"Mas tú, Señor, dominas para siempre."
,"10":"¡Mira cómo perecen tus contrarios, cómo mueren, Señor, tus enemigos, y se dispersan todos los que hacen el mal!"
,"11":"Levantas mi cornamenta,como levanta el búfalo la suya, me haces masajes con aceite fresco;"
,"12":"miro con desprecio a los que me espían,y oigo, sin temor, a esos criminales."
,"13":"'El justo crecerá como palmera, se alzará como cedro del Líbano."
,"14":"Los plantados en la casa del Señor,darán flores en los patios de nuestro Dios."
,"15":"Aún en la vejez tendrán sus frutos,pues aún están verdes y floridos, para anunciar cuán justo es el Señor: El es mi Roca, en él no existe falla'."
}`)
	CurrentBook.AddChapter(93, `{
"1":"Reina el Señor, vestido de grandeza, el Señor se revistió de poder, lo ciñó a su cintura, el mundo está ahora firme e inamovible."
,"2":"Tu trono está erigido desde siempre, pues tú eres, Señor, desde la eternidad."
,"3":"Los ríos levantan, Señor, los ríos levantan su voz, los ríos levantan su fragor."
,"4":"Pero más que el fragor de las aguas, más grandioso que el oleaje de la mar,es el Señor, grandioso en las alturas."
,"5":"Nada hay más seguro que tus palabras, tu casa es el lugar de la santidad, oh Señor, día tras día y para siempre."
}`)
	CurrentBook.AddChapter(94, `{
"1":"¡Dios vengador, Señor, Dios vengador, manifiéstate!"
,"2":"Imponte tú, que juzgas a la tierra, dales su merecido a los soberbios."
,"3":"¿Hasta cuándo, Señor, esos malvados, hasta cuándo los malvados triunfarán?"
,"4":"Hablan mal, dicen insolencias, se jactan todos esos malhechores."
,"5":"Señor, aplastan a tu pueblo, oprimen a tu familia."
,"6":"Asesinan a la viuda y al forastero, masacran a los huérfanos,"
,"7":"y dicen: 'El Señor no ve nada, el Dios de Jacob no se enterará'."
,"8":"¡Cuidado, más estúpidos que cualquiera! ¡Tontos, ¿cuándo van a comprender?"
,"9":"Así que quien hace la oreja, no oirá y quien ha formado el ojo, no verá?"
,"10":"¿No castigará el que reprende a las naciones, y que enseña a los hombres el saber?"
,"11":"El Señor conoce los planes de los hombres y sabe que sólo viento son."
,"12":"¡Feliz el hombre que corriges, Señor, y al que tú enseñas tu Ley!"
,"13":"Le das calma en los días de desgracia, mientras cavan la tumba del malvado."
,"14":"Pues el Señor no rechaza a su pueblo, ni abandona a los suyos."
,"15":"Retornará el poder al que es Justo y con él, a los de recto corazón."
,"16":"¿Quién por mí se alzará contra los malos, quién por mí enfrentará a los malhechores?"
,"17":"Si el Señor no me hubiera socorrido, por poco no habría acabado entre los muertos."
,"18":"Apenas dije: '¡Vacilan mis pies!' tu bondad, Señor, me reafirmó."
,"19":"Cuando las preocupaciones me asediaban, tus consuelos me alegraban el alma."
,"20":"¿Tendrás por aliado a un poder inicuo, autor de leyes opresivas?"
,"21":"Conspiran contra la vida del justo y condenan la sangre inocente."
,"22":"Pero el Señor es para mí una ciudadela, mi Dios es la roca donde me refugio."
,"23":"Hará que sobre ellos recaiga su maldad y los aniquilará su propia malicia: el Señor, nuestro Dios, los aniquilará."
}`)
	CurrentBook.AddChapter(95, `{
"1":"Vengan, alegres demos vivas al Señor, aclamemos a la Roca que nos salva;"
,"2":"partamos a su encuentro dando gracias; aclamémosle con cánticos."
,"3":"Pues el Señor es un Dios grande, un rey grande por encima de todos los dioses."
,"4":"En su mano están las bases de la tierra,y son suyas las cumbres de los montes."
,"5":"Suyo es el mar, él fue quien lo creó, y la tierra firme, que formaron sus manos."
,"6":"¡Entremos, agachémonos, postrémonos; de rodillas ante el Señor que nos creó!"
,"7":"Pues él es nuestro Dios,y nosotros el pueblo que él pastorea, el rebaño bajo su mano. Ojalá pudieran hoy oír su voz."
,"8":"'No endurezcan sus corazones como en Meribá, como en el día de Masá en el desierto,"
,"9":"allí me desafiaron sus padres,y me tentaron, aunque veían mis obras."
,"10":"Cuarenta años me disgustó esa gente,y yo dije: 'Son un pueblo que siempre se escapa, que no han conocido mis caminos'."
,"11":"Por eso, en mi cólera juré: 'Jamás entrarán en mi reposo'."
}`)
	CurrentBook.AddChapter(96, `{
"1":"¡Canten al Señor un canto nuevo, cante al Señor toda la tierra!"
,"2":"Canten al Señor, bendigan su nombre, su salvación anuncien día a día."
,"3":"Cuenten su gloria a las naciones,y a todos los pueblos sus maravillas."
,"4":"Porque el Señor es grande y muy digno de alabanza, más temible que todos los dioses."
,"5":"Pues son nada esos dioses de los pueblos, mas el Señor es quien hizo los cielos."
,"6":"Honor y Majestad van precediéndole, y en su santuario están Fuerza y Esplendor."
,"7":"Ríndanle al Señor tribus y pueblos, ríndanle al Señor gloria y poder."
,"8":"Ríndanle al Señor la gloria de su nombre, traigan la ofrenda y entren en su templo."
,"9":"Adoren al Señor en el atrio sagrado, tiemblen ante él, pueblos de toda la tierra."
,"10":"'El Señor reina', anuncien a los pueblos, él fijó el universo inamovible, él juzgará a los pueblos con justicia."
,"11":"¡Gozo en los cielos, júbilo en la tierra, bramido del mar y del mundo marino!"
,"12":"Muestren su júbilo el campo y todos sus frutos, lancen vivas los árboles del bosque"
,"13":"delante del Señor, porque ya viene, porque ya viene a juzgar a la tierra. Al mundo con justicia juzgará, y a los pueblos, según su verdad."
}`)
	CurrentBook.AddChapter(97, `{
"1":"¡El Señor reina, alégrese la tierra, regocíjense las islas numerosas!"
,"2":"Lo rodea una nube tenebrosa, justicia y derecho son la base de su trono."
,"3":"Va avanzando un fuego delante de él, que alrededor devora a sus contrarios."
,"4":"Sus relámpagos iluminan el mundo, la tierra lo contempla y se estremece."
,"5":"Los montes se derriten como cera ante el que es Amo de toda la tierra;"
,"6":"los cielos proclaman su justicia y todos los pueblos ven su gloria."
,"7":"Se avergüenzan los que adoran ídolos, los que se jactan de cosas estúpidas ¡Todos los dioses se postran ante él!"
,"8":"Sión lo ha oído y se regocija, se festejan los pueblos de Judá a la espera, Señor, de tus sentencias."
,"9":"Porque tú eres Señor Altísimo en toda la tierra, que destaca muy por encima de los dioses."
,"10":"Amados del Señor, odien el mal, pues él cuida las almas de sus fieles y los libra de manos de malvados."
,"11":"La luz ya asoma para el justo y la alegría, para los de recto corazón."
,"12":"Alégrense, justos en el Señor, y den gracias a su santo nombre."
}`)
	CurrentBook.AddChapter(98, `{
"1":"Entonen al Señor un canto nuevo, pues ha hecho maravillas, la salvación provino de su diestra, de su brazo de santidad."
,"2":"El Señor dio a conocer su salvación, hizo ver a los paganos su justicia,"
,"3":"se acordó de su amor y fidelidad en favor de la casa de Israel. Todos, hasta los confines del mundo, han visto la salvación de nuestro Dios."
,"4":"¡Aclamen al Señor, toda la tierra, estallen en gritos de alegría!"
,"5":"¡Canten con la cítara al Señor, con la cítara y al son de la salmodia,"
,"6":"al son de la trompeta y del cuerno aclamen el paso del Rey, el Señor!"
,"7":"¡Rujan el mar y todo lo que contiene, el mundo y todos los que lo habitan!"
,"8":"Aplaudan los ríos y los montes griten de alegría delante del Señor, porque ya viene, porque ya viene a juzgar la tierra. Juzgará al mundo con justicia y a los pueblos según su derecho."
}`)
	CurrentBook.AddChapter(99, `{
"1":"El Señor reina, tiemblan los pueblos; monta en querubines, la tierra se estremece."
,"2":"En Sión el Señor es muy grande, exaltado por encima de todos los pueblos."
,"3":"Que celebran tu nombre grande y terrible: '¡El es Santo!'"
,"4":"Rey poderoso, amante de la justicia, tú has establecido la rectitud, tú ejerces en Jacob el derecho y la sentencia justa."
,"5":"Ensalcen al Señor, nuestro Dios, póstrense ante la tarima de sus pies: ¡El es Santo!"
,"6":"Moisés y Aarón eran sus sacerdotes, Samuel también invocaba su nombre: invocaban al Señor y él les respondía."
,"7":"De la columna de nube les hablaba, guardaban sus órdenes, las leyes que les dio."
,"8":"Oh Señor, nuestro Dios, tú les respondías, tú eras para ellos un Dios tolerante, pero no les dejabas pasar nada."
,"9":"Ensalcen al Señor, nuestro Dios, póstrense ante su santo monte: ¡Santo es el Señor nuestro Dios!"
}`)
	CurrentBook.AddChapter(100, `{
"1":"¡Aclame al Señor la tierra entera,"
,"2":"sirvan al Señor con alegría, lleguen a él, con cánticos de gozo!"
,"3":"Sepan que el Señor es Dios, él nos hizo y nosotros somos suyos, su pueblo y el rebaño de su pradera."
,"4":"¡Entren por sus puertas dando gracias, en sus atrios canten su alabanza. Denle gracias y bendigan su nombre!"
,"5":"'Sí, el Señor es bueno, su amor dura por siempre, y su fidelidad por todas las edades'."
}`)
	CurrentBook.AddChapter(101, `{
"1":"Quiero cantar lo que es bueno y justo; para ti, Señor, será mi salmo."
,"2":"Me entrenaré en el camino perfecto; pero tú, ¿vendrás a mí?,No tendré más que rectas intenciones para actuar en mi casa."
,"3":"Nada tendré en vista que pueda ser malvado. Odio el proceder de los extraviados, no permitiré que se me pegue."
,"4":"Lejos de mí el corazón perverso, desconozco al malvado."
,"5":"Al que denigra en secreto a su prójimo yo lo haré callar; al de ojos altaneros y corazón engreído no lo soportaré."
,"6":"Buscaré a los leales del país para que vivan conmigo; al que sigue el camino perfecto lo pondré a mi servicio."
,"7":"No morará en mi casa el que trama el engaño; el que anda con mentiras no comparezca en mi presencia."
,"8":"Cada mañana acabaré con todos los malvados del país, para suprimir de la ciudad del Señor a todos los que hacen el mal."
}`)
	CurrentBook.AddChapter(102, `{
"2":"Señor, escucha mi plegaria, que mis gritos lleguen hasta ti."
,"3":"No me escondas tu cara en el día de mi desgracia, vuelve tus oídos hacia mí el día que te invoco, apresúrate en responderme."
,"4":"Pues mis días se esfuman, mis huesos se consumen como brasas;"
,"5":"como hierba segada, mi corazón se seca y hasta me olvido de comer mi pan;"
,"6":"con lo fuerte de mis sollozos, a través de la piel se ven mis huesos."
,"7":"Me parezco al pelícano del desierto, soy como la lechuza de las ruinas."
,"8":"Paso en vela gimiendo como un pájaro solo en un tejado."
,"9":"Todo el día me insultan mis enemigos, los que me adulan maldicen de mí."
,"10":"El pan que como es la ceniza, mezclo mi bebida con mis lágrimas,"
,"11":"debido a tu cólera y a tu furor pues me arrancaste y me tiraste al suelo."
,"12":"Mis días son como la sombra que declina, y yo me voy secando como el pasto."
,"13":"Mas tú, Señor, reinas para siempre, y te invocan por todas las edades."
,"14":"Tú te levantarás, enternecido por Sión, pues ya es tiempo que de ella te apiades, ya ha llegado la hora;"
,"15":"tus siervos se encariñan con sus piedras y sienten pena al ver sus escombros."
,"16":"Entonces los pueblos respetarán tu nombre, y todos los reyes de la tierra, tu gloria;"
,"17":"cuando el Señor reconstruya a Sión y se manifieste en su gloria,"
,"18":"cuando atienda la oración del despojado y no se haga sordo a su plegaria."
,"19":"Escríbanlo para la nueva generación: un pueblo recreado alabará al Señor."
,"20":"Pues se inclinó de lo alto de su santuario, desde los cielos miró el Señor a la tierra"
,"21":"para escuchar el gemido del cautivo y liberar a los condenados a muerte,"
,"22":"para que resuene en Sión el nombre del Señor y su alabanza, en Jerusalén."
,"23":"Se reunirán entonces los pueblos y los reinos para adorar al Señor."
,"24":"Agotó mi fuerza en el camino, y ha abreviado mis días,"
,"25":"pero yo digo: Dios mío, no me arranques a mitad de mis días, siendo que tus años corren de edad en edad."
,"26":"Hace tiempo que fundaste la tierra, y los cielos son la obra de tus manos;"
,"27":"ellos perecerán, pero tú permaneces, todos se gastan como la ropa, los cambias como un vestido, y se mudan,"
,"28":"pero tú eres el mismo, tus años no se acaban."
,"29":"Los hijos de tus siervos vivirán en ella y su raza siempre te servirá."
}`)
	CurrentBook.AddChapter(103, `{
"1":"Bendice al Señor, alma mía, alabe todo mi ser su santo Nombre."
,"2":"Bendice, alma mía, al Señor, y no olvides ninguno de sus beneficios."
,"3":"El perdona todas tus ofensas y te cura de todas tus dolencias."
,"4":"El rescata tu vida de la tumba, te corona de amor y de ternura."
,"5":"El colma de dicha tu existencia y como el águila se renueva tu juventud."
,"6":"El Señor obra en justicia y a los oprimidos les da lo que es debido."
,"7":"Reveló sus caminos a Moisés y a los hijos de Israel sus proezas."
,"8":"El Señor es ternura y compasión, lento a la cólera y lleno de amor;"
,"9":"si se querella, no es para siempre, si guarda rencor, es sólo por un rato."
,"10":"No nos trata según nuestros pecados ni nos paga según nuestras ofensas."
,"11":"Cuanto se alzan los cielos sobre la tierra tan alto es su amor con los que le temen."
,"12":"Como el oriente está lejos del occidente así aleja de nosotros nuestras culpas."
,"13":"Como la ternura de un padre con sus hijos es la ternura del Señor con los que le temen."
,"14":"El sabe de qué fuimos formados, se recuerda que sólo somos polvo."
,"15":"El hombre: sus días son como la hierba, él florece como la flor del campo;"
,"16":"un soplo pasa sobre él, y ya no existe y nunca más se sabrá dónde estuvo."
,"17":"Pero el amor del Señor con los que le temen es desde siempre y para siempre; defenderá a los hijos de sus hijos,"
,"18":"de aquellos que guardan su alianza y se acuerdan de cumplir sus ordenanzas."
,"19":"El Señor ha fijado su trono en los cielos y su realeza todo lo domina."
,"20":"Bendigan al Señor todos sus ángeles, héroes poderosos, que ejecutan sus órdenes apenas oyen el sonido de su palabra."
,"21":"Bendigan al Señor todos sus ejércitos, sus servidores, para hacer su voluntad."
,"22":"Bendigan al Señor todas sus obras, en todos los lugares de su dominio."
}`)
	CurrentBook.AddChapter(104, `{
"1":"¡Bendice al Señor, alma mía!,¡Eres muy grande, oh Señor, mi Dios, vestido de gloria y majestad,"
,"2":"envuelto de luz como en un manto!,Tú despliegas los cielos como un toldo,"
,"3":"construyes sobre las aguas tu piso alto. Tú haces tu carro de las nubes,y avanzas en alas de los vientos."
,"4":"Tomas de mensajeros a los vientos,y como servidores un fuego en llamas."
,"5":"Pusiste la tierra sobre sus bases, por siempre jamás es inamovible."
,"6":"La cubres con el manto de los océanos, las aguas se han detenido en las montañas."
,"7":"Ante tu amenaza emprenden la fuga, se precipitan a la voz de tu trueno;"
,"8":"suben los montes, bajan por los valles,hasta el lugar que tú les señalaste;"
,"9":"pusiste un límite que no franquearán, para que no vuelvan a cubrir la tierra."
,"10":"Haces brotar vertientes en las quebradas, que corren por en medio de los montes,"
,"11":"calman la sed de todos los animales; allí extinguen su sed los burros salvajes."
,"12":"Aves del cielo moran cerca de ellas, entremedio del follaje alzan sus trinos."
,"13":"De lo alto de tus moradas riegas los montes, sacias la tierra del fruto de tus obras;"
,"14":"haces brotar el pasto para el ganado,y las plantas que el hombre ha de cultivar, para que de la tierra saque el pan"
,"15":"y el vino que alegra el corazón del hombre. El aceite le dará brillo a su rostro,y el pan fortificará su corazón."
,"16":"Los árboles del Señor están colmados, los cedros del Líbano que plantó."
,"17":"Allí hacen sus nidos los pajaritos, en su copa tiene su casa la cigüeña;"
,"18":"para las cabras son los altos montes, las rocas son escondrijo de los conejos."
,"19":"Pusiste la luna para el calendario,y el sol que sabe a qué hora ha de ponerse."
,"20":"Tú traes las tinieblas y es de noche, en que rondan todas las fieras de la selva;"
,"21":"rugen los leoncitos por su presa,reclamando a Dios su alimento."
,"22":"Cuando el sol aparece se retiran,y vuelven a acostarse en sus guaridas;"
,"23":"el hombre entonces sale a su trabajo, a su labor, hasta que entre la noche."
,"24":"¡Señor, qué numerosas son tus obras!,Todas las has hecho con sabiduría, de tus criaturas la tierra está repleta!"
,"25":"Mira el gran mar, vasto en todo sentido, allí bullen en número incontable,pequeños y grandes animales;"
,"26":"por allí circulan los navíos,y Leviatán que hiciste para entretenerte."
,"27":"Todas esas criaturas de ti esperan,que les des a su tiempo el alimento;"
,"28":"apenas se lo das, ellos lo toman, abres tu mano, y sacian su apetito."
,"29":"Si escondes tu cara, quedan anonadados, recoges su espíritu, expiran,y retornan a su polvo."
,"30":"Si envías tu espíritu, son creados,y así renuevas la faz de la tierra."
,"31":"¡Que la gloria del Señor dure por siempre,y en sus obras el Señor se regocije!"
,"32":"él, que mira a la tierra y ésta tiembla, y si toca a los montes, echan humo."
,"33":"Al Señor quiero cantar toda mi vida, salmodiar para mi Dios mientras yo exista."
,"34":"Ojalá que le agrade mi poema, yo, como sea, me alegro en el Señor."
,"35":"¡Desaparezcan de la tierra los pecadores,y que no existan más los malvados!,¡Alma mía, bendice al Señor!"
}`)
	CurrentBook.AddChapter(105, `{
"1":"¡Den gracias al Señor, su nombre invoquen, entre los pueblos anuncien sus hazañas!"
,"2":"Cántenle y toquen para él, y mediten todos sus prodigios."
,"3":"Siéntanse orgullosos de su santo nombre, y alégrense los que buscan al Señor."
,"4":"¡Busquen al Señor, esto será su fuerza, busquen su cara sin cesar!"
,"5":"¡Recuerden las maravillas que realizó, sus prodigios, las sentencias que pronunció,"
,"6":"raza de Abrahán, su servidor, hijos de Jacob, su elegido!"
,"7":"El es el Señor, es nuestro Dios, sus decisiones tocan a toda la tierra."
,"8":"Se acuerda para siempre de su alianza, de la palabra impuesta a mil generaciones,"
,"9":"del pacto que con Abrahán concluyó, y de su juramento a Isaac."
,"10":"Lo erigió como ley para Jacob, como alianza eterna para Israel."
,"11":"Dijo: 'Te daré la tierra de Canaán, esa será tu parte de la herencia'."
,"12":"Aunque eran gente fácil de numerar, bien poca cosa y extraños en ese país,"
,"13":"e iban errantes de una nación a otra, de un reino a otro pueblo,"
,"14":"a nadie permitió que los oprimiera, y a reyes, por su causa, reprendió:"
,"15":"'No toquen a los que me he consagrado, a mis profetas no les hagan daño.'"
,"16":"Dejó caer la hambruna en el país, les cortó el alimento;"
,"17":"pero delante de ellos envió a un hombre, a José, vendido como esclavo."
,"18":"Fue humillado con grillos en sus pies, y su cuello pusieron entre fierros;"
,"19":"hasta el día en que se cumplió su predicción: la palabra del Señor le dio la razón."
,"20":"El rey ordenó que lo soltaran, el amo de los pueblos lo dejó libre;"
,"21":"lo estableció como señor de su casa, gobernador de todos sus dominios,"
,"22":"para instruir a los príncipes en su nombre y enseñar sabiduría a sus ancianos."
,"23":"Entonces Israel entró en Egipto, Jacob se instaló en tierra de Cam."
,"24":"Dios quiso que su pueblo creciera mucho, lo hizo más fuerte que sus adversarios,"
,"25":"les cambió el corazón y odiaron a su pueblo, y trataron de dañar a sus servidores."
,"26":"Envió, entonces, a Moisés, su servidor, a Aarón, al que había elegido;"
,"27":"por su medio realizó las señales predichas y sus prodigios en la tierra de Cam."
,"28":"Les envió tinieblas y todo se oscureció, pero no tomaron en cuenta su palabra."
,"29":"Cambió sus aguas en sangre e hizo que sus peces perecieran."
,"30":"Pululó de ranas su país hasta en las habitaciones de los reyes."
,"31":"Habló y llegaron los mosquitos, plaga de insectos en todo su territorio."
,"32":"En vez de lluvia les envió el granizo y rayos en todo su país."
,"33":"Azotó sus viñas y sus higueras, rompió los árboles de su territorio."
,"34":"Habló y llegaron las langostas y saltamontes, que eran incontables,"
,"35":"se comieron toda la hierba en su país, devoraron el fruto de su suelo."
,"36":"Golpeó a todo primogénito, en su país, a todas las primicias de su virilidad."
,"37":"Hizo salir a los suyos con oro y plata, y en sus tribus ninguno iba cojeando."
,"38":"Egipto se alegró de su salida, pues el terror lo había dominado;"
,"39":"desplegó una nube como un velo, y un fuego para alumbrarlos de noche."
,"40":"A su pedido, les envió codornices, y con pan de los cielos los sació."
,"41":"Abrió la roca y las aguas brotaron, y por la tierra seca corrían como ríos."
,"42":"Es que se acordó de su santa palabra que le dio a Abrahán, su servidor;"
,"43":"hizo salir a su pueblo alegremente, a sus elegidos entre gritos de gozo."
,"44":"Les dio las tierras de otras naciones y heredaron el trabajo de otros pueblos,"
,"45":"para que así guardaran sus preceptos y observaran sus leyes."
}`)
	CurrentBook.AddChapter(106, `{
"1":"¡Aleluya! Den gracias al Señor porque él es bueno, porque su amor perdura para siempre."
,"2":"¿Quién contará las hazañas del Señor y hará que oigamos toda su alabanza?"
,"3":"¡Felices los que respetan el derecho y practican la justicia en todo tiempo!"
,"4":"Acuérdate de mí, Señor, tú que amas a tu pueblo, que tu visita traiga tu salvación."
,"5":"¡Que veamos la dicha de tus elegidos, nos alegremos con el gozo de tu pueblo y nuestro orgullo sea el de tu familia!"
,"6":"Junto con nuestros padres hemos pecado, cometimos una falta, somos culpables."
,"7":"Nuestros padres en Egipto no entendieron nada de tus milagros, se olvidaron de tus favores sin cuento, se rebelaron contra el Altísimo junto al Mar Rojo."
,"8":"Pero en virtud de su nombre los salvó, para que su valentía fuera conocida."
,"9":"Increpó al Mar Rojo y se secó, los condujo por el fondo como en el desierto."
,"10":"Los salvó de las manos del que los odiaba y los libró de las manos del enemigo."
,"11":"Las aguas cubrieron a sus adversarios ni uno solo de entre ellos escapó."
,"12":"Entonces creyeron en sus palabras y cantaron su alabanza."
,"13":"Pero pronto se olvidaron de sus obras y no contaron con su providencia."
,"14":"Se despertó su gula en el desierto y en la estepa pusieron a Dios a prueba."
,"15":"El les concedió lo que pedían, se lo dio hasta que tuvieran asco."
,"16":"Envidiaron a Moisés, en el campamento, y a Aarón, el santo del Señor."
,"17":"Se abrió la tierra y se tragó a Datán, se cerró sobre la banda de Abirón."
,"18":"Un fuego se encendió contra su grupo, una llama devoró a esos malvados."
,"19":"Luego, en Horeb se hicieron un ternero y se postraron ante un metal fundido,"
,"20":"cambiaron su Gloria por la imagen de un buey que come pasto."
,"21":"¡Se olvidaron de Dios que los había salvado, del que hizo grandes cosas en Egipto,"
,"22":"milagros en el país de Cam, y un prodigio asombroso en el Mar Rojo!"
,"23":"Entonces habló de exterminarlos, a no ser porque su elegido Moisés se puso en la brecha frente a El para impedir que su ira los destruyera."
,"24":"Despreciaron una tierra de delicias, no creyeron en su palabra;"
,"25":"se quedaron en sus tiendas criticando en vez de escuchar la voz del Señor."
,"26":"Alzó su mano sobre ellos y juró que los haría caer en el desierto,"
,"27":"dispersaría su raza entre los paganos y los esparciría entre los países."
,"28":"Se sometieron a Baal-Peor, comieron de los sacrificios a los muertos;"
,"29":"tanto lo irritaron con esas prácticas que una plaga se desató contra ellos."
,"30":"Entonces surgió Finjás e intervino y el flagelo se detuvo."
,"31":"Ese fue su mérito, se lo reconoce por generaciones, para siempre."
,"32":"Lo irritaron en las aguas de Meribá, por su culpa le fue mal a Moisés,"
,"33":"pues agriaron su espíritu y sus labios hablaron lo indebido."
,"34":"No acabaron con los pueblos que el Señor les había ordenado;"
,"35":"se mezclaron con los paganos y aprendieron sus modos de comportarse."
,"36":"Sirvieron a los ídolos, que fueron una trampa para ellos;"
,"37":"sacrificaron sus hijos y sus hijas a los demonios"
,"38":"Derramaron la sangre inocente, la sangre de sus hijos y de sus hijas, sacrificados a los ídolos de Canaán, y el país quedó manchado de sangre."
,"39":"Se mancharon con esas acciones, se prostituyeron con tales prácticas."
,"40":"La cólera del Señor se encendió contra su pueblo y tuvo horror de su propia gente."
,"41":"Los entregó en manos de los paganos y los que los odiaban los dominaron."
,"42":"Los oprimieron sus enemigos, a su yugo debieron doblegarse."
,"43":"¡Cuántas veces no los liberó! Pero ellos, rebeldes a sus consejos, se sumían en su culpa."
,"44":"Mas apenas los veía en la miseria y escuchaba sus clamores,"
,"45":"se acordaba de su alianza con ellos y se compadecía según su gran amor."
,"46":"Así hizo que de ellos se apiadaran todos los que los habían capturado."
,"47":"Oh Señor y Dios nuestro, sálvanos, júntanos de entre las naciones, para que demos gracias a tu santo nombre y sea nuestra gloria tu alabanza."
,"48":"¡Bendito sea el Señor, Dios de Israel, desde siempre y para siempre!,Que todo el pueblo diga: ¡Amén, Aleluya!"
}`)
	CurrentBook.AddChapter(107, `{
"1":"¡Den gracias al Señor porque él es bueno, porque es eterna su misericordia!"
,"2":"Que lo digan los que el Señor rescató, que rescató de manos del adversario,"
,"3":"que reunió de todos los países del oriente y poniente, del norte y del sur."
,"4":"Erraban por el desierto, por la estepa, sin hallar el camino de una ciudad poblada."
,"5":"Tenían hambre, pero más tenían sed, su alma en ellos ya desfallecía."
,"6":"Pero al Señor clamaron en su angustia y él los libró de su aflicción,"
,"7":"los encaminó por una ruta recta para que llegaran a una ciudad poblada."
,"8":"Den gracias al Señor por su bondad, sus maravillas con los hijos de los hombres."
,"9":"Dio de beber a la garganta seca y a los hambrientos los colmó de bienes."
,"10":"Habitaban en la sombra y en tinieblas, atenazados por la miseria y los hierros,"
,"11":"por no haber escuchado las palabras de Dios y despreciado los consejos del Altísimo."
,"12":"En la pena él sumió su corazón, sucumbían y nadie los socorría."
,"13":"En su angustia clamaron al Señor y él los liberó de su aflicción,"
,"14":"los sacó de la sombra, de las tinieblas y rompió sus cadenas."
,"15":"¡Den gracias al Señor por su bondad, sus maravillas con los hijos de los hombres!"
,"16":"Pues él rompió las puertas de bronce y destrozó los cerrojos de fierro."
,"17":"Vueltos locos en su mal camino, y desdichados a causa de sus faltas,"
,"18":"sentían asco de cualquier alimento y estaban a las puertas de la muerte."
,"19":"Pero en su angustia clamaron al Señor y él los liberó de su aflicción."
,"20":"Les envió su palabra, los sanó y salvó sus vidas de la tumba."
,"21":"¡Den gracias al Señor por su bondad, sus maravillas con los hijos de los hombres!"
,"22":"Ofrezcan sacrificios de acción de gracias, cuenten sus obras con cánticos de júbilo."
,"23":"Los que bajan al mar en sus navíos y negocian entre las grandes aguas,"
,"24":"estos han visto las obras del Señor, sus maravillas en las profundidades."
,"25":"A su orden surgió un viento huracanado, que levantaba las olas;"
,"26":"subían a los cielos, bajaban a los abismos, su alma se consumía en el mareo;"
,"27":"por el vértigo, titubeaban como un ebrio, toda su pericia había sido tragada."
,"28":"Pero al Señor clamaron en su angustia y él los hizo salir de su aflicción."
,"29":"Hizo que amainara la tormenta y las olas del mar enmudecieron."
,"30":"Se alegraron al ver calmado todo, y los llevó al puerto deseado."
,"31":"¡Den gracias al Señor por su bondad, sus maravillas con los hijos de los hombres!"
,"32":"Que lo exalten en la asamblea del pueblo y lo alaben en el consejo de ancianos."
,"33":"El convierte los ríos en desierto y en tierra seca las vertientes de agua;"
,"34":"la tierra fértil se cubre de sal debido a la maldad de sus habitantes."
,"35":"Pero cambia el desierto en capa de agua y la tierra árida en fuente de agua;"
,"36":"allí hace que habiten los hambrientos y funden una ciudad habitable."
,"37":"Siembran sus campos y plantan viñedos, recolectan sus frutos."
,"38":"Los bendice, se multiplican mucho, y su ganado no se les reduce."
,"39":"Luego disminuyeron y se vieron abatidos bajo el peso de males y desgracias,"
,"40":"pero él, que derrama el desprecio sobre los grandes y los hace errar en un desierto sin caminos,"
,"41":"levanta al pobre de su miseria y multiplica las familias como el rebaño."
,"42":"Los hombres rectos véanlo y alégrense, pero todo lo que es vil cierre la boca."
,"43":"¡El que sea sabio, que medite estas cosas y reconozca las bondades del Señor!"
}`)
	CurrentBook.AddChapter(108, `{
"2":"¡Oh Dios, listo está mi corazón, quiero cantar, quiero tocar para ti con todo mi corazón!"
,"3":"Despierten, arpa y cítara, despertaré a la aurora."
,"4":"Te alabaré, Señor, entre los pueblos, tocaré para ti en las provincias,"
,"5":"pues tu amor va más allá de los cielos y tu verdad alcanza hasta las nubes."
,"6":"Oh Dios, muéstrate por encima de los cielos, que brille tu gloria sobre toda la tierra."
,"7":"¡Que sean liberados tus muy amados. Sálvanos con tu diestra y respóndenos!"
,"8":"Dios habló desde su santuario: 'Estoy en forma, repartiré Siquem y lotearé el valle de Sucot."
,"9":"Mío es Galaad, mío Manasés, Efraín es el casco para mi cabeza, y Judá, mi bastón de mando."
,"10":"Moab es la vasija en que me lavo, sobre Edom arrojo mi sandalia, contra Filistea lanzo el grito de victoria'."
,"11":"¿Quién me llevará a la ciudad fuerte, quién me guiará hasta Edom?"
,"12":"Sólo tú, oh Dios; pero nos has rechazado y ya no sales más con nuestras tropas."
,"13":"Danos tu ayuda contra el opresor, pues la ayuda humana es ilusoria."
,"14":"¡Con Dios maravillas obtendremos y él pisoteará a nuestros adversarios!"
}`)
	CurrentBook.AddChapter(109, `{
"1":"Oh Dios a quien alabo, no guardes silencio,"
,"2":"pues la boca maligna y la boca impostora se abren contra mí. Me hablan con lengua mentirosa, "
,"3":"me rodean palabras de odio, me atacan sin motivo."
,"4":"¡En pago a mi amistad me acusan y yo tan solo oro!"
,"5":"Me devuelven mal por bien y odio, por mi amistad."
,"6":"Haz que un hombre malo le pida cuentas, que el acusador se pare a su derecha."
,"7":"¡Que en el juicio resulte culpable, que consideren pecado su apelación!"
,"8":"¡Que sus días le sean acortados y que otro se apodere de su cargo!"
,"9":"¡Que sus hijos queden huérfanos y su mujer viuda!"
,"10":"¡Que sus hijos anden vagabundos y mendiguen, y los echen de sus casas destruidas!"
,"11":"¡Que un acreedor le quite todo y extraños se apoderen de lo que le ha costado!"
,"12":"¡Que nadie le haga un favor, y nadie se compadezca de sus huérfanos!"
,"13":"¡Que sea su descendencia exterminada y se borre su nombre en una generación!"
,"14":"¡Que recuerde el Señor la culpa de sus padres, que no se borre el pecado de su madre,"
,"15":"que estén siempre presentes ante el Señor, que borre de la tierra su memoria!"
,"16":"Pues nunca se acordó de ser amable, persiguió al pobre y al desvalido, y hasta la muerte al hombre de triste corazón."
,"17":"¡Ya que amó la maldición, que con él se quede; no quiso la bendición, que lo abandone!"
,"18":"Se puso la maldición como su ropa: que le penetre hasta el fondo como el agua y le cale como aceite hasta sus huesos."
,"19":"Que sea como un manto que lo envuelva, un cinturón que lo apriete sin cesar."
,"20":"Así pague el Señor a mis acusadores y a los que hablan mal de mi persona."
,"21":"Pero tú, Señor Adonai, actúa para mí en honor a tu nombre, sálvame, pues es tan bueno tu amor."
,"22":"Porque soy pobre y desdichado, herido está mi corazón dentro de mí,"
,"23":"me voy como la sombra que declina, como langosta arrastrada por el viento."
,"24":"De tanto ayuno flaquean mis rodillas, y mi cuerpo, sin grasa, ha enflaquecido;"
,"25":"soy un pretexto para sus insultos, cuando me ven, menean la cabeza."
,"26":"Señor, mi Dios, ayúdame, sálvame, tú que eres bueno:"
,"27":"y que sepan que allí está tu mano, que eres tú, Señor, quien hizo eso."
,"28":"Si ellos maldicen, tu bendecirás: mis adversarios serán confundidos y tu servidor se alegrará."
,"29":"¡Que se cubran de infamia mis acusadores, envueltos en su vergüenza como en un manto!"
,"30":"Por mi boca al Señor doy muchas gracias y alabanzas en medio de la muchedumbre,"
,"31":"pues se puso a la derecha del pobre para salvar su vida de sus jueces."
}`)
	CurrentBook.AddChapter(110, `{
"1":"Palabra del Señor a mi señor: '¡Siéntate a mi derecha,y ve cómo hago de tus enemigos,la tarima de tus pies!'"
,"2":"Desde Sión extenderá el Señor,el cetro de tu mando: domina en medio de tus enemigos."
,"3":"'Tuyo es el principado,desde el día de tu nacimiento; de mí en el monte sagrado tú has nacido, como nace el rocío de la aurora'."
,"4":"Juró el Señor y no ha de retractarse: 'Tú eres para siempre sacerdote,a la manera de Melquisedec'."
,"5":"A tu diestra está el Señor, aplasta a los reyes en el día de su cólera;"
,"6":"juzga a las naciones; está lleno de cadáveres, y de cabezas rotas a lo ancho de la tierra."
,"7":"El bebe del torrente, en el camino, por eso levanta su cabeza."
}`)
	CurrentBook.AddChapter(111, `{
"1":"¡Aleluya!,Doy gracias al Señor de todo corazón,en la reunión de los justos y en la asamblea."
,"2":"Grandiosas son las obras del Señor, las profundizan los que en ellas se complacen."
,"3":"Toda su obra es grandeza y esplendor,y su justicia dura para siempre."
,"4":"Quiso que se recordaran sus milagros, ¿no es el Señor clemente y compasivo?"
,"5":"Dio el alimento a aquellos que le temen, se acuerda para siempre de su alianza."
,"6":"Mostró a su pueblo la fuerza de sus obras,al darle la tierra de los paganos."
,"7":"Verdad y justicia son obra de sus manos, todos sus decretos son seguros,"
,"8":"apoyados en una base inamovible, portadores de verdad y rectitud."
,"9":"Envió a su pueblo la liberación, fijó con él una alianza para siempre; santo y temible es su Nombre."
,"10":"El principio del saber es temer al Señor, es sabio de verdad el que así vive, su alabanza perdura para siempre."
}`)
	CurrentBook.AddChapter(112, `{
"1":"¡Aleluya!,¡Feliz el hombre que teme al Señor,y valora mucho sus mandamientos!"
,"2":"Su semilla será pujante en el país, los retoños del hombre bueno serán benditos."
,"3":"Habrá en su casa bienes y riquezas, y su honradez, que durará para siempre."
,"4":"Brilla como luz en las tinieblas,para los de recto corazón; él comprende, es clemente y justo."
,"5":"Le va bien al compasivo y que presta, y lleva sus negocios en conciencia,"
,"6":"pues nada logrará perturbarlo: el recuerdo del justo será eterno."
,"7":"No tiene miedo a las malas noticias, pues en su corazón confía en el Señor;"
,"8":"su corazón está firme, nada teme, al final, despreciará a sus adversarios."
,"9":"Es generoso en dar a los pobres, su honradez permanece para siempre, su cuerno aumenta en gloria."
,"10":"El malvado lo ve y se irrita, le rechinan los dientes, se debilita; nada queda del deseo de los malos."
}`)
	CurrentBook.AddChapter(113, `{
"1":"¡Aleluya!,¡Alaben, servidores del Señor, alaben el nombre del Señor!"
,"2":"¡Bendito sea el nombre del Señor,ahora y para siempre!"
,"3":"¡Desde donde sale el sol hasta su ocaso, alabado sea el nombre del Señor!"
,"4":"¡El Señor domina a todas las naciones, su gloria está por encima de los cielos!"
,"5":"¿Quién es como el Señor, nuestro Dios, que se sienta en las alturas, pero que se inclina para ver,los cielos y la tierra?"
,"7":"Al pobre lo recoge desde el polvo, de la mugre retira al desvalido,"
,"8":"para darle un asiento entre los nobles, con los grandes de su pueblo."
,"9":"Da un hogar a la mujer estéril, ahora feliz madre de sus hijos."
}`)
	CurrentBook.AddChapter(114, `{
"1":"Cuando Israel salió de Egipto, la casa de Jacob, de un pueblo bárbaro,"
,"2":"Judá pasó a ser su santuario, Israel se convirtió en su dominio."
,"3":"El mar lo vio y huyó, el Jordán debió retroceder,"
,"4":"las montañas saltaron como carneros,y como corderos las colinas."
,"5":"¿Qué te pasa, mar, que huyes?,Y tú, Jordán, ¿por qué retrocedes?"
,"6":"Montañas, ¿por qué saltan como carneros,y ustedes, colinas, como corderos?"
,"7":"Tiembla, tierra, en presencia del Señor, en presencia del Dios de Jacob, del que cambia la roca en manantial, y la piedra, en fontana."
}`)
	CurrentBook.AddChapter(115, `{
"1":"¡No a nosotros, Señor, nos des la gloria, no a nosotros, sino a tu nombre, llevado por tu amor, tu lealtad!"
,"2":"¿Quieres que digan los paganos: '¿Dónde está, pues, su Dios?'"
,"3":"Nuestro Dios está en los cielos, él realiza todo lo que quiere."
,"4":"Sus ídolos no son más que oro y plata, una obra de la mano del hombre."
,"5":"Tienen boca pero no hablan, ojos, pero no ven , orejas, pero no oyen, nariz, pero no huelen."
,"7":"Tienen manos, mas no palpan, pies, pero no andan, ni un susurro sale de su garganta."
,"8":"¡Que sean como ellos los que los fabrican,y todos los que en ellos tienen confianza!"
,"9":"¡Casa de Israel, confíen en el Señor, él es su socorro y su escudo!"
,"10":"¡Casa de Aarón, confíen en el Señor, él es su socorro y su escudo!"
,"11":"¡Los que temen al Señor, confíen en el Señor, él es su socorro y su escudo!"
,"12":"El Señor no nos olvida, nos bendecirá: bendecirá a la casa de Israel, bendecirá a la casa de Aarón,"
,"13":"bendecirá a los que temen al Señor, tanto a los pequeños como a los grandes."
,"14":"Que el Señor los haga crecer,a ustedes y a sus hijos."
,"15":"¡Que el Señor los bendiga, el que hizo los cielos y la tierra!"
,"16":"Los cielos son la morada del Señor, mas dio la tierra a los hijos de Adán."
,"17":"No son los muertos los que alaban al Señor, ni todos los que bajan al Silencio,"
,"18":"mas nosotros, los vivos, bendecimos al Señor,desde ahora y para siempre."
}`)
	CurrentBook.AddChapter(116, `{
"1":"Amo al Señor porque escucha,el clamor de mi plegaria;"
,"2":"Inclinó hacia mí su oído,el día en que lo llamé."
,"3":"Me envolvían los lazos de la muerte, estaba preso en las redes fatales, me ahogaban la angustia y el pesar,"
,"4":"pero invoqué el nombre del Señor: '¡Ay, Señor, salva mi vida!'"
,"5":"El Señor es muy bueno y justo, nuestro Dios es compasivo;"
,"6":"El Señor cuida de los pequeños, estaba débil y me salvó."
,"7":"Alma mía, vuelve a tu descanso, que el Señor cuida de ti."
,"8":"Ha librado mi alma de la muerte, de lágrimas mis ojos,y mis pies de dar un paso en falso."
,"9":"Caminaré en presencia del Señor,en la tierra de los vivos."
,"10":"Tenía fe, aun cuando me decía: 'Realmente yo soy un desdichado'."
,"11":"Pensaba en medio de mi confusión: '¡Todo hombre decepciona!'"
,"12":"¿Cómo le devolveré al Señor,todo el bien que me ha hecho?"
,"13":"Alzaré la copa por una salvación,e invocaré el nombre del Señor;"
,"14":"cumpliré mis promesas al Señor,en presencia de todo su pueblo."
,"15":"Tiene un precio a los ojos del Señor,la muerte de sus fieles:"
,"16":"'¡Mira, Señor, que soy tu servidor, tu servidor y el hijo de tu esclava: tú has roto mis cadenas!'"
,"17":"Te ofreceré el sacrificio de acción de gracias,e invocaré el nombre del Señor."
,"18":"Cumpliré mis promesas al Señor,en presencia de todo su pueblo,"
,"19":"en los atrios de la casa del Señor, en medio de ti, Jerusalén."
}`)
	CurrentBook.AddChapter(117, `{
"1":"¡Alaben al Señor en todas las naciones, y festéjenlo todos los pueblos!"
,"2":"Pues su amor hacia nosotros es muy grande, y la lealtad del Señor es para siempre."
}`)
	CurrentBook.AddChapter(118, `{
"1":"Den gracias al Señor, pues él es bueno, pues su bondad perdura para siempre."
,"2":"Que lo diga Israel: ¡su bondad es para siempre!"
,"3":"Que lo diga la casa de Aarón: ¡su bondad es para siempre!"
,"4":"Que lo digan los que temen al Señor: ¡su bondad es para siempre!"
,"5":"Al Señor, en mi angustia, yo clamé, y me respondió sacándome de apuros."
,"6":"Si el Señor está conmigo, no temo, ¿qué podrá hacerme el hombre?"
,"7":"Cuento al Señor entre los que me ayudan, y veré a mis enemigos a mis pies."
,"8":"Más vale refugiarse en el Señor,que confiar en los poderosos."
,"10":"Todos los paganos me rodeaban, pero en el nombre del Señor los humillé."
,"11":"Me rodeaban, me tenían cercado, pero en el nombre del Señor los humillé."
,"12":"Me rodeaban como avispas, cayeron como zarza que se quema, pues en nombre del Señor los humillé."
,"13":"Me empujaron con fuerza para botarme, pero acudió el Señor a socorrerme."
,"14":"El Señor es mi fuerza, el motivo de mi canto, ha sido para mí la salvación."
,"15":"Clamores de alegría y de triunfo,resuenan en las tiendas de los justos: '¡La diestra del Señor hizo proezas,"
,"16":"la diestra del Señor lo ha enaltecido, la diestra del Señor hizo proezas!'"
,"17":"No, no moriré sino que viviré,y contaré las obras del Señor."
,"18":"El Señor me corrigió mucho, pero no me entregó a la muerte."
,"19":"'¡Abranme las puertas de justicia,para entrar a dar gracias al Señor!'"
,"20":"'Esta es la puerta que lleva al Señor, por ella entran los justos'."
,"21":"¡Te agradezco que me hayas escuchado, tú has sido para mí la salvación!"
,"22":"La piedra rechazada por los maestros,pasó a ser la piedra principal;"
,"23":"ésta fue la obra del Señor, no podían creerlo nuestros ojos."
,"24":"¡Este es el día que ha hecho el Señor, gocemos y alegrémonos en él!"
,"25":"¡Danos, oh Señor, la salvación, danos, oh Señor, la victoria!"
,"26":"'¡Bendito sea el que viene,en el nombre del Señor!,Desde la casa del Señor los bendecimos:"
,"27":"el Señor es Dios, él nos ilumina'. Formen la procesión con ramos en la mano,hasta los cuernos del altar."
,"28":"Tú eres mi Dios, te doy gracias; ¡Dios mío, te digo que eres grande!"
,"29":"Den gracias al Señor, pues él es bueno, pues su bondad perdura para siempre."
}`)
	CurrentBook.AddChapter(119, `{
"1":"Dichosos los que sin yerro andan el camino y caminan según la Ley del Señor."
,"2":"Dichosos los que observan sus testimonios y lo buscan de todo corazón,"
,"3":"que sin cometer injusticia caminan por sus sendas."
,"4":"Tú eres quien promulgó tus ordenanzas para que las observen totalmente."
,"5":"Ojalá sea firme mi conducta en cumplir tus preceptos."
,"6":"Entonces no tendré vergüenza alguna en respetar todos tus mandamientos."
,"7":"Te daré gracias con rectitud de corazón cuando vaya aprendiendo tus juicios justos."
,"8":"Tus preceptos, yo los quiero guardar, no me abandones, pues, completamente."
,"9":"¿Cómo un joven purifica su camino? Basta con que observe tus palabras."
,"10":"¡Con todo mi corazón te he buscado, no me desvíes de tus mandamientos!"
,"11":"En mi corazón escondí tu palabra para no pecar contra ti."
,"12":"¡Bendito seas, Señor, enséñame tus preceptos!"
,"13":"Con mis labios he enumerado todos los juicios de tu boca."
,"14":"Me he complacido en seguir tus testimonios más que en tener toda una fortuna."
,"15":"Quiero meditar tus ordenanzas y tener ante mis ojos tus senderos."
,"16":"En tus preceptos me deleitaré, jamás me olvidaré de tus palabras."
,"17":"Sé bueno con tu servidor y viviré, pues yo quisiera guardar tu palabra."
,"18":"Abre mis ojos para que yo vea las maravillas de tu Ley."
,"19":"En la tierra soy sólo un pasajero, no me ocultes, pues, tus mandamientos."
,"20":"Mi alma se consume deseando tus juicios en todo tiempo."
,"21":"Tú amenazas a los arrogantes malditos, que desertan de tus mandamientos."
,"22":"Ahórrame el desprecio y la vergüenza, pues tus testimonios he guardado."
,"23":"Aunque príncipes sesionen en mi contra, tu servidor meditará en tus maravillas."
,"24":"Tus testimonios son también mis delicias, tus preceptos son mis consejeros."
,"25":"Mi alma está adherida al polvo, vivifícame conforme a tu palabra."
,"26":"Te expuse mis proyectos y me respondiste: enséñame tus preceptos."
,"27":"Haz que tome el camino de tus ordenanzas para que medite tus maravillas."
,"28":"Mi alma está deprimida de pesar, levántame de acuerdo a tu palabra."
,"29":"Aleja de mí el camino engañador, y dame la gracia de tu Ley."
,"30":"He elegido el camino de la verdad, y tus juicios he deseado."
,"31":"Me he apegado, Señor, a tus testimonios, que no me decepcione."
,"32":"Corro por el camino de tus mandamientos, ahí me ensanchas el corazón."
,"33":"Señor, enséñame el camino de tus preceptos, que los quiero seguir hasta el final."
,"34":"Dame inteligencia para guardar tu Ley, y que la observe de todo corazón."
,"35":"Guíame por la senda de tus mandamientos, pues en ésa me complazco."
,"36":"Inclina mi corazón hacia tus testimonios y no hacia la ganancia."
,"37":"Guarda mis ojos de mirar cosas vanas, me darás vida en tus caminos."
,"38":"Cumple con tu siervo tu promesa, dirigida a aquellos que te temen."
,"39":"Aparta de mí el desprecio que temo, pues tus juicios son para mi bien."
,"40":"Mira cómo deseo tus ordenanzas, tú que eres justo, vivifícame."
,"41":"Que vengan a mí, Señor, tu gracia y tu salvación, conforme a tu palabra."
,"42":"Entonces responderé a los que se burlan, que puedo confiar en tus palabras."
,"43":"Que no se me olvide la palabra de verdad, pues espero en tus juicios."
,"44":"Quiero observar tu Ley constantemente, por siempre jamás."
,"45":"Estaré a mis anchas en todos mis caminos, pues tus ordenanzas he buscado."
,"46":"Ante reyes hablaré de tus testimonios y no tendré vergüenza."
,"47":"Me he deleitado en tus mandamientos, a los que amaba mucho."
,"48":"Alzaré mis manos hacia ti y meditaré en tus preceptos."
,"49":"Recuerda tu palabra a tu servidor, ella ha mantenido mi esperanza."
,"50":"Este es mi consuelo en mi miseria que tu palabra me vivificará."
,"51":"Los soberbios se burlaban mucho de mí, pero no me he movido de tu Ley."
,"52":"Me acuerdo de tus juicios de otros tiempos y eso, Señor, me da aliento."
,"53":"Al ver a los impíos me da rabia: ¿por qué abandonan tu Ley?"
,"54":"Tus preceptos son salmodias para mí en la casa donde me reciben."
,"55":"Por la noche me acuerdo de tu nombre, oh Señor, y observo tu Ley."
,"56":"Por lo menos esto me quedará, haber guardado tus ordenanzas."
,"57":"Lo que escojo, Señor, yo lo he dicho, es observar tus palabras."
,"58":"Con todo mi corazón he procurado que tu rostro se enternezca, ten piedad de mí según tu palabra."
,"59":"He reflexionado en mis caminos, a tus testimonios readecuaré mis pasos."
,"60":"Me he apresurado, no me he retardado en obedecer tus mandamientos."
,"61":"Las pecadores intentaron seducirme, pero no me he olvidado de tu Ley."
,"62":"A medianoche me levanto, te doy gracias por tus justos juicios."
,"63":"Me he aliado con todos los que te temen y que observan tus ordenanzas."
,"64":"De tu bondad, Señor, está llena la tierra, enséñame tus preceptos."
,"65":"Has sido bueno con tu servidor, Señor, de acuerdo a tu palabra."
,"66":"Enséñame el buen sentido y el saber, pues tengo fe en tus mandamientos."
,"67":"Antes de ser humillado me había alejado, pero ahora yo observo tu palabra."
,"68":"Tú que eres bueno y bienhechor, enséñame tus preceptos."
,"69":"Los soberbios me recubren de mentira, mas, con todo el corazón, guardo tus ordenanzas."
,"70":"Su corazón está paralizado y ciego, pero para mí tu Ley es mi delicia."
,"71":"Fue bueno para mí que me humillaras, para que así aprendiera tus preceptos."
,"72":"La ley de tu boca vale más para mí que millones de oro y plata."
,"73":"Tus manos me han hecho y organizado, dame inteligencia para aprender tus mandatos."
,"74":"Se alegrarán los que te temen al ver que he esperado en tu palabra."
,"75":"Sé, Señor, que tus juicios son justos y que con razón me has afligido."
,"76":"Que tu gracia me asista y me consuele, conforme a tu palabra dada a tu siervo."
,"77":"Que venga a mí tu ternura y me dé vida, porque mis delicias son tu Ley."
,"78":"Confunde a los soberbios que me calumnian, mientras yo medito en tus ordenanzas."
,"79":"Que se vuelvan a mí los que te temen y que saben de tus testimonios."
,"80":"Que cumpla mi corazón sin falla tus preceptos, para que no quede avergonzado."
,"81":"Mi alma se desgastó anhelando tu salvación, espero en tu palabra."
,"82":"Mis ojos se cansaron por tu palabra, ¿cuándo vendrás a confortarme?"
,"83":"Aunque parezco un cuero ahumado, no he olvidado tus preceptos."
,"84":"¿Qual será la suerte de tu servidor? ¿cuándo harás justicia con mis perseguidores?"
,"85":"Los soberbios me han cavado trampas, lo que estaba en contra de tu Ley."
,"86":"Todos tus mandamientos son verdad: me persiguen sin razón, ¡ayúdame!"
,"87":"Por poco no me dejaban en el suelo, pero yo no abandoné tus ordenanzas."
,"88":"Por tu bondad dame vida, para que observe el testimonio de tu boca."
,"89":"Tu palabra, Señor, es para siempre, inmutable en los cielos."
,"90":"De generación en generación tu verdad; igual que la tierra que tú fundaste"
,"91":"y que se mantiene por tu decisión, pues el universo es tu servidor."
,"92":"Si en tu Ley no hubiera puesto mis delicias habría perecido en mi miseria."
,"93":"Jamás olvidaré tus ordenanzas pues por ellas me haces revivir."
,"94":"Tuyo soy, sálvame, ya que he buscado tus ordenanzas."
,"95":"Los malvados me espían para perderme, pero estoy atento a tus testimonios."
,"96":"He visto el fin de todo lo perfecto, ¡cuánto más amplio es tu mandamiento!"
,"97":"¡Cuánto amo tu Ley! En ella medito todo el día."
,"98":"Me haces más sabio que mis enemigos, por tu mandamiento que es siempre mío."
,"99":"Soy más agudo que todos mis maestros, merced a tus testimonios que medito."
,"100":"Superé a los ancianos en saber, pues guardo tus ordenanzas."
,"101":"Aparté mis pasos de todo mal camino, pues quería ser fiel a tu palabra."
,"102":"De tus juicios no me he apartado, pues tú me los enseñas."
,"103":"¡A mi paladar son dulces tus palabras, más que la miel para mi boca!"
,"104":"Tus ordenanzas me han dado la inteligencia, por eso odio cualquier ruta mentirosa."
,"105":"Para mis pasos tu palabra es una lámpara, una luz en mi sendero."
,"106":"He hecho un juramento y lo mantendré, de guardar tus justos juicios."
,"107":"He sido hasta el colmo afligido, vivifícame, Señor, según tu palabra."
,"108":"Acepta, Señor, la ofrenda de mi boca, y enséñame tus juicios."
,"109":"Expongo mi vida a cada instante, pero jamás me olvido de tu ley."
,"110":"Los malvados me han tendido una celada, pero no me alejé de tus ordenanzas."
,"111":"Tus testimonios han sido siempre mi herencia, son la alegría de mi corazón."
,"112":"Incliné mi corazón a cumplir tus preceptos, siempre y totalmente."
,"113":"Odio los corazones repartidos y amo tu Ley."
,"114":"Tú eres mi refugio y mi escudo, he puesto en tu palabra mi esperanza."
,"115":"Apártense de mi, agentes del mal, para que guarde los mandamientos de mi Dios."
,"116":"Sostenme según tu palabra, y viviré, que no sea en vano mi esperanza."
,"117":"Sé mi apoyo y estaré salvado, que tus preceptos sean siempre mis delicias."
,"118":"Desprecias a los que abandonan tus preceptos, sus proyectos no son más que mentira."
,"119":"Los malos del país son para ti la escoria, por eso yo amo tus testimonios."
,"120":"Ante ti mi carne tiembla de miedo, tus juicios me llenan de temor."
,"121":"He actuado con derecho y con justicia, no me entregues a mis opresores."
,"122":"Defiende la causa de tu servidor, no dejes que me opriman los soberbios."
,"123":"Por tu salvación mis ojos languidecen, y por tu justa palabra."
,"124":"Según tu amor actúa con tu siervo, y enséñame tus preceptos."
,"125":"Soy tu servidor, dame inteligencia para que conozca tus testimonios."
,"126":"Señor, es tiempo de que actúes, pues se viola tu Ley;"
,"127":"al verlo amo más tus mandamientos, los aprecio más que el oro fino."
,"128":"Me regulo por todos tus preceptos y odio cualquier camino de mentira."
,"129":"Maravillosos son tus testimonios por eso mi alma los guarda."
,"130":"Exponer tus palabras es dar luz y abrir la inteligencia de los sencillos."
,"131":"Abro una boca grande para aspirar, pues estoy ávido de tus mandamientos."
,"132":"Vuélvete a mí y ten de mí piedad, como los que aman tu nombre lo merecen."
,"133":"Afirma con tu palabra mis pasos, no dejes que me domine algún mal."
,"134":"Líbrame de la opresión del hombre, para que pueda observar tus ordenanzas."
,"135":"Haz brillar tu faz sobre tu siervo y enséñame tus preceptos."
,"136":"De mis ojos han brotado ríos de lágrimas, al ver que no se observa tu Ley."
,"137":"Tú eres justo, Señor, y rectos son tus juicios."
,"138":"Has dictado tus testimonios con justicia y con toda verdad."
,"139":"Me consumo de indignación, pues mis adversarios olvidan tus palabras."
,"140":"Tu palabra está totalmente comprobada, por eso tu servidor la ama."
,"141":"Aunque soy poca cosa y despreciable, no me olvido de tus ordenanzas."
,"142":"Tu justicia es justicia eternamente y tu Ley es verdad."
,"143":"Si me asaltan la angustia y la ansiedad, tus mandamientos aún son mis delicias."
,"144":"Tus testimonios son justicia eterna, dame inteligencia y viviré."
,"145":"Te invoco, Señor, con todo el corazón, respóndeme, pues quiero observar tus preceptos."
,"146":"Yo a ti clamo, sálvame, pues quiero guardar tus testimonios."
,"147":"Me adelanto a la aurora para clamarte, espero en tus palabras."
,"148":"Mis ojos se adelantaron a las horas y volví a meditar tu palabra."
,"149":"Por tu amor, Señor, oye mi voz, hazme vivir según tus juicios."
,"150":"Mis perseguidores se adhieren al crimen, pero se alejan de tu Ley."
,"151":"Tú estás cerca, Señor, y todos tus mandamientos son verdad."
,"152":"Lo que hace tiempo sé de tus testimonios es que los fundaste para siempre."
,"153":"Mira mi miseria y líbrame, pues no me he olvidado de tu Ley."
,"154":"Defiende mi causa y líbrame, que me vivifique tu palabra."
,"155":"La salvación está lejos de los impíos, pues no se interesan en tus preceptos."
,"156":"Frecuentes son, Señor, tus misericordias, hazme vivir según tus juicios."
,"157":"Mis perseguidores y mis enemigos son sin cuento, pero no me aparté de tus testimonios."
,"158":"Vi a los traidores y me dieron asco, pues no respetan tu palabra."
,"159":"Mira cuánto amo tus ordenanzas, Señor, hazme vivir según tu gracia."
,"160":"El principio de tu palabra es la verdad, tus juicios son justos para siempre."
,"161":"Si bien los príncipes me perseguían sin razón, mi corazón temía más a tus palabras."
,"162":"Tu palabra me llena de gozo como quien encuentra un gran tesoro."
,"163":"Detesto la mentira, la aborrezco, pero eso sí que amo tu Ley."
,"164":"Siete veces al día yo te alabo por tus juicios que son justos."
,"165":"Una paz grande para los que aman tu Ley, nada podrá hacerlos tropezar."
,"166":"Espero, Señor, tu salvación, y pongo en práctica tus mandamientos."
,"167":"Mi alma toma en cuenta tus testimonios, los amo totalmente."
,"168":"Observo tus ordenanzas, tus testimonios, a tu vista están todos mis caminos."
,"169":"¡Que mi grito se acerque a tu faz, Señor, según tu palabra, dame inteligencia!"
,"170":"¡Que mi súplica llegue hasta tu presencia, líbrame de acuerdo a tu palabra!"
,"171":"¡Que mis labios publiquen tu alabanza, pues tú me enseñas tus preceptos!"
,"172":"¡Que mi lengua celebre tu palabra, pues son justos todos tus mandamientos!"
,"173":"¡Que tu mano venga a socorrerme, pues yo elegí tus ordenanzas!"
,"174":"He ansiado, Señor, tu salvación, y tu Ley ha sido mi delicia."
,"175":"¡Que mi alma viva para alabarte, y tus juicios vendrán en mi ayuda!"
,"176":"Iba errante como oveja perdida, ven a buscar a tu servidor, pues bien sabes que no olvidé tus mandamientos."
}`)
	CurrentBook.AddChapter(120, `{
"1":"Al Señor en medio de mi angustia,yo clamé y él me respondió."
,"2":"Salva mi alma, Señor, de los labios mentirosos, de la lengua calumniadora."
,"3":"¿Qué se te dará o que se te agregará, oh lengua calumniadora?"
,"4":"Flechas muy puntiagudas de guerrero, endurecidas en brasas de retama."
,"5":"¡Ay de mí que en Mesec debo vivir,y habitar en las tiendas de Quedar!"
,"6":"Mi alma halló muy larga su permanencia,entre aquellos que detestan la paz."
,"7":"Estoy por la paz, pero apenas de eso hablo, ellos no piensan más que en guerra."
}`)
	CurrentBook.AddChapter(121, `{
"1":"Dirijo la mirada hacia los montes: ¿de dónde me llegará ayuda?"
,"2":"Mi socorro me viene del Señor, que hizo el cielo y la tierra."
,"3":"No deja que tu pie dé un paso en falso, no duerme tu guardián;"
,"4":"jamás lo rinde el sueño o cabecea,el guardián de Israel."
,"5":"El Señor es tu guardián y tu sombra, el Señor está a tu diestra."
,"6":"Durante el día el sol no te maltratará, ni la luna de noche."
,"7":"Te preserva el Señor de todo mal, él guarda tu alma."
,"8":"El te guarda al salir y al regresar, ahora y para siempre."
}`)
	CurrentBook.AddChapter(122, `{
"1":"Me puse alegre cuando me dijeron: '¡Vamos a la casa del Señor!'"
,"2":"Ahora nuestros pasos se detienen,delante de tus puertas, Jerusalén."
,"3":"Jerusalén, edificada cual ciudad,en que todo se funde en la unidad."
,"4":"Allá suben las tribus, las tribus del Señor, la asamblea de Israel, para alabar el Nombre del Señor."
,"5":"Pues allí están las cortes de justicia, los ministerios de la casa de David."
,"6":"Para Jerusalén pidan la paz: '¡Que vivan tranquilos los que te aman!"
,"7":"¡Que la paz guarde tus muros,y haya seguridad en tus palacios!'"
,"8":"Por mis hermanos y por mis amigos,quiero decir: '¡La paz esté contigo!'"
,"9":"Por la casa del Señor nuestro Dios, pido para ti la felicidad."
}`)
	CurrentBook.AddChapter(123, `{
"1":"A ti he elevado mis ojos, a ti que habitas en los cielos."
,"2":"Como los ojos de los siervos,se fijan en la mano de su dueño, como miran los ojos de una esclava,la mano de su dueña, así miran nuestros ojos al Señor, nuestro Dios, ¿cuándo tendrá piedad de nosotros?"
,"3":"Ten piedad de nosotros, Señor, ten piedad, porque estamos saturados de desprecios."
,"4":"Nuestra alma está colmada,de las burlas de la gente acomodada, del desprecio de los engreídos."
}`)
	CurrentBook.AddChapter(124, `{
"1":"De no estar el Señor en favor nuestro, que lo diga Israel,"
,"2":"de no estar el Señor en favor nuestro, cuando el mundo se lanzó contra nosotros,"
,"3":"nos habrían devorado vivos,en el fuego de su cólera."
,"4":"Entonces las aguas nos habrían arrollado,y el torrente pasado por encima,"
,"5":"entonces habrían pasado sobre nuestra alma,las aguas impetuosas."
,"6":"Bendito sea el Señor que no nos dio,por presa de sus dientes."
,"7":"Nuestra alma como pájaro escapó,de la red que puso el cazador. La malla se rompió,y nosotros escapamos."
,"8":"Nuestro auxilio está en el Nombre del Señor, que hizo el cielo y la tierra."
}`)
	CurrentBook.AddChapter(125, `{
"1":"Los que buscan apoyo en el Señor,se parecen al monte Sión: inconmovible y estable para siempre."
,"2":"Jerusalén, los montes la rodean, así el Señor está en torno a su pueblo,desde ahora y para siempre."
,"3":"Jamás el cetro impío se impondrá,sobre la parcela de los justos, no sea que los justos,ensangrienten sus manos en el crimen."
,"4":"Con los buenos, Señor, pórtate bien, con los que tienen rectitud de corazón."
,"5":"Mas a los que son dobles y traidores, los eche el Señor con los malhechores."
,"6":"¡Tenga paz Israel!"
}`)
	CurrentBook.AddChapter(126, `{
"1":"Cuando el Señor hizo volver,a los cautivos de Sión, nos parecía estar soñando;"
,"2":"nuestra boca se llenaba de risa,y nuestra lengua de gritos de alegría. Entonces entre los paganos se decía: '¡Qué grandes cosas no ha hecho el Señor por ellos!'"
,"3":"Sí, grandes cosas ha hecho el Señor por nosotros, rebosábamos de gozo."
,"4":"Haz que vuelvan, Señor, nuestros cautivos, como riachuelos en tierras áridas."
,"5":"Los que siembran entre lágrimas,cosecharán entre gritos de alegría."
,"6":"Se van, se van llorando,los que siembran la semilla, pero regresarán cantando,trayendo sus gavillas."
}`)
	CurrentBook.AddChapter(127, `{
"1":"Si el Señor no construye la casa,en vano trabajan los albañiles; si el Señor no protege la ciudad, en vano vigila el centinela."
,"2":"En vano te levantas tan temprano,y te acuestas tan tarde, y con tanto sudor comes tu pan: él lo da a sus amigos mientras duermen."
,"3":"Un regalo del Señor son los hijos, recompensa, el fruto de las entrañas."
,"4":"Como flechas en manos del guerrero,son los hijos de la juventud."
,"5":"Feliz el hombre que con tales flechas,ha llenado su aljaba, cuando a la puerta vayan a litigar,"
,"4":"sus contrarios no los harán callar."
}`)
	CurrentBook.AddChapter(128, `{
"1":"Felices los que temen al Señor,y siguen sus caminos."
,"2":"Comerás del trabajo de tus manos, esto será tu fortuna y tu dicha."
,"3":"Tu esposa será como vid fecunda,en medio de tu casa, tus hijos serán como olivos nuevos,alrededor de tu mesa."
,"4":"Así será bendito,el hombre que teme al Señor."
,"5":"¡Que el Señor te bendiga desde Sión: puedas ver la dicha de Jerusalén,durante todos los días de tu vida!,¡Que veas a los hijos de tus hijos,y en Israel, la paz!"
}`)
	CurrentBook.AddChapter(129, `{
"1":"Me han atacado mucho desde joven, que lo diga Israel;"
,"2":"me han atacado mucho desde joven, pero no me vencieron."
,"3":"Sobre mi espalda araron labradores, abrieron largos surcos;"
,"4":"pero el Señor, el justo, cortó las cuerdas de los malos."
,"5":"Que sean humillados y rechazados,todos los que odian a Sión;"
,"6":"que sean como la hierba de los techos,que se seca antes de que la arranquen,"
,"7":"que no le llena la mano al segador,ni su regazo al que amarra las gavillas."
,"8":"Que tampoco digan los que pasan: '¡Que el Señor los bendiga!',En nombre del Señor los bendecimos."
}`)
	CurrentBook.AddChapter(130, `{
"1":"Desde el abismo clamo a ti, Señor,"
,"2":"¡Señor, escucha mi voz!,que tus oídos pongan atención,al clamor de mis súplicas!"
,"3":"Señor, si no te olvidas de las faltas, Adonai, ¿quién podrá subsistir?"
,"4":"Pero de ti procede el perdón, y así se te venera."
,"5":"Espero, Señor, mi alma espera, confío en tu palabra;"
,"6":"mi alma cuenta con el Señor, más que con la aurora, el centinela."
,"7":"Como confía en la aurora el centinela, así Israel confíe en el Señor; porque junto al Señor está su bondad,y la abundancia de sus liberaciones,"
,"8":"y él liberará a Israel,de todas sus culpas."
}`)
	CurrentBook.AddChapter(131, `{
"1":"Señor, mi corazón no es engreído,ni mis ojos altaneros: no he tomado un camino de grandezas,ni de prodigios que me superaran."
,"2":"Al contrario, tranquila y en silencio,he mantenido mi alma, como un niño saciado que se aprieta a su madre; mi alma en mí nada reclama."
,"3":"¡Que Israel cuente con el Señor, desde ahora y para siempre!"
}`)
	CurrentBook.AddChapter(132, `{
"1":"Señor, tenle en cuenta a David su total disponibilidad,"
,"2":"cuando hizo un juramento al Señor, una promesa al Fuerte de Jacob:"
,"3":"'No entraré en la tienda, que es mi casa, ni me tenderé en el lecho donde descanso,"
,"4":"no concederé el sueño a mis ojos ni descanso a mis párpados"
,"5":"hasta que halle un lugar para el Señor, una morada para el Fuerte de Jacob'."
,"6":"Hemos sabido que el Arca está en Efrata, la encontramos en los campos de Jaar."
,"7":"Entremos, pues, en su morada, postrémonos ante la tarima de sus pies."
,"8":"¡Levántate, Señor, y ven a tu reposo, tú y el Arca de tu fuerza!"
,"9":"¡Que tus sacerdotes se revistan de justicia y tus fieles griten de alegría!"
,"10":"Por amor a David, tu servidor, no apartes la cara de tu ungido."
,"11":"El Señor se lo juró a David, verdad de la que no se desdecirá: 'Del fruto de tus entrañas pondré a alguien en tu trono."
,"12":"Si tus hijos guardaren mi alianza y mis testimonios que les he enseñado, también sus hijos para siempre se sentarán en tu trono'."
,"13":"Y el Señor escogió a Sión, quiso que fuera su residencia:"
,"14":"'Aquí está mi descanso para siempre, en ella moraré, pues yo lo quise."
,"15":"Sus graneros los bendeciré y a sus pobres los saciaré de pan."
,"16":"De gloria revestiré a sus sacerdotes y sus fieles gritarán de júbilo."
,"17":"Allí haré brotar un cuerno para David, allí pondré una lámpara para mi ungido."
,"18":"Cubriré de vergüenza a sus enemigos, mientras sobre él brillará su diadema'."
}`)
	CurrentBook.AddChapter(133, `{
"1":"¡Qué bueno y qué tierno es,ver a esos hermanos vivir juntos!"
,"2":"Es como un aceite refinado,que desde su cabeza,desciende hasta la barba, la barba de Aarón, hasta el cuello de su túnica."
,"3":"Es como un rocío del Hermón, que baja sobre las montañas de Sión. Allí el Señor otorgó su bendición, la vida para siempre."
}`)
	CurrentBook.AddChapter(134, `{
"1":"¡Ea, vamos! Bendigan al Señor,todos los servidores del Señor, los que sirven en la casa del Señor, en los atrios de la casa de nuestro Dios."
,"2":"Alcen sus manos al Santuario por las noches, y bendigan al Señor."
,"3":"Que el Señor desde Sión te bendiga, el que ha hecho los cielos y la tierra."
}`)
	CurrentBook.AddChapter(135, `{
"1":"Alaben el nombre del Señor, alábenlo servidores del Señor,"
,"2":"que sirven en la casa del Señor, en los atrios de la casa de nuestro Dios."
,"3":"Alaben al Señor porque él es bueno, cántenle a su nombre porque es delicioso."
,"4":"Porque el Señor se escogió a Jacob, a Israel, para que fuera su propiedad."
,"5":"Yo sé que el Señor es grande, que nuestro Señor supera a todos los dioses."
,"6":"Todo lo que quiere lo hace el Señor, en los cielos y en la tierra, en los océanos y en todos los mares."
,"7":"Del confín de la tierra hace subir las nubes, produce con relámpagos la lluvia, saca de sus depósitos el viento."
,"8":"Hirió a los primogénitos de Egipto, a los hombres igual que a los ganados."
,"9":"Envió señales y prodigios en medio de ti, Egipto, en contra del Faraón y de todos sus siervos."
,"10":"A numerosas naciones les pegó y dio muerte a reyes poderosos:"
,"11":"a Sijón, rey de los amorreos, a Og, rey de Basán, y a todos los reyes de Canaán."
,"12":"Y su tierra la entregó en herencia, en herencia a su pueblo de Israel."
,"13":"Señor, tu nombre dura para siempre, y tu recuerdo por generaciones."
,"14":"Pues el Señor hará justicia a su pueblo, y se apiadará de sus servidores."
,"15":"De oro y plata son los ídolos de las naciones, obra de las manos de los hombres;"
,"16":"tienen boca y no hablan, ojos, pero no ven;"
,"17":"tienen orejas, pero no oyen, ni siquiera un suspiro hay en su boca."
,"18":"Que sean como ellos sus autores y todos los que en ellos se confían."
,"19":"Casa de Israel, bendigan al Señor, casa de Aarón, bendigan al Señor,"
,"20":"casa de Leví, bendigan al Señor, los que temen al Señor, que lo bendigan."
,"21":"Bendito sea el Señor desde Sión, él, que reside en Jerusalén."
}`)
	CurrentBook.AddChapter(136, `{
"1":"Den gracias al Señor, porque él es bueno, porque su amor perdura para siempre."
,"2":"Den gracias al que es Dios de los dioses, porque su amor perdura para siempre."
,"3":"Den gracias al Señor de los señores, porque su amor perdura para siempre."
,"4":"Al único que ha hecho maravillas, porque su amor perdura para siempre."
,"5":"Al que con sabiduría hizo los cielos, porque su amor perdura para siempre."
,"6":"Al que puso la tierra sobre las aguas, porque su amor perdura para siempre."
,"7":"Al que creó las grandes luminarias, porque su amor perdura para siempre."
,"8":"Al sol para que gobierne el día, porque su amor perdura para siempre."
,"9":"La luna y las estrellas para que manden la noche, porque su amor perdura para siempre."
,"10":"Al que hirió a Egipto en sus primogénitos, porque su amor perdura para siempre."
,"11":"Y a Israel lo sacó de en medio de ellos, porque su amor perdura para siempre."
,"12":"Con mano fuerte y brazo levantado, porque su amor perdura para siempre."
,"13":"Al que separó en dos el Mar de Juncos, porque su amor perdura para siempre."
,"14":"Y condujo a Israel por medio de él, porque su amor perdura para siempre."
,"15":"Allí tumbó a Faraón y a su ejército, porque su amor perdura para siempre."
,"16":"Al que guió a su pueblo en el desierto, porque su amor perdura para siempre."
,"17":"Al que aplastó a reyes poderosos, porque su amor perdura para siempre."
,"18":"Y dio muerte a monarcas respetables, porque su amor perdura para siempre."
,"19":"A Sijón, rey de los Amorreos, porque su amor perdura para siempre."
,"20":"Y a Og, rey de Basán, porque su amor perdura para siempre."
,"21":"Y traspasó sus tierras como herencia, porque su amor perdura para siempre."
,"22":"Como herencia a Israel, su servidor, porque su amor perdura para siempre."
,"23":"Se acordó de nosotros en nuestro abatimiento, porque su amor perdura para siempre."
,"24":"Y nos libró de nuestros opresores, porque su amor perdura para siempre."
,"25":"El da su pan a todo ser carnal, porque su amor perdura para siempre."
,"26":"Den gracias al que es Dios de los cielos, porque su amor perdura para siempre."
}`)
	CurrentBook.AddChapter(137, `{
"1":"Al borde de los canales de Babilonia,nos sentábamos y llorábamos"
,"2":"al acordarnos de Sión; en los sauces que por allí se encuentran,habíamos colgado nuestras arpas."
,"3":"Allí los que nos habían deportado,nos pedían palabras de una canción, y nuestros raptores un canto de alegría: '¡Cántennos un canto de Sión!'"
,"4":"¿Cómo íbamos a cantar un canto del Señor,en un suelo extranjero?"
,"5":"¡Si me olvido de ti, Jerusalén, que mi derecha se olvide de mí!"
,"6":"Que mi lengua se me pegue al paladar,si de ti no me acuerdo, si no considero a Jerusalén,como mi máxima alegría."
,"7":"No te olvides, Señor, de los hijos de Edom,que, el día en que cayó Jerusalén, decían: '¡Arrásenla, arrásenla hasta los mismos cimientos!'"
,"8":"Hija de Babilonia, que serás destruida, dichoso el que te hiciere,los males que a nosotros nos hiciste."
,"9":"¡Dichoso aquel que agarre a tus pequeños,y los estrelle contra las rocas!"
}`)
	CurrentBook.AddChapter(138, `{
"1":"Te doy gracias, Señor, de todo corazón, pues oíste las palabras de mi boca. Canto para ti en presencia de los ángeles,"
,"2":"y me postro ante tu Templo santo. Doy gracias a tu nombre por tu amor y tu verdad, pues tu palabra ha superado tu renombre."
,"3":"El día en que clamé, me respondiste,y aumentaste la fuerza en mi alma."
,"4":"Te darán gracias, Señor, todos los reyes de la tierra, cuando oigan las palabras de tu boca,"
,"5":"celebrarán los caminos del Señor: '¡Es muy grande la gloria del Señor!'"
,"6":"Desde arriba el Señor ve a los humildes,y de lejos distingue al orgulloso."
,"7":"Si en medio de angustias caminare, tú me harías vivir; con tu mano paras al enemigo,y tu diestra me salva."
,"8":"El Señor lo hará todo por mí, Señor, tu amor perdura para siempre, no abandones la obra de tus manos."
}`)
	CurrentBook.AddChapter(139, `{
"1":"Señor, tú me examinas y conoces,"
,"2":"sabes si me siento o me levanto, tú conoces de lejos lo que pienso."
,"3":"Ya esté caminando o en la cama me escudriñas, eres testigo de todos mis pasos."
,"4":"Aún no está en mi lengua la palabra,cuando ya tú, Señor, la conoces entera."
,"5":"Me aprietas por detrás y por delante,y colocas tu mano sobre mí."
,"6":"Me supera ese prodigio de saber, son alturas que no puedo alcanzar."
,"7":"¿A dónde iré lejos de tu espíritu, a dónde huiré lejos de tu rostro?"
,"8":"Si escalo los cielos, tú allí estás, si me acuesto entre los muertos, allí también estás."
,"9":"Si le pido las alas a la aurora,para irme a la otra orilla del mar,"
,"10":"también allá tu mano me conduce,y me tiene tomado tu derecha."
,"11":"Sí digo entonces: '¡Que me oculten, al menos, las tinieblas,y la luz se haga noche sobre mí!'"
,"12":"Mas para ti ni son oscuras las tinieblas,y la noche es luminosa como el día."
,"13":"Pues eres tú quien formó mis riñones, quien me tejió en el seno de mi madre."
,"14":"Te doy gracias por tantas maravillas, admirables son tus obras,y mi alma bien lo sabe."
,"15":"Mis huesos no te estaban ocultos,cuando yo era formado en el secreto, o bordado en lo profundo de la tierra."
,"16":"Tus ojos veían todos mis días, todos ya estaban escritos en tu libro,y contados antes que existiera uno de ellos."
,"17":"¡Tus pensamientos, Dios, cuanto me superan, qué impresionante es su conjunto!"
,"18":"¿Pormenorizarlos? Son más que las arenas, nunca terminaré de estar contigo."
,"19":"¡Ojalá, oh Dios, mataras al malvado,y se alejaran de mí los sanguinarios;"
,"20":"arman maquinaciones en tu contra,y no toman en cuenta tus declaraciones!"
,"21":"Señor, ¿no debo odiar a los que te odian,y estar hastiado de los que te atacan?"
,"22":"Con un odio perfecto yo los odio,y para mí también son enemigos."
,"23":"Examíname, oh Dios, mira mi corazón, ponme a prueba y conoce mi inquietud;"
,"24":"fíjate si es que voy por mal camino,y condúceme por la antigua senda."
}`)
	CurrentBook.AddChapter(140, `{
"2":"Líbrame, Señor, del hombre malvado, defiéndeme de la gente violenta,"
,"3":"de los que en su corazón maquinan males y que provocan riñas cada día;"
,"4":"que cual serpiente afilan sus lenguas y veneno de víbora hay en sus labios."
,"5":"Señor, protégeme de las manos del impío, defiéndeme de la gente violenta, que piensan cómo hacerme tropezar."
,"6":"Los soberbios me han puesto un lazo oculto, han tendido redes bajo mis pies y me han puesto trampas junto al sendero."
,"7":"Dije al Señor: 'Tú eres mi Dios, presta atención, Señor, a la voz de mi súplica'."
,"8":"Señor Dios, poderoso para salvar, tú cubres mi cabeza el día del combate."
,"9":"No consientas, Señor, los deseos del malvado, no dejes que su plan se realice."
,"10":"Que no alcen la cabeza los que me asedian, que la malicia de sus labios los ahogue;"
,"11":"que lluevan sobre ellos brasas ardientes, que los eches al abismo y no salgan."
,"12":"Que la tierra rechace al detractor y persiga al violento el mal sin tregua."
,"13":"Sé que el Señor hará justicia al desvalido y dará a los pobres la razón."
,"14":"Los justos darán gracias a tu Nombre, los hombres rectos se quedarán en tu presencia."
}`)
	CurrentBook.AddChapter(141, `{
"1":"Señor, te llamo, ven a mí sin demora, oye mi voz cuando te grito."
,"2":"¡Suba a ti mi oración como el incienso, mis manos que a ti levanto sean como la ofrenda de la tarde!"
,"3":"Pon, Señor, una guardia ante mi boca y vigila la puerta de mis labios."
,"4":"Mi corazón no inclines a obras malas, que en negocios oscuros no me meta con los que hacen el mal. ¡No me dejes probar sus golosinas!"
,"5":"Que el justo me golpee y me corrija y el óleo de los malos no luzca en mi cabeza. Mi oración denunciará siempre sus crímenes."
,"6":"Sus jefes fueron echados desde el peñón, comprendieron entonces que hablaba con bondad;"
,"7":"cuando la tierra se abrió a sus pies, sus huesos tapizaron la entrada del infierno."
,"8":"Adonai Señor, hacia ti vuelvo mis ojos, en ti me refugio, no expongas mi vida."
,"9":"Protégeme del lazo que me han tendido, de las trampas de los que hacen el mal."
,"10":"Que en sus propias redes caigan los impíos mientras que sólo a mí se me abre paso."
}`)
	CurrentBook.AddChapter(142, `{
"2":"Al Señor imploro a grandes voces, al Señor suplico a grandes voces."
,"3":"En su presencia explayo mi lamento,y ante él relato mi aflicción"
,"4":"cuando en mí desfallece mi espíritu, pero tú, ¿no conoces mi sendero?,En el camino por donde pasaba,ocultaron una trampa."
,"5":"Dirige a la derecha tu mirada,y ve cómo ninguno me conoce. Lejos de mí está cualquier refugio, nadie se preocupa de mi vida."
,"6":"¡A ti clamo, Señor, a ti te digo: 'Tú eres mi esperanza, mi parte en la tierra de los que viven!'"
,"7":"Atiende a mi clamor,porque estoy muy decaído. Ponme a salvo de mis perseguidores, que son más fuertes que yo."
,"8":"Sácame de la prisión,para que dé gracias a tu Nombre. una ronda harán los justos en torno a mí,al saber los favores que me has hecho."
}`)
	CurrentBook.AddChapter(143, `{
"1":"Señor, escucha mi oración, atiende a mis plegarias, respóndeme, tú que eres fiel y justo."
,"2":"No llames a juicio a tu siervo pues no hay quien sea justo en tu presencia."
,"3":"El enemigo corre tras mi vida, me aplasta contra el suelo y me manda de vuelta a las tinieblas junto a los muertos sin edad ni tiempo."
,"4":"Mi espíritu en mí desfallece, mi corazón se asusta en mi interior."
,"5":"Me acuerdo de los días de otro tiempo, medito en todas tus acciones, en la obra de tus manos reflexiono."
,"6":"Alargo a ti mis manos, mi alma es una tierra sedienta de ti."
,"7":"Apresúrate, Señor, en responderme, porque me estoy quedando sin resuello; no me escondas tu cara, que no sea de los que bajan a la fosa."
,"8":"Hazme sentir tu amor desde la mañana, pues en ti yo confío; haz que sepa el camino que he de seguir, pues levanto a ti mi alma."
,"9":"Líbrame, Señor, de mis enemigos, pues me escondí cerca de ti."
,"10":"Enséñame a que haga tu voluntad, ya que tú eres mi Dios; que tu buen espíritu me guíe por un terreno plano."
,"11":"Por el honor de tu nombre, Señor, haz que yo viva; tú que eres justo, sácame del aprieto."
,"12":"Por tu amor aniquila a mis contrarios y destruye a mis opresores, pues yo soy tu servidor."
}`)
	CurrentBook.AddChapter(144, `{
"1":"Bendito sea el Señor, Roca mía, que mis manos adiestra para el combate y mis dedos para la batalla."
,"2":"El es mi refugio y mi baluarte, mi fortaleza y mi libertador, mi escudo en que me amparo, él humilla a los pueblos a mis pies."
,"3":"Señor, ¿qué es el hombre para que de él te acuerdes? ¿Qué es el hijo de Adán para que en él pienses?"
,"4":"El hombre es como un soplo, sus días como la sombra que pasa."
,"5":"Señor, inclina tus cielos y desciende, toca los montes para que echen humo."
,"6":"Envía tus relámpagos, dispérsalos, tira tus flechas y cáusales estragos."
,"7":"Desde lo alto tiéndeme tus manos, sálvame sacándome de las aguas profundas y de las manos de los hijos de extranjeros,"
,"8":"cuya boca dice falsedades y su diestra es una diestra de perjurio."
,"9":"Oh Dios, quiero cantarte un canto nuevo, y tocar para ti en la lira de diez cuerdas,"
,"10":"a ti que das a los reyes la victoria, que salvas a David, tu servidor de la espada que mata (11)."
,"12":"Aquí están nuestros hijos como plantas que van creciendo desde su niñez; nuestras hijas son columnas angulares esculpidas en el frontis de un palacio."
,"13":"Están nuestros graneros muy repletos, rebosantes de toda clase de cosechas; nuestras ovejas se cuentan por miles, por millares se ven en nuestros campos;"
,"14":"nuestras bestias viajan muy cargadas. No hay hoyos en los muros ni rendiciones, ni gritos de lamento en nuestras plazas."
,"15":"Dichoso el pueblo que esta suerte tiene, dichoso el pueblo cuyo Dios es el Señor."
}`)
	CurrentBook.AddChapter(145, `{
"1":"Te celebro, oh Rey mi Dios, y bendigo tu nombre para siempre."
,"2":"Deseo bendecirte cada día, alabaré tu Nombre para siempre."
,"3":"Grande es el Señor, muy digno de alabanza, y no puede medirse su grandeza."
,"4":"De generación en generación,se celebran tus obras, se cuentan tus proezas."
,"5":"El esplendor, la gloria de tu Nombre, tus maravillas, los repetiré."
,"6":"De tu poder formidable se hablará, y tus grandezas yo las contaré."
,"7":"Nos harán recordar tu gran bondad,y se proclamará tu justicia."
,"8":"El Señor es ternura y compasión, paciente y lleno de amor."
,"9":"El Señor es bondad para con todos, sus ternuras están en todas sus obras."
,"10":"Te den gracias, Señor, todas tus obras, te bendigan tus amigos;"
,"11":"que hablen de la gloria de tu reino,y anuncien tus hazañas,"
,"12":"para que vean los hombres tus proezas, el brillo y la gloria de tu reino."
,"13":"Tu reino es reino por todos los siglos, y tu imperio por todas las edades. Fiel es el Señor en todas sus palabras,y bondadoso en todas sus obras."
,"14":"Sostiene el Señor a todos los que caen, a los que están encorvados endereza."
,"15":"Los ojos de todos de ti esperan,que les des a su tiempo su alimento."
,"16":"Tú sólo abres tu mano, y satisfaces,de lo que quiera a todo ser viviente."
,"17":"Justo es el Señor en todos sus caminos,y bondadoso en todas sus obras."
,"18":"Cerca está el Señor de los que le invocan, de todos los que lo invocan de verdad."
,"19":"Les da en el gusto a todos los que lo temen, escucha su clamor y los salva."
,"20":"El Señor guarda a todos los que lo aman, y a todos los malvados extermina. ¡Que mi boca proclame la alabanza del Señor,y todo ser carnal bendiga su santo nombre, por siempre y para siempre!"
}`)
	CurrentBook.AddChapter(146, `{
"1":"¡Aleluya!,¡Alaba al Señor, alma mía!"
,"2":"Mientras viva yo quiero alabar al Señor, quiero salmodiar para el Señor mientras exista."
,"3":"No pongas tu confianza en los que mandan, ni en el mortal, que no puede salvarte;"
,"4":"no bien se le va el alma, vuelve al polvo, y ese día se acaban sus proyectos."
,"5":"Dichoso aquel que al Dios de Jacob tiene de ayuda,y pone su esperanza en el Señor, su Dios,"
,"6":"en el que hizo los cielos y la tierra, el mar y todo cuanto ellos encierran. El su lealtad conserva siempre,"
,"7":"y su justicia da a los oprimidos, proporciona su pan a los hambrientos. El Señor deja libres a los presos."
,"8":"el Señor da la vista a los ciegos, el Señor endereza a los encorvados, el Señor ama a los justos;"
,"9":"da el Señor protección al forastero, y reanima al huérfano y a la viuda, mas desvía el camino de los malvados."
,"10":"El Señor reina para siempre, tu Dios, Sión, de generación en generación."
}`)
	CurrentBook.AddChapter(147, `{
"1":"Alaben al Señor porque él es bueno, canten a nuestro Dios porque es amable, porque a él le conviene la alabanza."
,"2":"Reconstruye el Señor Jerusalén, reúne a los exiliados de Israel,"
,"3":"sana los corazones destrozados,y venda sus heridas."
,"4":"El cuenta las estrellas una a una,y llama a cada una por su nombre."
,"5":"Grande es nuestro Señor, todo lo puede, no se puede medir su inteligencia."
,"6":"Reanima el Señor a los humildes, pero humillla hasta el polvo a los malvados."
,"7":"Entonen al Señor la acción de gracias, para nuestro Dios toquen sus arpas."
,"8":"Porque él cubre de nubes los cielos, y prepara las lluvias de la tierra, hace brotar la hierba en las colinas,y las plantas que el hombre ha de cultivar;"
,"9":"él entrega a las bestias su alimento,y a las crías del cuervo cuando graznan."
,"10":"No le atraen los bríos del caballo, ni un hombre por sus músculos le agrada;"
,"11":"se complace el Señor en los que le temen, en los que esperan en su amor."
,"12":"¡Glorifica al Señor, Jerusalén, a tu Dios alaba, oh Sión!"
,"13":"El refuerza las trancas de tus puertas,y bendice a tus hijos en tu seno;"
,"14":"guarda en paz tus fronteras, te da del mejor trigo en abundancia."
,"15":"Si a la tierra envía su mensaje, su palabra corre rápidamente;"
,"16":"esparce la nieve como lana,y derrama la escarcha cual ceniza."
,"17":"En trocitos arroja su granizo, ¿a su frío quién puede resistir?"
,"18":"Envía su palabra y los derrite, sopla su viento y corren las aguas."
,"19":"A Jacob le revela su palabra, sus leyes y sus juicios a Israel."
,"20":"Con ningún otro pueblo ha actuado así, ni les dio a conocer sus decisiones."
}`)
	CurrentBook.AddChapter(148, `{
"1":"¡Aleluya!,Alaben al Señor desde los cielos, alábenlo en las alturas,"
,"2":"alábenlo todos sus ángeles, alábenlo todos sus ejércitos."
,"3":"Alábenlo el sol y la luna, alábenlo todos los astros de luz;"
,"4":"alábenlo cielos de los cielos,y las aguas por encima de los cielos."
,"5":"Alaben el nombre del Señor, pues lo ordenó y fueron creados;"
,"6":"los puso por los siglos de los siglos,bajo una ley que nunca cambiará."
,"7":"Alaben al Señor desde la tierra, monstruos del mar y todos sus abismos,"
,"8":"fuego y granizo, nieve y neblina, huracán que ejecuta su palabra,"
,"9":"las montañas y todas las colinas, árboles frutales y todos los cedros, animales salvajes y domésticos, reptiles y aves que vuelan,"
,"11":"reyes de la tierra, todas las naciones, príncipes y los que gobiernan la tierra,"
,"12":"jóvenes y muchachas, ancianos con los niños."
,"13":"Alaben el nombre del Señor,pues su Nombre es el único sublime, su majestad excede tierra y cielo."
,"14":"Levantó la cornamenta de su pueblo, causa de orgullo para todos sus amigos, para Israel, el pueblo que a él se acerca."
}`)
	CurrentBook.AddChapter(149, `{
"1":"¡Aleluya!,Canten al Señor un canto nuevo: su alabanza en la asamblea de los santos."
,"2":"Alégrese Israel de quien lo hizo, festejen a su rey, hijos de Sión."
,"3":"Su nombre alaben en medio de danzas, el arpa y el tambor toquen para él."
,"4":"Pues el Señor se siente bien con su pueblo, con su salvación reviste a los humildes."
,"5":"De júbilo triunfante rebosan sus fieles, de sus esteras gritan de alegría;"
,"6":"en su garganta están los elogios de Dios y en su mano, la espada de dos filos,"
,"7":"para ejercer venganza entre los pueblos y dar a las naciones el castigo,"
,"8":"para atar con cadenas a sus reyes y con grillos de hierro a sus notables,"
,"9":"para aplicarles la sentencia escrita: eso es un honor para todos los suyos."
}`)
	CurrentBook.AddChapter(150, `{
"1":"¡Aleluya!,¡Alaben a Dios en su santuario, alábenlo en el firmamento de su poder!"
,"2":"Alábenlo por sus hechos portentosos, alábenlo por toda su grandeza!"
,"3":"¡Alábenlo con el fragor del cuerno, alábenlo con arpas y con cítaras,"
,"4":"alábenlo con danzas y tamboriles, alábenlo con mandolinas y flautas,"
,"5":"alábenlo con platillos sonoros, alábenlo con platillos triunfales!"
,"6":"¡Alabe al Señor todo ser que respira!,¡Aleluya!"
}`)

}
func ES_LBL_LoadVSSPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Amen la justicia, ustedes que gobiernan la tierra, tengan para con el Señor los sentimientos que convienen, búsquenlo con un corazón sincero."
,"2":"Porque se deja encontrar por los que no lo provocan, se manifiesta a los que le tienen confianza."
,"3":"Sepan que los razonamientos tortuosos alejan de Dios: La Omnipotencia pondrá en su lugar a los insensatos que la ponen a prueba."
,"4":"La Sabiduría no entrará en un alma mal dispuesta, ni habitará en un cuerpo esclavo del pecado."
,"5":"El Espíritu Santo que nos educa huye de la duplicidad; rechaza los pensamientos estúpidos y se paraliza frente a la maldad."
,"6":"La Sabiduría es un espíritu que ama a los hombres, pero no dejará sin castigo al que blasfema, porque Dios conoce sus pensamientos íntimos, ve claro en su corazón y escucha sus palabras."
,"7":"Porque el Espíritu del Señor repleta el universo y mantiene su unidad: conoce, pues, todo lo que se dice."
,"8":"Por eso, cualquiera que tome una decisión injusta no puede escapársele; no quedará sin sanción, éste lo reducirá al silencio."
,"9":"Los proyectos del impío serán investigados, sus palabras serán transmitidas al Señor y sus crímenes serán castigados."
,"10":"Sepan que hay un oído atento que lo escucha todo, y nada de lo que se murmura se le escapa."
,"11":"Déjense pues de quejas injustificadas, eviten los propósitos condenables, pues ni siquiera la palabra dicha en secreto queda sin consecuencias y la boca mentirosa mata al alma."
,"12":"¡Nada de vida desordenada, eso sería buscar la muerte! No hagan cosas que les acarrearían la desgracia."
,"13":"Porque Dios no hizo la muerte, y no le gusta que se pierdan los vivos."
,"14":"El creó todas las cosas para que existan; las especies que aparecen en la naturaleza son medicinales, y no traen veneno ni muerte. La tierra no está sometida a la muerte,"
,"15":"pues el orden de la justicia está más allá de la muerte."
,"16":"Los impíos, sin embargo, llaman a la muerte con gestos y palabras; ven en ella a una amiga y se han prendado de ella; han hecho con ella un pacto y se hacen merecedores de caer en sus manos."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Partiendo de falsos razonamientos sacan estas conclusiones: 'Nuestra vida es corta y llena de decepciones, tendremos un fin y será sin remedio: nunca se ha visto que alguien haya subido del mundo de los muertos."
,"2":"Nacimos por pura casualidad, y cuando lleguemos al final será como si no hubiésemos existido. Nuestro soplo vital no es más que el vapor de nuestro aliento; nuestro pensamiento salta como una chispa del latido de nuestro corazón."
,"3":"Cuando llegue a extinguirse, el cuerpo regresará al polvo, y el espíritu se dispersará como una bocanada de aire."
,"4":"Con el tiempo se olvidarán de nuestro nombre, nadie más pensará en lo que hicimos; nuestra vida pasa como la sombra de una nube, se desvanece como niebla a los rayos del sol."
,"5":"Nuestra vida es sólo el paso de una sombra, cuando llega el fin es sin vuelta: una vez sellado, nadie vuelve."
,"6":"Vengan, pues, gocemos de los bienes presentes, aprovechémonos de todo, ¡ea, vamos, es la juventud!,"
,"7":"¡que haya vino y perfumes!"
,"8":"¡No dejemos que se marchiten las rosas, pongámoslas en nuestra corona!"
,"9":"¡Que nadie de nosotros falte a nuestra comilonas; por todas partes dejaremos recuerdos de nuestras fiestas, pues ésa es nuestra herencia y nuestra suerte."
,"10":"Seamos duros con esos pobres piadosos, y lo mismo con las viudas; ¡nada de respeto con los viejos de cabellos blancos!"
,"11":"¡Nuestra fuerza sea la ley! ¡La debilidad es prueba de que uno no sirve para nada!"
,"12":"Hagamos la guerra al que nos reprende porque violamos la Ley; nos recuerda cómo fuimos educados y nos echa en cara nuestra conducta."
,"13":"Pretende conocer a Dios y se proclama hijo del Señor."
,"14":"No hace más que contradecir nuestras ideas, y su sola presencia nos cae pesada."
,"15":"Lleva una vida distinta a la de todos y es rara su conducta."
,"16":"Nos considera unos degenerados, creería mancharse si actuara como nosotros. Habla de una felicidad para los justos al final y se vanagloría de tener a Dios por padre."
,"17":"Veamos, pues, si lo que dice es verdad y hagamos la prueba: ¿cómo se librará?"
,"18":"Si el justo es hijo de Dios, Dios lo ayudará y lo librará de sus adversarios."
,"19":"Sometámoslo a humillaciones y a torturas, veamos cómo las acepta, probemos su paciencia."
,"20":"Luego, condenémoslo a una muerte infame pues, según él, alguien intenvendrá.'"
,"21":"Así, es como razonan, pero están equivocados. Su maldad los enceguece,"
,"22":"de tal manera que no conocen los secretos de Dios. No esperan la recompensa de una vida santa, ni creen que las almas puras tendrán su paga."
,"23":"Pero Dios creó al hombre a imagen de lo que en El es invisible, y no para que fuera un ser corruptible."
,"24":"La envidia del diablo introdujo la muerte en el mundo, y la experimentan los que toman su partido."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Las almas de los justos están en las manos de Dios y ningún tormento podrá alcanzarlos."
,"2":"A los ojos de los insensatos están bien muertos y su partida parece una derrota."
,"3":"Nos abandonaron: parece que nada quedó de ellos. Pero, en realidad, entraron en la paz."
,"4":"Aunque los hombres hayan visto en eso un castigo, allí estaba la vida inmortal para sostener su esperanza:"
,"5":"después de una corta prueba recibirán grandes recompensas. Sí, Dios los puso a prueba y los encontró dignos de él. "
,"6":"Los probó como al oro en el horno donde se funden los metales, y los aceptó como una ofrenda perfecta."
,"7":"Cuando venga Dios a visitarnos, serán luz, semejantes a la centella que corre por entre la maleza."
,"8":"Gobernarán naciones y dominarán a los pueblos, y el Señor será su rey para siempre."
,"9":"Los que confiaron en él conocerán la verdad, los que fueron fieles en el amor permanecerán junto a él."
,"10":"Pero los impíos que menospreciaron al justo y renegaron del Señor serán castigados por sus malas intenciones."
,"11":"Sí, ay de aquellos que rechazan la sabiduría y la disciplina: ¡para ellos toda esperanza es vana, todo esfuerzo inútil, toda obra estéril!"
,"12":"También son estúpidas sus mujeres, y sus hijos, perversos: una maldición se cierne sobre su descendencia."
,"13":"Feliz la mujer sin hijos si ha permanecido pura, si no ha tenido alguna unión culpable; cuando sean juzgadas las almas, se verán sus frutos."
,"14":"Feliz también el eunuco si no tomó parte en el mal ni tuvo pensamientos de rebelión contra el Señor: su fidelidad será bien recompensada, tendrá un lugar de privilegio en el templo del Señor."
,"15":"Porque cualquier esfuerzo por el bien produce frutos admirables; el verdadero conocimiento es una raíz que nunca se seca."
,"16":"En cambio, los hijos nacidos del adulterio no maduran, la descendencia de una unión ilegítima desaparece."
,"17":"Si llegare a suceder que se prolonga su vida, no serán tomados en cuenta y por último envejecerán sin gloria."
,"18":"Y si mueren jóvenes, será sin esperanza: la espera del juicio no les servirá de consuelo."
,"19":"Sí, una raza malvada está condenada a una suerte cruel."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Más vale no haber tenido hijos pero haber actuado bien: uno será entonces considerado tanto por Dios como por los hombres y dejará un recuerdo imperecedero."
,"2":"A una vida tan recta, se la imita cuando se la ve y se la echa de menos cuando desaparece: en la eternidad recibe la corona de gloria porque triunfó en combates perfectos."
,"3":"Al contrario, la numerosa posteridad de un impío no significa nada: sus retoños bastardos no echarán raíces profundas ni se establecerán en tierra firme."
,"4":"Aunque por un tiempo echen brotes, sus débiles ramas serán sacudidas por el viento, y arrancadas por la tempestad."
,"5":"Sus ramas se quebrarán antes de crecer, sus frutos no servirán: ¡demasiado verdes para comerlos, sólo sirven para que los boten!"
,"6":"En el día del juicio, los hijos nacidos de uniones culpables testimoniarán en contra del pecado de sus padres."
,"7":"El justo en cambio, aunque muera prematuramente, encontrará su descanso."
,"8":"La edad que merece el respeto no depende de la duración de la vida, ni se mide por el número de años."
,"9":"¡El verdadero conocimiento es como tener los cabellos blancos! Una vida sin mancha equivale a una edad madura."
,"10":"Era recto, agradó a Dios que lo amó; pero como vivía en medio de los pecadores, fue sacado de allí."
,"11":"Dios lo sacó por temor a que el mal corrompiera su inteligencia o que su alma se dejara seducir por la mentira."
,"12":"Porque la fascinación del mal oculta los verdaderos valores y los reclamos del deseo conmueven a un alma sin malicia."
,"13":"Acabó pronto, pero había recorrido ya un largo camino."
,"14":"Su alma era preciosa a los ojos del Señor, por eso la retiró pronto de su ambiente corrompido. La gente al ver eso no entendió; no comprendieron "
,"15":"que la benevolencia y la misericordia de Dios acompañan a sus elegidos, y que él vela por los suyos."
,"16":"El justo que muere condena a los impíos que sobreviven, una vida joven que llega pronto a la perfección, denuncia la vejez interminable de los malvados."
,"17":"Verán pues la muerte del sabio, pero sin comprender las intenciones divinas al respecto, ni por qué el Señor lo puso a resguardo."
,"18":"Al ver eso podrán tal vez reírse, pero el Señor también se reirá de ellos"
,"19":"cuando a su vez sean cadáveres despreciables, y estén sin defensa entre los muertos. Porque el Señor los reducirá al silencio y los precipitará de cabeza; los arrancará de cuajo y los destruirá irremediablemente: entonces sabrán lo que es el dolor, cuando todos los hayan olvidado."
,"20":"Se presentarán temblando cuando se haga el recuento de sus pecados, y sus crímenes se alzarán frente a ellos."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Entonces el justo se presentará seguro de sí mismo frente a los que lo persiguieron,y que redujeron a nada todos sus esfuerzos."
,"2":"Al verlo comenzarán a temblar de un miedo inmenso, asombrados de ver que se ha salvado contra toda esperanza."
,"3":"Llenos de remordimiento, se dirán, muy angustiados, y con gemidos:"
,"4":"'Este es al que tomábamos para la risa, el objeto de nuestras bromas: ¡qué imbéciles éramos!,Su vida nos parecía una locura, su muerte nos pareció el fracaso final."
,"5":"Y véanlo ahora entre los hijos de Dios: ¿cómo fue que recibió su lugar entre los santos?"
,"6":"¡Cómo nos equivocamos lejos de la verdad!,La luz de la justicia no nos iluminó, el Sol no se levantó para nosotros."
,"7":"Nos hartamos de injusticias y crímenes, recorriendo desiertos de los cuales no salíamos, en vez de reconocer el camino del Señor."
,"8":"¿De qué nos sirvió nuestro orgullo?,¿De qué nos valió la riqueza,de la que tanto nos enorgullecíamos?"
,"9":"Todo eso pasó como una sombra, como un rumor que se disipa,"
,"10":"como el navío que corta la espuma del mar, y de cuyo paso no queda huella alguna, ni marca de su quilla en las olas."
,"11":"O como el pájaro que atraviesa el espacio,y los vestigios de su carrera nadie encuentra, que no deja ninguna señal de su trayecto. Sus plumas rozaron el aire leve, un silbido se produjo al partirlo, batiendo sus alas se abrió camino, pero después, ¿quién encontró alguna huella de su vuelo?"
,"12":"O como una flecha disparada al blanco: el aire que va cortando vuelve sobre sí mismo, sin permitir que se vea su camino."
,"13":"Así también nosotros, apenas nacimos desaparecimos; nos hemos agotado en nuestras malas obras,y no tenemos mérito alguno que podamos mostrar.'"
,"14":"Sí, la esperanza de los impíos es como la paja,que se la lleva el viento, o como el copo de nieve que arrastra la tormenta, como el humo disipado por el viento, o el recuerdo de un huésped de un día: que se olvida."
,"15":"Los justos, en cambio, viven para siempre, y su recompensa está junto al Señor: cuidan de ellos en casa del Altísimo."
,"16":"Recibirán de manos del Señor,la corona magnífica, la diadema radiante; con su mano derecha los cubrirá, y con su brazo los protegerá."
,"17":"Su amor celoso lo llevó a tomar las armas, moviliza al universo para castigar a sus enemigos."
,"18":"Toma como coraza la rectitud, y como casco escogió sus juicios equitativos."
,"19":"Su invencible santidad le sirve de escudo,"
,"20":"se ha hecho una espada con su cólera inflexible, y junto con él el universo lucha contra los insensatos."
,"21":"Los dardos del rayo darán recto en el blanco, disparados de las nubes como de un arco bien tenso;"
,"22":"los granizos de su cólera caerán sobre ellos, el océano se indignará con ellos,y los ríos los inundarán sin piedad."
,"23":"El aliento de su Poder se alzará contra ellos,y los dispersará como el huracán. Su pecado convertirá a la tierra en desierto, las maldades de los poderosos echarán abajo sus tronos."
}`)
	CurrentBook.AddChapter(6, `{
"1":"¡Oh reyes, escuchen y entiendan! ¡Déjense instruir, ustedes que gobiernan las lejanas tierras!"
,"2":"¡Pongan atención, ustedes que mandan a multitudes, que están tan orgullosos de sus numerosos pueblos!"
,"3":"Porque el Señor es quien les dio el poder, y la realeza les viene del Altísimo; él examinará su comportamiento y pondrá al descubierto las intenciones de ustedes."
,"4":"Ustedes son los representantes de su poder real; ahora bien, si no han juzgado conforme a la justicia, ni han observado su ley, ni procedido según la voluntad de Dios,"
,"5":"los declarará culpables bruscamente, de manera terrible. Porque rigurosa es la sentencia para la gente que tiene un alto puesto. "
,"6":"Se tiene compasión de los pequeños y se los perdona, pero los poderosos serán controlados estrictamente."
,"7":"El Amo universal no teme a nadie, y las dignidades humanas no le impresionan: él hizo a los pequeños y a los grandes; él se preocupa por todos,"
,"8":"pero a los poderosos se los examinará más a fondo."
,"9":"A ustedes, pues, príncipes, me dirijo, para que aprendan la sabiduría y no caigan."
,"10":"Porque los que observan santamente las leyes santas se harán santos y los que las hayan profundizado encontrarán en ellas su defensa."
,"11":"Sean pues ávidos de mis palabras y búsquenlas: los instruirán."
,"12":"La Sabiduría es luz y no se torna opaca; se muestra con gusto a los que la aman, se deja encontrar por los que la aman."
,"13":"Sale al encuentro de los que la quieren conocer;"
,"14":"el que por ella se levantó temprano, casi no tendrá que esforzarse: la hallará sentada a su puerta."
,"15":"Apasionarse por ella es la mejor de las ambiciones, el que trasnocha a causa de ella estará pronto sin preocupaciones."
,"16":"Ella misma sale en busca de los que son dignos de ella; se muestra con benevolencia en sus caminos, sale a su encuentro en todos sus pensamientos."
,"17":"El comienzo de la sabiduría es un verdadero deseo de formarse: buscar la instrucción es amarla."
,"18":"El que la ama observa sus leyes, el que obedece sus leyes se asegura la vida que no perece,"
,"19":"y la vida que no perece nos pone muy cerca de Dios."
,"20":"¡Vean, pues, de qué manera la sabiduría nos lleva a la realeza!"
,"21":"Pues bien, soberanos de los pueblos, si aprecian el trono y las insignias del poder, honren a la Sabiduría y reinarán por siempre."
,"22":"Les voy a decir lo que es la sabiduría y cuál es su origen, no les ocultaré secreto alguno. Quiero seguirla desde sus comienzos y exponerles claramente, sin apartarme de la verdad, todo lo que de ella se puede saber."
,"23":"Porque aquí no hay secretos que guardar celosamente, eso no tendría nada que ver con la Sabiduría."
,"24":"Si se multiplicaran los sabios, sería la salvación del mundo, porque un rey inteligente hace la prosperidad de su pueblo."
,"25":"Instrúyanse pues por medio de mis palabras, y con ello obtendrán beneficios."
}`)
	CurrentBook.AddChapter(7, `{
"1":"No soy más que un mortal como todos los demás, un descendiente del primero que fue formado de la tierra. Mi cuerpo se elaboró en el vientre de mi madre,"
,"2":"donde durante diez meses fui modelado en su sangre, a partir del semen viril y del placer compartido en una cama."
,"3":"Una vez nacido, respiré el mismo aire que los demás, y vine a caer en la misma tierra, lancé el primer grito y lloré como ellos;"
,"4":"me envolvieron en pañales y cuidaron de mí."
,"5":"Ningún rey comenzó su vida de otra manera:"
,"6":"la vida sólo tiene una entrada, y la salida es la misma para todos."
,"7":"Oré y me fue dada la inteligencia; supliqué, y el espíritu de sabiduría vino a mí."
,"8":"La preferí a los cetros y a los tronos, y estimé en nada la riqueza al lado de ella."
,"9":"Vi que valía más que las piedras preciosas; el oro es sólo un poco de arena delante de ella, y la plata, menos que el barro."
,"10":"La amé más que a la salud y a la belleza, incluso la preferí a la luz del sol, pues su claridad nunca se oculta."
,"11":"Junto con ella me llegaron todos los bienes: sus manos estaban repletas de riquezas incontables."
,"12":"Recibía con alegría todas esas cosas de que me proveía la sabiduría, pero todavía no sabía que la sabiduría era su madre."
,"13":"Estudié de manera desinteresada, por eso la comparto sin segundas intenciones: es una riqueza que no esconderé."
,"14":"Porque la Sabiduría es para los hombres un tesoro inagotable; los que la adquieren se hacen amigos de Dios, debido a los frutos de su educación."
,"15":"¡Que Dios permita que pueda hablar correctamente de ella y apasionarme por ella en la medida de los beneficios recibidos! Porque él es quien conduce a la Sabiduría y dirige a los sabios."
,"16":"Estamos en las manos de Dios, nosotros, nuestras palabras, nuestras reflexiones y nuestras habilidades."
,"17":"El me dio el verdadero conocimiento de la realidad: la constitución del universo y las propiedades de los elementos,"
,"18":"el comienzo, el fin y el entretiempo, las posiciones del sol y la alternancia de las estaciones,"
,"19":"los ciclos del año y el movimiento de las estrellas,"
,"20":"las diferentes especies y el comportamiento de las fieras salvajes, el poder de los espíritus y los problemas de los hombres, la variedad de las plantas y las propiedades de sus raíces."
,"21":"Supe, pues, todo lo que está oculto y todo lo que se ve, puesto que la sabiduría que lo ha hecho todo me lo enseñaba."
,"22":"En ella se encuentra un espíritu inteligente, santo, único, múltiple, ágil, móvil, penetrante, puro, límpido, no puede corromperse, orientado al bien y eficaz."
,"23":"Es un espíritu irresistible, bienhechor, amigo de los hombres, firme, seguro, apacible, que lo puede todo y que vela por todo, impregna a todos los otros espíritus por inteligentes, puros y sutiles que sean."
,"24":"La sabiduría es más movible que cualquier cosa, gracias a su fuerza atraviesa y lo penetra todo."
,"25":"Se desprende, como un vapor, del poder de Dios, es una emanación muy pura de su Gloria; por eso, nada de sucio se introduce en ella."
,"26":"Es la irradiación de la luz eterna, el espejo sin tacha de la actividad de Dios y la imagen de su perfección."
,"27":"Es una, pero lo puede todo; sin salir de sí misma, lo renueva todo. De generación en generación pasa a las almas santas de las cuales hace amigos de Dios y profetas."
,"28":"Porque Dios sólo ama al que vive con la Sabiduría."
,"29":"Es más bella que el sol y supera a cualquier constelación; comparada con la luz, le gana,"
,"30":"porque la noche sucede al día, mientras que el mal jamás vencerá a la sabiduría."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Sí, la sabiduría se extiende de un extremo al otro de la tierra, y en todas partes pone orden."
,"2":"La amé y la deseé desde mi juventud; traté de tomarla por esposa, porque estaba enamorado de su belleza."
,"3":"El hecho de que esté cerca de Dios hace resaltar su noble origen: el Dueño de todas las cosas la amó."
,"4":"Fue iniciada en el conocimiento mismo de Dios, y ella decide qué obras hay que realizar."
,"5":"Si lo que se desea en el mundo es la riqueza, ¿acaso hay riqueza más grande que la Sabiduría, que todo lo realiza?"
,"6":"Y si la inteligencia precede a las obras, ¿quién entre los vivos hace las cosas mejor que ella?"
,"7":"¿Aman ustedes la rectitud? Sepan que todas las virtudes son fruto de su trabajo; ella enseña la prudencia y la inteligencia, la justicia y el valor; nada hay en la vida que sea más útil a los hombres."
,"8":"¿Busca alguien vastos conocimientos? La Sabiduría conoce las cosas del pasado y prevé el porvenir; sabe interpretar los discursos y resolver los enigmas, anuncia de antemano las señales de la naturaleza y los prodigios, el fin de las épocas y de los tiempos."
,"9":"Por eso decidí tomarla como compañera de mi vida: sabía que me aconsejaría en los momentos felices y me sostendría en las preocupaciones y en las penas."
,"10":"'Gracias a la Sabiduría, me decía, seré honrado por las muchedumbres y, a pesar de mi juventud, respetado por los ancianos."
,"11":"Reconocerán en mí un discernimiento penetrante, y los poderosos me admirarán."
,"12":"Si me callo, me esperarán; si hablo, estarán atentos; y aunque se prolongue mi discurso, seguirán escuchándome."
,"13":"Gracias a la Sabiduría obtendré la inmortalidad, y dejaré un recuerdo eterno a los que vendrán después de mí."
,"14":"Gobernaré a los pueblos, y se me someterán las naciones."
,"15":"Soberanos temibles se llenarán de temor al oír hablar de mí; seré bueno con mi gente y valiente en el combate."
,"16":"De vuelta a casa, descansaré a su lado, porque su compañía no es amarga; vivir con ella no cuesta nada, sino que, al contrario, trae alegría y felicidad'."
,"17":"Así razonaba conmigo mismo. Comprendí que uno encuentra la vida inmortal en la unión con la Sabiduría,"
,"18":"se adquiere una alegría superior gracias a su amistad, una riqueza perdurable gracias a sus desvelos, la inteligencia cuando se ejercita en entenderla, y la fama en las conversaciones con ella. Salí pues en su busca para traerla a mi casa."
,"19":"Había nacido como niño bien dotado, había recibido como herencia un alma buena;"
,"20":"o más bien, siendo bueno, había llegado con un cuerpo sin defectos."
,"21":"Pero también comprendía que el único medio para tenerla era que Dios me la diera, y ya era una señal de inteligencia el haberlo comprendido. Por eso, me volví al Señor y le supliqué; le dije con todo mi corazón:"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Dios de nuestros padres, Señor de misericordia, por tu Palabra hiciste todas las cosas,"
,"2":"y por tu Sabiduría formaste al hombre para que domine a todas las criaturas por debajo de ti,"
,"3":"para que gobierne al mundo con santidad y justicia, y tome sus decisiones con recta conciencia:"
,"4":"dame pues la Sabiduría que comparte tu trono, y no me excluyas del número de tus hijos."
,"5":"¡Mírame, soy tu sirviente, el hijo de tu esclava, un hombre débil cuya vida es breve, demasiado limitado para comprender la justicia y las leyes!"
,"6":"Ni siquiera el más perfecto de los hombres será algo sin la sabiduría que viene de ti."
,"7":"Me elegiste como rey de tu pueblo, como juez para tus hijos y tus hijas."
,"8":"Me has dicho que te construya un templo en la montaña santa, un altar en la ciudad donde habitas, a semejanza de esa Tienda celestial que habías preparado para ti desde el principio."
,"9":"Junto a ti está esa Sabiduría que conoce todas tus obras, que estaba contigo cuando hacías el mundo, que sabe lo que te agrada y está de acuerdo con tus mandamientos."
,"10":"Haz que descienda desde el cielo donde todo es santo, envíala desde tu trono glorioso, para que esté a mi lado en mis trabajos y sepa lo que te gusta."
,"11":"Porque ella todo lo conoce y lo comprende; ella me guiará con prudencia en todo lo que haga, y su majestad me protegerá."
,"12":"Entonces te serán agradables mis obras, gobernaré a tu pueblo con justicia, y seré digno del trono de mi padre."
,"13":"¿Quién, en realidad, podría conocer la voluntad del Señor? ¿Quién se apasionará por lo que quiere el Señor?"
,"14":"La razón humana avanza tímidamente, nuestras reflexiones no son seguras,"
,"15":"porque un cuerpo perecible pesa enormemente sobre el alma, y nuestra cáscara de arcilla paraliza al espíritu que está siempre en vela."
,"16":"Si nos cuesta conocer las cosas terrestres, y descubrir lo que está al alcance de la mano, ¿quién podrá comprender lo que está en los cielos?"
,"17":"¿Y quién podrá conocer tus intenciones, si tu no les has dado primero la Sabiduría, o no le has enviado de lo alto tu Espíritu Santo?"
,"18":"Así fue como los habitantes de la tierra pudieron corregir su conducta; al saber lo que te agrada, fueron salvados por la Sabiduría."
}`)
	CurrentBook.AddChapter(10, `{
"1":"La Sabiduría protegió al padre del mundo, a ese primer hombre que fue formado por Dios y que fue creado como único. Lo levantó de su caída"
,"2":"y le dio la fuerza para que dominara a todas las cosas."
,"3":"El hombre se alejó de ella, arrastrado por su propio furor, se hizo malo hasta matar a su hermano y se perdió junto con su arrebato."
,"4":"Pero cuando por culpa de él las aguas inundaron la tierra, la Sabiduría lo salvó una vez más: ella guiaba su barca."
,"5":"Más tarde, los pueblos se juntaron para hacer el mal, y la discordia se instaló en medio de ellos. La sabiduría reconoció entonces a otro justo: lo mantuvo irreprochable delante de Dios y le dio la fuerza para sobreponerse a la ternura por su hijo."
,"6":"Ella también libró al justo en su huida, cuando bajaba el fuego sobre las cinco ciudades para aniquilar a los impíos."
,"7":"Y aún hasta ahora permanece un testigo de su perversidad: una tierra árida y siempre humeante, arbustos cuyos frutos no maduran, una columna de sal en recuerdo de la que no creyó."
,"8":"Los que se apartaron del camino de la Sabiduría no sólo fueron castigados, perdiendo su felicidad, sino que sus ruinas están allí como un recuerdo para todos los vivos, para que sus pecados no sean nunca olvidados."
,"9":"En cambio la Sabiduría libró de sus problemas a los que la servían."
,"10":"Condujo por caminos seguros al justo que huía de la cólera de su hermano. Le mostró el reino de Dios y le permitió que conociera a los santos ángeles. Hizo que tuviera éxito en sus trabajos y que fructificaran sus esfuerzos."
,"11":"Lo defendió contra la avaricia de sus amos y lo hizo muy rico."
,"12":"Lo guardó de sus enemigos y lo protegió de los que le tendían trampas. Le dio la victoria en un rudo combate para hacerle entender que la piedad es más poderosa que cualquier otra cosa."
,"13":"La Sabiduría no abandonó al justo cuando lo vendieron: lo preservó del pecado."
,"14":"Descendió con él al pozo y no lo dejó solo en la prisión; muy por el contrario, le confió el poder en el reino y le dio autoridad sobre los que lo habían perseguido. Hizo que quedara al descubierto la mentira de sus calumniadores y le consiguió una gloria que no pasará."
,"15":"La Sabiduría arrancó al pueblo santo, a la raza irreprochable de manos de la nación opresora."
,"16":"Entró en el alma de un servidor del Señor para hacer frente a reyes temibles, por medio de señales y prodigios."
,"17":"Le dio al pueblo santo el pago por sus penas, los guió por un camino asombroso. Los cubría con su sombra durante el día y los alumbraba como un astro durante la noche."
,"18":"Los hizo pasar el Mar Rojo: ¡atravesaron las inmensas aguas!"
,"19":"Ella se tragó a sus enemigos, para luego echar sus cuerpos a lo más profundo del mar."
,"20":"De ese modo, los justos despojaron a los impíos; ¡cantaron himnos a tu santo Nombre, oh Señor! Con un solo corazón te dieron gracias, porque tú los habías librado."
,"21":"Porque el Señor abre la boca de los mudos y hace hablar a los pequeñines."
}`)
	CurrentBook.AddChapter(11, `{
"1":"La sabiduría hizo que lo que ellos emprendían tuviera éxito gracias a un santo profeta."
,"2":"Atravesaron un desierto deshabitado y levantaron sus tiendas en lugares inaccesibles."
,"3":"Enfrentaron a sus adversarios y rechazaron a sus enemigos."
,"4":"Cuanto tuvieron sed, te invocaron; les diste el agua que brotó de una roca dura: sí, una piedra tosca calmó su sed."
,"5":"Los mismos elementos que habían servido para castigar a sus enemigos se transformaban en benéficos para el pueblo santo."
,"6":"Los Egipcios vieron cómo su río, un verdadero río que corría en todas las estaciones, estaba manchado con un barro sanguinolento:"
,"7":"era en castigo por el decreto que había ordenado matar a los recién nacidos de Israel. En cambio, tú diste a tu pueblo, contra toda esperanza, un agua abundante."
,"8":"Después de haber padecido de sed, comprendieron mejor cómo castigabas a sus enemigos."
,"9":"Para ellos la prueba no había sido más que una suave corrección, en cambio veían cuán gran castigo atormentaba a los impíos, cuando los azotaba tu justa cólera."
,"10":"Pusiste a prueba a tu pueblo como un padre corrige a su hijo, pero a sus enemigos los condenaste como lo hace un rey severo."
,"11":"Tuvieron que sufrir con la partida de Israel, y sufrieron también después."
,"12":"Cuando se acordaban de todo lo que les había pasado, sentían una pena doble."
,"13":"Cuando supieron que el agua, instrumento de su castigo, se había vuelto favorable para Israel, reconocieron entonces la mano del Señor."
,"14":"Mucho antes habían expuesto a Moisés a la muerte; más tarde, lo habían rechazado con desprecio. Pero ahora lo admiraban debido a esa sed que los devoraba a ellos y no a los justos."
,"15":"Su mal corazón los había extraviado: era una locura que adoraran a reptiles irracionales y a viles animales. Por eso, en castigo les enviaste nubes de insectos,"
,"16":"para hacerles ver que se los castigaba por lo mismo que habían pecado."
,"17":"Tu mano poderosa sólo tenía que elegir: como tu creaste el mundo a partir de una materia informe, habrías podido enviar contra ellos sin dificultad bandadas de osos o leones indomables."
,"18":"Para castigarlos habrías podido crear nuevas especies, animales llenos de furor, que respiraran fuego, cuyas narices lanzaran un vapor ardiente, cuyos ojos emitieran relámpagos terribles."
,"19":"Con sólo verlos, antes de ser atacados, se habrían muerto de espanto."
,"20":"Pero aun sin eso, bastó que tu justicia los persiguiera, que tu poderoso aliento los dispersara; pues podías derribarlos de un soplido. No lo quisiste, porque respetas totalmente lo que has dispuesto: mesura, número y peso."
,"21":"En realidad, tú puedes imponerte soberanamente, y ¿quién podría oponerse a la fuerza de tu brazo?"
,"22":"El mundo entero está delante de ti como un grano en la balanza, como una gota de rocío que cayó al suelo de madrugada."
,"23":"Pero, porque lo puedes todo, tienes piedad de todos y parece como que no hicieras caso de los pecados de los hombres para que así se arrepientan."
,"24":"Porque tú amas a todos los seres, tú no detestas nada de lo que has hecho: Si no los hubieras querido, no los habrías hecho."
,"25":"¿Cómo podría durar una cosa que tú no quisieras? ¿Qué podría subsistir si tú no lo hubieras llamado?"
,"26":"Pero tienes lástima de todo, porque todo te pertenece, ¡oh Señor, que amas la vida,"
}`)
	CurrentBook.AddChapter(12, `{
"1":"y tu Espíritu imperecedero está en todo!"
,"2":"Así es cómo corriges de a poco a los que pecan. Les haces ver, mediante tus correcciones, en qué han pecado, para que renuncien al mal y crean en ti, Señor."
,"3":"Así pasó con los antiguos habitantes de tu Tierra Santa:"
,"4":"los aborrecías debido a sus prácticas detestables, su brujería y sus ritos impíos,"
,"5":"el asesinato sin piedad de niñitos, los banquetes sanguinarios en que comían la carne humana con la sangre y las entrañas, mientras celebraban sus cultos secretos."
,"6":"Habías decidido acabar con esos padres asesinos de seres indefensos por medio de nuestros padres."
,"7":"Querías que esta a la que quieres más que a las demás, fuese la patria de los hijos de Dios dignos de ella."
,"8":"Pero, incluso con estos antiguos habitantes, diste muestra de moderación porque eran seres humanos. Les enviaste, como vanguardia de tu ejército, avispas para que los destruyeran poco a poco."
,"9":"Sin duda, habrías podido aplastar a los impíos por medio de los justos a través de una batalla, o aniquilarlos de un solo golpe por medio de fieras terribles o con una sola palabra salida de ti."
,"10":"Pero, al castigarlos progresivamente, les dabas oportunidad para que se arrepintieran. No ignorabas, sin embargo, que su interior era perverso y que su maldad era innata, y que no cambiarían,"
,"11":"porque su raza había sido declarada maldita desde el principio. De todos modos, no fue por miedo a alguien que dejaste sin castigo sus crímenes."
,"12":"Porque, ¿quién podría decirte: '¿Qué has hecho?'; quién podría oponerse a tus decisiones? ¿Quién podría llamarte la atención por aniquilar a naciones que tú creaste? ¿Quién te impediría castigar a hombres injustos?"
,"13":"Fuera de ti, que te preocupas de todos, no hay otro Dios al que tengas que probarle que no actuaste injustamente."
,"14":"No hay tampoco rey o soberano alguno que pueda oponérsete cuando decides castigar."
,"15":"Puesto que tú eres perfectamente justo, lo haces todo con justicia: harías un mal uso de tu poder si condenaras al que no merece ser castigado."
,"16":"Tu fuerza es el fundamento de tu justicia; como eres el dueño de todas las cosas, puedes también perdonarlas."
,"17":"Muestras tu fuerza a los que ponen en duda tu poder absoluto; castigas la audacia de los que lo desafían."
,"18":"Pero, aunque seas un Señor poderoso, juzgas con moderación y nos gobiernas con mucha paciencia, porque eres libre de intervenir cuando quieras."
,"19":"Al actuar así le has mostrado a tu pueblo que el justo debe amar a todos los hombres, y has dado a tus hijos esa dulce esperanza de que después del pecado les permites que se arrepientan."
,"20":"Incluso con los cananeos, enemigos de tus hijos y dignos de muerte, actuaste con moderación e indulgencia para darles tiempo y oportunidad a que se convirtieran."
,"21":"Pero con tus hijos actuaste todavía con más miramientos, ya que estabas ligado a sus antepasados por juramentos, alianzas y tantas otras bellas promesas."
,"22":"De tal manera, que cuando castigas a nuestros enemigos con moderación, lo haces para que aprendamos, para que pensemos en tu bondad cuando nos toque ser jueces, y para que confiemos en tu misericordia cuando seamos juzgados."
,"23":"A los que vivían alocadamente en el mal, los castigaste por medio de sus ídolos abominables."
,"24":"¡Habían llegado muy lejos por los caminos del error, tomando como dioses a los animales más feos y más despreciables! Se habían dejado engañar como niños sin juicio."
,"25":"Así, como a niños que no piensan, les dirigiste primero una leve advertencia,"
,"26":"pero no comprendieron esos benignos reproches, así que merecían experimentar el juicio de Dios."
,"27":"En medio de sus sufrimientos, se indignaron con esos animales a los que habían tomado por dioses, y que ahora se transformaban en los instrumentos de su castigo. Entonces descubrieron y reconocieron como Dios al que antes se negaban a ver: ése fue el motivo del castigo supremo que recayó sobre ellos."
}`)
	CurrentBook.AddChapter(13, `{
"1":"La incapacidad natural del hombre se revela en su ignorancia de Dios. Todo lo que admiran por su valor no los llevó a conocer al Que Es. ¡Se quedaron con las obras y no reconocieron al Artesano!"
,"2":"Consideraron como dioses que gobiernan el mundo tanto al fuego como al viento, a la brisa, al firmamento estrellado, al agua impetuosa o a las luminarias del cielo."
,"3":"Fascinados por tanta belleza, los consideraron como dioses, pero entonces, ¿no debieron haber sabido que su soberano es todavía más grande? Porque sólo son criaturas del que hace que aparezca toda esa belleza."
,"4":"Si estaban impresionados por su fuerza y su actividad, debieron haber comprendido que su Creador es más poderoso aún."
,"5":"Porque la grandeza y la belleza de las criaturas dan alguna idea del Que les dio el ser."
,"6":"Pero, quizás no haya que criticar tanto a esa gente: tal vez se extraviaron cuando buscaban a Dios y querían encontrarlo."
,"7":"Reflexionaban sobre las criaturas que los rodeaban, y lo que veían era tan hermoso que se quedaron con lo exterior."
,"8":"Pero ni aun así están libres de culpa:"
,"9":"si fueron capaces de escudriñar el universo, ¿cómo no descubrieron en primer lugar al que es su Dueño?"
,"10":"¡Cuánta más pena dan los que ponen su confianza en cosas muertas, y que dan el nombre de dioses a lo que ha salido de manos humanas: oro, plata cincelada, figuras de animales y hasta la piedra inservible, que un buen día fue esculpida por alguien!"
,"11":"Tomemos por ejemplo a un leñador: aserrucha un árbol que no le cueste mucho transportar, raspa cuidadosamente la corteza; luego, lo corta con destreza y se hace un mueble cualquiera de uso corriente."
,"12":"Los restos de la obra los emplea para cocer su comida y así recuperar sus fuerzas."
,"13":"Entre los palos que le quedan y que no sirven para nada, divisa uno todo torcido y lleno de nudos; lo toma y lo va esculpiendo a ratos; pone en él todo su arte y le da forma humana,"
,"14":"a no ser que represente a un vulgar animal. Lo pinta de rojo, habiendo antes recubierto con pasta todos los defectos."
,"15":"Después le prepara en el muro un nicho a su medida, y lo afirma allí con clavos de fierro."
,"16":"Toma sus precauciones para que no se caiga, pues sabe muy bien que su dios es incapaz de ayudarse a sí mismo: hay que ayudarlo porque no es más que una estatua."
,"17":"Y, sin embargo, ya sea que se trate de sus negocios, ya sea de su matrimonio o de sus hijos, no se avergüenza de dirigirle la palabra a esa cosa sin vida. ¡Para tener salud invoca a un objeto sin fuerza;"
,"18":"para vivir rinde homenaje al que no vive; para que le ayude, se lo pide a esa madera impotente; antes de un viaje, invoca al que no camina."
,"19":"Para obtener ganancias, para su trabajo, para su arte, recurre a una estatua cuyas manos no tienen la menor habilidad."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Veamos a otro que se prepara para embarcarse. Antes de enfrentar el furor de las olas, invoca a un pedazo de madera más frágil aún que la embarcación que lo llevará."
,"2":"Ese barco nació del afán de ganar plata, y el arte del técnico lo confeccionó;"
,"3":"pero es tu Providencia, oh Padre, la que lo conduce. Tú has abierto un camino en el mar y trazado una ruta segura por entre las olas."
,"4":"Así nos demuestras que puedes salvarnos en cualquier parte, aunque uno se embarque sin gran experiencia."
,"5":"No quieres que los hombres, obras de tu Sabiduría, estén sin hacer nada; pero, mira cómo confían su vida a un pedazo de madera: una balsa les permite atravesar las olas sanos y salvos."
,"6":"Ya antiguamente, mientras perecían los gigantes orgullosos, el justo que llevaba consigo la esperanza del universo, se refugió en una balsa; guiado por tu mano, dejó al mundo la semilla de una nueva humanidad."
,"7":"¡Bendita sea la madera que fue instrumento de tu salvación!"
,"8":"Pero, en cuanto al ídolo fabricado y al que lo hizo, ¡que sean malditos ambos: el obrero porque lo hizo, y el objeto porque se lo llamó dios!"
,"9":"Ambos son insoportables para Dios, el impío y el producto de su impiedad;"
,"10":"¡la obra será destruida junto con el artesano!"
,"11":"Por eso, el castigo alcanzará también a los ídolos de las naciones, porque son cosas abominables en el seno de la creación: hacen caer a las almas de los hombres y los insensatos se dejan seducir."
,"12":"La invención de los ídolos fue el comienzo de la perversión; esa invención corrompió la vida."
,"13":"Porque al comienzo no existían, ni durarán para siempre."
,"14":"La vanidad humana los introdujo en el mundo y por eso su destrucción está decidida."
,"15":"Imagínese a un padre afligido por la muerte prematura de su hijo; manda hacer una imagen de él, y luego honra como dios al que no es más que un difunto. Transmite a su familia ritos y ceremonias,"
,"16":"y con el tiempo esta costumbre impía se consolida hasta tal punto que se hace obligatoria para todos."
,"17":"De igual modo se veneran estatuas por orden de los príncipes. Aquellos de sus súbditos que no podían honrarlos personalmente porque vivían lejos, quisieron tener su retrato. Mediante esa imagen podrían venerar al rey como si estuviera presente."
,"18":"El talento del artista hizo que aumentara ese culto entre los que no conocían al soberano."
,"19":"Con el afán de agradarle se las ingenió para representarlo más bello de lo que era."
,"20":"La representación era tan perfecta que la muchedumbre se dejó seducir: así se llegó rápidamente a ver un dios en el que se veneraba."
,"21":"Todo esto se ha convertido en una trampa para los vivos: hombres azotados por la desgracia o sometidos a los poderosos dieron a piedras o a la madera el Nombre incomunicable."
,"22":"No les bastó con tal error en el conocimiento de Dios. La ignorancia los llevó a tan grandes contradicciones que llegaron a considerar como normales los peores excesos:"
,"23":"los asesinatos de niños que eran ofrecidos en sacrificio, los ritos secretos, las orgías furiosas y extravagantes."
,"24":"Ni el más mínimo recato en sus vidas o en su matrimonio: uno suprime al otro a traición o lo deshonra por medio del adulterio."
,"25":"Por todas partes sólo hay sangre y muerte, robos, fraudes, corrupción, mala fe, revueltas, perjurios,"
,"26":"confusión en la gente buena, olvido de los favores, escándalos, prácticas antinaturales, desórdenes en el matrimonio, adulterio, libertinaje."
,"27":"El culto a los dioses, que ni siquiera merecen tal nombre, es el comienzo, la causa y el fin de todo mal."
,"28":"Hay algunos a los que les gusta excitarse hasta el delirio, y entonces entregan falsos oráculos. Otros viven en el mal y llegan hasta el perjurio;"
,"29":"sabiendo que se apoyan en ídolos sin vida, ¿cómo tendrían miedo de que sus falsos juramentos sean castigados?"
,"30":"Pero con toda justicia serán castigados por dos motivos: primero, porque desconocieron a Dios al irse con los ídolos; y segundo, porque cometieron un fraude; al hacer falsos juramentos menospreciando lo que es sagrado."
,"31":"Aunque los ídolos sean impotentes, el castigo reservado a los pecadores alcanzará también a los impíos..."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Pero tú, oh Dios nuestro, eres bueno y veraz; tú eres paciente y gobiernas el universo con misericordia."
,"2":"Aunque pequemos, somos tuyos, pues reconocemos tu poder; pero, sabiendo que somos tuyos, evitaremos el pecado."
,"3":"Toda la rectitud consiste en conocerte; reconocer tu poder es el punto de partida de la inmortalidad."
,"4":"Nosotros no nos hemos dejado engañar por una invención mentirosa de los hombres, por esas obras inútiles de los artistas, esos ídolos embadurnados de colores."
,"5":"Sólo conmueven a los insensatos, que pueden excitarse por la belleza inanimada de imágenes muertas."
,"6":"En verdad, los fabricantes de imágenes sólo buscan su desgracia y la tienen bien merecida, y lo mismo los que creen en ellas y las adoran."
,"7":"Veamos ahora a un alfarero: moldea concienzudamente la blanda arcilla, modela para nuestra utilidad toda clase de objetos. De la misma masa saca utensilios destinados a usos nobles y otros, a usos ordinarios. ¿Para qué servirá tal o cual cántaro? Eso lo decide el alfarero."
,"8":"Con la misma arcilla elabora la estatua de un dios falso: ¡cuánto trabajo perdido por un hombre justamente salido de la tierra y que dentro de poco volverá a ella cuando le pidan de nuevo su alma!"
,"9":"No reflexiona que tendrá que morir y que su vida es breve: sólo piensa en rivalizar con los orfebres y los fundidores de plata, imita a los que cuelan el bronce y se gloría de fabricar cosas falsas."
,"10":"Su corazón no es más que ceniza, sus ambiciones son más inconsistentes que la tierra; pero su existencia tiene menos valor que la arcilla"
,"11":"ya que ignora al que lo formó y no reconoce al que le insufló un alma consciente, poniendo en él el soplo vital."
,"12":"La vida le parece un juego, y la existencia una seguidilla de negocios: '¡Hay que sacar provecho, dice, de cualquier parte, incluso del mal!'"
,"13":"Ese hombre sabe mejor que los otros que peca al fabricar de un mismo barro, cosas e imágenes divinas."
,"14":"Pero los enemigos de tu pueblo, los que lo oprimieron, eran realmente insensatos, y merecían más lástima que pobres niños ingenuos."
,"15":"Habían adoptado como dioses a ídolos venidos de todas las naciones -imágenes incapaces de ver con sus ojos, respirar con su nariz, oír con sus oídos-, que no podían ni tocar con sus dedos ni caminar con sus pies."
,"16":"Eso era normal pues fue un hombre quien los hizo. El que los elaboró no tenía más vida que la que se le dio, y ni siquiera era capaz de hacer un dios que se le asemejara,"
,"17":"porque sus manos impías de mortal sólo producían cosas muertas. Ese hombre tiene más valor que los objetos que adora: él por lo menos vive, pero éstos, jamás."
,"18":"Esa gente adora hasta a las fieras más repugnantes (porque de hecho son más estúpidas que las demás)."
,"19":"Estas no tienen absolutamente nada de atrayente y espantan cualquier deseo de alabar a Dios y de darle gracias."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Por eso, nuestros perseguidores fueron justamente castigados por animales de ese género y atormentados por una multitud de insectos."
,"2":"En cambio a tu pueblo, en vez de castigarlo, lo colmaste de favores: le enviaste un alimento maravilloso -¡codornices!- para saciar su hambre voraz."
,"3":"Cuando nuestros enemigos tenían hambre, sintieron asco ante el aspecto horroroso de los animales que les enviaste; tu pueblo, en cambio, después de una breve privación, disfrutó de un alimento exquisito."
,"4":"Era necesario que se castigara a los opresores con un hambre implacable, y que tu pueblo, en cambio, viera de qué manera eran torturados sus enemigos."
,"5":"Incluso cuando fieras feroces se apoderaron furiosamente de los tuyos y cuando éstos sucumbieron por la mordedura de serpientes venenosas, tu cólera no duró hasta el final."
,"6":"El castigo que se dejó caer por un momento, tenía valor de advertencia: esta señal de salvación les recordaría los mandamientos de tu Ley."
,"7":"En efecto, cualquiera que se volvía al objeto de bronce se salvaba, no por lo que tenía a su vista, sino por ti, el Salvador de todos."
,"8":"Y allí una vez más mostraste a nuestros enemigos que eres tú el que envía cualquier castigo."
,"9":"Eran mordeduras de langostas y de moscas que les provocaban la muerte, sin que se encontrara remedio para mantenerlos con vida: ésa era la prueba de que tenían ese castigo totalmente merecido."
,"10":"Tus hijos, en cambio, resistían aun a las dentelladas de las serpientes venenosas, y esto porque dabas una muestra de misericordia y los salvabas."
,"11":"Eran mordidos para recordarles tus oráculos, para que así no te olvidaran completamente ni se volvieran insensibles a tus favores; y muy pronto fueron curados."
,"12":"Su curación no se debió a hierbas o a pomadas sino a tu palabra, Señor, porque tú lo sanas todo."
,"13":"Sí, tú tienes poder sobre la vida y la muerte; tú haces que bajen los hombres a la morada subterránea o tú los preservas de ella."
,"14":"El hombre, en su maldad, es capaz de quitar la vida, pero no puede hacer que vuelva el aliento cuando se ha escapado, ni puede llamar de nuevo al alma que ha partido."
,"15":"¡Es imposible escapar a tu mano!"
,"16":"Los impíos que se negaron a reconocerte fueron azotados por tu brazo poderoso, perseguidos por lluvias extraordinarias, por el granizo, y tormentas inclementes; el fuego los devoró."
,"17":"Extraño fenómeno: fue justamente en el agua que lo apaga todo donde el fuego ardía más violentamente, porque todos los elementos se juntaron para proteger a los justos."
,"18":"Unas veces las llamas besaban para no quemarlos a los animales que habían sido enviados contra los impíos: así comprenderían que Dios quería castigarlos;"
,"19":"otras, en cambio, la llama surgía con más fuerza bajo el aguacero para destruir las cosechas de un país perverso."
,"20":"A tu pueblo, sin embargo, le distribuías el alimento de los ángeles; le enviabas desde el cielo incansablemente un pan ya listo, que tenía en sí todos los sabores y se adaptaba al gusto de cada cual."
,"21":"Ese alimento demostraba tu ternura por tus hijos, ya que respondía a los deseos del que lo comía y se transformaba en lo que quería cada uno."
,"22":"Se parecía a la nieve, pero soportaba el fuego sin derretirse; mientras que por ese tiempo las cosechas de los enemigos eran presa de las llamas que ardían en medio del granizo: los relámpagos brillaban bajo la lluvia."
,"23":"Pero el fuego parecía haber perdido sus propiedades cuando se trataba del alimento de los justos."
,"24":"Tu creación está a tu servicio porque tú eres su autor. Se dedica a castigar a los malos, y luego se ablanda en favor de los que en ti ponen su confianza."
,"25":"Para servir a tu bondad, que da a todos el alimento, se transformó, acomodándose al deseo de los que la necesitaban."
,"26":"Así aprendieron tus hijos muy queridos, Señor, que no son los productos de la tierra lo que alimenta al hombre, sino que es tu palabra lo que sostiene a los que creen en ti."
,"27":"Ese alimento que el fuego no podía destruir se derretía con el calor del primer rayo de sol,"
,"28":"para que así supieran que hay que adelantarse al sol para darte gracias y rezarte desde el amanecer."
,"29":"Pues los proyectos de los ingratos se derretirán como la escarcha invernal y se escurrirán como agua que se pierde."
}`)
	CurrentBook.AddChapter(17, `{
"1":"¡Qué elevados son tus designios y cuán difíciles de entender! Por eso, los que no los conocen andan extraviados."
,"2":"Los impíos pensaban someter bajo su poder a la nación santa: pero se encontraron cautivos, prisioneros de una larga noche, encerrados bajo sus propios techos, desterrados lejos de tu infalible protección."
,"3":"Pensaban esconderse junto con sus pecados bajo el velo del olvido, pero fueron dispersados, sometidos a terribles horrores, aterrorizados por fantasmas."
,"4":"Los escondrijos donde se refugiaron no los pusieron al abrigo del miedo: ruidos espantosos resonaban a su derredor, y se les aparecían espectros lívidos, de rasgos lúgubres."
,"5":"Ningún fuego podía alumbrarles, y el brillante resplandor de las estrellas no se atrevía a traspasar esa sombría noche."
,"6":"La única cosa que podían ver era un fuego terrible que no se extinguía; y cuando esa visión había ya desaparecido, en su terror exageraban todavía lo que acababan de ver."
,"7":"Las artimañas de la magia no sirvieron para nada, y su pretendida sabiduría recibió un tajante desmentido,"
,"8":"porque aquellos que se jactaban de sanar a los espíritus de sus perturbaciones y de sus temores, eran presa de un miedo ridículo."
,"9":"Aunque no hubiera nada que temer, el simple paso de un animal o el silbido de una serpiente bastaba para aterrorizarlos;"
,"10":"se morían en convulsiones de miedo, no atreviéndose a mirar ese aire que nos rodea y del cual nadie podría huir."
,"11":"Porque la maldad es miedosa: se condena a sí misma. Perseguida por su conciencia, espera siempre lo peor."
,"12":"Tener miedo es simplemente renunciar a la ayuda de la razón; mientras menos se cuenta con esa ayuda interior, más aumenta la causa desconocida de sus sufrimientos."
,"13":"Esa noche había surgido de un mundo infernal, mundo de la impotencia; se había apoderado de ellos durante el sueño y los mantenía en la impotencia. A lo largo de toda esa noche,"
,"14":"se veían perseguidos por espectros y permanecían clavados en su sitio: un miedo horrible y súbito los embargaba."
,"15":"Cada uno permanecía donde había caído, inmovilizado en esa prisión sin grillos."
,"16":"Fuera labrador, pastor o trabajador solitario, cada uno había sido tomado de improviso, sin poder resistir; una misma oscuridad los tenía a todos encadenados."
,"17":"Todo los llenaba de terror y los paralizaba: el murmullo de la brisa, el gorjeo de un pajarito entre las ramas, o el ruido regular de una cascada,"
,"18":"o el estruendo de un desmoronamiento de piedras en una pendiente, o"
,"19":"la carrera invisible de animales saltando, o aun el aullido de las fieras salvajes y el eco retumbante en las gargantas de las montañas."
,"20":"El resto del mundo disfrutaba de una brillante luz sin que nada le impidiera realizar sus trabajos;"
,"21":"sobre ellos en cambio pesaba una abrumadora noche, imagen de las tinieblas que les tocarían en suerte un día: ¿no eran en sí mismos más pesados que las tinieblas?"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Para tus santos, sin embargo, resplandecía la luz. Los egipcios no los veían, pero los oían y pensaban que habían tenido mucha suerte al librarse de ellas."
,"2":"Además, les agradecían que no se vengaran después de todo lo que habían sufrido, y les pedían perdón."
,"3":"En vez de esa oscuridad diste a tu pueblo una columna de fuego para que los guiara en su viaje a la aventura: su gloriosa migración se iba pues a hacer bajo un sol que no los quemaría."
,"4":"Los egipcios merecieron esa privación de la luz, esas tinieblas que los aprisionaban: ¿no habían ellos acaso retenido cautivos a tus hijos que debían llevar al mundo la luz inapagable de tu Ley?"
,"5":"Quisieron exterminar a los recién nacidos del pueblo santo; Moisés fue el único que se salvó entre los que eran abandonados. Para castigarlos, hiciste perecer a un gran número de ellos, luego los ahogaste a todos juntos en el mar impetuoso."
,"6":"Esa noche había sido anunciada a nuestros padres, para que supieran después valorar tus promesas y depositaran en ellas su confianza."
,"7":"Tu pueblo, pues, aguardaba el momento en que los justos serían salvados y sus enemigos, arruinados;"
,"8":"al castigar a nuestros adversarios cubriste de gloria a tus elegidos, es decir, a nosotros mismos."
,"9":"Tus santos hijos, la raza de los buenos, ofrecieron pues en secreto el sacrificio y se comprometieron a observar esa Ley divina: el pueblo seguiría siendo solidario tanto en los éxitos como en los peligros; después de lo cual entonaron los cantos de sus padres."
,"10":"En ese mismo momento le hacían eco los clamores confusos de sus enemigos, junto con los gritos lastimeros de los que lloraban a sus hijos."
,"11":"Una misma sentencia había castigado al servidor y a su patrón; el hombre del pueblo sufría lo mismo que el rey."
,"12":"Lloraban a sus innumerables muertos, derribados todos por la misma muerte; los vivos no daban abasto para enterrarlos: la flor y nata de esa raza había perecido en un instante."
,"13":"En un primer momento se habían negado a creer, engañados por sus magos, pero después de la muerte de sus primogénitos reconocieron que este pueblo era hijo de Dios."
,"14":"Cuando todo estaba tranquilo en medio del silencio, y había transcurrido la mitad de la noche,"
,"15":"tu Palabra omnipotente se lanzó desde lo alto de los cielos, donde está junto a tu trono real, y se precipitó como un guerrero furioso sobre el país condenado al exterminio. Llevaba como espada acerada tu irrevocable decisión;"
,"16":"tocaba el cielo y pisaba la tierra; cuando golpeaba esparcía la muerte por todas partes."
,"17":"De repente se sintieron perturbados por apariciones y horribles pesadillas: un terror indecible se apoderó de ellos."
,"18":"Cuando caían agonizando en cualquier parte, sabían decir por qué morían,"
,"19":"porque habían sido informados por los sueños que los habían perturbado. No debían sucumbir sin saber por qué tenían que sufrir."
,"20":"Es cierto que los justos también experimentaron la muerte: el flagelo alcanzó a muchos de ellos en el desierto; pero la cólera de Dios no duró tanto."
,"21":"Un hombre intachable tomó inmediatamente su defensa con las armas de su ministerio: la oración y el incienso de los sacrificios expiatorios. Así enfrentó a tu cólera, Señor, y puso fin a su prueba: vieron entonces que era tu servidor. "
,"22":"Puso fin a tu resentimiento no con la fuerza física o la eficacia de las armas sino con su palabra: le recordó al Exterminador las promesas y las alianzas pactadas antiguamente con nuestros padres."
,"23":"Cuando se interpuso, los muertos ya se apilaban; puso fin a la Cólera y le cerró el camino hacia los vivos."
,"24":"Todo el mundo estaba representado en su larga túnica, en las cuatro hileras de piedras preciosas llevaba los nombres gloriosos de nuestros padres, y en su cabeza la diadema de tu majestad."
,"25":"Al verlo, el Exterminador retrocedió y tuvo miedo: había bastado con este anticipo de tu cólera."
}`)
	CurrentBook.AddChapter(19, `{
"1":"A los impíos, empero, un furor inclemente los castigó hasta el fin, porque Dios sabía de antemano lo que harían:"
,"2":"después de haber autorizado a tu pueblo a que se fuera y de haberlo incluso empujado a ello, cambiaron de parecer y se pusieron a perseguirlo."
,"3":"Aún no terminaban de llorar a sus muertos y de lamentarse en sus tumbas, cuando tomaron la decisión de perseguir como fugitivos a los que les habían suplicado que se fueran."
,"4":"Una justa fatalidad los impulsó a esta medida extrema y les hizo olvidar todo lo que había pasado: era necesario que nuevos tormentos colmaran la medida de su castigo."
,"5":"Tu pueblo iba a vivir la experiencia de un viaje increíble, mientras ellos tenían que experimentar una muerte poco común."
,"6":"A una orden tuya, toda la creación, con sus propiedades naturales, se renovó desde arriba para proteger a tus hijos."
,"7":"Se vio a una nube que cubría el campamento con su sombra y que aparecía la tierra seca en medio del agua; se abrió en el Mar Rojo un paso seguro, una verde llanura reemplazó a las olas impetuosas,"
,"8":"y todo el pueblo pasó por allí. Protegido por tu mano, fueron testigos de esos prodigios asombrosos."
,"9":"Saltaban como caballos en la pradera, o brincaban como corderos, alabándote porque tú, Señor, los habías librado."
,"10":"Así podrían acordarse de lo que habían visto en el país de su destierro, de cómo el suelo estaba cubierto no por animales sino por mosquitos, y de cómo el río había botado no peces sino incontables ranas."
,"11":"Más tarde, vieron además como nacían pájaros de una manera nueva, cuando el hambre los apretaba y pedían una comida más sustancial;"
,"12":"salieron codornices del mar para satisfacer sus necesidades."
,"13":"Los otros, los pecadores, habían sido advertidos por violentas tormentas, antes que cayeran sobre ellos los castigos. Fueron castigados con toda justicia por su propia maldad, porque habían mostrado un odio terrible hacia los extranjeros."
,"14":"Otros, en otro lugar, se habían negado a acoger a unos desconocidos, pero éstos habían reducido a la esclavitud a un pueblo bienhechor que se había instalado en medio de ellos."
,"15":"Aquellos, que habían recibido con tanto odio a los extranjeros, tenían que ser castigados,"
,"16":"pero estos, que habían acogido a nuestros padres con festejos, los habían luego sometido a trabajos forzados después de haberlos tratado como iguales."
,"17":"Por eso, fueron heridos de ceguera como les había ocurrido a los habitantes de Sodoma frente a la puerta de Lot, el justo: se encontraron en la oscuridad y cada uno tuvo que buscar, a tientas, su propia puerta."
,"18":"Fue como si los diferentes elementos del mundo intercambiaran sus propiedades, igual como en la cítara la alternancia de los sonidos cambia el ritmo, conservando sin embargo cada nota su propia tonalidad. Y si se examinan los hechos, eso fue justamente lo que pasó."
,"19":"Lo que vive en la tierra se adaptó al agua, lo que está hecho para el agua se volvió terrestre."
,"20":"El fuego ardía más fuerte al contacto con el agua, y ésta se olvidó de apagarlo."
,"21":"Las llamas no quemaban a los frágiles insectos que las atravesaban; ni hacían que se derritiera el maná, ese alimento divino que debió licuarse como la escarcha en un instante."
,"22":"¡De cuántas maneras, Señor, has exaltado y glorificado a tu pueblo! Nunca lo has olvidado, sino que lo has asistido siempre y en todas partes."
}`)

}
